#include <tree_sitter/parser.h>

#if defined(__GNUC__) || defined(__clang__)
#pragma GCC diagnostic push
#pragma GCC diagnostic ignored "-Wmissing-field-initializers"
#endif

#define LANGUAGE_VERSION 8
#define STATE_COUNT 3215
#define SYMBOL_COUNT 278
#define ALIAS_COUNT 22
#define TOKEN_COUNT 117
#define EXTERNAL_TOKEN_COUNT 1
#define MAX_ALIAS_SEQUENCE_LENGTH 5

enum {
  sym_raw_string_literal = 1,
  aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH = 2,
  aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH = 3,
  aux_sym_SLASH_LBRACK_BSLASHt_RBRACK_PLUS_SLASH = 4,
  anon_sym_LF = 5,
  anon_sym_LPAREN = 6,
  anon_sym_DOT_DOT_DOT = 7,
  anon_sym_COMMA = 8,
  anon_sym_RPAREN = 9,
  aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH = 10,
  aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH = 11,
  aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH = 12,
  aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH = 13,
  aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH = 14,
  aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH = 15,
  sym_preproc_directive = 16,
  sym_preproc_arg = 17,
  anon_sym_SEMI = 18,
  anon_sym_typedef = 19,
  anon_sym_extern = 20,
  anon_sym_LBRACE = 21,
  anon_sym_RBRACE = 22,
  anon_sym_STAR = 23,
  anon_sym_LBRACK = 24,
  anon_sym_RBRACK = 25,
  anon_sym_EQ = 26,
  anon_sym_static = 27,
  anon_sym_register = 28,
  anon_sym_inline = 29,
  anon_sym_const = 30,
  anon_sym_restrict = 31,
  anon_sym_volatile = 32,
  anon_sym__Atomic = 33,
  anon_sym_mutable = 34,
  anon_sym_explicit = 35,
  anon_sym_constexpr = 36,
  anon_sym_unsigned = 37,
  anon_sym_long = 38,
  anon_sym_short = 39,
  sym_primitive_type = 40,
  anon_sym_enum = 41,
  anon_sym_struct = 42,
  anon_sym_union = 43,
  anon_sym_COLON = 44,
  anon_sym_if = 45,
  anon_sym_else = 46,
  anon_sym_switch = 47,
  anon_sym_case = 48,
  anon_sym_default = 49,
  anon_sym_while = 50,
  anon_sym_do = 51,
  anon_sym_for = 52,
  anon_sym_return = 53,
  anon_sym_break = 54,
  anon_sym_continue = 55,
  anon_sym_goto = 56,
  anon_sym_QMARK = 57,
  anon_sym_STAR_EQ = 58,
  anon_sym_SLASH_EQ = 59,
  anon_sym_PERCENT_EQ = 60,
  anon_sym_PLUS_EQ = 61,
  anon_sym_DASH_EQ = 62,
  anon_sym_LT_LT_EQ = 63,
  anon_sym_GT_GT_EQ = 64,
  anon_sym_AMP_EQ = 65,
  anon_sym_CARET_EQ = 66,
  anon_sym_PIPE_EQ = 67,
  anon_sym_AMP = 68,
  anon_sym_PIPE_PIPE = 69,
  anon_sym_AMP_AMP = 70,
  anon_sym_BANG = 71,
  anon_sym_PIPE = 72,
  anon_sym_CARET = 73,
  anon_sym_TILDE = 74,
  anon_sym_EQ_EQ = 75,
  anon_sym_BANG_EQ = 76,
  anon_sym_LT = 77,
  anon_sym_GT = 78,
  anon_sym_LT_EQ = 79,
  anon_sym_GT_EQ = 80,
  anon_sym_LT_LT = 81,
  anon_sym_GT_GT = 82,
  anon_sym_PLUS = 83,
  anon_sym_DASH = 84,
  anon_sym_SLASH = 85,
  anon_sym_PERCENT = 86,
  anon_sym_DASH_DASH = 87,
  anon_sym_PLUS_PLUS = 88,
  anon_sym_sizeof = 89,
  anon_sym_DOT = 90,
  anon_sym_DASH_GT = 91,
  sym_number_literal = 92,
  sym_char_literal = 93,
  sym_string_literal = 94,
  sym_system_lib_string = 95,
  sym_true = 96,
  sym_false = 97,
  sym_null = 98,
  sym_identifier = 99,
  sym_comment = 100,
  anon_sym_class = 101,
  anon_sym_public = 102,
  sym_auto = 103,
  anon_sym_typename = 104,
  anon_sym_template = 105,
  anon_sym_friend = 106,
  anon_sym_private = 107,
  anon_sym_protected = 108,
  sym_noexcept = 109,
  anon_sym_namespace = 110,
  anon_sym_using = 111,
  anon_sym_new = 112,
  anon_sym_COLON_COLON = 113,
  anon_sym_delete = 114,
  sym_operator_name = 115,
  sym_nullptr = 116,
  sym_translation_unit = 117,
  sym_preproc_include = 118,
  sym_preproc_def = 119,
  sym_preproc_function_def = 120,
  sym_preproc_params = 121,
  sym_preproc_call = 122,
  sym_preproc_if = 123,
  sym_preproc_ifdef = 124,
  sym_preproc_else = 125,
  sym_preproc_elif = 126,
  sym_preproc_if_in_compound_statement = 127,
  sym_preproc_ifdef_in_compound_statement = 128,
  sym_preproc_else_in_compound_statement = 129,
  sym_preproc_elif_in_compound_statement = 130,
  sym_preproc_if_in_field_declaration_list = 131,
  sym_preproc_ifdef_in_field_declaration_list = 132,
  sym_preproc_else_in_field_declaration_list = 133,
  sym_preproc_elif_in_field_declaration_list = 134,
  sym_function_definition = 135,
  sym_declaration = 136,
  sym_type_definition = 137,
  sym__declaration_specifiers = 138,
  sym_linkage_specification = 139,
  sym_declaration_list = 140,
  sym__declarator = 141,
  sym__field_declarator = 142,
  sym__type_declarator = 143,
  sym__abstract_declarator = 144,
  sym_pointer_declarator = 145,
  sym_pointer_field_declarator = 146,
  sym_pointer_type_declarator = 147,
  sym_abstract_pointer_declarator = 148,
  sym_function_declarator = 149,
  sym_function_field_declarator = 150,
  sym_function_type_declarator = 151,
  sym_abstract_function_declarator = 152,
  sym_array_declarator = 153,
  sym_array_field_declarator = 154,
  sym_array_type_declarator = 155,
  sym_abstract_array_declarator = 156,
  sym_init_declarator = 157,
  sym_compound_statement = 158,
  sym_storage_class_specifier = 159,
  sym_type_qualifier = 160,
  sym__type_specifier = 161,
  sym_sized_type_specifier = 162,
  sym_enum_specifier = 163,
  sym_enumerator_list = 164,
  sym_struct_specifier = 165,
  sym_union_specifier = 166,
  sym_field_declaration_list = 167,
  sym__field_declaration_list_item = 168,
  sym_field_declaration = 169,
  sym_enumerator = 170,
  sym_parameter_list = 171,
  sym_parameter_declaration = 172,
  sym_labeled_statement = 173,
  sym_expression_statement = 174,
  sym_if_statement = 175,
  sym_switch_statement = 176,
  sym_case_statement = 177,
  sym_while_statement = 178,
  sym_do_statement = 179,
  sym_for_statement = 180,
  sym_return_statement = 181,
  sym_break_statement = 182,
  sym_continue_statement = 183,
  sym_goto_statement = 184,
  sym__expression = 185,
  sym_comma_expression = 186,
  sym_conditional_expression = 187,
  sym_assignment_expression = 188,
  sym_pointer_expression = 189,
  sym_logical_expression = 190,
  sym_bitwise_expression = 191,
  sym_equality_expression = 192,
  sym_relational_expression = 193,
  sym_shift_expression = 194,
  sym_math_expression = 195,
  sym_cast_expression = 196,
  sym_type_descriptor = 197,
  sym_sizeof_expression = 198,
  sym_subscript_expression = 199,
  sym_call_expression = 200,
  sym_argument_list = 201,
  sym_field_expression = 202,
  sym_compound_literal_expression = 203,
  sym_parenthesized_expression = 204,
  sym_initializer_list = 205,
  sym_initializer_pair = 206,
  sym_subscript_designator = 207,
  sym_field_designator = 208,
  sym_concatenated_string = 209,
  sym__empty_declaration = 210,
  sym_macro_type_specifier = 211,
  sym_class_specifier = 212,
  sym__class_name = 213,
  sym_base_class_clause = 214,
  sym_dependent_type = 215,
  sym_structured_binding_declaration = 216,
  sym_template_declaration = 217,
  sym_template_instantiation = 218,
  sym_template_parameter_list = 219,
  sym_type_parameter_declaration = 220,
  sym_optional_type_parameter_declaration = 221,
  sym_field_initializer_list = 222,
  sym_field_initializer = 223,
  sym_inline_method_definition = 224,
  sym_constructor_or_destructor_definition = 225,
  sym_constructor_or_destructor_declaration = 226,
  sym_friend_declaration = 227,
  sym_access_specifier = 228,
  sym_reference_declarator = 229,
  sym_reference_field_declarator = 230,
  sym_abstract_reference_declarator = 231,
  sym_structured_binding_reference_declarator = 232,
  sym_structured_binding_declarator = 233,
  sym_trailing_return_type = 234,
  sym_template_type = 235,
  sym_template_method = 236,
  sym_template_function = 237,
  sym_template_argument_list = 238,
  sym_namespace_definition = 239,
  sym_using_declaration = 240,
  sym_alias_declaration = 241,
  sym_for_range_loop = 242,
  sym_for_range_declaration = 243,
  sym_new_expression = 244,
  sym_new_declarator = 245,
  sym_delete_expression = 246,
  sym_lambda_expression = 247,
  sym_lambda_capture_specifier = 248,
  sym_lambda_default_capture = 249,
  sym_destructor_name = 250,
  sym_scoped_field_identifier = 251,
  sym_scoped_identifier = 252,
  sym_scoped_type_identifier = 253,
  sym_scoped_namespace_identifier = 254,
  aux_sym_translation_unit_repeat1 = 255,
  aux_sym_preproc_params_repeat1 = 256,
  aux_sym_preproc_if_in_compound_statement_repeat1 = 257,
  aux_sym_preproc_if_in_field_declaration_list_repeat1 = 258,
  aux_sym_declaration_repeat1 = 259,
  aux_sym_type_definition_repeat1 = 260,
  aux_sym__declaration_specifiers_repeat1 = 261,
  aux_sym_function_declarator_repeat1 = 262,
  aux_sym_abstract_function_declarator_repeat1 = 263,
  aux_sym_sized_type_specifier_repeat1 = 264,
  aux_sym_enumerator_list_repeat1 = 265,
  aux_sym_field_declaration_repeat1 = 266,
  aux_sym_parameter_list_repeat1 = 267,
  aux_sym_for_statement_repeat1 = 268,
  aux_sym_argument_list_repeat1 = 269,
  aux_sym_initializer_list_repeat1 = 270,
  aux_sym_initializer_pair_repeat1 = 271,
  aux_sym_concatenated_string_repeat1 = 272,
  aux_sym_base_class_clause_repeat1 = 273,
  aux_sym_template_parameter_list_repeat1 = 274,
  aux_sym_field_initializer_list_repeat1 = 275,
  aux_sym_structured_binding_declarator_repeat1 = 276,
  aux_sym_template_argument_list_repeat1 = 277,
  anon_alias_sym_POUNDdefine = 278,
  anon_alias_sym_POUNDelif = 279,
  anon_alias_sym_POUNDelse = 280,
  anon_alias_sym_POUNDendif = 281,
  anon_alias_sym_POUNDif = 282,
  anon_alias_sym_POUNDifdef = 283,
  anon_alias_sym_POUNDifndef = 284,
  anon_alias_sym_POUNDinclude = 285,
  alias_sym_array_declarator = 286,
  alias_sym_declaration = 287,
  alias_sym_field_identifier = 288,
  alias_sym_function_declarator = 289,
  alias_sym_function_definition = 290,
  alias_sym_namespace_identifier = 291,
  alias_sym_pointer_declarator = 292,
  alias_sym_preproc_elif = 293,
  alias_sym_preproc_else = 294,
  alias_sym_preproc_if = 295,
  alias_sym_preproc_ifdef = 296,
  alias_sym_reference_declarator = 297,
  alias_sym_statement_identifier = 298,
  alias_sym_type_identifier = 299,
};

static const char *ts_symbol_names[] = {
  [sym_raw_string_literal] = "raw_string_literal",
  [ts_builtin_sym_end] = "END",
  [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = "/#[ 	]*include/",
  [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = "/#[ 	]*define/",
  [aux_sym_SLASH_LBRACK_BSLASHt_RBRACK_PLUS_SLASH] = "/[ \\t]+/",
  [anon_sym_LF] = "\n",
  [anon_sym_LPAREN] = "(",
  [anon_sym_DOT_DOT_DOT] = "...",
  [anon_sym_COMMA] = ",",
  [anon_sym_RPAREN] = ")",
  [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = "/#[ 	]*if/",
  [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = "/#[ 	]*endif/",
  [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = "/#[ 	]*ifdef/",
  [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = "/#[ 	]*ifndef/",
  [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = "/#[ 	]*else/",
  [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = "/#[ 	]*elif/",
  [sym_preproc_directive] = "preproc_directive",
  [sym_preproc_arg] = "preproc_arg",
  [anon_sym_SEMI] = ";",
  [anon_sym_typedef] = "typedef",
  [anon_sym_extern] = "extern",
  [anon_sym_LBRACE] = "{",
  [anon_sym_RBRACE] = "}",
  [anon_sym_STAR] = "*",
  [anon_sym_LBRACK] = "[",
  [anon_sym_RBRACK] = "]",
  [anon_sym_EQ] = "=",
  [anon_sym_static] = "static",
  [anon_sym_register] = "register",
  [anon_sym_inline] = "inline",
  [anon_sym_const] = "const",
  [anon_sym_restrict] = "restrict",
  [anon_sym_volatile] = "volatile",
  [anon_sym__Atomic] = "_Atomic",
  [anon_sym_mutable] = "mutable",
  [anon_sym_explicit] = "explicit",
  [anon_sym_constexpr] = "constexpr",
  [anon_sym_unsigned] = "unsigned",
  [anon_sym_long] = "long",
  [anon_sym_short] = "short",
  [sym_primitive_type] = "primitive_type",
  [anon_sym_enum] = "enum",
  [anon_sym_struct] = "struct",
  [anon_sym_union] = "union",
  [anon_sym_COLON] = ":",
  [anon_sym_if] = "if",
  [anon_sym_else] = "else",
  [anon_sym_switch] = "switch",
  [anon_sym_case] = "case",
  [anon_sym_default] = "default",
  [anon_sym_while] = "while",
  [anon_sym_do] = "do",
  [anon_sym_for] = "for",
  [anon_sym_return] = "return",
  [anon_sym_break] = "break",
  [anon_sym_continue] = "continue",
  [anon_sym_goto] = "goto",
  [anon_sym_QMARK] = "?",
  [anon_sym_STAR_EQ] = "*=",
  [anon_sym_SLASH_EQ] = "/=",
  [anon_sym_PERCENT_EQ] = "%=",
  [anon_sym_PLUS_EQ] = "+=",
  [anon_sym_DASH_EQ] = "-=",
  [anon_sym_LT_LT_EQ] = "<<=",
  [anon_sym_GT_GT_EQ] = ">>=",
  [anon_sym_AMP_EQ] = "&=",
  [anon_sym_CARET_EQ] = "^=",
  [anon_sym_PIPE_EQ] = "|=",
  [anon_sym_AMP] = "&",
  [anon_sym_PIPE_PIPE] = "||",
  [anon_sym_AMP_AMP] = "&&",
  [anon_sym_BANG] = "!",
  [anon_sym_PIPE] = "|",
  [anon_sym_CARET] = "^",
  [anon_sym_TILDE] = "~",
  [anon_sym_EQ_EQ] = "==",
  [anon_sym_BANG_EQ] = "!=",
  [anon_sym_LT] = "<",
  [anon_sym_GT] = ">",
  [anon_sym_LT_EQ] = "<=",
  [anon_sym_GT_EQ] = ">=",
  [anon_sym_LT_LT] = "<<",
  [anon_sym_GT_GT] = ">>",
  [anon_sym_PLUS] = "+",
  [anon_sym_DASH] = "-",
  [anon_sym_SLASH] = "/",
  [anon_sym_PERCENT] = "%",
  [anon_sym_DASH_DASH] = "--",
  [anon_sym_PLUS_PLUS] = "++",
  [anon_sym_sizeof] = "sizeof",
  [anon_sym_DOT] = ".",
  [anon_sym_DASH_GT] = "->",
  [sym_number_literal] = "number_literal",
  [sym_char_literal] = "char_literal",
  [sym_string_literal] = "string_literal",
  [sym_system_lib_string] = "system_lib_string",
  [sym_true] = "true",
  [sym_false] = "false",
  [sym_null] = "null",
  [sym_identifier] = "identifier",
  [sym_comment] = "comment",
  [anon_sym_class] = "class",
  [anon_sym_public] = "public",
  [sym_auto] = "auto",
  [anon_sym_typename] = "typename",
  [anon_sym_template] = "template",
  [anon_sym_friend] = "friend",
  [anon_sym_private] = "private",
  [anon_sym_protected] = "protected",
  [sym_noexcept] = "noexcept",
  [anon_sym_namespace] = "namespace",
  [anon_sym_using] = "using",
  [anon_sym_new] = "new",
  [anon_sym_COLON_COLON] = "::",
  [anon_sym_delete] = "delete",
  [sym_operator_name] = "operator_name",
  [sym_nullptr] = "nullptr",
  [sym_translation_unit] = "translation_unit",
  [sym_preproc_include] = "preproc_include",
  [sym_preproc_def] = "preproc_def",
  [sym_preproc_function_def] = "preproc_function_def",
  [sym_preproc_params] = "preproc_params",
  [sym_preproc_call] = "preproc_call",
  [sym_preproc_if] = "preproc_if",
  [sym_preproc_ifdef] = "preproc_ifdef",
  [sym_preproc_else] = "preproc_else",
  [sym_preproc_elif] = "preproc_elif",
  [sym_preproc_if_in_compound_statement] = "preproc_if_in_compound_statement",
  [sym_preproc_ifdef_in_compound_statement] = "preproc_ifdef_in_compound_statement",
  [sym_preproc_else_in_compound_statement] = "preproc_else_in_compound_statement",
  [sym_preproc_elif_in_compound_statement] = "preproc_elif_in_compound_statement",
  [sym_preproc_if_in_field_declaration_list] = "preproc_if_in_field_declaration_list",
  [sym_preproc_ifdef_in_field_declaration_list] = "preproc_ifdef_in_field_declaration_list",
  [sym_preproc_else_in_field_declaration_list] = "preproc_else_in_field_declaration_list",
  [sym_preproc_elif_in_field_declaration_list] = "preproc_elif_in_field_declaration_list",
  [sym_function_definition] = "function_definition",
  [sym_declaration] = "declaration",
  [sym_type_definition] = "type_definition",
  [sym__declaration_specifiers] = "_declaration_specifiers",
  [sym_linkage_specification] = "linkage_specification",
  [sym_declaration_list] = "declaration_list",
  [sym__declarator] = "_declarator",
  [sym__field_declarator] = "_field_declarator",
  [sym__type_declarator] = "_type_declarator",
  [sym__abstract_declarator] = "_abstract_declarator",
  [sym_pointer_declarator] = "pointer_declarator",
  [sym_pointer_field_declarator] = "pointer_field_declarator",
  [sym_pointer_type_declarator] = "pointer_type_declarator",
  [sym_abstract_pointer_declarator] = "abstract_pointer_declarator",
  [sym_function_declarator] = "function_declarator",
  [sym_function_field_declarator] = "function_field_declarator",
  [sym_function_type_declarator] = "function_type_declarator",
  [sym_abstract_function_declarator] = "abstract_function_declarator",
  [sym_array_declarator] = "array_declarator",
  [sym_array_field_declarator] = "array_field_declarator",
  [sym_array_type_declarator] = "array_type_declarator",
  [sym_abstract_array_declarator] = "abstract_array_declarator",
  [sym_init_declarator] = "init_declarator",
  [sym_compound_statement] = "compound_statement",
  [sym_storage_class_specifier] = "storage_class_specifier",
  [sym_type_qualifier] = "type_qualifier",
  [sym__type_specifier] = "_type_specifier",
  [sym_sized_type_specifier] = "sized_type_specifier",
  [sym_enum_specifier] = "enum_specifier",
  [sym_enumerator_list] = "enumerator_list",
  [sym_struct_specifier] = "struct_specifier",
  [sym_union_specifier] = "union_specifier",
  [sym_field_declaration_list] = "field_declaration_list",
  [sym__field_declaration_list_item] = "_field_declaration_list_item",
  [sym_field_declaration] = "field_declaration",
  [sym_enumerator] = "enumerator",
  [sym_parameter_list] = "parameter_list",
  [sym_parameter_declaration] = "parameter_declaration",
  [sym_labeled_statement] = "labeled_statement",
  [sym_expression_statement] = "expression_statement",
  [sym_if_statement] = "if_statement",
  [sym_switch_statement] = "switch_statement",
  [sym_case_statement] = "case_statement",
  [sym_while_statement] = "while_statement",
  [sym_do_statement] = "do_statement",
  [sym_for_statement] = "for_statement",
  [sym_return_statement] = "return_statement",
  [sym_break_statement] = "break_statement",
  [sym_continue_statement] = "continue_statement",
  [sym_goto_statement] = "goto_statement",
  [sym__expression] = "_expression",
  [sym_comma_expression] = "comma_expression",
  [sym_conditional_expression] = "conditional_expression",
  [sym_assignment_expression] = "assignment_expression",
  [sym_pointer_expression] = "pointer_expression",
  [sym_logical_expression] = "logical_expression",
  [sym_bitwise_expression] = "bitwise_expression",
  [sym_equality_expression] = "equality_expression",
  [sym_relational_expression] = "relational_expression",
  [sym_shift_expression] = "shift_expression",
  [sym_math_expression] = "math_expression",
  [sym_cast_expression] = "cast_expression",
  [sym_type_descriptor] = "type_descriptor",
  [sym_sizeof_expression] = "sizeof_expression",
  [sym_subscript_expression] = "subscript_expression",
  [sym_call_expression] = "call_expression",
  [sym_argument_list] = "argument_list",
  [sym_field_expression] = "field_expression",
  [sym_compound_literal_expression] = "compound_literal_expression",
  [sym_parenthesized_expression] = "parenthesized_expression",
  [sym_initializer_list] = "initializer_list",
  [sym_initializer_pair] = "initializer_pair",
  [sym_subscript_designator] = "subscript_designator",
  [sym_field_designator] = "field_designator",
  [sym_concatenated_string] = "concatenated_string",
  [sym__empty_declaration] = "_empty_declaration",
  [sym_macro_type_specifier] = "macro_type_specifier",
  [sym_class_specifier] = "class_specifier",
  [sym__class_name] = "_class_name",
  [sym_base_class_clause] = "base_class_clause",
  [sym_dependent_type] = "dependent_type",
  [sym_structured_binding_declaration] = "structured_binding_declaration",
  [sym_template_declaration] = "template_declaration",
  [sym_template_instantiation] = "template_instantiation",
  [sym_template_parameter_list] = "template_parameter_list",
  [sym_type_parameter_declaration] = "type_parameter_declaration",
  [sym_optional_type_parameter_declaration] = "optional_type_parameter_declaration",
  [sym_field_initializer_list] = "field_initializer_list",
  [sym_field_initializer] = "field_initializer",
  [sym_inline_method_definition] = "inline_method_definition",
  [sym_constructor_or_destructor_definition] = "constructor_or_destructor_definition",
  [sym_constructor_or_destructor_declaration] = "constructor_or_destructor_declaration",
  [sym_friend_declaration] = "friend_declaration",
  [sym_access_specifier] = "access_specifier",
  [sym_reference_declarator] = "reference_declarator",
  [sym_reference_field_declarator] = "reference_field_declarator",
  [sym_abstract_reference_declarator] = "abstract_reference_declarator",
  [sym_structured_binding_reference_declarator] = "structured_binding_reference_declarator",
  [sym_structured_binding_declarator] = "structured_binding_declarator",
  [sym_trailing_return_type] = "trailing_return_type",
  [sym_template_type] = "template_type",
  [sym_template_method] = "template_method",
  [sym_template_function] = "template_function",
  [sym_template_argument_list] = "template_argument_list",
  [sym_namespace_definition] = "namespace_definition",
  [sym_using_declaration] = "using_declaration",
  [sym_alias_declaration] = "alias_declaration",
  [sym_for_range_loop] = "for_range_loop",
  [sym_for_range_declaration] = "for_range_declaration",
  [sym_new_expression] = "new_expression",
  [sym_new_declarator] = "new_declarator",
  [sym_delete_expression] = "delete_expression",
  [sym_lambda_expression] = "lambda_expression",
  [sym_lambda_capture_specifier] = "lambda_capture_specifier",
  [sym_lambda_default_capture] = "lambda_default_capture",
  [sym_destructor_name] = "destructor_name",
  [sym_scoped_field_identifier] = "scoped_field_identifier",
  [sym_scoped_identifier] = "scoped_identifier",
  [sym_scoped_type_identifier] = "scoped_type_identifier",
  [sym_scoped_namespace_identifier] = "scoped_namespace_identifier",
  [aux_sym_translation_unit_repeat1] = "translation_unit_repeat1",
  [aux_sym_preproc_params_repeat1] = "preproc_params_repeat1",
  [aux_sym_preproc_if_in_compound_statement_repeat1] = "preproc_if_in_compound_statement_repeat1",
  [aux_sym_preproc_if_in_field_declaration_list_repeat1] = "preproc_if_in_field_declaration_list_repeat1",
  [aux_sym_declaration_repeat1] = "declaration_repeat1",
  [aux_sym_type_definition_repeat1] = "type_definition_repeat1",
  [aux_sym__declaration_specifiers_repeat1] = "_declaration_specifiers_repeat1",
  [aux_sym_function_declarator_repeat1] = "function_declarator_repeat1",
  [aux_sym_abstract_function_declarator_repeat1] = "abstract_function_declarator_repeat1",
  [aux_sym_sized_type_specifier_repeat1] = "sized_type_specifier_repeat1",
  [aux_sym_enumerator_list_repeat1] = "enumerator_list_repeat1",
  [aux_sym_field_declaration_repeat1] = "field_declaration_repeat1",
  [aux_sym_parameter_list_repeat1] = "parameter_list_repeat1",
  [aux_sym_for_statement_repeat1] = "for_statement_repeat1",
  [aux_sym_argument_list_repeat1] = "argument_list_repeat1",
  [aux_sym_initializer_list_repeat1] = "initializer_list_repeat1",
  [aux_sym_initializer_pair_repeat1] = "initializer_pair_repeat1",
  [aux_sym_concatenated_string_repeat1] = "concatenated_string_repeat1",
  [aux_sym_base_class_clause_repeat1] = "base_class_clause_repeat1",
  [aux_sym_template_parameter_list_repeat1] = "template_parameter_list_repeat1",
  [aux_sym_field_initializer_list_repeat1] = "field_initializer_list_repeat1",
  [aux_sym_structured_binding_declarator_repeat1] = "structured_binding_declarator_repeat1",
  [aux_sym_template_argument_list_repeat1] = "template_argument_list_repeat1",
  [anon_alias_sym_POUNDdefine] = "#define",
  [anon_alias_sym_POUNDelif] = "#elif",
  [anon_alias_sym_POUNDelse] = "#else",
  [anon_alias_sym_POUNDendif] = "#endif",
  [anon_alias_sym_POUNDif] = "#if",
  [anon_alias_sym_POUNDifdef] = "#ifdef",
  [anon_alias_sym_POUNDifndef] = "#ifndef",
  [anon_alias_sym_POUNDinclude] = "#include",
  [alias_sym_array_declarator] = "array_declarator",
  [alias_sym_declaration] = "declaration",
  [alias_sym_field_identifier] = "field_identifier",
  [alias_sym_function_declarator] = "function_declarator",
  [alias_sym_function_definition] = "function_definition",
  [alias_sym_namespace_identifier] = "namespace_identifier",
  [alias_sym_pointer_declarator] = "pointer_declarator",
  [alias_sym_preproc_elif] = "preproc_elif",
  [alias_sym_preproc_else] = "preproc_else",
  [alias_sym_preproc_if] = "preproc_if",
  [alias_sym_preproc_ifdef] = "preproc_ifdef",
  [alias_sym_reference_declarator] = "reference_declarator",
  [alias_sym_statement_identifier] = "statement_identifier",
  [alias_sym_type_identifier] = "type_identifier",
};

static const TSSymbolMetadata ts_symbol_metadata[] = {
  [sym_raw_string_literal] = {
    .visible = true,
    .named = true,
  },
  [ts_builtin_sym_end] = {
    .visible = false,
    .named = true,
  },
  [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_SLASH_LBRACK_BSLASHt_RBRACK_PLUS_SLASH] = {
    .visible = false,
    .named = false,
  },
  [anon_sym_LF] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT_DOT_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COMMA] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RPAREN] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = {
    .visible = false,
    .named = false,
  },
  [sym_preproc_directive] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_arg] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_SEMI] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_typedef] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_extern] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_static] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_register] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_inline] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_const] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_restrict] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_volatile] = {
    .visible = true,
    .named = false,
  },
  [anon_sym__Atomic] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_mutable] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_explicit] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_constexpr] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_unsigned] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_long] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_short] = {
    .visible = true,
    .named = false,
  },
  [sym_primitive_type] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_enum] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_struct] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_union] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_if] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_else] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_switch] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_case] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_default] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_while] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_do] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_for] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_return] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_break] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_continue] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_goto] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_QMARK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PERCENT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_LT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_CARET_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP_AMP] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_CARET] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_TILDE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PERCENT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS_PLUS] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_sizeof] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_GT] = {
    .visible = true,
    .named = false,
  },
  [sym_number_literal] = {
    .visible = true,
    .named = true,
  },
  [sym_char_literal] = {
    .visible = true,
    .named = true,
  },
  [sym_string_literal] = {
    .visible = true,
    .named = true,
  },
  [sym_system_lib_string] = {
    .visible = true,
    .named = true,
  },
  [sym_true] = {
    .visible = true,
    .named = true,
  },
  [sym_false] = {
    .visible = true,
    .named = true,
  },
  [sym_null] = {
    .visible = true,
    .named = true,
  },
  [sym_identifier] = {
    .visible = true,
    .named = true,
  },
  [sym_comment] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_class] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_public] = {
    .visible = true,
    .named = false,
  },
  [sym_auto] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_typename] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_template] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_friend] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_private] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_protected] = {
    .visible = true,
    .named = false,
  },
  [sym_noexcept] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_namespace] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_using] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_new] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_delete] = {
    .visible = true,
    .named = false,
  },
  [sym_operator_name] = {
    .visible = true,
    .named = true,
  },
  [sym_nullptr] = {
    .visible = true,
    .named = true,
  },
  [sym_translation_unit] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_include] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_def] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_function_def] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_params] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_call] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_if] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_ifdef] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_else] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_elif] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_if_in_compound_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_ifdef_in_compound_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_else_in_compound_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_elif_in_compound_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_if_in_field_declaration_list] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_ifdef_in_field_declaration_list] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_else_in_field_declaration_list] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_elif_in_field_declaration_list] = {
    .visible = true,
    .named = true,
  },
  [sym_function_definition] = {
    .visible = true,
    .named = true,
  },
  [sym_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_type_definition] = {
    .visible = true,
    .named = true,
  },
  [sym__declaration_specifiers] = {
    .visible = false,
    .named = true,
  },
  [sym_linkage_specification] = {
    .visible = true,
    .named = true,
  },
  [sym_declaration_list] = {
    .visible = true,
    .named = true,
  },
  [sym__declarator] = {
    .visible = false,
    .named = true,
  },
  [sym__field_declarator] = {
    .visible = false,
    .named = true,
  },
  [sym__type_declarator] = {
    .visible = false,
    .named = true,
  },
  [sym__abstract_declarator] = {
    .visible = false,
    .named = true,
  },
  [sym_pointer_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_pointer_field_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_pointer_type_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_abstract_pointer_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_function_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_function_field_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_function_type_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_abstract_function_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_array_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_array_field_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_array_type_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_abstract_array_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_init_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_compound_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_storage_class_specifier] = {
    .visible = true,
    .named = true,
  },
  [sym_type_qualifier] = {
    .visible = true,
    .named = true,
  },
  [sym__type_specifier] = {
    .visible = false,
    .named = true,
  },
  [sym_sized_type_specifier] = {
    .visible = true,
    .named = true,
  },
  [sym_enum_specifier] = {
    .visible = true,
    .named = true,
  },
  [sym_enumerator_list] = {
    .visible = true,
    .named = true,
  },
  [sym_struct_specifier] = {
    .visible = true,
    .named = true,
  },
  [sym_union_specifier] = {
    .visible = true,
    .named = true,
  },
  [sym_field_declaration_list] = {
    .visible = true,
    .named = true,
  },
  [sym__field_declaration_list_item] = {
    .visible = false,
    .named = true,
  },
  [sym_field_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_enumerator] = {
    .visible = true,
    .named = true,
  },
  [sym_parameter_list] = {
    .visible = true,
    .named = true,
  },
  [sym_parameter_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_labeled_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_expression_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_if_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_switch_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_case_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_while_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_do_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_for_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_return_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_break_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_continue_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_goto_statement] = {
    .visible = true,
    .named = true,
  },
  [sym__expression] = {
    .visible = false,
    .named = true,
  },
  [sym_comma_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_conditional_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_assignment_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_pointer_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_logical_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_bitwise_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_equality_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_relational_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_shift_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_math_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_cast_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_type_descriptor] = {
    .visible = true,
    .named = true,
  },
  [sym_sizeof_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_subscript_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_call_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_argument_list] = {
    .visible = true,
    .named = true,
  },
  [sym_field_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_compound_literal_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_parenthesized_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_initializer_list] = {
    .visible = true,
    .named = true,
  },
  [sym_initializer_pair] = {
    .visible = true,
    .named = true,
  },
  [sym_subscript_designator] = {
    .visible = true,
    .named = true,
  },
  [sym_field_designator] = {
    .visible = true,
    .named = true,
  },
  [sym_concatenated_string] = {
    .visible = true,
    .named = true,
  },
  [sym__empty_declaration] = {
    .visible = false,
    .named = true,
  },
  [sym_macro_type_specifier] = {
    .visible = true,
    .named = true,
  },
  [sym_class_specifier] = {
    .visible = true,
    .named = true,
  },
  [sym__class_name] = {
    .visible = false,
    .named = true,
  },
  [sym_base_class_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_dependent_type] = {
    .visible = true,
    .named = true,
  },
  [sym_structured_binding_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_template_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_template_instantiation] = {
    .visible = true,
    .named = true,
  },
  [sym_template_parameter_list] = {
    .visible = true,
    .named = true,
  },
  [sym_type_parameter_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_optional_type_parameter_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_field_initializer_list] = {
    .visible = true,
    .named = true,
  },
  [sym_field_initializer] = {
    .visible = true,
    .named = true,
  },
  [sym_inline_method_definition] = {
    .visible = true,
    .named = true,
  },
  [sym_constructor_or_destructor_definition] = {
    .visible = true,
    .named = true,
  },
  [sym_constructor_or_destructor_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_friend_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_access_specifier] = {
    .visible = true,
    .named = true,
  },
  [sym_reference_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_reference_field_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_abstract_reference_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_structured_binding_reference_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_structured_binding_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_trailing_return_type] = {
    .visible = true,
    .named = true,
  },
  [sym_template_type] = {
    .visible = true,
    .named = true,
  },
  [sym_template_method] = {
    .visible = true,
    .named = true,
  },
  [sym_template_function] = {
    .visible = true,
    .named = true,
  },
  [sym_template_argument_list] = {
    .visible = true,
    .named = true,
  },
  [sym_namespace_definition] = {
    .visible = true,
    .named = true,
  },
  [sym_using_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_alias_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_for_range_loop] = {
    .visible = true,
    .named = true,
  },
  [sym_for_range_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_new_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_new_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_delete_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_lambda_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_lambda_capture_specifier] = {
    .visible = true,
    .named = true,
  },
  [sym_lambda_default_capture] = {
    .visible = true,
    .named = true,
  },
  [sym_destructor_name] = {
    .visible = true,
    .named = true,
  },
  [sym_scoped_field_identifier] = {
    .visible = true,
    .named = true,
  },
  [sym_scoped_identifier] = {
    .visible = true,
    .named = true,
  },
  [sym_scoped_type_identifier] = {
    .visible = true,
    .named = true,
  },
  [sym_scoped_namespace_identifier] = {
    .visible = true,
    .named = true,
  },
  [aux_sym_translation_unit_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_preproc_params_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_preproc_if_in_compound_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_preproc_if_in_field_declaration_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_declaration_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_type_definition_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__declaration_specifiers_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_function_declarator_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_abstract_function_declarator_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_sized_type_specifier_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_enumerator_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_field_declaration_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_parameter_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_for_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_argument_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_initializer_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_initializer_pair_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_concatenated_string_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_base_class_clause_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_template_parameter_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_field_initializer_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_structured_binding_declarator_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_template_argument_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [anon_alias_sym_POUNDdefine] = {
    .visible = true,
    .named = false,
  },
  [anon_alias_sym_POUNDelif] = {
    .visible = true,
    .named = false,
  },
  [anon_alias_sym_POUNDelse] = {
    .visible = true,
    .named = false,
  },
  [anon_alias_sym_POUNDendif] = {
    .visible = true,
    .named = false,
  },
  [anon_alias_sym_POUNDif] = {
    .visible = true,
    .named = false,
  },
  [anon_alias_sym_POUNDifdef] = {
    .visible = true,
    .named = false,
  },
  [anon_alias_sym_POUNDifndef] = {
    .visible = true,
    .named = false,
  },
  [anon_alias_sym_POUNDinclude] = {
    .visible = true,
    .named = false,
  },
  [alias_sym_array_declarator] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_declaration] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_field_identifier] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_function_declarator] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_function_definition] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_namespace_identifier] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_pointer_declarator] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_preproc_elif] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_preproc_else] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_preproc_if] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_preproc_ifdef] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_reference_declarator] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_statement_identifier] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_type_identifier] = {
    .visible = true,
    .named = true,
  },
};

static TSSymbol ts_alias_sequences[53][MAX_ALIAS_SEQUENCE_LENGTH] = {
  [1] = {
    [0] = alias_sym_type_identifier,
  },
  [2] = {
    [0] = alias_sym_function_definition,
  },
  [3] = {
    [0] = anon_alias_sym_POUNDinclude,
  },
  [4] = {
    [1] = alias_sym_type_identifier,
  },
  [5] = {
    [1] = alias_sym_namespace_identifier,
  },
  [6] = {
    [0] = anon_alias_sym_POUNDdefine,
  },
  [7] = {
    [0] = anon_alias_sym_POUNDif,
    [2] = anon_alias_sym_POUNDendif,
  },
  [8] = {
    [0] = anon_alias_sym_POUNDelse,
  },
  [9] = {
    [0] = anon_alias_sym_POUNDifdef,
    [2] = anon_alias_sym_POUNDendif,
  },
  [10] = {
    [0] = anon_alias_sym_POUNDifndef,
    [2] = anon_alias_sym_POUNDendif,
  },
  [11] = {
    [0] = alias_sym_pointer_declarator,
  },
  [12] = {
    [0] = alias_sym_function_declarator,
  },
  [13] = {
    [0] = alias_sym_array_declarator,
  },
  [14] = {
    [0] = alias_sym_preproc_if,
  },
  [15] = {
    [0] = alias_sym_preproc_ifdef,
  },
  [16] = {
    [0] = alias_sym_declaration,
  },
  [17] = {
    [0] = alias_sym_namespace_identifier,
  },
  [18] = {
    [0] = alias_sym_namespace_identifier,
    [2] = alias_sym_type_identifier,
  },
  [19] = {
    [0] = alias_sym_namespace_identifier,
    [2] = alias_sym_namespace_identifier,
  },
  [20] = {
    [2] = alias_sym_type_identifier,
  },
  [21] = {
    [2] = alias_sym_namespace_identifier,
  },
  [22] = {
    [0] = anon_alias_sym_POUNDelif,
  },
  [23] = {
    [0] = anon_alias_sym_POUNDif,
    [3] = anon_alias_sym_POUNDendif,
  },
  [24] = {
    [0] = anon_alias_sym_POUNDifdef,
    [3] = anon_alias_sym_POUNDendif,
  },
  [25] = {
    [0] = anon_alias_sym_POUNDifndef,
    [3] = anon_alias_sym_POUNDendif,
  },
  [26] = {
    [0] = alias_sym_field_identifier,
  },
  [27] = {
    [0] = alias_sym_reference_declarator,
  },
  [28] = {
    [1] = alias_sym_reference_declarator,
  },
  [29] = {
    [1] = alias_sym_field_identifier,
  },
  [30] = {
    [0] = anon_alias_sym_POUNDif,
    [4] = anon_alias_sym_POUNDendif,
  },
  [31] = {
    [0] = anon_alias_sym_POUNDifdef,
    [4] = anon_alias_sym_POUNDendif,
  },
  [32] = {
    [0] = anon_alias_sym_POUNDifndef,
    [4] = anon_alias_sym_POUNDendif,
  },
  [33] = {
    [2] = alias_sym_field_identifier,
  },
  [34] = {
    [1] = alias_sym_statement_identifier,
  },
  [35] = {
    [0] = alias_sym_statement_identifier,
  },
  [36] = {
    [0] = alias_sym_namespace_identifier,
    [2] = alias_sym_field_identifier,
  },
  [37] = {
    [0] = anon_alias_sym_POUNDif,
    [2] = alias_sym_preproc_else,
    [3] = anon_alias_sym_POUNDendif,
  },
  [38] = {
    [0] = anon_alias_sym_POUNDif,
    [2] = alias_sym_preproc_elif,
    [3] = anon_alias_sym_POUNDendif,
  },
  [39] = {
    [0] = anon_alias_sym_POUNDifdef,
    [2] = alias_sym_preproc_else,
    [3] = anon_alias_sym_POUNDendif,
  },
  [40] = {
    [0] = anon_alias_sym_POUNDifdef,
    [2] = alias_sym_preproc_elif,
    [3] = anon_alias_sym_POUNDendif,
  },
  [41] = {
    [0] = anon_alias_sym_POUNDifndef,
    [2] = alias_sym_preproc_else,
    [3] = anon_alias_sym_POUNDendif,
  },
  [42] = {
    [0] = anon_alias_sym_POUNDifndef,
    [2] = alias_sym_preproc_elif,
    [3] = anon_alias_sym_POUNDendif,
  },
  [43] = {
    [0] = anon_alias_sym_POUNDelif,
    [2] = alias_sym_preproc_else,
  },
  [44] = {
    [0] = anon_alias_sym_POUNDelif,
    [2] = alias_sym_preproc_elif,
  },
  [45] = {
    [0] = anon_alias_sym_POUNDif,
    [3] = alias_sym_preproc_else,
    [4] = anon_alias_sym_POUNDendif,
  },
  [46] = {
    [0] = anon_alias_sym_POUNDif,
    [3] = alias_sym_preproc_elif,
    [4] = anon_alias_sym_POUNDendif,
  },
  [47] = {
    [0] = anon_alias_sym_POUNDifdef,
    [3] = alias_sym_preproc_else,
    [4] = anon_alias_sym_POUNDendif,
  },
  [48] = {
    [0] = anon_alias_sym_POUNDifdef,
    [3] = alias_sym_preproc_elif,
    [4] = anon_alias_sym_POUNDendif,
  },
  [49] = {
    [0] = anon_alias_sym_POUNDifndef,
    [3] = alias_sym_preproc_else,
    [4] = anon_alias_sym_POUNDendif,
  },
  [50] = {
    [0] = anon_alias_sym_POUNDifndef,
    [3] = alias_sym_preproc_elif,
    [4] = anon_alias_sym_POUNDendif,
  },
  [51] = {
    [0] = anon_alias_sym_POUNDelif,
    [3] = alias_sym_preproc_else,
  },
  [52] = {
    [0] = anon_alias_sym_POUNDelif,
    [3] = alias_sym_preproc_elif,
  },
};

static bool ts_lex(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  switch (state) {
    case 0:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '\"')
        ADVANCE(4);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(40);
      if (lookahead == '&')
        ADVANCE(42);
      if (lookahead == '\'')
        ADVANCE(45);
      if (lookahead == '(')
        ADVANCE(50);
      if (lookahead == ')')
        ADVANCE(51);
      if (lookahead == '*')
        ADVANCE(52);
      if (lookahead == '+')
        ADVANCE(54);
      if (lookahead == ',')
        ADVANCE(57);
      if (lookahead == '-')
        ADVANCE(58);
      if (lookahead == '.')
        ADVANCE(62);
      if (lookahead == '/')
        ADVANCE(65);
      if (lookahead == '0')
        ADVANCE(71);
      if (lookahead == ':')
        ADVANCE(80);
      if (lookahead == ';')
        ADVANCE(82);
      if (lookahead == '<')
        ADVANCE(83);
      if (lookahead == '=')
        ADVANCE(87);
      if (lookahead == '>')
        ADVANCE(89);
      if (lookahead == '?')
        ADVANCE(93);
      if (lookahead == 'F')
        ADVANCE(94);
      if (lookahead == 'N')
        ADVANCE(100);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == ']')
        ADVANCE(109);
      if (lookahead == '^')
        ADVANCE(110);
      if (lookahead == '_')
        ADVANCE(112);
      if (lookahead == 'a')
        ADVANCE(119);
      if (lookahead == 'b')
        ADVANCE(123);
      if (lookahead == 'c')
        ADVANCE(131);
      if (lookahead == 'd')
        ADVANCE(162);
      if (lookahead == 'e')
        ADVANCE(177);
      if (lookahead == 'f')
        ADVANCE(195);
      if (lookahead == 'g')
        ADVANCE(208);
      if (lookahead == 'i')
        ADVANCE(212);
      if (lookahead == 'l')
        ADVANCE(219);
      if (lookahead == 'm')
        ADVANCE(223);
      if (lookahead == 'n')
        ADVANCE(230);
      if (lookahead == 'o')
        ADVANCE(254);
      if (lookahead == 'p')
        ADVANCE(273);
      if (lookahead == 'r')
        ADVANCE(292);
      if (lookahead == 's')
        ADVANCE(310);
      if (lookahead == 't')
        ADVANCE(337);
      if (lookahead == 'u')
        ADVANCE(357);
      if (lookahead == 'v')
        ADVANCE(375);
      if (lookahead == 'w')
        ADVANCE(384);
      if (lookahead == '{')
        ADVANCE(389);
      if (lookahead == '|')
        ADVANCE(390);
      if (lookahead == '}')
        ADVANCE(393);
      if (lookahead == '~')
        ADVANCE(394);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(0);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(79);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('h' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 1:
      ACCEPT_TOKEN(ts_builtin_sym_end);
      END_STATE();
    case 2:
      ACCEPT_TOKEN(anon_sym_BANG);
      if (lookahead == '=')
        ADVANCE(3);
      END_STATE();
    case 3:
      ACCEPT_TOKEN(anon_sym_BANG_EQ);
      END_STATE();
    case 4:
      if (lookahead == '\"')
        ADVANCE(5);
      if (lookahead == '\\')
        ADVANCE(6);
      if (lookahead != 0 &&
          lookahead != '\n')
        ADVANCE(4);
      END_STATE();
    case 5:
      ACCEPT_TOKEN(sym_string_literal);
      END_STATE();
    case 6:
      if (lookahead != 0 &&
          lookahead != '\n')
        ADVANCE(4);
      END_STATE();
    case 7:
      if (lookahead == 'd')
        ADVANCE(8);
      if (lookahead == 'e')
        ADVANCE(15);
      if (lookahead == 'i')
        ADVANCE(25);
      if (lookahead == '\t' ||
          lookahead == ' ')
        ADVANCE(7);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(14);
      END_STATE();
    case 8:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'e')
        ADVANCE(9);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(14);
      END_STATE();
    case 9:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'f')
        ADVANCE(10);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(14);
      END_STATE();
    case 10:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'i')
        ADVANCE(11);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(14);
      END_STATE();
    case 11:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'n')
        ADVANCE(12);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(14);
      END_STATE();
    case 12:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'e')
        ADVANCE(13);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(14);
      END_STATE();
    case 13:
      ACCEPT_TOKEN(aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(14);
      END_STATE();
    case 14:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(14);
      END_STATE();
    case 15:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'l')
        ADVANCE(16);
      if (lookahead == 'n')
        ADVANCE(21);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(14);
      END_STATE();
    case 16:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'i')
        ADVANCE(17);
      if (lookahead == 's')
        ADVANCE(19);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(14);
      END_STATE();
    case 17:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'f')
        ADVANCE(18);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(14);
      END_STATE();
    case 18:
      ACCEPT_TOKEN(aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(14);
      END_STATE();
    case 19:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'e')
        ADVANCE(20);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(14);
      END_STATE();
    case 20:
      ACCEPT_TOKEN(aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(14);
      END_STATE();
    case 21:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'd')
        ADVANCE(22);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(14);
      END_STATE();
    case 22:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'i')
        ADVANCE(23);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(14);
      END_STATE();
    case 23:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'f')
        ADVANCE(24);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(14);
      END_STATE();
    case 24:
      ACCEPT_TOKEN(aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(14);
      END_STATE();
    case 25:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'f')
        ADVANCE(26);
      if (lookahead == 'n')
        ADVANCE(34);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(14);
      END_STATE();
    case 26:
      ACCEPT_TOKEN(aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH);
      if (lookahead == 'd')
        ADVANCE(27);
      if (lookahead == 'n')
        ADVANCE(30);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(14);
      END_STATE();
    case 27:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'e')
        ADVANCE(28);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(14);
      END_STATE();
    case 28:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'f')
        ADVANCE(29);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(14);
      END_STATE();
    case 29:
      ACCEPT_TOKEN(aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(14);
      END_STATE();
    case 30:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'd')
        ADVANCE(31);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(14);
      END_STATE();
    case 31:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'e')
        ADVANCE(32);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(14);
      END_STATE();
    case 32:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'f')
        ADVANCE(33);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(14);
      END_STATE();
    case 33:
      ACCEPT_TOKEN(aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(14);
      END_STATE();
    case 34:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'c')
        ADVANCE(35);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(14);
      END_STATE();
    case 35:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'l')
        ADVANCE(36);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(14);
      END_STATE();
    case 36:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'u')
        ADVANCE(37);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(14);
      END_STATE();
    case 37:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'd')
        ADVANCE(38);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(14);
      END_STATE();
    case 38:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'e')
        ADVANCE(39);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(14);
      END_STATE();
    case 39:
      ACCEPT_TOKEN(aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(14);
      END_STATE();
    case 40:
      ACCEPT_TOKEN(anon_sym_PERCENT);
      if (lookahead == '=')
        ADVANCE(41);
      END_STATE();
    case 41:
      ACCEPT_TOKEN(anon_sym_PERCENT_EQ);
      END_STATE();
    case 42:
      ACCEPT_TOKEN(anon_sym_AMP);
      if (lookahead == '&')
        ADVANCE(43);
      if (lookahead == '=')
        ADVANCE(44);
      END_STATE();
    case 43:
      ACCEPT_TOKEN(anon_sym_AMP_AMP);
      END_STATE();
    case 44:
      ACCEPT_TOKEN(anon_sym_AMP_EQ);
      END_STATE();
    case 45:
      if (lookahead == '\\')
        ADVANCE(46);
      if (lookahead != 0 &&
          lookahead != '\'')
        ADVANCE(49);
      END_STATE();
    case 46:
      if (lookahead == '\'')
        ADVANCE(47);
      if (lookahead != 0)
        ADVANCE(49);
      END_STATE();
    case 47:
      ACCEPT_TOKEN(sym_char_literal);
      if (lookahead == '\'')
        ADVANCE(48);
      END_STATE();
    case 48:
      ACCEPT_TOKEN(sym_char_literal);
      END_STATE();
    case 49:
      if (lookahead == '\'')
        ADVANCE(48);
      END_STATE();
    case 50:
      ACCEPT_TOKEN(anon_sym_LPAREN);
      END_STATE();
    case 51:
      ACCEPT_TOKEN(anon_sym_RPAREN);
      END_STATE();
    case 52:
      ACCEPT_TOKEN(anon_sym_STAR);
      if (lookahead == '=')
        ADVANCE(53);
      END_STATE();
    case 53:
      ACCEPT_TOKEN(anon_sym_STAR_EQ);
      END_STATE();
    case 54:
      ACCEPT_TOKEN(anon_sym_PLUS);
      if (lookahead == '+')
        ADVANCE(55);
      if (lookahead == '=')
        ADVANCE(56);
      END_STATE();
    case 55:
      ACCEPT_TOKEN(anon_sym_PLUS_PLUS);
      END_STATE();
    case 56:
      ACCEPT_TOKEN(anon_sym_PLUS_EQ);
      END_STATE();
    case 57:
      ACCEPT_TOKEN(anon_sym_COMMA);
      END_STATE();
    case 58:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '-')
        ADVANCE(59);
      if (lookahead == '=')
        ADVANCE(60);
      if (lookahead == '>')
        ADVANCE(61);
      END_STATE();
    case 59:
      ACCEPT_TOKEN(anon_sym_DASH_DASH);
      END_STATE();
    case 60:
      ACCEPT_TOKEN(anon_sym_DASH_EQ);
      END_STATE();
    case 61:
      ACCEPT_TOKEN(anon_sym_DASH_GT);
      END_STATE();
    case 62:
      ACCEPT_TOKEN(anon_sym_DOT);
      if (lookahead == '.')
        ADVANCE(63);
      END_STATE();
    case 63:
      if (lookahead == '.')
        ADVANCE(64);
      END_STATE();
    case 64:
      ACCEPT_TOKEN(anon_sym_DOT_DOT_DOT);
      END_STATE();
    case 65:
      ACCEPT_TOKEN(anon_sym_SLASH);
      if (lookahead == '*')
        ADVANCE(66);
      if (lookahead == '/')
        ADVANCE(69);
      if (lookahead == '=')
        ADVANCE(70);
      END_STATE();
    case 66:
      if (lookahead == '*')
        ADVANCE(67);
      if (lookahead != 0)
        ADVANCE(66);
      END_STATE();
    case 67:
      if (lookahead == '*')
        ADVANCE(67);
      if (lookahead == '/')
        ADVANCE(68);
      if (lookahead != 0)
        ADVANCE(66);
      END_STATE();
    case 68:
      ACCEPT_TOKEN(sym_comment);
      END_STATE();
    case 69:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead != 0 &&
          lookahead != '\n')
        ADVANCE(69);
      END_STATE();
    case 70:
      ACCEPT_TOKEN(anon_sym_SLASH_EQ);
      END_STATE();
    case 71:
      ACCEPT_TOKEN(sym_number_literal);
      if (lookahead == '.')
        ADVANCE(72);
      if (lookahead == 'L')
        ADVANCE(74);
      if (lookahead == 'U')
        ADVANCE(74);
      if (lookahead == 'b')
        ADVANCE(75);
      if (lookahead == 'l')
        ADVANCE(74);
      if (lookahead == 'u')
        ADVANCE(74);
      if (lookahead == 'x')
        ADVANCE(77);
      if (('0' <= lookahead && lookahead <= '9'))
        ADVANCE(79);
      END_STATE();
    case 72:
      if (('0' <= lookahead && lookahead <= '9'))
        ADVANCE(73);
      END_STATE();
    case 73:
      ACCEPT_TOKEN(sym_number_literal);
      if (lookahead == 'L')
        ADVANCE(74);
      if (lookahead == 'U')
        ADVANCE(74);
      if (lookahead == 'l')
        ADVANCE(74);
      if (lookahead == 'u')
        ADVANCE(74);
      if (('0' <= lookahead && lookahead <= '9'))
        ADVANCE(73);
      END_STATE();
    case 74:
      ACCEPT_TOKEN(sym_number_literal);
      if (lookahead == 'L')
        ADVANCE(74);
      if (lookahead == 'U')
        ADVANCE(74);
      if (lookahead == 'l')
        ADVANCE(74);
      if (lookahead == 'u')
        ADVANCE(74);
      END_STATE();
    case 75:
      if (lookahead == '0' ||
          lookahead == '1')
        ADVANCE(76);
      END_STATE();
    case 76:
      ACCEPT_TOKEN(sym_number_literal);
      if (lookahead == 'L')
        ADVANCE(74);
      if (lookahead == 'U')
        ADVANCE(74);
      if (lookahead == 'l')
        ADVANCE(74);
      if (lookahead == 'u')
        ADVANCE(74);
      if (lookahead == '0' ||
          lookahead == '1')
        ADVANCE(76);
      END_STATE();
    case 77:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'f'))
        ADVANCE(78);
      END_STATE();
    case 78:
      ACCEPT_TOKEN(sym_number_literal);
      if (lookahead == 'L')
        ADVANCE(78);
      if (lookahead == 'U')
        ADVANCE(78);
      if (lookahead == 'l')
        ADVANCE(74);
      if (lookahead == 'u')
        ADVANCE(74);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'f'))
        ADVANCE(78);
      END_STATE();
    case 79:
      ACCEPT_TOKEN(sym_number_literal);
      if (lookahead == '.')
        ADVANCE(72);
      if (lookahead == 'L')
        ADVANCE(74);
      if (lookahead == 'U')
        ADVANCE(74);
      if (lookahead == 'l')
        ADVANCE(74);
      if (lookahead == 'u')
        ADVANCE(74);
      if (('0' <= lookahead && lookahead <= '9'))
        ADVANCE(79);
      END_STATE();
    case 80:
      ACCEPT_TOKEN(anon_sym_COLON);
      if (lookahead == ':')
        ADVANCE(81);
      END_STATE();
    case 81:
      ACCEPT_TOKEN(anon_sym_COLON_COLON);
      END_STATE();
    case 82:
      ACCEPT_TOKEN(anon_sym_SEMI);
      END_STATE();
    case 83:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '<')
        ADVANCE(84);
      if (lookahead == '=')
        ADVANCE(86);
      END_STATE();
    case 84:
      ACCEPT_TOKEN(anon_sym_LT_LT);
      if (lookahead == '=')
        ADVANCE(85);
      END_STATE();
    case 85:
      ACCEPT_TOKEN(anon_sym_LT_LT_EQ);
      END_STATE();
    case 86:
      ACCEPT_TOKEN(anon_sym_LT_EQ);
      END_STATE();
    case 87:
      ACCEPT_TOKEN(anon_sym_EQ);
      if (lookahead == '=')
        ADVANCE(88);
      END_STATE();
    case 88:
      ACCEPT_TOKEN(anon_sym_EQ_EQ);
      END_STATE();
    case 89:
      ACCEPT_TOKEN(anon_sym_GT);
      if (lookahead == '=')
        ADVANCE(90);
      if (lookahead == '>')
        ADVANCE(91);
      END_STATE();
    case 90:
      ACCEPT_TOKEN(anon_sym_GT_EQ);
      END_STATE();
    case 91:
      ACCEPT_TOKEN(anon_sym_GT_GT);
      if (lookahead == '=')
        ADVANCE(92);
      END_STATE();
    case 92:
      ACCEPT_TOKEN(anon_sym_GT_GT_EQ);
      END_STATE();
    case 93:
      ACCEPT_TOKEN(anon_sym_QMARK);
      END_STATE();
    case 94:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'A')
        ADVANCE(95);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('B' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 95:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'L')
        ADVANCE(96);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 96:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'S')
        ADVANCE(97);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 97:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'E')
        ADVANCE(98);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 98:
      ACCEPT_TOKEN(sym_false);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 99:
      ACCEPT_TOKEN(sym_identifier);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 100:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'U')
        ADVANCE(101);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 101:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'L')
        ADVANCE(102);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 102:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'L')
        ADVANCE(103);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 103:
      ACCEPT_TOKEN(sym_null);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 104:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'R')
        ADVANCE(105);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 105:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'U')
        ADVANCE(106);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 106:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'E')
        ADVANCE(107);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 107:
      ACCEPT_TOKEN(sym_true);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 108:
      ACCEPT_TOKEN(anon_sym_LBRACK);
      END_STATE();
    case 109:
      ACCEPT_TOKEN(anon_sym_RBRACK);
      END_STATE();
    case 110:
      ACCEPT_TOKEN(anon_sym_CARET);
      if (lookahead == '=')
        ADVANCE(111);
      END_STATE();
    case 111:
      ACCEPT_TOKEN(anon_sym_CARET_EQ);
      END_STATE();
    case 112:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'A')
        ADVANCE(113);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('B' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 113:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 't')
        ADVANCE(114);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 114:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'o')
        ADVANCE(115);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 115:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'm')
        ADVANCE(116);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 116:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'i')
        ADVANCE(117);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 117:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'c')
        ADVANCE(118);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 118:
      ACCEPT_TOKEN(anon_sym__Atomic);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 119:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'u')
        ADVANCE(120);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 120:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 't')
        ADVANCE(121);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 121:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'o')
        ADVANCE(122);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 122:
      ACCEPT_TOKEN(sym_auto);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 123:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'o')
        ADVANCE(124);
      if (lookahead == 'r')
        ADVANCE(127);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 124:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'o')
        ADVANCE(125);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 125:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'l')
        ADVANCE(126);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 126:
      ACCEPT_TOKEN(sym_primitive_type);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 127:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'e')
        ADVANCE(128);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 128:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'a')
        ADVANCE(129);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 129:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'k')
        ADVANCE(130);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 130:
      ACCEPT_TOKEN(anon_sym_break);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 131:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'a')
        ADVANCE(132);
      if (lookahead == 'h')
        ADVANCE(135);
      if (lookahead == 'l')
        ADVANCE(145);
      if (lookahead == 'o')
        ADVANCE(149);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 132:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 's')
        ADVANCE(133);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 133:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'e')
        ADVANCE(134);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 134:
      ACCEPT_TOKEN(anon_sym_case);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 135:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'a')
        ADVANCE(136);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 136:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'r')
        ADVANCE(137);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 137:
      ACCEPT_TOKEN(sym_primitive_type);
      if (lookahead == '1')
        ADVANCE(138);
      if (lookahead == '3')
        ADVANCE(141);
      if (lookahead == '6')
        ADVANCE(142);
      if (lookahead == '8')
        ADVANCE(139);
      if (lookahead == 'p')
        ADVANCE(143);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 138:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '6')
        ADVANCE(139);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 139:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '_')
        ADVANCE(140);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 140:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 't')
        ADVANCE(126);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 141:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '2')
        ADVANCE(139);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 142:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '4')
        ADVANCE(139);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 143:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 't')
        ADVANCE(144);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 144:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'r')
        ADVANCE(139);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 145:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'a')
        ADVANCE(146);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 146:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 's')
        ADVANCE(147);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 147:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 's')
        ADVANCE(148);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 148:
      ACCEPT_TOKEN(anon_sym_class);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 149:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'n')
        ADVANCE(150);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 150:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 's')
        ADVANCE(151);
      if (lookahead == 't')
        ADVANCE(157);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 151:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 't')
        ADVANCE(152);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 152:
      ACCEPT_TOKEN(anon_sym_const);
      if (lookahead == 'e')
        ADVANCE(153);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 153:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'x')
        ADVANCE(154);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 154:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'p')
        ADVANCE(155);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 155:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'r')
        ADVANCE(156);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 156:
      ACCEPT_TOKEN(anon_sym_constexpr);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 157:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'i')
        ADVANCE(158);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 158:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'n')
        ADVANCE(159);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 159:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'u')
        ADVANCE(160);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 160:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'e')
        ADVANCE(161);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 161:
      ACCEPT_TOKEN(anon_sym_continue);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 162:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'e')
        ADVANCE(163);
      if (lookahead == 'o')
        ADVANCE(173);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 163:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'f')
        ADVANCE(164);
      if (lookahead == 'l')
        ADVANCE(169);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 164:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'a')
        ADVANCE(165);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 165:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'u')
        ADVANCE(166);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 166:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'l')
        ADVANCE(167);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 167:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 't')
        ADVANCE(168);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 168:
      ACCEPT_TOKEN(anon_sym_default);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 169:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'e')
        ADVANCE(170);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 170:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 't')
        ADVANCE(171);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 171:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'e')
        ADVANCE(172);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 172:
      ACCEPT_TOKEN(anon_sym_delete);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 173:
      ACCEPT_TOKEN(anon_sym_do);
      if (lookahead == 'u')
        ADVANCE(174);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 174:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'b')
        ADVANCE(175);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 175:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'l')
        ADVANCE(176);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 176:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'e')
        ADVANCE(126);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 177:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'l')
        ADVANCE(178);
      if (lookahead == 'n')
        ADVANCE(181);
      if (lookahead == 'x')
        ADVANCE(184);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 178:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 's')
        ADVANCE(179);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 179:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'e')
        ADVANCE(180);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 180:
      ACCEPT_TOKEN(anon_sym_else);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 181:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'u')
        ADVANCE(182);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 182:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'm')
        ADVANCE(183);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 183:
      ACCEPT_TOKEN(anon_sym_enum);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 184:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'p')
        ADVANCE(185);
      if (lookahead == 't')
        ADVANCE(191);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 185:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'l')
        ADVANCE(186);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 186:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'i')
        ADVANCE(187);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 187:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'c')
        ADVANCE(188);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 188:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'i')
        ADVANCE(189);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 189:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 't')
        ADVANCE(190);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 190:
      ACCEPT_TOKEN(anon_sym_explicit);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 191:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'e')
        ADVANCE(192);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 192:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'r')
        ADVANCE(193);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 193:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'n')
        ADVANCE(194);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 194:
      ACCEPT_TOKEN(anon_sym_extern);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 195:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'a')
        ADVANCE(196);
      if (lookahead == 'l')
        ADVANCE(199);
      if (lookahead == 'o')
        ADVANCE(201);
      if (lookahead == 'r')
        ADVANCE(203);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 196:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'l')
        ADVANCE(197);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 197:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 's')
        ADVANCE(198);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 198:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'e')
        ADVANCE(98);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 199:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'o')
        ADVANCE(200);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 200:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'a')
        ADVANCE(140);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 201:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'r')
        ADVANCE(202);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 202:
      ACCEPT_TOKEN(anon_sym_for);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 203:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'i')
        ADVANCE(204);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 204:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'e')
        ADVANCE(205);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 205:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'n')
        ADVANCE(206);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 206:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'd')
        ADVANCE(207);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 207:
      ACCEPT_TOKEN(anon_sym_friend);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 208:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'o')
        ADVANCE(209);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 209:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 't')
        ADVANCE(210);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 210:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'o')
        ADVANCE(211);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 211:
      ACCEPT_TOKEN(anon_sym_goto);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 212:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'f')
        ADVANCE(213);
      if (lookahead == 'n')
        ADVANCE(214);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 213:
      ACCEPT_TOKEN(anon_sym_if);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 214:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'l')
        ADVANCE(215);
      if (lookahead == 't')
        ADVANCE(137);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 215:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'i')
        ADVANCE(216);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 216:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'n')
        ADVANCE(217);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 217:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'e')
        ADVANCE(218);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 218:
      ACCEPT_TOKEN(anon_sym_inline);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 219:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'o')
        ADVANCE(220);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 220:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'n')
        ADVANCE(221);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 221:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'g')
        ADVANCE(222);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 222:
      ACCEPT_TOKEN(anon_sym_long);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 223:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'u')
        ADVANCE(224);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 224:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 't')
        ADVANCE(225);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 225:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'a')
        ADVANCE(226);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 226:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'b')
        ADVANCE(227);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 227:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'l')
        ADVANCE(228);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 228:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'e')
        ADVANCE(229);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 229:
      ACCEPT_TOKEN(anon_sym_mutable);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 230:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'a')
        ADVANCE(231);
      if (lookahead == 'e')
        ADVANCE(239);
      if (lookahead == 'o')
        ADVANCE(241);
      if (lookahead == 'u')
        ADVANCE(248);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 231:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'm')
        ADVANCE(232);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 232:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'e')
        ADVANCE(233);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 233:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 's')
        ADVANCE(234);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 234:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'p')
        ADVANCE(235);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 235:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'a')
        ADVANCE(236);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 236:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'c')
        ADVANCE(237);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 237:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'e')
        ADVANCE(238);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 238:
      ACCEPT_TOKEN(anon_sym_namespace);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 239:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'w')
        ADVANCE(240);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 240:
      ACCEPT_TOKEN(anon_sym_new);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 241:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'e')
        ADVANCE(242);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 242:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'x')
        ADVANCE(243);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 243:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'c')
        ADVANCE(244);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 244:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'e')
        ADVANCE(245);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 245:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'p')
        ADVANCE(246);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 246:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 't')
        ADVANCE(247);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 247:
      ACCEPT_TOKEN(sym_noexcept);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 248:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'l')
        ADVANCE(249);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 249:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'l')
        ADVANCE(250);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 250:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'p')
        ADVANCE(251);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 251:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 't')
        ADVANCE(252);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 252:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'r')
        ADVANCE(253);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 253:
      ACCEPT_TOKEN(sym_nullptr);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 254:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'p')
        ADVANCE(255);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 255:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'e')
        ADVANCE(256);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 256:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'r')
        ADVANCE(257);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 257:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'a')
        ADVANCE(258);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 258:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 't')
        ADVANCE(259);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 259:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'o')
        ADVANCE(260);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 260:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'r')
        ADVANCE(261);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 261:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '!')
        ADVANCE(262);
      if (lookahead == '%')
        ADVANCE(262);
      if (lookahead == '&')
        ADVANCE(264);
      if (lookahead == '(')
        ADVANCE(265);
      if (lookahead == '*')
        ADVANCE(262);
      if (lookahead == '+')
        ADVANCE(266);
      if (lookahead == ',')
        ADVANCE(263);
      if (lookahead == '-')
        ADVANCE(267);
      if (lookahead == '/')
        ADVANCE(262);
      if (lookahead == '<')
        ADVANCE(269);
      if (lookahead == '=')
        ADVANCE(262);
      if (lookahead == '>')
        ADVANCE(270);
      if (lookahead == '[')
        ADVANCE(271);
      if (lookahead == '^')
        ADVANCE(262);
      if (lookahead == '|')
        ADVANCE(272);
      if (lookahead == '~')
        ADVANCE(263);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 262:
      ACCEPT_TOKEN(sym_operator_name);
      if (lookahead == '=')
        ADVANCE(263);
      END_STATE();
    case 263:
      ACCEPT_TOKEN(sym_operator_name);
      END_STATE();
    case 264:
      ACCEPT_TOKEN(sym_operator_name);
      if (lookahead == '&')
        ADVANCE(263);
      if (lookahead == '=')
        ADVANCE(263);
      END_STATE();
    case 265:
      if (lookahead == ')')
        ADVANCE(263);
      END_STATE();
    case 266:
      ACCEPT_TOKEN(sym_operator_name);
      if (lookahead == '+')
        ADVANCE(263);
      if (lookahead == '=')
        ADVANCE(263);
      END_STATE();
    case 267:
      ACCEPT_TOKEN(sym_operator_name);
      if (lookahead == '-')
        ADVANCE(263);
      if (lookahead == '=')
        ADVANCE(263);
      if (lookahead == '>')
        ADVANCE(268);
      END_STATE();
    case 268:
      ACCEPT_TOKEN(sym_operator_name);
      if (lookahead == '*')
        ADVANCE(263);
      END_STATE();
    case 269:
      ACCEPT_TOKEN(sym_operator_name);
      if (lookahead == '<')
        ADVANCE(262);
      if (lookahead == '=')
        ADVANCE(263);
      END_STATE();
    case 270:
      ACCEPT_TOKEN(sym_operator_name);
      if (lookahead == '=')
        ADVANCE(263);
      if (lookahead == '>')
        ADVANCE(262);
      END_STATE();
    case 271:
      if (lookahead == ']')
        ADVANCE(263);
      END_STATE();
    case 272:
      ACCEPT_TOKEN(sym_operator_name);
      if (lookahead == '=')
        ADVANCE(263);
      if (lookahead == '|')
        ADVANCE(263);
      END_STATE();
    case 273:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'r')
        ADVANCE(274);
      if (lookahead == 'u')
        ADVANCE(287);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 274:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'i')
        ADVANCE(275);
      if (lookahead == 'o')
        ADVANCE(280);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 275:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'v')
        ADVANCE(276);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 276:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'a')
        ADVANCE(277);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 277:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 't')
        ADVANCE(278);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 278:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'e')
        ADVANCE(279);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 279:
      ACCEPT_TOKEN(anon_sym_private);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 280:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 't')
        ADVANCE(281);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 281:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'e')
        ADVANCE(282);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 282:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'c')
        ADVANCE(283);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 283:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 't')
        ADVANCE(284);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 284:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'e')
        ADVANCE(285);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 285:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'd')
        ADVANCE(286);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 286:
      ACCEPT_TOKEN(anon_sym_protected);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 287:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'b')
        ADVANCE(288);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 288:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'l')
        ADVANCE(289);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 289:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'i')
        ADVANCE(290);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 290:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'c')
        ADVANCE(291);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 291:
      ACCEPT_TOKEN(anon_sym_public);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 292:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'e')
        ADVANCE(293);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 293:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'g')
        ADVANCE(294);
      if (lookahead == 's')
        ADVANCE(300);
      if (lookahead == 't')
        ADVANCE(306);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 294:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'i')
        ADVANCE(295);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 295:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 's')
        ADVANCE(296);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 296:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 't')
        ADVANCE(297);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 297:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'e')
        ADVANCE(298);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 298:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'r')
        ADVANCE(299);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 299:
      ACCEPT_TOKEN(anon_sym_register);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 300:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 't')
        ADVANCE(301);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 301:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'r')
        ADVANCE(302);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 302:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'i')
        ADVANCE(303);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 303:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'c')
        ADVANCE(304);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 304:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 't')
        ADVANCE(305);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 305:
      ACCEPT_TOKEN(anon_sym_restrict);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 306:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'u')
        ADVANCE(307);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 307:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'r')
        ADVANCE(308);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 308:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'n')
        ADVANCE(309);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 309:
      ACCEPT_TOKEN(anon_sym_return);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 310:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'h')
        ADVANCE(311);
      if (lookahead == 'i')
        ADVANCE(315);
      if (lookahead == 's')
        ADVANCE(320);
      if (lookahead == 't')
        ADVANCE(323);
      if (lookahead == 'w')
        ADVANCE(332);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 311:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'o')
        ADVANCE(312);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 312:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'r')
        ADVANCE(313);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 313:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 't')
        ADVANCE(314);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 314:
      ACCEPT_TOKEN(anon_sym_short);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 315:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'z')
        ADVANCE(316);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'y'))
        ADVANCE(99);
      END_STATE();
    case 316:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'e')
        ADVANCE(317);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 317:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '_')
        ADVANCE(140);
      if (lookahead == 'o')
        ADVANCE(318);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 318:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'f')
        ADVANCE(319);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 319:
      ACCEPT_TOKEN(anon_sym_sizeof);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 320:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'i')
        ADVANCE(321);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 321:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'z')
        ADVANCE(322);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'y'))
        ADVANCE(99);
      END_STATE();
    case 322:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'e')
        ADVANCE(139);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 323:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'a')
        ADVANCE(324);
      if (lookahead == 'r')
        ADVANCE(328);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 324:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 't')
        ADVANCE(325);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 325:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'i')
        ADVANCE(326);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 326:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'c')
        ADVANCE(327);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 327:
      ACCEPT_TOKEN(anon_sym_static);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 328:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'u')
        ADVANCE(329);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 329:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'c')
        ADVANCE(330);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 330:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 't')
        ADVANCE(331);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 331:
      ACCEPT_TOKEN(anon_sym_struct);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 332:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'i')
        ADVANCE(333);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 333:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 't')
        ADVANCE(334);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 334:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'c')
        ADVANCE(335);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 335:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'h')
        ADVANCE(336);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 336:
      ACCEPT_TOKEN(anon_sym_switch);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 337:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'e')
        ADVANCE(338);
      if (lookahead == 'r')
        ADVANCE(345);
      if (lookahead == 'y')
        ADVANCE(347);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 338:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'm')
        ADVANCE(339);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 339:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'p')
        ADVANCE(340);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 340:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'l')
        ADVANCE(341);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 341:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'a')
        ADVANCE(342);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 342:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 't')
        ADVANCE(343);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 343:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'e')
        ADVANCE(344);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 344:
      ACCEPT_TOKEN(anon_sym_template);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 345:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'u')
        ADVANCE(346);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 346:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'e')
        ADVANCE(107);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 347:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'p')
        ADVANCE(348);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 348:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'e')
        ADVANCE(349);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 349:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'd')
        ADVANCE(350);
      if (lookahead == 'n')
        ADVANCE(353);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 350:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'e')
        ADVANCE(351);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 351:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'f')
        ADVANCE(352);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 352:
      ACCEPT_TOKEN(anon_sym_typedef);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 353:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'a')
        ADVANCE(354);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 354:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'm')
        ADVANCE(355);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 355:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'e')
        ADVANCE(356);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 356:
      ACCEPT_TOKEN(anon_sym_typename);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 357:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'i')
        ADVANCE(358);
      if (lookahead == 'n')
        ADVANCE(361);
      if (lookahead == 's')
        ADVANCE(371);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 358:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'n')
        ADVANCE(359);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 359:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 't')
        ADVANCE(360);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 360:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '1')
        ADVANCE(138);
      if (lookahead == '3')
        ADVANCE(141);
      if (lookahead == '6')
        ADVANCE(142);
      if (lookahead == '8')
        ADVANCE(139);
      if (lookahead == 'p')
        ADVANCE(143);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 361:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'i')
        ADVANCE(362);
      if (lookahead == 's')
        ADVANCE(365);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 362:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'o')
        ADVANCE(363);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 363:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'n')
        ADVANCE(364);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 364:
      ACCEPT_TOKEN(anon_sym_union);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 365:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'i')
        ADVANCE(366);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 366:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'g')
        ADVANCE(367);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 367:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'n')
        ADVANCE(368);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 368:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'e')
        ADVANCE(369);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 369:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'd')
        ADVANCE(370);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 370:
      ACCEPT_TOKEN(anon_sym_unsigned);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 371:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'i')
        ADVANCE(372);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 372:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'n')
        ADVANCE(373);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 373:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'g')
        ADVANCE(374);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 374:
      ACCEPT_TOKEN(anon_sym_using);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 375:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'o')
        ADVANCE(376);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 376:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'i')
        ADVANCE(377);
      if (lookahead == 'l')
        ADVANCE(378);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 377:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'd')
        ADVANCE(126);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 378:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'a')
        ADVANCE(379);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 379:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 't')
        ADVANCE(380);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 380:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'i')
        ADVANCE(381);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 381:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'l')
        ADVANCE(382);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 382:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'e')
        ADVANCE(383);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 383:
      ACCEPT_TOKEN(anon_sym_volatile);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 384:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'h')
        ADVANCE(385);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 385:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'i')
        ADVANCE(386);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 386:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'l')
        ADVANCE(387);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 387:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'e')
        ADVANCE(388);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 388:
      ACCEPT_TOKEN(anon_sym_while);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 389:
      ACCEPT_TOKEN(anon_sym_LBRACE);
      END_STATE();
    case 390:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == '=')
        ADVANCE(391);
      if (lookahead == '|')
        ADVANCE(392);
      END_STATE();
    case 391:
      ACCEPT_TOKEN(anon_sym_PIPE_EQ);
      END_STATE();
    case 392:
      ACCEPT_TOKEN(anon_sym_PIPE_PIPE);
      END_STATE();
    case 393:
      ACCEPT_TOKEN(anon_sym_RBRACE);
      END_STATE();
    case 394:
      ACCEPT_TOKEN(anon_sym_TILDE);
      END_STATE();
    case 395:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '#')
        ADVANCE(396);
      if (lookahead == '&')
        ADVANCE(397);
      if (lookahead == '(')
        ADVANCE(50);
      if (lookahead == '*')
        ADVANCE(398);
      if (lookahead == ',')
        ADVANCE(57);
      if (lookahead == '/')
        ADVANCE(399);
      if (lookahead == ':')
        ADVANCE(400);
      if (lookahead == ';')
        ADVANCE(82);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '_')
        ADVANCE(112);
      if (lookahead == 'a')
        ADVANCE(119);
      if (lookahead == 'b')
        ADVANCE(401);
      if (lookahead == 'c')
        ADVANCE(402);
      if (lookahead == 'd')
        ADVANCE(405);
      if (lookahead == 'e')
        ADVANCE(407);
      if (lookahead == 'f')
        ADVANCE(408);
      if (lookahead == 'i')
        ADVANCE(409);
      if (lookahead == 'l')
        ADVANCE(219);
      if (lookahead == 'm')
        ADVANCE(223);
      if (lookahead == 'n')
        ADVANCE(410);
      if (lookahead == 'o')
        ADVANCE(254);
      if (lookahead == 'r')
        ADVANCE(411);
      if (lookahead == 's')
        ADVANCE(413);
      if (lookahead == 't')
        ADVANCE(414);
      if (lookahead == 'u')
        ADVANCE(357);
      if (lookahead == 'v')
        ADVANCE(375);
      if (lookahead == '{')
        ADVANCE(389);
      if (lookahead == '}')
        ADVANCE(393);
      if (lookahead == '~')
        ADVANCE(394);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(395);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('g' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 396:
      if (lookahead == 'd')
        ADVANCE(8);
      if (lookahead == 'i')
        ADVANCE(25);
      if (lookahead == '\t' ||
          lookahead == ' ')
        ADVANCE(396);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(14);
      END_STATE();
    case 397:
      ACCEPT_TOKEN(anon_sym_AMP);
      if (lookahead == '&')
        ADVANCE(43);
      END_STATE();
    case 398:
      ACCEPT_TOKEN(anon_sym_STAR);
      END_STATE();
    case 399:
      if (lookahead == '*')
        ADVANCE(66);
      if (lookahead == '/')
        ADVANCE(69);
      END_STATE();
    case 400:
      if (lookahead == ':')
        ADVANCE(81);
      END_STATE();
    case 401:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'o')
        ADVANCE(124);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 402:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'h')
        ADVANCE(135);
      if (lookahead == 'l')
        ADVANCE(145);
      if (lookahead == 'o')
        ADVANCE(403);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 403:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'n')
        ADVANCE(404);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 404:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 's')
        ADVANCE(151);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 405:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'o')
        ADVANCE(406);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 406:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'u')
        ADVANCE(174);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 407:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'n')
        ADVANCE(181);
      if (lookahead == 'x')
        ADVANCE(184);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 408:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'l')
        ADVANCE(199);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 409:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'n')
        ADVANCE(214);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 410:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'a')
        ADVANCE(231);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 411:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'e')
        ADVANCE(412);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 412:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'g')
        ADVANCE(294);
      if (lookahead == 's')
        ADVANCE(300);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 413:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'h')
        ADVANCE(311);
      if (lookahead == 'i')
        ADVANCE(321);
      if (lookahead == 's')
        ADVANCE(320);
      if (lookahead == 't')
        ADVANCE(323);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 414:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'e')
        ADVANCE(338);
      if (lookahead == 'y')
        ADVANCE(347);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 415:
      if (lookahead == '\"')
        ADVANCE(4);
      if (lookahead == '/')
        ADVANCE(399);
      if (lookahead == '<')
        ADVANCE(416);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(415);
      END_STATE();
    case 416:
      if (lookahead == '>')
        ADVANCE(417);
      if (lookahead == '\\')
        ADVANCE(418);
      if (lookahead != 0 &&
          lookahead != '\n')
        ADVANCE(416);
      END_STATE();
    case 417:
      ACCEPT_TOKEN(sym_system_lib_string);
      END_STATE();
    case 418:
      if (lookahead == '>')
        ADVANCE(419);
      if (lookahead == '\\')
        ADVANCE(418);
      if (lookahead != 0 &&
          lookahead != '\n')
        ADVANCE(416);
      END_STATE();
    case 419:
      ACCEPT_TOKEN(sym_system_lib_string);
      if (lookahead == '>')
        ADVANCE(417);
      if (lookahead == '\\')
        ADVANCE(418);
      if (lookahead != 0 &&
          lookahead != '\n')
        ADVANCE(416);
      END_STATE();
    case 420:
      if (lookahead == '&')
        ADVANCE(397);
      if (lookahead == '(')
        ADVANCE(50);
      if (lookahead == ')')
        ADVANCE(51);
      if (lookahead == '*')
        ADVANCE(398);
      if (lookahead == ',')
        ADVANCE(57);
      if (lookahead == '.')
        ADVANCE(62);
      if (lookahead == '/')
        ADVANCE(399);
      if (lookahead == ':')
        ADVANCE(80);
      if (lookahead == ';')
        ADVANCE(82);
      if (lookahead == '<')
        ADVANCE(421);
      if (lookahead == '=')
        ADVANCE(422);
      if (lookahead == '>')
        ADVANCE(423);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == ']')
        ADVANCE(109);
      if (lookahead == '{')
        ADVANCE(389);
      if (lookahead == '}')
        ADVANCE(393);
      if (lookahead == '~')
        ADVANCE(394);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(420);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 421:
      ACCEPT_TOKEN(anon_sym_LT);
      END_STATE();
    case 422:
      ACCEPT_TOKEN(anon_sym_EQ);
      END_STATE();
    case 423:
      ACCEPT_TOKEN(anon_sym_GT);
      END_STATE();
    case 424:
      if (lookahead == '#')
        ADVANCE(425);
      if (lookahead == '&')
        ADVANCE(397);
      if (lookahead == '(')
        ADVANCE(50);
      if (lookahead == '*')
        ADVANCE(398);
      if (lookahead == '/')
        ADVANCE(399);
      if (lookahead == ':')
        ADVANCE(400);
      if (lookahead == ';')
        ADVANCE(82);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == 'o')
        ADVANCE(254);
      if (lookahead == '~')
        ADVANCE(394);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(424);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 425:
      if (lookahead == 'e')
        ADVANCE(426);
      if (lookahead == '\t' ||
          lookahead == ' ')
        ADVANCE(425);
      END_STATE();
    case 426:
      if (lookahead == 'n')
        ADVANCE(427);
      END_STATE();
    case 427:
      if (lookahead == 'd')
        ADVANCE(428);
      END_STATE();
    case 428:
      if (lookahead == 'i')
        ADVANCE(429);
      END_STATE();
    case 429:
      if (lookahead == 'f')
        ADVANCE(430);
      END_STATE();
    case 430:
      ACCEPT_TOKEN(aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH);
      END_STATE();
    case 431:
      if (lookahead == '\n')
        SKIP(431);
      if (lookahead == '/')
        ADVANCE(432);
      if (lookahead == '\\')
        ADVANCE(437);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        ADVANCE(439);
      if (lookahead != 0)
        ADVANCE(438);
      END_STATE();
    case 432:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '*')
        ADVANCE(433);
      if (lookahead == '/')
        ADVANCE(436);
      if (lookahead == '\\')
        ADVANCE(437);
      if (lookahead != 0 &&
          lookahead != '\n')
        ADVANCE(438);
      END_STATE();
    case 433:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '\n')
        ADVANCE(66);
      if (lookahead == '*')
        ADVANCE(434);
      if (lookahead == '\\')
        ADVANCE(435);
      if (lookahead != 0)
        ADVANCE(433);
      END_STATE();
    case 434:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '\n')
        ADVANCE(66);
      if (lookahead == '*')
        ADVANCE(434);
      if (lookahead == '/')
        ADVANCE(68);
      if (lookahead == '\\')
        ADVANCE(435);
      if (lookahead != 0)
        ADVANCE(433);
      END_STATE();
    case 435:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '\n')
        ADVANCE(433);
      if (lookahead == '*')
        ADVANCE(434);
      if (lookahead == '\\')
        ADVANCE(435);
      if (lookahead != 0)
        ADVANCE(433);
      END_STATE();
    case 436:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead == '\\')
        ADVANCE(436);
      if (lookahead != 0 &&
          lookahead != '\n')
        ADVANCE(436);
      END_STATE();
    case 437:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '\n')
        ADVANCE(438);
      if (lookahead == '\\')
        ADVANCE(437);
      if (lookahead != 0)
        ADVANCE(438);
      END_STATE();
    case 438:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '\\')
        ADVANCE(437);
      if (lookahead != 0 &&
          lookahead != '\n')
        ADVANCE(438);
      END_STATE();
    case 439:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '/')
        ADVANCE(432);
      if (lookahead == '\\')
        ADVANCE(437);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        ADVANCE(439);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n')
        ADVANCE(438);
      END_STATE();
    case 440:
      if (lookahead == '\n')
        ADVANCE(441);
      if (lookahead == '\r')
        SKIP(440);
      if (lookahead == '(')
        ADVANCE(50);
      if (lookahead == '/')
        ADVANCE(399);
      if (lookahead == '\t' ||
          lookahead == ' ')
        ADVANCE(442);
      END_STATE();
    case 441:
      ACCEPT_TOKEN(anon_sym_LF);
      END_STATE();
    case 442:
      ACCEPT_TOKEN(aux_sym_SLASH_LBRACK_BSLASHt_RBRACK_PLUS_SLASH);
      if (lookahead == '\t' ||
          lookahead == ' ')
        ADVANCE(442);
      END_STATE();
    case 443:
      if (lookahead == '(')
        ADVANCE(50);
      if (lookahead == '/')
        ADVANCE(399);
      if (lookahead == ':')
        ADVANCE(400);
      if (lookahead == '>')
        ADVANCE(423);
      if (lookahead == '_')
        ADVANCE(112);
      if (lookahead == 'a')
        ADVANCE(119);
      if (lookahead == 'b')
        ADVANCE(401);
      if (lookahead == 'c')
        ADVANCE(402);
      if (lookahead == 'd')
        ADVANCE(405);
      if (lookahead == 'e')
        ADVANCE(444);
      if (lookahead == 'f')
        ADVANCE(408);
      if (lookahead == 'i')
        ADVANCE(446);
      if (lookahead == 'l')
        ADVANCE(219);
      if (lookahead == 'm')
        ADVANCE(223);
      if (lookahead == 'r')
        ADVANCE(448);
      if (lookahead == 's')
        ADVANCE(450);
      if (lookahead == 't')
        ADVANCE(452);
      if (lookahead == 'u')
        ADVANCE(456);
      if (lookahead == 'v')
        ADVANCE(375);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(443);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('g' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 444:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'n')
        ADVANCE(181);
      if (lookahead == 'x')
        ADVANCE(445);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 445:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'p')
        ADVANCE(185);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 446:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'n')
        ADVANCE(447);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 447:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 't')
        ADVANCE(137);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 448:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'e')
        ADVANCE(449);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 449:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 's')
        ADVANCE(300);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 450:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'h')
        ADVANCE(311);
      if (lookahead == 'i')
        ADVANCE(321);
      if (lookahead == 's')
        ADVANCE(320);
      if (lookahead == 't')
        ADVANCE(451);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 451:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'r')
        ADVANCE(328);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 452:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'y')
        ADVANCE(453);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 453:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'p')
        ADVANCE(454);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 454:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'e')
        ADVANCE(455);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 455:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'n')
        ADVANCE(353);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 456:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'i')
        ADVANCE(358);
      if (lookahead == 'n')
        ADVANCE(361);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 457:
      if (lookahead == '\"')
        ADVANCE(4);
      if (lookahead == '&')
        ADVANCE(397);
      if (lookahead == '(')
        ADVANCE(50);
      if (lookahead == ')')
        ADVANCE(51);
      if (lookahead == '*')
        ADVANCE(398);
      if (lookahead == '.')
        ADVANCE(458);
      if (lookahead == '/')
        ADVANCE(399);
      if (lookahead == ':')
        ADVANCE(400);
      if (lookahead == '<')
        ADVANCE(421);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '_')
        ADVANCE(112);
      if (lookahead == 'a')
        ADVANCE(119);
      if (lookahead == 'b')
        ADVANCE(401);
      if (lookahead == 'c')
        ADVANCE(402);
      if (lookahead == 'd')
        ADVANCE(405);
      if (lookahead == 'e')
        ADVANCE(407);
      if (lookahead == 'f')
        ADVANCE(408);
      if (lookahead == 'i')
        ADVANCE(409);
      if (lookahead == 'l')
        ADVANCE(219);
      if (lookahead == 'm')
        ADVANCE(223);
      if (lookahead == 'o')
        ADVANCE(254);
      if (lookahead == 'r')
        ADVANCE(411);
      if (lookahead == 's')
        ADVANCE(413);
      if (lookahead == 't')
        ADVANCE(452);
      if (lookahead == 'u')
        ADVANCE(456);
      if (lookahead == 'v')
        ADVANCE(375);
      if (lookahead == '~')
        ADVANCE(394);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(457);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('g' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 458:
      if (lookahead == '.')
        ADVANCE(63);
      END_STATE();
    case 459:
      if (lookahead == '&')
        ADVANCE(397);
      if (lookahead == '(')
        ADVANCE(50);
      if (lookahead == ')')
        ADVANCE(51);
      if (lookahead == '*')
        ADVANCE(398);
      if (lookahead == ',')
        ADVANCE(57);
      if (lookahead == '/')
        ADVANCE(399);
      if (lookahead == ':')
        ADVANCE(80);
      if (lookahead == ';')
        ADVANCE(82);
      if (lookahead == '<')
        ADVANCE(421);
      if (lookahead == '=')
        ADVANCE(422);
      if (lookahead == '>')
        ADVANCE(423);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '_')
        ADVANCE(112);
      if (lookahead == 'c')
        ADVANCE(460);
      if (lookahead == 'e')
        ADVANCE(461);
      if (lookahead == 'i')
        ADVANCE(462);
      if (lookahead == 'm')
        ADVANCE(223);
      if (lookahead == 'o')
        ADVANCE(254);
      if (lookahead == 'r')
        ADVANCE(411);
      if (lookahead == 's')
        ADVANCE(464);
      if (lookahead == 'v')
        ADVANCE(466);
      if (lookahead == '{')
        ADVANCE(389);
      if (lookahead == '~')
        ADVANCE(394);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(459);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 460:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'o')
        ADVANCE(403);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 461:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'x')
        ADVANCE(184);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 462:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'n')
        ADVANCE(463);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 463:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'l')
        ADVANCE(215);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 464:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 't')
        ADVANCE(465);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 465:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'a')
        ADVANCE(324);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 466:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'o')
        ADVANCE(467);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 467:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'l')
        ADVANCE(378);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 468:
      if (lookahead == '/')
        ADVANCE(399);
      if (lookahead == ':')
        ADVANCE(400);
      if (lookahead == 'a')
        ADVANCE(119);
      if (lookahead == 'b')
        ADVANCE(401);
      if (lookahead == 'c')
        ADVANCE(469);
      if (lookahead == 'd')
        ADVANCE(405);
      if (lookahead == 'e')
        ADVANCE(470);
      if (lookahead == 'f')
        ADVANCE(408);
      if (lookahead == 'i')
        ADVANCE(446);
      if (lookahead == 'l')
        ADVANCE(219);
      if (lookahead == 's')
        ADVANCE(450);
      if (lookahead == 't')
        ADVANCE(452);
      if (lookahead == 'u')
        ADVANCE(456);
      if (lookahead == 'v')
        ADVANCE(471);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(468);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('g' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 469:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'h')
        ADVANCE(135);
      if (lookahead == 'l')
        ADVANCE(145);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 470:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'n')
        ADVANCE(181);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 471:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'o')
        ADVANCE(472);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 472:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'i')
        ADVANCE(377);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 473:
      if (lookahead == '!')
        ADVANCE(474);
      if (lookahead == '%')
        ADVANCE(40);
      if (lookahead == '&')
        ADVANCE(42);
      if (lookahead == '(')
        ADVANCE(50);
      if (lookahead == ')')
        ADVANCE(51);
      if (lookahead == '*')
        ADVANCE(52);
      if (lookahead == '+')
        ADVANCE(54);
      if (lookahead == ',')
        ADVANCE(57);
      if (lookahead == '-')
        ADVANCE(58);
      if (lookahead == '.')
        ADVANCE(475);
      if (lookahead == '/')
        ADVANCE(65);
      if (lookahead == ':')
        ADVANCE(80);
      if (lookahead == ';')
        ADVANCE(82);
      if (lookahead == '<')
        ADVANCE(83);
      if (lookahead == '=')
        ADVANCE(87);
      if (lookahead == '>')
        ADVANCE(89);
      if (lookahead == '?')
        ADVANCE(93);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == ']')
        ADVANCE(109);
      if (lookahead == '^')
        ADVANCE(110);
      if (lookahead == 'n')
        ADVANCE(410);
      if (lookahead == '{')
        ADVANCE(389);
      if (lookahead == '|')
        ADVANCE(390);
      if (lookahead == '}')
        ADVANCE(393);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(473);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 474:
      if (lookahead == '=')
        ADVANCE(3);
      END_STATE();
    case 475:
      ACCEPT_TOKEN(anon_sym_DOT);
      END_STATE();
    case 476:
      if (lookahead == '&')
        ADVANCE(397);
      if (lookahead == '(')
        ADVANCE(50);
      if (lookahead == ')')
        ADVANCE(51);
      if (lookahead == '*')
        ADVANCE(398);
      if (lookahead == ',')
        ADVANCE(57);
      if (lookahead == '/')
        ADVANCE(399);
      if (lookahead == ':')
        ADVANCE(477);
      if (lookahead == ';')
        ADVANCE(82);
      if (lookahead == '<')
        ADVANCE(421);
      if (lookahead == '=')
        ADVANCE(422);
      if (lookahead == '>')
        ADVANCE(423);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == 'b')
        ADVANCE(401);
      if (lookahead == 'c')
        ADVANCE(478);
      if (lookahead == 'd')
        ADVANCE(405);
      if (lookahead == 'f')
        ADVANCE(408);
      if (lookahead == 'i')
        ADVANCE(446);
      if (lookahead == 'l')
        ADVANCE(219);
      if (lookahead == 's')
        ADVANCE(479);
      if (lookahead == 'u')
        ADVANCE(480);
      if (lookahead == 'v')
        ADVANCE(471);
      if (lookahead == '{')
        ADVANCE(389);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(476);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 477:
      ACCEPT_TOKEN(anon_sym_COLON);
      END_STATE();
    case 478:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'h')
        ADVANCE(135);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 479:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'h')
        ADVANCE(311);
      if (lookahead == 'i')
        ADVANCE(321);
      if (lookahead == 's')
        ADVANCE(320);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 480:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'i')
        ADVANCE(358);
      if (lookahead == 'n')
        ADVANCE(481);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 481:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 's')
        ADVANCE(365);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 482:
      if (lookahead == '&')
        ADVANCE(397);
      if (lookahead == '(')
        ADVANCE(50);
      if (lookahead == ')')
        ADVANCE(51);
      if (lookahead == '*')
        ADVANCE(398);
      if (lookahead == ',')
        ADVANCE(57);
      if (lookahead == '/')
        ADVANCE(399);
      if (lookahead == ':')
        ADVANCE(80);
      if (lookahead == ';')
        ADVANCE(82);
      if (lookahead == '>')
        ADVANCE(423);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '_')
        ADVANCE(112);
      if (lookahead == 'b')
        ADVANCE(401);
      if (lookahead == 'c')
        ADVANCE(483);
      if (lookahead == 'd')
        ADVANCE(405);
      if (lookahead == 'e')
        ADVANCE(461);
      if (lookahead == 'f')
        ADVANCE(408);
      if (lookahead == 'i')
        ADVANCE(409);
      if (lookahead == 'l')
        ADVANCE(219);
      if (lookahead == 'm')
        ADVANCE(223);
      if (lookahead == 'o')
        ADVANCE(254);
      if (lookahead == 'r')
        ADVANCE(411);
      if (lookahead == 's')
        ADVANCE(484);
      if (lookahead == 'u')
        ADVANCE(480);
      if (lookahead == 'v')
        ADVANCE(375);
      if (lookahead == '~')
        ADVANCE(394);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(482);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 483:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'h')
        ADVANCE(135);
      if (lookahead == 'o')
        ADVANCE(403);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 484:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'h')
        ADVANCE(311);
      if (lookahead == 'i')
        ADVANCE(321);
      if (lookahead == 's')
        ADVANCE(320);
      if (lookahead == 't')
        ADVANCE(465);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 485:
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '&')
        ADVANCE(397);
      if (lookahead == '(')
        ADVANCE(50);
      if (lookahead == '*')
        ADVANCE(398);
      if (lookahead == ',')
        ADVANCE(57);
      if (lookahead == '/')
        ADVANCE(399);
      if (lookahead == ':')
        ADVANCE(400);
      if (lookahead == ';')
        ADVANCE(82);
      if (lookahead == '_')
        ADVANCE(112);
      if (lookahead == 'a')
        ADVANCE(119);
      if (lookahead == 'b')
        ADVANCE(401);
      if (lookahead == 'c')
        ADVANCE(402);
      if (lookahead == 'd')
        ADVANCE(405);
      if (lookahead == 'e')
        ADVANCE(407);
      if (lookahead == 'f')
        ADVANCE(408);
      if (lookahead == 'i')
        ADVANCE(409);
      if (lookahead == 'l')
        ADVANCE(219);
      if (lookahead == 'm')
        ADVANCE(223);
      if (lookahead == 'n')
        ADVANCE(410);
      if (lookahead == 'o')
        ADVANCE(254);
      if (lookahead == 'r')
        ADVANCE(411);
      if (lookahead == 's')
        ADVANCE(413);
      if (lookahead == 't')
        ADVANCE(414);
      if (lookahead == 'u')
        ADVANCE(357);
      if (lookahead == 'v')
        ADVANCE(375);
      if (lookahead == '~')
        ADVANCE(394);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(485);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('g' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 486:
      if (lookahead == '&')
        ADVANCE(397);
      if (lookahead == '(')
        ADVANCE(50);
      if (lookahead == ')')
        ADVANCE(51);
      if (lookahead == '*')
        ADVANCE(398);
      if (lookahead == '.')
        ADVANCE(458);
      if (lookahead == '/')
        ADVANCE(399);
      if (lookahead == ':')
        ADVANCE(400);
      if (lookahead == '>')
        ADVANCE(423);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '_')
        ADVANCE(112);
      if (lookahead == 'a')
        ADVANCE(119);
      if (lookahead == 'b')
        ADVANCE(401);
      if (lookahead == 'c')
        ADVANCE(402);
      if (lookahead == 'd')
        ADVANCE(405);
      if (lookahead == 'e')
        ADVANCE(407);
      if (lookahead == 'f')
        ADVANCE(408);
      if (lookahead == 'i')
        ADVANCE(409);
      if (lookahead == 'l')
        ADVANCE(219);
      if (lookahead == 'm')
        ADVANCE(223);
      if (lookahead == 'r')
        ADVANCE(411);
      if (lookahead == 's')
        ADVANCE(413);
      if (lookahead == 't')
        ADVANCE(452);
      if (lookahead == 'u')
        ADVANCE(456);
      if (lookahead == 'v')
        ADVANCE(375);
      if (lookahead == '{')
        ADVANCE(389);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(486);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('g' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 487:
      if (lookahead == '#')
        ADVANCE(488);
      if (lookahead == '&')
        ADVANCE(397);
      if (lookahead == '(')
        ADVANCE(50);
      if (lookahead == '*')
        ADVANCE(398);
      if (lookahead == '/')
        ADVANCE(399);
      if (lookahead == ':')
        ADVANCE(400);
      if (lookahead == '_')
        ADVANCE(112);
      if (lookahead == 'a')
        ADVANCE(119);
      if (lookahead == 'b')
        ADVANCE(401);
      if (lookahead == 'c')
        ADVANCE(402);
      if (lookahead == 'd')
        ADVANCE(405);
      if (lookahead == 'e')
        ADVANCE(407);
      if (lookahead == 'f')
        ADVANCE(498);
      if (lookahead == 'i')
        ADVANCE(409);
      if (lookahead == 'l')
        ADVANCE(219);
      if (lookahead == 'm')
        ADVANCE(223);
      if (lookahead == 'o')
        ADVANCE(254);
      if (lookahead == 'p')
        ADVANCE(273);
      if (lookahead == 'r')
        ADVANCE(411);
      if (lookahead == 's')
        ADVANCE(413);
      if (lookahead == 't')
        ADVANCE(414);
      if (lookahead == 'u')
        ADVANCE(357);
      if (lookahead == 'v')
        ADVANCE(375);
      if (lookahead == '}')
        ADVANCE(393);
      if (lookahead == '~')
        ADVANCE(394);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(487);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('g' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 488:
      if (lookahead == 'i')
        ADVANCE(489);
      if (lookahead == '\t' ||
          lookahead == ' ')
        ADVANCE(488);
      END_STATE();
    case 489:
      if (lookahead == 'f')
        ADVANCE(490);
      END_STATE();
    case 490:
      ACCEPT_TOKEN(aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH);
      if (lookahead == 'd')
        ADVANCE(491);
      if (lookahead == 'n')
        ADVANCE(494);
      END_STATE();
    case 491:
      if (lookahead == 'e')
        ADVANCE(492);
      END_STATE();
    case 492:
      if (lookahead == 'f')
        ADVANCE(493);
      END_STATE();
    case 493:
      ACCEPT_TOKEN(aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH);
      END_STATE();
    case 494:
      if (lookahead == 'd')
        ADVANCE(495);
      END_STATE();
    case 495:
      if (lookahead == 'e')
        ADVANCE(496);
      END_STATE();
    case 496:
      if (lookahead == 'f')
        ADVANCE(497);
      END_STATE();
    case 497:
      ACCEPT_TOKEN(aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH);
      END_STATE();
    case 498:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'l')
        ADVANCE(199);
      if (lookahead == 'r')
        ADVANCE(203);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 499:
      if (lookahead == '/')
        ADVANCE(399);
      if (lookahead == ':')
        ADVANCE(400);
      if (lookahead == 'p')
        ADVANCE(500);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(499);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 500:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'u')
        ADVANCE(287);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 501:
      if (lookahead == '!')
        ADVANCE(474);
      if (lookahead == '%')
        ADVANCE(40);
      if (lookahead == '&')
        ADVANCE(42);
      if (lookahead == '(')
        ADVANCE(50);
      if (lookahead == ')')
        ADVANCE(51);
      if (lookahead == '*')
        ADVANCE(52);
      if (lookahead == '+')
        ADVANCE(54);
      if (lookahead == ',')
        ADVANCE(57);
      if (lookahead == '-')
        ADVANCE(58);
      if (lookahead == '.')
        ADVANCE(475);
      if (lookahead == '/')
        ADVANCE(65);
      if (lookahead == ':')
        ADVANCE(477);
      if (lookahead == ';')
        ADVANCE(82);
      if (lookahead == '<')
        ADVANCE(83);
      if (lookahead == '=')
        ADVANCE(87);
      if (lookahead == '>')
        ADVANCE(89);
      if (lookahead == '?')
        ADVANCE(93);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == ']')
        ADVANCE(109);
      if (lookahead == '^')
        ADVANCE(110);
      if (lookahead == '_')
        ADVANCE(502);
      if (lookahead == 'c')
        ADVANCE(509);
      if (lookahead == 'e')
        ADVANCE(518);
      if (lookahead == 'm')
        ADVANCE(529);
      if (lookahead == 'n')
        ADVANCE(536);
      if (lookahead == 'r')
        ADVANCE(544);
      if (lookahead == 'v')
        ADVANCE(552);
      if (lookahead == 'w')
        ADVANCE(560);
      if (lookahead == '{')
        ADVANCE(389);
      if (lookahead == '|')
        ADVANCE(390);
      if (lookahead == '}')
        ADVANCE(393);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(501);
      END_STATE();
    case 502:
      if (lookahead == 'A')
        ADVANCE(503);
      END_STATE();
    case 503:
      if (lookahead == 't')
        ADVANCE(504);
      END_STATE();
    case 504:
      if (lookahead == 'o')
        ADVANCE(505);
      END_STATE();
    case 505:
      if (lookahead == 'm')
        ADVANCE(506);
      END_STATE();
    case 506:
      if (lookahead == 'i')
        ADVANCE(507);
      END_STATE();
    case 507:
      if (lookahead == 'c')
        ADVANCE(508);
      END_STATE();
    case 508:
      ACCEPT_TOKEN(anon_sym__Atomic);
      END_STATE();
    case 509:
      if (lookahead == 'o')
        ADVANCE(510);
      END_STATE();
    case 510:
      if (lookahead == 'n')
        ADVANCE(511);
      END_STATE();
    case 511:
      if (lookahead == 's')
        ADVANCE(512);
      END_STATE();
    case 512:
      if (lookahead == 't')
        ADVANCE(513);
      END_STATE();
    case 513:
      ACCEPT_TOKEN(anon_sym_const);
      if (lookahead == 'e')
        ADVANCE(514);
      END_STATE();
    case 514:
      if (lookahead == 'x')
        ADVANCE(515);
      END_STATE();
    case 515:
      if (lookahead == 'p')
        ADVANCE(516);
      END_STATE();
    case 516:
      if (lookahead == 'r')
        ADVANCE(517);
      END_STATE();
    case 517:
      ACCEPT_TOKEN(anon_sym_constexpr);
      END_STATE();
    case 518:
      if (lookahead == 'l')
        ADVANCE(519);
      if (lookahead == 'x')
        ADVANCE(522);
      END_STATE();
    case 519:
      if (lookahead == 's')
        ADVANCE(520);
      END_STATE();
    case 520:
      if (lookahead == 'e')
        ADVANCE(521);
      END_STATE();
    case 521:
      ACCEPT_TOKEN(anon_sym_else);
      END_STATE();
    case 522:
      if (lookahead == 'p')
        ADVANCE(523);
      END_STATE();
    case 523:
      if (lookahead == 'l')
        ADVANCE(524);
      END_STATE();
    case 524:
      if (lookahead == 'i')
        ADVANCE(525);
      END_STATE();
    case 525:
      if (lookahead == 'c')
        ADVANCE(526);
      END_STATE();
    case 526:
      if (lookahead == 'i')
        ADVANCE(527);
      END_STATE();
    case 527:
      if (lookahead == 't')
        ADVANCE(528);
      END_STATE();
    case 528:
      ACCEPT_TOKEN(anon_sym_explicit);
      END_STATE();
    case 529:
      if (lookahead == 'u')
        ADVANCE(530);
      END_STATE();
    case 530:
      if (lookahead == 't')
        ADVANCE(531);
      END_STATE();
    case 531:
      if (lookahead == 'a')
        ADVANCE(532);
      END_STATE();
    case 532:
      if (lookahead == 'b')
        ADVANCE(533);
      END_STATE();
    case 533:
      if (lookahead == 'l')
        ADVANCE(534);
      END_STATE();
    case 534:
      if (lookahead == 'e')
        ADVANCE(535);
      END_STATE();
    case 535:
      ACCEPT_TOKEN(anon_sym_mutable);
      END_STATE();
    case 536:
      if (lookahead == 'o')
        ADVANCE(537);
      END_STATE();
    case 537:
      if (lookahead == 'e')
        ADVANCE(538);
      END_STATE();
    case 538:
      if (lookahead == 'x')
        ADVANCE(539);
      END_STATE();
    case 539:
      if (lookahead == 'c')
        ADVANCE(540);
      END_STATE();
    case 540:
      if (lookahead == 'e')
        ADVANCE(541);
      END_STATE();
    case 541:
      if (lookahead == 'p')
        ADVANCE(542);
      END_STATE();
    case 542:
      if (lookahead == 't')
        ADVANCE(543);
      END_STATE();
    case 543:
      ACCEPT_TOKEN(sym_noexcept);
      END_STATE();
    case 544:
      if (lookahead == 'e')
        ADVANCE(545);
      END_STATE();
    case 545:
      if (lookahead == 's')
        ADVANCE(546);
      END_STATE();
    case 546:
      if (lookahead == 't')
        ADVANCE(547);
      END_STATE();
    case 547:
      if (lookahead == 'r')
        ADVANCE(548);
      END_STATE();
    case 548:
      if (lookahead == 'i')
        ADVANCE(549);
      END_STATE();
    case 549:
      if (lookahead == 'c')
        ADVANCE(550);
      END_STATE();
    case 550:
      if (lookahead == 't')
        ADVANCE(551);
      END_STATE();
    case 551:
      ACCEPT_TOKEN(anon_sym_restrict);
      END_STATE();
    case 552:
      if (lookahead == 'o')
        ADVANCE(553);
      END_STATE();
    case 553:
      if (lookahead == 'l')
        ADVANCE(554);
      END_STATE();
    case 554:
      if (lookahead == 'a')
        ADVANCE(555);
      END_STATE();
    case 555:
      if (lookahead == 't')
        ADVANCE(556);
      END_STATE();
    case 556:
      if (lookahead == 'i')
        ADVANCE(557);
      END_STATE();
    case 557:
      if (lookahead == 'l')
        ADVANCE(558);
      END_STATE();
    case 558:
      if (lookahead == 'e')
        ADVANCE(559);
      END_STATE();
    case 559:
      ACCEPT_TOKEN(anon_sym_volatile);
      END_STATE();
    case 560:
      if (lookahead == 'h')
        ADVANCE(561);
      END_STATE();
    case 561:
      if (lookahead == 'i')
        ADVANCE(562);
      END_STATE();
    case 562:
      if (lookahead == 'l')
        ADVANCE(563);
      END_STATE();
    case 563:
      if (lookahead == 'e')
        ADVANCE(564);
      END_STATE();
    case 564:
      ACCEPT_TOKEN(anon_sym_while);
      END_STATE();
    case 565:
      if (lookahead == '!')
        ADVANCE(566);
      if (lookahead == '\"')
        ADVANCE(4);
      if (lookahead == '&')
        ADVANCE(567);
      if (lookahead == '\'')
        ADVANCE(45);
      if (lookahead == '(')
        ADVANCE(50);
      if (lookahead == '*')
        ADVANCE(398);
      if (lookahead == '+')
        ADVANCE(568);
      if (lookahead == '-')
        ADVANCE(569);
      if (lookahead == '/')
        ADVANCE(399);
      if (lookahead == '0')
        ADVANCE(71);
      if (lookahead == ':')
        ADVANCE(400);
      if (lookahead == 'F')
        ADVANCE(94);
      if (lookahead == 'N')
        ADVANCE(100);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == ']')
        ADVANCE(109);
      if (lookahead == '_')
        ADVANCE(112);
      if (lookahead == 'a')
        ADVANCE(119);
      if (lookahead == 'b')
        ADVANCE(401);
      if (lookahead == 'c')
        ADVANCE(402);
      if (lookahead == 'd')
        ADVANCE(570);
      if (lookahead == 'e')
        ADVANCE(407);
      if (lookahead == 'f')
        ADVANCE(572);
      if (lookahead == 'i')
        ADVANCE(409);
      if (lookahead == 'l')
        ADVANCE(219);
      if (lookahead == 'm')
        ADVANCE(223);
      if (lookahead == 'n')
        ADVANCE(573);
      if (lookahead == 'r')
        ADVANCE(411);
      if (lookahead == 's')
        ADVANCE(574);
      if (lookahead == 't')
        ADVANCE(575);
      if (lookahead == 'u')
        ADVANCE(456);
      if (lookahead == 'v')
        ADVANCE(375);
      if (lookahead == '~')
        ADVANCE(394);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(565);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(79);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('g' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 566:
      ACCEPT_TOKEN(anon_sym_BANG);
      END_STATE();
    case 567:
      ACCEPT_TOKEN(anon_sym_AMP);
      END_STATE();
    case 568:
      ACCEPT_TOKEN(anon_sym_PLUS);
      if (lookahead == '+')
        ADVANCE(55);
      END_STATE();
    case 569:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '-')
        ADVANCE(59);
      END_STATE();
    case 570:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'e')
        ADVANCE(571);
      if (lookahead == 'o')
        ADVANCE(406);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 571:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'l')
        ADVANCE(169);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 572:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'a')
        ADVANCE(196);
      if (lookahead == 'l')
        ADVANCE(199);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 573:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'e')
        ADVANCE(239);
      if (lookahead == 'u')
        ADVANCE(248);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 574:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'h')
        ADVANCE(311);
      if (lookahead == 'i')
        ADVANCE(315);
      if (lookahead == 's')
        ADVANCE(320);
      if (lookahead == 't')
        ADVANCE(323);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 575:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'r')
        ADVANCE(345);
      if (lookahead == 'y')
        ADVANCE(453);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 576:
      if (lookahead == '!')
        ADVANCE(566);
      if (lookahead == '\"')
        ADVANCE(4);
      if (lookahead == '#')
        ADVANCE(396);
      if (lookahead == '&')
        ADVANCE(567);
      if (lookahead == '\'')
        ADVANCE(45);
      if (lookahead == '(')
        ADVANCE(50);
      if (lookahead == '*')
        ADVANCE(398);
      if (lookahead == '+')
        ADVANCE(568);
      if (lookahead == '-')
        ADVANCE(569);
      if (lookahead == '/')
        ADVANCE(399);
      if (lookahead == '0')
        ADVANCE(71);
      if (lookahead == ':')
        ADVANCE(400);
      if (lookahead == ';')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(94);
      if (lookahead == 'N')
        ADVANCE(100);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '_')
        ADVANCE(112);
      if (lookahead == 'a')
        ADVANCE(119);
      if (lookahead == 'b')
        ADVANCE(123);
      if (lookahead == 'c')
        ADVANCE(131);
      if (lookahead == 'd')
        ADVANCE(162);
      if (lookahead == 'e')
        ADVANCE(407);
      if (lookahead == 'f')
        ADVANCE(577);
      if (lookahead == 'g')
        ADVANCE(208);
      if (lookahead == 'i')
        ADVANCE(212);
      if (lookahead == 'l')
        ADVANCE(219);
      if (lookahead == 'm')
        ADVANCE(223);
      if (lookahead == 'n')
        ADVANCE(573);
      if (lookahead == 'r')
        ADVANCE(292);
      if (lookahead == 's')
        ADVANCE(310);
      if (lookahead == 't')
        ADVANCE(578);
      if (lookahead == 'u')
        ADVANCE(456);
      if (lookahead == 'v')
        ADVANCE(375);
      if (lookahead == 'w')
        ADVANCE(384);
      if (lookahead == '{')
        ADVANCE(389);
      if (lookahead == '}')
        ADVANCE(393);
      if (lookahead == '~')
        ADVANCE(394);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(576);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(79);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('h' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 577:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'a')
        ADVANCE(196);
      if (lookahead == 'l')
        ADVANCE(199);
      if (lookahead == 'o')
        ADVANCE(201);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 578:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'r')
        ADVANCE(345);
      if (lookahead == 'y')
        ADVANCE(347);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 579:
      if (lookahead == '\n')
        ADVANCE(441);
      if (lookahead == '/')
        ADVANCE(432);
      if (lookahead == '\\')
        ADVANCE(437);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        ADVANCE(580);
      if (lookahead != 0)
        ADVANCE(438);
      END_STATE();
    case 580:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '/')
        ADVANCE(432);
      if (lookahead == '\\')
        ADVANCE(437);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        ADVANCE(580);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n')
        ADVANCE(438);
      END_STATE();
    case 581:
      if (lookahead == '#')
        ADVANCE(582);
      if (lookahead == '&')
        ADVANCE(397);
      if (lookahead == '(')
        ADVANCE(50);
      if (lookahead == '*')
        ADVANCE(398);
      if (lookahead == ',')
        ADVANCE(57);
      if (lookahead == '/')
        ADVANCE(399);
      if (lookahead == ':')
        ADVANCE(400);
      if (lookahead == ';')
        ADVANCE(82);
      if (lookahead == '_')
        ADVANCE(112);
      if (lookahead == 'a')
        ADVANCE(119);
      if (lookahead == 'b')
        ADVANCE(401);
      if (lookahead == 'c')
        ADVANCE(402);
      if (lookahead == 'd')
        ADVANCE(405);
      if (lookahead == 'e')
        ADVANCE(407);
      if (lookahead == 'f')
        ADVANCE(408);
      if (lookahead == 'i')
        ADVANCE(409);
      if (lookahead == 'l')
        ADVANCE(219);
      if (lookahead == 'm')
        ADVANCE(223);
      if (lookahead == 'n')
        ADVANCE(410);
      if (lookahead == 'o')
        ADVANCE(254);
      if (lookahead == 'r')
        ADVANCE(411);
      if (lookahead == 's')
        ADVANCE(413);
      if (lookahead == 't')
        ADVANCE(414);
      if (lookahead == 'u')
        ADVANCE(357);
      if (lookahead == 'v')
        ADVANCE(375);
      if (lookahead == '~')
        ADVANCE(394);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(581);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('g' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 582:
      if (lookahead == 'd')
        ADVANCE(8);
      if (lookahead == 'e')
        ADVANCE(583);
      if (lookahead == 'i')
        ADVANCE(25);
      if (lookahead == '\t' ||
          lookahead == ' ')
        ADVANCE(582);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(14);
      END_STATE();
    case 583:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'n')
        ADVANCE(21);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(14);
      END_STATE();
    case 584:
      if (lookahead == '\n')
        ADVANCE(441);
      if (lookahead == '/')
        ADVANCE(399);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(584);
      END_STATE();
    case 585:
      if (lookahead == '(')
        ADVANCE(50);
      if (lookahead == '*')
        ADVANCE(398);
      if (lookahead == '/')
        ADVANCE(399);
      if (lookahead == ':')
        ADVANCE(477);
      if (lookahead == '<')
        ADVANCE(421);
      if (lookahead == '{')
        ADVANCE(389);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(585);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 586:
      if (lookahead == '#')
        ADVANCE(587);
      if (lookahead == '&')
        ADVANCE(397);
      if (lookahead == '(')
        ADVANCE(50);
      if (lookahead == '*')
        ADVANCE(398);
      if (lookahead == ',')
        ADVANCE(57);
      if (lookahead == '/')
        ADVANCE(399);
      if (lookahead == ':')
        ADVANCE(400);
      if (lookahead == ';')
        ADVANCE(82);
      if (lookahead == '_')
        ADVANCE(112);
      if (lookahead == 'a')
        ADVANCE(119);
      if (lookahead == 'b')
        ADVANCE(401);
      if (lookahead == 'c')
        ADVANCE(402);
      if (lookahead == 'd')
        ADVANCE(405);
      if (lookahead == 'e')
        ADVANCE(407);
      if (lookahead == 'f')
        ADVANCE(498);
      if (lookahead == 'i')
        ADVANCE(409);
      if (lookahead == 'l')
        ADVANCE(219);
      if (lookahead == 'm')
        ADVANCE(223);
      if (lookahead == 'o')
        ADVANCE(254);
      if (lookahead == 'p')
        ADVANCE(273);
      if (lookahead == 'r')
        ADVANCE(411);
      if (lookahead == 's')
        ADVANCE(413);
      if (lookahead == 't')
        ADVANCE(414);
      if (lookahead == 'u')
        ADVANCE(357);
      if (lookahead == 'v')
        ADVANCE(375);
      if (lookahead == '}')
        ADVANCE(393);
      if (lookahead == '~')
        ADVANCE(394);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(586);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('g' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 587:
      if (lookahead == 'e')
        ADVANCE(588);
      if (lookahead == 'i')
        ADVANCE(489);
      if (lookahead == '\t' ||
          lookahead == ' ')
        ADVANCE(587);
      END_STATE();
    case 588:
      if (lookahead == 'l')
        ADVANCE(589);
      if (lookahead == 'n')
        ADVANCE(427);
      END_STATE();
    case 589:
      if (lookahead == 'i')
        ADVANCE(590);
      if (lookahead == 's')
        ADVANCE(592);
      END_STATE();
    case 590:
      if (lookahead == 'f')
        ADVANCE(591);
      END_STATE();
    case 591:
      ACCEPT_TOKEN(aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH);
      END_STATE();
    case 592:
      if (lookahead == 'e')
        ADVANCE(593);
      END_STATE();
    case 593:
      ACCEPT_TOKEN(aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH);
      END_STATE();
    case 594:
      if (lookahead == '&')
        ADVANCE(397);
      if (lookahead == '(')
        ADVANCE(50);
      if (lookahead == ')')
        ADVANCE(51);
      if (lookahead == '*')
        ADVANCE(398);
      if (lookahead == ',')
        ADVANCE(57);
      if (lookahead == '/')
        ADVANCE(399);
      if (lookahead == ':')
        ADVANCE(80);
      if (lookahead == ';')
        ADVANCE(82);
      if (lookahead == '>')
        ADVANCE(423);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == 'o')
        ADVANCE(254);
      if (lookahead == '~')
        ADVANCE(394);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(594);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 595:
      if (lookahead == '!')
        ADVANCE(566);
      if (lookahead == '\"')
        ADVANCE(4);
      if (lookahead == '&')
        ADVANCE(567);
      if (lookahead == '\'')
        ADVANCE(45);
      if (lookahead == '(')
        ADVANCE(50);
      if (lookahead == '*')
        ADVANCE(398);
      if (lookahead == '+')
        ADVANCE(568);
      if (lookahead == '-')
        ADVANCE(569);
      if (lookahead == '/')
        ADVANCE(399);
      if (lookahead == '0')
        ADVANCE(71);
      if (lookahead == ':')
        ADVANCE(400);
      if (lookahead == 'F')
        ADVANCE(94);
      if (lookahead == 'N')
        ADVANCE(100);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == 'd')
        ADVANCE(596);
      if (lookahead == 'f')
        ADVANCE(597);
      if (lookahead == 'n')
        ADVANCE(573);
      if (lookahead == 's')
        ADVANCE(598);
      if (lookahead == 't')
        ADVANCE(602);
      if (lookahead == '~')
        ADVANCE(394);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(595);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(79);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 596:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'e')
        ADVANCE(571);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 597:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'a')
        ADVANCE(196);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 598:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'i')
        ADVANCE(599);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 599:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'z')
        ADVANCE(600);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'y'))
        ADVANCE(99);
      END_STATE();
    case 600:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'e')
        ADVANCE(601);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 601:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'o')
        ADVANCE(318);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 602:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'r')
        ADVANCE(345);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 603:
      if (lookahead == '!')
        ADVANCE(566);
      if (lookahead == '\"')
        ADVANCE(4);
      if (lookahead == '&')
        ADVANCE(567);
      if (lookahead == '\'')
        ADVANCE(45);
      if (lookahead == '(')
        ADVANCE(50);
      if (lookahead == ')')
        ADVANCE(51);
      if (lookahead == '*')
        ADVANCE(398);
      if (lookahead == '+')
        ADVANCE(568);
      if (lookahead == '-')
        ADVANCE(569);
      if (lookahead == '.')
        ADVANCE(458);
      if (lookahead == '/')
        ADVANCE(399);
      if (lookahead == '0')
        ADVANCE(71);
      if (lookahead == ':')
        ADVANCE(400);
      if (lookahead == 'F')
        ADVANCE(94);
      if (lookahead == 'N')
        ADVANCE(100);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '_')
        ADVANCE(112);
      if (lookahead == 'a')
        ADVANCE(119);
      if (lookahead == 'b')
        ADVANCE(401);
      if (lookahead == 'c')
        ADVANCE(402);
      if (lookahead == 'd')
        ADVANCE(570);
      if (lookahead == 'e')
        ADVANCE(407);
      if (lookahead == 'f')
        ADVANCE(572);
      if (lookahead == 'i')
        ADVANCE(409);
      if (lookahead == 'l')
        ADVANCE(219);
      if (lookahead == 'm')
        ADVANCE(223);
      if (lookahead == 'n')
        ADVANCE(573);
      if (lookahead == 'r')
        ADVANCE(411);
      if (lookahead == 's')
        ADVANCE(574);
      if (lookahead == 't')
        ADVANCE(575);
      if (lookahead == 'u')
        ADVANCE(456);
      if (lookahead == 'v')
        ADVANCE(375);
      if (lookahead == '{')
        ADVANCE(389);
      if (lookahead == '~')
        ADVANCE(394);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(603);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(79);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('g' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 604:
      if (lookahead == '!')
        ADVANCE(566);
      if (lookahead == '\"')
        ADVANCE(4);
      if (lookahead == '#')
        ADVANCE(396);
      if (lookahead == '&')
        ADVANCE(567);
      if (lookahead == '\'')
        ADVANCE(45);
      if (lookahead == '(')
        ADVANCE(50);
      if (lookahead == '*')
        ADVANCE(398);
      if (lookahead == '+')
        ADVANCE(568);
      if (lookahead == ',')
        ADVANCE(57);
      if (lookahead == '-')
        ADVANCE(569);
      if (lookahead == '.')
        ADVANCE(475);
      if (lookahead == '/')
        ADVANCE(399);
      if (lookahead == '0')
        ADVANCE(71);
      if (lookahead == ':')
        ADVANCE(400);
      if (lookahead == ';')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(94);
      if (lookahead == 'N')
        ADVANCE(100);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '_')
        ADVANCE(112);
      if (lookahead == 'a')
        ADVANCE(119);
      if (lookahead == 'b')
        ADVANCE(123);
      if (lookahead == 'c')
        ADVANCE(131);
      if (lookahead == 'd')
        ADVANCE(162);
      if (lookahead == 'e')
        ADVANCE(407);
      if (lookahead == 'f')
        ADVANCE(577);
      if (lookahead == 'g')
        ADVANCE(208);
      if (lookahead == 'i')
        ADVANCE(212);
      if (lookahead == 'l')
        ADVANCE(219);
      if (lookahead == 'm')
        ADVANCE(223);
      if (lookahead == 'n')
        ADVANCE(573);
      if (lookahead == 'r')
        ADVANCE(292);
      if (lookahead == 's')
        ADVANCE(310);
      if (lookahead == 't')
        ADVANCE(578);
      if (lookahead == 'u')
        ADVANCE(456);
      if (lookahead == 'v')
        ADVANCE(375);
      if (lookahead == 'w')
        ADVANCE(384);
      if (lookahead == '{')
        ADVANCE(389);
      if (lookahead == '}')
        ADVANCE(393);
      if (lookahead == '~')
        ADVANCE(394);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(604);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(79);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('h' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 605:
      if (lookahead == '!')
        ADVANCE(566);
      if (lookahead == '\"')
        ADVANCE(4);
      if (lookahead == '&')
        ADVANCE(567);
      if (lookahead == '\'')
        ADVANCE(45);
      if (lookahead == '(')
        ADVANCE(50);
      if (lookahead == '*')
        ADVANCE(398);
      if (lookahead == '+')
        ADVANCE(568);
      if (lookahead == '-')
        ADVANCE(569);
      if (lookahead == '/')
        ADVANCE(399);
      if (lookahead == '0')
        ADVANCE(71);
      if (lookahead == ':')
        ADVANCE(400);
      if (lookahead == 'F')
        ADVANCE(94);
      if (lookahead == 'N')
        ADVANCE(100);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == 'd')
        ADVANCE(596);
      if (lookahead == 'f')
        ADVANCE(597);
      if (lookahead == 'n')
        ADVANCE(573);
      if (lookahead == 's')
        ADVANCE(598);
      if (lookahead == 't')
        ADVANCE(602);
      if (lookahead == '{')
        ADVANCE(389);
      if (lookahead == '~')
        ADVANCE(394);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(605);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(79);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 606:
      if (lookahead == '!')
        ADVANCE(566);
      if (lookahead == '\"')
        ADVANCE(4);
      if (lookahead == '&')
        ADVANCE(567);
      if (lookahead == '\'')
        ADVANCE(45);
      if (lookahead == '(')
        ADVANCE(50);
      if (lookahead == ')')
        ADVANCE(51);
      if (lookahead == '*')
        ADVANCE(398);
      if (lookahead == '+')
        ADVANCE(568);
      if (lookahead == '-')
        ADVANCE(569);
      if (lookahead == '/')
        ADVANCE(399);
      if (lookahead == '0')
        ADVANCE(71);
      if (lookahead == ':')
        ADVANCE(400);
      if (lookahead == 'F')
        ADVANCE(94);
      if (lookahead == 'N')
        ADVANCE(100);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == 'd')
        ADVANCE(596);
      if (lookahead == 'f')
        ADVANCE(597);
      if (lookahead == 'n')
        ADVANCE(573);
      if (lookahead == 's')
        ADVANCE(598);
      if (lookahead == 't')
        ADVANCE(602);
      if (lookahead == '{')
        ADVANCE(389);
      if (lookahead == '~')
        ADVANCE(394);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(606);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(79);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 607:
      if (lookahead == '!')
        ADVANCE(566);
      if (lookahead == '\"')
        ADVANCE(4);
      if (lookahead == '&')
        ADVANCE(567);
      if (lookahead == '\'')
        ADVANCE(45);
      if (lookahead == '(')
        ADVANCE(50);
      if (lookahead == '*')
        ADVANCE(398);
      if (lookahead == '+')
        ADVANCE(568);
      if (lookahead == ',')
        ADVANCE(57);
      if (lookahead == '-')
        ADVANCE(569);
      if (lookahead == '.')
        ADVANCE(475);
      if (lookahead == '/')
        ADVANCE(399);
      if (lookahead == '0')
        ADVANCE(71);
      if (lookahead == ':')
        ADVANCE(400);
      if (lookahead == 'F')
        ADVANCE(94);
      if (lookahead == 'N')
        ADVANCE(100);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == 'd')
        ADVANCE(596);
      if (lookahead == 'f')
        ADVANCE(597);
      if (lookahead == 'n')
        ADVANCE(573);
      if (lookahead == 's')
        ADVANCE(598);
      if (lookahead == 't')
        ADVANCE(602);
      if (lookahead == '{')
        ADVANCE(389);
      if (lookahead == '}')
        ADVANCE(393);
      if (lookahead == '~')
        ADVANCE(394);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(607);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(79);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 608:
      if (lookahead == '&')
        ADVANCE(397);
      if (lookahead == '(')
        ADVANCE(50);
      if (lookahead == ')')
        ADVANCE(51);
      if (lookahead == '*')
        ADVANCE(398);
      if (lookahead == ',')
        ADVANCE(57);
      if (lookahead == '-')
        ADVANCE(609);
      if (lookahead == '/')
        ADVANCE(399);
      if (lookahead == ':')
        ADVANCE(477);
      if (lookahead == ';')
        ADVANCE(82);
      if (lookahead == '<')
        ADVANCE(421);
      if (lookahead == '=')
        ADVANCE(422);
      if (lookahead == '>')
        ADVANCE(423);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '_')
        ADVANCE(112);
      if (lookahead == 'b')
        ADVANCE(401);
      if (lookahead == 'c')
        ADVANCE(483);
      if (lookahead == 'd')
        ADVANCE(405);
      if (lookahead == 'e')
        ADVANCE(610);
      if (lookahead == 'f')
        ADVANCE(408);
      if (lookahead == 'i')
        ADVANCE(446);
      if (lookahead == 'l')
        ADVANCE(219);
      if (lookahead == 'm')
        ADVANCE(223);
      if (lookahead == 'n')
        ADVANCE(611);
      if (lookahead == 'r')
        ADVANCE(448);
      if (lookahead == 's')
        ADVANCE(479);
      if (lookahead == 'u')
        ADVANCE(480);
      if (lookahead == 'v')
        ADVANCE(375);
      if (lookahead == '{')
        ADVANCE(389);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(608);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 609:
      if (lookahead == '>')
        ADVANCE(61);
      END_STATE();
    case 610:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'x')
        ADVANCE(445);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 611:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'o')
        ADVANCE(241);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 612:
      if (lookahead == '!')
        ADVANCE(566);
      if (lookahead == '\"')
        ADVANCE(4);
      if (lookahead == '&')
        ADVANCE(567);
      if (lookahead == '\'')
        ADVANCE(45);
      if (lookahead == '(')
        ADVANCE(50);
      if (lookahead == '*')
        ADVANCE(398);
      if (lookahead == '+')
        ADVANCE(568);
      if (lookahead == '-')
        ADVANCE(569);
      if (lookahead == '/')
        ADVANCE(399);
      if (lookahead == '0')
        ADVANCE(71);
      if (lookahead == ':')
        ADVANCE(400);
      if (lookahead == 'F')
        ADVANCE(94);
      if (lookahead == 'N')
        ADVANCE(100);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '_')
        ADVANCE(112);
      if (lookahead == 'a')
        ADVANCE(119);
      if (lookahead == 'b')
        ADVANCE(401);
      if (lookahead == 'c')
        ADVANCE(402);
      if (lookahead == 'd')
        ADVANCE(570);
      if (lookahead == 'e')
        ADVANCE(444);
      if (lookahead == 'f')
        ADVANCE(572);
      if (lookahead == 'i')
        ADVANCE(446);
      if (lookahead == 'l')
        ADVANCE(219);
      if (lookahead == 'm')
        ADVANCE(223);
      if (lookahead == 'n')
        ADVANCE(573);
      if (lookahead == 'r')
        ADVANCE(448);
      if (lookahead == 's')
        ADVANCE(613);
      if (lookahead == 't')
        ADVANCE(575);
      if (lookahead == 'u')
        ADVANCE(456);
      if (lookahead == 'v')
        ADVANCE(375);
      if (lookahead == '~')
        ADVANCE(394);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(612);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(79);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('g' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 613:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'h')
        ADVANCE(311);
      if (lookahead == 'i')
        ADVANCE(315);
      if (lookahead == 's')
        ADVANCE(320);
      if (lookahead == 't')
        ADVANCE(451);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 614:
      if (lookahead == '!')
        ADVANCE(566);
      if (lookahead == '\"')
        ADVANCE(4);
      if (lookahead == '&')
        ADVANCE(567);
      if (lookahead == '\'')
        ADVANCE(45);
      if (lookahead == '(')
        ADVANCE(50);
      if (lookahead == '*')
        ADVANCE(398);
      if (lookahead == '+')
        ADVANCE(568);
      if (lookahead == '-')
        ADVANCE(569);
      if (lookahead == '/')
        ADVANCE(399);
      if (lookahead == '0')
        ADVANCE(71);
      if (lookahead == ':')
        ADVANCE(400);
      if (lookahead == '=')
        ADVANCE(422);
      if (lookahead == 'F')
        ADVANCE(94);
      if (lookahead == 'N')
        ADVANCE(100);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == ']')
        ADVANCE(109);
      if (lookahead == 'd')
        ADVANCE(596);
      if (lookahead == 'f')
        ADVANCE(597);
      if (lookahead == 'n')
        ADVANCE(573);
      if (lookahead == 's')
        ADVANCE(598);
      if (lookahead == 't')
        ADVANCE(602);
      if (lookahead == '~')
        ADVANCE(394);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(614);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(79);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 615:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '\"')
        ADVANCE(4);
      if (lookahead == '%')
        ADVANCE(40);
      if (lookahead == '&')
        ADVANCE(42);
      if (lookahead == '\'')
        ADVANCE(45);
      if (lookahead == '(')
        ADVANCE(50);
      if (lookahead == '*')
        ADVANCE(52);
      if (lookahead == '+')
        ADVANCE(54);
      if (lookahead == '-')
        ADVANCE(58);
      if (lookahead == '.')
        ADVANCE(475);
      if (lookahead == '/')
        ADVANCE(65);
      if (lookahead == '0')
        ADVANCE(71);
      if (lookahead == ':')
        ADVANCE(400);
      if (lookahead == '<')
        ADVANCE(83);
      if (lookahead == '=')
        ADVANCE(87);
      if (lookahead == '>')
        ADVANCE(89);
      if (lookahead == '?')
        ADVANCE(93);
      if (lookahead == 'F')
        ADVANCE(94);
      if (lookahead == 'N')
        ADVANCE(100);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == ']')
        ADVANCE(109);
      if (lookahead == '^')
        ADVANCE(110);
      if (lookahead == '_')
        ADVANCE(112);
      if (lookahead == 'c')
        ADVANCE(460);
      if (lookahead == 'd')
        ADVANCE(596);
      if (lookahead == 'e')
        ADVANCE(461);
      if (lookahead == 'f')
        ADVANCE(597);
      if (lookahead == 'i')
        ADVANCE(462);
      if (lookahead == 'm')
        ADVANCE(223);
      if (lookahead == 'n')
        ADVANCE(573);
      if (lookahead == 'r')
        ADVANCE(411);
      if (lookahead == 's')
        ADVANCE(616);
      if (lookahead == 't')
        ADVANCE(602);
      if (lookahead == 'v')
        ADVANCE(466);
      if (lookahead == '{')
        ADVANCE(389);
      if (lookahead == '|')
        ADVANCE(390);
      if (lookahead == '~')
        ADVANCE(394);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(615);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(79);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 616:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'i')
        ADVANCE(599);
      if (lookahead == 't')
        ADVANCE(465);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 617:
      if (lookahead == '!')
        ADVANCE(474);
      if (lookahead == '\"')
        ADVANCE(4);
      if (lookahead == '%')
        ADVANCE(40);
      if (lookahead == '&')
        ADVANCE(42);
      if (lookahead == '(')
        ADVANCE(50);
      if (lookahead == ')')
        ADVANCE(51);
      if (lookahead == '*')
        ADVANCE(52);
      if (lookahead == '+')
        ADVANCE(54);
      if (lookahead == ',')
        ADVANCE(57);
      if (lookahead == '-')
        ADVANCE(58);
      if (lookahead == '.')
        ADVANCE(475);
      if (lookahead == '/')
        ADVANCE(65);
      if (lookahead == ':')
        ADVANCE(477);
      if (lookahead == ';')
        ADVANCE(82);
      if (lookahead == '<')
        ADVANCE(83);
      if (lookahead == '=')
        ADVANCE(87);
      if (lookahead == '>')
        ADVANCE(89);
      if (lookahead == '?')
        ADVANCE(93);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '^')
        ADVANCE(110);
      if (lookahead == 'd')
        ADVANCE(596);
      if (lookahead == 'o')
        ADVANCE(254);
      if (lookahead == '|')
        ADVANCE(390);
      if (lookahead == '}')
        ADVANCE(393);
      if (lookahead == '~')
        ADVANCE(394);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(617);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 618:
      if (lookahead == '!')
        ADVANCE(566);
      if (lookahead == '\"')
        ADVANCE(4);
      if (lookahead == '&')
        ADVANCE(567);
      if (lookahead == '\'')
        ADVANCE(45);
      if (lookahead == '(')
        ADVANCE(50);
      if (lookahead == '*')
        ADVANCE(398);
      if (lookahead == '+')
        ADVANCE(568);
      if (lookahead == '-')
        ADVANCE(569);
      if (lookahead == '/')
        ADVANCE(399);
      if (lookahead == '0')
        ADVANCE(71);
      if (lookahead == ':')
        ADVANCE(400);
      if (lookahead == 'F')
        ADVANCE(94);
      if (lookahead == 'N')
        ADVANCE(100);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == ']')
        ADVANCE(109);
      if (lookahead == 'd')
        ADVANCE(596);
      if (lookahead == 'f')
        ADVANCE(597);
      if (lookahead == 'n')
        ADVANCE(573);
      if (lookahead == 's')
        ADVANCE(598);
      if (lookahead == 't')
        ADVANCE(602);
      if (lookahead == '~')
        ADVANCE(394);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(618);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(79);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 619:
      if (lookahead == '!')
        ADVANCE(566);
      if (lookahead == '\"')
        ADVANCE(4);
      if (lookahead == '&')
        ADVANCE(567);
      if (lookahead == '\'')
        ADVANCE(45);
      if (lookahead == '(')
        ADVANCE(50);
      if (lookahead == '*')
        ADVANCE(398);
      if (lookahead == '+')
        ADVANCE(568);
      if (lookahead == '-')
        ADVANCE(569);
      if (lookahead == '/')
        ADVANCE(399);
      if (lookahead == '0')
        ADVANCE(71);
      if (lookahead == ':')
        ADVANCE(400);
      if (lookahead == 'F')
        ADVANCE(94);
      if (lookahead == 'N')
        ADVANCE(100);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == ']')
        ADVANCE(109);
      if (lookahead == '_')
        ADVANCE(112);
      if (lookahead == 'c')
        ADVANCE(460);
      if (lookahead == 'd')
        ADVANCE(596);
      if (lookahead == 'e')
        ADVANCE(461);
      if (lookahead == 'f')
        ADVANCE(597);
      if (lookahead == 'i')
        ADVANCE(462);
      if (lookahead == 'm')
        ADVANCE(223);
      if (lookahead == 'n')
        ADVANCE(573);
      if (lookahead == 'r')
        ADVANCE(411);
      if (lookahead == 's')
        ADVANCE(616);
      if (lookahead == 't')
        ADVANCE(602);
      if (lookahead == 'v')
        ADVANCE(466);
      if (lookahead == '~')
        ADVANCE(394);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(619);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(79);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 620:
      if (lookahead == '!')
        ADVANCE(566);
      if (lookahead == '\"')
        ADVANCE(4);
      if (lookahead == '&')
        ADVANCE(567);
      if (lookahead == '\'')
        ADVANCE(45);
      if (lookahead == '(')
        ADVANCE(50);
      if (lookahead == '*')
        ADVANCE(398);
      if (lookahead == '+')
        ADVANCE(568);
      if (lookahead == '-')
        ADVANCE(569);
      if (lookahead == '/')
        ADVANCE(399);
      if (lookahead == '0')
        ADVANCE(71);
      if (lookahead == ':')
        ADVANCE(400);
      if (lookahead == 'F')
        ADVANCE(94);
      if (lookahead == 'N')
        ADVANCE(100);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == ']')
        ADVANCE(109);
      if (lookahead == '_')
        ADVANCE(112);
      if (lookahead == 'c')
        ADVANCE(460);
      if (lookahead == 'd')
        ADVANCE(596);
      if (lookahead == 'e')
        ADVANCE(461);
      if (lookahead == 'f')
        ADVANCE(597);
      if (lookahead == 'i')
        ADVANCE(462);
      if (lookahead == 'm')
        ADVANCE(223);
      if (lookahead == 'n')
        ADVANCE(573);
      if (lookahead == 'r')
        ADVANCE(411);
      if (lookahead == 's')
        ADVANCE(616);
      if (lookahead == 't')
        ADVANCE(602);
      if (lookahead == 'v')
        ADVANCE(466);
      if (lookahead == '{')
        ADVANCE(389);
      if (lookahead == '~')
        ADVANCE(394);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(620);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(79);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 621:
      if (lookahead == '!')
        ADVANCE(566);
      if (lookahead == '\"')
        ADVANCE(4);
      if (lookahead == '&')
        ADVANCE(567);
      if (lookahead == '\'')
        ADVANCE(45);
      if (lookahead == '(')
        ADVANCE(50);
      if (lookahead == '*')
        ADVANCE(398);
      if (lookahead == '+')
        ADVANCE(568);
      if (lookahead == '-')
        ADVANCE(569);
      if (lookahead == '/')
        ADVANCE(399);
      if (lookahead == '0')
        ADVANCE(71);
      if (lookahead == ':')
        ADVANCE(400);
      if (lookahead == '<')
        ADVANCE(421);
      if (lookahead == 'F')
        ADVANCE(94);
      if (lookahead == 'N')
        ADVANCE(100);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == ']')
        ADVANCE(109);
      if (lookahead == '_')
        ADVANCE(112);
      if (lookahead == 'c')
        ADVANCE(460);
      if (lookahead == 'd')
        ADVANCE(596);
      if (lookahead == 'e')
        ADVANCE(461);
      if (lookahead == 'f')
        ADVANCE(597);
      if (lookahead == 'i')
        ADVANCE(462);
      if (lookahead == 'm')
        ADVANCE(223);
      if (lookahead == 'n')
        ADVANCE(573);
      if (lookahead == 'r')
        ADVANCE(411);
      if (lookahead == 's')
        ADVANCE(616);
      if (lookahead == 't')
        ADVANCE(602);
      if (lookahead == 'v')
        ADVANCE(466);
      if (lookahead == '{')
        ADVANCE(389);
      if (lookahead == '~')
        ADVANCE(394);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(621);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(79);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 622:
      if (lookahead == '!')
        ADVANCE(566);
      if (lookahead == '\"')
        ADVANCE(4);
      if (lookahead == '&')
        ADVANCE(567);
      if (lookahead == '\'')
        ADVANCE(45);
      if (lookahead == '(')
        ADVANCE(50);
      if (lookahead == '*')
        ADVANCE(398);
      if (lookahead == '+')
        ADVANCE(568);
      if (lookahead == '-')
        ADVANCE(569);
      if (lookahead == '/')
        ADVANCE(399);
      if (lookahead == '0')
        ADVANCE(71);
      if (lookahead == ':')
        ADVANCE(400);
      if (lookahead == 'F')
        ADVANCE(94);
      if (lookahead == 'N')
        ADVANCE(100);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == ']')
        ADVANCE(109);
      if (lookahead == '_')
        ADVANCE(112);
      if (lookahead == 'b')
        ADVANCE(401);
      if (lookahead == 'c')
        ADVANCE(483);
      if (lookahead == 'd')
        ADVANCE(570);
      if (lookahead == 'e')
        ADVANCE(461);
      if (lookahead == 'f')
        ADVANCE(572);
      if (lookahead == 'i')
        ADVANCE(409);
      if (lookahead == 'l')
        ADVANCE(219);
      if (lookahead == 'm')
        ADVANCE(223);
      if (lookahead == 'n')
        ADVANCE(573);
      if (lookahead == 'r')
        ADVANCE(411);
      if (lookahead == 's')
        ADVANCE(623);
      if (lookahead == 't')
        ADVANCE(602);
      if (lookahead == 'u')
        ADVANCE(480);
      if (lookahead == 'v')
        ADVANCE(375);
      if (lookahead == '~')
        ADVANCE(394);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(622);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(79);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 623:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'h')
        ADVANCE(311);
      if (lookahead == 'i')
        ADVANCE(315);
      if (lookahead == 's')
        ADVANCE(320);
      if (lookahead == 't')
        ADVANCE(465);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 624:
      if (lookahead == '!')
        ADVANCE(566);
      if (lookahead == '\"')
        ADVANCE(4);
      if (lookahead == '&')
        ADVANCE(567);
      if (lookahead == '\'')
        ADVANCE(45);
      if (lookahead == '(')
        ADVANCE(50);
      if (lookahead == '*')
        ADVANCE(398);
      if (lookahead == '+')
        ADVANCE(568);
      if (lookahead == '-')
        ADVANCE(569);
      if (lookahead == '/')
        ADVANCE(399);
      if (lookahead == '0')
        ADVANCE(71);
      if (lookahead == ':')
        ADVANCE(400);
      if (lookahead == ';')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(94);
      if (lookahead == 'N')
        ADVANCE(100);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == 'b')
        ADVANCE(625);
      if (lookahead == 'c')
        ADVANCE(626);
      if (lookahead == 'd')
        ADVANCE(629);
      if (lookahead == 'f')
        ADVANCE(631);
      if (lookahead == 'g')
        ADVANCE(208);
      if (lookahead == 'i')
        ADVANCE(632);
      if (lookahead == 'n')
        ADVANCE(573);
      if (lookahead == 'r')
        ADVANCE(633);
      if (lookahead == 's')
        ADVANCE(635);
      if (lookahead == 't')
        ADVANCE(602);
      if (lookahead == 'w')
        ADVANCE(384);
      if (lookahead == '{')
        ADVANCE(389);
      if (lookahead == '~')
        ADVANCE(394);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(624);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(79);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 625:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'r')
        ADVANCE(127);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 626:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'a')
        ADVANCE(132);
      if (lookahead == 'o')
        ADVANCE(627);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 627:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'n')
        ADVANCE(628);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 628:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 't')
        ADVANCE(157);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 629:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'e')
        ADVANCE(163);
      if (lookahead == 'o')
        ADVANCE(630);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 630:
      ACCEPT_TOKEN(anon_sym_do);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 631:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'a')
        ADVANCE(196);
      if (lookahead == 'o')
        ADVANCE(201);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 632:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'f')
        ADVANCE(213);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 633:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'e')
        ADVANCE(634);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 634:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 't')
        ADVANCE(306);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 635:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'i')
        ADVANCE(599);
      if (lookahead == 'w')
        ADVANCE(332);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 636:
      if (lookahead == '!')
        ADVANCE(566);
      if (lookahead == '\"')
        ADVANCE(4);
      if (lookahead == '&')
        ADVANCE(567);
      if (lookahead == '\'')
        ADVANCE(45);
      if (lookahead == '(')
        ADVANCE(50);
      if (lookahead == '*')
        ADVANCE(398);
      if (lookahead == '+')
        ADVANCE(568);
      if (lookahead == '-')
        ADVANCE(569);
      if (lookahead == '/')
        ADVANCE(399);
      if (lookahead == '0')
        ADVANCE(71);
      if (lookahead == ':')
        ADVANCE(400);
      if (lookahead == ';')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(94);
      if (lookahead == 'N')
        ADVANCE(100);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == 'd')
        ADVANCE(596);
      if (lookahead == 'f')
        ADVANCE(597);
      if (lookahead == 'n')
        ADVANCE(573);
      if (lookahead == 's')
        ADVANCE(598);
      if (lookahead == 't')
        ADVANCE(602);
      if (lookahead == '{')
        ADVANCE(389);
      if (lookahead == '~')
        ADVANCE(394);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(636);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(79);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 637:
      if (lookahead == '!')
        ADVANCE(474);
      if (lookahead == '%')
        ADVANCE(40);
      if (lookahead == '&')
        ADVANCE(42);
      if (lookahead == '(')
        ADVANCE(50);
      if (lookahead == ')')
        ADVANCE(51);
      if (lookahead == '*')
        ADVANCE(52);
      if (lookahead == '+')
        ADVANCE(54);
      if (lookahead == ',')
        ADVANCE(57);
      if (lookahead == '-')
        ADVANCE(58);
      if (lookahead == '.')
        ADVANCE(475);
      if (lookahead == '/')
        ADVANCE(65);
      if (lookahead == ':')
        ADVANCE(80);
      if (lookahead == ';')
        ADVANCE(82);
      if (lookahead == '<')
        ADVANCE(83);
      if (lookahead == '=')
        ADVANCE(87);
      if (lookahead == '>')
        ADVANCE(89);
      if (lookahead == '?')
        ADVANCE(93);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '^')
        ADVANCE(110);
      if (lookahead == '_')
        ADVANCE(112);
      if (lookahead == 'c')
        ADVANCE(460);
      if (lookahead == 'e')
        ADVANCE(461);
      if (lookahead == 'i')
        ADVANCE(462);
      if (lookahead == 'm')
        ADVANCE(223);
      if (lookahead == 'o')
        ADVANCE(254);
      if (lookahead == 'r')
        ADVANCE(411);
      if (lookahead == 's')
        ADVANCE(464);
      if (lookahead == 'v')
        ADVANCE(466);
      if (lookahead == '{')
        ADVANCE(389);
      if (lookahead == '|')
        ADVANCE(390);
      if (lookahead == '}')
        ADVANCE(393);
      if (lookahead == '~')
        ADVANCE(394);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(637);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 638:
      if (lookahead == '#')
        ADVANCE(587);
      if (lookahead == '&')
        ADVANCE(397);
      if (lookahead == '(')
        ADVANCE(50);
      if (lookahead == '*')
        ADVANCE(398);
      if (lookahead == '/')
        ADVANCE(399);
      if (lookahead == ':')
        ADVANCE(400);
      if (lookahead == '_')
        ADVANCE(112);
      if (lookahead == 'a')
        ADVANCE(119);
      if (lookahead == 'b')
        ADVANCE(401);
      if (lookahead == 'c')
        ADVANCE(402);
      if (lookahead == 'd')
        ADVANCE(405);
      if (lookahead == 'e')
        ADVANCE(407);
      if (lookahead == 'f')
        ADVANCE(498);
      if (lookahead == 'i')
        ADVANCE(409);
      if (lookahead == 'l')
        ADVANCE(219);
      if (lookahead == 'm')
        ADVANCE(223);
      if (lookahead == 'o')
        ADVANCE(254);
      if (lookahead == 'p')
        ADVANCE(273);
      if (lookahead == 'r')
        ADVANCE(411);
      if (lookahead == 's')
        ADVANCE(413);
      if (lookahead == 't')
        ADVANCE(414);
      if (lookahead == 'u')
        ADVANCE(357);
      if (lookahead == 'v')
        ADVANCE(375);
      if (lookahead == '~')
        ADVANCE(394);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(638);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('g' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 639:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '\"')
        ADVANCE(4);
      if (lookahead == '%')
        ADVANCE(40);
      if (lookahead == '&')
        ADVANCE(42);
      if (lookahead == '\'')
        ADVANCE(45);
      if (lookahead == '(')
        ADVANCE(50);
      if (lookahead == '*')
        ADVANCE(52);
      if (lookahead == '+')
        ADVANCE(54);
      if (lookahead == ',')
        ADVANCE(57);
      if (lookahead == '-')
        ADVANCE(58);
      if (lookahead == '.')
        ADVANCE(475);
      if (lookahead == '/')
        ADVANCE(65);
      if (lookahead == '0')
        ADVANCE(71);
      if (lookahead == ':')
        ADVANCE(400);
      if (lookahead == '<')
        ADVANCE(83);
      if (lookahead == '=')
        ADVANCE(87);
      if (lookahead == '>')
        ADVANCE(89);
      if (lookahead == '?')
        ADVANCE(93);
      if (lookahead == 'F')
        ADVANCE(94);
      if (lookahead == 'N')
        ADVANCE(100);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == ']')
        ADVANCE(109);
      if (lookahead == '^')
        ADVANCE(110);
      if (lookahead == 'd')
        ADVANCE(596);
      if (lookahead == 'f')
        ADVANCE(597);
      if (lookahead == 'n')
        ADVANCE(573);
      if (lookahead == 's')
        ADVANCE(598);
      if (lookahead == 't')
        ADVANCE(602);
      if (lookahead == '{')
        ADVANCE(389);
      if (lookahead == '|')
        ADVANCE(390);
      if (lookahead == '~')
        ADVANCE(394);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(639);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(79);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 640:
      if (lookahead == '!')
        ADVANCE(566);
      if (lookahead == '\"')
        ADVANCE(4);
      if (lookahead == '&')
        ADVANCE(567);
      if (lookahead == '\'')
        ADVANCE(45);
      if (lookahead == '(')
        ADVANCE(50);
      if (lookahead == '*')
        ADVANCE(398);
      if (lookahead == '+')
        ADVANCE(568);
      if (lookahead == '-')
        ADVANCE(569);
      if (lookahead == '/')
        ADVANCE(399);
      if (lookahead == '0')
        ADVANCE(71);
      if (lookahead == ':')
        ADVANCE(80);
      if (lookahead == '<')
        ADVANCE(421);
      if (lookahead == 'F')
        ADVANCE(94);
      if (lookahead == 'N')
        ADVANCE(100);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == ']')
        ADVANCE(109);
      if (lookahead == '_')
        ADVANCE(112);
      if (lookahead == 'c')
        ADVANCE(460);
      if (lookahead == 'd')
        ADVANCE(596);
      if (lookahead == 'e')
        ADVANCE(461);
      if (lookahead == 'f')
        ADVANCE(597);
      if (lookahead == 'i')
        ADVANCE(462);
      if (lookahead == 'm')
        ADVANCE(223);
      if (lookahead == 'n')
        ADVANCE(573);
      if (lookahead == 'r')
        ADVANCE(411);
      if (lookahead == 's')
        ADVANCE(616);
      if (lookahead == 't')
        ADVANCE(602);
      if (lookahead == 'v')
        ADVANCE(466);
      if (lookahead == '{')
        ADVANCE(389);
      if (lookahead == '~')
        ADVANCE(394);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(640);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(79);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 641:
      if (lookahead == '!')
        ADVANCE(566);
      if (lookahead == '\"')
        ADVANCE(4);
      if (lookahead == '&')
        ADVANCE(567);
      if (lookahead == '\'')
        ADVANCE(45);
      if (lookahead == '(')
        ADVANCE(50);
      if (lookahead == '*')
        ADVANCE(398);
      if (lookahead == '+')
        ADVANCE(568);
      if (lookahead == '-')
        ADVANCE(569);
      if (lookahead == '/')
        ADVANCE(399);
      if (lookahead == '0')
        ADVANCE(71);
      if (lookahead == ':')
        ADVANCE(80);
      if (lookahead == 'F')
        ADVANCE(94);
      if (lookahead == 'N')
        ADVANCE(100);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == ']')
        ADVANCE(109);
      if (lookahead == '_')
        ADVANCE(112);
      if (lookahead == 'c')
        ADVANCE(460);
      if (lookahead == 'd')
        ADVANCE(596);
      if (lookahead == 'e')
        ADVANCE(461);
      if (lookahead == 'f')
        ADVANCE(597);
      if (lookahead == 'i')
        ADVANCE(462);
      if (lookahead == 'm')
        ADVANCE(223);
      if (lookahead == 'n')
        ADVANCE(573);
      if (lookahead == 'r')
        ADVANCE(411);
      if (lookahead == 's')
        ADVANCE(616);
      if (lookahead == 't')
        ADVANCE(602);
      if (lookahead == 'v')
        ADVANCE(466);
      if (lookahead == '{')
        ADVANCE(389);
      if (lookahead == '~')
        ADVANCE(394);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(641);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(79);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 642:
      if (lookahead == '!')
        ADVANCE(566);
      if (lookahead == '\"')
        ADVANCE(4);
      if (lookahead == '&')
        ADVANCE(567);
      if (lookahead == '\'')
        ADVANCE(45);
      if (lookahead == '(')
        ADVANCE(50);
      if (lookahead == '*')
        ADVANCE(398);
      if (lookahead == '+')
        ADVANCE(568);
      if (lookahead == '-')
        ADVANCE(569);
      if (lookahead == '/')
        ADVANCE(399);
      if (lookahead == '0')
        ADVANCE(71);
      if (lookahead == ':')
        ADVANCE(400);
      if (lookahead == '<')
        ADVANCE(421);
      if (lookahead == 'F')
        ADVANCE(94);
      if (lookahead == 'N')
        ADVANCE(100);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == ']')
        ADVANCE(109);
      if (lookahead == '_')
        ADVANCE(112);
      if (lookahead == 'c')
        ADVANCE(460);
      if (lookahead == 'd')
        ADVANCE(596);
      if (lookahead == 'e')
        ADVANCE(461);
      if (lookahead == 'f')
        ADVANCE(597);
      if (lookahead == 'i')
        ADVANCE(462);
      if (lookahead == 'm')
        ADVANCE(223);
      if (lookahead == 'n')
        ADVANCE(573);
      if (lookahead == 'r')
        ADVANCE(411);
      if (lookahead == 's')
        ADVANCE(616);
      if (lookahead == 't')
        ADVANCE(602);
      if (lookahead == 'v')
        ADVANCE(466);
      if (lookahead == '~')
        ADVANCE(394);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(642);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(79);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 643:
      if (lookahead == '&')
        ADVANCE(397);
      if (lookahead == '(')
        ADVANCE(50);
      if (lookahead == ')')
        ADVANCE(51);
      if (lookahead == '*')
        ADVANCE(398);
      if (lookahead == ',')
        ADVANCE(57);
      if (lookahead == '-')
        ADVANCE(609);
      if (lookahead == '/')
        ADVANCE(399);
      if (lookahead == ':')
        ADVANCE(80);
      if (lookahead == ';')
        ADVANCE(82);
      if (lookahead == '<')
        ADVANCE(421);
      if (lookahead == '=')
        ADVANCE(422);
      if (lookahead == '>')
        ADVANCE(423);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '_')
        ADVANCE(502);
      if (lookahead == 'c')
        ADVANCE(509);
      if (lookahead == 'e')
        ADVANCE(644);
      if (lookahead == 'm')
        ADVANCE(529);
      if (lookahead == 'n')
        ADVANCE(536);
      if (lookahead == 'r')
        ADVANCE(544);
      if (lookahead == 'v')
        ADVANCE(552);
      if (lookahead == '{')
        ADVANCE(389);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(643);
      END_STATE();
    case 644:
      if (lookahead == 'x')
        ADVANCE(522);
      END_STATE();
    case 645:
      if (lookahead == '!')
        ADVANCE(566);
      if (lookahead == '\"')
        ADVANCE(4);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '&')
        ADVANCE(567);
      if (lookahead == '\'')
        ADVANCE(45);
      if (lookahead == '(')
        ADVANCE(50);
      if (lookahead == '*')
        ADVANCE(398);
      if (lookahead == '+')
        ADVANCE(568);
      if (lookahead == '-')
        ADVANCE(569);
      if (lookahead == '/')
        ADVANCE(399);
      if (lookahead == '0')
        ADVANCE(71);
      if (lookahead == ':')
        ADVANCE(400);
      if (lookahead == ';')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(94);
      if (lookahead == 'N')
        ADVANCE(100);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '_')
        ADVANCE(112);
      if (lookahead == 'a')
        ADVANCE(119);
      if (lookahead == 'b')
        ADVANCE(123);
      if (lookahead == 'c')
        ADVANCE(131);
      if (lookahead == 'd')
        ADVANCE(162);
      if (lookahead == 'e')
        ADVANCE(407);
      if (lookahead == 'f')
        ADVANCE(577);
      if (lookahead == 'g')
        ADVANCE(208);
      if (lookahead == 'i')
        ADVANCE(212);
      if (lookahead == 'l')
        ADVANCE(219);
      if (lookahead == 'm')
        ADVANCE(223);
      if (lookahead == 'n')
        ADVANCE(573);
      if (lookahead == 'r')
        ADVANCE(292);
      if (lookahead == 's')
        ADVANCE(310);
      if (lookahead == 't')
        ADVANCE(578);
      if (lookahead == 'u')
        ADVANCE(456);
      if (lookahead == 'v')
        ADVANCE(375);
      if (lookahead == 'w')
        ADVANCE(384);
      if (lookahead == '{')
        ADVANCE(389);
      if (lookahead == '~')
        ADVANCE(394);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(645);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(79);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('h' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 646:
      if (lookahead == '!')
        ADVANCE(566);
      if (lookahead == '\"')
        ADVANCE(4);
      if (lookahead == '&')
        ADVANCE(567);
      if (lookahead == '\'')
        ADVANCE(45);
      if (lookahead == '(')
        ADVANCE(50);
      if (lookahead == '*')
        ADVANCE(398);
      if (lookahead == '+')
        ADVANCE(568);
      if (lookahead == '-')
        ADVANCE(569);
      if (lookahead == '/')
        ADVANCE(399);
      if (lookahead == '0')
        ADVANCE(71);
      if (lookahead == ':')
        ADVANCE(400);
      if (lookahead == ';')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(94);
      if (lookahead == 'N')
        ADVANCE(100);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '_')
        ADVANCE(112);
      if (lookahead == 'a')
        ADVANCE(119);
      if (lookahead == 'b')
        ADVANCE(123);
      if (lookahead == 'c')
        ADVANCE(131);
      if (lookahead == 'd')
        ADVANCE(162);
      if (lookahead == 'e')
        ADVANCE(407);
      if (lookahead == 'f')
        ADVANCE(577);
      if (lookahead == 'g')
        ADVANCE(208);
      if (lookahead == 'i')
        ADVANCE(212);
      if (lookahead == 'l')
        ADVANCE(219);
      if (lookahead == 'm')
        ADVANCE(223);
      if (lookahead == 'n')
        ADVANCE(573);
      if (lookahead == 'r')
        ADVANCE(292);
      if (lookahead == 's')
        ADVANCE(310);
      if (lookahead == 't')
        ADVANCE(578);
      if (lookahead == 'u')
        ADVANCE(456);
      if (lookahead == 'v')
        ADVANCE(375);
      if (lookahead == 'w')
        ADVANCE(384);
      if (lookahead == '{')
        ADVANCE(389);
      if (lookahead == '~')
        ADVANCE(394);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(646);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(79);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('h' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 647:
      if (lookahead == '!')
        ADVANCE(566);
      if (lookahead == '\"')
        ADVANCE(4);
      if (lookahead == '&')
        ADVANCE(567);
      if (lookahead == '\'')
        ADVANCE(45);
      if (lookahead == '(')
        ADVANCE(50);
      if (lookahead == '*')
        ADVANCE(398);
      if (lookahead == '+')
        ADVANCE(568);
      if (lookahead == '-')
        ADVANCE(569);
      if (lookahead == '/')
        ADVANCE(399);
      if (lookahead == '0')
        ADVANCE(71);
      if (lookahead == ':')
        ADVANCE(400);
      if (lookahead == ';')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(94);
      if (lookahead == 'N')
        ADVANCE(100);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '_')
        ADVANCE(112);
      if (lookahead == 'a')
        ADVANCE(119);
      if (lookahead == 'b')
        ADVANCE(401);
      if (lookahead == 'c')
        ADVANCE(402);
      if (lookahead == 'd')
        ADVANCE(570);
      if (lookahead == 'e')
        ADVANCE(407);
      if (lookahead == 'f')
        ADVANCE(572);
      if (lookahead == 'i')
        ADVANCE(409);
      if (lookahead == 'l')
        ADVANCE(219);
      if (lookahead == 'm')
        ADVANCE(223);
      if (lookahead == 'n')
        ADVANCE(573);
      if (lookahead == 'r')
        ADVANCE(411);
      if (lookahead == 's')
        ADVANCE(574);
      if (lookahead == 't')
        ADVANCE(575);
      if (lookahead == 'u')
        ADVANCE(456);
      if (lookahead == 'v')
        ADVANCE(375);
      if (lookahead == '~')
        ADVANCE(394);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(647);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(79);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('g' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 648:
      if (lookahead == '!')
        ADVANCE(566);
      if (lookahead == '\"')
        ADVANCE(4);
      if (lookahead == '#')
        ADVANCE(396);
      if (lookahead == '&')
        ADVANCE(567);
      if (lookahead == '\'')
        ADVANCE(45);
      if (lookahead == '(')
        ADVANCE(50);
      if (lookahead == '*')
        ADVANCE(398);
      if (lookahead == '+')
        ADVANCE(568);
      if (lookahead == ',')
        ADVANCE(57);
      if (lookahead == '-')
        ADVANCE(569);
      if (lookahead == '/')
        ADVANCE(399);
      if (lookahead == '0')
        ADVANCE(71);
      if (lookahead == ':')
        ADVANCE(400);
      if (lookahead == ';')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(94);
      if (lookahead == 'N')
        ADVANCE(100);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '_')
        ADVANCE(112);
      if (lookahead == 'a')
        ADVANCE(119);
      if (lookahead == 'b')
        ADVANCE(123);
      if (lookahead == 'c')
        ADVANCE(131);
      if (lookahead == 'd')
        ADVANCE(162);
      if (lookahead == 'e')
        ADVANCE(407);
      if (lookahead == 'f')
        ADVANCE(577);
      if (lookahead == 'g')
        ADVANCE(208);
      if (lookahead == 'i')
        ADVANCE(212);
      if (lookahead == 'l')
        ADVANCE(219);
      if (lookahead == 'm')
        ADVANCE(223);
      if (lookahead == 'n')
        ADVANCE(573);
      if (lookahead == 'r')
        ADVANCE(292);
      if (lookahead == 's')
        ADVANCE(310);
      if (lookahead == 't')
        ADVANCE(578);
      if (lookahead == 'u')
        ADVANCE(456);
      if (lookahead == 'v')
        ADVANCE(375);
      if (lookahead == 'w')
        ADVANCE(384);
      if (lookahead == '{')
        ADVANCE(389);
      if (lookahead == '}')
        ADVANCE(393);
      if (lookahead == '~')
        ADVANCE(394);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(648);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(79);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('h' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 649:
      if (lookahead == '!')
        ADVANCE(566);
      if (lookahead == '\"')
        ADVANCE(4);
      if (lookahead == '&')
        ADVANCE(567);
      if (lookahead == '\'')
        ADVANCE(45);
      if (lookahead == '(')
        ADVANCE(50);
      if (lookahead == '*')
        ADVANCE(398);
      if (lookahead == '+')
        ADVANCE(568);
      if (lookahead == '-')
        ADVANCE(569);
      if (lookahead == '.')
        ADVANCE(475);
      if (lookahead == '/')
        ADVANCE(399);
      if (lookahead == '0')
        ADVANCE(71);
      if (lookahead == ':')
        ADVANCE(400);
      if (lookahead == 'F')
        ADVANCE(94);
      if (lookahead == 'N')
        ADVANCE(100);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == 'd')
        ADVANCE(596);
      if (lookahead == 'f')
        ADVANCE(597);
      if (lookahead == 'n')
        ADVANCE(573);
      if (lookahead == 's')
        ADVANCE(598);
      if (lookahead == 't')
        ADVANCE(602);
      if (lookahead == '{')
        ADVANCE(389);
      if (lookahead == '}')
        ADVANCE(393);
      if (lookahead == '~')
        ADVANCE(394);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(649);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(79);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 650:
      if (lookahead == '!')
        ADVANCE(566);
      if (lookahead == '\"')
        ADVANCE(4);
      if (lookahead == '&')
        ADVANCE(397);
      if (lookahead == '\'')
        ADVANCE(45);
      if (lookahead == '(')
        ADVANCE(50);
      if (lookahead == '*')
        ADVANCE(398);
      if (lookahead == '+')
        ADVANCE(568);
      if (lookahead == '-')
        ADVANCE(569);
      if (lookahead == '/')
        ADVANCE(399);
      if (lookahead == '0')
        ADVANCE(71);
      if (lookahead == ':')
        ADVANCE(400);
      if (lookahead == 'F')
        ADVANCE(94);
      if (lookahead == 'N')
        ADVANCE(100);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == 'd')
        ADVANCE(596);
      if (lookahead == 'f')
        ADVANCE(597);
      if (lookahead == 'n')
        ADVANCE(573);
      if (lookahead == 's')
        ADVANCE(598);
      if (lookahead == 't')
        ADVANCE(602);
      if (lookahead == '~')
        ADVANCE(394);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(650);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(79);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 651:
      if (lookahead == '!')
        ADVANCE(474);
      if (lookahead == '%')
        ADVANCE(40);
      if (lookahead == '&')
        ADVANCE(42);
      if (lookahead == '(')
        ADVANCE(50);
      if (lookahead == ')')
        ADVANCE(51);
      if (lookahead == '*')
        ADVANCE(52);
      if (lookahead == '+')
        ADVANCE(54);
      if (lookahead == ',')
        ADVANCE(57);
      if (lookahead == '-')
        ADVANCE(58);
      if (lookahead == '.')
        ADVANCE(475);
      if (lookahead == '/')
        ADVANCE(65);
      if (lookahead == ':')
        ADVANCE(80);
      if (lookahead == ';')
        ADVANCE(82);
      if (lookahead == '<')
        ADVANCE(83);
      if (lookahead == '=')
        ADVANCE(87);
      if (lookahead == '>')
        ADVANCE(89);
      if (lookahead == '?')
        ADVANCE(93);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == ']')
        ADVANCE(109);
      if (lookahead == '^')
        ADVANCE(110);
      if (lookahead == '_')
        ADVANCE(112);
      if (lookahead == 'c')
        ADVANCE(460);
      if (lookahead == 'e')
        ADVANCE(461);
      if (lookahead == 'i')
        ADVANCE(462);
      if (lookahead == 'm')
        ADVANCE(223);
      if (lookahead == 'o')
        ADVANCE(254);
      if (lookahead == 'r')
        ADVANCE(411);
      if (lookahead == 's')
        ADVANCE(464);
      if (lookahead == 'v')
        ADVANCE(466);
      if (lookahead == '{')
        ADVANCE(389);
      if (lookahead == '|')
        ADVANCE(390);
      if (lookahead == '}')
        ADVANCE(393);
      if (lookahead == '~')
        ADVANCE(394);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(651);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 652:
      if (lookahead == '!')
        ADVANCE(566);
      if (lookahead == '\"')
        ADVANCE(4);
      if (lookahead == '#')
        ADVANCE(582);
      if (lookahead == '&')
        ADVANCE(567);
      if (lookahead == '\'')
        ADVANCE(45);
      if (lookahead == '(')
        ADVANCE(50);
      if (lookahead == '*')
        ADVANCE(398);
      if (lookahead == '+')
        ADVANCE(568);
      if (lookahead == '-')
        ADVANCE(569);
      if (lookahead == '/')
        ADVANCE(399);
      if (lookahead == '0')
        ADVANCE(71);
      if (lookahead == ':')
        ADVANCE(400);
      if (lookahead == ';')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(94);
      if (lookahead == 'N')
        ADVANCE(100);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '_')
        ADVANCE(112);
      if (lookahead == 'a')
        ADVANCE(119);
      if (lookahead == 'b')
        ADVANCE(123);
      if (lookahead == 'c')
        ADVANCE(131);
      if (lookahead == 'd')
        ADVANCE(162);
      if (lookahead == 'e')
        ADVANCE(407);
      if (lookahead == 'f')
        ADVANCE(577);
      if (lookahead == 'g')
        ADVANCE(208);
      if (lookahead == 'i')
        ADVANCE(212);
      if (lookahead == 'l')
        ADVANCE(219);
      if (lookahead == 'm')
        ADVANCE(223);
      if (lookahead == 'n')
        ADVANCE(573);
      if (lookahead == 'r')
        ADVANCE(292);
      if (lookahead == 's')
        ADVANCE(310);
      if (lookahead == 't')
        ADVANCE(578);
      if (lookahead == 'u')
        ADVANCE(456);
      if (lookahead == 'v')
        ADVANCE(375);
      if (lookahead == 'w')
        ADVANCE(384);
      if (lookahead == '{')
        ADVANCE(389);
      if (lookahead == '~')
        ADVANCE(394);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(652);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(79);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('h' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 653:
      if (lookahead == '!')
        ADVANCE(566);
      if (lookahead == '\"')
        ADVANCE(4);
      if (lookahead == '&')
        ADVANCE(567);
      if (lookahead == '\'')
        ADVANCE(45);
      if (lookahead == '(')
        ADVANCE(50);
      if (lookahead == '*')
        ADVANCE(398);
      if (lookahead == '+')
        ADVANCE(568);
      if (lookahead == '-')
        ADVANCE(569);
      if (lookahead == '/')
        ADVANCE(399);
      if (lookahead == '0')
        ADVANCE(71);
      if (lookahead == ':')
        ADVANCE(400);
      if (lookahead == ';')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(94);
      if (lookahead == 'N')
        ADVANCE(100);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == 'd')
        ADVANCE(596);
      if (lookahead == 'f')
        ADVANCE(597);
      if (lookahead == 'n')
        ADVANCE(573);
      if (lookahead == 's')
        ADVANCE(598);
      if (lookahead == 't')
        ADVANCE(602);
      if (lookahead == '~')
        ADVANCE(394);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(653);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(79);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 654:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '\"')
        ADVANCE(4);
      if (lookahead == '%')
        ADVANCE(40);
      if (lookahead == '&')
        ADVANCE(42);
      if (lookahead == '\'')
        ADVANCE(45);
      if (lookahead == '(')
        ADVANCE(50);
      if (lookahead == '*')
        ADVANCE(52);
      if (lookahead == '+')
        ADVANCE(54);
      if (lookahead == '-')
        ADVANCE(58);
      if (lookahead == '.')
        ADVANCE(475);
      if (lookahead == '/')
        ADVANCE(65);
      if (lookahead == '0')
        ADVANCE(71);
      if (lookahead == ':')
        ADVANCE(400);
      if (lookahead == '<')
        ADVANCE(83);
      if (lookahead == '=')
        ADVANCE(87);
      if (lookahead == '>')
        ADVANCE(89);
      if (lookahead == '?')
        ADVANCE(93);
      if (lookahead == 'F')
        ADVANCE(94);
      if (lookahead == 'N')
        ADVANCE(100);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == ']')
        ADVANCE(109);
      if (lookahead == '^')
        ADVANCE(110);
      if (lookahead == 'd')
        ADVANCE(596);
      if (lookahead == 'f')
        ADVANCE(597);
      if (lookahead == 'n')
        ADVANCE(573);
      if (lookahead == 's')
        ADVANCE(598);
      if (lookahead == 't')
        ADVANCE(602);
      if (lookahead == '{')
        ADVANCE(389);
      if (lookahead == '|')
        ADVANCE(390);
      if (lookahead == '~')
        ADVANCE(394);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(654);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(79);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 655:
      if (lookahead == '!')
        ADVANCE(566);
      if (lookahead == '\"')
        ADVANCE(4);
      if (lookahead == '&')
        ADVANCE(567);
      if (lookahead == '\'')
        ADVANCE(45);
      if (lookahead == '(')
        ADVANCE(50);
      if (lookahead == ')')
        ADVANCE(51);
      if (lookahead == '*')
        ADVANCE(398);
      if (lookahead == '+')
        ADVANCE(568);
      if (lookahead == '-')
        ADVANCE(569);
      if (lookahead == '/')
        ADVANCE(399);
      if (lookahead == '0')
        ADVANCE(71);
      if (lookahead == ':')
        ADVANCE(400);
      if (lookahead == 'F')
        ADVANCE(94);
      if (lookahead == 'N')
        ADVANCE(100);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == 'd')
        ADVANCE(596);
      if (lookahead == 'f')
        ADVANCE(597);
      if (lookahead == 'n')
        ADVANCE(573);
      if (lookahead == 's')
        ADVANCE(598);
      if (lookahead == 't')
        ADVANCE(602);
      if (lookahead == '~')
        ADVANCE(394);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(655);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(79);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 656:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '\"')
        ADVANCE(4);
      if (lookahead == '%')
        ADVANCE(40);
      if (lookahead == '&')
        ADVANCE(42);
      if (lookahead == '\'')
        ADVANCE(45);
      if (lookahead == '(')
        ADVANCE(50);
      if (lookahead == '*')
        ADVANCE(52);
      if (lookahead == '+')
        ADVANCE(54);
      if (lookahead == ',')
        ADVANCE(57);
      if (lookahead == '-')
        ADVANCE(58);
      if (lookahead == '.')
        ADVANCE(475);
      if (lookahead == '/')
        ADVANCE(65);
      if (lookahead == '0')
        ADVANCE(71);
      if (lookahead == ':')
        ADVANCE(400);
      if (lookahead == ';')
        ADVANCE(82);
      if (lookahead == '<')
        ADVANCE(83);
      if (lookahead == '=')
        ADVANCE(87);
      if (lookahead == '>')
        ADVANCE(89);
      if (lookahead == '?')
        ADVANCE(93);
      if (lookahead == 'F')
        ADVANCE(94);
      if (lookahead == 'N')
        ADVANCE(100);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '^')
        ADVANCE(110);
      if (lookahead == 'd')
        ADVANCE(596);
      if (lookahead == 'f')
        ADVANCE(597);
      if (lookahead == 'n')
        ADVANCE(573);
      if (lookahead == 's')
        ADVANCE(598);
      if (lookahead == 't')
        ADVANCE(602);
      if (lookahead == '{')
        ADVANCE(389);
      if (lookahead == '|')
        ADVANCE(390);
      if (lookahead == '~')
        ADVANCE(394);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(656);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(79);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 657:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '\"')
        ADVANCE(4);
      if (lookahead == '%')
        ADVANCE(40);
      if (lookahead == '&')
        ADVANCE(42);
      if (lookahead == '\'')
        ADVANCE(45);
      if (lookahead == '(')
        ADVANCE(50);
      if (lookahead == ')')
        ADVANCE(51);
      if (lookahead == '*')
        ADVANCE(52);
      if (lookahead == '+')
        ADVANCE(54);
      if (lookahead == ',')
        ADVANCE(57);
      if (lookahead == '-')
        ADVANCE(58);
      if (lookahead == '.')
        ADVANCE(475);
      if (lookahead == '/')
        ADVANCE(65);
      if (lookahead == '0')
        ADVANCE(71);
      if (lookahead == ':')
        ADVANCE(400);
      if (lookahead == '<')
        ADVANCE(83);
      if (lookahead == '=')
        ADVANCE(87);
      if (lookahead == '>')
        ADVANCE(89);
      if (lookahead == '?')
        ADVANCE(93);
      if (lookahead == 'F')
        ADVANCE(94);
      if (lookahead == 'N')
        ADVANCE(100);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '^')
        ADVANCE(110);
      if (lookahead == 'd')
        ADVANCE(596);
      if (lookahead == 'f')
        ADVANCE(597);
      if (lookahead == 'n')
        ADVANCE(573);
      if (lookahead == 's')
        ADVANCE(598);
      if (lookahead == 't')
        ADVANCE(602);
      if (lookahead == '{')
        ADVANCE(389);
      if (lookahead == '|')
        ADVANCE(390);
      if (lookahead == '~')
        ADVANCE(394);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(657);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(79);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 658:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '\"')
        ADVANCE(4);
      if (lookahead == '%')
        ADVANCE(40);
      if (lookahead == '&')
        ADVANCE(42);
      if (lookahead == '\'')
        ADVANCE(45);
      if (lookahead == '(')
        ADVANCE(50);
      if (lookahead == '*')
        ADVANCE(52);
      if (lookahead == '+')
        ADVANCE(54);
      if (lookahead == ',')
        ADVANCE(57);
      if (lookahead == '-')
        ADVANCE(58);
      if (lookahead == '.')
        ADVANCE(475);
      if (lookahead == '/')
        ADVANCE(65);
      if (lookahead == '0')
        ADVANCE(71);
      if (lookahead == ':')
        ADVANCE(400);
      if (lookahead == ';')
        ADVANCE(82);
      if (lookahead == '<')
        ADVANCE(83);
      if (lookahead == '=')
        ADVANCE(87);
      if (lookahead == '>')
        ADVANCE(89);
      if (lookahead == '?')
        ADVANCE(93);
      if (lookahead == 'F')
        ADVANCE(94);
      if (lookahead == 'N')
        ADVANCE(100);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '^')
        ADVANCE(110);
      if (lookahead == 'd')
        ADVANCE(596);
      if (lookahead == 'f')
        ADVANCE(597);
      if (lookahead == 'n')
        ADVANCE(573);
      if (lookahead == 's')
        ADVANCE(598);
      if (lookahead == 't')
        ADVANCE(602);
      if (lookahead == '{')
        ADVANCE(389);
      if (lookahead == '|')
        ADVANCE(390);
      if (lookahead == '}')
        ADVANCE(393);
      if (lookahead == '~')
        ADVANCE(394);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(658);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(79);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 659:
      if (lookahead == '!')
        ADVANCE(566);
      if (lookahead == '\"')
        ADVANCE(4);
      if (lookahead == '&')
        ADVANCE(567);
      if (lookahead == '\'')
        ADVANCE(45);
      if (lookahead == '(')
        ADVANCE(50);
      if (lookahead == '*')
        ADVANCE(398);
      if (lookahead == '+')
        ADVANCE(568);
      if (lookahead == '-')
        ADVANCE(569);
      if (lookahead == '.')
        ADVANCE(475);
      if (lookahead == '/')
        ADVANCE(399);
      if (lookahead == '0')
        ADVANCE(71);
      if (lookahead == ':')
        ADVANCE(400);
      if (lookahead == 'F')
        ADVANCE(94);
      if (lookahead == 'N')
        ADVANCE(100);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == 'd')
        ADVANCE(596);
      if (lookahead == 'f')
        ADVANCE(597);
      if (lookahead == 'n')
        ADVANCE(573);
      if (lookahead == 's')
        ADVANCE(598);
      if (lookahead == 't')
        ADVANCE(602);
      if (lookahead == '{')
        ADVANCE(389);
      if (lookahead == '~')
        ADVANCE(394);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(659);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(79);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 660:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '\"')
        ADVANCE(4);
      if (lookahead == '%')
        ADVANCE(40);
      if (lookahead == '&')
        ADVANCE(42);
      if (lookahead == '\'')
        ADVANCE(45);
      if (lookahead == '(')
        ADVANCE(50);
      if (lookahead == '*')
        ADVANCE(52);
      if (lookahead == '+')
        ADVANCE(54);
      if (lookahead == ',')
        ADVANCE(57);
      if (lookahead == '-')
        ADVANCE(58);
      if (lookahead == '.')
        ADVANCE(475);
      if (lookahead == '/')
        ADVANCE(65);
      if (lookahead == '0')
        ADVANCE(71);
      if (lookahead == ':')
        ADVANCE(400);
      if (lookahead == '<')
        ADVANCE(83);
      if (lookahead == '=')
        ADVANCE(87);
      if (lookahead == '>')
        ADVANCE(89);
      if (lookahead == '?')
        ADVANCE(93);
      if (lookahead == 'F')
        ADVANCE(94);
      if (lookahead == 'N')
        ADVANCE(100);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '^')
        ADVANCE(110);
      if (lookahead == 'd')
        ADVANCE(596);
      if (lookahead == 'f')
        ADVANCE(597);
      if (lookahead == 'n')
        ADVANCE(573);
      if (lookahead == 's')
        ADVANCE(598);
      if (lookahead == 't')
        ADVANCE(602);
      if (lookahead == '{')
        ADVANCE(389);
      if (lookahead == '|')
        ADVANCE(390);
      if (lookahead == '}')
        ADVANCE(393);
      if (lookahead == '~')
        ADVANCE(394);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(660);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(79);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 661:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '\"')
        ADVANCE(4);
      if (lookahead == '%')
        ADVANCE(40);
      if (lookahead == '&')
        ADVANCE(42);
      if (lookahead == '\'')
        ADVANCE(45);
      if (lookahead == '(')
        ADVANCE(50);
      if (lookahead == '*')
        ADVANCE(52);
      if (lookahead == '+')
        ADVANCE(54);
      if (lookahead == '-')
        ADVANCE(58);
      if (lookahead == '.')
        ADVANCE(475);
      if (lookahead == '/')
        ADVANCE(65);
      if (lookahead == '0')
        ADVANCE(71);
      if (lookahead == ':')
        ADVANCE(400);
      if (lookahead == ';')
        ADVANCE(82);
      if (lookahead == '<')
        ADVANCE(83);
      if (lookahead == '=')
        ADVANCE(87);
      if (lookahead == '>')
        ADVANCE(89);
      if (lookahead == '?')
        ADVANCE(93);
      if (lookahead == 'F')
        ADVANCE(94);
      if (lookahead == 'N')
        ADVANCE(100);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '^')
        ADVANCE(110);
      if (lookahead == 'd')
        ADVANCE(596);
      if (lookahead == 'f')
        ADVANCE(597);
      if (lookahead == 'n')
        ADVANCE(573);
      if (lookahead == 's')
        ADVANCE(598);
      if (lookahead == 't')
        ADVANCE(602);
      if (lookahead == '{')
        ADVANCE(389);
      if (lookahead == '|')
        ADVANCE(390);
      if (lookahead == '~')
        ADVANCE(394);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(661);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(79);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 662:
      if (lookahead == '!')
        ADVANCE(566);
      if (lookahead == '\"')
        ADVANCE(4);
      if (lookahead == '#')
        ADVANCE(396);
      if (lookahead == '&')
        ADVANCE(567);
      if (lookahead == '\'')
        ADVANCE(45);
      if (lookahead == '(')
        ADVANCE(50);
      if (lookahead == '*')
        ADVANCE(398);
      if (lookahead == '+')
        ADVANCE(568);
      if (lookahead == '-')
        ADVANCE(569);
      if (lookahead == '/')
        ADVANCE(399);
      if (lookahead == '0')
        ADVANCE(71);
      if (lookahead == ':')
        ADVANCE(400);
      if (lookahead == ';')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(94);
      if (lookahead == 'N')
        ADVANCE(100);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '_')
        ADVANCE(112);
      if (lookahead == 'a')
        ADVANCE(119);
      if (lookahead == 'b')
        ADVANCE(123);
      if (lookahead == 'c')
        ADVANCE(131);
      if (lookahead == 'd')
        ADVANCE(162);
      if (lookahead == 'e')
        ADVANCE(177);
      if (lookahead == 'f')
        ADVANCE(577);
      if (lookahead == 'g')
        ADVANCE(208);
      if (lookahead == 'i')
        ADVANCE(212);
      if (lookahead == 'l')
        ADVANCE(219);
      if (lookahead == 'm')
        ADVANCE(223);
      if (lookahead == 'n')
        ADVANCE(573);
      if (lookahead == 'r')
        ADVANCE(292);
      if (lookahead == 's')
        ADVANCE(310);
      if (lookahead == 't')
        ADVANCE(578);
      if (lookahead == 'u')
        ADVANCE(456);
      if (lookahead == 'v')
        ADVANCE(375);
      if (lookahead == 'w')
        ADVANCE(384);
      if (lookahead == '{')
        ADVANCE(389);
      if (lookahead == '}')
        ADVANCE(393);
      if (lookahead == '~')
        ADVANCE(394);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(662);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(79);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('h' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 663:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '\"')
        ADVANCE(4);
      if (lookahead == '%')
        ADVANCE(40);
      if (lookahead == '&')
        ADVANCE(42);
      if (lookahead == '\'')
        ADVANCE(45);
      if (lookahead == '(')
        ADVANCE(50);
      if (lookahead == '*')
        ADVANCE(52);
      if (lookahead == '+')
        ADVANCE(54);
      if (lookahead == '-')
        ADVANCE(58);
      if (lookahead == '.')
        ADVANCE(475);
      if (lookahead == '/')
        ADVANCE(65);
      if (lookahead == '0')
        ADVANCE(71);
      if (lookahead == ':')
        ADVANCE(80);
      if (lookahead == '<')
        ADVANCE(83);
      if (lookahead == '=')
        ADVANCE(87);
      if (lookahead == '>')
        ADVANCE(89);
      if (lookahead == '?')
        ADVANCE(93);
      if (lookahead == 'F')
        ADVANCE(94);
      if (lookahead == 'N')
        ADVANCE(100);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '^')
        ADVANCE(110);
      if (lookahead == 'd')
        ADVANCE(596);
      if (lookahead == 'f')
        ADVANCE(597);
      if (lookahead == 'n')
        ADVANCE(573);
      if (lookahead == 's')
        ADVANCE(598);
      if (lookahead == 't')
        ADVANCE(602);
      if (lookahead == '{')
        ADVANCE(389);
      if (lookahead == '|')
        ADVANCE(390);
      if (lookahead == '~')
        ADVANCE(394);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(663);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(79);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 664:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '\"')
        ADVANCE(4);
      if (lookahead == '%')
        ADVANCE(40);
      if (lookahead == '&')
        ADVANCE(42);
      if (lookahead == '\'')
        ADVANCE(45);
      if (lookahead == '(')
        ADVANCE(50);
      if (lookahead == ')')
        ADVANCE(51);
      if (lookahead == '*')
        ADVANCE(52);
      if (lookahead == '+')
        ADVANCE(54);
      if (lookahead == '-')
        ADVANCE(58);
      if (lookahead == '.')
        ADVANCE(475);
      if (lookahead == '/')
        ADVANCE(65);
      if (lookahead == '0')
        ADVANCE(71);
      if (lookahead == ':')
        ADVANCE(400);
      if (lookahead == '<')
        ADVANCE(83);
      if (lookahead == '=')
        ADVANCE(87);
      if (lookahead == '>')
        ADVANCE(89);
      if (lookahead == '?')
        ADVANCE(93);
      if (lookahead == 'F')
        ADVANCE(94);
      if (lookahead == 'N')
        ADVANCE(100);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '^')
        ADVANCE(110);
      if (lookahead == 'd')
        ADVANCE(596);
      if (lookahead == 'f')
        ADVANCE(597);
      if (lookahead == 'n')
        ADVANCE(573);
      if (lookahead == 's')
        ADVANCE(598);
      if (lookahead == 't')
        ADVANCE(602);
      if (lookahead == '{')
        ADVANCE(389);
      if (lookahead == '|')
        ADVANCE(390);
      if (lookahead == '~')
        ADVANCE(394);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(664);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(79);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 665:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '\"')
        ADVANCE(4);
      if (lookahead == '%')
        ADVANCE(40);
      if (lookahead == '&')
        ADVANCE(42);
      if (lookahead == '\'')
        ADVANCE(45);
      if (lookahead == '(')
        ADVANCE(50);
      if (lookahead == '*')
        ADVANCE(52);
      if (lookahead == '+')
        ADVANCE(54);
      if (lookahead == ',')
        ADVANCE(57);
      if (lookahead == '-')
        ADVANCE(58);
      if (lookahead == '.')
        ADVANCE(475);
      if (lookahead == '/')
        ADVANCE(65);
      if (lookahead == '0')
        ADVANCE(71);
      if (lookahead == ':')
        ADVANCE(400);
      if (lookahead == '<')
        ADVANCE(83);
      if (lookahead == '=')
        ADVANCE(87);
      if (lookahead == '>')
        ADVANCE(89);
      if (lookahead == '?')
        ADVANCE(93);
      if (lookahead == 'F')
        ADVANCE(94);
      if (lookahead == 'N')
        ADVANCE(100);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '^')
        ADVANCE(110);
      if (lookahead == 'd')
        ADVANCE(596);
      if (lookahead == 'f')
        ADVANCE(597);
      if (lookahead == 'n')
        ADVANCE(573);
      if (lookahead == 's')
        ADVANCE(598);
      if (lookahead == 't')
        ADVANCE(602);
      if (lookahead == '{')
        ADVANCE(389);
      if (lookahead == '|')
        ADVANCE(390);
      if (lookahead == '~')
        ADVANCE(394);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(665);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(79);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 666:
      if (lookahead == '!')
        ADVANCE(566);
      if (lookahead == '\"')
        ADVANCE(4);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '&')
        ADVANCE(567);
      if (lookahead == '\'')
        ADVANCE(45);
      if (lookahead == '(')
        ADVANCE(50);
      if (lookahead == '*')
        ADVANCE(398);
      if (lookahead == '+')
        ADVANCE(568);
      if (lookahead == '-')
        ADVANCE(569);
      if (lookahead == '/')
        ADVANCE(399);
      if (lookahead == '0')
        ADVANCE(71);
      if (lookahead == ':')
        ADVANCE(400);
      if (lookahead == ';')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(94);
      if (lookahead == 'N')
        ADVANCE(100);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '_')
        ADVANCE(112);
      if (lookahead == 'a')
        ADVANCE(119);
      if (lookahead == 'b')
        ADVANCE(123);
      if (lookahead == 'c')
        ADVANCE(131);
      if (lookahead == 'd')
        ADVANCE(162);
      if (lookahead == 'e')
        ADVANCE(177);
      if (lookahead == 'f')
        ADVANCE(577);
      if (lookahead == 'g')
        ADVANCE(208);
      if (lookahead == 'i')
        ADVANCE(212);
      if (lookahead == 'l')
        ADVANCE(219);
      if (lookahead == 'm')
        ADVANCE(223);
      if (lookahead == 'n')
        ADVANCE(573);
      if (lookahead == 'r')
        ADVANCE(292);
      if (lookahead == 's')
        ADVANCE(310);
      if (lookahead == 't')
        ADVANCE(578);
      if (lookahead == 'u')
        ADVANCE(456);
      if (lookahead == 'v')
        ADVANCE(375);
      if (lookahead == 'w')
        ADVANCE(384);
      if (lookahead == '{')
        ADVANCE(389);
      if (lookahead == '~')
        ADVANCE(394);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(666);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(79);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('h' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    case 667:
      if (lookahead == '!')
        ADVANCE(566);
      if (lookahead == '\"')
        ADVANCE(4);
      if (lookahead == '#')
        ADVANCE(582);
      if (lookahead == '&')
        ADVANCE(567);
      if (lookahead == '\'')
        ADVANCE(45);
      if (lookahead == '(')
        ADVANCE(50);
      if (lookahead == '*')
        ADVANCE(398);
      if (lookahead == '+')
        ADVANCE(568);
      if (lookahead == '-')
        ADVANCE(569);
      if (lookahead == '/')
        ADVANCE(399);
      if (lookahead == '0')
        ADVANCE(71);
      if (lookahead == ':')
        ADVANCE(400);
      if (lookahead == ';')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(94);
      if (lookahead == 'N')
        ADVANCE(100);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '_')
        ADVANCE(112);
      if (lookahead == 'a')
        ADVANCE(119);
      if (lookahead == 'b')
        ADVANCE(123);
      if (lookahead == 'c')
        ADVANCE(131);
      if (lookahead == 'd')
        ADVANCE(162);
      if (lookahead == 'e')
        ADVANCE(177);
      if (lookahead == 'f')
        ADVANCE(577);
      if (lookahead == 'g')
        ADVANCE(208);
      if (lookahead == 'i')
        ADVANCE(212);
      if (lookahead == 'l')
        ADVANCE(219);
      if (lookahead == 'm')
        ADVANCE(223);
      if (lookahead == 'n')
        ADVANCE(573);
      if (lookahead == 'r')
        ADVANCE(292);
      if (lookahead == 's')
        ADVANCE(310);
      if (lookahead == 't')
        ADVANCE(578);
      if (lookahead == 'u')
        ADVANCE(456);
      if (lookahead == 'v')
        ADVANCE(375);
      if (lookahead == 'w')
        ADVANCE(384);
      if (lookahead == '{')
        ADVANCE(389);
      if (lookahead == '~')
        ADVANCE(394);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(667);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(79);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('h' <= lookahead && lookahead <= 'z'))
        ADVANCE(99);
      END_STATE();
    default:
      return false;
  }
}

static TSLexMode ts_lex_modes[STATE_COUNT] = {
  [0] = {.lex_state = 0, .external_lex_state = 1},
  [1] = {.lex_state = 395},
  [2] = {.lex_state = 415},
  [3] = {.lex_state = 420},
  [4] = {.lex_state = 424},
  [5] = {.lex_state = 431},
  [6] = {.lex_state = 420},
  [7] = {.lex_state = 420},
  [8] = {.lex_state = 440},
  [9] = {.lex_state = 443},
  [10] = {.lex_state = 457},
  [11] = {.lex_state = 424},
  [12] = {.lex_state = 457},
  [13] = {.lex_state = 457},
  [14] = {.lex_state = 420},
  [15] = {.lex_state = 420},
  [16] = {.lex_state = 420},
  [17] = {.lex_state = 424},
  [18] = {.lex_state = 420},
  [19] = {.lex_state = 459},
  [20] = {.lex_state = 420},
  [21] = {.lex_state = 468},
  [22] = {.lex_state = 457},
  [23] = {.lex_state = 420},
  [24] = {.lex_state = 473},
  [25] = {.lex_state = 424},
  [26] = {.lex_state = 0},
  [27] = {.lex_state = 424},
  [28] = {.lex_state = 0},
  [29] = {.lex_state = 476},
  [30] = {.lex_state = 459},
  [31] = {.lex_state = 395},
  [32] = {.lex_state = 459},
  [33] = {.lex_state = 420},
  [34] = {.lex_state = 459},
  [35] = {.lex_state = 0},
  [36] = {.lex_state = 395},
  [37] = {.lex_state = 457},
  [38] = {.lex_state = 482},
  [39] = {.lex_state = 395},
  [40] = {.lex_state = 440},
  [41] = {.lex_state = 424},
  [42] = {.lex_state = 424},
  [43] = {.lex_state = 420},
  [44] = {.lex_state = 424},
  [45] = {.lex_state = 420},
  [46] = {.lex_state = 0},
  [47] = {.lex_state = 420},
  [48] = {.lex_state = 485},
  [49] = {.lex_state = 485},
  [50] = {.lex_state = 485},
  [51] = {.lex_state = 431},
  [52] = {.lex_state = 395},
  [53] = {.lex_state = 443},
  [54] = {.lex_state = 420},
  [55] = {.lex_state = 420},
  [56] = {.lex_state = 420},
  [57] = {.lex_state = 420},
  [58] = {.lex_state = 420},
  [59] = {.lex_state = 468},
  [60] = {.lex_state = 420},
  [61] = {.lex_state = 420},
  [62] = {.lex_state = 420},
  [63] = {.lex_state = 420},
  [64] = {.lex_state = 0},
  [65] = {.lex_state = 443},
  [66] = {.lex_state = 476},
  [67] = {.lex_state = 486},
  [68] = {.lex_state = 0},
  [69] = {.lex_state = 420},
  [70] = {.lex_state = 459},
  [71] = {.lex_state = 459},
  [72] = {.lex_state = 487},
  [73] = {.lex_state = 499},
  [74] = {.lex_state = 459},
  [75] = {.lex_state = 420},
  [76] = {.lex_state = 459},
  [77] = {.lex_state = 459},
  [78] = {.lex_state = 0},
  [79] = {.lex_state = 459},
  [80] = {.lex_state = 459},
  [81] = {.lex_state = 0},
  [82] = {.lex_state = 459},
  [83] = {.lex_state = 459},
  [84] = {.lex_state = 0},
  [85] = {.lex_state = 476},
  [86] = {.lex_state = 443},
  [87] = {.lex_state = 424},
  [88] = {.lex_state = 459},
  [89] = {.lex_state = 459},
  [90] = {.lex_state = 459},
  [91] = {.lex_state = 0},
  [92] = {.lex_state = 459},
  [93] = {.lex_state = 459},
  [94] = {.lex_state = 459},
  [95] = {.lex_state = 486},
  [96] = {.lex_state = 424},
  [97] = {.lex_state = 486},
  [98] = {.lex_state = 424},
  [99] = {.lex_state = 486},
  [100] = {.lex_state = 459},
  [101] = {.lex_state = 468},
  [102] = {.lex_state = 424},
  [103] = {.lex_state = 424},
  [104] = {.lex_state = 0},
  [105] = {.lex_state = 459},
  [106] = {.lex_state = 486},
  [107] = {.lex_state = 459},
  [108] = {.lex_state = 0},
  [109] = {.lex_state = 486},
  [110] = {.lex_state = 482},
  [111] = {.lex_state = 395},
  [112] = {.lex_state = 0},
  [113] = {.lex_state = 395},
  [114] = {.lex_state = 420},
  [115] = {.lex_state = 420},
  [116] = {.lex_state = 424},
  [117] = {.lex_state = 0},
  [118] = {.lex_state = 0},
  [119] = {.lex_state = 459},
  [120] = {.lex_state = 501},
  [121] = {.lex_state = 395},
  [122] = {.lex_state = 424},
  [123] = {.lex_state = 420},
  [124] = {.lex_state = 424},
  [125] = {.lex_state = 420},
  [126] = {.lex_state = 0},
  [127] = {.lex_state = 420},
  [128] = {.lex_state = 420},
  [129] = {.lex_state = 486},
  [130] = {.lex_state = 565, .external_lex_state = 1},
  [131] = {.lex_state = 501},
  [132] = {.lex_state = 576, .external_lex_state = 1},
  [133] = {.lex_state = 420},
  [134] = {.lex_state = 395},
  [135] = {.lex_state = 0},
  [136] = {.lex_state = 459},
  [137] = {.lex_state = 459},
  [138] = {.lex_state = 459},
  [139] = {.lex_state = 424},
  [140] = {.lex_state = 501},
  [141] = {.lex_state = 459},
  [142] = {.lex_state = 395},
  [143] = {.lex_state = 476},
  [144] = {.lex_state = 459},
  [145] = {.lex_state = 457},
  [146] = {.lex_state = 459},
  [147] = {.lex_state = 459},
  [148] = {.lex_state = 482},
  [149] = {.lex_state = 431},
  [150] = {.lex_state = 395},
  [151] = {.lex_state = 420},
  [152] = {.lex_state = 579},
  [153] = {.lex_state = 420},
  [154] = {.lex_state = 420},
  [155] = {.lex_state = 424},
  [156] = {.lex_state = 420},
  [157] = {.lex_state = 420},
  [158] = {.lex_state = 476},
  [159] = {.lex_state = 501},
  [160] = {.lex_state = 424},
  [161] = {.lex_state = 415},
  [162] = {.lex_state = 420},
  [163] = {.lex_state = 431},
  [164] = {.lex_state = 395},
  [165] = {.lex_state = 420},
  [166] = {.lex_state = 420},
  [167] = {.lex_state = 581},
  [168] = {.lex_state = 431},
  [169] = {.lex_state = 440},
  [170] = {.lex_state = 443},
  [171] = {.lex_state = 457},
  [172] = {.lex_state = 457},
  [173] = {.lex_state = 420},
  [174] = {.lex_state = 473},
  [175] = {.lex_state = 424},
  [176] = {.lex_state = 424},
  [177] = {.lex_state = 476},
  [178] = {.lex_state = 485},
  [179] = {.lex_state = 485},
  [180] = {.lex_state = 457},
  [181] = {.lex_state = 395},
  [182] = {.lex_state = 424},
  [183] = {.lex_state = 485},
  [184] = {.lex_state = 395},
  [185] = {.lex_state = 424},
  [186] = {.lex_state = 485},
  [187] = {.lex_state = 584},
  [188] = {.lex_state = 420},
  [189] = {.lex_state = 420},
  [190] = {.lex_state = 420},
  [191] = {.lex_state = 487},
  [192] = {.lex_state = 420},
  [193] = {.lex_state = 420},
  [194] = {.lex_state = 585},
  [195] = {.lex_state = 0},
  [196] = {.lex_state = 420},
  [197] = {.lex_state = 585},
  [198] = {.lex_state = 420},
  [199] = {.lex_state = 585},
  [200] = {.lex_state = 0},
  [201] = {.lex_state = 443},
  [202] = {.lex_state = 420},
  [203] = {.lex_state = 420},
  [204] = {.lex_state = 420},
  [205] = {.lex_state = 585},
  [206] = {.lex_state = 0},
  [207] = {.lex_state = 420},
  [208] = {.lex_state = 420},
  [209] = {.lex_state = 420},
  [210] = {.lex_state = 420},
  [211] = {.lex_state = 420},
  [212] = {.lex_state = 0},
  [213] = {.lex_state = 420},
  [214] = {.lex_state = 420},
  [215] = {.lex_state = 420},
  [216] = {.lex_state = 420},
  [217] = {.lex_state = 420},
  [218] = {.lex_state = 420},
  [219] = {.lex_state = 443},
  [220] = {.lex_state = 420},
  [221] = {.lex_state = 420},
  [222] = {.lex_state = 476},
  [223] = {.lex_state = 395},
  [224] = {.lex_state = 424},
  [225] = {.lex_state = 501},
  [226] = {.lex_state = 395},
  [227] = {.lex_state = 459},
  [228] = {.lex_state = 420},
  [229] = {.lex_state = 395},
  [230] = {.lex_state = 459},
  [231] = {.lex_state = 431},
  [232] = {.lex_state = 420},
  [233] = {.lex_state = 420},
  [234] = {.lex_state = 443},
  [235] = {.lex_state = 459},
  [236] = {.lex_state = 420},
  [237] = {.lex_state = 420},
  [238] = {.lex_state = 459},
  [239] = {.lex_state = 420},
  [240] = {.lex_state = 476},
  [241] = {.lex_state = 468},
  [242] = {.lex_state = 420},
  [243] = {.lex_state = 486},
  [244] = {.lex_state = 473},
  [245] = {.lex_state = 424},
  [246] = {.lex_state = 586},
  [247] = {.lex_state = 586},
  [248] = {.lex_state = 594},
  [249] = {.lex_state = 0},
  [250] = {.lex_state = 476},
  [251] = {.lex_state = 459},
  [252] = {.lex_state = 586},
  [253] = {.lex_state = 586},
  [254] = {.lex_state = 459},
  [255] = {.lex_state = 0},
  [256] = {.lex_state = 487},
  [257] = {.lex_state = 457},
  [258] = {.lex_state = 482},
  [259] = {.lex_state = 420},
  [260] = {.lex_state = 420},
  [261] = {.lex_state = 0},
  [262] = {.lex_state = 420},
  [263] = {.lex_state = 459},
  [264] = {.lex_state = 459},
  [265] = {.lex_state = 459},
  [266] = {.lex_state = 0},
  [267] = {.lex_state = 420},
  [268] = {.lex_state = 459},
  [269] = {.lex_state = 0},
  [270] = {.lex_state = 595, .external_lex_state = 1},
  [271] = {.lex_state = 420},
  [272] = {.lex_state = 420},
  [273] = {.lex_state = 459},
  [274] = {.lex_state = 420},
  [275] = {.lex_state = 420},
  [276] = {.lex_state = 468},
  [277] = {.lex_state = 420},
  [278] = {.lex_state = 420},
  [279] = {.lex_state = 443},
  [280] = {.lex_state = 476},
  [281] = {.lex_state = 459},
  [282] = {.lex_state = 501},
  [283] = {.lex_state = 459},
  [284] = {.lex_state = 0},
  [285] = {.lex_state = 0},
  [286] = {.lex_state = 0},
  [287] = {.lex_state = 486},
  [288] = {.lex_state = 468},
  [289] = {.lex_state = 594},
  [290] = {.lex_state = 459},
  [291] = {.lex_state = 420},
  [292] = {.lex_state = 486},
  [293] = {.lex_state = 482},
  [294] = {.lex_state = 424},
  [295] = {.lex_state = 459},
  [296] = {.lex_state = 459},
  [297] = {.lex_state = 0},
  [298] = {.lex_state = 395},
  [299] = {.lex_state = 501},
  [300] = {.lex_state = 459},
  [301] = {.lex_state = 468},
  [302] = {.lex_state = 395},
  [303] = {.lex_state = 424},
  [304] = {.lex_state = 459},
  [305] = {.lex_state = 486},
  [306] = {.lex_state = 482},
  [307] = {.lex_state = 424},
  [308] = {.lex_state = 459},
  [309] = {.lex_state = 486},
  [310] = {.lex_state = 482},
  [311] = {.lex_state = 395},
  [312] = {.lex_state = 395},
  [313] = {.lex_state = 395},
  [314] = {.lex_state = 395},
  [315] = {.lex_state = 443},
  [316] = {.lex_state = 424},
  [317] = {.lex_state = 420},
  [318] = {.lex_state = 0},
  [319] = {.lex_state = 420},
  [320] = {.lex_state = 424},
  [321] = {.lex_state = 424},
  [322] = {.lex_state = 420},
  [323] = {.lex_state = 420},
  [324] = {.lex_state = 420},
  [325] = {.lex_state = 420},
  [326] = {.lex_state = 603, .external_lex_state = 1},
  [327] = {.lex_state = 424},
  [328] = {.lex_state = 395},
  [329] = {.lex_state = 604, .external_lex_state = 1},
  [330] = {.lex_state = 605, .external_lex_state = 1},
  [331] = {.lex_state = 395},
  [332] = {.lex_state = 501},
  [333] = {.lex_state = 420},
  [334] = {.lex_state = 0},
  [335] = {.lex_state = 606, .external_lex_state = 1},
  [336] = {.lex_state = 607, .external_lex_state = 1},
  [337] = {.lex_state = 605, .external_lex_state = 1},
  [338] = {.lex_state = 0},
  [339] = {.lex_state = 605, .external_lex_state = 1},
  [340] = {.lex_state = 0},
  [341] = {.lex_state = 420},
  [342] = {.lex_state = 608},
  [343] = {.lex_state = 468},
  [344] = {.lex_state = 594},
  [345] = {.lex_state = 459},
  [346] = {.lex_state = 486},
  [347] = {.lex_state = 482},
  [348] = {.lex_state = 612, .external_lex_state = 1},
  [349] = {.lex_state = 595, .external_lex_state = 1},
  [350] = {.lex_state = 614, .external_lex_state = 1},
  [351] = {.lex_state = 476},
  [352] = {.lex_state = 420},
  [353] = {.lex_state = 420},
  [354] = {.lex_state = 420},
  [355] = {.lex_state = 595, .external_lex_state = 1},
  [356] = {.lex_state = 595, .external_lex_state = 1},
  [357] = {.lex_state = 595, .external_lex_state = 1},
  [358] = {.lex_state = 595, .external_lex_state = 1},
  [359] = {.lex_state = 615},
  [360] = {.lex_state = 615, .external_lex_state = 1},
  [361] = {.lex_state = 420},
  [362] = {.lex_state = 468},
  [363] = {.lex_state = 420},
  [364] = {.lex_state = 617},
  [365] = {.lex_state = 595, .external_lex_state = 1},
  [366] = {.lex_state = 618, .external_lex_state = 1},
  [367] = {.lex_state = 619, .external_lex_state = 1},
  [368] = {.lex_state = 473},
  [369] = {.lex_state = 620, .external_lex_state = 1},
  [370] = {.lex_state = 395},
  [371] = {.lex_state = 473},
  [372] = {.lex_state = 621, .external_lex_state = 1},
  [373] = {.lex_state = 0},
  [374] = {.lex_state = 486},
  [375] = {.lex_state = 622, .external_lex_state = 1},
  [376] = {.lex_state = 608},
  [377] = {.lex_state = 468},
  [378] = {.lex_state = 501},
  [379] = {.lex_state = 415},
  [380] = {.lex_state = 420},
  [381] = {.lex_state = 612, .external_lex_state = 1},
  [382] = {.lex_state = 431},
  [383] = {.lex_state = 420},
  [384] = {.lex_state = 420},
  [385] = {.lex_state = 440},
  [386] = {.lex_state = 576, .external_lex_state = 1},
  [387] = {.lex_state = 443},
  [388] = {.lex_state = 576, .external_lex_state = 1},
  [389] = {.lex_state = 395},
  [390] = {.lex_state = 595, .external_lex_state = 1},
  [391] = {.lex_state = 0},
  [392] = {.lex_state = 0},
  [393] = {.lex_state = 595, .external_lex_state = 1},
  [394] = {.lex_state = 476},
  [395] = {.lex_state = 0},
  [396] = {.lex_state = 624, .external_lex_state = 1},
  [397] = {.lex_state = 0},
  [398] = {.lex_state = 636, .external_lex_state = 1},
  [399] = {.lex_state = 0},
  [400] = {.lex_state = 0},
  [401] = {.lex_state = 420},
  [402] = {.lex_state = 595, .external_lex_state = 1},
  [403] = {.lex_state = 595, .external_lex_state = 1},
  [404] = {.lex_state = 595, .external_lex_state = 1},
  [405] = {.lex_state = 595, .external_lex_state = 1},
  [406] = {.lex_state = 617},
  [407] = {.lex_state = 637},
  [408] = {.lex_state = 617},
  [409] = {.lex_state = 595, .external_lex_state = 1},
  [410] = {.lex_state = 576, .external_lex_state = 1},
  [411] = {.lex_state = 576, .external_lex_state = 1},
  [412] = {.lex_state = 424},
  [413] = {.lex_state = 473},
  [414] = {.lex_state = 0},
  [415] = {.lex_state = 459},
  [416] = {.lex_state = 459},
  [417] = {.lex_state = 0},
  [418] = {.lex_state = 576, .external_lex_state = 1},
  [419] = {.lex_state = 486},
  [420] = {.lex_state = 420},
  [421] = {.lex_state = 424},
  [422] = {.lex_state = 0},
  [423] = {.lex_state = 0},
  [424] = {.lex_state = 0},
  [425] = {.lex_state = 395},
  [426] = {.lex_state = 459},
  [427] = {.lex_state = 459},
  [428] = {.lex_state = 501},
  [429] = {.lex_state = 0},
  [430] = {.lex_state = 459},
  [431] = {.lex_state = 584},
  [432] = {.lex_state = 420},
  [433] = {.lex_state = 579},
  [434] = {.lex_state = 395},
  [435] = {.lex_state = 584},
  [436] = {.lex_state = 420},
  [437] = {.lex_state = 468},
  [438] = {.lex_state = 501},
  [439] = {.lex_state = 420},
  [440] = {.lex_state = 485},
  [441] = {.lex_state = 440},
  [442] = {.lex_state = 485},
  [443] = {.lex_state = 485},
  [444] = {.lex_state = 485},
  [445] = {.lex_state = 415},
  [446] = {.lex_state = 420},
  [447] = {.lex_state = 431},
  [448] = {.lex_state = 420},
  [449] = {.lex_state = 420},
  [450] = {.lex_state = 440},
  [451] = {.lex_state = 443},
  [452] = {.lex_state = 457},
  [453] = {.lex_state = 457},
  [454] = {.lex_state = 420},
  [455] = {.lex_state = 473},
  [456] = {.lex_state = 424},
  [457] = {.lex_state = 476},
  [458] = {.lex_state = 581},
  [459] = {.lex_state = 581},
  [460] = {.lex_state = 457},
  [461] = {.lex_state = 485},
  [462] = {.lex_state = 431},
  [463] = {.lex_state = 485},
  [464] = {.lex_state = 420},
  [465] = {.lex_state = 443},
  [466] = {.lex_state = 486},
  [467] = {.lex_state = 424},
  [468] = {.lex_state = 0},
  [469] = {.lex_state = 486},
  [470] = {.lex_state = 395},
  [471] = {.lex_state = 0},
  [472] = {.lex_state = 485},
  [473] = {.lex_state = 420},
  [474] = {.lex_state = 420},
  [475] = {.lex_state = 0},
  [476] = {.lex_state = 395},
  [477] = {.lex_state = 485},
  [478] = {.lex_state = 420},
  [479] = {.lex_state = 0},
  [480] = {.lex_state = 420},
  [481] = {.lex_state = 420},
  [482] = {.lex_state = 576, .external_lex_state = 1},
  [483] = {.lex_state = 485},
  [484] = {.lex_state = 0},
  [485] = {.lex_state = 424},
  [486] = {.lex_state = 485},
  [487] = {.lex_state = 476},
  [488] = {.lex_state = 395},
  [489] = {.lex_state = 424},
  [490] = {.lex_state = 395},
  [491] = {.lex_state = 424},
  [492] = {.lex_state = 395},
  [493] = {.lex_state = 395},
  [494] = {.lex_state = 420},
  [495] = {.lex_state = 395},
  [496] = {.lex_state = 420},
  [497] = {.lex_state = 420},
  [498] = {.lex_state = 487},
  [499] = {.lex_state = 420},
  [500] = {.lex_state = 0},
  [501] = {.lex_state = 420},
  [502] = {.lex_state = 0},
  [503] = {.lex_state = 420},
  [504] = {.lex_state = 420},
  [505] = {.lex_state = 420},
  [506] = {.lex_state = 420},
  [507] = {.lex_state = 0},
  [508] = {.lex_state = 420},
  [509] = {.lex_state = 420},
  [510] = {.lex_state = 420},
  [511] = {.lex_state = 395},
  [512] = {.lex_state = 565, .external_lex_state = 1},
  [513] = {.lex_state = 420},
  [514] = {.lex_state = 420},
  [515] = {.lex_state = 0},
  [516] = {.lex_state = 468},
  [517] = {.lex_state = 501},
  [518] = {.lex_state = 459},
  [519] = {.lex_state = 595, .external_lex_state = 1},
  [520] = {.lex_state = 420},
  [521] = {.lex_state = 395},
  [522] = {.lex_state = 638},
  [523] = {.lex_state = 638},
  [524] = {.lex_state = 638},
  [525] = {.lex_state = 420},
  [526] = {.lex_state = 443},
  [527] = {.lex_state = 459},
  [528] = {.lex_state = 459},
  [529] = {.lex_state = 424},
  [530] = {.lex_state = 459},
  [531] = {.lex_state = 459},
  [532] = {.lex_state = 586},
  [533] = {.lex_state = 486},
  [534] = {.lex_state = 586},
  [535] = {.lex_state = 424},
  [536] = {.lex_state = 459},
  [537] = {.lex_state = 420},
  [538] = {.lex_state = 420},
  [539] = {.lex_state = 0},
  [540] = {.lex_state = 459},
  [541] = {.lex_state = 424},
  [542] = {.lex_state = 586},
  [543] = {.lex_state = 424},
  [544] = {.lex_state = 595, .external_lex_state = 1},
  [545] = {.lex_state = 424},
  [546] = {.lex_state = 420},
  [547] = {.lex_state = 424},
  [548] = {.lex_state = 476},
  [549] = {.lex_state = 476},
  [550] = {.lex_state = 476},
  [551] = {.lex_state = 476},
  [552] = {.lex_state = 476},
  [553] = {.lex_state = 0},
  [554] = {.lex_state = 420},
  [555] = {.lex_state = 501},
  [556] = {.lex_state = 586},
  [557] = {.lex_state = 576, .external_lex_state = 1},
  [558] = {.lex_state = 586},
  [559] = {.lex_state = 0},
  [560] = {.lex_state = 459},
  [561] = {.lex_state = 424},
  [562] = {.lex_state = 459},
  [563] = {.lex_state = 487},
  [564] = {.lex_state = 476},
  [565] = {.lex_state = 459},
  [566] = {.lex_state = 482},
  [567] = {.lex_state = 0},
  [568] = {.lex_state = 499},
  [569] = {.lex_state = 0},
  [570] = {.lex_state = 459},
  [571] = {.lex_state = 459},
  [572] = {.lex_state = 459},
  [573] = {.lex_state = 459},
  [574] = {.lex_state = 612, .external_lex_state = 1},
  [575] = {.lex_state = 595, .external_lex_state = 1},
  [576] = {.lex_state = 595, .external_lex_state = 1},
  [577] = {.lex_state = 595, .external_lex_state = 1},
  [578] = {.lex_state = 595, .external_lex_state = 1},
  [579] = {.lex_state = 595, .external_lex_state = 1},
  [580] = {.lex_state = 617},
  [581] = {.lex_state = 473},
  [582] = {.lex_state = 617},
  [583] = {.lex_state = 595, .external_lex_state = 1},
  [584] = {.lex_state = 473},
  [585] = {.lex_state = 420},
  [586] = {.lex_state = 0},
  [587] = {.lex_state = 420},
  [588] = {.lex_state = 0},
  [589] = {.lex_state = 476},
  [590] = {.lex_state = 476},
  [591] = {.lex_state = 476},
  [592] = {.lex_state = 476},
  [593] = {.lex_state = 486},
  [594] = {.lex_state = 420},
  [595] = {.lex_state = 565, .external_lex_state = 1},
  [596] = {.lex_state = 420},
  [597] = {.lex_state = 420},
  [598] = {.lex_state = 608},
  [599] = {.lex_state = 443},
  [600] = {.lex_state = 459},
  [601] = {.lex_state = 420},
  [602] = {.lex_state = 420},
  [603] = {.lex_state = 476},
  [604] = {.lex_state = 459},
  [605] = {.lex_state = 459},
  [606] = {.lex_state = 468},
  [607] = {.lex_state = 457},
  [608] = {.lex_state = 594},
  [609] = {.lex_state = 594},
  [610] = {.lex_state = 420},
  [611] = {.lex_state = 424},
  [612] = {.lex_state = 420},
  [613] = {.lex_state = 420},
  [614] = {.lex_state = 420},
  [615] = {.lex_state = 0},
  [616] = {.lex_state = 420},
  [617] = {.lex_state = 459},
  [618] = {.lex_state = 486},
  [619] = {.lex_state = 486},
  [620] = {.lex_state = 420},
  [621] = {.lex_state = 459},
  [622] = {.lex_state = 482},
  [623] = {.lex_state = 459},
  [624] = {.lex_state = 395},
  [625] = {.lex_state = 468},
  [626] = {.lex_state = 501},
  [627] = {.lex_state = 459},
  [628] = {.lex_state = 459},
  [629] = {.lex_state = 459},
  [630] = {.lex_state = 482},
  [631] = {.lex_state = 459},
  [632] = {.lex_state = 459},
  [633] = {.lex_state = 395},
  [634] = {.lex_state = 395},
  [635] = {.lex_state = 468},
  [636] = {.lex_state = 395},
  [637] = {.lex_state = 0},
  [638] = {.lex_state = 443},
  [639] = {.lex_state = 476},
  [640] = {.lex_state = 420},
  [641] = {.lex_state = 395},
  [642] = {.lex_state = 420},
  [643] = {.lex_state = 420},
  [644] = {.lex_state = 420},
  [645] = {.lex_state = 420},
  [646] = {.lex_state = 608},
  [647] = {.lex_state = 637},
  [648] = {.lex_state = 617},
  [649] = {.lex_state = 473},
  [650] = {.lex_state = 420},
  [651] = {.lex_state = 459},
  [652] = {.lex_state = 0},
  [653] = {.lex_state = 420},
  [654] = {.lex_state = 0},
  [655] = {.lex_state = 612, .external_lex_state = 1},
  [656] = {.lex_state = 395},
  [657] = {.lex_state = 604, .external_lex_state = 1},
  [658] = {.lex_state = 395},
  [659] = {.lex_state = 595, .external_lex_state = 1},
  [660] = {.lex_state = 614, .external_lex_state = 1},
  [661] = {.lex_state = 595, .external_lex_state = 1},
  [662] = {.lex_state = 595, .external_lex_state = 1},
  [663] = {.lex_state = 595, .external_lex_state = 1},
  [664] = {.lex_state = 595, .external_lex_state = 1},
  [665] = {.lex_state = 420},
  [666] = {.lex_state = 617},
  [667] = {.lex_state = 617},
  [668] = {.lex_state = 595, .external_lex_state = 1},
  [669] = {.lex_state = 473},
  [670] = {.lex_state = 395},
  [671] = {.lex_state = 420},
  [672] = {.lex_state = 617},
  [673] = {.lex_state = 473},
  [674] = {.lex_state = 420},
  [675] = {.lex_state = 468},
  [676] = {.lex_state = 501},
  [677] = {.lex_state = 395},
  [678] = {.lex_state = 0},
  [679] = {.lex_state = 501},
  [680] = {.lex_state = 612, .external_lex_state = 1},
  [681] = {.lex_state = 501},
  [682] = {.lex_state = 595, .external_lex_state = 1},
  [683] = {.lex_state = 595, .external_lex_state = 1},
  [684] = {.lex_state = 595, .external_lex_state = 1},
  [685] = {.lex_state = 595, .external_lex_state = 1},
  [686] = {.lex_state = 595, .external_lex_state = 1},
  [687] = {.lex_state = 617},
  [688] = {.lex_state = 617},
  [689] = {.lex_state = 595, .external_lex_state = 1},
  [690] = {.lex_state = 473},
  [691] = {.lex_state = 612, .external_lex_state = 1},
  [692] = {.lex_state = 595, .external_lex_state = 1},
  [693] = {.lex_state = 595, .external_lex_state = 1},
  [694] = {.lex_state = 595, .external_lex_state = 1},
  [695] = {.lex_state = 595, .external_lex_state = 1},
  [696] = {.lex_state = 595, .external_lex_state = 1},
  [697] = {.lex_state = 617},
  [698] = {.lex_state = 617},
  [699] = {.lex_state = 595, .external_lex_state = 1},
  [700] = {.lex_state = 473},
  [701] = {.lex_state = 0},
  [702] = {.lex_state = 395},
  [703] = {.lex_state = 473},
  [704] = {.lex_state = 0},
  [705] = {.lex_state = 395},
  [706] = {.lex_state = 486},
  [707] = {.lex_state = 608},
  [708] = {.lex_state = 420},
  [709] = {.lex_state = 594},
  [710] = {.lex_state = 594},
  [711] = {.lex_state = 420},
  [712] = {.lex_state = 420},
  [713] = {.lex_state = 501},
  [714] = {.lex_state = 459},
  [715] = {.lex_state = 459},
  [716] = {.lex_state = 482},
  [717] = {.lex_state = 473},
  [718] = {.lex_state = 468},
  [719] = {.lex_state = 617},
  [720] = {.lex_state = 420},
  [721] = {.lex_state = 473},
  [722] = {.lex_state = 420},
  [723] = {.lex_state = 420},
  [724] = {.lex_state = 443},
  [725] = {.lex_state = 476},
  [726] = {.lex_state = 617},
  [727] = {.lex_state = 473},
  [728] = {.lex_state = 612, .external_lex_state = 1},
  [729] = {.lex_state = 595, .external_lex_state = 1},
  [730] = {.lex_state = 395},
  [731] = {.lex_state = 420},
  [732] = {.lex_state = 618, .external_lex_state = 1},
  [733] = {.lex_state = 595, .external_lex_state = 1},
  [734] = {.lex_state = 595, .external_lex_state = 1},
  [735] = {.lex_state = 595, .external_lex_state = 1},
  [736] = {.lex_state = 595, .external_lex_state = 1},
  [737] = {.lex_state = 639},
  [738] = {.lex_state = 617},
  [739] = {.lex_state = 595, .external_lex_state = 1},
  [740] = {.lex_state = 473},
  [741] = {.lex_state = 420},
  [742] = {.lex_state = 420},
  [743] = {.lex_state = 620, .external_lex_state = 1},
  [744] = {.lex_state = 619, .external_lex_state = 1},
  [745] = {.lex_state = 487},
  [746] = {.lex_state = 640, .external_lex_state = 1},
  [747] = {.lex_state = 420},
  [748] = {.lex_state = 619, .external_lex_state = 1},
  [749] = {.lex_state = 641, .external_lex_state = 1},
  [750] = {.lex_state = 0},
  [751] = {.lex_state = 641, .external_lex_state = 1},
  [752] = {.lex_state = 640, .external_lex_state = 1},
  [753] = {.lex_state = 0},
  [754] = {.lex_state = 619, .external_lex_state = 1},
  [755] = {.lex_state = 641, .external_lex_state = 1},
  [756] = {.lex_state = 0},
  [757] = {.lex_state = 473},
  [758] = {.lex_state = 473},
  [759] = {.lex_state = 473},
  [760] = {.lex_state = 612, .external_lex_state = 1},
  [761] = {.lex_state = 473},
  [762] = {.lex_state = 615},
  [763] = {.lex_state = 443},
  [764] = {.lex_state = 424},
  [765] = {.lex_state = 501},
  [766] = {.lex_state = 615, .external_lex_state = 1},
  [767] = {.lex_state = 619, .external_lex_state = 1},
  [768] = {.lex_state = 641, .external_lex_state = 1},
  [769] = {.lex_state = 0},
  [770] = {.lex_state = 642, .external_lex_state = 1},
  [771] = {.lex_state = 619, .external_lex_state = 1},
  [772] = {.lex_state = 619, .external_lex_state = 1},
  [773] = {.lex_state = 642, .external_lex_state = 1},
  [774] = {.lex_state = 420},
  [775] = {.lex_state = 420},
  [776] = {.lex_state = 420},
  [777] = {.lex_state = 420},
  [778] = {.lex_state = 615, .external_lex_state = 1},
  [779] = {.lex_state = 595, .external_lex_state = 1},
  [780] = {.lex_state = 614, .external_lex_state = 1},
  [781] = {.lex_state = 473},
  [782] = {.lex_state = 476},
  [783] = {.lex_state = 473},
  [784] = {.lex_state = 619, .external_lex_state = 1},
  [785] = {.lex_state = 619, .external_lex_state = 1},
  [786] = {.lex_state = 619, .external_lex_state = 1},
  [787] = {.lex_state = 595, .external_lex_state = 1},
  [788] = {.lex_state = 595, .external_lex_state = 1},
  [789] = {.lex_state = 595, .external_lex_state = 1},
  [790] = {.lex_state = 595, .external_lex_state = 1},
  [791] = {.lex_state = 595, .external_lex_state = 1},
  [792] = {.lex_state = 595, .external_lex_state = 1},
  [793] = {.lex_state = 595, .external_lex_state = 1},
  [794] = {.lex_state = 595, .external_lex_state = 1},
  [795] = {.lex_state = 595, .external_lex_state = 1},
  [796] = {.lex_state = 595, .external_lex_state = 1},
  [797] = {.lex_state = 595, .external_lex_state = 1},
  [798] = {.lex_state = 595, .external_lex_state = 1},
  [799] = {.lex_state = 595, .external_lex_state = 1},
  [800] = {.lex_state = 501},
  [801] = {.lex_state = 420},
  [802] = {.lex_state = 501},
  [803] = {.lex_state = 424},
  [804] = {.lex_state = 501},
  [805] = {.lex_state = 395},
  [806] = {.lex_state = 395},
  [807] = {.lex_state = 0},
  [808] = {.lex_state = 0},
  [809] = {.lex_state = 501},
  [810] = {.lex_state = 443},
  [811] = {.lex_state = 443},
  [812] = {.lex_state = 641, .external_lex_state = 1},
  [813] = {.lex_state = 619, .external_lex_state = 1},
  [814] = {.lex_state = 619, .external_lex_state = 1},
  [815] = {.lex_state = 619, .external_lex_state = 1},
  [816] = {.lex_state = 622, .external_lex_state = 1},
  [817] = {.lex_state = 420},
  [818] = {.lex_state = 420},
  [819] = {.lex_state = 420},
  [820] = {.lex_state = 643},
  [821] = {.lex_state = 420},
  [822] = {.lex_state = 468},
  [823] = {.lex_state = 420},
  [824] = {.lex_state = 608},
  [825] = {.lex_state = 643},
  [826] = {.lex_state = 608},
  [827] = {.lex_state = 0},
  [828] = {.lex_state = 608},
  [829] = {.lex_state = 501},
  [830] = {.lex_state = 576, .external_lex_state = 1},
  [831] = {.lex_state = 440},
  [832] = {.lex_state = 420},
  [833] = {.lex_state = 645, .external_lex_state = 1},
  [834] = {.lex_state = 645, .external_lex_state = 1},
  [835] = {.lex_state = 645, .external_lex_state = 1},
  [836] = {.lex_state = 431},
  [837] = {.lex_state = 576, .external_lex_state = 1},
  [838] = {.lex_state = 420},
  [839] = {.lex_state = 443},
  [840] = {.lex_state = 576, .external_lex_state = 1},
  [841] = {.lex_state = 576, .external_lex_state = 1},
  [842] = {.lex_state = 595, .external_lex_state = 1},
  [843] = {.lex_state = 0},
  [844] = {.lex_state = 595, .external_lex_state = 1},
  [845] = {.lex_state = 612, .external_lex_state = 1},
  [846] = {.lex_state = 595, .external_lex_state = 1},
  [847] = {.lex_state = 595, .external_lex_state = 1},
  [848] = {.lex_state = 595, .external_lex_state = 1},
  [849] = {.lex_state = 595, .external_lex_state = 1},
  [850] = {.lex_state = 595, .external_lex_state = 1},
  [851] = {.lex_state = 617},
  [852] = {.lex_state = 617},
  [853] = {.lex_state = 595, .external_lex_state = 1},
  [854] = {.lex_state = 501},
  [855] = {.lex_state = 501},
  [856] = {.lex_state = 646, .external_lex_state = 1},
  [857] = {.lex_state = 595, .external_lex_state = 1},
  [858] = {.lex_state = 501},
  [859] = {.lex_state = 576, .external_lex_state = 1},
  [860] = {.lex_state = 0},
  [861] = {.lex_state = 0},
  [862] = {.lex_state = 595, .external_lex_state = 1},
  [863] = {.lex_state = 476},
  [864] = {.lex_state = 0},
  [865] = {.lex_state = 624, .external_lex_state = 1},
  [866] = {.lex_state = 0},
  [867] = {.lex_state = 636, .external_lex_state = 1},
  [868] = {.lex_state = 0},
  [869] = {.lex_state = 0},
  [870] = {.lex_state = 420},
  [871] = {.lex_state = 473},
  [872] = {.lex_state = 501},
  [873] = {.lex_state = 473},
  [874] = {.lex_state = 0},
  [875] = {.lex_state = 647, .external_lex_state = 1},
  [876] = {.lex_state = 576, .external_lex_state = 1},
  [877] = {.lex_state = 473},
  [878] = {.lex_state = 0},
  [879] = {.lex_state = 576, .external_lex_state = 1},
  [880] = {.lex_state = 576, .external_lex_state = 1},
  [881] = {.lex_state = 0},
  [882] = {.lex_state = 612, .external_lex_state = 1},
  [883] = {.lex_state = 473},
  [884] = {.lex_state = 617},
  [885] = {.lex_state = 624, .external_lex_state = 1},
  [886] = {.lex_state = 424},
  [887] = {.lex_state = 637},
  [888] = {.lex_state = 637},
  [889] = {.lex_state = 595, .external_lex_state = 1},
  [890] = {.lex_state = 614, .external_lex_state = 1},
  [891] = {.lex_state = 473},
  [892] = {.lex_state = 576, .external_lex_state = 1},
  [893] = {.lex_state = 420},
  [894] = {.lex_state = 0},
  [895] = {.lex_state = 420},
  [896] = {.lex_state = 420},
  [897] = {.lex_state = 595, .external_lex_state = 1},
  [898] = {.lex_state = 576, .external_lex_state = 1},
  [899] = {.lex_state = 595, .external_lex_state = 1},
  [900] = {.lex_state = 595, .external_lex_state = 1},
  [901] = {.lex_state = 595, .external_lex_state = 1},
  [902] = {.lex_state = 595, .external_lex_state = 1},
  [903] = {.lex_state = 595, .external_lex_state = 1},
  [904] = {.lex_state = 595, .external_lex_state = 1},
  [905] = {.lex_state = 595, .external_lex_state = 1},
  [906] = {.lex_state = 595, .external_lex_state = 1},
  [907] = {.lex_state = 595, .external_lex_state = 1},
  [908] = {.lex_state = 595, .external_lex_state = 1},
  [909] = {.lex_state = 595, .external_lex_state = 1},
  [910] = {.lex_state = 595, .external_lex_state = 1},
  [911] = {.lex_state = 424},
  [912] = {.lex_state = 395},
  [913] = {.lex_state = 576, .external_lex_state = 1},
  [914] = {.lex_state = 424},
  [915] = {.lex_state = 0},
  [916] = {.lex_state = 420},
  [917] = {.lex_state = 420},
  [918] = {.lex_state = 420},
  [919] = {.lex_state = 0},
  [920] = {.lex_state = 424},
  [921] = {.lex_state = 0},
  [922] = {.lex_state = 395},
  [923] = {.lex_state = 395},
  [924] = {.lex_state = 420},
  [925] = {.lex_state = 579},
  [926] = {.lex_state = 420},
  [927] = {.lex_state = 395},
  [928] = {.lex_state = 420},
  [929] = {.lex_state = 420},
  [930] = {.lex_state = 420},
  [931] = {.lex_state = 420},
  [932] = {.lex_state = 468},
  [933] = {.lex_state = 608},
  [934] = {.lex_state = 608},
  [935] = {.lex_state = 501},
  [936] = {.lex_state = 431},
  [937] = {.lex_state = 485},
  [938] = {.lex_state = 579},
  [939] = {.lex_state = 485},
  [940] = {.lex_state = 424},
  [941] = {.lex_state = 485},
  [942] = {.lex_state = 485},
  [943] = {.lex_state = 424},
  [944] = {.lex_state = 485},
  [945] = {.lex_state = 485},
  [946] = {.lex_state = 424},
  [947] = {.lex_state = 485},
  [948] = {.lex_state = 581},
  [949] = {.lex_state = 440},
  [950] = {.lex_state = 485},
  [951] = {.lex_state = 485},
  [952] = {.lex_state = 485},
  [953] = {.lex_state = 431},
  [954] = {.lex_state = 581},
  [955] = {.lex_state = 420},
  [956] = {.lex_state = 443},
  [957] = {.lex_state = 486},
  [958] = {.lex_state = 424},
  [959] = {.lex_state = 0},
  [960] = {.lex_state = 486},
  [961] = {.lex_state = 395},
  [962] = {.lex_state = 0},
  [963] = {.lex_state = 581},
  [964] = {.lex_state = 420},
  [965] = {.lex_state = 420},
  [966] = {.lex_state = 0},
  [967] = {.lex_state = 581},
  [968] = {.lex_state = 420},
  [969] = {.lex_state = 0},
  [970] = {.lex_state = 420},
  [971] = {.lex_state = 420},
  [972] = {.lex_state = 576, .external_lex_state = 1},
  [973] = {.lex_state = 581},
  [974] = {.lex_state = 0},
  [975] = {.lex_state = 581},
  [976] = {.lex_state = 476},
  [977] = {.lex_state = 424},
  [978] = {.lex_state = 485},
  [979] = {.lex_state = 584},
  [980] = {.lex_state = 0},
  [981] = {.lex_state = 420},
  [982] = {.lex_state = 485},
  [983] = {.lex_state = 424},
  [984] = {.lex_state = 0},
  [985] = {.lex_state = 485},
  [986] = {.lex_state = 485},
  [987] = {.lex_state = 424},
  [988] = {.lex_state = 485},
  [989] = {.lex_state = 395},
  [990] = {.lex_state = 485},
  [991] = {.lex_state = 485},
  [992] = {.lex_state = 443},
  [993] = {.lex_state = 420},
  [994] = {.lex_state = 0},
  [995] = {.lex_state = 485},
  [996] = {.lex_state = 604, .external_lex_state = 1},
  [997] = {.lex_state = 485},
  [998] = {.lex_state = 0},
  [999] = {.lex_state = 605, .external_lex_state = 1},
  [1000] = {.lex_state = 0},
  [1001] = {.lex_state = 605, .external_lex_state = 1},
  [1002] = {.lex_state = 0},
  [1003] = {.lex_state = 485},
  [1004] = {.lex_state = 576, .external_lex_state = 1},
  [1005] = {.lex_state = 485},
  [1006] = {.lex_state = 395},
  [1007] = {.lex_state = 0},
  [1008] = {.lex_state = 395},
  [1009] = {.lex_state = 395},
  [1010] = {.lex_state = 420},
  [1011] = {.lex_state = 420},
  [1012] = {.lex_state = 395},
  [1013] = {.lex_state = 420},
  [1014] = {.lex_state = 420},
  [1015] = {.lex_state = 420},
  [1016] = {.lex_state = 420},
  [1017] = {.lex_state = 420},
  [1018] = {.lex_state = 420},
  [1019] = {.lex_state = 420},
  [1020] = {.lex_state = 420},
  [1021] = {.lex_state = 618, .external_lex_state = 1},
  [1022] = {.lex_state = 473},
  [1023] = {.lex_state = 395},
  [1024] = {.lex_state = 468},
  [1025] = {.lex_state = 608},
  [1026] = {.lex_state = 608},
  [1027] = {.lex_state = 501},
  [1028] = {.lex_state = 473},
  [1029] = {.lex_state = 459},
  [1030] = {.lex_state = 395},
  [1031] = {.lex_state = 420},
  [1032] = {.lex_state = 395},
  [1033] = {.lex_state = 586},
  [1034] = {.lex_state = 638},
  [1035] = {.lex_state = 431},
  [1036] = {.lex_state = 424},
  [1037] = {.lex_state = 424},
  [1038] = {.lex_state = 638},
  [1039] = {.lex_state = 586},
  [1040] = {.lex_state = 424},
  [1041] = {.lex_state = 424},
  [1042] = {.lex_state = 638},
  [1043] = {.lex_state = 586},
  [1044] = {.lex_state = 424},
  [1045] = {.lex_state = 424},
  [1046] = {.lex_state = 638},
  [1047] = {.lex_state = 0},
  [1048] = {.lex_state = 420},
  [1049] = {.lex_state = 459},
  [1050] = {.lex_state = 586},
  [1051] = {.lex_state = 424},
  [1052] = {.lex_state = 420},
  [1053] = {.lex_state = 0},
  [1054] = {.lex_state = 586},
  [1055] = {.lex_state = 586},
  [1056] = {.lex_state = 443},
  [1057] = {.lex_state = 420},
  [1058] = {.lex_state = 0},
  [1059] = {.lex_state = 424},
  [1060] = {.lex_state = 424},
  [1061] = {.lex_state = 420},
  [1062] = {.lex_state = 420},
  [1063] = {.lex_state = 476},
  [1064] = {.lex_state = 473},
  [1065] = {.lex_state = 476},
  [1066] = {.lex_state = 424},
  [1067] = {.lex_state = 473},
  [1068] = {.lex_state = 420},
  [1069] = {.lex_state = 424},
  [1070] = {.lex_state = 586},
  [1071] = {.lex_state = 565, .external_lex_state = 1},
  [1072] = {.lex_state = 595, .external_lex_state = 1},
  [1073] = {.lex_state = 586},
  [1074] = {.lex_state = 501},
  [1075] = {.lex_state = 476},
  [1076] = {.lex_state = 424},
  [1077] = {.lex_state = 443},
  [1078] = {.lex_state = 501},
  [1079] = {.lex_state = 468},
  [1080] = {.lex_state = 501},
  [1081] = {.lex_state = 586},
  [1082] = {.lex_state = 576, .external_lex_state = 1},
  [1083] = {.lex_state = 586},
  [1084] = {.lex_state = 459},
  [1085] = {.lex_state = 459},
  [1086] = {.lex_state = 0},
  [1087] = {.lex_state = 459},
  [1088] = {.lex_state = 0},
  [1089] = {.lex_state = 420},
  [1090] = {.lex_state = 0},
  [1091] = {.lex_state = 0},
  [1092] = {.lex_state = 420},
  [1093] = {.lex_state = 612, .external_lex_state = 1},
  [1094] = {.lex_state = 473},
  [1095] = {.lex_state = 617},
  [1096] = {.lex_state = 424},
  [1097] = {.lex_state = 473},
  [1098] = {.lex_state = 473},
  [1099] = {.lex_state = 595, .external_lex_state = 1},
  [1100] = {.lex_state = 614, .external_lex_state = 1},
  [1101] = {.lex_state = 473},
  [1102] = {.lex_state = 595, .external_lex_state = 1},
  [1103] = {.lex_state = 420},
  [1104] = {.lex_state = 595, .external_lex_state = 1},
  [1105] = {.lex_state = 595, .external_lex_state = 1},
  [1106] = {.lex_state = 595, .external_lex_state = 1},
  [1107] = {.lex_state = 595, .external_lex_state = 1},
  [1108] = {.lex_state = 595, .external_lex_state = 1},
  [1109] = {.lex_state = 595, .external_lex_state = 1},
  [1110] = {.lex_state = 595, .external_lex_state = 1},
  [1111] = {.lex_state = 595, .external_lex_state = 1},
  [1112] = {.lex_state = 595, .external_lex_state = 1},
  [1113] = {.lex_state = 595, .external_lex_state = 1},
  [1114] = {.lex_state = 595, .external_lex_state = 1},
  [1115] = {.lex_state = 595, .external_lex_state = 1},
  [1116] = {.lex_state = 424},
  [1117] = {.lex_state = 420},
  [1118] = {.lex_state = 420},
  [1119] = {.lex_state = 420},
  [1120] = {.lex_state = 501},
  [1121] = {.lex_state = 420},
  [1122] = {.lex_state = 608},
  [1123] = {.lex_state = 618, .external_lex_state = 1},
  [1124] = {.lex_state = 473},
  [1125] = {.lex_state = 420},
  [1126] = {.lex_state = 565, .external_lex_state = 1},
  [1127] = {.lex_state = 608},
  [1128] = {.lex_state = 468},
  [1129] = {.lex_state = 608},
  [1130] = {.lex_state = 608},
  [1131] = {.lex_state = 420},
  [1132] = {.lex_state = 459},
  [1133] = {.lex_state = 420},
  [1134] = {.lex_state = 420},
  [1135] = {.lex_state = 468},
  [1136] = {.lex_state = 594},
  [1137] = {.lex_state = 594},
  [1138] = {.lex_state = 420},
  [1139] = {.lex_state = 420},
  [1140] = {.lex_state = 424},
  [1141] = {.lex_state = 420},
  [1142] = {.lex_state = 603, .external_lex_state = 1},
  [1143] = {.lex_state = 607, .external_lex_state = 1},
  [1144] = {.lex_state = 605, .external_lex_state = 1},
  [1145] = {.lex_state = 608},
  [1146] = {.lex_state = 424},
  [1147] = {.lex_state = 420},
  [1148] = {.lex_state = 459},
  [1149] = {.lex_state = 420},
  [1150] = {.lex_state = 486},
  [1151] = {.lex_state = 420},
  [1152] = {.lex_state = 459},
  [1153] = {.lex_state = 468},
  [1154] = {.lex_state = 608},
  [1155] = {.lex_state = 608},
  [1156] = {.lex_state = 501},
  [1157] = {.lex_state = 459},
  [1158] = {.lex_state = 459},
  [1159] = {.lex_state = 395},
  [1160] = {.lex_state = 395},
  [1161] = {.lex_state = 0},
  [1162] = {.lex_state = 501},
  [1163] = {.lex_state = 395},
  [1164] = {.lex_state = 395},
  [1165] = {.lex_state = 476},
  [1166] = {.lex_state = 420},
  [1167] = {.lex_state = 420},
  [1168] = {.lex_state = 420},
  [1169] = {.lex_state = 424},
  [1170] = {.lex_state = 637},
  [1171] = {.lex_state = 637},
  [1172] = {.lex_state = 605, .external_lex_state = 1},
  [1173] = {.lex_state = 501},
  [1174] = {.lex_state = 420},
  [1175] = {.lex_state = 424},
  [1176] = {.lex_state = 420},
  [1177] = {.lex_state = 501},
  [1178] = {.lex_state = 648, .external_lex_state = 1},
  [1179] = {.lex_state = 617},
  [1180] = {.lex_state = 473},
  [1181] = {.lex_state = 612, .external_lex_state = 1},
  [1182] = {.lex_state = 473},
  [1183] = {.lex_state = 420},
  [1184] = {.lex_state = 617},
  [1185] = {.lex_state = 595, .external_lex_state = 1},
  [1186] = {.lex_state = 614, .external_lex_state = 1},
  [1187] = {.lex_state = 473},
  [1188] = {.lex_state = 649, .external_lex_state = 1},
  [1189] = {.lex_state = 595, .external_lex_state = 1},
  [1190] = {.lex_state = 595, .external_lex_state = 1},
  [1191] = {.lex_state = 595, .external_lex_state = 1},
  [1192] = {.lex_state = 595, .external_lex_state = 1},
  [1193] = {.lex_state = 595, .external_lex_state = 1},
  [1194] = {.lex_state = 595, .external_lex_state = 1},
  [1195] = {.lex_state = 595, .external_lex_state = 1},
  [1196] = {.lex_state = 595, .external_lex_state = 1},
  [1197] = {.lex_state = 595, .external_lex_state = 1},
  [1198] = {.lex_state = 595, .external_lex_state = 1},
  [1199] = {.lex_state = 595, .external_lex_state = 1},
  [1200] = {.lex_state = 595, .external_lex_state = 1},
  [1201] = {.lex_state = 395},
  [1202] = {.lex_state = 649, .external_lex_state = 1},
  [1203] = {.lex_state = 595, .external_lex_state = 1},
  [1204] = {.lex_state = 605, .external_lex_state = 1},
  [1205] = {.lex_state = 420},
  [1206] = {.lex_state = 420},
  [1207] = {.lex_state = 420},
  [1208] = {.lex_state = 420},
  [1209] = {.lex_state = 468},
  [1210] = {.lex_state = 608},
  [1211] = {.lex_state = 608},
  [1212] = {.lex_state = 501},
  [1213] = {.lex_state = 420},
  [1214] = {.lex_state = 612, .external_lex_state = 1},
  [1215] = {.lex_state = 473},
  [1216] = {.lex_state = 617},
  [1217] = {.lex_state = 595, .external_lex_state = 1},
  [1218] = {.lex_state = 614, .external_lex_state = 1},
  [1219] = {.lex_state = 473},
  [1220] = {.lex_state = 595, .external_lex_state = 1},
  [1221] = {.lex_state = 595, .external_lex_state = 1},
  [1222] = {.lex_state = 595, .external_lex_state = 1},
  [1223] = {.lex_state = 595, .external_lex_state = 1},
  [1224] = {.lex_state = 595, .external_lex_state = 1},
  [1225] = {.lex_state = 595, .external_lex_state = 1},
  [1226] = {.lex_state = 595, .external_lex_state = 1},
  [1227] = {.lex_state = 595, .external_lex_state = 1},
  [1228] = {.lex_state = 595, .external_lex_state = 1},
  [1229] = {.lex_state = 595, .external_lex_state = 1},
  [1230] = {.lex_state = 595, .external_lex_state = 1},
  [1231] = {.lex_state = 595, .external_lex_state = 1},
  [1232] = {.lex_state = 420},
  [1233] = {.lex_state = 612, .external_lex_state = 1},
  [1234] = {.lex_state = 473},
  [1235] = {.lex_state = 617},
  [1236] = {.lex_state = 595, .external_lex_state = 1},
  [1237] = {.lex_state = 614, .external_lex_state = 1},
  [1238] = {.lex_state = 473},
  [1239] = {.lex_state = 395},
  [1240] = {.lex_state = 595, .external_lex_state = 1},
  [1241] = {.lex_state = 595, .external_lex_state = 1},
  [1242] = {.lex_state = 595, .external_lex_state = 1},
  [1243] = {.lex_state = 595, .external_lex_state = 1},
  [1244] = {.lex_state = 595, .external_lex_state = 1},
  [1245] = {.lex_state = 595, .external_lex_state = 1},
  [1246] = {.lex_state = 595, .external_lex_state = 1},
  [1247] = {.lex_state = 595, .external_lex_state = 1},
  [1248] = {.lex_state = 595, .external_lex_state = 1},
  [1249] = {.lex_state = 595, .external_lex_state = 1},
  [1250] = {.lex_state = 595, .external_lex_state = 1},
  [1251] = {.lex_state = 595, .external_lex_state = 1},
  [1252] = {.lex_state = 395},
  [1253] = {.lex_state = 420},
  [1254] = {.lex_state = 608},
  [1255] = {.lex_state = 420},
  [1256] = {.lex_state = 420},
  [1257] = {.lex_state = 420},
  [1258] = {.lex_state = 420},
  [1259] = {.lex_state = 420},
  [1260] = {.lex_state = 605, .external_lex_state = 1},
  [1261] = {.lex_state = 501},
  [1262] = {.lex_state = 501},
  [1263] = {.lex_state = 468},
  [1264] = {.lex_state = 501},
  [1265] = {.lex_state = 459},
  [1266] = {.lex_state = 459},
  [1267] = {.lex_state = 420},
  [1268] = {.lex_state = 501},
  [1269] = {.lex_state = 605, .external_lex_state = 1},
  [1270] = {.lex_state = 420},
  [1271] = {.lex_state = 476},
  [1272] = {.lex_state = 420},
  [1273] = {.lex_state = 612, .external_lex_state = 1},
  [1274] = {.lex_state = 473},
  [1275] = {.lex_state = 639},
  [1276] = {.lex_state = 595, .external_lex_state = 1},
  [1277] = {.lex_state = 614, .external_lex_state = 1},
  [1278] = {.lex_state = 473},
  [1279] = {.lex_state = 595, .external_lex_state = 1},
  [1280] = {.lex_state = 595, .external_lex_state = 1},
  [1281] = {.lex_state = 395},
  [1282] = {.lex_state = 595, .external_lex_state = 1},
  [1283] = {.lex_state = 595, .external_lex_state = 1},
  [1284] = {.lex_state = 595, .external_lex_state = 1},
  [1285] = {.lex_state = 595, .external_lex_state = 1},
  [1286] = {.lex_state = 595, .external_lex_state = 1},
  [1287] = {.lex_state = 595, .external_lex_state = 1},
  [1288] = {.lex_state = 595, .external_lex_state = 1},
  [1289] = {.lex_state = 595, .external_lex_state = 1},
  [1290] = {.lex_state = 595, .external_lex_state = 1},
  [1291] = {.lex_state = 595, .external_lex_state = 1},
  [1292] = {.lex_state = 595, .external_lex_state = 1},
  [1293] = {.lex_state = 420},
  [1294] = {.lex_state = 395},
  [1295] = {.lex_state = 619, .external_lex_state = 1},
  [1296] = {.lex_state = 395},
  [1297] = {.lex_state = 619, .external_lex_state = 1},
  [1298] = {.lex_state = 619, .external_lex_state = 1},
  [1299] = {.lex_state = 487},
  [1300] = {.lex_state = 420},
  [1301] = {.lex_state = 641, .external_lex_state = 1},
  [1302] = {.lex_state = 640, .external_lex_state = 1},
  [1303] = {.lex_state = 619, .external_lex_state = 1},
  [1304] = {.lex_state = 0},
  [1305] = {.lex_state = 420},
  [1306] = {.lex_state = 619, .external_lex_state = 1},
  [1307] = {.lex_state = 0},
  [1308] = {.lex_state = 420},
  [1309] = {.lex_state = 615},
  [1310] = {.lex_state = 615, .external_lex_state = 1},
  [1311] = {.lex_state = 420},
  [1312] = {.lex_state = 615, .external_lex_state = 1},
  [1313] = {.lex_state = 619, .external_lex_state = 1},
  [1314] = {.lex_state = 0},
  [1315] = {.lex_state = 595, .external_lex_state = 1},
  [1316] = {.lex_state = 501},
  [1317] = {.lex_state = 0},
  [1318] = {.lex_state = 420},
  [1319] = {.lex_state = 420},
  [1320] = {.lex_state = 501},
  [1321] = {.lex_state = 0},
  [1322] = {.lex_state = 501},
  [1323] = {.lex_state = 614, .external_lex_state = 1},
  [1324] = {.lex_state = 473},
  [1325] = {.lex_state = 650, .external_lex_state = 1},
  [1326] = {.lex_state = 476},
  [1327] = {.lex_state = 619, .external_lex_state = 1},
  [1328] = {.lex_state = 473},
  [1329] = {.lex_state = 473},
  [1330] = {.lex_state = 473},
  [1331] = {.lex_state = 501},
  [1332] = {.lex_state = 473},
  [1333] = {.lex_state = 473},
  [1334] = {.lex_state = 473},
  [1335] = {.lex_state = 473},
  [1336] = {.lex_state = 473},
  [1337] = {.lex_state = 473},
  [1338] = {.lex_state = 473},
  [1339] = {.lex_state = 473},
  [1340] = {.lex_state = 473},
  [1341] = {.lex_state = 473},
  [1342] = {.lex_state = 501},
  [1343] = {.lex_state = 420},
  [1344] = {.lex_state = 615, .external_lex_state = 1},
  [1345] = {.lex_state = 0},
  [1346] = {.lex_state = 501},
  [1347] = {.lex_state = 501},
  [1348] = {.lex_state = 501},
  [1349] = {.lex_state = 468},
  [1350] = {.lex_state = 501},
  [1351] = {.lex_state = 651},
  [1352] = {.lex_state = 420},
  [1353] = {.lex_state = 641, .external_lex_state = 1},
  [1354] = {.lex_state = 420},
  [1355] = {.lex_state = 619, .external_lex_state = 1},
  [1356] = {.lex_state = 420},
  [1357] = {.lex_state = 608},
  [1358] = {.lex_state = 608},
  [1359] = {.lex_state = 487},
  [1360] = {.lex_state = 643},
  [1361] = {.lex_state = 608},
  [1362] = {.lex_state = 608},
  [1363] = {.lex_state = 0},
  [1364] = {.lex_state = 643},
  [1365] = {.lex_state = 608},
  [1366] = {.lex_state = 608},
  [1367] = {.lex_state = 608},
  [1368] = {.lex_state = 0},
  [1369] = {.lex_state = 443},
  [1370] = {.lex_state = 420},
  [1371] = {.lex_state = 643},
  [1372] = {.lex_state = 608},
  [1373] = {.lex_state = 608},
  [1374] = {.lex_state = 0},
  [1375] = {.lex_state = 608},
  [1376] = {.lex_state = 643},
  [1377] = {.lex_state = 608},
  [1378] = {.lex_state = 608},
  [1379] = {.lex_state = 501},
  [1380] = {.lex_state = 501},
  [1381] = {.lex_state = 420},
  [1382] = {.lex_state = 643},
  [1383] = {.lex_state = 608},
  [1384] = {.lex_state = 608},
  [1385] = {.lex_state = 608},
  [1386] = {.lex_state = 431},
  [1387] = {.lex_state = 576, .external_lex_state = 1},
  [1388] = {.lex_state = 579},
  [1389] = {.lex_state = 605, .external_lex_state = 1},
  [1390] = {.lex_state = 415},
  [1391] = {.lex_state = 420},
  [1392] = {.lex_state = 431},
  [1393] = {.lex_state = 576, .external_lex_state = 1},
  [1394] = {.lex_state = 420},
  [1395] = {.lex_state = 420},
  [1396] = {.lex_state = 652, .external_lex_state = 1},
  [1397] = {.lex_state = 431},
  [1398] = {.lex_state = 440},
  [1399] = {.lex_state = 645, .external_lex_state = 1},
  [1400] = {.lex_state = 443},
  [1401] = {.lex_state = 576, .external_lex_state = 1},
  [1402] = {.lex_state = 0},
  [1403] = {.lex_state = 0},
  [1404] = {.lex_state = 595, .external_lex_state = 1},
  [1405] = {.lex_state = 476},
  [1406] = {.lex_state = 0},
  [1407] = {.lex_state = 624, .external_lex_state = 1},
  [1408] = {.lex_state = 0},
  [1409] = {.lex_state = 636, .external_lex_state = 1},
  [1410] = {.lex_state = 0},
  [1411] = {.lex_state = 0},
  [1412] = {.lex_state = 420},
  [1413] = {.lex_state = 637},
  [1414] = {.lex_state = 645, .external_lex_state = 1},
  [1415] = {.lex_state = 645, .external_lex_state = 1},
  [1416] = {.lex_state = 424},
  [1417] = {.lex_state = 424},
  [1418] = {.lex_state = 424},
  [1419] = {.lex_state = 473},
  [1420] = {.lex_state = 0},
  [1421] = {.lex_state = 645, .external_lex_state = 1},
  [1422] = {.lex_state = 576, .external_lex_state = 1},
  [1423] = {.lex_state = 424},
  [1424] = {.lex_state = 424},
  [1425] = {.lex_state = 645, .external_lex_state = 1},
  [1426] = {.lex_state = 576, .external_lex_state = 1},
  [1427] = {.lex_state = 424},
  [1428] = {.lex_state = 424},
  [1429] = {.lex_state = 645, .external_lex_state = 1},
  [1430] = {.lex_state = 584},
  [1431] = {.lex_state = 0},
  [1432] = {.lex_state = 420},
  [1433] = {.lex_state = 576, .external_lex_state = 1},
  [1434] = {.lex_state = 612, .external_lex_state = 1},
  [1435] = {.lex_state = 595, .external_lex_state = 1},
  [1436] = {.lex_state = 595, .external_lex_state = 1},
  [1437] = {.lex_state = 595, .external_lex_state = 1},
  [1438] = {.lex_state = 595, .external_lex_state = 1},
  [1439] = {.lex_state = 595, .external_lex_state = 1},
  [1440] = {.lex_state = 617},
  [1441] = {.lex_state = 617},
  [1442] = {.lex_state = 595, .external_lex_state = 1},
  [1443] = {.lex_state = 473},
  [1444] = {.lex_state = 595, .external_lex_state = 1},
  [1445] = {.lex_state = 473},
  [1446] = {.lex_state = 420},
  [1447] = {.lex_state = 501},
  [1448] = {.lex_state = 501},
  [1449] = {.lex_state = 501},
  [1450] = {.lex_state = 501},
  [1451] = {.lex_state = 612, .external_lex_state = 1},
  [1452] = {.lex_state = 501},
  [1453] = {.lex_state = 617},
  [1454] = {.lex_state = 595, .external_lex_state = 1},
  [1455] = {.lex_state = 614, .external_lex_state = 1},
  [1456] = {.lex_state = 501},
  [1457] = {.lex_state = 595, .external_lex_state = 1},
  [1458] = {.lex_state = 595, .external_lex_state = 1},
  [1459] = {.lex_state = 646, .external_lex_state = 1},
  [1460] = {.lex_state = 595, .external_lex_state = 1},
  [1461] = {.lex_state = 595, .external_lex_state = 1},
  [1462] = {.lex_state = 595, .external_lex_state = 1},
  [1463] = {.lex_state = 595, .external_lex_state = 1},
  [1464] = {.lex_state = 595, .external_lex_state = 1},
  [1465] = {.lex_state = 595, .external_lex_state = 1},
  [1466] = {.lex_state = 595, .external_lex_state = 1},
  [1467] = {.lex_state = 595, .external_lex_state = 1},
  [1468] = {.lex_state = 595, .external_lex_state = 1},
  [1469] = {.lex_state = 595, .external_lex_state = 1},
  [1470] = {.lex_state = 420},
  [1471] = {.lex_state = 637},
  [1472] = {.lex_state = 617},
  [1473] = {.lex_state = 576, .external_lex_state = 1},
  [1474] = {.lex_state = 424},
  [1475] = {.lex_state = 459},
  [1476] = {.lex_state = 0},
  [1477] = {.lex_state = 473},
  [1478] = {.lex_state = 501},
  [1479] = {.lex_state = 576, .external_lex_state = 1},
  [1480] = {.lex_state = 595, .external_lex_state = 1},
  [1481] = {.lex_state = 0},
  [1482] = {.lex_state = 595, .external_lex_state = 1},
  [1483] = {.lex_state = 501},
  [1484] = {.lex_state = 646, .external_lex_state = 1},
  [1485] = {.lex_state = 595, .external_lex_state = 1},
  [1486] = {.lex_state = 501},
  [1487] = {.lex_state = 647, .external_lex_state = 1},
  [1488] = {.lex_state = 501},
  [1489] = {.lex_state = 473},
  [1490] = {.lex_state = 0},
  [1491] = {.lex_state = 501},
  [1492] = {.lex_state = 501},
  [1493] = {.lex_state = 0},
  [1494] = {.lex_state = 624, .external_lex_state = 1},
  [1495] = {.lex_state = 0},
  [1496] = {.lex_state = 501},
  [1497] = {.lex_state = 653, .external_lex_state = 1},
  [1498] = {.lex_state = 637},
  [1499] = {.lex_state = 617},
  [1500] = {.lex_state = 424},
  [1501] = {.lex_state = 473},
  [1502] = {.lex_state = 476},
  [1503] = {.lex_state = 576, .external_lex_state = 1},
  [1504] = {.lex_state = 576, .external_lex_state = 1},
  [1505] = {.lex_state = 420},
  [1506] = {.lex_state = 617},
  [1507] = {.lex_state = 473},
  [1508] = {.lex_state = 576, .external_lex_state = 1},
  [1509] = {.lex_state = 637},
  [1510] = {.lex_state = 614, .external_lex_state = 1},
  [1511] = {.lex_state = 473},
  [1512] = {.lex_state = 650, .external_lex_state = 1},
  [1513] = {.lex_state = 576, .external_lex_state = 1},
  [1514] = {.lex_state = 0},
  [1515] = {.lex_state = 605, .external_lex_state = 1},
  [1516] = {.lex_state = 0},
  [1517] = {.lex_state = 605, .external_lex_state = 1},
  [1518] = {.lex_state = 0},
  [1519] = {.lex_state = 473},
  [1520] = {.lex_state = 420},
  [1521] = {.lex_state = 473},
  [1522] = {.lex_state = 501},
  [1523] = {.lex_state = 473},
  [1524] = {.lex_state = 473},
  [1525] = {.lex_state = 473},
  [1526] = {.lex_state = 473},
  [1527] = {.lex_state = 473},
  [1528] = {.lex_state = 473},
  [1529] = {.lex_state = 473},
  [1530] = {.lex_state = 473},
  [1531] = {.lex_state = 473},
  [1532] = {.lex_state = 637},
  [1533] = {.lex_state = 420},
  [1534] = {.lex_state = 420},
  [1535] = {.lex_state = 0},
  [1536] = {.lex_state = 0},
  [1537] = {.lex_state = 420},
  [1538] = {.lex_state = 420},
  [1539] = {.lex_state = 420},
  [1540] = {.lex_state = 579},
  [1541] = {.lex_state = 420},
  [1542] = {.lex_state = 608},
  [1543] = {.lex_state = 608},
  [1544] = {.lex_state = 608},
  [1545] = {.lex_state = 608},
  [1546] = {.lex_state = 608},
  [1547] = {.lex_state = 608},
  [1548] = {.lex_state = 501},
  [1549] = {.lex_state = 501},
  [1550] = {.lex_state = 608},
  [1551] = {.lex_state = 584},
  [1552] = {.lex_state = 485},
  [1553] = {.lex_state = 584},
  [1554] = {.lex_state = 485},
  [1555] = {.lex_state = 424},
  [1556] = {.lex_state = 485},
  [1557] = {.lex_state = 424},
  [1558] = {.lex_state = 485},
  [1559] = {.lex_state = 424},
  [1560] = {.lex_state = 431},
  [1561] = {.lex_state = 581},
  [1562] = {.lex_state = 579},
  [1563] = {.lex_state = 581},
  [1564] = {.lex_state = 424},
  [1565] = {.lex_state = 485},
  [1566] = {.lex_state = 581},
  [1567] = {.lex_state = 424},
  [1568] = {.lex_state = 485},
  [1569] = {.lex_state = 581},
  [1570] = {.lex_state = 424},
  [1571] = {.lex_state = 485},
  [1572] = {.lex_state = 584},
  [1573] = {.lex_state = 0},
  [1574] = {.lex_state = 420},
  [1575] = {.lex_state = 581},
  [1576] = {.lex_state = 424},
  [1577] = {.lex_state = 0},
  [1578] = {.lex_state = 581},
  [1579] = {.lex_state = 581},
  [1580] = {.lex_state = 424},
  [1581] = {.lex_state = 581},
  [1582] = {.lex_state = 395},
  [1583] = {.lex_state = 581},
  [1584] = {.lex_state = 581},
  [1585] = {.lex_state = 443},
  [1586] = {.lex_state = 420},
  [1587] = {.lex_state = 0},
  [1588] = {.lex_state = 581},
  [1589] = {.lex_state = 604, .external_lex_state = 1},
  [1590] = {.lex_state = 581},
  [1591] = {.lex_state = 0},
  [1592] = {.lex_state = 605, .external_lex_state = 1},
  [1593] = {.lex_state = 0},
  [1594] = {.lex_state = 605, .external_lex_state = 1},
  [1595] = {.lex_state = 0},
  [1596] = {.lex_state = 581},
  [1597] = {.lex_state = 576, .external_lex_state = 1},
  [1598] = {.lex_state = 581},
  [1599] = {.lex_state = 0},
  [1600] = {.lex_state = 424},
  [1601] = {.lex_state = 485},
  [1602] = {.lex_state = 485},
  [1603] = {.lex_state = 0},
  [1604] = {.lex_state = 485},
  [1605] = {.lex_state = 485},
  [1606] = {.lex_state = 0},
  [1607] = {.lex_state = 485},
  [1608] = {.lex_state = 485},
  [1609] = {.lex_state = 485},
  [1610] = {.lex_state = 473},
  [1611] = {.lex_state = 0},
  [1612] = {.lex_state = 485},
  [1613] = {.lex_state = 473},
  [1614] = {.lex_state = 0},
  [1615] = {.lex_state = 485},
  [1616] = {.lex_state = 485},
  [1617] = {.lex_state = 485},
  [1618] = {.lex_state = 420},
  [1619] = {.lex_state = 420},
  [1620] = {.lex_state = 420},
  [1621] = {.lex_state = 420},
  [1622] = {.lex_state = 473},
  [1623] = {.lex_state = 608},
  [1624] = {.lex_state = 608},
  [1625] = {.lex_state = 501},
  [1626] = {.lex_state = 501},
  [1627] = {.lex_state = 608},
  [1628] = {.lex_state = 459},
  [1629] = {.lex_state = 420},
  [1630] = {.lex_state = 638},
  [1631] = {.lex_state = 638},
  [1632] = {.lex_state = 586},
  [1633] = {.lex_state = 586},
  [1634] = {.lex_state = 586},
  [1635] = {.lex_state = 424},
  [1636] = {.lex_state = 424},
  [1637] = {.lex_state = 638},
  [1638] = {.lex_state = 586},
  [1639] = {.lex_state = 586},
  [1640] = {.lex_state = 586},
  [1641] = {.lex_state = 424},
  [1642] = {.lex_state = 424},
  [1643] = {.lex_state = 586},
  [1644] = {.lex_state = 586},
  [1645] = {.lex_state = 586},
  [1646] = {.lex_state = 424},
  [1647] = {.lex_state = 424},
  [1648] = {.lex_state = 586},
  [1649] = {.lex_state = 0},
  [1650] = {.lex_state = 586},
  [1651] = {.lex_state = 586},
  [1652] = {.lex_state = 604, .external_lex_state = 1},
  [1653] = {.lex_state = 586},
  [1654] = {.lex_state = 0},
  [1655] = {.lex_state = 0},
  [1656] = {.lex_state = 586},
  [1657] = {.lex_state = 420},
  [1658] = {.lex_state = 420},
  [1659] = {.lex_state = 476},
  [1660] = {.lex_state = 501},
  [1661] = {.lex_state = 586},
  [1662] = {.lex_state = 420},
  [1663] = {.lex_state = 424},
  [1664] = {.lex_state = 424},
  [1665] = {.lex_state = 476},
  [1666] = {.lex_state = 476},
  [1667] = {.lex_state = 618, .external_lex_state = 1},
  [1668] = {.lex_state = 473},
  [1669] = {.lex_state = 473},
  [1670] = {.lex_state = 468},
  [1671] = {.lex_state = 501},
  [1672] = {.lex_state = 595, .external_lex_state = 1},
  [1673] = {.lex_state = 476},
  [1674] = {.lex_state = 420},
  [1675] = {.lex_state = 501},
  [1676] = {.lex_state = 420},
  [1677] = {.lex_state = 468},
  [1678] = {.lex_state = 608},
  [1679] = {.lex_state = 608},
  [1680] = {.lex_state = 501},
  [1681] = {.lex_state = 586},
  [1682] = {.lex_state = 586},
  [1683] = {.lex_state = 0},
  [1684] = {.lex_state = 605, .external_lex_state = 1},
  [1685] = {.lex_state = 420},
  [1686] = {.lex_state = 617},
  [1687] = {.lex_state = 473},
  [1688] = {.lex_state = 614, .external_lex_state = 1},
  [1689] = {.lex_state = 473},
  [1690] = {.lex_state = 650, .external_lex_state = 1},
  [1691] = {.lex_state = 473},
  [1692] = {.lex_state = 473},
  [1693] = {.lex_state = 501},
  [1694] = {.lex_state = 473},
  [1695] = {.lex_state = 473},
  [1696] = {.lex_state = 473},
  [1697] = {.lex_state = 473},
  [1698] = {.lex_state = 473},
  [1699] = {.lex_state = 473},
  [1700] = {.lex_state = 473},
  [1701] = {.lex_state = 473},
  [1702] = {.lex_state = 473},
  [1703] = {.lex_state = 473},
  [1704] = {.lex_state = 420},
  [1705] = {.lex_state = 420},
  [1706] = {.lex_state = 608},
  [1707] = {.lex_state = 501},
  [1708] = {.lex_state = 468},
  [1709] = {.lex_state = 501},
  [1710] = {.lex_state = 608},
  [1711] = {.lex_state = 473},
  [1712] = {.lex_state = 618, .external_lex_state = 1},
  [1713] = {.lex_state = 608},
  [1714] = {.lex_state = 608},
  [1715] = {.lex_state = 420},
  [1716] = {.lex_state = 608},
  [1717] = {.lex_state = 468},
  [1718] = {.lex_state = 420},
  [1719] = {.lex_state = 476},
  [1720] = {.lex_state = 420},
  [1721] = {.lex_state = 473},
  [1722] = {.lex_state = 420},
  [1723] = {.lex_state = 395},
  [1724] = {.lex_state = 420},
  [1725] = {.lex_state = 473},
  [1726] = {.lex_state = 395},
  [1727] = {.lex_state = 612, .external_lex_state = 1},
  [1728] = {.lex_state = 595, .external_lex_state = 1},
  [1729] = {.lex_state = 595, .external_lex_state = 1},
  [1730] = {.lex_state = 595, .external_lex_state = 1},
  [1731] = {.lex_state = 595, .external_lex_state = 1},
  [1732] = {.lex_state = 595, .external_lex_state = 1},
  [1733] = {.lex_state = 617},
  [1734] = {.lex_state = 617},
  [1735] = {.lex_state = 595, .external_lex_state = 1},
  [1736] = {.lex_state = 473},
  [1737] = {.lex_state = 468},
  [1738] = {.lex_state = 608},
  [1739] = {.lex_state = 420},
  [1740] = {.lex_state = 608},
  [1741] = {.lex_state = 608},
  [1742] = {.lex_state = 501},
  [1743] = {.lex_state = 501},
  [1744] = {.lex_state = 608},
  [1745] = {.lex_state = 0},
  [1746] = {.lex_state = 0},
  [1747] = {.lex_state = 501},
  [1748] = {.lex_state = 468},
  [1749] = {.lex_state = 501},
  [1750] = {.lex_state = 0},
  [1751] = {.lex_state = 637},
  [1752] = {.lex_state = 473},
  [1753] = {.lex_state = 420},
  [1754] = {.lex_state = 501},
  [1755] = {.lex_state = 420},
  [1756] = {.lex_state = 637},
  [1757] = {.lex_state = 605, .external_lex_state = 1},
  [1758] = {.lex_state = 420},
  [1759] = {.lex_state = 420},
  [1760] = {.lex_state = 617},
  [1761] = {.lex_state = 614, .external_lex_state = 1},
  [1762] = {.lex_state = 473},
  [1763] = {.lex_state = 650, .external_lex_state = 1},
  [1764] = {.lex_state = 501},
  [1765] = {.lex_state = 473},
  [1766] = {.lex_state = 395},
  [1767] = {.lex_state = 473},
  [1768] = {.lex_state = 501},
  [1769] = {.lex_state = 473},
  [1770] = {.lex_state = 473},
  [1771] = {.lex_state = 473},
  [1772] = {.lex_state = 473},
  [1773] = {.lex_state = 473},
  [1774] = {.lex_state = 473},
  [1775] = {.lex_state = 473},
  [1776] = {.lex_state = 473},
  [1777] = {.lex_state = 473},
  [1778] = {.lex_state = 649, .external_lex_state = 1},
  [1779] = {.lex_state = 395},
  [1780] = {.lex_state = 473},
  [1781] = {.lex_state = 473},
  [1782] = {.lex_state = 473},
  [1783] = {.lex_state = 395},
  [1784] = {.lex_state = 608},
  [1785] = {.lex_state = 608},
  [1786] = {.lex_state = 608},
  [1787] = {.lex_state = 608},
  [1788] = {.lex_state = 608},
  [1789] = {.lex_state = 501},
  [1790] = {.lex_state = 501},
  [1791] = {.lex_state = 608},
  [1792] = {.lex_state = 605, .external_lex_state = 1},
  [1793] = {.lex_state = 420},
  [1794] = {.lex_state = 617},
  [1795] = {.lex_state = 614, .external_lex_state = 1},
  [1796] = {.lex_state = 473},
  [1797] = {.lex_state = 650, .external_lex_state = 1},
  [1798] = {.lex_state = 473},
  [1799] = {.lex_state = 501},
  [1800] = {.lex_state = 473},
  [1801] = {.lex_state = 473},
  [1802] = {.lex_state = 473},
  [1803] = {.lex_state = 473},
  [1804] = {.lex_state = 473},
  [1805] = {.lex_state = 473},
  [1806] = {.lex_state = 473},
  [1807] = {.lex_state = 473},
  [1808] = {.lex_state = 473},
  [1809] = {.lex_state = 605, .external_lex_state = 1},
  [1810] = {.lex_state = 420},
  [1811] = {.lex_state = 617},
  [1812] = {.lex_state = 614, .external_lex_state = 1},
  [1813] = {.lex_state = 473},
  [1814] = {.lex_state = 650, .external_lex_state = 1},
  [1815] = {.lex_state = 473},
  [1816] = {.lex_state = 501},
  [1817] = {.lex_state = 473},
  [1818] = {.lex_state = 473},
  [1819] = {.lex_state = 473},
  [1820] = {.lex_state = 473},
  [1821] = {.lex_state = 473},
  [1822] = {.lex_state = 473},
  [1823] = {.lex_state = 473},
  [1824] = {.lex_state = 473},
  [1825] = {.lex_state = 473},
  [1826] = {.lex_state = 473},
  [1827] = {.lex_state = 468},
  [1828] = {.lex_state = 501},
  [1829] = {.lex_state = 501},
  [1830] = {.lex_state = 468},
  [1831] = {.lex_state = 420},
  [1832] = {.lex_state = 476},
  [1833] = {.lex_state = 501},
  [1834] = {.lex_state = 473},
  [1835] = {.lex_state = 501},
  [1836] = {.lex_state = 420},
  [1837] = {.lex_state = 605, .external_lex_state = 1},
  [1838] = {.lex_state = 420},
  [1839] = {.lex_state = 639},
  [1840] = {.lex_state = 614, .external_lex_state = 1},
  [1841] = {.lex_state = 473},
  [1842] = {.lex_state = 650, .external_lex_state = 1},
  [1843] = {.lex_state = 473},
  [1844] = {.lex_state = 473},
  [1845] = {.lex_state = 501},
  [1846] = {.lex_state = 473},
  [1847] = {.lex_state = 473},
  [1848] = {.lex_state = 473},
  [1849] = {.lex_state = 473},
  [1850] = {.lex_state = 473},
  [1851] = {.lex_state = 473},
  [1852] = {.lex_state = 473},
  [1853] = {.lex_state = 473},
  [1854] = {.lex_state = 473},
  [1855] = {.lex_state = 395},
  [1856] = {.lex_state = 420},
  [1857] = {.lex_state = 619, .external_lex_state = 1},
  [1858] = {.lex_state = 420},
  [1859] = {.lex_state = 395},
  [1860] = {.lex_state = 619, .external_lex_state = 1},
  [1861] = {.lex_state = 640, .external_lex_state = 1},
  [1862] = {.lex_state = 619, .external_lex_state = 1},
  [1863] = {.lex_state = 640, .external_lex_state = 1},
  [1864] = {.lex_state = 619, .external_lex_state = 1},
  [1865] = {.lex_state = 654, .external_lex_state = 1},
  [1866] = {.lex_state = 615, .external_lex_state = 1},
  [1867] = {.lex_state = 420},
  [1868] = {.lex_state = 619, .external_lex_state = 1},
  [1869] = {.lex_state = 473},
  [1870] = {.lex_state = 501},
  [1871] = {.lex_state = 501},
  [1872] = {.lex_state = 0},
  [1873] = {.lex_state = 501},
  [1874] = {.lex_state = 0},
  [1875] = {.lex_state = 650, .external_lex_state = 1},
  [1876] = {.lex_state = 473},
  [1877] = {.lex_state = 501},
  [1878] = {.lex_state = 595, .external_lex_state = 1},
  [1879] = {.lex_state = 501},
  [1880] = {.lex_state = 468},
  [1881] = {.lex_state = 501},
  [1882] = {.lex_state = 501},
  [1883] = {.lex_state = 420},
  [1884] = {.lex_state = 420},
  [1885] = {.lex_state = 420},
  [1886] = {.lex_state = 420},
  [1887] = {.lex_state = 468},
  [1888] = {.lex_state = 395},
  [1889] = {.lex_state = 476},
  [1890] = {.lex_state = 501},
  [1891] = {.lex_state = 651},
  [1892] = {.lex_state = 420},
  [1893] = {.lex_state = 641, .external_lex_state = 1},
  [1894] = {.lex_state = 420},
  [1895] = {.lex_state = 395},
  [1896] = {.lex_state = 608},
  [1897] = {.lex_state = 395},
  [1898] = {.lex_state = 608},
  [1899] = {.lex_state = 608},
  [1900] = {.lex_state = 487},
  [1901] = {.lex_state = 608},
  [1902] = {.lex_state = 0},
  [1903] = {.lex_state = 608},
  [1904] = {.lex_state = 0},
  [1905] = {.lex_state = 643},
  [1906] = {.lex_state = 420},
  [1907] = {.lex_state = 643},
  [1908] = {.lex_state = 608},
  [1909] = {.lex_state = 0},
  [1910] = {.lex_state = 501},
  [1911] = {.lex_state = 501},
  [1912] = {.lex_state = 501},
  [1913] = {.lex_state = 501},
  [1914] = {.lex_state = 643},
  [1915] = {.lex_state = 584},
  [1916] = {.lex_state = 576, .external_lex_state = 1},
  [1917] = {.lex_state = 584},
  [1918] = {.lex_state = 645, .external_lex_state = 1},
  [1919] = {.lex_state = 440},
  [1920] = {.lex_state = 645, .external_lex_state = 1},
  [1921] = {.lex_state = 645, .external_lex_state = 1},
  [1922] = {.lex_state = 645, .external_lex_state = 1},
  [1923] = {.lex_state = 415},
  [1924] = {.lex_state = 420},
  [1925] = {.lex_state = 431},
  [1926] = {.lex_state = 420},
  [1927] = {.lex_state = 420},
  [1928] = {.lex_state = 440},
  [1929] = {.lex_state = 652, .external_lex_state = 1},
  [1930] = {.lex_state = 443},
  [1931] = {.lex_state = 576, .external_lex_state = 1},
  [1932] = {.lex_state = 0},
  [1933] = {.lex_state = 0},
  [1934] = {.lex_state = 595, .external_lex_state = 1},
  [1935] = {.lex_state = 476},
  [1936] = {.lex_state = 0},
  [1937] = {.lex_state = 624, .external_lex_state = 1},
  [1938] = {.lex_state = 0},
  [1939] = {.lex_state = 636, .external_lex_state = 1},
  [1940] = {.lex_state = 0},
  [1941] = {.lex_state = 0},
  [1942] = {.lex_state = 420},
  [1943] = {.lex_state = 637},
  [1944] = {.lex_state = 652, .external_lex_state = 1},
  [1945] = {.lex_state = 652, .external_lex_state = 1},
  [1946] = {.lex_state = 424},
  [1947] = {.lex_state = 473},
  [1948] = {.lex_state = 0},
  [1949] = {.lex_state = 652, .external_lex_state = 1},
  [1950] = {.lex_state = 645, .external_lex_state = 1},
  [1951] = {.lex_state = 431},
  [1952] = {.lex_state = 645, .external_lex_state = 1},
  [1953] = {.lex_state = 420},
  [1954] = {.lex_state = 443},
  [1955] = {.lex_state = 645, .external_lex_state = 1},
  [1956] = {.lex_state = 576, .external_lex_state = 1},
  [1957] = {.lex_state = 595, .external_lex_state = 1},
  [1958] = {.lex_state = 0},
  [1959] = {.lex_state = 595, .external_lex_state = 1},
  [1960] = {.lex_state = 501},
  [1961] = {.lex_state = 646, .external_lex_state = 1},
  [1962] = {.lex_state = 595, .external_lex_state = 1},
  [1963] = {.lex_state = 501},
  [1964] = {.lex_state = 647, .external_lex_state = 1},
  [1965] = {.lex_state = 645, .external_lex_state = 1},
  [1966] = {.lex_state = 473},
  [1967] = {.lex_state = 0},
  [1968] = {.lex_state = 645, .external_lex_state = 1},
  [1969] = {.lex_state = 645, .external_lex_state = 1},
  [1970] = {.lex_state = 0},
  [1971] = {.lex_state = 624, .external_lex_state = 1},
  [1972] = {.lex_state = 576, .external_lex_state = 1},
  [1973] = {.lex_state = 576, .external_lex_state = 1},
  [1974] = {.lex_state = 645, .external_lex_state = 1},
  [1975] = {.lex_state = 420},
  [1976] = {.lex_state = 0},
  [1977] = {.lex_state = 420},
  [1978] = {.lex_state = 420},
  [1979] = {.lex_state = 645, .external_lex_state = 1},
  [1980] = {.lex_state = 576, .external_lex_state = 1},
  [1981] = {.lex_state = 424},
  [1982] = {.lex_state = 424},
  [1983] = {.lex_state = 645, .external_lex_state = 1},
  [1984] = {.lex_state = 576, .external_lex_state = 1},
  [1985] = {.lex_state = 576, .external_lex_state = 1},
  [1986] = {.lex_state = 576, .external_lex_state = 1},
  [1987] = {.lex_state = 424},
  [1988] = {.lex_state = 424},
  [1989] = {.lex_state = 576, .external_lex_state = 1},
  [1990] = {.lex_state = 576, .external_lex_state = 1},
  [1991] = {.lex_state = 576, .external_lex_state = 1},
  [1992] = {.lex_state = 424},
  [1993] = {.lex_state = 424},
  [1994] = {.lex_state = 576, .external_lex_state = 1},
  [1995] = {.lex_state = 576, .external_lex_state = 1},
  [1996] = {.lex_state = 0},
  [1997] = {.lex_state = 420},
  [1998] = {.lex_state = 612, .external_lex_state = 1},
  [1999] = {.lex_state = 473},
  [2000] = {.lex_state = 617},
  [2001] = {.lex_state = 595, .external_lex_state = 1},
  [2002] = {.lex_state = 614, .external_lex_state = 1},
  [2003] = {.lex_state = 473},
  [2004] = {.lex_state = 624, .external_lex_state = 1},
  [2005] = {.lex_state = 595, .external_lex_state = 1},
  [2006] = {.lex_state = 595, .external_lex_state = 1},
  [2007] = {.lex_state = 595, .external_lex_state = 1},
  [2008] = {.lex_state = 595, .external_lex_state = 1},
  [2009] = {.lex_state = 595, .external_lex_state = 1},
  [2010] = {.lex_state = 595, .external_lex_state = 1},
  [2011] = {.lex_state = 595, .external_lex_state = 1},
  [2012] = {.lex_state = 595, .external_lex_state = 1},
  [2013] = {.lex_state = 595, .external_lex_state = 1},
  [2014] = {.lex_state = 595, .external_lex_state = 1},
  [2015] = {.lex_state = 595, .external_lex_state = 1},
  [2016] = {.lex_state = 595, .external_lex_state = 1},
  [2017] = {.lex_state = 473},
  [2018] = {.lex_state = 624, .external_lex_state = 1},
  [2019] = {.lex_state = 605, .external_lex_state = 1},
  [2020] = {.lex_state = 420},
  [2021] = {.lex_state = 617},
  [2022] = {.lex_state = 614, .external_lex_state = 1},
  [2023] = {.lex_state = 501},
  [2024] = {.lex_state = 650, .external_lex_state = 1},
  [2025] = {.lex_state = 501},
  [2026] = {.lex_state = 501},
  [2027] = {.lex_state = 576, .external_lex_state = 1},
  [2028] = {.lex_state = 501},
  [2029] = {.lex_state = 501},
  [2030] = {.lex_state = 501},
  [2031] = {.lex_state = 501},
  [2032] = {.lex_state = 501},
  [2033] = {.lex_state = 501},
  [2034] = {.lex_state = 501},
  [2035] = {.lex_state = 501},
  [2036] = {.lex_state = 501},
  [2037] = {.lex_state = 501},
  [2038] = {.lex_state = 424},
  [2039] = {.lex_state = 637},
  [2040] = {.lex_state = 637},
  [2041] = {.lex_state = 424},
  [2042] = {.lex_state = 624, .external_lex_state = 1},
  [2043] = {.lex_state = 501},
  [2044] = {.lex_state = 473},
  [2045] = {.lex_state = 595, .external_lex_state = 1},
  [2046] = {.lex_state = 473},
  [2047] = {.lex_state = 646, .external_lex_state = 1},
  [2048] = {.lex_state = 443},
  [2049] = {.lex_state = 637},
  [2050] = {.lex_state = 501},
  [2051] = {.lex_state = 424},
  [2052] = {.lex_state = 473},
  [2053] = {.lex_state = 0},
  [2054] = {.lex_state = 653, .external_lex_state = 1},
  [2055] = {.lex_state = 473},
  [2056] = {.lex_state = 476},
  [2057] = {.lex_state = 501},
  [2058] = {.lex_state = 501},
  [2059] = {.lex_state = 501},
  [2060] = {.lex_state = 595, .external_lex_state = 1},
  [2061] = {.lex_state = 655, .external_lex_state = 1},
  [2062] = {.lex_state = 473},
  [2063] = {.lex_state = 424},
  [2064] = {.lex_state = 424},
  [2065] = {.lex_state = 476},
  [2066] = {.lex_state = 0},
  [2067] = {.lex_state = 476},
  [2068] = {.lex_state = 653, .external_lex_state = 1},
  [2069] = {.lex_state = 595, .external_lex_state = 1},
  [2070] = {.lex_state = 656, .external_lex_state = 1},
  [2071] = {.lex_state = 650, .external_lex_state = 1},
  [2072] = {.lex_state = 473},
  [2073] = {.lex_state = 576, .external_lex_state = 1},
  [2074] = {.lex_state = 473},
  [2075] = {.lex_state = 0},
  [2076] = {.lex_state = 576, .external_lex_state = 1},
  [2077] = {.lex_state = 473},
  [2078] = {.lex_state = 0},
  [2079] = {.lex_state = 576, .external_lex_state = 1},
  [2080] = {.lex_state = 595, .external_lex_state = 1},
  [2081] = {.lex_state = 501},
  [2082] = {.lex_state = 501},
  [2083] = {.lex_state = 501},
  [2084] = {.lex_state = 501},
  [2085] = {.lex_state = 485},
  [2086] = {.lex_state = 485},
  [2087] = {.lex_state = 485},
  [2088] = {.lex_state = 485},
  [2089] = {.lex_state = 485},
  [2090] = {.lex_state = 584},
  [2091] = {.lex_state = 581},
  [2092] = {.lex_state = 584},
  [2093] = {.lex_state = 581},
  [2094] = {.lex_state = 424},
  [2095] = {.lex_state = 581},
  [2096] = {.lex_state = 424},
  [2097] = {.lex_state = 581},
  [2098] = {.lex_state = 424},
  [2099] = {.lex_state = 581},
  [2100] = {.lex_state = 581},
  [2101] = {.lex_state = 0},
  [2102] = {.lex_state = 581},
  [2103] = {.lex_state = 581},
  [2104] = {.lex_state = 0},
  [2105] = {.lex_state = 581},
  [2106] = {.lex_state = 581},
  [2107] = {.lex_state = 581},
  [2108] = {.lex_state = 473},
  [2109] = {.lex_state = 0},
  [2110] = {.lex_state = 581},
  [2111] = {.lex_state = 473},
  [2112] = {.lex_state = 0},
  [2113] = {.lex_state = 581},
  [2114] = {.lex_state = 581},
  [2115] = {.lex_state = 581},
  [2116] = {.lex_state = 485},
  [2117] = {.lex_state = 485},
  [2118] = {.lex_state = 485},
  [2119] = {.lex_state = 485},
  [2120] = {.lex_state = 420},
  [2121] = {.lex_state = 420},
  [2122] = {.lex_state = 501},
  [2123] = {.lex_state = 501},
  [2124] = {.lex_state = 501},
  [2125] = {.lex_state = 501},
  [2126] = {.lex_state = 638},
  [2127] = {.lex_state = 424},
  [2128] = {.lex_state = 424},
  [2129] = {.lex_state = 638},
  [2130] = {.lex_state = 586},
  [2131] = {.lex_state = 586},
  [2132] = {.lex_state = 586},
  [2133] = {.lex_state = 586},
  [2134] = {.lex_state = 586},
  [2135] = {.lex_state = 586},
  [2136] = {.lex_state = 586},
  [2137] = {.lex_state = 586},
  [2138] = {.lex_state = 586},
  [2139] = {.lex_state = 586},
  [2140] = {.lex_state = 501},
  [2141] = {.lex_state = 476},
  [2142] = {.lex_state = 476},
  [2143] = {.lex_state = 501},
  [2144] = {.lex_state = 476},
  [2145] = {.lex_state = 473},
  [2146] = {.lex_state = 586},
  [2147] = {.lex_state = 468},
  [2148] = {.lex_state = 608},
  [2149] = {.lex_state = 608},
  [2150] = {.lex_state = 501},
  [2151] = {.lex_state = 473},
  [2152] = {.lex_state = 501},
  [2153] = {.lex_state = 420},
  [2154] = {.lex_state = 608},
  [2155] = {.lex_state = 608},
  [2156] = {.lex_state = 501},
  [2157] = {.lex_state = 501},
  [2158] = {.lex_state = 608},
  [2159] = {.lex_state = 657, .external_lex_state = 1},
  [2160] = {.lex_state = 650, .external_lex_state = 1},
  [2161] = {.lex_state = 473},
  [2162] = {.lex_state = 595, .external_lex_state = 1},
  [2163] = {.lex_state = 501},
  [2164] = {.lex_state = 420},
  [2165] = {.lex_state = 501},
  [2166] = {.lex_state = 608},
  [2167] = {.lex_state = 473},
  [2168] = {.lex_state = 608},
  [2169] = {.lex_state = 420},
  [2170] = {.lex_state = 476},
  [2171] = {.lex_state = 420},
  [2172] = {.lex_state = 420},
  [2173] = {.lex_state = 420},
  [2174] = {.lex_state = 649, .external_lex_state = 1},
  [2175] = {.lex_state = 395},
  [2176] = {.lex_state = 420},
  [2177] = {.lex_state = 612, .external_lex_state = 1},
  [2178] = {.lex_state = 473},
  [2179] = {.lex_state = 617},
  [2180] = {.lex_state = 595, .external_lex_state = 1},
  [2181] = {.lex_state = 614, .external_lex_state = 1},
  [2182] = {.lex_state = 473},
  [2183] = {.lex_state = 595, .external_lex_state = 1},
  [2184] = {.lex_state = 595, .external_lex_state = 1},
  [2185] = {.lex_state = 595, .external_lex_state = 1},
  [2186] = {.lex_state = 595, .external_lex_state = 1},
  [2187] = {.lex_state = 595, .external_lex_state = 1},
  [2188] = {.lex_state = 595, .external_lex_state = 1},
  [2189] = {.lex_state = 595, .external_lex_state = 1},
  [2190] = {.lex_state = 595, .external_lex_state = 1},
  [2191] = {.lex_state = 595, .external_lex_state = 1},
  [2192] = {.lex_state = 595, .external_lex_state = 1},
  [2193] = {.lex_state = 595, .external_lex_state = 1},
  [2194] = {.lex_state = 595, .external_lex_state = 1},
  [2195] = {.lex_state = 468},
  [2196] = {.lex_state = 608},
  [2197] = {.lex_state = 608},
  [2198] = {.lex_state = 608},
  [2199] = {.lex_state = 501},
  [2200] = {.lex_state = 501},
  [2201] = {.lex_state = 501},
  [2202] = {.lex_state = 501},
  [2203] = {.lex_state = 501},
  [2204] = {.lex_state = 395},
  [2205] = {.lex_state = 501},
  [2206] = {.lex_state = 658, .external_lex_state = 1},
  [2207] = {.lex_state = 650, .external_lex_state = 1},
  [2208] = {.lex_state = 473},
  [2209] = {.lex_state = 595, .external_lex_state = 1},
  [2210] = {.lex_state = 501},
  [2211] = {.lex_state = 659, .external_lex_state = 1},
  [2212] = {.lex_state = 420},
  [2213] = {.lex_state = 501},
  [2214] = {.lex_state = 501},
  [2215] = {.lex_state = 501},
  [2216] = {.lex_state = 501},
  [2217] = {.lex_state = 660, .external_lex_state = 1},
  [2218] = {.lex_state = 650, .external_lex_state = 1},
  [2219] = {.lex_state = 473},
  [2220] = {.lex_state = 595, .external_lex_state = 1},
  [2221] = {.lex_state = 661, .external_lex_state = 1},
  [2222] = {.lex_state = 650, .external_lex_state = 1},
  [2223] = {.lex_state = 473},
  [2224] = {.lex_state = 595, .external_lex_state = 1},
  [2225] = {.lex_state = 468},
  [2226] = {.lex_state = 608},
  [2227] = {.lex_state = 608},
  [2228] = {.lex_state = 501},
  [2229] = {.lex_state = 420},
  [2230] = {.lex_state = 420},
  [2231] = {.lex_state = 420},
  [2232] = {.lex_state = 476},
  [2233] = {.lex_state = 639, .external_lex_state = 1},
  [2234] = {.lex_state = 650, .external_lex_state = 1},
  [2235] = {.lex_state = 473},
  [2236] = {.lex_state = 595, .external_lex_state = 1},
  [2237] = {.lex_state = 619, .external_lex_state = 1},
  [2238] = {.lex_state = 420},
  [2239] = {.lex_state = 615, .external_lex_state = 1},
  [2240] = {.lex_state = 0},
  [2241] = {.lex_state = 501},
  [2242] = {.lex_state = 501},
  [2243] = {.lex_state = 473},
  [2244] = {.lex_state = 473},
  [2245] = {.lex_state = 501},
  [2246] = {.lex_state = 468},
  [2247] = {.lex_state = 395},
  [2248] = {.lex_state = 476},
  [2249] = {.lex_state = 501},
  [2250] = {.lex_state = 395},
  [2251] = {.lex_state = 476},
  [2252] = {.lex_state = 476},
  [2253] = {.lex_state = 476},
  [2254] = {.lex_state = 395},
  [2255] = {.lex_state = 395},
  [2256] = {.lex_state = 0},
  [2257] = {.lex_state = 476},
  [2258] = {.lex_state = 651},
  [2259] = {.lex_state = 641, .external_lex_state = 1},
  [2260] = {.lex_state = 608},
  [2261] = {.lex_state = 420},
  [2262] = {.lex_state = 395},
  [2263] = {.lex_state = 608},
  [2264] = {.lex_state = 608},
  [2265] = {.lex_state = 608},
  [2266] = {.lex_state = 643},
  [2267] = {.lex_state = 420},
  [2268] = {.lex_state = 608},
  [2269] = {.lex_state = 501},
  [2270] = {.lex_state = 501},
  [2271] = {.lex_state = 576, .external_lex_state = 1},
  [2272] = {.lex_state = 576, .external_lex_state = 1},
  [2273] = {.lex_state = 431},
  [2274] = {.lex_state = 645, .external_lex_state = 1},
  [2275] = {.lex_state = 579},
  [2276] = {.lex_state = 645, .external_lex_state = 1},
  [2277] = {.lex_state = 424},
  [2278] = {.lex_state = 424},
  [2279] = {.lex_state = 645, .external_lex_state = 1},
  [2280] = {.lex_state = 645, .external_lex_state = 1},
  [2281] = {.lex_state = 424},
  [2282] = {.lex_state = 424},
  [2283] = {.lex_state = 645, .external_lex_state = 1},
  [2284] = {.lex_state = 645, .external_lex_state = 1},
  [2285] = {.lex_state = 424},
  [2286] = {.lex_state = 424},
  [2287] = {.lex_state = 645, .external_lex_state = 1},
  [2288] = {.lex_state = 652, .external_lex_state = 1},
  [2289] = {.lex_state = 440},
  [2290] = {.lex_state = 645, .external_lex_state = 1},
  [2291] = {.lex_state = 645, .external_lex_state = 1},
  [2292] = {.lex_state = 645, .external_lex_state = 1},
  [2293] = {.lex_state = 431},
  [2294] = {.lex_state = 652, .external_lex_state = 1},
  [2295] = {.lex_state = 420},
  [2296] = {.lex_state = 443},
  [2297] = {.lex_state = 652, .external_lex_state = 1},
  [2298] = {.lex_state = 576, .external_lex_state = 1},
  [2299] = {.lex_state = 595, .external_lex_state = 1},
  [2300] = {.lex_state = 0},
  [2301] = {.lex_state = 595, .external_lex_state = 1},
  [2302] = {.lex_state = 501},
  [2303] = {.lex_state = 646, .external_lex_state = 1},
  [2304] = {.lex_state = 595, .external_lex_state = 1},
  [2305] = {.lex_state = 501},
  [2306] = {.lex_state = 647, .external_lex_state = 1},
  [2307] = {.lex_state = 652, .external_lex_state = 1},
  [2308] = {.lex_state = 473},
  [2309] = {.lex_state = 0},
  [2310] = {.lex_state = 652, .external_lex_state = 1},
  [2311] = {.lex_state = 652, .external_lex_state = 1},
  [2312] = {.lex_state = 0},
  [2313] = {.lex_state = 624, .external_lex_state = 1},
  [2314] = {.lex_state = 652, .external_lex_state = 1},
  [2315] = {.lex_state = 420},
  [2316] = {.lex_state = 0},
  [2317] = {.lex_state = 420},
  [2318] = {.lex_state = 420},
  [2319] = {.lex_state = 652, .external_lex_state = 1},
  [2320] = {.lex_state = 652, .external_lex_state = 1},
  [2321] = {.lex_state = 424},
  [2322] = {.lex_state = 424},
  [2323] = {.lex_state = 645, .external_lex_state = 1},
  [2324] = {.lex_state = 584},
  [2325] = {.lex_state = 0},
  [2326] = {.lex_state = 420},
  [2327] = {.lex_state = 645, .external_lex_state = 1},
  [2328] = {.lex_state = 473},
  [2329] = {.lex_state = 595, .external_lex_state = 1},
  [2330] = {.lex_state = 473},
  [2331] = {.lex_state = 646, .external_lex_state = 1},
  [2332] = {.lex_state = 637},
  [2333] = {.lex_state = 645, .external_lex_state = 1},
  [2334] = {.lex_state = 424},
  [2335] = {.lex_state = 473},
  [2336] = {.lex_state = 0},
  [2337] = {.lex_state = 653, .external_lex_state = 1},
  [2338] = {.lex_state = 473},
  [2339] = {.lex_state = 476},
  [2340] = {.lex_state = 645, .external_lex_state = 1},
  [2341] = {.lex_state = 645, .external_lex_state = 1},
  [2342] = {.lex_state = 473},
  [2343] = {.lex_state = 645, .external_lex_state = 1},
  [2344] = {.lex_state = 645, .external_lex_state = 1},
  [2345] = {.lex_state = 0},
  [2346] = {.lex_state = 605, .external_lex_state = 1},
  [2347] = {.lex_state = 0},
  [2348] = {.lex_state = 605, .external_lex_state = 1},
  [2349] = {.lex_state = 0},
  [2350] = {.lex_state = 576, .external_lex_state = 1},
  [2351] = {.lex_state = 576, .external_lex_state = 1},
  [2352] = {.lex_state = 576, .external_lex_state = 1},
  [2353] = {.lex_state = 576, .external_lex_state = 1},
  [2354] = {.lex_state = 576, .external_lex_state = 1},
  [2355] = {.lex_state = 576, .external_lex_state = 1},
  [2356] = {.lex_state = 576, .external_lex_state = 1},
  [2357] = {.lex_state = 605, .external_lex_state = 1},
  [2358] = {.lex_state = 420},
  [2359] = {.lex_state = 617},
  [2360] = {.lex_state = 614, .external_lex_state = 1},
  [2361] = {.lex_state = 473},
  [2362] = {.lex_state = 650, .external_lex_state = 1},
  [2363] = {.lex_state = 662, .external_lex_state = 1},
  [2364] = {.lex_state = 576, .external_lex_state = 1},
  [2365] = {.lex_state = 0},
  [2366] = {.lex_state = 0},
  [2367] = {.lex_state = 595, .external_lex_state = 1},
  [2368] = {.lex_state = 476},
  [2369] = {.lex_state = 0},
  [2370] = {.lex_state = 624, .external_lex_state = 1},
  [2371] = {.lex_state = 0},
  [2372] = {.lex_state = 636, .external_lex_state = 1},
  [2373] = {.lex_state = 0},
  [2374] = {.lex_state = 0},
  [2375] = {.lex_state = 420},
  [2376] = {.lex_state = 473},
  [2377] = {.lex_state = 662, .external_lex_state = 1},
  [2378] = {.lex_state = 473},
  [2379] = {.lex_state = 0},
  [2380] = {.lex_state = 473},
  [2381] = {.lex_state = 501},
  [2382] = {.lex_state = 473},
  [2383] = {.lex_state = 473},
  [2384] = {.lex_state = 473},
  [2385] = {.lex_state = 473},
  [2386] = {.lex_state = 473},
  [2387] = {.lex_state = 473},
  [2388] = {.lex_state = 473},
  [2389] = {.lex_state = 473},
  [2390] = {.lex_state = 473},
  [2391] = {.lex_state = 624, .external_lex_state = 1},
  [2392] = {.lex_state = 576, .external_lex_state = 1},
  [2393] = {.lex_state = 501},
  [2394] = {.lex_state = 663, .external_lex_state = 1},
  [2395] = {.lex_state = 650, .external_lex_state = 1},
  [2396] = {.lex_state = 501},
  [2397] = {.lex_state = 595, .external_lex_state = 1},
  [2398] = {.lex_state = 637},
  [2399] = {.lex_state = 637},
  [2400] = {.lex_state = 576, .external_lex_state = 1},
  [2401] = {.lex_state = 624, .external_lex_state = 1},
  [2402] = {.lex_state = 473},
  [2403] = {.lex_state = 624, .external_lex_state = 1},
  [2404] = {.lex_state = 501},
  [2405] = {.lex_state = 420},
  [2406] = {.lex_state = 443},
  [2407] = {.lex_state = 420},
  [2408] = {.lex_state = 0},
  [2409] = {.lex_state = 624, .external_lex_state = 1},
  [2410] = {.lex_state = 595, .external_lex_state = 1},
  [2411] = {.lex_state = 655, .external_lex_state = 1},
  [2412] = {.lex_state = 473},
  [2413] = {.lex_state = 653, .external_lex_state = 1},
  [2414] = {.lex_state = 595, .external_lex_state = 1},
  [2415] = {.lex_state = 473},
  [2416] = {.lex_state = 624, .external_lex_state = 1},
  [2417] = {.lex_state = 473},
  [2418] = {.lex_state = 655, .external_lex_state = 1},
  [2419] = {.lex_state = 476},
  [2420] = {.lex_state = 476},
  [2421] = {.lex_state = 653, .external_lex_state = 1},
  [2422] = {.lex_state = 501},
  [2423] = {.lex_state = 0},
  [2424] = {.lex_state = 473},
  [2425] = {.lex_state = 473},
  [2426] = {.lex_state = 473},
  [2427] = {.lex_state = 576, .external_lex_state = 1},
  [2428] = {.lex_state = 576, .external_lex_state = 1},
  [2429] = {.lex_state = 473},
  [2430] = {.lex_state = 501},
  [2431] = {.lex_state = 581},
  [2432] = {.lex_state = 581},
  [2433] = {.lex_state = 581},
  [2434] = {.lex_state = 581},
  [2435] = {.lex_state = 581},
  [2436] = {.lex_state = 581},
  [2437] = {.lex_state = 581},
  [2438] = {.lex_state = 581},
  [2439] = {.lex_state = 581},
  [2440] = {.lex_state = 501},
  [2441] = {.lex_state = 424},
  [2442] = {.lex_state = 424},
  [2443] = {.lex_state = 468},
  [2444] = {.lex_state = 501},
  [2445] = {.lex_state = 476},
  [2446] = {.lex_state = 608},
  [2447] = {.lex_state = 608},
  [2448] = {.lex_state = 501},
  [2449] = {.lex_state = 501},
  [2450] = {.lex_state = 608},
  [2451] = {.lex_state = 586},
  [2452] = {.lex_state = 501},
  [2453] = {.lex_state = 501},
  [2454] = {.lex_state = 501},
  [2455] = {.lex_state = 501},
  [2456] = {.lex_state = 501},
  [2457] = {.lex_state = 473},
  [2458] = {.lex_state = 473},
  [2459] = {.lex_state = 420},
  [2460] = {.lex_state = 608},
  [2461] = {.lex_state = 420},
  [2462] = {.lex_state = 420},
  [2463] = {.lex_state = 649, .external_lex_state = 1},
  [2464] = {.lex_state = 605, .external_lex_state = 1},
  [2465] = {.lex_state = 420},
  [2466] = {.lex_state = 617},
  [2467] = {.lex_state = 614, .external_lex_state = 1},
  [2468] = {.lex_state = 473},
  [2469] = {.lex_state = 650, .external_lex_state = 1},
  [2470] = {.lex_state = 473},
  [2471] = {.lex_state = 501},
  [2472] = {.lex_state = 473},
  [2473] = {.lex_state = 473},
  [2474] = {.lex_state = 473},
  [2475] = {.lex_state = 473},
  [2476] = {.lex_state = 473},
  [2477] = {.lex_state = 473},
  [2478] = {.lex_state = 473},
  [2479] = {.lex_state = 473},
  [2480] = {.lex_state = 473},
  [2481] = {.lex_state = 608},
  [2482] = {.lex_state = 608},
  [2483] = {.lex_state = 608},
  [2484] = {.lex_state = 608},
  [2485] = {.lex_state = 608},
  [2486] = {.lex_state = 501},
  [2487] = {.lex_state = 0},
  [2488] = {.lex_state = 473},
  [2489] = {.lex_state = 473},
  [2490] = {.lex_state = 501},
  [2491] = {.lex_state = 501},
  [2492] = {.lex_state = 473},
  [2493] = {.lex_state = 473},
  [2494] = {.lex_state = 473},
  [2495] = {.lex_state = 473},
  [2496] = {.lex_state = 608},
  [2497] = {.lex_state = 608},
  [2498] = {.lex_state = 501},
  [2499] = {.lex_state = 501},
  [2500] = {.lex_state = 608},
  [2501] = {.lex_state = 473},
  [2502] = {.lex_state = 473},
  [2503] = {.lex_state = 619, .external_lex_state = 1},
  [2504] = {.lex_state = 0},
  [2505] = {.lex_state = 476},
  [2506] = {.lex_state = 0},
  [2507] = {.lex_state = 0},
  [2508] = {.lex_state = 608},
  [2509] = {.lex_state = 420},
  [2510] = {.lex_state = 643},
  [2511] = {.lex_state = 584},
  [2512] = {.lex_state = 645, .external_lex_state = 1},
  [2513] = {.lex_state = 584},
  [2514] = {.lex_state = 645, .external_lex_state = 1},
  [2515] = {.lex_state = 645, .external_lex_state = 1},
  [2516] = {.lex_state = 645, .external_lex_state = 1},
  [2517] = {.lex_state = 424},
  [2518] = {.lex_state = 424},
  [2519] = {.lex_state = 645, .external_lex_state = 1},
  [2520] = {.lex_state = 645, .external_lex_state = 1},
  [2521] = {.lex_state = 645, .external_lex_state = 1},
  [2522] = {.lex_state = 424},
  [2523] = {.lex_state = 424},
  [2524] = {.lex_state = 645, .external_lex_state = 1},
  [2525] = {.lex_state = 645, .external_lex_state = 1},
  [2526] = {.lex_state = 645, .external_lex_state = 1},
  [2527] = {.lex_state = 424},
  [2528] = {.lex_state = 424},
  [2529] = {.lex_state = 431},
  [2530] = {.lex_state = 652, .external_lex_state = 1},
  [2531] = {.lex_state = 579},
  [2532] = {.lex_state = 652, .external_lex_state = 1},
  [2533] = {.lex_state = 424},
  [2534] = {.lex_state = 424},
  [2535] = {.lex_state = 645, .external_lex_state = 1},
  [2536] = {.lex_state = 652, .external_lex_state = 1},
  [2537] = {.lex_state = 424},
  [2538] = {.lex_state = 424},
  [2539] = {.lex_state = 645, .external_lex_state = 1},
  [2540] = {.lex_state = 652, .external_lex_state = 1},
  [2541] = {.lex_state = 424},
  [2542] = {.lex_state = 424},
  [2543] = {.lex_state = 645, .external_lex_state = 1},
  [2544] = {.lex_state = 584},
  [2545] = {.lex_state = 0},
  [2546] = {.lex_state = 420},
  [2547] = {.lex_state = 652, .external_lex_state = 1},
  [2548] = {.lex_state = 473},
  [2549] = {.lex_state = 595, .external_lex_state = 1},
  [2550] = {.lex_state = 473},
  [2551] = {.lex_state = 646, .external_lex_state = 1},
  [2552] = {.lex_state = 637},
  [2553] = {.lex_state = 652, .external_lex_state = 1},
  [2554] = {.lex_state = 424},
  [2555] = {.lex_state = 473},
  [2556] = {.lex_state = 0},
  [2557] = {.lex_state = 653, .external_lex_state = 1},
  [2558] = {.lex_state = 473},
  [2559] = {.lex_state = 476},
  [2560] = {.lex_state = 652, .external_lex_state = 1},
  [2561] = {.lex_state = 652, .external_lex_state = 1},
  [2562] = {.lex_state = 473},
  [2563] = {.lex_state = 652, .external_lex_state = 1},
  [2564] = {.lex_state = 652, .external_lex_state = 1},
  [2565] = {.lex_state = 0},
  [2566] = {.lex_state = 605, .external_lex_state = 1},
  [2567] = {.lex_state = 0},
  [2568] = {.lex_state = 605, .external_lex_state = 1},
  [2569] = {.lex_state = 0},
  [2570] = {.lex_state = 424},
  [2571] = {.lex_state = 424},
  [2572] = {.lex_state = 645, .external_lex_state = 1},
  [2573] = {.lex_state = 645, .external_lex_state = 1},
  [2574] = {.lex_state = 0},
  [2575] = {.lex_state = 624, .external_lex_state = 1},
  [2576] = {.lex_state = 473},
  [2577] = {.lex_state = 624, .external_lex_state = 1},
  [2578] = {.lex_state = 645, .external_lex_state = 1},
  [2579] = {.lex_state = 624, .external_lex_state = 1},
  [2580] = {.lex_state = 595, .external_lex_state = 1},
  [2581] = {.lex_state = 655, .external_lex_state = 1},
  [2582] = {.lex_state = 473},
  [2583] = {.lex_state = 653, .external_lex_state = 1},
  [2584] = {.lex_state = 595, .external_lex_state = 1},
  [2585] = {.lex_state = 645, .external_lex_state = 1},
  [2586] = {.lex_state = 473},
  [2587] = {.lex_state = 0},
  [2588] = {.lex_state = 645, .external_lex_state = 1},
  [2589] = {.lex_state = 473},
  [2590] = {.lex_state = 0},
  [2591] = {.lex_state = 645, .external_lex_state = 1},
  [2592] = {.lex_state = 664, .external_lex_state = 1},
  [2593] = {.lex_state = 650, .external_lex_state = 1},
  [2594] = {.lex_state = 473},
  [2595] = {.lex_state = 662, .external_lex_state = 1},
  [2596] = {.lex_state = 576, .external_lex_state = 1},
  [2597] = {.lex_state = 595, .external_lex_state = 1},
  [2598] = {.lex_state = 0},
  [2599] = {.lex_state = 595, .external_lex_state = 1},
  [2600] = {.lex_state = 501},
  [2601] = {.lex_state = 646, .external_lex_state = 1},
  [2602] = {.lex_state = 595, .external_lex_state = 1},
  [2603] = {.lex_state = 501},
  [2604] = {.lex_state = 647, .external_lex_state = 1},
  [2605] = {.lex_state = 662, .external_lex_state = 1},
  [2606] = {.lex_state = 473},
  [2607] = {.lex_state = 0},
  [2608] = {.lex_state = 662, .external_lex_state = 1},
  [2609] = {.lex_state = 662, .external_lex_state = 1},
  [2610] = {.lex_state = 0},
  [2611] = {.lex_state = 624, .external_lex_state = 1},
  [2612] = {.lex_state = 624, .external_lex_state = 1},
  [2613] = {.lex_state = 662, .external_lex_state = 1},
  [2614] = {.lex_state = 595, .external_lex_state = 1},
  [2615] = {.lex_state = 662, .external_lex_state = 1},
  [2616] = {.lex_state = 501},
  [2617] = {.lex_state = 501},
  [2618] = {.lex_state = 0},
  [2619] = {.lex_state = 0},
  [2620] = {.lex_state = 595, .external_lex_state = 1},
  [2621] = {.lex_state = 476},
  [2622] = {.lex_state = 0},
  [2623] = {.lex_state = 0},
  [2624] = {.lex_state = 473},
  [2625] = {.lex_state = 501},
  [2626] = {.lex_state = 624, .external_lex_state = 1},
  [2627] = {.lex_state = 501},
  [2628] = {.lex_state = 0},
  [2629] = {.lex_state = 420},
  [2630] = {.lex_state = 501},
  [2631] = {.lex_state = 0},
  [2632] = {.lex_state = 501},
  [2633] = {.lex_state = 473},
  [2634] = {.lex_state = 624, .external_lex_state = 1},
  [2635] = {.lex_state = 473},
  [2636] = {.lex_state = 655, .external_lex_state = 1},
  [2637] = {.lex_state = 473},
  [2638] = {.lex_state = 473},
  [2639] = {.lex_state = 576, .external_lex_state = 1},
  [2640] = {.lex_state = 576, .external_lex_state = 1},
  [2641] = {.lex_state = 595, .external_lex_state = 1},
  [2642] = {.lex_state = 624, .external_lex_state = 1},
  [2643] = {.lex_state = 420},
  [2644] = {.lex_state = 473},
  [2645] = {.lex_state = 468},
  [2646] = {.lex_state = 501},
  [2647] = {.lex_state = 653, .external_lex_state = 1},
  [2648] = {.lex_state = 655, .external_lex_state = 1},
  [2649] = {.lex_state = 624, .external_lex_state = 1},
  [2650] = {.lex_state = 420},
  [2651] = {.lex_state = 420},
  [2652] = {.lex_state = 420},
  [2653] = {.lex_state = 468},
  [2654] = {.lex_state = 608},
  [2655] = {.lex_state = 608},
  [2656] = {.lex_state = 501},
  [2657] = {.lex_state = 501},
  [2658] = {.lex_state = 501},
  [2659] = {.lex_state = 501},
  [2660] = {.lex_state = 501},
  [2661] = {.lex_state = 501},
  [2662] = {.lex_state = 501},
  [2663] = {.lex_state = 420},
  [2664] = {.lex_state = 665, .external_lex_state = 1},
  [2665] = {.lex_state = 650, .external_lex_state = 1},
  [2666] = {.lex_state = 473},
  [2667] = {.lex_state = 595, .external_lex_state = 1},
  [2668] = {.lex_state = 608},
  [2669] = {.lex_state = 608},
  [2670] = {.lex_state = 608},
  [2671] = {.lex_state = 608},
  [2672] = {.lex_state = 501},
  [2673] = {.lex_state = 501},
  [2674] = {.lex_state = 501},
  [2675] = {.lex_state = 501},
  [2676] = {.lex_state = 608},
  [2677] = {.lex_state = 645, .external_lex_state = 1},
  [2678] = {.lex_state = 645, .external_lex_state = 1},
  [2679] = {.lex_state = 645, .external_lex_state = 1},
  [2680] = {.lex_state = 645, .external_lex_state = 1},
  [2681] = {.lex_state = 645, .external_lex_state = 1},
  [2682] = {.lex_state = 645, .external_lex_state = 1},
  [2683] = {.lex_state = 645, .external_lex_state = 1},
  [2684] = {.lex_state = 645, .external_lex_state = 1},
  [2685] = {.lex_state = 584},
  [2686] = {.lex_state = 652, .external_lex_state = 1},
  [2687] = {.lex_state = 584},
  [2688] = {.lex_state = 652, .external_lex_state = 1},
  [2689] = {.lex_state = 652, .external_lex_state = 1},
  [2690] = {.lex_state = 652, .external_lex_state = 1},
  [2691] = {.lex_state = 424},
  [2692] = {.lex_state = 424},
  [2693] = {.lex_state = 652, .external_lex_state = 1},
  [2694] = {.lex_state = 652, .external_lex_state = 1},
  [2695] = {.lex_state = 652, .external_lex_state = 1},
  [2696] = {.lex_state = 424},
  [2697] = {.lex_state = 424},
  [2698] = {.lex_state = 652, .external_lex_state = 1},
  [2699] = {.lex_state = 652, .external_lex_state = 1},
  [2700] = {.lex_state = 652, .external_lex_state = 1},
  [2701] = {.lex_state = 424},
  [2702] = {.lex_state = 424},
  [2703] = {.lex_state = 652, .external_lex_state = 1},
  [2704] = {.lex_state = 652, .external_lex_state = 1},
  [2705] = {.lex_state = 0},
  [2706] = {.lex_state = 624, .external_lex_state = 1},
  [2707] = {.lex_state = 473},
  [2708] = {.lex_state = 624, .external_lex_state = 1},
  [2709] = {.lex_state = 652, .external_lex_state = 1},
  [2710] = {.lex_state = 624, .external_lex_state = 1},
  [2711] = {.lex_state = 595, .external_lex_state = 1},
  [2712] = {.lex_state = 655, .external_lex_state = 1},
  [2713] = {.lex_state = 473},
  [2714] = {.lex_state = 653, .external_lex_state = 1},
  [2715] = {.lex_state = 595, .external_lex_state = 1},
  [2716] = {.lex_state = 652, .external_lex_state = 1},
  [2717] = {.lex_state = 473},
  [2718] = {.lex_state = 0},
  [2719] = {.lex_state = 652, .external_lex_state = 1},
  [2720] = {.lex_state = 473},
  [2721] = {.lex_state = 0},
  [2722] = {.lex_state = 652, .external_lex_state = 1},
  [2723] = {.lex_state = 645, .external_lex_state = 1},
  [2724] = {.lex_state = 666, .external_lex_state = 1},
  [2725] = {.lex_state = 576, .external_lex_state = 1},
  [2726] = {.lex_state = 0},
  [2727] = {.lex_state = 0},
  [2728] = {.lex_state = 595, .external_lex_state = 1},
  [2729] = {.lex_state = 476},
  [2730] = {.lex_state = 0},
  [2731] = {.lex_state = 624, .external_lex_state = 1},
  [2732] = {.lex_state = 0},
  [2733] = {.lex_state = 636, .external_lex_state = 1},
  [2734] = {.lex_state = 0},
  [2735] = {.lex_state = 0},
  [2736] = {.lex_state = 420},
  [2737] = {.lex_state = 473},
  [2738] = {.lex_state = 666, .external_lex_state = 1},
  [2739] = {.lex_state = 473},
  [2740] = {.lex_state = 0},
  [2741] = {.lex_state = 624, .external_lex_state = 1},
  [2742] = {.lex_state = 645, .external_lex_state = 1},
  [2743] = {.lex_state = 645, .external_lex_state = 1},
  [2744] = {.lex_state = 473},
  [2745] = {.lex_state = 624, .external_lex_state = 1},
  [2746] = {.lex_state = 473},
  [2747] = {.lex_state = 655, .external_lex_state = 1},
  [2748] = {.lex_state = 473},
  [2749] = {.lex_state = 473},
  [2750] = {.lex_state = 645, .external_lex_state = 1},
  [2751] = {.lex_state = 645, .external_lex_state = 1},
  [2752] = {.lex_state = 473},
  [2753] = {.lex_state = 662, .external_lex_state = 1},
  [2754] = {.lex_state = 473},
  [2755] = {.lex_state = 595, .external_lex_state = 1},
  [2756] = {.lex_state = 473},
  [2757] = {.lex_state = 646, .external_lex_state = 1},
  [2758] = {.lex_state = 443},
  [2759] = {.lex_state = 637},
  [2760] = {.lex_state = 662, .external_lex_state = 1},
  [2761] = {.lex_state = 424},
  [2762] = {.lex_state = 473},
  [2763] = {.lex_state = 0},
  [2764] = {.lex_state = 653, .external_lex_state = 1},
  [2765] = {.lex_state = 473},
  [2766] = {.lex_state = 476},
  [2767] = {.lex_state = 662, .external_lex_state = 1},
  [2768] = {.lex_state = 662, .external_lex_state = 1},
  [2769] = {.lex_state = 662, .external_lex_state = 1},
  [2770] = {.lex_state = 576, .external_lex_state = 1},
  [2771] = {.lex_state = 473},
  [2772] = {.lex_state = 624, .external_lex_state = 1},
  [2773] = {.lex_state = 595, .external_lex_state = 1},
  [2774] = {.lex_state = 0},
  [2775] = {.lex_state = 595, .external_lex_state = 1},
  [2776] = {.lex_state = 501},
  [2777] = {.lex_state = 646, .external_lex_state = 1},
  [2778] = {.lex_state = 595, .external_lex_state = 1},
  [2779] = {.lex_state = 647, .external_lex_state = 1},
  [2780] = {.lex_state = 624, .external_lex_state = 1},
  [2781] = {.lex_state = 624, .external_lex_state = 1},
  [2782] = {.lex_state = 501},
  [2783] = {.lex_state = 501},
  [2784] = {.lex_state = 0},
  [2785] = {.lex_state = 501},
  [2786] = {.lex_state = 501},
  [2787] = {.lex_state = 501},
  [2788] = {.lex_state = 624, .external_lex_state = 1},
  [2789] = {.lex_state = 420},
  [2790] = {.lex_state = 473},
  [2791] = {.lex_state = 655, .external_lex_state = 1},
  [2792] = {.lex_state = 624, .external_lex_state = 1},
  [2793] = {.lex_state = 473},
  [2794] = {.lex_state = 576, .external_lex_state = 1},
  [2795] = {.lex_state = 624, .external_lex_state = 1},
  [2796] = {.lex_state = 420},
  [2797] = {.lex_state = 420},
  [2798] = {.lex_state = 468},
  [2799] = {.lex_state = 608},
  [2800] = {.lex_state = 608},
  [2801] = {.lex_state = 501},
  [2802] = {.lex_state = 473},
  [2803] = {.lex_state = 576, .external_lex_state = 1},
  [2804] = {.lex_state = 608},
  [2805] = {.lex_state = 608},
  [2806] = {.lex_state = 608},
  [2807] = {.lex_state = 608},
  [2808] = {.lex_state = 608},
  [2809] = {.lex_state = 501},
  [2810] = {.lex_state = 501},
  [2811] = {.lex_state = 608},
  [2812] = {.lex_state = 501},
  [2813] = {.lex_state = 501},
  [2814] = {.lex_state = 473},
  [2815] = {.lex_state = 473},
  [2816] = {.lex_state = 608},
  [2817] = {.lex_state = 608},
  [2818] = {.lex_state = 501},
  [2819] = {.lex_state = 501},
  [2820] = {.lex_state = 652, .external_lex_state = 1},
  [2821] = {.lex_state = 652, .external_lex_state = 1},
  [2822] = {.lex_state = 652, .external_lex_state = 1},
  [2823] = {.lex_state = 652, .external_lex_state = 1},
  [2824] = {.lex_state = 652, .external_lex_state = 1},
  [2825] = {.lex_state = 652, .external_lex_state = 1},
  [2826] = {.lex_state = 652, .external_lex_state = 1},
  [2827] = {.lex_state = 652, .external_lex_state = 1},
  [2828] = {.lex_state = 652, .external_lex_state = 1},
  [2829] = {.lex_state = 667, .external_lex_state = 1},
  [2830] = {.lex_state = 576, .external_lex_state = 1},
  [2831] = {.lex_state = 0},
  [2832] = {.lex_state = 0},
  [2833] = {.lex_state = 595, .external_lex_state = 1},
  [2834] = {.lex_state = 476},
  [2835] = {.lex_state = 0},
  [2836] = {.lex_state = 624, .external_lex_state = 1},
  [2837] = {.lex_state = 0},
  [2838] = {.lex_state = 636, .external_lex_state = 1},
  [2839] = {.lex_state = 0},
  [2840] = {.lex_state = 0},
  [2841] = {.lex_state = 420},
  [2842] = {.lex_state = 473},
  [2843] = {.lex_state = 667, .external_lex_state = 1},
  [2844] = {.lex_state = 473},
  [2845] = {.lex_state = 0},
  [2846] = {.lex_state = 624, .external_lex_state = 1},
  [2847] = {.lex_state = 652, .external_lex_state = 1},
  [2848] = {.lex_state = 652, .external_lex_state = 1},
  [2849] = {.lex_state = 473},
  [2850] = {.lex_state = 624, .external_lex_state = 1},
  [2851] = {.lex_state = 473},
  [2852] = {.lex_state = 655, .external_lex_state = 1},
  [2853] = {.lex_state = 473},
  [2854] = {.lex_state = 473},
  [2855] = {.lex_state = 652, .external_lex_state = 1},
  [2856] = {.lex_state = 652, .external_lex_state = 1},
  [2857] = {.lex_state = 666, .external_lex_state = 1},
  [2858] = {.lex_state = 576, .external_lex_state = 1},
  [2859] = {.lex_state = 595, .external_lex_state = 1},
  [2860] = {.lex_state = 0},
  [2861] = {.lex_state = 595, .external_lex_state = 1},
  [2862] = {.lex_state = 501},
  [2863] = {.lex_state = 646, .external_lex_state = 1},
  [2864] = {.lex_state = 595, .external_lex_state = 1},
  [2865] = {.lex_state = 501},
  [2866] = {.lex_state = 647, .external_lex_state = 1},
  [2867] = {.lex_state = 666, .external_lex_state = 1},
  [2868] = {.lex_state = 473},
  [2869] = {.lex_state = 0},
  [2870] = {.lex_state = 666, .external_lex_state = 1},
  [2871] = {.lex_state = 666, .external_lex_state = 1},
  [2872] = {.lex_state = 0},
  [2873] = {.lex_state = 624, .external_lex_state = 1},
  [2874] = {.lex_state = 624, .external_lex_state = 1},
  [2875] = {.lex_state = 666, .external_lex_state = 1},
  [2876] = {.lex_state = 666, .external_lex_state = 1},
  [2877] = {.lex_state = 645, .external_lex_state = 1},
  [2878] = {.lex_state = 645, .external_lex_state = 1},
  [2879] = {.lex_state = 624, .external_lex_state = 1},
  [2880] = {.lex_state = 420},
  [2881] = {.lex_state = 473},
  [2882] = {.lex_state = 655, .external_lex_state = 1},
  [2883] = {.lex_state = 624, .external_lex_state = 1},
  [2884] = {.lex_state = 624, .external_lex_state = 1},
  [2885] = {.lex_state = 473},
  [2886] = {.lex_state = 624, .external_lex_state = 1},
  [2887] = {.lex_state = 662, .external_lex_state = 1},
  [2888] = {.lex_state = 420},
  [2889] = {.lex_state = 443},
  [2890] = {.lex_state = 420},
  [2891] = {.lex_state = 0},
  [2892] = {.lex_state = 624, .external_lex_state = 1},
  [2893] = {.lex_state = 595, .external_lex_state = 1},
  [2894] = {.lex_state = 655, .external_lex_state = 1},
  [2895] = {.lex_state = 473},
  [2896] = {.lex_state = 653, .external_lex_state = 1},
  [2897] = {.lex_state = 595, .external_lex_state = 1},
  [2898] = {.lex_state = 576, .external_lex_state = 1},
  [2899] = {.lex_state = 473},
  [2900] = {.lex_state = 595, .external_lex_state = 1},
  [2901] = {.lex_state = 473},
  [2902] = {.lex_state = 646, .external_lex_state = 1},
  [2903] = {.lex_state = 637},
  [2904] = {.lex_state = 473},
  [2905] = {.lex_state = 653, .external_lex_state = 1},
  [2906] = {.lex_state = 473},
  [2907] = {.lex_state = 476},
  [2908] = {.lex_state = 501},
  [2909] = {.lex_state = 624, .external_lex_state = 1},
  [2910] = {.lex_state = 501},
  [2911] = {.lex_state = 501},
  [2912] = {.lex_state = 624, .external_lex_state = 1},
  [2913] = {.lex_state = 420},
  [2914] = {.lex_state = 473},
  [2915] = {.lex_state = 501},
  [2916] = {.lex_state = 576, .external_lex_state = 1},
  [2917] = {.lex_state = 624, .external_lex_state = 1},
  [2918] = {.lex_state = 608},
  [2919] = {.lex_state = 608},
  [2920] = {.lex_state = 501},
  [2921] = {.lex_state = 501},
  [2922] = {.lex_state = 608},
  [2923] = {.lex_state = 420},
  [2924] = {.lex_state = 501},
  [2925] = {.lex_state = 501},
  [2926] = {.lex_state = 501},
  [2927] = {.lex_state = 501},
  [2928] = {.lex_state = 667, .external_lex_state = 1},
  [2929] = {.lex_state = 576, .external_lex_state = 1},
  [2930] = {.lex_state = 595, .external_lex_state = 1},
  [2931] = {.lex_state = 0},
  [2932] = {.lex_state = 595, .external_lex_state = 1},
  [2933] = {.lex_state = 501},
  [2934] = {.lex_state = 646, .external_lex_state = 1},
  [2935] = {.lex_state = 595, .external_lex_state = 1},
  [2936] = {.lex_state = 501},
  [2937] = {.lex_state = 647, .external_lex_state = 1},
  [2938] = {.lex_state = 667, .external_lex_state = 1},
  [2939] = {.lex_state = 473},
  [2940] = {.lex_state = 0},
  [2941] = {.lex_state = 667, .external_lex_state = 1},
  [2942] = {.lex_state = 667, .external_lex_state = 1},
  [2943] = {.lex_state = 0},
  [2944] = {.lex_state = 624, .external_lex_state = 1},
  [2945] = {.lex_state = 624, .external_lex_state = 1},
  [2946] = {.lex_state = 667, .external_lex_state = 1},
  [2947] = {.lex_state = 667, .external_lex_state = 1},
  [2948] = {.lex_state = 652, .external_lex_state = 1},
  [2949] = {.lex_state = 652, .external_lex_state = 1},
  [2950] = {.lex_state = 624, .external_lex_state = 1},
  [2951] = {.lex_state = 420},
  [2952] = {.lex_state = 473},
  [2953] = {.lex_state = 655, .external_lex_state = 1},
  [2954] = {.lex_state = 624, .external_lex_state = 1},
  [2955] = {.lex_state = 666, .external_lex_state = 1},
  [2956] = {.lex_state = 473},
  [2957] = {.lex_state = 595, .external_lex_state = 1},
  [2958] = {.lex_state = 473},
  [2959] = {.lex_state = 646, .external_lex_state = 1},
  [2960] = {.lex_state = 443},
  [2961] = {.lex_state = 637},
  [2962] = {.lex_state = 666, .external_lex_state = 1},
  [2963] = {.lex_state = 424},
  [2964] = {.lex_state = 473},
  [2965] = {.lex_state = 0},
  [2966] = {.lex_state = 653, .external_lex_state = 1},
  [2967] = {.lex_state = 473},
  [2968] = {.lex_state = 476},
  [2969] = {.lex_state = 666, .external_lex_state = 1},
  [2970] = {.lex_state = 666, .external_lex_state = 1},
  [2971] = {.lex_state = 666, .external_lex_state = 1},
  [2972] = {.lex_state = 645, .external_lex_state = 1},
  [2973] = {.lex_state = 624, .external_lex_state = 1},
  [2974] = {.lex_state = 645, .external_lex_state = 1},
  [2975] = {.lex_state = 624, .external_lex_state = 1},
  [2976] = {.lex_state = 420},
  [2977] = {.lex_state = 473},
  [2978] = {.lex_state = 645, .external_lex_state = 1},
  [2979] = {.lex_state = 662, .external_lex_state = 1},
  [2980] = {.lex_state = 624, .external_lex_state = 1},
  [2981] = {.lex_state = 662, .external_lex_state = 1},
  [2982] = {.lex_state = 0},
  [2983] = {.lex_state = 420},
  [2984] = {.lex_state = 662, .external_lex_state = 1},
  [2985] = {.lex_state = 0},
  [2986] = {.lex_state = 662, .external_lex_state = 1},
  [2987] = {.lex_state = 473},
  [2988] = {.lex_state = 624, .external_lex_state = 1},
  [2989] = {.lex_state = 473},
  [2990] = {.lex_state = 655, .external_lex_state = 1},
  [2991] = {.lex_state = 473},
  [2992] = {.lex_state = 473},
  [2993] = {.lex_state = 624, .external_lex_state = 1},
  [2994] = {.lex_state = 473},
  [2995] = {.lex_state = 624, .external_lex_state = 1},
  [2996] = {.lex_state = 624, .external_lex_state = 1},
  [2997] = {.lex_state = 655, .external_lex_state = 1},
  [2998] = {.lex_state = 473},
  [2999] = {.lex_state = 653, .external_lex_state = 1},
  [3000] = {.lex_state = 595, .external_lex_state = 1},
  [3001] = {.lex_state = 501},
  [3002] = {.lex_state = 501},
  [3003] = {.lex_state = 624, .external_lex_state = 1},
  [3004] = {.lex_state = 420},
  [3005] = {.lex_state = 576, .external_lex_state = 1},
  [3006] = {.lex_state = 501},
  [3007] = {.lex_state = 501},
  [3008] = {.lex_state = 501},
  [3009] = {.lex_state = 501},
  [3010] = {.lex_state = 624, .external_lex_state = 1},
  [3011] = {.lex_state = 501},
  [3012] = {.lex_state = 501},
  [3013] = {.lex_state = 667, .external_lex_state = 1},
  [3014] = {.lex_state = 473},
  [3015] = {.lex_state = 595, .external_lex_state = 1},
  [3016] = {.lex_state = 473},
  [3017] = {.lex_state = 646, .external_lex_state = 1},
  [3018] = {.lex_state = 443},
  [3019] = {.lex_state = 637},
  [3020] = {.lex_state = 667, .external_lex_state = 1},
  [3021] = {.lex_state = 424},
  [3022] = {.lex_state = 473},
  [3023] = {.lex_state = 0},
  [3024] = {.lex_state = 653, .external_lex_state = 1},
  [3025] = {.lex_state = 473},
  [3026] = {.lex_state = 476},
  [3027] = {.lex_state = 667, .external_lex_state = 1},
  [3028] = {.lex_state = 667, .external_lex_state = 1},
  [3029] = {.lex_state = 667, .external_lex_state = 1},
  [3030] = {.lex_state = 652, .external_lex_state = 1},
  [3031] = {.lex_state = 624, .external_lex_state = 1},
  [3032] = {.lex_state = 652, .external_lex_state = 1},
  [3033] = {.lex_state = 624, .external_lex_state = 1},
  [3034] = {.lex_state = 420},
  [3035] = {.lex_state = 473},
  [3036] = {.lex_state = 652, .external_lex_state = 1},
  [3037] = {.lex_state = 624, .external_lex_state = 1},
  [3038] = {.lex_state = 473},
  [3039] = {.lex_state = 624, .external_lex_state = 1},
  [3040] = {.lex_state = 666, .external_lex_state = 1},
  [3041] = {.lex_state = 420},
  [3042] = {.lex_state = 443},
  [3043] = {.lex_state = 420},
  [3044] = {.lex_state = 0},
  [3045] = {.lex_state = 624, .external_lex_state = 1},
  [3046] = {.lex_state = 595, .external_lex_state = 1},
  [3047] = {.lex_state = 655, .external_lex_state = 1},
  [3048] = {.lex_state = 473},
  [3049] = {.lex_state = 653, .external_lex_state = 1},
  [3050] = {.lex_state = 595, .external_lex_state = 1},
  [3051] = {.lex_state = 645, .external_lex_state = 1},
  [3052] = {.lex_state = 645, .external_lex_state = 1},
  [3053] = {.lex_state = 624, .external_lex_state = 1},
  [3054] = {.lex_state = 420},
  [3055] = {.lex_state = 624, .external_lex_state = 1},
  [3056] = {.lex_state = 662, .external_lex_state = 1},
  [3057] = {.lex_state = 662, .external_lex_state = 1},
  [3058] = {.lex_state = 0},
  [3059] = {.lex_state = 662, .external_lex_state = 1},
  [3060] = {.lex_state = 662, .external_lex_state = 1},
  [3061] = {.lex_state = 662, .external_lex_state = 1},
  [3062] = {.lex_state = 624, .external_lex_state = 1},
  [3063] = {.lex_state = 420},
  [3064] = {.lex_state = 473},
  [3065] = {.lex_state = 655, .external_lex_state = 1},
  [3066] = {.lex_state = 624, .external_lex_state = 1},
  [3067] = {.lex_state = 501},
  [3068] = {.lex_state = 624, .external_lex_state = 1},
  [3069] = {.lex_state = 624, .external_lex_state = 1},
  [3070] = {.lex_state = 473},
  [3071] = {.lex_state = 655, .external_lex_state = 1},
  [3072] = {.lex_state = 473},
  [3073] = {.lex_state = 473},
  [3074] = {.lex_state = 501},
  [3075] = {.lex_state = 624, .external_lex_state = 1},
  [3076] = {.lex_state = 501},
  [3077] = {.lex_state = 501},
  [3078] = {.lex_state = 576, .external_lex_state = 1},
  [3079] = {.lex_state = 624, .external_lex_state = 1},
  [3080] = {.lex_state = 473},
  [3081] = {.lex_state = 624, .external_lex_state = 1},
  [3082] = {.lex_state = 667, .external_lex_state = 1},
  [3083] = {.lex_state = 420},
  [3084] = {.lex_state = 443},
  [3085] = {.lex_state = 420},
  [3086] = {.lex_state = 0},
  [3087] = {.lex_state = 624, .external_lex_state = 1},
  [3088] = {.lex_state = 595, .external_lex_state = 1},
  [3089] = {.lex_state = 655, .external_lex_state = 1},
  [3090] = {.lex_state = 473},
  [3091] = {.lex_state = 653, .external_lex_state = 1},
  [3092] = {.lex_state = 595, .external_lex_state = 1},
  [3093] = {.lex_state = 652, .external_lex_state = 1},
  [3094] = {.lex_state = 652, .external_lex_state = 1},
  [3095] = {.lex_state = 624, .external_lex_state = 1},
  [3096] = {.lex_state = 420},
  [3097] = {.lex_state = 666, .external_lex_state = 1},
  [3098] = {.lex_state = 624, .external_lex_state = 1},
  [3099] = {.lex_state = 666, .external_lex_state = 1},
  [3100] = {.lex_state = 0},
  [3101] = {.lex_state = 420},
  [3102] = {.lex_state = 666, .external_lex_state = 1},
  [3103] = {.lex_state = 0},
  [3104] = {.lex_state = 666, .external_lex_state = 1},
  [3105] = {.lex_state = 473},
  [3106] = {.lex_state = 624, .external_lex_state = 1},
  [3107] = {.lex_state = 473},
  [3108] = {.lex_state = 655, .external_lex_state = 1},
  [3109] = {.lex_state = 473},
  [3110] = {.lex_state = 473},
  [3111] = {.lex_state = 645, .external_lex_state = 1},
  [3112] = {.lex_state = 624, .external_lex_state = 1},
  [3113] = {.lex_state = 662, .external_lex_state = 1},
  [3114] = {.lex_state = 624, .external_lex_state = 1},
  [3115] = {.lex_state = 662, .external_lex_state = 1},
  [3116] = {.lex_state = 662, .external_lex_state = 1},
  [3117] = {.lex_state = 624, .external_lex_state = 1},
  [3118] = {.lex_state = 420},
  [3119] = {.lex_state = 473},
  [3120] = {.lex_state = 662, .external_lex_state = 1},
  [3121] = {.lex_state = 624, .external_lex_state = 1},
  [3122] = {.lex_state = 501},
  [3123] = {.lex_state = 624, .external_lex_state = 1},
  [3124] = {.lex_state = 420},
  [3125] = {.lex_state = 473},
  [3126] = {.lex_state = 655, .external_lex_state = 1},
  [3127] = {.lex_state = 624, .external_lex_state = 1},
  [3128] = {.lex_state = 501},
  [3129] = {.lex_state = 667, .external_lex_state = 1},
  [3130] = {.lex_state = 624, .external_lex_state = 1},
  [3131] = {.lex_state = 667, .external_lex_state = 1},
  [3132] = {.lex_state = 0},
  [3133] = {.lex_state = 420},
  [3134] = {.lex_state = 667, .external_lex_state = 1},
  [3135] = {.lex_state = 0},
  [3136] = {.lex_state = 667, .external_lex_state = 1},
  [3137] = {.lex_state = 473},
  [3138] = {.lex_state = 624, .external_lex_state = 1},
  [3139] = {.lex_state = 473},
  [3140] = {.lex_state = 655, .external_lex_state = 1},
  [3141] = {.lex_state = 473},
  [3142] = {.lex_state = 473},
  [3143] = {.lex_state = 652, .external_lex_state = 1},
  [3144] = {.lex_state = 624, .external_lex_state = 1},
  [3145] = {.lex_state = 624, .external_lex_state = 1},
  [3146] = {.lex_state = 666, .external_lex_state = 1},
  [3147] = {.lex_state = 666, .external_lex_state = 1},
  [3148] = {.lex_state = 0},
  [3149] = {.lex_state = 666, .external_lex_state = 1},
  [3150] = {.lex_state = 666, .external_lex_state = 1},
  [3151] = {.lex_state = 666, .external_lex_state = 1},
  [3152] = {.lex_state = 624, .external_lex_state = 1},
  [3153] = {.lex_state = 420},
  [3154] = {.lex_state = 473},
  [3155] = {.lex_state = 655, .external_lex_state = 1},
  [3156] = {.lex_state = 624, .external_lex_state = 1},
  [3157] = {.lex_state = 645, .external_lex_state = 1},
  [3158] = {.lex_state = 662, .external_lex_state = 1},
  [3159] = {.lex_state = 662, .external_lex_state = 1},
  [3160] = {.lex_state = 624, .external_lex_state = 1},
  [3161] = {.lex_state = 420},
  [3162] = {.lex_state = 624, .external_lex_state = 1},
  [3163] = {.lex_state = 624, .external_lex_state = 1},
  [3164] = {.lex_state = 420},
  [3165] = {.lex_state = 473},
  [3166] = {.lex_state = 624, .external_lex_state = 1},
  [3167] = {.lex_state = 667, .external_lex_state = 1},
  [3168] = {.lex_state = 667, .external_lex_state = 1},
  [3169] = {.lex_state = 0},
  [3170] = {.lex_state = 667, .external_lex_state = 1},
  [3171] = {.lex_state = 667, .external_lex_state = 1},
  [3172] = {.lex_state = 667, .external_lex_state = 1},
  [3173] = {.lex_state = 624, .external_lex_state = 1},
  [3174] = {.lex_state = 420},
  [3175] = {.lex_state = 473},
  [3176] = {.lex_state = 655, .external_lex_state = 1},
  [3177] = {.lex_state = 624, .external_lex_state = 1},
  [3178] = {.lex_state = 652, .external_lex_state = 1},
  [3179] = {.lex_state = 666, .external_lex_state = 1},
  [3180] = {.lex_state = 624, .external_lex_state = 1},
  [3181] = {.lex_state = 666, .external_lex_state = 1},
  [3182] = {.lex_state = 666, .external_lex_state = 1},
  [3183] = {.lex_state = 624, .external_lex_state = 1},
  [3184] = {.lex_state = 420},
  [3185] = {.lex_state = 473},
  [3186] = {.lex_state = 666, .external_lex_state = 1},
  [3187] = {.lex_state = 662, .external_lex_state = 1},
  [3188] = {.lex_state = 624, .external_lex_state = 1},
  [3189] = {.lex_state = 624, .external_lex_state = 1},
  [3190] = {.lex_state = 420},
  [3191] = {.lex_state = 667, .external_lex_state = 1},
  [3192] = {.lex_state = 624, .external_lex_state = 1},
  [3193] = {.lex_state = 667, .external_lex_state = 1},
  [3194] = {.lex_state = 667, .external_lex_state = 1},
  [3195] = {.lex_state = 624, .external_lex_state = 1},
  [3196] = {.lex_state = 420},
  [3197] = {.lex_state = 473},
  [3198] = {.lex_state = 667, .external_lex_state = 1},
  [3199] = {.lex_state = 666, .external_lex_state = 1},
  [3200] = {.lex_state = 666, .external_lex_state = 1},
  [3201] = {.lex_state = 624, .external_lex_state = 1},
  [3202] = {.lex_state = 420},
  [3203] = {.lex_state = 662, .external_lex_state = 1},
  [3204] = {.lex_state = 624, .external_lex_state = 1},
  [3205] = {.lex_state = 667, .external_lex_state = 1},
  [3206] = {.lex_state = 667, .external_lex_state = 1},
  [3207] = {.lex_state = 624, .external_lex_state = 1},
  [3208] = {.lex_state = 420},
  [3209] = {.lex_state = 666, .external_lex_state = 1},
  [3210] = {.lex_state = 624, .external_lex_state = 1},
  [3211] = {.lex_state = 667, .external_lex_state = 1},
  [3212] = {.lex_state = 624, .external_lex_state = 1},
  [3213] = {.lex_state = 666, .external_lex_state = 1},
  [3214] = {.lex_state = 667, .external_lex_state = 1},
};

enum {
  ts_external_token_raw_string_literal,
};

static TSSymbol ts_external_scanner_symbol_map[EXTERNAL_TOKEN_COUNT] = {
  [ts_external_token_raw_string_literal] = sym_raw_string_literal,
};

static bool ts_external_scanner_states[2][EXTERNAL_TOKEN_COUNT] = {
  [1] = {
    [ts_external_token_raw_string_literal] = true,
  },
};

static uint16_t ts_parse_table[STATE_COUNT][SYMBOL_COUNT] = {
  [0] = {
    [sym_raw_string_literal] = ACTIONS(1),
    [ts_builtin_sym_end] = ACTIONS(1),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(1),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1),
    [anon_sym_COMMA] = ACTIONS(1),
    [anon_sym_RPAREN] = ACTIONS(1),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(3),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(3),
    [sym_preproc_directive] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(1),
    [anon_sym_typedef] = ACTIONS(3),
    [anon_sym_extern] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(1),
    [anon_sym_RBRACE] = ACTIONS(1),
    [anon_sym_STAR] = ACTIONS(3),
    [anon_sym_LBRACK] = ACTIONS(1),
    [anon_sym_RBRACK] = ACTIONS(1),
    [anon_sym_EQ] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(3),
    [anon_sym_register] = ACTIONS(3),
    [anon_sym_inline] = ACTIONS(3),
    [anon_sym_const] = ACTIONS(3),
    [anon_sym_restrict] = ACTIONS(3),
    [anon_sym_volatile] = ACTIONS(3),
    [anon_sym__Atomic] = ACTIONS(3),
    [anon_sym_mutable] = ACTIONS(3),
    [anon_sym_explicit] = ACTIONS(3),
    [anon_sym_constexpr] = ACTIONS(3),
    [anon_sym_unsigned] = ACTIONS(3),
    [anon_sym_long] = ACTIONS(3),
    [anon_sym_short] = ACTIONS(3),
    [sym_primitive_type] = ACTIONS(3),
    [anon_sym_enum] = ACTIONS(3),
    [anon_sym_struct] = ACTIONS(3),
    [anon_sym_union] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(3),
    [anon_sym_if] = ACTIONS(3),
    [anon_sym_else] = ACTIONS(3),
    [anon_sym_switch] = ACTIONS(3),
    [anon_sym_case] = ACTIONS(3),
    [anon_sym_default] = ACTIONS(3),
    [anon_sym_while] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(3),
    [anon_sym_for] = ACTIONS(3),
    [anon_sym_return] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(3),
    [anon_sym_continue] = ACTIONS(3),
    [anon_sym_goto] = ACTIONS(3),
    [anon_sym_QMARK] = ACTIONS(1),
    [anon_sym_STAR_EQ] = ACTIONS(1),
    [anon_sym_SLASH_EQ] = ACTIONS(1),
    [anon_sym_PERCENT_EQ] = ACTIONS(1),
    [anon_sym_PLUS_EQ] = ACTIONS(1),
    [anon_sym_DASH_EQ] = ACTIONS(1),
    [anon_sym_LT_LT_EQ] = ACTIONS(1),
    [anon_sym_GT_GT_EQ] = ACTIONS(1),
    [anon_sym_AMP_EQ] = ACTIONS(1),
    [anon_sym_CARET_EQ] = ACTIONS(1),
    [anon_sym_PIPE_EQ] = ACTIONS(1),
    [anon_sym_AMP] = ACTIONS(3),
    [anon_sym_PIPE_PIPE] = ACTIONS(1),
    [anon_sym_AMP_AMP] = ACTIONS(1),
    [anon_sym_BANG] = ACTIONS(3),
    [anon_sym_PIPE] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(3),
    [anon_sym_TILDE] = ACTIONS(1),
    [anon_sym_EQ_EQ] = ACTIONS(1),
    [anon_sym_BANG_EQ] = ACTIONS(1),
    [anon_sym_LT] = ACTIONS(3),
    [anon_sym_GT] = ACTIONS(3),
    [anon_sym_LT_EQ] = ACTIONS(1),
    [anon_sym_GT_EQ] = ACTIONS(1),
    [anon_sym_LT_LT] = ACTIONS(3),
    [anon_sym_GT_GT] = ACTIONS(3),
    [anon_sym_PLUS] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(3),
    [anon_sym_SLASH] = ACTIONS(3),
    [anon_sym_PERCENT] = ACTIONS(3),
    [anon_sym_DASH_DASH] = ACTIONS(1),
    [anon_sym_PLUS_PLUS] = ACTIONS(1),
    [anon_sym_sizeof] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(3),
    [anon_sym_DASH_GT] = ACTIONS(1),
    [sym_number_literal] = ACTIONS(1),
    [sym_char_literal] = ACTIONS(1),
    [sym_string_literal] = ACTIONS(1),
    [sym_true] = ACTIONS(3),
    [sym_false] = ACTIONS(3),
    [sym_null] = ACTIONS(3),
    [sym_identifier] = ACTIONS(3),
    [sym_comment] = ACTIONS(1),
    [anon_sym_class] = ACTIONS(3),
    [anon_sym_public] = ACTIONS(3),
    [sym_auto] = ACTIONS(3),
    [anon_sym_typename] = ACTIONS(3),
    [anon_sym_template] = ACTIONS(3),
    [anon_sym_friend] = ACTIONS(3),
    [anon_sym_private] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(3),
    [sym_noexcept] = ACTIONS(3),
    [anon_sym_namespace] = ACTIONS(3),
    [anon_sym_using] = ACTIONS(3),
    [anon_sym_new] = ACTIONS(3),
    [anon_sym_COLON_COLON] = ACTIONS(1),
    [anon_sym_delete] = ACTIONS(3),
    [sym_operator_name] = ACTIONS(1),
    [sym_nullptr] = ACTIONS(3),
  },
  [1] = {
    [sym_translation_unit] = STATE(26),
    [sym_preproc_include] = STATE(36),
    [sym_preproc_def] = STATE(36),
    [sym_preproc_function_def] = STATE(36),
    [sym_preproc_call] = STATE(36),
    [sym_preproc_if] = STATE(36),
    [sym_preproc_ifdef] = STATE(36),
    [sym_function_definition] = STATE(36),
    [sym_declaration] = STATE(36),
    [sym_type_definition] = STATE(36),
    [sym__declaration_specifiers] = STATE(27),
    [sym_linkage_specification] = STATE(36),
    [sym__declarator] = STATE(28),
    [sym_pointer_declarator] = STATE(28),
    [sym_function_declarator] = STATE(29),
    [sym_array_declarator] = STATE(28),
    [sym_storage_class_specifier] = STATE(37),
    [sym_type_qualifier] = STATE(37),
    [sym__type_specifier] = STATE(30),
    [sym_sized_type_specifier] = STATE(30),
    [sym_enum_specifier] = STATE(30),
    [sym_struct_specifier] = STATE(30),
    [sym_union_specifier] = STATE(30),
    [sym__empty_declaration] = STATE(36),
    [sym_macro_type_specifier] = STATE(30),
    [sym_class_specifier] = STATE(30),
    [sym_dependent_type] = STATE(30),
    [sym_structured_binding_declaration] = STATE(36),
    [sym_template_declaration] = STATE(36),
    [sym_template_instantiation] = STATE(36),
    [sym_constructor_or_destructor_definition] = STATE(31),
    [sym_reference_declarator] = STATE(28),
    [sym_template_type] = STATE(32),
    [sym_template_function] = STATE(28),
    [sym_namespace_definition] = STATE(36),
    [sym_using_declaration] = STATE(36),
    [sym_alias_declaration] = STATE(36),
    [sym_destructor_name] = STATE(28),
    [sym_scoped_identifier] = STATE(33),
    [sym_scoped_type_identifier] = STATE(34),
    [sym_scoped_namespace_identifier] = STATE(35),
    [aux_sym_translation_unit_repeat1] = STATE(36),
    [aux_sym__declaration_specifiers_repeat1] = STATE(37),
    [aux_sym_sized_type_specifier_repeat1] = STATE(38),
    [ts_builtin_sym_end] = ACTIONS(5),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(7),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(11),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(13),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(15),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(17),
    [sym_preproc_directive] = ACTIONS(19),
    [anon_sym_typedef] = ACTIONS(21),
    [anon_sym_extern] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_static] = ACTIONS(27),
    [anon_sym_register] = ACTIONS(27),
    [anon_sym_inline] = ACTIONS(27),
    [anon_sym_const] = ACTIONS(29),
    [anon_sym_restrict] = ACTIONS(29),
    [anon_sym_volatile] = ACTIONS(29),
    [anon_sym__Atomic] = ACTIONS(29),
    [anon_sym_mutable] = ACTIONS(29),
    [anon_sym_explicit] = ACTIONS(29),
    [anon_sym_constexpr] = ACTIONS(29),
    [anon_sym_unsigned] = ACTIONS(31),
    [anon_sym_long] = ACTIONS(31),
    [anon_sym_short] = ACTIONS(31),
    [sym_primitive_type] = ACTIONS(33),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_union] = ACTIONS(39),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(45),
    [sym_identifier] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(51),
    [sym_auto] = ACTIONS(33),
    [anon_sym_typename] = ACTIONS(53),
    [anon_sym_template] = ACTIONS(55),
    [anon_sym_namespace] = ACTIONS(57),
    [anon_sym_using] = ACTIONS(59),
    [anon_sym_COLON_COLON] = ACTIONS(61),
    [sym_operator_name] = ACTIONS(63),
  },
  [2] = {
    [sym_string_literal] = ACTIONS(65),
    [sym_system_lib_string] = ACTIONS(65),
    [sym_comment] = ACTIONS(49),
  },
  [3] = {
    [sym_identifier] = ACTIONS(67),
    [sym_comment] = ACTIONS(49),
  },
  [4] = {
    [sym__declarator] = STATE(45),
    [sym_pointer_declarator] = STATE(45),
    [sym_function_declarator] = STATE(45),
    [sym_array_declarator] = STATE(45),
    [sym_reference_declarator] = STATE(45),
    [sym_template_type] = STATE(46),
    [sym_template_function] = STATE(45),
    [sym_destructor_name] = STATE(45),
    [sym_scoped_identifier] = STATE(33),
    [sym_scoped_type_identifier] = STATE(47),
    [sym_scoped_namespace_identifier] = STATE(46),
    [anon_sym_LPAREN] = ACTIONS(11),
    [anon_sym_STAR] = ACTIONS(69),
    [anon_sym_AMP] = ACTIONS(71),
    [anon_sym_AMP_AMP] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(45),
    [sym_identifier] = ACTIONS(75),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(77),
    [sym_operator_name] = ACTIONS(79),
  },
  [5] = {
    [sym_preproc_arg] = ACTIONS(81),
    [sym_comment] = ACTIONS(83),
  },
  [6] = {
    [sym_identifier] = ACTIONS(85),
    [sym_comment] = ACTIONS(49),
  },
  [7] = {
    [sym_identifier] = ACTIONS(87),
    [sym_comment] = ACTIONS(49),
  },
  [8] = {
    [aux_sym_SLASH_LBRACK_BSLASHt_RBRACK_PLUS_SLASH] = ACTIONS(89),
    [anon_sym_LF] = ACTIONS(91),
    [sym_comment] = ACTIONS(83),
  },
  [9] = {
    [sym_type_qualifier] = STATE(65),
    [sym__type_specifier] = STATE(61),
    [sym_sized_type_specifier] = STATE(61),
    [sym_enum_specifier] = STATE(61),
    [sym_struct_specifier] = STATE(61),
    [sym_union_specifier] = STATE(61),
    [sym_macro_type_specifier] = STATE(61),
    [sym_class_specifier] = STATE(61),
    [sym_dependent_type] = STATE(61),
    [sym_template_type] = STATE(62),
    [sym_scoped_type_identifier] = STATE(63),
    [sym_scoped_namespace_identifier] = STATE(64),
    [aux_sym_type_definition_repeat1] = STATE(65),
    [aux_sym_sized_type_specifier_repeat1] = STATE(66),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_restrict] = ACTIONS(93),
    [anon_sym_volatile] = ACTIONS(93),
    [anon_sym__Atomic] = ACTIONS(93),
    [anon_sym_mutable] = ACTIONS(93),
    [anon_sym_explicit] = ACTIONS(93),
    [anon_sym_constexpr] = ACTIONS(93),
    [anon_sym_unsigned] = ACTIONS(95),
    [anon_sym_long] = ACTIONS(95),
    [anon_sym_short] = ACTIONS(95),
    [sym_primitive_type] = ACTIONS(97),
    [anon_sym_enum] = ACTIONS(99),
    [anon_sym_struct] = ACTIONS(101),
    [anon_sym_union] = ACTIONS(103),
    [sym_identifier] = ACTIONS(105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(107),
    [sym_auto] = ACTIONS(97),
    [anon_sym_typename] = ACTIONS(109),
    [anon_sym_COLON_COLON] = ACTIONS(111),
  },
  [10] = {
    [anon_sym_LPAREN] = ACTIONS(113),
    [anon_sym_extern] = ACTIONS(115),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_static] = ACTIONS(115),
    [anon_sym_register] = ACTIONS(115),
    [anon_sym_inline] = ACTIONS(115),
    [anon_sym_const] = ACTIONS(115),
    [anon_sym_restrict] = ACTIONS(115),
    [anon_sym_volatile] = ACTIONS(115),
    [anon_sym__Atomic] = ACTIONS(115),
    [anon_sym_mutable] = ACTIONS(115),
    [anon_sym_explicit] = ACTIONS(115),
    [anon_sym_constexpr] = ACTIONS(115),
    [anon_sym_unsigned] = ACTIONS(115),
    [anon_sym_long] = ACTIONS(115),
    [anon_sym_short] = ACTIONS(115),
    [sym_primitive_type] = ACTIONS(115),
    [anon_sym_enum] = ACTIONS(115),
    [anon_sym_struct] = ACTIONS(115),
    [anon_sym_union] = ACTIONS(115),
    [anon_sym_AMP] = ACTIONS(115),
    [anon_sym_AMP_AMP] = ACTIONS(113),
    [anon_sym_TILDE] = ACTIONS(113),
    [sym_string_literal] = ACTIONS(117),
    [sym_identifier] = ACTIONS(115),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(115),
    [sym_auto] = ACTIONS(115),
    [anon_sym_typename] = ACTIONS(115),
    [anon_sym_COLON_COLON] = ACTIONS(113),
    [sym_operator_name] = ACTIONS(113),
  },
  [11] = {
    [sym__declarator] = STATE(68),
    [sym_pointer_declarator] = STATE(68),
    [sym_function_declarator] = STATE(68),
    [sym_array_declarator] = STATE(68),
    [sym_reference_declarator] = STATE(68),
    [sym_template_type] = STATE(46),
    [sym_template_function] = STATE(68),
    [sym_destructor_name] = STATE(68),
    [sym_scoped_identifier] = STATE(33),
    [sym_scoped_type_identifier] = STATE(47),
    [sym_scoped_namespace_identifier] = STATE(46),
    [anon_sym_LPAREN] = ACTIONS(11),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(45),
    [sym_identifier] = ACTIONS(75),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(77),
    [sym_operator_name] = ACTIONS(119),
  },
  [12] = {
    [anon_sym_LPAREN] = ACTIONS(113),
    [anon_sym_extern] = ACTIONS(115),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_static] = ACTIONS(115),
    [anon_sym_register] = ACTIONS(115),
    [anon_sym_inline] = ACTIONS(115),
    [anon_sym_const] = ACTIONS(115),
    [anon_sym_restrict] = ACTIONS(115),
    [anon_sym_volatile] = ACTIONS(115),
    [anon_sym__Atomic] = ACTIONS(115),
    [anon_sym_mutable] = ACTIONS(115),
    [anon_sym_explicit] = ACTIONS(115),
    [anon_sym_constexpr] = ACTIONS(115),
    [anon_sym_unsigned] = ACTIONS(115),
    [anon_sym_long] = ACTIONS(115),
    [anon_sym_short] = ACTIONS(115),
    [sym_primitive_type] = ACTIONS(115),
    [anon_sym_enum] = ACTIONS(115),
    [anon_sym_struct] = ACTIONS(115),
    [anon_sym_union] = ACTIONS(115),
    [anon_sym_AMP] = ACTIONS(115),
    [anon_sym_AMP_AMP] = ACTIONS(113),
    [anon_sym_TILDE] = ACTIONS(113),
    [sym_identifier] = ACTIONS(115),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(115),
    [sym_auto] = ACTIONS(115),
    [anon_sym_typename] = ACTIONS(115),
    [anon_sym_COLON_COLON] = ACTIONS(113),
    [sym_operator_name] = ACTIONS(113),
  },
  [13] = {
    [anon_sym_LPAREN] = ACTIONS(121),
    [anon_sym_extern] = ACTIONS(123),
    [anon_sym_STAR] = ACTIONS(121),
    [anon_sym_static] = ACTIONS(123),
    [anon_sym_register] = ACTIONS(123),
    [anon_sym_inline] = ACTIONS(123),
    [anon_sym_const] = ACTIONS(123),
    [anon_sym_restrict] = ACTIONS(123),
    [anon_sym_volatile] = ACTIONS(123),
    [anon_sym__Atomic] = ACTIONS(123),
    [anon_sym_mutable] = ACTIONS(123),
    [anon_sym_explicit] = ACTIONS(123),
    [anon_sym_constexpr] = ACTIONS(123),
    [anon_sym_unsigned] = ACTIONS(123),
    [anon_sym_long] = ACTIONS(123),
    [anon_sym_short] = ACTIONS(123),
    [sym_primitive_type] = ACTIONS(123),
    [anon_sym_enum] = ACTIONS(123),
    [anon_sym_struct] = ACTIONS(123),
    [anon_sym_union] = ACTIONS(123),
    [anon_sym_AMP] = ACTIONS(123),
    [anon_sym_AMP_AMP] = ACTIONS(121),
    [anon_sym_TILDE] = ACTIONS(121),
    [sym_identifier] = ACTIONS(123),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(123),
    [sym_auto] = ACTIONS(123),
    [anon_sym_typename] = ACTIONS(123),
    [anon_sym_COLON_COLON] = ACTIONS(121),
    [sym_operator_name] = ACTIONS(121),
  },
  [14] = {
    [sym_enumerator_list] = STATE(71),
    [anon_sym_LBRACE] = ACTIONS(125),
    [sym_identifier] = ACTIONS(127),
    [sym_comment] = ACTIONS(49),
  },
  [15] = {
    [sym_field_declaration_list] = STATE(76),
    [sym__class_name] = STATE(77),
    [sym_base_class_clause] = STATE(78),
    [sym_template_type] = STATE(79),
    [sym_scoped_type_identifier] = STATE(80),
    [sym_scoped_namespace_identifier] = STATE(81),
    [anon_sym_LBRACE] = ACTIONS(129),
    [anon_sym_COLON] = ACTIONS(131),
    [sym_identifier] = ACTIONS(133),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(135),
  },
  [16] = {
    [sym_field_declaration_list] = STATE(82),
    [sym__class_name] = STATE(83),
    [sym_base_class_clause] = STATE(84),
    [sym_template_type] = STATE(79),
    [sym_scoped_type_identifier] = STATE(80),
    [sym_scoped_namespace_identifier] = STATE(81),
    [anon_sym_LBRACE] = ACTIONS(129),
    [anon_sym_COLON] = ACTIONS(131),
    [sym_identifier] = ACTIONS(133),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(135),
  },
  [17] = {
    [sym__declarator] = STATE(68),
    [sym_pointer_declarator] = STATE(68),
    [sym_function_declarator] = STATE(68),
    [sym_array_declarator] = STATE(68),
    [sym_reference_declarator] = STATE(68),
    [sym_template_type] = STATE(46),
    [sym_template_function] = STATE(68),
    [sym_destructor_name] = STATE(68),
    [sym_scoped_identifier] = STATE(33),
    [sym_scoped_type_identifier] = STATE(47),
    [sym_scoped_namespace_identifier] = STATE(46),
    [anon_sym_LPAREN] = ACTIONS(11),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(45),
    [sym_identifier] = ACTIONS(75),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(77),
    [sym_operator_name] = ACTIONS(119),
  },
  [18] = {
    [sym_identifier] = ACTIONS(137),
    [sym_comment] = ACTIONS(49),
  },
  [19] = {
    [sym_template_argument_list] = STATE(88),
    [anon_sym_LPAREN] = ACTIONS(139),
    [anon_sym_COMMA] = ACTIONS(142),
    [anon_sym_RPAREN] = ACTIONS(139),
    [anon_sym_SEMI] = ACTIONS(142),
    [anon_sym_extern] = ACTIONS(144),
    [anon_sym_STAR] = ACTIONS(142),
    [anon_sym_LBRACK] = ACTIONS(139),
    [anon_sym_static] = ACTIONS(144),
    [anon_sym_register] = ACTIONS(144),
    [anon_sym_inline] = ACTIONS(144),
    [anon_sym_const] = ACTIONS(144),
    [anon_sym_restrict] = ACTIONS(144),
    [anon_sym_volatile] = ACTIONS(144),
    [anon_sym__Atomic] = ACTIONS(144),
    [anon_sym_mutable] = ACTIONS(144),
    [anon_sym_explicit] = ACTIONS(144),
    [anon_sym_constexpr] = ACTIONS(144),
    [anon_sym_AMP] = ACTIONS(144),
    [anon_sym_AMP_AMP] = ACTIONS(142),
    [anon_sym_TILDE] = ACTIONS(142),
    [anon_sym_LT] = ACTIONS(146),
    [sym_identifier] = ACTIONS(144),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(148),
    [sym_operator_name] = ACTIONS(142),
  },
  [20] = {
    [sym_field_declaration_list] = STATE(89),
    [sym__class_name] = STATE(90),
    [sym_base_class_clause] = STATE(91),
    [sym_template_type] = STATE(79),
    [sym_scoped_type_identifier] = STATE(80),
    [sym_scoped_namespace_identifier] = STATE(81),
    [anon_sym_LBRACE] = ACTIONS(129),
    [anon_sym_COLON] = ACTIONS(131),
    [sym_identifier] = ACTIONS(133),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(135),
  },
  [21] = {
    [sym__type_specifier] = STATE(93),
    [sym_sized_type_specifier] = STATE(93),
    [sym_enum_specifier] = STATE(93),
    [sym_struct_specifier] = STATE(93),
    [sym_union_specifier] = STATE(93),
    [sym_macro_type_specifier] = STATE(93),
    [sym_class_specifier] = STATE(93),
    [sym_dependent_type] = STATE(93),
    [sym_template_type] = STATE(94),
    [sym_scoped_type_identifier] = STATE(34),
    [sym_scoped_namespace_identifier] = STATE(81),
    [aux_sym_sized_type_specifier_repeat1] = STATE(38),
    [anon_sym_unsigned] = ACTIONS(31),
    [anon_sym_long] = ACTIONS(31),
    [anon_sym_short] = ACTIONS(31),
    [sym_primitive_type] = ACTIONS(150),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_union] = ACTIONS(39),
    [sym_identifier] = ACTIONS(152),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(51),
    [sym_auto] = ACTIONS(150),
    [anon_sym_typename] = ACTIONS(53),
    [anon_sym_COLON_COLON] = ACTIONS(135),
  },
  [22] = {
    [sym__declaration_specifiers] = STATE(103),
    [sym__declarator] = STATE(104),
    [sym_pointer_declarator] = STATE(104),
    [sym_function_declarator] = STATE(104),
    [sym_array_declarator] = STATE(104),
    [sym_storage_class_specifier] = STATE(109),
    [sym_type_qualifier] = STATE(109),
    [sym__type_specifier] = STATE(105),
    [sym_sized_type_specifier] = STATE(105),
    [sym_enum_specifier] = STATE(105),
    [sym_struct_specifier] = STATE(105),
    [sym_union_specifier] = STATE(105),
    [sym_macro_type_specifier] = STATE(105),
    [sym_class_specifier] = STATE(105),
    [sym_dependent_type] = STATE(105),
    [sym_template_parameter_list] = STATE(106),
    [sym_reference_declarator] = STATE(104),
    [sym_template_type] = STATE(107),
    [sym_template_function] = STATE(104),
    [sym_destructor_name] = STATE(104),
    [sym_scoped_identifier] = STATE(33),
    [sym_scoped_type_identifier] = STATE(34),
    [sym_scoped_namespace_identifier] = STATE(108),
    [aux_sym__declaration_specifiers_repeat1] = STATE(109),
    [aux_sym_sized_type_specifier_repeat1] = STATE(110),
    [anon_sym_LPAREN] = ACTIONS(11),
    [anon_sym_extern] = ACTIONS(154),
    [anon_sym_STAR] = ACTIONS(156),
    [anon_sym_static] = ACTIONS(154),
    [anon_sym_register] = ACTIONS(154),
    [anon_sym_inline] = ACTIONS(154),
    [anon_sym_const] = ACTIONS(158),
    [anon_sym_restrict] = ACTIONS(158),
    [anon_sym_volatile] = ACTIONS(158),
    [anon_sym__Atomic] = ACTIONS(158),
    [anon_sym_mutable] = ACTIONS(158),
    [anon_sym_explicit] = ACTIONS(158),
    [anon_sym_constexpr] = ACTIONS(158),
    [anon_sym_unsigned] = ACTIONS(160),
    [anon_sym_long] = ACTIONS(160),
    [anon_sym_short] = ACTIONS(160),
    [sym_primitive_type] = ACTIONS(162),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_union] = ACTIONS(39),
    [anon_sym_AMP] = ACTIONS(164),
    [anon_sym_AMP_AMP] = ACTIONS(166),
    [anon_sym_TILDE] = ACTIONS(45),
    [anon_sym_LT] = ACTIONS(168),
    [sym_identifier] = ACTIONS(170),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(51),
    [sym_auto] = ACTIONS(162),
    [anon_sym_typename] = ACTIONS(172),
    [anon_sym_COLON_COLON] = ACTIONS(174),
    [sym_operator_name] = ACTIONS(176),
  },
  [23] = {
    [sym_declaration_list] = STATE(113),
    [anon_sym_LBRACE] = ACTIONS(178),
    [sym_identifier] = ACTIONS(180),
    [sym_comment] = ACTIONS(49),
  },
  [24] = {
    [sym_template_type] = STATE(117),
    [sym_scoped_identifier] = STATE(118),
    [sym_scoped_type_identifier] = STATE(47),
    [sym_scoped_namespace_identifier] = STATE(117),
    [sym_identifier] = ACTIONS(182),
    [sym_comment] = ACTIONS(49),
    [anon_sym_namespace] = ACTIONS(184),
    [anon_sym_COLON_COLON] = ACTIONS(186),
  },
  [25] = {
    [sym_destructor_name] = STATE(120),
    [anon_sym_TILDE] = ACTIONS(45),
    [sym_identifier] = ACTIONS(188),
    [sym_comment] = ACTIONS(49),
    [sym_operator_name] = ACTIONS(190),
  },
  [26] = {
    [ts_builtin_sym_end] = ACTIONS(192),
    [sym_comment] = ACTIONS(49),
  },
  [27] = {
    [sym__declarator] = STATE(125),
    [sym_pointer_declarator] = STATE(125),
    [sym_function_declarator] = STATE(125),
    [sym_array_declarator] = STATE(125),
    [sym_init_declarator] = STATE(126),
    [sym_reference_declarator] = STATE(125),
    [sym_structured_binding_reference_declarator] = STATE(127),
    [sym_structured_binding_declarator] = STATE(128),
    [sym_template_type] = STATE(46),
    [sym_template_function] = STATE(125),
    [sym_destructor_name] = STATE(125),
    [sym_scoped_identifier] = STATE(33),
    [sym_scoped_type_identifier] = STATE(47),
    [sym_scoped_namespace_identifier] = STATE(46),
    [anon_sym_LPAREN] = ACTIONS(11),
    [anon_sym_SEMI] = ACTIONS(194),
    [anon_sym_STAR] = ACTIONS(196),
    [anon_sym_LBRACK] = ACTIONS(198),
    [anon_sym_AMP] = ACTIONS(200),
    [anon_sym_AMP_AMP] = ACTIONS(202),
    [anon_sym_TILDE] = ACTIONS(45),
    [sym_identifier] = ACTIONS(75),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(77),
    [sym_operator_name] = ACTIONS(204),
  },
  [28] = {
    [sym_parameter_list] = STATE(131),
    [anon_sym_LPAREN] = ACTIONS(206),
    [anon_sym_LBRACK] = ACTIONS(208),
    [sym_comment] = ACTIONS(49),
  },
  [29] = {
    [sym_compound_statement] = STATE(134),
    [sym_field_initializer_list] = STATE(135),
    [anon_sym_LPAREN] = ACTIONS(210),
    [anon_sym_LBRACE] = ACTIONS(212),
    [anon_sym_LBRACK] = ACTIONS(210),
    [anon_sym_COLON] = ACTIONS(214),
    [sym_comment] = ACTIONS(49),
  },
  [30] = {
    [sym_storage_class_specifier] = STATE(138),
    [sym_type_qualifier] = STATE(138),
    [aux_sym__declaration_specifiers_repeat1] = STATE(138),
    [anon_sym_LPAREN] = ACTIONS(216),
    [anon_sym_SEMI] = ACTIONS(216),
    [anon_sym_extern] = ACTIONS(218),
    [anon_sym_STAR] = ACTIONS(216),
    [anon_sym_LBRACK] = ACTIONS(216),
    [anon_sym_static] = ACTIONS(218),
    [anon_sym_register] = ACTIONS(218),
    [anon_sym_inline] = ACTIONS(218),
    [anon_sym_const] = ACTIONS(220),
    [anon_sym_restrict] = ACTIONS(220),
    [anon_sym_volatile] = ACTIONS(220),
    [anon_sym__Atomic] = ACTIONS(220),
    [anon_sym_mutable] = ACTIONS(220),
    [anon_sym_explicit] = ACTIONS(220),
    [anon_sym_constexpr] = ACTIONS(220),
    [anon_sym_AMP] = ACTIONS(222),
    [anon_sym_AMP_AMP] = ACTIONS(216),
    [anon_sym_TILDE] = ACTIONS(216),
    [sym_identifier] = ACTIONS(222),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(216),
    [sym_operator_name] = ACTIONS(216),
  },
  [31] = {
    [ts_builtin_sym_end] = ACTIONS(224),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(226),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(226),
    [anon_sym_LPAREN] = ACTIONS(224),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(226),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(226),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(226),
    [sym_preproc_directive] = ACTIONS(226),
    [anon_sym_typedef] = ACTIONS(226),
    [anon_sym_extern] = ACTIONS(226),
    [anon_sym_RBRACE] = ACTIONS(224),
    [anon_sym_STAR] = ACTIONS(224),
    [anon_sym_static] = ACTIONS(226),
    [anon_sym_register] = ACTIONS(226),
    [anon_sym_inline] = ACTIONS(226),
    [anon_sym_const] = ACTIONS(226),
    [anon_sym_restrict] = ACTIONS(226),
    [anon_sym_volatile] = ACTIONS(226),
    [anon_sym__Atomic] = ACTIONS(226),
    [anon_sym_mutable] = ACTIONS(226),
    [anon_sym_explicit] = ACTIONS(226),
    [anon_sym_constexpr] = ACTIONS(226),
    [anon_sym_unsigned] = ACTIONS(226),
    [anon_sym_long] = ACTIONS(226),
    [anon_sym_short] = ACTIONS(226),
    [sym_primitive_type] = ACTIONS(226),
    [anon_sym_enum] = ACTIONS(226),
    [anon_sym_struct] = ACTIONS(226),
    [anon_sym_union] = ACTIONS(226),
    [anon_sym_AMP] = ACTIONS(226),
    [anon_sym_AMP_AMP] = ACTIONS(224),
    [anon_sym_TILDE] = ACTIONS(224),
    [sym_identifier] = ACTIONS(226),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(226),
    [sym_auto] = ACTIONS(226),
    [anon_sym_typename] = ACTIONS(226),
    [anon_sym_template] = ACTIONS(226),
    [anon_sym_namespace] = ACTIONS(226),
    [anon_sym_using] = ACTIONS(226),
    [anon_sym_COLON_COLON] = ACTIONS(224),
    [sym_operator_name] = ACTIONS(224),
  },
  [32] = {
    [anon_sym_LPAREN] = ACTIONS(228),
    [anon_sym_COMMA] = ACTIONS(228),
    [anon_sym_RPAREN] = ACTIONS(228),
    [anon_sym_SEMI] = ACTIONS(228),
    [anon_sym_extern] = ACTIONS(230),
    [anon_sym_STAR] = ACTIONS(228),
    [anon_sym_LBRACK] = ACTIONS(228),
    [anon_sym_static] = ACTIONS(230),
    [anon_sym_register] = ACTIONS(230),
    [anon_sym_inline] = ACTIONS(230),
    [anon_sym_const] = ACTIONS(230),
    [anon_sym_restrict] = ACTIONS(230),
    [anon_sym_volatile] = ACTIONS(230),
    [anon_sym__Atomic] = ACTIONS(230),
    [anon_sym_mutable] = ACTIONS(230),
    [anon_sym_explicit] = ACTIONS(230),
    [anon_sym_constexpr] = ACTIONS(230),
    [anon_sym_AMP] = ACTIONS(230),
    [anon_sym_AMP_AMP] = ACTIONS(228),
    [anon_sym_TILDE] = ACTIONS(228),
    [sym_identifier] = ACTIONS(230),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(232),
    [sym_operator_name] = ACTIONS(228),
  },
  [33] = {
    [sym_template_argument_list] = STATE(140),
    [anon_sym_LPAREN] = ACTIONS(210),
    [anon_sym_COMMA] = ACTIONS(210),
    [anon_sym_RPAREN] = ACTIONS(210),
    [anon_sym_SEMI] = ACTIONS(210),
    [anon_sym_LBRACE] = ACTIONS(210),
    [anon_sym_LBRACK] = ACTIONS(210),
    [anon_sym_EQ] = ACTIONS(210),
    [anon_sym_LT] = ACTIONS(146),
    [sym_comment] = ACTIONS(49),
  },
  [34] = {
    [sym_template_argument_list] = STATE(141),
    [anon_sym_LPAREN] = ACTIONS(228),
    [anon_sym_COMMA] = ACTIONS(228),
    [anon_sym_RPAREN] = ACTIONS(228),
    [anon_sym_SEMI] = ACTIONS(228),
    [anon_sym_extern] = ACTIONS(230),
    [anon_sym_LBRACE] = ACTIONS(228),
    [anon_sym_STAR] = ACTIONS(228),
    [anon_sym_LBRACK] = ACTIONS(228),
    [anon_sym_static] = ACTIONS(230),
    [anon_sym_register] = ACTIONS(230),
    [anon_sym_inline] = ACTIONS(230),
    [anon_sym_const] = ACTIONS(230),
    [anon_sym_restrict] = ACTIONS(230),
    [anon_sym_volatile] = ACTIONS(230),
    [anon_sym__Atomic] = ACTIONS(230),
    [anon_sym_mutable] = ACTIONS(230),
    [anon_sym_explicit] = ACTIONS(230),
    [anon_sym_constexpr] = ACTIONS(230),
    [anon_sym_COLON] = ACTIONS(230),
    [anon_sym_AMP] = ACTIONS(230),
    [anon_sym_AMP_AMP] = ACTIONS(228),
    [anon_sym_TILDE] = ACTIONS(228),
    [anon_sym_LT] = ACTIONS(146),
    [anon_sym_GT] = ACTIONS(228),
    [sym_identifier] = ACTIONS(230),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(228),
    [sym_operator_name] = ACTIONS(228),
  },
  [35] = {
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(232),
  },
  [36] = {
    [sym_preproc_include] = STATE(142),
    [sym_preproc_def] = STATE(142),
    [sym_preproc_function_def] = STATE(142),
    [sym_preproc_call] = STATE(142),
    [sym_preproc_if] = STATE(142),
    [sym_preproc_ifdef] = STATE(142),
    [sym_function_definition] = STATE(142),
    [sym_declaration] = STATE(142),
    [sym_type_definition] = STATE(142),
    [sym__declaration_specifiers] = STATE(27),
    [sym_linkage_specification] = STATE(142),
    [sym__declarator] = STATE(28),
    [sym_pointer_declarator] = STATE(28),
    [sym_function_declarator] = STATE(29),
    [sym_array_declarator] = STATE(28),
    [sym_storage_class_specifier] = STATE(37),
    [sym_type_qualifier] = STATE(37),
    [sym__type_specifier] = STATE(30),
    [sym_sized_type_specifier] = STATE(30),
    [sym_enum_specifier] = STATE(30),
    [sym_struct_specifier] = STATE(30),
    [sym_union_specifier] = STATE(30),
    [sym__empty_declaration] = STATE(142),
    [sym_macro_type_specifier] = STATE(30),
    [sym_class_specifier] = STATE(30),
    [sym_dependent_type] = STATE(30),
    [sym_structured_binding_declaration] = STATE(142),
    [sym_template_declaration] = STATE(142),
    [sym_template_instantiation] = STATE(142),
    [sym_constructor_or_destructor_definition] = STATE(31),
    [sym_reference_declarator] = STATE(28),
    [sym_template_type] = STATE(32),
    [sym_template_function] = STATE(28),
    [sym_namespace_definition] = STATE(142),
    [sym_using_declaration] = STATE(142),
    [sym_alias_declaration] = STATE(142),
    [sym_destructor_name] = STATE(28),
    [sym_scoped_identifier] = STATE(33),
    [sym_scoped_type_identifier] = STATE(34),
    [sym_scoped_namespace_identifier] = STATE(35),
    [aux_sym_translation_unit_repeat1] = STATE(142),
    [aux_sym__declaration_specifiers_repeat1] = STATE(37),
    [aux_sym_sized_type_specifier_repeat1] = STATE(38),
    [ts_builtin_sym_end] = ACTIONS(234),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(7),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(11),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(13),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(15),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(17),
    [sym_preproc_directive] = ACTIONS(19),
    [anon_sym_typedef] = ACTIONS(21),
    [anon_sym_extern] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_static] = ACTIONS(27),
    [anon_sym_register] = ACTIONS(27),
    [anon_sym_inline] = ACTIONS(27),
    [anon_sym_const] = ACTIONS(29),
    [anon_sym_restrict] = ACTIONS(29),
    [anon_sym_volatile] = ACTIONS(29),
    [anon_sym__Atomic] = ACTIONS(29),
    [anon_sym_mutable] = ACTIONS(29),
    [anon_sym_explicit] = ACTIONS(29),
    [anon_sym_constexpr] = ACTIONS(29),
    [anon_sym_unsigned] = ACTIONS(31),
    [anon_sym_long] = ACTIONS(31),
    [anon_sym_short] = ACTIONS(31),
    [sym_primitive_type] = ACTIONS(33),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_union] = ACTIONS(39),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(45),
    [sym_identifier] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(51),
    [sym_auto] = ACTIONS(33),
    [anon_sym_typename] = ACTIONS(53),
    [anon_sym_template] = ACTIONS(55),
    [anon_sym_namespace] = ACTIONS(57),
    [anon_sym_using] = ACTIONS(59),
    [anon_sym_COLON_COLON] = ACTIONS(61),
    [sym_operator_name] = ACTIONS(63),
  },
  [37] = {
    [sym__declarator] = STATE(28),
    [sym_pointer_declarator] = STATE(28),
    [sym_function_declarator] = STATE(143),
    [sym_array_declarator] = STATE(28),
    [sym_storage_class_specifier] = STATE(145),
    [sym_type_qualifier] = STATE(145),
    [sym__type_specifier] = STATE(144),
    [sym_sized_type_specifier] = STATE(144),
    [sym_enum_specifier] = STATE(144),
    [sym_struct_specifier] = STATE(144),
    [sym_union_specifier] = STATE(144),
    [sym_macro_type_specifier] = STATE(144),
    [sym_class_specifier] = STATE(144),
    [sym_dependent_type] = STATE(144),
    [sym_reference_declarator] = STATE(28),
    [sym_template_type] = STATE(32),
    [sym_template_function] = STATE(28),
    [sym_destructor_name] = STATE(28),
    [sym_scoped_identifier] = STATE(33),
    [sym_scoped_type_identifier] = STATE(34),
    [sym_scoped_namespace_identifier] = STATE(35),
    [aux_sym__declaration_specifiers_repeat1] = STATE(145),
    [aux_sym_sized_type_specifier_repeat1] = STATE(38),
    [anon_sym_LPAREN] = ACTIONS(11),
    [anon_sym_extern] = ACTIONS(27),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_static] = ACTIONS(27),
    [anon_sym_register] = ACTIONS(27),
    [anon_sym_inline] = ACTIONS(27),
    [anon_sym_const] = ACTIONS(29),
    [anon_sym_restrict] = ACTIONS(29),
    [anon_sym_volatile] = ACTIONS(29),
    [anon_sym__Atomic] = ACTIONS(29),
    [anon_sym_mutable] = ACTIONS(29),
    [anon_sym_explicit] = ACTIONS(29),
    [anon_sym_constexpr] = ACTIONS(29),
    [anon_sym_unsigned] = ACTIONS(31),
    [anon_sym_long] = ACTIONS(31),
    [anon_sym_short] = ACTIONS(31),
    [sym_primitive_type] = ACTIONS(236),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_union] = ACTIONS(39),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(45),
    [sym_identifier] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(51),
    [sym_auto] = ACTIONS(236),
    [anon_sym_typename] = ACTIONS(53),
    [anon_sym_COLON_COLON] = ACTIONS(61),
    [sym_operator_name] = ACTIONS(63),
  },
  [38] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(148),
    [anon_sym_LPAREN] = ACTIONS(238),
    [anon_sym_SEMI] = ACTIONS(238),
    [anon_sym_extern] = ACTIONS(240),
    [anon_sym_STAR] = ACTIONS(238),
    [anon_sym_LBRACK] = ACTIONS(238),
    [anon_sym_static] = ACTIONS(240),
    [anon_sym_register] = ACTIONS(240),
    [anon_sym_inline] = ACTIONS(240),
    [anon_sym_const] = ACTIONS(240),
    [anon_sym_restrict] = ACTIONS(240),
    [anon_sym_volatile] = ACTIONS(240),
    [anon_sym__Atomic] = ACTIONS(240),
    [anon_sym_mutable] = ACTIONS(240),
    [anon_sym_explicit] = ACTIONS(240),
    [anon_sym_constexpr] = ACTIONS(240),
    [anon_sym_unsigned] = ACTIONS(242),
    [anon_sym_long] = ACTIONS(242),
    [anon_sym_short] = ACTIONS(242),
    [sym_primitive_type] = ACTIONS(244),
    [anon_sym_AMP] = ACTIONS(240),
    [anon_sym_AMP_AMP] = ACTIONS(238),
    [anon_sym_TILDE] = ACTIONS(238),
    [sym_identifier] = ACTIONS(246),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(238),
    [sym_operator_name] = ACTIONS(238),
  },
  [39] = {
    [ts_builtin_sym_end] = ACTIONS(249),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(251),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(251),
    [anon_sym_LPAREN] = ACTIONS(249),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(251),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(251),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(251),
    [sym_preproc_directive] = ACTIONS(251),
    [anon_sym_typedef] = ACTIONS(251),
    [anon_sym_extern] = ACTIONS(251),
    [anon_sym_RBRACE] = ACTIONS(249),
    [anon_sym_STAR] = ACTIONS(249),
    [anon_sym_static] = ACTIONS(251),
    [anon_sym_register] = ACTIONS(251),
    [anon_sym_inline] = ACTIONS(251),
    [anon_sym_const] = ACTIONS(251),
    [anon_sym_restrict] = ACTIONS(251),
    [anon_sym_volatile] = ACTIONS(251),
    [anon_sym__Atomic] = ACTIONS(251),
    [anon_sym_mutable] = ACTIONS(251),
    [anon_sym_explicit] = ACTIONS(251),
    [anon_sym_constexpr] = ACTIONS(251),
    [anon_sym_unsigned] = ACTIONS(251),
    [anon_sym_long] = ACTIONS(251),
    [anon_sym_short] = ACTIONS(251),
    [sym_primitive_type] = ACTIONS(251),
    [anon_sym_enum] = ACTIONS(251),
    [anon_sym_struct] = ACTIONS(251),
    [anon_sym_union] = ACTIONS(251),
    [anon_sym_AMP] = ACTIONS(251),
    [anon_sym_AMP_AMP] = ACTIONS(249),
    [anon_sym_TILDE] = ACTIONS(249),
    [sym_identifier] = ACTIONS(251),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(251),
    [sym_auto] = ACTIONS(251),
    [anon_sym_typename] = ACTIONS(251),
    [anon_sym_template] = ACTIONS(251),
    [anon_sym_namespace] = ACTIONS(251),
    [anon_sym_using] = ACTIONS(251),
    [anon_sym_COLON_COLON] = ACTIONS(249),
    [sym_operator_name] = ACTIONS(249),
  },
  [40] = {
    [sym_preproc_params] = STATE(152),
    [aux_sym_SLASH_LBRACK_BSLASHt_RBRACK_PLUS_SLASH] = ACTIONS(253),
    [anon_sym_LF] = ACTIONS(255),
    [anon_sym_LPAREN] = ACTIONS(257),
    [sym_comment] = ACTIONS(83),
  },
  [41] = {
    [sym__declarator] = STATE(153),
    [sym_pointer_declarator] = STATE(153),
    [sym_function_declarator] = STATE(153),
    [sym_array_declarator] = STATE(153),
    [sym_reference_declarator] = STATE(153),
    [sym_template_type] = STATE(46),
    [sym_template_function] = STATE(153),
    [sym_destructor_name] = STATE(153),
    [sym_scoped_identifier] = STATE(33),
    [sym_scoped_type_identifier] = STATE(47),
    [sym_scoped_namespace_identifier] = STATE(46),
    [anon_sym_LPAREN] = ACTIONS(11),
    [anon_sym_STAR] = ACTIONS(69),
    [anon_sym_AMP] = ACTIONS(71),
    [anon_sym_AMP_AMP] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(45),
    [sym_identifier] = ACTIONS(75),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(77),
    [sym_operator_name] = ACTIONS(259),
  },
  [42] = {
    [sym__declarator] = STATE(154),
    [sym_pointer_declarator] = STATE(154),
    [sym_function_declarator] = STATE(154),
    [sym_array_declarator] = STATE(154),
    [sym_reference_declarator] = STATE(154),
    [sym_template_type] = STATE(46),
    [sym_template_function] = STATE(154),
    [sym_destructor_name] = STATE(154),
    [sym_scoped_identifier] = STATE(33),
    [sym_scoped_type_identifier] = STATE(47),
    [sym_scoped_namespace_identifier] = STATE(46),
    [anon_sym_LPAREN] = ACTIONS(11),
    [anon_sym_STAR] = ACTIONS(69),
    [anon_sym_AMP] = ACTIONS(71),
    [anon_sym_AMP_AMP] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(45),
    [sym_identifier] = ACTIONS(75),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(77),
    [sym_operator_name] = ACTIONS(261),
  },
  [43] = {
    [sym_template_argument_list] = STATE(156),
    [anon_sym_LPAREN] = ACTIONS(210),
    [anon_sym_COMMA] = ACTIONS(210),
    [anon_sym_RPAREN] = ACTIONS(210),
    [anon_sym_SEMI] = ACTIONS(210),
    [anon_sym_LBRACE] = ACTIONS(210),
    [anon_sym_LBRACK] = ACTIONS(210),
    [anon_sym_EQ] = ACTIONS(210),
    [anon_sym_COLON] = ACTIONS(263),
    [anon_sym_LT] = ACTIONS(146),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(265),
  },
  [44] = {
    [sym_destructor_name] = STATE(120),
    [anon_sym_TILDE] = ACTIONS(45),
    [sym_identifier] = ACTIONS(267),
    [sym_comment] = ACTIONS(49),
    [sym_operator_name] = ACTIONS(190),
  },
  [45] = {
    [sym_parameter_list] = STATE(159),
    [anon_sym_LPAREN] = ACTIONS(206),
    [anon_sym_RPAREN] = ACTIONS(269),
    [anon_sym_LBRACK] = ACTIONS(208),
    [sym_comment] = ACTIONS(49),
  },
  [46] = {
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(271),
  },
  [47] = {
    [sym_template_argument_list] = STATE(141),
    [anon_sym_LT] = ACTIONS(146),
    [sym_comment] = ACTIONS(49),
  },
  [48] = {
    [sym_preproc_include] = STATE(179),
    [sym_preproc_def] = STATE(179),
    [sym_preproc_function_def] = STATE(179),
    [sym_preproc_call] = STATE(179),
    [sym_preproc_if] = STATE(179),
    [sym_preproc_ifdef] = STATE(179),
    [sym_preproc_else] = STATE(175),
    [sym_preproc_elif] = STATE(175),
    [sym_function_definition] = STATE(179),
    [sym_declaration] = STATE(179),
    [sym_type_definition] = STATE(179),
    [sym__declaration_specifiers] = STATE(176),
    [sym_linkage_specification] = STATE(179),
    [sym__declarator] = STATE(28),
    [sym_pointer_declarator] = STATE(28),
    [sym_function_declarator] = STATE(177),
    [sym_array_declarator] = STATE(28),
    [sym_storage_class_specifier] = STATE(180),
    [sym_type_qualifier] = STATE(180),
    [sym__type_specifier] = STATE(30),
    [sym_sized_type_specifier] = STATE(30),
    [sym_enum_specifier] = STATE(30),
    [sym_struct_specifier] = STATE(30),
    [sym_union_specifier] = STATE(30),
    [sym__empty_declaration] = STATE(179),
    [sym_macro_type_specifier] = STATE(30),
    [sym_class_specifier] = STATE(30),
    [sym_dependent_type] = STATE(30),
    [sym_structured_binding_declaration] = STATE(179),
    [sym_template_declaration] = STATE(179),
    [sym_template_instantiation] = STATE(179),
    [sym_constructor_or_destructor_definition] = STATE(178),
    [sym_reference_declarator] = STATE(28),
    [sym_template_type] = STATE(32),
    [sym_template_function] = STATE(28),
    [sym_namespace_definition] = STATE(179),
    [sym_using_declaration] = STATE(179),
    [sym_alias_declaration] = STATE(179),
    [sym_destructor_name] = STATE(28),
    [sym_scoped_identifier] = STATE(33),
    [sym_scoped_type_identifier] = STATE(34),
    [sym_scoped_namespace_identifier] = STATE(35),
    [aux_sym_translation_unit_repeat1] = STATE(179),
    [aux_sym__declaration_specifiers_repeat1] = STATE(180),
    [aux_sym_sized_type_specifier_repeat1] = STATE(38),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(273),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(275),
    [anon_sym_LPAREN] = ACTIONS(11),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(277),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(279),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(281),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(283),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(285),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(287),
    [sym_preproc_directive] = ACTIONS(289),
    [anon_sym_typedef] = ACTIONS(291),
    [anon_sym_extern] = ACTIONS(293),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_static] = ACTIONS(27),
    [anon_sym_register] = ACTIONS(27),
    [anon_sym_inline] = ACTIONS(27),
    [anon_sym_const] = ACTIONS(29),
    [anon_sym_restrict] = ACTIONS(29),
    [anon_sym_volatile] = ACTIONS(29),
    [anon_sym__Atomic] = ACTIONS(29),
    [anon_sym_mutable] = ACTIONS(29),
    [anon_sym_explicit] = ACTIONS(29),
    [anon_sym_constexpr] = ACTIONS(29),
    [anon_sym_unsigned] = ACTIONS(31),
    [anon_sym_long] = ACTIONS(31),
    [anon_sym_short] = ACTIONS(31),
    [sym_primitive_type] = ACTIONS(33),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_union] = ACTIONS(39),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(45),
    [sym_identifier] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(51),
    [sym_auto] = ACTIONS(33),
    [anon_sym_typename] = ACTIONS(53),
    [anon_sym_template] = ACTIONS(295),
    [anon_sym_namespace] = ACTIONS(297),
    [anon_sym_using] = ACTIONS(299),
    [anon_sym_COLON_COLON] = ACTIONS(61),
    [sym_operator_name] = ACTIONS(63),
  },
  [49] = {
    [sym_preproc_include] = STATE(183),
    [sym_preproc_def] = STATE(183),
    [sym_preproc_function_def] = STATE(183),
    [sym_preproc_call] = STATE(183),
    [sym_preproc_if] = STATE(183),
    [sym_preproc_ifdef] = STATE(183),
    [sym_preproc_else] = STATE(182),
    [sym_preproc_elif] = STATE(182),
    [sym_function_definition] = STATE(183),
    [sym_declaration] = STATE(183),
    [sym_type_definition] = STATE(183),
    [sym__declaration_specifiers] = STATE(176),
    [sym_linkage_specification] = STATE(183),
    [sym__declarator] = STATE(28),
    [sym_pointer_declarator] = STATE(28),
    [sym_function_declarator] = STATE(177),
    [sym_array_declarator] = STATE(28),
    [sym_storage_class_specifier] = STATE(180),
    [sym_type_qualifier] = STATE(180),
    [sym__type_specifier] = STATE(30),
    [sym_sized_type_specifier] = STATE(30),
    [sym_enum_specifier] = STATE(30),
    [sym_struct_specifier] = STATE(30),
    [sym_union_specifier] = STATE(30),
    [sym__empty_declaration] = STATE(183),
    [sym_macro_type_specifier] = STATE(30),
    [sym_class_specifier] = STATE(30),
    [sym_dependent_type] = STATE(30),
    [sym_structured_binding_declaration] = STATE(183),
    [sym_template_declaration] = STATE(183),
    [sym_template_instantiation] = STATE(183),
    [sym_constructor_or_destructor_definition] = STATE(178),
    [sym_reference_declarator] = STATE(28),
    [sym_template_type] = STATE(32),
    [sym_template_function] = STATE(28),
    [sym_namespace_definition] = STATE(183),
    [sym_using_declaration] = STATE(183),
    [sym_alias_declaration] = STATE(183),
    [sym_destructor_name] = STATE(28),
    [sym_scoped_identifier] = STATE(33),
    [sym_scoped_type_identifier] = STATE(34),
    [sym_scoped_namespace_identifier] = STATE(35),
    [aux_sym_translation_unit_repeat1] = STATE(183),
    [aux_sym__declaration_specifiers_repeat1] = STATE(180),
    [aux_sym_sized_type_specifier_repeat1] = STATE(38),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(273),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(275),
    [anon_sym_LPAREN] = ACTIONS(11),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(277),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(301),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(281),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(283),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(285),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(287),
    [sym_preproc_directive] = ACTIONS(289),
    [anon_sym_typedef] = ACTIONS(291),
    [anon_sym_extern] = ACTIONS(293),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_static] = ACTIONS(27),
    [anon_sym_register] = ACTIONS(27),
    [anon_sym_inline] = ACTIONS(27),
    [anon_sym_const] = ACTIONS(29),
    [anon_sym_restrict] = ACTIONS(29),
    [anon_sym_volatile] = ACTIONS(29),
    [anon_sym__Atomic] = ACTIONS(29),
    [anon_sym_mutable] = ACTIONS(29),
    [anon_sym_explicit] = ACTIONS(29),
    [anon_sym_constexpr] = ACTIONS(29),
    [anon_sym_unsigned] = ACTIONS(31),
    [anon_sym_long] = ACTIONS(31),
    [anon_sym_short] = ACTIONS(31),
    [sym_primitive_type] = ACTIONS(33),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_union] = ACTIONS(39),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(45),
    [sym_identifier] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(51),
    [sym_auto] = ACTIONS(33),
    [anon_sym_typename] = ACTIONS(53),
    [anon_sym_template] = ACTIONS(295),
    [anon_sym_namespace] = ACTIONS(297),
    [anon_sym_using] = ACTIONS(299),
    [anon_sym_COLON_COLON] = ACTIONS(61),
    [sym_operator_name] = ACTIONS(63),
  },
  [50] = {
    [sym_preproc_include] = STATE(186),
    [sym_preproc_def] = STATE(186),
    [sym_preproc_function_def] = STATE(186),
    [sym_preproc_call] = STATE(186),
    [sym_preproc_if] = STATE(186),
    [sym_preproc_ifdef] = STATE(186),
    [sym_preproc_else] = STATE(185),
    [sym_preproc_elif] = STATE(185),
    [sym_function_definition] = STATE(186),
    [sym_declaration] = STATE(186),
    [sym_type_definition] = STATE(186),
    [sym__declaration_specifiers] = STATE(176),
    [sym_linkage_specification] = STATE(186),
    [sym__declarator] = STATE(28),
    [sym_pointer_declarator] = STATE(28),
    [sym_function_declarator] = STATE(177),
    [sym_array_declarator] = STATE(28),
    [sym_storage_class_specifier] = STATE(180),
    [sym_type_qualifier] = STATE(180),
    [sym__type_specifier] = STATE(30),
    [sym_sized_type_specifier] = STATE(30),
    [sym_enum_specifier] = STATE(30),
    [sym_struct_specifier] = STATE(30),
    [sym_union_specifier] = STATE(30),
    [sym__empty_declaration] = STATE(186),
    [sym_macro_type_specifier] = STATE(30),
    [sym_class_specifier] = STATE(30),
    [sym_dependent_type] = STATE(30),
    [sym_structured_binding_declaration] = STATE(186),
    [sym_template_declaration] = STATE(186),
    [sym_template_instantiation] = STATE(186),
    [sym_constructor_or_destructor_definition] = STATE(178),
    [sym_reference_declarator] = STATE(28),
    [sym_template_type] = STATE(32),
    [sym_template_function] = STATE(28),
    [sym_namespace_definition] = STATE(186),
    [sym_using_declaration] = STATE(186),
    [sym_alias_declaration] = STATE(186),
    [sym_destructor_name] = STATE(28),
    [sym_scoped_identifier] = STATE(33),
    [sym_scoped_type_identifier] = STATE(34),
    [sym_scoped_namespace_identifier] = STATE(35),
    [aux_sym_translation_unit_repeat1] = STATE(186),
    [aux_sym__declaration_specifiers_repeat1] = STATE(180),
    [aux_sym_sized_type_specifier_repeat1] = STATE(38),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(273),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(275),
    [anon_sym_LPAREN] = ACTIONS(11),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(277),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(303),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(281),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(283),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(285),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(287),
    [sym_preproc_directive] = ACTIONS(289),
    [anon_sym_typedef] = ACTIONS(291),
    [anon_sym_extern] = ACTIONS(293),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_static] = ACTIONS(27),
    [anon_sym_register] = ACTIONS(27),
    [anon_sym_inline] = ACTIONS(27),
    [anon_sym_const] = ACTIONS(29),
    [anon_sym_restrict] = ACTIONS(29),
    [anon_sym_volatile] = ACTIONS(29),
    [anon_sym__Atomic] = ACTIONS(29),
    [anon_sym_mutable] = ACTIONS(29),
    [anon_sym_explicit] = ACTIONS(29),
    [anon_sym_constexpr] = ACTIONS(29),
    [anon_sym_unsigned] = ACTIONS(31),
    [anon_sym_long] = ACTIONS(31),
    [anon_sym_short] = ACTIONS(31),
    [sym_primitive_type] = ACTIONS(33),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_union] = ACTIONS(39),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(45),
    [sym_identifier] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(51),
    [sym_auto] = ACTIONS(33),
    [anon_sym_typename] = ACTIONS(53),
    [anon_sym_template] = ACTIONS(295),
    [anon_sym_namespace] = ACTIONS(297),
    [anon_sym_using] = ACTIONS(299),
    [anon_sym_COLON_COLON] = ACTIONS(61),
    [sym_operator_name] = ACTIONS(63),
  },
  [51] = {
    [sym_preproc_arg] = ACTIONS(305),
    [sym_comment] = ACTIONS(83),
  },
  [52] = {
    [ts_builtin_sym_end] = ACTIONS(307),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(309),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(309),
    [anon_sym_LPAREN] = ACTIONS(307),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(309),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(309),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(309),
    [sym_preproc_directive] = ACTIONS(309),
    [anon_sym_typedef] = ACTIONS(309),
    [anon_sym_extern] = ACTIONS(309),
    [anon_sym_RBRACE] = ACTIONS(307),
    [anon_sym_STAR] = ACTIONS(307),
    [anon_sym_static] = ACTIONS(309),
    [anon_sym_register] = ACTIONS(309),
    [anon_sym_inline] = ACTIONS(309),
    [anon_sym_const] = ACTIONS(309),
    [anon_sym_restrict] = ACTIONS(309),
    [anon_sym_volatile] = ACTIONS(309),
    [anon_sym__Atomic] = ACTIONS(309),
    [anon_sym_mutable] = ACTIONS(309),
    [anon_sym_explicit] = ACTIONS(309),
    [anon_sym_constexpr] = ACTIONS(309),
    [anon_sym_unsigned] = ACTIONS(309),
    [anon_sym_long] = ACTIONS(309),
    [anon_sym_short] = ACTIONS(309),
    [sym_primitive_type] = ACTIONS(309),
    [anon_sym_enum] = ACTIONS(309),
    [anon_sym_struct] = ACTIONS(309),
    [anon_sym_union] = ACTIONS(309),
    [anon_sym_AMP] = ACTIONS(309),
    [anon_sym_AMP_AMP] = ACTIONS(307),
    [anon_sym_TILDE] = ACTIONS(307),
    [sym_identifier] = ACTIONS(309),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(309),
    [sym_auto] = ACTIONS(309),
    [anon_sym_typename] = ACTIONS(309),
    [anon_sym_template] = ACTIONS(309),
    [anon_sym_namespace] = ACTIONS(309),
    [anon_sym_using] = ACTIONS(309),
    [anon_sym_COLON_COLON] = ACTIONS(307),
    [sym_operator_name] = ACTIONS(307),
  },
  [53] = {
    [anon_sym_const] = ACTIONS(123),
    [anon_sym_restrict] = ACTIONS(123),
    [anon_sym_volatile] = ACTIONS(123),
    [anon_sym__Atomic] = ACTIONS(123),
    [anon_sym_mutable] = ACTIONS(123),
    [anon_sym_explicit] = ACTIONS(123),
    [anon_sym_constexpr] = ACTIONS(123),
    [anon_sym_unsigned] = ACTIONS(123),
    [anon_sym_long] = ACTIONS(123),
    [anon_sym_short] = ACTIONS(123),
    [sym_primitive_type] = ACTIONS(123),
    [anon_sym_enum] = ACTIONS(123),
    [anon_sym_struct] = ACTIONS(123),
    [anon_sym_union] = ACTIONS(123),
    [sym_identifier] = ACTIONS(123),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(123),
    [sym_auto] = ACTIONS(123),
    [anon_sym_typename] = ACTIONS(123),
    [anon_sym_COLON_COLON] = ACTIONS(121),
  },
  [54] = {
    [sym_enumerator_list] = STATE(190),
    [anon_sym_LBRACE] = ACTIONS(311),
    [sym_identifier] = ACTIONS(313),
    [sym_comment] = ACTIONS(49),
  },
  [55] = {
    [sym_field_declaration_list] = STATE(193),
    [sym__class_name] = STATE(194),
    [sym_base_class_clause] = STATE(195),
    [sym_template_type] = STATE(196),
    [sym_scoped_type_identifier] = STATE(197),
    [sym_scoped_namespace_identifier] = STATE(64),
    [anon_sym_LBRACE] = ACTIONS(315),
    [anon_sym_COLON] = ACTIONS(131),
    [sym_identifier] = ACTIONS(317),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(111),
  },
  [56] = {
    [sym_field_declaration_list] = STATE(198),
    [sym__class_name] = STATE(199),
    [sym_base_class_clause] = STATE(200),
    [sym_template_type] = STATE(196),
    [sym_scoped_type_identifier] = STATE(197),
    [sym_scoped_namespace_identifier] = STATE(64),
    [anon_sym_LBRACE] = ACTIONS(315),
    [anon_sym_COLON] = ACTIONS(131),
    [sym_identifier] = ACTIONS(317),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(111),
  },
  [57] = {
    [sym_template_argument_list] = STATE(203),
    [anon_sym_LPAREN] = ACTIONS(142),
    [anon_sym_STAR] = ACTIONS(142),
    [anon_sym_LT] = ACTIONS(319),
    [sym_identifier] = ACTIONS(142),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(321),
  },
  [58] = {
    [sym_field_declaration_list] = STATE(204),
    [sym__class_name] = STATE(205),
    [sym_base_class_clause] = STATE(206),
    [sym_template_type] = STATE(196),
    [sym_scoped_type_identifier] = STATE(197),
    [sym_scoped_namespace_identifier] = STATE(64),
    [anon_sym_LBRACE] = ACTIONS(315),
    [anon_sym_COLON] = ACTIONS(131),
    [sym_identifier] = ACTIONS(317),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(111),
  },
  [59] = {
    [sym__type_specifier] = STATE(207),
    [sym_sized_type_specifier] = STATE(207),
    [sym_enum_specifier] = STATE(207),
    [sym_struct_specifier] = STATE(207),
    [sym_union_specifier] = STATE(207),
    [sym_macro_type_specifier] = STATE(207),
    [sym_class_specifier] = STATE(207),
    [sym_dependent_type] = STATE(207),
    [sym_template_type] = STATE(62),
    [sym_scoped_type_identifier] = STATE(63),
    [sym_scoped_namespace_identifier] = STATE(64),
    [aux_sym_sized_type_specifier_repeat1] = STATE(66),
    [anon_sym_unsigned] = ACTIONS(95),
    [anon_sym_long] = ACTIONS(95),
    [anon_sym_short] = ACTIONS(95),
    [sym_primitive_type] = ACTIONS(323),
    [anon_sym_enum] = ACTIONS(99),
    [anon_sym_struct] = ACTIONS(101),
    [anon_sym_union] = ACTIONS(103),
    [sym_identifier] = ACTIONS(105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(107),
    [sym_auto] = ACTIONS(323),
    [anon_sym_typename] = ACTIONS(109),
    [anon_sym_COLON_COLON] = ACTIONS(111),
  },
  [60] = {
    [sym_identifier] = ACTIONS(325),
    [sym_comment] = ACTIONS(49),
  },
  [61] = {
    [sym__type_declarator] = STATE(212),
    [sym_pointer_type_declarator] = STATE(213),
    [sym_function_type_declarator] = STATE(214),
    [sym_array_type_declarator] = STATE(215),
    [anon_sym_LPAREN] = ACTIONS(327),
    [anon_sym_STAR] = ACTIONS(329),
    [sym_identifier] = ACTIONS(331),
    [sym_comment] = ACTIONS(49),
  },
  [62] = {
    [anon_sym_LPAREN] = ACTIONS(228),
    [anon_sym_COMMA] = ACTIONS(228),
    [anon_sym_RPAREN] = ACTIONS(228),
    [anon_sym_SEMI] = ACTIONS(228),
    [anon_sym_LBRACE] = ACTIONS(228),
    [anon_sym_STAR] = ACTIONS(228),
    [anon_sym_LBRACK] = ACTIONS(228),
    [anon_sym_AMP] = ACTIONS(230),
    [anon_sym_AMP_AMP] = ACTIONS(228),
    [anon_sym_GT] = ACTIONS(228),
    [sym_identifier] = ACTIONS(228),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(333),
  },
  [63] = {
    [sym_template_argument_list] = STATE(217),
    [anon_sym_LPAREN] = ACTIONS(228),
    [anon_sym_STAR] = ACTIONS(228),
    [anon_sym_LT] = ACTIONS(319),
    [sym_identifier] = ACTIONS(228),
    [sym_comment] = ACTIONS(49),
  },
  [64] = {
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(333),
  },
  [65] = {
    [sym_type_qualifier] = STATE(219),
    [sym__type_specifier] = STATE(218),
    [sym_sized_type_specifier] = STATE(218),
    [sym_enum_specifier] = STATE(218),
    [sym_struct_specifier] = STATE(218),
    [sym_union_specifier] = STATE(218),
    [sym_macro_type_specifier] = STATE(218),
    [sym_class_specifier] = STATE(218),
    [sym_dependent_type] = STATE(218),
    [sym_template_type] = STATE(62),
    [sym_scoped_type_identifier] = STATE(63),
    [sym_scoped_namespace_identifier] = STATE(64),
    [aux_sym_type_definition_repeat1] = STATE(219),
    [aux_sym_sized_type_specifier_repeat1] = STATE(66),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_restrict] = ACTIONS(93),
    [anon_sym_volatile] = ACTIONS(93),
    [anon_sym__Atomic] = ACTIONS(93),
    [anon_sym_mutable] = ACTIONS(93),
    [anon_sym_explicit] = ACTIONS(93),
    [anon_sym_constexpr] = ACTIONS(93),
    [anon_sym_unsigned] = ACTIONS(95),
    [anon_sym_long] = ACTIONS(95),
    [anon_sym_short] = ACTIONS(95),
    [sym_primitive_type] = ACTIONS(335),
    [anon_sym_enum] = ACTIONS(99),
    [anon_sym_struct] = ACTIONS(101),
    [anon_sym_union] = ACTIONS(103),
    [sym_identifier] = ACTIONS(105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(107),
    [sym_auto] = ACTIONS(335),
    [anon_sym_typename] = ACTIONS(109),
    [anon_sym_COLON_COLON] = ACTIONS(111),
  },
  [66] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(222),
    [anon_sym_LPAREN] = ACTIONS(238),
    [anon_sym_STAR] = ACTIONS(238),
    [anon_sym_unsigned] = ACTIONS(337),
    [anon_sym_long] = ACTIONS(337),
    [anon_sym_short] = ACTIONS(337),
    [sym_primitive_type] = ACTIONS(339),
    [sym_identifier] = ACTIONS(341),
    [sym_comment] = ACTIONS(49),
  },
  [67] = {
    [sym_function_definition] = STATE(223),
    [sym_declaration] = STATE(223),
    [sym__declaration_specifiers] = STATE(224),
    [sym_declaration_list] = STATE(223),
    [sym_storage_class_specifier] = STATE(109),
    [sym_type_qualifier] = STATE(109),
    [sym__type_specifier] = STATE(105),
    [sym_sized_type_specifier] = STATE(105),
    [sym_enum_specifier] = STATE(105),
    [sym_struct_specifier] = STATE(105),
    [sym_union_specifier] = STATE(105),
    [sym_macro_type_specifier] = STATE(105),
    [sym_class_specifier] = STATE(105),
    [sym_dependent_type] = STATE(105),
    [sym_template_type] = STATE(94),
    [sym_scoped_type_identifier] = STATE(34),
    [sym_scoped_namespace_identifier] = STATE(81),
    [aux_sym__declaration_specifiers_repeat1] = STATE(109),
    [aux_sym_sized_type_specifier_repeat1] = STATE(110),
    [anon_sym_extern] = ACTIONS(154),
    [anon_sym_LBRACE] = ACTIONS(178),
    [anon_sym_static] = ACTIONS(154),
    [anon_sym_register] = ACTIONS(154),
    [anon_sym_inline] = ACTIONS(154),
    [anon_sym_const] = ACTIONS(158),
    [anon_sym_restrict] = ACTIONS(158),
    [anon_sym_volatile] = ACTIONS(158),
    [anon_sym__Atomic] = ACTIONS(158),
    [anon_sym_mutable] = ACTIONS(158),
    [anon_sym_explicit] = ACTIONS(158),
    [anon_sym_constexpr] = ACTIONS(158),
    [anon_sym_unsigned] = ACTIONS(160),
    [anon_sym_long] = ACTIONS(160),
    [anon_sym_short] = ACTIONS(160),
    [sym_primitive_type] = ACTIONS(162),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_union] = ACTIONS(39),
    [sym_identifier] = ACTIONS(152),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(51),
    [sym_auto] = ACTIONS(162),
    [anon_sym_typename] = ACTIONS(172),
    [anon_sym_COLON_COLON] = ACTIONS(135),
  },
  [68] = {
    [sym_parameter_list] = STATE(225),
    [anon_sym_LPAREN] = ACTIONS(206),
    [anon_sym_LBRACK] = ACTIONS(208),
    [sym_comment] = ACTIONS(49),
  },
  [69] = {
    [sym_enumerator] = STATE(229),
    [anon_sym_COMMA] = ACTIONS(344),
    [anon_sym_RBRACE] = ACTIONS(346),
    [sym_identifier] = ACTIONS(348),
    [sym_comment] = ACTIONS(49),
  },
  [70] = {
    [sym_enumerator_list] = STATE(230),
    [anon_sym_LPAREN] = ACTIONS(350),
    [anon_sym_COMMA] = ACTIONS(350),
    [anon_sym_RPAREN] = ACTIONS(350),
    [anon_sym_SEMI] = ACTIONS(350),
    [anon_sym_extern] = ACTIONS(352),
    [anon_sym_LBRACE] = ACTIONS(125),
    [anon_sym_STAR] = ACTIONS(350),
    [anon_sym_LBRACK] = ACTIONS(350),
    [anon_sym_static] = ACTIONS(352),
    [anon_sym_register] = ACTIONS(352),
    [anon_sym_inline] = ACTIONS(352),
    [anon_sym_const] = ACTIONS(352),
    [anon_sym_restrict] = ACTIONS(352),
    [anon_sym_volatile] = ACTIONS(352),
    [anon_sym__Atomic] = ACTIONS(352),
    [anon_sym_mutable] = ACTIONS(352),
    [anon_sym_explicit] = ACTIONS(352),
    [anon_sym_constexpr] = ACTIONS(352),
    [anon_sym_COLON] = ACTIONS(352),
    [anon_sym_AMP] = ACTIONS(352),
    [anon_sym_AMP_AMP] = ACTIONS(350),
    [anon_sym_TILDE] = ACTIONS(350),
    [anon_sym_GT] = ACTIONS(350),
    [sym_identifier] = ACTIONS(352),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(350),
    [sym_operator_name] = ACTIONS(350),
  },
  [71] = {
    [anon_sym_LPAREN] = ACTIONS(354),
    [anon_sym_COMMA] = ACTIONS(354),
    [anon_sym_RPAREN] = ACTIONS(354),
    [anon_sym_SEMI] = ACTIONS(354),
    [anon_sym_extern] = ACTIONS(356),
    [anon_sym_LBRACE] = ACTIONS(354),
    [anon_sym_STAR] = ACTIONS(354),
    [anon_sym_LBRACK] = ACTIONS(354),
    [anon_sym_static] = ACTIONS(356),
    [anon_sym_register] = ACTIONS(356),
    [anon_sym_inline] = ACTIONS(356),
    [anon_sym_const] = ACTIONS(356),
    [anon_sym_restrict] = ACTIONS(356),
    [anon_sym_volatile] = ACTIONS(356),
    [anon_sym__Atomic] = ACTIONS(356),
    [anon_sym_mutable] = ACTIONS(356),
    [anon_sym_explicit] = ACTIONS(356),
    [anon_sym_constexpr] = ACTIONS(356),
    [anon_sym_COLON] = ACTIONS(356),
    [anon_sym_AMP] = ACTIONS(356),
    [anon_sym_AMP_AMP] = ACTIONS(354),
    [anon_sym_TILDE] = ACTIONS(354),
    [anon_sym_GT] = ACTIONS(354),
    [sym_identifier] = ACTIONS(356),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(354),
    [sym_operator_name] = ACTIONS(354),
  },
  [72] = {
    [sym_preproc_if_in_field_declaration_list] = STATE(246),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(247),
    [sym_type_definition] = STATE(256),
    [sym__declaration_specifiers] = STATE(248),
    [sym__declarator] = STATE(249),
    [sym_pointer_declarator] = STATE(249),
    [sym_function_declarator] = STATE(250),
    [sym_array_declarator] = STATE(249),
    [sym_storage_class_specifier] = STATE(257),
    [sym_type_qualifier] = STATE(257),
    [sym__type_specifier] = STATE(251),
    [sym_sized_type_specifier] = STATE(251),
    [sym_enum_specifier] = STATE(251),
    [sym_struct_specifier] = STATE(251),
    [sym_union_specifier] = STATE(251),
    [sym__field_declaration_list_item] = STATE(256),
    [sym_field_declaration] = STATE(256),
    [sym_macro_type_specifier] = STATE(251),
    [sym_class_specifier] = STATE(251),
    [sym_dependent_type] = STATE(251),
    [sym_template_declaration] = STATE(256),
    [sym_inline_method_definition] = STATE(252),
    [sym_constructor_or_destructor_definition] = STATE(252),
    [sym_constructor_or_destructor_declaration] = STATE(253),
    [sym_friend_declaration] = STATE(256),
    [sym_access_specifier] = STATE(256),
    [sym_reference_declarator] = STATE(249),
    [sym_template_type] = STATE(254),
    [sym_template_function] = STATE(249),
    [sym_using_declaration] = STATE(256),
    [sym_alias_declaration] = STATE(256),
    [sym_destructor_name] = STATE(249),
    [sym_scoped_identifier] = STATE(33),
    [sym_scoped_type_identifier] = STATE(34),
    [sym_scoped_namespace_identifier] = STATE(255),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(256),
    [aux_sym__declaration_specifiers_repeat1] = STATE(257),
    [aux_sym_sized_type_specifier_repeat1] = STATE(258),
    [anon_sym_LPAREN] = ACTIONS(11),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(358),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(360),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(362),
    [anon_sym_typedef] = ACTIONS(364),
    [anon_sym_extern] = ACTIONS(27),
    [anon_sym_RBRACE] = ACTIONS(366),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_static] = ACTIONS(27),
    [anon_sym_register] = ACTIONS(27),
    [anon_sym_inline] = ACTIONS(27),
    [anon_sym_const] = ACTIONS(29),
    [anon_sym_restrict] = ACTIONS(29),
    [anon_sym_volatile] = ACTIONS(29),
    [anon_sym__Atomic] = ACTIONS(29),
    [anon_sym_mutable] = ACTIONS(29),
    [anon_sym_explicit] = ACTIONS(29),
    [anon_sym_constexpr] = ACTIONS(29),
    [anon_sym_unsigned] = ACTIONS(368),
    [anon_sym_long] = ACTIONS(368),
    [anon_sym_short] = ACTIONS(368),
    [sym_primitive_type] = ACTIONS(370),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(372),
    [anon_sym_union] = ACTIONS(374),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(45),
    [sym_identifier] = ACTIONS(376),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(378),
    [anon_sym_public] = ACTIONS(380),
    [sym_auto] = ACTIONS(370),
    [anon_sym_typename] = ACTIONS(382),
    [anon_sym_template] = ACTIONS(384),
    [anon_sym_friend] = ACTIONS(386),
    [anon_sym_private] = ACTIONS(380),
    [anon_sym_protected] = ACTIONS(380),
    [anon_sym_using] = ACTIONS(388),
    [anon_sym_COLON_COLON] = ACTIONS(390),
    [sym_operator_name] = ACTIONS(392),
  },
  [73] = {
    [sym__class_name] = STATE(261),
    [sym_template_type] = STATE(196),
    [sym_scoped_type_identifier] = STATE(80),
    [sym_scoped_namespace_identifier] = STATE(64),
    [sym_identifier] = ACTIONS(394),
    [sym_comment] = ACTIONS(49),
    [anon_sym_public] = ACTIONS(396),
    [anon_sym_COLON_COLON] = ACTIONS(111),
  },
  [74] = {
    [sym_template_argument_list] = STATE(263),
    [anon_sym_LPAREN] = ACTIONS(398),
    [anon_sym_COMMA] = ACTIONS(398),
    [anon_sym_RPAREN] = ACTIONS(398),
    [anon_sym_SEMI] = ACTIONS(398),
    [anon_sym_extern] = ACTIONS(400),
    [anon_sym_LBRACE] = ACTIONS(398),
    [anon_sym_STAR] = ACTIONS(398),
    [anon_sym_LBRACK] = ACTIONS(398),
    [anon_sym_static] = ACTIONS(400),
    [anon_sym_register] = ACTIONS(400),
    [anon_sym_inline] = ACTIONS(400),
    [anon_sym_const] = ACTIONS(400),
    [anon_sym_restrict] = ACTIONS(400),
    [anon_sym_volatile] = ACTIONS(400),
    [anon_sym__Atomic] = ACTIONS(400),
    [anon_sym_mutable] = ACTIONS(400),
    [anon_sym_explicit] = ACTIONS(400),
    [anon_sym_constexpr] = ACTIONS(400),
    [anon_sym_COLON] = ACTIONS(400),
    [anon_sym_AMP] = ACTIONS(400),
    [anon_sym_AMP_AMP] = ACTIONS(398),
    [anon_sym_TILDE] = ACTIONS(398),
    [anon_sym_LT] = ACTIONS(146),
    [anon_sym_GT] = ACTIONS(398),
    [sym_identifier] = ACTIONS(400),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(402),
    [sym_operator_name] = ACTIONS(398),
  },
  [75] = {
    [sym_identifier] = ACTIONS(404),
    [sym_comment] = ACTIONS(49),
  },
  [76] = {
    [anon_sym_LPAREN] = ACTIONS(406),
    [anon_sym_COMMA] = ACTIONS(406),
    [anon_sym_RPAREN] = ACTIONS(406),
    [anon_sym_SEMI] = ACTIONS(406),
    [anon_sym_extern] = ACTIONS(408),
    [anon_sym_LBRACE] = ACTIONS(406),
    [anon_sym_STAR] = ACTIONS(406),
    [anon_sym_LBRACK] = ACTIONS(406),
    [anon_sym_static] = ACTIONS(408),
    [anon_sym_register] = ACTIONS(408),
    [anon_sym_inline] = ACTIONS(408),
    [anon_sym_const] = ACTIONS(408),
    [anon_sym_restrict] = ACTIONS(408),
    [anon_sym_volatile] = ACTIONS(408),
    [anon_sym__Atomic] = ACTIONS(408),
    [anon_sym_mutable] = ACTIONS(408),
    [anon_sym_explicit] = ACTIONS(408),
    [anon_sym_constexpr] = ACTIONS(408),
    [anon_sym_COLON] = ACTIONS(408),
    [anon_sym_AMP] = ACTIONS(408),
    [anon_sym_AMP_AMP] = ACTIONS(406),
    [anon_sym_TILDE] = ACTIONS(406),
    [anon_sym_GT] = ACTIONS(406),
    [sym_identifier] = ACTIONS(408),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(406),
    [sym_operator_name] = ACTIONS(406),
  },
  [77] = {
    [sym_field_declaration_list] = STATE(265),
    [sym_base_class_clause] = STATE(266),
    [anon_sym_LPAREN] = ACTIONS(406),
    [anon_sym_COMMA] = ACTIONS(406),
    [anon_sym_RPAREN] = ACTIONS(406),
    [anon_sym_SEMI] = ACTIONS(406),
    [anon_sym_extern] = ACTIONS(408),
    [anon_sym_LBRACE] = ACTIONS(129),
    [anon_sym_STAR] = ACTIONS(406),
    [anon_sym_LBRACK] = ACTIONS(406),
    [anon_sym_static] = ACTIONS(408),
    [anon_sym_register] = ACTIONS(408),
    [anon_sym_inline] = ACTIONS(408),
    [anon_sym_const] = ACTIONS(408),
    [anon_sym_restrict] = ACTIONS(408),
    [anon_sym_volatile] = ACTIONS(408),
    [anon_sym__Atomic] = ACTIONS(408),
    [anon_sym_mutable] = ACTIONS(408),
    [anon_sym_explicit] = ACTIONS(408),
    [anon_sym_constexpr] = ACTIONS(408),
    [anon_sym_COLON] = ACTIONS(131),
    [anon_sym_AMP] = ACTIONS(408),
    [anon_sym_AMP_AMP] = ACTIONS(406),
    [anon_sym_TILDE] = ACTIONS(406),
    [anon_sym_GT] = ACTIONS(406),
    [sym_identifier] = ACTIONS(408),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(406),
    [sym_operator_name] = ACTIONS(406),
  },
  [78] = {
    [sym_field_declaration_list] = STATE(265),
    [anon_sym_LBRACE] = ACTIONS(129),
    [sym_comment] = ACTIONS(49),
  },
  [79] = {
    [anon_sym_LPAREN] = ACTIONS(410),
    [anon_sym_COMMA] = ACTIONS(410),
    [anon_sym_RPAREN] = ACTIONS(410),
    [anon_sym_SEMI] = ACTIONS(410),
    [anon_sym_extern] = ACTIONS(412),
    [anon_sym_LBRACE] = ACTIONS(410),
    [anon_sym_STAR] = ACTIONS(410),
    [anon_sym_LBRACK] = ACTIONS(410),
    [anon_sym_static] = ACTIONS(412),
    [anon_sym_register] = ACTIONS(412),
    [anon_sym_inline] = ACTIONS(412),
    [anon_sym_const] = ACTIONS(412),
    [anon_sym_restrict] = ACTIONS(412),
    [anon_sym_volatile] = ACTIONS(412),
    [anon_sym__Atomic] = ACTIONS(412),
    [anon_sym_mutable] = ACTIONS(412),
    [anon_sym_explicit] = ACTIONS(412),
    [anon_sym_constexpr] = ACTIONS(412),
    [anon_sym_COLON] = ACTIONS(412),
    [anon_sym_AMP] = ACTIONS(412),
    [anon_sym_AMP_AMP] = ACTIONS(410),
    [anon_sym_TILDE] = ACTIONS(410),
    [anon_sym_GT] = ACTIONS(410),
    [sym_identifier] = ACTIONS(412),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(414),
    [sym_operator_name] = ACTIONS(410),
  },
  [80] = {
    [sym_template_argument_list] = STATE(141),
    [anon_sym_LPAREN] = ACTIONS(410),
    [anon_sym_COMMA] = ACTIONS(410),
    [anon_sym_RPAREN] = ACTIONS(410),
    [anon_sym_SEMI] = ACTIONS(410),
    [anon_sym_extern] = ACTIONS(412),
    [anon_sym_LBRACE] = ACTIONS(410),
    [anon_sym_STAR] = ACTIONS(410),
    [anon_sym_LBRACK] = ACTIONS(410),
    [anon_sym_static] = ACTIONS(412),
    [anon_sym_register] = ACTIONS(412),
    [anon_sym_inline] = ACTIONS(412),
    [anon_sym_const] = ACTIONS(412),
    [anon_sym_restrict] = ACTIONS(412),
    [anon_sym_volatile] = ACTIONS(412),
    [anon_sym__Atomic] = ACTIONS(412),
    [anon_sym_mutable] = ACTIONS(412),
    [anon_sym_explicit] = ACTIONS(412),
    [anon_sym_constexpr] = ACTIONS(412),
    [anon_sym_COLON] = ACTIONS(412),
    [anon_sym_AMP] = ACTIONS(412),
    [anon_sym_AMP_AMP] = ACTIONS(410),
    [anon_sym_TILDE] = ACTIONS(410),
    [anon_sym_LT] = ACTIONS(146),
    [anon_sym_GT] = ACTIONS(410),
    [sym_identifier] = ACTIONS(412),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(410),
    [sym_operator_name] = ACTIONS(410),
  },
  [81] = {
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(414),
  },
  [82] = {
    [anon_sym_LPAREN] = ACTIONS(416),
    [anon_sym_COMMA] = ACTIONS(416),
    [anon_sym_RPAREN] = ACTIONS(416),
    [anon_sym_SEMI] = ACTIONS(416),
    [anon_sym_extern] = ACTIONS(418),
    [anon_sym_LBRACE] = ACTIONS(416),
    [anon_sym_STAR] = ACTIONS(416),
    [anon_sym_LBRACK] = ACTIONS(416),
    [anon_sym_static] = ACTIONS(418),
    [anon_sym_register] = ACTIONS(418),
    [anon_sym_inline] = ACTIONS(418),
    [anon_sym_const] = ACTIONS(418),
    [anon_sym_restrict] = ACTIONS(418),
    [anon_sym_volatile] = ACTIONS(418),
    [anon_sym__Atomic] = ACTIONS(418),
    [anon_sym_mutable] = ACTIONS(418),
    [anon_sym_explicit] = ACTIONS(418),
    [anon_sym_constexpr] = ACTIONS(418),
    [anon_sym_COLON] = ACTIONS(418),
    [anon_sym_AMP] = ACTIONS(418),
    [anon_sym_AMP_AMP] = ACTIONS(416),
    [anon_sym_TILDE] = ACTIONS(416),
    [anon_sym_GT] = ACTIONS(416),
    [sym_identifier] = ACTIONS(418),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(416),
    [sym_operator_name] = ACTIONS(416),
  },
  [83] = {
    [sym_field_declaration_list] = STATE(268),
    [sym_base_class_clause] = STATE(269),
    [anon_sym_LPAREN] = ACTIONS(416),
    [anon_sym_COMMA] = ACTIONS(416),
    [anon_sym_RPAREN] = ACTIONS(416),
    [anon_sym_SEMI] = ACTIONS(416),
    [anon_sym_extern] = ACTIONS(418),
    [anon_sym_LBRACE] = ACTIONS(129),
    [anon_sym_STAR] = ACTIONS(416),
    [anon_sym_LBRACK] = ACTIONS(416),
    [anon_sym_static] = ACTIONS(418),
    [anon_sym_register] = ACTIONS(418),
    [anon_sym_inline] = ACTIONS(418),
    [anon_sym_const] = ACTIONS(418),
    [anon_sym_restrict] = ACTIONS(418),
    [anon_sym_volatile] = ACTIONS(418),
    [anon_sym__Atomic] = ACTIONS(418),
    [anon_sym_mutable] = ACTIONS(418),
    [anon_sym_explicit] = ACTIONS(418),
    [anon_sym_constexpr] = ACTIONS(418),
    [anon_sym_COLON] = ACTIONS(131),
    [anon_sym_AMP] = ACTIONS(418),
    [anon_sym_AMP_AMP] = ACTIONS(416),
    [anon_sym_TILDE] = ACTIONS(416),
    [anon_sym_GT] = ACTIONS(416),
    [sym_identifier] = ACTIONS(418),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(416),
    [sym_operator_name] = ACTIONS(416),
  },
  [84] = {
    [sym_field_declaration_list] = STATE(268),
    [anon_sym_LBRACE] = ACTIONS(129),
    [sym_comment] = ACTIONS(49),
  },
  [85] = {
    [anon_sym_LPAREN] = ACTIONS(420),
    [anon_sym_COMMA] = ACTIONS(420),
    [anon_sym_RPAREN] = ACTIONS(420),
    [anon_sym_SEMI] = ACTIONS(420),
    [anon_sym_LBRACE] = ACTIONS(420),
    [anon_sym_LBRACK] = ACTIONS(420),
    [anon_sym_EQ] = ACTIONS(420),
    [anon_sym_COLON] = ACTIONS(420),
    [anon_sym_LT] = ACTIONS(420),
    [anon_sym_GT] = ACTIONS(420),
    [sym_comment] = ACTIONS(49),
  },
  [86] = {
    [sym_type_qualifier] = STATE(279),
    [sym__type_specifier] = STATE(277),
    [sym_sized_type_specifier] = STATE(277),
    [sym_enum_specifier] = STATE(277),
    [sym_struct_specifier] = STATE(277),
    [sym_union_specifier] = STATE(277),
    [sym_type_descriptor] = STATE(278),
    [sym_parenthesized_expression] = STATE(278),
    [sym_macro_type_specifier] = STATE(277),
    [sym_class_specifier] = STATE(277),
    [sym_dependent_type] = STATE(277),
    [sym_template_type] = STATE(62),
    [sym_scoped_type_identifier] = STATE(34),
    [sym_scoped_namespace_identifier] = STATE(64),
    [aux_sym_type_definition_repeat1] = STATE(279),
    [aux_sym_sized_type_specifier_repeat1] = STATE(280),
    [anon_sym_LPAREN] = ACTIONS(422),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_restrict] = ACTIONS(93),
    [anon_sym_volatile] = ACTIONS(93),
    [anon_sym__Atomic] = ACTIONS(93),
    [anon_sym_mutable] = ACTIONS(93),
    [anon_sym_explicit] = ACTIONS(93),
    [anon_sym_constexpr] = ACTIONS(93),
    [anon_sym_unsigned] = ACTIONS(424),
    [anon_sym_long] = ACTIONS(424),
    [anon_sym_short] = ACTIONS(424),
    [sym_primitive_type] = ACTIONS(426),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(428),
    [anon_sym_union] = ACTIONS(430),
    [anon_sym_GT] = ACTIONS(432),
    [sym_identifier] = ACTIONS(434),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(436),
    [sym_auto] = ACTIONS(426),
    [anon_sym_typename] = ACTIONS(438),
    [anon_sym_COLON_COLON] = ACTIONS(111),
  },
  [87] = {
    [sym_destructor_name] = STATE(282),
    [anon_sym_TILDE] = ACTIONS(45),
    [sym_identifier] = ACTIONS(440),
    [sym_comment] = ACTIONS(49),
    [sym_operator_name] = ACTIONS(442),
  },
  [88] = {
    [anon_sym_LPAREN] = ACTIONS(444),
    [anon_sym_COMMA] = ACTIONS(447),
    [anon_sym_RPAREN] = ACTIONS(444),
    [anon_sym_SEMI] = ACTIONS(447),
    [anon_sym_extern] = ACTIONS(449),
    [anon_sym_STAR] = ACTIONS(447),
    [anon_sym_LBRACK] = ACTIONS(444),
    [anon_sym_static] = ACTIONS(449),
    [anon_sym_register] = ACTIONS(449),
    [anon_sym_inline] = ACTIONS(449),
    [anon_sym_const] = ACTIONS(449),
    [anon_sym_restrict] = ACTIONS(449),
    [anon_sym_volatile] = ACTIONS(449),
    [anon_sym__Atomic] = ACTIONS(449),
    [anon_sym_mutable] = ACTIONS(449),
    [anon_sym_explicit] = ACTIONS(449),
    [anon_sym_constexpr] = ACTIONS(449),
    [anon_sym_AMP] = ACTIONS(449),
    [anon_sym_AMP_AMP] = ACTIONS(447),
    [anon_sym_TILDE] = ACTIONS(447),
    [sym_identifier] = ACTIONS(449),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(447),
    [sym_operator_name] = ACTIONS(447),
  },
  [89] = {
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_COMMA] = ACTIONS(451),
    [anon_sym_RPAREN] = ACTIONS(451),
    [anon_sym_SEMI] = ACTIONS(451),
    [anon_sym_extern] = ACTIONS(453),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_STAR] = ACTIONS(451),
    [anon_sym_LBRACK] = ACTIONS(451),
    [anon_sym_static] = ACTIONS(453),
    [anon_sym_register] = ACTIONS(453),
    [anon_sym_inline] = ACTIONS(453),
    [anon_sym_const] = ACTIONS(453),
    [anon_sym_restrict] = ACTIONS(453),
    [anon_sym_volatile] = ACTIONS(453),
    [anon_sym__Atomic] = ACTIONS(453),
    [anon_sym_mutable] = ACTIONS(453),
    [anon_sym_explicit] = ACTIONS(453),
    [anon_sym_constexpr] = ACTIONS(453),
    [anon_sym_COLON] = ACTIONS(453),
    [anon_sym_AMP] = ACTIONS(453),
    [anon_sym_AMP_AMP] = ACTIONS(451),
    [anon_sym_TILDE] = ACTIONS(451),
    [anon_sym_GT] = ACTIONS(451),
    [sym_identifier] = ACTIONS(453),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(451),
    [sym_operator_name] = ACTIONS(451),
  },
  [90] = {
    [sym_field_declaration_list] = STATE(283),
    [sym_base_class_clause] = STATE(284),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_COMMA] = ACTIONS(451),
    [anon_sym_RPAREN] = ACTIONS(451),
    [anon_sym_SEMI] = ACTIONS(451),
    [anon_sym_extern] = ACTIONS(453),
    [anon_sym_LBRACE] = ACTIONS(129),
    [anon_sym_STAR] = ACTIONS(451),
    [anon_sym_LBRACK] = ACTIONS(451),
    [anon_sym_static] = ACTIONS(453),
    [anon_sym_register] = ACTIONS(453),
    [anon_sym_inline] = ACTIONS(453),
    [anon_sym_const] = ACTIONS(453),
    [anon_sym_restrict] = ACTIONS(453),
    [anon_sym_volatile] = ACTIONS(453),
    [anon_sym__Atomic] = ACTIONS(453),
    [anon_sym_mutable] = ACTIONS(453),
    [anon_sym_explicit] = ACTIONS(453),
    [anon_sym_constexpr] = ACTIONS(453),
    [anon_sym_COLON] = ACTIONS(131),
    [anon_sym_AMP] = ACTIONS(453),
    [anon_sym_AMP_AMP] = ACTIONS(451),
    [anon_sym_TILDE] = ACTIONS(451),
    [anon_sym_GT] = ACTIONS(451),
    [sym_identifier] = ACTIONS(453),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(451),
    [sym_operator_name] = ACTIONS(451),
  },
  [91] = {
    [sym_field_declaration_list] = STATE(283),
    [anon_sym_LBRACE] = ACTIONS(129),
    [sym_comment] = ACTIONS(49),
  },
  [92] = {
    [sym_template_argument_list] = STATE(263),
    [anon_sym_LPAREN] = ACTIONS(142),
    [anon_sym_COMMA] = ACTIONS(142),
    [anon_sym_RPAREN] = ACTIONS(142),
    [anon_sym_SEMI] = ACTIONS(142),
    [anon_sym_extern] = ACTIONS(144),
    [anon_sym_STAR] = ACTIONS(142),
    [anon_sym_LBRACK] = ACTIONS(142),
    [anon_sym_static] = ACTIONS(144),
    [anon_sym_register] = ACTIONS(144),
    [anon_sym_inline] = ACTIONS(144),
    [anon_sym_const] = ACTIONS(144),
    [anon_sym_restrict] = ACTIONS(144),
    [anon_sym_volatile] = ACTIONS(144),
    [anon_sym__Atomic] = ACTIONS(144),
    [anon_sym_mutable] = ACTIONS(144),
    [anon_sym_explicit] = ACTIONS(144),
    [anon_sym_constexpr] = ACTIONS(144),
    [anon_sym_COLON] = ACTIONS(144),
    [anon_sym_AMP] = ACTIONS(144),
    [anon_sym_AMP_AMP] = ACTIONS(142),
    [anon_sym_TILDE] = ACTIONS(142),
    [anon_sym_LT] = ACTIONS(146),
    [anon_sym_GT] = ACTIONS(142),
    [sym_identifier] = ACTIONS(144),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(402),
    [sym_operator_name] = ACTIONS(142),
  },
  [93] = {
    [anon_sym_LPAREN] = ACTIONS(455),
    [anon_sym_COMMA] = ACTIONS(455),
    [anon_sym_RPAREN] = ACTIONS(455),
    [anon_sym_SEMI] = ACTIONS(455),
    [anon_sym_extern] = ACTIONS(457),
    [anon_sym_LBRACE] = ACTIONS(455),
    [anon_sym_STAR] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(455),
    [anon_sym_static] = ACTIONS(457),
    [anon_sym_register] = ACTIONS(457),
    [anon_sym_inline] = ACTIONS(457),
    [anon_sym_const] = ACTIONS(457),
    [anon_sym_restrict] = ACTIONS(457),
    [anon_sym_volatile] = ACTIONS(457),
    [anon_sym__Atomic] = ACTIONS(457),
    [anon_sym_mutable] = ACTIONS(457),
    [anon_sym_explicit] = ACTIONS(457),
    [anon_sym_constexpr] = ACTIONS(457),
    [anon_sym_COLON] = ACTIONS(457),
    [anon_sym_AMP] = ACTIONS(457),
    [anon_sym_AMP_AMP] = ACTIONS(455),
    [anon_sym_TILDE] = ACTIONS(455),
    [anon_sym_GT] = ACTIONS(455),
    [sym_identifier] = ACTIONS(457),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(455),
    [sym_operator_name] = ACTIONS(455),
  },
  [94] = {
    [anon_sym_LPAREN] = ACTIONS(228),
    [anon_sym_COMMA] = ACTIONS(228),
    [anon_sym_RPAREN] = ACTIONS(228),
    [anon_sym_SEMI] = ACTIONS(228),
    [anon_sym_extern] = ACTIONS(230),
    [anon_sym_STAR] = ACTIONS(228),
    [anon_sym_LBRACK] = ACTIONS(228),
    [anon_sym_static] = ACTIONS(230),
    [anon_sym_register] = ACTIONS(230),
    [anon_sym_inline] = ACTIONS(230),
    [anon_sym_const] = ACTIONS(230),
    [anon_sym_restrict] = ACTIONS(230),
    [anon_sym_volatile] = ACTIONS(230),
    [anon_sym__Atomic] = ACTIONS(230),
    [anon_sym_mutable] = ACTIONS(230),
    [anon_sym_explicit] = ACTIONS(230),
    [anon_sym_constexpr] = ACTIONS(230),
    [anon_sym_COLON] = ACTIONS(230),
    [anon_sym_AMP] = ACTIONS(230),
    [anon_sym_AMP_AMP] = ACTIONS(228),
    [anon_sym_TILDE] = ACTIONS(228),
    [anon_sym_GT] = ACTIONS(228),
    [sym_identifier] = ACTIONS(230),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(414),
    [sym_operator_name] = ACTIONS(228),
  },
  [95] = {
    [anon_sym_extern] = ACTIONS(115),
    [anon_sym_static] = ACTIONS(115),
    [anon_sym_register] = ACTIONS(115),
    [anon_sym_inline] = ACTIONS(115),
    [anon_sym_const] = ACTIONS(115),
    [anon_sym_restrict] = ACTIONS(115),
    [anon_sym_volatile] = ACTIONS(115),
    [anon_sym__Atomic] = ACTIONS(115),
    [anon_sym_mutable] = ACTIONS(115),
    [anon_sym_explicit] = ACTIONS(115),
    [anon_sym_constexpr] = ACTIONS(115),
    [anon_sym_unsigned] = ACTIONS(115),
    [anon_sym_long] = ACTIONS(115),
    [anon_sym_short] = ACTIONS(115),
    [sym_primitive_type] = ACTIONS(115),
    [anon_sym_enum] = ACTIONS(115),
    [anon_sym_struct] = ACTIONS(115),
    [anon_sym_union] = ACTIONS(115),
    [sym_identifier] = ACTIONS(115),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(115),
    [sym_auto] = ACTIONS(115),
    [anon_sym_typename] = ACTIONS(115),
    [anon_sym_COLON_COLON] = ACTIONS(113),
  },
  [96] = {
    [sym__declarator] = STATE(285),
    [sym_pointer_declarator] = STATE(285),
    [sym_function_declarator] = STATE(285),
    [sym_array_declarator] = STATE(285),
    [sym_reference_declarator] = STATE(285),
    [sym_template_type] = STATE(46),
    [sym_template_function] = STATE(285),
    [sym_destructor_name] = STATE(285),
    [sym_scoped_identifier] = STATE(33),
    [sym_scoped_type_identifier] = STATE(47),
    [sym_scoped_namespace_identifier] = STATE(46),
    [anon_sym_LPAREN] = ACTIONS(11),
    [anon_sym_STAR] = ACTIONS(156),
    [anon_sym_AMP] = ACTIONS(164),
    [anon_sym_AMP_AMP] = ACTIONS(166),
    [anon_sym_TILDE] = ACTIONS(45),
    [sym_identifier] = ACTIONS(75),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(77),
    [sym_operator_name] = ACTIONS(459),
  },
  [97] = {
    [anon_sym_extern] = ACTIONS(123),
    [anon_sym_static] = ACTIONS(123),
    [anon_sym_register] = ACTIONS(123),
    [anon_sym_inline] = ACTIONS(123),
    [anon_sym_const] = ACTIONS(123),
    [anon_sym_restrict] = ACTIONS(123),
    [anon_sym_volatile] = ACTIONS(123),
    [anon_sym__Atomic] = ACTIONS(123),
    [anon_sym_mutable] = ACTIONS(123),
    [anon_sym_explicit] = ACTIONS(123),
    [anon_sym_constexpr] = ACTIONS(123),
    [anon_sym_unsigned] = ACTIONS(123),
    [anon_sym_long] = ACTIONS(123),
    [anon_sym_short] = ACTIONS(123),
    [sym_primitive_type] = ACTIONS(123),
    [anon_sym_enum] = ACTIONS(123),
    [anon_sym_struct] = ACTIONS(123),
    [anon_sym_union] = ACTIONS(123),
    [sym_identifier] = ACTIONS(123),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(123),
    [sym_auto] = ACTIONS(123),
    [anon_sym_typename] = ACTIONS(123),
    [anon_sym_COLON_COLON] = ACTIONS(121),
  },
  [98] = {
    [sym__declarator] = STATE(286),
    [sym_pointer_declarator] = STATE(286),
    [sym_function_declarator] = STATE(286),
    [sym_array_declarator] = STATE(286),
    [sym_reference_declarator] = STATE(286),
    [sym_template_type] = STATE(46),
    [sym_template_function] = STATE(286),
    [sym_destructor_name] = STATE(286),
    [sym_scoped_identifier] = STATE(33),
    [sym_scoped_type_identifier] = STATE(47),
    [sym_scoped_namespace_identifier] = STATE(46),
    [anon_sym_LPAREN] = ACTIONS(11),
    [anon_sym_STAR] = ACTIONS(156),
    [anon_sym_AMP] = ACTIONS(164),
    [anon_sym_AMP_AMP] = ACTIONS(166),
    [anon_sym_TILDE] = ACTIONS(45),
    [sym_identifier] = ACTIONS(75),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(77),
    [sym_operator_name] = ACTIONS(461),
  },
  [99] = {
    [sym__declaration_specifiers] = STATE(289),
    [sym_storage_class_specifier] = STATE(292),
    [sym_type_qualifier] = STATE(292),
    [sym__type_specifier] = STATE(290),
    [sym_sized_type_specifier] = STATE(290),
    [sym_enum_specifier] = STATE(290),
    [sym_struct_specifier] = STATE(290),
    [sym_union_specifier] = STATE(290),
    [sym_parameter_declaration] = STATE(291),
    [sym_macro_type_specifier] = STATE(290),
    [sym_class_specifier] = STATE(290),
    [sym_dependent_type] = STATE(290),
    [sym_type_parameter_declaration] = STATE(291),
    [sym_optional_type_parameter_declaration] = STATE(291),
    [sym_template_type] = STATE(94),
    [sym_scoped_type_identifier] = STATE(34),
    [sym_scoped_namespace_identifier] = STATE(81),
    [aux_sym__declaration_specifiers_repeat1] = STATE(292),
    [aux_sym_sized_type_specifier_repeat1] = STATE(293),
    [anon_sym_extern] = ACTIONS(154),
    [anon_sym_static] = ACTIONS(154),
    [anon_sym_register] = ACTIONS(154),
    [anon_sym_inline] = ACTIONS(154),
    [anon_sym_const] = ACTIONS(158),
    [anon_sym_restrict] = ACTIONS(158),
    [anon_sym_volatile] = ACTIONS(158),
    [anon_sym__Atomic] = ACTIONS(158),
    [anon_sym_mutable] = ACTIONS(158),
    [anon_sym_explicit] = ACTIONS(158),
    [anon_sym_constexpr] = ACTIONS(158),
    [anon_sym_unsigned] = ACTIONS(463),
    [anon_sym_long] = ACTIONS(463),
    [anon_sym_short] = ACTIONS(463),
    [sym_primitive_type] = ACTIONS(465),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_union] = ACTIONS(39),
    [anon_sym_GT] = ACTIONS(467),
    [sym_identifier] = ACTIONS(152),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(51),
    [sym_auto] = ACTIONS(465),
    [anon_sym_typename] = ACTIONS(469),
    [anon_sym_COLON_COLON] = ACTIONS(135),
  },
  [100] = {
    [sym_template_argument_list] = STATE(295),
    [anon_sym_LPAREN] = ACTIONS(139),
    [anon_sym_SEMI] = ACTIONS(210),
    [anon_sym_extern] = ACTIONS(144),
    [anon_sym_STAR] = ACTIONS(142),
    [anon_sym_LBRACK] = ACTIONS(210),
    [anon_sym_static] = ACTIONS(144),
    [anon_sym_register] = ACTIONS(144),
    [anon_sym_inline] = ACTIONS(144),
    [anon_sym_const] = ACTIONS(144),
    [anon_sym_restrict] = ACTIONS(144),
    [anon_sym_volatile] = ACTIONS(144),
    [anon_sym__Atomic] = ACTIONS(144),
    [anon_sym_mutable] = ACTIONS(144),
    [anon_sym_explicit] = ACTIONS(144),
    [anon_sym_constexpr] = ACTIONS(144),
    [anon_sym_AMP] = ACTIONS(144),
    [anon_sym_AMP_AMP] = ACTIONS(142),
    [anon_sym_TILDE] = ACTIONS(142),
    [anon_sym_LT] = ACTIONS(146),
    [sym_identifier] = ACTIONS(144),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(471),
    [sym_operator_name] = ACTIONS(142),
  },
  [101] = {
    [sym__type_specifier] = STATE(93),
    [sym_sized_type_specifier] = STATE(93),
    [sym_enum_specifier] = STATE(93),
    [sym_struct_specifier] = STATE(93),
    [sym_union_specifier] = STATE(93),
    [sym_macro_type_specifier] = STATE(93),
    [sym_class_specifier] = STATE(93),
    [sym_dependent_type] = STATE(93),
    [sym_template_type] = STATE(94),
    [sym_scoped_type_identifier] = STATE(34),
    [sym_scoped_namespace_identifier] = STATE(81),
    [aux_sym_sized_type_specifier_repeat1] = STATE(110),
    [anon_sym_unsigned] = ACTIONS(160),
    [anon_sym_long] = ACTIONS(160),
    [anon_sym_short] = ACTIONS(160),
    [sym_primitive_type] = ACTIONS(150),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_union] = ACTIONS(39),
    [sym_identifier] = ACTIONS(152),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(51),
    [sym_auto] = ACTIONS(150),
    [anon_sym_typename] = ACTIONS(172),
    [anon_sym_COLON_COLON] = ACTIONS(135),
  },
  [102] = {
    [sym_destructor_name] = STATE(120),
    [anon_sym_TILDE] = ACTIONS(45),
    [sym_identifier] = ACTIONS(473),
    [sym_comment] = ACTIONS(49),
    [sym_operator_name] = ACTIONS(190),
  },
  [103] = {
    [sym__declarator] = STATE(297),
    [sym_pointer_declarator] = STATE(297),
    [sym_function_declarator] = STATE(297),
    [sym_array_declarator] = STATE(297),
    [sym_reference_declarator] = STATE(297),
    [sym_template_type] = STATE(46),
    [sym_template_function] = STATE(297),
    [sym_destructor_name] = STATE(297),
    [sym_scoped_identifier] = STATE(33),
    [sym_scoped_type_identifier] = STATE(47),
    [sym_scoped_namespace_identifier] = STATE(46),
    [anon_sym_LPAREN] = ACTIONS(11),
    [anon_sym_STAR] = ACTIONS(156),
    [anon_sym_AMP] = ACTIONS(164),
    [anon_sym_AMP_AMP] = ACTIONS(166),
    [anon_sym_TILDE] = ACTIONS(45),
    [sym_identifier] = ACTIONS(75),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(77),
    [sym_operator_name] = ACTIONS(475),
  },
  [104] = {
    [sym_parameter_list] = STATE(299),
    [anon_sym_LPAREN] = ACTIONS(206),
    [anon_sym_SEMI] = ACTIONS(477),
    [anon_sym_LBRACK] = ACTIONS(208),
    [sym_comment] = ACTIONS(49),
  },
  [105] = {
    [sym_storage_class_specifier] = STATE(300),
    [sym_type_qualifier] = STATE(300),
    [aux_sym__declaration_specifiers_repeat1] = STATE(300),
    [anon_sym_LPAREN] = ACTIONS(216),
    [anon_sym_extern] = ACTIONS(218),
    [anon_sym_STAR] = ACTIONS(216),
    [anon_sym_static] = ACTIONS(218),
    [anon_sym_register] = ACTIONS(218),
    [anon_sym_inline] = ACTIONS(218),
    [anon_sym_const] = ACTIONS(220),
    [anon_sym_restrict] = ACTIONS(220),
    [anon_sym_volatile] = ACTIONS(220),
    [anon_sym__Atomic] = ACTIONS(220),
    [anon_sym_mutable] = ACTIONS(220),
    [anon_sym_explicit] = ACTIONS(220),
    [anon_sym_constexpr] = ACTIONS(220),
    [anon_sym_AMP] = ACTIONS(222),
    [anon_sym_AMP_AMP] = ACTIONS(216),
    [anon_sym_TILDE] = ACTIONS(216),
    [sym_identifier] = ACTIONS(222),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(216),
    [sym_operator_name] = ACTIONS(216),
  },
  [106] = {
    [sym_function_definition] = STATE(302),
    [sym_declaration] = STATE(302),
    [sym__declaration_specifiers] = STATE(303),
    [sym_storage_class_specifier] = STATE(305),
    [sym_type_qualifier] = STATE(305),
    [sym__type_specifier] = STATE(304),
    [sym_sized_type_specifier] = STATE(304),
    [sym_enum_specifier] = STATE(304),
    [sym_struct_specifier] = STATE(304),
    [sym_union_specifier] = STATE(304),
    [sym__empty_declaration] = STATE(302),
    [sym_macro_type_specifier] = STATE(304),
    [sym_class_specifier] = STATE(304),
    [sym_dependent_type] = STATE(304),
    [sym_template_type] = STATE(94),
    [sym_scoped_type_identifier] = STATE(34),
    [sym_scoped_namespace_identifier] = STATE(81),
    [aux_sym__declaration_specifiers_repeat1] = STATE(305),
    [aux_sym_sized_type_specifier_repeat1] = STATE(306),
    [anon_sym_extern] = ACTIONS(154),
    [anon_sym_static] = ACTIONS(154),
    [anon_sym_register] = ACTIONS(154),
    [anon_sym_inline] = ACTIONS(154),
    [anon_sym_const] = ACTIONS(158),
    [anon_sym_restrict] = ACTIONS(158),
    [anon_sym_volatile] = ACTIONS(158),
    [anon_sym__Atomic] = ACTIONS(158),
    [anon_sym_mutable] = ACTIONS(158),
    [anon_sym_explicit] = ACTIONS(158),
    [anon_sym_constexpr] = ACTIONS(158),
    [anon_sym_unsigned] = ACTIONS(479),
    [anon_sym_long] = ACTIONS(479),
    [anon_sym_short] = ACTIONS(479),
    [sym_primitive_type] = ACTIONS(481),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_union] = ACTIONS(39),
    [sym_identifier] = ACTIONS(152),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(51),
    [sym_auto] = ACTIONS(481),
    [anon_sym_typename] = ACTIONS(483),
    [anon_sym_COLON_COLON] = ACTIONS(135),
  },
  [107] = {
    [anon_sym_LPAREN] = ACTIONS(228),
    [anon_sym_extern] = ACTIONS(230),
    [anon_sym_STAR] = ACTIONS(228),
    [anon_sym_static] = ACTIONS(230),
    [anon_sym_register] = ACTIONS(230),
    [anon_sym_inline] = ACTIONS(230),
    [anon_sym_const] = ACTIONS(230),
    [anon_sym_restrict] = ACTIONS(230),
    [anon_sym_volatile] = ACTIONS(230),
    [anon_sym__Atomic] = ACTIONS(230),
    [anon_sym_mutable] = ACTIONS(230),
    [anon_sym_explicit] = ACTIONS(230),
    [anon_sym_constexpr] = ACTIONS(230),
    [anon_sym_AMP] = ACTIONS(230),
    [anon_sym_AMP_AMP] = ACTIONS(228),
    [anon_sym_TILDE] = ACTIONS(228),
    [sym_identifier] = ACTIONS(230),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(485),
    [sym_operator_name] = ACTIONS(228),
  },
  [108] = {
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(485),
  },
  [109] = {
    [sym_storage_class_specifier] = STATE(309),
    [sym_type_qualifier] = STATE(309),
    [sym__type_specifier] = STATE(308),
    [sym_sized_type_specifier] = STATE(308),
    [sym_enum_specifier] = STATE(308),
    [sym_struct_specifier] = STATE(308),
    [sym_union_specifier] = STATE(308),
    [sym_macro_type_specifier] = STATE(308),
    [sym_class_specifier] = STATE(308),
    [sym_dependent_type] = STATE(308),
    [sym_template_type] = STATE(94),
    [sym_scoped_type_identifier] = STATE(34),
    [sym_scoped_namespace_identifier] = STATE(81),
    [aux_sym__declaration_specifiers_repeat1] = STATE(309),
    [aux_sym_sized_type_specifier_repeat1] = STATE(110),
    [anon_sym_extern] = ACTIONS(154),
    [anon_sym_static] = ACTIONS(154),
    [anon_sym_register] = ACTIONS(154),
    [anon_sym_inline] = ACTIONS(154),
    [anon_sym_const] = ACTIONS(158),
    [anon_sym_restrict] = ACTIONS(158),
    [anon_sym_volatile] = ACTIONS(158),
    [anon_sym__Atomic] = ACTIONS(158),
    [anon_sym_mutable] = ACTIONS(158),
    [anon_sym_explicit] = ACTIONS(158),
    [anon_sym_constexpr] = ACTIONS(158),
    [anon_sym_unsigned] = ACTIONS(160),
    [anon_sym_long] = ACTIONS(160),
    [anon_sym_short] = ACTIONS(160),
    [sym_primitive_type] = ACTIONS(487),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_union] = ACTIONS(39),
    [sym_identifier] = ACTIONS(152),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(51),
    [sym_auto] = ACTIONS(487),
    [anon_sym_typename] = ACTIONS(172),
    [anon_sym_COLON_COLON] = ACTIONS(135),
  },
  [110] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(310),
    [anon_sym_LPAREN] = ACTIONS(238),
    [anon_sym_extern] = ACTIONS(240),
    [anon_sym_STAR] = ACTIONS(238),
    [anon_sym_static] = ACTIONS(240),
    [anon_sym_register] = ACTIONS(240),
    [anon_sym_inline] = ACTIONS(240),
    [anon_sym_const] = ACTIONS(240),
    [anon_sym_restrict] = ACTIONS(240),
    [anon_sym_volatile] = ACTIONS(240),
    [anon_sym__Atomic] = ACTIONS(240),
    [anon_sym_mutable] = ACTIONS(240),
    [anon_sym_explicit] = ACTIONS(240),
    [anon_sym_constexpr] = ACTIONS(240),
    [anon_sym_unsigned] = ACTIONS(489),
    [anon_sym_long] = ACTIONS(489),
    [anon_sym_short] = ACTIONS(489),
    [sym_primitive_type] = ACTIONS(244),
    [anon_sym_AMP] = ACTIONS(240),
    [anon_sym_AMP_AMP] = ACTIONS(238),
    [anon_sym_TILDE] = ACTIONS(238),
    [sym_identifier] = ACTIONS(246),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(238),
    [sym_operator_name] = ACTIONS(238),
  },
  [111] = {
    [sym_preproc_include] = STATE(312),
    [sym_preproc_def] = STATE(312),
    [sym_preproc_function_def] = STATE(312),
    [sym_preproc_call] = STATE(312),
    [sym_preproc_if] = STATE(312),
    [sym_preproc_ifdef] = STATE(312),
    [sym_function_definition] = STATE(312),
    [sym_declaration] = STATE(312),
    [sym_type_definition] = STATE(312),
    [sym__declaration_specifiers] = STATE(27),
    [sym_linkage_specification] = STATE(312),
    [sym__declarator] = STATE(28),
    [sym_pointer_declarator] = STATE(28),
    [sym_function_declarator] = STATE(29),
    [sym_array_declarator] = STATE(28),
    [sym_storage_class_specifier] = STATE(37),
    [sym_type_qualifier] = STATE(37),
    [sym__type_specifier] = STATE(30),
    [sym_sized_type_specifier] = STATE(30),
    [sym_enum_specifier] = STATE(30),
    [sym_struct_specifier] = STATE(30),
    [sym_union_specifier] = STATE(30),
    [sym__empty_declaration] = STATE(312),
    [sym_macro_type_specifier] = STATE(30),
    [sym_class_specifier] = STATE(30),
    [sym_dependent_type] = STATE(30),
    [sym_structured_binding_declaration] = STATE(312),
    [sym_template_declaration] = STATE(312),
    [sym_template_instantiation] = STATE(312),
    [sym_constructor_or_destructor_definition] = STATE(31),
    [sym_reference_declarator] = STATE(28),
    [sym_template_type] = STATE(32),
    [sym_template_function] = STATE(28),
    [sym_namespace_definition] = STATE(312),
    [sym_using_declaration] = STATE(312),
    [sym_alias_declaration] = STATE(312),
    [sym_destructor_name] = STATE(28),
    [sym_scoped_identifier] = STATE(33),
    [sym_scoped_type_identifier] = STATE(34),
    [sym_scoped_namespace_identifier] = STATE(35),
    [aux_sym_translation_unit_repeat1] = STATE(312),
    [aux_sym__declaration_specifiers_repeat1] = STATE(37),
    [aux_sym_sized_type_specifier_repeat1] = STATE(38),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(7),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(11),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(13),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(15),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(17),
    [sym_preproc_directive] = ACTIONS(19),
    [anon_sym_typedef] = ACTIONS(21),
    [anon_sym_extern] = ACTIONS(23),
    [anon_sym_RBRACE] = ACTIONS(491),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_static] = ACTIONS(27),
    [anon_sym_register] = ACTIONS(27),
    [anon_sym_inline] = ACTIONS(27),
    [anon_sym_const] = ACTIONS(29),
    [anon_sym_restrict] = ACTIONS(29),
    [anon_sym_volatile] = ACTIONS(29),
    [anon_sym__Atomic] = ACTIONS(29),
    [anon_sym_mutable] = ACTIONS(29),
    [anon_sym_explicit] = ACTIONS(29),
    [anon_sym_constexpr] = ACTIONS(29),
    [anon_sym_unsigned] = ACTIONS(31),
    [anon_sym_long] = ACTIONS(31),
    [anon_sym_short] = ACTIONS(31),
    [sym_primitive_type] = ACTIONS(33),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_union] = ACTIONS(39),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(45),
    [sym_identifier] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(51),
    [sym_auto] = ACTIONS(33),
    [anon_sym_typename] = ACTIONS(53),
    [anon_sym_template] = ACTIONS(55),
    [anon_sym_namespace] = ACTIONS(57),
    [anon_sym_using] = ACTIONS(59),
    [anon_sym_COLON_COLON] = ACTIONS(61),
    [sym_operator_name] = ACTIONS(63),
  },
  [112] = {
    [sym_declaration_list] = STATE(313),
    [anon_sym_LBRACE] = ACTIONS(178),
    [sym_comment] = ACTIONS(49),
  },
  [113] = {
    [ts_builtin_sym_end] = ACTIONS(493),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(495),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(495),
    [anon_sym_LPAREN] = ACTIONS(493),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(495),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(495),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(495),
    [sym_preproc_directive] = ACTIONS(495),
    [anon_sym_typedef] = ACTIONS(495),
    [anon_sym_extern] = ACTIONS(495),
    [anon_sym_RBRACE] = ACTIONS(493),
    [anon_sym_STAR] = ACTIONS(493),
    [anon_sym_static] = ACTIONS(495),
    [anon_sym_register] = ACTIONS(495),
    [anon_sym_inline] = ACTIONS(495),
    [anon_sym_const] = ACTIONS(495),
    [anon_sym_restrict] = ACTIONS(495),
    [anon_sym_volatile] = ACTIONS(495),
    [anon_sym__Atomic] = ACTIONS(495),
    [anon_sym_mutable] = ACTIONS(495),
    [anon_sym_explicit] = ACTIONS(495),
    [anon_sym_constexpr] = ACTIONS(495),
    [anon_sym_unsigned] = ACTIONS(495),
    [anon_sym_long] = ACTIONS(495),
    [anon_sym_short] = ACTIONS(495),
    [sym_primitive_type] = ACTIONS(495),
    [anon_sym_enum] = ACTIONS(495),
    [anon_sym_struct] = ACTIONS(495),
    [anon_sym_union] = ACTIONS(495),
    [anon_sym_AMP] = ACTIONS(495),
    [anon_sym_AMP_AMP] = ACTIONS(493),
    [anon_sym_TILDE] = ACTIONS(493),
    [sym_identifier] = ACTIONS(495),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(495),
    [sym_auto] = ACTIONS(495),
    [anon_sym_typename] = ACTIONS(495),
    [anon_sym_template] = ACTIONS(495),
    [anon_sym_namespace] = ACTIONS(495),
    [anon_sym_using] = ACTIONS(495),
    [anon_sym_COLON_COLON] = ACTIONS(493),
    [sym_operator_name] = ACTIONS(493),
  },
  [114] = {
    [sym_template_argument_list] = STATE(203),
    [anon_sym_SEMI] = ACTIONS(497),
    [anon_sym_EQ] = ACTIONS(499),
    [anon_sym_LT] = ACTIONS(146),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(501),
  },
  [115] = {
    [sym_template_type] = STATE(117),
    [sym_scoped_identifier] = STATE(318),
    [sym_scoped_type_identifier] = STATE(47),
    [sym_scoped_namespace_identifier] = STATE(117),
    [sym_identifier] = ACTIONS(503),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(186),
  },
  [116] = {
    [sym_destructor_name] = STATE(120),
    [anon_sym_TILDE] = ACTIONS(45),
    [sym_identifier] = ACTIONS(505),
    [sym_comment] = ACTIONS(49),
    [sym_operator_name] = ACTIONS(190),
  },
  [117] = {
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(507),
  },
  [118] = {
    [anon_sym_SEMI] = ACTIONS(497),
    [sym_comment] = ACTIONS(49),
  },
  [119] = {
    [anon_sym_LPAREN] = ACTIONS(509),
    [anon_sym_COMMA] = ACTIONS(512),
    [anon_sym_RPAREN] = ACTIONS(509),
    [anon_sym_SEMI] = ACTIONS(512),
    [anon_sym_extern] = ACTIONS(514),
    [anon_sym_STAR] = ACTIONS(512),
    [anon_sym_LBRACK] = ACTIONS(509),
    [anon_sym_static] = ACTIONS(514),
    [anon_sym_register] = ACTIONS(514),
    [anon_sym_inline] = ACTIONS(514),
    [anon_sym_const] = ACTIONS(514),
    [anon_sym_restrict] = ACTIONS(514),
    [anon_sym_volatile] = ACTIONS(514),
    [anon_sym__Atomic] = ACTIONS(514),
    [anon_sym_mutable] = ACTIONS(514),
    [anon_sym_explicit] = ACTIONS(514),
    [anon_sym_constexpr] = ACTIONS(514),
    [anon_sym_AMP] = ACTIONS(514),
    [anon_sym_AMP_AMP] = ACTIONS(512),
    [anon_sym_TILDE] = ACTIONS(512),
    [anon_sym_LT] = ACTIONS(509),
    [sym_identifier] = ACTIONS(514),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(516),
    [sym_operator_name] = ACTIONS(512),
  },
  [120] = {
    [anon_sym_LPAREN] = ACTIONS(518),
    [anon_sym_COMMA] = ACTIONS(518),
    [anon_sym_RPAREN] = ACTIONS(518),
    [anon_sym_SEMI] = ACTIONS(518),
    [anon_sym_LBRACE] = ACTIONS(518),
    [anon_sym_RBRACE] = ACTIONS(518),
    [anon_sym_STAR] = ACTIONS(520),
    [anon_sym_LBRACK] = ACTIONS(518),
    [anon_sym_RBRACK] = ACTIONS(518),
    [anon_sym_EQ] = ACTIONS(520),
    [anon_sym_COLON] = ACTIONS(518),
    [anon_sym_QMARK] = ACTIONS(518),
    [anon_sym_STAR_EQ] = ACTIONS(518),
    [anon_sym_SLASH_EQ] = ACTIONS(518),
    [anon_sym_PERCENT_EQ] = ACTIONS(518),
    [anon_sym_PLUS_EQ] = ACTIONS(518),
    [anon_sym_DASH_EQ] = ACTIONS(518),
    [anon_sym_LT_LT_EQ] = ACTIONS(518),
    [anon_sym_GT_GT_EQ] = ACTIONS(518),
    [anon_sym_AMP_EQ] = ACTIONS(518),
    [anon_sym_CARET_EQ] = ACTIONS(518),
    [anon_sym_PIPE_EQ] = ACTIONS(518),
    [anon_sym_AMP] = ACTIONS(520),
    [anon_sym_PIPE_PIPE] = ACTIONS(518),
    [anon_sym_AMP_AMP] = ACTIONS(518),
    [anon_sym_PIPE] = ACTIONS(520),
    [anon_sym_CARET] = ACTIONS(520),
    [anon_sym_EQ_EQ] = ACTIONS(518),
    [anon_sym_BANG_EQ] = ACTIONS(518),
    [anon_sym_LT] = ACTIONS(520),
    [anon_sym_GT] = ACTIONS(520),
    [anon_sym_LT_EQ] = ACTIONS(518),
    [anon_sym_GT_EQ] = ACTIONS(518),
    [anon_sym_LT_LT] = ACTIONS(520),
    [anon_sym_GT_GT] = ACTIONS(520),
    [anon_sym_PLUS] = ACTIONS(520),
    [anon_sym_DASH] = ACTIONS(520),
    [anon_sym_SLASH] = ACTIONS(520),
    [anon_sym_PERCENT] = ACTIONS(520),
    [anon_sym_DASH_DASH] = ACTIONS(518),
    [anon_sym_PLUS_PLUS] = ACTIONS(518),
    [anon_sym_DOT] = ACTIONS(518),
    [anon_sym_DASH_GT] = ACTIONS(518),
    [sym_comment] = ACTIONS(49),
  },
  [121] = {
    [ts_builtin_sym_end] = ACTIONS(522),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(524),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(524),
    [anon_sym_LPAREN] = ACTIONS(522),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(524),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(524),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(524),
    [sym_preproc_directive] = ACTIONS(524),
    [anon_sym_typedef] = ACTIONS(524),
    [anon_sym_extern] = ACTIONS(524),
    [anon_sym_RBRACE] = ACTIONS(522),
    [anon_sym_STAR] = ACTIONS(522),
    [anon_sym_static] = ACTIONS(524),
    [anon_sym_register] = ACTIONS(524),
    [anon_sym_inline] = ACTIONS(524),
    [anon_sym_const] = ACTIONS(524),
    [anon_sym_restrict] = ACTIONS(524),
    [anon_sym_volatile] = ACTIONS(524),
    [anon_sym__Atomic] = ACTIONS(524),
    [anon_sym_mutable] = ACTIONS(524),
    [anon_sym_explicit] = ACTIONS(524),
    [anon_sym_constexpr] = ACTIONS(524),
    [anon_sym_unsigned] = ACTIONS(524),
    [anon_sym_long] = ACTIONS(524),
    [anon_sym_short] = ACTIONS(524),
    [sym_primitive_type] = ACTIONS(524),
    [anon_sym_enum] = ACTIONS(524),
    [anon_sym_struct] = ACTIONS(524),
    [anon_sym_union] = ACTIONS(524),
    [anon_sym_AMP] = ACTIONS(524),
    [anon_sym_AMP_AMP] = ACTIONS(522),
    [anon_sym_TILDE] = ACTIONS(522),
    [sym_identifier] = ACTIONS(524),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(524),
    [sym_auto] = ACTIONS(524),
    [anon_sym_typename] = ACTIONS(524),
    [anon_sym_template] = ACTIONS(524),
    [anon_sym_namespace] = ACTIONS(524),
    [anon_sym_using] = ACTIONS(524),
    [anon_sym_COLON_COLON] = ACTIONS(522),
    [sym_operator_name] = ACTIONS(522),
  },
  [122] = {
    [sym__declarator] = STATE(322),
    [sym_pointer_declarator] = STATE(322),
    [sym_function_declarator] = STATE(322),
    [sym_array_declarator] = STATE(322),
    [sym_reference_declarator] = STATE(322),
    [sym_template_type] = STATE(46),
    [sym_template_function] = STATE(322),
    [sym_destructor_name] = STATE(322),
    [sym_scoped_identifier] = STATE(33),
    [sym_scoped_type_identifier] = STATE(47),
    [sym_scoped_namespace_identifier] = STATE(46),
    [anon_sym_LPAREN] = ACTIONS(11),
    [anon_sym_STAR] = ACTIONS(196),
    [anon_sym_AMP] = ACTIONS(526),
    [anon_sym_AMP_AMP] = ACTIONS(528),
    [anon_sym_TILDE] = ACTIONS(45),
    [sym_identifier] = ACTIONS(75),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(77),
    [sym_operator_name] = ACTIONS(530),
  },
  [123] = {
    [sym_identifier] = ACTIONS(532),
    [sym_comment] = ACTIONS(49),
  },
  [124] = {
    [sym__declarator] = STATE(324),
    [sym_pointer_declarator] = STATE(324),
    [sym_function_declarator] = STATE(324),
    [sym_array_declarator] = STATE(324),
    [sym_reference_declarator] = STATE(324),
    [sym_structured_binding_declarator] = STATE(325),
    [sym_template_type] = STATE(46),
    [sym_template_function] = STATE(324),
    [sym_destructor_name] = STATE(324),
    [sym_scoped_identifier] = STATE(33),
    [sym_scoped_type_identifier] = STATE(47),
    [sym_scoped_namespace_identifier] = STATE(46),
    [anon_sym_LPAREN] = ACTIONS(11),
    [anon_sym_STAR] = ACTIONS(196),
    [anon_sym_LBRACK] = ACTIONS(198),
    [anon_sym_AMP] = ACTIONS(526),
    [anon_sym_AMP_AMP] = ACTIONS(528),
    [anon_sym_TILDE] = ACTIONS(45),
    [sym_identifier] = ACTIONS(75),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(77),
    [sym_operator_name] = ACTIONS(534),
  },
  [125] = {
    [sym_compound_statement] = STATE(331),
    [sym_parameter_list] = STATE(332),
    [sym_argument_list] = STATE(333),
    [sym_initializer_list] = STATE(333),
    [aux_sym_declaration_repeat1] = STATE(334),
    [anon_sym_LPAREN] = ACTIONS(536),
    [anon_sym_COMMA] = ACTIONS(538),
    [anon_sym_SEMI] = ACTIONS(540),
    [anon_sym_LBRACE] = ACTIONS(542),
    [anon_sym_LBRACK] = ACTIONS(208),
    [anon_sym_EQ] = ACTIONS(544),
    [sym_comment] = ACTIONS(49),
  },
  [126] = {
    [aux_sym_declaration_repeat1] = STATE(334),
    [anon_sym_COMMA] = ACTIONS(538),
    [anon_sym_SEMI] = ACTIONS(540),
    [sym_comment] = ACTIONS(49),
  },
  [127] = {
    [sym_argument_list] = STATE(338),
    [sym_initializer_list] = STATE(338),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_LBRACE] = ACTIONS(548),
    [anon_sym_EQ] = ACTIONS(550),
    [sym_comment] = ACTIONS(49),
  },
  [128] = {
    [sym_argument_list] = STATE(340),
    [sym_initializer_list] = STATE(340),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_LBRACE] = ACTIONS(548),
    [anon_sym_EQ] = ACTIONS(552),
    [sym_comment] = ACTIONS(49),
  },
  [129] = {
    [sym__declaration_specifiers] = STATE(344),
    [sym_storage_class_specifier] = STATE(346),
    [sym_type_qualifier] = STATE(346),
    [sym__type_specifier] = STATE(345),
    [sym_sized_type_specifier] = STATE(345),
    [sym_enum_specifier] = STATE(345),
    [sym_struct_specifier] = STATE(345),
    [sym_union_specifier] = STATE(345),
    [sym_parameter_declaration] = STATE(341),
    [sym_macro_type_specifier] = STATE(345),
    [sym_class_specifier] = STATE(345),
    [sym_dependent_type] = STATE(345),
    [sym_template_type] = STATE(94),
    [sym_scoped_type_identifier] = STATE(34),
    [sym_scoped_namespace_identifier] = STATE(81),
    [aux_sym__declaration_specifiers_repeat1] = STATE(346),
    [aux_sym_sized_type_specifier_repeat1] = STATE(347),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(554),
    [anon_sym_RPAREN] = ACTIONS(556),
    [anon_sym_extern] = ACTIONS(154),
    [anon_sym_static] = ACTIONS(154),
    [anon_sym_register] = ACTIONS(154),
    [anon_sym_inline] = ACTIONS(154),
    [anon_sym_const] = ACTIONS(158),
    [anon_sym_restrict] = ACTIONS(158),
    [anon_sym_volatile] = ACTIONS(158),
    [anon_sym__Atomic] = ACTIONS(158),
    [anon_sym_mutable] = ACTIONS(158),
    [anon_sym_explicit] = ACTIONS(158),
    [anon_sym_constexpr] = ACTIONS(158),
    [anon_sym_unsigned] = ACTIONS(558),
    [anon_sym_long] = ACTIONS(558),
    [anon_sym_short] = ACTIONS(558),
    [sym_primitive_type] = ACTIONS(560),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_union] = ACTIONS(39),
    [sym_identifier] = ACTIONS(152),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(51),
    [sym_auto] = ACTIONS(560),
    [anon_sym_typename] = ACTIONS(562),
    [anon_sym_COLON_COLON] = ACTIONS(135),
  },
  [130] = {
    [sym__declaration_specifiers] = STATE(366),
    [sym_storage_class_specifier] = STATE(374),
    [sym_type_qualifier] = STATE(374),
    [sym__type_specifier] = STATE(367),
    [sym_sized_type_specifier] = STATE(367),
    [sym_enum_specifier] = STATE(367),
    [sym_struct_specifier] = STATE(367),
    [sym_union_specifier] = STATE(367),
    [sym__expression] = STATE(368),
    [sym_conditional_expression] = STATE(368),
    [sym_assignment_expression] = STATE(368),
    [sym_pointer_expression] = STATE(368),
    [sym_logical_expression] = STATE(368),
    [sym_bitwise_expression] = STATE(368),
    [sym_equality_expression] = STATE(368),
    [sym_relational_expression] = STATE(368),
    [sym_shift_expression] = STATE(368),
    [sym_math_expression] = STATE(368),
    [sym_cast_expression] = STATE(368),
    [sym_sizeof_expression] = STATE(368),
    [sym_subscript_expression] = STATE(368),
    [sym_call_expression] = STATE(368),
    [sym_field_expression] = STATE(368),
    [sym_compound_literal_expression] = STATE(368),
    [sym_parenthesized_expression] = STATE(368),
    [sym_concatenated_string] = STATE(368),
    [sym_macro_type_specifier] = STATE(367),
    [sym_class_specifier] = STATE(367),
    [sym_dependent_type] = STATE(367),
    [sym_template_type] = STATE(369),
    [sym_template_function] = STATE(368),
    [sym_new_expression] = STATE(368),
    [sym_delete_expression] = STATE(368),
    [sym_lambda_expression] = STATE(368),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(372),
    [sym_scoped_namespace_identifier] = STATE(373),
    [aux_sym__declaration_specifiers_repeat1] = STATE(374),
    [aux_sym_sized_type_specifier_repeat1] = STATE(375),
    [sym_raw_string_literal] = ACTIONS(564),
    [anon_sym_LPAREN] = ACTIONS(566),
    [anon_sym_extern] = ACTIONS(154),
    [anon_sym_STAR] = ACTIONS(568),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_RBRACK] = ACTIONS(572),
    [anon_sym_static] = ACTIONS(154),
    [anon_sym_register] = ACTIONS(154),
    [anon_sym_inline] = ACTIONS(154),
    [anon_sym_const] = ACTIONS(158),
    [anon_sym_restrict] = ACTIONS(158),
    [anon_sym_volatile] = ACTIONS(158),
    [anon_sym__Atomic] = ACTIONS(158),
    [anon_sym_mutable] = ACTIONS(158),
    [anon_sym_explicit] = ACTIONS(158),
    [anon_sym_constexpr] = ACTIONS(158),
    [anon_sym_unsigned] = ACTIONS(574),
    [anon_sym_long] = ACTIONS(574),
    [anon_sym_short] = ACTIONS(574),
    [sym_primitive_type] = ACTIONS(576),
    [anon_sym_enum] = ACTIONS(578),
    [anon_sym_struct] = ACTIONS(580),
    [anon_sym_union] = ACTIONS(582),
    [anon_sym_AMP] = ACTIONS(568),
    [anon_sym_BANG] = ACTIONS(584),
    [anon_sym_TILDE] = ACTIONS(586),
    [anon_sym_PLUS] = ACTIONS(588),
    [anon_sym_DASH] = ACTIONS(588),
    [anon_sym_DASH_DASH] = ACTIONS(590),
    [anon_sym_PLUS_PLUS] = ACTIONS(590),
    [anon_sym_sizeof] = ACTIONS(592),
    [sym_number_literal] = ACTIONS(564),
    [sym_char_literal] = ACTIONS(564),
    [sym_string_literal] = ACTIONS(594),
    [sym_true] = ACTIONS(596),
    [sym_false] = ACTIONS(596),
    [sym_null] = ACTIONS(596),
    [sym_identifier] = ACTIONS(598),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(600),
    [sym_auto] = ACTIONS(576),
    [anon_sym_typename] = ACTIONS(602),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(606),
    [anon_sym_delete] = ACTIONS(608),
    [sym_nullptr] = ACTIONS(596),
  },
  [131] = {
    [sym_type_qualifier] = STATE(378),
    [sym_trailing_return_type] = STATE(378),
    [aux_sym_function_declarator_repeat1] = STATE(378),
    [anon_sym_LPAREN] = ACTIONS(610),
    [anon_sym_LBRACE] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(610),
    [anon_sym_const] = ACTIONS(612),
    [anon_sym_restrict] = ACTIONS(614),
    [anon_sym_volatile] = ACTIONS(614),
    [anon_sym__Atomic] = ACTIONS(614),
    [anon_sym_mutable] = ACTIONS(614),
    [anon_sym_explicit] = ACTIONS(614),
    [anon_sym_constexpr] = ACTIONS(614),
    [anon_sym_COLON] = ACTIONS(610),
    [anon_sym_DASH_GT] = ACTIONS(616),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(618),
  },
  [132] = {
    [sym_preproc_include] = STATE(418),
    [sym_preproc_def] = STATE(418),
    [sym_preproc_function_def] = STATE(418),
    [sym_preproc_call] = STATE(418),
    [sym_preproc_if_in_compound_statement] = STATE(410),
    [sym_preproc_ifdef_in_compound_statement] = STATE(411),
    [sym_declaration] = STATE(418),
    [sym_type_definition] = STATE(418),
    [sym__declaration_specifiers] = STATE(412),
    [sym_compound_statement] = STATE(418),
    [sym_storage_class_specifier] = STATE(419),
    [sym_type_qualifier] = STATE(419),
    [sym__type_specifier] = STATE(30),
    [sym_sized_type_specifier] = STATE(30),
    [sym_enum_specifier] = STATE(30),
    [sym_struct_specifier] = STATE(30),
    [sym_union_specifier] = STATE(30),
    [sym_labeled_statement] = STATE(418),
    [sym_expression_statement] = STATE(418),
    [sym_if_statement] = STATE(418),
    [sym_switch_statement] = STATE(418),
    [sym_case_statement] = STATE(418),
    [sym_while_statement] = STATE(418),
    [sym_do_statement] = STATE(418),
    [sym_for_statement] = STATE(418),
    [sym_return_statement] = STATE(418),
    [sym_break_statement] = STATE(418),
    [sym_continue_statement] = STATE(418),
    [sym_goto_statement] = STATE(418),
    [sym__expression] = STATE(413),
    [sym_comma_expression] = STATE(414),
    [sym_conditional_expression] = STATE(413),
    [sym_assignment_expression] = STATE(413),
    [sym_pointer_expression] = STATE(413),
    [sym_logical_expression] = STATE(413),
    [sym_bitwise_expression] = STATE(413),
    [sym_equality_expression] = STATE(413),
    [sym_relational_expression] = STATE(413),
    [sym_shift_expression] = STATE(413),
    [sym_math_expression] = STATE(413),
    [sym_cast_expression] = STATE(413),
    [sym_sizeof_expression] = STATE(413),
    [sym_subscript_expression] = STATE(413),
    [sym_call_expression] = STATE(413),
    [sym_field_expression] = STATE(413),
    [sym_compound_literal_expression] = STATE(413),
    [sym_parenthesized_expression] = STATE(413),
    [sym_concatenated_string] = STATE(413),
    [sym__empty_declaration] = STATE(418),
    [sym_macro_type_specifier] = STATE(30),
    [sym_class_specifier] = STATE(30),
    [sym_dependent_type] = STATE(30),
    [sym_structured_binding_declaration] = STATE(418),
    [sym_template_type] = STATE(415),
    [sym_template_function] = STATE(413),
    [sym_for_range_loop] = STATE(418),
    [sym_new_expression] = STATE(413),
    [sym_delete_expression] = STATE(413),
    [sym_lambda_expression] = STATE(413),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(416),
    [sym_scoped_namespace_identifier] = STATE(417),
    [aux_sym_preproc_if_in_compound_statement_repeat1] = STATE(418),
    [aux_sym__declaration_specifiers_repeat1] = STATE(419),
    [aux_sym_sized_type_specifier_repeat1] = STATE(38),
    [sym_raw_string_literal] = ACTIONS(620),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(622),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(624),
    [anon_sym_LPAREN] = ACTIONS(626),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(628),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(630),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(632),
    [sym_preproc_directive] = ACTIONS(634),
    [anon_sym_SEMI] = ACTIONS(636),
    [anon_sym_typedef] = ACTIONS(638),
    [anon_sym_extern] = ACTIONS(154),
    [anon_sym_LBRACE] = ACTIONS(640),
    [anon_sym_RBRACE] = ACTIONS(642),
    [anon_sym_STAR] = ACTIONS(644),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_static] = ACTIONS(154),
    [anon_sym_register] = ACTIONS(154),
    [anon_sym_inline] = ACTIONS(154),
    [anon_sym_const] = ACTIONS(158),
    [anon_sym_restrict] = ACTIONS(158),
    [anon_sym_volatile] = ACTIONS(158),
    [anon_sym__Atomic] = ACTIONS(158),
    [anon_sym_mutable] = ACTIONS(158),
    [anon_sym_explicit] = ACTIONS(158),
    [anon_sym_constexpr] = ACTIONS(158),
    [anon_sym_unsigned] = ACTIONS(31),
    [anon_sym_long] = ACTIONS(31),
    [anon_sym_short] = ACTIONS(31),
    [sym_primitive_type] = ACTIONS(33),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_union] = ACTIONS(39),
    [anon_sym_if] = ACTIONS(646),
    [anon_sym_switch] = ACTIONS(648),
    [anon_sym_case] = ACTIONS(650),
    [anon_sym_default] = ACTIONS(652),
    [anon_sym_while] = ACTIONS(654),
    [anon_sym_do] = ACTIONS(656),
    [anon_sym_for] = ACTIONS(658),
    [anon_sym_return] = ACTIONS(660),
    [anon_sym_break] = ACTIONS(662),
    [anon_sym_continue] = ACTIONS(664),
    [anon_sym_goto] = ACTIONS(666),
    [anon_sym_AMP] = ACTIONS(644),
    [anon_sym_BANG] = ACTIONS(668),
    [anon_sym_TILDE] = ACTIONS(670),
    [anon_sym_PLUS] = ACTIONS(672),
    [anon_sym_DASH] = ACTIONS(672),
    [anon_sym_DASH_DASH] = ACTIONS(674),
    [anon_sym_PLUS_PLUS] = ACTIONS(674),
    [anon_sym_sizeof] = ACTIONS(676),
    [sym_number_literal] = ACTIONS(620),
    [sym_char_literal] = ACTIONS(620),
    [sym_string_literal] = ACTIONS(678),
    [sym_true] = ACTIONS(680),
    [sym_false] = ACTIONS(680),
    [sym_null] = ACTIONS(680),
    [sym_identifier] = ACTIONS(682),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(51),
    [sym_auto] = ACTIONS(33),
    [anon_sym_typename] = ACTIONS(53),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(684),
    [anon_sym_delete] = ACTIONS(686),
    [sym_nullptr] = ACTIONS(680),
  },
  [133] = {
    [sym_field_initializer] = STATE(422),
    [sym_template_type] = STATE(423),
    [sym_scoped_field_identifier] = STATE(424),
    [sym_scoped_type_identifier] = STATE(47),
    [sym_scoped_namespace_identifier] = STATE(423),
    [sym_identifier] = ACTIONS(688),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(690),
  },
  [134] = {
    [ts_builtin_sym_end] = ACTIONS(692),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(694),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(694),
    [anon_sym_LPAREN] = ACTIONS(692),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(694),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(694),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(694),
    [sym_preproc_directive] = ACTIONS(694),
    [anon_sym_typedef] = ACTIONS(694),
    [anon_sym_extern] = ACTIONS(694),
    [anon_sym_RBRACE] = ACTIONS(692),
    [anon_sym_STAR] = ACTIONS(692),
    [anon_sym_static] = ACTIONS(694),
    [anon_sym_register] = ACTIONS(694),
    [anon_sym_inline] = ACTIONS(694),
    [anon_sym_const] = ACTIONS(694),
    [anon_sym_restrict] = ACTIONS(694),
    [anon_sym_volatile] = ACTIONS(694),
    [anon_sym__Atomic] = ACTIONS(694),
    [anon_sym_mutable] = ACTIONS(694),
    [anon_sym_explicit] = ACTIONS(694),
    [anon_sym_constexpr] = ACTIONS(694),
    [anon_sym_unsigned] = ACTIONS(694),
    [anon_sym_long] = ACTIONS(694),
    [anon_sym_short] = ACTIONS(694),
    [sym_primitive_type] = ACTIONS(694),
    [anon_sym_enum] = ACTIONS(694),
    [anon_sym_struct] = ACTIONS(694),
    [anon_sym_union] = ACTIONS(694),
    [anon_sym_AMP] = ACTIONS(694),
    [anon_sym_AMP_AMP] = ACTIONS(692),
    [anon_sym_TILDE] = ACTIONS(692),
    [sym_identifier] = ACTIONS(694),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(694),
    [sym_auto] = ACTIONS(694),
    [anon_sym_typename] = ACTIONS(694),
    [anon_sym_template] = ACTIONS(694),
    [anon_sym_namespace] = ACTIONS(694),
    [anon_sym_using] = ACTIONS(694),
    [anon_sym_COLON_COLON] = ACTIONS(692),
    [sym_operator_name] = ACTIONS(692),
  },
  [135] = {
    [sym_compound_statement] = STATE(425),
    [anon_sym_LBRACE] = ACTIONS(212),
    [sym_comment] = ACTIONS(49),
  },
  [136] = {
    [anon_sym_LPAREN] = ACTIONS(113),
    [anon_sym_COMMA] = ACTIONS(113),
    [anon_sym_RPAREN] = ACTIONS(113),
    [anon_sym_SEMI] = ACTIONS(113),
    [anon_sym_extern] = ACTIONS(115),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_LBRACK] = ACTIONS(113),
    [anon_sym_static] = ACTIONS(115),
    [anon_sym_register] = ACTIONS(115),
    [anon_sym_inline] = ACTIONS(115),
    [anon_sym_const] = ACTIONS(115),
    [anon_sym_restrict] = ACTIONS(115),
    [anon_sym_volatile] = ACTIONS(115),
    [anon_sym__Atomic] = ACTIONS(115),
    [anon_sym_mutable] = ACTIONS(115),
    [anon_sym_explicit] = ACTIONS(115),
    [anon_sym_constexpr] = ACTIONS(115),
    [anon_sym_COLON] = ACTIONS(115),
    [anon_sym_AMP] = ACTIONS(115),
    [anon_sym_AMP_AMP] = ACTIONS(113),
    [anon_sym_TILDE] = ACTIONS(113),
    [anon_sym_GT] = ACTIONS(113),
    [sym_identifier] = ACTIONS(115),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(113),
    [sym_operator_name] = ACTIONS(113),
  },
  [137] = {
    [anon_sym_LPAREN] = ACTIONS(121),
    [anon_sym_COMMA] = ACTIONS(121),
    [anon_sym_RPAREN] = ACTIONS(121),
    [anon_sym_SEMI] = ACTIONS(121),
    [anon_sym_extern] = ACTIONS(123),
    [anon_sym_STAR] = ACTIONS(121),
    [anon_sym_LBRACK] = ACTIONS(121),
    [anon_sym_static] = ACTIONS(123),
    [anon_sym_register] = ACTIONS(123),
    [anon_sym_inline] = ACTIONS(123),
    [anon_sym_const] = ACTIONS(123),
    [anon_sym_restrict] = ACTIONS(123),
    [anon_sym_volatile] = ACTIONS(123),
    [anon_sym__Atomic] = ACTIONS(123),
    [anon_sym_mutable] = ACTIONS(123),
    [anon_sym_explicit] = ACTIONS(123),
    [anon_sym_constexpr] = ACTIONS(123),
    [anon_sym_COLON] = ACTIONS(123),
    [anon_sym_AMP] = ACTIONS(123),
    [anon_sym_AMP_AMP] = ACTIONS(121),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_GT] = ACTIONS(121),
    [sym_identifier] = ACTIONS(123),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(121),
    [sym_operator_name] = ACTIONS(121),
  },
  [138] = {
    [sym_storage_class_specifier] = STATE(426),
    [sym_type_qualifier] = STATE(426),
    [aux_sym__declaration_specifiers_repeat1] = STATE(426),
    [anon_sym_LPAREN] = ACTIONS(696),
    [anon_sym_SEMI] = ACTIONS(696),
    [anon_sym_extern] = ACTIONS(218),
    [anon_sym_STAR] = ACTIONS(696),
    [anon_sym_LBRACK] = ACTIONS(696),
    [anon_sym_static] = ACTIONS(218),
    [anon_sym_register] = ACTIONS(218),
    [anon_sym_inline] = ACTIONS(218),
    [anon_sym_const] = ACTIONS(220),
    [anon_sym_restrict] = ACTIONS(220),
    [anon_sym_volatile] = ACTIONS(220),
    [anon_sym__Atomic] = ACTIONS(220),
    [anon_sym_mutable] = ACTIONS(220),
    [anon_sym_explicit] = ACTIONS(220),
    [anon_sym_constexpr] = ACTIONS(220),
    [anon_sym_AMP] = ACTIONS(698),
    [anon_sym_AMP_AMP] = ACTIONS(696),
    [anon_sym_TILDE] = ACTIONS(696),
    [sym_identifier] = ACTIONS(698),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(696),
    [sym_operator_name] = ACTIONS(696),
  },
  [139] = {
    [sym_destructor_name] = STATE(428),
    [anon_sym_TILDE] = ACTIONS(45),
    [sym_identifier] = ACTIONS(700),
    [sym_comment] = ACTIONS(49),
    [sym_operator_name] = ACTIONS(702),
  },
  [140] = {
    [anon_sym_LPAREN] = ACTIONS(704),
    [anon_sym_COMMA] = ACTIONS(704),
    [anon_sym_RPAREN] = ACTIONS(704),
    [anon_sym_SEMI] = ACTIONS(704),
    [anon_sym_LBRACE] = ACTIONS(704),
    [anon_sym_RBRACE] = ACTIONS(704),
    [anon_sym_STAR] = ACTIONS(706),
    [anon_sym_LBRACK] = ACTIONS(704),
    [anon_sym_RBRACK] = ACTIONS(704),
    [anon_sym_EQ] = ACTIONS(706),
    [anon_sym_COLON] = ACTIONS(704),
    [anon_sym_QMARK] = ACTIONS(704),
    [anon_sym_STAR_EQ] = ACTIONS(704),
    [anon_sym_SLASH_EQ] = ACTIONS(704),
    [anon_sym_PERCENT_EQ] = ACTIONS(704),
    [anon_sym_PLUS_EQ] = ACTIONS(704),
    [anon_sym_DASH_EQ] = ACTIONS(704),
    [anon_sym_LT_LT_EQ] = ACTIONS(704),
    [anon_sym_GT_GT_EQ] = ACTIONS(704),
    [anon_sym_AMP_EQ] = ACTIONS(704),
    [anon_sym_CARET_EQ] = ACTIONS(704),
    [anon_sym_PIPE_EQ] = ACTIONS(704),
    [anon_sym_AMP] = ACTIONS(706),
    [anon_sym_PIPE_PIPE] = ACTIONS(704),
    [anon_sym_AMP_AMP] = ACTIONS(704),
    [anon_sym_PIPE] = ACTIONS(706),
    [anon_sym_CARET] = ACTIONS(706),
    [anon_sym_EQ_EQ] = ACTIONS(704),
    [anon_sym_BANG_EQ] = ACTIONS(704),
    [anon_sym_LT] = ACTIONS(706),
    [anon_sym_GT] = ACTIONS(706),
    [anon_sym_LT_EQ] = ACTIONS(704),
    [anon_sym_GT_EQ] = ACTIONS(704),
    [anon_sym_LT_LT] = ACTIONS(706),
    [anon_sym_GT_GT] = ACTIONS(706),
    [anon_sym_PLUS] = ACTIONS(706),
    [anon_sym_DASH] = ACTIONS(706),
    [anon_sym_SLASH] = ACTIONS(706),
    [anon_sym_PERCENT] = ACTIONS(706),
    [anon_sym_DASH_DASH] = ACTIONS(704),
    [anon_sym_PLUS_PLUS] = ACTIONS(704),
    [anon_sym_DOT] = ACTIONS(704),
    [anon_sym_DASH_GT] = ACTIONS(704),
    [sym_comment] = ACTIONS(49),
  },
  [141] = {
    [anon_sym_LPAREN] = ACTIONS(708),
    [anon_sym_COMMA] = ACTIONS(708),
    [anon_sym_RPAREN] = ACTIONS(708),
    [anon_sym_SEMI] = ACTIONS(708),
    [anon_sym_extern] = ACTIONS(710),
    [anon_sym_LBRACE] = ACTIONS(708),
    [anon_sym_STAR] = ACTIONS(708),
    [anon_sym_LBRACK] = ACTIONS(708),
    [anon_sym_static] = ACTIONS(710),
    [anon_sym_register] = ACTIONS(710),
    [anon_sym_inline] = ACTIONS(710),
    [anon_sym_const] = ACTIONS(710),
    [anon_sym_restrict] = ACTIONS(710),
    [anon_sym_volatile] = ACTIONS(710),
    [anon_sym__Atomic] = ACTIONS(710),
    [anon_sym_mutable] = ACTIONS(710),
    [anon_sym_explicit] = ACTIONS(710),
    [anon_sym_constexpr] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(710),
    [anon_sym_AMP] = ACTIONS(710),
    [anon_sym_AMP_AMP] = ACTIONS(708),
    [anon_sym_TILDE] = ACTIONS(708),
    [anon_sym_GT] = ACTIONS(708),
    [sym_identifier] = ACTIONS(710),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(708),
    [sym_operator_name] = ACTIONS(708),
  },
  [142] = {
    [sym_preproc_include] = STATE(142),
    [sym_preproc_def] = STATE(142),
    [sym_preproc_function_def] = STATE(142),
    [sym_preproc_call] = STATE(142),
    [sym_preproc_if] = STATE(142),
    [sym_preproc_ifdef] = STATE(142),
    [sym_function_definition] = STATE(142),
    [sym_declaration] = STATE(142),
    [sym_type_definition] = STATE(142),
    [sym__declaration_specifiers] = STATE(27),
    [sym_linkage_specification] = STATE(142),
    [sym__declarator] = STATE(28),
    [sym_pointer_declarator] = STATE(28),
    [sym_function_declarator] = STATE(29),
    [sym_array_declarator] = STATE(28),
    [sym_storage_class_specifier] = STATE(37),
    [sym_type_qualifier] = STATE(37),
    [sym__type_specifier] = STATE(30),
    [sym_sized_type_specifier] = STATE(30),
    [sym_enum_specifier] = STATE(30),
    [sym_struct_specifier] = STATE(30),
    [sym_union_specifier] = STATE(30),
    [sym__empty_declaration] = STATE(142),
    [sym_macro_type_specifier] = STATE(30),
    [sym_class_specifier] = STATE(30),
    [sym_dependent_type] = STATE(30),
    [sym_structured_binding_declaration] = STATE(142),
    [sym_template_declaration] = STATE(142),
    [sym_template_instantiation] = STATE(142),
    [sym_constructor_or_destructor_definition] = STATE(31),
    [sym_reference_declarator] = STATE(28),
    [sym_template_type] = STATE(32),
    [sym_template_function] = STATE(28),
    [sym_namespace_definition] = STATE(142),
    [sym_using_declaration] = STATE(142),
    [sym_alias_declaration] = STATE(142),
    [sym_destructor_name] = STATE(28),
    [sym_scoped_identifier] = STATE(33),
    [sym_scoped_type_identifier] = STATE(34),
    [sym_scoped_namespace_identifier] = STATE(35),
    [aux_sym_translation_unit_repeat1] = STATE(142),
    [aux_sym__declaration_specifiers_repeat1] = STATE(37),
    [aux_sym_sized_type_specifier_repeat1] = STATE(38),
    [ts_builtin_sym_end] = ACTIONS(712),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(714),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(717),
    [anon_sym_LPAREN] = ACTIONS(720),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(723),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(726),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(729),
    [sym_preproc_directive] = ACTIONS(732),
    [anon_sym_typedef] = ACTIONS(735),
    [anon_sym_extern] = ACTIONS(738),
    [anon_sym_STAR] = ACTIONS(741),
    [anon_sym_static] = ACTIONS(744),
    [anon_sym_register] = ACTIONS(744),
    [anon_sym_inline] = ACTIONS(744),
    [anon_sym_const] = ACTIONS(747),
    [anon_sym_restrict] = ACTIONS(747),
    [anon_sym_volatile] = ACTIONS(747),
    [anon_sym__Atomic] = ACTIONS(747),
    [anon_sym_mutable] = ACTIONS(747),
    [anon_sym_explicit] = ACTIONS(747),
    [anon_sym_constexpr] = ACTIONS(747),
    [anon_sym_unsigned] = ACTIONS(750),
    [anon_sym_long] = ACTIONS(750),
    [anon_sym_short] = ACTIONS(750),
    [sym_primitive_type] = ACTIONS(753),
    [anon_sym_enum] = ACTIONS(756),
    [anon_sym_struct] = ACTIONS(759),
    [anon_sym_union] = ACTIONS(762),
    [anon_sym_AMP] = ACTIONS(765),
    [anon_sym_AMP_AMP] = ACTIONS(768),
    [anon_sym_TILDE] = ACTIONS(771),
    [sym_identifier] = ACTIONS(774),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(777),
    [sym_auto] = ACTIONS(753),
    [anon_sym_typename] = ACTIONS(780),
    [anon_sym_template] = ACTIONS(783),
    [anon_sym_namespace] = ACTIONS(786),
    [anon_sym_using] = ACTIONS(789),
    [anon_sym_COLON_COLON] = ACTIONS(792),
    [sym_operator_name] = ACTIONS(795),
  },
  [143] = {
    [sym_compound_statement] = STATE(425),
    [sym_field_initializer_list] = STATE(429),
    [anon_sym_LPAREN] = ACTIONS(210),
    [anon_sym_LBRACE] = ACTIONS(212),
    [anon_sym_LBRACK] = ACTIONS(210),
    [anon_sym_COLON] = ACTIONS(214),
    [sym_comment] = ACTIONS(49),
  },
  [144] = {
    [sym_storage_class_specifier] = STATE(430),
    [sym_type_qualifier] = STATE(430),
    [aux_sym__declaration_specifiers_repeat1] = STATE(430),
    [anon_sym_LPAREN] = ACTIONS(696),
    [anon_sym_SEMI] = ACTIONS(696),
    [anon_sym_extern] = ACTIONS(218),
    [anon_sym_STAR] = ACTIONS(696),
    [anon_sym_LBRACK] = ACTIONS(696),
    [anon_sym_static] = ACTIONS(218),
    [anon_sym_register] = ACTIONS(218),
    [anon_sym_inline] = ACTIONS(218),
    [anon_sym_const] = ACTIONS(220),
    [anon_sym_restrict] = ACTIONS(220),
    [anon_sym_volatile] = ACTIONS(220),
    [anon_sym__Atomic] = ACTIONS(220),
    [anon_sym_mutable] = ACTIONS(220),
    [anon_sym_explicit] = ACTIONS(220),
    [anon_sym_constexpr] = ACTIONS(220),
    [anon_sym_AMP] = ACTIONS(698),
    [anon_sym_AMP_AMP] = ACTIONS(696),
    [anon_sym_TILDE] = ACTIONS(696),
    [sym_identifier] = ACTIONS(698),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(696),
    [sym_operator_name] = ACTIONS(696),
  },
  [145] = {
    [sym_storage_class_specifier] = STATE(145),
    [sym_type_qualifier] = STATE(145),
    [aux_sym__declaration_specifiers_repeat1] = STATE(145),
    [anon_sym_LPAREN] = ACTIONS(798),
    [anon_sym_extern] = ACTIONS(800),
    [anon_sym_STAR] = ACTIONS(798),
    [anon_sym_static] = ACTIONS(800),
    [anon_sym_register] = ACTIONS(800),
    [anon_sym_inline] = ACTIONS(800),
    [anon_sym_const] = ACTIONS(803),
    [anon_sym_restrict] = ACTIONS(803),
    [anon_sym_volatile] = ACTIONS(803),
    [anon_sym__Atomic] = ACTIONS(803),
    [anon_sym_mutable] = ACTIONS(803),
    [anon_sym_explicit] = ACTIONS(803),
    [anon_sym_constexpr] = ACTIONS(803),
    [anon_sym_unsigned] = ACTIONS(806),
    [anon_sym_long] = ACTIONS(806),
    [anon_sym_short] = ACTIONS(806),
    [sym_primitive_type] = ACTIONS(806),
    [anon_sym_enum] = ACTIONS(806),
    [anon_sym_struct] = ACTIONS(806),
    [anon_sym_union] = ACTIONS(806),
    [anon_sym_AMP] = ACTIONS(806),
    [anon_sym_AMP_AMP] = ACTIONS(798),
    [anon_sym_TILDE] = ACTIONS(798),
    [sym_identifier] = ACTIONS(806),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(806),
    [sym_auto] = ACTIONS(806),
    [anon_sym_typename] = ACTIONS(806),
    [anon_sym_COLON_COLON] = ACTIONS(798),
    [sym_operator_name] = ACTIONS(798),
  },
  [146] = {
    [anon_sym_LPAREN] = ACTIONS(808),
    [anon_sym_COMMA] = ACTIONS(808),
    [anon_sym_RPAREN] = ACTIONS(808),
    [anon_sym_SEMI] = ACTIONS(808),
    [anon_sym_extern] = ACTIONS(810),
    [anon_sym_LBRACE] = ACTIONS(808),
    [anon_sym_STAR] = ACTIONS(808),
    [anon_sym_LBRACK] = ACTIONS(808),
    [anon_sym_static] = ACTIONS(810),
    [anon_sym_register] = ACTIONS(810),
    [anon_sym_inline] = ACTIONS(810),
    [anon_sym_const] = ACTIONS(810),
    [anon_sym_restrict] = ACTIONS(810),
    [anon_sym_volatile] = ACTIONS(810),
    [anon_sym__Atomic] = ACTIONS(810),
    [anon_sym_mutable] = ACTIONS(810),
    [anon_sym_explicit] = ACTIONS(810),
    [anon_sym_constexpr] = ACTIONS(810),
    [anon_sym_COLON] = ACTIONS(810),
    [anon_sym_AMP] = ACTIONS(810),
    [anon_sym_AMP_AMP] = ACTIONS(808),
    [anon_sym_TILDE] = ACTIONS(808),
    [anon_sym_GT] = ACTIONS(808),
    [sym_identifier] = ACTIONS(810),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(808),
    [sym_operator_name] = ACTIONS(808),
  },
  [147] = {
    [anon_sym_LPAREN] = ACTIONS(812),
    [anon_sym_COMMA] = ACTIONS(812),
    [anon_sym_RPAREN] = ACTIONS(812),
    [anon_sym_SEMI] = ACTIONS(812),
    [anon_sym_extern] = ACTIONS(814),
    [anon_sym_LBRACE] = ACTIONS(812),
    [anon_sym_STAR] = ACTIONS(812),
    [anon_sym_LBRACK] = ACTIONS(812),
    [anon_sym_static] = ACTIONS(814),
    [anon_sym_register] = ACTIONS(814),
    [anon_sym_inline] = ACTIONS(814),
    [anon_sym_const] = ACTIONS(814),
    [anon_sym_restrict] = ACTIONS(814),
    [anon_sym_volatile] = ACTIONS(814),
    [anon_sym__Atomic] = ACTIONS(814),
    [anon_sym_mutable] = ACTIONS(814),
    [anon_sym_explicit] = ACTIONS(814),
    [anon_sym_constexpr] = ACTIONS(814),
    [anon_sym_COLON] = ACTIONS(814),
    [anon_sym_AMP] = ACTIONS(814),
    [anon_sym_AMP_AMP] = ACTIONS(812),
    [anon_sym_TILDE] = ACTIONS(812),
    [anon_sym_GT] = ACTIONS(812),
    [sym_identifier] = ACTIONS(814),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(812),
    [sym_operator_name] = ACTIONS(812),
  },
  [148] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(148),
    [anon_sym_LPAREN] = ACTIONS(816),
    [anon_sym_SEMI] = ACTIONS(816),
    [anon_sym_extern] = ACTIONS(818),
    [anon_sym_STAR] = ACTIONS(816),
    [anon_sym_LBRACK] = ACTIONS(816),
    [anon_sym_static] = ACTIONS(818),
    [anon_sym_register] = ACTIONS(818),
    [anon_sym_inline] = ACTIONS(818),
    [anon_sym_const] = ACTIONS(818),
    [anon_sym_restrict] = ACTIONS(818),
    [anon_sym_volatile] = ACTIONS(818),
    [anon_sym__Atomic] = ACTIONS(818),
    [anon_sym_mutable] = ACTIONS(818),
    [anon_sym_explicit] = ACTIONS(818),
    [anon_sym_constexpr] = ACTIONS(818),
    [anon_sym_unsigned] = ACTIONS(820),
    [anon_sym_long] = ACTIONS(820),
    [anon_sym_short] = ACTIONS(820),
    [sym_primitive_type] = ACTIONS(818),
    [anon_sym_AMP] = ACTIONS(818),
    [anon_sym_AMP_AMP] = ACTIONS(816),
    [anon_sym_TILDE] = ACTIONS(816),
    [sym_identifier] = ACTIONS(818),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(816),
    [sym_operator_name] = ACTIONS(816),
  },
  [149] = {
    [sym_preproc_arg] = ACTIONS(823),
    [sym_comment] = ACTIONS(83),
  },
  [150] = {
    [ts_builtin_sym_end] = ACTIONS(825),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(827),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(827),
    [anon_sym_LPAREN] = ACTIONS(825),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(827),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(827),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(827),
    [sym_preproc_directive] = ACTIONS(827),
    [anon_sym_typedef] = ACTIONS(827),
    [anon_sym_extern] = ACTIONS(827),
    [anon_sym_RBRACE] = ACTIONS(825),
    [anon_sym_STAR] = ACTIONS(825),
    [anon_sym_static] = ACTIONS(827),
    [anon_sym_register] = ACTIONS(827),
    [anon_sym_inline] = ACTIONS(827),
    [anon_sym_const] = ACTIONS(827),
    [anon_sym_restrict] = ACTIONS(827),
    [anon_sym_volatile] = ACTIONS(827),
    [anon_sym__Atomic] = ACTIONS(827),
    [anon_sym_mutable] = ACTIONS(827),
    [anon_sym_explicit] = ACTIONS(827),
    [anon_sym_constexpr] = ACTIONS(827),
    [anon_sym_unsigned] = ACTIONS(827),
    [anon_sym_long] = ACTIONS(827),
    [anon_sym_short] = ACTIONS(827),
    [sym_primitive_type] = ACTIONS(827),
    [anon_sym_enum] = ACTIONS(827),
    [anon_sym_struct] = ACTIONS(827),
    [anon_sym_union] = ACTIONS(827),
    [anon_sym_AMP] = ACTIONS(827),
    [anon_sym_AMP_AMP] = ACTIONS(825),
    [anon_sym_TILDE] = ACTIONS(825),
    [sym_identifier] = ACTIONS(827),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(827),
    [sym_auto] = ACTIONS(827),
    [anon_sym_typename] = ACTIONS(827),
    [anon_sym_template] = ACTIONS(827),
    [anon_sym_namespace] = ACTIONS(827),
    [anon_sym_using] = ACTIONS(827),
    [anon_sym_COLON_COLON] = ACTIONS(825),
    [sym_operator_name] = ACTIONS(825),
  },
  [151] = {
    [anon_sym_DOT_DOT_DOT] = ACTIONS(829),
    [anon_sym_RPAREN] = ACTIONS(831),
    [sym_identifier] = ACTIONS(829),
    [sym_comment] = ACTIONS(49),
  },
  [152] = {
    [anon_sym_LF] = ACTIONS(833),
    [sym_preproc_arg] = ACTIONS(835),
    [sym_comment] = ACTIONS(83),
  },
  [153] = {
    [sym_parameter_list] = STATE(159),
    [anon_sym_LPAREN] = ACTIONS(206),
    [anon_sym_RPAREN] = ACTIONS(837),
    [anon_sym_LBRACK] = ACTIONS(208),
    [sym_comment] = ACTIONS(49),
  },
  [154] = {
    [sym_parameter_list] = STATE(159),
    [anon_sym_LPAREN] = ACTIONS(206),
    [anon_sym_RPAREN] = ACTIONS(839),
    [anon_sym_LBRACK] = ACTIONS(208),
    [sym_comment] = ACTIONS(49),
  },
  [155] = {
    [sym_destructor_name] = STATE(282),
    [anon_sym_TILDE] = ACTIONS(45),
    [sym_identifier] = ACTIONS(841),
    [sym_comment] = ACTIONS(49),
    [sym_operator_name] = ACTIONS(442),
  },
  [156] = {
    [anon_sym_LPAREN] = ACTIONS(704),
    [anon_sym_COMMA] = ACTIONS(704),
    [anon_sym_RPAREN] = ACTIONS(704),
    [anon_sym_SEMI] = ACTIONS(704),
    [anon_sym_LBRACE] = ACTIONS(704),
    [anon_sym_LBRACK] = ACTIONS(704),
    [anon_sym_EQ] = ACTIONS(704),
    [anon_sym_COLON] = ACTIONS(706),
    [anon_sym_GT] = ACTIONS(704),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(447),
  },
  [157] = {
    [anon_sym_LPAREN] = ACTIONS(518),
    [anon_sym_COMMA] = ACTIONS(518),
    [anon_sym_RPAREN] = ACTIONS(518),
    [anon_sym_SEMI] = ACTIONS(518),
    [anon_sym_LBRACE] = ACTIONS(518),
    [anon_sym_LBRACK] = ACTIONS(518),
    [anon_sym_EQ] = ACTIONS(518),
    [anon_sym_COLON] = ACTIONS(520),
    [anon_sym_LT] = ACTIONS(509),
    [anon_sym_GT] = ACTIONS(518),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(516),
  },
  [158] = {
    [anon_sym_LPAREN] = ACTIONS(843),
    [anon_sym_COMMA] = ACTIONS(843),
    [anon_sym_RPAREN] = ACTIONS(843),
    [anon_sym_SEMI] = ACTIONS(843),
    [anon_sym_LBRACE] = ACTIONS(843),
    [anon_sym_LBRACK] = ACTIONS(843),
    [anon_sym_EQ] = ACTIONS(843),
    [anon_sym_COLON] = ACTIONS(843),
    [anon_sym_GT] = ACTIONS(843),
    [sym_comment] = ACTIONS(49),
  },
  [159] = {
    [sym_type_qualifier] = STATE(438),
    [sym_trailing_return_type] = STATE(438),
    [aux_sym_function_declarator_repeat1] = STATE(438),
    [anon_sym_LPAREN] = ACTIONS(610),
    [anon_sym_RPAREN] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(610),
    [anon_sym_const] = ACTIONS(612),
    [anon_sym_restrict] = ACTIONS(614),
    [anon_sym_volatile] = ACTIONS(614),
    [anon_sym__Atomic] = ACTIONS(614),
    [anon_sym_mutable] = ACTIONS(614),
    [anon_sym_explicit] = ACTIONS(614),
    [anon_sym_constexpr] = ACTIONS(614),
    [anon_sym_DASH_GT] = ACTIONS(845),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(847),
  },
  [160] = {
    [sym_destructor_name] = STATE(428),
    [anon_sym_TILDE] = ACTIONS(45),
    [sym_identifier] = ACTIONS(849),
    [sym_comment] = ACTIONS(49),
    [sym_operator_name] = ACTIONS(702),
  },
  [161] = {
    [sym_string_literal] = ACTIONS(851),
    [sym_system_lib_string] = ACTIONS(851),
    [sym_comment] = ACTIONS(49),
  },
  [162] = {
    [sym_identifier] = ACTIONS(853),
    [sym_comment] = ACTIONS(49),
  },
  [163] = {
    [sym_preproc_arg] = ACTIONS(855),
    [sym_comment] = ACTIONS(83),
  },
  [164] = {
    [ts_builtin_sym_end] = ACTIONS(857),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(859),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(859),
    [anon_sym_LPAREN] = ACTIONS(857),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(859),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(859),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(859),
    [sym_preproc_directive] = ACTIONS(859),
    [anon_sym_typedef] = ACTIONS(859),
    [anon_sym_extern] = ACTIONS(859),
    [anon_sym_RBRACE] = ACTIONS(857),
    [anon_sym_STAR] = ACTIONS(857),
    [anon_sym_static] = ACTIONS(859),
    [anon_sym_register] = ACTIONS(859),
    [anon_sym_inline] = ACTIONS(859),
    [anon_sym_const] = ACTIONS(859),
    [anon_sym_restrict] = ACTIONS(859),
    [anon_sym_volatile] = ACTIONS(859),
    [anon_sym__Atomic] = ACTIONS(859),
    [anon_sym_mutable] = ACTIONS(859),
    [anon_sym_explicit] = ACTIONS(859),
    [anon_sym_constexpr] = ACTIONS(859),
    [anon_sym_unsigned] = ACTIONS(859),
    [anon_sym_long] = ACTIONS(859),
    [anon_sym_short] = ACTIONS(859),
    [sym_primitive_type] = ACTIONS(859),
    [anon_sym_enum] = ACTIONS(859),
    [anon_sym_struct] = ACTIONS(859),
    [anon_sym_union] = ACTIONS(859),
    [anon_sym_AMP] = ACTIONS(859),
    [anon_sym_AMP_AMP] = ACTIONS(857),
    [anon_sym_TILDE] = ACTIONS(857),
    [sym_identifier] = ACTIONS(859),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(859),
    [sym_auto] = ACTIONS(859),
    [anon_sym_typename] = ACTIONS(859),
    [anon_sym_template] = ACTIONS(859),
    [anon_sym_namespace] = ACTIONS(859),
    [anon_sym_using] = ACTIONS(859),
    [anon_sym_COLON_COLON] = ACTIONS(857),
    [sym_operator_name] = ACTIONS(857),
  },
  [165] = {
    [sym_identifier] = ACTIONS(861),
    [sym_comment] = ACTIONS(49),
  },
  [166] = {
    [sym_identifier] = ACTIONS(863),
    [sym_comment] = ACTIONS(49),
  },
  [167] = {
    [sym_preproc_include] = STATE(459),
    [sym_preproc_def] = STATE(459),
    [sym_preproc_function_def] = STATE(459),
    [sym_preproc_call] = STATE(459),
    [sym_preproc_if] = STATE(459),
    [sym_preproc_ifdef] = STATE(459),
    [sym_function_definition] = STATE(459),
    [sym_declaration] = STATE(459),
    [sym_type_definition] = STATE(459),
    [sym__declaration_specifiers] = STATE(456),
    [sym_linkage_specification] = STATE(459),
    [sym__declarator] = STATE(28),
    [sym_pointer_declarator] = STATE(28),
    [sym_function_declarator] = STATE(457),
    [sym_array_declarator] = STATE(28),
    [sym_storage_class_specifier] = STATE(460),
    [sym_type_qualifier] = STATE(460),
    [sym__type_specifier] = STATE(30),
    [sym_sized_type_specifier] = STATE(30),
    [sym_enum_specifier] = STATE(30),
    [sym_struct_specifier] = STATE(30),
    [sym_union_specifier] = STATE(30),
    [sym__empty_declaration] = STATE(459),
    [sym_macro_type_specifier] = STATE(30),
    [sym_class_specifier] = STATE(30),
    [sym_dependent_type] = STATE(30),
    [sym_structured_binding_declaration] = STATE(459),
    [sym_template_declaration] = STATE(459),
    [sym_template_instantiation] = STATE(459),
    [sym_constructor_or_destructor_definition] = STATE(458),
    [sym_reference_declarator] = STATE(28),
    [sym_template_type] = STATE(32),
    [sym_template_function] = STATE(28),
    [sym_namespace_definition] = STATE(459),
    [sym_using_declaration] = STATE(459),
    [sym_alias_declaration] = STATE(459),
    [sym_destructor_name] = STATE(28),
    [sym_scoped_identifier] = STATE(33),
    [sym_scoped_type_identifier] = STATE(34),
    [sym_scoped_namespace_identifier] = STATE(35),
    [aux_sym_translation_unit_repeat1] = STATE(459),
    [aux_sym__declaration_specifiers_repeat1] = STATE(460),
    [aux_sym_sized_type_specifier_repeat1] = STATE(38),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(865),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(11),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(869),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(871),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(873),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(875),
    [sym_preproc_directive] = ACTIONS(877),
    [anon_sym_typedef] = ACTIONS(879),
    [anon_sym_extern] = ACTIONS(881),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_static] = ACTIONS(27),
    [anon_sym_register] = ACTIONS(27),
    [anon_sym_inline] = ACTIONS(27),
    [anon_sym_const] = ACTIONS(29),
    [anon_sym_restrict] = ACTIONS(29),
    [anon_sym_volatile] = ACTIONS(29),
    [anon_sym__Atomic] = ACTIONS(29),
    [anon_sym_mutable] = ACTIONS(29),
    [anon_sym_explicit] = ACTIONS(29),
    [anon_sym_constexpr] = ACTIONS(29),
    [anon_sym_unsigned] = ACTIONS(31),
    [anon_sym_long] = ACTIONS(31),
    [anon_sym_short] = ACTIONS(31),
    [sym_primitive_type] = ACTIONS(33),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_union] = ACTIONS(39),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(45),
    [sym_identifier] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(51),
    [sym_auto] = ACTIONS(33),
    [anon_sym_typename] = ACTIONS(53),
    [anon_sym_template] = ACTIONS(883),
    [anon_sym_namespace] = ACTIONS(885),
    [anon_sym_using] = ACTIONS(887),
    [anon_sym_COLON_COLON] = ACTIONS(61),
    [sym_operator_name] = ACTIONS(63),
  },
  [168] = {
    [sym_preproc_arg] = ACTIONS(889),
    [sym_comment] = ACTIONS(83),
  },
  [169] = {
    [aux_sym_SLASH_LBRACK_BSLASHt_RBRACK_PLUS_SLASH] = ACTIONS(891),
    [anon_sym_LF] = ACTIONS(893),
    [sym_comment] = ACTIONS(83),
  },
  [170] = {
    [sym_type_qualifier] = STATE(465),
    [sym__type_specifier] = STATE(464),
    [sym_sized_type_specifier] = STATE(464),
    [sym_enum_specifier] = STATE(464),
    [sym_struct_specifier] = STATE(464),
    [sym_union_specifier] = STATE(464),
    [sym_macro_type_specifier] = STATE(464),
    [sym_class_specifier] = STATE(464),
    [sym_dependent_type] = STATE(464),
    [sym_template_type] = STATE(62),
    [sym_scoped_type_identifier] = STATE(63),
    [sym_scoped_namespace_identifier] = STATE(64),
    [aux_sym_type_definition_repeat1] = STATE(465),
    [aux_sym_sized_type_specifier_repeat1] = STATE(66),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_restrict] = ACTIONS(93),
    [anon_sym_volatile] = ACTIONS(93),
    [anon_sym__Atomic] = ACTIONS(93),
    [anon_sym_mutable] = ACTIONS(93),
    [anon_sym_explicit] = ACTIONS(93),
    [anon_sym_constexpr] = ACTIONS(93),
    [anon_sym_unsigned] = ACTIONS(95),
    [anon_sym_long] = ACTIONS(95),
    [anon_sym_short] = ACTIONS(95),
    [sym_primitive_type] = ACTIONS(895),
    [anon_sym_enum] = ACTIONS(99),
    [anon_sym_struct] = ACTIONS(101),
    [anon_sym_union] = ACTIONS(103),
    [sym_identifier] = ACTIONS(105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(107),
    [sym_auto] = ACTIONS(895),
    [anon_sym_typename] = ACTIONS(109),
    [anon_sym_COLON_COLON] = ACTIONS(111),
  },
  [171] = {
    [anon_sym_LPAREN] = ACTIONS(113),
    [anon_sym_extern] = ACTIONS(115),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_static] = ACTIONS(115),
    [anon_sym_register] = ACTIONS(115),
    [anon_sym_inline] = ACTIONS(115),
    [anon_sym_const] = ACTIONS(115),
    [anon_sym_restrict] = ACTIONS(115),
    [anon_sym_volatile] = ACTIONS(115),
    [anon_sym__Atomic] = ACTIONS(115),
    [anon_sym_mutable] = ACTIONS(115),
    [anon_sym_explicit] = ACTIONS(115),
    [anon_sym_constexpr] = ACTIONS(115),
    [anon_sym_unsigned] = ACTIONS(115),
    [anon_sym_long] = ACTIONS(115),
    [anon_sym_short] = ACTIONS(115),
    [sym_primitive_type] = ACTIONS(115),
    [anon_sym_enum] = ACTIONS(115),
    [anon_sym_struct] = ACTIONS(115),
    [anon_sym_union] = ACTIONS(115),
    [anon_sym_AMP] = ACTIONS(115),
    [anon_sym_AMP_AMP] = ACTIONS(113),
    [anon_sym_TILDE] = ACTIONS(113),
    [sym_string_literal] = ACTIONS(897),
    [sym_identifier] = ACTIONS(115),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(115),
    [sym_auto] = ACTIONS(115),
    [anon_sym_typename] = ACTIONS(115),
    [anon_sym_COLON_COLON] = ACTIONS(113),
    [sym_operator_name] = ACTIONS(113),
  },
  [172] = {
    [sym__declaration_specifiers] = STATE(467),
    [sym__declarator] = STATE(468),
    [sym_pointer_declarator] = STATE(468),
    [sym_function_declarator] = STATE(468),
    [sym_array_declarator] = STATE(468),
    [sym_storage_class_specifier] = STATE(109),
    [sym_type_qualifier] = STATE(109),
    [sym__type_specifier] = STATE(105),
    [sym_sized_type_specifier] = STATE(105),
    [sym_enum_specifier] = STATE(105),
    [sym_struct_specifier] = STATE(105),
    [sym_union_specifier] = STATE(105),
    [sym_macro_type_specifier] = STATE(105),
    [sym_class_specifier] = STATE(105),
    [sym_dependent_type] = STATE(105),
    [sym_template_parameter_list] = STATE(469),
    [sym_reference_declarator] = STATE(468),
    [sym_template_type] = STATE(107),
    [sym_template_function] = STATE(468),
    [sym_destructor_name] = STATE(468),
    [sym_scoped_identifier] = STATE(33),
    [sym_scoped_type_identifier] = STATE(34),
    [sym_scoped_namespace_identifier] = STATE(108),
    [aux_sym__declaration_specifiers_repeat1] = STATE(109),
    [aux_sym_sized_type_specifier_repeat1] = STATE(110),
    [anon_sym_LPAREN] = ACTIONS(11),
    [anon_sym_extern] = ACTIONS(154),
    [anon_sym_STAR] = ACTIONS(156),
    [anon_sym_static] = ACTIONS(154),
    [anon_sym_register] = ACTIONS(154),
    [anon_sym_inline] = ACTIONS(154),
    [anon_sym_const] = ACTIONS(158),
    [anon_sym_restrict] = ACTIONS(158),
    [anon_sym_volatile] = ACTIONS(158),
    [anon_sym__Atomic] = ACTIONS(158),
    [anon_sym_mutable] = ACTIONS(158),
    [anon_sym_explicit] = ACTIONS(158),
    [anon_sym_constexpr] = ACTIONS(158),
    [anon_sym_unsigned] = ACTIONS(160),
    [anon_sym_long] = ACTIONS(160),
    [anon_sym_short] = ACTIONS(160),
    [sym_primitive_type] = ACTIONS(162),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_union] = ACTIONS(39),
    [anon_sym_AMP] = ACTIONS(164),
    [anon_sym_AMP_AMP] = ACTIONS(166),
    [anon_sym_TILDE] = ACTIONS(45),
    [anon_sym_LT] = ACTIONS(168),
    [sym_identifier] = ACTIONS(170),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(51),
    [sym_auto] = ACTIONS(162),
    [anon_sym_typename] = ACTIONS(172),
    [anon_sym_COLON_COLON] = ACTIONS(174),
    [sym_operator_name] = ACTIONS(899),
  },
  [173] = {
    [sym_declaration_list] = STATE(472),
    [anon_sym_LBRACE] = ACTIONS(901),
    [sym_identifier] = ACTIONS(903),
    [sym_comment] = ACTIONS(49),
  },
  [174] = {
    [sym_template_type] = STATE(117),
    [sym_scoped_identifier] = STATE(475),
    [sym_scoped_type_identifier] = STATE(47),
    [sym_scoped_namespace_identifier] = STATE(117),
    [sym_identifier] = ACTIONS(905),
    [sym_comment] = ACTIONS(49),
    [anon_sym_namespace] = ACTIONS(907),
    [anon_sym_COLON_COLON] = ACTIONS(186),
  },
  [175] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(909),
    [sym_comment] = ACTIONS(49),
  },
  [176] = {
    [sym__declarator] = STATE(478),
    [sym_pointer_declarator] = STATE(478),
    [sym_function_declarator] = STATE(478),
    [sym_array_declarator] = STATE(478),
    [sym_init_declarator] = STATE(479),
    [sym_reference_declarator] = STATE(478),
    [sym_structured_binding_reference_declarator] = STATE(480),
    [sym_structured_binding_declarator] = STATE(481),
    [sym_template_type] = STATE(46),
    [sym_template_function] = STATE(478),
    [sym_destructor_name] = STATE(478),
    [sym_scoped_identifier] = STATE(33),
    [sym_scoped_type_identifier] = STATE(47),
    [sym_scoped_namespace_identifier] = STATE(46),
    [anon_sym_LPAREN] = ACTIONS(11),
    [anon_sym_SEMI] = ACTIONS(911),
    [anon_sym_STAR] = ACTIONS(196),
    [anon_sym_LBRACK] = ACTIONS(198),
    [anon_sym_AMP] = ACTIONS(200),
    [anon_sym_AMP_AMP] = ACTIONS(202),
    [anon_sym_TILDE] = ACTIONS(45),
    [sym_identifier] = ACTIONS(75),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(77),
    [sym_operator_name] = ACTIONS(913),
  },
  [177] = {
    [sym_compound_statement] = STATE(483),
    [sym_field_initializer_list] = STATE(484),
    [anon_sym_LPAREN] = ACTIONS(210),
    [anon_sym_LBRACE] = ACTIONS(915),
    [anon_sym_LBRACK] = ACTIONS(210),
    [anon_sym_COLON] = ACTIONS(214),
    [sym_comment] = ACTIONS(49),
  },
  [178] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(226),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(226),
    [anon_sym_LPAREN] = ACTIONS(224),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(226),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(226),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(226),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(226),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(226),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(226),
    [sym_preproc_directive] = ACTIONS(226),
    [anon_sym_typedef] = ACTIONS(226),
    [anon_sym_extern] = ACTIONS(226),
    [anon_sym_STAR] = ACTIONS(224),
    [anon_sym_static] = ACTIONS(226),
    [anon_sym_register] = ACTIONS(226),
    [anon_sym_inline] = ACTIONS(226),
    [anon_sym_const] = ACTIONS(226),
    [anon_sym_restrict] = ACTIONS(226),
    [anon_sym_volatile] = ACTIONS(226),
    [anon_sym__Atomic] = ACTIONS(226),
    [anon_sym_mutable] = ACTIONS(226),
    [anon_sym_explicit] = ACTIONS(226),
    [anon_sym_constexpr] = ACTIONS(226),
    [anon_sym_unsigned] = ACTIONS(226),
    [anon_sym_long] = ACTIONS(226),
    [anon_sym_short] = ACTIONS(226),
    [sym_primitive_type] = ACTIONS(226),
    [anon_sym_enum] = ACTIONS(226),
    [anon_sym_struct] = ACTIONS(226),
    [anon_sym_union] = ACTIONS(226),
    [anon_sym_AMP] = ACTIONS(226),
    [anon_sym_AMP_AMP] = ACTIONS(224),
    [anon_sym_TILDE] = ACTIONS(224),
    [sym_identifier] = ACTIONS(226),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(226),
    [sym_auto] = ACTIONS(226),
    [anon_sym_typename] = ACTIONS(226),
    [anon_sym_template] = ACTIONS(226),
    [anon_sym_namespace] = ACTIONS(226),
    [anon_sym_using] = ACTIONS(226),
    [anon_sym_COLON_COLON] = ACTIONS(224),
    [sym_operator_name] = ACTIONS(224),
  },
  [179] = {
    [sym_preproc_include] = STATE(486),
    [sym_preproc_def] = STATE(486),
    [sym_preproc_function_def] = STATE(486),
    [sym_preproc_call] = STATE(486),
    [sym_preproc_if] = STATE(486),
    [sym_preproc_ifdef] = STATE(486),
    [sym_preproc_else] = STATE(485),
    [sym_preproc_elif] = STATE(485),
    [sym_function_definition] = STATE(486),
    [sym_declaration] = STATE(486),
    [sym_type_definition] = STATE(486),
    [sym__declaration_specifiers] = STATE(176),
    [sym_linkage_specification] = STATE(486),
    [sym__declarator] = STATE(28),
    [sym_pointer_declarator] = STATE(28),
    [sym_function_declarator] = STATE(177),
    [sym_array_declarator] = STATE(28),
    [sym_storage_class_specifier] = STATE(180),
    [sym_type_qualifier] = STATE(180),
    [sym__type_specifier] = STATE(30),
    [sym_sized_type_specifier] = STATE(30),
    [sym_enum_specifier] = STATE(30),
    [sym_struct_specifier] = STATE(30),
    [sym_union_specifier] = STATE(30),
    [sym__empty_declaration] = STATE(486),
    [sym_macro_type_specifier] = STATE(30),
    [sym_class_specifier] = STATE(30),
    [sym_dependent_type] = STATE(30),
    [sym_structured_binding_declaration] = STATE(486),
    [sym_template_declaration] = STATE(486),
    [sym_template_instantiation] = STATE(486),
    [sym_constructor_or_destructor_definition] = STATE(178),
    [sym_reference_declarator] = STATE(28),
    [sym_template_type] = STATE(32),
    [sym_template_function] = STATE(28),
    [sym_namespace_definition] = STATE(486),
    [sym_using_declaration] = STATE(486),
    [sym_alias_declaration] = STATE(486),
    [sym_destructor_name] = STATE(28),
    [sym_scoped_identifier] = STATE(33),
    [sym_scoped_type_identifier] = STATE(34),
    [sym_scoped_namespace_identifier] = STATE(35),
    [aux_sym_translation_unit_repeat1] = STATE(486),
    [aux_sym__declaration_specifiers_repeat1] = STATE(180),
    [aux_sym_sized_type_specifier_repeat1] = STATE(38),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(273),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(275),
    [anon_sym_LPAREN] = ACTIONS(11),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(277),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(917),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(281),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(283),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(285),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(287),
    [sym_preproc_directive] = ACTIONS(289),
    [anon_sym_typedef] = ACTIONS(291),
    [anon_sym_extern] = ACTIONS(293),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_static] = ACTIONS(27),
    [anon_sym_register] = ACTIONS(27),
    [anon_sym_inline] = ACTIONS(27),
    [anon_sym_const] = ACTIONS(29),
    [anon_sym_restrict] = ACTIONS(29),
    [anon_sym_volatile] = ACTIONS(29),
    [anon_sym__Atomic] = ACTIONS(29),
    [anon_sym_mutable] = ACTIONS(29),
    [anon_sym_explicit] = ACTIONS(29),
    [anon_sym_constexpr] = ACTIONS(29),
    [anon_sym_unsigned] = ACTIONS(31),
    [anon_sym_long] = ACTIONS(31),
    [anon_sym_short] = ACTIONS(31),
    [sym_primitive_type] = ACTIONS(33),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_union] = ACTIONS(39),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(45),
    [sym_identifier] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(51),
    [sym_auto] = ACTIONS(33),
    [anon_sym_typename] = ACTIONS(53),
    [anon_sym_template] = ACTIONS(295),
    [anon_sym_namespace] = ACTIONS(297),
    [anon_sym_using] = ACTIONS(299),
    [anon_sym_COLON_COLON] = ACTIONS(61),
    [sym_operator_name] = ACTIONS(63),
  },
  [180] = {
    [sym__declarator] = STATE(28),
    [sym_pointer_declarator] = STATE(28),
    [sym_function_declarator] = STATE(487),
    [sym_array_declarator] = STATE(28),
    [sym_storage_class_specifier] = STATE(145),
    [sym_type_qualifier] = STATE(145),
    [sym__type_specifier] = STATE(144),
    [sym_sized_type_specifier] = STATE(144),
    [sym_enum_specifier] = STATE(144),
    [sym_struct_specifier] = STATE(144),
    [sym_union_specifier] = STATE(144),
    [sym_macro_type_specifier] = STATE(144),
    [sym_class_specifier] = STATE(144),
    [sym_dependent_type] = STATE(144),
    [sym_reference_declarator] = STATE(28),
    [sym_template_type] = STATE(32),
    [sym_template_function] = STATE(28),
    [sym_destructor_name] = STATE(28),
    [sym_scoped_identifier] = STATE(33),
    [sym_scoped_type_identifier] = STATE(34),
    [sym_scoped_namespace_identifier] = STATE(35),
    [aux_sym__declaration_specifiers_repeat1] = STATE(145),
    [aux_sym_sized_type_specifier_repeat1] = STATE(38),
    [anon_sym_LPAREN] = ACTIONS(11),
    [anon_sym_extern] = ACTIONS(27),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_static] = ACTIONS(27),
    [anon_sym_register] = ACTIONS(27),
    [anon_sym_inline] = ACTIONS(27),
    [anon_sym_const] = ACTIONS(29),
    [anon_sym_restrict] = ACTIONS(29),
    [anon_sym_volatile] = ACTIONS(29),
    [anon_sym__Atomic] = ACTIONS(29),
    [anon_sym_mutable] = ACTIONS(29),
    [anon_sym_explicit] = ACTIONS(29),
    [anon_sym_constexpr] = ACTIONS(29),
    [anon_sym_unsigned] = ACTIONS(31),
    [anon_sym_long] = ACTIONS(31),
    [anon_sym_short] = ACTIONS(31),
    [sym_primitive_type] = ACTIONS(236),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_union] = ACTIONS(39),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(45),
    [sym_identifier] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(51),
    [sym_auto] = ACTIONS(236),
    [anon_sym_typename] = ACTIONS(53),
    [anon_sym_COLON_COLON] = ACTIONS(61),
    [sym_operator_name] = ACTIONS(63),
  },
  [181] = {
    [ts_builtin_sym_end] = ACTIONS(919),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(921),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(921),
    [anon_sym_LPAREN] = ACTIONS(919),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(921),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(921),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(921),
    [sym_preproc_directive] = ACTIONS(921),
    [anon_sym_typedef] = ACTIONS(921),
    [anon_sym_extern] = ACTIONS(921),
    [anon_sym_RBRACE] = ACTIONS(919),
    [anon_sym_STAR] = ACTIONS(919),
    [anon_sym_static] = ACTIONS(921),
    [anon_sym_register] = ACTIONS(921),
    [anon_sym_inline] = ACTIONS(921),
    [anon_sym_const] = ACTIONS(921),
    [anon_sym_restrict] = ACTIONS(921),
    [anon_sym_volatile] = ACTIONS(921),
    [anon_sym__Atomic] = ACTIONS(921),
    [anon_sym_mutable] = ACTIONS(921),
    [anon_sym_explicit] = ACTIONS(921),
    [anon_sym_constexpr] = ACTIONS(921),
    [anon_sym_unsigned] = ACTIONS(921),
    [anon_sym_long] = ACTIONS(921),
    [anon_sym_short] = ACTIONS(921),
    [sym_primitive_type] = ACTIONS(921),
    [anon_sym_enum] = ACTIONS(921),
    [anon_sym_struct] = ACTIONS(921),
    [anon_sym_union] = ACTIONS(921),
    [anon_sym_AMP] = ACTIONS(921),
    [anon_sym_AMP_AMP] = ACTIONS(919),
    [anon_sym_TILDE] = ACTIONS(919),
    [sym_identifier] = ACTIONS(921),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(921),
    [sym_auto] = ACTIONS(921),
    [anon_sym_typename] = ACTIONS(921),
    [anon_sym_template] = ACTIONS(921),
    [anon_sym_namespace] = ACTIONS(921),
    [anon_sym_using] = ACTIONS(921),
    [anon_sym_COLON_COLON] = ACTIONS(919),
    [sym_operator_name] = ACTIONS(919),
  },
  [182] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(923),
    [sym_comment] = ACTIONS(49),
  },
  [183] = {
    [sym_preproc_include] = STATE(486),
    [sym_preproc_def] = STATE(486),
    [sym_preproc_function_def] = STATE(486),
    [sym_preproc_call] = STATE(486),
    [sym_preproc_if] = STATE(486),
    [sym_preproc_ifdef] = STATE(486),
    [sym_preproc_else] = STATE(489),
    [sym_preproc_elif] = STATE(489),
    [sym_function_definition] = STATE(486),
    [sym_declaration] = STATE(486),
    [sym_type_definition] = STATE(486),
    [sym__declaration_specifiers] = STATE(176),
    [sym_linkage_specification] = STATE(486),
    [sym__declarator] = STATE(28),
    [sym_pointer_declarator] = STATE(28),
    [sym_function_declarator] = STATE(177),
    [sym_array_declarator] = STATE(28),
    [sym_storage_class_specifier] = STATE(180),
    [sym_type_qualifier] = STATE(180),
    [sym__type_specifier] = STATE(30),
    [sym_sized_type_specifier] = STATE(30),
    [sym_enum_specifier] = STATE(30),
    [sym_struct_specifier] = STATE(30),
    [sym_union_specifier] = STATE(30),
    [sym__empty_declaration] = STATE(486),
    [sym_macro_type_specifier] = STATE(30),
    [sym_class_specifier] = STATE(30),
    [sym_dependent_type] = STATE(30),
    [sym_structured_binding_declaration] = STATE(486),
    [sym_template_declaration] = STATE(486),
    [sym_template_instantiation] = STATE(486),
    [sym_constructor_or_destructor_definition] = STATE(178),
    [sym_reference_declarator] = STATE(28),
    [sym_template_type] = STATE(32),
    [sym_template_function] = STATE(28),
    [sym_namespace_definition] = STATE(486),
    [sym_using_declaration] = STATE(486),
    [sym_alias_declaration] = STATE(486),
    [sym_destructor_name] = STATE(28),
    [sym_scoped_identifier] = STATE(33),
    [sym_scoped_type_identifier] = STATE(34),
    [sym_scoped_namespace_identifier] = STATE(35),
    [aux_sym_translation_unit_repeat1] = STATE(486),
    [aux_sym__declaration_specifiers_repeat1] = STATE(180),
    [aux_sym_sized_type_specifier_repeat1] = STATE(38),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(273),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(275),
    [anon_sym_LPAREN] = ACTIONS(11),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(277),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(925),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(281),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(283),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(285),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(287),
    [sym_preproc_directive] = ACTIONS(289),
    [anon_sym_typedef] = ACTIONS(291),
    [anon_sym_extern] = ACTIONS(293),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_static] = ACTIONS(27),
    [anon_sym_register] = ACTIONS(27),
    [anon_sym_inline] = ACTIONS(27),
    [anon_sym_const] = ACTIONS(29),
    [anon_sym_restrict] = ACTIONS(29),
    [anon_sym_volatile] = ACTIONS(29),
    [anon_sym__Atomic] = ACTIONS(29),
    [anon_sym_mutable] = ACTIONS(29),
    [anon_sym_explicit] = ACTIONS(29),
    [anon_sym_constexpr] = ACTIONS(29),
    [anon_sym_unsigned] = ACTIONS(31),
    [anon_sym_long] = ACTIONS(31),
    [anon_sym_short] = ACTIONS(31),
    [sym_primitive_type] = ACTIONS(33),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_union] = ACTIONS(39),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(45),
    [sym_identifier] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(51),
    [sym_auto] = ACTIONS(33),
    [anon_sym_typename] = ACTIONS(53),
    [anon_sym_template] = ACTIONS(295),
    [anon_sym_namespace] = ACTIONS(297),
    [anon_sym_using] = ACTIONS(299),
    [anon_sym_COLON_COLON] = ACTIONS(61),
    [sym_operator_name] = ACTIONS(63),
  },
  [184] = {
    [ts_builtin_sym_end] = ACTIONS(927),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(929),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(929),
    [anon_sym_LPAREN] = ACTIONS(927),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(929),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(929),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(929),
    [sym_preproc_directive] = ACTIONS(929),
    [anon_sym_typedef] = ACTIONS(929),
    [anon_sym_extern] = ACTIONS(929),
    [anon_sym_RBRACE] = ACTIONS(927),
    [anon_sym_STAR] = ACTIONS(927),
    [anon_sym_static] = ACTIONS(929),
    [anon_sym_register] = ACTIONS(929),
    [anon_sym_inline] = ACTIONS(929),
    [anon_sym_const] = ACTIONS(929),
    [anon_sym_restrict] = ACTIONS(929),
    [anon_sym_volatile] = ACTIONS(929),
    [anon_sym__Atomic] = ACTIONS(929),
    [anon_sym_mutable] = ACTIONS(929),
    [anon_sym_explicit] = ACTIONS(929),
    [anon_sym_constexpr] = ACTIONS(929),
    [anon_sym_unsigned] = ACTIONS(929),
    [anon_sym_long] = ACTIONS(929),
    [anon_sym_short] = ACTIONS(929),
    [sym_primitive_type] = ACTIONS(929),
    [anon_sym_enum] = ACTIONS(929),
    [anon_sym_struct] = ACTIONS(929),
    [anon_sym_union] = ACTIONS(929),
    [anon_sym_AMP] = ACTIONS(929),
    [anon_sym_AMP_AMP] = ACTIONS(927),
    [anon_sym_TILDE] = ACTIONS(927),
    [sym_identifier] = ACTIONS(929),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(929),
    [sym_auto] = ACTIONS(929),
    [anon_sym_typename] = ACTIONS(929),
    [anon_sym_template] = ACTIONS(929),
    [anon_sym_namespace] = ACTIONS(929),
    [anon_sym_using] = ACTIONS(929),
    [anon_sym_COLON_COLON] = ACTIONS(927),
    [sym_operator_name] = ACTIONS(927),
  },
  [185] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(931),
    [sym_comment] = ACTIONS(49),
  },
  [186] = {
    [sym_preproc_include] = STATE(486),
    [sym_preproc_def] = STATE(486),
    [sym_preproc_function_def] = STATE(486),
    [sym_preproc_call] = STATE(486),
    [sym_preproc_if] = STATE(486),
    [sym_preproc_ifdef] = STATE(486),
    [sym_preproc_else] = STATE(491),
    [sym_preproc_elif] = STATE(491),
    [sym_function_definition] = STATE(486),
    [sym_declaration] = STATE(486),
    [sym_type_definition] = STATE(486),
    [sym__declaration_specifiers] = STATE(176),
    [sym_linkage_specification] = STATE(486),
    [sym__declarator] = STATE(28),
    [sym_pointer_declarator] = STATE(28),
    [sym_function_declarator] = STATE(177),
    [sym_array_declarator] = STATE(28),
    [sym_storage_class_specifier] = STATE(180),
    [sym_type_qualifier] = STATE(180),
    [sym__type_specifier] = STATE(30),
    [sym_sized_type_specifier] = STATE(30),
    [sym_enum_specifier] = STATE(30),
    [sym_struct_specifier] = STATE(30),
    [sym_union_specifier] = STATE(30),
    [sym__empty_declaration] = STATE(486),
    [sym_macro_type_specifier] = STATE(30),
    [sym_class_specifier] = STATE(30),
    [sym_dependent_type] = STATE(30),
    [sym_structured_binding_declaration] = STATE(486),
    [sym_template_declaration] = STATE(486),
    [sym_template_instantiation] = STATE(486),
    [sym_constructor_or_destructor_definition] = STATE(178),
    [sym_reference_declarator] = STATE(28),
    [sym_template_type] = STATE(32),
    [sym_template_function] = STATE(28),
    [sym_namespace_definition] = STATE(486),
    [sym_using_declaration] = STATE(486),
    [sym_alias_declaration] = STATE(486),
    [sym_destructor_name] = STATE(28),
    [sym_scoped_identifier] = STATE(33),
    [sym_scoped_type_identifier] = STATE(34),
    [sym_scoped_namespace_identifier] = STATE(35),
    [aux_sym_translation_unit_repeat1] = STATE(486),
    [aux_sym__declaration_specifiers_repeat1] = STATE(180),
    [aux_sym_sized_type_specifier_repeat1] = STATE(38),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(273),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(275),
    [anon_sym_LPAREN] = ACTIONS(11),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(277),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(933),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(281),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(283),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(285),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(287),
    [sym_preproc_directive] = ACTIONS(289),
    [anon_sym_typedef] = ACTIONS(291),
    [anon_sym_extern] = ACTIONS(293),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_static] = ACTIONS(27),
    [anon_sym_register] = ACTIONS(27),
    [anon_sym_inline] = ACTIONS(27),
    [anon_sym_const] = ACTIONS(29),
    [anon_sym_restrict] = ACTIONS(29),
    [anon_sym_volatile] = ACTIONS(29),
    [anon_sym__Atomic] = ACTIONS(29),
    [anon_sym_mutable] = ACTIONS(29),
    [anon_sym_explicit] = ACTIONS(29),
    [anon_sym_constexpr] = ACTIONS(29),
    [anon_sym_unsigned] = ACTIONS(31),
    [anon_sym_long] = ACTIONS(31),
    [anon_sym_short] = ACTIONS(31),
    [sym_primitive_type] = ACTIONS(33),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_union] = ACTIONS(39),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(45),
    [sym_identifier] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(51),
    [sym_auto] = ACTIONS(33),
    [anon_sym_typename] = ACTIONS(53),
    [anon_sym_template] = ACTIONS(295),
    [anon_sym_namespace] = ACTIONS(297),
    [anon_sym_using] = ACTIONS(299),
    [anon_sym_COLON_COLON] = ACTIONS(61),
    [sym_operator_name] = ACTIONS(63),
  },
  [187] = {
    [anon_sym_LF] = ACTIONS(935),
    [sym_comment] = ACTIONS(83),
  },
  [188] = {
    [sym_enumerator] = STATE(495),
    [anon_sym_COMMA] = ACTIONS(937),
    [anon_sym_RBRACE] = ACTIONS(939),
    [sym_identifier] = ACTIONS(348),
    [sym_comment] = ACTIONS(49),
  },
  [189] = {
    [sym_enumerator_list] = STATE(496),
    [anon_sym_LPAREN] = ACTIONS(350),
    [anon_sym_LBRACE] = ACTIONS(311),
    [anon_sym_STAR] = ACTIONS(350),
    [sym_identifier] = ACTIONS(350),
    [sym_comment] = ACTIONS(49),
  },
  [190] = {
    [anon_sym_LPAREN] = ACTIONS(354),
    [anon_sym_STAR] = ACTIONS(354),
    [sym_identifier] = ACTIONS(354),
    [sym_comment] = ACTIONS(49),
  },
  [191] = {
    [sym_preproc_if_in_field_declaration_list] = STATE(246),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(247),
    [sym_type_definition] = STATE(498),
    [sym__declaration_specifiers] = STATE(248),
    [sym__declarator] = STATE(249),
    [sym_pointer_declarator] = STATE(249),
    [sym_function_declarator] = STATE(250),
    [sym_array_declarator] = STATE(249),
    [sym_storage_class_specifier] = STATE(257),
    [sym_type_qualifier] = STATE(257),
    [sym__type_specifier] = STATE(251),
    [sym_sized_type_specifier] = STATE(251),
    [sym_enum_specifier] = STATE(251),
    [sym_struct_specifier] = STATE(251),
    [sym_union_specifier] = STATE(251),
    [sym__field_declaration_list_item] = STATE(498),
    [sym_field_declaration] = STATE(498),
    [sym_macro_type_specifier] = STATE(251),
    [sym_class_specifier] = STATE(251),
    [sym_dependent_type] = STATE(251),
    [sym_template_declaration] = STATE(498),
    [sym_inline_method_definition] = STATE(252),
    [sym_constructor_or_destructor_definition] = STATE(252),
    [sym_constructor_or_destructor_declaration] = STATE(253),
    [sym_friend_declaration] = STATE(498),
    [sym_access_specifier] = STATE(498),
    [sym_reference_declarator] = STATE(249),
    [sym_template_type] = STATE(254),
    [sym_template_function] = STATE(249),
    [sym_using_declaration] = STATE(498),
    [sym_alias_declaration] = STATE(498),
    [sym_destructor_name] = STATE(249),
    [sym_scoped_identifier] = STATE(33),
    [sym_scoped_type_identifier] = STATE(34),
    [sym_scoped_namespace_identifier] = STATE(255),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(498),
    [aux_sym__declaration_specifiers_repeat1] = STATE(257),
    [aux_sym_sized_type_specifier_repeat1] = STATE(258),
    [anon_sym_LPAREN] = ACTIONS(11),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(358),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(360),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(362),
    [anon_sym_typedef] = ACTIONS(364),
    [anon_sym_extern] = ACTIONS(27),
    [anon_sym_RBRACE] = ACTIONS(941),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_static] = ACTIONS(27),
    [anon_sym_register] = ACTIONS(27),
    [anon_sym_inline] = ACTIONS(27),
    [anon_sym_const] = ACTIONS(29),
    [anon_sym_restrict] = ACTIONS(29),
    [anon_sym_volatile] = ACTIONS(29),
    [anon_sym__Atomic] = ACTIONS(29),
    [anon_sym_mutable] = ACTIONS(29),
    [anon_sym_explicit] = ACTIONS(29),
    [anon_sym_constexpr] = ACTIONS(29),
    [anon_sym_unsigned] = ACTIONS(368),
    [anon_sym_long] = ACTIONS(368),
    [anon_sym_short] = ACTIONS(368),
    [sym_primitive_type] = ACTIONS(370),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(372),
    [anon_sym_union] = ACTIONS(374),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(45),
    [sym_identifier] = ACTIONS(376),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(378),
    [anon_sym_public] = ACTIONS(380),
    [sym_auto] = ACTIONS(370),
    [anon_sym_typename] = ACTIONS(382),
    [anon_sym_template] = ACTIONS(384),
    [anon_sym_friend] = ACTIONS(386),
    [anon_sym_private] = ACTIONS(380),
    [anon_sym_protected] = ACTIONS(380),
    [anon_sym_using] = ACTIONS(388),
    [anon_sym_COLON_COLON] = ACTIONS(390),
    [sym_operator_name] = ACTIONS(392),
  },
  [192] = {
    [sym_template_argument_list] = STATE(203),
    [anon_sym_LPAREN] = ACTIONS(398),
    [anon_sym_LBRACE] = ACTIONS(398),
    [anon_sym_STAR] = ACTIONS(398),
    [anon_sym_COLON] = ACTIONS(400),
    [anon_sym_LT] = ACTIONS(319),
    [sym_identifier] = ACTIONS(398),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(321),
  },
  [193] = {
    [anon_sym_LPAREN] = ACTIONS(406),
    [anon_sym_STAR] = ACTIONS(406),
    [sym_identifier] = ACTIONS(406),
    [sym_comment] = ACTIONS(49),
  },
  [194] = {
    [sym_field_declaration_list] = STATE(499),
    [sym_base_class_clause] = STATE(500),
    [anon_sym_LPAREN] = ACTIONS(406),
    [anon_sym_LBRACE] = ACTIONS(315),
    [anon_sym_STAR] = ACTIONS(406),
    [anon_sym_COLON] = ACTIONS(943),
    [sym_identifier] = ACTIONS(406),
    [sym_comment] = ACTIONS(49),
  },
  [195] = {
    [sym_field_declaration_list] = STATE(499),
    [anon_sym_LBRACE] = ACTIONS(315),
    [sym_comment] = ACTIONS(49),
  },
  [196] = {
    [anon_sym_LPAREN] = ACTIONS(410),
    [anon_sym_COMMA] = ACTIONS(410),
    [anon_sym_RPAREN] = ACTIONS(410),
    [anon_sym_SEMI] = ACTIONS(410),
    [anon_sym_LBRACE] = ACTIONS(410),
    [anon_sym_STAR] = ACTIONS(410),
    [anon_sym_LBRACK] = ACTIONS(410),
    [anon_sym_COLON] = ACTIONS(412),
    [anon_sym_AMP] = ACTIONS(412),
    [anon_sym_AMP_AMP] = ACTIONS(410),
    [anon_sym_GT] = ACTIONS(410),
    [sym_identifier] = ACTIONS(410),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(333),
  },
  [197] = {
    [sym_template_argument_list] = STATE(217),
    [anon_sym_LPAREN] = ACTIONS(410),
    [anon_sym_LBRACE] = ACTIONS(410),
    [anon_sym_STAR] = ACTIONS(410),
    [anon_sym_COLON] = ACTIONS(410),
    [anon_sym_LT] = ACTIONS(319),
    [sym_identifier] = ACTIONS(410),
    [sym_comment] = ACTIONS(49),
  },
  [198] = {
    [anon_sym_LPAREN] = ACTIONS(416),
    [anon_sym_STAR] = ACTIONS(416),
    [sym_identifier] = ACTIONS(416),
    [sym_comment] = ACTIONS(49),
  },
  [199] = {
    [sym_field_declaration_list] = STATE(501),
    [sym_base_class_clause] = STATE(502),
    [anon_sym_LPAREN] = ACTIONS(416),
    [anon_sym_LBRACE] = ACTIONS(315),
    [anon_sym_STAR] = ACTIONS(416),
    [anon_sym_COLON] = ACTIONS(943),
    [sym_identifier] = ACTIONS(416),
    [sym_comment] = ACTIONS(49),
  },
  [200] = {
    [sym_field_declaration_list] = STATE(501),
    [anon_sym_LBRACE] = ACTIONS(315),
    [sym_comment] = ACTIONS(49),
  },
  [201] = {
    [sym_type_qualifier] = STATE(279),
    [sym__type_specifier] = STATE(277),
    [sym_sized_type_specifier] = STATE(277),
    [sym_enum_specifier] = STATE(277),
    [sym_struct_specifier] = STATE(277),
    [sym_union_specifier] = STATE(277),
    [sym_type_descriptor] = STATE(504),
    [sym_parenthesized_expression] = STATE(504),
    [sym_macro_type_specifier] = STATE(277),
    [sym_class_specifier] = STATE(277),
    [sym_dependent_type] = STATE(277),
    [sym_template_type] = STATE(62),
    [sym_scoped_type_identifier] = STATE(34),
    [sym_scoped_namespace_identifier] = STATE(64),
    [aux_sym_type_definition_repeat1] = STATE(279),
    [aux_sym_sized_type_specifier_repeat1] = STATE(280),
    [anon_sym_LPAREN] = ACTIONS(422),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_restrict] = ACTIONS(93),
    [anon_sym_volatile] = ACTIONS(93),
    [anon_sym__Atomic] = ACTIONS(93),
    [anon_sym_mutable] = ACTIONS(93),
    [anon_sym_explicit] = ACTIONS(93),
    [anon_sym_constexpr] = ACTIONS(93),
    [anon_sym_unsigned] = ACTIONS(424),
    [anon_sym_long] = ACTIONS(424),
    [anon_sym_short] = ACTIONS(424),
    [sym_primitive_type] = ACTIONS(426),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(428),
    [anon_sym_union] = ACTIONS(430),
    [anon_sym_GT] = ACTIONS(945),
    [sym_identifier] = ACTIONS(434),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(436),
    [sym_auto] = ACTIONS(426),
    [anon_sym_typename] = ACTIONS(438),
    [anon_sym_COLON_COLON] = ACTIONS(111),
  },
  [202] = {
    [sym_identifier] = ACTIONS(947),
    [sym_comment] = ACTIONS(49),
  },
  [203] = {
    [anon_sym_LPAREN] = ACTIONS(447),
    [anon_sym_COMMA] = ACTIONS(447),
    [anon_sym_RPAREN] = ACTIONS(447),
    [anon_sym_SEMI] = ACTIONS(447),
    [anon_sym_LBRACE] = ACTIONS(447),
    [anon_sym_STAR] = ACTIONS(447),
    [anon_sym_LBRACK] = ACTIONS(447),
    [anon_sym_COLON] = ACTIONS(449),
    [anon_sym_AMP] = ACTIONS(449),
    [anon_sym_AMP_AMP] = ACTIONS(447),
    [anon_sym_GT] = ACTIONS(447),
    [sym_identifier] = ACTIONS(447),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(447),
  },
  [204] = {
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_STAR] = ACTIONS(451),
    [sym_identifier] = ACTIONS(451),
    [sym_comment] = ACTIONS(49),
  },
  [205] = {
    [sym_field_declaration_list] = STATE(506),
    [sym_base_class_clause] = STATE(507),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_LBRACE] = ACTIONS(315),
    [anon_sym_STAR] = ACTIONS(451),
    [anon_sym_COLON] = ACTIONS(943),
    [sym_identifier] = ACTIONS(451),
    [sym_comment] = ACTIONS(49),
  },
  [206] = {
    [sym_field_declaration_list] = STATE(506),
    [anon_sym_LBRACE] = ACTIONS(315),
    [sym_comment] = ACTIONS(49),
  },
  [207] = {
    [anon_sym_LPAREN] = ACTIONS(455),
    [anon_sym_STAR] = ACTIONS(455),
    [sym_identifier] = ACTIONS(455),
    [sym_comment] = ACTIONS(49),
  },
  [208] = {
    [anon_sym_LPAREN] = ACTIONS(512),
    [anon_sym_COMMA] = ACTIONS(512),
    [anon_sym_RPAREN] = ACTIONS(512),
    [anon_sym_SEMI] = ACTIONS(512),
    [anon_sym_LBRACE] = ACTIONS(512),
    [anon_sym_STAR] = ACTIONS(512),
    [anon_sym_LBRACK] = ACTIONS(512),
    [anon_sym_COLON] = ACTIONS(514),
    [anon_sym_AMP] = ACTIONS(514),
    [anon_sym_AMP_AMP] = ACTIONS(512),
    [anon_sym_LT] = ACTIONS(512),
    [anon_sym_GT] = ACTIONS(512),
    [sym_identifier] = ACTIONS(512),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(516),
  },
  [209] = {
    [sym__type_declarator] = STATE(509),
    [sym_pointer_type_declarator] = STATE(213),
    [sym_function_type_declarator] = STATE(214),
    [sym_array_type_declarator] = STATE(215),
    [anon_sym_LPAREN] = ACTIONS(327),
    [anon_sym_STAR] = ACTIONS(949),
    [sym_identifier] = ACTIONS(331),
    [sym_comment] = ACTIONS(49),
  },
  [210] = {
    [sym__type_declarator] = STATE(510),
    [sym_pointer_type_declarator] = STATE(213),
    [sym_function_type_declarator] = STATE(214),
    [sym_array_type_declarator] = STATE(215),
    [anon_sym_LPAREN] = ACTIONS(327),
    [anon_sym_STAR] = ACTIONS(329),
    [sym_identifier] = ACTIONS(331),
    [sym_comment] = ACTIONS(49),
  },
  [211] = {
    [anon_sym_LPAREN] = ACTIONS(951),
    [anon_sym_RPAREN] = ACTIONS(951),
    [anon_sym_SEMI] = ACTIONS(951),
    [anon_sym_LBRACK] = ACTIONS(951),
    [sym_comment] = ACTIONS(49),
  },
  [212] = {
    [sym_parameter_list] = STATE(513),
    [anon_sym_LPAREN] = ACTIONS(206),
    [anon_sym_SEMI] = ACTIONS(953),
    [anon_sym_LBRACK] = ACTIONS(955),
    [sym_comment] = ACTIONS(49),
  },
  [213] = {
    [anon_sym_LPAREN] = ACTIONS(957),
    [anon_sym_RPAREN] = ACTIONS(957),
    [anon_sym_SEMI] = ACTIONS(957),
    [anon_sym_LBRACK] = ACTIONS(957),
    [sym_comment] = ACTIONS(49),
  },
  [214] = {
    [anon_sym_LPAREN] = ACTIONS(959),
    [anon_sym_RPAREN] = ACTIONS(959),
    [anon_sym_SEMI] = ACTIONS(959),
    [anon_sym_LBRACK] = ACTIONS(959),
    [sym_comment] = ACTIONS(49),
  },
  [215] = {
    [anon_sym_LPAREN] = ACTIONS(961),
    [anon_sym_RPAREN] = ACTIONS(961),
    [anon_sym_SEMI] = ACTIONS(961),
    [anon_sym_LBRACK] = ACTIONS(961),
    [sym_comment] = ACTIONS(49),
  },
  [216] = {
    [sym_identifier] = ACTIONS(963),
    [sym_comment] = ACTIONS(49),
  },
  [217] = {
    [anon_sym_LPAREN] = ACTIONS(708),
    [anon_sym_LBRACE] = ACTIONS(708),
    [anon_sym_STAR] = ACTIONS(708),
    [anon_sym_COLON] = ACTIONS(710),
    [sym_identifier] = ACTIONS(708),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(708),
  },
  [218] = {
    [sym__type_declarator] = STATE(515),
    [sym_pointer_type_declarator] = STATE(213),
    [sym_function_type_declarator] = STATE(214),
    [sym_array_type_declarator] = STATE(215),
    [anon_sym_LPAREN] = ACTIONS(327),
    [anon_sym_STAR] = ACTIONS(329),
    [sym_identifier] = ACTIONS(331),
    [sym_comment] = ACTIONS(49),
  },
  [219] = {
    [sym_type_qualifier] = STATE(219),
    [aux_sym_type_definition_repeat1] = STATE(219),
    [anon_sym_const] = ACTIONS(965),
    [anon_sym_restrict] = ACTIONS(965),
    [anon_sym_volatile] = ACTIONS(965),
    [anon_sym__Atomic] = ACTIONS(965),
    [anon_sym_mutable] = ACTIONS(965),
    [anon_sym_explicit] = ACTIONS(965),
    [anon_sym_constexpr] = ACTIONS(965),
    [anon_sym_unsigned] = ACTIONS(968),
    [anon_sym_long] = ACTIONS(968),
    [anon_sym_short] = ACTIONS(968),
    [sym_primitive_type] = ACTIONS(968),
    [anon_sym_enum] = ACTIONS(968),
    [anon_sym_struct] = ACTIONS(968),
    [anon_sym_union] = ACTIONS(968),
    [sym_identifier] = ACTIONS(968),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(968),
    [sym_auto] = ACTIONS(968),
    [anon_sym_typename] = ACTIONS(968),
    [anon_sym_COLON_COLON] = ACTIONS(970),
  },
  [220] = {
    [anon_sym_LPAREN] = ACTIONS(808),
    [anon_sym_STAR] = ACTIONS(808),
    [sym_identifier] = ACTIONS(808),
    [sym_comment] = ACTIONS(49),
  },
  [221] = {
    [anon_sym_LPAREN] = ACTIONS(812),
    [anon_sym_STAR] = ACTIONS(812),
    [sym_identifier] = ACTIONS(812),
    [sym_comment] = ACTIONS(49),
  },
  [222] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(222),
    [anon_sym_LPAREN] = ACTIONS(816),
    [anon_sym_STAR] = ACTIONS(816),
    [anon_sym_unsigned] = ACTIONS(972),
    [anon_sym_long] = ACTIONS(972),
    [anon_sym_short] = ACTIONS(972),
    [sym_primitive_type] = ACTIONS(818),
    [sym_identifier] = ACTIONS(818),
    [sym_comment] = ACTIONS(49),
  },
  [223] = {
    [ts_builtin_sym_end] = ACTIONS(975),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(977),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(977),
    [anon_sym_LPAREN] = ACTIONS(975),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(977),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(977),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(977),
    [sym_preproc_directive] = ACTIONS(977),
    [anon_sym_typedef] = ACTIONS(977),
    [anon_sym_extern] = ACTIONS(977),
    [anon_sym_RBRACE] = ACTIONS(975),
    [anon_sym_STAR] = ACTIONS(975),
    [anon_sym_static] = ACTIONS(977),
    [anon_sym_register] = ACTIONS(977),
    [anon_sym_inline] = ACTIONS(977),
    [anon_sym_const] = ACTIONS(977),
    [anon_sym_restrict] = ACTIONS(977),
    [anon_sym_volatile] = ACTIONS(977),
    [anon_sym__Atomic] = ACTIONS(977),
    [anon_sym_mutable] = ACTIONS(977),
    [anon_sym_explicit] = ACTIONS(977),
    [anon_sym_constexpr] = ACTIONS(977),
    [anon_sym_unsigned] = ACTIONS(977),
    [anon_sym_long] = ACTIONS(977),
    [anon_sym_short] = ACTIONS(977),
    [sym_primitive_type] = ACTIONS(977),
    [anon_sym_enum] = ACTIONS(977),
    [anon_sym_struct] = ACTIONS(977),
    [anon_sym_union] = ACTIONS(977),
    [anon_sym_AMP] = ACTIONS(977),
    [anon_sym_AMP_AMP] = ACTIONS(975),
    [anon_sym_TILDE] = ACTIONS(975),
    [sym_identifier] = ACTIONS(977),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(977),
    [sym_auto] = ACTIONS(977),
    [anon_sym_typename] = ACTIONS(977),
    [anon_sym_template] = ACTIONS(977),
    [anon_sym_namespace] = ACTIONS(977),
    [anon_sym_using] = ACTIONS(977),
    [anon_sym_COLON_COLON] = ACTIONS(975),
    [sym_operator_name] = ACTIONS(975),
  },
  [224] = {
    [sym__declarator] = STATE(125),
    [sym_pointer_declarator] = STATE(125),
    [sym_function_declarator] = STATE(125),
    [sym_array_declarator] = STATE(125),
    [sym_init_declarator] = STATE(126),
    [sym_reference_declarator] = STATE(125),
    [sym_template_type] = STATE(46),
    [sym_template_function] = STATE(125),
    [sym_destructor_name] = STATE(125),
    [sym_scoped_identifier] = STATE(33),
    [sym_scoped_type_identifier] = STATE(47),
    [sym_scoped_namespace_identifier] = STATE(46),
    [anon_sym_LPAREN] = ACTIONS(11),
    [anon_sym_STAR] = ACTIONS(196),
    [anon_sym_AMP] = ACTIONS(526),
    [anon_sym_AMP_AMP] = ACTIONS(528),
    [anon_sym_TILDE] = ACTIONS(45),
    [sym_identifier] = ACTIONS(75),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(77),
    [sym_operator_name] = ACTIONS(204),
  },
  [225] = {
    [sym_type_qualifier] = STATE(517),
    [sym_trailing_return_type] = STATE(517),
    [aux_sym_function_declarator_repeat1] = STATE(517),
    [anon_sym_LPAREN] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(610),
    [anon_sym_const] = ACTIONS(612),
    [anon_sym_restrict] = ACTIONS(614),
    [anon_sym_volatile] = ACTIONS(614),
    [anon_sym__Atomic] = ACTIONS(614),
    [anon_sym_mutable] = ACTIONS(614),
    [anon_sym_explicit] = ACTIONS(614),
    [anon_sym_constexpr] = ACTIONS(614),
    [anon_sym_DASH_GT] = ACTIONS(979),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(981),
  },
  [226] = {
    [anon_sym_RBRACE] = ACTIONS(983),
    [sym_comment] = ACTIONS(49),
  },
  [227] = {
    [anon_sym_LPAREN] = ACTIONS(985),
    [anon_sym_COMMA] = ACTIONS(985),
    [anon_sym_RPAREN] = ACTIONS(985),
    [anon_sym_SEMI] = ACTIONS(985),
    [anon_sym_extern] = ACTIONS(987),
    [anon_sym_LBRACE] = ACTIONS(985),
    [anon_sym_STAR] = ACTIONS(985),
    [anon_sym_LBRACK] = ACTIONS(985),
    [anon_sym_static] = ACTIONS(987),
    [anon_sym_register] = ACTIONS(987),
    [anon_sym_inline] = ACTIONS(987),
    [anon_sym_const] = ACTIONS(987),
    [anon_sym_restrict] = ACTIONS(987),
    [anon_sym_volatile] = ACTIONS(987),
    [anon_sym__Atomic] = ACTIONS(987),
    [anon_sym_mutable] = ACTIONS(987),
    [anon_sym_explicit] = ACTIONS(987),
    [anon_sym_constexpr] = ACTIONS(987),
    [anon_sym_COLON] = ACTIONS(987),
    [anon_sym_AMP] = ACTIONS(987),
    [anon_sym_AMP_AMP] = ACTIONS(985),
    [anon_sym_TILDE] = ACTIONS(985),
    [anon_sym_GT] = ACTIONS(985),
    [sym_identifier] = ACTIONS(987),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(985),
    [sym_operator_name] = ACTIONS(985),
  },
  [228] = {
    [anon_sym_COMMA] = ACTIONS(989),
    [anon_sym_RBRACE] = ACTIONS(989),
    [anon_sym_EQ] = ACTIONS(991),
    [sym_comment] = ACTIONS(49),
  },
  [229] = {
    [aux_sym_enumerator_list_repeat1] = STATE(521),
    [anon_sym_COMMA] = ACTIONS(993),
    [anon_sym_RBRACE] = ACTIONS(983),
    [sym_comment] = ACTIONS(49),
  },
  [230] = {
    [anon_sym_LPAREN] = ACTIONS(995),
    [anon_sym_COMMA] = ACTIONS(995),
    [anon_sym_RPAREN] = ACTIONS(995),
    [anon_sym_SEMI] = ACTIONS(995),
    [anon_sym_extern] = ACTIONS(997),
    [anon_sym_LBRACE] = ACTIONS(995),
    [anon_sym_STAR] = ACTIONS(995),
    [anon_sym_LBRACK] = ACTIONS(995),
    [anon_sym_static] = ACTIONS(997),
    [anon_sym_register] = ACTIONS(997),
    [anon_sym_inline] = ACTIONS(997),
    [anon_sym_const] = ACTIONS(997),
    [anon_sym_restrict] = ACTIONS(997),
    [anon_sym_volatile] = ACTIONS(997),
    [anon_sym__Atomic] = ACTIONS(997),
    [anon_sym_mutable] = ACTIONS(997),
    [anon_sym_explicit] = ACTIONS(997),
    [anon_sym_constexpr] = ACTIONS(997),
    [anon_sym_COLON] = ACTIONS(997),
    [anon_sym_AMP] = ACTIONS(997),
    [anon_sym_AMP_AMP] = ACTIONS(995),
    [anon_sym_TILDE] = ACTIONS(995),
    [anon_sym_GT] = ACTIONS(995),
    [sym_identifier] = ACTIONS(997),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(995),
    [sym_operator_name] = ACTIONS(995),
  },
  [231] = {
    [sym_preproc_arg] = ACTIONS(999),
    [sym_comment] = ACTIONS(83),
  },
  [232] = {
    [sym_identifier] = ACTIONS(1001),
    [sym_comment] = ACTIONS(49),
  },
  [233] = {
    [sym_identifier] = ACTIONS(1003),
    [sym_comment] = ACTIONS(49),
  },
  [234] = {
    [sym_type_qualifier] = STATE(526),
    [sym__type_specifier] = STATE(525),
    [sym_sized_type_specifier] = STATE(525),
    [sym_enum_specifier] = STATE(525),
    [sym_struct_specifier] = STATE(525),
    [sym_union_specifier] = STATE(525),
    [sym_macro_type_specifier] = STATE(525),
    [sym_class_specifier] = STATE(525),
    [sym_dependent_type] = STATE(525),
    [sym_template_type] = STATE(62),
    [sym_scoped_type_identifier] = STATE(63),
    [sym_scoped_namespace_identifier] = STATE(64),
    [aux_sym_type_definition_repeat1] = STATE(526),
    [aux_sym_sized_type_specifier_repeat1] = STATE(66),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_restrict] = ACTIONS(93),
    [anon_sym_volatile] = ACTIONS(93),
    [anon_sym__Atomic] = ACTIONS(93),
    [anon_sym_mutable] = ACTIONS(93),
    [anon_sym_explicit] = ACTIONS(93),
    [anon_sym_constexpr] = ACTIONS(93),
    [anon_sym_unsigned] = ACTIONS(95),
    [anon_sym_long] = ACTIONS(95),
    [anon_sym_short] = ACTIONS(95),
    [sym_primitive_type] = ACTIONS(1005),
    [anon_sym_enum] = ACTIONS(99),
    [anon_sym_struct] = ACTIONS(101),
    [anon_sym_union] = ACTIONS(103),
    [sym_identifier] = ACTIONS(105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(107),
    [sym_auto] = ACTIONS(1005),
    [anon_sym_typename] = ACTIONS(109),
    [anon_sym_COLON_COLON] = ACTIONS(111),
  },
  [235] = {
    [anon_sym_LPAREN] = ACTIONS(1007),
    [anon_sym_COMMA] = ACTIONS(1007),
    [anon_sym_RPAREN] = ACTIONS(1007),
    [anon_sym_SEMI] = ACTIONS(1007),
    [anon_sym_extern] = ACTIONS(1009),
    [anon_sym_LBRACE] = ACTIONS(1007),
    [anon_sym_STAR] = ACTIONS(1007),
    [anon_sym_LBRACK] = ACTIONS(1007),
    [anon_sym_static] = ACTIONS(1009),
    [anon_sym_register] = ACTIONS(1009),
    [anon_sym_inline] = ACTIONS(1009),
    [anon_sym_const] = ACTIONS(1009),
    [anon_sym_restrict] = ACTIONS(1009),
    [anon_sym_volatile] = ACTIONS(1009),
    [anon_sym__Atomic] = ACTIONS(1009),
    [anon_sym_mutable] = ACTIONS(1009),
    [anon_sym_explicit] = ACTIONS(1009),
    [anon_sym_constexpr] = ACTIONS(1009),
    [anon_sym_COLON] = ACTIONS(1009),
    [anon_sym_AMP] = ACTIONS(1009),
    [anon_sym_AMP_AMP] = ACTIONS(1007),
    [anon_sym_TILDE] = ACTIONS(1007),
    [anon_sym_GT] = ACTIONS(1007),
    [sym_identifier] = ACTIONS(1009),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(1007),
    [sym_operator_name] = ACTIONS(1007),
  },
  [236] = {
    [sym_field_declaration_list] = STATE(76),
    [sym__class_name] = STATE(527),
    [sym_base_class_clause] = STATE(78),
    [sym_template_type] = STATE(79),
    [sym_scoped_type_identifier] = STATE(80),
    [sym_scoped_namespace_identifier] = STATE(81),
    [anon_sym_LBRACE] = ACTIONS(129),
    [anon_sym_COLON] = ACTIONS(131),
    [sym_identifier] = ACTIONS(133),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(135),
  },
  [237] = {
    [sym_field_declaration_list] = STATE(82),
    [sym__class_name] = STATE(528),
    [sym_base_class_clause] = STATE(84),
    [sym_template_type] = STATE(79),
    [sym_scoped_type_identifier] = STATE(80),
    [sym_scoped_namespace_identifier] = STATE(81),
    [anon_sym_LBRACE] = ACTIONS(129),
    [anon_sym_COLON] = ACTIONS(131),
    [sym_identifier] = ACTIONS(133),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(135),
  },
  [238] = {
    [sym_template_argument_list] = STATE(530),
    [anon_sym_LPAREN] = ACTIONS(139),
    [anon_sym_SEMI] = ACTIONS(142),
    [anon_sym_extern] = ACTIONS(144),
    [anon_sym_STAR] = ACTIONS(142),
    [anon_sym_LBRACK] = ACTIONS(210),
    [anon_sym_static] = ACTIONS(144),
    [anon_sym_register] = ACTIONS(144),
    [anon_sym_inline] = ACTIONS(144),
    [anon_sym_const] = ACTIONS(144),
    [anon_sym_restrict] = ACTIONS(144),
    [anon_sym_volatile] = ACTIONS(144),
    [anon_sym__Atomic] = ACTIONS(144),
    [anon_sym_mutable] = ACTIONS(144),
    [anon_sym_explicit] = ACTIONS(144),
    [anon_sym_constexpr] = ACTIONS(144),
    [anon_sym_COLON] = ACTIONS(144),
    [anon_sym_AMP] = ACTIONS(144),
    [anon_sym_AMP_AMP] = ACTIONS(142),
    [anon_sym_LT] = ACTIONS(146),
    [sym_identifier] = ACTIONS(144),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(1011),
    [sym_operator_name] = ACTIONS(142),
  },
  [239] = {
    [sym_field_declaration_list] = STATE(89),
    [sym__class_name] = STATE(531),
    [sym_base_class_clause] = STATE(91),
    [sym_template_type] = STATE(79),
    [sym_scoped_type_identifier] = STATE(80),
    [sym_scoped_namespace_identifier] = STATE(81),
    [anon_sym_LBRACE] = ACTIONS(129),
    [anon_sym_COLON] = ACTIONS(131),
    [sym_identifier] = ACTIONS(133),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(135),
  },
  [240] = {
    [anon_sym_COLON] = ACTIONS(1013),
    [sym_comment] = ACTIONS(49),
  },
  [241] = {
    [sym__type_specifier] = STATE(93),
    [sym_sized_type_specifier] = STATE(93),
    [sym_enum_specifier] = STATE(93),
    [sym_struct_specifier] = STATE(93),
    [sym_union_specifier] = STATE(93),
    [sym_macro_type_specifier] = STATE(93),
    [sym_class_specifier] = STATE(93),
    [sym_dependent_type] = STATE(93),
    [sym_template_type] = STATE(94),
    [sym_scoped_type_identifier] = STATE(34),
    [sym_scoped_namespace_identifier] = STATE(81),
    [aux_sym_sized_type_specifier_repeat1] = STATE(258),
    [anon_sym_unsigned] = ACTIONS(368),
    [anon_sym_long] = ACTIONS(368),
    [anon_sym_short] = ACTIONS(368),
    [sym_primitive_type] = ACTIONS(150),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(372),
    [anon_sym_union] = ACTIONS(374),
    [sym_identifier] = ACTIONS(152),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(378),
    [sym_auto] = ACTIONS(150),
    [anon_sym_typename] = ACTIONS(382),
    [anon_sym_COLON_COLON] = ACTIONS(135),
  },
  [242] = {
    [sym_template_parameter_list] = STATE(533),
    [anon_sym_LT] = ACTIONS(168),
    [sym_comment] = ACTIONS(49),
  },
  [243] = {
    [sym_function_definition] = STATE(534),
    [sym_declaration] = STATE(534),
    [sym__declaration_specifiers] = STATE(535),
    [sym_storage_class_specifier] = STATE(109),
    [sym_type_qualifier] = STATE(109),
    [sym__type_specifier] = STATE(105),
    [sym_sized_type_specifier] = STATE(105),
    [sym_enum_specifier] = STATE(105),
    [sym_struct_specifier] = STATE(105),
    [sym_union_specifier] = STATE(105),
    [sym_macro_type_specifier] = STATE(105),
    [sym_class_specifier] = STATE(536),
    [sym_dependent_type] = STATE(105),
    [sym_template_type] = STATE(94),
    [sym_scoped_type_identifier] = STATE(34),
    [sym_scoped_namespace_identifier] = STATE(81),
    [aux_sym__declaration_specifiers_repeat1] = STATE(109),
    [aux_sym_sized_type_specifier_repeat1] = STATE(110),
    [anon_sym_extern] = ACTIONS(154),
    [anon_sym_static] = ACTIONS(154),
    [anon_sym_register] = ACTIONS(154),
    [anon_sym_inline] = ACTIONS(154),
    [anon_sym_const] = ACTIONS(158),
    [anon_sym_restrict] = ACTIONS(158),
    [anon_sym_volatile] = ACTIONS(158),
    [anon_sym__Atomic] = ACTIONS(158),
    [anon_sym_mutable] = ACTIONS(158),
    [anon_sym_explicit] = ACTIONS(158),
    [anon_sym_constexpr] = ACTIONS(158),
    [anon_sym_unsigned] = ACTIONS(160),
    [anon_sym_long] = ACTIONS(160),
    [anon_sym_short] = ACTIONS(160),
    [sym_primitive_type] = ACTIONS(162),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_union] = ACTIONS(39),
    [sym_identifier] = ACTIONS(152),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(51),
    [sym_auto] = ACTIONS(162),
    [anon_sym_typename] = ACTIONS(172),
    [anon_sym_COLON_COLON] = ACTIONS(135),
  },
  [244] = {
    [sym_template_type] = STATE(117),
    [sym_scoped_identifier] = STATE(539),
    [sym_scoped_type_identifier] = STATE(47),
    [sym_scoped_namespace_identifier] = STATE(117),
    [sym_identifier] = ACTIONS(1015),
    [sym_comment] = ACTIONS(49),
    [anon_sym_namespace] = ACTIONS(1017),
    [anon_sym_COLON_COLON] = ACTIONS(186),
  },
  [245] = {
    [sym_destructor_name] = STATE(120),
    [anon_sym_TILDE] = ACTIONS(45),
    [sym_identifier] = ACTIONS(1019),
    [sym_comment] = ACTIONS(49),
    [sym_operator_name] = ACTIONS(190),
  },
  [246] = {
    [anon_sym_LPAREN] = ACTIONS(1021),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1023),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(1021),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1021),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1021),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(1021),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(1021),
    [anon_sym_typedef] = ACTIONS(1023),
    [anon_sym_extern] = ACTIONS(1023),
    [anon_sym_RBRACE] = ACTIONS(1021),
    [anon_sym_STAR] = ACTIONS(1021),
    [anon_sym_static] = ACTIONS(1023),
    [anon_sym_register] = ACTIONS(1023),
    [anon_sym_inline] = ACTIONS(1023),
    [anon_sym_const] = ACTIONS(1023),
    [anon_sym_restrict] = ACTIONS(1023),
    [anon_sym_volatile] = ACTIONS(1023),
    [anon_sym__Atomic] = ACTIONS(1023),
    [anon_sym_mutable] = ACTIONS(1023),
    [anon_sym_explicit] = ACTIONS(1023),
    [anon_sym_constexpr] = ACTIONS(1023),
    [anon_sym_unsigned] = ACTIONS(1023),
    [anon_sym_long] = ACTIONS(1023),
    [anon_sym_short] = ACTIONS(1023),
    [sym_primitive_type] = ACTIONS(1023),
    [anon_sym_enum] = ACTIONS(1023),
    [anon_sym_struct] = ACTIONS(1023),
    [anon_sym_union] = ACTIONS(1023),
    [anon_sym_AMP] = ACTIONS(1023),
    [anon_sym_AMP_AMP] = ACTIONS(1021),
    [anon_sym_TILDE] = ACTIONS(1021),
    [sym_identifier] = ACTIONS(1023),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(1023),
    [anon_sym_public] = ACTIONS(1023),
    [sym_auto] = ACTIONS(1023),
    [anon_sym_typename] = ACTIONS(1023),
    [anon_sym_template] = ACTIONS(1023),
    [anon_sym_friend] = ACTIONS(1023),
    [anon_sym_private] = ACTIONS(1023),
    [anon_sym_protected] = ACTIONS(1023),
    [anon_sym_using] = ACTIONS(1023),
    [anon_sym_COLON_COLON] = ACTIONS(1021),
    [sym_operator_name] = ACTIONS(1021),
  },
  [247] = {
    [anon_sym_LPAREN] = ACTIONS(1025),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1027),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(1025),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1025),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1025),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(1025),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(1025),
    [anon_sym_typedef] = ACTIONS(1027),
    [anon_sym_extern] = ACTIONS(1027),
    [anon_sym_RBRACE] = ACTIONS(1025),
    [anon_sym_STAR] = ACTIONS(1025),
    [anon_sym_static] = ACTIONS(1027),
    [anon_sym_register] = ACTIONS(1027),
    [anon_sym_inline] = ACTIONS(1027),
    [anon_sym_const] = ACTIONS(1027),
    [anon_sym_restrict] = ACTIONS(1027),
    [anon_sym_volatile] = ACTIONS(1027),
    [anon_sym__Atomic] = ACTIONS(1027),
    [anon_sym_mutable] = ACTIONS(1027),
    [anon_sym_explicit] = ACTIONS(1027),
    [anon_sym_constexpr] = ACTIONS(1027),
    [anon_sym_unsigned] = ACTIONS(1027),
    [anon_sym_long] = ACTIONS(1027),
    [anon_sym_short] = ACTIONS(1027),
    [sym_primitive_type] = ACTIONS(1027),
    [anon_sym_enum] = ACTIONS(1027),
    [anon_sym_struct] = ACTIONS(1027),
    [anon_sym_union] = ACTIONS(1027),
    [anon_sym_AMP] = ACTIONS(1027),
    [anon_sym_AMP_AMP] = ACTIONS(1025),
    [anon_sym_TILDE] = ACTIONS(1025),
    [sym_identifier] = ACTIONS(1027),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(1027),
    [anon_sym_public] = ACTIONS(1027),
    [sym_auto] = ACTIONS(1027),
    [anon_sym_typename] = ACTIONS(1027),
    [anon_sym_template] = ACTIONS(1027),
    [anon_sym_friend] = ACTIONS(1027),
    [anon_sym_private] = ACTIONS(1027),
    [anon_sym_protected] = ACTIONS(1027),
    [anon_sym_using] = ACTIONS(1027),
    [anon_sym_COLON_COLON] = ACTIONS(1025),
    [sym_operator_name] = ACTIONS(1025),
  },
  [248] = {
    [sym__field_declarator] = STATE(548),
    [sym_pointer_field_declarator] = STATE(549),
    [sym_function_field_declarator] = STATE(550),
    [sym_array_field_declarator] = STATE(551),
    [sym_reference_field_declarator] = STATE(552),
    [sym_template_type] = STATE(553),
    [sym_template_method] = STATE(548),
    [sym_scoped_field_identifier] = STATE(554),
    [sym_scoped_type_identifier] = STATE(47),
    [sym_scoped_namespace_identifier] = STATE(553),
    [anon_sym_LPAREN] = ACTIONS(1029),
    [anon_sym_SEMI] = ACTIONS(1031),
    [anon_sym_STAR] = ACTIONS(1033),
    [anon_sym_COLON] = ACTIONS(1035),
    [anon_sym_AMP] = ACTIONS(1037),
    [anon_sym_AMP_AMP] = ACTIONS(1039),
    [sym_identifier] = ACTIONS(1041),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(1043),
    [sym_operator_name] = ACTIONS(1045),
  },
  [249] = {
    [sym_parameter_list] = STATE(555),
    [anon_sym_LPAREN] = ACTIONS(206),
    [anon_sym_LBRACK] = ACTIONS(208),
    [sym_comment] = ACTIONS(49),
  },
  [250] = {
    [sym_compound_statement] = STATE(558),
    [sym_field_initializer_list] = STATE(559),
    [anon_sym_LPAREN] = ACTIONS(210),
    [anon_sym_SEMI] = ACTIONS(1047),
    [anon_sym_LBRACE] = ACTIONS(1049),
    [anon_sym_LBRACK] = ACTIONS(210),
    [anon_sym_COLON] = ACTIONS(214),
    [sym_comment] = ACTIONS(49),
  },
  [251] = {
    [sym_storage_class_specifier] = STATE(560),
    [sym_type_qualifier] = STATE(560),
    [aux_sym__declaration_specifiers_repeat1] = STATE(560),
    [anon_sym_LPAREN] = ACTIONS(216),
    [anon_sym_SEMI] = ACTIONS(216),
    [anon_sym_extern] = ACTIONS(218),
    [anon_sym_STAR] = ACTIONS(216),
    [anon_sym_static] = ACTIONS(218),
    [anon_sym_register] = ACTIONS(218),
    [anon_sym_inline] = ACTIONS(218),
    [anon_sym_const] = ACTIONS(220),
    [anon_sym_restrict] = ACTIONS(220),
    [anon_sym_volatile] = ACTIONS(220),
    [anon_sym__Atomic] = ACTIONS(220),
    [anon_sym_mutable] = ACTIONS(220),
    [anon_sym_explicit] = ACTIONS(220),
    [anon_sym_constexpr] = ACTIONS(220),
    [anon_sym_COLON] = ACTIONS(222),
    [anon_sym_AMP] = ACTIONS(222),
    [anon_sym_AMP_AMP] = ACTIONS(216),
    [sym_identifier] = ACTIONS(222),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(216),
    [sym_operator_name] = ACTIONS(216),
  },
  [252] = {
    [anon_sym_LPAREN] = ACTIONS(1051),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1053),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(1051),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1051),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1051),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(1051),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(1051),
    [anon_sym_typedef] = ACTIONS(1053),
    [anon_sym_extern] = ACTIONS(1053),
    [anon_sym_RBRACE] = ACTIONS(1051),
    [anon_sym_STAR] = ACTIONS(1051),
    [anon_sym_static] = ACTIONS(1053),
    [anon_sym_register] = ACTIONS(1053),
    [anon_sym_inline] = ACTIONS(1053),
    [anon_sym_const] = ACTIONS(1053),
    [anon_sym_restrict] = ACTIONS(1053),
    [anon_sym_volatile] = ACTIONS(1053),
    [anon_sym__Atomic] = ACTIONS(1053),
    [anon_sym_mutable] = ACTIONS(1053),
    [anon_sym_explicit] = ACTIONS(1053),
    [anon_sym_constexpr] = ACTIONS(1053),
    [anon_sym_unsigned] = ACTIONS(1053),
    [anon_sym_long] = ACTIONS(1053),
    [anon_sym_short] = ACTIONS(1053),
    [sym_primitive_type] = ACTIONS(1053),
    [anon_sym_enum] = ACTIONS(1053),
    [anon_sym_struct] = ACTIONS(1053),
    [anon_sym_union] = ACTIONS(1053),
    [anon_sym_AMP] = ACTIONS(1053),
    [anon_sym_AMP_AMP] = ACTIONS(1051),
    [anon_sym_TILDE] = ACTIONS(1051),
    [sym_identifier] = ACTIONS(1053),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(1053),
    [anon_sym_public] = ACTIONS(1053),
    [sym_auto] = ACTIONS(1053),
    [anon_sym_typename] = ACTIONS(1053),
    [anon_sym_template] = ACTIONS(1053),
    [anon_sym_friend] = ACTIONS(1053),
    [anon_sym_private] = ACTIONS(1053),
    [anon_sym_protected] = ACTIONS(1053),
    [anon_sym_using] = ACTIONS(1053),
    [anon_sym_COLON_COLON] = ACTIONS(1051),
    [sym_operator_name] = ACTIONS(1051),
  },
  [253] = {
    [anon_sym_LPAREN] = ACTIONS(1055),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1057),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(1055),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1055),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1055),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(1055),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(1055),
    [anon_sym_typedef] = ACTIONS(1057),
    [anon_sym_extern] = ACTIONS(1057),
    [anon_sym_RBRACE] = ACTIONS(1055),
    [anon_sym_STAR] = ACTIONS(1055),
    [anon_sym_static] = ACTIONS(1057),
    [anon_sym_register] = ACTIONS(1057),
    [anon_sym_inline] = ACTIONS(1057),
    [anon_sym_const] = ACTIONS(1057),
    [anon_sym_restrict] = ACTIONS(1057),
    [anon_sym_volatile] = ACTIONS(1057),
    [anon_sym__Atomic] = ACTIONS(1057),
    [anon_sym_mutable] = ACTIONS(1057),
    [anon_sym_explicit] = ACTIONS(1057),
    [anon_sym_constexpr] = ACTIONS(1057),
    [anon_sym_unsigned] = ACTIONS(1057),
    [anon_sym_long] = ACTIONS(1057),
    [anon_sym_short] = ACTIONS(1057),
    [sym_primitive_type] = ACTIONS(1057),
    [anon_sym_enum] = ACTIONS(1057),
    [anon_sym_struct] = ACTIONS(1057),
    [anon_sym_union] = ACTIONS(1057),
    [anon_sym_AMP] = ACTIONS(1057),
    [anon_sym_AMP_AMP] = ACTIONS(1055),
    [anon_sym_TILDE] = ACTIONS(1055),
    [sym_identifier] = ACTIONS(1057),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(1057),
    [anon_sym_public] = ACTIONS(1057),
    [sym_auto] = ACTIONS(1057),
    [anon_sym_typename] = ACTIONS(1057),
    [anon_sym_template] = ACTIONS(1057),
    [anon_sym_friend] = ACTIONS(1057),
    [anon_sym_private] = ACTIONS(1057),
    [anon_sym_protected] = ACTIONS(1057),
    [anon_sym_using] = ACTIONS(1057),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [sym_operator_name] = ACTIONS(1055),
  },
  [254] = {
    [anon_sym_LPAREN] = ACTIONS(228),
    [anon_sym_SEMI] = ACTIONS(228),
    [anon_sym_extern] = ACTIONS(230),
    [anon_sym_STAR] = ACTIONS(228),
    [anon_sym_static] = ACTIONS(230),
    [anon_sym_register] = ACTIONS(230),
    [anon_sym_inline] = ACTIONS(230),
    [anon_sym_const] = ACTIONS(230),
    [anon_sym_restrict] = ACTIONS(230),
    [anon_sym_volatile] = ACTIONS(230),
    [anon_sym__Atomic] = ACTIONS(230),
    [anon_sym_mutable] = ACTIONS(230),
    [anon_sym_explicit] = ACTIONS(230),
    [anon_sym_constexpr] = ACTIONS(230),
    [anon_sym_COLON] = ACTIONS(230),
    [anon_sym_AMP] = ACTIONS(230),
    [anon_sym_AMP_AMP] = ACTIONS(228),
    [sym_identifier] = ACTIONS(230),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(1059),
    [sym_operator_name] = ACTIONS(228),
  },
  [255] = {
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(1059),
  },
  [256] = {
    [sym_preproc_if_in_field_declaration_list] = STATE(246),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(247),
    [sym_type_definition] = STATE(563),
    [sym__declaration_specifiers] = STATE(248),
    [sym__declarator] = STATE(249),
    [sym_pointer_declarator] = STATE(249),
    [sym_function_declarator] = STATE(250),
    [sym_array_declarator] = STATE(249),
    [sym_storage_class_specifier] = STATE(257),
    [sym_type_qualifier] = STATE(257),
    [sym__type_specifier] = STATE(251),
    [sym_sized_type_specifier] = STATE(251),
    [sym_enum_specifier] = STATE(251),
    [sym_struct_specifier] = STATE(251),
    [sym_union_specifier] = STATE(251),
    [sym__field_declaration_list_item] = STATE(563),
    [sym_field_declaration] = STATE(563),
    [sym_macro_type_specifier] = STATE(251),
    [sym_class_specifier] = STATE(251),
    [sym_dependent_type] = STATE(251),
    [sym_template_declaration] = STATE(563),
    [sym_inline_method_definition] = STATE(252),
    [sym_constructor_or_destructor_definition] = STATE(252),
    [sym_constructor_or_destructor_declaration] = STATE(253),
    [sym_friend_declaration] = STATE(563),
    [sym_access_specifier] = STATE(563),
    [sym_reference_declarator] = STATE(249),
    [sym_template_type] = STATE(254),
    [sym_template_function] = STATE(249),
    [sym_using_declaration] = STATE(563),
    [sym_alias_declaration] = STATE(563),
    [sym_destructor_name] = STATE(249),
    [sym_scoped_identifier] = STATE(33),
    [sym_scoped_type_identifier] = STATE(34),
    [sym_scoped_namespace_identifier] = STATE(255),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(563),
    [aux_sym__declaration_specifiers_repeat1] = STATE(257),
    [aux_sym_sized_type_specifier_repeat1] = STATE(258),
    [anon_sym_LPAREN] = ACTIONS(11),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(358),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(360),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(362),
    [anon_sym_typedef] = ACTIONS(364),
    [anon_sym_extern] = ACTIONS(27),
    [anon_sym_RBRACE] = ACTIONS(1061),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_static] = ACTIONS(27),
    [anon_sym_register] = ACTIONS(27),
    [anon_sym_inline] = ACTIONS(27),
    [anon_sym_const] = ACTIONS(29),
    [anon_sym_restrict] = ACTIONS(29),
    [anon_sym_volatile] = ACTIONS(29),
    [anon_sym__Atomic] = ACTIONS(29),
    [anon_sym_mutable] = ACTIONS(29),
    [anon_sym_explicit] = ACTIONS(29),
    [anon_sym_constexpr] = ACTIONS(29),
    [anon_sym_unsigned] = ACTIONS(368),
    [anon_sym_long] = ACTIONS(368),
    [anon_sym_short] = ACTIONS(368),
    [sym_primitive_type] = ACTIONS(370),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(372),
    [anon_sym_union] = ACTIONS(374),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(45),
    [sym_identifier] = ACTIONS(376),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(378),
    [anon_sym_public] = ACTIONS(380),
    [sym_auto] = ACTIONS(370),
    [anon_sym_typename] = ACTIONS(382),
    [anon_sym_template] = ACTIONS(384),
    [anon_sym_friend] = ACTIONS(386),
    [anon_sym_private] = ACTIONS(380),
    [anon_sym_protected] = ACTIONS(380),
    [anon_sym_using] = ACTIONS(388),
    [anon_sym_COLON_COLON] = ACTIONS(390),
    [sym_operator_name] = ACTIONS(392),
  },
  [257] = {
    [sym__declarator] = STATE(28),
    [sym_pointer_declarator] = STATE(28),
    [sym_function_declarator] = STATE(564),
    [sym_array_declarator] = STATE(28),
    [sym_storage_class_specifier] = STATE(145),
    [sym_type_qualifier] = STATE(145),
    [sym__type_specifier] = STATE(565),
    [sym_sized_type_specifier] = STATE(565),
    [sym_enum_specifier] = STATE(565),
    [sym_struct_specifier] = STATE(565),
    [sym_union_specifier] = STATE(565),
    [sym_macro_type_specifier] = STATE(565),
    [sym_class_specifier] = STATE(565),
    [sym_dependent_type] = STATE(565),
    [sym_reference_declarator] = STATE(28),
    [sym_template_type] = STATE(254),
    [sym_template_function] = STATE(28),
    [sym_destructor_name] = STATE(28),
    [sym_scoped_identifier] = STATE(33),
    [sym_scoped_type_identifier] = STATE(34),
    [sym_scoped_namespace_identifier] = STATE(255),
    [aux_sym__declaration_specifiers_repeat1] = STATE(145),
    [aux_sym_sized_type_specifier_repeat1] = STATE(258),
    [anon_sym_LPAREN] = ACTIONS(11),
    [anon_sym_extern] = ACTIONS(27),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_static] = ACTIONS(27),
    [anon_sym_register] = ACTIONS(27),
    [anon_sym_inline] = ACTIONS(27),
    [anon_sym_const] = ACTIONS(29),
    [anon_sym_restrict] = ACTIONS(29),
    [anon_sym_volatile] = ACTIONS(29),
    [anon_sym__Atomic] = ACTIONS(29),
    [anon_sym_mutable] = ACTIONS(29),
    [anon_sym_explicit] = ACTIONS(29),
    [anon_sym_constexpr] = ACTIONS(29),
    [anon_sym_unsigned] = ACTIONS(368),
    [anon_sym_long] = ACTIONS(368),
    [anon_sym_short] = ACTIONS(368),
    [sym_primitive_type] = ACTIONS(1063),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(372),
    [anon_sym_union] = ACTIONS(374),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(45),
    [sym_identifier] = ACTIONS(376),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(378),
    [sym_auto] = ACTIONS(1063),
    [anon_sym_typename] = ACTIONS(382),
    [anon_sym_COLON_COLON] = ACTIONS(390),
    [sym_operator_name] = ACTIONS(63),
  },
  [258] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(566),
    [anon_sym_LPAREN] = ACTIONS(238),
    [anon_sym_SEMI] = ACTIONS(238),
    [anon_sym_extern] = ACTIONS(240),
    [anon_sym_STAR] = ACTIONS(238),
    [anon_sym_static] = ACTIONS(240),
    [anon_sym_register] = ACTIONS(240),
    [anon_sym_inline] = ACTIONS(240),
    [anon_sym_const] = ACTIONS(240),
    [anon_sym_restrict] = ACTIONS(240),
    [anon_sym_volatile] = ACTIONS(240),
    [anon_sym__Atomic] = ACTIONS(240),
    [anon_sym_mutable] = ACTIONS(240),
    [anon_sym_explicit] = ACTIONS(240),
    [anon_sym_constexpr] = ACTIONS(240),
    [anon_sym_unsigned] = ACTIONS(1065),
    [anon_sym_long] = ACTIONS(1065),
    [anon_sym_short] = ACTIONS(1065),
    [sym_primitive_type] = ACTIONS(244),
    [anon_sym_COLON] = ACTIONS(240),
    [anon_sym_AMP] = ACTIONS(240),
    [anon_sym_AMP_AMP] = ACTIONS(238),
    [sym_identifier] = ACTIONS(246),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(238),
    [sym_operator_name] = ACTIONS(238),
  },
  [259] = {
    [sym_template_argument_list] = STATE(203),
    [anon_sym_LPAREN] = ACTIONS(398),
    [anon_sym_COMMA] = ACTIONS(398),
    [anon_sym_RPAREN] = ACTIONS(398),
    [anon_sym_SEMI] = ACTIONS(398),
    [anon_sym_LBRACE] = ACTIONS(398),
    [anon_sym_STAR] = ACTIONS(398),
    [anon_sym_LBRACK] = ACTIONS(398),
    [anon_sym_COLON] = ACTIONS(400),
    [anon_sym_AMP] = ACTIONS(400),
    [anon_sym_AMP_AMP] = ACTIONS(398),
    [anon_sym_LT] = ACTIONS(146),
    [anon_sym_GT] = ACTIONS(398),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(321),
  },
  [260] = {
    [sym__class_name] = STATE(567),
    [sym_template_type] = STATE(196),
    [sym_scoped_type_identifier] = STATE(80),
    [sym_scoped_namespace_identifier] = STATE(64),
    [sym_identifier] = ACTIONS(1067),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(111),
  },
  [261] = {
    [aux_sym_base_class_clause_repeat1] = STATE(569),
    [anon_sym_COMMA] = ACTIONS(1069),
    [anon_sym_LBRACE] = ACTIONS(1071),
    [sym_comment] = ACTIONS(49),
  },
  [262] = {
    [sym_identifier] = ACTIONS(1073),
    [sym_comment] = ACTIONS(49),
  },
  [263] = {
    [anon_sym_LPAREN] = ACTIONS(447),
    [anon_sym_COMMA] = ACTIONS(447),
    [anon_sym_RPAREN] = ACTIONS(447),
    [anon_sym_SEMI] = ACTIONS(447),
    [anon_sym_extern] = ACTIONS(449),
    [anon_sym_LBRACE] = ACTIONS(447),
    [anon_sym_STAR] = ACTIONS(447),
    [anon_sym_LBRACK] = ACTIONS(447),
    [anon_sym_static] = ACTIONS(449),
    [anon_sym_register] = ACTIONS(449),
    [anon_sym_inline] = ACTIONS(449),
    [anon_sym_const] = ACTIONS(449),
    [anon_sym_restrict] = ACTIONS(449),
    [anon_sym_volatile] = ACTIONS(449),
    [anon_sym__Atomic] = ACTIONS(449),
    [anon_sym_mutable] = ACTIONS(449),
    [anon_sym_explicit] = ACTIONS(449),
    [anon_sym_constexpr] = ACTIONS(449),
    [anon_sym_COLON] = ACTIONS(449),
    [anon_sym_AMP] = ACTIONS(449),
    [anon_sym_AMP_AMP] = ACTIONS(447),
    [anon_sym_TILDE] = ACTIONS(447),
    [anon_sym_GT] = ACTIONS(447),
    [sym_identifier] = ACTIONS(449),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(447),
    [sym_operator_name] = ACTIONS(447),
  },
  [264] = {
    [anon_sym_LPAREN] = ACTIONS(512),
    [anon_sym_COMMA] = ACTIONS(512),
    [anon_sym_RPAREN] = ACTIONS(512),
    [anon_sym_SEMI] = ACTIONS(512),
    [anon_sym_extern] = ACTIONS(514),
    [anon_sym_LBRACE] = ACTIONS(512),
    [anon_sym_STAR] = ACTIONS(512),
    [anon_sym_LBRACK] = ACTIONS(512),
    [anon_sym_static] = ACTIONS(514),
    [anon_sym_register] = ACTIONS(514),
    [anon_sym_inline] = ACTIONS(514),
    [anon_sym_const] = ACTIONS(514),
    [anon_sym_restrict] = ACTIONS(514),
    [anon_sym_volatile] = ACTIONS(514),
    [anon_sym__Atomic] = ACTIONS(514),
    [anon_sym_mutable] = ACTIONS(514),
    [anon_sym_explicit] = ACTIONS(514),
    [anon_sym_constexpr] = ACTIONS(514),
    [anon_sym_COLON] = ACTIONS(514),
    [anon_sym_AMP] = ACTIONS(514),
    [anon_sym_AMP_AMP] = ACTIONS(512),
    [anon_sym_TILDE] = ACTIONS(512),
    [anon_sym_LT] = ACTIONS(512),
    [anon_sym_GT] = ACTIONS(512),
    [sym_identifier] = ACTIONS(514),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(516),
    [sym_operator_name] = ACTIONS(512),
  },
  [265] = {
    [anon_sym_LPAREN] = ACTIONS(1075),
    [anon_sym_COMMA] = ACTIONS(1075),
    [anon_sym_RPAREN] = ACTIONS(1075),
    [anon_sym_SEMI] = ACTIONS(1075),
    [anon_sym_extern] = ACTIONS(1077),
    [anon_sym_LBRACE] = ACTIONS(1075),
    [anon_sym_STAR] = ACTIONS(1075),
    [anon_sym_LBRACK] = ACTIONS(1075),
    [anon_sym_static] = ACTIONS(1077),
    [anon_sym_register] = ACTIONS(1077),
    [anon_sym_inline] = ACTIONS(1077),
    [anon_sym_const] = ACTIONS(1077),
    [anon_sym_restrict] = ACTIONS(1077),
    [anon_sym_volatile] = ACTIONS(1077),
    [anon_sym__Atomic] = ACTIONS(1077),
    [anon_sym_mutable] = ACTIONS(1077),
    [anon_sym_explicit] = ACTIONS(1077),
    [anon_sym_constexpr] = ACTIONS(1077),
    [anon_sym_COLON] = ACTIONS(1077),
    [anon_sym_AMP] = ACTIONS(1077),
    [anon_sym_AMP_AMP] = ACTIONS(1075),
    [anon_sym_TILDE] = ACTIONS(1075),
    [anon_sym_GT] = ACTIONS(1075),
    [sym_identifier] = ACTIONS(1077),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(1075),
    [sym_operator_name] = ACTIONS(1075),
  },
  [266] = {
    [sym_field_declaration_list] = STATE(571),
    [anon_sym_LBRACE] = ACTIONS(129),
    [sym_comment] = ACTIONS(49),
  },
  [267] = {
    [sym_identifier] = ACTIONS(1079),
    [sym_comment] = ACTIONS(49),
  },
  [268] = {
    [anon_sym_LPAREN] = ACTIONS(1081),
    [anon_sym_COMMA] = ACTIONS(1081),
    [anon_sym_RPAREN] = ACTIONS(1081),
    [anon_sym_SEMI] = ACTIONS(1081),
    [anon_sym_extern] = ACTIONS(1083),
    [anon_sym_LBRACE] = ACTIONS(1081),
    [anon_sym_STAR] = ACTIONS(1081),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_static] = ACTIONS(1083),
    [anon_sym_register] = ACTIONS(1083),
    [anon_sym_inline] = ACTIONS(1083),
    [anon_sym_const] = ACTIONS(1083),
    [anon_sym_restrict] = ACTIONS(1083),
    [anon_sym_volatile] = ACTIONS(1083),
    [anon_sym__Atomic] = ACTIONS(1083),
    [anon_sym_mutable] = ACTIONS(1083),
    [anon_sym_explicit] = ACTIONS(1083),
    [anon_sym_constexpr] = ACTIONS(1083),
    [anon_sym_COLON] = ACTIONS(1083),
    [anon_sym_AMP] = ACTIONS(1083),
    [anon_sym_AMP_AMP] = ACTIONS(1081),
    [anon_sym_TILDE] = ACTIONS(1081),
    [anon_sym_GT] = ACTIONS(1081),
    [sym_identifier] = ACTIONS(1083),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(1081),
    [sym_operator_name] = ACTIONS(1081),
  },
  [269] = {
    [sym_field_declaration_list] = STATE(573),
    [anon_sym_LBRACE] = ACTIONS(129),
    [sym_comment] = ACTIONS(49),
  },
  [270] = {
    [sym__expression] = STATE(584),
    [sym_comma_expression] = STATE(585),
    [sym_conditional_expression] = STATE(584),
    [sym_assignment_expression] = STATE(584),
    [sym_pointer_expression] = STATE(584),
    [sym_logical_expression] = STATE(584),
    [sym_bitwise_expression] = STATE(584),
    [sym_equality_expression] = STATE(584),
    [sym_relational_expression] = STATE(584),
    [sym_shift_expression] = STATE(584),
    [sym_math_expression] = STATE(584),
    [sym_cast_expression] = STATE(584),
    [sym_sizeof_expression] = STATE(584),
    [sym_subscript_expression] = STATE(584),
    [sym_call_expression] = STATE(584),
    [sym_field_expression] = STATE(584),
    [sym_compound_literal_expression] = STATE(584),
    [sym_parenthesized_expression] = STATE(584),
    [sym_concatenated_string] = STATE(584),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(584),
    [sym_new_expression] = STATE(584),
    [sym_delete_expression] = STATE(584),
    [sym_lambda_expression] = STATE(584),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(1085),
    [anon_sym_LPAREN] = ACTIONS(1087),
    [anon_sym_STAR] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_AMP] = ACTIONS(1089),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1093),
    [anon_sym_PLUS] = ACTIONS(1095),
    [anon_sym_DASH] = ACTIONS(1095),
    [anon_sym_DASH_DASH] = ACTIONS(1097),
    [anon_sym_PLUS_PLUS] = ACTIONS(1097),
    [anon_sym_sizeof] = ACTIONS(1099),
    [sym_number_literal] = ACTIONS(1085),
    [sym_char_literal] = ACTIONS(1085),
    [sym_string_literal] = ACTIONS(1101),
    [sym_true] = ACTIONS(1103),
    [sym_false] = ACTIONS(1103),
    [sym_null] = ACTIONS(1103),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_delete] = ACTIONS(1109),
    [sym_nullptr] = ACTIONS(1103),
  },
  [271] = {
    [sym_field_declaration_list] = STATE(76),
    [sym__class_name] = STATE(589),
    [sym_base_class_clause] = STATE(78),
    [sym_template_type] = STATE(196),
    [sym_scoped_type_identifier] = STATE(590),
    [sym_scoped_namespace_identifier] = STATE(64),
    [anon_sym_LBRACE] = ACTIONS(129),
    [anon_sym_COLON] = ACTIONS(131),
    [sym_identifier] = ACTIONS(1067),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(111),
  },
  [272] = {
    [sym_field_declaration_list] = STATE(82),
    [sym__class_name] = STATE(591),
    [sym_base_class_clause] = STATE(84),
    [sym_template_type] = STATE(196),
    [sym_scoped_type_identifier] = STATE(590),
    [sym_scoped_namespace_identifier] = STATE(64),
    [anon_sym_LBRACE] = ACTIONS(129),
    [anon_sym_COLON] = ACTIONS(131),
    [sym_identifier] = ACTIONS(1067),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(111),
  },
  [273] = {
    [anon_sym_LPAREN] = ACTIONS(1111),
    [anon_sym_COMMA] = ACTIONS(1111),
    [anon_sym_RPAREN] = ACTIONS(1111),
    [anon_sym_SEMI] = ACTIONS(1111),
    [anon_sym_extern] = ACTIONS(1113),
    [anon_sym_LBRACE] = ACTIONS(1111),
    [anon_sym_STAR] = ACTIONS(1111),
    [anon_sym_LBRACK] = ACTIONS(1111),
    [anon_sym_EQ] = ACTIONS(1111),
    [anon_sym_static] = ACTIONS(1113),
    [anon_sym_register] = ACTIONS(1113),
    [anon_sym_inline] = ACTIONS(1113),
    [anon_sym_const] = ACTIONS(1113),
    [anon_sym_restrict] = ACTIONS(1113),
    [anon_sym_volatile] = ACTIONS(1113),
    [anon_sym__Atomic] = ACTIONS(1113),
    [anon_sym_mutable] = ACTIONS(1113),
    [anon_sym_explicit] = ACTIONS(1113),
    [anon_sym_constexpr] = ACTIONS(1113),
    [anon_sym_COLON] = ACTIONS(1113),
    [anon_sym_AMP] = ACTIONS(1113),
    [anon_sym_AMP_AMP] = ACTIONS(1111),
    [anon_sym_TILDE] = ACTIONS(1111),
    [anon_sym_GT] = ACTIONS(1111),
    [sym_identifier] = ACTIONS(1113),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(1111),
    [sym_operator_name] = ACTIONS(1111),
  },
  [274] = {
    [sym_template_argument_list] = STATE(203),
    [anon_sym_LPAREN] = ACTIONS(142),
    [anon_sym_COMMA] = ACTIONS(142),
    [anon_sym_RPAREN] = ACTIONS(142),
    [anon_sym_SEMI] = ACTIONS(142),
    [anon_sym_LBRACE] = ACTIONS(142),
    [anon_sym_STAR] = ACTIONS(142),
    [anon_sym_LBRACK] = ACTIONS(142),
    [anon_sym_AMP] = ACTIONS(144),
    [anon_sym_AMP_AMP] = ACTIONS(142),
    [anon_sym_LT] = ACTIONS(146),
    [anon_sym_GT] = ACTIONS(142),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(321),
  },
  [275] = {
    [sym_field_declaration_list] = STATE(89),
    [sym__class_name] = STATE(592),
    [sym_base_class_clause] = STATE(91),
    [sym_template_type] = STATE(196),
    [sym_scoped_type_identifier] = STATE(590),
    [sym_scoped_namespace_identifier] = STATE(64),
    [anon_sym_LBRACE] = ACTIONS(129),
    [anon_sym_COLON] = ACTIONS(131),
    [sym_identifier] = ACTIONS(1067),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(111),
  },
  [276] = {
    [sym__type_specifier] = STATE(93),
    [sym_sized_type_specifier] = STATE(93),
    [sym_enum_specifier] = STATE(93),
    [sym_struct_specifier] = STATE(93),
    [sym_union_specifier] = STATE(93),
    [sym_macro_type_specifier] = STATE(93),
    [sym_class_specifier] = STATE(93),
    [sym_dependent_type] = STATE(93),
    [sym_template_type] = STATE(62),
    [sym_scoped_type_identifier] = STATE(34),
    [sym_scoped_namespace_identifier] = STATE(64),
    [aux_sym_sized_type_specifier_repeat1] = STATE(280),
    [anon_sym_unsigned] = ACTIONS(424),
    [anon_sym_long] = ACTIONS(424),
    [anon_sym_short] = ACTIONS(424),
    [sym_primitive_type] = ACTIONS(150),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(428),
    [anon_sym_union] = ACTIONS(430),
    [sym_identifier] = ACTIONS(434),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(436),
    [sym_auto] = ACTIONS(150),
    [anon_sym_typename] = ACTIONS(438),
    [anon_sym_COLON_COLON] = ACTIONS(111),
  },
  [277] = {
    [sym__abstract_declarator] = STATE(597),
    [sym_abstract_pointer_declarator] = STATE(597),
    [sym_abstract_function_declarator] = STATE(597),
    [sym_abstract_array_declarator] = STATE(597),
    [sym_parameter_list] = STATE(598),
    [sym_abstract_reference_declarator] = STATE(597),
    [anon_sym_LPAREN] = ACTIONS(1115),
    [anon_sym_COMMA] = ACTIONS(1117),
    [anon_sym_STAR] = ACTIONS(1119),
    [anon_sym_LBRACK] = ACTIONS(1121),
    [anon_sym_AMP] = ACTIONS(1123),
    [anon_sym_AMP_AMP] = ACTIONS(1125),
    [anon_sym_GT] = ACTIONS(1117),
    [sym_comment] = ACTIONS(49),
  },
  [278] = {
    [aux_sym_template_argument_list_repeat1] = STATE(601),
    [anon_sym_COMMA] = ACTIONS(1127),
    [anon_sym_GT] = ACTIONS(1129),
    [sym_comment] = ACTIONS(49),
  },
  [279] = {
    [sym_type_qualifier] = STATE(219),
    [sym__type_specifier] = STATE(602),
    [sym_sized_type_specifier] = STATE(602),
    [sym_enum_specifier] = STATE(602),
    [sym_struct_specifier] = STATE(602),
    [sym_union_specifier] = STATE(602),
    [sym_macro_type_specifier] = STATE(602),
    [sym_class_specifier] = STATE(602),
    [sym_dependent_type] = STATE(602),
    [sym_template_type] = STATE(62),
    [sym_scoped_type_identifier] = STATE(34),
    [sym_scoped_namespace_identifier] = STATE(64),
    [aux_sym_type_definition_repeat1] = STATE(219),
    [aux_sym_sized_type_specifier_repeat1] = STATE(280),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_restrict] = ACTIONS(93),
    [anon_sym_volatile] = ACTIONS(93),
    [anon_sym__Atomic] = ACTIONS(93),
    [anon_sym_mutable] = ACTIONS(93),
    [anon_sym_explicit] = ACTIONS(93),
    [anon_sym_constexpr] = ACTIONS(93),
    [anon_sym_unsigned] = ACTIONS(424),
    [anon_sym_long] = ACTIONS(424),
    [anon_sym_short] = ACTIONS(424),
    [sym_primitive_type] = ACTIONS(1131),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(428),
    [anon_sym_union] = ACTIONS(430),
    [sym_identifier] = ACTIONS(434),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(436),
    [sym_auto] = ACTIONS(1131),
    [anon_sym_typename] = ACTIONS(438),
    [anon_sym_COLON_COLON] = ACTIONS(111),
  },
  [280] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(603),
    [anon_sym_LPAREN] = ACTIONS(238),
    [anon_sym_COMMA] = ACTIONS(238),
    [anon_sym_STAR] = ACTIONS(238),
    [anon_sym_LBRACK] = ACTIONS(238),
    [anon_sym_unsigned] = ACTIONS(1133),
    [anon_sym_long] = ACTIONS(1133),
    [anon_sym_short] = ACTIONS(1133),
    [sym_primitive_type] = ACTIONS(244),
    [anon_sym_AMP] = ACTIONS(240),
    [anon_sym_AMP_AMP] = ACTIONS(238),
    [anon_sym_GT] = ACTIONS(238),
    [sym_identifier] = ACTIONS(1135),
    [sym_comment] = ACTIONS(49),
  },
  [281] = {
    [anon_sym_LPAREN] = ACTIONS(1137),
    [anon_sym_COMMA] = ACTIONS(1140),
    [anon_sym_RPAREN] = ACTIONS(1137),
    [anon_sym_SEMI] = ACTIONS(1140),
    [anon_sym_extern] = ACTIONS(1142),
    [anon_sym_STAR] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [anon_sym_static] = ACTIONS(1142),
    [anon_sym_register] = ACTIONS(1142),
    [anon_sym_inline] = ACTIONS(1142),
    [anon_sym_const] = ACTIONS(1142),
    [anon_sym_restrict] = ACTIONS(1142),
    [anon_sym_volatile] = ACTIONS(1142),
    [anon_sym__Atomic] = ACTIONS(1142),
    [anon_sym_mutable] = ACTIONS(1142),
    [anon_sym_explicit] = ACTIONS(1142),
    [anon_sym_constexpr] = ACTIONS(1142),
    [anon_sym_AMP] = ACTIONS(1142),
    [anon_sym_AMP_AMP] = ACTIONS(1140),
    [anon_sym_TILDE] = ACTIONS(1140),
    [anon_sym_LT] = ACTIONS(1137),
    [sym_identifier] = ACTIONS(1142),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(1144),
    [sym_operator_name] = ACTIONS(1140),
  },
  [282] = {
    [anon_sym_LPAREN] = ACTIONS(1146),
    [anon_sym_COMMA] = ACTIONS(1146),
    [anon_sym_RPAREN] = ACTIONS(1146),
    [anon_sym_SEMI] = ACTIONS(1146),
    [anon_sym_LBRACE] = ACTIONS(1146),
    [anon_sym_RBRACE] = ACTIONS(1146),
    [anon_sym_STAR] = ACTIONS(1148),
    [anon_sym_LBRACK] = ACTIONS(1146),
    [anon_sym_RBRACK] = ACTIONS(1146),
    [anon_sym_EQ] = ACTIONS(1148),
    [anon_sym_COLON] = ACTIONS(1146),
    [anon_sym_QMARK] = ACTIONS(1146),
    [anon_sym_STAR_EQ] = ACTIONS(1146),
    [anon_sym_SLASH_EQ] = ACTIONS(1146),
    [anon_sym_PERCENT_EQ] = ACTIONS(1146),
    [anon_sym_PLUS_EQ] = ACTIONS(1146),
    [anon_sym_DASH_EQ] = ACTIONS(1146),
    [anon_sym_LT_LT_EQ] = ACTIONS(1146),
    [anon_sym_GT_GT_EQ] = ACTIONS(1146),
    [anon_sym_AMP_EQ] = ACTIONS(1146),
    [anon_sym_CARET_EQ] = ACTIONS(1146),
    [anon_sym_PIPE_EQ] = ACTIONS(1146),
    [anon_sym_AMP] = ACTIONS(1148),
    [anon_sym_PIPE_PIPE] = ACTIONS(1146),
    [anon_sym_AMP_AMP] = ACTIONS(1146),
    [anon_sym_PIPE] = ACTIONS(1148),
    [anon_sym_CARET] = ACTIONS(1148),
    [anon_sym_EQ_EQ] = ACTIONS(1146),
    [anon_sym_BANG_EQ] = ACTIONS(1146),
    [anon_sym_LT] = ACTIONS(1148),
    [anon_sym_GT] = ACTIONS(1148),
    [anon_sym_LT_EQ] = ACTIONS(1146),
    [anon_sym_GT_EQ] = ACTIONS(1146),
    [anon_sym_LT_LT] = ACTIONS(1148),
    [anon_sym_GT_GT] = ACTIONS(1148),
    [anon_sym_PLUS] = ACTIONS(1148),
    [anon_sym_DASH] = ACTIONS(1148),
    [anon_sym_SLASH] = ACTIONS(1148),
    [anon_sym_PERCENT] = ACTIONS(1148),
    [anon_sym_DASH_DASH] = ACTIONS(1146),
    [anon_sym_PLUS_PLUS] = ACTIONS(1146),
    [anon_sym_DOT] = ACTIONS(1146),
    [anon_sym_DASH_GT] = ACTIONS(1146),
    [sym_comment] = ACTIONS(49),
  },
  [283] = {
    [anon_sym_LPAREN] = ACTIONS(1150),
    [anon_sym_COMMA] = ACTIONS(1150),
    [anon_sym_RPAREN] = ACTIONS(1150),
    [anon_sym_SEMI] = ACTIONS(1150),
    [anon_sym_extern] = ACTIONS(1152),
    [anon_sym_LBRACE] = ACTIONS(1150),
    [anon_sym_STAR] = ACTIONS(1150),
    [anon_sym_LBRACK] = ACTIONS(1150),
    [anon_sym_static] = ACTIONS(1152),
    [anon_sym_register] = ACTIONS(1152),
    [anon_sym_inline] = ACTIONS(1152),
    [anon_sym_const] = ACTIONS(1152),
    [anon_sym_restrict] = ACTIONS(1152),
    [anon_sym_volatile] = ACTIONS(1152),
    [anon_sym__Atomic] = ACTIONS(1152),
    [anon_sym_mutable] = ACTIONS(1152),
    [anon_sym_explicit] = ACTIONS(1152),
    [anon_sym_constexpr] = ACTIONS(1152),
    [anon_sym_COLON] = ACTIONS(1152),
    [anon_sym_AMP] = ACTIONS(1152),
    [anon_sym_AMP_AMP] = ACTIONS(1150),
    [anon_sym_TILDE] = ACTIONS(1150),
    [anon_sym_GT] = ACTIONS(1150),
    [sym_identifier] = ACTIONS(1152),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(1150),
    [sym_operator_name] = ACTIONS(1150),
  },
  [284] = {
    [sym_field_declaration_list] = STATE(604),
    [anon_sym_LBRACE] = ACTIONS(129),
    [sym_comment] = ACTIONS(49),
  },
  [285] = {
    [sym_parameter_list] = STATE(299),
    [anon_sym_LPAREN] = ACTIONS(206),
    [anon_sym_SEMI] = ACTIONS(837),
    [anon_sym_LBRACK] = ACTIONS(208),
    [sym_comment] = ACTIONS(49),
  },
  [286] = {
    [sym_parameter_list] = STATE(299),
    [anon_sym_LPAREN] = ACTIONS(206),
    [anon_sym_SEMI] = ACTIONS(839),
    [anon_sym_LBRACK] = ACTIONS(208),
    [sym_comment] = ACTIONS(49),
  },
  [287] = {
    [anon_sym_extern] = ACTIONS(1154),
    [anon_sym_static] = ACTIONS(1154),
    [anon_sym_register] = ACTIONS(1154),
    [anon_sym_inline] = ACTIONS(1154),
    [anon_sym_const] = ACTIONS(1154),
    [anon_sym_restrict] = ACTIONS(1154),
    [anon_sym_volatile] = ACTIONS(1154),
    [anon_sym__Atomic] = ACTIONS(1154),
    [anon_sym_mutable] = ACTIONS(1154),
    [anon_sym_explicit] = ACTIONS(1154),
    [anon_sym_constexpr] = ACTIONS(1154),
    [anon_sym_unsigned] = ACTIONS(1154),
    [anon_sym_long] = ACTIONS(1154),
    [anon_sym_short] = ACTIONS(1154),
    [sym_primitive_type] = ACTIONS(1154),
    [anon_sym_enum] = ACTIONS(1154),
    [anon_sym_struct] = ACTIONS(1154),
    [anon_sym_union] = ACTIONS(1154),
    [sym_identifier] = ACTIONS(1154),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(1154),
    [sym_auto] = ACTIONS(1154),
    [anon_sym_typename] = ACTIONS(1154),
    [anon_sym_COLON_COLON] = ACTIONS(1156),
  },
  [288] = {
    [sym__type_specifier] = STATE(93),
    [sym_sized_type_specifier] = STATE(93),
    [sym_enum_specifier] = STATE(93),
    [sym_struct_specifier] = STATE(93),
    [sym_union_specifier] = STATE(93),
    [sym_macro_type_specifier] = STATE(93),
    [sym_class_specifier] = STATE(93),
    [sym_dependent_type] = STATE(93),
    [sym_template_type] = STATE(94),
    [sym_scoped_type_identifier] = STATE(34),
    [sym_scoped_namespace_identifier] = STATE(81),
    [aux_sym_sized_type_specifier_repeat1] = STATE(293),
    [anon_sym_unsigned] = ACTIONS(463),
    [anon_sym_long] = ACTIONS(463),
    [anon_sym_short] = ACTIONS(463),
    [sym_primitive_type] = ACTIONS(150),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_union] = ACTIONS(39),
    [sym_identifier] = ACTIONS(1158),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(51),
    [sym_auto] = ACTIONS(150),
    [anon_sym_typename] = ACTIONS(1160),
    [anon_sym_COLON_COLON] = ACTIONS(135),
  },
  [289] = {
    [sym__declarator] = STATE(612),
    [sym__abstract_declarator] = STATE(613),
    [sym_pointer_declarator] = STATE(612),
    [sym_abstract_pointer_declarator] = STATE(613),
    [sym_function_declarator] = STATE(612),
    [sym_abstract_function_declarator] = STATE(613),
    [sym_array_declarator] = STATE(612),
    [sym_abstract_array_declarator] = STATE(613),
    [sym_init_declarator] = STATE(614),
    [sym_parameter_list] = STATE(598),
    [sym_reference_declarator] = STATE(612),
    [sym_abstract_reference_declarator] = STATE(613),
    [sym_template_type] = STATE(615),
    [sym_template_function] = STATE(612),
    [sym_destructor_name] = STATE(612),
    [sym_scoped_identifier] = STATE(616),
    [sym_scoped_type_identifier] = STATE(47),
    [sym_scoped_namespace_identifier] = STATE(615),
    [anon_sym_LPAREN] = ACTIONS(1162),
    [anon_sym_COMMA] = ACTIONS(1164),
    [anon_sym_STAR] = ACTIONS(1166),
    [anon_sym_LBRACK] = ACTIONS(1121),
    [anon_sym_AMP] = ACTIONS(1168),
    [anon_sym_AMP_AMP] = ACTIONS(1170),
    [anon_sym_TILDE] = ACTIONS(45),
    [anon_sym_GT] = ACTIONS(1164),
    [sym_identifier] = ACTIONS(1172),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(1174),
    [sym_operator_name] = ACTIONS(1176),
  },
  [290] = {
    [sym_storage_class_specifier] = STATE(617),
    [sym_type_qualifier] = STATE(617),
    [aux_sym__declaration_specifiers_repeat1] = STATE(617),
    [anon_sym_LPAREN] = ACTIONS(216),
    [anon_sym_COMMA] = ACTIONS(216),
    [anon_sym_extern] = ACTIONS(218),
    [anon_sym_STAR] = ACTIONS(216),
    [anon_sym_LBRACK] = ACTIONS(216),
    [anon_sym_static] = ACTIONS(218),
    [anon_sym_register] = ACTIONS(218),
    [anon_sym_inline] = ACTIONS(218),
    [anon_sym_const] = ACTIONS(220),
    [anon_sym_restrict] = ACTIONS(220),
    [anon_sym_volatile] = ACTIONS(220),
    [anon_sym__Atomic] = ACTIONS(220),
    [anon_sym_mutable] = ACTIONS(220),
    [anon_sym_explicit] = ACTIONS(220),
    [anon_sym_constexpr] = ACTIONS(220),
    [anon_sym_AMP] = ACTIONS(222),
    [anon_sym_AMP_AMP] = ACTIONS(216),
    [anon_sym_TILDE] = ACTIONS(216),
    [anon_sym_GT] = ACTIONS(216),
    [sym_identifier] = ACTIONS(222),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(216),
    [sym_operator_name] = ACTIONS(216),
  },
  [291] = {
    [aux_sym_template_parameter_list_repeat1] = STATE(620),
    [anon_sym_COMMA] = ACTIONS(1178),
    [anon_sym_GT] = ACTIONS(1180),
    [sym_comment] = ACTIONS(49),
  },
  [292] = {
    [sym_storage_class_specifier] = STATE(309),
    [sym_type_qualifier] = STATE(309),
    [sym__type_specifier] = STATE(621),
    [sym_sized_type_specifier] = STATE(621),
    [sym_enum_specifier] = STATE(621),
    [sym_struct_specifier] = STATE(621),
    [sym_union_specifier] = STATE(621),
    [sym_macro_type_specifier] = STATE(621),
    [sym_class_specifier] = STATE(621),
    [sym_dependent_type] = STATE(621),
    [sym_template_type] = STATE(94),
    [sym_scoped_type_identifier] = STATE(34),
    [sym_scoped_namespace_identifier] = STATE(81),
    [aux_sym__declaration_specifiers_repeat1] = STATE(309),
    [aux_sym_sized_type_specifier_repeat1] = STATE(293),
    [anon_sym_extern] = ACTIONS(154),
    [anon_sym_static] = ACTIONS(154),
    [anon_sym_register] = ACTIONS(154),
    [anon_sym_inline] = ACTIONS(154),
    [anon_sym_const] = ACTIONS(158),
    [anon_sym_restrict] = ACTIONS(158),
    [anon_sym_volatile] = ACTIONS(158),
    [anon_sym__Atomic] = ACTIONS(158),
    [anon_sym_mutable] = ACTIONS(158),
    [anon_sym_explicit] = ACTIONS(158),
    [anon_sym_constexpr] = ACTIONS(158),
    [anon_sym_unsigned] = ACTIONS(463),
    [anon_sym_long] = ACTIONS(463),
    [anon_sym_short] = ACTIONS(463),
    [sym_primitive_type] = ACTIONS(1182),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_union] = ACTIONS(39),
    [sym_identifier] = ACTIONS(152),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(51),
    [sym_auto] = ACTIONS(1182),
    [anon_sym_typename] = ACTIONS(1160),
    [anon_sym_COLON_COLON] = ACTIONS(135),
  },
  [293] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(622),
    [anon_sym_LPAREN] = ACTIONS(238),
    [anon_sym_COMMA] = ACTIONS(238),
    [anon_sym_extern] = ACTIONS(240),
    [anon_sym_STAR] = ACTIONS(238),
    [anon_sym_LBRACK] = ACTIONS(238),
    [anon_sym_static] = ACTIONS(240),
    [anon_sym_register] = ACTIONS(240),
    [anon_sym_inline] = ACTIONS(240),
    [anon_sym_const] = ACTIONS(240),
    [anon_sym_restrict] = ACTIONS(240),
    [anon_sym_volatile] = ACTIONS(240),
    [anon_sym__Atomic] = ACTIONS(240),
    [anon_sym_mutable] = ACTIONS(240),
    [anon_sym_explicit] = ACTIONS(240),
    [anon_sym_constexpr] = ACTIONS(240),
    [anon_sym_unsigned] = ACTIONS(1184),
    [anon_sym_long] = ACTIONS(1184),
    [anon_sym_short] = ACTIONS(1184),
    [sym_primitive_type] = ACTIONS(244),
    [anon_sym_AMP] = ACTIONS(240),
    [anon_sym_AMP_AMP] = ACTIONS(238),
    [anon_sym_TILDE] = ACTIONS(238),
    [anon_sym_GT] = ACTIONS(238),
    [sym_identifier] = ACTIONS(246),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(238),
    [sym_operator_name] = ACTIONS(238),
  },
  [294] = {
    [sym_destructor_name] = STATE(282),
    [anon_sym_TILDE] = ACTIONS(45),
    [sym_identifier] = ACTIONS(1186),
    [sym_comment] = ACTIONS(49),
    [sym_operator_name] = ACTIONS(442),
  },
  [295] = {
    [anon_sym_LPAREN] = ACTIONS(444),
    [anon_sym_SEMI] = ACTIONS(704),
    [anon_sym_extern] = ACTIONS(449),
    [anon_sym_STAR] = ACTIONS(447),
    [anon_sym_LBRACK] = ACTIONS(704),
    [anon_sym_static] = ACTIONS(449),
    [anon_sym_register] = ACTIONS(449),
    [anon_sym_inline] = ACTIONS(449),
    [anon_sym_const] = ACTIONS(449),
    [anon_sym_restrict] = ACTIONS(449),
    [anon_sym_volatile] = ACTIONS(449),
    [anon_sym__Atomic] = ACTIONS(449),
    [anon_sym_mutable] = ACTIONS(449),
    [anon_sym_explicit] = ACTIONS(449),
    [anon_sym_constexpr] = ACTIONS(449),
    [anon_sym_AMP] = ACTIONS(449),
    [anon_sym_AMP_AMP] = ACTIONS(447),
    [anon_sym_TILDE] = ACTIONS(447),
    [sym_identifier] = ACTIONS(449),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(447),
    [sym_operator_name] = ACTIONS(447),
  },
  [296] = {
    [anon_sym_LPAREN] = ACTIONS(509),
    [anon_sym_SEMI] = ACTIONS(518),
    [anon_sym_extern] = ACTIONS(514),
    [anon_sym_STAR] = ACTIONS(512),
    [anon_sym_LBRACK] = ACTIONS(518),
    [anon_sym_static] = ACTIONS(514),
    [anon_sym_register] = ACTIONS(514),
    [anon_sym_inline] = ACTIONS(514),
    [anon_sym_const] = ACTIONS(514),
    [anon_sym_restrict] = ACTIONS(514),
    [anon_sym_volatile] = ACTIONS(514),
    [anon_sym__Atomic] = ACTIONS(514),
    [anon_sym_mutable] = ACTIONS(514),
    [anon_sym_explicit] = ACTIONS(514),
    [anon_sym_constexpr] = ACTIONS(514),
    [anon_sym_AMP] = ACTIONS(514),
    [anon_sym_AMP_AMP] = ACTIONS(512),
    [anon_sym_TILDE] = ACTIONS(512),
    [anon_sym_LT] = ACTIONS(509),
    [sym_identifier] = ACTIONS(514),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(516),
    [sym_operator_name] = ACTIONS(512),
  },
  [297] = {
    [sym_parameter_list] = STATE(299),
    [anon_sym_LPAREN] = ACTIONS(206),
    [anon_sym_SEMI] = ACTIONS(1188),
    [anon_sym_LBRACK] = ACTIONS(208),
    [sym_comment] = ACTIONS(49),
  },
  [298] = {
    [ts_builtin_sym_end] = ACTIONS(1190),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1192),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1192),
    [anon_sym_LPAREN] = ACTIONS(1190),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1192),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1192),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1192),
    [sym_preproc_directive] = ACTIONS(1192),
    [anon_sym_typedef] = ACTIONS(1192),
    [anon_sym_extern] = ACTIONS(1192),
    [anon_sym_RBRACE] = ACTIONS(1190),
    [anon_sym_STAR] = ACTIONS(1190),
    [anon_sym_static] = ACTIONS(1192),
    [anon_sym_register] = ACTIONS(1192),
    [anon_sym_inline] = ACTIONS(1192),
    [anon_sym_const] = ACTIONS(1192),
    [anon_sym_restrict] = ACTIONS(1192),
    [anon_sym_volatile] = ACTIONS(1192),
    [anon_sym__Atomic] = ACTIONS(1192),
    [anon_sym_mutable] = ACTIONS(1192),
    [anon_sym_explicit] = ACTIONS(1192),
    [anon_sym_constexpr] = ACTIONS(1192),
    [anon_sym_unsigned] = ACTIONS(1192),
    [anon_sym_long] = ACTIONS(1192),
    [anon_sym_short] = ACTIONS(1192),
    [sym_primitive_type] = ACTIONS(1192),
    [anon_sym_enum] = ACTIONS(1192),
    [anon_sym_struct] = ACTIONS(1192),
    [anon_sym_union] = ACTIONS(1192),
    [anon_sym_AMP] = ACTIONS(1192),
    [anon_sym_AMP_AMP] = ACTIONS(1190),
    [anon_sym_TILDE] = ACTIONS(1190),
    [sym_identifier] = ACTIONS(1192),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(1192),
    [sym_auto] = ACTIONS(1192),
    [anon_sym_typename] = ACTIONS(1192),
    [anon_sym_template] = ACTIONS(1192),
    [anon_sym_namespace] = ACTIONS(1192),
    [anon_sym_using] = ACTIONS(1192),
    [anon_sym_COLON_COLON] = ACTIONS(1190),
    [sym_operator_name] = ACTIONS(1190),
  },
  [299] = {
    [sym_type_qualifier] = STATE(626),
    [sym_trailing_return_type] = STATE(626),
    [aux_sym_function_declarator_repeat1] = STATE(626),
    [anon_sym_LPAREN] = ACTIONS(610),
    [anon_sym_SEMI] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(610),
    [anon_sym_const] = ACTIONS(612),
    [anon_sym_restrict] = ACTIONS(614),
    [anon_sym_volatile] = ACTIONS(614),
    [anon_sym__Atomic] = ACTIONS(614),
    [anon_sym_mutable] = ACTIONS(614),
    [anon_sym_explicit] = ACTIONS(614),
    [anon_sym_constexpr] = ACTIONS(614),
    [anon_sym_DASH_GT] = ACTIONS(1194),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(1196),
  },
  [300] = {
    [sym_storage_class_specifier] = STATE(627),
    [sym_type_qualifier] = STATE(627),
    [aux_sym__declaration_specifiers_repeat1] = STATE(627),
    [anon_sym_LPAREN] = ACTIONS(696),
    [anon_sym_extern] = ACTIONS(218),
    [anon_sym_STAR] = ACTIONS(696),
    [anon_sym_static] = ACTIONS(218),
    [anon_sym_register] = ACTIONS(218),
    [anon_sym_inline] = ACTIONS(218),
    [anon_sym_const] = ACTIONS(220),
    [anon_sym_restrict] = ACTIONS(220),
    [anon_sym_volatile] = ACTIONS(220),
    [anon_sym__Atomic] = ACTIONS(220),
    [anon_sym_mutable] = ACTIONS(220),
    [anon_sym_explicit] = ACTIONS(220),
    [anon_sym_constexpr] = ACTIONS(220),
    [anon_sym_AMP] = ACTIONS(698),
    [anon_sym_AMP_AMP] = ACTIONS(696),
    [anon_sym_TILDE] = ACTIONS(696),
    [sym_identifier] = ACTIONS(698),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(696),
    [sym_operator_name] = ACTIONS(696),
  },
  [301] = {
    [sym__type_specifier] = STATE(93),
    [sym_sized_type_specifier] = STATE(93),
    [sym_enum_specifier] = STATE(93),
    [sym_struct_specifier] = STATE(93),
    [sym_union_specifier] = STATE(93),
    [sym_macro_type_specifier] = STATE(93),
    [sym_class_specifier] = STATE(93),
    [sym_dependent_type] = STATE(93),
    [sym_template_type] = STATE(94),
    [sym_scoped_type_identifier] = STATE(34),
    [sym_scoped_namespace_identifier] = STATE(81),
    [aux_sym_sized_type_specifier_repeat1] = STATE(306),
    [anon_sym_unsigned] = ACTIONS(479),
    [anon_sym_long] = ACTIONS(479),
    [anon_sym_short] = ACTIONS(479),
    [sym_primitive_type] = ACTIONS(150),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_union] = ACTIONS(39),
    [sym_identifier] = ACTIONS(152),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(51),
    [sym_auto] = ACTIONS(150),
    [anon_sym_typename] = ACTIONS(483),
    [anon_sym_COLON_COLON] = ACTIONS(135),
  },
  [302] = {
    [ts_builtin_sym_end] = ACTIONS(1198),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1200),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1200),
    [anon_sym_LPAREN] = ACTIONS(1198),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1200),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1200),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1200),
    [sym_preproc_directive] = ACTIONS(1200),
    [anon_sym_typedef] = ACTIONS(1200),
    [anon_sym_extern] = ACTIONS(1200),
    [anon_sym_RBRACE] = ACTIONS(1198),
    [anon_sym_STAR] = ACTIONS(1198),
    [anon_sym_static] = ACTIONS(1200),
    [anon_sym_register] = ACTIONS(1200),
    [anon_sym_inline] = ACTIONS(1200),
    [anon_sym_const] = ACTIONS(1200),
    [anon_sym_restrict] = ACTIONS(1200),
    [anon_sym_volatile] = ACTIONS(1200),
    [anon_sym__Atomic] = ACTIONS(1200),
    [anon_sym_mutable] = ACTIONS(1200),
    [anon_sym_explicit] = ACTIONS(1200),
    [anon_sym_constexpr] = ACTIONS(1200),
    [anon_sym_unsigned] = ACTIONS(1200),
    [anon_sym_long] = ACTIONS(1200),
    [anon_sym_short] = ACTIONS(1200),
    [sym_primitive_type] = ACTIONS(1200),
    [anon_sym_enum] = ACTIONS(1200),
    [anon_sym_struct] = ACTIONS(1200),
    [anon_sym_union] = ACTIONS(1200),
    [anon_sym_AMP] = ACTIONS(1200),
    [anon_sym_AMP_AMP] = ACTIONS(1198),
    [anon_sym_TILDE] = ACTIONS(1198),
    [sym_identifier] = ACTIONS(1200),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(1200),
    [sym_auto] = ACTIONS(1200),
    [anon_sym_typename] = ACTIONS(1200),
    [anon_sym_template] = ACTIONS(1200),
    [anon_sym_namespace] = ACTIONS(1200),
    [anon_sym_using] = ACTIONS(1200),
    [anon_sym_COLON_COLON] = ACTIONS(1198),
    [sym_operator_name] = ACTIONS(1198),
  },
  [303] = {
    [sym__declarator] = STATE(125),
    [sym_pointer_declarator] = STATE(125),
    [sym_function_declarator] = STATE(125),
    [sym_array_declarator] = STATE(125),
    [sym_init_declarator] = STATE(126),
    [sym_reference_declarator] = STATE(125),
    [sym_template_type] = STATE(46),
    [sym_template_function] = STATE(125),
    [sym_destructor_name] = STATE(125),
    [sym_scoped_identifier] = STATE(33),
    [sym_scoped_type_identifier] = STATE(47),
    [sym_scoped_namespace_identifier] = STATE(46),
    [anon_sym_LPAREN] = ACTIONS(11),
    [anon_sym_SEMI] = ACTIONS(194),
    [anon_sym_STAR] = ACTIONS(196),
    [anon_sym_AMP] = ACTIONS(526),
    [anon_sym_AMP_AMP] = ACTIONS(528),
    [anon_sym_TILDE] = ACTIONS(45),
    [sym_identifier] = ACTIONS(75),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(77),
    [sym_operator_name] = ACTIONS(204),
  },
  [304] = {
    [sym_storage_class_specifier] = STATE(628),
    [sym_type_qualifier] = STATE(628),
    [aux_sym__declaration_specifiers_repeat1] = STATE(628),
    [anon_sym_LPAREN] = ACTIONS(216),
    [anon_sym_SEMI] = ACTIONS(216),
    [anon_sym_extern] = ACTIONS(218),
    [anon_sym_STAR] = ACTIONS(216),
    [anon_sym_static] = ACTIONS(218),
    [anon_sym_register] = ACTIONS(218),
    [anon_sym_inline] = ACTIONS(218),
    [anon_sym_const] = ACTIONS(220),
    [anon_sym_restrict] = ACTIONS(220),
    [anon_sym_volatile] = ACTIONS(220),
    [anon_sym__Atomic] = ACTIONS(220),
    [anon_sym_mutable] = ACTIONS(220),
    [anon_sym_explicit] = ACTIONS(220),
    [anon_sym_constexpr] = ACTIONS(220),
    [anon_sym_AMP] = ACTIONS(222),
    [anon_sym_AMP_AMP] = ACTIONS(216),
    [anon_sym_TILDE] = ACTIONS(216),
    [sym_identifier] = ACTIONS(222),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(216),
    [sym_operator_name] = ACTIONS(216),
  },
  [305] = {
    [sym_storage_class_specifier] = STATE(309),
    [sym_type_qualifier] = STATE(309),
    [sym__type_specifier] = STATE(629),
    [sym_sized_type_specifier] = STATE(629),
    [sym_enum_specifier] = STATE(629),
    [sym_struct_specifier] = STATE(629),
    [sym_union_specifier] = STATE(629),
    [sym_macro_type_specifier] = STATE(629),
    [sym_class_specifier] = STATE(629),
    [sym_dependent_type] = STATE(629),
    [sym_template_type] = STATE(94),
    [sym_scoped_type_identifier] = STATE(34),
    [sym_scoped_namespace_identifier] = STATE(81),
    [aux_sym__declaration_specifiers_repeat1] = STATE(309),
    [aux_sym_sized_type_specifier_repeat1] = STATE(306),
    [anon_sym_extern] = ACTIONS(154),
    [anon_sym_static] = ACTIONS(154),
    [anon_sym_register] = ACTIONS(154),
    [anon_sym_inline] = ACTIONS(154),
    [anon_sym_const] = ACTIONS(158),
    [anon_sym_restrict] = ACTIONS(158),
    [anon_sym_volatile] = ACTIONS(158),
    [anon_sym__Atomic] = ACTIONS(158),
    [anon_sym_mutable] = ACTIONS(158),
    [anon_sym_explicit] = ACTIONS(158),
    [anon_sym_constexpr] = ACTIONS(158),
    [anon_sym_unsigned] = ACTIONS(479),
    [anon_sym_long] = ACTIONS(479),
    [anon_sym_short] = ACTIONS(479),
    [sym_primitive_type] = ACTIONS(1202),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_union] = ACTIONS(39),
    [sym_identifier] = ACTIONS(152),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(51),
    [sym_auto] = ACTIONS(1202),
    [anon_sym_typename] = ACTIONS(483),
    [anon_sym_COLON_COLON] = ACTIONS(135),
  },
  [306] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(630),
    [anon_sym_LPAREN] = ACTIONS(238),
    [anon_sym_SEMI] = ACTIONS(238),
    [anon_sym_extern] = ACTIONS(240),
    [anon_sym_STAR] = ACTIONS(238),
    [anon_sym_static] = ACTIONS(240),
    [anon_sym_register] = ACTIONS(240),
    [anon_sym_inline] = ACTIONS(240),
    [anon_sym_const] = ACTIONS(240),
    [anon_sym_restrict] = ACTIONS(240),
    [anon_sym_volatile] = ACTIONS(240),
    [anon_sym__Atomic] = ACTIONS(240),
    [anon_sym_mutable] = ACTIONS(240),
    [anon_sym_explicit] = ACTIONS(240),
    [anon_sym_constexpr] = ACTIONS(240),
    [anon_sym_unsigned] = ACTIONS(1204),
    [anon_sym_long] = ACTIONS(1204),
    [anon_sym_short] = ACTIONS(1204),
    [sym_primitive_type] = ACTIONS(244),
    [anon_sym_AMP] = ACTIONS(240),
    [anon_sym_AMP_AMP] = ACTIONS(238),
    [anon_sym_TILDE] = ACTIONS(238),
    [sym_identifier] = ACTIONS(246),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(238),
    [sym_operator_name] = ACTIONS(238),
  },
  [307] = {
    [sym_destructor_name] = STATE(428),
    [anon_sym_TILDE] = ACTIONS(45),
    [sym_identifier] = ACTIONS(1206),
    [sym_comment] = ACTIONS(49),
    [sym_operator_name] = ACTIONS(702),
  },
  [308] = {
    [sym_storage_class_specifier] = STATE(632),
    [sym_type_qualifier] = STATE(632),
    [aux_sym__declaration_specifiers_repeat1] = STATE(632),
    [anon_sym_LPAREN] = ACTIONS(696),
    [anon_sym_extern] = ACTIONS(218),
    [anon_sym_STAR] = ACTIONS(696),
    [anon_sym_static] = ACTIONS(218),
    [anon_sym_register] = ACTIONS(218),
    [anon_sym_inline] = ACTIONS(218),
    [anon_sym_const] = ACTIONS(220),
    [anon_sym_restrict] = ACTIONS(220),
    [anon_sym_volatile] = ACTIONS(220),
    [anon_sym__Atomic] = ACTIONS(220),
    [anon_sym_mutable] = ACTIONS(220),
    [anon_sym_explicit] = ACTIONS(220),
    [anon_sym_constexpr] = ACTIONS(220),
    [anon_sym_AMP] = ACTIONS(698),
    [anon_sym_AMP_AMP] = ACTIONS(696),
    [anon_sym_TILDE] = ACTIONS(696),
    [sym_identifier] = ACTIONS(698),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(696),
    [sym_operator_name] = ACTIONS(696),
  },
  [309] = {
    [sym_storage_class_specifier] = STATE(309),
    [sym_type_qualifier] = STATE(309),
    [aux_sym__declaration_specifiers_repeat1] = STATE(309),
    [anon_sym_extern] = ACTIONS(1208),
    [anon_sym_static] = ACTIONS(1208),
    [anon_sym_register] = ACTIONS(1208),
    [anon_sym_inline] = ACTIONS(1208),
    [anon_sym_const] = ACTIONS(1211),
    [anon_sym_restrict] = ACTIONS(1211),
    [anon_sym_volatile] = ACTIONS(1211),
    [anon_sym__Atomic] = ACTIONS(1211),
    [anon_sym_mutable] = ACTIONS(1211),
    [anon_sym_explicit] = ACTIONS(1211),
    [anon_sym_constexpr] = ACTIONS(1211),
    [anon_sym_unsigned] = ACTIONS(806),
    [anon_sym_long] = ACTIONS(806),
    [anon_sym_short] = ACTIONS(806),
    [sym_primitive_type] = ACTIONS(806),
    [anon_sym_enum] = ACTIONS(806),
    [anon_sym_struct] = ACTIONS(806),
    [anon_sym_union] = ACTIONS(806),
    [sym_identifier] = ACTIONS(806),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(806),
    [sym_auto] = ACTIONS(806),
    [anon_sym_typename] = ACTIONS(806),
    [anon_sym_COLON_COLON] = ACTIONS(798),
  },
  [310] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(310),
    [anon_sym_LPAREN] = ACTIONS(816),
    [anon_sym_extern] = ACTIONS(818),
    [anon_sym_STAR] = ACTIONS(816),
    [anon_sym_static] = ACTIONS(818),
    [anon_sym_register] = ACTIONS(818),
    [anon_sym_inline] = ACTIONS(818),
    [anon_sym_const] = ACTIONS(818),
    [anon_sym_restrict] = ACTIONS(818),
    [anon_sym_volatile] = ACTIONS(818),
    [anon_sym__Atomic] = ACTIONS(818),
    [anon_sym_mutable] = ACTIONS(818),
    [anon_sym_explicit] = ACTIONS(818),
    [anon_sym_constexpr] = ACTIONS(818),
    [anon_sym_unsigned] = ACTIONS(1214),
    [anon_sym_long] = ACTIONS(1214),
    [anon_sym_short] = ACTIONS(1214),
    [sym_primitive_type] = ACTIONS(818),
    [anon_sym_AMP] = ACTIONS(818),
    [anon_sym_AMP_AMP] = ACTIONS(816),
    [anon_sym_TILDE] = ACTIONS(816),
    [sym_identifier] = ACTIONS(818),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(816),
    [sym_operator_name] = ACTIONS(816),
  },
  [311] = {
    [ts_builtin_sym_end] = ACTIONS(1217),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1219),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1219),
    [anon_sym_LPAREN] = ACTIONS(1217),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1219),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1219),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1219),
    [sym_preproc_directive] = ACTIONS(1219),
    [anon_sym_typedef] = ACTIONS(1219),
    [anon_sym_extern] = ACTIONS(1219),
    [anon_sym_RBRACE] = ACTIONS(1217),
    [anon_sym_STAR] = ACTIONS(1217),
    [anon_sym_static] = ACTIONS(1219),
    [anon_sym_register] = ACTIONS(1219),
    [anon_sym_inline] = ACTIONS(1219),
    [anon_sym_const] = ACTIONS(1219),
    [anon_sym_restrict] = ACTIONS(1219),
    [anon_sym_volatile] = ACTIONS(1219),
    [anon_sym__Atomic] = ACTIONS(1219),
    [anon_sym_mutable] = ACTIONS(1219),
    [anon_sym_explicit] = ACTIONS(1219),
    [anon_sym_constexpr] = ACTIONS(1219),
    [anon_sym_unsigned] = ACTIONS(1219),
    [anon_sym_long] = ACTIONS(1219),
    [anon_sym_short] = ACTIONS(1219),
    [sym_primitive_type] = ACTIONS(1219),
    [anon_sym_enum] = ACTIONS(1219),
    [anon_sym_struct] = ACTIONS(1219),
    [anon_sym_union] = ACTIONS(1219),
    [anon_sym_AMP] = ACTIONS(1219),
    [anon_sym_AMP_AMP] = ACTIONS(1217),
    [anon_sym_TILDE] = ACTIONS(1217),
    [sym_identifier] = ACTIONS(1219),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(1219),
    [sym_auto] = ACTIONS(1219),
    [anon_sym_typename] = ACTIONS(1219),
    [anon_sym_template] = ACTIONS(1219),
    [anon_sym_namespace] = ACTIONS(1219),
    [anon_sym_using] = ACTIONS(1219),
    [anon_sym_COLON_COLON] = ACTIONS(1217),
    [sym_operator_name] = ACTIONS(1217),
  },
  [312] = {
    [sym_preproc_include] = STATE(634),
    [sym_preproc_def] = STATE(634),
    [sym_preproc_function_def] = STATE(634),
    [sym_preproc_call] = STATE(634),
    [sym_preproc_if] = STATE(634),
    [sym_preproc_ifdef] = STATE(634),
    [sym_function_definition] = STATE(634),
    [sym_declaration] = STATE(634),
    [sym_type_definition] = STATE(634),
    [sym__declaration_specifiers] = STATE(27),
    [sym_linkage_specification] = STATE(634),
    [sym__declarator] = STATE(28),
    [sym_pointer_declarator] = STATE(28),
    [sym_function_declarator] = STATE(29),
    [sym_array_declarator] = STATE(28),
    [sym_storage_class_specifier] = STATE(37),
    [sym_type_qualifier] = STATE(37),
    [sym__type_specifier] = STATE(30),
    [sym_sized_type_specifier] = STATE(30),
    [sym_enum_specifier] = STATE(30),
    [sym_struct_specifier] = STATE(30),
    [sym_union_specifier] = STATE(30),
    [sym__empty_declaration] = STATE(634),
    [sym_macro_type_specifier] = STATE(30),
    [sym_class_specifier] = STATE(30),
    [sym_dependent_type] = STATE(30),
    [sym_structured_binding_declaration] = STATE(634),
    [sym_template_declaration] = STATE(634),
    [sym_template_instantiation] = STATE(634),
    [sym_constructor_or_destructor_definition] = STATE(31),
    [sym_reference_declarator] = STATE(28),
    [sym_template_type] = STATE(32),
    [sym_template_function] = STATE(28),
    [sym_namespace_definition] = STATE(634),
    [sym_using_declaration] = STATE(634),
    [sym_alias_declaration] = STATE(634),
    [sym_destructor_name] = STATE(28),
    [sym_scoped_identifier] = STATE(33),
    [sym_scoped_type_identifier] = STATE(34),
    [sym_scoped_namespace_identifier] = STATE(35),
    [aux_sym_translation_unit_repeat1] = STATE(634),
    [aux_sym__declaration_specifiers_repeat1] = STATE(37),
    [aux_sym_sized_type_specifier_repeat1] = STATE(38),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(7),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(11),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(13),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(15),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(17),
    [sym_preproc_directive] = ACTIONS(19),
    [anon_sym_typedef] = ACTIONS(21),
    [anon_sym_extern] = ACTIONS(23),
    [anon_sym_RBRACE] = ACTIONS(1221),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_static] = ACTIONS(27),
    [anon_sym_register] = ACTIONS(27),
    [anon_sym_inline] = ACTIONS(27),
    [anon_sym_const] = ACTIONS(29),
    [anon_sym_restrict] = ACTIONS(29),
    [anon_sym_volatile] = ACTIONS(29),
    [anon_sym__Atomic] = ACTIONS(29),
    [anon_sym_mutable] = ACTIONS(29),
    [anon_sym_explicit] = ACTIONS(29),
    [anon_sym_constexpr] = ACTIONS(29),
    [anon_sym_unsigned] = ACTIONS(31),
    [anon_sym_long] = ACTIONS(31),
    [anon_sym_short] = ACTIONS(31),
    [sym_primitive_type] = ACTIONS(33),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_union] = ACTIONS(39),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(45),
    [sym_identifier] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(51),
    [sym_auto] = ACTIONS(33),
    [anon_sym_typename] = ACTIONS(53),
    [anon_sym_template] = ACTIONS(55),
    [anon_sym_namespace] = ACTIONS(57),
    [anon_sym_using] = ACTIONS(59),
    [anon_sym_COLON_COLON] = ACTIONS(61),
    [sym_operator_name] = ACTIONS(63),
  },
  [313] = {
    [ts_builtin_sym_end] = ACTIONS(1223),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1225),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1225),
    [anon_sym_LPAREN] = ACTIONS(1223),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1225),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1225),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1225),
    [sym_preproc_directive] = ACTIONS(1225),
    [anon_sym_typedef] = ACTIONS(1225),
    [anon_sym_extern] = ACTIONS(1225),
    [anon_sym_RBRACE] = ACTIONS(1223),
    [anon_sym_STAR] = ACTIONS(1223),
    [anon_sym_static] = ACTIONS(1225),
    [anon_sym_register] = ACTIONS(1225),
    [anon_sym_inline] = ACTIONS(1225),
    [anon_sym_const] = ACTIONS(1225),
    [anon_sym_restrict] = ACTIONS(1225),
    [anon_sym_volatile] = ACTIONS(1225),
    [anon_sym__Atomic] = ACTIONS(1225),
    [anon_sym_mutable] = ACTIONS(1225),
    [anon_sym_explicit] = ACTIONS(1225),
    [anon_sym_constexpr] = ACTIONS(1225),
    [anon_sym_unsigned] = ACTIONS(1225),
    [anon_sym_long] = ACTIONS(1225),
    [anon_sym_short] = ACTIONS(1225),
    [sym_primitive_type] = ACTIONS(1225),
    [anon_sym_enum] = ACTIONS(1225),
    [anon_sym_struct] = ACTIONS(1225),
    [anon_sym_union] = ACTIONS(1225),
    [anon_sym_AMP] = ACTIONS(1225),
    [anon_sym_AMP_AMP] = ACTIONS(1223),
    [anon_sym_TILDE] = ACTIONS(1223),
    [sym_identifier] = ACTIONS(1225),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(1225),
    [sym_auto] = ACTIONS(1225),
    [anon_sym_typename] = ACTIONS(1225),
    [anon_sym_template] = ACTIONS(1225),
    [anon_sym_namespace] = ACTIONS(1225),
    [anon_sym_using] = ACTIONS(1225),
    [anon_sym_COLON_COLON] = ACTIONS(1223),
    [sym_operator_name] = ACTIONS(1223),
  },
  [314] = {
    [ts_builtin_sym_end] = ACTIONS(1227),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1229),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1229),
    [anon_sym_LPAREN] = ACTIONS(1227),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1229),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1229),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1229),
    [sym_preproc_directive] = ACTIONS(1229),
    [anon_sym_typedef] = ACTIONS(1229),
    [anon_sym_extern] = ACTIONS(1229),
    [anon_sym_RBRACE] = ACTIONS(1227),
    [anon_sym_STAR] = ACTIONS(1227),
    [anon_sym_static] = ACTIONS(1229),
    [anon_sym_register] = ACTIONS(1229),
    [anon_sym_inline] = ACTIONS(1229),
    [anon_sym_const] = ACTIONS(1229),
    [anon_sym_restrict] = ACTIONS(1229),
    [anon_sym_volatile] = ACTIONS(1229),
    [anon_sym__Atomic] = ACTIONS(1229),
    [anon_sym_mutable] = ACTIONS(1229),
    [anon_sym_explicit] = ACTIONS(1229),
    [anon_sym_constexpr] = ACTIONS(1229),
    [anon_sym_unsigned] = ACTIONS(1229),
    [anon_sym_long] = ACTIONS(1229),
    [anon_sym_short] = ACTIONS(1229),
    [sym_primitive_type] = ACTIONS(1229),
    [anon_sym_enum] = ACTIONS(1229),
    [anon_sym_struct] = ACTIONS(1229),
    [anon_sym_union] = ACTIONS(1229),
    [anon_sym_AMP] = ACTIONS(1229),
    [anon_sym_AMP_AMP] = ACTIONS(1227),
    [anon_sym_TILDE] = ACTIONS(1227),
    [sym_identifier] = ACTIONS(1229),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(1229),
    [sym_auto] = ACTIONS(1229),
    [anon_sym_typename] = ACTIONS(1229),
    [anon_sym_template] = ACTIONS(1229),
    [anon_sym_namespace] = ACTIONS(1229),
    [anon_sym_using] = ACTIONS(1229),
    [anon_sym_COLON_COLON] = ACTIONS(1227),
    [sym_operator_name] = ACTIONS(1227),
  },
  [315] = {
    [sym_type_qualifier] = STATE(638),
    [sym__type_specifier] = STATE(636),
    [sym_sized_type_specifier] = STATE(636),
    [sym_enum_specifier] = STATE(636),
    [sym_struct_specifier] = STATE(636),
    [sym_union_specifier] = STATE(636),
    [sym_type_descriptor] = STATE(637),
    [sym_macro_type_specifier] = STATE(636),
    [sym_class_specifier] = STATE(636),
    [sym_dependent_type] = STATE(636),
    [sym_template_type] = STATE(62),
    [sym_scoped_type_identifier] = STATE(34),
    [sym_scoped_namespace_identifier] = STATE(64),
    [aux_sym_type_definition_repeat1] = STATE(638),
    [aux_sym_sized_type_specifier_repeat1] = STATE(639),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_restrict] = ACTIONS(93),
    [anon_sym_volatile] = ACTIONS(93),
    [anon_sym__Atomic] = ACTIONS(93),
    [anon_sym_mutable] = ACTIONS(93),
    [anon_sym_explicit] = ACTIONS(93),
    [anon_sym_constexpr] = ACTIONS(93),
    [anon_sym_unsigned] = ACTIONS(1231),
    [anon_sym_long] = ACTIONS(1231),
    [anon_sym_short] = ACTIONS(1231),
    [sym_primitive_type] = ACTIONS(1233),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(428),
    [anon_sym_union] = ACTIONS(430),
    [sym_identifier] = ACTIONS(434),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(436),
    [sym_auto] = ACTIONS(1233),
    [anon_sym_typename] = ACTIONS(1235),
    [anon_sym_COLON_COLON] = ACTIONS(111),
  },
  [316] = {
    [sym_destructor_name] = STATE(282),
    [anon_sym_TILDE] = ACTIONS(45),
    [sym_identifier] = ACTIONS(1237),
    [sym_comment] = ACTIONS(49),
    [sym_operator_name] = ACTIONS(442),
  },
  [317] = {
    [sym_template_argument_list] = STATE(203),
    [anon_sym_SEMI] = ACTIONS(1239),
    [anon_sym_LT] = ACTIONS(146),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(501),
  },
  [318] = {
    [anon_sym_SEMI] = ACTIONS(1239),
    [sym_comment] = ACTIONS(49),
  },
  [319] = {
    [anon_sym_SEMI] = ACTIONS(518),
    [anon_sym_LT] = ACTIONS(512),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(516),
  },
  [320] = {
    [sym_destructor_name] = STATE(428),
    [anon_sym_TILDE] = ACTIONS(45),
    [sym_identifier] = ACTIONS(1241),
    [sym_comment] = ACTIONS(49),
    [sym_operator_name] = ACTIONS(702),
  },
  [321] = {
    [sym__declarator] = STATE(324),
    [sym_pointer_declarator] = STATE(324),
    [sym_function_declarator] = STATE(324),
    [sym_array_declarator] = STATE(324),
    [sym_reference_declarator] = STATE(324),
    [sym_template_type] = STATE(46),
    [sym_template_function] = STATE(324),
    [sym_destructor_name] = STATE(324),
    [sym_scoped_identifier] = STATE(33),
    [sym_scoped_type_identifier] = STATE(47),
    [sym_scoped_namespace_identifier] = STATE(46),
    [anon_sym_LPAREN] = ACTIONS(11),
    [anon_sym_STAR] = ACTIONS(196),
    [anon_sym_AMP] = ACTIONS(526),
    [anon_sym_AMP_AMP] = ACTIONS(528),
    [anon_sym_TILDE] = ACTIONS(45),
    [sym_identifier] = ACTIONS(75),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(77),
    [sym_operator_name] = ACTIONS(534),
  },
  [322] = {
    [sym_parameter_list] = STATE(332),
    [anon_sym_LPAREN] = ACTIONS(206),
    [anon_sym_COMMA] = ACTIONS(837),
    [anon_sym_SEMI] = ACTIONS(837),
    [anon_sym_LBRACE] = ACTIONS(837),
    [anon_sym_LBRACK] = ACTIONS(208),
    [anon_sym_EQ] = ACTIONS(837),
    [sym_comment] = ACTIONS(49),
  },
  [323] = {
    [aux_sym_structured_binding_declarator_repeat1] = STATE(645),
    [anon_sym_COMMA] = ACTIONS(1243),
    [anon_sym_RBRACK] = ACTIONS(1245),
    [sym_comment] = ACTIONS(49),
  },
  [324] = {
    [sym_parameter_list] = STATE(332),
    [anon_sym_LPAREN] = ACTIONS(206),
    [anon_sym_COMMA] = ACTIONS(839),
    [anon_sym_SEMI] = ACTIONS(839),
    [anon_sym_LBRACE] = ACTIONS(839),
    [anon_sym_LBRACK] = ACTIONS(208),
    [anon_sym_EQ] = ACTIONS(839),
    [sym_comment] = ACTIONS(49),
  },
  [325] = {
    [anon_sym_LPAREN] = ACTIONS(1247),
    [anon_sym_LBRACE] = ACTIONS(1247),
    [anon_sym_EQ] = ACTIONS(1247),
    [sym_comment] = ACTIONS(49),
  },
  [326] = {
    [sym__declaration_specifiers] = STATE(344),
    [sym_storage_class_specifier] = STATE(346),
    [sym_type_qualifier] = STATE(346),
    [sym__type_specifier] = STATE(345),
    [sym_sized_type_specifier] = STATE(345),
    [sym_enum_specifier] = STATE(345),
    [sym_struct_specifier] = STATE(345),
    [sym_union_specifier] = STATE(345),
    [sym_parameter_declaration] = STATE(341),
    [sym__expression] = STATE(649),
    [sym_conditional_expression] = STATE(649),
    [sym_assignment_expression] = STATE(649),
    [sym_pointer_expression] = STATE(649),
    [sym_logical_expression] = STATE(649),
    [sym_bitwise_expression] = STATE(649),
    [sym_equality_expression] = STATE(649),
    [sym_relational_expression] = STATE(649),
    [sym_shift_expression] = STATE(649),
    [sym_math_expression] = STATE(649),
    [sym_cast_expression] = STATE(649),
    [sym_sizeof_expression] = STATE(649),
    [sym_subscript_expression] = STATE(649),
    [sym_call_expression] = STATE(649),
    [sym_field_expression] = STATE(649),
    [sym_compound_literal_expression] = STATE(649),
    [sym_parenthesized_expression] = STATE(649),
    [sym_initializer_list] = STATE(650),
    [sym_concatenated_string] = STATE(649),
    [sym_macro_type_specifier] = STATE(345),
    [sym_class_specifier] = STATE(345),
    [sym_dependent_type] = STATE(345),
    [sym_template_type] = STATE(651),
    [sym_template_function] = STATE(649),
    [sym_new_expression] = STATE(649),
    [sym_delete_expression] = STATE(649),
    [sym_lambda_expression] = STATE(649),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(416),
    [sym_scoped_namespace_identifier] = STATE(652),
    [aux_sym__declaration_specifiers_repeat1] = STATE(346),
    [aux_sym_sized_type_specifier_repeat1] = STATE(347),
    [sym_raw_string_literal] = ACTIONS(1249),
    [anon_sym_LPAREN] = ACTIONS(1087),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(554),
    [anon_sym_RPAREN] = ACTIONS(1251),
    [anon_sym_extern] = ACTIONS(154),
    [anon_sym_LBRACE] = ACTIONS(548),
    [anon_sym_STAR] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_static] = ACTIONS(154),
    [anon_sym_register] = ACTIONS(154),
    [anon_sym_inline] = ACTIONS(154),
    [anon_sym_const] = ACTIONS(158),
    [anon_sym_restrict] = ACTIONS(158),
    [anon_sym_volatile] = ACTIONS(158),
    [anon_sym__Atomic] = ACTIONS(158),
    [anon_sym_mutable] = ACTIONS(158),
    [anon_sym_explicit] = ACTIONS(158),
    [anon_sym_constexpr] = ACTIONS(158),
    [anon_sym_unsigned] = ACTIONS(558),
    [anon_sym_long] = ACTIONS(558),
    [anon_sym_short] = ACTIONS(558),
    [sym_primitive_type] = ACTIONS(560),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_union] = ACTIONS(39),
    [anon_sym_AMP] = ACTIONS(1089),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1093),
    [anon_sym_PLUS] = ACTIONS(1095),
    [anon_sym_DASH] = ACTIONS(1095),
    [anon_sym_DASH_DASH] = ACTIONS(1097),
    [anon_sym_PLUS_PLUS] = ACTIONS(1097),
    [anon_sym_sizeof] = ACTIONS(1099),
    [sym_number_literal] = ACTIONS(1249),
    [sym_char_literal] = ACTIONS(1249),
    [sym_string_literal] = ACTIONS(1101),
    [sym_true] = ACTIONS(1253),
    [sym_false] = ACTIONS(1253),
    [sym_null] = ACTIONS(1253),
    [sym_identifier] = ACTIONS(1255),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(51),
    [sym_auto] = ACTIONS(560),
    [anon_sym_typename] = ACTIONS(562),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1257),
    [anon_sym_delete] = ACTIONS(1109),
    [sym_nullptr] = ACTIONS(1253),
  },
  [327] = {
    [sym__declarator] = STATE(653),
    [sym_pointer_declarator] = STATE(653),
    [sym_function_declarator] = STATE(653),
    [sym_array_declarator] = STATE(653),
    [sym_init_declarator] = STATE(654),
    [sym_reference_declarator] = STATE(653),
    [sym_template_type] = STATE(46),
    [sym_template_function] = STATE(653),
    [sym_destructor_name] = STATE(653),
    [sym_scoped_identifier] = STATE(33),
    [sym_scoped_type_identifier] = STATE(47),
    [sym_scoped_namespace_identifier] = STATE(46),
    [anon_sym_LPAREN] = ACTIONS(11),
    [anon_sym_STAR] = ACTIONS(196),
    [anon_sym_AMP] = ACTIONS(526),
    [anon_sym_AMP_AMP] = ACTIONS(528),
    [anon_sym_TILDE] = ACTIONS(45),
    [sym_identifier] = ACTIONS(75),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(77),
    [sym_operator_name] = ACTIONS(1259),
  },
  [328] = {
    [ts_builtin_sym_end] = ACTIONS(1261),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1263),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1263),
    [anon_sym_LPAREN] = ACTIONS(1261),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1263),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1263),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1263),
    [sym_preproc_directive] = ACTIONS(1263),
    [anon_sym_typedef] = ACTIONS(1263),
    [anon_sym_extern] = ACTIONS(1263),
    [anon_sym_RBRACE] = ACTIONS(1261),
    [anon_sym_STAR] = ACTIONS(1261),
    [anon_sym_static] = ACTIONS(1263),
    [anon_sym_register] = ACTIONS(1263),
    [anon_sym_inline] = ACTIONS(1263),
    [anon_sym_const] = ACTIONS(1263),
    [anon_sym_restrict] = ACTIONS(1263),
    [anon_sym_volatile] = ACTIONS(1263),
    [anon_sym__Atomic] = ACTIONS(1263),
    [anon_sym_mutable] = ACTIONS(1263),
    [anon_sym_explicit] = ACTIONS(1263),
    [anon_sym_constexpr] = ACTIONS(1263),
    [anon_sym_unsigned] = ACTIONS(1263),
    [anon_sym_long] = ACTIONS(1263),
    [anon_sym_short] = ACTIONS(1263),
    [sym_primitive_type] = ACTIONS(1263),
    [anon_sym_enum] = ACTIONS(1263),
    [anon_sym_struct] = ACTIONS(1263),
    [anon_sym_union] = ACTIONS(1263),
    [anon_sym_AMP] = ACTIONS(1263),
    [anon_sym_AMP_AMP] = ACTIONS(1261),
    [anon_sym_TILDE] = ACTIONS(1261),
    [sym_identifier] = ACTIONS(1263),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(1263),
    [sym_auto] = ACTIONS(1263),
    [anon_sym_typename] = ACTIONS(1263),
    [anon_sym_template] = ACTIONS(1263),
    [anon_sym_namespace] = ACTIONS(1263),
    [anon_sym_using] = ACTIONS(1263),
    [anon_sym_COLON_COLON] = ACTIONS(1261),
    [sym_operator_name] = ACTIONS(1261),
  },
  [329] = {
    [sym_preproc_include] = STATE(418),
    [sym_preproc_def] = STATE(418),
    [sym_preproc_function_def] = STATE(418),
    [sym_preproc_call] = STATE(418),
    [sym_preproc_if_in_compound_statement] = STATE(410),
    [sym_preproc_ifdef_in_compound_statement] = STATE(411),
    [sym_declaration] = STATE(418),
    [sym_type_definition] = STATE(418),
    [sym__declaration_specifiers] = STATE(412),
    [sym_compound_statement] = STATE(418),
    [sym_storage_class_specifier] = STATE(419),
    [sym_type_qualifier] = STATE(419),
    [sym__type_specifier] = STATE(30),
    [sym_sized_type_specifier] = STATE(30),
    [sym_enum_specifier] = STATE(30),
    [sym_struct_specifier] = STATE(30),
    [sym_union_specifier] = STATE(30),
    [sym_labeled_statement] = STATE(418),
    [sym_expression_statement] = STATE(418),
    [sym_if_statement] = STATE(418),
    [sym_switch_statement] = STATE(418),
    [sym_case_statement] = STATE(418),
    [sym_while_statement] = STATE(418),
    [sym_do_statement] = STATE(418),
    [sym_for_statement] = STATE(418),
    [sym_return_statement] = STATE(418),
    [sym_break_statement] = STATE(418),
    [sym_continue_statement] = STATE(418),
    [sym_goto_statement] = STATE(418),
    [sym__expression] = STATE(669),
    [sym_comma_expression] = STATE(414),
    [sym_conditional_expression] = STATE(669),
    [sym_assignment_expression] = STATE(669),
    [sym_pointer_expression] = STATE(669),
    [sym_logical_expression] = STATE(669),
    [sym_bitwise_expression] = STATE(669),
    [sym_equality_expression] = STATE(669),
    [sym_relational_expression] = STATE(669),
    [sym_shift_expression] = STATE(669),
    [sym_math_expression] = STATE(669),
    [sym_cast_expression] = STATE(669),
    [sym_sizeof_expression] = STATE(669),
    [sym_subscript_expression] = STATE(669),
    [sym_call_expression] = STATE(669),
    [sym_field_expression] = STATE(669),
    [sym_compound_literal_expression] = STATE(669),
    [sym_parenthesized_expression] = STATE(669),
    [sym_initializer_list] = STATE(670),
    [sym_initializer_pair] = STATE(670),
    [sym_subscript_designator] = STATE(671),
    [sym_field_designator] = STATE(671),
    [sym_concatenated_string] = STATE(669),
    [sym__empty_declaration] = STATE(418),
    [sym_macro_type_specifier] = STATE(30),
    [sym_class_specifier] = STATE(30),
    [sym_dependent_type] = STATE(30),
    [sym_structured_binding_declaration] = STATE(418),
    [sym_template_type] = STATE(415),
    [sym_template_function] = STATE(669),
    [sym_for_range_loop] = STATE(418),
    [sym_new_expression] = STATE(669),
    [sym_delete_expression] = STATE(669),
    [sym_lambda_expression] = STATE(669),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(416),
    [sym_scoped_namespace_identifier] = STATE(417),
    [aux_sym_preproc_if_in_compound_statement_repeat1] = STATE(418),
    [aux_sym__declaration_specifiers_repeat1] = STATE(419),
    [aux_sym_sized_type_specifier_repeat1] = STATE(38),
    [aux_sym_initializer_pair_repeat1] = STATE(671),
    [sym_raw_string_literal] = ACTIONS(1265),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(622),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(624),
    [anon_sym_LPAREN] = ACTIONS(1267),
    [anon_sym_COMMA] = ACTIONS(1269),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(628),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(630),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(632),
    [sym_preproc_directive] = ACTIONS(634),
    [anon_sym_SEMI] = ACTIONS(636),
    [anon_sym_typedef] = ACTIONS(638),
    [anon_sym_extern] = ACTIONS(154),
    [anon_sym_LBRACE] = ACTIONS(1271),
    [anon_sym_RBRACE] = ACTIONS(1273),
    [anon_sym_STAR] = ACTIONS(1275),
    [anon_sym_LBRACK] = ACTIONS(1277),
    [anon_sym_static] = ACTIONS(154),
    [anon_sym_register] = ACTIONS(154),
    [anon_sym_inline] = ACTIONS(154),
    [anon_sym_const] = ACTIONS(158),
    [anon_sym_restrict] = ACTIONS(158),
    [anon_sym_volatile] = ACTIONS(158),
    [anon_sym__Atomic] = ACTIONS(158),
    [anon_sym_mutable] = ACTIONS(158),
    [anon_sym_explicit] = ACTIONS(158),
    [anon_sym_constexpr] = ACTIONS(158),
    [anon_sym_unsigned] = ACTIONS(31),
    [anon_sym_long] = ACTIONS(31),
    [anon_sym_short] = ACTIONS(31),
    [sym_primitive_type] = ACTIONS(33),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_union] = ACTIONS(39),
    [anon_sym_if] = ACTIONS(646),
    [anon_sym_switch] = ACTIONS(648),
    [anon_sym_case] = ACTIONS(650),
    [anon_sym_default] = ACTIONS(652),
    [anon_sym_while] = ACTIONS(654),
    [anon_sym_do] = ACTIONS(656),
    [anon_sym_for] = ACTIONS(658),
    [anon_sym_return] = ACTIONS(660),
    [anon_sym_break] = ACTIONS(662),
    [anon_sym_continue] = ACTIONS(664),
    [anon_sym_goto] = ACTIONS(666),
    [anon_sym_AMP] = ACTIONS(1275),
    [anon_sym_BANG] = ACTIONS(1279),
    [anon_sym_TILDE] = ACTIONS(1281),
    [anon_sym_PLUS] = ACTIONS(1283),
    [anon_sym_DASH] = ACTIONS(1283),
    [anon_sym_DASH_DASH] = ACTIONS(1285),
    [anon_sym_PLUS_PLUS] = ACTIONS(1285),
    [anon_sym_sizeof] = ACTIONS(1287),
    [anon_sym_DOT] = ACTIONS(1289),
    [sym_number_literal] = ACTIONS(1265),
    [sym_char_literal] = ACTIONS(1265),
    [sym_string_literal] = ACTIONS(1291),
    [sym_true] = ACTIONS(1293),
    [sym_false] = ACTIONS(1293),
    [sym_null] = ACTIONS(1293),
    [sym_identifier] = ACTIONS(682),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(51),
    [sym_auto] = ACTIONS(33),
    [anon_sym_typename] = ACTIONS(53),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1295),
    [anon_sym_delete] = ACTIONS(1297),
    [sym_nullptr] = ACTIONS(1293),
  },
  [330] = {
    [sym__expression] = STATE(673),
    [sym_conditional_expression] = STATE(673),
    [sym_assignment_expression] = STATE(673),
    [sym_pointer_expression] = STATE(673),
    [sym_logical_expression] = STATE(673),
    [sym_bitwise_expression] = STATE(673),
    [sym_equality_expression] = STATE(673),
    [sym_relational_expression] = STATE(673),
    [sym_shift_expression] = STATE(673),
    [sym_math_expression] = STATE(673),
    [sym_cast_expression] = STATE(673),
    [sym_sizeof_expression] = STATE(673),
    [sym_subscript_expression] = STATE(673),
    [sym_call_expression] = STATE(673),
    [sym_field_expression] = STATE(673),
    [sym_compound_literal_expression] = STATE(673),
    [sym_parenthesized_expression] = STATE(673),
    [sym_initializer_list] = STATE(674),
    [sym_concatenated_string] = STATE(673),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(673),
    [sym_new_expression] = STATE(673),
    [sym_delete_expression] = STATE(673),
    [sym_lambda_expression] = STATE(673),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(1299),
    [anon_sym_LPAREN] = ACTIONS(626),
    [anon_sym_LBRACE] = ACTIONS(548),
    [anon_sym_STAR] = ACTIONS(644),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_AMP] = ACTIONS(644),
    [anon_sym_BANG] = ACTIONS(668),
    [anon_sym_TILDE] = ACTIONS(670),
    [anon_sym_PLUS] = ACTIONS(672),
    [anon_sym_DASH] = ACTIONS(672),
    [anon_sym_DASH_DASH] = ACTIONS(674),
    [anon_sym_PLUS_PLUS] = ACTIONS(674),
    [anon_sym_sizeof] = ACTIONS(676),
    [sym_number_literal] = ACTIONS(1299),
    [sym_char_literal] = ACTIONS(1299),
    [sym_string_literal] = ACTIONS(678),
    [sym_true] = ACTIONS(1301),
    [sym_false] = ACTIONS(1301),
    [sym_null] = ACTIONS(1301),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1303),
    [anon_sym_delete] = ACTIONS(686),
    [sym_nullptr] = ACTIONS(1301),
  },
  [331] = {
    [ts_builtin_sym_end] = ACTIONS(1305),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1307),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1307),
    [anon_sym_LPAREN] = ACTIONS(1305),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1307),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1307),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1307),
    [sym_preproc_directive] = ACTIONS(1307),
    [anon_sym_typedef] = ACTIONS(1307),
    [anon_sym_extern] = ACTIONS(1307),
    [anon_sym_RBRACE] = ACTIONS(1305),
    [anon_sym_STAR] = ACTIONS(1305),
    [anon_sym_static] = ACTIONS(1307),
    [anon_sym_register] = ACTIONS(1307),
    [anon_sym_inline] = ACTIONS(1307),
    [anon_sym_const] = ACTIONS(1307),
    [anon_sym_restrict] = ACTIONS(1307),
    [anon_sym_volatile] = ACTIONS(1307),
    [anon_sym__Atomic] = ACTIONS(1307),
    [anon_sym_mutable] = ACTIONS(1307),
    [anon_sym_explicit] = ACTIONS(1307),
    [anon_sym_constexpr] = ACTIONS(1307),
    [anon_sym_unsigned] = ACTIONS(1307),
    [anon_sym_long] = ACTIONS(1307),
    [anon_sym_short] = ACTIONS(1307),
    [sym_primitive_type] = ACTIONS(1307),
    [anon_sym_enum] = ACTIONS(1307),
    [anon_sym_struct] = ACTIONS(1307),
    [anon_sym_union] = ACTIONS(1307),
    [anon_sym_AMP] = ACTIONS(1307),
    [anon_sym_AMP_AMP] = ACTIONS(1305),
    [anon_sym_TILDE] = ACTIONS(1305),
    [sym_identifier] = ACTIONS(1307),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(1307),
    [sym_auto] = ACTIONS(1307),
    [anon_sym_typename] = ACTIONS(1307),
    [anon_sym_template] = ACTIONS(1307),
    [anon_sym_namespace] = ACTIONS(1307),
    [anon_sym_using] = ACTIONS(1307),
    [anon_sym_COLON_COLON] = ACTIONS(1305),
    [sym_operator_name] = ACTIONS(1305),
  },
  [332] = {
    [sym_type_qualifier] = STATE(676),
    [sym_trailing_return_type] = STATE(676),
    [aux_sym_function_declarator_repeat1] = STATE(676),
    [anon_sym_LPAREN] = ACTIONS(610),
    [anon_sym_COMMA] = ACTIONS(610),
    [anon_sym_SEMI] = ACTIONS(610),
    [anon_sym_LBRACE] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(610),
    [anon_sym_EQ] = ACTIONS(610),
    [anon_sym_const] = ACTIONS(612),
    [anon_sym_restrict] = ACTIONS(614),
    [anon_sym_volatile] = ACTIONS(614),
    [anon_sym__Atomic] = ACTIONS(614),
    [anon_sym_mutable] = ACTIONS(614),
    [anon_sym_explicit] = ACTIONS(614),
    [anon_sym_constexpr] = ACTIONS(614),
    [anon_sym_DASH_GT] = ACTIONS(1309),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(1311),
  },
  [333] = {
    [anon_sym_COMMA] = ACTIONS(1313),
    [anon_sym_RPAREN] = ACTIONS(1313),
    [anon_sym_SEMI] = ACTIONS(1313),
    [anon_sym_GT] = ACTIONS(1313),
    [sym_comment] = ACTIONS(49),
  },
  [334] = {
    [aux_sym_declaration_repeat1] = STATE(678),
    [anon_sym_COMMA] = ACTIONS(538),
    [anon_sym_SEMI] = ACTIONS(1315),
    [sym_comment] = ACTIONS(49),
  },
  [335] = {
    [sym__expression] = STATE(649),
    [sym_conditional_expression] = STATE(649),
    [sym_assignment_expression] = STATE(649),
    [sym_pointer_expression] = STATE(649),
    [sym_logical_expression] = STATE(649),
    [sym_bitwise_expression] = STATE(649),
    [sym_equality_expression] = STATE(649),
    [sym_relational_expression] = STATE(649),
    [sym_shift_expression] = STATE(649),
    [sym_math_expression] = STATE(649),
    [sym_cast_expression] = STATE(649),
    [sym_sizeof_expression] = STATE(649),
    [sym_subscript_expression] = STATE(649),
    [sym_call_expression] = STATE(649),
    [sym_field_expression] = STATE(649),
    [sym_compound_literal_expression] = STATE(649),
    [sym_parenthesized_expression] = STATE(649),
    [sym_initializer_list] = STATE(650),
    [sym_concatenated_string] = STATE(649),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(649),
    [sym_new_expression] = STATE(649),
    [sym_delete_expression] = STATE(649),
    [sym_lambda_expression] = STATE(649),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(1249),
    [anon_sym_LPAREN] = ACTIONS(1087),
    [anon_sym_RPAREN] = ACTIONS(1317),
    [anon_sym_LBRACE] = ACTIONS(548),
    [anon_sym_STAR] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_AMP] = ACTIONS(1089),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1093),
    [anon_sym_PLUS] = ACTIONS(1095),
    [anon_sym_DASH] = ACTIONS(1095),
    [anon_sym_DASH_DASH] = ACTIONS(1097),
    [anon_sym_PLUS_PLUS] = ACTIONS(1097),
    [anon_sym_sizeof] = ACTIONS(1099),
    [sym_number_literal] = ACTIONS(1249),
    [sym_char_literal] = ACTIONS(1249),
    [sym_string_literal] = ACTIONS(1101),
    [sym_true] = ACTIONS(1253),
    [sym_false] = ACTIONS(1253),
    [sym_null] = ACTIONS(1253),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_delete] = ACTIONS(1109),
    [sym_nullptr] = ACTIONS(1253),
  },
  [336] = {
    [sym__expression] = STATE(690),
    [sym_conditional_expression] = STATE(690),
    [sym_assignment_expression] = STATE(690),
    [sym_pointer_expression] = STATE(690),
    [sym_logical_expression] = STATE(690),
    [sym_bitwise_expression] = STATE(690),
    [sym_equality_expression] = STATE(690),
    [sym_relational_expression] = STATE(690),
    [sym_shift_expression] = STATE(690),
    [sym_math_expression] = STATE(690),
    [sym_cast_expression] = STATE(690),
    [sym_sizeof_expression] = STATE(690),
    [sym_subscript_expression] = STATE(690),
    [sym_call_expression] = STATE(690),
    [sym_field_expression] = STATE(690),
    [sym_compound_literal_expression] = STATE(690),
    [sym_parenthesized_expression] = STATE(690),
    [sym_initializer_list] = STATE(670),
    [sym_initializer_pair] = STATE(670),
    [sym_subscript_designator] = STATE(671),
    [sym_field_designator] = STATE(671),
    [sym_concatenated_string] = STATE(690),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(690),
    [sym_new_expression] = STATE(690),
    [sym_delete_expression] = STATE(690),
    [sym_lambda_expression] = STATE(690),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [aux_sym_initializer_pair_repeat1] = STATE(671),
    [sym_raw_string_literal] = ACTIONS(1319),
    [anon_sym_LPAREN] = ACTIONS(1321),
    [anon_sym_COMMA] = ACTIONS(1269),
    [anon_sym_LBRACE] = ACTIONS(548),
    [anon_sym_RBRACE] = ACTIONS(1323),
    [anon_sym_STAR] = ACTIONS(1325),
    [anon_sym_LBRACK] = ACTIONS(1277),
    [anon_sym_AMP] = ACTIONS(1325),
    [anon_sym_BANG] = ACTIONS(1327),
    [anon_sym_TILDE] = ACTIONS(1329),
    [anon_sym_PLUS] = ACTIONS(1331),
    [anon_sym_DASH] = ACTIONS(1331),
    [anon_sym_DASH_DASH] = ACTIONS(1333),
    [anon_sym_PLUS_PLUS] = ACTIONS(1333),
    [anon_sym_sizeof] = ACTIONS(1335),
    [anon_sym_DOT] = ACTIONS(1289),
    [sym_number_literal] = ACTIONS(1319),
    [sym_char_literal] = ACTIONS(1319),
    [sym_string_literal] = ACTIONS(1337),
    [sym_true] = ACTIONS(1339),
    [sym_false] = ACTIONS(1339),
    [sym_null] = ACTIONS(1339),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1341),
    [anon_sym_delete] = ACTIONS(1343),
    [sym_nullptr] = ACTIONS(1339),
  },
  [337] = {
    [sym__expression] = STATE(700),
    [sym_conditional_expression] = STATE(700),
    [sym_assignment_expression] = STATE(700),
    [sym_pointer_expression] = STATE(700),
    [sym_logical_expression] = STATE(700),
    [sym_bitwise_expression] = STATE(700),
    [sym_equality_expression] = STATE(700),
    [sym_relational_expression] = STATE(700),
    [sym_shift_expression] = STATE(700),
    [sym_math_expression] = STATE(700),
    [sym_cast_expression] = STATE(700),
    [sym_sizeof_expression] = STATE(700),
    [sym_subscript_expression] = STATE(700),
    [sym_call_expression] = STATE(700),
    [sym_field_expression] = STATE(700),
    [sym_compound_literal_expression] = STATE(700),
    [sym_parenthesized_expression] = STATE(700),
    [sym_initializer_list] = STATE(701),
    [sym_concatenated_string] = STATE(700),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(700),
    [sym_new_expression] = STATE(700),
    [sym_delete_expression] = STATE(700),
    [sym_lambda_expression] = STATE(700),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(1345),
    [anon_sym_LPAREN] = ACTIONS(1347),
    [anon_sym_LBRACE] = ACTIONS(548),
    [anon_sym_STAR] = ACTIONS(1349),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_AMP] = ACTIONS(1349),
    [anon_sym_BANG] = ACTIONS(1351),
    [anon_sym_TILDE] = ACTIONS(1353),
    [anon_sym_PLUS] = ACTIONS(1355),
    [anon_sym_DASH] = ACTIONS(1355),
    [anon_sym_DASH_DASH] = ACTIONS(1357),
    [anon_sym_PLUS_PLUS] = ACTIONS(1357),
    [anon_sym_sizeof] = ACTIONS(1359),
    [sym_number_literal] = ACTIONS(1345),
    [sym_char_literal] = ACTIONS(1345),
    [sym_string_literal] = ACTIONS(1361),
    [sym_true] = ACTIONS(1363),
    [sym_false] = ACTIONS(1363),
    [sym_null] = ACTIONS(1363),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1365),
    [anon_sym_delete] = ACTIONS(1367),
    [sym_nullptr] = ACTIONS(1363),
  },
  [338] = {
    [anon_sym_SEMI] = ACTIONS(1369),
    [sym_comment] = ACTIONS(49),
  },
  [339] = {
    [sym__expression] = STATE(703),
    [sym_conditional_expression] = STATE(703),
    [sym_assignment_expression] = STATE(703),
    [sym_pointer_expression] = STATE(703),
    [sym_logical_expression] = STATE(703),
    [sym_bitwise_expression] = STATE(703),
    [sym_equality_expression] = STATE(703),
    [sym_relational_expression] = STATE(703),
    [sym_shift_expression] = STATE(703),
    [sym_math_expression] = STATE(703),
    [sym_cast_expression] = STATE(703),
    [sym_sizeof_expression] = STATE(703),
    [sym_subscript_expression] = STATE(703),
    [sym_call_expression] = STATE(703),
    [sym_field_expression] = STATE(703),
    [sym_compound_literal_expression] = STATE(703),
    [sym_parenthesized_expression] = STATE(703),
    [sym_initializer_list] = STATE(704),
    [sym_concatenated_string] = STATE(703),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(703),
    [sym_new_expression] = STATE(703),
    [sym_delete_expression] = STATE(703),
    [sym_lambda_expression] = STATE(703),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(1371),
    [anon_sym_LPAREN] = ACTIONS(1347),
    [anon_sym_LBRACE] = ACTIONS(548),
    [anon_sym_STAR] = ACTIONS(1349),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_AMP] = ACTIONS(1349),
    [anon_sym_BANG] = ACTIONS(1351),
    [anon_sym_TILDE] = ACTIONS(1353),
    [anon_sym_PLUS] = ACTIONS(1355),
    [anon_sym_DASH] = ACTIONS(1355),
    [anon_sym_DASH_DASH] = ACTIONS(1357),
    [anon_sym_PLUS_PLUS] = ACTIONS(1357),
    [anon_sym_sizeof] = ACTIONS(1359),
    [sym_number_literal] = ACTIONS(1371),
    [sym_char_literal] = ACTIONS(1371),
    [sym_string_literal] = ACTIONS(1361),
    [sym_true] = ACTIONS(1373),
    [sym_false] = ACTIONS(1373),
    [sym_null] = ACTIONS(1373),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1365),
    [anon_sym_delete] = ACTIONS(1367),
    [sym_nullptr] = ACTIONS(1373),
  },
  [340] = {
    [anon_sym_SEMI] = ACTIONS(1375),
    [sym_comment] = ACTIONS(49),
  },
  [341] = {
    [aux_sym_parameter_list_repeat1] = STATE(708),
    [anon_sym_COMMA] = ACTIONS(1377),
    [anon_sym_RPAREN] = ACTIONS(1379),
    [sym_comment] = ACTIONS(49),
  },
  [342] = {
    [anon_sym_LPAREN] = ACTIONS(1381),
    [anon_sym_COMMA] = ACTIONS(1381),
    [anon_sym_RPAREN] = ACTIONS(1381),
    [anon_sym_SEMI] = ACTIONS(1381),
    [anon_sym_LBRACE] = ACTIONS(1381),
    [anon_sym_LBRACK] = ACTIONS(1381),
    [anon_sym_EQ] = ACTIONS(1381),
    [anon_sym_const] = ACTIONS(1383),
    [anon_sym_restrict] = ACTIONS(1381),
    [anon_sym_volatile] = ACTIONS(1381),
    [anon_sym__Atomic] = ACTIONS(1381),
    [anon_sym_mutable] = ACTIONS(1381),
    [anon_sym_explicit] = ACTIONS(1381),
    [anon_sym_constexpr] = ACTIONS(1381),
    [anon_sym_COLON] = ACTIONS(1381),
    [anon_sym_GT] = ACTIONS(1381),
    [anon_sym_DASH_GT] = ACTIONS(1381),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(1381),
  },
  [343] = {
    [sym__type_specifier] = STATE(93),
    [sym_sized_type_specifier] = STATE(93),
    [sym_enum_specifier] = STATE(93),
    [sym_struct_specifier] = STATE(93),
    [sym_union_specifier] = STATE(93),
    [sym_macro_type_specifier] = STATE(93),
    [sym_class_specifier] = STATE(93),
    [sym_dependent_type] = STATE(93),
    [sym_template_type] = STATE(94),
    [sym_scoped_type_identifier] = STATE(34),
    [sym_scoped_namespace_identifier] = STATE(81),
    [aux_sym_sized_type_specifier_repeat1] = STATE(347),
    [anon_sym_unsigned] = ACTIONS(558),
    [anon_sym_long] = ACTIONS(558),
    [anon_sym_short] = ACTIONS(558),
    [sym_primitive_type] = ACTIONS(150),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_union] = ACTIONS(39),
    [sym_identifier] = ACTIONS(152),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(51),
    [sym_auto] = ACTIONS(150),
    [anon_sym_typename] = ACTIONS(562),
    [anon_sym_COLON_COLON] = ACTIONS(135),
  },
  [344] = {
    [sym__declarator] = STATE(711),
    [sym__abstract_declarator] = STATE(712),
    [sym_pointer_declarator] = STATE(711),
    [sym_abstract_pointer_declarator] = STATE(712),
    [sym_function_declarator] = STATE(711),
    [sym_abstract_function_declarator] = STATE(712),
    [sym_array_declarator] = STATE(711),
    [sym_abstract_array_declarator] = STATE(712),
    [sym_init_declarator] = STATE(614),
    [sym_parameter_list] = STATE(713),
    [sym_reference_declarator] = STATE(711),
    [sym_abstract_reference_declarator] = STATE(712),
    [sym_template_type] = STATE(46),
    [sym_template_function] = STATE(711),
    [sym_destructor_name] = STATE(711),
    [sym_scoped_identifier] = STATE(33),
    [sym_scoped_type_identifier] = STATE(47),
    [sym_scoped_namespace_identifier] = STATE(46),
    [anon_sym_LPAREN] = ACTIONS(1162),
    [anon_sym_COMMA] = ACTIONS(1164),
    [anon_sym_RPAREN] = ACTIONS(1164),
    [anon_sym_STAR] = ACTIONS(1385),
    [anon_sym_LBRACK] = ACTIONS(1121),
    [anon_sym_AMP] = ACTIONS(1387),
    [anon_sym_AMP_AMP] = ACTIONS(1389),
    [anon_sym_TILDE] = ACTIONS(45),
    [sym_identifier] = ACTIONS(75),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(77),
    [sym_operator_name] = ACTIONS(1391),
  },
  [345] = {
    [sym_storage_class_specifier] = STATE(714),
    [sym_type_qualifier] = STATE(714),
    [aux_sym__declaration_specifiers_repeat1] = STATE(714),
    [anon_sym_LPAREN] = ACTIONS(216),
    [anon_sym_COMMA] = ACTIONS(216),
    [anon_sym_RPAREN] = ACTIONS(216),
    [anon_sym_extern] = ACTIONS(218),
    [anon_sym_STAR] = ACTIONS(216),
    [anon_sym_LBRACK] = ACTIONS(216),
    [anon_sym_static] = ACTIONS(218),
    [anon_sym_register] = ACTIONS(218),
    [anon_sym_inline] = ACTIONS(218),
    [anon_sym_const] = ACTIONS(220),
    [anon_sym_restrict] = ACTIONS(220),
    [anon_sym_volatile] = ACTIONS(220),
    [anon_sym__Atomic] = ACTIONS(220),
    [anon_sym_mutable] = ACTIONS(220),
    [anon_sym_explicit] = ACTIONS(220),
    [anon_sym_constexpr] = ACTIONS(220),
    [anon_sym_AMP] = ACTIONS(222),
    [anon_sym_AMP_AMP] = ACTIONS(216),
    [anon_sym_TILDE] = ACTIONS(216),
    [sym_identifier] = ACTIONS(222),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(216),
    [sym_operator_name] = ACTIONS(216),
  },
  [346] = {
    [sym_storage_class_specifier] = STATE(309),
    [sym_type_qualifier] = STATE(309),
    [sym__type_specifier] = STATE(715),
    [sym_sized_type_specifier] = STATE(715),
    [sym_enum_specifier] = STATE(715),
    [sym_struct_specifier] = STATE(715),
    [sym_union_specifier] = STATE(715),
    [sym_macro_type_specifier] = STATE(715),
    [sym_class_specifier] = STATE(715),
    [sym_dependent_type] = STATE(715),
    [sym_template_type] = STATE(94),
    [sym_scoped_type_identifier] = STATE(34),
    [sym_scoped_namespace_identifier] = STATE(81),
    [aux_sym__declaration_specifiers_repeat1] = STATE(309),
    [aux_sym_sized_type_specifier_repeat1] = STATE(347),
    [anon_sym_extern] = ACTIONS(154),
    [anon_sym_static] = ACTIONS(154),
    [anon_sym_register] = ACTIONS(154),
    [anon_sym_inline] = ACTIONS(154),
    [anon_sym_const] = ACTIONS(158),
    [anon_sym_restrict] = ACTIONS(158),
    [anon_sym_volatile] = ACTIONS(158),
    [anon_sym__Atomic] = ACTIONS(158),
    [anon_sym_mutable] = ACTIONS(158),
    [anon_sym_explicit] = ACTIONS(158),
    [anon_sym_constexpr] = ACTIONS(158),
    [anon_sym_unsigned] = ACTIONS(558),
    [anon_sym_long] = ACTIONS(558),
    [anon_sym_short] = ACTIONS(558),
    [sym_primitive_type] = ACTIONS(1393),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_union] = ACTIONS(39),
    [sym_identifier] = ACTIONS(152),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(51),
    [sym_auto] = ACTIONS(1393),
    [anon_sym_typename] = ACTIONS(562),
    [anon_sym_COLON_COLON] = ACTIONS(135),
  },
  [347] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(716),
    [anon_sym_LPAREN] = ACTIONS(238),
    [anon_sym_COMMA] = ACTIONS(238),
    [anon_sym_RPAREN] = ACTIONS(238),
    [anon_sym_extern] = ACTIONS(240),
    [anon_sym_STAR] = ACTIONS(238),
    [anon_sym_LBRACK] = ACTIONS(238),
    [anon_sym_static] = ACTIONS(240),
    [anon_sym_register] = ACTIONS(240),
    [anon_sym_inline] = ACTIONS(240),
    [anon_sym_const] = ACTIONS(240),
    [anon_sym_restrict] = ACTIONS(240),
    [anon_sym_volatile] = ACTIONS(240),
    [anon_sym__Atomic] = ACTIONS(240),
    [anon_sym_mutable] = ACTIONS(240),
    [anon_sym_explicit] = ACTIONS(240),
    [anon_sym_constexpr] = ACTIONS(240),
    [anon_sym_unsigned] = ACTIONS(1395),
    [anon_sym_long] = ACTIONS(1395),
    [anon_sym_short] = ACTIONS(1395),
    [sym_primitive_type] = ACTIONS(244),
    [anon_sym_AMP] = ACTIONS(240),
    [anon_sym_AMP_AMP] = ACTIONS(238),
    [anon_sym_TILDE] = ACTIONS(238),
    [sym_identifier] = ACTIONS(246),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(238),
    [sym_operator_name] = ACTIONS(238),
  },
  [348] = {
    [sym_type_qualifier] = STATE(724),
    [sym__type_specifier] = STATE(720),
    [sym_sized_type_specifier] = STATE(720),
    [sym_enum_specifier] = STATE(720),
    [sym_struct_specifier] = STATE(720),
    [sym_union_specifier] = STATE(720),
    [sym__expression] = STATE(721),
    [sym_comma_expression] = STATE(722),
    [sym_conditional_expression] = STATE(721),
    [sym_assignment_expression] = STATE(721),
    [sym_pointer_expression] = STATE(721),
    [sym_logical_expression] = STATE(721),
    [sym_bitwise_expression] = STATE(721),
    [sym_equality_expression] = STATE(721),
    [sym_relational_expression] = STATE(721),
    [sym_shift_expression] = STATE(721),
    [sym_math_expression] = STATE(721),
    [sym_cast_expression] = STATE(721),
    [sym_type_descriptor] = STATE(723),
    [sym_sizeof_expression] = STATE(721),
    [sym_subscript_expression] = STATE(721),
    [sym_call_expression] = STATE(721),
    [sym_field_expression] = STATE(721),
    [sym_compound_literal_expression] = STATE(721),
    [sym_parenthesized_expression] = STATE(721),
    [sym_concatenated_string] = STATE(721),
    [sym_macro_type_specifier] = STATE(720),
    [sym_class_specifier] = STATE(720),
    [sym_dependent_type] = STATE(720),
    [sym_template_type] = STATE(415),
    [sym_template_function] = STATE(721),
    [sym_new_expression] = STATE(721),
    [sym_delete_expression] = STATE(721),
    [sym_lambda_expression] = STATE(721),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(416),
    [sym_scoped_namespace_identifier] = STATE(417),
    [aux_sym_type_definition_repeat1] = STATE(724),
    [aux_sym_sized_type_specifier_repeat1] = STATE(725),
    [sym_raw_string_literal] = ACTIONS(1397),
    [anon_sym_LPAREN] = ACTIONS(1087),
    [anon_sym_STAR] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_restrict] = ACTIONS(93),
    [anon_sym_volatile] = ACTIONS(93),
    [anon_sym__Atomic] = ACTIONS(93),
    [anon_sym_mutable] = ACTIONS(93),
    [anon_sym_explicit] = ACTIONS(93),
    [anon_sym_constexpr] = ACTIONS(93),
    [anon_sym_unsigned] = ACTIONS(1399),
    [anon_sym_long] = ACTIONS(1399),
    [anon_sym_short] = ACTIONS(1399),
    [sym_primitive_type] = ACTIONS(1401),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(428),
    [anon_sym_union] = ACTIONS(430),
    [anon_sym_AMP] = ACTIONS(1089),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1093),
    [anon_sym_PLUS] = ACTIONS(1095),
    [anon_sym_DASH] = ACTIONS(1095),
    [anon_sym_DASH_DASH] = ACTIONS(1097),
    [anon_sym_PLUS_PLUS] = ACTIONS(1097),
    [anon_sym_sizeof] = ACTIONS(1099),
    [sym_number_literal] = ACTIONS(1397),
    [sym_char_literal] = ACTIONS(1397),
    [sym_string_literal] = ACTIONS(1101),
    [sym_true] = ACTIONS(1403),
    [sym_false] = ACTIONS(1403),
    [sym_null] = ACTIONS(1403),
    [sym_identifier] = ACTIONS(1405),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(436),
    [sym_auto] = ACTIONS(1401),
    [anon_sym_typename] = ACTIONS(1407),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1409),
    [anon_sym_delete] = ACTIONS(1109),
    [sym_nullptr] = ACTIONS(1403),
  },
  [349] = {
    [sym__expression] = STATE(727),
    [sym_conditional_expression] = STATE(727),
    [sym_assignment_expression] = STATE(727),
    [sym_pointer_expression] = STATE(727),
    [sym_logical_expression] = STATE(727),
    [sym_bitwise_expression] = STATE(727),
    [sym_equality_expression] = STATE(727),
    [sym_relational_expression] = STATE(727),
    [sym_shift_expression] = STATE(727),
    [sym_math_expression] = STATE(727),
    [sym_cast_expression] = STATE(727),
    [sym_sizeof_expression] = STATE(727),
    [sym_subscript_expression] = STATE(727),
    [sym_call_expression] = STATE(727),
    [sym_field_expression] = STATE(727),
    [sym_compound_literal_expression] = STATE(727),
    [sym_parenthesized_expression] = STATE(727),
    [sym_concatenated_string] = STATE(727),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(727),
    [sym_new_expression] = STATE(727),
    [sym_delete_expression] = STATE(727),
    [sym_lambda_expression] = STATE(727),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(1411),
    [anon_sym_LPAREN] = ACTIONS(566),
    [anon_sym_STAR] = ACTIONS(568),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_AMP] = ACTIONS(568),
    [anon_sym_BANG] = ACTIONS(584),
    [anon_sym_TILDE] = ACTIONS(586),
    [anon_sym_PLUS] = ACTIONS(588),
    [anon_sym_DASH] = ACTIONS(588),
    [anon_sym_DASH_DASH] = ACTIONS(590),
    [anon_sym_PLUS_PLUS] = ACTIONS(590),
    [anon_sym_sizeof] = ACTIONS(592),
    [sym_number_literal] = ACTIONS(1411),
    [sym_char_literal] = ACTIONS(1411),
    [sym_string_literal] = ACTIONS(594),
    [sym_true] = ACTIONS(1413),
    [sym_false] = ACTIONS(1413),
    [sym_null] = ACTIONS(1413),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1415),
    [anon_sym_delete] = ACTIONS(608),
    [sym_nullptr] = ACTIONS(1413),
  },
  [350] = {
    [sym__expression] = STATE(740),
    [sym_conditional_expression] = STATE(740),
    [sym_assignment_expression] = STATE(740),
    [sym_pointer_expression] = STATE(740),
    [sym_logical_expression] = STATE(740),
    [sym_bitwise_expression] = STATE(740),
    [sym_equality_expression] = STATE(740),
    [sym_relational_expression] = STATE(740),
    [sym_shift_expression] = STATE(740),
    [sym_math_expression] = STATE(740),
    [sym_cast_expression] = STATE(740),
    [sym_sizeof_expression] = STATE(740),
    [sym_subscript_expression] = STATE(740),
    [sym_call_expression] = STATE(740),
    [sym_field_expression] = STATE(740),
    [sym_compound_literal_expression] = STATE(740),
    [sym_parenthesized_expression] = STATE(740),
    [sym_concatenated_string] = STATE(740),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(740),
    [sym_new_expression] = STATE(740),
    [sym_delete_expression] = STATE(740),
    [sym_lambda_expression] = STATE(740),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_lambda_default_capture] = STATE(741),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(1417),
    [anon_sym_LPAREN] = ACTIONS(1419),
    [anon_sym_STAR] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_RBRACK] = ACTIONS(1423),
    [anon_sym_EQ] = ACTIONS(1425),
    [anon_sym_AMP] = ACTIONS(1427),
    [anon_sym_BANG] = ACTIONS(1429),
    [anon_sym_TILDE] = ACTIONS(1431),
    [anon_sym_PLUS] = ACTIONS(1433),
    [anon_sym_DASH] = ACTIONS(1433),
    [anon_sym_DASH_DASH] = ACTIONS(1435),
    [anon_sym_PLUS_PLUS] = ACTIONS(1435),
    [anon_sym_sizeof] = ACTIONS(1437),
    [sym_number_literal] = ACTIONS(1417),
    [sym_char_literal] = ACTIONS(1417),
    [sym_string_literal] = ACTIONS(1439),
    [sym_true] = ACTIONS(1441),
    [sym_false] = ACTIONS(1441),
    [sym_null] = ACTIONS(1441),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1443),
    [anon_sym_delete] = ACTIONS(1445),
    [sym_nullptr] = ACTIONS(1441),
  },
  [351] = {
    [anon_sym_LPAREN] = ACTIONS(1447),
    [anon_sym_COMMA] = ACTIONS(1447),
    [anon_sym_RPAREN] = ACTIONS(1447),
    [anon_sym_SEMI] = ACTIONS(1447),
    [anon_sym_LBRACE] = ACTIONS(1447),
    [anon_sym_LBRACK] = ACTIONS(1447),
    [anon_sym_EQ] = ACTIONS(1447),
    [anon_sym_COLON] = ACTIONS(1447),
    [anon_sym_GT] = ACTIONS(1447),
    [sym_comment] = ACTIONS(49),
  },
  [352] = {
    [sym_enumerator_list] = STATE(744),
    [anon_sym_LBRACE] = ACTIONS(1449),
    [sym_identifier] = ACTIONS(1451),
    [sym_comment] = ACTIONS(49),
  },
  [353] = {
    [sym_field_declaration_list] = STATE(748),
    [sym__class_name] = STATE(749),
    [sym_base_class_clause] = STATE(750),
    [sym_template_type] = STATE(751),
    [sym_scoped_type_identifier] = STATE(752),
    [sym_scoped_namespace_identifier] = STATE(753),
    [anon_sym_LBRACE] = ACTIONS(1453),
    [anon_sym_COLON] = ACTIONS(131),
    [sym_identifier] = ACTIONS(1455),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(1457),
  },
  [354] = {
    [sym_field_declaration_list] = STATE(754),
    [sym__class_name] = STATE(755),
    [sym_base_class_clause] = STATE(756),
    [sym_template_type] = STATE(751),
    [sym_scoped_type_identifier] = STATE(752),
    [sym_scoped_namespace_identifier] = STATE(753),
    [anon_sym_LBRACE] = ACTIONS(1453),
    [anon_sym_COLON] = ACTIONS(131),
    [sym_identifier] = ACTIONS(1455),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(1457),
  },
  [355] = {
    [sym__expression] = STATE(757),
    [sym_conditional_expression] = STATE(757),
    [sym_assignment_expression] = STATE(757),
    [sym_pointer_expression] = STATE(757),
    [sym_logical_expression] = STATE(757),
    [sym_bitwise_expression] = STATE(757),
    [sym_equality_expression] = STATE(757),
    [sym_relational_expression] = STATE(757),
    [sym_shift_expression] = STATE(757),
    [sym_math_expression] = STATE(757),
    [sym_cast_expression] = STATE(757),
    [sym_sizeof_expression] = STATE(757),
    [sym_subscript_expression] = STATE(757),
    [sym_call_expression] = STATE(757),
    [sym_field_expression] = STATE(757),
    [sym_compound_literal_expression] = STATE(757),
    [sym_parenthesized_expression] = STATE(757),
    [sym_concatenated_string] = STATE(757),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(757),
    [sym_new_expression] = STATE(757),
    [sym_delete_expression] = STATE(757),
    [sym_lambda_expression] = STATE(757),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(1459),
    [anon_sym_LPAREN] = ACTIONS(566),
    [anon_sym_STAR] = ACTIONS(568),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_AMP] = ACTIONS(568),
    [anon_sym_BANG] = ACTIONS(584),
    [anon_sym_TILDE] = ACTIONS(586),
    [anon_sym_PLUS] = ACTIONS(588),
    [anon_sym_DASH] = ACTIONS(588),
    [anon_sym_DASH_DASH] = ACTIONS(590),
    [anon_sym_PLUS_PLUS] = ACTIONS(590),
    [anon_sym_sizeof] = ACTIONS(592),
    [sym_number_literal] = ACTIONS(1459),
    [sym_char_literal] = ACTIONS(1459),
    [sym_string_literal] = ACTIONS(594),
    [sym_true] = ACTIONS(1461),
    [sym_false] = ACTIONS(1461),
    [sym_null] = ACTIONS(1461),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1415),
    [anon_sym_delete] = ACTIONS(608),
    [sym_nullptr] = ACTIONS(1461),
  },
  [356] = {
    [sym__expression] = STATE(758),
    [sym_conditional_expression] = STATE(758),
    [sym_assignment_expression] = STATE(758),
    [sym_pointer_expression] = STATE(758),
    [sym_logical_expression] = STATE(758),
    [sym_bitwise_expression] = STATE(758),
    [sym_equality_expression] = STATE(758),
    [sym_relational_expression] = STATE(758),
    [sym_shift_expression] = STATE(758),
    [sym_math_expression] = STATE(758),
    [sym_cast_expression] = STATE(758),
    [sym_sizeof_expression] = STATE(758),
    [sym_subscript_expression] = STATE(758),
    [sym_call_expression] = STATE(758),
    [sym_field_expression] = STATE(758),
    [sym_compound_literal_expression] = STATE(758),
    [sym_parenthesized_expression] = STATE(758),
    [sym_concatenated_string] = STATE(758),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(758),
    [sym_new_expression] = STATE(758),
    [sym_delete_expression] = STATE(758),
    [sym_lambda_expression] = STATE(758),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(1463),
    [anon_sym_LPAREN] = ACTIONS(566),
    [anon_sym_STAR] = ACTIONS(568),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_AMP] = ACTIONS(568),
    [anon_sym_BANG] = ACTIONS(584),
    [anon_sym_TILDE] = ACTIONS(586),
    [anon_sym_PLUS] = ACTIONS(588),
    [anon_sym_DASH] = ACTIONS(588),
    [anon_sym_DASH_DASH] = ACTIONS(590),
    [anon_sym_PLUS_PLUS] = ACTIONS(590),
    [anon_sym_sizeof] = ACTIONS(592),
    [sym_number_literal] = ACTIONS(1463),
    [sym_char_literal] = ACTIONS(1463),
    [sym_string_literal] = ACTIONS(594),
    [sym_true] = ACTIONS(1465),
    [sym_false] = ACTIONS(1465),
    [sym_null] = ACTIONS(1465),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1415),
    [anon_sym_delete] = ACTIONS(608),
    [sym_nullptr] = ACTIONS(1465),
  },
  [357] = {
    [sym__expression] = STATE(759),
    [sym_conditional_expression] = STATE(759),
    [sym_assignment_expression] = STATE(759),
    [sym_pointer_expression] = STATE(759),
    [sym_logical_expression] = STATE(759),
    [sym_bitwise_expression] = STATE(759),
    [sym_equality_expression] = STATE(759),
    [sym_relational_expression] = STATE(759),
    [sym_shift_expression] = STATE(759),
    [sym_math_expression] = STATE(759),
    [sym_cast_expression] = STATE(759),
    [sym_sizeof_expression] = STATE(759),
    [sym_subscript_expression] = STATE(759),
    [sym_call_expression] = STATE(759),
    [sym_field_expression] = STATE(759),
    [sym_compound_literal_expression] = STATE(759),
    [sym_parenthesized_expression] = STATE(759),
    [sym_concatenated_string] = STATE(759),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(759),
    [sym_new_expression] = STATE(759),
    [sym_delete_expression] = STATE(759),
    [sym_lambda_expression] = STATE(759),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(1467),
    [anon_sym_LPAREN] = ACTIONS(566),
    [anon_sym_STAR] = ACTIONS(568),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_AMP] = ACTIONS(568),
    [anon_sym_BANG] = ACTIONS(584),
    [anon_sym_TILDE] = ACTIONS(586),
    [anon_sym_PLUS] = ACTIONS(588),
    [anon_sym_DASH] = ACTIONS(588),
    [anon_sym_DASH_DASH] = ACTIONS(590),
    [anon_sym_PLUS_PLUS] = ACTIONS(590),
    [anon_sym_sizeof] = ACTIONS(592),
    [sym_number_literal] = ACTIONS(1467),
    [sym_char_literal] = ACTIONS(1467),
    [sym_string_literal] = ACTIONS(594),
    [sym_true] = ACTIONS(1469),
    [sym_false] = ACTIONS(1469),
    [sym_null] = ACTIONS(1469),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1415),
    [anon_sym_delete] = ACTIONS(608),
    [sym_nullptr] = ACTIONS(1469),
  },
  [358] = {
    [sym__expression] = STATE(761),
    [sym_conditional_expression] = STATE(761),
    [sym_assignment_expression] = STATE(761),
    [sym_pointer_expression] = STATE(761),
    [sym_logical_expression] = STATE(761),
    [sym_bitwise_expression] = STATE(761),
    [sym_equality_expression] = STATE(761),
    [sym_relational_expression] = STATE(761),
    [sym_shift_expression] = STATE(761),
    [sym_math_expression] = STATE(761),
    [sym_cast_expression] = STATE(761),
    [sym_sizeof_expression] = STATE(761),
    [sym_subscript_expression] = STATE(761),
    [sym_call_expression] = STATE(761),
    [sym_field_expression] = STATE(761),
    [sym_compound_literal_expression] = STATE(761),
    [sym_parenthesized_expression] = STATE(761),
    [sym_concatenated_string] = STATE(761),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(761),
    [sym_new_expression] = STATE(761),
    [sym_delete_expression] = STATE(761),
    [sym_lambda_expression] = STATE(761),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(1471),
    [anon_sym_LPAREN] = ACTIONS(1473),
    [anon_sym_STAR] = ACTIONS(568),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_AMP] = ACTIONS(568),
    [anon_sym_BANG] = ACTIONS(584),
    [anon_sym_TILDE] = ACTIONS(586),
    [anon_sym_PLUS] = ACTIONS(588),
    [anon_sym_DASH] = ACTIONS(588),
    [anon_sym_DASH_DASH] = ACTIONS(590),
    [anon_sym_PLUS_PLUS] = ACTIONS(590),
    [anon_sym_sizeof] = ACTIONS(592),
    [sym_number_literal] = ACTIONS(1471),
    [sym_char_literal] = ACTIONS(1471),
    [sym_string_literal] = ACTIONS(594),
    [sym_true] = ACTIONS(1475),
    [sym_false] = ACTIONS(1475),
    [sym_null] = ACTIONS(1475),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1415),
    [anon_sym_delete] = ACTIONS(608),
    [sym_nullptr] = ACTIONS(1475),
  },
  [359] = {
    [aux_sym_concatenated_string_repeat1] = STATE(762),
    [anon_sym_LPAREN] = ACTIONS(1477),
    [anon_sym_STAR] = ACTIONS(1479),
    [anon_sym_LBRACK] = ACTIONS(1477),
    [anon_sym_RBRACK] = ACTIONS(1477),
    [anon_sym_EQ] = ACTIONS(1479),
    [anon_sym_QMARK] = ACTIONS(1477),
    [anon_sym_STAR_EQ] = ACTIONS(1477),
    [anon_sym_SLASH_EQ] = ACTIONS(1477),
    [anon_sym_PERCENT_EQ] = ACTIONS(1477),
    [anon_sym_PLUS_EQ] = ACTIONS(1477),
    [anon_sym_DASH_EQ] = ACTIONS(1477),
    [anon_sym_LT_LT_EQ] = ACTIONS(1477),
    [anon_sym_GT_GT_EQ] = ACTIONS(1477),
    [anon_sym_AMP_EQ] = ACTIONS(1477),
    [anon_sym_CARET_EQ] = ACTIONS(1477),
    [anon_sym_PIPE_EQ] = ACTIONS(1477),
    [anon_sym_AMP] = ACTIONS(1479),
    [anon_sym_PIPE_PIPE] = ACTIONS(1477),
    [anon_sym_AMP_AMP] = ACTIONS(1477),
    [anon_sym_PIPE] = ACTIONS(1479),
    [anon_sym_CARET] = ACTIONS(1479),
    [anon_sym_EQ_EQ] = ACTIONS(1477),
    [anon_sym_BANG_EQ] = ACTIONS(1477),
    [anon_sym_LT] = ACTIONS(1479),
    [anon_sym_GT] = ACTIONS(1479),
    [anon_sym_LT_EQ] = ACTIONS(1477),
    [anon_sym_GT_EQ] = ACTIONS(1477),
    [anon_sym_LT_LT] = ACTIONS(1479),
    [anon_sym_GT_GT] = ACTIONS(1479),
    [anon_sym_PLUS] = ACTIONS(1479),
    [anon_sym_DASH] = ACTIONS(1479),
    [anon_sym_SLASH] = ACTIONS(1479),
    [anon_sym_PERCENT] = ACTIONS(1479),
    [anon_sym_DASH_DASH] = ACTIONS(1477),
    [anon_sym_PLUS_PLUS] = ACTIONS(1477),
    [anon_sym_DOT] = ACTIONS(1477),
    [anon_sym_DASH_GT] = ACTIONS(1477),
    [sym_string_literal] = ACTIONS(1481),
    [sym_comment] = ACTIONS(49),
  },
  [360] = {
    [sym_initializer_list] = STATE(765),
    [sym_template_argument_list] = STATE(766),
    [sym_raw_string_literal] = ACTIONS(142),
    [anon_sym_LPAREN] = ACTIONS(1483),
    [anon_sym_extern] = ACTIONS(144),
    [anon_sym_LBRACE] = ACTIONS(548),
    [anon_sym_STAR] = ACTIONS(1486),
    [anon_sym_LBRACK] = ACTIONS(1483),
    [anon_sym_RBRACK] = ACTIONS(1483),
    [anon_sym_EQ] = ACTIONS(1479),
    [anon_sym_static] = ACTIONS(144),
    [anon_sym_register] = ACTIONS(144),
    [anon_sym_inline] = ACTIONS(144),
    [anon_sym_const] = ACTIONS(144),
    [anon_sym_restrict] = ACTIONS(144),
    [anon_sym_volatile] = ACTIONS(144),
    [anon_sym__Atomic] = ACTIONS(144),
    [anon_sym_mutable] = ACTIONS(144),
    [anon_sym_explicit] = ACTIONS(144),
    [anon_sym_constexpr] = ACTIONS(144),
    [anon_sym_QMARK] = ACTIONS(1477),
    [anon_sym_STAR_EQ] = ACTIONS(1477),
    [anon_sym_SLASH_EQ] = ACTIONS(1477),
    [anon_sym_PERCENT_EQ] = ACTIONS(1477),
    [anon_sym_PLUS_EQ] = ACTIONS(1477),
    [anon_sym_DASH_EQ] = ACTIONS(1477),
    [anon_sym_LT_LT_EQ] = ACTIONS(1477),
    [anon_sym_GT_GT_EQ] = ACTIONS(1477),
    [anon_sym_AMP_EQ] = ACTIONS(1477),
    [anon_sym_CARET_EQ] = ACTIONS(1477),
    [anon_sym_PIPE_EQ] = ACTIONS(1477),
    [anon_sym_AMP] = ACTIONS(1486),
    [anon_sym_PIPE_PIPE] = ACTIONS(1477),
    [anon_sym_AMP_AMP] = ACTIONS(1477),
    [anon_sym_BANG] = ACTIONS(144),
    [anon_sym_PIPE] = ACTIONS(1479),
    [anon_sym_CARET] = ACTIONS(1479),
    [anon_sym_TILDE] = ACTIONS(142),
    [anon_sym_EQ_EQ] = ACTIONS(1477),
    [anon_sym_BANG_EQ] = ACTIONS(1477),
    [anon_sym_LT] = ACTIONS(1489),
    [anon_sym_GT] = ACTIONS(1479),
    [anon_sym_LT_EQ] = ACTIONS(1477),
    [anon_sym_GT_EQ] = ACTIONS(1477),
    [anon_sym_LT_LT] = ACTIONS(1479),
    [anon_sym_GT_GT] = ACTIONS(1479),
    [anon_sym_PLUS] = ACTIONS(1486),
    [anon_sym_DASH] = ACTIONS(1486),
    [anon_sym_SLASH] = ACTIONS(1479),
    [anon_sym_PERCENT] = ACTIONS(1479),
    [anon_sym_DASH_DASH] = ACTIONS(1483),
    [anon_sym_PLUS_PLUS] = ACTIONS(1483),
    [anon_sym_sizeof] = ACTIONS(144),
    [anon_sym_DOT] = ACTIONS(1477),
    [anon_sym_DASH_GT] = ACTIONS(1477),
    [sym_number_literal] = ACTIONS(142),
    [sym_char_literal] = ACTIONS(142),
    [sym_string_literal] = ACTIONS(142),
    [sym_true] = ACTIONS(144),
    [sym_false] = ACTIONS(144),
    [sym_null] = ACTIONS(144),
    [sym_identifier] = ACTIONS(144),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(144),
    [anon_sym_COLON_COLON] = ACTIONS(1492),
    [anon_sym_delete] = ACTIONS(144),
    [sym_nullptr] = ACTIONS(144),
  },
  [361] = {
    [sym_field_declaration_list] = STATE(767),
    [sym__class_name] = STATE(768),
    [sym_base_class_clause] = STATE(769),
    [sym_template_type] = STATE(751),
    [sym_scoped_type_identifier] = STATE(752),
    [sym_scoped_namespace_identifier] = STATE(753),
    [anon_sym_LBRACE] = ACTIONS(1453),
    [anon_sym_COLON] = ACTIONS(131),
    [sym_identifier] = ACTIONS(1455),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(1457),
  },
  [362] = {
    [sym__type_specifier] = STATE(771),
    [sym_sized_type_specifier] = STATE(771),
    [sym_enum_specifier] = STATE(771),
    [sym_struct_specifier] = STATE(771),
    [sym_union_specifier] = STATE(771),
    [sym_macro_type_specifier] = STATE(771),
    [sym_class_specifier] = STATE(771),
    [sym_dependent_type] = STATE(771),
    [sym_template_type] = STATE(772),
    [sym_scoped_type_identifier] = STATE(773),
    [sym_scoped_namespace_identifier] = STATE(753),
    [aux_sym_sized_type_specifier_repeat1] = STATE(375),
    [anon_sym_unsigned] = ACTIONS(574),
    [anon_sym_long] = ACTIONS(574),
    [anon_sym_short] = ACTIONS(574),
    [sym_primitive_type] = ACTIONS(1494),
    [anon_sym_enum] = ACTIONS(578),
    [anon_sym_struct] = ACTIONS(580),
    [anon_sym_union] = ACTIONS(582),
    [sym_identifier] = ACTIONS(1496),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(600),
    [sym_auto] = ACTIONS(1494),
    [anon_sym_typename] = ACTIONS(602),
    [anon_sym_COLON_COLON] = ACTIONS(1457),
  },
  [363] = {
    [sym_parenthesized_expression] = STATE(775),
    [sym_template_type] = STATE(64),
    [sym_scoped_type_identifier] = STATE(776),
    [sym_scoped_namespace_identifier] = STATE(64),
    [anon_sym_LPAREN] = ACTIONS(422),
    [sym_identifier] = ACTIONS(1498),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(111),
  },
  [364] = {
    [sym_destructor_name] = STATE(120),
    [anon_sym_TILDE] = ACTIONS(1500),
    [sym_identifier] = ACTIONS(1502),
    [sym_comment] = ACTIONS(49),
    [anon_sym_delete] = ACTIONS(1504),
    [sym_operator_name] = ACTIONS(190),
  },
  [365] = {
    [sym__expression] = STATE(781),
    [sym_conditional_expression] = STATE(781),
    [sym_assignment_expression] = STATE(781),
    [sym_pointer_expression] = STATE(781),
    [sym_logical_expression] = STATE(781),
    [sym_bitwise_expression] = STATE(781),
    [sym_equality_expression] = STATE(781),
    [sym_relational_expression] = STATE(781),
    [sym_shift_expression] = STATE(781),
    [sym_math_expression] = STATE(781),
    [sym_cast_expression] = STATE(781),
    [sym_sizeof_expression] = STATE(781),
    [sym_subscript_expression] = STATE(781),
    [sym_call_expression] = STATE(781),
    [sym_field_expression] = STATE(781),
    [sym_compound_literal_expression] = STATE(781),
    [sym_parenthesized_expression] = STATE(781),
    [sym_concatenated_string] = STATE(781),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(781),
    [sym_new_expression] = STATE(781),
    [sym_delete_expression] = STATE(781),
    [sym_lambda_expression] = STATE(781),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(1506),
    [anon_sym_LPAREN] = ACTIONS(566),
    [anon_sym_STAR] = ACTIONS(568),
    [anon_sym_LBRACK] = ACTIONS(1508),
    [anon_sym_AMP] = ACTIONS(568),
    [anon_sym_BANG] = ACTIONS(584),
    [anon_sym_TILDE] = ACTIONS(586),
    [anon_sym_PLUS] = ACTIONS(588),
    [anon_sym_DASH] = ACTIONS(588),
    [anon_sym_DASH_DASH] = ACTIONS(590),
    [anon_sym_PLUS_PLUS] = ACTIONS(590),
    [anon_sym_sizeof] = ACTIONS(592),
    [sym_number_literal] = ACTIONS(1506),
    [sym_char_literal] = ACTIONS(1506),
    [sym_string_literal] = ACTIONS(594),
    [sym_true] = ACTIONS(1510),
    [sym_false] = ACTIONS(1510),
    [sym_null] = ACTIONS(1510),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1415),
    [anon_sym_delete] = ACTIONS(608),
    [sym_nullptr] = ACTIONS(1510),
  },
  [366] = {
    [sym__expression] = STATE(783),
    [sym_conditional_expression] = STATE(783),
    [sym_assignment_expression] = STATE(783),
    [sym_pointer_expression] = STATE(783),
    [sym_logical_expression] = STATE(783),
    [sym_bitwise_expression] = STATE(783),
    [sym_equality_expression] = STATE(783),
    [sym_relational_expression] = STATE(783),
    [sym_shift_expression] = STATE(783),
    [sym_math_expression] = STATE(783),
    [sym_cast_expression] = STATE(783),
    [sym_sizeof_expression] = STATE(783),
    [sym_subscript_expression] = STATE(783),
    [sym_call_expression] = STATE(783),
    [sym_field_expression] = STATE(783),
    [sym_compound_literal_expression] = STATE(783),
    [sym_parenthesized_expression] = STATE(783),
    [sym_concatenated_string] = STATE(783),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(783),
    [sym_new_expression] = STATE(783),
    [sym_delete_expression] = STATE(783),
    [sym_lambda_expression] = STATE(783),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(1512),
    [anon_sym_LPAREN] = ACTIONS(566),
    [anon_sym_STAR] = ACTIONS(568),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_RBRACK] = ACTIONS(1514),
    [anon_sym_AMP] = ACTIONS(568),
    [anon_sym_BANG] = ACTIONS(584),
    [anon_sym_TILDE] = ACTIONS(586),
    [anon_sym_PLUS] = ACTIONS(588),
    [anon_sym_DASH] = ACTIONS(588),
    [anon_sym_DASH_DASH] = ACTIONS(590),
    [anon_sym_PLUS_PLUS] = ACTIONS(590),
    [anon_sym_sizeof] = ACTIONS(592),
    [sym_number_literal] = ACTIONS(1512),
    [sym_char_literal] = ACTIONS(1512),
    [sym_string_literal] = ACTIONS(594),
    [sym_true] = ACTIONS(1516),
    [sym_false] = ACTIONS(1516),
    [sym_null] = ACTIONS(1516),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1415),
    [anon_sym_delete] = ACTIONS(608),
    [sym_nullptr] = ACTIONS(1516),
  },
  [367] = {
    [sym_storage_class_specifier] = STATE(786),
    [sym_type_qualifier] = STATE(786),
    [aux_sym__declaration_specifiers_repeat1] = STATE(786),
    [sym_raw_string_literal] = ACTIONS(216),
    [anon_sym_LPAREN] = ACTIONS(216),
    [anon_sym_extern] = ACTIONS(1518),
    [anon_sym_STAR] = ACTIONS(216),
    [anon_sym_LBRACK] = ACTIONS(216),
    [anon_sym_RBRACK] = ACTIONS(216),
    [anon_sym_static] = ACTIONS(1518),
    [anon_sym_register] = ACTIONS(1518),
    [anon_sym_inline] = ACTIONS(1518),
    [anon_sym_const] = ACTIONS(1520),
    [anon_sym_restrict] = ACTIONS(1520),
    [anon_sym_volatile] = ACTIONS(1520),
    [anon_sym__Atomic] = ACTIONS(1520),
    [anon_sym_mutable] = ACTIONS(1520),
    [anon_sym_explicit] = ACTIONS(1520),
    [anon_sym_constexpr] = ACTIONS(1520),
    [anon_sym_AMP] = ACTIONS(216),
    [anon_sym_BANG] = ACTIONS(216),
    [anon_sym_TILDE] = ACTIONS(216),
    [anon_sym_PLUS] = ACTIONS(222),
    [anon_sym_DASH] = ACTIONS(222),
    [anon_sym_DASH_DASH] = ACTIONS(216),
    [anon_sym_PLUS_PLUS] = ACTIONS(216),
    [anon_sym_sizeof] = ACTIONS(222),
    [sym_number_literal] = ACTIONS(216),
    [sym_char_literal] = ACTIONS(216),
    [sym_string_literal] = ACTIONS(216),
    [sym_true] = ACTIONS(222),
    [sym_false] = ACTIONS(222),
    [sym_null] = ACTIONS(222),
    [sym_identifier] = ACTIONS(222),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(222),
    [anon_sym_COLON_COLON] = ACTIONS(216),
    [anon_sym_delete] = ACTIONS(222),
    [sym_nullptr] = ACTIONS(222),
  },
  [368] = {
    [sym_argument_list] = STATE(802),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_STAR] = ACTIONS(1522),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_RBRACK] = ACTIONS(1514),
    [anon_sym_EQ] = ACTIONS(1526),
    [anon_sym_QMARK] = ACTIONS(1528),
    [anon_sym_STAR_EQ] = ACTIONS(1530),
    [anon_sym_SLASH_EQ] = ACTIONS(1530),
    [anon_sym_PERCENT_EQ] = ACTIONS(1530),
    [anon_sym_PLUS_EQ] = ACTIONS(1530),
    [anon_sym_DASH_EQ] = ACTIONS(1530),
    [anon_sym_LT_LT_EQ] = ACTIONS(1530),
    [anon_sym_GT_GT_EQ] = ACTIONS(1530),
    [anon_sym_AMP_EQ] = ACTIONS(1530),
    [anon_sym_CARET_EQ] = ACTIONS(1530),
    [anon_sym_PIPE_EQ] = ACTIONS(1530),
    [anon_sym_AMP] = ACTIONS(1532),
    [anon_sym_PIPE_PIPE] = ACTIONS(1534),
    [anon_sym_AMP_AMP] = ACTIONS(1536),
    [anon_sym_PIPE] = ACTIONS(1538),
    [anon_sym_CARET] = ACTIONS(1540),
    [anon_sym_EQ_EQ] = ACTIONS(1542),
    [anon_sym_BANG_EQ] = ACTIONS(1542),
    [anon_sym_LT] = ACTIONS(1544),
    [anon_sym_GT] = ACTIONS(1544),
    [anon_sym_LT_EQ] = ACTIONS(1546),
    [anon_sym_GT_EQ] = ACTIONS(1546),
    [anon_sym_LT_LT] = ACTIONS(1548),
    [anon_sym_GT_GT] = ACTIONS(1548),
    [anon_sym_PLUS] = ACTIONS(1550),
    [anon_sym_DASH] = ACTIONS(1550),
    [anon_sym_SLASH] = ACTIONS(1522),
    [anon_sym_PERCENT] = ACTIONS(1522),
    [anon_sym_DASH_DASH] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(1554),
    [anon_sym_DASH_GT] = ACTIONS(1554),
    [sym_comment] = ACTIONS(49),
  },
  [369] = {
    [sym_initializer_list] = STATE(804),
    [sym_raw_string_literal] = ACTIONS(228),
    [anon_sym_LPAREN] = ACTIONS(228),
    [anon_sym_extern] = ACTIONS(230),
    [anon_sym_LBRACE] = ACTIONS(548),
    [anon_sym_STAR] = ACTIONS(228),
    [anon_sym_LBRACK] = ACTIONS(228),
    [anon_sym_RBRACK] = ACTIONS(228),
    [anon_sym_static] = ACTIONS(230),
    [anon_sym_register] = ACTIONS(230),
    [anon_sym_inline] = ACTIONS(230),
    [anon_sym_const] = ACTIONS(230),
    [anon_sym_restrict] = ACTIONS(230),
    [anon_sym_volatile] = ACTIONS(230),
    [anon_sym__Atomic] = ACTIONS(230),
    [anon_sym_mutable] = ACTIONS(230),
    [anon_sym_explicit] = ACTIONS(230),
    [anon_sym_constexpr] = ACTIONS(230),
    [anon_sym_AMP] = ACTIONS(228),
    [anon_sym_BANG] = ACTIONS(228),
    [anon_sym_TILDE] = ACTIONS(228),
    [anon_sym_PLUS] = ACTIONS(230),
    [anon_sym_DASH] = ACTIONS(230),
    [anon_sym_DASH_DASH] = ACTIONS(228),
    [anon_sym_PLUS_PLUS] = ACTIONS(228),
    [anon_sym_sizeof] = ACTIONS(230),
    [sym_number_literal] = ACTIONS(228),
    [sym_char_literal] = ACTIONS(228),
    [sym_string_literal] = ACTIONS(228),
    [sym_true] = ACTIONS(230),
    [sym_false] = ACTIONS(230),
    [sym_null] = ACTIONS(230),
    [sym_identifier] = ACTIONS(230),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(230),
    [anon_sym_COLON_COLON] = ACTIONS(1556),
    [anon_sym_delete] = ACTIONS(230),
    [sym_nullptr] = ACTIONS(230),
  },
  [370] = {
    [sym__abstract_declarator] = STATE(807),
    [sym_abstract_pointer_declarator] = STATE(807),
    [sym_abstract_function_declarator] = STATE(808),
    [sym_abstract_array_declarator] = STATE(807),
    [sym_parameter_list] = STATE(809),
    [sym_abstract_reference_declarator] = STATE(807),
    [anon_sym_LPAREN] = ACTIONS(1115),
    [anon_sym_STAR] = ACTIONS(1558),
    [anon_sym_LBRACK] = ACTIONS(1121),
    [anon_sym_AMP] = ACTIONS(1560),
    [anon_sym_AMP_AMP] = ACTIONS(1562),
    [sym_comment] = ACTIONS(49),
  },
  [371] = {
    [sym_template_argument_list] = STATE(140),
    [anon_sym_LPAREN] = ACTIONS(1477),
    [anon_sym_COMMA] = ACTIONS(1477),
    [anon_sym_RPAREN] = ACTIONS(1477),
    [anon_sym_SEMI] = ACTIONS(1477),
    [anon_sym_RBRACE] = ACTIONS(1477),
    [anon_sym_STAR] = ACTIONS(1479),
    [anon_sym_LBRACK] = ACTIONS(1477),
    [anon_sym_RBRACK] = ACTIONS(1477),
    [anon_sym_EQ] = ACTIONS(1479),
    [anon_sym_QMARK] = ACTIONS(1477),
    [anon_sym_STAR_EQ] = ACTIONS(1477),
    [anon_sym_SLASH_EQ] = ACTIONS(1477),
    [anon_sym_PERCENT_EQ] = ACTIONS(1477),
    [anon_sym_PLUS_EQ] = ACTIONS(1477),
    [anon_sym_DASH_EQ] = ACTIONS(1477),
    [anon_sym_LT_LT_EQ] = ACTIONS(1477),
    [anon_sym_GT_GT_EQ] = ACTIONS(1477),
    [anon_sym_AMP_EQ] = ACTIONS(1477),
    [anon_sym_CARET_EQ] = ACTIONS(1477),
    [anon_sym_PIPE_EQ] = ACTIONS(1477),
    [anon_sym_AMP] = ACTIONS(1479),
    [anon_sym_PIPE_PIPE] = ACTIONS(1477),
    [anon_sym_AMP_AMP] = ACTIONS(1477),
    [anon_sym_PIPE] = ACTIONS(1479),
    [anon_sym_CARET] = ACTIONS(1479),
    [anon_sym_EQ_EQ] = ACTIONS(1477),
    [anon_sym_BANG_EQ] = ACTIONS(1477),
    [anon_sym_LT] = ACTIONS(1564),
    [anon_sym_GT] = ACTIONS(1479),
    [anon_sym_LT_EQ] = ACTIONS(1477),
    [anon_sym_GT_EQ] = ACTIONS(1477),
    [anon_sym_LT_LT] = ACTIONS(1479),
    [anon_sym_GT_GT] = ACTIONS(1479),
    [anon_sym_PLUS] = ACTIONS(1479),
    [anon_sym_DASH] = ACTIONS(1479),
    [anon_sym_SLASH] = ACTIONS(1479),
    [anon_sym_PERCENT] = ACTIONS(1479),
    [anon_sym_DASH_DASH] = ACTIONS(1477),
    [anon_sym_PLUS_PLUS] = ACTIONS(1477),
    [anon_sym_DOT] = ACTIONS(1477),
    [anon_sym_DASH_GT] = ACTIONS(1477),
    [sym_comment] = ACTIONS(49),
  },
  [372] = {
    [sym_initializer_list] = STATE(804),
    [sym_template_argument_list] = STATE(812),
    [sym_raw_string_literal] = ACTIONS(228),
    [anon_sym_LPAREN] = ACTIONS(228),
    [anon_sym_extern] = ACTIONS(230),
    [anon_sym_LBRACE] = ACTIONS(548),
    [anon_sym_STAR] = ACTIONS(228),
    [anon_sym_LBRACK] = ACTIONS(228),
    [anon_sym_RBRACK] = ACTIONS(228),
    [anon_sym_static] = ACTIONS(230),
    [anon_sym_register] = ACTIONS(230),
    [anon_sym_inline] = ACTIONS(230),
    [anon_sym_const] = ACTIONS(230),
    [anon_sym_restrict] = ACTIONS(230),
    [anon_sym_volatile] = ACTIONS(230),
    [anon_sym__Atomic] = ACTIONS(230),
    [anon_sym_mutable] = ACTIONS(230),
    [anon_sym_explicit] = ACTIONS(230),
    [anon_sym_constexpr] = ACTIONS(230),
    [anon_sym_AMP] = ACTIONS(228),
    [anon_sym_BANG] = ACTIONS(228),
    [anon_sym_TILDE] = ACTIONS(228),
    [anon_sym_LT] = ACTIONS(1567),
    [anon_sym_PLUS] = ACTIONS(230),
    [anon_sym_DASH] = ACTIONS(230),
    [anon_sym_DASH_DASH] = ACTIONS(228),
    [anon_sym_PLUS_PLUS] = ACTIONS(228),
    [anon_sym_sizeof] = ACTIONS(230),
    [sym_number_literal] = ACTIONS(228),
    [sym_char_literal] = ACTIONS(228),
    [sym_string_literal] = ACTIONS(228),
    [sym_true] = ACTIONS(230),
    [sym_false] = ACTIONS(230),
    [sym_null] = ACTIONS(230),
    [sym_identifier] = ACTIONS(230),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(230),
    [anon_sym_COLON_COLON] = ACTIONS(228),
    [anon_sym_delete] = ACTIONS(230),
    [sym_nullptr] = ACTIONS(230),
  },
  [373] = {
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(1556),
  },
  [374] = {
    [sym_storage_class_specifier] = STATE(309),
    [sym_type_qualifier] = STATE(309),
    [sym__type_specifier] = STATE(813),
    [sym_sized_type_specifier] = STATE(813),
    [sym_enum_specifier] = STATE(813),
    [sym_struct_specifier] = STATE(813),
    [sym_union_specifier] = STATE(813),
    [sym_macro_type_specifier] = STATE(813),
    [sym_class_specifier] = STATE(813),
    [sym_dependent_type] = STATE(813),
    [sym_template_type] = STATE(772),
    [sym_scoped_type_identifier] = STATE(773),
    [sym_scoped_namespace_identifier] = STATE(753),
    [aux_sym__declaration_specifiers_repeat1] = STATE(309),
    [aux_sym_sized_type_specifier_repeat1] = STATE(375),
    [anon_sym_extern] = ACTIONS(154),
    [anon_sym_static] = ACTIONS(154),
    [anon_sym_register] = ACTIONS(154),
    [anon_sym_inline] = ACTIONS(154),
    [anon_sym_const] = ACTIONS(158),
    [anon_sym_restrict] = ACTIONS(158),
    [anon_sym_volatile] = ACTIONS(158),
    [anon_sym__Atomic] = ACTIONS(158),
    [anon_sym_mutable] = ACTIONS(158),
    [anon_sym_explicit] = ACTIONS(158),
    [anon_sym_constexpr] = ACTIONS(158),
    [anon_sym_unsigned] = ACTIONS(574),
    [anon_sym_long] = ACTIONS(574),
    [anon_sym_short] = ACTIONS(574),
    [sym_primitive_type] = ACTIONS(1569),
    [anon_sym_enum] = ACTIONS(578),
    [anon_sym_struct] = ACTIONS(580),
    [anon_sym_union] = ACTIONS(582),
    [sym_identifier] = ACTIONS(1496),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(600),
    [sym_auto] = ACTIONS(1569),
    [anon_sym_typename] = ACTIONS(602),
    [anon_sym_COLON_COLON] = ACTIONS(1457),
  },
  [375] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(816),
    [sym_raw_string_literal] = ACTIONS(238),
    [anon_sym_LPAREN] = ACTIONS(238),
    [anon_sym_extern] = ACTIONS(240),
    [anon_sym_STAR] = ACTIONS(238),
    [anon_sym_LBRACK] = ACTIONS(238),
    [anon_sym_RBRACK] = ACTIONS(238),
    [anon_sym_static] = ACTIONS(240),
    [anon_sym_register] = ACTIONS(240),
    [anon_sym_inline] = ACTIONS(240),
    [anon_sym_const] = ACTIONS(240),
    [anon_sym_restrict] = ACTIONS(240),
    [anon_sym_volatile] = ACTIONS(240),
    [anon_sym__Atomic] = ACTIONS(240),
    [anon_sym_mutable] = ACTIONS(240),
    [anon_sym_explicit] = ACTIONS(240),
    [anon_sym_constexpr] = ACTIONS(240),
    [anon_sym_unsigned] = ACTIONS(1571),
    [anon_sym_long] = ACTIONS(1571),
    [anon_sym_short] = ACTIONS(1571),
    [sym_primitive_type] = ACTIONS(1573),
    [anon_sym_AMP] = ACTIONS(238),
    [anon_sym_BANG] = ACTIONS(238),
    [anon_sym_TILDE] = ACTIONS(238),
    [anon_sym_PLUS] = ACTIONS(240),
    [anon_sym_DASH] = ACTIONS(240),
    [anon_sym_DASH_DASH] = ACTIONS(238),
    [anon_sym_PLUS_PLUS] = ACTIONS(238),
    [anon_sym_sizeof] = ACTIONS(240),
    [sym_number_literal] = ACTIONS(238),
    [sym_char_literal] = ACTIONS(238),
    [sym_string_literal] = ACTIONS(238),
    [sym_true] = ACTIONS(240),
    [sym_false] = ACTIONS(240),
    [sym_null] = ACTIONS(240),
    [sym_identifier] = ACTIONS(1575),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(240),
    [anon_sym_COLON_COLON] = ACTIONS(238),
    [anon_sym_delete] = ACTIONS(240),
    [sym_nullptr] = ACTIONS(240),
  },
  [376] = {
    [anon_sym_LPAREN] = ACTIONS(121),
    [anon_sym_COMMA] = ACTIONS(121),
    [anon_sym_RPAREN] = ACTIONS(121),
    [anon_sym_SEMI] = ACTIONS(121),
    [anon_sym_LBRACE] = ACTIONS(121),
    [anon_sym_LBRACK] = ACTIONS(121),
    [anon_sym_EQ] = ACTIONS(121),
    [anon_sym_const] = ACTIONS(123),
    [anon_sym_restrict] = ACTIONS(121),
    [anon_sym_volatile] = ACTIONS(121),
    [anon_sym__Atomic] = ACTIONS(121),
    [anon_sym_mutable] = ACTIONS(121),
    [anon_sym_explicit] = ACTIONS(121),
    [anon_sym_constexpr] = ACTIONS(121),
    [anon_sym_COLON] = ACTIONS(121),
    [anon_sym_GT] = ACTIONS(121),
    [anon_sym_DASH_GT] = ACTIONS(121),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(121),
  },
  [377] = {
    [sym__type_specifier] = STATE(824),
    [sym_sized_type_specifier] = STATE(824),
    [sym_enum_specifier] = STATE(824),
    [sym_struct_specifier] = STATE(824),
    [sym_union_specifier] = STATE(824),
    [sym_macro_type_specifier] = STATE(824),
    [sym_class_specifier] = STATE(824),
    [sym_dependent_type] = STATE(824),
    [sym_template_type] = STATE(825),
    [sym_scoped_type_identifier] = STATE(826),
    [sym_scoped_namespace_identifier] = STATE(827),
    [aux_sym_sized_type_specifier_repeat1] = STATE(828),
    [anon_sym_unsigned] = ACTIONS(1578),
    [anon_sym_long] = ACTIONS(1578),
    [anon_sym_short] = ACTIONS(1578),
    [sym_primitive_type] = ACTIONS(1580),
    [anon_sym_enum] = ACTIONS(1582),
    [anon_sym_struct] = ACTIONS(1584),
    [anon_sym_union] = ACTIONS(1586),
    [sym_identifier] = ACTIONS(1588),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(1590),
    [sym_auto] = ACTIONS(1580),
    [anon_sym_typename] = ACTIONS(1592),
    [anon_sym_COLON_COLON] = ACTIONS(1594),
  },
  [378] = {
    [sym_type_qualifier] = STATE(829),
    [sym_trailing_return_type] = STATE(829),
    [aux_sym_function_declarator_repeat1] = STATE(829),
    [anon_sym_LPAREN] = ACTIONS(1596),
    [anon_sym_LBRACE] = ACTIONS(1596),
    [anon_sym_LBRACK] = ACTIONS(1596),
    [anon_sym_const] = ACTIONS(612),
    [anon_sym_restrict] = ACTIONS(614),
    [anon_sym_volatile] = ACTIONS(614),
    [anon_sym__Atomic] = ACTIONS(614),
    [anon_sym_mutable] = ACTIONS(614),
    [anon_sym_explicit] = ACTIONS(614),
    [anon_sym_constexpr] = ACTIONS(614),
    [anon_sym_COLON] = ACTIONS(1596),
    [anon_sym_DASH_GT] = ACTIONS(616),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(1598),
  },
  [379] = {
    [sym_string_literal] = ACTIONS(1600),
    [sym_system_lib_string] = ACTIONS(1600),
    [sym_comment] = ACTIONS(49),
  },
  [380] = {
    [sym_identifier] = ACTIONS(1602),
    [sym_comment] = ACTIONS(49),
  },
  [381] = {
    [sym_type_qualifier] = STATE(724),
    [sym__type_specifier] = STATE(720),
    [sym_sized_type_specifier] = STATE(720),
    [sym_enum_specifier] = STATE(720),
    [sym_struct_specifier] = STATE(720),
    [sym_union_specifier] = STATE(720),
    [sym__expression] = STATE(721),
    [sym_comma_expression] = STATE(722),
    [sym_conditional_expression] = STATE(721),
    [sym_assignment_expression] = STATE(721),
    [sym_pointer_expression] = STATE(721),
    [sym_logical_expression] = STATE(721),
    [sym_bitwise_expression] = STATE(721),
    [sym_equality_expression] = STATE(721),
    [sym_relational_expression] = STATE(721),
    [sym_shift_expression] = STATE(721),
    [sym_math_expression] = STATE(721),
    [sym_cast_expression] = STATE(721),
    [sym_type_descriptor] = STATE(832),
    [sym_sizeof_expression] = STATE(721),
    [sym_subscript_expression] = STATE(721),
    [sym_call_expression] = STATE(721),
    [sym_field_expression] = STATE(721),
    [sym_compound_literal_expression] = STATE(721),
    [sym_parenthesized_expression] = STATE(721),
    [sym_concatenated_string] = STATE(721),
    [sym_macro_type_specifier] = STATE(720),
    [sym_class_specifier] = STATE(720),
    [sym_dependent_type] = STATE(720),
    [sym_template_type] = STATE(415),
    [sym_template_function] = STATE(721),
    [sym_new_expression] = STATE(721),
    [sym_delete_expression] = STATE(721),
    [sym_lambda_expression] = STATE(721),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(416),
    [sym_scoped_namespace_identifier] = STATE(417),
    [aux_sym_type_definition_repeat1] = STATE(724),
    [aux_sym_sized_type_specifier_repeat1] = STATE(725),
    [sym_raw_string_literal] = ACTIONS(1397),
    [anon_sym_LPAREN] = ACTIONS(1087),
    [anon_sym_STAR] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_restrict] = ACTIONS(93),
    [anon_sym_volatile] = ACTIONS(93),
    [anon_sym__Atomic] = ACTIONS(93),
    [anon_sym_mutable] = ACTIONS(93),
    [anon_sym_explicit] = ACTIONS(93),
    [anon_sym_constexpr] = ACTIONS(93),
    [anon_sym_unsigned] = ACTIONS(1399),
    [anon_sym_long] = ACTIONS(1399),
    [anon_sym_short] = ACTIONS(1399),
    [sym_primitive_type] = ACTIONS(1401),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(428),
    [anon_sym_union] = ACTIONS(430),
    [anon_sym_AMP] = ACTIONS(1089),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1093),
    [anon_sym_PLUS] = ACTIONS(1095),
    [anon_sym_DASH] = ACTIONS(1095),
    [anon_sym_DASH_DASH] = ACTIONS(1097),
    [anon_sym_PLUS_PLUS] = ACTIONS(1097),
    [anon_sym_sizeof] = ACTIONS(1099),
    [sym_number_literal] = ACTIONS(1397),
    [sym_char_literal] = ACTIONS(1397),
    [sym_string_literal] = ACTIONS(1101),
    [sym_true] = ACTIONS(1403),
    [sym_false] = ACTIONS(1403),
    [sym_null] = ACTIONS(1403),
    [sym_identifier] = ACTIONS(1405),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(436),
    [sym_auto] = ACTIONS(1401),
    [anon_sym_typename] = ACTIONS(1407),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1409),
    [anon_sym_delete] = ACTIONS(1109),
    [sym_nullptr] = ACTIONS(1403),
  },
  [382] = {
    [sym_preproc_arg] = ACTIONS(1604),
    [sym_comment] = ACTIONS(83),
  },
  [383] = {
    [sym_identifier] = ACTIONS(1606),
    [sym_comment] = ACTIONS(49),
  },
  [384] = {
    [sym_identifier] = ACTIONS(1608),
    [sym_comment] = ACTIONS(49),
  },
  [385] = {
    [aux_sym_SLASH_LBRACK_BSLASHt_RBRACK_PLUS_SLASH] = ACTIONS(1610),
    [anon_sym_LF] = ACTIONS(1612),
    [sym_comment] = ACTIONS(83),
  },
  [386] = {
    [sym_raw_string_literal] = ACTIONS(1614),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1616),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1616),
    [anon_sym_LPAREN] = ACTIONS(1614),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1616),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1616),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1616),
    [sym_preproc_directive] = ACTIONS(1616),
    [anon_sym_SEMI] = ACTIONS(1614),
    [anon_sym_typedef] = ACTIONS(1616),
    [anon_sym_extern] = ACTIONS(1616),
    [anon_sym_LBRACE] = ACTIONS(1614),
    [anon_sym_RBRACE] = ACTIONS(1614),
    [anon_sym_STAR] = ACTIONS(1614),
    [anon_sym_LBRACK] = ACTIONS(1614),
    [anon_sym_static] = ACTIONS(1616),
    [anon_sym_register] = ACTIONS(1616),
    [anon_sym_inline] = ACTIONS(1616),
    [anon_sym_const] = ACTIONS(1616),
    [anon_sym_restrict] = ACTIONS(1616),
    [anon_sym_volatile] = ACTIONS(1616),
    [anon_sym__Atomic] = ACTIONS(1616),
    [anon_sym_mutable] = ACTIONS(1616),
    [anon_sym_explicit] = ACTIONS(1616),
    [anon_sym_constexpr] = ACTIONS(1616),
    [anon_sym_unsigned] = ACTIONS(1616),
    [anon_sym_long] = ACTIONS(1616),
    [anon_sym_short] = ACTIONS(1616),
    [sym_primitive_type] = ACTIONS(1616),
    [anon_sym_enum] = ACTIONS(1616),
    [anon_sym_struct] = ACTIONS(1616),
    [anon_sym_union] = ACTIONS(1616),
    [anon_sym_if] = ACTIONS(1616),
    [anon_sym_switch] = ACTIONS(1616),
    [anon_sym_case] = ACTIONS(1616),
    [anon_sym_default] = ACTIONS(1616),
    [anon_sym_while] = ACTIONS(1616),
    [anon_sym_do] = ACTIONS(1616),
    [anon_sym_for] = ACTIONS(1616),
    [anon_sym_return] = ACTIONS(1616),
    [anon_sym_break] = ACTIONS(1616),
    [anon_sym_continue] = ACTIONS(1616),
    [anon_sym_goto] = ACTIONS(1616),
    [anon_sym_AMP] = ACTIONS(1614),
    [anon_sym_BANG] = ACTIONS(1614),
    [anon_sym_TILDE] = ACTIONS(1614),
    [anon_sym_PLUS] = ACTIONS(1616),
    [anon_sym_DASH] = ACTIONS(1616),
    [anon_sym_DASH_DASH] = ACTIONS(1614),
    [anon_sym_PLUS_PLUS] = ACTIONS(1614),
    [anon_sym_sizeof] = ACTIONS(1616),
    [sym_number_literal] = ACTIONS(1614),
    [sym_char_literal] = ACTIONS(1614),
    [sym_string_literal] = ACTIONS(1614),
    [sym_true] = ACTIONS(1616),
    [sym_false] = ACTIONS(1616),
    [sym_null] = ACTIONS(1616),
    [sym_identifier] = ACTIONS(1616),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(1616),
    [sym_auto] = ACTIONS(1616),
    [anon_sym_typename] = ACTIONS(1616),
    [anon_sym_new] = ACTIONS(1616),
    [anon_sym_COLON_COLON] = ACTIONS(1614),
    [anon_sym_delete] = ACTIONS(1616),
    [sym_nullptr] = ACTIONS(1616),
  },
  [387] = {
    [sym_type_qualifier] = STATE(839),
    [sym__type_specifier] = STATE(838),
    [sym_sized_type_specifier] = STATE(838),
    [sym_enum_specifier] = STATE(838),
    [sym_struct_specifier] = STATE(838),
    [sym_union_specifier] = STATE(838),
    [sym_macro_type_specifier] = STATE(838),
    [sym_class_specifier] = STATE(838),
    [sym_dependent_type] = STATE(838),
    [sym_template_type] = STATE(62),
    [sym_scoped_type_identifier] = STATE(63),
    [sym_scoped_namespace_identifier] = STATE(64),
    [aux_sym_type_definition_repeat1] = STATE(839),
    [aux_sym_sized_type_specifier_repeat1] = STATE(66),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_restrict] = ACTIONS(93),
    [anon_sym_volatile] = ACTIONS(93),
    [anon_sym__Atomic] = ACTIONS(93),
    [anon_sym_mutable] = ACTIONS(93),
    [anon_sym_explicit] = ACTIONS(93),
    [anon_sym_constexpr] = ACTIONS(93),
    [anon_sym_unsigned] = ACTIONS(95),
    [anon_sym_long] = ACTIONS(95),
    [anon_sym_short] = ACTIONS(95),
    [sym_primitive_type] = ACTIONS(1618),
    [anon_sym_enum] = ACTIONS(99),
    [anon_sym_struct] = ACTIONS(101),
    [anon_sym_union] = ACTIONS(103),
    [sym_identifier] = ACTIONS(105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(107),
    [sym_auto] = ACTIONS(1618),
    [anon_sym_typename] = ACTIONS(109),
    [anon_sym_COLON_COLON] = ACTIONS(111),
  },
  [388] = {
    [sym_preproc_include] = STATE(841),
    [sym_preproc_def] = STATE(841),
    [sym_preproc_function_def] = STATE(841),
    [sym_preproc_call] = STATE(841),
    [sym_preproc_if_in_compound_statement] = STATE(410),
    [sym_preproc_ifdef_in_compound_statement] = STATE(411),
    [sym_declaration] = STATE(841),
    [sym_type_definition] = STATE(841),
    [sym__declaration_specifiers] = STATE(412),
    [sym_compound_statement] = STATE(841),
    [sym_storage_class_specifier] = STATE(419),
    [sym_type_qualifier] = STATE(419),
    [sym__type_specifier] = STATE(30),
    [sym_sized_type_specifier] = STATE(30),
    [sym_enum_specifier] = STATE(30),
    [sym_struct_specifier] = STATE(30),
    [sym_union_specifier] = STATE(30),
    [sym_labeled_statement] = STATE(841),
    [sym_expression_statement] = STATE(841),
    [sym_if_statement] = STATE(841),
    [sym_switch_statement] = STATE(841),
    [sym_case_statement] = STATE(841),
    [sym_while_statement] = STATE(841),
    [sym_do_statement] = STATE(841),
    [sym_for_statement] = STATE(841),
    [sym_return_statement] = STATE(841),
    [sym_break_statement] = STATE(841),
    [sym_continue_statement] = STATE(841),
    [sym_goto_statement] = STATE(841),
    [sym__expression] = STATE(413),
    [sym_comma_expression] = STATE(414),
    [sym_conditional_expression] = STATE(413),
    [sym_assignment_expression] = STATE(413),
    [sym_pointer_expression] = STATE(413),
    [sym_logical_expression] = STATE(413),
    [sym_bitwise_expression] = STATE(413),
    [sym_equality_expression] = STATE(413),
    [sym_relational_expression] = STATE(413),
    [sym_shift_expression] = STATE(413),
    [sym_math_expression] = STATE(413),
    [sym_cast_expression] = STATE(413),
    [sym_sizeof_expression] = STATE(413),
    [sym_subscript_expression] = STATE(413),
    [sym_call_expression] = STATE(413),
    [sym_field_expression] = STATE(413),
    [sym_compound_literal_expression] = STATE(413),
    [sym_parenthesized_expression] = STATE(413),
    [sym_concatenated_string] = STATE(413),
    [sym__empty_declaration] = STATE(841),
    [sym_macro_type_specifier] = STATE(30),
    [sym_class_specifier] = STATE(30),
    [sym_dependent_type] = STATE(30),
    [sym_structured_binding_declaration] = STATE(841),
    [sym_template_type] = STATE(415),
    [sym_template_function] = STATE(413),
    [sym_for_range_loop] = STATE(841),
    [sym_new_expression] = STATE(413),
    [sym_delete_expression] = STATE(413),
    [sym_lambda_expression] = STATE(413),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(416),
    [sym_scoped_namespace_identifier] = STATE(417),
    [aux_sym_preproc_if_in_compound_statement_repeat1] = STATE(841),
    [aux_sym__declaration_specifiers_repeat1] = STATE(419),
    [aux_sym_sized_type_specifier_repeat1] = STATE(38),
    [sym_raw_string_literal] = ACTIONS(620),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(622),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(624),
    [anon_sym_LPAREN] = ACTIONS(626),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(628),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(630),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(632),
    [sym_preproc_directive] = ACTIONS(634),
    [anon_sym_SEMI] = ACTIONS(636),
    [anon_sym_typedef] = ACTIONS(638),
    [anon_sym_extern] = ACTIONS(154),
    [anon_sym_LBRACE] = ACTIONS(640),
    [anon_sym_RBRACE] = ACTIONS(1620),
    [anon_sym_STAR] = ACTIONS(644),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_static] = ACTIONS(154),
    [anon_sym_register] = ACTIONS(154),
    [anon_sym_inline] = ACTIONS(154),
    [anon_sym_const] = ACTIONS(158),
    [anon_sym_restrict] = ACTIONS(158),
    [anon_sym_volatile] = ACTIONS(158),
    [anon_sym__Atomic] = ACTIONS(158),
    [anon_sym_mutable] = ACTIONS(158),
    [anon_sym_explicit] = ACTIONS(158),
    [anon_sym_constexpr] = ACTIONS(158),
    [anon_sym_unsigned] = ACTIONS(31),
    [anon_sym_long] = ACTIONS(31),
    [anon_sym_short] = ACTIONS(31),
    [sym_primitive_type] = ACTIONS(33),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_union] = ACTIONS(39),
    [anon_sym_if] = ACTIONS(646),
    [anon_sym_switch] = ACTIONS(648),
    [anon_sym_case] = ACTIONS(650),
    [anon_sym_default] = ACTIONS(652),
    [anon_sym_while] = ACTIONS(654),
    [anon_sym_do] = ACTIONS(656),
    [anon_sym_for] = ACTIONS(658),
    [anon_sym_return] = ACTIONS(660),
    [anon_sym_break] = ACTIONS(662),
    [anon_sym_continue] = ACTIONS(664),
    [anon_sym_goto] = ACTIONS(666),
    [anon_sym_AMP] = ACTIONS(644),
    [anon_sym_BANG] = ACTIONS(668),
    [anon_sym_TILDE] = ACTIONS(670),
    [anon_sym_PLUS] = ACTIONS(672),
    [anon_sym_DASH] = ACTIONS(672),
    [anon_sym_DASH_DASH] = ACTIONS(674),
    [anon_sym_PLUS_PLUS] = ACTIONS(674),
    [anon_sym_sizeof] = ACTIONS(676),
    [sym_number_literal] = ACTIONS(620),
    [sym_char_literal] = ACTIONS(620),
    [sym_string_literal] = ACTIONS(678),
    [sym_true] = ACTIONS(680),
    [sym_false] = ACTIONS(680),
    [sym_null] = ACTIONS(680),
    [sym_identifier] = ACTIONS(682),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(51),
    [sym_auto] = ACTIONS(33),
    [anon_sym_typename] = ACTIONS(53),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(684),
    [anon_sym_delete] = ACTIONS(686),
    [sym_nullptr] = ACTIONS(680),
  },
  [389] = {
    [ts_builtin_sym_end] = ACTIONS(1622),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1624),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1624),
    [anon_sym_LPAREN] = ACTIONS(1622),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1624),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1624),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1624),
    [sym_preproc_directive] = ACTIONS(1624),
    [anon_sym_typedef] = ACTIONS(1624),
    [anon_sym_extern] = ACTIONS(1624),
    [anon_sym_RBRACE] = ACTIONS(1622),
    [anon_sym_STAR] = ACTIONS(1622),
    [anon_sym_static] = ACTIONS(1624),
    [anon_sym_register] = ACTIONS(1624),
    [anon_sym_inline] = ACTIONS(1624),
    [anon_sym_const] = ACTIONS(1624),
    [anon_sym_restrict] = ACTIONS(1624),
    [anon_sym_volatile] = ACTIONS(1624),
    [anon_sym__Atomic] = ACTIONS(1624),
    [anon_sym_mutable] = ACTIONS(1624),
    [anon_sym_explicit] = ACTIONS(1624),
    [anon_sym_constexpr] = ACTIONS(1624),
    [anon_sym_unsigned] = ACTIONS(1624),
    [anon_sym_long] = ACTIONS(1624),
    [anon_sym_short] = ACTIONS(1624),
    [sym_primitive_type] = ACTIONS(1624),
    [anon_sym_enum] = ACTIONS(1624),
    [anon_sym_struct] = ACTIONS(1624),
    [anon_sym_union] = ACTIONS(1624),
    [anon_sym_AMP] = ACTIONS(1624),
    [anon_sym_AMP_AMP] = ACTIONS(1622),
    [anon_sym_TILDE] = ACTIONS(1622),
    [sym_identifier] = ACTIONS(1624),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(1624),
    [sym_auto] = ACTIONS(1624),
    [anon_sym_typename] = ACTIONS(1624),
    [anon_sym_template] = ACTIONS(1624),
    [anon_sym_namespace] = ACTIONS(1624),
    [anon_sym_using] = ACTIONS(1624),
    [anon_sym_COLON_COLON] = ACTIONS(1622),
    [sym_operator_name] = ACTIONS(1622),
  },
  [390] = {
    [sym__expression] = STATE(727),
    [sym_conditional_expression] = STATE(727),
    [sym_assignment_expression] = STATE(727),
    [sym_pointer_expression] = STATE(727),
    [sym_logical_expression] = STATE(727),
    [sym_bitwise_expression] = STATE(727),
    [sym_equality_expression] = STATE(727),
    [sym_relational_expression] = STATE(727),
    [sym_shift_expression] = STATE(727),
    [sym_math_expression] = STATE(727),
    [sym_cast_expression] = STATE(727),
    [sym_sizeof_expression] = STATE(727),
    [sym_subscript_expression] = STATE(727),
    [sym_call_expression] = STATE(727),
    [sym_field_expression] = STATE(727),
    [sym_compound_literal_expression] = STATE(727),
    [sym_parenthesized_expression] = STATE(727),
    [sym_concatenated_string] = STATE(727),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(727),
    [sym_new_expression] = STATE(727),
    [sym_delete_expression] = STATE(727),
    [sym_lambda_expression] = STATE(727),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(1411),
    [anon_sym_LPAREN] = ACTIONS(626),
    [anon_sym_STAR] = ACTIONS(644),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_AMP] = ACTIONS(644),
    [anon_sym_BANG] = ACTIONS(668),
    [anon_sym_TILDE] = ACTIONS(670),
    [anon_sym_PLUS] = ACTIONS(672),
    [anon_sym_DASH] = ACTIONS(672),
    [anon_sym_DASH_DASH] = ACTIONS(674),
    [anon_sym_PLUS_PLUS] = ACTIONS(674),
    [anon_sym_sizeof] = ACTIONS(676),
    [sym_number_literal] = ACTIONS(1411),
    [sym_char_literal] = ACTIONS(1411),
    [sym_string_literal] = ACTIONS(678),
    [sym_true] = ACTIONS(1413),
    [sym_false] = ACTIONS(1413),
    [sym_null] = ACTIONS(1413),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1303),
    [anon_sym_delete] = ACTIONS(686),
    [sym_nullptr] = ACTIONS(1413),
  },
  [391] = {
    [anon_sym_LPAREN] = ACTIONS(1626),
    [anon_sym_constexpr] = ACTIONS(1628),
    [sym_comment] = ACTIONS(49),
  },
  [392] = {
    [anon_sym_LPAREN] = ACTIONS(1630),
    [sym_comment] = ACTIONS(49),
  },
  [393] = {
    [sym__expression] = STATE(854),
    [sym_conditional_expression] = STATE(854),
    [sym_assignment_expression] = STATE(854),
    [sym_pointer_expression] = STATE(854),
    [sym_logical_expression] = STATE(854),
    [sym_bitwise_expression] = STATE(854),
    [sym_equality_expression] = STATE(854),
    [sym_relational_expression] = STATE(854),
    [sym_shift_expression] = STATE(854),
    [sym_math_expression] = STATE(854),
    [sym_cast_expression] = STATE(854),
    [sym_sizeof_expression] = STATE(854),
    [sym_subscript_expression] = STATE(854),
    [sym_call_expression] = STATE(854),
    [sym_field_expression] = STATE(854),
    [sym_compound_literal_expression] = STATE(854),
    [sym_parenthesized_expression] = STATE(854),
    [sym_concatenated_string] = STATE(854),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(854),
    [sym_new_expression] = STATE(854),
    [sym_delete_expression] = STATE(854),
    [sym_lambda_expression] = STATE(854),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(855),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(1632),
    [anon_sym_LPAREN] = ACTIONS(1634),
    [anon_sym_STAR] = ACTIONS(1636),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_AMP] = ACTIONS(1636),
    [anon_sym_BANG] = ACTIONS(1638),
    [anon_sym_TILDE] = ACTIONS(1640),
    [anon_sym_PLUS] = ACTIONS(1642),
    [anon_sym_DASH] = ACTIONS(1642),
    [anon_sym_DASH_DASH] = ACTIONS(1644),
    [anon_sym_PLUS_PLUS] = ACTIONS(1644),
    [anon_sym_sizeof] = ACTIONS(1646),
    [sym_number_literal] = ACTIONS(1632),
    [sym_char_literal] = ACTIONS(1632),
    [sym_string_literal] = ACTIONS(1648),
    [sym_true] = ACTIONS(1650),
    [sym_false] = ACTIONS(1650),
    [sym_null] = ACTIONS(1650),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1652),
    [anon_sym_delete] = ACTIONS(1654),
    [sym_nullptr] = ACTIONS(1650),
  },
  [394] = {
    [anon_sym_COLON] = ACTIONS(1656),
    [sym_comment] = ACTIONS(49),
  },
  [395] = {
    [anon_sym_LPAREN] = ACTIONS(1658),
    [sym_comment] = ACTIONS(49),
  },
  [396] = {
    [sym_compound_statement] = STATE(872),
    [sym_labeled_statement] = STATE(872),
    [sym_expression_statement] = STATE(872),
    [sym_if_statement] = STATE(872),
    [sym_switch_statement] = STATE(872),
    [sym_case_statement] = STATE(872),
    [sym_while_statement] = STATE(872),
    [sym_do_statement] = STATE(872),
    [sym_for_statement] = STATE(872),
    [sym_return_statement] = STATE(872),
    [sym_break_statement] = STATE(872),
    [sym_continue_statement] = STATE(872),
    [sym_goto_statement] = STATE(872),
    [sym__expression] = STATE(873),
    [sym_comma_expression] = STATE(874),
    [sym_conditional_expression] = STATE(873),
    [sym_assignment_expression] = STATE(873),
    [sym_pointer_expression] = STATE(873),
    [sym_logical_expression] = STATE(873),
    [sym_bitwise_expression] = STATE(873),
    [sym_equality_expression] = STATE(873),
    [sym_relational_expression] = STATE(873),
    [sym_shift_expression] = STATE(873),
    [sym_math_expression] = STATE(873),
    [sym_cast_expression] = STATE(873),
    [sym_sizeof_expression] = STATE(873),
    [sym_subscript_expression] = STATE(873),
    [sym_call_expression] = STATE(873),
    [sym_field_expression] = STATE(873),
    [sym_compound_literal_expression] = STATE(873),
    [sym_parenthesized_expression] = STATE(873),
    [sym_concatenated_string] = STATE(873),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(873),
    [sym_for_range_loop] = STATE(872),
    [sym_new_expression] = STATE(873),
    [sym_delete_expression] = STATE(873),
    [sym_lambda_expression] = STATE(873),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(1660),
    [anon_sym_LPAREN] = ACTIONS(626),
    [anon_sym_SEMI] = ACTIONS(1662),
    [anon_sym_LBRACE] = ACTIONS(1664),
    [anon_sym_STAR] = ACTIONS(644),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_if] = ACTIONS(1666),
    [anon_sym_switch] = ACTIONS(1668),
    [anon_sym_case] = ACTIONS(1670),
    [anon_sym_default] = ACTIONS(1672),
    [anon_sym_while] = ACTIONS(1674),
    [anon_sym_do] = ACTIONS(1676),
    [anon_sym_for] = ACTIONS(1678),
    [anon_sym_return] = ACTIONS(1680),
    [anon_sym_break] = ACTIONS(1682),
    [anon_sym_continue] = ACTIONS(1684),
    [anon_sym_goto] = ACTIONS(1686),
    [anon_sym_AMP] = ACTIONS(644),
    [anon_sym_BANG] = ACTIONS(668),
    [anon_sym_TILDE] = ACTIONS(670),
    [anon_sym_PLUS] = ACTIONS(672),
    [anon_sym_DASH] = ACTIONS(672),
    [anon_sym_DASH_DASH] = ACTIONS(674),
    [anon_sym_PLUS_PLUS] = ACTIONS(674),
    [anon_sym_sizeof] = ACTIONS(676),
    [sym_number_literal] = ACTIONS(1660),
    [sym_char_literal] = ACTIONS(1660),
    [sym_string_literal] = ACTIONS(678),
    [sym_true] = ACTIONS(1688),
    [sym_false] = ACTIONS(1688),
    [sym_null] = ACTIONS(1688),
    [sym_identifier] = ACTIONS(1690),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1303),
    [anon_sym_delete] = ACTIONS(686),
    [sym_nullptr] = ACTIONS(1688),
  },
  [397] = {
    [anon_sym_LPAREN] = ACTIONS(1692),
    [sym_comment] = ACTIONS(49),
  },
  [398] = {
    [sym__expression] = STATE(877),
    [sym_conditional_expression] = STATE(877),
    [sym_assignment_expression] = STATE(877),
    [sym_pointer_expression] = STATE(877),
    [sym_logical_expression] = STATE(877),
    [sym_bitwise_expression] = STATE(877),
    [sym_equality_expression] = STATE(877),
    [sym_relational_expression] = STATE(877),
    [sym_shift_expression] = STATE(877),
    [sym_math_expression] = STATE(877),
    [sym_cast_expression] = STATE(877),
    [sym_sizeof_expression] = STATE(877),
    [sym_subscript_expression] = STATE(877),
    [sym_call_expression] = STATE(877),
    [sym_field_expression] = STATE(877),
    [sym_compound_literal_expression] = STATE(877),
    [sym_parenthesized_expression] = STATE(877),
    [sym_initializer_list] = STATE(878),
    [sym_concatenated_string] = STATE(877),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(877),
    [sym_new_expression] = STATE(877),
    [sym_delete_expression] = STATE(877),
    [sym_lambda_expression] = STATE(877),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(1694),
    [anon_sym_LPAREN] = ACTIONS(1347),
    [anon_sym_SEMI] = ACTIONS(1696),
    [anon_sym_LBRACE] = ACTIONS(548),
    [anon_sym_STAR] = ACTIONS(1349),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_AMP] = ACTIONS(1349),
    [anon_sym_BANG] = ACTIONS(1351),
    [anon_sym_TILDE] = ACTIONS(1353),
    [anon_sym_PLUS] = ACTIONS(1355),
    [anon_sym_DASH] = ACTIONS(1355),
    [anon_sym_DASH_DASH] = ACTIONS(1357),
    [anon_sym_PLUS_PLUS] = ACTIONS(1357),
    [anon_sym_sizeof] = ACTIONS(1359),
    [sym_number_literal] = ACTIONS(1694),
    [sym_char_literal] = ACTIONS(1694),
    [sym_string_literal] = ACTIONS(1361),
    [sym_true] = ACTIONS(1698),
    [sym_false] = ACTIONS(1698),
    [sym_null] = ACTIONS(1698),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1365),
    [anon_sym_delete] = ACTIONS(1367),
    [sym_nullptr] = ACTIONS(1698),
  },
  [399] = {
    [anon_sym_SEMI] = ACTIONS(1700),
    [sym_comment] = ACTIONS(49),
  },
  [400] = {
    [anon_sym_SEMI] = ACTIONS(1702),
    [sym_comment] = ACTIONS(49),
  },
  [401] = {
    [sym_identifier] = ACTIONS(1704),
    [sym_comment] = ACTIONS(49),
  },
  [402] = {
    [sym__expression] = STATE(757),
    [sym_conditional_expression] = STATE(757),
    [sym_assignment_expression] = STATE(757),
    [sym_pointer_expression] = STATE(757),
    [sym_logical_expression] = STATE(757),
    [sym_bitwise_expression] = STATE(757),
    [sym_equality_expression] = STATE(757),
    [sym_relational_expression] = STATE(757),
    [sym_shift_expression] = STATE(757),
    [sym_math_expression] = STATE(757),
    [sym_cast_expression] = STATE(757),
    [sym_sizeof_expression] = STATE(757),
    [sym_subscript_expression] = STATE(757),
    [sym_call_expression] = STATE(757),
    [sym_field_expression] = STATE(757),
    [sym_compound_literal_expression] = STATE(757),
    [sym_parenthesized_expression] = STATE(757),
    [sym_concatenated_string] = STATE(757),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(757),
    [sym_new_expression] = STATE(757),
    [sym_delete_expression] = STATE(757),
    [sym_lambda_expression] = STATE(757),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(1459),
    [anon_sym_LPAREN] = ACTIONS(626),
    [anon_sym_STAR] = ACTIONS(644),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_AMP] = ACTIONS(644),
    [anon_sym_BANG] = ACTIONS(668),
    [anon_sym_TILDE] = ACTIONS(670),
    [anon_sym_PLUS] = ACTIONS(672),
    [anon_sym_DASH] = ACTIONS(672),
    [anon_sym_DASH_DASH] = ACTIONS(674),
    [anon_sym_PLUS_PLUS] = ACTIONS(674),
    [anon_sym_sizeof] = ACTIONS(676),
    [sym_number_literal] = ACTIONS(1459),
    [sym_char_literal] = ACTIONS(1459),
    [sym_string_literal] = ACTIONS(678),
    [sym_true] = ACTIONS(1461),
    [sym_false] = ACTIONS(1461),
    [sym_null] = ACTIONS(1461),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1303),
    [anon_sym_delete] = ACTIONS(686),
    [sym_nullptr] = ACTIONS(1461),
  },
  [403] = {
    [sym__expression] = STATE(758),
    [sym_conditional_expression] = STATE(758),
    [sym_assignment_expression] = STATE(758),
    [sym_pointer_expression] = STATE(758),
    [sym_logical_expression] = STATE(758),
    [sym_bitwise_expression] = STATE(758),
    [sym_equality_expression] = STATE(758),
    [sym_relational_expression] = STATE(758),
    [sym_shift_expression] = STATE(758),
    [sym_math_expression] = STATE(758),
    [sym_cast_expression] = STATE(758),
    [sym_sizeof_expression] = STATE(758),
    [sym_subscript_expression] = STATE(758),
    [sym_call_expression] = STATE(758),
    [sym_field_expression] = STATE(758),
    [sym_compound_literal_expression] = STATE(758),
    [sym_parenthesized_expression] = STATE(758),
    [sym_concatenated_string] = STATE(758),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(758),
    [sym_new_expression] = STATE(758),
    [sym_delete_expression] = STATE(758),
    [sym_lambda_expression] = STATE(758),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(1463),
    [anon_sym_LPAREN] = ACTIONS(626),
    [anon_sym_STAR] = ACTIONS(644),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_AMP] = ACTIONS(644),
    [anon_sym_BANG] = ACTIONS(668),
    [anon_sym_TILDE] = ACTIONS(670),
    [anon_sym_PLUS] = ACTIONS(672),
    [anon_sym_DASH] = ACTIONS(672),
    [anon_sym_DASH_DASH] = ACTIONS(674),
    [anon_sym_PLUS_PLUS] = ACTIONS(674),
    [anon_sym_sizeof] = ACTIONS(676),
    [sym_number_literal] = ACTIONS(1463),
    [sym_char_literal] = ACTIONS(1463),
    [sym_string_literal] = ACTIONS(678),
    [sym_true] = ACTIONS(1465),
    [sym_false] = ACTIONS(1465),
    [sym_null] = ACTIONS(1465),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1303),
    [anon_sym_delete] = ACTIONS(686),
    [sym_nullptr] = ACTIONS(1465),
  },
  [404] = {
    [sym__expression] = STATE(759),
    [sym_conditional_expression] = STATE(759),
    [sym_assignment_expression] = STATE(759),
    [sym_pointer_expression] = STATE(759),
    [sym_logical_expression] = STATE(759),
    [sym_bitwise_expression] = STATE(759),
    [sym_equality_expression] = STATE(759),
    [sym_relational_expression] = STATE(759),
    [sym_shift_expression] = STATE(759),
    [sym_math_expression] = STATE(759),
    [sym_cast_expression] = STATE(759),
    [sym_sizeof_expression] = STATE(759),
    [sym_subscript_expression] = STATE(759),
    [sym_call_expression] = STATE(759),
    [sym_field_expression] = STATE(759),
    [sym_compound_literal_expression] = STATE(759),
    [sym_parenthesized_expression] = STATE(759),
    [sym_concatenated_string] = STATE(759),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(759),
    [sym_new_expression] = STATE(759),
    [sym_delete_expression] = STATE(759),
    [sym_lambda_expression] = STATE(759),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(1467),
    [anon_sym_LPAREN] = ACTIONS(626),
    [anon_sym_STAR] = ACTIONS(644),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_AMP] = ACTIONS(644),
    [anon_sym_BANG] = ACTIONS(668),
    [anon_sym_TILDE] = ACTIONS(670),
    [anon_sym_PLUS] = ACTIONS(672),
    [anon_sym_DASH] = ACTIONS(672),
    [anon_sym_DASH_DASH] = ACTIONS(674),
    [anon_sym_PLUS_PLUS] = ACTIONS(674),
    [anon_sym_sizeof] = ACTIONS(676),
    [sym_number_literal] = ACTIONS(1467),
    [sym_char_literal] = ACTIONS(1467),
    [sym_string_literal] = ACTIONS(678),
    [sym_true] = ACTIONS(1469),
    [sym_false] = ACTIONS(1469),
    [sym_null] = ACTIONS(1469),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1303),
    [anon_sym_delete] = ACTIONS(686),
    [sym_nullptr] = ACTIONS(1469),
  },
  [405] = {
    [sym__expression] = STATE(883),
    [sym_conditional_expression] = STATE(883),
    [sym_assignment_expression] = STATE(883),
    [sym_pointer_expression] = STATE(883),
    [sym_logical_expression] = STATE(883),
    [sym_bitwise_expression] = STATE(883),
    [sym_equality_expression] = STATE(883),
    [sym_relational_expression] = STATE(883),
    [sym_shift_expression] = STATE(883),
    [sym_math_expression] = STATE(883),
    [sym_cast_expression] = STATE(883),
    [sym_sizeof_expression] = STATE(883),
    [sym_subscript_expression] = STATE(883),
    [sym_call_expression] = STATE(883),
    [sym_field_expression] = STATE(883),
    [sym_compound_literal_expression] = STATE(883),
    [sym_parenthesized_expression] = STATE(883),
    [sym_concatenated_string] = STATE(883),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(883),
    [sym_new_expression] = STATE(883),
    [sym_delete_expression] = STATE(883),
    [sym_lambda_expression] = STATE(883),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(1706),
    [anon_sym_LPAREN] = ACTIONS(1708),
    [anon_sym_STAR] = ACTIONS(644),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_AMP] = ACTIONS(644),
    [anon_sym_BANG] = ACTIONS(668),
    [anon_sym_TILDE] = ACTIONS(670),
    [anon_sym_PLUS] = ACTIONS(672),
    [anon_sym_DASH] = ACTIONS(672),
    [anon_sym_DASH_DASH] = ACTIONS(674),
    [anon_sym_PLUS_PLUS] = ACTIONS(674),
    [anon_sym_sizeof] = ACTIONS(676),
    [sym_number_literal] = ACTIONS(1706),
    [sym_char_literal] = ACTIONS(1706),
    [sym_string_literal] = ACTIONS(678),
    [sym_true] = ACTIONS(1710),
    [sym_false] = ACTIONS(1710),
    [sym_null] = ACTIONS(1710),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1303),
    [anon_sym_delete] = ACTIONS(686),
    [sym_nullptr] = ACTIONS(1710),
  },
  [406] = {
    [aux_sym_concatenated_string_repeat1] = STATE(884),
    [anon_sym_LPAREN] = ACTIONS(1477),
    [anon_sym_COMMA] = ACTIONS(1477),
    [anon_sym_SEMI] = ACTIONS(1477),
    [anon_sym_STAR] = ACTIONS(1479),
    [anon_sym_LBRACK] = ACTIONS(1477),
    [anon_sym_EQ] = ACTIONS(1479),
    [anon_sym_QMARK] = ACTIONS(1477),
    [anon_sym_STAR_EQ] = ACTIONS(1477),
    [anon_sym_SLASH_EQ] = ACTIONS(1477),
    [anon_sym_PERCENT_EQ] = ACTIONS(1477),
    [anon_sym_PLUS_EQ] = ACTIONS(1477),
    [anon_sym_DASH_EQ] = ACTIONS(1477),
    [anon_sym_LT_LT_EQ] = ACTIONS(1477),
    [anon_sym_GT_GT_EQ] = ACTIONS(1477),
    [anon_sym_AMP_EQ] = ACTIONS(1477),
    [anon_sym_CARET_EQ] = ACTIONS(1477),
    [anon_sym_PIPE_EQ] = ACTIONS(1477),
    [anon_sym_AMP] = ACTIONS(1479),
    [anon_sym_PIPE_PIPE] = ACTIONS(1477),
    [anon_sym_AMP_AMP] = ACTIONS(1477),
    [anon_sym_PIPE] = ACTIONS(1479),
    [anon_sym_CARET] = ACTIONS(1479),
    [anon_sym_EQ_EQ] = ACTIONS(1477),
    [anon_sym_BANG_EQ] = ACTIONS(1477),
    [anon_sym_LT] = ACTIONS(1479),
    [anon_sym_GT] = ACTIONS(1479),
    [anon_sym_LT_EQ] = ACTIONS(1477),
    [anon_sym_GT_EQ] = ACTIONS(1477),
    [anon_sym_LT_LT] = ACTIONS(1479),
    [anon_sym_GT_GT] = ACTIONS(1479),
    [anon_sym_PLUS] = ACTIONS(1479),
    [anon_sym_DASH] = ACTIONS(1479),
    [anon_sym_SLASH] = ACTIONS(1479),
    [anon_sym_PERCENT] = ACTIONS(1479),
    [anon_sym_DASH_DASH] = ACTIONS(1477),
    [anon_sym_PLUS_PLUS] = ACTIONS(1477),
    [anon_sym_DOT] = ACTIONS(1477),
    [anon_sym_DASH_GT] = ACTIONS(1477),
    [sym_string_literal] = ACTIONS(1712),
    [sym_comment] = ACTIONS(49),
  },
  [407] = {
    [sym_initializer_list] = STATE(765),
    [sym_template_argument_list] = STATE(887),
    [anon_sym_LPAREN] = ACTIONS(1483),
    [anon_sym_COMMA] = ACTIONS(1477),
    [anon_sym_SEMI] = ACTIONS(1483),
    [anon_sym_extern] = ACTIONS(144),
    [anon_sym_LBRACE] = ACTIONS(548),
    [anon_sym_RBRACE] = ACTIONS(1477),
    [anon_sym_STAR] = ACTIONS(1486),
    [anon_sym_LBRACK] = ACTIONS(1483),
    [anon_sym_EQ] = ACTIONS(1479),
    [anon_sym_static] = ACTIONS(144),
    [anon_sym_register] = ACTIONS(144),
    [anon_sym_inline] = ACTIONS(144),
    [anon_sym_const] = ACTIONS(144),
    [anon_sym_restrict] = ACTIONS(144),
    [anon_sym_volatile] = ACTIONS(144),
    [anon_sym__Atomic] = ACTIONS(144),
    [anon_sym_mutable] = ACTIONS(144),
    [anon_sym_explicit] = ACTIONS(144),
    [anon_sym_constexpr] = ACTIONS(144),
    [anon_sym_COLON] = ACTIONS(1714),
    [anon_sym_QMARK] = ACTIONS(1477),
    [anon_sym_STAR_EQ] = ACTIONS(1477),
    [anon_sym_SLASH_EQ] = ACTIONS(1477),
    [anon_sym_PERCENT_EQ] = ACTIONS(1477),
    [anon_sym_PLUS_EQ] = ACTIONS(1477),
    [anon_sym_DASH_EQ] = ACTIONS(1477),
    [anon_sym_LT_LT_EQ] = ACTIONS(1477),
    [anon_sym_GT_GT_EQ] = ACTIONS(1477),
    [anon_sym_AMP_EQ] = ACTIONS(1477),
    [anon_sym_CARET_EQ] = ACTIONS(1477),
    [anon_sym_PIPE_EQ] = ACTIONS(1477),
    [anon_sym_AMP] = ACTIONS(1486),
    [anon_sym_PIPE_PIPE] = ACTIONS(1477),
    [anon_sym_AMP_AMP] = ACTIONS(1483),
    [anon_sym_PIPE] = ACTIONS(1479),
    [anon_sym_CARET] = ACTIONS(1479),
    [anon_sym_TILDE] = ACTIONS(142),
    [anon_sym_EQ_EQ] = ACTIONS(1477),
    [anon_sym_BANG_EQ] = ACTIONS(1477),
    [anon_sym_LT] = ACTIONS(1564),
    [anon_sym_GT] = ACTIONS(1479),
    [anon_sym_LT_EQ] = ACTIONS(1477),
    [anon_sym_GT_EQ] = ACTIONS(1477),
    [anon_sym_LT_LT] = ACTIONS(1479),
    [anon_sym_GT_GT] = ACTIONS(1479),
    [anon_sym_PLUS] = ACTIONS(1479),
    [anon_sym_DASH] = ACTIONS(1479),
    [anon_sym_SLASH] = ACTIONS(1479),
    [anon_sym_PERCENT] = ACTIONS(1479),
    [anon_sym_DASH_DASH] = ACTIONS(1477),
    [anon_sym_PLUS_PLUS] = ACTIONS(1477),
    [anon_sym_DOT] = ACTIONS(1477),
    [anon_sym_DASH_GT] = ACTIONS(1477),
    [sym_identifier] = ACTIONS(144),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(1716),
    [sym_operator_name] = ACTIONS(142),
  },
  [408] = {
    [sym_destructor_name] = STATE(120),
    [anon_sym_TILDE] = ACTIONS(1500),
    [sym_identifier] = ACTIONS(1718),
    [sym_comment] = ACTIONS(49),
    [anon_sym_delete] = ACTIONS(1720),
    [sym_operator_name] = ACTIONS(190),
  },
  [409] = {
    [sym__expression] = STATE(891),
    [sym_conditional_expression] = STATE(891),
    [sym_assignment_expression] = STATE(891),
    [sym_pointer_expression] = STATE(891),
    [sym_logical_expression] = STATE(891),
    [sym_bitwise_expression] = STATE(891),
    [sym_equality_expression] = STATE(891),
    [sym_relational_expression] = STATE(891),
    [sym_shift_expression] = STATE(891),
    [sym_math_expression] = STATE(891),
    [sym_cast_expression] = STATE(891),
    [sym_sizeof_expression] = STATE(891),
    [sym_subscript_expression] = STATE(891),
    [sym_call_expression] = STATE(891),
    [sym_field_expression] = STATE(891),
    [sym_compound_literal_expression] = STATE(891),
    [sym_parenthesized_expression] = STATE(891),
    [sym_concatenated_string] = STATE(891),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(891),
    [sym_new_expression] = STATE(891),
    [sym_delete_expression] = STATE(891),
    [sym_lambda_expression] = STATE(891),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(1722),
    [anon_sym_LPAREN] = ACTIONS(626),
    [anon_sym_STAR] = ACTIONS(644),
    [anon_sym_LBRACK] = ACTIONS(1724),
    [anon_sym_AMP] = ACTIONS(644),
    [anon_sym_BANG] = ACTIONS(668),
    [anon_sym_TILDE] = ACTIONS(670),
    [anon_sym_PLUS] = ACTIONS(672),
    [anon_sym_DASH] = ACTIONS(672),
    [anon_sym_DASH_DASH] = ACTIONS(674),
    [anon_sym_PLUS_PLUS] = ACTIONS(674),
    [anon_sym_sizeof] = ACTIONS(676),
    [sym_number_literal] = ACTIONS(1722),
    [sym_char_literal] = ACTIONS(1722),
    [sym_string_literal] = ACTIONS(678),
    [sym_true] = ACTIONS(1726),
    [sym_false] = ACTIONS(1726),
    [sym_null] = ACTIONS(1726),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1303),
    [anon_sym_delete] = ACTIONS(686),
    [sym_nullptr] = ACTIONS(1726),
  },
  [410] = {
    [sym_raw_string_literal] = ACTIONS(1728),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1730),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1730),
    [anon_sym_LPAREN] = ACTIONS(1728),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1730),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1730),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1730),
    [sym_preproc_directive] = ACTIONS(1730),
    [anon_sym_SEMI] = ACTIONS(1728),
    [anon_sym_typedef] = ACTIONS(1730),
    [anon_sym_extern] = ACTIONS(1730),
    [anon_sym_LBRACE] = ACTIONS(1728),
    [anon_sym_RBRACE] = ACTIONS(1728),
    [anon_sym_STAR] = ACTIONS(1728),
    [anon_sym_LBRACK] = ACTIONS(1728),
    [anon_sym_static] = ACTIONS(1730),
    [anon_sym_register] = ACTIONS(1730),
    [anon_sym_inline] = ACTIONS(1730),
    [anon_sym_const] = ACTIONS(1730),
    [anon_sym_restrict] = ACTIONS(1730),
    [anon_sym_volatile] = ACTIONS(1730),
    [anon_sym__Atomic] = ACTIONS(1730),
    [anon_sym_mutable] = ACTIONS(1730),
    [anon_sym_explicit] = ACTIONS(1730),
    [anon_sym_constexpr] = ACTIONS(1730),
    [anon_sym_unsigned] = ACTIONS(1730),
    [anon_sym_long] = ACTIONS(1730),
    [anon_sym_short] = ACTIONS(1730),
    [sym_primitive_type] = ACTIONS(1730),
    [anon_sym_enum] = ACTIONS(1730),
    [anon_sym_struct] = ACTIONS(1730),
    [anon_sym_union] = ACTIONS(1730),
    [anon_sym_if] = ACTIONS(1730),
    [anon_sym_switch] = ACTIONS(1730),
    [anon_sym_case] = ACTIONS(1730),
    [anon_sym_default] = ACTIONS(1730),
    [anon_sym_while] = ACTIONS(1730),
    [anon_sym_do] = ACTIONS(1730),
    [anon_sym_for] = ACTIONS(1730),
    [anon_sym_return] = ACTIONS(1730),
    [anon_sym_break] = ACTIONS(1730),
    [anon_sym_continue] = ACTIONS(1730),
    [anon_sym_goto] = ACTIONS(1730),
    [anon_sym_AMP] = ACTIONS(1728),
    [anon_sym_BANG] = ACTIONS(1728),
    [anon_sym_TILDE] = ACTIONS(1728),
    [anon_sym_PLUS] = ACTIONS(1730),
    [anon_sym_DASH] = ACTIONS(1730),
    [anon_sym_DASH_DASH] = ACTIONS(1728),
    [anon_sym_PLUS_PLUS] = ACTIONS(1728),
    [anon_sym_sizeof] = ACTIONS(1730),
    [sym_number_literal] = ACTIONS(1728),
    [sym_char_literal] = ACTIONS(1728),
    [sym_string_literal] = ACTIONS(1728),
    [sym_true] = ACTIONS(1730),
    [sym_false] = ACTIONS(1730),
    [sym_null] = ACTIONS(1730),
    [sym_identifier] = ACTIONS(1730),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(1730),
    [sym_auto] = ACTIONS(1730),
    [anon_sym_typename] = ACTIONS(1730),
    [anon_sym_new] = ACTIONS(1730),
    [anon_sym_COLON_COLON] = ACTIONS(1728),
    [anon_sym_delete] = ACTIONS(1730),
    [sym_nullptr] = ACTIONS(1730),
  },
  [411] = {
    [sym_raw_string_literal] = ACTIONS(1732),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1734),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1734),
    [anon_sym_LPAREN] = ACTIONS(1732),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1734),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1734),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1734),
    [sym_preproc_directive] = ACTIONS(1734),
    [anon_sym_SEMI] = ACTIONS(1732),
    [anon_sym_typedef] = ACTIONS(1734),
    [anon_sym_extern] = ACTIONS(1734),
    [anon_sym_LBRACE] = ACTIONS(1732),
    [anon_sym_RBRACE] = ACTIONS(1732),
    [anon_sym_STAR] = ACTIONS(1732),
    [anon_sym_LBRACK] = ACTIONS(1732),
    [anon_sym_static] = ACTIONS(1734),
    [anon_sym_register] = ACTIONS(1734),
    [anon_sym_inline] = ACTIONS(1734),
    [anon_sym_const] = ACTIONS(1734),
    [anon_sym_restrict] = ACTIONS(1734),
    [anon_sym_volatile] = ACTIONS(1734),
    [anon_sym__Atomic] = ACTIONS(1734),
    [anon_sym_mutable] = ACTIONS(1734),
    [anon_sym_explicit] = ACTIONS(1734),
    [anon_sym_constexpr] = ACTIONS(1734),
    [anon_sym_unsigned] = ACTIONS(1734),
    [anon_sym_long] = ACTIONS(1734),
    [anon_sym_short] = ACTIONS(1734),
    [sym_primitive_type] = ACTIONS(1734),
    [anon_sym_enum] = ACTIONS(1734),
    [anon_sym_struct] = ACTIONS(1734),
    [anon_sym_union] = ACTIONS(1734),
    [anon_sym_if] = ACTIONS(1734),
    [anon_sym_switch] = ACTIONS(1734),
    [anon_sym_case] = ACTIONS(1734),
    [anon_sym_default] = ACTIONS(1734),
    [anon_sym_while] = ACTIONS(1734),
    [anon_sym_do] = ACTIONS(1734),
    [anon_sym_for] = ACTIONS(1734),
    [anon_sym_return] = ACTIONS(1734),
    [anon_sym_break] = ACTIONS(1734),
    [anon_sym_continue] = ACTIONS(1734),
    [anon_sym_goto] = ACTIONS(1734),
    [anon_sym_AMP] = ACTIONS(1732),
    [anon_sym_BANG] = ACTIONS(1732),
    [anon_sym_TILDE] = ACTIONS(1732),
    [anon_sym_PLUS] = ACTIONS(1734),
    [anon_sym_DASH] = ACTIONS(1734),
    [anon_sym_DASH_DASH] = ACTIONS(1732),
    [anon_sym_PLUS_PLUS] = ACTIONS(1732),
    [anon_sym_sizeof] = ACTIONS(1734),
    [sym_number_literal] = ACTIONS(1732),
    [sym_char_literal] = ACTIONS(1732),
    [sym_string_literal] = ACTIONS(1732),
    [sym_true] = ACTIONS(1734),
    [sym_false] = ACTIONS(1734),
    [sym_null] = ACTIONS(1734),
    [sym_identifier] = ACTIONS(1734),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(1734),
    [sym_auto] = ACTIONS(1734),
    [anon_sym_typename] = ACTIONS(1734),
    [anon_sym_new] = ACTIONS(1734),
    [anon_sym_COLON_COLON] = ACTIONS(1732),
    [anon_sym_delete] = ACTIONS(1734),
    [sym_nullptr] = ACTIONS(1734),
  },
  [412] = {
    [sym__declarator] = STATE(893),
    [sym_pointer_declarator] = STATE(893),
    [sym_function_declarator] = STATE(893),
    [sym_array_declarator] = STATE(893),
    [sym_init_declarator] = STATE(894),
    [sym_reference_declarator] = STATE(893),
    [sym_structured_binding_reference_declarator] = STATE(895),
    [sym_structured_binding_declarator] = STATE(896),
    [sym_template_type] = STATE(46),
    [sym_template_function] = STATE(893),
    [sym_destructor_name] = STATE(893),
    [sym_scoped_identifier] = STATE(33),
    [sym_scoped_type_identifier] = STATE(47),
    [sym_scoped_namespace_identifier] = STATE(46),
    [anon_sym_LPAREN] = ACTIONS(11),
    [anon_sym_SEMI] = ACTIONS(1736),
    [anon_sym_STAR] = ACTIONS(196),
    [anon_sym_LBRACK] = ACTIONS(198),
    [anon_sym_AMP] = ACTIONS(200),
    [anon_sym_AMP_AMP] = ACTIONS(202),
    [anon_sym_TILDE] = ACTIONS(45),
    [sym_identifier] = ACTIONS(75),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(77),
    [sym_operator_name] = ACTIONS(1738),
  },
  [413] = {
    [sym_argument_list] = STATE(802),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_COMMA] = ACTIONS(1740),
    [anon_sym_SEMI] = ACTIONS(1742),
    [anon_sym_STAR] = ACTIONS(1744),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_EQ] = ACTIONS(1746),
    [anon_sym_QMARK] = ACTIONS(1748),
    [anon_sym_STAR_EQ] = ACTIONS(1750),
    [anon_sym_SLASH_EQ] = ACTIONS(1750),
    [anon_sym_PERCENT_EQ] = ACTIONS(1750),
    [anon_sym_PLUS_EQ] = ACTIONS(1750),
    [anon_sym_DASH_EQ] = ACTIONS(1750),
    [anon_sym_LT_LT_EQ] = ACTIONS(1750),
    [anon_sym_GT_GT_EQ] = ACTIONS(1750),
    [anon_sym_AMP_EQ] = ACTIONS(1750),
    [anon_sym_CARET_EQ] = ACTIONS(1750),
    [anon_sym_PIPE_EQ] = ACTIONS(1750),
    [anon_sym_AMP] = ACTIONS(1752),
    [anon_sym_PIPE_PIPE] = ACTIONS(1754),
    [anon_sym_AMP_AMP] = ACTIONS(1756),
    [anon_sym_PIPE] = ACTIONS(1758),
    [anon_sym_CARET] = ACTIONS(1760),
    [anon_sym_EQ_EQ] = ACTIONS(1762),
    [anon_sym_BANG_EQ] = ACTIONS(1762),
    [anon_sym_LT] = ACTIONS(1764),
    [anon_sym_GT] = ACTIONS(1764),
    [anon_sym_LT_EQ] = ACTIONS(1766),
    [anon_sym_GT_EQ] = ACTIONS(1766),
    [anon_sym_LT_LT] = ACTIONS(1768),
    [anon_sym_GT_GT] = ACTIONS(1768),
    [anon_sym_PLUS] = ACTIONS(1770),
    [anon_sym_DASH] = ACTIONS(1770),
    [anon_sym_SLASH] = ACTIONS(1744),
    [anon_sym_PERCENT] = ACTIONS(1744),
    [anon_sym_DASH_DASH] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(1554),
    [anon_sym_DASH_GT] = ACTIONS(1554),
    [sym_comment] = ACTIONS(49),
  },
  [414] = {
    [anon_sym_SEMI] = ACTIONS(1742),
    [sym_comment] = ACTIONS(49),
  },
  [415] = {
    [sym_initializer_list] = STATE(804),
    [anon_sym_LPAREN] = ACTIONS(228),
    [anon_sym_RPAREN] = ACTIONS(228),
    [anon_sym_SEMI] = ACTIONS(228),
    [anon_sym_extern] = ACTIONS(230),
    [anon_sym_LBRACE] = ACTIONS(548),
    [anon_sym_STAR] = ACTIONS(228),
    [anon_sym_LBRACK] = ACTIONS(228),
    [anon_sym_static] = ACTIONS(230),
    [anon_sym_register] = ACTIONS(230),
    [anon_sym_inline] = ACTIONS(230),
    [anon_sym_const] = ACTIONS(230),
    [anon_sym_restrict] = ACTIONS(230),
    [anon_sym_volatile] = ACTIONS(230),
    [anon_sym__Atomic] = ACTIONS(230),
    [anon_sym_mutable] = ACTIONS(230),
    [anon_sym_explicit] = ACTIONS(230),
    [anon_sym_constexpr] = ACTIONS(230),
    [anon_sym_AMP] = ACTIONS(230),
    [anon_sym_AMP_AMP] = ACTIONS(228),
    [anon_sym_TILDE] = ACTIONS(228),
    [sym_identifier] = ACTIONS(230),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(1772),
    [sym_operator_name] = ACTIONS(228),
  },
  [416] = {
    [sym_initializer_list] = STATE(804),
    [sym_template_argument_list] = STATE(141),
    [anon_sym_LPAREN] = ACTIONS(228),
    [anon_sym_COMMA] = ACTIONS(228),
    [anon_sym_RPAREN] = ACTIONS(228),
    [anon_sym_SEMI] = ACTIONS(228),
    [anon_sym_extern] = ACTIONS(230),
    [anon_sym_LBRACE] = ACTIONS(548),
    [anon_sym_STAR] = ACTIONS(228),
    [anon_sym_LBRACK] = ACTIONS(228),
    [anon_sym_static] = ACTIONS(230),
    [anon_sym_register] = ACTIONS(230),
    [anon_sym_inline] = ACTIONS(230),
    [anon_sym_const] = ACTIONS(230),
    [anon_sym_restrict] = ACTIONS(230),
    [anon_sym_volatile] = ACTIONS(230),
    [anon_sym__Atomic] = ACTIONS(230),
    [anon_sym_mutable] = ACTIONS(230),
    [anon_sym_explicit] = ACTIONS(230),
    [anon_sym_constexpr] = ACTIONS(230),
    [anon_sym_AMP] = ACTIONS(230),
    [anon_sym_AMP_AMP] = ACTIONS(228),
    [anon_sym_TILDE] = ACTIONS(228),
    [anon_sym_LT] = ACTIONS(146),
    [sym_identifier] = ACTIONS(230),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(228),
    [sym_operator_name] = ACTIONS(228),
  },
  [417] = {
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(1772),
  },
  [418] = {
    [sym_preproc_include] = STATE(913),
    [sym_preproc_def] = STATE(913),
    [sym_preproc_function_def] = STATE(913),
    [sym_preproc_call] = STATE(913),
    [sym_preproc_if_in_compound_statement] = STATE(410),
    [sym_preproc_ifdef_in_compound_statement] = STATE(411),
    [sym_declaration] = STATE(913),
    [sym_type_definition] = STATE(913),
    [sym__declaration_specifiers] = STATE(412),
    [sym_compound_statement] = STATE(913),
    [sym_storage_class_specifier] = STATE(419),
    [sym_type_qualifier] = STATE(419),
    [sym__type_specifier] = STATE(30),
    [sym_sized_type_specifier] = STATE(30),
    [sym_enum_specifier] = STATE(30),
    [sym_struct_specifier] = STATE(30),
    [sym_union_specifier] = STATE(30),
    [sym_labeled_statement] = STATE(913),
    [sym_expression_statement] = STATE(913),
    [sym_if_statement] = STATE(913),
    [sym_switch_statement] = STATE(913),
    [sym_case_statement] = STATE(913),
    [sym_while_statement] = STATE(913),
    [sym_do_statement] = STATE(913),
    [sym_for_statement] = STATE(913),
    [sym_return_statement] = STATE(913),
    [sym_break_statement] = STATE(913),
    [sym_continue_statement] = STATE(913),
    [sym_goto_statement] = STATE(913),
    [sym__expression] = STATE(413),
    [sym_comma_expression] = STATE(414),
    [sym_conditional_expression] = STATE(413),
    [sym_assignment_expression] = STATE(413),
    [sym_pointer_expression] = STATE(413),
    [sym_logical_expression] = STATE(413),
    [sym_bitwise_expression] = STATE(413),
    [sym_equality_expression] = STATE(413),
    [sym_relational_expression] = STATE(413),
    [sym_shift_expression] = STATE(413),
    [sym_math_expression] = STATE(413),
    [sym_cast_expression] = STATE(413),
    [sym_sizeof_expression] = STATE(413),
    [sym_subscript_expression] = STATE(413),
    [sym_call_expression] = STATE(413),
    [sym_field_expression] = STATE(413),
    [sym_compound_literal_expression] = STATE(413),
    [sym_parenthesized_expression] = STATE(413),
    [sym_concatenated_string] = STATE(413),
    [sym__empty_declaration] = STATE(913),
    [sym_macro_type_specifier] = STATE(30),
    [sym_class_specifier] = STATE(30),
    [sym_dependent_type] = STATE(30),
    [sym_structured_binding_declaration] = STATE(913),
    [sym_template_type] = STATE(415),
    [sym_template_function] = STATE(413),
    [sym_for_range_loop] = STATE(913),
    [sym_new_expression] = STATE(413),
    [sym_delete_expression] = STATE(413),
    [sym_lambda_expression] = STATE(413),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(416),
    [sym_scoped_namespace_identifier] = STATE(417),
    [aux_sym_preproc_if_in_compound_statement_repeat1] = STATE(913),
    [aux_sym__declaration_specifiers_repeat1] = STATE(419),
    [aux_sym_sized_type_specifier_repeat1] = STATE(38),
    [sym_raw_string_literal] = ACTIONS(620),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(622),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(624),
    [anon_sym_LPAREN] = ACTIONS(626),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(628),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(630),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(632),
    [sym_preproc_directive] = ACTIONS(634),
    [anon_sym_SEMI] = ACTIONS(636),
    [anon_sym_typedef] = ACTIONS(638),
    [anon_sym_extern] = ACTIONS(154),
    [anon_sym_LBRACE] = ACTIONS(640),
    [anon_sym_RBRACE] = ACTIONS(1774),
    [anon_sym_STAR] = ACTIONS(644),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_static] = ACTIONS(154),
    [anon_sym_register] = ACTIONS(154),
    [anon_sym_inline] = ACTIONS(154),
    [anon_sym_const] = ACTIONS(158),
    [anon_sym_restrict] = ACTIONS(158),
    [anon_sym_volatile] = ACTIONS(158),
    [anon_sym__Atomic] = ACTIONS(158),
    [anon_sym_mutable] = ACTIONS(158),
    [anon_sym_explicit] = ACTIONS(158),
    [anon_sym_constexpr] = ACTIONS(158),
    [anon_sym_unsigned] = ACTIONS(31),
    [anon_sym_long] = ACTIONS(31),
    [anon_sym_short] = ACTIONS(31),
    [sym_primitive_type] = ACTIONS(33),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_union] = ACTIONS(39),
    [anon_sym_if] = ACTIONS(646),
    [anon_sym_switch] = ACTIONS(648),
    [anon_sym_case] = ACTIONS(650),
    [anon_sym_default] = ACTIONS(652),
    [anon_sym_while] = ACTIONS(654),
    [anon_sym_do] = ACTIONS(656),
    [anon_sym_for] = ACTIONS(658),
    [anon_sym_return] = ACTIONS(660),
    [anon_sym_break] = ACTIONS(662),
    [anon_sym_continue] = ACTIONS(664),
    [anon_sym_goto] = ACTIONS(666),
    [anon_sym_AMP] = ACTIONS(644),
    [anon_sym_BANG] = ACTIONS(668),
    [anon_sym_TILDE] = ACTIONS(670),
    [anon_sym_PLUS] = ACTIONS(672),
    [anon_sym_DASH] = ACTIONS(672),
    [anon_sym_DASH_DASH] = ACTIONS(674),
    [anon_sym_PLUS_PLUS] = ACTIONS(674),
    [anon_sym_sizeof] = ACTIONS(676),
    [sym_number_literal] = ACTIONS(620),
    [sym_char_literal] = ACTIONS(620),
    [sym_string_literal] = ACTIONS(678),
    [sym_true] = ACTIONS(680),
    [sym_false] = ACTIONS(680),
    [sym_null] = ACTIONS(680),
    [sym_identifier] = ACTIONS(682),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(51),
    [sym_auto] = ACTIONS(33),
    [anon_sym_typename] = ACTIONS(53),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(684),
    [anon_sym_delete] = ACTIONS(686),
    [sym_nullptr] = ACTIONS(680),
  },
  [419] = {
    [sym_storage_class_specifier] = STATE(309),
    [sym_type_qualifier] = STATE(309),
    [sym__type_specifier] = STATE(144),
    [sym_sized_type_specifier] = STATE(144),
    [sym_enum_specifier] = STATE(144),
    [sym_struct_specifier] = STATE(144),
    [sym_union_specifier] = STATE(144),
    [sym_macro_type_specifier] = STATE(144),
    [sym_class_specifier] = STATE(144),
    [sym_dependent_type] = STATE(144),
    [sym_template_type] = STATE(94),
    [sym_scoped_type_identifier] = STATE(34),
    [sym_scoped_namespace_identifier] = STATE(81),
    [aux_sym__declaration_specifiers_repeat1] = STATE(309),
    [aux_sym_sized_type_specifier_repeat1] = STATE(38),
    [anon_sym_extern] = ACTIONS(154),
    [anon_sym_static] = ACTIONS(154),
    [anon_sym_register] = ACTIONS(154),
    [anon_sym_inline] = ACTIONS(154),
    [anon_sym_const] = ACTIONS(158),
    [anon_sym_restrict] = ACTIONS(158),
    [anon_sym_volatile] = ACTIONS(158),
    [anon_sym__Atomic] = ACTIONS(158),
    [anon_sym_mutable] = ACTIONS(158),
    [anon_sym_explicit] = ACTIONS(158),
    [anon_sym_constexpr] = ACTIONS(158),
    [anon_sym_unsigned] = ACTIONS(31),
    [anon_sym_long] = ACTIONS(31),
    [anon_sym_short] = ACTIONS(31),
    [sym_primitive_type] = ACTIONS(236),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_union] = ACTIONS(39),
    [sym_identifier] = ACTIONS(152),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(51),
    [sym_auto] = ACTIONS(236),
    [anon_sym_typename] = ACTIONS(53),
    [anon_sym_COLON_COLON] = ACTIONS(135),
  },
  [420] = {
    [sym_argument_list] = STATE(915),
    [sym_initializer_list] = STATE(915),
    [sym_template_argument_list] = STATE(203),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_LBRACE] = ACTIONS(548),
    [anon_sym_LT] = ACTIONS(146),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(1776),
  },
  [421] = {
    [sym_destructor_name] = STATE(917),
    [anon_sym_TILDE] = ACTIONS(45),
    [sym_identifier] = ACTIONS(1778),
    [sym_comment] = ACTIONS(49),
    [sym_operator_name] = ACTIONS(1780),
  },
  [422] = {
    [aux_sym_field_initializer_list_repeat1] = STATE(919),
    [anon_sym_COMMA] = ACTIONS(1782),
    [anon_sym_LBRACE] = ACTIONS(1784),
    [sym_comment] = ACTIONS(49),
  },
  [423] = {
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(1786),
  },
  [424] = {
    [sym_argument_list] = STATE(921),
    [sym_initializer_list] = STATE(921),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_LBRACE] = ACTIONS(548),
    [sym_comment] = ACTIONS(49),
  },
  [425] = {
    [ts_builtin_sym_end] = ACTIONS(1788),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1790),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1790),
    [anon_sym_LPAREN] = ACTIONS(1788),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1790),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1790),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1790),
    [sym_preproc_directive] = ACTIONS(1790),
    [anon_sym_typedef] = ACTIONS(1790),
    [anon_sym_extern] = ACTIONS(1790),
    [anon_sym_RBRACE] = ACTIONS(1788),
    [anon_sym_STAR] = ACTIONS(1788),
    [anon_sym_static] = ACTIONS(1790),
    [anon_sym_register] = ACTIONS(1790),
    [anon_sym_inline] = ACTIONS(1790),
    [anon_sym_const] = ACTIONS(1790),
    [anon_sym_restrict] = ACTIONS(1790),
    [anon_sym_volatile] = ACTIONS(1790),
    [anon_sym__Atomic] = ACTIONS(1790),
    [anon_sym_mutable] = ACTIONS(1790),
    [anon_sym_explicit] = ACTIONS(1790),
    [anon_sym_constexpr] = ACTIONS(1790),
    [anon_sym_unsigned] = ACTIONS(1790),
    [anon_sym_long] = ACTIONS(1790),
    [anon_sym_short] = ACTIONS(1790),
    [sym_primitive_type] = ACTIONS(1790),
    [anon_sym_enum] = ACTIONS(1790),
    [anon_sym_struct] = ACTIONS(1790),
    [anon_sym_union] = ACTIONS(1790),
    [anon_sym_AMP] = ACTIONS(1790),
    [anon_sym_AMP_AMP] = ACTIONS(1788),
    [anon_sym_TILDE] = ACTIONS(1788),
    [sym_identifier] = ACTIONS(1790),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(1790),
    [sym_auto] = ACTIONS(1790),
    [anon_sym_typename] = ACTIONS(1790),
    [anon_sym_template] = ACTIONS(1790),
    [anon_sym_namespace] = ACTIONS(1790),
    [anon_sym_using] = ACTIONS(1790),
    [anon_sym_COLON_COLON] = ACTIONS(1788),
    [sym_operator_name] = ACTIONS(1788),
  },
  [426] = {
    [sym_storage_class_specifier] = STATE(426),
    [sym_type_qualifier] = STATE(426),
    [aux_sym__declaration_specifiers_repeat1] = STATE(426),
    [anon_sym_LPAREN] = ACTIONS(798),
    [anon_sym_SEMI] = ACTIONS(798),
    [anon_sym_extern] = ACTIONS(1792),
    [anon_sym_STAR] = ACTIONS(798),
    [anon_sym_LBRACK] = ACTIONS(798),
    [anon_sym_static] = ACTIONS(1792),
    [anon_sym_register] = ACTIONS(1792),
    [anon_sym_inline] = ACTIONS(1792),
    [anon_sym_const] = ACTIONS(1795),
    [anon_sym_restrict] = ACTIONS(1795),
    [anon_sym_volatile] = ACTIONS(1795),
    [anon_sym__Atomic] = ACTIONS(1795),
    [anon_sym_mutable] = ACTIONS(1795),
    [anon_sym_explicit] = ACTIONS(1795),
    [anon_sym_constexpr] = ACTIONS(1795),
    [anon_sym_AMP] = ACTIONS(806),
    [anon_sym_AMP_AMP] = ACTIONS(798),
    [anon_sym_TILDE] = ACTIONS(798),
    [sym_identifier] = ACTIONS(806),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(798),
    [sym_operator_name] = ACTIONS(798),
  },
  [427] = {
    [anon_sym_LPAREN] = ACTIONS(1798),
    [anon_sym_COMMA] = ACTIONS(1801),
    [anon_sym_RPAREN] = ACTIONS(1798),
    [anon_sym_SEMI] = ACTIONS(1801),
    [anon_sym_extern] = ACTIONS(1803),
    [anon_sym_STAR] = ACTIONS(1801),
    [anon_sym_LBRACK] = ACTIONS(1798),
    [anon_sym_static] = ACTIONS(1803),
    [anon_sym_register] = ACTIONS(1803),
    [anon_sym_inline] = ACTIONS(1803),
    [anon_sym_const] = ACTIONS(1803),
    [anon_sym_restrict] = ACTIONS(1803),
    [anon_sym_volatile] = ACTIONS(1803),
    [anon_sym__Atomic] = ACTIONS(1803),
    [anon_sym_mutable] = ACTIONS(1803),
    [anon_sym_explicit] = ACTIONS(1803),
    [anon_sym_constexpr] = ACTIONS(1803),
    [anon_sym_AMP] = ACTIONS(1803),
    [anon_sym_AMP_AMP] = ACTIONS(1801),
    [anon_sym_TILDE] = ACTIONS(1801),
    [anon_sym_LT] = ACTIONS(1798),
    [sym_identifier] = ACTIONS(1803),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(1805),
    [sym_operator_name] = ACTIONS(1801),
  },
  [428] = {
    [anon_sym_LPAREN] = ACTIONS(1807),
    [anon_sym_COMMA] = ACTIONS(1807),
    [anon_sym_RPAREN] = ACTIONS(1807),
    [anon_sym_SEMI] = ACTIONS(1807),
    [anon_sym_LBRACE] = ACTIONS(1807),
    [anon_sym_RBRACE] = ACTIONS(1807),
    [anon_sym_STAR] = ACTIONS(1809),
    [anon_sym_LBRACK] = ACTIONS(1807),
    [anon_sym_RBRACK] = ACTIONS(1807),
    [anon_sym_EQ] = ACTIONS(1809),
    [anon_sym_COLON] = ACTIONS(1807),
    [anon_sym_QMARK] = ACTIONS(1807),
    [anon_sym_STAR_EQ] = ACTIONS(1807),
    [anon_sym_SLASH_EQ] = ACTIONS(1807),
    [anon_sym_PERCENT_EQ] = ACTIONS(1807),
    [anon_sym_PLUS_EQ] = ACTIONS(1807),
    [anon_sym_DASH_EQ] = ACTIONS(1807),
    [anon_sym_LT_LT_EQ] = ACTIONS(1807),
    [anon_sym_GT_GT_EQ] = ACTIONS(1807),
    [anon_sym_AMP_EQ] = ACTIONS(1807),
    [anon_sym_CARET_EQ] = ACTIONS(1807),
    [anon_sym_PIPE_EQ] = ACTIONS(1807),
    [anon_sym_AMP] = ACTIONS(1809),
    [anon_sym_PIPE_PIPE] = ACTIONS(1807),
    [anon_sym_AMP_AMP] = ACTIONS(1807),
    [anon_sym_PIPE] = ACTIONS(1809),
    [anon_sym_CARET] = ACTIONS(1809),
    [anon_sym_EQ_EQ] = ACTIONS(1807),
    [anon_sym_BANG_EQ] = ACTIONS(1807),
    [anon_sym_LT] = ACTIONS(1809),
    [anon_sym_GT] = ACTIONS(1809),
    [anon_sym_LT_EQ] = ACTIONS(1807),
    [anon_sym_GT_EQ] = ACTIONS(1807),
    [anon_sym_LT_LT] = ACTIONS(1809),
    [anon_sym_GT_GT] = ACTIONS(1809),
    [anon_sym_PLUS] = ACTIONS(1809),
    [anon_sym_DASH] = ACTIONS(1809),
    [anon_sym_SLASH] = ACTIONS(1809),
    [anon_sym_PERCENT] = ACTIONS(1809),
    [anon_sym_DASH_DASH] = ACTIONS(1807),
    [anon_sym_PLUS_PLUS] = ACTIONS(1807),
    [anon_sym_DOT] = ACTIONS(1807),
    [anon_sym_DASH_GT] = ACTIONS(1807),
    [sym_comment] = ACTIONS(49),
  },
  [429] = {
    [sym_compound_statement] = STATE(922),
    [anon_sym_LBRACE] = ACTIONS(212),
    [sym_comment] = ACTIONS(49),
  },
  [430] = {
    [sym_storage_class_specifier] = STATE(426),
    [sym_type_qualifier] = STATE(426),
    [aux_sym__declaration_specifiers_repeat1] = STATE(426),
    [anon_sym_LPAREN] = ACTIONS(1811),
    [anon_sym_SEMI] = ACTIONS(1811),
    [anon_sym_extern] = ACTIONS(218),
    [anon_sym_STAR] = ACTIONS(1811),
    [anon_sym_LBRACK] = ACTIONS(1811),
    [anon_sym_static] = ACTIONS(218),
    [anon_sym_register] = ACTIONS(218),
    [anon_sym_inline] = ACTIONS(218),
    [anon_sym_const] = ACTIONS(220),
    [anon_sym_restrict] = ACTIONS(220),
    [anon_sym_volatile] = ACTIONS(220),
    [anon_sym__Atomic] = ACTIONS(220),
    [anon_sym_mutable] = ACTIONS(220),
    [anon_sym_explicit] = ACTIONS(220),
    [anon_sym_constexpr] = ACTIONS(220),
    [anon_sym_AMP] = ACTIONS(1813),
    [anon_sym_AMP_AMP] = ACTIONS(1811),
    [anon_sym_TILDE] = ACTIONS(1811),
    [sym_identifier] = ACTIONS(1813),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(1811),
    [sym_operator_name] = ACTIONS(1811),
  },
  [431] = {
    [anon_sym_LF] = ACTIONS(1815),
    [sym_comment] = ACTIONS(83),
  },
  [432] = {
    [aux_sym_preproc_params_repeat1] = STATE(926),
    [anon_sym_COMMA] = ACTIONS(1817),
    [anon_sym_RPAREN] = ACTIONS(1819),
    [sym_comment] = ACTIONS(49),
  },
  [433] = {
    [anon_sym_LF] = ACTIONS(1821),
    [sym_preproc_arg] = ACTIONS(1821),
    [sym_comment] = ACTIONS(83),
  },
  [434] = {
    [ts_builtin_sym_end] = ACTIONS(1823),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1825),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1825),
    [anon_sym_LPAREN] = ACTIONS(1823),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1825),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1825),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1825),
    [sym_preproc_directive] = ACTIONS(1825),
    [anon_sym_typedef] = ACTIONS(1825),
    [anon_sym_extern] = ACTIONS(1825),
    [anon_sym_RBRACE] = ACTIONS(1823),
    [anon_sym_STAR] = ACTIONS(1823),
    [anon_sym_static] = ACTIONS(1825),
    [anon_sym_register] = ACTIONS(1825),
    [anon_sym_inline] = ACTIONS(1825),
    [anon_sym_const] = ACTIONS(1825),
    [anon_sym_restrict] = ACTIONS(1825),
    [anon_sym_volatile] = ACTIONS(1825),
    [anon_sym__Atomic] = ACTIONS(1825),
    [anon_sym_mutable] = ACTIONS(1825),
    [anon_sym_explicit] = ACTIONS(1825),
    [anon_sym_constexpr] = ACTIONS(1825),
    [anon_sym_unsigned] = ACTIONS(1825),
    [anon_sym_long] = ACTIONS(1825),
    [anon_sym_short] = ACTIONS(1825),
    [sym_primitive_type] = ACTIONS(1825),
    [anon_sym_enum] = ACTIONS(1825),
    [anon_sym_struct] = ACTIONS(1825),
    [anon_sym_union] = ACTIONS(1825),
    [anon_sym_AMP] = ACTIONS(1825),
    [anon_sym_AMP_AMP] = ACTIONS(1823),
    [anon_sym_TILDE] = ACTIONS(1823),
    [sym_identifier] = ACTIONS(1825),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(1825),
    [sym_auto] = ACTIONS(1825),
    [anon_sym_typename] = ACTIONS(1825),
    [anon_sym_template] = ACTIONS(1825),
    [anon_sym_namespace] = ACTIONS(1825),
    [anon_sym_using] = ACTIONS(1825),
    [anon_sym_COLON_COLON] = ACTIONS(1823),
    [sym_operator_name] = ACTIONS(1823),
  },
  [435] = {
    [anon_sym_LF] = ACTIONS(1827),
    [sym_comment] = ACTIONS(83),
  },
  [436] = {
    [anon_sym_LPAREN] = ACTIONS(1146),
    [anon_sym_COMMA] = ACTIONS(1146),
    [anon_sym_RPAREN] = ACTIONS(1146),
    [anon_sym_SEMI] = ACTIONS(1146),
    [anon_sym_LBRACE] = ACTIONS(1146),
    [anon_sym_LBRACK] = ACTIONS(1146),
    [anon_sym_EQ] = ACTIONS(1146),
    [anon_sym_COLON] = ACTIONS(1148),
    [anon_sym_LT] = ACTIONS(1137),
    [anon_sym_GT] = ACTIONS(1146),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(1144),
  },
  [437] = {
    [sym__type_specifier] = STATE(933),
    [sym_sized_type_specifier] = STATE(933),
    [sym_enum_specifier] = STATE(933),
    [sym_struct_specifier] = STATE(933),
    [sym_union_specifier] = STATE(933),
    [sym_macro_type_specifier] = STATE(933),
    [sym_class_specifier] = STATE(933),
    [sym_dependent_type] = STATE(933),
    [sym_template_type] = STATE(825),
    [sym_scoped_type_identifier] = STATE(826),
    [sym_scoped_namespace_identifier] = STATE(827),
    [aux_sym_sized_type_specifier_repeat1] = STATE(934),
    [anon_sym_unsigned] = ACTIONS(1829),
    [anon_sym_long] = ACTIONS(1829),
    [anon_sym_short] = ACTIONS(1829),
    [sym_primitive_type] = ACTIONS(1831),
    [anon_sym_enum] = ACTIONS(1833),
    [anon_sym_struct] = ACTIONS(1835),
    [anon_sym_union] = ACTIONS(1837),
    [sym_identifier] = ACTIONS(1588),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(1839),
    [sym_auto] = ACTIONS(1831),
    [anon_sym_typename] = ACTIONS(1841),
    [anon_sym_COLON_COLON] = ACTIONS(1594),
  },
  [438] = {
    [sym_type_qualifier] = STATE(935),
    [sym_trailing_return_type] = STATE(935),
    [aux_sym_function_declarator_repeat1] = STATE(935),
    [anon_sym_LPAREN] = ACTIONS(1596),
    [anon_sym_RPAREN] = ACTIONS(1596),
    [anon_sym_LBRACK] = ACTIONS(1596),
    [anon_sym_const] = ACTIONS(612),
    [anon_sym_restrict] = ACTIONS(614),
    [anon_sym_volatile] = ACTIONS(614),
    [anon_sym__Atomic] = ACTIONS(614),
    [anon_sym_mutable] = ACTIONS(614),
    [anon_sym_explicit] = ACTIONS(614),
    [anon_sym_constexpr] = ACTIONS(614),
    [anon_sym_DASH_GT] = ACTIONS(845),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(1843),
  },
  [439] = {
    [anon_sym_LPAREN] = ACTIONS(1807),
    [anon_sym_COMMA] = ACTIONS(1807),
    [anon_sym_RPAREN] = ACTIONS(1807),
    [anon_sym_SEMI] = ACTIONS(1807),
    [anon_sym_LBRACE] = ACTIONS(1807),
    [anon_sym_LBRACK] = ACTIONS(1807),
    [anon_sym_EQ] = ACTIONS(1807),
    [anon_sym_COLON] = ACTIONS(1809),
    [anon_sym_LT] = ACTIONS(1798),
    [anon_sym_GT] = ACTIONS(1807),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(1805),
  },
  [440] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(251),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(251),
    [anon_sym_LPAREN] = ACTIONS(249),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(251),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(251),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(251),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(251),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(251),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(251),
    [sym_preproc_directive] = ACTIONS(251),
    [anon_sym_typedef] = ACTIONS(251),
    [anon_sym_extern] = ACTIONS(251),
    [anon_sym_STAR] = ACTIONS(249),
    [anon_sym_static] = ACTIONS(251),
    [anon_sym_register] = ACTIONS(251),
    [anon_sym_inline] = ACTIONS(251),
    [anon_sym_const] = ACTIONS(251),
    [anon_sym_restrict] = ACTIONS(251),
    [anon_sym_volatile] = ACTIONS(251),
    [anon_sym__Atomic] = ACTIONS(251),
    [anon_sym_mutable] = ACTIONS(251),
    [anon_sym_explicit] = ACTIONS(251),
    [anon_sym_constexpr] = ACTIONS(251),
    [anon_sym_unsigned] = ACTIONS(251),
    [anon_sym_long] = ACTIONS(251),
    [anon_sym_short] = ACTIONS(251),
    [sym_primitive_type] = ACTIONS(251),
    [anon_sym_enum] = ACTIONS(251),
    [anon_sym_struct] = ACTIONS(251),
    [anon_sym_union] = ACTIONS(251),
    [anon_sym_AMP] = ACTIONS(251),
    [anon_sym_AMP_AMP] = ACTIONS(249),
    [anon_sym_TILDE] = ACTIONS(249),
    [sym_identifier] = ACTIONS(251),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(251),
    [sym_auto] = ACTIONS(251),
    [anon_sym_typename] = ACTIONS(251),
    [anon_sym_template] = ACTIONS(251),
    [anon_sym_namespace] = ACTIONS(251),
    [anon_sym_using] = ACTIONS(251),
    [anon_sym_COLON_COLON] = ACTIONS(249),
    [sym_operator_name] = ACTIONS(249),
  },
  [441] = {
    [sym_preproc_params] = STATE(938),
    [aux_sym_SLASH_LBRACK_BSLASHt_RBRACK_PLUS_SLASH] = ACTIONS(1845),
    [anon_sym_LF] = ACTIONS(1847),
    [anon_sym_LPAREN] = ACTIONS(257),
    [sym_comment] = ACTIONS(83),
  },
  [442] = {
    [sym_preproc_include] = STATE(941),
    [sym_preproc_def] = STATE(941),
    [sym_preproc_function_def] = STATE(941),
    [sym_preproc_call] = STATE(941),
    [sym_preproc_if] = STATE(941),
    [sym_preproc_ifdef] = STATE(941),
    [sym_preproc_else] = STATE(940),
    [sym_preproc_elif] = STATE(940),
    [sym_function_definition] = STATE(941),
    [sym_declaration] = STATE(941),
    [sym_type_definition] = STATE(941),
    [sym__declaration_specifiers] = STATE(176),
    [sym_linkage_specification] = STATE(941),
    [sym__declarator] = STATE(28),
    [sym_pointer_declarator] = STATE(28),
    [sym_function_declarator] = STATE(177),
    [sym_array_declarator] = STATE(28),
    [sym_storage_class_specifier] = STATE(180),
    [sym_type_qualifier] = STATE(180),
    [sym__type_specifier] = STATE(30),
    [sym_sized_type_specifier] = STATE(30),
    [sym_enum_specifier] = STATE(30),
    [sym_struct_specifier] = STATE(30),
    [sym_union_specifier] = STATE(30),
    [sym__empty_declaration] = STATE(941),
    [sym_macro_type_specifier] = STATE(30),
    [sym_class_specifier] = STATE(30),
    [sym_dependent_type] = STATE(30),
    [sym_structured_binding_declaration] = STATE(941),
    [sym_template_declaration] = STATE(941),
    [sym_template_instantiation] = STATE(941),
    [sym_constructor_or_destructor_definition] = STATE(178),
    [sym_reference_declarator] = STATE(28),
    [sym_template_type] = STATE(32),
    [sym_template_function] = STATE(28),
    [sym_namespace_definition] = STATE(941),
    [sym_using_declaration] = STATE(941),
    [sym_alias_declaration] = STATE(941),
    [sym_destructor_name] = STATE(28),
    [sym_scoped_identifier] = STATE(33),
    [sym_scoped_type_identifier] = STATE(34),
    [sym_scoped_namespace_identifier] = STATE(35),
    [aux_sym_translation_unit_repeat1] = STATE(941),
    [aux_sym__declaration_specifiers_repeat1] = STATE(180),
    [aux_sym_sized_type_specifier_repeat1] = STATE(38),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(273),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(275),
    [anon_sym_LPAREN] = ACTIONS(11),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(277),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(1849),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(281),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(283),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(285),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(287),
    [sym_preproc_directive] = ACTIONS(289),
    [anon_sym_typedef] = ACTIONS(291),
    [anon_sym_extern] = ACTIONS(293),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_static] = ACTIONS(27),
    [anon_sym_register] = ACTIONS(27),
    [anon_sym_inline] = ACTIONS(27),
    [anon_sym_const] = ACTIONS(29),
    [anon_sym_restrict] = ACTIONS(29),
    [anon_sym_volatile] = ACTIONS(29),
    [anon_sym__Atomic] = ACTIONS(29),
    [anon_sym_mutable] = ACTIONS(29),
    [anon_sym_explicit] = ACTIONS(29),
    [anon_sym_constexpr] = ACTIONS(29),
    [anon_sym_unsigned] = ACTIONS(31),
    [anon_sym_long] = ACTIONS(31),
    [anon_sym_short] = ACTIONS(31),
    [sym_primitive_type] = ACTIONS(33),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_union] = ACTIONS(39),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(45),
    [sym_identifier] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(51),
    [sym_auto] = ACTIONS(33),
    [anon_sym_typename] = ACTIONS(53),
    [anon_sym_template] = ACTIONS(295),
    [anon_sym_namespace] = ACTIONS(297),
    [anon_sym_using] = ACTIONS(299),
    [anon_sym_COLON_COLON] = ACTIONS(61),
    [sym_operator_name] = ACTIONS(63),
  },
  [443] = {
    [sym_preproc_include] = STATE(944),
    [sym_preproc_def] = STATE(944),
    [sym_preproc_function_def] = STATE(944),
    [sym_preproc_call] = STATE(944),
    [sym_preproc_if] = STATE(944),
    [sym_preproc_ifdef] = STATE(944),
    [sym_preproc_else] = STATE(943),
    [sym_preproc_elif] = STATE(943),
    [sym_function_definition] = STATE(944),
    [sym_declaration] = STATE(944),
    [sym_type_definition] = STATE(944),
    [sym__declaration_specifiers] = STATE(176),
    [sym_linkage_specification] = STATE(944),
    [sym__declarator] = STATE(28),
    [sym_pointer_declarator] = STATE(28),
    [sym_function_declarator] = STATE(177),
    [sym_array_declarator] = STATE(28),
    [sym_storage_class_specifier] = STATE(180),
    [sym_type_qualifier] = STATE(180),
    [sym__type_specifier] = STATE(30),
    [sym_sized_type_specifier] = STATE(30),
    [sym_enum_specifier] = STATE(30),
    [sym_struct_specifier] = STATE(30),
    [sym_union_specifier] = STATE(30),
    [sym__empty_declaration] = STATE(944),
    [sym_macro_type_specifier] = STATE(30),
    [sym_class_specifier] = STATE(30),
    [sym_dependent_type] = STATE(30),
    [sym_structured_binding_declaration] = STATE(944),
    [sym_template_declaration] = STATE(944),
    [sym_template_instantiation] = STATE(944),
    [sym_constructor_or_destructor_definition] = STATE(178),
    [sym_reference_declarator] = STATE(28),
    [sym_template_type] = STATE(32),
    [sym_template_function] = STATE(28),
    [sym_namespace_definition] = STATE(944),
    [sym_using_declaration] = STATE(944),
    [sym_alias_declaration] = STATE(944),
    [sym_destructor_name] = STATE(28),
    [sym_scoped_identifier] = STATE(33),
    [sym_scoped_type_identifier] = STATE(34),
    [sym_scoped_namespace_identifier] = STATE(35),
    [aux_sym_translation_unit_repeat1] = STATE(944),
    [aux_sym__declaration_specifiers_repeat1] = STATE(180),
    [aux_sym_sized_type_specifier_repeat1] = STATE(38),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(273),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(275),
    [anon_sym_LPAREN] = ACTIONS(11),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(277),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(1851),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(281),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(283),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(285),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(287),
    [sym_preproc_directive] = ACTIONS(289),
    [anon_sym_typedef] = ACTIONS(291),
    [anon_sym_extern] = ACTIONS(293),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_static] = ACTIONS(27),
    [anon_sym_register] = ACTIONS(27),
    [anon_sym_inline] = ACTIONS(27),
    [anon_sym_const] = ACTIONS(29),
    [anon_sym_restrict] = ACTIONS(29),
    [anon_sym_volatile] = ACTIONS(29),
    [anon_sym__Atomic] = ACTIONS(29),
    [anon_sym_mutable] = ACTIONS(29),
    [anon_sym_explicit] = ACTIONS(29),
    [anon_sym_constexpr] = ACTIONS(29),
    [anon_sym_unsigned] = ACTIONS(31),
    [anon_sym_long] = ACTIONS(31),
    [anon_sym_short] = ACTIONS(31),
    [sym_primitive_type] = ACTIONS(33),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_union] = ACTIONS(39),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(45),
    [sym_identifier] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(51),
    [sym_auto] = ACTIONS(33),
    [anon_sym_typename] = ACTIONS(53),
    [anon_sym_template] = ACTIONS(295),
    [anon_sym_namespace] = ACTIONS(297),
    [anon_sym_using] = ACTIONS(299),
    [anon_sym_COLON_COLON] = ACTIONS(61),
    [sym_operator_name] = ACTIONS(63),
  },
  [444] = {
    [sym_preproc_include] = STATE(947),
    [sym_preproc_def] = STATE(947),
    [sym_preproc_function_def] = STATE(947),
    [sym_preproc_call] = STATE(947),
    [sym_preproc_if] = STATE(947),
    [sym_preproc_ifdef] = STATE(947),
    [sym_preproc_else] = STATE(946),
    [sym_preproc_elif] = STATE(946),
    [sym_function_definition] = STATE(947),
    [sym_declaration] = STATE(947),
    [sym_type_definition] = STATE(947),
    [sym__declaration_specifiers] = STATE(176),
    [sym_linkage_specification] = STATE(947),
    [sym__declarator] = STATE(28),
    [sym_pointer_declarator] = STATE(28),
    [sym_function_declarator] = STATE(177),
    [sym_array_declarator] = STATE(28),
    [sym_storage_class_specifier] = STATE(180),
    [sym_type_qualifier] = STATE(180),
    [sym__type_specifier] = STATE(30),
    [sym_sized_type_specifier] = STATE(30),
    [sym_enum_specifier] = STATE(30),
    [sym_struct_specifier] = STATE(30),
    [sym_union_specifier] = STATE(30),
    [sym__empty_declaration] = STATE(947),
    [sym_macro_type_specifier] = STATE(30),
    [sym_class_specifier] = STATE(30),
    [sym_dependent_type] = STATE(30),
    [sym_structured_binding_declaration] = STATE(947),
    [sym_template_declaration] = STATE(947),
    [sym_template_instantiation] = STATE(947),
    [sym_constructor_or_destructor_definition] = STATE(178),
    [sym_reference_declarator] = STATE(28),
    [sym_template_type] = STATE(32),
    [sym_template_function] = STATE(28),
    [sym_namespace_definition] = STATE(947),
    [sym_using_declaration] = STATE(947),
    [sym_alias_declaration] = STATE(947),
    [sym_destructor_name] = STATE(28),
    [sym_scoped_identifier] = STATE(33),
    [sym_scoped_type_identifier] = STATE(34),
    [sym_scoped_namespace_identifier] = STATE(35),
    [aux_sym_translation_unit_repeat1] = STATE(947),
    [aux_sym__declaration_specifiers_repeat1] = STATE(180),
    [aux_sym_sized_type_specifier_repeat1] = STATE(38),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(273),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(275),
    [anon_sym_LPAREN] = ACTIONS(11),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(277),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(1853),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(281),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(283),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(285),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(287),
    [sym_preproc_directive] = ACTIONS(289),
    [anon_sym_typedef] = ACTIONS(291),
    [anon_sym_extern] = ACTIONS(293),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_static] = ACTIONS(27),
    [anon_sym_register] = ACTIONS(27),
    [anon_sym_inline] = ACTIONS(27),
    [anon_sym_const] = ACTIONS(29),
    [anon_sym_restrict] = ACTIONS(29),
    [anon_sym_volatile] = ACTIONS(29),
    [anon_sym__Atomic] = ACTIONS(29),
    [anon_sym_mutable] = ACTIONS(29),
    [anon_sym_explicit] = ACTIONS(29),
    [anon_sym_constexpr] = ACTIONS(29),
    [anon_sym_unsigned] = ACTIONS(31),
    [anon_sym_long] = ACTIONS(31),
    [anon_sym_short] = ACTIONS(31),
    [sym_primitive_type] = ACTIONS(33),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_union] = ACTIONS(39),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(45),
    [sym_identifier] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(51),
    [sym_auto] = ACTIONS(33),
    [anon_sym_typename] = ACTIONS(53),
    [anon_sym_template] = ACTIONS(295),
    [anon_sym_namespace] = ACTIONS(297),
    [anon_sym_using] = ACTIONS(299),
    [anon_sym_COLON_COLON] = ACTIONS(61),
    [sym_operator_name] = ACTIONS(63),
  },
  [445] = {
    [sym_string_literal] = ACTIONS(1855),
    [sym_system_lib_string] = ACTIONS(1855),
    [sym_comment] = ACTIONS(49),
  },
  [446] = {
    [sym_identifier] = ACTIONS(1857),
    [sym_comment] = ACTIONS(49),
  },
  [447] = {
    [sym_preproc_arg] = ACTIONS(1859),
    [sym_comment] = ACTIONS(83),
  },
  [448] = {
    [sym_identifier] = ACTIONS(1861),
    [sym_comment] = ACTIONS(49),
  },
  [449] = {
    [sym_identifier] = ACTIONS(1863),
    [sym_comment] = ACTIONS(49),
  },
  [450] = {
    [aux_sym_SLASH_LBRACK_BSLASHt_RBRACK_PLUS_SLASH] = ACTIONS(1865),
    [anon_sym_LF] = ACTIONS(1867),
    [sym_comment] = ACTIONS(83),
  },
  [451] = {
    [sym_type_qualifier] = STATE(956),
    [sym__type_specifier] = STATE(955),
    [sym_sized_type_specifier] = STATE(955),
    [sym_enum_specifier] = STATE(955),
    [sym_struct_specifier] = STATE(955),
    [sym_union_specifier] = STATE(955),
    [sym_macro_type_specifier] = STATE(955),
    [sym_class_specifier] = STATE(955),
    [sym_dependent_type] = STATE(955),
    [sym_template_type] = STATE(62),
    [sym_scoped_type_identifier] = STATE(63),
    [sym_scoped_namespace_identifier] = STATE(64),
    [aux_sym_type_definition_repeat1] = STATE(956),
    [aux_sym_sized_type_specifier_repeat1] = STATE(66),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_restrict] = ACTIONS(93),
    [anon_sym_volatile] = ACTIONS(93),
    [anon_sym__Atomic] = ACTIONS(93),
    [anon_sym_mutable] = ACTIONS(93),
    [anon_sym_explicit] = ACTIONS(93),
    [anon_sym_constexpr] = ACTIONS(93),
    [anon_sym_unsigned] = ACTIONS(95),
    [anon_sym_long] = ACTIONS(95),
    [anon_sym_short] = ACTIONS(95),
    [sym_primitive_type] = ACTIONS(1869),
    [anon_sym_enum] = ACTIONS(99),
    [anon_sym_struct] = ACTIONS(101),
    [anon_sym_union] = ACTIONS(103),
    [sym_identifier] = ACTIONS(105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(107),
    [sym_auto] = ACTIONS(1869),
    [anon_sym_typename] = ACTIONS(109),
    [anon_sym_COLON_COLON] = ACTIONS(111),
  },
  [452] = {
    [anon_sym_LPAREN] = ACTIONS(113),
    [anon_sym_extern] = ACTIONS(115),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_static] = ACTIONS(115),
    [anon_sym_register] = ACTIONS(115),
    [anon_sym_inline] = ACTIONS(115),
    [anon_sym_const] = ACTIONS(115),
    [anon_sym_restrict] = ACTIONS(115),
    [anon_sym_volatile] = ACTIONS(115),
    [anon_sym__Atomic] = ACTIONS(115),
    [anon_sym_mutable] = ACTIONS(115),
    [anon_sym_explicit] = ACTIONS(115),
    [anon_sym_constexpr] = ACTIONS(115),
    [anon_sym_unsigned] = ACTIONS(115),
    [anon_sym_long] = ACTIONS(115),
    [anon_sym_short] = ACTIONS(115),
    [sym_primitive_type] = ACTIONS(115),
    [anon_sym_enum] = ACTIONS(115),
    [anon_sym_struct] = ACTIONS(115),
    [anon_sym_union] = ACTIONS(115),
    [anon_sym_AMP] = ACTIONS(115),
    [anon_sym_AMP_AMP] = ACTIONS(113),
    [anon_sym_TILDE] = ACTIONS(113),
    [sym_string_literal] = ACTIONS(1871),
    [sym_identifier] = ACTIONS(115),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(115),
    [sym_auto] = ACTIONS(115),
    [anon_sym_typename] = ACTIONS(115),
    [anon_sym_COLON_COLON] = ACTIONS(113),
    [sym_operator_name] = ACTIONS(113),
  },
  [453] = {
    [sym__declaration_specifiers] = STATE(958),
    [sym__declarator] = STATE(959),
    [sym_pointer_declarator] = STATE(959),
    [sym_function_declarator] = STATE(959),
    [sym_array_declarator] = STATE(959),
    [sym_storage_class_specifier] = STATE(109),
    [sym_type_qualifier] = STATE(109),
    [sym__type_specifier] = STATE(105),
    [sym_sized_type_specifier] = STATE(105),
    [sym_enum_specifier] = STATE(105),
    [sym_struct_specifier] = STATE(105),
    [sym_union_specifier] = STATE(105),
    [sym_macro_type_specifier] = STATE(105),
    [sym_class_specifier] = STATE(105),
    [sym_dependent_type] = STATE(105),
    [sym_template_parameter_list] = STATE(960),
    [sym_reference_declarator] = STATE(959),
    [sym_template_type] = STATE(107),
    [sym_template_function] = STATE(959),
    [sym_destructor_name] = STATE(959),
    [sym_scoped_identifier] = STATE(33),
    [sym_scoped_type_identifier] = STATE(34),
    [sym_scoped_namespace_identifier] = STATE(108),
    [aux_sym__declaration_specifiers_repeat1] = STATE(109),
    [aux_sym_sized_type_specifier_repeat1] = STATE(110),
    [anon_sym_LPAREN] = ACTIONS(11),
    [anon_sym_extern] = ACTIONS(154),
    [anon_sym_STAR] = ACTIONS(156),
    [anon_sym_static] = ACTIONS(154),
    [anon_sym_register] = ACTIONS(154),
    [anon_sym_inline] = ACTIONS(154),
    [anon_sym_const] = ACTIONS(158),
    [anon_sym_restrict] = ACTIONS(158),
    [anon_sym_volatile] = ACTIONS(158),
    [anon_sym__Atomic] = ACTIONS(158),
    [anon_sym_mutable] = ACTIONS(158),
    [anon_sym_explicit] = ACTIONS(158),
    [anon_sym_constexpr] = ACTIONS(158),
    [anon_sym_unsigned] = ACTIONS(160),
    [anon_sym_long] = ACTIONS(160),
    [anon_sym_short] = ACTIONS(160),
    [sym_primitive_type] = ACTIONS(162),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_union] = ACTIONS(39),
    [anon_sym_AMP] = ACTIONS(164),
    [anon_sym_AMP_AMP] = ACTIONS(166),
    [anon_sym_TILDE] = ACTIONS(45),
    [anon_sym_LT] = ACTIONS(168),
    [sym_identifier] = ACTIONS(170),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(51),
    [sym_auto] = ACTIONS(162),
    [anon_sym_typename] = ACTIONS(172),
    [anon_sym_COLON_COLON] = ACTIONS(174),
    [sym_operator_name] = ACTIONS(1873),
  },
  [454] = {
    [sym_declaration_list] = STATE(963),
    [anon_sym_LBRACE] = ACTIONS(1875),
    [sym_identifier] = ACTIONS(1877),
    [sym_comment] = ACTIONS(49),
  },
  [455] = {
    [sym_template_type] = STATE(117),
    [sym_scoped_identifier] = STATE(966),
    [sym_scoped_type_identifier] = STATE(47),
    [sym_scoped_namespace_identifier] = STATE(117),
    [sym_identifier] = ACTIONS(1879),
    [sym_comment] = ACTIONS(49),
    [anon_sym_namespace] = ACTIONS(1881),
    [anon_sym_COLON_COLON] = ACTIONS(186),
  },
  [456] = {
    [sym__declarator] = STATE(968),
    [sym_pointer_declarator] = STATE(968),
    [sym_function_declarator] = STATE(968),
    [sym_array_declarator] = STATE(968),
    [sym_init_declarator] = STATE(969),
    [sym_reference_declarator] = STATE(968),
    [sym_structured_binding_reference_declarator] = STATE(970),
    [sym_structured_binding_declarator] = STATE(971),
    [sym_template_type] = STATE(46),
    [sym_template_function] = STATE(968),
    [sym_destructor_name] = STATE(968),
    [sym_scoped_identifier] = STATE(33),
    [sym_scoped_type_identifier] = STATE(47),
    [sym_scoped_namespace_identifier] = STATE(46),
    [anon_sym_LPAREN] = ACTIONS(11),
    [anon_sym_SEMI] = ACTIONS(1883),
    [anon_sym_STAR] = ACTIONS(196),
    [anon_sym_LBRACK] = ACTIONS(198),
    [anon_sym_AMP] = ACTIONS(200),
    [anon_sym_AMP_AMP] = ACTIONS(202),
    [anon_sym_TILDE] = ACTIONS(45),
    [sym_identifier] = ACTIONS(75),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(77),
    [sym_operator_name] = ACTIONS(1885),
  },
  [457] = {
    [sym_compound_statement] = STATE(973),
    [sym_field_initializer_list] = STATE(974),
    [anon_sym_LPAREN] = ACTIONS(210),
    [anon_sym_LBRACE] = ACTIONS(1887),
    [anon_sym_LBRACK] = ACTIONS(210),
    [anon_sym_COLON] = ACTIONS(214),
    [sym_comment] = ACTIONS(49),
  },
  [458] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(226),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(226),
    [anon_sym_LPAREN] = ACTIONS(224),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(226),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(226),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(226),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(226),
    [sym_preproc_directive] = ACTIONS(226),
    [anon_sym_typedef] = ACTIONS(226),
    [anon_sym_extern] = ACTIONS(226),
    [anon_sym_STAR] = ACTIONS(224),
    [anon_sym_static] = ACTIONS(226),
    [anon_sym_register] = ACTIONS(226),
    [anon_sym_inline] = ACTIONS(226),
    [anon_sym_const] = ACTIONS(226),
    [anon_sym_restrict] = ACTIONS(226),
    [anon_sym_volatile] = ACTIONS(226),
    [anon_sym__Atomic] = ACTIONS(226),
    [anon_sym_mutable] = ACTIONS(226),
    [anon_sym_explicit] = ACTIONS(226),
    [anon_sym_constexpr] = ACTIONS(226),
    [anon_sym_unsigned] = ACTIONS(226),
    [anon_sym_long] = ACTIONS(226),
    [anon_sym_short] = ACTIONS(226),
    [sym_primitive_type] = ACTIONS(226),
    [anon_sym_enum] = ACTIONS(226),
    [anon_sym_struct] = ACTIONS(226),
    [anon_sym_union] = ACTIONS(226),
    [anon_sym_AMP] = ACTIONS(226),
    [anon_sym_AMP_AMP] = ACTIONS(224),
    [anon_sym_TILDE] = ACTIONS(224),
    [sym_identifier] = ACTIONS(226),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(226),
    [sym_auto] = ACTIONS(226),
    [anon_sym_typename] = ACTIONS(226),
    [anon_sym_template] = ACTIONS(226),
    [anon_sym_namespace] = ACTIONS(226),
    [anon_sym_using] = ACTIONS(226),
    [anon_sym_COLON_COLON] = ACTIONS(224),
    [sym_operator_name] = ACTIONS(224),
  },
  [459] = {
    [sym_preproc_include] = STATE(975),
    [sym_preproc_def] = STATE(975),
    [sym_preproc_function_def] = STATE(975),
    [sym_preproc_call] = STATE(975),
    [sym_preproc_if] = STATE(975),
    [sym_preproc_ifdef] = STATE(975),
    [sym_function_definition] = STATE(975),
    [sym_declaration] = STATE(975),
    [sym_type_definition] = STATE(975),
    [sym__declaration_specifiers] = STATE(456),
    [sym_linkage_specification] = STATE(975),
    [sym__declarator] = STATE(28),
    [sym_pointer_declarator] = STATE(28),
    [sym_function_declarator] = STATE(457),
    [sym_array_declarator] = STATE(28),
    [sym_storage_class_specifier] = STATE(460),
    [sym_type_qualifier] = STATE(460),
    [sym__type_specifier] = STATE(30),
    [sym_sized_type_specifier] = STATE(30),
    [sym_enum_specifier] = STATE(30),
    [sym_struct_specifier] = STATE(30),
    [sym_union_specifier] = STATE(30),
    [sym__empty_declaration] = STATE(975),
    [sym_macro_type_specifier] = STATE(30),
    [sym_class_specifier] = STATE(30),
    [sym_dependent_type] = STATE(30),
    [sym_structured_binding_declaration] = STATE(975),
    [sym_template_declaration] = STATE(975),
    [sym_template_instantiation] = STATE(975),
    [sym_constructor_or_destructor_definition] = STATE(458),
    [sym_reference_declarator] = STATE(28),
    [sym_template_type] = STATE(32),
    [sym_template_function] = STATE(28),
    [sym_namespace_definition] = STATE(975),
    [sym_using_declaration] = STATE(975),
    [sym_alias_declaration] = STATE(975),
    [sym_destructor_name] = STATE(28),
    [sym_scoped_identifier] = STATE(33),
    [sym_scoped_type_identifier] = STATE(34),
    [sym_scoped_namespace_identifier] = STATE(35),
    [aux_sym_translation_unit_repeat1] = STATE(975),
    [aux_sym__declaration_specifiers_repeat1] = STATE(460),
    [aux_sym_sized_type_specifier_repeat1] = STATE(38),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(865),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(11),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(869),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(1889),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(873),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(875),
    [sym_preproc_directive] = ACTIONS(877),
    [anon_sym_typedef] = ACTIONS(879),
    [anon_sym_extern] = ACTIONS(881),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_static] = ACTIONS(27),
    [anon_sym_register] = ACTIONS(27),
    [anon_sym_inline] = ACTIONS(27),
    [anon_sym_const] = ACTIONS(29),
    [anon_sym_restrict] = ACTIONS(29),
    [anon_sym_volatile] = ACTIONS(29),
    [anon_sym__Atomic] = ACTIONS(29),
    [anon_sym_mutable] = ACTIONS(29),
    [anon_sym_explicit] = ACTIONS(29),
    [anon_sym_constexpr] = ACTIONS(29),
    [anon_sym_unsigned] = ACTIONS(31),
    [anon_sym_long] = ACTIONS(31),
    [anon_sym_short] = ACTIONS(31),
    [sym_primitive_type] = ACTIONS(33),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_union] = ACTIONS(39),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(45),
    [sym_identifier] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(51),
    [sym_auto] = ACTIONS(33),
    [anon_sym_typename] = ACTIONS(53),
    [anon_sym_template] = ACTIONS(883),
    [anon_sym_namespace] = ACTIONS(885),
    [anon_sym_using] = ACTIONS(887),
    [anon_sym_COLON_COLON] = ACTIONS(61),
    [sym_operator_name] = ACTIONS(63),
  },
  [460] = {
    [sym__declarator] = STATE(28),
    [sym_pointer_declarator] = STATE(28),
    [sym_function_declarator] = STATE(976),
    [sym_array_declarator] = STATE(28),
    [sym_storage_class_specifier] = STATE(145),
    [sym_type_qualifier] = STATE(145),
    [sym__type_specifier] = STATE(144),
    [sym_sized_type_specifier] = STATE(144),
    [sym_enum_specifier] = STATE(144),
    [sym_struct_specifier] = STATE(144),
    [sym_union_specifier] = STATE(144),
    [sym_macro_type_specifier] = STATE(144),
    [sym_class_specifier] = STATE(144),
    [sym_dependent_type] = STATE(144),
    [sym_reference_declarator] = STATE(28),
    [sym_template_type] = STATE(32),
    [sym_template_function] = STATE(28),
    [sym_destructor_name] = STATE(28),
    [sym_scoped_identifier] = STATE(33),
    [sym_scoped_type_identifier] = STATE(34),
    [sym_scoped_namespace_identifier] = STATE(35),
    [aux_sym__declaration_specifiers_repeat1] = STATE(145),
    [aux_sym_sized_type_specifier_repeat1] = STATE(38),
    [anon_sym_LPAREN] = ACTIONS(11),
    [anon_sym_extern] = ACTIONS(27),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_static] = ACTIONS(27),
    [anon_sym_register] = ACTIONS(27),
    [anon_sym_inline] = ACTIONS(27),
    [anon_sym_const] = ACTIONS(29),
    [anon_sym_restrict] = ACTIONS(29),
    [anon_sym_volatile] = ACTIONS(29),
    [anon_sym__Atomic] = ACTIONS(29),
    [anon_sym_mutable] = ACTIONS(29),
    [anon_sym_explicit] = ACTIONS(29),
    [anon_sym_constexpr] = ACTIONS(29),
    [anon_sym_unsigned] = ACTIONS(31),
    [anon_sym_long] = ACTIONS(31),
    [anon_sym_short] = ACTIONS(31),
    [sym_primitive_type] = ACTIONS(236),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_union] = ACTIONS(39),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(45),
    [sym_identifier] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(51),
    [sym_auto] = ACTIONS(236),
    [anon_sym_typename] = ACTIONS(53),
    [anon_sym_COLON_COLON] = ACTIONS(61),
    [sym_operator_name] = ACTIONS(63),
  },
  [461] = {
    [sym_preproc_include] = STATE(978),
    [sym_preproc_def] = STATE(978),
    [sym_preproc_function_def] = STATE(978),
    [sym_preproc_call] = STATE(978),
    [sym_preproc_if] = STATE(978),
    [sym_preproc_ifdef] = STATE(978),
    [sym_preproc_else] = STATE(977),
    [sym_preproc_elif] = STATE(977),
    [sym_function_definition] = STATE(978),
    [sym_declaration] = STATE(978),
    [sym_type_definition] = STATE(978),
    [sym__declaration_specifiers] = STATE(176),
    [sym_linkage_specification] = STATE(978),
    [sym__declarator] = STATE(28),
    [sym_pointer_declarator] = STATE(28),
    [sym_function_declarator] = STATE(177),
    [sym_array_declarator] = STATE(28),
    [sym_storage_class_specifier] = STATE(180),
    [sym_type_qualifier] = STATE(180),
    [sym__type_specifier] = STATE(30),
    [sym_sized_type_specifier] = STATE(30),
    [sym_enum_specifier] = STATE(30),
    [sym_struct_specifier] = STATE(30),
    [sym_union_specifier] = STATE(30),
    [sym__empty_declaration] = STATE(978),
    [sym_macro_type_specifier] = STATE(30),
    [sym_class_specifier] = STATE(30),
    [sym_dependent_type] = STATE(30),
    [sym_structured_binding_declaration] = STATE(978),
    [sym_template_declaration] = STATE(978),
    [sym_template_instantiation] = STATE(978),
    [sym_constructor_or_destructor_definition] = STATE(178),
    [sym_reference_declarator] = STATE(28),
    [sym_template_type] = STATE(32),
    [sym_template_function] = STATE(28),
    [sym_namespace_definition] = STATE(978),
    [sym_using_declaration] = STATE(978),
    [sym_alias_declaration] = STATE(978),
    [sym_destructor_name] = STATE(28),
    [sym_scoped_identifier] = STATE(33),
    [sym_scoped_type_identifier] = STATE(34),
    [sym_scoped_namespace_identifier] = STATE(35),
    [aux_sym_translation_unit_repeat1] = STATE(978),
    [aux_sym__declaration_specifiers_repeat1] = STATE(180),
    [aux_sym_sized_type_specifier_repeat1] = STATE(38),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(273),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(275),
    [anon_sym_LPAREN] = ACTIONS(11),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(277),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(1891),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(281),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(283),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(285),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(287),
    [sym_preproc_directive] = ACTIONS(289),
    [anon_sym_typedef] = ACTIONS(291),
    [anon_sym_extern] = ACTIONS(293),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_static] = ACTIONS(27),
    [anon_sym_register] = ACTIONS(27),
    [anon_sym_inline] = ACTIONS(27),
    [anon_sym_const] = ACTIONS(29),
    [anon_sym_restrict] = ACTIONS(29),
    [anon_sym_volatile] = ACTIONS(29),
    [anon_sym__Atomic] = ACTIONS(29),
    [anon_sym_mutable] = ACTIONS(29),
    [anon_sym_explicit] = ACTIONS(29),
    [anon_sym_constexpr] = ACTIONS(29),
    [anon_sym_unsigned] = ACTIONS(31),
    [anon_sym_long] = ACTIONS(31),
    [anon_sym_short] = ACTIONS(31),
    [sym_primitive_type] = ACTIONS(33),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_union] = ACTIONS(39),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(45),
    [sym_identifier] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(51),
    [sym_auto] = ACTIONS(33),
    [anon_sym_typename] = ACTIONS(53),
    [anon_sym_template] = ACTIONS(295),
    [anon_sym_namespace] = ACTIONS(297),
    [anon_sym_using] = ACTIONS(299),
    [anon_sym_COLON_COLON] = ACTIONS(61),
    [sym_operator_name] = ACTIONS(63),
  },
  [462] = {
    [sym_preproc_arg] = ACTIONS(1893),
    [sym_comment] = ACTIONS(83),
  },
  [463] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(309),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(309),
    [anon_sym_LPAREN] = ACTIONS(307),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(309),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(309),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(309),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(309),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(309),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(309),
    [sym_preproc_directive] = ACTIONS(309),
    [anon_sym_typedef] = ACTIONS(309),
    [anon_sym_extern] = ACTIONS(309),
    [anon_sym_STAR] = ACTIONS(307),
    [anon_sym_static] = ACTIONS(309),
    [anon_sym_register] = ACTIONS(309),
    [anon_sym_inline] = ACTIONS(309),
    [anon_sym_const] = ACTIONS(309),
    [anon_sym_restrict] = ACTIONS(309),
    [anon_sym_volatile] = ACTIONS(309),
    [anon_sym__Atomic] = ACTIONS(309),
    [anon_sym_mutable] = ACTIONS(309),
    [anon_sym_explicit] = ACTIONS(309),
    [anon_sym_constexpr] = ACTIONS(309),
    [anon_sym_unsigned] = ACTIONS(309),
    [anon_sym_long] = ACTIONS(309),
    [anon_sym_short] = ACTIONS(309),
    [sym_primitive_type] = ACTIONS(309),
    [anon_sym_enum] = ACTIONS(309),
    [anon_sym_struct] = ACTIONS(309),
    [anon_sym_union] = ACTIONS(309),
    [anon_sym_AMP] = ACTIONS(309),
    [anon_sym_AMP_AMP] = ACTIONS(307),
    [anon_sym_TILDE] = ACTIONS(307),
    [sym_identifier] = ACTIONS(309),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(309),
    [sym_auto] = ACTIONS(309),
    [anon_sym_typename] = ACTIONS(309),
    [anon_sym_template] = ACTIONS(309),
    [anon_sym_namespace] = ACTIONS(309),
    [anon_sym_using] = ACTIONS(309),
    [anon_sym_COLON_COLON] = ACTIONS(307),
    [sym_operator_name] = ACTIONS(307),
  },
  [464] = {
    [sym__type_declarator] = STATE(980),
    [sym_pointer_type_declarator] = STATE(213),
    [sym_function_type_declarator] = STATE(214),
    [sym_array_type_declarator] = STATE(215),
    [anon_sym_LPAREN] = ACTIONS(327),
    [anon_sym_STAR] = ACTIONS(329),
    [sym_identifier] = ACTIONS(331),
    [sym_comment] = ACTIONS(49),
  },
  [465] = {
    [sym_type_qualifier] = STATE(219),
    [sym__type_specifier] = STATE(981),
    [sym_sized_type_specifier] = STATE(981),
    [sym_enum_specifier] = STATE(981),
    [sym_struct_specifier] = STATE(981),
    [sym_union_specifier] = STATE(981),
    [sym_macro_type_specifier] = STATE(981),
    [sym_class_specifier] = STATE(981),
    [sym_dependent_type] = STATE(981),
    [sym_template_type] = STATE(62),
    [sym_scoped_type_identifier] = STATE(63),
    [sym_scoped_namespace_identifier] = STATE(64),
    [aux_sym_type_definition_repeat1] = STATE(219),
    [aux_sym_sized_type_specifier_repeat1] = STATE(66),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_restrict] = ACTIONS(93),
    [anon_sym_volatile] = ACTIONS(93),
    [anon_sym__Atomic] = ACTIONS(93),
    [anon_sym_mutable] = ACTIONS(93),
    [anon_sym_explicit] = ACTIONS(93),
    [anon_sym_constexpr] = ACTIONS(93),
    [anon_sym_unsigned] = ACTIONS(95),
    [anon_sym_long] = ACTIONS(95),
    [anon_sym_short] = ACTIONS(95),
    [sym_primitive_type] = ACTIONS(1895),
    [anon_sym_enum] = ACTIONS(99),
    [anon_sym_struct] = ACTIONS(101),
    [anon_sym_union] = ACTIONS(103),
    [sym_identifier] = ACTIONS(105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(107),
    [sym_auto] = ACTIONS(1895),
    [anon_sym_typename] = ACTIONS(109),
    [anon_sym_COLON_COLON] = ACTIONS(111),
  },
  [466] = {
    [sym_function_definition] = STATE(982),
    [sym_declaration] = STATE(982),
    [sym__declaration_specifiers] = STATE(983),
    [sym_declaration_list] = STATE(982),
    [sym_storage_class_specifier] = STATE(109),
    [sym_type_qualifier] = STATE(109),
    [sym__type_specifier] = STATE(105),
    [sym_sized_type_specifier] = STATE(105),
    [sym_enum_specifier] = STATE(105),
    [sym_struct_specifier] = STATE(105),
    [sym_union_specifier] = STATE(105),
    [sym_macro_type_specifier] = STATE(105),
    [sym_class_specifier] = STATE(105),
    [sym_dependent_type] = STATE(105),
    [sym_template_type] = STATE(94),
    [sym_scoped_type_identifier] = STATE(34),
    [sym_scoped_namespace_identifier] = STATE(81),
    [aux_sym__declaration_specifiers_repeat1] = STATE(109),
    [aux_sym_sized_type_specifier_repeat1] = STATE(110),
    [anon_sym_extern] = ACTIONS(154),
    [anon_sym_LBRACE] = ACTIONS(901),
    [anon_sym_static] = ACTIONS(154),
    [anon_sym_register] = ACTIONS(154),
    [anon_sym_inline] = ACTIONS(154),
    [anon_sym_const] = ACTIONS(158),
    [anon_sym_restrict] = ACTIONS(158),
    [anon_sym_volatile] = ACTIONS(158),
    [anon_sym__Atomic] = ACTIONS(158),
    [anon_sym_mutable] = ACTIONS(158),
    [anon_sym_explicit] = ACTIONS(158),
    [anon_sym_constexpr] = ACTIONS(158),
    [anon_sym_unsigned] = ACTIONS(160),
    [anon_sym_long] = ACTIONS(160),
    [anon_sym_short] = ACTIONS(160),
    [sym_primitive_type] = ACTIONS(162),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_union] = ACTIONS(39),
    [sym_identifier] = ACTIONS(152),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(51),
    [sym_auto] = ACTIONS(162),
    [anon_sym_typename] = ACTIONS(172),
    [anon_sym_COLON_COLON] = ACTIONS(135),
  },
  [467] = {
    [sym__declarator] = STATE(984),
    [sym_pointer_declarator] = STATE(984),
    [sym_function_declarator] = STATE(984),
    [sym_array_declarator] = STATE(984),
    [sym_reference_declarator] = STATE(984),
    [sym_template_type] = STATE(46),
    [sym_template_function] = STATE(984),
    [sym_destructor_name] = STATE(984),
    [sym_scoped_identifier] = STATE(33),
    [sym_scoped_type_identifier] = STATE(47),
    [sym_scoped_namespace_identifier] = STATE(46),
    [anon_sym_LPAREN] = ACTIONS(11),
    [anon_sym_STAR] = ACTIONS(156),
    [anon_sym_AMP] = ACTIONS(164),
    [anon_sym_AMP_AMP] = ACTIONS(166),
    [anon_sym_TILDE] = ACTIONS(45),
    [sym_identifier] = ACTIONS(75),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(77),
    [sym_operator_name] = ACTIONS(1897),
  },
  [468] = {
    [sym_parameter_list] = STATE(299),
    [anon_sym_LPAREN] = ACTIONS(206),
    [anon_sym_SEMI] = ACTIONS(1899),
    [anon_sym_LBRACK] = ACTIONS(208),
    [sym_comment] = ACTIONS(49),
  },
  [469] = {
    [sym_function_definition] = STATE(986),
    [sym_declaration] = STATE(986),
    [sym__declaration_specifiers] = STATE(987),
    [sym_storage_class_specifier] = STATE(305),
    [sym_type_qualifier] = STATE(305),
    [sym__type_specifier] = STATE(304),
    [sym_sized_type_specifier] = STATE(304),
    [sym_enum_specifier] = STATE(304),
    [sym_struct_specifier] = STATE(304),
    [sym_union_specifier] = STATE(304),
    [sym__empty_declaration] = STATE(986),
    [sym_macro_type_specifier] = STATE(304),
    [sym_class_specifier] = STATE(304),
    [sym_dependent_type] = STATE(304),
    [sym_template_type] = STATE(94),
    [sym_scoped_type_identifier] = STATE(34),
    [sym_scoped_namespace_identifier] = STATE(81),
    [aux_sym__declaration_specifiers_repeat1] = STATE(305),
    [aux_sym_sized_type_specifier_repeat1] = STATE(306),
    [anon_sym_extern] = ACTIONS(154),
    [anon_sym_static] = ACTIONS(154),
    [anon_sym_register] = ACTIONS(154),
    [anon_sym_inline] = ACTIONS(154),
    [anon_sym_const] = ACTIONS(158),
    [anon_sym_restrict] = ACTIONS(158),
    [anon_sym_volatile] = ACTIONS(158),
    [anon_sym__Atomic] = ACTIONS(158),
    [anon_sym_mutable] = ACTIONS(158),
    [anon_sym_explicit] = ACTIONS(158),
    [anon_sym_constexpr] = ACTIONS(158),
    [anon_sym_unsigned] = ACTIONS(479),
    [anon_sym_long] = ACTIONS(479),
    [anon_sym_short] = ACTIONS(479),
    [sym_primitive_type] = ACTIONS(481),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_union] = ACTIONS(39),
    [sym_identifier] = ACTIONS(152),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(51),
    [sym_auto] = ACTIONS(481),
    [anon_sym_typename] = ACTIONS(483),
    [anon_sym_COLON_COLON] = ACTIONS(135),
  },
  [470] = {
    [sym_preproc_include] = STATE(989),
    [sym_preproc_def] = STATE(989),
    [sym_preproc_function_def] = STATE(989),
    [sym_preproc_call] = STATE(989),
    [sym_preproc_if] = STATE(989),
    [sym_preproc_ifdef] = STATE(989),
    [sym_function_definition] = STATE(989),
    [sym_declaration] = STATE(989),
    [sym_type_definition] = STATE(989),
    [sym__declaration_specifiers] = STATE(27),
    [sym_linkage_specification] = STATE(989),
    [sym__declarator] = STATE(28),
    [sym_pointer_declarator] = STATE(28),
    [sym_function_declarator] = STATE(29),
    [sym_array_declarator] = STATE(28),
    [sym_storage_class_specifier] = STATE(37),
    [sym_type_qualifier] = STATE(37),
    [sym__type_specifier] = STATE(30),
    [sym_sized_type_specifier] = STATE(30),
    [sym_enum_specifier] = STATE(30),
    [sym_struct_specifier] = STATE(30),
    [sym_union_specifier] = STATE(30),
    [sym__empty_declaration] = STATE(989),
    [sym_macro_type_specifier] = STATE(30),
    [sym_class_specifier] = STATE(30),
    [sym_dependent_type] = STATE(30),
    [sym_structured_binding_declaration] = STATE(989),
    [sym_template_declaration] = STATE(989),
    [sym_template_instantiation] = STATE(989),
    [sym_constructor_or_destructor_definition] = STATE(31),
    [sym_reference_declarator] = STATE(28),
    [sym_template_type] = STATE(32),
    [sym_template_function] = STATE(28),
    [sym_namespace_definition] = STATE(989),
    [sym_using_declaration] = STATE(989),
    [sym_alias_declaration] = STATE(989),
    [sym_destructor_name] = STATE(28),
    [sym_scoped_identifier] = STATE(33),
    [sym_scoped_type_identifier] = STATE(34),
    [sym_scoped_namespace_identifier] = STATE(35),
    [aux_sym_translation_unit_repeat1] = STATE(989),
    [aux_sym__declaration_specifiers_repeat1] = STATE(37),
    [aux_sym_sized_type_specifier_repeat1] = STATE(38),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(7),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(11),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(13),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(15),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(17),
    [sym_preproc_directive] = ACTIONS(19),
    [anon_sym_typedef] = ACTIONS(21),
    [anon_sym_extern] = ACTIONS(23),
    [anon_sym_RBRACE] = ACTIONS(1901),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_static] = ACTIONS(27),
    [anon_sym_register] = ACTIONS(27),
    [anon_sym_inline] = ACTIONS(27),
    [anon_sym_const] = ACTIONS(29),
    [anon_sym_restrict] = ACTIONS(29),
    [anon_sym_volatile] = ACTIONS(29),
    [anon_sym__Atomic] = ACTIONS(29),
    [anon_sym_mutable] = ACTIONS(29),
    [anon_sym_explicit] = ACTIONS(29),
    [anon_sym_constexpr] = ACTIONS(29),
    [anon_sym_unsigned] = ACTIONS(31),
    [anon_sym_long] = ACTIONS(31),
    [anon_sym_short] = ACTIONS(31),
    [sym_primitive_type] = ACTIONS(33),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_union] = ACTIONS(39),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(45),
    [sym_identifier] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(51),
    [sym_auto] = ACTIONS(33),
    [anon_sym_typename] = ACTIONS(53),
    [anon_sym_template] = ACTIONS(55),
    [anon_sym_namespace] = ACTIONS(57),
    [anon_sym_using] = ACTIONS(59),
    [anon_sym_COLON_COLON] = ACTIONS(61),
    [sym_operator_name] = ACTIONS(63),
  },
  [471] = {
    [sym_declaration_list] = STATE(990),
    [anon_sym_LBRACE] = ACTIONS(901),
    [sym_comment] = ACTIONS(49),
  },
  [472] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(495),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(495),
    [anon_sym_LPAREN] = ACTIONS(493),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(495),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(495),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(495),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(495),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(495),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(495),
    [sym_preproc_directive] = ACTIONS(495),
    [anon_sym_typedef] = ACTIONS(495),
    [anon_sym_extern] = ACTIONS(495),
    [anon_sym_STAR] = ACTIONS(493),
    [anon_sym_static] = ACTIONS(495),
    [anon_sym_register] = ACTIONS(495),
    [anon_sym_inline] = ACTIONS(495),
    [anon_sym_const] = ACTIONS(495),
    [anon_sym_restrict] = ACTIONS(495),
    [anon_sym_volatile] = ACTIONS(495),
    [anon_sym__Atomic] = ACTIONS(495),
    [anon_sym_mutable] = ACTIONS(495),
    [anon_sym_explicit] = ACTIONS(495),
    [anon_sym_constexpr] = ACTIONS(495),
    [anon_sym_unsigned] = ACTIONS(495),
    [anon_sym_long] = ACTIONS(495),
    [anon_sym_short] = ACTIONS(495),
    [sym_primitive_type] = ACTIONS(495),
    [anon_sym_enum] = ACTIONS(495),
    [anon_sym_struct] = ACTIONS(495),
    [anon_sym_union] = ACTIONS(495),
    [anon_sym_AMP] = ACTIONS(495),
    [anon_sym_AMP_AMP] = ACTIONS(493),
    [anon_sym_TILDE] = ACTIONS(493),
    [sym_identifier] = ACTIONS(495),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(495),
    [sym_auto] = ACTIONS(495),
    [anon_sym_typename] = ACTIONS(495),
    [anon_sym_template] = ACTIONS(495),
    [anon_sym_namespace] = ACTIONS(495),
    [anon_sym_using] = ACTIONS(495),
    [anon_sym_COLON_COLON] = ACTIONS(493),
    [sym_operator_name] = ACTIONS(493),
  },
  [473] = {
    [sym_template_argument_list] = STATE(203),
    [anon_sym_SEMI] = ACTIONS(1903),
    [anon_sym_EQ] = ACTIONS(1905),
    [anon_sym_LT] = ACTIONS(146),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(501),
  },
  [474] = {
    [sym_template_type] = STATE(117),
    [sym_scoped_identifier] = STATE(994),
    [sym_scoped_type_identifier] = STATE(47),
    [sym_scoped_namespace_identifier] = STATE(117),
    [sym_identifier] = ACTIONS(1907),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(186),
  },
  [475] = {
    [anon_sym_SEMI] = ACTIONS(1903),
    [sym_comment] = ACTIONS(49),
  },
  [476] = {
    [ts_builtin_sym_end] = ACTIONS(1909),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1911),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1911),
    [anon_sym_LPAREN] = ACTIONS(1909),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1911),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1911),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1911),
    [sym_preproc_directive] = ACTIONS(1911),
    [anon_sym_typedef] = ACTIONS(1911),
    [anon_sym_extern] = ACTIONS(1911),
    [anon_sym_RBRACE] = ACTIONS(1909),
    [anon_sym_STAR] = ACTIONS(1909),
    [anon_sym_static] = ACTIONS(1911),
    [anon_sym_register] = ACTIONS(1911),
    [anon_sym_inline] = ACTIONS(1911),
    [anon_sym_const] = ACTIONS(1911),
    [anon_sym_restrict] = ACTIONS(1911),
    [anon_sym_volatile] = ACTIONS(1911),
    [anon_sym__Atomic] = ACTIONS(1911),
    [anon_sym_mutable] = ACTIONS(1911),
    [anon_sym_explicit] = ACTIONS(1911),
    [anon_sym_constexpr] = ACTIONS(1911),
    [anon_sym_unsigned] = ACTIONS(1911),
    [anon_sym_long] = ACTIONS(1911),
    [anon_sym_short] = ACTIONS(1911),
    [sym_primitive_type] = ACTIONS(1911),
    [anon_sym_enum] = ACTIONS(1911),
    [anon_sym_struct] = ACTIONS(1911),
    [anon_sym_union] = ACTIONS(1911),
    [anon_sym_AMP] = ACTIONS(1911),
    [anon_sym_AMP_AMP] = ACTIONS(1909),
    [anon_sym_TILDE] = ACTIONS(1909),
    [sym_identifier] = ACTIONS(1911),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(1911),
    [sym_auto] = ACTIONS(1911),
    [anon_sym_typename] = ACTIONS(1911),
    [anon_sym_template] = ACTIONS(1911),
    [anon_sym_namespace] = ACTIONS(1911),
    [anon_sym_using] = ACTIONS(1911),
    [anon_sym_COLON_COLON] = ACTIONS(1909),
    [sym_operator_name] = ACTIONS(1909),
  },
  [477] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(524),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(524),
    [anon_sym_LPAREN] = ACTIONS(522),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(524),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(524),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(524),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(524),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(524),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(524),
    [sym_preproc_directive] = ACTIONS(524),
    [anon_sym_typedef] = ACTIONS(524),
    [anon_sym_extern] = ACTIONS(524),
    [anon_sym_STAR] = ACTIONS(522),
    [anon_sym_static] = ACTIONS(524),
    [anon_sym_register] = ACTIONS(524),
    [anon_sym_inline] = ACTIONS(524),
    [anon_sym_const] = ACTIONS(524),
    [anon_sym_restrict] = ACTIONS(524),
    [anon_sym_volatile] = ACTIONS(524),
    [anon_sym__Atomic] = ACTIONS(524),
    [anon_sym_mutable] = ACTIONS(524),
    [anon_sym_explicit] = ACTIONS(524),
    [anon_sym_constexpr] = ACTIONS(524),
    [anon_sym_unsigned] = ACTIONS(524),
    [anon_sym_long] = ACTIONS(524),
    [anon_sym_short] = ACTIONS(524),
    [sym_primitive_type] = ACTIONS(524),
    [anon_sym_enum] = ACTIONS(524),
    [anon_sym_struct] = ACTIONS(524),
    [anon_sym_union] = ACTIONS(524),
    [anon_sym_AMP] = ACTIONS(524),
    [anon_sym_AMP_AMP] = ACTIONS(522),
    [anon_sym_TILDE] = ACTIONS(522),
    [sym_identifier] = ACTIONS(524),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(524),
    [sym_auto] = ACTIONS(524),
    [anon_sym_typename] = ACTIONS(524),
    [anon_sym_template] = ACTIONS(524),
    [anon_sym_namespace] = ACTIONS(524),
    [anon_sym_using] = ACTIONS(524),
    [anon_sym_COLON_COLON] = ACTIONS(522),
    [sym_operator_name] = ACTIONS(522),
  },
  [478] = {
    [sym_compound_statement] = STATE(997),
    [sym_parameter_list] = STATE(332),
    [sym_argument_list] = STATE(333),
    [sym_initializer_list] = STATE(333),
    [aux_sym_declaration_repeat1] = STATE(998),
    [anon_sym_LPAREN] = ACTIONS(536),
    [anon_sym_COMMA] = ACTIONS(538),
    [anon_sym_SEMI] = ACTIONS(1913),
    [anon_sym_LBRACE] = ACTIONS(1915),
    [anon_sym_LBRACK] = ACTIONS(208),
    [anon_sym_EQ] = ACTIONS(544),
    [sym_comment] = ACTIONS(49),
  },
  [479] = {
    [aux_sym_declaration_repeat1] = STATE(998),
    [anon_sym_COMMA] = ACTIONS(538),
    [anon_sym_SEMI] = ACTIONS(1913),
    [sym_comment] = ACTIONS(49),
  },
  [480] = {
    [sym_argument_list] = STATE(1000),
    [sym_initializer_list] = STATE(1000),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_LBRACE] = ACTIONS(548),
    [anon_sym_EQ] = ACTIONS(1917),
    [sym_comment] = ACTIONS(49),
  },
  [481] = {
    [sym_argument_list] = STATE(1002),
    [sym_initializer_list] = STATE(1002),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_LBRACE] = ACTIONS(548),
    [anon_sym_EQ] = ACTIONS(1919),
    [sym_comment] = ACTIONS(49),
  },
  [482] = {
    [sym_preproc_include] = STATE(1004),
    [sym_preproc_def] = STATE(1004),
    [sym_preproc_function_def] = STATE(1004),
    [sym_preproc_call] = STATE(1004),
    [sym_preproc_if_in_compound_statement] = STATE(410),
    [sym_preproc_ifdef_in_compound_statement] = STATE(411),
    [sym_declaration] = STATE(1004),
    [sym_type_definition] = STATE(1004),
    [sym__declaration_specifiers] = STATE(412),
    [sym_compound_statement] = STATE(1004),
    [sym_storage_class_specifier] = STATE(419),
    [sym_type_qualifier] = STATE(419),
    [sym__type_specifier] = STATE(30),
    [sym_sized_type_specifier] = STATE(30),
    [sym_enum_specifier] = STATE(30),
    [sym_struct_specifier] = STATE(30),
    [sym_union_specifier] = STATE(30),
    [sym_labeled_statement] = STATE(1004),
    [sym_expression_statement] = STATE(1004),
    [sym_if_statement] = STATE(1004),
    [sym_switch_statement] = STATE(1004),
    [sym_case_statement] = STATE(1004),
    [sym_while_statement] = STATE(1004),
    [sym_do_statement] = STATE(1004),
    [sym_for_statement] = STATE(1004),
    [sym_return_statement] = STATE(1004),
    [sym_break_statement] = STATE(1004),
    [sym_continue_statement] = STATE(1004),
    [sym_goto_statement] = STATE(1004),
    [sym__expression] = STATE(413),
    [sym_comma_expression] = STATE(414),
    [sym_conditional_expression] = STATE(413),
    [sym_assignment_expression] = STATE(413),
    [sym_pointer_expression] = STATE(413),
    [sym_logical_expression] = STATE(413),
    [sym_bitwise_expression] = STATE(413),
    [sym_equality_expression] = STATE(413),
    [sym_relational_expression] = STATE(413),
    [sym_shift_expression] = STATE(413),
    [sym_math_expression] = STATE(413),
    [sym_cast_expression] = STATE(413),
    [sym_sizeof_expression] = STATE(413),
    [sym_subscript_expression] = STATE(413),
    [sym_call_expression] = STATE(413),
    [sym_field_expression] = STATE(413),
    [sym_compound_literal_expression] = STATE(413),
    [sym_parenthesized_expression] = STATE(413),
    [sym_concatenated_string] = STATE(413),
    [sym__empty_declaration] = STATE(1004),
    [sym_macro_type_specifier] = STATE(30),
    [sym_class_specifier] = STATE(30),
    [sym_dependent_type] = STATE(30),
    [sym_structured_binding_declaration] = STATE(1004),
    [sym_template_type] = STATE(415),
    [sym_template_function] = STATE(413),
    [sym_for_range_loop] = STATE(1004),
    [sym_new_expression] = STATE(413),
    [sym_delete_expression] = STATE(413),
    [sym_lambda_expression] = STATE(413),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(416),
    [sym_scoped_namespace_identifier] = STATE(417),
    [aux_sym_preproc_if_in_compound_statement_repeat1] = STATE(1004),
    [aux_sym__declaration_specifiers_repeat1] = STATE(419),
    [aux_sym_sized_type_specifier_repeat1] = STATE(38),
    [sym_raw_string_literal] = ACTIONS(620),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(622),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(624),
    [anon_sym_LPAREN] = ACTIONS(626),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(628),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(630),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(632),
    [sym_preproc_directive] = ACTIONS(634),
    [anon_sym_SEMI] = ACTIONS(636),
    [anon_sym_typedef] = ACTIONS(638),
    [anon_sym_extern] = ACTIONS(154),
    [anon_sym_LBRACE] = ACTIONS(640),
    [anon_sym_RBRACE] = ACTIONS(1921),
    [anon_sym_STAR] = ACTIONS(644),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_static] = ACTIONS(154),
    [anon_sym_register] = ACTIONS(154),
    [anon_sym_inline] = ACTIONS(154),
    [anon_sym_const] = ACTIONS(158),
    [anon_sym_restrict] = ACTIONS(158),
    [anon_sym_volatile] = ACTIONS(158),
    [anon_sym__Atomic] = ACTIONS(158),
    [anon_sym_mutable] = ACTIONS(158),
    [anon_sym_explicit] = ACTIONS(158),
    [anon_sym_constexpr] = ACTIONS(158),
    [anon_sym_unsigned] = ACTIONS(31),
    [anon_sym_long] = ACTIONS(31),
    [anon_sym_short] = ACTIONS(31),
    [sym_primitive_type] = ACTIONS(33),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_union] = ACTIONS(39),
    [anon_sym_if] = ACTIONS(646),
    [anon_sym_switch] = ACTIONS(648),
    [anon_sym_case] = ACTIONS(650),
    [anon_sym_default] = ACTIONS(652),
    [anon_sym_while] = ACTIONS(654),
    [anon_sym_do] = ACTIONS(656),
    [anon_sym_for] = ACTIONS(658),
    [anon_sym_return] = ACTIONS(660),
    [anon_sym_break] = ACTIONS(662),
    [anon_sym_continue] = ACTIONS(664),
    [anon_sym_goto] = ACTIONS(666),
    [anon_sym_AMP] = ACTIONS(644),
    [anon_sym_BANG] = ACTIONS(668),
    [anon_sym_TILDE] = ACTIONS(670),
    [anon_sym_PLUS] = ACTIONS(672),
    [anon_sym_DASH] = ACTIONS(672),
    [anon_sym_DASH_DASH] = ACTIONS(674),
    [anon_sym_PLUS_PLUS] = ACTIONS(674),
    [anon_sym_sizeof] = ACTIONS(676),
    [sym_number_literal] = ACTIONS(620),
    [sym_char_literal] = ACTIONS(620),
    [sym_string_literal] = ACTIONS(678),
    [sym_true] = ACTIONS(680),
    [sym_false] = ACTIONS(680),
    [sym_null] = ACTIONS(680),
    [sym_identifier] = ACTIONS(682),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(51),
    [sym_auto] = ACTIONS(33),
    [anon_sym_typename] = ACTIONS(53),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(684),
    [anon_sym_delete] = ACTIONS(686),
    [sym_nullptr] = ACTIONS(680),
  },
  [483] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(694),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(694),
    [anon_sym_LPAREN] = ACTIONS(692),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(694),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(694),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(694),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(694),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(694),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(694),
    [sym_preproc_directive] = ACTIONS(694),
    [anon_sym_typedef] = ACTIONS(694),
    [anon_sym_extern] = ACTIONS(694),
    [anon_sym_STAR] = ACTIONS(692),
    [anon_sym_static] = ACTIONS(694),
    [anon_sym_register] = ACTIONS(694),
    [anon_sym_inline] = ACTIONS(694),
    [anon_sym_const] = ACTIONS(694),
    [anon_sym_restrict] = ACTIONS(694),
    [anon_sym_volatile] = ACTIONS(694),
    [anon_sym__Atomic] = ACTIONS(694),
    [anon_sym_mutable] = ACTIONS(694),
    [anon_sym_explicit] = ACTIONS(694),
    [anon_sym_constexpr] = ACTIONS(694),
    [anon_sym_unsigned] = ACTIONS(694),
    [anon_sym_long] = ACTIONS(694),
    [anon_sym_short] = ACTIONS(694),
    [sym_primitive_type] = ACTIONS(694),
    [anon_sym_enum] = ACTIONS(694),
    [anon_sym_struct] = ACTIONS(694),
    [anon_sym_union] = ACTIONS(694),
    [anon_sym_AMP] = ACTIONS(694),
    [anon_sym_AMP_AMP] = ACTIONS(692),
    [anon_sym_TILDE] = ACTIONS(692),
    [sym_identifier] = ACTIONS(694),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(694),
    [sym_auto] = ACTIONS(694),
    [anon_sym_typename] = ACTIONS(694),
    [anon_sym_template] = ACTIONS(694),
    [anon_sym_namespace] = ACTIONS(694),
    [anon_sym_using] = ACTIONS(694),
    [anon_sym_COLON_COLON] = ACTIONS(692),
    [sym_operator_name] = ACTIONS(692),
  },
  [484] = {
    [sym_compound_statement] = STATE(1005),
    [anon_sym_LBRACE] = ACTIONS(915),
    [sym_comment] = ACTIONS(49),
  },
  [485] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(1923),
    [sym_comment] = ACTIONS(49),
  },
  [486] = {
    [sym_preproc_include] = STATE(486),
    [sym_preproc_def] = STATE(486),
    [sym_preproc_function_def] = STATE(486),
    [sym_preproc_call] = STATE(486),
    [sym_preproc_if] = STATE(486),
    [sym_preproc_ifdef] = STATE(486),
    [sym_function_definition] = STATE(486),
    [sym_declaration] = STATE(486),
    [sym_type_definition] = STATE(486),
    [sym__declaration_specifiers] = STATE(176),
    [sym_linkage_specification] = STATE(486),
    [sym__declarator] = STATE(28),
    [sym_pointer_declarator] = STATE(28),
    [sym_function_declarator] = STATE(177),
    [sym_array_declarator] = STATE(28),
    [sym_storage_class_specifier] = STATE(180),
    [sym_type_qualifier] = STATE(180),
    [sym__type_specifier] = STATE(30),
    [sym_sized_type_specifier] = STATE(30),
    [sym_enum_specifier] = STATE(30),
    [sym_struct_specifier] = STATE(30),
    [sym_union_specifier] = STATE(30),
    [sym__empty_declaration] = STATE(486),
    [sym_macro_type_specifier] = STATE(30),
    [sym_class_specifier] = STATE(30),
    [sym_dependent_type] = STATE(30),
    [sym_structured_binding_declaration] = STATE(486),
    [sym_template_declaration] = STATE(486),
    [sym_template_instantiation] = STATE(486),
    [sym_constructor_or_destructor_definition] = STATE(178),
    [sym_reference_declarator] = STATE(28),
    [sym_template_type] = STATE(32),
    [sym_template_function] = STATE(28),
    [sym_namespace_definition] = STATE(486),
    [sym_using_declaration] = STATE(486),
    [sym_alias_declaration] = STATE(486),
    [sym_destructor_name] = STATE(28),
    [sym_scoped_identifier] = STATE(33),
    [sym_scoped_type_identifier] = STATE(34),
    [sym_scoped_namespace_identifier] = STATE(35),
    [aux_sym_translation_unit_repeat1] = STATE(486),
    [aux_sym__declaration_specifiers_repeat1] = STATE(180),
    [aux_sym_sized_type_specifier_repeat1] = STATE(38),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1925),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1928),
    [anon_sym_LPAREN] = ACTIONS(720),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1931),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(1934),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1936),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1939),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(1934),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(1934),
    [sym_preproc_directive] = ACTIONS(1942),
    [anon_sym_typedef] = ACTIONS(1945),
    [anon_sym_extern] = ACTIONS(1948),
    [anon_sym_STAR] = ACTIONS(741),
    [anon_sym_static] = ACTIONS(744),
    [anon_sym_register] = ACTIONS(744),
    [anon_sym_inline] = ACTIONS(744),
    [anon_sym_const] = ACTIONS(747),
    [anon_sym_restrict] = ACTIONS(747),
    [anon_sym_volatile] = ACTIONS(747),
    [anon_sym__Atomic] = ACTIONS(747),
    [anon_sym_mutable] = ACTIONS(747),
    [anon_sym_explicit] = ACTIONS(747),
    [anon_sym_constexpr] = ACTIONS(747),
    [anon_sym_unsigned] = ACTIONS(750),
    [anon_sym_long] = ACTIONS(750),
    [anon_sym_short] = ACTIONS(750),
    [sym_primitive_type] = ACTIONS(753),
    [anon_sym_enum] = ACTIONS(756),
    [anon_sym_struct] = ACTIONS(759),
    [anon_sym_union] = ACTIONS(762),
    [anon_sym_AMP] = ACTIONS(765),
    [anon_sym_AMP_AMP] = ACTIONS(768),
    [anon_sym_TILDE] = ACTIONS(771),
    [sym_identifier] = ACTIONS(774),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(777),
    [sym_auto] = ACTIONS(753),
    [anon_sym_typename] = ACTIONS(780),
    [anon_sym_template] = ACTIONS(1951),
    [anon_sym_namespace] = ACTIONS(1954),
    [anon_sym_using] = ACTIONS(1957),
    [anon_sym_COLON_COLON] = ACTIONS(792),
    [sym_operator_name] = ACTIONS(795),
  },
  [487] = {
    [sym_compound_statement] = STATE(1005),
    [sym_field_initializer_list] = STATE(1007),
    [anon_sym_LPAREN] = ACTIONS(210),
    [anon_sym_LBRACE] = ACTIONS(915),
    [anon_sym_LBRACK] = ACTIONS(210),
    [anon_sym_COLON] = ACTIONS(214),
    [sym_comment] = ACTIONS(49),
  },
  [488] = {
    [ts_builtin_sym_end] = ACTIONS(1960),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1962),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1962),
    [anon_sym_LPAREN] = ACTIONS(1960),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1962),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1962),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1962),
    [sym_preproc_directive] = ACTIONS(1962),
    [anon_sym_typedef] = ACTIONS(1962),
    [anon_sym_extern] = ACTIONS(1962),
    [anon_sym_RBRACE] = ACTIONS(1960),
    [anon_sym_STAR] = ACTIONS(1960),
    [anon_sym_static] = ACTIONS(1962),
    [anon_sym_register] = ACTIONS(1962),
    [anon_sym_inline] = ACTIONS(1962),
    [anon_sym_const] = ACTIONS(1962),
    [anon_sym_restrict] = ACTIONS(1962),
    [anon_sym_volatile] = ACTIONS(1962),
    [anon_sym__Atomic] = ACTIONS(1962),
    [anon_sym_mutable] = ACTIONS(1962),
    [anon_sym_explicit] = ACTIONS(1962),
    [anon_sym_constexpr] = ACTIONS(1962),
    [anon_sym_unsigned] = ACTIONS(1962),
    [anon_sym_long] = ACTIONS(1962),
    [anon_sym_short] = ACTIONS(1962),
    [sym_primitive_type] = ACTIONS(1962),
    [anon_sym_enum] = ACTIONS(1962),
    [anon_sym_struct] = ACTIONS(1962),
    [anon_sym_union] = ACTIONS(1962),
    [anon_sym_AMP] = ACTIONS(1962),
    [anon_sym_AMP_AMP] = ACTIONS(1960),
    [anon_sym_TILDE] = ACTIONS(1960),
    [sym_identifier] = ACTIONS(1962),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(1962),
    [sym_auto] = ACTIONS(1962),
    [anon_sym_typename] = ACTIONS(1962),
    [anon_sym_template] = ACTIONS(1962),
    [anon_sym_namespace] = ACTIONS(1962),
    [anon_sym_using] = ACTIONS(1962),
    [anon_sym_COLON_COLON] = ACTIONS(1960),
    [sym_operator_name] = ACTIONS(1960),
  },
  [489] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(1964),
    [sym_comment] = ACTIONS(49),
  },
  [490] = {
    [ts_builtin_sym_end] = ACTIONS(1966),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1968),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1968),
    [anon_sym_LPAREN] = ACTIONS(1966),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1968),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1968),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1968),
    [sym_preproc_directive] = ACTIONS(1968),
    [anon_sym_typedef] = ACTIONS(1968),
    [anon_sym_extern] = ACTIONS(1968),
    [anon_sym_RBRACE] = ACTIONS(1966),
    [anon_sym_STAR] = ACTIONS(1966),
    [anon_sym_static] = ACTIONS(1968),
    [anon_sym_register] = ACTIONS(1968),
    [anon_sym_inline] = ACTIONS(1968),
    [anon_sym_const] = ACTIONS(1968),
    [anon_sym_restrict] = ACTIONS(1968),
    [anon_sym_volatile] = ACTIONS(1968),
    [anon_sym__Atomic] = ACTIONS(1968),
    [anon_sym_mutable] = ACTIONS(1968),
    [anon_sym_explicit] = ACTIONS(1968),
    [anon_sym_constexpr] = ACTIONS(1968),
    [anon_sym_unsigned] = ACTIONS(1968),
    [anon_sym_long] = ACTIONS(1968),
    [anon_sym_short] = ACTIONS(1968),
    [sym_primitive_type] = ACTIONS(1968),
    [anon_sym_enum] = ACTIONS(1968),
    [anon_sym_struct] = ACTIONS(1968),
    [anon_sym_union] = ACTIONS(1968),
    [anon_sym_AMP] = ACTIONS(1968),
    [anon_sym_AMP_AMP] = ACTIONS(1966),
    [anon_sym_TILDE] = ACTIONS(1966),
    [sym_identifier] = ACTIONS(1968),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(1968),
    [sym_auto] = ACTIONS(1968),
    [anon_sym_typename] = ACTIONS(1968),
    [anon_sym_template] = ACTIONS(1968),
    [anon_sym_namespace] = ACTIONS(1968),
    [anon_sym_using] = ACTIONS(1968),
    [anon_sym_COLON_COLON] = ACTIONS(1966),
    [sym_operator_name] = ACTIONS(1966),
  },
  [491] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(1970),
    [sym_comment] = ACTIONS(49),
  },
  [492] = {
    [ts_builtin_sym_end] = ACTIONS(1972),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1974),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1974),
    [anon_sym_LPAREN] = ACTIONS(1972),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1974),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1974),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1974),
    [sym_preproc_directive] = ACTIONS(1974),
    [anon_sym_typedef] = ACTIONS(1974),
    [anon_sym_extern] = ACTIONS(1974),
    [anon_sym_RBRACE] = ACTIONS(1972),
    [anon_sym_STAR] = ACTIONS(1972),
    [anon_sym_static] = ACTIONS(1974),
    [anon_sym_register] = ACTIONS(1974),
    [anon_sym_inline] = ACTIONS(1974),
    [anon_sym_const] = ACTIONS(1974),
    [anon_sym_restrict] = ACTIONS(1974),
    [anon_sym_volatile] = ACTIONS(1974),
    [anon_sym__Atomic] = ACTIONS(1974),
    [anon_sym_mutable] = ACTIONS(1974),
    [anon_sym_explicit] = ACTIONS(1974),
    [anon_sym_constexpr] = ACTIONS(1974),
    [anon_sym_unsigned] = ACTIONS(1974),
    [anon_sym_long] = ACTIONS(1974),
    [anon_sym_short] = ACTIONS(1974),
    [sym_primitive_type] = ACTIONS(1974),
    [anon_sym_enum] = ACTIONS(1974),
    [anon_sym_struct] = ACTIONS(1974),
    [anon_sym_union] = ACTIONS(1974),
    [anon_sym_AMP] = ACTIONS(1974),
    [anon_sym_AMP_AMP] = ACTIONS(1972),
    [anon_sym_TILDE] = ACTIONS(1972),
    [sym_identifier] = ACTIONS(1974),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(1974),
    [sym_auto] = ACTIONS(1974),
    [anon_sym_typename] = ACTIONS(1974),
    [anon_sym_template] = ACTIONS(1974),
    [anon_sym_namespace] = ACTIONS(1974),
    [anon_sym_using] = ACTIONS(1974),
    [anon_sym_COLON_COLON] = ACTIONS(1972),
    [sym_operator_name] = ACTIONS(1972),
  },
  [493] = {
    [anon_sym_RBRACE] = ACTIONS(1976),
    [sym_comment] = ACTIONS(49),
  },
  [494] = {
    [anon_sym_LPAREN] = ACTIONS(985),
    [anon_sym_STAR] = ACTIONS(985),
    [sym_identifier] = ACTIONS(985),
    [sym_comment] = ACTIONS(49),
  },
  [495] = {
    [aux_sym_enumerator_list_repeat1] = STATE(1012),
    [anon_sym_COMMA] = ACTIONS(1978),
    [anon_sym_RBRACE] = ACTIONS(1976),
    [sym_comment] = ACTIONS(49),
  },
  [496] = {
    [anon_sym_LPAREN] = ACTIONS(995),
    [anon_sym_STAR] = ACTIONS(995),
    [sym_identifier] = ACTIONS(995),
    [sym_comment] = ACTIONS(49),
  },
  [497] = {
    [anon_sym_LPAREN] = ACTIONS(1007),
    [anon_sym_STAR] = ACTIONS(1007),
    [sym_identifier] = ACTIONS(1007),
    [sym_comment] = ACTIONS(49),
  },
  [498] = {
    [sym_preproc_if_in_field_declaration_list] = STATE(246),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(247),
    [sym_type_definition] = STATE(563),
    [sym__declaration_specifiers] = STATE(248),
    [sym__declarator] = STATE(249),
    [sym_pointer_declarator] = STATE(249),
    [sym_function_declarator] = STATE(250),
    [sym_array_declarator] = STATE(249),
    [sym_storage_class_specifier] = STATE(257),
    [sym_type_qualifier] = STATE(257),
    [sym__type_specifier] = STATE(251),
    [sym_sized_type_specifier] = STATE(251),
    [sym_enum_specifier] = STATE(251),
    [sym_struct_specifier] = STATE(251),
    [sym_union_specifier] = STATE(251),
    [sym__field_declaration_list_item] = STATE(563),
    [sym_field_declaration] = STATE(563),
    [sym_macro_type_specifier] = STATE(251),
    [sym_class_specifier] = STATE(251),
    [sym_dependent_type] = STATE(251),
    [sym_template_declaration] = STATE(563),
    [sym_inline_method_definition] = STATE(252),
    [sym_constructor_or_destructor_definition] = STATE(252),
    [sym_constructor_or_destructor_declaration] = STATE(253),
    [sym_friend_declaration] = STATE(563),
    [sym_access_specifier] = STATE(563),
    [sym_reference_declarator] = STATE(249),
    [sym_template_type] = STATE(254),
    [sym_template_function] = STATE(249),
    [sym_using_declaration] = STATE(563),
    [sym_alias_declaration] = STATE(563),
    [sym_destructor_name] = STATE(249),
    [sym_scoped_identifier] = STATE(33),
    [sym_scoped_type_identifier] = STATE(34),
    [sym_scoped_namespace_identifier] = STATE(255),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(563),
    [aux_sym__declaration_specifiers_repeat1] = STATE(257),
    [aux_sym_sized_type_specifier_repeat1] = STATE(258),
    [anon_sym_LPAREN] = ACTIONS(11),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(358),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(360),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(362),
    [anon_sym_typedef] = ACTIONS(364),
    [anon_sym_extern] = ACTIONS(27),
    [anon_sym_RBRACE] = ACTIONS(1980),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_static] = ACTIONS(27),
    [anon_sym_register] = ACTIONS(27),
    [anon_sym_inline] = ACTIONS(27),
    [anon_sym_const] = ACTIONS(29),
    [anon_sym_restrict] = ACTIONS(29),
    [anon_sym_volatile] = ACTIONS(29),
    [anon_sym__Atomic] = ACTIONS(29),
    [anon_sym_mutable] = ACTIONS(29),
    [anon_sym_explicit] = ACTIONS(29),
    [anon_sym_constexpr] = ACTIONS(29),
    [anon_sym_unsigned] = ACTIONS(368),
    [anon_sym_long] = ACTIONS(368),
    [anon_sym_short] = ACTIONS(368),
    [sym_primitive_type] = ACTIONS(370),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(372),
    [anon_sym_union] = ACTIONS(374),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(45),
    [sym_identifier] = ACTIONS(376),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(378),
    [anon_sym_public] = ACTIONS(380),
    [sym_auto] = ACTIONS(370),
    [anon_sym_typename] = ACTIONS(382),
    [anon_sym_template] = ACTIONS(384),
    [anon_sym_friend] = ACTIONS(386),
    [anon_sym_private] = ACTIONS(380),
    [anon_sym_protected] = ACTIONS(380),
    [anon_sym_using] = ACTIONS(388),
    [anon_sym_COLON_COLON] = ACTIONS(390),
    [sym_operator_name] = ACTIONS(392),
  },
  [499] = {
    [anon_sym_LPAREN] = ACTIONS(1075),
    [anon_sym_STAR] = ACTIONS(1075),
    [sym_identifier] = ACTIONS(1075),
    [sym_comment] = ACTIONS(49),
  },
  [500] = {
    [sym_field_declaration_list] = STATE(1014),
    [anon_sym_LBRACE] = ACTIONS(315),
    [sym_comment] = ACTIONS(49),
  },
  [501] = {
    [anon_sym_LPAREN] = ACTIONS(1081),
    [anon_sym_STAR] = ACTIONS(1081),
    [sym_identifier] = ACTIONS(1081),
    [sym_comment] = ACTIONS(49),
  },
  [502] = {
    [sym_field_declaration_list] = STATE(1015),
    [anon_sym_LBRACE] = ACTIONS(315),
    [sym_comment] = ACTIONS(49),
  },
  [503] = {
    [anon_sym_LPAREN] = ACTIONS(1111),
    [anon_sym_LBRACE] = ACTIONS(1111),
    [anon_sym_STAR] = ACTIONS(1111),
    [anon_sym_COLON] = ACTIONS(1113),
    [sym_identifier] = ACTIONS(1111),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(1111),
  },
  [504] = {
    [aux_sym_template_argument_list_repeat1] = STATE(1017),
    [anon_sym_COMMA] = ACTIONS(1127),
    [anon_sym_GT] = ACTIONS(1982),
    [sym_comment] = ACTIONS(49),
  },
  [505] = {
    [anon_sym_LPAREN] = ACTIONS(1140),
    [anon_sym_COMMA] = ACTIONS(1140),
    [anon_sym_RPAREN] = ACTIONS(1140),
    [anon_sym_SEMI] = ACTIONS(1140),
    [anon_sym_LBRACE] = ACTIONS(1140),
    [anon_sym_STAR] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1140),
    [anon_sym_COLON] = ACTIONS(1142),
    [anon_sym_AMP] = ACTIONS(1142),
    [anon_sym_AMP_AMP] = ACTIONS(1140),
    [anon_sym_LT] = ACTIONS(1140),
    [anon_sym_GT] = ACTIONS(1140),
    [sym_identifier] = ACTIONS(1140),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(1144),
  },
  [506] = {
    [anon_sym_LPAREN] = ACTIONS(1150),
    [anon_sym_STAR] = ACTIONS(1150),
    [sym_identifier] = ACTIONS(1150),
    [sym_comment] = ACTIONS(49),
  },
  [507] = {
    [sym_field_declaration_list] = STATE(1018),
    [anon_sym_LBRACE] = ACTIONS(315),
    [sym_comment] = ACTIONS(49),
  },
  [508] = {
    [sym__type_declarator] = STATE(510),
    [sym_pointer_type_declarator] = STATE(213),
    [sym_function_type_declarator] = STATE(214),
    [sym_array_type_declarator] = STATE(215),
    [anon_sym_LPAREN] = ACTIONS(327),
    [anon_sym_STAR] = ACTIONS(949),
    [sym_identifier] = ACTIONS(331),
    [sym_comment] = ACTIONS(49),
  },
  [509] = {
    [sym_parameter_list] = STATE(513),
    [anon_sym_LPAREN] = ACTIONS(206),
    [anon_sym_RPAREN] = ACTIONS(1984),
    [anon_sym_LBRACK] = ACTIONS(955),
    [sym_comment] = ACTIONS(49),
  },
  [510] = {
    [sym_parameter_list] = STATE(513),
    [anon_sym_LPAREN] = ACTIONS(206),
    [anon_sym_RPAREN] = ACTIONS(1986),
    [anon_sym_SEMI] = ACTIONS(1986),
    [anon_sym_LBRACK] = ACTIONS(955),
    [sym_comment] = ACTIONS(49),
  },
  [511] = {
    [ts_builtin_sym_end] = ACTIONS(1988),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1990),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1990),
    [anon_sym_LPAREN] = ACTIONS(1988),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1990),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1990),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1990),
    [sym_preproc_directive] = ACTIONS(1990),
    [anon_sym_typedef] = ACTIONS(1990),
    [anon_sym_extern] = ACTIONS(1990),
    [anon_sym_RBRACE] = ACTIONS(1988),
    [anon_sym_STAR] = ACTIONS(1988),
    [anon_sym_static] = ACTIONS(1990),
    [anon_sym_register] = ACTIONS(1990),
    [anon_sym_inline] = ACTIONS(1990),
    [anon_sym_const] = ACTIONS(1990),
    [anon_sym_restrict] = ACTIONS(1990),
    [anon_sym_volatile] = ACTIONS(1990),
    [anon_sym__Atomic] = ACTIONS(1990),
    [anon_sym_mutable] = ACTIONS(1990),
    [anon_sym_explicit] = ACTIONS(1990),
    [anon_sym_constexpr] = ACTIONS(1990),
    [anon_sym_unsigned] = ACTIONS(1990),
    [anon_sym_long] = ACTIONS(1990),
    [anon_sym_short] = ACTIONS(1990),
    [sym_primitive_type] = ACTIONS(1990),
    [anon_sym_enum] = ACTIONS(1990),
    [anon_sym_struct] = ACTIONS(1990),
    [anon_sym_union] = ACTIONS(1990),
    [anon_sym_AMP] = ACTIONS(1990),
    [anon_sym_AMP_AMP] = ACTIONS(1988),
    [anon_sym_TILDE] = ACTIONS(1988),
    [sym_identifier] = ACTIONS(1990),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(1990),
    [sym_auto] = ACTIONS(1990),
    [anon_sym_typename] = ACTIONS(1990),
    [anon_sym_template] = ACTIONS(1990),
    [anon_sym_namespace] = ACTIONS(1990),
    [anon_sym_using] = ACTIONS(1990),
    [anon_sym_COLON_COLON] = ACTIONS(1988),
    [sym_operator_name] = ACTIONS(1988),
  },
  [512] = {
    [sym__declaration_specifiers] = STATE(1021),
    [sym_storage_class_specifier] = STATE(374),
    [sym_type_qualifier] = STATE(374),
    [sym__type_specifier] = STATE(367),
    [sym_sized_type_specifier] = STATE(367),
    [sym_enum_specifier] = STATE(367),
    [sym_struct_specifier] = STATE(367),
    [sym_union_specifier] = STATE(367),
    [sym__expression] = STATE(1022),
    [sym_conditional_expression] = STATE(1022),
    [sym_assignment_expression] = STATE(1022),
    [sym_pointer_expression] = STATE(1022),
    [sym_logical_expression] = STATE(1022),
    [sym_bitwise_expression] = STATE(1022),
    [sym_equality_expression] = STATE(1022),
    [sym_relational_expression] = STATE(1022),
    [sym_shift_expression] = STATE(1022),
    [sym_math_expression] = STATE(1022),
    [sym_cast_expression] = STATE(1022),
    [sym_sizeof_expression] = STATE(1022),
    [sym_subscript_expression] = STATE(1022),
    [sym_call_expression] = STATE(1022),
    [sym_field_expression] = STATE(1022),
    [sym_compound_literal_expression] = STATE(1022),
    [sym_parenthesized_expression] = STATE(1022),
    [sym_concatenated_string] = STATE(1022),
    [sym_macro_type_specifier] = STATE(367),
    [sym_class_specifier] = STATE(367),
    [sym_dependent_type] = STATE(367),
    [sym_template_type] = STATE(369),
    [sym_template_function] = STATE(1022),
    [sym_new_expression] = STATE(1022),
    [sym_delete_expression] = STATE(1022),
    [sym_lambda_expression] = STATE(1022),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(372),
    [sym_scoped_namespace_identifier] = STATE(373),
    [aux_sym__declaration_specifiers_repeat1] = STATE(374),
    [aux_sym_sized_type_specifier_repeat1] = STATE(375),
    [sym_raw_string_literal] = ACTIONS(1992),
    [anon_sym_LPAREN] = ACTIONS(566),
    [anon_sym_extern] = ACTIONS(154),
    [anon_sym_STAR] = ACTIONS(568),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_RBRACK] = ACTIONS(1994),
    [anon_sym_static] = ACTIONS(154),
    [anon_sym_register] = ACTIONS(154),
    [anon_sym_inline] = ACTIONS(154),
    [anon_sym_const] = ACTIONS(158),
    [anon_sym_restrict] = ACTIONS(158),
    [anon_sym_volatile] = ACTIONS(158),
    [anon_sym__Atomic] = ACTIONS(158),
    [anon_sym_mutable] = ACTIONS(158),
    [anon_sym_explicit] = ACTIONS(158),
    [anon_sym_constexpr] = ACTIONS(158),
    [anon_sym_unsigned] = ACTIONS(574),
    [anon_sym_long] = ACTIONS(574),
    [anon_sym_short] = ACTIONS(574),
    [sym_primitive_type] = ACTIONS(576),
    [anon_sym_enum] = ACTIONS(578),
    [anon_sym_struct] = ACTIONS(580),
    [anon_sym_union] = ACTIONS(582),
    [anon_sym_AMP] = ACTIONS(568),
    [anon_sym_BANG] = ACTIONS(584),
    [anon_sym_TILDE] = ACTIONS(586),
    [anon_sym_PLUS] = ACTIONS(588),
    [anon_sym_DASH] = ACTIONS(588),
    [anon_sym_DASH_DASH] = ACTIONS(590),
    [anon_sym_PLUS_PLUS] = ACTIONS(590),
    [anon_sym_sizeof] = ACTIONS(592),
    [sym_number_literal] = ACTIONS(1992),
    [sym_char_literal] = ACTIONS(1992),
    [sym_string_literal] = ACTIONS(594),
    [sym_true] = ACTIONS(1996),
    [sym_false] = ACTIONS(1996),
    [sym_null] = ACTIONS(1996),
    [sym_identifier] = ACTIONS(598),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(600),
    [sym_auto] = ACTIONS(576),
    [anon_sym_typename] = ACTIONS(602),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(606),
    [anon_sym_delete] = ACTIONS(608),
    [sym_nullptr] = ACTIONS(1996),
  },
  [513] = {
    [anon_sym_LPAREN] = ACTIONS(1998),
    [anon_sym_RPAREN] = ACTIONS(1998),
    [anon_sym_SEMI] = ACTIONS(1998),
    [anon_sym_LBRACK] = ACTIONS(1998),
    [sym_comment] = ACTIONS(49),
  },
  [514] = {
    [anon_sym_LPAREN] = ACTIONS(1801),
    [anon_sym_COMMA] = ACTIONS(1801),
    [anon_sym_RPAREN] = ACTIONS(1801),
    [anon_sym_SEMI] = ACTIONS(1801),
    [anon_sym_LBRACE] = ACTIONS(1801),
    [anon_sym_STAR] = ACTIONS(1801),
    [anon_sym_LBRACK] = ACTIONS(1801),
    [anon_sym_COLON] = ACTIONS(1803),
    [anon_sym_AMP] = ACTIONS(1803),
    [anon_sym_AMP_AMP] = ACTIONS(1801),
    [anon_sym_LT] = ACTIONS(1801),
    [anon_sym_GT] = ACTIONS(1801),
    [sym_identifier] = ACTIONS(1801),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(1805),
  },
  [515] = {
    [sym_parameter_list] = STATE(513),
    [anon_sym_LPAREN] = ACTIONS(206),
    [anon_sym_SEMI] = ACTIONS(2000),
    [anon_sym_LBRACK] = ACTIONS(955),
    [sym_comment] = ACTIONS(49),
  },
  [516] = {
    [sym__type_specifier] = STATE(1025),
    [sym_sized_type_specifier] = STATE(1025),
    [sym_enum_specifier] = STATE(1025),
    [sym_struct_specifier] = STATE(1025),
    [sym_union_specifier] = STATE(1025),
    [sym_macro_type_specifier] = STATE(1025),
    [sym_class_specifier] = STATE(1025),
    [sym_dependent_type] = STATE(1025),
    [sym_template_type] = STATE(825),
    [sym_scoped_type_identifier] = STATE(826),
    [sym_scoped_namespace_identifier] = STATE(827),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1026),
    [anon_sym_unsigned] = ACTIONS(2002),
    [anon_sym_long] = ACTIONS(2002),
    [anon_sym_short] = ACTIONS(2002),
    [sym_primitive_type] = ACTIONS(2004),
    [anon_sym_enum] = ACTIONS(1833),
    [anon_sym_struct] = ACTIONS(1835),
    [anon_sym_union] = ACTIONS(1837),
    [sym_identifier] = ACTIONS(1588),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(1839),
    [sym_auto] = ACTIONS(2004),
    [anon_sym_typename] = ACTIONS(2006),
    [anon_sym_COLON_COLON] = ACTIONS(1594),
  },
  [517] = {
    [sym_type_qualifier] = STATE(1027),
    [sym_trailing_return_type] = STATE(1027),
    [aux_sym_function_declarator_repeat1] = STATE(1027),
    [anon_sym_LPAREN] = ACTIONS(1596),
    [anon_sym_LBRACK] = ACTIONS(1596),
    [anon_sym_const] = ACTIONS(612),
    [anon_sym_restrict] = ACTIONS(614),
    [anon_sym_volatile] = ACTIONS(614),
    [anon_sym__Atomic] = ACTIONS(614),
    [anon_sym_mutable] = ACTIONS(614),
    [anon_sym_explicit] = ACTIONS(614),
    [anon_sym_constexpr] = ACTIONS(614),
    [anon_sym_DASH_GT] = ACTIONS(979),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(2008),
  },
  [518] = {
    [anon_sym_LPAREN] = ACTIONS(2010),
    [anon_sym_COMMA] = ACTIONS(2010),
    [anon_sym_RPAREN] = ACTIONS(2010),
    [anon_sym_SEMI] = ACTIONS(2010),
    [anon_sym_extern] = ACTIONS(2012),
    [anon_sym_LBRACE] = ACTIONS(2010),
    [anon_sym_STAR] = ACTIONS(2010),
    [anon_sym_LBRACK] = ACTIONS(2010),
    [anon_sym_static] = ACTIONS(2012),
    [anon_sym_register] = ACTIONS(2012),
    [anon_sym_inline] = ACTIONS(2012),
    [anon_sym_const] = ACTIONS(2012),
    [anon_sym_restrict] = ACTIONS(2012),
    [anon_sym_volatile] = ACTIONS(2012),
    [anon_sym__Atomic] = ACTIONS(2012),
    [anon_sym_mutable] = ACTIONS(2012),
    [anon_sym_explicit] = ACTIONS(2012),
    [anon_sym_constexpr] = ACTIONS(2012),
    [anon_sym_COLON] = ACTIONS(2012),
    [anon_sym_AMP] = ACTIONS(2012),
    [anon_sym_AMP_AMP] = ACTIONS(2010),
    [anon_sym_TILDE] = ACTIONS(2010),
    [anon_sym_GT] = ACTIONS(2010),
    [sym_identifier] = ACTIONS(2012),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(2010),
    [sym_operator_name] = ACTIONS(2010),
  },
  [519] = {
    [sym__expression] = STATE(1028),
    [sym_conditional_expression] = STATE(1028),
    [sym_assignment_expression] = STATE(1028),
    [sym_pointer_expression] = STATE(1028),
    [sym_logical_expression] = STATE(1028),
    [sym_bitwise_expression] = STATE(1028),
    [sym_equality_expression] = STATE(1028),
    [sym_relational_expression] = STATE(1028),
    [sym_shift_expression] = STATE(1028),
    [sym_math_expression] = STATE(1028),
    [sym_cast_expression] = STATE(1028),
    [sym_sizeof_expression] = STATE(1028),
    [sym_subscript_expression] = STATE(1028),
    [sym_call_expression] = STATE(1028),
    [sym_field_expression] = STATE(1028),
    [sym_compound_literal_expression] = STATE(1028),
    [sym_parenthesized_expression] = STATE(1028),
    [sym_concatenated_string] = STATE(1028),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(1028),
    [sym_new_expression] = STATE(1028),
    [sym_delete_expression] = STATE(1028),
    [sym_lambda_expression] = STATE(1028),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(2014),
    [anon_sym_LPAREN] = ACTIONS(1321),
    [anon_sym_STAR] = ACTIONS(1325),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_AMP] = ACTIONS(1325),
    [anon_sym_BANG] = ACTIONS(1327),
    [anon_sym_TILDE] = ACTIONS(1329),
    [anon_sym_PLUS] = ACTIONS(1331),
    [anon_sym_DASH] = ACTIONS(1331),
    [anon_sym_DASH_DASH] = ACTIONS(1333),
    [anon_sym_PLUS_PLUS] = ACTIONS(1333),
    [anon_sym_sizeof] = ACTIONS(1335),
    [sym_number_literal] = ACTIONS(2014),
    [sym_char_literal] = ACTIONS(2014),
    [sym_string_literal] = ACTIONS(1337),
    [sym_true] = ACTIONS(2016),
    [sym_false] = ACTIONS(2016),
    [sym_null] = ACTIONS(2016),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1341),
    [anon_sym_delete] = ACTIONS(1343),
    [sym_nullptr] = ACTIONS(2016),
  },
  [520] = {
    [sym_enumerator] = STATE(1030),
    [anon_sym_RBRACE] = ACTIONS(2018),
    [sym_identifier] = ACTIONS(348),
    [sym_comment] = ACTIONS(49),
  },
  [521] = {
    [aux_sym_enumerator_list_repeat1] = STATE(1032),
    [anon_sym_COMMA] = ACTIONS(2020),
    [anon_sym_RBRACE] = ACTIONS(2018),
    [sym_comment] = ACTIONS(49),
  },
  [522] = {
    [sym_preproc_if_in_field_declaration_list] = STATE(246),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(247),
    [sym_preproc_else_in_field_declaration_list] = STATE(1036),
    [sym_preproc_elif_in_field_declaration_list] = STATE(1037),
    [sym_type_definition] = STATE(1038),
    [sym__declaration_specifiers] = STATE(248),
    [sym__declarator] = STATE(249),
    [sym_pointer_declarator] = STATE(249),
    [sym_function_declarator] = STATE(250),
    [sym_array_declarator] = STATE(249),
    [sym_storage_class_specifier] = STATE(257),
    [sym_type_qualifier] = STATE(257),
    [sym__type_specifier] = STATE(251),
    [sym_sized_type_specifier] = STATE(251),
    [sym_enum_specifier] = STATE(251),
    [sym_struct_specifier] = STATE(251),
    [sym_union_specifier] = STATE(251),
    [sym__field_declaration_list_item] = STATE(1038),
    [sym_field_declaration] = STATE(1038),
    [sym_macro_type_specifier] = STATE(251),
    [sym_class_specifier] = STATE(251),
    [sym_dependent_type] = STATE(251),
    [sym_template_declaration] = STATE(1038),
    [sym_inline_method_definition] = STATE(252),
    [sym_constructor_or_destructor_definition] = STATE(252),
    [sym_constructor_or_destructor_declaration] = STATE(253),
    [sym_friend_declaration] = STATE(1038),
    [sym_access_specifier] = STATE(1038),
    [sym_reference_declarator] = STATE(249),
    [sym_template_type] = STATE(254),
    [sym_template_function] = STATE(249),
    [sym_using_declaration] = STATE(1038),
    [sym_alias_declaration] = STATE(1038),
    [sym_destructor_name] = STATE(249),
    [sym_scoped_identifier] = STATE(33),
    [sym_scoped_type_identifier] = STATE(34),
    [sym_scoped_namespace_identifier] = STATE(255),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(1038),
    [aux_sym__declaration_specifiers_repeat1] = STATE(257),
    [aux_sym_sized_type_specifier_repeat1] = STATE(258),
    [anon_sym_LPAREN] = ACTIONS(11),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(358),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(2022),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(360),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(362),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(2024),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(2026),
    [anon_sym_typedef] = ACTIONS(364),
    [anon_sym_extern] = ACTIONS(27),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_static] = ACTIONS(27),
    [anon_sym_register] = ACTIONS(27),
    [anon_sym_inline] = ACTIONS(27),
    [anon_sym_const] = ACTIONS(29),
    [anon_sym_restrict] = ACTIONS(29),
    [anon_sym_volatile] = ACTIONS(29),
    [anon_sym__Atomic] = ACTIONS(29),
    [anon_sym_mutable] = ACTIONS(29),
    [anon_sym_explicit] = ACTIONS(29),
    [anon_sym_constexpr] = ACTIONS(29),
    [anon_sym_unsigned] = ACTIONS(368),
    [anon_sym_long] = ACTIONS(368),
    [anon_sym_short] = ACTIONS(368),
    [sym_primitive_type] = ACTIONS(370),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(372),
    [anon_sym_union] = ACTIONS(374),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(45),
    [sym_identifier] = ACTIONS(376),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(378),
    [anon_sym_public] = ACTIONS(380),
    [sym_auto] = ACTIONS(370),
    [anon_sym_typename] = ACTIONS(382),
    [anon_sym_template] = ACTIONS(384),
    [anon_sym_friend] = ACTIONS(386),
    [anon_sym_private] = ACTIONS(380),
    [anon_sym_protected] = ACTIONS(380),
    [anon_sym_using] = ACTIONS(388),
    [anon_sym_COLON_COLON] = ACTIONS(390),
    [sym_operator_name] = ACTIONS(392),
  },
  [523] = {
    [sym_preproc_if_in_field_declaration_list] = STATE(246),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(247),
    [sym_preproc_else_in_field_declaration_list] = STATE(1040),
    [sym_preproc_elif_in_field_declaration_list] = STATE(1041),
    [sym_type_definition] = STATE(1042),
    [sym__declaration_specifiers] = STATE(248),
    [sym__declarator] = STATE(249),
    [sym_pointer_declarator] = STATE(249),
    [sym_function_declarator] = STATE(250),
    [sym_array_declarator] = STATE(249),
    [sym_storage_class_specifier] = STATE(257),
    [sym_type_qualifier] = STATE(257),
    [sym__type_specifier] = STATE(251),
    [sym_sized_type_specifier] = STATE(251),
    [sym_enum_specifier] = STATE(251),
    [sym_struct_specifier] = STATE(251),
    [sym_union_specifier] = STATE(251),
    [sym__field_declaration_list_item] = STATE(1042),
    [sym_field_declaration] = STATE(1042),
    [sym_macro_type_specifier] = STATE(251),
    [sym_class_specifier] = STATE(251),
    [sym_dependent_type] = STATE(251),
    [sym_template_declaration] = STATE(1042),
    [sym_inline_method_definition] = STATE(252),
    [sym_constructor_or_destructor_definition] = STATE(252),
    [sym_constructor_or_destructor_declaration] = STATE(253),
    [sym_friend_declaration] = STATE(1042),
    [sym_access_specifier] = STATE(1042),
    [sym_reference_declarator] = STATE(249),
    [sym_template_type] = STATE(254),
    [sym_template_function] = STATE(249),
    [sym_using_declaration] = STATE(1042),
    [sym_alias_declaration] = STATE(1042),
    [sym_destructor_name] = STATE(249),
    [sym_scoped_identifier] = STATE(33),
    [sym_scoped_type_identifier] = STATE(34),
    [sym_scoped_namespace_identifier] = STATE(255),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(1042),
    [aux_sym__declaration_specifiers_repeat1] = STATE(257),
    [aux_sym_sized_type_specifier_repeat1] = STATE(258),
    [anon_sym_LPAREN] = ACTIONS(11),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(358),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(2028),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(360),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(362),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(2024),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(2026),
    [anon_sym_typedef] = ACTIONS(364),
    [anon_sym_extern] = ACTIONS(27),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_static] = ACTIONS(27),
    [anon_sym_register] = ACTIONS(27),
    [anon_sym_inline] = ACTIONS(27),
    [anon_sym_const] = ACTIONS(29),
    [anon_sym_restrict] = ACTIONS(29),
    [anon_sym_volatile] = ACTIONS(29),
    [anon_sym__Atomic] = ACTIONS(29),
    [anon_sym_mutable] = ACTIONS(29),
    [anon_sym_explicit] = ACTIONS(29),
    [anon_sym_constexpr] = ACTIONS(29),
    [anon_sym_unsigned] = ACTIONS(368),
    [anon_sym_long] = ACTIONS(368),
    [anon_sym_short] = ACTIONS(368),
    [sym_primitive_type] = ACTIONS(370),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(372),
    [anon_sym_union] = ACTIONS(374),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(45),
    [sym_identifier] = ACTIONS(376),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(378),
    [anon_sym_public] = ACTIONS(380),
    [sym_auto] = ACTIONS(370),
    [anon_sym_typename] = ACTIONS(382),
    [anon_sym_template] = ACTIONS(384),
    [anon_sym_friend] = ACTIONS(386),
    [anon_sym_private] = ACTIONS(380),
    [anon_sym_protected] = ACTIONS(380),
    [anon_sym_using] = ACTIONS(388),
    [anon_sym_COLON_COLON] = ACTIONS(390),
    [sym_operator_name] = ACTIONS(392),
  },
  [524] = {
    [sym_preproc_if_in_field_declaration_list] = STATE(246),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(247),
    [sym_preproc_else_in_field_declaration_list] = STATE(1044),
    [sym_preproc_elif_in_field_declaration_list] = STATE(1045),
    [sym_type_definition] = STATE(1046),
    [sym__declaration_specifiers] = STATE(248),
    [sym__declarator] = STATE(249),
    [sym_pointer_declarator] = STATE(249),
    [sym_function_declarator] = STATE(250),
    [sym_array_declarator] = STATE(249),
    [sym_storage_class_specifier] = STATE(257),
    [sym_type_qualifier] = STATE(257),
    [sym__type_specifier] = STATE(251),
    [sym_sized_type_specifier] = STATE(251),
    [sym_enum_specifier] = STATE(251),
    [sym_struct_specifier] = STATE(251),
    [sym_union_specifier] = STATE(251),
    [sym__field_declaration_list_item] = STATE(1046),
    [sym_field_declaration] = STATE(1046),
    [sym_macro_type_specifier] = STATE(251),
    [sym_class_specifier] = STATE(251),
    [sym_dependent_type] = STATE(251),
    [sym_template_declaration] = STATE(1046),
    [sym_inline_method_definition] = STATE(252),
    [sym_constructor_or_destructor_definition] = STATE(252),
    [sym_constructor_or_destructor_declaration] = STATE(253),
    [sym_friend_declaration] = STATE(1046),
    [sym_access_specifier] = STATE(1046),
    [sym_reference_declarator] = STATE(249),
    [sym_template_type] = STATE(254),
    [sym_template_function] = STATE(249),
    [sym_using_declaration] = STATE(1046),
    [sym_alias_declaration] = STATE(1046),
    [sym_destructor_name] = STATE(249),
    [sym_scoped_identifier] = STATE(33),
    [sym_scoped_type_identifier] = STATE(34),
    [sym_scoped_namespace_identifier] = STATE(255),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(1046),
    [aux_sym__declaration_specifiers_repeat1] = STATE(257),
    [aux_sym_sized_type_specifier_repeat1] = STATE(258),
    [anon_sym_LPAREN] = ACTIONS(11),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(358),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(2030),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(360),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(362),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(2024),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(2026),
    [anon_sym_typedef] = ACTIONS(364),
    [anon_sym_extern] = ACTIONS(27),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_static] = ACTIONS(27),
    [anon_sym_register] = ACTIONS(27),
    [anon_sym_inline] = ACTIONS(27),
    [anon_sym_const] = ACTIONS(29),
    [anon_sym_restrict] = ACTIONS(29),
    [anon_sym_volatile] = ACTIONS(29),
    [anon_sym__Atomic] = ACTIONS(29),
    [anon_sym_mutable] = ACTIONS(29),
    [anon_sym_explicit] = ACTIONS(29),
    [anon_sym_constexpr] = ACTIONS(29),
    [anon_sym_unsigned] = ACTIONS(368),
    [anon_sym_long] = ACTIONS(368),
    [anon_sym_short] = ACTIONS(368),
    [sym_primitive_type] = ACTIONS(370),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(372),
    [anon_sym_union] = ACTIONS(374),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(45),
    [sym_identifier] = ACTIONS(376),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(378),
    [anon_sym_public] = ACTIONS(380),
    [sym_auto] = ACTIONS(370),
    [anon_sym_typename] = ACTIONS(382),
    [anon_sym_template] = ACTIONS(384),
    [anon_sym_friend] = ACTIONS(386),
    [anon_sym_private] = ACTIONS(380),
    [anon_sym_protected] = ACTIONS(380),
    [anon_sym_using] = ACTIONS(388),
    [anon_sym_COLON_COLON] = ACTIONS(390),
    [sym_operator_name] = ACTIONS(392),
  },
  [525] = {
    [sym__type_declarator] = STATE(1047),
    [sym_pointer_type_declarator] = STATE(213),
    [sym_function_type_declarator] = STATE(214),
    [sym_array_type_declarator] = STATE(215),
    [anon_sym_LPAREN] = ACTIONS(327),
    [anon_sym_STAR] = ACTIONS(329),
    [sym_identifier] = ACTIONS(331),
    [sym_comment] = ACTIONS(49),
  },
  [526] = {
    [sym_type_qualifier] = STATE(219),
    [sym__type_specifier] = STATE(1048),
    [sym_sized_type_specifier] = STATE(1048),
    [sym_enum_specifier] = STATE(1048),
    [sym_struct_specifier] = STATE(1048),
    [sym_union_specifier] = STATE(1048),
    [sym_macro_type_specifier] = STATE(1048),
    [sym_class_specifier] = STATE(1048),
    [sym_dependent_type] = STATE(1048),
    [sym_template_type] = STATE(62),
    [sym_scoped_type_identifier] = STATE(63),
    [sym_scoped_namespace_identifier] = STATE(64),
    [aux_sym_type_definition_repeat1] = STATE(219),
    [aux_sym_sized_type_specifier_repeat1] = STATE(66),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_restrict] = ACTIONS(93),
    [anon_sym_volatile] = ACTIONS(93),
    [anon_sym__Atomic] = ACTIONS(93),
    [anon_sym_mutable] = ACTIONS(93),
    [anon_sym_explicit] = ACTIONS(93),
    [anon_sym_constexpr] = ACTIONS(93),
    [anon_sym_unsigned] = ACTIONS(95),
    [anon_sym_long] = ACTIONS(95),
    [anon_sym_short] = ACTIONS(95),
    [sym_primitive_type] = ACTIONS(2032),
    [anon_sym_enum] = ACTIONS(99),
    [anon_sym_struct] = ACTIONS(101),
    [anon_sym_union] = ACTIONS(103),
    [sym_identifier] = ACTIONS(105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(107),
    [sym_auto] = ACTIONS(2032),
    [anon_sym_typename] = ACTIONS(109),
    [anon_sym_COLON_COLON] = ACTIONS(111),
  },
  [527] = {
    [sym_field_declaration_list] = STATE(265),
    [sym_base_class_clause] = STATE(266),
    [anon_sym_LPAREN] = ACTIONS(406),
    [anon_sym_SEMI] = ACTIONS(406),
    [anon_sym_extern] = ACTIONS(408),
    [anon_sym_LBRACE] = ACTIONS(129),
    [anon_sym_STAR] = ACTIONS(406),
    [anon_sym_static] = ACTIONS(408),
    [anon_sym_register] = ACTIONS(408),
    [anon_sym_inline] = ACTIONS(408),
    [anon_sym_const] = ACTIONS(408),
    [anon_sym_restrict] = ACTIONS(408),
    [anon_sym_volatile] = ACTIONS(408),
    [anon_sym__Atomic] = ACTIONS(408),
    [anon_sym_mutable] = ACTIONS(408),
    [anon_sym_explicit] = ACTIONS(408),
    [anon_sym_constexpr] = ACTIONS(408),
    [anon_sym_COLON] = ACTIONS(408),
    [anon_sym_AMP] = ACTIONS(408),
    [anon_sym_AMP_AMP] = ACTIONS(406),
    [sym_identifier] = ACTIONS(408),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(406),
    [sym_operator_name] = ACTIONS(406),
  },
  [528] = {
    [sym_field_declaration_list] = STATE(268),
    [sym_base_class_clause] = STATE(269),
    [anon_sym_LPAREN] = ACTIONS(416),
    [anon_sym_SEMI] = ACTIONS(416),
    [anon_sym_extern] = ACTIONS(418),
    [anon_sym_LBRACE] = ACTIONS(129),
    [anon_sym_STAR] = ACTIONS(416),
    [anon_sym_static] = ACTIONS(418),
    [anon_sym_register] = ACTIONS(418),
    [anon_sym_inline] = ACTIONS(418),
    [anon_sym_const] = ACTIONS(418),
    [anon_sym_restrict] = ACTIONS(418),
    [anon_sym_volatile] = ACTIONS(418),
    [anon_sym__Atomic] = ACTIONS(418),
    [anon_sym_mutable] = ACTIONS(418),
    [anon_sym_explicit] = ACTIONS(418),
    [anon_sym_constexpr] = ACTIONS(418),
    [anon_sym_COLON] = ACTIONS(418),
    [anon_sym_AMP] = ACTIONS(418),
    [anon_sym_AMP_AMP] = ACTIONS(416),
    [sym_identifier] = ACTIONS(418),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(416),
    [sym_operator_name] = ACTIONS(416),
  },
  [529] = {
    [sym_destructor_name] = STATE(282),
    [anon_sym_TILDE] = ACTIONS(45),
    [sym_identifier] = ACTIONS(2034),
    [sym_comment] = ACTIONS(49),
    [sym_operator_name] = ACTIONS(442),
  },
  [530] = {
    [anon_sym_LPAREN] = ACTIONS(444),
    [anon_sym_SEMI] = ACTIONS(447),
    [anon_sym_extern] = ACTIONS(449),
    [anon_sym_STAR] = ACTIONS(447),
    [anon_sym_LBRACK] = ACTIONS(704),
    [anon_sym_static] = ACTIONS(449),
    [anon_sym_register] = ACTIONS(449),
    [anon_sym_inline] = ACTIONS(449),
    [anon_sym_const] = ACTIONS(449),
    [anon_sym_restrict] = ACTIONS(449),
    [anon_sym_volatile] = ACTIONS(449),
    [anon_sym__Atomic] = ACTIONS(449),
    [anon_sym_mutable] = ACTIONS(449),
    [anon_sym_explicit] = ACTIONS(449),
    [anon_sym_constexpr] = ACTIONS(449),
    [anon_sym_COLON] = ACTIONS(449),
    [anon_sym_AMP] = ACTIONS(449),
    [anon_sym_AMP_AMP] = ACTIONS(447),
    [sym_identifier] = ACTIONS(449),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(447),
    [sym_operator_name] = ACTIONS(447),
  },
  [531] = {
    [sym_field_declaration_list] = STATE(283),
    [sym_base_class_clause] = STATE(284),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_SEMI] = ACTIONS(451),
    [anon_sym_extern] = ACTIONS(453),
    [anon_sym_LBRACE] = ACTIONS(129),
    [anon_sym_STAR] = ACTIONS(451),
    [anon_sym_static] = ACTIONS(453),
    [anon_sym_register] = ACTIONS(453),
    [anon_sym_inline] = ACTIONS(453),
    [anon_sym_const] = ACTIONS(453),
    [anon_sym_restrict] = ACTIONS(453),
    [anon_sym_volatile] = ACTIONS(453),
    [anon_sym__Atomic] = ACTIONS(453),
    [anon_sym_mutable] = ACTIONS(453),
    [anon_sym_explicit] = ACTIONS(453),
    [anon_sym_constexpr] = ACTIONS(453),
    [anon_sym_COLON] = ACTIONS(453),
    [anon_sym_AMP] = ACTIONS(453),
    [anon_sym_AMP_AMP] = ACTIONS(451),
    [sym_identifier] = ACTIONS(453),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(451),
    [sym_operator_name] = ACTIONS(451),
  },
  [532] = {
    [anon_sym_LPAREN] = ACTIONS(2036),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(2038),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(2036),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(2036),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(2036),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(2036),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(2036),
    [anon_sym_typedef] = ACTIONS(2038),
    [anon_sym_extern] = ACTIONS(2038),
    [anon_sym_RBRACE] = ACTIONS(2036),
    [anon_sym_STAR] = ACTIONS(2036),
    [anon_sym_static] = ACTIONS(2038),
    [anon_sym_register] = ACTIONS(2038),
    [anon_sym_inline] = ACTIONS(2038),
    [anon_sym_const] = ACTIONS(2038),
    [anon_sym_restrict] = ACTIONS(2038),
    [anon_sym_volatile] = ACTIONS(2038),
    [anon_sym__Atomic] = ACTIONS(2038),
    [anon_sym_mutable] = ACTIONS(2038),
    [anon_sym_explicit] = ACTIONS(2038),
    [anon_sym_constexpr] = ACTIONS(2038),
    [anon_sym_unsigned] = ACTIONS(2038),
    [anon_sym_long] = ACTIONS(2038),
    [anon_sym_short] = ACTIONS(2038),
    [sym_primitive_type] = ACTIONS(2038),
    [anon_sym_enum] = ACTIONS(2038),
    [anon_sym_struct] = ACTIONS(2038),
    [anon_sym_union] = ACTIONS(2038),
    [anon_sym_AMP] = ACTIONS(2038),
    [anon_sym_AMP_AMP] = ACTIONS(2036),
    [anon_sym_TILDE] = ACTIONS(2036),
    [sym_identifier] = ACTIONS(2038),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(2038),
    [anon_sym_public] = ACTIONS(2038),
    [sym_auto] = ACTIONS(2038),
    [anon_sym_typename] = ACTIONS(2038),
    [anon_sym_template] = ACTIONS(2038),
    [anon_sym_friend] = ACTIONS(2038),
    [anon_sym_private] = ACTIONS(2038),
    [anon_sym_protected] = ACTIONS(2038),
    [anon_sym_using] = ACTIONS(2038),
    [anon_sym_COLON_COLON] = ACTIONS(2036),
    [sym_operator_name] = ACTIONS(2036),
  },
  [533] = {
    [sym_function_definition] = STATE(1050),
    [sym_declaration] = STATE(1050),
    [sym__declaration_specifiers] = STATE(1051),
    [sym_storage_class_specifier] = STATE(305),
    [sym_type_qualifier] = STATE(305),
    [sym__type_specifier] = STATE(304),
    [sym_sized_type_specifier] = STATE(304),
    [sym_enum_specifier] = STATE(304),
    [sym_struct_specifier] = STATE(304),
    [sym_union_specifier] = STATE(304),
    [sym__empty_declaration] = STATE(1050),
    [sym_macro_type_specifier] = STATE(304),
    [sym_class_specifier] = STATE(304),
    [sym_dependent_type] = STATE(304),
    [sym_template_type] = STATE(94),
    [sym_scoped_type_identifier] = STATE(34),
    [sym_scoped_namespace_identifier] = STATE(81),
    [aux_sym__declaration_specifiers_repeat1] = STATE(305),
    [aux_sym_sized_type_specifier_repeat1] = STATE(306),
    [anon_sym_extern] = ACTIONS(154),
    [anon_sym_static] = ACTIONS(154),
    [anon_sym_register] = ACTIONS(154),
    [anon_sym_inline] = ACTIONS(154),
    [anon_sym_const] = ACTIONS(158),
    [anon_sym_restrict] = ACTIONS(158),
    [anon_sym_volatile] = ACTIONS(158),
    [anon_sym__Atomic] = ACTIONS(158),
    [anon_sym_mutable] = ACTIONS(158),
    [anon_sym_explicit] = ACTIONS(158),
    [anon_sym_constexpr] = ACTIONS(158),
    [anon_sym_unsigned] = ACTIONS(479),
    [anon_sym_long] = ACTIONS(479),
    [anon_sym_short] = ACTIONS(479),
    [sym_primitive_type] = ACTIONS(481),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_union] = ACTIONS(39),
    [sym_identifier] = ACTIONS(152),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(51),
    [sym_auto] = ACTIONS(481),
    [anon_sym_typename] = ACTIONS(483),
    [anon_sym_COLON_COLON] = ACTIONS(135),
  },
  [534] = {
    [anon_sym_LPAREN] = ACTIONS(2040),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(2042),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(2040),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(2040),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(2040),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(2040),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(2040),
    [anon_sym_typedef] = ACTIONS(2042),
    [anon_sym_extern] = ACTIONS(2042),
    [anon_sym_RBRACE] = ACTIONS(2040),
    [anon_sym_STAR] = ACTIONS(2040),
    [anon_sym_static] = ACTIONS(2042),
    [anon_sym_register] = ACTIONS(2042),
    [anon_sym_inline] = ACTIONS(2042),
    [anon_sym_const] = ACTIONS(2042),
    [anon_sym_restrict] = ACTIONS(2042),
    [anon_sym_volatile] = ACTIONS(2042),
    [anon_sym__Atomic] = ACTIONS(2042),
    [anon_sym_mutable] = ACTIONS(2042),
    [anon_sym_explicit] = ACTIONS(2042),
    [anon_sym_constexpr] = ACTIONS(2042),
    [anon_sym_unsigned] = ACTIONS(2042),
    [anon_sym_long] = ACTIONS(2042),
    [anon_sym_short] = ACTIONS(2042),
    [sym_primitive_type] = ACTIONS(2042),
    [anon_sym_enum] = ACTIONS(2042),
    [anon_sym_struct] = ACTIONS(2042),
    [anon_sym_union] = ACTIONS(2042),
    [anon_sym_AMP] = ACTIONS(2042),
    [anon_sym_AMP_AMP] = ACTIONS(2040),
    [anon_sym_TILDE] = ACTIONS(2040),
    [sym_identifier] = ACTIONS(2042),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(2042),
    [anon_sym_public] = ACTIONS(2042),
    [sym_auto] = ACTIONS(2042),
    [anon_sym_typename] = ACTIONS(2042),
    [anon_sym_template] = ACTIONS(2042),
    [anon_sym_friend] = ACTIONS(2042),
    [anon_sym_private] = ACTIONS(2042),
    [anon_sym_protected] = ACTIONS(2042),
    [anon_sym_using] = ACTIONS(2042),
    [anon_sym_COLON_COLON] = ACTIONS(2040),
    [sym_operator_name] = ACTIONS(2040),
  },
  [535] = {
    [sym__declarator] = STATE(1052),
    [sym_pointer_declarator] = STATE(1052),
    [sym_function_declarator] = STATE(1052),
    [sym_array_declarator] = STATE(1052),
    [sym_init_declarator] = STATE(1053),
    [sym_reference_declarator] = STATE(1052),
    [sym_template_type] = STATE(46),
    [sym_template_function] = STATE(1052),
    [sym_destructor_name] = STATE(1052),
    [sym_scoped_identifier] = STATE(33),
    [sym_scoped_type_identifier] = STATE(47),
    [sym_scoped_namespace_identifier] = STATE(46),
    [anon_sym_LPAREN] = ACTIONS(11),
    [anon_sym_STAR] = ACTIONS(196),
    [anon_sym_AMP] = ACTIONS(526),
    [anon_sym_AMP_AMP] = ACTIONS(528),
    [anon_sym_TILDE] = ACTIONS(45),
    [sym_identifier] = ACTIONS(75),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(77),
    [sym_operator_name] = ACTIONS(2044),
  },
  [536] = {
    [anon_sym_LPAREN] = ACTIONS(228),
    [anon_sym_SEMI] = ACTIONS(2046),
    [anon_sym_extern] = ACTIONS(230),
    [anon_sym_STAR] = ACTIONS(228),
    [anon_sym_static] = ACTIONS(230),
    [anon_sym_register] = ACTIONS(230),
    [anon_sym_inline] = ACTIONS(230),
    [anon_sym_const] = ACTIONS(230),
    [anon_sym_restrict] = ACTIONS(230),
    [anon_sym_volatile] = ACTIONS(230),
    [anon_sym__Atomic] = ACTIONS(230),
    [anon_sym_mutable] = ACTIONS(230),
    [anon_sym_explicit] = ACTIONS(230),
    [anon_sym_constexpr] = ACTIONS(230),
    [anon_sym_AMP] = ACTIONS(230),
    [anon_sym_AMP_AMP] = ACTIONS(228),
    [anon_sym_TILDE] = ACTIONS(228),
    [sym_identifier] = ACTIONS(230),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(228),
    [sym_operator_name] = ACTIONS(228),
  },
  [537] = {
    [sym_template_argument_list] = STATE(203),
    [anon_sym_SEMI] = ACTIONS(2048),
    [anon_sym_EQ] = ACTIONS(2050),
    [anon_sym_LT] = ACTIONS(146),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(501),
  },
  [538] = {
    [sym_template_type] = STATE(117),
    [sym_scoped_identifier] = STATE(1058),
    [sym_scoped_type_identifier] = STATE(47),
    [sym_scoped_namespace_identifier] = STATE(117),
    [sym_identifier] = ACTIONS(2052),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(186),
  },
  [539] = {
    [anon_sym_SEMI] = ACTIONS(2048),
    [sym_comment] = ACTIONS(49),
  },
  [540] = {
    [anon_sym_LPAREN] = ACTIONS(509),
    [anon_sym_SEMI] = ACTIONS(512),
    [anon_sym_extern] = ACTIONS(514),
    [anon_sym_STAR] = ACTIONS(512),
    [anon_sym_LBRACK] = ACTIONS(518),
    [anon_sym_static] = ACTIONS(514),
    [anon_sym_register] = ACTIONS(514),
    [anon_sym_inline] = ACTIONS(514),
    [anon_sym_const] = ACTIONS(514),
    [anon_sym_restrict] = ACTIONS(514),
    [anon_sym_volatile] = ACTIONS(514),
    [anon_sym__Atomic] = ACTIONS(514),
    [anon_sym_mutable] = ACTIONS(514),
    [anon_sym_explicit] = ACTIONS(514),
    [anon_sym_constexpr] = ACTIONS(514),
    [anon_sym_COLON] = ACTIONS(514),
    [anon_sym_AMP] = ACTIONS(514),
    [anon_sym_AMP_AMP] = ACTIONS(512),
    [anon_sym_LT] = ACTIONS(509),
    [sym_identifier] = ACTIONS(514),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(516),
    [sym_operator_name] = ACTIONS(512),
  },
  [541] = {
    [sym__field_declarator] = STATE(1061),
    [sym_pointer_field_declarator] = STATE(549),
    [sym_function_field_declarator] = STATE(550),
    [sym_array_field_declarator] = STATE(551),
    [sym_reference_field_declarator] = STATE(552),
    [sym_template_type] = STATE(553),
    [sym_template_method] = STATE(1061),
    [sym_scoped_field_identifier] = STATE(1062),
    [sym_scoped_type_identifier] = STATE(47),
    [sym_scoped_namespace_identifier] = STATE(553),
    [anon_sym_LPAREN] = ACTIONS(1029),
    [anon_sym_STAR] = ACTIONS(2054),
    [anon_sym_AMP] = ACTIONS(2056),
    [anon_sym_AMP_AMP] = ACTIONS(2058),
    [sym_identifier] = ACTIONS(1041),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(1043),
    [sym_operator_name] = ACTIONS(2060),
  },
  [542] = {
    [anon_sym_LPAREN] = ACTIONS(2062),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(2064),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(2062),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(2062),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(2062),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(2062),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(2062),
    [anon_sym_typedef] = ACTIONS(2064),
    [anon_sym_extern] = ACTIONS(2064),
    [anon_sym_RBRACE] = ACTIONS(2062),
    [anon_sym_STAR] = ACTIONS(2062),
    [anon_sym_static] = ACTIONS(2064),
    [anon_sym_register] = ACTIONS(2064),
    [anon_sym_inline] = ACTIONS(2064),
    [anon_sym_const] = ACTIONS(2064),
    [anon_sym_restrict] = ACTIONS(2064),
    [anon_sym_volatile] = ACTIONS(2064),
    [anon_sym__Atomic] = ACTIONS(2064),
    [anon_sym_mutable] = ACTIONS(2064),
    [anon_sym_explicit] = ACTIONS(2064),
    [anon_sym_constexpr] = ACTIONS(2064),
    [anon_sym_unsigned] = ACTIONS(2064),
    [anon_sym_long] = ACTIONS(2064),
    [anon_sym_short] = ACTIONS(2064),
    [sym_primitive_type] = ACTIONS(2064),
    [anon_sym_enum] = ACTIONS(2064),
    [anon_sym_struct] = ACTIONS(2064),
    [anon_sym_union] = ACTIONS(2064),
    [anon_sym_AMP] = ACTIONS(2064),
    [anon_sym_AMP_AMP] = ACTIONS(2062),
    [anon_sym_TILDE] = ACTIONS(2062),
    [sym_identifier] = ACTIONS(2064),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(2064),
    [anon_sym_public] = ACTIONS(2064),
    [sym_auto] = ACTIONS(2064),
    [anon_sym_typename] = ACTIONS(2064),
    [anon_sym_template] = ACTIONS(2064),
    [anon_sym_friend] = ACTIONS(2064),
    [anon_sym_private] = ACTIONS(2064),
    [anon_sym_protected] = ACTIONS(2064),
    [anon_sym_using] = ACTIONS(2064),
    [anon_sym_COLON_COLON] = ACTIONS(2062),
    [sym_operator_name] = ACTIONS(2062),
  },
  [543] = {
    [sym__field_declarator] = STATE(1063),
    [sym_pointer_field_declarator] = STATE(549),
    [sym_function_field_declarator] = STATE(550),
    [sym_array_field_declarator] = STATE(551),
    [sym_reference_field_declarator] = STATE(552),
    [sym_template_type] = STATE(553),
    [sym_template_method] = STATE(1063),
    [sym_scoped_field_identifier] = STATE(554),
    [sym_scoped_type_identifier] = STATE(47),
    [sym_scoped_namespace_identifier] = STATE(553),
    [anon_sym_LPAREN] = ACTIONS(1029),
    [anon_sym_STAR] = ACTIONS(1033),
    [anon_sym_AMP] = ACTIONS(1037),
    [anon_sym_AMP_AMP] = ACTIONS(1039),
    [sym_identifier] = ACTIONS(1041),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(1043),
    [sym_operator_name] = ACTIONS(2066),
  },
  [544] = {
    [sym__expression] = STATE(1064),
    [sym_conditional_expression] = STATE(1064),
    [sym_assignment_expression] = STATE(1064),
    [sym_pointer_expression] = STATE(1064),
    [sym_logical_expression] = STATE(1064),
    [sym_bitwise_expression] = STATE(1064),
    [sym_equality_expression] = STATE(1064),
    [sym_relational_expression] = STATE(1064),
    [sym_shift_expression] = STATE(1064),
    [sym_math_expression] = STATE(1064),
    [sym_cast_expression] = STATE(1064),
    [sym_sizeof_expression] = STATE(1064),
    [sym_subscript_expression] = STATE(1064),
    [sym_call_expression] = STATE(1064),
    [sym_field_expression] = STATE(1064),
    [sym_compound_literal_expression] = STATE(1064),
    [sym_parenthesized_expression] = STATE(1064),
    [sym_concatenated_string] = STATE(1064),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(1064),
    [sym_new_expression] = STATE(1064),
    [sym_delete_expression] = STATE(1064),
    [sym_lambda_expression] = STATE(1064),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(2068),
    [anon_sym_LPAREN] = ACTIONS(1347),
    [anon_sym_STAR] = ACTIONS(1349),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_AMP] = ACTIONS(1349),
    [anon_sym_BANG] = ACTIONS(1351),
    [anon_sym_TILDE] = ACTIONS(1353),
    [anon_sym_PLUS] = ACTIONS(1355),
    [anon_sym_DASH] = ACTIONS(1355),
    [anon_sym_DASH_DASH] = ACTIONS(1357),
    [anon_sym_PLUS_PLUS] = ACTIONS(1357),
    [anon_sym_sizeof] = ACTIONS(1359),
    [sym_number_literal] = ACTIONS(2068),
    [sym_char_literal] = ACTIONS(2068),
    [sym_string_literal] = ACTIONS(1361),
    [sym_true] = ACTIONS(2070),
    [sym_false] = ACTIONS(2070),
    [sym_null] = ACTIONS(2070),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1365),
    [anon_sym_delete] = ACTIONS(1367),
    [sym_nullptr] = ACTIONS(2070),
  },
  [545] = {
    [sym__field_declarator] = STATE(1065),
    [sym_pointer_field_declarator] = STATE(549),
    [sym_function_field_declarator] = STATE(550),
    [sym_array_field_declarator] = STATE(551),
    [sym_reference_field_declarator] = STATE(552),
    [sym_template_type] = STATE(553),
    [sym_template_method] = STATE(1065),
    [sym_scoped_field_identifier] = STATE(554),
    [sym_scoped_type_identifier] = STATE(47),
    [sym_scoped_namespace_identifier] = STATE(553),
    [anon_sym_LPAREN] = ACTIONS(1029),
    [anon_sym_STAR] = ACTIONS(1033),
    [anon_sym_AMP] = ACTIONS(1037),
    [anon_sym_AMP_AMP] = ACTIONS(1039),
    [sym_identifier] = ACTIONS(1041),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(1043),
    [sym_operator_name] = ACTIONS(2072),
  },
  [546] = {
    [sym_template_argument_list] = STATE(1067),
    [anon_sym_LPAREN] = ACTIONS(2074),
    [anon_sym_COMMA] = ACTIONS(2074),
    [anon_sym_RPAREN] = ACTIONS(2074),
    [anon_sym_SEMI] = ACTIONS(2074),
    [anon_sym_LBRACE] = ACTIONS(2074),
    [anon_sym_LBRACK] = ACTIONS(2074),
    [anon_sym_COLON] = ACTIONS(2076),
    [anon_sym_LT] = ACTIONS(146),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(2078),
  },
  [547] = {
    [sym_destructor_name] = STATE(917),
    [anon_sym_TILDE] = ACTIONS(45),
    [sym_identifier] = ACTIONS(2080),
    [sym_comment] = ACTIONS(49),
    [sym_operator_name] = ACTIONS(1780),
  },
  [548] = {
    [sym_compound_statement] = STATE(1073),
    [sym_parameter_list] = STATE(1074),
    [aux_sym_field_declaration_repeat1] = STATE(1075),
    [anon_sym_LPAREN] = ACTIONS(206),
    [anon_sym_COMMA] = ACTIONS(2082),
    [anon_sym_SEMI] = ACTIONS(2084),
    [anon_sym_LBRACE] = ACTIONS(1049),
    [anon_sym_LBRACK] = ACTIONS(2086),
    [anon_sym_COLON] = ACTIONS(2088),
    [sym_comment] = ACTIONS(49),
  },
  [549] = {
    [anon_sym_LPAREN] = ACTIONS(2090),
    [anon_sym_COMMA] = ACTIONS(2090),
    [anon_sym_RPAREN] = ACTIONS(2090),
    [anon_sym_SEMI] = ACTIONS(2090),
    [anon_sym_LBRACE] = ACTIONS(2090),
    [anon_sym_LBRACK] = ACTIONS(2090),
    [anon_sym_COLON] = ACTIONS(2090),
    [sym_comment] = ACTIONS(49),
  },
  [550] = {
    [anon_sym_LPAREN] = ACTIONS(2092),
    [anon_sym_COMMA] = ACTIONS(2092),
    [anon_sym_RPAREN] = ACTIONS(2092),
    [anon_sym_SEMI] = ACTIONS(2092),
    [anon_sym_LBRACE] = ACTIONS(2092),
    [anon_sym_LBRACK] = ACTIONS(2092),
    [anon_sym_COLON] = ACTIONS(2092),
    [sym_comment] = ACTIONS(49),
  },
  [551] = {
    [anon_sym_LPAREN] = ACTIONS(2094),
    [anon_sym_COMMA] = ACTIONS(2094),
    [anon_sym_RPAREN] = ACTIONS(2094),
    [anon_sym_SEMI] = ACTIONS(2094),
    [anon_sym_LBRACE] = ACTIONS(2094),
    [anon_sym_LBRACK] = ACTIONS(2094),
    [anon_sym_COLON] = ACTIONS(2094),
    [sym_comment] = ACTIONS(49),
  },
  [552] = {
    [anon_sym_LPAREN] = ACTIONS(2096),
    [anon_sym_COMMA] = ACTIONS(2096),
    [anon_sym_RPAREN] = ACTIONS(2096),
    [anon_sym_SEMI] = ACTIONS(2096),
    [anon_sym_LBRACE] = ACTIONS(2096),
    [anon_sym_LBRACK] = ACTIONS(2096),
    [anon_sym_COLON] = ACTIONS(2096),
    [sym_comment] = ACTIONS(49),
  },
  [553] = {
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(2098),
  },
  [554] = {
    [sym_template_argument_list] = STATE(1078),
    [anon_sym_LT] = ACTIONS(2100),
    [sym_comment] = ACTIONS(49),
  },
  [555] = {
    [sym_type_qualifier] = STATE(1080),
    [sym_trailing_return_type] = STATE(1080),
    [aux_sym_function_declarator_repeat1] = STATE(1080),
    [anon_sym_LPAREN] = ACTIONS(610),
    [anon_sym_SEMI] = ACTIONS(610),
    [anon_sym_LBRACE] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(610),
    [anon_sym_const] = ACTIONS(612),
    [anon_sym_restrict] = ACTIONS(614),
    [anon_sym_volatile] = ACTIONS(614),
    [anon_sym__Atomic] = ACTIONS(614),
    [anon_sym_mutable] = ACTIONS(614),
    [anon_sym_explicit] = ACTIONS(614),
    [anon_sym_constexpr] = ACTIONS(614),
    [anon_sym_COLON] = ACTIONS(610),
    [anon_sym_DASH_GT] = ACTIONS(2102),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(2104),
  },
  [556] = {
    [anon_sym_LPAREN] = ACTIONS(2106),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(2108),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(2106),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(2106),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(2106),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(2106),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(2106),
    [anon_sym_typedef] = ACTIONS(2108),
    [anon_sym_extern] = ACTIONS(2108),
    [anon_sym_RBRACE] = ACTIONS(2106),
    [anon_sym_STAR] = ACTIONS(2106),
    [anon_sym_static] = ACTIONS(2108),
    [anon_sym_register] = ACTIONS(2108),
    [anon_sym_inline] = ACTIONS(2108),
    [anon_sym_const] = ACTIONS(2108),
    [anon_sym_restrict] = ACTIONS(2108),
    [anon_sym_volatile] = ACTIONS(2108),
    [anon_sym__Atomic] = ACTIONS(2108),
    [anon_sym_mutable] = ACTIONS(2108),
    [anon_sym_explicit] = ACTIONS(2108),
    [anon_sym_constexpr] = ACTIONS(2108),
    [anon_sym_unsigned] = ACTIONS(2108),
    [anon_sym_long] = ACTIONS(2108),
    [anon_sym_short] = ACTIONS(2108),
    [sym_primitive_type] = ACTIONS(2108),
    [anon_sym_enum] = ACTIONS(2108),
    [anon_sym_struct] = ACTIONS(2108),
    [anon_sym_union] = ACTIONS(2108),
    [anon_sym_AMP] = ACTIONS(2108),
    [anon_sym_AMP_AMP] = ACTIONS(2106),
    [anon_sym_TILDE] = ACTIONS(2106),
    [sym_identifier] = ACTIONS(2108),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(2108),
    [anon_sym_public] = ACTIONS(2108),
    [sym_auto] = ACTIONS(2108),
    [anon_sym_typename] = ACTIONS(2108),
    [anon_sym_template] = ACTIONS(2108),
    [anon_sym_friend] = ACTIONS(2108),
    [anon_sym_private] = ACTIONS(2108),
    [anon_sym_protected] = ACTIONS(2108),
    [anon_sym_using] = ACTIONS(2108),
    [anon_sym_COLON_COLON] = ACTIONS(2106),
    [sym_operator_name] = ACTIONS(2106),
  },
  [557] = {
    [sym_preproc_include] = STATE(1082),
    [sym_preproc_def] = STATE(1082),
    [sym_preproc_function_def] = STATE(1082),
    [sym_preproc_call] = STATE(1082),
    [sym_preproc_if_in_compound_statement] = STATE(410),
    [sym_preproc_ifdef_in_compound_statement] = STATE(411),
    [sym_declaration] = STATE(1082),
    [sym_type_definition] = STATE(1082),
    [sym__declaration_specifiers] = STATE(412),
    [sym_compound_statement] = STATE(1082),
    [sym_storage_class_specifier] = STATE(419),
    [sym_type_qualifier] = STATE(419),
    [sym__type_specifier] = STATE(30),
    [sym_sized_type_specifier] = STATE(30),
    [sym_enum_specifier] = STATE(30),
    [sym_struct_specifier] = STATE(30),
    [sym_union_specifier] = STATE(30),
    [sym_labeled_statement] = STATE(1082),
    [sym_expression_statement] = STATE(1082),
    [sym_if_statement] = STATE(1082),
    [sym_switch_statement] = STATE(1082),
    [sym_case_statement] = STATE(1082),
    [sym_while_statement] = STATE(1082),
    [sym_do_statement] = STATE(1082),
    [sym_for_statement] = STATE(1082),
    [sym_return_statement] = STATE(1082),
    [sym_break_statement] = STATE(1082),
    [sym_continue_statement] = STATE(1082),
    [sym_goto_statement] = STATE(1082),
    [sym__expression] = STATE(413),
    [sym_comma_expression] = STATE(414),
    [sym_conditional_expression] = STATE(413),
    [sym_assignment_expression] = STATE(413),
    [sym_pointer_expression] = STATE(413),
    [sym_logical_expression] = STATE(413),
    [sym_bitwise_expression] = STATE(413),
    [sym_equality_expression] = STATE(413),
    [sym_relational_expression] = STATE(413),
    [sym_shift_expression] = STATE(413),
    [sym_math_expression] = STATE(413),
    [sym_cast_expression] = STATE(413),
    [sym_sizeof_expression] = STATE(413),
    [sym_subscript_expression] = STATE(413),
    [sym_call_expression] = STATE(413),
    [sym_field_expression] = STATE(413),
    [sym_compound_literal_expression] = STATE(413),
    [sym_parenthesized_expression] = STATE(413),
    [sym_concatenated_string] = STATE(413),
    [sym__empty_declaration] = STATE(1082),
    [sym_macro_type_specifier] = STATE(30),
    [sym_class_specifier] = STATE(30),
    [sym_dependent_type] = STATE(30),
    [sym_structured_binding_declaration] = STATE(1082),
    [sym_template_type] = STATE(415),
    [sym_template_function] = STATE(413),
    [sym_for_range_loop] = STATE(1082),
    [sym_new_expression] = STATE(413),
    [sym_delete_expression] = STATE(413),
    [sym_lambda_expression] = STATE(413),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(416),
    [sym_scoped_namespace_identifier] = STATE(417),
    [aux_sym_preproc_if_in_compound_statement_repeat1] = STATE(1082),
    [aux_sym__declaration_specifiers_repeat1] = STATE(419),
    [aux_sym_sized_type_specifier_repeat1] = STATE(38),
    [sym_raw_string_literal] = ACTIONS(620),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(622),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(624),
    [anon_sym_LPAREN] = ACTIONS(626),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(628),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(630),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(632),
    [sym_preproc_directive] = ACTIONS(634),
    [anon_sym_SEMI] = ACTIONS(636),
    [anon_sym_typedef] = ACTIONS(638),
    [anon_sym_extern] = ACTIONS(154),
    [anon_sym_LBRACE] = ACTIONS(640),
    [anon_sym_RBRACE] = ACTIONS(2110),
    [anon_sym_STAR] = ACTIONS(644),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_static] = ACTIONS(154),
    [anon_sym_register] = ACTIONS(154),
    [anon_sym_inline] = ACTIONS(154),
    [anon_sym_const] = ACTIONS(158),
    [anon_sym_restrict] = ACTIONS(158),
    [anon_sym_volatile] = ACTIONS(158),
    [anon_sym__Atomic] = ACTIONS(158),
    [anon_sym_mutable] = ACTIONS(158),
    [anon_sym_explicit] = ACTIONS(158),
    [anon_sym_constexpr] = ACTIONS(158),
    [anon_sym_unsigned] = ACTIONS(31),
    [anon_sym_long] = ACTIONS(31),
    [anon_sym_short] = ACTIONS(31),
    [sym_primitive_type] = ACTIONS(33),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_union] = ACTIONS(39),
    [anon_sym_if] = ACTIONS(646),
    [anon_sym_switch] = ACTIONS(648),
    [anon_sym_case] = ACTIONS(650),
    [anon_sym_default] = ACTIONS(652),
    [anon_sym_while] = ACTIONS(654),
    [anon_sym_do] = ACTIONS(656),
    [anon_sym_for] = ACTIONS(658),
    [anon_sym_return] = ACTIONS(660),
    [anon_sym_break] = ACTIONS(662),
    [anon_sym_continue] = ACTIONS(664),
    [anon_sym_goto] = ACTIONS(666),
    [anon_sym_AMP] = ACTIONS(644),
    [anon_sym_BANG] = ACTIONS(668),
    [anon_sym_TILDE] = ACTIONS(670),
    [anon_sym_PLUS] = ACTIONS(672),
    [anon_sym_DASH] = ACTIONS(672),
    [anon_sym_DASH_DASH] = ACTIONS(674),
    [anon_sym_PLUS_PLUS] = ACTIONS(674),
    [anon_sym_sizeof] = ACTIONS(676),
    [sym_number_literal] = ACTIONS(620),
    [sym_char_literal] = ACTIONS(620),
    [sym_string_literal] = ACTIONS(678),
    [sym_true] = ACTIONS(680),
    [sym_false] = ACTIONS(680),
    [sym_null] = ACTIONS(680),
    [sym_identifier] = ACTIONS(682),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(51),
    [sym_auto] = ACTIONS(33),
    [anon_sym_typename] = ACTIONS(53),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(684),
    [anon_sym_delete] = ACTIONS(686),
    [sym_nullptr] = ACTIONS(680),
  },
  [558] = {
    [anon_sym_LPAREN] = ACTIONS(692),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(694),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(692),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(692),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(692),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(692),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(692),
    [anon_sym_typedef] = ACTIONS(694),
    [anon_sym_extern] = ACTIONS(694),
    [anon_sym_RBRACE] = ACTIONS(692),
    [anon_sym_STAR] = ACTIONS(692),
    [anon_sym_static] = ACTIONS(694),
    [anon_sym_register] = ACTIONS(694),
    [anon_sym_inline] = ACTIONS(694),
    [anon_sym_const] = ACTIONS(694),
    [anon_sym_restrict] = ACTIONS(694),
    [anon_sym_volatile] = ACTIONS(694),
    [anon_sym__Atomic] = ACTIONS(694),
    [anon_sym_mutable] = ACTIONS(694),
    [anon_sym_explicit] = ACTIONS(694),
    [anon_sym_constexpr] = ACTIONS(694),
    [anon_sym_unsigned] = ACTIONS(694),
    [anon_sym_long] = ACTIONS(694),
    [anon_sym_short] = ACTIONS(694),
    [sym_primitive_type] = ACTIONS(694),
    [anon_sym_enum] = ACTIONS(694),
    [anon_sym_struct] = ACTIONS(694),
    [anon_sym_union] = ACTIONS(694),
    [anon_sym_AMP] = ACTIONS(694),
    [anon_sym_AMP_AMP] = ACTIONS(692),
    [anon_sym_TILDE] = ACTIONS(692),
    [sym_identifier] = ACTIONS(694),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(694),
    [anon_sym_public] = ACTIONS(694),
    [sym_auto] = ACTIONS(694),
    [anon_sym_typename] = ACTIONS(694),
    [anon_sym_template] = ACTIONS(694),
    [anon_sym_friend] = ACTIONS(694),
    [anon_sym_private] = ACTIONS(694),
    [anon_sym_protected] = ACTIONS(694),
    [anon_sym_using] = ACTIONS(694),
    [anon_sym_COLON_COLON] = ACTIONS(692),
    [sym_operator_name] = ACTIONS(692),
  },
  [559] = {
    [sym_compound_statement] = STATE(1083),
    [anon_sym_LBRACE] = ACTIONS(1049),
    [sym_comment] = ACTIONS(49),
  },
  [560] = {
    [sym_storage_class_specifier] = STATE(1084),
    [sym_type_qualifier] = STATE(1084),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1084),
    [anon_sym_LPAREN] = ACTIONS(696),
    [anon_sym_SEMI] = ACTIONS(696),
    [anon_sym_extern] = ACTIONS(218),
    [anon_sym_STAR] = ACTIONS(696),
    [anon_sym_static] = ACTIONS(218),
    [anon_sym_register] = ACTIONS(218),
    [anon_sym_inline] = ACTIONS(218),
    [anon_sym_const] = ACTIONS(220),
    [anon_sym_restrict] = ACTIONS(220),
    [anon_sym_volatile] = ACTIONS(220),
    [anon_sym__Atomic] = ACTIONS(220),
    [anon_sym_mutable] = ACTIONS(220),
    [anon_sym_explicit] = ACTIONS(220),
    [anon_sym_constexpr] = ACTIONS(220),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_AMP] = ACTIONS(698),
    [anon_sym_AMP_AMP] = ACTIONS(696),
    [sym_identifier] = ACTIONS(698),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(696),
    [sym_operator_name] = ACTIONS(696),
  },
  [561] = {
    [sym_destructor_name] = STATE(428),
    [anon_sym_TILDE] = ACTIONS(45),
    [sym_identifier] = ACTIONS(2112),
    [sym_comment] = ACTIONS(49),
    [sym_operator_name] = ACTIONS(702),
  },
  [562] = {
    [anon_sym_LPAREN] = ACTIONS(2114),
    [anon_sym_COMMA] = ACTIONS(2114),
    [anon_sym_RPAREN] = ACTIONS(2114),
    [anon_sym_SEMI] = ACTIONS(2114),
    [anon_sym_extern] = ACTIONS(2116),
    [anon_sym_LBRACE] = ACTIONS(2114),
    [anon_sym_STAR] = ACTIONS(2114),
    [anon_sym_LBRACK] = ACTIONS(2114),
    [anon_sym_static] = ACTIONS(2116),
    [anon_sym_register] = ACTIONS(2116),
    [anon_sym_inline] = ACTIONS(2116),
    [anon_sym_const] = ACTIONS(2116),
    [anon_sym_restrict] = ACTIONS(2116),
    [anon_sym_volatile] = ACTIONS(2116),
    [anon_sym__Atomic] = ACTIONS(2116),
    [anon_sym_mutable] = ACTIONS(2116),
    [anon_sym_explicit] = ACTIONS(2116),
    [anon_sym_constexpr] = ACTIONS(2116),
    [anon_sym_COLON] = ACTIONS(2116),
    [anon_sym_AMP] = ACTIONS(2116),
    [anon_sym_AMP_AMP] = ACTIONS(2114),
    [anon_sym_TILDE] = ACTIONS(2114),
    [anon_sym_GT] = ACTIONS(2114),
    [sym_identifier] = ACTIONS(2116),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(2114),
    [sym_operator_name] = ACTIONS(2114),
  },
  [563] = {
    [sym_preproc_if_in_field_declaration_list] = STATE(246),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(247),
    [sym_type_definition] = STATE(563),
    [sym__declaration_specifiers] = STATE(248),
    [sym__declarator] = STATE(249),
    [sym_pointer_declarator] = STATE(249),
    [sym_function_declarator] = STATE(250),
    [sym_array_declarator] = STATE(249),
    [sym_storage_class_specifier] = STATE(257),
    [sym_type_qualifier] = STATE(257),
    [sym__type_specifier] = STATE(251),
    [sym_sized_type_specifier] = STATE(251),
    [sym_enum_specifier] = STATE(251),
    [sym_struct_specifier] = STATE(251),
    [sym_union_specifier] = STATE(251),
    [sym__field_declaration_list_item] = STATE(563),
    [sym_field_declaration] = STATE(563),
    [sym_macro_type_specifier] = STATE(251),
    [sym_class_specifier] = STATE(251),
    [sym_dependent_type] = STATE(251),
    [sym_template_declaration] = STATE(563),
    [sym_inline_method_definition] = STATE(252),
    [sym_constructor_or_destructor_definition] = STATE(252),
    [sym_constructor_or_destructor_declaration] = STATE(253),
    [sym_friend_declaration] = STATE(563),
    [sym_access_specifier] = STATE(563),
    [sym_reference_declarator] = STATE(249),
    [sym_template_type] = STATE(254),
    [sym_template_function] = STATE(249),
    [sym_using_declaration] = STATE(563),
    [sym_alias_declaration] = STATE(563),
    [sym_destructor_name] = STATE(249),
    [sym_scoped_identifier] = STATE(33),
    [sym_scoped_type_identifier] = STATE(34),
    [sym_scoped_namespace_identifier] = STATE(255),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(563),
    [aux_sym__declaration_specifiers_repeat1] = STATE(257),
    [aux_sym_sized_type_specifier_repeat1] = STATE(258),
    [anon_sym_LPAREN] = ACTIONS(2118),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(2121),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(2124),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(2127),
    [anon_sym_typedef] = ACTIONS(2130),
    [anon_sym_extern] = ACTIONS(2133),
    [anon_sym_RBRACE] = ACTIONS(2136),
    [anon_sym_STAR] = ACTIONS(2138),
    [anon_sym_static] = ACTIONS(2133),
    [anon_sym_register] = ACTIONS(2133),
    [anon_sym_inline] = ACTIONS(2133),
    [anon_sym_const] = ACTIONS(2141),
    [anon_sym_restrict] = ACTIONS(2141),
    [anon_sym_volatile] = ACTIONS(2141),
    [anon_sym__Atomic] = ACTIONS(2141),
    [anon_sym_mutable] = ACTIONS(2141),
    [anon_sym_explicit] = ACTIONS(2141),
    [anon_sym_constexpr] = ACTIONS(2141),
    [anon_sym_unsigned] = ACTIONS(2144),
    [anon_sym_long] = ACTIONS(2144),
    [anon_sym_short] = ACTIONS(2144),
    [sym_primitive_type] = ACTIONS(2147),
    [anon_sym_enum] = ACTIONS(2150),
    [anon_sym_struct] = ACTIONS(2153),
    [anon_sym_union] = ACTIONS(2156),
    [anon_sym_AMP] = ACTIONS(2159),
    [anon_sym_AMP_AMP] = ACTIONS(2162),
    [anon_sym_TILDE] = ACTIONS(2165),
    [sym_identifier] = ACTIONS(2168),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(2171),
    [anon_sym_public] = ACTIONS(2174),
    [sym_auto] = ACTIONS(2147),
    [anon_sym_typename] = ACTIONS(2177),
    [anon_sym_template] = ACTIONS(2180),
    [anon_sym_friend] = ACTIONS(2183),
    [anon_sym_private] = ACTIONS(2174),
    [anon_sym_protected] = ACTIONS(2174),
    [anon_sym_using] = ACTIONS(2186),
    [anon_sym_COLON_COLON] = ACTIONS(2189),
    [sym_operator_name] = ACTIONS(2192),
  },
  [564] = {
    [sym_compound_statement] = STATE(1083),
    [sym_field_initializer_list] = STATE(1086),
    [anon_sym_LPAREN] = ACTIONS(210),
    [anon_sym_LBRACE] = ACTIONS(1049),
    [anon_sym_LBRACK] = ACTIONS(210),
    [anon_sym_COLON] = ACTIONS(214),
    [sym_comment] = ACTIONS(49),
  },
  [565] = {
    [sym_storage_class_specifier] = STATE(1087),
    [sym_type_qualifier] = STATE(1087),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1087),
    [anon_sym_LPAREN] = ACTIONS(696),
    [anon_sym_SEMI] = ACTIONS(696),
    [anon_sym_extern] = ACTIONS(218),
    [anon_sym_STAR] = ACTIONS(696),
    [anon_sym_static] = ACTIONS(218),
    [anon_sym_register] = ACTIONS(218),
    [anon_sym_inline] = ACTIONS(218),
    [anon_sym_const] = ACTIONS(220),
    [anon_sym_restrict] = ACTIONS(220),
    [anon_sym_volatile] = ACTIONS(220),
    [anon_sym__Atomic] = ACTIONS(220),
    [anon_sym_mutable] = ACTIONS(220),
    [anon_sym_explicit] = ACTIONS(220),
    [anon_sym_constexpr] = ACTIONS(220),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_AMP] = ACTIONS(698),
    [anon_sym_AMP_AMP] = ACTIONS(696),
    [sym_identifier] = ACTIONS(698),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(696),
    [sym_operator_name] = ACTIONS(696),
  },
  [566] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(566),
    [anon_sym_LPAREN] = ACTIONS(816),
    [anon_sym_SEMI] = ACTIONS(816),
    [anon_sym_extern] = ACTIONS(818),
    [anon_sym_STAR] = ACTIONS(816),
    [anon_sym_static] = ACTIONS(818),
    [anon_sym_register] = ACTIONS(818),
    [anon_sym_inline] = ACTIONS(818),
    [anon_sym_const] = ACTIONS(818),
    [anon_sym_restrict] = ACTIONS(818),
    [anon_sym_volatile] = ACTIONS(818),
    [anon_sym__Atomic] = ACTIONS(818),
    [anon_sym_mutable] = ACTIONS(818),
    [anon_sym_explicit] = ACTIONS(818),
    [anon_sym_constexpr] = ACTIONS(818),
    [anon_sym_unsigned] = ACTIONS(2195),
    [anon_sym_long] = ACTIONS(2195),
    [anon_sym_short] = ACTIONS(2195),
    [sym_primitive_type] = ACTIONS(818),
    [anon_sym_COLON] = ACTIONS(818),
    [anon_sym_AMP] = ACTIONS(818),
    [anon_sym_AMP_AMP] = ACTIONS(816),
    [sym_identifier] = ACTIONS(818),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(816),
    [sym_operator_name] = ACTIONS(816),
  },
  [567] = {
    [aux_sym_base_class_clause_repeat1] = STATE(1088),
    [anon_sym_COMMA] = ACTIONS(1069),
    [anon_sym_LBRACE] = ACTIONS(2198),
    [sym_comment] = ACTIONS(49),
  },
  [568] = {
    [sym__class_name] = STATE(1090),
    [sym_template_type] = STATE(196),
    [sym_scoped_type_identifier] = STATE(80),
    [sym_scoped_namespace_identifier] = STATE(64),
    [sym_identifier] = ACTIONS(394),
    [sym_comment] = ACTIONS(49),
    [anon_sym_public] = ACTIONS(2200),
    [anon_sym_COLON_COLON] = ACTIONS(111),
  },
  [569] = {
    [aux_sym_base_class_clause_repeat1] = STATE(1091),
    [anon_sym_COMMA] = ACTIONS(1069),
    [anon_sym_LBRACE] = ACTIONS(2198),
    [sym_comment] = ACTIONS(49),
  },
  [570] = {
    [anon_sym_LPAREN] = ACTIONS(1140),
    [anon_sym_COMMA] = ACTIONS(1140),
    [anon_sym_RPAREN] = ACTIONS(1140),
    [anon_sym_SEMI] = ACTIONS(1140),
    [anon_sym_extern] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(1140),
    [anon_sym_STAR] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1140),
    [anon_sym_static] = ACTIONS(1142),
    [anon_sym_register] = ACTIONS(1142),
    [anon_sym_inline] = ACTIONS(1142),
    [anon_sym_const] = ACTIONS(1142),
    [anon_sym_restrict] = ACTIONS(1142),
    [anon_sym_volatile] = ACTIONS(1142),
    [anon_sym__Atomic] = ACTIONS(1142),
    [anon_sym_mutable] = ACTIONS(1142),
    [anon_sym_explicit] = ACTIONS(1142),
    [anon_sym_constexpr] = ACTIONS(1142),
    [anon_sym_COLON] = ACTIONS(1142),
    [anon_sym_AMP] = ACTIONS(1142),
    [anon_sym_AMP_AMP] = ACTIONS(1140),
    [anon_sym_TILDE] = ACTIONS(1140),
    [anon_sym_LT] = ACTIONS(1140),
    [anon_sym_GT] = ACTIONS(1140),
    [sym_identifier] = ACTIONS(1142),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(1144),
    [sym_operator_name] = ACTIONS(1140),
  },
  [571] = {
    [anon_sym_LPAREN] = ACTIONS(2202),
    [anon_sym_COMMA] = ACTIONS(2202),
    [anon_sym_RPAREN] = ACTIONS(2202),
    [anon_sym_SEMI] = ACTIONS(2202),
    [anon_sym_extern] = ACTIONS(2204),
    [anon_sym_LBRACE] = ACTIONS(2202),
    [anon_sym_STAR] = ACTIONS(2202),
    [anon_sym_LBRACK] = ACTIONS(2202),
    [anon_sym_static] = ACTIONS(2204),
    [anon_sym_register] = ACTIONS(2204),
    [anon_sym_inline] = ACTIONS(2204),
    [anon_sym_const] = ACTIONS(2204),
    [anon_sym_restrict] = ACTIONS(2204),
    [anon_sym_volatile] = ACTIONS(2204),
    [anon_sym__Atomic] = ACTIONS(2204),
    [anon_sym_mutable] = ACTIONS(2204),
    [anon_sym_explicit] = ACTIONS(2204),
    [anon_sym_constexpr] = ACTIONS(2204),
    [anon_sym_COLON] = ACTIONS(2204),
    [anon_sym_AMP] = ACTIONS(2204),
    [anon_sym_AMP_AMP] = ACTIONS(2202),
    [anon_sym_TILDE] = ACTIONS(2202),
    [anon_sym_GT] = ACTIONS(2202),
    [sym_identifier] = ACTIONS(2204),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(2202),
    [sym_operator_name] = ACTIONS(2202),
  },
  [572] = {
    [anon_sym_LPAREN] = ACTIONS(1801),
    [anon_sym_COMMA] = ACTIONS(1801),
    [anon_sym_RPAREN] = ACTIONS(1801),
    [anon_sym_SEMI] = ACTIONS(1801),
    [anon_sym_extern] = ACTIONS(1803),
    [anon_sym_LBRACE] = ACTIONS(1801),
    [anon_sym_STAR] = ACTIONS(1801),
    [anon_sym_LBRACK] = ACTIONS(1801),
    [anon_sym_static] = ACTIONS(1803),
    [anon_sym_register] = ACTIONS(1803),
    [anon_sym_inline] = ACTIONS(1803),
    [anon_sym_const] = ACTIONS(1803),
    [anon_sym_restrict] = ACTIONS(1803),
    [anon_sym_volatile] = ACTIONS(1803),
    [anon_sym__Atomic] = ACTIONS(1803),
    [anon_sym_mutable] = ACTIONS(1803),
    [anon_sym_explicit] = ACTIONS(1803),
    [anon_sym_constexpr] = ACTIONS(1803),
    [anon_sym_COLON] = ACTIONS(1803),
    [anon_sym_AMP] = ACTIONS(1803),
    [anon_sym_AMP_AMP] = ACTIONS(1801),
    [anon_sym_TILDE] = ACTIONS(1801),
    [anon_sym_LT] = ACTIONS(1801),
    [anon_sym_GT] = ACTIONS(1801),
    [sym_identifier] = ACTIONS(1803),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(1805),
    [sym_operator_name] = ACTIONS(1801),
  },
  [573] = {
    [anon_sym_LPAREN] = ACTIONS(2206),
    [anon_sym_COMMA] = ACTIONS(2206),
    [anon_sym_RPAREN] = ACTIONS(2206),
    [anon_sym_SEMI] = ACTIONS(2206),
    [anon_sym_extern] = ACTIONS(2208),
    [anon_sym_LBRACE] = ACTIONS(2206),
    [anon_sym_STAR] = ACTIONS(2206),
    [anon_sym_LBRACK] = ACTIONS(2206),
    [anon_sym_static] = ACTIONS(2208),
    [anon_sym_register] = ACTIONS(2208),
    [anon_sym_inline] = ACTIONS(2208),
    [anon_sym_const] = ACTIONS(2208),
    [anon_sym_restrict] = ACTIONS(2208),
    [anon_sym_volatile] = ACTIONS(2208),
    [anon_sym__Atomic] = ACTIONS(2208),
    [anon_sym_mutable] = ACTIONS(2208),
    [anon_sym_explicit] = ACTIONS(2208),
    [anon_sym_constexpr] = ACTIONS(2208),
    [anon_sym_COLON] = ACTIONS(2208),
    [anon_sym_AMP] = ACTIONS(2208),
    [anon_sym_AMP_AMP] = ACTIONS(2206),
    [anon_sym_TILDE] = ACTIONS(2206),
    [anon_sym_GT] = ACTIONS(2206),
    [sym_identifier] = ACTIONS(2208),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(2206),
    [sym_operator_name] = ACTIONS(2206),
  },
  [574] = {
    [sym_type_qualifier] = STATE(724),
    [sym__type_specifier] = STATE(720),
    [sym_sized_type_specifier] = STATE(720),
    [sym_enum_specifier] = STATE(720),
    [sym_struct_specifier] = STATE(720),
    [sym_union_specifier] = STATE(720),
    [sym__expression] = STATE(721),
    [sym_comma_expression] = STATE(722),
    [sym_conditional_expression] = STATE(721),
    [sym_assignment_expression] = STATE(721),
    [sym_pointer_expression] = STATE(721),
    [sym_logical_expression] = STATE(721),
    [sym_bitwise_expression] = STATE(721),
    [sym_equality_expression] = STATE(721),
    [sym_relational_expression] = STATE(721),
    [sym_shift_expression] = STATE(721),
    [sym_math_expression] = STATE(721),
    [sym_cast_expression] = STATE(721),
    [sym_type_descriptor] = STATE(1092),
    [sym_sizeof_expression] = STATE(721),
    [sym_subscript_expression] = STATE(721),
    [sym_call_expression] = STATE(721),
    [sym_field_expression] = STATE(721),
    [sym_compound_literal_expression] = STATE(721),
    [sym_parenthesized_expression] = STATE(721),
    [sym_concatenated_string] = STATE(721),
    [sym_macro_type_specifier] = STATE(720),
    [sym_class_specifier] = STATE(720),
    [sym_dependent_type] = STATE(720),
    [sym_template_type] = STATE(415),
    [sym_template_function] = STATE(721),
    [sym_new_expression] = STATE(721),
    [sym_delete_expression] = STATE(721),
    [sym_lambda_expression] = STATE(721),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(416),
    [sym_scoped_namespace_identifier] = STATE(417),
    [aux_sym_type_definition_repeat1] = STATE(724),
    [aux_sym_sized_type_specifier_repeat1] = STATE(725),
    [sym_raw_string_literal] = ACTIONS(1397),
    [anon_sym_LPAREN] = ACTIONS(1087),
    [anon_sym_STAR] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_restrict] = ACTIONS(93),
    [anon_sym_volatile] = ACTIONS(93),
    [anon_sym__Atomic] = ACTIONS(93),
    [anon_sym_mutable] = ACTIONS(93),
    [anon_sym_explicit] = ACTIONS(93),
    [anon_sym_constexpr] = ACTIONS(93),
    [anon_sym_unsigned] = ACTIONS(1399),
    [anon_sym_long] = ACTIONS(1399),
    [anon_sym_short] = ACTIONS(1399),
    [sym_primitive_type] = ACTIONS(1401),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(428),
    [anon_sym_union] = ACTIONS(430),
    [anon_sym_AMP] = ACTIONS(1089),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1093),
    [anon_sym_PLUS] = ACTIONS(1095),
    [anon_sym_DASH] = ACTIONS(1095),
    [anon_sym_DASH_DASH] = ACTIONS(1097),
    [anon_sym_PLUS_PLUS] = ACTIONS(1097),
    [anon_sym_sizeof] = ACTIONS(1099),
    [sym_number_literal] = ACTIONS(1397),
    [sym_char_literal] = ACTIONS(1397),
    [sym_string_literal] = ACTIONS(1101),
    [sym_true] = ACTIONS(1403),
    [sym_false] = ACTIONS(1403),
    [sym_null] = ACTIONS(1403),
    [sym_identifier] = ACTIONS(1405),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(436),
    [sym_auto] = ACTIONS(1401),
    [anon_sym_typename] = ACTIONS(1407),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1409),
    [anon_sym_delete] = ACTIONS(1109),
    [sym_nullptr] = ACTIONS(1403),
  },
  [575] = {
    [sym__expression] = STATE(727),
    [sym_conditional_expression] = STATE(727),
    [sym_assignment_expression] = STATE(727),
    [sym_pointer_expression] = STATE(727),
    [sym_logical_expression] = STATE(727),
    [sym_bitwise_expression] = STATE(727),
    [sym_equality_expression] = STATE(727),
    [sym_relational_expression] = STATE(727),
    [sym_shift_expression] = STATE(727),
    [sym_math_expression] = STATE(727),
    [sym_cast_expression] = STATE(727),
    [sym_sizeof_expression] = STATE(727),
    [sym_subscript_expression] = STATE(727),
    [sym_call_expression] = STATE(727),
    [sym_field_expression] = STATE(727),
    [sym_compound_literal_expression] = STATE(727),
    [sym_parenthesized_expression] = STATE(727),
    [sym_concatenated_string] = STATE(727),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(727),
    [sym_new_expression] = STATE(727),
    [sym_delete_expression] = STATE(727),
    [sym_lambda_expression] = STATE(727),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(1411),
    [anon_sym_LPAREN] = ACTIONS(1087),
    [anon_sym_STAR] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_AMP] = ACTIONS(1089),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1093),
    [anon_sym_PLUS] = ACTIONS(1095),
    [anon_sym_DASH] = ACTIONS(1095),
    [anon_sym_DASH_DASH] = ACTIONS(1097),
    [anon_sym_PLUS_PLUS] = ACTIONS(1097),
    [anon_sym_sizeof] = ACTIONS(1099),
    [sym_number_literal] = ACTIONS(1411),
    [sym_char_literal] = ACTIONS(1411),
    [sym_string_literal] = ACTIONS(1101),
    [sym_true] = ACTIONS(1413),
    [sym_false] = ACTIONS(1413),
    [sym_null] = ACTIONS(1413),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_delete] = ACTIONS(1109),
    [sym_nullptr] = ACTIONS(1413),
  },
  [576] = {
    [sym__expression] = STATE(757),
    [sym_conditional_expression] = STATE(757),
    [sym_assignment_expression] = STATE(757),
    [sym_pointer_expression] = STATE(757),
    [sym_logical_expression] = STATE(757),
    [sym_bitwise_expression] = STATE(757),
    [sym_equality_expression] = STATE(757),
    [sym_relational_expression] = STATE(757),
    [sym_shift_expression] = STATE(757),
    [sym_math_expression] = STATE(757),
    [sym_cast_expression] = STATE(757),
    [sym_sizeof_expression] = STATE(757),
    [sym_subscript_expression] = STATE(757),
    [sym_call_expression] = STATE(757),
    [sym_field_expression] = STATE(757),
    [sym_compound_literal_expression] = STATE(757),
    [sym_parenthesized_expression] = STATE(757),
    [sym_concatenated_string] = STATE(757),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(757),
    [sym_new_expression] = STATE(757),
    [sym_delete_expression] = STATE(757),
    [sym_lambda_expression] = STATE(757),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(1459),
    [anon_sym_LPAREN] = ACTIONS(1087),
    [anon_sym_STAR] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_AMP] = ACTIONS(1089),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1093),
    [anon_sym_PLUS] = ACTIONS(1095),
    [anon_sym_DASH] = ACTIONS(1095),
    [anon_sym_DASH_DASH] = ACTIONS(1097),
    [anon_sym_PLUS_PLUS] = ACTIONS(1097),
    [anon_sym_sizeof] = ACTIONS(1099),
    [sym_number_literal] = ACTIONS(1459),
    [sym_char_literal] = ACTIONS(1459),
    [sym_string_literal] = ACTIONS(1101),
    [sym_true] = ACTIONS(1461),
    [sym_false] = ACTIONS(1461),
    [sym_null] = ACTIONS(1461),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_delete] = ACTIONS(1109),
    [sym_nullptr] = ACTIONS(1461),
  },
  [577] = {
    [sym__expression] = STATE(758),
    [sym_conditional_expression] = STATE(758),
    [sym_assignment_expression] = STATE(758),
    [sym_pointer_expression] = STATE(758),
    [sym_logical_expression] = STATE(758),
    [sym_bitwise_expression] = STATE(758),
    [sym_equality_expression] = STATE(758),
    [sym_relational_expression] = STATE(758),
    [sym_shift_expression] = STATE(758),
    [sym_math_expression] = STATE(758),
    [sym_cast_expression] = STATE(758),
    [sym_sizeof_expression] = STATE(758),
    [sym_subscript_expression] = STATE(758),
    [sym_call_expression] = STATE(758),
    [sym_field_expression] = STATE(758),
    [sym_compound_literal_expression] = STATE(758),
    [sym_parenthesized_expression] = STATE(758),
    [sym_concatenated_string] = STATE(758),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(758),
    [sym_new_expression] = STATE(758),
    [sym_delete_expression] = STATE(758),
    [sym_lambda_expression] = STATE(758),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(1463),
    [anon_sym_LPAREN] = ACTIONS(1087),
    [anon_sym_STAR] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_AMP] = ACTIONS(1089),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1093),
    [anon_sym_PLUS] = ACTIONS(1095),
    [anon_sym_DASH] = ACTIONS(1095),
    [anon_sym_DASH_DASH] = ACTIONS(1097),
    [anon_sym_PLUS_PLUS] = ACTIONS(1097),
    [anon_sym_sizeof] = ACTIONS(1099),
    [sym_number_literal] = ACTIONS(1463),
    [sym_char_literal] = ACTIONS(1463),
    [sym_string_literal] = ACTIONS(1101),
    [sym_true] = ACTIONS(1465),
    [sym_false] = ACTIONS(1465),
    [sym_null] = ACTIONS(1465),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_delete] = ACTIONS(1109),
    [sym_nullptr] = ACTIONS(1465),
  },
  [578] = {
    [sym__expression] = STATE(759),
    [sym_conditional_expression] = STATE(759),
    [sym_assignment_expression] = STATE(759),
    [sym_pointer_expression] = STATE(759),
    [sym_logical_expression] = STATE(759),
    [sym_bitwise_expression] = STATE(759),
    [sym_equality_expression] = STATE(759),
    [sym_relational_expression] = STATE(759),
    [sym_shift_expression] = STATE(759),
    [sym_math_expression] = STATE(759),
    [sym_cast_expression] = STATE(759),
    [sym_sizeof_expression] = STATE(759),
    [sym_subscript_expression] = STATE(759),
    [sym_call_expression] = STATE(759),
    [sym_field_expression] = STATE(759),
    [sym_compound_literal_expression] = STATE(759),
    [sym_parenthesized_expression] = STATE(759),
    [sym_concatenated_string] = STATE(759),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(759),
    [sym_new_expression] = STATE(759),
    [sym_delete_expression] = STATE(759),
    [sym_lambda_expression] = STATE(759),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(1467),
    [anon_sym_LPAREN] = ACTIONS(1087),
    [anon_sym_STAR] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_AMP] = ACTIONS(1089),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1093),
    [anon_sym_PLUS] = ACTIONS(1095),
    [anon_sym_DASH] = ACTIONS(1095),
    [anon_sym_DASH_DASH] = ACTIONS(1097),
    [anon_sym_PLUS_PLUS] = ACTIONS(1097),
    [anon_sym_sizeof] = ACTIONS(1099),
    [sym_number_literal] = ACTIONS(1467),
    [sym_char_literal] = ACTIONS(1467),
    [sym_string_literal] = ACTIONS(1101),
    [sym_true] = ACTIONS(1469),
    [sym_false] = ACTIONS(1469),
    [sym_null] = ACTIONS(1469),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_delete] = ACTIONS(1109),
    [sym_nullptr] = ACTIONS(1469),
  },
  [579] = {
    [sym__expression] = STATE(1094),
    [sym_conditional_expression] = STATE(1094),
    [sym_assignment_expression] = STATE(1094),
    [sym_pointer_expression] = STATE(1094),
    [sym_logical_expression] = STATE(1094),
    [sym_bitwise_expression] = STATE(1094),
    [sym_equality_expression] = STATE(1094),
    [sym_relational_expression] = STATE(1094),
    [sym_shift_expression] = STATE(1094),
    [sym_math_expression] = STATE(1094),
    [sym_cast_expression] = STATE(1094),
    [sym_sizeof_expression] = STATE(1094),
    [sym_subscript_expression] = STATE(1094),
    [sym_call_expression] = STATE(1094),
    [sym_field_expression] = STATE(1094),
    [sym_compound_literal_expression] = STATE(1094),
    [sym_parenthesized_expression] = STATE(1094),
    [sym_concatenated_string] = STATE(1094),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(1094),
    [sym_new_expression] = STATE(1094),
    [sym_delete_expression] = STATE(1094),
    [sym_lambda_expression] = STATE(1094),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(2210),
    [anon_sym_LPAREN] = ACTIONS(2212),
    [anon_sym_STAR] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_AMP] = ACTIONS(1089),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1093),
    [anon_sym_PLUS] = ACTIONS(1095),
    [anon_sym_DASH] = ACTIONS(1095),
    [anon_sym_DASH_DASH] = ACTIONS(1097),
    [anon_sym_PLUS_PLUS] = ACTIONS(1097),
    [anon_sym_sizeof] = ACTIONS(1099),
    [sym_number_literal] = ACTIONS(2210),
    [sym_char_literal] = ACTIONS(2210),
    [sym_string_literal] = ACTIONS(1101),
    [sym_true] = ACTIONS(2214),
    [sym_false] = ACTIONS(2214),
    [sym_null] = ACTIONS(2214),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_delete] = ACTIONS(1109),
    [sym_nullptr] = ACTIONS(2214),
  },
  [580] = {
    [aux_sym_concatenated_string_repeat1] = STATE(1095),
    [anon_sym_LPAREN] = ACTIONS(1477),
    [anon_sym_COMMA] = ACTIONS(1477),
    [anon_sym_RPAREN] = ACTIONS(1477),
    [anon_sym_STAR] = ACTIONS(1479),
    [anon_sym_LBRACK] = ACTIONS(1477),
    [anon_sym_EQ] = ACTIONS(1479),
    [anon_sym_QMARK] = ACTIONS(1477),
    [anon_sym_STAR_EQ] = ACTIONS(1477),
    [anon_sym_SLASH_EQ] = ACTIONS(1477),
    [anon_sym_PERCENT_EQ] = ACTIONS(1477),
    [anon_sym_PLUS_EQ] = ACTIONS(1477),
    [anon_sym_DASH_EQ] = ACTIONS(1477),
    [anon_sym_LT_LT_EQ] = ACTIONS(1477),
    [anon_sym_GT_GT_EQ] = ACTIONS(1477),
    [anon_sym_AMP_EQ] = ACTIONS(1477),
    [anon_sym_CARET_EQ] = ACTIONS(1477),
    [anon_sym_PIPE_EQ] = ACTIONS(1477),
    [anon_sym_AMP] = ACTIONS(1479),
    [anon_sym_PIPE_PIPE] = ACTIONS(1477),
    [anon_sym_AMP_AMP] = ACTIONS(1477),
    [anon_sym_PIPE] = ACTIONS(1479),
    [anon_sym_CARET] = ACTIONS(1479),
    [anon_sym_EQ_EQ] = ACTIONS(1477),
    [anon_sym_BANG_EQ] = ACTIONS(1477),
    [anon_sym_LT] = ACTIONS(1479),
    [anon_sym_GT] = ACTIONS(1479),
    [anon_sym_LT_EQ] = ACTIONS(1477),
    [anon_sym_GT_EQ] = ACTIONS(1477),
    [anon_sym_LT_LT] = ACTIONS(1479),
    [anon_sym_GT_GT] = ACTIONS(1479),
    [anon_sym_PLUS] = ACTIONS(1479),
    [anon_sym_DASH] = ACTIONS(1479),
    [anon_sym_SLASH] = ACTIONS(1479),
    [anon_sym_PERCENT] = ACTIONS(1479),
    [anon_sym_DASH_DASH] = ACTIONS(1477),
    [anon_sym_PLUS_PLUS] = ACTIONS(1477),
    [anon_sym_DOT] = ACTIONS(1477),
    [anon_sym_DASH_GT] = ACTIONS(1477),
    [sym_string_literal] = ACTIONS(2216),
    [sym_comment] = ACTIONS(49),
  },
  [581] = {
    [sym_initializer_list] = STATE(765),
    [sym_template_argument_list] = STATE(1097),
    [anon_sym_LPAREN] = ACTIONS(1477),
    [anon_sym_COMMA] = ACTIONS(1477),
    [anon_sym_RPAREN] = ACTIONS(1477),
    [anon_sym_SEMI] = ACTIONS(1477),
    [anon_sym_LBRACE] = ACTIONS(548),
    [anon_sym_RBRACE] = ACTIONS(1477),
    [anon_sym_STAR] = ACTIONS(1479),
    [anon_sym_LBRACK] = ACTIONS(1477),
    [anon_sym_RBRACK] = ACTIONS(1477),
    [anon_sym_EQ] = ACTIONS(1479),
    [anon_sym_COLON] = ACTIONS(1479),
    [anon_sym_QMARK] = ACTIONS(1477),
    [anon_sym_STAR_EQ] = ACTIONS(1477),
    [anon_sym_SLASH_EQ] = ACTIONS(1477),
    [anon_sym_PERCENT_EQ] = ACTIONS(1477),
    [anon_sym_PLUS_EQ] = ACTIONS(1477),
    [anon_sym_DASH_EQ] = ACTIONS(1477),
    [anon_sym_LT_LT_EQ] = ACTIONS(1477),
    [anon_sym_GT_GT_EQ] = ACTIONS(1477),
    [anon_sym_AMP_EQ] = ACTIONS(1477),
    [anon_sym_CARET_EQ] = ACTIONS(1477),
    [anon_sym_PIPE_EQ] = ACTIONS(1477),
    [anon_sym_AMP] = ACTIONS(1479),
    [anon_sym_PIPE_PIPE] = ACTIONS(1477),
    [anon_sym_AMP_AMP] = ACTIONS(1477),
    [anon_sym_PIPE] = ACTIONS(1479),
    [anon_sym_CARET] = ACTIONS(1479),
    [anon_sym_EQ_EQ] = ACTIONS(1477),
    [anon_sym_BANG_EQ] = ACTIONS(1477),
    [anon_sym_LT] = ACTIONS(1564),
    [anon_sym_GT] = ACTIONS(1479),
    [anon_sym_LT_EQ] = ACTIONS(1477),
    [anon_sym_GT_EQ] = ACTIONS(1477),
    [anon_sym_LT_LT] = ACTIONS(1479),
    [anon_sym_GT_GT] = ACTIONS(1479),
    [anon_sym_PLUS] = ACTIONS(1479),
    [anon_sym_DASH] = ACTIONS(1479),
    [anon_sym_SLASH] = ACTIONS(1479),
    [anon_sym_PERCENT] = ACTIONS(1479),
    [anon_sym_DASH_DASH] = ACTIONS(1477),
    [anon_sym_PLUS_PLUS] = ACTIONS(1477),
    [anon_sym_DOT] = ACTIONS(1477),
    [anon_sym_DASH_GT] = ACTIONS(1477),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(2218),
  },
  [582] = {
    [sym_destructor_name] = STATE(120),
    [anon_sym_TILDE] = ACTIONS(1500),
    [sym_identifier] = ACTIONS(2220),
    [sym_comment] = ACTIONS(49),
    [anon_sym_delete] = ACTIONS(2222),
    [sym_operator_name] = ACTIONS(190),
  },
  [583] = {
    [sym__expression] = STATE(1101),
    [sym_conditional_expression] = STATE(1101),
    [sym_assignment_expression] = STATE(1101),
    [sym_pointer_expression] = STATE(1101),
    [sym_logical_expression] = STATE(1101),
    [sym_bitwise_expression] = STATE(1101),
    [sym_equality_expression] = STATE(1101),
    [sym_relational_expression] = STATE(1101),
    [sym_shift_expression] = STATE(1101),
    [sym_math_expression] = STATE(1101),
    [sym_cast_expression] = STATE(1101),
    [sym_sizeof_expression] = STATE(1101),
    [sym_subscript_expression] = STATE(1101),
    [sym_call_expression] = STATE(1101),
    [sym_field_expression] = STATE(1101),
    [sym_compound_literal_expression] = STATE(1101),
    [sym_parenthesized_expression] = STATE(1101),
    [sym_concatenated_string] = STATE(1101),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(1101),
    [sym_new_expression] = STATE(1101),
    [sym_delete_expression] = STATE(1101),
    [sym_lambda_expression] = STATE(1101),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(2224),
    [anon_sym_LPAREN] = ACTIONS(1087),
    [anon_sym_STAR] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(2226),
    [anon_sym_AMP] = ACTIONS(1089),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1093),
    [anon_sym_PLUS] = ACTIONS(1095),
    [anon_sym_DASH] = ACTIONS(1095),
    [anon_sym_DASH_DASH] = ACTIONS(1097),
    [anon_sym_PLUS_PLUS] = ACTIONS(1097),
    [anon_sym_sizeof] = ACTIONS(1099),
    [sym_number_literal] = ACTIONS(2224),
    [sym_char_literal] = ACTIONS(2224),
    [sym_string_literal] = ACTIONS(1101),
    [sym_true] = ACTIONS(2228),
    [sym_false] = ACTIONS(2228),
    [sym_null] = ACTIONS(2228),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_delete] = ACTIONS(1109),
    [sym_nullptr] = ACTIONS(2228),
  },
  [584] = {
    [sym_argument_list] = STATE(802),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_COMMA] = ACTIONS(2230),
    [anon_sym_RPAREN] = ACTIONS(2232),
    [anon_sym_STAR] = ACTIONS(2234),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_EQ] = ACTIONS(2236),
    [anon_sym_QMARK] = ACTIONS(2238),
    [anon_sym_STAR_EQ] = ACTIONS(2240),
    [anon_sym_SLASH_EQ] = ACTIONS(2240),
    [anon_sym_PERCENT_EQ] = ACTIONS(2240),
    [anon_sym_PLUS_EQ] = ACTIONS(2240),
    [anon_sym_DASH_EQ] = ACTIONS(2240),
    [anon_sym_LT_LT_EQ] = ACTIONS(2240),
    [anon_sym_GT_GT_EQ] = ACTIONS(2240),
    [anon_sym_AMP_EQ] = ACTIONS(2240),
    [anon_sym_CARET_EQ] = ACTIONS(2240),
    [anon_sym_PIPE_EQ] = ACTIONS(2240),
    [anon_sym_AMP] = ACTIONS(2242),
    [anon_sym_PIPE_PIPE] = ACTIONS(2244),
    [anon_sym_AMP_AMP] = ACTIONS(2246),
    [anon_sym_PIPE] = ACTIONS(2248),
    [anon_sym_CARET] = ACTIONS(2250),
    [anon_sym_EQ_EQ] = ACTIONS(2252),
    [anon_sym_BANG_EQ] = ACTIONS(2252),
    [anon_sym_LT] = ACTIONS(2254),
    [anon_sym_GT] = ACTIONS(2254),
    [anon_sym_LT_EQ] = ACTIONS(2256),
    [anon_sym_GT_EQ] = ACTIONS(2256),
    [anon_sym_LT_LT] = ACTIONS(2258),
    [anon_sym_GT_GT] = ACTIONS(2258),
    [anon_sym_PLUS] = ACTIONS(2260),
    [anon_sym_DASH] = ACTIONS(2260),
    [anon_sym_SLASH] = ACTIONS(2234),
    [anon_sym_PERCENT] = ACTIONS(2234),
    [anon_sym_DASH_DASH] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(1554),
    [anon_sym_DASH_GT] = ACTIONS(1554),
    [sym_comment] = ACTIONS(49),
  },
  [585] = {
    [anon_sym_RPAREN] = ACTIONS(2232),
    [sym_comment] = ACTIONS(49),
  },
  [586] = {
    [sym_initializer_list] = STATE(804),
    [anon_sym_LBRACE] = ACTIONS(548),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(2262),
  },
  [587] = {
    [sym_initializer_list] = STATE(804),
    [sym_template_argument_list] = STATE(141),
    [anon_sym_LBRACE] = ACTIONS(548),
    [anon_sym_LT] = ACTIONS(146),
    [sym_comment] = ACTIONS(49),
  },
  [588] = {
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(2262),
  },
  [589] = {
    [sym_field_declaration_list] = STATE(265),
    [sym_base_class_clause] = STATE(266),
    [anon_sym_LPAREN] = ACTIONS(406),
    [anon_sym_COMMA] = ACTIONS(406),
    [anon_sym_RPAREN] = ACTIONS(406),
    [anon_sym_SEMI] = ACTIONS(406),
    [anon_sym_LBRACE] = ACTIONS(129),
    [anon_sym_STAR] = ACTIONS(406),
    [anon_sym_LBRACK] = ACTIONS(406),
    [anon_sym_COLON] = ACTIONS(943),
    [anon_sym_AMP] = ACTIONS(408),
    [anon_sym_AMP_AMP] = ACTIONS(406),
    [anon_sym_GT] = ACTIONS(406),
    [sym_comment] = ACTIONS(49),
  },
  [590] = {
    [sym_template_argument_list] = STATE(141),
    [anon_sym_LPAREN] = ACTIONS(410),
    [anon_sym_COMMA] = ACTIONS(410),
    [anon_sym_RPAREN] = ACTIONS(410),
    [anon_sym_SEMI] = ACTIONS(410),
    [anon_sym_LBRACE] = ACTIONS(410),
    [anon_sym_STAR] = ACTIONS(410),
    [anon_sym_LBRACK] = ACTIONS(410),
    [anon_sym_COLON] = ACTIONS(410),
    [anon_sym_AMP] = ACTIONS(412),
    [anon_sym_AMP_AMP] = ACTIONS(410),
    [anon_sym_LT] = ACTIONS(146),
    [anon_sym_GT] = ACTIONS(410),
    [sym_comment] = ACTIONS(49),
  },
  [591] = {
    [sym_field_declaration_list] = STATE(268),
    [sym_base_class_clause] = STATE(269),
    [anon_sym_LPAREN] = ACTIONS(416),
    [anon_sym_COMMA] = ACTIONS(416),
    [anon_sym_RPAREN] = ACTIONS(416),
    [anon_sym_SEMI] = ACTIONS(416),
    [anon_sym_LBRACE] = ACTIONS(129),
    [anon_sym_STAR] = ACTIONS(416),
    [anon_sym_LBRACK] = ACTIONS(416),
    [anon_sym_COLON] = ACTIONS(943),
    [anon_sym_AMP] = ACTIONS(418),
    [anon_sym_AMP_AMP] = ACTIONS(416),
    [anon_sym_GT] = ACTIONS(416),
    [sym_comment] = ACTIONS(49),
  },
  [592] = {
    [sym_field_declaration_list] = STATE(283),
    [sym_base_class_clause] = STATE(284),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_COMMA] = ACTIONS(451),
    [anon_sym_RPAREN] = ACTIONS(451),
    [anon_sym_SEMI] = ACTIONS(451),
    [anon_sym_LBRACE] = ACTIONS(129),
    [anon_sym_STAR] = ACTIONS(451),
    [anon_sym_LBRACK] = ACTIONS(451),
    [anon_sym_COLON] = ACTIONS(943),
    [anon_sym_AMP] = ACTIONS(453),
    [anon_sym_AMP_AMP] = ACTIONS(451),
    [anon_sym_GT] = ACTIONS(451),
    [sym_comment] = ACTIONS(49),
  },
  [593] = {
    [sym__declaration_specifiers] = STATE(344),
    [sym__abstract_declarator] = STATE(1119),
    [sym_abstract_pointer_declarator] = STATE(1119),
    [sym_abstract_function_declarator] = STATE(1119),
    [sym_abstract_array_declarator] = STATE(1119),
    [sym_storage_class_specifier] = STATE(346),
    [sym_type_qualifier] = STATE(346),
    [sym__type_specifier] = STATE(345),
    [sym_sized_type_specifier] = STATE(345),
    [sym_enum_specifier] = STATE(345),
    [sym_struct_specifier] = STATE(345),
    [sym_union_specifier] = STATE(345),
    [sym_parameter_list] = STATE(1120),
    [sym_parameter_declaration] = STATE(341),
    [sym_macro_type_specifier] = STATE(345),
    [sym_class_specifier] = STATE(345),
    [sym_dependent_type] = STATE(345),
    [sym_abstract_reference_declarator] = STATE(1119),
    [sym_template_type] = STATE(94),
    [sym_scoped_type_identifier] = STATE(34),
    [sym_scoped_namespace_identifier] = STATE(81),
    [aux_sym__declaration_specifiers_repeat1] = STATE(346),
    [aux_sym_sized_type_specifier_repeat1] = STATE(347),
    [anon_sym_LPAREN] = ACTIONS(1115),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(554),
    [anon_sym_RPAREN] = ACTIONS(556),
    [anon_sym_extern] = ACTIONS(154),
    [anon_sym_STAR] = ACTIONS(2264),
    [anon_sym_LBRACK] = ACTIONS(1121),
    [anon_sym_static] = ACTIONS(154),
    [anon_sym_register] = ACTIONS(154),
    [anon_sym_inline] = ACTIONS(154),
    [anon_sym_const] = ACTIONS(158),
    [anon_sym_restrict] = ACTIONS(158),
    [anon_sym_volatile] = ACTIONS(158),
    [anon_sym__Atomic] = ACTIONS(158),
    [anon_sym_mutable] = ACTIONS(158),
    [anon_sym_explicit] = ACTIONS(158),
    [anon_sym_constexpr] = ACTIONS(158),
    [anon_sym_unsigned] = ACTIONS(558),
    [anon_sym_long] = ACTIONS(558),
    [anon_sym_short] = ACTIONS(558),
    [sym_primitive_type] = ACTIONS(560),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_union] = ACTIONS(39),
    [anon_sym_AMP] = ACTIONS(2266),
    [anon_sym_AMP_AMP] = ACTIONS(2268),
    [sym_identifier] = ACTIONS(152),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(51),
    [sym_auto] = ACTIONS(560),
    [anon_sym_typename] = ACTIONS(562),
    [anon_sym_COLON_COLON] = ACTIONS(135),
  },
  [594] = {
    [sym__abstract_declarator] = STATE(1121),
    [sym_abstract_pointer_declarator] = STATE(1121),
    [sym_abstract_function_declarator] = STATE(1121),
    [sym_abstract_array_declarator] = STATE(1121),
    [sym_parameter_list] = STATE(598),
    [sym_abstract_reference_declarator] = STATE(1121),
    [anon_sym_LPAREN] = ACTIONS(1115),
    [anon_sym_COMMA] = ACTIONS(2270),
    [anon_sym_STAR] = ACTIONS(1119),
    [anon_sym_LBRACK] = ACTIONS(1121),
    [anon_sym_AMP] = ACTIONS(1123),
    [anon_sym_AMP_AMP] = ACTIONS(1125),
    [anon_sym_GT] = ACTIONS(2270),
    [sym_comment] = ACTIONS(49),
  },
  [595] = {
    [sym__declaration_specifiers] = STATE(1123),
    [sym_storage_class_specifier] = STATE(374),
    [sym_type_qualifier] = STATE(374),
    [sym__type_specifier] = STATE(367),
    [sym_sized_type_specifier] = STATE(367),
    [sym_enum_specifier] = STATE(367),
    [sym_struct_specifier] = STATE(367),
    [sym_union_specifier] = STATE(367),
    [sym__expression] = STATE(1124),
    [sym_conditional_expression] = STATE(1124),
    [sym_assignment_expression] = STATE(1124),
    [sym_pointer_expression] = STATE(1124),
    [sym_logical_expression] = STATE(1124),
    [sym_bitwise_expression] = STATE(1124),
    [sym_equality_expression] = STATE(1124),
    [sym_relational_expression] = STATE(1124),
    [sym_shift_expression] = STATE(1124),
    [sym_math_expression] = STATE(1124),
    [sym_cast_expression] = STATE(1124),
    [sym_sizeof_expression] = STATE(1124),
    [sym_subscript_expression] = STATE(1124),
    [sym_call_expression] = STATE(1124),
    [sym_field_expression] = STATE(1124),
    [sym_compound_literal_expression] = STATE(1124),
    [sym_parenthesized_expression] = STATE(1124),
    [sym_concatenated_string] = STATE(1124),
    [sym_macro_type_specifier] = STATE(367),
    [sym_class_specifier] = STATE(367),
    [sym_dependent_type] = STATE(367),
    [sym_template_type] = STATE(369),
    [sym_template_function] = STATE(1124),
    [sym_new_expression] = STATE(1124),
    [sym_delete_expression] = STATE(1124),
    [sym_lambda_expression] = STATE(1124),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(372),
    [sym_scoped_namespace_identifier] = STATE(373),
    [aux_sym__declaration_specifiers_repeat1] = STATE(374),
    [aux_sym_sized_type_specifier_repeat1] = STATE(375),
    [sym_raw_string_literal] = ACTIONS(2272),
    [anon_sym_LPAREN] = ACTIONS(566),
    [anon_sym_extern] = ACTIONS(154),
    [anon_sym_STAR] = ACTIONS(568),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_RBRACK] = ACTIONS(2274),
    [anon_sym_static] = ACTIONS(154),
    [anon_sym_register] = ACTIONS(154),
    [anon_sym_inline] = ACTIONS(154),
    [anon_sym_const] = ACTIONS(158),
    [anon_sym_restrict] = ACTIONS(158),
    [anon_sym_volatile] = ACTIONS(158),
    [anon_sym__Atomic] = ACTIONS(158),
    [anon_sym_mutable] = ACTIONS(158),
    [anon_sym_explicit] = ACTIONS(158),
    [anon_sym_constexpr] = ACTIONS(158),
    [anon_sym_unsigned] = ACTIONS(574),
    [anon_sym_long] = ACTIONS(574),
    [anon_sym_short] = ACTIONS(574),
    [sym_primitive_type] = ACTIONS(576),
    [anon_sym_enum] = ACTIONS(578),
    [anon_sym_struct] = ACTIONS(580),
    [anon_sym_union] = ACTIONS(582),
    [anon_sym_AMP] = ACTIONS(568),
    [anon_sym_BANG] = ACTIONS(584),
    [anon_sym_TILDE] = ACTIONS(586),
    [anon_sym_PLUS] = ACTIONS(588),
    [anon_sym_DASH] = ACTIONS(588),
    [anon_sym_DASH_DASH] = ACTIONS(590),
    [anon_sym_PLUS_PLUS] = ACTIONS(590),
    [anon_sym_sizeof] = ACTIONS(592),
    [sym_number_literal] = ACTIONS(2272),
    [sym_char_literal] = ACTIONS(2272),
    [sym_string_literal] = ACTIONS(594),
    [sym_true] = ACTIONS(2276),
    [sym_false] = ACTIONS(2276),
    [sym_null] = ACTIONS(2276),
    [sym_identifier] = ACTIONS(598),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(600),
    [sym_auto] = ACTIONS(576),
    [anon_sym_typename] = ACTIONS(602),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(606),
    [anon_sym_delete] = ACTIONS(608),
    [sym_nullptr] = ACTIONS(2276),
  },
  [596] = {
    [sym__abstract_declarator] = STATE(1125),
    [sym_abstract_pointer_declarator] = STATE(1125),
    [sym_abstract_function_declarator] = STATE(1125),
    [sym_abstract_array_declarator] = STATE(1125),
    [sym_parameter_list] = STATE(598),
    [sym_abstract_reference_declarator] = STATE(1125),
    [anon_sym_LPAREN] = ACTIONS(1115),
    [anon_sym_COMMA] = ACTIONS(2278),
    [anon_sym_STAR] = ACTIONS(1119),
    [anon_sym_LBRACK] = ACTIONS(1121),
    [anon_sym_AMP] = ACTIONS(1123),
    [anon_sym_AMP_AMP] = ACTIONS(1125),
    [anon_sym_GT] = ACTIONS(2278),
    [sym_comment] = ACTIONS(49),
  },
  [597] = {
    [sym_parameter_list] = STATE(1127),
    [anon_sym_LPAREN] = ACTIONS(206),
    [anon_sym_COMMA] = ACTIONS(2280),
    [anon_sym_LBRACK] = ACTIONS(2282),
    [anon_sym_GT] = ACTIONS(2280),
    [sym_comment] = ACTIONS(49),
  },
  [598] = {
    [sym_type_qualifier] = STATE(1130),
    [sym_trailing_return_type] = STATE(1129),
    [aux_sym_abstract_function_declarator_repeat1] = STATE(1130),
    [anon_sym_LPAREN] = ACTIONS(2284),
    [anon_sym_COMMA] = ACTIONS(2284),
    [anon_sym_LBRACK] = ACTIONS(2284),
    [anon_sym_const] = ACTIONS(612),
    [anon_sym_restrict] = ACTIONS(614),
    [anon_sym_volatile] = ACTIONS(614),
    [anon_sym__Atomic] = ACTIONS(614),
    [anon_sym_mutable] = ACTIONS(614),
    [anon_sym_explicit] = ACTIONS(614),
    [anon_sym_constexpr] = ACTIONS(614),
    [anon_sym_GT] = ACTIONS(2284),
    [anon_sym_DASH_GT] = ACTIONS(2286),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(2288),
  },
  [599] = {
    [sym_type_qualifier] = STATE(279),
    [sym__type_specifier] = STATE(277),
    [sym_sized_type_specifier] = STATE(277),
    [sym_enum_specifier] = STATE(277),
    [sym_struct_specifier] = STATE(277),
    [sym_union_specifier] = STATE(277),
    [sym_type_descriptor] = STATE(1131),
    [sym_parenthesized_expression] = STATE(1131),
    [sym_macro_type_specifier] = STATE(277),
    [sym_class_specifier] = STATE(277),
    [sym_dependent_type] = STATE(277),
    [sym_template_type] = STATE(62),
    [sym_scoped_type_identifier] = STATE(34),
    [sym_scoped_namespace_identifier] = STATE(64),
    [aux_sym_type_definition_repeat1] = STATE(279),
    [aux_sym_sized_type_specifier_repeat1] = STATE(280),
    [anon_sym_LPAREN] = ACTIONS(422),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_restrict] = ACTIONS(93),
    [anon_sym_volatile] = ACTIONS(93),
    [anon_sym__Atomic] = ACTIONS(93),
    [anon_sym_mutable] = ACTIONS(93),
    [anon_sym_explicit] = ACTIONS(93),
    [anon_sym_constexpr] = ACTIONS(93),
    [anon_sym_unsigned] = ACTIONS(424),
    [anon_sym_long] = ACTIONS(424),
    [anon_sym_short] = ACTIONS(424),
    [sym_primitive_type] = ACTIONS(426),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(428),
    [anon_sym_union] = ACTIONS(430),
    [sym_identifier] = ACTIONS(434),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(436),
    [sym_auto] = ACTIONS(426),
    [anon_sym_typename] = ACTIONS(438),
    [anon_sym_COLON_COLON] = ACTIONS(111),
  },
  [600] = {
    [anon_sym_LPAREN] = ACTIONS(2290),
    [anon_sym_COMMA] = ACTIONS(2290),
    [anon_sym_RPAREN] = ACTIONS(2290),
    [anon_sym_SEMI] = ACTIONS(2290),
    [anon_sym_extern] = ACTIONS(2292),
    [anon_sym_LBRACE] = ACTIONS(2290),
    [anon_sym_STAR] = ACTIONS(2290),
    [anon_sym_LBRACK] = ACTIONS(2290),
    [anon_sym_EQ] = ACTIONS(2290),
    [anon_sym_static] = ACTIONS(2292),
    [anon_sym_register] = ACTIONS(2292),
    [anon_sym_inline] = ACTIONS(2292),
    [anon_sym_const] = ACTIONS(2292),
    [anon_sym_restrict] = ACTIONS(2292),
    [anon_sym_volatile] = ACTIONS(2292),
    [anon_sym__Atomic] = ACTIONS(2292),
    [anon_sym_mutable] = ACTIONS(2292),
    [anon_sym_explicit] = ACTIONS(2292),
    [anon_sym_constexpr] = ACTIONS(2292),
    [anon_sym_COLON] = ACTIONS(2292),
    [anon_sym_AMP] = ACTIONS(2292),
    [anon_sym_AMP_AMP] = ACTIONS(2290),
    [anon_sym_TILDE] = ACTIONS(2290),
    [anon_sym_GT] = ACTIONS(2290),
    [sym_identifier] = ACTIONS(2292),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(2290),
    [sym_operator_name] = ACTIONS(2290),
  },
  [601] = {
    [aux_sym_template_argument_list_repeat1] = STATE(1133),
    [anon_sym_COMMA] = ACTIONS(1127),
    [anon_sym_GT] = ACTIONS(2294),
    [sym_comment] = ACTIONS(49),
  },
  [602] = {
    [sym__abstract_declarator] = STATE(1134),
    [sym_abstract_pointer_declarator] = STATE(1134),
    [sym_abstract_function_declarator] = STATE(1134),
    [sym_abstract_array_declarator] = STATE(1134),
    [sym_parameter_list] = STATE(598),
    [sym_abstract_reference_declarator] = STATE(1134),
    [anon_sym_LPAREN] = ACTIONS(1115),
    [anon_sym_COMMA] = ACTIONS(2280),
    [anon_sym_STAR] = ACTIONS(1119),
    [anon_sym_LBRACK] = ACTIONS(1121),
    [anon_sym_AMP] = ACTIONS(1123),
    [anon_sym_AMP_AMP] = ACTIONS(1125),
    [anon_sym_GT] = ACTIONS(2280),
    [sym_comment] = ACTIONS(49),
  },
  [603] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(603),
    [anon_sym_LPAREN] = ACTIONS(816),
    [anon_sym_COMMA] = ACTIONS(816),
    [anon_sym_STAR] = ACTIONS(816),
    [anon_sym_LBRACK] = ACTIONS(816),
    [anon_sym_unsigned] = ACTIONS(2296),
    [anon_sym_long] = ACTIONS(2296),
    [anon_sym_short] = ACTIONS(2296),
    [sym_primitive_type] = ACTIONS(818),
    [anon_sym_AMP] = ACTIONS(818),
    [anon_sym_AMP_AMP] = ACTIONS(816),
    [anon_sym_GT] = ACTIONS(816),
    [sym_identifier] = ACTIONS(818),
    [sym_comment] = ACTIONS(49),
  },
  [604] = {
    [anon_sym_LPAREN] = ACTIONS(2299),
    [anon_sym_COMMA] = ACTIONS(2299),
    [anon_sym_RPAREN] = ACTIONS(2299),
    [anon_sym_SEMI] = ACTIONS(2299),
    [anon_sym_extern] = ACTIONS(2301),
    [anon_sym_LBRACE] = ACTIONS(2299),
    [anon_sym_STAR] = ACTIONS(2299),
    [anon_sym_LBRACK] = ACTIONS(2299),
    [anon_sym_static] = ACTIONS(2301),
    [anon_sym_register] = ACTIONS(2301),
    [anon_sym_inline] = ACTIONS(2301),
    [anon_sym_const] = ACTIONS(2301),
    [anon_sym_restrict] = ACTIONS(2301),
    [anon_sym_volatile] = ACTIONS(2301),
    [anon_sym__Atomic] = ACTIONS(2301),
    [anon_sym_mutable] = ACTIONS(2301),
    [anon_sym_explicit] = ACTIONS(2301),
    [anon_sym_constexpr] = ACTIONS(2301),
    [anon_sym_COLON] = ACTIONS(2301),
    [anon_sym_AMP] = ACTIONS(2301),
    [anon_sym_AMP_AMP] = ACTIONS(2299),
    [anon_sym_TILDE] = ACTIONS(2299),
    [anon_sym_GT] = ACTIONS(2299),
    [sym_identifier] = ACTIONS(2301),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(2299),
    [sym_operator_name] = ACTIONS(2299),
  },
  [605] = {
    [sym_template_argument_list] = STATE(263),
    [anon_sym_LPAREN] = ACTIONS(142),
    [anon_sym_COMMA] = ACTIONS(2303),
    [anon_sym_extern] = ACTIONS(144),
    [anon_sym_STAR] = ACTIONS(142),
    [anon_sym_LBRACK] = ACTIONS(142),
    [anon_sym_EQ] = ACTIONS(2305),
    [anon_sym_static] = ACTIONS(144),
    [anon_sym_register] = ACTIONS(144),
    [anon_sym_inline] = ACTIONS(144),
    [anon_sym_const] = ACTIONS(144),
    [anon_sym_restrict] = ACTIONS(144),
    [anon_sym_volatile] = ACTIONS(144),
    [anon_sym__Atomic] = ACTIONS(144),
    [anon_sym_mutable] = ACTIONS(144),
    [anon_sym_explicit] = ACTIONS(144),
    [anon_sym_constexpr] = ACTIONS(144),
    [anon_sym_AMP] = ACTIONS(144),
    [anon_sym_AMP_AMP] = ACTIONS(142),
    [anon_sym_TILDE] = ACTIONS(142),
    [anon_sym_LT] = ACTIONS(146),
    [anon_sym_GT] = ACTIONS(2303),
    [sym_identifier] = ACTIONS(144),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(402),
    [sym_operator_name] = ACTIONS(142),
  },
  [606] = {
    [sym__type_specifier] = STATE(93),
    [sym_sized_type_specifier] = STATE(93),
    [sym_enum_specifier] = STATE(93),
    [sym_struct_specifier] = STATE(93),
    [sym_union_specifier] = STATE(93),
    [sym_macro_type_specifier] = STATE(93),
    [sym_class_specifier] = STATE(93),
    [sym_dependent_type] = STATE(93),
    [sym_template_type] = STATE(94),
    [sym_scoped_type_identifier] = STATE(34),
    [sym_scoped_namespace_identifier] = STATE(81),
    [aux_sym_sized_type_specifier_repeat1] = STATE(293),
    [anon_sym_unsigned] = ACTIONS(463),
    [anon_sym_long] = ACTIONS(463),
    [anon_sym_short] = ACTIONS(463),
    [sym_primitive_type] = ACTIONS(150),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_union] = ACTIONS(39),
    [sym_identifier] = ACTIONS(152),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(51),
    [sym_auto] = ACTIONS(150),
    [anon_sym_typename] = ACTIONS(1160),
    [anon_sym_COLON_COLON] = ACTIONS(135),
  },
  [607] = {
    [sym__declaration_specifiers] = STATE(344),
    [sym__declarator] = STATE(45),
    [sym__abstract_declarator] = STATE(1119),
    [sym_pointer_declarator] = STATE(45),
    [sym_abstract_pointer_declarator] = STATE(1119),
    [sym_function_declarator] = STATE(45),
    [sym_abstract_function_declarator] = STATE(1119),
    [sym_array_declarator] = STATE(45),
    [sym_abstract_array_declarator] = STATE(1119),
    [sym_storage_class_specifier] = STATE(346),
    [sym_type_qualifier] = STATE(346),
    [sym__type_specifier] = STATE(345),
    [sym_sized_type_specifier] = STATE(345),
    [sym_enum_specifier] = STATE(345),
    [sym_struct_specifier] = STATE(345),
    [sym_union_specifier] = STATE(345),
    [sym_parameter_list] = STATE(1120),
    [sym_parameter_declaration] = STATE(341),
    [sym_macro_type_specifier] = STATE(345),
    [sym_class_specifier] = STATE(345),
    [sym_dependent_type] = STATE(345),
    [sym_reference_declarator] = STATE(45),
    [sym_abstract_reference_declarator] = STATE(1119),
    [sym_template_type] = STATE(32),
    [sym_template_function] = STATE(45),
    [sym_destructor_name] = STATE(45),
    [sym_scoped_identifier] = STATE(33),
    [sym_scoped_type_identifier] = STATE(34),
    [sym_scoped_namespace_identifier] = STATE(35),
    [aux_sym__declaration_specifiers_repeat1] = STATE(346),
    [aux_sym_sized_type_specifier_repeat1] = STATE(347),
    [anon_sym_LPAREN] = ACTIONS(1162),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(554),
    [anon_sym_RPAREN] = ACTIONS(556),
    [anon_sym_extern] = ACTIONS(154),
    [anon_sym_STAR] = ACTIONS(2307),
    [anon_sym_LBRACK] = ACTIONS(1121),
    [anon_sym_static] = ACTIONS(154),
    [anon_sym_register] = ACTIONS(154),
    [anon_sym_inline] = ACTIONS(154),
    [anon_sym_const] = ACTIONS(158),
    [anon_sym_restrict] = ACTIONS(158),
    [anon_sym_volatile] = ACTIONS(158),
    [anon_sym__Atomic] = ACTIONS(158),
    [anon_sym_mutable] = ACTIONS(158),
    [anon_sym_explicit] = ACTIONS(158),
    [anon_sym_constexpr] = ACTIONS(158),
    [anon_sym_unsigned] = ACTIONS(558),
    [anon_sym_long] = ACTIONS(558),
    [anon_sym_short] = ACTIONS(558),
    [sym_primitive_type] = ACTIONS(560),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_union] = ACTIONS(39),
    [anon_sym_AMP] = ACTIONS(2309),
    [anon_sym_AMP_AMP] = ACTIONS(2311),
    [anon_sym_TILDE] = ACTIONS(45),
    [sym_identifier] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(51),
    [sym_auto] = ACTIONS(560),
    [anon_sym_typename] = ACTIONS(562),
    [anon_sym_COLON_COLON] = ACTIONS(61),
    [sym_operator_name] = ACTIONS(79),
  },
  [608] = {
    [sym__declarator] = STATE(1138),
    [sym__abstract_declarator] = STATE(1121),
    [sym_pointer_declarator] = STATE(1138),
    [sym_abstract_pointer_declarator] = STATE(1121),
    [sym_function_declarator] = STATE(1138),
    [sym_abstract_function_declarator] = STATE(1121),
    [sym_array_declarator] = STATE(1138),
    [sym_abstract_array_declarator] = STATE(1121),
    [sym_parameter_list] = STATE(598),
    [sym_reference_declarator] = STATE(1138),
    [sym_abstract_reference_declarator] = STATE(1121),
    [sym_template_type] = STATE(615),
    [sym_template_function] = STATE(1138),
    [sym_destructor_name] = STATE(1138),
    [sym_scoped_identifier] = STATE(616),
    [sym_scoped_type_identifier] = STATE(47),
    [sym_scoped_namespace_identifier] = STATE(615),
    [anon_sym_LPAREN] = ACTIONS(1162),
    [anon_sym_COMMA] = ACTIONS(2270),
    [anon_sym_STAR] = ACTIONS(1166),
    [anon_sym_LBRACK] = ACTIONS(1121),
    [anon_sym_AMP] = ACTIONS(1168),
    [anon_sym_AMP_AMP] = ACTIONS(1170),
    [anon_sym_TILDE] = ACTIONS(45),
    [anon_sym_GT] = ACTIONS(2270),
    [sym_identifier] = ACTIONS(1172),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(1174),
    [sym_operator_name] = ACTIONS(2313),
  },
  [609] = {
    [sym__declarator] = STATE(1139),
    [sym__abstract_declarator] = STATE(1125),
    [sym_pointer_declarator] = STATE(1139),
    [sym_abstract_pointer_declarator] = STATE(1125),
    [sym_function_declarator] = STATE(1139),
    [sym_abstract_function_declarator] = STATE(1125),
    [sym_array_declarator] = STATE(1139),
    [sym_abstract_array_declarator] = STATE(1125),
    [sym_parameter_list] = STATE(598),
    [sym_reference_declarator] = STATE(1139),
    [sym_abstract_reference_declarator] = STATE(1125),
    [sym_template_type] = STATE(615),
    [sym_template_function] = STATE(1139),
    [sym_destructor_name] = STATE(1139),
    [sym_scoped_identifier] = STATE(616),
    [sym_scoped_type_identifier] = STATE(47),
    [sym_scoped_namespace_identifier] = STATE(615),
    [anon_sym_LPAREN] = ACTIONS(1162),
    [anon_sym_COMMA] = ACTIONS(2278),
    [anon_sym_STAR] = ACTIONS(1166),
    [anon_sym_LBRACK] = ACTIONS(1121),
    [anon_sym_AMP] = ACTIONS(1168),
    [anon_sym_AMP_AMP] = ACTIONS(1170),
    [anon_sym_TILDE] = ACTIONS(45),
    [anon_sym_GT] = ACTIONS(2278),
    [sym_identifier] = ACTIONS(1172),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(1174),
    [sym_operator_name] = ACTIONS(2315),
  },
  [610] = {
    [sym_template_argument_list] = STATE(156),
    [anon_sym_LPAREN] = ACTIONS(210),
    [anon_sym_COMMA] = ACTIONS(210),
    [anon_sym_LBRACE] = ACTIONS(210),
    [anon_sym_LBRACK] = ACTIONS(210),
    [anon_sym_EQ] = ACTIONS(210),
    [anon_sym_LT] = ACTIONS(146),
    [anon_sym_GT] = ACTIONS(210),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(2317),
  },
  [611] = {
    [sym_destructor_name] = STATE(1141),
    [anon_sym_TILDE] = ACTIONS(45),
    [sym_identifier] = ACTIONS(267),
    [sym_comment] = ACTIONS(49),
    [sym_operator_name] = ACTIONS(2319),
  },
  [612] = {
    [sym_parameter_list] = STATE(1145),
    [sym_argument_list] = STATE(333),
    [sym_initializer_list] = STATE(333),
    [anon_sym_LPAREN] = ACTIONS(2321),
    [anon_sym_COMMA] = ACTIONS(2323),
    [anon_sym_LBRACE] = ACTIONS(2325),
    [anon_sym_LBRACK] = ACTIONS(208),
    [anon_sym_EQ] = ACTIONS(2327),
    [anon_sym_GT] = ACTIONS(2323),
    [sym_comment] = ACTIONS(49),
  },
  [613] = {
    [sym_parameter_list] = STATE(1127),
    [anon_sym_LPAREN] = ACTIONS(206),
    [anon_sym_COMMA] = ACTIONS(2323),
    [anon_sym_LBRACK] = ACTIONS(2282),
    [anon_sym_GT] = ACTIONS(2323),
    [sym_comment] = ACTIONS(49),
  },
  [614] = {
    [anon_sym_COMMA] = ACTIONS(2323),
    [anon_sym_RPAREN] = ACTIONS(2323),
    [anon_sym_GT] = ACTIONS(2323),
    [sym_comment] = ACTIONS(49),
  },
  [615] = {
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(2329),
  },
  [616] = {
    [sym_template_argument_list] = STATE(1147),
    [anon_sym_LPAREN] = ACTIONS(210),
    [anon_sym_COMMA] = ACTIONS(210),
    [anon_sym_LBRACE] = ACTIONS(210),
    [anon_sym_LBRACK] = ACTIONS(210),
    [anon_sym_EQ] = ACTIONS(210),
    [anon_sym_LT] = ACTIONS(146),
    [anon_sym_GT] = ACTIONS(210),
    [sym_comment] = ACTIONS(49),
  },
  [617] = {
    [sym_storage_class_specifier] = STATE(1148),
    [sym_type_qualifier] = STATE(1148),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1148),
    [anon_sym_LPAREN] = ACTIONS(696),
    [anon_sym_COMMA] = ACTIONS(696),
    [anon_sym_extern] = ACTIONS(218),
    [anon_sym_STAR] = ACTIONS(696),
    [anon_sym_LBRACK] = ACTIONS(696),
    [anon_sym_static] = ACTIONS(218),
    [anon_sym_register] = ACTIONS(218),
    [anon_sym_inline] = ACTIONS(218),
    [anon_sym_const] = ACTIONS(220),
    [anon_sym_restrict] = ACTIONS(220),
    [anon_sym_volatile] = ACTIONS(220),
    [anon_sym__Atomic] = ACTIONS(220),
    [anon_sym_mutable] = ACTIONS(220),
    [anon_sym_explicit] = ACTIONS(220),
    [anon_sym_constexpr] = ACTIONS(220),
    [anon_sym_AMP] = ACTIONS(698),
    [anon_sym_AMP_AMP] = ACTIONS(696),
    [anon_sym_TILDE] = ACTIONS(696),
    [anon_sym_GT] = ACTIONS(696),
    [sym_identifier] = ACTIONS(698),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(696),
    [sym_operator_name] = ACTIONS(696),
  },
  [618] = {
    [sym__declaration_specifiers] = STATE(289),
    [sym_storage_class_specifier] = STATE(292),
    [sym_type_qualifier] = STATE(292),
    [sym__type_specifier] = STATE(290),
    [sym_sized_type_specifier] = STATE(290),
    [sym_enum_specifier] = STATE(290),
    [sym_struct_specifier] = STATE(290),
    [sym_union_specifier] = STATE(290),
    [sym_parameter_declaration] = STATE(1149),
    [sym_macro_type_specifier] = STATE(290),
    [sym_class_specifier] = STATE(290),
    [sym_dependent_type] = STATE(290),
    [sym_type_parameter_declaration] = STATE(1149),
    [sym_optional_type_parameter_declaration] = STATE(1149),
    [sym_template_type] = STATE(94),
    [sym_scoped_type_identifier] = STATE(34),
    [sym_scoped_namespace_identifier] = STATE(81),
    [aux_sym__declaration_specifiers_repeat1] = STATE(292),
    [aux_sym_sized_type_specifier_repeat1] = STATE(293),
    [anon_sym_extern] = ACTIONS(154),
    [anon_sym_static] = ACTIONS(154),
    [anon_sym_register] = ACTIONS(154),
    [anon_sym_inline] = ACTIONS(154),
    [anon_sym_const] = ACTIONS(158),
    [anon_sym_restrict] = ACTIONS(158),
    [anon_sym_volatile] = ACTIONS(158),
    [anon_sym__Atomic] = ACTIONS(158),
    [anon_sym_mutable] = ACTIONS(158),
    [anon_sym_explicit] = ACTIONS(158),
    [anon_sym_constexpr] = ACTIONS(158),
    [anon_sym_unsigned] = ACTIONS(463),
    [anon_sym_long] = ACTIONS(463),
    [anon_sym_short] = ACTIONS(463),
    [sym_primitive_type] = ACTIONS(465),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_union] = ACTIONS(39),
    [sym_identifier] = ACTIONS(152),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(51),
    [sym_auto] = ACTIONS(465),
    [anon_sym_typename] = ACTIONS(469),
    [anon_sym_COLON_COLON] = ACTIONS(135),
  },
  [619] = {
    [anon_sym_extern] = ACTIONS(2331),
    [anon_sym_static] = ACTIONS(2331),
    [anon_sym_register] = ACTIONS(2331),
    [anon_sym_inline] = ACTIONS(2331),
    [anon_sym_const] = ACTIONS(2331),
    [anon_sym_restrict] = ACTIONS(2331),
    [anon_sym_volatile] = ACTIONS(2331),
    [anon_sym__Atomic] = ACTIONS(2331),
    [anon_sym_mutable] = ACTIONS(2331),
    [anon_sym_explicit] = ACTIONS(2331),
    [anon_sym_constexpr] = ACTIONS(2331),
    [anon_sym_unsigned] = ACTIONS(2331),
    [anon_sym_long] = ACTIONS(2331),
    [anon_sym_short] = ACTIONS(2331),
    [sym_primitive_type] = ACTIONS(2331),
    [anon_sym_enum] = ACTIONS(2331),
    [anon_sym_struct] = ACTIONS(2331),
    [anon_sym_union] = ACTIONS(2331),
    [sym_identifier] = ACTIONS(2331),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(2331),
    [sym_auto] = ACTIONS(2331),
    [anon_sym_typename] = ACTIONS(2331),
    [anon_sym_COLON_COLON] = ACTIONS(2333),
  },
  [620] = {
    [aux_sym_template_parameter_list_repeat1] = STATE(1151),
    [anon_sym_COMMA] = ACTIONS(1178),
    [anon_sym_GT] = ACTIONS(2335),
    [sym_comment] = ACTIONS(49),
  },
  [621] = {
    [sym_storage_class_specifier] = STATE(1152),
    [sym_type_qualifier] = STATE(1152),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1152),
    [anon_sym_LPAREN] = ACTIONS(696),
    [anon_sym_COMMA] = ACTIONS(696),
    [anon_sym_extern] = ACTIONS(218),
    [anon_sym_STAR] = ACTIONS(696),
    [anon_sym_LBRACK] = ACTIONS(696),
    [anon_sym_static] = ACTIONS(218),
    [anon_sym_register] = ACTIONS(218),
    [anon_sym_inline] = ACTIONS(218),
    [anon_sym_const] = ACTIONS(220),
    [anon_sym_restrict] = ACTIONS(220),
    [anon_sym_volatile] = ACTIONS(220),
    [anon_sym__Atomic] = ACTIONS(220),
    [anon_sym_mutable] = ACTIONS(220),
    [anon_sym_explicit] = ACTIONS(220),
    [anon_sym_constexpr] = ACTIONS(220),
    [anon_sym_AMP] = ACTIONS(698),
    [anon_sym_AMP_AMP] = ACTIONS(696),
    [anon_sym_TILDE] = ACTIONS(696),
    [anon_sym_GT] = ACTIONS(696),
    [sym_identifier] = ACTIONS(698),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(696),
    [sym_operator_name] = ACTIONS(696),
  },
  [622] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(622),
    [anon_sym_LPAREN] = ACTIONS(816),
    [anon_sym_COMMA] = ACTIONS(816),
    [anon_sym_extern] = ACTIONS(818),
    [anon_sym_STAR] = ACTIONS(816),
    [anon_sym_LBRACK] = ACTIONS(816),
    [anon_sym_static] = ACTIONS(818),
    [anon_sym_register] = ACTIONS(818),
    [anon_sym_inline] = ACTIONS(818),
    [anon_sym_const] = ACTIONS(818),
    [anon_sym_restrict] = ACTIONS(818),
    [anon_sym_volatile] = ACTIONS(818),
    [anon_sym__Atomic] = ACTIONS(818),
    [anon_sym_mutable] = ACTIONS(818),
    [anon_sym_explicit] = ACTIONS(818),
    [anon_sym_constexpr] = ACTIONS(818),
    [anon_sym_unsigned] = ACTIONS(2337),
    [anon_sym_long] = ACTIONS(2337),
    [anon_sym_short] = ACTIONS(2337),
    [sym_primitive_type] = ACTIONS(818),
    [anon_sym_AMP] = ACTIONS(818),
    [anon_sym_AMP_AMP] = ACTIONS(816),
    [anon_sym_TILDE] = ACTIONS(816),
    [anon_sym_GT] = ACTIONS(816),
    [sym_identifier] = ACTIONS(818),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(816),
    [sym_operator_name] = ACTIONS(816),
  },
  [623] = {
    [anon_sym_LPAREN] = ACTIONS(1137),
    [anon_sym_SEMI] = ACTIONS(1146),
    [anon_sym_extern] = ACTIONS(1142),
    [anon_sym_STAR] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1146),
    [anon_sym_static] = ACTIONS(1142),
    [anon_sym_register] = ACTIONS(1142),
    [anon_sym_inline] = ACTIONS(1142),
    [anon_sym_const] = ACTIONS(1142),
    [anon_sym_restrict] = ACTIONS(1142),
    [anon_sym_volatile] = ACTIONS(1142),
    [anon_sym__Atomic] = ACTIONS(1142),
    [anon_sym_mutable] = ACTIONS(1142),
    [anon_sym_explicit] = ACTIONS(1142),
    [anon_sym_constexpr] = ACTIONS(1142),
    [anon_sym_AMP] = ACTIONS(1142),
    [anon_sym_AMP_AMP] = ACTIONS(1140),
    [anon_sym_TILDE] = ACTIONS(1140),
    [anon_sym_LT] = ACTIONS(1137),
    [sym_identifier] = ACTIONS(1142),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(1144),
    [sym_operator_name] = ACTIONS(1140),
  },
  [624] = {
    [ts_builtin_sym_end] = ACTIONS(2340),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(2342),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(2342),
    [anon_sym_LPAREN] = ACTIONS(2340),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(2342),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(2342),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(2342),
    [sym_preproc_directive] = ACTIONS(2342),
    [anon_sym_typedef] = ACTIONS(2342),
    [anon_sym_extern] = ACTIONS(2342),
    [anon_sym_RBRACE] = ACTIONS(2340),
    [anon_sym_STAR] = ACTIONS(2340),
    [anon_sym_static] = ACTIONS(2342),
    [anon_sym_register] = ACTIONS(2342),
    [anon_sym_inline] = ACTIONS(2342),
    [anon_sym_const] = ACTIONS(2342),
    [anon_sym_restrict] = ACTIONS(2342),
    [anon_sym_volatile] = ACTIONS(2342),
    [anon_sym__Atomic] = ACTIONS(2342),
    [anon_sym_mutable] = ACTIONS(2342),
    [anon_sym_explicit] = ACTIONS(2342),
    [anon_sym_constexpr] = ACTIONS(2342),
    [anon_sym_unsigned] = ACTIONS(2342),
    [anon_sym_long] = ACTIONS(2342),
    [anon_sym_short] = ACTIONS(2342),
    [sym_primitive_type] = ACTIONS(2342),
    [anon_sym_enum] = ACTIONS(2342),
    [anon_sym_struct] = ACTIONS(2342),
    [anon_sym_union] = ACTIONS(2342),
    [anon_sym_AMP] = ACTIONS(2342),
    [anon_sym_AMP_AMP] = ACTIONS(2340),
    [anon_sym_TILDE] = ACTIONS(2340),
    [sym_identifier] = ACTIONS(2342),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(2342),
    [sym_auto] = ACTIONS(2342),
    [anon_sym_typename] = ACTIONS(2342),
    [anon_sym_template] = ACTIONS(2342),
    [anon_sym_namespace] = ACTIONS(2342),
    [anon_sym_using] = ACTIONS(2342),
    [anon_sym_COLON_COLON] = ACTIONS(2340),
    [sym_operator_name] = ACTIONS(2340),
  },
  [625] = {
    [sym__type_specifier] = STATE(1154),
    [sym_sized_type_specifier] = STATE(1154),
    [sym_enum_specifier] = STATE(1154),
    [sym_struct_specifier] = STATE(1154),
    [sym_union_specifier] = STATE(1154),
    [sym_macro_type_specifier] = STATE(1154),
    [sym_class_specifier] = STATE(1154),
    [sym_dependent_type] = STATE(1154),
    [sym_template_type] = STATE(825),
    [sym_scoped_type_identifier] = STATE(826),
    [sym_scoped_namespace_identifier] = STATE(827),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1155),
    [anon_sym_unsigned] = ACTIONS(2344),
    [anon_sym_long] = ACTIONS(2344),
    [anon_sym_short] = ACTIONS(2344),
    [sym_primitive_type] = ACTIONS(2346),
    [anon_sym_enum] = ACTIONS(1833),
    [anon_sym_struct] = ACTIONS(1835),
    [anon_sym_union] = ACTIONS(1837),
    [sym_identifier] = ACTIONS(1588),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(1839),
    [sym_auto] = ACTIONS(2346),
    [anon_sym_typename] = ACTIONS(2348),
    [anon_sym_COLON_COLON] = ACTIONS(1594),
  },
  [626] = {
    [sym_type_qualifier] = STATE(1156),
    [sym_trailing_return_type] = STATE(1156),
    [aux_sym_function_declarator_repeat1] = STATE(1156),
    [anon_sym_LPAREN] = ACTIONS(1596),
    [anon_sym_SEMI] = ACTIONS(1596),
    [anon_sym_LBRACK] = ACTIONS(1596),
    [anon_sym_const] = ACTIONS(612),
    [anon_sym_restrict] = ACTIONS(614),
    [anon_sym_volatile] = ACTIONS(614),
    [anon_sym__Atomic] = ACTIONS(614),
    [anon_sym_mutable] = ACTIONS(614),
    [anon_sym_explicit] = ACTIONS(614),
    [anon_sym_constexpr] = ACTIONS(614),
    [anon_sym_DASH_GT] = ACTIONS(1194),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(2350),
  },
  [627] = {
    [sym_storage_class_specifier] = STATE(627),
    [sym_type_qualifier] = STATE(627),
    [aux_sym__declaration_specifiers_repeat1] = STATE(627),
    [anon_sym_LPAREN] = ACTIONS(798),
    [anon_sym_extern] = ACTIONS(1792),
    [anon_sym_STAR] = ACTIONS(798),
    [anon_sym_static] = ACTIONS(1792),
    [anon_sym_register] = ACTIONS(1792),
    [anon_sym_inline] = ACTIONS(1792),
    [anon_sym_const] = ACTIONS(1795),
    [anon_sym_restrict] = ACTIONS(1795),
    [anon_sym_volatile] = ACTIONS(1795),
    [anon_sym__Atomic] = ACTIONS(1795),
    [anon_sym_mutable] = ACTIONS(1795),
    [anon_sym_explicit] = ACTIONS(1795),
    [anon_sym_constexpr] = ACTIONS(1795),
    [anon_sym_AMP] = ACTIONS(806),
    [anon_sym_AMP_AMP] = ACTIONS(798),
    [anon_sym_TILDE] = ACTIONS(798),
    [sym_identifier] = ACTIONS(806),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(798),
    [sym_operator_name] = ACTIONS(798),
  },
  [628] = {
    [sym_storage_class_specifier] = STATE(1157),
    [sym_type_qualifier] = STATE(1157),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1157),
    [anon_sym_LPAREN] = ACTIONS(696),
    [anon_sym_SEMI] = ACTIONS(696),
    [anon_sym_extern] = ACTIONS(218),
    [anon_sym_STAR] = ACTIONS(696),
    [anon_sym_static] = ACTIONS(218),
    [anon_sym_register] = ACTIONS(218),
    [anon_sym_inline] = ACTIONS(218),
    [anon_sym_const] = ACTIONS(220),
    [anon_sym_restrict] = ACTIONS(220),
    [anon_sym_volatile] = ACTIONS(220),
    [anon_sym__Atomic] = ACTIONS(220),
    [anon_sym_mutable] = ACTIONS(220),
    [anon_sym_explicit] = ACTIONS(220),
    [anon_sym_constexpr] = ACTIONS(220),
    [anon_sym_AMP] = ACTIONS(698),
    [anon_sym_AMP_AMP] = ACTIONS(696),
    [anon_sym_TILDE] = ACTIONS(696),
    [sym_identifier] = ACTIONS(698),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(696),
    [sym_operator_name] = ACTIONS(696),
  },
  [629] = {
    [sym_storage_class_specifier] = STATE(1158),
    [sym_type_qualifier] = STATE(1158),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1158),
    [anon_sym_LPAREN] = ACTIONS(696),
    [anon_sym_SEMI] = ACTIONS(696),
    [anon_sym_extern] = ACTIONS(218),
    [anon_sym_STAR] = ACTIONS(696),
    [anon_sym_static] = ACTIONS(218),
    [anon_sym_register] = ACTIONS(218),
    [anon_sym_inline] = ACTIONS(218),
    [anon_sym_const] = ACTIONS(220),
    [anon_sym_restrict] = ACTIONS(220),
    [anon_sym_volatile] = ACTIONS(220),
    [anon_sym__Atomic] = ACTIONS(220),
    [anon_sym_mutable] = ACTIONS(220),
    [anon_sym_explicit] = ACTIONS(220),
    [anon_sym_constexpr] = ACTIONS(220),
    [anon_sym_AMP] = ACTIONS(698),
    [anon_sym_AMP_AMP] = ACTIONS(696),
    [anon_sym_TILDE] = ACTIONS(696),
    [sym_identifier] = ACTIONS(698),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(696),
    [sym_operator_name] = ACTIONS(696),
  },
  [630] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(630),
    [anon_sym_LPAREN] = ACTIONS(816),
    [anon_sym_SEMI] = ACTIONS(816),
    [anon_sym_extern] = ACTIONS(818),
    [anon_sym_STAR] = ACTIONS(816),
    [anon_sym_static] = ACTIONS(818),
    [anon_sym_register] = ACTIONS(818),
    [anon_sym_inline] = ACTIONS(818),
    [anon_sym_const] = ACTIONS(818),
    [anon_sym_restrict] = ACTIONS(818),
    [anon_sym_volatile] = ACTIONS(818),
    [anon_sym__Atomic] = ACTIONS(818),
    [anon_sym_mutable] = ACTIONS(818),
    [anon_sym_explicit] = ACTIONS(818),
    [anon_sym_constexpr] = ACTIONS(818),
    [anon_sym_unsigned] = ACTIONS(2352),
    [anon_sym_long] = ACTIONS(2352),
    [anon_sym_short] = ACTIONS(2352),
    [sym_primitive_type] = ACTIONS(818),
    [anon_sym_AMP] = ACTIONS(818),
    [anon_sym_AMP_AMP] = ACTIONS(816),
    [anon_sym_TILDE] = ACTIONS(816),
    [sym_identifier] = ACTIONS(818),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(816),
    [sym_operator_name] = ACTIONS(816),
  },
  [631] = {
    [anon_sym_LPAREN] = ACTIONS(1798),
    [anon_sym_SEMI] = ACTIONS(1807),
    [anon_sym_extern] = ACTIONS(1803),
    [anon_sym_STAR] = ACTIONS(1801),
    [anon_sym_LBRACK] = ACTIONS(1807),
    [anon_sym_static] = ACTIONS(1803),
    [anon_sym_register] = ACTIONS(1803),
    [anon_sym_inline] = ACTIONS(1803),
    [anon_sym_const] = ACTIONS(1803),
    [anon_sym_restrict] = ACTIONS(1803),
    [anon_sym_volatile] = ACTIONS(1803),
    [anon_sym__Atomic] = ACTIONS(1803),
    [anon_sym_mutable] = ACTIONS(1803),
    [anon_sym_explicit] = ACTIONS(1803),
    [anon_sym_constexpr] = ACTIONS(1803),
    [anon_sym_AMP] = ACTIONS(1803),
    [anon_sym_AMP_AMP] = ACTIONS(1801),
    [anon_sym_TILDE] = ACTIONS(1801),
    [anon_sym_LT] = ACTIONS(1798),
    [sym_identifier] = ACTIONS(1803),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(1805),
    [sym_operator_name] = ACTIONS(1801),
  },
  [632] = {
    [sym_storage_class_specifier] = STATE(627),
    [sym_type_qualifier] = STATE(627),
    [aux_sym__declaration_specifiers_repeat1] = STATE(627),
    [anon_sym_LPAREN] = ACTIONS(1811),
    [anon_sym_extern] = ACTIONS(218),
    [anon_sym_STAR] = ACTIONS(1811),
    [anon_sym_static] = ACTIONS(218),
    [anon_sym_register] = ACTIONS(218),
    [anon_sym_inline] = ACTIONS(218),
    [anon_sym_const] = ACTIONS(220),
    [anon_sym_restrict] = ACTIONS(220),
    [anon_sym_volatile] = ACTIONS(220),
    [anon_sym__Atomic] = ACTIONS(220),
    [anon_sym_mutable] = ACTIONS(220),
    [anon_sym_explicit] = ACTIONS(220),
    [anon_sym_constexpr] = ACTIONS(220),
    [anon_sym_AMP] = ACTIONS(1813),
    [anon_sym_AMP_AMP] = ACTIONS(1811),
    [anon_sym_TILDE] = ACTIONS(1811),
    [sym_identifier] = ACTIONS(1813),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(1811),
    [sym_operator_name] = ACTIONS(1811),
  },
  [633] = {
    [ts_builtin_sym_end] = ACTIONS(2355),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(2357),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(2357),
    [anon_sym_LPAREN] = ACTIONS(2355),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(2357),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(2357),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(2357),
    [sym_preproc_directive] = ACTIONS(2357),
    [anon_sym_typedef] = ACTIONS(2357),
    [anon_sym_extern] = ACTIONS(2357),
    [anon_sym_RBRACE] = ACTIONS(2355),
    [anon_sym_STAR] = ACTIONS(2355),
    [anon_sym_static] = ACTIONS(2357),
    [anon_sym_register] = ACTIONS(2357),
    [anon_sym_inline] = ACTIONS(2357),
    [anon_sym_const] = ACTIONS(2357),
    [anon_sym_restrict] = ACTIONS(2357),
    [anon_sym_volatile] = ACTIONS(2357),
    [anon_sym__Atomic] = ACTIONS(2357),
    [anon_sym_mutable] = ACTIONS(2357),
    [anon_sym_explicit] = ACTIONS(2357),
    [anon_sym_constexpr] = ACTIONS(2357),
    [anon_sym_unsigned] = ACTIONS(2357),
    [anon_sym_long] = ACTIONS(2357),
    [anon_sym_short] = ACTIONS(2357),
    [sym_primitive_type] = ACTIONS(2357),
    [anon_sym_enum] = ACTIONS(2357),
    [anon_sym_struct] = ACTIONS(2357),
    [anon_sym_union] = ACTIONS(2357),
    [anon_sym_AMP] = ACTIONS(2357),
    [anon_sym_AMP_AMP] = ACTIONS(2355),
    [anon_sym_TILDE] = ACTIONS(2355),
    [sym_identifier] = ACTIONS(2357),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(2357),
    [sym_auto] = ACTIONS(2357),
    [anon_sym_typename] = ACTIONS(2357),
    [anon_sym_template] = ACTIONS(2357),
    [anon_sym_namespace] = ACTIONS(2357),
    [anon_sym_using] = ACTIONS(2357),
    [anon_sym_COLON_COLON] = ACTIONS(2355),
    [sym_operator_name] = ACTIONS(2355),
  },
  [634] = {
    [sym_preproc_include] = STATE(634),
    [sym_preproc_def] = STATE(634),
    [sym_preproc_function_def] = STATE(634),
    [sym_preproc_call] = STATE(634),
    [sym_preproc_if] = STATE(634),
    [sym_preproc_ifdef] = STATE(634),
    [sym_function_definition] = STATE(634),
    [sym_declaration] = STATE(634),
    [sym_type_definition] = STATE(634),
    [sym__declaration_specifiers] = STATE(27),
    [sym_linkage_specification] = STATE(634),
    [sym__declarator] = STATE(28),
    [sym_pointer_declarator] = STATE(28),
    [sym_function_declarator] = STATE(29),
    [sym_array_declarator] = STATE(28),
    [sym_storage_class_specifier] = STATE(37),
    [sym_type_qualifier] = STATE(37),
    [sym__type_specifier] = STATE(30),
    [sym_sized_type_specifier] = STATE(30),
    [sym_enum_specifier] = STATE(30),
    [sym_struct_specifier] = STATE(30),
    [sym_union_specifier] = STATE(30),
    [sym__empty_declaration] = STATE(634),
    [sym_macro_type_specifier] = STATE(30),
    [sym_class_specifier] = STATE(30),
    [sym_dependent_type] = STATE(30),
    [sym_structured_binding_declaration] = STATE(634),
    [sym_template_declaration] = STATE(634),
    [sym_template_instantiation] = STATE(634),
    [sym_constructor_or_destructor_definition] = STATE(31),
    [sym_reference_declarator] = STATE(28),
    [sym_template_type] = STATE(32),
    [sym_template_function] = STATE(28),
    [sym_namespace_definition] = STATE(634),
    [sym_using_declaration] = STATE(634),
    [sym_alias_declaration] = STATE(634),
    [sym_destructor_name] = STATE(28),
    [sym_scoped_identifier] = STATE(33),
    [sym_scoped_type_identifier] = STATE(34),
    [sym_scoped_namespace_identifier] = STATE(35),
    [aux_sym_translation_unit_repeat1] = STATE(634),
    [aux_sym__declaration_specifiers_repeat1] = STATE(37),
    [aux_sym_sized_type_specifier_repeat1] = STATE(38),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(714),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(717),
    [anon_sym_LPAREN] = ACTIONS(720),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(723),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(726),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(729),
    [sym_preproc_directive] = ACTIONS(732),
    [anon_sym_typedef] = ACTIONS(735),
    [anon_sym_extern] = ACTIONS(738),
    [anon_sym_RBRACE] = ACTIONS(712),
    [anon_sym_STAR] = ACTIONS(741),
    [anon_sym_static] = ACTIONS(744),
    [anon_sym_register] = ACTIONS(744),
    [anon_sym_inline] = ACTIONS(744),
    [anon_sym_const] = ACTIONS(747),
    [anon_sym_restrict] = ACTIONS(747),
    [anon_sym_volatile] = ACTIONS(747),
    [anon_sym__Atomic] = ACTIONS(747),
    [anon_sym_mutable] = ACTIONS(747),
    [anon_sym_explicit] = ACTIONS(747),
    [anon_sym_constexpr] = ACTIONS(747),
    [anon_sym_unsigned] = ACTIONS(750),
    [anon_sym_long] = ACTIONS(750),
    [anon_sym_short] = ACTIONS(750),
    [sym_primitive_type] = ACTIONS(753),
    [anon_sym_enum] = ACTIONS(756),
    [anon_sym_struct] = ACTIONS(759),
    [anon_sym_union] = ACTIONS(762),
    [anon_sym_AMP] = ACTIONS(765),
    [anon_sym_AMP_AMP] = ACTIONS(768),
    [anon_sym_TILDE] = ACTIONS(771),
    [sym_identifier] = ACTIONS(774),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(777),
    [sym_auto] = ACTIONS(753),
    [anon_sym_typename] = ACTIONS(780),
    [anon_sym_template] = ACTIONS(783),
    [anon_sym_namespace] = ACTIONS(786),
    [anon_sym_using] = ACTIONS(789),
    [anon_sym_COLON_COLON] = ACTIONS(792),
    [sym_operator_name] = ACTIONS(795),
  },
  [635] = {
    [sym__type_specifier] = STATE(93),
    [sym_sized_type_specifier] = STATE(93),
    [sym_enum_specifier] = STATE(93),
    [sym_struct_specifier] = STATE(93),
    [sym_union_specifier] = STATE(93),
    [sym_macro_type_specifier] = STATE(93),
    [sym_class_specifier] = STATE(93),
    [sym_dependent_type] = STATE(93),
    [sym_template_type] = STATE(62),
    [sym_scoped_type_identifier] = STATE(34),
    [sym_scoped_namespace_identifier] = STATE(64),
    [aux_sym_sized_type_specifier_repeat1] = STATE(639),
    [anon_sym_unsigned] = ACTIONS(1231),
    [anon_sym_long] = ACTIONS(1231),
    [anon_sym_short] = ACTIONS(1231),
    [sym_primitive_type] = ACTIONS(150),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(428),
    [anon_sym_union] = ACTIONS(430),
    [sym_identifier] = ACTIONS(434),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(436),
    [sym_auto] = ACTIONS(150),
    [anon_sym_typename] = ACTIONS(1235),
    [anon_sym_COLON_COLON] = ACTIONS(111),
  },
  [636] = {
    [sym__abstract_declarator] = STATE(1161),
    [sym_abstract_pointer_declarator] = STATE(1161),
    [sym_abstract_function_declarator] = STATE(1161),
    [sym_abstract_array_declarator] = STATE(1161),
    [sym_parameter_list] = STATE(1162),
    [sym_abstract_reference_declarator] = STATE(1161),
    [anon_sym_LPAREN] = ACTIONS(1115),
    [anon_sym_SEMI] = ACTIONS(1117),
    [anon_sym_STAR] = ACTIONS(2359),
    [anon_sym_LBRACK] = ACTIONS(1121),
    [anon_sym_AMP] = ACTIONS(2361),
    [anon_sym_AMP_AMP] = ACTIONS(2363),
    [sym_comment] = ACTIONS(49),
  },
  [637] = {
    [anon_sym_SEMI] = ACTIONS(2365),
    [sym_comment] = ACTIONS(49),
  },
  [638] = {
    [sym_type_qualifier] = STATE(219),
    [sym__type_specifier] = STATE(1164),
    [sym_sized_type_specifier] = STATE(1164),
    [sym_enum_specifier] = STATE(1164),
    [sym_struct_specifier] = STATE(1164),
    [sym_union_specifier] = STATE(1164),
    [sym_macro_type_specifier] = STATE(1164),
    [sym_class_specifier] = STATE(1164),
    [sym_dependent_type] = STATE(1164),
    [sym_template_type] = STATE(62),
    [sym_scoped_type_identifier] = STATE(34),
    [sym_scoped_namespace_identifier] = STATE(64),
    [aux_sym_type_definition_repeat1] = STATE(219),
    [aux_sym_sized_type_specifier_repeat1] = STATE(639),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_restrict] = ACTIONS(93),
    [anon_sym_volatile] = ACTIONS(93),
    [anon_sym__Atomic] = ACTIONS(93),
    [anon_sym_mutable] = ACTIONS(93),
    [anon_sym_explicit] = ACTIONS(93),
    [anon_sym_constexpr] = ACTIONS(93),
    [anon_sym_unsigned] = ACTIONS(1231),
    [anon_sym_long] = ACTIONS(1231),
    [anon_sym_short] = ACTIONS(1231),
    [sym_primitive_type] = ACTIONS(2367),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(428),
    [anon_sym_union] = ACTIONS(430),
    [sym_identifier] = ACTIONS(434),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(436),
    [sym_auto] = ACTIONS(2367),
    [anon_sym_typename] = ACTIONS(1235),
    [anon_sym_COLON_COLON] = ACTIONS(111),
  },
  [639] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(1165),
    [anon_sym_LPAREN] = ACTIONS(238),
    [anon_sym_SEMI] = ACTIONS(238),
    [anon_sym_STAR] = ACTIONS(238),
    [anon_sym_LBRACK] = ACTIONS(238),
    [anon_sym_unsigned] = ACTIONS(2369),
    [anon_sym_long] = ACTIONS(2369),
    [anon_sym_short] = ACTIONS(2369),
    [sym_primitive_type] = ACTIONS(244),
    [anon_sym_AMP] = ACTIONS(240),
    [anon_sym_AMP_AMP] = ACTIONS(238),
    [sym_identifier] = ACTIONS(1135),
    [sym_comment] = ACTIONS(49),
  },
  [640] = {
    [anon_sym_SEMI] = ACTIONS(1146),
    [anon_sym_LT] = ACTIONS(1140),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(1144),
  },
  [641] = {
    [ts_builtin_sym_end] = ACTIONS(2371),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(2373),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(2373),
    [anon_sym_LPAREN] = ACTIONS(2371),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(2373),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(2373),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(2373),
    [sym_preproc_directive] = ACTIONS(2373),
    [anon_sym_typedef] = ACTIONS(2373),
    [anon_sym_extern] = ACTIONS(2373),
    [anon_sym_RBRACE] = ACTIONS(2371),
    [anon_sym_STAR] = ACTIONS(2371),
    [anon_sym_static] = ACTIONS(2373),
    [anon_sym_register] = ACTIONS(2373),
    [anon_sym_inline] = ACTIONS(2373),
    [anon_sym_const] = ACTIONS(2373),
    [anon_sym_restrict] = ACTIONS(2373),
    [anon_sym_volatile] = ACTIONS(2373),
    [anon_sym__Atomic] = ACTIONS(2373),
    [anon_sym_mutable] = ACTIONS(2373),
    [anon_sym_explicit] = ACTIONS(2373),
    [anon_sym_constexpr] = ACTIONS(2373),
    [anon_sym_unsigned] = ACTIONS(2373),
    [anon_sym_long] = ACTIONS(2373),
    [anon_sym_short] = ACTIONS(2373),
    [sym_primitive_type] = ACTIONS(2373),
    [anon_sym_enum] = ACTIONS(2373),
    [anon_sym_struct] = ACTIONS(2373),
    [anon_sym_union] = ACTIONS(2373),
    [anon_sym_AMP] = ACTIONS(2373),
    [anon_sym_AMP_AMP] = ACTIONS(2371),
    [anon_sym_TILDE] = ACTIONS(2371),
    [sym_identifier] = ACTIONS(2373),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(2373),
    [sym_auto] = ACTIONS(2373),
    [anon_sym_typename] = ACTIONS(2373),
    [anon_sym_template] = ACTIONS(2373),
    [anon_sym_namespace] = ACTIONS(2373),
    [anon_sym_using] = ACTIONS(2373),
    [anon_sym_COLON_COLON] = ACTIONS(2371),
    [sym_operator_name] = ACTIONS(2371),
  },
  [642] = {
    [anon_sym_SEMI] = ACTIONS(1807),
    [anon_sym_LT] = ACTIONS(1801),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(1805),
  },
  [643] = {
    [sym_identifier] = ACTIONS(2375),
    [sym_comment] = ACTIONS(49),
  },
  [644] = {
    [anon_sym_LPAREN] = ACTIONS(2377),
    [anon_sym_LBRACE] = ACTIONS(2377),
    [anon_sym_EQ] = ACTIONS(2377),
    [sym_comment] = ACTIONS(49),
  },
  [645] = {
    [aux_sym_structured_binding_declarator_repeat1] = STATE(1168),
    [anon_sym_COMMA] = ACTIONS(1243),
    [anon_sym_RBRACK] = ACTIONS(2379),
    [sym_comment] = ACTIONS(49),
  },
  [646] = {
    [anon_sym_LPAREN] = ACTIONS(1381),
    [anon_sym_COMMA] = ACTIONS(2381),
    [anon_sym_RPAREN] = ACTIONS(2381),
    [anon_sym_SEMI] = ACTIONS(2381),
    [anon_sym_LBRACE] = ACTIONS(1381),
    [anon_sym_LBRACK] = ACTIONS(1381),
    [anon_sym_EQ] = ACTIONS(1381),
    [anon_sym_const] = ACTIONS(1383),
    [anon_sym_restrict] = ACTIONS(1381),
    [anon_sym_volatile] = ACTIONS(1381),
    [anon_sym__Atomic] = ACTIONS(1381),
    [anon_sym_mutable] = ACTIONS(1381),
    [anon_sym_explicit] = ACTIONS(1381),
    [anon_sym_constexpr] = ACTIONS(1381),
    [anon_sym_COLON] = ACTIONS(1381),
    [anon_sym_GT] = ACTIONS(2381),
    [anon_sym_DASH_GT] = ACTIONS(1381),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(1381),
  },
  [647] = {
    [sym_initializer_list] = STATE(765),
    [sym_template_argument_list] = STATE(1170),
    [anon_sym_LPAREN] = ACTIONS(1483),
    [anon_sym_COMMA] = ACTIONS(1483),
    [anon_sym_RPAREN] = ACTIONS(1483),
    [anon_sym_extern] = ACTIONS(144),
    [anon_sym_LBRACE] = ACTIONS(548),
    [anon_sym_STAR] = ACTIONS(1486),
    [anon_sym_LBRACK] = ACTIONS(1483),
    [anon_sym_EQ] = ACTIONS(1479),
    [anon_sym_static] = ACTIONS(144),
    [anon_sym_register] = ACTIONS(144),
    [anon_sym_inline] = ACTIONS(144),
    [anon_sym_const] = ACTIONS(144),
    [anon_sym_restrict] = ACTIONS(144),
    [anon_sym_volatile] = ACTIONS(144),
    [anon_sym__Atomic] = ACTIONS(144),
    [anon_sym_mutable] = ACTIONS(144),
    [anon_sym_explicit] = ACTIONS(144),
    [anon_sym_constexpr] = ACTIONS(144),
    [anon_sym_QMARK] = ACTIONS(1477),
    [anon_sym_STAR_EQ] = ACTIONS(1477),
    [anon_sym_SLASH_EQ] = ACTIONS(1477),
    [anon_sym_PERCENT_EQ] = ACTIONS(1477),
    [anon_sym_PLUS_EQ] = ACTIONS(1477),
    [anon_sym_DASH_EQ] = ACTIONS(1477),
    [anon_sym_LT_LT_EQ] = ACTIONS(1477),
    [anon_sym_GT_GT_EQ] = ACTIONS(1477),
    [anon_sym_AMP_EQ] = ACTIONS(1477),
    [anon_sym_CARET_EQ] = ACTIONS(1477),
    [anon_sym_PIPE_EQ] = ACTIONS(1477),
    [anon_sym_AMP] = ACTIONS(1486),
    [anon_sym_PIPE_PIPE] = ACTIONS(1477),
    [anon_sym_AMP_AMP] = ACTIONS(1483),
    [anon_sym_PIPE] = ACTIONS(1479),
    [anon_sym_CARET] = ACTIONS(1479),
    [anon_sym_TILDE] = ACTIONS(142),
    [anon_sym_EQ_EQ] = ACTIONS(1477),
    [anon_sym_BANG_EQ] = ACTIONS(1477),
    [anon_sym_LT] = ACTIONS(1564),
    [anon_sym_GT] = ACTIONS(1479),
    [anon_sym_LT_EQ] = ACTIONS(1477),
    [anon_sym_GT_EQ] = ACTIONS(1477),
    [anon_sym_LT_LT] = ACTIONS(1479),
    [anon_sym_GT_GT] = ACTIONS(1479),
    [anon_sym_PLUS] = ACTIONS(1479),
    [anon_sym_DASH] = ACTIONS(1479),
    [anon_sym_SLASH] = ACTIONS(1479),
    [anon_sym_PERCENT] = ACTIONS(1479),
    [anon_sym_DASH_DASH] = ACTIONS(1477),
    [anon_sym_PLUS_PLUS] = ACTIONS(1477),
    [anon_sym_DOT] = ACTIONS(1477),
    [anon_sym_DASH_GT] = ACTIONS(1477),
    [sym_identifier] = ACTIONS(144),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(2384),
    [sym_operator_name] = ACTIONS(142),
  },
  [648] = {
    [sym_destructor_name] = STATE(120),
    [anon_sym_TILDE] = ACTIONS(1500),
    [sym_identifier] = ACTIONS(2386),
    [sym_comment] = ACTIONS(49),
    [anon_sym_delete] = ACTIONS(2222),
    [sym_operator_name] = ACTIONS(190),
  },
  [649] = {
    [sym_argument_list] = STATE(802),
    [aux_sym_argument_list_repeat1] = STATE(1174),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_COMMA] = ACTIONS(2388),
    [anon_sym_RPAREN] = ACTIONS(2390),
    [anon_sym_STAR] = ACTIONS(2234),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_EQ] = ACTIONS(2236),
    [anon_sym_QMARK] = ACTIONS(2238),
    [anon_sym_STAR_EQ] = ACTIONS(2240),
    [anon_sym_SLASH_EQ] = ACTIONS(2240),
    [anon_sym_PERCENT_EQ] = ACTIONS(2240),
    [anon_sym_PLUS_EQ] = ACTIONS(2240),
    [anon_sym_DASH_EQ] = ACTIONS(2240),
    [anon_sym_LT_LT_EQ] = ACTIONS(2240),
    [anon_sym_GT_GT_EQ] = ACTIONS(2240),
    [anon_sym_AMP_EQ] = ACTIONS(2240),
    [anon_sym_CARET_EQ] = ACTIONS(2240),
    [anon_sym_PIPE_EQ] = ACTIONS(2240),
    [anon_sym_AMP] = ACTIONS(2242),
    [anon_sym_PIPE_PIPE] = ACTIONS(2244),
    [anon_sym_AMP_AMP] = ACTIONS(2246),
    [anon_sym_PIPE] = ACTIONS(2248),
    [anon_sym_CARET] = ACTIONS(2250),
    [anon_sym_EQ_EQ] = ACTIONS(2252),
    [anon_sym_BANG_EQ] = ACTIONS(2252),
    [anon_sym_LT] = ACTIONS(2254),
    [anon_sym_GT] = ACTIONS(2254),
    [anon_sym_LT_EQ] = ACTIONS(2256),
    [anon_sym_GT_EQ] = ACTIONS(2256),
    [anon_sym_LT_LT] = ACTIONS(2258),
    [anon_sym_GT_GT] = ACTIONS(2258),
    [anon_sym_PLUS] = ACTIONS(2260),
    [anon_sym_DASH] = ACTIONS(2260),
    [anon_sym_SLASH] = ACTIONS(2234),
    [anon_sym_PERCENT] = ACTIONS(2234),
    [anon_sym_DASH_DASH] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(1554),
    [anon_sym_DASH_GT] = ACTIONS(1554),
    [sym_comment] = ACTIONS(49),
  },
  [650] = {
    [aux_sym_argument_list_repeat1] = STATE(1174),
    [anon_sym_COMMA] = ACTIONS(2388),
    [anon_sym_RPAREN] = ACTIONS(2390),
    [sym_comment] = ACTIONS(49),
  },
  [651] = {
    [sym_initializer_list] = STATE(804),
    [anon_sym_LPAREN] = ACTIONS(228),
    [anon_sym_COMMA] = ACTIONS(228),
    [anon_sym_RPAREN] = ACTIONS(228),
    [anon_sym_extern] = ACTIONS(230),
    [anon_sym_LBRACE] = ACTIONS(548),
    [anon_sym_STAR] = ACTIONS(228),
    [anon_sym_LBRACK] = ACTIONS(228),
    [anon_sym_static] = ACTIONS(230),
    [anon_sym_register] = ACTIONS(230),
    [anon_sym_inline] = ACTIONS(230),
    [anon_sym_const] = ACTIONS(230),
    [anon_sym_restrict] = ACTIONS(230),
    [anon_sym_volatile] = ACTIONS(230),
    [anon_sym__Atomic] = ACTIONS(230),
    [anon_sym_mutable] = ACTIONS(230),
    [anon_sym_explicit] = ACTIONS(230),
    [anon_sym_constexpr] = ACTIONS(230),
    [anon_sym_AMP] = ACTIONS(230),
    [anon_sym_AMP_AMP] = ACTIONS(228),
    [anon_sym_TILDE] = ACTIONS(228),
    [sym_identifier] = ACTIONS(230),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(2392),
    [sym_operator_name] = ACTIONS(228),
  },
  [652] = {
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(2392),
  },
  [653] = {
    [sym_parameter_list] = STATE(332),
    [sym_argument_list] = STATE(333),
    [sym_initializer_list] = STATE(333),
    [anon_sym_LPAREN] = ACTIONS(536),
    [anon_sym_COMMA] = ACTIONS(2394),
    [anon_sym_SEMI] = ACTIONS(2394),
    [anon_sym_LBRACE] = ACTIONS(548),
    [anon_sym_LBRACK] = ACTIONS(208),
    [anon_sym_EQ] = ACTIONS(544),
    [sym_comment] = ACTIONS(49),
  },
  [654] = {
    [anon_sym_COMMA] = ACTIONS(2394),
    [anon_sym_SEMI] = ACTIONS(2394),
    [sym_comment] = ACTIONS(49),
  },
  [655] = {
    [sym_type_qualifier] = STATE(724),
    [sym__type_specifier] = STATE(720),
    [sym_sized_type_specifier] = STATE(720),
    [sym_enum_specifier] = STATE(720),
    [sym_struct_specifier] = STATE(720),
    [sym_union_specifier] = STATE(720),
    [sym__expression] = STATE(721),
    [sym_comma_expression] = STATE(722),
    [sym_conditional_expression] = STATE(721),
    [sym_assignment_expression] = STATE(721),
    [sym_pointer_expression] = STATE(721),
    [sym_logical_expression] = STATE(721),
    [sym_bitwise_expression] = STATE(721),
    [sym_equality_expression] = STATE(721),
    [sym_relational_expression] = STATE(721),
    [sym_shift_expression] = STATE(721),
    [sym_math_expression] = STATE(721),
    [sym_cast_expression] = STATE(721),
    [sym_type_descriptor] = STATE(1176),
    [sym_sizeof_expression] = STATE(721),
    [sym_subscript_expression] = STATE(721),
    [sym_call_expression] = STATE(721),
    [sym_field_expression] = STATE(721),
    [sym_compound_literal_expression] = STATE(721),
    [sym_parenthesized_expression] = STATE(721),
    [sym_concatenated_string] = STATE(721),
    [sym_macro_type_specifier] = STATE(720),
    [sym_class_specifier] = STATE(720),
    [sym_dependent_type] = STATE(720),
    [sym_template_type] = STATE(415),
    [sym_template_function] = STATE(721),
    [sym_new_expression] = STATE(721),
    [sym_delete_expression] = STATE(721),
    [sym_lambda_expression] = STATE(721),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(416),
    [sym_scoped_namespace_identifier] = STATE(417),
    [aux_sym_type_definition_repeat1] = STATE(724),
    [aux_sym_sized_type_specifier_repeat1] = STATE(725),
    [sym_raw_string_literal] = ACTIONS(1397),
    [anon_sym_LPAREN] = ACTIONS(1087),
    [anon_sym_STAR] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_restrict] = ACTIONS(93),
    [anon_sym_volatile] = ACTIONS(93),
    [anon_sym__Atomic] = ACTIONS(93),
    [anon_sym_mutable] = ACTIONS(93),
    [anon_sym_explicit] = ACTIONS(93),
    [anon_sym_constexpr] = ACTIONS(93),
    [anon_sym_unsigned] = ACTIONS(1399),
    [anon_sym_long] = ACTIONS(1399),
    [anon_sym_short] = ACTIONS(1399),
    [sym_primitive_type] = ACTIONS(1401),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(428),
    [anon_sym_union] = ACTIONS(430),
    [anon_sym_AMP] = ACTIONS(1089),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1093),
    [anon_sym_PLUS] = ACTIONS(1095),
    [anon_sym_DASH] = ACTIONS(1095),
    [anon_sym_DASH_DASH] = ACTIONS(1097),
    [anon_sym_PLUS_PLUS] = ACTIONS(1097),
    [anon_sym_sizeof] = ACTIONS(1099),
    [sym_number_literal] = ACTIONS(1397),
    [sym_char_literal] = ACTIONS(1397),
    [sym_string_literal] = ACTIONS(1101),
    [sym_true] = ACTIONS(1403),
    [sym_false] = ACTIONS(1403),
    [sym_null] = ACTIONS(1403),
    [sym_identifier] = ACTIONS(1405),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(436),
    [sym_auto] = ACTIONS(1401),
    [anon_sym_typename] = ACTIONS(1407),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1409),
    [anon_sym_delete] = ACTIONS(1109),
    [sym_nullptr] = ACTIONS(1403),
  },
  [656] = {
    [anon_sym_RBRACE] = ACTIONS(2396),
    [sym_comment] = ACTIONS(49),
  },
  [657] = {
    [sym_preproc_include] = STATE(841),
    [sym_preproc_def] = STATE(841),
    [sym_preproc_function_def] = STATE(841),
    [sym_preproc_call] = STATE(841),
    [sym_preproc_if_in_compound_statement] = STATE(410),
    [sym_preproc_ifdef_in_compound_statement] = STATE(411),
    [sym_declaration] = STATE(841),
    [sym_type_definition] = STATE(841),
    [sym__declaration_specifiers] = STATE(412),
    [sym_compound_statement] = STATE(841),
    [sym_storage_class_specifier] = STATE(419),
    [sym_type_qualifier] = STATE(419),
    [sym__type_specifier] = STATE(30),
    [sym_sized_type_specifier] = STATE(30),
    [sym_enum_specifier] = STATE(30),
    [sym_struct_specifier] = STATE(30),
    [sym_union_specifier] = STATE(30),
    [sym_labeled_statement] = STATE(841),
    [sym_expression_statement] = STATE(841),
    [sym_if_statement] = STATE(841),
    [sym_switch_statement] = STATE(841),
    [sym_case_statement] = STATE(841),
    [sym_while_statement] = STATE(841),
    [sym_do_statement] = STATE(841),
    [sym_for_statement] = STATE(841),
    [sym_return_statement] = STATE(841),
    [sym_break_statement] = STATE(841),
    [sym_continue_statement] = STATE(841),
    [sym_goto_statement] = STATE(841),
    [sym__expression] = STATE(669),
    [sym_comma_expression] = STATE(414),
    [sym_conditional_expression] = STATE(669),
    [sym_assignment_expression] = STATE(669),
    [sym_pointer_expression] = STATE(669),
    [sym_logical_expression] = STATE(669),
    [sym_bitwise_expression] = STATE(669),
    [sym_equality_expression] = STATE(669),
    [sym_relational_expression] = STATE(669),
    [sym_shift_expression] = STATE(669),
    [sym_math_expression] = STATE(669),
    [sym_cast_expression] = STATE(669),
    [sym_sizeof_expression] = STATE(669),
    [sym_subscript_expression] = STATE(669),
    [sym_call_expression] = STATE(669),
    [sym_field_expression] = STATE(669),
    [sym_compound_literal_expression] = STATE(669),
    [sym_parenthesized_expression] = STATE(669),
    [sym_initializer_list] = STATE(670),
    [sym_initializer_pair] = STATE(670),
    [sym_subscript_designator] = STATE(671),
    [sym_field_designator] = STATE(671),
    [sym_concatenated_string] = STATE(669),
    [sym__empty_declaration] = STATE(841),
    [sym_macro_type_specifier] = STATE(30),
    [sym_class_specifier] = STATE(30),
    [sym_dependent_type] = STATE(30),
    [sym_structured_binding_declaration] = STATE(841),
    [sym_template_type] = STATE(415),
    [sym_template_function] = STATE(669),
    [sym_for_range_loop] = STATE(841),
    [sym_new_expression] = STATE(669),
    [sym_delete_expression] = STATE(669),
    [sym_lambda_expression] = STATE(669),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(416),
    [sym_scoped_namespace_identifier] = STATE(417),
    [aux_sym_preproc_if_in_compound_statement_repeat1] = STATE(841),
    [aux_sym__declaration_specifiers_repeat1] = STATE(419),
    [aux_sym_sized_type_specifier_repeat1] = STATE(38),
    [aux_sym_initializer_pair_repeat1] = STATE(671),
    [sym_raw_string_literal] = ACTIONS(1265),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(622),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(624),
    [anon_sym_LPAREN] = ACTIONS(1267),
    [anon_sym_COMMA] = ACTIONS(1269),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(628),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(630),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(632),
    [sym_preproc_directive] = ACTIONS(634),
    [anon_sym_SEMI] = ACTIONS(636),
    [anon_sym_typedef] = ACTIONS(638),
    [anon_sym_extern] = ACTIONS(154),
    [anon_sym_LBRACE] = ACTIONS(1271),
    [anon_sym_RBRACE] = ACTIONS(2398),
    [anon_sym_STAR] = ACTIONS(1275),
    [anon_sym_LBRACK] = ACTIONS(1277),
    [anon_sym_static] = ACTIONS(154),
    [anon_sym_register] = ACTIONS(154),
    [anon_sym_inline] = ACTIONS(154),
    [anon_sym_const] = ACTIONS(158),
    [anon_sym_restrict] = ACTIONS(158),
    [anon_sym_volatile] = ACTIONS(158),
    [anon_sym__Atomic] = ACTIONS(158),
    [anon_sym_mutable] = ACTIONS(158),
    [anon_sym_explicit] = ACTIONS(158),
    [anon_sym_constexpr] = ACTIONS(158),
    [anon_sym_unsigned] = ACTIONS(31),
    [anon_sym_long] = ACTIONS(31),
    [anon_sym_short] = ACTIONS(31),
    [sym_primitive_type] = ACTIONS(33),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_union] = ACTIONS(39),
    [anon_sym_if] = ACTIONS(646),
    [anon_sym_switch] = ACTIONS(648),
    [anon_sym_case] = ACTIONS(650),
    [anon_sym_default] = ACTIONS(652),
    [anon_sym_while] = ACTIONS(654),
    [anon_sym_do] = ACTIONS(656),
    [anon_sym_for] = ACTIONS(658),
    [anon_sym_return] = ACTIONS(660),
    [anon_sym_break] = ACTIONS(662),
    [anon_sym_continue] = ACTIONS(664),
    [anon_sym_goto] = ACTIONS(666),
    [anon_sym_AMP] = ACTIONS(1275),
    [anon_sym_BANG] = ACTIONS(1279),
    [anon_sym_TILDE] = ACTIONS(1281),
    [anon_sym_PLUS] = ACTIONS(1283),
    [anon_sym_DASH] = ACTIONS(1283),
    [anon_sym_DASH_DASH] = ACTIONS(1285),
    [anon_sym_PLUS_PLUS] = ACTIONS(1285),
    [anon_sym_sizeof] = ACTIONS(1287),
    [anon_sym_DOT] = ACTIONS(1289),
    [sym_number_literal] = ACTIONS(1265),
    [sym_char_literal] = ACTIONS(1265),
    [sym_string_literal] = ACTIONS(1291),
    [sym_true] = ACTIONS(1293),
    [sym_false] = ACTIONS(1293),
    [sym_null] = ACTIONS(1293),
    [sym_identifier] = ACTIONS(682),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(51),
    [sym_auto] = ACTIONS(33),
    [anon_sym_typename] = ACTIONS(53),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1295),
    [anon_sym_delete] = ACTIONS(1297),
    [sym_nullptr] = ACTIONS(1293),
  },
  [658] = {
    [ts_builtin_sym_end] = ACTIONS(1622),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1624),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1624),
    [anon_sym_LPAREN] = ACTIONS(1622),
    [anon_sym_COMMA] = ACTIONS(2400),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1624),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1624),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1624),
    [sym_preproc_directive] = ACTIONS(1624),
    [anon_sym_SEMI] = ACTIONS(2400),
    [anon_sym_typedef] = ACTIONS(1624),
    [anon_sym_extern] = ACTIONS(1624),
    [anon_sym_RBRACE] = ACTIONS(1622),
    [anon_sym_STAR] = ACTIONS(1622),
    [anon_sym_static] = ACTIONS(1624),
    [anon_sym_register] = ACTIONS(1624),
    [anon_sym_inline] = ACTIONS(1624),
    [anon_sym_const] = ACTIONS(1624),
    [anon_sym_restrict] = ACTIONS(1624),
    [anon_sym_volatile] = ACTIONS(1624),
    [anon_sym__Atomic] = ACTIONS(1624),
    [anon_sym_mutable] = ACTIONS(1624),
    [anon_sym_explicit] = ACTIONS(1624),
    [anon_sym_constexpr] = ACTIONS(1624),
    [anon_sym_unsigned] = ACTIONS(1624),
    [anon_sym_long] = ACTIONS(1624),
    [anon_sym_short] = ACTIONS(1624),
    [sym_primitive_type] = ACTIONS(1624),
    [anon_sym_enum] = ACTIONS(1624),
    [anon_sym_struct] = ACTIONS(1624),
    [anon_sym_union] = ACTIONS(1624),
    [anon_sym_AMP] = ACTIONS(1624),
    [anon_sym_AMP_AMP] = ACTIONS(1622),
    [anon_sym_TILDE] = ACTIONS(1622),
    [sym_identifier] = ACTIONS(1624),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(1624),
    [sym_auto] = ACTIONS(1624),
    [anon_sym_typename] = ACTIONS(1624),
    [anon_sym_template] = ACTIONS(1624),
    [anon_sym_namespace] = ACTIONS(1624),
    [anon_sym_using] = ACTIONS(1624),
    [anon_sym_COLON_COLON] = ACTIONS(1622),
    [sym_operator_name] = ACTIONS(1622),
  },
  [659] = {
    [sym__expression] = STATE(727),
    [sym_conditional_expression] = STATE(727),
    [sym_assignment_expression] = STATE(727),
    [sym_pointer_expression] = STATE(727),
    [sym_logical_expression] = STATE(727),
    [sym_bitwise_expression] = STATE(727),
    [sym_equality_expression] = STATE(727),
    [sym_relational_expression] = STATE(727),
    [sym_shift_expression] = STATE(727),
    [sym_math_expression] = STATE(727),
    [sym_cast_expression] = STATE(727),
    [sym_sizeof_expression] = STATE(727),
    [sym_subscript_expression] = STATE(727),
    [sym_call_expression] = STATE(727),
    [sym_field_expression] = STATE(727),
    [sym_compound_literal_expression] = STATE(727),
    [sym_parenthesized_expression] = STATE(727),
    [sym_concatenated_string] = STATE(727),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(727),
    [sym_new_expression] = STATE(727),
    [sym_delete_expression] = STATE(727),
    [sym_lambda_expression] = STATE(727),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(1411),
    [anon_sym_LPAREN] = ACTIONS(1267),
    [anon_sym_STAR] = ACTIONS(1275),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_AMP] = ACTIONS(1275),
    [anon_sym_BANG] = ACTIONS(1279),
    [anon_sym_TILDE] = ACTIONS(1281),
    [anon_sym_PLUS] = ACTIONS(1283),
    [anon_sym_DASH] = ACTIONS(1283),
    [anon_sym_DASH_DASH] = ACTIONS(1285),
    [anon_sym_PLUS_PLUS] = ACTIONS(1285),
    [anon_sym_sizeof] = ACTIONS(1287),
    [sym_number_literal] = ACTIONS(1411),
    [sym_char_literal] = ACTIONS(1411),
    [sym_string_literal] = ACTIONS(1291),
    [sym_true] = ACTIONS(1413),
    [sym_false] = ACTIONS(1413),
    [sym_null] = ACTIONS(1413),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(2402),
    [anon_sym_delete] = ACTIONS(1297),
    [sym_nullptr] = ACTIONS(1413),
  },
  [660] = {
    [sym__expression] = STATE(1180),
    [sym_conditional_expression] = STATE(1180),
    [sym_assignment_expression] = STATE(1180),
    [sym_pointer_expression] = STATE(1180),
    [sym_logical_expression] = STATE(1180),
    [sym_bitwise_expression] = STATE(1180),
    [sym_equality_expression] = STATE(1180),
    [sym_relational_expression] = STATE(1180),
    [sym_shift_expression] = STATE(1180),
    [sym_math_expression] = STATE(1180),
    [sym_cast_expression] = STATE(1180),
    [sym_sizeof_expression] = STATE(1180),
    [sym_subscript_expression] = STATE(1180),
    [sym_call_expression] = STATE(1180),
    [sym_field_expression] = STATE(1180),
    [sym_compound_literal_expression] = STATE(1180),
    [sym_parenthesized_expression] = STATE(1180),
    [sym_concatenated_string] = STATE(1180),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(1180),
    [sym_new_expression] = STATE(1180),
    [sym_delete_expression] = STATE(1180),
    [sym_lambda_expression] = STATE(1180),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_lambda_default_capture] = STATE(741),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(2404),
    [anon_sym_LPAREN] = ACTIONS(1419),
    [anon_sym_STAR] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_RBRACK] = ACTIONS(1423),
    [anon_sym_EQ] = ACTIONS(1425),
    [anon_sym_AMP] = ACTIONS(1427),
    [anon_sym_BANG] = ACTIONS(1429),
    [anon_sym_TILDE] = ACTIONS(1431),
    [anon_sym_PLUS] = ACTIONS(1433),
    [anon_sym_DASH] = ACTIONS(1433),
    [anon_sym_DASH_DASH] = ACTIONS(1435),
    [anon_sym_PLUS_PLUS] = ACTIONS(1435),
    [anon_sym_sizeof] = ACTIONS(1437),
    [sym_number_literal] = ACTIONS(2404),
    [sym_char_literal] = ACTIONS(2404),
    [sym_string_literal] = ACTIONS(1439),
    [sym_true] = ACTIONS(2406),
    [sym_false] = ACTIONS(2406),
    [sym_null] = ACTIONS(2406),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1443),
    [anon_sym_delete] = ACTIONS(1445),
    [sym_nullptr] = ACTIONS(2406),
  },
  [661] = {
    [sym__expression] = STATE(757),
    [sym_conditional_expression] = STATE(757),
    [sym_assignment_expression] = STATE(757),
    [sym_pointer_expression] = STATE(757),
    [sym_logical_expression] = STATE(757),
    [sym_bitwise_expression] = STATE(757),
    [sym_equality_expression] = STATE(757),
    [sym_relational_expression] = STATE(757),
    [sym_shift_expression] = STATE(757),
    [sym_math_expression] = STATE(757),
    [sym_cast_expression] = STATE(757),
    [sym_sizeof_expression] = STATE(757),
    [sym_subscript_expression] = STATE(757),
    [sym_call_expression] = STATE(757),
    [sym_field_expression] = STATE(757),
    [sym_compound_literal_expression] = STATE(757),
    [sym_parenthesized_expression] = STATE(757),
    [sym_concatenated_string] = STATE(757),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(757),
    [sym_new_expression] = STATE(757),
    [sym_delete_expression] = STATE(757),
    [sym_lambda_expression] = STATE(757),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(1459),
    [anon_sym_LPAREN] = ACTIONS(1267),
    [anon_sym_STAR] = ACTIONS(1275),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_AMP] = ACTIONS(1275),
    [anon_sym_BANG] = ACTIONS(1279),
    [anon_sym_TILDE] = ACTIONS(1281),
    [anon_sym_PLUS] = ACTIONS(1283),
    [anon_sym_DASH] = ACTIONS(1283),
    [anon_sym_DASH_DASH] = ACTIONS(1285),
    [anon_sym_PLUS_PLUS] = ACTIONS(1285),
    [anon_sym_sizeof] = ACTIONS(1287),
    [sym_number_literal] = ACTIONS(1459),
    [sym_char_literal] = ACTIONS(1459),
    [sym_string_literal] = ACTIONS(1291),
    [sym_true] = ACTIONS(1461),
    [sym_false] = ACTIONS(1461),
    [sym_null] = ACTIONS(1461),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(2402),
    [anon_sym_delete] = ACTIONS(1297),
    [sym_nullptr] = ACTIONS(1461),
  },
  [662] = {
    [sym__expression] = STATE(758),
    [sym_conditional_expression] = STATE(758),
    [sym_assignment_expression] = STATE(758),
    [sym_pointer_expression] = STATE(758),
    [sym_logical_expression] = STATE(758),
    [sym_bitwise_expression] = STATE(758),
    [sym_equality_expression] = STATE(758),
    [sym_relational_expression] = STATE(758),
    [sym_shift_expression] = STATE(758),
    [sym_math_expression] = STATE(758),
    [sym_cast_expression] = STATE(758),
    [sym_sizeof_expression] = STATE(758),
    [sym_subscript_expression] = STATE(758),
    [sym_call_expression] = STATE(758),
    [sym_field_expression] = STATE(758),
    [sym_compound_literal_expression] = STATE(758),
    [sym_parenthesized_expression] = STATE(758),
    [sym_concatenated_string] = STATE(758),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(758),
    [sym_new_expression] = STATE(758),
    [sym_delete_expression] = STATE(758),
    [sym_lambda_expression] = STATE(758),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(1463),
    [anon_sym_LPAREN] = ACTIONS(1267),
    [anon_sym_STAR] = ACTIONS(1275),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_AMP] = ACTIONS(1275),
    [anon_sym_BANG] = ACTIONS(1279),
    [anon_sym_TILDE] = ACTIONS(1281),
    [anon_sym_PLUS] = ACTIONS(1283),
    [anon_sym_DASH] = ACTIONS(1283),
    [anon_sym_DASH_DASH] = ACTIONS(1285),
    [anon_sym_PLUS_PLUS] = ACTIONS(1285),
    [anon_sym_sizeof] = ACTIONS(1287),
    [sym_number_literal] = ACTIONS(1463),
    [sym_char_literal] = ACTIONS(1463),
    [sym_string_literal] = ACTIONS(1291),
    [sym_true] = ACTIONS(1465),
    [sym_false] = ACTIONS(1465),
    [sym_null] = ACTIONS(1465),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(2402),
    [anon_sym_delete] = ACTIONS(1297),
    [sym_nullptr] = ACTIONS(1465),
  },
  [663] = {
    [sym__expression] = STATE(759),
    [sym_conditional_expression] = STATE(759),
    [sym_assignment_expression] = STATE(759),
    [sym_pointer_expression] = STATE(759),
    [sym_logical_expression] = STATE(759),
    [sym_bitwise_expression] = STATE(759),
    [sym_equality_expression] = STATE(759),
    [sym_relational_expression] = STATE(759),
    [sym_shift_expression] = STATE(759),
    [sym_math_expression] = STATE(759),
    [sym_cast_expression] = STATE(759),
    [sym_sizeof_expression] = STATE(759),
    [sym_subscript_expression] = STATE(759),
    [sym_call_expression] = STATE(759),
    [sym_field_expression] = STATE(759),
    [sym_compound_literal_expression] = STATE(759),
    [sym_parenthesized_expression] = STATE(759),
    [sym_concatenated_string] = STATE(759),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(759),
    [sym_new_expression] = STATE(759),
    [sym_delete_expression] = STATE(759),
    [sym_lambda_expression] = STATE(759),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(1467),
    [anon_sym_LPAREN] = ACTIONS(1267),
    [anon_sym_STAR] = ACTIONS(1275),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_AMP] = ACTIONS(1275),
    [anon_sym_BANG] = ACTIONS(1279),
    [anon_sym_TILDE] = ACTIONS(1281),
    [anon_sym_PLUS] = ACTIONS(1283),
    [anon_sym_DASH] = ACTIONS(1283),
    [anon_sym_DASH_DASH] = ACTIONS(1285),
    [anon_sym_PLUS_PLUS] = ACTIONS(1285),
    [anon_sym_sizeof] = ACTIONS(1287),
    [sym_number_literal] = ACTIONS(1467),
    [sym_char_literal] = ACTIONS(1467),
    [sym_string_literal] = ACTIONS(1291),
    [sym_true] = ACTIONS(1469),
    [sym_false] = ACTIONS(1469),
    [sym_null] = ACTIONS(1469),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(2402),
    [anon_sym_delete] = ACTIONS(1297),
    [sym_nullptr] = ACTIONS(1469),
  },
  [664] = {
    [sym__expression] = STATE(1182),
    [sym_conditional_expression] = STATE(1182),
    [sym_assignment_expression] = STATE(1182),
    [sym_pointer_expression] = STATE(1182),
    [sym_logical_expression] = STATE(1182),
    [sym_bitwise_expression] = STATE(1182),
    [sym_equality_expression] = STATE(1182),
    [sym_relational_expression] = STATE(1182),
    [sym_shift_expression] = STATE(1182),
    [sym_math_expression] = STATE(1182),
    [sym_cast_expression] = STATE(1182),
    [sym_sizeof_expression] = STATE(1182),
    [sym_subscript_expression] = STATE(1182),
    [sym_call_expression] = STATE(1182),
    [sym_field_expression] = STATE(1182),
    [sym_compound_literal_expression] = STATE(1182),
    [sym_parenthesized_expression] = STATE(1182),
    [sym_concatenated_string] = STATE(1182),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(1182),
    [sym_new_expression] = STATE(1182),
    [sym_delete_expression] = STATE(1182),
    [sym_lambda_expression] = STATE(1182),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(2408),
    [anon_sym_LPAREN] = ACTIONS(2410),
    [anon_sym_STAR] = ACTIONS(1275),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_AMP] = ACTIONS(1275),
    [anon_sym_BANG] = ACTIONS(1279),
    [anon_sym_TILDE] = ACTIONS(1281),
    [anon_sym_PLUS] = ACTIONS(1283),
    [anon_sym_DASH] = ACTIONS(1283),
    [anon_sym_DASH_DASH] = ACTIONS(1285),
    [anon_sym_PLUS_PLUS] = ACTIONS(1285),
    [anon_sym_sizeof] = ACTIONS(1287),
    [sym_number_literal] = ACTIONS(2408),
    [sym_char_literal] = ACTIONS(2408),
    [sym_string_literal] = ACTIONS(1291),
    [sym_true] = ACTIONS(2412),
    [sym_false] = ACTIONS(2412),
    [sym_null] = ACTIONS(2412),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(2402),
    [anon_sym_delete] = ACTIONS(1297),
    [sym_nullptr] = ACTIONS(2412),
  },
  [665] = {
    [sym_identifier] = ACTIONS(2414),
    [sym_comment] = ACTIONS(49),
  },
  [666] = {
    [aux_sym_concatenated_string_repeat1] = STATE(1184),
    [anon_sym_LPAREN] = ACTIONS(1477),
    [anon_sym_COMMA] = ACTIONS(1477),
    [anon_sym_SEMI] = ACTIONS(1477),
    [anon_sym_RBRACE] = ACTIONS(1477),
    [anon_sym_STAR] = ACTIONS(1479),
    [anon_sym_LBRACK] = ACTIONS(1477),
    [anon_sym_EQ] = ACTIONS(1479),
    [anon_sym_QMARK] = ACTIONS(1477),
    [anon_sym_STAR_EQ] = ACTIONS(1477),
    [anon_sym_SLASH_EQ] = ACTIONS(1477),
    [anon_sym_PERCENT_EQ] = ACTIONS(1477),
    [anon_sym_PLUS_EQ] = ACTIONS(1477),
    [anon_sym_DASH_EQ] = ACTIONS(1477),
    [anon_sym_LT_LT_EQ] = ACTIONS(1477),
    [anon_sym_GT_GT_EQ] = ACTIONS(1477),
    [anon_sym_AMP_EQ] = ACTIONS(1477),
    [anon_sym_CARET_EQ] = ACTIONS(1477),
    [anon_sym_PIPE_EQ] = ACTIONS(1477),
    [anon_sym_AMP] = ACTIONS(1479),
    [anon_sym_PIPE_PIPE] = ACTIONS(1477),
    [anon_sym_AMP_AMP] = ACTIONS(1477),
    [anon_sym_PIPE] = ACTIONS(1479),
    [anon_sym_CARET] = ACTIONS(1479),
    [anon_sym_EQ_EQ] = ACTIONS(1477),
    [anon_sym_BANG_EQ] = ACTIONS(1477),
    [anon_sym_LT] = ACTIONS(1479),
    [anon_sym_GT] = ACTIONS(1479),
    [anon_sym_LT_EQ] = ACTIONS(1477),
    [anon_sym_GT_EQ] = ACTIONS(1477),
    [anon_sym_LT_LT] = ACTIONS(1479),
    [anon_sym_GT_GT] = ACTIONS(1479),
    [anon_sym_PLUS] = ACTIONS(1479),
    [anon_sym_DASH] = ACTIONS(1479),
    [anon_sym_SLASH] = ACTIONS(1479),
    [anon_sym_PERCENT] = ACTIONS(1479),
    [anon_sym_DASH_DASH] = ACTIONS(1477),
    [anon_sym_PLUS_PLUS] = ACTIONS(1477),
    [anon_sym_DOT] = ACTIONS(1477),
    [anon_sym_DASH_GT] = ACTIONS(1477),
    [sym_string_literal] = ACTIONS(2416),
    [sym_comment] = ACTIONS(49),
  },
  [667] = {
    [sym_destructor_name] = STATE(120),
    [anon_sym_TILDE] = ACTIONS(1500),
    [sym_identifier] = ACTIONS(1718),
    [sym_comment] = ACTIONS(49),
    [anon_sym_delete] = ACTIONS(2418),
    [sym_operator_name] = ACTIONS(190),
  },
  [668] = {
    [sym__expression] = STATE(1187),
    [sym_conditional_expression] = STATE(1187),
    [sym_assignment_expression] = STATE(1187),
    [sym_pointer_expression] = STATE(1187),
    [sym_logical_expression] = STATE(1187),
    [sym_bitwise_expression] = STATE(1187),
    [sym_equality_expression] = STATE(1187),
    [sym_relational_expression] = STATE(1187),
    [sym_shift_expression] = STATE(1187),
    [sym_math_expression] = STATE(1187),
    [sym_cast_expression] = STATE(1187),
    [sym_sizeof_expression] = STATE(1187),
    [sym_subscript_expression] = STATE(1187),
    [sym_call_expression] = STATE(1187),
    [sym_field_expression] = STATE(1187),
    [sym_compound_literal_expression] = STATE(1187),
    [sym_parenthesized_expression] = STATE(1187),
    [sym_concatenated_string] = STATE(1187),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(1187),
    [sym_new_expression] = STATE(1187),
    [sym_delete_expression] = STATE(1187),
    [sym_lambda_expression] = STATE(1187),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(2420),
    [anon_sym_LPAREN] = ACTIONS(1267),
    [anon_sym_STAR] = ACTIONS(1275),
    [anon_sym_LBRACK] = ACTIONS(2422),
    [anon_sym_AMP] = ACTIONS(1275),
    [anon_sym_BANG] = ACTIONS(1279),
    [anon_sym_TILDE] = ACTIONS(1281),
    [anon_sym_PLUS] = ACTIONS(1283),
    [anon_sym_DASH] = ACTIONS(1283),
    [anon_sym_DASH_DASH] = ACTIONS(1285),
    [anon_sym_PLUS_PLUS] = ACTIONS(1285),
    [anon_sym_sizeof] = ACTIONS(1287),
    [sym_number_literal] = ACTIONS(2420),
    [sym_char_literal] = ACTIONS(2420),
    [sym_string_literal] = ACTIONS(1291),
    [sym_true] = ACTIONS(2424),
    [sym_false] = ACTIONS(2424),
    [sym_null] = ACTIONS(2424),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(2402),
    [anon_sym_delete] = ACTIONS(1297),
    [sym_nullptr] = ACTIONS(2424),
  },
  [669] = {
    [sym_argument_list] = STATE(802),
    [aux_sym_initializer_list_repeat1] = STATE(1201),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_COMMA] = ACTIONS(2426),
    [anon_sym_SEMI] = ACTIONS(1742),
    [anon_sym_RBRACE] = ACTIONS(2396),
    [anon_sym_STAR] = ACTIONS(2428),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_EQ] = ACTIONS(2430),
    [anon_sym_QMARK] = ACTIONS(2432),
    [anon_sym_STAR_EQ] = ACTIONS(2434),
    [anon_sym_SLASH_EQ] = ACTIONS(2434),
    [anon_sym_PERCENT_EQ] = ACTIONS(2434),
    [anon_sym_PLUS_EQ] = ACTIONS(2434),
    [anon_sym_DASH_EQ] = ACTIONS(2434),
    [anon_sym_LT_LT_EQ] = ACTIONS(2434),
    [anon_sym_GT_GT_EQ] = ACTIONS(2434),
    [anon_sym_AMP_EQ] = ACTIONS(2434),
    [anon_sym_CARET_EQ] = ACTIONS(2434),
    [anon_sym_PIPE_EQ] = ACTIONS(2434),
    [anon_sym_AMP] = ACTIONS(2436),
    [anon_sym_PIPE_PIPE] = ACTIONS(2438),
    [anon_sym_AMP_AMP] = ACTIONS(2440),
    [anon_sym_PIPE] = ACTIONS(2442),
    [anon_sym_CARET] = ACTIONS(2444),
    [anon_sym_EQ_EQ] = ACTIONS(2446),
    [anon_sym_BANG_EQ] = ACTIONS(2446),
    [anon_sym_LT] = ACTIONS(2448),
    [anon_sym_GT] = ACTIONS(2448),
    [anon_sym_LT_EQ] = ACTIONS(2450),
    [anon_sym_GT_EQ] = ACTIONS(2450),
    [anon_sym_LT_LT] = ACTIONS(2452),
    [anon_sym_GT_GT] = ACTIONS(2452),
    [anon_sym_PLUS] = ACTIONS(2454),
    [anon_sym_DASH] = ACTIONS(2454),
    [anon_sym_SLASH] = ACTIONS(2428),
    [anon_sym_PERCENT] = ACTIONS(2428),
    [anon_sym_DASH_DASH] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(1554),
    [anon_sym_DASH_GT] = ACTIONS(1554),
    [sym_comment] = ACTIONS(49),
  },
  [670] = {
    [aux_sym_initializer_list_repeat1] = STATE(1201),
    [anon_sym_COMMA] = ACTIONS(2456),
    [anon_sym_RBRACE] = ACTIONS(2396),
    [sym_comment] = ACTIONS(49),
  },
  [671] = {
    [sym_subscript_designator] = STATE(1205),
    [sym_field_designator] = STATE(1205),
    [aux_sym_initializer_pair_repeat1] = STATE(1205),
    [anon_sym_LBRACK] = ACTIONS(2458),
    [anon_sym_EQ] = ACTIONS(2460),
    [anon_sym_DOT] = ACTIONS(1289),
    [sym_comment] = ACTIONS(49),
  },
  [672] = {
    [sym_destructor_name] = STATE(120),
    [anon_sym_TILDE] = ACTIONS(1500),
    [sym_identifier] = ACTIONS(2220),
    [sym_comment] = ACTIONS(49),
    [anon_sym_delete] = ACTIONS(1720),
    [sym_operator_name] = ACTIONS(190),
  },
  [673] = {
    [sym_argument_list] = STATE(802),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_COMMA] = ACTIONS(2462),
    [anon_sym_SEMI] = ACTIONS(2462),
    [anon_sym_STAR] = ACTIONS(1744),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_EQ] = ACTIONS(1746),
    [anon_sym_QMARK] = ACTIONS(1748),
    [anon_sym_STAR_EQ] = ACTIONS(1750),
    [anon_sym_SLASH_EQ] = ACTIONS(1750),
    [anon_sym_PERCENT_EQ] = ACTIONS(1750),
    [anon_sym_PLUS_EQ] = ACTIONS(1750),
    [anon_sym_DASH_EQ] = ACTIONS(1750),
    [anon_sym_LT_LT_EQ] = ACTIONS(1750),
    [anon_sym_GT_GT_EQ] = ACTIONS(1750),
    [anon_sym_AMP_EQ] = ACTIONS(1750),
    [anon_sym_CARET_EQ] = ACTIONS(1750),
    [anon_sym_PIPE_EQ] = ACTIONS(1750),
    [anon_sym_AMP] = ACTIONS(1752),
    [anon_sym_PIPE_PIPE] = ACTIONS(1754),
    [anon_sym_AMP_AMP] = ACTIONS(1756),
    [anon_sym_PIPE] = ACTIONS(1758),
    [anon_sym_CARET] = ACTIONS(1760),
    [anon_sym_EQ_EQ] = ACTIONS(1762),
    [anon_sym_BANG_EQ] = ACTIONS(1762),
    [anon_sym_LT] = ACTIONS(1764),
    [anon_sym_GT] = ACTIONS(1764),
    [anon_sym_LT_EQ] = ACTIONS(1766),
    [anon_sym_GT_EQ] = ACTIONS(1766),
    [anon_sym_LT_LT] = ACTIONS(1768),
    [anon_sym_GT_GT] = ACTIONS(1768),
    [anon_sym_PLUS] = ACTIONS(1770),
    [anon_sym_DASH] = ACTIONS(1770),
    [anon_sym_SLASH] = ACTIONS(1744),
    [anon_sym_PERCENT] = ACTIONS(1744),
    [anon_sym_DASH_DASH] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(1554),
    [anon_sym_DASH_GT] = ACTIONS(1554),
    [sym_comment] = ACTIONS(49),
  },
  [674] = {
    [anon_sym_COMMA] = ACTIONS(2462),
    [anon_sym_RPAREN] = ACTIONS(2462),
    [anon_sym_SEMI] = ACTIONS(2462),
    [anon_sym_GT] = ACTIONS(2462),
    [sym_comment] = ACTIONS(49),
  },
  [675] = {
    [sym__type_specifier] = STATE(1210),
    [sym_sized_type_specifier] = STATE(1210),
    [sym_enum_specifier] = STATE(1210),
    [sym_struct_specifier] = STATE(1210),
    [sym_union_specifier] = STATE(1210),
    [sym_macro_type_specifier] = STATE(1210),
    [sym_class_specifier] = STATE(1210),
    [sym_dependent_type] = STATE(1210),
    [sym_template_type] = STATE(825),
    [sym_scoped_type_identifier] = STATE(826),
    [sym_scoped_namespace_identifier] = STATE(827),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1211),
    [anon_sym_unsigned] = ACTIONS(2464),
    [anon_sym_long] = ACTIONS(2464),
    [anon_sym_short] = ACTIONS(2464),
    [sym_primitive_type] = ACTIONS(2466),
    [anon_sym_enum] = ACTIONS(1582),
    [anon_sym_struct] = ACTIONS(2468),
    [anon_sym_union] = ACTIONS(2470),
    [sym_identifier] = ACTIONS(1588),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(2472),
    [sym_auto] = ACTIONS(2466),
    [anon_sym_typename] = ACTIONS(2474),
    [anon_sym_COLON_COLON] = ACTIONS(1594),
  },
  [676] = {
    [sym_type_qualifier] = STATE(1212),
    [sym_trailing_return_type] = STATE(1212),
    [aux_sym_function_declarator_repeat1] = STATE(1212),
    [anon_sym_LPAREN] = ACTIONS(1596),
    [anon_sym_COMMA] = ACTIONS(1596),
    [anon_sym_SEMI] = ACTIONS(1596),
    [anon_sym_LBRACE] = ACTIONS(1596),
    [anon_sym_LBRACK] = ACTIONS(1596),
    [anon_sym_EQ] = ACTIONS(1596),
    [anon_sym_const] = ACTIONS(612),
    [anon_sym_restrict] = ACTIONS(614),
    [anon_sym_volatile] = ACTIONS(614),
    [anon_sym__Atomic] = ACTIONS(614),
    [anon_sym_mutable] = ACTIONS(614),
    [anon_sym_explicit] = ACTIONS(614),
    [anon_sym_constexpr] = ACTIONS(614),
    [anon_sym_DASH_GT] = ACTIONS(1309),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(2476),
  },
  [677] = {
    [ts_builtin_sym_end] = ACTIONS(2478),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(2480),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(2480),
    [anon_sym_LPAREN] = ACTIONS(2478),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(2480),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(2480),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(2480),
    [sym_preproc_directive] = ACTIONS(2480),
    [anon_sym_typedef] = ACTIONS(2480),
    [anon_sym_extern] = ACTIONS(2480),
    [anon_sym_RBRACE] = ACTIONS(2478),
    [anon_sym_STAR] = ACTIONS(2478),
    [anon_sym_static] = ACTIONS(2480),
    [anon_sym_register] = ACTIONS(2480),
    [anon_sym_inline] = ACTIONS(2480),
    [anon_sym_const] = ACTIONS(2480),
    [anon_sym_restrict] = ACTIONS(2480),
    [anon_sym_volatile] = ACTIONS(2480),
    [anon_sym__Atomic] = ACTIONS(2480),
    [anon_sym_mutable] = ACTIONS(2480),
    [anon_sym_explicit] = ACTIONS(2480),
    [anon_sym_constexpr] = ACTIONS(2480),
    [anon_sym_unsigned] = ACTIONS(2480),
    [anon_sym_long] = ACTIONS(2480),
    [anon_sym_short] = ACTIONS(2480),
    [sym_primitive_type] = ACTIONS(2480),
    [anon_sym_enum] = ACTIONS(2480),
    [anon_sym_struct] = ACTIONS(2480),
    [anon_sym_union] = ACTIONS(2480),
    [anon_sym_AMP] = ACTIONS(2480),
    [anon_sym_AMP_AMP] = ACTIONS(2478),
    [anon_sym_TILDE] = ACTIONS(2478),
    [sym_identifier] = ACTIONS(2480),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(2480),
    [sym_auto] = ACTIONS(2480),
    [anon_sym_typename] = ACTIONS(2480),
    [anon_sym_template] = ACTIONS(2480),
    [anon_sym_namespace] = ACTIONS(2480),
    [anon_sym_using] = ACTIONS(2480),
    [anon_sym_COLON_COLON] = ACTIONS(2478),
    [sym_operator_name] = ACTIONS(2478),
  },
  [678] = {
    [aux_sym_declaration_repeat1] = STATE(678),
    [anon_sym_COMMA] = ACTIONS(2482),
    [anon_sym_SEMI] = ACTIONS(2394),
    [sym_comment] = ACTIONS(49),
  },
  [679] = {
    [anon_sym_LPAREN] = ACTIONS(2485),
    [anon_sym_COMMA] = ACTIONS(2485),
    [anon_sym_RPAREN] = ACTIONS(2485),
    [anon_sym_SEMI] = ACTIONS(2485),
    [anon_sym_LBRACE] = ACTIONS(2485),
    [anon_sym_RBRACE] = ACTIONS(2485),
    [anon_sym_STAR] = ACTIONS(2487),
    [anon_sym_LBRACK] = ACTIONS(2485),
    [anon_sym_RBRACK] = ACTIONS(2485),
    [anon_sym_EQ] = ACTIONS(2487),
    [anon_sym_COLON] = ACTIONS(2485),
    [anon_sym_QMARK] = ACTIONS(2485),
    [anon_sym_STAR_EQ] = ACTIONS(2485),
    [anon_sym_SLASH_EQ] = ACTIONS(2485),
    [anon_sym_PERCENT_EQ] = ACTIONS(2485),
    [anon_sym_PLUS_EQ] = ACTIONS(2485),
    [anon_sym_DASH_EQ] = ACTIONS(2485),
    [anon_sym_LT_LT_EQ] = ACTIONS(2485),
    [anon_sym_GT_GT_EQ] = ACTIONS(2485),
    [anon_sym_AMP_EQ] = ACTIONS(2485),
    [anon_sym_CARET_EQ] = ACTIONS(2485),
    [anon_sym_PIPE_EQ] = ACTIONS(2485),
    [anon_sym_AMP] = ACTIONS(2487),
    [anon_sym_PIPE_PIPE] = ACTIONS(2485),
    [anon_sym_AMP_AMP] = ACTIONS(2485),
    [anon_sym_PIPE] = ACTIONS(2487),
    [anon_sym_CARET] = ACTIONS(2487),
    [anon_sym_EQ_EQ] = ACTIONS(2485),
    [anon_sym_BANG_EQ] = ACTIONS(2485),
    [anon_sym_LT] = ACTIONS(2487),
    [anon_sym_GT] = ACTIONS(2487),
    [anon_sym_LT_EQ] = ACTIONS(2485),
    [anon_sym_GT_EQ] = ACTIONS(2485),
    [anon_sym_LT_LT] = ACTIONS(2487),
    [anon_sym_GT_GT] = ACTIONS(2487),
    [anon_sym_PLUS] = ACTIONS(2487),
    [anon_sym_DASH] = ACTIONS(2487),
    [anon_sym_SLASH] = ACTIONS(2487),
    [anon_sym_PERCENT] = ACTIONS(2487),
    [anon_sym_DASH_DASH] = ACTIONS(2485),
    [anon_sym_PLUS_PLUS] = ACTIONS(2485),
    [anon_sym_DOT] = ACTIONS(2485),
    [anon_sym_DASH_GT] = ACTIONS(2485),
    [sym_comment] = ACTIONS(49),
  },
  [680] = {
    [sym_type_qualifier] = STATE(724),
    [sym__type_specifier] = STATE(720),
    [sym_sized_type_specifier] = STATE(720),
    [sym_enum_specifier] = STATE(720),
    [sym_struct_specifier] = STATE(720),
    [sym_union_specifier] = STATE(720),
    [sym__expression] = STATE(721),
    [sym_comma_expression] = STATE(722),
    [sym_conditional_expression] = STATE(721),
    [sym_assignment_expression] = STATE(721),
    [sym_pointer_expression] = STATE(721),
    [sym_logical_expression] = STATE(721),
    [sym_bitwise_expression] = STATE(721),
    [sym_equality_expression] = STATE(721),
    [sym_relational_expression] = STATE(721),
    [sym_shift_expression] = STATE(721),
    [sym_math_expression] = STATE(721),
    [sym_cast_expression] = STATE(721),
    [sym_type_descriptor] = STATE(1213),
    [sym_sizeof_expression] = STATE(721),
    [sym_subscript_expression] = STATE(721),
    [sym_call_expression] = STATE(721),
    [sym_field_expression] = STATE(721),
    [sym_compound_literal_expression] = STATE(721),
    [sym_parenthesized_expression] = STATE(721),
    [sym_concatenated_string] = STATE(721),
    [sym_macro_type_specifier] = STATE(720),
    [sym_class_specifier] = STATE(720),
    [sym_dependent_type] = STATE(720),
    [sym_template_type] = STATE(415),
    [sym_template_function] = STATE(721),
    [sym_new_expression] = STATE(721),
    [sym_delete_expression] = STATE(721),
    [sym_lambda_expression] = STATE(721),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(416),
    [sym_scoped_namespace_identifier] = STATE(417),
    [aux_sym_type_definition_repeat1] = STATE(724),
    [aux_sym_sized_type_specifier_repeat1] = STATE(725),
    [sym_raw_string_literal] = ACTIONS(1397),
    [anon_sym_LPAREN] = ACTIONS(1087),
    [anon_sym_STAR] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_restrict] = ACTIONS(93),
    [anon_sym_volatile] = ACTIONS(93),
    [anon_sym__Atomic] = ACTIONS(93),
    [anon_sym_mutable] = ACTIONS(93),
    [anon_sym_explicit] = ACTIONS(93),
    [anon_sym_constexpr] = ACTIONS(93),
    [anon_sym_unsigned] = ACTIONS(1399),
    [anon_sym_long] = ACTIONS(1399),
    [anon_sym_short] = ACTIONS(1399),
    [sym_primitive_type] = ACTIONS(1401),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(428),
    [anon_sym_union] = ACTIONS(430),
    [anon_sym_AMP] = ACTIONS(1089),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1093),
    [anon_sym_PLUS] = ACTIONS(1095),
    [anon_sym_DASH] = ACTIONS(1095),
    [anon_sym_DASH_DASH] = ACTIONS(1097),
    [anon_sym_PLUS_PLUS] = ACTIONS(1097),
    [anon_sym_sizeof] = ACTIONS(1099),
    [sym_number_literal] = ACTIONS(1397),
    [sym_char_literal] = ACTIONS(1397),
    [sym_string_literal] = ACTIONS(1101),
    [sym_true] = ACTIONS(1403),
    [sym_false] = ACTIONS(1403),
    [sym_null] = ACTIONS(1403),
    [sym_identifier] = ACTIONS(1405),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(436),
    [sym_auto] = ACTIONS(1401),
    [anon_sym_typename] = ACTIONS(1407),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1409),
    [anon_sym_delete] = ACTIONS(1109),
    [sym_nullptr] = ACTIONS(1403),
  },
  [681] = {
    [anon_sym_LPAREN] = ACTIONS(2400),
    [anon_sym_COMMA] = ACTIONS(2400),
    [anon_sym_RPAREN] = ACTIONS(2400),
    [anon_sym_SEMI] = ACTIONS(2400),
    [anon_sym_LBRACE] = ACTIONS(2400),
    [anon_sym_RBRACE] = ACTIONS(2400),
    [anon_sym_STAR] = ACTIONS(2489),
    [anon_sym_LBRACK] = ACTIONS(2400),
    [anon_sym_RBRACK] = ACTIONS(2400),
    [anon_sym_EQ] = ACTIONS(2489),
    [anon_sym_COLON] = ACTIONS(2400),
    [anon_sym_QMARK] = ACTIONS(2400),
    [anon_sym_STAR_EQ] = ACTIONS(2400),
    [anon_sym_SLASH_EQ] = ACTIONS(2400),
    [anon_sym_PERCENT_EQ] = ACTIONS(2400),
    [anon_sym_PLUS_EQ] = ACTIONS(2400),
    [anon_sym_DASH_EQ] = ACTIONS(2400),
    [anon_sym_LT_LT_EQ] = ACTIONS(2400),
    [anon_sym_GT_GT_EQ] = ACTIONS(2400),
    [anon_sym_AMP_EQ] = ACTIONS(2400),
    [anon_sym_CARET_EQ] = ACTIONS(2400),
    [anon_sym_PIPE_EQ] = ACTIONS(2400),
    [anon_sym_AMP] = ACTIONS(2489),
    [anon_sym_PIPE_PIPE] = ACTIONS(2400),
    [anon_sym_AMP_AMP] = ACTIONS(2400),
    [anon_sym_PIPE] = ACTIONS(2489),
    [anon_sym_CARET] = ACTIONS(2489),
    [anon_sym_EQ_EQ] = ACTIONS(2400),
    [anon_sym_BANG_EQ] = ACTIONS(2400),
    [anon_sym_LT] = ACTIONS(2489),
    [anon_sym_GT] = ACTIONS(2489),
    [anon_sym_LT_EQ] = ACTIONS(2400),
    [anon_sym_GT_EQ] = ACTIONS(2400),
    [anon_sym_LT_LT] = ACTIONS(2489),
    [anon_sym_GT_GT] = ACTIONS(2489),
    [anon_sym_PLUS] = ACTIONS(2489),
    [anon_sym_DASH] = ACTIONS(2489),
    [anon_sym_SLASH] = ACTIONS(2489),
    [anon_sym_PERCENT] = ACTIONS(2489),
    [anon_sym_DASH_DASH] = ACTIONS(2400),
    [anon_sym_PLUS_PLUS] = ACTIONS(2400),
    [anon_sym_DOT] = ACTIONS(2400),
    [anon_sym_DASH_GT] = ACTIONS(2400),
    [sym_comment] = ACTIONS(49),
  },
  [682] = {
    [sym__expression] = STATE(727),
    [sym_conditional_expression] = STATE(727),
    [sym_assignment_expression] = STATE(727),
    [sym_pointer_expression] = STATE(727),
    [sym_logical_expression] = STATE(727),
    [sym_bitwise_expression] = STATE(727),
    [sym_equality_expression] = STATE(727),
    [sym_relational_expression] = STATE(727),
    [sym_shift_expression] = STATE(727),
    [sym_math_expression] = STATE(727),
    [sym_cast_expression] = STATE(727),
    [sym_sizeof_expression] = STATE(727),
    [sym_subscript_expression] = STATE(727),
    [sym_call_expression] = STATE(727),
    [sym_field_expression] = STATE(727),
    [sym_compound_literal_expression] = STATE(727),
    [sym_parenthesized_expression] = STATE(727),
    [sym_concatenated_string] = STATE(727),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(727),
    [sym_new_expression] = STATE(727),
    [sym_delete_expression] = STATE(727),
    [sym_lambda_expression] = STATE(727),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(1411),
    [anon_sym_LPAREN] = ACTIONS(1321),
    [anon_sym_STAR] = ACTIONS(1325),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_AMP] = ACTIONS(1325),
    [anon_sym_BANG] = ACTIONS(1327),
    [anon_sym_TILDE] = ACTIONS(1329),
    [anon_sym_PLUS] = ACTIONS(1331),
    [anon_sym_DASH] = ACTIONS(1331),
    [anon_sym_DASH_DASH] = ACTIONS(1333),
    [anon_sym_PLUS_PLUS] = ACTIONS(1333),
    [anon_sym_sizeof] = ACTIONS(1335),
    [sym_number_literal] = ACTIONS(1411),
    [sym_char_literal] = ACTIONS(1411),
    [sym_string_literal] = ACTIONS(1337),
    [sym_true] = ACTIONS(1413),
    [sym_false] = ACTIONS(1413),
    [sym_null] = ACTIONS(1413),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1341),
    [anon_sym_delete] = ACTIONS(1343),
    [sym_nullptr] = ACTIONS(1413),
  },
  [683] = {
    [sym__expression] = STATE(757),
    [sym_conditional_expression] = STATE(757),
    [sym_assignment_expression] = STATE(757),
    [sym_pointer_expression] = STATE(757),
    [sym_logical_expression] = STATE(757),
    [sym_bitwise_expression] = STATE(757),
    [sym_equality_expression] = STATE(757),
    [sym_relational_expression] = STATE(757),
    [sym_shift_expression] = STATE(757),
    [sym_math_expression] = STATE(757),
    [sym_cast_expression] = STATE(757),
    [sym_sizeof_expression] = STATE(757),
    [sym_subscript_expression] = STATE(757),
    [sym_call_expression] = STATE(757),
    [sym_field_expression] = STATE(757),
    [sym_compound_literal_expression] = STATE(757),
    [sym_parenthesized_expression] = STATE(757),
    [sym_concatenated_string] = STATE(757),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(757),
    [sym_new_expression] = STATE(757),
    [sym_delete_expression] = STATE(757),
    [sym_lambda_expression] = STATE(757),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(1459),
    [anon_sym_LPAREN] = ACTIONS(1321),
    [anon_sym_STAR] = ACTIONS(1325),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_AMP] = ACTIONS(1325),
    [anon_sym_BANG] = ACTIONS(1327),
    [anon_sym_TILDE] = ACTIONS(1329),
    [anon_sym_PLUS] = ACTIONS(1331),
    [anon_sym_DASH] = ACTIONS(1331),
    [anon_sym_DASH_DASH] = ACTIONS(1333),
    [anon_sym_PLUS_PLUS] = ACTIONS(1333),
    [anon_sym_sizeof] = ACTIONS(1335),
    [sym_number_literal] = ACTIONS(1459),
    [sym_char_literal] = ACTIONS(1459),
    [sym_string_literal] = ACTIONS(1337),
    [sym_true] = ACTIONS(1461),
    [sym_false] = ACTIONS(1461),
    [sym_null] = ACTIONS(1461),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1341),
    [anon_sym_delete] = ACTIONS(1343),
    [sym_nullptr] = ACTIONS(1461),
  },
  [684] = {
    [sym__expression] = STATE(758),
    [sym_conditional_expression] = STATE(758),
    [sym_assignment_expression] = STATE(758),
    [sym_pointer_expression] = STATE(758),
    [sym_logical_expression] = STATE(758),
    [sym_bitwise_expression] = STATE(758),
    [sym_equality_expression] = STATE(758),
    [sym_relational_expression] = STATE(758),
    [sym_shift_expression] = STATE(758),
    [sym_math_expression] = STATE(758),
    [sym_cast_expression] = STATE(758),
    [sym_sizeof_expression] = STATE(758),
    [sym_subscript_expression] = STATE(758),
    [sym_call_expression] = STATE(758),
    [sym_field_expression] = STATE(758),
    [sym_compound_literal_expression] = STATE(758),
    [sym_parenthesized_expression] = STATE(758),
    [sym_concatenated_string] = STATE(758),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(758),
    [sym_new_expression] = STATE(758),
    [sym_delete_expression] = STATE(758),
    [sym_lambda_expression] = STATE(758),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(1463),
    [anon_sym_LPAREN] = ACTIONS(1321),
    [anon_sym_STAR] = ACTIONS(1325),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_AMP] = ACTIONS(1325),
    [anon_sym_BANG] = ACTIONS(1327),
    [anon_sym_TILDE] = ACTIONS(1329),
    [anon_sym_PLUS] = ACTIONS(1331),
    [anon_sym_DASH] = ACTIONS(1331),
    [anon_sym_DASH_DASH] = ACTIONS(1333),
    [anon_sym_PLUS_PLUS] = ACTIONS(1333),
    [anon_sym_sizeof] = ACTIONS(1335),
    [sym_number_literal] = ACTIONS(1463),
    [sym_char_literal] = ACTIONS(1463),
    [sym_string_literal] = ACTIONS(1337),
    [sym_true] = ACTIONS(1465),
    [sym_false] = ACTIONS(1465),
    [sym_null] = ACTIONS(1465),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1341),
    [anon_sym_delete] = ACTIONS(1343),
    [sym_nullptr] = ACTIONS(1465),
  },
  [685] = {
    [sym__expression] = STATE(759),
    [sym_conditional_expression] = STATE(759),
    [sym_assignment_expression] = STATE(759),
    [sym_pointer_expression] = STATE(759),
    [sym_logical_expression] = STATE(759),
    [sym_bitwise_expression] = STATE(759),
    [sym_equality_expression] = STATE(759),
    [sym_relational_expression] = STATE(759),
    [sym_shift_expression] = STATE(759),
    [sym_math_expression] = STATE(759),
    [sym_cast_expression] = STATE(759),
    [sym_sizeof_expression] = STATE(759),
    [sym_subscript_expression] = STATE(759),
    [sym_call_expression] = STATE(759),
    [sym_field_expression] = STATE(759),
    [sym_compound_literal_expression] = STATE(759),
    [sym_parenthesized_expression] = STATE(759),
    [sym_concatenated_string] = STATE(759),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(759),
    [sym_new_expression] = STATE(759),
    [sym_delete_expression] = STATE(759),
    [sym_lambda_expression] = STATE(759),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(1467),
    [anon_sym_LPAREN] = ACTIONS(1321),
    [anon_sym_STAR] = ACTIONS(1325),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_AMP] = ACTIONS(1325),
    [anon_sym_BANG] = ACTIONS(1327),
    [anon_sym_TILDE] = ACTIONS(1329),
    [anon_sym_PLUS] = ACTIONS(1331),
    [anon_sym_DASH] = ACTIONS(1331),
    [anon_sym_DASH_DASH] = ACTIONS(1333),
    [anon_sym_PLUS_PLUS] = ACTIONS(1333),
    [anon_sym_sizeof] = ACTIONS(1335),
    [sym_number_literal] = ACTIONS(1467),
    [sym_char_literal] = ACTIONS(1467),
    [sym_string_literal] = ACTIONS(1337),
    [sym_true] = ACTIONS(1469),
    [sym_false] = ACTIONS(1469),
    [sym_null] = ACTIONS(1469),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1341),
    [anon_sym_delete] = ACTIONS(1343),
    [sym_nullptr] = ACTIONS(1469),
  },
  [686] = {
    [sym__expression] = STATE(1215),
    [sym_conditional_expression] = STATE(1215),
    [sym_assignment_expression] = STATE(1215),
    [sym_pointer_expression] = STATE(1215),
    [sym_logical_expression] = STATE(1215),
    [sym_bitwise_expression] = STATE(1215),
    [sym_equality_expression] = STATE(1215),
    [sym_relational_expression] = STATE(1215),
    [sym_shift_expression] = STATE(1215),
    [sym_math_expression] = STATE(1215),
    [sym_cast_expression] = STATE(1215),
    [sym_sizeof_expression] = STATE(1215),
    [sym_subscript_expression] = STATE(1215),
    [sym_call_expression] = STATE(1215),
    [sym_field_expression] = STATE(1215),
    [sym_compound_literal_expression] = STATE(1215),
    [sym_parenthesized_expression] = STATE(1215),
    [sym_concatenated_string] = STATE(1215),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(1215),
    [sym_new_expression] = STATE(1215),
    [sym_delete_expression] = STATE(1215),
    [sym_lambda_expression] = STATE(1215),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(2491),
    [anon_sym_LPAREN] = ACTIONS(2493),
    [anon_sym_STAR] = ACTIONS(1325),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_AMP] = ACTIONS(1325),
    [anon_sym_BANG] = ACTIONS(1327),
    [anon_sym_TILDE] = ACTIONS(1329),
    [anon_sym_PLUS] = ACTIONS(1331),
    [anon_sym_DASH] = ACTIONS(1331),
    [anon_sym_DASH_DASH] = ACTIONS(1333),
    [anon_sym_PLUS_PLUS] = ACTIONS(1333),
    [anon_sym_sizeof] = ACTIONS(1335),
    [sym_number_literal] = ACTIONS(2491),
    [sym_char_literal] = ACTIONS(2491),
    [sym_string_literal] = ACTIONS(1337),
    [sym_true] = ACTIONS(2495),
    [sym_false] = ACTIONS(2495),
    [sym_null] = ACTIONS(2495),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1341),
    [anon_sym_delete] = ACTIONS(1343),
    [sym_nullptr] = ACTIONS(2495),
  },
  [687] = {
    [aux_sym_concatenated_string_repeat1] = STATE(1216),
    [anon_sym_LPAREN] = ACTIONS(1477),
    [anon_sym_COMMA] = ACTIONS(1477),
    [anon_sym_RBRACE] = ACTIONS(1477),
    [anon_sym_STAR] = ACTIONS(1479),
    [anon_sym_LBRACK] = ACTIONS(1477),
    [anon_sym_EQ] = ACTIONS(1479),
    [anon_sym_QMARK] = ACTIONS(1477),
    [anon_sym_STAR_EQ] = ACTIONS(1477),
    [anon_sym_SLASH_EQ] = ACTIONS(1477),
    [anon_sym_PERCENT_EQ] = ACTIONS(1477),
    [anon_sym_PLUS_EQ] = ACTIONS(1477),
    [anon_sym_DASH_EQ] = ACTIONS(1477),
    [anon_sym_LT_LT_EQ] = ACTIONS(1477),
    [anon_sym_GT_GT_EQ] = ACTIONS(1477),
    [anon_sym_AMP_EQ] = ACTIONS(1477),
    [anon_sym_CARET_EQ] = ACTIONS(1477),
    [anon_sym_PIPE_EQ] = ACTIONS(1477),
    [anon_sym_AMP] = ACTIONS(1479),
    [anon_sym_PIPE_PIPE] = ACTIONS(1477),
    [anon_sym_AMP_AMP] = ACTIONS(1477),
    [anon_sym_PIPE] = ACTIONS(1479),
    [anon_sym_CARET] = ACTIONS(1479),
    [anon_sym_EQ_EQ] = ACTIONS(1477),
    [anon_sym_BANG_EQ] = ACTIONS(1477),
    [anon_sym_LT] = ACTIONS(1479),
    [anon_sym_GT] = ACTIONS(1479),
    [anon_sym_LT_EQ] = ACTIONS(1477),
    [anon_sym_GT_EQ] = ACTIONS(1477),
    [anon_sym_LT_LT] = ACTIONS(1479),
    [anon_sym_GT_GT] = ACTIONS(1479),
    [anon_sym_PLUS] = ACTIONS(1479),
    [anon_sym_DASH] = ACTIONS(1479),
    [anon_sym_SLASH] = ACTIONS(1479),
    [anon_sym_PERCENT] = ACTIONS(1479),
    [anon_sym_DASH_DASH] = ACTIONS(1477),
    [anon_sym_PLUS_PLUS] = ACTIONS(1477),
    [anon_sym_DOT] = ACTIONS(1477),
    [anon_sym_DASH_GT] = ACTIONS(1477),
    [sym_string_literal] = ACTIONS(2497),
    [sym_comment] = ACTIONS(49),
  },
  [688] = {
    [sym_destructor_name] = STATE(120),
    [anon_sym_TILDE] = ACTIONS(1500),
    [sym_identifier] = ACTIONS(2220),
    [sym_comment] = ACTIONS(49),
    [anon_sym_delete] = ACTIONS(2499),
    [sym_operator_name] = ACTIONS(190),
  },
  [689] = {
    [sym__expression] = STATE(1219),
    [sym_conditional_expression] = STATE(1219),
    [sym_assignment_expression] = STATE(1219),
    [sym_pointer_expression] = STATE(1219),
    [sym_logical_expression] = STATE(1219),
    [sym_bitwise_expression] = STATE(1219),
    [sym_equality_expression] = STATE(1219),
    [sym_relational_expression] = STATE(1219),
    [sym_shift_expression] = STATE(1219),
    [sym_math_expression] = STATE(1219),
    [sym_cast_expression] = STATE(1219),
    [sym_sizeof_expression] = STATE(1219),
    [sym_subscript_expression] = STATE(1219),
    [sym_call_expression] = STATE(1219),
    [sym_field_expression] = STATE(1219),
    [sym_compound_literal_expression] = STATE(1219),
    [sym_parenthesized_expression] = STATE(1219),
    [sym_concatenated_string] = STATE(1219),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(1219),
    [sym_new_expression] = STATE(1219),
    [sym_delete_expression] = STATE(1219),
    [sym_lambda_expression] = STATE(1219),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(2501),
    [anon_sym_LPAREN] = ACTIONS(1321),
    [anon_sym_STAR] = ACTIONS(1325),
    [anon_sym_LBRACK] = ACTIONS(2503),
    [anon_sym_AMP] = ACTIONS(1325),
    [anon_sym_BANG] = ACTIONS(1327),
    [anon_sym_TILDE] = ACTIONS(1329),
    [anon_sym_PLUS] = ACTIONS(1331),
    [anon_sym_DASH] = ACTIONS(1331),
    [anon_sym_DASH_DASH] = ACTIONS(1333),
    [anon_sym_PLUS_PLUS] = ACTIONS(1333),
    [anon_sym_sizeof] = ACTIONS(1335),
    [sym_number_literal] = ACTIONS(2501),
    [sym_char_literal] = ACTIONS(2501),
    [sym_string_literal] = ACTIONS(1337),
    [sym_true] = ACTIONS(2505),
    [sym_false] = ACTIONS(2505),
    [sym_null] = ACTIONS(2505),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1341),
    [anon_sym_delete] = ACTIONS(1343),
    [sym_nullptr] = ACTIONS(2505),
  },
  [690] = {
    [sym_argument_list] = STATE(802),
    [aux_sym_initializer_list_repeat1] = STATE(1201),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_COMMA] = ACTIONS(2456),
    [anon_sym_RBRACE] = ACTIONS(2396),
    [anon_sym_STAR] = ACTIONS(2507),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_EQ] = ACTIONS(2509),
    [anon_sym_QMARK] = ACTIONS(2511),
    [anon_sym_STAR_EQ] = ACTIONS(2513),
    [anon_sym_SLASH_EQ] = ACTIONS(2513),
    [anon_sym_PERCENT_EQ] = ACTIONS(2513),
    [anon_sym_PLUS_EQ] = ACTIONS(2513),
    [anon_sym_DASH_EQ] = ACTIONS(2513),
    [anon_sym_LT_LT_EQ] = ACTIONS(2513),
    [anon_sym_GT_GT_EQ] = ACTIONS(2513),
    [anon_sym_AMP_EQ] = ACTIONS(2513),
    [anon_sym_CARET_EQ] = ACTIONS(2513),
    [anon_sym_PIPE_EQ] = ACTIONS(2513),
    [anon_sym_AMP] = ACTIONS(2515),
    [anon_sym_PIPE_PIPE] = ACTIONS(2517),
    [anon_sym_AMP_AMP] = ACTIONS(2519),
    [anon_sym_PIPE] = ACTIONS(2521),
    [anon_sym_CARET] = ACTIONS(2523),
    [anon_sym_EQ_EQ] = ACTIONS(2525),
    [anon_sym_BANG_EQ] = ACTIONS(2525),
    [anon_sym_LT] = ACTIONS(2527),
    [anon_sym_GT] = ACTIONS(2527),
    [anon_sym_LT_EQ] = ACTIONS(2529),
    [anon_sym_GT_EQ] = ACTIONS(2529),
    [anon_sym_LT_LT] = ACTIONS(2531),
    [anon_sym_GT_GT] = ACTIONS(2531),
    [anon_sym_PLUS] = ACTIONS(2533),
    [anon_sym_DASH] = ACTIONS(2533),
    [anon_sym_SLASH] = ACTIONS(2507),
    [anon_sym_PERCENT] = ACTIONS(2507),
    [anon_sym_DASH_DASH] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(1554),
    [anon_sym_DASH_GT] = ACTIONS(1554),
    [sym_comment] = ACTIONS(49),
  },
  [691] = {
    [sym_type_qualifier] = STATE(724),
    [sym__type_specifier] = STATE(720),
    [sym_sized_type_specifier] = STATE(720),
    [sym_enum_specifier] = STATE(720),
    [sym_struct_specifier] = STATE(720),
    [sym_union_specifier] = STATE(720),
    [sym__expression] = STATE(721),
    [sym_comma_expression] = STATE(722),
    [sym_conditional_expression] = STATE(721),
    [sym_assignment_expression] = STATE(721),
    [sym_pointer_expression] = STATE(721),
    [sym_logical_expression] = STATE(721),
    [sym_bitwise_expression] = STATE(721),
    [sym_equality_expression] = STATE(721),
    [sym_relational_expression] = STATE(721),
    [sym_shift_expression] = STATE(721),
    [sym_math_expression] = STATE(721),
    [sym_cast_expression] = STATE(721),
    [sym_type_descriptor] = STATE(1232),
    [sym_sizeof_expression] = STATE(721),
    [sym_subscript_expression] = STATE(721),
    [sym_call_expression] = STATE(721),
    [sym_field_expression] = STATE(721),
    [sym_compound_literal_expression] = STATE(721),
    [sym_parenthesized_expression] = STATE(721),
    [sym_concatenated_string] = STATE(721),
    [sym_macro_type_specifier] = STATE(720),
    [sym_class_specifier] = STATE(720),
    [sym_dependent_type] = STATE(720),
    [sym_template_type] = STATE(415),
    [sym_template_function] = STATE(721),
    [sym_new_expression] = STATE(721),
    [sym_delete_expression] = STATE(721),
    [sym_lambda_expression] = STATE(721),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(416),
    [sym_scoped_namespace_identifier] = STATE(417),
    [aux_sym_type_definition_repeat1] = STATE(724),
    [aux_sym_sized_type_specifier_repeat1] = STATE(725),
    [sym_raw_string_literal] = ACTIONS(1397),
    [anon_sym_LPAREN] = ACTIONS(1087),
    [anon_sym_STAR] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_restrict] = ACTIONS(93),
    [anon_sym_volatile] = ACTIONS(93),
    [anon_sym__Atomic] = ACTIONS(93),
    [anon_sym_mutable] = ACTIONS(93),
    [anon_sym_explicit] = ACTIONS(93),
    [anon_sym_constexpr] = ACTIONS(93),
    [anon_sym_unsigned] = ACTIONS(1399),
    [anon_sym_long] = ACTIONS(1399),
    [anon_sym_short] = ACTIONS(1399),
    [sym_primitive_type] = ACTIONS(1401),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(428),
    [anon_sym_union] = ACTIONS(430),
    [anon_sym_AMP] = ACTIONS(1089),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1093),
    [anon_sym_PLUS] = ACTIONS(1095),
    [anon_sym_DASH] = ACTIONS(1095),
    [anon_sym_DASH_DASH] = ACTIONS(1097),
    [anon_sym_PLUS_PLUS] = ACTIONS(1097),
    [anon_sym_sizeof] = ACTIONS(1099),
    [sym_number_literal] = ACTIONS(1397),
    [sym_char_literal] = ACTIONS(1397),
    [sym_string_literal] = ACTIONS(1101),
    [sym_true] = ACTIONS(1403),
    [sym_false] = ACTIONS(1403),
    [sym_null] = ACTIONS(1403),
    [sym_identifier] = ACTIONS(1405),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(436),
    [sym_auto] = ACTIONS(1401),
    [anon_sym_typename] = ACTIONS(1407),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1409),
    [anon_sym_delete] = ACTIONS(1109),
    [sym_nullptr] = ACTIONS(1403),
  },
  [692] = {
    [sym__expression] = STATE(727),
    [sym_conditional_expression] = STATE(727),
    [sym_assignment_expression] = STATE(727),
    [sym_pointer_expression] = STATE(727),
    [sym_logical_expression] = STATE(727),
    [sym_bitwise_expression] = STATE(727),
    [sym_equality_expression] = STATE(727),
    [sym_relational_expression] = STATE(727),
    [sym_shift_expression] = STATE(727),
    [sym_math_expression] = STATE(727),
    [sym_cast_expression] = STATE(727),
    [sym_sizeof_expression] = STATE(727),
    [sym_subscript_expression] = STATE(727),
    [sym_call_expression] = STATE(727),
    [sym_field_expression] = STATE(727),
    [sym_compound_literal_expression] = STATE(727),
    [sym_parenthesized_expression] = STATE(727),
    [sym_concatenated_string] = STATE(727),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(727),
    [sym_new_expression] = STATE(727),
    [sym_delete_expression] = STATE(727),
    [sym_lambda_expression] = STATE(727),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(1411),
    [anon_sym_LPAREN] = ACTIONS(1347),
    [anon_sym_STAR] = ACTIONS(1349),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_AMP] = ACTIONS(1349),
    [anon_sym_BANG] = ACTIONS(1351),
    [anon_sym_TILDE] = ACTIONS(1353),
    [anon_sym_PLUS] = ACTIONS(1355),
    [anon_sym_DASH] = ACTIONS(1355),
    [anon_sym_DASH_DASH] = ACTIONS(1357),
    [anon_sym_PLUS_PLUS] = ACTIONS(1357),
    [anon_sym_sizeof] = ACTIONS(1359),
    [sym_number_literal] = ACTIONS(1411),
    [sym_char_literal] = ACTIONS(1411),
    [sym_string_literal] = ACTIONS(1361),
    [sym_true] = ACTIONS(1413),
    [sym_false] = ACTIONS(1413),
    [sym_null] = ACTIONS(1413),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1365),
    [anon_sym_delete] = ACTIONS(1367),
    [sym_nullptr] = ACTIONS(1413),
  },
  [693] = {
    [sym__expression] = STATE(757),
    [sym_conditional_expression] = STATE(757),
    [sym_assignment_expression] = STATE(757),
    [sym_pointer_expression] = STATE(757),
    [sym_logical_expression] = STATE(757),
    [sym_bitwise_expression] = STATE(757),
    [sym_equality_expression] = STATE(757),
    [sym_relational_expression] = STATE(757),
    [sym_shift_expression] = STATE(757),
    [sym_math_expression] = STATE(757),
    [sym_cast_expression] = STATE(757),
    [sym_sizeof_expression] = STATE(757),
    [sym_subscript_expression] = STATE(757),
    [sym_call_expression] = STATE(757),
    [sym_field_expression] = STATE(757),
    [sym_compound_literal_expression] = STATE(757),
    [sym_parenthesized_expression] = STATE(757),
    [sym_concatenated_string] = STATE(757),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(757),
    [sym_new_expression] = STATE(757),
    [sym_delete_expression] = STATE(757),
    [sym_lambda_expression] = STATE(757),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(1459),
    [anon_sym_LPAREN] = ACTIONS(1347),
    [anon_sym_STAR] = ACTIONS(1349),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_AMP] = ACTIONS(1349),
    [anon_sym_BANG] = ACTIONS(1351),
    [anon_sym_TILDE] = ACTIONS(1353),
    [anon_sym_PLUS] = ACTIONS(1355),
    [anon_sym_DASH] = ACTIONS(1355),
    [anon_sym_DASH_DASH] = ACTIONS(1357),
    [anon_sym_PLUS_PLUS] = ACTIONS(1357),
    [anon_sym_sizeof] = ACTIONS(1359),
    [sym_number_literal] = ACTIONS(1459),
    [sym_char_literal] = ACTIONS(1459),
    [sym_string_literal] = ACTIONS(1361),
    [sym_true] = ACTIONS(1461),
    [sym_false] = ACTIONS(1461),
    [sym_null] = ACTIONS(1461),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1365),
    [anon_sym_delete] = ACTIONS(1367),
    [sym_nullptr] = ACTIONS(1461),
  },
  [694] = {
    [sym__expression] = STATE(758),
    [sym_conditional_expression] = STATE(758),
    [sym_assignment_expression] = STATE(758),
    [sym_pointer_expression] = STATE(758),
    [sym_logical_expression] = STATE(758),
    [sym_bitwise_expression] = STATE(758),
    [sym_equality_expression] = STATE(758),
    [sym_relational_expression] = STATE(758),
    [sym_shift_expression] = STATE(758),
    [sym_math_expression] = STATE(758),
    [sym_cast_expression] = STATE(758),
    [sym_sizeof_expression] = STATE(758),
    [sym_subscript_expression] = STATE(758),
    [sym_call_expression] = STATE(758),
    [sym_field_expression] = STATE(758),
    [sym_compound_literal_expression] = STATE(758),
    [sym_parenthesized_expression] = STATE(758),
    [sym_concatenated_string] = STATE(758),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(758),
    [sym_new_expression] = STATE(758),
    [sym_delete_expression] = STATE(758),
    [sym_lambda_expression] = STATE(758),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(1463),
    [anon_sym_LPAREN] = ACTIONS(1347),
    [anon_sym_STAR] = ACTIONS(1349),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_AMP] = ACTIONS(1349),
    [anon_sym_BANG] = ACTIONS(1351),
    [anon_sym_TILDE] = ACTIONS(1353),
    [anon_sym_PLUS] = ACTIONS(1355),
    [anon_sym_DASH] = ACTIONS(1355),
    [anon_sym_DASH_DASH] = ACTIONS(1357),
    [anon_sym_PLUS_PLUS] = ACTIONS(1357),
    [anon_sym_sizeof] = ACTIONS(1359),
    [sym_number_literal] = ACTIONS(1463),
    [sym_char_literal] = ACTIONS(1463),
    [sym_string_literal] = ACTIONS(1361),
    [sym_true] = ACTIONS(1465),
    [sym_false] = ACTIONS(1465),
    [sym_null] = ACTIONS(1465),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1365),
    [anon_sym_delete] = ACTIONS(1367),
    [sym_nullptr] = ACTIONS(1465),
  },
  [695] = {
    [sym__expression] = STATE(759),
    [sym_conditional_expression] = STATE(759),
    [sym_assignment_expression] = STATE(759),
    [sym_pointer_expression] = STATE(759),
    [sym_logical_expression] = STATE(759),
    [sym_bitwise_expression] = STATE(759),
    [sym_equality_expression] = STATE(759),
    [sym_relational_expression] = STATE(759),
    [sym_shift_expression] = STATE(759),
    [sym_math_expression] = STATE(759),
    [sym_cast_expression] = STATE(759),
    [sym_sizeof_expression] = STATE(759),
    [sym_subscript_expression] = STATE(759),
    [sym_call_expression] = STATE(759),
    [sym_field_expression] = STATE(759),
    [sym_compound_literal_expression] = STATE(759),
    [sym_parenthesized_expression] = STATE(759),
    [sym_concatenated_string] = STATE(759),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(759),
    [sym_new_expression] = STATE(759),
    [sym_delete_expression] = STATE(759),
    [sym_lambda_expression] = STATE(759),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(1467),
    [anon_sym_LPAREN] = ACTIONS(1347),
    [anon_sym_STAR] = ACTIONS(1349),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_AMP] = ACTIONS(1349),
    [anon_sym_BANG] = ACTIONS(1351),
    [anon_sym_TILDE] = ACTIONS(1353),
    [anon_sym_PLUS] = ACTIONS(1355),
    [anon_sym_DASH] = ACTIONS(1355),
    [anon_sym_DASH_DASH] = ACTIONS(1357),
    [anon_sym_PLUS_PLUS] = ACTIONS(1357),
    [anon_sym_sizeof] = ACTIONS(1359),
    [sym_number_literal] = ACTIONS(1467),
    [sym_char_literal] = ACTIONS(1467),
    [sym_string_literal] = ACTIONS(1361),
    [sym_true] = ACTIONS(1469),
    [sym_false] = ACTIONS(1469),
    [sym_null] = ACTIONS(1469),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1365),
    [anon_sym_delete] = ACTIONS(1367),
    [sym_nullptr] = ACTIONS(1469),
  },
  [696] = {
    [sym__expression] = STATE(1234),
    [sym_conditional_expression] = STATE(1234),
    [sym_assignment_expression] = STATE(1234),
    [sym_pointer_expression] = STATE(1234),
    [sym_logical_expression] = STATE(1234),
    [sym_bitwise_expression] = STATE(1234),
    [sym_equality_expression] = STATE(1234),
    [sym_relational_expression] = STATE(1234),
    [sym_shift_expression] = STATE(1234),
    [sym_math_expression] = STATE(1234),
    [sym_cast_expression] = STATE(1234),
    [sym_sizeof_expression] = STATE(1234),
    [sym_subscript_expression] = STATE(1234),
    [sym_call_expression] = STATE(1234),
    [sym_field_expression] = STATE(1234),
    [sym_compound_literal_expression] = STATE(1234),
    [sym_parenthesized_expression] = STATE(1234),
    [sym_concatenated_string] = STATE(1234),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(1234),
    [sym_new_expression] = STATE(1234),
    [sym_delete_expression] = STATE(1234),
    [sym_lambda_expression] = STATE(1234),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(2535),
    [anon_sym_LPAREN] = ACTIONS(2537),
    [anon_sym_STAR] = ACTIONS(1349),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_AMP] = ACTIONS(1349),
    [anon_sym_BANG] = ACTIONS(1351),
    [anon_sym_TILDE] = ACTIONS(1353),
    [anon_sym_PLUS] = ACTIONS(1355),
    [anon_sym_DASH] = ACTIONS(1355),
    [anon_sym_DASH_DASH] = ACTIONS(1357),
    [anon_sym_PLUS_PLUS] = ACTIONS(1357),
    [anon_sym_sizeof] = ACTIONS(1359),
    [sym_number_literal] = ACTIONS(2535),
    [sym_char_literal] = ACTIONS(2535),
    [sym_string_literal] = ACTIONS(1361),
    [sym_true] = ACTIONS(2539),
    [sym_false] = ACTIONS(2539),
    [sym_null] = ACTIONS(2539),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1365),
    [anon_sym_delete] = ACTIONS(1367),
    [sym_nullptr] = ACTIONS(2539),
  },
  [697] = {
    [aux_sym_concatenated_string_repeat1] = STATE(1235),
    [anon_sym_LPAREN] = ACTIONS(1477),
    [anon_sym_SEMI] = ACTIONS(1477),
    [anon_sym_STAR] = ACTIONS(1479),
    [anon_sym_LBRACK] = ACTIONS(1477),
    [anon_sym_EQ] = ACTIONS(1479),
    [anon_sym_QMARK] = ACTIONS(1477),
    [anon_sym_STAR_EQ] = ACTIONS(1477),
    [anon_sym_SLASH_EQ] = ACTIONS(1477),
    [anon_sym_PERCENT_EQ] = ACTIONS(1477),
    [anon_sym_PLUS_EQ] = ACTIONS(1477),
    [anon_sym_DASH_EQ] = ACTIONS(1477),
    [anon_sym_LT_LT_EQ] = ACTIONS(1477),
    [anon_sym_GT_GT_EQ] = ACTIONS(1477),
    [anon_sym_AMP_EQ] = ACTIONS(1477),
    [anon_sym_CARET_EQ] = ACTIONS(1477),
    [anon_sym_PIPE_EQ] = ACTIONS(1477),
    [anon_sym_AMP] = ACTIONS(1479),
    [anon_sym_PIPE_PIPE] = ACTIONS(1477),
    [anon_sym_AMP_AMP] = ACTIONS(1477),
    [anon_sym_PIPE] = ACTIONS(1479),
    [anon_sym_CARET] = ACTIONS(1479),
    [anon_sym_EQ_EQ] = ACTIONS(1477),
    [anon_sym_BANG_EQ] = ACTIONS(1477),
    [anon_sym_LT] = ACTIONS(1479),
    [anon_sym_GT] = ACTIONS(1479),
    [anon_sym_LT_EQ] = ACTIONS(1477),
    [anon_sym_GT_EQ] = ACTIONS(1477),
    [anon_sym_LT_LT] = ACTIONS(1479),
    [anon_sym_GT_GT] = ACTIONS(1479),
    [anon_sym_PLUS] = ACTIONS(1479),
    [anon_sym_DASH] = ACTIONS(1479),
    [anon_sym_SLASH] = ACTIONS(1479),
    [anon_sym_PERCENT] = ACTIONS(1479),
    [anon_sym_DASH_DASH] = ACTIONS(1477),
    [anon_sym_PLUS_PLUS] = ACTIONS(1477),
    [anon_sym_DOT] = ACTIONS(1477),
    [anon_sym_DASH_GT] = ACTIONS(1477),
    [sym_string_literal] = ACTIONS(2541),
    [sym_comment] = ACTIONS(49),
  },
  [698] = {
    [sym_destructor_name] = STATE(120),
    [anon_sym_TILDE] = ACTIONS(1500),
    [sym_identifier] = ACTIONS(2220),
    [sym_comment] = ACTIONS(49),
    [anon_sym_delete] = ACTIONS(2543),
    [sym_operator_name] = ACTIONS(190),
  },
  [699] = {
    [sym__expression] = STATE(1238),
    [sym_conditional_expression] = STATE(1238),
    [sym_assignment_expression] = STATE(1238),
    [sym_pointer_expression] = STATE(1238),
    [sym_logical_expression] = STATE(1238),
    [sym_bitwise_expression] = STATE(1238),
    [sym_equality_expression] = STATE(1238),
    [sym_relational_expression] = STATE(1238),
    [sym_shift_expression] = STATE(1238),
    [sym_math_expression] = STATE(1238),
    [sym_cast_expression] = STATE(1238),
    [sym_sizeof_expression] = STATE(1238),
    [sym_subscript_expression] = STATE(1238),
    [sym_call_expression] = STATE(1238),
    [sym_field_expression] = STATE(1238),
    [sym_compound_literal_expression] = STATE(1238),
    [sym_parenthesized_expression] = STATE(1238),
    [sym_concatenated_string] = STATE(1238),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(1238),
    [sym_new_expression] = STATE(1238),
    [sym_delete_expression] = STATE(1238),
    [sym_lambda_expression] = STATE(1238),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(2545),
    [anon_sym_LPAREN] = ACTIONS(1347),
    [anon_sym_STAR] = ACTIONS(1349),
    [anon_sym_LBRACK] = ACTIONS(2547),
    [anon_sym_AMP] = ACTIONS(1349),
    [anon_sym_BANG] = ACTIONS(1351),
    [anon_sym_TILDE] = ACTIONS(1353),
    [anon_sym_PLUS] = ACTIONS(1355),
    [anon_sym_DASH] = ACTIONS(1355),
    [anon_sym_DASH_DASH] = ACTIONS(1357),
    [anon_sym_PLUS_PLUS] = ACTIONS(1357),
    [anon_sym_sizeof] = ACTIONS(1359),
    [sym_number_literal] = ACTIONS(2545),
    [sym_char_literal] = ACTIONS(2545),
    [sym_string_literal] = ACTIONS(1361),
    [sym_true] = ACTIONS(2549),
    [sym_false] = ACTIONS(2549),
    [sym_null] = ACTIONS(2549),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1365),
    [anon_sym_delete] = ACTIONS(1367),
    [sym_nullptr] = ACTIONS(2549),
  },
  [700] = {
    [sym_argument_list] = STATE(802),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_SEMI] = ACTIONS(2551),
    [anon_sym_STAR] = ACTIONS(2553),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_EQ] = ACTIONS(2555),
    [anon_sym_QMARK] = ACTIONS(2557),
    [anon_sym_STAR_EQ] = ACTIONS(2559),
    [anon_sym_SLASH_EQ] = ACTIONS(2559),
    [anon_sym_PERCENT_EQ] = ACTIONS(2559),
    [anon_sym_PLUS_EQ] = ACTIONS(2559),
    [anon_sym_DASH_EQ] = ACTIONS(2559),
    [anon_sym_LT_LT_EQ] = ACTIONS(2559),
    [anon_sym_GT_GT_EQ] = ACTIONS(2559),
    [anon_sym_AMP_EQ] = ACTIONS(2559),
    [anon_sym_CARET_EQ] = ACTIONS(2559),
    [anon_sym_PIPE_EQ] = ACTIONS(2559),
    [anon_sym_AMP] = ACTIONS(2561),
    [anon_sym_PIPE_PIPE] = ACTIONS(2563),
    [anon_sym_AMP_AMP] = ACTIONS(2565),
    [anon_sym_PIPE] = ACTIONS(2567),
    [anon_sym_CARET] = ACTIONS(2569),
    [anon_sym_EQ_EQ] = ACTIONS(2571),
    [anon_sym_BANG_EQ] = ACTIONS(2571),
    [anon_sym_LT] = ACTIONS(2573),
    [anon_sym_GT] = ACTIONS(2573),
    [anon_sym_LT_EQ] = ACTIONS(2575),
    [anon_sym_GT_EQ] = ACTIONS(2575),
    [anon_sym_LT_LT] = ACTIONS(2577),
    [anon_sym_GT_GT] = ACTIONS(2577),
    [anon_sym_PLUS] = ACTIONS(2579),
    [anon_sym_DASH] = ACTIONS(2579),
    [anon_sym_SLASH] = ACTIONS(2553),
    [anon_sym_PERCENT] = ACTIONS(2553),
    [anon_sym_DASH_DASH] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(1554),
    [anon_sym_DASH_GT] = ACTIONS(1554),
    [sym_comment] = ACTIONS(49),
  },
  [701] = {
    [anon_sym_SEMI] = ACTIONS(2551),
    [sym_comment] = ACTIONS(49),
  },
  [702] = {
    [ts_builtin_sym_end] = ACTIONS(2581),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(2583),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(2583),
    [anon_sym_LPAREN] = ACTIONS(2581),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(2583),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(2583),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(2583),
    [sym_preproc_directive] = ACTIONS(2583),
    [anon_sym_typedef] = ACTIONS(2583),
    [anon_sym_extern] = ACTIONS(2583),
    [anon_sym_RBRACE] = ACTIONS(2581),
    [anon_sym_STAR] = ACTIONS(2581),
    [anon_sym_static] = ACTIONS(2583),
    [anon_sym_register] = ACTIONS(2583),
    [anon_sym_inline] = ACTIONS(2583),
    [anon_sym_const] = ACTIONS(2583),
    [anon_sym_restrict] = ACTIONS(2583),
    [anon_sym_volatile] = ACTIONS(2583),
    [anon_sym__Atomic] = ACTIONS(2583),
    [anon_sym_mutable] = ACTIONS(2583),
    [anon_sym_explicit] = ACTIONS(2583),
    [anon_sym_constexpr] = ACTIONS(2583),
    [anon_sym_unsigned] = ACTIONS(2583),
    [anon_sym_long] = ACTIONS(2583),
    [anon_sym_short] = ACTIONS(2583),
    [sym_primitive_type] = ACTIONS(2583),
    [anon_sym_enum] = ACTIONS(2583),
    [anon_sym_struct] = ACTIONS(2583),
    [anon_sym_union] = ACTIONS(2583),
    [anon_sym_AMP] = ACTIONS(2583),
    [anon_sym_AMP_AMP] = ACTIONS(2581),
    [anon_sym_TILDE] = ACTIONS(2581),
    [sym_identifier] = ACTIONS(2583),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(2583),
    [sym_auto] = ACTIONS(2583),
    [anon_sym_typename] = ACTIONS(2583),
    [anon_sym_template] = ACTIONS(2583),
    [anon_sym_namespace] = ACTIONS(2583),
    [anon_sym_using] = ACTIONS(2583),
    [anon_sym_COLON_COLON] = ACTIONS(2581),
    [sym_operator_name] = ACTIONS(2581),
  },
  [703] = {
    [sym_argument_list] = STATE(802),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_SEMI] = ACTIONS(2585),
    [anon_sym_STAR] = ACTIONS(2553),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_EQ] = ACTIONS(2555),
    [anon_sym_QMARK] = ACTIONS(2557),
    [anon_sym_STAR_EQ] = ACTIONS(2559),
    [anon_sym_SLASH_EQ] = ACTIONS(2559),
    [anon_sym_PERCENT_EQ] = ACTIONS(2559),
    [anon_sym_PLUS_EQ] = ACTIONS(2559),
    [anon_sym_DASH_EQ] = ACTIONS(2559),
    [anon_sym_LT_LT_EQ] = ACTIONS(2559),
    [anon_sym_GT_GT_EQ] = ACTIONS(2559),
    [anon_sym_AMP_EQ] = ACTIONS(2559),
    [anon_sym_CARET_EQ] = ACTIONS(2559),
    [anon_sym_PIPE_EQ] = ACTIONS(2559),
    [anon_sym_AMP] = ACTIONS(2561),
    [anon_sym_PIPE_PIPE] = ACTIONS(2563),
    [anon_sym_AMP_AMP] = ACTIONS(2565),
    [anon_sym_PIPE] = ACTIONS(2567),
    [anon_sym_CARET] = ACTIONS(2569),
    [anon_sym_EQ_EQ] = ACTIONS(2571),
    [anon_sym_BANG_EQ] = ACTIONS(2571),
    [anon_sym_LT] = ACTIONS(2573),
    [anon_sym_GT] = ACTIONS(2573),
    [anon_sym_LT_EQ] = ACTIONS(2575),
    [anon_sym_GT_EQ] = ACTIONS(2575),
    [anon_sym_LT_LT] = ACTIONS(2577),
    [anon_sym_GT_GT] = ACTIONS(2577),
    [anon_sym_PLUS] = ACTIONS(2579),
    [anon_sym_DASH] = ACTIONS(2579),
    [anon_sym_SLASH] = ACTIONS(2553),
    [anon_sym_PERCENT] = ACTIONS(2553),
    [anon_sym_DASH_DASH] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(1554),
    [anon_sym_DASH_GT] = ACTIONS(1554),
    [sym_comment] = ACTIONS(49),
  },
  [704] = {
    [anon_sym_SEMI] = ACTIONS(2585),
    [sym_comment] = ACTIONS(49),
  },
  [705] = {
    [ts_builtin_sym_end] = ACTIONS(2587),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(2589),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(2589),
    [anon_sym_LPAREN] = ACTIONS(2587),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(2589),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(2589),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(2589),
    [sym_preproc_directive] = ACTIONS(2589),
    [anon_sym_typedef] = ACTIONS(2589),
    [anon_sym_extern] = ACTIONS(2589),
    [anon_sym_RBRACE] = ACTIONS(2587),
    [anon_sym_STAR] = ACTIONS(2587),
    [anon_sym_static] = ACTIONS(2589),
    [anon_sym_register] = ACTIONS(2589),
    [anon_sym_inline] = ACTIONS(2589),
    [anon_sym_const] = ACTIONS(2589),
    [anon_sym_restrict] = ACTIONS(2589),
    [anon_sym_volatile] = ACTIONS(2589),
    [anon_sym__Atomic] = ACTIONS(2589),
    [anon_sym_mutable] = ACTIONS(2589),
    [anon_sym_explicit] = ACTIONS(2589),
    [anon_sym_constexpr] = ACTIONS(2589),
    [anon_sym_unsigned] = ACTIONS(2589),
    [anon_sym_long] = ACTIONS(2589),
    [anon_sym_short] = ACTIONS(2589),
    [sym_primitive_type] = ACTIONS(2589),
    [anon_sym_enum] = ACTIONS(2589),
    [anon_sym_struct] = ACTIONS(2589),
    [anon_sym_union] = ACTIONS(2589),
    [anon_sym_AMP] = ACTIONS(2589),
    [anon_sym_AMP_AMP] = ACTIONS(2587),
    [anon_sym_TILDE] = ACTIONS(2587),
    [sym_identifier] = ACTIONS(2589),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(2589),
    [sym_auto] = ACTIONS(2589),
    [anon_sym_typename] = ACTIONS(2589),
    [anon_sym_template] = ACTIONS(2589),
    [anon_sym_namespace] = ACTIONS(2589),
    [anon_sym_using] = ACTIONS(2589),
    [anon_sym_COLON_COLON] = ACTIONS(2587),
    [sym_operator_name] = ACTIONS(2587),
  },
  [706] = {
    [sym__declaration_specifiers] = STATE(344),
    [sym_storage_class_specifier] = STATE(346),
    [sym_type_qualifier] = STATE(346),
    [sym__type_specifier] = STATE(345),
    [sym_sized_type_specifier] = STATE(345),
    [sym_enum_specifier] = STATE(345),
    [sym_struct_specifier] = STATE(345),
    [sym_union_specifier] = STATE(345),
    [sym_parameter_declaration] = STATE(1253),
    [sym_macro_type_specifier] = STATE(345),
    [sym_class_specifier] = STATE(345),
    [sym_dependent_type] = STATE(345),
    [sym_template_type] = STATE(94),
    [sym_scoped_type_identifier] = STATE(34),
    [sym_scoped_namespace_identifier] = STATE(81),
    [aux_sym__declaration_specifiers_repeat1] = STATE(346),
    [aux_sym_sized_type_specifier_repeat1] = STATE(347),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2591),
    [anon_sym_extern] = ACTIONS(154),
    [anon_sym_static] = ACTIONS(154),
    [anon_sym_register] = ACTIONS(154),
    [anon_sym_inline] = ACTIONS(154),
    [anon_sym_const] = ACTIONS(158),
    [anon_sym_restrict] = ACTIONS(158),
    [anon_sym_volatile] = ACTIONS(158),
    [anon_sym__Atomic] = ACTIONS(158),
    [anon_sym_mutable] = ACTIONS(158),
    [anon_sym_explicit] = ACTIONS(158),
    [anon_sym_constexpr] = ACTIONS(158),
    [anon_sym_unsigned] = ACTIONS(558),
    [anon_sym_long] = ACTIONS(558),
    [anon_sym_short] = ACTIONS(558),
    [sym_primitive_type] = ACTIONS(560),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_union] = ACTIONS(39),
    [sym_identifier] = ACTIONS(152),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(51),
    [sym_auto] = ACTIONS(560),
    [anon_sym_typename] = ACTIONS(562),
    [anon_sym_COLON_COLON] = ACTIONS(135),
  },
  [707] = {
    [anon_sym_LPAREN] = ACTIONS(2593),
    [anon_sym_COMMA] = ACTIONS(2593),
    [anon_sym_RPAREN] = ACTIONS(2593),
    [anon_sym_SEMI] = ACTIONS(2593),
    [anon_sym_LBRACE] = ACTIONS(2593),
    [anon_sym_LBRACK] = ACTIONS(2593),
    [anon_sym_EQ] = ACTIONS(2593),
    [anon_sym_const] = ACTIONS(2595),
    [anon_sym_restrict] = ACTIONS(2593),
    [anon_sym_volatile] = ACTIONS(2593),
    [anon_sym__Atomic] = ACTIONS(2593),
    [anon_sym_mutable] = ACTIONS(2593),
    [anon_sym_explicit] = ACTIONS(2593),
    [anon_sym_constexpr] = ACTIONS(2593),
    [anon_sym_COLON] = ACTIONS(2593),
    [anon_sym_GT] = ACTIONS(2593),
    [anon_sym_DASH_GT] = ACTIONS(2593),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(2593),
  },
  [708] = {
    [aux_sym_parameter_list_repeat1] = STATE(1255),
    [anon_sym_COMMA] = ACTIONS(1377),
    [anon_sym_RPAREN] = ACTIONS(2597),
    [sym_comment] = ACTIONS(49),
  },
  [709] = {
    [sym__declarator] = STATE(1256),
    [sym__abstract_declarator] = STATE(1257),
    [sym_pointer_declarator] = STATE(1256),
    [sym_abstract_pointer_declarator] = STATE(1257),
    [sym_function_declarator] = STATE(1256),
    [sym_abstract_function_declarator] = STATE(1257),
    [sym_array_declarator] = STATE(1256),
    [sym_abstract_array_declarator] = STATE(1257),
    [sym_parameter_list] = STATE(713),
    [sym_reference_declarator] = STATE(1256),
    [sym_abstract_reference_declarator] = STATE(1257),
    [sym_template_type] = STATE(46),
    [sym_template_function] = STATE(1256),
    [sym_destructor_name] = STATE(1256),
    [sym_scoped_identifier] = STATE(33),
    [sym_scoped_type_identifier] = STATE(47),
    [sym_scoped_namespace_identifier] = STATE(46),
    [anon_sym_LPAREN] = ACTIONS(1162),
    [anon_sym_COMMA] = ACTIONS(2270),
    [anon_sym_RPAREN] = ACTIONS(2270),
    [anon_sym_STAR] = ACTIONS(1385),
    [anon_sym_LBRACK] = ACTIONS(1121),
    [anon_sym_AMP] = ACTIONS(1387),
    [anon_sym_AMP_AMP] = ACTIONS(1389),
    [anon_sym_TILDE] = ACTIONS(45),
    [sym_identifier] = ACTIONS(75),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(77),
    [sym_operator_name] = ACTIONS(2599),
  },
  [710] = {
    [sym__declarator] = STATE(1258),
    [sym__abstract_declarator] = STATE(1259),
    [sym_pointer_declarator] = STATE(1258),
    [sym_abstract_pointer_declarator] = STATE(1259),
    [sym_function_declarator] = STATE(1258),
    [sym_abstract_function_declarator] = STATE(1259),
    [sym_array_declarator] = STATE(1258),
    [sym_abstract_array_declarator] = STATE(1259),
    [sym_parameter_list] = STATE(713),
    [sym_reference_declarator] = STATE(1258),
    [sym_abstract_reference_declarator] = STATE(1259),
    [sym_template_type] = STATE(46),
    [sym_template_function] = STATE(1258),
    [sym_destructor_name] = STATE(1258),
    [sym_scoped_identifier] = STATE(33),
    [sym_scoped_type_identifier] = STATE(47),
    [sym_scoped_namespace_identifier] = STATE(46),
    [anon_sym_LPAREN] = ACTIONS(1162),
    [anon_sym_COMMA] = ACTIONS(2278),
    [anon_sym_RPAREN] = ACTIONS(2278),
    [anon_sym_STAR] = ACTIONS(1385),
    [anon_sym_LBRACK] = ACTIONS(1121),
    [anon_sym_AMP] = ACTIONS(1387),
    [anon_sym_AMP_AMP] = ACTIONS(1389),
    [anon_sym_TILDE] = ACTIONS(45),
    [sym_identifier] = ACTIONS(75),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(77),
    [sym_operator_name] = ACTIONS(2601),
  },
  [711] = {
    [sym_parameter_list] = STATE(1261),
    [sym_argument_list] = STATE(333),
    [sym_initializer_list] = STATE(333),
    [anon_sym_LPAREN] = ACTIONS(536),
    [anon_sym_COMMA] = ACTIONS(2323),
    [anon_sym_RPAREN] = ACTIONS(2323),
    [anon_sym_LBRACE] = ACTIONS(548),
    [anon_sym_LBRACK] = ACTIONS(208),
    [anon_sym_EQ] = ACTIONS(2603),
    [sym_comment] = ACTIONS(49),
  },
  [712] = {
    [sym_parameter_list] = STATE(1262),
    [anon_sym_LPAREN] = ACTIONS(206),
    [anon_sym_COMMA] = ACTIONS(2323),
    [anon_sym_RPAREN] = ACTIONS(2323),
    [anon_sym_LBRACK] = ACTIONS(2282),
    [sym_comment] = ACTIONS(49),
  },
  [713] = {
    [sym_type_qualifier] = STATE(1264),
    [sym_trailing_return_type] = STATE(1129),
    [aux_sym_abstract_function_declarator_repeat1] = STATE(1264),
    [anon_sym_LPAREN] = ACTIONS(2284),
    [anon_sym_COMMA] = ACTIONS(2284),
    [anon_sym_RPAREN] = ACTIONS(2284),
    [anon_sym_LBRACK] = ACTIONS(2284),
    [anon_sym_const] = ACTIONS(612),
    [anon_sym_restrict] = ACTIONS(614),
    [anon_sym_volatile] = ACTIONS(614),
    [anon_sym__Atomic] = ACTIONS(614),
    [anon_sym_mutable] = ACTIONS(614),
    [anon_sym_explicit] = ACTIONS(614),
    [anon_sym_constexpr] = ACTIONS(614),
    [anon_sym_DASH_GT] = ACTIONS(2605),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(2607),
  },
  [714] = {
    [sym_storage_class_specifier] = STATE(1265),
    [sym_type_qualifier] = STATE(1265),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1265),
    [anon_sym_LPAREN] = ACTIONS(696),
    [anon_sym_COMMA] = ACTIONS(696),
    [anon_sym_RPAREN] = ACTIONS(696),
    [anon_sym_extern] = ACTIONS(218),
    [anon_sym_STAR] = ACTIONS(696),
    [anon_sym_LBRACK] = ACTIONS(696),
    [anon_sym_static] = ACTIONS(218),
    [anon_sym_register] = ACTIONS(218),
    [anon_sym_inline] = ACTIONS(218),
    [anon_sym_const] = ACTIONS(220),
    [anon_sym_restrict] = ACTIONS(220),
    [anon_sym_volatile] = ACTIONS(220),
    [anon_sym__Atomic] = ACTIONS(220),
    [anon_sym_mutable] = ACTIONS(220),
    [anon_sym_explicit] = ACTIONS(220),
    [anon_sym_constexpr] = ACTIONS(220),
    [anon_sym_AMP] = ACTIONS(698),
    [anon_sym_AMP_AMP] = ACTIONS(696),
    [anon_sym_TILDE] = ACTIONS(696),
    [sym_identifier] = ACTIONS(698),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(696),
    [sym_operator_name] = ACTIONS(696),
  },
  [715] = {
    [sym_storage_class_specifier] = STATE(1266),
    [sym_type_qualifier] = STATE(1266),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1266),
    [anon_sym_LPAREN] = ACTIONS(696),
    [anon_sym_COMMA] = ACTIONS(696),
    [anon_sym_RPAREN] = ACTIONS(696),
    [anon_sym_extern] = ACTIONS(218),
    [anon_sym_STAR] = ACTIONS(696),
    [anon_sym_LBRACK] = ACTIONS(696),
    [anon_sym_static] = ACTIONS(218),
    [anon_sym_register] = ACTIONS(218),
    [anon_sym_inline] = ACTIONS(218),
    [anon_sym_const] = ACTIONS(220),
    [anon_sym_restrict] = ACTIONS(220),
    [anon_sym_volatile] = ACTIONS(220),
    [anon_sym__Atomic] = ACTIONS(220),
    [anon_sym_mutable] = ACTIONS(220),
    [anon_sym_explicit] = ACTIONS(220),
    [anon_sym_constexpr] = ACTIONS(220),
    [anon_sym_AMP] = ACTIONS(698),
    [anon_sym_AMP_AMP] = ACTIONS(696),
    [anon_sym_TILDE] = ACTIONS(696),
    [sym_identifier] = ACTIONS(698),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(696),
    [sym_operator_name] = ACTIONS(696),
  },
  [716] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(716),
    [anon_sym_LPAREN] = ACTIONS(816),
    [anon_sym_COMMA] = ACTIONS(816),
    [anon_sym_RPAREN] = ACTIONS(816),
    [anon_sym_extern] = ACTIONS(818),
    [anon_sym_STAR] = ACTIONS(816),
    [anon_sym_LBRACK] = ACTIONS(816),
    [anon_sym_static] = ACTIONS(818),
    [anon_sym_register] = ACTIONS(818),
    [anon_sym_inline] = ACTIONS(818),
    [anon_sym_const] = ACTIONS(818),
    [anon_sym_restrict] = ACTIONS(818),
    [anon_sym_volatile] = ACTIONS(818),
    [anon_sym__Atomic] = ACTIONS(818),
    [anon_sym_mutable] = ACTIONS(818),
    [anon_sym_explicit] = ACTIONS(818),
    [anon_sym_constexpr] = ACTIONS(818),
    [anon_sym_unsigned] = ACTIONS(2609),
    [anon_sym_long] = ACTIONS(2609),
    [anon_sym_short] = ACTIONS(2609),
    [sym_primitive_type] = ACTIONS(818),
    [anon_sym_AMP] = ACTIONS(818),
    [anon_sym_AMP_AMP] = ACTIONS(816),
    [anon_sym_TILDE] = ACTIONS(816),
    [sym_identifier] = ACTIONS(818),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(816),
    [sym_operator_name] = ACTIONS(816),
  },
  [717] = {
    [sym_initializer_list] = STATE(765),
    [sym_template_argument_list] = STATE(887),
    [anon_sym_LPAREN] = ACTIONS(1483),
    [anon_sym_COMMA] = ACTIONS(1477),
    [anon_sym_RPAREN] = ACTIONS(1483),
    [anon_sym_LBRACE] = ACTIONS(548),
    [anon_sym_STAR] = ACTIONS(1486),
    [anon_sym_LBRACK] = ACTIONS(1483),
    [anon_sym_EQ] = ACTIONS(1479),
    [anon_sym_QMARK] = ACTIONS(1477),
    [anon_sym_STAR_EQ] = ACTIONS(1477),
    [anon_sym_SLASH_EQ] = ACTIONS(1477),
    [anon_sym_PERCENT_EQ] = ACTIONS(1477),
    [anon_sym_PLUS_EQ] = ACTIONS(1477),
    [anon_sym_DASH_EQ] = ACTIONS(1477),
    [anon_sym_LT_LT_EQ] = ACTIONS(1477),
    [anon_sym_GT_GT_EQ] = ACTIONS(1477),
    [anon_sym_AMP_EQ] = ACTIONS(1477),
    [anon_sym_CARET_EQ] = ACTIONS(1477),
    [anon_sym_PIPE_EQ] = ACTIONS(1477),
    [anon_sym_AMP] = ACTIONS(1486),
    [anon_sym_PIPE_PIPE] = ACTIONS(1477),
    [anon_sym_AMP_AMP] = ACTIONS(1483),
    [anon_sym_PIPE] = ACTIONS(1479),
    [anon_sym_CARET] = ACTIONS(1479),
    [anon_sym_EQ_EQ] = ACTIONS(1477),
    [anon_sym_BANG_EQ] = ACTIONS(1477),
    [anon_sym_LT] = ACTIONS(1564),
    [anon_sym_GT] = ACTIONS(1479),
    [anon_sym_LT_EQ] = ACTIONS(1477),
    [anon_sym_GT_EQ] = ACTIONS(1477),
    [anon_sym_LT_LT] = ACTIONS(1479),
    [anon_sym_GT_GT] = ACTIONS(1479),
    [anon_sym_PLUS] = ACTIONS(1479),
    [anon_sym_DASH] = ACTIONS(1479),
    [anon_sym_SLASH] = ACTIONS(1479),
    [anon_sym_PERCENT] = ACTIONS(1479),
    [anon_sym_DASH_DASH] = ACTIONS(1477),
    [anon_sym_PLUS_PLUS] = ACTIONS(1477),
    [anon_sym_DOT] = ACTIONS(1477),
    [anon_sym_DASH_GT] = ACTIONS(1477),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(1716),
  },
  [718] = {
    [sym__type_specifier] = STATE(93),
    [sym_sized_type_specifier] = STATE(93),
    [sym_enum_specifier] = STATE(93),
    [sym_struct_specifier] = STATE(93),
    [sym_union_specifier] = STATE(93),
    [sym_macro_type_specifier] = STATE(93),
    [sym_class_specifier] = STATE(93),
    [sym_dependent_type] = STATE(93),
    [sym_template_type] = STATE(62),
    [sym_scoped_type_identifier] = STATE(34),
    [sym_scoped_namespace_identifier] = STATE(64),
    [aux_sym_sized_type_specifier_repeat1] = STATE(725),
    [anon_sym_unsigned] = ACTIONS(1399),
    [anon_sym_long] = ACTIONS(1399),
    [anon_sym_short] = ACTIONS(1399),
    [sym_primitive_type] = ACTIONS(150),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(428),
    [anon_sym_union] = ACTIONS(430),
    [sym_identifier] = ACTIONS(434),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(436),
    [sym_auto] = ACTIONS(150),
    [anon_sym_typename] = ACTIONS(1407),
    [anon_sym_COLON_COLON] = ACTIONS(111),
  },
  [719] = {
    [sym_destructor_name] = STATE(120),
    [anon_sym_TILDE] = ACTIONS(1500),
    [sym_identifier] = ACTIONS(1718),
    [sym_comment] = ACTIONS(49),
    [anon_sym_delete] = ACTIONS(2222),
    [sym_operator_name] = ACTIONS(190),
  },
  [720] = {
    [sym__abstract_declarator] = STATE(1267),
    [sym_abstract_pointer_declarator] = STATE(1267),
    [sym_abstract_function_declarator] = STATE(1267),
    [sym_abstract_array_declarator] = STATE(1267),
    [sym_parameter_list] = STATE(1120),
    [sym_abstract_reference_declarator] = STATE(1267),
    [anon_sym_LPAREN] = ACTIONS(1115),
    [anon_sym_RPAREN] = ACTIONS(1117),
    [anon_sym_STAR] = ACTIONS(2264),
    [anon_sym_LBRACK] = ACTIONS(1121),
    [anon_sym_AMP] = ACTIONS(2266),
    [anon_sym_AMP_AMP] = ACTIONS(2268),
    [sym_comment] = ACTIONS(49),
  },
  [721] = {
    [sym_argument_list] = STATE(802),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_COMMA] = ACTIONS(2230),
    [anon_sym_RPAREN] = ACTIONS(2612),
    [anon_sym_STAR] = ACTIONS(2234),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_EQ] = ACTIONS(2236),
    [anon_sym_QMARK] = ACTIONS(2238),
    [anon_sym_STAR_EQ] = ACTIONS(2240),
    [anon_sym_SLASH_EQ] = ACTIONS(2240),
    [anon_sym_PERCENT_EQ] = ACTIONS(2240),
    [anon_sym_PLUS_EQ] = ACTIONS(2240),
    [anon_sym_DASH_EQ] = ACTIONS(2240),
    [anon_sym_LT_LT_EQ] = ACTIONS(2240),
    [anon_sym_GT_GT_EQ] = ACTIONS(2240),
    [anon_sym_AMP_EQ] = ACTIONS(2240),
    [anon_sym_CARET_EQ] = ACTIONS(2240),
    [anon_sym_PIPE_EQ] = ACTIONS(2240),
    [anon_sym_AMP] = ACTIONS(2242),
    [anon_sym_PIPE_PIPE] = ACTIONS(2244),
    [anon_sym_AMP_AMP] = ACTIONS(2246),
    [anon_sym_PIPE] = ACTIONS(2248),
    [anon_sym_CARET] = ACTIONS(2250),
    [anon_sym_EQ_EQ] = ACTIONS(2252),
    [anon_sym_BANG_EQ] = ACTIONS(2252),
    [anon_sym_LT] = ACTIONS(2254),
    [anon_sym_GT] = ACTIONS(2254),
    [anon_sym_LT_EQ] = ACTIONS(2256),
    [anon_sym_GT_EQ] = ACTIONS(2256),
    [anon_sym_LT_LT] = ACTIONS(2258),
    [anon_sym_GT_GT] = ACTIONS(2258),
    [anon_sym_PLUS] = ACTIONS(2260),
    [anon_sym_DASH] = ACTIONS(2260),
    [anon_sym_SLASH] = ACTIONS(2234),
    [anon_sym_PERCENT] = ACTIONS(2234),
    [anon_sym_DASH_DASH] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(1554),
    [anon_sym_DASH_GT] = ACTIONS(1554),
    [sym_comment] = ACTIONS(49),
  },
  [722] = {
    [anon_sym_RPAREN] = ACTIONS(2612),
    [sym_comment] = ACTIONS(49),
  },
  [723] = {
    [anon_sym_RPAREN] = ACTIONS(2614),
    [sym_comment] = ACTIONS(49),
  },
  [724] = {
    [sym_type_qualifier] = STATE(219),
    [sym__type_specifier] = STATE(1270),
    [sym_sized_type_specifier] = STATE(1270),
    [sym_enum_specifier] = STATE(1270),
    [sym_struct_specifier] = STATE(1270),
    [sym_union_specifier] = STATE(1270),
    [sym_macro_type_specifier] = STATE(1270),
    [sym_class_specifier] = STATE(1270),
    [sym_dependent_type] = STATE(1270),
    [sym_template_type] = STATE(62),
    [sym_scoped_type_identifier] = STATE(34),
    [sym_scoped_namespace_identifier] = STATE(64),
    [aux_sym_type_definition_repeat1] = STATE(219),
    [aux_sym_sized_type_specifier_repeat1] = STATE(725),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_restrict] = ACTIONS(93),
    [anon_sym_volatile] = ACTIONS(93),
    [anon_sym__Atomic] = ACTIONS(93),
    [anon_sym_mutable] = ACTIONS(93),
    [anon_sym_explicit] = ACTIONS(93),
    [anon_sym_constexpr] = ACTIONS(93),
    [anon_sym_unsigned] = ACTIONS(1399),
    [anon_sym_long] = ACTIONS(1399),
    [anon_sym_short] = ACTIONS(1399),
    [sym_primitive_type] = ACTIONS(2616),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(428),
    [anon_sym_union] = ACTIONS(430),
    [sym_identifier] = ACTIONS(434),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(436),
    [sym_auto] = ACTIONS(2616),
    [anon_sym_typename] = ACTIONS(1407),
    [anon_sym_COLON_COLON] = ACTIONS(111),
  },
  [725] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(1271),
    [anon_sym_LPAREN] = ACTIONS(238),
    [anon_sym_RPAREN] = ACTIONS(238),
    [anon_sym_STAR] = ACTIONS(238),
    [anon_sym_LBRACK] = ACTIONS(238),
    [anon_sym_unsigned] = ACTIONS(2618),
    [anon_sym_long] = ACTIONS(2618),
    [anon_sym_short] = ACTIONS(2618),
    [sym_primitive_type] = ACTIONS(244),
    [anon_sym_AMP] = ACTIONS(240),
    [anon_sym_AMP_AMP] = ACTIONS(238),
    [sym_identifier] = ACTIONS(1135),
    [sym_comment] = ACTIONS(49),
  },
  [726] = {
    [sym_destructor_name] = STATE(120),
    [anon_sym_TILDE] = ACTIONS(1500),
    [sym_identifier] = ACTIONS(2220),
    [sym_comment] = ACTIONS(49),
    [anon_sym_delete] = ACTIONS(1504),
    [sym_operator_name] = ACTIONS(190),
  },
  [727] = {
    [sym_argument_list] = STATE(802),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_COMMA] = ACTIONS(2620),
    [anon_sym_RPAREN] = ACTIONS(2620),
    [anon_sym_SEMI] = ACTIONS(2620),
    [anon_sym_RBRACE] = ACTIONS(2620),
    [anon_sym_STAR] = ACTIONS(2622),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_RBRACK] = ACTIONS(2620),
    [anon_sym_EQ] = ACTIONS(2622),
    [anon_sym_QMARK] = ACTIONS(2620),
    [anon_sym_STAR_EQ] = ACTIONS(2620),
    [anon_sym_SLASH_EQ] = ACTIONS(2620),
    [anon_sym_PERCENT_EQ] = ACTIONS(2620),
    [anon_sym_PLUS_EQ] = ACTIONS(2620),
    [anon_sym_DASH_EQ] = ACTIONS(2620),
    [anon_sym_LT_LT_EQ] = ACTIONS(2620),
    [anon_sym_GT_GT_EQ] = ACTIONS(2620),
    [anon_sym_AMP_EQ] = ACTIONS(2620),
    [anon_sym_CARET_EQ] = ACTIONS(2620),
    [anon_sym_PIPE_EQ] = ACTIONS(2620),
    [anon_sym_AMP] = ACTIONS(2622),
    [anon_sym_PIPE_PIPE] = ACTIONS(2620),
    [anon_sym_AMP_AMP] = ACTIONS(2620),
    [anon_sym_PIPE] = ACTIONS(2622),
    [anon_sym_CARET] = ACTIONS(2622),
    [anon_sym_EQ_EQ] = ACTIONS(2620),
    [anon_sym_BANG_EQ] = ACTIONS(2620),
    [anon_sym_LT] = ACTIONS(2622),
    [anon_sym_GT] = ACTIONS(2622),
    [anon_sym_LT_EQ] = ACTIONS(2620),
    [anon_sym_GT_EQ] = ACTIONS(2620),
    [anon_sym_LT_LT] = ACTIONS(2622),
    [anon_sym_GT_GT] = ACTIONS(2622),
    [anon_sym_PLUS] = ACTIONS(2622),
    [anon_sym_DASH] = ACTIONS(2622),
    [anon_sym_SLASH] = ACTIONS(2622),
    [anon_sym_PERCENT] = ACTIONS(2622),
    [anon_sym_DASH_DASH] = ACTIONS(2620),
    [anon_sym_PLUS_PLUS] = ACTIONS(2620),
    [anon_sym_DOT] = ACTIONS(1554),
    [anon_sym_DASH_GT] = ACTIONS(1554),
    [sym_comment] = ACTIONS(49),
  },
  [728] = {
    [sym_type_qualifier] = STATE(724),
    [sym__type_specifier] = STATE(720),
    [sym_sized_type_specifier] = STATE(720),
    [sym_enum_specifier] = STATE(720),
    [sym_struct_specifier] = STATE(720),
    [sym_union_specifier] = STATE(720),
    [sym__expression] = STATE(721),
    [sym_comma_expression] = STATE(722),
    [sym_conditional_expression] = STATE(721),
    [sym_assignment_expression] = STATE(721),
    [sym_pointer_expression] = STATE(721),
    [sym_logical_expression] = STATE(721),
    [sym_bitwise_expression] = STATE(721),
    [sym_equality_expression] = STATE(721),
    [sym_relational_expression] = STATE(721),
    [sym_shift_expression] = STATE(721),
    [sym_math_expression] = STATE(721),
    [sym_cast_expression] = STATE(721),
    [sym_type_descriptor] = STATE(1272),
    [sym_sizeof_expression] = STATE(721),
    [sym_subscript_expression] = STATE(721),
    [sym_call_expression] = STATE(721),
    [sym_field_expression] = STATE(721),
    [sym_compound_literal_expression] = STATE(721),
    [sym_parenthesized_expression] = STATE(721),
    [sym_concatenated_string] = STATE(721),
    [sym_macro_type_specifier] = STATE(720),
    [sym_class_specifier] = STATE(720),
    [sym_dependent_type] = STATE(720),
    [sym_template_type] = STATE(415),
    [sym_template_function] = STATE(721),
    [sym_new_expression] = STATE(721),
    [sym_delete_expression] = STATE(721),
    [sym_lambda_expression] = STATE(721),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(416),
    [sym_scoped_namespace_identifier] = STATE(417),
    [aux_sym_type_definition_repeat1] = STATE(724),
    [aux_sym_sized_type_specifier_repeat1] = STATE(725),
    [sym_raw_string_literal] = ACTIONS(1397),
    [anon_sym_LPAREN] = ACTIONS(1087),
    [anon_sym_STAR] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_restrict] = ACTIONS(93),
    [anon_sym_volatile] = ACTIONS(93),
    [anon_sym__Atomic] = ACTIONS(93),
    [anon_sym_mutable] = ACTIONS(93),
    [anon_sym_explicit] = ACTIONS(93),
    [anon_sym_constexpr] = ACTIONS(93),
    [anon_sym_unsigned] = ACTIONS(1399),
    [anon_sym_long] = ACTIONS(1399),
    [anon_sym_short] = ACTIONS(1399),
    [sym_primitive_type] = ACTIONS(1401),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(428),
    [anon_sym_union] = ACTIONS(430),
    [anon_sym_AMP] = ACTIONS(1089),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1093),
    [anon_sym_PLUS] = ACTIONS(1095),
    [anon_sym_DASH] = ACTIONS(1095),
    [anon_sym_DASH_DASH] = ACTIONS(1097),
    [anon_sym_PLUS_PLUS] = ACTIONS(1097),
    [anon_sym_sizeof] = ACTIONS(1099),
    [sym_number_literal] = ACTIONS(1397),
    [sym_char_literal] = ACTIONS(1397),
    [sym_string_literal] = ACTIONS(1101),
    [sym_true] = ACTIONS(1403),
    [sym_false] = ACTIONS(1403),
    [sym_null] = ACTIONS(1403),
    [sym_identifier] = ACTIONS(1405),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(436),
    [sym_auto] = ACTIONS(1401),
    [anon_sym_typename] = ACTIONS(1407),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1409),
    [anon_sym_delete] = ACTIONS(1109),
    [sym_nullptr] = ACTIONS(1403),
  },
  [729] = {
    [sym__expression] = STATE(727),
    [sym_conditional_expression] = STATE(727),
    [sym_assignment_expression] = STATE(727),
    [sym_pointer_expression] = STATE(727),
    [sym_logical_expression] = STATE(727),
    [sym_bitwise_expression] = STATE(727),
    [sym_equality_expression] = STATE(727),
    [sym_relational_expression] = STATE(727),
    [sym_shift_expression] = STATE(727),
    [sym_math_expression] = STATE(727),
    [sym_cast_expression] = STATE(727),
    [sym_sizeof_expression] = STATE(727),
    [sym_subscript_expression] = STATE(727),
    [sym_call_expression] = STATE(727),
    [sym_field_expression] = STATE(727),
    [sym_compound_literal_expression] = STATE(727),
    [sym_parenthesized_expression] = STATE(727),
    [sym_concatenated_string] = STATE(727),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(727),
    [sym_new_expression] = STATE(727),
    [sym_delete_expression] = STATE(727),
    [sym_lambda_expression] = STATE(727),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(1411),
    [anon_sym_LPAREN] = ACTIONS(1419),
    [anon_sym_STAR] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_AMP] = ACTIONS(1421),
    [anon_sym_BANG] = ACTIONS(1429),
    [anon_sym_TILDE] = ACTIONS(1431),
    [anon_sym_PLUS] = ACTIONS(1433),
    [anon_sym_DASH] = ACTIONS(1433),
    [anon_sym_DASH_DASH] = ACTIONS(1435),
    [anon_sym_PLUS_PLUS] = ACTIONS(1435),
    [anon_sym_sizeof] = ACTIONS(1437),
    [sym_number_literal] = ACTIONS(1411),
    [sym_char_literal] = ACTIONS(1411),
    [sym_string_literal] = ACTIONS(1439),
    [sym_true] = ACTIONS(1413),
    [sym_false] = ACTIONS(1413),
    [sym_null] = ACTIONS(1413),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1443),
    [anon_sym_delete] = ACTIONS(1445),
    [sym_nullptr] = ACTIONS(1413),
  },
  [730] = {
    [anon_sym_LPAREN] = ACTIONS(2624),
    [anon_sym_STAR] = ACTIONS(2624),
    [anon_sym_LBRACK] = ACTIONS(2624),
    [anon_sym_AMP] = ACTIONS(2626),
    [anon_sym_AMP_AMP] = ACTIONS(2624),
    [sym_comment] = ACTIONS(49),
  },
  [731] = {
    [anon_sym_RBRACK] = ACTIONS(2628),
    [sym_comment] = ACTIONS(49),
  },
  [732] = {
    [sym__expression] = STATE(727),
    [sym_conditional_expression] = STATE(727),
    [sym_assignment_expression] = STATE(727),
    [sym_pointer_expression] = STATE(727),
    [sym_logical_expression] = STATE(727),
    [sym_bitwise_expression] = STATE(727),
    [sym_equality_expression] = STATE(727),
    [sym_relational_expression] = STATE(727),
    [sym_shift_expression] = STATE(727),
    [sym_math_expression] = STATE(727),
    [sym_cast_expression] = STATE(727),
    [sym_sizeof_expression] = STATE(727),
    [sym_subscript_expression] = STATE(727),
    [sym_call_expression] = STATE(727),
    [sym_field_expression] = STATE(727),
    [sym_compound_literal_expression] = STATE(727),
    [sym_parenthesized_expression] = STATE(727),
    [sym_concatenated_string] = STATE(727),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(727),
    [sym_new_expression] = STATE(727),
    [sym_delete_expression] = STATE(727),
    [sym_lambda_expression] = STATE(727),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(1411),
    [anon_sym_LPAREN] = ACTIONS(1419),
    [anon_sym_STAR] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_RBRACK] = ACTIONS(2628),
    [anon_sym_AMP] = ACTIONS(1421),
    [anon_sym_BANG] = ACTIONS(1429),
    [anon_sym_TILDE] = ACTIONS(1431),
    [anon_sym_PLUS] = ACTIONS(1433),
    [anon_sym_DASH] = ACTIONS(1433),
    [anon_sym_DASH_DASH] = ACTIONS(1435),
    [anon_sym_PLUS_PLUS] = ACTIONS(1435),
    [anon_sym_sizeof] = ACTIONS(1437),
    [sym_number_literal] = ACTIONS(1411),
    [sym_char_literal] = ACTIONS(1411),
    [sym_string_literal] = ACTIONS(1439),
    [sym_true] = ACTIONS(1413),
    [sym_false] = ACTIONS(1413),
    [sym_null] = ACTIONS(1413),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1443),
    [anon_sym_delete] = ACTIONS(1445),
    [sym_nullptr] = ACTIONS(1413),
  },
  [733] = {
    [sym__expression] = STATE(757),
    [sym_conditional_expression] = STATE(757),
    [sym_assignment_expression] = STATE(757),
    [sym_pointer_expression] = STATE(757),
    [sym_logical_expression] = STATE(757),
    [sym_bitwise_expression] = STATE(757),
    [sym_equality_expression] = STATE(757),
    [sym_relational_expression] = STATE(757),
    [sym_shift_expression] = STATE(757),
    [sym_math_expression] = STATE(757),
    [sym_cast_expression] = STATE(757),
    [sym_sizeof_expression] = STATE(757),
    [sym_subscript_expression] = STATE(757),
    [sym_call_expression] = STATE(757),
    [sym_field_expression] = STATE(757),
    [sym_compound_literal_expression] = STATE(757),
    [sym_parenthesized_expression] = STATE(757),
    [sym_concatenated_string] = STATE(757),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(757),
    [sym_new_expression] = STATE(757),
    [sym_delete_expression] = STATE(757),
    [sym_lambda_expression] = STATE(757),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(1459),
    [anon_sym_LPAREN] = ACTIONS(1419),
    [anon_sym_STAR] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_AMP] = ACTIONS(1421),
    [anon_sym_BANG] = ACTIONS(1429),
    [anon_sym_TILDE] = ACTIONS(1431),
    [anon_sym_PLUS] = ACTIONS(1433),
    [anon_sym_DASH] = ACTIONS(1433),
    [anon_sym_DASH_DASH] = ACTIONS(1435),
    [anon_sym_PLUS_PLUS] = ACTIONS(1435),
    [anon_sym_sizeof] = ACTIONS(1437),
    [sym_number_literal] = ACTIONS(1459),
    [sym_char_literal] = ACTIONS(1459),
    [sym_string_literal] = ACTIONS(1439),
    [sym_true] = ACTIONS(1461),
    [sym_false] = ACTIONS(1461),
    [sym_null] = ACTIONS(1461),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1443),
    [anon_sym_delete] = ACTIONS(1445),
    [sym_nullptr] = ACTIONS(1461),
  },
  [734] = {
    [sym__expression] = STATE(758),
    [sym_conditional_expression] = STATE(758),
    [sym_assignment_expression] = STATE(758),
    [sym_pointer_expression] = STATE(758),
    [sym_logical_expression] = STATE(758),
    [sym_bitwise_expression] = STATE(758),
    [sym_equality_expression] = STATE(758),
    [sym_relational_expression] = STATE(758),
    [sym_shift_expression] = STATE(758),
    [sym_math_expression] = STATE(758),
    [sym_cast_expression] = STATE(758),
    [sym_sizeof_expression] = STATE(758),
    [sym_subscript_expression] = STATE(758),
    [sym_call_expression] = STATE(758),
    [sym_field_expression] = STATE(758),
    [sym_compound_literal_expression] = STATE(758),
    [sym_parenthesized_expression] = STATE(758),
    [sym_concatenated_string] = STATE(758),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(758),
    [sym_new_expression] = STATE(758),
    [sym_delete_expression] = STATE(758),
    [sym_lambda_expression] = STATE(758),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(1463),
    [anon_sym_LPAREN] = ACTIONS(1419),
    [anon_sym_STAR] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_AMP] = ACTIONS(1421),
    [anon_sym_BANG] = ACTIONS(1429),
    [anon_sym_TILDE] = ACTIONS(1431),
    [anon_sym_PLUS] = ACTIONS(1433),
    [anon_sym_DASH] = ACTIONS(1433),
    [anon_sym_DASH_DASH] = ACTIONS(1435),
    [anon_sym_PLUS_PLUS] = ACTIONS(1435),
    [anon_sym_sizeof] = ACTIONS(1437),
    [sym_number_literal] = ACTIONS(1463),
    [sym_char_literal] = ACTIONS(1463),
    [sym_string_literal] = ACTIONS(1439),
    [sym_true] = ACTIONS(1465),
    [sym_false] = ACTIONS(1465),
    [sym_null] = ACTIONS(1465),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1443),
    [anon_sym_delete] = ACTIONS(1445),
    [sym_nullptr] = ACTIONS(1465),
  },
  [735] = {
    [sym__expression] = STATE(759),
    [sym_conditional_expression] = STATE(759),
    [sym_assignment_expression] = STATE(759),
    [sym_pointer_expression] = STATE(759),
    [sym_logical_expression] = STATE(759),
    [sym_bitwise_expression] = STATE(759),
    [sym_equality_expression] = STATE(759),
    [sym_relational_expression] = STATE(759),
    [sym_shift_expression] = STATE(759),
    [sym_math_expression] = STATE(759),
    [sym_cast_expression] = STATE(759),
    [sym_sizeof_expression] = STATE(759),
    [sym_subscript_expression] = STATE(759),
    [sym_call_expression] = STATE(759),
    [sym_field_expression] = STATE(759),
    [sym_compound_literal_expression] = STATE(759),
    [sym_parenthesized_expression] = STATE(759),
    [sym_concatenated_string] = STATE(759),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(759),
    [sym_new_expression] = STATE(759),
    [sym_delete_expression] = STATE(759),
    [sym_lambda_expression] = STATE(759),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(1467),
    [anon_sym_LPAREN] = ACTIONS(1419),
    [anon_sym_STAR] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_AMP] = ACTIONS(1421),
    [anon_sym_BANG] = ACTIONS(1429),
    [anon_sym_TILDE] = ACTIONS(1431),
    [anon_sym_PLUS] = ACTIONS(1433),
    [anon_sym_DASH] = ACTIONS(1433),
    [anon_sym_DASH_DASH] = ACTIONS(1435),
    [anon_sym_PLUS_PLUS] = ACTIONS(1435),
    [anon_sym_sizeof] = ACTIONS(1437),
    [sym_number_literal] = ACTIONS(1467),
    [sym_char_literal] = ACTIONS(1467),
    [sym_string_literal] = ACTIONS(1439),
    [sym_true] = ACTIONS(1469),
    [sym_false] = ACTIONS(1469),
    [sym_null] = ACTIONS(1469),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1443),
    [anon_sym_delete] = ACTIONS(1445),
    [sym_nullptr] = ACTIONS(1469),
  },
  [736] = {
    [sym__expression] = STATE(1274),
    [sym_conditional_expression] = STATE(1274),
    [sym_assignment_expression] = STATE(1274),
    [sym_pointer_expression] = STATE(1274),
    [sym_logical_expression] = STATE(1274),
    [sym_bitwise_expression] = STATE(1274),
    [sym_equality_expression] = STATE(1274),
    [sym_relational_expression] = STATE(1274),
    [sym_shift_expression] = STATE(1274),
    [sym_math_expression] = STATE(1274),
    [sym_cast_expression] = STATE(1274),
    [sym_sizeof_expression] = STATE(1274),
    [sym_subscript_expression] = STATE(1274),
    [sym_call_expression] = STATE(1274),
    [sym_field_expression] = STATE(1274),
    [sym_compound_literal_expression] = STATE(1274),
    [sym_parenthesized_expression] = STATE(1274),
    [sym_concatenated_string] = STATE(1274),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(1274),
    [sym_new_expression] = STATE(1274),
    [sym_delete_expression] = STATE(1274),
    [sym_lambda_expression] = STATE(1274),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(2630),
    [anon_sym_LPAREN] = ACTIONS(2632),
    [anon_sym_STAR] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_AMP] = ACTIONS(1421),
    [anon_sym_BANG] = ACTIONS(1429),
    [anon_sym_TILDE] = ACTIONS(1431),
    [anon_sym_PLUS] = ACTIONS(1433),
    [anon_sym_DASH] = ACTIONS(1433),
    [anon_sym_DASH_DASH] = ACTIONS(1435),
    [anon_sym_PLUS_PLUS] = ACTIONS(1435),
    [anon_sym_sizeof] = ACTIONS(1437),
    [sym_number_literal] = ACTIONS(2630),
    [sym_char_literal] = ACTIONS(2630),
    [sym_string_literal] = ACTIONS(1439),
    [sym_true] = ACTIONS(2634),
    [sym_false] = ACTIONS(2634),
    [sym_null] = ACTIONS(2634),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1443),
    [anon_sym_delete] = ACTIONS(1445),
    [sym_nullptr] = ACTIONS(2634),
  },
  [737] = {
    [aux_sym_concatenated_string_repeat1] = STATE(1275),
    [anon_sym_LPAREN] = ACTIONS(1477),
    [anon_sym_COMMA] = ACTIONS(1477),
    [anon_sym_STAR] = ACTIONS(1479),
    [anon_sym_LBRACK] = ACTIONS(1477),
    [anon_sym_RBRACK] = ACTIONS(1477),
    [anon_sym_EQ] = ACTIONS(1479),
    [anon_sym_QMARK] = ACTIONS(1477),
    [anon_sym_STAR_EQ] = ACTIONS(1477),
    [anon_sym_SLASH_EQ] = ACTIONS(1477),
    [anon_sym_PERCENT_EQ] = ACTIONS(1477),
    [anon_sym_PLUS_EQ] = ACTIONS(1477),
    [anon_sym_DASH_EQ] = ACTIONS(1477),
    [anon_sym_LT_LT_EQ] = ACTIONS(1477),
    [anon_sym_GT_GT_EQ] = ACTIONS(1477),
    [anon_sym_AMP_EQ] = ACTIONS(1477),
    [anon_sym_CARET_EQ] = ACTIONS(1477),
    [anon_sym_PIPE_EQ] = ACTIONS(1477),
    [anon_sym_AMP] = ACTIONS(1479),
    [anon_sym_PIPE_PIPE] = ACTIONS(1477),
    [anon_sym_AMP_AMP] = ACTIONS(1477),
    [anon_sym_PIPE] = ACTIONS(1479),
    [anon_sym_CARET] = ACTIONS(1479),
    [anon_sym_EQ_EQ] = ACTIONS(1477),
    [anon_sym_BANG_EQ] = ACTIONS(1477),
    [anon_sym_LT] = ACTIONS(1479),
    [anon_sym_GT] = ACTIONS(1479),
    [anon_sym_LT_EQ] = ACTIONS(1477),
    [anon_sym_GT_EQ] = ACTIONS(1477),
    [anon_sym_LT_LT] = ACTIONS(1479),
    [anon_sym_GT_GT] = ACTIONS(1479),
    [anon_sym_PLUS] = ACTIONS(1479),
    [anon_sym_DASH] = ACTIONS(1479),
    [anon_sym_SLASH] = ACTIONS(1479),
    [anon_sym_PERCENT] = ACTIONS(1479),
    [anon_sym_DASH_DASH] = ACTIONS(1477),
    [anon_sym_PLUS_PLUS] = ACTIONS(1477),
    [anon_sym_DOT] = ACTIONS(1477),
    [anon_sym_DASH_GT] = ACTIONS(1477),
    [sym_string_literal] = ACTIONS(2636),
    [sym_comment] = ACTIONS(49),
  },
  [738] = {
    [sym_destructor_name] = STATE(120),
    [anon_sym_TILDE] = ACTIONS(1500),
    [sym_identifier] = ACTIONS(2220),
    [sym_comment] = ACTIONS(49),
    [anon_sym_delete] = ACTIONS(2638),
    [sym_operator_name] = ACTIONS(190),
  },
  [739] = {
    [sym__expression] = STATE(1278),
    [sym_conditional_expression] = STATE(1278),
    [sym_assignment_expression] = STATE(1278),
    [sym_pointer_expression] = STATE(1278),
    [sym_logical_expression] = STATE(1278),
    [sym_bitwise_expression] = STATE(1278),
    [sym_equality_expression] = STATE(1278),
    [sym_relational_expression] = STATE(1278),
    [sym_shift_expression] = STATE(1278),
    [sym_math_expression] = STATE(1278),
    [sym_cast_expression] = STATE(1278),
    [sym_sizeof_expression] = STATE(1278),
    [sym_subscript_expression] = STATE(1278),
    [sym_call_expression] = STATE(1278),
    [sym_field_expression] = STATE(1278),
    [sym_compound_literal_expression] = STATE(1278),
    [sym_parenthesized_expression] = STATE(1278),
    [sym_concatenated_string] = STATE(1278),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(1278),
    [sym_new_expression] = STATE(1278),
    [sym_delete_expression] = STATE(1278),
    [sym_lambda_expression] = STATE(1278),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(2640),
    [anon_sym_LPAREN] = ACTIONS(1419),
    [anon_sym_STAR] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(2642),
    [anon_sym_AMP] = ACTIONS(1421),
    [anon_sym_BANG] = ACTIONS(1429),
    [anon_sym_TILDE] = ACTIONS(1431),
    [anon_sym_PLUS] = ACTIONS(1433),
    [anon_sym_DASH] = ACTIONS(1433),
    [anon_sym_DASH_DASH] = ACTIONS(1435),
    [anon_sym_PLUS_PLUS] = ACTIONS(1435),
    [anon_sym_sizeof] = ACTIONS(1437),
    [sym_number_literal] = ACTIONS(2640),
    [sym_char_literal] = ACTIONS(2640),
    [sym_string_literal] = ACTIONS(1439),
    [sym_true] = ACTIONS(2644),
    [sym_false] = ACTIONS(2644),
    [sym_null] = ACTIONS(2644),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1443),
    [anon_sym_delete] = ACTIONS(1445),
    [sym_nullptr] = ACTIONS(2644),
  },
  [740] = {
    [sym_argument_list] = STATE(802),
    [aux_sym_for_statement_repeat1] = STATE(1293),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_COMMA] = ACTIONS(2646),
    [anon_sym_STAR] = ACTIONS(2648),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_RBRACK] = ACTIONS(2650),
    [anon_sym_EQ] = ACTIONS(2652),
    [anon_sym_QMARK] = ACTIONS(2654),
    [anon_sym_STAR_EQ] = ACTIONS(2656),
    [anon_sym_SLASH_EQ] = ACTIONS(2656),
    [anon_sym_PERCENT_EQ] = ACTIONS(2656),
    [anon_sym_PLUS_EQ] = ACTIONS(2656),
    [anon_sym_DASH_EQ] = ACTIONS(2656),
    [anon_sym_LT_LT_EQ] = ACTIONS(2656),
    [anon_sym_GT_GT_EQ] = ACTIONS(2656),
    [anon_sym_AMP_EQ] = ACTIONS(2656),
    [anon_sym_CARET_EQ] = ACTIONS(2656),
    [anon_sym_PIPE_EQ] = ACTIONS(2656),
    [anon_sym_AMP] = ACTIONS(2658),
    [anon_sym_PIPE_PIPE] = ACTIONS(2660),
    [anon_sym_AMP_AMP] = ACTIONS(2662),
    [anon_sym_PIPE] = ACTIONS(2664),
    [anon_sym_CARET] = ACTIONS(2666),
    [anon_sym_EQ_EQ] = ACTIONS(2668),
    [anon_sym_BANG_EQ] = ACTIONS(2668),
    [anon_sym_LT] = ACTIONS(2670),
    [anon_sym_GT] = ACTIONS(2670),
    [anon_sym_LT_EQ] = ACTIONS(2672),
    [anon_sym_GT_EQ] = ACTIONS(2672),
    [anon_sym_LT_LT] = ACTIONS(2674),
    [anon_sym_GT_GT] = ACTIONS(2674),
    [anon_sym_PLUS] = ACTIONS(2676),
    [anon_sym_DASH] = ACTIONS(2676),
    [anon_sym_SLASH] = ACTIONS(2648),
    [anon_sym_PERCENT] = ACTIONS(2648),
    [anon_sym_DASH_DASH] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(1554),
    [anon_sym_DASH_GT] = ACTIONS(1554),
    [sym_comment] = ACTIONS(49),
  },
  [741] = {
    [anon_sym_RBRACK] = ACTIONS(2650),
    [sym_comment] = ACTIONS(49),
  },
  [742] = {
    [sym_enumerator] = STATE(1296),
    [anon_sym_COMMA] = ACTIONS(2678),
    [anon_sym_RBRACE] = ACTIONS(2680),
    [sym_identifier] = ACTIONS(348),
    [sym_comment] = ACTIONS(49),
  },
  [743] = {
    [sym_enumerator_list] = STATE(1297),
    [sym_raw_string_literal] = ACTIONS(350),
    [anon_sym_LPAREN] = ACTIONS(350),
    [anon_sym_extern] = ACTIONS(352),
    [anon_sym_LBRACE] = ACTIONS(1449),
    [anon_sym_STAR] = ACTIONS(350),
    [anon_sym_LBRACK] = ACTIONS(350),
    [anon_sym_RBRACK] = ACTIONS(350),
    [anon_sym_static] = ACTIONS(352),
    [anon_sym_register] = ACTIONS(352),
    [anon_sym_inline] = ACTIONS(352),
    [anon_sym_const] = ACTIONS(352),
    [anon_sym_restrict] = ACTIONS(352),
    [anon_sym_volatile] = ACTIONS(352),
    [anon_sym__Atomic] = ACTIONS(352),
    [anon_sym_mutable] = ACTIONS(352),
    [anon_sym_explicit] = ACTIONS(352),
    [anon_sym_constexpr] = ACTIONS(352),
    [anon_sym_AMP] = ACTIONS(350),
    [anon_sym_BANG] = ACTIONS(350),
    [anon_sym_TILDE] = ACTIONS(350),
    [anon_sym_PLUS] = ACTIONS(352),
    [anon_sym_DASH] = ACTIONS(352),
    [anon_sym_DASH_DASH] = ACTIONS(350),
    [anon_sym_PLUS_PLUS] = ACTIONS(350),
    [anon_sym_sizeof] = ACTIONS(352),
    [sym_number_literal] = ACTIONS(350),
    [sym_char_literal] = ACTIONS(350),
    [sym_string_literal] = ACTIONS(350),
    [sym_true] = ACTIONS(352),
    [sym_false] = ACTIONS(352),
    [sym_null] = ACTIONS(352),
    [sym_identifier] = ACTIONS(352),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(352),
    [anon_sym_COLON_COLON] = ACTIONS(350),
    [anon_sym_delete] = ACTIONS(352),
    [sym_nullptr] = ACTIONS(352),
  },
  [744] = {
    [sym_raw_string_literal] = ACTIONS(354),
    [anon_sym_LPAREN] = ACTIONS(354),
    [anon_sym_extern] = ACTIONS(356),
    [anon_sym_STAR] = ACTIONS(354),
    [anon_sym_LBRACK] = ACTIONS(354),
    [anon_sym_RBRACK] = ACTIONS(354),
    [anon_sym_static] = ACTIONS(356),
    [anon_sym_register] = ACTIONS(356),
    [anon_sym_inline] = ACTIONS(356),
    [anon_sym_const] = ACTIONS(356),
    [anon_sym_restrict] = ACTIONS(356),
    [anon_sym_volatile] = ACTIONS(356),
    [anon_sym__Atomic] = ACTIONS(356),
    [anon_sym_mutable] = ACTIONS(356),
    [anon_sym_explicit] = ACTIONS(356),
    [anon_sym_constexpr] = ACTIONS(356),
    [anon_sym_AMP] = ACTIONS(354),
    [anon_sym_BANG] = ACTIONS(354),
    [anon_sym_TILDE] = ACTIONS(354),
    [anon_sym_PLUS] = ACTIONS(356),
    [anon_sym_DASH] = ACTIONS(356),
    [anon_sym_DASH_DASH] = ACTIONS(354),
    [anon_sym_PLUS_PLUS] = ACTIONS(354),
    [anon_sym_sizeof] = ACTIONS(356),
    [sym_number_literal] = ACTIONS(354),
    [sym_char_literal] = ACTIONS(354),
    [sym_string_literal] = ACTIONS(354),
    [sym_true] = ACTIONS(356),
    [sym_false] = ACTIONS(356),
    [sym_null] = ACTIONS(356),
    [sym_identifier] = ACTIONS(356),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(356),
    [anon_sym_COLON_COLON] = ACTIONS(354),
    [anon_sym_delete] = ACTIONS(356),
    [sym_nullptr] = ACTIONS(356),
  },
  [745] = {
    [sym_preproc_if_in_field_declaration_list] = STATE(246),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(247),
    [sym_type_definition] = STATE(1299),
    [sym__declaration_specifiers] = STATE(248),
    [sym__declarator] = STATE(249),
    [sym_pointer_declarator] = STATE(249),
    [sym_function_declarator] = STATE(250),
    [sym_array_declarator] = STATE(249),
    [sym_storage_class_specifier] = STATE(257),
    [sym_type_qualifier] = STATE(257),
    [sym__type_specifier] = STATE(251),
    [sym_sized_type_specifier] = STATE(251),
    [sym_enum_specifier] = STATE(251),
    [sym_struct_specifier] = STATE(251),
    [sym_union_specifier] = STATE(251),
    [sym__field_declaration_list_item] = STATE(1299),
    [sym_field_declaration] = STATE(1299),
    [sym_macro_type_specifier] = STATE(251),
    [sym_class_specifier] = STATE(251),
    [sym_dependent_type] = STATE(251),
    [sym_template_declaration] = STATE(1299),
    [sym_inline_method_definition] = STATE(252),
    [sym_constructor_or_destructor_definition] = STATE(252),
    [sym_constructor_or_destructor_declaration] = STATE(253),
    [sym_friend_declaration] = STATE(1299),
    [sym_access_specifier] = STATE(1299),
    [sym_reference_declarator] = STATE(249),
    [sym_template_type] = STATE(254),
    [sym_template_function] = STATE(249),
    [sym_using_declaration] = STATE(1299),
    [sym_alias_declaration] = STATE(1299),
    [sym_destructor_name] = STATE(249),
    [sym_scoped_identifier] = STATE(33),
    [sym_scoped_type_identifier] = STATE(34),
    [sym_scoped_namespace_identifier] = STATE(255),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(1299),
    [aux_sym__declaration_specifiers_repeat1] = STATE(257),
    [aux_sym_sized_type_specifier_repeat1] = STATE(258),
    [anon_sym_LPAREN] = ACTIONS(11),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(358),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(360),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(362),
    [anon_sym_typedef] = ACTIONS(364),
    [anon_sym_extern] = ACTIONS(27),
    [anon_sym_RBRACE] = ACTIONS(2682),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_static] = ACTIONS(27),
    [anon_sym_register] = ACTIONS(27),
    [anon_sym_inline] = ACTIONS(27),
    [anon_sym_const] = ACTIONS(29),
    [anon_sym_restrict] = ACTIONS(29),
    [anon_sym_volatile] = ACTIONS(29),
    [anon_sym__Atomic] = ACTIONS(29),
    [anon_sym_mutable] = ACTIONS(29),
    [anon_sym_explicit] = ACTIONS(29),
    [anon_sym_constexpr] = ACTIONS(29),
    [anon_sym_unsigned] = ACTIONS(368),
    [anon_sym_long] = ACTIONS(368),
    [anon_sym_short] = ACTIONS(368),
    [sym_primitive_type] = ACTIONS(370),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(372),
    [anon_sym_union] = ACTIONS(374),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(45),
    [sym_identifier] = ACTIONS(376),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(378),
    [anon_sym_public] = ACTIONS(380),
    [sym_auto] = ACTIONS(370),
    [anon_sym_typename] = ACTIONS(382),
    [anon_sym_template] = ACTIONS(384),
    [anon_sym_friend] = ACTIONS(386),
    [anon_sym_private] = ACTIONS(380),
    [anon_sym_protected] = ACTIONS(380),
    [anon_sym_using] = ACTIONS(388),
    [anon_sym_COLON_COLON] = ACTIONS(390),
    [sym_operator_name] = ACTIONS(392),
  },
  [746] = {
    [sym_template_argument_list] = STATE(1301),
    [sym_raw_string_literal] = ACTIONS(398),
    [anon_sym_LPAREN] = ACTIONS(398),
    [anon_sym_extern] = ACTIONS(400),
    [anon_sym_LBRACE] = ACTIONS(398),
    [anon_sym_STAR] = ACTIONS(398),
    [anon_sym_LBRACK] = ACTIONS(398),
    [anon_sym_RBRACK] = ACTIONS(398),
    [anon_sym_static] = ACTIONS(400),
    [anon_sym_register] = ACTIONS(400),
    [anon_sym_inline] = ACTIONS(400),
    [anon_sym_const] = ACTIONS(400),
    [anon_sym_restrict] = ACTIONS(400),
    [anon_sym_volatile] = ACTIONS(400),
    [anon_sym__Atomic] = ACTIONS(400),
    [anon_sym_mutable] = ACTIONS(400),
    [anon_sym_explicit] = ACTIONS(400),
    [anon_sym_constexpr] = ACTIONS(400),
    [anon_sym_COLON] = ACTIONS(400),
    [anon_sym_AMP] = ACTIONS(398),
    [anon_sym_BANG] = ACTIONS(398),
    [anon_sym_TILDE] = ACTIONS(398),
    [anon_sym_LT] = ACTIONS(1567),
    [anon_sym_PLUS] = ACTIONS(400),
    [anon_sym_DASH] = ACTIONS(400),
    [anon_sym_DASH_DASH] = ACTIONS(398),
    [anon_sym_PLUS_PLUS] = ACTIONS(398),
    [anon_sym_sizeof] = ACTIONS(400),
    [sym_number_literal] = ACTIONS(398),
    [sym_char_literal] = ACTIONS(398),
    [sym_string_literal] = ACTIONS(398),
    [sym_true] = ACTIONS(400),
    [sym_false] = ACTIONS(400),
    [sym_null] = ACTIONS(400),
    [sym_identifier] = ACTIONS(400),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(400),
    [anon_sym_COLON_COLON] = ACTIONS(2684),
    [anon_sym_delete] = ACTIONS(400),
    [sym_nullptr] = ACTIONS(400),
  },
  [747] = {
    [sym_identifier] = ACTIONS(2686),
    [sym_comment] = ACTIONS(49),
  },
  [748] = {
    [sym_raw_string_literal] = ACTIONS(406),
    [anon_sym_LPAREN] = ACTIONS(406),
    [anon_sym_extern] = ACTIONS(408),
    [anon_sym_STAR] = ACTIONS(406),
    [anon_sym_LBRACK] = ACTIONS(406),
    [anon_sym_RBRACK] = ACTIONS(406),
    [anon_sym_static] = ACTIONS(408),
    [anon_sym_register] = ACTIONS(408),
    [anon_sym_inline] = ACTIONS(408),
    [anon_sym_const] = ACTIONS(408),
    [anon_sym_restrict] = ACTIONS(408),
    [anon_sym_volatile] = ACTIONS(408),
    [anon_sym__Atomic] = ACTIONS(408),
    [anon_sym_mutable] = ACTIONS(408),
    [anon_sym_explicit] = ACTIONS(408),
    [anon_sym_constexpr] = ACTIONS(408),
    [anon_sym_AMP] = ACTIONS(406),
    [anon_sym_BANG] = ACTIONS(406),
    [anon_sym_TILDE] = ACTIONS(406),
    [anon_sym_PLUS] = ACTIONS(408),
    [anon_sym_DASH] = ACTIONS(408),
    [anon_sym_DASH_DASH] = ACTIONS(406),
    [anon_sym_PLUS_PLUS] = ACTIONS(406),
    [anon_sym_sizeof] = ACTIONS(408),
    [sym_number_literal] = ACTIONS(406),
    [sym_char_literal] = ACTIONS(406),
    [sym_string_literal] = ACTIONS(406),
    [sym_true] = ACTIONS(408),
    [sym_false] = ACTIONS(408),
    [sym_null] = ACTIONS(408),
    [sym_identifier] = ACTIONS(408),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(408),
    [anon_sym_COLON_COLON] = ACTIONS(406),
    [anon_sym_delete] = ACTIONS(408),
    [sym_nullptr] = ACTIONS(408),
  },
  [749] = {
    [sym_field_declaration_list] = STATE(1303),
    [sym_base_class_clause] = STATE(1304),
    [sym_raw_string_literal] = ACTIONS(406),
    [anon_sym_LPAREN] = ACTIONS(406),
    [anon_sym_extern] = ACTIONS(408),
    [anon_sym_LBRACE] = ACTIONS(1453),
    [anon_sym_STAR] = ACTIONS(406),
    [anon_sym_LBRACK] = ACTIONS(406),
    [anon_sym_RBRACK] = ACTIONS(406),
    [anon_sym_static] = ACTIONS(408),
    [anon_sym_register] = ACTIONS(408),
    [anon_sym_inline] = ACTIONS(408),
    [anon_sym_const] = ACTIONS(408),
    [anon_sym_restrict] = ACTIONS(408),
    [anon_sym_volatile] = ACTIONS(408),
    [anon_sym__Atomic] = ACTIONS(408),
    [anon_sym_mutable] = ACTIONS(408),
    [anon_sym_explicit] = ACTIONS(408),
    [anon_sym_constexpr] = ACTIONS(408),
    [anon_sym_COLON] = ACTIONS(131),
    [anon_sym_AMP] = ACTIONS(406),
    [anon_sym_BANG] = ACTIONS(406),
    [anon_sym_TILDE] = ACTIONS(406),
    [anon_sym_PLUS] = ACTIONS(408),
    [anon_sym_DASH] = ACTIONS(408),
    [anon_sym_DASH_DASH] = ACTIONS(406),
    [anon_sym_PLUS_PLUS] = ACTIONS(406),
    [anon_sym_sizeof] = ACTIONS(408),
    [sym_number_literal] = ACTIONS(406),
    [sym_char_literal] = ACTIONS(406),
    [sym_string_literal] = ACTIONS(406),
    [sym_true] = ACTIONS(408),
    [sym_false] = ACTIONS(408),
    [sym_null] = ACTIONS(408),
    [sym_identifier] = ACTIONS(408),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(408),
    [anon_sym_COLON_COLON] = ACTIONS(406),
    [anon_sym_delete] = ACTIONS(408),
    [sym_nullptr] = ACTIONS(408),
  },
  [750] = {
    [sym_field_declaration_list] = STATE(1303),
    [anon_sym_LBRACE] = ACTIONS(1453),
    [sym_comment] = ACTIONS(49),
  },
  [751] = {
    [sym_raw_string_literal] = ACTIONS(410),
    [anon_sym_LPAREN] = ACTIONS(410),
    [anon_sym_extern] = ACTIONS(412),
    [anon_sym_LBRACE] = ACTIONS(410),
    [anon_sym_STAR] = ACTIONS(410),
    [anon_sym_LBRACK] = ACTIONS(410),
    [anon_sym_RBRACK] = ACTIONS(410),
    [anon_sym_static] = ACTIONS(412),
    [anon_sym_register] = ACTIONS(412),
    [anon_sym_inline] = ACTIONS(412),
    [anon_sym_const] = ACTIONS(412),
    [anon_sym_restrict] = ACTIONS(412),
    [anon_sym_volatile] = ACTIONS(412),
    [anon_sym__Atomic] = ACTIONS(412),
    [anon_sym_mutable] = ACTIONS(412),
    [anon_sym_explicit] = ACTIONS(412),
    [anon_sym_constexpr] = ACTIONS(412),
    [anon_sym_COLON] = ACTIONS(412),
    [anon_sym_AMP] = ACTIONS(410),
    [anon_sym_BANG] = ACTIONS(410),
    [anon_sym_TILDE] = ACTIONS(410),
    [anon_sym_PLUS] = ACTIONS(412),
    [anon_sym_DASH] = ACTIONS(412),
    [anon_sym_DASH_DASH] = ACTIONS(410),
    [anon_sym_PLUS_PLUS] = ACTIONS(410),
    [anon_sym_sizeof] = ACTIONS(412),
    [sym_number_literal] = ACTIONS(410),
    [sym_char_literal] = ACTIONS(410),
    [sym_string_literal] = ACTIONS(410),
    [sym_true] = ACTIONS(412),
    [sym_false] = ACTIONS(412),
    [sym_null] = ACTIONS(412),
    [sym_identifier] = ACTIONS(412),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(412),
    [anon_sym_COLON_COLON] = ACTIONS(2688),
    [anon_sym_delete] = ACTIONS(412),
    [sym_nullptr] = ACTIONS(412),
  },
  [752] = {
    [sym_template_argument_list] = STATE(812),
    [sym_raw_string_literal] = ACTIONS(410),
    [anon_sym_LPAREN] = ACTIONS(410),
    [anon_sym_extern] = ACTIONS(412),
    [anon_sym_LBRACE] = ACTIONS(410),
    [anon_sym_STAR] = ACTIONS(410),
    [anon_sym_LBRACK] = ACTIONS(410),
    [anon_sym_RBRACK] = ACTIONS(410),
    [anon_sym_static] = ACTIONS(412),
    [anon_sym_register] = ACTIONS(412),
    [anon_sym_inline] = ACTIONS(412),
    [anon_sym_const] = ACTIONS(412),
    [anon_sym_restrict] = ACTIONS(412),
    [anon_sym_volatile] = ACTIONS(412),
    [anon_sym__Atomic] = ACTIONS(412),
    [anon_sym_mutable] = ACTIONS(412),
    [anon_sym_explicit] = ACTIONS(412),
    [anon_sym_constexpr] = ACTIONS(412),
    [anon_sym_COLON] = ACTIONS(412),
    [anon_sym_AMP] = ACTIONS(410),
    [anon_sym_BANG] = ACTIONS(410),
    [anon_sym_TILDE] = ACTIONS(410),
    [anon_sym_LT] = ACTIONS(1567),
    [anon_sym_PLUS] = ACTIONS(412),
    [anon_sym_DASH] = ACTIONS(412),
    [anon_sym_DASH_DASH] = ACTIONS(410),
    [anon_sym_PLUS_PLUS] = ACTIONS(410),
    [anon_sym_sizeof] = ACTIONS(412),
    [sym_number_literal] = ACTIONS(410),
    [sym_char_literal] = ACTIONS(410),
    [sym_string_literal] = ACTIONS(410),
    [sym_true] = ACTIONS(412),
    [sym_false] = ACTIONS(412),
    [sym_null] = ACTIONS(412),
    [sym_identifier] = ACTIONS(412),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(412),
    [anon_sym_COLON_COLON] = ACTIONS(410),
    [anon_sym_delete] = ACTIONS(412),
    [sym_nullptr] = ACTIONS(412),
  },
  [753] = {
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(2688),
  },
  [754] = {
    [sym_raw_string_literal] = ACTIONS(416),
    [anon_sym_LPAREN] = ACTIONS(416),
    [anon_sym_extern] = ACTIONS(418),
    [anon_sym_STAR] = ACTIONS(416),
    [anon_sym_LBRACK] = ACTIONS(416),
    [anon_sym_RBRACK] = ACTIONS(416),
    [anon_sym_static] = ACTIONS(418),
    [anon_sym_register] = ACTIONS(418),
    [anon_sym_inline] = ACTIONS(418),
    [anon_sym_const] = ACTIONS(418),
    [anon_sym_restrict] = ACTIONS(418),
    [anon_sym_volatile] = ACTIONS(418),
    [anon_sym__Atomic] = ACTIONS(418),
    [anon_sym_mutable] = ACTIONS(418),
    [anon_sym_explicit] = ACTIONS(418),
    [anon_sym_constexpr] = ACTIONS(418),
    [anon_sym_AMP] = ACTIONS(416),
    [anon_sym_BANG] = ACTIONS(416),
    [anon_sym_TILDE] = ACTIONS(416),
    [anon_sym_PLUS] = ACTIONS(418),
    [anon_sym_DASH] = ACTIONS(418),
    [anon_sym_DASH_DASH] = ACTIONS(416),
    [anon_sym_PLUS_PLUS] = ACTIONS(416),
    [anon_sym_sizeof] = ACTIONS(418),
    [sym_number_literal] = ACTIONS(416),
    [sym_char_literal] = ACTIONS(416),
    [sym_string_literal] = ACTIONS(416),
    [sym_true] = ACTIONS(418),
    [sym_false] = ACTIONS(418),
    [sym_null] = ACTIONS(418),
    [sym_identifier] = ACTIONS(418),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(418),
    [anon_sym_COLON_COLON] = ACTIONS(416),
    [anon_sym_delete] = ACTIONS(418),
    [sym_nullptr] = ACTIONS(418),
  },
  [755] = {
    [sym_field_declaration_list] = STATE(1306),
    [sym_base_class_clause] = STATE(1307),
    [sym_raw_string_literal] = ACTIONS(416),
    [anon_sym_LPAREN] = ACTIONS(416),
    [anon_sym_extern] = ACTIONS(418),
    [anon_sym_LBRACE] = ACTIONS(1453),
    [anon_sym_STAR] = ACTIONS(416),
    [anon_sym_LBRACK] = ACTIONS(416),
    [anon_sym_RBRACK] = ACTIONS(416),
    [anon_sym_static] = ACTIONS(418),
    [anon_sym_register] = ACTIONS(418),
    [anon_sym_inline] = ACTIONS(418),
    [anon_sym_const] = ACTIONS(418),
    [anon_sym_restrict] = ACTIONS(418),
    [anon_sym_volatile] = ACTIONS(418),
    [anon_sym__Atomic] = ACTIONS(418),
    [anon_sym_mutable] = ACTIONS(418),
    [anon_sym_explicit] = ACTIONS(418),
    [anon_sym_constexpr] = ACTIONS(418),
    [anon_sym_COLON] = ACTIONS(131),
    [anon_sym_AMP] = ACTIONS(416),
    [anon_sym_BANG] = ACTIONS(416),
    [anon_sym_TILDE] = ACTIONS(416),
    [anon_sym_PLUS] = ACTIONS(418),
    [anon_sym_DASH] = ACTIONS(418),
    [anon_sym_DASH_DASH] = ACTIONS(416),
    [anon_sym_PLUS_PLUS] = ACTIONS(416),
    [anon_sym_sizeof] = ACTIONS(418),
    [sym_number_literal] = ACTIONS(416),
    [sym_char_literal] = ACTIONS(416),
    [sym_string_literal] = ACTIONS(416),
    [sym_true] = ACTIONS(418),
    [sym_false] = ACTIONS(418),
    [sym_null] = ACTIONS(418),
    [sym_identifier] = ACTIONS(418),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(418),
    [anon_sym_COLON_COLON] = ACTIONS(416),
    [anon_sym_delete] = ACTIONS(418),
    [sym_nullptr] = ACTIONS(418),
  },
  [756] = {
    [sym_field_declaration_list] = STATE(1306),
    [anon_sym_LBRACE] = ACTIONS(1453),
    [sym_comment] = ACTIONS(49),
  },
  [757] = {
    [sym_argument_list] = STATE(802),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_COMMA] = ACTIONS(2690),
    [anon_sym_RPAREN] = ACTIONS(2690),
    [anon_sym_SEMI] = ACTIONS(2690),
    [anon_sym_RBRACE] = ACTIONS(2690),
    [anon_sym_STAR] = ACTIONS(2692),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_RBRACK] = ACTIONS(2690),
    [anon_sym_EQ] = ACTIONS(2692),
    [anon_sym_QMARK] = ACTIONS(2690),
    [anon_sym_STAR_EQ] = ACTIONS(2690),
    [anon_sym_SLASH_EQ] = ACTIONS(2690),
    [anon_sym_PERCENT_EQ] = ACTIONS(2690),
    [anon_sym_PLUS_EQ] = ACTIONS(2690),
    [anon_sym_DASH_EQ] = ACTIONS(2690),
    [anon_sym_LT_LT_EQ] = ACTIONS(2690),
    [anon_sym_GT_GT_EQ] = ACTIONS(2690),
    [anon_sym_AMP_EQ] = ACTIONS(2690),
    [anon_sym_CARET_EQ] = ACTIONS(2690),
    [anon_sym_PIPE_EQ] = ACTIONS(2690),
    [anon_sym_AMP] = ACTIONS(2692),
    [anon_sym_PIPE_PIPE] = ACTIONS(2690),
    [anon_sym_AMP_AMP] = ACTIONS(2690),
    [anon_sym_PIPE] = ACTIONS(2692),
    [anon_sym_CARET] = ACTIONS(2692),
    [anon_sym_EQ_EQ] = ACTIONS(2690),
    [anon_sym_BANG_EQ] = ACTIONS(2690),
    [anon_sym_LT] = ACTIONS(2692),
    [anon_sym_GT] = ACTIONS(2692),
    [anon_sym_LT_EQ] = ACTIONS(2690),
    [anon_sym_GT_EQ] = ACTIONS(2690),
    [anon_sym_LT_LT] = ACTIONS(2692),
    [anon_sym_GT_GT] = ACTIONS(2692),
    [anon_sym_PLUS] = ACTIONS(2692),
    [anon_sym_DASH] = ACTIONS(2692),
    [anon_sym_SLASH] = ACTIONS(2692),
    [anon_sym_PERCENT] = ACTIONS(2692),
    [anon_sym_DASH_DASH] = ACTIONS(2690),
    [anon_sym_PLUS_PLUS] = ACTIONS(2690),
    [anon_sym_DOT] = ACTIONS(1554),
    [anon_sym_DASH_GT] = ACTIONS(1554),
    [sym_comment] = ACTIONS(49),
  },
  [758] = {
    [sym_argument_list] = STATE(802),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_COMMA] = ACTIONS(2694),
    [anon_sym_RPAREN] = ACTIONS(2694),
    [anon_sym_SEMI] = ACTIONS(2694),
    [anon_sym_RBRACE] = ACTIONS(2694),
    [anon_sym_STAR] = ACTIONS(2696),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_RBRACK] = ACTIONS(2694),
    [anon_sym_EQ] = ACTIONS(2696),
    [anon_sym_QMARK] = ACTIONS(2694),
    [anon_sym_STAR_EQ] = ACTIONS(2694),
    [anon_sym_SLASH_EQ] = ACTIONS(2694),
    [anon_sym_PERCENT_EQ] = ACTIONS(2694),
    [anon_sym_PLUS_EQ] = ACTIONS(2694),
    [anon_sym_DASH_EQ] = ACTIONS(2694),
    [anon_sym_LT_LT_EQ] = ACTIONS(2694),
    [anon_sym_GT_GT_EQ] = ACTIONS(2694),
    [anon_sym_AMP_EQ] = ACTIONS(2694),
    [anon_sym_CARET_EQ] = ACTIONS(2694),
    [anon_sym_PIPE_EQ] = ACTIONS(2694),
    [anon_sym_AMP] = ACTIONS(2696),
    [anon_sym_PIPE_PIPE] = ACTIONS(2694),
    [anon_sym_AMP_AMP] = ACTIONS(2694),
    [anon_sym_PIPE] = ACTIONS(2696),
    [anon_sym_CARET] = ACTIONS(2696),
    [anon_sym_EQ_EQ] = ACTIONS(2694),
    [anon_sym_BANG_EQ] = ACTIONS(2694),
    [anon_sym_LT] = ACTIONS(2696),
    [anon_sym_GT] = ACTIONS(2696),
    [anon_sym_LT_EQ] = ACTIONS(2694),
    [anon_sym_GT_EQ] = ACTIONS(2694),
    [anon_sym_LT_LT] = ACTIONS(2696),
    [anon_sym_GT_GT] = ACTIONS(2696),
    [anon_sym_PLUS] = ACTIONS(2696),
    [anon_sym_DASH] = ACTIONS(2696),
    [anon_sym_SLASH] = ACTIONS(2696),
    [anon_sym_PERCENT] = ACTIONS(2696),
    [anon_sym_DASH_DASH] = ACTIONS(2694),
    [anon_sym_PLUS_PLUS] = ACTIONS(2694),
    [anon_sym_DOT] = ACTIONS(1554),
    [anon_sym_DASH_GT] = ACTIONS(1554),
    [sym_comment] = ACTIONS(49),
  },
  [759] = {
    [sym_argument_list] = STATE(802),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_COMMA] = ACTIONS(2698),
    [anon_sym_RPAREN] = ACTIONS(2698),
    [anon_sym_SEMI] = ACTIONS(2698),
    [anon_sym_RBRACE] = ACTIONS(2698),
    [anon_sym_STAR] = ACTIONS(2700),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_RBRACK] = ACTIONS(2698),
    [anon_sym_EQ] = ACTIONS(2700),
    [anon_sym_QMARK] = ACTIONS(2698),
    [anon_sym_STAR_EQ] = ACTIONS(2698),
    [anon_sym_SLASH_EQ] = ACTIONS(2698),
    [anon_sym_PERCENT_EQ] = ACTIONS(2698),
    [anon_sym_PLUS_EQ] = ACTIONS(2698),
    [anon_sym_DASH_EQ] = ACTIONS(2698),
    [anon_sym_LT_LT_EQ] = ACTIONS(2698),
    [anon_sym_GT_GT_EQ] = ACTIONS(2698),
    [anon_sym_AMP_EQ] = ACTIONS(2698),
    [anon_sym_CARET_EQ] = ACTIONS(2698),
    [anon_sym_PIPE_EQ] = ACTIONS(2698),
    [anon_sym_AMP] = ACTIONS(2700),
    [anon_sym_PIPE_PIPE] = ACTIONS(2698),
    [anon_sym_AMP_AMP] = ACTIONS(2698),
    [anon_sym_PIPE] = ACTIONS(2700),
    [anon_sym_CARET] = ACTIONS(2700),
    [anon_sym_EQ_EQ] = ACTIONS(2698),
    [anon_sym_BANG_EQ] = ACTIONS(2698),
    [anon_sym_LT] = ACTIONS(2700),
    [anon_sym_GT] = ACTIONS(2700),
    [anon_sym_LT_EQ] = ACTIONS(2698),
    [anon_sym_GT_EQ] = ACTIONS(2698),
    [anon_sym_LT_LT] = ACTIONS(2700),
    [anon_sym_GT_GT] = ACTIONS(2700),
    [anon_sym_PLUS] = ACTIONS(2700),
    [anon_sym_DASH] = ACTIONS(2700),
    [anon_sym_SLASH] = ACTIONS(2700),
    [anon_sym_PERCENT] = ACTIONS(2700),
    [anon_sym_DASH_DASH] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(1554),
    [anon_sym_DASH_GT] = ACTIONS(1554),
    [sym_comment] = ACTIONS(49),
  },
  [760] = {
    [sym_type_qualifier] = STATE(724),
    [sym__type_specifier] = STATE(720),
    [sym_sized_type_specifier] = STATE(720),
    [sym_enum_specifier] = STATE(720),
    [sym_struct_specifier] = STATE(720),
    [sym_union_specifier] = STATE(720),
    [sym__expression] = STATE(721),
    [sym_comma_expression] = STATE(722),
    [sym_conditional_expression] = STATE(721),
    [sym_assignment_expression] = STATE(721),
    [sym_pointer_expression] = STATE(721),
    [sym_logical_expression] = STATE(721),
    [sym_bitwise_expression] = STATE(721),
    [sym_equality_expression] = STATE(721),
    [sym_relational_expression] = STATE(721),
    [sym_shift_expression] = STATE(721),
    [sym_math_expression] = STATE(721),
    [sym_cast_expression] = STATE(721),
    [sym_type_descriptor] = STATE(1308),
    [sym_sizeof_expression] = STATE(721),
    [sym_subscript_expression] = STATE(721),
    [sym_call_expression] = STATE(721),
    [sym_field_expression] = STATE(721),
    [sym_compound_literal_expression] = STATE(721),
    [sym_parenthesized_expression] = STATE(721),
    [sym_concatenated_string] = STATE(721),
    [sym_macro_type_specifier] = STATE(720),
    [sym_class_specifier] = STATE(720),
    [sym_dependent_type] = STATE(720),
    [sym_template_type] = STATE(415),
    [sym_template_function] = STATE(721),
    [sym_new_expression] = STATE(721),
    [sym_delete_expression] = STATE(721),
    [sym_lambda_expression] = STATE(721),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(416),
    [sym_scoped_namespace_identifier] = STATE(417),
    [aux_sym_type_definition_repeat1] = STATE(724),
    [aux_sym_sized_type_specifier_repeat1] = STATE(725),
    [sym_raw_string_literal] = ACTIONS(1397),
    [anon_sym_LPAREN] = ACTIONS(1087),
    [anon_sym_STAR] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_restrict] = ACTIONS(93),
    [anon_sym_volatile] = ACTIONS(93),
    [anon_sym__Atomic] = ACTIONS(93),
    [anon_sym_mutable] = ACTIONS(93),
    [anon_sym_explicit] = ACTIONS(93),
    [anon_sym_constexpr] = ACTIONS(93),
    [anon_sym_unsigned] = ACTIONS(1399),
    [anon_sym_long] = ACTIONS(1399),
    [anon_sym_short] = ACTIONS(1399),
    [sym_primitive_type] = ACTIONS(1401),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(428),
    [anon_sym_union] = ACTIONS(430),
    [anon_sym_AMP] = ACTIONS(1089),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1093),
    [anon_sym_PLUS] = ACTIONS(1095),
    [anon_sym_DASH] = ACTIONS(1095),
    [anon_sym_DASH_DASH] = ACTIONS(1097),
    [anon_sym_PLUS_PLUS] = ACTIONS(1097),
    [anon_sym_sizeof] = ACTIONS(1099),
    [sym_number_literal] = ACTIONS(1397),
    [sym_char_literal] = ACTIONS(1397),
    [sym_string_literal] = ACTIONS(1101),
    [sym_true] = ACTIONS(1403),
    [sym_false] = ACTIONS(1403),
    [sym_null] = ACTIONS(1403),
    [sym_identifier] = ACTIONS(1405),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(436),
    [sym_auto] = ACTIONS(1401),
    [anon_sym_typename] = ACTIONS(1407),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1409),
    [anon_sym_delete] = ACTIONS(1109),
    [sym_nullptr] = ACTIONS(1403),
  },
  [761] = {
    [sym_argument_list] = STATE(802),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_STAR] = ACTIONS(1522),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_RBRACK] = ACTIONS(2702),
    [anon_sym_EQ] = ACTIONS(2704),
    [anon_sym_QMARK] = ACTIONS(2702),
    [anon_sym_STAR_EQ] = ACTIONS(2702),
    [anon_sym_SLASH_EQ] = ACTIONS(2702),
    [anon_sym_PERCENT_EQ] = ACTIONS(2702),
    [anon_sym_PLUS_EQ] = ACTIONS(2702),
    [anon_sym_DASH_EQ] = ACTIONS(2702),
    [anon_sym_LT_LT_EQ] = ACTIONS(2702),
    [anon_sym_GT_GT_EQ] = ACTIONS(2702),
    [anon_sym_AMP_EQ] = ACTIONS(2702),
    [anon_sym_CARET_EQ] = ACTIONS(2702),
    [anon_sym_PIPE_EQ] = ACTIONS(2702),
    [anon_sym_AMP] = ACTIONS(2704),
    [anon_sym_PIPE_PIPE] = ACTIONS(2702),
    [anon_sym_AMP_AMP] = ACTIONS(2702),
    [anon_sym_PIPE] = ACTIONS(2704),
    [anon_sym_CARET] = ACTIONS(2704),
    [anon_sym_EQ_EQ] = ACTIONS(2702),
    [anon_sym_BANG_EQ] = ACTIONS(2702),
    [anon_sym_LT] = ACTIONS(2704),
    [anon_sym_GT] = ACTIONS(2704),
    [anon_sym_LT_EQ] = ACTIONS(2702),
    [anon_sym_GT_EQ] = ACTIONS(2702),
    [anon_sym_LT_LT] = ACTIONS(1548),
    [anon_sym_GT_GT] = ACTIONS(1548),
    [anon_sym_PLUS] = ACTIONS(1550),
    [anon_sym_DASH] = ACTIONS(1550),
    [anon_sym_SLASH] = ACTIONS(1522),
    [anon_sym_PERCENT] = ACTIONS(1522),
    [anon_sym_DASH_DASH] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(1554),
    [anon_sym_DASH_GT] = ACTIONS(1554),
    [sym_comment] = ACTIONS(49),
  },
  [762] = {
    [aux_sym_concatenated_string_repeat1] = STATE(1309),
    [anon_sym_LPAREN] = ACTIONS(2706),
    [anon_sym_STAR] = ACTIONS(2708),
    [anon_sym_LBRACK] = ACTIONS(2706),
    [anon_sym_RBRACK] = ACTIONS(2706),
    [anon_sym_EQ] = ACTIONS(2708),
    [anon_sym_QMARK] = ACTIONS(2706),
    [anon_sym_STAR_EQ] = ACTIONS(2706),
    [anon_sym_SLASH_EQ] = ACTIONS(2706),
    [anon_sym_PERCENT_EQ] = ACTIONS(2706),
    [anon_sym_PLUS_EQ] = ACTIONS(2706),
    [anon_sym_DASH_EQ] = ACTIONS(2706),
    [anon_sym_LT_LT_EQ] = ACTIONS(2706),
    [anon_sym_GT_GT_EQ] = ACTIONS(2706),
    [anon_sym_AMP_EQ] = ACTIONS(2706),
    [anon_sym_CARET_EQ] = ACTIONS(2706),
    [anon_sym_PIPE_EQ] = ACTIONS(2706),
    [anon_sym_AMP] = ACTIONS(2708),
    [anon_sym_PIPE_PIPE] = ACTIONS(2706),
    [anon_sym_AMP_AMP] = ACTIONS(2706),
    [anon_sym_PIPE] = ACTIONS(2708),
    [anon_sym_CARET] = ACTIONS(2708),
    [anon_sym_EQ_EQ] = ACTIONS(2706),
    [anon_sym_BANG_EQ] = ACTIONS(2706),
    [anon_sym_LT] = ACTIONS(2708),
    [anon_sym_GT] = ACTIONS(2708),
    [anon_sym_LT_EQ] = ACTIONS(2706),
    [anon_sym_GT_EQ] = ACTIONS(2706),
    [anon_sym_LT_LT] = ACTIONS(2708),
    [anon_sym_GT_GT] = ACTIONS(2708),
    [anon_sym_PLUS] = ACTIONS(2708),
    [anon_sym_DASH] = ACTIONS(2708),
    [anon_sym_SLASH] = ACTIONS(2708),
    [anon_sym_PERCENT] = ACTIONS(2708),
    [anon_sym_DASH_DASH] = ACTIONS(2706),
    [anon_sym_PLUS_PLUS] = ACTIONS(2706),
    [anon_sym_DOT] = ACTIONS(2706),
    [anon_sym_DASH_GT] = ACTIONS(2706),
    [sym_string_literal] = ACTIONS(2710),
    [sym_comment] = ACTIONS(49),
  },
  [763] = {
    [sym_type_qualifier] = STATE(279),
    [sym__type_specifier] = STATE(277),
    [sym_sized_type_specifier] = STATE(277),
    [sym_enum_specifier] = STATE(277),
    [sym_struct_specifier] = STATE(277),
    [sym_union_specifier] = STATE(277),
    [sym_type_descriptor] = STATE(1311),
    [sym_parenthesized_expression] = STATE(1311),
    [sym_macro_type_specifier] = STATE(277),
    [sym_class_specifier] = STATE(277),
    [sym_dependent_type] = STATE(277),
    [sym_template_type] = STATE(62),
    [sym_scoped_type_identifier] = STATE(34),
    [sym_scoped_namespace_identifier] = STATE(64),
    [aux_sym_type_definition_repeat1] = STATE(279),
    [aux_sym_sized_type_specifier_repeat1] = STATE(280),
    [anon_sym_LPAREN] = ACTIONS(422),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_restrict] = ACTIONS(93),
    [anon_sym_volatile] = ACTIONS(93),
    [anon_sym__Atomic] = ACTIONS(93),
    [anon_sym_mutable] = ACTIONS(93),
    [anon_sym_explicit] = ACTIONS(93),
    [anon_sym_constexpr] = ACTIONS(93),
    [anon_sym_unsigned] = ACTIONS(424),
    [anon_sym_long] = ACTIONS(424),
    [anon_sym_short] = ACTIONS(424),
    [sym_primitive_type] = ACTIONS(426),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(428),
    [anon_sym_union] = ACTIONS(430),
    [anon_sym_GT] = ACTIONS(2712),
    [sym_identifier] = ACTIONS(434),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(436),
    [sym_auto] = ACTIONS(426),
    [anon_sym_typename] = ACTIONS(438),
    [anon_sym_COLON_COLON] = ACTIONS(111),
  },
  [764] = {
    [sym_destructor_name] = STATE(282),
    [anon_sym_TILDE] = ACTIONS(1500),
    [sym_identifier] = ACTIONS(2714),
    [sym_comment] = ACTIONS(49),
    [sym_operator_name] = ACTIONS(442),
  },
  [765] = {
    [anon_sym_LPAREN] = ACTIONS(2716),
    [anon_sym_COMMA] = ACTIONS(2716),
    [anon_sym_RPAREN] = ACTIONS(2716),
    [anon_sym_SEMI] = ACTIONS(2716),
    [anon_sym_RBRACE] = ACTIONS(2716),
    [anon_sym_STAR] = ACTIONS(2718),
    [anon_sym_LBRACK] = ACTIONS(2716),
    [anon_sym_RBRACK] = ACTIONS(2716),
    [anon_sym_EQ] = ACTIONS(2718),
    [anon_sym_COLON] = ACTIONS(2716),
    [anon_sym_QMARK] = ACTIONS(2716),
    [anon_sym_STAR_EQ] = ACTIONS(2716),
    [anon_sym_SLASH_EQ] = ACTIONS(2716),
    [anon_sym_PERCENT_EQ] = ACTIONS(2716),
    [anon_sym_PLUS_EQ] = ACTIONS(2716),
    [anon_sym_DASH_EQ] = ACTIONS(2716),
    [anon_sym_LT_LT_EQ] = ACTIONS(2716),
    [anon_sym_GT_GT_EQ] = ACTIONS(2716),
    [anon_sym_AMP_EQ] = ACTIONS(2716),
    [anon_sym_CARET_EQ] = ACTIONS(2716),
    [anon_sym_PIPE_EQ] = ACTIONS(2716),
    [anon_sym_AMP] = ACTIONS(2718),
    [anon_sym_PIPE_PIPE] = ACTIONS(2716),
    [anon_sym_AMP_AMP] = ACTIONS(2716),
    [anon_sym_PIPE] = ACTIONS(2718),
    [anon_sym_CARET] = ACTIONS(2718),
    [anon_sym_EQ_EQ] = ACTIONS(2716),
    [anon_sym_BANG_EQ] = ACTIONS(2716),
    [anon_sym_LT] = ACTIONS(2718),
    [anon_sym_GT] = ACTIONS(2718),
    [anon_sym_LT_EQ] = ACTIONS(2716),
    [anon_sym_GT_EQ] = ACTIONS(2716),
    [anon_sym_LT_LT] = ACTIONS(2718),
    [anon_sym_GT_GT] = ACTIONS(2718),
    [anon_sym_PLUS] = ACTIONS(2718),
    [anon_sym_DASH] = ACTIONS(2718),
    [anon_sym_SLASH] = ACTIONS(2718),
    [anon_sym_PERCENT] = ACTIONS(2718),
    [anon_sym_DASH_DASH] = ACTIONS(2716),
    [anon_sym_PLUS_PLUS] = ACTIONS(2716),
    [anon_sym_DOT] = ACTIONS(2716),
    [anon_sym_DASH_GT] = ACTIONS(2716),
    [sym_comment] = ACTIONS(49),
  },
  [766] = {
    [sym_raw_string_literal] = ACTIONS(447),
    [anon_sym_LPAREN] = ACTIONS(444),
    [anon_sym_extern] = ACTIONS(449),
    [anon_sym_LBRACE] = ACTIONS(447),
    [anon_sym_STAR] = ACTIONS(2720),
    [anon_sym_LBRACK] = ACTIONS(444),
    [anon_sym_RBRACK] = ACTIONS(444),
    [anon_sym_EQ] = ACTIONS(706),
    [anon_sym_static] = ACTIONS(449),
    [anon_sym_register] = ACTIONS(449),
    [anon_sym_inline] = ACTIONS(449),
    [anon_sym_const] = ACTIONS(449),
    [anon_sym_restrict] = ACTIONS(449),
    [anon_sym_volatile] = ACTIONS(449),
    [anon_sym__Atomic] = ACTIONS(449),
    [anon_sym_mutable] = ACTIONS(449),
    [anon_sym_explicit] = ACTIONS(449),
    [anon_sym_constexpr] = ACTIONS(449),
    [anon_sym_QMARK] = ACTIONS(704),
    [anon_sym_STAR_EQ] = ACTIONS(704),
    [anon_sym_SLASH_EQ] = ACTIONS(704),
    [anon_sym_PERCENT_EQ] = ACTIONS(704),
    [anon_sym_PLUS_EQ] = ACTIONS(704),
    [anon_sym_DASH_EQ] = ACTIONS(704),
    [anon_sym_LT_LT_EQ] = ACTIONS(704),
    [anon_sym_GT_GT_EQ] = ACTIONS(704),
    [anon_sym_AMP_EQ] = ACTIONS(704),
    [anon_sym_CARET_EQ] = ACTIONS(704),
    [anon_sym_PIPE_EQ] = ACTIONS(704),
    [anon_sym_AMP] = ACTIONS(2720),
    [anon_sym_PIPE_PIPE] = ACTIONS(704),
    [anon_sym_AMP_AMP] = ACTIONS(704),
    [anon_sym_BANG] = ACTIONS(449),
    [anon_sym_PIPE] = ACTIONS(706),
    [anon_sym_CARET] = ACTIONS(706),
    [anon_sym_TILDE] = ACTIONS(447),
    [anon_sym_EQ_EQ] = ACTIONS(704),
    [anon_sym_BANG_EQ] = ACTIONS(704),
    [anon_sym_LT] = ACTIONS(706),
    [anon_sym_GT] = ACTIONS(706),
    [anon_sym_LT_EQ] = ACTIONS(704),
    [anon_sym_GT_EQ] = ACTIONS(704),
    [anon_sym_LT_LT] = ACTIONS(706),
    [anon_sym_GT_GT] = ACTIONS(706),
    [anon_sym_PLUS] = ACTIONS(2720),
    [anon_sym_DASH] = ACTIONS(2720),
    [anon_sym_SLASH] = ACTIONS(706),
    [anon_sym_PERCENT] = ACTIONS(706),
    [anon_sym_DASH_DASH] = ACTIONS(444),
    [anon_sym_PLUS_PLUS] = ACTIONS(444),
    [anon_sym_sizeof] = ACTIONS(449),
    [anon_sym_DOT] = ACTIONS(704),
    [anon_sym_DASH_GT] = ACTIONS(704),
    [sym_number_literal] = ACTIONS(447),
    [sym_char_literal] = ACTIONS(447),
    [sym_string_literal] = ACTIONS(447),
    [sym_true] = ACTIONS(449),
    [sym_false] = ACTIONS(449),
    [sym_null] = ACTIONS(449),
    [sym_identifier] = ACTIONS(449),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(449),
    [anon_sym_COLON_COLON] = ACTIONS(447),
    [anon_sym_delete] = ACTIONS(449),
    [sym_nullptr] = ACTIONS(449),
  },
  [767] = {
    [sym_raw_string_literal] = ACTIONS(451),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_extern] = ACTIONS(453),
    [anon_sym_STAR] = ACTIONS(451),
    [anon_sym_LBRACK] = ACTIONS(451),
    [anon_sym_RBRACK] = ACTIONS(451),
    [anon_sym_static] = ACTIONS(453),
    [anon_sym_register] = ACTIONS(453),
    [anon_sym_inline] = ACTIONS(453),
    [anon_sym_const] = ACTIONS(453),
    [anon_sym_restrict] = ACTIONS(453),
    [anon_sym_volatile] = ACTIONS(453),
    [anon_sym__Atomic] = ACTIONS(453),
    [anon_sym_mutable] = ACTIONS(453),
    [anon_sym_explicit] = ACTIONS(453),
    [anon_sym_constexpr] = ACTIONS(453),
    [anon_sym_AMP] = ACTIONS(451),
    [anon_sym_BANG] = ACTIONS(451),
    [anon_sym_TILDE] = ACTIONS(451),
    [anon_sym_PLUS] = ACTIONS(453),
    [anon_sym_DASH] = ACTIONS(453),
    [anon_sym_DASH_DASH] = ACTIONS(451),
    [anon_sym_PLUS_PLUS] = ACTIONS(451),
    [anon_sym_sizeof] = ACTIONS(453),
    [sym_number_literal] = ACTIONS(451),
    [sym_char_literal] = ACTIONS(451),
    [sym_string_literal] = ACTIONS(451),
    [sym_true] = ACTIONS(453),
    [sym_false] = ACTIONS(453),
    [sym_null] = ACTIONS(453),
    [sym_identifier] = ACTIONS(453),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(453),
    [anon_sym_COLON_COLON] = ACTIONS(451),
    [anon_sym_delete] = ACTIONS(453),
    [sym_nullptr] = ACTIONS(453),
  },
  [768] = {
    [sym_field_declaration_list] = STATE(1313),
    [sym_base_class_clause] = STATE(1314),
    [sym_raw_string_literal] = ACTIONS(451),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_extern] = ACTIONS(453),
    [anon_sym_LBRACE] = ACTIONS(1453),
    [anon_sym_STAR] = ACTIONS(451),
    [anon_sym_LBRACK] = ACTIONS(451),
    [anon_sym_RBRACK] = ACTIONS(451),
    [anon_sym_static] = ACTIONS(453),
    [anon_sym_register] = ACTIONS(453),
    [anon_sym_inline] = ACTIONS(453),
    [anon_sym_const] = ACTIONS(453),
    [anon_sym_restrict] = ACTIONS(453),
    [anon_sym_volatile] = ACTIONS(453),
    [anon_sym__Atomic] = ACTIONS(453),
    [anon_sym_mutable] = ACTIONS(453),
    [anon_sym_explicit] = ACTIONS(453),
    [anon_sym_constexpr] = ACTIONS(453),
    [anon_sym_COLON] = ACTIONS(131),
    [anon_sym_AMP] = ACTIONS(451),
    [anon_sym_BANG] = ACTIONS(451),
    [anon_sym_TILDE] = ACTIONS(451),
    [anon_sym_PLUS] = ACTIONS(453),
    [anon_sym_DASH] = ACTIONS(453),
    [anon_sym_DASH_DASH] = ACTIONS(451),
    [anon_sym_PLUS_PLUS] = ACTIONS(451),
    [anon_sym_sizeof] = ACTIONS(453),
    [sym_number_literal] = ACTIONS(451),
    [sym_char_literal] = ACTIONS(451),
    [sym_string_literal] = ACTIONS(451),
    [sym_true] = ACTIONS(453),
    [sym_false] = ACTIONS(453),
    [sym_null] = ACTIONS(453),
    [sym_identifier] = ACTIONS(453),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(453),
    [anon_sym_COLON_COLON] = ACTIONS(451),
    [anon_sym_delete] = ACTIONS(453),
    [sym_nullptr] = ACTIONS(453),
  },
  [769] = {
    [sym_field_declaration_list] = STATE(1313),
    [anon_sym_LBRACE] = ACTIONS(1453),
    [sym_comment] = ACTIONS(49),
  },
  [770] = {
    [sym_template_argument_list] = STATE(1301),
    [sym_raw_string_literal] = ACTIONS(142),
    [anon_sym_LPAREN] = ACTIONS(142),
    [anon_sym_extern] = ACTIONS(144),
    [anon_sym_STAR] = ACTIONS(142),
    [anon_sym_LBRACK] = ACTIONS(142),
    [anon_sym_RBRACK] = ACTIONS(142),
    [anon_sym_static] = ACTIONS(144),
    [anon_sym_register] = ACTIONS(144),
    [anon_sym_inline] = ACTIONS(144),
    [anon_sym_const] = ACTIONS(144),
    [anon_sym_restrict] = ACTIONS(144),
    [anon_sym_volatile] = ACTIONS(144),
    [anon_sym__Atomic] = ACTIONS(144),
    [anon_sym_mutable] = ACTIONS(144),
    [anon_sym_explicit] = ACTIONS(144),
    [anon_sym_constexpr] = ACTIONS(144),
    [anon_sym_AMP] = ACTIONS(142),
    [anon_sym_BANG] = ACTIONS(142),
    [anon_sym_TILDE] = ACTIONS(142),
    [anon_sym_LT] = ACTIONS(1567),
    [anon_sym_PLUS] = ACTIONS(144),
    [anon_sym_DASH] = ACTIONS(144),
    [anon_sym_DASH_DASH] = ACTIONS(142),
    [anon_sym_PLUS_PLUS] = ACTIONS(142),
    [anon_sym_sizeof] = ACTIONS(144),
    [sym_number_literal] = ACTIONS(142),
    [sym_char_literal] = ACTIONS(142),
    [sym_string_literal] = ACTIONS(142),
    [sym_true] = ACTIONS(144),
    [sym_false] = ACTIONS(144),
    [sym_null] = ACTIONS(144),
    [sym_identifier] = ACTIONS(144),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(144),
    [anon_sym_COLON_COLON] = ACTIONS(2684),
    [anon_sym_delete] = ACTIONS(144),
    [sym_nullptr] = ACTIONS(144),
  },
  [771] = {
    [sym_raw_string_literal] = ACTIONS(455),
    [anon_sym_LPAREN] = ACTIONS(455),
    [anon_sym_extern] = ACTIONS(457),
    [anon_sym_STAR] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(455),
    [anon_sym_RBRACK] = ACTIONS(455),
    [anon_sym_static] = ACTIONS(457),
    [anon_sym_register] = ACTIONS(457),
    [anon_sym_inline] = ACTIONS(457),
    [anon_sym_const] = ACTIONS(457),
    [anon_sym_restrict] = ACTIONS(457),
    [anon_sym_volatile] = ACTIONS(457),
    [anon_sym__Atomic] = ACTIONS(457),
    [anon_sym_mutable] = ACTIONS(457),
    [anon_sym_explicit] = ACTIONS(457),
    [anon_sym_constexpr] = ACTIONS(457),
    [anon_sym_AMP] = ACTIONS(455),
    [anon_sym_BANG] = ACTIONS(455),
    [anon_sym_TILDE] = ACTIONS(455),
    [anon_sym_PLUS] = ACTIONS(457),
    [anon_sym_DASH] = ACTIONS(457),
    [anon_sym_DASH_DASH] = ACTIONS(455),
    [anon_sym_PLUS_PLUS] = ACTIONS(455),
    [anon_sym_sizeof] = ACTIONS(457),
    [sym_number_literal] = ACTIONS(455),
    [sym_char_literal] = ACTIONS(455),
    [sym_string_literal] = ACTIONS(455),
    [sym_true] = ACTIONS(457),
    [sym_false] = ACTIONS(457),
    [sym_null] = ACTIONS(457),
    [sym_identifier] = ACTIONS(457),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(457),
    [anon_sym_COLON_COLON] = ACTIONS(455),
    [anon_sym_delete] = ACTIONS(457),
    [sym_nullptr] = ACTIONS(457),
  },
  [772] = {
    [sym_raw_string_literal] = ACTIONS(228),
    [anon_sym_LPAREN] = ACTIONS(228),
    [anon_sym_extern] = ACTIONS(230),
    [anon_sym_STAR] = ACTIONS(228),
    [anon_sym_LBRACK] = ACTIONS(228),
    [anon_sym_RBRACK] = ACTIONS(228),
    [anon_sym_static] = ACTIONS(230),
    [anon_sym_register] = ACTIONS(230),
    [anon_sym_inline] = ACTIONS(230),
    [anon_sym_const] = ACTIONS(230),
    [anon_sym_restrict] = ACTIONS(230),
    [anon_sym_volatile] = ACTIONS(230),
    [anon_sym__Atomic] = ACTIONS(230),
    [anon_sym_mutable] = ACTIONS(230),
    [anon_sym_explicit] = ACTIONS(230),
    [anon_sym_constexpr] = ACTIONS(230),
    [anon_sym_AMP] = ACTIONS(228),
    [anon_sym_BANG] = ACTIONS(228),
    [anon_sym_TILDE] = ACTIONS(228),
    [anon_sym_PLUS] = ACTIONS(230),
    [anon_sym_DASH] = ACTIONS(230),
    [anon_sym_DASH_DASH] = ACTIONS(228),
    [anon_sym_PLUS_PLUS] = ACTIONS(228),
    [anon_sym_sizeof] = ACTIONS(230),
    [sym_number_literal] = ACTIONS(228),
    [sym_char_literal] = ACTIONS(228),
    [sym_string_literal] = ACTIONS(228),
    [sym_true] = ACTIONS(230),
    [sym_false] = ACTIONS(230),
    [sym_null] = ACTIONS(230),
    [sym_identifier] = ACTIONS(230),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(230),
    [anon_sym_COLON_COLON] = ACTIONS(2688),
    [anon_sym_delete] = ACTIONS(230),
    [sym_nullptr] = ACTIONS(230),
  },
  [773] = {
    [sym_template_argument_list] = STATE(812),
    [sym_raw_string_literal] = ACTIONS(228),
    [anon_sym_LPAREN] = ACTIONS(228),
    [anon_sym_extern] = ACTIONS(230),
    [anon_sym_STAR] = ACTIONS(228),
    [anon_sym_LBRACK] = ACTIONS(228),
    [anon_sym_RBRACK] = ACTIONS(228),
    [anon_sym_static] = ACTIONS(230),
    [anon_sym_register] = ACTIONS(230),
    [anon_sym_inline] = ACTIONS(230),
    [anon_sym_const] = ACTIONS(230),
    [anon_sym_restrict] = ACTIONS(230),
    [anon_sym_volatile] = ACTIONS(230),
    [anon_sym__Atomic] = ACTIONS(230),
    [anon_sym_mutable] = ACTIONS(230),
    [anon_sym_explicit] = ACTIONS(230),
    [anon_sym_constexpr] = ACTIONS(230),
    [anon_sym_AMP] = ACTIONS(228),
    [anon_sym_BANG] = ACTIONS(228),
    [anon_sym_TILDE] = ACTIONS(228),
    [anon_sym_LT] = ACTIONS(1567),
    [anon_sym_PLUS] = ACTIONS(230),
    [anon_sym_DASH] = ACTIONS(230),
    [anon_sym_DASH_DASH] = ACTIONS(228),
    [anon_sym_PLUS_PLUS] = ACTIONS(228),
    [anon_sym_sizeof] = ACTIONS(230),
    [sym_number_literal] = ACTIONS(228),
    [sym_char_literal] = ACTIONS(228),
    [sym_string_literal] = ACTIONS(228),
    [sym_true] = ACTIONS(230),
    [sym_false] = ACTIONS(230),
    [sym_null] = ACTIONS(230),
    [sym_identifier] = ACTIONS(230),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(230),
    [anon_sym_COLON_COLON] = ACTIONS(228),
    [anon_sym_delete] = ACTIONS(230),
    [sym_nullptr] = ACTIONS(230),
  },
  [774] = {
    [sym_argument_list] = STATE(1316),
    [sym_initializer_list] = STATE(1316),
    [sym_template_argument_list] = STATE(203),
    [sym_new_declarator] = STATE(1317),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_LBRACE] = ACTIONS(548),
    [anon_sym_LBRACK] = ACTIONS(2723),
    [anon_sym_LT] = ACTIONS(146),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(321),
  },
  [775] = {
    [sym_template_type] = STATE(64),
    [sym_scoped_type_identifier] = STATE(1319),
    [sym_scoped_namespace_identifier] = STATE(64),
    [sym_identifier] = ACTIONS(2725),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(111),
  },
  [776] = {
    [sym_argument_list] = STATE(1320),
    [sym_initializer_list] = STATE(1320),
    [sym_template_argument_list] = STATE(141),
    [sym_new_declarator] = STATE(1321),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_LBRACE] = ACTIONS(548),
    [anon_sym_LBRACK] = ACTIONS(2723),
    [anon_sym_LT] = ACTIONS(146),
    [sym_comment] = ACTIONS(49),
  },
  [777] = {
    [sym_identifier] = ACTIONS(2727),
    [sym_comment] = ACTIONS(49),
  },
  [778] = {
    [sym_raw_string_literal] = ACTIONS(512),
    [anon_sym_LPAREN] = ACTIONS(509),
    [anon_sym_extern] = ACTIONS(514),
    [anon_sym_LBRACE] = ACTIONS(512),
    [anon_sym_STAR] = ACTIONS(2729),
    [anon_sym_LBRACK] = ACTIONS(509),
    [anon_sym_RBRACK] = ACTIONS(509),
    [anon_sym_EQ] = ACTIONS(520),
    [anon_sym_static] = ACTIONS(514),
    [anon_sym_register] = ACTIONS(514),
    [anon_sym_inline] = ACTIONS(514),
    [anon_sym_const] = ACTIONS(514),
    [anon_sym_restrict] = ACTIONS(514),
    [anon_sym_volatile] = ACTIONS(514),
    [anon_sym__Atomic] = ACTIONS(514),
    [anon_sym_mutable] = ACTIONS(514),
    [anon_sym_explicit] = ACTIONS(514),
    [anon_sym_constexpr] = ACTIONS(514),
    [anon_sym_QMARK] = ACTIONS(518),
    [anon_sym_STAR_EQ] = ACTIONS(518),
    [anon_sym_SLASH_EQ] = ACTIONS(518),
    [anon_sym_PERCENT_EQ] = ACTIONS(518),
    [anon_sym_PLUS_EQ] = ACTIONS(518),
    [anon_sym_DASH_EQ] = ACTIONS(518),
    [anon_sym_LT_LT_EQ] = ACTIONS(518),
    [anon_sym_GT_GT_EQ] = ACTIONS(518),
    [anon_sym_AMP_EQ] = ACTIONS(518),
    [anon_sym_CARET_EQ] = ACTIONS(518),
    [anon_sym_PIPE_EQ] = ACTIONS(518),
    [anon_sym_AMP] = ACTIONS(2729),
    [anon_sym_PIPE_PIPE] = ACTIONS(518),
    [anon_sym_AMP_AMP] = ACTIONS(518),
    [anon_sym_BANG] = ACTIONS(514),
    [anon_sym_PIPE] = ACTIONS(520),
    [anon_sym_CARET] = ACTIONS(520),
    [anon_sym_TILDE] = ACTIONS(512),
    [anon_sym_EQ_EQ] = ACTIONS(518),
    [anon_sym_BANG_EQ] = ACTIONS(518),
    [anon_sym_LT] = ACTIONS(2729),
    [anon_sym_GT] = ACTIONS(520),
    [anon_sym_LT_EQ] = ACTIONS(518),
    [anon_sym_GT_EQ] = ACTIONS(518),
    [anon_sym_LT_LT] = ACTIONS(520),
    [anon_sym_GT_GT] = ACTIONS(520),
    [anon_sym_PLUS] = ACTIONS(2729),
    [anon_sym_DASH] = ACTIONS(2729),
    [anon_sym_SLASH] = ACTIONS(520),
    [anon_sym_PERCENT] = ACTIONS(520),
    [anon_sym_DASH_DASH] = ACTIONS(509),
    [anon_sym_PLUS_PLUS] = ACTIONS(509),
    [anon_sym_sizeof] = ACTIONS(514),
    [anon_sym_DOT] = ACTIONS(518),
    [anon_sym_DASH_GT] = ACTIONS(518),
    [sym_number_literal] = ACTIONS(512),
    [sym_char_literal] = ACTIONS(512),
    [sym_string_literal] = ACTIONS(512),
    [sym_true] = ACTIONS(514),
    [sym_false] = ACTIONS(514),
    [sym_null] = ACTIONS(514),
    [sym_identifier] = ACTIONS(514),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(514),
    [anon_sym_COLON_COLON] = ACTIONS(516),
    [anon_sym_delete] = ACTIONS(514),
    [sym_nullptr] = ACTIONS(514),
  },
  [779] = {
    [sym__expression] = STATE(1324),
    [sym_conditional_expression] = STATE(1324),
    [sym_assignment_expression] = STATE(1324),
    [sym_pointer_expression] = STATE(1324),
    [sym_logical_expression] = STATE(1324),
    [sym_bitwise_expression] = STATE(1324),
    [sym_equality_expression] = STATE(1324),
    [sym_relational_expression] = STATE(1324),
    [sym_shift_expression] = STATE(1324),
    [sym_math_expression] = STATE(1324),
    [sym_cast_expression] = STATE(1324),
    [sym_sizeof_expression] = STATE(1324),
    [sym_subscript_expression] = STATE(1324),
    [sym_call_expression] = STATE(1324),
    [sym_field_expression] = STATE(1324),
    [sym_compound_literal_expression] = STATE(1324),
    [sym_parenthesized_expression] = STATE(1324),
    [sym_concatenated_string] = STATE(1324),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(1324),
    [sym_new_expression] = STATE(1324),
    [sym_delete_expression] = STATE(1324),
    [sym_lambda_expression] = STATE(1324),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(2732),
    [anon_sym_LPAREN] = ACTIONS(566),
    [anon_sym_STAR] = ACTIONS(568),
    [anon_sym_LBRACK] = ACTIONS(2734),
    [anon_sym_AMP] = ACTIONS(568),
    [anon_sym_BANG] = ACTIONS(584),
    [anon_sym_TILDE] = ACTIONS(586),
    [anon_sym_PLUS] = ACTIONS(588),
    [anon_sym_DASH] = ACTIONS(588),
    [anon_sym_DASH_DASH] = ACTIONS(590),
    [anon_sym_PLUS_PLUS] = ACTIONS(590),
    [anon_sym_sizeof] = ACTIONS(592),
    [sym_number_literal] = ACTIONS(2732),
    [sym_char_literal] = ACTIONS(2732),
    [sym_string_literal] = ACTIONS(594),
    [sym_true] = ACTIONS(2736),
    [sym_false] = ACTIONS(2736),
    [sym_null] = ACTIONS(2736),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1415),
    [anon_sym_delete] = ACTIONS(608),
    [sym_nullptr] = ACTIONS(2736),
  },
  [780] = {
    [sym__expression] = STATE(740),
    [sym_conditional_expression] = STATE(740),
    [sym_assignment_expression] = STATE(740),
    [sym_pointer_expression] = STATE(740),
    [sym_logical_expression] = STATE(740),
    [sym_bitwise_expression] = STATE(740),
    [sym_equality_expression] = STATE(740),
    [sym_relational_expression] = STATE(740),
    [sym_shift_expression] = STATE(740),
    [sym_math_expression] = STATE(740),
    [sym_cast_expression] = STATE(740),
    [sym_sizeof_expression] = STATE(740),
    [sym_subscript_expression] = STATE(740),
    [sym_call_expression] = STATE(740),
    [sym_field_expression] = STATE(740),
    [sym_compound_literal_expression] = STATE(740),
    [sym_parenthesized_expression] = STATE(740),
    [sym_concatenated_string] = STATE(740),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(740),
    [sym_new_expression] = STATE(740),
    [sym_delete_expression] = STATE(740),
    [sym_lambda_expression] = STATE(740),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_lambda_default_capture] = STATE(741),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(1417),
    [anon_sym_LPAREN] = ACTIONS(1419),
    [anon_sym_STAR] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_RBRACK] = ACTIONS(2738),
    [anon_sym_EQ] = ACTIONS(1425),
    [anon_sym_AMP] = ACTIONS(1427),
    [anon_sym_BANG] = ACTIONS(1429),
    [anon_sym_TILDE] = ACTIONS(1431),
    [anon_sym_PLUS] = ACTIONS(1433),
    [anon_sym_DASH] = ACTIONS(1433),
    [anon_sym_DASH_DASH] = ACTIONS(1435),
    [anon_sym_PLUS_PLUS] = ACTIONS(1435),
    [anon_sym_sizeof] = ACTIONS(1437),
    [sym_number_literal] = ACTIONS(1417),
    [sym_char_literal] = ACTIONS(1417),
    [sym_string_literal] = ACTIONS(1439),
    [sym_true] = ACTIONS(1441),
    [sym_false] = ACTIONS(1441),
    [sym_null] = ACTIONS(1441),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1443),
    [anon_sym_delete] = ACTIONS(1445),
    [sym_nullptr] = ACTIONS(1441),
  },
  [781] = {
    [sym_argument_list] = STATE(802),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_STAR] = ACTIONS(1522),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_RBRACK] = ACTIONS(2740),
    [anon_sym_EQ] = ACTIONS(2742),
    [anon_sym_QMARK] = ACTIONS(2740),
    [anon_sym_STAR_EQ] = ACTIONS(2740),
    [anon_sym_SLASH_EQ] = ACTIONS(2740),
    [anon_sym_PERCENT_EQ] = ACTIONS(2740),
    [anon_sym_PLUS_EQ] = ACTIONS(2740),
    [anon_sym_DASH_EQ] = ACTIONS(2740),
    [anon_sym_LT_LT_EQ] = ACTIONS(2740),
    [anon_sym_GT_GT_EQ] = ACTIONS(2740),
    [anon_sym_AMP_EQ] = ACTIONS(2740),
    [anon_sym_CARET_EQ] = ACTIONS(2740),
    [anon_sym_PIPE_EQ] = ACTIONS(2740),
    [anon_sym_AMP] = ACTIONS(1532),
    [anon_sym_PIPE_PIPE] = ACTIONS(1534),
    [anon_sym_AMP_AMP] = ACTIONS(1536),
    [anon_sym_PIPE] = ACTIONS(1538),
    [anon_sym_CARET] = ACTIONS(1540),
    [anon_sym_EQ_EQ] = ACTIONS(1542),
    [anon_sym_BANG_EQ] = ACTIONS(1542),
    [anon_sym_LT] = ACTIONS(1544),
    [anon_sym_GT] = ACTIONS(1544),
    [anon_sym_LT_EQ] = ACTIONS(1546),
    [anon_sym_GT_EQ] = ACTIONS(1546),
    [anon_sym_LT_LT] = ACTIONS(1548),
    [anon_sym_GT_GT] = ACTIONS(1548),
    [anon_sym_PLUS] = ACTIONS(1550),
    [anon_sym_DASH] = ACTIONS(1550),
    [anon_sym_SLASH] = ACTIONS(1522),
    [anon_sym_PERCENT] = ACTIONS(1522),
    [anon_sym_DASH_DASH] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(1554),
    [anon_sym_DASH_GT] = ACTIONS(1554),
    [sym_comment] = ACTIONS(49),
  },
  [782] = {
    [anon_sym_LPAREN] = ACTIONS(2744),
    [anon_sym_COMMA] = ACTIONS(2744),
    [anon_sym_RPAREN] = ACTIONS(2744),
    [anon_sym_SEMI] = ACTIONS(2744),
    [anon_sym_LBRACE] = ACTIONS(2744),
    [anon_sym_LBRACK] = ACTIONS(2744),
    [anon_sym_EQ] = ACTIONS(2744),
    [anon_sym_COLON] = ACTIONS(2744),
    [anon_sym_GT] = ACTIONS(2744),
    [sym_comment] = ACTIONS(49),
  },
  [783] = {
    [sym_argument_list] = STATE(802),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_STAR] = ACTIONS(1522),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_RBRACK] = ACTIONS(2746),
    [anon_sym_EQ] = ACTIONS(1526),
    [anon_sym_QMARK] = ACTIONS(1528),
    [anon_sym_STAR_EQ] = ACTIONS(1530),
    [anon_sym_SLASH_EQ] = ACTIONS(1530),
    [anon_sym_PERCENT_EQ] = ACTIONS(1530),
    [anon_sym_PLUS_EQ] = ACTIONS(1530),
    [anon_sym_DASH_EQ] = ACTIONS(1530),
    [anon_sym_LT_LT_EQ] = ACTIONS(1530),
    [anon_sym_GT_GT_EQ] = ACTIONS(1530),
    [anon_sym_AMP_EQ] = ACTIONS(1530),
    [anon_sym_CARET_EQ] = ACTIONS(1530),
    [anon_sym_PIPE_EQ] = ACTIONS(1530),
    [anon_sym_AMP] = ACTIONS(1532),
    [anon_sym_PIPE_PIPE] = ACTIONS(1534),
    [anon_sym_AMP_AMP] = ACTIONS(1536),
    [anon_sym_PIPE] = ACTIONS(1538),
    [anon_sym_CARET] = ACTIONS(1540),
    [anon_sym_EQ_EQ] = ACTIONS(1542),
    [anon_sym_BANG_EQ] = ACTIONS(1542),
    [anon_sym_LT] = ACTIONS(1544),
    [anon_sym_GT] = ACTIONS(1544),
    [anon_sym_LT_EQ] = ACTIONS(1546),
    [anon_sym_GT_EQ] = ACTIONS(1546),
    [anon_sym_LT_LT] = ACTIONS(1548),
    [anon_sym_GT_GT] = ACTIONS(1548),
    [anon_sym_PLUS] = ACTIONS(1550),
    [anon_sym_DASH] = ACTIONS(1550),
    [anon_sym_SLASH] = ACTIONS(1522),
    [anon_sym_PERCENT] = ACTIONS(1522),
    [anon_sym_DASH_DASH] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(1554),
    [anon_sym_DASH_GT] = ACTIONS(1554),
    [sym_comment] = ACTIONS(49),
  },
  [784] = {
    [sym_raw_string_literal] = ACTIONS(113),
    [anon_sym_LPAREN] = ACTIONS(113),
    [anon_sym_extern] = ACTIONS(115),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_LBRACK] = ACTIONS(113),
    [anon_sym_RBRACK] = ACTIONS(113),
    [anon_sym_static] = ACTIONS(115),
    [anon_sym_register] = ACTIONS(115),
    [anon_sym_inline] = ACTIONS(115),
    [anon_sym_const] = ACTIONS(115),
    [anon_sym_restrict] = ACTIONS(115),
    [anon_sym_volatile] = ACTIONS(115),
    [anon_sym__Atomic] = ACTIONS(115),
    [anon_sym_mutable] = ACTIONS(115),
    [anon_sym_explicit] = ACTIONS(115),
    [anon_sym_constexpr] = ACTIONS(115),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_TILDE] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(115),
    [anon_sym_DASH] = ACTIONS(115),
    [anon_sym_DASH_DASH] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(113),
    [anon_sym_sizeof] = ACTIONS(115),
    [sym_number_literal] = ACTIONS(113),
    [sym_char_literal] = ACTIONS(113),
    [sym_string_literal] = ACTIONS(113),
    [sym_true] = ACTIONS(115),
    [sym_false] = ACTIONS(115),
    [sym_null] = ACTIONS(115),
    [sym_identifier] = ACTIONS(115),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(115),
    [anon_sym_COLON_COLON] = ACTIONS(113),
    [anon_sym_delete] = ACTIONS(115),
    [sym_nullptr] = ACTIONS(115),
  },
  [785] = {
    [sym_raw_string_literal] = ACTIONS(121),
    [anon_sym_LPAREN] = ACTIONS(121),
    [anon_sym_extern] = ACTIONS(123),
    [anon_sym_STAR] = ACTIONS(121),
    [anon_sym_LBRACK] = ACTIONS(121),
    [anon_sym_RBRACK] = ACTIONS(121),
    [anon_sym_static] = ACTIONS(123),
    [anon_sym_register] = ACTIONS(123),
    [anon_sym_inline] = ACTIONS(123),
    [anon_sym_const] = ACTIONS(123),
    [anon_sym_restrict] = ACTIONS(123),
    [anon_sym_volatile] = ACTIONS(123),
    [anon_sym__Atomic] = ACTIONS(123),
    [anon_sym_mutable] = ACTIONS(123),
    [anon_sym_explicit] = ACTIONS(123),
    [anon_sym_constexpr] = ACTIONS(123),
    [anon_sym_AMP] = ACTIONS(121),
    [anon_sym_BANG] = ACTIONS(121),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_PLUS] = ACTIONS(123),
    [anon_sym_DASH] = ACTIONS(123),
    [anon_sym_DASH_DASH] = ACTIONS(121),
    [anon_sym_PLUS_PLUS] = ACTIONS(121),
    [anon_sym_sizeof] = ACTIONS(123),
    [sym_number_literal] = ACTIONS(121),
    [sym_char_literal] = ACTIONS(121),
    [sym_string_literal] = ACTIONS(121),
    [sym_true] = ACTIONS(123),
    [sym_false] = ACTIONS(123),
    [sym_null] = ACTIONS(123),
    [sym_identifier] = ACTIONS(123),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(123),
    [anon_sym_COLON_COLON] = ACTIONS(121),
    [anon_sym_delete] = ACTIONS(123),
    [sym_nullptr] = ACTIONS(123),
  },
  [786] = {
    [sym_storage_class_specifier] = STATE(1327),
    [sym_type_qualifier] = STATE(1327),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1327),
    [sym_raw_string_literal] = ACTIONS(696),
    [anon_sym_LPAREN] = ACTIONS(696),
    [anon_sym_extern] = ACTIONS(1518),
    [anon_sym_STAR] = ACTIONS(696),
    [anon_sym_LBRACK] = ACTIONS(696),
    [anon_sym_RBRACK] = ACTIONS(696),
    [anon_sym_static] = ACTIONS(1518),
    [anon_sym_register] = ACTIONS(1518),
    [anon_sym_inline] = ACTIONS(1518),
    [anon_sym_const] = ACTIONS(1520),
    [anon_sym_restrict] = ACTIONS(1520),
    [anon_sym_volatile] = ACTIONS(1520),
    [anon_sym__Atomic] = ACTIONS(1520),
    [anon_sym_mutable] = ACTIONS(1520),
    [anon_sym_explicit] = ACTIONS(1520),
    [anon_sym_constexpr] = ACTIONS(1520),
    [anon_sym_AMP] = ACTIONS(696),
    [anon_sym_BANG] = ACTIONS(696),
    [anon_sym_TILDE] = ACTIONS(696),
    [anon_sym_PLUS] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DASH_DASH] = ACTIONS(696),
    [anon_sym_PLUS_PLUS] = ACTIONS(696),
    [anon_sym_sizeof] = ACTIONS(698),
    [sym_number_literal] = ACTIONS(696),
    [sym_char_literal] = ACTIONS(696),
    [sym_string_literal] = ACTIONS(696),
    [sym_true] = ACTIONS(698),
    [sym_false] = ACTIONS(698),
    [sym_null] = ACTIONS(698),
    [sym_identifier] = ACTIONS(698),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(698),
    [anon_sym_COLON_COLON] = ACTIONS(696),
    [anon_sym_delete] = ACTIONS(698),
    [sym_nullptr] = ACTIONS(698),
  },
  [787] = {
    [sym__expression] = STATE(1328),
    [sym_conditional_expression] = STATE(1328),
    [sym_assignment_expression] = STATE(1328),
    [sym_pointer_expression] = STATE(1328),
    [sym_logical_expression] = STATE(1328),
    [sym_bitwise_expression] = STATE(1328),
    [sym_equality_expression] = STATE(1328),
    [sym_relational_expression] = STATE(1328),
    [sym_shift_expression] = STATE(1328),
    [sym_math_expression] = STATE(1328),
    [sym_cast_expression] = STATE(1328),
    [sym_sizeof_expression] = STATE(1328),
    [sym_subscript_expression] = STATE(1328),
    [sym_call_expression] = STATE(1328),
    [sym_field_expression] = STATE(1328),
    [sym_compound_literal_expression] = STATE(1328),
    [sym_parenthesized_expression] = STATE(1328),
    [sym_concatenated_string] = STATE(1328),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(1328),
    [sym_new_expression] = STATE(1328),
    [sym_delete_expression] = STATE(1328),
    [sym_lambda_expression] = STATE(1328),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(2748),
    [anon_sym_LPAREN] = ACTIONS(566),
    [anon_sym_STAR] = ACTIONS(568),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_AMP] = ACTIONS(568),
    [anon_sym_BANG] = ACTIONS(584),
    [anon_sym_TILDE] = ACTIONS(586),
    [anon_sym_PLUS] = ACTIONS(588),
    [anon_sym_DASH] = ACTIONS(588),
    [anon_sym_DASH_DASH] = ACTIONS(590),
    [anon_sym_PLUS_PLUS] = ACTIONS(590),
    [anon_sym_sizeof] = ACTIONS(592),
    [sym_number_literal] = ACTIONS(2748),
    [sym_char_literal] = ACTIONS(2748),
    [sym_string_literal] = ACTIONS(594),
    [sym_true] = ACTIONS(2750),
    [sym_false] = ACTIONS(2750),
    [sym_null] = ACTIONS(2750),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1415),
    [anon_sym_delete] = ACTIONS(608),
    [sym_nullptr] = ACTIONS(2750),
  },
  [788] = {
    [sym__expression] = STATE(1329),
    [sym_conditional_expression] = STATE(1329),
    [sym_assignment_expression] = STATE(1329),
    [sym_pointer_expression] = STATE(1329),
    [sym_logical_expression] = STATE(1329),
    [sym_bitwise_expression] = STATE(1329),
    [sym_equality_expression] = STATE(1329),
    [sym_relational_expression] = STATE(1329),
    [sym_shift_expression] = STATE(1329),
    [sym_math_expression] = STATE(1329),
    [sym_cast_expression] = STATE(1329),
    [sym_sizeof_expression] = STATE(1329),
    [sym_subscript_expression] = STATE(1329),
    [sym_call_expression] = STATE(1329),
    [sym_field_expression] = STATE(1329),
    [sym_compound_literal_expression] = STATE(1329),
    [sym_parenthesized_expression] = STATE(1329),
    [sym_concatenated_string] = STATE(1329),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(1329),
    [sym_new_expression] = STATE(1329),
    [sym_delete_expression] = STATE(1329),
    [sym_lambda_expression] = STATE(1329),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(2752),
    [anon_sym_LPAREN] = ACTIONS(566),
    [anon_sym_STAR] = ACTIONS(568),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_AMP] = ACTIONS(568),
    [anon_sym_BANG] = ACTIONS(584),
    [anon_sym_TILDE] = ACTIONS(586),
    [anon_sym_PLUS] = ACTIONS(588),
    [anon_sym_DASH] = ACTIONS(588),
    [anon_sym_DASH_DASH] = ACTIONS(590),
    [anon_sym_PLUS_PLUS] = ACTIONS(590),
    [anon_sym_sizeof] = ACTIONS(592),
    [sym_number_literal] = ACTIONS(2752),
    [sym_char_literal] = ACTIONS(2752),
    [sym_string_literal] = ACTIONS(594),
    [sym_true] = ACTIONS(2754),
    [sym_false] = ACTIONS(2754),
    [sym_null] = ACTIONS(2754),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1415),
    [anon_sym_delete] = ACTIONS(608),
    [sym_nullptr] = ACTIONS(2754),
  },
  [789] = {
    [sym__expression] = STATE(1330),
    [sym_conditional_expression] = STATE(1330),
    [sym_assignment_expression] = STATE(1330),
    [sym_pointer_expression] = STATE(1330),
    [sym_logical_expression] = STATE(1330),
    [sym_bitwise_expression] = STATE(1330),
    [sym_equality_expression] = STATE(1330),
    [sym_relational_expression] = STATE(1330),
    [sym_shift_expression] = STATE(1330),
    [sym_math_expression] = STATE(1330),
    [sym_cast_expression] = STATE(1330),
    [sym_sizeof_expression] = STATE(1330),
    [sym_subscript_expression] = STATE(1330),
    [sym_call_expression] = STATE(1330),
    [sym_field_expression] = STATE(1330),
    [sym_compound_literal_expression] = STATE(1330),
    [sym_parenthesized_expression] = STATE(1330),
    [sym_concatenated_string] = STATE(1330),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(1330),
    [sym_new_expression] = STATE(1330),
    [sym_delete_expression] = STATE(1330),
    [sym_lambda_expression] = STATE(1330),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(2756),
    [anon_sym_LPAREN] = ACTIONS(566),
    [anon_sym_STAR] = ACTIONS(568),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_AMP] = ACTIONS(568),
    [anon_sym_BANG] = ACTIONS(584),
    [anon_sym_TILDE] = ACTIONS(586),
    [anon_sym_PLUS] = ACTIONS(588),
    [anon_sym_DASH] = ACTIONS(588),
    [anon_sym_DASH_DASH] = ACTIONS(590),
    [anon_sym_PLUS_PLUS] = ACTIONS(590),
    [anon_sym_sizeof] = ACTIONS(592),
    [sym_number_literal] = ACTIONS(2756),
    [sym_char_literal] = ACTIONS(2756),
    [sym_string_literal] = ACTIONS(594),
    [sym_true] = ACTIONS(2758),
    [sym_false] = ACTIONS(2758),
    [sym_null] = ACTIONS(2758),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1415),
    [anon_sym_delete] = ACTIONS(608),
    [sym_nullptr] = ACTIONS(2758),
  },
  [790] = {
    [sym__expression] = STATE(1331),
    [sym_conditional_expression] = STATE(1331),
    [sym_assignment_expression] = STATE(1331),
    [sym_pointer_expression] = STATE(1331),
    [sym_logical_expression] = STATE(1331),
    [sym_bitwise_expression] = STATE(1331),
    [sym_equality_expression] = STATE(1331),
    [sym_relational_expression] = STATE(1331),
    [sym_shift_expression] = STATE(1331),
    [sym_math_expression] = STATE(1331),
    [sym_cast_expression] = STATE(1331),
    [sym_sizeof_expression] = STATE(1331),
    [sym_subscript_expression] = STATE(1331),
    [sym_call_expression] = STATE(1331),
    [sym_field_expression] = STATE(1331),
    [sym_compound_literal_expression] = STATE(1331),
    [sym_parenthesized_expression] = STATE(1331),
    [sym_concatenated_string] = STATE(1331),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(1331),
    [sym_new_expression] = STATE(1331),
    [sym_delete_expression] = STATE(1331),
    [sym_lambda_expression] = STATE(1331),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(855),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(2760),
    [anon_sym_LPAREN] = ACTIONS(1634),
    [anon_sym_STAR] = ACTIONS(1636),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_AMP] = ACTIONS(1636),
    [anon_sym_BANG] = ACTIONS(1638),
    [anon_sym_TILDE] = ACTIONS(1640),
    [anon_sym_PLUS] = ACTIONS(1642),
    [anon_sym_DASH] = ACTIONS(1642),
    [anon_sym_DASH_DASH] = ACTIONS(1644),
    [anon_sym_PLUS_PLUS] = ACTIONS(1644),
    [anon_sym_sizeof] = ACTIONS(1646),
    [sym_number_literal] = ACTIONS(2760),
    [sym_char_literal] = ACTIONS(2760),
    [sym_string_literal] = ACTIONS(1648),
    [sym_true] = ACTIONS(2762),
    [sym_false] = ACTIONS(2762),
    [sym_null] = ACTIONS(2762),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1652),
    [anon_sym_delete] = ACTIONS(1654),
    [sym_nullptr] = ACTIONS(2762),
  },
  [791] = {
    [sym__expression] = STATE(1332),
    [sym_conditional_expression] = STATE(1332),
    [sym_assignment_expression] = STATE(1332),
    [sym_pointer_expression] = STATE(1332),
    [sym_logical_expression] = STATE(1332),
    [sym_bitwise_expression] = STATE(1332),
    [sym_equality_expression] = STATE(1332),
    [sym_relational_expression] = STATE(1332),
    [sym_shift_expression] = STATE(1332),
    [sym_math_expression] = STATE(1332),
    [sym_cast_expression] = STATE(1332),
    [sym_sizeof_expression] = STATE(1332),
    [sym_subscript_expression] = STATE(1332),
    [sym_call_expression] = STATE(1332),
    [sym_field_expression] = STATE(1332),
    [sym_compound_literal_expression] = STATE(1332),
    [sym_parenthesized_expression] = STATE(1332),
    [sym_concatenated_string] = STATE(1332),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(1332),
    [sym_new_expression] = STATE(1332),
    [sym_delete_expression] = STATE(1332),
    [sym_lambda_expression] = STATE(1332),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(2764),
    [anon_sym_LPAREN] = ACTIONS(566),
    [anon_sym_STAR] = ACTIONS(568),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_AMP] = ACTIONS(568),
    [anon_sym_BANG] = ACTIONS(584),
    [anon_sym_TILDE] = ACTIONS(586),
    [anon_sym_PLUS] = ACTIONS(588),
    [anon_sym_DASH] = ACTIONS(588),
    [anon_sym_DASH_DASH] = ACTIONS(590),
    [anon_sym_PLUS_PLUS] = ACTIONS(590),
    [anon_sym_sizeof] = ACTIONS(592),
    [sym_number_literal] = ACTIONS(2764),
    [sym_char_literal] = ACTIONS(2764),
    [sym_string_literal] = ACTIONS(594),
    [sym_true] = ACTIONS(2766),
    [sym_false] = ACTIONS(2766),
    [sym_null] = ACTIONS(2766),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1415),
    [anon_sym_delete] = ACTIONS(608),
    [sym_nullptr] = ACTIONS(2766),
  },
  [792] = {
    [sym__expression] = STATE(1333),
    [sym_conditional_expression] = STATE(1333),
    [sym_assignment_expression] = STATE(1333),
    [sym_pointer_expression] = STATE(1333),
    [sym_logical_expression] = STATE(1333),
    [sym_bitwise_expression] = STATE(1333),
    [sym_equality_expression] = STATE(1333),
    [sym_relational_expression] = STATE(1333),
    [sym_shift_expression] = STATE(1333),
    [sym_math_expression] = STATE(1333),
    [sym_cast_expression] = STATE(1333),
    [sym_sizeof_expression] = STATE(1333),
    [sym_subscript_expression] = STATE(1333),
    [sym_call_expression] = STATE(1333),
    [sym_field_expression] = STATE(1333),
    [sym_compound_literal_expression] = STATE(1333),
    [sym_parenthesized_expression] = STATE(1333),
    [sym_concatenated_string] = STATE(1333),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(1333),
    [sym_new_expression] = STATE(1333),
    [sym_delete_expression] = STATE(1333),
    [sym_lambda_expression] = STATE(1333),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(2768),
    [anon_sym_LPAREN] = ACTIONS(566),
    [anon_sym_STAR] = ACTIONS(568),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_AMP] = ACTIONS(568),
    [anon_sym_BANG] = ACTIONS(584),
    [anon_sym_TILDE] = ACTIONS(586),
    [anon_sym_PLUS] = ACTIONS(588),
    [anon_sym_DASH] = ACTIONS(588),
    [anon_sym_DASH_DASH] = ACTIONS(590),
    [anon_sym_PLUS_PLUS] = ACTIONS(590),
    [anon_sym_sizeof] = ACTIONS(592),
    [sym_number_literal] = ACTIONS(2768),
    [sym_char_literal] = ACTIONS(2768),
    [sym_string_literal] = ACTIONS(594),
    [sym_true] = ACTIONS(2770),
    [sym_false] = ACTIONS(2770),
    [sym_null] = ACTIONS(2770),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1415),
    [anon_sym_delete] = ACTIONS(608),
    [sym_nullptr] = ACTIONS(2770),
  },
  [793] = {
    [sym__expression] = STATE(1334),
    [sym_conditional_expression] = STATE(1334),
    [sym_assignment_expression] = STATE(1334),
    [sym_pointer_expression] = STATE(1334),
    [sym_logical_expression] = STATE(1334),
    [sym_bitwise_expression] = STATE(1334),
    [sym_equality_expression] = STATE(1334),
    [sym_relational_expression] = STATE(1334),
    [sym_shift_expression] = STATE(1334),
    [sym_math_expression] = STATE(1334),
    [sym_cast_expression] = STATE(1334),
    [sym_sizeof_expression] = STATE(1334),
    [sym_subscript_expression] = STATE(1334),
    [sym_call_expression] = STATE(1334),
    [sym_field_expression] = STATE(1334),
    [sym_compound_literal_expression] = STATE(1334),
    [sym_parenthesized_expression] = STATE(1334),
    [sym_concatenated_string] = STATE(1334),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(1334),
    [sym_new_expression] = STATE(1334),
    [sym_delete_expression] = STATE(1334),
    [sym_lambda_expression] = STATE(1334),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(2772),
    [anon_sym_LPAREN] = ACTIONS(566),
    [anon_sym_STAR] = ACTIONS(568),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_AMP] = ACTIONS(568),
    [anon_sym_BANG] = ACTIONS(584),
    [anon_sym_TILDE] = ACTIONS(586),
    [anon_sym_PLUS] = ACTIONS(588),
    [anon_sym_DASH] = ACTIONS(588),
    [anon_sym_DASH_DASH] = ACTIONS(590),
    [anon_sym_PLUS_PLUS] = ACTIONS(590),
    [anon_sym_sizeof] = ACTIONS(592),
    [sym_number_literal] = ACTIONS(2772),
    [sym_char_literal] = ACTIONS(2772),
    [sym_string_literal] = ACTIONS(594),
    [sym_true] = ACTIONS(2774),
    [sym_false] = ACTIONS(2774),
    [sym_null] = ACTIONS(2774),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1415),
    [anon_sym_delete] = ACTIONS(608),
    [sym_nullptr] = ACTIONS(2774),
  },
  [794] = {
    [sym__expression] = STATE(1335),
    [sym_conditional_expression] = STATE(1335),
    [sym_assignment_expression] = STATE(1335),
    [sym_pointer_expression] = STATE(1335),
    [sym_logical_expression] = STATE(1335),
    [sym_bitwise_expression] = STATE(1335),
    [sym_equality_expression] = STATE(1335),
    [sym_relational_expression] = STATE(1335),
    [sym_shift_expression] = STATE(1335),
    [sym_math_expression] = STATE(1335),
    [sym_cast_expression] = STATE(1335),
    [sym_sizeof_expression] = STATE(1335),
    [sym_subscript_expression] = STATE(1335),
    [sym_call_expression] = STATE(1335),
    [sym_field_expression] = STATE(1335),
    [sym_compound_literal_expression] = STATE(1335),
    [sym_parenthesized_expression] = STATE(1335),
    [sym_concatenated_string] = STATE(1335),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(1335),
    [sym_new_expression] = STATE(1335),
    [sym_delete_expression] = STATE(1335),
    [sym_lambda_expression] = STATE(1335),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(2776),
    [anon_sym_LPAREN] = ACTIONS(566),
    [anon_sym_STAR] = ACTIONS(568),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_AMP] = ACTIONS(568),
    [anon_sym_BANG] = ACTIONS(584),
    [anon_sym_TILDE] = ACTIONS(586),
    [anon_sym_PLUS] = ACTIONS(588),
    [anon_sym_DASH] = ACTIONS(588),
    [anon_sym_DASH_DASH] = ACTIONS(590),
    [anon_sym_PLUS_PLUS] = ACTIONS(590),
    [anon_sym_sizeof] = ACTIONS(592),
    [sym_number_literal] = ACTIONS(2776),
    [sym_char_literal] = ACTIONS(2776),
    [sym_string_literal] = ACTIONS(594),
    [sym_true] = ACTIONS(2778),
    [sym_false] = ACTIONS(2778),
    [sym_null] = ACTIONS(2778),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1415),
    [anon_sym_delete] = ACTIONS(608),
    [sym_nullptr] = ACTIONS(2778),
  },
  [795] = {
    [sym__expression] = STATE(1336),
    [sym_conditional_expression] = STATE(1336),
    [sym_assignment_expression] = STATE(1336),
    [sym_pointer_expression] = STATE(1336),
    [sym_logical_expression] = STATE(1336),
    [sym_bitwise_expression] = STATE(1336),
    [sym_equality_expression] = STATE(1336),
    [sym_relational_expression] = STATE(1336),
    [sym_shift_expression] = STATE(1336),
    [sym_math_expression] = STATE(1336),
    [sym_cast_expression] = STATE(1336),
    [sym_sizeof_expression] = STATE(1336),
    [sym_subscript_expression] = STATE(1336),
    [sym_call_expression] = STATE(1336),
    [sym_field_expression] = STATE(1336),
    [sym_compound_literal_expression] = STATE(1336),
    [sym_parenthesized_expression] = STATE(1336),
    [sym_concatenated_string] = STATE(1336),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(1336),
    [sym_new_expression] = STATE(1336),
    [sym_delete_expression] = STATE(1336),
    [sym_lambda_expression] = STATE(1336),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(2780),
    [anon_sym_LPAREN] = ACTIONS(566),
    [anon_sym_STAR] = ACTIONS(568),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_AMP] = ACTIONS(568),
    [anon_sym_BANG] = ACTIONS(584),
    [anon_sym_TILDE] = ACTIONS(586),
    [anon_sym_PLUS] = ACTIONS(588),
    [anon_sym_DASH] = ACTIONS(588),
    [anon_sym_DASH_DASH] = ACTIONS(590),
    [anon_sym_PLUS_PLUS] = ACTIONS(590),
    [anon_sym_sizeof] = ACTIONS(592),
    [sym_number_literal] = ACTIONS(2780),
    [sym_char_literal] = ACTIONS(2780),
    [sym_string_literal] = ACTIONS(594),
    [sym_true] = ACTIONS(2782),
    [sym_false] = ACTIONS(2782),
    [sym_null] = ACTIONS(2782),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1415),
    [anon_sym_delete] = ACTIONS(608),
    [sym_nullptr] = ACTIONS(2782),
  },
  [796] = {
    [sym__expression] = STATE(1337),
    [sym_conditional_expression] = STATE(1337),
    [sym_assignment_expression] = STATE(1337),
    [sym_pointer_expression] = STATE(1337),
    [sym_logical_expression] = STATE(1337),
    [sym_bitwise_expression] = STATE(1337),
    [sym_equality_expression] = STATE(1337),
    [sym_relational_expression] = STATE(1337),
    [sym_shift_expression] = STATE(1337),
    [sym_math_expression] = STATE(1337),
    [sym_cast_expression] = STATE(1337),
    [sym_sizeof_expression] = STATE(1337),
    [sym_subscript_expression] = STATE(1337),
    [sym_call_expression] = STATE(1337),
    [sym_field_expression] = STATE(1337),
    [sym_compound_literal_expression] = STATE(1337),
    [sym_parenthesized_expression] = STATE(1337),
    [sym_concatenated_string] = STATE(1337),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(1337),
    [sym_new_expression] = STATE(1337),
    [sym_delete_expression] = STATE(1337),
    [sym_lambda_expression] = STATE(1337),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(2784),
    [anon_sym_LPAREN] = ACTIONS(566),
    [anon_sym_STAR] = ACTIONS(568),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_AMP] = ACTIONS(568),
    [anon_sym_BANG] = ACTIONS(584),
    [anon_sym_TILDE] = ACTIONS(586),
    [anon_sym_PLUS] = ACTIONS(588),
    [anon_sym_DASH] = ACTIONS(588),
    [anon_sym_DASH_DASH] = ACTIONS(590),
    [anon_sym_PLUS_PLUS] = ACTIONS(590),
    [anon_sym_sizeof] = ACTIONS(592),
    [sym_number_literal] = ACTIONS(2784),
    [sym_char_literal] = ACTIONS(2784),
    [sym_string_literal] = ACTIONS(594),
    [sym_true] = ACTIONS(2786),
    [sym_false] = ACTIONS(2786),
    [sym_null] = ACTIONS(2786),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1415),
    [anon_sym_delete] = ACTIONS(608),
    [sym_nullptr] = ACTIONS(2786),
  },
  [797] = {
    [sym__expression] = STATE(1338),
    [sym_conditional_expression] = STATE(1338),
    [sym_assignment_expression] = STATE(1338),
    [sym_pointer_expression] = STATE(1338),
    [sym_logical_expression] = STATE(1338),
    [sym_bitwise_expression] = STATE(1338),
    [sym_equality_expression] = STATE(1338),
    [sym_relational_expression] = STATE(1338),
    [sym_shift_expression] = STATE(1338),
    [sym_math_expression] = STATE(1338),
    [sym_cast_expression] = STATE(1338),
    [sym_sizeof_expression] = STATE(1338),
    [sym_subscript_expression] = STATE(1338),
    [sym_call_expression] = STATE(1338),
    [sym_field_expression] = STATE(1338),
    [sym_compound_literal_expression] = STATE(1338),
    [sym_parenthesized_expression] = STATE(1338),
    [sym_concatenated_string] = STATE(1338),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(1338),
    [sym_new_expression] = STATE(1338),
    [sym_delete_expression] = STATE(1338),
    [sym_lambda_expression] = STATE(1338),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(2788),
    [anon_sym_LPAREN] = ACTIONS(566),
    [anon_sym_STAR] = ACTIONS(568),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_AMP] = ACTIONS(568),
    [anon_sym_BANG] = ACTIONS(584),
    [anon_sym_TILDE] = ACTIONS(586),
    [anon_sym_PLUS] = ACTIONS(588),
    [anon_sym_DASH] = ACTIONS(588),
    [anon_sym_DASH_DASH] = ACTIONS(590),
    [anon_sym_PLUS_PLUS] = ACTIONS(590),
    [anon_sym_sizeof] = ACTIONS(592),
    [sym_number_literal] = ACTIONS(2788),
    [sym_char_literal] = ACTIONS(2788),
    [sym_string_literal] = ACTIONS(594),
    [sym_true] = ACTIONS(2790),
    [sym_false] = ACTIONS(2790),
    [sym_null] = ACTIONS(2790),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1415),
    [anon_sym_delete] = ACTIONS(608),
    [sym_nullptr] = ACTIONS(2790),
  },
  [798] = {
    [sym__expression] = STATE(1339),
    [sym_conditional_expression] = STATE(1339),
    [sym_assignment_expression] = STATE(1339),
    [sym_pointer_expression] = STATE(1339),
    [sym_logical_expression] = STATE(1339),
    [sym_bitwise_expression] = STATE(1339),
    [sym_equality_expression] = STATE(1339),
    [sym_relational_expression] = STATE(1339),
    [sym_shift_expression] = STATE(1339),
    [sym_math_expression] = STATE(1339),
    [sym_cast_expression] = STATE(1339),
    [sym_sizeof_expression] = STATE(1339),
    [sym_subscript_expression] = STATE(1339),
    [sym_call_expression] = STATE(1339),
    [sym_field_expression] = STATE(1339),
    [sym_compound_literal_expression] = STATE(1339),
    [sym_parenthesized_expression] = STATE(1339),
    [sym_concatenated_string] = STATE(1339),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(1339),
    [sym_new_expression] = STATE(1339),
    [sym_delete_expression] = STATE(1339),
    [sym_lambda_expression] = STATE(1339),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(2792),
    [anon_sym_LPAREN] = ACTIONS(566),
    [anon_sym_STAR] = ACTIONS(568),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_AMP] = ACTIONS(568),
    [anon_sym_BANG] = ACTIONS(584),
    [anon_sym_TILDE] = ACTIONS(586),
    [anon_sym_PLUS] = ACTIONS(588),
    [anon_sym_DASH] = ACTIONS(588),
    [anon_sym_DASH_DASH] = ACTIONS(590),
    [anon_sym_PLUS_PLUS] = ACTIONS(590),
    [anon_sym_sizeof] = ACTIONS(592),
    [sym_number_literal] = ACTIONS(2792),
    [sym_char_literal] = ACTIONS(2792),
    [sym_string_literal] = ACTIONS(594),
    [sym_true] = ACTIONS(2794),
    [sym_false] = ACTIONS(2794),
    [sym_null] = ACTIONS(2794),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1415),
    [anon_sym_delete] = ACTIONS(608),
    [sym_nullptr] = ACTIONS(2794),
  },
  [799] = {
    [sym__expression] = STATE(1340),
    [sym_conditional_expression] = STATE(1340),
    [sym_assignment_expression] = STATE(1340),
    [sym_pointer_expression] = STATE(1340),
    [sym_logical_expression] = STATE(1340),
    [sym_bitwise_expression] = STATE(1340),
    [sym_equality_expression] = STATE(1340),
    [sym_relational_expression] = STATE(1340),
    [sym_shift_expression] = STATE(1340),
    [sym_math_expression] = STATE(1340),
    [sym_cast_expression] = STATE(1340),
    [sym_sizeof_expression] = STATE(1340),
    [sym_subscript_expression] = STATE(1340),
    [sym_call_expression] = STATE(1340),
    [sym_field_expression] = STATE(1340),
    [sym_compound_literal_expression] = STATE(1340),
    [sym_parenthesized_expression] = STATE(1340),
    [sym_concatenated_string] = STATE(1340),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(1340),
    [sym_new_expression] = STATE(1340),
    [sym_delete_expression] = STATE(1340),
    [sym_lambda_expression] = STATE(1340),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(2796),
    [anon_sym_LPAREN] = ACTIONS(566),
    [anon_sym_STAR] = ACTIONS(568),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_AMP] = ACTIONS(568),
    [anon_sym_BANG] = ACTIONS(584),
    [anon_sym_TILDE] = ACTIONS(586),
    [anon_sym_PLUS] = ACTIONS(588),
    [anon_sym_DASH] = ACTIONS(588),
    [anon_sym_DASH_DASH] = ACTIONS(590),
    [anon_sym_PLUS_PLUS] = ACTIONS(590),
    [anon_sym_sizeof] = ACTIONS(592),
    [sym_number_literal] = ACTIONS(2796),
    [sym_char_literal] = ACTIONS(2796),
    [sym_string_literal] = ACTIONS(594),
    [sym_true] = ACTIONS(2798),
    [sym_false] = ACTIONS(2798),
    [sym_null] = ACTIONS(2798),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1415),
    [anon_sym_delete] = ACTIONS(608),
    [sym_nullptr] = ACTIONS(2798),
  },
  [800] = {
    [anon_sym_LPAREN] = ACTIONS(2698),
    [anon_sym_COMMA] = ACTIONS(2698),
    [anon_sym_RPAREN] = ACTIONS(2698),
    [anon_sym_SEMI] = ACTIONS(2698),
    [anon_sym_RBRACE] = ACTIONS(2698),
    [anon_sym_STAR] = ACTIONS(2700),
    [anon_sym_LBRACK] = ACTIONS(2698),
    [anon_sym_RBRACK] = ACTIONS(2698),
    [anon_sym_EQ] = ACTIONS(2700),
    [anon_sym_COLON] = ACTIONS(2698),
    [anon_sym_QMARK] = ACTIONS(2698),
    [anon_sym_STAR_EQ] = ACTIONS(2698),
    [anon_sym_SLASH_EQ] = ACTIONS(2698),
    [anon_sym_PERCENT_EQ] = ACTIONS(2698),
    [anon_sym_PLUS_EQ] = ACTIONS(2698),
    [anon_sym_DASH_EQ] = ACTIONS(2698),
    [anon_sym_LT_LT_EQ] = ACTIONS(2698),
    [anon_sym_GT_GT_EQ] = ACTIONS(2698),
    [anon_sym_AMP_EQ] = ACTIONS(2698),
    [anon_sym_CARET_EQ] = ACTIONS(2698),
    [anon_sym_PIPE_EQ] = ACTIONS(2698),
    [anon_sym_AMP] = ACTIONS(2700),
    [anon_sym_PIPE_PIPE] = ACTIONS(2698),
    [anon_sym_AMP_AMP] = ACTIONS(2698),
    [anon_sym_PIPE] = ACTIONS(2700),
    [anon_sym_CARET] = ACTIONS(2700),
    [anon_sym_EQ_EQ] = ACTIONS(2698),
    [anon_sym_BANG_EQ] = ACTIONS(2698),
    [anon_sym_LT] = ACTIONS(2700),
    [anon_sym_GT] = ACTIONS(2700),
    [anon_sym_LT_EQ] = ACTIONS(2698),
    [anon_sym_GT_EQ] = ACTIONS(2698),
    [anon_sym_LT_LT] = ACTIONS(2700),
    [anon_sym_GT_GT] = ACTIONS(2700),
    [anon_sym_PLUS] = ACTIONS(2700),
    [anon_sym_DASH] = ACTIONS(2700),
    [anon_sym_SLASH] = ACTIONS(2700),
    [anon_sym_PERCENT] = ACTIONS(2700),
    [anon_sym_DASH_DASH] = ACTIONS(2698),
    [anon_sym_PLUS_PLUS] = ACTIONS(2698),
    [anon_sym_DOT] = ACTIONS(2698),
    [anon_sym_DASH_GT] = ACTIONS(2698),
    [sym_comment] = ACTIONS(49),
  },
  [801] = {
    [sym_template_type] = STATE(553),
    [sym_template_method] = STATE(1342),
    [sym_destructor_name] = STATE(1342),
    [sym_scoped_field_identifier] = STATE(1343),
    [sym_scoped_type_identifier] = STATE(47),
    [sym_scoped_namespace_identifier] = STATE(553),
    [anon_sym_TILDE] = ACTIONS(1500),
    [sym_identifier] = ACTIONS(2800),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(1043),
  },
  [802] = {
    [anon_sym_LPAREN] = ACTIONS(2802),
    [anon_sym_COMMA] = ACTIONS(2802),
    [anon_sym_RPAREN] = ACTIONS(2802),
    [anon_sym_SEMI] = ACTIONS(2802),
    [anon_sym_RBRACE] = ACTIONS(2802),
    [anon_sym_STAR] = ACTIONS(2804),
    [anon_sym_LBRACK] = ACTIONS(2802),
    [anon_sym_RBRACK] = ACTIONS(2802),
    [anon_sym_EQ] = ACTIONS(2804),
    [anon_sym_COLON] = ACTIONS(2802),
    [anon_sym_QMARK] = ACTIONS(2802),
    [anon_sym_STAR_EQ] = ACTIONS(2802),
    [anon_sym_SLASH_EQ] = ACTIONS(2802),
    [anon_sym_PERCENT_EQ] = ACTIONS(2802),
    [anon_sym_PLUS_EQ] = ACTIONS(2802),
    [anon_sym_DASH_EQ] = ACTIONS(2802),
    [anon_sym_LT_LT_EQ] = ACTIONS(2802),
    [anon_sym_GT_GT_EQ] = ACTIONS(2802),
    [anon_sym_AMP_EQ] = ACTIONS(2802),
    [anon_sym_CARET_EQ] = ACTIONS(2802),
    [anon_sym_PIPE_EQ] = ACTIONS(2802),
    [anon_sym_AMP] = ACTIONS(2804),
    [anon_sym_PIPE_PIPE] = ACTIONS(2802),
    [anon_sym_AMP_AMP] = ACTIONS(2802),
    [anon_sym_PIPE] = ACTIONS(2804),
    [anon_sym_CARET] = ACTIONS(2804),
    [anon_sym_EQ_EQ] = ACTIONS(2802),
    [anon_sym_BANG_EQ] = ACTIONS(2802),
    [anon_sym_LT] = ACTIONS(2804),
    [anon_sym_GT] = ACTIONS(2804),
    [anon_sym_LT_EQ] = ACTIONS(2802),
    [anon_sym_GT_EQ] = ACTIONS(2802),
    [anon_sym_LT_LT] = ACTIONS(2804),
    [anon_sym_GT_GT] = ACTIONS(2804),
    [anon_sym_PLUS] = ACTIONS(2804),
    [anon_sym_DASH] = ACTIONS(2804),
    [anon_sym_SLASH] = ACTIONS(2804),
    [anon_sym_PERCENT] = ACTIONS(2804),
    [anon_sym_DASH_DASH] = ACTIONS(2802),
    [anon_sym_PLUS_PLUS] = ACTIONS(2802),
    [anon_sym_DOT] = ACTIONS(2802),
    [anon_sym_DASH_GT] = ACTIONS(2802),
    [sym_comment] = ACTIONS(49),
  },
  [803] = {
    [sym_destructor_name] = STATE(428),
    [anon_sym_TILDE] = ACTIONS(1500),
    [sym_identifier] = ACTIONS(2806),
    [sym_comment] = ACTIONS(49),
    [sym_operator_name] = ACTIONS(702),
  },
  [804] = {
    [anon_sym_LPAREN] = ACTIONS(2808),
    [anon_sym_COMMA] = ACTIONS(2808),
    [anon_sym_RPAREN] = ACTIONS(2808),
    [anon_sym_SEMI] = ACTIONS(2808),
    [anon_sym_RBRACE] = ACTIONS(2808),
    [anon_sym_STAR] = ACTIONS(2810),
    [anon_sym_LBRACK] = ACTIONS(2808),
    [anon_sym_RBRACK] = ACTIONS(2808),
    [anon_sym_EQ] = ACTIONS(2810),
    [anon_sym_COLON] = ACTIONS(2808),
    [anon_sym_QMARK] = ACTIONS(2808),
    [anon_sym_STAR_EQ] = ACTIONS(2808),
    [anon_sym_SLASH_EQ] = ACTIONS(2808),
    [anon_sym_PERCENT_EQ] = ACTIONS(2808),
    [anon_sym_PLUS_EQ] = ACTIONS(2808),
    [anon_sym_DASH_EQ] = ACTIONS(2808),
    [anon_sym_LT_LT_EQ] = ACTIONS(2808),
    [anon_sym_GT_GT_EQ] = ACTIONS(2808),
    [anon_sym_AMP_EQ] = ACTIONS(2808),
    [anon_sym_CARET_EQ] = ACTIONS(2808),
    [anon_sym_PIPE_EQ] = ACTIONS(2808),
    [anon_sym_AMP] = ACTIONS(2810),
    [anon_sym_PIPE_PIPE] = ACTIONS(2808),
    [anon_sym_AMP_AMP] = ACTIONS(2808),
    [anon_sym_PIPE] = ACTIONS(2810),
    [anon_sym_CARET] = ACTIONS(2810),
    [anon_sym_EQ_EQ] = ACTIONS(2808),
    [anon_sym_BANG_EQ] = ACTIONS(2808),
    [anon_sym_LT] = ACTIONS(2810),
    [anon_sym_GT] = ACTIONS(2810),
    [anon_sym_LT_EQ] = ACTIONS(2808),
    [anon_sym_GT_EQ] = ACTIONS(2808),
    [anon_sym_LT_LT] = ACTIONS(2810),
    [anon_sym_GT_GT] = ACTIONS(2810),
    [anon_sym_PLUS] = ACTIONS(2810),
    [anon_sym_DASH] = ACTIONS(2810),
    [anon_sym_SLASH] = ACTIONS(2810),
    [anon_sym_PERCENT] = ACTIONS(2810),
    [anon_sym_DASH_DASH] = ACTIONS(2808),
    [anon_sym_PLUS_PLUS] = ACTIONS(2808),
    [anon_sym_DOT] = ACTIONS(2808),
    [anon_sym_DASH_GT] = ACTIONS(2808),
    [sym_comment] = ACTIONS(49),
  },
  [805] = {
    [sym__abstract_declarator] = STATE(1345),
    [sym_abstract_pointer_declarator] = STATE(1345),
    [sym_abstract_function_declarator] = STATE(1345),
    [sym_abstract_array_declarator] = STATE(1345),
    [sym_parameter_list] = STATE(1346),
    [sym_abstract_reference_declarator] = STATE(1345),
    [anon_sym_LPAREN] = ACTIONS(1115),
    [anon_sym_STAR] = ACTIONS(1558),
    [anon_sym_LBRACK] = ACTIONS(1121),
    [anon_sym_AMP] = ACTIONS(1560),
    [anon_sym_AMP_AMP] = ACTIONS(1562),
    [sym_comment] = ACTIONS(49),
  },
  [806] = {
    [sym__abstract_declarator] = STATE(1345),
    [sym_abstract_pointer_declarator] = STATE(1345),
    [sym_abstract_function_declarator] = STATE(1345),
    [sym_abstract_array_declarator] = STATE(1345),
    [sym_parameter_list] = STATE(1346),
    [sym_abstract_reference_declarator] = STATE(1345),
    [anon_sym_LPAREN] = ACTIONS(1115),
    [anon_sym_STAR] = ACTIONS(1558),
    [anon_sym_LBRACK] = ACTIONS(1121),
    [anon_sym_AMP] = ACTIONS(1560),
    [anon_sym_AMP_AMP] = ACTIONS(1562),
    [sym_comment] = ACTIONS(49),
  },
  [807] = {
    [sym_parameter_list] = STATE(1347),
    [anon_sym_LPAREN] = ACTIONS(206),
    [anon_sym_LBRACK] = ACTIONS(2282),
    [sym_comment] = ACTIONS(49),
  },
  [808] = {
    [sym_compound_statement] = STATE(1348),
    [anon_sym_LPAREN] = ACTIONS(2812),
    [anon_sym_LBRACE] = ACTIONS(1664),
    [anon_sym_LBRACK] = ACTIONS(2812),
    [sym_comment] = ACTIONS(49),
  },
  [809] = {
    [sym_type_qualifier] = STATE(1350),
    [sym_trailing_return_type] = STATE(1129),
    [aux_sym_abstract_function_declarator_repeat1] = STATE(1350),
    [anon_sym_LPAREN] = ACTIONS(2284),
    [anon_sym_LBRACE] = ACTIONS(2284),
    [anon_sym_LBRACK] = ACTIONS(2284),
    [anon_sym_const] = ACTIONS(612),
    [anon_sym_restrict] = ACTIONS(614),
    [anon_sym_volatile] = ACTIONS(614),
    [anon_sym__Atomic] = ACTIONS(614),
    [anon_sym_mutable] = ACTIONS(614),
    [anon_sym_explicit] = ACTIONS(614),
    [anon_sym_constexpr] = ACTIONS(614),
    [anon_sym_DASH_GT] = ACTIONS(2814),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(2816),
  },
  [810] = {
    [sym_type_qualifier] = STATE(279),
    [sym__type_specifier] = STATE(277),
    [sym_sized_type_specifier] = STATE(277),
    [sym_enum_specifier] = STATE(277),
    [sym_struct_specifier] = STATE(277),
    [sym_union_specifier] = STATE(277),
    [sym_type_descriptor] = STATE(1352),
    [sym_parenthesized_expression] = STATE(1352),
    [sym_macro_type_specifier] = STATE(277),
    [sym_class_specifier] = STATE(277),
    [sym_dependent_type] = STATE(277),
    [sym_template_type] = STATE(62),
    [sym_scoped_type_identifier] = STATE(34),
    [sym_scoped_namespace_identifier] = STATE(64),
    [aux_sym_type_definition_repeat1] = STATE(279),
    [aux_sym_sized_type_specifier_repeat1] = STATE(280),
    [anon_sym_LPAREN] = ACTIONS(422),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_restrict] = ACTIONS(93),
    [anon_sym_volatile] = ACTIONS(93),
    [anon_sym__Atomic] = ACTIONS(93),
    [anon_sym_mutable] = ACTIONS(93),
    [anon_sym_explicit] = ACTIONS(93),
    [anon_sym_constexpr] = ACTIONS(93),
    [anon_sym_unsigned] = ACTIONS(424),
    [anon_sym_long] = ACTIONS(424),
    [anon_sym_short] = ACTIONS(424),
    [sym_primitive_type] = ACTIONS(426),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(428),
    [anon_sym_union] = ACTIONS(430),
    [anon_sym_GT] = ACTIONS(2818),
    [sym_identifier] = ACTIONS(434),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(436),
    [sym_auto] = ACTIONS(426),
    [anon_sym_typename] = ACTIONS(438),
    [anon_sym_COLON_COLON] = ACTIONS(111),
  },
  [811] = {
    [sym_type_qualifier] = STATE(279),
    [sym__type_specifier] = STATE(277),
    [sym_sized_type_specifier] = STATE(277),
    [sym_enum_specifier] = STATE(277),
    [sym_struct_specifier] = STATE(277),
    [sym_union_specifier] = STATE(277),
    [sym_type_descriptor] = STATE(1354),
    [sym_parenthesized_expression] = STATE(1354),
    [sym_macro_type_specifier] = STATE(277),
    [sym_class_specifier] = STATE(277),
    [sym_dependent_type] = STATE(277),
    [sym_template_type] = STATE(62),
    [sym_scoped_type_identifier] = STATE(34),
    [sym_scoped_namespace_identifier] = STATE(64),
    [aux_sym_type_definition_repeat1] = STATE(279),
    [aux_sym_sized_type_specifier_repeat1] = STATE(280),
    [anon_sym_LPAREN] = ACTIONS(422),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_restrict] = ACTIONS(93),
    [anon_sym_volatile] = ACTIONS(93),
    [anon_sym__Atomic] = ACTIONS(93),
    [anon_sym_mutable] = ACTIONS(93),
    [anon_sym_explicit] = ACTIONS(93),
    [anon_sym_constexpr] = ACTIONS(93),
    [anon_sym_unsigned] = ACTIONS(424),
    [anon_sym_long] = ACTIONS(424),
    [anon_sym_short] = ACTIONS(424),
    [sym_primitive_type] = ACTIONS(426),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(428),
    [anon_sym_union] = ACTIONS(430),
    [anon_sym_GT] = ACTIONS(2820),
    [sym_identifier] = ACTIONS(434),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(436),
    [sym_auto] = ACTIONS(426),
    [anon_sym_typename] = ACTIONS(438),
    [anon_sym_COLON_COLON] = ACTIONS(111),
  },
  [812] = {
    [sym_raw_string_literal] = ACTIONS(708),
    [anon_sym_LPAREN] = ACTIONS(708),
    [anon_sym_extern] = ACTIONS(710),
    [anon_sym_LBRACE] = ACTIONS(708),
    [anon_sym_STAR] = ACTIONS(708),
    [anon_sym_LBRACK] = ACTIONS(708),
    [anon_sym_RBRACK] = ACTIONS(708),
    [anon_sym_static] = ACTIONS(710),
    [anon_sym_register] = ACTIONS(710),
    [anon_sym_inline] = ACTIONS(710),
    [anon_sym_const] = ACTIONS(710),
    [anon_sym_restrict] = ACTIONS(710),
    [anon_sym_volatile] = ACTIONS(710),
    [anon_sym__Atomic] = ACTIONS(710),
    [anon_sym_mutable] = ACTIONS(710),
    [anon_sym_explicit] = ACTIONS(710),
    [anon_sym_constexpr] = ACTIONS(710),
    [anon_sym_COLON] = ACTIONS(710),
    [anon_sym_AMP] = ACTIONS(708),
    [anon_sym_BANG] = ACTIONS(708),
    [anon_sym_TILDE] = ACTIONS(708),
    [anon_sym_PLUS] = ACTIONS(710),
    [anon_sym_DASH] = ACTIONS(710),
    [anon_sym_DASH_DASH] = ACTIONS(708),
    [anon_sym_PLUS_PLUS] = ACTIONS(708),
    [anon_sym_sizeof] = ACTIONS(710),
    [sym_number_literal] = ACTIONS(708),
    [sym_char_literal] = ACTIONS(708),
    [sym_string_literal] = ACTIONS(708),
    [sym_true] = ACTIONS(710),
    [sym_false] = ACTIONS(710),
    [sym_null] = ACTIONS(710),
    [sym_identifier] = ACTIONS(710),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(710),
    [anon_sym_COLON_COLON] = ACTIONS(708),
    [anon_sym_delete] = ACTIONS(710),
    [sym_nullptr] = ACTIONS(710),
  },
  [813] = {
    [sym_storage_class_specifier] = STATE(1355),
    [sym_type_qualifier] = STATE(1355),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1355),
    [sym_raw_string_literal] = ACTIONS(696),
    [anon_sym_LPAREN] = ACTIONS(696),
    [anon_sym_extern] = ACTIONS(1518),
    [anon_sym_STAR] = ACTIONS(696),
    [anon_sym_LBRACK] = ACTIONS(696),
    [anon_sym_RBRACK] = ACTIONS(696),
    [anon_sym_static] = ACTIONS(1518),
    [anon_sym_register] = ACTIONS(1518),
    [anon_sym_inline] = ACTIONS(1518),
    [anon_sym_const] = ACTIONS(1520),
    [anon_sym_restrict] = ACTIONS(1520),
    [anon_sym_volatile] = ACTIONS(1520),
    [anon_sym__Atomic] = ACTIONS(1520),
    [anon_sym_mutable] = ACTIONS(1520),
    [anon_sym_explicit] = ACTIONS(1520),
    [anon_sym_constexpr] = ACTIONS(1520),
    [anon_sym_AMP] = ACTIONS(696),
    [anon_sym_BANG] = ACTIONS(696),
    [anon_sym_TILDE] = ACTIONS(696),
    [anon_sym_PLUS] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DASH_DASH] = ACTIONS(696),
    [anon_sym_PLUS_PLUS] = ACTIONS(696),
    [anon_sym_sizeof] = ACTIONS(698),
    [sym_number_literal] = ACTIONS(696),
    [sym_char_literal] = ACTIONS(696),
    [sym_string_literal] = ACTIONS(696),
    [sym_true] = ACTIONS(698),
    [sym_false] = ACTIONS(698),
    [sym_null] = ACTIONS(698),
    [sym_identifier] = ACTIONS(698),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(698),
    [anon_sym_COLON_COLON] = ACTIONS(696),
    [anon_sym_delete] = ACTIONS(698),
    [sym_nullptr] = ACTIONS(698),
  },
  [814] = {
    [sym_raw_string_literal] = ACTIONS(808),
    [anon_sym_LPAREN] = ACTIONS(808),
    [anon_sym_extern] = ACTIONS(810),
    [anon_sym_STAR] = ACTIONS(808),
    [anon_sym_LBRACK] = ACTIONS(808),
    [anon_sym_RBRACK] = ACTIONS(808),
    [anon_sym_static] = ACTIONS(810),
    [anon_sym_register] = ACTIONS(810),
    [anon_sym_inline] = ACTIONS(810),
    [anon_sym_const] = ACTIONS(810),
    [anon_sym_restrict] = ACTIONS(810),
    [anon_sym_volatile] = ACTIONS(810),
    [anon_sym__Atomic] = ACTIONS(810),
    [anon_sym_mutable] = ACTIONS(810),
    [anon_sym_explicit] = ACTIONS(810),
    [anon_sym_constexpr] = ACTIONS(810),
    [anon_sym_AMP] = ACTIONS(808),
    [anon_sym_BANG] = ACTIONS(808),
    [anon_sym_TILDE] = ACTIONS(808),
    [anon_sym_PLUS] = ACTIONS(810),
    [anon_sym_DASH] = ACTIONS(810),
    [anon_sym_DASH_DASH] = ACTIONS(808),
    [anon_sym_PLUS_PLUS] = ACTIONS(808),
    [anon_sym_sizeof] = ACTIONS(810),
    [sym_number_literal] = ACTIONS(808),
    [sym_char_literal] = ACTIONS(808),
    [sym_string_literal] = ACTIONS(808),
    [sym_true] = ACTIONS(810),
    [sym_false] = ACTIONS(810),
    [sym_null] = ACTIONS(810),
    [sym_identifier] = ACTIONS(810),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(810),
    [anon_sym_COLON_COLON] = ACTIONS(808),
    [anon_sym_delete] = ACTIONS(810),
    [sym_nullptr] = ACTIONS(810),
  },
  [815] = {
    [sym_raw_string_literal] = ACTIONS(812),
    [anon_sym_LPAREN] = ACTIONS(812),
    [anon_sym_extern] = ACTIONS(814),
    [anon_sym_STAR] = ACTIONS(812),
    [anon_sym_LBRACK] = ACTIONS(812),
    [anon_sym_RBRACK] = ACTIONS(812),
    [anon_sym_static] = ACTIONS(814),
    [anon_sym_register] = ACTIONS(814),
    [anon_sym_inline] = ACTIONS(814),
    [anon_sym_const] = ACTIONS(814),
    [anon_sym_restrict] = ACTIONS(814),
    [anon_sym_volatile] = ACTIONS(814),
    [anon_sym__Atomic] = ACTIONS(814),
    [anon_sym_mutable] = ACTIONS(814),
    [anon_sym_explicit] = ACTIONS(814),
    [anon_sym_constexpr] = ACTIONS(814),
    [anon_sym_AMP] = ACTIONS(812),
    [anon_sym_BANG] = ACTIONS(812),
    [anon_sym_TILDE] = ACTIONS(812),
    [anon_sym_PLUS] = ACTIONS(814),
    [anon_sym_DASH] = ACTIONS(814),
    [anon_sym_DASH_DASH] = ACTIONS(812),
    [anon_sym_PLUS_PLUS] = ACTIONS(812),
    [anon_sym_sizeof] = ACTIONS(814),
    [sym_number_literal] = ACTIONS(812),
    [sym_char_literal] = ACTIONS(812),
    [sym_string_literal] = ACTIONS(812),
    [sym_true] = ACTIONS(814),
    [sym_false] = ACTIONS(814),
    [sym_null] = ACTIONS(814),
    [sym_identifier] = ACTIONS(814),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(814),
    [anon_sym_COLON_COLON] = ACTIONS(812),
    [anon_sym_delete] = ACTIONS(814),
    [sym_nullptr] = ACTIONS(814),
  },
  [816] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(816),
    [sym_raw_string_literal] = ACTIONS(816),
    [anon_sym_LPAREN] = ACTIONS(816),
    [anon_sym_extern] = ACTIONS(818),
    [anon_sym_STAR] = ACTIONS(816),
    [anon_sym_LBRACK] = ACTIONS(816),
    [anon_sym_RBRACK] = ACTIONS(816),
    [anon_sym_static] = ACTIONS(818),
    [anon_sym_register] = ACTIONS(818),
    [anon_sym_inline] = ACTIONS(818),
    [anon_sym_const] = ACTIONS(818),
    [anon_sym_restrict] = ACTIONS(818),
    [anon_sym_volatile] = ACTIONS(818),
    [anon_sym__Atomic] = ACTIONS(818),
    [anon_sym_mutable] = ACTIONS(818),
    [anon_sym_explicit] = ACTIONS(818),
    [anon_sym_constexpr] = ACTIONS(818),
    [anon_sym_unsigned] = ACTIONS(2822),
    [anon_sym_long] = ACTIONS(2822),
    [anon_sym_short] = ACTIONS(2822),
    [sym_primitive_type] = ACTIONS(818),
    [anon_sym_AMP] = ACTIONS(816),
    [anon_sym_BANG] = ACTIONS(816),
    [anon_sym_TILDE] = ACTIONS(816),
    [anon_sym_PLUS] = ACTIONS(818),
    [anon_sym_DASH] = ACTIONS(818),
    [anon_sym_DASH_DASH] = ACTIONS(816),
    [anon_sym_PLUS_PLUS] = ACTIONS(816),
    [anon_sym_sizeof] = ACTIONS(818),
    [sym_number_literal] = ACTIONS(816),
    [sym_char_literal] = ACTIONS(816),
    [sym_string_literal] = ACTIONS(816),
    [sym_true] = ACTIONS(818),
    [sym_false] = ACTIONS(818),
    [sym_null] = ACTIONS(818),
    [sym_identifier] = ACTIONS(818),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(818),
    [anon_sym_COLON_COLON] = ACTIONS(816),
    [anon_sym_delete] = ACTIONS(818),
    [sym_nullptr] = ACTIONS(818),
  },
  [817] = {
    [sym_enumerator_list] = STATE(1358),
    [anon_sym_LBRACE] = ACTIONS(2825),
    [sym_identifier] = ACTIONS(2827),
    [sym_comment] = ACTIONS(49),
  },
  [818] = {
    [sym_field_declaration_list] = STATE(1361),
    [sym__class_name] = STATE(1362),
    [sym_base_class_clause] = STATE(1363),
    [sym_template_type] = STATE(1364),
    [sym_scoped_type_identifier] = STATE(1365),
    [sym_scoped_namespace_identifier] = STATE(827),
    [anon_sym_LBRACE] = ACTIONS(2829),
    [anon_sym_COLON] = ACTIONS(131),
    [sym_identifier] = ACTIONS(2831),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(1594),
  },
  [819] = {
    [sym_field_declaration_list] = STATE(1366),
    [sym__class_name] = STATE(1367),
    [sym_base_class_clause] = STATE(1368),
    [sym_template_type] = STATE(1364),
    [sym_scoped_type_identifier] = STATE(1365),
    [sym_scoped_namespace_identifier] = STATE(827),
    [anon_sym_LBRACE] = ACTIONS(2829),
    [anon_sym_COLON] = ACTIONS(131),
    [sym_identifier] = ACTIONS(2831),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(1594),
  },
  [820] = {
    [sym_template_argument_list] = STATE(1371),
    [anon_sym_LPAREN] = ACTIONS(142),
    [anon_sym_COMMA] = ACTIONS(142),
    [anon_sym_RPAREN] = ACTIONS(142),
    [anon_sym_SEMI] = ACTIONS(142),
    [anon_sym_LBRACE] = ACTIONS(142),
    [anon_sym_STAR] = ACTIONS(142),
    [anon_sym_LBRACK] = ACTIONS(142),
    [anon_sym_EQ] = ACTIONS(142),
    [anon_sym_const] = ACTIONS(144),
    [anon_sym_restrict] = ACTIONS(142),
    [anon_sym_volatile] = ACTIONS(142),
    [anon_sym__Atomic] = ACTIONS(142),
    [anon_sym_mutable] = ACTIONS(142),
    [anon_sym_explicit] = ACTIONS(142),
    [anon_sym_constexpr] = ACTIONS(142),
    [anon_sym_COLON] = ACTIONS(144),
    [anon_sym_AMP] = ACTIONS(144),
    [anon_sym_AMP_AMP] = ACTIONS(142),
    [anon_sym_LT] = ACTIONS(2833),
    [anon_sym_GT] = ACTIONS(142),
    [anon_sym_DASH_GT] = ACTIONS(142),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(142),
    [anon_sym_COLON_COLON] = ACTIONS(2835),
  },
  [821] = {
    [sym_field_declaration_list] = STATE(1372),
    [sym__class_name] = STATE(1373),
    [sym_base_class_clause] = STATE(1374),
    [sym_template_type] = STATE(1364),
    [sym_scoped_type_identifier] = STATE(1365),
    [sym_scoped_namespace_identifier] = STATE(827),
    [anon_sym_LBRACE] = ACTIONS(2829),
    [anon_sym_COLON] = ACTIONS(131),
    [sym_identifier] = ACTIONS(2831),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(1594),
  },
  [822] = {
    [sym__type_specifier] = STATE(1375),
    [sym_sized_type_specifier] = STATE(1375),
    [sym_enum_specifier] = STATE(1375),
    [sym_struct_specifier] = STATE(1375),
    [sym_union_specifier] = STATE(1375),
    [sym_macro_type_specifier] = STATE(1375),
    [sym_class_specifier] = STATE(1375),
    [sym_dependent_type] = STATE(1375),
    [sym_template_type] = STATE(825),
    [sym_scoped_type_identifier] = STATE(826),
    [sym_scoped_namespace_identifier] = STATE(827),
    [aux_sym_sized_type_specifier_repeat1] = STATE(828),
    [anon_sym_unsigned] = ACTIONS(1578),
    [anon_sym_long] = ACTIONS(1578),
    [anon_sym_short] = ACTIONS(1578),
    [sym_primitive_type] = ACTIONS(2837),
    [anon_sym_enum] = ACTIONS(1582),
    [anon_sym_struct] = ACTIONS(1584),
    [anon_sym_union] = ACTIONS(1586),
    [sym_identifier] = ACTIONS(1588),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(1590),
    [sym_auto] = ACTIONS(2837),
    [anon_sym_typename] = ACTIONS(1592),
    [anon_sym_COLON_COLON] = ACTIONS(1594),
  },
  [823] = {
    [sym_identifier] = ACTIONS(2839),
    [sym_comment] = ACTIONS(49),
  },
  [824] = {
    [sym__abstract_declarator] = STATE(1379),
    [sym_abstract_pointer_declarator] = STATE(1379),
    [sym_abstract_function_declarator] = STATE(1379),
    [sym_abstract_array_declarator] = STATE(1379),
    [sym_parameter_list] = STATE(1380),
    [sym_abstract_reference_declarator] = STATE(1379),
    [anon_sym_LPAREN] = ACTIONS(1115),
    [anon_sym_LBRACE] = ACTIONS(2841),
    [anon_sym_STAR] = ACTIONS(2843),
    [anon_sym_LBRACK] = ACTIONS(1121),
    [anon_sym_const] = ACTIONS(2845),
    [anon_sym_restrict] = ACTIONS(2841),
    [anon_sym_volatile] = ACTIONS(2841),
    [anon_sym__Atomic] = ACTIONS(2841),
    [anon_sym_mutable] = ACTIONS(2841),
    [anon_sym_explicit] = ACTIONS(2841),
    [anon_sym_constexpr] = ACTIONS(2841),
    [anon_sym_COLON] = ACTIONS(2841),
    [anon_sym_AMP] = ACTIONS(2847),
    [anon_sym_AMP_AMP] = ACTIONS(2849),
    [anon_sym_DASH_GT] = ACTIONS(2841),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(2841),
  },
  [825] = {
    [anon_sym_LPAREN] = ACTIONS(228),
    [anon_sym_COMMA] = ACTIONS(228),
    [anon_sym_RPAREN] = ACTIONS(228),
    [anon_sym_SEMI] = ACTIONS(228),
    [anon_sym_LBRACE] = ACTIONS(228),
    [anon_sym_STAR] = ACTIONS(228),
    [anon_sym_LBRACK] = ACTIONS(228),
    [anon_sym_EQ] = ACTIONS(228),
    [anon_sym_const] = ACTIONS(230),
    [anon_sym_restrict] = ACTIONS(228),
    [anon_sym_volatile] = ACTIONS(228),
    [anon_sym__Atomic] = ACTIONS(228),
    [anon_sym_mutable] = ACTIONS(228),
    [anon_sym_explicit] = ACTIONS(228),
    [anon_sym_constexpr] = ACTIONS(228),
    [anon_sym_COLON] = ACTIONS(230),
    [anon_sym_AMP] = ACTIONS(230),
    [anon_sym_AMP_AMP] = ACTIONS(228),
    [anon_sym_GT] = ACTIONS(228),
    [anon_sym_DASH_GT] = ACTIONS(228),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(228),
    [anon_sym_COLON_COLON] = ACTIONS(2851),
  },
  [826] = {
    [sym_template_argument_list] = STATE(1382),
    [anon_sym_LPAREN] = ACTIONS(228),
    [anon_sym_COMMA] = ACTIONS(228),
    [anon_sym_RPAREN] = ACTIONS(228),
    [anon_sym_SEMI] = ACTIONS(228),
    [anon_sym_LBRACE] = ACTIONS(228),
    [anon_sym_STAR] = ACTIONS(228),
    [anon_sym_LBRACK] = ACTIONS(228),
    [anon_sym_EQ] = ACTIONS(228),
    [anon_sym_const] = ACTIONS(230),
    [anon_sym_restrict] = ACTIONS(228),
    [anon_sym_volatile] = ACTIONS(228),
    [anon_sym__Atomic] = ACTIONS(228),
    [anon_sym_mutable] = ACTIONS(228),
    [anon_sym_explicit] = ACTIONS(228),
    [anon_sym_constexpr] = ACTIONS(228),
    [anon_sym_COLON] = ACTIONS(228),
    [anon_sym_AMP] = ACTIONS(230),
    [anon_sym_AMP_AMP] = ACTIONS(228),
    [anon_sym_LT] = ACTIONS(2833),
    [anon_sym_GT] = ACTIONS(228),
    [anon_sym_DASH_GT] = ACTIONS(228),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(228),
  },
  [827] = {
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(2851),
  },
  [828] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(1385),
    [anon_sym_LPAREN] = ACTIONS(238),
    [anon_sym_LBRACE] = ACTIONS(238),
    [anon_sym_STAR] = ACTIONS(238),
    [anon_sym_LBRACK] = ACTIONS(238),
    [anon_sym_const] = ACTIONS(240),
    [anon_sym_restrict] = ACTIONS(240),
    [anon_sym_volatile] = ACTIONS(240),
    [anon_sym__Atomic] = ACTIONS(240),
    [anon_sym_mutable] = ACTIONS(240),
    [anon_sym_explicit] = ACTIONS(240),
    [anon_sym_constexpr] = ACTIONS(240),
    [anon_sym_unsigned] = ACTIONS(2853),
    [anon_sym_long] = ACTIONS(2853),
    [anon_sym_short] = ACTIONS(2853),
    [sym_primitive_type] = ACTIONS(2855),
    [anon_sym_COLON] = ACTIONS(238),
    [anon_sym_AMP] = ACTIONS(240),
    [anon_sym_AMP_AMP] = ACTIONS(238),
    [anon_sym_DASH_GT] = ACTIONS(238),
    [sym_identifier] = ACTIONS(2857),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(240),
  },
  [829] = {
    [sym_type_qualifier] = STATE(829),
    [sym_trailing_return_type] = STATE(829),
    [aux_sym_function_declarator_repeat1] = STATE(829),
    [anon_sym_LPAREN] = ACTIONS(2859),
    [anon_sym_LBRACE] = ACTIONS(2859),
    [anon_sym_LBRACK] = ACTIONS(2859),
    [anon_sym_const] = ACTIONS(2861),
    [anon_sym_restrict] = ACTIONS(2864),
    [anon_sym_volatile] = ACTIONS(2864),
    [anon_sym__Atomic] = ACTIONS(2864),
    [anon_sym_mutable] = ACTIONS(2864),
    [anon_sym_explicit] = ACTIONS(2864),
    [anon_sym_constexpr] = ACTIONS(2864),
    [anon_sym_COLON] = ACTIONS(2859),
    [anon_sym_DASH_GT] = ACTIONS(2867),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(2870),
  },
  [830] = {
    [sym_raw_string_literal] = ACTIONS(249),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(251),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(251),
    [anon_sym_LPAREN] = ACTIONS(249),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(251),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(251),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(251),
    [sym_preproc_directive] = ACTIONS(251),
    [anon_sym_SEMI] = ACTIONS(249),
    [anon_sym_typedef] = ACTIONS(251),
    [anon_sym_extern] = ACTIONS(251),
    [anon_sym_LBRACE] = ACTIONS(249),
    [anon_sym_RBRACE] = ACTIONS(249),
    [anon_sym_STAR] = ACTIONS(249),
    [anon_sym_LBRACK] = ACTIONS(249),
    [anon_sym_static] = ACTIONS(251),
    [anon_sym_register] = ACTIONS(251),
    [anon_sym_inline] = ACTIONS(251),
    [anon_sym_const] = ACTIONS(251),
    [anon_sym_restrict] = ACTIONS(251),
    [anon_sym_volatile] = ACTIONS(251),
    [anon_sym__Atomic] = ACTIONS(251),
    [anon_sym_mutable] = ACTIONS(251),
    [anon_sym_explicit] = ACTIONS(251),
    [anon_sym_constexpr] = ACTIONS(251),
    [anon_sym_unsigned] = ACTIONS(251),
    [anon_sym_long] = ACTIONS(251),
    [anon_sym_short] = ACTIONS(251),
    [sym_primitive_type] = ACTIONS(251),
    [anon_sym_enum] = ACTIONS(251),
    [anon_sym_struct] = ACTIONS(251),
    [anon_sym_union] = ACTIONS(251),
    [anon_sym_if] = ACTIONS(251),
    [anon_sym_switch] = ACTIONS(251),
    [anon_sym_case] = ACTIONS(251),
    [anon_sym_default] = ACTIONS(251),
    [anon_sym_while] = ACTIONS(251),
    [anon_sym_do] = ACTIONS(251),
    [anon_sym_for] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(251),
    [anon_sym_break] = ACTIONS(251),
    [anon_sym_continue] = ACTIONS(251),
    [anon_sym_goto] = ACTIONS(251),
    [anon_sym_AMP] = ACTIONS(249),
    [anon_sym_BANG] = ACTIONS(249),
    [anon_sym_TILDE] = ACTIONS(249),
    [anon_sym_PLUS] = ACTIONS(251),
    [anon_sym_DASH] = ACTIONS(251),
    [anon_sym_DASH_DASH] = ACTIONS(249),
    [anon_sym_PLUS_PLUS] = ACTIONS(249),
    [anon_sym_sizeof] = ACTIONS(251),
    [sym_number_literal] = ACTIONS(249),
    [sym_char_literal] = ACTIONS(249),
    [sym_string_literal] = ACTIONS(249),
    [sym_true] = ACTIONS(251),
    [sym_false] = ACTIONS(251),
    [sym_null] = ACTIONS(251),
    [sym_identifier] = ACTIONS(251),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(251),
    [sym_auto] = ACTIONS(251),
    [anon_sym_typename] = ACTIONS(251),
    [anon_sym_new] = ACTIONS(251),
    [anon_sym_COLON_COLON] = ACTIONS(249),
    [anon_sym_delete] = ACTIONS(251),
    [sym_nullptr] = ACTIONS(251),
  },
  [831] = {
    [sym_preproc_params] = STATE(1388),
    [aux_sym_SLASH_LBRACK_BSLASHt_RBRACK_PLUS_SLASH] = ACTIONS(2873),
    [anon_sym_LF] = ACTIONS(2875),
    [anon_sym_LPAREN] = ACTIONS(257),
    [sym_comment] = ACTIONS(83),
  },
  [832] = {
    [anon_sym_RPAREN] = ACTIONS(2877),
    [sym_comment] = ACTIONS(49),
  },
  [833] = {
    [sym_preproc_include] = STATE(1421),
    [sym_preproc_def] = STATE(1421),
    [sym_preproc_function_def] = STATE(1421),
    [sym_preproc_call] = STATE(1421),
    [sym_preproc_if_in_compound_statement] = STATE(1414),
    [sym_preproc_ifdef_in_compound_statement] = STATE(1415),
    [sym_preproc_else_in_compound_statement] = STATE(1416),
    [sym_preproc_elif_in_compound_statement] = STATE(1417),
    [sym_declaration] = STATE(1421),
    [sym_type_definition] = STATE(1421),
    [sym__declaration_specifiers] = STATE(1418),
    [sym_compound_statement] = STATE(1421),
    [sym_storage_class_specifier] = STATE(419),
    [sym_type_qualifier] = STATE(419),
    [sym__type_specifier] = STATE(30),
    [sym_sized_type_specifier] = STATE(30),
    [sym_enum_specifier] = STATE(30),
    [sym_struct_specifier] = STATE(30),
    [sym_union_specifier] = STATE(30),
    [sym_labeled_statement] = STATE(1421),
    [sym_expression_statement] = STATE(1421),
    [sym_if_statement] = STATE(1421),
    [sym_switch_statement] = STATE(1421),
    [sym_case_statement] = STATE(1421),
    [sym_while_statement] = STATE(1421),
    [sym_do_statement] = STATE(1421),
    [sym_for_statement] = STATE(1421),
    [sym_return_statement] = STATE(1421),
    [sym_break_statement] = STATE(1421),
    [sym_continue_statement] = STATE(1421),
    [sym_goto_statement] = STATE(1421),
    [sym__expression] = STATE(1419),
    [sym_comma_expression] = STATE(1420),
    [sym_conditional_expression] = STATE(1419),
    [sym_assignment_expression] = STATE(1419),
    [sym_pointer_expression] = STATE(1419),
    [sym_logical_expression] = STATE(1419),
    [sym_bitwise_expression] = STATE(1419),
    [sym_equality_expression] = STATE(1419),
    [sym_relational_expression] = STATE(1419),
    [sym_shift_expression] = STATE(1419),
    [sym_math_expression] = STATE(1419),
    [sym_cast_expression] = STATE(1419),
    [sym_sizeof_expression] = STATE(1419),
    [sym_subscript_expression] = STATE(1419),
    [sym_call_expression] = STATE(1419),
    [sym_field_expression] = STATE(1419),
    [sym_compound_literal_expression] = STATE(1419),
    [sym_parenthesized_expression] = STATE(1419),
    [sym_concatenated_string] = STATE(1419),
    [sym__empty_declaration] = STATE(1421),
    [sym_macro_type_specifier] = STATE(30),
    [sym_class_specifier] = STATE(30),
    [sym_dependent_type] = STATE(30),
    [sym_structured_binding_declaration] = STATE(1421),
    [sym_template_type] = STATE(415),
    [sym_template_function] = STATE(1419),
    [sym_for_range_loop] = STATE(1421),
    [sym_new_expression] = STATE(1419),
    [sym_delete_expression] = STATE(1419),
    [sym_lambda_expression] = STATE(1419),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(416),
    [sym_scoped_namespace_identifier] = STATE(417),
    [aux_sym_preproc_if_in_compound_statement_repeat1] = STATE(1421),
    [aux_sym__declaration_specifiers_repeat1] = STATE(419),
    [aux_sym_sized_type_specifier_repeat1] = STATE(38),
    [sym_raw_string_literal] = ACTIONS(2879),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(2881),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(2883),
    [anon_sym_LPAREN] = ACTIONS(626),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(2885),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(2887),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(2889),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(2891),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(2893),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(2895),
    [sym_preproc_directive] = ACTIONS(2897),
    [anon_sym_SEMI] = ACTIONS(2899),
    [anon_sym_typedef] = ACTIONS(2901),
    [anon_sym_extern] = ACTIONS(154),
    [anon_sym_LBRACE] = ACTIONS(2903),
    [anon_sym_STAR] = ACTIONS(644),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_static] = ACTIONS(154),
    [anon_sym_register] = ACTIONS(154),
    [anon_sym_inline] = ACTIONS(154),
    [anon_sym_const] = ACTIONS(158),
    [anon_sym_restrict] = ACTIONS(158),
    [anon_sym_volatile] = ACTIONS(158),
    [anon_sym__Atomic] = ACTIONS(158),
    [anon_sym_mutable] = ACTIONS(158),
    [anon_sym_explicit] = ACTIONS(158),
    [anon_sym_constexpr] = ACTIONS(158),
    [anon_sym_unsigned] = ACTIONS(31),
    [anon_sym_long] = ACTIONS(31),
    [anon_sym_short] = ACTIONS(31),
    [sym_primitive_type] = ACTIONS(33),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_union] = ACTIONS(39),
    [anon_sym_if] = ACTIONS(2905),
    [anon_sym_switch] = ACTIONS(2907),
    [anon_sym_case] = ACTIONS(2909),
    [anon_sym_default] = ACTIONS(2911),
    [anon_sym_while] = ACTIONS(2913),
    [anon_sym_do] = ACTIONS(2915),
    [anon_sym_for] = ACTIONS(2917),
    [anon_sym_return] = ACTIONS(2919),
    [anon_sym_break] = ACTIONS(2921),
    [anon_sym_continue] = ACTIONS(2923),
    [anon_sym_goto] = ACTIONS(2925),
    [anon_sym_AMP] = ACTIONS(644),
    [anon_sym_BANG] = ACTIONS(668),
    [anon_sym_TILDE] = ACTIONS(670),
    [anon_sym_PLUS] = ACTIONS(672),
    [anon_sym_DASH] = ACTIONS(672),
    [anon_sym_DASH_DASH] = ACTIONS(674),
    [anon_sym_PLUS_PLUS] = ACTIONS(674),
    [anon_sym_sizeof] = ACTIONS(676),
    [sym_number_literal] = ACTIONS(2879),
    [sym_char_literal] = ACTIONS(2879),
    [sym_string_literal] = ACTIONS(678),
    [sym_true] = ACTIONS(2927),
    [sym_false] = ACTIONS(2927),
    [sym_null] = ACTIONS(2927),
    [sym_identifier] = ACTIONS(2929),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(51),
    [sym_auto] = ACTIONS(33),
    [anon_sym_typename] = ACTIONS(53),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(684),
    [anon_sym_delete] = ACTIONS(686),
    [sym_nullptr] = ACTIONS(2927),
  },
  [834] = {
    [sym_preproc_include] = STATE(1425),
    [sym_preproc_def] = STATE(1425),
    [sym_preproc_function_def] = STATE(1425),
    [sym_preproc_call] = STATE(1425),
    [sym_preproc_if_in_compound_statement] = STATE(1414),
    [sym_preproc_ifdef_in_compound_statement] = STATE(1415),
    [sym_preproc_else_in_compound_statement] = STATE(1423),
    [sym_preproc_elif_in_compound_statement] = STATE(1424),
    [sym_declaration] = STATE(1425),
    [sym_type_definition] = STATE(1425),
    [sym__declaration_specifiers] = STATE(1418),
    [sym_compound_statement] = STATE(1425),
    [sym_storage_class_specifier] = STATE(419),
    [sym_type_qualifier] = STATE(419),
    [sym__type_specifier] = STATE(30),
    [sym_sized_type_specifier] = STATE(30),
    [sym_enum_specifier] = STATE(30),
    [sym_struct_specifier] = STATE(30),
    [sym_union_specifier] = STATE(30),
    [sym_labeled_statement] = STATE(1425),
    [sym_expression_statement] = STATE(1425),
    [sym_if_statement] = STATE(1425),
    [sym_switch_statement] = STATE(1425),
    [sym_case_statement] = STATE(1425),
    [sym_while_statement] = STATE(1425),
    [sym_do_statement] = STATE(1425),
    [sym_for_statement] = STATE(1425),
    [sym_return_statement] = STATE(1425),
    [sym_break_statement] = STATE(1425),
    [sym_continue_statement] = STATE(1425),
    [sym_goto_statement] = STATE(1425),
    [sym__expression] = STATE(1419),
    [sym_comma_expression] = STATE(1420),
    [sym_conditional_expression] = STATE(1419),
    [sym_assignment_expression] = STATE(1419),
    [sym_pointer_expression] = STATE(1419),
    [sym_logical_expression] = STATE(1419),
    [sym_bitwise_expression] = STATE(1419),
    [sym_equality_expression] = STATE(1419),
    [sym_relational_expression] = STATE(1419),
    [sym_shift_expression] = STATE(1419),
    [sym_math_expression] = STATE(1419),
    [sym_cast_expression] = STATE(1419),
    [sym_sizeof_expression] = STATE(1419),
    [sym_subscript_expression] = STATE(1419),
    [sym_call_expression] = STATE(1419),
    [sym_field_expression] = STATE(1419),
    [sym_compound_literal_expression] = STATE(1419),
    [sym_parenthesized_expression] = STATE(1419),
    [sym_concatenated_string] = STATE(1419),
    [sym__empty_declaration] = STATE(1425),
    [sym_macro_type_specifier] = STATE(30),
    [sym_class_specifier] = STATE(30),
    [sym_dependent_type] = STATE(30),
    [sym_structured_binding_declaration] = STATE(1425),
    [sym_template_type] = STATE(415),
    [sym_template_function] = STATE(1419),
    [sym_for_range_loop] = STATE(1425),
    [sym_new_expression] = STATE(1419),
    [sym_delete_expression] = STATE(1419),
    [sym_lambda_expression] = STATE(1419),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(416),
    [sym_scoped_namespace_identifier] = STATE(417),
    [aux_sym_preproc_if_in_compound_statement_repeat1] = STATE(1425),
    [aux_sym__declaration_specifiers_repeat1] = STATE(419),
    [aux_sym_sized_type_specifier_repeat1] = STATE(38),
    [sym_raw_string_literal] = ACTIONS(2879),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(2881),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(2883),
    [anon_sym_LPAREN] = ACTIONS(626),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(2885),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(2931),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(2889),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(2891),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(2893),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(2895),
    [sym_preproc_directive] = ACTIONS(2897),
    [anon_sym_SEMI] = ACTIONS(2899),
    [anon_sym_typedef] = ACTIONS(2901),
    [anon_sym_extern] = ACTIONS(154),
    [anon_sym_LBRACE] = ACTIONS(2903),
    [anon_sym_STAR] = ACTIONS(644),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_static] = ACTIONS(154),
    [anon_sym_register] = ACTIONS(154),
    [anon_sym_inline] = ACTIONS(154),
    [anon_sym_const] = ACTIONS(158),
    [anon_sym_restrict] = ACTIONS(158),
    [anon_sym_volatile] = ACTIONS(158),
    [anon_sym__Atomic] = ACTIONS(158),
    [anon_sym_mutable] = ACTIONS(158),
    [anon_sym_explicit] = ACTIONS(158),
    [anon_sym_constexpr] = ACTIONS(158),
    [anon_sym_unsigned] = ACTIONS(31),
    [anon_sym_long] = ACTIONS(31),
    [anon_sym_short] = ACTIONS(31),
    [sym_primitive_type] = ACTIONS(33),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_union] = ACTIONS(39),
    [anon_sym_if] = ACTIONS(2905),
    [anon_sym_switch] = ACTIONS(2907),
    [anon_sym_case] = ACTIONS(2909),
    [anon_sym_default] = ACTIONS(2911),
    [anon_sym_while] = ACTIONS(2913),
    [anon_sym_do] = ACTIONS(2915),
    [anon_sym_for] = ACTIONS(2917),
    [anon_sym_return] = ACTIONS(2919),
    [anon_sym_break] = ACTIONS(2921),
    [anon_sym_continue] = ACTIONS(2923),
    [anon_sym_goto] = ACTIONS(2925),
    [anon_sym_AMP] = ACTIONS(644),
    [anon_sym_BANG] = ACTIONS(668),
    [anon_sym_TILDE] = ACTIONS(670),
    [anon_sym_PLUS] = ACTIONS(672),
    [anon_sym_DASH] = ACTIONS(672),
    [anon_sym_DASH_DASH] = ACTIONS(674),
    [anon_sym_PLUS_PLUS] = ACTIONS(674),
    [anon_sym_sizeof] = ACTIONS(676),
    [sym_number_literal] = ACTIONS(2879),
    [sym_char_literal] = ACTIONS(2879),
    [sym_string_literal] = ACTIONS(678),
    [sym_true] = ACTIONS(2927),
    [sym_false] = ACTIONS(2927),
    [sym_null] = ACTIONS(2927),
    [sym_identifier] = ACTIONS(2929),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(51),
    [sym_auto] = ACTIONS(33),
    [anon_sym_typename] = ACTIONS(53),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(684),
    [anon_sym_delete] = ACTIONS(686),
    [sym_nullptr] = ACTIONS(2927),
  },
  [835] = {
    [sym_preproc_include] = STATE(1429),
    [sym_preproc_def] = STATE(1429),
    [sym_preproc_function_def] = STATE(1429),
    [sym_preproc_call] = STATE(1429),
    [sym_preproc_if_in_compound_statement] = STATE(1414),
    [sym_preproc_ifdef_in_compound_statement] = STATE(1415),
    [sym_preproc_else_in_compound_statement] = STATE(1427),
    [sym_preproc_elif_in_compound_statement] = STATE(1428),
    [sym_declaration] = STATE(1429),
    [sym_type_definition] = STATE(1429),
    [sym__declaration_specifiers] = STATE(1418),
    [sym_compound_statement] = STATE(1429),
    [sym_storage_class_specifier] = STATE(419),
    [sym_type_qualifier] = STATE(419),
    [sym__type_specifier] = STATE(30),
    [sym_sized_type_specifier] = STATE(30),
    [sym_enum_specifier] = STATE(30),
    [sym_struct_specifier] = STATE(30),
    [sym_union_specifier] = STATE(30),
    [sym_labeled_statement] = STATE(1429),
    [sym_expression_statement] = STATE(1429),
    [sym_if_statement] = STATE(1429),
    [sym_switch_statement] = STATE(1429),
    [sym_case_statement] = STATE(1429),
    [sym_while_statement] = STATE(1429),
    [sym_do_statement] = STATE(1429),
    [sym_for_statement] = STATE(1429),
    [sym_return_statement] = STATE(1429),
    [sym_break_statement] = STATE(1429),
    [sym_continue_statement] = STATE(1429),
    [sym_goto_statement] = STATE(1429),
    [sym__expression] = STATE(1419),
    [sym_comma_expression] = STATE(1420),
    [sym_conditional_expression] = STATE(1419),
    [sym_assignment_expression] = STATE(1419),
    [sym_pointer_expression] = STATE(1419),
    [sym_logical_expression] = STATE(1419),
    [sym_bitwise_expression] = STATE(1419),
    [sym_equality_expression] = STATE(1419),
    [sym_relational_expression] = STATE(1419),
    [sym_shift_expression] = STATE(1419),
    [sym_math_expression] = STATE(1419),
    [sym_cast_expression] = STATE(1419),
    [sym_sizeof_expression] = STATE(1419),
    [sym_subscript_expression] = STATE(1419),
    [sym_call_expression] = STATE(1419),
    [sym_field_expression] = STATE(1419),
    [sym_compound_literal_expression] = STATE(1419),
    [sym_parenthesized_expression] = STATE(1419),
    [sym_concatenated_string] = STATE(1419),
    [sym__empty_declaration] = STATE(1429),
    [sym_macro_type_specifier] = STATE(30),
    [sym_class_specifier] = STATE(30),
    [sym_dependent_type] = STATE(30),
    [sym_structured_binding_declaration] = STATE(1429),
    [sym_template_type] = STATE(415),
    [sym_template_function] = STATE(1419),
    [sym_for_range_loop] = STATE(1429),
    [sym_new_expression] = STATE(1419),
    [sym_delete_expression] = STATE(1419),
    [sym_lambda_expression] = STATE(1419),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(416),
    [sym_scoped_namespace_identifier] = STATE(417),
    [aux_sym_preproc_if_in_compound_statement_repeat1] = STATE(1429),
    [aux_sym__declaration_specifiers_repeat1] = STATE(419),
    [aux_sym_sized_type_specifier_repeat1] = STATE(38),
    [sym_raw_string_literal] = ACTIONS(2879),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(2881),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(2883),
    [anon_sym_LPAREN] = ACTIONS(626),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(2885),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(2933),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(2889),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(2891),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(2893),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(2895),
    [sym_preproc_directive] = ACTIONS(2897),
    [anon_sym_SEMI] = ACTIONS(2899),
    [anon_sym_typedef] = ACTIONS(2901),
    [anon_sym_extern] = ACTIONS(154),
    [anon_sym_LBRACE] = ACTIONS(2903),
    [anon_sym_STAR] = ACTIONS(644),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_static] = ACTIONS(154),
    [anon_sym_register] = ACTIONS(154),
    [anon_sym_inline] = ACTIONS(154),
    [anon_sym_const] = ACTIONS(158),
    [anon_sym_restrict] = ACTIONS(158),
    [anon_sym_volatile] = ACTIONS(158),
    [anon_sym__Atomic] = ACTIONS(158),
    [anon_sym_mutable] = ACTIONS(158),
    [anon_sym_explicit] = ACTIONS(158),
    [anon_sym_constexpr] = ACTIONS(158),
    [anon_sym_unsigned] = ACTIONS(31),
    [anon_sym_long] = ACTIONS(31),
    [anon_sym_short] = ACTIONS(31),
    [sym_primitive_type] = ACTIONS(33),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_union] = ACTIONS(39),
    [anon_sym_if] = ACTIONS(2905),
    [anon_sym_switch] = ACTIONS(2907),
    [anon_sym_case] = ACTIONS(2909),
    [anon_sym_default] = ACTIONS(2911),
    [anon_sym_while] = ACTIONS(2913),
    [anon_sym_do] = ACTIONS(2915),
    [anon_sym_for] = ACTIONS(2917),
    [anon_sym_return] = ACTIONS(2919),
    [anon_sym_break] = ACTIONS(2921),
    [anon_sym_continue] = ACTIONS(2923),
    [anon_sym_goto] = ACTIONS(2925),
    [anon_sym_AMP] = ACTIONS(644),
    [anon_sym_BANG] = ACTIONS(668),
    [anon_sym_TILDE] = ACTIONS(670),
    [anon_sym_PLUS] = ACTIONS(672),
    [anon_sym_DASH] = ACTIONS(672),
    [anon_sym_DASH_DASH] = ACTIONS(674),
    [anon_sym_PLUS_PLUS] = ACTIONS(674),
    [anon_sym_sizeof] = ACTIONS(676),
    [sym_number_literal] = ACTIONS(2879),
    [sym_char_literal] = ACTIONS(2879),
    [sym_string_literal] = ACTIONS(678),
    [sym_true] = ACTIONS(2927),
    [sym_false] = ACTIONS(2927),
    [sym_null] = ACTIONS(2927),
    [sym_identifier] = ACTIONS(2929),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(51),
    [sym_auto] = ACTIONS(33),
    [anon_sym_typename] = ACTIONS(53),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(684),
    [anon_sym_delete] = ACTIONS(686),
    [sym_nullptr] = ACTIONS(2927),
  },
  [836] = {
    [sym_preproc_arg] = ACTIONS(2935),
    [sym_comment] = ACTIONS(83),
  },
  [837] = {
    [sym_raw_string_literal] = ACTIONS(307),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(309),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(309),
    [anon_sym_LPAREN] = ACTIONS(307),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(309),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(309),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(309),
    [sym_preproc_directive] = ACTIONS(309),
    [anon_sym_SEMI] = ACTIONS(307),
    [anon_sym_typedef] = ACTIONS(309),
    [anon_sym_extern] = ACTIONS(309),
    [anon_sym_LBRACE] = ACTIONS(307),
    [anon_sym_RBRACE] = ACTIONS(307),
    [anon_sym_STAR] = ACTIONS(307),
    [anon_sym_LBRACK] = ACTIONS(307),
    [anon_sym_static] = ACTIONS(309),
    [anon_sym_register] = ACTIONS(309),
    [anon_sym_inline] = ACTIONS(309),
    [anon_sym_const] = ACTIONS(309),
    [anon_sym_restrict] = ACTIONS(309),
    [anon_sym_volatile] = ACTIONS(309),
    [anon_sym__Atomic] = ACTIONS(309),
    [anon_sym_mutable] = ACTIONS(309),
    [anon_sym_explicit] = ACTIONS(309),
    [anon_sym_constexpr] = ACTIONS(309),
    [anon_sym_unsigned] = ACTIONS(309),
    [anon_sym_long] = ACTIONS(309),
    [anon_sym_short] = ACTIONS(309),
    [sym_primitive_type] = ACTIONS(309),
    [anon_sym_enum] = ACTIONS(309),
    [anon_sym_struct] = ACTIONS(309),
    [anon_sym_union] = ACTIONS(309),
    [anon_sym_if] = ACTIONS(309),
    [anon_sym_switch] = ACTIONS(309),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_default] = ACTIONS(309),
    [anon_sym_while] = ACTIONS(309),
    [anon_sym_do] = ACTIONS(309),
    [anon_sym_for] = ACTIONS(309),
    [anon_sym_return] = ACTIONS(309),
    [anon_sym_break] = ACTIONS(309),
    [anon_sym_continue] = ACTIONS(309),
    [anon_sym_goto] = ACTIONS(309),
    [anon_sym_AMP] = ACTIONS(307),
    [anon_sym_BANG] = ACTIONS(307),
    [anon_sym_TILDE] = ACTIONS(307),
    [anon_sym_PLUS] = ACTIONS(309),
    [anon_sym_DASH] = ACTIONS(309),
    [anon_sym_DASH_DASH] = ACTIONS(307),
    [anon_sym_PLUS_PLUS] = ACTIONS(307),
    [anon_sym_sizeof] = ACTIONS(309),
    [sym_number_literal] = ACTIONS(307),
    [sym_char_literal] = ACTIONS(307),
    [sym_string_literal] = ACTIONS(307),
    [sym_true] = ACTIONS(309),
    [sym_false] = ACTIONS(309),
    [sym_null] = ACTIONS(309),
    [sym_identifier] = ACTIONS(309),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(309),
    [sym_auto] = ACTIONS(309),
    [anon_sym_typename] = ACTIONS(309),
    [anon_sym_new] = ACTIONS(309),
    [anon_sym_COLON_COLON] = ACTIONS(307),
    [anon_sym_delete] = ACTIONS(309),
    [sym_nullptr] = ACTIONS(309),
  },
  [838] = {
    [sym__type_declarator] = STATE(1431),
    [sym_pointer_type_declarator] = STATE(213),
    [sym_function_type_declarator] = STATE(214),
    [sym_array_type_declarator] = STATE(215),
    [anon_sym_LPAREN] = ACTIONS(327),
    [anon_sym_STAR] = ACTIONS(329),
    [sym_identifier] = ACTIONS(331),
    [sym_comment] = ACTIONS(49),
  },
  [839] = {
    [sym_type_qualifier] = STATE(219),
    [sym__type_specifier] = STATE(1432),
    [sym_sized_type_specifier] = STATE(1432),
    [sym_enum_specifier] = STATE(1432),
    [sym_struct_specifier] = STATE(1432),
    [sym_union_specifier] = STATE(1432),
    [sym_macro_type_specifier] = STATE(1432),
    [sym_class_specifier] = STATE(1432),
    [sym_dependent_type] = STATE(1432),
    [sym_template_type] = STATE(62),
    [sym_scoped_type_identifier] = STATE(63),
    [sym_scoped_namespace_identifier] = STATE(64),
    [aux_sym_type_definition_repeat1] = STATE(219),
    [aux_sym_sized_type_specifier_repeat1] = STATE(66),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_restrict] = ACTIONS(93),
    [anon_sym_volatile] = ACTIONS(93),
    [anon_sym__Atomic] = ACTIONS(93),
    [anon_sym_mutable] = ACTIONS(93),
    [anon_sym_explicit] = ACTIONS(93),
    [anon_sym_constexpr] = ACTIONS(93),
    [anon_sym_unsigned] = ACTIONS(95),
    [anon_sym_long] = ACTIONS(95),
    [anon_sym_short] = ACTIONS(95),
    [sym_primitive_type] = ACTIONS(2937),
    [anon_sym_enum] = ACTIONS(99),
    [anon_sym_struct] = ACTIONS(101),
    [anon_sym_union] = ACTIONS(103),
    [sym_identifier] = ACTIONS(105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(107),
    [sym_auto] = ACTIONS(2937),
    [anon_sym_typename] = ACTIONS(109),
    [anon_sym_COLON_COLON] = ACTIONS(111),
  },
  [840] = {
    [sym_raw_string_literal] = ACTIONS(1622),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1624),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1624),
    [anon_sym_LPAREN] = ACTIONS(1622),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1624),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1624),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1624),
    [sym_preproc_directive] = ACTIONS(1624),
    [anon_sym_SEMI] = ACTIONS(1622),
    [anon_sym_typedef] = ACTIONS(1624),
    [anon_sym_extern] = ACTIONS(1624),
    [anon_sym_LBRACE] = ACTIONS(1622),
    [anon_sym_RBRACE] = ACTIONS(1622),
    [anon_sym_STAR] = ACTIONS(1622),
    [anon_sym_LBRACK] = ACTIONS(1622),
    [anon_sym_static] = ACTIONS(1624),
    [anon_sym_register] = ACTIONS(1624),
    [anon_sym_inline] = ACTIONS(1624),
    [anon_sym_const] = ACTIONS(1624),
    [anon_sym_restrict] = ACTIONS(1624),
    [anon_sym_volatile] = ACTIONS(1624),
    [anon_sym__Atomic] = ACTIONS(1624),
    [anon_sym_mutable] = ACTIONS(1624),
    [anon_sym_explicit] = ACTIONS(1624),
    [anon_sym_constexpr] = ACTIONS(1624),
    [anon_sym_unsigned] = ACTIONS(1624),
    [anon_sym_long] = ACTIONS(1624),
    [anon_sym_short] = ACTIONS(1624),
    [sym_primitive_type] = ACTIONS(1624),
    [anon_sym_enum] = ACTIONS(1624),
    [anon_sym_struct] = ACTIONS(1624),
    [anon_sym_union] = ACTIONS(1624),
    [anon_sym_if] = ACTIONS(1624),
    [anon_sym_switch] = ACTIONS(1624),
    [anon_sym_case] = ACTIONS(1624),
    [anon_sym_default] = ACTIONS(1624),
    [anon_sym_while] = ACTIONS(1624),
    [anon_sym_do] = ACTIONS(1624),
    [anon_sym_for] = ACTIONS(1624),
    [anon_sym_return] = ACTIONS(1624),
    [anon_sym_break] = ACTIONS(1624),
    [anon_sym_continue] = ACTIONS(1624),
    [anon_sym_goto] = ACTIONS(1624),
    [anon_sym_AMP] = ACTIONS(1622),
    [anon_sym_BANG] = ACTIONS(1622),
    [anon_sym_TILDE] = ACTIONS(1622),
    [anon_sym_PLUS] = ACTIONS(1624),
    [anon_sym_DASH] = ACTIONS(1624),
    [anon_sym_DASH_DASH] = ACTIONS(1622),
    [anon_sym_PLUS_PLUS] = ACTIONS(1622),
    [anon_sym_sizeof] = ACTIONS(1624),
    [sym_number_literal] = ACTIONS(1622),
    [sym_char_literal] = ACTIONS(1622),
    [sym_string_literal] = ACTIONS(1622),
    [sym_true] = ACTIONS(1624),
    [sym_false] = ACTIONS(1624),
    [sym_null] = ACTIONS(1624),
    [sym_identifier] = ACTIONS(1624),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(1624),
    [sym_auto] = ACTIONS(1624),
    [anon_sym_typename] = ACTIONS(1624),
    [anon_sym_new] = ACTIONS(1624),
    [anon_sym_COLON_COLON] = ACTIONS(1622),
    [anon_sym_delete] = ACTIONS(1624),
    [sym_nullptr] = ACTIONS(1624),
  },
  [841] = {
    [sym_preproc_include] = STATE(913),
    [sym_preproc_def] = STATE(913),
    [sym_preproc_function_def] = STATE(913),
    [sym_preproc_call] = STATE(913),
    [sym_preproc_if_in_compound_statement] = STATE(410),
    [sym_preproc_ifdef_in_compound_statement] = STATE(411),
    [sym_declaration] = STATE(913),
    [sym_type_definition] = STATE(913),
    [sym__declaration_specifiers] = STATE(412),
    [sym_compound_statement] = STATE(913),
    [sym_storage_class_specifier] = STATE(419),
    [sym_type_qualifier] = STATE(419),
    [sym__type_specifier] = STATE(30),
    [sym_sized_type_specifier] = STATE(30),
    [sym_enum_specifier] = STATE(30),
    [sym_struct_specifier] = STATE(30),
    [sym_union_specifier] = STATE(30),
    [sym_labeled_statement] = STATE(913),
    [sym_expression_statement] = STATE(913),
    [sym_if_statement] = STATE(913),
    [sym_switch_statement] = STATE(913),
    [sym_case_statement] = STATE(913),
    [sym_while_statement] = STATE(913),
    [sym_do_statement] = STATE(913),
    [sym_for_statement] = STATE(913),
    [sym_return_statement] = STATE(913),
    [sym_break_statement] = STATE(913),
    [sym_continue_statement] = STATE(913),
    [sym_goto_statement] = STATE(913),
    [sym__expression] = STATE(413),
    [sym_comma_expression] = STATE(414),
    [sym_conditional_expression] = STATE(413),
    [sym_assignment_expression] = STATE(413),
    [sym_pointer_expression] = STATE(413),
    [sym_logical_expression] = STATE(413),
    [sym_bitwise_expression] = STATE(413),
    [sym_equality_expression] = STATE(413),
    [sym_relational_expression] = STATE(413),
    [sym_shift_expression] = STATE(413),
    [sym_math_expression] = STATE(413),
    [sym_cast_expression] = STATE(413),
    [sym_sizeof_expression] = STATE(413),
    [sym_subscript_expression] = STATE(413),
    [sym_call_expression] = STATE(413),
    [sym_field_expression] = STATE(413),
    [sym_compound_literal_expression] = STATE(413),
    [sym_parenthesized_expression] = STATE(413),
    [sym_concatenated_string] = STATE(413),
    [sym__empty_declaration] = STATE(913),
    [sym_macro_type_specifier] = STATE(30),
    [sym_class_specifier] = STATE(30),
    [sym_dependent_type] = STATE(30),
    [sym_structured_binding_declaration] = STATE(913),
    [sym_template_type] = STATE(415),
    [sym_template_function] = STATE(413),
    [sym_for_range_loop] = STATE(913),
    [sym_new_expression] = STATE(413),
    [sym_delete_expression] = STATE(413),
    [sym_lambda_expression] = STATE(413),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(416),
    [sym_scoped_namespace_identifier] = STATE(417),
    [aux_sym_preproc_if_in_compound_statement_repeat1] = STATE(913),
    [aux_sym__declaration_specifiers_repeat1] = STATE(419),
    [aux_sym_sized_type_specifier_repeat1] = STATE(38),
    [sym_raw_string_literal] = ACTIONS(620),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(622),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(624),
    [anon_sym_LPAREN] = ACTIONS(626),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(628),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(630),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(632),
    [sym_preproc_directive] = ACTIONS(634),
    [anon_sym_SEMI] = ACTIONS(636),
    [anon_sym_typedef] = ACTIONS(638),
    [anon_sym_extern] = ACTIONS(154),
    [anon_sym_LBRACE] = ACTIONS(640),
    [anon_sym_RBRACE] = ACTIONS(2939),
    [anon_sym_STAR] = ACTIONS(644),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_static] = ACTIONS(154),
    [anon_sym_register] = ACTIONS(154),
    [anon_sym_inline] = ACTIONS(154),
    [anon_sym_const] = ACTIONS(158),
    [anon_sym_restrict] = ACTIONS(158),
    [anon_sym_volatile] = ACTIONS(158),
    [anon_sym__Atomic] = ACTIONS(158),
    [anon_sym_mutable] = ACTIONS(158),
    [anon_sym_explicit] = ACTIONS(158),
    [anon_sym_constexpr] = ACTIONS(158),
    [anon_sym_unsigned] = ACTIONS(31),
    [anon_sym_long] = ACTIONS(31),
    [anon_sym_short] = ACTIONS(31),
    [sym_primitive_type] = ACTIONS(33),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_union] = ACTIONS(39),
    [anon_sym_if] = ACTIONS(646),
    [anon_sym_switch] = ACTIONS(648),
    [anon_sym_case] = ACTIONS(650),
    [anon_sym_default] = ACTIONS(652),
    [anon_sym_while] = ACTIONS(654),
    [anon_sym_do] = ACTIONS(656),
    [anon_sym_for] = ACTIONS(658),
    [anon_sym_return] = ACTIONS(660),
    [anon_sym_break] = ACTIONS(662),
    [anon_sym_continue] = ACTIONS(664),
    [anon_sym_goto] = ACTIONS(666),
    [anon_sym_AMP] = ACTIONS(644),
    [anon_sym_BANG] = ACTIONS(668),
    [anon_sym_TILDE] = ACTIONS(670),
    [anon_sym_PLUS] = ACTIONS(672),
    [anon_sym_DASH] = ACTIONS(672),
    [anon_sym_DASH_DASH] = ACTIONS(674),
    [anon_sym_PLUS_PLUS] = ACTIONS(674),
    [anon_sym_sizeof] = ACTIONS(676),
    [sym_number_literal] = ACTIONS(620),
    [sym_char_literal] = ACTIONS(620),
    [sym_string_literal] = ACTIONS(678),
    [sym_true] = ACTIONS(680),
    [sym_false] = ACTIONS(680),
    [sym_null] = ACTIONS(680),
    [sym_identifier] = ACTIONS(682),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(51),
    [sym_auto] = ACTIONS(33),
    [anon_sym_typename] = ACTIONS(53),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(684),
    [anon_sym_delete] = ACTIONS(686),
    [sym_nullptr] = ACTIONS(680),
  },
  [842] = {
    [sym__expression] = STATE(1443),
    [sym_conditional_expression] = STATE(1443),
    [sym_assignment_expression] = STATE(1443),
    [sym_pointer_expression] = STATE(1443),
    [sym_logical_expression] = STATE(1443),
    [sym_bitwise_expression] = STATE(1443),
    [sym_equality_expression] = STATE(1443),
    [sym_relational_expression] = STATE(1443),
    [sym_shift_expression] = STATE(1443),
    [sym_math_expression] = STATE(1443),
    [sym_cast_expression] = STATE(1443),
    [sym_sizeof_expression] = STATE(1443),
    [sym_subscript_expression] = STATE(1443),
    [sym_call_expression] = STATE(1443),
    [sym_field_expression] = STATE(1443),
    [sym_compound_literal_expression] = STATE(1443),
    [sym_parenthesized_expression] = STATE(1443),
    [sym_concatenated_string] = STATE(1443),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(1443),
    [sym_new_expression] = STATE(1443),
    [sym_delete_expression] = STATE(1443),
    [sym_lambda_expression] = STATE(1443),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(2941),
    [anon_sym_LPAREN] = ACTIONS(2943),
    [anon_sym_STAR] = ACTIONS(2945),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_AMP] = ACTIONS(2945),
    [anon_sym_BANG] = ACTIONS(2947),
    [anon_sym_TILDE] = ACTIONS(2949),
    [anon_sym_PLUS] = ACTIONS(2951),
    [anon_sym_DASH] = ACTIONS(2951),
    [anon_sym_DASH_DASH] = ACTIONS(2953),
    [anon_sym_PLUS_PLUS] = ACTIONS(2953),
    [anon_sym_sizeof] = ACTIONS(2955),
    [sym_number_literal] = ACTIONS(2941),
    [sym_char_literal] = ACTIONS(2941),
    [sym_string_literal] = ACTIONS(2957),
    [sym_true] = ACTIONS(2959),
    [sym_false] = ACTIONS(2959),
    [sym_null] = ACTIONS(2959),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(2961),
    [anon_sym_delete] = ACTIONS(2963),
    [sym_nullptr] = ACTIONS(2959),
  },
  [843] = {
    [anon_sym_LPAREN] = ACTIONS(2965),
    [sym_comment] = ACTIONS(49),
  },
  [844] = {
    [sym__expression] = STATE(1445),
    [sym_conditional_expression] = STATE(1445),
    [sym_assignment_expression] = STATE(1445),
    [sym_pointer_expression] = STATE(1445),
    [sym_logical_expression] = STATE(1445),
    [sym_bitwise_expression] = STATE(1445),
    [sym_equality_expression] = STATE(1445),
    [sym_relational_expression] = STATE(1445),
    [sym_shift_expression] = STATE(1445),
    [sym_math_expression] = STATE(1445),
    [sym_cast_expression] = STATE(1445),
    [sym_sizeof_expression] = STATE(1445),
    [sym_subscript_expression] = STATE(1445),
    [sym_call_expression] = STATE(1445),
    [sym_field_expression] = STATE(1445),
    [sym_compound_literal_expression] = STATE(1445),
    [sym_parenthesized_expression] = STATE(1445),
    [sym_concatenated_string] = STATE(1445),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(1445),
    [sym_new_expression] = STATE(1445),
    [sym_delete_expression] = STATE(1445),
    [sym_lambda_expression] = STATE(1445),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(2967),
    [anon_sym_LPAREN] = ACTIONS(2943),
    [anon_sym_STAR] = ACTIONS(2945),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_AMP] = ACTIONS(2945),
    [anon_sym_BANG] = ACTIONS(2947),
    [anon_sym_TILDE] = ACTIONS(2949),
    [anon_sym_PLUS] = ACTIONS(2951),
    [anon_sym_DASH] = ACTIONS(2951),
    [anon_sym_DASH_DASH] = ACTIONS(2953),
    [anon_sym_PLUS_PLUS] = ACTIONS(2953),
    [anon_sym_sizeof] = ACTIONS(2955),
    [sym_number_literal] = ACTIONS(2967),
    [sym_char_literal] = ACTIONS(2967),
    [sym_string_literal] = ACTIONS(2957),
    [sym_true] = ACTIONS(2969),
    [sym_false] = ACTIONS(2969),
    [sym_null] = ACTIONS(2969),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(2961),
    [anon_sym_delete] = ACTIONS(2963),
    [sym_nullptr] = ACTIONS(2969),
  },
  [845] = {
    [sym_type_qualifier] = STATE(724),
    [sym__type_specifier] = STATE(720),
    [sym_sized_type_specifier] = STATE(720),
    [sym_enum_specifier] = STATE(720),
    [sym_struct_specifier] = STATE(720),
    [sym_union_specifier] = STATE(720),
    [sym__expression] = STATE(721),
    [sym_comma_expression] = STATE(722),
    [sym_conditional_expression] = STATE(721),
    [sym_assignment_expression] = STATE(721),
    [sym_pointer_expression] = STATE(721),
    [sym_logical_expression] = STATE(721),
    [sym_bitwise_expression] = STATE(721),
    [sym_equality_expression] = STATE(721),
    [sym_relational_expression] = STATE(721),
    [sym_shift_expression] = STATE(721),
    [sym_math_expression] = STATE(721),
    [sym_cast_expression] = STATE(721),
    [sym_type_descriptor] = STATE(1446),
    [sym_sizeof_expression] = STATE(721),
    [sym_subscript_expression] = STATE(721),
    [sym_call_expression] = STATE(721),
    [sym_field_expression] = STATE(721),
    [sym_compound_literal_expression] = STATE(721),
    [sym_parenthesized_expression] = STATE(721),
    [sym_concatenated_string] = STATE(721),
    [sym_macro_type_specifier] = STATE(720),
    [sym_class_specifier] = STATE(720),
    [sym_dependent_type] = STATE(720),
    [sym_template_type] = STATE(415),
    [sym_template_function] = STATE(721),
    [sym_new_expression] = STATE(721),
    [sym_delete_expression] = STATE(721),
    [sym_lambda_expression] = STATE(721),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(416),
    [sym_scoped_namespace_identifier] = STATE(417),
    [aux_sym_type_definition_repeat1] = STATE(724),
    [aux_sym_sized_type_specifier_repeat1] = STATE(725),
    [sym_raw_string_literal] = ACTIONS(1397),
    [anon_sym_LPAREN] = ACTIONS(1087),
    [anon_sym_STAR] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_restrict] = ACTIONS(93),
    [anon_sym_volatile] = ACTIONS(93),
    [anon_sym__Atomic] = ACTIONS(93),
    [anon_sym_mutable] = ACTIONS(93),
    [anon_sym_explicit] = ACTIONS(93),
    [anon_sym_constexpr] = ACTIONS(93),
    [anon_sym_unsigned] = ACTIONS(1399),
    [anon_sym_long] = ACTIONS(1399),
    [anon_sym_short] = ACTIONS(1399),
    [sym_primitive_type] = ACTIONS(1401),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(428),
    [anon_sym_union] = ACTIONS(430),
    [anon_sym_AMP] = ACTIONS(1089),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1093),
    [anon_sym_PLUS] = ACTIONS(1095),
    [anon_sym_DASH] = ACTIONS(1095),
    [anon_sym_DASH_DASH] = ACTIONS(1097),
    [anon_sym_PLUS_PLUS] = ACTIONS(1097),
    [anon_sym_sizeof] = ACTIONS(1099),
    [sym_number_literal] = ACTIONS(1397),
    [sym_char_literal] = ACTIONS(1397),
    [sym_string_literal] = ACTIONS(1101),
    [sym_true] = ACTIONS(1403),
    [sym_false] = ACTIONS(1403),
    [sym_null] = ACTIONS(1403),
    [sym_identifier] = ACTIONS(1405),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(436),
    [sym_auto] = ACTIONS(1401),
    [anon_sym_typename] = ACTIONS(1407),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1409),
    [anon_sym_delete] = ACTIONS(1109),
    [sym_nullptr] = ACTIONS(1403),
  },
  [846] = {
    [sym__expression] = STATE(1447),
    [sym_conditional_expression] = STATE(1447),
    [sym_assignment_expression] = STATE(1447),
    [sym_pointer_expression] = STATE(1447),
    [sym_logical_expression] = STATE(1447),
    [sym_bitwise_expression] = STATE(1447),
    [sym_equality_expression] = STATE(1447),
    [sym_relational_expression] = STATE(1447),
    [sym_shift_expression] = STATE(1447),
    [sym_math_expression] = STATE(1447),
    [sym_cast_expression] = STATE(1447),
    [sym_sizeof_expression] = STATE(1447),
    [sym_subscript_expression] = STATE(1447),
    [sym_call_expression] = STATE(1447),
    [sym_field_expression] = STATE(1447),
    [sym_compound_literal_expression] = STATE(1447),
    [sym_parenthesized_expression] = STATE(1447),
    [sym_concatenated_string] = STATE(1447),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(1447),
    [sym_new_expression] = STATE(1447),
    [sym_delete_expression] = STATE(1447),
    [sym_lambda_expression] = STATE(1447),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(855),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(2971),
    [anon_sym_LPAREN] = ACTIONS(1634),
    [anon_sym_STAR] = ACTIONS(1636),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_AMP] = ACTIONS(1636),
    [anon_sym_BANG] = ACTIONS(1638),
    [anon_sym_TILDE] = ACTIONS(1640),
    [anon_sym_PLUS] = ACTIONS(1642),
    [anon_sym_DASH] = ACTIONS(1642),
    [anon_sym_DASH_DASH] = ACTIONS(1644),
    [anon_sym_PLUS_PLUS] = ACTIONS(1644),
    [anon_sym_sizeof] = ACTIONS(1646),
    [sym_number_literal] = ACTIONS(2971),
    [sym_char_literal] = ACTIONS(2971),
    [sym_string_literal] = ACTIONS(1648),
    [sym_true] = ACTIONS(2973),
    [sym_false] = ACTIONS(2973),
    [sym_null] = ACTIONS(2973),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1652),
    [anon_sym_delete] = ACTIONS(1654),
    [sym_nullptr] = ACTIONS(2973),
  },
  [847] = {
    [sym__expression] = STATE(1448),
    [sym_conditional_expression] = STATE(1448),
    [sym_assignment_expression] = STATE(1448),
    [sym_pointer_expression] = STATE(1448),
    [sym_logical_expression] = STATE(1448),
    [sym_bitwise_expression] = STATE(1448),
    [sym_equality_expression] = STATE(1448),
    [sym_relational_expression] = STATE(1448),
    [sym_shift_expression] = STATE(1448),
    [sym_math_expression] = STATE(1448),
    [sym_cast_expression] = STATE(1448),
    [sym_sizeof_expression] = STATE(1448),
    [sym_subscript_expression] = STATE(1448),
    [sym_call_expression] = STATE(1448),
    [sym_field_expression] = STATE(1448),
    [sym_compound_literal_expression] = STATE(1448),
    [sym_parenthesized_expression] = STATE(1448),
    [sym_concatenated_string] = STATE(1448),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(1448),
    [sym_new_expression] = STATE(1448),
    [sym_delete_expression] = STATE(1448),
    [sym_lambda_expression] = STATE(1448),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(855),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(2975),
    [anon_sym_LPAREN] = ACTIONS(1634),
    [anon_sym_STAR] = ACTIONS(1636),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_AMP] = ACTIONS(1636),
    [anon_sym_BANG] = ACTIONS(1638),
    [anon_sym_TILDE] = ACTIONS(1640),
    [anon_sym_PLUS] = ACTIONS(1642),
    [anon_sym_DASH] = ACTIONS(1642),
    [anon_sym_DASH_DASH] = ACTIONS(1644),
    [anon_sym_PLUS_PLUS] = ACTIONS(1644),
    [anon_sym_sizeof] = ACTIONS(1646),
    [sym_number_literal] = ACTIONS(2975),
    [sym_char_literal] = ACTIONS(2975),
    [sym_string_literal] = ACTIONS(1648),
    [sym_true] = ACTIONS(2977),
    [sym_false] = ACTIONS(2977),
    [sym_null] = ACTIONS(2977),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1652),
    [anon_sym_delete] = ACTIONS(1654),
    [sym_nullptr] = ACTIONS(2977),
  },
  [848] = {
    [sym__expression] = STATE(1449),
    [sym_conditional_expression] = STATE(1449),
    [sym_assignment_expression] = STATE(1449),
    [sym_pointer_expression] = STATE(1449),
    [sym_logical_expression] = STATE(1449),
    [sym_bitwise_expression] = STATE(1449),
    [sym_equality_expression] = STATE(1449),
    [sym_relational_expression] = STATE(1449),
    [sym_shift_expression] = STATE(1449),
    [sym_math_expression] = STATE(1449),
    [sym_cast_expression] = STATE(1449),
    [sym_sizeof_expression] = STATE(1449),
    [sym_subscript_expression] = STATE(1449),
    [sym_call_expression] = STATE(1449),
    [sym_field_expression] = STATE(1449),
    [sym_compound_literal_expression] = STATE(1449),
    [sym_parenthesized_expression] = STATE(1449),
    [sym_concatenated_string] = STATE(1449),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(1449),
    [sym_new_expression] = STATE(1449),
    [sym_delete_expression] = STATE(1449),
    [sym_lambda_expression] = STATE(1449),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(855),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(2979),
    [anon_sym_LPAREN] = ACTIONS(1634),
    [anon_sym_STAR] = ACTIONS(1636),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_AMP] = ACTIONS(1636),
    [anon_sym_BANG] = ACTIONS(1638),
    [anon_sym_TILDE] = ACTIONS(1640),
    [anon_sym_PLUS] = ACTIONS(1642),
    [anon_sym_DASH] = ACTIONS(1642),
    [anon_sym_DASH_DASH] = ACTIONS(1644),
    [anon_sym_PLUS_PLUS] = ACTIONS(1644),
    [anon_sym_sizeof] = ACTIONS(1646),
    [sym_number_literal] = ACTIONS(2979),
    [sym_char_literal] = ACTIONS(2979),
    [sym_string_literal] = ACTIONS(1648),
    [sym_true] = ACTIONS(2981),
    [sym_false] = ACTIONS(2981),
    [sym_null] = ACTIONS(2981),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1652),
    [anon_sym_delete] = ACTIONS(1654),
    [sym_nullptr] = ACTIONS(2981),
  },
  [849] = {
    [sym__expression] = STATE(1450),
    [sym_conditional_expression] = STATE(1450),
    [sym_assignment_expression] = STATE(1450),
    [sym_pointer_expression] = STATE(1450),
    [sym_logical_expression] = STATE(1450),
    [sym_bitwise_expression] = STATE(1450),
    [sym_equality_expression] = STATE(1450),
    [sym_relational_expression] = STATE(1450),
    [sym_shift_expression] = STATE(1450),
    [sym_math_expression] = STATE(1450),
    [sym_cast_expression] = STATE(1450),
    [sym_sizeof_expression] = STATE(1450),
    [sym_subscript_expression] = STATE(1450),
    [sym_call_expression] = STATE(1450),
    [sym_field_expression] = STATE(1450),
    [sym_compound_literal_expression] = STATE(1450),
    [sym_parenthesized_expression] = STATE(1450),
    [sym_concatenated_string] = STATE(1450),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(1450),
    [sym_new_expression] = STATE(1450),
    [sym_delete_expression] = STATE(1450),
    [sym_lambda_expression] = STATE(1450),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(855),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(2983),
    [anon_sym_LPAREN] = ACTIONS(1634),
    [anon_sym_STAR] = ACTIONS(1636),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_AMP] = ACTIONS(1636),
    [anon_sym_BANG] = ACTIONS(1638),
    [anon_sym_TILDE] = ACTIONS(1640),
    [anon_sym_PLUS] = ACTIONS(1642),
    [anon_sym_DASH] = ACTIONS(1642),
    [anon_sym_DASH_DASH] = ACTIONS(1644),
    [anon_sym_PLUS_PLUS] = ACTIONS(1644),
    [anon_sym_sizeof] = ACTIONS(1646),
    [sym_number_literal] = ACTIONS(2983),
    [sym_char_literal] = ACTIONS(2983),
    [sym_string_literal] = ACTIONS(1648),
    [sym_true] = ACTIONS(2985),
    [sym_false] = ACTIONS(2985),
    [sym_null] = ACTIONS(2985),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1652),
    [anon_sym_delete] = ACTIONS(1654),
    [sym_nullptr] = ACTIONS(2985),
  },
  [850] = {
    [sym__expression] = STATE(1452),
    [sym_conditional_expression] = STATE(1452),
    [sym_assignment_expression] = STATE(1452),
    [sym_pointer_expression] = STATE(1452),
    [sym_logical_expression] = STATE(1452),
    [sym_bitwise_expression] = STATE(1452),
    [sym_equality_expression] = STATE(1452),
    [sym_relational_expression] = STATE(1452),
    [sym_shift_expression] = STATE(1452),
    [sym_math_expression] = STATE(1452),
    [sym_cast_expression] = STATE(1452),
    [sym_sizeof_expression] = STATE(1452),
    [sym_subscript_expression] = STATE(1452),
    [sym_call_expression] = STATE(1452),
    [sym_field_expression] = STATE(1452),
    [sym_compound_literal_expression] = STATE(1452),
    [sym_parenthesized_expression] = STATE(1452),
    [sym_concatenated_string] = STATE(1452),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(1452),
    [sym_new_expression] = STATE(1452),
    [sym_delete_expression] = STATE(1452),
    [sym_lambda_expression] = STATE(1452),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(855),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(2987),
    [anon_sym_LPAREN] = ACTIONS(2989),
    [anon_sym_STAR] = ACTIONS(1636),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_AMP] = ACTIONS(1636),
    [anon_sym_BANG] = ACTIONS(1638),
    [anon_sym_TILDE] = ACTIONS(1640),
    [anon_sym_PLUS] = ACTIONS(1642),
    [anon_sym_DASH] = ACTIONS(1642),
    [anon_sym_DASH_DASH] = ACTIONS(1644),
    [anon_sym_PLUS_PLUS] = ACTIONS(1644),
    [anon_sym_sizeof] = ACTIONS(1646),
    [sym_number_literal] = ACTIONS(2987),
    [sym_char_literal] = ACTIONS(2987),
    [sym_string_literal] = ACTIONS(1648),
    [sym_true] = ACTIONS(2991),
    [sym_false] = ACTIONS(2991),
    [sym_null] = ACTIONS(2991),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1652),
    [anon_sym_delete] = ACTIONS(1654),
    [sym_nullptr] = ACTIONS(2991),
  },
  [851] = {
    [aux_sym_concatenated_string_repeat1] = STATE(1453),
    [anon_sym_LPAREN] = ACTIONS(1477),
    [anon_sym_STAR] = ACTIONS(1479),
    [anon_sym_LBRACK] = ACTIONS(1477),
    [anon_sym_EQ] = ACTIONS(1479),
    [anon_sym_COLON] = ACTIONS(1477),
    [anon_sym_QMARK] = ACTIONS(1477),
    [anon_sym_STAR_EQ] = ACTIONS(1477),
    [anon_sym_SLASH_EQ] = ACTIONS(1477),
    [anon_sym_PERCENT_EQ] = ACTIONS(1477),
    [anon_sym_PLUS_EQ] = ACTIONS(1477),
    [anon_sym_DASH_EQ] = ACTIONS(1477),
    [anon_sym_LT_LT_EQ] = ACTIONS(1477),
    [anon_sym_GT_GT_EQ] = ACTIONS(1477),
    [anon_sym_AMP_EQ] = ACTIONS(1477),
    [anon_sym_CARET_EQ] = ACTIONS(1477),
    [anon_sym_PIPE_EQ] = ACTIONS(1477),
    [anon_sym_AMP] = ACTIONS(1479),
    [anon_sym_PIPE_PIPE] = ACTIONS(1477),
    [anon_sym_AMP_AMP] = ACTIONS(1477),
    [anon_sym_PIPE] = ACTIONS(1479),
    [anon_sym_CARET] = ACTIONS(1479),
    [anon_sym_EQ_EQ] = ACTIONS(1477),
    [anon_sym_BANG_EQ] = ACTIONS(1477),
    [anon_sym_LT] = ACTIONS(1479),
    [anon_sym_GT] = ACTIONS(1479),
    [anon_sym_LT_EQ] = ACTIONS(1477),
    [anon_sym_GT_EQ] = ACTIONS(1477),
    [anon_sym_LT_LT] = ACTIONS(1479),
    [anon_sym_GT_GT] = ACTIONS(1479),
    [anon_sym_PLUS] = ACTIONS(1479),
    [anon_sym_DASH] = ACTIONS(1479),
    [anon_sym_SLASH] = ACTIONS(1479),
    [anon_sym_PERCENT] = ACTIONS(1479),
    [anon_sym_DASH_DASH] = ACTIONS(1477),
    [anon_sym_PLUS_PLUS] = ACTIONS(1477),
    [anon_sym_DOT] = ACTIONS(1477),
    [anon_sym_DASH_GT] = ACTIONS(1477),
    [sym_string_literal] = ACTIONS(2993),
    [sym_comment] = ACTIONS(49),
  },
  [852] = {
    [sym_destructor_name] = STATE(120),
    [anon_sym_TILDE] = ACTIONS(1500),
    [sym_identifier] = ACTIONS(2220),
    [sym_comment] = ACTIONS(49),
    [anon_sym_delete] = ACTIONS(2995),
    [sym_operator_name] = ACTIONS(190),
  },
  [853] = {
    [sym__expression] = STATE(1456),
    [sym_conditional_expression] = STATE(1456),
    [sym_assignment_expression] = STATE(1456),
    [sym_pointer_expression] = STATE(1456),
    [sym_logical_expression] = STATE(1456),
    [sym_bitwise_expression] = STATE(1456),
    [sym_equality_expression] = STATE(1456),
    [sym_relational_expression] = STATE(1456),
    [sym_shift_expression] = STATE(1456),
    [sym_math_expression] = STATE(1456),
    [sym_cast_expression] = STATE(1456),
    [sym_sizeof_expression] = STATE(1456),
    [sym_subscript_expression] = STATE(1456),
    [sym_call_expression] = STATE(1456),
    [sym_field_expression] = STATE(1456),
    [sym_compound_literal_expression] = STATE(1456),
    [sym_parenthesized_expression] = STATE(1456),
    [sym_concatenated_string] = STATE(1456),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(1456),
    [sym_new_expression] = STATE(1456),
    [sym_delete_expression] = STATE(1456),
    [sym_lambda_expression] = STATE(1456),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(855),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(2997),
    [anon_sym_LPAREN] = ACTIONS(1634),
    [anon_sym_STAR] = ACTIONS(1636),
    [anon_sym_LBRACK] = ACTIONS(2999),
    [anon_sym_AMP] = ACTIONS(1636),
    [anon_sym_BANG] = ACTIONS(1638),
    [anon_sym_TILDE] = ACTIONS(1640),
    [anon_sym_PLUS] = ACTIONS(1642),
    [anon_sym_DASH] = ACTIONS(1642),
    [anon_sym_DASH_DASH] = ACTIONS(1644),
    [anon_sym_PLUS_PLUS] = ACTIONS(1644),
    [anon_sym_sizeof] = ACTIONS(1646),
    [sym_number_literal] = ACTIONS(2997),
    [sym_char_literal] = ACTIONS(2997),
    [sym_string_literal] = ACTIONS(1648),
    [sym_true] = ACTIONS(3001),
    [sym_false] = ACTIONS(3001),
    [sym_null] = ACTIONS(3001),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1652),
    [anon_sym_delete] = ACTIONS(1654),
    [sym_nullptr] = ACTIONS(3001),
  },
  [854] = {
    [sym_argument_list] = STATE(802),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_STAR] = ACTIONS(3003),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_EQ] = ACTIONS(3005),
    [anon_sym_COLON] = ACTIONS(3007),
    [anon_sym_QMARK] = ACTIONS(3009),
    [anon_sym_STAR_EQ] = ACTIONS(3011),
    [anon_sym_SLASH_EQ] = ACTIONS(3011),
    [anon_sym_PERCENT_EQ] = ACTIONS(3011),
    [anon_sym_PLUS_EQ] = ACTIONS(3011),
    [anon_sym_DASH_EQ] = ACTIONS(3011),
    [anon_sym_LT_LT_EQ] = ACTIONS(3011),
    [anon_sym_GT_GT_EQ] = ACTIONS(3011),
    [anon_sym_AMP_EQ] = ACTIONS(3011),
    [anon_sym_CARET_EQ] = ACTIONS(3011),
    [anon_sym_PIPE_EQ] = ACTIONS(3011),
    [anon_sym_AMP] = ACTIONS(3013),
    [anon_sym_PIPE_PIPE] = ACTIONS(3015),
    [anon_sym_AMP_AMP] = ACTIONS(3017),
    [anon_sym_PIPE] = ACTIONS(3019),
    [anon_sym_CARET] = ACTIONS(3021),
    [anon_sym_EQ_EQ] = ACTIONS(3023),
    [anon_sym_BANG_EQ] = ACTIONS(3023),
    [anon_sym_LT] = ACTIONS(3025),
    [anon_sym_GT] = ACTIONS(3025),
    [anon_sym_LT_EQ] = ACTIONS(3027),
    [anon_sym_GT_EQ] = ACTIONS(3027),
    [anon_sym_LT_LT] = ACTIONS(3029),
    [anon_sym_GT_GT] = ACTIONS(3029),
    [anon_sym_PLUS] = ACTIONS(3031),
    [anon_sym_DASH] = ACTIONS(3031),
    [anon_sym_SLASH] = ACTIONS(3003),
    [anon_sym_PERCENT] = ACTIONS(3003),
    [anon_sym_DASH_DASH] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(3033),
    [anon_sym_DASH_GT] = ACTIONS(3033),
    [sym_comment] = ACTIONS(49),
  },
  [855] = {
    [sym_template_argument_list] = STATE(140),
    [anon_sym_LPAREN] = ACTIONS(1477),
    [anon_sym_STAR] = ACTIONS(1479),
    [anon_sym_LBRACK] = ACTIONS(1477),
    [anon_sym_EQ] = ACTIONS(1479),
    [anon_sym_COLON] = ACTIONS(1477),
    [anon_sym_QMARK] = ACTIONS(1477),
    [anon_sym_STAR_EQ] = ACTIONS(1477),
    [anon_sym_SLASH_EQ] = ACTIONS(1477),
    [anon_sym_PERCENT_EQ] = ACTIONS(1477),
    [anon_sym_PLUS_EQ] = ACTIONS(1477),
    [anon_sym_DASH_EQ] = ACTIONS(1477),
    [anon_sym_LT_LT_EQ] = ACTIONS(1477),
    [anon_sym_GT_GT_EQ] = ACTIONS(1477),
    [anon_sym_AMP_EQ] = ACTIONS(1477),
    [anon_sym_CARET_EQ] = ACTIONS(1477),
    [anon_sym_PIPE_EQ] = ACTIONS(1477),
    [anon_sym_AMP] = ACTIONS(1479),
    [anon_sym_PIPE_PIPE] = ACTIONS(1477),
    [anon_sym_AMP_AMP] = ACTIONS(1477),
    [anon_sym_PIPE] = ACTIONS(1479),
    [anon_sym_CARET] = ACTIONS(1479),
    [anon_sym_EQ_EQ] = ACTIONS(1477),
    [anon_sym_BANG_EQ] = ACTIONS(1477),
    [anon_sym_LT] = ACTIONS(3035),
    [anon_sym_GT] = ACTIONS(1479),
    [anon_sym_LT_EQ] = ACTIONS(1477),
    [anon_sym_GT_EQ] = ACTIONS(1477),
    [anon_sym_LT_LT] = ACTIONS(1479),
    [anon_sym_GT_GT] = ACTIONS(1479),
    [anon_sym_PLUS] = ACTIONS(1479),
    [anon_sym_DASH] = ACTIONS(1479),
    [anon_sym_SLASH] = ACTIONS(1479),
    [anon_sym_PERCENT] = ACTIONS(1479),
    [anon_sym_DASH_DASH] = ACTIONS(1477),
    [anon_sym_PLUS_PLUS] = ACTIONS(1477),
    [anon_sym_DOT] = ACTIONS(1477),
    [anon_sym_DASH_GT] = ACTIONS(1477),
    [sym_comment] = ACTIONS(49),
  },
  [856] = {
    [sym_declaration] = STATE(1473),
    [sym_type_definition] = STATE(1473),
    [sym__declaration_specifiers] = STATE(1474),
    [sym_compound_statement] = STATE(1473),
    [sym_storage_class_specifier] = STATE(109),
    [sym_type_qualifier] = STATE(109),
    [sym__type_specifier] = STATE(105),
    [sym_sized_type_specifier] = STATE(105),
    [sym_enum_specifier] = STATE(105),
    [sym_struct_specifier] = STATE(105),
    [sym_union_specifier] = STATE(105),
    [sym_labeled_statement] = STATE(1473),
    [sym_expression_statement] = STATE(1473),
    [sym_if_statement] = STATE(1473),
    [sym_switch_statement] = STATE(1473),
    [sym_case_statement] = STATE(1473),
    [sym_while_statement] = STATE(1473),
    [sym_do_statement] = STATE(1473),
    [sym_for_statement] = STATE(1473),
    [sym_return_statement] = STATE(1473),
    [sym_break_statement] = STATE(1473),
    [sym_continue_statement] = STATE(1473),
    [sym_goto_statement] = STATE(1473),
    [sym__expression] = STATE(413),
    [sym_comma_expression] = STATE(414),
    [sym_conditional_expression] = STATE(413),
    [sym_assignment_expression] = STATE(413),
    [sym_pointer_expression] = STATE(413),
    [sym_logical_expression] = STATE(413),
    [sym_bitwise_expression] = STATE(413),
    [sym_equality_expression] = STATE(413),
    [sym_relational_expression] = STATE(413),
    [sym_shift_expression] = STATE(413),
    [sym_math_expression] = STATE(413),
    [sym_cast_expression] = STATE(413),
    [sym_sizeof_expression] = STATE(413),
    [sym_subscript_expression] = STATE(413),
    [sym_call_expression] = STATE(413),
    [sym_field_expression] = STATE(413),
    [sym_compound_literal_expression] = STATE(413),
    [sym_parenthesized_expression] = STATE(413),
    [sym_concatenated_string] = STATE(413),
    [sym_macro_type_specifier] = STATE(105),
    [sym_class_specifier] = STATE(105),
    [sym_dependent_type] = STATE(105),
    [sym_template_type] = STATE(1475),
    [sym_template_function] = STATE(413),
    [sym_for_range_loop] = STATE(1473),
    [sym_new_expression] = STATE(413),
    [sym_delete_expression] = STATE(413),
    [sym_lambda_expression] = STATE(413),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(416),
    [sym_scoped_namespace_identifier] = STATE(1476),
    [aux_sym__declaration_specifiers_repeat1] = STATE(109),
    [aux_sym_sized_type_specifier_repeat1] = STATE(110),
    [sym_raw_string_literal] = ACTIONS(620),
    [anon_sym_LPAREN] = ACTIONS(626),
    [anon_sym_SEMI] = ACTIONS(636),
    [anon_sym_typedef] = ACTIONS(638),
    [anon_sym_extern] = ACTIONS(154),
    [anon_sym_LBRACE] = ACTIONS(640),
    [anon_sym_STAR] = ACTIONS(644),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_static] = ACTIONS(154),
    [anon_sym_register] = ACTIONS(154),
    [anon_sym_inline] = ACTIONS(154),
    [anon_sym_const] = ACTIONS(158),
    [anon_sym_restrict] = ACTIONS(158),
    [anon_sym_volatile] = ACTIONS(158),
    [anon_sym__Atomic] = ACTIONS(158),
    [anon_sym_mutable] = ACTIONS(158),
    [anon_sym_explicit] = ACTIONS(158),
    [anon_sym_constexpr] = ACTIONS(158),
    [anon_sym_unsigned] = ACTIONS(160),
    [anon_sym_long] = ACTIONS(160),
    [anon_sym_short] = ACTIONS(160),
    [sym_primitive_type] = ACTIONS(162),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_union] = ACTIONS(39),
    [anon_sym_if] = ACTIONS(646),
    [anon_sym_switch] = ACTIONS(648),
    [anon_sym_case] = ACTIONS(650),
    [anon_sym_default] = ACTIONS(652),
    [anon_sym_while] = ACTIONS(654),
    [anon_sym_do] = ACTIONS(656),
    [anon_sym_for] = ACTIONS(658),
    [anon_sym_return] = ACTIONS(660),
    [anon_sym_break] = ACTIONS(662),
    [anon_sym_continue] = ACTIONS(664),
    [anon_sym_goto] = ACTIONS(666),
    [anon_sym_AMP] = ACTIONS(644),
    [anon_sym_BANG] = ACTIONS(668),
    [anon_sym_TILDE] = ACTIONS(670),
    [anon_sym_PLUS] = ACTIONS(672),
    [anon_sym_DASH] = ACTIONS(672),
    [anon_sym_DASH_DASH] = ACTIONS(674),
    [anon_sym_PLUS_PLUS] = ACTIONS(674),
    [anon_sym_sizeof] = ACTIONS(676),
    [sym_number_literal] = ACTIONS(620),
    [sym_char_literal] = ACTIONS(620),
    [sym_string_literal] = ACTIONS(678),
    [sym_true] = ACTIONS(680),
    [sym_false] = ACTIONS(680),
    [sym_null] = ACTIONS(680),
    [sym_identifier] = ACTIONS(3038),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(51),
    [sym_auto] = ACTIONS(162),
    [anon_sym_typename] = ACTIONS(172),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(3040),
    [anon_sym_delete] = ACTIONS(686),
    [sym_nullptr] = ACTIONS(680),
  },
  [857] = {
    [sym__expression] = STATE(1477),
    [sym_conditional_expression] = STATE(1477),
    [sym_assignment_expression] = STATE(1477),
    [sym_pointer_expression] = STATE(1477),
    [sym_logical_expression] = STATE(1477),
    [sym_bitwise_expression] = STATE(1477),
    [sym_equality_expression] = STATE(1477),
    [sym_relational_expression] = STATE(1477),
    [sym_shift_expression] = STATE(1477),
    [sym_math_expression] = STATE(1477),
    [sym_cast_expression] = STATE(1477),
    [sym_sizeof_expression] = STATE(1477),
    [sym_subscript_expression] = STATE(1477),
    [sym_call_expression] = STATE(1477),
    [sym_field_expression] = STATE(1477),
    [sym_compound_literal_expression] = STATE(1477),
    [sym_parenthesized_expression] = STATE(1477),
    [sym_concatenated_string] = STATE(1477),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(1477),
    [sym_new_expression] = STATE(1477),
    [sym_delete_expression] = STATE(1477),
    [sym_lambda_expression] = STATE(1477),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(3042),
    [anon_sym_LPAREN] = ACTIONS(2943),
    [anon_sym_STAR] = ACTIONS(2945),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_AMP] = ACTIONS(2945),
    [anon_sym_BANG] = ACTIONS(2947),
    [anon_sym_TILDE] = ACTIONS(2949),
    [anon_sym_PLUS] = ACTIONS(2951),
    [anon_sym_DASH] = ACTIONS(2951),
    [anon_sym_DASH_DASH] = ACTIONS(2953),
    [anon_sym_PLUS_PLUS] = ACTIONS(2953),
    [anon_sym_sizeof] = ACTIONS(2955),
    [sym_number_literal] = ACTIONS(3042),
    [sym_char_literal] = ACTIONS(3042),
    [sym_string_literal] = ACTIONS(2957),
    [sym_true] = ACTIONS(3044),
    [sym_false] = ACTIONS(3044),
    [sym_null] = ACTIONS(3044),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(2961),
    [anon_sym_delete] = ACTIONS(2963),
    [sym_nullptr] = ACTIONS(3044),
  },
  [858] = {
    [anon_sym_else] = ACTIONS(1614),
    [anon_sym_while] = ACTIONS(1614),
    [sym_comment] = ACTIONS(49),
  },
  [859] = {
    [sym_preproc_include] = STATE(1479),
    [sym_preproc_def] = STATE(1479),
    [sym_preproc_function_def] = STATE(1479),
    [sym_preproc_call] = STATE(1479),
    [sym_preproc_if_in_compound_statement] = STATE(410),
    [sym_preproc_ifdef_in_compound_statement] = STATE(411),
    [sym_declaration] = STATE(1479),
    [sym_type_definition] = STATE(1479),
    [sym__declaration_specifiers] = STATE(412),
    [sym_compound_statement] = STATE(1479),
    [sym_storage_class_specifier] = STATE(419),
    [sym_type_qualifier] = STATE(419),
    [sym__type_specifier] = STATE(30),
    [sym_sized_type_specifier] = STATE(30),
    [sym_enum_specifier] = STATE(30),
    [sym_struct_specifier] = STATE(30),
    [sym_union_specifier] = STATE(30),
    [sym_labeled_statement] = STATE(1479),
    [sym_expression_statement] = STATE(1479),
    [sym_if_statement] = STATE(1479),
    [sym_switch_statement] = STATE(1479),
    [sym_case_statement] = STATE(1479),
    [sym_while_statement] = STATE(1479),
    [sym_do_statement] = STATE(1479),
    [sym_for_statement] = STATE(1479),
    [sym_return_statement] = STATE(1479),
    [sym_break_statement] = STATE(1479),
    [sym_continue_statement] = STATE(1479),
    [sym_goto_statement] = STATE(1479),
    [sym__expression] = STATE(413),
    [sym_comma_expression] = STATE(414),
    [sym_conditional_expression] = STATE(413),
    [sym_assignment_expression] = STATE(413),
    [sym_pointer_expression] = STATE(413),
    [sym_logical_expression] = STATE(413),
    [sym_bitwise_expression] = STATE(413),
    [sym_equality_expression] = STATE(413),
    [sym_relational_expression] = STATE(413),
    [sym_shift_expression] = STATE(413),
    [sym_math_expression] = STATE(413),
    [sym_cast_expression] = STATE(413),
    [sym_sizeof_expression] = STATE(413),
    [sym_subscript_expression] = STATE(413),
    [sym_call_expression] = STATE(413),
    [sym_field_expression] = STATE(413),
    [sym_compound_literal_expression] = STATE(413),
    [sym_parenthesized_expression] = STATE(413),
    [sym_concatenated_string] = STATE(413),
    [sym__empty_declaration] = STATE(1479),
    [sym_macro_type_specifier] = STATE(30),
    [sym_class_specifier] = STATE(30),
    [sym_dependent_type] = STATE(30),
    [sym_structured_binding_declaration] = STATE(1479),
    [sym_template_type] = STATE(415),
    [sym_template_function] = STATE(413),
    [sym_for_range_loop] = STATE(1479),
    [sym_new_expression] = STATE(413),
    [sym_delete_expression] = STATE(413),
    [sym_lambda_expression] = STATE(413),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(416),
    [sym_scoped_namespace_identifier] = STATE(417),
    [aux_sym_preproc_if_in_compound_statement_repeat1] = STATE(1479),
    [aux_sym__declaration_specifiers_repeat1] = STATE(419),
    [aux_sym_sized_type_specifier_repeat1] = STATE(38),
    [sym_raw_string_literal] = ACTIONS(620),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(622),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(624),
    [anon_sym_LPAREN] = ACTIONS(626),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(628),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(630),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(632),
    [sym_preproc_directive] = ACTIONS(634),
    [anon_sym_SEMI] = ACTIONS(636),
    [anon_sym_typedef] = ACTIONS(638),
    [anon_sym_extern] = ACTIONS(154),
    [anon_sym_LBRACE] = ACTIONS(640),
    [anon_sym_RBRACE] = ACTIONS(3046),
    [anon_sym_STAR] = ACTIONS(644),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_static] = ACTIONS(154),
    [anon_sym_register] = ACTIONS(154),
    [anon_sym_inline] = ACTIONS(154),
    [anon_sym_const] = ACTIONS(158),
    [anon_sym_restrict] = ACTIONS(158),
    [anon_sym_volatile] = ACTIONS(158),
    [anon_sym__Atomic] = ACTIONS(158),
    [anon_sym_mutable] = ACTIONS(158),
    [anon_sym_explicit] = ACTIONS(158),
    [anon_sym_constexpr] = ACTIONS(158),
    [anon_sym_unsigned] = ACTIONS(31),
    [anon_sym_long] = ACTIONS(31),
    [anon_sym_short] = ACTIONS(31),
    [sym_primitive_type] = ACTIONS(33),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_union] = ACTIONS(39),
    [anon_sym_if] = ACTIONS(646),
    [anon_sym_switch] = ACTIONS(648),
    [anon_sym_case] = ACTIONS(650),
    [anon_sym_default] = ACTIONS(652),
    [anon_sym_while] = ACTIONS(654),
    [anon_sym_do] = ACTIONS(656),
    [anon_sym_for] = ACTIONS(658),
    [anon_sym_return] = ACTIONS(660),
    [anon_sym_break] = ACTIONS(662),
    [anon_sym_continue] = ACTIONS(664),
    [anon_sym_goto] = ACTIONS(666),
    [anon_sym_AMP] = ACTIONS(644),
    [anon_sym_BANG] = ACTIONS(668),
    [anon_sym_TILDE] = ACTIONS(670),
    [anon_sym_PLUS] = ACTIONS(672),
    [anon_sym_DASH] = ACTIONS(672),
    [anon_sym_DASH_DASH] = ACTIONS(674),
    [anon_sym_PLUS_PLUS] = ACTIONS(674),
    [anon_sym_sizeof] = ACTIONS(676),
    [sym_number_literal] = ACTIONS(620),
    [sym_char_literal] = ACTIONS(620),
    [sym_string_literal] = ACTIONS(678),
    [sym_true] = ACTIONS(680),
    [sym_false] = ACTIONS(680),
    [sym_null] = ACTIONS(680),
    [sym_identifier] = ACTIONS(682),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(51),
    [sym_auto] = ACTIONS(33),
    [anon_sym_typename] = ACTIONS(53),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(684),
    [anon_sym_delete] = ACTIONS(686),
    [sym_nullptr] = ACTIONS(680),
  },
  [860] = {
    [anon_sym_LPAREN] = ACTIONS(3048),
    [anon_sym_constexpr] = ACTIONS(3050),
    [sym_comment] = ACTIONS(49),
  },
  [861] = {
    [anon_sym_LPAREN] = ACTIONS(3052),
    [sym_comment] = ACTIONS(49),
  },
  [862] = {
    [sym__expression] = STATE(1483),
    [sym_conditional_expression] = STATE(1483),
    [sym_assignment_expression] = STATE(1483),
    [sym_pointer_expression] = STATE(1483),
    [sym_logical_expression] = STATE(1483),
    [sym_bitwise_expression] = STATE(1483),
    [sym_equality_expression] = STATE(1483),
    [sym_relational_expression] = STATE(1483),
    [sym_shift_expression] = STATE(1483),
    [sym_math_expression] = STATE(1483),
    [sym_cast_expression] = STATE(1483),
    [sym_sizeof_expression] = STATE(1483),
    [sym_subscript_expression] = STATE(1483),
    [sym_call_expression] = STATE(1483),
    [sym_field_expression] = STATE(1483),
    [sym_compound_literal_expression] = STATE(1483),
    [sym_parenthesized_expression] = STATE(1483),
    [sym_concatenated_string] = STATE(1483),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(1483),
    [sym_new_expression] = STATE(1483),
    [sym_delete_expression] = STATE(1483),
    [sym_lambda_expression] = STATE(1483),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(855),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(3054),
    [anon_sym_LPAREN] = ACTIONS(1634),
    [anon_sym_STAR] = ACTIONS(1636),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_AMP] = ACTIONS(1636),
    [anon_sym_BANG] = ACTIONS(1638),
    [anon_sym_TILDE] = ACTIONS(1640),
    [anon_sym_PLUS] = ACTIONS(1642),
    [anon_sym_DASH] = ACTIONS(1642),
    [anon_sym_DASH_DASH] = ACTIONS(1644),
    [anon_sym_PLUS_PLUS] = ACTIONS(1644),
    [anon_sym_sizeof] = ACTIONS(1646),
    [sym_number_literal] = ACTIONS(3054),
    [sym_char_literal] = ACTIONS(3054),
    [sym_string_literal] = ACTIONS(1648),
    [sym_true] = ACTIONS(3056),
    [sym_false] = ACTIONS(3056),
    [sym_null] = ACTIONS(3056),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1652),
    [anon_sym_delete] = ACTIONS(1654),
    [sym_nullptr] = ACTIONS(3056),
  },
  [863] = {
    [anon_sym_COLON] = ACTIONS(3058),
    [sym_comment] = ACTIONS(49),
  },
  [864] = {
    [anon_sym_LPAREN] = ACTIONS(3060),
    [sym_comment] = ACTIONS(49),
  },
  [865] = {
    [sym_compound_statement] = STATE(1486),
    [sym_labeled_statement] = STATE(1486),
    [sym_expression_statement] = STATE(1486),
    [sym_if_statement] = STATE(1486),
    [sym_switch_statement] = STATE(1486),
    [sym_case_statement] = STATE(1486),
    [sym_while_statement] = STATE(1486),
    [sym_do_statement] = STATE(1486),
    [sym_for_statement] = STATE(1486),
    [sym_return_statement] = STATE(1486),
    [sym_break_statement] = STATE(1486),
    [sym_continue_statement] = STATE(1486),
    [sym_goto_statement] = STATE(1486),
    [sym__expression] = STATE(873),
    [sym_comma_expression] = STATE(874),
    [sym_conditional_expression] = STATE(873),
    [sym_assignment_expression] = STATE(873),
    [sym_pointer_expression] = STATE(873),
    [sym_logical_expression] = STATE(873),
    [sym_bitwise_expression] = STATE(873),
    [sym_equality_expression] = STATE(873),
    [sym_relational_expression] = STATE(873),
    [sym_shift_expression] = STATE(873),
    [sym_math_expression] = STATE(873),
    [sym_cast_expression] = STATE(873),
    [sym_sizeof_expression] = STATE(873),
    [sym_subscript_expression] = STATE(873),
    [sym_call_expression] = STATE(873),
    [sym_field_expression] = STATE(873),
    [sym_compound_literal_expression] = STATE(873),
    [sym_parenthesized_expression] = STATE(873),
    [sym_concatenated_string] = STATE(873),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(873),
    [sym_for_range_loop] = STATE(1486),
    [sym_new_expression] = STATE(873),
    [sym_delete_expression] = STATE(873),
    [sym_lambda_expression] = STATE(873),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(1660),
    [anon_sym_LPAREN] = ACTIONS(626),
    [anon_sym_SEMI] = ACTIONS(1662),
    [anon_sym_LBRACE] = ACTIONS(1664),
    [anon_sym_STAR] = ACTIONS(644),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_if] = ACTIONS(1666),
    [anon_sym_switch] = ACTIONS(1668),
    [anon_sym_case] = ACTIONS(1670),
    [anon_sym_default] = ACTIONS(1672),
    [anon_sym_while] = ACTIONS(1674),
    [anon_sym_do] = ACTIONS(1676),
    [anon_sym_for] = ACTIONS(1678),
    [anon_sym_return] = ACTIONS(1680),
    [anon_sym_break] = ACTIONS(1682),
    [anon_sym_continue] = ACTIONS(1684),
    [anon_sym_goto] = ACTIONS(1686),
    [anon_sym_AMP] = ACTIONS(644),
    [anon_sym_BANG] = ACTIONS(668),
    [anon_sym_TILDE] = ACTIONS(670),
    [anon_sym_PLUS] = ACTIONS(672),
    [anon_sym_DASH] = ACTIONS(672),
    [anon_sym_DASH_DASH] = ACTIONS(674),
    [anon_sym_PLUS_PLUS] = ACTIONS(674),
    [anon_sym_sizeof] = ACTIONS(676),
    [sym_number_literal] = ACTIONS(1660),
    [sym_char_literal] = ACTIONS(1660),
    [sym_string_literal] = ACTIONS(678),
    [sym_true] = ACTIONS(1688),
    [sym_false] = ACTIONS(1688),
    [sym_null] = ACTIONS(1688),
    [sym_identifier] = ACTIONS(1690),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1303),
    [anon_sym_delete] = ACTIONS(686),
    [sym_nullptr] = ACTIONS(1688),
  },
  [866] = {
    [anon_sym_LPAREN] = ACTIONS(3062),
    [sym_comment] = ACTIONS(49),
  },
  [867] = {
    [sym__expression] = STATE(1489),
    [sym_conditional_expression] = STATE(1489),
    [sym_assignment_expression] = STATE(1489),
    [sym_pointer_expression] = STATE(1489),
    [sym_logical_expression] = STATE(1489),
    [sym_bitwise_expression] = STATE(1489),
    [sym_equality_expression] = STATE(1489),
    [sym_relational_expression] = STATE(1489),
    [sym_shift_expression] = STATE(1489),
    [sym_math_expression] = STATE(1489),
    [sym_cast_expression] = STATE(1489),
    [sym_sizeof_expression] = STATE(1489),
    [sym_subscript_expression] = STATE(1489),
    [sym_call_expression] = STATE(1489),
    [sym_field_expression] = STATE(1489),
    [sym_compound_literal_expression] = STATE(1489),
    [sym_parenthesized_expression] = STATE(1489),
    [sym_initializer_list] = STATE(1490),
    [sym_concatenated_string] = STATE(1489),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(1489),
    [sym_new_expression] = STATE(1489),
    [sym_delete_expression] = STATE(1489),
    [sym_lambda_expression] = STATE(1489),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(3064),
    [anon_sym_LPAREN] = ACTIONS(1347),
    [anon_sym_SEMI] = ACTIONS(3066),
    [anon_sym_LBRACE] = ACTIONS(548),
    [anon_sym_STAR] = ACTIONS(1349),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_AMP] = ACTIONS(1349),
    [anon_sym_BANG] = ACTIONS(1351),
    [anon_sym_TILDE] = ACTIONS(1353),
    [anon_sym_PLUS] = ACTIONS(1355),
    [anon_sym_DASH] = ACTIONS(1355),
    [anon_sym_DASH_DASH] = ACTIONS(1357),
    [anon_sym_PLUS_PLUS] = ACTIONS(1357),
    [anon_sym_sizeof] = ACTIONS(1359),
    [sym_number_literal] = ACTIONS(3064),
    [sym_char_literal] = ACTIONS(3064),
    [sym_string_literal] = ACTIONS(1361),
    [sym_true] = ACTIONS(3068),
    [sym_false] = ACTIONS(3068),
    [sym_null] = ACTIONS(3068),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1365),
    [anon_sym_delete] = ACTIONS(1367),
    [sym_nullptr] = ACTIONS(3068),
  },
  [868] = {
    [anon_sym_SEMI] = ACTIONS(3070),
    [sym_comment] = ACTIONS(49),
  },
  [869] = {
    [anon_sym_SEMI] = ACTIONS(3072),
    [sym_comment] = ACTIONS(49),
  },
  [870] = {
    [sym_identifier] = ACTIONS(3074),
    [sym_comment] = ACTIONS(49),
  },
  [871] = {
    [sym_initializer_list] = STATE(765),
    [sym_template_argument_list] = STATE(1097),
    [anon_sym_LPAREN] = ACTIONS(1477),
    [anon_sym_COMMA] = ACTIONS(1477),
    [anon_sym_SEMI] = ACTIONS(1477),
    [anon_sym_LBRACE] = ACTIONS(548),
    [anon_sym_STAR] = ACTIONS(1479),
    [anon_sym_LBRACK] = ACTIONS(1477),
    [anon_sym_EQ] = ACTIONS(1479),
    [anon_sym_COLON] = ACTIONS(3076),
    [anon_sym_QMARK] = ACTIONS(1477),
    [anon_sym_STAR_EQ] = ACTIONS(1477),
    [anon_sym_SLASH_EQ] = ACTIONS(1477),
    [anon_sym_PERCENT_EQ] = ACTIONS(1477),
    [anon_sym_PLUS_EQ] = ACTIONS(1477),
    [anon_sym_DASH_EQ] = ACTIONS(1477),
    [anon_sym_LT_LT_EQ] = ACTIONS(1477),
    [anon_sym_GT_GT_EQ] = ACTIONS(1477),
    [anon_sym_AMP_EQ] = ACTIONS(1477),
    [anon_sym_CARET_EQ] = ACTIONS(1477),
    [anon_sym_PIPE_EQ] = ACTIONS(1477),
    [anon_sym_AMP] = ACTIONS(1479),
    [anon_sym_PIPE_PIPE] = ACTIONS(1477),
    [anon_sym_AMP_AMP] = ACTIONS(1477),
    [anon_sym_PIPE] = ACTIONS(1479),
    [anon_sym_CARET] = ACTIONS(1479),
    [anon_sym_EQ_EQ] = ACTIONS(1477),
    [anon_sym_BANG_EQ] = ACTIONS(1477),
    [anon_sym_LT] = ACTIONS(1564),
    [anon_sym_GT] = ACTIONS(1479),
    [anon_sym_LT_EQ] = ACTIONS(1477),
    [anon_sym_GT_EQ] = ACTIONS(1477),
    [anon_sym_LT_LT] = ACTIONS(1479),
    [anon_sym_GT_GT] = ACTIONS(1479),
    [anon_sym_PLUS] = ACTIONS(1479),
    [anon_sym_DASH] = ACTIONS(1479),
    [anon_sym_SLASH] = ACTIONS(1479),
    [anon_sym_PERCENT] = ACTIONS(1479),
    [anon_sym_DASH_DASH] = ACTIONS(1477),
    [anon_sym_PLUS_PLUS] = ACTIONS(1477),
    [anon_sym_DOT] = ACTIONS(1477),
    [anon_sym_DASH_GT] = ACTIONS(1477),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(2218),
  },
  [872] = {
    [anon_sym_while] = ACTIONS(3078),
    [sym_comment] = ACTIONS(49),
  },
  [873] = {
    [sym_argument_list] = STATE(802),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_COMMA] = ACTIONS(1740),
    [anon_sym_SEMI] = ACTIONS(3080),
    [anon_sym_STAR] = ACTIONS(1744),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_EQ] = ACTIONS(1746),
    [anon_sym_QMARK] = ACTIONS(1748),
    [anon_sym_STAR_EQ] = ACTIONS(1750),
    [anon_sym_SLASH_EQ] = ACTIONS(1750),
    [anon_sym_PERCENT_EQ] = ACTIONS(1750),
    [anon_sym_PLUS_EQ] = ACTIONS(1750),
    [anon_sym_DASH_EQ] = ACTIONS(1750),
    [anon_sym_LT_LT_EQ] = ACTIONS(1750),
    [anon_sym_GT_GT_EQ] = ACTIONS(1750),
    [anon_sym_AMP_EQ] = ACTIONS(1750),
    [anon_sym_CARET_EQ] = ACTIONS(1750),
    [anon_sym_PIPE_EQ] = ACTIONS(1750),
    [anon_sym_AMP] = ACTIONS(1752),
    [anon_sym_PIPE_PIPE] = ACTIONS(1754),
    [anon_sym_AMP_AMP] = ACTIONS(1756),
    [anon_sym_PIPE] = ACTIONS(1758),
    [anon_sym_CARET] = ACTIONS(1760),
    [anon_sym_EQ_EQ] = ACTIONS(1762),
    [anon_sym_BANG_EQ] = ACTIONS(1762),
    [anon_sym_LT] = ACTIONS(1764),
    [anon_sym_GT] = ACTIONS(1764),
    [anon_sym_LT_EQ] = ACTIONS(1766),
    [anon_sym_GT_EQ] = ACTIONS(1766),
    [anon_sym_LT_LT] = ACTIONS(1768),
    [anon_sym_GT_GT] = ACTIONS(1768),
    [anon_sym_PLUS] = ACTIONS(1770),
    [anon_sym_DASH] = ACTIONS(1770),
    [anon_sym_SLASH] = ACTIONS(1744),
    [anon_sym_PERCENT] = ACTIONS(1744),
    [anon_sym_DASH_DASH] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(1554),
    [anon_sym_DASH_GT] = ACTIONS(1554),
    [sym_comment] = ACTIONS(49),
  },
  [874] = {
    [anon_sym_SEMI] = ACTIONS(3080),
    [sym_comment] = ACTIONS(49),
  },
  [875] = {
    [sym_declaration] = STATE(1497),
    [sym__declaration_specifiers] = STATE(1500),
    [sym_storage_class_specifier] = STATE(109),
    [sym_type_qualifier] = STATE(109),
    [sym__type_specifier] = STATE(105),
    [sym_sized_type_specifier] = STATE(105),
    [sym_enum_specifier] = STATE(105),
    [sym_struct_specifier] = STATE(105),
    [sym_union_specifier] = STATE(105),
    [sym__expression] = STATE(1501),
    [sym_conditional_expression] = STATE(1501),
    [sym_assignment_expression] = STATE(1501),
    [sym_pointer_expression] = STATE(1501),
    [sym_logical_expression] = STATE(1501),
    [sym_bitwise_expression] = STATE(1501),
    [sym_equality_expression] = STATE(1501),
    [sym_relational_expression] = STATE(1501),
    [sym_shift_expression] = STATE(1501),
    [sym_math_expression] = STATE(1501),
    [sym_cast_expression] = STATE(1501),
    [sym_sizeof_expression] = STATE(1501),
    [sym_subscript_expression] = STATE(1501),
    [sym_call_expression] = STATE(1501),
    [sym_field_expression] = STATE(1501),
    [sym_compound_literal_expression] = STATE(1501),
    [sym_parenthesized_expression] = STATE(1501),
    [sym_concatenated_string] = STATE(1501),
    [sym_macro_type_specifier] = STATE(105),
    [sym_class_specifier] = STATE(105),
    [sym_dependent_type] = STATE(105),
    [sym_template_type] = STATE(1475),
    [sym_template_function] = STATE(1501),
    [sym_for_range_declaration] = STATE(1502),
    [sym_new_expression] = STATE(1501),
    [sym_delete_expression] = STATE(1501),
    [sym_lambda_expression] = STATE(1501),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(416),
    [sym_scoped_namespace_identifier] = STATE(1476),
    [aux_sym__declaration_specifiers_repeat1] = STATE(109),
    [aux_sym_sized_type_specifier_repeat1] = STATE(110),
    [sym_raw_string_literal] = ACTIONS(3082),
    [anon_sym_LPAREN] = ACTIONS(1347),
    [anon_sym_SEMI] = ACTIONS(3084),
    [anon_sym_extern] = ACTIONS(154),
    [anon_sym_STAR] = ACTIONS(1349),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_static] = ACTIONS(154),
    [anon_sym_register] = ACTIONS(154),
    [anon_sym_inline] = ACTIONS(154),
    [anon_sym_const] = ACTIONS(158),
    [anon_sym_restrict] = ACTIONS(158),
    [anon_sym_volatile] = ACTIONS(158),
    [anon_sym__Atomic] = ACTIONS(158),
    [anon_sym_mutable] = ACTIONS(158),
    [anon_sym_explicit] = ACTIONS(158),
    [anon_sym_constexpr] = ACTIONS(158),
    [anon_sym_unsigned] = ACTIONS(160),
    [anon_sym_long] = ACTIONS(160),
    [anon_sym_short] = ACTIONS(160),
    [sym_primitive_type] = ACTIONS(162),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_union] = ACTIONS(39),
    [anon_sym_AMP] = ACTIONS(1349),
    [anon_sym_BANG] = ACTIONS(1351),
    [anon_sym_TILDE] = ACTIONS(1353),
    [anon_sym_PLUS] = ACTIONS(1355),
    [anon_sym_DASH] = ACTIONS(1355),
    [anon_sym_DASH_DASH] = ACTIONS(1357),
    [anon_sym_PLUS_PLUS] = ACTIONS(1357),
    [anon_sym_sizeof] = ACTIONS(1359),
    [sym_number_literal] = ACTIONS(3082),
    [sym_char_literal] = ACTIONS(3082),
    [sym_string_literal] = ACTIONS(1361),
    [sym_true] = ACTIONS(3086),
    [sym_false] = ACTIONS(3086),
    [sym_null] = ACTIONS(3086),
    [sym_identifier] = ACTIONS(3088),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(51),
    [sym_auto] = ACTIONS(162),
    [anon_sym_typename] = ACTIONS(172),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(3090),
    [anon_sym_delete] = ACTIONS(1367),
    [sym_nullptr] = ACTIONS(3086),
  },
  [876] = {
    [sym_raw_string_literal] = ACTIONS(3092),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3094),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3094),
    [anon_sym_LPAREN] = ACTIONS(3092),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3094),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3094),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3094),
    [sym_preproc_directive] = ACTIONS(3094),
    [anon_sym_SEMI] = ACTIONS(3092),
    [anon_sym_typedef] = ACTIONS(3094),
    [anon_sym_extern] = ACTIONS(3094),
    [anon_sym_LBRACE] = ACTIONS(3092),
    [anon_sym_RBRACE] = ACTIONS(3092),
    [anon_sym_STAR] = ACTIONS(3092),
    [anon_sym_LBRACK] = ACTIONS(3092),
    [anon_sym_static] = ACTIONS(3094),
    [anon_sym_register] = ACTIONS(3094),
    [anon_sym_inline] = ACTIONS(3094),
    [anon_sym_const] = ACTIONS(3094),
    [anon_sym_restrict] = ACTIONS(3094),
    [anon_sym_volatile] = ACTIONS(3094),
    [anon_sym__Atomic] = ACTIONS(3094),
    [anon_sym_mutable] = ACTIONS(3094),
    [anon_sym_explicit] = ACTIONS(3094),
    [anon_sym_constexpr] = ACTIONS(3094),
    [anon_sym_unsigned] = ACTIONS(3094),
    [anon_sym_long] = ACTIONS(3094),
    [anon_sym_short] = ACTIONS(3094),
    [sym_primitive_type] = ACTIONS(3094),
    [anon_sym_enum] = ACTIONS(3094),
    [anon_sym_struct] = ACTIONS(3094),
    [anon_sym_union] = ACTIONS(3094),
    [anon_sym_if] = ACTIONS(3094),
    [anon_sym_switch] = ACTIONS(3094),
    [anon_sym_case] = ACTIONS(3094),
    [anon_sym_default] = ACTIONS(3094),
    [anon_sym_while] = ACTIONS(3094),
    [anon_sym_do] = ACTIONS(3094),
    [anon_sym_for] = ACTIONS(3094),
    [anon_sym_return] = ACTIONS(3094),
    [anon_sym_break] = ACTIONS(3094),
    [anon_sym_continue] = ACTIONS(3094),
    [anon_sym_goto] = ACTIONS(3094),
    [anon_sym_AMP] = ACTIONS(3092),
    [anon_sym_BANG] = ACTIONS(3092),
    [anon_sym_TILDE] = ACTIONS(3092),
    [anon_sym_PLUS] = ACTIONS(3094),
    [anon_sym_DASH] = ACTIONS(3094),
    [anon_sym_DASH_DASH] = ACTIONS(3092),
    [anon_sym_PLUS_PLUS] = ACTIONS(3092),
    [anon_sym_sizeof] = ACTIONS(3094),
    [sym_number_literal] = ACTIONS(3092),
    [sym_char_literal] = ACTIONS(3092),
    [sym_string_literal] = ACTIONS(3092),
    [sym_true] = ACTIONS(3094),
    [sym_false] = ACTIONS(3094),
    [sym_null] = ACTIONS(3094),
    [sym_identifier] = ACTIONS(3094),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(3094),
    [sym_auto] = ACTIONS(3094),
    [anon_sym_typename] = ACTIONS(3094),
    [anon_sym_new] = ACTIONS(3094),
    [anon_sym_COLON_COLON] = ACTIONS(3092),
    [anon_sym_delete] = ACTIONS(3094),
    [sym_nullptr] = ACTIONS(3094),
  },
  [877] = {
    [sym_argument_list] = STATE(802),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_SEMI] = ACTIONS(3096),
    [anon_sym_STAR] = ACTIONS(2553),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_EQ] = ACTIONS(2555),
    [anon_sym_QMARK] = ACTIONS(2557),
    [anon_sym_STAR_EQ] = ACTIONS(2559),
    [anon_sym_SLASH_EQ] = ACTIONS(2559),
    [anon_sym_PERCENT_EQ] = ACTIONS(2559),
    [anon_sym_PLUS_EQ] = ACTIONS(2559),
    [anon_sym_DASH_EQ] = ACTIONS(2559),
    [anon_sym_LT_LT_EQ] = ACTIONS(2559),
    [anon_sym_GT_GT_EQ] = ACTIONS(2559),
    [anon_sym_AMP_EQ] = ACTIONS(2559),
    [anon_sym_CARET_EQ] = ACTIONS(2559),
    [anon_sym_PIPE_EQ] = ACTIONS(2559),
    [anon_sym_AMP] = ACTIONS(2561),
    [anon_sym_PIPE_PIPE] = ACTIONS(2563),
    [anon_sym_AMP_AMP] = ACTIONS(2565),
    [anon_sym_PIPE] = ACTIONS(2567),
    [anon_sym_CARET] = ACTIONS(2569),
    [anon_sym_EQ_EQ] = ACTIONS(2571),
    [anon_sym_BANG_EQ] = ACTIONS(2571),
    [anon_sym_LT] = ACTIONS(2573),
    [anon_sym_GT] = ACTIONS(2573),
    [anon_sym_LT_EQ] = ACTIONS(2575),
    [anon_sym_GT_EQ] = ACTIONS(2575),
    [anon_sym_LT_LT] = ACTIONS(2577),
    [anon_sym_GT_GT] = ACTIONS(2577),
    [anon_sym_PLUS] = ACTIONS(2579),
    [anon_sym_DASH] = ACTIONS(2579),
    [anon_sym_SLASH] = ACTIONS(2553),
    [anon_sym_PERCENT] = ACTIONS(2553),
    [anon_sym_DASH_DASH] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(1554),
    [anon_sym_DASH_GT] = ACTIONS(1554),
    [sym_comment] = ACTIONS(49),
  },
  [878] = {
    [anon_sym_SEMI] = ACTIONS(3096),
    [sym_comment] = ACTIONS(49),
  },
  [879] = {
    [sym_raw_string_literal] = ACTIONS(3098),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3100),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3100),
    [anon_sym_LPAREN] = ACTIONS(3098),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3100),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3100),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3100),
    [sym_preproc_directive] = ACTIONS(3100),
    [anon_sym_SEMI] = ACTIONS(3098),
    [anon_sym_typedef] = ACTIONS(3100),
    [anon_sym_extern] = ACTIONS(3100),
    [anon_sym_LBRACE] = ACTIONS(3098),
    [anon_sym_RBRACE] = ACTIONS(3098),
    [anon_sym_STAR] = ACTIONS(3098),
    [anon_sym_LBRACK] = ACTIONS(3098),
    [anon_sym_static] = ACTIONS(3100),
    [anon_sym_register] = ACTIONS(3100),
    [anon_sym_inline] = ACTIONS(3100),
    [anon_sym_const] = ACTIONS(3100),
    [anon_sym_restrict] = ACTIONS(3100),
    [anon_sym_volatile] = ACTIONS(3100),
    [anon_sym__Atomic] = ACTIONS(3100),
    [anon_sym_mutable] = ACTIONS(3100),
    [anon_sym_explicit] = ACTIONS(3100),
    [anon_sym_constexpr] = ACTIONS(3100),
    [anon_sym_unsigned] = ACTIONS(3100),
    [anon_sym_long] = ACTIONS(3100),
    [anon_sym_short] = ACTIONS(3100),
    [sym_primitive_type] = ACTIONS(3100),
    [anon_sym_enum] = ACTIONS(3100),
    [anon_sym_struct] = ACTIONS(3100),
    [anon_sym_union] = ACTIONS(3100),
    [anon_sym_if] = ACTIONS(3100),
    [anon_sym_switch] = ACTIONS(3100),
    [anon_sym_case] = ACTIONS(3100),
    [anon_sym_default] = ACTIONS(3100),
    [anon_sym_while] = ACTIONS(3100),
    [anon_sym_do] = ACTIONS(3100),
    [anon_sym_for] = ACTIONS(3100),
    [anon_sym_return] = ACTIONS(3100),
    [anon_sym_break] = ACTIONS(3100),
    [anon_sym_continue] = ACTIONS(3100),
    [anon_sym_goto] = ACTIONS(3100),
    [anon_sym_AMP] = ACTIONS(3098),
    [anon_sym_BANG] = ACTIONS(3098),
    [anon_sym_TILDE] = ACTIONS(3098),
    [anon_sym_PLUS] = ACTIONS(3100),
    [anon_sym_DASH] = ACTIONS(3100),
    [anon_sym_DASH_DASH] = ACTIONS(3098),
    [anon_sym_PLUS_PLUS] = ACTIONS(3098),
    [anon_sym_sizeof] = ACTIONS(3100),
    [sym_number_literal] = ACTIONS(3098),
    [sym_char_literal] = ACTIONS(3098),
    [sym_string_literal] = ACTIONS(3098),
    [sym_true] = ACTIONS(3100),
    [sym_false] = ACTIONS(3100),
    [sym_null] = ACTIONS(3100),
    [sym_identifier] = ACTIONS(3100),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(3100),
    [sym_auto] = ACTIONS(3100),
    [anon_sym_typename] = ACTIONS(3100),
    [anon_sym_new] = ACTIONS(3100),
    [anon_sym_COLON_COLON] = ACTIONS(3098),
    [anon_sym_delete] = ACTIONS(3100),
    [sym_nullptr] = ACTIONS(3100),
  },
  [880] = {
    [sym_raw_string_literal] = ACTIONS(3102),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3104),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3104),
    [anon_sym_LPAREN] = ACTIONS(3102),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3104),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3104),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3104),
    [sym_preproc_directive] = ACTIONS(3104),
    [anon_sym_SEMI] = ACTIONS(3102),
    [anon_sym_typedef] = ACTIONS(3104),
    [anon_sym_extern] = ACTIONS(3104),
    [anon_sym_LBRACE] = ACTIONS(3102),
    [anon_sym_RBRACE] = ACTIONS(3102),
    [anon_sym_STAR] = ACTIONS(3102),
    [anon_sym_LBRACK] = ACTIONS(3102),
    [anon_sym_static] = ACTIONS(3104),
    [anon_sym_register] = ACTIONS(3104),
    [anon_sym_inline] = ACTIONS(3104),
    [anon_sym_const] = ACTIONS(3104),
    [anon_sym_restrict] = ACTIONS(3104),
    [anon_sym_volatile] = ACTIONS(3104),
    [anon_sym__Atomic] = ACTIONS(3104),
    [anon_sym_mutable] = ACTIONS(3104),
    [anon_sym_explicit] = ACTIONS(3104),
    [anon_sym_constexpr] = ACTIONS(3104),
    [anon_sym_unsigned] = ACTIONS(3104),
    [anon_sym_long] = ACTIONS(3104),
    [anon_sym_short] = ACTIONS(3104),
    [sym_primitive_type] = ACTIONS(3104),
    [anon_sym_enum] = ACTIONS(3104),
    [anon_sym_struct] = ACTIONS(3104),
    [anon_sym_union] = ACTIONS(3104),
    [anon_sym_if] = ACTIONS(3104),
    [anon_sym_switch] = ACTIONS(3104),
    [anon_sym_case] = ACTIONS(3104),
    [anon_sym_default] = ACTIONS(3104),
    [anon_sym_while] = ACTIONS(3104),
    [anon_sym_do] = ACTIONS(3104),
    [anon_sym_for] = ACTIONS(3104),
    [anon_sym_return] = ACTIONS(3104),
    [anon_sym_break] = ACTIONS(3104),
    [anon_sym_continue] = ACTIONS(3104),
    [anon_sym_goto] = ACTIONS(3104),
    [anon_sym_AMP] = ACTIONS(3102),
    [anon_sym_BANG] = ACTIONS(3102),
    [anon_sym_TILDE] = ACTIONS(3102),
    [anon_sym_PLUS] = ACTIONS(3104),
    [anon_sym_DASH] = ACTIONS(3104),
    [anon_sym_DASH_DASH] = ACTIONS(3102),
    [anon_sym_PLUS_PLUS] = ACTIONS(3102),
    [anon_sym_sizeof] = ACTIONS(3104),
    [sym_number_literal] = ACTIONS(3102),
    [sym_char_literal] = ACTIONS(3102),
    [sym_string_literal] = ACTIONS(3102),
    [sym_true] = ACTIONS(3104),
    [sym_false] = ACTIONS(3104),
    [sym_null] = ACTIONS(3104),
    [sym_identifier] = ACTIONS(3104),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(3104),
    [sym_auto] = ACTIONS(3104),
    [anon_sym_typename] = ACTIONS(3104),
    [anon_sym_new] = ACTIONS(3104),
    [anon_sym_COLON_COLON] = ACTIONS(3102),
    [anon_sym_delete] = ACTIONS(3104),
    [sym_nullptr] = ACTIONS(3104),
  },
  [881] = {
    [anon_sym_SEMI] = ACTIONS(3106),
    [sym_comment] = ACTIONS(49),
  },
  [882] = {
    [sym_type_qualifier] = STATE(724),
    [sym__type_specifier] = STATE(720),
    [sym_sized_type_specifier] = STATE(720),
    [sym_enum_specifier] = STATE(720),
    [sym_struct_specifier] = STATE(720),
    [sym_union_specifier] = STATE(720),
    [sym__expression] = STATE(721),
    [sym_comma_expression] = STATE(722),
    [sym_conditional_expression] = STATE(721),
    [sym_assignment_expression] = STATE(721),
    [sym_pointer_expression] = STATE(721),
    [sym_logical_expression] = STATE(721),
    [sym_bitwise_expression] = STATE(721),
    [sym_equality_expression] = STATE(721),
    [sym_relational_expression] = STATE(721),
    [sym_shift_expression] = STATE(721),
    [sym_math_expression] = STATE(721),
    [sym_cast_expression] = STATE(721),
    [sym_type_descriptor] = STATE(1505),
    [sym_sizeof_expression] = STATE(721),
    [sym_subscript_expression] = STATE(721),
    [sym_call_expression] = STATE(721),
    [sym_field_expression] = STATE(721),
    [sym_compound_literal_expression] = STATE(721),
    [sym_parenthesized_expression] = STATE(721),
    [sym_concatenated_string] = STATE(721),
    [sym_macro_type_specifier] = STATE(720),
    [sym_class_specifier] = STATE(720),
    [sym_dependent_type] = STATE(720),
    [sym_template_type] = STATE(415),
    [sym_template_function] = STATE(721),
    [sym_new_expression] = STATE(721),
    [sym_delete_expression] = STATE(721),
    [sym_lambda_expression] = STATE(721),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(416),
    [sym_scoped_namespace_identifier] = STATE(417),
    [aux_sym_type_definition_repeat1] = STATE(724),
    [aux_sym_sized_type_specifier_repeat1] = STATE(725),
    [sym_raw_string_literal] = ACTIONS(1397),
    [anon_sym_LPAREN] = ACTIONS(1087),
    [anon_sym_STAR] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_restrict] = ACTIONS(93),
    [anon_sym_volatile] = ACTIONS(93),
    [anon_sym__Atomic] = ACTIONS(93),
    [anon_sym_mutable] = ACTIONS(93),
    [anon_sym_explicit] = ACTIONS(93),
    [anon_sym_constexpr] = ACTIONS(93),
    [anon_sym_unsigned] = ACTIONS(1399),
    [anon_sym_long] = ACTIONS(1399),
    [anon_sym_short] = ACTIONS(1399),
    [sym_primitive_type] = ACTIONS(1401),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(428),
    [anon_sym_union] = ACTIONS(430),
    [anon_sym_AMP] = ACTIONS(1089),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1093),
    [anon_sym_PLUS] = ACTIONS(1095),
    [anon_sym_DASH] = ACTIONS(1095),
    [anon_sym_DASH_DASH] = ACTIONS(1097),
    [anon_sym_PLUS_PLUS] = ACTIONS(1097),
    [anon_sym_sizeof] = ACTIONS(1099),
    [sym_number_literal] = ACTIONS(1397),
    [sym_char_literal] = ACTIONS(1397),
    [sym_string_literal] = ACTIONS(1101),
    [sym_true] = ACTIONS(1403),
    [sym_false] = ACTIONS(1403),
    [sym_null] = ACTIONS(1403),
    [sym_identifier] = ACTIONS(1405),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(436),
    [sym_auto] = ACTIONS(1401),
    [anon_sym_typename] = ACTIONS(1407),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1409),
    [anon_sym_delete] = ACTIONS(1109),
    [sym_nullptr] = ACTIONS(1403),
  },
  [883] = {
    [sym_argument_list] = STATE(802),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_COMMA] = ACTIONS(2702),
    [anon_sym_SEMI] = ACTIONS(2702),
    [anon_sym_STAR] = ACTIONS(1744),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_EQ] = ACTIONS(2704),
    [anon_sym_QMARK] = ACTIONS(2702),
    [anon_sym_STAR_EQ] = ACTIONS(2702),
    [anon_sym_SLASH_EQ] = ACTIONS(2702),
    [anon_sym_PERCENT_EQ] = ACTIONS(2702),
    [anon_sym_PLUS_EQ] = ACTIONS(2702),
    [anon_sym_DASH_EQ] = ACTIONS(2702),
    [anon_sym_LT_LT_EQ] = ACTIONS(2702),
    [anon_sym_GT_GT_EQ] = ACTIONS(2702),
    [anon_sym_AMP_EQ] = ACTIONS(2702),
    [anon_sym_CARET_EQ] = ACTIONS(2702),
    [anon_sym_PIPE_EQ] = ACTIONS(2702),
    [anon_sym_AMP] = ACTIONS(2704),
    [anon_sym_PIPE_PIPE] = ACTIONS(2702),
    [anon_sym_AMP_AMP] = ACTIONS(2702),
    [anon_sym_PIPE] = ACTIONS(2704),
    [anon_sym_CARET] = ACTIONS(2704),
    [anon_sym_EQ_EQ] = ACTIONS(2702),
    [anon_sym_BANG_EQ] = ACTIONS(2702),
    [anon_sym_LT] = ACTIONS(2704),
    [anon_sym_GT] = ACTIONS(2704),
    [anon_sym_LT_EQ] = ACTIONS(2702),
    [anon_sym_GT_EQ] = ACTIONS(2702),
    [anon_sym_LT_LT] = ACTIONS(1768),
    [anon_sym_GT_GT] = ACTIONS(1768),
    [anon_sym_PLUS] = ACTIONS(1770),
    [anon_sym_DASH] = ACTIONS(1770),
    [anon_sym_SLASH] = ACTIONS(1744),
    [anon_sym_PERCENT] = ACTIONS(1744),
    [anon_sym_DASH_DASH] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(1554),
    [anon_sym_DASH_GT] = ACTIONS(1554),
    [sym_comment] = ACTIONS(49),
  },
  [884] = {
    [aux_sym_concatenated_string_repeat1] = STATE(1506),
    [anon_sym_LPAREN] = ACTIONS(2706),
    [anon_sym_COMMA] = ACTIONS(2706),
    [anon_sym_SEMI] = ACTIONS(2706),
    [anon_sym_STAR] = ACTIONS(2708),
    [anon_sym_LBRACK] = ACTIONS(2706),
    [anon_sym_EQ] = ACTIONS(2708),
    [anon_sym_QMARK] = ACTIONS(2706),
    [anon_sym_STAR_EQ] = ACTIONS(2706),
    [anon_sym_SLASH_EQ] = ACTIONS(2706),
    [anon_sym_PERCENT_EQ] = ACTIONS(2706),
    [anon_sym_PLUS_EQ] = ACTIONS(2706),
    [anon_sym_DASH_EQ] = ACTIONS(2706),
    [anon_sym_LT_LT_EQ] = ACTIONS(2706),
    [anon_sym_GT_GT_EQ] = ACTIONS(2706),
    [anon_sym_AMP_EQ] = ACTIONS(2706),
    [anon_sym_CARET_EQ] = ACTIONS(2706),
    [anon_sym_PIPE_EQ] = ACTIONS(2706),
    [anon_sym_AMP] = ACTIONS(2708),
    [anon_sym_PIPE_PIPE] = ACTIONS(2706),
    [anon_sym_AMP_AMP] = ACTIONS(2706),
    [anon_sym_PIPE] = ACTIONS(2708),
    [anon_sym_CARET] = ACTIONS(2708),
    [anon_sym_EQ_EQ] = ACTIONS(2706),
    [anon_sym_BANG_EQ] = ACTIONS(2706),
    [anon_sym_LT] = ACTIONS(2708),
    [anon_sym_GT] = ACTIONS(2708),
    [anon_sym_LT_EQ] = ACTIONS(2706),
    [anon_sym_GT_EQ] = ACTIONS(2706),
    [anon_sym_LT_LT] = ACTIONS(2708),
    [anon_sym_GT_GT] = ACTIONS(2708),
    [anon_sym_PLUS] = ACTIONS(2708),
    [anon_sym_DASH] = ACTIONS(2708),
    [anon_sym_SLASH] = ACTIONS(2708),
    [anon_sym_PERCENT] = ACTIONS(2708),
    [anon_sym_DASH_DASH] = ACTIONS(2706),
    [anon_sym_PLUS_PLUS] = ACTIONS(2706),
    [anon_sym_DOT] = ACTIONS(2706),
    [anon_sym_DASH_GT] = ACTIONS(2706),
    [sym_string_literal] = ACTIONS(3108),
    [sym_comment] = ACTIONS(49),
  },
  [885] = {
    [sym_compound_statement] = STATE(1508),
    [sym_labeled_statement] = STATE(1508),
    [sym_expression_statement] = STATE(1508),
    [sym_if_statement] = STATE(1508),
    [sym_switch_statement] = STATE(1508),
    [sym_case_statement] = STATE(1508),
    [sym_while_statement] = STATE(1508),
    [sym_do_statement] = STATE(1508),
    [sym_for_statement] = STATE(1508),
    [sym_return_statement] = STATE(1508),
    [sym_break_statement] = STATE(1508),
    [sym_continue_statement] = STATE(1508),
    [sym_goto_statement] = STATE(1508),
    [sym__expression] = STATE(413),
    [sym_comma_expression] = STATE(414),
    [sym_conditional_expression] = STATE(413),
    [sym_assignment_expression] = STATE(413),
    [sym_pointer_expression] = STATE(413),
    [sym_logical_expression] = STATE(413),
    [sym_bitwise_expression] = STATE(413),
    [sym_equality_expression] = STATE(413),
    [sym_relational_expression] = STATE(413),
    [sym_shift_expression] = STATE(413),
    [sym_math_expression] = STATE(413),
    [sym_cast_expression] = STATE(413),
    [sym_sizeof_expression] = STATE(413),
    [sym_subscript_expression] = STATE(413),
    [sym_call_expression] = STATE(413),
    [sym_field_expression] = STATE(413),
    [sym_compound_literal_expression] = STATE(413),
    [sym_parenthesized_expression] = STATE(413),
    [sym_concatenated_string] = STATE(413),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(413),
    [sym_for_range_loop] = STATE(1508),
    [sym_new_expression] = STATE(413),
    [sym_delete_expression] = STATE(413),
    [sym_lambda_expression] = STATE(413),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(620),
    [anon_sym_LPAREN] = ACTIONS(626),
    [anon_sym_SEMI] = ACTIONS(636),
    [anon_sym_LBRACE] = ACTIONS(640),
    [anon_sym_STAR] = ACTIONS(644),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_if] = ACTIONS(646),
    [anon_sym_switch] = ACTIONS(648),
    [anon_sym_case] = ACTIONS(650),
    [anon_sym_default] = ACTIONS(652),
    [anon_sym_while] = ACTIONS(654),
    [anon_sym_do] = ACTIONS(656),
    [anon_sym_for] = ACTIONS(658),
    [anon_sym_return] = ACTIONS(660),
    [anon_sym_break] = ACTIONS(662),
    [anon_sym_continue] = ACTIONS(664),
    [anon_sym_goto] = ACTIONS(666),
    [anon_sym_AMP] = ACTIONS(644),
    [anon_sym_BANG] = ACTIONS(668),
    [anon_sym_TILDE] = ACTIONS(670),
    [anon_sym_PLUS] = ACTIONS(672),
    [anon_sym_DASH] = ACTIONS(672),
    [anon_sym_DASH_DASH] = ACTIONS(674),
    [anon_sym_PLUS_PLUS] = ACTIONS(674),
    [anon_sym_sizeof] = ACTIONS(676),
    [sym_number_literal] = ACTIONS(620),
    [sym_char_literal] = ACTIONS(620),
    [sym_string_literal] = ACTIONS(678),
    [sym_true] = ACTIONS(680),
    [sym_false] = ACTIONS(680),
    [sym_null] = ACTIONS(680),
    [sym_identifier] = ACTIONS(3110),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1303),
    [anon_sym_delete] = ACTIONS(686),
    [sym_nullptr] = ACTIONS(680),
  },
  [886] = {
    [sym_destructor_name] = STATE(282),
    [anon_sym_TILDE] = ACTIONS(1500),
    [sym_identifier] = ACTIONS(3112),
    [sym_comment] = ACTIONS(49),
    [sym_operator_name] = ACTIONS(442),
  },
  [887] = {
    [anon_sym_LPAREN] = ACTIONS(444),
    [anon_sym_COMMA] = ACTIONS(704),
    [anon_sym_RPAREN] = ACTIONS(444),
    [anon_sym_SEMI] = ACTIONS(444),
    [anon_sym_extern] = ACTIONS(449),
    [anon_sym_LBRACE] = ACTIONS(447),
    [anon_sym_RBRACE] = ACTIONS(704),
    [anon_sym_STAR] = ACTIONS(2720),
    [anon_sym_LBRACK] = ACTIONS(444),
    [anon_sym_EQ] = ACTIONS(706),
    [anon_sym_static] = ACTIONS(449),
    [anon_sym_register] = ACTIONS(449),
    [anon_sym_inline] = ACTIONS(449),
    [anon_sym_const] = ACTIONS(449),
    [anon_sym_restrict] = ACTIONS(449),
    [anon_sym_volatile] = ACTIONS(449),
    [anon_sym__Atomic] = ACTIONS(449),
    [anon_sym_mutable] = ACTIONS(449),
    [anon_sym_explicit] = ACTIONS(449),
    [anon_sym_constexpr] = ACTIONS(449),
    [anon_sym_QMARK] = ACTIONS(704),
    [anon_sym_STAR_EQ] = ACTIONS(704),
    [anon_sym_SLASH_EQ] = ACTIONS(704),
    [anon_sym_PERCENT_EQ] = ACTIONS(704),
    [anon_sym_PLUS_EQ] = ACTIONS(704),
    [anon_sym_DASH_EQ] = ACTIONS(704),
    [anon_sym_LT_LT_EQ] = ACTIONS(704),
    [anon_sym_GT_GT_EQ] = ACTIONS(704),
    [anon_sym_AMP_EQ] = ACTIONS(704),
    [anon_sym_CARET_EQ] = ACTIONS(704),
    [anon_sym_PIPE_EQ] = ACTIONS(704),
    [anon_sym_AMP] = ACTIONS(2720),
    [anon_sym_PIPE_PIPE] = ACTIONS(704),
    [anon_sym_AMP_AMP] = ACTIONS(444),
    [anon_sym_PIPE] = ACTIONS(706),
    [anon_sym_CARET] = ACTIONS(706),
    [anon_sym_TILDE] = ACTIONS(447),
    [anon_sym_EQ_EQ] = ACTIONS(704),
    [anon_sym_BANG_EQ] = ACTIONS(704),
    [anon_sym_LT] = ACTIONS(706),
    [anon_sym_GT] = ACTIONS(706),
    [anon_sym_LT_EQ] = ACTIONS(704),
    [anon_sym_GT_EQ] = ACTIONS(704),
    [anon_sym_LT_LT] = ACTIONS(706),
    [anon_sym_GT_GT] = ACTIONS(706),
    [anon_sym_PLUS] = ACTIONS(706),
    [anon_sym_DASH] = ACTIONS(706),
    [anon_sym_SLASH] = ACTIONS(706),
    [anon_sym_PERCENT] = ACTIONS(706),
    [anon_sym_DASH_DASH] = ACTIONS(704),
    [anon_sym_PLUS_PLUS] = ACTIONS(704),
    [anon_sym_DOT] = ACTIONS(704),
    [anon_sym_DASH_GT] = ACTIONS(704),
    [sym_identifier] = ACTIONS(449),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(447),
    [sym_operator_name] = ACTIONS(447),
  },
  [888] = {
    [anon_sym_LPAREN] = ACTIONS(509),
    [anon_sym_COMMA] = ACTIONS(518),
    [anon_sym_RPAREN] = ACTIONS(509),
    [anon_sym_SEMI] = ACTIONS(509),
    [anon_sym_extern] = ACTIONS(514),
    [anon_sym_LBRACE] = ACTIONS(512),
    [anon_sym_RBRACE] = ACTIONS(518),
    [anon_sym_STAR] = ACTIONS(2729),
    [anon_sym_LBRACK] = ACTIONS(509),
    [anon_sym_EQ] = ACTIONS(520),
    [anon_sym_static] = ACTIONS(514),
    [anon_sym_register] = ACTIONS(514),
    [anon_sym_inline] = ACTIONS(514),
    [anon_sym_const] = ACTIONS(514),
    [anon_sym_restrict] = ACTIONS(514),
    [anon_sym_volatile] = ACTIONS(514),
    [anon_sym__Atomic] = ACTIONS(514),
    [anon_sym_mutable] = ACTIONS(514),
    [anon_sym_explicit] = ACTIONS(514),
    [anon_sym_constexpr] = ACTIONS(514),
    [anon_sym_QMARK] = ACTIONS(518),
    [anon_sym_STAR_EQ] = ACTIONS(518),
    [anon_sym_SLASH_EQ] = ACTIONS(518),
    [anon_sym_PERCENT_EQ] = ACTIONS(518),
    [anon_sym_PLUS_EQ] = ACTIONS(518),
    [anon_sym_DASH_EQ] = ACTIONS(518),
    [anon_sym_LT_LT_EQ] = ACTIONS(518),
    [anon_sym_GT_GT_EQ] = ACTIONS(518),
    [anon_sym_AMP_EQ] = ACTIONS(518),
    [anon_sym_CARET_EQ] = ACTIONS(518),
    [anon_sym_PIPE_EQ] = ACTIONS(518),
    [anon_sym_AMP] = ACTIONS(2729),
    [anon_sym_PIPE_PIPE] = ACTIONS(518),
    [anon_sym_AMP_AMP] = ACTIONS(509),
    [anon_sym_PIPE] = ACTIONS(520),
    [anon_sym_CARET] = ACTIONS(520),
    [anon_sym_TILDE] = ACTIONS(512),
    [anon_sym_EQ_EQ] = ACTIONS(518),
    [anon_sym_BANG_EQ] = ACTIONS(518),
    [anon_sym_LT] = ACTIONS(2729),
    [anon_sym_GT] = ACTIONS(520),
    [anon_sym_LT_EQ] = ACTIONS(518),
    [anon_sym_GT_EQ] = ACTIONS(518),
    [anon_sym_LT_LT] = ACTIONS(520),
    [anon_sym_GT_GT] = ACTIONS(520),
    [anon_sym_PLUS] = ACTIONS(520),
    [anon_sym_DASH] = ACTIONS(520),
    [anon_sym_SLASH] = ACTIONS(520),
    [anon_sym_PERCENT] = ACTIONS(520),
    [anon_sym_DASH_DASH] = ACTIONS(518),
    [anon_sym_PLUS_PLUS] = ACTIONS(518),
    [anon_sym_DOT] = ACTIONS(518),
    [anon_sym_DASH_GT] = ACTIONS(518),
    [sym_identifier] = ACTIONS(514),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(516),
    [sym_operator_name] = ACTIONS(512),
  },
  [889] = {
    [sym__expression] = STATE(1511),
    [sym_conditional_expression] = STATE(1511),
    [sym_assignment_expression] = STATE(1511),
    [sym_pointer_expression] = STATE(1511),
    [sym_logical_expression] = STATE(1511),
    [sym_bitwise_expression] = STATE(1511),
    [sym_equality_expression] = STATE(1511),
    [sym_relational_expression] = STATE(1511),
    [sym_shift_expression] = STATE(1511),
    [sym_math_expression] = STATE(1511),
    [sym_cast_expression] = STATE(1511),
    [sym_sizeof_expression] = STATE(1511),
    [sym_subscript_expression] = STATE(1511),
    [sym_call_expression] = STATE(1511),
    [sym_field_expression] = STATE(1511),
    [sym_compound_literal_expression] = STATE(1511),
    [sym_parenthesized_expression] = STATE(1511),
    [sym_concatenated_string] = STATE(1511),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(1511),
    [sym_new_expression] = STATE(1511),
    [sym_delete_expression] = STATE(1511),
    [sym_lambda_expression] = STATE(1511),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(3114),
    [anon_sym_LPAREN] = ACTIONS(626),
    [anon_sym_STAR] = ACTIONS(644),
    [anon_sym_LBRACK] = ACTIONS(3116),
    [anon_sym_AMP] = ACTIONS(644),
    [anon_sym_BANG] = ACTIONS(668),
    [anon_sym_TILDE] = ACTIONS(670),
    [anon_sym_PLUS] = ACTIONS(672),
    [anon_sym_DASH] = ACTIONS(672),
    [anon_sym_DASH_DASH] = ACTIONS(674),
    [anon_sym_PLUS_PLUS] = ACTIONS(674),
    [anon_sym_sizeof] = ACTIONS(676),
    [sym_number_literal] = ACTIONS(3114),
    [sym_char_literal] = ACTIONS(3114),
    [sym_string_literal] = ACTIONS(678),
    [sym_true] = ACTIONS(3118),
    [sym_false] = ACTIONS(3118),
    [sym_null] = ACTIONS(3118),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1303),
    [anon_sym_delete] = ACTIONS(686),
    [sym_nullptr] = ACTIONS(3118),
  },
  [890] = {
    [sym__expression] = STATE(740),
    [sym_conditional_expression] = STATE(740),
    [sym_assignment_expression] = STATE(740),
    [sym_pointer_expression] = STATE(740),
    [sym_logical_expression] = STATE(740),
    [sym_bitwise_expression] = STATE(740),
    [sym_equality_expression] = STATE(740),
    [sym_relational_expression] = STATE(740),
    [sym_shift_expression] = STATE(740),
    [sym_math_expression] = STATE(740),
    [sym_cast_expression] = STATE(740),
    [sym_sizeof_expression] = STATE(740),
    [sym_subscript_expression] = STATE(740),
    [sym_call_expression] = STATE(740),
    [sym_field_expression] = STATE(740),
    [sym_compound_literal_expression] = STATE(740),
    [sym_parenthesized_expression] = STATE(740),
    [sym_concatenated_string] = STATE(740),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(740),
    [sym_new_expression] = STATE(740),
    [sym_delete_expression] = STATE(740),
    [sym_lambda_expression] = STATE(740),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_lambda_default_capture] = STATE(741),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(1417),
    [anon_sym_LPAREN] = ACTIONS(1419),
    [anon_sym_STAR] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_RBRACK] = ACTIONS(3120),
    [anon_sym_EQ] = ACTIONS(1425),
    [anon_sym_AMP] = ACTIONS(1427),
    [anon_sym_BANG] = ACTIONS(1429),
    [anon_sym_TILDE] = ACTIONS(1431),
    [anon_sym_PLUS] = ACTIONS(1433),
    [anon_sym_DASH] = ACTIONS(1433),
    [anon_sym_DASH_DASH] = ACTIONS(1435),
    [anon_sym_PLUS_PLUS] = ACTIONS(1435),
    [anon_sym_sizeof] = ACTIONS(1437),
    [sym_number_literal] = ACTIONS(1417),
    [sym_char_literal] = ACTIONS(1417),
    [sym_string_literal] = ACTIONS(1439),
    [sym_true] = ACTIONS(1441),
    [sym_false] = ACTIONS(1441),
    [sym_null] = ACTIONS(1441),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1443),
    [anon_sym_delete] = ACTIONS(1445),
    [sym_nullptr] = ACTIONS(1441),
  },
  [891] = {
    [sym_argument_list] = STATE(802),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_COMMA] = ACTIONS(2740),
    [anon_sym_SEMI] = ACTIONS(2740),
    [anon_sym_STAR] = ACTIONS(1744),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_EQ] = ACTIONS(2742),
    [anon_sym_QMARK] = ACTIONS(2740),
    [anon_sym_STAR_EQ] = ACTIONS(2740),
    [anon_sym_SLASH_EQ] = ACTIONS(2740),
    [anon_sym_PERCENT_EQ] = ACTIONS(2740),
    [anon_sym_PLUS_EQ] = ACTIONS(2740),
    [anon_sym_DASH_EQ] = ACTIONS(2740),
    [anon_sym_LT_LT_EQ] = ACTIONS(2740),
    [anon_sym_GT_GT_EQ] = ACTIONS(2740),
    [anon_sym_AMP_EQ] = ACTIONS(2740),
    [anon_sym_CARET_EQ] = ACTIONS(2740),
    [anon_sym_PIPE_EQ] = ACTIONS(2740),
    [anon_sym_AMP] = ACTIONS(1752),
    [anon_sym_PIPE_PIPE] = ACTIONS(1754),
    [anon_sym_AMP_AMP] = ACTIONS(1756),
    [anon_sym_PIPE] = ACTIONS(1758),
    [anon_sym_CARET] = ACTIONS(1760),
    [anon_sym_EQ_EQ] = ACTIONS(1762),
    [anon_sym_BANG_EQ] = ACTIONS(1762),
    [anon_sym_LT] = ACTIONS(1764),
    [anon_sym_GT] = ACTIONS(1764),
    [anon_sym_LT_EQ] = ACTIONS(1766),
    [anon_sym_GT_EQ] = ACTIONS(1766),
    [anon_sym_LT_LT] = ACTIONS(1768),
    [anon_sym_GT_GT] = ACTIONS(1768),
    [anon_sym_PLUS] = ACTIONS(1770),
    [anon_sym_DASH] = ACTIONS(1770),
    [anon_sym_SLASH] = ACTIONS(1744),
    [anon_sym_PERCENT] = ACTIONS(1744),
    [anon_sym_DASH_DASH] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(1554),
    [anon_sym_DASH_GT] = ACTIONS(1554),
    [sym_comment] = ACTIONS(49),
  },
  [892] = {
    [sym_raw_string_literal] = ACTIONS(522),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(524),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(524),
    [anon_sym_LPAREN] = ACTIONS(522),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(524),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(524),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(524),
    [sym_preproc_directive] = ACTIONS(524),
    [anon_sym_SEMI] = ACTIONS(522),
    [anon_sym_typedef] = ACTIONS(524),
    [anon_sym_extern] = ACTIONS(524),
    [anon_sym_LBRACE] = ACTIONS(522),
    [anon_sym_RBRACE] = ACTIONS(522),
    [anon_sym_STAR] = ACTIONS(522),
    [anon_sym_LBRACK] = ACTIONS(522),
    [anon_sym_static] = ACTIONS(524),
    [anon_sym_register] = ACTIONS(524),
    [anon_sym_inline] = ACTIONS(524),
    [anon_sym_const] = ACTIONS(524),
    [anon_sym_restrict] = ACTIONS(524),
    [anon_sym_volatile] = ACTIONS(524),
    [anon_sym__Atomic] = ACTIONS(524),
    [anon_sym_mutable] = ACTIONS(524),
    [anon_sym_explicit] = ACTIONS(524),
    [anon_sym_constexpr] = ACTIONS(524),
    [anon_sym_unsigned] = ACTIONS(524),
    [anon_sym_long] = ACTIONS(524),
    [anon_sym_short] = ACTIONS(524),
    [sym_primitive_type] = ACTIONS(524),
    [anon_sym_enum] = ACTIONS(524),
    [anon_sym_struct] = ACTIONS(524),
    [anon_sym_union] = ACTIONS(524),
    [anon_sym_if] = ACTIONS(524),
    [anon_sym_switch] = ACTIONS(524),
    [anon_sym_case] = ACTIONS(524),
    [anon_sym_default] = ACTIONS(524),
    [anon_sym_while] = ACTIONS(524),
    [anon_sym_do] = ACTIONS(524),
    [anon_sym_for] = ACTIONS(524),
    [anon_sym_return] = ACTIONS(524),
    [anon_sym_break] = ACTIONS(524),
    [anon_sym_continue] = ACTIONS(524),
    [anon_sym_goto] = ACTIONS(524),
    [anon_sym_AMP] = ACTIONS(522),
    [anon_sym_BANG] = ACTIONS(522),
    [anon_sym_TILDE] = ACTIONS(522),
    [anon_sym_PLUS] = ACTIONS(524),
    [anon_sym_DASH] = ACTIONS(524),
    [anon_sym_DASH_DASH] = ACTIONS(522),
    [anon_sym_PLUS_PLUS] = ACTIONS(522),
    [anon_sym_sizeof] = ACTIONS(524),
    [sym_number_literal] = ACTIONS(522),
    [sym_char_literal] = ACTIONS(522),
    [sym_string_literal] = ACTIONS(522),
    [sym_true] = ACTIONS(524),
    [sym_false] = ACTIONS(524),
    [sym_null] = ACTIONS(524),
    [sym_identifier] = ACTIONS(524),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(524),
    [sym_auto] = ACTIONS(524),
    [anon_sym_typename] = ACTIONS(524),
    [anon_sym_new] = ACTIONS(524),
    [anon_sym_COLON_COLON] = ACTIONS(522),
    [anon_sym_delete] = ACTIONS(524),
    [sym_nullptr] = ACTIONS(524),
  },
  [893] = {
    [sym_parameter_list] = STATE(332),
    [sym_argument_list] = STATE(333),
    [sym_initializer_list] = STATE(333),
    [aux_sym_declaration_repeat1] = STATE(1514),
    [anon_sym_LPAREN] = ACTIONS(536),
    [anon_sym_COMMA] = ACTIONS(538),
    [anon_sym_SEMI] = ACTIONS(3122),
    [anon_sym_LBRACE] = ACTIONS(548),
    [anon_sym_LBRACK] = ACTIONS(208),
    [anon_sym_EQ] = ACTIONS(544),
    [sym_comment] = ACTIONS(49),
  },
  [894] = {
    [aux_sym_declaration_repeat1] = STATE(1514),
    [anon_sym_COMMA] = ACTIONS(538),
    [anon_sym_SEMI] = ACTIONS(3122),
    [sym_comment] = ACTIONS(49),
  },
  [895] = {
    [sym_argument_list] = STATE(1516),
    [sym_initializer_list] = STATE(1516),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_LBRACE] = ACTIONS(548),
    [anon_sym_EQ] = ACTIONS(3124),
    [sym_comment] = ACTIONS(49),
  },
  [896] = {
    [sym_argument_list] = STATE(1518),
    [sym_initializer_list] = STATE(1518),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_LBRACE] = ACTIONS(548),
    [anon_sym_EQ] = ACTIONS(3126),
    [sym_comment] = ACTIONS(49),
  },
  [897] = {
    [sym__expression] = STATE(1519),
    [sym_comma_expression] = STATE(1520),
    [sym_conditional_expression] = STATE(1519),
    [sym_assignment_expression] = STATE(1519),
    [sym_pointer_expression] = STATE(1519),
    [sym_logical_expression] = STATE(1519),
    [sym_bitwise_expression] = STATE(1519),
    [sym_equality_expression] = STATE(1519),
    [sym_relational_expression] = STATE(1519),
    [sym_shift_expression] = STATE(1519),
    [sym_math_expression] = STATE(1519),
    [sym_cast_expression] = STATE(1519),
    [sym_sizeof_expression] = STATE(1519),
    [sym_subscript_expression] = STATE(1519),
    [sym_call_expression] = STATE(1519),
    [sym_field_expression] = STATE(1519),
    [sym_compound_literal_expression] = STATE(1519),
    [sym_parenthesized_expression] = STATE(1519),
    [sym_concatenated_string] = STATE(1519),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(1519),
    [sym_new_expression] = STATE(1519),
    [sym_delete_expression] = STATE(1519),
    [sym_lambda_expression] = STATE(1519),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(3128),
    [anon_sym_LPAREN] = ACTIONS(626),
    [anon_sym_STAR] = ACTIONS(644),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_AMP] = ACTIONS(644),
    [anon_sym_BANG] = ACTIONS(668),
    [anon_sym_TILDE] = ACTIONS(670),
    [anon_sym_PLUS] = ACTIONS(672),
    [anon_sym_DASH] = ACTIONS(672),
    [anon_sym_DASH_DASH] = ACTIONS(674),
    [anon_sym_PLUS_PLUS] = ACTIONS(674),
    [anon_sym_sizeof] = ACTIONS(676),
    [sym_number_literal] = ACTIONS(3128),
    [sym_char_literal] = ACTIONS(3128),
    [sym_string_literal] = ACTIONS(678),
    [sym_true] = ACTIONS(3130),
    [sym_false] = ACTIONS(3130),
    [sym_null] = ACTIONS(3130),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1303),
    [anon_sym_delete] = ACTIONS(686),
    [sym_nullptr] = ACTIONS(3130),
  },
  [898] = {
    [sym_raw_string_literal] = ACTIONS(3132),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3134),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3134),
    [anon_sym_LPAREN] = ACTIONS(3132),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3134),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3134),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3134),
    [sym_preproc_directive] = ACTIONS(3134),
    [anon_sym_SEMI] = ACTIONS(3132),
    [anon_sym_typedef] = ACTIONS(3134),
    [anon_sym_extern] = ACTIONS(3134),
    [anon_sym_LBRACE] = ACTIONS(3132),
    [anon_sym_RBRACE] = ACTIONS(3132),
    [anon_sym_STAR] = ACTIONS(3132),
    [anon_sym_LBRACK] = ACTIONS(3132),
    [anon_sym_static] = ACTIONS(3134),
    [anon_sym_register] = ACTIONS(3134),
    [anon_sym_inline] = ACTIONS(3134),
    [anon_sym_const] = ACTIONS(3134),
    [anon_sym_restrict] = ACTIONS(3134),
    [anon_sym_volatile] = ACTIONS(3134),
    [anon_sym__Atomic] = ACTIONS(3134),
    [anon_sym_mutable] = ACTIONS(3134),
    [anon_sym_explicit] = ACTIONS(3134),
    [anon_sym_constexpr] = ACTIONS(3134),
    [anon_sym_unsigned] = ACTIONS(3134),
    [anon_sym_long] = ACTIONS(3134),
    [anon_sym_short] = ACTIONS(3134),
    [sym_primitive_type] = ACTIONS(3134),
    [anon_sym_enum] = ACTIONS(3134),
    [anon_sym_struct] = ACTIONS(3134),
    [anon_sym_union] = ACTIONS(3134),
    [anon_sym_if] = ACTIONS(3134),
    [anon_sym_switch] = ACTIONS(3134),
    [anon_sym_case] = ACTIONS(3134),
    [anon_sym_default] = ACTIONS(3134),
    [anon_sym_while] = ACTIONS(3134),
    [anon_sym_do] = ACTIONS(3134),
    [anon_sym_for] = ACTIONS(3134),
    [anon_sym_return] = ACTIONS(3134),
    [anon_sym_break] = ACTIONS(3134),
    [anon_sym_continue] = ACTIONS(3134),
    [anon_sym_goto] = ACTIONS(3134),
    [anon_sym_AMP] = ACTIONS(3132),
    [anon_sym_BANG] = ACTIONS(3132),
    [anon_sym_TILDE] = ACTIONS(3132),
    [anon_sym_PLUS] = ACTIONS(3134),
    [anon_sym_DASH] = ACTIONS(3134),
    [anon_sym_DASH_DASH] = ACTIONS(3132),
    [anon_sym_PLUS_PLUS] = ACTIONS(3132),
    [anon_sym_sizeof] = ACTIONS(3134),
    [sym_number_literal] = ACTIONS(3132),
    [sym_char_literal] = ACTIONS(3132),
    [sym_string_literal] = ACTIONS(3132),
    [sym_true] = ACTIONS(3134),
    [sym_false] = ACTIONS(3134),
    [sym_null] = ACTIONS(3134),
    [sym_identifier] = ACTIONS(3134),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(3134),
    [sym_auto] = ACTIONS(3134),
    [anon_sym_typename] = ACTIONS(3134),
    [anon_sym_new] = ACTIONS(3134),
    [anon_sym_COLON_COLON] = ACTIONS(3132),
    [anon_sym_delete] = ACTIONS(3134),
    [sym_nullptr] = ACTIONS(3134),
  },
  [899] = {
    [sym__expression] = STATE(1328),
    [sym_conditional_expression] = STATE(1328),
    [sym_assignment_expression] = STATE(1328),
    [sym_pointer_expression] = STATE(1328),
    [sym_logical_expression] = STATE(1328),
    [sym_bitwise_expression] = STATE(1328),
    [sym_equality_expression] = STATE(1328),
    [sym_relational_expression] = STATE(1328),
    [sym_shift_expression] = STATE(1328),
    [sym_math_expression] = STATE(1328),
    [sym_cast_expression] = STATE(1328),
    [sym_sizeof_expression] = STATE(1328),
    [sym_subscript_expression] = STATE(1328),
    [sym_call_expression] = STATE(1328),
    [sym_field_expression] = STATE(1328),
    [sym_compound_literal_expression] = STATE(1328),
    [sym_parenthesized_expression] = STATE(1328),
    [sym_concatenated_string] = STATE(1328),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(1328),
    [sym_new_expression] = STATE(1328),
    [sym_delete_expression] = STATE(1328),
    [sym_lambda_expression] = STATE(1328),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(2748),
    [anon_sym_LPAREN] = ACTIONS(626),
    [anon_sym_STAR] = ACTIONS(644),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_AMP] = ACTIONS(644),
    [anon_sym_BANG] = ACTIONS(668),
    [anon_sym_TILDE] = ACTIONS(670),
    [anon_sym_PLUS] = ACTIONS(672),
    [anon_sym_DASH] = ACTIONS(672),
    [anon_sym_DASH_DASH] = ACTIONS(674),
    [anon_sym_PLUS_PLUS] = ACTIONS(674),
    [anon_sym_sizeof] = ACTIONS(676),
    [sym_number_literal] = ACTIONS(2748),
    [sym_char_literal] = ACTIONS(2748),
    [sym_string_literal] = ACTIONS(678),
    [sym_true] = ACTIONS(2750),
    [sym_false] = ACTIONS(2750),
    [sym_null] = ACTIONS(2750),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1303),
    [anon_sym_delete] = ACTIONS(686),
    [sym_nullptr] = ACTIONS(2750),
  },
  [900] = {
    [sym__expression] = STATE(1521),
    [sym_conditional_expression] = STATE(1521),
    [sym_assignment_expression] = STATE(1521),
    [sym_pointer_expression] = STATE(1521),
    [sym_logical_expression] = STATE(1521),
    [sym_bitwise_expression] = STATE(1521),
    [sym_equality_expression] = STATE(1521),
    [sym_relational_expression] = STATE(1521),
    [sym_shift_expression] = STATE(1521),
    [sym_math_expression] = STATE(1521),
    [sym_cast_expression] = STATE(1521),
    [sym_sizeof_expression] = STATE(1521),
    [sym_subscript_expression] = STATE(1521),
    [sym_call_expression] = STATE(1521),
    [sym_field_expression] = STATE(1521),
    [sym_compound_literal_expression] = STATE(1521),
    [sym_parenthesized_expression] = STATE(1521),
    [sym_concatenated_string] = STATE(1521),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(1521),
    [sym_new_expression] = STATE(1521),
    [sym_delete_expression] = STATE(1521),
    [sym_lambda_expression] = STATE(1521),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(3136),
    [anon_sym_LPAREN] = ACTIONS(626),
    [anon_sym_STAR] = ACTIONS(644),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_AMP] = ACTIONS(644),
    [anon_sym_BANG] = ACTIONS(668),
    [anon_sym_TILDE] = ACTIONS(670),
    [anon_sym_PLUS] = ACTIONS(672),
    [anon_sym_DASH] = ACTIONS(672),
    [anon_sym_DASH_DASH] = ACTIONS(674),
    [anon_sym_PLUS_PLUS] = ACTIONS(674),
    [anon_sym_sizeof] = ACTIONS(676),
    [sym_number_literal] = ACTIONS(3136),
    [sym_char_literal] = ACTIONS(3136),
    [sym_string_literal] = ACTIONS(678),
    [sym_true] = ACTIONS(3138),
    [sym_false] = ACTIONS(3138),
    [sym_null] = ACTIONS(3138),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1303),
    [anon_sym_delete] = ACTIONS(686),
    [sym_nullptr] = ACTIONS(3138),
  },
  [901] = {
    [sym__expression] = STATE(1522),
    [sym_conditional_expression] = STATE(1522),
    [sym_assignment_expression] = STATE(1522),
    [sym_pointer_expression] = STATE(1522),
    [sym_logical_expression] = STATE(1522),
    [sym_bitwise_expression] = STATE(1522),
    [sym_equality_expression] = STATE(1522),
    [sym_relational_expression] = STATE(1522),
    [sym_shift_expression] = STATE(1522),
    [sym_math_expression] = STATE(1522),
    [sym_cast_expression] = STATE(1522),
    [sym_sizeof_expression] = STATE(1522),
    [sym_subscript_expression] = STATE(1522),
    [sym_call_expression] = STATE(1522),
    [sym_field_expression] = STATE(1522),
    [sym_compound_literal_expression] = STATE(1522),
    [sym_parenthesized_expression] = STATE(1522),
    [sym_concatenated_string] = STATE(1522),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(1522),
    [sym_new_expression] = STATE(1522),
    [sym_delete_expression] = STATE(1522),
    [sym_lambda_expression] = STATE(1522),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(855),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(3140),
    [anon_sym_LPAREN] = ACTIONS(1634),
    [anon_sym_STAR] = ACTIONS(1636),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_AMP] = ACTIONS(1636),
    [anon_sym_BANG] = ACTIONS(1638),
    [anon_sym_TILDE] = ACTIONS(1640),
    [anon_sym_PLUS] = ACTIONS(1642),
    [anon_sym_DASH] = ACTIONS(1642),
    [anon_sym_DASH_DASH] = ACTIONS(1644),
    [anon_sym_PLUS_PLUS] = ACTIONS(1644),
    [anon_sym_sizeof] = ACTIONS(1646),
    [sym_number_literal] = ACTIONS(3140),
    [sym_char_literal] = ACTIONS(3140),
    [sym_string_literal] = ACTIONS(1648),
    [sym_true] = ACTIONS(3142),
    [sym_false] = ACTIONS(3142),
    [sym_null] = ACTIONS(3142),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1652),
    [anon_sym_delete] = ACTIONS(1654),
    [sym_nullptr] = ACTIONS(3142),
  },
  [902] = {
    [sym__expression] = STATE(1523),
    [sym_conditional_expression] = STATE(1523),
    [sym_assignment_expression] = STATE(1523),
    [sym_pointer_expression] = STATE(1523),
    [sym_logical_expression] = STATE(1523),
    [sym_bitwise_expression] = STATE(1523),
    [sym_equality_expression] = STATE(1523),
    [sym_relational_expression] = STATE(1523),
    [sym_shift_expression] = STATE(1523),
    [sym_math_expression] = STATE(1523),
    [sym_cast_expression] = STATE(1523),
    [sym_sizeof_expression] = STATE(1523),
    [sym_subscript_expression] = STATE(1523),
    [sym_call_expression] = STATE(1523),
    [sym_field_expression] = STATE(1523),
    [sym_compound_literal_expression] = STATE(1523),
    [sym_parenthesized_expression] = STATE(1523),
    [sym_concatenated_string] = STATE(1523),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(1523),
    [sym_new_expression] = STATE(1523),
    [sym_delete_expression] = STATE(1523),
    [sym_lambda_expression] = STATE(1523),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(3144),
    [anon_sym_LPAREN] = ACTIONS(626),
    [anon_sym_STAR] = ACTIONS(644),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_AMP] = ACTIONS(644),
    [anon_sym_BANG] = ACTIONS(668),
    [anon_sym_TILDE] = ACTIONS(670),
    [anon_sym_PLUS] = ACTIONS(672),
    [anon_sym_DASH] = ACTIONS(672),
    [anon_sym_DASH_DASH] = ACTIONS(674),
    [anon_sym_PLUS_PLUS] = ACTIONS(674),
    [anon_sym_sizeof] = ACTIONS(676),
    [sym_number_literal] = ACTIONS(3144),
    [sym_char_literal] = ACTIONS(3144),
    [sym_string_literal] = ACTIONS(678),
    [sym_true] = ACTIONS(3146),
    [sym_false] = ACTIONS(3146),
    [sym_null] = ACTIONS(3146),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1303),
    [anon_sym_delete] = ACTIONS(686),
    [sym_nullptr] = ACTIONS(3146),
  },
  [903] = {
    [sym__expression] = STATE(1524),
    [sym_conditional_expression] = STATE(1524),
    [sym_assignment_expression] = STATE(1524),
    [sym_pointer_expression] = STATE(1524),
    [sym_logical_expression] = STATE(1524),
    [sym_bitwise_expression] = STATE(1524),
    [sym_equality_expression] = STATE(1524),
    [sym_relational_expression] = STATE(1524),
    [sym_shift_expression] = STATE(1524),
    [sym_math_expression] = STATE(1524),
    [sym_cast_expression] = STATE(1524),
    [sym_sizeof_expression] = STATE(1524),
    [sym_subscript_expression] = STATE(1524),
    [sym_call_expression] = STATE(1524),
    [sym_field_expression] = STATE(1524),
    [sym_compound_literal_expression] = STATE(1524),
    [sym_parenthesized_expression] = STATE(1524),
    [sym_concatenated_string] = STATE(1524),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(1524),
    [sym_new_expression] = STATE(1524),
    [sym_delete_expression] = STATE(1524),
    [sym_lambda_expression] = STATE(1524),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(3148),
    [anon_sym_LPAREN] = ACTIONS(626),
    [anon_sym_STAR] = ACTIONS(644),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_AMP] = ACTIONS(644),
    [anon_sym_BANG] = ACTIONS(668),
    [anon_sym_TILDE] = ACTIONS(670),
    [anon_sym_PLUS] = ACTIONS(672),
    [anon_sym_DASH] = ACTIONS(672),
    [anon_sym_DASH_DASH] = ACTIONS(674),
    [anon_sym_PLUS_PLUS] = ACTIONS(674),
    [anon_sym_sizeof] = ACTIONS(676),
    [sym_number_literal] = ACTIONS(3148),
    [sym_char_literal] = ACTIONS(3148),
    [sym_string_literal] = ACTIONS(678),
    [sym_true] = ACTIONS(3150),
    [sym_false] = ACTIONS(3150),
    [sym_null] = ACTIONS(3150),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1303),
    [anon_sym_delete] = ACTIONS(686),
    [sym_nullptr] = ACTIONS(3150),
  },
  [904] = {
    [sym__expression] = STATE(1525),
    [sym_conditional_expression] = STATE(1525),
    [sym_assignment_expression] = STATE(1525),
    [sym_pointer_expression] = STATE(1525),
    [sym_logical_expression] = STATE(1525),
    [sym_bitwise_expression] = STATE(1525),
    [sym_equality_expression] = STATE(1525),
    [sym_relational_expression] = STATE(1525),
    [sym_shift_expression] = STATE(1525),
    [sym_math_expression] = STATE(1525),
    [sym_cast_expression] = STATE(1525),
    [sym_sizeof_expression] = STATE(1525),
    [sym_subscript_expression] = STATE(1525),
    [sym_call_expression] = STATE(1525),
    [sym_field_expression] = STATE(1525),
    [sym_compound_literal_expression] = STATE(1525),
    [sym_parenthesized_expression] = STATE(1525),
    [sym_concatenated_string] = STATE(1525),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(1525),
    [sym_new_expression] = STATE(1525),
    [sym_delete_expression] = STATE(1525),
    [sym_lambda_expression] = STATE(1525),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(3152),
    [anon_sym_LPAREN] = ACTIONS(626),
    [anon_sym_STAR] = ACTIONS(644),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_AMP] = ACTIONS(644),
    [anon_sym_BANG] = ACTIONS(668),
    [anon_sym_TILDE] = ACTIONS(670),
    [anon_sym_PLUS] = ACTIONS(672),
    [anon_sym_DASH] = ACTIONS(672),
    [anon_sym_DASH_DASH] = ACTIONS(674),
    [anon_sym_PLUS_PLUS] = ACTIONS(674),
    [anon_sym_sizeof] = ACTIONS(676),
    [sym_number_literal] = ACTIONS(3152),
    [sym_char_literal] = ACTIONS(3152),
    [sym_string_literal] = ACTIONS(678),
    [sym_true] = ACTIONS(3154),
    [sym_false] = ACTIONS(3154),
    [sym_null] = ACTIONS(3154),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1303),
    [anon_sym_delete] = ACTIONS(686),
    [sym_nullptr] = ACTIONS(3154),
  },
  [905] = {
    [sym__expression] = STATE(1526),
    [sym_conditional_expression] = STATE(1526),
    [sym_assignment_expression] = STATE(1526),
    [sym_pointer_expression] = STATE(1526),
    [sym_logical_expression] = STATE(1526),
    [sym_bitwise_expression] = STATE(1526),
    [sym_equality_expression] = STATE(1526),
    [sym_relational_expression] = STATE(1526),
    [sym_shift_expression] = STATE(1526),
    [sym_math_expression] = STATE(1526),
    [sym_cast_expression] = STATE(1526),
    [sym_sizeof_expression] = STATE(1526),
    [sym_subscript_expression] = STATE(1526),
    [sym_call_expression] = STATE(1526),
    [sym_field_expression] = STATE(1526),
    [sym_compound_literal_expression] = STATE(1526),
    [sym_parenthesized_expression] = STATE(1526),
    [sym_concatenated_string] = STATE(1526),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(1526),
    [sym_new_expression] = STATE(1526),
    [sym_delete_expression] = STATE(1526),
    [sym_lambda_expression] = STATE(1526),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(3156),
    [anon_sym_LPAREN] = ACTIONS(626),
    [anon_sym_STAR] = ACTIONS(644),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_AMP] = ACTIONS(644),
    [anon_sym_BANG] = ACTIONS(668),
    [anon_sym_TILDE] = ACTIONS(670),
    [anon_sym_PLUS] = ACTIONS(672),
    [anon_sym_DASH] = ACTIONS(672),
    [anon_sym_DASH_DASH] = ACTIONS(674),
    [anon_sym_PLUS_PLUS] = ACTIONS(674),
    [anon_sym_sizeof] = ACTIONS(676),
    [sym_number_literal] = ACTIONS(3156),
    [sym_char_literal] = ACTIONS(3156),
    [sym_string_literal] = ACTIONS(678),
    [sym_true] = ACTIONS(3158),
    [sym_false] = ACTIONS(3158),
    [sym_null] = ACTIONS(3158),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1303),
    [anon_sym_delete] = ACTIONS(686),
    [sym_nullptr] = ACTIONS(3158),
  },
  [906] = {
    [sym__expression] = STATE(1527),
    [sym_conditional_expression] = STATE(1527),
    [sym_assignment_expression] = STATE(1527),
    [sym_pointer_expression] = STATE(1527),
    [sym_logical_expression] = STATE(1527),
    [sym_bitwise_expression] = STATE(1527),
    [sym_equality_expression] = STATE(1527),
    [sym_relational_expression] = STATE(1527),
    [sym_shift_expression] = STATE(1527),
    [sym_math_expression] = STATE(1527),
    [sym_cast_expression] = STATE(1527),
    [sym_sizeof_expression] = STATE(1527),
    [sym_subscript_expression] = STATE(1527),
    [sym_call_expression] = STATE(1527),
    [sym_field_expression] = STATE(1527),
    [sym_compound_literal_expression] = STATE(1527),
    [sym_parenthesized_expression] = STATE(1527),
    [sym_concatenated_string] = STATE(1527),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(1527),
    [sym_new_expression] = STATE(1527),
    [sym_delete_expression] = STATE(1527),
    [sym_lambda_expression] = STATE(1527),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(3160),
    [anon_sym_LPAREN] = ACTIONS(626),
    [anon_sym_STAR] = ACTIONS(644),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_AMP] = ACTIONS(644),
    [anon_sym_BANG] = ACTIONS(668),
    [anon_sym_TILDE] = ACTIONS(670),
    [anon_sym_PLUS] = ACTIONS(672),
    [anon_sym_DASH] = ACTIONS(672),
    [anon_sym_DASH_DASH] = ACTIONS(674),
    [anon_sym_PLUS_PLUS] = ACTIONS(674),
    [anon_sym_sizeof] = ACTIONS(676),
    [sym_number_literal] = ACTIONS(3160),
    [sym_char_literal] = ACTIONS(3160),
    [sym_string_literal] = ACTIONS(678),
    [sym_true] = ACTIONS(3162),
    [sym_false] = ACTIONS(3162),
    [sym_null] = ACTIONS(3162),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1303),
    [anon_sym_delete] = ACTIONS(686),
    [sym_nullptr] = ACTIONS(3162),
  },
  [907] = {
    [sym__expression] = STATE(1528),
    [sym_conditional_expression] = STATE(1528),
    [sym_assignment_expression] = STATE(1528),
    [sym_pointer_expression] = STATE(1528),
    [sym_logical_expression] = STATE(1528),
    [sym_bitwise_expression] = STATE(1528),
    [sym_equality_expression] = STATE(1528),
    [sym_relational_expression] = STATE(1528),
    [sym_shift_expression] = STATE(1528),
    [sym_math_expression] = STATE(1528),
    [sym_cast_expression] = STATE(1528),
    [sym_sizeof_expression] = STATE(1528),
    [sym_subscript_expression] = STATE(1528),
    [sym_call_expression] = STATE(1528),
    [sym_field_expression] = STATE(1528),
    [sym_compound_literal_expression] = STATE(1528),
    [sym_parenthesized_expression] = STATE(1528),
    [sym_concatenated_string] = STATE(1528),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(1528),
    [sym_new_expression] = STATE(1528),
    [sym_delete_expression] = STATE(1528),
    [sym_lambda_expression] = STATE(1528),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(3164),
    [anon_sym_LPAREN] = ACTIONS(626),
    [anon_sym_STAR] = ACTIONS(644),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_AMP] = ACTIONS(644),
    [anon_sym_BANG] = ACTIONS(668),
    [anon_sym_TILDE] = ACTIONS(670),
    [anon_sym_PLUS] = ACTIONS(672),
    [anon_sym_DASH] = ACTIONS(672),
    [anon_sym_DASH_DASH] = ACTIONS(674),
    [anon_sym_PLUS_PLUS] = ACTIONS(674),
    [anon_sym_sizeof] = ACTIONS(676),
    [sym_number_literal] = ACTIONS(3164),
    [sym_char_literal] = ACTIONS(3164),
    [sym_string_literal] = ACTIONS(678),
    [sym_true] = ACTIONS(3166),
    [sym_false] = ACTIONS(3166),
    [sym_null] = ACTIONS(3166),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1303),
    [anon_sym_delete] = ACTIONS(686),
    [sym_nullptr] = ACTIONS(3166),
  },
  [908] = {
    [sym__expression] = STATE(1529),
    [sym_conditional_expression] = STATE(1529),
    [sym_assignment_expression] = STATE(1529),
    [sym_pointer_expression] = STATE(1529),
    [sym_logical_expression] = STATE(1529),
    [sym_bitwise_expression] = STATE(1529),
    [sym_equality_expression] = STATE(1529),
    [sym_relational_expression] = STATE(1529),
    [sym_shift_expression] = STATE(1529),
    [sym_math_expression] = STATE(1529),
    [sym_cast_expression] = STATE(1529),
    [sym_sizeof_expression] = STATE(1529),
    [sym_subscript_expression] = STATE(1529),
    [sym_call_expression] = STATE(1529),
    [sym_field_expression] = STATE(1529),
    [sym_compound_literal_expression] = STATE(1529),
    [sym_parenthesized_expression] = STATE(1529),
    [sym_concatenated_string] = STATE(1529),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(1529),
    [sym_new_expression] = STATE(1529),
    [sym_delete_expression] = STATE(1529),
    [sym_lambda_expression] = STATE(1529),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(3168),
    [anon_sym_LPAREN] = ACTIONS(626),
    [anon_sym_STAR] = ACTIONS(644),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_AMP] = ACTIONS(644),
    [anon_sym_BANG] = ACTIONS(668),
    [anon_sym_TILDE] = ACTIONS(670),
    [anon_sym_PLUS] = ACTIONS(672),
    [anon_sym_DASH] = ACTIONS(672),
    [anon_sym_DASH_DASH] = ACTIONS(674),
    [anon_sym_PLUS_PLUS] = ACTIONS(674),
    [anon_sym_sizeof] = ACTIONS(676),
    [sym_number_literal] = ACTIONS(3168),
    [sym_char_literal] = ACTIONS(3168),
    [sym_string_literal] = ACTIONS(678),
    [sym_true] = ACTIONS(3170),
    [sym_false] = ACTIONS(3170),
    [sym_null] = ACTIONS(3170),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1303),
    [anon_sym_delete] = ACTIONS(686),
    [sym_nullptr] = ACTIONS(3170),
  },
  [909] = {
    [sym__expression] = STATE(1530),
    [sym_conditional_expression] = STATE(1530),
    [sym_assignment_expression] = STATE(1530),
    [sym_pointer_expression] = STATE(1530),
    [sym_logical_expression] = STATE(1530),
    [sym_bitwise_expression] = STATE(1530),
    [sym_equality_expression] = STATE(1530),
    [sym_relational_expression] = STATE(1530),
    [sym_shift_expression] = STATE(1530),
    [sym_math_expression] = STATE(1530),
    [sym_cast_expression] = STATE(1530),
    [sym_sizeof_expression] = STATE(1530),
    [sym_subscript_expression] = STATE(1530),
    [sym_call_expression] = STATE(1530),
    [sym_field_expression] = STATE(1530),
    [sym_compound_literal_expression] = STATE(1530),
    [sym_parenthesized_expression] = STATE(1530),
    [sym_concatenated_string] = STATE(1530),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(1530),
    [sym_new_expression] = STATE(1530),
    [sym_delete_expression] = STATE(1530),
    [sym_lambda_expression] = STATE(1530),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(3172),
    [anon_sym_LPAREN] = ACTIONS(626),
    [anon_sym_STAR] = ACTIONS(644),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_AMP] = ACTIONS(644),
    [anon_sym_BANG] = ACTIONS(668),
    [anon_sym_TILDE] = ACTIONS(670),
    [anon_sym_PLUS] = ACTIONS(672),
    [anon_sym_DASH] = ACTIONS(672),
    [anon_sym_DASH_DASH] = ACTIONS(674),
    [anon_sym_PLUS_PLUS] = ACTIONS(674),
    [anon_sym_sizeof] = ACTIONS(676),
    [sym_number_literal] = ACTIONS(3172),
    [sym_char_literal] = ACTIONS(3172),
    [sym_string_literal] = ACTIONS(678),
    [sym_true] = ACTIONS(3174),
    [sym_false] = ACTIONS(3174),
    [sym_null] = ACTIONS(3174),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1303),
    [anon_sym_delete] = ACTIONS(686),
    [sym_nullptr] = ACTIONS(3174),
  },
  [910] = {
    [sym__expression] = STATE(1531),
    [sym_conditional_expression] = STATE(1531),
    [sym_assignment_expression] = STATE(1531),
    [sym_pointer_expression] = STATE(1531),
    [sym_logical_expression] = STATE(1531),
    [sym_bitwise_expression] = STATE(1531),
    [sym_equality_expression] = STATE(1531),
    [sym_relational_expression] = STATE(1531),
    [sym_shift_expression] = STATE(1531),
    [sym_math_expression] = STATE(1531),
    [sym_cast_expression] = STATE(1531),
    [sym_sizeof_expression] = STATE(1531),
    [sym_subscript_expression] = STATE(1531),
    [sym_call_expression] = STATE(1531),
    [sym_field_expression] = STATE(1531),
    [sym_compound_literal_expression] = STATE(1531),
    [sym_parenthesized_expression] = STATE(1531),
    [sym_concatenated_string] = STATE(1531),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(1531),
    [sym_new_expression] = STATE(1531),
    [sym_delete_expression] = STATE(1531),
    [sym_lambda_expression] = STATE(1531),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(626),
    [anon_sym_STAR] = ACTIONS(644),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_AMP] = ACTIONS(644),
    [anon_sym_BANG] = ACTIONS(668),
    [anon_sym_TILDE] = ACTIONS(670),
    [anon_sym_PLUS] = ACTIONS(672),
    [anon_sym_DASH] = ACTIONS(672),
    [anon_sym_DASH_DASH] = ACTIONS(674),
    [anon_sym_PLUS_PLUS] = ACTIONS(674),
    [anon_sym_sizeof] = ACTIONS(676),
    [sym_number_literal] = ACTIONS(3176),
    [sym_char_literal] = ACTIONS(3176),
    [sym_string_literal] = ACTIONS(678),
    [sym_true] = ACTIONS(3178),
    [sym_false] = ACTIONS(3178),
    [sym_null] = ACTIONS(3178),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1303),
    [anon_sym_delete] = ACTIONS(686),
    [sym_nullptr] = ACTIONS(3178),
  },
  [911] = {
    [sym_destructor_name] = STATE(428),
    [anon_sym_TILDE] = ACTIONS(1500),
    [sym_identifier] = ACTIONS(3180),
    [sym_comment] = ACTIONS(49),
    [sym_operator_name] = ACTIONS(702),
  },
  [912] = {
    [ts_builtin_sym_end] = ACTIONS(3182),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3184),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3184),
    [anon_sym_LPAREN] = ACTIONS(3182),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3184),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3184),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3184),
    [sym_preproc_directive] = ACTIONS(3184),
    [anon_sym_typedef] = ACTIONS(3184),
    [anon_sym_extern] = ACTIONS(3184),
    [anon_sym_RBRACE] = ACTIONS(3182),
    [anon_sym_STAR] = ACTIONS(3182),
    [anon_sym_static] = ACTIONS(3184),
    [anon_sym_register] = ACTIONS(3184),
    [anon_sym_inline] = ACTIONS(3184),
    [anon_sym_const] = ACTIONS(3184),
    [anon_sym_restrict] = ACTIONS(3184),
    [anon_sym_volatile] = ACTIONS(3184),
    [anon_sym__Atomic] = ACTIONS(3184),
    [anon_sym_mutable] = ACTIONS(3184),
    [anon_sym_explicit] = ACTIONS(3184),
    [anon_sym_constexpr] = ACTIONS(3184),
    [anon_sym_unsigned] = ACTIONS(3184),
    [anon_sym_long] = ACTIONS(3184),
    [anon_sym_short] = ACTIONS(3184),
    [sym_primitive_type] = ACTIONS(3184),
    [anon_sym_enum] = ACTIONS(3184),
    [anon_sym_struct] = ACTIONS(3184),
    [anon_sym_union] = ACTIONS(3184),
    [anon_sym_AMP] = ACTIONS(3184),
    [anon_sym_AMP_AMP] = ACTIONS(3182),
    [anon_sym_TILDE] = ACTIONS(3182),
    [sym_identifier] = ACTIONS(3184),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(3184),
    [sym_auto] = ACTIONS(3184),
    [anon_sym_typename] = ACTIONS(3184),
    [anon_sym_template] = ACTIONS(3184),
    [anon_sym_namespace] = ACTIONS(3184),
    [anon_sym_using] = ACTIONS(3184),
    [anon_sym_COLON_COLON] = ACTIONS(3182),
    [sym_operator_name] = ACTIONS(3182),
  },
  [913] = {
    [sym_preproc_include] = STATE(913),
    [sym_preproc_def] = STATE(913),
    [sym_preproc_function_def] = STATE(913),
    [sym_preproc_call] = STATE(913),
    [sym_preproc_if_in_compound_statement] = STATE(410),
    [sym_preproc_ifdef_in_compound_statement] = STATE(411),
    [sym_declaration] = STATE(913),
    [sym_type_definition] = STATE(913),
    [sym__declaration_specifiers] = STATE(412),
    [sym_compound_statement] = STATE(913),
    [sym_storage_class_specifier] = STATE(419),
    [sym_type_qualifier] = STATE(419),
    [sym__type_specifier] = STATE(30),
    [sym_sized_type_specifier] = STATE(30),
    [sym_enum_specifier] = STATE(30),
    [sym_struct_specifier] = STATE(30),
    [sym_union_specifier] = STATE(30),
    [sym_labeled_statement] = STATE(913),
    [sym_expression_statement] = STATE(913),
    [sym_if_statement] = STATE(913),
    [sym_switch_statement] = STATE(913),
    [sym_case_statement] = STATE(913),
    [sym_while_statement] = STATE(913),
    [sym_do_statement] = STATE(913),
    [sym_for_statement] = STATE(913),
    [sym_return_statement] = STATE(913),
    [sym_break_statement] = STATE(913),
    [sym_continue_statement] = STATE(913),
    [sym_goto_statement] = STATE(913),
    [sym__expression] = STATE(413),
    [sym_comma_expression] = STATE(414),
    [sym_conditional_expression] = STATE(413),
    [sym_assignment_expression] = STATE(413),
    [sym_pointer_expression] = STATE(413),
    [sym_logical_expression] = STATE(413),
    [sym_bitwise_expression] = STATE(413),
    [sym_equality_expression] = STATE(413),
    [sym_relational_expression] = STATE(413),
    [sym_shift_expression] = STATE(413),
    [sym_math_expression] = STATE(413),
    [sym_cast_expression] = STATE(413),
    [sym_sizeof_expression] = STATE(413),
    [sym_subscript_expression] = STATE(413),
    [sym_call_expression] = STATE(413),
    [sym_field_expression] = STATE(413),
    [sym_compound_literal_expression] = STATE(413),
    [sym_parenthesized_expression] = STATE(413),
    [sym_concatenated_string] = STATE(413),
    [sym__empty_declaration] = STATE(913),
    [sym_macro_type_specifier] = STATE(30),
    [sym_class_specifier] = STATE(30),
    [sym_dependent_type] = STATE(30),
    [sym_structured_binding_declaration] = STATE(913),
    [sym_template_type] = STATE(415),
    [sym_template_function] = STATE(413),
    [sym_for_range_loop] = STATE(913),
    [sym_new_expression] = STATE(413),
    [sym_delete_expression] = STATE(413),
    [sym_lambda_expression] = STATE(413),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(416),
    [sym_scoped_namespace_identifier] = STATE(417),
    [aux_sym_preproc_if_in_compound_statement_repeat1] = STATE(913),
    [aux_sym__declaration_specifiers_repeat1] = STATE(419),
    [aux_sym_sized_type_specifier_repeat1] = STATE(38),
    [sym_raw_string_literal] = ACTIONS(3186),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3189),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3192),
    [anon_sym_LPAREN] = ACTIONS(3195),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3198),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3201),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3204),
    [sym_preproc_directive] = ACTIONS(3207),
    [anon_sym_SEMI] = ACTIONS(3210),
    [anon_sym_typedef] = ACTIONS(3213),
    [anon_sym_extern] = ACTIONS(3216),
    [anon_sym_LBRACE] = ACTIONS(3219),
    [anon_sym_RBRACE] = ACTIONS(3222),
    [anon_sym_STAR] = ACTIONS(3224),
    [anon_sym_LBRACK] = ACTIONS(3227),
    [anon_sym_static] = ACTIONS(3216),
    [anon_sym_register] = ACTIONS(3216),
    [anon_sym_inline] = ACTIONS(3216),
    [anon_sym_const] = ACTIONS(3230),
    [anon_sym_restrict] = ACTIONS(3230),
    [anon_sym_volatile] = ACTIONS(3230),
    [anon_sym__Atomic] = ACTIONS(3230),
    [anon_sym_mutable] = ACTIONS(3230),
    [anon_sym_explicit] = ACTIONS(3230),
    [anon_sym_constexpr] = ACTIONS(3230),
    [anon_sym_unsigned] = ACTIONS(3233),
    [anon_sym_long] = ACTIONS(3233),
    [anon_sym_short] = ACTIONS(3233),
    [sym_primitive_type] = ACTIONS(3236),
    [anon_sym_enum] = ACTIONS(3239),
    [anon_sym_struct] = ACTIONS(3242),
    [anon_sym_union] = ACTIONS(3245),
    [anon_sym_if] = ACTIONS(3248),
    [anon_sym_switch] = ACTIONS(3251),
    [anon_sym_case] = ACTIONS(3254),
    [anon_sym_default] = ACTIONS(3257),
    [anon_sym_while] = ACTIONS(3260),
    [anon_sym_do] = ACTIONS(3263),
    [anon_sym_for] = ACTIONS(3266),
    [anon_sym_return] = ACTIONS(3269),
    [anon_sym_break] = ACTIONS(3272),
    [anon_sym_continue] = ACTIONS(3275),
    [anon_sym_goto] = ACTIONS(3278),
    [anon_sym_AMP] = ACTIONS(3224),
    [anon_sym_BANG] = ACTIONS(3281),
    [anon_sym_TILDE] = ACTIONS(3284),
    [anon_sym_PLUS] = ACTIONS(3287),
    [anon_sym_DASH] = ACTIONS(3287),
    [anon_sym_DASH_DASH] = ACTIONS(3290),
    [anon_sym_PLUS_PLUS] = ACTIONS(3290),
    [anon_sym_sizeof] = ACTIONS(3293),
    [sym_number_literal] = ACTIONS(3186),
    [sym_char_literal] = ACTIONS(3186),
    [sym_string_literal] = ACTIONS(3296),
    [sym_true] = ACTIONS(3299),
    [sym_false] = ACTIONS(3299),
    [sym_null] = ACTIONS(3299),
    [sym_identifier] = ACTIONS(3302),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(3305),
    [sym_auto] = ACTIONS(3236),
    [anon_sym_typename] = ACTIONS(3308),
    [anon_sym_new] = ACTIONS(3311),
    [anon_sym_COLON_COLON] = ACTIONS(3314),
    [anon_sym_delete] = ACTIONS(3317),
    [sym_nullptr] = ACTIONS(3299),
  },
  [914] = {
    [sym_destructor_name] = STATE(1534),
    [anon_sym_TILDE] = ACTIONS(45),
    [sym_identifier] = ACTIONS(3320),
    [sym_comment] = ACTIONS(49),
    [sym_operator_name] = ACTIONS(3322),
  },
  [915] = {
    [anon_sym_COMMA] = ACTIONS(3324),
    [anon_sym_LBRACE] = ACTIONS(3324),
    [sym_comment] = ACTIONS(49),
  },
  [916] = {
    [anon_sym_LPAREN] = ACTIONS(3326),
    [anon_sym_LBRACE] = ACTIONS(3326),
    [anon_sym_LT] = ACTIONS(512),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(516),
  },
  [917] = {
    [anon_sym_LPAREN] = ACTIONS(3328),
    [anon_sym_LBRACE] = ACTIONS(3328),
    [anon_sym_LT] = ACTIONS(3328),
    [sym_comment] = ACTIONS(49),
  },
  [918] = {
    [sym_field_initializer] = STATE(1535),
    [sym_template_type] = STATE(423),
    [sym_scoped_field_identifier] = STATE(424),
    [sym_scoped_type_identifier] = STATE(47),
    [sym_scoped_namespace_identifier] = STATE(423),
    [sym_identifier] = ACTIONS(688),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(690),
  },
  [919] = {
    [aux_sym_field_initializer_list_repeat1] = STATE(1536),
    [anon_sym_COMMA] = ACTIONS(1782),
    [anon_sym_LBRACE] = ACTIONS(3330),
    [sym_comment] = ACTIONS(49),
  },
  [920] = {
    [sym_destructor_name] = STATE(1538),
    [anon_sym_TILDE] = ACTIONS(45),
    [sym_identifier] = ACTIONS(3332),
    [sym_comment] = ACTIONS(49),
    [sym_operator_name] = ACTIONS(3334),
  },
  [921] = {
    [anon_sym_COMMA] = ACTIONS(3336),
    [anon_sym_LBRACE] = ACTIONS(3336),
    [sym_comment] = ACTIONS(49),
  },
  [922] = {
    [ts_builtin_sym_end] = ACTIONS(3338),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3340),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3340),
    [anon_sym_LPAREN] = ACTIONS(3338),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3340),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3340),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3340),
    [sym_preproc_directive] = ACTIONS(3340),
    [anon_sym_typedef] = ACTIONS(3340),
    [anon_sym_extern] = ACTIONS(3340),
    [anon_sym_RBRACE] = ACTIONS(3338),
    [anon_sym_STAR] = ACTIONS(3338),
    [anon_sym_static] = ACTIONS(3340),
    [anon_sym_register] = ACTIONS(3340),
    [anon_sym_inline] = ACTIONS(3340),
    [anon_sym_const] = ACTIONS(3340),
    [anon_sym_restrict] = ACTIONS(3340),
    [anon_sym_volatile] = ACTIONS(3340),
    [anon_sym__Atomic] = ACTIONS(3340),
    [anon_sym_mutable] = ACTIONS(3340),
    [anon_sym_explicit] = ACTIONS(3340),
    [anon_sym_constexpr] = ACTIONS(3340),
    [anon_sym_unsigned] = ACTIONS(3340),
    [anon_sym_long] = ACTIONS(3340),
    [anon_sym_short] = ACTIONS(3340),
    [sym_primitive_type] = ACTIONS(3340),
    [anon_sym_enum] = ACTIONS(3340),
    [anon_sym_struct] = ACTIONS(3340),
    [anon_sym_union] = ACTIONS(3340),
    [anon_sym_AMP] = ACTIONS(3340),
    [anon_sym_AMP_AMP] = ACTIONS(3338),
    [anon_sym_TILDE] = ACTIONS(3338),
    [sym_identifier] = ACTIONS(3340),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(3340),
    [sym_auto] = ACTIONS(3340),
    [anon_sym_typename] = ACTIONS(3340),
    [anon_sym_template] = ACTIONS(3340),
    [anon_sym_namespace] = ACTIONS(3340),
    [anon_sym_using] = ACTIONS(3340),
    [anon_sym_COLON_COLON] = ACTIONS(3338),
    [sym_operator_name] = ACTIONS(3338),
  },
  [923] = {
    [ts_builtin_sym_end] = ACTIONS(3342),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3344),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3344),
    [anon_sym_LPAREN] = ACTIONS(3342),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3344),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3344),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3344),
    [sym_preproc_directive] = ACTIONS(3344),
    [anon_sym_typedef] = ACTIONS(3344),
    [anon_sym_extern] = ACTIONS(3344),
    [anon_sym_RBRACE] = ACTIONS(3342),
    [anon_sym_STAR] = ACTIONS(3342),
    [anon_sym_static] = ACTIONS(3344),
    [anon_sym_register] = ACTIONS(3344),
    [anon_sym_inline] = ACTIONS(3344),
    [anon_sym_const] = ACTIONS(3344),
    [anon_sym_restrict] = ACTIONS(3344),
    [anon_sym_volatile] = ACTIONS(3344),
    [anon_sym__Atomic] = ACTIONS(3344),
    [anon_sym_mutable] = ACTIONS(3344),
    [anon_sym_explicit] = ACTIONS(3344),
    [anon_sym_constexpr] = ACTIONS(3344),
    [anon_sym_unsigned] = ACTIONS(3344),
    [anon_sym_long] = ACTIONS(3344),
    [anon_sym_short] = ACTIONS(3344),
    [sym_primitive_type] = ACTIONS(3344),
    [anon_sym_enum] = ACTIONS(3344),
    [anon_sym_struct] = ACTIONS(3344),
    [anon_sym_union] = ACTIONS(3344),
    [anon_sym_AMP] = ACTIONS(3344),
    [anon_sym_AMP_AMP] = ACTIONS(3342),
    [anon_sym_TILDE] = ACTIONS(3342),
    [sym_identifier] = ACTIONS(3344),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(3344),
    [sym_auto] = ACTIONS(3344),
    [anon_sym_typename] = ACTIONS(3344),
    [anon_sym_template] = ACTIONS(3344),
    [anon_sym_namespace] = ACTIONS(3344),
    [anon_sym_using] = ACTIONS(3344),
    [anon_sym_COLON_COLON] = ACTIONS(3342),
    [sym_operator_name] = ACTIONS(3342),
  },
  [924] = {
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3346),
    [sym_identifier] = ACTIONS(3346),
    [sym_comment] = ACTIONS(49),
  },
  [925] = {
    [anon_sym_LF] = ACTIONS(3348),
    [sym_preproc_arg] = ACTIONS(3348),
    [sym_comment] = ACTIONS(83),
  },
  [926] = {
    [aux_sym_preproc_params_repeat1] = STATE(1541),
    [anon_sym_COMMA] = ACTIONS(1817),
    [anon_sym_RPAREN] = ACTIONS(3350),
    [sym_comment] = ACTIONS(49),
  },
  [927] = {
    [ts_builtin_sym_end] = ACTIONS(3352),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3354),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3354),
    [anon_sym_LPAREN] = ACTIONS(3352),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3354),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3354),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3354),
    [sym_preproc_directive] = ACTIONS(3354),
    [anon_sym_typedef] = ACTIONS(3354),
    [anon_sym_extern] = ACTIONS(3354),
    [anon_sym_RBRACE] = ACTIONS(3352),
    [anon_sym_STAR] = ACTIONS(3352),
    [anon_sym_static] = ACTIONS(3354),
    [anon_sym_register] = ACTIONS(3354),
    [anon_sym_inline] = ACTIONS(3354),
    [anon_sym_const] = ACTIONS(3354),
    [anon_sym_restrict] = ACTIONS(3354),
    [anon_sym_volatile] = ACTIONS(3354),
    [anon_sym__Atomic] = ACTIONS(3354),
    [anon_sym_mutable] = ACTIONS(3354),
    [anon_sym_explicit] = ACTIONS(3354),
    [anon_sym_constexpr] = ACTIONS(3354),
    [anon_sym_unsigned] = ACTIONS(3354),
    [anon_sym_long] = ACTIONS(3354),
    [anon_sym_short] = ACTIONS(3354),
    [sym_primitive_type] = ACTIONS(3354),
    [anon_sym_enum] = ACTIONS(3354),
    [anon_sym_struct] = ACTIONS(3354),
    [anon_sym_union] = ACTIONS(3354),
    [anon_sym_AMP] = ACTIONS(3354),
    [anon_sym_AMP_AMP] = ACTIONS(3352),
    [anon_sym_TILDE] = ACTIONS(3352),
    [sym_identifier] = ACTIONS(3354),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(3354),
    [sym_auto] = ACTIONS(3354),
    [anon_sym_typename] = ACTIONS(3354),
    [anon_sym_template] = ACTIONS(3354),
    [anon_sym_namespace] = ACTIONS(3354),
    [anon_sym_using] = ACTIONS(3354),
    [anon_sym_COLON_COLON] = ACTIONS(3352),
    [sym_operator_name] = ACTIONS(3352),
  },
  [928] = {
    [sym_enumerator_list] = STATE(1358),
    [anon_sym_LBRACE] = ACTIONS(2825),
    [sym_identifier] = ACTIONS(3356),
    [sym_comment] = ACTIONS(49),
  },
  [929] = {
    [sym_field_declaration_list] = STATE(1361),
    [sym__class_name] = STATE(1543),
    [sym_base_class_clause] = STATE(1363),
    [sym_template_type] = STATE(1364),
    [sym_scoped_type_identifier] = STATE(1365),
    [sym_scoped_namespace_identifier] = STATE(827),
    [anon_sym_LBRACE] = ACTIONS(2829),
    [anon_sym_COLON] = ACTIONS(131),
    [sym_identifier] = ACTIONS(2831),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(1594),
  },
  [930] = {
    [sym_field_declaration_list] = STATE(1366),
    [sym__class_name] = STATE(1544),
    [sym_base_class_clause] = STATE(1368),
    [sym_template_type] = STATE(1364),
    [sym_scoped_type_identifier] = STATE(1365),
    [sym_scoped_namespace_identifier] = STATE(827),
    [anon_sym_LBRACE] = ACTIONS(2829),
    [anon_sym_COLON] = ACTIONS(131),
    [sym_identifier] = ACTIONS(2831),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(1594),
  },
  [931] = {
    [sym_field_declaration_list] = STATE(1372),
    [sym__class_name] = STATE(1545),
    [sym_base_class_clause] = STATE(1374),
    [sym_template_type] = STATE(1364),
    [sym_scoped_type_identifier] = STATE(1365),
    [sym_scoped_namespace_identifier] = STATE(827),
    [anon_sym_LBRACE] = ACTIONS(2829),
    [anon_sym_COLON] = ACTIONS(131),
    [sym_identifier] = ACTIONS(2831),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(1594),
  },
  [932] = {
    [sym__type_specifier] = STATE(1375),
    [sym_sized_type_specifier] = STATE(1375),
    [sym_enum_specifier] = STATE(1375),
    [sym_struct_specifier] = STATE(1375),
    [sym_union_specifier] = STATE(1375),
    [sym_macro_type_specifier] = STATE(1375),
    [sym_class_specifier] = STATE(1375),
    [sym_dependent_type] = STATE(1375),
    [sym_template_type] = STATE(825),
    [sym_scoped_type_identifier] = STATE(826),
    [sym_scoped_namespace_identifier] = STATE(827),
    [aux_sym_sized_type_specifier_repeat1] = STATE(934),
    [anon_sym_unsigned] = ACTIONS(1829),
    [anon_sym_long] = ACTIONS(1829),
    [anon_sym_short] = ACTIONS(1829),
    [sym_primitive_type] = ACTIONS(2837),
    [anon_sym_enum] = ACTIONS(1833),
    [anon_sym_struct] = ACTIONS(1835),
    [anon_sym_union] = ACTIONS(1837),
    [sym_identifier] = ACTIONS(1588),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(1839),
    [sym_auto] = ACTIONS(2837),
    [anon_sym_typename] = ACTIONS(1841),
    [anon_sym_COLON_COLON] = ACTIONS(1594),
  },
  [933] = {
    [sym__abstract_declarator] = STATE(1548),
    [sym_abstract_pointer_declarator] = STATE(1548),
    [sym_abstract_function_declarator] = STATE(1548),
    [sym_abstract_array_declarator] = STATE(1548),
    [sym_parameter_list] = STATE(1549),
    [sym_abstract_reference_declarator] = STATE(1548),
    [anon_sym_LPAREN] = ACTIONS(1115),
    [anon_sym_RPAREN] = ACTIONS(2841),
    [anon_sym_STAR] = ACTIONS(3358),
    [anon_sym_LBRACK] = ACTIONS(1121),
    [anon_sym_const] = ACTIONS(2845),
    [anon_sym_restrict] = ACTIONS(2841),
    [anon_sym_volatile] = ACTIONS(2841),
    [anon_sym__Atomic] = ACTIONS(2841),
    [anon_sym_mutable] = ACTIONS(2841),
    [anon_sym_explicit] = ACTIONS(2841),
    [anon_sym_constexpr] = ACTIONS(2841),
    [anon_sym_AMP] = ACTIONS(3360),
    [anon_sym_AMP_AMP] = ACTIONS(3362),
    [anon_sym_DASH_GT] = ACTIONS(2841),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(2841),
  },
  [934] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(1550),
    [anon_sym_LPAREN] = ACTIONS(238),
    [anon_sym_RPAREN] = ACTIONS(238),
    [anon_sym_STAR] = ACTIONS(238),
    [anon_sym_LBRACK] = ACTIONS(238),
    [anon_sym_const] = ACTIONS(240),
    [anon_sym_restrict] = ACTIONS(240),
    [anon_sym_volatile] = ACTIONS(240),
    [anon_sym__Atomic] = ACTIONS(240),
    [anon_sym_mutable] = ACTIONS(240),
    [anon_sym_explicit] = ACTIONS(240),
    [anon_sym_constexpr] = ACTIONS(240),
    [anon_sym_unsigned] = ACTIONS(3364),
    [anon_sym_long] = ACTIONS(3364),
    [anon_sym_short] = ACTIONS(3364),
    [sym_primitive_type] = ACTIONS(2855),
    [anon_sym_AMP] = ACTIONS(240),
    [anon_sym_AMP_AMP] = ACTIONS(238),
    [anon_sym_DASH_GT] = ACTIONS(238),
    [sym_identifier] = ACTIONS(2857),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(240),
  },
  [935] = {
    [sym_type_qualifier] = STATE(935),
    [sym_trailing_return_type] = STATE(935),
    [aux_sym_function_declarator_repeat1] = STATE(935),
    [anon_sym_LPAREN] = ACTIONS(2859),
    [anon_sym_RPAREN] = ACTIONS(2859),
    [anon_sym_LBRACK] = ACTIONS(2859),
    [anon_sym_const] = ACTIONS(2861),
    [anon_sym_restrict] = ACTIONS(2864),
    [anon_sym_volatile] = ACTIONS(2864),
    [anon_sym__Atomic] = ACTIONS(2864),
    [anon_sym_mutable] = ACTIONS(2864),
    [anon_sym_explicit] = ACTIONS(2864),
    [anon_sym_constexpr] = ACTIONS(2864),
    [anon_sym_DASH_GT] = ACTIONS(3366),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(3369),
  },
  [936] = {
    [sym_preproc_arg] = ACTIONS(3372),
    [sym_comment] = ACTIONS(83),
  },
  [937] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(827),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(827),
    [anon_sym_LPAREN] = ACTIONS(825),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(827),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(827),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(827),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(827),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(827),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(827),
    [sym_preproc_directive] = ACTIONS(827),
    [anon_sym_typedef] = ACTIONS(827),
    [anon_sym_extern] = ACTIONS(827),
    [anon_sym_STAR] = ACTIONS(825),
    [anon_sym_static] = ACTIONS(827),
    [anon_sym_register] = ACTIONS(827),
    [anon_sym_inline] = ACTIONS(827),
    [anon_sym_const] = ACTIONS(827),
    [anon_sym_restrict] = ACTIONS(827),
    [anon_sym_volatile] = ACTIONS(827),
    [anon_sym__Atomic] = ACTIONS(827),
    [anon_sym_mutable] = ACTIONS(827),
    [anon_sym_explicit] = ACTIONS(827),
    [anon_sym_constexpr] = ACTIONS(827),
    [anon_sym_unsigned] = ACTIONS(827),
    [anon_sym_long] = ACTIONS(827),
    [anon_sym_short] = ACTIONS(827),
    [sym_primitive_type] = ACTIONS(827),
    [anon_sym_enum] = ACTIONS(827),
    [anon_sym_struct] = ACTIONS(827),
    [anon_sym_union] = ACTIONS(827),
    [anon_sym_AMP] = ACTIONS(827),
    [anon_sym_AMP_AMP] = ACTIONS(825),
    [anon_sym_TILDE] = ACTIONS(825),
    [sym_identifier] = ACTIONS(827),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(827),
    [sym_auto] = ACTIONS(827),
    [anon_sym_typename] = ACTIONS(827),
    [anon_sym_template] = ACTIONS(827),
    [anon_sym_namespace] = ACTIONS(827),
    [anon_sym_using] = ACTIONS(827),
    [anon_sym_COLON_COLON] = ACTIONS(825),
    [sym_operator_name] = ACTIONS(825),
  },
  [938] = {
    [anon_sym_LF] = ACTIONS(3374),
    [sym_preproc_arg] = ACTIONS(3376),
    [sym_comment] = ACTIONS(83),
  },
  [939] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(859),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(859),
    [anon_sym_LPAREN] = ACTIONS(857),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(859),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(859),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(859),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(859),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(859),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(859),
    [sym_preproc_directive] = ACTIONS(859),
    [anon_sym_typedef] = ACTIONS(859),
    [anon_sym_extern] = ACTIONS(859),
    [anon_sym_STAR] = ACTIONS(857),
    [anon_sym_static] = ACTIONS(859),
    [anon_sym_register] = ACTIONS(859),
    [anon_sym_inline] = ACTIONS(859),
    [anon_sym_const] = ACTIONS(859),
    [anon_sym_restrict] = ACTIONS(859),
    [anon_sym_volatile] = ACTIONS(859),
    [anon_sym__Atomic] = ACTIONS(859),
    [anon_sym_mutable] = ACTIONS(859),
    [anon_sym_explicit] = ACTIONS(859),
    [anon_sym_constexpr] = ACTIONS(859),
    [anon_sym_unsigned] = ACTIONS(859),
    [anon_sym_long] = ACTIONS(859),
    [anon_sym_short] = ACTIONS(859),
    [sym_primitive_type] = ACTIONS(859),
    [anon_sym_enum] = ACTIONS(859),
    [anon_sym_struct] = ACTIONS(859),
    [anon_sym_union] = ACTIONS(859),
    [anon_sym_AMP] = ACTIONS(859),
    [anon_sym_AMP_AMP] = ACTIONS(857),
    [anon_sym_TILDE] = ACTIONS(857),
    [sym_identifier] = ACTIONS(859),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(859),
    [sym_auto] = ACTIONS(859),
    [anon_sym_typename] = ACTIONS(859),
    [anon_sym_template] = ACTIONS(859),
    [anon_sym_namespace] = ACTIONS(859),
    [anon_sym_using] = ACTIONS(859),
    [anon_sym_COLON_COLON] = ACTIONS(857),
    [sym_operator_name] = ACTIONS(857),
  },
  [940] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3378),
    [sym_comment] = ACTIONS(49),
  },
  [941] = {
    [sym_preproc_include] = STATE(486),
    [sym_preproc_def] = STATE(486),
    [sym_preproc_function_def] = STATE(486),
    [sym_preproc_call] = STATE(486),
    [sym_preproc_if] = STATE(486),
    [sym_preproc_ifdef] = STATE(486),
    [sym_preproc_else] = STATE(1555),
    [sym_preproc_elif] = STATE(1555),
    [sym_function_definition] = STATE(486),
    [sym_declaration] = STATE(486),
    [sym_type_definition] = STATE(486),
    [sym__declaration_specifiers] = STATE(176),
    [sym_linkage_specification] = STATE(486),
    [sym__declarator] = STATE(28),
    [sym_pointer_declarator] = STATE(28),
    [sym_function_declarator] = STATE(177),
    [sym_array_declarator] = STATE(28),
    [sym_storage_class_specifier] = STATE(180),
    [sym_type_qualifier] = STATE(180),
    [sym__type_specifier] = STATE(30),
    [sym_sized_type_specifier] = STATE(30),
    [sym_enum_specifier] = STATE(30),
    [sym_struct_specifier] = STATE(30),
    [sym_union_specifier] = STATE(30),
    [sym__empty_declaration] = STATE(486),
    [sym_macro_type_specifier] = STATE(30),
    [sym_class_specifier] = STATE(30),
    [sym_dependent_type] = STATE(30),
    [sym_structured_binding_declaration] = STATE(486),
    [sym_template_declaration] = STATE(486),
    [sym_template_instantiation] = STATE(486),
    [sym_constructor_or_destructor_definition] = STATE(178),
    [sym_reference_declarator] = STATE(28),
    [sym_template_type] = STATE(32),
    [sym_template_function] = STATE(28),
    [sym_namespace_definition] = STATE(486),
    [sym_using_declaration] = STATE(486),
    [sym_alias_declaration] = STATE(486),
    [sym_destructor_name] = STATE(28),
    [sym_scoped_identifier] = STATE(33),
    [sym_scoped_type_identifier] = STATE(34),
    [sym_scoped_namespace_identifier] = STATE(35),
    [aux_sym_translation_unit_repeat1] = STATE(486),
    [aux_sym__declaration_specifiers_repeat1] = STATE(180),
    [aux_sym_sized_type_specifier_repeat1] = STATE(38),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(273),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(275),
    [anon_sym_LPAREN] = ACTIONS(11),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(277),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3380),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(281),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(283),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(285),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(287),
    [sym_preproc_directive] = ACTIONS(289),
    [anon_sym_typedef] = ACTIONS(291),
    [anon_sym_extern] = ACTIONS(293),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_static] = ACTIONS(27),
    [anon_sym_register] = ACTIONS(27),
    [anon_sym_inline] = ACTIONS(27),
    [anon_sym_const] = ACTIONS(29),
    [anon_sym_restrict] = ACTIONS(29),
    [anon_sym_volatile] = ACTIONS(29),
    [anon_sym__Atomic] = ACTIONS(29),
    [anon_sym_mutable] = ACTIONS(29),
    [anon_sym_explicit] = ACTIONS(29),
    [anon_sym_constexpr] = ACTIONS(29),
    [anon_sym_unsigned] = ACTIONS(31),
    [anon_sym_long] = ACTIONS(31),
    [anon_sym_short] = ACTIONS(31),
    [sym_primitive_type] = ACTIONS(33),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_union] = ACTIONS(39),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(45),
    [sym_identifier] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(51),
    [sym_auto] = ACTIONS(33),
    [anon_sym_typename] = ACTIONS(53),
    [anon_sym_template] = ACTIONS(295),
    [anon_sym_namespace] = ACTIONS(297),
    [anon_sym_using] = ACTIONS(299),
    [anon_sym_COLON_COLON] = ACTIONS(61),
    [sym_operator_name] = ACTIONS(63),
  },
  [942] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(921),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(921),
    [anon_sym_LPAREN] = ACTIONS(919),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(921),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(921),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(921),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(921),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(921),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(921),
    [sym_preproc_directive] = ACTIONS(921),
    [anon_sym_typedef] = ACTIONS(921),
    [anon_sym_extern] = ACTIONS(921),
    [anon_sym_STAR] = ACTIONS(919),
    [anon_sym_static] = ACTIONS(921),
    [anon_sym_register] = ACTIONS(921),
    [anon_sym_inline] = ACTIONS(921),
    [anon_sym_const] = ACTIONS(921),
    [anon_sym_restrict] = ACTIONS(921),
    [anon_sym_volatile] = ACTIONS(921),
    [anon_sym__Atomic] = ACTIONS(921),
    [anon_sym_mutable] = ACTIONS(921),
    [anon_sym_explicit] = ACTIONS(921),
    [anon_sym_constexpr] = ACTIONS(921),
    [anon_sym_unsigned] = ACTIONS(921),
    [anon_sym_long] = ACTIONS(921),
    [anon_sym_short] = ACTIONS(921),
    [sym_primitive_type] = ACTIONS(921),
    [anon_sym_enum] = ACTIONS(921),
    [anon_sym_struct] = ACTIONS(921),
    [anon_sym_union] = ACTIONS(921),
    [anon_sym_AMP] = ACTIONS(921),
    [anon_sym_AMP_AMP] = ACTIONS(919),
    [anon_sym_TILDE] = ACTIONS(919),
    [sym_identifier] = ACTIONS(921),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(921),
    [sym_auto] = ACTIONS(921),
    [anon_sym_typename] = ACTIONS(921),
    [anon_sym_template] = ACTIONS(921),
    [anon_sym_namespace] = ACTIONS(921),
    [anon_sym_using] = ACTIONS(921),
    [anon_sym_COLON_COLON] = ACTIONS(919),
    [sym_operator_name] = ACTIONS(919),
  },
  [943] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3382),
    [sym_comment] = ACTIONS(49),
  },
  [944] = {
    [sym_preproc_include] = STATE(486),
    [sym_preproc_def] = STATE(486),
    [sym_preproc_function_def] = STATE(486),
    [sym_preproc_call] = STATE(486),
    [sym_preproc_if] = STATE(486),
    [sym_preproc_ifdef] = STATE(486),
    [sym_preproc_else] = STATE(1557),
    [sym_preproc_elif] = STATE(1557),
    [sym_function_definition] = STATE(486),
    [sym_declaration] = STATE(486),
    [sym_type_definition] = STATE(486),
    [sym__declaration_specifiers] = STATE(176),
    [sym_linkage_specification] = STATE(486),
    [sym__declarator] = STATE(28),
    [sym_pointer_declarator] = STATE(28),
    [sym_function_declarator] = STATE(177),
    [sym_array_declarator] = STATE(28),
    [sym_storage_class_specifier] = STATE(180),
    [sym_type_qualifier] = STATE(180),
    [sym__type_specifier] = STATE(30),
    [sym_sized_type_specifier] = STATE(30),
    [sym_enum_specifier] = STATE(30),
    [sym_struct_specifier] = STATE(30),
    [sym_union_specifier] = STATE(30),
    [sym__empty_declaration] = STATE(486),
    [sym_macro_type_specifier] = STATE(30),
    [sym_class_specifier] = STATE(30),
    [sym_dependent_type] = STATE(30),
    [sym_structured_binding_declaration] = STATE(486),
    [sym_template_declaration] = STATE(486),
    [sym_template_instantiation] = STATE(486),
    [sym_constructor_or_destructor_definition] = STATE(178),
    [sym_reference_declarator] = STATE(28),
    [sym_template_type] = STATE(32),
    [sym_template_function] = STATE(28),
    [sym_namespace_definition] = STATE(486),
    [sym_using_declaration] = STATE(486),
    [sym_alias_declaration] = STATE(486),
    [sym_destructor_name] = STATE(28),
    [sym_scoped_identifier] = STATE(33),
    [sym_scoped_type_identifier] = STATE(34),
    [sym_scoped_namespace_identifier] = STATE(35),
    [aux_sym_translation_unit_repeat1] = STATE(486),
    [aux_sym__declaration_specifiers_repeat1] = STATE(180),
    [aux_sym_sized_type_specifier_repeat1] = STATE(38),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(273),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(275),
    [anon_sym_LPAREN] = ACTIONS(11),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(277),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3384),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(281),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(283),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(285),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(287),
    [sym_preproc_directive] = ACTIONS(289),
    [anon_sym_typedef] = ACTIONS(291),
    [anon_sym_extern] = ACTIONS(293),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_static] = ACTIONS(27),
    [anon_sym_register] = ACTIONS(27),
    [anon_sym_inline] = ACTIONS(27),
    [anon_sym_const] = ACTIONS(29),
    [anon_sym_restrict] = ACTIONS(29),
    [anon_sym_volatile] = ACTIONS(29),
    [anon_sym__Atomic] = ACTIONS(29),
    [anon_sym_mutable] = ACTIONS(29),
    [anon_sym_explicit] = ACTIONS(29),
    [anon_sym_constexpr] = ACTIONS(29),
    [anon_sym_unsigned] = ACTIONS(31),
    [anon_sym_long] = ACTIONS(31),
    [anon_sym_short] = ACTIONS(31),
    [sym_primitive_type] = ACTIONS(33),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_union] = ACTIONS(39),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(45),
    [sym_identifier] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(51),
    [sym_auto] = ACTIONS(33),
    [anon_sym_typename] = ACTIONS(53),
    [anon_sym_template] = ACTIONS(295),
    [anon_sym_namespace] = ACTIONS(297),
    [anon_sym_using] = ACTIONS(299),
    [anon_sym_COLON_COLON] = ACTIONS(61),
    [sym_operator_name] = ACTIONS(63),
  },
  [945] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(929),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(929),
    [anon_sym_LPAREN] = ACTIONS(927),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(929),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(929),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(929),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(929),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(929),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(929),
    [sym_preproc_directive] = ACTIONS(929),
    [anon_sym_typedef] = ACTIONS(929),
    [anon_sym_extern] = ACTIONS(929),
    [anon_sym_STAR] = ACTIONS(927),
    [anon_sym_static] = ACTIONS(929),
    [anon_sym_register] = ACTIONS(929),
    [anon_sym_inline] = ACTIONS(929),
    [anon_sym_const] = ACTIONS(929),
    [anon_sym_restrict] = ACTIONS(929),
    [anon_sym_volatile] = ACTIONS(929),
    [anon_sym__Atomic] = ACTIONS(929),
    [anon_sym_mutable] = ACTIONS(929),
    [anon_sym_explicit] = ACTIONS(929),
    [anon_sym_constexpr] = ACTIONS(929),
    [anon_sym_unsigned] = ACTIONS(929),
    [anon_sym_long] = ACTIONS(929),
    [anon_sym_short] = ACTIONS(929),
    [sym_primitive_type] = ACTIONS(929),
    [anon_sym_enum] = ACTIONS(929),
    [anon_sym_struct] = ACTIONS(929),
    [anon_sym_union] = ACTIONS(929),
    [anon_sym_AMP] = ACTIONS(929),
    [anon_sym_AMP_AMP] = ACTIONS(927),
    [anon_sym_TILDE] = ACTIONS(927),
    [sym_identifier] = ACTIONS(929),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(929),
    [sym_auto] = ACTIONS(929),
    [anon_sym_typename] = ACTIONS(929),
    [anon_sym_template] = ACTIONS(929),
    [anon_sym_namespace] = ACTIONS(929),
    [anon_sym_using] = ACTIONS(929),
    [anon_sym_COLON_COLON] = ACTIONS(927),
    [sym_operator_name] = ACTIONS(927),
  },
  [946] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3386),
    [sym_comment] = ACTIONS(49),
  },
  [947] = {
    [sym_preproc_include] = STATE(486),
    [sym_preproc_def] = STATE(486),
    [sym_preproc_function_def] = STATE(486),
    [sym_preproc_call] = STATE(486),
    [sym_preproc_if] = STATE(486),
    [sym_preproc_ifdef] = STATE(486),
    [sym_preproc_else] = STATE(1559),
    [sym_preproc_elif] = STATE(1559),
    [sym_function_definition] = STATE(486),
    [sym_declaration] = STATE(486),
    [sym_type_definition] = STATE(486),
    [sym__declaration_specifiers] = STATE(176),
    [sym_linkage_specification] = STATE(486),
    [sym__declarator] = STATE(28),
    [sym_pointer_declarator] = STATE(28),
    [sym_function_declarator] = STATE(177),
    [sym_array_declarator] = STATE(28),
    [sym_storage_class_specifier] = STATE(180),
    [sym_type_qualifier] = STATE(180),
    [sym__type_specifier] = STATE(30),
    [sym_sized_type_specifier] = STATE(30),
    [sym_enum_specifier] = STATE(30),
    [sym_struct_specifier] = STATE(30),
    [sym_union_specifier] = STATE(30),
    [sym__empty_declaration] = STATE(486),
    [sym_macro_type_specifier] = STATE(30),
    [sym_class_specifier] = STATE(30),
    [sym_dependent_type] = STATE(30),
    [sym_structured_binding_declaration] = STATE(486),
    [sym_template_declaration] = STATE(486),
    [sym_template_instantiation] = STATE(486),
    [sym_constructor_or_destructor_definition] = STATE(178),
    [sym_reference_declarator] = STATE(28),
    [sym_template_type] = STATE(32),
    [sym_template_function] = STATE(28),
    [sym_namespace_definition] = STATE(486),
    [sym_using_declaration] = STATE(486),
    [sym_alias_declaration] = STATE(486),
    [sym_destructor_name] = STATE(28),
    [sym_scoped_identifier] = STATE(33),
    [sym_scoped_type_identifier] = STATE(34),
    [sym_scoped_namespace_identifier] = STATE(35),
    [aux_sym_translation_unit_repeat1] = STATE(486),
    [aux_sym__declaration_specifiers_repeat1] = STATE(180),
    [aux_sym_sized_type_specifier_repeat1] = STATE(38),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(273),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(275),
    [anon_sym_LPAREN] = ACTIONS(11),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(277),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3388),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(281),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(283),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(285),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(287),
    [sym_preproc_directive] = ACTIONS(289),
    [anon_sym_typedef] = ACTIONS(291),
    [anon_sym_extern] = ACTIONS(293),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_static] = ACTIONS(27),
    [anon_sym_register] = ACTIONS(27),
    [anon_sym_inline] = ACTIONS(27),
    [anon_sym_const] = ACTIONS(29),
    [anon_sym_restrict] = ACTIONS(29),
    [anon_sym_volatile] = ACTIONS(29),
    [anon_sym__Atomic] = ACTIONS(29),
    [anon_sym_mutable] = ACTIONS(29),
    [anon_sym_explicit] = ACTIONS(29),
    [anon_sym_constexpr] = ACTIONS(29),
    [anon_sym_unsigned] = ACTIONS(31),
    [anon_sym_long] = ACTIONS(31),
    [anon_sym_short] = ACTIONS(31),
    [sym_primitive_type] = ACTIONS(33),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_union] = ACTIONS(39),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(45),
    [sym_identifier] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(51),
    [sym_auto] = ACTIONS(33),
    [anon_sym_typename] = ACTIONS(53),
    [anon_sym_template] = ACTIONS(295),
    [anon_sym_namespace] = ACTIONS(297),
    [anon_sym_using] = ACTIONS(299),
    [anon_sym_COLON_COLON] = ACTIONS(61),
    [sym_operator_name] = ACTIONS(63),
  },
  [948] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(251),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(251),
    [anon_sym_LPAREN] = ACTIONS(249),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(251),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(251),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(251),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(251),
    [sym_preproc_directive] = ACTIONS(251),
    [anon_sym_typedef] = ACTIONS(251),
    [anon_sym_extern] = ACTIONS(251),
    [anon_sym_STAR] = ACTIONS(249),
    [anon_sym_static] = ACTIONS(251),
    [anon_sym_register] = ACTIONS(251),
    [anon_sym_inline] = ACTIONS(251),
    [anon_sym_const] = ACTIONS(251),
    [anon_sym_restrict] = ACTIONS(251),
    [anon_sym_volatile] = ACTIONS(251),
    [anon_sym__Atomic] = ACTIONS(251),
    [anon_sym_mutable] = ACTIONS(251),
    [anon_sym_explicit] = ACTIONS(251),
    [anon_sym_constexpr] = ACTIONS(251),
    [anon_sym_unsigned] = ACTIONS(251),
    [anon_sym_long] = ACTIONS(251),
    [anon_sym_short] = ACTIONS(251),
    [sym_primitive_type] = ACTIONS(251),
    [anon_sym_enum] = ACTIONS(251),
    [anon_sym_struct] = ACTIONS(251),
    [anon_sym_union] = ACTIONS(251),
    [anon_sym_AMP] = ACTIONS(251),
    [anon_sym_AMP_AMP] = ACTIONS(249),
    [anon_sym_TILDE] = ACTIONS(249),
    [sym_identifier] = ACTIONS(251),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(251),
    [sym_auto] = ACTIONS(251),
    [anon_sym_typename] = ACTIONS(251),
    [anon_sym_template] = ACTIONS(251),
    [anon_sym_namespace] = ACTIONS(251),
    [anon_sym_using] = ACTIONS(251),
    [anon_sym_COLON_COLON] = ACTIONS(249),
    [sym_operator_name] = ACTIONS(249),
  },
  [949] = {
    [sym_preproc_params] = STATE(1562),
    [aux_sym_SLASH_LBRACK_BSLASHt_RBRACK_PLUS_SLASH] = ACTIONS(3390),
    [anon_sym_LF] = ACTIONS(3392),
    [anon_sym_LPAREN] = ACTIONS(257),
    [sym_comment] = ACTIONS(83),
  },
  [950] = {
    [sym_preproc_include] = STATE(1565),
    [sym_preproc_def] = STATE(1565),
    [sym_preproc_function_def] = STATE(1565),
    [sym_preproc_call] = STATE(1565),
    [sym_preproc_if] = STATE(1565),
    [sym_preproc_ifdef] = STATE(1565),
    [sym_preproc_else] = STATE(1564),
    [sym_preproc_elif] = STATE(1564),
    [sym_function_definition] = STATE(1565),
    [sym_declaration] = STATE(1565),
    [sym_type_definition] = STATE(1565),
    [sym__declaration_specifiers] = STATE(176),
    [sym_linkage_specification] = STATE(1565),
    [sym__declarator] = STATE(28),
    [sym_pointer_declarator] = STATE(28),
    [sym_function_declarator] = STATE(177),
    [sym_array_declarator] = STATE(28),
    [sym_storage_class_specifier] = STATE(180),
    [sym_type_qualifier] = STATE(180),
    [sym__type_specifier] = STATE(30),
    [sym_sized_type_specifier] = STATE(30),
    [sym_enum_specifier] = STATE(30),
    [sym_struct_specifier] = STATE(30),
    [sym_union_specifier] = STATE(30),
    [sym__empty_declaration] = STATE(1565),
    [sym_macro_type_specifier] = STATE(30),
    [sym_class_specifier] = STATE(30),
    [sym_dependent_type] = STATE(30),
    [sym_structured_binding_declaration] = STATE(1565),
    [sym_template_declaration] = STATE(1565),
    [sym_template_instantiation] = STATE(1565),
    [sym_constructor_or_destructor_definition] = STATE(178),
    [sym_reference_declarator] = STATE(28),
    [sym_template_type] = STATE(32),
    [sym_template_function] = STATE(28),
    [sym_namespace_definition] = STATE(1565),
    [sym_using_declaration] = STATE(1565),
    [sym_alias_declaration] = STATE(1565),
    [sym_destructor_name] = STATE(28),
    [sym_scoped_identifier] = STATE(33),
    [sym_scoped_type_identifier] = STATE(34),
    [sym_scoped_namespace_identifier] = STATE(35),
    [aux_sym_translation_unit_repeat1] = STATE(1565),
    [aux_sym__declaration_specifiers_repeat1] = STATE(180),
    [aux_sym_sized_type_specifier_repeat1] = STATE(38),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(273),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(275),
    [anon_sym_LPAREN] = ACTIONS(11),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(277),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3394),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(281),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(283),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(285),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(287),
    [sym_preproc_directive] = ACTIONS(289),
    [anon_sym_typedef] = ACTIONS(291),
    [anon_sym_extern] = ACTIONS(293),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_static] = ACTIONS(27),
    [anon_sym_register] = ACTIONS(27),
    [anon_sym_inline] = ACTIONS(27),
    [anon_sym_const] = ACTIONS(29),
    [anon_sym_restrict] = ACTIONS(29),
    [anon_sym_volatile] = ACTIONS(29),
    [anon_sym__Atomic] = ACTIONS(29),
    [anon_sym_mutable] = ACTIONS(29),
    [anon_sym_explicit] = ACTIONS(29),
    [anon_sym_constexpr] = ACTIONS(29),
    [anon_sym_unsigned] = ACTIONS(31),
    [anon_sym_long] = ACTIONS(31),
    [anon_sym_short] = ACTIONS(31),
    [sym_primitive_type] = ACTIONS(33),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_union] = ACTIONS(39),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(45),
    [sym_identifier] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(51),
    [sym_auto] = ACTIONS(33),
    [anon_sym_typename] = ACTIONS(53),
    [anon_sym_template] = ACTIONS(295),
    [anon_sym_namespace] = ACTIONS(297),
    [anon_sym_using] = ACTIONS(299),
    [anon_sym_COLON_COLON] = ACTIONS(61),
    [sym_operator_name] = ACTIONS(63),
  },
  [951] = {
    [sym_preproc_include] = STATE(1568),
    [sym_preproc_def] = STATE(1568),
    [sym_preproc_function_def] = STATE(1568),
    [sym_preproc_call] = STATE(1568),
    [sym_preproc_if] = STATE(1568),
    [sym_preproc_ifdef] = STATE(1568),
    [sym_preproc_else] = STATE(1567),
    [sym_preproc_elif] = STATE(1567),
    [sym_function_definition] = STATE(1568),
    [sym_declaration] = STATE(1568),
    [sym_type_definition] = STATE(1568),
    [sym__declaration_specifiers] = STATE(176),
    [sym_linkage_specification] = STATE(1568),
    [sym__declarator] = STATE(28),
    [sym_pointer_declarator] = STATE(28),
    [sym_function_declarator] = STATE(177),
    [sym_array_declarator] = STATE(28),
    [sym_storage_class_specifier] = STATE(180),
    [sym_type_qualifier] = STATE(180),
    [sym__type_specifier] = STATE(30),
    [sym_sized_type_specifier] = STATE(30),
    [sym_enum_specifier] = STATE(30),
    [sym_struct_specifier] = STATE(30),
    [sym_union_specifier] = STATE(30),
    [sym__empty_declaration] = STATE(1568),
    [sym_macro_type_specifier] = STATE(30),
    [sym_class_specifier] = STATE(30),
    [sym_dependent_type] = STATE(30),
    [sym_structured_binding_declaration] = STATE(1568),
    [sym_template_declaration] = STATE(1568),
    [sym_template_instantiation] = STATE(1568),
    [sym_constructor_or_destructor_definition] = STATE(178),
    [sym_reference_declarator] = STATE(28),
    [sym_template_type] = STATE(32),
    [sym_template_function] = STATE(28),
    [sym_namespace_definition] = STATE(1568),
    [sym_using_declaration] = STATE(1568),
    [sym_alias_declaration] = STATE(1568),
    [sym_destructor_name] = STATE(28),
    [sym_scoped_identifier] = STATE(33),
    [sym_scoped_type_identifier] = STATE(34),
    [sym_scoped_namespace_identifier] = STATE(35),
    [aux_sym_translation_unit_repeat1] = STATE(1568),
    [aux_sym__declaration_specifiers_repeat1] = STATE(180),
    [aux_sym_sized_type_specifier_repeat1] = STATE(38),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(273),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(275),
    [anon_sym_LPAREN] = ACTIONS(11),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(277),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3396),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(281),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(283),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(285),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(287),
    [sym_preproc_directive] = ACTIONS(289),
    [anon_sym_typedef] = ACTIONS(291),
    [anon_sym_extern] = ACTIONS(293),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_static] = ACTIONS(27),
    [anon_sym_register] = ACTIONS(27),
    [anon_sym_inline] = ACTIONS(27),
    [anon_sym_const] = ACTIONS(29),
    [anon_sym_restrict] = ACTIONS(29),
    [anon_sym_volatile] = ACTIONS(29),
    [anon_sym__Atomic] = ACTIONS(29),
    [anon_sym_mutable] = ACTIONS(29),
    [anon_sym_explicit] = ACTIONS(29),
    [anon_sym_constexpr] = ACTIONS(29),
    [anon_sym_unsigned] = ACTIONS(31),
    [anon_sym_long] = ACTIONS(31),
    [anon_sym_short] = ACTIONS(31),
    [sym_primitive_type] = ACTIONS(33),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_union] = ACTIONS(39),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(45),
    [sym_identifier] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(51),
    [sym_auto] = ACTIONS(33),
    [anon_sym_typename] = ACTIONS(53),
    [anon_sym_template] = ACTIONS(295),
    [anon_sym_namespace] = ACTIONS(297),
    [anon_sym_using] = ACTIONS(299),
    [anon_sym_COLON_COLON] = ACTIONS(61),
    [sym_operator_name] = ACTIONS(63),
  },
  [952] = {
    [sym_preproc_include] = STATE(1571),
    [sym_preproc_def] = STATE(1571),
    [sym_preproc_function_def] = STATE(1571),
    [sym_preproc_call] = STATE(1571),
    [sym_preproc_if] = STATE(1571),
    [sym_preproc_ifdef] = STATE(1571),
    [sym_preproc_else] = STATE(1570),
    [sym_preproc_elif] = STATE(1570),
    [sym_function_definition] = STATE(1571),
    [sym_declaration] = STATE(1571),
    [sym_type_definition] = STATE(1571),
    [sym__declaration_specifiers] = STATE(176),
    [sym_linkage_specification] = STATE(1571),
    [sym__declarator] = STATE(28),
    [sym_pointer_declarator] = STATE(28),
    [sym_function_declarator] = STATE(177),
    [sym_array_declarator] = STATE(28),
    [sym_storage_class_specifier] = STATE(180),
    [sym_type_qualifier] = STATE(180),
    [sym__type_specifier] = STATE(30),
    [sym_sized_type_specifier] = STATE(30),
    [sym_enum_specifier] = STATE(30),
    [sym_struct_specifier] = STATE(30),
    [sym_union_specifier] = STATE(30),
    [sym__empty_declaration] = STATE(1571),
    [sym_macro_type_specifier] = STATE(30),
    [sym_class_specifier] = STATE(30),
    [sym_dependent_type] = STATE(30),
    [sym_structured_binding_declaration] = STATE(1571),
    [sym_template_declaration] = STATE(1571),
    [sym_template_instantiation] = STATE(1571),
    [sym_constructor_or_destructor_definition] = STATE(178),
    [sym_reference_declarator] = STATE(28),
    [sym_template_type] = STATE(32),
    [sym_template_function] = STATE(28),
    [sym_namespace_definition] = STATE(1571),
    [sym_using_declaration] = STATE(1571),
    [sym_alias_declaration] = STATE(1571),
    [sym_destructor_name] = STATE(28),
    [sym_scoped_identifier] = STATE(33),
    [sym_scoped_type_identifier] = STATE(34),
    [sym_scoped_namespace_identifier] = STATE(35),
    [aux_sym_translation_unit_repeat1] = STATE(1571),
    [aux_sym__declaration_specifiers_repeat1] = STATE(180),
    [aux_sym_sized_type_specifier_repeat1] = STATE(38),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(273),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(275),
    [anon_sym_LPAREN] = ACTIONS(11),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(277),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3398),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(281),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(283),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(285),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(287),
    [sym_preproc_directive] = ACTIONS(289),
    [anon_sym_typedef] = ACTIONS(291),
    [anon_sym_extern] = ACTIONS(293),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_static] = ACTIONS(27),
    [anon_sym_register] = ACTIONS(27),
    [anon_sym_inline] = ACTIONS(27),
    [anon_sym_const] = ACTIONS(29),
    [anon_sym_restrict] = ACTIONS(29),
    [anon_sym_volatile] = ACTIONS(29),
    [anon_sym__Atomic] = ACTIONS(29),
    [anon_sym_mutable] = ACTIONS(29),
    [anon_sym_explicit] = ACTIONS(29),
    [anon_sym_constexpr] = ACTIONS(29),
    [anon_sym_unsigned] = ACTIONS(31),
    [anon_sym_long] = ACTIONS(31),
    [anon_sym_short] = ACTIONS(31),
    [sym_primitive_type] = ACTIONS(33),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_union] = ACTIONS(39),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(45),
    [sym_identifier] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(51),
    [sym_auto] = ACTIONS(33),
    [anon_sym_typename] = ACTIONS(53),
    [anon_sym_template] = ACTIONS(295),
    [anon_sym_namespace] = ACTIONS(297),
    [anon_sym_using] = ACTIONS(299),
    [anon_sym_COLON_COLON] = ACTIONS(61),
    [sym_operator_name] = ACTIONS(63),
  },
  [953] = {
    [sym_preproc_arg] = ACTIONS(3400),
    [sym_comment] = ACTIONS(83),
  },
  [954] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(309),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(309),
    [anon_sym_LPAREN] = ACTIONS(307),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(309),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(309),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(309),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(309),
    [sym_preproc_directive] = ACTIONS(309),
    [anon_sym_typedef] = ACTIONS(309),
    [anon_sym_extern] = ACTIONS(309),
    [anon_sym_STAR] = ACTIONS(307),
    [anon_sym_static] = ACTIONS(309),
    [anon_sym_register] = ACTIONS(309),
    [anon_sym_inline] = ACTIONS(309),
    [anon_sym_const] = ACTIONS(309),
    [anon_sym_restrict] = ACTIONS(309),
    [anon_sym_volatile] = ACTIONS(309),
    [anon_sym__Atomic] = ACTIONS(309),
    [anon_sym_mutable] = ACTIONS(309),
    [anon_sym_explicit] = ACTIONS(309),
    [anon_sym_constexpr] = ACTIONS(309),
    [anon_sym_unsigned] = ACTIONS(309),
    [anon_sym_long] = ACTIONS(309),
    [anon_sym_short] = ACTIONS(309),
    [sym_primitive_type] = ACTIONS(309),
    [anon_sym_enum] = ACTIONS(309),
    [anon_sym_struct] = ACTIONS(309),
    [anon_sym_union] = ACTIONS(309),
    [anon_sym_AMP] = ACTIONS(309),
    [anon_sym_AMP_AMP] = ACTIONS(307),
    [anon_sym_TILDE] = ACTIONS(307),
    [sym_identifier] = ACTIONS(309),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(309),
    [sym_auto] = ACTIONS(309),
    [anon_sym_typename] = ACTIONS(309),
    [anon_sym_template] = ACTIONS(309),
    [anon_sym_namespace] = ACTIONS(309),
    [anon_sym_using] = ACTIONS(309),
    [anon_sym_COLON_COLON] = ACTIONS(307),
    [sym_operator_name] = ACTIONS(307),
  },
  [955] = {
    [sym__type_declarator] = STATE(1573),
    [sym_pointer_type_declarator] = STATE(213),
    [sym_function_type_declarator] = STATE(214),
    [sym_array_type_declarator] = STATE(215),
    [anon_sym_LPAREN] = ACTIONS(327),
    [anon_sym_STAR] = ACTIONS(329),
    [sym_identifier] = ACTIONS(331),
    [sym_comment] = ACTIONS(49),
  },
  [956] = {
    [sym_type_qualifier] = STATE(219),
    [sym__type_specifier] = STATE(1574),
    [sym_sized_type_specifier] = STATE(1574),
    [sym_enum_specifier] = STATE(1574),
    [sym_struct_specifier] = STATE(1574),
    [sym_union_specifier] = STATE(1574),
    [sym_macro_type_specifier] = STATE(1574),
    [sym_class_specifier] = STATE(1574),
    [sym_dependent_type] = STATE(1574),
    [sym_template_type] = STATE(62),
    [sym_scoped_type_identifier] = STATE(63),
    [sym_scoped_namespace_identifier] = STATE(64),
    [aux_sym_type_definition_repeat1] = STATE(219),
    [aux_sym_sized_type_specifier_repeat1] = STATE(66),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_restrict] = ACTIONS(93),
    [anon_sym_volatile] = ACTIONS(93),
    [anon_sym__Atomic] = ACTIONS(93),
    [anon_sym_mutable] = ACTIONS(93),
    [anon_sym_explicit] = ACTIONS(93),
    [anon_sym_constexpr] = ACTIONS(93),
    [anon_sym_unsigned] = ACTIONS(95),
    [anon_sym_long] = ACTIONS(95),
    [anon_sym_short] = ACTIONS(95),
    [sym_primitive_type] = ACTIONS(3402),
    [anon_sym_enum] = ACTIONS(99),
    [anon_sym_struct] = ACTIONS(101),
    [anon_sym_union] = ACTIONS(103),
    [sym_identifier] = ACTIONS(105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(107),
    [sym_auto] = ACTIONS(3402),
    [anon_sym_typename] = ACTIONS(109),
    [anon_sym_COLON_COLON] = ACTIONS(111),
  },
  [957] = {
    [sym_function_definition] = STATE(1575),
    [sym_declaration] = STATE(1575),
    [sym__declaration_specifiers] = STATE(1576),
    [sym_declaration_list] = STATE(1575),
    [sym_storage_class_specifier] = STATE(109),
    [sym_type_qualifier] = STATE(109),
    [sym__type_specifier] = STATE(105),
    [sym_sized_type_specifier] = STATE(105),
    [sym_enum_specifier] = STATE(105),
    [sym_struct_specifier] = STATE(105),
    [sym_union_specifier] = STATE(105),
    [sym_macro_type_specifier] = STATE(105),
    [sym_class_specifier] = STATE(105),
    [sym_dependent_type] = STATE(105),
    [sym_template_type] = STATE(94),
    [sym_scoped_type_identifier] = STATE(34),
    [sym_scoped_namespace_identifier] = STATE(81),
    [aux_sym__declaration_specifiers_repeat1] = STATE(109),
    [aux_sym_sized_type_specifier_repeat1] = STATE(110),
    [anon_sym_extern] = ACTIONS(154),
    [anon_sym_LBRACE] = ACTIONS(1875),
    [anon_sym_static] = ACTIONS(154),
    [anon_sym_register] = ACTIONS(154),
    [anon_sym_inline] = ACTIONS(154),
    [anon_sym_const] = ACTIONS(158),
    [anon_sym_restrict] = ACTIONS(158),
    [anon_sym_volatile] = ACTIONS(158),
    [anon_sym__Atomic] = ACTIONS(158),
    [anon_sym_mutable] = ACTIONS(158),
    [anon_sym_explicit] = ACTIONS(158),
    [anon_sym_constexpr] = ACTIONS(158),
    [anon_sym_unsigned] = ACTIONS(160),
    [anon_sym_long] = ACTIONS(160),
    [anon_sym_short] = ACTIONS(160),
    [sym_primitive_type] = ACTIONS(162),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_union] = ACTIONS(39),
    [sym_identifier] = ACTIONS(152),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(51),
    [sym_auto] = ACTIONS(162),
    [anon_sym_typename] = ACTIONS(172),
    [anon_sym_COLON_COLON] = ACTIONS(135),
  },
  [958] = {
    [sym__declarator] = STATE(1577),
    [sym_pointer_declarator] = STATE(1577),
    [sym_function_declarator] = STATE(1577),
    [sym_array_declarator] = STATE(1577),
    [sym_reference_declarator] = STATE(1577),
    [sym_template_type] = STATE(46),
    [sym_template_function] = STATE(1577),
    [sym_destructor_name] = STATE(1577),
    [sym_scoped_identifier] = STATE(33),
    [sym_scoped_type_identifier] = STATE(47),
    [sym_scoped_namespace_identifier] = STATE(46),
    [anon_sym_LPAREN] = ACTIONS(11),
    [anon_sym_STAR] = ACTIONS(156),
    [anon_sym_AMP] = ACTIONS(164),
    [anon_sym_AMP_AMP] = ACTIONS(166),
    [anon_sym_TILDE] = ACTIONS(45),
    [sym_identifier] = ACTIONS(75),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(77),
    [sym_operator_name] = ACTIONS(3404),
  },
  [959] = {
    [sym_parameter_list] = STATE(299),
    [anon_sym_LPAREN] = ACTIONS(206),
    [anon_sym_SEMI] = ACTIONS(3406),
    [anon_sym_LBRACK] = ACTIONS(208),
    [sym_comment] = ACTIONS(49),
  },
  [960] = {
    [sym_function_definition] = STATE(1579),
    [sym_declaration] = STATE(1579),
    [sym__declaration_specifiers] = STATE(1580),
    [sym_storage_class_specifier] = STATE(305),
    [sym_type_qualifier] = STATE(305),
    [sym__type_specifier] = STATE(304),
    [sym_sized_type_specifier] = STATE(304),
    [sym_enum_specifier] = STATE(304),
    [sym_struct_specifier] = STATE(304),
    [sym_union_specifier] = STATE(304),
    [sym__empty_declaration] = STATE(1579),
    [sym_macro_type_specifier] = STATE(304),
    [sym_class_specifier] = STATE(304),
    [sym_dependent_type] = STATE(304),
    [sym_template_type] = STATE(94),
    [sym_scoped_type_identifier] = STATE(34),
    [sym_scoped_namespace_identifier] = STATE(81),
    [aux_sym__declaration_specifiers_repeat1] = STATE(305),
    [aux_sym_sized_type_specifier_repeat1] = STATE(306),
    [anon_sym_extern] = ACTIONS(154),
    [anon_sym_static] = ACTIONS(154),
    [anon_sym_register] = ACTIONS(154),
    [anon_sym_inline] = ACTIONS(154),
    [anon_sym_const] = ACTIONS(158),
    [anon_sym_restrict] = ACTIONS(158),
    [anon_sym_volatile] = ACTIONS(158),
    [anon_sym__Atomic] = ACTIONS(158),
    [anon_sym_mutable] = ACTIONS(158),
    [anon_sym_explicit] = ACTIONS(158),
    [anon_sym_constexpr] = ACTIONS(158),
    [anon_sym_unsigned] = ACTIONS(479),
    [anon_sym_long] = ACTIONS(479),
    [anon_sym_short] = ACTIONS(479),
    [sym_primitive_type] = ACTIONS(481),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_union] = ACTIONS(39),
    [sym_identifier] = ACTIONS(152),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(51),
    [sym_auto] = ACTIONS(481),
    [anon_sym_typename] = ACTIONS(483),
    [anon_sym_COLON_COLON] = ACTIONS(135),
  },
  [961] = {
    [sym_preproc_include] = STATE(1582),
    [sym_preproc_def] = STATE(1582),
    [sym_preproc_function_def] = STATE(1582),
    [sym_preproc_call] = STATE(1582),
    [sym_preproc_if] = STATE(1582),
    [sym_preproc_ifdef] = STATE(1582),
    [sym_function_definition] = STATE(1582),
    [sym_declaration] = STATE(1582),
    [sym_type_definition] = STATE(1582),
    [sym__declaration_specifiers] = STATE(27),
    [sym_linkage_specification] = STATE(1582),
    [sym__declarator] = STATE(28),
    [sym_pointer_declarator] = STATE(28),
    [sym_function_declarator] = STATE(29),
    [sym_array_declarator] = STATE(28),
    [sym_storage_class_specifier] = STATE(37),
    [sym_type_qualifier] = STATE(37),
    [sym__type_specifier] = STATE(30),
    [sym_sized_type_specifier] = STATE(30),
    [sym_enum_specifier] = STATE(30),
    [sym_struct_specifier] = STATE(30),
    [sym_union_specifier] = STATE(30),
    [sym__empty_declaration] = STATE(1582),
    [sym_macro_type_specifier] = STATE(30),
    [sym_class_specifier] = STATE(30),
    [sym_dependent_type] = STATE(30),
    [sym_structured_binding_declaration] = STATE(1582),
    [sym_template_declaration] = STATE(1582),
    [sym_template_instantiation] = STATE(1582),
    [sym_constructor_or_destructor_definition] = STATE(31),
    [sym_reference_declarator] = STATE(28),
    [sym_template_type] = STATE(32),
    [sym_template_function] = STATE(28),
    [sym_namespace_definition] = STATE(1582),
    [sym_using_declaration] = STATE(1582),
    [sym_alias_declaration] = STATE(1582),
    [sym_destructor_name] = STATE(28),
    [sym_scoped_identifier] = STATE(33),
    [sym_scoped_type_identifier] = STATE(34),
    [sym_scoped_namespace_identifier] = STATE(35),
    [aux_sym_translation_unit_repeat1] = STATE(1582),
    [aux_sym__declaration_specifiers_repeat1] = STATE(37),
    [aux_sym_sized_type_specifier_repeat1] = STATE(38),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(7),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(11),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(13),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(15),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(17),
    [sym_preproc_directive] = ACTIONS(19),
    [anon_sym_typedef] = ACTIONS(21),
    [anon_sym_extern] = ACTIONS(23),
    [anon_sym_RBRACE] = ACTIONS(3408),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_static] = ACTIONS(27),
    [anon_sym_register] = ACTIONS(27),
    [anon_sym_inline] = ACTIONS(27),
    [anon_sym_const] = ACTIONS(29),
    [anon_sym_restrict] = ACTIONS(29),
    [anon_sym_volatile] = ACTIONS(29),
    [anon_sym__Atomic] = ACTIONS(29),
    [anon_sym_mutable] = ACTIONS(29),
    [anon_sym_explicit] = ACTIONS(29),
    [anon_sym_constexpr] = ACTIONS(29),
    [anon_sym_unsigned] = ACTIONS(31),
    [anon_sym_long] = ACTIONS(31),
    [anon_sym_short] = ACTIONS(31),
    [sym_primitive_type] = ACTIONS(33),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_union] = ACTIONS(39),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(45),
    [sym_identifier] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(51),
    [sym_auto] = ACTIONS(33),
    [anon_sym_typename] = ACTIONS(53),
    [anon_sym_template] = ACTIONS(55),
    [anon_sym_namespace] = ACTIONS(57),
    [anon_sym_using] = ACTIONS(59),
    [anon_sym_COLON_COLON] = ACTIONS(61),
    [sym_operator_name] = ACTIONS(63),
  },
  [962] = {
    [sym_declaration_list] = STATE(1583),
    [anon_sym_LBRACE] = ACTIONS(1875),
    [sym_comment] = ACTIONS(49),
  },
  [963] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(495),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(495),
    [anon_sym_LPAREN] = ACTIONS(493),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(495),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(495),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(495),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(495),
    [sym_preproc_directive] = ACTIONS(495),
    [anon_sym_typedef] = ACTIONS(495),
    [anon_sym_extern] = ACTIONS(495),
    [anon_sym_STAR] = ACTIONS(493),
    [anon_sym_static] = ACTIONS(495),
    [anon_sym_register] = ACTIONS(495),
    [anon_sym_inline] = ACTIONS(495),
    [anon_sym_const] = ACTIONS(495),
    [anon_sym_restrict] = ACTIONS(495),
    [anon_sym_volatile] = ACTIONS(495),
    [anon_sym__Atomic] = ACTIONS(495),
    [anon_sym_mutable] = ACTIONS(495),
    [anon_sym_explicit] = ACTIONS(495),
    [anon_sym_constexpr] = ACTIONS(495),
    [anon_sym_unsigned] = ACTIONS(495),
    [anon_sym_long] = ACTIONS(495),
    [anon_sym_short] = ACTIONS(495),
    [sym_primitive_type] = ACTIONS(495),
    [anon_sym_enum] = ACTIONS(495),
    [anon_sym_struct] = ACTIONS(495),
    [anon_sym_union] = ACTIONS(495),
    [anon_sym_AMP] = ACTIONS(495),
    [anon_sym_AMP_AMP] = ACTIONS(493),
    [anon_sym_TILDE] = ACTIONS(493),
    [sym_identifier] = ACTIONS(495),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(495),
    [sym_auto] = ACTIONS(495),
    [anon_sym_typename] = ACTIONS(495),
    [anon_sym_template] = ACTIONS(495),
    [anon_sym_namespace] = ACTIONS(495),
    [anon_sym_using] = ACTIONS(495),
    [anon_sym_COLON_COLON] = ACTIONS(493),
    [sym_operator_name] = ACTIONS(493),
  },
  [964] = {
    [sym_template_argument_list] = STATE(203),
    [anon_sym_SEMI] = ACTIONS(3410),
    [anon_sym_EQ] = ACTIONS(3412),
    [anon_sym_LT] = ACTIONS(146),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(501),
  },
  [965] = {
    [sym_template_type] = STATE(117),
    [sym_scoped_identifier] = STATE(1587),
    [sym_scoped_type_identifier] = STATE(47),
    [sym_scoped_namespace_identifier] = STATE(117),
    [sym_identifier] = ACTIONS(3414),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(186),
  },
  [966] = {
    [anon_sym_SEMI] = ACTIONS(3410),
    [sym_comment] = ACTIONS(49),
  },
  [967] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(524),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(524),
    [anon_sym_LPAREN] = ACTIONS(522),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(524),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(524),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(524),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(524),
    [sym_preproc_directive] = ACTIONS(524),
    [anon_sym_typedef] = ACTIONS(524),
    [anon_sym_extern] = ACTIONS(524),
    [anon_sym_STAR] = ACTIONS(522),
    [anon_sym_static] = ACTIONS(524),
    [anon_sym_register] = ACTIONS(524),
    [anon_sym_inline] = ACTIONS(524),
    [anon_sym_const] = ACTIONS(524),
    [anon_sym_restrict] = ACTIONS(524),
    [anon_sym_volatile] = ACTIONS(524),
    [anon_sym__Atomic] = ACTIONS(524),
    [anon_sym_mutable] = ACTIONS(524),
    [anon_sym_explicit] = ACTIONS(524),
    [anon_sym_constexpr] = ACTIONS(524),
    [anon_sym_unsigned] = ACTIONS(524),
    [anon_sym_long] = ACTIONS(524),
    [anon_sym_short] = ACTIONS(524),
    [sym_primitive_type] = ACTIONS(524),
    [anon_sym_enum] = ACTIONS(524),
    [anon_sym_struct] = ACTIONS(524),
    [anon_sym_union] = ACTIONS(524),
    [anon_sym_AMP] = ACTIONS(524),
    [anon_sym_AMP_AMP] = ACTIONS(522),
    [anon_sym_TILDE] = ACTIONS(522),
    [sym_identifier] = ACTIONS(524),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(524),
    [sym_auto] = ACTIONS(524),
    [anon_sym_typename] = ACTIONS(524),
    [anon_sym_template] = ACTIONS(524),
    [anon_sym_namespace] = ACTIONS(524),
    [anon_sym_using] = ACTIONS(524),
    [anon_sym_COLON_COLON] = ACTIONS(522),
    [sym_operator_name] = ACTIONS(522),
  },
  [968] = {
    [sym_compound_statement] = STATE(1590),
    [sym_parameter_list] = STATE(332),
    [sym_argument_list] = STATE(333),
    [sym_initializer_list] = STATE(333),
    [aux_sym_declaration_repeat1] = STATE(1591),
    [anon_sym_LPAREN] = ACTIONS(536),
    [anon_sym_COMMA] = ACTIONS(538),
    [anon_sym_SEMI] = ACTIONS(3416),
    [anon_sym_LBRACE] = ACTIONS(3418),
    [anon_sym_LBRACK] = ACTIONS(208),
    [anon_sym_EQ] = ACTIONS(544),
    [sym_comment] = ACTIONS(49),
  },
  [969] = {
    [aux_sym_declaration_repeat1] = STATE(1591),
    [anon_sym_COMMA] = ACTIONS(538),
    [anon_sym_SEMI] = ACTIONS(3416),
    [sym_comment] = ACTIONS(49),
  },
  [970] = {
    [sym_argument_list] = STATE(1593),
    [sym_initializer_list] = STATE(1593),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_LBRACE] = ACTIONS(548),
    [anon_sym_EQ] = ACTIONS(3420),
    [sym_comment] = ACTIONS(49),
  },
  [971] = {
    [sym_argument_list] = STATE(1595),
    [sym_initializer_list] = STATE(1595),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_LBRACE] = ACTIONS(548),
    [anon_sym_EQ] = ACTIONS(3422),
    [sym_comment] = ACTIONS(49),
  },
  [972] = {
    [sym_preproc_include] = STATE(1597),
    [sym_preproc_def] = STATE(1597),
    [sym_preproc_function_def] = STATE(1597),
    [sym_preproc_call] = STATE(1597),
    [sym_preproc_if_in_compound_statement] = STATE(410),
    [sym_preproc_ifdef_in_compound_statement] = STATE(411),
    [sym_declaration] = STATE(1597),
    [sym_type_definition] = STATE(1597),
    [sym__declaration_specifiers] = STATE(412),
    [sym_compound_statement] = STATE(1597),
    [sym_storage_class_specifier] = STATE(419),
    [sym_type_qualifier] = STATE(419),
    [sym__type_specifier] = STATE(30),
    [sym_sized_type_specifier] = STATE(30),
    [sym_enum_specifier] = STATE(30),
    [sym_struct_specifier] = STATE(30),
    [sym_union_specifier] = STATE(30),
    [sym_labeled_statement] = STATE(1597),
    [sym_expression_statement] = STATE(1597),
    [sym_if_statement] = STATE(1597),
    [sym_switch_statement] = STATE(1597),
    [sym_case_statement] = STATE(1597),
    [sym_while_statement] = STATE(1597),
    [sym_do_statement] = STATE(1597),
    [sym_for_statement] = STATE(1597),
    [sym_return_statement] = STATE(1597),
    [sym_break_statement] = STATE(1597),
    [sym_continue_statement] = STATE(1597),
    [sym_goto_statement] = STATE(1597),
    [sym__expression] = STATE(413),
    [sym_comma_expression] = STATE(414),
    [sym_conditional_expression] = STATE(413),
    [sym_assignment_expression] = STATE(413),
    [sym_pointer_expression] = STATE(413),
    [sym_logical_expression] = STATE(413),
    [sym_bitwise_expression] = STATE(413),
    [sym_equality_expression] = STATE(413),
    [sym_relational_expression] = STATE(413),
    [sym_shift_expression] = STATE(413),
    [sym_math_expression] = STATE(413),
    [sym_cast_expression] = STATE(413),
    [sym_sizeof_expression] = STATE(413),
    [sym_subscript_expression] = STATE(413),
    [sym_call_expression] = STATE(413),
    [sym_field_expression] = STATE(413),
    [sym_compound_literal_expression] = STATE(413),
    [sym_parenthesized_expression] = STATE(413),
    [sym_concatenated_string] = STATE(413),
    [sym__empty_declaration] = STATE(1597),
    [sym_macro_type_specifier] = STATE(30),
    [sym_class_specifier] = STATE(30),
    [sym_dependent_type] = STATE(30),
    [sym_structured_binding_declaration] = STATE(1597),
    [sym_template_type] = STATE(415),
    [sym_template_function] = STATE(413),
    [sym_for_range_loop] = STATE(1597),
    [sym_new_expression] = STATE(413),
    [sym_delete_expression] = STATE(413),
    [sym_lambda_expression] = STATE(413),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(416),
    [sym_scoped_namespace_identifier] = STATE(417),
    [aux_sym_preproc_if_in_compound_statement_repeat1] = STATE(1597),
    [aux_sym__declaration_specifiers_repeat1] = STATE(419),
    [aux_sym_sized_type_specifier_repeat1] = STATE(38),
    [sym_raw_string_literal] = ACTIONS(620),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(622),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(624),
    [anon_sym_LPAREN] = ACTIONS(626),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(628),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(630),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(632),
    [sym_preproc_directive] = ACTIONS(634),
    [anon_sym_SEMI] = ACTIONS(636),
    [anon_sym_typedef] = ACTIONS(638),
    [anon_sym_extern] = ACTIONS(154),
    [anon_sym_LBRACE] = ACTIONS(640),
    [anon_sym_RBRACE] = ACTIONS(3424),
    [anon_sym_STAR] = ACTIONS(644),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_static] = ACTIONS(154),
    [anon_sym_register] = ACTIONS(154),
    [anon_sym_inline] = ACTIONS(154),
    [anon_sym_const] = ACTIONS(158),
    [anon_sym_restrict] = ACTIONS(158),
    [anon_sym_volatile] = ACTIONS(158),
    [anon_sym__Atomic] = ACTIONS(158),
    [anon_sym_mutable] = ACTIONS(158),
    [anon_sym_explicit] = ACTIONS(158),
    [anon_sym_constexpr] = ACTIONS(158),
    [anon_sym_unsigned] = ACTIONS(31),
    [anon_sym_long] = ACTIONS(31),
    [anon_sym_short] = ACTIONS(31),
    [sym_primitive_type] = ACTIONS(33),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_union] = ACTIONS(39),
    [anon_sym_if] = ACTIONS(646),
    [anon_sym_switch] = ACTIONS(648),
    [anon_sym_case] = ACTIONS(650),
    [anon_sym_default] = ACTIONS(652),
    [anon_sym_while] = ACTIONS(654),
    [anon_sym_do] = ACTIONS(656),
    [anon_sym_for] = ACTIONS(658),
    [anon_sym_return] = ACTIONS(660),
    [anon_sym_break] = ACTIONS(662),
    [anon_sym_continue] = ACTIONS(664),
    [anon_sym_goto] = ACTIONS(666),
    [anon_sym_AMP] = ACTIONS(644),
    [anon_sym_BANG] = ACTIONS(668),
    [anon_sym_TILDE] = ACTIONS(670),
    [anon_sym_PLUS] = ACTIONS(672),
    [anon_sym_DASH] = ACTIONS(672),
    [anon_sym_DASH_DASH] = ACTIONS(674),
    [anon_sym_PLUS_PLUS] = ACTIONS(674),
    [anon_sym_sizeof] = ACTIONS(676),
    [sym_number_literal] = ACTIONS(620),
    [sym_char_literal] = ACTIONS(620),
    [sym_string_literal] = ACTIONS(678),
    [sym_true] = ACTIONS(680),
    [sym_false] = ACTIONS(680),
    [sym_null] = ACTIONS(680),
    [sym_identifier] = ACTIONS(682),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(51),
    [sym_auto] = ACTIONS(33),
    [anon_sym_typename] = ACTIONS(53),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(684),
    [anon_sym_delete] = ACTIONS(686),
    [sym_nullptr] = ACTIONS(680),
  },
  [973] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(694),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(694),
    [anon_sym_LPAREN] = ACTIONS(692),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(694),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(694),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(694),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(694),
    [sym_preproc_directive] = ACTIONS(694),
    [anon_sym_typedef] = ACTIONS(694),
    [anon_sym_extern] = ACTIONS(694),
    [anon_sym_STAR] = ACTIONS(692),
    [anon_sym_static] = ACTIONS(694),
    [anon_sym_register] = ACTIONS(694),
    [anon_sym_inline] = ACTIONS(694),
    [anon_sym_const] = ACTIONS(694),
    [anon_sym_restrict] = ACTIONS(694),
    [anon_sym_volatile] = ACTIONS(694),
    [anon_sym__Atomic] = ACTIONS(694),
    [anon_sym_mutable] = ACTIONS(694),
    [anon_sym_explicit] = ACTIONS(694),
    [anon_sym_constexpr] = ACTIONS(694),
    [anon_sym_unsigned] = ACTIONS(694),
    [anon_sym_long] = ACTIONS(694),
    [anon_sym_short] = ACTIONS(694),
    [sym_primitive_type] = ACTIONS(694),
    [anon_sym_enum] = ACTIONS(694),
    [anon_sym_struct] = ACTIONS(694),
    [anon_sym_union] = ACTIONS(694),
    [anon_sym_AMP] = ACTIONS(694),
    [anon_sym_AMP_AMP] = ACTIONS(692),
    [anon_sym_TILDE] = ACTIONS(692),
    [sym_identifier] = ACTIONS(694),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(694),
    [sym_auto] = ACTIONS(694),
    [anon_sym_typename] = ACTIONS(694),
    [anon_sym_template] = ACTIONS(694),
    [anon_sym_namespace] = ACTIONS(694),
    [anon_sym_using] = ACTIONS(694),
    [anon_sym_COLON_COLON] = ACTIONS(692),
    [sym_operator_name] = ACTIONS(692),
  },
  [974] = {
    [sym_compound_statement] = STATE(1598),
    [anon_sym_LBRACE] = ACTIONS(1887),
    [sym_comment] = ACTIONS(49),
  },
  [975] = {
    [sym_preproc_include] = STATE(975),
    [sym_preproc_def] = STATE(975),
    [sym_preproc_function_def] = STATE(975),
    [sym_preproc_call] = STATE(975),
    [sym_preproc_if] = STATE(975),
    [sym_preproc_ifdef] = STATE(975),
    [sym_function_definition] = STATE(975),
    [sym_declaration] = STATE(975),
    [sym_type_definition] = STATE(975),
    [sym__declaration_specifiers] = STATE(456),
    [sym_linkage_specification] = STATE(975),
    [sym__declarator] = STATE(28),
    [sym_pointer_declarator] = STATE(28),
    [sym_function_declarator] = STATE(457),
    [sym_array_declarator] = STATE(28),
    [sym_storage_class_specifier] = STATE(460),
    [sym_type_qualifier] = STATE(460),
    [sym__type_specifier] = STATE(30),
    [sym_sized_type_specifier] = STATE(30),
    [sym_enum_specifier] = STATE(30),
    [sym_struct_specifier] = STATE(30),
    [sym_union_specifier] = STATE(30),
    [sym__empty_declaration] = STATE(975),
    [sym_macro_type_specifier] = STATE(30),
    [sym_class_specifier] = STATE(30),
    [sym_dependent_type] = STATE(30),
    [sym_structured_binding_declaration] = STATE(975),
    [sym_template_declaration] = STATE(975),
    [sym_template_instantiation] = STATE(975),
    [sym_constructor_or_destructor_definition] = STATE(458),
    [sym_reference_declarator] = STATE(28),
    [sym_template_type] = STATE(32),
    [sym_template_function] = STATE(28),
    [sym_namespace_definition] = STATE(975),
    [sym_using_declaration] = STATE(975),
    [sym_alias_declaration] = STATE(975),
    [sym_destructor_name] = STATE(28),
    [sym_scoped_identifier] = STATE(33),
    [sym_scoped_type_identifier] = STATE(34),
    [sym_scoped_namespace_identifier] = STATE(35),
    [aux_sym_translation_unit_repeat1] = STATE(975),
    [aux_sym__declaration_specifiers_repeat1] = STATE(460),
    [aux_sym_sized_type_specifier_repeat1] = STATE(38),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3426),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3429),
    [anon_sym_LPAREN] = ACTIONS(720),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3432),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(1934),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3435),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3438),
    [sym_preproc_directive] = ACTIONS(3441),
    [anon_sym_typedef] = ACTIONS(3444),
    [anon_sym_extern] = ACTIONS(3447),
    [anon_sym_STAR] = ACTIONS(741),
    [anon_sym_static] = ACTIONS(744),
    [anon_sym_register] = ACTIONS(744),
    [anon_sym_inline] = ACTIONS(744),
    [anon_sym_const] = ACTIONS(747),
    [anon_sym_restrict] = ACTIONS(747),
    [anon_sym_volatile] = ACTIONS(747),
    [anon_sym__Atomic] = ACTIONS(747),
    [anon_sym_mutable] = ACTIONS(747),
    [anon_sym_explicit] = ACTIONS(747),
    [anon_sym_constexpr] = ACTIONS(747),
    [anon_sym_unsigned] = ACTIONS(750),
    [anon_sym_long] = ACTIONS(750),
    [anon_sym_short] = ACTIONS(750),
    [sym_primitive_type] = ACTIONS(753),
    [anon_sym_enum] = ACTIONS(756),
    [anon_sym_struct] = ACTIONS(759),
    [anon_sym_union] = ACTIONS(762),
    [anon_sym_AMP] = ACTIONS(765),
    [anon_sym_AMP_AMP] = ACTIONS(768),
    [anon_sym_TILDE] = ACTIONS(771),
    [sym_identifier] = ACTIONS(774),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(777),
    [sym_auto] = ACTIONS(753),
    [anon_sym_typename] = ACTIONS(780),
    [anon_sym_template] = ACTIONS(3450),
    [anon_sym_namespace] = ACTIONS(3453),
    [anon_sym_using] = ACTIONS(3456),
    [anon_sym_COLON_COLON] = ACTIONS(792),
    [sym_operator_name] = ACTIONS(795),
  },
  [976] = {
    [sym_compound_statement] = STATE(1598),
    [sym_field_initializer_list] = STATE(1599),
    [anon_sym_LPAREN] = ACTIONS(210),
    [anon_sym_LBRACE] = ACTIONS(1887),
    [anon_sym_LBRACK] = ACTIONS(210),
    [anon_sym_COLON] = ACTIONS(214),
    [sym_comment] = ACTIONS(49),
  },
  [977] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3459),
    [sym_comment] = ACTIONS(49),
  },
  [978] = {
    [sym_preproc_include] = STATE(486),
    [sym_preproc_def] = STATE(486),
    [sym_preproc_function_def] = STATE(486),
    [sym_preproc_call] = STATE(486),
    [sym_preproc_if] = STATE(486),
    [sym_preproc_ifdef] = STATE(486),
    [sym_preproc_else] = STATE(1600),
    [sym_preproc_elif] = STATE(1600),
    [sym_function_definition] = STATE(486),
    [sym_declaration] = STATE(486),
    [sym_type_definition] = STATE(486),
    [sym__declaration_specifiers] = STATE(176),
    [sym_linkage_specification] = STATE(486),
    [sym__declarator] = STATE(28),
    [sym_pointer_declarator] = STATE(28),
    [sym_function_declarator] = STATE(177),
    [sym_array_declarator] = STATE(28),
    [sym_storage_class_specifier] = STATE(180),
    [sym_type_qualifier] = STATE(180),
    [sym__type_specifier] = STATE(30),
    [sym_sized_type_specifier] = STATE(30),
    [sym_enum_specifier] = STATE(30),
    [sym_struct_specifier] = STATE(30),
    [sym_union_specifier] = STATE(30),
    [sym__empty_declaration] = STATE(486),
    [sym_macro_type_specifier] = STATE(30),
    [sym_class_specifier] = STATE(30),
    [sym_dependent_type] = STATE(30),
    [sym_structured_binding_declaration] = STATE(486),
    [sym_template_declaration] = STATE(486),
    [sym_template_instantiation] = STATE(486),
    [sym_constructor_or_destructor_definition] = STATE(178),
    [sym_reference_declarator] = STATE(28),
    [sym_template_type] = STATE(32),
    [sym_template_function] = STATE(28),
    [sym_namespace_definition] = STATE(486),
    [sym_using_declaration] = STATE(486),
    [sym_alias_declaration] = STATE(486),
    [sym_destructor_name] = STATE(28),
    [sym_scoped_identifier] = STATE(33),
    [sym_scoped_type_identifier] = STATE(34),
    [sym_scoped_namespace_identifier] = STATE(35),
    [aux_sym_translation_unit_repeat1] = STATE(486),
    [aux_sym__declaration_specifiers_repeat1] = STATE(180),
    [aux_sym_sized_type_specifier_repeat1] = STATE(38),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(273),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(275),
    [anon_sym_LPAREN] = ACTIONS(11),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(277),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3461),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(281),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(283),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(285),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(287),
    [sym_preproc_directive] = ACTIONS(289),
    [anon_sym_typedef] = ACTIONS(291),
    [anon_sym_extern] = ACTIONS(293),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_static] = ACTIONS(27),
    [anon_sym_register] = ACTIONS(27),
    [anon_sym_inline] = ACTIONS(27),
    [anon_sym_const] = ACTIONS(29),
    [anon_sym_restrict] = ACTIONS(29),
    [anon_sym_volatile] = ACTIONS(29),
    [anon_sym__Atomic] = ACTIONS(29),
    [anon_sym_mutable] = ACTIONS(29),
    [anon_sym_explicit] = ACTIONS(29),
    [anon_sym_constexpr] = ACTIONS(29),
    [anon_sym_unsigned] = ACTIONS(31),
    [anon_sym_long] = ACTIONS(31),
    [anon_sym_short] = ACTIONS(31),
    [sym_primitive_type] = ACTIONS(33),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_union] = ACTIONS(39),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(45),
    [sym_identifier] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(51),
    [sym_auto] = ACTIONS(33),
    [anon_sym_typename] = ACTIONS(53),
    [anon_sym_template] = ACTIONS(295),
    [anon_sym_namespace] = ACTIONS(297),
    [anon_sym_using] = ACTIONS(299),
    [anon_sym_COLON_COLON] = ACTIONS(61),
    [sym_operator_name] = ACTIONS(63),
  },
  [979] = {
    [anon_sym_LF] = ACTIONS(3463),
    [sym_comment] = ACTIONS(83),
  },
  [980] = {
    [sym_parameter_list] = STATE(513),
    [anon_sym_LPAREN] = ACTIONS(206),
    [anon_sym_SEMI] = ACTIONS(3465),
    [anon_sym_LBRACK] = ACTIONS(955),
    [sym_comment] = ACTIONS(49),
  },
  [981] = {
    [sym__type_declarator] = STATE(1603),
    [sym_pointer_type_declarator] = STATE(213),
    [sym_function_type_declarator] = STATE(214),
    [sym_array_type_declarator] = STATE(215),
    [anon_sym_LPAREN] = ACTIONS(327),
    [anon_sym_STAR] = ACTIONS(329),
    [sym_identifier] = ACTIONS(331),
    [sym_comment] = ACTIONS(49),
  },
  [982] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(977),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(977),
    [anon_sym_LPAREN] = ACTIONS(975),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(977),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(977),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(977),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(977),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(977),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(977),
    [sym_preproc_directive] = ACTIONS(977),
    [anon_sym_typedef] = ACTIONS(977),
    [anon_sym_extern] = ACTIONS(977),
    [anon_sym_STAR] = ACTIONS(975),
    [anon_sym_static] = ACTIONS(977),
    [anon_sym_register] = ACTIONS(977),
    [anon_sym_inline] = ACTIONS(977),
    [anon_sym_const] = ACTIONS(977),
    [anon_sym_restrict] = ACTIONS(977),
    [anon_sym_volatile] = ACTIONS(977),
    [anon_sym__Atomic] = ACTIONS(977),
    [anon_sym_mutable] = ACTIONS(977),
    [anon_sym_explicit] = ACTIONS(977),
    [anon_sym_constexpr] = ACTIONS(977),
    [anon_sym_unsigned] = ACTIONS(977),
    [anon_sym_long] = ACTIONS(977),
    [anon_sym_short] = ACTIONS(977),
    [sym_primitive_type] = ACTIONS(977),
    [anon_sym_enum] = ACTIONS(977),
    [anon_sym_struct] = ACTIONS(977),
    [anon_sym_union] = ACTIONS(977),
    [anon_sym_AMP] = ACTIONS(977),
    [anon_sym_AMP_AMP] = ACTIONS(975),
    [anon_sym_TILDE] = ACTIONS(975),
    [sym_identifier] = ACTIONS(977),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(977),
    [sym_auto] = ACTIONS(977),
    [anon_sym_typename] = ACTIONS(977),
    [anon_sym_template] = ACTIONS(977),
    [anon_sym_namespace] = ACTIONS(977),
    [anon_sym_using] = ACTIONS(977),
    [anon_sym_COLON_COLON] = ACTIONS(975),
    [sym_operator_name] = ACTIONS(975),
  },
  [983] = {
    [sym__declarator] = STATE(478),
    [sym_pointer_declarator] = STATE(478),
    [sym_function_declarator] = STATE(478),
    [sym_array_declarator] = STATE(478),
    [sym_init_declarator] = STATE(479),
    [sym_reference_declarator] = STATE(478),
    [sym_template_type] = STATE(46),
    [sym_template_function] = STATE(478),
    [sym_destructor_name] = STATE(478),
    [sym_scoped_identifier] = STATE(33),
    [sym_scoped_type_identifier] = STATE(47),
    [sym_scoped_namespace_identifier] = STATE(46),
    [anon_sym_LPAREN] = ACTIONS(11),
    [anon_sym_STAR] = ACTIONS(196),
    [anon_sym_AMP] = ACTIONS(526),
    [anon_sym_AMP_AMP] = ACTIONS(528),
    [anon_sym_TILDE] = ACTIONS(45),
    [sym_identifier] = ACTIONS(75),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(77),
    [sym_operator_name] = ACTIONS(913),
  },
  [984] = {
    [sym_parameter_list] = STATE(299),
    [anon_sym_LPAREN] = ACTIONS(206),
    [anon_sym_SEMI] = ACTIONS(3467),
    [anon_sym_LBRACK] = ACTIONS(208),
    [sym_comment] = ACTIONS(49),
  },
  [985] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1192),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1192),
    [anon_sym_LPAREN] = ACTIONS(1190),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1192),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(1192),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1192),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1192),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(1192),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(1192),
    [sym_preproc_directive] = ACTIONS(1192),
    [anon_sym_typedef] = ACTIONS(1192),
    [anon_sym_extern] = ACTIONS(1192),
    [anon_sym_STAR] = ACTIONS(1190),
    [anon_sym_static] = ACTIONS(1192),
    [anon_sym_register] = ACTIONS(1192),
    [anon_sym_inline] = ACTIONS(1192),
    [anon_sym_const] = ACTIONS(1192),
    [anon_sym_restrict] = ACTIONS(1192),
    [anon_sym_volatile] = ACTIONS(1192),
    [anon_sym__Atomic] = ACTIONS(1192),
    [anon_sym_mutable] = ACTIONS(1192),
    [anon_sym_explicit] = ACTIONS(1192),
    [anon_sym_constexpr] = ACTIONS(1192),
    [anon_sym_unsigned] = ACTIONS(1192),
    [anon_sym_long] = ACTIONS(1192),
    [anon_sym_short] = ACTIONS(1192),
    [sym_primitive_type] = ACTIONS(1192),
    [anon_sym_enum] = ACTIONS(1192),
    [anon_sym_struct] = ACTIONS(1192),
    [anon_sym_union] = ACTIONS(1192),
    [anon_sym_AMP] = ACTIONS(1192),
    [anon_sym_AMP_AMP] = ACTIONS(1190),
    [anon_sym_TILDE] = ACTIONS(1190),
    [sym_identifier] = ACTIONS(1192),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(1192),
    [sym_auto] = ACTIONS(1192),
    [anon_sym_typename] = ACTIONS(1192),
    [anon_sym_template] = ACTIONS(1192),
    [anon_sym_namespace] = ACTIONS(1192),
    [anon_sym_using] = ACTIONS(1192),
    [anon_sym_COLON_COLON] = ACTIONS(1190),
    [sym_operator_name] = ACTIONS(1190),
  },
  [986] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1200),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1200),
    [anon_sym_LPAREN] = ACTIONS(1198),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1200),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(1200),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1200),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1200),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(1200),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(1200),
    [sym_preproc_directive] = ACTIONS(1200),
    [anon_sym_typedef] = ACTIONS(1200),
    [anon_sym_extern] = ACTIONS(1200),
    [anon_sym_STAR] = ACTIONS(1198),
    [anon_sym_static] = ACTIONS(1200),
    [anon_sym_register] = ACTIONS(1200),
    [anon_sym_inline] = ACTIONS(1200),
    [anon_sym_const] = ACTIONS(1200),
    [anon_sym_restrict] = ACTIONS(1200),
    [anon_sym_volatile] = ACTIONS(1200),
    [anon_sym__Atomic] = ACTIONS(1200),
    [anon_sym_mutable] = ACTIONS(1200),
    [anon_sym_explicit] = ACTIONS(1200),
    [anon_sym_constexpr] = ACTIONS(1200),
    [anon_sym_unsigned] = ACTIONS(1200),
    [anon_sym_long] = ACTIONS(1200),
    [anon_sym_short] = ACTIONS(1200),
    [sym_primitive_type] = ACTIONS(1200),
    [anon_sym_enum] = ACTIONS(1200),
    [anon_sym_struct] = ACTIONS(1200),
    [anon_sym_union] = ACTIONS(1200),
    [anon_sym_AMP] = ACTIONS(1200),
    [anon_sym_AMP_AMP] = ACTIONS(1198),
    [anon_sym_TILDE] = ACTIONS(1198),
    [sym_identifier] = ACTIONS(1200),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(1200),
    [sym_auto] = ACTIONS(1200),
    [anon_sym_typename] = ACTIONS(1200),
    [anon_sym_template] = ACTIONS(1200),
    [anon_sym_namespace] = ACTIONS(1200),
    [anon_sym_using] = ACTIONS(1200),
    [anon_sym_COLON_COLON] = ACTIONS(1198),
    [sym_operator_name] = ACTIONS(1198),
  },
  [987] = {
    [sym__declarator] = STATE(478),
    [sym_pointer_declarator] = STATE(478),
    [sym_function_declarator] = STATE(478),
    [sym_array_declarator] = STATE(478),
    [sym_init_declarator] = STATE(479),
    [sym_reference_declarator] = STATE(478),
    [sym_template_type] = STATE(46),
    [sym_template_function] = STATE(478),
    [sym_destructor_name] = STATE(478),
    [sym_scoped_identifier] = STATE(33),
    [sym_scoped_type_identifier] = STATE(47),
    [sym_scoped_namespace_identifier] = STATE(46),
    [anon_sym_LPAREN] = ACTIONS(11),
    [anon_sym_SEMI] = ACTIONS(911),
    [anon_sym_STAR] = ACTIONS(196),
    [anon_sym_AMP] = ACTIONS(526),
    [anon_sym_AMP_AMP] = ACTIONS(528),
    [anon_sym_TILDE] = ACTIONS(45),
    [sym_identifier] = ACTIONS(75),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(77),
    [sym_operator_name] = ACTIONS(913),
  },
  [988] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1219),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1219),
    [anon_sym_LPAREN] = ACTIONS(1217),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1219),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(1219),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1219),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1219),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(1219),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(1219),
    [sym_preproc_directive] = ACTIONS(1219),
    [anon_sym_typedef] = ACTIONS(1219),
    [anon_sym_extern] = ACTIONS(1219),
    [anon_sym_STAR] = ACTIONS(1217),
    [anon_sym_static] = ACTIONS(1219),
    [anon_sym_register] = ACTIONS(1219),
    [anon_sym_inline] = ACTIONS(1219),
    [anon_sym_const] = ACTIONS(1219),
    [anon_sym_restrict] = ACTIONS(1219),
    [anon_sym_volatile] = ACTIONS(1219),
    [anon_sym__Atomic] = ACTIONS(1219),
    [anon_sym_mutable] = ACTIONS(1219),
    [anon_sym_explicit] = ACTIONS(1219),
    [anon_sym_constexpr] = ACTIONS(1219),
    [anon_sym_unsigned] = ACTIONS(1219),
    [anon_sym_long] = ACTIONS(1219),
    [anon_sym_short] = ACTIONS(1219),
    [sym_primitive_type] = ACTIONS(1219),
    [anon_sym_enum] = ACTIONS(1219),
    [anon_sym_struct] = ACTIONS(1219),
    [anon_sym_union] = ACTIONS(1219),
    [anon_sym_AMP] = ACTIONS(1219),
    [anon_sym_AMP_AMP] = ACTIONS(1217),
    [anon_sym_TILDE] = ACTIONS(1217),
    [sym_identifier] = ACTIONS(1219),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(1219),
    [sym_auto] = ACTIONS(1219),
    [anon_sym_typename] = ACTIONS(1219),
    [anon_sym_template] = ACTIONS(1219),
    [anon_sym_namespace] = ACTIONS(1219),
    [anon_sym_using] = ACTIONS(1219),
    [anon_sym_COLON_COLON] = ACTIONS(1217),
    [sym_operator_name] = ACTIONS(1217),
  },
  [989] = {
    [sym_preproc_include] = STATE(634),
    [sym_preproc_def] = STATE(634),
    [sym_preproc_function_def] = STATE(634),
    [sym_preproc_call] = STATE(634),
    [sym_preproc_if] = STATE(634),
    [sym_preproc_ifdef] = STATE(634),
    [sym_function_definition] = STATE(634),
    [sym_declaration] = STATE(634),
    [sym_type_definition] = STATE(634),
    [sym__declaration_specifiers] = STATE(27),
    [sym_linkage_specification] = STATE(634),
    [sym__declarator] = STATE(28),
    [sym_pointer_declarator] = STATE(28),
    [sym_function_declarator] = STATE(29),
    [sym_array_declarator] = STATE(28),
    [sym_storage_class_specifier] = STATE(37),
    [sym_type_qualifier] = STATE(37),
    [sym__type_specifier] = STATE(30),
    [sym_sized_type_specifier] = STATE(30),
    [sym_enum_specifier] = STATE(30),
    [sym_struct_specifier] = STATE(30),
    [sym_union_specifier] = STATE(30),
    [sym__empty_declaration] = STATE(634),
    [sym_macro_type_specifier] = STATE(30),
    [sym_class_specifier] = STATE(30),
    [sym_dependent_type] = STATE(30),
    [sym_structured_binding_declaration] = STATE(634),
    [sym_template_declaration] = STATE(634),
    [sym_template_instantiation] = STATE(634),
    [sym_constructor_or_destructor_definition] = STATE(31),
    [sym_reference_declarator] = STATE(28),
    [sym_template_type] = STATE(32),
    [sym_template_function] = STATE(28),
    [sym_namespace_definition] = STATE(634),
    [sym_using_declaration] = STATE(634),
    [sym_alias_declaration] = STATE(634),
    [sym_destructor_name] = STATE(28),
    [sym_scoped_identifier] = STATE(33),
    [sym_scoped_type_identifier] = STATE(34),
    [sym_scoped_namespace_identifier] = STATE(35),
    [aux_sym_translation_unit_repeat1] = STATE(634),
    [aux_sym__declaration_specifiers_repeat1] = STATE(37),
    [aux_sym_sized_type_specifier_repeat1] = STATE(38),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(7),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(11),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(13),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(15),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(17),
    [sym_preproc_directive] = ACTIONS(19),
    [anon_sym_typedef] = ACTIONS(21),
    [anon_sym_extern] = ACTIONS(23),
    [anon_sym_RBRACE] = ACTIONS(3469),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_static] = ACTIONS(27),
    [anon_sym_register] = ACTIONS(27),
    [anon_sym_inline] = ACTIONS(27),
    [anon_sym_const] = ACTIONS(29),
    [anon_sym_restrict] = ACTIONS(29),
    [anon_sym_volatile] = ACTIONS(29),
    [anon_sym__Atomic] = ACTIONS(29),
    [anon_sym_mutable] = ACTIONS(29),
    [anon_sym_explicit] = ACTIONS(29),
    [anon_sym_constexpr] = ACTIONS(29),
    [anon_sym_unsigned] = ACTIONS(31),
    [anon_sym_long] = ACTIONS(31),
    [anon_sym_short] = ACTIONS(31),
    [sym_primitive_type] = ACTIONS(33),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_union] = ACTIONS(39),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(45),
    [sym_identifier] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(51),
    [sym_auto] = ACTIONS(33),
    [anon_sym_typename] = ACTIONS(53),
    [anon_sym_template] = ACTIONS(55),
    [anon_sym_namespace] = ACTIONS(57),
    [anon_sym_using] = ACTIONS(59),
    [anon_sym_COLON_COLON] = ACTIONS(61),
    [sym_operator_name] = ACTIONS(63),
  },
  [990] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1225),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1225),
    [anon_sym_LPAREN] = ACTIONS(1223),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1225),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(1225),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1225),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1225),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(1225),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(1225),
    [sym_preproc_directive] = ACTIONS(1225),
    [anon_sym_typedef] = ACTIONS(1225),
    [anon_sym_extern] = ACTIONS(1225),
    [anon_sym_STAR] = ACTIONS(1223),
    [anon_sym_static] = ACTIONS(1225),
    [anon_sym_register] = ACTIONS(1225),
    [anon_sym_inline] = ACTIONS(1225),
    [anon_sym_const] = ACTIONS(1225),
    [anon_sym_restrict] = ACTIONS(1225),
    [anon_sym_volatile] = ACTIONS(1225),
    [anon_sym__Atomic] = ACTIONS(1225),
    [anon_sym_mutable] = ACTIONS(1225),
    [anon_sym_explicit] = ACTIONS(1225),
    [anon_sym_constexpr] = ACTIONS(1225),
    [anon_sym_unsigned] = ACTIONS(1225),
    [anon_sym_long] = ACTIONS(1225),
    [anon_sym_short] = ACTIONS(1225),
    [sym_primitive_type] = ACTIONS(1225),
    [anon_sym_enum] = ACTIONS(1225),
    [anon_sym_struct] = ACTIONS(1225),
    [anon_sym_union] = ACTIONS(1225),
    [anon_sym_AMP] = ACTIONS(1225),
    [anon_sym_AMP_AMP] = ACTIONS(1223),
    [anon_sym_TILDE] = ACTIONS(1223),
    [sym_identifier] = ACTIONS(1225),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(1225),
    [sym_auto] = ACTIONS(1225),
    [anon_sym_typename] = ACTIONS(1225),
    [anon_sym_template] = ACTIONS(1225),
    [anon_sym_namespace] = ACTIONS(1225),
    [anon_sym_using] = ACTIONS(1225),
    [anon_sym_COLON_COLON] = ACTIONS(1223),
    [sym_operator_name] = ACTIONS(1223),
  },
  [991] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1229),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1229),
    [anon_sym_LPAREN] = ACTIONS(1227),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1229),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(1229),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1229),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1229),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(1229),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(1229),
    [sym_preproc_directive] = ACTIONS(1229),
    [anon_sym_typedef] = ACTIONS(1229),
    [anon_sym_extern] = ACTIONS(1229),
    [anon_sym_STAR] = ACTIONS(1227),
    [anon_sym_static] = ACTIONS(1229),
    [anon_sym_register] = ACTIONS(1229),
    [anon_sym_inline] = ACTIONS(1229),
    [anon_sym_const] = ACTIONS(1229),
    [anon_sym_restrict] = ACTIONS(1229),
    [anon_sym_volatile] = ACTIONS(1229),
    [anon_sym__Atomic] = ACTIONS(1229),
    [anon_sym_mutable] = ACTIONS(1229),
    [anon_sym_explicit] = ACTIONS(1229),
    [anon_sym_constexpr] = ACTIONS(1229),
    [anon_sym_unsigned] = ACTIONS(1229),
    [anon_sym_long] = ACTIONS(1229),
    [anon_sym_short] = ACTIONS(1229),
    [sym_primitive_type] = ACTIONS(1229),
    [anon_sym_enum] = ACTIONS(1229),
    [anon_sym_struct] = ACTIONS(1229),
    [anon_sym_union] = ACTIONS(1229),
    [anon_sym_AMP] = ACTIONS(1229),
    [anon_sym_AMP_AMP] = ACTIONS(1227),
    [anon_sym_TILDE] = ACTIONS(1227),
    [sym_identifier] = ACTIONS(1229),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(1229),
    [sym_auto] = ACTIONS(1229),
    [anon_sym_typename] = ACTIONS(1229),
    [anon_sym_template] = ACTIONS(1229),
    [anon_sym_namespace] = ACTIONS(1229),
    [anon_sym_using] = ACTIONS(1229),
    [anon_sym_COLON_COLON] = ACTIONS(1227),
    [sym_operator_name] = ACTIONS(1227),
  },
  [992] = {
    [sym_type_qualifier] = STATE(638),
    [sym__type_specifier] = STATE(636),
    [sym_sized_type_specifier] = STATE(636),
    [sym_enum_specifier] = STATE(636),
    [sym_struct_specifier] = STATE(636),
    [sym_union_specifier] = STATE(636),
    [sym_type_descriptor] = STATE(1606),
    [sym_macro_type_specifier] = STATE(636),
    [sym_class_specifier] = STATE(636),
    [sym_dependent_type] = STATE(636),
    [sym_template_type] = STATE(62),
    [sym_scoped_type_identifier] = STATE(34),
    [sym_scoped_namespace_identifier] = STATE(64),
    [aux_sym_type_definition_repeat1] = STATE(638),
    [aux_sym_sized_type_specifier_repeat1] = STATE(639),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_restrict] = ACTIONS(93),
    [anon_sym_volatile] = ACTIONS(93),
    [anon_sym__Atomic] = ACTIONS(93),
    [anon_sym_mutable] = ACTIONS(93),
    [anon_sym_explicit] = ACTIONS(93),
    [anon_sym_constexpr] = ACTIONS(93),
    [anon_sym_unsigned] = ACTIONS(1231),
    [anon_sym_long] = ACTIONS(1231),
    [anon_sym_short] = ACTIONS(1231),
    [sym_primitive_type] = ACTIONS(1233),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(428),
    [anon_sym_union] = ACTIONS(430),
    [sym_identifier] = ACTIONS(434),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(436),
    [sym_auto] = ACTIONS(1233),
    [anon_sym_typename] = ACTIONS(1235),
    [anon_sym_COLON_COLON] = ACTIONS(111),
  },
  [993] = {
    [sym_template_argument_list] = STATE(203),
    [anon_sym_SEMI] = ACTIONS(3471),
    [anon_sym_LT] = ACTIONS(146),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(501),
  },
  [994] = {
    [anon_sym_SEMI] = ACTIONS(3471),
    [sym_comment] = ACTIONS(49),
  },
  [995] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1263),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1263),
    [anon_sym_LPAREN] = ACTIONS(1261),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1263),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(1263),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1263),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1263),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(1263),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(1263),
    [sym_preproc_directive] = ACTIONS(1263),
    [anon_sym_typedef] = ACTIONS(1263),
    [anon_sym_extern] = ACTIONS(1263),
    [anon_sym_STAR] = ACTIONS(1261),
    [anon_sym_static] = ACTIONS(1263),
    [anon_sym_register] = ACTIONS(1263),
    [anon_sym_inline] = ACTIONS(1263),
    [anon_sym_const] = ACTIONS(1263),
    [anon_sym_restrict] = ACTIONS(1263),
    [anon_sym_volatile] = ACTIONS(1263),
    [anon_sym__Atomic] = ACTIONS(1263),
    [anon_sym_mutable] = ACTIONS(1263),
    [anon_sym_explicit] = ACTIONS(1263),
    [anon_sym_constexpr] = ACTIONS(1263),
    [anon_sym_unsigned] = ACTIONS(1263),
    [anon_sym_long] = ACTIONS(1263),
    [anon_sym_short] = ACTIONS(1263),
    [sym_primitive_type] = ACTIONS(1263),
    [anon_sym_enum] = ACTIONS(1263),
    [anon_sym_struct] = ACTIONS(1263),
    [anon_sym_union] = ACTIONS(1263),
    [anon_sym_AMP] = ACTIONS(1263),
    [anon_sym_AMP_AMP] = ACTIONS(1261),
    [anon_sym_TILDE] = ACTIONS(1261),
    [sym_identifier] = ACTIONS(1263),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(1263),
    [sym_auto] = ACTIONS(1263),
    [anon_sym_typename] = ACTIONS(1263),
    [anon_sym_template] = ACTIONS(1263),
    [anon_sym_namespace] = ACTIONS(1263),
    [anon_sym_using] = ACTIONS(1263),
    [anon_sym_COLON_COLON] = ACTIONS(1261),
    [sym_operator_name] = ACTIONS(1261),
  },
  [996] = {
    [sym_preproc_include] = STATE(1004),
    [sym_preproc_def] = STATE(1004),
    [sym_preproc_function_def] = STATE(1004),
    [sym_preproc_call] = STATE(1004),
    [sym_preproc_if_in_compound_statement] = STATE(410),
    [sym_preproc_ifdef_in_compound_statement] = STATE(411),
    [sym_declaration] = STATE(1004),
    [sym_type_definition] = STATE(1004),
    [sym__declaration_specifiers] = STATE(412),
    [sym_compound_statement] = STATE(1004),
    [sym_storage_class_specifier] = STATE(419),
    [sym_type_qualifier] = STATE(419),
    [sym__type_specifier] = STATE(30),
    [sym_sized_type_specifier] = STATE(30),
    [sym_enum_specifier] = STATE(30),
    [sym_struct_specifier] = STATE(30),
    [sym_union_specifier] = STATE(30),
    [sym_labeled_statement] = STATE(1004),
    [sym_expression_statement] = STATE(1004),
    [sym_if_statement] = STATE(1004),
    [sym_switch_statement] = STATE(1004),
    [sym_case_statement] = STATE(1004),
    [sym_while_statement] = STATE(1004),
    [sym_do_statement] = STATE(1004),
    [sym_for_statement] = STATE(1004),
    [sym_return_statement] = STATE(1004),
    [sym_break_statement] = STATE(1004),
    [sym_continue_statement] = STATE(1004),
    [sym_goto_statement] = STATE(1004),
    [sym__expression] = STATE(669),
    [sym_comma_expression] = STATE(414),
    [sym_conditional_expression] = STATE(669),
    [sym_assignment_expression] = STATE(669),
    [sym_pointer_expression] = STATE(669),
    [sym_logical_expression] = STATE(669),
    [sym_bitwise_expression] = STATE(669),
    [sym_equality_expression] = STATE(669),
    [sym_relational_expression] = STATE(669),
    [sym_shift_expression] = STATE(669),
    [sym_math_expression] = STATE(669),
    [sym_cast_expression] = STATE(669),
    [sym_sizeof_expression] = STATE(669),
    [sym_subscript_expression] = STATE(669),
    [sym_call_expression] = STATE(669),
    [sym_field_expression] = STATE(669),
    [sym_compound_literal_expression] = STATE(669),
    [sym_parenthesized_expression] = STATE(669),
    [sym_initializer_list] = STATE(670),
    [sym_initializer_pair] = STATE(670),
    [sym_subscript_designator] = STATE(671),
    [sym_field_designator] = STATE(671),
    [sym_concatenated_string] = STATE(669),
    [sym__empty_declaration] = STATE(1004),
    [sym_macro_type_specifier] = STATE(30),
    [sym_class_specifier] = STATE(30),
    [sym_dependent_type] = STATE(30),
    [sym_structured_binding_declaration] = STATE(1004),
    [sym_template_type] = STATE(415),
    [sym_template_function] = STATE(669),
    [sym_for_range_loop] = STATE(1004),
    [sym_new_expression] = STATE(669),
    [sym_delete_expression] = STATE(669),
    [sym_lambda_expression] = STATE(669),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(416),
    [sym_scoped_namespace_identifier] = STATE(417),
    [aux_sym_preproc_if_in_compound_statement_repeat1] = STATE(1004),
    [aux_sym__declaration_specifiers_repeat1] = STATE(419),
    [aux_sym_sized_type_specifier_repeat1] = STATE(38),
    [aux_sym_initializer_pair_repeat1] = STATE(671),
    [sym_raw_string_literal] = ACTIONS(1265),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(622),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(624),
    [anon_sym_LPAREN] = ACTIONS(1267),
    [anon_sym_COMMA] = ACTIONS(1269),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(628),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(630),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(632),
    [sym_preproc_directive] = ACTIONS(634),
    [anon_sym_SEMI] = ACTIONS(636),
    [anon_sym_typedef] = ACTIONS(638),
    [anon_sym_extern] = ACTIONS(154),
    [anon_sym_LBRACE] = ACTIONS(1271),
    [anon_sym_RBRACE] = ACTIONS(3473),
    [anon_sym_STAR] = ACTIONS(1275),
    [anon_sym_LBRACK] = ACTIONS(1277),
    [anon_sym_static] = ACTIONS(154),
    [anon_sym_register] = ACTIONS(154),
    [anon_sym_inline] = ACTIONS(154),
    [anon_sym_const] = ACTIONS(158),
    [anon_sym_restrict] = ACTIONS(158),
    [anon_sym_volatile] = ACTIONS(158),
    [anon_sym__Atomic] = ACTIONS(158),
    [anon_sym_mutable] = ACTIONS(158),
    [anon_sym_explicit] = ACTIONS(158),
    [anon_sym_constexpr] = ACTIONS(158),
    [anon_sym_unsigned] = ACTIONS(31),
    [anon_sym_long] = ACTIONS(31),
    [anon_sym_short] = ACTIONS(31),
    [sym_primitive_type] = ACTIONS(33),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_union] = ACTIONS(39),
    [anon_sym_if] = ACTIONS(646),
    [anon_sym_switch] = ACTIONS(648),
    [anon_sym_case] = ACTIONS(650),
    [anon_sym_default] = ACTIONS(652),
    [anon_sym_while] = ACTIONS(654),
    [anon_sym_do] = ACTIONS(656),
    [anon_sym_for] = ACTIONS(658),
    [anon_sym_return] = ACTIONS(660),
    [anon_sym_break] = ACTIONS(662),
    [anon_sym_continue] = ACTIONS(664),
    [anon_sym_goto] = ACTIONS(666),
    [anon_sym_AMP] = ACTIONS(1275),
    [anon_sym_BANG] = ACTIONS(1279),
    [anon_sym_TILDE] = ACTIONS(1281),
    [anon_sym_PLUS] = ACTIONS(1283),
    [anon_sym_DASH] = ACTIONS(1283),
    [anon_sym_DASH_DASH] = ACTIONS(1285),
    [anon_sym_PLUS_PLUS] = ACTIONS(1285),
    [anon_sym_sizeof] = ACTIONS(1287),
    [anon_sym_DOT] = ACTIONS(1289),
    [sym_number_literal] = ACTIONS(1265),
    [sym_char_literal] = ACTIONS(1265),
    [sym_string_literal] = ACTIONS(1291),
    [sym_true] = ACTIONS(1293),
    [sym_false] = ACTIONS(1293),
    [sym_null] = ACTIONS(1293),
    [sym_identifier] = ACTIONS(682),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(51),
    [sym_auto] = ACTIONS(33),
    [anon_sym_typename] = ACTIONS(53),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1295),
    [anon_sym_delete] = ACTIONS(1297),
    [sym_nullptr] = ACTIONS(1293),
  },
  [997] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1307),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1307),
    [anon_sym_LPAREN] = ACTIONS(1305),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1307),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(1307),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1307),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1307),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(1307),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(1307),
    [sym_preproc_directive] = ACTIONS(1307),
    [anon_sym_typedef] = ACTIONS(1307),
    [anon_sym_extern] = ACTIONS(1307),
    [anon_sym_STAR] = ACTIONS(1305),
    [anon_sym_static] = ACTIONS(1307),
    [anon_sym_register] = ACTIONS(1307),
    [anon_sym_inline] = ACTIONS(1307),
    [anon_sym_const] = ACTIONS(1307),
    [anon_sym_restrict] = ACTIONS(1307),
    [anon_sym_volatile] = ACTIONS(1307),
    [anon_sym__Atomic] = ACTIONS(1307),
    [anon_sym_mutable] = ACTIONS(1307),
    [anon_sym_explicit] = ACTIONS(1307),
    [anon_sym_constexpr] = ACTIONS(1307),
    [anon_sym_unsigned] = ACTIONS(1307),
    [anon_sym_long] = ACTIONS(1307),
    [anon_sym_short] = ACTIONS(1307),
    [sym_primitive_type] = ACTIONS(1307),
    [anon_sym_enum] = ACTIONS(1307),
    [anon_sym_struct] = ACTIONS(1307),
    [anon_sym_union] = ACTIONS(1307),
    [anon_sym_AMP] = ACTIONS(1307),
    [anon_sym_AMP_AMP] = ACTIONS(1305),
    [anon_sym_TILDE] = ACTIONS(1305),
    [sym_identifier] = ACTIONS(1307),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(1307),
    [sym_auto] = ACTIONS(1307),
    [anon_sym_typename] = ACTIONS(1307),
    [anon_sym_template] = ACTIONS(1307),
    [anon_sym_namespace] = ACTIONS(1307),
    [anon_sym_using] = ACTIONS(1307),
    [anon_sym_COLON_COLON] = ACTIONS(1305),
    [sym_operator_name] = ACTIONS(1305),
  },
  [998] = {
    [aux_sym_declaration_repeat1] = STATE(678),
    [anon_sym_COMMA] = ACTIONS(538),
    [anon_sym_SEMI] = ACTIONS(3475),
    [sym_comment] = ACTIONS(49),
  },
  [999] = {
    [sym__expression] = STATE(1610),
    [sym_conditional_expression] = STATE(1610),
    [sym_assignment_expression] = STATE(1610),
    [sym_pointer_expression] = STATE(1610),
    [sym_logical_expression] = STATE(1610),
    [sym_bitwise_expression] = STATE(1610),
    [sym_equality_expression] = STATE(1610),
    [sym_relational_expression] = STATE(1610),
    [sym_shift_expression] = STATE(1610),
    [sym_math_expression] = STATE(1610),
    [sym_cast_expression] = STATE(1610),
    [sym_sizeof_expression] = STATE(1610),
    [sym_subscript_expression] = STATE(1610),
    [sym_call_expression] = STATE(1610),
    [sym_field_expression] = STATE(1610),
    [sym_compound_literal_expression] = STATE(1610),
    [sym_parenthesized_expression] = STATE(1610),
    [sym_initializer_list] = STATE(1611),
    [sym_concatenated_string] = STATE(1610),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(1610),
    [sym_new_expression] = STATE(1610),
    [sym_delete_expression] = STATE(1610),
    [sym_lambda_expression] = STATE(1610),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(3477),
    [anon_sym_LPAREN] = ACTIONS(1347),
    [anon_sym_LBRACE] = ACTIONS(548),
    [anon_sym_STAR] = ACTIONS(1349),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_AMP] = ACTIONS(1349),
    [anon_sym_BANG] = ACTIONS(1351),
    [anon_sym_TILDE] = ACTIONS(1353),
    [anon_sym_PLUS] = ACTIONS(1355),
    [anon_sym_DASH] = ACTIONS(1355),
    [anon_sym_DASH_DASH] = ACTIONS(1357),
    [anon_sym_PLUS_PLUS] = ACTIONS(1357),
    [anon_sym_sizeof] = ACTIONS(1359),
    [sym_number_literal] = ACTIONS(3477),
    [sym_char_literal] = ACTIONS(3477),
    [sym_string_literal] = ACTIONS(1361),
    [sym_true] = ACTIONS(3479),
    [sym_false] = ACTIONS(3479),
    [sym_null] = ACTIONS(3479),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1365),
    [anon_sym_delete] = ACTIONS(1367),
    [sym_nullptr] = ACTIONS(3479),
  },
  [1000] = {
    [anon_sym_SEMI] = ACTIONS(3481),
    [sym_comment] = ACTIONS(49),
  },
  [1001] = {
    [sym__expression] = STATE(1613),
    [sym_conditional_expression] = STATE(1613),
    [sym_assignment_expression] = STATE(1613),
    [sym_pointer_expression] = STATE(1613),
    [sym_logical_expression] = STATE(1613),
    [sym_bitwise_expression] = STATE(1613),
    [sym_equality_expression] = STATE(1613),
    [sym_relational_expression] = STATE(1613),
    [sym_shift_expression] = STATE(1613),
    [sym_math_expression] = STATE(1613),
    [sym_cast_expression] = STATE(1613),
    [sym_sizeof_expression] = STATE(1613),
    [sym_subscript_expression] = STATE(1613),
    [sym_call_expression] = STATE(1613),
    [sym_field_expression] = STATE(1613),
    [sym_compound_literal_expression] = STATE(1613),
    [sym_parenthesized_expression] = STATE(1613),
    [sym_initializer_list] = STATE(1614),
    [sym_concatenated_string] = STATE(1613),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(1613),
    [sym_new_expression] = STATE(1613),
    [sym_delete_expression] = STATE(1613),
    [sym_lambda_expression] = STATE(1613),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(3483),
    [anon_sym_LPAREN] = ACTIONS(1347),
    [anon_sym_LBRACE] = ACTIONS(548),
    [anon_sym_STAR] = ACTIONS(1349),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_AMP] = ACTIONS(1349),
    [anon_sym_BANG] = ACTIONS(1351),
    [anon_sym_TILDE] = ACTIONS(1353),
    [anon_sym_PLUS] = ACTIONS(1355),
    [anon_sym_DASH] = ACTIONS(1355),
    [anon_sym_DASH_DASH] = ACTIONS(1357),
    [anon_sym_PLUS_PLUS] = ACTIONS(1357),
    [anon_sym_sizeof] = ACTIONS(1359),
    [sym_number_literal] = ACTIONS(3483),
    [sym_char_literal] = ACTIONS(3483),
    [sym_string_literal] = ACTIONS(1361),
    [sym_true] = ACTIONS(3485),
    [sym_false] = ACTIONS(3485),
    [sym_null] = ACTIONS(3485),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1365),
    [anon_sym_delete] = ACTIONS(1367),
    [sym_nullptr] = ACTIONS(3485),
  },
  [1002] = {
    [anon_sym_SEMI] = ACTIONS(3487),
    [sym_comment] = ACTIONS(49),
  },
  [1003] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1624),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1624),
    [anon_sym_LPAREN] = ACTIONS(1622),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1624),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(1624),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1624),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1624),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(1624),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(1624),
    [sym_preproc_directive] = ACTIONS(1624),
    [anon_sym_typedef] = ACTIONS(1624),
    [anon_sym_extern] = ACTIONS(1624),
    [anon_sym_STAR] = ACTIONS(1622),
    [anon_sym_static] = ACTIONS(1624),
    [anon_sym_register] = ACTIONS(1624),
    [anon_sym_inline] = ACTIONS(1624),
    [anon_sym_const] = ACTIONS(1624),
    [anon_sym_restrict] = ACTIONS(1624),
    [anon_sym_volatile] = ACTIONS(1624),
    [anon_sym__Atomic] = ACTIONS(1624),
    [anon_sym_mutable] = ACTIONS(1624),
    [anon_sym_explicit] = ACTIONS(1624),
    [anon_sym_constexpr] = ACTIONS(1624),
    [anon_sym_unsigned] = ACTIONS(1624),
    [anon_sym_long] = ACTIONS(1624),
    [anon_sym_short] = ACTIONS(1624),
    [sym_primitive_type] = ACTIONS(1624),
    [anon_sym_enum] = ACTIONS(1624),
    [anon_sym_struct] = ACTIONS(1624),
    [anon_sym_union] = ACTIONS(1624),
    [anon_sym_AMP] = ACTIONS(1624),
    [anon_sym_AMP_AMP] = ACTIONS(1622),
    [anon_sym_TILDE] = ACTIONS(1622),
    [sym_identifier] = ACTIONS(1624),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(1624),
    [sym_auto] = ACTIONS(1624),
    [anon_sym_typename] = ACTIONS(1624),
    [anon_sym_template] = ACTIONS(1624),
    [anon_sym_namespace] = ACTIONS(1624),
    [anon_sym_using] = ACTIONS(1624),
    [anon_sym_COLON_COLON] = ACTIONS(1622),
    [sym_operator_name] = ACTIONS(1622),
  },
  [1004] = {
    [sym_preproc_include] = STATE(913),
    [sym_preproc_def] = STATE(913),
    [sym_preproc_function_def] = STATE(913),
    [sym_preproc_call] = STATE(913),
    [sym_preproc_if_in_compound_statement] = STATE(410),
    [sym_preproc_ifdef_in_compound_statement] = STATE(411),
    [sym_declaration] = STATE(913),
    [sym_type_definition] = STATE(913),
    [sym__declaration_specifiers] = STATE(412),
    [sym_compound_statement] = STATE(913),
    [sym_storage_class_specifier] = STATE(419),
    [sym_type_qualifier] = STATE(419),
    [sym__type_specifier] = STATE(30),
    [sym_sized_type_specifier] = STATE(30),
    [sym_enum_specifier] = STATE(30),
    [sym_struct_specifier] = STATE(30),
    [sym_union_specifier] = STATE(30),
    [sym_labeled_statement] = STATE(913),
    [sym_expression_statement] = STATE(913),
    [sym_if_statement] = STATE(913),
    [sym_switch_statement] = STATE(913),
    [sym_case_statement] = STATE(913),
    [sym_while_statement] = STATE(913),
    [sym_do_statement] = STATE(913),
    [sym_for_statement] = STATE(913),
    [sym_return_statement] = STATE(913),
    [sym_break_statement] = STATE(913),
    [sym_continue_statement] = STATE(913),
    [sym_goto_statement] = STATE(913),
    [sym__expression] = STATE(413),
    [sym_comma_expression] = STATE(414),
    [sym_conditional_expression] = STATE(413),
    [sym_assignment_expression] = STATE(413),
    [sym_pointer_expression] = STATE(413),
    [sym_logical_expression] = STATE(413),
    [sym_bitwise_expression] = STATE(413),
    [sym_equality_expression] = STATE(413),
    [sym_relational_expression] = STATE(413),
    [sym_shift_expression] = STATE(413),
    [sym_math_expression] = STATE(413),
    [sym_cast_expression] = STATE(413),
    [sym_sizeof_expression] = STATE(413),
    [sym_subscript_expression] = STATE(413),
    [sym_call_expression] = STATE(413),
    [sym_field_expression] = STATE(413),
    [sym_compound_literal_expression] = STATE(413),
    [sym_parenthesized_expression] = STATE(413),
    [sym_concatenated_string] = STATE(413),
    [sym__empty_declaration] = STATE(913),
    [sym_macro_type_specifier] = STATE(30),
    [sym_class_specifier] = STATE(30),
    [sym_dependent_type] = STATE(30),
    [sym_structured_binding_declaration] = STATE(913),
    [sym_template_type] = STATE(415),
    [sym_template_function] = STATE(413),
    [sym_for_range_loop] = STATE(913),
    [sym_new_expression] = STATE(413),
    [sym_delete_expression] = STATE(413),
    [sym_lambda_expression] = STATE(413),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(416),
    [sym_scoped_namespace_identifier] = STATE(417),
    [aux_sym_preproc_if_in_compound_statement_repeat1] = STATE(913),
    [aux_sym__declaration_specifiers_repeat1] = STATE(419),
    [aux_sym_sized_type_specifier_repeat1] = STATE(38),
    [sym_raw_string_literal] = ACTIONS(620),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(622),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(624),
    [anon_sym_LPAREN] = ACTIONS(626),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(628),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(630),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(632),
    [sym_preproc_directive] = ACTIONS(634),
    [anon_sym_SEMI] = ACTIONS(636),
    [anon_sym_typedef] = ACTIONS(638),
    [anon_sym_extern] = ACTIONS(154),
    [anon_sym_LBRACE] = ACTIONS(640),
    [anon_sym_RBRACE] = ACTIONS(3489),
    [anon_sym_STAR] = ACTIONS(644),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_static] = ACTIONS(154),
    [anon_sym_register] = ACTIONS(154),
    [anon_sym_inline] = ACTIONS(154),
    [anon_sym_const] = ACTIONS(158),
    [anon_sym_restrict] = ACTIONS(158),
    [anon_sym_volatile] = ACTIONS(158),
    [anon_sym__Atomic] = ACTIONS(158),
    [anon_sym_mutable] = ACTIONS(158),
    [anon_sym_explicit] = ACTIONS(158),
    [anon_sym_constexpr] = ACTIONS(158),
    [anon_sym_unsigned] = ACTIONS(31),
    [anon_sym_long] = ACTIONS(31),
    [anon_sym_short] = ACTIONS(31),
    [sym_primitive_type] = ACTIONS(33),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_union] = ACTIONS(39),
    [anon_sym_if] = ACTIONS(646),
    [anon_sym_switch] = ACTIONS(648),
    [anon_sym_case] = ACTIONS(650),
    [anon_sym_default] = ACTIONS(652),
    [anon_sym_while] = ACTIONS(654),
    [anon_sym_do] = ACTIONS(656),
    [anon_sym_for] = ACTIONS(658),
    [anon_sym_return] = ACTIONS(660),
    [anon_sym_break] = ACTIONS(662),
    [anon_sym_continue] = ACTIONS(664),
    [anon_sym_goto] = ACTIONS(666),
    [anon_sym_AMP] = ACTIONS(644),
    [anon_sym_BANG] = ACTIONS(668),
    [anon_sym_TILDE] = ACTIONS(670),
    [anon_sym_PLUS] = ACTIONS(672),
    [anon_sym_DASH] = ACTIONS(672),
    [anon_sym_DASH_DASH] = ACTIONS(674),
    [anon_sym_PLUS_PLUS] = ACTIONS(674),
    [anon_sym_sizeof] = ACTIONS(676),
    [sym_number_literal] = ACTIONS(620),
    [sym_char_literal] = ACTIONS(620),
    [sym_string_literal] = ACTIONS(678),
    [sym_true] = ACTIONS(680),
    [sym_false] = ACTIONS(680),
    [sym_null] = ACTIONS(680),
    [sym_identifier] = ACTIONS(682),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(51),
    [sym_auto] = ACTIONS(33),
    [anon_sym_typename] = ACTIONS(53),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(684),
    [anon_sym_delete] = ACTIONS(686),
    [sym_nullptr] = ACTIONS(680),
  },
  [1005] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1790),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1790),
    [anon_sym_LPAREN] = ACTIONS(1788),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1790),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(1790),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1790),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1790),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(1790),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(1790),
    [sym_preproc_directive] = ACTIONS(1790),
    [anon_sym_typedef] = ACTIONS(1790),
    [anon_sym_extern] = ACTIONS(1790),
    [anon_sym_STAR] = ACTIONS(1788),
    [anon_sym_static] = ACTIONS(1790),
    [anon_sym_register] = ACTIONS(1790),
    [anon_sym_inline] = ACTIONS(1790),
    [anon_sym_const] = ACTIONS(1790),
    [anon_sym_restrict] = ACTIONS(1790),
    [anon_sym_volatile] = ACTIONS(1790),
    [anon_sym__Atomic] = ACTIONS(1790),
    [anon_sym_mutable] = ACTIONS(1790),
    [anon_sym_explicit] = ACTIONS(1790),
    [anon_sym_constexpr] = ACTIONS(1790),
    [anon_sym_unsigned] = ACTIONS(1790),
    [anon_sym_long] = ACTIONS(1790),
    [anon_sym_short] = ACTIONS(1790),
    [sym_primitive_type] = ACTIONS(1790),
    [anon_sym_enum] = ACTIONS(1790),
    [anon_sym_struct] = ACTIONS(1790),
    [anon_sym_union] = ACTIONS(1790),
    [anon_sym_AMP] = ACTIONS(1790),
    [anon_sym_AMP_AMP] = ACTIONS(1788),
    [anon_sym_TILDE] = ACTIONS(1788),
    [sym_identifier] = ACTIONS(1790),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(1790),
    [sym_auto] = ACTIONS(1790),
    [anon_sym_typename] = ACTIONS(1790),
    [anon_sym_template] = ACTIONS(1790),
    [anon_sym_namespace] = ACTIONS(1790),
    [anon_sym_using] = ACTIONS(1790),
    [anon_sym_COLON_COLON] = ACTIONS(1788),
    [sym_operator_name] = ACTIONS(1788),
  },
  [1006] = {
    [ts_builtin_sym_end] = ACTIONS(3491),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3493),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3493),
    [anon_sym_LPAREN] = ACTIONS(3491),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3493),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3493),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3493),
    [sym_preproc_directive] = ACTIONS(3493),
    [anon_sym_typedef] = ACTIONS(3493),
    [anon_sym_extern] = ACTIONS(3493),
    [anon_sym_RBRACE] = ACTIONS(3491),
    [anon_sym_STAR] = ACTIONS(3491),
    [anon_sym_static] = ACTIONS(3493),
    [anon_sym_register] = ACTIONS(3493),
    [anon_sym_inline] = ACTIONS(3493),
    [anon_sym_const] = ACTIONS(3493),
    [anon_sym_restrict] = ACTIONS(3493),
    [anon_sym_volatile] = ACTIONS(3493),
    [anon_sym__Atomic] = ACTIONS(3493),
    [anon_sym_mutable] = ACTIONS(3493),
    [anon_sym_explicit] = ACTIONS(3493),
    [anon_sym_constexpr] = ACTIONS(3493),
    [anon_sym_unsigned] = ACTIONS(3493),
    [anon_sym_long] = ACTIONS(3493),
    [anon_sym_short] = ACTIONS(3493),
    [sym_primitive_type] = ACTIONS(3493),
    [anon_sym_enum] = ACTIONS(3493),
    [anon_sym_struct] = ACTIONS(3493),
    [anon_sym_union] = ACTIONS(3493),
    [anon_sym_AMP] = ACTIONS(3493),
    [anon_sym_AMP_AMP] = ACTIONS(3491),
    [anon_sym_TILDE] = ACTIONS(3491),
    [sym_identifier] = ACTIONS(3493),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(3493),
    [sym_auto] = ACTIONS(3493),
    [anon_sym_typename] = ACTIONS(3493),
    [anon_sym_template] = ACTIONS(3493),
    [anon_sym_namespace] = ACTIONS(3493),
    [anon_sym_using] = ACTIONS(3493),
    [anon_sym_COLON_COLON] = ACTIONS(3491),
    [sym_operator_name] = ACTIONS(3491),
  },
  [1007] = {
    [sym_compound_statement] = STATE(1617),
    [anon_sym_LBRACE] = ACTIONS(915),
    [sym_comment] = ACTIONS(49),
  },
  [1008] = {
    [ts_builtin_sym_end] = ACTIONS(3495),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3497),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3497),
    [anon_sym_LPAREN] = ACTIONS(3495),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3497),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3497),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3497),
    [sym_preproc_directive] = ACTIONS(3497),
    [anon_sym_typedef] = ACTIONS(3497),
    [anon_sym_extern] = ACTIONS(3497),
    [anon_sym_RBRACE] = ACTIONS(3495),
    [anon_sym_STAR] = ACTIONS(3495),
    [anon_sym_static] = ACTIONS(3497),
    [anon_sym_register] = ACTIONS(3497),
    [anon_sym_inline] = ACTIONS(3497),
    [anon_sym_const] = ACTIONS(3497),
    [anon_sym_restrict] = ACTIONS(3497),
    [anon_sym_volatile] = ACTIONS(3497),
    [anon_sym__Atomic] = ACTIONS(3497),
    [anon_sym_mutable] = ACTIONS(3497),
    [anon_sym_explicit] = ACTIONS(3497),
    [anon_sym_constexpr] = ACTIONS(3497),
    [anon_sym_unsigned] = ACTIONS(3497),
    [anon_sym_long] = ACTIONS(3497),
    [anon_sym_short] = ACTIONS(3497),
    [sym_primitive_type] = ACTIONS(3497),
    [anon_sym_enum] = ACTIONS(3497),
    [anon_sym_struct] = ACTIONS(3497),
    [anon_sym_union] = ACTIONS(3497),
    [anon_sym_AMP] = ACTIONS(3497),
    [anon_sym_AMP_AMP] = ACTIONS(3495),
    [anon_sym_TILDE] = ACTIONS(3495),
    [sym_identifier] = ACTIONS(3497),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(3497),
    [sym_auto] = ACTIONS(3497),
    [anon_sym_typename] = ACTIONS(3497),
    [anon_sym_template] = ACTIONS(3497),
    [anon_sym_namespace] = ACTIONS(3497),
    [anon_sym_using] = ACTIONS(3497),
    [anon_sym_COLON_COLON] = ACTIONS(3495),
    [sym_operator_name] = ACTIONS(3495),
  },
  [1009] = {
    [ts_builtin_sym_end] = ACTIONS(3499),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3501),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3501),
    [anon_sym_LPAREN] = ACTIONS(3499),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3501),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3501),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3501),
    [sym_preproc_directive] = ACTIONS(3501),
    [anon_sym_typedef] = ACTIONS(3501),
    [anon_sym_extern] = ACTIONS(3501),
    [anon_sym_RBRACE] = ACTIONS(3499),
    [anon_sym_STAR] = ACTIONS(3499),
    [anon_sym_static] = ACTIONS(3501),
    [anon_sym_register] = ACTIONS(3501),
    [anon_sym_inline] = ACTIONS(3501),
    [anon_sym_const] = ACTIONS(3501),
    [anon_sym_restrict] = ACTIONS(3501),
    [anon_sym_volatile] = ACTIONS(3501),
    [anon_sym__Atomic] = ACTIONS(3501),
    [anon_sym_mutable] = ACTIONS(3501),
    [anon_sym_explicit] = ACTIONS(3501),
    [anon_sym_constexpr] = ACTIONS(3501),
    [anon_sym_unsigned] = ACTIONS(3501),
    [anon_sym_long] = ACTIONS(3501),
    [anon_sym_short] = ACTIONS(3501),
    [sym_primitive_type] = ACTIONS(3501),
    [anon_sym_enum] = ACTIONS(3501),
    [anon_sym_struct] = ACTIONS(3501),
    [anon_sym_union] = ACTIONS(3501),
    [anon_sym_AMP] = ACTIONS(3501),
    [anon_sym_AMP_AMP] = ACTIONS(3499),
    [anon_sym_TILDE] = ACTIONS(3499),
    [sym_identifier] = ACTIONS(3501),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(3501),
    [sym_auto] = ACTIONS(3501),
    [anon_sym_typename] = ACTIONS(3501),
    [anon_sym_template] = ACTIONS(3501),
    [anon_sym_namespace] = ACTIONS(3501),
    [anon_sym_using] = ACTIONS(3501),
    [anon_sym_COLON_COLON] = ACTIONS(3499),
    [sym_operator_name] = ACTIONS(3499),
  },
  [1010] = {
    [anon_sym_LPAREN] = ACTIONS(2010),
    [anon_sym_STAR] = ACTIONS(2010),
    [sym_identifier] = ACTIONS(2010),
    [sym_comment] = ACTIONS(49),
  },
  [1011] = {
    [sym_enumerator] = STATE(1030),
    [anon_sym_RBRACE] = ACTIONS(3503),
    [sym_identifier] = ACTIONS(348),
    [sym_comment] = ACTIONS(49),
  },
  [1012] = {
    [aux_sym_enumerator_list_repeat1] = STATE(1032),
    [anon_sym_COMMA] = ACTIONS(3505),
    [anon_sym_RBRACE] = ACTIONS(3503),
    [sym_comment] = ACTIONS(49),
  },
  [1013] = {
    [anon_sym_LPAREN] = ACTIONS(2114),
    [anon_sym_STAR] = ACTIONS(2114),
    [sym_identifier] = ACTIONS(2114),
    [sym_comment] = ACTIONS(49),
  },
  [1014] = {
    [anon_sym_LPAREN] = ACTIONS(2202),
    [anon_sym_STAR] = ACTIONS(2202),
    [sym_identifier] = ACTIONS(2202),
    [sym_comment] = ACTIONS(49),
  },
  [1015] = {
    [anon_sym_LPAREN] = ACTIONS(2206),
    [anon_sym_STAR] = ACTIONS(2206),
    [sym_identifier] = ACTIONS(2206),
    [sym_comment] = ACTIONS(49),
  },
  [1016] = {
    [anon_sym_LPAREN] = ACTIONS(2290),
    [anon_sym_LBRACE] = ACTIONS(2290),
    [anon_sym_STAR] = ACTIONS(2290),
    [anon_sym_COLON] = ACTIONS(2292),
    [sym_identifier] = ACTIONS(2290),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(2290),
  },
  [1017] = {
    [aux_sym_template_argument_list_repeat1] = STATE(1133),
    [anon_sym_COMMA] = ACTIONS(1127),
    [anon_sym_GT] = ACTIONS(3507),
    [sym_comment] = ACTIONS(49),
  },
  [1018] = {
    [anon_sym_LPAREN] = ACTIONS(2299),
    [anon_sym_STAR] = ACTIONS(2299),
    [sym_identifier] = ACTIONS(2299),
    [sym_comment] = ACTIONS(49),
  },
  [1019] = {
    [anon_sym_LPAREN] = ACTIONS(3509),
    [anon_sym_RPAREN] = ACTIONS(3509),
    [anon_sym_SEMI] = ACTIONS(3509),
    [anon_sym_LBRACK] = ACTIONS(3509),
    [sym_comment] = ACTIONS(49),
  },
  [1020] = {
    [anon_sym_LPAREN] = ACTIONS(3511),
    [anon_sym_RPAREN] = ACTIONS(3511),
    [anon_sym_SEMI] = ACTIONS(3511),
    [anon_sym_LBRACK] = ACTIONS(3511),
    [sym_comment] = ACTIONS(49),
  },
  [1021] = {
    [sym__expression] = STATE(1622),
    [sym_conditional_expression] = STATE(1622),
    [sym_assignment_expression] = STATE(1622),
    [sym_pointer_expression] = STATE(1622),
    [sym_logical_expression] = STATE(1622),
    [sym_bitwise_expression] = STATE(1622),
    [sym_equality_expression] = STATE(1622),
    [sym_relational_expression] = STATE(1622),
    [sym_shift_expression] = STATE(1622),
    [sym_math_expression] = STATE(1622),
    [sym_cast_expression] = STATE(1622),
    [sym_sizeof_expression] = STATE(1622),
    [sym_subscript_expression] = STATE(1622),
    [sym_call_expression] = STATE(1622),
    [sym_field_expression] = STATE(1622),
    [sym_compound_literal_expression] = STATE(1622),
    [sym_parenthesized_expression] = STATE(1622),
    [sym_concatenated_string] = STATE(1622),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(1622),
    [sym_new_expression] = STATE(1622),
    [sym_delete_expression] = STATE(1622),
    [sym_lambda_expression] = STATE(1622),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(3513),
    [anon_sym_LPAREN] = ACTIONS(566),
    [anon_sym_STAR] = ACTIONS(568),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_RBRACK] = ACTIONS(3515),
    [anon_sym_AMP] = ACTIONS(568),
    [anon_sym_BANG] = ACTIONS(584),
    [anon_sym_TILDE] = ACTIONS(586),
    [anon_sym_PLUS] = ACTIONS(588),
    [anon_sym_DASH] = ACTIONS(588),
    [anon_sym_DASH_DASH] = ACTIONS(590),
    [anon_sym_PLUS_PLUS] = ACTIONS(590),
    [anon_sym_sizeof] = ACTIONS(592),
    [sym_number_literal] = ACTIONS(3513),
    [sym_char_literal] = ACTIONS(3513),
    [sym_string_literal] = ACTIONS(594),
    [sym_true] = ACTIONS(3517),
    [sym_false] = ACTIONS(3517),
    [sym_null] = ACTIONS(3517),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1415),
    [anon_sym_delete] = ACTIONS(608),
    [sym_nullptr] = ACTIONS(3517),
  },
  [1022] = {
    [sym_argument_list] = STATE(802),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_STAR] = ACTIONS(1522),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_RBRACK] = ACTIONS(3515),
    [anon_sym_EQ] = ACTIONS(1526),
    [anon_sym_QMARK] = ACTIONS(1528),
    [anon_sym_STAR_EQ] = ACTIONS(1530),
    [anon_sym_SLASH_EQ] = ACTIONS(1530),
    [anon_sym_PERCENT_EQ] = ACTIONS(1530),
    [anon_sym_PLUS_EQ] = ACTIONS(1530),
    [anon_sym_DASH_EQ] = ACTIONS(1530),
    [anon_sym_LT_LT_EQ] = ACTIONS(1530),
    [anon_sym_GT_GT_EQ] = ACTIONS(1530),
    [anon_sym_AMP_EQ] = ACTIONS(1530),
    [anon_sym_CARET_EQ] = ACTIONS(1530),
    [anon_sym_PIPE_EQ] = ACTIONS(1530),
    [anon_sym_AMP] = ACTIONS(1532),
    [anon_sym_PIPE_PIPE] = ACTIONS(1534),
    [anon_sym_AMP_AMP] = ACTIONS(1536),
    [anon_sym_PIPE] = ACTIONS(1538),
    [anon_sym_CARET] = ACTIONS(1540),
    [anon_sym_EQ_EQ] = ACTIONS(1542),
    [anon_sym_BANG_EQ] = ACTIONS(1542),
    [anon_sym_LT] = ACTIONS(1544),
    [anon_sym_GT] = ACTIONS(1544),
    [anon_sym_LT_EQ] = ACTIONS(1546),
    [anon_sym_GT_EQ] = ACTIONS(1546),
    [anon_sym_LT_LT] = ACTIONS(1548),
    [anon_sym_GT_GT] = ACTIONS(1548),
    [anon_sym_PLUS] = ACTIONS(1550),
    [anon_sym_DASH] = ACTIONS(1550),
    [anon_sym_SLASH] = ACTIONS(1522),
    [anon_sym_PERCENT] = ACTIONS(1522),
    [anon_sym_DASH_DASH] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(1554),
    [anon_sym_DASH_GT] = ACTIONS(1554),
    [sym_comment] = ACTIONS(49),
  },
  [1023] = {
    [ts_builtin_sym_end] = ACTIONS(3519),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3521),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3521),
    [anon_sym_LPAREN] = ACTIONS(3519),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3521),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3521),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3521),
    [sym_preproc_directive] = ACTIONS(3521),
    [anon_sym_typedef] = ACTIONS(3521),
    [anon_sym_extern] = ACTIONS(3521),
    [anon_sym_RBRACE] = ACTIONS(3519),
    [anon_sym_STAR] = ACTIONS(3519),
    [anon_sym_static] = ACTIONS(3521),
    [anon_sym_register] = ACTIONS(3521),
    [anon_sym_inline] = ACTIONS(3521),
    [anon_sym_const] = ACTIONS(3521),
    [anon_sym_restrict] = ACTIONS(3521),
    [anon_sym_volatile] = ACTIONS(3521),
    [anon_sym__Atomic] = ACTIONS(3521),
    [anon_sym_mutable] = ACTIONS(3521),
    [anon_sym_explicit] = ACTIONS(3521),
    [anon_sym_constexpr] = ACTIONS(3521),
    [anon_sym_unsigned] = ACTIONS(3521),
    [anon_sym_long] = ACTIONS(3521),
    [anon_sym_short] = ACTIONS(3521),
    [sym_primitive_type] = ACTIONS(3521),
    [anon_sym_enum] = ACTIONS(3521),
    [anon_sym_struct] = ACTIONS(3521),
    [anon_sym_union] = ACTIONS(3521),
    [anon_sym_AMP] = ACTIONS(3521),
    [anon_sym_AMP_AMP] = ACTIONS(3519),
    [anon_sym_TILDE] = ACTIONS(3519),
    [sym_identifier] = ACTIONS(3521),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(3521),
    [sym_auto] = ACTIONS(3521),
    [anon_sym_typename] = ACTIONS(3521),
    [anon_sym_template] = ACTIONS(3521),
    [anon_sym_namespace] = ACTIONS(3521),
    [anon_sym_using] = ACTIONS(3521),
    [anon_sym_COLON_COLON] = ACTIONS(3519),
    [sym_operator_name] = ACTIONS(3519),
  },
  [1024] = {
    [sym__type_specifier] = STATE(1375),
    [sym_sized_type_specifier] = STATE(1375),
    [sym_enum_specifier] = STATE(1375),
    [sym_struct_specifier] = STATE(1375),
    [sym_union_specifier] = STATE(1375),
    [sym_macro_type_specifier] = STATE(1375),
    [sym_class_specifier] = STATE(1375),
    [sym_dependent_type] = STATE(1375),
    [sym_template_type] = STATE(825),
    [sym_scoped_type_identifier] = STATE(826),
    [sym_scoped_namespace_identifier] = STATE(827),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1026),
    [anon_sym_unsigned] = ACTIONS(2002),
    [anon_sym_long] = ACTIONS(2002),
    [anon_sym_short] = ACTIONS(2002),
    [sym_primitive_type] = ACTIONS(2837),
    [anon_sym_enum] = ACTIONS(1833),
    [anon_sym_struct] = ACTIONS(1835),
    [anon_sym_union] = ACTIONS(1837),
    [sym_identifier] = ACTIONS(1588),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(1839),
    [sym_auto] = ACTIONS(2837),
    [anon_sym_typename] = ACTIONS(2006),
    [anon_sym_COLON_COLON] = ACTIONS(1594),
  },
  [1025] = {
    [sym__abstract_declarator] = STATE(1625),
    [sym_abstract_pointer_declarator] = STATE(1625),
    [sym_abstract_function_declarator] = STATE(1625),
    [sym_abstract_array_declarator] = STATE(1625),
    [sym_parameter_list] = STATE(1626),
    [sym_abstract_reference_declarator] = STATE(1625),
    [anon_sym_LPAREN] = ACTIONS(1115),
    [anon_sym_STAR] = ACTIONS(3523),
    [anon_sym_LBRACK] = ACTIONS(1121),
    [anon_sym_const] = ACTIONS(2845),
    [anon_sym_restrict] = ACTIONS(2841),
    [anon_sym_volatile] = ACTIONS(2841),
    [anon_sym__Atomic] = ACTIONS(2841),
    [anon_sym_mutable] = ACTIONS(2841),
    [anon_sym_explicit] = ACTIONS(2841),
    [anon_sym_constexpr] = ACTIONS(2841),
    [anon_sym_AMP] = ACTIONS(3525),
    [anon_sym_AMP_AMP] = ACTIONS(3527),
    [anon_sym_DASH_GT] = ACTIONS(2841),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(2841),
  },
  [1026] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(1627),
    [anon_sym_LPAREN] = ACTIONS(238),
    [anon_sym_STAR] = ACTIONS(238),
    [anon_sym_LBRACK] = ACTIONS(238),
    [anon_sym_const] = ACTIONS(240),
    [anon_sym_restrict] = ACTIONS(240),
    [anon_sym_volatile] = ACTIONS(240),
    [anon_sym__Atomic] = ACTIONS(240),
    [anon_sym_mutable] = ACTIONS(240),
    [anon_sym_explicit] = ACTIONS(240),
    [anon_sym_constexpr] = ACTIONS(240),
    [anon_sym_unsigned] = ACTIONS(3529),
    [anon_sym_long] = ACTIONS(3529),
    [anon_sym_short] = ACTIONS(3529),
    [sym_primitive_type] = ACTIONS(2855),
    [anon_sym_AMP] = ACTIONS(240),
    [anon_sym_AMP_AMP] = ACTIONS(238),
    [anon_sym_DASH_GT] = ACTIONS(238),
    [sym_identifier] = ACTIONS(2857),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(240),
  },
  [1027] = {
    [sym_type_qualifier] = STATE(1027),
    [sym_trailing_return_type] = STATE(1027),
    [aux_sym_function_declarator_repeat1] = STATE(1027),
    [anon_sym_LPAREN] = ACTIONS(2859),
    [anon_sym_LBRACK] = ACTIONS(2859),
    [anon_sym_const] = ACTIONS(2861),
    [anon_sym_restrict] = ACTIONS(2864),
    [anon_sym_volatile] = ACTIONS(2864),
    [anon_sym__Atomic] = ACTIONS(2864),
    [anon_sym_mutable] = ACTIONS(2864),
    [anon_sym_explicit] = ACTIONS(2864),
    [anon_sym_constexpr] = ACTIONS(2864),
    [anon_sym_DASH_GT] = ACTIONS(3531),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(3534),
  },
  [1028] = {
    [sym_argument_list] = STATE(802),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_COMMA] = ACTIONS(3537),
    [anon_sym_RBRACE] = ACTIONS(3537),
    [anon_sym_STAR] = ACTIONS(2507),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_EQ] = ACTIONS(2509),
    [anon_sym_QMARK] = ACTIONS(2511),
    [anon_sym_STAR_EQ] = ACTIONS(2513),
    [anon_sym_SLASH_EQ] = ACTIONS(2513),
    [anon_sym_PERCENT_EQ] = ACTIONS(2513),
    [anon_sym_PLUS_EQ] = ACTIONS(2513),
    [anon_sym_DASH_EQ] = ACTIONS(2513),
    [anon_sym_LT_LT_EQ] = ACTIONS(2513),
    [anon_sym_GT_GT_EQ] = ACTIONS(2513),
    [anon_sym_AMP_EQ] = ACTIONS(2513),
    [anon_sym_CARET_EQ] = ACTIONS(2513),
    [anon_sym_PIPE_EQ] = ACTIONS(2513),
    [anon_sym_AMP] = ACTIONS(2515),
    [anon_sym_PIPE_PIPE] = ACTIONS(2517),
    [anon_sym_AMP_AMP] = ACTIONS(2519),
    [anon_sym_PIPE] = ACTIONS(2521),
    [anon_sym_CARET] = ACTIONS(2523),
    [anon_sym_EQ_EQ] = ACTIONS(2525),
    [anon_sym_BANG_EQ] = ACTIONS(2525),
    [anon_sym_LT] = ACTIONS(2527),
    [anon_sym_GT] = ACTIONS(2527),
    [anon_sym_LT_EQ] = ACTIONS(2529),
    [anon_sym_GT_EQ] = ACTIONS(2529),
    [anon_sym_LT_LT] = ACTIONS(2531),
    [anon_sym_GT_GT] = ACTIONS(2531),
    [anon_sym_PLUS] = ACTIONS(2533),
    [anon_sym_DASH] = ACTIONS(2533),
    [anon_sym_SLASH] = ACTIONS(2507),
    [anon_sym_PERCENT] = ACTIONS(2507),
    [anon_sym_DASH_DASH] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(1554),
    [anon_sym_DASH_GT] = ACTIONS(1554),
    [sym_comment] = ACTIONS(49),
  },
  [1029] = {
    [anon_sym_LPAREN] = ACTIONS(3539),
    [anon_sym_COMMA] = ACTIONS(3539),
    [anon_sym_RPAREN] = ACTIONS(3539),
    [anon_sym_SEMI] = ACTIONS(3539),
    [anon_sym_extern] = ACTIONS(3541),
    [anon_sym_LBRACE] = ACTIONS(3539),
    [anon_sym_STAR] = ACTIONS(3539),
    [anon_sym_LBRACK] = ACTIONS(3539),
    [anon_sym_static] = ACTIONS(3541),
    [anon_sym_register] = ACTIONS(3541),
    [anon_sym_inline] = ACTIONS(3541),
    [anon_sym_const] = ACTIONS(3541),
    [anon_sym_restrict] = ACTIONS(3541),
    [anon_sym_volatile] = ACTIONS(3541),
    [anon_sym__Atomic] = ACTIONS(3541),
    [anon_sym_mutable] = ACTIONS(3541),
    [anon_sym_explicit] = ACTIONS(3541),
    [anon_sym_constexpr] = ACTIONS(3541),
    [anon_sym_COLON] = ACTIONS(3541),
    [anon_sym_AMP] = ACTIONS(3541),
    [anon_sym_AMP_AMP] = ACTIONS(3539),
    [anon_sym_TILDE] = ACTIONS(3539),
    [anon_sym_GT] = ACTIONS(3539),
    [sym_identifier] = ACTIONS(3541),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(3539),
    [sym_operator_name] = ACTIONS(3539),
  },
  [1030] = {
    [anon_sym_COMMA] = ACTIONS(3543),
    [anon_sym_RBRACE] = ACTIONS(3543),
    [sym_comment] = ACTIONS(49),
  },
  [1031] = {
    [sym_enumerator] = STATE(1030),
    [anon_sym_RBRACE] = ACTIONS(3545),
    [sym_identifier] = ACTIONS(348),
    [sym_comment] = ACTIONS(49),
  },
  [1032] = {
    [aux_sym_enumerator_list_repeat1] = STATE(1032),
    [anon_sym_COMMA] = ACTIONS(3547),
    [anon_sym_RBRACE] = ACTIONS(3543),
    [sym_comment] = ACTIONS(49),
  },
  [1033] = {
    [anon_sym_LPAREN] = ACTIONS(3550),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3552),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3550),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3550),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3550),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(3550),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(3550),
    [anon_sym_typedef] = ACTIONS(3552),
    [anon_sym_extern] = ACTIONS(3552),
    [anon_sym_RBRACE] = ACTIONS(3550),
    [anon_sym_STAR] = ACTIONS(3550),
    [anon_sym_static] = ACTIONS(3552),
    [anon_sym_register] = ACTIONS(3552),
    [anon_sym_inline] = ACTIONS(3552),
    [anon_sym_const] = ACTIONS(3552),
    [anon_sym_restrict] = ACTIONS(3552),
    [anon_sym_volatile] = ACTIONS(3552),
    [anon_sym__Atomic] = ACTIONS(3552),
    [anon_sym_mutable] = ACTIONS(3552),
    [anon_sym_explicit] = ACTIONS(3552),
    [anon_sym_constexpr] = ACTIONS(3552),
    [anon_sym_unsigned] = ACTIONS(3552),
    [anon_sym_long] = ACTIONS(3552),
    [anon_sym_short] = ACTIONS(3552),
    [sym_primitive_type] = ACTIONS(3552),
    [anon_sym_enum] = ACTIONS(3552),
    [anon_sym_struct] = ACTIONS(3552),
    [anon_sym_union] = ACTIONS(3552),
    [anon_sym_AMP] = ACTIONS(3552),
    [anon_sym_AMP_AMP] = ACTIONS(3550),
    [anon_sym_TILDE] = ACTIONS(3550),
    [sym_identifier] = ACTIONS(3552),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(3552),
    [anon_sym_public] = ACTIONS(3552),
    [sym_auto] = ACTIONS(3552),
    [anon_sym_typename] = ACTIONS(3552),
    [anon_sym_template] = ACTIONS(3552),
    [anon_sym_friend] = ACTIONS(3552),
    [anon_sym_private] = ACTIONS(3552),
    [anon_sym_protected] = ACTIONS(3552),
    [anon_sym_using] = ACTIONS(3552),
    [anon_sym_COLON_COLON] = ACTIONS(3550),
    [sym_operator_name] = ACTIONS(3550),
  },
  [1034] = {
    [sym_preproc_if_in_field_declaration_list] = STATE(246),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(247),
    [sym_type_definition] = STATE(1630),
    [sym__declaration_specifiers] = STATE(248),
    [sym__declarator] = STATE(249),
    [sym_pointer_declarator] = STATE(249),
    [sym_function_declarator] = STATE(250),
    [sym_array_declarator] = STATE(249),
    [sym_storage_class_specifier] = STATE(257),
    [sym_type_qualifier] = STATE(257),
    [sym__type_specifier] = STATE(251),
    [sym_sized_type_specifier] = STATE(251),
    [sym_enum_specifier] = STATE(251),
    [sym_struct_specifier] = STATE(251),
    [sym_union_specifier] = STATE(251),
    [sym__field_declaration_list_item] = STATE(1630),
    [sym_field_declaration] = STATE(1630),
    [sym_macro_type_specifier] = STATE(251),
    [sym_class_specifier] = STATE(251),
    [sym_dependent_type] = STATE(251),
    [sym_template_declaration] = STATE(1630),
    [sym_inline_method_definition] = STATE(252),
    [sym_constructor_or_destructor_definition] = STATE(252),
    [sym_constructor_or_destructor_declaration] = STATE(253),
    [sym_friend_declaration] = STATE(1630),
    [sym_access_specifier] = STATE(1630),
    [sym_reference_declarator] = STATE(249),
    [sym_template_type] = STATE(254),
    [sym_template_function] = STATE(249),
    [sym_using_declaration] = STATE(1630),
    [sym_alias_declaration] = STATE(1630),
    [sym_destructor_name] = STATE(249),
    [sym_scoped_identifier] = STATE(33),
    [sym_scoped_type_identifier] = STATE(34),
    [sym_scoped_namespace_identifier] = STATE(255),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(1630),
    [aux_sym__declaration_specifiers_repeat1] = STATE(257),
    [aux_sym_sized_type_specifier_repeat1] = STATE(258),
    [anon_sym_LPAREN] = ACTIONS(11),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(358),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3554),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(360),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(362),
    [anon_sym_typedef] = ACTIONS(364),
    [anon_sym_extern] = ACTIONS(27),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_static] = ACTIONS(27),
    [anon_sym_register] = ACTIONS(27),
    [anon_sym_inline] = ACTIONS(27),
    [anon_sym_const] = ACTIONS(29),
    [anon_sym_restrict] = ACTIONS(29),
    [anon_sym_volatile] = ACTIONS(29),
    [anon_sym__Atomic] = ACTIONS(29),
    [anon_sym_mutable] = ACTIONS(29),
    [anon_sym_explicit] = ACTIONS(29),
    [anon_sym_constexpr] = ACTIONS(29),
    [anon_sym_unsigned] = ACTIONS(368),
    [anon_sym_long] = ACTIONS(368),
    [anon_sym_short] = ACTIONS(368),
    [sym_primitive_type] = ACTIONS(370),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(372),
    [anon_sym_union] = ACTIONS(374),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(45),
    [sym_identifier] = ACTIONS(376),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(378),
    [anon_sym_public] = ACTIONS(380),
    [sym_auto] = ACTIONS(370),
    [anon_sym_typename] = ACTIONS(382),
    [anon_sym_template] = ACTIONS(384),
    [anon_sym_friend] = ACTIONS(386),
    [anon_sym_private] = ACTIONS(380),
    [anon_sym_protected] = ACTIONS(380),
    [anon_sym_using] = ACTIONS(388),
    [anon_sym_COLON_COLON] = ACTIONS(390),
    [sym_operator_name] = ACTIONS(392),
  },
  [1035] = {
    [sym_preproc_arg] = ACTIONS(3556),
    [sym_comment] = ACTIONS(83),
  },
  [1036] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3558),
    [sym_comment] = ACTIONS(49),
  },
  [1037] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3560),
    [sym_comment] = ACTIONS(49),
  },
  [1038] = {
    [sym_preproc_if_in_field_declaration_list] = STATE(246),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(247),
    [sym_preproc_else_in_field_declaration_list] = STATE(1635),
    [sym_preproc_elif_in_field_declaration_list] = STATE(1636),
    [sym_type_definition] = STATE(1637),
    [sym__declaration_specifiers] = STATE(248),
    [sym__declarator] = STATE(249),
    [sym_pointer_declarator] = STATE(249),
    [sym_function_declarator] = STATE(250),
    [sym_array_declarator] = STATE(249),
    [sym_storage_class_specifier] = STATE(257),
    [sym_type_qualifier] = STATE(257),
    [sym__type_specifier] = STATE(251),
    [sym_sized_type_specifier] = STATE(251),
    [sym_enum_specifier] = STATE(251),
    [sym_struct_specifier] = STATE(251),
    [sym_union_specifier] = STATE(251),
    [sym__field_declaration_list_item] = STATE(1637),
    [sym_field_declaration] = STATE(1637),
    [sym_macro_type_specifier] = STATE(251),
    [sym_class_specifier] = STATE(251),
    [sym_dependent_type] = STATE(251),
    [sym_template_declaration] = STATE(1637),
    [sym_inline_method_definition] = STATE(252),
    [sym_constructor_or_destructor_definition] = STATE(252),
    [sym_constructor_or_destructor_declaration] = STATE(253),
    [sym_friend_declaration] = STATE(1637),
    [sym_access_specifier] = STATE(1637),
    [sym_reference_declarator] = STATE(249),
    [sym_template_type] = STATE(254),
    [sym_template_function] = STATE(249),
    [sym_using_declaration] = STATE(1637),
    [sym_alias_declaration] = STATE(1637),
    [sym_destructor_name] = STATE(249),
    [sym_scoped_identifier] = STATE(33),
    [sym_scoped_type_identifier] = STATE(34),
    [sym_scoped_namespace_identifier] = STATE(255),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(1637),
    [aux_sym__declaration_specifiers_repeat1] = STATE(257),
    [aux_sym_sized_type_specifier_repeat1] = STATE(258),
    [anon_sym_LPAREN] = ACTIONS(11),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(358),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3562),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(360),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(362),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(2024),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(2026),
    [anon_sym_typedef] = ACTIONS(364),
    [anon_sym_extern] = ACTIONS(27),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_static] = ACTIONS(27),
    [anon_sym_register] = ACTIONS(27),
    [anon_sym_inline] = ACTIONS(27),
    [anon_sym_const] = ACTIONS(29),
    [anon_sym_restrict] = ACTIONS(29),
    [anon_sym_volatile] = ACTIONS(29),
    [anon_sym__Atomic] = ACTIONS(29),
    [anon_sym_mutable] = ACTIONS(29),
    [anon_sym_explicit] = ACTIONS(29),
    [anon_sym_constexpr] = ACTIONS(29),
    [anon_sym_unsigned] = ACTIONS(368),
    [anon_sym_long] = ACTIONS(368),
    [anon_sym_short] = ACTIONS(368),
    [sym_primitive_type] = ACTIONS(370),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(372),
    [anon_sym_union] = ACTIONS(374),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(45),
    [sym_identifier] = ACTIONS(376),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(378),
    [anon_sym_public] = ACTIONS(380),
    [sym_auto] = ACTIONS(370),
    [anon_sym_typename] = ACTIONS(382),
    [anon_sym_template] = ACTIONS(384),
    [anon_sym_friend] = ACTIONS(386),
    [anon_sym_private] = ACTIONS(380),
    [anon_sym_protected] = ACTIONS(380),
    [anon_sym_using] = ACTIONS(388),
    [anon_sym_COLON_COLON] = ACTIONS(390),
    [sym_operator_name] = ACTIONS(392),
  },
  [1039] = {
    [anon_sym_LPAREN] = ACTIONS(3564),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3566),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3564),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3564),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3564),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(3564),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(3564),
    [anon_sym_typedef] = ACTIONS(3566),
    [anon_sym_extern] = ACTIONS(3566),
    [anon_sym_RBRACE] = ACTIONS(3564),
    [anon_sym_STAR] = ACTIONS(3564),
    [anon_sym_static] = ACTIONS(3566),
    [anon_sym_register] = ACTIONS(3566),
    [anon_sym_inline] = ACTIONS(3566),
    [anon_sym_const] = ACTIONS(3566),
    [anon_sym_restrict] = ACTIONS(3566),
    [anon_sym_volatile] = ACTIONS(3566),
    [anon_sym__Atomic] = ACTIONS(3566),
    [anon_sym_mutable] = ACTIONS(3566),
    [anon_sym_explicit] = ACTIONS(3566),
    [anon_sym_constexpr] = ACTIONS(3566),
    [anon_sym_unsigned] = ACTIONS(3566),
    [anon_sym_long] = ACTIONS(3566),
    [anon_sym_short] = ACTIONS(3566),
    [sym_primitive_type] = ACTIONS(3566),
    [anon_sym_enum] = ACTIONS(3566),
    [anon_sym_struct] = ACTIONS(3566),
    [anon_sym_union] = ACTIONS(3566),
    [anon_sym_AMP] = ACTIONS(3566),
    [anon_sym_AMP_AMP] = ACTIONS(3564),
    [anon_sym_TILDE] = ACTIONS(3564),
    [sym_identifier] = ACTIONS(3566),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(3566),
    [anon_sym_public] = ACTIONS(3566),
    [sym_auto] = ACTIONS(3566),
    [anon_sym_typename] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(3566),
    [anon_sym_friend] = ACTIONS(3566),
    [anon_sym_private] = ACTIONS(3566),
    [anon_sym_protected] = ACTIONS(3566),
    [anon_sym_using] = ACTIONS(3566),
    [anon_sym_COLON_COLON] = ACTIONS(3564),
    [sym_operator_name] = ACTIONS(3564),
  },
  [1040] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3568),
    [sym_comment] = ACTIONS(49),
  },
  [1041] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3570),
    [sym_comment] = ACTIONS(49),
  },
  [1042] = {
    [sym_preproc_if_in_field_declaration_list] = STATE(246),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(247),
    [sym_preproc_else_in_field_declaration_list] = STATE(1641),
    [sym_preproc_elif_in_field_declaration_list] = STATE(1642),
    [sym_type_definition] = STATE(1637),
    [sym__declaration_specifiers] = STATE(248),
    [sym__declarator] = STATE(249),
    [sym_pointer_declarator] = STATE(249),
    [sym_function_declarator] = STATE(250),
    [sym_array_declarator] = STATE(249),
    [sym_storage_class_specifier] = STATE(257),
    [sym_type_qualifier] = STATE(257),
    [sym__type_specifier] = STATE(251),
    [sym_sized_type_specifier] = STATE(251),
    [sym_enum_specifier] = STATE(251),
    [sym_struct_specifier] = STATE(251),
    [sym_union_specifier] = STATE(251),
    [sym__field_declaration_list_item] = STATE(1637),
    [sym_field_declaration] = STATE(1637),
    [sym_macro_type_specifier] = STATE(251),
    [sym_class_specifier] = STATE(251),
    [sym_dependent_type] = STATE(251),
    [sym_template_declaration] = STATE(1637),
    [sym_inline_method_definition] = STATE(252),
    [sym_constructor_or_destructor_definition] = STATE(252),
    [sym_constructor_or_destructor_declaration] = STATE(253),
    [sym_friend_declaration] = STATE(1637),
    [sym_access_specifier] = STATE(1637),
    [sym_reference_declarator] = STATE(249),
    [sym_template_type] = STATE(254),
    [sym_template_function] = STATE(249),
    [sym_using_declaration] = STATE(1637),
    [sym_alias_declaration] = STATE(1637),
    [sym_destructor_name] = STATE(249),
    [sym_scoped_identifier] = STATE(33),
    [sym_scoped_type_identifier] = STATE(34),
    [sym_scoped_namespace_identifier] = STATE(255),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(1637),
    [aux_sym__declaration_specifiers_repeat1] = STATE(257),
    [aux_sym_sized_type_specifier_repeat1] = STATE(258),
    [anon_sym_LPAREN] = ACTIONS(11),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(358),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3572),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(360),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(362),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(2024),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(2026),
    [anon_sym_typedef] = ACTIONS(364),
    [anon_sym_extern] = ACTIONS(27),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_static] = ACTIONS(27),
    [anon_sym_register] = ACTIONS(27),
    [anon_sym_inline] = ACTIONS(27),
    [anon_sym_const] = ACTIONS(29),
    [anon_sym_restrict] = ACTIONS(29),
    [anon_sym_volatile] = ACTIONS(29),
    [anon_sym__Atomic] = ACTIONS(29),
    [anon_sym_mutable] = ACTIONS(29),
    [anon_sym_explicit] = ACTIONS(29),
    [anon_sym_constexpr] = ACTIONS(29),
    [anon_sym_unsigned] = ACTIONS(368),
    [anon_sym_long] = ACTIONS(368),
    [anon_sym_short] = ACTIONS(368),
    [sym_primitive_type] = ACTIONS(370),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(372),
    [anon_sym_union] = ACTIONS(374),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(45),
    [sym_identifier] = ACTIONS(376),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(378),
    [anon_sym_public] = ACTIONS(380),
    [sym_auto] = ACTIONS(370),
    [anon_sym_typename] = ACTIONS(382),
    [anon_sym_template] = ACTIONS(384),
    [anon_sym_friend] = ACTIONS(386),
    [anon_sym_private] = ACTIONS(380),
    [anon_sym_protected] = ACTIONS(380),
    [anon_sym_using] = ACTIONS(388),
    [anon_sym_COLON_COLON] = ACTIONS(390),
    [sym_operator_name] = ACTIONS(392),
  },
  [1043] = {
    [anon_sym_LPAREN] = ACTIONS(3574),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3576),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3574),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3574),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3574),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(3574),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(3574),
    [anon_sym_typedef] = ACTIONS(3576),
    [anon_sym_extern] = ACTIONS(3576),
    [anon_sym_RBRACE] = ACTIONS(3574),
    [anon_sym_STAR] = ACTIONS(3574),
    [anon_sym_static] = ACTIONS(3576),
    [anon_sym_register] = ACTIONS(3576),
    [anon_sym_inline] = ACTIONS(3576),
    [anon_sym_const] = ACTIONS(3576),
    [anon_sym_restrict] = ACTIONS(3576),
    [anon_sym_volatile] = ACTIONS(3576),
    [anon_sym__Atomic] = ACTIONS(3576),
    [anon_sym_mutable] = ACTIONS(3576),
    [anon_sym_explicit] = ACTIONS(3576),
    [anon_sym_constexpr] = ACTIONS(3576),
    [anon_sym_unsigned] = ACTIONS(3576),
    [anon_sym_long] = ACTIONS(3576),
    [anon_sym_short] = ACTIONS(3576),
    [sym_primitive_type] = ACTIONS(3576),
    [anon_sym_enum] = ACTIONS(3576),
    [anon_sym_struct] = ACTIONS(3576),
    [anon_sym_union] = ACTIONS(3576),
    [anon_sym_AMP] = ACTIONS(3576),
    [anon_sym_AMP_AMP] = ACTIONS(3574),
    [anon_sym_TILDE] = ACTIONS(3574),
    [sym_identifier] = ACTIONS(3576),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(3576),
    [anon_sym_public] = ACTIONS(3576),
    [sym_auto] = ACTIONS(3576),
    [anon_sym_typename] = ACTIONS(3576),
    [anon_sym_template] = ACTIONS(3576),
    [anon_sym_friend] = ACTIONS(3576),
    [anon_sym_private] = ACTIONS(3576),
    [anon_sym_protected] = ACTIONS(3576),
    [anon_sym_using] = ACTIONS(3576),
    [anon_sym_COLON_COLON] = ACTIONS(3574),
    [sym_operator_name] = ACTIONS(3574),
  },
  [1044] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3578),
    [sym_comment] = ACTIONS(49),
  },
  [1045] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3580),
    [sym_comment] = ACTIONS(49),
  },
  [1046] = {
    [sym_preproc_if_in_field_declaration_list] = STATE(246),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(247),
    [sym_preproc_else_in_field_declaration_list] = STATE(1646),
    [sym_preproc_elif_in_field_declaration_list] = STATE(1647),
    [sym_type_definition] = STATE(1637),
    [sym__declaration_specifiers] = STATE(248),
    [sym__declarator] = STATE(249),
    [sym_pointer_declarator] = STATE(249),
    [sym_function_declarator] = STATE(250),
    [sym_array_declarator] = STATE(249),
    [sym_storage_class_specifier] = STATE(257),
    [sym_type_qualifier] = STATE(257),
    [sym__type_specifier] = STATE(251),
    [sym_sized_type_specifier] = STATE(251),
    [sym_enum_specifier] = STATE(251),
    [sym_struct_specifier] = STATE(251),
    [sym_union_specifier] = STATE(251),
    [sym__field_declaration_list_item] = STATE(1637),
    [sym_field_declaration] = STATE(1637),
    [sym_macro_type_specifier] = STATE(251),
    [sym_class_specifier] = STATE(251),
    [sym_dependent_type] = STATE(251),
    [sym_template_declaration] = STATE(1637),
    [sym_inline_method_definition] = STATE(252),
    [sym_constructor_or_destructor_definition] = STATE(252),
    [sym_constructor_or_destructor_declaration] = STATE(253),
    [sym_friend_declaration] = STATE(1637),
    [sym_access_specifier] = STATE(1637),
    [sym_reference_declarator] = STATE(249),
    [sym_template_type] = STATE(254),
    [sym_template_function] = STATE(249),
    [sym_using_declaration] = STATE(1637),
    [sym_alias_declaration] = STATE(1637),
    [sym_destructor_name] = STATE(249),
    [sym_scoped_identifier] = STATE(33),
    [sym_scoped_type_identifier] = STATE(34),
    [sym_scoped_namespace_identifier] = STATE(255),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(1637),
    [aux_sym__declaration_specifiers_repeat1] = STATE(257),
    [aux_sym_sized_type_specifier_repeat1] = STATE(258),
    [anon_sym_LPAREN] = ACTIONS(11),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(358),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3582),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(360),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(362),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(2024),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(2026),
    [anon_sym_typedef] = ACTIONS(364),
    [anon_sym_extern] = ACTIONS(27),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_static] = ACTIONS(27),
    [anon_sym_register] = ACTIONS(27),
    [anon_sym_inline] = ACTIONS(27),
    [anon_sym_const] = ACTIONS(29),
    [anon_sym_restrict] = ACTIONS(29),
    [anon_sym_volatile] = ACTIONS(29),
    [anon_sym__Atomic] = ACTIONS(29),
    [anon_sym_mutable] = ACTIONS(29),
    [anon_sym_explicit] = ACTIONS(29),
    [anon_sym_constexpr] = ACTIONS(29),
    [anon_sym_unsigned] = ACTIONS(368),
    [anon_sym_long] = ACTIONS(368),
    [anon_sym_short] = ACTIONS(368),
    [sym_primitive_type] = ACTIONS(370),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(372),
    [anon_sym_union] = ACTIONS(374),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(45),
    [sym_identifier] = ACTIONS(376),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(378),
    [anon_sym_public] = ACTIONS(380),
    [sym_auto] = ACTIONS(370),
    [anon_sym_typename] = ACTIONS(382),
    [anon_sym_template] = ACTIONS(384),
    [anon_sym_friend] = ACTIONS(386),
    [anon_sym_private] = ACTIONS(380),
    [anon_sym_protected] = ACTIONS(380),
    [anon_sym_using] = ACTIONS(388),
    [anon_sym_COLON_COLON] = ACTIONS(390),
    [sym_operator_name] = ACTIONS(392),
  },
  [1047] = {
    [sym_parameter_list] = STATE(513),
    [anon_sym_LPAREN] = ACTIONS(206),
    [anon_sym_SEMI] = ACTIONS(3584),
    [anon_sym_LBRACK] = ACTIONS(955),
    [sym_comment] = ACTIONS(49),
  },
  [1048] = {
    [sym__type_declarator] = STATE(1649),
    [sym_pointer_type_declarator] = STATE(213),
    [sym_function_type_declarator] = STATE(214),
    [sym_array_type_declarator] = STATE(215),
    [anon_sym_LPAREN] = ACTIONS(327),
    [anon_sym_STAR] = ACTIONS(329),
    [sym_identifier] = ACTIONS(331),
    [sym_comment] = ACTIONS(49),
  },
  [1049] = {
    [anon_sym_LPAREN] = ACTIONS(1137),
    [anon_sym_SEMI] = ACTIONS(1140),
    [anon_sym_extern] = ACTIONS(1142),
    [anon_sym_STAR] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1146),
    [anon_sym_static] = ACTIONS(1142),
    [anon_sym_register] = ACTIONS(1142),
    [anon_sym_inline] = ACTIONS(1142),
    [anon_sym_const] = ACTIONS(1142),
    [anon_sym_restrict] = ACTIONS(1142),
    [anon_sym_volatile] = ACTIONS(1142),
    [anon_sym__Atomic] = ACTIONS(1142),
    [anon_sym_mutable] = ACTIONS(1142),
    [anon_sym_explicit] = ACTIONS(1142),
    [anon_sym_constexpr] = ACTIONS(1142),
    [anon_sym_COLON] = ACTIONS(1142),
    [anon_sym_AMP] = ACTIONS(1142),
    [anon_sym_AMP_AMP] = ACTIONS(1140),
    [anon_sym_LT] = ACTIONS(1137),
    [sym_identifier] = ACTIONS(1142),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(1144),
    [sym_operator_name] = ACTIONS(1140),
  },
  [1050] = {
    [anon_sym_LPAREN] = ACTIONS(1198),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1200),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(1198),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1198),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1198),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(1198),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(1198),
    [anon_sym_typedef] = ACTIONS(1200),
    [anon_sym_extern] = ACTIONS(1200),
    [anon_sym_RBRACE] = ACTIONS(1198),
    [anon_sym_STAR] = ACTIONS(1198),
    [anon_sym_static] = ACTIONS(1200),
    [anon_sym_register] = ACTIONS(1200),
    [anon_sym_inline] = ACTIONS(1200),
    [anon_sym_const] = ACTIONS(1200),
    [anon_sym_restrict] = ACTIONS(1200),
    [anon_sym_volatile] = ACTIONS(1200),
    [anon_sym__Atomic] = ACTIONS(1200),
    [anon_sym_mutable] = ACTIONS(1200),
    [anon_sym_explicit] = ACTIONS(1200),
    [anon_sym_constexpr] = ACTIONS(1200),
    [anon_sym_unsigned] = ACTIONS(1200),
    [anon_sym_long] = ACTIONS(1200),
    [anon_sym_short] = ACTIONS(1200),
    [sym_primitive_type] = ACTIONS(1200),
    [anon_sym_enum] = ACTIONS(1200),
    [anon_sym_struct] = ACTIONS(1200),
    [anon_sym_union] = ACTIONS(1200),
    [anon_sym_AMP] = ACTIONS(1200),
    [anon_sym_AMP_AMP] = ACTIONS(1198),
    [anon_sym_TILDE] = ACTIONS(1198),
    [sym_identifier] = ACTIONS(1200),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(1200),
    [anon_sym_public] = ACTIONS(1200),
    [sym_auto] = ACTIONS(1200),
    [anon_sym_typename] = ACTIONS(1200),
    [anon_sym_template] = ACTIONS(1200),
    [anon_sym_friend] = ACTIONS(1200),
    [anon_sym_private] = ACTIONS(1200),
    [anon_sym_protected] = ACTIONS(1200),
    [anon_sym_using] = ACTIONS(1200),
    [anon_sym_COLON_COLON] = ACTIONS(1198),
    [sym_operator_name] = ACTIONS(1198),
  },
  [1051] = {
    [sym__declarator] = STATE(1052),
    [sym_pointer_declarator] = STATE(1052),
    [sym_function_declarator] = STATE(1052),
    [sym_array_declarator] = STATE(1052),
    [sym_init_declarator] = STATE(1053),
    [sym_reference_declarator] = STATE(1052),
    [sym_template_type] = STATE(46),
    [sym_template_function] = STATE(1052),
    [sym_destructor_name] = STATE(1052),
    [sym_scoped_identifier] = STATE(33),
    [sym_scoped_type_identifier] = STATE(47),
    [sym_scoped_namespace_identifier] = STATE(46),
    [anon_sym_LPAREN] = ACTIONS(11),
    [anon_sym_SEMI] = ACTIONS(3586),
    [anon_sym_STAR] = ACTIONS(196),
    [anon_sym_AMP] = ACTIONS(526),
    [anon_sym_AMP_AMP] = ACTIONS(528),
    [anon_sym_TILDE] = ACTIONS(45),
    [sym_identifier] = ACTIONS(75),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(77),
    [sym_operator_name] = ACTIONS(2044),
  },
  [1052] = {
    [sym_compound_statement] = STATE(1653),
    [sym_parameter_list] = STATE(332),
    [sym_argument_list] = STATE(333),
    [sym_initializer_list] = STATE(333),
    [aux_sym_declaration_repeat1] = STATE(1654),
    [anon_sym_LPAREN] = ACTIONS(536),
    [anon_sym_COMMA] = ACTIONS(538),
    [anon_sym_SEMI] = ACTIONS(3588),
    [anon_sym_LBRACE] = ACTIONS(3590),
    [anon_sym_LBRACK] = ACTIONS(208),
    [anon_sym_EQ] = ACTIONS(544),
    [sym_comment] = ACTIONS(49),
  },
  [1053] = {
    [aux_sym_declaration_repeat1] = STATE(1654),
    [anon_sym_COMMA] = ACTIONS(538),
    [anon_sym_SEMI] = ACTIONS(3588),
    [sym_comment] = ACTIONS(49),
  },
  [1054] = {
    [anon_sym_LPAREN] = ACTIONS(3592),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3594),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3592),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3592),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3592),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(3592),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(3592),
    [anon_sym_typedef] = ACTIONS(3594),
    [anon_sym_extern] = ACTIONS(3594),
    [anon_sym_RBRACE] = ACTIONS(3592),
    [anon_sym_STAR] = ACTIONS(3592),
    [anon_sym_static] = ACTIONS(3594),
    [anon_sym_register] = ACTIONS(3594),
    [anon_sym_inline] = ACTIONS(3594),
    [anon_sym_const] = ACTIONS(3594),
    [anon_sym_restrict] = ACTIONS(3594),
    [anon_sym_volatile] = ACTIONS(3594),
    [anon_sym__Atomic] = ACTIONS(3594),
    [anon_sym_mutable] = ACTIONS(3594),
    [anon_sym_explicit] = ACTIONS(3594),
    [anon_sym_constexpr] = ACTIONS(3594),
    [anon_sym_unsigned] = ACTIONS(3594),
    [anon_sym_long] = ACTIONS(3594),
    [anon_sym_short] = ACTIONS(3594),
    [sym_primitive_type] = ACTIONS(3594),
    [anon_sym_enum] = ACTIONS(3594),
    [anon_sym_struct] = ACTIONS(3594),
    [anon_sym_union] = ACTIONS(3594),
    [anon_sym_AMP] = ACTIONS(3594),
    [anon_sym_AMP_AMP] = ACTIONS(3592),
    [anon_sym_TILDE] = ACTIONS(3592),
    [sym_identifier] = ACTIONS(3594),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(3594),
    [anon_sym_public] = ACTIONS(3594),
    [sym_auto] = ACTIONS(3594),
    [anon_sym_typename] = ACTIONS(3594),
    [anon_sym_template] = ACTIONS(3594),
    [anon_sym_friend] = ACTIONS(3594),
    [anon_sym_private] = ACTIONS(3594),
    [anon_sym_protected] = ACTIONS(3594),
    [anon_sym_using] = ACTIONS(3594),
    [anon_sym_COLON_COLON] = ACTIONS(3592),
    [sym_operator_name] = ACTIONS(3592),
  },
  [1055] = {
    [anon_sym_LPAREN] = ACTIONS(1227),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1229),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(1227),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1227),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1227),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(1227),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(1227),
    [anon_sym_typedef] = ACTIONS(1229),
    [anon_sym_extern] = ACTIONS(1229),
    [anon_sym_RBRACE] = ACTIONS(1227),
    [anon_sym_STAR] = ACTIONS(1227),
    [anon_sym_static] = ACTIONS(1229),
    [anon_sym_register] = ACTIONS(1229),
    [anon_sym_inline] = ACTIONS(1229),
    [anon_sym_const] = ACTIONS(1229),
    [anon_sym_restrict] = ACTIONS(1229),
    [anon_sym_volatile] = ACTIONS(1229),
    [anon_sym__Atomic] = ACTIONS(1229),
    [anon_sym_mutable] = ACTIONS(1229),
    [anon_sym_explicit] = ACTIONS(1229),
    [anon_sym_constexpr] = ACTIONS(1229),
    [anon_sym_unsigned] = ACTIONS(1229),
    [anon_sym_long] = ACTIONS(1229),
    [anon_sym_short] = ACTIONS(1229),
    [sym_primitive_type] = ACTIONS(1229),
    [anon_sym_enum] = ACTIONS(1229),
    [anon_sym_struct] = ACTIONS(1229),
    [anon_sym_union] = ACTIONS(1229),
    [anon_sym_AMP] = ACTIONS(1229),
    [anon_sym_AMP_AMP] = ACTIONS(1227),
    [anon_sym_TILDE] = ACTIONS(1227),
    [sym_identifier] = ACTIONS(1229),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(1229),
    [anon_sym_public] = ACTIONS(1229),
    [sym_auto] = ACTIONS(1229),
    [anon_sym_typename] = ACTIONS(1229),
    [anon_sym_template] = ACTIONS(1229),
    [anon_sym_friend] = ACTIONS(1229),
    [anon_sym_private] = ACTIONS(1229),
    [anon_sym_protected] = ACTIONS(1229),
    [anon_sym_using] = ACTIONS(1229),
    [anon_sym_COLON_COLON] = ACTIONS(1227),
    [sym_operator_name] = ACTIONS(1227),
  },
  [1056] = {
    [sym_type_qualifier] = STATE(638),
    [sym__type_specifier] = STATE(636),
    [sym_sized_type_specifier] = STATE(636),
    [sym_enum_specifier] = STATE(636),
    [sym_struct_specifier] = STATE(636),
    [sym_union_specifier] = STATE(636),
    [sym_type_descriptor] = STATE(1655),
    [sym_macro_type_specifier] = STATE(636),
    [sym_class_specifier] = STATE(636),
    [sym_dependent_type] = STATE(636),
    [sym_template_type] = STATE(62),
    [sym_scoped_type_identifier] = STATE(34),
    [sym_scoped_namespace_identifier] = STATE(64),
    [aux_sym_type_definition_repeat1] = STATE(638),
    [aux_sym_sized_type_specifier_repeat1] = STATE(639),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_restrict] = ACTIONS(93),
    [anon_sym_volatile] = ACTIONS(93),
    [anon_sym__Atomic] = ACTIONS(93),
    [anon_sym_mutable] = ACTIONS(93),
    [anon_sym_explicit] = ACTIONS(93),
    [anon_sym_constexpr] = ACTIONS(93),
    [anon_sym_unsigned] = ACTIONS(1231),
    [anon_sym_long] = ACTIONS(1231),
    [anon_sym_short] = ACTIONS(1231),
    [sym_primitive_type] = ACTIONS(1233),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(428),
    [anon_sym_union] = ACTIONS(430),
    [sym_identifier] = ACTIONS(434),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(436),
    [sym_auto] = ACTIONS(1233),
    [anon_sym_typename] = ACTIONS(1235),
    [anon_sym_COLON_COLON] = ACTIONS(111),
  },
  [1057] = {
    [sym_template_argument_list] = STATE(203),
    [anon_sym_SEMI] = ACTIONS(3596),
    [anon_sym_LT] = ACTIONS(146),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(501),
  },
  [1058] = {
    [anon_sym_SEMI] = ACTIONS(3596),
    [sym_comment] = ACTIONS(49),
  },
  [1059] = {
    [sym__field_declarator] = STATE(1657),
    [sym_pointer_field_declarator] = STATE(549),
    [sym_function_field_declarator] = STATE(550),
    [sym_array_field_declarator] = STATE(551),
    [sym_reference_field_declarator] = STATE(552),
    [sym_template_type] = STATE(553),
    [sym_template_method] = STATE(1657),
    [sym_scoped_field_identifier] = STATE(1062),
    [sym_scoped_type_identifier] = STATE(47),
    [sym_scoped_namespace_identifier] = STATE(553),
    [anon_sym_LPAREN] = ACTIONS(1029),
    [anon_sym_STAR] = ACTIONS(2054),
    [anon_sym_AMP] = ACTIONS(2056),
    [anon_sym_AMP_AMP] = ACTIONS(2058),
    [sym_identifier] = ACTIONS(1041),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(1043),
    [sym_operator_name] = ACTIONS(3598),
  },
  [1060] = {
    [sym__field_declarator] = STATE(1658),
    [sym_pointer_field_declarator] = STATE(549),
    [sym_function_field_declarator] = STATE(550),
    [sym_array_field_declarator] = STATE(551),
    [sym_reference_field_declarator] = STATE(552),
    [sym_template_type] = STATE(553),
    [sym_template_method] = STATE(1658),
    [sym_scoped_field_identifier] = STATE(1062),
    [sym_scoped_type_identifier] = STATE(47),
    [sym_scoped_namespace_identifier] = STATE(553),
    [anon_sym_LPAREN] = ACTIONS(1029),
    [anon_sym_STAR] = ACTIONS(2054),
    [anon_sym_AMP] = ACTIONS(2056),
    [anon_sym_AMP_AMP] = ACTIONS(2058),
    [sym_identifier] = ACTIONS(1041),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(1043),
    [sym_operator_name] = ACTIONS(3600),
  },
  [1061] = {
    [sym_parameter_list] = STATE(1660),
    [anon_sym_LPAREN] = ACTIONS(206),
    [anon_sym_RPAREN] = ACTIONS(3602),
    [anon_sym_LBRACK] = ACTIONS(2086),
    [sym_comment] = ACTIONS(49),
  },
  [1062] = {
    [sym_template_argument_list] = STATE(1078),
    [anon_sym_LT] = ACTIONS(146),
    [sym_comment] = ACTIONS(49),
  },
  [1063] = {
    [sym_parameter_list] = STATE(1074),
    [anon_sym_LPAREN] = ACTIONS(206),
    [anon_sym_COMMA] = ACTIONS(3604),
    [anon_sym_SEMI] = ACTIONS(3604),
    [anon_sym_LBRACE] = ACTIONS(3604),
    [anon_sym_LBRACK] = ACTIONS(2086),
    [anon_sym_COLON] = ACTIONS(3604),
    [sym_comment] = ACTIONS(49),
  },
  [1064] = {
    [sym_argument_list] = STATE(802),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_SEMI] = ACTIONS(3606),
    [anon_sym_STAR] = ACTIONS(2553),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_EQ] = ACTIONS(2555),
    [anon_sym_QMARK] = ACTIONS(2557),
    [anon_sym_STAR_EQ] = ACTIONS(2559),
    [anon_sym_SLASH_EQ] = ACTIONS(2559),
    [anon_sym_PERCENT_EQ] = ACTIONS(2559),
    [anon_sym_PLUS_EQ] = ACTIONS(2559),
    [anon_sym_DASH_EQ] = ACTIONS(2559),
    [anon_sym_LT_LT_EQ] = ACTIONS(2559),
    [anon_sym_GT_GT_EQ] = ACTIONS(2559),
    [anon_sym_AMP_EQ] = ACTIONS(2559),
    [anon_sym_CARET_EQ] = ACTIONS(2559),
    [anon_sym_PIPE_EQ] = ACTIONS(2559),
    [anon_sym_AMP] = ACTIONS(2561),
    [anon_sym_PIPE_PIPE] = ACTIONS(2563),
    [anon_sym_AMP_AMP] = ACTIONS(2565),
    [anon_sym_PIPE] = ACTIONS(2567),
    [anon_sym_CARET] = ACTIONS(2569),
    [anon_sym_EQ_EQ] = ACTIONS(2571),
    [anon_sym_BANG_EQ] = ACTIONS(2571),
    [anon_sym_LT] = ACTIONS(2573),
    [anon_sym_GT] = ACTIONS(2573),
    [anon_sym_LT_EQ] = ACTIONS(2575),
    [anon_sym_GT_EQ] = ACTIONS(2575),
    [anon_sym_LT_LT] = ACTIONS(2577),
    [anon_sym_GT_GT] = ACTIONS(2577),
    [anon_sym_PLUS] = ACTIONS(2579),
    [anon_sym_DASH] = ACTIONS(2579),
    [anon_sym_SLASH] = ACTIONS(2553),
    [anon_sym_PERCENT] = ACTIONS(2553),
    [anon_sym_DASH_DASH] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(1554),
    [anon_sym_DASH_GT] = ACTIONS(1554),
    [sym_comment] = ACTIONS(49),
  },
  [1065] = {
    [sym_parameter_list] = STATE(1074),
    [anon_sym_LPAREN] = ACTIONS(206),
    [anon_sym_COMMA] = ACTIONS(3608),
    [anon_sym_SEMI] = ACTIONS(3608),
    [anon_sym_LBRACE] = ACTIONS(3608),
    [anon_sym_LBRACK] = ACTIONS(2086),
    [anon_sym_COLON] = ACTIONS(3608),
    [sym_comment] = ACTIONS(49),
  },
  [1066] = {
    [sym_destructor_name] = STATE(1534),
    [anon_sym_TILDE] = ACTIONS(45),
    [sym_identifier] = ACTIONS(3610),
    [sym_comment] = ACTIONS(49),
    [sym_operator_name] = ACTIONS(3322),
  },
  [1067] = {
    [anon_sym_LPAREN] = ACTIONS(3612),
    [anon_sym_COMMA] = ACTIONS(3612),
    [anon_sym_RPAREN] = ACTIONS(3612),
    [anon_sym_SEMI] = ACTIONS(3612),
    [anon_sym_LBRACE] = ACTIONS(3612),
    [anon_sym_RBRACE] = ACTIONS(3612),
    [anon_sym_STAR] = ACTIONS(3614),
    [anon_sym_LBRACK] = ACTIONS(3612),
    [anon_sym_RBRACK] = ACTIONS(3612),
    [anon_sym_EQ] = ACTIONS(3614),
    [anon_sym_COLON] = ACTIONS(3614),
    [anon_sym_QMARK] = ACTIONS(3612),
    [anon_sym_STAR_EQ] = ACTIONS(3612),
    [anon_sym_SLASH_EQ] = ACTIONS(3612),
    [anon_sym_PERCENT_EQ] = ACTIONS(3612),
    [anon_sym_PLUS_EQ] = ACTIONS(3612),
    [anon_sym_DASH_EQ] = ACTIONS(3612),
    [anon_sym_LT_LT_EQ] = ACTIONS(3612),
    [anon_sym_GT_GT_EQ] = ACTIONS(3612),
    [anon_sym_AMP_EQ] = ACTIONS(3612),
    [anon_sym_CARET_EQ] = ACTIONS(3612),
    [anon_sym_PIPE_EQ] = ACTIONS(3612),
    [anon_sym_AMP] = ACTIONS(3614),
    [anon_sym_PIPE_PIPE] = ACTIONS(3612),
    [anon_sym_AMP_AMP] = ACTIONS(3612),
    [anon_sym_PIPE] = ACTIONS(3614),
    [anon_sym_CARET] = ACTIONS(3614),
    [anon_sym_EQ_EQ] = ACTIONS(3612),
    [anon_sym_BANG_EQ] = ACTIONS(3612),
    [anon_sym_LT] = ACTIONS(3614),
    [anon_sym_GT] = ACTIONS(3614),
    [anon_sym_LT_EQ] = ACTIONS(3612),
    [anon_sym_GT_EQ] = ACTIONS(3612),
    [anon_sym_LT_LT] = ACTIONS(3614),
    [anon_sym_GT_GT] = ACTIONS(3614),
    [anon_sym_PLUS] = ACTIONS(3614),
    [anon_sym_DASH] = ACTIONS(3614),
    [anon_sym_SLASH] = ACTIONS(3614),
    [anon_sym_PERCENT] = ACTIONS(3614),
    [anon_sym_DASH_DASH] = ACTIONS(3612),
    [anon_sym_PLUS_PLUS] = ACTIONS(3612),
    [anon_sym_DOT] = ACTIONS(3612),
    [anon_sym_DASH_GT] = ACTIONS(3612),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(447),
  },
  [1068] = {
    [anon_sym_LT] = ACTIONS(3616),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(516),
  },
  [1069] = {
    [sym__field_declarator] = STATE(1665),
    [sym_pointer_field_declarator] = STATE(549),
    [sym_function_field_declarator] = STATE(550),
    [sym_array_field_declarator] = STATE(551),
    [sym_reference_field_declarator] = STATE(552),
    [sym_template_type] = STATE(553),
    [sym_template_method] = STATE(1665),
    [sym_scoped_field_identifier] = STATE(554),
    [sym_scoped_type_identifier] = STATE(47),
    [sym_scoped_namespace_identifier] = STATE(553),
    [anon_sym_LPAREN] = ACTIONS(1029),
    [anon_sym_STAR] = ACTIONS(3619),
    [anon_sym_AMP] = ACTIONS(3621),
    [anon_sym_AMP_AMP] = ACTIONS(3623),
    [sym_identifier] = ACTIONS(1041),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(1043),
    [sym_operator_name] = ACTIONS(3625),
  },
  [1070] = {
    [anon_sym_LPAREN] = ACTIONS(3627),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3629),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3627),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3627),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3627),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(3627),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(3627),
    [anon_sym_typedef] = ACTIONS(3629),
    [anon_sym_extern] = ACTIONS(3629),
    [anon_sym_RBRACE] = ACTIONS(3627),
    [anon_sym_STAR] = ACTIONS(3627),
    [anon_sym_static] = ACTIONS(3629),
    [anon_sym_register] = ACTIONS(3629),
    [anon_sym_inline] = ACTIONS(3629),
    [anon_sym_const] = ACTIONS(3629),
    [anon_sym_restrict] = ACTIONS(3629),
    [anon_sym_volatile] = ACTIONS(3629),
    [anon_sym__Atomic] = ACTIONS(3629),
    [anon_sym_mutable] = ACTIONS(3629),
    [anon_sym_explicit] = ACTIONS(3629),
    [anon_sym_constexpr] = ACTIONS(3629),
    [anon_sym_unsigned] = ACTIONS(3629),
    [anon_sym_long] = ACTIONS(3629),
    [anon_sym_short] = ACTIONS(3629),
    [sym_primitive_type] = ACTIONS(3629),
    [anon_sym_enum] = ACTIONS(3629),
    [anon_sym_struct] = ACTIONS(3629),
    [anon_sym_union] = ACTIONS(3629),
    [anon_sym_AMP] = ACTIONS(3629),
    [anon_sym_AMP_AMP] = ACTIONS(3627),
    [anon_sym_TILDE] = ACTIONS(3627),
    [sym_identifier] = ACTIONS(3629),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(3629),
    [anon_sym_public] = ACTIONS(3629),
    [sym_auto] = ACTIONS(3629),
    [anon_sym_typename] = ACTIONS(3629),
    [anon_sym_template] = ACTIONS(3629),
    [anon_sym_friend] = ACTIONS(3629),
    [anon_sym_private] = ACTIONS(3629),
    [anon_sym_protected] = ACTIONS(3629),
    [anon_sym_using] = ACTIONS(3629),
    [anon_sym_COLON_COLON] = ACTIONS(3627),
    [sym_operator_name] = ACTIONS(3627),
  },
  [1071] = {
    [sym__declaration_specifiers] = STATE(1667),
    [sym_storage_class_specifier] = STATE(374),
    [sym_type_qualifier] = STATE(374),
    [sym__type_specifier] = STATE(367),
    [sym_sized_type_specifier] = STATE(367),
    [sym_enum_specifier] = STATE(367),
    [sym_struct_specifier] = STATE(367),
    [sym_union_specifier] = STATE(367),
    [sym__expression] = STATE(1668),
    [sym_conditional_expression] = STATE(1668),
    [sym_assignment_expression] = STATE(1668),
    [sym_pointer_expression] = STATE(1668),
    [sym_logical_expression] = STATE(1668),
    [sym_bitwise_expression] = STATE(1668),
    [sym_equality_expression] = STATE(1668),
    [sym_relational_expression] = STATE(1668),
    [sym_shift_expression] = STATE(1668),
    [sym_math_expression] = STATE(1668),
    [sym_cast_expression] = STATE(1668),
    [sym_sizeof_expression] = STATE(1668),
    [sym_subscript_expression] = STATE(1668),
    [sym_call_expression] = STATE(1668),
    [sym_field_expression] = STATE(1668),
    [sym_compound_literal_expression] = STATE(1668),
    [sym_parenthesized_expression] = STATE(1668),
    [sym_concatenated_string] = STATE(1668),
    [sym_macro_type_specifier] = STATE(367),
    [sym_class_specifier] = STATE(367),
    [sym_dependent_type] = STATE(367),
    [sym_template_type] = STATE(369),
    [sym_template_function] = STATE(1668),
    [sym_new_expression] = STATE(1668),
    [sym_delete_expression] = STATE(1668),
    [sym_lambda_expression] = STATE(1668),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(372),
    [sym_scoped_namespace_identifier] = STATE(373),
    [aux_sym__declaration_specifiers_repeat1] = STATE(374),
    [aux_sym_sized_type_specifier_repeat1] = STATE(375),
    [sym_raw_string_literal] = ACTIONS(3631),
    [anon_sym_LPAREN] = ACTIONS(566),
    [anon_sym_extern] = ACTIONS(154),
    [anon_sym_STAR] = ACTIONS(568),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_RBRACK] = ACTIONS(3633),
    [anon_sym_static] = ACTIONS(154),
    [anon_sym_register] = ACTIONS(154),
    [anon_sym_inline] = ACTIONS(154),
    [anon_sym_const] = ACTIONS(158),
    [anon_sym_restrict] = ACTIONS(158),
    [anon_sym_volatile] = ACTIONS(158),
    [anon_sym__Atomic] = ACTIONS(158),
    [anon_sym_mutable] = ACTIONS(158),
    [anon_sym_explicit] = ACTIONS(158),
    [anon_sym_constexpr] = ACTIONS(158),
    [anon_sym_unsigned] = ACTIONS(574),
    [anon_sym_long] = ACTIONS(574),
    [anon_sym_short] = ACTIONS(574),
    [sym_primitive_type] = ACTIONS(576),
    [anon_sym_enum] = ACTIONS(578),
    [anon_sym_struct] = ACTIONS(580),
    [anon_sym_union] = ACTIONS(582),
    [anon_sym_AMP] = ACTIONS(568),
    [anon_sym_BANG] = ACTIONS(584),
    [anon_sym_TILDE] = ACTIONS(586),
    [anon_sym_PLUS] = ACTIONS(588),
    [anon_sym_DASH] = ACTIONS(588),
    [anon_sym_DASH_DASH] = ACTIONS(590),
    [anon_sym_PLUS_PLUS] = ACTIONS(590),
    [anon_sym_sizeof] = ACTIONS(592),
    [sym_number_literal] = ACTIONS(3631),
    [sym_char_literal] = ACTIONS(3631),
    [sym_string_literal] = ACTIONS(594),
    [sym_true] = ACTIONS(3635),
    [sym_false] = ACTIONS(3635),
    [sym_null] = ACTIONS(3635),
    [sym_identifier] = ACTIONS(598),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(600),
    [sym_auto] = ACTIONS(576),
    [anon_sym_typename] = ACTIONS(602),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(606),
    [anon_sym_delete] = ACTIONS(608),
    [sym_nullptr] = ACTIONS(3635),
  },
  [1072] = {
    [sym__expression] = STATE(1669),
    [sym_conditional_expression] = STATE(1669),
    [sym_assignment_expression] = STATE(1669),
    [sym_pointer_expression] = STATE(1669),
    [sym_logical_expression] = STATE(1669),
    [sym_bitwise_expression] = STATE(1669),
    [sym_equality_expression] = STATE(1669),
    [sym_relational_expression] = STATE(1669),
    [sym_shift_expression] = STATE(1669),
    [sym_math_expression] = STATE(1669),
    [sym_cast_expression] = STATE(1669),
    [sym_sizeof_expression] = STATE(1669),
    [sym_subscript_expression] = STATE(1669),
    [sym_call_expression] = STATE(1669),
    [sym_field_expression] = STATE(1669),
    [sym_compound_literal_expression] = STATE(1669),
    [sym_parenthesized_expression] = STATE(1669),
    [sym_concatenated_string] = STATE(1669),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(1669),
    [sym_new_expression] = STATE(1669),
    [sym_delete_expression] = STATE(1669),
    [sym_lambda_expression] = STATE(1669),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(3637),
    [anon_sym_LPAREN] = ACTIONS(1347),
    [anon_sym_STAR] = ACTIONS(1349),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_AMP] = ACTIONS(1349),
    [anon_sym_BANG] = ACTIONS(1351),
    [anon_sym_TILDE] = ACTIONS(1353),
    [anon_sym_PLUS] = ACTIONS(1355),
    [anon_sym_DASH] = ACTIONS(1355),
    [anon_sym_DASH_DASH] = ACTIONS(1357),
    [anon_sym_PLUS_PLUS] = ACTIONS(1357),
    [anon_sym_sizeof] = ACTIONS(1359),
    [sym_number_literal] = ACTIONS(3637),
    [sym_char_literal] = ACTIONS(3637),
    [sym_string_literal] = ACTIONS(1361),
    [sym_true] = ACTIONS(3639),
    [sym_false] = ACTIONS(3639),
    [sym_null] = ACTIONS(3639),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1365),
    [anon_sym_delete] = ACTIONS(1367),
    [sym_nullptr] = ACTIONS(3639),
  },
  [1073] = {
    [anon_sym_LPAREN] = ACTIONS(3641),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3643),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3641),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3641),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3641),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(3641),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(3641),
    [anon_sym_typedef] = ACTIONS(3643),
    [anon_sym_extern] = ACTIONS(3643),
    [anon_sym_RBRACE] = ACTIONS(3641),
    [anon_sym_STAR] = ACTIONS(3641),
    [anon_sym_static] = ACTIONS(3643),
    [anon_sym_register] = ACTIONS(3643),
    [anon_sym_inline] = ACTIONS(3643),
    [anon_sym_const] = ACTIONS(3643),
    [anon_sym_restrict] = ACTIONS(3643),
    [anon_sym_volatile] = ACTIONS(3643),
    [anon_sym__Atomic] = ACTIONS(3643),
    [anon_sym_mutable] = ACTIONS(3643),
    [anon_sym_explicit] = ACTIONS(3643),
    [anon_sym_constexpr] = ACTIONS(3643),
    [anon_sym_unsigned] = ACTIONS(3643),
    [anon_sym_long] = ACTIONS(3643),
    [anon_sym_short] = ACTIONS(3643),
    [sym_primitive_type] = ACTIONS(3643),
    [anon_sym_enum] = ACTIONS(3643),
    [anon_sym_struct] = ACTIONS(3643),
    [anon_sym_union] = ACTIONS(3643),
    [anon_sym_AMP] = ACTIONS(3643),
    [anon_sym_AMP_AMP] = ACTIONS(3641),
    [anon_sym_TILDE] = ACTIONS(3641),
    [sym_identifier] = ACTIONS(3643),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(3643),
    [anon_sym_public] = ACTIONS(3643),
    [sym_auto] = ACTIONS(3643),
    [anon_sym_typename] = ACTIONS(3643),
    [anon_sym_template] = ACTIONS(3643),
    [anon_sym_friend] = ACTIONS(3643),
    [anon_sym_private] = ACTIONS(3643),
    [anon_sym_protected] = ACTIONS(3643),
    [anon_sym_using] = ACTIONS(3643),
    [anon_sym_COLON_COLON] = ACTIONS(3641),
    [sym_operator_name] = ACTIONS(3641),
  },
  [1074] = {
    [sym_type_qualifier] = STATE(1671),
    [sym_trailing_return_type] = STATE(1671),
    [aux_sym_function_declarator_repeat1] = STATE(1671),
    [anon_sym_LPAREN] = ACTIONS(3645),
    [anon_sym_COMMA] = ACTIONS(3645),
    [anon_sym_SEMI] = ACTIONS(3645),
    [anon_sym_LBRACE] = ACTIONS(3645),
    [anon_sym_LBRACK] = ACTIONS(3645),
    [anon_sym_const] = ACTIONS(612),
    [anon_sym_restrict] = ACTIONS(614),
    [anon_sym_volatile] = ACTIONS(614),
    [anon_sym__Atomic] = ACTIONS(614),
    [anon_sym_mutable] = ACTIONS(614),
    [anon_sym_explicit] = ACTIONS(614),
    [anon_sym_constexpr] = ACTIONS(614),
    [anon_sym_COLON] = ACTIONS(3645),
    [anon_sym_DASH_GT] = ACTIONS(3647),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(3649),
  },
  [1075] = {
    [aux_sym_field_declaration_repeat1] = STATE(1673),
    [anon_sym_COMMA] = ACTIONS(2082),
    [anon_sym_SEMI] = ACTIONS(3606),
    [anon_sym_COLON] = ACTIONS(3651),
    [sym_comment] = ACTIONS(49),
  },
  [1076] = {
    [sym_destructor_name] = STATE(1538),
    [anon_sym_TILDE] = ACTIONS(45),
    [sym_identifier] = ACTIONS(3653),
    [sym_comment] = ACTIONS(49),
    [sym_operator_name] = ACTIONS(3334),
  },
  [1077] = {
    [sym_type_qualifier] = STATE(279),
    [sym__type_specifier] = STATE(277),
    [sym_sized_type_specifier] = STATE(277),
    [sym_enum_specifier] = STATE(277),
    [sym_struct_specifier] = STATE(277),
    [sym_union_specifier] = STATE(277),
    [sym_type_descriptor] = STATE(1676),
    [sym_parenthesized_expression] = STATE(1676),
    [sym_macro_type_specifier] = STATE(277),
    [sym_class_specifier] = STATE(277),
    [sym_dependent_type] = STATE(277),
    [sym_template_type] = STATE(62),
    [sym_scoped_type_identifier] = STATE(34),
    [sym_scoped_namespace_identifier] = STATE(64),
    [aux_sym_type_definition_repeat1] = STATE(279),
    [aux_sym_sized_type_specifier_repeat1] = STATE(280),
    [anon_sym_LPAREN] = ACTIONS(422),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_restrict] = ACTIONS(93),
    [anon_sym_volatile] = ACTIONS(93),
    [anon_sym__Atomic] = ACTIONS(93),
    [anon_sym_mutable] = ACTIONS(93),
    [anon_sym_explicit] = ACTIONS(93),
    [anon_sym_constexpr] = ACTIONS(93),
    [anon_sym_unsigned] = ACTIONS(424),
    [anon_sym_long] = ACTIONS(424),
    [anon_sym_short] = ACTIONS(424),
    [sym_primitive_type] = ACTIONS(426),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(428),
    [anon_sym_union] = ACTIONS(430),
    [anon_sym_GT] = ACTIONS(3655),
    [sym_identifier] = ACTIONS(434),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(436),
    [sym_auto] = ACTIONS(426),
    [anon_sym_typename] = ACTIONS(438),
    [anon_sym_COLON_COLON] = ACTIONS(111),
  },
  [1078] = {
    [anon_sym_LPAREN] = ACTIONS(3657),
    [anon_sym_COMMA] = ACTIONS(3657),
    [anon_sym_RPAREN] = ACTIONS(3657),
    [anon_sym_SEMI] = ACTIONS(3657),
    [anon_sym_LBRACE] = ACTIONS(3657),
    [anon_sym_RBRACE] = ACTIONS(3657),
    [anon_sym_STAR] = ACTIONS(3659),
    [anon_sym_LBRACK] = ACTIONS(3657),
    [anon_sym_RBRACK] = ACTIONS(3657),
    [anon_sym_EQ] = ACTIONS(3659),
    [anon_sym_COLON] = ACTIONS(3657),
    [anon_sym_QMARK] = ACTIONS(3657),
    [anon_sym_STAR_EQ] = ACTIONS(3657),
    [anon_sym_SLASH_EQ] = ACTIONS(3657),
    [anon_sym_PERCENT_EQ] = ACTIONS(3657),
    [anon_sym_PLUS_EQ] = ACTIONS(3657),
    [anon_sym_DASH_EQ] = ACTIONS(3657),
    [anon_sym_LT_LT_EQ] = ACTIONS(3657),
    [anon_sym_GT_GT_EQ] = ACTIONS(3657),
    [anon_sym_AMP_EQ] = ACTIONS(3657),
    [anon_sym_CARET_EQ] = ACTIONS(3657),
    [anon_sym_PIPE_EQ] = ACTIONS(3657),
    [anon_sym_AMP] = ACTIONS(3659),
    [anon_sym_PIPE_PIPE] = ACTIONS(3657),
    [anon_sym_AMP_AMP] = ACTIONS(3657),
    [anon_sym_PIPE] = ACTIONS(3659),
    [anon_sym_CARET] = ACTIONS(3659),
    [anon_sym_EQ_EQ] = ACTIONS(3657),
    [anon_sym_BANG_EQ] = ACTIONS(3657),
    [anon_sym_LT] = ACTIONS(3659),
    [anon_sym_GT] = ACTIONS(3659),
    [anon_sym_LT_EQ] = ACTIONS(3657),
    [anon_sym_GT_EQ] = ACTIONS(3657),
    [anon_sym_LT_LT] = ACTIONS(3659),
    [anon_sym_GT_GT] = ACTIONS(3659),
    [anon_sym_PLUS] = ACTIONS(3659),
    [anon_sym_DASH] = ACTIONS(3659),
    [anon_sym_SLASH] = ACTIONS(3659),
    [anon_sym_PERCENT] = ACTIONS(3659),
    [anon_sym_DASH_DASH] = ACTIONS(3657),
    [anon_sym_PLUS_PLUS] = ACTIONS(3657),
    [anon_sym_DOT] = ACTIONS(3657),
    [anon_sym_DASH_GT] = ACTIONS(3657),
    [sym_comment] = ACTIONS(49),
  },
  [1079] = {
    [sym__type_specifier] = STATE(1678),
    [sym_sized_type_specifier] = STATE(1678),
    [sym_enum_specifier] = STATE(1678),
    [sym_struct_specifier] = STATE(1678),
    [sym_union_specifier] = STATE(1678),
    [sym_macro_type_specifier] = STATE(1678),
    [sym_class_specifier] = STATE(1678),
    [sym_dependent_type] = STATE(1678),
    [sym_template_type] = STATE(825),
    [sym_scoped_type_identifier] = STATE(826),
    [sym_scoped_namespace_identifier] = STATE(827),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1679),
    [anon_sym_unsigned] = ACTIONS(3661),
    [anon_sym_long] = ACTIONS(3661),
    [anon_sym_short] = ACTIONS(3661),
    [sym_primitive_type] = ACTIONS(3663),
    [anon_sym_enum] = ACTIONS(1582),
    [anon_sym_struct] = ACTIONS(1584),
    [anon_sym_union] = ACTIONS(1586),
    [sym_identifier] = ACTIONS(1588),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(1590),
    [sym_auto] = ACTIONS(3663),
    [anon_sym_typename] = ACTIONS(3665),
    [anon_sym_COLON_COLON] = ACTIONS(1594),
  },
  [1080] = {
    [sym_type_qualifier] = STATE(1680),
    [sym_trailing_return_type] = STATE(1680),
    [aux_sym_function_declarator_repeat1] = STATE(1680),
    [anon_sym_LPAREN] = ACTIONS(1596),
    [anon_sym_SEMI] = ACTIONS(1596),
    [anon_sym_LBRACE] = ACTIONS(1596),
    [anon_sym_LBRACK] = ACTIONS(1596),
    [anon_sym_const] = ACTIONS(612),
    [anon_sym_restrict] = ACTIONS(614),
    [anon_sym_volatile] = ACTIONS(614),
    [anon_sym__Atomic] = ACTIONS(614),
    [anon_sym_mutable] = ACTIONS(614),
    [anon_sym_explicit] = ACTIONS(614),
    [anon_sym_constexpr] = ACTIONS(614),
    [anon_sym_COLON] = ACTIONS(1596),
    [anon_sym_DASH_GT] = ACTIONS(2102),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(3667),
  },
  [1081] = {
    [anon_sym_LPAREN] = ACTIONS(1622),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1624),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(1622),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1622),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1622),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(1622),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(1622),
    [anon_sym_typedef] = ACTIONS(1624),
    [anon_sym_extern] = ACTIONS(1624),
    [anon_sym_RBRACE] = ACTIONS(1622),
    [anon_sym_STAR] = ACTIONS(1622),
    [anon_sym_static] = ACTIONS(1624),
    [anon_sym_register] = ACTIONS(1624),
    [anon_sym_inline] = ACTIONS(1624),
    [anon_sym_const] = ACTIONS(1624),
    [anon_sym_restrict] = ACTIONS(1624),
    [anon_sym_volatile] = ACTIONS(1624),
    [anon_sym__Atomic] = ACTIONS(1624),
    [anon_sym_mutable] = ACTIONS(1624),
    [anon_sym_explicit] = ACTIONS(1624),
    [anon_sym_constexpr] = ACTIONS(1624),
    [anon_sym_unsigned] = ACTIONS(1624),
    [anon_sym_long] = ACTIONS(1624),
    [anon_sym_short] = ACTIONS(1624),
    [sym_primitive_type] = ACTIONS(1624),
    [anon_sym_enum] = ACTIONS(1624),
    [anon_sym_struct] = ACTIONS(1624),
    [anon_sym_union] = ACTIONS(1624),
    [anon_sym_AMP] = ACTIONS(1624),
    [anon_sym_AMP_AMP] = ACTIONS(1622),
    [anon_sym_TILDE] = ACTIONS(1622),
    [sym_identifier] = ACTIONS(1624),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(1624),
    [anon_sym_public] = ACTIONS(1624),
    [sym_auto] = ACTIONS(1624),
    [anon_sym_typename] = ACTIONS(1624),
    [anon_sym_template] = ACTIONS(1624),
    [anon_sym_friend] = ACTIONS(1624),
    [anon_sym_private] = ACTIONS(1624),
    [anon_sym_protected] = ACTIONS(1624),
    [anon_sym_using] = ACTIONS(1624),
    [anon_sym_COLON_COLON] = ACTIONS(1622),
    [sym_operator_name] = ACTIONS(1622),
  },
  [1082] = {
    [sym_preproc_include] = STATE(913),
    [sym_preproc_def] = STATE(913),
    [sym_preproc_function_def] = STATE(913),
    [sym_preproc_call] = STATE(913),
    [sym_preproc_if_in_compound_statement] = STATE(410),
    [sym_preproc_ifdef_in_compound_statement] = STATE(411),
    [sym_declaration] = STATE(913),
    [sym_type_definition] = STATE(913),
    [sym__declaration_specifiers] = STATE(412),
    [sym_compound_statement] = STATE(913),
    [sym_storage_class_specifier] = STATE(419),
    [sym_type_qualifier] = STATE(419),
    [sym__type_specifier] = STATE(30),
    [sym_sized_type_specifier] = STATE(30),
    [sym_enum_specifier] = STATE(30),
    [sym_struct_specifier] = STATE(30),
    [sym_union_specifier] = STATE(30),
    [sym_labeled_statement] = STATE(913),
    [sym_expression_statement] = STATE(913),
    [sym_if_statement] = STATE(913),
    [sym_switch_statement] = STATE(913),
    [sym_case_statement] = STATE(913),
    [sym_while_statement] = STATE(913),
    [sym_do_statement] = STATE(913),
    [sym_for_statement] = STATE(913),
    [sym_return_statement] = STATE(913),
    [sym_break_statement] = STATE(913),
    [sym_continue_statement] = STATE(913),
    [sym_goto_statement] = STATE(913),
    [sym__expression] = STATE(413),
    [sym_comma_expression] = STATE(414),
    [sym_conditional_expression] = STATE(413),
    [sym_assignment_expression] = STATE(413),
    [sym_pointer_expression] = STATE(413),
    [sym_logical_expression] = STATE(413),
    [sym_bitwise_expression] = STATE(413),
    [sym_equality_expression] = STATE(413),
    [sym_relational_expression] = STATE(413),
    [sym_shift_expression] = STATE(413),
    [sym_math_expression] = STATE(413),
    [sym_cast_expression] = STATE(413),
    [sym_sizeof_expression] = STATE(413),
    [sym_subscript_expression] = STATE(413),
    [sym_call_expression] = STATE(413),
    [sym_field_expression] = STATE(413),
    [sym_compound_literal_expression] = STATE(413),
    [sym_parenthesized_expression] = STATE(413),
    [sym_concatenated_string] = STATE(413),
    [sym__empty_declaration] = STATE(913),
    [sym_macro_type_specifier] = STATE(30),
    [sym_class_specifier] = STATE(30),
    [sym_dependent_type] = STATE(30),
    [sym_structured_binding_declaration] = STATE(913),
    [sym_template_type] = STATE(415),
    [sym_template_function] = STATE(413),
    [sym_for_range_loop] = STATE(913),
    [sym_new_expression] = STATE(413),
    [sym_delete_expression] = STATE(413),
    [sym_lambda_expression] = STATE(413),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(416),
    [sym_scoped_namespace_identifier] = STATE(417),
    [aux_sym_preproc_if_in_compound_statement_repeat1] = STATE(913),
    [aux_sym__declaration_specifiers_repeat1] = STATE(419),
    [aux_sym_sized_type_specifier_repeat1] = STATE(38),
    [sym_raw_string_literal] = ACTIONS(620),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(622),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(624),
    [anon_sym_LPAREN] = ACTIONS(626),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(628),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(630),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(632),
    [sym_preproc_directive] = ACTIONS(634),
    [anon_sym_SEMI] = ACTIONS(636),
    [anon_sym_typedef] = ACTIONS(638),
    [anon_sym_extern] = ACTIONS(154),
    [anon_sym_LBRACE] = ACTIONS(640),
    [anon_sym_RBRACE] = ACTIONS(3669),
    [anon_sym_STAR] = ACTIONS(644),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_static] = ACTIONS(154),
    [anon_sym_register] = ACTIONS(154),
    [anon_sym_inline] = ACTIONS(154),
    [anon_sym_const] = ACTIONS(158),
    [anon_sym_restrict] = ACTIONS(158),
    [anon_sym_volatile] = ACTIONS(158),
    [anon_sym__Atomic] = ACTIONS(158),
    [anon_sym_mutable] = ACTIONS(158),
    [anon_sym_explicit] = ACTIONS(158),
    [anon_sym_constexpr] = ACTIONS(158),
    [anon_sym_unsigned] = ACTIONS(31),
    [anon_sym_long] = ACTIONS(31),
    [anon_sym_short] = ACTIONS(31),
    [sym_primitive_type] = ACTIONS(33),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_union] = ACTIONS(39),
    [anon_sym_if] = ACTIONS(646),
    [anon_sym_switch] = ACTIONS(648),
    [anon_sym_case] = ACTIONS(650),
    [anon_sym_default] = ACTIONS(652),
    [anon_sym_while] = ACTIONS(654),
    [anon_sym_do] = ACTIONS(656),
    [anon_sym_for] = ACTIONS(658),
    [anon_sym_return] = ACTIONS(660),
    [anon_sym_break] = ACTIONS(662),
    [anon_sym_continue] = ACTIONS(664),
    [anon_sym_goto] = ACTIONS(666),
    [anon_sym_AMP] = ACTIONS(644),
    [anon_sym_BANG] = ACTIONS(668),
    [anon_sym_TILDE] = ACTIONS(670),
    [anon_sym_PLUS] = ACTIONS(672),
    [anon_sym_DASH] = ACTIONS(672),
    [anon_sym_DASH_DASH] = ACTIONS(674),
    [anon_sym_PLUS_PLUS] = ACTIONS(674),
    [anon_sym_sizeof] = ACTIONS(676),
    [sym_number_literal] = ACTIONS(620),
    [sym_char_literal] = ACTIONS(620),
    [sym_string_literal] = ACTIONS(678),
    [sym_true] = ACTIONS(680),
    [sym_false] = ACTIONS(680),
    [sym_null] = ACTIONS(680),
    [sym_identifier] = ACTIONS(682),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(51),
    [sym_auto] = ACTIONS(33),
    [anon_sym_typename] = ACTIONS(53),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(684),
    [anon_sym_delete] = ACTIONS(686),
    [sym_nullptr] = ACTIONS(680),
  },
  [1083] = {
    [anon_sym_LPAREN] = ACTIONS(1788),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1790),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(1788),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1788),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1788),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(1788),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(1788),
    [anon_sym_typedef] = ACTIONS(1790),
    [anon_sym_extern] = ACTIONS(1790),
    [anon_sym_RBRACE] = ACTIONS(1788),
    [anon_sym_STAR] = ACTIONS(1788),
    [anon_sym_static] = ACTIONS(1790),
    [anon_sym_register] = ACTIONS(1790),
    [anon_sym_inline] = ACTIONS(1790),
    [anon_sym_const] = ACTIONS(1790),
    [anon_sym_restrict] = ACTIONS(1790),
    [anon_sym_volatile] = ACTIONS(1790),
    [anon_sym__Atomic] = ACTIONS(1790),
    [anon_sym_mutable] = ACTIONS(1790),
    [anon_sym_explicit] = ACTIONS(1790),
    [anon_sym_constexpr] = ACTIONS(1790),
    [anon_sym_unsigned] = ACTIONS(1790),
    [anon_sym_long] = ACTIONS(1790),
    [anon_sym_short] = ACTIONS(1790),
    [sym_primitive_type] = ACTIONS(1790),
    [anon_sym_enum] = ACTIONS(1790),
    [anon_sym_struct] = ACTIONS(1790),
    [anon_sym_union] = ACTIONS(1790),
    [anon_sym_AMP] = ACTIONS(1790),
    [anon_sym_AMP_AMP] = ACTIONS(1788),
    [anon_sym_TILDE] = ACTIONS(1788),
    [sym_identifier] = ACTIONS(1790),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(1790),
    [anon_sym_public] = ACTIONS(1790),
    [sym_auto] = ACTIONS(1790),
    [anon_sym_typename] = ACTIONS(1790),
    [anon_sym_template] = ACTIONS(1790),
    [anon_sym_friend] = ACTIONS(1790),
    [anon_sym_private] = ACTIONS(1790),
    [anon_sym_protected] = ACTIONS(1790),
    [anon_sym_using] = ACTIONS(1790),
    [anon_sym_COLON_COLON] = ACTIONS(1788),
    [sym_operator_name] = ACTIONS(1788),
  },
  [1084] = {
    [sym_storage_class_specifier] = STATE(1084),
    [sym_type_qualifier] = STATE(1084),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1084),
    [anon_sym_LPAREN] = ACTIONS(798),
    [anon_sym_SEMI] = ACTIONS(798),
    [anon_sym_extern] = ACTIONS(1792),
    [anon_sym_STAR] = ACTIONS(798),
    [anon_sym_static] = ACTIONS(1792),
    [anon_sym_register] = ACTIONS(1792),
    [anon_sym_inline] = ACTIONS(1792),
    [anon_sym_const] = ACTIONS(1795),
    [anon_sym_restrict] = ACTIONS(1795),
    [anon_sym_volatile] = ACTIONS(1795),
    [anon_sym__Atomic] = ACTIONS(1795),
    [anon_sym_mutable] = ACTIONS(1795),
    [anon_sym_explicit] = ACTIONS(1795),
    [anon_sym_constexpr] = ACTIONS(1795),
    [anon_sym_COLON] = ACTIONS(806),
    [anon_sym_AMP] = ACTIONS(806),
    [anon_sym_AMP_AMP] = ACTIONS(798),
    [sym_identifier] = ACTIONS(806),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(798),
    [sym_operator_name] = ACTIONS(798),
  },
  [1085] = {
    [anon_sym_LPAREN] = ACTIONS(1798),
    [anon_sym_SEMI] = ACTIONS(1801),
    [anon_sym_extern] = ACTIONS(1803),
    [anon_sym_STAR] = ACTIONS(1801),
    [anon_sym_LBRACK] = ACTIONS(1807),
    [anon_sym_static] = ACTIONS(1803),
    [anon_sym_register] = ACTIONS(1803),
    [anon_sym_inline] = ACTIONS(1803),
    [anon_sym_const] = ACTIONS(1803),
    [anon_sym_restrict] = ACTIONS(1803),
    [anon_sym_volatile] = ACTIONS(1803),
    [anon_sym__Atomic] = ACTIONS(1803),
    [anon_sym_mutable] = ACTIONS(1803),
    [anon_sym_explicit] = ACTIONS(1803),
    [anon_sym_constexpr] = ACTIONS(1803),
    [anon_sym_COLON] = ACTIONS(1803),
    [anon_sym_AMP] = ACTIONS(1803),
    [anon_sym_AMP_AMP] = ACTIONS(1801),
    [anon_sym_LT] = ACTIONS(1798),
    [sym_identifier] = ACTIONS(1803),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(1805),
    [sym_operator_name] = ACTIONS(1801),
  },
  [1086] = {
    [sym_compound_statement] = STATE(1682),
    [anon_sym_LBRACE] = ACTIONS(1049),
    [sym_comment] = ACTIONS(49),
  },
  [1087] = {
    [sym_storage_class_specifier] = STATE(1084),
    [sym_type_qualifier] = STATE(1084),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1084),
    [anon_sym_LPAREN] = ACTIONS(1811),
    [anon_sym_SEMI] = ACTIONS(1811),
    [anon_sym_extern] = ACTIONS(218),
    [anon_sym_STAR] = ACTIONS(1811),
    [anon_sym_static] = ACTIONS(218),
    [anon_sym_register] = ACTIONS(218),
    [anon_sym_inline] = ACTIONS(218),
    [anon_sym_const] = ACTIONS(220),
    [anon_sym_restrict] = ACTIONS(220),
    [anon_sym_volatile] = ACTIONS(220),
    [anon_sym__Atomic] = ACTIONS(220),
    [anon_sym_mutable] = ACTIONS(220),
    [anon_sym_explicit] = ACTIONS(220),
    [anon_sym_constexpr] = ACTIONS(220),
    [anon_sym_COLON] = ACTIONS(1813),
    [anon_sym_AMP] = ACTIONS(1813),
    [anon_sym_AMP_AMP] = ACTIONS(1811),
    [sym_identifier] = ACTIONS(1813),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(1811),
    [sym_operator_name] = ACTIONS(1811),
  },
  [1088] = {
    [aux_sym_base_class_clause_repeat1] = STATE(1091),
    [anon_sym_COMMA] = ACTIONS(1069),
    [anon_sym_LBRACE] = ACTIONS(3671),
    [sym_comment] = ACTIONS(49),
  },
  [1089] = {
    [sym__class_name] = STATE(1683),
    [sym_template_type] = STATE(196),
    [sym_scoped_type_identifier] = STATE(80),
    [sym_scoped_namespace_identifier] = STATE(64),
    [sym_identifier] = ACTIONS(1067),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(111),
  },
  [1090] = {
    [anon_sym_COMMA] = ACTIONS(3673),
    [anon_sym_LBRACE] = ACTIONS(3673),
    [sym_comment] = ACTIONS(49),
  },
  [1091] = {
    [aux_sym_base_class_clause_repeat1] = STATE(1091),
    [anon_sym_COMMA] = ACTIONS(3675),
    [anon_sym_LBRACE] = ACTIONS(3673),
    [sym_comment] = ACTIONS(49),
  },
  [1092] = {
    [anon_sym_RPAREN] = ACTIONS(3678),
    [sym_comment] = ACTIONS(49),
  },
  [1093] = {
    [sym_type_qualifier] = STATE(724),
    [sym__type_specifier] = STATE(720),
    [sym_sized_type_specifier] = STATE(720),
    [sym_enum_specifier] = STATE(720),
    [sym_struct_specifier] = STATE(720),
    [sym_union_specifier] = STATE(720),
    [sym__expression] = STATE(721),
    [sym_comma_expression] = STATE(722),
    [sym_conditional_expression] = STATE(721),
    [sym_assignment_expression] = STATE(721),
    [sym_pointer_expression] = STATE(721),
    [sym_logical_expression] = STATE(721),
    [sym_bitwise_expression] = STATE(721),
    [sym_equality_expression] = STATE(721),
    [sym_relational_expression] = STATE(721),
    [sym_shift_expression] = STATE(721),
    [sym_math_expression] = STATE(721),
    [sym_cast_expression] = STATE(721),
    [sym_type_descriptor] = STATE(1685),
    [sym_sizeof_expression] = STATE(721),
    [sym_subscript_expression] = STATE(721),
    [sym_call_expression] = STATE(721),
    [sym_field_expression] = STATE(721),
    [sym_compound_literal_expression] = STATE(721),
    [sym_parenthesized_expression] = STATE(721),
    [sym_concatenated_string] = STATE(721),
    [sym_macro_type_specifier] = STATE(720),
    [sym_class_specifier] = STATE(720),
    [sym_dependent_type] = STATE(720),
    [sym_template_type] = STATE(415),
    [sym_template_function] = STATE(721),
    [sym_new_expression] = STATE(721),
    [sym_delete_expression] = STATE(721),
    [sym_lambda_expression] = STATE(721),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(416),
    [sym_scoped_namespace_identifier] = STATE(417),
    [aux_sym_type_definition_repeat1] = STATE(724),
    [aux_sym_sized_type_specifier_repeat1] = STATE(725),
    [sym_raw_string_literal] = ACTIONS(1397),
    [anon_sym_LPAREN] = ACTIONS(1087),
    [anon_sym_STAR] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_restrict] = ACTIONS(93),
    [anon_sym_volatile] = ACTIONS(93),
    [anon_sym__Atomic] = ACTIONS(93),
    [anon_sym_mutable] = ACTIONS(93),
    [anon_sym_explicit] = ACTIONS(93),
    [anon_sym_constexpr] = ACTIONS(93),
    [anon_sym_unsigned] = ACTIONS(1399),
    [anon_sym_long] = ACTIONS(1399),
    [anon_sym_short] = ACTIONS(1399),
    [sym_primitive_type] = ACTIONS(1401),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(428),
    [anon_sym_union] = ACTIONS(430),
    [anon_sym_AMP] = ACTIONS(1089),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1093),
    [anon_sym_PLUS] = ACTIONS(1095),
    [anon_sym_DASH] = ACTIONS(1095),
    [anon_sym_DASH_DASH] = ACTIONS(1097),
    [anon_sym_PLUS_PLUS] = ACTIONS(1097),
    [anon_sym_sizeof] = ACTIONS(1099),
    [sym_number_literal] = ACTIONS(1397),
    [sym_char_literal] = ACTIONS(1397),
    [sym_string_literal] = ACTIONS(1101),
    [sym_true] = ACTIONS(1403),
    [sym_false] = ACTIONS(1403),
    [sym_null] = ACTIONS(1403),
    [sym_identifier] = ACTIONS(1405),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(436),
    [sym_auto] = ACTIONS(1401),
    [anon_sym_typename] = ACTIONS(1407),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1409),
    [anon_sym_delete] = ACTIONS(1109),
    [sym_nullptr] = ACTIONS(1403),
  },
  [1094] = {
    [sym_argument_list] = STATE(802),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_COMMA] = ACTIONS(2702),
    [anon_sym_RPAREN] = ACTIONS(2702),
    [anon_sym_STAR] = ACTIONS(2234),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_EQ] = ACTIONS(2704),
    [anon_sym_QMARK] = ACTIONS(2702),
    [anon_sym_STAR_EQ] = ACTIONS(2702),
    [anon_sym_SLASH_EQ] = ACTIONS(2702),
    [anon_sym_PERCENT_EQ] = ACTIONS(2702),
    [anon_sym_PLUS_EQ] = ACTIONS(2702),
    [anon_sym_DASH_EQ] = ACTIONS(2702),
    [anon_sym_LT_LT_EQ] = ACTIONS(2702),
    [anon_sym_GT_GT_EQ] = ACTIONS(2702),
    [anon_sym_AMP_EQ] = ACTIONS(2702),
    [anon_sym_CARET_EQ] = ACTIONS(2702),
    [anon_sym_PIPE_EQ] = ACTIONS(2702),
    [anon_sym_AMP] = ACTIONS(2704),
    [anon_sym_PIPE_PIPE] = ACTIONS(2702),
    [anon_sym_AMP_AMP] = ACTIONS(2702),
    [anon_sym_PIPE] = ACTIONS(2704),
    [anon_sym_CARET] = ACTIONS(2704),
    [anon_sym_EQ_EQ] = ACTIONS(2702),
    [anon_sym_BANG_EQ] = ACTIONS(2702),
    [anon_sym_LT] = ACTIONS(2704),
    [anon_sym_GT] = ACTIONS(2704),
    [anon_sym_LT_EQ] = ACTIONS(2702),
    [anon_sym_GT_EQ] = ACTIONS(2702),
    [anon_sym_LT_LT] = ACTIONS(2258),
    [anon_sym_GT_GT] = ACTIONS(2258),
    [anon_sym_PLUS] = ACTIONS(2260),
    [anon_sym_DASH] = ACTIONS(2260),
    [anon_sym_SLASH] = ACTIONS(2234),
    [anon_sym_PERCENT] = ACTIONS(2234),
    [anon_sym_DASH_DASH] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(1554),
    [anon_sym_DASH_GT] = ACTIONS(1554),
    [sym_comment] = ACTIONS(49),
  },
  [1095] = {
    [aux_sym_concatenated_string_repeat1] = STATE(1686),
    [anon_sym_LPAREN] = ACTIONS(2706),
    [anon_sym_COMMA] = ACTIONS(2706),
    [anon_sym_RPAREN] = ACTIONS(2706),
    [anon_sym_STAR] = ACTIONS(2708),
    [anon_sym_LBRACK] = ACTIONS(2706),
    [anon_sym_EQ] = ACTIONS(2708),
    [anon_sym_QMARK] = ACTIONS(2706),
    [anon_sym_STAR_EQ] = ACTIONS(2706),
    [anon_sym_SLASH_EQ] = ACTIONS(2706),
    [anon_sym_PERCENT_EQ] = ACTIONS(2706),
    [anon_sym_PLUS_EQ] = ACTIONS(2706),
    [anon_sym_DASH_EQ] = ACTIONS(2706),
    [anon_sym_LT_LT_EQ] = ACTIONS(2706),
    [anon_sym_GT_GT_EQ] = ACTIONS(2706),
    [anon_sym_AMP_EQ] = ACTIONS(2706),
    [anon_sym_CARET_EQ] = ACTIONS(2706),
    [anon_sym_PIPE_EQ] = ACTIONS(2706),
    [anon_sym_AMP] = ACTIONS(2708),
    [anon_sym_PIPE_PIPE] = ACTIONS(2706),
    [anon_sym_AMP_AMP] = ACTIONS(2706),
    [anon_sym_PIPE] = ACTIONS(2708),
    [anon_sym_CARET] = ACTIONS(2708),
    [anon_sym_EQ_EQ] = ACTIONS(2706),
    [anon_sym_BANG_EQ] = ACTIONS(2706),
    [anon_sym_LT] = ACTIONS(2708),
    [anon_sym_GT] = ACTIONS(2708),
    [anon_sym_LT_EQ] = ACTIONS(2706),
    [anon_sym_GT_EQ] = ACTIONS(2706),
    [anon_sym_LT_LT] = ACTIONS(2708),
    [anon_sym_GT_GT] = ACTIONS(2708),
    [anon_sym_PLUS] = ACTIONS(2708),
    [anon_sym_DASH] = ACTIONS(2708),
    [anon_sym_SLASH] = ACTIONS(2708),
    [anon_sym_PERCENT] = ACTIONS(2708),
    [anon_sym_DASH_DASH] = ACTIONS(2706),
    [anon_sym_PLUS_PLUS] = ACTIONS(2706),
    [anon_sym_DOT] = ACTIONS(2706),
    [anon_sym_DASH_GT] = ACTIONS(2706),
    [sym_string_literal] = ACTIONS(3680),
    [sym_comment] = ACTIONS(49),
  },
  [1096] = {
    [sym_destructor_name] = STATE(282),
    [anon_sym_TILDE] = ACTIONS(1500),
    [sym_identifier] = ACTIONS(3682),
    [sym_comment] = ACTIONS(49),
    [sym_operator_name] = ACTIONS(442),
  },
  [1097] = {
    [anon_sym_LPAREN] = ACTIONS(704),
    [anon_sym_COMMA] = ACTIONS(704),
    [anon_sym_RPAREN] = ACTIONS(704),
    [anon_sym_SEMI] = ACTIONS(704),
    [anon_sym_LBRACE] = ACTIONS(447),
    [anon_sym_RBRACE] = ACTIONS(704),
    [anon_sym_STAR] = ACTIONS(706),
    [anon_sym_LBRACK] = ACTIONS(704),
    [anon_sym_RBRACK] = ACTIONS(704),
    [anon_sym_EQ] = ACTIONS(706),
    [anon_sym_COLON] = ACTIONS(706),
    [anon_sym_QMARK] = ACTIONS(704),
    [anon_sym_STAR_EQ] = ACTIONS(704),
    [anon_sym_SLASH_EQ] = ACTIONS(704),
    [anon_sym_PERCENT_EQ] = ACTIONS(704),
    [anon_sym_PLUS_EQ] = ACTIONS(704),
    [anon_sym_DASH_EQ] = ACTIONS(704),
    [anon_sym_LT_LT_EQ] = ACTIONS(704),
    [anon_sym_GT_GT_EQ] = ACTIONS(704),
    [anon_sym_AMP_EQ] = ACTIONS(704),
    [anon_sym_CARET_EQ] = ACTIONS(704),
    [anon_sym_PIPE_EQ] = ACTIONS(704),
    [anon_sym_AMP] = ACTIONS(706),
    [anon_sym_PIPE_PIPE] = ACTIONS(704),
    [anon_sym_AMP_AMP] = ACTIONS(704),
    [anon_sym_PIPE] = ACTIONS(706),
    [anon_sym_CARET] = ACTIONS(706),
    [anon_sym_EQ_EQ] = ACTIONS(704),
    [anon_sym_BANG_EQ] = ACTIONS(704),
    [anon_sym_LT] = ACTIONS(706),
    [anon_sym_GT] = ACTIONS(706),
    [anon_sym_LT_EQ] = ACTIONS(704),
    [anon_sym_GT_EQ] = ACTIONS(704),
    [anon_sym_LT_LT] = ACTIONS(706),
    [anon_sym_GT_GT] = ACTIONS(706),
    [anon_sym_PLUS] = ACTIONS(706),
    [anon_sym_DASH] = ACTIONS(706),
    [anon_sym_SLASH] = ACTIONS(706),
    [anon_sym_PERCENT] = ACTIONS(706),
    [anon_sym_DASH_DASH] = ACTIONS(704),
    [anon_sym_PLUS_PLUS] = ACTIONS(704),
    [anon_sym_DOT] = ACTIONS(704),
    [anon_sym_DASH_GT] = ACTIONS(704),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(447),
  },
  [1098] = {
    [anon_sym_LPAREN] = ACTIONS(518),
    [anon_sym_COMMA] = ACTIONS(518),
    [anon_sym_RPAREN] = ACTIONS(518),
    [anon_sym_SEMI] = ACTIONS(518),
    [anon_sym_LBRACE] = ACTIONS(512),
    [anon_sym_RBRACE] = ACTIONS(518),
    [anon_sym_STAR] = ACTIONS(520),
    [anon_sym_LBRACK] = ACTIONS(518),
    [anon_sym_RBRACK] = ACTIONS(518),
    [anon_sym_EQ] = ACTIONS(520),
    [anon_sym_COLON] = ACTIONS(520),
    [anon_sym_QMARK] = ACTIONS(518),
    [anon_sym_STAR_EQ] = ACTIONS(518),
    [anon_sym_SLASH_EQ] = ACTIONS(518),
    [anon_sym_PERCENT_EQ] = ACTIONS(518),
    [anon_sym_PLUS_EQ] = ACTIONS(518),
    [anon_sym_DASH_EQ] = ACTIONS(518),
    [anon_sym_LT_LT_EQ] = ACTIONS(518),
    [anon_sym_GT_GT_EQ] = ACTIONS(518),
    [anon_sym_AMP_EQ] = ACTIONS(518),
    [anon_sym_CARET_EQ] = ACTIONS(518),
    [anon_sym_PIPE_EQ] = ACTIONS(518),
    [anon_sym_AMP] = ACTIONS(520),
    [anon_sym_PIPE_PIPE] = ACTIONS(518),
    [anon_sym_AMP_AMP] = ACTIONS(518),
    [anon_sym_PIPE] = ACTIONS(520),
    [anon_sym_CARET] = ACTIONS(520),
    [anon_sym_EQ_EQ] = ACTIONS(518),
    [anon_sym_BANG_EQ] = ACTIONS(518),
    [anon_sym_LT] = ACTIONS(2729),
    [anon_sym_GT] = ACTIONS(520),
    [anon_sym_LT_EQ] = ACTIONS(518),
    [anon_sym_GT_EQ] = ACTIONS(518),
    [anon_sym_LT_LT] = ACTIONS(520),
    [anon_sym_GT_GT] = ACTIONS(520),
    [anon_sym_PLUS] = ACTIONS(520),
    [anon_sym_DASH] = ACTIONS(520),
    [anon_sym_SLASH] = ACTIONS(520),
    [anon_sym_PERCENT] = ACTIONS(520),
    [anon_sym_DASH_DASH] = ACTIONS(518),
    [anon_sym_PLUS_PLUS] = ACTIONS(518),
    [anon_sym_DOT] = ACTIONS(518),
    [anon_sym_DASH_GT] = ACTIONS(518),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(516),
  },
  [1099] = {
    [sym__expression] = STATE(1689),
    [sym_conditional_expression] = STATE(1689),
    [sym_assignment_expression] = STATE(1689),
    [sym_pointer_expression] = STATE(1689),
    [sym_logical_expression] = STATE(1689),
    [sym_bitwise_expression] = STATE(1689),
    [sym_equality_expression] = STATE(1689),
    [sym_relational_expression] = STATE(1689),
    [sym_shift_expression] = STATE(1689),
    [sym_math_expression] = STATE(1689),
    [sym_cast_expression] = STATE(1689),
    [sym_sizeof_expression] = STATE(1689),
    [sym_subscript_expression] = STATE(1689),
    [sym_call_expression] = STATE(1689),
    [sym_field_expression] = STATE(1689),
    [sym_compound_literal_expression] = STATE(1689),
    [sym_parenthesized_expression] = STATE(1689),
    [sym_concatenated_string] = STATE(1689),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(1689),
    [sym_new_expression] = STATE(1689),
    [sym_delete_expression] = STATE(1689),
    [sym_lambda_expression] = STATE(1689),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(3684),
    [anon_sym_LPAREN] = ACTIONS(1087),
    [anon_sym_STAR] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(3686),
    [anon_sym_AMP] = ACTIONS(1089),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1093),
    [anon_sym_PLUS] = ACTIONS(1095),
    [anon_sym_DASH] = ACTIONS(1095),
    [anon_sym_DASH_DASH] = ACTIONS(1097),
    [anon_sym_PLUS_PLUS] = ACTIONS(1097),
    [anon_sym_sizeof] = ACTIONS(1099),
    [sym_number_literal] = ACTIONS(3684),
    [sym_char_literal] = ACTIONS(3684),
    [sym_string_literal] = ACTIONS(1101),
    [sym_true] = ACTIONS(3688),
    [sym_false] = ACTIONS(3688),
    [sym_null] = ACTIONS(3688),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_delete] = ACTIONS(1109),
    [sym_nullptr] = ACTIONS(3688),
  },
  [1100] = {
    [sym__expression] = STATE(740),
    [sym_conditional_expression] = STATE(740),
    [sym_assignment_expression] = STATE(740),
    [sym_pointer_expression] = STATE(740),
    [sym_logical_expression] = STATE(740),
    [sym_bitwise_expression] = STATE(740),
    [sym_equality_expression] = STATE(740),
    [sym_relational_expression] = STATE(740),
    [sym_shift_expression] = STATE(740),
    [sym_math_expression] = STATE(740),
    [sym_cast_expression] = STATE(740),
    [sym_sizeof_expression] = STATE(740),
    [sym_subscript_expression] = STATE(740),
    [sym_call_expression] = STATE(740),
    [sym_field_expression] = STATE(740),
    [sym_compound_literal_expression] = STATE(740),
    [sym_parenthesized_expression] = STATE(740),
    [sym_concatenated_string] = STATE(740),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(740),
    [sym_new_expression] = STATE(740),
    [sym_delete_expression] = STATE(740),
    [sym_lambda_expression] = STATE(740),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_lambda_default_capture] = STATE(741),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(1417),
    [anon_sym_LPAREN] = ACTIONS(1419),
    [anon_sym_STAR] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_RBRACK] = ACTIONS(3690),
    [anon_sym_EQ] = ACTIONS(1425),
    [anon_sym_AMP] = ACTIONS(1427),
    [anon_sym_BANG] = ACTIONS(1429),
    [anon_sym_TILDE] = ACTIONS(1431),
    [anon_sym_PLUS] = ACTIONS(1433),
    [anon_sym_DASH] = ACTIONS(1433),
    [anon_sym_DASH_DASH] = ACTIONS(1435),
    [anon_sym_PLUS_PLUS] = ACTIONS(1435),
    [anon_sym_sizeof] = ACTIONS(1437),
    [sym_number_literal] = ACTIONS(1417),
    [sym_char_literal] = ACTIONS(1417),
    [sym_string_literal] = ACTIONS(1439),
    [sym_true] = ACTIONS(1441),
    [sym_false] = ACTIONS(1441),
    [sym_null] = ACTIONS(1441),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1443),
    [anon_sym_delete] = ACTIONS(1445),
    [sym_nullptr] = ACTIONS(1441),
  },
  [1101] = {
    [sym_argument_list] = STATE(802),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_COMMA] = ACTIONS(2740),
    [anon_sym_RPAREN] = ACTIONS(2740),
    [anon_sym_STAR] = ACTIONS(2234),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_EQ] = ACTIONS(2742),
    [anon_sym_QMARK] = ACTIONS(2740),
    [anon_sym_STAR_EQ] = ACTIONS(2740),
    [anon_sym_SLASH_EQ] = ACTIONS(2740),
    [anon_sym_PERCENT_EQ] = ACTIONS(2740),
    [anon_sym_PLUS_EQ] = ACTIONS(2740),
    [anon_sym_DASH_EQ] = ACTIONS(2740),
    [anon_sym_LT_LT_EQ] = ACTIONS(2740),
    [anon_sym_GT_GT_EQ] = ACTIONS(2740),
    [anon_sym_AMP_EQ] = ACTIONS(2740),
    [anon_sym_CARET_EQ] = ACTIONS(2740),
    [anon_sym_PIPE_EQ] = ACTIONS(2740),
    [anon_sym_AMP] = ACTIONS(2242),
    [anon_sym_PIPE_PIPE] = ACTIONS(2244),
    [anon_sym_AMP_AMP] = ACTIONS(2246),
    [anon_sym_PIPE] = ACTIONS(2248),
    [anon_sym_CARET] = ACTIONS(2250),
    [anon_sym_EQ_EQ] = ACTIONS(2252),
    [anon_sym_BANG_EQ] = ACTIONS(2252),
    [anon_sym_LT] = ACTIONS(2254),
    [anon_sym_GT] = ACTIONS(2254),
    [anon_sym_LT_EQ] = ACTIONS(2256),
    [anon_sym_GT_EQ] = ACTIONS(2256),
    [anon_sym_LT_LT] = ACTIONS(2258),
    [anon_sym_GT_GT] = ACTIONS(2258),
    [anon_sym_PLUS] = ACTIONS(2260),
    [anon_sym_DASH] = ACTIONS(2260),
    [anon_sym_SLASH] = ACTIONS(2234),
    [anon_sym_PERCENT] = ACTIONS(2234),
    [anon_sym_DASH_DASH] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(1554),
    [anon_sym_DASH_GT] = ACTIONS(1554),
    [sym_comment] = ACTIONS(49),
  },
  [1102] = {
    [sym__expression] = STATE(1691),
    [sym_comma_expression] = STATE(1520),
    [sym_conditional_expression] = STATE(1691),
    [sym_assignment_expression] = STATE(1691),
    [sym_pointer_expression] = STATE(1691),
    [sym_logical_expression] = STATE(1691),
    [sym_bitwise_expression] = STATE(1691),
    [sym_equality_expression] = STATE(1691),
    [sym_relational_expression] = STATE(1691),
    [sym_shift_expression] = STATE(1691),
    [sym_math_expression] = STATE(1691),
    [sym_cast_expression] = STATE(1691),
    [sym_sizeof_expression] = STATE(1691),
    [sym_subscript_expression] = STATE(1691),
    [sym_call_expression] = STATE(1691),
    [sym_field_expression] = STATE(1691),
    [sym_compound_literal_expression] = STATE(1691),
    [sym_parenthesized_expression] = STATE(1691),
    [sym_concatenated_string] = STATE(1691),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(1691),
    [sym_new_expression] = STATE(1691),
    [sym_delete_expression] = STATE(1691),
    [sym_lambda_expression] = STATE(1691),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(3692),
    [anon_sym_LPAREN] = ACTIONS(1087),
    [anon_sym_STAR] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_AMP] = ACTIONS(1089),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1093),
    [anon_sym_PLUS] = ACTIONS(1095),
    [anon_sym_DASH] = ACTIONS(1095),
    [anon_sym_DASH_DASH] = ACTIONS(1097),
    [anon_sym_PLUS_PLUS] = ACTIONS(1097),
    [anon_sym_sizeof] = ACTIONS(1099),
    [sym_number_literal] = ACTIONS(3692),
    [sym_char_literal] = ACTIONS(3692),
    [sym_string_literal] = ACTIONS(1101),
    [sym_true] = ACTIONS(3694),
    [sym_false] = ACTIONS(3694),
    [sym_null] = ACTIONS(3694),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_delete] = ACTIONS(1109),
    [sym_nullptr] = ACTIONS(3694),
  },
  [1103] = {
    [anon_sym_COMMA] = ACTIONS(3696),
    [anon_sym_GT] = ACTIONS(3696),
    [sym_identifier] = ACTIONS(3696),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(3696),
  },
  [1104] = {
    [sym__expression] = STATE(1328),
    [sym_conditional_expression] = STATE(1328),
    [sym_assignment_expression] = STATE(1328),
    [sym_pointer_expression] = STATE(1328),
    [sym_logical_expression] = STATE(1328),
    [sym_bitwise_expression] = STATE(1328),
    [sym_equality_expression] = STATE(1328),
    [sym_relational_expression] = STATE(1328),
    [sym_shift_expression] = STATE(1328),
    [sym_math_expression] = STATE(1328),
    [sym_cast_expression] = STATE(1328),
    [sym_sizeof_expression] = STATE(1328),
    [sym_subscript_expression] = STATE(1328),
    [sym_call_expression] = STATE(1328),
    [sym_field_expression] = STATE(1328),
    [sym_compound_literal_expression] = STATE(1328),
    [sym_parenthesized_expression] = STATE(1328),
    [sym_concatenated_string] = STATE(1328),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(1328),
    [sym_new_expression] = STATE(1328),
    [sym_delete_expression] = STATE(1328),
    [sym_lambda_expression] = STATE(1328),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(2748),
    [anon_sym_LPAREN] = ACTIONS(1087),
    [anon_sym_STAR] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_AMP] = ACTIONS(1089),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1093),
    [anon_sym_PLUS] = ACTIONS(1095),
    [anon_sym_DASH] = ACTIONS(1095),
    [anon_sym_DASH_DASH] = ACTIONS(1097),
    [anon_sym_PLUS_PLUS] = ACTIONS(1097),
    [anon_sym_sizeof] = ACTIONS(1099),
    [sym_number_literal] = ACTIONS(2748),
    [sym_char_literal] = ACTIONS(2748),
    [sym_string_literal] = ACTIONS(1101),
    [sym_true] = ACTIONS(2750),
    [sym_false] = ACTIONS(2750),
    [sym_null] = ACTIONS(2750),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_delete] = ACTIONS(1109),
    [sym_nullptr] = ACTIONS(2750),
  },
  [1105] = {
    [sym__expression] = STATE(1692),
    [sym_conditional_expression] = STATE(1692),
    [sym_assignment_expression] = STATE(1692),
    [sym_pointer_expression] = STATE(1692),
    [sym_logical_expression] = STATE(1692),
    [sym_bitwise_expression] = STATE(1692),
    [sym_equality_expression] = STATE(1692),
    [sym_relational_expression] = STATE(1692),
    [sym_shift_expression] = STATE(1692),
    [sym_math_expression] = STATE(1692),
    [sym_cast_expression] = STATE(1692),
    [sym_sizeof_expression] = STATE(1692),
    [sym_subscript_expression] = STATE(1692),
    [sym_call_expression] = STATE(1692),
    [sym_field_expression] = STATE(1692),
    [sym_compound_literal_expression] = STATE(1692),
    [sym_parenthesized_expression] = STATE(1692),
    [sym_concatenated_string] = STATE(1692),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(1692),
    [sym_new_expression] = STATE(1692),
    [sym_delete_expression] = STATE(1692),
    [sym_lambda_expression] = STATE(1692),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(3698),
    [anon_sym_LPAREN] = ACTIONS(1087),
    [anon_sym_STAR] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_AMP] = ACTIONS(1089),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1093),
    [anon_sym_PLUS] = ACTIONS(1095),
    [anon_sym_DASH] = ACTIONS(1095),
    [anon_sym_DASH_DASH] = ACTIONS(1097),
    [anon_sym_PLUS_PLUS] = ACTIONS(1097),
    [anon_sym_sizeof] = ACTIONS(1099),
    [sym_number_literal] = ACTIONS(3698),
    [sym_char_literal] = ACTIONS(3698),
    [sym_string_literal] = ACTIONS(1101),
    [sym_true] = ACTIONS(3700),
    [sym_false] = ACTIONS(3700),
    [sym_null] = ACTIONS(3700),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_delete] = ACTIONS(1109),
    [sym_nullptr] = ACTIONS(3700),
  },
  [1106] = {
    [sym__expression] = STATE(1693),
    [sym_conditional_expression] = STATE(1693),
    [sym_assignment_expression] = STATE(1693),
    [sym_pointer_expression] = STATE(1693),
    [sym_logical_expression] = STATE(1693),
    [sym_bitwise_expression] = STATE(1693),
    [sym_equality_expression] = STATE(1693),
    [sym_relational_expression] = STATE(1693),
    [sym_shift_expression] = STATE(1693),
    [sym_math_expression] = STATE(1693),
    [sym_cast_expression] = STATE(1693),
    [sym_sizeof_expression] = STATE(1693),
    [sym_subscript_expression] = STATE(1693),
    [sym_call_expression] = STATE(1693),
    [sym_field_expression] = STATE(1693),
    [sym_compound_literal_expression] = STATE(1693),
    [sym_parenthesized_expression] = STATE(1693),
    [sym_concatenated_string] = STATE(1693),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(1693),
    [sym_new_expression] = STATE(1693),
    [sym_delete_expression] = STATE(1693),
    [sym_lambda_expression] = STATE(1693),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(855),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(3702),
    [anon_sym_LPAREN] = ACTIONS(1634),
    [anon_sym_STAR] = ACTIONS(1636),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_AMP] = ACTIONS(1636),
    [anon_sym_BANG] = ACTIONS(1638),
    [anon_sym_TILDE] = ACTIONS(1640),
    [anon_sym_PLUS] = ACTIONS(1642),
    [anon_sym_DASH] = ACTIONS(1642),
    [anon_sym_DASH_DASH] = ACTIONS(1644),
    [anon_sym_PLUS_PLUS] = ACTIONS(1644),
    [anon_sym_sizeof] = ACTIONS(1646),
    [sym_number_literal] = ACTIONS(3702),
    [sym_char_literal] = ACTIONS(3702),
    [sym_string_literal] = ACTIONS(1648),
    [sym_true] = ACTIONS(3704),
    [sym_false] = ACTIONS(3704),
    [sym_null] = ACTIONS(3704),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1652),
    [anon_sym_delete] = ACTIONS(1654),
    [sym_nullptr] = ACTIONS(3704),
  },
  [1107] = {
    [sym__expression] = STATE(1694),
    [sym_conditional_expression] = STATE(1694),
    [sym_assignment_expression] = STATE(1694),
    [sym_pointer_expression] = STATE(1694),
    [sym_logical_expression] = STATE(1694),
    [sym_bitwise_expression] = STATE(1694),
    [sym_equality_expression] = STATE(1694),
    [sym_relational_expression] = STATE(1694),
    [sym_shift_expression] = STATE(1694),
    [sym_math_expression] = STATE(1694),
    [sym_cast_expression] = STATE(1694),
    [sym_sizeof_expression] = STATE(1694),
    [sym_subscript_expression] = STATE(1694),
    [sym_call_expression] = STATE(1694),
    [sym_field_expression] = STATE(1694),
    [sym_compound_literal_expression] = STATE(1694),
    [sym_parenthesized_expression] = STATE(1694),
    [sym_concatenated_string] = STATE(1694),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(1694),
    [sym_new_expression] = STATE(1694),
    [sym_delete_expression] = STATE(1694),
    [sym_lambda_expression] = STATE(1694),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(3706),
    [anon_sym_LPAREN] = ACTIONS(1087),
    [anon_sym_STAR] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_AMP] = ACTIONS(1089),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1093),
    [anon_sym_PLUS] = ACTIONS(1095),
    [anon_sym_DASH] = ACTIONS(1095),
    [anon_sym_DASH_DASH] = ACTIONS(1097),
    [anon_sym_PLUS_PLUS] = ACTIONS(1097),
    [anon_sym_sizeof] = ACTIONS(1099),
    [sym_number_literal] = ACTIONS(3706),
    [sym_char_literal] = ACTIONS(3706),
    [sym_string_literal] = ACTIONS(1101),
    [sym_true] = ACTIONS(3708),
    [sym_false] = ACTIONS(3708),
    [sym_null] = ACTIONS(3708),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_delete] = ACTIONS(1109),
    [sym_nullptr] = ACTIONS(3708),
  },
  [1108] = {
    [sym__expression] = STATE(1695),
    [sym_conditional_expression] = STATE(1695),
    [sym_assignment_expression] = STATE(1695),
    [sym_pointer_expression] = STATE(1695),
    [sym_logical_expression] = STATE(1695),
    [sym_bitwise_expression] = STATE(1695),
    [sym_equality_expression] = STATE(1695),
    [sym_relational_expression] = STATE(1695),
    [sym_shift_expression] = STATE(1695),
    [sym_math_expression] = STATE(1695),
    [sym_cast_expression] = STATE(1695),
    [sym_sizeof_expression] = STATE(1695),
    [sym_subscript_expression] = STATE(1695),
    [sym_call_expression] = STATE(1695),
    [sym_field_expression] = STATE(1695),
    [sym_compound_literal_expression] = STATE(1695),
    [sym_parenthesized_expression] = STATE(1695),
    [sym_concatenated_string] = STATE(1695),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(1695),
    [sym_new_expression] = STATE(1695),
    [sym_delete_expression] = STATE(1695),
    [sym_lambda_expression] = STATE(1695),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(3710),
    [anon_sym_LPAREN] = ACTIONS(1087),
    [anon_sym_STAR] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_AMP] = ACTIONS(1089),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1093),
    [anon_sym_PLUS] = ACTIONS(1095),
    [anon_sym_DASH] = ACTIONS(1095),
    [anon_sym_DASH_DASH] = ACTIONS(1097),
    [anon_sym_PLUS_PLUS] = ACTIONS(1097),
    [anon_sym_sizeof] = ACTIONS(1099),
    [sym_number_literal] = ACTIONS(3710),
    [sym_char_literal] = ACTIONS(3710),
    [sym_string_literal] = ACTIONS(1101),
    [sym_true] = ACTIONS(3712),
    [sym_false] = ACTIONS(3712),
    [sym_null] = ACTIONS(3712),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_delete] = ACTIONS(1109),
    [sym_nullptr] = ACTIONS(3712),
  },
  [1109] = {
    [sym__expression] = STATE(1696),
    [sym_conditional_expression] = STATE(1696),
    [sym_assignment_expression] = STATE(1696),
    [sym_pointer_expression] = STATE(1696),
    [sym_logical_expression] = STATE(1696),
    [sym_bitwise_expression] = STATE(1696),
    [sym_equality_expression] = STATE(1696),
    [sym_relational_expression] = STATE(1696),
    [sym_shift_expression] = STATE(1696),
    [sym_math_expression] = STATE(1696),
    [sym_cast_expression] = STATE(1696),
    [sym_sizeof_expression] = STATE(1696),
    [sym_subscript_expression] = STATE(1696),
    [sym_call_expression] = STATE(1696),
    [sym_field_expression] = STATE(1696),
    [sym_compound_literal_expression] = STATE(1696),
    [sym_parenthesized_expression] = STATE(1696),
    [sym_concatenated_string] = STATE(1696),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(1696),
    [sym_new_expression] = STATE(1696),
    [sym_delete_expression] = STATE(1696),
    [sym_lambda_expression] = STATE(1696),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(3714),
    [anon_sym_LPAREN] = ACTIONS(1087),
    [anon_sym_STAR] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_AMP] = ACTIONS(1089),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1093),
    [anon_sym_PLUS] = ACTIONS(1095),
    [anon_sym_DASH] = ACTIONS(1095),
    [anon_sym_DASH_DASH] = ACTIONS(1097),
    [anon_sym_PLUS_PLUS] = ACTIONS(1097),
    [anon_sym_sizeof] = ACTIONS(1099),
    [sym_number_literal] = ACTIONS(3714),
    [sym_char_literal] = ACTIONS(3714),
    [sym_string_literal] = ACTIONS(1101),
    [sym_true] = ACTIONS(3716),
    [sym_false] = ACTIONS(3716),
    [sym_null] = ACTIONS(3716),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_delete] = ACTIONS(1109),
    [sym_nullptr] = ACTIONS(3716),
  },
  [1110] = {
    [sym__expression] = STATE(1697),
    [sym_conditional_expression] = STATE(1697),
    [sym_assignment_expression] = STATE(1697),
    [sym_pointer_expression] = STATE(1697),
    [sym_logical_expression] = STATE(1697),
    [sym_bitwise_expression] = STATE(1697),
    [sym_equality_expression] = STATE(1697),
    [sym_relational_expression] = STATE(1697),
    [sym_shift_expression] = STATE(1697),
    [sym_math_expression] = STATE(1697),
    [sym_cast_expression] = STATE(1697),
    [sym_sizeof_expression] = STATE(1697),
    [sym_subscript_expression] = STATE(1697),
    [sym_call_expression] = STATE(1697),
    [sym_field_expression] = STATE(1697),
    [sym_compound_literal_expression] = STATE(1697),
    [sym_parenthesized_expression] = STATE(1697),
    [sym_concatenated_string] = STATE(1697),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(1697),
    [sym_new_expression] = STATE(1697),
    [sym_delete_expression] = STATE(1697),
    [sym_lambda_expression] = STATE(1697),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(3718),
    [anon_sym_LPAREN] = ACTIONS(1087),
    [anon_sym_STAR] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_AMP] = ACTIONS(1089),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1093),
    [anon_sym_PLUS] = ACTIONS(1095),
    [anon_sym_DASH] = ACTIONS(1095),
    [anon_sym_DASH_DASH] = ACTIONS(1097),
    [anon_sym_PLUS_PLUS] = ACTIONS(1097),
    [anon_sym_sizeof] = ACTIONS(1099),
    [sym_number_literal] = ACTIONS(3718),
    [sym_char_literal] = ACTIONS(3718),
    [sym_string_literal] = ACTIONS(1101),
    [sym_true] = ACTIONS(3720),
    [sym_false] = ACTIONS(3720),
    [sym_null] = ACTIONS(3720),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_delete] = ACTIONS(1109),
    [sym_nullptr] = ACTIONS(3720),
  },
  [1111] = {
    [sym__expression] = STATE(1698),
    [sym_conditional_expression] = STATE(1698),
    [sym_assignment_expression] = STATE(1698),
    [sym_pointer_expression] = STATE(1698),
    [sym_logical_expression] = STATE(1698),
    [sym_bitwise_expression] = STATE(1698),
    [sym_equality_expression] = STATE(1698),
    [sym_relational_expression] = STATE(1698),
    [sym_shift_expression] = STATE(1698),
    [sym_math_expression] = STATE(1698),
    [sym_cast_expression] = STATE(1698),
    [sym_sizeof_expression] = STATE(1698),
    [sym_subscript_expression] = STATE(1698),
    [sym_call_expression] = STATE(1698),
    [sym_field_expression] = STATE(1698),
    [sym_compound_literal_expression] = STATE(1698),
    [sym_parenthesized_expression] = STATE(1698),
    [sym_concatenated_string] = STATE(1698),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(1698),
    [sym_new_expression] = STATE(1698),
    [sym_delete_expression] = STATE(1698),
    [sym_lambda_expression] = STATE(1698),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(3722),
    [anon_sym_LPAREN] = ACTIONS(1087),
    [anon_sym_STAR] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_AMP] = ACTIONS(1089),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1093),
    [anon_sym_PLUS] = ACTIONS(1095),
    [anon_sym_DASH] = ACTIONS(1095),
    [anon_sym_DASH_DASH] = ACTIONS(1097),
    [anon_sym_PLUS_PLUS] = ACTIONS(1097),
    [anon_sym_sizeof] = ACTIONS(1099),
    [sym_number_literal] = ACTIONS(3722),
    [sym_char_literal] = ACTIONS(3722),
    [sym_string_literal] = ACTIONS(1101),
    [sym_true] = ACTIONS(3724),
    [sym_false] = ACTIONS(3724),
    [sym_null] = ACTIONS(3724),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_delete] = ACTIONS(1109),
    [sym_nullptr] = ACTIONS(3724),
  },
  [1112] = {
    [sym__expression] = STATE(1699),
    [sym_conditional_expression] = STATE(1699),
    [sym_assignment_expression] = STATE(1699),
    [sym_pointer_expression] = STATE(1699),
    [sym_logical_expression] = STATE(1699),
    [sym_bitwise_expression] = STATE(1699),
    [sym_equality_expression] = STATE(1699),
    [sym_relational_expression] = STATE(1699),
    [sym_shift_expression] = STATE(1699),
    [sym_math_expression] = STATE(1699),
    [sym_cast_expression] = STATE(1699),
    [sym_sizeof_expression] = STATE(1699),
    [sym_subscript_expression] = STATE(1699),
    [sym_call_expression] = STATE(1699),
    [sym_field_expression] = STATE(1699),
    [sym_compound_literal_expression] = STATE(1699),
    [sym_parenthesized_expression] = STATE(1699),
    [sym_concatenated_string] = STATE(1699),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(1699),
    [sym_new_expression] = STATE(1699),
    [sym_delete_expression] = STATE(1699),
    [sym_lambda_expression] = STATE(1699),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(3726),
    [anon_sym_LPAREN] = ACTIONS(1087),
    [anon_sym_STAR] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_AMP] = ACTIONS(1089),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1093),
    [anon_sym_PLUS] = ACTIONS(1095),
    [anon_sym_DASH] = ACTIONS(1095),
    [anon_sym_DASH_DASH] = ACTIONS(1097),
    [anon_sym_PLUS_PLUS] = ACTIONS(1097),
    [anon_sym_sizeof] = ACTIONS(1099),
    [sym_number_literal] = ACTIONS(3726),
    [sym_char_literal] = ACTIONS(3726),
    [sym_string_literal] = ACTIONS(1101),
    [sym_true] = ACTIONS(3728),
    [sym_false] = ACTIONS(3728),
    [sym_null] = ACTIONS(3728),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_delete] = ACTIONS(1109),
    [sym_nullptr] = ACTIONS(3728),
  },
  [1113] = {
    [sym__expression] = STATE(1700),
    [sym_conditional_expression] = STATE(1700),
    [sym_assignment_expression] = STATE(1700),
    [sym_pointer_expression] = STATE(1700),
    [sym_logical_expression] = STATE(1700),
    [sym_bitwise_expression] = STATE(1700),
    [sym_equality_expression] = STATE(1700),
    [sym_relational_expression] = STATE(1700),
    [sym_shift_expression] = STATE(1700),
    [sym_math_expression] = STATE(1700),
    [sym_cast_expression] = STATE(1700),
    [sym_sizeof_expression] = STATE(1700),
    [sym_subscript_expression] = STATE(1700),
    [sym_call_expression] = STATE(1700),
    [sym_field_expression] = STATE(1700),
    [sym_compound_literal_expression] = STATE(1700),
    [sym_parenthesized_expression] = STATE(1700),
    [sym_concatenated_string] = STATE(1700),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(1700),
    [sym_new_expression] = STATE(1700),
    [sym_delete_expression] = STATE(1700),
    [sym_lambda_expression] = STATE(1700),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(3730),
    [anon_sym_LPAREN] = ACTIONS(1087),
    [anon_sym_STAR] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_AMP] = ACTIONS(1089),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1093),
    [anon_sym_PLUS] = ACTIONS(1095),
    [anon_sym_DASH] = ACTIONS(1095),
    [anon_sym_DASH_DASH] = ACTIONS(1097),
    [anon_sym_PLUS_PLUS] = ACTIONS(1097),
    [anon_sym_sizeof] = ACTIONS(1099),
    [sym_number_literal] = ACTIONS(3730),
    [sym_char_literal] = ACTIONS(3730),
    [sym_string_literal] = ACTIONS(1101),
    [sym_true] = ACTIONS(3732),
    [sym_false] = ACTIONS(3732),
    [sym_null] = ACTIONS(3732),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_delete] = ACTIONS(1109),
    [sym_nullptr] = ACTIONS(3732),
  },
  [1114] = {
    [sym__expression] = STATE(1701),
    [sym_conditional_expression] = STATE(1701),
    [sym_assignment_expression] = STATE(1701),
    [sym_pointer_expression] = STATE(1701),
    [sym_logical_expression] = STATE(1701),
    [sym_bitwise_expression] = STATE(1701),
    [sym_equality_expression] = STATE(1701),
    [sym_relational_expression] = STATE(1701),
    [sym_shift_expression] = STATE(1701),
    [sym_math_expression] = STATE(1701),
    [sym_cast_expression] = STATE(1701),
    [sym_sizeof_expression] = STATE(1701),
    [sym_subscript_expression] = STATE(1701),
    [sym_call_expression] = STATE(1701),
    [sym_field_expression] = STATE(1701),
    [sym_compound_literal_expression] = STATE(1701),
    [sym_parenthesized_expression] = STATE(1701),
    [sym_concatenated_string] = STATE(1701),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(1701),
    [sym_new_expression] = STATE(1701),
    [sym_delete_expression] = STATE(1701),
    [sym_lambda_expression] = STATE(1701),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(3734),
    [anon_sym_LPAREN] = ACTIONS(1087),
    [anon_sym_STAR] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_AMP] = ACTIONS(1089),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1093),
    [anon_sym_PLUS] = ACTIONS(1095),
    [anon_sym_DASH] = ACTIONS(1095),
    [anon_sym_DASH_DASH] = ACTIONS(1097),
    [anon_sym_PLUS_PLUS] = ACTIONS(1097),
    [anon_sym_sizeof] = ACTIONS(1099),
    [sym_number_literal] = ACTIONS(3734),
    [sym_char_literal] = ACTIONS(3734),
    [sym_string_literal] = ACTIONS(1101),
    [sym_true] = ACTIONS(3736),
    [sym_false] = ACTIONS(3736),
    [sym_null] = ACTIONS(3736),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_delete] = ACTIONS(1109),
    [sym_nullptr] = ACTIONS(3736),
  },
  [1115] = {
    [sym__expression] = STATE(1702),
    [sym_conditional_expression] = STATE(1702),
    [sym_assignment_expression] = STATE(1702),
    [sym_pointer_expression] = STATE(1702),
    [sym_logical_expression] = STATE(1702),
    [sym_bitwise_expression] = STATE(1702),
    [sym_equality_expression] = STATE(1702),
    [sym_relational_expression] = STATE(1702),
    [sym_shift_expression] = STATE(1702),
    [sym_math_expression] = STATE(1702),
    [sym_cast_expression] = STATE(1702),
    [sym_sizeof_expression] = STATE(1702),
    [sym_subscript_expression] = STATE(1702),
    [sym_call_expression] = STATE(1702),
    [sym_field_expression] = STATE(1702),
    [sym_compound_literal_expression] = STATE(1702),
    [sym_parenthesized_expression] = STATE(1702),
    [sym_concatenated_string] = STATE(1702),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(1702),
    [sym_new_expression] = STATE(1702),
    [sym_delete_expression] = STATE(1702),
    [sym_lambda_expression] = STATE(1702),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(3738),
    [anon_sym_LPAREN] = ACTIONS(1087),
    [anon_sym_STAR] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_AMP] = ACTIONS(1089),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1093),
    [anon_sym_PLUS] = ACTIONS(1095),
    [anon_sym_DASH] = ACTIONS(1095),
    [anon_sym_DASH_DASH] = ACTIONS(1097),
    [anon_sym_PLUS_PLUS] = ACTIONS(1097),
    [anon_sym_sizeof] = ACTIONS(1099),
    [sym_number_literal] = ACTIONS(3738),
    [sym_char_literal] = ACTIONS(3738),
    [sym_string_literal] = ACTIONS(1101),
    [sym_true] = ACTIONS(3740),
    [sym_false] = ACTIONS(3740),
    [sym_null] = ACTIONS(3740),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_delete] = ACTIONS(1109),
    [sym_nullptr] = ACTIONS(3740),
  },
  [1116] = {
    [sym_destructor_name] = STATE(428),
    [anon_sym_TILDE] = ACTIONS(1500),
    [sym_identifier] = ACTIONS(3742),
    [sym_comment] = ACTIONS(49),
    [sym_operator_name] = ACTIONS(702),
  },
  [1117] = {
    [sym__abstract_declarator] = STATE(1704),
    [sym_abstract_pointer_declarator] = STATE(1704),
    [sym_abstract_function_declarator] = STATE(1704),
    [sym_abstract_array_declarator] = STATE(1704),
    [sym_parameter_list] = STATE(1120),
    [sym_abstract_reference_declarator] = STATE(1704),
    [anon_sym_LPAREN] = ACTIONS(1115),
    [anon_sym_RPAREN] = ACTIONS(2270),
    [anon_sym_STAR] = ACTIONS(2264),
    [anon_sym_LBRACK] = ACTIONS(1121),
    [anon_sym_AMP] = ACTIONS(2266),
    [anon_sym_AMP_AMP] = ACTIONS(2268),
    [sym_comment] = ACTIONS(49),
  },
  [1118] = {
    [sym__abstract_declarator] = STATE(1705),
    [sym_abstract_pointer_declarator] = STATE(1705),
    [sym_abstract_function_declarator] = STATE(1705),
    [sym_abstract_array_declarator] = STATE(1705),
    [sym_parameter_list] = STATE(1120),
    [sym_abstract_reference_declarator] = STATE(1705),
    [anon_sym_LPAREN] = ACTIONS(1115),
    [anon_sym_RPAREN] = ACTIONS(2278),
    [anon_sym_STAR] = ACTIONS(2264),
    [anon_sym_LBRACK] = ACTIONS(1121),
    [anon_sym_AMP] = ACTIONS(2266),
    [anon_sym_AMP_AMP] = ACTIONS(2268),
    [sym_comment] = ACTIONS(49),
  },
  [1119] = {
    [sym_parameter_list] = STATE(1707),
    [anon_sym_LPAREN] = ACTIONS(206),
    [anon_sym_RPAREN] = ACTIONS(3744),
    [anon_sym_LBRACK] = ACTIONS(2282),
    [sym_comment] = ACTIONS(49),
  },
  [1120] = {
    [sym_type_qualifier] = STATE(1709),
    [sym_trailing_return_type] = STATE(1129),
    [aux_sym_abstract_function_declarator_repeat1] = STATE(1709),
    [anon_sym_LPAREN] = ACTIONS(2284),
    [anon_sym_RPAREN] = ACTIONS(2284),
    [anon_sym_LBRACK] = ACTIONS(2284),
    [anon_sym_const] = ACTIONS(612),
    [anon_sym_restrict] = ACTIONS(614),
    [anon_sym_volatile] = ACTIONS(614),
    [anon_sym__Atomic] = ACTIONS(614),
    [anon_sym_mutable] = ACTIONS(614),
    [anon_sym_explicit] = ACTIONS(614),
    [anon_sym_constexpr] = ACTIONS(614),
    [anon_sym_DASH_GT] = ACTIONS(3746),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(3748),
  },
  [1121] = {
    [sym_parameter_list] = STATE(1127),
    [anon_sym_LPAREN] = ACTIONS(206),
    [anon_sym_COMMA] = ACTIONS(3750),
    [anon_sym_LBRACK] = ACTIONS(2282),
    [anon_sym_GT] = ACTIONS(3750),
    [sym_comment] = ACTIONS(49),
  },
  [1122] = {
    [anon_sym_LPAREN] = ACTIONS(3752),
    [anon_sym_COMMA] = ACTIONS(3752),
    [anon_sym_RPAREN] = ACTIONS(3752),
    [anon_sym_SEMI] = ACTIONS(3752),
    [anon_sym_LBRACE] = ACTIONS(3752),
    [anon_sym_LBRACK] = ACTIONS(3752),
    [anon_sym_EQ] = ACTIONS(3752),
    [anon_sym_const] = ACTIONS(3754),
    [anon_sym_restrict] = ACTIONS(3752),
    [anon_sym_volatile] = ACTIONS(3752),
    [anon_sym__Atomic] = ACTIONS(3752),
    [anon_sym_mutable] = ACTIONS(3752),
    [anon_sym_explicit] = ACTIONS(3752),
    [anon_sym_constexpr] = ACTIONS(3752),
    [anon_sym_COLON] = ACTIONS(3752),
    [anon_sym_GT] = ACTIONS(3752),
    [anon_sym_DASH_GT] = ACTIONS(3752),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(3752),
  },
  [1123] = {
    [sym__expression] = STATE(1711),
    [sym_conditional_expression] = STATE(1711),
    [sym_assignment_expression] = STATE(1711),
    [sym_pointer_expression] = STATE(1711),
    [sym_logical_expression] = STATE(1711),
    [sym_bitwise_expression] = STATE(1711),
    [sym_equality_expression] = STATE(1711),
    [sym_relational_expression] = STATE(1711),
    [sym_shift_expression] = STATE(1711),
    [sym_math_expression] = STATE(1711),
    [sym_cast_expression] = STATE(1711),
    [sym_sizeof_expression] = STATE(1711),
    [sym_subscript_expression] = STATE(1711),
    [sym_call_expression] = STATE(1711),
    [sym_field_expression] = STATE(1711),
    [sym_compound_literal_expression] = STATE(1711),
    [sym_parenthesized_expression] = STATE(1711),
    [sym_concatenated_string] = STATE(1711),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(1711),
    [sym_new_expression] = STATE(1711),
    [sym_delete_expression] = STATE(1711),
    [sym_lambda_expression] = STATE(1711),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(3756),
    [anon_sym_LPAREN] = ACTIONS(566),
    [anon_sym_STAR] = ACTIONS(568),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_RBRACK] = ACTIONS(3758),
    [anon_sym_AMP] = ACTIONS(568),
    [anon_sym_BANG] = ACTIONS(584),
    [anon_sym_TILDE] = ACTIONS(586),
    [anon_sym_PLUS] = ACTIONS(588),
    [anon_sym_DASH] = ACTIONS(588),
    [anon_sym_DASH_DASH] = ACTIONS(590),
    [anon_sym_PLUS_PLUS] = ACTIONS(590),
    [anon_sym_sizeof] = ACTIONS(592),
    [sym_number_literal] = ACTIONS(3756),
    [sym_char_literal] = ACTIONS(3756),
    [sym_string_literal] = ACTIONS(594),
    [sym_true] = ACTIONS(3760),
    [sym_false] = ACTIONS(3760),
    [sym_null] = ACTIONS(3760),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1415),
    [anon_sym_delete] = ACTIONS(608),
    [sym_nullptr] = ACTIONS(3760),
  },
  [1124] = {
    [sym_argument_list] = STATE(802),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_STAR] = ACTIONS(1522),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_RBRACK] = ACTIONS(3758),
    [anon_sym_EQ] = ACTIONS(1526),
    [anon_sym_QMARK] = ACTIONS(1528),
    [anon_sym_STAR_EQ] = ACTIONS(1530),
    [anon_sym_SLASH_EQ] = ACTIONS(1530),
    [anon_sym_PERCENT_EQ] = ACTIONS(1530),
    [anon_sym_PLUS_EQ] = ACTIONS(1530),
    [anon_sym_DASH_EQ] = ACTIONS(1530),
    [anon_sym_LT_LT_EQ] = ACTIONS(1530),
    [anon_sym_GT_GT_EQ] = ACTIONS(1530),
    [anon_sym_AMP_EQ] = ACTIONS(1530),
    [anon_sym_CARET_EQ] = ACTIONS(1530),
    [anon_sym_PIPE_EQ] = ACTIONS(1530),
    [anon_sym_AMP] = ACTIONS(1532),
    [anon_sym_PIPE_PIPE] = ACTIONS(1534),
    [anon_sym_AMP_AMP] = ACTIONS(1536),
    [anon_sym_PIPE] = ACTIONS(1538),
    [anon_sym_CARET] = ACTIONS(1540),
    [anon_sym_EQ_EQ] = ACTIONS(1542),
    [anon_sym_BANG_EQ] = ACTIONS(1542),
    [anon_sym_LT] = ACTIONS(1544),
    [anon_sym_GT] = ACTIONS(1544),
    [anon_sym_LT_EQ] = ACTIONS(1546),
    [anon_sym_GT_EQ] = ACTIONS(1546),
    [anon_sym_LT_LT] = ACTIONS(1548),
    [anon_sym_GT_GT] = ACTIONS(1548),
    [anon_sym_PLUS] = ACTIONS(1550),
    [anon_sym_DASH] = ACTIONS(1550),
    [anon_sym_SLASH] = ACTIONS(1522),
    [anon_sym_PERCENT] = ACTIONS(1522),
    [anon_sym_DASH_DASH] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(1554),
    [anon_sym_DASH_GT] = ACTIONS(1554),
    [sym_comment] = ACTIONS(49),
  },
  [1125] = {
    [sym_parameter_list] = STATE(1127),
    [anon_sym_LPAREN] = ACTIONS(206),
    [anon_sym_COMMA] = ACTIONS(3762),
    [anon_sym_LBRACK] = ACTIONS(2282),
    [anon_sym_GT] = ACTIONS(3762),
    [sym_comment] = ACTIONS(49),
  },
  [1126] = {
    [sym__declaration_specifiers] = STATE(1712),
    [sym_storage_class_specifier] = STATE(374),
    [sym_type_qualifier] = STATE(374),
    [sym__type_specifier] = STATE(367),
    [sym_sized_type_specifier] = STATE(367),
    [sym_enum_specifier] = STATE(367),
    [sym_struct_specifier] = STATE(367),
    [sym_union_specifier] = STATE(367),
    [sym__expression] = STATE(1711),
    [sym_conditional_expression] = STATE(1711),
    [sym_assignment_expression] = STATE(1711),
    [sym_pointer_expression] = STATE(1711),
    [sym_logical_expression] = STATE(1711),
    [sym_bitwise_expression] = STATE(1711),
    [sym_equality_expression] = STATE(1711),
    [sym_relational_expression] = STATE(1711),
    [sym_shift_expression] = STATE(1711),
    [sym_math_expression] = STATE(1711),
    [sym_cast_expression] = STATE(1711),
    [sym_sizeof_expression] = STATE(1711),
    [sym_subscript_expression] = STATE(1711),
    [sym_call_expression] = STATE(1711),
    [sym_field_expression] = STATE(1711),
    [sym_compound_literal_expression] = STATE(1711),
    [sym_parenthesized_expression] = STATE(1711),
    [sym_concatenated_string] = STATE(1711),
    [sym_macro_type_specifier] = STATE(367),
    [sym_class_specifier] = STATE(367),
    [sym_dependent_type] = STATE(367),
    [sym_template_type] = STATE(369),
    [sym_template_function] = STATE(1711),
    [sym_new_expression] = STATE(1711),
    [sym_delete_expression] = STATE(1711),
    [sym_lambda_expression] = STATE(1711),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(372),
    [sym_scoped_namespace_identifier] = STATE(373),
    [aux_sym__declaration_specifiers_repeat1] = STATE(374),
    [aux_sym_sized_type_specifier_repeat1] = STATE(375),
    [sym_raw_string_literal] = ACTIONS(3756),
    [anon_sym_LPAREN] = ACTIONS(566),
    [anon_sym_extern] = ACTIONS(154),
    [anon_sym_STAR] = ACTIONS(568),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_RBRACK] = ACTIONS(3758),
    [anon_sym_static] = ACTIONS(154),
    [anon_sym_register] = ACTIONS(154),
    [anon_sym_inline] = ACTIONS(154),
    [anon_sym_const] = ACTIONS(158),
    [anon_sym_restrict] = ACTIONS(158),
    [anon_sym_volatile] = ACTIONS(158),
    [anon_sym__Atomic] = ACTIONS(158),
    [anon_sym_mutable] = ACTIONS(158),
    [anon_sym_explicit] = ACTIONS(158),
    [anon_sym_constexpr] = ACTIONS(158),
    [anon_sym_unsigned] = ACTIONS(574),
    [anon_sym_long] = ACTIONS(574),
    [anon_sym_short] = ACTIONS(574),
    [sym_primitive_type] = ACTIONS(576),
    [anon_sym_enum] = ACTIONS(578),
    [anon_sym_struct] = ACTIONS(580),
    [anon_sym_union] = ACTIONS(582),
    [anon_sym_AMP] = ACTIONS(568),
    [anon_sym_BANG] = ACTIONS(584),
    [anon_sym_TILDE] = ACTIONS(586),
    [anon_sym_PLUS] = ACTIONS(588),
    [anon_sym_DASH] = ACTIONS(588),
    [anon_sym_DASH_DASH] = ACTIONS(590),
    [anon_sym_PLUS_PLUS] = ACTIONS(590),
    [anon_sym_sizeof] = ACTIONS(592),
    [sym_number_literal] = ACTIONS(3756),
    [sym_char_literal] = ACTIONS(3756),
    [sym_string_literal] = ACTIONS(594),
    [sym_true] = ACTIONS(3760),
    [sym_false] = ACTIONS(3760),
    [sym_null] = ACTIONS(3760),
    [sym_identifier] = ACTIONS(598),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(600),
    [sym_auto] = ACTIONS(576),
    [anon_sym_typename] = ACTIONS(602),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(606),
    [anon_sym_delete] = ACTIONS(608),
    [sym_nullptr] = ACTIONS(3760),
  },
  [1127] = {
    [sym_type_qualifier] = STATE(1714),
    [sym_trailing_return_type] = STATE(1713),
    [aux_sym_abstract_function_declarator_repeat1] = STATE(1714),
    [anon_sym_LPAREN] = ACTIONS(3764),
    [anon_sym_COMMA] = ACTIONS(3764),
    [anon_sym_LBRACK] = ACTIONS(3764),
    [anon_sym_const] = ACTIONS(612),
    [anon_sym_restrict] = ACTIONS(614),
    [anon_sym_volatile] = ACTIONS(614),
    [anon_sym__Atomic] = ACTIONS(614),
    [anon_sym_mutable] = ACTIONS(614),
    [anon_sym_explicit] = ACTIONS(614),
    [anon_sym_constexpr] = ACTIONS(614),
    [anon_sym_GT] = ACTIONS(3764),
    [anon_sym_DASH_GT] = ACTIONS(2286),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(3766),
  },
  [1128] = {
    [sym__type_specifier] = STATE(1715),
    [sym_sized_type_specifier] = STATE(1715),
    [sym_enum_specifier] = STATE(1715),
    [sym_struct_specifier] = STATE(1715),
    [sym_union_specifier] = STATE(1715),
    [sym_macro_type_specifier] = STATE(1715),
    [sym_class_specifier] = STATE(1715),
    [sym_dependent_type] = STATE(1715),
    [sym_template_type] = STATE(62),
    [sym_scoped_type_identifier] = STATE(34),
    [sym_scoped_namespace_identifier] = STATE(64),
    [aux_sym_sized_type_specifier_repeat1] = STATE(280),
    [anon_sym_unsigned] = ACTIONS(424),
    [anon_sym_long] = ACTIONS(424),
    [anon_sym_short] = ACTIONS(424),
    [sym_primitive_type] = ACTIONS(3768),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(428),
    [anon_sym_union] = ACTIONS(430),
    [sym_identifier] = ACTIONS(434),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(436),
    [sym_auto] = ACTIONS(3768),
    [anon_sym_typename] = ACTIONS(438),
    [anon_sym_COLON_COLON] = ACTIONS(111),
  },
  [1129] = {
    [anon_sym_LPAREN] = ACTIONS(3764),
    [anon_sym_COMMA] = ACTIONS(3764),
    [anon_sym_RPAREN] = ACTIONS(3764),
    [anon_sym_SEMI] = ACTIONS(3764),
    [anon_sym_LBRACE] = ACTIONS(3764),
    [anon_sym_LBRACK] = ACTIONS(3764),
    [anon_sym_EQ] = ACTIONS(3764),
    [anon_sym_const] = ACTIONS(3770),
    [anon_sym_restrict] = ACTIONS(3764),
    [anon_sym_volatile] = ACTIONS(3764),
    [anon_sym__Atomic] = ACTIONS(3764),
    [anon_sym_mutable] = ACTIONS(3764),
    [anon_sym_explicit] = ACTIONS(3764),
    [anon_sym_constexpr] = ACTIONS(3764),
    [anon_sym_COLON] = ACTIONS(3764),
    [anon_sym_GT] = ACTIONS(3764),
    [anon_sym_DASH_GT] = ACTIONS(3764),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(3764),
  },
  [1130] = {
    [sym_type_qualifier] = STATE(1716),
    [sym_trailing_return_type] = STATE(1713),
    [aux_sym_abstract_function_declarator_repeat1] = STATE(1716),
    [anon_sym_LPAREN] = ACTIONS(3764),
    [anon_sym_COMMA] = ACTIONS(3764),
    [anon_sym_LBRACK] = ACTIONS(3764),
    [anon_sym_const] = ACTIONS(612),
    [anon_sym_restrict] = ACTIONS(614),
    [anon_sym_volatile] = ACTIONS(614),
    [anon_sym__Atomic] = ACTIONS(614),
    [anon_sym_mutable] = ACTIONS(614),
    [anon_sym_explicit] = ACTIONS(614),
    [anon_sym_constexpr] = ACTIONS(614),
    [anon_sym_GT] = ACTIONS(3764),
    [anon_sym_DASH_GT] = ACTIONS(2286),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(3772),
  },
  [1131] = {
    [anon_sym_COMMA] = ACTIONS(3774),
    [anon_sym_GT] = ACTIONS(3774),
    [sym_comment] = ACTIONS(49),
  },
  [1132] = {
    [anon_sym_LPAREN] = ACTIONS(3776),
    [anon_sym_COMMA] = ACTIONS(3776),
    [anon_sym_RPAREN] = ACTIONS(3776),
    [anon_sym_SEMI] = ACTIONS(3776),
    [anon_sym_extern] = ACTIONS(3778),
    [anon_sym_LBRACE] = ACTIONS(3776),
    [anon_sym_STAR] = ACTIONS(3776),
    [anon_sym_LBRACK] = ACTIONS(3776),
    [anon_sym_EQ] = ACTIONS(3776),
    [anon_sym_static] = ACTIONS(3778),
    [anon_sym_register] = ACTIONS(3778),
    [anon_sym_inline] = ACTIONS(3778),
    [anon_sym_const] = ACTIONS(3778),
    [anon_sym_restrict] = ACTIONS(3778),
    [anon_sym_volatile] = ACTIONS(3778),
    [anon_sym__Atomic] = ACTIONS(3778),
    [anon_sym_mutable] = ACTIONS(3778),
    [anon_sym_explicit] = ACTIONS(3778),
    [anon_sym_constexpr] = ACTIONS(3778),
    [anon_sym_COLON] = ACTIONS(3778),
    [anon_sym_AMP] = ACTIONS(3778),
    [anon_sym_AMP_AMP] = ACTIONS(3776),
    [anon_sym_TILDE] = ACTIONS(3776),
    [anon_sym_GT] = ACTIONS(3776),
    [sym_identifier] = ACTIONS(3778),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(3776),
    [sym_operator_name] = ACTIONS(3776),
  },
  [1133] = {
    [aux_sym_template_argument_list_repeat1] = STATE(1133),
    [anon_sym_COMMA] = ACTIONS(3780),
    [anon_sym_GT] = ACTIONS(3774),
    [sym_comment] = ACTIONS(49),
  },
  [1134] = {
    [sym_parameter_list] = STATE(1127),
    [anon_sym_LPAREN] = ACTIONS(206),
    [anon_sym_COMMA] = ACTIONS(3783),
    [anon_sym_LBRACK] = ACTIONS(2282),
    [anon_sym_GT] = ACTIONS(3783),
    [sym_comment] = ACTIONS(49),
  },
  [1135] = {
    [sym__type_specifier] = STATE(1718),
    [sym_sized_type_specifier] = STATE(1718),
    [sym_enum_specifier] = STATE(1718),
    [sym_struct_specifier] = STATE(1718),
    [sym_union_specifier] = STATE(1718),
    [sym_macro_type_specifier] = STATE(1718),
    [sym_class_specifier] = STATE(1718),
    [sym_dependent_type] = STATE(1718),
    [sym_template_type] = STATE(62),
    [sym_scoped_type_identifier] = STATE(34),
    [sym_scoped_namespace_identifier] = STATE(64),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1719),
    [anon_sym_unsigned] = ACTIONS(3785),
    [anon_sym_long] = ACTIONS(3785),
    [anon_sym_short] = ACTIONS(3785),
    [sym_primitive_type] = ACTIONS(3787),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(428),
    [anon_sym_union] = ACTIONS(430),
    [sym_identifier] = ACTIONS(434),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(436),
    [sym_auto] = ACTIONS(3787),
    [anon_sym_typename] = ACTIONS(3789),
    [anon_sym_COLON_COLON] = ACTIONS(111),
  },
  [1136] = {
    [sym__declarator] = STATE(153),
    [sym__abstract_declarator] = STATE(1704),
    [sym_pointer_declarator] = STATE(153),
    [sym_abstract_pointer_declarator] = STATE(1704),
    [sym_function_declarator] = STATE(153),
    [sym_abstract_function_declarator] = STATE(1704),
    [sym_array_declarator] = STATE(153),
    [sym_abstract_array_declarator] = STATE(1704),
    [sym_parameter_list] = STATE(1120),
    [sym_reference_declarator] = STATE(153),
    [sym_abstract_reference_declarator] = STATE(1704),
    [sym_template_type] = STATE(46),
    [sym_template_function] = STATE(153),
    [sym_destructor_name] = STATE(153),
    [sym_scoped_identifier] = STATE(33),
    [sym_scoped_type_identifier] = STATE(47),
    [sym_scoped_namespace_identifier] = STATE(46),
    [anon_sym_LPAREN] = ACTIONS(1162),
    [anon_sym_RPAREN] = ACTIONS(2270),
    [anon_sym_STAR] = ACTIONS(2307),
    [anon_sym_LBRACK] = ACTIONS(1121),
    [anon_sym_AMP] = ACTIONS(2309),
    [anon_sym_AMP_AMP] = ACTIONS(2311),
    [anon_sym_TILDE] = ACTIONS(45),
    [sym_identifier] = ACTIONS(75),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(77),
    [sym_operator_name] = ACTIONS(259),
  },
  [1137] = {
    [sym__declarator] = STATE(154),
    [sym__abstract_declarator] = STATE(1705),
    [sym_pointer_declarator] = STATE(154),
    [sym_abstract_pointer_declarator] = STATE(1705),
    [sym_function_declarator] = STATE(154),
    [sym_abstract_function_declarator] = STATE(1705),
    [sym_array_declarator] = STATE(154),
    [sym_abstract_array_declarator] = STATE(1705),
    [sym_parameter_list] = STATE(1120),
    [sym_reference_declarator] = STATE(154),
    [sym_abstract_reference_declarator] = STATE(1705),
    [sym_template_type] = STATE(46),
    [sym_template_function] = STATE(154),
    [sym_destructor_name] = STATE(154),
    [sym_scoped_identifier] = STATE(33),
    [sym_scoped_type_identifier] = STATE(47),
    [sym_scoped_namespace_identifier] = STATE(46),
    [anon_sym_LPAREN] = ACTIONS(1162),
    [anon_sym_RPAREN] = ACTIONS(2278),
    [anon_sym_STAR] = ACTIONS(2307),
    [anon_sym_LBRACK] = ACTIONS(1121),
    [anon_sym_AMP] = ACTIONS(2309),
    [anon_sym_AMP_AMP] = ACTIONS(2311),
    [anon_sym_TILDE] = ACTIONS(45),
    [sym_identifier] = ACTIONS(75),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(77),
    [sym_operator_name] = ACTIONS(261),
  },
  [1138] = {
    [sym_parameter_list] = STATE(1145),
    [anon_sym_LPAREN] = ACTIONS(206),
    [anon_sym_COMMA] = ACTIONS(837),
    [anon_sym_LBRACE] = ACTIONS(837),
    [anon_sym_LBRACK] = ACTIONS(208),
    [anon_sym_EQ] = ACTIONS(837),
    [anon_sym_GT] = ACTIONS(837),
    [sym_comment] = ACTIONS(49),
  },
  [1139] = {
    [sym_parameter_list] = STATE(1145),
    [anon_sym_LPAREN] = ACTIONS(206),
    [anon_sym_COMMA] = ACTIONS(839),
    [anon_sym_LBRACE] = ACTIONS(839),
    [anon_sym_LBRACK] = ACTIONS(208),
    [anon_sym_EQ] = ACTIONS(839),
    [anon_sym_GT] = ACTIONS(839),
    [sym_comment] = ACTIONS(49),
  },
  [1140] = {
    [sym_destructor_name] = STATE(1720),
    [anon_sym_TILDE] = ACTIONS(45),
    [sym_identifier] = ACTIONS(841),
    [sym_comment] = ACTIONS(49),
    [sym_operator_name] = ACTIONS(3791),
  },
  [1141] = {
    [anon_sym_LPAREN] = ACTIONS(518),
    [anon_sym_COMMA] = ACTIONS(518),
    [anon_sym_LBRACE] = ACTIONS(518),
    [anon_sym_LBRACK] = ACTIONS(518),
    [anon_sym_EQ] = ACTIONS(518),
    [anon_sym_LT] = ACTIONS(518),
    [anon_sym_GT] = ACTIONS(518),
    [sym_comment] = ACTIONS(49),
  },
  [1142] = {
    [sym__declaration_specifiers] = STATE(344),
    [sym_storage_class_specifier] = STATE(346),
    [sym_type_qualifier] = STATE(346),
    [sym__type_specifier] = STATE(345),
    [sym_sized_type_specifier] = STATE(345),
    [sym_enum_specifier] = STATE(345),
    [sym_struct_specifier] = STATE(345),
    [sym_union_specifier] = STATE(345),
    [sym_parameter_declaration] = STATE(341),
    [sym__expression] = STATE(1721),
    [sym_conditional_expression] = STATE(1721),
    [sym_assignment_expression] = STATE(1721),
    [sym_pointer_expression] = STATE(1721),
    [sym_logical_expression] = STATE(1721),
    [sym_bitwise_expression] = STATE(1721),
    [sym_equality_expression] = STATE(1721),
    [sym_relational_expression] = STATE(1721),
    [sym_shift_expression] = STATE(1721),
    [sym_math_expression] = STATE(1721),
    [sym_cast_expression] = STATE(1721),
    [sym_sizeof_expression] = STATE(1721),
    [sym_subscript_expression] = STATE(1721),
    [sym_call_expression] = STATE(1721),
    [sym_field_expression] = STATE(1721),
    [sym_compound_literal_expression] = STATE(1721),
    [sym_parenthesized_expression] = STATE(1721),
    [sym_initializer_list] = STATE(1722),
    [sym_concatenated_string] = STATE(1721),
    [sym_macro_type_specifier] = STATE(345),
    [sym_class_specifier] = STATE(345),
    [sym_dependent_type] = STATE(345),
    [sym_template_type] = STATE(651),
    [sym_template_function] = STATE(1721),
    [sym_new_expression] = STATE(1721),
    [sym_delete_expression] = STATE(1721),
    [sym_lambda_expression] = STATE(1721),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(416),
    [sym_scoped_namespace_identifier] = STATE(652),
    [aux_sym__declaration_specifiers_repeat1] = STATE(346),
    [aux_sym_sized_type_specifier_repeat1] = STATE(347),
    [sym_raw_string_literal] = ACTIONS(3793),
    [anon_sym_LPAREN] = ACTIONS(1087),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(554),
    [anon_sym_RPAREN] = ACTIONS(1251),
    [anon_sym_extern] = ACTIONS(154),
    [anon_sym_LBRACE] = ACTIONS(548),
    [anon_sym_STAR] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_static] = ACTIONS(154),
    [anon_sym_register] = ACTIONS(154),
    [anon_sym_inline] = ACTIONS(154),
    [anon_sym_const] = ACTIONS(158),
    [anon_sym_restrict] = ACTIONS(158),
    [anon_sym_volatile] = ACTIONS(158),
    [anon_sym__Atomic] = ACTIONS(158),
    [anon_sym_mutable] = ACTIONS(158),
    [anon_sym_explicit] = ACTIONS(158),
    [anon_sym_constexpr] = ACTIONS(158),
    [anon_sym_unsigned] = ACTIONS(558),
    [anon_sym_long] = ACTIONS(558),
    [anon_sym_short] = ACTIONS(558),
    [sym_primitive_type] = ACTIONS(560),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_union] = ACTIONS(39),
    [anon_sym_AMP] = ACTIONS(1089),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1093),
    [anon_sym_PLUS] = ACTIONS(1095),
    [anon_sym_DASH] = ACTIONS(1095),
    [anon_sym_DASH_DASH] = ACTIONS(1097),
    [anon_sym_PLUS_PLUS] = ACTIONS(1097),
    [anon_sym_sizeof] = ACTIONS(1099),
    [sym_number_literal] = ACTIONS(3793),
    [sym_char_literal] = ACTIONS(3793),
    [sym_string_literal] = ACTIONS(1101),
    [sym_true] = ACTIONS(3795),
    [sym_false] = ACTIONS(3795),
    [sym_null] = ACTIONS(3795),
    [sym_identifier] = ACTIONS(1255),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(51),
    [sym_auto] = ACTIONS(560),
    [anon_sym_typename] = ACTIONS(562),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1257),
    [anon_sym_delete] = ACTIONS(1109),
    [sym_nullptr] = ACTIONS(3795),
  },
  [1143] = {
    [sym__expression] = STATE(1725),
    [sym_conditional_expression] = STATE(1725),
    [sym_assignment_expression] = STATE(1725),
    [sym_pointer_expression] = STATE(1725),
    [sym_logical_expression] = STATE(1725),
    [sym_bitwise_expression] = STATE(1725),
    [sym_equality_expression] = STATE(1725),
    [sym_relational_expression] = STATE(1725),
    [sym_shift_expression] = STATE(1725),
    [sym_math_expression] = STATE(1725),
    [sym_cast_expression] = STATE(1725),
    [sym_sizeof_expression] = STATE(1725),
    [sym_subscript_expression] = STATE(1725),
    [sym_call_expression] = STATE(1725),
    [sym_field_expression] = STATE(1725),
    [sym_compound_literal_expression] = STATE(1725),
    [sym_parenthesized_expression] = STATE(1725),
    [sym_initializer_list] = STATE(1726),
    [sym_initializer_pair] = STATE(1726),
    [sym_subscript_designator] = STATE(671),
    [sym_field_designator] = STATE(671),
    [sym_concatenated_string] = STATE(1725),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(1725),
    [sym_new_expression] = STATE(1725),
    [sym_delete_expression] = STATE(1725),
    [sym_lambda_expression] = STATE(1725),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [aux_sym_initializer_pair_repeat1] = STATE(671),
    [sym_raw_string_literal] = ACTIONS(3797),
    [anon_sym_LPAREN] = ACTIONS(1321),
    [anon_sym_COMMA] = ACTIONS(3799),
    [anon_sym_LBRACE] = ACTIONS(548),
    [anon_sym_RBRACE] = ACTIONS(3801),
    [anon_sym_STAR] = ACTIONS(1325),
    [anon_sym_LBRACK] = ACTIONS(1277),
    [anon_sym_AMP] = ACTIONS(1325),
    [anon_sym_BANG] = ACTIONS(1327),
    [anon_sym_TILDE] = ACTIONS(1329),
    [anon_sym_PLUS] = ACTIONS(1331),
    [anon_sym_DASH] = ACTIONS(1331),
    [anon_sym_DASH_DASH] = ACTIONS(1333),
    [anon_sym_PLUS_PLUS] = ACTIONS(1333),
    [anon_sym_sizeof] = ACTIONS(1335),
    [anon_sym_DOT] = ACTIONS(1289),
    [sym_number_literal] = ACTIONS(3797),
    [sym_char_literal] = ACTIONS(3797),
    [sym_string_literal] = ACTIONS(1337),
    [sym_true] = ACTIONS(3803),
    [sym_false] = ACTIONS(3803),
    [sym_null] = ACTIONS(3803),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1341),
    [anon_sym_delete] = ACTIONS(1343),
    [sym_nullptr] = ACTIONS(3803),
  },
  [1144] = {
    [sym__expression] = STATE(1736),
    [sym_conditional_expression] = STATE(1736),
    [sym_assignment_expression] = STATE(1736),
    [sym_pointer_expression] = STATE(1736),
    [sym_logical_expression] = STATE(1736),
    [sym_bitwise_expression] = STATE(1736),
    [sym_equality_expression] = STATE(1736),
    [sym_relational_expression] = STATE(1736),
    [sym_shift_expression] = STATE(1736),
    [sym_math_expression] = STATE(1736),
    [sym_cast_expression] = STATE(1736),
    [sym_sizeof_expression] = STATE(1736),
    [sym_subscript_expression] = STATE(1736),
    [sym_call_expression] = STATE(1736),
    [sym_field_expression] = STATE(1736),
    [sym_compound_literal_expression] = STATE(1736),
    [sym_parenthesized_expression] = STATE(1736),
    [sym_initializer_list] = STATE(674),
    [sym_concatenated_string] = STATE(1736),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(1736),
    [sym_new_expression] = STATE(1736),
    [sym_delete_expression] = STATE(1736),
    [sym_lambda_expression] = STATE(1736),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(3805),
    [anon_sym_LPAREN] = ACTIONS(3807),
    [anon_sym_LBRACE] = ACTIONS(2325),
    [anon_sym_STAR] = ACTIONS(3809),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_AMP] = ACTIONS(3809),
    [anon_sym_BANG] = ACTIONS(3811),
    [anon_sym_TILDE] = ACTIONS(3813),
    [anon_sym_PLUS] = ACTIONS(3815),
    [anon_sym_DASH] = ACTIONS(3815),
    [anon_sym_DASH_DASH] = ACTIONS(3817),
    [anon_sym_PLUS_PLUS] = ACTIONS(3817),
    [anon_sym_sizeof] = ACTIONS(3819),
    [sym_number_literal] = ACTIONS(3805),
    [sym_char_literal] = ACTIONS(3805),
    [sym_string_literal] = ACTIONS(3821),
    [sym_true] = ACTIONS(3823),
    [sym_false] = ACTIONS(3823),
    [sym_null] = ACTIONS(3823),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(3825),
    [anon_sym_delete] = ACTIONS(3827),
    [sym_nullptr] = ACTIONS(3823),
  },
  [1145] = {
    [sym_type_qualifier] = STATE(1738),
    [sym_trailing_return_type] = STATE(1738),
    [aux_sym_function_declarator_repeat1] = STATE(1738),
    [anon_sym_LPAREN] = ACTIONS(610),
    [anon_sym_COMMA] = ACTIONS(610),
    [anon_sym_LBRACE] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(610),
    [anon_sym_EQ] = ACTIONS(610),
    [anon_sym_const] = ACTIONS(612),
    [anon_sym_restrict] = ACTIONS(614),
    [anon_sym_volatile] = ACTIONS(614),
    [anon_sym__Atomic] = ACTIONS(614),
    [anon_sym_mutable] = ACTIONS(614),
    [anon_sym_explicit] = ACTIONS(614),
    [anon_sym_constexpr] = ACTIONS(614),
    [anon_sym_GT] = ACTIONS(610),
    [anon_sym_DASH_GT] = ACTIONS(3829),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(3831),
  },
  [1146] = {
    [sym_destructor_name] = STATE(1739),
    [anon_sym_TILDE] = ACTIONS(45),
    [sym_identifier] = ACTIONS(849),
    [sym_comment] = ACTIONS(49),
    [sym_operator_name] = ACTIONS(3833),
  },
  [1147] = {
    [anon_sym_LPAREN] = ACTIONS(704),
    [anon_sym_COMMA] = ACTIONS(704),
    [anon_sym_LBRACE] = ACTIONS(704),
    [anon_sym_LBRACK] = ACTIONS(704),
    [anon_sym_EQ] = ACTIONS(704),
    [anon_sym_GT] = ACTIONS(704),
    [sym_comment] = ACTIONS(49),
  },
  [1148] = {
    [sym_storage_class_specifier] = STATE(1148),
    [sym_type_qualifier] = STATE(1148),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1148),
    [anon_sym_LPAREN] = ACTIONS(798),
    [anon_sym_COMMA] = ACTIONS(798),
    [anon_sym_extern] = ACTIONS(1792),
    [anon_sym_STAR] = ACTIONS(798),
    [anon_sym_LBRACK] = ACTIONS(798),
    [anon_sym_static] = ACTIONS(1792),
    [anon_sym_register] = ACTIONS(1792),
    [anon_sym_inline] = ACTIONS(1792),
    [anon_sym_const] = ACTIONS(1795),
    [anon_sym_restrict] = ACTIONS(1795),
    [anon_sym_volatile] = ACTIONS(1795),
    [anon_sym__Atomic] = ACTIONS(1795),
    [anon_sym_mutable] = ACTIONS(1795),
    [anon_sym_explicit] = ACTIONS(1795),
    [anon_sym_constexpr] = ACTIONS(1795),
    [anon_sym_AMP] = ACTIONS(806),
    [anon_sym_AMP_AMP] = ACTIONS(798),
    [anon_sym_TILDE] = ACTIONS(798),
    [anon_sym_GT] = ACTIONS(798),
    [sym_identifier] = ACTIONS(806),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(798),
    [sym_operator_name] = ACTIONS(798),
  },
  [1149] = {
    [anon_sym_COMMA] = ACTIONS(3835),
    [anon_sym_GT] = ACTIONS(3835),
    [sym_comment] = ACTIONS(49),
  },
  [1150] = {
    [anon_sym_extern] = ACTIONS(3837),
    [anon_sym_static] = ACTIONS(3837),
    [anon_sym_register] = ACTIONS(3837),
    [anon_sym_inline] = ACTIONS(3837),
    [anon_sym_const] = ACTIONS(3837),
    [anon_sym_restrict] = ACTIONS(3837),
    [anon_sym_volatile] = ACTIONS(3837),
    [anon_sym__Atomic] = ACTIONS(3837),
    [anon_sym_mutable] = ACTIONS(3837),
    [anon_sym_explicit] = ACTIONS(3837),
    [anon_sym_constexpr] = ACTIONS(3837),
    [anon_sym_unsigned] = ACTIONS(3837),
    [anon_sym_long] = ACTIONS(3837),
    [anon_sym_short] = ACTIONS(3837),
    [sym_primitive_type] = ACTIONS(3837),
    [anon_sym_enum] = ACTIONS(3837),
    [anon_sym_struct] = ACTIONS(3837),
    [anon_sym_union] = ACTIONS(3837),
    [sym_identifier] = ACTIONS(3837),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(3837),
    [sym_auto] = ACTIONS(3837),
    [anon_sym_typename] = ACTIONS(3837),
    [anon_sym_COLON_COLON] = ACTIONS(3839),
  },
  [1151] = {
    [aux_sym_template_parameter_list_repeat1] = STATE(1151),
    [anon_sym_COMMA] = ACTIONS(3841),
    [anon_sym_GT] = ACTIONS(3835),
    [sym_comment] = ACTIONS(49),
  },
  [1152] = {
    [sym_storage_class_specifier] = STATE(1148),
    [sym_type_qualifier] = STATE(1148),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1148),
    [anon_sym_LPAREN] = ACTIONS(1811),
    [anon_sym_COMMA] = ACTIONS(1811),
    [anon_sym_extern] = ACTIONS(218),
    [anon_sym_STAR] = ACTIONS(1811),
    [anon_sym_LBRACK] = ACTIONS(1811),
    [anon_sym_static] = ACTIONS(218),
    [anon_sym_register] = ACTIONS(218),
    [anon_sym_inline] = ACTIONS(218),
    [anon_sym_const] = ACTIONS(220),
    [anon_sym_restrict] = ACTIONS(220),
    [anon_sym_volatile] = ACTIONS(220),
    [anon_sym__Atomic] = ACTIONS(220),
    [anon_sym_mutable] = ACTIONS(220),
    [anon_sym_explicit] = ACTIONS(220),
    [anon_sym_constexpr] = ACTIONS(220),
    [anon_sym_AMP] = ACTIONS(1813),
    [anon_sym_AMP_AMP] = ACTIONS(1811),
    [anon_sym_TILDE] = ACTIONS(1811),
    [anon_sym_GT] = ACTIONS(1811),
    [sym_identifier] = ACTIONS(1813),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(1811),
    [sym_operator_name] = ACTIONS(1811),
  },
  [1153] = {
    [sym__type_specifier] = STATE(1375),
    [sym_sized_type_specifier] = STATE(1375),
    [sym_enum_specifier] = STATE(1375),
    [sym_struct_specifier] = STATE(1375),
    [sym_union_specifier] = STATE(1375),
    [sym_macro_type_specifier] = STATE(1375),
    [sym_class_specifier] = STATE(1375),
    [sym_dependent_type] = STATE(1375),
    [sym_template_type] = STATE(825),
    [sym_scoped_type_identifier] = STATE(826),
    [sym_scoped_namespace_identifier] = STATE(827),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1155),
    [anon_sym_unsigned] = ACTIONS(2344),
    [anon_sym_long] = ACTIONS(2344),
    [anon_sym_short] = ACTIONS(2344),
    [sym_primitive_type] = ACTIONS(2837),
    [anon_sym_enum] = ACTIONS(1833),
    [anon_sym_struct] = ACTIONS(1835),
    [anon_sym_union] = ACTIONS(1837),
    [sym_identifier] = ACTIONS(1588),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(1839),
    [sym_auto] = ACTIONS(2837),
    [anon_sym_typename] = ACTIONS(2348),
    [anon_sym_COLON_COLON] = ACTIONS(1594),
  },
  [1154] = {
    [sym__abstract_declarator] = STATE(1742),
    [sym_abstract_pointer_declarator] = STATE(1742),
    [sym_abstract_function_declarator] = STATE(1742),
    [sym_abstract_array_declarator] = STATE(1742),
    [sym_parameter_list] = STATE(1743),
    [sym_abstract_reference_declarator] = STATE(1742),
    [anon_sym_LPAREN] = ACTIONS(1115),
    [anon_sym_SEMI] = ACTIONS(2841),
    [anon_sym_STAR] = ACTIONS(3844),
    [anon_sym_LBRACK] = ACTIONS(1121),
    [anon_sym_const] = ACTIONS(2845),
    [anon_sym_restrict] = ACTIONS(2841),
    [anon_sym_volatile] = ACTIONS(2841),
    [anon_sym__Atomic] = ACTIONS(2841),
    [anon_sym_mutable] = ACTIONS(2841),
    [anon_sym_explicit] = ACTIONS(2841),
    [anon_sym_constexpr] = ACTIONS(2841),
    [anon_sym_AMP] = ACTIONS(3846),
    [anon_sym_AMP_AMP] = ACTIONS(3848),
    [anon_sym_DASH_GT] = ACTIONS(2841),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(2841),
  },
  [1155] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(1744),
    [anon_sym_LPAREN] = ACTIONS(238),
    [anon_sym_SEMI] = ACTIONS(238),
    [anon_sym_STAR] = ACTIONS(238),
    [anon_sym_LBRACK] = ACTIONS(238),
    [anon_sym_const] = ACTIONS(240),
    [anon_sym_restrict] = ACTIONS(240),
    [anon_sym_volatile] = ACTIONS(240),
    [anon_sym__Atomic] = ACTIONS(240),
    [anon_sym_mutable] = ACTIONS(240),
    [anon_sym_explicit] = ACTIONS(240),
    [anon_sym_constexpr] = ACTIONS(240),
    [anon_sym_unsigned] = ACTIONS(3850),
    [anon_sym_long] = ACTIONS(3850),
    [anon_sym_short] = ACTIONS(3850),
    [sym_primitive_type] = ACTIONS(2855),
    [anon_sym_AMP] = ACTIONS(240),
    [anon_sym_AMP_AMP] = ACTIONS(238),
    [anon_sym_DASH_GT] = ACTIONS(238),
    [sym_identifier] = ACTIONS(2857),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(240),
  },
  [1156] = {
    [sym_type_qualifier] = STATE(1156),
    [sym_trailing_return_type] = STATE(1156),
    [aux_sym_function_declarator_repeat1] = STATE(1156),
    [anon_sym_LPAREN] = ACTIONS(2859),
    [anon_sym_SEMI] = ACTIONS(2859),
    [anon_sym_LBRACK] = ACTIONS(2859),
    [anon_sym_const] = ACTIONS(2861),
    [anon_sym_restrict] = ACTIONS(2864),
    [anon_sym_volatile] = ACTIONS(2864),
    [anon_sym__Atomic] = ACTIONS(2864),
    [anon_sym_mutable] = ACTIONS(2864),
    [anon_sym_explicit] = ACTIONS(2864),
    [anon_sym_constexpr] = ACTIONS(2864),
    [anon_sym_DASH_GT] = ACTIONS(3852),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(3855),
  },
  [1157] = {
    [sym_storage_class_specifier] = STATE(1157),
    [sym_type_qualifier] = STATE(1157),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1157),
    [anon_sym_LPAREN] = ACTIONS(798),
    [anon_sym_SEMI] = ACTIONS(798),
    [anon_sym_extern] = ACTIONS(1792),
    [anon_sym_STAR] = ACTIONS(798),
    [anon_sym_static] = ACTIONS(1792),
    [anon_sym_register] = ACTIONS(1792),
    [anon_sym_inline] = ACTIONS(1792),
    [anon_sym_const] = ACTIONS(1795),
    [anon_sym_restrict] = ACTIONS(1795),
    [anon_sym_volatile] = ACTIONS(1795),
    [anon_sym__Atomic] = ACTIONS(1795),
    [anon_sym_mutable] = ACTIONS(1795),
    [anon_sym_explicit] = ACTIONS(1795),
    [anon_sym_constexpr] = ACTIONS(1795),
    [anon_sym_AMP] = ACTIONS(806),
    [anon_sym_AMP_AMP] = ACTIONS(798),
    [anon_sym_TILDE] = ACTIONS(798),
    [sym_identifier] = ACTIONS(806),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(798),
    [sym_operator_name] = ACTIONS(798),
  },
  [1158] = {
    [sym_storage_class_specifier] = STATE(1157),
    [sym_type_qualifier] = STATE(1157),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1157),
    [anon_sym_LPAREN] = ACTIONS(1811),
    [anon_sym_SEMI] = ACTIONS(1811),
    [anon_sym_extern] = ACTIONS(218),
    [anon_sym_STAR] = ACTIONS(1811),
    [anon_sym_static] = ACTIONS(218),
    [anon_sym_register] = ACTIONS(218),
    [anon_sym_inline] = ACTIONS(218),
    [anon_sym_const] = ACTIONS(220),
    [anon_sym_restrict] = ACTIONS(220),
    [anon_sym_volatile] = ACTIONS(220),
    [anon_sym__Atomic] = ACTIONS(220),
    [anon_sym_mutable] = ACTIONS(220),
    [anon_sym_explicit] = ACTIONS(220),
    [anon_sym_constexpr] = ACTIONS(220),
    [anon_sym_AMP] = ACTIONS(1813),
    [anon_sym_AMP_AMP] = ACTIONS(1811),
    [anon_sym_TILDE] = ACTIONS(1811),
    [sym_identifier] = ACTIONS(1813),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(1811),
    [sym_operator_name] = ACTIONS(1811),
  },
  [1159] = {
    [sym__abstract_declarator] = STATE(1745),
    [sym_abstract_pointer_declarator] = STATE(1745),
    [sym_abstract_function_declarator] = STATE(1745),
    [sym_abstract_array_declarator] = STATE(1745),
    [sym_parameter_list] = STATE(1162),
    [sym_abstract_reference_declarator] = STATE(1745),
    [anon_sym_LPAREN] = ACTIONS(1115),
    [anon_sym_SEMI] = ACTIONS(2270),
    [anon_sym_STAR] = ACTIONS(2359),
    [anon_sym_LBRACK] = ACTIONS(1121),
    [anon_sym_AMP] = ACTIONS(2361),
    [anon_sym_AMP_AMP] = ACTIONS(2363),
    [sym_comment] = ACTIONS(49),
  },
  [1160] = {
    [sym__abstract_declarator] = STATE(1746),
    [sym_abstract_pointer_declarator] = STATE(1746),
    [sym_abstract_function_declarator] = STATE(1746),
    [sym_abstract_array_declarator] = STATE(1746),
    [sym_parameter_list] = STATE(1162),
    [sym_abstract_reference_declarator] = STATE(1746),
    [anon_sym_LPAREN] = ACTIONS(1115),
    [anon_sym_SEMI] = ACTIONS(2278),
    [anon_sym_STAR] = ACTIONS(2359),
    [anon_sym_LBRACK] = ACTIONS(1121),
    [anon_sym_AMP] = ACTIONS(2361),
    [anon_sym_AMP_AMP] = ACTIONS(2363),
    [sym_comment] = ACTIONS(49),
  },
  [1161] = {
    [sym_parameter_list] = STATE(1747),
    [anon_sym_LPAREN] = ACTIONS(206),
    [anon_sym_SEMI] = ACTIONS(2280),
    [anon_sym_LBRACK] = ACTIONS(2282),
    [sym_comment] = ACTIONS(49),
  },
  [1162] = {
    [sym_type_qualifier] = STATE(1749),
    [sym_trailing_return_type] = STATE(1129),
    [aux_sym_abstract_function_declarator_repeat1] = STATE(1749),
    [anon_sym_LPAREN] = ACTIONS(2284),
    [anon_sym_SEMI] = ACTIONS(2284),
    [anon_sym_LBRACK] = ACTIONS(2284),
    [anon_sym_const] = ACTIONS(612),
    [anon_sym_restrict] = ACTIONS(614),
    [anon_sym_volatile] = ACTIONS(614),
    [anon_sym__Atomic] = ACTIONS(614),
    [anon_sym_mutable] = ACTIONS(614),
    [anon_sym_explicit] = ACTIONS(614),
    [anon_sym_constexpr] = ACTIONS(614),
    [anon_sym_DASH_GT] = ACTIONS(3858),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(3860),
  },
  [1163] = {
    [ts_builtin_sym_end] = ACTIONS(3862),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3864),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3864),
    [anon_sym_LPAREN] = ACTIONS(3862),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3864),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3864),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3864),
    [sym_preproc_directive] = ACTIONS(3864),
    [anon_sym_typedef] = ACTIONS(3864),
    [anon_sym_extern] = ACTIONS(3864),
    [anon_sym_RBRACE] = ACTIONS(3862),
    [anon_sym_STAR] = ACTIONS(3862),
    [anon_sym_static] = ACTIONS(3864),
    [anon_sym_register] = ACTIONS(3864),
    [anon_sym_inline] = ACTIONS(3864),
    [anon_sym_const] = ACTIONS(3864),
    [anon_sym_restrict] = ACTIONS(3864),
    [anon_sym_volatile] = ACTIONS(3864),
    [anon_sym__Atomic] = ACTIONS(3864),
    [anon_sym_mutable] = ACTIONS(3864),
    [anon_sym_explicit] = ACTIONS(3864),
    [anon_sym_constexpr] = ACTIONS(3864),
    [anon_sym_unsigned] = ACTIONS(3864),
    [anon_sym_long] = ACTIONS(3864),
    [anon_sym_short] = ACTIONS(3864),
    [sym_primitive_type] = ACTIONS(3864),
    [anon_sym_enum] = ACTIONS(3864),
    [anon_sym_struct] = ACTIONS(3864),
    [anon_sym_union] = ACTIONS(3864),
    [anon_sym_AMP] = ACTIONS(3864),
    [anon_sym_AMP_AMP] = ACTIONS(3862),
    [anon_sym_TILDE] = ACTIONS(3862),
    [sym_identifier] = ACTIONS(3864),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(3864),
    [sym_auto] = ACTIONS(3864),
    [anon_sym_typename] = ACTIONS(3864),
    [anon_sym_template] = ACTIONS(3864),
    [anon_sym_namespace] = ACTIONS(3864),
    [anon_sym_using] = ACTIONS(3864),
    [anon_sym_COLON_COLON] = ACTIONS(3862),
    [sym_operator_name] = ACTIONS(3862),
  },
  [1164] = {
    [sym__abstract_declarator] = STATE(1750),
    [sym_abstract_pointer_declarator] = STATE(1750),
    [sym_abstract_function_declarator] = STATE(1750),
    [sym_abstract_array_declarator] = STATE(1750),
    [sym_parameter_list] = STATE(1162),
    [sym_abstract_reference_declarator] = STATE(1750),
    [anon_sym_LPAREN] = ACTIONS(1115),
    [anon_sym_SEMI] = ACTIONS(2280),
    [anon_sym_STAR] = ACTIONS(2359),
    [anon_sym_LBRACK] = ACTIONS(1121),
    [anon_sym_AMP] = ACTIONS(2361),
    [anon_sym_AMP_AMP] = ACTIONS(2363),
    [sym_comment] = ACTIONS(49),
  },
  [1165] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(1165),
    [anon_sym_LPAREN] = ACTIONS(816),
    [anon_sym_SEMI] = ACTIONS(816),
    [anon_sym_STAR] = ACTIONS(816),
    [anon_sym_LBRACK] = ACTIONS(816),
    [anon_sym_unsigned] = ACTIONS(3866),
    [anon_sym_long] = ACTIONS(3866),
    [anon_sym_short] = ACTIONS(3866),
    [sym_primitive_type] = ACTIONS(818),
    [anon_sym_AMP] = ACTIONS(818),
    [anon_sym_AMP_AMP] = ACTIONS(816),
    [sym_identifier] = ACTIONS(818),
    [sym_comment] = ACTIONS(49),
  },
  [1166] = {
    [anon_sym_COMMA] = ACTIONS(3869),
    [anon_sym_RBRACK] = ACTIONS(3869),
    [sym_comment] = ACTIONS(49),
  },
  [1167] = {
    [anon_sym_LPAREN] = ACTIONS(3871),
    [anon_sym_LBRACE] = ACTIONS(3871),
    [anon_sym_EQ] = ACTIONS(3871),
    [sym_comment] = ACTIONS(49),
  },
  [1168] = {
    [aux_sym_structured_binding_declarator_repeat1] = STATE(1168),
    [anon_sym_COMMA] = ACTIONS(3873),
    [anon_sym_RBRACK] = ACTIONS(3869),
    [sym_comment] = ACTIONS(49),
  },
  [1169] = {
    [sym_destructor_name] = STATE(282),
    [anon_sym_TILDE] = ACTIONS(1500),
    [sym_identifier] = ACTIONS(3876),
    [sym_comment] = ACTIONS(49),
    [sym_operator_name] = ACTIONS(442),
  },
  [1170] = {
    [anon_sym_LPAREN] = ACTIONS(444),
    [anon_sym_COMMA] = ACTIONS(444),
    [anon_sym_RPAREN] = ACTIONS(444),
    [anon_sym_extern] = ACTIONS(449),
    [anon_sym_LBRACE] = ACTIONS(447),
    [anon_sym_STAR] = ACTIONS(2720),
    [anon_sym_LBRACK] = ACTIONS(444),
    [anon_sym_EQ] = ACTIONS(706),
    [anon_sym_static] = ACTIONS(449),
    [anon_sym_register] = ACTIONS(449),
    [anon_sym_inline] = ACTIONS(449),
    [anon_sym_const] = ACTIONS(449),
    [anon_sym_restrict] = ACTIONS(449),
    [anon_sym_volatile] = ACTIONS(449),
    [anon_sym__Atomic] = ACTIONS(449),
    [anon_sym_mutable] = ACTIONS(449),
    [anon_sym_explicit] = ACTIONS(449),
    [anon_sym_constexpr] = ACTIONS(449),
    [anon_sym_QMARK] = ACTIONS(704),
    [anon_sym_STAR_EQ] = ACTIONS(704),
    [anon_sym_SLASH_EQ] = ACTIONS(704),
    [anon_sym_PERCENT_EQ] = ACTIONS(704),
    [anon_sym_PLUS_EQ] = ACTIONS(704),
    [anon_sym_DASH_EQ] = ACTIONS(704),
    [anon_sym_LT_LT_EQ] = ACTIONS(704),
    [anon_sym_GT_GT_EQ] = ACTIONS(704),
    [anon_sym_AMP_EQ] = ACTIONS(704),
    [anon_sym_CARET_EQ] = ACTIONS(704),
    [anon_sym_PIPE_EQ] = ACTIONS(704),
    [anon_sym_AMP] = ACTIONS(2720),
    [anon_sym_PIPE_PIPE] = ACTIONS(704),
    [anon_sym_AMP_AMP] = ACTIONS(444),
    [anon_sym_PIPE] = ACTIONS(706),
    [anon_sym_CARET] = ACTIONS(706),
    [anon_sym_TILDE] = ACTIONS(447),
    [anon_sym_EQ_EQ] = ACTIONS(704),
    [anon_sym_BANG_EQ] = ACTIONS(704),
    [anon_sym_LT] = ACTIONS(706),
    [anon_sym_GT] = ACTIONS(706),
    [anon_sym_LT_EQ] = ACTIONS(704),
    [anon_sym_GT_EQ] = ACTIONS(704),
    [anon_sym_LT_LT] = ACTIONS(706),
    [anon_sym_GT_GT] = ACTIONS(706),
    [anon_sym_PLUS] = ACTIONS(706),
    [anon_sym_DASH] = ACTIONS(706),
    [anon_sym_SLASH] = ACTIONS(706),
    [anon_sym_PERCENT] = ACTIONS(706),
    [anon_sym_DASH_DASH] = ACTIONS(704),
    [anon_sym_PLUS_PLUS] = ACTIONS(704),
    [anon_sym_DOT] = ACTIONS(704),
    [anon_sym_DASH_GT] = ACTIONS(704),
    [sym_identifier] = ACTIONS(449),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(447),
    [sym_operator_name] = ACTIONS(447),
  },
  [1171] = {
    [anon_sym_LPAREN] = ACTIONS(509),
    [anon_sym_COMMA] = ACTIONS(509),
    [anon_sym_RPAREN] = ACTIONS(509),
    [anon_sym_extern] = ACTIONS(514),
    [anon_sym_LBRACE] = ACTIONS(512),
    [anon_sym_STAR] = ACTIONS(2729),
    [anon_sym_LBRACK] = ACTIONS(509),
    [anon_sym_EQ] = ACTIONS(520),
    [anon_sym_static] = ACTIONS(514),
    [anon_sym_register] = ACTIONS(514),
    [anon_sym_inline] = ACTIONS(514),
    [anon_sym_const] = ACTIONS(514),
    [anon_sym_restrict] = ACTIONS(514),
    [anon_sym_volatile] = ACTIONS(514),
    [anon_sym__Atomic] = ACTIONS(514),
    [anon_sym_mutable] = ACTIONS(514),
    [anon_sym_explicit] = ACTIONS(514),
    [anon_sym_constexpr] = ACTIONS(514),
    [anon_sym_QMARK] = ACTIONS(518),
    [anon_sym_STAR_EQ] = ACTIONS(518),
    [anon_sym_SLASH_EQ] = ACTIONS(518),
    [anon_sym_PERCENT_EQ] = ACTIONS(518),
    [anon_sym_PLUS_EQ] = ACTIONS(518),
    [anon_sym_DASH_EQ] = ACTIONS(518),
    [anon_sym_LT_LT_EQ] = ACTIONS(518),
    [anon_sym_GT_GT_EQ] = ACTIONS(518),
    [anon_sym_AMP_EQ] = ACTIONS(518),
    [anon_sym_CARET_EQ] = ACTIONS(518),
    [anon_sym_PIPE_EQ] = ACTIONS(518),
    [anon_sym_AMP] = ACTIONS(2729),
    [anon_sym_PIPE_PIPE] = ACTIONS(518),
    [anon_sym_AMP_AMP] = ACTIONS(509),
    [anon_sym_PIPE] = ACTIONS(520),
    [anon_sym_CARET] = ACTIONS(520),
    [anon_sym_TILDE] = ACTIONS(512),
    [anon_sym_EQ_EQ] = ACTIONS(518),
    [anon_sym_BANG_EQ] = ACTIONS(518),
    [anon_sym_LT] = ACTIONS(2729),
    [anon_sym_GT] = ACTIONS(520),
    [anon_sym_LT_EQ] = ACTIONS(518),
    [anon_sym_GT_EQ] = ACTIONS(518),
    [anon_sym_LT_LT] = ACTIONS(520),
    [anon_sym_GT_GT] = ACTIONS(520),
    [anon_sym_PLUS] = ACTIONS(520),
    [anon_sym_DASH] = ACTIONS(520),
    [anon_sym_SLASH] = ACTIONS(520),
    [anon_sym_PERCENT] = ACTIONS(520),
    [anon_sym_DASH_DASH] = ACTIONS(518),
    [anon_sym_PLUS_PLUS] = ACTIONS(518),
    [anon_sym_DOT] = ACTIONS(518),
    [anon_sym_DASH_GT] = ACTIONS(518),
    [sym_identifier] = ACTIONS(514),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(516),
    [sym_operator_name] = ACTIONS(512),
  },
  [1172] = {
    [sym__expression] = STATE(1752),
    [sym_conditional_expression] = STATE(1752),
    [sym_assignment_expression] = STATE(1752),
    [sym_pointer_expression] = STATE(1752),
    [sym_logical_expression] = STATE(1752),
    [sym_bitwise_expression] = STATE(1752),
    [sym_equality_expression] = STATE(1752),
    [sym_relational_expression] = STATE(1752),
    [sym_shift_expression] = STATE(1752),
    [sym_math_expression] = STATE(1752),
    [sym_cast_expression] = STATE(1752),
    [sym_sizeof_expression] = STATE(1752),
    [sym_subscript_expression] = STATE(1752),
    [sym_call_expression] = STATE(1752),
    [sym_field_expression] = STATE(1752),
    [sym_compound_literal_expression] = STATE(1752),
    [sym_parenthesized_expression] = STATE(1752),
    [sym_initializer_list] = STATE(1753),
    [sym_concatenated_string] = STATE(1752),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(1752),
    [sym_new_expression] = STATE(1752),
    [sym_delete_expression] = STATE(1752),
    [sym_lambda_expression] = STATE(1752),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(3878),
    [anon_sym_LPAREN] = ACTIONS(1087),
    [anon_sym_LBRACE] = ACTIONS(548),
    [anon_sym_STAR] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_AMP] = ACTIONS(1089),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1093),
    [anon_sym_PLUS] = ACTIONS(1095),
    [anon_sym_DASH] = ACTIONS(1095),
    [anon_sym_DASH_DASH] = ACTIONS(1097),
    [anon_sym_PLUS_PLUS] = ACTIONS(1097),
    [anon_sym_sizeof] = ACTIONS(1099),
    [sym_number_literal] = ACTIONS(3878),
    [sym_char_literal] = ACTIONS(3878),
    [sym_string_literal] = ACTIONS(1101),
    [sym_true] = ACTIONS(3880),
    [sym_false] = ACTIONS(3880),
    [sym_null] = ACTIONS(3880),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_delete] = ACTIONS(1109),
    [sym_nullptr] = ACTIONS(3880),
  },
  [1173] = {
    [anon_sym_LPAREN] = ACTIONS(3882),
    [anon_sym_COMMA] = ACTIONS(3882),
    [anon_sym_RPAREN] = ACTIONS(3882),
    [anon_sym_SEMI] = ACTIONS(3882),
    [anon_sym_LBRACE] = ACTIONS(3882),
    [anon_sym_RBRACE] = ACTIONS(3882),
    [anon_sym_STAR] = ACTIONS(3884),
    [anon_sym_LBRACK] = ACTIONS(3882),
    [anon_sym_RBRACK] = ACTIONS(3882),
    [anon_sym_EQ] = ACTIONS(3884),
    [anon_sym_COLON] = ACTIONS(3882),
    [anon_sym_QMARK] = ACTIONS(3882),
    [anon_sym_STAR_EQ] = ACTIONS(3882),
    [anon_sym_SLASH_EQ] = ACTIONS(3882),
    [anon_sym_PERCENT_EQ] = ACTIONS(3882),
    [anon_sym_PLUS_EQ] = ACTIONS(3882),
    [anon_sym_DASH_EQ] = ACTIONS(3882),
    [anon_sym_LT_LT_EQ] = ACTIONS(3882),
    [anon_sym_GT_GT_EQ] = ACTIONS(3882),
    [anon_sym_AMP_EQ] = ACTIONS(3882),
    [anon_sym_CARET_EQ] = ACTIONS(3882),
    [anon_sym_PIPE_EQ] = ACTIONS(3882),
    [anon_sym_AMP] = ACTIONS(3884),
    [anon_sym_PIPE_PIPE] = ACTIONS(3882),
    [anon_sym_AMP_AMP] = ACTIONS(3882),
    [anon_sym_PIPE] = ACTIONS(3884),
    [anon_sym_CARET] = ACTIONS(3884),
    [anon_sym_EQ_EQ] = ACTIONS(3882),
    [anon_sym_BANG_EQ] = ACTIONS(3882),
    [anon_sym_LT] = ACTIONS(3884),
    [anon_sym_GT] = ACTIONS(3884),
    [anon_sym_LT_EQ] = ACTIONS(3882),
    [anon_sym_GT_EQ] = ACTIONS(3882),
    [anon_sym_LT_LT] = ACTIONS(3884),
    [anon_sym_GT_GT] = ACTIONS(3884),
    [anon_sym_PLUS] = ACTIONS(3884),
    [anon_sym_DASH] = ACTIONS(3884),
    [anon_sym_SLASH] = ACTIONS(3884),
    [anon_sym_PERCENT] = ACTIONS(3884),
    [anon_sym_DASH_DASH] = ACTIONS(3882),
    [anon_sym_PLUS_PLUS] = ACTIONS(3882),
    [anon_sym_DOT] = ACTIONS(3882),
    [anon_sym_DASH_GT] = ACTIONS(3882),
    [sym_comment] = ACTIONS(49),
  },
  [1174] = {
    [aux_sym_argument_list_repeat1] = STATE(1755),
    [anon_sym_COMMA] = ACTIONS(2388),
    [anon_sym_RPAREN] = ACTIONS(3886),
    [sym_comment] = ACTIONS(49),
  },
  [1175] = {
    [sym_destructor_name] = STATE(428),
    [anon_sym_TILDE] = ACTIONS(1500),
    [sym_identifier] = ACTIONS(3888),
    [sym_comment] = ACTIONS(49),
    [sym_operator_name] = ACTIONS(702),
  },
  [1176] = {
    [anon_sym_RPAREN] = ACTIONS(3890),
    [sym_comment] = ACTIONS(49),
  },
  [1177] = {
    [anon_sym_LPAREN] = ACTIONS(3892),
    [anon_sym_COMMA] = ACTIONS(3892),
    [anon_sym_RPAREN] = ACTIONS(3892),
    [anon_sym_SEMI] = ACTIONS(3892),
    [anon_sym_LBRACE] = ACTIONS(3892),
    [anon_sym_RBRACE] = ACTIONS(3892),
    [anon_sym_STAR] = ACTIONS(3894),
    [anon_sym_LBRACK] = ACTIONS(3892),
    [anon_sym_RBRACK] = ACTIONS(3892),
    [anon_sym_EQ] = ACTIONS(3894),
    [anon_sym_COLON] = ACTIONS(3892),
    [anon_sym_QMARK] = ACTIONS(3892),
    [anon_sym_STAR_EQ] = ACTIONS(3892),
    [anon_sym_SLASH_EQ] = ACTIONS(3892),
    [anon_sym_PERCENT_EQ] = ACTIONS(3892),
    [anon_sym_PLUS_EQ] = ACTIONS(3892),
    [anon_sym_DASH_EQ] = ACTIONS(3892),
    [anon_sym_LT_LT_EQ] = ACTIONS(3892),
    [anon_sym_GT_GT_EQ] = ACTIONS(3892),
    [anon_sym_AMP_EQ] = ACTIONS(3892),
    [anon_sym_CARET_EQ] = ACTIONS(3892),
    [anon_sym_PIPE_EQ] = ACTIONS(3892),
    [anon_sym_AMP] = ACTIONS(3894),
    [anon_sym_PIPE_PIPE] = ACTIONS(3892),
    [anon_sym_AMP_AMP] = ACTIONS(3892),
    [anon_sym_PIPE] = ACTIONS(3894),
    [anon_sym_CARET] = ACTIONS(3894),
    [anon_sym_EQ_EQ] = ACTIONS(3892),
    [anon_sym_BANG_EQ] = ACTIONS(3892),
    [anon_sym_LT] = ACTIONS(3894),
    [anon_sym_GT] = ACTIONS(3894),
    [anon_sym_LT_EQ] = ACTIONS(3892),
    [anon_sym_GT_EQ] = ACTIONS(3892),
    [anon_sym_LT_LT] = ACTIONS(3894),
    [anon_sym_GT_GT] = ACTIONS(3894),
    [anon_sym_PLUS] = ACTIONS(3894),
    [anon_sym_DASH] = ACTIONS(3894),
    [anon_sym_SLASH] = ACTIONS(3894),
    [anon_sym_PERCENT] = ACTIONS(3894),
    [anon_sym_DASH_DASH] = ACTIONS(3892),
    [anon_sym_PLUS_PLUS] = ACTIONS(3892),
    [anon_sym_DOT] = ACTIONS(3892),
    [anon_sym_DASH_GT] = ACTIONS(3892),
    [sym_comment] = ACTIONS(49),
  },
  [1178] = {
    [sym_raw_string_literal] = ACTIONS(1622),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1624),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1624),
    [anon_sym_LPAREN] = ACTIONS(1622),
    [anon_sym_COMMA] = ACTIONS(2400),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1624),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1624),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1624),
    [sym_preproc_directive] = ACTIONS(1624),
    [anon_sym_SEMI] = ACTIONS(1622),
    [anon_sym_typedef] = ACTIONS(1624),
    [anon_sym_extern] = ACTIONS(1624),
    [anon_sym_LBRACE] = ACTIONS(1622),
    [anon_sym_RBRACE] = ACTIONS(2400),
    [anon_sym_STAR] = ACTIONS(1622),
    [anon_sym_LBRACK] = ACTIONS(1622),
    [anon_sym_static] = ACTIONS(1624),
    [anon_sym_register] = ACTIONS(1624),
    [anon_sym_inline] = ACTIONS(1624),
    [anon_sym_const] = ACTIONS(1624),
    [anon_sym_restrict] = ACTIONS(1624),
    [anon_sym_volatile] = ACTIONS(1624),
    [anon_sym__Atomic] = ACTIONS(1624),
    [anon_sym_mutable] = ACTIONS(1624),
    [anon_sym_explicit] = ACTIONS(1624),
    [anon_sym_constexpr] = ACTIONS(1624),
    [anon_sym_unsigned] = ACTIONS(1624),
    [anon_sym_long] = ACTIONS(1624),
    [anon_sym_short] = ACTIONS(1624),
    [sym_primitive_type] = ACTIONS(1624),
    [anon_sym_enum] = ACTIONS(1624),
    [anon_sym_struct] = ACTIONS(1624),
    [anon_sym_union] = ACTIONS(1624),
    [anon_sym_if] = ACTIONS(1624),
    [anon_sym_switch] = ACTIONS(1624),
    [anon_sym_case] = ACTIONS(1624),
    [anon_sym_default] = ACTIONS(1624),
    [anon_sym_while] = ACTIONS(1624),
    [anon_sym_do] = ACTIONS(1624),
    [anon_sym_for] = ACTIONS(1624),
    [anon_sym_return] = ACTIONS(1624),
    [anon_sym_break] = ACTIONS(1624),
    [anon_sym_continue] = ACTIONS(1624),
    [anon_sym_goto] = ACTIONS(1624),
    [anon_sym_AMP] = ACTIONS(1622),
    [anon_sym_BANG] = ACTIONS(1622),
    [anon_sym_TILDE] = ACTIONS(1622),
    [anon_sym_PLUS] = ACTIONS(1624),
    [anon_sym_DASH] = ACTIONS(1624),
    [anon_sym_DASH_DASH] = ACTIONS(1622),
    [anon_sym_PLUS_PLUS] = ACTIONS(1622),
    [anon_sym_sizeof] = ACTIONS(1624),
    [sym_number_literal] = ACTIONS(1622),
    [sym_char_literal] = ACTIONS(1622),
    [sym_string_literal] = ACTIONS(1622),
    [sym_true] = ACTIONS(1624),
    [sym_false] = ACTIONS(1624),
    [sym_null] = ACTIONS(1624),
    [sym_identifier] = ACTIONS(1624),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(1624),
    [sym_auto] = ACTIONS(1624),
    [anon_sym_typename] = ACTIONS(1624),
    [anon_sym_new] = ACTIONS(1624),
    [anon_sym_COLON_COLON] = ACTIONS(1622),
    [anon_sym_delete] = ACTIONS(1624),
    [sym_nullptr] = ACTIONS(1624),
  },
  [1179] = {
    [sym_destructor_name] = STATE(120),
    [anon_sym_TILDE] = ACTIONS(1500),
    [sym_identifier] = ACTIONS(2220),
    [sym_comment] = ACTIONS(49),
    [anon_sym_delete] = ACTIONS(2418),
    [sym_operator_name] = ACTIONS(190),
  },
  [1180] = {
    [sym_argument_list] = STATE(802),
    [aux_sym_for_statement_repeat1] = STATE(1293),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_COMMA] = ACTIONS(2646),
    [anon_sym_STAR] = ACTIONS(2648),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_RBRACK] = ACTIONS(3896),
    [anon_sym_EQ] = ACTIONS(2652),
    [anon_sym_QMARK] = ACTIONS(2654),
    [anon_sym_STAR_EQ] = ACTIONS(2656),
    [anon_sym_SLASH_EQ] = ACTIONS(2656),
    [anon_sym_PERCENT_EQ] = ACTIONS(2656),
    [anon_sym_PLUS_EQ] = ACTIONS(2656),
    [anon_sym_DASH_EQ] = ACTIONS(2656),
    [anon_sym_LT_LT_EQ] = ACTIONS(2656),
    [anon_sym_GT_GT_EQ] = ACTIONS(2656),
    [anon_sym_AMP_EQ] = ACTIONS(2656),
    [anon_sym_CARET_EQ] = ACTIONS(2656),
    [anon_sym_PIPE_EQ] = ACTIONS(2656),
    [anon_sym_AMP] = ACTIONS(2658),
    [anon_sym_PIPE_PIPE] = ACTIONS(2660),
    [anon_sym_AMP_AMP] = ACTIONS(2662),
    [anon_sym_PIPE] = ACTIONS(2664),
    [anon_sym_CARET] = ACTIONS(2666),
    [anon_sym_EQ_EQ] = ACTIONS(2668),
    [anon_sym_BANG_EQ] = ACTIONS(2668),
    [anon_sym_LT] = ACTIONS(2670),
    [anon_sym_GT] = ACTIONS(2670),
    [anon_sym_LT_EQ] = ACTIONS(2672),
    [anon_sym_GT_EQ] = ACTIONS(2672),
    [anon_sym_LT_LT] = ACTIONS(2674),
    [anon_sym_GT_GT] = ACTIONS(2674),
    [anon_sym_PLUS] = ACTIONS(2676),
    [anon_sym_DASH] = ACTIONS(2676),
    [anon_sym_SLASH] = ACTIONS(2648),
    [anon_sym_PERCENT] = ACTIONS(2648),
    [anon_sym_DASH_DASH] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(1554),
    [anon_sym_DASH_GT] = ACTIONS(1554),
    [sym_comment] = ACTIONS(49),
  },
  [1181] = {
    [sym_type_qualifier] = STATE(724),
    [sym__type_specifier] = STATE(720),
    [sym_sized_type_specifier] = STATE(720),
    [sym_enum_specifier] = STATE(720),
    [sym_struct_specifier] = STATE(720),
    [sym_union_specifier] = STATE(720),
    [sym__expression] = STATE(721),
    [sym_comma_expression] = STATE(722),
    [sym_conditional_expression] = STATE(721),
    [sym_assignment_expression] = STATE(721),
    [sym_pointer_expression] = STATE(721),
    [sym_logical_expression] = STATE(721),
    [sym_bitwise_expression] = STATE(721),
    [sym_equality_expression] = STATE(721),
    [sym_relational_expression] = STATE(721),
    [sym_shift_expression] = STATE(721),
    [sym_math_expression] = STATE(721),
    [sym_cast_expression] = STATE(721),
    [sym_type_descriptor] = STATE(1759),
    [sym_sizeof_expression] = STATE(721),
    [sym_subscript_expression] = STATE(721),
    [sym_call_expression] = STATE(721),
    [sym_field_expression] = STATE(721),
    [sym_compound_literal_expression] = STATE(721),
    [sym_parenthesized_expression] = STATE(721),
    [sym_concatenated_string] = STATE(721),
    [sym_macro_type_specifier] = STATE(720),
    [sym_class_specifier] = STATE(720),
    [sym_dependent_type] = STATE(720),
    [sym_template_type] = STATE(415),
    [sym_template_function] = STATE(721),
    [sym_new_expression] = STATE(721),
    [sym_delete_expression] = STATE(721),
    [sym_lambda_expression] = STATE(721),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(416),
    [sym_scoped_namespace_identifier] = STATE(417),
    [aux_sym_type_definition_repeat1] = STATE(724),
    [aux_sym_sized_type_specifier_repeat1] = STATE(725),
    [sym_raw_string_literal] = ACTIONS(1397),
    [anon_sym_LPAREN] = ACTIONS(1087),
    [anon_sym_STAR] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_restrict] = ACTIONS(93),
    [anon_sym_volatile] = ACTIONS(93),
    [anon_sym__Atomic] = ACTIONS(93),
    [anon_sym_mutable] = ACTIONS(93),
    [anon_sym_explicit] = ACTIONS(93),
    [anon_sym_constexpr] = ACTIONS(93),
    [anon_sym_unsigned] = ACTIONS(1399),
    [anon_sym_long] = ACTIONS(1399),
    [anon_sym_short] = ACTIONS(1399),
    [sym_primitive_type] = ACTIONS(1401),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(428),
    [anon_sym_union] = ACTIONS(430),
    [anon_sym_AMP] = ACTIONS(1089),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1093),
    [anon_sym_PLUS] = ACTIONS(1095),
    [anon_sym_DASH] = ACTIONS(1095),
    [anon_sym_DASH_DASH] = ACTIONS(1097),
    [anon_sym_PLUS_PLUS] = ACTIONS(1097),
    [anon_sym_sizeof] = ACTIONS(1099),
    [sym_number_literal] = ACTIONS(1397),
    [sym_char_literal] = ACTIONS(1397),
    [sym_string_literal] = ACTIONS(1101),
    [sym_true] = ACTIONS(1403),
    [sym_false] = ACTIONS(1403),
    [sym_null] = ACTIONS(1403),
    [sym_identifier] = ACTIONS(1405),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(436),
    [sym_auto] = ACTIONS(1401),
    [anon_sym_typename] = ACTIONS(1407),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1409),
    [anon_sym_delete] = ACTIONS(1109),
    [sym_nullptr] = ACTIONS(1403),
  },
  [1182] = {
    [sym_argument_list] = STATE(802),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_COMMA] = ACTIONS(2702),
    [anon_sym_SEMI] = ACTIONS(2702),
    [anon_sym_RBRACE] = ACTIONS(2702),
    [anon_sym_STAR] = ACTIONS(2428),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_EQ] = ACTIONS(2704),
    [anon_sym_QMARK] = ACTIONS(2702),
    [anon_sym_STAR_EQ] = ACTIONS(2702),
    [anon_sym_SLASH_EQ] = ACTIONS(2702),
    [anon_sym_PERCENT_EQ] = ACTIONS(2702),
    [anon_sym_PLUS_EQ] = ACTIONS(2702),
    [anon_sym_DASH_EQ] = ACTIONS(2702),
    [anon_sym_LT_LT_EQ] = ACTIONS(2702),
    [anon_sym_GT_GT_EQ] = ACTIONS(2702),
    [anon_sym_AMP_EQ] = ACTIONS(2702),
    [anon_sym_CARET_EQ] = ACTIONS(2702),
    [anon_sym_PIPE_EQ] = ACTIONS(2702),
    [anon_sym_AMP] = ACTIONS(2704),
    [anon_sym_PIPE_PIPE] = ACTIONS(2702),
    [anon_sym_AMP_AMP] = ACTIONS(2702),
    [anon_sym_PIPE] = ACTIONS(2704),
    [anon_sym_CARET] = ACTIONS(2704),
    [anon_sym_EQ_EQ] = ACTIONS(2702),
    [anon_sym_BANG_EQ] = ACTIONS(2702),
    [anon_sym_LT] = ACTIONS(2704),
    [anon_sym_GT] = ACTIONS(2704),
    [anon_sym_LT_EQ] = ACTIONS(2702),
    [anon_sym_GT_EQ] = ACTIONS(2702),
    [anon_sym_LT_LT] = ACTIONS(2452),
    [anon_sym_GT_GT] = ACTIONS(2452),
    [anon_sym_PLUS] = ACTIONS(2454),
    [anon_sym_DASH] = ACTIONS(2454),
    [anon_sym_SLASH] = ACTIONS(2428),
    [anon_sym_PERCENT] = ACTIONS(2428),
    [anon_sym_DASH_DASH] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(1554),
    [anon_sym_DASH_GT] = ACTIONS(1554),
    [sym_comment] = ACTIONS(49),
  },
  [1183] = {
    [anon_sym_LBRACK] = ACTIONS(3898),
    [anon_sym_EQ] = ACTIONS(3898),
    [anon_sym_DOT] = ACTIONS(3898),
    [sym_comment] = ACTIONS(49),
  },
  [1184] = {
    [aux_sym_concatenated_string_repeat1] = STATE(1760),
    [anon_sym_LPAREN] = ACTIONS(2706),
    [anon_sym_COMMA] = ACTIONS(2706),
    [anon_sym_SEMI] = ACTIONS(2706),
    [anon_sym_RBRACE] = ACTIONS(2706),
    [anon_sym_STAR] = ACTIONS(2708),
    [anon_sym_LBRACK] = ACTIONS(2706),
    [anon_sym_EQ] = ACTIONS(2708),
    [anon_sym_QMARK] = ACTIONS(2706),
    [anon_sym_STAR_EQ] = ACTIONS(2706),
    [anon_sym_SLASH_EQ] = ACTIONS(2706),
    [anon_sym_PERCENT_EQ] = ACTIONS(2706),
    [anon_sym_PLUS_EQ] = ACTIONS(2706),
    [anon_sym_DASH_EQ] = ACTIONS(2706),
    [anon_sym_LT_LT_EQ] = ACTIONS(2706),
    [anon_sym_GT_GT_EQ] = ACTIONS(2706),
    [anon_sym_AMP_EQ] = ACTIONS(2706),
    [anon_sym_CARET_EQ] = ACTIONS(2706),
    [anon_sym_PIPE_EQ] = ACTIONS(2706),
    [anon_sym_AMP] = ACTIONS(2708),
    [anon_sym_PIPE_PIPE] = ACTIONS(2706),
    [anon_sym_AMP_AMP] = ACTIONS(2706),
    [anon_sym_PIPE] = ACTIONS(2708),
    [anon_sym_CARET] = ACTIONS(2708),
    [anon_sym_EQ_EQ] = ACTIONS(2706),
    [anon_sym_BANG_EQ] = ACTIONS(2706),
    [anon_sym_LT] = ACTIONS(2708),
    [anon_sym_GT] = ACTIONS(2708),
    [anon_sym_LT_EQ] = ACTIONS(2706),
    [anon_sym_GT_EQ] = ACTIONS(2706),
    [anon_sym_LT_LT] = ACTIONS(2708),
    [anon_sym_GT_GT] = ACTIONS(2708),
    [anon_sym_PLUS] = ACTIONS(2708),
    [anon_sym_DASH] = ACTIONS(2708),
    [anon_sym_SLASH] = ACTIONS(2708),
    [anon_sym_PERCENT] = ACTIONS(2708),
    [anon_sym_DASH_DASH] = ACTIONS(2706),
    [anon_sym_PLUS_PLUS] = ACTIONS(2706),
    [anon_sym_DOT] = ACTIONS(2706),
    [anon_sym_DASH_GT] = ACTIONS(2706),
    [sym_string_literal] = ACTIONS(3900),
    [sym_comment] = ACTIONS(49),
  },
  [1185] = {
    [sym__expression] = STATE(1762),
    [sym_conditional_expression] = STATE(1762),
    [sym_assignment_expression] = STATE(1762),
    [sym_pointer_expression] = STATE(1762),
    [sym_logical_expression] = STATE(1762),
    [sym_bitwise_expression] = STATE(1762),
    [sym_equality_expression] = STATE(1762),
    [sym_relational_expression] = STATE(1762),
    [sym_shift_expression] = STATE(1762),
    [sym_math_expression] = STATE(1762),
    [sym_cast_expression] = STATE(1762),
    [sym_sizeof_expression] = STATE(1762),
    [sym_subscript_expression] = STATE(1762),
    [sym_call_expression] = STATE(1762),
    [sym_field_expression] = STATE(1762),
    [sym_compound_literal_expression] = STATE(1762),
    [sym_parenthesized_expression] = STATE(1762),
    [sym_concatenated_string] = STATE(1762),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(1762),
    [sym_new_expression] = STATE(1762),
    [sym_delete_expression] = STATE(1762),
    [sym_lambda_expression] = STATE(1762),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(3902),
    [anon_sym_LPAREN] = ACTIONS(1267),
    [anon_sym_STAR] = ACTIONS(1275),
    [anon_sym_LBRACK] = ACTIONS(3904),
    [anon_sym_AMP] = ACTIONS(1275),
    [anon_sym_BANG] = ACTIONS(1279),
    [anon_sym_TILDE] = ACTIONS(1281),
    [anon_sym_PLUS] = ACTIONS(1283),
    [anon_sym_DASH] = ACTIONS(1283),
    [anon_sym_DASH_DASH] = ACTIONS(1285),
    [anon_sym_PLUS_PLUS] = ACTIONS(1285),
    [anon_sym_sizeof] = ACTIONS(1287),
    [sym_number_literal] = ACTIONS(3902),
    [sym_char_literal] = ACTIONS(3902),
    [sym_string_literal] = ACTIONS(1291),
    [sym_true] = ACTIONS(3906),
    [sym_false] = ACTIONS(3906),
    [sym_null] = ACTIONS(3906),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(2402),
    [anon_sym_delete] = ACTIONS(1297),
    [sym_nullptr] = ACTIONS(3906),
  },
  [1186] = {
    [sym__expression] = STATE(740),
    [sym_conditional_expression] = STATE(740),
    [sym_assignment_expression] = STATE(740),
    [sym_pointer_expression] = STATE(740),
    [sym_logical_expression] = STATE(740),
    [sym_bitwise_expression] = STATE(740),
    [sym_equality_expression] = STATE(740),
    [sym_relational_expression] = STATE(740),
    [sym_shift_expression] = STATE(740),
    [sym_math_expression] = STATE(740),
    [sym_cast_expression] = STATE(740),
    [sym_sizeof_expression] = STATE(740),
    [sym_subscript_expression] = STATE(740),
    [sym_call_expression] = STATE(740),
    [sym_field_expression] = STATE(740),
    [sym_compound_literal_expression] = STATE(740),
    [sym_parenthesized_expression] = STATE(740),
    [sym_concatenated_string] = STATE(740),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(740),
    [sym_new_expression] = STATE(740),
    [sym_delete_expression] = STATE(740),
    [sym_lambda_expression] = STATE(740),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_lambda_default_capture] = STATE(741),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(1417),
    [anon_sym_LPAREN] = ACTIONS(1419),
    [anon_sym_STAR] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_RBRACK] = ACTIONS(3908),
    [anon_sym_EQ] = ACTIONS(1425),
    [anon_sym_AMP] = ACTIONS(1427),
    [anon_sym_BANG] = ACTIONS(1429),
    [anon_sym_TILDE] = ACTIONS(1431),
    [anon_sym_PLUS] = ACTIONS(1433),
    [anon_sym_DASH] = ACTIONS(1433),
    [anon_sym_DASH_DASH] = ACTIONS(1435),
    [anon_sym_PLUS_PLUS] = ACTIONS(1435),
    [anon_sym_sizeof] = ACTIONS(1437),
    [sym_number_literal] = ACTIONS(1417),
    [sym_char_literal] = ACTIONS(1417),
    [sym_string_literal] = ACTIONS(1439),
    [sym_true] = ACTIONS(1441),
    [sym_false] = ACTIONS(1441),
    [sym_null] = ACTIONS(1441),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1443),
    [anon_sym_delete] = ACTIONS(1445),
    [sym_nullptr] = ACTIONS(1441),
  },
  [1187] = {
    [sym_argument_list] = STATE(802),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_COMMA] = ACTIONS(2740),
    [anon_sym_SEMI] = ACTIONS(2740),
    [anon_sym_RBRACE] = ACTIONS(2740),
    [anon_sym_STAR] = ACTIONS(2428),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_EQ] = ACTIONS(2742),
    [anon_sym_QMARK] = ACTIONS(2740),
    [anon_sym_STAR_EQ] = ACTIONS(2740),
    [anon_sym_SLASH_EQ] = ACTIONS(2740),
    [anon_sym_PERCENT_EQ] = ACTIONS(2740),
    [anon_sym_PLUS_EQ] = ACTIONS(2740),
    [anon_sym_DASH_EQ] = ACTIONS(2740),
    [anon_sym_LT_LT_EQ] = ACTIONS(2740),
    [anon_sym_GT_GT_EQ] = ACTIONS(2740),
    [anon_sym_AMP_EQ] = ACTIONS(2740),
    [anon_sym_CARET_EQ] = ACTIONS(2740),
    [anon_sym_PIPE_EQ] = ACTIONS(2740),
    [anon_sym_AMP] = ACTIONS(2436),
    [anon_sym_PIPE_PIPE] = ACTIONS(2438),
    [anon_sym_AMP_AMP] = ACTIONS(2440),
    [anon_sym_PIPE] = ACTIONS(2442),
    [anon_sym_CARET] = ACTIONS(2444),
    [anon_sym_EQ_EQ] = ACTIONS(2446),
    [anon_sym_BANG_EQ] = ACTIONS(2446),
    [anon_sym_LT] = ACTIONS(2448),
    [anon_sym_GT] = ACTIONS(2448),
    [anon_sym_LT_EQ] = ACTIONS(2450),
    [anon_sym_GT_EQ] = ACTIONS(2450),
    [anon_sym_LT_LT] = ACTIONS(2452),
    [anon_sym_GT_GT] = ACTIONS(2452),
    [anon_sym_PLUS] = ACTIONS(2454),
    [anon_sym_DASH] = ACTIONS(2454),
    [anon_sym_SLASH] = ACTIONS(2428),
    [anon_sym_PERCENT] = ACTIONS(2428),
    [anon_sym_DASH_DASH] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(1554),
    [anon_sym_DASH_GT] = ACTIONS(1554),
    [sym_comment] = ACTIONS(49),
  },
  [1188] = {
    [sym__expression] = STATE(1765),
    [sym_comma_expression] = STATE(1520),
    [sym_conditional_expression] = STATE(1765),
    [sym_assignment_expression] = STATE(1765),
    [sym_pointer_expression] = STATE(1765),
    [sym_logical_expression] = STATE(1765),
    [sym_bitwise_expression] = STATE(1765),
    [sym_equality_expression] = STATE(1765),
    [sym_relational_expression] = STATE(1765),
    [sym_shift_expression] = STATE(1765),
    [sym_math_expression] = STATE(1765),
    [sym_cast_expression] = STATE(1765),
    [sym_sizeof_expression] = STATE(1765),
    [sym_subscript_expression] = STATE(1765),
    [sym_call_expression] = STATE(1765),
    [sym_field_expression] = STATE(1765),
    [sym_compound_literal_expression] = STATE(1765),
    [sym_parenthesized_expression] = STATE(1765),
    [sym_initializer_list] = STATE(1766),
    [sym_initializer_pair] = STATE(1766),
    [sym_subscript_designator] = STATE(671),
    [sym_field_designator] = STATE(671),
    [sym_concatenated_string] = STATE(1765),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(1765),
    [sym_new_expression] = STATE(1765),
    [sym_delete_expression] = STATE(1765),
    [sym_lambda_expression] = STATE(1765),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [aux_sym_initializer_pair_repeat1] = STATE(671),
    [sym_raw_string_literal] = ACTIONS(3910),
    [anon_sym_LPAREN] = ACTIONS(1267),
    [anon_sym_LBRACE] = ACTIONS(548),
    [anon_sym_RBRACE] = ACTIONS(3912),
    [anon_sym_STAR] = ACTIONS(1275),
    [anon_sym_LBRACK] = ACTIONS(1277),
    [anon_sym_AMP] = ACTIONS(1275),
    [anon_sym_BANG] = ACTIONS(1279),
    [anon_sym_TILDE] = ACTIONS(1281),
    [anon_sym_PLUS] = ACTIONS(1283),
    [anon_sym_DASH] = ACTIONS(1283),
    [anon_sym_DASH_DASH] = ACTIONS(1285),
    [anon_sym_PLUS_PLUS] = ACTIONS(1285),
    [anon_sym_sizeof] = ACTIONS(1287),
    [anon_sym_DOT] = ACTIONS(1289),
    [sym_number_literal] = ACTIONS(3910),
    [sym_char_literal] = ACTIONS(3910),
    [sym_string_literal] = ACTIONS(1291),
    [sym_true] = ACTIONS(3914),
    [sym_false] = ACTIONS(3914),
    [sym_null] = ACTIONS(3914),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(2402),
    [anon_sym_delete] = ACTIONS(1297),
    [sym_nullptr] = ACTIONS(3914),
  },
  [1189] = {
    [sym__expression] = STATE(1328),
    [sym_conditional_expression] = STATE(1328),
    [sym_assignment_expression] = STATE(1328),
    [sym_pointer_expression] = STATE(1328),
    [sym_logical_expression] = STATE(1328),
    [sym_bitwise_expression] = STATE(1328),
    [sym_equality_expression] = STATE(1328),
    [sym_relational_expression] = STATE(1328),
    [sym_shift_expression] = STATE(1328),
    [sym_math_expression] = STATE(1328),
    [sym_cast_expression] = STATE(1328),
    [sym_sizeof_expression] = STATE(1328),
    [sym_subscript_expression] = STATE(1328),
    [sym_call_expression] = STATE(1328),
    [sym_field_expression] = STATE(1328),
    [sym_compound_literal_expression] = STATE(1328),
    [sym_parenthesized_expression] = STATE(1328),
    [sym_concatenated_string] = STATE(1328),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(1328),
    [sym_new_expression] = STATE(1328),
    [sym_delete_expression] = STATE(1328),
    [sym_lambda_expression] = STATE(1328),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(2748),
    [anon_sym_LPAREN] = ACTIONS(1267),
    [anon_sym_STAR] = ACTIONS(1275),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_AMP] = ACTIONS(1275),
    [anon_sym_BANG] = ACTIONS(1279),
    [anon_sym_TILDE] = ACTIONS(1281),
    [anon_sym_PLUS] = ACTIONS(1283),
    [anon_sym_DASH] = ACTIONS(1283),
    [anon_sym_DASH_DASH] = ACTIONS(1285),
    [anon_sym_PLUS_PLUS] = ACTIONS(1285),
    [anon_sym_sizeof] = ACTIONS(1287),
    [sym_number_literal] = ACTIONS(2748),
    [sym_char_literal] = ACTIONS(2748),
    [sym_string_literal] = ACTIONS(1291),
    [sym_true] = ACTIONS(2750),
    [sym_false] = ACTIONS(2750),
    [sym_null] = ACTIONS(2750),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(2402),
    [anon_sym_delete] = ACTIONS(1297),
    [sym_nullptr] = ACTIONS(2750),
  },
  [1190] = {
    [sym__expression] = STATE(1767),
    [sym_conditional_expression] = STATE(1767),
    [sym_assignment_expression] = STATE(1767),
    [sym_pointer_expression] = STATE(1767),
    [sym_logical_expression] = STATE(1767),
    [sym_bitwise_expression] = STATE(1767),
    [sym_equality_expression] = STATE(1767),
    [sym_relational_expression] = STATE(1767),
    [sym_shift_expression] = STATE(1767),
    [sym_math_expression] = STATE(1767),
    [sym_cast_expression] = STATE(1767),
    [sym_sizeof_expression] = STATE(1767),
    [sym_subscript_expression] = STATE(1767),
    [sym_call_expression] = STATE(1767),
    [sym_field_expression] = STATE(1767),
    [sym_compound_literal_expression] = STATE(1767),
    [sym_parenthesized_expression] = STATE(1767),
    [sym_concatenated_string] = STATE(1767),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(1767),
    [sym_new_expression] = STATE(1767),
    [sym_delete_expression] = STATE(1767),
    [sym_lambda_expression] = STATE(1767),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(3916),
    [anon_sym_LPAREN] = ACTIONS(1267),
    [anon_sym_STAR] = ACTIONS(1275),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_AMP] = ACTIONS(1275),
    [anon_sym_BANG] = ACTIONS(1279),
    [anon_sym_TILDE] = ACTIONS(1281),
    [anon_sym_PLUS] = ACTIONS(1283),
    [anon_sym_DASH] = ACTIONS(1283),
    [anon_sym_DASH_DASH] = ACTIONS(1285),
    [anon_sym_PLUS_PLUS] = ACTIONS(1285),
    [anon_sym_sizeof] = ACTIONS(1287),
    [sym_number_literal] = ACTIONS(3916),
    [sym_char_literal] = ACTIONS(3916),
    [sym_string_literal] = ACTIONS(1291),
    [sym_true] = ACTIONS(3918),
    [sym_false] = ACTIONS(3918),
    [sym_null] = ACTIONS(3918),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(2402),
    [anon_sym_delete] = ACTIONS(1297),
    [sym_nullptr] = ACTIONS(3918),
  },
  [1191] = {
    [sym__expression] = STATE(1768),
    [sym_conditional_expression] = STATE(1768),
    [sym_assignment_expression] = STATE(1768),
    [sym_pointer_expression] = STATE(1768),
    [sym_logical_expression] = STATE(1768),
    [sym_bitwise_expression] = STATE(1768),
    [sym_equality_expression] = STATE(1768),
    [sym_relational_expression] = STATE(1768),
    [sym_shift_expression] = STATE(1768),
    [sym_math_expression] = STATE(1768),
    [sym_cast_expression] = STATE(1768),
    [sym_sizeof_expression] = STATE(1768),
    [sym_subscript_expression] = STATE(1768),
    [sym_call_expression] = STATE(1768),
    [sym_field_expression] = STATE(1768),
    [sym_compound_literal_expression] = STATE(1768),
    [sym_parenthesized_expression] = STATE(1768),
    [sym_concatenated_string] = STATE(1768),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(1768),
    [sym_new_expression] = STATE(1768),
    [sym_delete_expression] = STATE(1768),
    [sym_lambda_expression] = STATE(1768),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(855),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(3920),
    [anon_sym_LPAREN] = ACTIONS(1634),
    [anon_sym_STAR] = ACTIONS(1636),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_AMP] = ACTIONS(1636),
    [anon_sym_BANG] = ACTIONS(1638),
    [anon_sym_TILDE] = ACTIONS(1640),
    [anon_sym_PLUS] = ACTIONS(1642),
    [anon_sym_DASH] = ACTIONS(1642),
    [anon_sym_DASH_DASH] = ACTIONS(1644),
    [anon_sym_PLUS_PLUS] = ACTIONS(1644),
    [anon_sym_sizeof] = ACTIONS(1646),
    [sym_number_literal] = ACTIONS(3920),
    [sym_char_literal] = ACTIONS(3920),
    [sym_string_literal] = ACTIONS(1648),
    [sym_true] = ACTIONS(3922),
    [sym_false] = ACTIONS(3922),
    [sym_null] = ACTIONS(3922),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1652),
    [anon_sym_delete] = ACTIONS(1654),
    [sym_nullptr] = ACTIONS(3922),
  },
  [1192] = {
    [sym__expression] = STATE(1769),
    [sym_conditional_expression] = STATE(1769),
    [sym_assignment_expression] = STATE(1769),
    [sym_pointer_expression] = STATE(1769),
    [sym_logical_expression] = STATE(1769),
    [sym_bitwise_expression] = STATE(1769),
    [sym_equality_expression] = STATE(1769),
    [sym_relational_expression] = STATE(1769),
    [sym_shift_expression] = STATE(1769),
    [sym_math_expression] = STATE(1769),
    [sym_cast_expression] = STATE(1769),
    [sym_sizeof_expression] = STATE(1769),
    [sym_subscript_expression] = STATE(1769),
    [sym_call_expression] = STATE(1769),
    [sym_field_expression] = STATE(1769),
    [sym_compound_literal_expression] = STATE(1769),
    [sym_parenthesized_expression] = STATE(1769),
    [sym_concatenated_string] = STATE(1769),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(1769),
    [sym_new_expression] = STATE(1769),
    [sym_delete_expression] = STATE(1769),
    [sym_lambda_expression] = STATE(1769),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(3924),
    [anon_sym_LPAREN] = ACTIONS(1267),
    [anon_sym_STAR] = ACTIONS(1275),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_AMP] = ACTIONS(1275),
    [anon_sym_BANG] = ACTIONS(1279),
    [anon_sym_TILDE] = ACTIONS(1281),
    [anon_sym_PLUS] = ACTIONS(1283),
    [anon_sym_DASH] = ACTIONS(1283),
    [anon_sym_DASH_DASH] = ACTIONS(1285),
    [anon_sym_PLUS_PLUS] = ACTIONS(1285),
    [anon_sym_sizeof] = ACTIONS(1287),
    [sym_number_literal] = ACTIONS(3924),
    [sym_char_literal] = ACTIONS(3924),
    [sym_string_literal] = ACTIONS(1291),
    [sym_true] = ACTIONS(3926),
    [sym_false] = ACTIONS(3926),
    [sym_null] = ACTIONS(3926),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(2402),
    [anon_sym_delete] = ACTIONS(1297),
    [sym_nullptr] = ACTIONS(3926),
  },
  [1193] = {
    [sym__expression] = STATE(1770),
    [sym_conditional_expression] = STATE(1770),
    [sym_assignment_expression] = STATE(1770),
    [sym_pointer_expression] = STATE(1770),
    [sym_logical_expression] = STATE(1770),
    [sym_bitwise_expression] = STATE(1770),
    [sym_equality_expression] = STATE(1770),
    [sym_relational_expression] = STATE(1770),
    [sym_shift_expression] = STATE(1770),
    [sym_math_expression] = STATE(1770),
    [sym_cast_expression] = STATE(1770),
    [sym_sizeof_expression] = STATE(1770),
    [sym_subscript_expression] = STATE(1770),
    [sym_call_expression] = STATE(1770),
    [sym_field_expression] = STATE(1770),
    [sym_compound_literal_expression] = STATE(1770),
    [sym_parenthesized_expression] = STATE(1770),
    [sym_concatenated_string] = STATE(1770),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(1770),
    [sym_new_expression] = STATE(1770),
    [sym_delete_expression] = STATE(1770),
    [sym_lambda_expression] = STATE(1770),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(3928),
    [anon_sym_LPAREN] = ACTIONS(1267),
    [anon_sym_STAR] = ACTIONS(1275),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_AMP] = ACTIONS(1275),
    [anon_sym_BANG] = ACTIONS(1279),
    [anon_sym_TILDE] = ACTIONS(1281),
    [anon_sym_PLUS] = ACTIONS(1283),
    [anon_sym_DASH] = ACTIONS(1283),
    [anon_sym_DASH_DASH] = ACTIONS(1285),
    [anon_sym_PLUS_PLUS] = ACTIONS(1285),
    [anon_sym_sizeof] = ACTIONS(1287),
    [sym_number_literal] = ACTIONS(3928),
    [sym_char_literal] = ACTIONS(3928),
    [sym_string_literal] = ACTIONS(1291),
    [sym_true] = ACTIONS(3930),
    [sym_false] = ACTIONS(3930),
    [sym_null] = ACTIONS(3930),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(2402),
    [anon_sym_delete] = ACTIONS(1297),
    [sym_nullptr] = ACTIONS(3930),
  },
  [1194] = {
    [sym__expression] = STATE(1771),
    [sym_conditional_expression] = STATE(1771),
    [sym_assignment_expression] = STATE(1771),
    [sym_pointer_expression] = STATE(1771),
    [sym_logical_expression] = STATE(1771),
    [sym_bitwise_expression] = STATE(1771),
    [sym_equality_expression] = STATE(1771),
    [sym_relational_expression] = STATE(1771),
    [sym_shift_expression] = STATE(1771),
    [sym_math_expression] = STATE(1771),
    [sym_cast_expression] = STATE(1771),
    [sym_sizeof_expression] = STATE(1771),
    [sym_subscript_expression] = STATE(1771),
    [sym_call_expression] = STATE(1771),
    [sym_field_expression] = STATE(1771),
    [sym_compound_literal_expression] = STATE(1771),
    [sym_parenthesized_expression] = STATE(1771),
    [sym_concatenated_string] = STATE(1771),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(1771),
    [sym_new_expression] = STATE(1771),
    [sym_delete_expression] = STATE(1771),
    [sym_lambda_expression] = STATE(1771),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(3932),
    [anon_sym_LPAREN] = ACTIONS(1267),
    [anon_sym_STAR] = ACTIONS(1275),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_AMP] = ACTIONS(1275),
    [anon_sym_BANG] = ACTIONS(1279),
    [anon_sym_TILDE] = ACTIONS(1281),
    [anon_sym_PLUS] = ACTIONS(1283),
    [anon_sym_DASH] = ACTIONS(1283),
    [anon_sym_DASH_DASH] = ACTIONS(1285),
    [anon_sym_PLUS_PLUS] = ACTIONS(1285),
    [anon_sym_sizeof] = ACTIONS(1287),
    [sym_number_literal] = ACTIONS(3932),
    [sym_char_literal] = ACTIONS(3932),
    [sym_string_literal] = ACTIONS(1291),
    [sym_true] = ACTIONS(3934),
    [sym_false] = ACTIONS(3934),
    [sym_null] = ACTIONS(3934),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(2402),
    [anon_sym_delete] = ACTIONS(1297),
    [sym_nullptr] = ACTIONS(3934),
  },
  [1195] = {
    [sym__expression] = STATE(1772),
    [sym_conditional_expression] = STATE(1772),
    [sym_assignment_expression] = STATE(1772),
    [sym_pointer_expression] = STATE(1772),
    [sym_logical_expression] = STATE(1772),
    [sym_bitwise_expression] = STATE(1772),
    [sym_equality_expression] = STATE(1772),
    [sym_relational_expression] = STATE(1772),
    [sym_shift_expression] = STATE(1772),
    [sym_math_expression] = STATE(1772),
    [sym_cast_expression] = STATE(1772),
    [sym_sizeof_expression] = STATE(1772),
    [sym_subscript_expression] = STATE(1772),
    [sym_call_expression] = STATE(1772),
    [sym_field_expression] = STATE(1772),
    [sym_compound_literal_expression] = STATE(1772),
    [sym_parenthesized_expression] = STATE(1772),
    [sym_concatenated_string] = STATE(1772),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(1772),
    [sym_new_expression] = STATE(1772),
    [sym_delete_expression] = STATE(1772),
    [sym_lambda_expression] = STATE(1772),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(3936),
    [anon_sym_LPAREN] = ACTIONS(1267),
    [anon_sym_STAR] = ACTIONS(1275),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_AMP] = ACTIONS(1275),
    [anon_sym_BANG] = ACTIONS(1279),
    [anon_sym_TILDE] = ACTIONS(1281),
    [anon_sym_PLUS] = ACTIONS(1283),
    [anon_sym_DASH] = ACTIONS(1283),
    [anon_sym_DASH_DASH] = ACTIONS(1285),
    [anon_sym_PLUS_PLUS] = ACTIONS(1285),
    [anon_sym_sizeof] = ACTIONS(1287),
    [sym_number_literal] = ACTIONS(3936),
    [sym_char_literal] = ACTIONS(3936),
    [sym_string_literal] = ACTIONS(1291),
    [sym_true] = ACTIONS(3938),
    [sym_false] = ACTIONS(3938),
    [sym_null] = ACTIONS(3938),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(2402),
    [anon_sym_delete] = ACTIONS(1297),
    [sym_nullptr] = ACTIONS(3938),
  },
  [1196] = {
    [sym__expression] = STATE(1773),
    [sym_conditional_expression] = STATE(1773),
    [sym_assignment_expression] = STATE(1773),
    [sym_pointer_expression] = STATE(1773),
    [sym_logical_expression] = STATE(1773),
    [sym_bitwise_expression] = STATE(1773),
    [sym_equality_expression] = STATE(1773),
    [sym_relational_expression] = STATE(1773),
    [sym_shift_expression] = STATE(1773),
    [sym_math_expression] = STATE(1773),
    [sym_cast_expression] = STATE(1773),
    [sym_sizeof_expression] = STATE(1773),
    [sym_subscript_expression] = STATE(1773),
    [sym_call_expression] = STATE(1773),
    [sym_field_expression] = STATE(1773),
    [sym_compound_literal_expression] = STATE(1773),
    [sym_parenthesized_expression] = STATE(1773),
    [sym_concatenated_string] = STATE(1773),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(1773),
    [sym_new_expression] = STATE(1773),
    [sym_delete_expression] = STATE(1773),
    [sym_lambda_expression] = STATE(1773),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(3940),
    [anon_sym_LPAREN] = ACTIONS(1267),
    [anon_sym_STAR] = ACTIONS(1275),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_AMP] = ACTIONS(1275),
    [anon_sym_BANG] = ACTIONS(1279),
    [anon_sym_TILDE] = ACTIONS(1281),
    [anon_sym_PLUS] = ACTIONS(1283),
    [anon_sym_DASH] = ACTIONS(1283),
    [anon_sym_DASH_DASH] = ACTIONS(1285),
    [anon_sym_PLUS_PLUS] = ACTIONS(1285),
    [anon_sym_sizeof] = ACTIONS(1287),
    [sym_number_literal] = ACTIONS(3940),
    [sym_char_literal] = ACTIONS(3940),
    [sym_string_literal] = ACTIONS(1291),
    [sym_true] = ACTIONS(3942),
    [sym_false] = ACTIONS(3942),
    [sym_null] = ACTIONS(3942),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(2402),
    [anon_sym_delete] = ACTIONS(1297),
    [sym_nullptr] = ACTIONS(3942),
  },
  [1197] = {
    [sym__expression] = STATE(1774),
    [sym_conditional_expression] = STATE(1774),
    [sym_assignment_expression] = STATE(1774),
    [sym_pointer_expression] = STATE(1774),
    [sym_logical_expression] = STATE(1774),
    [sym_bitwise_expression] = STATE(1774),
    [sym_equality_expression] = STATE(1774),
    [sym_relational_expression] = STATE(1774),
    [sym_shift_expression] = STATE(1774),
    [sym_math_expression] = STATE(1774),
    [sym_cast_expression] = STATE(1774),
    [sym_sizeof_expression] = STATE(1774),
    [sym_subscript_expression] = STATE(1774),
    [sym_call_expression] = STATE(1774),
    [sym_field_expression] = STATE(1774),
    [sym_compound_literal_expression] = STATE(1774),
    [sym_parenthesized_expression] = STATE(1774),
    [sym_concatenated_string] = STATE(1774),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(1774),
    [sym_new_expression] = STATE(1774),
    [sym_delete_expression] = STATE(1774),
    [sym_lambda_expression] = STATE(1774),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(3944),
    [anon_sym_LPAREN] = ACTIONS(1267),
    [anon_sym_STAR] = ACTIONS(1275),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_AMP] = ACTIONS(1275),
    [anon_sym_BANG] = ACTIONS(1279),
    [anon_sym_TILDE] = ACTIONS(1281),
    [anon_sym_PLUS] = ACTIONS(1283),
    [anon_sym_DASH] = ACTIONS(1283),
    [anon_sym_DASH_DASH] = ACTIONS(1285),
    [anon_sym_PLUS_PLUS] = ACTIONS(1285),
    [anon_sym_sizeof] = ACTIONS(1287),
    [sym_number_literal] = ACTIONS(3944),
    [sym_char_literal] = ACTIONS(3944),
    [sym_string_literal] = ACTIONS(1291),
    [sym_true] = ACTIONS(3946),
    [sym_false] = ACTIONS(3946),
    [sym_null] = ACTIONS(3946),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(2402),
    [anon_sym_delete] = ACTIONS(1297),
    [sym_nullptr] = ACTIONS(3946),
  },
  [1198] = {
    [sym__expression] = STATE(1775),
    [sym_conditional_expression] = STATE(1775),
    [sym_assignment_expression] = STATE(1775),
    [sym_pointer_expression] = STATE(1775),
    [sym_logical_expression] = STATE(1775),
    [sym_bitwise_expression] = STATE(1775),
    [sym_equality_expression] = STATE(1775),
    [sym_relational_expression] = STATE(1775),
    [sym_shift_expression] = STATE(1775),
    [sym_math_expression] = STATE(1775),
    [sym_cast_expression] = STATE(1775),
    [sym_sizeof_expression] = STATE(1775),
    [sym_subscript_expression] = STATE(1775),
    [sym_call_expression] = STATE(1775),
    [sym_field_expression] = STATE(1775),
    [sym_compound_literal_expression] = STATE(1775),
    [sym_parenthesized_expression] = STATE(1775),
    [sym_concatenated_string] = STATE(1775),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(1775),
    [sym_new_expression] = STATE(1775),
    [sym_delete_expression] = STATE(1775),
    [sym_lambda_expression] = STATE(1775),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(3948),
    [anon_sym_LPAREN] = ACTIONS(1267),
    [anon_sym_STAR] = ACTIONS(1275),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_AMP] = ACTIONS(1275),
    [anon_sym_BANG] = ACTIONS(1279),
    [anon_sym_TILDE] = ACTIONS(1281),
    [anon_sym_PLUS] = ACTIONS(1283),
    [anon_sym_DASH] = ACTIONS(1283),
    [anon_sym_DASH_DASH] = ACTIONS(1285),
    [anon_sym_PLUS_PLUS] = ACTIONS(1285),
    [anon_sym_sizeof] = ACTIONS(1287),
    [sym_number_literal] = ACTIONS(3948),
    [sym_char_literal] = ACTIONS(3948),
    [sym_string_literal] = ACTIONS(1291),
    [sym_true] = ACTIONS(3950),
    [sym_false] = ACTIONS(3950),
    [sym_null] = ACTIONS(3950),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(2402),
    [anon_sym_delete] = ACTIONS(1297),
    [sym_nullptr] = ACTIONS(3950),
  },
  [1199] = {
    [sym__expression] = STATE(1776),
    [sym_conditional_expression] = STATE(1776),
    [sym_assignment_expression] = STATE(1776),
    [sym_pointer_expression] = STATE(1776),
    [sym_logical_expression] = STATE(1776),
    [sym_bitwise_expression] = STATE(1776),
    [sym_equality_expression] = STATE(1776),
    [sym_relational_expression] = STATE(1776),
    [sym_shift_expression] = STATE(1776),
    [sym_math_expression] = STATE(1776),
    [sym_cast_expression] = STATE(1776),
    [sym_sizeof_expression] = STATE(1776),
    [sym_subscript_expression] = STATE(1776),
    [sym_call_expression] = STATE(1776),
    [sym_field_expression] = STATE(1776),
    [sym_compound_literal_expression] = STATE(1776),
    [sym_parenthesized_expression] = STATE(1776),
    [sym_concatenated_string] = STATE(1776),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(1776),
    [sym_new_expression] = STATE(1776),
    [sym_delete_expression] = STATE(1776),
    [sym_lambda_expression] = STATE(1776),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(3952),
    [anon_sym_LPAREN] = ACTIONS(1267),
    [anon_sym_STAR] = ACTIONS(1275),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_AMP] = ACTIONS(1275),
    [anon_sym_BANG] = ACTIONS(1279),
    [anon_sym_TILDE] = ACTIONS(1281),
    [anon_sym_PLUS] = ACTIONS(1283),
    [anon_sym_DASH] = ACTIONS(1283),
    [anon_sym_DASH_DASH] = ACTIONS(1285),
    [anon_sym_PLUS_PLUS] = ACTIONS(1285),
    [anon_sym_sizeof] = ACTIONS(1287),
    [sym_number_literal] = ACTIONS(3952),
    [sym_char_literal] = ACTIONS(3952),
    [sym_string_literal] = ACTIONS(1291),
    [sym_true] = ACTIONS(3954),
    [sym_false] = ACTIONS(3954),
    [sym_null] = ACTIONS(3954),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(2402),
    [anon_sym_delete] = ACTIONS(1297),
    [sym_nullptr] = ACTIONS(3954),
  },
  [1200] = {
    [sym__expression] = STATE(1777),
    [sym_conditional_expression] = STATE(1777),
    [sym_assignment_expression] = STATE(1777),
    [sym_pointer_expression] = STATE(1777),
    [sym_logical_expression] = STATE(1777),
    [sym_bitwise_expression] = STATE(1777),
    [sym_equality_expression] = STATE(1777),
    [sym_relational_expression] = STATE(1777),
    [sym_shift_expression] = STATE(1777),
    [sym_math_expression] = STATE(1777),
    [sym_cast_expression] = STATE(1777),
    [sym_sizeof_expression] = STATE(1777),
    [sym_subscript_expression] = STATE(1777),
    [sym_call_expression] = STATE(1777),
    [sym_field_expression] = STATE(1777),
    [sym_compound_literal_expression] = STATE(1777),
    [sym_parenthesized_expression] = STATE(1777),
    [sym_concatenated_string] = STATE(1777),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(1777),
    [sym_new_expression] = STATE(1777),
    [sym_delete_expression] = STATE(1777),
    [sym_lambda_expression] = STATE(1777),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(3956),
    [anon_sym_LPAREN] = ACTIONS(1267),
    [anon_sym_STAR] = ACTIONS(1275),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_AMP] = ACTIONS(1275),
    [anon_sym_BANG] = ACTIONS(1279),
    [anon_sym_TILDE] = ACTIONS(1281),
    [anon_sym_PLUS] = ACTIONS(1283),
    [anon_sym_DASH] = ACTIONS(1283),
    [anon_sym_DASH_DASH] = ACTIONS(1285),
    [anon_sym_PLUS_PLUS] = ACTIONS(1285),
    [anon_sym_sizeof] = ACTIONS(1287),
    [sym_number_literal] = ACTIONS(3956),
    [sym_char_literal] = ACTIONS(3956),
    [sym_string_literal] = ACTIONS(1291),
    [sym_true] = ACTIONS(3958),
    [sym_false] = ACTIONS(3958),
    [sym_null] = ACTIONS(3958),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(2402),
    [anon_sym_delete] = ACTIONS(1297),
    [sym_nullptr] = ACTIONS(3958),
  },
  [1201] = {
    [aux_sym_initializer_list_repeat1] = STATE(1779),
    [anon_sym_COMMA] = ACTIONS(3960),
    [anon_sym_RBRACE] = ACTIONS(3912),
    [sym_comment] = ACTIONS(49),
  },
  [1202] = {
    [sym__expression] = STATE(1780),
    [sym_conditional_expression] = STATE(1780),
    [sym_assignment_expression] = STATE(1780),
    [sym_pointer_expression] = STATE(1780),
    [sym_logical_expression] = STATE(1780),
    [sym_bitwise_expression] = STATE(1780),
    [sym_equality_expression] = STATE(1780),
    [sym_relational_expression] = STATE(1780),
    [sym_shift_expression] = STATE(1780),
    [sym_math_expression] = STATE(1780),
    [sym_cast_expression] = STATE(1780),
    [sym_sizeof_expression] = STATE(1780),
    [sym_subscript_expression] = STATE(1780),
    [sym_call_expression] = STATE(1780),
    [sym_field_expression] = STATE(1780),
    [sym_compound_literal_expression] = STATE(1780),
    [sym_parenthesized_expression] = STATE(1780),
    [sym_initializer_list] = STATE(1766),
    [sym_initializer_pair] = STATE(1766),
    [sym_subscript_designator] = STATE(671),
    [sym_field_designator] = STATE(671),
    [sym_concatenated_string] = STATE(1780),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(1780),
    [sym_new_expression] = STATE(1780),
    [sym_delete_expression] = STATE(1780),
    [sym_lambda_expression] = STATE(1780),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [aux_sym_initializer_pair_repeat1] = STATE(671),
    [sym_raw_string_literal] = ACTIONS(3962),
    [anon_sym_LPAREN] = ACTIONS(1321),
    [anon_sym_LBRACE] = ACTIONS(548),
    [anon_sym_RBRACE] = ACTIONS(3912),
    [anon_sym_STAR] = ACTIONS(1325),
    [anon_sym_LBRACK] = ACTIONS(1277),
    [anon_sym_AMP] = ACTIONS(1325),
    [anon_sym_BANG] = ACTIONS(1327),
    [anon_sym_TILDE] = ACTIONS(1329),
    [anon_sym_PLUS] = ACTIONS(1331),
    [anon_sym_DASH] = ACTIONS(1331),
    [anon_sym_DASH_DASH] = ACTIONS(1333),
    [anon_sym_PLUS_PLUS] = ACTIONS(1333),
    [anon_sym_sizeof] = ACTIONS(1335),
    [anon_sym_DOT] = ACTIONS(1289),
    [sym_number_literal] = ACTIONS(3962),
    [sym_char_literal] = ACTIONS(3962),
    [sym_string_literal] = ACTIONS(1337),
    [sym_true] = ACTIONS(3964),
    [sym_false] = ACTIONS(3964),
    [sym_null] = ACTIONS(3964),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1341),
    [anon_sym_delete] = ACTIONS(1343),
    [sym_nullptr] = ACTIONS(3964),
  },
  [1203] = {
    [sym__expression] = STATE(1781),
    [sym_conditional_expression] = STATE(1781),
    [sym_assignment_expression] = STATE(1781),
    [sym_pointer_expression] = STATE(1781),
    [sym_logical_expression] = STATE(1781),
    [sym_bitwise_expression] = STATE(1781),
    [sym_equality_expression] = STATE(1781),
    [sym_relational_expression] = STATE(1781),
    [sym_shift_expression] = STATE(1781),
    [sym_math_expression] = STATE(1781),
    [sym_cast_expression] = STATE(1781),
    [sym_sizeof_expression] = STATE(1781),
    [sym_subscript_expression] = STATE(1781),
    [sym_call_expression] = STATE(1781),
    [sym_field_expression] = STATE(1781),
    [sym_compound_literal_expression] = STATE(1781),
    [sym_parenthesized_expression] = STATE(1781),
    [sym_concatenated_string] = STATE(1781),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(1781),
    [sym_new_expression] = STATE(1781),
    [sym_delete_expression] = STATE(1781),
    [sym_lambda_expression] = STATE(1781),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(3966),
    [anon_sym_LPAREN] = ACTIONS(566),
    [anon_sym_STAR] = ACTIONS(568),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_AMP] = ACTIONS(568),
    [anon_sym_BANG] = ACTIONS(584),
    [anon_sym_TILDE] = ACTIONS(586),
    [anon_sym_PLUS] = ACTIONS(588),
    [anon_sym_DASH] = ACTIONS(588),
    [anon_sym_DASH_DASH] = ACTIONS(590),
    [anon_sym_PLUS_PLUS] = ACTIONS(590),
    [anon_sym_sizeof] = ACTIONS(592),
    [sym_number_literal] = ACTIONS(3966),
    [sym_char_literal] = ACTIONS(3966),
    [sym_string_literal] = ACTIONS(594),
    [sym_true] = ACTIONS(3968),
    [sym_false] = ACTIONS(3968),
    [sym_null] = ACTIONS(3968),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1415),
    [anon_sym_delete] = ACTIONS(608),
    [sym_nullptr] = ACTIONS(3968),
  },
  [1204] = {
    [sym__expression] = STATE(1782),
    [sym_conditional_expression] = STATE(1782),
    [sym_assignment_expression] = STATE(1782),
    [sym_pointer_expression] = STATE(1782),
    [sym_logical_expression] = STATE(1782),
    [sym_bitwise_expression] = STATE(1782),
    [sym_equality_expression] = STATE(1782),
    [sym_relational_expression] = STATE(1782),
    [sym_shift_expression] = STATE(1782),
    [sym_math_expression] = STATE(1782),
    [sym_cast_expression] = STATE(1782),
    [sym_sizeof_expression] = STATE(1782),
    [sym_subscript_expression] = STATE(1782),
    [sym_call_expression] = STATE(1782),
    [sym_field_expression] = STATE(1782),
    [sym_compound_literal_expression] = STATE(1782),
    [sym_parenthesized_expression] = STATE(1782),
    [sym_initializer_list] = STATE(1783),
    [sym_concatenated_string] = STATE(1782),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(1782),
    [sym_new_expression] = STATE(1782),
    [sym_delete_expression] = STATE(1782),
    [sym_lambda_expression] = STATE(1782),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(3970),
    [anon_sym_LPAREN] = ACTIONS(1321),
    [anon_sym_LBRACE] = ACTIONS(548),
    [anon_sym_STAR] = ACTIONS(1325),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_AMP] = ACTIONS(1325),
    [anon_sym_BANG] = ACTIONS(1327),
    [anon_sym_TILDE] = ACTIONS(1329),
    [anon_sym_PLUS] = ACTIONS(1331),
    [anon_sym_DASH] = ACTIONS(1331),
    [anon_sym_DASH_DASH] = ACTIONS(1333),
    [anon_sym_PLUS_PLUS] = ACTIONS(1333),
    [anon_sym_sizeof] = ACTIONS(1335),
    [sym_number_literal] = ACTIONS(3970),
    [sym_char_literal] = ACTIONS(3970),
    [sym_string_literal] = ACTIONS(1337),
    [sym_true] = ACTIONS(3972),
    [sym_false] = ACTIONS(3972),
    [sym_null] = ACTIONS(3972),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1341),
    [anon_sym_delete] = ACTIONS(1343),
    [sym_nullptr] = ACTIONS(3972),
  },
  [1205] = {
    [sym_subscript_designator] = STATE(1205),
    [sym_field_designator] = STATE(1205),
    [aux_sym_initializer_pair_repeat1] = STATE(1205),
    [anon_sym_LBRACK] = ACTIONS(3974),
    [anon_sym_EQ] = ACTIONS(3977),
    [anon_sym_DOT] = ACTIONS(3979),
    [sym_comment] = ACTIONS(49),
  },
  [1206] = {
    [sym_field_declaration_list] = STATE(1361),
    [sym__class_name] = STATE(1784),
    [sym_base_class_clause] = STATE(1363),
    [sym_template_type] = STATE(1364),
    [sym_scoped_type_identifier] = STATE(1365),
    [sym_scoped_namespace_identifier] = STATE(827),
    [anon_sym_LBRACE] = ACTIONS(2829),
    [anon_sym_COLON] = ACTIONS(131),
    [sym_identifier] = ACTIONS(2831),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(1594),
  },
  [1207] = {
    [sym_field_declaration_list] = STATE(1366),
    [sym__class_name] = STATE(1785),
    [sym_base_class_clause] = STATE(1368),
    [sym_template_type] = STATE(1364),
    [sym_scoped_type_identifier] = STATE(1365),
    [sym_scoped_namespace_identifier] = STATE(827),
    [anon_sym_LBRACE] = ACTIONS(2829),
    [anon_sym_COLON] = ACTIONS(131),
    [sym_identifier] = ACTIONS(2831),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(1594),
  },
  [1208] = {
    [sym_field_declaration_list] = STATE(1372),
    [sym__class_name] = STATE(1786),
    [sym_base_class_clause] = STATE(1374),
    [sym_template_type] = STATE(1364),
    [sym_scoped_type_identifier] = STATE(1365),
    [sym_scoped_namespace_identifier] = STATE(827),
    [anon_sym_LBRACE] = ACTIONS(2829),
    [anon_sym_COLON] = ACTIONS(131),
    [sym_identifier] = ACTIONS(2831),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(1594),
  },
  [1209] = {
    [sym__type_specifier] = STATE(1375),
    [sym_sized_type_specifier] = STATE(1375),
    [sym_enum_specifier] = STATE(1375),
    [sym_struct_specifier] = STATE(1375),
    [sym_union_specifier] = STATE(1375),
    [sym_macro_type_specifier] = STATE(1375),
    [sym_class_specifier] = STATE(1375),
    [sym_dependent_type] = STATE(1375),
    [sym_template_type] = STATE(825),
    [sym_scoped_type_identifier] = STATE(826),
    [sym_scoped_namespace_identifier] = STATE(827),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1211),
    [anon_sym_unsigned] = ACTIONS(2464),
    [anon_sym_long] = ACTIONS(2464),
    [anon_sym_short] = ACTIONS(2464),
    [sym_primitive_type] = ACTIONS(2837),
    [anon_sym_enum] = ACTIONS(1582),
    [anon_sym_struct] = ACTIONS(2468),
    [anon_sym_union] = ACTIONS(2470),
    [sym_identifier] = ACTIONS(1588),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(2472),
    [sym_auto] = ACTIONS(2837),
    [anon_sym_typename] = ACTIONS(2474),
    [anon_sym_COLON_COLON] = ACTIONS(1594),
  },
  [1210] = {
    [sym__abstract_declarator] = STATE(1789),
    [sym_abstract_pointer_declarator] = STATE(1789),
    [sym_abstract_function_declarator] = STATE(1789),
    [sym_abstract_array_declarator] = STATE(1789),
    [sym_parameter_list] = STATE(1790),
    [sym_abstract_reference_declarator] = STATE(1789),
    [anon_sym_LPAREN] = ACTIONS(1115),
    [anon_sym_COMMA] = ACTIONS(2841),
    [anon_sym_SEMI] = ACTIONS(2841),
    [anon_sym_LBRACE] = ACTIONS(2841),
    [anon_sym_STAR] = ACTIONS(3982),
    [anon_sym_LBRACK] = ACTIONS(1121),
    [anon_sym_EQ] = ACTIONS(2841),
    [anon_sym_const] = ACTIONS(2845),
    [anon_sym_restrict] = ACTIONS(2841),
    [anon_sym_volatile] = ACTIONS(2841),
    [anon_sym__Atomic] = ACTIONS(2841),
    [anon_sym_mutable] = ACTIONS(2841),
    [anon_sym_explicit] = ACTIONS(2841),
    [anon_sym_constexpr] = ACTIONS(2841),
    [anon_sym_AMP] = ACTIONS(3984),
    [anon_sym_AMP_AMP] = ACTIONS(3986),
    [anon_sym_DASH_GT] = ACTIONS(2841),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(2841),
  },
  [1211] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(1791),
    [anon_sym_LPAREN] = ACTIONS(238),
    [anon_sym_COMMA] = ACTIONS(238),
    [anon_sym_SEMI] = ACTIONS(238),
    [anon_sym_LBRACE] = ACTIONS(238),
    [anon_sym_STAR] = ACTIONS(238),
    [anon_sym_LBRACK] = ACTIONS(238),
    [anon_sym_EQ] = ACTIONS(238),
    [anon_sym_const] = ACTIONS(240),
    [anon_sym_restrict] = ACTIONS(240),
    [anon_sym_volatile] = ACTIONS(240),
    [anon_sym__Atomic] = ACTIONS(240),
    [anon_sym_mutable] = ACTIONS(240),
    [anon_sym_explicit] = ACTIONS(240),
    [anon_sym_constexpr] = ACTIONS(240),
    [anon_sym_unsigned] = ACTIONS(3988),
    [anon_sym_long] = ACTIONS(3988),
    [anon_sym_short] = ACTIONS(3988),
    [sym_primitive_type] = ACTIONS(2855),
    [anon_sym_AMP] = ACTIONS(240),
    [anon_sym_AMP_AMP] = ACTIONS(238),
    [anon_sym_DASH_GT] = ACTIONS(238),
    [sym_identifier] = ACTIONS(2857),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(240),
  },
  [1212] = {
    [sym_type_qualifier] = STATE(1212),
    [sym_trailing_return_type] = STATE(1212),
    [aux_sym_function_declarator_repeat1] = STATE(1212),
    [anon_sym_LPAREN] = ACTIONS(2859),
    [anon_sym_COMMA] = ACTIONS(2859),
    [anon_sym_SEMI] = ACTIONS(2859),
    [anon_sym_LBRACE] = ACTIONS(2859),
    [anon_sym_LBRACK] = ACTIONS(2859),
    [anon_sym_EQ] = ACTIONS(2859),
    [anon_sym_const] = ACTIONS(2861),
    [anon_sym_restrict] = ACTIONS(2864),
    [anon_sym_volatile] = ACTIONS(2864),
    [anon_sym__Atomic] = ACTIONS(2864),
    [anon_sym_mutable] = ACTIONS(2864),
    [anon_sym_explicit] = ACTIONS(2864),
    [anon_sym_constexpr] = ACTIONS(2864),
    [anon_sym_DASH_GT] = ACTIONS(3990),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(3993),
  },
  [1213] = {
    [anon_sym_RPAREN] = ACTIONS(3996),
    [sym_comment] = ACTIONS(49),
  },
  [1214] = {
    [sym_type_qualifier] = STATE(724),
    [sym__type_specifier] = STATE(720),
    [sym_sized_type_specifier] = STATE(720),
    [sym_enum_specifier] = STATE(720),
    [sym_struct_specifier] = STATE(720),
    [sym_union_specifier] = STATE(720),
    [sym__expression] = STATE(721),
    [sym_comma_expression] = STATE(722),
    [sym_conditional_expression] = STATE(721),
    [sym_assignment_expression] = STATE(721),
    [sym_pointer_expression] = STATE(721),
    [sym_logical_expression] = STATE(721),
    [sym_bitwise_expression] = STATE(721),
    [sym_equality_expression] = STATE(721),
    [sym_relational_expression] = STATE(721),
    [sym_shift_expression] = STATE(721),
    [sym_math_expression] = STATE(721),
    [sym_cast_expression] = STATE(721),
    [sym_type_descriptor] = STATE(1793),
    [sym_sizeof_expression] = STATE(721),
    [sym_subscript_expression] = STATE(721),
    [sym_call_expression] = STATE(721),
    [sym_field_expression] = STATE(721),
    [sym_compound_literal_expression] = STATE(721),
    [sym_parenthesized_expression] = STATE(721),
    [sym_concatenated_string] = STATE(721),
    [sym_macro_type_specifier] = STATE(720),
    [sym_class_specifier] = STATE(720),
    [sym_dependent_type] = STATE(720),
    [sym_template_type] = STATE(415),
    [sym_template_function] = STATE(721),
    [sym_new_expression] = STATE(721),
    [sym_delete_expression] = STATE(721),
    [sym_lambda_expression] = STATE(721),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(416),
    [sym_scoped_namespace_identifier] = STATE(417),
    [aux_sym_type_definition_repeat1] = STATE(724),
    [aux_sym_sized_type_specifier_repeat1] = STATE(725),
    [sym_raw_string_literal] = ACTIONS(1397),
    [anon_sym_LPAREN] = ACTIONS(1087),
    [anon_sym_STAR] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_restrict] = ACTIONS(93),
    [anon_sym_volatile] = ACTIONS(93),
    [anon_sym__Atomic] = ACTIONS(93),
    [anon_sym_mutable] = ACTIONS(93),
    [anon_sym_explicit] = ACTIONS(93),
    [anon_sym_constexpr] = ACTIONS(93),
    [anon_sym_unsigned] = ACTIONS(1399),
    [anon_sym_long] = ACTIONS(1399),
    [anon_sym_short] = ACTIONS(1399),
    [sym_primitive_type] = ACTIONS(1401),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(428),
    [anon_sym_union] = ACTIONS(430),
    [anon_sym_AMP] = ACTIONS(1089),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1093),
    [anon_sym_PLUS] = ACTIONS(1095),
    [anon_sym_DASH] = ACTIONS(1095),
    [anon_sym_DASH_DASH] = ACTIONS(1097),
    [anon_sym_PLUS_PLUS] = ACTIONS(1097),
    [anon_sym_sizeof] = ACTIONS(1099),
    [sym_number_literal] = ACTIONS(1397),
    [sym_char_literal] = ACTIONS(1397),
    [sym_string_literal] = ACTIONS(1101),
    [sym_true] = ACTIONS(1403),
    [sym_false] = ACTIONS(1403),
    [sym_null] = ACTIONS(1403),
    [sym_identifier] = ACTIONS(1405),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(436),
    [sym_auto] = ACTIONS(1401),
    [anon_sym_typename] = ACTIONS(1407),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1409),
    [anon_sym_delete] = ACTIONS(1109),
    [sym_nullptr] = ACTIONS(1403),
  },
  [1215] = {
    [sym_argument_list] = STATE(802),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_COMMA] = ACTIONS(2702),
    [anon_sym_RBRACE] = ACTIONS(2702),
    [anon_sym_STAR] = ACTIONS(2507),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_EQ] = ACTIONS(2704),
    [anon_sym_QMARK] = ACTIONS(2702),
    [anon_sym_STAR_EQ] = ACTIONS(2702),
    [anon_sym_SLASH_EQ] = ACTIONS(2702),
    [anon_sym_PERCENT_EQ] = ACTIONS(2702),
    [anon_sym_PLUS_EQ] = ACTIONS(2702),
    [anon_sym_DASH_EQ] = ACTIONS(2702),
    [anon_sym_LT_LT_EQ] = ACTIONS(2702),
    [anon_sym_GT_GT_EQ] = ACTIONS(2702),
    [anon_sym_AMP_EQ] = ACTIONS(2702),
    [anon_sym_CARET_EQ] = ACTIONS(2702),
    [anon_sym_PIPE_EQ] = ACTIONS(2702),
    [anon_sym_AMP] = ACTIONS(2704),
    [anon_sym_PIPE_PIPE] = ACTIONS(2702),
    [anon_sym_AMP_AMP] = ACTIONS(2702),
    [anon_sym_PIPE] = ACTIONS(2704),
    [anon_sym_CARET] = ACTIONS(2704),
    [anon_sym_EQ_EQ] = ACTIONS(2702),
    [anon_sym_BANG_EQ] = ACTIONS(2702),
    [anon_sym_LT] = ACTIONS(2704),
    [anon_sym_GT] = ACTIONS(2704),
    [anon_sym_LT_EQ] = ACTIONS(2702),
    [anon_sym_GT_EQ] = ACTIONS(2702),
    [anon_sym_LT_LT] = ACTIONS(2531),
    [anon_sym_GT_GT] = ACTIONS(2531),
    [anon_sym_PLUS] = ACTIONS(2533),
    [anon_sym_DASH] = ACTIONS(2533),
    [anon_sym_SLASH] = ACTIONS(2507),
    [anon_sym_PERCENT] = ACTIONS(2507),
    [anon_sym_DASH_DASH] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(1554),
    [anon_sym_DASH_GT] = ACTIONS(1554),
    [sym_comment] = ACTIONS(49),
  },
  [1216] = {
    [aux_sym_concatenated_string_repeat1] = STATE(1794),
    [anon_sym_LPAREN] = ACTIONS(2706),
    [anon_sym_COMMA] = ACTIONS(2706),
    [anon_sym_RBRACE] = ACTIONS(2706),
    [anon_sym_STAR] = ACTIONS(2708),
    [anon_sym_LBRACK] = ACTIONS(2706),
    [anon_sym_EQ] = ACTIONS(2708),
    [anon_sym_QMARK] = ACTIONS(2706),
    [anon_sym_STAR_EQ] = ACTIONS(2706),
    [anon_sym_SLASH_EQ] = ACTIONS(2706),
    [anon_sym_PERCENT_EQ] = ACTIONS(2706),
    [anon_sym_PLUS_EQ] = ACTIONS(2706),
    [anon_sym_DASH_EQ] = ACTIONS(2706),
    [anon_sym_LT_LT_EQ] = ACTIONS(2706),
    [anon_sym_GT_GT_EQ] = ACTIONS(2706),
    [anon_sym_AMP_EQ] = ACTIONS(2706),
    [anon_sym_CARET_EQ] = ACTIONS(2706),
    [anon_sym_PIPE_EQ] = ACTIONS(2706),
    [anon_sym_AMP] = ACTIONS(2708),
    [anon_sym_PIPE_PIPE] = ACTIONS(2706),
    [anon_sym_AMP_AMP] = ACTIONS(2706),
    [anon_sym_PIPE] = ACTIONS(2708),
    [anon_sym_CARET] = ACTIONS(2708),
    [anon_sym_EQ_EQ] = ACTIONS(2706),
    [anon_sym_BANG_EQ] = ACTIONS(2706),
    [anon_sym_LT] = ACTIONS(2708),
    [anon_sym_GT] = ACTIONS(2708),
    [anon_sym_LT_EQ] = ACTIONS(2706),
    [anon_sym_GT_EQ] = ACTIONS(2706),
    [anon_sym_LT_LT] = ACTIONS(2708),
    [anon_sym_GT_GT] = ACTIONS(2708),
    [anon_sym_PLUS] = ACTIONS(2708),
    [anon_sym_DASH] = ACTIONS(2708),
    [anon_sym_SLASH] = ACTIONS(2708),
    [anon_sym_PERCENT] = ACTIONS(2708),
    [anon_sym_DASH_DASH] = ACTIONS(2706),
    [anon_sym_PLUS_PLUS] = ACTIONS(2706),
    [anon_sym_DOT] = ACTIONS(2706),
    [anon_sym_DASH_GT] = ACTIONS(2706),
    [sym_string_literal] = ACTIONS(3998),
    [sym_comment] = ACTIONS(49),
  },
  [1217] = {
    [sym__expression] = STATE(1796),
    [sym_conditional_expression] = STATE(1796),
    [sym_assignment_expression] = STATE(1796),
    [sym_pointer_expression] = STATE(1796),
    [sym_logical_expression] = STATE(1796),
    [sym_bitwise_expression] = STATE(1796),
    [sym_equality_expression] = STATE(1796),
    [sym_relational_expression] = STATE(1796),
    [sym_shift_expression] = STATE(1796),
    [sym_math_expression] = STATE(1796),
    [sym_cast_expression] = STATE(1796),
    [sym_sizeof_expression] = STATE(1796),
    [sym_subscript_expression] = STATE(1796),
    [sym_call_expression] = STATE(1796),
    [sym_field_expression] = STATE(1796),
    [sym_compound_literal_expression] = STATE(1796),
    [sym_parenthesized_expression] = STATE(1796),
    [sym_concatenated_string] = STATE(1796),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(1796),
    [sym_new_expression] = STATE(1796),
    [sym_delete_expression] = STATE(1796),
    [sym_lambda_expression] = STATE(1796),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(4000),
    [anon_sym_LPAREN] = ACTIONS(1321),
    [anon_sym_STAR] = ACTIONS(1325),
    [anon_sym_LBRACK] = ACTIONS(4002),
    [anon_sym_AMP] = ACTIONS(1325),
    [anon_sym_BANG] = ACTIONS(1327),
    [anon_sym_TILDE] = ACTIONS(1329),
    [anon_sym_PLUS] = ACTIONS(1331),
    [anon_sym_DASH] = ACTIONS(1331),
    [anon_sym_DASH_DASH] = ACTIONS(1333),
    [anon_sym_PLUS_PLUS] = ACTIONS(1333),
    [anon_sym_sizeof] = ACTIONS(1335),
    [sym_number_literal] = ACTIONS(4000),
    [sym_char_literal] = ACTIONS(4000),
    [sym_string_literal] = ACTIONS(1337),
    [sym_true] = ACTIONS(4004),
    [sym_false] = ACTIONS(4004),
    [sym_null] = ACTIONS(4004),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1341),
    [anon_sym_delete] = ACTIONS(1343),
    [sym_nullptr] = ACTIONS(4004),
  },
  [1218] = {
    [sym__expression] = STATE(740),
    [sym_conditional_expression] = STATE(740),
    [sym_assignment_expression] = STATE(740),
    [sym_pointer_expression] = STATE(740),
    [sym_logical_expression] = STATE(740),
    [sym_bitwise_expression] = STATE(740),
    [sym_equality_expression] = STATE(740),
    [sym_relational_expression] = STATE(740),
    [sym_shift_expression] = STATE(740),
    [sym_math_expression] = STATE(740),
    [sym_cast_expression] = STATE(740),
    [sym_sizeof_expression] = STATE(740),
    [sym_subscript_expression] = STATE(740),
    [sym_call_expression] = STATE(740),
    [sym_field_expression] = STATE(740),
    [sym_compound_literal_expression] = STATE(740),
    [sym_parenthesized_expression] = STATE(740),
    [sym_concatenated_string] = STATE(740),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(740),
    [sym_new_expression] = STATE(740),
    [sym_delete_expression] = STATE(740),
    [sym_lambda_expression] = STATE(740),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_lambda_default_capture] = STATE(741),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(1417),
    [anon_sym_LPAREN] = ACTIONS(1419),
    [anon_sym_STAR] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_RBRACK] = ACTIONS(4006),
    [anon_sym_EQ] = ACTIONS(1425),
    [anon_sym_AMP] = ACTIONS(1427),
    [anon_sym_BANG] = ACTIONS(1429),
    [anon_sym_TILDE] = ACTIONS(1431),
    [anon_sym_PLUS] = ACTIONS(1433),
    [anon_sym_DASH] = ACTIONS(1433),
    [anon_sym_DASH_DASH] = ACTIONS(1435),
    [anon_sym_PLUS_PLUS] = ACTIONS(1435),
    [anon_sym_sizeof] = ACTIONS(1437),
    [sym_number_literal] = ACTIONS(1417),
    [sym_char_literal] = ACTIONS(1417),
    [sym_string_literal] = ACTIONS(1439),
    [sym_true] = ACTIONS(1441),
    [sym_false] = ACTIONS(1441),
    [sym_null] = ACTIONS(1441),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1443),
    [anon_sym_delete] = ACTIONS(1445),
    [sym_nullptr] = ACTIONS(1441),
  },
  [1219] = {
    [sym_argument_list] = STATE(802),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_COMMA] = ACTIONS(2740),
    [anon_sym_RBRACE] = ACTIONS(2740),
    [anon_sym_STAR] = ACTIONS(2507),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_EQ] = ACTIONS(2742),
    [anon_sym_QMARK] = ACTIONS(2740),
    [anon_sym_STAR_EQ] = ACTIONS(2740),
    [anon_sym_SLASH_EQ] = ACTIONS(2740),
    [anon_sym_PERCENT_EQ] = ACTIONS(2740),
    [anon_sym_PLUS_EQ] = ACTIONS(2740),
    [anon_sym_DASH_EQ] = ACTIONS(2740),
    [anon_sym_LT_LT_EQ] = ACTIONS(2740),
    [anon_sym_GT_GT_EQ] = ACTIONS(2740),
    [anon_sym_AMP_EQ] = ACTIONS(2740),
    [anon_sym_CARET_EQ] = ACTIONS(2740),
    [anon_sym_PIPE_EQ] = ACTIONS(2740),
    [anon_sym_AMP] = ACTIONS(2515),
    [anon_sym_PIPE_PIPE] = ACTIONS(2517),
    [anon_sym_AMP_AMP] = ACTIONS(2519),
    [anon_sym_PIPE] = ACTIONS(2521),
    [anon_sym_CARET] = ACTIONS(2523),
    [anon_sym_EQ_EQ] = ACTIONS(2525),
    [anon_sym_BANG_EQ] = ACTIONS(2525),
    [anon_sym_LT] = ACTIONS(2527),
    [anon_sym_GT] = ACTIONS(2527),
    [anon_sym_LT_EQ] = ACTIONS(2529),
    [anon_sym_GT_EQ] = ACTIONS(2529),
    [anon_sym_LT_LT] = ACTIONS(2531),
    [anon_sym_GT_GT] = ACTIONS(2531),
    [anon_sym_PLUS] = ACTIONS(2533),
    [anon_sym_DASH] = ACTIONS(2533),
    [anon_sym_SLASH] = ACTIONS(2507),
    [anon_sym_PERCENT] = ACTIONS(2507),
    [anon_sym_DASH_DASH] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(1554),
    [anon_sym_DASH_GT] = ACTIONS(1554),
    [sym_comment] = ACTIONS(49),
  },
  [1220] = {
    [sym__expression] = STATE(1328),
    [sym_conditional_expression] = STATE(1328),
    [sym_assignment_expression] = STATE(1328),
    [sym_pointer_expression] = STATE(1328),
    [sym_logical_expression] = STATE(1328),
    [sym_bitwise_expression] = STATE(1328),
    [sym_equality_expression] = STATE(1328),
    [sym_relational_expression] = STATE(1328),
    [sym_shift_expression] = STATE(1328),
    [sym_math_expression] = STATE(1328),
    [sym_cast_expression] = STATE(1328),
    [sym_sizeof_expression] = STATE(1328),
    [sym_subscript_expression] = STATE(1328),
    [sym_call_expression] = STATE(1328),
    [sym_field_expression] = STATE(1328),
    [sym_compound_literal_expression] = STATE(1328),
    [sym_parenthesized_expression] = STATE(1328),
    [sym_concatenated_string] = STATE(1328),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(1328),
    [sym_new_expression] = STATE(1328),
    [sym_delete_expression] = STATE(1328),
    [sym_lambda_expression] = STATE(1328),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(2748),
    [anon_sym_LPAREN] = ACTIONS(1321),
    [anon_sym_STAR] = ACTIONS(1325),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_AMP] = ACTIONS(1325),
    [anon_sym_BANG] = ACTIONS(1327),
    [anon_sym_TILDE] = ACTIONS(1329),
    [anon_sym_PLUS] = ACTIONS(1331),
    [anon_sym_DASH] = ACTIONS(1331),
    [anon_sym_DASH_DASH] = ACTIONS(1333),
    [anon_sym_PLUS_PLUS] = ACTIONS(1333),
    [anon_sym_sizeof] = ACTIONS(1335),
    [sym_number_literal] = ACTIONS(2748),
    [sym_char_literal] = ACTIONS(2748),
    [sym_string_literal] = ACTIONS(1337),
    [sym_true] = ACTIONS(2750),
    [sym_false] = ACTIONS(2750),
    [sym_null] = ACTIONS(2750),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1341),
    [anon_sym_delete] = ACTIONS(1343),
    [sym_nullptr] = ACTIONS(2750),
  },
  [1221] = {
    [sym__expression] = STATE(1798),
    [sym_conditional_expression] = STATE(1798),
    [sym_assignment_expression] = STATE(1798),
    [sym_pointer_expression] = STATE(1798),
    [sym_logical_expression] = STATE(1798),
    [sym_bitwise_expression] = STATE(1798),
    [sym_equality_expression] = STATE(1798),
    [sym_relational_expression] = STATE(1798),
    [sym_shift_expression] = STATE(1798),
    [sym_math_expression] = STATE(1798),
    [sym_cast_expression] = STATE(1798),
    [sym_sizeof_expression] = STATE(1798),
    [sym_subscript_expression] = STATE(1798),
    [sym_call_expression] = STATE(1798),
    [sym_field_expression] = STATE(1798),
    [sym_compound_literal_expression] = STATE(1798),
    [sym_parenthesized_expression] = STATE(1798),
    [sym_concatenated_string] = STATE(1798),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(1798),
    [sym_new_expression] = STATE(1798),
    [sym_delete_expression] = STATE(1798),
    [sym_lambda_expression] = STATE(1798),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(4008),
    [anon_sym_LPAREN] = ACTIONS(1321),
    [anon_sym_STAR] = ACTIONS(1325),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_AMP] = ACTIONS(1325),
    [anon_sym_BANG] = ACTIONS(1327),
    [anon_sym_TILDE] = ACTIONS(1329),
    [anon_sym_PLUS] = ACTIONS(1331),
    [anon_sym_DASH] = ACTIONS(1331),
    [anon_sym_DASH_DASH] = ACTIONS(1333),
    [anon_sym_PLUS_PLUS] = ACTIONS(1333),
    [anon_sym_sizeof] = ACTIONS(1335),
    [sym_number_literal] = ACTIONS(4008),
    [sym_char_literal] = ACTIONS(4008),
    [sym_string_literal] = ACTIONS(1337),
    [sym_true] = ACTIONS(4010),
    [sym_false] = ACTIONS(4010),
    [sym_null] = ACTIONS(4010),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1341),
    [anon_sym_delete] = ACTIONS(1343),
    [sym_nullptr] = ACTIONS(4010),
  },
  [1222] = {
    [sym__expression] = STATE(1799),
    [sym_conditional_expression] = STATE(1799),
    [sym_assignment_expression] = STATE(1799),
    [sym_pointer_expression] = STATE(1799),
    [sym_logical_expression] = STATE(1799),
    [sym_bitwise_expression] = STATE(1799),
    [sym_equality_expression] = STATE(1799),
    [sym_relational_expression] = STATE(1799),
    [sym_shift_expression] = STATE(1799),
    [sym_math_expression] = STATE(1799),
    [sym_cast_expression] = STATE(1799),
    [sym_sizeof_expression] = STATE(1799),
    [sym_subscript_expression] = STATE(1799),
    [sym_call_expression] = STATE(1799),
    [sym_field_expression] = STATE(1799),
    [sym_compound_literal_expression] = STATE(1799),
    [sym_parenthesized_expression] = STATE(1799),
    [sym_concatenated_string] = STATE(1799),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(1799),
    [sym_new_expression] = STATE(1799),
    [sym_delete_expression] = STATE(1799),
    [sym_lambda_expression] = STATE(1799),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(855),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(4012),
    [anon_sym_LPAREN] = ACTIONS(1634),
    [anon_sym_STAR] = ACTIONS(1636),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_AMP] = ACTIONS(1636),
    [anon_sym_BANG] = ACTIONS(1638),
    [anon_sym_TILDE] = ACTIONS(1640),
    [anon_sym_PLUS] = ACTIONS(1642),
    [anon_sym_DASH] = ACTIONS(1642),
    [anon_sym_DASH_DASH] = ACTIONS(1644),
    [anon_sym_PLUS_PLUS] = ACTIONS(1644),
    [anon_sym_sizeof] = ACTIONS(1646),
    [sym_number_literal] = ACTIONS(4012),
    [sym_char_literal] = ACTIONS(4012),
    [sym_string_literal] = ACTIONS(1648),
    [sym_true] = ACTIONS(4014),
    [sym_false] = ACTIONS(4014),
    [sym_null] = ACTIONS(4014),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1652),
    [anon_sym_delete] = ACTIONS(1654),
    [sym_nullptr] = ACTIONS(4014),
  },
  [1223] = {
    [sym__expression] = STATE(1800),
    [sym_conditional_expression] = STATE(1800),
    [sym_assignment_expression] = STATE(1800),
    [sym_pointer_expression] = STATE(1800),
    [sym_logical_expression] = STATE(1800),
    [sym_bitwise_expression] = STATE(1800),
    [sym_equality_expression] = STATE(1800),
    [sym_relational_expression] = STATE(1800),
    [sym_shift_expression] = STATE(1800),
    [sym_math_expression] = STATE(1800),
    [sym_cast_expression] = STATE(1800),
    [sym_sizeof_expression] = STATE(1800),
    [sym_subscript_expression] = STATE(1800),
    [sym_call_expression] = STATE(1800),
    [sym_field_expression] = STATE(1800),
    [sym_compound_literal_expression] = STATE(1800),
    [sym_parenthesized_expression] = STATE(1800),
    [sym_concatenated_string] = STATE(1800),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(1800),
    [sym_new_expression] = STATE(1800),
    [sym_delete_expression] = STATE(1800),
    [sym_lambda_expression] = STATE(1800),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(4016),
    [anon_sym_LPAREN] = ACTIONS(1321),
    [anon_sym_STAR] = ACTIONS(1325),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_AMP] = ACTIONS(1325),
    [anon_sym_BANG] = ACTIONS(1327),
    [anon_sym_TILDE] = ACTIONS(1329),
    [anon_sym_PLUS] = ACTIONS(1331),
    [anon_sym_DASH] = ACTIONS(1331),
    [anon_sym_DASH_DASH] = ACTIONS(1333),
    [anon_sym_PLUS_PLUS] = ACTIONS(1333),
    [anon_sym_sizeof] = ACTIONS(1335),
    [sym_number_literal] = ACTIONS(4016),
    [sym_char_literal] = ACTIONS(4016),
    [sym_string_literal] = ACTIONS(1337),
    [sym_true] = ACTIONS(4018),
    [sym_false] = ACTIONS(4018),
    [sym_null] = ACTIONS(4018),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1341),
    [anon_sym_delete] = ACTIONS(1343),
    [sym_nullptr] = ACTIONS(4018),
  },
  [1224] = {
    [sym__expression] = STATE(1801),
    [sym_conditional_expression] = STATE(1801),
    [sym_assignment_expression] = STATE(1801),
    [sym_pointer_expression] = STATE(1801),
    [sym_logical_expression] = STATE(1801),
    [sym_bitwise_expression] = STATE(1801),
    [sym_equality_expression] = STATE(1801),
    [sym_relational_expression] = STATE(1801),
    [sym_shift_expression] = STATE(1801),
    [sym_math_expression] = STATE(1801),
    [sym_cast_expression] = STATE(1801),
    [sym_sizeof_expression] = STATE(1801),
    [sym_subscript_expression] = STATE(1801),
    [sym_call_expression] = STATE(1801),
    [sym_field_expression] = STATE(1801),
    [sym_compound_literal_expression] = STATE(1801),
    [sym_parenthesized_expression] = STATE(1801),
    [sym_concatenated_string] = STATE(1801),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(1801),
    [sym_new_expression] = STATE(1801),
    [sym_delete_expression] = STATE(1801),
    [sym_lambda_expression] = STATE(1801),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(4020),
    [anon_sym_LPAREN] = ACTIONS(1321),
    [anon_sym_STAR] = ACTIONS(1325),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_AMP] = ACTIONS(1325),
    [anon_sym_BANG] = ACTIONS(1327),
    [anon_sym_TILDE] = ACTIONS(1329),
    [anon_sym_PLUS] = ACTIONS(1331),
    [anon_sym_DASH] = ACTIONS(1331),
    [anon_sym_DASH_DASH] = ACTIONS(1333),
    [anon_sym_PLUS_PLUS] = ACTIONS(1333),
    [anon_sym_sizeof] = ACTIONS(1335),
    [sym_number_literal] = ACTIONS(4020),
    [sym_char_literal] = ACTIONS(4020),
    [sym_string_literal] = ACTIONS(1337),
    [sym_true] = ACTIONS(4022),
    [sym_false] = ACTIONS(4022),
    [sym_null] = ACTIONS(4022),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1341),
    [anon_sym_delete] = ACTIONS(1343),
    [sym_nullptr] = ACTIONS(4022),
  },
  [1225] = {
    [sym__expression] = STATE(1802),
    [sym_conditional_expression] = STATE(1802),
    [sym_assignment_expression] = STATE(1802),
    [sym_pointer_expression] = STATE(1802),
    [sym_logical_expression] = STATE(1802),
    [sym_bitwise_expression] = STATE(1802),
    [sym_equality_expression] = STATE(1802),
    [sym_relational_expression] = STATE(1802),
    [sym_shift_expression] = STATE(1802),
    [sym_math_expression] = STATE(1802),
    [sym_cast_expression] = STATE(1802),
    [sym_sizeof_expression] = STATE(1802),
    [sym_subscript_expression] = STATE(1802),
    [sym_call_expression] = STATE(1802),
    [sym_field_expression] = STATE(1802),
    [sym_compound_literal_expression] = STATE(1802),
    [sym_parenthesized_expression] = STATE(1802),
    [sym_concatenated_string] = STATE(1802),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(1802),
    [sym_new_expression] = STATE(1802),
    [sym_delete_expression] = STATE(1802),
    [sym_lambda_expression] = STATE(1802),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(4024),
    [anon_sym_LPAREN] = ACTIONS(1321),
    [anon_sym_STAR] = ACTIONS(1325),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_AMP] = ACTIONS(1325),
    [anon_sym_BANG] = ACTIONS(1327),
    [anon_sym_TILDE] = ACTIONS(1329),
    [anon_sym_PLUS] = ACTIONS(1331),
    [anon_sym_DASH] = ACTIONS(1331),
    [anon_sym_DASH_DASH] = ACTIONS(1333),
    [anon_sym_PLUS_PLUS] = ACTIONS(1333),
    [anon_sym_sizeof] = ACTIONS(1335),
    [sym_number_literal] = ACTIONS(4024),
    [sym_char_literal] = ACTIONS(4024),
    [sym_string_literal] = ACTIONS(1337),
    [sym_true] = ACTIONS(4026),
    [sym_false] = ACTIONS(4026),
    [sym_null] = ACTIONS(4026),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1341),
    [anon_sym_delete] = ACTIONS(1343),
    [sym_nullptr] = ACTIONS(4026),
  },
  [1226] = {
    [sym__expression] = STATE(1803),
    [sym_conditional_expression] = STATE(1803),
    [sym_assignment_expression] = STATE(1803),
    [sym_pointer_expression] = STATE(1803),
    [sym_logical_expression] = STATE(1803),
    [sym_bitwise_expression] = STATE(1803),
    [sym_equality_expression] = STATE(1803),
    [sym_relational_expression] = STATE(1803),
    [sym_shift_expression] = STATE(1803),
    [sym_math_expression] = STATE(1803),
    [sym_cast_expression] = STATE(1803),
    [sym_sizeof_expression] = STATE(1803),
    [sym_subscript_expression] = STATE(1803),
    [sym_call_expression] = STATE(1803),
    [sym_field_expression] = STATE(1803),
    [sym_compound_literal_expression] = STATE(1803),
    [sym_parenthesized_expression] = STATE(1803),
    [sym_concatenated_string] = STATE(1803),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(1803),
    [sym_new_expression] = STATE(1803),
    [sym_delete_expression] = STATE(1803),
    [sym_lambda_expression] = STATE(1803),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(4028),
    [anon_sym_LPAREN] = ACTIONS(1321),
    [anon_sym_STAR] = ACTIONS(1325),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_AMP] = ACTIONS(1325),
    [anon_sym_BANG] = ACTIONS(1327),
    [anon_sym_TILDE] = ACTIONS(1329),
    [anon_sym_PLUS] = ACTIONS(1331),
    [anon_sym_DASH] = ACTIONS(1331),
    [anon_sym_DASH_DASH] = ACTIONS(1333),
    [anon_sym_PLUS_PLUS] = ACTIONS(1333),
    [anon_sym_sizeof] = ACTIONS(1335),
    [sym_number_literal] = ACTIONS(4028),
    [sym_char_literal] = ACTIONS(4028),
    [sym_string_literal] = ACTIONS(1337),
    [sym_true] = ACTIONS(4030),
    [sym_false] = ACTIONS(4030),
    [sym_null] = ACTIONS(4030),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1341),
    [anon_sym_delete] = ACTIONS(1343),
    [sym_nullptr] = ACTIONS(4030),
  },
  [1227] = {
    [sym__expression] = STATE(1804),
    [sym_conditional_expression] = STATE(1804),
    [sym_assignment_expression] = STATE(1804),
    [sym_pointer_expression] = STATE(1804),
    [sym_logical_expression] = STATE(1804),
    [sym_bitwise_expression] = STATE(1804),
    [sym_equality_expression] = STATE(1804),
    [sym_relational_expression] = STATE(1804),
    [sym_shift_expression] = STATE(1804),
    [sym_math_expression] = STATE(1804),
    [sym_cast_expression] = STATE(1804),
    [sym_sizeof_expression] = STATE(1804),
    [sym_subscript_expression] = STATE(1804),
    [sym_call_expression] = STATE(1804),
    [sym_field_expression] = STATE(1804),
    [sym_compound_literal_expression] = STATE(1804),
    [sym_parenthesized_expression] = STATE(1804),
    [sym_concatenated_string] = STATE(1804),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(1804),
    [sym_new_expression] = STATE(1804),
    [sym_delete_expression] = STATE(1804),
    [sym_lambda_expression] = STATE(1804),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(4032),
    [anon_sym_LPAREN] = ACTIONS(1321),
    [anon_sym_STAR] = ACTIONS(1325),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_AMP] = ACTIONS(1325),
    [anon_sym_BANG] = ACTIONS(1327),
    [anon_sym_TILDE] = ACTIONS(1329),
    [anon_sym_PLUS] = ACTIONS(1331),
    [anon_sym_DASH] = ACTIONS(1331),
    [anon_sym_DASH_DASH] = ACTIONS(1333),
    [anon_sym_PLUS_PLUS] = ACTIONS(1333),
    [anon_sym_sizeof] = ACTIONS(1335),
    [sym_number_literal] = ACTIONS(4032),
    [sym_char_literal] = ACTIONS(4032),
    [sym_string_literal] = ACTIONS(1337),
    [sym_true] = ACTIONS(4034),
    [sym_false] = ACTIONS(4034),
    [sym_null] = ACTIONS(4034),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1341),
    [anon_sym_delete] = ACTIONS(1343),
    [sym_nullptr] = ACTIONS(4034),
  },
  [1228] = {
    [sym__expression] = STATE(1805),
    [sym_conditional_expression] = STATE(1805),
    [sym_assignment_expression] = STATE(1805),
    [sym_pointer_expression] = STATE(1805),
    [sym_logical_expression] = STATE(1805),
    [sym_bitwise_expression] = STATE(1805),
    [sym_equality_expression] = STATE(1805),
    [sym_relational_expression] = STATE(1805),
    [sym_shift_expression] = STATE(1805),
    [sym_math_expression] = STATE(1805),
    [sym_cast_expression] = STATE(1805),
    [sym_sizeof_expression] = STATE(1805),
    [sym_subscript_expression] = STATE(1805),
    [sym_call_expression] = STATE(1805),
    [sym_field_expression] = STATE(1805),
    [sym_compound_literal_expression] = STATE(1805),
    [sym_parenthesized_expression] = STATE(1805),
    [sym_concatenated_string] = STATE(1805),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(1805),
    [sym_new_expression] = STATE(1805),
    [sym_delete_expression] = STATE(1805),
    [sym_lambda_expression] = STATE(1805),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(4036),
    [anon_sym_LPAREN] = ACTIONS(1321),
    [anon_sym_STAR] = ACTIONS(1325),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_AMP] = ACTIONS(1325),
    [anon_sym_BANG] = ACTIONS(1327),
    [anon_sym_TILDE] = ACTIONS(1329),
    [anon_sym_PLUS] = ACTIONS(1331),
    [anon_sym_DASH] = ACTIONS(1331),
    [anon_sym_DASH_DASH] = ACTIONS(1333),
    [anon_sym_PLUS_PLUS] = ACTIONS(1333),
    [anon_sym_sizeof] = ACTIONS(1335),
    [sym_number_literal] = ACTIONS(4036),
    [sym_char_literal] = ACTIONS(4036),
    [sym_string_literal] = ACTIONS(1337),
    [sym_true] = ACTIONS(4038),
    [sym_false] = ACTIONS(4038),
    [sym_null] = ACTIONS(4038),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1341),
    [anon_sym_delete] = ACTIONS(1343),
    [sym_nullptr] = ACTIONS(4038),
  },
  [1229] = {
    [sym__expression] = STATE(1806),
    [sym_conditional_expression] = STATE(1806),
    [sym_assignment_expression] = STATE(1806),
    [sym_pointer_expression] = STATE(1806),
    [sym_logical_expression] = STATE(1806),
    [sym_bitwise_expression] = STATE(1806),
    [sym_equality_expression] = STATE(1806),
    [sym_relational_expression] = STATE(1806),
    [sym_shift_expression] = STATE(1806),
    [sym_math_expression] = STATE(1806),
    [sym_cast_expression] = STATE(1806),
    [sym_sizeof_expression] = STATE(1806),
    [sym_subscript_expression] = STATE(1806),
    [sym_call_expression] = STATE(1806),
    [sym_field_expression] = STATE(1806),
    [sym_compound_literal_expression] = STATE(1806),
    [sym_parenthesized_expression] = STATE(1806),
    [sym_concatenated_string] = STATE(1806),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(1806),
    [sym_new_expression] = STATE(1806),
    [sym_delete_expression] = STATE(1806),
    [sym_lambda_expression] = STATE(1806),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(4040),
    [anon_sym_LPAREN] = ACTIONS(1321),
    [anon_sym_STAR] = ACTIONS(1325),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_AMP] = ACTIONS(1325),
    [anon_sym_BANG] = ACTIONS(1327),
    [anon_sym_TILDE] = ACTIONS(1329),
    [anon_sym_PLUS] = ACTIONS(1331),
    [anon_sym_DASH] = ACTIONS(1331),
    [anon_sym_DASH_DASH] = ACTIONS(1333),
    [anon_sym_PLUS_PLUS] = ACTIONS(1333),
    [anon_sym_sizeof] = ACTIONS(1335),
    [sym_number_literal] = ACTIONS(4040),
    [sym_char_literal] = ACTIONS(4040),
    [sym_string_literal] = ACTIONS(1337),
    [sym_true] = ACTIONS(4042),
    [sym_false] = ACTIONS(4042),
    [sym_null] = ACTIONS(4042),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1341),
    [anon_sym_delete] = ACTIONS(1343),
    [sym_nullptr] = ACTIONS(4042),
  },
  [1230] = {
    [sym__expression] = STATE(1807),
    [sym_conditional_expression] = STATE(1807),
    [sym_assignment_expression] = STATE(1807),
    [sym_pointer_expression] = STATE(1807),
    [sym_logical_expression] = STATE(1807),
    [sym_bitwise_expression] = STATE(1807),
    [sym_equality_expression] = STATE(1807),
    [sym_relational_expression] = STATE(1807),
    [sym_shift_expression] = STATE(1807),
    [sym_math_expression] = STATE(1807),
    [sym_cast_expression] = STATE(1807),
    [sym_sizeof_expression] = STATE(1807),
    [sym_subscript_expression] = STATE(1807),
    [sym_call_expression] = STATE(1807),
    [sym_field_expression] = STATE(1807),
    [sym_compound_literal_expression] = STATE(1807),
    [sym_parenthesized_expression] = STATE(1807),
    [sym_concatenated_string] = STATE(1807),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(1807),
    [sym_new_expression] = STATE(1807),
    [sym_delete_expression] = STATE(1807),
    [sym_lambda_expression] = STATE(1807),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(4044),
    [anon_sym_LPAREN] = ACTIONS(1321),
    [anon_sym_STAR] = ACTIONS(1325),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_AMP] = ACTIONS(1325),
    [anon_sym_BANG] = ACTIONS(1327),
    [anon_sym_TILDE] = ACTIONS(1329),
    [anon_sym_PLUS] = ACTIONS(1331),
    [anon_sym_DASH] = ACTIONS(1331),
    [anon_sym_DASH_DASH] = ACTIONS(1333),
    [anon_sym_PLUS_PLUS] = ACTIONS(1333),
    [anon_sym_sizeof] = ACTIONS(1335),
    [sym_number_literal] = ACTIONS(4044),
    [sym_char_literal] = ACTIONS(4044),
    [sym_string_literal] = ACTIONS(1337),
    [sym_true] = ACTIONS(4046),
    [sym_false] = ACTIONS(4046),
    [sym_null] = ACTIONS(4046),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1341),
    [anon_sym_delete] = ACTIONS(1343),
    [sym_nullptr] = ACTIONS(4046),
  },
  [1231] = {
    [sym__expression] = STATE(1808),
    [sym_conditional_expression] = STATE(1808),
    [sym_assignment_expression] = STATE(1808),
    [sym_pointer_expression] = STATE(1808),
    [sym_logical_expression] = STATE(1808),
    [sym_bitwise_expression] = STATE(1808),
    [sym_equality_expression] = STATE(1808),
    [sym_relational_expression] = STATE(1808),
    [sym_shift_expression] = STATE(1808),
    [sym_math_expression] = STATE(1808),
    [sym_cast_expression] = STATE(1808),
    [sym_sizeof_expression] = STATE(1808),
    [sym_subscript_expression] = STATE(1808),
    [sym_call_expression] = STATE(1808),
    [sym_field_expression] = STATE(1808),
    [sym_compound_literal_expression] = STATE(1808),
    [sym_parenthesized_expression] = STATE(1808),
    [sym_concatenated_string] = STATE(1808),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(1808),
    [sym_new_expression] = STATE(1808),
    [sym_delete_expression] = STATE(1808),
    [sym_lambda_expression] = STATE(1808),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(4048),
    [anon_sym_LPAREN] = ACTIONS(1321),
    [anon_sym_STAR] = ACTIONS(1325),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_AMP] = ACTIONS(1325),
    [anon_sym_BANG] = ACTIONS(1327),
    [anon_sym_TILDE] = ACTIONS(1329),
    [anon_sym_PLUS] = ACTIONS(1331),
    [anon_sym_DASH] = ACTIONS(1331),
    [anon_sym_DASH_DASH] = ACTIONS(1333),
    [anon_sym_PLUS_PLUS] = ACTIONS(1333),
    [anon_sym_sizeof] = ACTIONS(1335),
    [sym_number_literal] = ACTIONS(4048),
    [sym_char_literal] = ACTIONS(4048),
    [sym_string_literal] = ACTIONS(1337),
    [sym_true] = ACTIONS(4050),
    [sym_false] = ACTIONS(4050),
    [sym_null] = ACTIONS(4050),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1341),
    [anon_sym_delete] = ACTIONS(1343),
    [sym_nullptr] = ACTIONS(4050),
  },
  [1232] = {
    [anon_sym_RPAREN] = ACTIONS(4052),
    [sym_comment] = ACTIONS(49),
  },
  [1233] = {
    [sym_type_qualifier] = STATE(724),
    [sym__type_specifier] = STATE(720),
    [sym_sized_type_specifier] = STATE(720),
    [sym_enum_specifier] = STATE(720),
    [sym_struct_specifier] = STATE(720),
    [sym_union_specifier] = STATE(720),
    [sym__expression] = STATE(721),
    [sym_comma_expression] = STATE(722),
    [sym_conditional_expression] = STATE(721),
    [sym_assignment_expression] = STATE(721),
    [sym_pointer_expression] = STATE(721),
    [sym_logical_expression] = STATE(721),
    [sym_bitwise_expression] = STATE(721),
    [sym_equality_expression] = STATE(721),
    [sym_relational_expression] = STATE(721),
    [sym_shift_expression] = STATE(721),
    [sym_math_expression] = STATE(721),
    [sym_cast_expression] = STATE(721),
    [sym_type_descriptor] = STATE(1810),
    [sym_sizeof_expression] = STATE(721),
    [sym_subscript_expression] = STATE(721),
    [sym_call_expression] = STATE(721),
    [sym_field_expression] = STATE(721),
    [sym_compound_literal_expression] = STATE(721),
    [sym_parenthesized_expression] = STATE(721),
    [sym_concatenated_string] = STATE(721),
    [sym_macro_type_specifier] = STATE(720),
    [sym_class_specifier] = STATE(720),
    [sym_dependent_type] = STATE(720),
    [sym_template_type] = STATE(415),
    [sym_template_function] = STATE(721),
    [sym_new_expression] = STATE(721),
    [sym_delete_expression] = STATE(721),
    [sym_lambda_expression] = STATE(721),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(416),
    [sym_scoped_namespace_identifier] = STATE(417),
    [aux_sym_type_definition_repeat1] = STATE(724),
    [aux_sym_sized_type_specifier_repeat1] = STATE(725),
    [sym_raw_string_literal] = ACTIONS(1397),
    [anon_sym_LPAREN] = ACTIONS(1087),
    [anon_sym_STAR] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_restrict] = ACTIONS(93),
    [anon_sym_volatile] = ACTIONS(93),
    [anon_sym__Atomic] = ACTIONS(93),
    [anon_sym_mutable] = ACTIONS(93),
    [anon_sym_explicit] = ACTIONS(93),
    [anon_sym_constexpr] = ACTIONS(93),
    [anon_sym_unsigned] = ACTIONS(1399),
    [anon_sym_long] = ACTIONS(1399),
    [anon_sym_short] = ACTIONS(1399),
    [sym_primitive_type] = ACTIONS(1401),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(428),
    [anon_sym_union] = ACTIONS(430),
    [anon_sym_AMP] = ACTIONS(1089),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1093),
    [anon_sym_PLUS] = ACTIONS(1095),
    [anon_sym_DASH] = ACTIONS(1095),
    [anon_sym_DASH_DASH] = ACTIONS(1097),
    [anon_sym_PLUS_PLUS] = ACTIONS(1097),
    [anon_sym_sizeof] = ACTIONS(1099),
    [sym_number_literal] = ACTIONS(1397),
    [sym_char_literal] = ACTIONS(1397),
    [sym_string_literal] = ACTIONS(1101),
    [sym_true] = ACTIONS(1403),
    [sym_false] = ACTIONS(1403),
    [sym_null] = ACTIONS(1403),
    [sym_identifier] = ACTIONS(1405),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(436),
    [sym_auto] = ACTIONS(1401),
    [anon_sym_typename] = ACTIONS(1407),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1409),
    [anon_sym_delete] = ACTIONS(1109),
    [sym_nullptr] = ACTIONS(1403),
  },
  [1234] = {
    [sym_argument_list] = STATE(802),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_SEMI] = ACTIONS(2702),
    [anon_sym_STAR] = ACTIONS(2553),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_EQ] = ACTIONS(2704),
    [anon_sym_QMARK] = ACTIONS(2702),
    [anon_sym_STAR_EQ] = ACTIONS(2702),
    [anon_sym_SLASH_EQ] = ACTIONS(2702),
    [anon_sym_PERCENT_EQ] = ACTIONS(2702),
    [anon_sym_PLUS_EQ] = ACTIONS(2702),
    [anon_sym_DASH_EQ] = ACTIONS(2702),
    [anon_sym_LT_LT_EQ] = ACTIONS(2702),
    [anon_sym_GT_GT_EQ] = ACTIONS(2702),
    [anon_sym_AMP_EQ] = ACTIONS(2702),
    [anon_sym_CARET_EQ] = ACTIONS(2702),
    [anon_sym_PIPE_EQ] = ACTIONS(2702),
    [anon_sym_AMP] = ACTIONS(2704),
    [anon_sym_PIPE_PIPE] = ACTIONS(2702),
    [anon_sym_AMP_AMP] = ACTIONS(2702),
    [anon_sym_PIPE] = ACTIONS(2704),
    [anon_sym_CARET] = ACTIONS(2704),
    [anon_sym_EQ_EQ] = ACTIONS(2702),
    [anon_sym_BANG_EQ] = ACTIONS(2702),
    [anon_sym_LT] = ACTIONS(2704),
    [anon_sym_GT] = ACTIONS(2704),
    [anon_sym_LT_EQ] = ACTIONS(2702),
    [anon_sym_GT_EQ] = ACTIONS(2702),
    [anon_sym_LT_LT] = ACTIONS(2577),
    [anon_sym_GT_GT] = ACTIONS(2577),
    [anon_sym_PLUS] = ACTIONS(2579),
    [anon_sym_DASH] = ACTIONS(2579),
    [anon_sym_SLASH] = ACTIONS(2553),
    [anon_sym_PERCENT] = ACTIONS(2553),
    [anon_sym_DASH_DASH] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(1554),
    [anon_sym_DASH_GT] = ACTIONS(1554),
    [sym_comment] = ACTIONS(49),
  },
  [1235] = {
    [aux_sym_concatenated_string_repeat1] = STATE(1811),
    [anon_sym_LPAREN] = ACTIONS(2706),
    [anon_sym_SEMI] = ACTIONS(2706),
    [anon_sym_STAR] = ACTIONS(2708),
    [anon_sym_LBRACK] = ACTIONS(2706),
    [anon_sym_EQ] = ACTIONS(2708),
    [anon_sym_QMARK] = ACTIONS(2706),
    [anon_sym_STAR_EQ] = ACTIONS(2706),
    [anon_sym_SLASH_EQ] = ACTIONS(2706),
    [anon_sym_PERCENT_EQ] = ACTIONS(2706),
    [anon_sym_PLUS_EQ] = ACTIONS(2706),
    [anon_sym_DASH_EQ] = ACTIONS(2706),
    [anon_sym_LT_LT_EQ] = ACTIONS(2706),
    [anon_sym_GT_GT_EQ] = ACTIONS(2706),
    [anon_sym_AMP_EQ] = ACTIONS(2706),
    [anon_sym_CARET_EQ] = ACTIONS(2706),
    [anon_sym_PIPE_EQ] = ACTIONS(2706),
    [anon_sym_AMP] = ACTIONS(2708),
    [anon_sym_PIPE_PIPE] = ACTIONS(2706),
    [anon_sym_AMP_AMP] = ACTIONS(2706),
    [anon_sym_PIPE] = ACTIONS(2708),
    [anon_sym_CARET] = ACTIONS(2708),
    [anon_sym_EQ_EQ] = ACTIONS(2706),
    [anon_sym_BANG_EQ] = ACTIONS(2706),
    [anon_sym_LT] = ACTIONS(2708),
    [anon_sym_GT] = ACTIONS(2708),
    [anon_sym_LT_EQ] = ACTIONS(2706),
    [anon_sym_GT_EQ] = ACTIONS(2706),
    [anon_sym_LT_LT] = ACTIONS(2708),
    [anon_sym_GT_GT] = ACTIONS(2708),
    [anon_sym_PLUS] = ACTIONS(2708),
    [anon_sym_DASH] = ACTIONS(2708),
    [anon_sym_SLASH] = ACTIONS(2708),
    [anon_sym_PERCENT] = ACTIONS(2708),
    [anon_sym_DASH_DASH] = ACTIONS(2706),
    [anon_sym_PLUS_PLUS] = ACTIONS(2706),
    [anon_sym_DOT] = ACTIONS(2706),
    [anon_sym_DASH_GT] = ACTIONS(2706),
    [sym_string_literal] = ACTIONS(4054),
    [sym_comment] = ACTIONS(49),
  },
  [1236] = {
    [sym__expression] = STATE(1813),
    [sym_conditional_expression] = STATE(1813),
    [sym_assignment_expression] = STATE(1813),
    [sym_pointer_expression] = STATE(1813),
    [sym_logical_expression] = STATE(1813),
    [sym_bitwise_expression] = STATE(1813),
    [sym_equality_expression] = STATE(1813),
    [sym_relational_expression] = STATE(1813),
    [sym_shift_expression] = STATE(1813),
    [sym_math_expression] = STATE(1813),
    [sym_cast_expression] = STATE(1813),
    [sym_sizeof_expression] = STATE(1813),
    [sym_subscript_expression] = STATE(1813),
    [sym_call_expression] = STATE(1813),
    [sym_field_expression] = STATE(1813),
    [sym_compound_literal_expression] = STATE(1813),
    [sym_parenthesized_expression] = STATE(1813),
    [sym_concatenated_string] = STATE(1813),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(1813),
    [sym_new_expression] = STATE(1813),
    [sym_delete_expression] = STATE(1813),
    [sym_lambda_expression] = STATE(1813),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(4056),
    [anon_sym_LPAREN] = ACTIONS(1347),
    [anon_sym_STAR] = ACTIONS(1349),
    [anon_sym_LBRACK] = ACTIONS(4058),
    [anon_sym_AMP] = ACTIONS(1349),
    [anon_sym_BANG] = ACTIONS(1351),
    [anon_sym_TILDE] = ACTIONS(1353),
    [anon_sym_PLUS] = ACTIONS(1355),
    [anon_sym_DASH] = ACTIONS(1355),
    [anon_sym_DASH_DASH] = ACTIONS(1357),
    [anon_sym_PLUS_PLUS] = ACTIONS(1357),
    [anon_sym_sizeof] = ACTIONS(1359),
    [sym_number_literal] = ACTIONS(4056),
    [sym_char_literal] = ACTIONS(4056),
    [sym_string_literal] = ACTIONS(1361),
    [sym_true] = ACTIONS(4060),
    [sym_false] = ACTIONS(4060),
    [sym_null] = ACTIONS(4060),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1365),
    [anon_sym_delete] = ACTIONS(1367),
    [sym_nullptr] = ACTIONS(4060),
  },
  [1237] = {
    [sym__expression] = STATE(740),
    [sym_conditional_expression] = STATE(740),
    [sym_assignment_expression] = STATE(740),
    [sym_pointer_expression] = STATE(740),
    [sym_logical_expression] = STATE(740),
    [sym_bitwise_expression] = STATE(740),
    [sym_equality_expression] = STATE(740),
    [sym_relational_expression] = STATE(740),
    [sym_shift_expression] = STATE(740),
    [sym_math_expression] = STATE(740),
    [sym_cast_expression] = STATE(740),
    [sym_sizeof_expression] = STATE(740),
    [sym_subscript_expression] = STATE(740),
    [sym_call_expression] = STATE(740),
    [sym_field_expression] = STATE(740),
    [sym_compound_literal_expression] = STATE(740),
    [sym_parenthesized_expression] = STATE(740),
    [sym_concatenated_string] = STATE(740),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(740),
    [sym_new_expression] = STATE(740),
    [sym_delete_expression] = STATE(740),
    [sym_lambda_expression] = STATE(740),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_lambda_default_capture] = STATE(741),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(1417),
    [anon_sym_LPAREN] = ACTIONS(1419),
    [anon_sym_STAR] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_RBRACK] = ACTIONS(4062),
    [anon_sym_EQ] = ACTIONS(1425),
    [anon_sym_AMP] = ACTIONS(1427),
    [anon_sym_BANG] = ACTIONS(1429),
    [anon_sym_TILDE] = ACTIONS(1431),
    [anon_sym_PLUS] = ACTIONS(1433),
    [anon_sym_DASH] = ACTIONS(1433),
    [anon_sym_DASH_DASH] = ACTIONS(1435),
    [anon_sym_PLUS_PLUS] = ACTIONS(1435),
    [anon_sym_sizeof] = ACTIONS(1437),
    [sym_number_literal] = ACTIONS(1417),
    [sym_char_literal] = ACTIONS(1417),
    [sym_string_literal] = ACTIONS(1439),
    [sym_true] = ACTIONS(1441),
    [sym_false] = ACTIONS(1441),
    [sym_null] = ACTIONS(1441),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1443),
    [anon_sym_delete] = ACTIONS(1445),
    [sym_nullptr] = ACTIONS(1441),
  },
  [1238] = {
    [sym_argument_list] = STATE(802),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_SEMI] = ACTIONS(2740),
    [anon_sym_STAR] = ACTIONS(2553),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_EQ] = ACTIONS(2742),
    [anon_sym_QMARK] = ACTIONS(2740),
    [anon_sym_STAR_EQ] = ACTIONS(2740),
    [anon_sym_SLASH_EQ] = ACTIONS(2740),
    [anon_sym_PERCENT_EQ] = ACTIONS(2740),
    [anon_sym_PLUS_EQ] = ACTIONS(2740),
    [anon_sym_DASH_EQ] = ACTIONS(2740),
    [anon_sym_LT_LT_EQ] = ACTIONS(2740),
    [anon_sym_GT_GT_EQ] = ACTIONS(2740),
    [anon_sym_AMP_EQ] = ACTIONS(2740),
    [anon_sym_CARET_EQ] = ACTIONS(2740),
    [anon_sym_PIPE_EQ] = ACTIONS(2740),
    [anon_sym_AMP] = ACTIONS(2561),
    [anon_sym_PIPE_PIPE] = ACTIONS(2563),
    [anon_sym_AMP_AMP] = ACTIONS(2565),
    [anon_sym_PIPE] = ACTIONS(2567),
    [anon_sym_CARET] = ACTIONS(2569),
    [anon_sym_EQ_EQ] = ACTIONS(2571),
    [anon_sym_BANG_EQ] = ACTIONS(2571),
    [anon_sym_LT] = ACTIONS(2573),
    [anon_sym_GT] = ACTIONS(2573),
    [anon_sym_LT_EQ] = ACTIONS(2575),
    [anon_sym_GT_EQ] = ACTIONS(2575),
    [anon_sym_LT_LT] = ACTIONS(2577),
    [anon_sym_GT_GT] = ACTIONS(2577),
    [anon_sym_PLUS] = ACTIONS(2579),
    [anon_sym_DASH] = ACTIONS(2579),
    [anon_sym_SLASH] = ACTIONS(2553),
    [anon_sym_PERCENT] = ACTIONS(2553),
    [anon_sym_DASH_DASH] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(1554),
    [anon_sym_DASH_GT] = ACTIONS(1554),
    [sym_comment] = ACTIONS(49),
  },
  [1239] = {
    [ts_builtin_sym_end] = ACTIONS(4064),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(4066),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(4066),
    [anon_sym_LPAREN] = ACTIONS(4064),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(4066),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(4066),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(4066),
    [sym_preproc_directive] = ACTIONS(4066),
    [anon_sym_typedef] = ACTIONS(4066),
    [anon_sym_extern] = ACTIONS(4066),
    [anon_sym_RBRACE] = ACTIONS(4064),
    [anon_sym_STAR] = ACTIONS(4064),
    [anon_sym_static] = ACTIONS(4066),
    [anon_sym_register] = ACTIONS(4066),
    [anon_sym_inline] = ACTIONS(4066),
    [anon_sym_const] = ACTIONS(4066),
    [anon_sym_restrict] = ACTIONS(4066),
    [anon_sym_volatile] = ACTIONS(4066),
    [anon_sym__Atomic] = ACTIONS(4066),
    [anon_sym_mutable] = ACTIONS(4066),
    [anon_sym_explicit] = ACTIONS(4066),
    [anon_sym_constexpr] = ACTIONS(4066),
    [anon_sym_unsigned] = ACTIONS(4066),
    [anon_sym_long] = ACTIONS(4066),
    [anon_sym_short] = ACTIONS(4066),
    [sym_primitive_type] = ACTIONS(4066),
    [anon_sym_enum] = ACTIONS(4066),
    [anon_sym_struct] = ACTIONS(4066),
    [anon_sym_union] = ACTIONS(4066),
    [anon_sym_AMP] = ACTIONS(4066),
    [anon_sym_AMP_AMP] = ACTIONS(4064),
    [anon_sym_TILDE] = ACTIONS(4064),
    [sym_identifier] = ACTIONS(4066),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(4066),
    [sym_auto] = ACTIONS(4066),
    [anon_sym_typename] = ACTIONS(4066),
    [anon_sym_template] = ACTIONS(4066),
    [anon_sym_namespace] = ACTIONS(4066),
    [anon_sym_using] = ACTIONS(4066),
    [anon_sym_COLON_COLON] = ACTIONS(4064),
    [sym_operator_name] = ACTIONS(4064),
  },
  [1240] = {
    [sym__expression] = STATE(1328),
    [sym_conditional_expression] = STATE(1328),
    [sym_assignment_expression] = STATE(1328),
    [sym_pointer_expression] = STATE(1328),
    [sym_logical_expression] = STATE(1328),
    [sym_bitwise_expression] = STATE(1328),
    [sym_equality_expression] = STATE(1328),
    [sym_relational_expression] = STATE(1328),
    [sym_shift_expression] = STATE(1328),
    [sym_math_expression] = STATE(1328),
    [sym_cast_expression] = STATE(1328),
    [sym_sizeof_expression] = STATE(1328),
    [sym_subscript_expression] = STATE(1328),
    [sym_call_expression] = STATE(1328),
    [sym_field_expression] = STATE(1328),
    [sym_compound_literal_expression] = STATE(1328),
    [sym_parenthesized_expression] = STATE(1328),
    [sym_concatenated_string] = STATE(1328),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(1328),
    [sym_new_expression] = STATE(1328),
    [sym_delete_expression] = STATE(1328),
    [sym_lambda_expression] = STATE(1328),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(2748),
    [anon_sym_LPAREN] = ACTIONS(1347),
    [anon_sym_STAR] = ACTIONS(1349),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_AMP] = ACTIONS(1349),
    [anon_sym_BANG] = ACTIONS(1351),
    [anon_sym_TILDE] = ACTIONS(1353),
    [anon_sym_PLUS] = ACTIONS(1355),
    [anon_sym_DASH] = ACTIONS(1355),
    [anon_sym_DASH_DASH] = ACTIONS(1357),
    [anon_sym_PLUS_PLUS] = ACTIONS(1357),
    [anon_sym_sizeof] = ACTIONS(1359),
    [sym_number_literal] = ACTIONS(2748),
    [sym_char_literal] = ACTIONS(2748),
    [sym_string_literal] = ACTIONS(1361),
    [sym_true] = ACTIONS(2750),
    [sym_false] = ACTIONS(2750),
    [sym_null] = ACTIONS(2750),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1365),
    [anon_sym_delete] = ACTIONS(1367),
    [sym_nullptr] = ACTIONS(2750),
  },
  [1241] = {
    [sym__expression] = STATE(1815),
    [sym_conditional_expression] = STATE(1815),
    [sym_assignment_expression] = STATE(1815),
    [sym_pointer_expression] = STATE(1815),
    [sym_logical_expression] = STATE(1815),
    [sym_bitwise_expression] = STATE(1815),
    [sym_equality_expression] = STATE(1815),
    [sym_relational_expression] = STATE(1815),
    [sym_shift_expression] = STATE(1815),
    [sym_math_expression] = STATE(1815),
    [sym_cast_expression] = STATE(1815),
    [sym_sizeof_expression] = STATE(1815),
    [sym_subscript_expression] = STATE(1815),
    [sym_call_expression] = STATE(1815),
    [sym_field_expression] = STATE(1815),
    [sym_compound_literal_expression] = STATE(1815),
    [sym_parenthesized_expression] = STATE(1815),
    [sym_concatenated_string] = STATE(1815),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(1815),
    [sym_new_expression] = STATE(1815),
    [sym_delete_expression] = STATE(1815),
    [sym_lambda_expression] = STATE(1815),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(4068),
    [anon_sym_LPAREN] = ACTIONS(1347),
    [anon_sym_STAR] = ACTIONS(1349),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_AMP] = ACTIONS(1349),
    [anon_sym_BANG] = ACTIONS(1351),
    [anon_sym_TILDE] = ACTIONS(1353),
    [anon_sym_PLUS] = ACTIONS(1355),
    [anon_sym_DASH] = ACTIONS(1355),
    [anon_sym_DASH_DASH] = ACTIONS(1357),
    [anon_sym_PLUS_PLUS] = ACTIONS(1357),
    [anon_sym_sizeof] = ACTIONS(1359),
    [sym_number_literal] = ACTIONS(4068),
    [sym_char_literal] = ACTIONS(4068),
    [sym_string_literal] = ACTIONS(1361),
    [sym_true] = ACTIONS(4070),
    [sym_false] = ACTIONS(4070),
    [sym_null] = ACTIONS(4070),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1365),
    [anon_sym_delete] = ACTIONS(1367),
    [sym_nullptr] = ACTIONS(4070),
  },
  [1242] = {
    [sym__expression] = STATE(1816),
    [sym_conditional_expression] = STATE(1816),
    [sym_assignment_expression] = STATE(1816),
    [sym_pointer_expression] = STATE(1816),
    [sym_logical_expression] = STATE(1816),
    [sym_bitwise_expression] = STATE(1816),
    [sym_equality_expression] = STATE(1816),
    [sym_relational_expression] = STATE(1816),
    [sym_shift_expression] = STATE(1816),
    [sym_math_expression] = STATE(1816),
    [sym_cast_expression] = STATE(1816),
    [sym_sizeof_expression] = STATE(1816),
    [sym_subscript_expression] = STATE(1816),
    [sym_call_expression] = STATE(1816),
    [sym_field_expression] = STATE(1816),
    [sym_compound_literal_expression] = STATE(1816),
    [sym_parenthesized_expression] = STATE(1816),
    [sym_concatenated_string] = STATE(1816),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(1816),
    [sym_new_expression] = STATE(1816),
    [sym_delete_expression] = STATE(1816),
    [sym_lambda_expression] = STATE(1816),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(855),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(4072),
    [anon_sym_LPAREN] = ACTIONS(1634),
    [anon_sym_STAR] = ACTIONS(1636),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_AMP] = ACTIONS(1636),
    [anon_sym_BANG] = ACTIONS(1638),
    [anon_sym_TILDE] = ACTIONS(1640),
    [anon_sym_PLUS] = ACTIONS(1642),
    [anon_sym_DASH] = ACTIONS(1642),
    [anon_sym_DASH_DASH] = ACTIONS(1644),
    [anon_sym_PLUS_PLUS] = ACTIONS(1644),
    [anon_sym_sizeof] = ACTIONS(1646),
    [sym_number_literal] = ACTIONS(4072),
    [sym_char_literal] = ACTIONS(4072),
    [sym_string_literal] = ACTIONS(1648),
    [sym_true] = ACTIONS(4074),
    [sym_false] = ACTIONS(4074),
    [sym_null] = ACTIONS(4074),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1652),
    [anon_sym_delete] = ACTIONS(1654),
    [sym_nullptr] = ACTIONS(4074),
  },
  [1243] = {
    [sym__expression] = STATE(1817),
    [sym_conditional_expression] = STATE(1817),
    [sym_assignment_expression] = STATE(1817),
    [sym_pointer_expression] = STATE(1817),
    [sym_logical_expression] = STATE(1817),
    [sym_bitwise_expression] = STATE(1817),
    [sym_equality_expression] = STATE(1817),
    [sym_relational_expression] = STATE(1817),
    [sym_shift_expression] = STATE(1817),
    [sym_math_expression] = STATE(1817),
    [sym_cast_expression] = STATE(1817),
    [sym_sizeof_expression] = STATE(1817),
    [sym_subscript_expression] = STATE(1817),
    [sym_call_expression] = STATE(1817),
    [sym_field_expression] = STATE(1817),
    [sym_compound_literal_expression] = STATE(1817),
    [sym_parenthesized_expression] = STATE(1817),
    [sym_concatenated_string] = STATE(1817),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(1817),
    [sym_new_expression] = STATE(1817),
    [sym_delete_expression] = STATE(1817),
    [sym_lambda_expression] = STATE(1817),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(4076),
    [anon_sym_LPAREN] = ACTIONS(1347),
    [anon_sym_STAR] = ACTIONS(1349),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_AMP] = ACTIONS(1349),
    [anon_sym_BANG] = ACTIONS(1351),
    [anon_sym_TILDE] = ACTIONS(1353),
    [anon_sym_PLUS] = ACTIONS(1355),
    [anon_sym_DASH] = ACTIONS(1355),
    [anon_sym_DASH_DASH] = ACTIONS(1357),
    [anon_sym_PLUS_PLUS] = ACTIONS(1357),
    [anon_sym_sizeof] = ACTIONS(1359),
    [sym_number_literal] = ACTIONS(4076),
    [sym_char_literal] = ACTIONS(4076),
    [sym_string_literal] = ACTIONS(1361),
    [sym_true] = ACTIONS(4078),
    [sym_false] = ACTIONS(4078),
    [sym_null] = ACTIONS(4078),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1365),
    [anon_sym_delete] = ACTIONS(1367),
    [sym_nullptr] = ACTIONS(4078),
  },
  [1244] = {
    [sym__expression] = STATE(1818),
    [sym_conditional_expression] = STATE(1818),
    [sym_assignment_expression] = STATE(1818),
    [sym_pointer_expression] = STATE(1818),
    [sym_logical_expression] = STATE(1818),
    [sym_bitwise_expression] = STATE(1818),
    [sym_equality_expression] = STATE(1818),
    [sym_relational_expression] = STATE(1818),
    [sym_shift_expression] = STATE(1818),
    [sym_math_expression] = STATE(1818),
    [sym_cast_expression] = STATE(1818),
    [sym_sizeof_expression] = STATE(1818),
    [sym_subscript_expression] = STATE(1818),
    [sym_call_expression] = STATE(1818),
    [sym_field_expression] = STATE(1818),
    [sym_compound_literal_expression] = STATE(1818),
    [sym_parenthesized_expression] = STATE(1818),
    [sym_concatenated_string] = STATE(1818),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(1818),
    [sym_new_expression] = STATE(1818),
    [sym_delete_expression] = STATE(1818),
    [sym_lambda_expression] = STATE(1818),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(4080),
    [anon_sym_LPAREN] = ACTIONS(1347),
    [anon_sym_STAR] = ACTIONS(1349),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_AMP] = ACTIONS(1349),
    [anon_sym_BANG] = ACTIONS(1351),
    [anon_sym_TILDE] = ACTIONS(1353),
    [anon_sym_PLUS] = ACTIONS(1355),
    [anon_sym_DASH] = ACTIONS(1355),
    [anon_sym_DASH_DASH] = ACTIONS(1357),
    [anon_sym_PLUS_PLUS] = ACTIONS(1357),
    [anon_sym_sizeof] = ACTIONS(1359),
    [sym_number_literal] = ACTIONS(4080),
    [sym_char_literal] = ACTIONS(4080),
    [sym_string_literal] = ACTIONS(1361),
    [sym_true] = ACTIONS(4082),
    [sym_false] = ACTIONS(4082),
    [sym_null] = ACTIONS(4082),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1365),
    [anon_sym_delete] = ACTIONS(1367),
    [sym_nullptr] = ACTIONS(4082),
  },
  [1245] = {
    [sym__expression] = STATE(1819),
    [sym_conditional_expression] = STATE(1819),
    [sym_assignment_expression] = STATE(1819),
    [sym_pointer_expression] = STATE(1819),
    [sym_logical_expression] = STATE(1819),
    [sym_bitwise_expression] = STATE(1819),
    [sym_equality_expression] = STATE(1819),
    [sym_relational_expression] = STATE(1819),
    [sym_shift_expression] = STATE(1819),
    [sym_math_expression] = STATE(1819),
    [sym_cast_expression] = STATE(1819),
    [sym_sizeof_expression] = STATE(1819),
    [sym_subscript_expression] = STATE(1819),
    [sym_call_expression] = STATE(1819),
    [sym_field_expression] = STATE(1819),
    [sym_compound_literal_expression] = STATE(1819),
    [sym_parenthesized_expression] = STATE(1819),
    [sym_concatenated_string] = STATE(1819),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(1819),
    [sym_new_expression] = STATE(1819),
    [sym_delete_expression] = STATE(1819),
    [sym_lambda_expression] = STATE(1819),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(4084),
    [anon_sym_LPAREN] = ACTIONS(1347),
    [anon_sym_STAR] = ACTIONS(1349),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_AMP] = ACTIONS(1349),
    [anon_sym_BANG] = ACTIONS(1351),
    [anon_sym_TILDE] = ACTIONS(1353),
    [anon_sym_PLUS] = ACTIONS(1355),
    [anon_sym_DASH] = ACTIONS(1355),
    [anon_sym_DASH_DASH] = ACTIONS(1357),
    [anon_sym_PLUS_PLUS] = ACTIONS(1357),
    [anon_sym_sizeof] = ACTIONS(1359),
    [sym_number_literal] = ACTIONS(4084),
    [sym_char_literal] = ACTIONS(4084),
    [sym_string_literal] = ACTIONS(1361),
    [sym_true] = ACTIONS(4086),
    [sym_false] = ACTIONS(4086),
    [sym_null] = ACTIONS(4086),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1365),
    [anon_sym_delete] = ACTIONS(1367),
    [sym_nullptr] = ACTIONS(4086),
  },
  [1246] = {
    [sym__expression] = STATE(1820),
    [sym_conditional_expression] = STATE(1820),
    [sym_assignment_expression] = STATE(1820),
    [sym_pointer_expression] = STATE(1820),
    [sym_logical_expression] = STATE(1820),
    [sym_bitwise_expression] = STATE(1820),
    [sym_equality_expression] = STATE(1820),
    [sym_relational_expression] = STATE(1820),
    [sym_shift_expression] = STATE(1820),
    [sym_math_expression] = STATE(1820),
    [sym_cast_expression] = STATE(1820),
    [sym_sizeof_expression] = STATE(1820),
    [sym_subscript_expression] = STATE(1820),
    [sym_call_expression] = STATE(1820),
    [sym_field_expression] = STATE(1820),
    [sym_compound_literal_expression] = STATE(1820),
    [sym_parenthesized_expression] = STATE(1820),
    [sym_concatenated_string] = STATE(1820),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(1820),
    [sym_new_expression] = STATE(1820),
    [sym_delete_expression] = STATE(1820),
    [sym_lambda_expression] = STATE(1820),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(4088),
    [anon_sym_LPAREN] = ACTIONS(1347),
    [anon_sym_STAR] = ACTIONS(1349),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_AMP] = ACTIONS(1349),
    [anon_sym_BANG] = ACTIONS(1351),
    [anon_sym_TILDE] = ACTIONS(1353),
    [anon_sym_PLUS] = ACTIONS(1355),
    [anon_sym_DASH] = ACTIONS(1355),
    [anon_sym_DASH_DASH] = ACTIONS(1357),
    [anon_sym_PLUS_PLUS] = ACTIONS(1357),
    [anon_sym_sizeof] = ACTIONS(1359),
    [sym_number_literal] = ACTIONS(4088),
    [sym_char_literal] = ACTIONS(4088),
    [sym_string_literal] = ACTIONS(1361),
    [sym_true] = ACTIONS(4090),
    [sym_false] = ACTIONS(4090),
    [sym_null] = ACTIONS(4090),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1365),
    [anon_sym_delete] = ACTIONS(1367),
    [sym_nullptr] = ACTIONS(4090),
  },
  [1247] = {
    [sym__expression] = STATE(1821),
    [sym_conditional_expression] = STATE(1821),
    [sym_assignment_expression] = STATE(1821),
    [sym_pointer_expression] = STATE(1821),
    [sym_logical_expression] = STATE(1821),
    [sym_bitwise_expression] = STATE(1821),
    [sym_equality_expression] = STATE(1821),
    [sym_relational_expression] = STATE(1821),
    [sym_shift_expression] = STATE(1821),
    [sym_math_expression] = STATE(1821),
    [sym_cast_expression] = STATE(1821),
    [sym_sizeof_expression] = STATE(1821),
    [sym_subscript_expression] = STATE(1821),
    [sym_call_expression] = STATE(1821),
    [sym_field_expression] = STATE(1821),
    [sym_compound_literal_expression] = STATE(1821),
    [sym_parenthesized_expression] = STATE(1821),
    [sym_concatenated_string] = STATE(1821),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(1821),
    [sym_new_expression] = STATE(1821),
    [sym_delete_expression] = STATE(1821),
    [sym_lambda_expression] = STATE(1821),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(4092),
    [anon_sym_LPAREN] = ACTIONS(1347),
    [anon_sym_STAR] = ACTIONS(1349),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_AMP] = ACTIONS(1349),
    [anon_sym_BANG] = ACTIONS(1351),
    [anon_sym_TILDE] = ACTIONS(1353),
    [anon_sym_PLUS] = ACTIONS(1355),
    [anon_sym_DASH] = ACTIONS(1355),
    [anon_sym_DASH_DASH] = ACTIONS(1357),
    [anon_sym_PLUS_PLUS] = ACTIONS(1357),
    [anon_sym_sizeof] = ACTIONS(1359),
    [sym_number_literal] = ACTIONS(4092),
    [sym_char_literal] = ACTIONS(4092),
    [sym_string_literal] = ACTIONS(1361),
    [sym_true] = ACTIONS(4094),
    [sym_false] = ACTIONS(4094),
    [sym_null] = ACTIONS(4094),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1365),
    [anon_sym_delete] = ACTIONS(1367),
    [sym_nullptr] = ACTIONS(4094),
  },
  [1248] = {
    [sym__expression] = STATE(1822),
    [sym_conditional_expression] = STATE(1822),
    [sym_assignment_expression] = STATE(1822),
    [sym_pointer_expression] = STATE(1822),
    [sym_logical_expression] = STATE(1822),
    [sym_bitwise_expression] = STATE(1822),
    [sym_equality_expression] = STATE(1822),
    [sym_relational_expression] = STATE(1822),
    [sym_shift_expression] = STATE(1822),
    [sym_math_expression] = STATE(1822),
    [sym_cast_expression] = STATE(1822),
    [sym_sizeof_expression] = STATE(1822),
    [sym_subscript_expression] = STATE(1822),
    [sym_call_expression] = STATE(1822),
    [sym_field_expression] = STATE(1822),
    [sym_compound_literal_expression] = STATE(1822),
    [sym_parenthesized_expression] = STATE(1822),
    [sym_concatenated_string] = STATE(1822),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(1822),
    [sym_new_expression] = STATE(1822),
    [sym_delete_expression] = STATE(1822),
    [sym_lambda_expression] = STATE(1822),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(4096),
    [anon_sym_LPAREN] = ACTIONS(1347),
    [anon_sym_STAR] = ACTIONS(1349),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_AMP] = ACTIONS(1349),
    [anon_sym_BANG] = ACTIONS(1351),
    [anon_sym_TILDE] = ACTIONS(1353),
    [anon_sym_PLUS] = ACTIONS(1355),
    [anon_sym_DASH] = ACTIONS(1355),
    [anon_sym_DASH_DASH] = ACTIONS(1357),
    [anon_sym_PLUS_PLUS] = ACTIONS(1357),
    [anon_sym_sizeof] = ACTIONS(1359),
    [sym_number_literal] = ACTIONS(4096),
    [sym_char_literal] = ACTIONS(4096),
    [sym_string_literal] = ACTIONS(1361),
    [sym_true] = ACTIONS(4098),
    [sym_false] = ACTIONS(4098),
    [sym_null] = ACTIONS(4098),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1365),
    [anon_sym_delete] = ACTIONS(1367),
    [sym_nullptr] = ACTIONS(4098),
  },
  [1249] = {
    [sym__expression] = STATE(1823),
    [sym_conditional_expression] = STATE(1823),
    [sym_assignment_expression] = STATE(1823),
    [sym_pointer_expression] = STATE(1823),
    [sym_logical_expression] = STATE(1823),
    [sym_bitwise_expression] = STATE(1823),
    [sym_equality_expression] = STATE(1823),
    [sym_relational_expression] = STATE(1823),
    [sym_shift_expression] = STATE(1823),
    [sym_math_expression] = STATE(1823),
    [sym_cast_expression] = STATE(1823),
    [sym_sizeof_expression] = STATE(1823),
    [sym_subscript_expression] = STATE(1823),
    [sym_call_expression] = STATE(1823),
    [sym_field_expression] = STATE(1823),
    [sym_compound_literal_expression] = STATE(1823),
    [sym_parenthesized_expression] = STATE(1823),
    [sym_concatenated_string] = STATE(1823),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(1823),
    [sym_new_expression] = STATE(1823),
    [sym_delete_expression] = STATE(1823),
    [sym_lambda_expression] = STATE(1823),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(4100),
    [anon_sym_LPAREN] = ACTIONS(1347),
    [anon_sym_STAR] = ACTIONS(1349),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_AMP] = ACTIONS(1349),
    [anon_sym_BANG] = ACTIONS(1351),
    [anon_sym_TILDE] = ACTIONS(1353),
    [anon_sym_PLUS] = ACTIONS(1355),
    [anon_sym_DASH] = ACTIONS(1355),
    [anon_sym_DASH_DASH] = ACTIONS(1357),
    [anon_sym_PLUS_PLUS] = ACTIONS(1357),
    [anon_sym_sizeof] = ACTIONS(1359),
    [sym_number_literal] = ACTIONS(4100),
    [sym_char_literal] = ACTIONS(4100),
    [sym_string_literal] = ACTIONS(1361),
    [sym_true] = ACTIONS(4102),
    [sym_false] = ACTIONS(4102),
    [sym_null] = ACTIONS(4102),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1365),
    [anon_sym_delete] = ACTIONS(1367),
    [sym_nullptr] = ACTIONS(4102),
  },
  [1250] = {
    [sym__expression] = STATE(1824),
    [sym_conditional_expression] = STATE(1824),
    [sym_assignment_expression] = STATE(1824),
    [sym_pointer_expression] = STATE(1824),
    [sym_logical_expression] = STATE(1824),
    [sym_bitwise_expression] = STATE(1824),
    [sym_equality_expression] = STATE(1824),
    [sym_relational_expression] = STATE(1824),
    [sym_shift_expression] = STATE(1824),
    [sym_math_expression] = STATE(1824),
    [sym_cast_expression] = STATE(1824),
    [sym_sizeof_expression] = STATE(1824),
    [sym_subscript_expression] = STATE(1824),
    [sym_call_expression] = STATE(1824),
    [sym_field_expression] = STATE(1824),
    [sym_compound_literal_expression] = STATE(1824),
    [sym_parenthesized_expression] = STATE(1824),
    [sym_concatenated_string] = STATE(1824),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(1824),
    [sym_new_expression] = STATE(1824),
    [sym_delete_expression] = STATE(1824),
    [sym_lambda_expression] = STATE(1824),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(4104),
    [anon_sym_LPAREN] = ACTIONS(1347),
    [anon_sym_STAR] = ACTIONS(1349),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_AMP] = ACTIONS(1349),
    [anon_sym_BANG] = ACTIONS(1351),
    [anon_sym_TILDE] = ACTIONS(1353),
    [anon_sym_PLUS] = ACTIONS(1355),
    [anon_sym_DASH] = ACTIONS(1355),
    [anon_sym_DASH_DASH] = ACTIONS(1357),
    [anon_sym_PLUS_PLUS] = ACTIONS(1357),
    [anon_sym_sizeof] = ACTIONS(1359),
    [sym_number_literal] = ACTIONS(4104),
    [sym_char_literal] = ACTIONS(4104),
    [sym_string_literal] = ACTIONS(1361),
    [sym_true] = ACTIONS(4106),
    [sym_false] = ACTIONS(4106),
    [sym_null] = ACTIONS(4106),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1365),
    [anon_sym_delete] = ACTIONS(1367),
    [sym_nullptr] = ACTIONS(4106),
  },
  [1251] = {
    [sym__expression] = STATE(1825),
    [sym_conditional_expression] = STATE(1825),
    [sym_assignment_expression] = STATE(1825),
    [sym_pointer_expression] = STATE(1825),
    [sym_logical_expression] = STATE(1825),
    [sym_bitwise_expression] = STATE(1825),
    [sym_equality_expression] = STATE(1825),
    [sym_relational_expression] = STATE(1825),
    [sym_shift_expression] = STATE(1825),
    [sym_math_expression] = STATE(1825),
    [sym_cast_expression] = STATE(1825),
    [sym_sizeof_expression] = STATE(1825),
    [sym_subscript_expression] = STATE(1825),
    [sym_call_expression] = STATE(1825),
    [sym_field_expression] = STATE(1825),
    [sym_compound_literal_expression] = STATE(1825),
    [sym_parenthesized_expression] = STATE(1825),
    [sym_concatenated_string] = STATE(1825),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(1825),
    [sym_new_expression] = STATE(1825),
    [sym_delete_expression] = STATE(1825),
    [sym_lambda_expression] = STATE(1825),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(4108),
    [anon_sym_LPAREN] = ACTIONS(1347),
    [anon_sym_STAR] = ACTIONS(1349),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_AMP] = ACTIONS(1349),
    [anon_sym_BANG] = ACTIONS(1351),
    [anon_sym_TILDE] = ACTIONS(1353),
    [anon_sym_PLUS] = ACTIONS(1355),
    [anon_sym_DASH] = ACTIONS(1355),
    [anon_sym_DASH_DASH] = ACTIONS(1357),
    [anon_sym_PLUS_PLUS] = ACTIONS(1357),
    [anon_sym_sizeof] = ACTIONS(1359),
    [sym_number_literal] = ACTIONS(4108),
    [sym_char_literal] = ACTIONS(4108),
    [sym_string_literal] = ACTIONS(1361),
    [sym_true] = ACTIONS(4110),
    [sym_false] = ACTIONS(4110),
    [sym_null] = ACTIONS(4110),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1365),
    [anon_sym_delete] = ACTIONS(1367),
    [sym_nullptr] = ACTIONS(4110),
  },
  [1252] = {
    [ts_builtin_sym_end] = ACTIONS(4112),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(4114),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(4114),
    [anon_sym_LPAREN] = ACTIONS(4112),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(4114),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(4114),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(4114),
    [sym_preproc_directive] = ACTIONS(4114),
    [anon_sym_typedef] = ACTIONS(4114),
    [anon_sym_extern] = ACTIONS(4114),
    [anon_sym_RBRACE] = ACTIONS(4112),
    [anon_sym_STAR] = ACTIONS(4112),
    [anon_sym_static] = ACTIONS(4114),
    [anon_sym_register] = ACTIONS(4114),
    [anon_sym_inline] = ACTIONS(4114),
    [anon_sym_const] = ACTIONS(4114),
    [anon_sym_restrict] = ACTIONS(4114),
    [anon_sym_volatile] = ACTIONS(4114),
    [anon_sym__Atomic] = ACTIONS(4114),
    [anon_sym_mutable] = ACTIONS(4114),
    [anon_sym_explicit] = ACTIONS(4114),
    [anon_sym_constexpr] = ACTIONS(4114),
    [anon_sym_unsigned] = ACTIONS(4114),
    [anon_sym_long] = ACTIONS(4114),
    [anon_sym_short] = ACTIONS(4114),
    [sym_primitive_type] = ACTIONS(4114),
    [anon_sym_enum] = ACTIONS(4114),
    [anon_sym_struct] = ACTIONS(4114),
    [anon_sym_union] = ACTIONS(4114),
    [anon_sym_AMP] = ACTIONS(4114),
    [anon_sym_AMP_AMP] = ACTIONS(4112),
    [anon_sym_TILDE] = ACTIONS(4112),
    [sym_identifier] = ACTIONS(4114),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(4114),
    [sym_auto] = ACTIONS(4114),
    [anon_sym_typename] = ACTIONS(4114),
    [anon_sym_template] = ACTIONS(4114),
    [anon_sym_namespace] = ACTIONS(4114),
    [anon_sym_using] = ACTIONS(4114),
    [anon_sym_COLON_COLON] = ACTIONS(4112),
    [sym_operator_name] = ACTIONS(4112),
  },
  [1253] = {
    [anon_sym_COMMA] = ACTIONS(4116),
    [anon_sym_RPAREN] = ACTIONS(4116),
    [sym_comment] = ACTIONS(49),
  },
  [1254] = {
    [anon_sym_LPAREN] = ACTIONS(4118),
    [anon_sym_COMMA] = ACTIONS(4118),
    [anon_sym_RPAREN] = ACTIONS(4118),
    [anon_sym_SEMI] = ACTIONS(4118),
    [anon_sym_LBRACE] = ACTIONS(4118),
    [anon_sym_LBRACK] = ACTIONS(4118),
    [anon_sym_EQ] = ACTIONS(4118),
    [anon_sym_const] = ACTIONS(4120),
    [anon_sym_restrict] = ACTIONS(4118),
    [anon_sym_volatile] = ACTIONS(4118),
    [anon_sym__Atomic] = ACTIONS(4118),
    [anon_sym_mutable] = ACTIONS(4118),
    [anon_sym_explicit] = ACTIONS(4118),
    [anon_sym_constexpr] = ACTIONS(4118),
    [anon_sym_COLON] = ACTIONS(4118),
    [anon_sym_GT] = ACTIONS(4118),
    [anon_sym_DASH_GT] = ACTIONS(4118),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(4118),
  },
  [1255] = {
    [aux_sym_parameter_list_repeat1] = STATE(1255),
    [anon_sym_COMMA] = ACTIONS(4122),
    [anon_sym_RPAREN] = ACTIONS(4116),
    [sym_comment] = ACTIONS(49),
  },
  [1256] = {
    [sym_parameter_list] = STATE(1261),
    [anon_sym_LPAREN] = ACTIONS(206),
    [anon_sym_COMMA] = ACTIONS(837),
    [anon_sym_RPAREN] = ACTIONS(837),
    [anon_sym_LBRACE] = ACTIONS(837),
    [anon_sym_LBRACK] = ACTIONS(208),
    [anon_sym_EQ] = ACTIONS(837),
    [sym_comment] = ACTIONS(49),
  },
  [1257] = {
    [sym_parameter_list] = STATE(1262),
    [anon_sym_LPAREN] = ACTIONS(206),
    [anon_sym_COMMA] = ACTIONS(3750),
    [anon_sym_RPAREN] = ACTIONS(3750),
    [anon_sym_LBRACK] = ACTIONS(2282),
    [sym_comment] = ACTIONS(49),
  },
  [1258] = {
    [sym_parameter_list] = STATE(1261),
    [anon_sym_LPAREN] = ACTIONS(206),
    [anon_sym_COMMA] = ACTIONS(839),
    [anon_sym_RPAREN] = ACTIONS(839),
    [anon_sym_LBRACE] = ACTIONS(839),
    [anon_sym_LBRACK] = ACTIONS(208),
    [anon_sym_EQ] = ACTIONS(839),
    [sym_comment] = ACTIONS(49),
  },
  [1259] = {
    [sym_parameter_list] = STATE(1262),
    [anon_sym_LPAREN] = ACTIONS(206),
    [anon_sym_COMMA] = ACTIONS(3762),
    [anon_sym_RPAREN] = ACTIONS(3762),
    [anon_sym_LBRACK] = ACTIONS(2282),
    [sym_comment] = ACTIONS(49),
  },
  [1260] = {
    [sym__expression] = STATE(1826),
    [sym_conditional_expression] = STATE(1826),
    [sym_assignment_expression] = STATE(1826),
    [sym_pointer_expression] = STATE(1826),
    [sym_logical_expression] = STATE(1826),
    [sym_bitwise_expression] = STATE(1826),
    [sym_equality_expression] = STATE(1826),
    [sym_relational_expression] = STATE(1826),
    [sym_shift_expression] = STATE(1826),
    [sym_math_expression] = STATE(1826),
    [sym_cast_expression] = STATE(1826),
    [sym_sizeof_expression] = STATE(1826),
    [sym_subscript_expression] = STATE(1826),
    [sym_call_expression] = STATE(1826),
    [sym_field_expression] = STATE(1826),
    [sym_compound_literal_expression] = STATE(1826),
    [sym_parenthesized_expression] = STATE(1826),
    [sym_initializer_list] = STATE(674),
    [sym_concatenated_string] = STATE(1826),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(1826),
    [sym_new_expression] = STATE(1826),
    [sym_delete_expression] = STATE(1826),
    [sym_lambda_expression] = STATE(1826),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(4125),
    [anon_sym_LPAREN] = ACTIONS(1087),
    [anon_sym_LBRACE] = ACTIONS(548),
    [anon_sym_STAR] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_AMP] = ACTIONS(1089),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1093),
    [anon_sym_PLUS] = ACTIONS(1095),
    [anon_sym_DASH] = ACTIONS(1095),
    [anon_sym_DASH_DASH] = ACTIONS(1097),
    [anon_sym_PLUS_PLUS] = ACTIONS(1097),
    [anon_sym_sizeof] = ACTIONS(1099),
    [sym_number_literal] = ACTIONS(4125),
    [sym_char_literal] = ACTIONS(4125),
    [sym_string_literal] = ACTIONS(1101),
    [sym_true] = ACTIONS(4127),
    [sym_false] = ACTIONS(4127),
    [sym_null] = ACTIONS(4127),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_delete] = ACTIONS(1109),
    [sym_nullptr] = ACTIONS(4127),
  },
  [1261] = {
    [sym_type_qualifier] = STATE(1828),
    [sym_trailing_return_type] = STATE(1828),
    [aux_sym_function_declarator_repeat1] = STATE(1828),
    [anon_sym_LPAREN] = ACTIONS(610),
    [anon_sym_COMMA] = ACTIONS(610),
    [anon_sym_RPAREN] = ACTIONS(610),
    [anon_sym_LBRACE] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(610),
    [anon_sym_EQ] = ACTIONS(610),
    [anon_sym_const] = ACTIONS(612),
    [anon_sym_restrict] = ACTIONS(614),
    [anon_sym_volatile] = ACTIONS(614),
    [anon_sym__Atomic] = ACTIONS(614),
    [anon_sym_mutable] = ACTIONS(614),
    [anon_sym_explicit] = ACTIONS(614),
    [anon_sym_constexpr] = ACTIONS(614),
    [anon_sym_DASH_GT] = ACTIONS(4129),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(4131),
  },
  [1262] = {
    [sym_type_qualifier] = STATE(1829),
    [sym_trailing_return_type] = STATE(1713),
    [aux_sym_abstract_function_declarator_repeat1] = STATE(1829),
    [anon_sym_LPAREN] = ACTIONS(3764),
    [anon_sym_COMMA] = ACTIONS(3764),
    [anon_sym_RPAREN] = ACTIONS(3764),
    [anon_sym_LBRACK] = ACTIONS(3764),
    [anon_sym_const] = ACTIONS(612),
    [anon_sym_restrict] = ACTIONS(614),
    [anon_sym_volatile] = ACTIONS(614),
    [anon_sym__Atomic] = ACTIONS(614),
    [anon_sym_mutable] = ACTIONS(614),
    [anon_sym_explicit] = ACTIONS(614),
    [anon_sym_constexpr] = ACTIONS(614),
    [anon_sym_DASH_GT] = ACTIONS(2605),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(4133),
  },
  [1263] = {
    [sym__type_specifier] = STATE(1831),
    [sym_sized_type_specifier] = STATE(1831),
    [sym_enum_specifier] = STATE(1831),
    [sym_struct_specifier] = STATE(1831),
    [sym_union_specifier] = STATE(1831),
    [sym_macro_type_specifier] = STATE(1831),
    [sym_class_specifier] = STATE(1831),
    [sym_dependent_type] = STATE(1831),
    [sym_template_type] = STATE(62),
    [sym_scoped_type_identifier] = STATE(34),
    [sym_scoped_namespace_identifier] = STATE(64),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1832),
    [anon_sym_unsigned] = ACTIONS(4135),
    [anon_sym_long] = ACTIONS(4135),
    [anon_sym_short] = ACTIONS(4135),
    [sym_primitive_type] = ACTIONS(4137),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(428),
    [anon_sym_union] = ACTIONS(430),
    [sym_identifier] = ACTIONS(434),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(436),
    [sym_auto] = ACTIONS(4137),
    [anon_sym_typename] = ACTIONS(4139),
    [anon_sym_COLON_COLON] = ACTIONS(111),
  },
  [1264] = {
    [sym_type_qualifier] = STATE(1833),
    [sym_trailing_return_type] = STATE(1713),
    [aux_sym_abstract_function_declarator_repeat1] = STATE(1833),
    [anon_sym_LPAREN] = ACTIONS(3764),
    [anon_sym_COMMA] = ACTIONS(3764),
    [anon_sym_RPAREN] = ACTIONS(3764),
    [anon_sym_LBRACK] = ACTIONS(3764),
    [anon_sym_const] = ACTIONS(612),
    [anon_sym_restrict] = ACTIONS(614),
    [anon_sym_volatile] = ACTIONS(614),
    [anon_sym__Atomic] = ACTIONS(614),
    [anon_sym_mutable] = ACTIONS(614),
    [anon_sym_explicit] = ACTIONS(614),
    [anon_sym_constexpr] = ACTIONS(614),
    [anon_sym_DASH_GT] = ACTIONS(2605),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(4141),
  },
  [1265] = {
    [sym_storage_class_specifier] = STATE(1265),
    [sym_type_qualifier] = STATE(1265),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1265),
    [anon_sym_LPAREN] = ACTIONS(798),
    [anon_sym_COMMA] = ACTIONS(798),
    [anon_sym_RPAREN] = ACTIONS(798),
    [anon_sym_extern] = ACTIONS(1792),
    [anon_sym_STAR] = ACTIONS(798),
    [anon_sym_LBRACK] = ACTIONS(798),
    [anon_sym_static] = ACTIONS(1792),
    [anon_sym_register] = ACTIONS(1792),
    [anon_sym_inline] = ACTIONS(1792),
    [anon_sym_const] = ACTIONS(1795),
    [anon_sym_restrict] = ACTIONS(1795),
    [anon_sym_volatile] = ACTIONS(1795),
    [anon_sym__Atomic] = ACTIONS(1795),
    [anon_sym_mutable] = ACTIONS(1795),
    [anon_sym_explicit] = ACTIONS(1795),
    [anon_sym_constexpr] = ACTIONS(1795),
    [anon_sym_AMP] = ACTIONS(806),
    [anon_sym_AMP_AMP] = ACTIONS(798),
    [anon_sym_TILDE] = ACTIONS(798),
    [sym_identifier] = ACTIONS(806),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(798),
    [sym_operator_name] = ACTIONS(798),
  },
  [1266] = {
    [sym_storage_class_specifier] = STATE(1265),
    [sym_type_qualifier] = STATE(1265),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1265),
    [anon_sym_LPAREN] = ACTIONS(1811),
    [anon_sym_COMMA] = ACTIONS(1811),
    [anon_sym_RPAREN] = ACTIONS(1811),
    [anon_sym_extern] = ACTIONS(218),
    [anon_sym_STAR] = ACTIONS(1811),
    [anon_sym_LBRACK] = ACTIONS(1811),
    [anon_sym_static] = ACTIONS(218),
    [anon_sym_register] = ACTIONS(218),
    [anon_sym_inline] = ACTIONS(218),
    [anon_sym_const] = ACTIONS(220),
    [anon_sym_restrict] = ACTIONS(220),
    [anon_sym_volatile] = ACTIONS(220),
    [anon_sym__Atomic] = ACTIONS(220),
    [anon_sym_mutable] = ACTIONS(220),
    [anon_sym_explicit] = ACTIONS(220),
    [anon_sym_constexpr] = ACTIONS(220),
    [anon_sym_AMP] = ACTIONS(1813),
    [anon_sym_AMP_AMP] = ACTIONS(1811),
    [anon_sym_TILDE] = ACTIONS(1811),
    [sym_identifier] = ACTIONS(1813),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(1811),
    [sym_operator_name] = ACTIONS(1811),
  },
  [1267] = {
    [sym_parameter_list] = STATE(1707),
    [anon_sym_LPAREN] = ACTIONS(206),
    [anon_sym_RPAREN] = ACTIONS(2280),
    [anon_sym_LBRACK] = ACTIONS(2282),
    [sym_comment] = ACTIONS(49),
  },
  [1268] = {
    [anon_sym_LPAREN] = ACTIONS(3696),
    [anon_sym_COMMA] = ACTIONS(3696),
    [anon_sym_RPAREN] = ACTIONS(3696),
    [anon_sym_SEMI] = ACTIONS(3696),
    [anon_sym_RBRACE] = ACTIONS(3696),
    [anon_sym_STAR] = ACTIONS(4143),
    [anon_sym_LBRACK] = ACTIONS(3696),
    [anon_sym_RBRACK] = ACTIONS(3696),
    [anon_sym_EQ] = ACTIONS(4143),
    [anon_sym_COLON] = ACTIONS(3696),
    [anon_sym_QMARK] = ACTIONS(3696),
    [anon_sym_STAR_EQ] = ACTIONS(3696),
    [anon_sym_SLASH_EQ] = ACTIONS(3696),
    [anon_sym_PERCENT_EQ] = ACTIONS(3696),
    [anon_sym_PLUS_EQ] = ACTIONS(3696),
    [anon_sym_DASH_EQ] = ACTIONS(3696),
    [anon_sym_LT_LT_EQ] = ACTIONS(3696),
    [anon_sym_GT_GT_EQ] = ACTIONS(3696),
    [anon_sym_AMP_EQ] = ACTIONS(3696),
    [anon_sym_CARET_EQ] = ACTIONS(3696),
    [anon_sym_PIPE_EQ] = ACTIONS(3696),
    [anon_sym_AMP] = ACTIONS(4143),
    [anon_sym_PIPE_PIPE] = ACTIONS(3696),
    [anon_sym_AMP_AMP] = ACTIONS(3696),
    [anon_sym_PIPE] = ACTIONS(4143),
    [anon_sym_CARET] = ACTIONS(4143),
    [anon_sym_EQ_EQ] = ACTIONS(3696),
    [anon_sym_BANG_EQ] = ACTIONS(3696),
    [anon_sym_LT] = ACTIONS(4143),
    [anon_sym_GT] = ACTIONS(4143),
    [anon_sym_LT_EQ] = ACTIONS(3696),
    [anon_sym_GT_EQ] = ACTIONS(3696),
    [anon_sym_LT_LT] = ACTIONS(4143),
    [anon_sym_GT_GT] = ACTIONS(4143),
    [anon_sym_PLUS] = ACTIONS(4143),
    [anon_sym_DASH] = ACTIONS(4143),
    [anon_sym_SLASH] = ACTIONS(4143),
    [anon_sym_PERCENT] = ACTIONS(4143),
    [anon_sym_DASH_DASH] = ACTIONS(3696),
    [anon_sym_PLUS_PLUS] = ACTIONS(3696),
    [anon_sym_DOT] = ACTIONS(3696),
    [anon_sym_DASH_GT] = ACTIONS(3696),
    [sym_comment] = ACTIONS(49),
  },
  [1269] = {
    [sym__expression] = STATE(1834),
    [sym_conditional_expression] = STATE(1834),
    [sym_assignment_expression] = STATE(1834),
    [sym_pointer_expression] = STATE(1834),
    [sym_logical_expression] = STATE(1834),
    [sym_bitwise_expression] = STATE(1834),
    [sym_equality_expression] = STATE(1834),
    [sym_relational_expression] = STATE(1834),
    [sym_shift_expression] = STATE(1834),
    [sym_math_expression] = STATE(1834),
    [sym_cast_expression] = STATE(1834),
    [sym_sizeof_expression] = STATE(1834),
    [sym_subscript_expression] = STATE(1834),
    [sym_call_expression] = STATE(1834),
    [sym_field_expression] = STATE(1834),
    [sym_compound_literal_expression] = STATE(1834),
    [sym_parenthesized_expression] = STATE(1834),
    [sym_initializer_list] = STATE(1835),
    [sym_concatenated_string] = STATE(1834),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(1834),
    [sym_new_expression] = STATE(1834),
    [sym_delete_expression] = STATE(1834),
    [sym_lambda_expression] = STATE(1834),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(4145),
    [anon_sym_LPAREN] = ACTIONS(566),
    [anon_sym_LBRACE] = ACTIONS(548),
    [anon_sym_STAR] = ACTIONS(568),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_AMP] = ACTIONS(568),
    [anon_sym_BANG] = ACTIONS(584),
    [anon_sym_TILDE] = ACTIONS(586),
    [anon_sym_PLUS] = ACTIONS(588),
    [anon_sym_DASH] = ACTIONS(588),
    [anon_sym_DASH_DASH] = ACTIONS(590),
    [anon_sym_PLUS_PLUS] = ACTIONS(590),
    [anon_sym_sizeof] = ACTIONS(592),
    [sym_number_literal] = ACTIONS(4145),
    [sym_char_literal] = ACTIONS(4145),
    [sym_string_literal] = ACTIONS(594),
    [sym_true] = ACTIONS(4147),
    [sym_false] = ACTIONS(4147),
    [sym_null] = ACTIONS(4147),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1415),
    [anon_sym_delete] = ACTIONS(608),
    [sym_nullptr] = ACTIONS(4147),
  },
  [1270] = {
    [sym__abstract_declarator] = STATE(1836),
    [sym_abstract_pointer_declarator] = STATE(1836),
    [sym_abstract_function_declarator] = STATE(1836),
    [sym_abstract_array_declarator] = STATE(1836),
    [sym_parameter_list] = STATE(1120),
    [sym_abstract_reference_declarator] = STATE(1836),
    [anon_sym_LPAREN] = ACTIONS(1115),
    [anon_sym_RPAREN] = ACTIONS(2280),
    [anon_sym_STAR] = ACTIONS(2264),
    [anon_sym_LBRACK] = ACTIONS(1121),
    [anon_sym_AMP] = ACTIONS(2266),
    [anon_sym_AMP_AMP] = ACTIONS(2268),
    [sym_comment] = ACTIONS(49),
  },
  [1271] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(1271),
    [anon_sym_LPAREN] = ACTIONS(816),
    [anon_sym_RPAREN] = ACTIONS(816),
    [anon_sym_STAR] = ACTIONS(816),
    [anon_sym_LBRACK] = ACTIONS(816),
    [anon_sym_unsigned] = ACTIONS(4149),
    [anon_sym_long] = ACTIONS(4149),
    [anon_sym_short] = ACTIONS(4149),
    [sym_primitive_type] = ACTIONS(818),
    [anon_sym_AMP] = ACTIONS(818),
    [anon_sym_AMP_AMP] = ACTIONS(816),
    [sym_identifier] = ACTIONS(818),
    [sym_comment] = ACTIONS(49),
  },
  [1272] = {
    [anon_sym_RPAREN] = ACTIONS(4152),
    [sym_comment] = ACTIONS(49),
  },
  [1273] = {
    [sym_type_qualifier] = STATE(724),
    [sym__type_specifier] = STATE(720),
    [sym_sized_type_specifier] = STATE(720),
    [sym_enum_specifier] = STATE(720),
    [sym_struct_specifier] = STATE(720),
    [sym_union_specifier] = STATE(720),
    [sym__expression] = STATE(721),
    [sym_comma_expression] = STATE(722),
    [sym_conditional_expression] = STATE(721),
    [sym_assignment_expression] = STATE(721),
    [sym_pointer_expression] = STATE(721),
    [sym_logical_expression] = STATE(721),
    [sym_bitwise_expression] = STATE(721),
    [sym_equality_expression] = STATE(721),
    [sym_relational_expression] = STATE(721),
    [sym_shift_expression] = STATE(721),
    [sym_math_expression] = STATE(721),
    [sym_cast_expression] = STATE(721),
    [sym_type_descriptor] = STATE(1838),
    [sym_sizeof_expression] = STATE(721),
    [sym_subscript_expression] = STATE(721),
    [sym_call_expression] = STATE(721),
    [sym_field_expression] = STATE(721),
    [sym_compound_literal_expression] = STATE(721),
    [sym_parenthesized_expression] = STATE(721),
    [sym_concatenated_string] = STATE(721),
    [sym_macro_type_specifier] = STATE(720),
    [sym_class_specifier] = STATE(720),
    [sym_dependent_type] = STATE(720),
    [sym_template_type] = STATE(415),
    [sym_template_function] = STATE(721),
    [sym_new_expression] = STATE(721),
    [sym_delete_expression] = STATE(721),
    [sym_lambda_expression] = STATE(721),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(416),
    [sym_scoped_namespace_identifier] = STATE(417),
    [aux_sym_type_definition_repeat1] = STATE(724),
    [aux_sym_sized_type_specifier_repeat1] = STATE(725),
    [sym_raw_string_literal] = ACTIONS(1397),
    [anon_sym_LPAREN] = ACTIONS(1087),
    [anon_sym_STAR] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_restrict] = ACTIONS(93),
    [anon_sym_volatile] = ACTIONS(93),
    [anon_sym__Atomic] = ACTIONS(93),
    [anon_sym_mutable] = ACTIONS(93),
    [anon_sym_explicit] = ACTIONS(93),
    [anon_sym_constexpr] = ACTIONS(93),
    [anon_sym_unsigned] = ACTIONS(1399),
    [anon_sym_long] = ACTIONS(1399),
    [anon_sym_short] = ACTIONS(1399),
    [sym_primitive_type] = ACTIONS(1401),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(428),
    [anon_sym_union] = ACTIONS(430),
    [anon_sym_AMP] = ACTIONS(1089),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1093),
    [anon_sym_PLUS] = ACTIONS(1095),
    [anon_sym_DASH] = ACTIONS(1095),
    [anon_sym_DASH_DASH] = ACTIONS(1097),
    [anon_sym_PLUS_PLUS] = ACTIONS(1097),
    [anon_sym_sizeof] = ACTIONS(1099),
    [sym_number_literal] = ACTIONS(1397),
    [sym_char_literal] = ACTIONS(1397),
    [sym_string_literal] = ACTIONS(1101),
    [sym_true] = ACTIONS(1403),
    [sym_false] = ACTIONS(1403),
    [sym_null] = ACTIONS(1403),
    [sym_identifier] = ACTIONS(1405),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(436),
    [sym_auto] = ACTIONS(1401),
    [anon_sym_typename] = ACTIONS(1407),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1409),
    [anon_sym_delete] = ACTIONS(1109),
    [sym_nullptr] = ACTIONS(1403),
  },
  [1274] = {
    [sym_argument_list] = STATE(802),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_COMMA] = ACTIONS(2702),
    [anon_sym_STAR] = ACTIONS(2648),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_RBRACK] = ACTIONS(2702),
    [anon_sym_EQ] = ACTIONS(2704),
    [anon_sym_QMARK] = ACTIONS(2702),
    [anon_sym_STAR_EQ] = ACTIONS(2702),
    [anon_sym_SLASH_EQ] = ACTIONS(2702),
    [anon_sym_PERCENT_EQ] = ACTIONS(2702),
    [anon_sym_PLUS_EQ] = ACTIONS(2702),
    [anon_sym_DASH_EQ] = ACTIONS(2702),
    [anon_sym_LT_LT_EQ] = ACTIONS(2702),
    [anon_sym_GT_GT_EQ] = ACTIONS(2702),
    [anon_sym_AMP_EQ] = ACTIONS(2702),
    [anon_sym_CARET_EQ] = ACTIONS(2702),
    [anon_sym_PIPE_EQ] = ACTIONS(2702),
    [anon_sym_AMP] = ACTIONS(2704),
    [anon_sym_PIPE_PIPE] = ACTIONS(2702),
    [anon_sym_AMP_AMP] = ACTIONS(2702),
    [anon_sym_PIPE] = ACTIONS(2704),
    [anon_sym_CARET] = ACTIONS(2704),
    [anon_sym_EQ_EQ] = ACTIONS(2702),
    [anon_sym_BANG_EQ] = ACTIONS(2702),
    [anon_sym_LT] = ACTIONS(2704),
    [anon_sym_GT] = ACTIONS(2704),
    [anon_sym_LT_EQ] = ACTIONS(2702),
    [anon_sym_GT_EQ] = ACTIONS(2702),
    [anon_sym_LT_LT] = ACTIONS(2674),
    [anon_sym_GT_GT] = ACTIONS(2674),
    [anon_sym_PLUS] = ACTIONS(2676),
    [anon_sym_DASH] = ACTIONS(2676),
    [anon_sym_SLASH] = ACTIONS(2648),
    [anon_sym_PERCENT] = ACTIONS(2648),
    [anon_sym_DASH_DASH] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(1554),
    [anon_sym_DASH_GT] = ACTIONS(1554),
    [sym_comment] = ACTIONS(49),
  },
  [1275] = {
    [aux_sym_concatenated_string_repeat1] = STATE(1839),
    [anon_sym_LPAREN] = ACTIONS(2706),
    [anon_sym_COMMA] = ACTIONS(2706),
    [anon_sym_STAR] = ACTIONS(2708),
    [anon_sym_LBRACK] = ACTIONS(2706),
    [anon_sym_RBRACK] = ACTIONS(2706),
    [anon_sym_EQ] = ACTIONS(2708),
    [anon_sym_QMARK] = ACTIONS(2706),
    [anon_sym_STAR_EQ] = ACTIONS(2706),
    [anon_sym_SLASH_EQ] = ACTIONS(2706),
    [anon_sym_PERCENT_EQ] = ACTIONS(2706),
    [anon_sym_PLUS_EQ] = ACTIONS(2706),
    [anon_sym_DASH_EQ] = ACTIONS(2706),
    [anon_sym_LT_LT_EQ] = ACTIONS(2706),
    [anon_sym_GT_GT_EQ] = ACTIONS(2706),
    [anon_sym_AMP_EQ] = ACTIONS(2706),
    [anon_sym_CARET_EQ] = ACTIONS(2706),
    [anon_sym_PIPE_EQ] = ACTIONS(2706),
    [anon_sym_AMP] = ACTIONS(2708),
    [anon_sym_PIPE_PIPE] = ACTIONS(2706),
    [anon_sym_AMP_AMP] = ACTIONS(2706),
    [anon_sym_PIPE] = ACTIONS(2708),
    [anon_sym_CARET] = ACTIONS(2708),
    [anon_sym_EQ_EQ] = ACTIONS(2706),
    [anon_sym_BANG_EQ] = ACTIONS(2706),
    [anon_sym_LT] = ACTIONS(2708),
    [anon_sym_GT] = ACTIONS(2708),
    [anon_sym_LT_EQ] = ACTIONS(2706),
    [anon_sym_GT_EQ] = ACTIONS(2706),
    [anon_sym_LT_LT] = ACTIONS(2708),
    [anon_sym_GT_GT] = ACTIONS(2708),
    [anon_sym_PLUS] = ACTIONS(2708),
    [anon_sym_DASH] = ACTIONS(2708),
    [anon_sym_SLASH] = ACTIONS(2708),
    [anon_sym_PERCENT] = ACTIONS(2708),
    [anon_sym_DASH_DASH] = ACTIONS(2706),
    [anon_sym_PLUS_PLUS] = ACTIONS(2706),
    [anon_sym_DOT] = ACTIONS(2706),
    [anon_sym_DASH_GT] = ACTIONS(2706),
    [sym_string_literal] = ACTIONS(4154),
    [sym_comment] = ACTIONS(49),
  },
  [1276] = {
    [sym__expression] = STATE(1841),
    [sym_conditional_expression] = STATE(1841),
    [sym_assignment_expression] = STATE(1841),
    [sym_pointer_expression] = STATE(1841),
    [sym_logical_expression] = STATE(1841),
    [sym_bitwise_expression] = STATE(1841),
    [sym_equality_expression] = STATE(1841),
    [sym_relational_expression] = STATE(1841),
    [sym_shift_expression] = STATE(1841),
    [sym_math_expression] = STATE(1841),
    [sym_cast_expression] = STATE(1841),
    [sym_sizeof_expression] = STATE(1841),
    [sym_subscript_expression] = STATE(1841),
    [sym_call_expression] = STATE(1841),
    [sym_field_expression] = STATE(1841),
    [sym_compound_literal_expression] = STATE(1841),
    [sym_parenthesized_expression] = STATE(1841),
    [sym_concatenated_string] = STATE(1841),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(1841),
    [sym_new_expression] = STATE(1841),
    [sym_delete_expression] = STATE(1841),
    [sym_lambda_expression] = STATE(1841),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(4156),
    [anon_sym_LPAREN] = ACTIONS(1419),
    [anon_sym_STAR] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(4158),
    [anon_sym_AMP] = ACTIONS(1421),
    [anon_sym_BANG] = ACTIONS(1429),
    [anon_sym_TILDE] = ACTIONS(1431),
    [anon_sym_PLUS] = ACTIONS(1433),
    [anon_sym_DASH] = ACTIONS(1433),
    [anon_sym_DASH_DASH] = ACTIONS(1435),
    [anon_sym_PLUS_PLUS] = ACTIONS(1435),
    [anon_sym_sizeof] = ACTIONS(1437),
    [sym_number_literal] = ACTIONS(4156),
    [sym_char_literal] = ACTIONS(4156),
    [sym_string_literal] = ACTIONS(1439),
    [sym_true] = ACTIONS(4160),
    [sym_false] = ACTIONS(4160),
    [sym_null] = ACTIONS(4160),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1443),
    [anon_sym_delete] = ACTIONS(1445),
    [sym_nullptr] = ACTIONS(4160),
  },
  [1277] = {
    [sym__expression] = STATE(740),
    [sym_conditional_expression] = STATE(740),
    [sym_assignment_expression] = STATE(740),
    [sym_pointer_expression] = STATE(740),
    [sym_logical_expression] = STATE(740),
    [sym_bitwise_expression] = STATE(740),
    [sym_equality_expression] = STATE(740),
    [sym_relational_expression] = STATE(740),
    [sym_shift_expression] = STATE(740),
    [sym_math_expression] = STATE(740),
    [sym_cast_expression] = STATE(740),
    [sym_sizeof_expression] = STATE(740),
    [sym_subscript_expression] = STATE(740),
    [sym_call_expression] = STATE(740),
    [sym_field_expression] = STATE(740),
    [sym_compound_literal_expression] = STATE(740),
    [sym_parenthesized_expression] = STATE(740),
    [sym_concatenated_string] = STATE(740),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(740),
    [sym_new_expression] = STATE(740),
    [sym_delete_expression] = STATE(740),
    [sym_lambda_expression] = STATE(740),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_lambda_default_capture] = STATE(741),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(1417),
    [anon_sym_LPAREN] = ACTIONS(1419),
    [anon_sym_STAR] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_RBRACK] = ACTIONS(4162),
    [anon_sym_EQ] = ACTIONS(1425),
    [anon_sym_AMP] = ACTIONS(1427),
    [anon_sym_BANG] = ACTIONS(1429),
    [anon_sym_TILDE] = ACTIONS(1431),
    [anon_sym_PLUS] = ACTIONS(1433),
    [anon_sym_DASH] = ACTIONS(1433),
    [anon_sym_DASH_DASH] = ACTIONS(1435),
    [anon_sym_PLUS_PLUS] = ACTIONS(1435),
    [anon_sym_sizeof] = ACTIONS(1437),
    [sym_number_literal] = ACTIONS(1417),
    [sym_char_literal] = ACTIONS(1417),
    [sym_string_literal] = ACTIONS(1439),
    [sym_true] = ACTIONS(1441),
    [sym_false] = ACTIONS(1441),
    [sym_null] = ACTIONS(1441),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1443),
    [anon_sym_delete] = ACTIONS(1445),
    [sym_nullptr] = ACTIONS(1441),
  },
  [1278] = {
    [sym_argument_list] = STATE(802),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_COMMA] = ACTIONS(2740),
    [anon_sym_STAR] = ACTIONS(2648),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_RBRACK] = ACTIONS(2740),
    [anon_sym_EQ] = ACTIONS(2742),
    [anon_sym_QMARK] = ACTIONS(2740),
    [anon_sym_STAR_EQ] = ACTIONS(2740),
    [anon_sym_SLASH_EQ] = ACTIONS(2740),
    [anon_sym_PERCENT_EQ] = ACTIONS(2740),
    [anon_sym_PLUS_EQ] = ACTIONS(2740),
    [anon_sym_DASH_EQ] = ACTIONS(2740),
    [anon_sym_LT_LT_EQ] = ACTIONS(2740),
    [anon_sym_GT_GT_EQ] = ACTIONS(2740),
    [anon_sym_AMP_EQ] = ACTIONS(2740),
    [anon_sym_CARET_EQ] = ACTIONS(2740),
    [anon_sym_PIPE_EQ] = ACTIONS(2740),
    [anon_sym_AMP] = ACTIONS(2658),
    [anon_sym_PIPE_PIPE] = ACTIONS(2660),
    [anon_sym_AMP_AMP] = ACTIONS(2662),
    [anon_sym_PIPE] = ACTIONS(2664),
    [anon_sym_CARET] = ACTIONS(2666),
    [anon_sym_EQ_EQ] = ACTIONS(2668),
    [anon_sym_BANG_EQ] = ACTIONS(2668),
    [anon_sym_LT] = ACTIONS(2670),
    [anon_sym_GT] = ACTIONS(2670),
    [anon_sym_LT_EQ] = ACTIONS(2672),
    [anon_sym_GT_EQ] = ACTIONS(2672),
    [anon_sym_LT_LT] = ACTIONS(2674),
    [anon_sym_GT_GT] = ACTIONS(2674),
    [anon_sym_PLUS] = ACTIONS(2676),
    [anon_sym_DASH] = ACTIONS(2676),
    [anon_sym_SLASH] = ACTIONS(2648),
    [anon_sym_PERCENT] = ACTIONS(2648),
    [anon_sym_DASH_DASH] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(1554),
    [anon_sym_DASH_GT] = ACTIONS(1554),
    [sym_comment] = ACTIONS(49),
  },
  [1279] = {
    [sym__expression] = STATE(1843),
    [sym_conditional_expression] = STATE(1843),
    [sym_assignment_expression] = STATE(1843),
    [sym_pointer_expression] = STATE(1843),
    [sym_logical_expression] = STATE(1843),
    [sym_bitwise_expression] = STATE(1843),
    [sym_equality_expression] = STATE(1843),
    [sym_relational_expression] = STATE(1843),
    [sym_shift_expression] = STATE(1843),
    [sym_math_expression] = STATE(1843),
    [sym_cast_expression] = STATE(1843),
    [sym_sizeof_expression] = STATE(1843),
    [sym_subscript_expression] = STATE(1843),
    [sym_call_expression] = STATE(1843),
    [sym_field_expression] = STATE(1843),
    [sym_compound_literal_expression] = STATE(1843),
    [sym_parenthesized_expression] = STATE(1843),
    [sym_concatenated_string] = STATE(1843),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(1843),
    [sym_new_expression] = STATE(1843),
    [sym_delete_expression] = STATE(1843),
    [sym_lambda_expression] = STATE(1843),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(4164),
    [anon_sym_LPAREN] = ACTIONS(1419),
    [anon_sym_STAR] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_AMP] = ACTIONS(1421),
    [anon_sym_BANG] = ACTIONS(1429),
    [anon_sym_TILDE] = ACTIONS(1431),
    [anon_sym_PLUS] = ACTIONS(1433),
    [anon_sym_DASH] = ACTIONS(1433),
    [anon_sym_DASH_DASH] = ACTIONS(1435),
    [anon_sym_PLUS_PLUS] = ACTIONS(1435),
    [anon_sym_sizeof] = ACTIONS(1437),
    [sym_number_literal] = ACTIONS(4164),
    [sym_char_literal] = ACTIONS(4164),
    [sym_string_literal] = ACTIONS(1439),
    [sym_true] = ACTIONS(4166),
    [sym_false] = ACTIONS(4166),
    [sym_null] = ACTIONS(4166),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1443),
    [anon_sym_delete] = ACTIONS(1445),
    [sym_nullptr] = ACTIONS(4166),
  },
  [1280] = {
    [sym__expression] = STATE(1328),
    [sym_conditional_expression] = STATE(1328),
    [sym_assignment_expression] = STATE(1328),
    [sym_pointer_expression] = STATE(1328),
    [sym_logical_expression] = STATE(1328),
    [sym_bitwise_expression] = STATE(1328),
    [sym_equality_expression] = STATE(1328),
    [sym_relational_expression] = STATE(1328),
    [sym_shift_expression] = STATE(1328),
    [sym_math_expression] = STATE(1328),
    [sym_cast_expression] = STATE(1328),
    [sym_sizeof_expression] = STATE(1328),
    [sym_subscript_expression] = STATE(1328),
    [sym_call_expression] = STATE(1328),
    [sym_field_expression] = STATE(1328),
    [sym_compound_literal_expression] = STATE(1328),
    [sym_parenthesized_expression] = STATE(1328),
    [sym_concatenated_string] = STATE(1328),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(1328),
    [sym_new_expression] = STATE(1328),
    [sym_delete_expression] = STATE(1328),
    [sym_lambda_expression] = STATE(1328),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(2748),
    [anon_sym_LPAREN] = ACTIONS(1419),
    [anon_sym_STAR] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_AMP] = ACTIONS(1421),
    [anon_sym_BANG] = ACTIONS(1429),
    [anon_sym_TILDE] = ACTIONS(1431),
    [anon_sym_PLUS] = ACTIONS(1433),
    [anon_sym_DASH] = ACTIONS(1433),
    [anon_sym_DASH_DASH] = ACTIONS(1435),
    [anon_sym_PLUS_PLUS] = ACTIONS(1435),
    [anon_sym_sizeof] = ACTIONS(1437),
    [sym_number_literal] = ACTIONS(2748),
    [sym_char_literal] = ACTIONS(2748),
    [sym_string_literal] = ACTIONS(1439),
    [sym_true] = ACTIONS(2750),
    [sym_false] = ACTIONS(2750),
    [sym_null] = ACTIONS(2750),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1443),
    [anon_sym_delete] = ACTIONS(1445),
    [sym_nullptr] = ACTIONS(2750),
  },
  [1281] = {
    [anon_sym_LPAREN] = ACTIONS(4168),
    [anon_sym_STAR] = ACTIONS(4168),
    [anon_sym_LBRACK] = ACTIONS(4168),
    [anon_sym_AMP] = ACTIONS(4170),
    [anon_sym_AMP_AMP] = ACTIONS(4168),
    [sym_comment] = ACTIONS(49),
  },
  [1282] = {
    [sym__expression] = STATE(1844),
    [sym_conditional_expression] = STATE(1844),
    [sym_assignment_expression] = STATE(1844),
    [sym_pointer_expression] = STATE(1844),
    [sym_logical_expression] = STATE(1844),
    [sym_bitwise_expression] = STATE(1844),
    [sym_equality_expression] = STATE(1844),
    [sym_relational_expression] = STATE(1844),
    [sym_shift_expression] = STATE(1844),
    [sym_math_expression] = STATE(1844),
    [sym_cast_expression] = STATE(1844),
    [sym_sizeof_expression] = STATE(1844),
    [sym_subscript_expression] = STATE(1844),
    [sym_call_expression] = STATE(1844),
    [sym_field_expression] = STATE(1844),
    [sym_compound_literal_expression] = STATE(1844),
    [sym_parenthesized_expression] = STATE(1844),
    [sym_concatenated_string] = STATE(1844),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(1844),
    [sym_new_expression] = STATE(1844),
    [sym_delete_expression] = STATE(1844),
    [sym_lambda_expression] = STATE(1844),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(4172),
    [anon_sym_LPAREN] = ACTIONS(1419),
    [anon_sym_STAR] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_AMP] = ACTIONS(1421),
    [anon_sym_BANG] = ACTIONS(1429),
    [anon_sym_TILDE] = ACTIONS(1431),
    [anon_sym_PLUS] = ACTIONS(1433),
    [anon_sym_DASH] = ACTIONS(1433),
    [anon_sym_DASH_DASH] = ACTIONS(1435),
    [anon_sym_PLUS_PLUS] = ACTIONS(1435),
    [anon_sym_sizeof] = ACTIONS(1437),
    [sym_number_literal] = ACTIONS(4172),
    [sym_char_literal] = ACTIONS(4172),
    [sym_string_literal] = ACTIONS(1439),
    [sym_true] = ACTIONS(4174),
    [sym_false] = ACTIONS(4174),
    [sym_null] = ACTIONS(4174),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1443),
    [anon_sym_delete] = ACTIONS(1445),
    [sym_nullptr] = ACTIONS(4174),
  },
  [1283] = {
    [sym__expression] = STATE(1845),
    [sym_conditional_expression] = STATE(1845),
    [sym_assignment_expression] = STATE(1845),
    [sym_pointer_expression] = STATE(1845),
    [sym_logical_expression] = STATE(1845),
    [sym_bitwise_expression] = STATE(1845),
    [sym_equality_expression] = STATE(1845),
    [sym_relational_expression] = STATE(1845),
    [sym_shift_expression] = STATE(1845),
    [sym_math_expression] = STATE(1845),
    [sym_cast_expression] = STATE(1845),
    [sym_sizeof_expression] = STATE(1845),
    [sym_subscript_expression] = STATE(1845),
    [sym_call_expression] = STATE(1845),
    [sym_field_expression] = STATE(1845),
    [sym_compound_literal_expression] = STATE(1845),
    [sym_parenthesized_expression] = STATE(1845),
    [sym_concatenated_string] = STATE(1845),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(1845),
    [sym_new_expression] = STATE(1845),
    [sym_delete_expression] = STATE(1845),
    [sym_lambda_expression] = STATE(1845),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(855),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(4176),
    [anon_sym_LPAREN] = ACTIONS(1634),
    [anon_sym_STAR] = ACTIONS(1636),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_AMP] = ACTIONS(1636),
    [anon_sym_BANG] = ACTIONS(1638),
    [anon_sym_TILDE] = ACTIONS(1640),
    [anon_sym_PLUS] = ACTIONS(1642),
    [anon_sym_DASH] = ACTIONS(1642),
    [anon_sym_DASH_DASH] = ACTIONS(1644),
    [anon_sym_PLUS_PLUS] = ACTIONS(1644),
    [anon_sym_sizeof] = ACTIONS(1646),
    [sym_number_literal] = ACTIONS(4176),
    [sym_char_literal] = ACTIONS(4176),
    [sym_string_literal] = ACTIONS(1648),
    [sym_true] = ACTIONS(4178),
    [sym_false] = ACTIONS(4178),
    [sym_null] = ACTIONS(4178),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1652),
    [anon_sym_delete] = ACTIONS(1654),
    [sym_nullptr] = ACTIONS(4178),
  },
  [1284] = {
    [sym__expression] = STATE(1846),
    [sym_conditional_expression] = STATE(1846),
    [sym_assignment_expression] = STATE(1846),
    [sym_pointer_expression] = STATE(1846),
    [sym_logical_expression] = STATE(1846),
    [sym_bitwise_expression] = STATE(1846),
    [sym_equality_expression] = STATE(1846),
    [sym_relational_expression] = STATE(1846),
    [sym_shift_expression] = STATE(1846),
    [sym_math_expression] = STATE(1846),
    [sym_cast_expression] = STATE(1846),
    [sym_sizeof_expression] = STATE(1846),
    [sym_subscript_expression] = STATE(1846),
    [sym_call_expression] = STATE(1846),
    [sym_field_expression] = STATE(1846),
    [sym_compound_literal_expression] = STATE(1846),
    [sym_parenthesized_expression] = STATE(1846),
    [sym_concatenated_string] = STATE(1846),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(1846),
    [sym_new_expression] = STATE(1846),
    [sym_delete_expression] = STATE(1846),
    [sym_lambda_expression] = STATE(1846),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(4180),
    [anon_sym_LPAREN] = ACTIONS(1419),
    [anon_sym_STAR] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_AMP] = ACTIONS(1421),
    [anon_sym_BANG] = ACTIONS(1429),
    [anon_sym_TILDE] = ACTIONS(1431),
    [anon_sym_PLUS] = ACTIONS(1433),
    [anon_sym_DASH] = ACTIONS(1433),
    [anon_sym_DASH_DASH] = ACTIONS(1435),
    [anon_sym_PLUS_PLUS] = ACTIONS(1435),
    [anon_sym_sizeof] = ACTIONS(1437),
    [sym_number_literal] = ACTIONS(4180),
    [sym_char_literal] = ACTIONS(4180),
    [sym_string_literal] = ACTIONS(1439),
    [sym_true] = ACTIONS(4182),
    [sym_false] = ACTIONS(4182),
    [sym_null] = ACTIONS(4182),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1443),
    [anon_sym_delete] = ACTIONS(1445),
    [sym_nullptr] = ACTIONS(4182),
  },
  [1285] = {
    [sym__expression] = STATE(1847),
    [sym_conditional_expression] = STATE(1847),
    [sym_assignment_expression] = STATE(1847),
    [sym_pointer_expression] = STATE(1847),
    [sym_logical_expression] = STATE(1847),
    [sym_bitwise_expression] = STATE(1847),
    [sym_equality_expression] = STATE(1847),
    [sym_relational_expression] = STATE(1847),
    [sym_shift_expression] = STATE(1847),
    [sym_math_expression] = STATE(1847),
    [sym_cast_expression] = STATE(1847),
    [sym_sizeof_expression] = STATE(1847),
    [sym_subscript_expression] = STATE(1847),
    [sym_call_expression] = STATE(1847),
    [sym_field_expression] = STATE(1847),
    [sym_compound_literal_expression] = STATE(1847),
    [sym_parenthesized_expression] = STATE(1847),
    [sym_concatenated_string] = STATE(1847),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(1847),
    [sym_new_expression] = STATE(1847),
    [sym_delete_expression] = STATE(1847),
    [sym_lambda_expression] = STATE(1847),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(4184),
    [anon_sym_LPAREN] = ACTIONS(1419),
    [anon_sym_STAR] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_AMP] = ACTIONS(1421),
    [anon_sym_BANG] = ACTIONS(1429),
    [anon_sym_TILDE] = ACTIONS(1431),
    [anon_sym_PLUS] = ACTIONS(1433),
    [anon_sym_DASH] = ACTIONS(1433),
    [anon_sym_DASH_DASH] = ACTIONS(1435),
    [anon_sym_PLUS_PLUS] = ACTIONS(1435),
    [anon_sym_sizeof] = ACTIONS(1437),
    [sym_number_literal] = ACTIONS(4184),
    [sym_char_literal] = ACTIONS(4184),
    [sym_string_literal] = ACTIONS(1439),
    [sym_true] = ACTIONS(4186),
    [sym_false] = ACTIONS(4186),
    [sym_null] = ACTIONS(4186),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1443),
    [anon_sym_delete] = ACTIONS(1445),
    [sym_nullptr] = ACTIONS(4186),
  },
  [1286] = {
    [sym__expression] = STATE(1848),
    [sym_conditional_expression] = STATE(1848),
    [sym_assignment_expression] = STATE(1848),
    [sym_pointer_expression] = STATE(1848),
    [sym_logical_expression] = STATE(1848),
    [sym_bitwise_expression] = STATE(1848),
    [sym_equality_expression] = STATE(1848),
    [sym_relational_expression] = STATE(1848),
    [sym_shift_expression] = STATE(1848),
    [sym_math_expression] = STATE(1848),
    [sym_cast_expression] = STATE(1848),
    [sym_sizeof_expression] = STATE(1848),
    [sym_subscript_expression] = STATE(1848),
    [sym_call_expression] = STATE(1848),
    [sym_field_expression] = STATE(1848),
    [sym_compound_literal_expression] = STATE(1848),
    [sym_parenthesized_expression] = STATE(1848),
    [sym_concatenated_string] = STATE(1848),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(1848),
    [sym_new_expression] = STATE(1848),
    [sym_delete_expression] = STATE(1848),
    [sym_lambda_expression] = STATE(1848),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(4188),
    [anon_sym_LPAREN] = ACTIONS(1419),
    [anon_sym_STAR] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_AMP] = ACTIONS(1421),
    [anon_sym_BANG] = ACTIONS(1429),
    [anon_sym_TILDE] = ACTIONS(1431),
    [anon_sym_PLUS] = ACTIONS(1433),
    [anon_sym_DASH] = ACTIONS(1433),
    [anon_sym_DASH_DASH] = ACTIONS(1435),
    [anon_sym_PLUS_PLUS] = ACTIONS(1435),
    [anon_sym_sizeof] = ACTIONS(1437),
    [sym_number_literal] = ACTIONS(4188),
    [sym_char_literal] = ACTIONS(4188),
    [sym_string_literal] = ACTIONS(1439),
    [sym_true] = ACTIONS(4190),
    [sym_false] = ACTIONS(4190),
    [sym_null] = ACTIONS(4190),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1443),
    [anon_sym_delete] = ACTIONS(1445),
    [sym_nullptr] = ACTIONS(4190),
  },
  [1287] = {
    [sym__expression] = STATE(1849),
    [sym_conditional_expression] = STATE(1849),
    [sym_assignment_expression] = STATE(1849),
    [sym_pointer_expression] = STATE(1849),
    [sym_logical_expression] = STATE(1849),
    [sym_bitwise_expression] = STATE(1849),
    [sym_equality_expression] = STATE(1849),
    [sym_relational_expression] = STATE(1849),
    [sym_shift_expression] = STATE(1849),
    [sym_math_expression] = STATE(1849),
    [sym_cast_expression] = STATE(1849),
    [sym_sizeof_expression] = STATE(1849),
    [sym_subscript_expression] = STATE(1849),
    [sym_call_expression] = STATE(1849),
    [sym_field_expression] = STATE(1849),
    [sym_compound_literal_expression] = STATE(1849),
    [sym_parenthesized_expression] = STATE(1849),
    [sym_concatenated_string] = STATE(1849),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(1849),
    [sym_new_expression] = STATE(1849),
    [sym_delete_expression] = STATE(1849),
    [sym_lambda_expression] = STATE(1849),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(4192),
    [anon_sym_LPAREN] = ACTIONS(1419),
    [anon_sym_STAR] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_AMP] = ACTIONS(1421),
    [anon_sym_BANG] = ACTIONS(1429),
    [anon_sym_TILDE] = ACTIONS(1431),
    [anon_sym_PLUS] = ACTIONS(1433),
    [anon_sym_DASH] = ACTIONS(1433),
    [anon_sym_DASH_DASH] = ACTIONS(1435),
    [anon_sym_PLUS_PLUS] = ACTIONS(1435),
    [anon_sym_sizeof] = ACTIONS(1437),
    [sym_number_literal] = ACTIONS(4192),
    [sym_char_literal] = ACTIONS(4192),
    [sym_string_literal] = ACTIONS(1439),
    [sym_true] = ACTIONS(4194),
    [sym_false] = ACTIONS(4194),
    [sym_null] = ACTIONS(4194),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1443),
    [anon_sym_delete] = ACTIONS(1445),
    [sym_nullptr] = ACTIONS(4194),
  },
  [1288] = {
    [sym__expression] = STATE(1850),
    [sym_conditional_expression] = STATE(1850),
    [sym_assignment_expression] = STATE(1850),
    [sym_pointer_expression] = STATE(1850),
    [sym_logical_expression] = STATE(1850),
    [sym_bitwise_expression] = STATE(1850),
    [sym_equality_expression] = STATE(1850),
    [sym_relational_expression] = STATE(1850),
    [sym_shift_expression] = STATE(1850),
    [sym_math_expression] = STATE(1850),
    [sym_cast_expression] = STATE(1850),
    [sym_sizeof_expression] = STATE(1850),
    [sym_subscript_expression] = STATE(1850),
    [sym_call_expression] = STATE(1850),
    [sym_field_expression] = STATE(1850),
    [sym_compound_literal_expression] = STATE(1850),
    [sym_parenthesized_expression] = STATE(1850),
    [sym_concatenated_string] = STATE(1850),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(1850),
    [sym_new_expression] = STATE(1850),
    [sym_delete_expression] = STATE(1850),
    [sym_lambda_expression] = STATE(1850),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(4196),
    [anon_sym_LPAREN] = ACTIONS(1419),
    [anon_sym_STAR] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_AMP] = ACTIONS(1421),
    [anon_sym_BANG] = ACTIONS(1429),
    [anon_sym_TILDE] = ACTIONS(1431),
    [anon_sym_PLUS] = ACTIONS(1433),
    [anon_sym_DASH] = ACTIONS(1433),
    [anon_sym_DASH_DASH] = ACTIONS(1435),
    [anon_sym_PLUS_PLUS] = ACTIONS(1435),
    [anon_sym_sizeof] = ACTIONS(1437),
    [sym_number_literal] = ACTIONS(4196),
    [sym_char_literal] = ACTIONS(4196),
    [sym_string_literal] = ACTIONS(1439),
    [sym_true] = ACTIONS(4198),
    [sym_false] = ACTIONS(4198),
    [sym_null] = ACTIONS(4198),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1443),
    [anon_sym_delete] = ACTIONS(1445),
    [sym_nullptr] = ACTIONS(4198),
  },
  [1289] = {
    [sym__expression] = STATE(1851),
    [sym_conditional_expression] = STATE(1851),
    [sym_assignment_expression] = STATE(1851),
    [sym_pointer_expression] = STATE(1851),
    [sym_logical_expression] = STATE(1851),
    [sym_bitwise_expression] = STATE(1851),
    [sym_equality_expression] = STATE(1851),
    [sym_relational_expression] = STATE(1851),
    [sym_shift_expression] = STATE(1851),
    [sym_math_expression] = STATE(1851),
    [sym_cast_expression] = STATE(1851),
    [sym_sizeof_expression] = STATE(1851),
    [sym_subscript_expression] = STATE(1851),
    [sym_call_expression] = STATE(1851),
    [sym_field_expression] = STATE(1851),
    [sym_compound_literal_expression] = STATE(1851),
    [sym_parenthesized_expression] = STATE(1851),
    [sym_concatenated_string] = STATE(1851),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(1851),
    [sym_new_expression] = STATE(1851),
    [sym_delete_expression] = STATE(1851),
    [sym_lambda_expression] = STATE(1851),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(4200),
    [anon_sym_LPAREN] = ACTIONS(1419),
    [anon_sym_STAR] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_AMP] = ACTIONS(1421),
    [anon_sym_BANG] = ACTIONS(1429),
    [anon_sym_TILDE] = ACTIONS(1431),
    [anon_sym_PLUS] = ACTIONS(1433),
    [anon_sym_DASH] = ACTIONS(1433),
    [anon_sym_DASH_DASH] = ACTIONS(1435),
    [anon_sym_PLUS_PLUS] = ACTIONS(1435),
    [anon_sym_sizeof] = ACTIONS(1437),
    [sym_number_literal] = ACTIONS(4200),
    [sym_char_literal] = ACTIONS(4200),
    [sym_string_literal] = ACTIONS(1439),
    [sym_true] = ACTIONS(4202),
    [sym_false] = ACTIONS(4202),
    [sym_null] = ACTIONS(4202),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1443),
    [anon_sym_delete] = ACTIONS(1445),
    [sym_nullptr] = ACTIONS(4202),
  },
  [1290] = {
    [sym__expression] = STATE(1852),
    [sym_conditional_expression] = STATE(1852),
    [sym_assignment_expression] = STATE(1852),
    [sym_pointer_expression] = STATE(1852),
    [sym_logical_expression] = STATE(1852),
    [sym_bitwise_expression] = STATE(1852),
    [sym_equality_expression] = STATE(1852),
    [sym_relational_expression] = STATE(1852),
    [sym_shift_expression] = STATE(1852),
    [sym_math_expression] = STATE(1852),
    [sym_cast_expression] = STATE(1852),
    [sym_sizeof_expression] = STATE(1852),
    [sym_subscript_expression] = STATE(1852),
    [sym_call_expression] = STATE(1852),
    [sym_field_expression] = STATE(1852),
    [sym_compound_literal_expression] = STATE(1852),
    [sym_parenthesized_expression] = STATE(1852),
    [sym_concatenated_string] = STATE(1852),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(1852),
    [sym_new_expression] = STATE(1852),
    [sym_delete_expression] = STATE(1852),
    [sym_lambda_expression] = STATE(1852),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(4204),
    [anon_sym_LPAREN] = ACTIONS(1419),
    [anon_sym_STAR] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_AMP] = ACTIONS(1421),
    [anon_sym_BANG] = ACTIONS(1429),
    [anon_sym_TILDE] = ACTIONS(1431),
    [anon_sym_PLUS] = ACTIONS(1433),
    [anon_sym_DASH] = ACTIONS(1433),
    [anon_sym_DASH_DASH] = ACTIONS(1435),
    [anon_sym_PLUS_PLUS] = ACTIONS(1435),
    [anon_sym_sizeof] = ACTIONS(1437),
    [sym_number_literal] = ACTIONS(4204),
    [sym_char_literal] = ACTIONS(4204),
    [sym_string_literal] = ACTIONS(1439),
    [sym_true] = ACTIONS(4206),
    [sym_false] = ACTIONS(4206),
    [sym_null] = ACTIONS(4206),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1443),
    [anon_sym_delete] = ACTIONS(1445),
    [sym_nullptr] = ACTIONS(4206),
  },
  [1291] = {
    [sym__expression] = STATE(1853),
    [sym_conditional_expression] = STATE(1853),
    [sym_assignment_expression] = STATE(1853),
    [sym_pointer_expression] = STATE(1853),
    [sym_logical_expression] = STATE(1853),
    [sym_bitwise_expression] = STATE(1853),
    [sym_equality_expression] = STATE(1853),
    [sym_relational_expression] = STATE(1853),
    [sym_shift_expression] = STATE(1853),
    [sym_math_expression] = STATE(1853),
    [sym_cast_expression] = STATE(1853),
    [sym_sizeof_expression] = STATE(1853),
    [sym_subscript_expression] = STATE(1853),
    [sym_call_expression] = STATE(1853),
    [sym_field_expression] = STATE(1853),
    [sym_compound_literal_expression] = STATE(1853),
    [sym_parenthesized_expression] = STATE(1853),
    [sym_concatenated_string] = STATE(1853),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(1853),
    [sym_new_expression] = STATE(1853),
    [sym_delete_expression] = STATE(1853),
    [sym_lambda_expression] = STATE(1853),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(4208),
    [anon_sym_LPAREN] = ACTIONS(1419),
    [anon_sym_STAR] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_AMP] = ACTIONS(1421),
    [anon_sym_BANG] = ACTIONS(1429),
    [anon_sym_TILDE] = ACTIONS(1431),
    [anon_sym_PLUS] = ACTIONS(1433),
    [anon_sym_DASH] = ACTIONS(1433),
    [anon_sym_DASH_DASH] = ACTIONS(1435),
    [anon_sym_PLUS_PLUS] = ACTIONS(1435),
    [anon_sym_sizeof] = ACTIONS(1437),
    [sym_number_literal] = ACTIONS(4208),
    [sym_char_literal] = ACTIONS(4208),
    [sym_string_literal] = ACTIONS(1439),
    [sym_true] = ACTIONS(4210),
    [sym_false] = ACTIONS(4210),
    [sym_null] = ACTIONS(4210),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1443),
    [anon_sym_delete] = ACTIONS(1445),
    [sym_nullptr] = ACTIONS(4210),
  },
  [1292] = {
    [sym__expression] = STATE(1854),
    [sym_conditional_expression] = STATE(1854),
    [sym_assignment_expression] = STATE(1854),
    [sym_pointer_expression] = STATE(1854),
    [sym_logical_expression] = STATE(1854),
    [sym_bitwise_expression] = STATE(1854),
    [sym_equality_expression] = STATE(1854),
    [sym_relational_expression] = STATE(1854),
    [sym_shift_expression] = STATE(1854),
    [sym_math_expression] = STATE(1854),
    [sym_cast_expression] = STATE(1854),
    [sym_sizeof_expression] = STATE(1854),
    [sym_subscript_expression] = STATE(1854),
    [sym_call_expression] = STATE(1854),
    [sym_field_expression] = STATE(1854),
    [sym_compound_literal_expression] = STATE(1854),
    [sym_parenthesized_expression] = STATE(1854),
    [sym_concatenated_string] = STATE(1854),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(1854),
    [sym_new_expression] = STATE(1854),
    [sym_delete_expression] = STATE(1854),
    [sym_lambda_expression] = STATE(1854),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(4212),
    [anon_sym_LPAREN] = ACTIONS(1419),
    [anon_sym_STAR] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_AMP] = ACTIONS(1421),
    [anon_sym_BANG] = ACTIONS(1429),
    [anon_sym_TILDE] = ACTIONS(1431),
    [anon_sym_PLUS] = ACTIONS(1433),
    [anon_sym_DASH] = ACTIONS(1433),
    [anon_sym_DASH_DASH] = ACTIONS(1435),
    [anon_sym_PLUS_PLUS] = ACTIONS(1435),
    [anon_sym_sizeof] = ACTIONS(1437),
    [sym_number_literal] = ACTIONS(4212),
    [sym_char_literal] = ACTIONS(4212),
    [sym_string_literal] = ACTIONS(1439),
    [sym_true] = ACTIONS(4214),
    [sym_false] = ACTIONS(4214),
    [sym_null] = ACTIONS(4214),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1443),
    [anon_sym_delete] = ACTIONS(1445),
    [sym_nullptr] = ACTIONS(4214),
  },
  [1293] = {
    [aux_sym_for_statement_repeat1] = STATE(1856),
    [anon_sym_COMMA] = ACTIONS(2646),
    [anon_sym_RBRACK] = ACTIONS(4216),
    [sym_comment] = ACTIONS(49),
  },
  [1294] = {
    [anon_sym_RBRACE] = ACTIONS(4218),
    [sym_comment] = ACTIONS(49),
  },
  [1295] = {
    [sym_raw_string_literal] = ACTIONS(985),
    [anon_sym_LPAREN] = ACTIONS(985),
    [anon_sym_extern] = ACTIONS(987),
    [anon_sym_STAR] = ACTIONS(985),
    [anon_sym_LBRACK] = ACTIONS(985),
    [anon_sym_RBRACK] = ACTIONS(985),
    [anon_sym_static] = ACTIONS(987),
    [anon_sym_register] = ACTIONS(987),
    [anon_sym_inline] = ACTIONS(987),
    [anon_sym_const] = ACTIONS(987),
    [anon_sym_restrict] = ACTIONS(987),
    [anon_sym_volatile] = ACTIONS(987),
    [anon_sym__Atomic] = ACTIONS(987),
    [anon_sym_mutable] = ACTIONS(987),
    [anon_sym_explicit] = ACTIONS(987),
    [anon_sym_constexpr] = ACTIONS(987),
    [anon_sym_AMP] = ACTIONS(985),
    [anon_sym_BANG] = ACTIONS(985),
    [anon_sym_TILDE] = ACTIONS(985),
    [anon_sym_PLUS] = ACTIONS(987),
    [anon_sym_DASH] = ACTIONS(987),
    [anon_sym_DASH_DASH] = ACTIONS(985),
    [anon_sym_PLUS_PLUS] = ACTIONS(985),
    [anon_sym_sizeof] = ACTIONS(987),
    [sym_number_literal] = ACTIONS(985),
    [sym_char_literal] = ACTIONS(985),
    [sym_string_literal] = ACTIONS(985),
    [sym_true] = ACTIONS(987),
    [sym_false] = ACTIONS(987),
    [sym_null] = ACTIONS(987),
    [sym_identifier] = ACTIONS(987),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(987),
    [anon_sym_COLON_COLON] = ACTIONS(985),
    [anon_sym_delete] = ACTIONS(987),
    [sym_nullptr] = ACTIONS(987),
  },
  [1296] = {
    [aux_sym_enumerator_list_repeat1] = STATE(1859),
    [anon_sym_COMMA] = ACTIONS(4220),
    [anon_sym_RBRACE] = ACTIONS(4218),
    [sym_comment] = ACTIONS(49),
  },
  [1297] = {
    [sym_raw_string_literal] = ACTIONS(995),
    [anon_sym_LPAREN] = ACTIONS(995),
    [anon_sym_extern] = ACTIONS(997),
    [anon_sym_STAR] = ACTIONS(995),
    [anon_sym_LBRACK] = ACTIONS(995),
    [anon_sym_RBRACK] = ACTIONS(995),
    [anon_sym_static] = ACTIONS(997),
    [anon_sym_register] = ACTIONS(997),
    [anon_sym_inline] = ACTIONS(997),
    [anon_sym_const] = ACTIONS(997),
    [anon_sym_restrict] = ACTIONS(997),
    [anon_sym_volatile] = ACTIONS(997),
    [anon_sym__Atomic] = ACTIONS(997),
    [anon_sym_mutable] = ACTIONS(997),
    [anon_sym_explicit] = ACTIONS(997),
    [anon_sym_constexpr] = ACTIONS(997),
    [anon_sym_AMP] = ACTIONS(995),
    [anon_sym_BANG] = ACTIONS(995),
    [anon_sym_TILDE] = ACTIONS(995),
    [anon_sym_PLUS] = ACTIONS(997),
    [anon_sym_DASH] = ACTIONS(997),
    [anon_sym_DASH_DASH] = ACTIONS(995),
    [anon_sym_PLUS_PLUS] = ACTIONS(995),
    [anon_sym_sizeof] = ACTIONS(997),
    [sym_number_literal] = ACTIONS(995),
    [sym_char_literal] = ACTIONS(995),
    [sym_string_literal] = ACTIONS(995),
    [sym_true] = ACTIONS(997),
    [sym_false] = ACTIONS(997),
    [sym_null] = ACTIONS(997),
    [sym_identifier] = ACTIONS(997),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(997),
    [anon_sym_COLON_COLON] = ACTIONS(995),
    [anon_sym_delete] = ACTIONS(997),
    [sym_nullptr] = ACTIONS(997),
  },
  [1298] = {
    [sym_raw_string_literal] = ACTIONS(1007),
    [anon_sym_LPAREN] = ACTIONS(1007),
    [anon_sym_extern] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(1007),
    [anon_sym_LBRACK] = ACTIONS(1007),
    [anon_sym_RBRACK] = ACTIONS(1007),
    [anon_sym_static] = ACTIONS(1009),
    [anon_sym_register] = ACTIONS(1009),
    [anon_sym_inline] = ACTIONS(1009),
    [anon_sym_const] = ACTIONS(1009),
    [anon_sym_restrict] = ACTIONS(1009),
    [anon_sym_volatile] = ACTIONS(1009),
    [anon_sym__Atomic] = ACTIONS(1009),
    [anon_sym_mutable] = ACTIONS(1009),
    [anon_sym_explicit] = ACTIONS(1009),
    [anon_sym_constexpr] = ACTIONS(1009),
    [anon_sym_AMP] = ACTIONS(1007),
    [anon_sym_BANG] = ACTIONS(1007),
    [anon_sym_TILDE] = ACTIONS(1007),
    [anon_sym_PLUS] = ACTIONS(1009),
    [anon_sym_DASH] = ACTIONS(1009),
    [anon_sym_DASH_DASH] = ACTIONS(1007),
    [anon_sym_PLUS_PLUS] = ACTIONS(1007),
    [anon_sym_sizeof] = ACTIONS(1009),
    [sym_number_literal] = ACTIONS(1007),
    [sym_char_literal] = ACTIONS(1007),
    [sym_string_literal] = ACTIONS(1007),
    [sym_true] = ACTIONS(1009),
    [sym_false] = ACTIONS(1009),
    [sym_null] = ACTIONS(1009),
    [sym_identifier] = ACTIONS(1009),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(1009),
    [anon_sym_COLON_COLON] = ACTIONS(1007),
    [anon_sym_delete] = ACTIONS(1009),
    [sym_nullptr] = ACTIONS(1009),
  },
  [1299] = {
    [sym_preproc_if_in_field_declaration_list] = STATE(246),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(247),
    [sym_type_definition] = STATE(563),
    [sym__declaration_specifiers] = STATE(248),
    [sym__declarator] = STATE(249),
    [sym_pointer_declarator] = STATE(249),
    [sym_function_declarator] = STATE(250),
    [sym_array_declarator] = STATE(249),
    [sym_storage_class_specifier] = STATE(257),
    [sym_type_qualifier] = STATE(257),
    [sym__type_specifier] = STATE(251),
    [sym_sized_type_specifier] = STATE(251),
    [sym_enum_specifier] = STATE(251),
    [sym_struct_specifier] = STATE(251),
    [sym_union_specifier] = STATE(251),
    [sym__field_declaration_list_item] = STATE(563),
    [sym_field_declaration] = STATE(563),
    [sym_macro_type_specifier] = STATE(251),
    [sym_class_specifier] = STATE(251),
    [sym_dependent_type] = STATE(251),
    [sym_template_declaration] = STATE(563),
    [sym_inline_method_definition] = STATE(252),
    [sym_constructor_or_destructor_definition] = STATE(252),
    [sym_constructor_or_destructor_declaration] = STATE(253),
    [sym_friend_declaration] = STATE(563),
    [sym_access_specifier] = STATE(563),
    [sym_reference_declarator] = STATE(249),
    [sym_template_type] = STATE(254),
    [sym_template_function] = STATE(249),
    [sym_using_declaration] = STATE(563),
    [sym_alias_declaration] = STATE(563),
    [sym_destructor_name] = STATE(249),
    [sym_scoped_identifier] = STATE(33),
    [sym_scoped_type_identifier] = STATE(34),
    [sym_scoped_namespace_identifier] = STATE(255),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(563),
    [aux_sym__declaration_specifiers_repeat1] = STATE(257),
    [aux_sym_sized_type_specifier_repeat1] = STATE(258),
    [anon_sym_LPAREN] = ACTIONS(11),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(358),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(360),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(362),
    [anon_sym_typedef] = ACTIONS(364),
    [anon_sym_extern] = ACTIONS(27),
    [anon_sym_RBRACE] = ACTIONS(4222),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_static] = ACTIONS(27),
    [anon_sym_register] = ACTIONS(27),
    [anon_sym_inline] = ACTIONS(27),
    [anon_sym_const] = ACTIONS(29),
    [anon_sym_restrict] = ACTIONS(29),
    [anon_sym_volatile] = ACTIONS(29),
    [anon_sym__Atomic] = ACTIONS(29),
    [anon_sym_mutable] = ACTIONS(29),
    [anon_sym_explicit] = ACTIONS(29),
    [anon_sym_constexpr] = ACTIONS(29),
    [anon_sym_unsigned] = ACTIONS(368),
    [anon_sym_long] = ACTIONS(368),
    [anon_sym_short] = ACTIONS(368),
    [sym_primitive_type] = ACTIONS(370),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(372),
    [anon_sym_union] = ACTIONS(374),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(45),
    [sym_identifier] = ACTIONS(376),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(378),
    [anon_sym_public] = ACTIONS(380),
    [sym_auto] = ACTIONS(370),
    [anon_sym_typename] = ACTIONS(382),
    [anon_sym_template] = ACTIONS(384),
    [anon_sym_friend] = ACTIONS(386),
    [anon_sym_private] = ACTIONS(380),
    [anon_sym_protected] = ACTIONS(380),
    [anon_sym_using] = ACTIONS(388),
    [anon_sym_COLON_COLON] = ACTIONS(390),
    [sym_operator_name] = ACTIONS(392),
  },
  [1300] = {
    [sym_identifier] = ACTIONS(4224),
    [sym_comment] = ACTIONS(49),
  },
  [1301] = {
    [sym_raw_string_literal] = ACTIONS(447),
    [anon_sym_LPAREN] = ACTIONS(447),
    [anon_sym_extern] = ACTIONS(449),
    [anon_sym_LBRACE] = ACTIONS(447),
    [anon_sym_STAR] = ACTIONS(447),
    [anon_sym_LBRACK] = ACTIONS(447),
    [anon_sym_RBRACK] = ACTIONS(447),
    [anon_sym_static] = ACTIONS(449),
    [anon_sym_register] = ACTIONS(449),
    [anon_sym_inline] = ACTIONS(449),
    [anon_sym_const] = ACTIONS(449),
    [anon_sym_restrict] = ACTIONS(449),
    [anon_sym_volatile] = ACTIONS(449),
    [anon_sym__Atomic] = ACTIONS(449),
    [anon_sym_mutable] = ACTIONS(449),
    [anon_sym_explicit] = ACTIONS(449),
    [anon_sym_constexpr] = ACTIONS(449),
    [anon_sym_COLON] = ACTIONS(449),
    [anon_sym_AMP] = ACTIONS(447),
    [anon_sym_BANG] = ACTIONS(447),
    [anon_sym_TILDE] = ACTIONS(447),
    [anon_sym_PLUS] = ACTIONS(449),
    [anon_sym_DASH] = ACTIONS(449),
    [anon_sym_DASH_DASH] = ACTIONS(447),
    [anon_sym_PLUS_PLUS] = ACTIONS(447),
    [anon_sym_sizeof] = ACTIONS(449),
    [sym_number_literal] = ACTIONS(447),
    [sym_char_literal] = ACTIONS(447),
    [sym_string_literal] = ACTIONS(447),
    [sym_true] = ACTIONS(449),
    [sym_false] = ACTIONS(449),
    [sym_null] = ACTIONS(449),
    [sym_identifier] = ACTIONS(449),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(449),
    [anon_sym_COLON_COLON] = ACTIONS(447),
    [anon_sym_delete] = ACTIONS(449),
    [sym_nullptr] = ACTIONS(449),
  },
  [1302] = {
    [sym_raw_string_literal] = ACTIONS(512),
    [anon_sym_LPAREN] = ACTIONS(512),
    [anon_sym_extern] = ACTIONS(514),
    [anon_sym_LBRACE] = ACTIONS(512),
    [anon_sym_STAR] = ACTIONS(512),
    [anon_sym_LBRACK] = ACTIONS(512),
    [anon_sym_RBRACK] = ACTIONS(512),
    [anon_sym_static] = ACTIONS(514),
    [anon_sym_register] = ACTIONS(514),
    [anon_sym_inline] = ACTIONS(514),
    [anon_sym_const] = ACTIONS(514),
    [anon_sym_restrict] = ACTIONS(514),
    [anon_sym_volatile] = ACTIONS(514),
    [anon_sym__Atomic] = ACTIONS(514),
    [anon_sym_mutable] = ACTIONS(514),
    [anon_sym_explicit] = ACTIONS(514),
    [anon_sym_constexpr] = ACTIONS(514),
    [anon_sym_COLON] = ACTIONS(514),
    [anon_sym_AMP] = ACTIONS(512),
    [anon_sym_BANG] = ACTIONS(512),
    [anon_sym_TILDE] = ACTIONS(512),
    [anon_sym_LT] = ACTIONS(512),
    [anon_sym_PLUS] = ACTIONS(514),
    [anon_sym_DASH] = ACTIONS(514),
    [anon_sym_DASH_DASH] = ACTIONS(512),
    [anon_sym_PLUS_PLUS] = ACTIONS(512),
    [anon_sym_sizeof] = ACTIONS(514),
    [sym_number_literal] = ACTIONS(512),
    [sym_char_literal] = ACTIONS(512),
    [sym_string_literal] = ACTIONS(512),
    [sym_true] = ACTIONS(514),
    [sym_false] = ACTIONS(514),
    [sym_null] = ACTIONS(514),
    [sym_identifier] = ACTIONS(514),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(514),
    [anon_sym_COLON_COLON] = ACTIONS(516),
    [anon_sym_delete] = ACTIONS(514),
    [sym_nullptr] = ACTIONS(514),
  },
  [1303] = {
    [sym_raw_string_literal] = ACTIONS(1075),
    [anon_sym_LPAREN] = ACTIONS(1075),
    [anon_sym_extern] = ACTIONS(1077),
    [anon_sym_STAR] = ACTIONS(1075),
    [anon_sym_LBRACK] = ACTIONS(1075),
    [anon_sym_RBRACK] = ACTIONS(1075),
    [anon_sym_static] = ACTIONS(1077),
    [anon_sym_register] = ACTIONS(1077),
    [anon_sym_inline] = ACTIONS(1077),
    [anon_sym_const] = ACTIONS(1077),
    [anon_sym_restrict] = ACTIONS(1077),
    [anon_sym_volatile] = ACTIONS(1077),
    [anon_sym__Atomic] = ACTIONS(1077),
    [anon_sym_mutable] = ACTIONS(1077),
    [anon_sym_explicit] = ACTIONS(1077),
    [anon_sym_constexpr] = ACTIONS(1077),
    [anon_sym_AMP] = ACTIONS(1075),
    [anon_sym_BANG] = ACTIONS(1075),
    [anon_sym_TILDE] = ACTIONS(1075),
    [anon_sym_PLUS] = ACTIONS(1077),
    [anon_sym_DASH] = ACTIONS(1077),
    [anon_sym_DASH_DASH] = ACTIONS(1075),
    [anon_sym_PLUS_PLUS] = ACTIONS(1075),
    [anon_sym_sizeof] = ACTIONS(1077),
    [sym_number_literal] = ACTIONS(1075),
    [sym_char_literal] = ACTIONS(1075),
    [sym_string_literal] = ACTIONS(1075),
    [sym_true] = ACTIONS(1077),
    [sym_false] = ACTIONS(1077),
    [sym_null] = ACTIONS(1077),
    [sym_identifier] = ACTIONS(1077),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(1077),
    [anon_sym_COLON_COLON] = ACTIONS(1075),
    [anon_sym_delete] = ACTIONS(1077),
    [sym_nullptr] = ACTIONS(1077),
  },
  [1304] = {
    [sym_field_declaration_list] = STATE(1862),
    [anon_sym_LBRACE] = ACTIONS(1453),
    [sym_comment] = ACTIONS(49),
  },
  [1305] = {
    [sym_identifier] = ACTIONS(4226),
    [sym_comment] = ACTIONS(49),
  },
  [1306] = {
    [sym_raw_string_literal] = ACTIONS(1081),
    [anon_sym_LPAREN] = ACTIONS(1081),
    [anon_sym_extern] = ACTIONS(1083),
    [anon_sym_STAR] = ACTIONS(1081),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_RBRACK] = ACTIONS(1081),
    [anon_sym_static] = ACTIONS(1083),
    [anon_sym_register] = ACTIONS(1083),
    [anon_sym_inline] = ACTIONS(1083),
    [anon_sym_const] = ACTIONS(1083),
    [anon_sym_restrict] = ACTIONS(1083),
    [anon_sym_volatile] = ACTIONS(1083),
    [anon_sym__Atomic] = ACTIONS(1083),
    [anon_sym_mutable] = ACTIONS(1083),
    [anon_sym_explicit] = ACTIONS(1083),
    [anon_sym_constexpr] = ACTIONS(1083),
    [anon_sym_AMP] = ACTIONS(1081),
    [anon_sym_BANG] = ACTIONS(1081),
    [anon_sym_TILDE] = ACTIONS(1081),
    [anon_sym_PLUS] = ACTIONS(1083),
    [anon_sym_DASH] = ACTIONS(1083),
    [anon_sym_DASH_DASH] = ACTIONS(1081),
    [anon_sym_PLUS_PLUS] = ACTIONS(1081),
    [anon_sym_sizeof] = ACTIONS(1083),
    [sym_number_literal] = ACTIONS(1081),
    [sym_char_literal] = ACTIONS(1081),
    [sym_string_literal] = ACTIONS(1081),
    [sym_true] = ACTIONS(1083),
    [sym_false] = ACTIONS(1083),
    [sym_null] = ACTIONS(1083),
    [sym_identifier] = ACTIONS(1083),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(1083),
    [anon_sym_COLON_COLON] = ACTIONS(1081),
    [anon_sym_delete] = ACTIONS(1083),
    [sym_nullptr] = ACTIONS(1083),
  },
  [1307] = {
    [sym_field_declaration_list] = STATE(1864),
    [anon_sym_LBRACE] = ACTIONS(1453),
    [sym_comment] = ACTIONS(49),
  },
  [1308] = {
    [anon_sym_RPAREN] = ACTIONS(4228),
    [sym_comment] = ACTIONS(49),
  },
  [1309] = {
    [aux_sym_concatenated_string_repeat1] = STATE(1309),
    [anon_sym_LPAREN] = ACTIONS(4230),
    [anon_sym_STAR] = ACTIONS(4232),
    [anon_sym_LBRACK] = ACTIONS(4230),
    [anon_sym_RBRACK] = ACTIONS(4230),
    [anon_sym_EQ] = ACTIONS(4232),
    [anon_sym_QMARK] = ACTIONS(4230),
    [anon_sym_STAR_EQ] = ACTIONS(4230),
    [anon_sym_SLASH_EQ] = ACTIONS(4230),
    [anon_sym_PERCENT_EQ] = ACTIONS(4230),
    [anon_sym_PLUS_EQ] = ACTIONS(4230),
    [anon_sym_DASH_EQ] = ACTIONS(4230),
    [anon_sym_LT_LT_EQ] = ACTIONS(4230),
    [anon_sym_GT_GT_EQ] = ACTIONS(4230),
    [anon_sym_AMP_EQ] = ACTIONS(4230),
    [anon_sym_CARET_EQ] = ACTIONS(4230),
    [anon_sym_PIPE_EQ] = ACTIONS(4230),
    [anon_sym_AMP] = ACTIONS(4232),
    [anon_sym_PIPE_PIPE] = ACTIONS(4230),
    [anon_sym_AMP_AMP] = ACTIONS(4230),
    [anon_sym_PIPE] = ACTIONS(4232),
    [anon_sym_CARET] = ACTIONS(4232),
    [anon_sym_EQ_EQ] = ACTIONS(4230),
    [anon_sym_BANG_EQ] = ACTIONS(4230),
    [anon_sym_LT] = ACTIONS(4232),
    [anon_sym_GT] = ACTIONS(4232),
    [anon_sym_LT_EQ] = ACTIONS(4230),
    [anon_sym_GT_EQ] = ACTIONS(4230),
    [anon_sym_LT_LT] = ACTIONS(4232),
    [anon_sym_GT_GT] = ACTIONS(4232),
    [anon_sym_PLUS] = ACTIONS(4232),
    [anon_sym_DASH] = ACTIONS(4232),
    [anon_sym_SLASH] = ACTIONS(4232),
    [anon_sym_PERCENT] = ACTIONS(4232),
    [anon_sym_DASH_DASH] = ACTIONS(4230),
    [anon_sym_PLUS_PLUS] = ACTIONS(4230),
    [anon_sym_DOT] = ACTIONS(4230),
    [anon_sym_DASH_GT] = ACTIONS(4230),
    [sym_string_literal] = ACTIONS(4234),
    [sym_comment] = ACTIONS(49),
  },
  [1310] = {
    [sym_raw_string_literal] = ACTIONS(1111),
    [anon_sym_LPAREN] = ACTIONS(1111),
    [anon_sym_extern] = ACTIONS(1113),
    [anon_sym_LBRACE] = ACTIONS(1111),
    [anon_sym_STAR] = ACTIONS(1113),
    [anon_sym_LBRACK] = ACTIONS(1111),
    [anon_sym_RBRACK] = ACTIONS(1111),
    [anon_sym_EQ] = ACTIONS(1113),
    [anon_sym_static] = ACTIONS(1113),
    [anon_sym_register] = ACTIONS(1113),
    [anon_sym_inline] = ACTIONS(1113),
    [anon_sym_const] = ACTIONS(1113),
    [anon_sym_restrict] = ACTIONS(1113),
    [anon_sym_volatile] = ACTIONS(1113),
    [anon_sym__Atomic] = ACTIONS(1113),
    [anon_sym_mutable] = ACTIONS(1113),
    [anon_sym_explicit] = ACTIONS(1113),
    [anon_sym_constexpr] = ACTIONS(1113),
    [anon_sym_QMARK] = ACTIONS(1111),
    [anon_sym_STAR_EQ] = ACTIONS(1111),
    [anon_sym_SLASH_EQ] = ACTIONS(1111),
    [anon_sym_PERCENT_EQ] = ACTIONS(1111),
    [anon_sym_PLUS_EQ] = ACTIONS(1111),
    [anon_sym_DASH_EQ] = ACTIONS(1111),
    [anon_sym_LT_LT_EQ] = ACTIONS(1111),
    [anon_sym_GT_GT_EQ] = ACTIONS(1111),
    [anon_sym_AMP_EQ] = ACTIONS(1111),
    [anon_sym_CARET_EQ] = ACTIONS(1111),
    [anon_sym_PIPE_EQ] = ACTIONS(1111),
    [anon_sym_AMP] = ACTIONS(1113),
    [anon_sym_PIPE_PIPE] = ACTIONS(1111),
    [anon_sym_AMP_AMP] = ACTIONS(1111),
    [anon_sym_BANG] = ACTIONS(1113),
    [anon_sym_PIPE] = ACTIONS(1113),
    [anon_sym_CARET] = ACTIONS(1113),
    [anon_sym_TILDE] = ACTIONS(1111),
    [anon_sym_EQ_EQ] = ACTIONS(1111),
    [anon_sym_BANG_EQ] = ACTIONS(1111),
    [anon_sym_LT] = ACTIONS(1113),
    [anon_sym_GT] = ACTIONS(1113),
    [anon_sym_LT_EQ] = ACTIONS(1111),
    [anon_sym_GT_EQ] = ACTIONS(1111),
    [anon_sym_LT_LT] = ACTIONS(1113),
    [anon_sym_GT_GT] = ACTIONS(1113),
    [anon_sym_PLUS] = ACTIONS(1113),
    [anon_sym_DASH] = ACTIONS(1113),
    [anon_sym_SLASH] = ACTIONS(1113),
    [anon_sym_PERCENT] = ACTIONS(1113),
    [anon_sym_DASH_DASH] = ACTIONS(1111),
    [anon_sym_PLUS_PLUS] = ACTIONS(1111),
    [anon_sym_sizeof] = ACTIONS(1113),
    [anon_sym_DOT] = ACTIONS(1111),
    [anon_sym_DASH_GT] = ACTIONS(1111),
    [sym_number_literal] = ACTIONS(1111),
    [sym_char_literal] = ACTIONS(1111),
    [sym_string_literal] = ACTIONS(1111),
    [sym_true] = ACTIONS(1113),
    [sym_false] = ACTIONS(1113),
    [sym_null] = ACTIONS(1113),
    [sym_identifier] = ACTIONS(1113),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(1113),
    [anon_sym_COLON_COLON] = ACTIONS(1111),
    [anon_sym_delete] = ACTIONS(1113),
    [sym_nullptr] = ACTIONS(1113),
  },
  [1311] = {
    [aux_sym_template_argument_list_repeat1] = STATE(1867),
    [anon_sym_COMMA] = ACTIONS(1127),
    [anon_sym_GT] = ACTIONS(4237),
    [sym_comment] = ACTIONS(49),
  },
  [1312] = {
    [sym_raw_string_literal] = ACTIONS(1140),
    [anon_sym_LPAREN] = ACTIONS(1137),
    [anon_sym_extern] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(1140),
    [anon_sym_STAR] = ACTIONS(4239),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [anon_sym_RBRACK] = ACTIONS(1137),
    [anon_sym_EQ] = ACTIONS(1148),
    [anon_sym_static] = ACTIONS(1142),
    [anon_sym_register] = ACTIONS(1142),
    [anon_sym_inline] = ACTIONS(1142),
    [anon_sym_const] = ACTIONS(1142),
    [anon_sym_restrict] = ACTIONS(1142),
    [anon_sym_volatile] = ACTIONS(1142),
    [anon_sym__Atomic] = ACTIONS(1142),
    [anon_sym_mutable] = ACTIONS(1142),
    [anon_sym_explicit] = ACTIONS(1142),
    [anon_sym_constexpr] = ACTIONS(1142),
    [anon_sym_QMARK] = ACTIONS(1146),
    [anon_sym_STAR_EQ] = ACTIONS(1146),
    [anon_sym_SLASH_EQ] = ACTIONS(1146),
    [anon_sym_PERCENT_EQ] = ACTIONS(1146),
    [anon_sym_PLUS_EQ] = ACTIONS(1146),
    [anon_sym_DASH_EQ] = ACTIONS(1146),
    [anon_sym_LT_LT_EQ] = ACTIONS(1146),
    [anon_sym_GT_GT_EQ] = ACTIONS(1146),
    [anon_sym_AMP_EQ] = ACTIONS(1146),
    [anon_sym_CARET_EQ] = ACTIONS(1146),
    [anon_sym_PIPE_EQ] = ACTIONS(1146),
    [anon_sym_AMP] = ACTIONS(4239),
    [anon_sym_PIPE_PIPE] = ACTIONS(1146),
    [anon_sym_AMP_AMP] = ACTIONS(1146),
    [anon_sym_BANG] = ACTIONS(1142),
    [anon_sym_PIPE] = ACTIONS(1148),
    [anon_sym_CARET] = ACTIONS(1148),
    [anon_sym_TILDE] = ACTIONS(1140),
    [anon_sym_EQ_EQ] = ACTIONS(1146),
    [anon_sym_BANG_EQ] = ACTIONS(1146),
    [anon_sym_LT] = ACTIONS(4239),
    [anon_sym_GT] = ACTIONS(1148),
    [anon_sym_LT_EQ] = ACTIONS(1146),
    [anon_sym_GT_EQ] = ACTIONS(1146),
    [anon_sym_LT_LT] = ACTIONS(1148),
    [anon_sym_GT_GT] = ACTIONS(1148),
    [anon_sym_PLUS] = ACTIONS(4239),
    [anon_sym_DASH] = ACTIONS(4239),
    [anon_sym_SLASH] = ACTIONS(1148),
    [anon_sym_PERCENT] = ACTIONS(1148),
    [anon_sym_DASH_DASH] = ACTIONS(1137),
    [anon_sym_PLUS_PLUS] = ACTIONS(1137),
    [anon_sym_sizeof] = ACTIONS(1142),
    [anon_sym_DOT] = ACTIONS(1146),
    [anon_sym_DASH_GT] = ACTIONS(1146),
    [sym_number_literal] = ACTIONS(1140),
    [sym_char_literal] = ACTIONS(1140),
    [sym_string_literal] = ACTIONS(1140),
    [sym_true] = ACTIONS(1142),
    [sym_false] = ACTIONS(1142),
    [sym_null] = ACTIONS(1142),
    [sym_identifier] = ACTIONS(1142),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(1142),
    [anon_sym_COLON_COLON] = ACTIONS(1144),
    [anon_sym_delete] = ACTIONS(1142),
    [sym_nullptr] = ACTIONS(1142),
  },
  [1313] = {
    [sym_raw_string_literal] = ACTIONS(1150),
    [anon_sym_LPAREN] = ACTIONS(1150),
    [anon_sym_extern] = ACTIONS(1152),
    [anon_sym_STAR] = ACTIONS(1150),
    [anon_sym_LBRACK] = ACTIONS(1150),
    [anon_sym_RBRACK] = ACTIONS(1150),
    [anon_sym_static] = ACTIONS(1152),
    [anon_sym_register] = ACTIONS(1152),
    [anon_sym_inline] = ACTIONS(1152),
    [anon_sym_const] = ACTIONS(1152),
    [anon_sym_restrict] = ACTIONS(1152),
    [anon_sym_volatile] = ACTIONS(1152),
    [anon_sym__Atomic] = ACTIONS(1152),
    [anon_sym_mutable] = ACTIONS(1152),
    [anon_sym_explicit] = ACTIONS(1152),
    [anon_sym_constexpr] = ACTIONS(1152),
    [anon_sym_AMP] = ACTIONS(1150),
    [anon_sym_BANG] = ACTIONS(1150),
    [anon_sym_TILDE] = ACTIONS(1150),
    [anon_sym_PLUS] = ACTIONS(1152),
    [anon_sym_DASH] = ACTIONS(1152),
    [anon_sym_DASH_DASH] = ACTIONS(1150),
    [anon_sym_PLUS_PLUS] = ACTIONS(1150),
    [anon_sym_sizeof] = ACTIONS(1152),
    [sym_number_literal] = ACTIONS(1150),
    [sym_char_literal] = ACTIONS(1150),
    [sym_string_literal] = ACTIONS(1150),
    [sym_true] = ACTIONS(1152),
    [sym_false] = ACTIONS(1152),
    [sym_null] = ACTIONS(1152),
    [sym_identifier] = ACTIONS(1152),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(1152),
    [anon_sym_COLON_COLON] = ACTIONS(1150),
    [anon_sym_delete] = ACTIONS(1152),
    [sym_nullptr] = ACTIONS(1152),
  },
  [1314] = {
    [sym_field_declaration_list] = STATE(1868),
    [anon_sym_LBRACE] = ACTIONS(1453),
    [sym_comment] = ACTIONS(49),
  },
  [1315] = {
    [sym__expression] = STATE(1869),
    [sym_conditional_expression] = STATE(1869),
    [sym_assignment_expression] = STATE(1869),
    [sym_pointer_expression] = STATE(1869),
    [sym_logical_expression] = STATE(1869),
    [sym_bitwise_expression] = STATE(1869),
    [sym_equality_expression] = STATE(1869),
    [sym_relational_expression] = STATE(1869),
    [sym_shift_expression] = STATE(1869),
    [sym_math_expression] = STATE(1869),
    [sym_cast_expression] = STATE(1869),
    [sym_sizeof_expression] = STATE(1869),
    [sym_subscript_expression] = STATE(1869),
    [sym_call_expression] = STATE(1869),
    [sym_field_expression] = STATE(1869),
    [sym_compound_literal_expression] = STATE(1869),
    [sym_parenthesized_expression] = STATE(1869),
    [sym_concatenated_string] = STATE(1869),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(1869),
    [sym_new_expression] = STATE(1869),
    [sym_delete_expression] = STATE(1869),
    [sym_lambda_expression] = STATE(1869),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(4242),
    [anon_sym_LPAREN] = ACTIONS(566),
    [anon_sym_STAR] = ACTIONS(568),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_AMP] = ACTIONS(568),
    [anon_sym_BANG] = ACTIONS(584),
    [anon_sym_TILDE] = ACTIONS(586),
    [anon_sym_PLUS] = ACTIONS(588),
    [anon_sym_DASH] = ACTIONS(588),
    [anon_sym_DASH_DASH] = ACTIONS(590),
    [anon_sym_PLUS_PLUS] = ACTIONS(590),
    [anon_sym_sizeof] = ACTIONS(592),
    [sym_number_literal] = ACTIONS(4242),
    [sym_char_literal] = ACTIONS(4242),
    [sym_string_literal] = ACTIONS(594),
    [sym_true] = ACTIONS(4244),
    [sym_false] = ACTIONS(4244),
    [sym_null] = ACTIONS(4244),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1415),
    [anon_sym_delete] = ACTIONS(608),
    [sym_nullptr] = ACTIONS(4244),
  },
  [1316] = {
    [anon_sym_LPAREN] = ACTIONS(4246),
    [anon_sym_COMMA] = ACTIONS(4246),
    [anon_sym_RPAREN] = ACTIONS(4246),
    [anon_sym_SEMI] = ACTIONS(4246),
    [anon_sym_RBRACE] = ACTIONS(4246),
    [anon_sym_STAR] = ACTIONS(4248),
    [anon_sym_LBRACK] = ACTIONS(4246),
    [anon_sym_RBRACK] = ACTIONS(4246),
    [anon_sym_EQ] = ACTIONS(4248),
    [anon_sym_COLON] = ACTIONS(4246),
    [anon_sym_QMARK] = ACTIONS(4246),
    [anon_sym_STAR_EQ] = ACTIONS(4246),
    [anon_sym_SLASH_EQ] = ACTIONS(4246),
    [anon_sym_PERCENT_EQ] = ACTIONS(4246),
    [anon_sym_PLUS_EQ] = ACTIONS(4246),
    [anon_sym_DASH_EQ] = ACTIONS(4246),
    [anon_sym_LT_LT_EQ] = ACTIONS(4246),
    [anon_sym_GT_GT_EQ] = ACTIONS(4246),
    [anon_sym_AMP_EQ] = ACTIONS(4246),
    [anon_sym_CARET_EQ] = ACTIONS(4246),
    [anon_sym_PIPE_EQ] = ACTIONS(4246),
    [anon_sym_AMP] = ACTIONS(4248),
    [anon_sym_PIPE_PIPE] = ACTIONS(4246),
    [anon_sym_AMP_AMP] = ACTIONS(4246),
    [anon_sym_PIPE] = ACTIONS(4248),
    [anon_sym_CARET] = ACTIONS(4248),
    [anon_sym_EQ_EQ] = ACTIONS(4246),
    [anon_sym_BANG_EQ] = ACTIONS(4246),
    [anon_sym_LT] = ACTIONS(4248),
    [anon_sym_GT] = ACTIONS(4248),
    [anon_sym_LT_EQ] = ACTIONS(4246),
    [anon_sym_GT_EQ] = ACTIONS(4246),
    [anon_sym_LT_LT] = ACTIONS(4248),
    [anon_sym_GT_GT] = ACTIONS(4248),
    [anon_sym_PLUS] = ACTIONS(4248),
    [anon_sym_DASH] = ACTIONS(4248),
    [anon_sym_SLASH] = ACTIONS(4248),
    [anon_sym_PERCENT] = ACTIONS(4248),
    [anon_sym_DASH_DASH] = ACTIONS(4246),
    [anon_sym_PLUS_PLUS] = ACTIONS(4246),
    [anon_sym_DOT] = ACTIONS(4246),
    [anon_sym_DASH_GT] = ACTIONS(4246),
    [sym_comment] = ACTIONS(49),
  },
  [1317] = {
    [sym_argument_list] = STATE(1870),
    [sym_initializer_list] = STATE(1870),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_LBRACE] = ACTIONS(548),
    [sym_comment] = ACTIONS(49),
  },
  [1318] = {
    [sym_argument_list] = STATE(1871),
    [sym_initializer_list] = STATE(1871),
    [sym_template_argument_list] = STATE(203),
    [sym_new_declarator] = STATE(1872),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_LBRACE] = ACTIONS(548),
    [anon_sym_LBRACK] = ACTIONS(2723),
    [anon_sym_LT] = ACTIONS(146),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(321),
  },
  [1319] = {
    [sym_argument_list] = STATE(1873),
    [sym_initializer_list] = STATE(1873),
    [sym_template_argument_list] = STATE(141),
    [sym_new_declarator] = STATE(1874),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_LBRACE] = ACTIONS(548),
    [anon_sym_LBRACK] = ACTIONS(2723),
    [anon_sym_LT] = ACTIONS(146),
    [sym_comment] = ACTIONS(49),
  },
  [1320] = {
    [anon_sym_LPAREN] = ACTIONS(4250),
    [anon_sym_COMMA] = ACTIONS(4250),
    [anon_sym_RPAREN] = ACTIONS(4250),
    [anon_sym_SEMI] = ACTIONS(4250),
    [anon_sym_RBRACE] = ACTIONS(4250),
    [anon_sym_STAR] = ACTIONS(4252),
    [anon_sym_LBRACK] = ACTIONS(4250),
    [anon_sym_RBRACK] = ACTIONS(4250),
    [anon_sym_EQ] = ACTIONS(4252),
    [anon_sym_COLON] = ACTIONS(4250),
    [anon_sym_QMARK] = ACTIONS(4250),
    [anon_sym_STAR_EQ] = ACTIONS(4250),
    [anon_sym_SLASH_EQ] = ACTIONS(4250),
    [anon_sym_PERCENT_EQ] = ACTIONS(4250),
    [anon_sym_PLUS_EQ] = ACTIONS(4250),
    [anon_sym_DASH_EQ] = ACTIONS(4250),
    [anon_sym_LT_LT_EQ] = ACTIONS(4250),
    [anon_sym_GT_GT_EQ] = ACTIONS(4250),
    [anon_sym_AMP_EQ] = ACTIONS(4250),
    [anon_sym_CARET_EQ] = ACTIONS(4250),
    [anon_sym_PIPE_EQ] = ACTIONS(4250),
    [anon_sym_AMP] = ACTIONS(4252),
    [anon_sym_PIPE_PIPE] = ACTIONS(4250),
    [anon_sym_AMP_AMP] = ACTIONS(4250),
    [anon_sym_PIPE] = ACTIONS(4252),
    [anon_sym_CARET] = ACTIONS(4252),
    [anon_sym_EQ_EQ] = ACTIONS(4250),
    [anon_sym_BANG_EQ] = ACTIONS(4250),
    [anon_sym_LT] = ACTIONS(4252),
    [anon_sym_GT] = ACTIONS(4252),
    [anon_sym_LT_EQ] = ACTIONS(4250),
    [anon_sym_GT_EQ] = ACTIONS(4250),
    [anon_sym_LT_LT] = ACTIONS(4252),
    [anon_sym_GT_GT] = ACTIONS(4252),
    [anon_sym_PLUS] = ACTIONS(4252),
    [anon_sym_DASH] = ACTIONS(4252),
    [anon_sym_SLASH] = ACTIONS(4252),
    [anon_sym_PERCENT] = ACTIONS(4252),
    [anon_sym_DASH_DASH] = ACTIONS(4250),
    [anon_sym_PLUS_PLUS] = ACTIONS(4250),
    [anon_sym_DOT] = ACTIONS(4250),
    [anon_sym_DASH_GT] = ACTIONS(4250),
    [sym_comment] = ACTIONS(49),
  },
  [1321] = {
    [sym_argument_list] = STATE(1873),
    [sym_initializer_list] = STATE(1873),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_LBRACE] = ACTIONS(548),
    [sym_comment] = ACTIONS(49),
  },
  [1322] = {
    [anon_sym_LPAREN] = ACTIONS(420),
    [anon_sym_COMMA] = ACTIONS(420),
    [anon_sym_RPAREN] = ACTIONS(420),
    [anon_sym_SEMI] = ACTIONS(420),
    [anon_sym_RBRACE] = ACTIONS(420),
    [anon_sym_STAR] = ACTIONS(4254),
    [anon_sym_LBRACK] = ACTIONS(420),
    [anon_sym_RBRACK] = ACTIONS(420),
    [anon_sym_EQ] = ACTIONS(4254),
    [anon_sym_COLON] = ACTIONS(420),
    [anon_sym_QMARK] = ACTIONS(420),
    [anon_sym_STAR_EQ] = ACTIONS(420),
    [anon_sym_SLASH_EQ] = ACTIONS(420),
    [anon_sym_PERCENT_EQ] = ACTIONS(420),
    [anon_sym_PLUS_EQ] = ACTIONS(420),
    [anon_sym_DASH_EQ] = ACTIONS(420),
    [anon_sym_LT_LT_EQ] = ACTIONS(420),
    [anon_sym_GT_GT_EQ] = ACTIONS(420),
    [anon_sym_AMP_EQ] = ACTIONS(420),
    [anon_sym_CARET_EQ] = ACTIONS(420),
    [anon_sym_PIPE_EQ] = ACTIONS(420),
    [anon_sym_AMP] = ACTIONS(4254),
    [anon_sym_PIPE_PIPE] = ACTIONS(420),
    [anon_sym_AMP_AMP] = ACTIONS(420),
    [anon_sym_PIPE] = ACTIONS(4254),
    [anon_sym_CARET] = ACTIONS(4254),
    [anon_sym_EQ_EQ] = ACTIONS(420),
    [anon_sym_BANG_EQ] = ACTIONS(420),
    [anon_sym_LT] = ACTIONS(4254),
    [anon_sym_GT] = ACTIONS(4254),
    [anon_sym_LT_EQ] = ACTIONS(420),
    [anon_sym_GT_EQ] = ACTIONS(420),
    [anon_sym_LT_LT] = ACTIONS(4254),
    [anon_sym_GT_GT] = ACTIONS(4254),
    [anon_sym_PLUS] = ACTIONS(4254),
    [anon_sym_DASH] = ACTIONS(4254),
    [anon_sym_SLASH] = ACTIONS(4254),
    [anon_sym_PERCENT] = ACTIONS(4254),
    [anon_sym_DASH_DASH] = ACTIONS(420),
    [anon_sym_PLUS_PLUS] = ACTIONS(420),
    [anon_sym_DOT] = ACTIONS(420),
    [anon_sym_DASH_GT] = ACTIONS(420),
    [sym_comment] = ACTIONS(49),
  },
  [1323] = {
    [sym__expression] = STATE(740),
    [sym_conditional_expression] = STATE(740),
    [sym_assignment_expression] = STATE(740),
    [sym_pointer_expression] = STATE(740),
    [sym_logical_expression] = STATE(740),
    [sym_bitwise_expression] = STATE(740),
    [sym_equality_expression] = STATE(740),
    [sym_relational_expression] = STATE(740),
    [sym_shift_expression] = STATE(740),
    [sym_math_expression] = STATE(740),
    [sym_cast_expression] = STATE(740),
    [sym_sizeof_expression] = STATE(740),
    [sym_subscript_expression] = STATE(740),
    [sym_call_expression] = STATE(740),
    [sym_field_expression] = STATE(740),
    [sym_compound_literal_expression] = STATE(740),
    [sym_parenthesized_expression] = STATE(740),
    [sym_concatenated_string] = STATE(740),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(740),
    [sym_new_expression] = STATE(740),
    [sym_delete_expression] = STATE(740),
    [sym_lambda_expression] = STATE(740),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_lambda_default_capture] = STATE(741),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(1417),
    [anon_sym_LPAREN] = ACTIONS(1419),
    [anon_sym_STAR] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_RBRACK] = ACTIONS(4256),
    [anon_sym_EQ] = ACTIONS(1425),
    [anon_sym_AMP] = ACTIONS(1427),
    [anon_sym_BANG] = ACTIONS(1429),
    [anon_sym_TILDE] = ACTIONS(1431),
    [anon_sym_PLUS] = ACTIONS(1433),
    [anon_sym_DASH] = ACTIONS(1433),
    [anon_sym_DASH_DASH] = ACTIONS(1435),
    [anon_sym_PLUS_PLUS] = ACTIONS(1435),
    [anon_sym_sizeof] = ACTIONS(1437),
    [sym_number_literal] = ACTIONS(1417),
    [sym_char_literal] = ACTIONS(1417),
    [sym_string_literal] = ACTIONS(1439),
    [sym_true] = ACTIONS(1441),
    [sym_false] = ACTIONS(1441),
    [sym_null] = ACTIONS(1441),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1443),
    [anon_sym_delete] = ACTIONS(1445),
    [sym_nullptr] = ACTIONS(1441),
  },
  [1324] = {
    [sym_argument_list] = STATE(802),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_STAR] = ACTIONS(1522),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_RBRACK] = ACTIONS(4258),
    [anon_sym_EQ] = ACTIONS(4260),
    [anon_sym_QMARK] = ACTIONS(4258),
    [anon_sym_STAR_EQ] = ACTIONS(4258),
    [anon_sym_SLASH_EQ] = ACTIONS(4258),
    [anon_sym_PERCENT_EQ] = ACTIONS(4258),
    [anon_sym_PLUS_EQ] = ACTIONS(4258),
    [anon_sym_DASH_EQ] = ACTIONS(4258),
    [anon_sym_LT_LT_EQ] = ACTIONS(4258),
    [anon_sym_GT_GT_EQ] = ACTIONS(4258),
    [anon_sym_AMP_EQ] = ACTIONS(4258),
    [anon_sym_CARET_EQ] = ACTIONS(4258),
    [anon_sym_PIPE_EQ] = ACTIONS(4258),
    [anon_sym_AMP] = ACTIONS(1532),
    [anon_sym_PIPE_PIPE] = ACTIONS(1534),
    [anon_sym_AMP_AMP] = ACTIONS(1536),
    [anon_sym_PIPE] = ACTIONS(1538),
    [anon_sym_CARET] = ACTIONS(1540),
    [anon_sym_EQ_EQ] = ACTIONS(1542),
    [anon_sym_BANG_EQ] = ACTIONS(1542),
    [anon_sym_LT] = ACTIONS(1544),
    [anon_sym_GT] = ACTIONS(1544),
    [anon_sym_LT_EQ] = ACTIONS(1546),
    [anon_sym_GT_EQ] = ACTIONS(1546),
    [anon_sym_LT_LT] = ACTIONS(1548),
    [anon_sym_GT_GT] = ACTIONS(1548),
    [anon_sym_PLUS] = ACTIONS(1550),
    [anon_sym_DASH] = ACTIONS(1550),
    [anon_sym_SLASH] = ACTIONS(1522),
    [anon_sym_PERCENT] = ACTIONS(1522),
    [anon_sym_DASH_DASH] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(1554),
    [anon_sym_DASH_GT] = ACTIONS(1554),
    [sym_comment] = ACTIONS(49),
  },
  [1325] = {
    [sym__expression] = STATE(1876),
    [sym_conditional_expression] = STATE(1876),
    [sym_assignment_expression] = STATE(1876),
    [sym_pointer_expression] = STATE(1876),
    [sym_logical_expression] = STATE(1876),
    [sym_bitwise_expression] = STATE(1876),
    [sym_equality_expression] = STATE(1876),
    [sym_relational_expression] = STATE(1876),
    [sym_shift_expression] = STATE(1876),
    [sym_math_expression] = STATE(1876),
    [sym_cast_expression] = STATE(1876),
    [sym_sizeof_expression] = STATE(1876),
    [sym_subscript_expression] = STATE(1876),
    [sym_call_expression] = STATE(1876),
    [sym_field_expression] = STATE(1876),
    [sym_compound_literal_expression] = STATE(1876),
    [sym_parenthesized_expression] = STATE(1876),
    [sym_concatenated_string] = STATE(1876),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(1876),
    [sym_new_expression] = STATE(1876),
    [sym_delete_expression] = STATE(1876),
    [sym_lambda_expression] = STATE(1876),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(4262),
    [anon_sym_LPAREN] = ACTIONS(2624),
    [anon_sym_STAR] = ACTIONS(2624),
    [anon_sym_LBRACK] = ACTIONS(2624),
    [anon_sym_AMP] = ACTIONS(2626),
    [anon_sym_AMP_AMP] = ACTIONS(2624),
    [anon_sym_BANG] = ACTIONS(584),
    [anon_sym_TILDE] = ACTIONS(586),
    [anon_sym_PLUS] = ACTIONS(588),
    [anon_sym_DASH] = ACTIONS(588),
    [anon_sym_DASH_DASH] = ACTIONS(590),
    [anon_sym_PLUS_PLUS] = ACTIONS(590),
    [anon_sym_sizeof] = ACTIONS(592),
    [sym_number_literal] = ACTIONS(4262),
    [sym_char_literal] = ACTIONS(4262),
    [sym_string_literal] = ACTIONS(594),
    [sym_true] = ACTIONS(4264),
    [sym_false] = ACTIONS(4264),
    [sym_null] = ACTIONS(4264),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1415),
    [anon_sym_delete] = ACTIONS(608),
    [sym_nullptr] = ACTIONS(4264),
  },
  [1326] = {
    [anon_sym_LPAREN] = ACTIONS(4266),
    [anon_sym_COMMA] = ACTIONS(4266),
    [anon_sym_RPAREN] = ACTIONS(4266),
    [anon_sym_SEMI] = ACTIONS(4266),
    [anon_sym_LBRACE] = ACTIONS(4266),
    [anon_sym_LBRACK] = ACTIONS(4266),
    [anon_sym_EQ] = ACTIONS(4266),
    [anon_sym_COLON] = ACTIONS(4266),
    [anon_sym_GT] = ACTIONS(4266),
    [sym_comment] = ACTIONS(49),
  },
  [1327] = {
    [sym_storage_class_specifier] = STATE(1327),
    [sym_type_qualifier] = STATE(1327),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1327),
    [sym_raw_string_literal] = ACTIONS(798),
    [anon_sym_LPAREN] = ACTIONS(798),
    [anon_sym_extern] = ACTIONS(4268),
    [anon_sym_STAR] = ACTIONS(798),
    [anon_sym_LBRACK] = ACTIONS(798),
    [anon_sym_RBRACK] = ACTIONS(798),
    [anon_sym_static] = ACTIONS(4268),
    [anon_sym_register] = ACTIONS(4268),
    [anon_sym_inline] = ACTIONS(4268),
    [anon_sym_const] = ACTIONS(4271),
    [anon_sym_restrict] = ACTIONS(4271),
    [anon_sym_volatile] = ACTIONS(4271),
    [anon_sym__Atomic] = ACTIONS(4271),
    [anon_sym_mutable] = ACTIONS(4271),
    [anon_sym_explicit] = ACTIONS(4271),
    [anon_sym_constexpr] = ACTIONS(4271),
    [anon_sym_AMP] = ACTIONS(798),
    [anon_sym_BANG] = ACTIONS(798),
    [anon_sym_TILDE] = ACTIONS(798),
    [anon_sym_PLUS] = ACTIONS(806),
    [anon_sym_DASH] = ACTIONS(806),
    [anon_sym_DASH_DASH] = ACTIONS(798),
    [anon_sym_PLUS_PLUS] = ACTIONS(798),
    [anon_sym_sizeof] = ACTIONS(806),
    [sym_number_literal] = ACTIONS(798),
    [sym_char_literal] = ACTIONS(798),
    [sym_string_literal] = ACTIONS(798),
    [sym_true] = ACTIONS(806),
    [sym_false] = ACTIONS(806),
    [sym_null] = ACTIONS(806),
    [sym_identifier] = ACTIONS(806),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(806),
    [anon_sym_COLON_COLON] = ACTIONS(798),
    [anon_sym_delete] = ACTIONS(806),
    [sym_nullptr] = ACTIONS(806),
  },
  [1328] = {
    [sym_argument_list] = STATE(802),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_COMMA] = ACTIONS(4274),
    [anon_sym_RPAREN] = ACTIONS(4274),
    [anon_sym_SEMI] = ACTIONS(4274),
    [anon_sym_RBRACE] = ACTIONS(4274),
    [anon_sym_STAR] = ACTIONS(4276),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_RBRACK] = ACTIONS(4274),
    [anon_sym_EQ] = ACTIONS(4276),
    [anon_sym_QMARK] = ACTIONS(4274),
    [anon_sym_STAR_EQ] = ACTIONS(4274),
    [anon_sym_SLASH_EQ] = ACTIONS(4274),
    [anon_sym_PERCENT_EQ] = ACTIONS(4274),
    [anon_sym_PLUS_EQ] = ACTIONS(4274),
    [anon_sym_DASH_EQ] = ACTIONS(4274),
    [anon_sym_LT_LT_EQ] = ACTIONS(4274),
    [anon_sym_GT_GT_EQ] = ACTIONS(4274),
    [anon_sym_AMP_EQ] = ACTIONS(4274),
    [anon_sym_CARET_EQ] = ACTIONS(4274),
    [anon_sym_PIPE_EQ] = ACTIONS(4274),
    [anon_sym_AMP] = ACTIONS(4276),
    [anon_sym_PIPE_PIPE] = ACTIONS(4274),
    [anon_sym_AMP_AMP] = ACTIONS(4274),
    [anon_sym_PIPE] = ACTIONS(4276),
    [anon_sym_CARET] = ACTIONS(4276),
    [anon_sym_EQ_EQ] = ACTIONS(4274),
    [anon_sym_BANG_EQ] = ACTIONS(4274),
    [anon_sym_LT] = ACTIONS(4276),
    [anon_sym_GT] = ACTIONS(4276),
    [anon_sym_LT_EQ] = ACTIONS(4274),
    [anon_sym_GT_EQ] = ACTIONS(4274),
    [anon_sym_LT_LT] = ACTIONS(4276),
    [anon_sym_GT_GT] = ACTIONS(4276),
    [anon_sym_PLUS] = ACTIONS(4276),
    [anon_sym_DASH] = ACTIONS(4276),
    [anon_sym_SLASH] = ACTIONS(4276),
    [anon_sym_PERCENT] = ACTIONS(4276),
    [anon_sym_DASH_DASH] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(1554),
    [anon_sym_DASH_GT] = ACTIONS(1554),
    [sym_comment] = ACTIONS(49),
  },
  [1329] = {
    [sym_argument_list] = STATE(802),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_STAR] = ACTIONS(1522),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_RBRACK] = ACTIONS(4278),
    [anon_sym_EQ] = ACTIONS(1526),
    [anon_sym_QMARK] = ACTIONS(1528),
    [anon_sym_STAR_EQ] = ACTIONS(1530),
    [anon_sym_SLASH_EQ] = ACTIONS(1530),
    [anon_sym_PERCENT_EQ] = ACTIONS(1530),
    [anon_sym_PLUS_EQ] = ACTIONS(1530),
    [anon_sym_DASH_EQ] = ACTIONS(1530),
    [anon_sym_LT_LT_EQ] = ACTIONS(1530),
    [anon_sym_GT_GT_EQ] = ACTIONS(1530),
    [anon_sym_AMP_EQ] = ACTIONS(1530),
    [anon_sym_CARET_EQ] = ACTIONS(1530),
    [anon_sym_PIPE_EQ] = ACTIONS(1530),
    [anon_sym_AMP] = ACTIONS(1532),
    [anon_sym_PIPE_PIPE] = ACTIONS(1534),
    [anon_sym_AMP_AMP] = ACTIONS(1536),
    [anon_sym_PIPE] = ACTIONS(1538),
    [anon_sym_CARET] = ACTIONS(1540),
    [anon_sym_EQ_EQ] = ACTIONS(1542),
    [anon_sym_BANG_EQ] = ACTIONS(1542),
    [anon_sym_LT] = ACTIONS(1544),
    [anon_sym_GT] = ACTIONS(1544),
    [anon_sym_LT_EQ] = ACTIONS(1546),
    [anon_sym_GT_EQ] = ACTIONS(1546),
    [anon_sym_LT_LT] = ACTIONS(1548),
    [anon_sym_GT_GT] = ACTIONS(1548),
    [anon_sym_PLUS] = ACTIONS(1550),
    [anon_sym_DASH] = ACTIONS(1550),
    [anon_sym_SLASH] = ACTIONS(1522),
    [anon_sym_PERCENT] = ACTIONS(1522),
    [anon_sym_DASH_DASH] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(1554),
    [anon_sym_DASH_GT] = ACTIONS(1554),
    [sym_comment] = ACTIONS(49),
  },
  [1330] = {
    [sym_argument_list] = STATE(802),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_STAR] = ACTIONS(1522),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_RBRACK] = ACTIONS(4280),
    [anon_sym_EQ] = ACTIONS(1526),
    [anon_sym_QMARK] = ACTIONS(4280),
    [anon_sym_STAR_EQ] = ACTIONS(1530),
    [anon_sym_SLASH_EQ] = ACTIONS(1530),
    [anon_sym_PERCENT_EQ] = ACTIONS(1530),
    [anon_sym_PLUS_EQ] = ACTIONS(1530),
    [anon_sym_DASH_EQ] = ACTIONS(1530),
    [anon_sym_LT_LT_EQ] = ACTIONS(1530),
    [anon_sym_GT_GT_EQ] = ACTIONS(1530),
    [anon_sym_AMP_EQ] = ACTIONS(1530),
    [anon_sym_CARET_EQ] = ACTIONS(1530),
    [anon_sym_PIPE_EQ] = ACTIONS(1530),
    [anon_sym_AMP] = ACTIONS(1532),
    [anon_sym_PIPE_PIPE] = ACTIONS(1534),
    [anon_sym_AMP_AMP] = ACTIONS(1536),
    [anon_sym_PIPE] = ACTIONS(1538),
    [anon_sym_CARET] = ACTIONS(1540),
    [anon_sym_EQ_EQ] = ACTIONS(1542),
    [anon_sym_BANG_EQ] = ACTIONS(1542),
    [anon_sym_LT] = ACTIONS(1544),
    [anon_sym_GT] = ACTIONS(1544),
    [anon_sym_LT_EQ] = ACTIONS(1546),
    [anon_sym_GT_EQ] = ACTIONS(1546),
    [anon_sym_LT_LT] = ACTIONS(1548),
    [anon_sym_GT_GT] = ACTIONS(1548),
    [anon_sym_PLUS] = ACTIONS(1550),
    [anon_sym_DASH] = ACTIONS(1550),
    [anon_sym_SLASH] = ACTIONS(1522),
    [anon_sym_PERCENT] = ACTIONS(1522),
    [anon_sym_DASH_DASH] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(1554),
    [anon_sym_DASH_GT] = ACTIONS(1554),
    [sym_comment] = ACTIONS(49),
  },
  [1331] = {
    [sym_argument_list] = STATE(802),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_STAR] = ACTIONS(3003),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_EQ] = ACTIONS(3005),
    [anon_sym_COLON] = ACTIONS(4282),
    [anon_sym_QMARK] = ACTIONS(3009),
    [anon_sym_STAR_EQ] = ACTIONS(3011),
    [anon_sym_SLASH_EQ] = ACTIONS(3011),
    [anon_sym_PERCENT_EQ] = ACTIONS(3011),
    [anon_sym_PLUS_EQ] = ACTIONS(3011),
    [anon_sym_DASH_EQ] = ACTIONS(3011),
    [anon_sym_LT_LT_EQ] = ACTIONS(3011),
    [anon_sym_GT_GT_EQ] = ACTIONS(3011),
    [anon_sym_AMP_EQ] = ACTIONS(3011),
    [anon_sym_CARET_EQ] = ACTIONS(3011),
    [anon_sym_PIPE_EQ] = ACTIONS(3011),
    [anon_sym_AMP] = ACTIONS(3013),
    [anon_sym_PIPE_PIPE] = ACTIONS(3015),
    [anon_sym_AMP_AMP] = ACTIONS(3017),
    [anon_sym_PIPE] = ACTIONS(3019),
    [anon_sym_CARET] = ACTIONS(3021),
    [anon_sym_EQ_EQ] = ACTIONS(3023),
    [anon_sym_BANG_EQ] = ACTIONS(3023),
    [anon_sym_LT] = ACTIONS(3025),
    [anon_sym_GT] = ACTIONS(3025),
    [anon_sym_LT_EQ] = ACTIONS(3027),
    [anon_sym_GT_EQ] = ACTIONS(3027),
    [anon_sym_LT_LT] = ACTIONS(3029),
    [anon_sym_GT_GT] = ACTIONS(3029),
    [anon_sym_PLUS] = ACTIONS(3031),
    [anon_sym_DASH] = ACTIONS(3031),
    [anon_sym_SLASH] = ACTIONS(3003),
    [anon_sym_PERCENT] = ACTIONS(3003),
    [anon_sym_DASH_DASH] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(3033),
    [anon_sym_DASH_GT] = ACTIONS(3033),
    [sym_comment] = ACTIONS(49),
  },
  [1332] = {
    [sym_argument_list] = STATE(802),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_STAR] = ACTIONS(1522),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_RBRACK] = ACTIONS(4284),
    [anon_sym_EQ] = ACTIONS(4286),
    [anon_sym_QMARK] = ACTIONS(4284),
    [anon_sym_STAR_EQ] = ACTIONS(4284),
    [anon_sym_SLASH_EQ] = ACTIONS(4284),
    [anon_sym_PERCENT_EQ] = ACTIONS(4284),
    [anon_sym_PLUS_EQ] = ACTIONS(4284),
    [anon_sym_DASH_EQ] = ACTIONS(4284),
    [anon_sym_LT_LT_EQ] = ACTIONS(4284),
    [anon_sym_GT_GT_EQ] = ACTIONS(4284),
    [anon_sym_AMP_EQ] = ACTIONS(4284),
    [anon_sym_CARET_EQ] = ACTIONS(4284),
    [anon_sym_PIPE_EQ] = ACTIONS(4284),
    [anon_sym_AMP] = ACTIONS(4286),
    [anon_sym_PIPE_PIPE] = ACTIONS(4284),
    [anon_sym_AMP_AMP] = ACTIONS(4284),
    [anon_sym_PIPE] = ACTIONS(4286),
    [anon_sym_CARET] = ACTIONS(4286),
    [anon_sym_EQ_EQ] = ACTIONS(1542),
    [anon_sym_BANG_EQ] = ACTIONS(1542),
    [anon_sym_LT] = ACTIONS(1544),
    [anon_sym_GT] = ACTIONS(1544),
    [anon_sym_LT_EQ] = ACTIONS(1546),
    [anon_sym_GT_EQ] = ACTIONS(1546),
    [anon_sym_LT_LT] = ACTIONS(1548),
    [anon_sym_GT_GT] = ACTIONS(1548),
    [anon_sym_PLUS] = ACTIONS(1550),
    [anon_sym_DASH] = ACTIONS(1550),
    [anon_sym_SLASH] = ACTIONS(1522),
    [anon_sym_PERCENT] = ACTIONS(1522),
    [anon_sym_DASH_DASH] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(1554),
    [anon_sym_DASH_GT] = ACTIONS(1554),
    [sym_comment] = ACTIONS(49),
  },
  [1333] = {
    [sym_argument_list] = STATE(802),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_STAR] = ACTIONS(1522),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_RBRACK] = ACTIONS(4288),
    [anon_sym_EQ] = ACTIONS(4290),
    [anon_sym_QMARK] = ACTIONS(4288),
    [anon_sym_STAR_EQ] = ACTIONS(4288),
    [anon_sym_SLASH_EQ] = ACTIONS(4288),
    [anon_sym_PERCENT_EQ] = ACTIONS(4288),
    [anon_sym_PLUS_EQ] = ACTIONS(4288),
    [anon_sym_DASH_EQ] = ACTIONS(4288),
    [anon_sym_LT_LT_EQ] = ACTIONS(4288),
    [anon_sym_GT_GT_EQ] = ACTIONS(4288),
    [anon_sym_AMP_EQ] = ACTIONS(4288),
    [anon_sym_CARET_EQ] = ACTIONS(4288),
    [anon_sym_PIPE_EQ] = ACTIONS(4288),
    [anon_sym_AMP] = ACTIONS(1532),
    [anon_sym_PIPE_PIPE] = ACTIONS(4288),
    [anon_sym_AMP_AMP] = ACTIONS(1536),
    [anon_sym_PIPE] = ACTIONS(1538),
    [anon_sym_CARET] = ACTIONS(1540),
    [anon_sym_EQ_EQ] = ACTIONS(1542),
    [anon_sym_BANG_EQ] = ACTIONS(1542),
    [anon_sym_LT] = ACTIONS(1544),
    [anon_sym_GT] = ACTIONS(1544),
    [anon_sym_LT_EQ] = ACTIONS(1546),
    [anon_sym_GT_EQ] = ACTIONS(1546),
    [anon_sym_LT_LT] = ACTIONS(1548),
    [anon_sym_GT_GT] = ACTIONS(1548),
    [anon_sym_PLUS] = ACTIONS(1550),
    [anon_sym_DASH] = ACTIONS(1550),
    [anon_sym_SLASH] = ACTIONS(1522),
    [anon_sym_PERCENT] = ACTIONS(1522),
    [anon_sym_DASH_DASH] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(1554),
    [anon_sym_DASH_GT] = ACTIONS(1554),
    [sym_comment] = ACTIONS(49),
  },
  [1334] = {
    [sym_argument_list] = STATE(802),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_STAR] = ACTIONS(1522),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_RBRACK] = ACTIONS(4288),
    [anon_sym_EQ] = ACTIONS(4290),
    [anon_sym_QMARK] = ACTIONS(4288),
    [anon_sym_STAR_EQ] = ACTIONS(4288),
    [anon_sym_SLASH_EQ] = ACTIONS(4288),
    [anon_sym_PERCENT_EQ] = ACTIONS(4288),
    [anon_sym_PLUS_EQ] = ACTIONS(4288),
    [anon_sym_DASH_EQ] = ACTIONS(4288),
    [anon_sym_LT_LT_EQ] = ACTIONS(4288),
    [anon_sym_GT_GT_EQ] = ACTIONS(4288),
    [anon_sym_AMP_EQ] = ACTIONS(4288),
    [anon_sym_CARET_EQ] = ACTIONS(4288),
    [anon_sym_PIPE_EQ] = ACTIONS(4288),
    [anon_sym_AMP] = ACTIONS(1532),
    [anon_sym_PIPE_PIPE] = ACTIONS(4288),
    [anon_sym_AMP_AMP] = ACTIONS(4288),
    [anon_sym_PIPE] = ACTIONS(1538),
    [anon_sym_CARET] = ACTIONS(1540),
    [anon_sym_EQ_EQ] = ACTIONS(1542),
    [anon_sym_BANG_EQ] = ACTIONS(1542),
    [anon_sym_LT] = ACTIONS(1544),
    [anon_sym_GT] = ACTIONS(1544),
    [anon_sym_LT_EQ] = ACTIONS(1546),
    [anon_sym_GT_EQ] = ACTIONS(1546),
    [anon_sym_LT_LT] = ACTIONS(1548),
    [anon_sym_GT_GT] = ACTIONS(1548),
    [anon_sym_PLUS] = ACTIONS(1550),
    [anon_sym_DASH] = ACTIONS(1550),
    [anon_sym_SLASH] = ACTIONS(1522),
    [anon_sym_PERCENT] = ACTIONS(1522),
    [anon_sym_DASH_DASH] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(1554),
    [anon_sym_DASH_GT] = ACTIONS(1554),
    [sym_comment] = ACTIONS(49),
  },
  [1335] = {
    [sym_argument_list] = STATE(802),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_STAR] = ACTIONS(1522),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_RBRACK] = ACTIONS(4284),
    [anon_sym_EQ] = ACTIONS(4286),
    [anon_sym_QMARK] = ACTIONS(4284),
    [anon_sym_STAR_EQ] = ACTIONS(4284),
    [anon_sym_SLASH_EQ] = ACTIONS(4284),
    [anon_sym_PERCENT_EQ] = ACTIONS(4284),
    [anon_sym_PLUS_EQ] = ACTIONS(4284),
    [anon_sym_DASH_EQ] = ACTIONS(4284),
    [anon_sym_LT_LT_EQ] = ACTIONS(4284),
    [anon_sym_GT_GT_EQ] = ACTIONS(4284),
    [anon_sym_AMP_EQ] = ACTIONS(4284),
    [anon_sym_CARET_EQ] = ACTIONS(4284),
    [anon_sym_PIPE_EQ] = ACTIONS(4284),
    [anon_sym_AMP] = ACTIONS(1532),
    [anon_sym_PIPE_PIPE] = ACTIONS(4284),
    [anon_sym_AMP_AMP] = ACTIONS(4284),
    [anon_sym_PIPE] = ACTIONS(4286),
    [anon_sym_CARET] = ACTIONS(1540),
    [anon_sym_EQ_EQ] = ACTIONS(1542),
    [anon_sym_BANG_EQ] = ACTIONS(1542),
    [anon_sym_LT] = ACTIONS(1544),
    [anon_sym_GT] = ACTIONS(1544),
    [anon_sym_LT_EQ] = ACTIONS(1546),
    [anon_sym_GT_EQ] = ACTIONS(1546),
    [anon_sym_LT_LT] = ACTIONS(1548),
    [anon_sym_GT_GT] = ACTIONS(1548),
    [anon_sym_PLUS] = ACTIONS(1550),
    [anon_sym_DASH] = ACTIONS(1550),
    [anon_sym_SLASH] = ACTIONS(1522),
    [anon_sym_PERCENT] = ACTIONS(1522),
    [anon_sym_DASH_DASH] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(1554),
    [anon_sym_DASH_GT] = ACTIONS(1554),
    [sym_comment] = ACTIONS(49),
  },
  [1336] = {
    [sym_argument_list] = STATE(802),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_STAR] = ACTIONS(1522),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_RBRACK] = ACTIONS(4284),
    [anon_sym_EQ] = ACTIONS(4286),
    [anon_sym_QMARK] = ACTIONS(4284),
    [anon_sym_STAR_EQ] = ACTIONS(4284),
    [anon_sym_SLASH_EQ] = ACTIONS(4284),
    [anon_sym_PERCENT_EQ] = ACTIONS(4284),
    [anon_sym_PLUS_EQ] = ACTIONS(4284),
    [anon_sym_DASH_EQ] = ACTIONS(4284),
    [anon_sym_LT_LT_EQ] = ACTIONS(4284),
    [anon_sym_GT_GT_EQ] = ACTIONS(4284),
    [anon_sym_AMP_EQ] = ACTIONS(4284),
    [anon_sym_CARET_EQ] = ACTIONS(4284),
    [anon_sym_PIPE_EQ] = ACTIONS(4284),
    [anon_sym_AMP] = ACTIONS(1532),
    [anon_sym_PIPE_PIPE] = ACTIONS(4284),
    [anon_sym_AMP_AMP] = ACTIONS(4284),
    [anon_sym_PIPE] = ACTIONS(4286),
    [anon_sym_CARET] = ACTIONS(4286),
    [anon_sym_EQ_EQ] = ACTIONS(1542),
    [anon_sym_BANG_EQ] = ACTIONS(1542),
    [anon_sym_LT] = ACTIONS(1544),
    [anon_sym_GT] = ACTIONS(1544),
    [anon_sym_LT_EQ] = ACTIONS(1546),
    [anon_sym_GT_EQ] = ACTIONS(1546),
    [anon_sym_LT_LT] = ACTIONS(1548),
    [anon_sym_GT_GT] = ACTIONS(1548),
    [anon_sym_PLUS] = ACTIONS(1550),
    [anon_sym_DASH] = ACTIONS(1550),
    [anon_sym_SLASH] = ACTIONS(1522),
    [anon_sym_PERCENT] = ACTIONS(1522),
    [anon_sym_DASH_DASH] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(1554),
    [anon_sym_DASH_GT] = ACTIONS(1554),
    [sym_comment] = ACTIONS(49),
  },
  [1337] = {
    [sym_argument_list] = STATE(802),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_STAR] = ACTIONS(1522),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_RBRACK] = ACTIONS(4292),
    [anon_sym_EQ] = ACTIONS(4294),
    [anon_sym_QMARK] = ACTIONS(4292),
    [anon_sym_STAR_EQ] = ACTIONS(4292),
    [anon_sym_SLASH_EQ] = ACTIONS(4292),
    [anon_sym_PERCENT_EQ] = ACTIONS(4292),
    [anon_sym_PLUS_EQ] = ACTIONS(4292),
    [anon_sym_DASH_EQ] = ACTIONS(4292),
    [anon_sym_LT_LT_EQ] = ACTIONS(4292),
    [anon_sym_GT_GT_EQ] = ACTIONS(4292),
    [anon_sym_AMP_EQ] = ACTIONS(4292),
    [anon_sym_CARET_EQ] = ACTIONS(4292),
    [anon_sym_PIPE_EQ] = ACTIONS(4292),
    [anon_sym_AMP] = ACTIONS(4294),
    [anon_sym_PIPE_PIPE] = ACTIONS(4292),
    [anon_sym_AMP_AMP] = ACTIONS(4292),
    [anon_sym_PIPE] = ACTIONS(4294),
    [anon_sym_CARET] = ACTIONS(4294),
    [anon_sym_EQ_EQ] = ACTIONS(4292),
    [anon_sym_BANG_EQ] = ACTIONS(4292),
    [anon_sym_LT] = ACTIONS(1544),
    [anon_sym_GT] = ACTIONS(1544),
    [anon_sym_LT_EQ] = ACTIONS(1546),
    [anon_sym_GT_EQ] = ACTIONS(1546),
    [anon_sym_LT_LT] = ACTIONS(1548),
    [anon_sym_GT_GT] = ACTIONS(1548),
    [anon_sym_PLUS] = ACTIONS(1550),
    [anon_sym_DASH] = ACTIONS(1550),
    [anon_sym_SLASH] = ACTIONS(1522),
    [anon_sym_PERCENT] = ACTIONS(1522),
    [anon_sym_DASH_DASH] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(1554),
    [anon_sym_DASH_GT] = ACTIONS(1554),
    [sym_comment] = ACTIONS(49),
  },
  [1338] = {
    [sym_argument_list] = STATE(802),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_STAR] = ACTIONS(1522),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_RBRACK] = ACTIONS(4296),
    [anon_sym_EQ] = ACTIONS(4298),
    [anon_sym_QMARK] = ACTIONS(4296),
    [anon_sym_STAR_EQ] = ACTIONS(4296),
    [anon_sym_SLASH_EQ] = ACTIONS(4296),
    [anon_sym_PERCENT_EQ] = ACTIONS(4296),
    [anon_sym_PLUS_EQ] = ACTIONS(4296),
    [anon_sym_DASH_EQ] = ACTIONS(4296),
    [anon_sym_LT_LT_EQ] = ACTIONS(4296),
    [anon_sym_GT_GT_EQ] = ACTIONS(4296),
    [anon_sym_AMP_EQ] = ACTIONS(4296),
    [anon_sym_CARET_EQ] = ACTIONS(4296),
    [anon_sym_PIPE_EQ] = ACTIONS(4296),
    [anon_sym_AMP] = ACTIONS(4298),
    [anon_sym_PIPE_PIPE] = ACTIONS(4296),
    [anon_sym_AMP_AMP] = ACTIONS(4296),
    [anon_sym_PIPE] = ACTIONS(4298),
    [anon_sym_CARET] = ACTIONS(4298),
    [anon_sym_EQ_EQ] = ACTIONS(4296),
    [anon_sym_BANG_EQ] = ACTIONS(4296),
    [anon_sym_LT] = ACTIONS(4298),
    [anon_sym_GT] = ACTIONS(4298),
    [anon_sym_LT_EQ] = ACTIONS(4296),
    [anon_sym_GT_EQ] = ACTIONS(4296),
    [anon_sym_LT_LT] = ACTIONS(1548),
    [anon_sym_GT_GT] = ACTIONS(1548),
    [anon_sym_PLUS] = ACTIONS(1550),
    [anon_sym_DASH] = ACTIONS(1550),
    [anon_sym_SLASH] = ACTIONS(1522),
    [anon_sym_PERCENT] = ACTIONS(1522),
    [anon_sym_DASH_DASH] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(1554),
    [anon_sym_DASH_GT] = ACTIONS(1554),
    [sym_comment] = ACTIONS(49),
  },
  [1339] = {
    [sym_argument_list] = STATE(802),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_STAR] = ACTIONS(1522),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_RBRACK] = ACTIONS(4300),
    [anon_sym_EQ] = ACTIONS(4302),
    [anon_sym_QMARK] = ACTIONS(4300),
    [anon_sym_STAR_EQ] = ACTIONS(4300),
    [anon_sym_SLASH_EQ] = ACTIONS(4300),
    [anon_sym_PERCENT_EQ] = ACTIONS(4300),
    [anon_sym_PLUS_EQ] = ACTIONS(4300),
    [anon_sym_DASH_EQ] = ACTIONS(4300),
    [anon_sym_LT_LT_EQ] = ACTIONS(4300),
    [anon_sym_GT_GT_EQ] = ACTIONS(4300),
    [anon_sym_AMP_EQ] = ACTIONS(4300),
    [anon_sym_CARET_EQ] = ACTIONS(4300),
    [anon_sym_PIPE_EQ] = ACTIONS(4300),
    [anon_sym_AMP] = ACTIONS(4302),
    [anon_sym_PIPE_PIPE] = ACTIONS(4300),
    [anon_sym_AMP_AMP] = ACTIONS(4300),
    [anon_sym_PIPE] = ACTIONS(4302),
    [anon_sym_CARET] = ACTIONS(4302),
    [anon_sym_EQ_EQ] = ACTIONS(4300),
    [anon_sym_BANG_EQ] = ACTIONS(4300),
    [anon_sym_LT] = ACTIONS(4302),
    [anon_sym_GT] = ACTIONS(4302),
    [anon_sym_LT_EQ] = ACTIONS(4300),
    [anon_sym_GT_EQ] = ACTIONS(4300),
    [anon_sym_LT_LT] = ACTIONS(4302),
    [anon_sym_GT_GT] = ACTIONS(4302),
    [anon_sym_PLUS] = ACTIONS(1550),
    [anon_sym_DASH] = ACTIONS(1550),
    [anon_sym_SLASH] = ACTIONS(1522),
    [anon_sym_PERCENT] = ACTIONS(1522),
    [anon_sym_DASH_DASH] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(1554),
    [anon_sym_DASH_GT] = ACTIONS(1554),
    [sym_comment] = ACTIONS(49),
  },
  [1340] = {
    [sym_argument_list] = STATE(802),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_STAR] = ACTIONS(1522),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_RBRACK] = ACTIONS(4274),
    [anon_sym_EQ] = ACTIONS(4276),
    [anon_sym_QMARK] = ACTIONS(4274),
    [anon_sym_STAR_EQ] = ACTIONS(4274),
    [anon_sym_SLASH_EQ] = ACTIONS(4274),
    [anon_sym_PERCENT_EQ] = ACTIONS(4274),
    [anon_sym_PLUS_EQ] = ACTIONS(4274),
    [anon_sym_DASH_EQ] = ACTIONS(4274),
    [anon_sym_LT_LT_EQ] = ACTIONS(4274),
    [anon_sym_GT_GT_EQ] = ACTIONS(4274),
    [anon_sym_AMP_EQ] = ACTIONS(4274),
    [anon_sym_CARET_EQ] = ACTIONS(4274),
    [anon_sym_PIPE_EQ] = ACTIONS(4274),
    [anon_sym_AMP] = ACTIONS(4276),
    [anon_sym_PIPE_PIPE] = ACTIONS(4274),
    [anon_sym_AMP_AMP] = ACTIONS(4274),
    [anon_sym_PIPE] = ACTIONS(4276),
    [anon_sym_CARET] = ACTIONS(4276),
    [anon_sym_EQ_EQ] = ACTIONS(4274),
    [anon_sym_BANG_EQ] = ACTIONS(4274),
    [anon_sym_LT] = ACTIONS(4276),
    [anon_sym_GT] = ACTIONS(4276),
    [anon_sym_LT_EQ] = ACTIONS(4274),
    [anon_sym_GT_EQ] = ACTIONS(4274),
    [anon_sym_LT_LT] = ACTIONS(4276),
    [anon_sym_GT_GT] = ACTIONS(4276),
    [anon_sym_PLUS] = ACTIONS(4276),
    [anon_sym_DASH] = ACTIONS(4276),
    [anon_sym_SLASH] = ACTIONS(1522),
    [anon_sym_PERCENT] = ACTIONS(1522),
    [anon_sym_DASH_DASH] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(1554),
    [anon_sym_DASH_GT] = ACTIONS(1554),
    [sym_comment] = ACTIONS(49),
  },
  [1341] = {
    [sym_template_argument_list] = STATE(1067),
    [anon_sym_LPAREN] = ACTIONS(4304),
    [anon_sym_COMMA] = ACTIONS(4304),
    [anon_sym_RPAREN] = ACTIONS(4304),
    [anon_sym_SEMI] = ACTIONS(4304),
    [anon_sym_RBRACE] = ACTIONS(4304),
    [anon_sym_STAR] = ACTIONS(4306),
    [anon_sym_LBRACK] = ACTIONS(4304),
    [anon_sym_RBRACK] = ACTIONS(4304),
    [anon_sym_EQ] = ACTIONS(4306),
    [anon_sym_COLON] = ACTIONS(4306),
    [anon_sym_QMARK] = ACTIONS(4304),
    [anon_sym_STAR_EQ] = ACTIONS(4304),
    [anon_sym_SLASH_EQ] = ACTIONS(4304),
    [anon_sym_PERCENT_EQ] = ACTIONS(4304),
    [anon_sym_PLUS_EQ] = ACTIONS(4304),
    [anon_sym_DASH_EQ] = ACTIONS(4304),
    [anon_sym_LT_LT_EQ] = ACTIONS(4304),
    [anon_sym_GT_GT_EQ] = ACTIONS(4304),
    [anon_sym_AMP_EQ] = ACTIONS(4304),
    [anon_sym_CARET_EQ] = ACTIONS(4304),
    [anon_sym_PIPE_EQ] = ACTIONS(4304),
    [anon_sym_AMP] = ACTIONS(4306),
    [anon_sym_PIPE_PIPE] = ACTIONS(4304),
    [anon_sym_AMP_AMP] = ACTIONS(4304),
    [anon_sym_PIPE] = ACTIONS(4306),
    [anon_sym_CARET] = ACTIONS(4306),
    [anon_sym_EQ_EQ] = ACTIONS(4304),
    [anon_sym_BANG_EQ] = ACTIONS(4304),
    [anon_sym_LT] = ACTIONS(4308),
    [anon_sym_GT] = ACTIONS(4306),
    [anon_sym_LT_EQ] = ACTIONS(4304),
    [anon_sym_GT_EQ] = ACTIONS(4304),
    [anon_sym_LT_LT] = ACTIONS(4306),
    [anon_sym_GT_GT] = ACTIONS(4306),
    [anon_sym_PLUS] = ACTIONS(4306),
    [anon_sym_DASH] = ACTIONS(4306),
    [anon_sym_SLASH] = ACTIONS(4306),
    [anon_sym_PERCENT] = ACTIONS(4306),
    [anon_sym_DASH_DASH] = ACTIONS(4304),
    [anon_sym_PLUS_PLUS] = ACTIONS(4304),
    [anon_sym_DOT] = ACTIONS(4304),
    [anon_sym_DASH_GT] = ACTIONS(4304),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(2078),
  },
  [1342] = {
    [anon_sym_LPAREN] = ACTIONS(4311),
    [anon_sym_COMMA] = ACTIONS(4311),
    [anon_sym_RPAREN] = ACTIONS(4311),
    [anon_sym_SEMI] = ACTIONS(4311),
    [anon_sym_RBRACE] = ACTIONS(4311),
    [anon_sym_STAR] = ACTIONS(4313),
    [anon_sym_LBRACK] = ACTIONS(4311),
    [anon_sym_RBRACK] = ACTIONS(4311),
    [anon_sym_EQ] = ACTIONS(4313),
    [anon_sym_COLON] = ACTIONS(4311),
    [anon_sym_QMARK] = ACTIONS(4311),
    [anon_sym_STAR_EQ] = ACTIONS(4311),
    [anon_sym_SLASH_EQ] = ACTIONS(4311),
    [anon_sym_PERCENT_EQ] = ACTIONS(4311),
    [anon_sym_PLUS_EQ] = ACTIONS(4311),
    [anon_sym_DASH_EQ] = ACTIONS(4311),
    [anon_sym_LT_LT_EQ] = ACTIONS(4311),
    [anon_sym_GT_GT_EQ] = ACTIONS(4311),
    [anon_sym_AMP_EQ] = ACTIONS(4311),
    [anon_sym_CARET_EQ] = ACTIONS(4311),
    [anon_sym_PIPE_EQ] = ACTIONS(4311),
    [anon_sym_AMP] = ACTIONS(4313),
    [anon_sym_PIPE_PIPE] = ACTIONS(4311),
    [anon_sym_AMP_AMP] = ACTIONS(4311),
    [anon_sym_PIPE] = ACTIONS(4313),
    [anon_sym_CARET] = ACTIONS(4313),
    [anon_sym_EQ_EQ] = ACTIONS(4311),
    [anon_sym_BANG_EQ] = ACTIONS(4311),
    [anon_sym_LT] = ACTIONS(4313),
    [anon_sym_GT] = ACTIONS(4313),
    [anon_sym_LT_EQ] = ACTIONS(4311),
    [anon_sym_GT_EQ] = ACTIONS(4311),
    [anon_sym_LT_LT] = ACTIONS(4313),
    [anon_sym_GT_GT] = ACTIONS(4313),
    [anon_sym_PLUS] = ACTIONS(4313),
    [anon_sym_DASH] = ACTIONS(4313),
    [anon_sym_SLASH] = ACTIONS(4313),
    [anon_sym_PERCENT] = ACTIONS(4313),
    [anon_sym_DASH_DASH] = ACTIONS(4311),
    [anon_sym_PLUS_PLUS] = ACTIONS(4311),
    [anon_sym_DOT] = ACTIONS(4311),
    [anon_sym_DASH_GT] = ACTIONS(4311),
    [sym_comment] = ACTIONS(49),
  },
  [1343] = {
    [sym_template_argument_list] = STATE(1078),
    [anon_sym_LT] = ACTIONS(4315),
    [sym_comment] = ACTIONS(49),
  },
  [1344] = {
    [sym_raw_string_literal] = ACTIONS(1801),
    [anon_sym_LPAREN] = ACTIONS(1798),
    [anon_sym_extern] = ACTIONS(1803),
    [anon_sym_LBRACE] = ACTIONS(1801),
    [anon_sym_STAR] = ACTIONS(4317),
    [anon_sym_LBRACK] = ACTIONS(1798),
    [anon_sym_RBRACK] = ACTIONS(1798),
    [anon_sym_EQ] = ACTIONS(1809),
    [anon_sym_static] = ACTIONS(1803),
    [anon_sym_register] = ACTIONS(1803),
    [anon_sym_inline] = ACTIONS(1803),
    [anon_sym_const] = ACTIONS(1803),
    [anon_sym_restrict] = ACTIONS(1803),
    [anon_sym_volatile] = ACTIONS(1803),
    [anon_sym__Atomic] = ACTIONS(1803),
    [anon_sym_mutable] = ACTIONS(1803),
    [anon_sym_explicit] = ACTIONS(1803),
    [anon_sym_constexpr] = ACTIONS(1803),
    [anon_sym_QMARK] = ACTIONS(1807),
    [anon_sym_STAR_EQ] = ACTIONS(1807),
    [anon_sym_SLASH_EQ] = ACTIONS(1807),
    [anon_sym_PERCENT_EQ] = ACTIONS(1807),
    [anon_sym_PLUS_EQ] = ACTIONS(1807),
    [anon_sym_DASH_EQ] = ACTIONS(1807),
    [anon_sym_LT_LT_EQ] = ACTIONS(1807),
    [anon_sym_GT_GT_EQ] = ACTIONS(1807),
    [anon_sym_AMP_EQ] = ACTIONS(1807),
    [anon_sym_CARET_EQ] = ACTIONS(1807),
    [anon_sym_PIPE_EQ] = ACTIONS(1807),
    [anon_sym_AMP] = ACTIONS(4317),
    [anon_sym_PIPE_PIPE] = ACTIONS(1807),
    [anon_sym_AMP_AMP] = ACTIONS(1807),
    [anon_sym_BANG] = ACTIONS(1803),
    [anon_sym_PIPE] = ACTIONS(1809),
    [anon_sym_CARET] = ACTIONS(1809),
    [anon_sym_TILDE] = ACTIONS(1801),
    [anon_sym_EQ_EQ] = ACTIONS(1807),
    [anon_sym_BANG_EQ] = ACTIONS(1807),
    [anon_sym_LT] = ACTIONS(4317),
    [anon_sym_GT] = ACTIONS(1809),
    [anon_sym_LT_EQ] = ACTIONS(1807),
    [anon_sym_GT_EQ] = ACTIONS(1807),
    [anon_sym_LT_LT] = ACTIONS(1809),
    [anon_sym_GT_GT] = ACTIONS(1809),
    [anon_sym_PLUS] = ACTIONS(4317),
    [anon_sym_DASH] = ACTIONS(4317),
    [anon_sym_SLASH] = ACTIONS(1809),
    [anon_sym_PERCENT] = ACTIONS(1809),
    [anon_sym_DASH_DASH] = ACTIONS(1798),
    [anon_sym_PLUS_PLUS] = ACTIONS(1798),
    [anon_sym_sizeof] = ACTIONS(1803),
    [anon_sym_DOT] = ACTIONS(1807),
    [anon_sym_DASH_GT] = ACTIONS(1807),
    [sym_number_literal] = ACTIONS(1801),
    [sym_char_literal] = ACTIONS(1801),
    [sym_string_literal] = ACTIONS(1801),
    [sym_true] = ACTIONS(1803),
    [sym_false] = ACTIONS(1803),
    [sym_null] = ACTIONS(1803),
    [sym_identifier] = ACTIONS(1803),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(1803),
    [anon_sym_COLON_COLON] = ACTIONS(1805),
    [anon_sym_delete] = ACTIONS(1803),
    [sym_nullptr] = ACTIONS(1803),
  },
  [1345] = {
    [sym_parameter_list] = STATE(1879),
    [anon_sym_LPAREN] = ACTIONS(206),
    [anon_sym_LBRACK] = ACTIONS(2282),
    [sym_comment] = ACTIONS(49),
  },
  [1346] = {
    [sym_type_qualifier] = STATE(1881),
    [sym_trailing_return_type] = STATE(1129),
    [aux_sym_abstract_function_declarator_repeat1] = STATE(1881),
    [anon_sym_LPAREN] = ACTIONS(2284),
    [anon_sym_LBRACK] = ACTIONS(2284),
    [anon_sym_const] = ACTIONS(612),
    [anon_sym_restrict] = ACTIONS(614),
    [anon_sym_volatile] = ACTIONS(614),
    [anon_sym__Atomic] = ACTIONS(614),
    [anon_sym_mutable] = ACTIONS(614),
    [anon_sym_explicit] = ACTIONS(614),
    [anon_sym_constexpr] = ACTIONS(614),
    [anon_sym_DASH_GT] = ACTIONS(4320),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(4322),
  },
  [1347] = {
    [sym_type_qualifier] = STATE(1882),
    [sym_trailing_return_type] = STATE(1713),
    [aux_sym_abstract_function_declarator_repeat1] = STATE(1882),
    [anon_sym_LPAREN] = ACTIONS(3764),
    [anon_sym_LBRACE] = ACTIONS(3764),
    [anon_sym_LBRACK] = ACTIONS(3764),
    [anon_sym_const] = ACTIONS(612),
    [anon_sym_restrict] = ACTIONS(614),
    [anon_sym_volatile] = ACTIONS(614),
    [anon_sym__Atomic] = ACTIONS(614),
    [anon_sym_mutable] = ACTIONS(614),
    [anon_sym_explicit] = ACTIONS(614),
    [anon_sym_constexpr] = ACTIONS(614),
    [anon_sym_DASH_GT] = ACTIONS(2814),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(4324),
  },
  [1348] = {
    [anon_sym_LPAREN] = ACTIONS(4326),
    [anon_sym_COMMA] = ACTIONS(4326),
    [anon_sym_RPAREN] = ACTIONS(4326),
    [anon_sym_SEMI] = ACTIONS(4326),
    [anon_sym_RBRACE] = ACTIONS(4326),
    [anon_sym_STAR] = ACTIONS(4328),
    [anon_sym_LBRACK] = ACTIONS(4326),
    [anon_sym_RBRACK] = ACTIONS(4326),
    [anon_sym_EQ] = ACTIONS(4328),
    [anon_sym_COLON] = ACTIONS(4326),
    [anon_sym_QMARK] = ACTIONS(4326),
    [anon_sym_STAR_EQ] = ACTIONS(4326),
    [anon_sym_SLASH_EQ] = ACTIONS(4326),
    [anon_sym_PERCENT_EQ] = ACTIONS(4326),
    [anon_sym_PLUS_EQ] = ACTIONS(4326),
    [anon_sym_DASH_EQ] = ACTIONS(4326),
    [anon_sym_LT_LT_EQ] = ACTIONS(4326),
    [anon_sym_GT_GT_EQ] = ACTIONS(4326),
    [anon_sym_AMP_EQ] = ACTIONS(4326),
    [anon_sym_CARET_EQ] = ACTIONS(4326),
    [anon_sym_PIPE_EQ] = ACTIONS(4326),
    [anon_sym_AMP] = ACTIONS(4328),
    [anon_sym_PIPE_PIPE] = ACTIONS(4326),
    [anon_sym_AMP_AMP] = ACTIONS(4326),
    [anon_sym_PIPE] = ACTIONS(4328),
    [anon_sym_CARET] = ACTIONS(4328),
    [anon_sym_EQ_EQ] = ACTIONS(4326),
    [anon_sym_BANG_EQ] = ACTIONS(4326),
    [anon_sym_LT] = ACTIONS(4328),
    [anon_sym_GT] = ACTIONS(4328),
    [anon_sym_LT_EQ] = ACTIONS(4326),
    [anon_sym_GT_EQ] = ACTIONS(4326),
    [anon_sym_LT_LT] = ACTIONS(4328),
    [anon_sym_GT_GT] = ACTIONS(4328),
    [anon_sym_PLUS] = ACTIONS(4328),
    [anon_sym_DASH] = ACTIONS(4328),
    [anon_sym_SLASH] = ACTIONS(4328),
    [anon_sym_PERCENT] = ACTIONS(4328),
    [anon_sym_DASH_DASH] = ACTIONS(4326),
    [anon_sym_PLUS_PLUS] = ACTIONS(4326),
    [anon_sym_DOT] = ACTIONS(4326),
    [anon_sym_DASH_GT] = ACTIONS(4326),
    [sym_comment] = ACTIONS(49),
  },
  [1349] = {
    [sym__type_specifier] = STATE(1888),
    [sym_sized_type_specifier] = STATE(1888),
    [sym_enum_specifier] = STATE(1888),
    [sym_struct_specifier] = STATE(1888),
    [sym_union_specifier] = STATE(1888),
    [sym_macro_type_specifier] = STATE(1888),
    [sym_class_specifier] = STATE(1888),
    [sym_dependent_type] = STATE(1888),
    [sym_template_type] = STATE(62),
    [sym_scoped_type_identifier] = STATE(34),
    [sym_scoped_namespace_identifier] = STATE(64),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1889),
    [anon_sym_unsigned] = ACTIONS(4330),
    [anon_sym_long] = ACTIONS(4330),
    [anon_sym_short] = ACTIONS(4330),
    [sym_primitive_type] = ACTIONS(4332),
    [anon_sym_enum] = ACTIONS(4334),
    [anon_sym_struct] = ACTIONS(4336),
    [anon_sym_union] = ACTIONS(4338),
    [sym_identifier] = ACTIONS(434),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(4340),
    [sym_auto] = ACTIONS(4332),
    [anon_sym_typename] = ACTIONS(4342),
    [anon_sym_COLON_COLON] = ACTIONS(111),
  },
  [1350] = {
    [sym_type_qualifier] = STATE(1890),
    [sym_trailing_return_type] = STATE(1713),
    [aux_sym_abstract_function_declarator_repeat1] = STATE(1890),
    [anon_sym_LPAREN] = ACTIONS(3764),
    [anon_sym_LBRACE] = ACTIONS(3764),
    [anon_sym_LBRACK] = ACTIONS(3764),
    [anon_sym_const] = ACTIONS(612),
    [anon_sym_restrict] = ACTIONS(614),
    [anon_sym_volatile] = ACTIONS(614),
    [anon_sym__Atomic] = ACTIONS(614),
    [anon_sym_mutable] = ACTIONS(614),
    [anon_sym_explicit] = ACTIONS(614),
    [anon_sym_constexpr] = ACTIONS(614),
    [anon_sym_DASH_GT] = ACTIONS(2814),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(4344),
  },
  [1351] = {
    [anon_sym_LPAREN] = ACTIONS(1111),
    [anon_sym_COMMA] = ACTIONS(1111),
    [anon_sym_RPAREN] = ACTIONS(1111),
    [anon_sym_SEMI] = ACTIONS(1111),
    [anon_sym_extern] = ACTIONS(1113),
    [anon_sym_LBRACE] = ACTIONS(1111),
    [anon_sym_RBRACE] = ACTIONS(1111),
    [anon_sym_STAR] = ACTIONS(1113),
    [anon_sym_LBRACK] = ACTIONS(1111),
    [anon_sym_RBRACK] = ACTIONS(1111),
    [anon_sym_EQ] = ACTIONS(1113),
    [anon_sym_static] = ACTIONS(1113),
    [anon_sym_register] = ACTIONS(1113),
    [anon_sym_inline] = ACTIONS(1113),
    [anon_sym_const] = ACTIONS(1113),
    [anon_sym_restrict] = ACTIONS(1113),
    [anon_sym_volatile] = ACTIONS(1113),
    [anon_sym__Atomic] = ACTIONS(1113),
    [anon_sym_mutable] = ACTIONS(1113),
    [anon_sym_explicit] = ACTIONS(1113),
    [anon_sym_constexpr] = ACTIONS(1113),
    [anon_sym_COLON] = ACTIONS(1113),
    [anon_sym_QMARK] = ACTIONS(1111),
    [anon_sym_STAR_EQ] = ACTIONS(1111),
    [anon_sym_SLASH_EQ] = ACTIONS(1111),
    [anon_sym_PERCENT_EQ] = ACTIONS(1111),
    [anon_sym_PLUS_EQ] = ACTIONS(1111),
    [anon_sym_DASH_EQ] = ACTIONS(1111),
    [anon_sym_LT_LT_EQ] = ACTIONS(1111),
    [anon_sym_GT_GT_EQ] = ACTIONS(1111),
    [anon_sym_AMP_EQ] = ACTIONS(1111),
    [anon_sym_CARET_EQ] = ACTIONS(1111),
    [anon_sym_PIPE_EQ] = ACTIONS(1111),
    [anon_sym_AMP] = ACTIONS(1113),
    [anon_sym_PIPE_PIPE] = ACTIONS(1111),
    [anon_sym_AMP_AMP] = ACTIONS(1111),
    [anon_sym_PIPE] = ACTIONS(1113),
    [anon_sym_CARET] = ACTIONS(1113),
    [anon_sym_TILDE] = ACTIONS(1111),
    [anon_sym_EQ_EQ] = ACTIONS(1111),
    [anon_sym_BANG_EQ] = ACTIONS(1111),
    [anon_sym_LT] = ACTIONS(1113),
    [anon_sym_GT] = ACTIONS(1113),
    [anon_sym_LT_EQ] = ACTIONS(1111),
    [anon_sym_GT_EQ] = ACTIONS(1111),
    [anon_sym_LT_LT] = ACTIONS(1113),
    [anon_sym_GT_GT] = ACTIONS(1113),
    [anon_sym_PLUS] = ACTIONS(1113),
    [anon_sym_DASH] = ACTIONS(1113),
    [anon_sym_SLASH] = ACTIONS(1113),
    [anon_sym_PERCENT] = ACTIONS(1113),
    [anon_sym_DASH_DASH] = ACTIONS(1111),
    [anon_sym_PLUS_PLUS] = ACTIONS(1111),
    [anon_sym_DOT] = ACTIONS(1111),
    [anon_sym_DASH_GT] = ACTIONS(1111),
    [sym_identifier] = ACTIONS(1113),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(1111),
    [sym_operator_name] = ACTIONS(1111),
  },
  [1352] = {
    [aux_sym_template_argument_list_repeat1] = STATE(1892),
    [anon_sym_COMMA] = ACTIONS(1127),
    [anon_sym_GT] = ACTIONS(4346),
    [sym_comment] = ACTIONS(49),
  },
  [1353] = {
    [sym_raw_string_literal] = ACTIONS(1111),
    [anon_sym_LPAREN] = ACTIONS(1111),
    [anon_sym_extern] = ACTIONS(1113),
    [anon_sym_LBRACE] = ACTIONS(1111),
    [anon_sym_STAR] = ACTIONS(1111),
    [anon_sym_LBRACK] = ACTIONS(1111),
    [anon_sym_RBRACK] = ACTIONS(1111),
    [anon_sym_static] = ACTIONS(1113),
    [anon_sym_register] = ACTIONS(1113),
    [anon_sym_inline] = ACTIONS(1113),
    [anon_sym_const] = ACTIONS(1113),
    [anon_sym_restrict] = ACTIONS(1113),
    [anon_sym_volatile] = ACTIONS(1113),
    [anon_sym__Atomic] = ACTIONS(1113),
    [anon_sym_mutable] = ACTIONS(1113),
    [anon_sym_explicit] = ACTIONS(1113),
    [anon_sym_constexpr] = ACTIONS(1113),
    [anon_sym_COLON] = ACTIONS(1113),
    [anon_sym_AMP] = ACTIONS(1111),
    [anon_sym_BANG] = ACTIONS(1111),
    [anon_sym_TILDE] = ACTIONS(1111),
    [anon_sym_PLUS] = ACTIONS(1113),
    [anon_sym_DASH] = ACTIONS(1113),
    [anon_sym_DASH_DASH] = ACTIONS(1111),
    [anon_sym_PLUS_PLUS] = ACTIONS(1111),
    [anon_sym_sizeof] = ACTIONS(1113),
    [sym_number_literal] = ACTIONS(1111),
    [sym_char_literal] = ACTIONS(1111),
    [sym_string_literal] = ACTIONS(1111),
    [sym_true] = ACTIONS(1113),
    [sym_false] = ACTIONS(1113),
    [sym_null] = ACTIONS(1113),
    [sym_identifier] = ACTIONS(1113),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(1113),
    [anon_sym_COLON_COLON] = ACTIONS(1111),
    [anon_sym_delete] = ACTIONS(1113),
    [sym_nullptr] = ACTIONS(1113),
  },
  [1354] = {
    [aux_sym_template_argument_list_repeat1] = STATE(1894),
    [anon_sym_COMMA] = ACTIONS(1127),
    [anon_sym_GT] = ACTIONS(4348),
    [sym_comment] = ACTIONS(49),
  },
  [1355] = {
    [sym_storage_class_specifier] = STATE(1327),
    [sym_type_qualifier] = STATE(1327),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1327),
    [sym_raw_string_literal] = ACTIONS(1811),
    [anon_sym_LPAREN] = ACTIONS(1811),
    [anon_sym_extern] = ACTIONS(1518),
    [anon_sym_STAR] = ACTIONS(1811),
    [anon_sym_LBRACK] = ACTIONS(1811),
    [anon_sym_RBRACK] = ACTIONS(1811),
    [anon_sym_static] = ACTIONS(1518),
    [anon_sym_register] = ACTIONS(1518),
    [anon_sym_inline] = ACTIONS(1518),
    [anon_sym_const] = ACTIONS(1520),
    [anon_sym_restrict] = ACTIONS(1520),
    [anon_sym_volatile] = ACTIONS(1520),
    [anon_sym__Atomic] = ACTIONS(1520),
    [anon_sym_mutable] = ACTIONS(1520),
    [anon_sym_explicit] = ACTIONS(1520),
    [anon_sym_constexpr] = ACTIONS(1520),
    [anon_sym_AMP] = ACTIONS(1811),
    [anon_sym_BANG] = ACTIONS(1811),
    [anon_sym_TILDE] = ACTIONS(1811),
    [anon_sym_PLUS] = ACTIONS(1813),
    [anon_sym_DASH] = ACTIONS(1813),
    [anon_sym_DASH_DASH] = ACTIONS(1811),
    [anon_sym_PLUS_PLUS] = ACTIONS(1811),
    [anon_sym_sizeof] = ACTIONS(1813),
    [sym_number_literal] = ACTIONS(1811),
    [sym_char_literal] = ACTIONS(1811),
    [sym_string_literal] = ACTIONS(1811),
    [sym_true] = ACTIONS(1813),
    [sym_false] = ACTIONS(1813),
    [sym_null] = ACTIONS(1813),
    [sym_identifier] = ACTIONS(1813),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(1813),
    [anon_sym_COLON_COLON] = ACTIONS(1811),
    [anon_sym_delete] = ACTIONS(1813),
    [sym_nullptr] = ACTIONS(1813),
  },
  [1356] = {
    [sym_enumerator] = STATE(1897),
    [anon_sym_COMMA] = ACTIONS(4350),
    [anon_sym_RBRACE] = ACTIONS(4352),
    [sym_identifier] = ACTIONS(348),
    [sym_comment] = ACTIONS(49),
  },
  [1357] = {
    [sym_enumerator_list] = STATE(1898),
    [anon_sym_LPAREN] = ACTIONS(350),
    [anon_sym_COMMA] = ACTIONS(350),
    [anon_sym_RPAREN] = ACTIONS(350),
    [anon_sym_SEMI] = ACTIONS(350),
    [anon_sym_LBRACE] = ACTIONS(350),
    [anon_sym_STAR] = ACTIONS(350),
    [anon_sym_LBRACK] = ACTIONS(350),
    [anon_sym_EQ] = ACTIONS(350),
    [anon_sym_const] = ACTIONS(352),
    [anon_sym_restrict] = ACTIONS(350),
    [anon_sym_volatile] = ACTIONS(350),
    [anon_sym__Atomic] = ACTIONS(350),
    [anon_sym_mutable] = ACTIONS(350),
    [anon_sym_explicit] = ACTIONS(350),
    [anon_sym_constexpr] = ACTIONS(350),
    [anon_sym_COLON] = ACTIONS(350),
    [anon_sym_AMP] = ACTIONS(352),
    [anon_sym_AMP_AMP] = ACTIONS(350),
    [anon_sym_GT] = ACTIONS(350),
    [anon_sym_DASH_GT] = ACTIONS(350),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(350),
  },
  [1358] = {
    [anon_sym_LPAREN] = ACTIONS(354),
    [anon_sym_COMMA] = ACTIONS(354),
    [anon_sym_RPAREN] = ACTIONS(354),
    [anon_sym_SEMI] = ACTIONS(354),
    [anon_sym_LBRACE] = ACTIONS(354),
    [anon_sym_STAR] = ACTIONS(354),
    [anon_sym_LBRACK] = ACTIONS(354),
    [anon_sym_EQ] = ACTIONS(354),
    [anon_sym_const] = ACTIONS(356),
    [anon_sym_restrict] = ACTIONS(354),
    [anon_sym_volatile] = ACTIONS(354),
    [anon_sym__Atomic] = ACTIONS(354),
    [anon_sym_mutable] = ACTIONS(354),
    [anon_sym_explicit] = ACTIONS(354),
    [anon_sym_constexpr] = ACTIONS(354),
    [anon_sym_COLON] = ACTIONS(354),
    [anon_sym_AMP] = ACTIONS(356),
    [anon_sym_AMP_AMP] = ACTIONS(354),
    [anon_sym_GT] = ACTIONS(354),
    [anon_sym_DASH_GT] = ACTIONS(354),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(354),
  },
  [1359] = {
    [sym_preproc_if_in_field_declaration_list] = STATE(246),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(247),
    [sym_type_definition] = STATE(1900),
    [sym__declaration_specifiers] = STATE(248),
    [sym__declarator] = STATE(249),
    [sym_pointer_declarator] = STATE(249),
    [sym_function_declarator] = STATE(250),
    [sym_array_declarator] = STATE(249),
    [sym_storage_class_specifier] = STATE(257),
    [sym_type_qualifier] = STATE(257),
    [sym__type_specifier] = STATE(251),
    [sym_sized_type_specifier] = STATE(251),
    [sym_enum_specifier] = STATE(251),
    [sym_struct_specifier] = STATE(251),
    [sym_union_specifier] = STATE(251),
    [sym__field_declaration_list_item] = STATE(1900),
    [sym_field_declaration] = STATE(1900),
    [sym_macro_type_specifier] = STATE(251),
    [sym_class_specifier] = STATE(251),
    [sym_dependent_type] = STATE(251),
    [sym_template_declaration] = STATE(1900),
    [sym_inline_method_definition] = STATE(252),
    [sym_constructor_or_destructor_definition] = STATE(252),
    [sym_constructor_or_destructor_declaration] = STATE(253),
    [sym_friend_declaration] = STATE(1900),
    [sym_access_specifier] = STATE(1900),
    [sym_reference_declarator] = STATE(249),
    [sym_template_type] = STATE(254),
    [sym_template_function] = STATE(249),
    [sym_using_declaration] = STATE(1900),
    [sym_alias_declaration] = STATE(1900),
    [sym_destructor_name] = STATE(249),
    [sym_scoped_identifier] = STATE(33),
    [sym_scoped_type_identifier] = STATE(34),
    [sym_scoped_namespace_identifier] = STATE(255),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(1900),
    [aux_sym__declaration_specifiers_repeat1] = STATE(257),
    [aux_sym_sized_type_specifier_repeat1] = STATE(258),
    [anon_sym_LPAREN] = ACTIONS(11),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(358),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(360),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(362),
    [anon_sym_typedef] = ACTIONS(364),
    [anon_sym_extern] = ACTIONS(27),
    [anon_sym_RBRACE] = ACTIONS(4354),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_static] = ACTIONS(27),
    [anon_sym_register] = ACTIONS(27),
    [anon_sym_inline] = ACTIONS(27),
    [anon_sym_const] = ACTIONS(29),
    [anon_sym_restrict] = ACTIONS(29),
    [anon_sym_volatile] = ACTIONS(29),
    [anon_sym__Atomic] = ACTIONS(29),
    [anon_sym_mutable] = ACTIONS(29),
    [anon_sym_explicit] = ACTIONS(29),
    [anon_sym_constexpr] = ACTIONS(29),
    [anon_sym_unsigned] = ACTIONS(368),
    [anon_sym_long] = ACTIONS(368),
    [anon_sym_short] = ACTIONS(368),
    [sym_primitive_type] = ACTIONS(370),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(372),
    [anon_sym_union] = ACTIONS(374),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(45),
    [sym_identifier] = ACTIONS(376),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(378),
    [anon_sym_public] = ACTIONS(380),
    [sym_auto] = ACTIONS(370),
    [anon_sym_typename] = ACTIONS(382),
    [anon_sym_template] = ACTIONS(384),
    [anon_sym_friend] = ACTIONS(386),
    [anon_sym_private] = ACTIONS(380),
    [anon_sym_protected] = ACTIONS(380),
    [anon_sym_using] = ACTIONS(388),
    [anon_sym_COLON_COLON] = ACTIONS(390),
    [sym_operator_name] = ACTIONS(392),
  },
  [1360] = {
    [sym_template_argument_list] = STATE(1371),
    [anon_sym_LPAREN] = ACTIONS(398),
    [anon_sym_COMMA] = ACTIONS(398),
    [anon_sym_RPAREN] = ACTIONS(398),
    [anon_sym_SEMI] = ACTIONS(398),
    [anon_sym_LBRACE] = ACTIONS(398),
    [anon_sym_STAR] = ACTIONS(398),
    [anon_sym_LBRACK] = ACTIONS(398),
    [anon_sym_EQ] = ACTIONS(398),
    [anon_sym_const] = ACTIONS(400),
    [anon_sym_restrict] = ACTIONS(398),
    [anon_sym_volatile] = ACTIONS(398),
    [anon_sym__Atomic] = ACTIONS(398),
    [anon_sym_mutable] = ACTIONS(398),
    [anon_sym_explicit] = ACTIONS(398),
    [anon_sym_constexpr] = ACTIONS(398),
    [anon_sym_COLON] = ACTIONS(400),
    [anon_sym_AMP] = ACTIONS(400),
    [anon_sym_AMP_AMP] = ACTIONS(398),
    [anon_sym_LT] = ACTIONS(2833),
    [anon_sym_GT] = ACTIONS(398),
    [anon_sym_DASH_GT] = ACTIONS(398),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(398),
    [anon_sym_COLON_COLON] = ACTIONS(2835),
  },
  [1361] = {
    [anon_sym_LPAREN] = ACTIONS(406),
    [anon_sym_COMMA] = ACTIONS(406),
    [anon_sym_RPAREN] = ACTIONS(406),
    [anon_sym_SEMI] = ACTIONS(406),
    [anon_sym_LBRACE] = ACTIONS(406),
    [anon_sym_STAR] = ACTIONS(406),
    [anon_sym_LBRACK] = ACTIONS(406),
    [anon_sym_EQ] = ACTIONS(406),
    [anon_sym_const] = ACTIONS(408),
    [anon_sym_restrict] = ACTIONS(406),
    [anon_sym_volatile] = ACTIONS(406),
    [anon_sym__Atomic] = ACTIONS(406),
    [anon_sym_mutable] = ACTIONS(406),
    [anon_sym_explicit] = ACTIONS(406),
    [anon_sym_constexpr] = ACTIONS(406),
    [anon_sym_COLON] = ACTIONS(406),
    [anon_sym_AMP] = ACTIONS(408),
    [anon_sym_AMP_AMP] = ACTIONS(406),
    [anon_sym_GT] = ACTIONS(406),
    [anon_sym_DASH_GT] = ACTIONS(406),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(406),
  },
  [1362] = {
    [sym_field_declaration_list] = STATE(1901),
    [sym_base_class_clause] = STATE(1902),
    [anon_sym_LPAREN] = ACTIONS(406),
    [anon_sym_COMMA] = ACTIONS(406),
    [anon_sym_SEMI] = ACTIONS(406),
    [anon_sym_LBRACE] = ACTIONS(406),
    [anon_sym_STAR] = ACTIONS(406),
    [anon_sym_LBRACK] = ACTIONS(406),
    [anon_sym_EQ] = ACTIONS(406),
    [anon_sym_const] = ACTIONS(408),
    [anon_sym_restrict] = ACTIONS(406),
    [anon_sym_volatile] = ACTIONS(406),
    [anon_sym__Atomic] = ACTIONS(406),
    [anon_sym_mutable] = ACTIONS(406),
    [anon_sym_explicit] = ACTIONS(406),
    [anon_sym_constexpr] = ACTIONS(406),
    [anon_sym_COLON] = ACTIONS(406),
    [anon_sym_AMP] = ACTIONS(408),
    [anon_sym_AMP_AMP] = ACTIONS(406),
    [anon_sym_DASH_GT] = ACTIONS(406),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(406),
  },
  [1363] = {
    [sym_field_declaration_list] = STATE(1901),
    [anon_sym_LBRACE] = ACTIONS(2829),
    [sym_comment] = ACTIONS(49),
  },
  [1364] = {
    [anon_sym_LPAREN] = ACTIONS(410),
    [anon_sym_COMMA] = ACTIONS(410),
    [anon_sym_RPAREN] = ACTIONS(410),
    [anon_sym_SEMI] = ACTIONS(410),
    [anon_sym_LBRACE] = ACTIONS(410),
    [anon_sym_STAR] = ACTIONS(410),
    [anon_sym_LBRACK] = ACTIONS(410),
    [anon_sym_EQ] = ACTIONS(410),
    [anon_sym_const] = ACTIONS(412),
    [anon_sym_restrict] = ACTIONS(410),
    [anon_sym_volatile] = ACTIONS(410),
    [anon_sym__Atomic] = ACTIONS(410),
    [anon_sym_mutable] = ACTIONS(410),
    [anon_sym_explicit] = ACTIONS(410),
    [anon_sym_constexpr] = ACTIONS(410),
    [anon_sym_COLON] = ACTIONS(412),
    [anon_sym_AMP] = ACTIONS(412),
    [anon_sym_AMP_AMP] = ACTIONS(410),
    [anon_sym_GT] = ACTIONS(410),
    [anon_sym_DASH_GT] = ACTIONS(410),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(410),
    [anon_sym_COLON_COLON] = ACTIONS(2851),
  },
  [1365] = {
    [sym_template_argument_list] = STATE(1382),
    [anon_sym_LPAREN] = ACTIONS(410),
    [anon_sym_COMMA] = ACTIONS(410),
    [anon_sym_RPAREN] = ACTIONS(410),
    [anon_sym_SEMI] = ACTIONS(410),
    [anon_sym_LBRACE] = ACTIONS(410),
    [anon_sym_STAR] = ACTIONS(410),
    [anon_sym_LBRACK] = ACTIONS(410),
    [anon_sym_EQ] = ACTIONS(410),
    [anon_sym_const] = ACTIONS(412),
    [anon_sym_restrict] = ACTIONS(410),
    [anon_sym_volatile] = ACTIONS(410),
    [anon_sym__Atomic] = ACTIONS(410),
    [anon_sym_mutable] = ACTIONS(410),
    [anon_sym_explicit] = ACTIONS(410),
    [anon_sym_constexpr] = ACTIONS(410),
    [anon_sym_COLON] = ACTIONS(410),
    [anon_sym_AMP] = ACTIONS(412),
    [anon_sym_AMP_AMP] = ACTIONS(410),
    [anon_sym_LT] = ACTIONS(2833),
    [anon_sym_GT] = ACTIONS(410),
    [anon_sym_DASH_GT] = ACTIONS(410),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(410),
  },
  [1366] = {
    [anon_sym_LPAREN] = ACTIONS(416),
    [anon_sym_COMMA] = ACTIONS(416),
    [anon_sym_RPAREN] = ACTIONS(416),
    [anon_sym_SEMI] = ACTIONS(416),
    [anon_sym_LBRACE] = ACTIONS(416),
    [anon_sym_STAR] = ACTIONS(416),
    [anon_sym_LBRACK] = ACTIONS(416),
    [anon_sym_EQ] = ACTIONS(416),
    [anon_sym_const] = ACTIONS(418),
    [anon_sym_restrict] = ACTIONS(416),
    [anon_sym_volatile] = ACTIONS(416),
    [anon_sym__Atomic] = ACTIONS(416),
    [anon_sym_mutable] = ACTIONS(416),
    [anon_sym_explicit] = ACTIONS(416),
    [anon_sym_constexpr] = ACTIONS(416),
    [anon_sym_COLON] = ACTIONS(416),
    [anon_sym_AMP] = ACTIONS(418),
    [anon_sym_AMP_AMP] = ACTIONS(416),
    [anon_sym_GT] = ACTIONS(416),
    [anon_sym_DASH_GT] = ACTIONS(416),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(416),
  },
  [1367] = {
    [sym_field_declaration_list] = STATE(1903),
    [sym_base_class_clause] = STATE(1904),
    [anon_sym_LPAREN] = ACTIONS(416),
    [anon_sym_COMMA] = ACTIONS(416),
    [anon_sym_SEMI] = ACTIONS(416),
    [anon_sym_LBRACE] = ACTIONS(416),
    [anon_sym_STAR] = ACTIONS(416),
    [anon_sym_LBRACK] = ACTIONS(416),
    [anon_sym_EQ] = ACTIONS(416),
    [anon_sym_const] = ACTIONS(418),
    [anon_sym_restrict] = ACTIONS(416),
    [anon_sym_volatile] = ACTIONS(416),
    [anon_sym__Atomic] = ACTIONS(416),
    [anon_sym_mutable] = ACTIONS(416),
    [anon_sym_explicit] = ACTIONS(416),
    [anon_sym_constexpr] = ACTIONS(416),
    [anon_sym_COLON] = ACTIONS(416),
    [anon_sym_AMP] = ACTIONS(418),
    [anon_sym_AMP_AMP] = ACTIONS(416),
    [anon_sym_DASH_GT] = ACTIONS(416),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(416),
  },
  [1368] = {
    [sym_field_declaration_list] = STATE(1903),
    [anon_sym_LBRACE] = ACTIONS(2829),
    [sym_comment] = ACTIONS(49),
  },
  [1369] = {
    [sym_type_qualifier] = STATE(279),
    [sym__type_specifier] = STATE(277),
    [sym_sized_type_specifier] = STATE(277),
    [sym_enum_specifier] = STATE(277),
    [sym_struct_specifier] = STATE(277),
    [sym_union_specifier] = STATE(277),
    [sym_type_descriptor] = STATE(1906),
    [sym_parenthesized_expression] = STATE(1906),
    [sym_macro_type_specifier] = STATE(277),
    [sym_class_specifier] = STATE(277),
    [sym_dependent_type] = STATE(277),
    [sym_template_type] = STATE(62),
    [sym_scoped_type_identifier] = STATE(34),
    [sym_scoped_namespace_identifier] = STATE(64),
    [aux_sym_type_definition_repeat1] = STATE(279),
    [aux_sym_sized_type_specifier_repeat1] = STATE(280),
    [anon_sym_LPAREN] = ACTIONS(422),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_restrict] = ACTIONS(93),
    [anon_sym_volatile] = ACTIONS(93),
    [anon_sym__Atomic] = ACTIONS(93),
    [anon_sym_mutable] = ACTIONS(93),
    [anon_sym_explicit] = ACTIONS(93),
    [anon_sym_constexpr] = ACTIONS(93),
    [anon_sym_unsigned] = ACTIONS(424),
    [anon_sym_long] = ACTIONS(424),
    [anon_sym_short] = ACTIONS(424),
    [sym_primitive_type] = ACTIONS(426),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(428),
    [anon_sym_union] = ACTIONS(430),
    [anon_sym_GT] = ACTIONS(4356),
    [sym_identifier] = ACTIONS(434),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(436),
    [sym_auto] = ACTIONS(426),
    [anon_sym_typename] = ACTIONS(438),
    [anon_sym_COLON_COLON] = ACTIONS(111),
  },
  [1370] = {
    [sym_identifier] = ACTIONS(4358),
    [sym_comment] = ACTIONS(49),
  },
  [1371] = {
    [anon_sym_LPAREN] = ACTIONS(447),
    [anon_sym_COMMA] = ACTIONS(447),
    [anon_sym_RPAREN] = ACTIONS(447),
    [anon_sym_SEMI] = ACTIONS(447),
    [anon_sym_LBRACE] = ACTIONS(447),
    [anon_sym_STAR] = ACTIONS(447),
    [anon_sym_LBRACK] = ACTIONS(447),
    [anon_sym_EQ] = ACTIONS(447),
    [anon_sym_const] = ACTIONS(449),
    [anon_sym_restrict] = ACTIONS(447),
    [anon_sym_volatile] = ACTIONS(447),
    [anon_sym__Atomic] = ACTIONS(447),
    [anon_sym_mutable] = ACTIONS(447),
    [anon_sym_explicit] = ACTIONS(447),
    [anon_sym_constexpr] = ACTIONS(447),
    [anon_sym_COLON] = ACTIONS(449),
    [anon_sym_AMP] = ACTIONS(449),
    [anon_sym_AMP_AMP] = ACTIONS(447),
    [anon_sym_GT] = ACTIONS(447),
    [anon_sym_DASH_GT] = ACTIONS(447),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(447),
    [anon_sym_COLON_COLON] = ACTIONS(447),
  },
  [1372] = {
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_COMMA] = ACTIONS(451),
    [anon_sym_RPAREN] = ACTIONS(451),
    [anon_sym_SEMI] = ACTIONS(451),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_STAR] = ACTIONS(451),
    [anon_sym_LBRACK] = ACTIONS(451),
    [anon_sym_EQ] = ACTIONS(451),
    [anon_sym_const] = ACTIONS(453),
    [anon_sym_restrict] = ACTIONS(451),
    [anon_sym_volatile] = ACTIONS(451),
    [anon_sym__Atomic] = ACTIONS(451),
    [anon_sym_mutable] = ACTIONS(451),
    [anon_sym_explicit] = ACTIONS(451),
    [anon_sym_constexpr] = ACTIONS(451),
    [anon_sym_COLON] = ACTIONS(451),
    [anon_sym_AMP] = ACTIONS(453),
    [anon_sym_AMP_AMP] = ACTIONS(451),
    [anon_sym_GT] = ACTIONS(451),
    [anon_sym_DASH_GT] = ACTIONS(451),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(451),
  },
  [1373] = {
    [sym_field_declaration_list] = STATE(1908),
    [sym_base_class_clause] = STATE(1909),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_COMMA] = ACTIONS(451),
    [anon_sym_SEMI] = ACTIONS(451),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_STAR] = ACTIONS(451),
    [anon_sym_LBRACK] = ACTIONS(451),
    [anon_sym_EQ] = ACTIONS(451),
    [anon_sym_const] = ACTIONS(453),
    [anon_sym_restrict] = ACTIONS(451),
    [anon_sym_volatile] = ACTIONS(451),
    [anon_sym__Atomic] = ACTIONS(451),
    [anon_sym_mutable] = ACTIONS(451),
    [anon_sym_explicit] = ACTIONS(451),
    [anon_sym_constexpr] = ACTIONS(451),
    [anon_sym_COLON] = ACTIONS(451),
    [anon_sym_AMP] = ACTIONS(453),
    [anon_sym_AMP_AMP] = ACTIONS(451),
    [anon_sym_DASH_GT] = ACTIONS(451),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(451),
  },
  [1374] = {
    [sym_field_declaration_list] = STATE(1908),
    [anon_sym_LBRACE] = ACTIONS(2829),
    [sym_comment] = ACTIONS(49),
  },
  [1375] = {
    [anon_sym_LPAREN] = ACTIONS(455),
    [anon_sym_COMMA] = ACTIONS(455),
    [anon_sym_RPAREN] = ACTIONS(455),
    [anon_sym_SEMI] = ACTIONS(455),
    [anon_sym_LBRACE] = ACTIONS(455),
    [anon_sym_STAR] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(455),
    [anon_sym_EQ] = ACTIONS(455),
    [anon_sym_const] = ACTIONS(457),
    [anon_sym_restrict] = ACTIONS(455),
    [anon_sym_volatile] = ACTIONS(455),
    [anon_sym__Atomic] = ACTIONS(455),
    [anon_sym_mutable] = ACTIONS(455),
    [anon_sym_explicit] = ACTIONS(455),
    [anon_sym_constexpr] = ACTIONS(455),
    [anon_sym_COLON] = ACTIONS(455),
    [anon_sym_AMP] = ACTIONS(457),
    [anon_sym_AMP_AMP] = ACTIONS(455),
    [anon_sym_GT] = ACTIONS(455),
    [anon_sym_DASH_GT] = ACTIONS(455),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(455),
  },
  [1376] = {
    [anon_sym_LPAREN] = ACTIONS(512),
    [anon_sym_COMMA] = ACTIONS(512),
    [anon_sym_RPAREN] = ACTIONS(512),
    [anon_sym_SEMI] = ACTIONS(512),
    [anon_sym_LBRACE] = ACTIONS(512),
    [anon_sym_STAR] = ACTIONS(512),
    [anon_sym_LBRACK] = ACTIONS(512),
    [anon_sym_EQ] = ACTIONS(512),
    [anon_sym_const] = ACTIONS(514),
    [anon_sym_restrict] = ACTIONS(512),
    [anon_sym_volatile] = ACTIONS(512),
    [anon_sym__Atomic] = ACTIONS(512),
    [anon_sym_mutable] = ACTIONS(512),
    [anon_sym_explicit] = ACTIONS(512),
    [anon_sym_constexpr] = ACTIONS(512),
    [anon_sym_COLON] = ACTIONS(514),
    [anon_sym_AMP] = ACTIONS(514),
    [anon_sym_AMP_AMP] = ACTIONS(512),
    [anon_sym_LT] = ACTIONS(512),
    [anon_sym_GT] = ACTIONS(512),
    [anon_sym_DASH_GT] = ACTIONS(512),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(512),
    [anon_sym_COLON_COLON] = ACTIONS(516),
  },
  [1377] = {
    [sym__abstract_declarator] = STATE(1910),
    [sym_abstract_pointer_declarator] = STATE(1910),
    [sym_abstract_function_declarator] = STATE(1910),
    [sym_abstract_array_declarator] = STATE(1910),
    [sym_parameter_list] = STATE(1380),
    [sym_abstract_reference_declarator] = STATE(1910),
    [anon_sym_LPAREN] = ACTIONS(1115),
    [anon_sym_LBRACE] = ACTIONS(2270),
    [anon_sym_STAR] = ACTIONS(2843),
    [anon_sym_LBRACK] = ACTIONS(1121),
    [anon_sym_const] = ACTIONS(4360),
    [anon_sym_restrict] = ACTIONS(2270),
    [anon_sym_volatile] = ACTIONS(2270),
    [anon_sym__Atomic] = ACTIONS(2270),
    [anon_sym_mutable] = ACTIONS(2270),
    [anon_sym_explicit] = ACTIONS(2270),
    [anon_sym_constexpr] = ACTIONS(2270),
    [anon_sym_COLON] = ACTIONS(2270),
    [anon_sym_AMP] = ACTIONS(2847),
    [anon_sym_AMP_AMP] = ACTIONS(2849),
    [anon_sym_DASH_GT] = ACTIONS(2270),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(2270),
  },
  [1378] = {
    [sym__abstract_declarator] = STATE(1911),
    [sym_abstract_pointer_declarator] = STATE(1911),
    [sym_abstract_function_declarator] = STATE(1911),
    [sym_abstract_array_declarator] = STATE(1911),
    [sym_parameter_list] = STATE(1380),
    [sym_abstract_reference_declarator] = STATE(1911),
    [anon_sym_LPAREN] = ACTIONS(1115),
    [anon_sym_LBRACE] = ACTIONS(2278),
    [anon_sym_STAR] = ACTIONS(2843),
    [anon_sym_LBRACK] = ACTIONS(1121),
    [anon_sym_const] = ACTIONS(4362),
    [anon_sym_restrict] = ACTIONS(2278),
    [anon_sym_volatile] = ACTIONS(2278),
    [anon_sym__Atomic] = ACTIONS(2278),
    [anon_sym_mutable] = ACTIONS(2278),
    [anon_sym_explicit] = ACTIONS(2278),
    [anon_sym_constexpr] = ACTIONS(2278),
    [anon_sym_COLON] = ACTIONS(2278),
    [anon_sym_AMP] = ACTIONS(2847),
    [anon_sym_AMP_AMP] = ACTIONS(2849),
    [anon_sym_DASH_GT] = ACTIONS(2278),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(2278),
  },
  [1379] = {
    [sym_parameter_list] = STATE(1912),
    [anon_sym_LPAREN] = ACTIONS(206),
    [anon_sym_LBRACE] = ACTIONS(4364),
    [anon_sym_LBRACK] = ACTIONS(2282),
    [anon_sym_const] = ACTIONS(4366),
    [anon_sym_restrict] = ACTIONS(4364),
    [anon_sym_volatile] = ACTIONS(4364),
    [anon_sym__Atomic] = ACTIONS(4364),
    [anon_sym_mutable] = ACTIONS(4364),
    [anon_sym_explicit] = ACTIONS(4364),
    [anon_sym_constexpr] = ACTIONS(4364),
    [anon_sym_COLON] = ACTIONS(4364),
    [anon_sym_DASH_GT] = ACTIONS(4364),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(4364),
  },
  [1380] = {
    [sym_type_qualifier] = STATE(1913),
    [sym_trailing_return_type] = STATE(1129),
    [aux_sym_abstract_function_declarator_repeat1] = STATE(1913),
    [anon_sym_LPAREN] = ACTIONS(2284),
    [anon_sym_LBRACE] = ACTIONS(2284),
    [anon_sym_LBRACK] = ACTIONS(2284),
    [anon_sym_const] = ACTIONS(4368),
    [anon_sym_restrict] = ACTIONS(2284),
    [anon_sym_volatile] = ACTIONS(2284),
    [anon_sym__Atomic] = ACTIONS(2284),
    [anon_sym_mutable] = ACTIONS(2284),
    [anon_sym_explicit] = ACTIONS(2284),
    [anon_sym_constexpr] = ACTIONS(2284),
    [anon_sym_COLON] = ACTIONS(2284),
    [anon_sym_DASH_GT] = ACTIONS(2284),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(2284),
  },
  [1381] = {
    [sym_identifier] = ACTIONS(4370),
    [sym_comment] = ACTIONS(49),
  },
  [1382] = {
    [anon_sym_LPAREN] = ACTIONS(708),
    [anon_sym_COMMA] = ACTIONS(708),
    [anon_sym_RPAREN] = ACTIONS(708),
    [anon_sym_SEMI] = ACTIONS(708),
    [anon_sym_LBRACE] = ACTIONS(708),
    [anon_sym_STAR] = ACTIONS(708),
    [anon_sym_LBRACK] = ACTIONS(708),
    [anon_sym_EQ] = ACTIONS(708),
    [anon_sym_const] = ACTIONS(710),
    [anon_sym_restrict] = ACTIONS(708),
    [anon_sym_volatile] = ACTIONS(708),
    [anon_sym__Atomic] = ACTIONS(708),
    [anon_sym_mutable] = ACTIONS(708),
    [anon_sym_explicit] = ACTIONS(708),
    [anon_sym_constexpr] = ACTIONS(708),
    [anon_sym_COLON] = ACTIONS(710),
    [anon_sym_AMP] = ACTIONS(710),
    [anon_sym_AMP_AMP] = ACTIONS(708),
    [anon_sym_GT] = ACTIONS(708),
    [anon_sym_DASH_GT] = ACTIONS(708),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(708),
    [anon_sym_COLON_COLON] = ACTIONS(708),
  },
  [1383] = {
    [anon_sym_LPAREN] = ACTIONS(808),
    [anon_sym_COMMA] = ACTIONS(808),
    [anon_sym_RPAREN] = ACTIONS(808),
    [anon_sym_SEMI] = ACTIONS(808),
    [anon_sym_LBRACE] = ACTIONS(808),
    [anon_sym_STAR] = ACTIONS(808),
    [anon_sym_LBRACK] = ACTIONS(808),
    [anon_sym_EQ] = ACTIONS(808),
    [anon_sym_const] = ACTIONS(810),
    [anon_sym_restrict] = ACTIONS(808),
    [anon_sym_volatile] = ACTIONS(808),
    [anon_sym__Atomic] = ACTIONS(808),
    [anon_sym_mutable] = ACTIONS(808),
    [anon_sym_explicit] = ACTIONS(808),
    [anon_sym_constexpr] = ACTIONS(808),
    [anon_sym_COLON] = ACTIONS(808),
    [anon_sym_AMP] = ACTIONS(810),
    [anon_sym_AMP_AMP] = ACTIONS(808),
    [anon_sym_GT] = ACTIONS(808),
    [anon_sym_DASH_GT] = ACTIONS(808),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(808),
  },
  [1384] = {
    [anon_sym_LPAREN] = ACTIONS(812),
    [anon_sym_COMMA] = ACTIONS(812),
    [anon_sym_RPAREN] = ACTIONS(812),
    [anon_sym_SEMI] = ACTIONS(812),
    [anon_sym_LBRACE] = ACTIONS(812),
    [anon_sym_STAR] = ACTIONS(812),
    [anon_sym_LBRACK] = ACTIONS(812),
    [anon_sym_EQ] = ACTIONS(812),
    [anon_sym_const] = ACTIONS(814),
    [anon_sym_restrict] = ACTIONS(812),
    [anon_sym_volatile] = ACTIONS(812),
    [anon_sym__Atomic] = ACTIONS(812),
    [anon_sym_mutable] = ACTIONS(812),
    [anon_sym_explicit] = ACTIONS(812),
    [anon_sym_constexpr] = ACTIONS(812),
    [anon_sym_COLON] = ACTIONS(812),
    [anon_sym_AMP] = ACTIONS(814),
    [anon_sym_AMP_AMP] = ACTIONS(812),
    [anon_sym_GT] = ACTIONS(812),
    [anon_sym_DASH_GT] = ACTIONS(812),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(812),
  },
  [1385] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(1385),
    [anon_sym_LPAREN] = ACTIONS(816),
    [anon_sym_LBRACE] = ACTIONS(816),
    [anon_sym_STAR] = ACTIONS(816),
    [anon_sym_LBRACK] = ACTIONS(816),
    [anon_sym_const] = ACTIONS(818),
    [anon_sym_restrict] = ACTIONS(818),
    [anon_sym_volatile] = ACTIONS(818),
    [anon_sym__Atomic] = ACTIONS(818),
    [anon_sym_mutable] = ACTIONS(818),
    [anon_sym_explicit] = ACTIONS(818),
    [anon_sym_constexpr] = ACTIONS(818),
    [anon_sym_unsigned] = ACTIONS(4372),
    [anon_sym_long] = ACTIONS(4372),
    [anon_sym_short] = ACTIONS(4372),
    [sym_primitive_type] = ACTIONS(818),
    [anon_sym_COLON] = ACTIONS(816),
    [anon_sym_AMP] = ACTIONS(818),
    [anon_sym_AMP_AMP] = ACTIONS(816),
    [anon_sym_DASH_GT] = ACTIONS(816),
    [sym_identifier] = ACTIONS(818),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(818),
  },
  [1386] = {
    [sym_preproc_arg] = ACTIONS(4375),
    [sym_comment] = ACTIONS(83),
  },
  [1387] = {
    [sym_raw_string_literal] = ACTIONS(825),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(827),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(827),
    [anon_sym_LPAREN] = ACTIONS(825),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(827),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(827),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(827),
    [sym_preproc_directive] = ACTIONS(827),
    [anon_sym_SEMI] = ACTIONS(825),
    [anon_sym_typedef] = ACTIONS(827),
    [anon_sym_extern] = ACTIONS(827),
    [anon_sym_LBRACE] = ACTIONS(825),
    [anon_sym_RBRACE] = ACTIONS(825),
    [anon_sym_STAR] = ACTIONS(825),
    [anon_sym_LBRACK] = ACTIONS(825),
    [anon_sym_static] = ACTIONS(827),
    [anon_sym_register] = ACTIONS(827),
    [anon_sym_inline] = ACTIONS(827),
    [anon_sym_const] = ACTIONS(827),
    [anon_sym_restrict] = ACTIONS(827),
    [anon_sym_volatile] = ACTIONS(827),
    [anon_sym__Atomic] = ACTIONS(827),
    [anon_sym_mutable] = ACTIONS(827),
    [anon_sym_explicit] = ACTIONS(827),
    [anon_sym_constexpr] = ACTIONS(827),
    [anon_sym_unsigned] = ACTIONS(827),
    [anon_sym_long] = ACTIONS(827),
    [anon_sym_short] = ACTIONS(827),
    [sym_primitive_type] = ACTIONS(827),
    [anon_sym_enum] = ACTIONS(827),
    [anon_sym_struct] = ACTIONS(827),
    [anon_sym_union] = ACTIONS(827),
    [anon_sym_if] = ACTIONS(827),
    [anon_sym_switch] = ACTIONS(827),
    [anon_sym_case] = ACTIONS(827),
    [anon_sym_default] = ACTIONS(827),
    [anon_sym_while] = ACTIONS(827),
    [anon_sym_do] = ACTIONS(827),
    [anon_sym_for] = ACTIONS(827),
    [anon_sym_return] = ACTIONS(827),
    [anon_sym_break] = ACTIONS(827),
    [anon_sym_continue] = ACTIONS(827),
    [anon_sym_goto] = ACTIONS(827),
    [anon_sym_AMP] = ACTIONS(825),
    [anon_sym_BANG] = ACTIONS(825),
    [anon_sym_TILDE] = ACTIONS(825),
    [anon_sym_PLUS] = ACTIONS(827),
    [anon_sym_DASH] = ACTIONS(827),
    [anon_sym_DASH_DASH] = ACTIONS(825),
    [anon_sym_PLUS_PLUS] = ACTIONS(825),
    [anon_sym_sizeof] = ACTIONS(827),
    [sym_number_literal] = ACTIONS(825),
    [sym_char_literal] = ACTIONS(825),
    [sym_string_literal] = ACTIONS(825),
    [sym_true] = ACTIONS(827),
    [sym_false] = ACTIONS(827),
    [sym_null] = ACTIONS(827),
    [sym_identifier] = ACTIONS(827),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(827),
    [sym_auto] = ACTIONS(827),
    [anon_sym_typename] = ACTIONS(827),
    [anon_sym_new] = ACTIONS(827),
    [anon_sym_COLON_COLON] = ACTIONS(825),
    [anon_sym_delete] = ACTIONS(827),
    [sym_nullptr] = ACTIONS(827),
  },
  [1388] = {
    [anon_sym_LF] = ACTIONS(4377),
    [sym_preproc_arg] = ACTIONS(4379),
    [sym_comment] = ACTIONS(83),
  },
  [1389] = {
    [sym__expression] = STATE(1834),
    [sym_conditional_expression] = STATE(1834),
    [sym_assignment_expression] = STATE(1834),
    [sym_pointer_expression] = STATE(1834),
    [sym_logical_expression] = STATE(1834),
    [sym_bitwise_expression] = STATE(1834),
    [sym_equality_expression] = STATE(1834),
    [sym_relational_expression] = STATE(1834),
    [sym_shift_expression] = STATE(1834),
    [sym_math_expression] = STATE(1834),
    [sym_cast_expression] = STATE(1834),
    [sym_sizeof_expression] = STATE(1834),
    [sym_subscript_expression] = STATE(1834),
    [sym_call_expression] = STATE(1834),
    [sym_field_expression] = STATE(1834),
    [sym_compound_literal_expression] = STATE(1834),
    [sym_parenthesized_expression] = STATE(1834),
    [sym_initializer_list] = STATE(1835),
    [sym_concatenated_string] = STATE(1834),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(1834),
    [sym_new_expression] = STATE(1834),
    [sym_delete_expression] = STATE(1834),
    [sym_lambda_expression] = STATE(1834),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(4145),
    [anon_sym_LPAREN] = ACTIONS(626),
    [anon_sym_LBRACE] = ACTIONS(548),
    [anon_sym_STAR] = ACTIONS(644),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_AMP] = ACTIONS(644),
    [anon_sym_BANG] = ACTIONS(668),
    [anon_sym_TILDE] = ACTIONS(670),
    [anon_sym_PLUS] = ACTIONS(672),
    [anon_sym_DASH] = ACTIONS(672),
    [anon_sym_DASH_DASH] = ACTIONS(674),
    [anon_sym_PLUS_PLUS] = ACTIONS(674),
    [anon_sym_sizeof] = ACTIONS(676),
    [sym_number_literal] = ACTIONS(4145),
    [sym_char_literal] = ACTIONS(4145),
    [sym_string_literal] = ACTIONS(678),
    [sym_true] = ACTIONS(4147),
    [sym_false] = ACTIONS(4147),
    [sym_null] = ACTIONS(4147),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1303),
    [anon_sym_delete] = ACTIONS(686),
    [sym_nullptr] = ACTIONS(4147),
  },
  [1390] = {
    [sym_string_literal] = ACTIONS(4381),
    [sym_system_lib_string] = ACTIONS(4381),
    [sym_comment] = ACTIONS(49),
  },
  [1391] = {
    [sym_identifier] = ACTIONS(4383),
    [sym_comment] = ACTIONS(49),
  },
  [1392] = {
    [sym_preproc_arg] = ACTIONS(4385),
    [sym_comment] = ACTIONS(83),
  },
  [1393] = {
    [sym_raw_string_literal] = ACTIONS(4387),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(4389),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(4389),
    [anon_sym_LPAREN] = ACTIONS(4387),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(4389),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(4389),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(4389),
    [sym_preproc_directive] = ACTIONS(4389),
    [anon_sym_SEMI] = ACTIONS(4387),
    [anon_sym_typedef] = ACTIONS(4389),
    [anon_sym_extern] = ACTIONS(4389),
    [anon_sym_LBRACE] = ACTIONS(4387),
    [anon_sym_RBRACE] = ACTIONS(4387),
    [anon_sym_STAR] = ACTIONS(4387),
    [anon_sym_LBRACK] = ACTIONS(4387),
    [anon_sym_static] = ACTIONS(4389),
    [anon_sym_register] = ACTIONS(4389),
    [anon_sym_inline] = ACTIONS(4389),
    [anon_sym_const] = ACTIONS(4389),
    [anon_sym_restrict] = ACTIONS(4389),
    [anon_sym_volatile] = ACTIONS(4389),
    [anon_sym__Atomic] = ACTIONS(4389),
    [anon_sym_mutable] = ACTIONS(4389),
    [anon_sym_explicit] = ACTIONS(4389),
    [anon_sym_constexpr] = ACTIONS(4389),
    [anon_sym_unsigned] = ACTIONS(4389),
    [anon_sym_long] = ACTIONS(4389),
    [anon_sym_short] = ACTIONS(4389),
    [sym_primitive_type] = ACTIONS(4389),
    [anon_sym_enum] = ACTIONS(4389),
    [anon_sym_struct] = ACTIONS(4389),
    [anon_sym_union] = ACTIONS(4389),
    [anon_sym_if] = ACTIONS(4389),
    [anon_sym_switch] = ACTIONS(4389),
    [anon_sym_case] = ACTIONS(4389),
    [anon_sym_default] = ACTIONS(4389),
    [anon_sym_while] = ACTIONS(4389),
    [anon_sym_do] = ACTIONS(4389),
    [anon_sym_for] = ACTIONS(4389),
    [anon_sym_return] = ACTIONS(4389),
    [anon_sym_break] = ACTIONS(4389),
    [anon_sym_continue] = ACTIONS(4389),
    [anon_sym_goto] = ACTIONS(4389),
    [anon_sym_AMP] = ACTIONS(4387),
    [anon_sym_BANG] = ACTIONS(4387),
    [anon_sym_TILDE] = ACTIONS(4387),
    [anon_sym_PLUS] = ACTIONS(4389),
    [anon_sym_DASH] = ACTIONS(4389),
    [anon_sym_DASH_DASH] = ACTIONS(4387),
    [anon_sym_PLUS_PLUS] = ACTIONS(4387),
    [anon_sym_sizeof] = ACTIONS(4389),
    [sym_number_literal] = ACTIONS(4387),
    [sym_char_literal] = ACTIONS(4387),
    [sym_string_literal] = ACTIONS(4387),
    [sym_true] = ACTIONS(4389),
    [sym_false] = ACTIONS(4389),
    [sym_null] = ACTIONS(4389),
    [sym_identifier] = ACTIONS(4389),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(4389),
    [sym_auto] = ACTIONS(4389),
    [anon_sym_typename] = ACTIONS(4389),
    [anon_sym_new] = ACTIONS(4389),
    [anon_sym_COLON_COLON] = ACTIONS(4387),
    [anon_sym_delete] = ACTIONS(4389),
    [sym_nullptr] = ACTIONS(4389),
  },
  [1394] = {
    [sym_identifier] = ACTIONS(4391),
    [sym_comment] = ACTIONS(49),
  },
  [1395] = {
    [sym_identifier] = ACTIONS(4393),
    [sym_comment] = ACTIONS(49),
  },
  [1396] = {
    [sym_preproc_include] = STATE(1949),
    [sym_preproc_def] = STATE(1949),
    [sym_preproc_function_def] = STATE(1949),
    [sym_preproc_call] = STATE(1949),
    [sym_preproc_if_in_compound_statement] = STATE(1944),
    [sym_preproc_ifdef_in_compound_statement] = STATE(1945),
    [sym_declaration] = STATE(1949),
    [sym_type_definition] = STATE(1949),
    [sym__declaration_specifiers] = STATE(1946),
    [sym_compound_statement] = STATE(1949),
    [sym_storage_class_specifier] = STATE(419),
    [sym_type_qualifier] = STATE(419),
    [sym__type_specifier] = STATE(30),
    [sym_sized_type_specifier] = STATE(30),
    [sym_enum_specifier] = STATE(30),
    [sym_struct_specifier] = STATE(30),
    [sym_union_specifier] = STATE(30),
    [sym_labeled_statement] = STATE(1949),
    [sym_expression_statement] = STATE(1949),
    [sym_if_statement] = STATE(1949),
    [sym_switch_statement] = STATE(1949),
    [sym_case_statement] = STATE(1949),
    [sym_while_statement] = STATE(1949),
    [sym_do_statement] = STATE(1949),
    [sym_for_statement] = STATE(1949),
    [sym_return_statement] = STATE(1949),
    [sym_break_statement] = STATE(1949),
    [sym_continue_statement] = STATE(1949),
    [sym_goto_statement] = STATE(1949),
    [sym__expression] = STATE(1947),
    [sym_comma_expression] = STATE(1948),
    [sym_conditional_expression] = STATE(1947),
    [sym_assignment_expression] = STATE(1947),
    [sym_pointer_expression] = STATE(1947),
    [sym_logical_expression] = STATE(1947),
    [sym_bitwise_expression] = STATE(1947),
    [sym_equality_expression] = STATE(1947),
    [sym_relational_expression] = STATE(1947),
    [sym_shift_expression] = STATE(1947),
    [sym_math_expression] = STATE(1947),
    [sym_cast_expression] = STATE(1947),
    [sym_sizeof_expression] = STATE(1947),
    [sym_subscript_expression] = STATE(1947),
    [sym_call_expression] = STATE(1947),
    [sym_field_expression] = STATE(1947),
    [sym_compound_literal_expression] = STATE(1947),
    [sym_parenthesized_expression] = STATE(1947),
    [sym_concatenated_string] = STATE(1947),
    [sym__empty_declaration] = STATE(1949),
    [sym_macro_type_specifier] = STATE(30),
    [sym_class_specifier] = STATE(30),
    [sym_dependent_type] = STATE(30),
    [sym_structured_binding_declaration] = STATE(1949),
    [sym_template_type] = STATE(415),
    [sym_template_function] = STATE(1947),
    [sym_for_range_loop] = STATE(1949),
    [sym_new_expression] = STATE(1947),
    [sym_delete_expression] = STATE(1947),
    [sym_lambda_expression] = STATE(1947),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(416),
    [sym_scoped_namespace_identifier] = STATE(417),
    [aux_sym_preproc_if_in_compound_statement_repeat1] = STATE(1949),
    [aux_sym__declaration_specifiers_repeat1] = STATE(419),
    [aux_sym_sized_type_specifier_repeat1] = STATE(38),
    [sym_raw_string_literal] = ACTIONS(4395),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(4397),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(4399),
    [anon_sym_LPAREN] = ACTIONS(626),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(4401),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(4403),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(4405),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(4407),
    [sym_preproc_directive] = ACTIONS(4409),
    [anon_sym_SEMI] = ACTIONS(4411),
    [anon_sym_typedef] = ACTIONS(4413),
    [anon_sym_extern] = ACTIONS(154),
    [anon_sym_LBRACE] = ACTIONS(4415),
    [anon_sym_STAR] = ACTIONS(644),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_static] = ACTIONS(154),
    [anon_sym_register] = ACTIONS(154),
    [anon_sym_inline] = ACTIONS(154),
    [anon_sym_const] = ACTIONS(158),
    [anon_sym_restrict] = ACTIONS(158),
    [anon_sym_volatile] = ACTIONS(158),
    [anon_sym__Atomic] = ACTIONS(158),
    [anon_sym_mutable] = ACTIONS(158),
    [anon_sym_explicit] = ACTIONS(158),
    [anon_sym_constexpr] = ACTIONS(158),
    [anon_sym_unsigned] = ACTIONS(31),
    [anon_sym_long] = ACTIONS(31),
    [anon_sym_short] = ACTIONS(31),
    [sym_primitive_type] = ACTIONS(33),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_union] = ACTIONS(39),
    [anon_sym_if] = ACTIONS(4417),
    [anon_sym_switch] = ACTIONS(4419),
    [anon_sym_case] = ACTIONS(4421),
    [anon_sym_default] = ACTIONS(4423),
    [anon_sym_while] = ACTIONS(4425),
    [anon_sym_do] = ACTIONS(4427),
    [anon_sym_for] = ACTIONS(4429),
    [anon_sym_return] = ACTIONS(4431),
    [anon_sym_break] = ACTIONS(4433),
    [anon_sym_continue] = ACTIONS(4435),
    [anon_sym_goto] = ACTIONS(4437),
    [anon_sym_AMP] = ACTIONS(644),
    [anon_sym_BANG] = ACTIONS(668),
    [anon_sym_TILDE] = ACTIONS(670),
    [anon_sym_PLUS] = ACTIONS(672),
    [anon_sym_DASH] = ACTIONS(672),
    [anon_sym_DASH_DASH] = ACTIONS(674),
    [anon_sym_PLUS_PLUS] = ACTIONS(674),
    [anon_sym_sizeof] = ACTIONS(676),
    [sym_number_literal] = ACTIONS(4395),
    [sym_char_literal] = ACTIONS(4395),
    [sym_string_literal] = ACTIONS(678),
    [sym_true] = ACTIONS(4439),
    [sym_false] = ACTIONS(4439),
    [sym_null] = ACTIONS(4439),
    [sym_identifier] = ACTIONS(4441),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(51),
    [sym_auto] = ACTIONS(33),
    [anon_sym_typename] = ACTIONS(53),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(684),
    [anon_sym_delete] = ACTIONS(686),
    [sym_nullptr] = ACTIONS(4439),
  },
  [1397] = {
    [sym_preproc_arg] = ACTIONS(4443),
    [sym_comment] = ACTIONS(83),
  },
  [1398] = {
    [aux_sym_SLASH_LBRACK_BSLASHt_RBRACK_PLUS_SLASH] = ACTIONS(4445),
    [anon_sym_LF] = ACTIONS(4447),
    [sym_comment] = ACTIONS(83),
  },
  [1399] = {
    [sym_raw_string_literal] = ACTIONS(1614),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1616),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1616),
    [anon_sym_LPAREN] = ACTIONS(1614),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1616),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(1616),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1616),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1616),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(1616),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(1616),
    [sym_preproc_directive] = ACTIONS(1616),
    [anon_sym_SEMI] = ACTIONS(1614),
    [anon_sym_typedef] = ACTIONS(1616),
    [anon_sym_extern] = ACTIONS(1616),
    [anon_sym_LBRACE] = ACTIONS(1614),
    [anon_sym_STAR] = ACTIONS(1614),
    [anon_sym_LBRACK] = ACTIONS(1614),
    [anon_sym_static] = ACTIONS(1616),
    [anon_sym_register] = ACTIONS(1616),
    [anon_sym_inline] = ACTIONS(1616),
    [anon_sym_const] = ACTIONS(1616),
    [anon_sym_restrict] = ACTIONS(1616),
    [anon_sym_volatile] = ACTIONS(1616),
    [anon_sym__Atomic] = ACTIONS(1616),
    [anon_sym_mutable] = ACTIONS(1616),
    [anon_sym_explicit] = ACTIONS(1616),
    [anon_sym_constexpr] = ACTIONS(1616),
    [anon_sym_unsigned] = ACTIONS(1616),
    [anon_sym_long] = ACTIONS(1616),
    [anon_sym_short] = ACTIONS(1616),
    [sym_primitive_type] = ACTIONS(1616),
    [anon_sym_enum] = ACTIONS(1616),
    [anon_sym_struct] = ACTIONS(1616),
    [anon_sym_union] = ACTIONS(1616),
    [anon_sym_if] = ACTIONS(1616),
    [anon_sym_switch] = ACTIONS(1616),
    [anon_sym_case] = ACTIONS(1616),
    [anon_sym_default] = ACTIONS(1616),
    [anon_sym_while] = ACTIONS(1616),
    [anon_sym_do] = ACTIONS(1616),
    [anon_sym_for] = ACTIONS(1616),
    [anon_sym_return] = ACTIONS(1616),
    [anon_sym_break] = ACTIONS(1616),
    [anon_sym_continue] = ACTIONS(1616),
    [anon_sym_goto] = ACTIONS(1616),
    [anon_sym_AMP] = ACTIONS(1614),
    [anon_sym_BANG] = ACTIONS(1614),
    [anon_sym_TILDE] = ACTIONS(1614),
    [anon_sym_PLUS] = ACTIONS(1616),
    [anon_sym_DASH] = ACTIONS(1616),
    [anon_sym_DASH_DASH] = ACTIONS(1614),
    [anon_sym_PLUS_PLUS] = ACTIONS(1614),
    [anon_sym_sizeof] = ACTIONS(1616),
    [sym_number_literal] = ACTIONS(1614),
    [sym_char_literal] = ACTIONS(1614),
    [sym_string_literal] = ACTIONS(1614),
    [sym_true] = ACTIONS(1616),
    [sym_false] = ACTIONS(1616),
    [sym_null] = ACTIONS(1616),
    [sym_identifier] = ACTIONS(1616),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(1616),
    [sym_auto] = ACTIONS(1616),
    [anon_sym_typename] = ACTIONS(1616),
    [anon_sym_new] = ACTIONS(1616),
    [anon_sym_COLON_COLON] = ACTIONS(1614),
    [anon_sym_delete] = ACTIONS(1616),
    [sym_nullptr] = ACTIONS(1616),
  },
  [1400] = {
    [sym_type_qualifier] = STATE(1954),
    [sym__type_specifier] = STATE(1953),
    [sym_sized_type_specifier] = STATE(1953),
    [sym_enum_specifier] = STATE(1953),
    [sym_struct_specifier] = STATE(1953),
    [sym_union_specifier] = STATE(1953),
    [sym_macro_type_specifier] = STATE(1953),
    [sym_class_specifier] = STATE(1953),
    [sym_dependent_type] = STATE(1953),
    [sym_template_type] = STATE(62),
    [sym_scoped_type_identifier] = STATE(63),
    [sym_scoped_namespace_identifier] = STATE(64),
    [aux_sym_type_definition_repeat1] = STATE(1954),
    [aux_sym_sized_type_specifier_repeat1] = STATE(66),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_restrict] = ACTIONS(93),
    [anon_sym_volatile] = ACTIONS(93),
    [anon_sym__Atomic] = ACTIONS(93),
    [anon_sym_mutable] = ACTIONS(93),
    [anon_sym_explicit] = ACTIONS(93),
    [anon_sym_constexpr] = ACTIONS(93),
    [anon_sym_unsigned] = ACTIONS(95),
    [anon_sym_long] = ACTIONS(95),
    [anon_sym_short] = ACTIONS(95),
    [sym_primitive_type] = ACTIONS(4449),
    [anon_sym_enum] = ACTIONS(99),
    [anon_sym_struct] = ACTIONS(101),
    [anon_sym_union] = ACTIONS(103),
    [sym_identifier] = ACTIONS(105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(107),
    [sym_auto] = ACTIONS(4449),
    [anon_sym_typename] = ACTIONS(109),
    [anon_sym_COLON_COLON] = ACTIONS(111),
  },
  [1401] = {
    [sym_preproc_include] = STATE(1956),
    [sym_preproc_def] = STATE(1956),
    [sym_preproc_function_def] = STATE(1956),
    [sym_preproc_call] = STATE(1956),
    [sym_preproc_if_in_compound_statement] = STATE(410),
    [sym_preproc_ifdef_in_compound_statement] = STATE(411),
    [sym_declaration] = STATE(1956),
    [sym_type_definition] = STATE(1956),
    [sym__declaration_specifiers] = STATE(412),
    [sym_compound_statement] = STATE(1956),
    [sym_storage_class_specifier] = STATE(419),
    [sym_type_qualifier] = STATE(419),
    [sym__type_specifier] = STATE(30),
    [sym_sized_type_specifier] = STATE(30),
    [sym_enum_specifier] = STATE(30),
    [sym_struct_specifier] = STATE(30),
    [sym_union_specifier] = STATE(30),
    [sym_labeled_statement] = STATE(1956),
    [sym_expression_statement] = STATE(1956),
    [sym_if_statement] = STATE(1956),
    [sym_switch_statement] = STATE(1956),
    [sym_case_statement] = STATE(1956),
    [sym_while_statement] = STATE(1956),
    [sym_do_statement] = STATE(1956),
    [sym_for_statement] = STATE(1956),
    [sym_return_statement] = STATE(1956),
    [sym_break_statement] = STATE(1956),
    [sym_continue_statement] = STATE(1956),
    [sym_goto_statement] = STATE(1956),
    [sym__expression] = STATE(413),
    [sym_comma_expression] = STATE(414),
    [sym_conditional_expression] = STATE(413),
    [sym_assignment_expression] = STATE(413),
    [sym_pointer_expression] = STATE(413),
    [sym_logical_expression] = STATE(413),
    [sym_bitwise_expression] = STATE(413),
    [sym_equality_expression] = STATE(413),
    [sym_relational_expression] = STATE(413),
    [sym_shift_expression] = STATE(413),
    [sym_math_expression] = STATE(413),
    [sym_cast_expression] = STATE(413),
    [sym_sizeof_expression] = STATE(413),
    [sym_subscript_expression] = STATE(413),
    [sym_call_expression] = STATE(413),
    [sym_field_expression] = STATE(413),
    [sym_compound_literal_expression] = STATE(413),
    [sym_parenthesized_expression] = STATE(413),
    [sym_concatenated_string] = STATE(413),
    [sym__empty_declaration] = STATE(1956),
    [sym_macro_type_specifier] = STATE(30),
    [sym_class_specifier] = STATE(30),
    [sym_dependent_type] = STATE(30),
    [sym_structured_binding_declaration] = STATE(1956),
    [sym_template_type] = STATE(415),
    [sym_template_function] = STATE(413),
    [sym_for_range_loop] = STATE(1956),
    [sym_new_expression] = STATE(413),
    [sym_delete_expression] = STATE(413),
    [sym_lambda_expression] = STATE(413),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(416),
    [sym_scoped_namespace_identifier] = STATE(417),
    [aux_sym_preproc_if_in_compound_statement_repeat1] = STATE(1956),
    [aux_sym__declaration_specifiers_repeat1] = STATE(419),
    [aux_sym_sized_type_specifier_repeat1] = STATE(38),
    [sym_raw_string_literal] = ACTIONS(620),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(622),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(624),
    [anon_sym_LPAREN] = ACTIONS(626),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(628),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(630),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(632),
    [sym_preproc_directive] = ACTIONS(634),
    [anon_sym_SEMI] = ACTIONS(636),
    [anon_sym_typedef] = ACTIONS(638),
    [anon_sym_extern] = ACTIONS(154),
    [anon_sym_LBRACE] = ACTIONS(640),
    [anon_sym_RBRACE] = ACTIONS(4451),
    [anon_sym_STAR] = ACTIONS(644),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_static] = ACTIONS(154),
    [anon_sym_register] = ACTIONS(154),
    [anon_sym_inline] = ACTIONS(154),
    [anon_sym_const] = ACTIONS(158),
    [anon_sym_restrict] = ACTIONS(158),
    [anon_sym_volatile] = ACTIONS(158),
    [anon_sym__Atomic] = ACTIONS(158),
    [anon_sym_mutable] = ACTIONS(158),
    [anon_sym_explicit] = ACTIONS(158),
    [anon_sym_constexpr] = ACTIONS(158),
    [anon_sym_unsigned] = ACTIONS(31),
    [anon_sym_long] = ACTIONS(31),
    [anon_sym_short] = ACTIONS(31),
    [sym_primitive_type] = ACTIONS(33),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_union] = ACTIONS(39),
    [anon_sym_if] = ACTIONS(646),
    [anon_sym_switch] = ACTIONS(648),
    [anon_sym_case] = ACTIONS(650),
    [anon_sym_default] = ACTIONS(652),
    [anon_sym_while] = ACTIONS(654),
    [anon_sym_do] = ACTIONS(656),
    [anon_sym_for] = ACTIONS(658),
    [anon_sym_return] = ACTIONS(660),
    [anon_sym_break] = ACTIONS(662),
    [anon_sym_continue] = ACTIONS(664),
    [anon_sym_goto] = ACTIONS(666),
    [anon_sym_AMP] = ACTIONS(644),
    [anon_sym_BANG] = ACTIONS(668),
    [anon_sym_TILDE] = ACTIONS(670),
    [anon_sym_PLUS] = ACTIONS(672),
    [anon_sym_DASH] = ACTIONS(672),
    [anon_sym_DASH_DASH] = ACTIONS(674),
    [anon_sym_PLUS_PLUS] = ACTIONS(674),
    [anon_sym_sizeof] = ACTIONS(676),
    [sym_number_literal] = ACTIONS(620),
    [sym_char_literal] = ACTIONS(620),
    [sym_string_literal] = ACTIONS(678),
    [sym_true] = ACTIONS(680),
    [sym_false] = ACTIONS(680),
    [sym_null] = ACTIONS(680),
    [sym_identifier] = ACTIONS(682),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(51),
    [sym_auto] = ACTIONS(33),
    [anon_sym_typename] = ACTIONS(53),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(684),
    [anon_sym_delete] = ACTIONS(686),
    [sym_nullptr] = ACTIONS(680),
  },
  [1402] = {
    [anon_sym_LPAREN] = ACTIONS(4453),
    [anon_sym_constexpr] = ACTIONS(4455),
    [sym_comment] = ACTIONS(49),
  },
  [1403] = {
    [anon_sym_LPAREN] = ACTIONS(4457),
    [sym_comment] = ACTIONS(49),
  },
  [1404] = {
    [sym__expression] = STATE(1960),
    [sym_conditional_expression] = STATE(1960),
    [sym_assignment_expression] = STATE(1960),
    [sym_pointer_expression] = STATE(1960),
    [sym_logical_expression] = STATE(1960),
    [sym_bitwise_expression] = STATE(1960),
    [sym_equality_expression] = STATE(1960),
    [sym_relational_expression] = STATE(1960),
    [sym_shift_expression] = STATE(1960),
    [sym_math_expression] = STATE(1960),
    [sym_cast_expression] = STATE(1960),
    [sym_sizeof_expression] = STATE(1960),
    [sym_subscript_expression] = STATE(1960),
    [sym_call_expression] = STATE(1960),
    [sym_field_expression] = STATE(1960),
    [sym_compound_literal_expression] = STATE(1960),
    [sym_parenthesized_expression] = STATE(1960),
    [sym_concatenated_string] = STATE(1960),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(1960),
    [sym_new_expression] = STATE(1960),
    [sym_delete_expression] = STATE(1960),
    [sym_lambda_expression] = STATE(1960),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(855),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(4459),
    [anon_sym_LPAREN] = ACTIONS(1634),
    [anon_sym_STAR] = ACTIONS(1636),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_AMP] = ACTIONS(1636),
    [anon_sym_BANG] = ACTIONS(1638),
    [anon_sym_TILDE] = ACTIONS(1640),
    [anon_sym_PLUS] = ACTIONS(1642),
    [anon_sym_DASH] = ACTIONS(1642),
    [anon_sym_DASH_DASH] = ACTIONS(1644),
    [anon_sym_PLUS_PLUS] = ACTIONS(1644),
    [anon_sym_sizeof] = ACTIONS(1646),
    [sym_number_literal] = ACTIONS(4459),
    [sym_char_literal] = ACTIONS(4459),
    [sym_string_literal] = ACTIONS(1648),
    [sym_true] = ACTIONS(4461),
    [sym_false] = ACTIONS(4461),
    [sym_null] = ACTIONS(4461),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1652),
    [anon_sym_delete] = ACTIONS(1654),
    [sym_nullptr] = ACTIONS(4461),
  },
  [1405] = {
    [anon_sym_COLON] = ACTIONS(4463),
    [sym_comment] = ACTIONS(49),
  },
  [1406] = {
    [anon_sym_LPAREN] = ACTIONS(4465),
    [sym_comment] = ACTIONS(49),
  },
  [1407] = {
    [sym_compound_statement] = STATE(1963),
    [sym_labeled_statement] = STATE(1963),
    [sym_expression_statement] = STATE(1963),
    [sym_if_statement] = STATE(1963),
    [sym_switch_statement] = STATE(1963),
    [sym_case_statement] = STATE(1963),
    [sym_while_statement] = STATE(1963),
    [sym_do_statement] = STATE(1963),
    [sym_for_statement] = STATE(1963),
    [sym_return_statement] = STATE(1963),
    [sym_break_statement] = STATE(1963),
    [sym_continue_statement] = STATE(1963),
    [sym_goto_statement] = STATE(1963),
    [sym__expression] = STATE(873),
    [sym_comma_expression] = STATE(874),
    [sym_conditional_expression] = STATE(873),
    [sym_assignment_expression] = STATE(873),
    [sym_pointer_expression] = STATE(873),
    [sym_logical_expression] = STATE(873),
    [sym_bitwise_expression] = STATE(873),
    [sym_equality_expression] = STATE(873),
    [sym_relational_expression] = STATE(873),
    [sym_shift_expression] = STATE(873),
    [sym_math_expression] = STATE(873),
    [sym_cast_expression] = STATE(873),
    [sym_sizeof_expression] = STATE(873),
    [sym_subscript_expression] = STATE(873),
    [sym_call_expression] = STATE(873),
    [sym_field_expression] = STATE(873),
    [sym_compound_literal_expression] = STATE(873),
    [sym_parenthesized_expression] = STATE(873),
    [sym_concatenated_string] = STATE(873),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(873),
    [sym_for_range_loop] = STATE(1963),
    [sym_new_expression] = STATE(873),
    [sym_delete_expression] = STATE(873),
    [sym_lambda_expression] = STATE(873),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(1660),
    [anon_sym_LPAREN] = ACTIONS(626),
    [anon_sym_SEMI] = ACTIONS(1662),
    [anon_sym_LBRACE] = ACTIONS(1664),
    [anon_sym_STAR] = ACTIONS(644),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_if] = ACTIONS(1666),
    [anon_sym_switch] = ACTIONS(1668),
    [anon_sym_case] = ACTIONS(1670),
    [anon_sym_default] = ACTIONS(1672),
    [anon_sym_while] = ACTIONS(1674),
    [anon_sym_do] = ACTIONS(1676),
    [anon_sym_for] = ACTIONS(1678),
    [anon_sym_return] = ACTIONS(1680),
    [anon_sym_break] = ACTIONS(1682),
    [anon_sym_continue] = ACTIONS(1684),
    [anon_sym_goto] = ACTIONS(1686),
    [anon_sym_AMP] = ACTIONS(644),
    [anon_sym_BANG] = ACTIONS(668),
    [anon_sym_TILDE] = ACTIONS(670),
    [anon_sym_PLUS] = ACTIONS(672),
    [anon_sym_DASH] = ACTIONS(672),
    [anon_sym_DASH_DASH] = ACTIONS(674),
    [anon_sym_PLUS_PLUS] = ACTIONS(674),
    [anon_sym_sizeof] = ACTIONS(676),
    [sym_number_literal] = ACTIONS(1660),
    [sym_char_literal] = ACTIONS(1660),
    [sym_string_literal] = ACTIONS(678),
    [sym_true] = ACTIONS(1688),
    [sym_false] = ACTIONS(1688),
    [sym_null] = ACTIONS(1688),
    [sym_identifier] = ACTIONS(1690),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1303),
    [anon_sym_delete] = ACTIONS(686),
    [sym_nullptr] = ACTIONS(1688),
  },
  [1408] = {
    [anon_sym_LPAREN] = ACTIONS(4467),
    [sym_comment] = ACTIONS(49),
  },
  [1409] = {
    [sym__expression] = STATE(1966),
    [sym_conditional_expression] = STATE(1966),
    [sym_assignment_expression] = STATE(1966),
    [sym_pointer_expression] = STATE(1966),
    [sym_logical_expression] = STATE(1966),
    [sym_bitwise_expression] = STATE(1966),
    [sym_equality_expression] = STATE(1966),
    [sym_relational_expression] = STATE(1966),
    [sym_shift_expression] = STATE(1966),
    [sym_math_expression] = STATE(1966),
    [sym_cast_expression] = STATE(1966),
    [sym_sizeof_expression] = STATE(1966),
    [sym_subscript_expression] = STATE(1966),
    [sym_call_expression] = STATE(1966),
    [sym_field_expression] = STATE(1966),
    [sym_compound_literal_expression] = STATE(1966),
    [sym_parenthesized_expression] = STATE(1966),
    [sym_initializer_list] = STATE(1967),
    [sym_concatenated_string] = STATE(1966),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(1966),
    [sym_new_expression] = STATE(1966),
    [sym_delete_expression] = STATE(1966),
    [sym_lambda_expression] = STATE(1966),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(4469),
    [anon_sym_LPAREN] = ACTIONS(1347),
    [anon_sym_SEMI] = ACTIONS(4471),
    [anon_sym_LBRACE] = ACTIONS(548),
    [anon_sym_STAR] = ACTIONS(1349),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_AMP] = ACTIONS(1349),
    [anon_sym_BANG] = ACTIONS(1351),
    [anon_sym_TILDE] = ACTIONS(1353),
    [anon_sym_PLUS] = ACTIONS(1355),
    [anon_sym_DASH] = ACTIONS(1355),
    [anon_sym_DASH_DASH] = ACTIONS(1357),
    [anon_sym_PLUS_PLUS] = ACTIONS(1357),
    [anon_sym_sizeof] = ACTIONS(1359),
    [sym_number_literal] = ACTIONS(4469),
    [sym_char_literal] = ACTIONS(4469),
    [sym_string_literal] = ACTIONS(1361),
    [sym_true] = ACTIONS(4473),
    [sym_false] = ACTIONS(4473),
    [sym_null] = ACTIONS(4473),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1365),
    [anon_sym_delete] = ACTIONS(1367),
    [sym_nullptr] = ACTIONS(4473),
  },
  [1410] = {
    [anon_sym_SEMI] = ACTIONS(4475),
    [sym_comment] = ACTIONS(49),
  },
  [1411] = {
    [anon_sym_SEMI] = ACTIONS(4477),
    [sym_comment] = ACTIONS(49),
  },
  [1412] = {
    [sym_identifier] = ACTIONS(4479),
    [sym_comment] = ACTIONS(49),
  },
  [1413] = {
    [sym_initializer_list] = STATE(765),
    [sym_template_argument_list] = STATE(887),
    [anon_sym_LPAREN] = ACTIONS(1483),
    [anon_sym_COMMA] = ACTIONS(1477),
    [anon_sym_SEMI] = ACTIONS(1483),
    [anon_sym_extern] = ACTIONS(144),
    [anon_sym_LBRACE] = ACTIONS(548),
    [anon_sym_STAR] = ACTIONS(1486),
    [anon_sym_LBRACK] = ACTIONS(1483),
    [anon_sym_EQ] = ACTIONS(1479),
    [anon_sym_static] = ACTIONS(144),
    [anon_sym_register] = ACTIONS(144),
    [anon_sym_inline] = ACTIONS(144),
    [anon_sym_const] = ACTIONS(144),
    [anon_sym_restrict] = ACTIONS(144),
    [anon_sym_volatile] = ACTIONS(144),
    [anon_sym__Atomic] = ACTIONS(144),
    [anon_sym_mutable] = ACTIONS(144),
    [anon_sym_explicit] = ACTIONS(144),
    [anon_sym_constexpr] = ACTIONS(144),
    [anon_sym_COLON] = ACTIONS(4481),
    [anon_sym_QMARK] = ACTIONS(1477),
    [anon_sym_STAR_EQ] = ACTIONS(1477),
    [anon_sym_SLASH_EQ] = ACTIONS(1477),
    [anon_sym_PERCENT_EQ] = ACTIONS(1477),
    [anon_sym_PLUS_EQ] = ACTIONS(1477),
    [anon_sym_DASH_EQ] = ACTIONS(1477),
    [anon_sym_LT_LT_EQ] = ACTIONS(1477),
    [anon_sym_GT_GT_EQ] = ACTIONS(1477),
    [anon_sym_AMP_EQ] = ACTIONS(1477),
    [anon_sym_CARET_EQ] = ACTIONS(1477),
    [anon_sym_PIPE_EQ] = ACTIONS(1477),
    [anon_sym_AMP] = ACTIONS(1486),
    [anon_sym_PIPE_PIPE] = ACTIONS(1477),
    [anon_sym_AMP_AMP] = ACTIONS(1483),
    [anon_sym_PIPE] = ACTIONS(1479),
    [anon_sym_CARET] = ACTIONS(1479),
    [anon_sym_TILDE] = ACTIONS(142),
    [anon_sym_EQ_EQ] = ACTIONS(1477),
    [anon_sym_BANG_EQ] = ACTIONS(1477),
    [anon_sym_LT] = ACTIONS(1564),
    [anon_sym_GT] = ACTIONS(1479),
    [anon_sym_LT_EQ] = ACTIONS(1477),
    [anon_sym_GT_EQ] = ACTIONS(1477),
    [anon_sym_LT_LT] = ACTIONS(1479),
    [anon_sym_GT_GT] = ACTIONS(1479),
    [anon_sym_PLUS] = ACTIONS(1479),
    [anon_sym_DASH] = ACTIONS(1479),
    [anon_sym_SLASH] = ACTIONS(1479),
    [anon_sym_PERCENT] = ACTIONS(1479),
    [anon_sym_DASH_DASH] = ACTIONS(1477),
    [anon_sym_PLUS_PLUS] = ACTIONS(1477),
    [anon_sym_DOT] = ACTIONS(1477),
    [anon_sym_DASH_GT] = ACTIONS(1477),
    [sym_identifier] = ACTIONS(144),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(1716),
    [sym_operator_name] = ACTIONS(142),
  },
  [1414] = {
    [sym_raw_string_literal] = ACTIONS(1728),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1730),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1730),
    [anon_sym_LPAREN] = ACTIONS(1728),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1730),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(1730),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1730),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1730),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(1730),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(1730),
    [sym_preproc_directive] = ACTIONS(1730),
    [anon_sym_SEMI] = ACTIONS(1728),
    [anon_sym_typedef] = ACTIONS(1730),
    [anon_sym_extern] = ACTIONS(1730),
    [anon_sym_LBRACE] = ACTIONS(1728),
    [anon_sym_STAR] = ACTIONS(1728),
    [anon_sym_LBRACK] = ACTIONS(1728),
    [anon_sym_static] = ACTIONS(1730),
    [anon_sym_register] = ACTIONS(1730),
    [anon_sym_inline] = ACTIONS(1730),
    [anon_sym_const] = ACTIONS(1730),
    [anon_sym_restrict] = ACTIONS(1730),
    [anon_sym_volatile] = ACTIONS(1730),
    [anon_sym__Atomic] = ACTIONS(1730),
    [anon_sym_mutable] = ACTIONS(1730),
    [anon_sym_explicit] = ACTIONS(1730),
    [anon_sym_constexpr] = ACTIONS(1730),
    [anon_sym_unsigned] = ACTIONS(1730),
    [anon_sym_long] = ACTIONS(1730),
    [anon_sym_short] = ACTIONS(1730),
    [sym_primitive_type] = ACTIONS(1730),
    [anon_sym_enum] = ACTIONS(1730),
    [anon_sym_struct] = ACTIONS(1730),
    [anon_sym_union] = ACTIONS(1730),
    [anon_sym_if] = ACTIONS(1730),
    [anon_sym_switch] = ACTIONS(1730),
    [anon_sym_case] = ACTIONS(1730),
    [anon_sym_default] = ACTIONS(1730),
    [anon_sym_while] = ACTIONS(1730),
    [anon_sym_do] = ACTIONS(1730),
    [anon_sym_for] = ACTIONS(1730),
    [anon_sym_return] = ACTIONS(1730),
    [anon_sym_break] = ACTIONS(1730),
    [anon_sym_continue] = ACTIONS(1730),
    [anon_sym_goto] = ACTIONS(1730),
    [anon_sym_AMP] = ACTIONS(1728),
    [anon_sym_BANG] = ACTIONS(1728),
    [anon_sym_TILDE] = ACTIONS(1728),
    [anon_sym_PLUS] = ACTIONS(1730),
    [anon_sym_DASH] = ACTIONS(1730),
    [anon_sym_DASH_DASH] = ACTIONS(1728),
    [anon_sym_PLUS_PLUS] = ACTIONS(1728),
    [anon_sym_sizeof] = ACTIONS(1730),
    [sym_number_literal] = ACTIONS(1728),
    [sym_char_literal] = ACTIONS(1728),
    [sym_string_literal] = ACTIONS(1728),
    [sym_true] = ACTIONS(1730),
    [sym_false] = ACTIONS(1730),
    [sym_null] = ACTIONS(1730),
    [sym_identifier] = ACTIONS(1730),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(1730),
    [sym_auto] = ACTIONS(1730),
    [anon_sym_typename] = ACTIONS(1730),
    [anon_sym_new] = ACTIONS(1730),
    [anon_sym_COLON_COLON] = ACTIONS(1728),
    [anon_sym_delete] = ACTIONS(1730),
    [sym_nullptr] = ACTIONS(1730),
  },
  [1415] = {
    [sym_raw_string_literal] = ACTIONS(1732),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1734),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1734),
    [anon_sym_LPAREN] = ACTIONS(1732),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1734),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(1734),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1734),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1734),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(1734),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(1734),
    [sym_preproc_directive] = ACTIONS(1734),
    [anon_sym_SEMI] = ACTIONS(1732),
    [anon_sym_typedef] = ACTIONS(1734),
    [anon_sym_extern] = ACTIONS(1734),
    [anon_sym_LBRACE] = ACTIONS(1732),
    [anon_sym_STAR] = ACTIONS(1732),
    [anon_sym_LBRACK] = ACTIONS(1732),
    [anon_sym_static] = ACTIONS(1734),
    [anon_sym_register] = ACTIONS(1734),
    [anon_sym_inline] = ACTIONS(1734),
    [anon_sym_const] = ACTIONS(1734),
    [anon_sym_restrict] = ACTIONS(1734),
    [anon_sym_volatile] = ACTIONS(1734),
    [anon_sym__Atomic] = ACTIONS(1734),
    [anon_sym_mutable] = ACTIONS(1734),
    [anon_sym_explicit] = ACTIONS(1734),
    [anon_sym_constexpr] = ACTIONS(1734),
    [anon_sym_unsigned] = ACTIONS(1734),
    [anon_sym_long] = ACTIONS(1734),
    [anon_sym_short] = ACTIONS(1734),
    [sym_primitive_type] = ACTIONS(1734),
    [anon_sym_enum] = ACTIONS(1734),
    [anon_sym_struct] = ACTIONS(1734),
    [anon_sym_union] = ACTIONS(1734),
    [anon_sym_if] = ACTIONS(1734),
    [anon_sym_switch] = ACTIONS(1734),
    [anon_sym_case] = ACTIONS(1734),
    [anon_sym_default] = ACTIONS(1734),
    [anon_sym_while] = ACTIONS(1734),
    [anon_sym_do] = ACTIONS(1734),
    [anon_sym_for] = ACTIONS(1734),
    [anon_sym_return] = ACTIONS(1734),
    [anon_sym_break] = ACTIONS(1734),
    [anon_sym_continue] = ACTIONS(1734),
    [anon_sym_goto] = ACTIONS(1734),
    [anon_sym_AMP] = ACTIONS(1732),
    [anon_sym_BANG] = ACTIONS(1732),
    [anon_sym_TILDE] = ACTIONS(1732),
    [anon_sym_PLUS] = ACTIONS(1734),
    [anon_sym_DASH] = ACTIONS(1734),
    [anon_sym_DASH_DASH] = ACTIONS(1732),
    [anon_sym_PLUS_PLUS] = ACTIONS(1732),
    [anon_sym_sizeof] = ACTIONS(1734),
    [sym_number_literal] = ACTIONS(1732),
    [sym_char_literal] = ACTIONS(1732),
    [sym_string_literal] = ACTIONS(1732),
    [sym_true] = ACTIONS(1734),
    [sym_false] = ACTIONS(1734),
    [sym_null] = ACTIONS(1734),
    [sym_identifier] = ACTIONS(1734),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(1734),
    [sym_auto] = ACTIONS(1734),
    [anon_sym_typename] = ACTIONS(1734),
    [anon_sym_new] = ACTIONS(1734),
    [anon_sym_COLON_COLON] = ACTIONS(1732),
    [anon_sym_delete] = ACTIONS(1734),
    [sym_nullptr] = ACTIONS(1734),
  },
  [1416] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(4483),
    [sym_comment] = ACTIONS(49),
  },
  [1417] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(4485),
    [sym_comment] = ACTIONS(49),
  },
  [1418] = {
    [sym__declarator] = STATE(1975),
    [sym_pointer_declarator] = STATE(1975),
    [sym_function_declarator] = STATE(1975),
    [sym_array_declarator] = STATE(1975),
    [sym_init_declarator] = STATE(1976),
    [sym_reference_declarator] = STATE(1975),
    [sym_structured_binding_reference_declarator] = STATE(1977),
    [sym_structured_binding_declarator] = STATE(1978),
    [sym_template_type] = STATE(46),
    [sym_template_function] = STATE(1975),
    [sym_destructor_name] = STATE(1975),
    [sym_scoped_identifier] = STATE(33),
    [sym_scoped_type_identifier] = STATE(47),
    [sym_scoped_namespace_identifier] = STATE(46),
    [anon_sym_LPAREN] = ACTIONS(11),
    [anon_sym_SEMI] = ACTIONS(4487),
    [anon_sym_STAR] = ACTIONS(196),
    [anon_sym_LBRACK] = ACTIONS(198),
    [anon_sym_AMP] = ACTIONS(200),
    [anon_sym_AMP_AMP] = ACTIONS(202),
    [anon_sym_TILDE] = ACTIONS(45),
    [sym_identifier] = ACTIONS(75),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(77),
    [sym_operator_name] = ACTIONS(4489),
  },
  [1419] = {
    [sym_argument_list] = STATE(802),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_COMMA] = ACTIONS(1740),
    [anon_sym_SEMI] = ACTIONS(4491),
    [anon_sym_STAR] = ACTIONS(1744),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_EQ] = ACTIONS(1746),
    [anon_sym_QMARK] = ACTIONS(1748),
    [anon_sym_STAR_EQ] = ACTIONS(1750),
    [anon_sym_SLASH_EQ] = ACTIONS(1750),
    [anon_sym_PERCENT_EQ] = ACTIONS(1750),
    [anon_sym_PLUS_EQ] = ACTIONS(1750),
    [anon_sym_DASH_EQ] = ACTIONS(1750),
    [anon_sym_LT_LT_EQ] = ACTIONS(1750),
    [anon_sym_GT_GT_EQ] = ACTIONS(1750),
    [anon_sym_AMP_EQ] = ACTIONS(1750),
    [anon_sym_CARET_EQ] = ACTIONS(1750),
    [anon_sym_PIPE_EQ] = ACTIONS(1750),
    [anon_sym_AMP] = ACTIONS(1752),
    [anon_sym_PIPE_PIPE] = ACTIONS(1754),
    [anon_sym_AMP_AMP] = ACTIONS(1756),
    [anon_sym_PIPE] = ACTIONS(1758),
    [anon_sym_CARET] = ACTIONS(1760),
    [anon_sym_EQ_EQ] = ACTIONS(1762),
    [anon_sym_BANG_EQ] = ACTIONS(1762),
    [anon_sym_LT] = ACTIONS(1764),
    [anon_sym_GT] = ACTIONS(1764),
    [anon_sym_LT_EQ] = ACTIONS(1766),
    [anon_sym_GT_EQ] = ACTIONS(1766),
    [anon_sym_LT_LT] = ACTIONS(1768),
    [anon_sym_GT_GT] = ACTIONS(1768),
    [anon_sym_PLUS] = ACTIONS(1770),
    [anon_sym_DASH] = ACTIONS(1770),
    [anon_sym_SLASH] = ACTIONS(1744),
    [anon_sym_PERCENT] = ACTIONS(1744),
    [anon_sym_DASH_DASH] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(1554),
    [anon_sym_DASH_GT] = ACTIONS(1554),
    [sym_comment] = ACTIONS(49),
  },
  [1420] = {
    [anon_sym_SEMI] = ACTIONS(4491),
    [sym_comment] = ACTIONS(49),
  },
  [1421] = {
    [sym_preproc_include] = STATE(1983),
    [sym_preproc_def] = STATE(1983),
    [sym_preproc_function_def] = STATE(1983),
    [sym_preproc_call] = STATE(1983),
    [sym_preproc_if_in_compound_statement] = STATE(1414),
    [sym_preproc_ifdef_in_compound_statement] = STATE(1415),
    [sym_preproc_else_in_compound_statement] = STATE(1981),
    [sym_preproc_elif_in_compound_statement] = STATE(1982),
    [sym_declaration] = STATE(1983),
    [sym_type_definition] = STATE(1983),
    [sym__declaration_specifiers] = STATE(1418),
    [sym_compound_statement] = STATE(1983),
    [sym_storage_class_specifier] = STATE(419),
    [sym_type_qualifier] = STATE(419),
    [sym__type_specifier] = STATE(30),
    [sym_sized_type_specifier] = STATE(30),
    [sym_enum_specifier] = STATE(30),
    [sym_struct_specifier] = STATE(30),
    [sym_union_specifier] = STATE(30),
    [sym_labeled_statement] = STATE(1983),
    [sym_expression_statement] = STATE(1983),
    [sym_if_statement] = STATE(1983),
    [sym_switch_statement] = STATE(1983),
    [sym_case_statement] = STATE(1983),
    [sym_while_statement] = STATE(1983),
    [sym_do_statement] = STATE(1983),
    [sym_for_statement] = STATE(1983),
    [sym_return_statement] = STATE(1983),
    [sym_break_statement] = STATE(1983),
    [sym_continue_statement] = STATE(1983),
    [sym_goto_statement] = STATE(1983),
    [sym__expression] = STATE(1419),
    [sym_comma_expression] = STATE(1420),
    [sym_conditional_expression] = STATE(1419),
    [sym_assignment_expression] = STATE(1419),
    [sym_pointer_expression] = STATE(1419),
    [sym_logical_expression] = STATE(1419),
    [sym_bitwise_expression] = STATE(1419),
    [sym_equality_expression] = STATE(1419),
    [sym_relational_expression] = STATE(1419),
    [sym_shift_expression] = STATE(1419),
    [sym_math_expression] = STATE(1419),
    [sym_cast_expression] = STATE(1419),
    [sym_sizeof_expression] = STATE(1419),
    [sym_subscript_expression] = STATE(1419),
    [sym_call_expression] = STATE(1419),
    [sym_field_expression] = STATE(1419),
    [sym_compound_literal_expression] = STATE(1419),
    [sym_parenthesized_expression] = STATE(1419),
    [sym_concatenated_string] = STATE(1419),
    [sym__empty_declaration] = STATE(1983),
    [sym_macro_type_specifier] = STATE(30),
    [sym_class_specifier] = STATE(30),
    [sym_dependent_type] = STATE(30),
    [sym_structured_binding_declaration] = STATE(1983),
    [sym_template_type] = STATE(415),
    [sym_template_function] = STATE(1419),
    [sym_for_range_loop] = STATE(1983),
    [sym_new_expression] = STATE(1419),
    [sym_delete_expression] = STATE(1419),
    [sym_lambda_expression] = STATE(1419),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(416),
    [sym_scoped_namespace_identifier] = STATE(417),
    [aux_sym_preproc_if_in_compound_statement_repeat1] = STATE(1983),
    [aux_sym__declaration_specifiers_repeat1] = STATE(419),
    [aux_sym_sized_type_specifier_repeat1] = STATE(38),
    [sym_raw_string_literal] = ACTIONS(2879),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(2881),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(2883),
    [anon_sym_LPAREN] = ACTIONS(626),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(2885),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(4493),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(2889),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(2891),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(2893),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(2895),
    [sym_preproc_directive] = ACTIONS(2897),
    [anon_sym_SEMI] = ACTIONS(2899),
    [anon_sym_typedef] = ACTIONS(2901),
    [anon_sym_extern] = ACTIONS(154),
    [anon_sym_LBRACE] = ACTIONS(2903),
    [anon_sym_STAR] = ACTIONS(644),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_static] = ACTIONS(154),
    [anon_sym_register] = ACTIONS(154),
    [anon_sym_inline] = ACTIONS(154),
    [anon_sym_const] = ACTIONS(158),
    [anon_sym_restrict] = ACTIONS(158),
    [anon_sym_volatile] = ACTIONS(158),
    [anon_sym__Atomic] = ACTIONS(158),
    [anon_sym_mutable] = ACTIONS(158),
    [anon_sym_explicit] = ACTIONS(158),
    [anon_sym_constexpr] = ACTIONS(158),
    [anon_sym_unsigned] = ACTIONS(31),
    [anon_sym_long] = ACTIONS(31),
    [anon_sym_short] = ACTIONS(31),
    [sym_primitive_type] = ACTIONS(33),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_union] = ACTIONS(39),
    [anon_sym_if] = ACTIONS(2905),
    [anon_sym_switch] = ACTIONS(2907),
    [anon_sym_case] = ACTIONS(2909),
    [anon_sym_default] = ACTIONS(2911),
    [anon_sym_while] = ACTIONS(2913),
    [anon_sym_do] = ACTIONS(2915),
    [anon_sym_for] = ACTIONS(2917),
    [anon_sym_return] = ACTIONS(2919),
    [anon_sym_break] = ACTIONS(2921),
    [anon_sym_continue] = ACTIONS(2923),
    [anon_sym_goto] = ACTIONS(2925),
    [anon_sym_AMP] = ACTIONS(644),
    [anon_sym_BANG] = ACTIONS(668),
    [anon_sym_TILDE] = ACTIONS(670),
    [anon_sym_PLUS] = ACTIONS(672),
    [anon_sym_DASH] = ACTIONS(672),
    [anon_sym_DASH_DASH] = ACTIONS(674),
    [anon_sym_PLUS_PLUS] = ACTIONS(674),
    [anon_sym_sizeof] = ACTIONS(676),
    [sym_number_literal] = ACTIONS(2879),
    [sym_char_literal] = ACTIONS(2879),
    [sym_string_literal] = ACTIONS(678),
    [sym_true] = ACTIONS(2927),
    [sym_false] = ACTIONS(2927),
    [sym_null] = ACTIONS(2927),
    [sym_identifier] = ACTIONS(2929),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(51),
    [sym_auto] = ACTIONS(33),
    [anon_sym_typename] = ACTIONS(53),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(684),
    [anon_sym_delete] = ACTIONS(686),
    [sym_nullptr] = ACTIONS(2927),
  },
  [1422] = {
    [sym_raw_string_literal] = ACTIONS(4495),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(4497),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(4497),
    [anon_sym_LPAREN] = ACTIONS(4495),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(4497),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(4497),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(4497),
    [sym_preproc_directive] = ACTIONS(4497),
    [anon_sym_SEMI] = ACTIONS(4495),
    [anon_sym_typedef] = ACTIONS(4497),
    [anon_sym_extern] = ACTIONS(4497),
    [anon_sym_LBRACE] = ACTIONS(4495),
    [anon_sym_RBRACE] = ACTIONS(4495),
    [anon_sym_STAR] = ACTIONS(4495),
    [anon_sym_LBRACK] = ACTIONS(4495),
    [anon_sym_static] = ACTIONS(4497),
    [anon_sym_register] = ACTIONS(4497),
    [anon_sym_inline] = ACTIONS(4497),
    [anon_sym_const] = ACTIONS(4497),
    [anon_sym_restrict] = ACTIONS(4497),
    [anon_sym_volatile] = ACTIONS(4497),
    [anon_sym__Atomic] = ACTIONS(4497),
    [anon_sym_mutable] = ACTIONS(4497),
    [anon_sym_explicit] = ACTIONS(4497),
    [anon_sym_constexpr] = ACTIONS(4497),
    [anon_sym_unsigned] = ACTIONS(4497),
    [anon_sym_long] = ACTIONS(4497),
    [anon_sym_short] = ACTIONS(4497),
    [sym_primitive_type] = ACTIONS(4497),
    [anon_sym_enum] = ACTIONS(4497),
    [anon_sym_struct] = ACTIONS(4497),
    [anon_sym_union] = ACTIONS(4497),
    [anon_sym_if] = ACTIONS(4497),
    [anon_sym_switch] = ACTIONS(4497),
    [anon_sym_case] = ACTIONS(4497),
    [anon_sym_default] = ACTIONS(4497),
    [anon_sym_while] = ACTIONS(4497),
    [anon_sym_do] = ACTIONS(4497),
    [anon_sym_for] = ACTIONS(4497),
    [anon_sym_return] = ACTIONS(4497),
    [anon_sym_break] = ACTIONS(4497),
    [anon_sym_continue] = ACTIONS(4497),
    [anon_sym_goto] = ACTIONS(4497),
    [anon_sym_AMP] = ACTIONS(4495),
    [anon_sym_BANG] = ACTIONS(4495),
    [anon_sym_TILDE] = ACTIONS(4495),
    [anon_sym_PLUS] = ACTIONS(4497),
    [anon_sym_DASH] = ACTIONS(4497),
    [anon_sym_DASH_DASH] = ACTIONS(4495),
    [anon_sym_PLUS_PLUS] = ACTIONS(4495),
    [anon_sym_sizeof] = ACTIONS(4497),
    [sym_number_literal] = ACTIONS(4495),
    [sym_char_literal] = ACTIONS(4495),
    [sym_string_literal] = ACTIONS(4495),
    [sym_true] = ACTIONS(4497),
    [sym_false] = ACTIONS(4497),
    [sym_null] = ACTIONS(4497),
    [sym_identifier] = ACTIONS(4497),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(4497),
    [sym_auto] = ACTIONS(4497),
    [anon_sym_typename] = ACTIONS(4497),
    [anon_sym_new] = ACTIONS(4497),
    [anon_sym_COLON_COLON] = ACTIONS(4495),
    [anon_sym_delete] = ACTIONS(4497),
    [sym_nullptr] = ACTIONS(4497),
  },
  [1423] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(4499),
    [sym_comment] = ACTIONS(49),
  },
  [1424] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(4501),
    [sym_comment] = ACTIONS(49),
  },
  [1425] = {
    [sym_preproc_include] = STATE(1983),
    [sym_preproc_def] = STATE(1983),
    [sym_preproc_function_def] = STATE(1983),
    [sym_preproc_call] = STATE(1983),
    [sym_preproc_if_in_compound_statement] = STATE(1414),
    [sym_preproc_ifdef_in_compound_statement] = STATE(1415),
    [sym_preproc_else_in_compound_statement] = STATE(1987),
    [sym_preproc_elif_in_compound_statement] = STATE(1988),
    [sym_declaration] = STATE(1983),
    [sym_type_definition] = STATE(1983),
    [sym__declaration_specifiers] = STATE(1418),
    [sym_compound_statement] = STATE(1983),
    [sym_storage_class_specifier] = STATE(419),
    [sym_type_qualifier] = STATE(419),
    [sym__type_specifier] = STATE(30),
    [sym_sized_type_specifier] = STATE(30),
    [sym_enum_specifier] = STATE(30),
    [sym_struct_specifier] = STATE(30),
    [sym_union_specifier] = STATE(30),
    [sym_labeled_statement] = STATE(1983),
    [sym_expression_statement] = STATE(1983),
    [sym_if_statement] = STATE(1983),
    [sym_switch_statement] = STATE(1983),
    [sym_case_statement] = STATE(1983),
    [sym_while_statement] = STATE(1983),
    [sym_do_statement] = STATE(1983),
    [sym_for_statement] = STATE(1983),
    [sym_return_statement] = STATE(1983),
    [sym_break_statement] = STATE(1983),
    [sym_continue_statement] = STATE(1983),
    [sym_goto_statement] = STATE(1983),
    [sym__expression] = STATE(1419),
    [sym_comma_expression] = STATE(1420),
    [sym_conditional_expression] = STATE(1419),
    [sym_assignment_expression] = STATE(1419),
    [sym_pointer_expression] = STATE(1419),
    [sym_logical_expression] = STATE(1419),
    [sym_bitwise_expression] = STATE(1419),
    [sym_equality_expression] = STATE(1419),
    [sym_relational_expression] = STATE(1419),
    [sym_shift_expression] = STATE(1419),
    [sym_math_expression] = STATE(1419),
    [sym_cast_expression] = STATE(1419),
    [sym_sizeof_expression] = STATE(1419),
    [sym_subscript_expression] = STATE(1419),
    [sym_call_expression] = STATE(1419),
    [sym_field_expression] = STATE(1419),
    [sym_compound_literal_expression] = STATE(1419),
    [sym_parenthesized_expression] = STATE(1419),
    [sym_concatenated_string] = STATE(1419),
    [sym__empty_declaration] = STATE(1983),
    [sym_macro_type_specifier] = STATE(30),
    [sym_class_specifier] = STATE(30),
    [sym_dependent_type] = STATE(30),
    [sym_structured_binding_declaration] = STATE(1983),
    [sym_template_type] = STATE(415),
    [sym_template_function] = STATE(1419),
    [sym_for_range_loop] = STATE(1983),
    [sym_new_expression] = STATE(1419),
    [sym_delete_expression] = STATE(1419),
    [sym_lambda_expression] = STATE(1419),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(416),
    [sym_scoped_namespace_identifier] = STATE(417),
    [aux_sym_preproc_if_in_compound_statement_repeat1] = STATE(1983),
    [aux_sym__declaration_specifiers_repeat1] = STATE(419),
    [aux_sym_sized_type_specifier_repeat1] = STATE(38),
    [sym_raw_string_literal] = ACTIONS(2879),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(2881),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(2883),
    [anon_sym_LPAREN] = ACTIONS(626),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(2885),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(4503),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(2889),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(2891),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(2893),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(2895),
    [sym_preproc_directive] = ACTIONS(2897),
    [anon_sym_SEMI] = ACTIONS(2899),
    [anon_sym_typedef] = ACTIONS(2901),
    [anon_sym_extern] = ACTIONS(154),
    [anon_sym_LBRACE] = ACTIONS(2903),
    [anon_sym_STAR] = ACTIONS(644),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_static] = ACTIONS(154),
    [anon_sym_register] = ACTIONS(154),
    [anon_sym_inline] = ACTIONS(154),
    [anon_sym_const] = ACTIONS(158),
    [anon_sym_restrict] = ACTIONS(158),
    [anon_sym_volatile] = ACTIONS(158),
    [anon_sym__Atomic] = ACTIONS(158),
    [anon_sym_mutable] = ACTIONS(158),
    [anon_sym_explicit] = ACTIONS(158),
    [anon_sym_constexpr] = ACTIONS(158),
    [anon_sym_unsigned] = ACTIONS(31),
    [anon_sym_long] = ACTIONS(31),
    [anon_sym_short] = ACTIONS(31),
    [sym_primitive_type] = ACTIONS(33),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_union] = ACTIONS(39),
    [anon_sym_if] = ACTIONS(2905),
    [anon_sym_switch] = ACTIONS(2907),
    [anon_sym_case] = ACTIONS(2909),
    [anon_sym_default] = ACTIONS(2911),
    [anon_sym_while] = ACTIONS(2913),
    [anon_sym_do] = ACTIONS(2915),
    [anon_sym_for] = ACTIONS(2917),
    [anon_sym_return] = ACTIONS(2919),
    [anon_sym_break] = ACTIONS(2921),
    [anon_sym_continue] = ACTIONS(2923),
    [anon_sym_goto] = ACTIONS(2925),
    [anon_sym_AMP] = ACTIONS(644),
    [anon_sym_BANG] = ACTIONS(668),
    [anon_sym_TILDE] = ACTIONS(670),
    [anon_sym_PLUS] = ACTIONS(672),
    [anon_sym_DASH] = ACTIONS(672),
    [anon_sym_DASH_DASH] = ACTIONS(674),
    [anon_sym_PLUS_PLUS] = ACTIONS(674),
    [anon_sym_sizeof] = ACTIONS(676),
    [sym_number_literal] = ACTIONS(2879),
    [sym_char_literal] = ACTIONS(2879),
    [sym_string_literal] = ACTIONS(678),
    [sym_true] = ACTIONS(2927),
    [sym_false] = ACTIONS(2927),
    [sym_null] = ACTIONS(2927),
    [sym_identifier] = ACTIONS(2929),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(51),
    [sym_auto] = ACTIONS(33),
    [anon_sym_typename] = ACTIONS(53),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(684),
    [anon_sym_delete] = ACTIONS(686),
    [sym_nullptr] = ACTIONS(2927),
  },
  [1426] = {
    [sym_raw_string_literal] = ACTIONS(4505),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(4507),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(4507),
    [anon_sym_LPAREN] = ACTIONS(4505),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(4507),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(4507),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(4507),
    [sym_preproc_directive] = ACTIONS(4507),
    [anon_sym_SEMI] = ACTIONS(4505),
    [anon_sym_typedef] = ACTIONS(4507),
    [anon_sym_extern] = ACTIONS(4507),
    [anon_sym_LBRACE] = ACTIONS(4505),
    [anon_sym_RBRACE] = ACTIONS(4505),
    [anon_sym_STAR] = ACTIONS(4505),
    [anon_sym_LBRACK] = ACTIONS(4505),
    [anon_sym_static] = ACTIONS(4507),
    [anon_sym_register] = ACTIONS(4507),
    [anon_sym_inline] = ACTIONS(4507),
    [anon_sym_const] = ACTIONS(4507),
    [anon_sym_restrict] = ACTIONS(4507),
    [anon_sym_volatile] = ACTIONS(4507),
    [anon_sym__Atomic] = ACTIONS(4507),
    [anon_sym_mutable] = ACTIONS(4507),
    [anon_sym_explicit] = ACTIONS(4507),
    [anon_sym_constexpr] = ACTIONS(4507),
    [anon_sym_unsigned] = ACTIONS(4507),
    [anon_sym_long] = ACTIONS(4507),
    [anon_sym_short] = ACTIONS(4507),
    [sym_primitive_type] = ACTIONS(4507),
    [anon_sym_enum] = ACTIONS(4507),
    [anon_sym_struct] = ACTIONS(4507),
    [anon_sym_union] = ACTIONS(4507),
    [anon_sym_if] = ACTIONS(4507),
    [anon_sym_switch] = ACTIONS(4507),
    [anon_sym_case] = ACTIONS(4507),
    [anon_sym_default] = ACTIONS(4507),
    [anon_sym_while] = ACTIONS(4507),
    [anon_sym_do] = ACTIONS(4507),
    [anon_sym_for] = ACTIONS(4507),
    [anon_sym_return] = ACTIONS(4507),
    [anon_sym_break] = ACTIONS(4507),
    [anon_sym_continue] = ACTIONS(4507),
    [anon_sym_goto] = ACTIONS(4507),
    [anon_sym_AMP] = ACTIONS(4505),
    [anon_sym_BANG] = ACTIONS(4505),
    [anon_sym_TILDE] = ACTIONS(4505),
    [anon_sym_PLUS] = ACTIONS(4507),
    [anon_sym_DASH] = ACTIONS(4507),
    [anon_sym_DASH_DASH] = ACTIONS(4505),
    [anon_sym_PLUS_PLUS] = ACTIONS(4505),
    [anon_sym_sizeof] = ACTIONS(4507),
    [sym_number_literal] = ACTIONS(4505),
    [sym_char_literal] = ACTIONS(4505),
    [sym_string_literal] = ACTIONS(4505),
    [sym_true] = ACTIONS(4507),
    [sym_false] = ACTIONS(4507),
    [sym_null] = ACTIONS(4507),
    [sym_identifier] = ACTIONS(4507),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(4507),
    [sym_auto] = ACTIONS(4507),
    [anon_sym_typename] = ACTIONS(4507),
    [anon_sym_new] = ACTIONS(4507),
    [anon_sym_COLON_COLON] = ACTIONS(4505),
    [anon_sym_delete] = ACTIONS(4507),
    [sym_nullptr] = ACTIONS(4507),
  },
  [1427] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(4509),
    [sym_comment] = ACTIONS(49),
  },
  [1428] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(4511),
    [sym_comment] = ACTIONS(49),
  },
  [1429] = {
    [sym_preproc_include] = STATE(1983),
    [sym_preproc_def] = STATE(1983),
    [sym_preproc_function_def] = STATE(1983),
    [sym_preproc_call] = STATE(1983),
    [sym_preproc_if_in_compound_statement] = STATE(1414),
    [sym_preproc_ifdef_in_compound_statement] = STATE(1415),
    [sym_preproc_else_in_compound_statement] = STATE(1992),
    [sym_preproc_elif_in_compound_statement] = STATE(1993),
    [sym_declaration] = STATE(1983),
    [sym_type_definition] = STATE(1983),
    [sym__declaration_specifiers] = STATE(1418),
    [sym_compound_statement] = STATE(1983),
    [sym_storage_class_specifier] = STATE(419),
    [sym_type_qualifier] = STATE(419),
    [sym__type_specifier] = STATE(30),
    [sym_sized_type_specifier] = STATE(30),
    [sym_enum_specifier] = STATE(30),
    [sym_struct_specifier] = STATE(30),
    [sym_union_specifier] = STATE(30),
    [sym_labeled_statement] = STATE(1983),
    [sym_expression_statement] = STATE(1983),
    [sym_if_statement] = STATE(1983),
    [sym_switch_statement] = STATE(1983),
    [sym_case_statement] = STATE(1983),
    [sym_while_statement] = STATE(1983),
    [sym_do_statement] = STATE(1983),
    [sym_for_statement] = STATE(1983),
    [sym_return_statement] = STATE(1983),
    [sym_break_statement] = STATE(1983),
    [sym_continue_statement] = STATE(1983),
    [sym_goto_statement] = STATE(1983),
    [sym__expression] = STATE(1419),
    [sym_comma_expression] = STATE(1420),
    [sym_conditional_expression] = STATE(1419),
    [sym_assignment_expression] = STATE(1419),
    [sym_pointer_expression] = STATE(1419),
    [sym_logical_expression] = STATE(1419),
    [sym_bitwise_expression] = STATE(1419),
    [sym_equality_expression] = STATE(1419),
    [sym_relational_expression] = STATE(1419),
    [sym_shift_expression] = STATE(1419),
    [sym_math_expression] = STATE(1419),
    [sym_cast_expression] = STATE(1419),
    [sym_sizeof_expression] = STATE(1419),
    [sym_subscript_expression] = STATE(1419),
    [sym_call_expression] = STATE(1419),
    [sym_field_expression] = STATE(1419),
    [sym_compound_literal_expression] = STATE(1419),
    [sym_parenthesized_expression] = STATE(1419),
    [sym_concatenated_string] = STATE(1419),
    [sym__empty_declaration] = STATE(1983),
    [sym_macro_type_specifier] = STATE(30),
    [sym_class_specifier] = STATE(30),
    [sym_dependent_type] = STATE(30),
    [sym_structured_binding_declaration] = STATE(1983),
    [sym_template_type] = STATE(415),
    [sym_template_function] = STATE(1419),
    [sym_for_range_loop] = STATE(1983),
    [sym_new_expression] = STATE(1419),
    [sym_delete_expression] = STATE(1419),
    [sym_lambda_expression] = STATE(1419),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(416),
    [sym_scoped_namespace_identifier] = STATE(417),
    [aux_sym_preproc_if_in_compound_statement_repeat1] = STATE(1983),
    [aux_sym__declaration_specifiers_repeat1] = STATE(419),
    [aux_sym_sized_type_specifier_repeat1] = STATE(38),
    [sym_raw_string_literal] = ACTIONS(2879),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(2881),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(2883),
    [anon_sym_LPAREN] = ACTIONS(626),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(2885),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(4513),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(2889),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(2891),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(2893),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(2895),
    [sym_preproc_directive] = ACTIONS(2897),
    [anon_sym_SEMI] = ACTIONS(2899),
    [anon_sym_typedef] = ACTIONS(2901),
    [anon_sym_extern] = ACTIONS(154),
    [anon_sym_LBRACE] = ACTIONS(2903),
    [anon_sym_STAR] = ACTIONS(644),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_static] = ACTIONS(154),
    [anon_sym_register] = ACTIONS(154),
    [anon_sym_inline] = ACTIONS(154),
    [anon_sym_const] = ACTIONS(158),
    [anon_sym_restrict] = ACTIONS(158),
    [anon_sym_volatile] = ACTIONS(158),
    [anon_sym__Atomic] = ACTIONS(158),
    [anon_sym_mutable] = ACTIONS(158),
    [anon_sym_explicit] = ACTIONS(158),
    [anon_sym_constexpr] = ACTIONS(158),
    [anon_sym_unsigned] = ACTIONS(31),
    [anon_sym_long] = ACTIONS(31),
    [anon_sym_short] = ACTIONS(31),
    [sym_primitive_type] = ACTIONS(33),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_union] = ACTIONS(39),
    [anon_sym_if] = ACTIONS(2905),
    [anon_sym_switch] = ACTIONS(2907),
    [anon_sym_case] = ACTIONS(2909),
    [anon_sym_default] = ACTIONS(2911),
    [anon_sym_while] = ACTIONS(2913),
    [anon_sym_do] = ACTIONS(2915),
    [anon_sym_for] = ACTIONS(2917),
    [anon_sym_return] = ACTIONS(2919),
    [anon_sym_break] = ACTIONS(2921),
    [anon_sym_continue] = ACTIONS(2923),
    [anon_sym_goto] = ACTIONS(2925),
    [anon_sym_AMP] = ACTIONS(644),
    [anon_sym_BANG] = ACTIONS(668),
    [anon_sym_TILDE] = ACTIONS(670),
    [anon_sym_PLUS] = ACTIONS(672),
    [anon_sym_DASH] = ACTIONS(672),
    [anon_sym_DASH_DASH] = ACTIONS(674),
    [anon_sym_PLUS_PLUS] = ACTIONS(674),
    [anon_sym_sizeof] = ACTIONS(676),
    [sym_number_literal] = ACTIONS(2879),
    [sym_char_literal] = ACTIONS(2879),
    [sym_string_literal] = ACTIONS(678),
    [sym_true] = ACTIONS(2927),
    [sym_false] = ACTIONS(2927),
    [sym_null] = ACTIONS(2927),
    [sym_identifier] = ACTIONS(2929),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(51),
    [sym_auto] = ACTIONS(33),
    [anon_sym_typename] = ACTIONS(53),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(684),
    [anon_sym_delete] = ACTIONS(686),
    [sym_nullptr] = ACTIONS(2927),
  },
  [1430] = {
    [anon_sym_LF] = ACTIONS(4515),
    [sym_comment] = ACTIONS(83),
  },
  [1431] = {
    [sym_parameter_list] = STATE(513),
    [anon_sym_LPAREN] = ACTIONS(206),
    [anon_sym_SEMI] = ACTIONS(4517),
    [anon_sym_LBRACK] = ACTIONS(955),
    [sym_comment] = ACTIONS(49),
  },
  [1432] = {
    [sym__type_declarator] = STATE(1996),
    [sym_pointer_type_declarator] = STATE(213),
    [sym_function_type_declarator] = STATE(214),
    [sym_array_type_declarator] = STATE(215),
    [anon_sym_LPAREN] = ACTIONS(327),
    [anon_sym_STAR] = ACTIONS(329),
    [sym_identifier] = ACTIONS(331),
    [sym_comment] = ACTIONS(49),
  },
  [1433] = {
    [sym_raw_string_literal] = ACTIONS(3182),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3184),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3184),
    [anon_sym_LPAREN] = ACTIONS(3182),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3184),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3184),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3184),
    [sym_preproc_directive] = ACTIONS(3184),
    [anon_sym_SEMI] = ACTIONS(3182),
    [anon_sym_typedef] = ACTIONS(3184),
    [anon_sym_extern] = ACTIONS(3184),
    [anon_sym_LBRACE] = ACTIONS(3182),
    [anon_sym_RBRACE] = ACTIONS(3182),
    [anon_sym_STAR] = ACTIONS(3182),
    [anon_sym_LBRACK] = ACTIONS(3182),
    [anon_sym_static] = ACTIONS(3184),
    [anon_sym_register] = ACTIONS(3184),
    [anon_sym_inline] = ACTIONS(3184),
    [anon_sym_const] = ACTIONS(3184),
    [anon_sym_restrict] = ACTIONS(3184),
    [anon_sym_volatile] = ACTIONS(3184),
    [anon_sym__Atomic] = ACTIONS(3184),
    [anon_sym_mutable] = ACTIONS(3184),
    [anon_sym_explicit] = ACTIONS(3184),
    [anon_sym_constexpr] = ACTIONS(3184),
    [anon_sym_unsigned] = ACTIONS(3184),
    [anon_sym_long] = ACTIONS(3184),
    [anon_sym_short] = ACTIONS(3184),
    [sym_primitive_type] = ACTIONS(3184),
    [anon_sym_enum] = ACTIONS(3184),
    [anon_sym_struct] = ACTIONS(3184),
    [anon_sym_union] = ACTIONS(3184),
    [anon_sym_if] = ACTIONS(3184),
    [anon_sym_switch] = ACTIONS(3184),
    [anon_sym_case] = ACTIONS(3184),
    [anon_sym_default] = ACTIONS(3184),
    [anon_sym_while] = ACTIONS(3184),
    [anon_sym_do] = ACTIONS(3184),
    [anon_sym_for] = ACTIONS(3184),
    [anon_sym_return] = ACTIONS(3184),
    [anon_sym_break] = ACTIONS(3184),
    [anon_sym_continue] = ACTIONS(3184),
    [anon_sym_goto] = ACTIONS(3184),
    [anon_sym_AMP] = ACTIONS(3182),
    [anon_sym_BANG] = ACTIONS(3182),
    [anon_sym_TILDE] = ACTIONS(3182),
    [anon_sym_PLUS] = ACTIONS(3184),
    [anon_sym_DASH] = ACTIONS(3184),
    [anon_sym_DASH_DASH] = ACTIONS(3182),
    [anon_sym_PLUS_PLUS] = ACTIONS(3182),
    [anon_sym_sizeof] = ACTIONS(3184),
    [sym_number_literal] = ACTIONS(3182),
    [sym_char_literal] = ACTIONS(3182),
    [sym_string_literal] = ACTIONS(3182),
    [sym_true] = ACTIONS(3184),
    [sym_false] = ACTIONS(3184),
    [sym_null] = ACTIONS(3184),
    [sym_identifier] = ACTIONS(3184),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(3184),
    [sym_auto] = ACTIONS(3184),
    [anon_sym_typename] = ACTIONS(3184),
    [anon_sym_new] = ACTIONS(3184),
    [anon_sym_COLON_COLON] = ACTIONS(3182),
    [anon_sym_delete] = ACTIONS(3184),
    [sym_nullptr] = ACTIONS(3184),
  },
  [1434] = {
    [sym_type_qualifier] = STATE(724),
    [sym__type_specifier] = STATE(720),
    [sym_sized_type_specifier] = STATE(720),
    [sym_enum_specifier] = STATE(720),
    [sym_struct_specifier] = STATE(720),
    [sym_union_specifier] = STATE(720),
    [sym__expression] = STATE(721),
    [sym_comma_expression] = STATE(722),
    [sym_conditional_expression] = STATE(721),
    [sym_assignment_expression] = STATE(721),
    [sym_pointer_expression] = STATE(721),
    [sym_logical_expression] = STATE(721),
    [sym_bitwise_expression] = STATE(721),
    [sym_equality_expression] = STATE(721),
    [sym_relational_expression] = STATE(721),
    [sym_shift_expression] = STATE(721),
    [sym_math_expression] = STATE(721),
    [sym_cast_expression] = STATE(721),
    [sym_type_descriptor] = STATE(1997),
    [sym_sizeof_expression] = STATE(721),
    [sym_subscript_expression] = STATE(721),
    [sym_call_expression] = STATE(721),
    [sym_field_expression] = STATE(721),
    [sym_compound_literal_expression] = STATE(721),
    [sym_parenthesized_expression] = STATE(721),
    [sym_concatenated_string] = STATE(721),
    [sym_macro_type_specifier] = STATE(720),
    [sym_class_specifier] = STATE(720),
    [sym_dependent_type] = STATE(720),
    [sym_template_type] = STATE(415),
    [sym_template_function] = STATE(721),
    [sym_new_expression] = STATE(721),
    [sym_delete_expression] = STATE(721),
    [sym_lambda_expression] = STATE(721),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(416),
    [sym_scoped_namespace_identifier] = STATE(417),
    [aux_sym_type_definition_repeat1] = STATE(724),
    [aux_sym_sized_type_specifier_repeat1] = STATE(725),
    [sym_raw_string_literal] = ACTIONS(1397),
    [anon_sym_LPAREN] = ACTIONS(1087),
    [anon_sym_STAR] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_restrict] = ACTIONS(93),
    [anon_sym_volatile] = ACTIONS(93),
    [anon_sym__Atomic] = ACTIONS(93),
    [anon_sym_mutable] = ACTIONS(93),
    [anon_sym_explicit] = ACTIONS(93),
    [anon_sym_constexpr] = ACTIONS(93),
    [anon_sym_unsigned] = ACTIONS(1399),
    [anon_sym_long] = ACTIONS(1399),
    [anon_sym_short] = ACTIONS(1399),
    [sym_primitive_type] = ACTIONS(1401),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(428),
    [anon_sym_union] = ACTIONS(430),
    [anon_sym_AMP] = ACTIONS(1089),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1093),
    [anon_sym_PLUS] = ACTIONS(1095),
    [anon_sym_DASH] = ACTIONS(1095),
    [anon_sym_DASH_DASH] = ACTIONS(1097),
    [anon_sym_PLUS_PLUS] = ACTIONS(1097),
    [anon_sym_sizeof] = ACTIONS(1099),
    [sym_number_literal] = ACTIONS(1397),
    [sym_char_literal] = ACTIONS(1397),
    [sym_string_literal] = ACTIONS(1101),
    [sym_true] = ACTIONS(1403),
    [sym_false] = ACTIONS(1403),
    [sym_null] = ACTIONS(1403),
    [sym_identifier] = ACTIONS(1405),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(436),
    [sym_auto] = ACTIONS(1401),
    [anon_sym_typename] = ACTIONS(1407),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1409),
    [anon_sym_delete] = ACTIONS(1109),
    [sym_nullptr] = ACTIONS(1403),
  },
  [1435] = {
    [sym__expression] = STATE(727),
    [sym_conditional_expression] = STATE(727),
    [sym_assignment_expression] = STATE(727),
    [sym_pointer_expression] = STATE(727),
    [sym_logical_expression] = STATE(727),
    [sym_bitwise_expression] = STATE(727),
    [sym_equality_expression] = STATE(727),
    [sym_relational_expression] = STATE(727),
    [sym_shift_expression] = STATE(727),
    [sym_math_expression] = STATE(727),
    [sym_cast_expression] = STATE(727),
    [sym_sizeof_expression] = STATE(727),
    [sym_subscript_expression] = STATE(727),
    [sym_call_expression] = STATE(727),
    [sym_field_expression] = STATE(727),
    [sym_compound_literal_expression] = STATE(727),
    [sym_parenthesized_expression] = STATE(727),
    [sym_concatenated_string] = STATE(727),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(727),
    [sym_new_expression] = STATE(727),
    [sym_delete_expression] = STATE(727),
    [sym_lambda_expression] = STATE(727),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(1411),
    [anon_sym_LPAREN] = ACTIONS(2943),
    [anon_sym_STAR] = ACTIONS(2945),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_AMP] = ACTIONS(2945),
    [anon_sym_BANG] = ACTIONS(2947),
    [anon_sym_TILDE] = ACTIONS(2949),
    [anon_sym_PLUS] = ACTIONS(2951),
    [anon_sym_DASH] = ACTIONS(2951),
    [anon_sym_DASH_DASH] = ACTIONS(2953),
    [anon_sym_PLUS_PLUS] = ACTIONS(2953),
    [anon_sym_sizeof] = ACTIONS(2955),
    [sym_number_literal] = ACTIONS(1411),
    [sym_char_literal] = ACTIONS(1411),
    [sym_string_literal] = ACTIONS(2957),
    [sym_true] = ACTIONS(1413),
    [sym_false] = ACTIONS(1413),
    [sym_null] = ACTIONS(1413),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(2961),
    [anon_sym_delete] = ACTIONS(2963),
    [sym_nullptr] = ACTIONS(1413),
  },
  [1436] = {
    [sym__expression] = STATE(757),
    [sym_conditional_expression] = STATE(757),
    [sym_assignment_expression] = STATE(757),
    [sym_pointer_expression] = STATE(757),
    [sym_logical_expression] = STATE(757),
    [sym_bitwise_expression] = STATE(757),
    [sym_equality_expression] = STATE(757),
    [sym_relational_expression] = STATE(757),
    [sym_shift_expression] = STATE(757),
    [sym_math_expression] = STATE(757),
    [sym_cast_expression] = STATE(757),
    [sym_sizeof_expression] = STATE(757),
    [sym_subscript_expression] = STATE(757),
    [sym_call_expression] = STATE(757),
    [sym_field_expression] = STATE(757),
    [sym_compound_literal_expression] = STATE(757),
    [sym_parenthesized_expression] = STATE(757),
    [sym_concatenated_string] = STATE(757),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(757),
    [sym_new_expression] = STATE(757),
    [sym_delete_expression] = STATE(757),
    [sym_lambda_expression] = STATE(757),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(1459),
    [anon_sym_LPAREN] = ACTIONS(2943),
    [anon_sym_STAR] = ACTIONS(2945),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_AMP] = ACTIONS(2945),
    [anon_sym_BANG] = ACTIONS(2947),
    [anon_sym_TILDE] = ACTIONS(2949),
    [anon_sym_PLUS] = ACTIONS(2951),
    [anon_sym_DASH] = ACTIONS(2951),
    [anon_sym_DASH_DASH] = ACTIONS(2953),
    [anon_sym_PLUS_PLUS] = ACTIONS(2953),
    [anon_sym_sizeof] = ACTIONS(2955),
    [sym_number_literal] = ACTIONS(1459),
    [sym_char_literal] = ACTIONS(1459),
    [sym_string_literal] = ACTIONS(2957),
    [sym_true] = ACTIONS(1461),
    [sym_false] = ACTIONS(1461),
    [sym_null] = ACTIONS(1461),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(2961),
    [anon_sym_delete] = ACTIONS(2963),
    [sym_nullptr] = ACTIONS(1461),
  },
  [1437] = {
    [sym__expression] = STATE(758),
    [sym_conditional_expression] = STATE(758),
    [sym_assignment_expression] = STATE(758),
    [sym_pointer_expression] = STATE(758),
    [sym_logical_expression] = STATE(758),
    [sym_bitwise_expression] = STATE(758),
    [sym_equality_expression] = STATE(758),
    [sym_relational_expression] = STATE(758),
    [sym_shift_expression] = STATE(758),
    [sym_math_expression] = STATE(758),
    [sym_cast_expression] = STATE(758),
    [sym_sizeof_expression] = STATE(758),
    [sym_subscript_expression] = STATE(758),
    [sym_call_expression] = STATE(758),
    [sym_field_expression] = STATE(758),
    [sym_compound_literal_expression] = STATE(758),
    [sym_parenthesized_expression] = STATE(758),
    [sym_concatenated_string] = STATE(758),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(758),
    [sym_new_expression] = STATE(758),
    [sym_delete_expression] = STATE(758),
    [sym_lambda_expression] = STATE(758),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(1463),
    [anon_sym_LPAREN] = ACTIONS(2943),
    [anon_sym_STAR] = ACTIONS(2945),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_AMP] = ACTIONS(2945),
    [anon_sym_BANG] = ACTIONS(2947),
    [anon_sym_TILDE] = ACTIONS(2949),
    [anon_sym_PLUS] = ACTIONS(2951),
    [anon_sym_DASH] = ACTIONS(2951),
    [anon_sym_DASH_DASH] = ACTIONS(2953),
    [anon_sym_PLUS_PLUS] = ACTIONS(2953),
    [anon_sym_sizeof] = ACTIONS(2955),
    [sym_number_literal] = ACTIONS(1463),
    [sym_char_literal] = ACTIONS(1463),
    [sym_string_literal] = ACTIONS(2957),
    [sym_true] = ACTIONS(1465),
    [sym_false] = ACTIONS(1465),
    [sym_null] = ACTIONS(1465),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(2961),
    [anon_sym_delete] = ACTIONS(2963),
    [sym_nullptr] = ACTIONS(1465),
  },
  [1438] = {
    [sym__expression] = STATE(759),
    [sym_conditional_expression] = STATE(759),
    [sym_assignment_expression] = STATE(759),
    [sym_pointer_expression] = STATE(759),
    [sym_logical_expression] = STATE(759),
    [sym_bitwise_expression] = STATE(759),
    [sym_equality_expression] = STATE(759),
    [sym_relational_expression] = STATE(759),
    [sym_shift_expression] = STATE(759),
    [sym_math_expression] = STATE(759),
    [sym_cast_expression] = STATE(759),
    [sym_sizeof_expression] = STATE(759),
    [sym_subscript_expression] = STATE(759),
    [sym_call_expression] = STATE(759),
    [sym_field_expression] = STATE(759),
    [sym_compound_literal_expression] = STATE(759),
    [sym_parenthesized_expression] = STATE(759),
    [sym_concatenated_string] = STATE(759),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(759),
    [sym_new_expression] = STATE(759),
    [sym_delete_expression] = STATE(759),
    [sym_lambda_expression] = STATE(759),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(1467),
    [anon_sym_LPAREN] = ACTIONS(2943),
    [anon_sym_STAR] = ACTIONS(2945),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_AMP] = ACTIONS(2945),
    [anon_sym_BANG] = ACTIONS(2947),
    [anon_sym_TILDE] = ACTIONS(2949),
    [anon_sym_PLUS] = ACTIONS(2951),
    [anon_sym_DASH] = ACTIONS(2951),
    [anon_sym_DASH_DASH] = ACTIONS(2953),
    [anon_sym_PLUS_PLUS] = ACTIONS(2953),
    [anon_sym_sizeof] = ACTIONS(2955),
    [sym_number_literal] = ACTIONS(1467),
    [sym_char_literal] = ACTIONS(1467),
    [sym_string_literal] = ACTIONS(2957),
    [sym_true] = ACTIONS(1469),
    [sym_false] = ACTIONS(1469),
    [sym_null] = ACTIONS(1469),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(2961),
    [anon_sym_delete] = ACTIONS(2963),
    [sym_nullptr] = ACTIONS(1469),
  },
  [1439] = {
    [sym__expression] = STATE(1999),
    [sym_conditional_expression] = STATE(1999),
    [sym_assignment_expression] = STATE(1999),
    [sym_pointer_expression] = STATE(1999),
    [sym_logical_expression] = STATE(1999),
    [sym_bitwise_expression] = STATE(1999),
    [sym_equality_expression] = STATE(1999),
    [sym_relational_expression] = STATE(1999),
    [sym_shift_expression] = STATE(1999),
    [sym_math_expression] = STATE(1999),
    [sym_cast_expression] = STATE(1999),
    [sym_sizeof_expression] = STATE(1999),
    [sym_subscript_expression] = STATE(1999),
    [sym_call_expression] = STATE(1999),
    [sym_field_expression] = STATE(1999),
    [sym_compound_literal_expression] = STATE(1999),
    [sym_parenthesized_expression] = STATE(1999),
    [sym_concatenated_string] = STATE(1999),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(1999),
    [sym_new_expression] = STATE(1999),
    [sym_delete_expression] = STATE(1999),
    [sym_lambda_expression] = STATE(1999),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(4519),
    [anon_sym_LPAREN] = ACTIONS(4521),
    [anon_sym_STAR] = ACTIONS(2945),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_AMP] = ACTIONS(2945),
    [anon_sym_BANG] = ACTIONS(2947),
    [anon_sym_TILDE] = ACTIONS(2949),
    [anon_sym_PLUS] = ACTIONS(2951),
    [anon_sym_DASH] = ACTIONS(2951),
    [anon_sym_DASH_DASH] = ACTIONS(2953),
    [anon_sym_PLUS_PLUS] = ACTIONS(2953),
    [anon_sym_sizeof] = ACTIONS(2955),
    [sym_number_literal] = ACTIONS(4519),
    [sym_char_literal] = ACTIONS(4519),
    [sym_string_literal] = ACTIONS(2957),
    [sym_true] = ACTIONS(4523),
    [sym_false] = ACTIONS(4523),
    [sym_null] = ACTIONS(4523),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(2961),
    [anon_sym_delete] = ACTIONS(2963),
    [sym_nullptr] = ACTIONS(4523),
  },
  [1440] = {
    [aux_sym_concatenated_string_repeat1] = STATE(2000),
    [anon_sym_LPAREN] = ACTIONS(1477),
    [anon_sym_RPAREN] = ACTIONS(1477),
    [anon_sym_STAR] = ACTIONS(1479),
    [anon_sym_LBRACK] = ACTIONS(1477),
    [anon_sym_EQ] = ACTIONS(1479),
    [anon_sym_QMARK] = ACTIONS(1477),
    [anon_sym_STAR_EQ] = ACTIONS(1477),
    [anon_sym_SLASH_EQ] = ACTIONS(1477),
    [anon_sym_PERCENT_EQ] = ACTIONS(1477),
    [anon_sym_PLUS_EQ] = ACTIONS(1477),
    [anon_sym_DASH_EQ] = ACTIONS(1477),
    [anon_sym_LT_LT_EQ] = ACTIONS(1477),
    [anon_sym_GT_GT_EQ] = ACTIONS(1477),
    [anon_sym_AMP_EQ] = ACTIONS(1477),
    [anon_sym_CARET_EQ] = ACTIONS(1477),
    [anon_sym_PIPE_EQ] = ACTIONS(1477),
    [anon_sym_AMP] = ACTIONS(1479),
    [anon_sym_PIPE_PIPE] = ACTIONS(1477),
    [anon_sym_AMP_AMP] = ACTIONS(1477),
    [anon_sym_PIPE] = ACTIONS(1479),
    [anon_sym_CARET] = ACTIONS(1479),
    [anon_sym_EQ_EQ] = ACTIONS(1477),
    [anon_sym_BANG_EQ] = ACTIONS(1477),
    [anon_sym_LT] = ACTIONS(1479),
    [anon_sym_GT] = ACTIONS(1479),
    [anon_sym_LT_EQ] = ACTIONS(1477),
    [anon_sym_GT_EQ] = ACTIONS(1477),
    [anon_sym_LT_LT] = ACTIONS(1479),
    [anon_sym_GT_GT] = ACTIONS(1479),
    [anon_sym_PLUS] = ACTIONS(1479),
    [anon_sym_DASH] = ACTIONS(1479),
    [anon_sym_SLASH] = ACTIONS(1479),
    [anon_sym_PERCENT] = ACTIONS(1479),
    [anon_sym_DASH_DASH] = ACTIONS(1477),
    [anon_sym_PLUS_PLUS] = ACTIONS(1477),
    [anon_sym_DOT] = ACTIONS(1477),
    [anon_sym_DASH_GT] = ACTIONS(1477),
    [sym_string_literal] = ACTIONS(4525),
    [sym_comment] = ACTIONS(49),
  },
  [1441] = {
    [sym_destructor_name] = STATE(120),
    [anon_sym_TILDE] = ACTIONS(1500),
    [sym_identifier] = ACTIONS(2220),
    [sym_comment] = ACTIONS(49),
    [anon_sym_delete] = ACTIONS(4527),
    [sym_operator_name] = ACTIONS(190),
  },
  [1442] = {
    [sym__expression] = STATE(2003),
    [sym_conditional_expression] = STATE(2003),
    [sym_assignment_expression] = STATE(2003),
    [sym_pointer_expression] = STATE(2003),
    [sym_logical_expression] = STATE(2003),
    [sym_bitwise_expression] = STATE(2003),
    [sym_equality_expression] = STATE(2003),
    [sym_relational_expression] = STATE(2003),
    [sym_shift_expression] = STATE(2003),
    [sym_math_expression] = STATE(2003),
    [sym_cast_expression] = STATE(2003),
    [sym_sizeof_expression] = STATE(2003),
    [sym_subscript_expression] = STATE(2003),
    [sym_call_expression] = STATE(2003),
    [sym_field_expression] = STATE(2003),
    [sym_compound_literal_expression] = STATE(2003),
    [sym_parenthesized_expression] = STATE(2003),
    [sym_concatenated_string] = STATE(2003),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(2003),
    [sym_new_expression] = STATE(2003),
    [sym_delete_expression] = STATE(2003),
    [sym_lambda_expression] = STATE(2003),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(4529),
    [anon_sym_LPAREN] = ACTIONS(2943),
    [anon_sym_STAR] = ACTIONS(2945),
    [anon_sym_LBRACK] = ACTIONS(4531),
    [anon_sym_AMP] = ACTIONS(2945),
    [anon_sym_BANG] = ACTIONS(2947),
    [anon_sym_TILDE] = ACTIONS(2949),
    [anon_sym_PLUS] = ACTIONS(2951),
    [anon_sym_DASH] = ACTIONS(2951),
    [anon_sym_DASH_DASH] = ACTIONS(2953),
    [anon_sym_PLUS_PLUS] = ACTIONS(2953),
    [anon_sym_sizeof] = ACTIONS(2955),
    [sym_number_literal] = ACTIONS(4529),
    [sym_char_literal] = ACTIONS(4529),
    [sym_string_literal] = ACTIONS(2957),
    [sym_true] = ACTIONS(4533),
    [sym_false] = ACTIONS(4533),
    [sym_null] = ACTIONS(4533),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(2961),
    [anon_sym_delete] = ACTIONS(2963),
    [sym_nullptr] = ACTIONS(4533),
  },
  [1443] = {
    [sym_argument_list] = STATE(802),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_RPAREN] = ACTIONS(4535),
    [anon_sym_STAR] = ACTIONS(4537),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_EQ] = ACTIONS(4539),
    [anon_sym_QMARK] = ACTIONS(4541),
    [anon_sym_STAR_EQ] = ACTIONS(4543),
    [anon_sym_SLASH_EQ] = ACTIONS(4543),
    [anon_sym_PERCENT_EQ] = ACTIONS(4543),
    [anon_sym_PLUS_EQ] = ACTIONS(4543),
    [anon_sym_DASH_EQ] = ACTIONS(4543),
    [anon_sym_LT_LT_EQ] = ACTIONS(4543),
    [anon_sym_GT_GT_EQ] = ACTIONS(4543),
    [anon_sym_AMP_EQ] = ACTIONS(4543),
    [anon_sym_CARET_EQ] = ACTIONS(4543),
    [anon_sym_PIPE_EQ] = ACTIONS(4543),
    [anon_sym_AMP] = ACTIONS(4545),
    [anon_sym_PIPE_PIPE] = ACTIONS(4547),
    [anon_sym_AMP_AMP] = ACTIONS(4549),
    [anon_sym_PIPE] = ACTIONS(4551),
    [anon_sym_CARET] = ACTIONS(4553),
    [anon_sym_EQ_EQ] = ACTIONS(4555),
    [anon_sym_BANG_EQ] = ACTIONS(4555),
    [anon_sym_LT] = ACTIONS(4557),
    [anon_sym_GT] = ACTIONS(4557),
    [anon_sym_LT_EQ] = ACTIONS(4559),
    [anon_sym_GT_EQ] = ACTIONS(4559),
    [anon_sym_LT_LT] = ACTIONS(4561),
    [anon_sym_GT_GT] = ACTIONS(4561),
    [anon_sym_PLUS] = ACTIONS(4563),
    [anon_sym_DASH] = ACTIONS(4563),
    [anon_sym_SLASH] = ACTIONS(4537),
    [anon_sym_PERCENT] = ACTIONS(4537),
    [anon_sym_DASH_DASH] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(1554),
    [anon_sym_DASH_GT] = ACTIONS(1554),
    [sym_comment] = ACTIONS(49),
  },
  [1444] = {
    [sym__expression] = STATE(2017),
    [sym_conditional_expression] = STATE(2017),
    [sym_assignment_expression] = STATE(2017),
    [sym_pointer_expression] = STATE(2017),
    [sym_logical_expression] = STATE(2017),
    [sym_bitwise_expression] = STATE(2017),
    [sym_equality_expression] = STATE(2017),
    [sym_relational_expression] = STATE(2017),
    [sym_shift_expression] = STATE(2017),
    [sym_math_expression] = STATE(2017),
    [sym_cast_expression] = STATE(2017),
    [sym_sizeof_expression] = STATE(2017),
    [sym_subscript_expression] = STATE(2017),
    [sym_call_expression] = STATE(2017),
    [sym_field_expression] = STATE(2017),
    [sym_compound_literal_expression] = STATE(2017),
    [sym_parenthesized_expression] = STATE(2017),
    [sym_concatenated_string] = STATE(2017),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(2017),
    [sym_new_expression] = STATE(2017),
    [sym_delete_expression] = STATE(2017),
    [sym_lambda_expression] = STATE(2017),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(4565),
    [anon_sym_LPAREN] = ACTIONS(2943),
    [anon_sym_STAR] = ACTIONS(2945),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_AMP] = ACTIONS(2945),
    [anon_sym_BANG] = ACTIONS(2947),
    [anon_sym_TILDE] = ACTIONS(2949),
    [anon_sym_PLUS] = ACTIONS(2951),
    [anon_sym_DASH] = ACTIONS(2951),
    [anon_sym_DASH_DASH] = ACTIONS(2953),
    [anon_sym_PLUS_PLUS] = ACTIONS(2953),
    [anon_sym_sizeof] = ACTIONS(2955),
    [sym_number_literal] = ACTIONS(4565),
    [sym_char_literal] = ACTIONS(4565),
    [sym_string_literal] = ACTIONS(2957),
    [sym_true] = ACTIONS(4567),
    [sym_false] = ACTIONS(4567),
    [sym_null] = ACTIONS(4567),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(2961),
    [anon_sym_delete] = ACTIONS(2963),
    [sym_nullptr] = ACTIONS(4567),
  },
  [1445] = {
    [sym_argument_list] = STATE(802),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_RPAREN] = ACTIONS(4569),
    [anon_sym_STAR] = ACTIONS(4537),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_EQ] = ACTIONS(4539),
    [anon_sym_QMARK] = ACTIONS(4541),
    [anon_sym_STAR_EQ] = ACTIONS(4543),
    [anon_sym_SLASH_EQ] = ACTIONS(4543),
    [anon_sym_PERCENT_EQ] = ACTIONS(4543),
    [anon_sym_PLUS_EQ] = ACTIONS(4543),
    [anon_sym_DASH_EQ] = ACTIONS(4543),
    [anon_sym_LT_LT_EQ] = ACTIONS(4543),
    [anon_sym_GT_GT_EQ] = ACTIONS(4543),
    [anon_sym_AMP_EQ] = ACTIONS(4543),
    [anon_sym_CARET_EQ] = ACTIONS(4543),
    [anon_sym_PIPE_EQ] = ACTIONS(4543),
    [anon_sym_AMP] = ACTIONS(4545),
    [anon_sym_PIPE_PIPE] = ACTIONS(4547),
    [anon_sym_AMP_AMP] = ACTIONS(4549),
    [anon_sym_PIPE] = ACTIONS(4551),
    [anon_sym_CARET] = ACTIONS(4553),
    [anon_sym_EQ_EQ] = ACTIONS(4555),
    [anon_sym_BANG_EQ] = ACTIONS(4555),
    [anon_sym_LT] = ACTIONS(4557),
    [anon_sym_GT] = ACTIONS(4557),
    [anon_sym_LT_EQ] = ACTIONS(4559),
    [anon_sym_GT_EQ] = ACTIONS(4559),
    [anon_sym_LT_LT] = ACTIONS(4561),
    [anon_sym_GT_GT] = ACTIONS(4561),
    [anon_sym_PLUS] = ACTIONS(4563),
    [anon_sym_DASH] = ACTIONS(4563),
    [anon_sym_SLASH] = ACTIONS(4537),
    [anon_sym_PERCENT] = ACTIONS(4537),
    [anon_sym_DASH_DASH] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(1554),
    [anon_sym_DASH_GT] = ACTIONS(1554),
    [sym_comment] = ACTIONS(49),
  },
  [1446] = {
    [anon_sym_RPAREN] = ACTIONS(4571),
    [sym_comment] = ACTIONS(49),
  },
  [1447] = {
    [sym_argument_list] = STATE(802),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_STAR] = ACTIONS(2622),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_EQ] = ACTIONS(2622),
    [anon_sym_COLON] = ACTIONS(2620),
    [anon_sym_QMARK] = ACTIONS(2620),
    [anon_sym_STAR_EQ] = ACTIONS(2620),
    [anon_sym_SLASH_EQ] = ACTIONS(2620),
    [anon_sym_PERCENT_EQ] = ACTIONS(2620),
    [anon_sym_PLUS_EQ] = ACTIONS(2620),
    [anon_sym_DASH_EQ] = ACTIONS(2620),
    [anon_sym_LT_LT_EQ] = ACTIONS(2620),
    [anon_sym_GT_GT_EQ] = ACTIONS(2620),
    [anon_sym_AMP_EQ] = ACTIONS(2620),
    [anon_sym_CARET_EQ] = ACTIONS(2620),
    [anon_sym_PIPE_EQ] = ACTIONS(2620),
    [anon_sym_AMP] = ACTIONS(2622),
    [anon_sym_PIPE_PIPE] = ACTIONS(2620),
    [anon_sym_AMP_AMP] = ACTIONS(2620),
    [anon_sym_PIPE] = ACTIONS(2622),
    [anon_sym_CARET] = ACTIONS(2622),
    [anon_sym_EQ_EQ] = ACTIONS(2620),
    [anon_sym_BANG_EQ] = ACTIONS(2620),
    [anon_sym_LT] = ACTIONS(2622),
    [anon_sym_GT] = ACTIONS(2622),
    [anon_sym_LT_EQ] = ACTIONS(2620),
    [anon_sym_GT_EQ] = ACTIONS(2620),
    [anon_sym_LT_LT] = ACTIONS(2622),
    [anon_sym_GT_GT] = ACTIONS(2622),
    [anon_sym_PLUS] = ACTIONS(2622),
    [anon_sym_DASH] = ACTIONS(2622),
    [anon_sym_SLASH] = ACTIONS(2622),
    [anon_sym_PERCENT] = ACTIONS(2622),
    [anon_sym_DASH_DASH] = ACTIONS(2620),
    [anon_sym_PLUS_PLUS] = ACTIONS(2620),
    [anon_sym_DOT] = ACTIONS(3033),
    [anon_sym_DASH_GT] = ACTIONS(3033),
    [sym_comment] = ACTIONS(49),
  },
  [1448] = {
    [sym_argument_list] = STATE(802),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_STAR] = ACTIONS(2692),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_EQ] = ACTIONS(2692),
    [anon_sym_COLON] = ACTIONS(2690),
    [anon_sym_QMARK] = ACTIONS(2690),
    [anon_sym_STAR_EQ] = ACTIONS(2690),
    [anon_sym_SLASH_EQ] = ACTIONS(2690),
    [anon_sym_PERCENT_EQ] = ACTIONS(2690),
    [anon_sym_PLUS_EQ] = ACTIONS(2690),
    [anon_sym_DASH_EQ] = ACTIONS(2690),
    [anon_sym_LT_LT_EQ] = ACTIONS(2690),
    [anon_sym_GT_GT_EQ] = ACTIONS(2690),
    [anon_sym_AMP_EQ] = ACTIONS(2690),
    [anon_sym_CARET_EQ] = ACTIONS(2690),
    [anon_sym_PIPE_EQ] = ACTIONS(2690),
    [anon_sym_AMP] = ACTIONS(2692),
    [anon_sym_PIPE_PIPE] = ACTIONS(2690),
    [anon_sym_AMP_AMP] = ACTIONS(2690),
    [anon_sym_PIPE] = ACTIONS(2692),
    [anon_sym_CARET] = ACTIONS(2692),
    [anon_sym_EQ_EQ] = ACTIONS(2690),
    [anon_sym_BANG_EQ] = ACTIONS(2690),
    [anon_sym_LT] = ACTIONS(2692),
    [anon_sym_GT] = ACTIONS(2692),
    [anon_sym_LT_EQ] = ACTIONS(2690),
    [anon_sym_GT_EQ] = ACTIONS(2690),
    [anon_sym_LT_LT] = ACTIONS(2692),
    [anon_sym_GT_GT] = ACTIONS(2692),
    [anon_sym_PLUS] = ACTIONS(2692),
    [anon_sym_DASH] = ACTIONS(2692),
    [anon_sym_SLASH] = ACTIONS(2692),
    [anon_sym_PERCENT] = ACTIONS(2692),
    [anon_sym_DASH_DASH] = ACTIONS(2690),
    [anon_sym_PLUS_PLUS] = ACTIONS(2690),
    [anon_sym_DOT] = ACTIONS(3033),
    [anon_sym_DASH_GT] = ACTIONS(3033),
    [sym_comment] = ACTIONS(49),
  },
  [1449] = {
    [sym_argument_list] = STATE(802),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_STAR] = ACTIONS(2696),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_EQ] = ACTIONS(2696),
    [anon_sym_COLON] = ACTIONS(2694),
    [anon_sym_QMARK] = ACTIONS(2694),
    [anon_sym_STAR_EQ] = ACTIONS(2694),
    [anon_sym_SLASH_EQ] = ACTIONS(2694),
    [anon_sym_PERCENT_EQ] = ACTIONS(2694),
    [anon_sym_PLUS_EQ] = ACTIONS(2694),
    [anon_sym_DASH_EQ] = ACTIONS(2694),
    [anon_sym_LT_LT_EQ] = ACTIONS(2694),
    [anon_sym_GT_GT_EQ] = ACTIONS(2694),
    [anon_sym_AMP_EQ] = ACTIONS(2694),
    [anon_sym_CARET_EQ] = ACTIONS(2694),
    [anon_sym_PIPE_EQ] = ACTIONS(2694),
    [anon_sym_AMP] = ACTIONS(2696),
    [anon_sym_PIPE_PIPE] = ACTIONS(2694),
    [anon_sym_AMP_AMP] = ACTIONS(2694),
    [anon_sym_PIPE] = ACTIONS(2696),
    [anon_sym_CARET] = ACTIONS(2696),
    [anon_sym_EQ_EQ] = ACTIONS(2694),
    [anon_sym_BANG_EQ] = ACTIONS(2694),
    [anon_sym_LT] = ACTIONS(2696),
    [anon_sym_GT] = ACTIONS(2696),
    [anon_sym_LT_EQ] = ACTIONS(2694),
    [anon_sym_GT_EQ] = ACTIONS(2694),
    [anon_sym_LT_LT] = ACTIONS(2696),
    [anon_sym_GT_GT] = ACTIONS(2696),
    [anon_sym_PLUS] = ACTIONS(2696),
    [anon_sym_DASH] = ACTIONS(2696),
    [anon_sym_SLASH] = ACTIONS(2696),
    [anon_sym_PERCENT] = ACTIONS(2696),
    [anon_sym_DASH_DASH] = ACTIONS(2694),
    [anon_sym_PLUS_PLUS] = ACTIONS(2694),
    [anon_sym_DOT] = ACTIONS(3033),
    [anon_sym_DASH_GT] = ACTIONS(3033),
    [sym_comment] = ACTIONS(49),
  },
  [1450] = {
    [sym_argument_list] = STATE(802),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_STAR] = ACTIONS(2700),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_EQ] = ACTIONS(2700),
    [anon_sym_COLON] = ACTIONS(2698),
    [anon_sym_QMARK] = ACTIONS(2698),
    [anon_sym_STAR_EQ] = ACTIONS(2698),
    [anon_sym_SLASH_EQ] = ACTIONS(2698),
    [anon_sym_PERCENT_EQ] = ACTIONS(2698),
    [anon_sym_PLUS_EQ] = ACTIONS(2698),
    [anon_sym_DASH_EQ] = ACTIONS(2698),
    [anon_sym_LT_LT_EQ] = ACTIONS(2698),
    [anon_sym_GT_GT_EQ] = ACTIONS(2698),
    [anon_sym_AMP_EQ] = ACTIONS(2698),
    [anon_sym_CARET_EQ] = ACTIONS(2698),
    [anon_sym_PIPE_EQ] = ACTIONS(2698),
    [anon_sym_AMP] = ACTIONS(2700),
    [anon_sym_PIPE_PIPE] = ACTIONS(2698),
    [anon_sym_AMP_AMP] = ACTIONS(2698),
    [anon_sym_PIPE] = ACTIONS(2700),
    [anon_sym_CARET] = ACTIONS(2700),
    [anon_sym_EQ_EQ] = ACTIONS(2698),
    [anon_sym_BANG_EQ] = ACTIONS(2698),
    [anon_sym_LT] = ACTIONS(2700),
    [anon_sym_GT] = ACTIONS(2700),
    [anon_sym_LT_EQ] = ACTIONS(2698),
    [anon_sym_GT_EQ] = ACTIONS(2698),
    [anon_sym_LT_LT] = ACTIONS(2700),
    [anon_sym_GT_GT] = ACTIONS(2700),
    [anon_sym_PLUS] = ACTIONS(2700),
    [anon_sym_DASH] = ACTIONS(2700),
    [anon_sym_SLASH] = ACTIONS(2700),
    [anon_sym_PERCENT] = ACTIONS(2700),
    [anon_sym_DASH_DASH] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(3033),
    [anon_sym_DASH_GT] = ACTIONS(3033),
    [sym_comment] = ACTIONS(49),
  },
  [1451] = {
    [sym_type_qualifier] = STATE(724),
    [sym__type_specifier] = STATE(720),
    [sym_sized_type_specifier] = STATE(720),
    [sym_enum_specifier] = STATE(720),
    [sym_struct_specifier] = STATE(720),
    [sym_union_specifier] = STATE(720),
    [sym__expression] = STATE(721),
    [sym_comma_expression] = STATE(722),
    [sym_conditional_expression] = STATE(721),
    [sym_assignment_expression] = STATE(721),
    [sym_pointer_expression] = STATE(721),
    [sym_logical_expression] = STATE(721),
    [sym_bitwise_expression] = STATE(721),
    [sym_equality_expression] = STATE(721),
    [sym_relational_expression] = STATE(721),
    [sym_shift_expression] = STATE(721),
    [sym_math_expression] = STATE(721),
    [sym_cast_expression] = STATE(721),
    [sym_type_descriptor] = STATE(2020),
    [sym_sizeof_expression] = STATE(721),
    [sym_subscript_expression] = STATE(721),
    [sym_call_expression] = STATE(721),
    [sym_field_expression] = STATE(721),
    [sym_compound_literal_expression] = STATE(721),
    [sym_parenthesized_expression] = STATE(721),
    [sym_concatenated_string] = STATE(721),
    [sym_macro_type_specifier] = STATE(720),
    [sym_class_specifier] = STATE(720),
    [sym_dependent_type] = STATE(720),
    [sym_template_type] = STATE(415),
    [sym_template_function] = STATE(721),
    [sym_new_expression] = STATE(721),
    [sym_delete_expression] = STATE(721),
    [sym_lambda_expression] = STATE(721),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(416),
    [sym_scoped_namespace_identifier] = STATE(417),
    [aux_sym_type_definition_repeat1] = STATE(724),
    [aux_sym_sized_type_specifier_repeat1] = STATE(725),
    [sym_raw_string_literal] = ACTIONS(1397),
    [anon_sym_LPAREN] = ACTIONS(1087),
    [anon_sym_STAR] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_restrict] = ACTIONS(93),
    [anon_sym_volatile] = ACTIONS(93),
    [anon_sym__Atomic] = ACTIONS(93),
    [anon_sym_mutable] = ACTIONS(93),
    [anon_sym_explicit] = ACTIONS(93),
    [anon_sym_constexpr] = ACTIONS(93),
    [anon_sym_unsigned] = ACTIONS(1399),
    [anon_sym_long] = ACTIONS(1399),
    [anon_sym_short] = ACTIONS(1399),
    [sym_primitive_type] = ACTIONS(1401),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(428),
    [anon_sym_union] = ACTIONS(430),
    [anon_sym_AMP] = ACTIONS(1089),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1093),
    [anon_sym_PLUS] = ACTIONS(1095),
    [anon_sym_DASH] = ACTIONS(1095),
    [anon_sym_DASH_DASH] = ACTIONS(1097),
    [anon_sym_PLUS_PLUS] = ACTIONS(1097),
    [anon_sym_sizeof] = ACTIONS(1099),
    [sym_number_literal] = ACTIONS(1397),
    [sym_char_literal] = ACTIONS(1397),
    [sym_string_literal] = ACTIONS(1101),
    [sym_true] = ACTIONS(1403),
    [sym_false] = ACTIONS(1403),
    [sym_null] = ACTIONS(1403),
    [sym_identifier] = ACTIONS(1405),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(436),
    [sym_auto] = ACTIONS(1401),
    [anon_sym_typename] = ACTIONS(1407),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1409),
    [anon_sym_delete] = ACTIONS(1109),
    [sym_nullptr] = ACTIONS(1403),
  },
  [1452] = {
    [sym_argument_list] = STATE(802),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_STAR] = ACTIONS(3003),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_EQ] = ACTIONS(2704),
    [anon_sym_COLON] = ACTIONS(2702),
    [anon_sym_QMARK] = ACTIONS(2702),
    [anon_sym_STAR_EQ] = ACTIONS(2702),
    [anon_sym_SLASH_EQ] = ACTIONS(2702),
    [anon_sym_PERCENT_EQ] = ACTIONS(2702),
    [anon_sym_PLUS_EQ] = ACTIONS(2702),
    [anon_sym_DASH_EQ] = ACTIONS(2702),
    [anon_sym_LT_LT_EQ] = ACTIONS(2702),
    [anon_sym_GT_GT_EQ] = ACTIONS(2702),
    [anon_sym_AMP_EQ] = ACTIONS(2702),
    [anon_sym_CARET_EQ] = ACTIONS(2702),
    [anon_sym_PIPE_EQ] = ACTIONS(2702),
    [anon_sym_AMP] = ACTIONS(2704),
    [anon_sym_PIPE_PIPE] = ACTIONS(2702),
    [anon_sym_AMP_AMP] = ACTIONS(2702),
    [anon_sym_PIPE] = ACTIONS(2704),
    [anon_sym_CARET] = ACTIONS(2704),
    [anon_sym_EQ_EQ] = ACTIONS(2702),
    [anon_sym_BANG_EQ] = ACTIONS(2702),
    [anon_sym_LT] = ACTIONS(2704),
    [anon_sym_GT] = ACTIONS(2704),
    [anon_sym_LT_EQ] = ACTIONS(2702),
    [anon_sym_GT_EQ] = ACTIONS(2702),
    [anon_sym_LT_LT] = ACTIONS(3029),
    [anon_sym_GT_GT] = ACTIONS(3029),
    [anon_sym_PLUS] = ACTIONS(3031),
    [anon_sym_DASH] = ACTIONS(3031),
    [anon_sym_SLASH] = ACTIONS(3003),
    [anon_sym_PERCENT] = ACTIONS(3003),
    [anon_sym_DASH_DASH] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(3033),
    [anon_sym_DASH_GT] = ACTIONS(3033),
    [sym_comment] = ACTIONS(49),
  },
  [1453] = {
    [aux_sym_concatenated_string_repeat1] = STATE(2021),
    [anon_sym_LPAREN] = ACTIONS(2706),
    [anon_sym_STAR] = ACTIONS(2708),
    [anon_sym_LBRACK] = ACTIONS(2706),
    [anon_sym_EQ] = ACTIONS(2708),
    [anon_sym_COLON] = ACTIONS(2706),
    [anon_sym_QMARK] = ACTIONS(2706),
    [anon_sym_STAR_EQ] = ACTIONS(2706),
    [anon_sym_SLASH_EQ] = ACTIONS(2706),
    [anon_sym_PERCENT_EQ] = ACTIONS(2706),
    [anon_sym_PLUS_EQ] = ACTIONS(2706),
    [anon_sym_DASH_EQ] = ACTIONS(2706),
    [anon_sym_LT_LT_EQ] = ACTIONS(2706),
    [anon_sym_GT_GT_EQ] = ACTIONS(2706),
    [anon_sym_AMP_EQ] = ACTIONS(2706),
    [anon_sym_CARET_EQ] = ACTIONS(2706),
    [anon_sym_PIPE_EQ] = ACTIONS(2706),
    [anon_sym_AMP] = ACTIONS(2708),
    [anon_sym_PIPE_PIPE] = ACTIONS(2706),
    [anon_sym_AMP_AMP] = ACTIONS(2706),
    [anon_sym_PIPE] = ACTIONS(2708),
    [anon_sym_CARET] = ACTIONS(2708),
    [anon_sym_EQ_EQ] = ACTIONS(2706),
    [anon_sym_BANG_EQ] = ACTIONS(2706),
    [anon_sym_LT] = ACTIONS(2708),
    [anon_sym_GT] = ACTIONS(2708),
    [anon_sym_LT_EQ] = ACTIONS(2706),
    [anon_sym_GT_EQ] = ACTIONS(2706),
    [anon_sym_LT_LT] = ACTIONS(2708),
    [anon_sym_GT_GT] = ACTIONS(2708),
    [anon_sym_PLUS] = ACTIONS(2708),
    [anon_sym_DASH] = ACTIONS(2708),
    [anon_sym_SLASH] = ACTIONS(2708),
    [anon_sym_PERCENT] = ACTIONS(2708),
    [anon_sym_DASH_DASH] = ACTIONS(2706),
    [anon_sym_PLUS_PLUS] = ACTIONS(2706),
    [anon_sym_DOT] = ACTIONS(2706),
    [anon_sym_DASH_GT] = ACTIONS(2706),
    [sym_string_literal] = ACTIONS(4573),
    [sym_comment] = ACTIONS(49),
  },
  [1454] = {
    [sym__expression] = STATE(2023),
    [sym_conditional_expression] = STATE(2023),
    [sym_assignment_expression] = STATE(2023),
    [sym_pointer_expression] = STATE(2023),
    [sym_logical_expression] = STATE(2023),
    [sym_bitwise_expression] = STATE(2023),
    [sym_equality_expression] = STATE(2023),
    [sym_relational_expression] = STATE(2023),
    [sym_shift_expression] = STATE(2023),
    [sym_math_expression] = STATE(2023),
    [sym_cast_expression] = STATE(2023),
    [sym_sizeof_expression] = STATE(2023),
    [sym_subscript_expression] = STATE(2023),
    [sym_call_expression] = STATE(2023),
    [sym_field_expression] = STATE(2023),
    [sym_compound_literal_expression] = STATE(2023),
    [sym_parenthesized_expression] = STATE(2023),
    [sym_concatenated_string] = STATE(2023),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(2023),
    [sym_new_expression] = STATE(2023),
    [sym_delete_expression] = STATE(2023),
    [sym_lambda_expression] = STATE(2023),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(855),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(4575),
    [anon_sym_LPAREN] = ACTIONS(1634),
    [anon_sym_STAR] = ACTIONS(1636),
    [anon_sym_LBRACK] = ACTIONS(4577),
    [anon_sym_AMP] = ACTIONS(1636),
    [anon_sym_BANG] = ACTIONS(1638),
    [anon_sym_TILDE] = ACTIONS(1640),
    [anon_sym_PLUS] = ACTIONS(1642),
    [anon_sym_DASH] = ACTIONS(1642),
    [anon_sym_DASH_DASH] = ACTIONS(1644),
    [anon_sym_PLUS_PLUS] = ACTIONS(1644),
    [anon_sym_sizeof] = ACTIONS(1646),
    [sym_number_literal] = ACTIONS(4575),
    [sym_char_literal] = ACTIONS(4575),
    [sym_string_literal] = ACTIONS(1648),
    [sym_true] = ACTIONS(4579),
    [sym_false] = ACTIONS(4579),
    [sym_null] = ACTIONS(4579),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1652),
    [anon_sym_delete] = ACTIONS(1654),
    [sym_nullptr] = ACTIONS(4579),
  },
  [1455] = {
    [sym__expression] = STATE(740),
    [sym_conditional_expression] = STATE(740),
    [sym_assignment_expression] = STATE(740),
    [sym_pointer_expression] = STATE(740),
    [sym_logical_expression] = STATE(740),
    [sym_bitwise_expression] = STATE(740),
    [sym_equality_expression] = STATE(740),
    [sym_relational_expression] = STATE(740),
    [sym_shift_expression] = STATE(740),
    [sym_math_expression] = STATE(740),
    [sym_cast_expression] = STATE(740),
    [sym_sizeof_expression] = STATE(740),
    [sym_subscript_expression] = STATE(740),
    [sym_call_expression] = STATE(740),
    [sym_field_expression] = STATE(740),
    [sym_compound_literal_expression] = STATE(740),
    [sym_parenthesized_expression] = STATE(740),
    [sym_concatenated_string] = STATE(740),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(740),
    [sym_new_expression] = STATE(740),
    [sym_delete_expression] = STATE(740),
    [sym_lambda_expression] = STATE(740),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_lambda_default_capture] = STATE(741),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(1417),
    [anon_sym_LPAREN] = ACTIONS(1419),
    [anon_sym_STAR] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_RBRACK] = ACTIONS(4581),
    [anon_sym_EQ] = ACTIONS(1425),
    [anon_sym_AMP] = ACTIONS(1427),
    [anon_sym_BANG] = ACTIONS(1429),
    [anon_sym_TILDE] = ACTIONS(1431),
    [anon_sym_PLUS] = ACTIONS(1433),
    [anon_sym_DASH] = ACTIONS(1433),
    [anon_sym_DASH_DASH] = ACTIONS(1435),
    [anon_sym_PLUS_PLUS] = ACTIONS(1435),
    [anon_sym_sizeof] = ACTIONS(1437),
    [sym_number_literal] = ACTIONS(1417),
    [sym_char_literal] = ACTIONS(1417),
    [sym_string_literal] = ACTIONS(1439),
    [sym_true] = ACTIONS(1441),
    [sym_false] = ACTIONS(1441),
    [sym_null] = ACTIONS(1441),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1443),
    [anon_sym_delete] = ACTIONS(1445),
    [sym_nullptr] = ACTIONS(1441),
  },
  [1456] = {
    [sym_argument_list] = STATE(802),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_STAR] = ACTIONS(3003),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_EQ] = ACTIONS(2742),
    [anon_sym_COLON] = ACTIONS(2740),
    [anon_sym_QMARK] = ACTIONS(2740),
    [anon_sym_STAR_EQ] = ACTIONS(2740),
    [anon_sym_SLASH_EQ] = ACTIONS(2740),
    [anon_sym_PERCENT_EQ] = ACTIONS(2740),
    [anon_sym_PLUS_EQ] = ACTIONS(2740),
    [anon_sym_DASH_EQ] = ACTIONS(2740),
    [anon_sym_LT_LT_EQ] = ACTIONS(2740),
    [anon_sym_GT_GT_EQ] = ACTIONS(2740),
    [anon_sym_AMP_EQ] = ACTIONS(2740),
    [anon_sym_CARET_EQ] = ACTIONS(2740),
    [anon_sym_PIPE_EQ] = ACTIONS(2740),
    [anon_sym_AMP] = ACTIONS(3013),
    [anon_sym_PIPE_PIPE] = ACTIONS(3015),
    [anon_sym_AMP_AMP] = ACTIONS(3017),
    [anon_sym_PIPE] = ACTIONS(3019),
    [anon_sym_CARET] = ACTIONS(3021),
    [anon_sym_EQ_EQ] = ACTIONS(3023),
    [anon_sym_BANG_EQ] = ACTIONS(3023),
    [anon_sym_LT] = ACTIONS(3025),
    [anon_sym_GT] = ACTIONS(3025),
    [anon_sym_LT_EQ] = ACTIONS(3027),
    [anon_sym_GT_EQ] = ACTIONS(3027),
    [anon_sym_LT_LT] = ACTIONS(3029),
    [anon_sym_GT_GT] = ACTIONS(3029),
    [anon_sym_PLUS] = ACTIONS(3031),
    [anon_sym_DASH] = ACTIONS(3031),
    [anon_sym_SLASH] = ACTIONS(3003),
    [anon_sym_PERCENT] = ACTIONS(3003),
    [anon_sym_DASH_DASH] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(3033),
    [anon_sym_DASH_GT] = ACTIONS(3033),
    [sym_comment] = ACTIONS(49),
  },
  [1457] = {
    [sym__expression] = STATE(2025),
    [sym_conditional_expression] = STATE(2025),
    [sym_assignment_expression] = STATE(2025),
    [sym_pointer_expression] = STATE(2025),
    [sym_logical_expression] = STATE(2025),
    [sym_bitwise_expression] = STATE(2025),
    [sym_equality_expression] = STATE(2025),
    [sym_relational_expression] = STATE(2025),
    [sym_shift_expression] = STATE(2025),
    [sym_math_expression] = STATE(2025),
    [sym_cast_expression] = STATE(2025),
    [sym_sizeof_expression] = STATE(2025),
    [sym_subscript_expression] = STATE(2025),
    [sym_call_expression] = STATE(2025),
    [sym_field_expression] = STATE(2025),
    [sym_compound_literal_expression] = STATE(2025),
    [sym_parenthesized_expression] = STATE(2025),
    [sym_concatenated_string] = STATE(2025),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(2025),
    [sym_new_expression] = STATE(2025),
    [sym_delete_expression] = STATE(2025),
    [sym_lambda_expression] = STATE(2025),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(855),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(4583),
    [anon_sym_LPAREN] = ACTIONS(1634),
    [anon_sym_STAR] = ACTIONS(1636),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_AMP] = ACTIONS(1636),
    [anon_sym_BANG] = ACTIONS(1638),
    [anon_sym_TILDE] = ACTIONS(1640),
    [anon_sym_PLUS] = ACTIONS(1642),
    [anon_sym_DASH] = ACTIONS(1642),
    [anon_sym_DASH_DASH] = ACTIONS(1644),
    [anon_sym_PLUS_PLUS] = ACTIONS(1644),
    [anon_sym_sizeof] = ACTIONS(1646),
    [sym_number_literal] = ACTIONS(4583),
    [sym_char_literal] = ACTIONS(4583),
    [sym_string_literal] = ACTIONS(1648),
    [sym_true] = ACTIONS(4585),
    [sym_false] = ACTIONS(4585),
    [sym_null] = ACTIONS(4585),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1652),
    [anon_sym_delete] = ACTIONS(1654),
    [sym_nullptr] = ACTIONS(4585),
  },
  [1458] = {
    [sym__expression] = STATE(2026),
    [sym_conditional_expression] = STATE(2026),
    [sym_assignment_expression] = STATE(2026),
    [sym_pointer_expression] = STATE(2026),
    [sym_logical_expression] = STATE(2026),
    [sym_bitwise_expression] = STATE(2026),
    [sym_equality_expression] = STATE(2026),
    [sym_relational_expression] = STATE(2026),
    [sym_shift_expression] = STATE(2026),
    [sym_math_expression] = STATE(2026),
    [sym_cast_expression] = STATE(2026),
    [sym_sizeof_expression] = STATE(2026),
    [sym_subscript_expression] = STATE(2026),
    [sym_call_expression] = STATE(2026),
    [sym_field_expression] = STATE(2026),
    [sym_compound_literal_expression] = STATE(2026),
    [sym_parenthesized_expression] = STATE(2026),
    [sym_concatenated_string] = STATE(2026),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(2026),
    [sym_new_expression] = STATE(2026),
    [sym_delete_expression] = STATE(2026),
    [sym_lambda_expression] = STATE(2026),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(855),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(4587),
    [anon_sym_LPAREN] = ACTIONS(1634),
    [anon_sym_STAR] = ACTIONS(1636),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_AMP] = ACTIONS(1636),
    [anon_sym_BANG] = ACTIONS(1638),
    [anon_sym_TILDE] = ACTIONS(1640),
    [anon_sym_PLUS] = ACTIONS(1642),
    [anon_sym_DASH] = ACTIONS(1642),
    [anon_sym_DASH_DASH] = ACTIONS(1644),
    [anon_sym_PLUS_PLUS] = ACTIONS(1644),
    [anon_sym_sizeof] = ACTIONS(1646),
    [sym_number_literal] = ACTIONS(4587),
    [sym_char_literal] = ACTIONS(4587),
    [sym_string_literal] = ACTIONS(1648),
    [sym_true] = ACTIONS(4589),
    [sym_false] = ACTIONS(4589),
    [sym_null] = ACTIONS(4589),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1652),
    [anon_sym_delete] = ACTIONS(1654),
    [sym_nullptr] = ACTIONS(4589),
  },
  [1459] = {
    [sym_declaration] = STATE(2027),
    [sym_type_definition] = STATE(2027),
    [sym__declaration_specifiers] = STATE(1474),
    [sym_compound_statement] = STATE(2027),
    [sym_storage_class_specifier] = STATE(109),
    [sym_type_qualifier] = STATE(109),
    [sym__type_specifier] = STATE(105),
    [sym_sized_type_specifier] = STATE(105),
    [sym_enum_specifier] = STATE(105),
    [sym_struct_specifier] = STATE(105),
    [sym_union_specifier] = STATE(105),
    [sym_labeled_statement] = STATE(2027),
    [sym_expression_statement] = STATE(2027),
    [sym_if_statement] = STATE(2027),
    [sym_switch_statement] = STATE(2027),
    [sym_case_statement] = STATE(2027),
    [sym_while_statement] = STATE(2027),
    [sym_do_statement] = STATE(2027),
    [sym_for_statement] = STATE(2027),
    [sym_return_statement] = STATE(2027),
    [sym_break_statement] = STATE(2027),
    [sym_continue_statement] = STATE(2027),
    [sym_goto_statement] = STATE(2027),
    [sym__expression] = STATE(413),
    [sym_comma_expression] = STATE(414),
    [sym_conditional_expression] = STATE(413),
    [sym_assignment_expression] = STATE(413),
    [sym_pointer_expression] = STATE(413),
    [sym_logical_expression] = STATE(413),
    [sym_bitwise_expression] = STATE(413),
    [sym_equality_expression] = STATE(413),
    [sym_relational_expression] = STATE(413),
    [sym_shift_expression] = STATE(413),
    [sym_math_expression] = STATE(413),
    [sym_cast_expression] = STATE(413),
    [sym_sizeof_expression] = STATE(413),
    [sym_subscript_expression] = STATE(413),
    [sym_call_expression] = STATE(413),
    [sym_field_expression] = STATE(413),
    [sym_compound_literal_expression] = STATE(413),
    [sym_parenthesized_expression] = STATE(413),
    [sym_concatenated_string] = STATE(413),
    [sym_macro_type_specifier] = STATE(105),
    [sym_class_specifier] = STATE(105),
    [sym_dependent_type] = STATE(105),
    [sym_template_type] = STATE(1475),
    [sym_template_function] = STATE(413),
    [sym_for_range_loop] = STATE(2027),
    [sym_new_expression] = STATE(413),
    [sym_delete_expression] = STATE(413),
    [sym_lambda_expression] = STATE(413),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(416),
    [sym_scoped_namespace_identifier] = STATE(1476),
    [aux_sym__declaration_specifiers_repeat1] = STATE(109),
    [aux_sym_sized_type_specifier_repeat1] = STATE(110),
    [sym_raw_string_literal] = ACTIONS(620),
    [anon_sym_LPAREN] = ACTIONS(626),
    [anon_sym_SEMI] = ACTIONS(636),
    [anon_sym_typedef] = ACTIONS(638),
    [anon_sym_extern] = ACTIONS(154),
    [anon_sym_LBRACE] = ACTIONS(640),
    [anon_sym_STAR] = ACTIONS(644),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_static] = ACTIONS(154),
    [anon_sym_register] = ACTIONS(154),
    [anon_sym_inline] = ACTIONS(154),
    [anon_sym_const] = ACTIONS(158),
    [anon_sym_restrict] = ACTIONS(158),
    [anon_sym_volatile] = ACTIONS(158),
    [anon_sym__Atomic] = ACTIONS(158),
    [anon_sym_mutable] = ACTIONS(158),
    [anon_sym_explicit] = ACTIONS(158),
    [anon_sym_constexpr] = ACTIONS(158),
    [anon_sym_unsigned] = ACTIONS(160),
    [anon_sym_long] = ACTIONS(160),
    [anon_sym_short] = ACTIONS(160),
    [sym_primitive_type] = ACTIONS(162),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_union] = ACTIONS(39),
    [anon_sym_if] = ACTIONS(646),
    [anon_sym_switch] = ACTIONS(648),
    [anon_sym_case] = ACTIONS(650),
    [anon_sym_default] = ACTIONS(652),
    [anon_sym_while] = ACTIONS(654),
    [anon_sym_do] = ACTIONS(656),
    [anon_sym_for] = ACTIONS(658),
    [anon_sym_return] = ACTIONS(660),
    [anon_sym_break] = ACTIONS(662),
    [anon_sym_continue] = ACTIONS(664),
    [anon_sym_goto] = ACTIONS(666),
    [anon_sym_AMP] = ACTIONS(644),
    [anon_sym_BANG] = ACTIONS(668),
    [anon_sym_TILDE] = ACTIONS(670),
    [anon_sym_PLUS] = ACTIONS(672),
    [anon_sym_DASH] = ACTIONS(672),
    [anon_sym_DASH_DASH] = ACTIONS(674),
    [anon_sym_PLUS_PLUS] = ACTIONS(674),
    [anon_sym_sizeof] = ACTIONS(676),
    [sym_number_literal] = ACTIONS(620),
    [sym_char_literal] = ACTIONS(620),
    [sym_string_literal] = ACTIONS(678),
    [sym_true] = ACTIONS(680),
    [sym_false] = ACTIONS(680),
    [sym_null] = ACTIONS(680),
    [sym_identifier] = ACTIONS(3038),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(51),
    [sym_auto] = ACTIONS(162),
    [anon_sym_typename] = ACTIONS(172),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(3040),
    [anon_sym_delete] = ACTIONS(686),
    [sym_nullptr] = ACTIONS(680),
  },
  [1460] = {
    [sym__expression] = STATE(2028),
    [sym_conditional_expression] = STATE(2028),
    [sym_assignment_expression] = STATE(2028),
    [sym_pointer_expression] = STATE(2028),
    [sym_logical_expression] = STATE(2028),
    [sym_bitwise_expression] = STATE(2028),
    [sym_equality_expression] = STATE(2028),
    [sym_relational_expression] = STATE(2028),
    [sym_shift_expression] = STATE(2028),
    [sym_math_expression] = STATE(2028),
    [sym_cast_expression] = STATE(2028),
    [sym_sizeof_expression] = STATE(2028),
    [sym_subscript_expression] = STATE(2028),
    [sym_call_expression] = STATE(2028),
    [sym_field_expression] = STATE(2028),
    [sym_compound_literal_expression] = STATE(2028),
    [sym_parenthesized_expression] = STATE(2028),
    [sym_concatenated_string] = STATE(2028),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(2028),
    [sym_new_expression] = STATE(2028),
    [sym_delete_expression] = STATE(2028),
    [sym_lambda_expression] = STATE(2028),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(855),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(4591),
    [anon_sym_LPAREN] = ACTIONS(1634),
    [anon_sym_STAR] = ACTIONS(1636),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_AMP] = ACTIONS(1636),
    [anon_sym_BANG] = ACTIONS(1638),
    [anon_sym_TILDE] = ACTIONS(1640),
    [anon_sym_PLUS] = ACTIONS(1642),
    [anon_sym_DASH] = ACTIONS(1642),
    [anon_sym_DASH_DASH] = ACTIONS(1644),
    [anon_sym_PLUS_PLUS] = ACTIONS(1644),
    [anon_sym_sizeof] = ACTIONS(1646),
    [sym_number_literal] = ACTIONS(4591),
    [sym_char_literal] = ACTIONS(4591),
    [sym_string_literal] = ACTIONS(1648),
    [sym_true] = ACTIONS(4593),
    [sym_false] = ACTIONS(4593),
    [sym_null] = ACTIONS(4593),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1652),
    [anon_sym_delete] = ACTIONS(1654),
    [sym_nullptr] = ACTIONS(4593),
  },
  [1461] = {
    [sym__expression] = STATE(2029),
    [sym_conditional_expression] = STATE(2029),
    [sym_assignment_expression] = STATE(2029),
    [sym_pointer_expression] = STATE(2029),
    [sym_logical_expression] = STATE(2029),
    [sym_bitwise_expression] = STATE(2029),
    [sym_equality_expression] = STATE(2029),
    [sym_relational_expression] = STATE(2029),
    [sym_shift_expression] = STATE(2029),
    [sym_math_expression] = STATE(2029),
    [sym_cast_expression] = STATE(2029),
    [sym_sizeof_expression] = STATE(2029),
    [sym_subscript_expression] = STATE(2029),
    [sym_call_expression] = STATE(2029),
    [sym_field_expression] = STATE(2029),
    [sym_compound_literal_expression] = STATE(2029),
    [sym_parenthesized_expression] = STATE(2029),
    [sym_concatenated_string] = STATE(2029),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(2029),
    [sym_new_expression] = STATE(2029),
    [sym_delete_expression] = STATE(2029),
    [sym_lambda_expression] = STATE(2029),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(855),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(4595),
    [anon_sym_LPAREN] = ACTIONS(1634),
    [anon_sym_STAR] = ACTIONS(1636),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_AMP] = ACTIONS(1636),
    [anon_sym_BANG] = ACTIONS(1638),
    [anon_sym_TILDE] = ACTIONS(1640),
    [anon_sym_PLUS] = ACTIONS(1642),
    [anon_sym_DASH] = ACTIONS(1642),
    [anon_sym_DASH_DASH] = ACTIONS(1644),
    [anon_sym_PLUS_PLUS] = ACTIONS(1644),
    [anon_sym_sizeof] = ACTIONS(1646),
    [sym_number_literal] = ACTIONS(4595),
    [sym_char_literal] = ACTIONS(4595),
    [sym_string_literal] = ACTIONS(1648),
    [sym_true] = ACTIONS(4597),
    [sym_false] = ACTIONS(4597),
    [sym_null] = ACTIONS(4597),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1652),
    [anon_sym_delete] = ACTIONS(1654),
    [sym_nullptr] = ACTIONS(4597),
  },
  [1462] = {
    [sym__expression] = STATE(2030),
    [sym_conditional_expression] = STATE(2030),
    [sym_assignment_expression] = STATE(2030),
    [sym_pointer_expression] = STATE(2030),
    [sym_logical_expression] = STATE(2030),
    [sym_bitwise_expression] = STATE(2030),
    [sym_equality_expression] = STATE(2030),
    [sym_relational_expression] = STATE(2030),
    [sym_shift_expression] = STATE(2030),
    [sym_math_expression] = STATE(2030),
    [sym_cast_expression] = STATE(2030),
    [sym_sizeof_expression] = STATE(2030),
    [sym_subscript_expression] = STATE(2030),
    [sym_call_expression] = STATE(2030),
    [sym_field_expression] = STATE(2030),
    [sym_compound_literal_expression] = STATE(2030),
    [sym_parenthesized_expression] = STATE(2030),
    [sym_concatenated_string] = STATE(2030),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(2030),
    [sym_new_expression] = STATE(2030),
    [sym_delete_expression] = STATE(2030),
    [sym_lambda_expression] = STATE(2030),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(855),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(4599),
    [anon_sym_LPAREN] = ACTIONS(1634),
    [anon_sym_STAR] = ACTIONS(1636),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_AMP] = ACTIONS(1636),
    [anon_sym_BANG] = ACTIONS(1638),
    [anon_sym_TILDE] = ACTIONS(1640),
    [anon_sym_PLUS] = ACTIONS(1642),
    [anon_sym_DASH] = ACTIONS(1642),
    [anon_sym_DASH_DASH] = ACTIONS(1644),
    [anon_sym_PLUS_PLUS] = ACTIONS(1644),
    [anon_sym_sizeof] = ACTIONS(1646),
    [sym_number_literal] = ACTIONS(4599),
    [sym_char_literal] = ACTIONS(4599),
    [sym_string_literal] = ACTIONS(1648),
    [sym_true] = ACTIONS(4601),
    [sym_false] = ACTIONS(4601),
    [sym_null] = ACTIONS(4601),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1652),
    [anon_sym_delete] = ACTIONS(1654),
    [sym_nullptr] = ACTIONS(4601),
  },
  [1463] = {
    [sym__expression] = STATE(2031),
    [sym_conditional_expression] = STATE(2031),
    [sym_assignment_expression] = STATE(2031),
    [sym_pointer_expression] = STATE(2031),
    [sym_logical_expression] = STATE(2031),
    [sym_bitwise_expression] = STATE(2031),
    [sym_equality_expression] = STATE(2031),
    [sym_relational_expression] = STATE(2031),
    [sym_shift_expression] = STATE(2031),
    [sym_math_expression] = STATE(2031),
    [sym_cast_expression] = STATE(2031),
    [sym_sizeof_expression] = STATE(2031),
    [sym_subscript_expression] = STATE(2031),
    [sym_call_expression] = STATE(2031),
    [sym_field_expression] = STATE(2031),
    [sym_compound_literal_expression] = STATE(2031),
    [sym_parenthesized_expression] = STATE(2031),
    [sym_concatenated_string] = STATE(2031),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(2031),
    [sym_new_expression] = STATE(2031),
    [sym_delete_expression] = STATE(2031),
    [sym_lambda_expression] = STATE(2031),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(855),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(4603),
    [anon_sym_LPAREN] = ACTIONS(1634),
    [anon_sym_STAR] = ACTIONS(1636),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_AMP] = ACTIONS(1636),
    [anon_sym_BANG] = ACTIONS(1638),
    [anon_sym_TILDE] = ACTIONS(1640),
    [anon_sym_PLUS] = ACTIONS(1642),
    [anon_sym_DASH] = ACTIONS(1642),
    [anon_sym_DASH_DASH] = ACTIONS(1644),
    [anon_sym_PLUS_PLUS] = ACTIONS(1644),
    [anon_sym_sizeof] = ACTIONS(1646),
    [sym_number_literal] = ACTIONS(4603),
    [sym_char_literal] = ACTIONS(4603),
    [sym_string_literal] = ACTIONS(1648),
    [sym_true] = ACTIONS(4605),
    [sym_false] = ACTIONS(4605),
    [sym_null] = ACTIONS(4605),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1652),
    [anon_sym_delete] = ACTIONS(1654),
    [sym_nullptr] = ACTIONS(4605),
  },
  [1464] = {
    [sym__expression] = STATE(2032),
    [sym_conditional_expression] = STATE(2032),
    [sym_assignment_expression] = STATE(2032),
    [sym_pointer_expression] = STATE(2032),
    [sym_logical_expression] = STATE(2032),
    [sym_bitwise_expression] = STATE(2032),
    [sym_equality_expression] = STATE(2032),
    [sym_relational_expression] = STATE(2032),
    [sym_shift_expression] = STATE(2032),
    [sym_math_expression] = STATE(2032),
    [sym_cast_expression] = STATE(2032),
    [sym_sizeof_expression] = STATE(2032),
    [sym_subscript_expression] = STATE(2032),
    [sym_call_expression] = STATE(2032),
    [sym_field_expression] = STATE(2032),
    [sym_compound_literal_expression] = STATE(2032),
    [sym_parenthesized_expression] = STATE(2032),
    [sym_concatenated_string] = STATE(2032),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(2032),
    [sym_new_expression] = STATE(2032),
    [sym_delete_expression] = STATE(2032),
    [sym_lambda_expression] = STATE(2032),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(855),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(4607),
    [anon_sym_LPAREN] = ACTIONS(1634),
    [anon_sym_STAR] = ACTIONS(1636),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_AMP] = ACTIONS(1636),
    [anon_sym_BANG] = ACTIONS(1638),
    [anon_sym_TILDE] = ACTIONS(1640),
    [anon_sym_PLUS] = ACTIONS(1642),
    [anon_sym_DASH] = ACTIONS(1642),
    [anon_sym_DASH_DASH] = ACTIONS(1644),
    [anon_sym_PLUS_PLUS] = ACTIONS(1644),
    [anon_sym_sizeof] = ACTIONS(1646),
    [sym_number_literal] = ACTIONS(4607),
    [sym_char_literal] = ACTIONS(4607),
    [sym_string_literal] = ACTIONS(1648),
    [sym_true] = ACTIONS(4609),
    [sym_false] = ACTIONS(4609),
    [sym_null] = ACTIONS(4609),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1652),
    [anon_sym_delete] = ACTIONS(1654),
    [sym_nullptr] = ACTIONS(4609),
  },
  [1465] = {
    [sym__expression] = STATE(2033),
    [sym_conditional_expression] = STATE(2033),
    [sym_assignment_expression] = STATE(2033),
    [sym_pointer_expression] = STATE(2033),
    [sym_logical_expression] = STATE(2033),
    [sym_bitwise_expression] = STATE(2033),
    [sym_equality_expression] = STATE(2033),
    [sym_relational_expression] = STATE(2033),
    [sym_shift_expression] = STATE(2033),
    [sym_math_expression] = STATE(2033),
    [sym_cast_expression] = STATE(2033),
    [sym_sizeof_expression] = STATE(2033),
    [sym_subscript_expression] = STATE(2033),
    [sym_call_expression] = STATE(2033),
    [sym_field_expression] = STATE(2033),
    [sym_compound_literal_expression] = STATE(2033),
    [sym_parenthesized_expression] = STATE(2033),
    [sym_concatenated_string] = STATE(2033),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(2033),
    [sym_new_expression] = STATE(2033),
    [sym_delete_expression] = STATE(2033),
    [sym_lambda_expression] = STATE(2033),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(855),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(4611),
    [anon_sym_LPAREN] = ACTIONS(1634),
    [anon_sym_STAR] = ACTIONS(1636),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_AMP] = ACTIONS(1636),
    [anon_sym_BANG] = ACTIONS(1638),
    [anon_sym_TILDE] = ACTIONS(1640),
    [anon_sym_PLUS] = ACTIONS(1642),
    [anon_sym_DASH] = ACTIONS(1642),
    [anon_sym_DASH_DASH] = ACTIONS(1644),
    [anon_sym_PLUS_PLUS] = ACTIONS(1644),
    [anon_sym_sizeof] = ACTIONS(1646),
    [sym_number_literal] = ACTIONS(4611),
    [sym_char_literal] = ACTIONS(4611),
    [sym_string_literal] = ACTIONS(1648),
    [sym_true] = ACTIONS(4613),
    [sym_false] = ACTIONS(4613),
    [sym_null] = ACTIONS(4613),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1652),
    [anon_sym_delete] = ACTIONS(1654),
    [sym_nullptr] = ACTIONS(4613),
  },
  [1466] = {
    [sym__expression] = STATE(2034),
    [sym_conditional_expression] = STATE(2034),
    [sym_assignment_expression] = STATE(2034),
    [sym_pointer_expression] = STATE(2034),
    [sym_logical_expression] = STATE(2034),
    [sym_bitwise_expression] = STATE(2034),
    [sym_equality_expression] = STATE(2034),
    [sym_relational_expression] = STATE(2034),
    [sym_shift_expression] = STATE(2034),
    [sym_math_expression] = STATE(2034),
    [sym_cast_expression] = STATE(2034),
    [sym_sizeof_expression] = STATE(2034),
    [sym_subscript_expression] = STATE(2034),
    [sym_call_expression] = STATE(2034),
    [sym_field_expression] = STATE(2034),
    [sym_compound_literal_expression] = STATE(2034),
    [sym_parenthesized_expression] = STATE(2034),
    [sym_concatenated_string] = STATE(2034),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(2034),
    [sym_new_expression] = STATE(2034),
    [sym_delete_expression] = STATE(2034),
    [sym_lambda_expression] = STATE(2034),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(855),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(4615),
    [anon_sym_LPAREN] = ACTIONS(1634),
    [anon_sym_STAR] = ACTIONS(1636),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_AMP] = ACTIONS(1636),
    [anon_sym_BANG] = ACTIONS(1638),
    [anon_sym_TILDE] = ACTIONS(1640),
    [anon_sym_PLUS] = ACTIONS(1642),
    [anon_sym_DASH] = ACTIONS(1642),
    [anon_sym_DASH_DASH] = ACTIONS(1644),
    [anon_sym_PLUS_PLUS] = ACTIONS(1644),
    [anon_sym_sizeof] = ACTIONS(1646),
    [sym_number_literal] = ACTIONS(4615),
    [sym_char_literal] = ACTIONS(4615),
    [sym_string_literal] = ACTIONS(1648),
    [sym_true] = ACTIONS(4617),
    [sym_false] = ACTIONS(4617),
    [sym_null] = ACTIONS(4617),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1652),
    [anon_sym_delete] = ACTIONS(1654),
    [sym_nullptr] = ACTIONS(4617),
  },
  [1467] = {
    [sym__expression] = STATE(2035),
    [sym_conditional_expression] = STATE(2035),
    [sym_assignment_expression] = STATE(2035),
    [sym_pointer_expression] = STATE(2035),
    [sym_logical_expression] = STATE(2035),
    [sym_bitwise_expression] = STATE(2035),
    [sym_equality_expression] = STATE(2035),
    [sym_relational_expression] = STATE(2035),
    [sym_shift_expression] = STATE(2035),
    [sym_math_expression] = STATE(2035),
    [sym_cast_expression] = STATE(2035),
    [sym_sizeof_expression] = STATE(2035),
    [sym_subscript_expression] = STATE(2035),
    [sym_call_expression] = STATE(2035),
    [sym_field_expression] = STATE(2035),
    [sym_compound_literal_expression] = STATE(2035),
    [sym_parenthesized_expression] = STATE(2035),
    [sym_concatenated_string] = STATE(2035),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(2035),
    [sym_new_expression] = STATE(2035),
    [sym_delete_expression] = STATE(2035),
    [sym_lambda_expression] = STATE(2035),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(855),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(4619),
    [anon_sym_LPAREN] = ACTIONS(1634),
    [anon_sym_STAR] = ACTIONS(1636),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_AMP] = ACTIONS(1636),
    [anon_sym_BANG] = ACTIONS(1638),
    [anon_sym_TILDE] = ACTIONS(1640),
    [anon_sym_PLUS] = ACTIONS(1642),
    [anon_sym_DASH] = ACTIONS(1642),
    [anon_sym_DASH_DASH] = ACTIONS(1644),
    [anon_sym_PLUS_PLUS] = ACTIONS(1644),
    [anon_sym_sizeof] = ACTIONS(1646),
    [sym_number_literal] = ACTIONS(4619),
    [sym_char_literal] = ACTIONS(4619),
    [sym_string_literal] = ACTIONS(1648),
    [sym_true] = ACTIONS(4621),
    [sym_false] = ACTIONS(4621),
    [sym_null] = ACTIONS(4621),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1652),
    [anon_sym_delete] = ACTIONS(1654),
    [sym_nullptr] = ACTIONS(4621),
  },
  [1468] = {
    [sym__expression] = STATE(2036),
    [sym_conditional_expression] = STATE(2036),
    [sym_assignment_expression] = STATE(2036),
    [sym_pointer_expression] = STATE(2036),
    [sym_logical_expression] = STATE(2036),
    [sym_bitwise_expression] = STATE(2036),
    [sym_equality_expression] = STATE(2036),
    [sym_relational_expression] = STATE(2036),
    [sym_shift_expression] = STATE(2036),
    [sym_math_expression] = STATE(2036),
    [sym_cast_expression] = STATE(2036),
    [sym_sizeof_expression] = STATE(2036),
    [sym_subscript_expression] = STATE(2036),
    [sym_call_expression] = STATE(2036),
    [sym_field_expression] = STATE(2036),
    [sym_compound_literal_expression] = STATE(2036),
    [sym_parenthesized_expression] = STATE(2036),
    [sym_concatenated_string] = STATE(2036),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(2036),
    [sym_new_expression] = STATE(2036),
    [sym_delete_expression] = STATE(2036),
    [sym_lambda_expression] = STATE(2036),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(855),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(4623),
    [anon_sym_LPAREN] = ACTIONS(1634),
    [anon_sym_STAR] = ACTIONS(1636),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_AMP] = ACTIONS(1636),
    [anon_sym_BANG] = ACTIONS(1638),
    [anon_sym_TILDE] = ACTIONS(1640),
    [anon_sym_PLUS] = ACTIONS(1642),
    [anon_sym_DASH] = ACTIONS(1642),
    [anon_sym_DASH_DASH] = ACTIONS(1644),
    [anon_sym_PLUS_PLUS] = ACTIONS(1644),
    [anon_sym_sizeof] = ACTIONS(1646),
    [sym_number_literal] = ACTIONS(4623),
    [sym_char_literal] = ACTIONS(4623),
    [sym_string_literal] = ACTIONS(1648),
    [sym_true] = ACTIONS(4625),
    [sym_false] = ACTIONS(4625),
    [sym_null] = ACTIONS(4625),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1652),
    [anon_sym_delete] = ACTIONS(1654),
    [sym_nullptr] = ACTIONS(4625),
  },
  [1469] = {
    [sym__expression] = STATE(2037),
    [sym_conditional_expression] = STATE(2037),
    [sym_assignment_expression] = STATE(2037),
    [sym_pointer_expression] = STATE(2037),
    [sym_logical_expression] = STATE(2037),
    [sym_bitwise_expression] = STATE(2037),
    [sym_equality_expression] = STATE(2037),
    [sym_relational_expression] = STATE(2037),
    [sym_shift_expression] = STATE(2037),
    [sym_math_expression] = STATE(2037),
    [sym_cast_expression] = STATE(2037),
    [sym_sizeof_expression] = STATE(2037),
    [sym_subscript_expression] = STATE(2037),
    [sym_call_expression] = STATE(2037),
    [sym_field_expression] = STATE(2037),
    [sym_compound_literal_expression] = STATE(2037),
    [sym_parenthesized_expression] = STATE(2037),
    [sym_concatenated_string] = STATE(2037),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(2037),
    [sym_new_expression] = STATE(2037),
    [sym_delete_expression] = STATE(2037),
    [sym_lambda_expression] = STATE(2037),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(855),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(4627),
    [anon_sym_LPAREN] = ACTIONS(1634),
    [anon_sym_STAR] = ACTIONS(1636),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_AMP] = ACTIONS(1636),
    [anon_sym_BANG] = ACTIONS(1638),
    [anon_sym_TILDE] = ACTIONS(1640),
    [anon_sym_PLUS] = ACTIONS(1642),
    [anon_sym_DASH] = ACTIONS(1642),
    [anon_sym_DASH_DASH] = ACTIONS(1644),
    [anon_sym_PLUS_PLUS] = ACTIONS(1644),
    [anon_sym_sizeof] = ACTIONS(1646),
    [sym_number_literal] = ACTIONS(4627),
    [sym_char_literal] = ACTIONS(4627),
    [sym_string_literal] = ACTIONS(1648),
    [sym_true] = ACTIONS(4629),
    [sym_false] = ACTIONS(4629),
    [sym_null] = ACTIONS(4629),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1652),
    [anon_sym_delete] = ACTIONS(1654),
    [sym_nullptr] = ACTIONS(4629),
  },
  [1470] = {
    [sym_template_type] = STATE(553),
    [sym_template_method] = STATE(1342),
    [sym_destructor_name] = STATE(1342),
    [sym_scoped_field_identifier] = STATE(554),
    [sym_scoped_type_identifier] = STATE(47),
    [sym_scoped_namespace_identifier] = STATE(553),
    [anon_sym_TILDE] = ACTIONS(1500),
    [sym_identifier] = ACTIONS(2800),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(1043),
  },
  [1471] = {
    [sym_initializer_list] = STATE(765),
    [sym_template_argument_list] = STATE(2039),
    [anon_sym_LPAREN] = ACTIONS(1483),
    [anon_sym_COMMA] = ACTIONS(1477),
    [anon_sym_SEMI] = ACTIONS(1477),
    [anon_sym_extern] = ACTIONS(144),
    [anon_sym_LBRACE] = ACTIONS(548),
    [anon_sym_STAR] = ACTIONS(1486),
    [anon_sym_LBRACK] = ACTIONS(1477),
    [anon_sym_EQ] = ACTIONS(1479),
    [anon_sym_static] = ACTIONS(144),
    [anon_sym_register] = ACTIONS(144),
    [anon_sym_inline] = ACTIONS(144),
    [anon_sym_const] = ACTIONS(144),
    [anon_sym_restrict] = ACTIONS(144),
    [anon_sym_volatile] = ACTIONS(144),
    [anon_sym__Atomic] = ACTIONS(144),
    [anon_sym_mutable] = ACTIONS(144),
    [anon_sym_explicit] = ACTIONS(144),
    [anon_sym_constexpr] = ACTIONS(144),
    [anon_sym_COLON] = ACTIONS(1714),
    [anon_sym_QMARK] = ACTIONS(1477),
    [anon_sym_STAR_EQ] = ACTIONS(1477),
    [anon_sym_SLASH_EQ] = ACTIONS(1477),
    [anon_sym_PERCENT_EQ] = ACTIONS(1477),
    [anon_sym_PLUS_EQ] = ACTIONS(1477),
    [anon_sym_DASH_EQ] = ACTIONS(1477),
    [anon_sym_LT_LT_EQ] = ACTIONS(1477),
    [anon_sym_GT_GT_EQ] = ACTIONS(1477),
    [anon_sym_AMP_EQ] = ACTIONS(1477),
    [anon_sym_CARET_EQ] = ACTIONS(1477),
    [anon_sym_PIPE_EQ] = ACTIONS(1477),
    [anon_sym_AMP] = ACTIONS(1486),
    [anon_sym_PIPE_PIPE] = ACTIONS(1477),
    [anon_sym_AMP_AMP] = ACTIONS(1483),
    [anon_sym_PIPE] = ACTIONS(1479),
    [anon_sym_CARET] = ACTIONS(1479),
    [anon_sym_TILDE] = ACTIONS(142),
    [anon_sym_EQ_EQ] = ACTIONS(1477),
    [anon_sym_BANG_EQ] = ACTIONS(1477),
    [anon_sym_LT] = ACTIONS(1564),
    [anon_sym_GT] = ACTIONS(1479),
    [anon_sym_LT_EQ] = ACTIONS(1477),
    [anon_sym_GT_EQ] = ACTIONS(1477),
    [anon_sym_LT_LT] = ACTIONS(1479),
    [anon_sym_GT_GT] = ACTIONS(1479),
    [anon_sym_PLUS] = ACTIONS(1479),
    [anon_sym_DASH] = ACTIONS(1479),
    [anon_sym_SLASH] = ACTIONS(1479),
    [anon_sym_PERCENT] = ACTIONS(1479),
    [anon_sym_DASH_DASH] = ACTIONS(1477),
    [anon_sym_PLUS_PLUS] = ACTIONS(1477),
    [anon_sym_DOT] = ACTIONS(1477),
    [anon_sym_DASH_GT] = ACTIONS(1477),
    [sym_identifier] = ACTIONS(144),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(4631),
    [sym_operator_name] = ACTIONS(142),
  },
  [1472] = {
    [sym_destructor_name] = STATE(120),
    [anon_sym_TILDE] = ACTIONS(1500),
    [sym_identifier] = ACTIONS(4633),
    [sym_comment] = ACTIONS(49),
    [anon_sym_delete] = ACTIONS(1720),
    [sym_operator_name] = ACTIONS(190),
  },
  [1473] = {
    [sym_raw_string_literal] = ACTIONS(4635),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(4637),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(4637),
    [anon_sym_LPAREN] = ACTIONS(4635),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(4637),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(4637),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(4637),
    [sym_preproc_directive] = ACTIONS(4637),
    [anon_sym_SEMI] = ACTIONS(4635),
    [anon_sym_typedef] = ACTIONS(4637),
    [anon_sym_extern] = ACTIONS(4637),
    [anon_sym_LBRACE] = ACTIONS(4635),
    [anon_sym_RBRACE] = ACTIONS(4635),
    [anon_sym_STAR] = ACTIONS(4635),
    [anon_sym_LBRACK] = ACTIONS(4635),
    [anon_sym_static] = ACTIONS(4637),
    [anon_sym_register] = ACTIONS(4637),
    [anon_sym_inline] = ACTIONS(4637),
    [anon_sym_const] = ACTIONS(4637),
    [anon_sym_restrict] = ACTIONS(4637),
    [anon_sym_volatile] = ACTIONS(4637),
    [anon_sym__Atomic] = ACTIONS(4637),
    [anon_sym_mutable] = ACTIONS(4637),
    [anon_sym_explicit] = ACTIONS(4637),
    [anon_sym_constexpr] = ACTIONS(4637),
    [anon_sym_unsigned] = ACTIONS(4637),
    [anon_sym_long] = ACTIONS(4637),
    [anon_sym_short] = ACTIONS(4637),
    [sym_primitive_type] = ACTIONS(4637),
    [anon_sym_enum] = ACTIONS(4637),
    [anon_sym_struct] = ACTIONS(4637),
    [anon_sym_union] = ACTIONS(4637),
    [anon_sym_if] = ACTIONS(4637),
    [anon_sym_switch] = ACTIONS(4637),
    [anon_sym_case] = ACTIONS(4637),
    [anon_sym_default] = ACTIONS(4637),
    [anon_sym_while] = ACTIONS(4637),
    [anon_sym_do] = ACTIONS(4637),
    [anon_sym_for] = ACTIONS(4637),
    [anon_sym_return] = ACTIONS(4637),
    [anon_sym_break] = ACTIONS(4637),
    [anon_sym_continue] = ACTIONS(4637),
    [anon_sym_goto] = ACTIONS(4637),
    [anon_sym_AMP] = ACTIONS(4635),
    [anon_sym_BANG] = ACTIONS(4635),
    [anon_sym_TILDE] = ACTIONS(4635),
    [anon_sym_PLUS] = ACTIONS(4637),
    [anon_sym_DASH] = ACTIONS(4637),
    [anon_sym_DASH_DASH] = ACTIONS(4635),
    [anon_sym_PLUS_PLUS] = ACTIONS(4635),
    [anon_sym_sizeof] = ACTIONS(4637),
    [sym_number_literal] = ACTIONS(4635),
    [sym_char_literal] = ACTIONS(4635),
    [sym_string_literal] = ACTIONS(4635),
    [sym_true] = ACTIONS(4637),
    [sym_false] = ACTIONS(4637),
    [sym_null] = ACTIONS(4637),
    [sym_identifier] = ACTIONS(4637),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(4637),
    [sym_auto] = ACTIONS(4637),
    [anon_sym_typename] = ACTIONS(4637),
    [anon_sym_new] = ACTIONS(4637),
    [anon_sym_COLON_COLON] = ACTIONS(4635),
    [anon_sym_delete] = ACTIONS(4637),
    [sym_nullptr] = ACTIONS(4637),
  },
  [1474] = {
    [sym__declarator] = STATE(893),
    [sym_pointer_declarator] = STATE(893),
    [sym_function_declarator] = STATE(893),
    [sym_array_declarator] = STATE(893),
    [sym_init_declarator] = STATE(894),
    [sym_reference_declarator] = STATE(893),
    [sym_template_type] = STATE(46),
    [sym_template_function] = STATE(893),
    [sym_destructor_name] = STATE(893),
    [sym_scoped_identifier] = STATE(33),
    [sym_scoped_type_identifier] = STATE(47),
    [sym_scoped_namespace_identifier] = STATE(46),
    [anon_sym_LPAREN] = ACTIONS(11),
    [anon_sym_STAR] = ACTIONS(196),
    [anon_sym_AMP] = ACTIONS(526),
    [anon_sym_AMP_AMP] = ACTIONS(528),
    [anon_sym_TILDE] = ACTIONS(45),
    [sym_identifier] = ACTIONS(75),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(77),
    [sym_operator_name] = ACTIONS(1738),
  },
  [1475] = {
    [sym_initializer_list] = STATE(804),
    [anon_sym_LPAREN] = ACTIONS(228),
    [anon_sym_extern] = ACTIONS(230),
    [anon_sym_LBRACE] = ACTIONS(548),
    [anon_sym_STAR] = ACTIONS(228),
    [anon_sym_static] = ACTIONS(230),
    [anon_sym_register] = ACTIONS(230),
    [anon_sym_inline] = ACTIONS(230),
    [anon_sym_const] = ACTIONS(230),
    [anon_sym_restrict] = ACTIONS(230),
    [anon_sym_volatile] = ACTIONS(230),
    [anon_sym__Atomic] = ACTIONS(230),
    [anon_sym_mutable] = ACTIONS(230),
    [anon_sym_explicit] = ACTIONS(230),
    [anon_sym_constexpr] = ACTIONS(230),
    [anon_sym_AMP] = ACTIONS(230),
    [anon_sym_AMP_AMP] = ACTIONS(228),
    [anon_sym_TILDE] = ACTIONS(228),
    [sym_identifier] = ACTIONS(230),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(4639),
    [sym_operator_name] = ACTIONS(228),
  },
  [1476] = {
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(4639),
  },
  [1477] = {
    [sym_argument_list] = STATE(802),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_RPAREN] = ACTIONS(4641),
    [anon_sym_STAR] = ACTIONS(4537),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_EQ] = ACTIONS(4539),
    [anon_sym_QMARK] = ACTIONS(4541),
    [anon_sym_STAR_EQ] = ACTIONS(4543),
    [anon_sym_SLASH_EQ] = ACTIONS(4543),
    [anon_sym_PERCENT_EQ] = ACTIONS(4543),
    [anon_sym_PLUS_EQ] = ACTIONS(4543),
    [anon_sym_DASH_EQ] = ACTIONS(4543),
    [anon_sym_LT_LT_EQ] = ACTIONS(4543),
    [anon_sym_GT_GT_EQ] = ACTIONS(4543),
    [anon_sym_AMP_EQ] = ACTIONS(4543),
    [anon_sym_CARET_EQ] = ACTIONS(4543),
    [anon_sym_PIPE_EQ] = ACTIONS(4543),
    [anon_sym_AMP] = ACTIONS(4545),
    [anon_sym_PIPE_PIPE] = ACTIONS(4547),
    [anon_sym_AMP_AMP] = ACTIONS(4549),
    [anon_sym_PIPE] = ACTIONS(4551),
    [anon_sym_CARET] = ACTIONS(4553),
    [anon_sym_EQ_EQ] = ACTIONS(4555),
    [anon_sym_BANG_EQ] = ACTIONS(4555),
    [anon_sym_LT] = ACTIONS(4557),
    [anon_sym_GT] = ACTIONS(4557),
    [anon_sym_LT_EQ] = ACTIONS(4559),
    [anon_sym_GT_EQ] = ACTIONS(4559),
    [anon_sym_LT_LT] = ACTIONS(4561),
    [anon_sym_GT_GT] = ACTIONS(4561),
    [anon_sym_PLUS] = ACTIONS(4563),
    [anon_sym_DASH] = ACTIONS(4563),
    [anon_sym_SLASH] = ACTIONS(4537),
    [anon_sym_PERCENT] = ACTIONS(4537),
    [anon_sym_DASH_DASH] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(1554),
    [anon_sym_DASH_GT] = ACTIONS(1554),
    [sym_comment] = ACTIONS(49),
  },
  [1478] = {
    [anon_sym_LPAREN] = ACTIONS(1622),
    [anon_sym_COMMA] = ACTIONS(1622),
    [anon_sym_RPAREN] = ACTIONS(1622),
    [anon_sym_SEMI] = ACTIONS(1622),
    [anon_sym_RBRACE] = ACTIONS(1622),
    [anon_sym_STAR] = ACTIONS(1624),
    [anon_sym_LBRACK] = ACTIONS(1622),
    [anon_sym_RBRACK] = ACTIONS(1622),
    [anon_sym_EQ] = ACTIONS(1624),
    [anon_sym_COLON] = ACTIONS(1622),
    [anon_sym_else] = ACTIONS(1622),
    [anon_sym_while] = ACTIONS(1622),
    [anon_sym_QMARK] = ACTIONS(1622),
    [anon_sym_STAR_EQ] = ACTIONS(1622),
    [anon_sym_SLASH_EQ] = ACTIONS(1622),
    [anon_sym_PERCENT_EQ] = ACTIONS(1622),
    [anon_sym_PLUS_EQ] = ACTIONS(1622),
    [anon_sym_DASH_EQ] = ACTIONS(1622),
    [anon_sym_LT_LT_EQ] = ACTIONS(1622),
    [anon_sym_GT_GT_EQ] = ACTIONS(1622),
    [anon_sym_AMP_EQ] = ACTIONS(1622),
    [anon_sym_CARET_EQ] = ACTIONS(1622),
    [anon_sym_PIPE_EQ] = ACTIONS(1622),
    [anon_sym_AMP] = ACTIONS(1624),
    [anon_sym_PIPE_PIPE] = ACTIONS(1622),
    [anon_sym_AMP_AMP] = ACTIONS(1622),
    [anon_sym_PIPE] = ACTIONS(1624),
    [anon_sym_CARET] = ACTIONS(1624),
    [anon_sym_EQ_EQ] = ACTIONS(1622),
    [anon_sym_BANG_EQ] = ACTIONS(1622),
    [anon_sym_LT] = ACTIONS(1624),
    [anon_sym_GT] = ACTIONS(1624),
    [anon_sym_LT_EQ] = ACTIONS(1622),
    [anon_sym_GT_EQ] = ACTIONS(1622),
    [anon_sym_LT_LT] = ACTIONS(1624),
    [anon_sym_GT_GT] = ACTIONS(1624),
    [anon_sym_PLUS] = ACTIONS(1624),
    [anon_sym_DASH] = ACTIONS(1624),
    [anon_sym_SLASH] = ACTIONS(1624),
    [anon_sym_PERCENT] = ACTIONS(1624),
    [anon_sym_DASH_DASH] = ACTIONS(1622),
    [anon_sym_PLUS_PLUS] = ACTIONS(1622),
    [anon_sym_DOT] = ACTIONS(1622),
    [anon_sym_DASH_GT] = ACTIONS(1622),
    [sym_comment] = ACTIONS(49),
  },
  [1479] = {
    [sym_preproc_include] = STATE(913),
    [sym_preproc_def] = STATE(913),
    [sym_preproc_function_def] = STATE(913),
    [sym_preproc_call] = STATE(913),
    [sym_preproc_if_in_compound_statement] = STATE(410),
    [sym_preproc_ifdef_in_compound_statement] = STATE(411),
    [sym_declaration] = STATE(913),
    [sym_type_definition] = STATE(913),
    [sym__declaration_specifiers] = STATE(412),
    [sym_compound_statement] = STATE(913),
    [sym_storage_class_specifier] = STATE(419),
    [sym_type_qualifier] = STATE(419),
    [sym__type_specifier] = STATE(30),
    [sym_sized_type_specifier] = STATE(30),
    [sym_enum_specifier] = STATE(30),
    [sym_struct_specifier] = STATE(30),
    [sym_union_specifier] = STATE(30),
    [sym_labeled_statement] = STATE(913),
    [sym_expression_statement] = STATE(913),
    [sym_if_statement] = STATE(913),
    [sym_switch_statement] = STATE(913),
    [sym_case_statement] = STATE(913),
    [sym_while_statement] = STATE(913),
    [sym_do_statement] = STATE(913),
    [sym_for_statement] = STATE(913),
    [sym_return_statement] = STATE(913),
    [sym_break_statement] = STATE(913),
    [sym_continue_statement] = STATE(913),
    [sym_goto_statement] = STATE(913),
    [sym__expression] = STATE(413),
    [sym_comma_expression] = STATE(414),
    [sym_conditional_expression] = STATE(413),
    [sym_assignment_expression] = STATE(413),
    [sym_pointer_expression] = STATE(413),
    [sym_logical_expression] = STATE(413),
    [sym_bitwise_expression] = STATE(413),
    [sym_equality_expression] = STATE(413),
    [sym_relational_expression] = STATE(413),
    [sym_shift_expression] = STATE(413),
    [sym_math_expression] = STATE(413),
    [sym_cast_expression] = STATE(413),
    [sym_sizeof_expression] = STATE(413),
    [sym_subscript_expression] = STATE(413),
    [sym_call_expression] = STATE(413),
    [sym_field_expression] = STATE(413),
    [sym_compound_literal_expression] = STATE(413),
    [sym_parenthesized_expression] = STATE(413),
    [sym_concatenated_string] = STATE(413),
    [sym__empty_declaration] = STATE(913),
    [sym_macro_type_specifier] = STATE(30),
    [sym_class_specifier] = STATE(30),
    [sym_dependent_type] = STATE(30),
    [sym_structured_binding_declaration] = STATE(913),
    [sym_template_type] = STATE(415),
    [sym_template_function] = STATE(413),
    [sym_for_range_loop] = STATE(913),
    [sym_new_expression] = STATE(413),
    [sym_delete_expression] = STATE(413),
    [sym_lambda_expression] = STATE(413),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(416),
    [sym_scoped_namespace_identifier] = STATE(417),
    [aux_sym_preproc_if_in_compound_statement_repeat1] = STATE(913),
    [aux_sym__declaration_specifiers_repeat1] = STATE(419),
    [aux_sym_sized_type_specifier_repeat1] = STATE(38),
    [sym_raw_string_literal] = ACTIONS(620),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(622),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(624),
    [anon_sym_LPAREN] = ACTIONS(626),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(628),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(630),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(632),
    [sym_preproc_directive] = ACTIONS(634),
    [anon_sym_SEMI] = ACTIONS(636),
    [anon_sym_typedef] = ACTIONS(638),
    [anon_sym_extern] = ACTIONS(154),
    [anon_sym_LBRACE] = ACTIONS(640),
    [anon_sym_RBRACE] = ACTIONS(4643),
    [anon_sym_STAR] = ACTIONS(644),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_static] = ACTIONS(154),
    [anon_sym_register] = ACTIONS(154),
    [anon_sym_inline] = ACTIONS(154),
    [anon_sym_const] = ACTIONS(158),
    [anon_sym_restrict] = ACTIONS(158),
    [anon_sym_volatile] = ACTIONS(158),
    [anon_sym__Atomic] = ACTIONS(158),
    [anon_sym_mutable] = ACTIONS(158),
    [anon_sym_explicit] = ACTIONS(158),
    [anon_sym_constexpr] = ACTIONS(158),
    [anon_sym_unsigned] = ACTIONS(31),
    [anon_sym_long] = ACTIONS(31),
    [anon_sym_short] = ACTIONS(31),
    [sym_primitive_type] = ACTIONS(33),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_union] = ACTIONS(39),
    [anon_sym_if] = ACTIONS(646),
    [anon_sym_switch] = ACTIONS(648),
    [anon_sym_case] = ACTIONS(650),
    [anon_sym_default] = ACTIONS(652),
    [anon_sym_while] = ACTIONS(654),
    [anon_sym_do] = ACTIONS(656),
    [anon_sym_for] = ACTIONS(658),
    [anon_sym_return] = ACTIONS(660),
    [anon_sym_break] = ACTIONS(662),
    [anon_sym_continue] = ACTIONS(664),
    [anon_sym_goto] = ACTIONS(666),
    [anon_sym_AMP] = ACTIONS(644),
    [anon_sym_BANG] = ACTIONS(668),
    [anon_sym_TILDE] = ACTIONS(670),
    [anon_sym_PLUS] = ACTIONS(672),
    [anon_sym_DASH] = ACTIONS(672),
    [anon_sym_DASH_DASH] = ACTIONS(674),
    [anon_sym_PLUS_PLUS] = ACTIONS(674),
    [anon_sym_sizeof] = ACTIONS(676),
    [sym_number_literal] = ACTIONS(620),
    [sym_char_literal] = ACTIONS(620),
    [sym_string_literal] = ACTIONS(678),
    [sym_true] = ACTIONS(680),
    [sym_false] = ACTIONS(680),
    [sym_null] = ACTIONS(680),
    [sym_identifier] = ACTIONS(682),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(51),
    [sym_auto] = ACTIONS(33),
    [anon_sym_typename] = ACTIONS(53),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(684),
    [anon_sym_delete] = ACTIONS(686),
    [sym_nullptr] = ACTIONS(680),
  },
  [1480] = {
    [sym__expression] = STATE(2044),
    [sym_conditional_expression] = STATE(2044),
    [sym_assignment_expression] = STATE(2044),
    [sym_pointer_expression] = STATE(2044),
    [sym_logical_expression] = STATE(2044),
    [sym_bitwise_expression] = STATE(2044),
    [sym_equality_expression] = STATE(2044),
    [sym_relational_expression] = STATE(2044),
    [sym_shift_expression] = STATE(2044),
    [sym_math_expression] = STATE(2044),
    [sym_cast_expression] = STATE(2044),
    [sym_sizeof_expression] = STATE(2044),
    [sym_subscript_expression] = STATE(2044),
    [sym_call_expression] = STATE(2044),
    [sym_field_expression] = STATE(2044),
    [sym_compound_literal_expression] = STATE(2044),
    [sym_parenthesized_expression] = STATE(2044),
    [sym_concatenated_string] = STATE(2044),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(2044),
    [sym_new_expression] = STATE(2044),
    [sym_delete_expression] = STATE(2044),
    [sym_lambda_expression] = STATE(2044),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(4645),
    [anon_sym_LPAREN] = ACTIONS(2943),
    [anon_sym_STAR] = ACTIONS(2945),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_AMP] = ACTIONS(2945),
    [anon_sym_BANG] = ACTIONS(2947),
    [anon_sym_TILDE] = ACTIONS(2949),
    [anon_sym_PLUS] = ACTIONS(2951),
    [anon_sym_DASH] = ACTIONS(2951),
    [anon_sym_DASH_DASH] = ACTIONS(2953),
    [anon_sym_PLUS_PLUS] = ACTIONS(2953),
    [anon_sym_sizeof] = ACTIONS(2955),
    [sym_number_literal] = ACTIONS(4645),
    [sym_char_literal] = ACTIONS(4645),
    [sym_string_literal] = ACTIONS(2957),
    [sym_true] = ACTIONS(4647),
    [sym_false] = ACTIONS(4647),
    [sym_null] = ACTIONS(4647),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(2961),
    [anon_sym_delete] = ACTIONS(2963),
    [sym_nullptr] = ACTIONS(4647),
  },
  [1481] = {
    [anon_sym_LPAREN] = ACTIONS(4649),
    [sym_comment] = ACTIONS(49),
  },
  [1482] = {
    [sym__expression] = STATE(2046),
    [sym_conditional_expression] = STATE(2046),
    [sym_assignment_expression] = STATE(2046),
    [sym_pointer_expression] = STATE(2046),
    [sym_logical_expression] = STATE(2046),
    [sym_bitwise_expression] = STATE(2046),
    [sym_equality_expression] = STATE(2046),
    [sym_relational_expression] = STATE(2046),
    [sym_shift_expression] = STATE(2046),
    [sym_math_expression] = STATE(2046),
    [sym_cast_expression] = STATE(2046),
    [sym_sizeof_expression] = STATE(2046),
    [sym_subscript_expression] = STATE(2046),
    [sym_call_expression] = STATE(2046),
    [sym_field_expression] = STATE(2046),
    [sym_compound_literal_expression] = STATE(2046),
    [sym_parenthesized_expression] = STATE(2046),
    [sym_concatenated_string] = STATE(2046),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(2046),
    [sym_new_expression] = STATE(2046),
    [sym_delete_expression] = STATE(2046),
    [sym_lambda_expression] = STATE(2046),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(4651),
    [anon_sym_LPAREN] = ACTIONS(2943),
    [anon_sym_STAR] = ACTIONS(2945),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_AMP] = ACTIONS(2945),
    [anon_sym_BANG] = ACTIONS(2947),
    [anon_sym_TILDE] = ACTIONS(2949),
    [anon_sym_PLUS] = ACTIONS(2951),
    [anon_sym_DASH] = ACTIONS(2951),
    [anon_sym_DASH_DASH] = ACTIONS(2953),
    [anon_sym_PLUS_PLUS] = ACTIONS(2953),
    [anon_sym_sizeof] = ACTIONS(2955),
    [sym_number_literal] = ACTIONS(4651),
    [sym_char_literal] = ACTIONS(4651),
    [sym_string_literal] = ACTIONS(2957),
    [sym_true] = ACTIONS(4653),
    [sym_false] = ACTIONS(4653),
    [sym_null] = ACTIONS(4653),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(2961),
    [anon_sym_delete] = ACTIONS(2963),
    [sym_nullptr] = ACTIONS(4653),
  },
  [1483] = {
    [sym_argument_list] = STATE(802),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_STAR] = ACTIONS(3003),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_EQ] = ACTIONS(3005),
    [anon_sym_COLON] = ACTIONS(4655),
    [anon_sym_QMARK] = ACTIONS(3009),
    [anon_sym_STAR_EQ] = ACTIONS(3011),
    [anon_sym_SLASH_EQ] = ACTIONS(3011),
    [anon_sym_PERCENT_EQ] = ACTIONS(3011),
    [anon_sym_PLUS_EQ] = ACTIONS(3011),
    [anon_sym_DASH_EQ] = ACTIONS(3011),
    [anon_sym_LT_LT_EQ] = ACTIONS(3011),
    [anon_sym_GT_GT_EQ] = ACTIONS(3011),
    [anon_sym_AMP_EQ] = ACTIONS(3011),
    [anon_sym_CARET_EQ] = ACTIONS(3011),
    [anon_sym_PIPE_EQ] = ACTIONS(3011),
    [anon_sym_AMP] = ACTIONS(3013),
    [anon_sym_PIPE_PIPE] = ACTIONS(3015),
    [anon_sym_AMP_AMP] = ACTIONS(3017),
    [anon_sym_PIPE] = ACTIONS(3019),
    [anon_sym_CARET] = ACTIONS(3021),
    [anon_sym_EQ_EQ] = ACTIONS(3023),
    [anon_sym_BANG_EQ] = ACTIONS(3023),
    [anon_sym_LT] = ACTIONS(3025),
    [anon_sym_GT] = ACTIONS(3025),
    [anon_sym_LT_EQ] = ACTIONS(3027),
    [anon_sym_GT_EQ] = ACTIONS(3027),
    [anon_sym_LT_LT] = ACTIONS(3029),
    [anon_sym_GT_GT] = ACTIONS(3029),
    [anon_sym_PLUS] = ACTIONS(3031),
    [anon_sym_DASH] = ACTIONS(3031),
    [anon_sym_SLASH] = ACTIONS(3003),
    [anon_sym_PERCENT] = ACTIONS(3003),
    [anon_sym_DASH_DASH] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(3033),
    [anon_sym_DASH_GT] = ACTIONS(3033),
    [sym_comment] = ACTIONS(49),
  },
  [1484] = {
    [sym_declaration] = STATE(2050),
    [sym_type_definition] = STATE(2050),
    [sym__declaration_specifiers] = STATE(2051),
    [sym_compound_statement] = STATE(2050),
    [sym_storage_class_specifier] = STATE(109),
    [sym_type_qualifier] = STATE(109),
    [sym__type_specifier] = STATE(105),
    [sym_sized_type_specifier] = STATE(105),
    [sym_enum_specifier] = STATE(105),
    [sym_struct_specifier] = STATE(105),
    [sym_union_specifier] = STATE(105),
    [sym_labeled_statement] = STATE(2050),
    [sym_expression_statement] = STATE(2050),
    [sym_if_statement] = STATE(2050),
    [sym_switch_statement] = STATE(2050),
    [sym_case_statement] = STATE(2050),
    [sym_while_statement] = STATE(2050),
    [sym_do_statement] = STATE(2050),
    [sym_for_statement] = STATE(2050),
    [sym_return_statement] = STATE(2050),
    [sym_break_statement] = STATE(2050),
    [sym_continue_statement] = STATE(2050),
    [sym_goto_statement] = STATE(2050),
    [sym__expression] = STATE(873),
    [sym_comma_expression] = STATE(874),
    [sym_conditional_expression] = STATE(873),
    [sym_assignment_expression] = STATE(873),
    [sym_pointer_expression] = STATE(873),
    [sym_logical_expression] = STATE(873),
    [sym_bitwise_expression] = STATE(873),
    [sym_equality_expression] = STATE(873),
    [sym_relational_expression] = STATE(873),
    [sym_shift_expression] = STATE(873),
    [sym_math_expression] = STATE(873),
    [sym_cast_expression] = STATE(873),
    [sym_sizeof_expression] = STATE(873),
    [sym_subscript_expression] = STATE(873),
    [sym_call_expression] = STATE(873),
    [sym_field_expression] = STATE(873),
    [sym_compound_literal_expression] = STATE(873),
    [sym_parenthesized_expression] = STATE(873),
    [sym_concatenated_string] = STATE(873),
    [sym_macro_type_specifier] = STATE(105),
    [sym_class_specifier] = STATE(105),
    [sym_dependent_type] = STATE(105),
    [sym_template_type] = STATE(1475),
    [sym_template_function] = STATE(873),
    [sym_for_range_loop] = STATE(2050),
    [sym_new_expression] = STATE(873),
    [sym_delete_expression] = STATE(873),
    [sym_lambda_expression] = STATE(873),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(416),
    [sym_scoped_namespace_identifier] = STATE(1476),
    [aux_sym__declaration_specifiers_repeat1] = STATE(109),
    [aux_sym_sized_type_specifier_repeat1] = STATE(110),
    [sym_raw_string_literal] = ACTIONS(1660),
    [anon_sym_LPAREN] = ACTIONS(626),
    [anon_sym_SEMI] = ACTIONS(1662),
    [anon_sym_typedef] = ACTIONS(4657),
    [anon_sym_extern] = ACTIONS(154),
    [anon_sym_LBRACE] = ACTIONS(1664),
    [anon_sym_STAR] = ACTIONS(644),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_static] = ACTIONS(154),
    [anon_sym_register] = ACTIONS(154),
    [anon_sym_inline] = ACTIONS(154),
    [anon_sym_const] = ACTIONS(158),
    [anon_sym_restrict] = ACTIONS(158),
    [anon_sym_volatile] = ACTIONS(158),
    [anon_sym__Atomic] = ACTIONS(158),
    [anon_sym_mutable] = ACTIONS(158),
    [anon_sym_explicit] = ACTIONS(158),
    [anon_sym_constexpr] = ACTIONS(158),
    [anon_sym_unsigned] = ACTIONS(160),
    [anon_sym_long] = ACTIONS(160),
    [anon_sym_short] = ACTIONS(160),
    [sym_primitive_type] = ACTIONS(162),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_union] = ACTIONS(39),
    [anon_sym_if] = ACTIONS(1666),
    [anon_sym_switch] = ACTIONS(1668),
    [anon_sym_case] = ACTIONS(1670),
    [anon_sym_default] = ACTIONS(1672),
    [anon_sym_while] = ACTIONS(1674),
    [anon_sym_do] = ACTIONS(1676),
    [anon_sym_for] = ACTIONS(1678),
    [anon_sym_return] = ACTIONS(1680),
    [anon_sym_break] = ACTIONS(1682),
    [anon_sym_continue] = ACTIONS(1684),
    [anon_sym_goto] = ACTIONS(1686),
    [anon_sym_AMP] = ACTIONS(644),
    [anon_sym_BANG] = ACTIONS(668),
    [anon_sym_TILDE] = ACTIONS(670),
    [anon_sym_PLUS] = ACTIONS(672),
    [anon_sym_DASH] = ACTIONS(672),
    [anon_sym_DASH_DASH] = ACTIONS(674),
    [anon_sym_PLUS_PLUS] = ACTIONS(674),
    [anon_sym_sizeof] = ACTIONS(676),
    [sym_number_literal] = ACTIONS(1660),
    [sym_char_literal] = ACTIONS(1660),
    [sym_string_literal] = ACTIONS(678),
    [sym_true] = ACTIONS(1688),
    [sym_false] = ACTIONS(1688),
    [sym_null] = ACTIONS(1688),
    [sym_identifier] = ACTIONS(4659),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(51),
    [sym_auto] = ACTIONS(162),
    [anon_sym_typename] = ACTIONS(172),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(3040),
    [anon_sym_delete] = ACTIONS(686),
    [sym_nullptr] = ACTIONS(1688),
  },
  [1485] = {
    [sym__expression] = STATE(2052),
    [sym_conditional_expression] = STATE(2052),
    [sym_assignment_expression] = STATE(2052),
    [sym_pointer_expression] = STATE(2052),
    [sym_logical_expression] = STATE(2052),
    [sym_bitwise_expression] = STATE(2052),
    [sym_equality_expression] = STATE(2052),
    [sym_relational_expression] = STATE(2052),
    [sym_shift_expression] = STATE(2052),
    [sym_math_expression] = STATE(2052),
    [sym_cast_expression] = STATE(2052),
    [sym_sizeof_expression] = STATE(2052),
    [sym_subscript_expression] = STATE(2052),
    [sym_call_expression] = STATE(2052),
    [sym_field_expression] = STATE(2052),
    [sym_compound_literal_expression] = STATE(2052),
    [sym_parenthesized_expression] = STATE(2052),
    [sym_concatenated_string] = STATE(2052),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(2052),
    [sym_new_expression] = STATE(2052),
    [sym_delete_expression] = STATE(2052),
    [sym_lambda_expression] = STATE(2052),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(4661),
    [anon_sym_LPAREN] = ACTIONS(2943),
    [anon_sym_STAR] = ACTIONS(2945),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_AMP] = ACTIONS(2945),
    [anon_sym_BANG] = ACTIONS(2947),
    [anon_sym_TILDE] = ACTIONS(2949),
    [anon_sym_PLUS] = ACTIONS(2951),
    [anon_sym_DASH] = ACTIONS(2951),
    [anon_sym_DASH_DASH] = ACTIONS(2953),
    [anon_sym_PLUS_PLUS] = ACTIONS(2953),
    [anon_sym_sizeof] = ACTIONS(2955),
    [sym_number_literal] = ACTIONS(4661),
    [sym_char_literal] = ACTIONS(4661),
    [sym_string_literal] = ACTIONS(2957),
    [sym_true] = ACTIONS(4663),
    [sym_false] = ACTIONS(4663),
    [sym_null] = ACTIONS(4663),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(2961),
    [anon_sym_delete] = ACTIONS(2963),
    [sym_nullptr] = ACTIONS(4663),
  },
  [1486] = {
    [anon_sym_while] = ACTIONS(4665),
    [sym_comment] = ACTIONS(49),
  },
  [1487] = {
    [sym_declaration] = STATE(2054),
    [sym__declaration_specifiers] = STATE(1500),
    [sym_storage_class_specifier] = STATE(109),
    [sym_type_qualifier] = STATE(109),
    [sym__type_specifier] = STATE(105),
    [sym_sized_type_specifier] = STATE(105),
    [sym_enum_specifier] = STATE(105),
    [sym_struct_specifier] = STATE(105),
    [sym_union_specifier] = STATE(105),
    [sym__expression] = STATE(2055),
    [sym_conditional_expression] = STATE(2055),
    [sym_assignment_expression] = STATE(2055),
    [sym_pointer_expression] = STATE(2055),
    [sym_logical_expression] = STATE(2055),
    [sym_bitwise_expression] = STATE(2055),
    [sym_equality_expression] = STATE(2055),
    [sym_relational_expression] = STATE(2055),
    [sym_shift_expression] = STATE(2055),
    [sym_math_expression] = STATE(2055),
    [sym_cast_expression] = STATE(2055),
    [sym_sizeof_expression] = STATE(2055),
    [sym_subscript_expression] = STATE(2055),
    [sym_call_expression] = STATE(2055),
    [sym_field_expression] = STATE(2055),
    [sym_compound_literal_expression] = STATE(2055),
    [sym_parenthesized_expression] = STATE(2055),
    [sym_concatenated_string] = STATE(2055),
    [sym_macro_type_specifier] = STATE(105),
    [sym_class_specifier] = STATE(105),
    [sym_dependent_type] = STATE(105),
    [sym_template_type] = STATE(1475),
    [sym_template_function] = STATE(2055),
    [sym_for_range_declaration] = STATE(2056),
    [sym_new_expression] = STATE(2055),
    [sym_delete_expression] = STATE(2055),
    [sym_lambda_expression] = STATE(2055),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(416),
    [sym_scoped_namespace_identifier] = STATE(1476),
    [aux_sym__declaration_specifiers_repeat1] = STATE(109),
    [aux_sym_sized_type_specifier_repeat1] = STATE(110),
    [sym_raw_string_literal] = ACTIONS(4667),
    [anon_sym_LPAREN] = ACTIONS(1347),
    [anon_sym_SEMI] = ACTIONS(4669),
    [anon_sym_extern] = ACTIONS(154),
    [anon_sym_STAR] = ACTIONS(1349),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_static] = ACTIONS(154),
    [anon_sym_register] = ACTIONS(154),
    [anon_sym_inline] = ACTIONS(154),
    [anon_sym_const] = ACTIONS(158),
    [anon_sym_restrict] = ACTIONS(158),
    [anon_sym_volatile] = ACTIONS(158),
    [anon_sym__Atomic] = ACTIONS(158),
    [anon_sym_mutable] = ACTIONS(158),
    [anon_sym_explicit] = ACTIONS(158),
    [anon_sym_constexpr] = ACTIONS(158),
    [anon_sym_unsigned] = ACTIONS(160),
    [anon_sym_long] = ACTIONS(160),
    [anon_sym_short] = ACTIONS(160),
    [sym_primitive_type] = ACTIONS(162),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_union] = ACTIONS(39),
    [anon_sym_AMP] = ACTIONS(1349),
    [anon_sym_BANG] = ACTIONS(1351),
    [anon_sym_TILDE] = ACTIONS(1353),
    [anon_sym_PLUS] = ACTIONS(1355),
    [anon_sym_DASH] = ACTIONS(1355),
    [anon_sym_DASH_DASH] = ACTIONS(1357),
    [anon_sym_PLUS_PLUS] = ACTIONS(1357),
    [anon_sym_sizeof] = ACTIONS(1359),
    [sym_number_literal] = ACTIONS(4667),
    [sym_char_literal] = ACTIONS(4667),
    [sym_string_literal] = ACTIONS(1361),
    [sym_true] = ACTIONS(4671),
    [sym_false] = ACTIONS(4671),
    [sym_null] = ACTIONS(4671),
    [sym_identifier] = ACTIONS(3088),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(51),
    [sym_auto] = ACTIONS(162),
    [anon_sym_typename] = ACTIONS(172),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(3090),
    [anon_sym_delete] = ACTIONS(1367),
    [sym_nullptr] = ACTIONS(4671),
  },
  [1488] = {
    [anon_sym_else] = ACTIONS(3092),
    [anon_sym_while] = ACTIONS(3092),
    [sym_comment] = ACTIONS(49),
  },
  [1489] = {
    [sym_argument_list] = STATE(802),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_SEMI] = ACTIONS(4673),
    [anon_sym_STAR] = ACTIONS(2553),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_EQ] = ACTIONS(2555),
    [anon_sym_QMARK] = ACTIONS(2557),
    [anon_sym_STAR_EQ] = ACTIONS(2559),
    [anon_sym_SLASH_EQ] = ACTIONS(2559),
    [anon_sym_PERCENT_EQ] = ACTIONS(2559),
    [anon_sym_PLUS_EQ] = ACTIONS(2559),
    [anon_sym_DASH_EQ] = ACTIONS(2559),
    [anon_sym_LT_LT_EQ] = ACTIONS(2559),
    [anon_sym_GT_GT_EQ] = ACTIONS(2559),
    [anon_sym_AMP_EQ] = ACTIONS(2559),
    [anon_sym_CARET_EQ] = ACTIONS(2559),
    [anon_sym_PIPE_EQ] = ACTIONS(2559),
    [anon_sym_AMP] = ACTIONS(2561),
    [anon_sym_PIPE_PIPE] = ACTIONS(2563),
    [anon_sym_AMP_AMP] = ACTIONS(2565),
    [anon_sym_PIPE] = ACTIONS(2567),
    [anon_sym_CARET] = ACTIONS(2569),
    [anon_sym_EQ_EQ] = ACTIONS(2571),
    [anon_sym_BANG_EQ] = ACTIONS(2571),
    [anon_sym_LT] = ACTIONS(2573),
    [anon_sym_GT] = ACTIONS(2573),
    [anon_sym_LT_EQ] = ACTIONS(2575),
    [anon_sym_GT_EQ] = ACTIONS(2575),
    [anon_sym_LT_LT] = ACTIONS(2577),
    [anon_sym_GT_GT] = ACTIONS(2577),
    [anon_sym_PLUS] = ACTIONS(2579),
    [anon_sym_DASH] = ACTIONS(2579),
    [anon_sym_SLASH] = ACTIONS(2553),
    [anon_sym_PERCENT] = ACTIONS(2553),
    [anon_sym_DASH_DASH] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(1554),
    [anon_sym_DASH_GT] = ACTIONS(1554),
    [sym_comment] = ACTIONS(49),
  },
  [1490] = {
    [anon_sym_SEMI] = ACTIONS(4673),
    [sym_comment] = ACTIONS(49),
  },
  [1491] = {
    [anon_sym_else] = ACTIONS(3098),
    [anon_sym_while] = ACTIONS(3098),
    [sym_comment] = ACTIONS(49),
  },
  [1492] = {
    [anon_sym_else] = ACTIONS(3102),
    [anon_sym_while] = ACTIONS(3102),
    [sym_comment] = ACTIONS(49),
  },
  [1493] = {
    [anon_sym_SEMI] = ACTIONS(4675),
    [sym_comment] = ACTIONS(49),
  },
  [1494] = {
    [sym_compound_statement] = STATE(2059),
    [sym_labeled_statement] = STATE(2059),
    [sym_expression_statement] = STATE(2059),
    [sym_if_statement] = STATE(2059),
    [sym_switch_statement] = STATE(2059),
    [sym_case_statement] = STATE(2059),
    [sym_while_statement] = STATE(2059),
    [sym_do_statement] = STATE(2059),
    [sym_for_statement] = STATE(2059),
    [sym_return_statement] = STATE(2059),
    [sym_break_statement] = STATE(2059),
    [sym_continue_statement] = STATE(2059),
    [sym_goto_statement] = STATE(2059),
    [sym__expression] = STATE(873),
    [sym_comma_expression] = STATE(874),
    [sym_conditional_expression] = STATE(873),
    [sym_assignment_expression] = STATE(873),
    [sym_pointer_expression] = STATE(873),
    [sym_logical_expression] = STATE(873),
    [sym_bitwise_expression] = STATE(873),
    [sym_equality_expression] = STATE(873),
    [sym_relational_expression] = STATE(873),
    [sym_shift_expression] = STATE(873),
    [sym_math_expression] = STATE(873),
    [sym_cast_expression] = STATE(873),
    [sym_sizeof_expression] = STATE(873),
    [sym_subscript_expression] = STATE(873),
    [sym_call_expression] = STATE(873),
    [sym_field_expression] = STATE(873),
    [sym_compound_literal_expression] = STATE(873),
    [sym_parenthesized_expression] = STATE(873),
    [sym_concatenated_string] = STATE(873),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(873),
    [sym_for_range_loop] = STATE(2059),
    [sym_new_expression] = STATE(873),
    [sym_delete_expression] = STATE(873),
    [sym_lambda_expression] = STATE(873),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(1660),
    [anon_sym_LPAREN] = ACTIONS(626),
    [anon_sym_SEMI] = ACTIONS(1662),
    [anon_sym_LBRACE] = ACTIONS(1664),
    [anon_sym_STAR] = ACTIONS(644),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_if] = ACTIONS(1666),
    [anon_sym_switch] = ACTIONS(1668),
    [anon_sym_case] = ACTIONS(1670),
    [anon_sym_default] = ACTIONS(1672),
    [anon_sym_while] = ACTIONS(1674),
    [anon_sym_do] = ACTIONS(1676),
    [anon_sym_for] = ACTIONS(1678),
    [anon_sym_return] = ACTIONS(1680),
    [anon_sym_break] = ACTIONS(1682),
    [anon_sym_continue] = ACTIONS(1684),
    [anon_sym_goto] = ACTIONS(1686),
    [anon_sym_AMP] = ACTIONS(644),
    [anon_sym_BANG] = ACTIONS(668),
    [anon_sym_TILDE] = ACTIONS(670),
    [anon_sym_PLUS] = ACTIONS(672),
    [anon_sym_DASH] = ACTIONS(672),
    [anon_sym_DASH_DASH] = ACTIONS(674),
    [anon_sym_PLUS_PLUS] = ACTIONS(674),
    [anon_sym_sizeof] = ACTIONS(676),
    [sym_number_literal] = ACTIONS(1660),
    [sym_char_literal] = ACTIONS(1660),
    [sym_string_literal] = ACTIONS(678),
    [sym_true] = ACTIONS(1688),
    [sym_false] = ACTIONS(1688),
    [sym_null] = ACTIONS(1688),
    [sym_identifier] = ACTIONS(1690),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1303),
    [anon_sym_delete] = ACTIONS(686),
    [sym_nullptr] = ACTIONS(1688),
  },
  [1495] = {
    [anon_sym_LPAREN] = ACTIONS(4677),
    [sym_comment] = ACTIONS(49),
  },
  [1496] = {
    [anon_sym_else] = ACTIONS(3132),
    [anon_sym_while] = ACTIONS(3132),
    [sym_comment] = ACTIONS(49),
  },
  [1497] = {
    [sym__expression] = STATE(2062),
    [sym_conditional_expression] = STATE(2062),
    [sym_assignment_expression] = STATE(2062),
    [sym_pointer_expression] = STATE(2062),
    [sym_logical_expression] = STATE(2062),
    [sym_bitwise_expression] = STATE(2062),
    [sym_equality_expression] = STATE(2062),
    [sym_relational_expression] = STATE(2062),
    [sym_shift_expression] = STATE(2062),
    [sym_math_expression] = STATE(2062),
    [sym_cast_expression] = STATE(2062),
    [sym_sizeof_expression] = STATE(2062),
    [sym_subscript_expression] = STATE(2062),
    [sym_call_expression] = STATE(2062),
    [sym_field_expression] = STATE(2062),
    [sym_compound_literal_expression] = STATE(2062),
    [sym_parenthesized_expression] = STATE(2062),
    [sym_concatenated_string] = STATE(2062),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(2062),
    [sym_new_expression] = STATE(2062),
    [sym_delete_expression] = STATE(2062),
    [sym_lambda_expression] = STATE(2062),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(4679),
    [anon_sym_LPAREN] = ACTIONS(1347),
    [anon_sym_SEMI] = ACTIONS(4681),
    [anon_sym_STAR] = ACTIONS(1349),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_AMP] = ACTIONS(1349),
    [anon_sym_BANG] = ACTIONS(1351),
    [anon_sym_TILDE] = ACTIONS(1353),
    [anon_sym_PLUS] = ACTIONS(1355),
    [anon_sym_DASH] = ACTIONS(1355),
    [anon_sym_DASH_DASH] = ACTIONS(1357),
    [anon_sym_PLUS_PLUS] = ACTIONS(1357),
    [anon_sym_sizeof] = ACTIONS(1359),
    [sym_number_literal] = ACTIONS(4679),
    [sym_char_literal] = ACTIONS(4679),
    [sym_string_literal] = ACTIONS(1361),
    [sym_true] = ACTIONS(4683),
    [sym_false] = ACTIONS(4683),
    [sym_null] = ACTIONS(4683),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1365),
    [anon_sym_delete] = ACTIONS(1367),
    [sym_nullptr] = ACTIONS(4683),
  },
  [1498] = {
    [sym_initializer_list] = STATE(765),
    [sym_template_argument_list] = STATE(2039),
    [anon_sym_LPAREN] = ACTIONS(1483),
    [anon_sym_SEMI] = ACTIONS(1477),
    [anon_sym_extern] = ACTIONS(144),
    [anon_sym_LBRACE] = ACTIONS(548),
    [anon_sym_STAR] = ACTIONS(1486),
    [anon_sym_LBRACK] = ACTIONS(1477),
    [anon_sym_EQ] = ACTIONS(1479),
    [anon_sym_static] = ACTIONS(144),
    [anon_sym_register] = ACTIONS(144),
    [anon_sym_inline] = ACTIONS(144),
    [anon_sym_const] = ACTIONS(144),
    [anon_sym_restrict] = ACTIONS(144),
    [anon_sym_volatile] = ACTIONS(144),
    [anon_sym__Atomic] = ACTIONS(144),
    [anon_sym_mutable] = ACTIONS(144),
    [anon_sym_explicit] = ACTIONS(144),
    [anon_sym_constexpr] = ACTIONS(144),
    [anon_sym_QMARK] = ACTIONS(1477),
    [anon_sym_STAR_EQ] = ACTIONS(1477),
    [anon_sym_SLASH_EQ] = ACTIONS(1477),
    [anon_sym_PERCENT_EQ] = ACTIONS(1477),
    [anon_sym_PLUS_EQ] = ACTIONS(1477),
    [anon_sym_DASH_EQ] = ACTIONS(1477),
    [anon_sym_LT_LT_EQ] = ACTIONS(1477),
    [anon_sym_GT_GT_EQ] = ACTIONS(1477),
    [anon_sym_AMP_EQ] = ACTIONS(1477),
    [anon_sym_CARET_EQ] = ACTIONS(1477),
    [anon_sym_PIPE_EQ] = ACTIONS(1477),
    [anon_sym_AMP] = ACTIONS(1486),
    [anon_sym_PIPE_PIPE] = ACTIONS(1477),
    [anon_sym_AMP_AMP] = ACTIONS(1483),
    [anon_sym_PIPE] = ACTIONS(1479),
    [anon_sym_CARET] = ACTIONS(1479),
    [anon_sym_TILDE] = ACTIONS(142),
    [anon_sym_EQ_EQ] = ACTIONS(1477),
    [anon_sym_BANG_EQ] = ACTIONS(1477),
    [anon_sym_LT] = ACTIONS(1564),
    [anon_sym_GT] = ACTIONS(1479),
    [anon_sym_LT_EQ] = ACTIONS(1477),
    [anon_sym_GT_EQ] = ACTIONS(1477),
    [anon_sym_LT_LT] = ACTIONS(1479),
    [anon_sym_GT_GT] = ACTIONS(1479),
    [anon_sym_PLUS] = ACTIONS(1479),
    [anon_sym_DASH] = ACTIONS(1479),
    [anon_sym_SLASH] = ACTIONS(1479),
    [anon_sym_PERCENT] = ACTIONS(1479),
    [anon_sym_DASH_DASH] = ACTIONS(1477),
    [anon_sym_PLUS_PLUS] = ACTIONS(1477),
    [anon_sym_DOT] = ACTIONS(1477),
    [anon_sym_DASH_GT] = ACTIONS(1477),
    [sym_identifier] = ACTIONS(144),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(4631),
    [sym_operator_name] = ACTIONS(142),
  },
  [1499] = {
    [sym_destructor_name] = STATE(120),
    [anon_sym_TILDE] = ACTIONS(1500),
    [sym_identifier] = ACTIONS(4633),
    [sym_comment] = ACTIONS(49),
    [anon_sym_delete] = ACTIONS(2543),
    [sym_operator_name] = ACTIONS(190),
  },
  [1500] = {
    [sym__declarator] = STATE(2065),
    [sym_pointer_declarator] = STATE(2065),
    [sym_function_declarator] = STATE(2065),
    [sym_array_declarator] = STATE(2065),
    [sym_init_declarator] = STATE(2066),
    [sym_reference_declarator] = STATE(2065),
    [sym_template_type] = STATE(46),
    [sym_template_function] = STATE(2065),
    [sym_destructor_name] = STATE(2065),
    [sym_scoped_identifier] = STATE(2067),
    [sym_scoped_type_identifier] = STATE(47),
    [sym_scoped_namespace_identifier] = STATE(46),
    [anon_sym_LPAREN] = ACTIONS(11),
    [anon_sym_STAR] = ACTIONS(4685),
    [anon_sym_AMP] = ACTIONS(4687),
    [anon_sym_AMP_AMP] = ACTIONS(4689),
    [anon_sym_TILDE] = ACTIONS(45),
    [sym_identifier] = ACTIONS(75),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(77),
    [sym_operator_name] = ACTIONS(4691),
  },
  [1501] = {
    [sym_argument_list] = STATE(802),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_SEMI] = ACTIONS(4693),
    [anon_sym_STAR] = ACTIONS(2553),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_EQ] = ACTIONS(2555),
    [anon_sym_QMARK] = ACTIONS(2557),
    [anon_sym_STAR_EQ] = ACTIONS(2559),
    [anon_sym_SLASH_EQ] = ACTIONS(2559),
    [anon_sym_PERCENT_EQ] = ACTIONS(2559),
    [anon_sym_PLUS_EQ] = ACTIONS(2559),
    [anon_sym_DASH_EQ] = ACTIONS(2559),
    [anon_sym_LT_LT_EQ] = ACTIONS(2559),
    [anon_sym_GT_GT_EQ] = ACTIONS(2559),
    [anon_sym_AMP_EQ] = ACTIONS(2559),
    [anon_sym_CARET_EQ] = ACTIONS(2559),
    [anon_sym_PIPE_EQ] = ACTIONS(2559),
    [anon_sym_AMP] = ACTIONS(2561),
    [anon_sym_PIPE_PIPE] = ACTIONS(2563),
    [anon_sym_AMP_AMP] = ACTIONS(2565),
    [anon_sym_PIPE] = ACTIONS(2567),
    [anon_sym_CARET] = ACTIONS(2569),
    [anon_sym_EQ_EQ] = ACTIONS(2571),
    [anon_sym_BANG_EQ] = ACTIONS(2571),
    [anon_sym_LT] = ACTIONS(2573),
    [anon_sym_GT] = ACTIONS(2573),
    [anon_sym_LT_EQ] = ACTIONS(2575),
    [anon_sym_GT_EQ] = ACTIONS(2575),
    [anon_sym_LT_LT] = ACTIONS(2577),
    [anon_sym_GT_GT] = ACTIONS(2577),
    [anon_sym_PLUS] = ACTIONS(2579),
    [anon_sym_DASH] = ACTIONS(2579),
    [anon_sym_SLASH] = ACTIONS(2553),
    [anon_sym_PERCENT] = ACTIONS(2553),
    [anon_sym_DASH_DASH] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(1554),
    [anon_sym_DASH_GT] = ACTIONS(1554),
    [sym_comment] = ACTIONS(49),
  },
  [1502] = {
    [anon_sym_COLON] = ACTIONS(4695),
    [sym_comment] = ACTIONS(49),
  },
  [1503] = {
    [sym_raw_string_literal] = ACTIONS(4697),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(4699),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(4699),
    [anon_sym_LPAREN] = ACTIONS(4697),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(4699),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(4699),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(4699),
    [sym_preproc_directive] = ACTIONS(4699),
    [anon_sym_SEMI] = ACTIONS(4697),
    [anon_sym_typedef] = ACTIONS(4699),
    [anon_sym_extern] = ACTIONS(4699),
    [anon_sym_LBRACE] = ACTIONS(4697),
    [anon_sym_RBRACE] = ACTIONS(4697),
    [anon_sym_STAR] = ACTIONS(4697),
    [anon_sym_LBRACK] = ACTIONS(4697),
    [anon_sym_static] = ACTIONS(4699),
    [anon_sym_register] = ACTIONS(4699),
    [anon_sym_inline] = ACTIONS(4699),
    [anon_sym_const] = ACTIONS(4699),
    [anon_sym_restrict] = ACTIONS(4699),
    [anon_sym_volatile] = ACTIONS(4699),
    [anon_sym__Atomic] = ACTIONS(4699),
    [anon_sym_mutable] = ACTIONS(4699),
    [anon_sym_explicit] = ACTIONS(4699),
    [anon_sym_constexpr] = ACTIONS(4699),
    [anon_sym_unsigned] = ACTIONS(4699),
    [anon_sym_long] = ACTIONS(4699),
    [anon_sym_short] = ACTIONS(4699),
    [sym_primitive_type] = ACTIONS(4699),
    [anon_sym_enum] = ACTIONS(4699),
    [anon_sym_struct] = ACTIONS(4699),
    [anon_sym_union] = ACTIONS(4699),
    [anon_sym_if] = ACTIONS(4699),
    [anon_sym_switch] = ACTIONS(4699),
    [anon_sym_case] = ACTIONS(4699),
    [anon_sym_default] = ACTIONS(4699),
    [anon_sym_while] = ACTIONS(4699),
    [anon_sym_do] = ACTIONS(4699),
    [anon_sym_for] = ACTIONS(4699),
    [anon_sym_return] = ACTIONS(4699),
    [anon_sym_break] = ACTIONS(4699),
    [anon_sym_continue] = ACTIONS(4699),
    [anon_sym_goto] = ACTIONS(4699),
    [anon_sym_AMP] = ACTIONS(4697),
    [anon_sym_BANG] = ACTIONS(4697),
    [anon_sym_TILDE] = ACTIONS(4697),
    [anon_sym_PLUS] = ACTIONS(4699),
    [anon_sym_DASH] = ACTIONS(4699),
    [anon_sym_DASH_DASH] = ACTIONS(4697),
    [anon_sym_PLUS_PLUS] = ACTIONS(4697),
    [anon_sym_sizeof] = ACTIONS(4699),
    [sym_number_literal] = ACTIONS(4697),
    [sym_char_literal] = ACTIONS(4697),
    [sym_string_literal] = ACTIONS(4697),
    [sym_true] = ACTIONS(4699),
    [sym_false] = ACTIONS(4699),
    [sym_null] = ACTIONS(4699),
    [sym_identifier] = ACTIONS(4699),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(4699),
    [sym_auto] = ACTIONS(4699),
    [anon_sym_typename] = ACTIONS(4699),
    [anon_sym_new] = ACTIONS(4699),
    [anon_sym_COLON_COLON] = ACTIONS(4697),
    [anon_sym_delete] = ACTIONS(4699),
    [sym_nullptr] = ACTIONS(4699),
  },
  [1504] = {
    [sym_raw_string_literal] = ACTIONS(4701),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(4703),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(4703),
    [anon_sym_LPAREN] = ACTIONS(4701),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(4703),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(4703),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(4703),
    [sym_preproc_directive] = ACTIONS(4703),
    [anon_sym_SEMI] = ACTIONS(4701),
    [anon_sym_typedef] = ACTIONS(4703),
    [anon_sym_extern] = ACTIONS(4703),
    [anon_sym_LBRACE] = ACTIONS(4701),
    [anon_sym_RBRACE] = ACTIONS(4701),
    [anon_sym_STAR] = ACTIONS(4701),
    [anon_sym_LBRACK] = ACTIONS(4701),
    [anon_sym_static] = ACTIONS(4703),
    [anon_sym_register] = ACTIONS(4703),
    [anon_sym_inline] = ACTIONS(4703),
    [anon_sym_const] = ACTIONS(4703),
    [anon_sym_restrict] = ACTIONS(4703),
    [anon_sym_volatile] = ACTIONS(4703),
    [anon_sym__Atomic] = ACTIONS(4703),
    [anon_sym_mutable] = ACTIONS(4703),
    [anon_sym_explicit] = ACTIONS(4703),
    [anon_sym_constexpr] = ACTIONS(4703),
    [anon_sym_unsigned] = ACTIONS(4703),
    [anon_sym_long] = ACTIONS(4703),
    [anon_sym_short] = ACTIONS(4703),
    [sym_primitive_type] = ACTIONS(4703),
    [anon_sym_enum] = ACTIONS(4703),
    [anon_sym_struct] = ACTIONS(4703),
    [anon_sym_union] = ACTIONS(4703),
    [anon_sym_if] = ACTIONS(4703),
    [anon_sym_switch] = ACTIONS(4703),
    [anon_sym_case] = ACTIONS(4703),
    [anon_sym_default] = ACTIONS(4703),
    [anon_sym_while] = ACTIONS(4703),
    [anon_sym_do] = ACTIONS(4703),
    [anon_sym_for] = ACTIONS(4703),
    [anon_sym_return] = ACTIONS(4703),
    [anon_sym_break] = ACTIONS(4703),
    [anon_sym_continue] = ACTIONS(4703),
    [anon_sym_goto] = ACTIONS(4703),
    [anon_sym_AMP] = ACTIONS(4701),
    [anon_sym_BANG] = ACTIONS(4701),
    [anon_sym_TILDE] = ACTIONS(4701),
    [anon_sym_PLUS] = ACTIONS(4703),
    [anon_sym_DASH] = ACTIONS(4703),
    [anon_sym_DASH_DASH] = ACTIONS(4701),
    [anon_sym_PLUS_PLUS] = ACTIONS(4701),
    [anon_sym_sizeof] = ACTIONS(4703),
    [sym_number_literal] = ACTIONS(4701),
    [sym_char_literal] = ACTIONS(4701),
    [sym_string_literal] = ACTIONS(4701),
    [sym_true] = ACTIONS(4703),
    [sym_false] = ACTIONS(4703),
    [sym_null] = ACTIONS(4703),
    [sym_identifier] = ACTIONS(4703),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(4703),
    [sym_auto] = ACTIONS(4703),
    [anon_sym_typename] = ACTIONS(4703),
    [anon_sym_new] = ACTIONS(4703),
    [anon_sym_COLON_COLON] = ACTIONS(4701),
    [anon_sym_delete] = ACTIONS(4703),
    [sym_nullptr] = ACTIONS(4703),
  },
  [1505] = {
    [anon_sym_RPAREN] = ACTIONS(4705),
    [sym_comment] = ACTIONS(49),
  },
  [1506] = {
    [aux_sym_concatenated_string_repeat1] = STATE(1506),
    [anon_sym_LPAREN] = ACTIONS(4230),
    [anon_sym_COMMA] = ACTIONS(4230),
    [anon_sym_SEMI] = ACTIONS(4230),
    [anon_sym_STAR] = ACTIONS(4232),
    [anon_sym_LBRACK] = ACTIONS(4230),
    [anon_sym_EQ] = ACTIONS(4232),
    [anon_sym_QMARK] = ACTIONS(4230),
    [anon_sym_STAR_EQ] = ACTIONS(4230),
    [anon_sym_SLASH_EQ] = ACTIONS(4230),
    [anon_sym_PERCENT_EQ] = ACTIONS(4230),
    [anon_sym_PLUS_EQ] = ACTIONS(4230),
    [anon_sym_DASH_EQ] = ACTIONS(4230),
    [anon_sym_LT_LT_EQ] = ACTIONS(4230),
    [anon_sym_GT_GT_EQ] = ACTIONS(4230),
    [anon_sym_AMP_EQ] = ACTIONS(4230),
    [anon_sym_CARET_EQ] = ACTIONS(4230),
    [anon_sym_PIPE_EQ] = ACTIONS(4230),
    [anon_sym_AMP] = ACTIONS(4232),
    [anon_sym_PIPE_PIPE] = ACTIONS(4230),
    [anon_sym_AMP_AMP] = ACTIONS(4230),
    [anon_sym_PIPE] = ACTIONS(4232),
    [anon_sym_CARET] = ACTIONS(4232),
    [anon_sym_EQ_EQ] = ACTIONS(4230),
    [anon_sym_BANG_EQ] = ACTIONS(4230),
    [anon_sym_LT] = ACTIONS(4232),
    [anon_sym_GT] = ACTIONS(4232),
    [anon_sym_LT_EQ] = ACTIONS(4230),
    [anon_sym_GT_EQ] = ACTIONS(4230),
    [anon_sym_LT_LT] = ACTIONS(4232),
    [anon_sym_GT_GT] = ACTIONS(4232),
    [anon_sym_PLUS] = ACTIONS(4232),
    [anon_sym_DASH] = ACTIONS(4232),
    [anon_sym_SLASH] = ACTIONS(4232),
    [anon_sym_PERCENT] = ACTIONS(4232),
    [anon_sym_DASH_DASH] = ACTIONS(4230),
    [anon_sym_PLUS_PLUS] = ACTIONS(4230),
    [anon_sym_DOT] = ACTIONS(4230),
    [anon_sym_DASH_GT] = ACTIONS(4230),
    [sym_string_literal] = ACTIONS(4707),
    [sym_comment] = ACTIONS(49),
  },
  [1507] = {
    [sym_initializer_list] = STATE(765),
    [sym_template_argument_list] = STATE(1097),
    [anon_sym_LPAREN] = ACTIONS(1477),
    [anon_sym_COMMA] = ACTIONS(1477),
    [anon_sym_SEMI] = ACTIONS(1477),
    [anon_sym_LBRACE] = ACTIONS(548),
    [anon_sym_STAR] = ACTIONS(1479),
    [anon_sym_LBRACK] = ACTIONS(1477),
    [anon_sym_EQ] = ACTIONS(1479),
    [anon_sym_COLON] = ACTIONS(1714),
    [anon_sym_QMARK] = ACTIONS(1477),
    [anon_sym_STAR_EQ] = ACTIONS(1477),
    [anon_sym_SLASH_EQ] = ACTIONS(1477),
    [anon_sym_PERCENT_EQ] = ACTIONS(1477),
    [anon_sym_PLUS_EQ] = ACTIONS(1477),
    [anon_sym_DASH_EQ] = ACTIONS(1477),
    [anon_sym_LT_LT_EQ] = ACTIONS(1477),
    [anon_sym_GT_GT_EQ] = ACTIONS(1477),
    [anon_sym_AMP_EQ] = ACTIONS(1477),
    [anon_sym_CARET_EQ] = ACTIONS(1477),
    [anon_sym_PIPE_EQ] = ACTIONS(1477),
    [anon_sym_AMP] = ACTIONS(1479),
    [anon_sym_PIPE_PIPE] = ACTIONS(1477),
    [anon_sym_AMP_AMP] = ACTIONS(1477),
    [anon_sym_PIPE] = ACTIONS(1479),
    [anon_sym_CARET] = ACTIONS(1479),
    [anon_sym_EQ_EQ] = ACTIONS(1477),
    [anon_sym_BANG_EQ] = ACTIONS(1477),
    [anon_sym_LT] = ACTIONS(1564),
    [anon_sym_GT] = ACTIONS(1479),
    [anon_sym_LT_EQ] = ACTIONS(1477),
    [anon_sym_GT_EQ] = ACTIONS(1477),
    [anon_sym_LT_LT] = ACTIONS(1479),
    [anon_sym_GT_GT] = ACTIONS(1479),
    [anon_sym_PLUS] = ACTIONS(1479),
    [anon_sym_DASH] = ACTIONS(1479),
    [anon_sym_SLASH] = ACTIONS(1479),
    [anon_sym_PERCENT] = ACTIONS(1479),
    [anon_sym_DASH_DASH] = ACTIONS(1477),
    [anon_sym_PLUS_PLUS] = ACTIONS(1477),
    [anon_sym_DOT] = ACTIONS(1477),
    [anon_sym_DASH_GT] = ACTIONS(1477),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(2218),
  },
  [1508] = {
    [sym_raw_string_literal] = ACTIONS(4710),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(4712),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(4712),
    [anon_sym_LPAREN] = ACTIONS(4710),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(4712),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(4712),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(4712),
    [sym_preproc_directive] = ACTIONS(4712),
    [anon_sym_SEMI] = ACTIONS(4710),
    [anon_sym_typedef] = ACTIONS(4712),
    [anon_sym_extern] = ACTIONS(4712),
    [anon_sym_LBRACE] = ACTIONS(4710),
    [anon_sym_RBRACE] = ACTIONS(4710),
    [anon_sym_STAR] = ACTIONS(4710),
    [anon_sym_LBRACK] = ACTIONS(4710),
    [anon_sym_static] = ACTIONS(4712),
    [anon_sym_register] = ACTIONS(4712),
    [anon_sym_inline] = ACTIONS(4712),
    [anon_sym_const] = ACTIONS(4712),
    [anon_sym_restrict] = ACTIONS(4712),
    [anon_sym_volatile] = ACTIONS(4712),
    [anon_sym__Atomic] = ACTIONS(4712),
    [anon_sym_mutable] = ACTIONS(4712),
    [anon_sym_explicit] = ACTIONS(4712),
    [anon_sym_constexpr] = ACTIONS(4712),
    [anon_sym_unsigned] = ACTIONS(4712),
    [anon_sym_long] = ACTIONS(4712),
    [anon_sym_short] = ACTIONS(4712),
    [sym_primitive_type] = ACTIONS(4712),
    [anon_sym_enum] = ACTIONS(4712),
    [anon_sym_struct] = ACTIONS(4712),
    [anon_sym_union] = ACTIONS(4712),
    [anon_sym_if] = ACTIONS(4712),
    [anon_sym_switch] = ACTIONS(4712),
    [anon_sym_case] = ACTIONS(4712),
    [anon_sym_default] = ACTIONS(4712),
    [anon_sym_while] = ACTIONS(4712),
    [anon_sym_do] = ACTIONS(4712),
    [anon_sym_for] = ACTIONS(4712),
    [anon_sym_return] = ACTIONS(4712),
    [anon_sym_break] = ACTIONS(4712),
    [anon_sym_continue] = ACTIONS(4712),
    [anon_sym_goto] = ACTIONS(4712),
    [anon_sym_AMP] = ACTIONS(4710),
    [anon_sym_BANG] = ACTIONS(4710),
    [anon_sym_TILDE] = ACTIONS(4710),
    [anon_sym_PLUS] = ACTIONS(4712),
    [anon_sym_DASH] = ACTIONS(4712),
    [anon_sym_DASH_DASH] = ACTIONS(4710),
    [anon_sym_PLUS_PLUS] = ACTIONS(4710),
    [anon_sym_sizeof] = ACTIONS(4712),
    [sym_number_literal] = ACTIONS(4710),
    [sym_char_literal] = ACTIONS(4710),
    [sym_string_literal] = ACTIONS(4710),
    [sym_true] = ACTIONS(4712),
    [sym_false] = ACTIONS(4712),
    [sym_null] = ACTIONS(4712),
    [sym_identifier] = ACTIONS(4712),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(4712),
    [sym_auto] = ACTIONS(4712),
    [anon_sym_typename] = ACTIONS(4712),
    [anon_sym_new] = ACTIONS(4712),
    [anon_sym_COLON_COLON] = ACTIONS(4710),
    [anon_sym_delete] = ACTIONS(4712),
    [sym_nullptr] = ACTIONS(4712),
  },
  [1509] = {
    [anon_sym_LPAREN] = ACTIONS(1137),
    [anon_sym_COMMA] = ACTIONS(1146),
    [anon_sym_RPAREN] = ACTIONS(1137),
    [anon_sym_SEMI] = ACTIONS(1137),
    [anon_sym_extern] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(1140),
    [anon_sym_RBRACE] = ACTIONS(1146),
    [anon_sym_STAR] = ACTIONS(4239),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [anon_sym_EQ] = ACTIONS(1148),
    [anon_sym_static] = ACTIONS(1142),
    [anon_sym_register] = ACTIONS(1142),
    [anon_sym_inline] = ACTIONS(1142),
    [anon_sym_const] = ACTIONS(1142),
    [anon_sym_restrict] = ACTIONS(1142),
    [anon_sym_volatile] = ACTIONS(1142),
    [anon_sym__Atomic] = ACTIONS(1142),
    [anon_sym_mutable] = ACTIONS(1142),
    [anon_sym_explicit] = ACTIONS(1142),
    [anon_sym_constexpr] = ACTIONS(1142),
    [anon_sym_QMARK] = ACTIONS(1146),
    [anon_sym_STAR_EQ] = ACTIONS(1146),
    [anon_sym_SLASH_EQ] = ACTIONS(1146),
    [anon_sym_PERCENT_EQ] = ACTIONS(1146),
    [anon_sym_PLUS_EQ] = ACTIONS(1146),
    [anon_sym_DASH_EQ] = ACTIONS(1146),
    [anon_sym_LT_LT_EQ] = ACTIONS(1146),
    [anon_sym_GT_GT_EQ] = ACTIONS(1146),
    [anon_sym_AMP_EQ] = ACTIONS(1146),
    [anon_sym_CARET_EQ] = ACTIONS(1146),
    [anon_sym_PIPE_EQ] = ACTIONS(1146),
    [anon_sym_AMP] = ACTIONS(4239),
    [anon_sym_PIPE_PIPE] = ACTIONS(1146),
    [anon_sym_AMP_AMP] = ACTIONS(1137),
    [anon_sym_PIPE] = ACTIONS(1148),
    [anon_sym_CARET] = ACTIONS(1148),
    [anon_sym_TILDE] = ACTIONS(1140),
    [anon_sym_EQ_EQ] = ACTIONS(1146),
    [anon_sym_BANG_EQ] = ACTIONS(1146),
    [anon_sym_LT] = ACTIONS(4239),
    [anon_sym_GT] = ACTIONS(1148),
    [anon_sym_LT_EQ] = ACTIONS(1146),
    [anon_sym_GT_EQ] = ACTIONS(1146),
    [anon_sym_LT_LT] = ACTIONS(1148),
    [anon_sym_GT_GT] = ACTIONS(1148),
    [anon_sym_PLUS] = ACTIONS(1148),
    [anon_sym_DASH] = ACTIONS(1148),
    [anon_sym_SLASH] = ACTIONS(1148),
    [anon_sym_PERCENT] = ACTIONS(1148),
    [anon_sym_DASH_DASH] = ACTIONS(1146),
    [anon_sym_PLUS_PLUS] = ACTIONS(1146),
    [anon_sym_DOT] = ACTIONS(1146),
    [anon_sym_DASH_GT] = ACTIONS(1146),
    [sym_identifier] = ACTIONS(1142),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(1144),
    [sym_operator_name] = ACTIONS(1140),
  },
  [1510] = {
    [sym__expression] = STATE(740),
    [sym_conditional_expression] = STATE(740),
    [sym_assignment_expression] = STATE(740),
    [sym_pointer_expression] = STATE(740),
    [sym_logical_expression] = STATE(740),
    [sym_bitwise_expression] = STATE(740),
    [sym_equality_expression] = STATE(740),
    [sym_relational_expression] = STATE(740),
    [sym_shift_expression] = STATE(740),
    [sym_math_expression] = STATE(740),
    [sym_cast_expression] = STATE(740),
    [sym_sizeof_expression] = STATE(740),
    [sym_subscript_expression] = STATE(740),
    [sym_call_expression] = STATE(740),
    [sym_field_expression] = STATE(740),
    [sym_compound_literal_expression] = STATE(740),
    [sym_parenthesized_expression] = STATE(740),
    [sym_concatenated_string] = STATE(740),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(740),
    [sym_new_expression] = STATE(740),
    [sym_delete_expression] = STATE(740),
    [sym_lambda_expression] = STATE(740),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_lambda_default_capture] = STATE(741),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(1417),
    [anon_sym_LPAREN] = ACTIONS(1419),
    [anon_sym_STAR] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_RBRACK] = ACTIONS(4714),
    [anon_sym_EQ] = ACTIONS(1425),
    [anon_sym_AMP] = ACTIONS(1427),
    [anon_sym_BANG] = ACTIONS(1429),
    [anon_sym_TILDE] = ACTIONS(1431),
    [anon_sym_PLUS] = ACTIONS(1433),
    [anon_sym_DASH] = ACTIONS(1433),
    [anon_sym_DASH_DASH] = ACTIONS(1435),
    [anon_sym_PLUS_PLUS] = ACTIONS(1435),
    [anon_sym_sizeof] = ACTIONS(1437),
    [sym_number_literal] = ACTIONS(1417),
    [sym_char_literal] = ACTIONS(1417),
    [sym_string_literal] = ACTIONS(1439),
    [sym_true] = ACTIONS(1441),
    [sym_false] = ACTIONS(1441),
    [sym_null] = ACTIONS(1441),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1443),
    [anon_sym_delete] = ACTIONS(1445),
    [sym_nullptr] = ACTIONS(1441),
  },
  [1511] = {
    [sym_argument_list] = STATE(802),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_COMMA] = ACTIONS(4258),
    [anon_sym_SEMI] = ACTIONS(4258),
    [anon_sym_STAR] = ACTIONS(1744),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_EQ] = ACTIONS(4260),
    [anon_sym_QMARK] = ACTIONS(4258),
    [anon_sym_STAR_EQ] = ACTIONS(4258),
    [anon_sym_SLASH_EQ] = ACTIONS(4258),
    [anon_sym_PERCENT_EQ] = ACTIONS(4258),
    [anon_sym_PLUS_EQ] = ACTIONS(4258),
    [anon_sym_DASH_EQ] = ACTIONS(4258),
    [anon_sym_LT_LT_EQ] = ACTIONS(4258),
    [anon_sym_GT_GT_EQ] = ACTIONS(4258),
    [anon_sym_AMP_EQ] = ACTIONS(4258),
    [anon_sym_CARET_EQ] = ACTIONS(4258),
    [anon_sym_PIPE_EQ] = ACTIONS(4258),
    [anon_sym_AMP] = ACTIONS(1752),
    [anon_sym_PIPE_PIPE] = ACTIONS(1754),
    [anon_sym_AMP_AMP] = ACTIONS(1756),
    [anon_sym_PIPE] = ACTIONS(1758),
    [anon_sym_CARET] = ACTIONS(1760),
    [anon_sym_EQ_EQ] = ACTIONS(1762),
    [anon_sym_BANG_EQ] = ACTIONS(1762),
    [anon_sym_LT] = ACTIONS(1764),
    [anon_sym_GT] = ACTIONS(1764),
    [anon_sym_LT_EQ] = ACTIONS(1766),
    [anon_sym_GT_EQ] = ACTIONS(1766),
    [anon_sym_LT_LT] = ACTIONS(1768),
    [anon_sym_GT_GT] = ACTIONS(1768),
    [anon_sym_PLUS] = ACTIONS(1770),
    [anon_sym_DASH] = ACTIONS(1770),
    [anon_sym_SLASH] = ACTIONS(1744),
    [anon_sym_PERCENT] = ACTIONS(1744),
    [anon_sym_DASH_DASH] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(1554),
    [anon_sym_DASH_GT] = ACTIONS(1554),
    [sym_comment] = ACTIONS(49),
  },
  [1512] = {
    [sym__expression] = STATE(2072),
    [sym_conditional_expression] = STATE(2072),
    [sym_assignment_expression] = STATE(2072),
    [sym_pointer_expression] = STATE(2072),
    [sym_logical_expression] = STATE(2072),
    [sym_bitwise_expression] = STATE(2072),
    [sym_equality_expression] = STATE(2072),
    [sym_relational_expression] = STATE(2072),
    [sym_shift_expression] = STATE(2072),
    [sym_math_expression] = STATE(2072),
    [sym_cast_expression] = STATE(2072),
    [sym_sizeof_expression] = STATE(2072),
    [sym_subscript_expression] = STATE(2072),
    [sym_call_expression] = STATE(2072),
    [sym_field_expression] = STATE(2072),
    [sym_compound_literal_expression] = STATE(2072),
    [sym_parenthesized_expression] = STATE(2072),
    [sym_concatenated_string] = STATE(2072),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(2072),
    [sym_new_expression] = STATE(2072),
    [sym_delete_expression] = STATE(2072),
    [sym_lambda_expression] = STATE(2072),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(4716),
    [anon_sym_LPAREN] = ACTIONS(2624),
    [anon_sym_STAR] = ACTIONS(2624),
    [anon_sym_LBRACK] = ACTIONS(2624),
    [anon_sym_AMP] = ACTIONS(2626),
    [anon_sym_AMP_AMP] = ACTIONS(2624),
    [anon_sym_BANG] = ACTIONS(668),
    [anon_sym_TILDE] = ACTIONS(670),
    [anon_sym_PLUS] = ACTIONS(672),
    [anon_sym_DASH] = ACTIONS(672),
    [anon_sym_DASH_DASH] = ACTIONS(674),
    [anon_sym_PLUS_PLUS] = ACTIONS(674),
    [anon_sym_sizeof] = ACTIONS(676),
    [sym_number_literal] = ACTIONS(4716),
    [sym_char_literal] = ACTIONS(4716),
    [sym_string_literal] = ACTIONS(678),
    [sym_true] = ACTIONS(4718),
    [sym_false] = ACTIONS(4718),
    [sym_null] = ACTIONS(4718),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1303),
    [anon_sym_delete] = ACTIONS(686),
    [sym_nullptr] = ACTIONS(4718),
  },
  [1513] = {
    [sym_raw_string_literal] = ACTIONS(1261),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1263),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1263),
    [anon_sym_LPAREN] = ACTIONS(1261),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1263),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1263),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1263),
    [sym_preproc_directive] = ACTIONS(1263),
    [anon_sym_SEMI] = ACTIONS(1261),
    [anon_sym_typedef] = ACTIONS(1263),
    [anon_sym_extern] = ACTIONS(1263),
    [anon_sym_LBRACE] = ACTIONS(1261),
    [anon_sym_RBRACE] = ACTIONS(1261),
    [anon_sym_STAR] = ACTIONS(1261),
    [anon_sym_LBRACK] = ACTIONS(1261),
    [anon_sym_static] = ACTIONS(1263),
    [anon_sym_register] = ACTIONS(1263),
    [anon_sym_inline] = ACTIONS(1263),
    [anon_sym_const] = ACTIONS(1263),
    [anon_sym_restrict] = ACTIONS(1263),
    [anon_sym_volatile] = ACTIONS(1263),
    [anon_sym__Atomic] = ACTIONS(1263),
    [anon_sym_mutable] = ACTIONS(1263),
    [anon_sym_explicit] = ACTIONS(1263),
    [anon_sym_constexpr] = ACTIONS(1263),
    [anon_sym_unsigned] = ACTIONS(1263),
    [anon_sym_long] = ACTIONS(1263),
    [anon_sym_short] = ACTIONS(1263),
    [sym_primitive_type] = ACTIONS(1263),
    [anon_sym_enum] = ACTIONS(1263),
    [anon_sym_struct] = ACTIONS(1263),
    [anon_sym_union] = ACTIONS(1263),
    [anon_sym_if] = ACTIONS(1263),
    [anon_sym_switch] = ACTIONS(1263),
    [anon_sym_case] = ACTIONS(1263),
    [anon_sym_default] = ACTIONS(1263),
    [anon_sym_while] = ACTIONS(1263),
    [anon_sym_do] = ACTIONS(1263),
    [anon_sym_for] = ACTIONS(1263),
    [anon_sym_return] = ACTIONS(1263),
    [anon_sym_break] = ACTIONS(1263),
    [anon_sym_continue] = ACTIONS(1263),
    [anon_sym_goto] = ACTIONS(1263),
    [anon_sym_AMP] = ACTIONS(1261),
    [anon_sym_BANG] = ACTIONS(1261),
    [anon_sym_TILDE] = ACTIONS(1261),
    [anon_sym_PLUS] = ACTIONS(1263),
    [anon_sym_DASH] = ACTIONS(1263),
    [anon_sym_DASH_DASH] = ACTIONS(1261),
    [anon_sym_PLUS_PLUS] = ACTIONS(1261),
    [anon_sym_sizeof] = ACTIONS(1263),
    [sym_number_literal] = ACTIONS(1261),
    [sym_char_literal] = ACTIONS(1261),
    [sym_string_literal] = ACTIONS(1261),
    [sym_true] = ACTIONS(1263),
    [sym_false] = ACTIONS(1263),
    [sym_null] = ACTIONS(1263),
    [sym_identifier] = ACTIONS(1263),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(1263),
    [sym_auto] = ACTIONS(1263),
    [anon_sym_typename] = ACTIONS(1263),
    [anon_sym_new] = ACTIONS(1263),
    [anon_sym_COLON_COLON] = ACTIONS(1261),
    [anon_sym_delete] = ACTIONS(1263),
    [sym_nullptr] = ACTIONS(1263),
  },
  [1514] = {
    [aux_sym_declaration_repeat1] = STATE(678),
    [anon_sym_COMMA] = ACTIONS(538),
    [anon_sym_SEMI] = ACTIONS(4720),
    [sym_comment] = ACTIONS(49),
  },
  [1515] = {
    [sym__expression] = STATE(2074),
    [sym_conditional_expression] = STATE(2074),
    [sym_assignment_expression] = STATE(2074),
    [sym_pointer_expression] = STATE(2074),
    [sym_logical_expression] = STATE(2074),
    [sym_bitwise_expression] = STATE(2074),
    [sym_equality_expression] = STATE(2074),
    [sym_relational_expression] = STATE(2074),
    [sym_shift_expression] = STATE(2074),
    [sym_math_expression] = STATE(2074),
    [sym_cast_expression] = STATE(2074),
    [sym_sizeof_expression] = STATE(2074),
    [sym_subscript_expression] = STATE(2074),
    [sym_call_expression] = STATE(2074),
    [sym_field_expression] = STATE(2074),
    [sym_compound_literal_expression] = STATE(2074),
    [sym_parenthesized_expression] = STATE(2074),
    [sym_initializer_list] = STATE(2075),
    [sym_concatenated_string] = STATE(2074),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(2074),
    [sym_new_expression] = STATE(2074),
    [sym_delete_expression] = STATE(2074),
    [sym_lambda_expression] = STATE(2074),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(4722),
    [anon_sym_LPAREN] = ACTIONS(1347),
    [anon_sym_LBRACE] = ACTIONS(548),
    [anon_sym_STAR] = ACTIONS(1349),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_AMP] = ACTIONS(1349),
    [anon_sym_BANG] = ACTIONS(1351),
    [anon_sym_TILDE] = ACTIONS(1353),
    [anon_sym_PLUS] = ACTIONS(1355),
    [anon_sym_DASH] = ACTIONS(1355),
    [anon_sym_DASH_DASH] = ACTIONS(1357),
    [anon_sym_PLUS_PLUS] = ACTIONS(1357),
    [anon_sym_sizeof] = ACTIONS(1359),
    [sym_number_literal] = ACTIONS(4722),
    [sym_char_literal] = ACTIONS(4722),
    [sym_string_literal] = ACTIONS(1361),
    [sym_true] = ACTIONS(4724),
    [sym_false] = ACTIONS(4724),
    [sym_null] = ACTIONS(4724),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1365),
    [anon_sym_delete] = ACTIONS(1367),
    [sym_nullptr] = ACTIONS(4724),
  },
  [1516] = {
    [anon_sym_SEMI] = ACTIONS(4726),
    [sym_comment] = ACTIONS(49),
  },
  [1517] = {
    [sym__expression] = STATE(2077),
    [sym_conditional_expression] = STATE(2077),
    [sym_assignment_expression] = STATE(2077),
    [sym_pointer_expression] = STATE(2077),
    [sym_logical_expression] = STATE(2077),
    [sym_bitwise_expression] = STATE(2077),
    [sym_equality_expression] = STATE(2077),
    [sym_relational_expression] = STATE(2077),
    [sym_shift_expression] = STATE(2077),
    [sym_math_expression] = STATE(2077),
    [sym_cast_expression] = STATE(2077),
    [sym_sizeof_expression] = STATE(2077),
    [sym_subscript_expression] = STATE(2077),
    [sym_call_expression] = STATE(2077),
    [sym_field_expression] = STATE(2077),
    [sym_compound_literal_expression] = STATE(2077),
    [sym_parenthesized_expression] = STATE(2077),
    [sym_initializer_list] = STATE(2078),
    [sym_concatenated_string] = STATE(2077),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(2077),
    [sym_new_expression] = STATE(2077),
    [sym_delete_expression] = STATE(2077),
    [sym_lambda_expression] = STATE(2077),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(4728),
    [anon_sym_LPAREN] = ACTIONS(1347),
    [anon_sym_LBRACE] = ACTIONS(548),
    [anon_sym_STAR] = ACTIONS(1349),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_AMP] = ACTIONS(1349),
    [anon_sym_BANG] = ACTIONS(1351),
    [anon_sym_TILDE] = ACTIONS(1353),
    [anon_sym_PLUS] = ACTIONS(1355),
    [anon_sym_DASH] = ACTIONS(1355),
    [anon_sym_DASH_DASH] = ACTIONS(1357),
    [anon_sym_PLUS_PLUS] = ACTIONS(1357),
    [anon_sym_sizeof] = ACTIONS(1359),
    [sym_number_literal] = ACTIONS(4728),
    [sym_char_literal] = ACTIONS(4728),
    [sym_string_literal] = ACTIONS(1361),
    [sym_true] = ACTIONS(4730),
    [sym_false] = ACTIONS(4730),
    [sym_null] = ACTIONS(4730),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1365),
    [anon_sym_delete] = ACTIONS(1367),
    [sym_nullptr] = ACTIONS(4730),
  },
  [1518] = {
    [anon_sym_SEMI] = ACTIONS(4732),
    [sym_comment] = ACTIONS(49),
  },
  [1519] = {
    [sym_argument_list] = STATE(802),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_COMMA] = ACTIONS(1740),
    [anon_sym_SEMI] = ACTIONS(4734),
    [anon_sym_STAR] = ACTIONS(1744),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_EQ] = ACTIONS(1746),
    [anon_sym_QMARK] = ACTIONS(1748),
    [anon_sym_STAR_EQ] = ACTIONS(1750),
    [anon_sym_SLASH_EQ] = ACTIONS(1750),
    [anon_sym_PERCENT_EQ] = ACTIONS(1750),
    [anon_sym_PLUS_EQ] = ACTIONS(1750),
    [anon_sym_DASH_EQ] = ACTIONS(1750),
    [anon_sym_LT_LT_EQ] = ACTIONS(1750),
    [anon_sym_GT_GT_EQ] = ACTIONS(1750),
    [anon_sym_AMP_EQ] = ACTIONS(1750),
    [anon_sym_CARET_EQ] = ACTIONS(1750),
    [anon_sym_PIPE_EQ] = ACTIONS(1750),
    [anon_sym_AMP] = ACTIONS(1752),
    [anon_sym_PIPE_PIPE] = ACTIONS(1754),
    [anon_sym_AMP_AMP] = ACTIONS(1756),
    [anon_sym_PIPE] = ACTIONS(1758),
    [anon_sym_CARET] = ACTIONS(1760),
    [anon_sym_EQ_EQ] = ACTIONS(1762),
    [anon_sym_BANG_EQ] = ACTIONS(1762),
    [anon_sym_LT] = ACTIONS(1764),
    [anon_sym_GT] = ACTIONS(1764),
    [anon_sym_LT_EQ] = ACTIONS(1766),
    [anon_sym_GT_EQ] = ACTIONS(1766),
    [anon_sym_LT_LT] = ACTIONS(1768),
    [anon_sym_GT_GT] = ACTIONS(1768),
    [anon_sym_PLUS] = ACTIONS(1770),
    [anon_sym_DASH] = ACTIONS(1770),
    [anon_sym_SLASH] = ACTIONS(1744),
    [anon_sym_PERCENT] = ACTIONS(1744),
    [anon_sym_DASH_DASH] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(1554),
    [anon_sym_DASH_GT] = ACTIONS(1554),
    [sym_comment] = ACTIONS(49),
  },
  [1520] = {
    [anon_sym_RPAREN] = ACTIONS(4734),
    [anon_sym_SEMI] = ACTIONS(4734),
    [sym_comment] = ACTIONS(49),
  },
  [1521] = {
    [sym_argument_list] = STATE(802),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_COMMA] = ACTIONS(4280),
    [anon_sym_SEMI] = ACTIONS(4280),
    [anon_sym_STAR] = ACTIONS(1744),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_EQ] = ACTIONS(1746),
    [anon_sym_QMARK] = ACTIONS(4280),
    [anon_sym_STAR_EQ] = ACTIONS(1750),
    [anon_sym_SLASH_EQ] = ACTIONS(1750),
    [anon_sym_PERCENT_EQ] = ACTIONS(1750),
    [anon_sym_PLUS_EQ] = ACTIONS(1750),
    [anon_sym_DASH_EQ] = ACTIONS(1750),
    [anon_sym_LT_LT_EQ] = ACTIONS(1750),
    [anon_sym_GT_GT_EQ] = ACTIONS(1750),
    [anon_sym_AMP_EQ] = ACTIONS(1750),
    [anon_sym_CARET_EQ] = ACTIONS(1750),
    [anon_sym_PIPE_EQ] = ACTIONS(1750),
    [anon_sym_AMP] = ACTIONS(1752),
    [anon_sym_PIPE_PIPE] = ACTIONS(1754),
    [anon_sym_AMP_AMP] = ACTIONS(1756),
    [anon_sym_PIPE] = ACTIONS(1758),
    [anon_sym_CARET] = ACTIONS(1760),
    [anon_sym_EQ_EQ] = ACTIONS(1762),
    [anon_sym_BANG_EQ] = ACTIONS(1762),
    [anon_sym_LT] = ACTIONS(1764),
    [anon_sym_GT] = ACTIONS(1764),
    [anon_sym_LT_EQ] = ACTIONS(1766),
    [anon_sym_GT_EQ] = ACTIONS(1766),
    [anon_sym_LT_LT] = ACTIONS(1768),
    [anon_sym_GT_GT] = ACTIONS(1768),
    [anon_sym_PLUS] = ACTIONS(1770),
    [anon_sym_DASH] = ACTIONS(1770),
    [anon_sym_SLASH] = ACTIONS(1744),
    [anon_sym_PERCENT] = ACTIONS(1744),
    [anon_sym_DASH_DASH] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(1554),
    [anon_sym_DASH_GT] = ACTIONS(1554),
    [sym_comment] = ACTIONS(49),
  },
  [1522] = {
    [sym_argument_list] = STATE(802),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_STAR] = ACTIONS(3003),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_EQ] = ACTIONS(3005),
    [anon_sym_COLON] = ACTIONS(4736),
    [anon_sym_QMARK] = ACTIONS(3009),
    [anon_sym_STAR_EQ] = ACTIONS(3011),
    [anon_sym_SLASH_EQ] = ACTIONS(3011),
    [anon_sym_PERCENT_EQ] = ACTIONS(3011),
    [anon_sym_PLUS_EQ] = ACTIONS(3011),
    [anon_sym_DASH_EQ] = ACTIONS(3011),
    [anon_sym_LT_LT_EQ] = ACTIONS(3011),
    [anon_sym_GT_GT_EQ] = ACTIONS(3011),
    [anon_sym_AMP_EQ] = ACTIONS(3011),
    [anon_sym_CARET_EQ] = ACTIONS(3011),
    [anon_sym_PIPE_EQ] = ACTIONS(3011),
    [anon_sym_AMP] = ACTIONS(3013),
    [anon_sym_PIPE_PIPE] = ACTIONS(3015),
    [anon_sym_AMP_AMP] = ACTIONS(3017),
    [anon_sym_PIPE] = ACTIONS(3019),
    [anon_sym_CARET] = ACTIONS(3021),
    [anon_sym_EQ_EQ] = ACTIONS(3023),
    [anon_sym_BANG_EQ] = ACTIONS(3023),
    [anon_sym_LT] = ACTIONS(3025),
    [anon_sym_GT] = ACTIONS(3025),
    [anon_sym_LT_EQ] = ACTIONS(3027),
    [anon_sym_GT_EQ] = ACTIONS(3027),
    [anon_sym_LT_LT] = ACTIONS(3029),
    [anon_sym_GT_GT] = ACTIONS(3029),
    [anon_sym_PLUS] = ACTIONS(3031),
    [anon_sym_DASH] = ACTIONS(3031),
    [anon_sym_SLASH] = ACTIONS(3003),
    [anon_sym_PERCENT] = ACTIONS(3003),
    [anon_sym_DASH_DASH] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(3033),
    [anon_sym_DASH_GT] = ACTIONS(3033),
    [sym_comment] = ACTIONS(49),
  },
  [1523] = {
    [sym_argument_list] = STATE(802),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_COMMA] = ACTIONS(4284),
    [anon_sym_SEMI] = ACTIONS(4284),
    [anon_sym_STAR] = ACTIONS(1744),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_EQ] = ACTIONS(4286),
    [anon_sym_QMARK] = ACTIONS(4284),
    [anon_sym_STAR_EQ] = ACTIONS(4284),
    [anon_sym_SLASH_EQ] = ACTIONS(4284),
    [anon_sym_PERCENT_EQ] = ACTIONS(4284),
    [anon_sym_PLUS_EQ] = ACTIONS(4284),
    [anon_sym_DASH_EQ] = ACTIONS(4284),
    [anon_sym_LT_LT_EQ] = ACTIONS(4284),
    [anon_sym_GT_GT_EQ] = ACTIONS(4284),
    [anon_sym_AMP_EQ] = ACTIONS(4284),
    [anon_sym_CARET_EQ] = ACTIONS(4284),
    [anon_sym_PIPE_EQ] = ACTIONS(4284),
    [anon_sym_AMP] = ACTIONS(4286),
    [anon_sym_PIPE_PIPE] = ACTIONS(4284),
    [anon_sym_AMP_AMP] = ACTIONS(4284),
    [anon_sym_PIPE] = ACTIONS(4286),
    [anon_sym_CARET] = ACTIONS(4286),
    [anon_sym_EQ_EQ] = ACTIONS(1762),
    [anon_sym_BANG_EQ] = ACTIONS(1762),
    [anon_sym_LT] = ACTIONS(1764),
    [anon_sym_GT] = ACTIONS(1764),
    [anon_sym_LT_EQ] = ACTIONS(1766),
    [anon_sym_GT_EQ] = ACTIONS(1766),
    [anon_sym_LT_LT] = ACTIONS(1768),
    [anon_sym_GT_GT] = ACTIONS(1768),
    [anon_sym_PLUS] = ACTIONS(1770),
    [anon_sym_DASH] = ACTIONS(1770),
    [anon_sym_SLASH] = ACTIONS(1744),
    [anon_sym_PERCENT] = ACTIONS(1744),
    [anon_sym_DASH_DASH] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(1554),
    [anon_sym_DASH_GT] = ACTIONS(1554),
    [sym_comment] = ACTIONS(49),
  },
  [1524] = {
    [sym_argument_list] = STATE(802),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_COMMA] = ACTIONS(4288),
    [anon_sym_SEMI] = ACTIONS(4288),
    [anon_sym_STAR] = ACTIONS(1744),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_EQ] = ACTIONS(4290),
    [anon_sym_QMARK] = ACTIONS(4288),
    [anon_sym_STAR_EQ] = ACTIONS(4288),
    [anon_sym_SLASH_EQ] = ACTIONS(4288),
    [anon_sym_PERCENT_EQ] = ACTIONS(4288),
    [anon_sym_PLUS_EQ] = ACTIONS(4288),
    [anon_sym_DASH_EQ] = ACTIONS(4288),
    [anon_sym_LT_LT_EQ] = ACTIONS(4288),
    [anon_sym_GT_GT_EQ] = ACTIONS(4288),
    [anon_sym_AMP_EQ] = ACTIONS(4288),
    [anon_sym_CARET_EQ] = ACTIONS(4288),
    [anon_sym_PIPE_EQ] = ACTIONS(4288),
    [anon_sym_AMP] = ACTIONS(1752),
    [anon_sym_PIPE_PIPE] = ACTIONS(4288),
    [anon_sym_AMP_AMP] = ACTIONS(1756),
    [anon_sym_PIPE] = ACTIONS(1758),
    [anon_sym_CARET] = ACTIONS(1760),
    [anon_sym_EQ_EQ] = ACTIONS(1762),
    [anon_sym_BANG_EQ] = ACTIONS(1762),
    [anon_sym_LT] = ACTIONS(1764),
    [anon_sym_GT] = ACTIONS(1764),
    [anon_sym_LT_EQ] = ACTIONS(1766),
    [anon_sym_GT_EQ] = ACTIONS(1766),
    [anon_sym_LT_LT] = ACTIONS(1768),
    [anon_sym_GT_GT] = ACTIONS(1768),
    [anon_sym_PLUS] = ACTIONS(1770),
    [anon_sym_DASH] = ACTIONS(1770),
    [anon_sym_SLASH] = ACTIONS(1744),
    [anon_sym_PERCENT] = ACTIONS(1744),
    [anon_sym_DASH_DASH] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(1554),
    [anon_sym_DASH_GT] = ACTIONS(1554),
    [sym_comment] = ACTIONS(49),
  },
  [1525] = {
    [sym_argument_list] = STATE(802),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_COMMA] = ACTIONS(4288),
    [anon_sym_SEMI] = ACTIONS(4288),
    [anon_sym_STAR] = ACTIONS(1744),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_EQ] = ACTIONS(4290),
    [anon_sym_QMARK] = ACTIONS(4288),
    [anon_sym_STAR_EQ] = ACTIONS(4288),
    [anon_sym_SLASH_EQ] = ACTIONS(4288),
    [anon_sym_PERCENT_EQ] = ACTIONS(4288),
    [anon_sym_PLUS_EQ] = ACTIONS(4288),
    [anon_sym_DASH_EQ] = ACTIONS(4288),
    [anon_sym_LT_LT_EQ] = ACTIONS(4288),
    [anon_sym_GT_GT_EQ] = ACTIONS(4288),
    [anon_sym_AMP_EQ] = ACTIONS(4288),
    [anon_sym_CARET_EQ] = ACTIONS(4288),
    [anon_sym_PIPE_EQ] = ACTIONS(4288),
    [anon_sym_AMP] = ACTIONS(1752),
    [anon_sym_PIPE_PIPE] = ACTIONS(4288),
    [anon_sym_AMP_AMP] = ACTIONS(4288),
    [anon_sym_PIPE] = ACTIONS(1758),
    [anon_sym_CARET] = ACTIONS(1760),
    [anon_sym_EQ_EQ] = ACTIONS(1762),
    [anon_sym_BANG_EQ] = ACTIONS(1762),
    [anon_sym_LT] = ACTIONS(1764),
    [anon_sym_GT] = ACTIONS(1764),
    [anon_sym_LT_EQ] = ACTIONS(1766),
    [anon_sym_GT_EQ] = ACTIONS(1766),
    [anon_sym_LT_LT] = ACTIONS(1768),
    [anon_sym_GT_GT] = ACTIONS(1768),
    [anon_sym_PLUS] = ACTIONS(1770),
    [anon_sym_DASH] = ACTIONS(1770),
    [anon_sym_SLASH] = ACTIONS(1744),
    [anon_sym_PERCENT] = ACTIONS(1744),
    [anon_sym_DASH_DASH] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(1554),
    [anon_sym_DASH_GT] = ACTIONS(1554),
    [sym_comment] = ACTIONS(49),
  },
  [1526] = {
    [sym_argument_list] = STATE(802),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_COMMA] = ACTIONS(4284),
    [anon_sym_SEMI] = ACTIONS(4284),
    [anon_sym_STAR] = ACTIONS(1744),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_EQ] = ACTIONS(4286),
    [anon_sym_QMARK] = ACTIONS(4284),
    [anon_sym_STAR_EQ] = ACTIONS(4284),
    [anon_sym_SLASH_EQ] = ACTIONS(4284),
    [anon_sym_PERCENT_EQ] = ACTIONS(4284),
    [anon_sym_PLUS_EQ] = ACTIONS(4284),
    [anon_sym_DASH_EQ] = ACTIONS(4284),
    [anon_sym_LT_LT_EQ] = ACTIONS(4284),
    [anon_sym_GT_GT_EQ] = ACTIONS(4284),
    [anon_sym_AMP_EQ] = ACTIONS(4284),
    [anon_sym_CARET_EQ] = ACTIONS(4284),
    [anon_sym_PIPE_EQ] = ACTIONS(4284),
    [anon_sym_AMP] = ACTIONS(1752),
    [anon_sym_PIPE_PIPE] = ACTIONS(4284),
    [anon_sym_AMP_AMP] = ACTIONS(4284),
    [anon_sym_PIPE] = ACTIONS(4286),
    [anon_sym_CARET] = ACTIONS(1760),
    [anon_sym_EQ_EQ] = ACTIONS(1762),
    [anon_sym_BANG_EQ] = ACTIONS(1762),
    [anon_sym_LT] = ACTIONS(1764),
    [anon_sym_GT] = ACTIONS(1764),
    [anon_sym_LT_EQ] = ACTIONS(1766),
    [anon_sym_GT_EQ] = ACTIONS(1766),
    [anon_sym_LT_LT] = ACTIONS(1768),
    [anon_sym_GT_GT] = ACTIONS(1768),
    [anon_sym_PLUS] = ACTIONS(1770),
    [anon_sym_DASH] = ACTIONS(1770),
    [anon_sym_SLASH] = ACTIONS(1744),
    [anon_sym_PERCENT] = ACTIONS(1744),
    [anon_sym_DASH_DASH] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(1554),
    [anon_sym_DASH_GT] = ACTIONS(1554),
    [sym_comment] = ACTIONS(49),
  },
  [1527] = {
    [sym_argument_list] = STATE(802),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_COMMA] = ACTIONS(4284),
    [anon_sym_SEMI] = ACTIONS(4284),
    [anon_sym_STAR] = ACTIONS(1744),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_EQ] = ACTIONS(4286),
    [anon_sym_QMARK] = ACTIONS(4284),
    [anon_sym_STAR_EQ] = ACTIONS(4284),
    [anon_sym_SLASH_EQ] = ACTIONS(4284),
    [anon_sym_PERCENT_EQ] = ACTIONS(4284),
    [anon_sym_PLUS_EQ] = ACTIONS(4284),
    [anon_sym_DASH_EQ] = ACTIONS(4284),
    [anon_sym_LT_LT_EQ] = ACTIONS(4284),
    [anon_sym_GT_GT_EQ] = ACTIONS(4284),
    [anon_sym_AMP_EQ] = ACTIONS(4284),
    [anon_sym_CARET_EQ] = ACTIONS(4284),
    [anon_sym_PIPE_EQ] = ACTIONS(4284),
    [anon_sym_AMP] = ACTIONS(1752),
    [anon_sym_PIPE_PIPE] = ACTIONS(4284),
    [anon_sym_AMP_AMP] = ACTIONS(4284),
    [anon_sym_PIPE] = ACTIONS(4286),
    [anon_sym_CARET] = ACTIONS(4286),
    [anon_sym_EQ_EQ] = ACTIONS(1762),
    [anon_sym_BANG_EQ] = ACTIONS(1762),
    [anon_sym_LT] = ACTIONS(1764),
    [anon_sym_GT] = ACTIONS(1764),
    [anon_sym_LT_EQ] = ACTIONS(1766),
    [anon_sym_GT_EQ] = ACTIONS(1766),
    [anon_sym_LT_LT] = ACTIONS(1768),
    [anon_sym_GT_GT] = ACTIONS(1768),
    [anon_sym_PLUS] = ACTIONS(1770),
    [anon_sym_DASH] = ACTIONS(1770),
    [anon_sym_SLASH] = ACTIONS(1744),
    [anon_sym_PERCENT] = ACTIONS(1744),
    [anon_sym_DASH_DASH] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(1554),
    [anon_sym_DASH_GT] = ACTIONS(1554),
    [sym_comment] = ACTIONS(49),
  },
  [1528] = {
    [sym_argument_list] = STATE(802),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_COMMA] = ACTIONS(4292),
    [anon_sym_SEMI] = ACTIONS(4292),
    [anon_sym_STAR] = ACTIONS(1744),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_EQ] = ACTIONS(4294),
    [anon_sym_QMARK] = ACTIONS(4292),
    [anon_sym_STAR_EQ] = ACTIONS(4292),
    [anon_sym_SLASH_EQ] = ACTIONS(4292),
    [anon_sym_PERCENT_EQ] = ACTIONS(4292),
    [anon_sym_PLUS_EQ] = ACTIONS(4292),
    [anon_sym_DASH_EQ] = ACTIONS(4292),
    [anon_sym_LT_LT_EQ] = ACTIONS(4292),
    [anon_sym_GT_GT_EQ] = ACTIONS(4292),
    [anon_sym_AMP_EQ] = ACTIONS(4292),
    [anon_sym_CARET_EQ] = ACTIONS(4292),
    [anon_sym_PIPE_EQ] = ACTIONS(4292),
    [anon_sym_AMP] = ACTIONS(4294),
    [anon_sym_PIPE_PIPE] = ACTIONS(4292),
    [anon_sym_AMP_AMP] = ACTIONS(4292),
    [anon_sym_PIPE] = ACTIONS(4294),
    [anon_sym_CARET] = ACTIONS(4294),
    [anon_sym_EQ_EQ] = ACTIONS(4292),
    [anon_sym_BANG_EQ] = ACTIONS(4292),
    [anon_sym_LT] = ACTIONS(1764),
    [anon_sym_GT] = ACTIONS(1764),
    [anon_sym_LT_EQ] = ACTIONS(1766),
    [anon_sym_GT_EQ] = ACTIONS(1766),
    [anon_sym_LT_LT] = ACTIONS(1768),
    [anon_sym_GT_GT] = ACTIONS(1768),
    [anon_sym_PLUS] = ACTIONS(1770),
    [anon_sym_DASH] = ACTIONS(1770),
    [anon_sym_SLASH] = ACTIONS(1744),
    [anon_sym_PERCENT] = ACTIONS(1744),
    [anon_sym_DASH_DASH] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(1554),
    [anon_sym_DASH_GT] = ACTIONS(1554),
    [sym_comment] = ACTIONS(49),
  },
  [1529] = {
    [sym_argument_list] = STATE(802),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_COMMA] = ACTIONS(4296),
    [anon_sym_SEMI] = ACTIONS(4296),
    [anon_sym_STAR] = ACTIONS(1744),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_EQ] = ACTIONS(4298),
    [anon_sym_QMARK] = ACTIONS(4296),
    [anon_sym_STAR_EQ] = ACTIONS(4296),
    [anon_sym_SLASH_EQ] = ACTIONS(4296),
    [anon_sym_PERCENT_EQ] = ACTIONS(4296),
    [anon_sym_PLUS_EQ] = ACTIONS(4296),
    [anon_sym_DASH_EQ] = ACTIONS(4296),
    [anon_sym_LT_LT_EQ] = ACTIONS(4296),
    [anon_sym_GT_GT_EQ] = ACTIONS(4296),
    [anon_sym_AMP_EQ] = ACTIONS(4296),
    [anon_sym_CARET_EQ] = ACTIONS(4296),
    [anon_sym_PIPE_EQ] = ACTIONS(4296),
    [anon_sym_AMP] = ACTIONS(4298),
    [anon_sym_PIPE_PIPE] = ACTIONS(4296),
    [anon_sym_AMP_AMP] = ACTIONS(4296),
    [anon_sym_PIPE] = ACTIONS(4298),
    [anon_sym_CARET] = ACTIONS(4298),
    [anon_sym_EQ_EQ] = ACTIONS(4296),
    [anon_sym_BANG_EQ] = ACTIONS(4296),
    [anon_sym_LT] = ACTIONS(4298),
    [anon_sym_GT] = ACTIONS(4298),
    [anon_sym_LT_EQ] = ACTIONS(4296),
    [anon_sym_GT_EQ] = ACTIONS(4296),
    [anon_sym_LT_LT] = ACTIONS(1768),
    [anon_sym_GT_GT] = ACTIONS(1768),
    [anon_sym_PLUS] = ACTIONS(1770),
    [anon_sym_DASH] = ACTIONS(1770),
    [anon_sym_SLASH] = ACTIONS(1744),
    [anon_sym_PERCENT] = ACTIONS(1744),
    [anon_sym_DASH_DASH] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(1554),
    [anon_sym_DASH_GT] = ACTIONS(1554),
    [sym_comment] = ACTIONS(49),
  },
  [1530] = {
    [sym_argument_list] = STATE(802),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_COMMA] = ACTIONS(4300),
    [anon_sym_SEMI] = ACTIONS(4300),
    [anon_sym_STAR] = ACTIONS(1744),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_EQ] = ACTIONS(4302),
    [anon_sym_QMARK] = ACTIONS(4300),
    [anon_sym_STAR_EQ] = ACTIONS(4300),
    [anon_sym_SLASH_EQ] = ACTIONS(4300),
    [anon_sym_PERCENT_EQ] = ACTIONS(4300),
    [anon_sym_PLUS_EQ] = ACTIONS(4300),
    [anon_sym_DASH_EQ] = ACTIONS(4300),
    [anon_sym_LT_LT_EQ] = ACTIONS(4300),
    [anon_sym_GT_GT_EQ] = ACTIONS(4300),
    [anon_sym_AMP_EQ] = ACTIONS(4300),
    [anon_sym_CARET_EQ] = ACTIONS(4300),
    [anon_sym_PIPE_EQ] = ACTIONS(4300),
    [anon_sym_AMP] = ACTIONS(4302),
    [anon_sym_PIPE_PIPE] = ACTIONS(4300),
    [anon_sym_AMP_AMP] = ACTIONS(4300),
    [anon_sym_PIPE] = ACTIONS(4302),
    [anon_sym_CARET] = ACTIONS(4302),
    [anon_sym_EQ_EQ] = ACTIONS(4300),
    [anon_sym_BANG_EQ] = ACTIONS(4300),
    [anon_sym_LT] = ACTIONS(4302),
    [anon_sym_GT] = ACTIONS(4302),
    [anon_sym_LT_EQ] = ACTIONS(4300),
    [anon_sym_GT_EQ] = ACTIONS(4300),
    [anon_sym_LT_LT] = ACTIONS(4302),
    [anon_sym_GT_GT] = ACTIONS(4302),
    [anon_sym_PLUS] = ACTIONS(1770),
    [anon_sym_DASH] = ACTIONS(1770),
    [anon_sym_SLASH] = ACTIONS(1744),
    [anon_sym_PERCENT] = ACTIONS(1744),
    [anon_sym_DASH_DASH] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(1554),
    [anon_sym_DASH_GT] = ACTIONS(1554),
    [sym_comment] = ACTIONS(49),
  },
  [1531] = {
    [sym_argument_list] = STATE(802),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_COMMA] = ACTIONS(4274),
    [anon_sym_SEMI] = ACTIONS(4274),
    [anon_sym_STAR] = ACTIONS(1744),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_EQ] = ACTIONS(4276),
    [anon_sym_QMARK] = ACTIONS(4274),
    [anon_sym_STAR_EQ] = ACTIONS(4274),
    [anon_sym_SLASH_EQ] = ACTIONS(4274),
    [anon_sym_PERCENT_EQ] = ACTIONS(4274),
    [anon_sym_PLUS_EQ] = ACTIONS(4274),
    [anon_sym_DASH_EQ] = ACTIONS(4274),
    [anon_sym_LT_LT_EQ] = ACTIONS(4274),
    [anon_sym_GT_GT_EQ] = ACTIONS(4274),
    [anon_sym_AMP_EQ] = ACTIONS(4274),
    [anon_sym_CARET_EQ] = ACTIONS(4274),
    [anon_sym_PIPE_EQ] = ACTIONS(4274),
    [anon_sym_AMP] = ACTIONS(4276),
    [anon_sym_PIPE_PIPE] = ACTIONS(4274),
    [anon_sym_AMP_AMP] = ACTIONS(4274),
    [anon_sym_PIPE] = ACTIONS(4276),
    [anon_sym_CARET] = ACTIONS(4276),
    [anon_sym_EQ_EQ] = ACTIONS(4274),
    [anon_sym_BANG_EQ] = ACTIONS(4274),
    [anon_sym_LT] = ACTIONS(4276),
    [anon_sym_GT] = ACTIONS(4276),
    [anon_sym_LT_EQ] = ACTIONS(4274),
    [anon_sym_GT_EQ] = ACTIONS(4274),
    [anon_sym_LT_LT] = ACTIONS(4276),
    [anon_sym_GT_GT] = ACTIONS(4276),
    [anon_sym_PLUS] = ACTIONS(4276),
    [anon_sym_DASH] = ACTIONS(4276),
    [anon_sym_SLASH] = ACTIONS(1744),
    [anon_sym_PERCENT] = ACTIONS(1744),
    [anon_sym_DASH_DASH] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(1554),
    [anon_sym_DASH_GT] = ACTIONS(1554),
    [sym_comment] = ACTIONS(49),
  },
  [1532] = {
    [anon_sym_LPAREN] = ACTIONS(1798),
    [anon_sym_COMMA] = ACTIONS(1807),
    [anon_sym_RPAREN] = ACTIONS(1798),
    [anon_sym_SEMI] = ACTIONS(1798),
    [anon_sym_extern] = ACTIONS(1803),
    [anon_sym_LBRACE] = ACTIONS(1801),
    [anon_sym_RBRACE] = ACTIONS(1807),
    [anon_sym_STAR] = ACTIONS(4317),
    [anon_sym_LBRACK] = ACTIONS(1798),
    [anon_sym_EQ] = ACTIONS(1809),
    [anon_sym_static] = ACTIONS(1803),
    [anon_sym_register] = ACTIONS(1803),
    [anon_sym_inline] = ACTIONS(1803),
    [anon_sym_const] = ACTIONS(1803),
    [anon_sym_restrict] = ACTIONS(1803),
    [anon_sym_volatile] = ACTIONS(1803),
    [anon_sym__Atomic] = ACTIONS(1803),
    [anon_sym_mutable] = ACTIONS(1803),
    [anon_sym_explicit] = ACTIONS(1803),
    [anon_sym_constexpr] = ACTIONS(1803),
    [anon_sym_QMARK] = ACTIONS(1807),
    [anon_sym_STAR_EQ] = ACTIONS(1807),
    [anon_sym_SLASH_EQ] = ACTIONS(1807),
    [anon_sym_PERCENT_EQ] = ACTIONS(1807),
    [anon_sym_PLUS_EQ] = ACTIONS(1807),
    [anon_sym_DASH_EQ] = ACTIONS(1807),
    [anon_sym_LT_LT_EQ] = ACTIONS(1807),
    [anon_sym_GT_GT_EQ] = ACTIONS(1807),
    [anon_sym_AMP_EQ] = ACTIONS(1807),
    [anon_sym_CARET_EQ] = ACTIONS(1807),
    [anon_sym_PIPE_EQ] = ACTIONS(1807),
    [anon_sym_AMP] = ACTIONS(4317),
    [anon_sym_PIPE_PIPE] = ACTIONS(1807),
    [anon_sym_AMP_AMP] = ACTIONS(1798),
    [anon_sym_PIPE] = ACTIONS(1809),
    [anon_sym_CARET] = ACTIONS(1809),
    [anon_sym_TILDE] = ACTIONS(1801),
    [anon_sym_EQ_EQ] = ACTIONS(1807),
    [anon_sym_BANG_EQ] = ACTIONS(1807),
    [anon_sym_LT] = ACTIONS(4317),
    [anon_sym_GT] = ACTIONS(1809),
    [anon_sym_LT_EQ] = ACTIONS(1807),
    [anon_sym_GT_EQ] = ACTIONS(1807),
    [anon_sym_LT_LT] = ACTIONS(1809),
    [anon_sym_GT_GT] = ACTIONS(1809),
    [anon_sym_PLUS] = ACTIONS(1809),
    [anon_sym_DASH] = ACTIONS(1809),
    [anon_sym_SLASH] = ACTIONS(1809),
    [anon_sym_PERCENT] = ACTIONS(1809),
    [anon_sym_DASH_DASH] = ACTIONS(1807),
    [anon_sym_PLUS_PLUS] = ACTIONS(1807),
    [anon_sym_DOT] = ACTIONS(1807),
    [anon_sym_DASH_GT] = ACTIONS(1807),
    [sym_identifier] = ACTIONS(1803),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(1805),
    [sym_operator_name] = ACTIONS(1801),
  },
  [1533] = {
    [anon_sym_LPAREN] = ACTIONS(4738),
    [anon_sym_LBRACE] = ACTIONS(4738),
    [anon_sym_LT] = ACTIONS(1140),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(1144),
  },
  [1534] = {
    [anon_sym_LPAREN] = ACTIONS(4740),
    [anon_sym_LBRACE] = ACTIONS(4740),
    [anon_sym_LT] = ACTIONS(4740),
    [sym_comment] = ACTIONS(49),
  },
  [1535] = {
    [anon_sym_COMMA] = ACTIONS(4742),
    [anon_sym_LBRACE] = ACTIONS(4742),
    [sym_comment] = ACTIONS(49),
  },
  [1536] = {
    [aux_sym_field_initializer_list_repeat1] = STATE(1536),
    [anon_sym_COMMA] = ACTIONS(4744),
    [anon_sym_LBRACE] = ACTIONS(4742),
    [sym_comment] = ACTIONS(49),
  },
  [1537] = {
    [anon_sym_LPAREN] = ACTIONS(4747),
    [anon_sym_LBRACE] = ACTIONS(4747),
    [anon_sym_LT] = ACTIONS(1801),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(1805),
  },
  [1538] = {
    [anon_sym_LPAREN] = ACTIONS(4749),
    [anon_sym_LBRACE] = ACTIONS(4749),
    [anon_sym_LT] = ACTIONS(4749),
    [sym_comment] = ACTIONS(49),
  },
  [1539] = {
    [anon_sym_COMMA] = ACTIONS(4751),
    [anon_sym_RPAREN] = ACTIONS(4751),
    [sym_comment] = ACTIONS(49),
  },
  [1540] = {
    [anon_sym_LF] = ACTIONS(4753),
    [sym_preproc_arg] = ACTIONS(4753),
    [sym_comment] = ACTIONS(83),
  },
  [1541] = {
    [aux_sym_preproc_params_repeat1] = STATE(1541),
    [anon_sym_COMMA] = ACTIONS(4755),
    [anon_sym_RPAREN] = ACTIONS(4751),
    [sym_comment] = ACTIONS(49),
  },
  [1542] = {
    [sym_enumerator_list] = STATE(1898),
    [anon_sym_LPAREN] = ACTIONS(350),
    [anon_sym_COMMA] = ACTIONS(350),
    [anon_sym_RPAREN] = ACTIONS(350),
    [anon_sym_SEMI] = ACTIONS(350),
    [anon_sym_LBRACE] = ACTIONS(2825),
    [anon_sym_STAR] = ACTIONS(350),
    [anon_sym_LBRACK] = ACTIONS(350),
    [anon_sym_const] = ACTIONS(352),
    [anon_sym_restrict] = ACTIONS(350),
    [anon_sym_volatile] = ACTIONS(350),
    [anon_sym__Atomic] = ACTIONS(350),
    [anon_sym_mutable] = ACTIONS(350),
    [anon_sym_explicit] = ACTIONS(350),
    [anon_sym_constexpr] = ACTIONS(350),
    [anon_sym_COLON] = ACTIONS(350),
    [anon_sym_AMP] = ACTIONS(352),
    [anon_sym_AMP_AMP] = ACTIONS(350),
    [anon_sym_DASH_GT] = ACTIONS(350),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(350),
  },
  [1543] = {
    [sym_field_declaration_list] = STATE(1901),
    [sym_base_class_clause] = STATE(1902),
    [anon_sym_LPAREN] = ACTIONS(406),
    [anon_sym_RPAREN] = ACTIONS(406),
    [anon_sym_SEMI] = ACTIONS(406),
    [anon_sym_LBRACE] = ACTIONS(2829),
    [anon_sym_STAR] = ACTIONS(406),
    [anon_sym_LBRACK] = ACTIONS(406),
    [anon_sym_const] = ACTIONS(408),
    [anon_sym_restrict] = ACTIONS(406),
    [anon_sym_volatile] = ACTIONS(406),
    [anon_sym__Atomic] = ACTIONS(406),
    [anon_sym_mutable] = ACTIONS(406),
    [anon_sym_explicit] = ACTIONS(406),
    [anon_sym_constexpr] = ACTIONS(406),
    [anon_sym_COLON] = ACTIONS(943),
    [anon_sym_AMP] = ACTIONS(408),
    [anon_sym_AMP_AMP] = ACTIONS(406),
    [anon_sym_DASH_GT] = ACTIONS(406),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(406),
  },
  [1544] = {
    [sym_field_declaration_list] = STATE(1903),
    [sym_base_class_clause] = STATE(1904),
    [anon_sym_LPAREN] = ACTIONS(416),
    [anon_sym_RPAREN] = ACTIONS(416),
    [anon_sym_SEMI] = ACTIONS(416),
    [anon_sym_LBRACE] = ACTIONS(2829),
    [anon_sym_STAR] = ACTIONS(416),
    [anon_sym_LBRACK] = ACTIONS(416),
    [anon_sym_const] = ACTIONS(418),
    [anon_sym_restrict] = ACTIONS(416),
    [anon_sym_volatile] = ACTIONS(416),
    [anon_sym__Atomic] = ACTIONS(416),
    [anon_sym_mutable] = ACTIONS(416),
    [anon_sym_explicit] = ACTIONS(416),
    [anon_sym_constexpr] = ACTIONS(416),
    [anon_sym_COLON] = ACTIONS(943),
    [anon_sym_AMP] = ACTIONS(418),
    [anon_sym_AMP_AMP] = ACTIONS(416),
    [anon_sym_DASH_GT] = ACTIONS(416),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(416),
  },
  [1545] = {
    [sym_field_declaration_list] = STATE(1908),
    [sym_base_class_clause] = STATE(1909),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_RPAREN] = ACTIONS(451),
    [anon_sym_SEMI] = ACTIONS(451),
    [anon_sym_LBRACE] = ACTIONS(2829),
    [anon_sym_STAR] = ACTIONS(451),
    [anon_sym_LBRACK] = ACTIONS(451),
    [anon_sym_const] = ACTIONS(453),
    [anon_sym_restrict] = ACTIONS(451),
    [anon_sym_volatile] = ACTIONS(451),
    [anon_sym__Atomic] = ACTIONS(451),
    [anon_sym_mutable] = ACTIONS(451),
    [anon_sym_explicit] = ACTIONS(451),
    [anon_sym_constexpr] = ACTIONS(451),
    [anon_sym_COLON] = ACTIONS(943),
    [anon_sym_AMP] = ACTIONS(453),
    [anon_sym_AMP_AMP] = ACTIONS(451),
    [anon_sym_DASH_GT] = ACTIONS(451),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(451),
  },
  [1546] = {
    [sym__abstract_declarator] = STATE(2081),
    [sym_abstract_pointer_declarator] = STATE(2081),
    [sym_abstract_function_declarator] = STATE(2081),
    [sym_abstract_array_declarator] = STATE(2081),
    [sym_parameter_list] = STATE(1549),
    [sym_abstract_reference_declarator] = STATE(2081),
    [anon_sym_LPAREN] = ACTIONS(1115),
    [anon_sym_RPAREN] = ACTIONS(2270),
    [anon_sym_STAR] = ACTIONS(3358),
    [anon_sym_LBRACK] = ACTIONS(1121),
    [anon_sym_const] = ACTIONS(4360),
    [anon_sym_restrict] = ACTIONS(2270),
    [anon_sym_volatile] = ACTIONS(2270),
    [anon_sym__Atomic] = ACTIONS(2270),
    [anon_sym_mutable] = ACTIONS(2270),
    [anon_sym_explicit] = ACTIONS(2270),
    [anon_sym_constexpr] = ACTIONS(2270),
    [anon_sym_AMP] = ACTIONS(3360),
    [anon_sym_AMP_AMP] = ACTIONS(3362),
    [anon_sym_DASH_GT] = ACTIONS(2270),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(2270),
  },
  [1547] = {
    [sym__abstract_declarator] = STATE(2082),
    [sym_abstract_pointer_declarator] = STATE(2082),
    [sym_abstract_function_declarator] = STATE(2082),
    [sym_abstract_array_declarator] = STATE(2082),
    [sym_parameter_list] = STATE(1549),
    [sym_abstract_reference_declarator] = STATE(2082),
    [anon_sym_LPAREN] = ACTIONS(1115),
    [anon_sym_RPAREN] = ACTIONS(2278),
    [anon_sym_STAR] = ACTIONS(3358),
    [anon_sym_LBRACK] = ACTIONS(1121),
    [anon_sym_const] = ACTIONS(4362),
    [anon_sym_restrict] = ACTIONS(2278),
    [anon_sym_volatile] = ACTIONS(2278),
    [anon_sym__Atomic] = ACTIONS(2278),
    [anon_sym_mutable] = ACTIONS(2278),
    [anon_sym_explicit] = ACTIONS(2278),
    [anon_sym_constexpr] = ACTIONS(2278),
    [anon_sym_AMP] = ACTIONS(3360),
    [anon_sym_AMP_AMP] = ACTIONS(3362),
    [anon_sym_DASH_GT] = ACTIONS(2278),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(2278),
  },
  [1548] = {
    [sym_parameter_list] = STATE(2083),
    [anon_sym_LPAREN] = ACTIONS(206),
    [anon_sym_RPAREN] = ACTIONS(4364),
    [anon_sym_LBRACK] = ACTIONS(2282),
    [anon_sym_const] = ACTIONS(4366),
    [anon_sym_restrict] = ACTIONS(4364),
    [anon_sym_volatile] = ACTIONS(4364),
    [anon_sym__Atomic] = ACTIONS(4364),
    [anon_sym_mutable] = ACTIONS(4364),
    [anon_sym_explicit] = ACTIONS(4364),
    [anon_sym_constexpr] = ACTIONS(4364),
    [anon_sym_DASH_GT] = ACTIONS(4364),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(4364),
  },
  [1549] = {
    [sym_type_qualifier] = STATE(2084),
    [sym_trailing_return_type] = STATE(1129),
    [aux_sym_abstract_function_declarator_repeat1] = STATE(2084),
    [anon_sym_LPAREN] = ACTIONS(2284),
    [anon_sym_RPAREN] = ACTIONS(2284),
    [anon_sym_LBRACK] = ACTIONS(2284),
    [anon_sym_const] = ACTIONS(4368),
    [anon_sym_restrict] = ACTIONS(2284),
    [anon_sym_volatile] = ACTIONS(2284),
    [anon_sym__Atomic] = ACTIONS(2284),
    [anon_sym_mutable] = ACTIONS(2284),
    [anon_sym_explicit] = ACTIONS(2284),
    [anon_sym_constexpr] = ACTIONS(2284),
    [anon_sym_DASH_GT] = ACTIONS(2284),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(2284),
  },
  [1550] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(1550),
    [anon_sym_LPAREN] = ACTIONS(816),
    [anon_sym_RPAREN] = ACTIONS(816),
    [anon_sym_STAR] = ACTIONS(816),
    [anon_sym_LBRACK] = ACTIONS(816),
    [anon_sym_const] = ACTIONS(818),
    [anon_sym_restrict] = ACTIONS(818),
    [anon_sym_volatile] = ACTIONS(818),
    [anon_sym__Atomic] = ACTIONS(818),
    [anon_sym_mutable] = ACTIONS(818),
    [anon_sym_explicit] = ACTIONS(818),
    [anon_sym_constexpr] = ACTIONS(818),
    [anon_sym_unsigned] = ACTIONS(4758),
    [anon_sym_long] = ACTIONS(4758),
    [anon_sym_short] = ACTIONS(4758),
    [sym_primitive_type] = ACTIONS(818),
    [anon_sym_AMP] = ACTIONS(818),
    [anon_sym_AMP_AMP] = ACTIONS(816),
    [anon_sym_DASH_GT] = ACTIONS(816),
    [sym_identifier] = ACTIONS(818),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(818),
  },
  [1551] = {
    [anon_sym_LF] = ACTIONS(4761),
    [sym_comment] = ACTIONS(83),
  },
  [1552] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1825),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1825),
    [anon_sym_LPAREN] = ACTIONS(1823),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1825),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(1825),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1825),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1825),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(1825),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(1825),
    [sym_preproc_directive] = ACTIONS(1825),
    [anon_sym_typedef] = ACTIONS(1825),
    [anon_sym_extern] = ACTIONS(1825),
    [anon_sym_STAR] = ACTIONS(1823),
    [anon_sym_static] = ACTIONS(1825),
    [anon_sym_register] = ACTIONS(1825),
    [anon_sym_inline] = ACTIONS(1825),
    [anon_sym_const] = ACTIONS(1825),
    [anon_sym_restrict] = ACTIONS(1825),
    [anon_sym_volatile] = ACTIONS(1825),
    [anon_sym__Atomic] = ACTIONS(1825),
    [anon_sym_mutable] = ACTIONS(1825),
    [anon_sym_explicit] = ACTIONS(1825),
    [anon_sym_constexpr] = ACTIONS(1825),
    [anon_sym_unsigned] = ACTIONS(1825),
    [anon_sym_long] = ACTIONS(1825),
    [anon_sym_short] = ACTIONS(1825),
    [sym_primitive_type] = ACTIONS(1825),
    [anon_sym_enum] = ACTIONS(1825),
    [anon_sym_struct] = ACTIONS(1825),
    [anon_sym_union] = ACTIONS(1825),
    [anon_sym_AMP] = ACTIONS(1825),
    [anon_sym_AMP_AMP] = ACTIONS(1823),
    [anon_sym_TILDE] = ACTIONS(1823),
    [sym_identifier] = ACTIONS(1825),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(1825),
    [sym_auto] = ACTIONS(1825),
    [anon_sym_typename] = ACTIONS(1825),
    [anon_sym_template] = ACTIONS(1825),
    [anon_sym_namespace] = ACTIONS(1825),
    [anon_sym_using] = ACTIONS(1825),
    [anon_sym_COLON_COLON] = ACTIONS(1823),
    [sym_operator_name] = ACTIONS(1823),
  },
  [1553] = {
    [anon_sym_LF] = ACTIONS(4763),
    [sym_comment] = ACTIONS(83),
  },
  [1554] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1911),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1911),
    [anon_sym_LPAREN] = ACTIONS(1909),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1911),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(1911),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1911),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1911),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(1911),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(1911),
    [sym_preproc_directive] = ACTIONS(1911),
    [anon_sym_typedef] = ACTIONS(1911),
    [anon_sym_extern] = ACTIONS(1911),
    [anon_sym_STAR] = ACTIONS(1909),
    [anon_sym_static] = ACTIONS(1911),
    [anon_sym_register] = ACTIONS(1911),
    [anon_sym_inline] = ACTIONS(1911),
    [anon_sym_const] = ACTIONS(1911),
    [anon_sym_restrict] = ACTIONS(1911),
    [anon_sym_volatile] = ACTIONS(1911),
    [anon_sym__Atomic] = ACTIONS(1911),
    [anon_sym_mutable] = ACTIONS(1911),
    [anon_sym_explicit] = ACTIONS(1911),
    [anon_sym_constexpr] = ACTIONS(1911),
    [anon_sym_unsigned] = ACTIONS(1911),
    [anon_sym_long] = ACTIONS(1911),
    [anon_sym_short] = ACTIONS(1911),
    [sym_primitive_type] = ACTIONS(1911),
    [anon_sym_enum] = ACTIONS(1911),
    [anon_sym_struct] = ACTIONS(1911),
    [anon_sym_union] = ACTIONS(1911),
    [anon_sym_AMP] = ACTIONS(1911),
    [anon_sym_AMP_AMP] = ACTIONS(1909),
    [anon_sym_TILDE] = ACTIONS(1909),
    [sym_identifier] = ACTIONS(1911),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(1911),
    [sym_auto] = ACTIONS(1911),
    [anon_sym_typename] = ACTIONS(1911),
    [anon_sym_template] = ACTIONS(1911),
    [anon_sym_namespace] = ACTIONS(1911),
    [anon_sym_using] = ACTIONS(1911),
    [anon_sym_COLON_COLON] = ACTIONS(1909),
    [sym_operator_name] = ACTIONS(1909),
  },
  [1555] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(4765),
    [sym_comment] = ACTIONS(49),
  },
  [1556] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1962),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1962),
    [anon_sym_LPAREN] = ACTIONS(1960),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1962),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(1962),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1962),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1962),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(1962),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(1962),
    [sym_preproc_directive] = ACTIONS(1962),
    [anon_sym_typedef] = ACTIONS(1962),
    [anon_sym_extern] = ACTIONS(1962),
    [anon_sym_STAR] = ACTIONS(1960),
    [anon_sym_static] = ACTIONS(1962),
    [anon_sym_register] = ACTIONS(1962),
    [anon_sym_inline] = ACTIONS(1962),
    [anon_sym_const] = ACTIONS(1962),
    [anon_sym_restrict] = ACTIONS(1962),
    [anon_sym_volatile] = ACTIONS(1962),
    [anon_sym__Atomic] = ACTIONS(1962),
    [anon_sym_mutable] = ACTIONS(1962),
    [anon_sym_explicit] = ACTIONS(1962),
    [anon_sym_constexpr] = ACTIONS(1962),
    [anon_sym_unsigned] = ACTIONS(1962),
    [anon_sym_long] = ACTIONS(1962),
    [anon_sym_short] = ACTIONS(1962),
    [sym_primitive_type] = ACTIONS(1962),
    [anon_sym_enum] = ACTIONS(1962),
    [anon_sym_struct] = ACTIONS(1962),
    [anon_sym_union] = ACTIONS(1962),
    [anon_sym_AMP] = ACTIONS(1962),
    [anon_sym_AMP_AMP] = ACTIONS(1960),
    [anon_sym_TILDE] = ACTIONS(1960),
    [sym_identifier] = ACTIONS(1962),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(1962),
    [sym_auto] = ACTIONS(1962),
    [anon_sym_typename] = ACTIONS(1962),
    [anon_sym_template] = ACTIONS(1962),
    [anon_sym_namespace] = ACTIONS(1962),
    [anon_sym_using] = ACTIONS(1962),
    [anon_sym_COLON_COLON] = ACTIONS(1960),
    [sym_operator_name] = ACTIONS(1960),
  },
  [1557] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(4767),
    [sym_comment] = ACTIONS(49),
  },
  [1558] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1968),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1968),
    [anon_sym_LPAREN] = ACTIONS(1966),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1968),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(1968),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1968),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1968),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(1968),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(1968),
    [sym_preproc_directive] = ACTIONS(1968),
    [anon_sym_typedef] = ACTIONS(1968),
    [anon_sym_extern] = ACTIONS(1968),
    [anon_sym_STAR] = ACTIONS(1966),
    [anon_sym_static] = ACTIONS(1968),
    [anon_sym_register] = ACTIONS(1968),
    [anon_sym_inline] = ACTIONS(1968),
    [anon_sym_const] = ACTIONS(1968),
    [anon_sym_restrict] = ACTIONS(1968),
    [anon_sym_volatile] = ACTIONS(1968),
    [anon_sym__Atomic] = ACTIONS(1968),
    [anon_sym_mutable] = ACTIONS(1968),
    [anon_sym_explicit] = ACTIONS(1968),
    [anon_sym_constexpr] = ACTIONS(1968),
    [anon_sym_unsigned] = ACTIONS(1968),
    [anon_sym_long] = ACTIONS(1968),
    [anon_sym_short] = ACTIONS(1968),
    [sym_primitive_type] = ACTIONS(1968),
    [anon_sym_enum] = ACTIONS(1968),
    [anon_sym_struct] = ACTIONS(1968),
    [anon_sym_union] = ACTIONS(1968),
    [anon_sym_AMP] = ACTIONS(1968),
    [anon_sym_AMP_AMP] = ACTIONS(1966),
    [anon_sym_TILDE] = ACTIONS(1966),
    [sym_identifier] = ACTIONS(1968),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(1968),
    [sym_auto] = ACTIONS(1968),
    [anon_sym_typename] = ACTIONS(1968),
    [anon_sym_template] = ACTIONS(1968),
    [anon_sym_namespace] = ACTIONS(1968),
    [anon_sym_using] = ACTIONS(1968),
    [anon_sym_COLON_COLON] = ACTIONS(1966),
    [sym_operator_name] = ACTIONS(1966),
  },
  [1559] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(4769),
    [sym_comment] = ACTIONS(49),
  },
  [1560] = {
    [sym_preproc_arg] = ACTIONS(4771),
    [sym_comment] = ACTIONS(83),
  },
  [1561] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(827),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(827),
    [anon_sym_LPAREN] = ACTIONS(825),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(827),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(827),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(827),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(827),
    [sym_preproc_directive] = ACTIONS(827),
    [anon_sym_typedef] = ACTIONS(827),
    [anon_sym_extern] = ACTIONS(827),
    [anon_sym_STAR] = ACTIONS(825),
    [anon_sym_static] = ACTIONS(827),
    [anon_sym_register] = ACTIONS(827),
    [anon_sym_inline] = ACTIONS(827),
    [anon_sym_const] = ACTIONS(827),
    [anon_sym_restrict] = ACTIONS(827),
    [anon_sym_volatile] = ACTIONS(827),
    [anon_sym__Atomic] = ACTIONS(827),
    [anon_sym_mutable] = ACTIONS(827),
    [anon_sym_explicit] = ACTIONS(827),
    [anon_sym_constexpr] = ACTIONS(827),
    [anon_sym_unsigned] = ACTIONS(827),
    [anon_sym_long] = ACTIONS(827),
    [anon_sym_short] = ACTIONS(827),
    [sym_primitive_type] = ACTIONS(827),
    [anon_sym_enum] = ACTIONS(827),
    [anon_sym_struct] = ACTIONS(827),
    [anon_sym_union] = ACTIONS(827),
    [anon_sym_AMP] = ACTIONS(827),
    [anon_sym_AMP_AMP] = ACTIONS(825),
    [anon_sym_TILDE] = ACTIONS(825),
    [sym_identifier] = ACTIONS(827),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(827),
    [sym_auto] = ACTIONS(827),
    [anon_sym_typename] = ACTIONS(827),
    [anon_sym_template] = ACTIONS(827),
    [anon_sym_namespace] = ACTIONS(827),
    [anon_sym_using] = ACTIONS(827),
    [anon_sym_COLON_COLON] = ACTIONS(825),
    [sym_operator_name] = ACTIONS(825),
  },
  [1562] = {
    [anon_sym_LF] = ACTIONS(4773),
    [sym_preproc_arg] = ACTIONS(4775),
    [sym_comment] = ACTIONS(83),
  },
  [1563] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(859),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(859),
    [anon_sym_LPAREN] = ACTIONS(857),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(859),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(859),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(859),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(859),
    [sym_preproc_directive] = ACTIONS(859),
    [anon_sym_typedef] = ACTIONS(859),
    [anon_sym_extern] = ACTIONS(859),
    [anon_sym_STAR] = ACTIONS(857),
    [anon_sym_static] = ACTIONS(859),
    [anon_sym_register] = ACTIONS(859),
    [anon_sym_inline] = ACTIONS(859),
    [anon_sym_const] = ACTIONS(859),
    [anon_sym_restrict] = ACTIONS(859),
    [anon_sym_volatile] = ACTIONS(859),
    [anon_sym__Atomic] = ACTIONS(859),
    [anon_sym_mutable] = ACTIONS(859),
    [anon_sym_explicit] = ACTIONS(859),
    [anon_sym_constexpr] = ACTIONS(859),
    [anon_sym_unsigned] = ACTIONS(859),
    [anon_sym_long] = ACTIONS(859),
    [anon_sym_short] = ACTIONS(859),
    [sym_primitive_type] = ACTIONS(859),
    [anon_sym_enum] = ACTIONS(859),
    [anon_sym_struct] = ACTIONS(859),
    [anon_sym_union] = ACTIONS(859),
    [anon_sym_AMP] = ACTIONS(859),
    [anon_sym_AMP_AMP] = ACTIONS(857),
    [anon_sym_TILDE] = ACTIONS(857),
    [sym_identifier] = ACTIONS(859),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(859),
    [sym_auto] = ACTIONS(859),
    [anon_sym_typename] = ACTIONS(859),
    [anon_sym_template] = ACTIONS(859),
    [anon_sym_namespace] = ACTIONS(859),
    [anon_sym_using] = ACTIONS(859),
    [anon_sym_COLON_COLON] = ACTIONS(857),
    [sym_operator_name] = ACTIONS(857),
  },
  [1564] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(4777),
    [sym_comment] = ACTIONS(49),
  },
  [1565] = {
    [sym_preproc_include] = STATE(486),
    [sym_preproc_def] = STATE(486),
    [sym_preproc_function_def] = STATE(486),
    [sym_preproc_call] = STATE(486),
    [sym_preproc_if] = STATE(486),
    [sym_preproc_ifdef] = STATE(486),
    [sym_preproc_else] = STATE(2094),
    [sym_preproc_elif] = STATE(2094),
    [sym_function_definition] = STATE(486),
    [sym_declaration] = STATE(486),
    [sym_type_definition] = STATE(486),
    [sym__declaration_specifiers] = STATE(176),
    [sym_linkage_specification] = STATE(486),
    [sym__declarator] = STATE(28),
    [sym_pointer_declarator] = STATE(28),
    [sym_function_declarator] = STATE(177),
    [sym_array_declarator] = STATE(28),
    [sym_storage_class_specifier] = STATE(180),
    [sym_type_qualifier] = STATE(180),
    [sym__type_specifier] = STATE(30),
    [sym_sized_type_specifier] = STATE(30),
    [sym_enum_specifier] = STATE(30),
    [sym_struct_specifier] = STATE(30),
    [sym_union_specifier] = STATE(30),
    [sym__empty_declaration] = STATE(486),
    [sym_macro_type_specifier] = STATE(30),
    [sym_class_specifier] = STATE(30),
    [sym_dependent_type] = STATE(30),
    [sym_structured_binding_declaration] = STATE(486),
    [sym_template_declaration] = STATE(486),
    [sym_template_instantiation] = STATE(486),
    [sym_constructor_or_destructor_definition] = STATE(178),
    [sym_reference_declarator] = STATE(28),
    [sym_template_type] = STATE(32),
    [sym_template_function] = STATE(28),
    [sym_namespace_definition] = STATE(486),
    [sym_using_declaration] = STATE(486),
    [sym_alias_declaration] = STATE(486),
    [sym_destructor_name] = STATE(28),
    [sym_scoped_identifier] = STATE(33),
    [sym_scoped_type_identifier] = STATE(34),
    [sym_scoped_namespace_identifier] = STATE(35),
    [aux_sym_translation_unit_repeat1] = STATE(486),
    [aux_sym__declaration_specifiers_repeat1] = STATE(180),
    [aux_sym_sized_type_specifier_repeat1] = STATE(38),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(273),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(275),
    [anon_sym_LPAREN] = ACTIONS(11),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(277),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(4779),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(281),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(283),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(285),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(287),
    [sym_preproc_directive] = ACTIONS(289),
    [anon_sym_typedef] = ACTIONS(291),
    [anon_sym_extern] = ACTIONS(293),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_static] = ACTIONS(27),
    [anon_sym_register] = ACTIONS(27),
    [anon_sym_inline] = ACTIONS(27),
    [anon_sym_const] = ACTIONS(29),
    [anon_sym_restrict] = ACTIONS(29),
    [anon_sym_volatile] = ACTIONS(29),
    [anon_sym__Atomic] = ACTIONS(29),
    [anon_sym_mutable] = ACTIONS(29),
    [anon_sym_explicit] = ACTIONS(29),
    [anon_sym_constexpr] = ACTIONS(29),
    [anon_sym_unsigned] = ACTIONS(31),
    [anon_sym_long] = ACTIONS(31),
    [anon_sym_short] = ACTIONS(31),
    [sym_primitive_type] = ACTIONS(33),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_union] = ACTIONS(39),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(45),
    [sym_identifier] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(51),
    [sym_auto] = ACTIONS(33),
    [anon_sym_typename] = ACTIONS(53),
    [anon_sym_template] = ACTIONS(295),
    [anon_sym_namespace] = ACTIONS(297),
    [anon_sym_using] = ACTIONS(299),
    [anon_sym_COLON_COLON] = ACTIONS(61),
    [sym_operator_name] = ACTIONS(63),
  },
  [1566] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(921),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(921),
    [anon_sym_LPAREN] = ACTIONS(919),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(921),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(921),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(921),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(921),
    [sym_preproc_directive] = ACTIONS(921),
    [anon_sym_typedef] = ACTIONS(921),
    [anon_sym_extern] = ACTIONS(921),
    [anon_sym_STAR] = ACTIONS(919),
    [anon_sym_static] = ACTIONS(921),
    [anon_sym_register] = ACTIONS(921),
    [anon_sym_inline] = ACTIONS(921),
    [anon_sym_const] = ACTIONS(921),
    [anon_sym_restrict] = ACTIONS(921),
    [anon_sym_volatile] = ACTIONS(921),
    [anon_sym__Atomic] = ACTIONS(921),
    [anon_sym_mutable] = ACTIONS(921),
    [anon_sym_explicit] = ACTIONS(921),
    [anon_sym_constexpr] = ACTIONS(921),
    [anon_sym_unsigned] = ACTIONS(921),
    [anon_sym_long] = ACTIONS(921),
    [anon_sym_short] = ACTIONS(921),
    [sym_primitive_type] = ACTIONS(921),
    [anon_sym_enum] = ACTIONS(921),
    [anon_sym_struct] = ACTIONS(921),
    [anon_sym_union] = ACTIONS(921),
    [anon_sym_AMP] = ACTIONS(921),
    [anon_sym_AMP_AMP] = ACTIONS(919),
    [anon_sym_TILDE] = ACTIONS(919),
    [sym_identifier] = ACTIONS(921),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(921),
    [sym_auto] = ACTIONS(921),
    [anon_sym_typename] = ACTIONS(921),
    [anon_sym_template] = ACTIONS(921),
    [anon_sym_namespace] = ACTIONS(921),
    [anon_sym_using] = ACTIONS(921),
    [anon_sym_COLON_COLON] = ACTIONS(919),
    [sym_operator_name] = ACTIONS(919),
  },
  [1567] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(4781),
    [sym_comment] = ACTIONS(49),
  },
  [1568] = {
    [sym_preproc_include] = STATE(486),
    [sym_preproc_def] = STATE(486),
    [sym_preproc_function_def] = STATE(486),
    [sym_preproc_call] = STATE(486),
    [sym_preproc_if] = STATE(486),
    [sym_preproc_ifdef] = STATE(486),
    [sym_preproc_else] = STATE(2096),
    [sym_preproc_elif] = STATE(2096),
    [sym_function_definition] = STATE(486),
    [sym_declaration] = STATE(486),
    [sym_type_definition] = STATE(486),
    [sym__declaration_specifiers] = STATE(176),
    [sym_linkage_specification] = STATE(486),
    [sym__declarator] = STATE(28),
    [sym_pointer_declarator] = STATE(28),
    [sym_function_declarator] = STATE(177),
    [sym_array_declarator] = STATE(28),
    [sym_storage_class_specifier] = STATE(180),
    [sym_type_qualifier] = STATE(180),
    [sym__type_specifier] = STATE(30),
    [sym_sized_type_specifier] = STATE(30),
    [sym_enum_specifier] = STATE(30),
    [sym_struct_specifier] = STATE(30),
    [sym_union_specifier] = STATE(30),
    [sym__empty_declaration] = STATE(486),
    [sym_macro_type_specifier] = STATE(30),
    [sym_class_specifier] = STATE(30),
    [sym_dependent_type] = STATE(30),
    [sym_structured_binding_declaration] = STATE(486),
    [sym_template_declaration] = STATE(486),
    [sym_template_instantiation] = STATE(486),
    [sym_constructor_or_destructor_definition] = STATE(178),
    [sym_reference_declarator] = STATE(28),
    [sym_template_type] = STATE(32),
    [sym_template_function] = STATE(28),
    [sym_namespace_definition] = STATE(486),
    [sym_using_declaration] = STATE(486),
    [sym_alias_declaration] = STATE(486),
    [sym_destructor_name] = STATE(28),
    [sym_scoped_identifier] = STATE(33),
    [sym_scoped_type_identifier] = STATE(34),
    [sym_scoped_namespace_identifier] = STATE(35),
    [aux_sym_translation_unit_repeat1] = STATE(486),
    [aux_sym__declaration_specifiers_repeat1] = STATE(180),
    [aux_sym_sized_type_specifier_repeat1] = STATE(38),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(273),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(275),
    [anon_sym_LPAREN] = ACTIONS(11),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(277),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(4783),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(281),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(283),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(285),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(287),
    [sym_preproc_directive] = ACTIONS(289),
    [anon_sym_typedef] = ACTIONS(291),
    [anon_sym_extern] = ACTIONS(293),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_static] = ACTIONS(27),
    [anon_sym_register] = ACTIONS(27),
    [anon_sym_inline] = ACTIONS(27),
    [anon_sym_const] = ACTIONS(29),
    [anon_sym_restrict] = ACTIONS(29),
    [anon_sym_volatile] = ACTIONS(29),
    [anon_sym__Atomic] = ACTIONS(29),
    [anon_sym_mutable] = ACTIONS(29),
    [anon_sym_explicit] = ACTIONS(29),
    [anon_sym_constexpr] = ACTIONS(29),
    [anon_sym_unsigned] = ACTIONS(31),
    [anon_sym_long] = ACTIONS(31),
    [anon_sym_short] = ACTIONS(31),
    [sym_primitive_type] = ACTIONS(33),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_union] = ACTIONS(39),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(45),
    [sym_identifier] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(51),
    [sym_auto] = ACTIONS(33),
    [anon_sym_typename] = ACTIONS(53),
    [anon_sym_template] = ACTIONS(295),
    [anon_sym_namespace] = ACTIONS(297),
    [anon_sym_using] = ACTIONS(299),
    [anon_sym_COLON_COLON] = ACTIONS(61),
    [sym_operator_name] = ACTIONS(63),
  },
  [1569] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(929),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(929),
    [anon_sym_LPAREN] = ACTIONS(927),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(929),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(929),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(929),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(929),
    [sym_preproc_directive] = ACTIONS(929),
    [anon_sym_typedef] = ACTIONS(929),
    [anon_sym_extern] = ACTIONS(929),
    [anon_sym_STAR] = ACTIONS(927),
    [anon_sym_static] = ACTIONS(929),
    [anon_sym_register] = ACTIONS(929),
    [anon_sym_inline] = ACTIONS(929),
    [anon_sym_const] = ACTIONS(929),
    [anon_sym_restrict] = ACTIONS(929),
    [anon_sym_volatile] = ACTIONS(929),
    [anon_sym__Atomic] = ACTIONS(929),
    [anon_sym_mutable] = ACTIONS(929),
    [anon_sym_explicit] = ACTIONS(929),
    [anon_sym_constexpr] = ACTIONS(929),
    [anon_sym_unsigned] = ACTIONS(929),
    [anon_sym_long] = ACTIONS(929),
    [anon_sym_short] = ACTIONS(929),
    [sym_primitive_type] = ACTIONS(929),
    [anon_sym_enum] = ACTIONS(929),
    [anon_sym_struct] = ACTIONS(929),
    [anon_sym_union] = ACTIONS(929),
    [anon_sym_AMP] = ACTIONS(929),
    [anon_sym_AMP_AMP] = ACTIONS(927),
    [anon_sym_TILDE] = ACTIONS(927),
    [sym_identifier] = ACTIONS(929),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(929),
    [sym_auto] = ACTIONS(929),
    [anon_sym_typename] = ACTIONS(929),
    [anon_sym_template] = ACTIONS(929),
    [anon_sym_namespace] = ACTIONS(929),
    [anon_sym_using] = ACTIONS(929),
    [anon_sym_COLON_COLON] = ACTIONS(927),
    [sym_operator_name] = ACTIONS(927),
  },
  [1570] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(4785),
    [sym_comment] = ACTIONS(49),
  },
  [1571] = {
    [sym_preproc_include] = STATE(486),
    [sym_preproc_def] = STATE(486),
    [sym_preproc_function_def] = STATE(486),
    [sym_preproc_call] = STATE(486),
    [sym_preproc_if] = STATE(486),
    [sym_preproc_ifdef] = STATE(486),
    [sym_preproc_else] = STATE(2098),
    [sym_preproc_elif] = STATE(2098),
    [sym_function_definition] = STATE(486),
    [sym_declaration] = STATE(486),
    [sym_type_definition] = STATE(486),
    [sym__declaration_specifiers] = STATE(176),
    [sym_linkage_specification] = STATE(486),
    [sym__declarator] = STATE(28),
    [sym_pointer_declarator] = STATE(28),
    [sym_function_declarator] = STATE(177),
    [sym_array_declarator] = STATE(28),
    [sym_storage_class_specifier] = STATE(180),
    [sym_type_qualifier] = STATE(180),
    [sym__type_specifier] = STATE(30),
    [sym_sized_type_specifier] = STATE(30),
    [sym_enum_specifier] = STATE(30),
    [sym_struct_specifier] = STATE(30),
    [sym_union_specifier] = STATE(30),
    [sym__empty_declaration] = STATE(486),
    [sym_macro_type_specifier] = STATE(30),
    [sym_class_specifier] = STATE(30),
    [sym_dependent_type] = STATE(30),
    [sym_structured_binding_declaration] = STATE(486),
    [sym_template_declaration] = STATE(486),
    [sym_template_instantiation] = STATE(486),
    [sym_constructor_or_destructor_definition] = STATE(178),
    [sym_reference_declarator] = STATE(28),
    [sym_template_type] = STATE(32),
    [sym_template_function] = STATE(28),
    [sym_namespace_definition] = STATE(486),
    [sym_using_declaration] = STATE(486),
    [sym_alias_declaration] = STATE(486),
    [sym_destructor_name] = STATE(28),
    [sym_scoped_identifier] = STATE(33),
    [sym_scoped_type_identifier] = STATE(34),
    [sym_scoped_namespace_identifier] = STATE(35),
    [aux_sym_translation_unit_repeat1] = STATE(486),
    [aux_sym__declaration_specifiers_repeat1] = STATE(180),
    [aux_sym_sized_type_specifier_repeat1] = STATE(38),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(273),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(275),
    [anon_sym_LPAREN] = ACTIONS(11),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(277),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(4787),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(281),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(283),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(285),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(287),
    [sym_preproc_directive] = ACTIONS(289),
    [anon_sym_typedef] = ACTIONS(291),
    [anon_sym_extern] = ACTIONS(293),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_static] = ACTIONS(27),
    [anon_sym_register] = ACTIONS(27),
    [anon_sym_inline] = ACTIONS(27),
    [anon_sym_const] = ACTIONS(29),
    [anon_sym_restrict] = ACTIONS(29),
    [anon_sym_volatile] = ACTIONS(29),
    [anon_sym__Atomic] = ACTIONS(29),
    [anon_sym_mutable] = ACTIONS(29),
    [anon_sym_explicit] = ACTIONS(29),
    [anon_sym_constexpr] = ACTIONS(29),
    [anon_sym_unsigned] = ACTIONS(31),
    [anon_sym_long] = ACTIONS(31),
    [anon_sym_short] = ACTIONS(31),
    [sym_primitive_type] = ACTIONS(33),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_union] = ACTIONS(39),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(45),
    [sym_identifier] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(51),
    [sym_auto] = ACTIONS(33),
    [anon_sym_typename] = ACTIONS(53),
    [anon_sym_template] = ACTIONS(295),
    [anon_sym_namespace] = ACTIONS(297),
    [anon_sym_using] = ACTIONS(299),
    [anon_sym_COLON_COLON] = ACTIONS(61),
    [sym_operator_name] = ACTIONS(63),
  },
  [1572] = {
    [anon_sym_LF] = ACTIONS(4789),
    [sym_comment] = ACTIONS(83),
  },
  [1573] = {
    [sym_parameter_list] = STATE(513),
    [anon_sym_LPAREN] = ACTIONS(206),
    [anon_sym_SEMI] = ACTIONS(4791),
    [anon_sym_LBRACK] = ACTIONS(955),
    [sym_comment] = ACTIONS(49),
  },
  [1574] = {
    [sym__type_declarator] = STATE(2101),
    [sym_pointer_type_declarator] = STATE(213),
    [sym_function_type_declarator] = STATE(214),
    [sym_array_type_declarator] = STATE(215),
    [anon_sym_LPAREN] = ACTIONS(327),
    [anon_sym_STAR] = ACTIONS(329),
    [sym_identifier] = ACTIONS(331),
    [sym_comment] = ACTIONS(49),
  },
  [1575] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(977),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(977),
    [anon_sym_LPAREN] = ACTIONS(975),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(977),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(977),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(977),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(977),
    [sym_preproc_directive] = ACTIONS(977),
    [anon_sym_typedef] = ACTIONS(977),
    [anon_sym_extern] = ACTIONS(977),
    [anon_sym_STAR] = ACTIONS(975),
    [anon_sym_static] = ACTIONS(977),
    [anon_sym_register] = ACTIONS(977),
    [anon_sym_inline] = ACTIONS(977),
    [anon_sym_const] = ACTIONS(977),
    [anon_sym_restrict] = ACTIONS(977),
    [anon_sym_volatile] = ACTIONS(977),
    [anon_sym__Atomic] = ACTIONS(977),
    [anon_sym_mutable] = ACTIONS(977),
    [anon_sym_explicit] = ACTIONS(977),
    [anon_sym_constexpr] = ACTIONS(977),
    [anon_sym_unsigned] = ACTIONS(977),
    [anon_sym_long] = ACTIONS(977),
    [anon_sym_short] = ACTIONS(977),
    [sym_primitive_type] = ACTIONS(977),
    [anon_sym_enum] = ACTIONS(977),
    [anon_sym_struct] = ACTIONS(977),
    [anon_sym_union] = ACTIONS(977),
    [anon_sym_AMP] = ACTIONS(977),
    [anon_sym_AMP_AMP] = ACTIONS(975),
    [anon_sym_TILDE] = ACTIONS(975),
    [sym_identifier] = ACTIONS(977),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(977),
    [sym_auto] = ACTIONS(977),
    [anon_sym_typename] = ACTIONS(977),
    [anon_sym_template] = ACTIONS(977),
    [anon_sym_namespace] = ACTIONS(977),
    [anon_sym_using] = ACTIONS(977),
    [anon_sym_COLON_COLON] = ACTIONS(975),
    [sym_operator_name] = ACTIONS(975),
  },
  [1576] = {
    [sym__declarator] = STATE(968),
    [sym_pointer_declarator] = STATE(968),
    [sym_function_declarator] = STATE(968),
    [sym_array_declarator] = STATE(968),
    [sym_init_declarator] = STATE(969),
    [sym_reference_declarator] = STATE(968),
    [sym_template_type] = STATE(46),
    [sym_template_function] = STATE(968),
    [sym_destructor_name] = STATE(968),
    [sym_scoped_identifier] = STATE(33),
    [sym_scoped_type_identifier] = STATE(47),
    [sym_scoped_namespace_identifier] = STATE(46),
    [anon_sym_LPAREN] = ACTIONS(11),
    [anon_sym_STAR] = ACTIONS(196),
    [anon_sym_AMP] = ACTIONS(526),
    [anon_sym_AMP_AMP] = ACTIONS(528),
    [anon_sym_TILDE] = ACTIONS(45),
    [sym_identifier] = ACTIONS(75),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(77),
    [sym_operator_name] = ACTIONS(1885),
  },
  [1577] = {
    [sym_parameter_list] = STATE(299),
    [anon_sym_LPAREN] = ACTIONS(206),
    [anon_sym_SEMI] = ACTIONS(4793),
    [anon_sym_LBRACK] = ACTIONS(208),
    [sym_comment] = ACTIONS(49),
  },
  [1578] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1192),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1192),
    [anon_sym_LPAREN] = ACTIONS(1190),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1192),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(1192),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1192),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1192),
    [sym_preproc_directive] = ACTIONS(1192),
    [anon_sym_typedef] = ACTIONS(1192),
    [anon_sym_extern] = ACTIONS(1192),
    [anon_sym_STAR] = ACTIONS(1190),
    [anon_sym_static] = ACTIONS(1192),
    [anon_sym_register] = ACTIONS(1192),
    [anon_sym_inline] = ACTIONS(1192),
    [anon_sym_const] = ACTIONS(1192),
    [anon_sym_restrict] = ACTIONS(1192),
    [anon_sym_volatile] = ACTIONS(1192),
    [anon_sym__Atomic] = ACTIONS(1192),
    [anon_sym_mutable] = ACTIONS(1192),
    [anon_sym_explicit] = ACTIONS(1192),
    [anon_sym_constexpr] = ACTIONS(1192),
    [anon_sym_unsigned] = ACTIONS(1192),
    [anon_sym_long] = ACTIONS(1192),
    [anon_sym_short] = ACTIONS(1192),
    [sym_primitive_type] = ACTIONS(1192),
    [anon_sym_enum] = ACTIONS(1192),
    [anon_sym_struct] = ACTIONS(1192),
    [anon_sym_union] = ACTIONS(1192),
    [anon_sym_AMP] = ACTIONS(1192),
    [anon_sym_AMP_AMP] = ACTIONS(1190),
    [anon_sym_TILDE] = ACTIONS(1190),
    [sym_identifier] = ACTIONS(1192),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(1192),
    [sym_auto] = ACTIONS(1192),
    [anon_sym_typename] = ACTIONS(1192),
    [anon_sym_template] = ACTIONS(1192),
    [anon_sym_namespace] = ACTIONS(1192),
    [anon_sym_using] = ACTIONS(1192),
    [anon_sym_COLON_COLON] = ACTIONS(1190),
    [sym_operator_name] = ACTIONS(1190),
  },
  [1579] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1200),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1200),
    [anon_sym_LPAREN] = ACTIONS(1198),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1200),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(1200),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1200),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1200),
    [sym_preproc_directive] = ACTIONS(1200),
    [anon_sym_typedef] = ACTIONS(1200),
    [anon_sym_extern] = ACTIONS(1200),
    [anon_sym_STAR] = ACTIONS(1198),
    [anon_sym_static] = ACTIONS(1200),
    [anon_sym_register] = ACTIONS(1200),
    [anon_sym_inline] = ACTIONS(1200),
    [anon_sym_const] = ACTIONS(1200),
    [anon_sym_restrict] = ACTIONS(1200),
    [anon_sym_volatile] = ACTIONS(1200),
    [anon_sym__Atomic] = ACTIONS(1200),
    [anon_sym_mutable] = ACTIONS(1200),
    [anon_sym_explicit] = ACTIONS(1200),
    [anon_sym_constexpr] = ACTIONS(1200),
    [anon_sym_unsigned] = ACTIONS(1200),
    [anon_sym_long] = ACTIONS(1200),
    [anon_sym_short] = ACTIONS(1200),
    [sym_primitive_type] = ACTIONS(1200),
    [anon_sym_enum] = ACTIONS(1200),
    [anon_sym_struct] = ACTIONS(1200),
    [anon_sym_union] = ACTIONS(1200),
    [anon_sym_AMP] = ACTIONS(1200),
    [anon_sym_AMP_AMP] = ACTIONS(1198),
    [anon_sym_TILDE] = ACTIONS(1198),
    [sym_identifier] = ACTIONS(1200),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(1200),
    [sym_auto] = ACTIONS(1200),
    [anon_sym_typename] = ACTIONS(1200),
    [anon_sym_template] = ACTIONS(1200),
    [anon_sym_namespace] = ACTIONS(1200),
    [anon_sym_using] = ACTIONS(1200),
    [anon_sym_COLON_COLON] = ACTIONS(1198),
    [sym_operator_name] = ACTIONS(1198),
  },
  [1580] = {
    [sym__declarator] = STATE(968),
    [sym_pointer_declarator] = STATE(968),
    [sym_function_declarator] = STATE(968),
    [sym_array_declarator] = STATE(968),
    [sym_init_declarator] = STATE(969),
    [sym_reference_declarator] = STATE(968),
    [sym_template_type] = STATE(46),
    [sym_template_function] = STATE(968),
    [sym_destructor_name] = STATE(968),
    [sym_scoped_identifier] = STATE(33),
    [sym_scoped_type_identifier] = STATE(47),
    [sym_scoped_namespace_identifier] = STATE(46),
    [anon_sym_LPAREN] = ACTIONS(11),
    [anon_sym_SEMI] = ACTIONS(1883),
    [anon_sym_STAR] = ACTIONS(196),
    [anon_sym_AMP] = ACTIONS(526),
    [anon_sym_AMP_AMP] = ACTIONS(528),
    [anon_sym_TILDE] = ACTIONS(45),
    [sym_identifier] = ACTIONS(75),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(77),
    [sym_operator_name] = ACTIONS(1885),
  },
  [1581] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1219),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1219),
    [anon_sym_LPAREN] = ACTIONS(1217),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1219),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(1219),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1219),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1219),
    [sym_preproc_directive] = ACTIONS(1219),
    [anon_sym_typedef] = ACTIONS(1219),
    [anon_sym_extern] = ACTIONS(1219),
    [anon_sym_STAR] = ACTIONS(1217),
    [anon_sym_static] = ACTIONS(1219),
    [anon_sym_register] = ACTIONS(1219),
    [anon_sym_inline] = ACTIONS(1219),
    [anon_sym_const] = ACTIONS(1219),
    [anon_sym_restrict] = ACTIONS(1219),
    [anon_sym_volatile] = ACTIONS(1219),
    [anon_sym__Atomic] = ACTIONS(1219),
    [anon_sym_mutable] = ACTIONS(1219),
    [anon_sym_explicit] = ACTIONS(1219),
    [anon_sym_constexpr] = ACTIONS(1219),
    [anon_sym_unsigned] = ACTIONS(1219),
    [anon_sym_long] = ACTIONS(1219),
    [anon_sym_short] = ACTIONS(1219),
    [sym_primitive_type] = ACTIONS(1219),
    [anon_sym_enum] = ACTIONS(1219),
    [anon_sym_struct] = ACTIONS(1219),
    [anon_sym_union] = ACTIONS(1219),
    [anon_sym_AMP] = ACTIONS(1219),
    [anon_sym_AMP_AMP] = ACTIONS(1217),
    [anon_sym_TILDE] = ACTIONS(1217),
    [sym_identifier] = ACTIONS(1219),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(1219),
    [sym_auto] = ACTIONS(1219),
    [anon_sym_typename] = ACTIONS(1219),
    [anon_sym_template] = ACTIONS(1219),
    [anon_sym_namespace] = ACTIONS(1219),
    [anon_sym_using] = ACTIONS(1219),
    [anon_sym_COLON_COLON] = ACTIONS(1217),
    [sym_operator_name] = ACTIONS(1217),
  },
  [1582] = {
    [sym_preproc_include] = STATE(634),
    [sym_preproc_def] = STATE(634),
    [sym_preproc_function_def] = STATE(634),
    [sym_preproc_call] = STATE(634),
    [sym_preproc_if] = STATE(634),
    [sym_preproc_ifdef] = STATE(634),
    [sym_function_definition] = STATE(634),
    [sym_declaration] = STATE(634),
    [sym_type_definition] = STATE(634),
    [sym__declaration_specifiers] = STATE(27),
    [sym_linkage_specification] = STATE(634),
    [sym__declarator] = STATE(28),
    [sym_pointer_declarator] = STATE(28),
    [sym_function_declarator] = STATE(29),
    [sym_array_declarator] = STATE(28),
    [sym_storage_class_specifier] = STATE(37),
    [sym_type_qualifier] = STATE(37),
    [sym__type_specifier] = STATE(30),
    [sym_sized_type_specifier] = STATE(30),
    [sym_enum_specifier] = STATE(30),
    [sym_struct_specifier] = STATE(30),
    [sym_union_specifier] = STATE(30),
    [sym__empty_declaration] = STATE(634),
    [sym_macro_type_specifier] = STATE(30),
    [sym_class_specifier] = STATE(30),
    [sym_dependent_type] = STATE(30),
    [sym_structured_binding_declaration] = STATE(634),
    [sym_template_declaration] = STATE(634),
    [sym_template_instantiation] = STATE(634),
    [sym_constructor_or_destructor_definition] = STATE(31),
    [sym_reference_declarator] = STATE(28),
    [sym_template_type] = STATE(32),
    [sym_template_function] = STATE(28),
    [sym_namespace_definition] = STATE(634),
    [sym_using_declaration] = STATE(634),
    [sym_alias_declaration] = STATE(634),
    [sym_destructor_name] = STATE(28),
    [sym_scoped_identifier] = STATE(33),
    [sym_scoped_type_identifier] = STATE(34),
    [sym_scoped_namespace_identifier] = STATE(35),
    [aux_sym_translation_unit_repeat1] = STATE(634),
    [aux_sym__declaration_specifiers_repeat1] = STATE(37),
    [aux_sym_sized_type_specifier_repeat1] = STATE(38),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(7),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(11),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(13),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(15),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(17),
    [sym_preproc_directive] = ACTIONS(19),
    [anon_sym_typedef] = ACTIONS(21),
    [anon_sym_extern] = ACTIONS(23),
    [anon_sym_RBRACE] = ACTIONS(4795),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_static] = ACTIONS(27),
    [anon_sym_register] = ACTIONS(27),
    [anon_sym_inline] = ACTIONS(27),
    [anon_sym_const] = ACTIONS(29),
    [anon_sym_restrict] = ACTIONS(29),
    [anon_sym_volatile] = ACTIONS(29),
    [anon_sym__Atomic] = ACTIONS(29),
    [anon_sym_mutable] = ACTIONS(29),
    [anon_sym_explicit] = ACTIONS(29),
    [anon_sym_constexpr] = ACTIONS(29),
    [anon_sym_unsigned] = ACTIONS(31),
    [anon_sym_long] = ACTIONS(31),
    [anon_sym_short] = ACTIONS(31),
    [sym_primitive_type] = ACTIONS(33),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_union] = ACTIONS(39),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(45),
    [sym_identifier] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(51),
    [sym_auto] = ACTIONS(33),
    [anon_sym_typename] = ACTIONS(53),
    [anon_sym_template] = ACTIONS(55),
    [anon_sym_namespace] = ACTIONS(57),
    [anon_sym_using] = ACTIONS(59),
    [anon_sym_COLON_COLON] = ACTIONS(61),
    [sym_operator_name] = ACTIONS(63),
  },
  [1583] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1225),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1225),
    [anon_sym_LPAREN] = ACTIONS(1223),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1225),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(1225),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1225),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1225),
    [sym_preproc_directive] = ACTIONS(1225),
    [anon_sym_typedef] = ACTIONS(1225),
    [anon_sym_extern] = ACTIONS(1225),
    [anon_sym_STAR] = ACTIONS(1223),
    [anon_sym_static] = ACTIONS(1225),
    [anon_sym_register] = ACTIONS(1225),
    [anon_sym_inline] = ACTIONS(1225),
    [anon_sym_const] = ACTIONS(1225),
    [anon_sym_restrict] = ACTIONS(1225),
    [anon_sym_volatile] = ACTIONS(1225),
    [anon_sym__Atomic] = ACTIONS(1225),
    [anon_sym_mutable] = ACTIONS(1225),
    [anon_sym_explicit] = ACTIONS(1225),
    [anon_sym_constexpr] = ACTIONS(1225),
    [anon_sym_unsigned] = ACTIONS(1225),
    [anon_sym_long] = ACTIONS(1225),
    [anon_sym_short] = ACTIONS(1225),
    [sym_primitive_type] = ACTIONS(1225),
    [anon_sym_enum] = ACTIONS(1225),
    [anon_sym_struct] = ACTIONS(1225),
    [anon_sym_union] = ACTIONS(1225),
    [anon_sym_AMP] = ACTIONS(1225),
    [anon_sym_AMP_AMP] = ACTIONS(1223),
    [anon_sym_TILDE] = ACTIONS(1223),
    [sym_identifier] = ACTIONS(1225),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(1225),
    [sym_auto] = ACTIONS(1225),
    [anon_sym_typename] = ACTIONS(1225),
    [anon_sym_template] = ACTIONS(1225),
    [anon_sym_namespace] = ACTIONS(1225),
    [anon_sym_using] = ACTIONS(1225),
    [anon_sym_COLON_COLON] = ACTIONS(1223),
    [sym_operator_name] = ACTIONS(1223),
  },
  [1584] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1229),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1229),
    [anon_sym_LPAREN] = ACTIONS(1227),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1229),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(1229),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1229),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1229),
    [sym_preproc_directive] = ACTIONS(1229),
    [anon_sym_typedef] = ACTIONS(1229),
    [anon_sym_extern] = ACTIONS(1229),
    [anon_sym_STAR] = ACTIONS(1227),
    [anon_sym_static] = ACTIONS(1229),
    [anon_sym_register] = ACTIONS(1229),
    [anon_sym_inline] = ACTIONS(1229),
    [anon_sym_const] = ACTIONS(1229),
    [anon_sym_restrict] = ACTIONS(1229),
    [anon_sym_volatile] = ACTIONS(1229),
    [anon_sym__Atomic] = ACTIONS(1229),
    [anon_sym_mutable] = ACTIONS(1229),
    [anon_sym_explicit] = ACTIONS(1229),
    [anon_sym_constexpr] = ACTIONS(1229),
    [anon_sym_unsigned] = ACTIONS(1229),
    [anon_sym_long] = ACTIONS(1229),
    [anon_sym_short] = ACTIONS(1229),
    [sym_primitive_type] = ACTIONS(1229),
    [anon_sym_enum] = ACTIONS(1229),
    [anon_sym_struct] = ACTIONS(1229),
    [anon_sym_union] = ACTIONS(1229),
    [anon_sym_AMP] = ACTIONS(1229),
    [anon_sym_AMP_AMP] = ACTIONS(1227),
    [anon_sym_TILDE] = ACTIONS(1227),
    [sym_identifier] = ACTIONS(1229),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(1229),
    [sym_auto] = ACTIONS(1229),
    [anon_sym_typename] = ACTIONS(1229),
    [anon_sym_template] = ACTIONS(1229),
    [anon_sym_namespace] = ACTIONS(1229),
    [anon_sym_using] = ACTIONS(1229),
    [anon_sym_COLON_COLON] = ACTIONS(1227),
    [sym_operator_name] = ACTIONS(1227),
  },
  [1585] = {
    [sym_type_qualifier] = STATE(638),
    [sym__type_specifier] = STATE(636),
    [sym_sized_type_specifier] = STATE(636),
    [sym_enum_specifier] = STATE(636),
    [sym_struct_specifier] = STATE(636),
    [sym_union_specifier] = STATE(636),
    [sym_type_descriptor] = STATE(2104),
    [sym_macro_type_specifier] = STATE(636),
    [sym_class_specifier] = STATE(636),
    [sym_dependent_type] = STATE(636),
    [sym_template_type] = STATE(62),
    [sym_scoped_type_identifier] = STATE(34),
    [sym_scoped_namespace_identifier] = STATE(64),
    [aux_sym_type_definition_repeat1] = STATE(638),
    [aux_sym_sized_type_specifier_repeat1] = STATE(639),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_restrict] = ACTIONS(93),
    [anon_sym_volatile] = ACTIONS(93),
    [anon_sym__Atomic] = ACTIONS(93),
    [anon_sym_mutable] = ACTIONS(93),
    [anon_sym_explicit] = ACTIONS(93),
    [anon_sym_constexpr] = ACTIONS(93),
    [anon_sym_unsigned] = ACTIONS(1231),
    [anon_sym_long] = ACTIONS(1231),
    [anon_sym_short] = ACTIONS(1231),
    [sym_primitive_type] = ACTIONS(1233),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(428),
    [anon_sym_union] = ACTIONS(430),
    [sym_identifier] = ACTIONS(434),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(436),
    [sym_auto] = ACTIONS(1233),
    [anon_sym_typename] = ACTIONS(1235),
    [anon_sym_COLON_COLON] = ACTIONS(111),
  },
  [1586] = {
    [sym_template_argument_list] = STATE(203),
    [anon_sym_SEMI] = ACTIONS(4797),
    [anon_sym_LT] = ACTIONS(146),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(501),
  },
  [1587] = {
    [anon_sym_SEMI] = ACTIONS(4797),
    [sym_comment] = ACTIONS(49),
  },
  [1588] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1263),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1263),
    [anon_sym_LPAREN] = ACTIONS(1261),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1263),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(1263),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1263),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1263),
    [sym_preproc_directive] = ACTIONS(1263),
    [anon_sym_typedef] = ACTIONS(1263),
    [anon_sym_extern] = ACTIONS(1263),
    [anon_sym_STAR] = ACTIONS(1261),
    [anon_sym_static] = ACTIONS(1263),
    [anon_sym_register] = ACTIONS(1263),
    [anon_sym_inline] = ACTIONS(1263),
    [anon_sym_const] = ACTIONS(1263),
    [anon_sym_restrict] = ACTIONS(1263),
    [anon_sym_volatile] = ACTIONS(1263),
    [anon_sym__Atomic] = ACTIONS(1263),
    [anon_sym_mutable] = ACTIONS(1263),
    [anon_sym_explicit] = ACTIONS(1263),
    [anon_sym_constexpr] = ACTIONS(1263),
    [anon_sym_unsigned] = ACTIONS(1263),
    [anon_sym_long] = ACTIONS(1263),
    [anon_sym_short] = ACTIONS(1263),
    [sym_primitive_type] = ACTIONS(1263),
    [anon_sym_enum] = ACTIONS(1263),
    [anon_sym_struct] = ACTIONS(1263),
    [anon_sym_union] = ACTIONS(1263),
    [anon_sym_AMP] = ACTIONS(1263),
    [anon_sym_AMP_AMP] = ACTIONS(1261),
    [anon_sym_TILDE] = ACTIONS(1261),
    [sym_identifier] = ACTIONS(1263),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(1263),
    [sym_auto] = ACTIONS(1263),
    [anon_sym_typename] = ACTIONS(1263),
    [anon_sym_template] = ACTIONS(1263),
    [anon_sym_namespace] = ACTIONS(1263),
    [anon_sym_using] = ACTIONS(1263),
    [anon_sym_COLON_COLON] = ACTIONS(1261),
    [sym_operator_name] = ACTIONS(1261),
  },
  [1589] = {
    [sym_preproc_include] = STATE(1597),
    [sym_preproc_def] = STATE(1597),
    [sym_preproc_function_def] = STATE(1597),
    [sym_preproc_call] = STATE(1597),
    [sym_preproc_if_in_compound_statement] = STATE(410),
    [sym_preproc_ifdef_in_compound_statement] = STATE(411),
    [sym_declaration] = STATE(1597),
    [sym_type_definition] = STATE(1597),
    [sym__declaration_specifiers] = STATE(412),
    [sym_compound_statement] = STATE(1597),
    [sym_storage_class_specifier] = STATE(419),
    [sym_type_qualifier] = STATE(419),
    [sym__type_specifier] = STATE(30),
    [sym_sized_type_specifier] = STATE(30),
    [sym_enum_specifier] = STATE(30),
    [sym_struct_specifier] = STATE(30),
    [sym_union_specifier] = STATE(30),
    [sym_labeled_statement] = STATE(1597),
    [sym_expression_statement] = STATE(1597),
    [sym_if_statement] = STATE(1597),
    [sym_switch_statement] = STATE(1597),
    [sym_case_statement] = STATE(1597),
    [sym_while_statement] = STATE(1597),
    [sym_do_statement] = STATE(1597),
    [sym_for_statement] = STATE(1597),
    [sym_return_statement] = STATE(1597),
    [sym_break_statement] = STATE(1597),
    [sym_continue_statement] = STATE(1597),
    [sym_goto_statement] = STATE(1597),
    [sym__expression] = STATE(669),
    [sym_comma_expression] = STATE(414),
    [sym_conditional_expression] = STATE(669),
    [sym_assignment_expression] = STATE(669),
    [sym_pointer_expression] = STATE(669),
    [sym_logical_expression] = STATE(669),
    [sym_bitwise_expression] = STATE(669),
    [sym_equality_expression] = STATE(669),
    [sym_relational_expression] = STATE(669),
    [sym_shift_expression] = STATE(669),
    [sym_math_expression] = STATE(669),
    [sym_cast_expression] = STATE(669),
    [sym_sizeof_expression] = STATE(669),
    [sym_subscript_expression] = STATE(669),
    [sym_call_expression] = STATE(669),
    [sym_field_expression] = STATE(669),
    [sym_compound_literal_expression] = STATE(669),
    [sym_parenthesized_expression] = STATE(669),
    [sym_initializer_list] = STATE(670),
    [sym_initializer_pair] = STATE(670),
    [sym_subscript_designator] = STATE(671),
    [sym_field_designator] = STATE(671),
    [sym_concatenated_string] = STATE(669),
    [sym__empty_declaration] = STATE(1597),
    [sym_macro_type_specifier] = STATE(30),
    [sym_class_specifier] = STATE(30),
    [sym_dependent_type] = STATE(30),
    [sym_structured_binding_declaration] = STATE(1597),
    [sym_template_type] = STATE(415),
    [sym_template_function] = STATE(669),
    [sym_for_range_loop] = STATE(1597),
    [sym_new_expression] = STATE(669),
    [sym_delete_expression] = STATE(669),
    [sym_lambda_expression] = STATE(669),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(416),
    [sym_scoped_namespace_identifier] = STATE(417),
    [aux_sym_preproc_if_in_compound_statement_repeat1] = STATE(1597),
    [aux_sym__declaration_specifiers_repeat1] = STATE(419),
    [aux_sym_sized_type_specifier_repeat1] = STATE(38),
    [aux_sym_initializer_pair_repeat1] = STATE(671),
    [sym_raw_string_literal] = ACTIONS(1265),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(622),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(624),
    [anon_sym_LPAREN] = ACTIONS(1267),
    [anon_sym_COMMA] = ACTIONS(1269),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(628),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(630),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(632),
    [sym_preproc_directive] = ACTIONS(634),
    [anon_sym_SEMI] = ACTIONS(636),
    [anon_sym_typedef] = ACTIONS(638),
    [anon_sym_extern] = ACTIONS(154),
    [anon_sym_LBRACE] = ACTIONS(1271),
    [anon_sym_RBRACE] = ACTIONS(4799),
    [anon_sym_STAR] = ACTIONS(1275),
    [anon_sym_LBRACK] = ACTIONS(1277),
    [anon_sym_static] = ACTIONS(154),
    [anon_sym_register] = ACTIONS(154),
    [anon_sym_inline] = ACTIONS(154),
    [anon_sym_const] = ACTIONS(158),
    [anon_sym_restrict] = ACTIONS(158),
    [anon_sym_volatile] = ACTIONS(158),
    [anon_sym__Atomic] = ACTIONS(158),
    [anon_sym_mutable] = ACTIONS(158),
    [anon_sym_explicit] = ACTIONS(158),
    [anon_sym_constexpr] = ACTIONS(158),
    [anon_sym_unsigned] = ACTIONS(31),
    [anon_sym_long] = ACTIONS(31),
    [anon_sym_short] = ACTIONS(31),
    [sym_primitive_type] = ACTIONS(33),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_union] = ACTIONS(39),
    [anon_sym_if] = ACTIONS(646),
    [anon_sym_switch] = ACTIONS(648),
    [anon_sym_case] = ACTIONS(650),
    [anon_sym_default] = ACTIONS(652),
    [anon_sym_while] = ACTIONS(654),
    [anon_sym_do] = ACTIONS(656),
    [anon_sym_for] = ACTIONS(658),
    [anon_sym_return] = ACTIONS(660),
    [anon_sym_break] = ACTIONS(662),
    [anon_sym_continue] = ACTIONS(664),
    [anon_sym_goto] = ACTIONS(666),
    [anon_sym_AMP] = ACTIONS(1275),
    [anon_sym_BANG] = ACTIONS(1279),
    [anon_sym_TILDE] = ACTIONS(1281),
    [anon_sym_PLUS] = ACTIONS(1283),
    [anon_sym_DASH] = ACTIONS(1283),
    [anon_sym_DASH_DASH] = ACTIONS(1285),
    [anon_sym_PLUS_PLUS] = ACTIONS(1285),
    [anon_sym_sizeof] = ACTIONS(1287),
    [anon_sym_DOT] = ACTIONS(1289),
    [sym_number_literal] = ACTIONS(1265),
    [sym_char_literal] = ACTIONS(1265),
    [sym_string_literal] = ACTIONS(1291),
    [sym_true] = ACTIONS(1293),
    [sym_false] = ACTIONS(1293),
    [sym_null] = ACTIONS(1293),
    [sym_identifier] = ACTIONS(682),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(51),
    [sym_auto] = ACTIONS(33),
    [anon_sym_typename] = ACTIONS(53),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1295),
    [anon_sym_delete] = ACTIONS(1297),
    [sym_nullptr] = ACTIONS(1293),
  },
  [1590] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1307),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1307),
    [anon_sym_LPAREN] = ACTIONS(1305),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1307),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(1307),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1307),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1307),
    [sym_preproc_directive] = ACTIONS(1307),
    [anon_sym_typedef] = ACTIONS(1307),
    [anon_sym_extern] = ACTIONS(1307),
    [anon_sym_STAR] = ACTIONS(1305),
    [anon_sym_static] = ACTIONS(1307),
    [anon_sym_register] = ACTIONS(1307),
    [anon_sym_inline] = ACTIONS(1307),
    [anon_sym_const] = ACTIONS(1307),
    [anon_sym_restrict] = ACTIONS(1307),
    [anon_sym_volatile] = ACTIONS(1307),
    [anon_sym__Atomic] = ACTIONS(1307),
    [anon_sym_mutable] = ACTIONS(1307),
    [anon_sym_explicit] = ACTIONS(1307),
    [anon_sym_constexpr] = ACTIONS(1307),
    [anon_sym_unsigned] = ACTIONS(1307),
    [anon_sym_long] = ACTIONS(1307),
    [anon_sym_short] = ACTIONS(1307),
    [sym_primitive_type] = ACTIONS(1307),
    [anon_sym_enum] = ACTIONS(1307),
    [anon_sym_struct] = ACTIONS(1307),
    [anon_sym_union] = ACTIONS(1307),
    [anon_sym_AMP] = ACTIONS(1307),
    [anon_sym_AMP_AMP] = ACTIONS(1305),
    [anon_sym_TILDE] = ACTIONS(1305),
    [sym_identifier] = ACTIONS(1307),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(1307),
    [sym_auto] = ACTIONS(1307),
    [anon_sym_typename] = ACTIONS(1307),
    [anon_sym_template] = ACTIONS(1307),
    [anon_sym_namespace] = ACTIONS(1307),
    [anon_sym_using] = ACTIONS(1307),
    [anon_sym_COLON_COLON] = ACTIONS(1305),
    [sym_operator_name] = ACTIONS(1305),
  },
  [1591] = {
    [aux_sym_declaration_repeat1] = STATE(678),
    [anon_sym_COMMA] = ACTIONS(538),
    [anon_sym_SEMI] = ACTIONS(4801),
    [sym_comment] = ACTIONS(49),
  },
  [1592] = {
    [sym__expression] = STATE(2108),
    [sym_conditional_expression] = STATE(2108),
    [sym_assignment_expression] = STATE(2108),
    [sym_pointer_expression] = STATE(2108),
    [sym_logical_expression] = STATE(2108),
    [sym_bitwise_expression] = STATE(2108),
    [sym_equality_expression] = STATE(2108),
    [sym_relational_expression] = STATE(2108),
    [sym_shift_expression] = STATE(2108),
    [sym_math_expression] = STATE(2108),
    [sym_cast_expression] = STATE(2108),
    [sym_sizeof_expression] = STATE(2108),
    [sym_subscript_expression] = STATE(2108),
    [sym_call_expression] = STATE(2108),
    [sym_field_expression] = STATE(2108),
    [sym_compound_literal_expression] = STATE(2108),
    [sym_parenthesized_expression] = STATE(2108),
    [sym_initializer_list] = STATE(2109),
    [sym_concatenated_string] = STATE(2108),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(2108),
    [sym_new_expression] = STATE(2108),
    [sym_delete_expression] = STATE(2108),
    [sym_lambda_expression] = STATE(2108),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(4803),
    [anon_sym_LPAREN] = ACTIONS(1347),
    [anon_sym_LBRACE] = ACTIONS(548),
    [anon_sym_STAR] = ACTIONS(1349),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_AMP] = ACTIONS(1349),
    [anon_sym_BANG] = ACTIONS(1351),
    [anon_sym_TILDE] = ACTIONS(1353),
    [anon_sym_PLUS] = ACTIONS(1355),
    [anon_sym_DASH] = ACTIONS(1355),
    [anon_sym_DASH_DASH] = ACTIONS(1357),
    [anon_sym_PLUS_PLUS] = ACTIONS(1357),
    [anon_sym_sizeof] = ACTIONS(1359),
    [sym_number_literal] = ACTIONS(4803),
    [sym_char_literal] = ACTIONS(4803),
    [sym_string_literal] = ACTIONS(1361),
    [sym_true] = ACTIONS(4805),
    [sym_false] = ACTIONS(4805),
    [sym_null] = ACTIONS(4805),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1365),
    [anon_sym_delete] = ACTIONS(1367),
    [sym_nullptr] = ACTIONS(4805),
  },
  [1593] = {
    [anon_sym_SEMI] = ACTIONS(4807),
    [sym_comment] = ACTIONS(49),
  },
  [1594] = {
    [sym__expression] = STATE(2111),
    [sym_conditional_expression] = STATE(2111),
    [sym_assignment_expression] = STATE(2111),
    [sym_pointer_expression] = STATE(2111),
    [sym_logical_expression] = STATE(2111),
    [sym_bitwise_expression] = STATE(2111),
    [sym_equality_expression] = STATE(2111),
    [sym_relational_expression] = STATE(2111),
    [sym_shift_expression] = STATE(2111),
    [sym_math_expression] = STATE(2111),
    [sym_cast_expression] = STATE(2111),
    [sym_sizeof_expression] = STATE(2111),
    [sym_subscript_expression] = STATE(2111),
    [sym_call_expression] = STATE(2111),
    [sym_field_expression] = STATE(2111),
    [sym_compound_literal_expression] = STATE(2111),
    [sym_parenthesized_expression] = STATE(2111),
    [sym_initializer_list] = STATE(2112),
    [sym_concatenated_string] = STATE(2111),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(2111),
    [sym_new_expression] = STATE(2111),
    [sym_delete_expression] = STATE(2111),
    [sym_lambda_expression] = STATE(2111),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(4809),
    [anon_sym_LPAREN] = ACTIONS(1347),
    [anon_sym_LBRACE] = ACTIONS(548),
    [anon_sym_STAR] = ACTIONS(1349),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_AMP] = ACTIONS(1349),
    [anon_sym_BANG] = ACTIONS(1351),
    [anon_sym_TILDE] = ACTIONS(1353),
    [anon_sym_PLUS] = ACTIONS(1355),
    [anon_sym_DASH] = ACTIONS(1355),
    [anon_sym_DASH_DASH] = ACTIONS(1357),
    [anon_sym_PLUS_PLUS] = ACTIONS(1357),
    [anon_sym_sizeof] = ACTIONS(1359),
    [sym_number_literal] = ACTIONS(4809),
    [sym_char_literal] = ACTIONS(4809),
    [sym_string_literal] = ACTIONS(1361),
    [sym_true] = ACTIONS(4811),
    [sym_false] = ACTIONS(4811),
    [sym_null] = ACTIONS(4811),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1365),
    [anon_sym_delete] = ACTIONS(1367),
    [sym_nullptr] = ACTIONS(4811),
  },
  [1595] = {
    [anon_sym_SEMI] = ACTIONS(4813),
    [sym_comment] = ACTIONS(49),
  },
  [1596] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1624),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1624),
    [anon_sym_LPAREN] = ACTIONS(1622),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1624),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(1624),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1624),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1624),
    [sym_preproc_directive] = ACTIONS(1624),
    [anon_sym_typedef] = ACTIONS(1624),
    [anon_sym_extern] = ACTIONS(1624),
    [anon_sym_STAR] = ACTIONS(1622),
    [anon_sym_static] = ACTIONS(1624),
    [anon_sym_register] = ACTIONS(1624),
    [anon_sym_inline] = ACTIONS(1624),
    [anon_sym_const] = ACTIONS(1624),
    [anon_sym_restrict] = ACTIONS(1624),
    [anon_sym_volatile] = ACTIONS(1624),
    [anon_sym__Atomic] = ACTIONS(1624),
    [anon_sym_mutable] = ACTIONS(1624),
    [anon_sym_explicit] = ACTIONS(1624),
    [anon_sym_constexpr] = ACTIONS(1624),
    [anon_sym_unsigned] = ACTIONS(1624),
    [anon_sym_long] = ACTIONS(1624),
    [anon_sym_short] = ACTIONS(1624),
    [sym_primitive_type] = ACTIONS(1624),
    [anon_sym_enum] = ACTIONS(1624),
    [anon_sym_struct] = ACTIONS(1624),
    [anon_sym_union] = ACTIONS(1624),
    [anon_sym_AMP] = ACTIONS(1624),
    [anon_sym_AMP_AMP] = ACTIONS(1622),
    [anon_sym_TILDE] = ACTIONS(1622),
    [sym_identifier] = ACTIONS(1624),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(1624),
    [sym_auto] = ACTIONS(1624),
    [anon_sym_typename] = ACTIONS(1624),
    [anon_sym_template] = ACTIONS(1624),
    [anon_sym_namespace] = ACTIONS(1624),
    [anon_sym_using] = ACTIONS(1624),
    [anon_sym_COLON_COLON] = ACTIONS(1622),
    [sym_operator_name] = ACTIONS(1622),
  },
  [1597] = {
    [sym_preproc_include] = STATE(913),
    [sym_preproc_def] = STATE(913),
    [sym_preproc_function_def] = STATE(913),
    [sym_preproc_call] = STATE(913),
    [sym_preproc_if_in_compound_statement] = STATE(410),
    [sym_preproc_ifdef_in_compound_statement] = STATE(411),
    [sym_declaration] = STATE(913),
    [sym_type_definition] = STATE(913),
    [sym__declaration_specifiers] = STATE(412),
    [sym_compound_statement] = STATE(913),
    [sym_storage_class_specifier] = STATE(419),
    [sym_type_qualifier] = STATE(419),
    [sym__type_specifier] = STATE(30),
    [sym_sized_type_specifier] = STATE(30),
    [sym_enum_specifier] = STATE(30),
    [sym_struct_specifier] = STATE(30),
    [sym_union_specifier] = STATE(30),
    [sym_labeled_statement] = STATE(913),
    [sym_expression_statement] = STATE(913),
    [sym_if_statement] = STATE(913),
    [sym_switch_statement] = STATE(913),
    [sym_case_statement] = STATE(913),
    [sym_while_statement] = STATE(913),
    [sym_do_statement] = STATE(913),
    [sym_for_statement] = STATE(913),
    [sym_return_statement] = STATE(913),
    [sym_break_statement] = STATE(913),
    [sym_continue_statement] = STATE(913),
    [sym_goto_statement] = STATE(913),
    [sym__expression] = STATE(413),
    [sym_comma_expression] = STATE(414),
    [sym_conditional_expression] = STATE(413),
    [sym_assignment_expression] = STATE(413),
    [sym_pointer_expression] = STATE(413),
    [sym_logical_expression] = STATE(413),
    [sym_bitwise_expression] = STATE(413),
    [sym_equality_expression] = STATE(413),
    [sym_relational_expression] = STATE(413),
    [sym_shift_expression] = STATE(413),
    [sym_math_expression] = STATE(413),
    [sym_cast_expression] = STATE(413),
    [sym_sizeof_expression] = STATE(413),
    [sym_subscript_expression] = STATE(413),
    [sym_call_expression] = STATE(413),
    [sym_field_expression] = STATE(413),
    [sym_compound_literal_expression] = STATE(413),
    [sym_parenthesized_expression] = STATE(413),
    [sym_concatenated_string] = STATE(413),
    [sym__empty_declaration] = STATE(913),
    [sym_macro_type_specifier] = STATE(30),
    [sym_class_specifier] = STATE(30),
    [sym_dependent_type] = STATE(30),
    [sym_structured_binding_declaration] = STATE(913),
    [sym_template_type] = STATE(415),
    [sym_template_function] = STATE(413),
    [sym_for_range_loop] = STATE(913),
    [sym_new_expression] = STATE(413),
    [sym_delete_expression] = STATE(413),
    [sym_lambda_expression] = STATE(413),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(416),
    [sym_scoped_namespace_identifier] = STATE(417),
    [aux_sym_preproc_if_in_compound_statement_repeat1] = STATE(913),
    [aux_sym__declaration_specifiers_repeat1] = STATE(419),
    [aux_sym_sized_type_specifier_repeat1] = STATE(38),
    [sym_raw_string_literal] = ACTIONS(620),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(622),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(624),
    [anon_sym_LPAREN] = ACTIONS(626),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(628),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(630),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(632),
    [sym_preproc_directive] = ACTIONS(634),
    [anon_sym_SEMI] = ACTIONS(636),
    [anon_sym_typedef] = ACTIONS(638),
    [anon_sym_extern] = ACTIONS(154),
    [anon_sym_LBRACE] = ACTIONS(640),
    [anon_sym_RBRACE] = ACTIONS(4815),
    [anon_sym_STAR] = ACTIONS(644),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_static] = ACTIONS(154),
    [anon_sym_register] = ACTIONS(154),
    [anon_sym_inline] = ACTIONS(154),
    [anon_sym_const] = ACTIONS(158),
    [anon_sym_restrict] = ACTIONS(158),
    [anon_sym_volatile] = ACTIONS(158),
    [anon_sym__Atomic] = ACTIONS(158),
    [anon_sym_mutable] = ACTIONS(158),
    [anon_sym_explicit] = ACTIONS(158),
    [anon_sym_constexpr] = ACTIONS(158),
    [anon_sym_unsigned] = ACTIONS(31),
    [anon_sym_long] = ACTIONS(31),
    [anon_sym_short] = ACTIONS(31),
    [sym_primitive_type] = ACTIONS(33),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_union] = ACTIONS(39),
    [anon_sym_if] = ACTIONS(646),
    [anon_sym_switch] = ACTIONS(648),
    [anon_sym_case] = ACTIONS(650),
    [anon_sym_default] = ACTIONS(652),
    [anon_sym_while] = ACTIONS(654),
    [anon_sym_do] = ACTIONS(656),
    [anon_sym_for] = ACTIONS(658),
    [anon_sym_return] = ACTIONS(660),
    [anon_sym_break] = ACTIONS(662),
    [anon_sym_continue] = ACTIONS(664),
    [anon_sym_goto] = ACTIONS(666),
    [anon_sym_AMP] = ACTIONS(644),
    [anon_sym_BANG] = ACTIONS(668),
    [anon_sym_TILDE] = ACTIONS(670),
    [anon_sym_PLUS] = ACTIONS(672),
    [anon_sym_DASH] = ACTIONS(672),
    [anon_sym_DASH_DASH] = ACTIONS(674),
    [anon_sym_PLUS_PLUS] = ACTIONS(674),
    [anon_sym_sizeof] = ACTIONS(676),
    [sym_number_literal] = ACTIONS(620),
    [sym_char_literal] = ACTIONS(620),
    [sym_string_literal] = ACTIONS(678),
    [sym_true] = ACTIONS(680),
    [sym_false] = ACTIONS(680),
    [sym_null] = ACTIONS(680),
    [sym_identifier] = ACTIONS(682),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(51),
    [sym_auto] = ACTIONS(33),
    [anon_sym_typename] = ACTIONS(53),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(684),
    [anon_sym_delete] = ACTIONS(686),
    [sym_nullptr] = ACTIONS(680),
  },
  [1598] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1790),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1790),
    [anon_sym_LPAREN] = ACTIONS(1788),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1790),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(1790),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1790),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1790),
    [sym_preproc_directive] = ACTIONS(1790),
    [anon_sym_typedef] = ACTIONS(1790),
    [anon_sym_extern] = ACTIONS(1790),
    [anon_sym_STAR] = ACTIONS(1788),
    [anon_sym_static] = ACTIONS(1790),
    [anon_sym_register] = ACTIONS(1790),
    [anon_sym_inline] = ACTIONS(1790),
    [anon_sym_const] = ACTIONS(1790),
    [anon_sym_restrict] = ACTIONS(1790),
    [anon_sym_volatile] = ACTIONS(1790),
    [anon_sym__Atomic] = ACTIONS(1790),
    [anon_sym_mutable] = ACTIONS(1790),
    [anon_sym_explicit] = ACTIONS(1790),
    [anon_sym_constexpr] = ACTIONS(1790),
    [anon_sym_unsigned] = ACTIONS(1790),
    [anon_sym_long] = ACTIONS(1790),
    [anon_sym_short] = ACTIONS(1790),
    [sym_primitive_type] = ACTIONS(1790),
    [anon_sym_enum] = ACTIONS(1790),
    [anon_sym_struct] = ACTIONS(1790),
    [anon_sym_union] = ACTIONS(1790),
    [anon_sym_AMP] = ACTIONS(1790),
    [anon_sym_AMP_AMP] = ACTIONS(1788),
    [anon_sym_TILDE] = ACTIONS(1788),
    [sym_identifier] = ACTIONS(1790),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(1790),
    [sym_auto] = ACTIONS(1790),
    [anon_sym_typename] = ACTIONS(1790),
    [anon_sym_template] = ACTIONS(1790),
    [anon_sym_namespace] = ACTIONS(1790),
    [anon_sym_using] = ACTIONS(1790),
    [anon_sym_COLON_COLON] = ACTIONS(1788),
    [sym_operator_name] = ACTIONS(1788),
  },
  [1599] = {
    [sym_compound_statement] = STATE(2115),
    [anon_sym_LBRACE] = ACTIONS(1887),
    [sym_comment] = ACTIONS(49),
  },
  [1600] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(4817),
    [sym_comment] = ACTIONS(49),
  },
  [1601] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1974),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1974),
    [anon_sym_LPAREN] = ACTIONS(1972),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1974),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(1974),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1974),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1974),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(1974),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(1974),
    [sym_preproc_directive] = ACTIONS(1974),
    [anon_sym_typedef] = ACTIONS(1974),
    [anon_sym_extern] = ACTIONS(1974),
    [anon_sym_STAR] = ACTIONS(1972),
    [anon_sym_static] = ACTIONS(1974),
    [anon_sym_register] = ACTIONS(1974),
    [anon_sym_inline] = ACTIONS(1974),
    [anon_sym_const] = ACTIONS(1974),
    [anon_sym_restrict] = ACTIONS(1974),
    [anon_sym_volatile] = ACTIONS(1974),
    [anon_sym__Atomic] = ACTIONS(1974),
    [anon_sym_mutable] = ACTIONS(1974),
    [anon_sym_explicit] = ACTIONS(1974),
    [anon_sym_constexpr] = ACTIONS(1974),
    [anon_sym_unsigned] = ACTIONS(1974),
    [anon_sym_long] = ACTIONS(1974),
    [anon_sym_short] = ACTIONS(1974),
    [sym_primitive_type] = ACTIONS(1974),
    [anon_sym_enum] = ACTIONS(1974),
    [anon_sym_struct] = ACTIONS(1974),
    [anon_sym_union] = ACTIONS(1974),
    [anon_sym_AMP] = ACTIONS(1974),
    [anon_sym_AMP_AMP] = ACTIONS(1972),
    [anon_sym_TILDE] = ACTIONS(1972),
    [sym_identifier] = ACTIONS(1974),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(1974),
    [sym_auto] = ACTIONS(1974),
    [anon_sym_typename] = ACTIONS(1974),
    [anon_sym_template] = ACTIONS(1974),
    [anon_sym_namespace] = ACTIONS(1974),
    [anon_sym_using] = ACTIONS(1974),
    [anon_sym_COLON_COLON] = ACTIONS(1972),
    [sym_operator_name] = ACTIONS(1972),
  },
  [1602] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1990),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1990),
    [anon_sym_LPAREN] = ACTIONS(1988),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1990),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(1990),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1990),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1990),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(1990),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(1990),
    [sym_preproc_directive] = ACTIONS(1990),
    [anon_sym_typedef] = ACTIONS(1990),
    [anon_sym_extern] = ACTIONS(1990),
    [anon_sym_STAR] = ACTIONS(1988),
    [anon_sym_static] = ACTIONS(1990),
    [anon_sym_register] = ACTIONS(1990),
    [anon_sym_inline] = ACTIONS(1990),
    [anon_sym_const] = ACTIONS(1990),
    [anon_sym_restrict] = ACTIONS(1990),
    [anon_sym_volatile] = ACTIONS(1990),
    [anon_sym__Atomic] = ACTIONS(1990),
    [anon_sym_mutable] = ACTIONS(1990),
    [anon_sym_explicit] = ACTIONS(1990),
    [anon_sym_constexpr] = ACTIONS(1990),
    [anon_sym_unsigned] = ACTIONS(1990),
    [anon_sym_long] = ACTIONS(1990),
    [anon_sym_short] = ACTIONS(1990),
    [sym_primitive_type] = ACTIONS(1990),
    [anon_sym_enum] = ACTIONS(1990),
    [anon_sym_struct] = ACTIONS(1990),
    [anon_sym_union] = ACTIONS(1990),
    [anon_sym_AMP] = ACTIONS(1990),
    [anon_sym_AMP_AMP] = ACTIONS(1988),
    [anon_sym_TILDE] = ACTIONS(1988),
    [sym_identifier] = ACTIONS(1990),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(1990),
    [sym_auto] = ACTIONS(1990),
    [anon_sym_typename] = ACTIONS(1990),
    [anon_sym_template] = ACTIONS(1990),
    [anon_sym_namespace] = ACTIONS(1990),
    [anon_sym_using] = ACTIONS(1990),
    [anon_sym_COLON_COLON] = ACTIONS(1988),
    [sym_operator_name] = ACTIONS(1988),
  },
  [1603] = {
    [sym_parameter_list] = STATE(513),
    [anon_sym_LPAREN] = ACTIONS(206),
    [anon_sym_SEMI] = ACTIONS(4819),
    [anon_sym_LBRACK] = ACTIONS(955),
    [sym_comment] = ACTIONS(49),
  },
  [1604] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(2342),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(2342),
    [anon_sym_LPAREN] = ACTIONS(2340),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(2342),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(2342),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(2342),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(2342),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(2342),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(2342),
    [sym_preproc_directive] = ACTIONS(2342),
    [anon_sym_typedef] = ACTIONS(2342),
    [anon_sym_extern] = ACTIONS(2342),
    [anon_sym_STAR] = ACTIONS(2340),
    [anon_sym_static] = ACTIONS(2342),
    [anon_sym_register] = ACTIONS(2342),
    [anon_sym_inline] = ACTIONS(2342),
    [anon_sym_const] = ACTIONS(2342),
    [anon_sym_restrict] = ACTIONS(2342),
    [anon_sym_volatile] = ACTIONS(2342),
    [anon_sym__Atomic] = ACTIONS(2342),
    [anon_sym_mutable] = ACTIONS(2342),
    [anon_sym_explicit] = ACTIONS(2342),
    [anon_sym_constexpr] = ACTIONS(2342),
    [anon_sym_unsigned] = ACTIONS(2342),
    [anon_sym_long] = ACTIONS(2342),
    [anon_sym_short] = ACTIONS(2342),
    [sym_primitive_type] = ACTIONS(2342),
    [anon_sym_enum] = ACTIONS(2342),
    [anon_sym_struct] = ACTIONS(2342),
    [anon_sym_union] = ACTIONS(2342),
    [anon_sym_AMP] = ACTIONS(2342),
    [anon_sym_AMP_AMP] = ACTIONS(2340),
    [anon_sym_TILDE] = ACTIONS(2340),
    [sym_identifier] = ACTIONS(2342),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(2342),
    [sym_auto] = ACTIONS(2342),
    [anon_sym_typename] = ACTIONS(2342),
    [anon_sym_template] = ACTIONS(2342),
    [anon_sym_namespace] = ACTIONS(2342),
    [anon_sym_using] = ACTIONS(2342),
    [anon_sym_COLON_COLON] = ACTIONS(2340),
    [sym_operator_name] = ACTIONS(2340),
  },
  [1605] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(2357),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(2357),
    [anon_sym_LPAREN] = ACTIONS(2355),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(2357),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(2357),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(2357),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(2357),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(2357),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(2357),
    [sym_preproc_directive] = ACTIONS(2357),
    [anon_sym_typedef] = ACTIONS(2357),
    [anon_sym_extern] = ACTIONS(2357),
    [anon_sym_STAR] = ACTIONS(2355),
    [anon_sym_static] = ACTIONS(2357),
    [anon_sym_register] = ACTIONS(2357),
    [anon_sym_inline] = ACTIONS(2357),
    [anon_sym_const] = ACTIONS(2357),
    [anon_sym_restrict] = ACTIONS(2357),
    [anon_sym_volatile] = ACTIONS(2357),
    [anon_sym__Atomic] = ACTIONS(2357),
    [anon_sym_mutable] = ACTIONS(2357),
    [anon_sym_explicit] = ACTIONS(2357),
    [anon_sym_constexpr] = ACTIONS(2357),
    [anon_sym_unsigned] = ACTIONS(2357),
    [anon_sym_long] = ACTIONS(2357),
    [anon_sym_short] = ACTIONS(2357),
    [sym_primitive_type] = ACTIONS(2357),
    [anon_sym_enum] = ACTIONS(2357),
    [anon_sym_struct] = ACTIONS(2357),
    [anon_sym_union] = ACTIONS(2357),
    [anon_sym_AMP] = ACTIONS(2357),
    [anon_sym_AMP_AMP] = ACTIONS(2355),
    [anon_sym_TILDE] = ACTIONS(2355),
    [sym_identifier] = ACTIONS(2357),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(2357),
    [sym_auto] = ACTIONS(2357),
    [anon_sym_typename] = ACTIONS(2357),
    [anon_sym_template] = ACTIONS(2357),
    [anon_sym_namespace] = ACTIONS(2357),
    [anon_sym_using] = ACTIONS(2357),
    [anon_sym_COLON_COLON] = ACTIONS(2355),
    [sym_operator_name] = ACTIONS(2355),
  },
  [1606] = {
    [anon_sym_SEMI] = ACTIONS(4821),
    [sym_comment] = ACTIONS(49),
  },
  [1607] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(2373),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(2373),
    [anon_sym_LPAREN] = ACTIONS(2371),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(2373),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(2373),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(2373),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(2373),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(2373),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(2373),
    [sym_preproc_directive] = ACTIONS(2373),
    [anon_sym_typedef] = ACTIONS(2373),
    [anon_sym_extern] = ACTIONS(2373),
    [anon_sym_STAR] = ACTIONS(2371),
    [anon_sym_static] = ACTIONS(2373),
    [anon_sym_register] = ACTIONS(2373),
    [anon_sym_inline] = ACTIONS(2373),
    [anon_sym_const] = ACTIONS(2373),
    [anon_sym_restrict] = ACTIONS(2373),
    [anon_sym_volatile] = ACTIONS(2373),
    [anon_sym__Atomic] = ACTIONS(2373),
    [anon_sym_mutable] = ACTIONS(2373),
    [anon_sym_explicit] = ACTIONS(2373),
    [anon_sym_constexpr] = ACTIONS(2373),
    [anon_sym_unsigned] = ACTIONS(2373),
    [anon_sym_long] = ACTIONS(2373),
    [anon_sym_short] = ACTIONS(2373),
    [sym_primitive_type] = ACTIONS(2373),
    [anon_sym_enum] = ACTIONS(2373),
    [anon_sym_struct] = ACTIONS(2373),
    [anon_sym_union] = ACTIONS(2373),
    [anon_sym_AMP] = ACTIONS(2373),
    [anon_sym_AMP_AMP] = ACTIONS(2371),
    [anon_sym_TILDE] = ACTIONS(2371),
    [sym_identifier] = ACTIONS(2373),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(2373),
    [sym_auto] = ACTIONS(2373),
    [anon_sym_typename] = ACTIONS(2373),
    [anon_sym_template] = ACTIONS(2373),
    [anon_sym_namespace] = ACTIONS(2373),
    [anon_sym_using] = ACTIONS(2373),
    [anon_sym_COLON_COLON] = ACTIONS(2371),
    [sym_operator_name] = ACTIONS(2371),
  },
  [1608] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1624),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1624),
    [anon_sym_LPAREN] = ACTIONS(1622),
    [anon_sym_COMMA] = ACTIONS(2400),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1624),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(1624),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1624),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1624),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(1624),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(1624),
    [sym_preproc_directive] = ACTIONS(1624),
    [anon_sym_SEMI] = ACTIONS(2400),
    [anon_sym_typedef] = ACTIONS(1624),
    [anon_sym_extern] = ACTIONS(1624),
    [anon_sym_STAR] = ACTIONS(1622),
    [anon_sym_static] = ACTIONS(1624),
    [anon_sym_register] = ACTIONS(1624),
    [anon_sym_inline] = ACTIONS(1624),
    [anon_sym_const] = ACTIONS(1624),
    [anon_sym_restrict] = ACTIONS(1624),
    [anon_sym_volatile] = ACTIONS(1624),
    [anon_sym__Atomic] = ACTIONS(1624),
    [anon_sym_mutable] = ACTIONS(1624),
    [anon_sym_explicit] = ACTIONS(1624),
    [anon_sym_constexpr] = ACTIONS(1624),
    [anon_sym_unsigned] = ACTIONS(1624),
    [anon_sym_long] = ACTIONS(1624),
    [anon_sym_short] = ACTIONS(1624),
    [sym_primitive_type] = ACTIONS(1624),
    [anon_sym_enum] = ACTIONS(1624),
    [anon_sym_struct] = ACTIONS(1624),
    [anon_sym_union] = ACTIONS(1624),
    [anon_sym_AMP] = ACTIONS(1624),
    [anon_sym_AMP_AMP] = ACTIONS(1622),
    [anon_sym_TILDE] = ACTIONS(1622),
    [sym_identifier] = ACTIONS(1624),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(1624),
    [sym_auto] = ACTIONS(1624),
    [anon_sym_typename] = ACTIONS(1624),
    [anon_sym_template] = ACTIONS(1624),
    [anon_sym_namespace] = ACTIONS(1624),
    [anon_sym_using] = ACTIONS(1624),
    [anon_sym_COLON_COLON] = ACTIONS(1622),
    [sym_operator_name] = ACTIONS(1622),
  },
  [1609] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(2480),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(2480),
    [anon_sym_LPAREN] = ACTIONS(2478),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(2480),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(2480),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(2480),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(2480),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(2480),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(2480),
    [sym_preproc_directive] = ACTIONS(2480),
    [anon_sym_typedef] = ACTIONS(2480),
    [anon_sym_extern] = ACTIONS(2480),
    [anon_sym_STAR] = ACTIONS(2478),
    [anon_sym_static] = ACTIONS(2480),
    [anon_sym_register] = ACTIONS(2480),
    [anon_sym_inline] = ACTIONS(2480),
    [anon_sym_const] = ACTIONS(2480),
    [anon_sym_restrict] = ACTIONS(2480),
    [anon_sym_volatile] = ACTIONS(2480),
    [anon_sym__Atomic] = ACTIONS(2480),
    [anon_sym_mutable] = ACTIONS(2480),
    [anon_sym_explicit] = ACTIONS(2480),
    [anon_sym_constexpr] = ACTIONS(2480),
    [anon_sym_unsigned] = ACTIONS(2480),
    [anon_sym_long] = ACTIONS(2480),
    [anon_sym_short] = ACTIONS(2480),
    [sym_primitive_type] = ACTIONS(2480),
    [anon_sym_enum] = ACTIONS(2480),
    [anon_sym_struct] = ACTIONS(2480),
    [anon_sym_union] = ACTIONS(2480),
    [anon_sym_AMP] = ACTIONS(2480),
    [anon_sym_AMP_AMP] = ACTIONS(2478),
    [anon_sym_TILDE] = ACTIONS(2478),
    [sym_identifier] = ACTIONS(2480),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(2480),
    [sym_auto] = ACTIONS(2480),
    [anon_sym_typename] = ACTIONS(2480),
    [anon_sym_template] = ACTIONS(2480),
    [anon_sym_namespace] = ACTIONS(2480),
    [anon_sym_using] = ACTIONS(2480),
    [anon_sym_COLON_COLON] = ACTIONS(2478),
    [sym_operator_name] = ACTIONS(2478),
  },
  [1610] = {
    [sym_argument_list] = STATE(802),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_SEMI] = ACTIONS(4823),
    [anon_sym_STAR] = ACTIONS(2553),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_EQ] = ACTIONS(2555),
    [anon_sym_QMARK] = ACTIONS(2557),
    [anon_sym_STAR_EQ] = ACTIONS(2559),
    [anon_sym_SLASH_EQ] = ACTIONS(2559),
    [anon_sym_PERCENT_EQ] = ACTIONS(2559),
    [anon_sym_PLUS_EQ] = ACTIONS(2559),
    [anon_sym_DASH_EQ] = ACTIONS(2559),
    [anon_sym_LT_LT_EQ] = ACTIONS(2559),
    [anon_sym_GT_GT_EQ] = ACTIONS(2559),
    [anon_sym_AMP_EQ] = ACTIONS(2559),
    [anon_sym_CARET_EQ] = ACTIONS(2559),
    [anon_sym_PIPE_EQ] = ACTIONS(2559),
    [anon_sym_AMP] = ACTIONS(2561),
    [anon_sym_PIPE_PIPE] = ACTIONS(2563),
    [anon_sym_AMP_AMP] = ACTIONS(2565),
    [anon_sym_PIPE] = ACTIONS(2567),
    [anon_sym_CARET] = ACTIONS(2569),
    [anon_sym_EQ_EQ] = ACTIONS(2571),
    [anon_sym_BANG_EQ] = ACTIONS(2571),
    [anon_sym_LT] = ACTIONS(2573),
    [anon_sym_GT] = ACTIONS(2573),
    [anon_sym_LT_EQ] = ACTIONS(2575),
    [anon_sym_GT_EQ] = ACTIONS(2575),
    [anon_sym_LT_LT] = ACTIONS(2577),
    [anon_sym_GT_GT] = ACTIONS(2577),
    [anon_sym_PLUS] = ACTIONS(2579),
    [anon_sym_DASH] = ACTIONS(2579),
    [anon_sym_SLASH] = ACTIONS(2553),
    [anon_sym_PERCENT] = ACTIONS(2553),
    [anon_sym_DASH_DASH] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(1554),
    [anon_sym_DASH_GT] = ACTIONS(1554),
    [sym_comment] = ACTIONS(49),
  },
  [1611] = {
    [anon_sym_SEMI] = ACTIONS(4823),
    [sym_comment] = ACTIONS(49),
  },
  [1612] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(2583),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(2583),
    [anon_sym_LPAREN] = ACTIONS(2581),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(2583),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(2583),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(2583),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(2583),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(2583),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(2583),
    [sym_preproc_directive] = ACTIONS(2583),
    [anon_sym_typedef] = ACTIONS(2583),
    [anon_sym_extern] = ACTIONS(2583),
    [anon_sym_STAR] = ACTIONS(2581),
    [anon_sym_static] = ACTIONS(2583),
    [anon_sym_register] = ACTIONS(2583),
    [anon_sym_inline] = ACTIONS(2583),
    [anon_sym_const] = ACTIONS(2583),
    [anon_sym_restrict] = ACTIONS(2583),
    [anon_sym_volatile] = ACTIONS(2583),
    [anon_sym__Atomic] = ACTIONS(2583),
    [anon_sym_mutable] = ACTIONS(2583),
    [anon_sym_explicit] = ACTIONS(2583),
    [anon_sym_constexpr] = ACTIONS(2583),
    [anon_sym_unsigned] = ACTIONS(2583),
    [anon_sym_long] = ACTIONS(2583),
    [anon_sym_short] = ACTIONS(2583),
    [sym_primitive_type] = ACTIONS(2583),
    [anon_sym_enum] = ACTIONS(2583),
    [anon_sym_struct] = ACTIONS(2583),
    [anon_sym_union] = ACTIONS(2583),
    [anon_sym_AMP] = ACTIONS(2583),
    [anon_sym_AMP_AMP] = ACTIONS(2581),
    [anon_sym_TILDE] = ACTIONS(2581),
    [sym_identifier] = ACTIONS(2583),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(2583),
    [sym_auto] = ACTIONS(2583),
    [anon_sym_typename] = ACTIONS(2583),
    [anon_sym_template] = ACTIONS(2583),
    [anon_sym_namespace] = ACTIONS(2583),
    [anon_sym_using] = ACTIONS(2583),
    [anon_sym_COLON_COLON] = ACTIONS(2581),
    [sym_operator_name] = ACTIONS(2581),
  },
  [1613] = {
    [sym_argument_list] = STATE(802),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_SEMI] = ACTIONS(4825),
    [anon_sym_STAR] = ACTIONS(2553),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_EQ] = ACTIONS(2555),
    [anon_sym_QMARK] = ACTIONS(2557),
    [anon_sym_STAR_EQ] = ACTIONS(2559),
    [anon_sym_SLASH_EQ] = ACTIONS(2559),
    [anon_sym_PERCENT_EQ] = ACTIONS(2559),
    [anon_sym_PLUS_EQ] = ACTIONS(2559),
    [anon_sym_DASH_EQ] = ACTIONS(2559),
    [anon_sym_LT_LT_EQ] = ACTIONS(2559),
    [anon_sym_GT_GT_EQ] = ACTIONS(2559),
    [anon_sym_AMP_EQ] = ACTIONS(2559),
    [anon_sym_CARET_EQ] = ACTIONS(2559),
    [anon_sym_PIPE_EQ] = ACTIONS(2559),
    [anon_sym_AMP] = ACTIONS(2561),
    [anon_sym_PIPE_PIPE] = ACTIONS(2563),
    [anon_sym_AMP_AMP] = ACTIONS(2565),
    [anon_sym_PIPE] = ACTIONS(2567),
    [anon_sym_CARET] = ACTIONS(2569),
    [anon_sym_EQ_EQ] = ACTIONS(2571),
    [anon_sym_BANG_EQ] = ACTIONS(2571),
    [anon_sym_LT] = ACTIONS(2573),
    [anon_sym_GT] = ACTIONS(2573),
    [anon_sym_LT_EQ] = ACTIONS(2575),
    [anon_sym_GT_EQ] = ACTIONS(2575),
    [anon_sym_LT_LT] = ACTIONS(2577),
    [anon_sym_GT_GT] = ACTIONS(2577),
    [anon_sym_PLUS] = ACTIONS(2579),
    [anon_sym_DASH] = ACTIONS(2579),
    [anon_sym_SLASH] = ACTIONS(2553),
    [anon_sym_PERCENT] = ACTIONS(2553),
    [anon_sym_DASH_DASH] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(1554),
    [anon_sym_DASH_GT] = ACTIONS(1554),
    [sym_comment] = ACTIONS(49),
  },
  [1614] = {
    [anon_sym_SEMI] = ACTIONS(4825),
    [sym_comment] = ACTIONS(49),
  },
  [1615] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(2589),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(2589),
    [anon_sym_LPAREN] = ACTIONS(2587),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(2589),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(2589),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(2589),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(2589),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(2589),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(2589),
    [sym_preproc_directive] = ACTIONS(2589),
    [anon_sym_typedef] = ACTIONS(2589),
    [anon_sym_extern] = ACTIONS(2589),
    [anon_sym_STAR] = ACTIONS(2587),
    [anon_sym_static] = ACTIONS(2589),
    [anon_sym_register] = ACTIONS(2589),
    [anon_sym_inline] = ACTIONS(2589),
    [anon_sym_const] = ACTIONS(2589),
    [anon_sym_restrict] = ACTIONS(2589),
    [anon_sym_volatile] = ACTIONS(2589),
    [anon_sym__Atomic] = ACTIONS(2589),
    [anon_sym_mutable] = ACTIONS(2589),
    [anon_sym_explicit] = ACTIONS(2589),
    [anon_sym_constexpr] = ACTIONS(2589),
    [anon_sym_unsigned] = ACTIONS(2589),
    [anon_sym_long] = ACTIONS(2589),
    [anon_sym_short] = ACTIONS(2589),
    [sym_primitive_type] = ACTIONS(2589),
    [anon_sym_enum] = ACTIONS(2589),
    [anon_sym_struct] = ACTIONS(2589),
    [anon_sym_union] = ACTIONS(2589),
    [anon_sym_AMP] = ACTIONS(2589),
    [anon_sym_AMP_AMP] = ACTIONS(2587),
    [anon_sym_TILDE] = ACTIONS(2587),
    [sym_identifier] = ACTIONS(2589),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(2589),
    [sym_auto] = ACTIONS(2589),
    [anon_sym_typename] = ACTIONS(2589),
    [anon_sym_template] = ACTIONS(2589),
    [anon_sym_namespace] = ACTIONS(2589),
    [anon_sym_using] = ACTIONS(2589),
    [anon_sym_COLON_COLON] = ACTIONS(2587),
    [sym_operator_name] = ACTIONS(2587),
  },
  [1616] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3184),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3184),
    [anon_sym_LPAREN] = ACTIONS(3182),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3184),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3184),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3184),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3184),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(3184),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(3184),
    [sym_preproc_directive] = ACTIONS(3184),
    [anon_sym_typedef] = ACTIONS(3184),
    [anon_sym_extern] = ACTIONS(3184),
    [anon_sym_STAR] = ACTIONS(3182),
    [anon_sym_static] = ACTIONS(3184),
    [anon_sym_register] = ACTIONS(3184),
    [anon_sym_inline] = ACTIONS(3184),
    [anon_sym_const] = ACTIONS(3184),
    [anon_sym_restrict] = ACTIONS(3184),
    [anon_sym_volatile] = ACTIONS(3184),
    [anon_sym__Atomic] = ACTIONS(3184),
    [anon_sym_mutable] = ACTIONS(3184),
    [anon_sym_explicit] = ACTIONS(3184),
    [anon_sym_constexpr] = ACTIONS(3184),
    [anon_sym_unsigned] = ACTIONS(3184),
    [anon_sym_long] = ACTIONS(3184),
    [anon_sym_short] = ACTIONS(3184),
    [sym_primitive_type] = ACTIONS(3184),
    [anon_sym_enum] = ACTIONS(3184),
    [anon_sym_struct] = ACTIONS(3184),
    [anon_sym_union] = ACTIONS(3184),
    [anon_sym_AMP] = ACTIONS(3184),
    [anon_sym_AMP_AMP] = ACTIONS(3182),
    [anon_sym_TILDE] = ACTIONS(3182),
    [sym_identifier] = ACTIONS(3184),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(3184),
    [sym_auto] = ACTIONS(3184),
    [anon_sym_typename] = ACTIONS(3184),
    [anon_sym_template] = ACTIONS(3184),
    [anon_sym_namespace] = ACTIONS(3184),
    [anon_sym_using] = ACTIONS(3184),
    [anon_sym_COLON_COLON] = ACTIONS(3182),
    [sym_operator_name] = ACTIONS(3182),
  },
  [1617] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3340),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3340),
    [anon_sym_LPAREN] = ACTIONS(3338),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3340),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3340),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3340),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3340),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(3340),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(3340),
    [sym_preproc_directive] = ACTIONS(3340),
    [anon_sym_typedef] = ACTIONS(3340),
    [anon_sym_extern] = ACTIONS(3340),
    [anon_sym_STAR] = ACTIONS(3338),
    [anon_sym_static] = ACTIONS(3340),
    [anon_sym_register] = ACTIONS(3340),
    [anon_sym_inline] = ACTIONS(3340),
    [anon_sym_const] = ACTIONS(3340),
    [anon_sym_restrict] = ACTIONS(3340),
    [anon_sym_volatile] = ACTIONS(3340),
    [anon_sym__Atomic] = ACTIONS(3340),
    [anon_sym_mutable] = ACTIONS(3340),
    [anon_sym_explicit] = ACTIONS(3340),
    [anon_sym_constexpr] = ACTIONS(3340),
    [anon_sym_unsigned] = ACTIONS(3340),
    [anon_sym_long] = ACTIONS(3340),
    [anon_sym_short] = ACTIONS(3340),
    [sym_primitive_type] = ACTIONS(3340),
    [anon_sym_enum] = ACTIONS(3340),
    [anon_sym_struct] = ACTIONS(3340),
    [anon_sym_union] = ACTIONS(3340),
    [anon_sym_AMP] = ACTIONS(3340),
    [anon_sym_AMP_AMP] = ACTIONS(3338),
    [anon_sym_TILDE] = ACTIONS(3338),
    [sym_identifier] = ACTIONS(3340),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(3340),
    [sym_auto] = ACTIONS(3340),
    [anon_sym_typename] = ACTIONS(3340),
    [anon_sym_template] = ACTIONS(3340),
    [anon_sym_namespace] = ACTIONS(3340),
    [anon_sym_using] = ACTIONS(3340),
    [anon_sym_COLON_COLON] = ACTIONS(3338),
    [sym_operator_name] = ACTIONS(3338),
  },
  [1618] = {
    [anon_sym_LPAREN] = ACTIONS(3539),
    [anon_sym_STAR] = ACTIONS(3539),
    [sym_identifier] = ACTIONS(3539),
    [sym_comment] = ACTIONS(49),
  },
  [1619] = {
    [sym_enumerator] = STATE(1030),
    [anon_sym_RBRACE] = ACTIONS(4827),
    [sym_identifier] = ACTIONS(348),
    [sym_comment] = ACTIONS(49),
  },
  [1620] = {
    [anon_sym_LPAREN] = ACTIONS(3776),
    [anon_sym_LBRACE] = ACTIONS(3776),
    [anon_sym_STAR] = ACTIONS(3776),
    [anon_sym_COLON] = ACTIONS(3778),
    [sym_identifier] = ACTIONS(3776),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(3776),
  },
  [1621] = {
    [anon_sym_LPAREN] = ACTIONS(4829),
    [anon_sym_RPAREN] = ACTIONS(4829),
    [anon_sym_SEMI] = ACTIONS(4829),
    [anon_sym_LBRACK] = ACTIONS(4829),
    [sym_comment] = ACTIONS(49),
  },
  [1622] = {
    [sym_argument_list] = STATE(802),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_STAR] = ACTIONS(1522),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_RBRACK] = ACTIONS(4831),
    [anon_sym_EQ] = ACTIONS(1526),
    [anon_sym_QMARK] = ACTIONS(1528),
    [anon_sym_STAR_EQ] = ACTIONS(1530),
    [anon_sym_SLASH_EQ] = ACTIONS(1530),
    [anon_sym_PERCENT_EQ] = ACTIONS(1530),
    [anon_sym_PLUS_EQ] = ACTIONS(1530),
    [anon_sym_DASH_EQ] = ACTIONS(1530),
    [anon_sym_LT_LT_EQ] = ACTIONS(1530),
    [anon_sym_GT_GT_EQ] = ACTIONS(1530),
    [anon_sym_AMP_EQ] = ACTIONS(1530),
    [anon_sym_CARET_EQ] = ACTIONS(1530),
    [anon_sym_PIPE_EQ] = ACTIONS(1530),
    [anon_sym_AMP] = ACTIONS(1532),
    [anon_sym_PIPE_PIPE] = ACTIONS(1534),
    [anon_sym_AMP_AMP] = ACTIONS(1536),
    [anon_sym_PIPE] = ACTIONS(1538),
    [anon_sym_CARET] = ACTIONS(1540),
    [anon_sym_EQ_EQ] = ACTIONS(1542),
    [anon_sym_BANG_EQ] = ACTIONS(1542),
    [anon_sym_LT] = ACTIONS(1544),
    [anon_sym_GT] = ACTIONS(1544),
    [anon_sym_LT_EQ] = ACTIONS(1546),
    [anon_sym_GT_EQ] = ACTIONS(1546),
    [anon_sym_LT_LT] = ACTIONS(1548),
    [anon_sym_GT_GT] = ACTIONS(1548),
    [anon_sym_PLUS] = ACTIONS(1550),
    [anon_sym_DASH] = ACTIONS(1550),
    [anon_sym_SLASH] = ACTIONS(1522),
    [anon_sym_PERCENT] = ACTIONS(1522),
    [anon_sym_DASH_DASH] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(1554),
    [anon_sym_DASH_GT] = ACTIONS(1554),
    [sym_comment] = ACTIONS(49),
  },
  [1623] = {
    [sym__abstract_declarator] = STATE(2122),
    [sym_abstract_pointer_declarator] = STATE(2122),
    [sym_abstract_function_declarator] = STATE(2122),
    [sym_abstract_array_declarator] = STATE(2122),
    [sym_parameter_list] = STATE(1626),
    [sym_abstract_reference_declarator] = STATE(2122),
    [anon_sym_LPAREN] = ACTIONS(1115),
    [anon_sym_STAR] = ACTIONS(3523),
    [anon_sym_LBRACK] = ACTIONS(1121),
    [anon_sym_const] = ACTIONS(4360),
    [anon_sym_restrict] = ACTIONS(2270),
    [anon_sym_volatile] = ACTIONS(2270),
    [anon_sym__Atomic] = ACTIONS(2270),
    [anon_sym_mutable] = ACTIONS(2270),
    [anon_sym_explicit] = ACTIONS(2270),
    [anon_sym_constexpr] = ACTIONS(2270),
    [anon_sym_AMP] = ACTIONS(3525),
    [anon_sym_AMP_AMP] = ACTIONS(3527),
    [anon_sym_DASH_GT] = ACTIONS(2270),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(2270),
  },
  [1624] = {
    [sym__abstract_declarator] = STATE(2123),
    [sym_abstract_pointer_declarator] = STATE(2123),
    [sym_abstract_function_declarator] = STATE(2123),
    [sym_abstract_array_declarator] = STATE(2123),
    [sym_parameter_list] = STATE(1626),
    [sym_abstract_reference_declarator] = STATE(2123),
    [anon_sym_LPAREN] = ACTIONS(1115),
    [anon_sym_STAR] = ACTIONS(3523),
    [anon_sym_LBRACK] = ACTIONS(1121),
    [anon_sym_const] = ACTIONS(4362),
    [anon_sym_restrict] = ACTIONS(2278),
    [anon_sym_volatile] = ACTIONS(2278),
    [anon_sym__Atomic] = ACTIONS(2278),
    [anon_sym_mutable] = ACTIONS(2278),
    [anon_sym_explicit] = ACTIONS(2278),
    [anon_sym_constexpr] = ACTIONS(2278),
    [anon_sym_AMP] = ACTIONS(3525),
    [anon_sym_AMP_AMP] = ACTIONS(3527),
    [anon_sym_DASH_GT] = ACTIONS(2278),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(2278),
  },
  [1625] = {
    [sym_parameter_list] = STATE(2124),
    [anon_sym_LPAREN] = ACTIONS(206),
    [anon_sym_LBRACK] = ACTIONS(2282),
    [anon_sym_const] = ACTIONS(4366),
    [anon_sym_restrict] = ACTIONS(4364),
    [anon_sym_volatile] = ACTIONS(4364),
    [anon_sym__Atomic] = ACTIONS(4364),
    [anon_sym_mutable] = ACTIONS(4364),
    [anon_sym_explicit] = ACTIONS(4364),
    [anon_sym_constexpr] = ACTIONS(4364),
    [anon_sym_DASH_GT] = ACTIONS(4364),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(4364),
  },
  [1626] = {
    [sym_type_qualifier] = STATE(2125),
    [sym_trailing_return_type] = STATE(1129),
    [aux_sym_abstract_function_declarator_repeat1] = STATE(2125),
    [anon_sym_LPAREN] = ACTIONS(2284),
    [anon_sym_LBRACK] = ACTIONS(2284),
    [anon_sym_const] = ACTIONS(4368),
    [anon_sym_restrict] = ACTIONS(2284),
    [anon_sym_volatile] = ACTIONS(2284),
    [anon_sym__Atomic] = ACTIONS(2284),
    [anon_sym_mutable] = ACTIONS(2284),
    [anon_sym_explicit] = ACTIONS(2284),
    [anon_sym_constexpr] = ACTIONS(2284),
    [anon_sym_DASH_GT] = ACTIONS(2284),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(2284),
  },
  [1627] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(1627),
    [anon_sym_LPAREN] = ACTIONS(816),
    [anon_sym_STAR] = ACTIONS(816),
    [anon_sym_LBRACK] = ACTIONS(816),
    [anon_sym_const] = ACTIONS(818),
    [anon_sym_restrict] = ACTIONS(818),
    [anon_sym_volatile] = ACTIONS(818),
    [anon_sym__Atomic] = ACTIONS(818),
    [anon_sym_mutable] = ACTIONS(818),
    [anon_sym_explicit] = ACTIONS(818),
    [anon_sym_constexpr] = ACTIONS(818),
    [anon_sym_unsigned] = ACTIONS(4833),
    [anon_sym_long] = ACTIONS(4833),
    [anon_sym_short] = ACTIONS(4833),
    [sym_primitive_type] = ACTIONS(818),
    [anon_sym_AMP] = ACTIONS(818),
    [anon_sym_AMP_AMP] = ACTIONS(816),
    [anon_sym_DASH_GT] = ACTIONS(816),
    [sym_identifier] = ACTIONS(818),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(818),
  },
  [1628] = {
    [anon_sym_LPAREN] = ACTIONS(4836),
    [anon_sym_COMMA] = ACTIONS(4836),
    [anon_sym_RPAREN] = ACTIONS(4836),
    [anon_sym_SEMI] = ACTIONS(4836),
    [anon_sym_extern] = ACTIONS(4838),
    [anon_sym_LBRACE] = ACTIONS(4836),
    [anon_sym_STAR] = ACTIONS(4836),
    [anon_sym_LBRACK] = ACTIONS(4836),
    [anon_sym_static] = ACTIONS(4838),
    [anon_sym_register] = ACTIONS(4838),
    [anon_sym_inline] = ACTIONS(4838),
    [anon_sym_const] = ACTIONS(4838),
    [anon_sym_restrict] = ACTIONS(4838),
    [anon_sym_volatile] = ACTIONS(4838),
    [anon_sym__Atomic] = ACTIONS(4838),
    [anon_sym_mutable] = ACTIONS(4838),
    [anon_sym_explicit] = ACTIONS(4838),
    [anon_sym_constexpr] = ACTIONS(4838),
    [anon_sym_COLON] = ACTIONS(4838),
    [anon_sym_AMP] = ACTIONS(4838),
    [anon_sym_AMP_AMP] = ACTIONS(4836),
    [anon_sym_TILDE] = ACTIONS(4836),
    [anon_sym_GT] = ACTIONS(4836),
    [sym_identifier] = ACTIONS(4838),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(4836),
    [sym_operator_name] = ACTIONS(4836),
  },
  [1629] = {
    [sym_enumerator] = STATE(1030),
    [sym_identifier] = ACTIONS(348),
    [sym_comment] = ACTIONS(49),
  },
  [1630] = {
    [sym_preproc_if_in_field_declaration_list] = STATE(246),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(247),
    [sym_type_definition] = STATE(2126),
    [sym__declaration_specifiers] = STATE(248),
    [sym__declarator] = STATE(249),
    [sym_pointer_declarator] = STATE(249),
    [sym_function_declarator] = STATE(250),
    [sym_array_declarator] = STATE(249),
    [sym_storage_class_specifier] = STATE(257),
    [sym_type_qualifier] = STATE(257),
    [sym__type_specifier] = STATE(251),
    [sym_sized_type_specifier] = STATE(251),
    [sym_enum_specifier] = STATE(251),
    [sym_struct_specifier] = STATE(251),
    [sym_union_specifier] = STATE(251),
    [sym__field_declaration_list_item] = STATE(2126),
    [sym_field_declaration] = STATE(2126),
    [sym_macro_type_specifier] = STATE(251),
    [sym_class_specifier] = STATE(251),
    [sym_dependent_type] = STATE(251),
    [sym_template_declaration] = STATE(2126),
    [sym_inline_method_definition] = STATE(252),
    [sym_constructor_or_destructor_definition] = STATE(252),
    [sym_constructor_or_destructor_declaration] = STATE(253),
    [sym_friend_declaration] = STATE(2126),
    [sym_access_specifier] = STATE(2126),
    [sym_reference_declarator] = STATE(249),
    [sym_template_type] = STATE(254),
    [sym_template_function] = STATE(249),
    [sym_using_declaration] = STATE(2126),
    [sym_alias_declaration] = STATE(2126),
    [sym_destructor_name] = STATE(249),
    [sym_scoped_identifier] = STATE(33),
    [sym_scoped_type_identifier] = STATE(34),
    [sym_scoped_namespace_identifier] = STATE(255),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(2126),
    [aux_sym__declaration_specifiers_repeat1] = STATE(257),
    [aux_sym_sized_type_specifier_repeat1] = STATE(258),
    [anon_sym_LPAREN] = ACTIONS(11),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(358),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(4840),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(360),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(362),
    [anon_sym_typedef] = ACTIONS(364),
    [anon_sym_extern] = ACTIONS(27),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_static] = ACTIONS(27),
    [anon_sym_register] = ACTIONS(27),
    [anon_sym_inline] = ACTIONS(27),
    [anon_sym_const] = ACTIONS(29),
    [anon_sym_restrict] = ACTIONS(29),
    [anon_sym_volatile] = ACTIONS(29),
    [anon_sym__Atomic] = ACTIONS(29),
    [anon_sym_mutable] = ACTIONS(29),
    [anon_sym_explicit] = ACTIONS(29),
    [anon_sym_constexpr] = ACTIONS(29),
    [anon_sym_unsigned] = ACTIONS(368),
    [anon_sym_long] = ACTIONS(368),
    [anon_sym_short] = ACTIONS(368),
    [sym_primitive_type] = ACTIONS(370),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(372),
    [anon_sym_union] = ACTIONS(374),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(45),
    [sym_identifier] = ACTIONS(376),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(378),
    [anon_sym_public] = ACTIONS(380),
    [sym_auto] = ACTIONS(370),
    [anon_sym_typename] = ACTIONS(382),
    [anon_sym_template] = ACTIONS(384),
    [anon_sym_friend] = ACTIONS(386),
    [anon_sym_private] = ACTIONS(380),
    [anon_sym_protected] = ACTIONS(380),
    [anon_sym_using] = ACTIONS(388),
    [anon_sym_COLON_COLON] = ACTIONS(390),
    [sym_operator_name] = ACTIONS(392),
  },
  [1631] = {
    [sym_preproc_if_in_field_declaration_list] = STATE(246),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(247),
    [sym_preproc_else_in_field_declaration_list] = STATE(2127),
    [sym_preproc_elif_in_field_declaration_list] = STATE(2128),
    [sym_type_definition] = STATE(2129),
    [sym__declaration_specifiers] = STATE(248),
    [sym__declarator] = STATE(249),
    [sym_pointer_declarator] = STATE(249),
    [sym_function_declarator] = STATE(250),
    [sym_array_declarator] = STATE(249),
    [sym_storage_class_specifier] = STATE(257),
    [sym_type_qualifier] = STATE(257),
    [sym__type_specifier] = STATE(251),
    [sym_sized_type_specifier] = STATE(251),
    [sym_enum_specifier] = STATE(251),
    [sym_struct_specifier] = STATE(251),
    [sym_union_specifier] = STATE(251),
    [sym__field_declaration_list_item] = STATE(2129),
    [sym_field_declaration] = STATE(2129),
    [sym_macro_type_specifier] = STATE(251),
    [sym_class_specifier] = STATE(251),
    [sym_dependent_type] = STATE(251),
    [sym_template_declaration] = STATE(2129),
    [sym_inline_method_definition] = STATE(252),
    [sym_constructor_or_destructor_definition] = STATE(252),
    [sym_constructor_or_destructor_declaration] = STATE(253),
    [sym_friend_declaration] = STATE(2129),
    [sym_access_specifier] = STATE(2129),
    [sym_reference_declarator] = STATE(249),
    [sym_template_type] = STATE(254),
    [sym_template_function] = STATE(249),
    [sym_using_declaration] = STATE(2129),
    [sym_alias_declaration] = STATE(2129),
    [sym_destructor_name] = STATE(249),
    [sym_scoped_identifier] = STATE(33),
    [sym_scoped_type_identifier] = STATE(34),
    [sym_scoped_namespace_identifier] = STATE(255),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(2129),
    [aux_sym__declaration_specifiers_repeat1] = STATE(257),
    [aux_sym_sized_type_specifier_repeat1] = STATE(258),
    [anon_sym_LPAREN] = ACTIONS(11),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(358),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(4842),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(360),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(362),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(2024),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(2026),
    [anon_sym_typedef] = ACTIONS(364),
    [anon_sym_extern] = ACTIONS(27),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_static] = ACTIONS(27),
    [anon_sym_register] = ACTIONS(27),
    [anon_sym_inline] = ACTIONS(27),
    [anon_sym_const] = ACTIONS(29),
    [anon_sym_restrict] = ACTIONS(29),
    [anon_sym_volatile] = ACTIONS(29),
    [anon_sym__Atomic] = ACTIONS(29),
    [anon_sym_mutable] = ACTIONS(29),
    [anon_sym_explicit] = ACTIONS(29),
    [anon_sym_constexpr] = ACTIONS(29),
    [anon_sym_unsigned] = ACTIONS(368),
    [anon_sym_long] = ACTIONS(368),
    [anon_sym_short] = ACTIONS(368),
    [sym_primitive_type] = ACTIONS(370),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(372),
    [anon_sym_union] = ACTIONS(374),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(45),
    [sym_identifier] = ACTIONS(376),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(378),
    [anon_sym_public] = ACTIONS(380),
    [sym_auto] = ACTIONS(370),
    [anon_sym_typename] = ACTIONS(382),
    [anon_sym_template] = ACTIONS(384),
    [anon_sym_friend] = ACTIONS(386),
    [anon_sym_private] = ACTIONS(380),
    [anon_sym_protected] = ACTIONS(380),
    [anon_sym_using] = ACTIONS(388),
    [anon_sym_COLON_COLON] = ACTIONS(390),
    [sym_operator_name] = ACTIONS(392),
  },
  [1632] = {
    [anon_sym_LPAREN] = ACTIONS(4844),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(4846),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(4844),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(4844),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(4844),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(4844),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(4844),
    [anon_sym_typedef] = ACTIONS(4846),
    [anon_sym_extern] = ACTIONS(4846),
    [anon_sym_RBRACE] = ACTIONS(4844),
    [anon_sym_STAR] = ACTIONS(4844),
    [anon_sym_static] = ACTIONS(4846),
    [anon_sym_register] = ACTIONS(4846),
    [anon_sym_inline] = ACTIONS(4846),
    [anon_sym_const] = ACTIONS(4846),
    [anon_sym_restrict] = ACTIONS(4846),
    [anon_sym_volatile] = ACTIONS(4846),
    [anon_sym__Atomic] = ACTIONS(4846),
    [anon_sym_mutable] = ACTIONS(4846),
    [anon_sym_explicit] = ACTIONS(4846),
    [anon_sym_constexpr] = ACTIONS(4846),
    [anon_sym_unsigned] = ACTIONS(4846),
    [anon_sym_long] = ACTIONS(4846),
    [anon_sym_short] = ACTIONS(4846),
    [sym_primitive_type] = ACTIONS(4846),
    [anon_sym_enum] = ACTIONS(4846),
    [anon_sym_struct] = ACTIONS(4846),
    [anon_sym_union] = ACTIONS(4846),
    [anon_sym_AMP] = ACTIONS(4846),
    [anon_sym_AMP_AMP] = ACTIONS(4844),
    [anon_sym_TILDE] = ACTIONS(4844),
    [sym_identifier] = ACTIONS(4846),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(4846),
    [anon_sym_public] = ACTIONS(4846),
    [sym_auto] = ACTIONS(4846),
    [anon_sym_typename] = ACTIONS(4846),
    [anon_sym_template] = ACTIONS(4846),
    [anon_sym_friend] = ACTIONS(4846),
    [anon_sym_private] = ACTIONS(4846),
    [anon_sym_protected] = ACTIONS(4846),
    [anon_sym_using] = ACTIONS(4846),
    [anon_sym_COLON_COLON] = ACTIONS(4844),
    [sym_operator_name] = ACTIONS(4844),
  },
  [1633] = {
    [anon_sym_LPAREN] = ACTIONS(4848),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(4850),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(4848),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(4848),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(4848),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(4848),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(4848),
    [anon_sym_typedef] = ACTIONS(4850),
    [anon_sym_extern] = ACTIONS(4850),
    [anon_sym_RBRACE] = ACTIONS(4848),
    [anon_sym_STAR] = ACTIONS(4848),
    [anon_sym_static] = ACTIONS(4850),
    [anon_sym_register] = ACTIONS(4850),
    [anon_sym_inline] = ACTIONS(4850),
    [anon_sym_const] = ACTIONS(4850),
    [anon_sym_restrict] = ACTIONS(4850),
    [anon_sym_volatile] = ACTIONS(4850),
    [anon_sym__Atomic] = ACTIONS(4850),
    [anon_sym_mutable] = ACTIONS(4850),
    [anon_sym_explicit] = ACTIONS(4850),
    [anon_sym_constexpr] = ACTIONS(4850),
    [anon_sym_unsigned] = ACTIONS(4850),
    [anon_sym_long] = ACTIONS(4850),
    [anon_sym_short] = ACTIONS(4850),
    [sym_primitive_type] = ACTIONS(4850),
    [anon_sym_enum] = ACTIONS(4850),
    [anon_sym_struct] = ACTIONS(4850),
    [anon_sym_union] = ACTIONS(4850),
    [anon_sym_AMP] = ACTIONS(4850),
    [anon_sym_AMP_AMP] = ACTIONS(4848),
    [anon_sym_TILDE] = ACTIONS(4848),
    [sym_identifier] = ACTIONS(4850),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(4850),
    [anon_sym_public] = ACTIONS(4850),
    [sym_auto] = ACTIONS(4850),
    [anon_sym_typename] = ACTIONS(4850),
    [anon_sym_template] = ACTIONS(4850),
    [anon_sym_friend] = ACTIONS(4850),
    [anon_sym_private] = ACTIONS(4850),
    [anon_sym_protected] = ACTIONS(4850),
    [anon_sym_using] = ACTIONS(4850),
    [anon_sym_COLON_COLON] = ACTIONS(4848),
    [sym_operator_name] = ACTIONS(4848),
  },
  [1634] = {
    [anon_sym_LPAREN] = ACTIONS(4852),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(4854),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(4852),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(4852),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(4852),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(4852),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(4852),
    [anon_sym_typedef] = ACTIONS(4854),
    [anon_sym_extern] = ACTIONS(4854),
    [anon_sym_RBRACE] = ACTIONS(4852),
    [anon_sym_STAR] = ACTIONS(4852),
    [anon_sym_static] = ACTIONS(4854),
    [anon_sym_register] = ACTIONS(4854),
    [anon_sym_inline] = ACTIONS(4854),
    [anon_sym_const] = ACTIONS(4854),
    [anon_sym_restrict] = ACTIONS(4854),
    [anon_sym_volatile] = ACTIONS(4854),
    [anon_sym__Atomic] = ACTIONS(4854),
    [anon_sym_mutable] = ACTIONS(4854),
    [anon_sym_explicit] = ACTIONS(4854),
    [anon_sym_constexpr] = ACTIONS(4854),
    [anon_sym_unsigned] = ACTIONS(4854),
    [anon_sym_long] = ACTIONS(4854),
    [anon_sym_short] = ACTIONS(4854),
    [sym_primitive_type] = ACTIONS(4854),
    [anon_sym_enum] = ACTIONS(4854),
    [anon_sym_struct] = ACTIONS(4854),
    [anon_sym_union] = ACTIONS(4854),
    [anon_sym_AMP] = ACTIONS(4854),
    [anon_sym_AMP_AMP] = ACTIONS(4852),
    [anon_sym_TILDE] = ACTIONS(4852),
    [sym_identifier] = ACTIONS(4854),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(4854),
    [anon_sym_public] = ACTIONS(4854),
    [sym_auto] = ACTIONS(4854),
    [anon_sym_typename] = ACTIONS(4854),
    [anon_sym_template] = ACTIONS(4854),
    [anon_sym_friend] = ACTIONS(4854),
    [anon_sym_private] = ACTIONS(4854),
    [anon_sym_protected] = ACTIONS(4854),
    [anon_sym_using] = ACTIONS(4854),
    [anon_sym_COLON_COLON] = ACTIONS(4852),
    [sym_operator_name] = ACTIONS(4852),
  },
  [1635] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(4856),
    [sym_comment] = ACTIONS(49),
  },
  [1636] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(4858),
    [sym_comment] = ACTIONS(49),
  },
  [1637] = {
    [sym_preproc_if_in_field_declaration_list] = STATE(246),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(247),
    [sym_type_definition] = STATE(1637),
    [sym__declaration_specifiers] = STATE(248),
    [sym__declarator] = STATE(249),
    [sym_pointer_declarator] = STATE(249),
    [sym_function_declarator] = STATE(250),
    [sym_array_declarator] = STATE(249),
    [sym_storage_class_specifier] = STATE(257),
    [sym_type_qualifier] = STATE(257),
    [sym__type_specifier] = STATE(251),
    [sym_sized_type_specifier] = STATE(251),
    [sym_enum_specifier] = STATE(251),
    [sym_struct_specifier] = STATE(251),
    [sym_union_specifier] = STATE(251),
    [sym__field_declaration_list_item] = STATE(1637),
    [sym_field_declaration] = STATE(1637),
    [sym_macro_type_specifier] = STATE(251),
    [sym_class_specifier] = STATE(251),
    [sym_dependent_type] = STATE(251),
    [sym_template_declaration] = STATE(1637),
    [sym_inline_method_definition] = STATE(252),
    [sym_constructor_or_destructor_definition] = STATE(252),
    [sym_constructor_or_destructor_declaration] = STATE(253),
    [sym_friend_declaration] = STATE(1637),
    [sym_access_specifier] = STATE(1637),
    [sym_reference_declarator] = STATE(249),
    [sym_template_type] = STATE(254),
    [sym_template_function] = STATE(249),
    [sym_using_declaration] = STATE(1637),
    [sym_alias_declaration] = STATE(1637),
    [sym_destructor_name] = STATE(249),
    [sym_scoped_identifier] = STATE(33),
    [sym_scoped_type_identifier] = STATE(34),
    [sym_scoped_namespace_identifier] = STATE(255),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(1637),
    [aux_sym__declaration_specifiers_repeat1] = STATE(257),
    [aux_sym_sized_type_specifier_repeat1] = STATE(258),
    [anon_sym_LPAREN] = ACTIONS(2118),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(2121),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(2136),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(2124),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(2127),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(2136),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(2136),
    [anon_sym_typedef] = ACTIONS(2130),
    [anon_sym_extern] = ACTIONS(2133),
    [anon_sym_STAR] = ACTIONS(2138),
    [anon_sym_static] = ACTIONS(2133),
    [anon_sym_register] = ACTIONS(2133),
    [anon_sym_inline] = ACTIONS(2133),
    [anon_sym_const] = ACTIONS(2141),
    [anon_sym_restrict] = ACTIONS(2141),
    [anon_sym_volatile] = ACTIONS(2141),
    [anon_sym__Atomic] = ACTIONS(2141),
    [anon_sym_mutable] = ACTIONS(2141),
    [anon_sym_explicit] = ACTIONS(2141),
    [anon_sym_constexpr] = ACTIONS(2141),
    [anon_sym_unsigned] = ACTIONS(2144),
    [anon_sym_long] = ACTIONS(2144),
    [anon_sym_short] = ACTIONS(2144),
    [sym_primitive_type] = ACTIONS(2147),
    [anon_sym_enum] = ACTIONS(2150),
    [anon_sym_struct] = ACTIONS(2153),
    [anon_sym_union] = ACTIONS(2156),
    [anon_sym_AMP] = ACTIONS(2159),
    [anon_sym_AMP_AMP] = ACTIONS(2162),
    [anon_sym_TILDE] = ACTIONS(2165),
    [sym_identifier] = ACTIONS(2168),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(2171),
    [anon_sym_public] = ACTIONS(2174),
    [sym_auto] = ACTIONS(2147),
    [anon_sym_typename] = ACTIONS(2177),
    [anon_sym_template] = ACTIONS(2180),
    [anon_sym_friend] = ACTIONS(2183),
    [anon_sym_private] = ACTIONS(2174),
    [anon_sym_protected] = ACTIONS(2174),
    [anon_sym_using] = ACTIONS(2186),
    [anon_sym_COLON_COLON] = ACTIONS(2189),
    [sym_operator_name] = ACTIONS(2192),
  },
  [1638] = {
    [anon_sym_LPAREN] = ACTIONS(4860),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(4862),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(4860),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(4860),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(4860),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(4860),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(4860),
    [anon_sym_typedef] = ACTIONS(4862),
    [anon_sym_extern] = ACTIONS(4862),
    [anon_sym_RBRACE] = ACTIONS(4860),
    [anon_sym_STAR] = ACTIONS(4860),
    [anon_sym_static] = ACTIONS(4862),
    [anon_sym_register] = ACTIONS(4862),
    [anon_sym_inline] = ACTIONS(4862),
    [anon_sym_const] = ACTIONS(4862),
    [anon_sym_restrict] = ACTIONS(4862),
    [anon_sym_volatile] = ACTIONS(4862),
    [anon_sym__Atomic] = ACTIONS(4862),
    [anon_sym_mutable] = ACTIONS(4862),
    [anon_sym_explicit] = ACTIONS(4862),
    [anon_sym_constexpr] = ACTIONS(4862),
    [anon_sym_unsigned] = ACTIONS(4862),
    [anon_sym_long] = ACTIONS(4862),
    [anon_sym_short] = ACTIONS(4862),
    [sym_primitive_type] = ACTIONS(4862),
    [anon_sym_enum] = ACTIONS(4862),
    [anon_sym_struct] = ACTIONS(4862),
    [anon_sym_union] = ACTIONS(4862),
    [anon_sym_AMP] = ACTIONS(4862),
    [anon_sym_AMP_AMP] = ACTIONS(4860),
    [anon_sym_TILDE] = ACTIONS(4860),
    [sym_identifier] = ACTIONS(4862),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(4862),
    [anon_sym_public] = ACTIONS(4862),
    [sym_auto] = ACTIONS(4862),
    [anon_sym_typename] = ACTIONS(4862),
    [anon_sym_template] = ACTIONS(4862),
    [anon_sym_friend] = ACTIONS(4862),
    [anon_sym_private] = ACTIONS(4862),
    [anon_sym_protected] = ACTIONS(4862),
    [anon_sym_using] = ACTIONS(4862),
    [anon_sym_COLON_COLON] = ACTIONS(4860),
    [sym_operator_name] = ACTIONS(4860),
  },
  [1639] = {
    [anon_sym_LPAREN] = ACTIONS(4864),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(4866),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(4864),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(4864),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(4864),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(4864),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(4864),
    [anon_sym_typedef] = ACTIONS(4866),
    [anon_sym_extern] = ACTIONS(4866),
    [anon_sym_RBRACE] = ACTIONS(4864),
    [anon_sym_STAR] = ACTIONS(4864),
    [anon_sym_static] = ACTIONS(4866),
    [anon_sym_register] = ACTIONS(4866),
    [anon_sym_inline] = ACTIONS(4866),
    [anon_sym_const] = ACTIONS(4866),
    [anon_sym_restrict] = ACTIONS(4866),
    [anon_sym_volatile] = ACTIONS(4866),
    [anon_sym__Atomic] = ACTIONS(4866),
    [anon_sym_mutable] = ACTIONS(4866),
    [anon_sym_explicit] = ACTIONS(4866),
    [anon_sym_constexpr] = ACTIONS(4866),
    [anon_sym_unsigned] = ACTIONS(4866),
    [anon_sym_long] = ACTIONS(4866),
    [anon_sym_short] = ACTIONS(4866),
    [sym_primitive_type] = ACTIONS(4866),
    [anon_sym_enum] = ACTIONS(4866),
    [anon_sym_struct] = ACTIONS(4866),
    [anon_sym_union] = ACTIONS(4866),
    [anon_sym_AMP] = ACTIONS(4866),
    [anon_sym_AMP_AMP] = ACTIONS(4864),
    [anon_sym_TILDE] = ACTIONS(4864),
    [sym_identifier] = ACTIONS(4866),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(4866),
    [anon_sym_public] = ACTIONS(4866),
    [sym_auto] = ACTIONS(4866),
    [anon_sym_typename] = ACTIONS(4866),
    [anon_sym_template] = ACTIONS(4866),
    [anon_sym_friend] = ACTIONS(4866),
    [anon_sym_private] = ACTIONS(4866),
    [anon_sym_protected] = ACTIONS(4866),
    [anon_sym_using] = ACTIONS(4866),
    [anon_sym_COLON_COLON] = ACTIONS(4864),
    [sym_operator_name] = ACTIONS(4864),
  },
  [1640] = {
    [anon_sym_LPAREN] = ACTIONS(4868),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(4870),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(4868),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(4868),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(4868),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(4868),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(4868),
    [anon_sym_typedef] = ACTIONS(4870),
    [anon_sym_extern] = ACTIONS(4870),
    [anon_sym_RBRACE] = ACTIONS(4868),
    [anon_sym_STAR] = ACTIONS(4868),
    [anon_sym_static] = ACTIONS(4870),
    [anon_sym_register] = ACTIONS(4870),
    [anon_sym_inline] = ACTIONS(4870),
    [anon_sym_const] = ACTIONS(4870),
    [anon_sym_restrict] = ACTIONS(4870),
    [anon_sym_volatile] = ACTIONS(4870),
    [anon_sym__Atomic] = ACTIONS(4870),
    [anon_sym_mutable] = ACTIONS(4870),
    [anon_sym_explicit] = ACTIONS(4870),
    [anon_sym_constexpr] = ACTIONS(4870),
    [anon_sym_unsigned] = ACTIONS(4870),
    [anon_sym_long] = ACTIONS(4870),
    [anon_sym_short] = ACTIONS(4870),
    [sym_primitive_type] = ACTIONS(4870),
    [anon_sym_enum] = ACTIONS(4870),
    [anon_sym_struct] = ACTIONS(4870),
    [anon_sym_union] = ACTIONS(4870),
    [anon_sym_AMP] = ACTIONS(4870),
    [anon_sym_AMP_AMP] = ACTIONS(4868),
    [anon_sym_TILDE] = ACTIONS(4868),
    [sym_identifier] = ACTIONS(4870),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(4870),
    [anon_sym_public] = ACTIONS(4870),
    [sym_auto] = ACTIONS(4870),
    [anon_sym_typename] = ACTIONS(4870),
    [anon_sym_template] = ACTIONS(4870),
    [anon_sym_friend] = ACTIONS(4870),
    [anon_sym_private] = ACTIONS(4870),
    [anon_sym_protected] = ACTIONS(4870),
    [anon_sym_using] = ACTIONS(4870),
    [anon_sym_COLON_COLON] = ACTIONS(4868),
    [sym_operator_name] = ACTIONS(4868),
  },
  [1641] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(4872),
    [sym_comment] = ACTIONS(49),
  },
  [1642] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(4874),
    [sym_comment] = ACTIONS(49),
  },
  [1643] = {
    [anon_sym_LPAREN] = ACTIONS(4876),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(4878),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(4876),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(4876),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(4876),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(4876),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(4876),
    [anon_sym_typedef] = ACTIONS(4878),
    [anon_sym_extern] = ACTIONS(4878),
    [anon_sym_RBRACE] = ACTIONS(4876),
    [anon_sym_STAR] = ACTIONS(4876),
    [anon_sym_static] = ACTIONS(4878),
    [anon_sym_register] = ACTIONS(4878),
    [anon_sym_inline] = ACTIONS(4878),
    [anon_sym_const] = ACTIONS(4878),
    [anon_sym_restrict] = ACTIONS(4878),
    [anon_sym_volatile] = ACTIONS(4878),
    [anon_sym__Atomic] = ACTIONS(4878),
    [anon_sym_mutable] = ACTIONS(4878),
    [anon_sym_explicit] = ACTIONS(4878),
    [anon_sym_constexpr] = ACTIONS(4878),
    [anon_sym_unsigned] = ACTIONS(4878),
    [anon_sym_long] = ACTIONS(4878),
    [anon_sym_short] = ACTIONS(4878),
    [sym_primitive_type] = ACTIONS(4878),
    [anon_sym_enum] = ACTIONS(4878),
    [anon_sym_struct] = ACTIONS(4878),
    [anon_sym_union] = ACTIONS(4878),
    [anon_sym_AMP] = ACTIONS(4878),
    [anon_sym_AMP_AMP] = ACTIONS(4876),
    [anon_sym_TILDE] = ACTIONS(4876),
    [sym_identifier] = ACTIONS(4878),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(4878),
    [anon_sym_public] = ACTIONS(4878),
    [sym_auto] = ACTIONS(4878),
    [anon_sym_typename] = ACTIONS(4878),
    [anon_sym_template] = ACTIONS(4878),
    [anon_sym_friend] = ACTIONS(4878),
    [anon_sym_private] = ACTIONS(4878),
    [anon_sym_protected] = ACTIONS(4878),
    [anon_sym_using] = ACTIONS(4878),
    [anon_sym_COLON_COLON] = ACTIONS(4876),
    [sym_operator_name] = ACTIONS(4876),
  },
  [1644] = {
    [anon_sym_LPAREN] = ACTIONS(4880),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(4882),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(4880),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(4880),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(4880),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(4880),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(4880),
    [anon_sym_typedef] = ACTIONS(4882),
    [anon_sym_extern] = ACTIONS(4882),
    [anon_sym_RBRACE] = ACTIONS(4880),
    [anon_sym_STAR] = ACTIONS(4880),
    [anon_sym_static] = ACTIONS(4882),
    [anon_sym_register] = ACTIONS(4882),
    [anon_sym_inline] = ACTIONS(4882),
    [anon_sym_const] = ACTIONS(4882),
    [anon_sym_restrict] = ACTIONS(4882),
    [anon_sym_volatile] = ACTIONS(4882),
    [anon_sym__Atomic] = ACTIONS(4882),
    [anon_sym_mutable] = ACTIONS(4882),
    [anon_sym_explicit] = ACTIONS(4882),
    [anon_sym_constexpr] = ACTIONS(4882),
    [anon_sym_unsigned] = ACTIONS(4882),
    [anon_sym_long] = ACTIONS(4882),
    [anon_sym_short] = ACTIONS(4882),
    [sym_primitive_type] = ACTIONS(4882),
    [anon_sym_enum] = ACTIONS(4882),
    [anon_sym_struct] = ACTIONS(4882),
    [anon_sym_union] = ACTIONS(4882),
    [anon_sym_AMP] = ACTIONS(4882),
    [anon_sym_AMP_AMP] = ACTIONS(4880),
    [anon_sym_TILDE] = ACTIONS(4880),
    [sym_identifier] = ACTIONS(4882),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(4882),
    [anon_sym_public] = ACTIONS(4882),
    [sym_auto] = ACTIONS(4882),
    [anon_sym_typename] = ACTIONS(4882),
    [anon_sym_template] = ACTIONS(4882),
    [anon_sym_friend] = ACTIONS(4882),
    [anon_sym_private] = ACTIONS(4882),
    [anon_sym_protected] = ACTIONS(4882),
    [anon_sym_using] = ACTIONS(4882),
    [anon_sym_COLON_COLON] = ACTIONS(4880),
    [sym_operator_name] = ACTIONS(4880),
  },
  [1645] = {
    [anon_sym_LPAREN] = ACTIONS(4884),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(4886),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(4884),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(4884),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(4884),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(4884),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(4884),
    [anon_sym_typedef] = ACTIONS(4886),
    [anon_sym_extern] = ACTIONS(4886),
    [anon_sym_RBRACE] = ACTIONS(4884),
    [anon_sym_STAR] = ACTIONS(4884),
    [anon_sym_static] = ACTIONS(4886),
    [anon_sym_register] = ACTIONS(4886),
    [anon_sym_inline] = ACTIONS(4886),
    [anon_sym_const] = ACTIONS(4886),
    [anon_sym_restrict] = ACTIONS(4886),
    [anon_sym_volatile] = ACTIONS(4886),
    [anon_sym__Atomic] = ACTIONS(4886),
    [anon_sym_mutable] = ACTIONS(4886),
    [anon_sym_explicit] = ACTIONS(4886),
    [anon_sym_constexpr] = ACTIONS(4886),
    [anon_sym_unsigned] = ACTIONS(4886),
    [anon_sym_long] = ACTIONS(4886),
    [anon_sym_short] = ACTIONS(4886),
    [sym_primitive_type] = ACTIONS(4886),
    [anon_sym_enum] = ACTIONS(4886),
    [anon_sym_struct] = ACTIONS(4886),
    [anon_sym_union] = ACTIONS(4886),
    [anon_sym_AMP] = ACTIONS(4886),
    [anon_sym_AMP_AMP] = ACTIONS(4884),
    [anon_sym_TILDE] = ACTIONS(4884),
    [sym_identifier] = ACTIONS(4886),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(4886),
    [anon_sym_public] = ACTIONS(4886),
    [sym_auto] = ACTIONS(4886),
    [anon_sym_typename] = ACTIONS(4886),
    [anon_sym_template] = ACTIONS(4886),
    [anon_sym_friend] = ACTIONS(4886),
    [anon_sym_private] = ACTIONS(4886),
    [anon_sym_protected] = ACTIONS(4886),
    [anon_sym_using] = ACTIONS(4886),
    [anon_sym_COLON_COLON] = ACTIONS(4884),
    [sym_operator_name] = ACTIONS(4884),
  },
  [1646] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(4888),
    [sym_comment] = ACTIONS(49),
  },
  [1647] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(4890),
    [sym_comment] = ACTIONS(49),
  },
  [1648] = {
    [anon_sym_LPAREN] = ACTIONS(1988),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1990),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(1988),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1988),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1988),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(1988),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(1988),
    [anon_sym_typedef] = ACTIONS(1990),
    [anon_sym_extern] = ACTIONS(1990),
    [anon_sym_RBRACE] = ACTIONS(1988),
    [anon_sym_STAR] = ACTIONS(1988),
    [anon_sym_static] = ACTIONS(1990),
    [anon_sym_register] = ACTIONS(1990),
    [anon_sym_inline] = ACTIONS(1990),
    [anon_sym_const] = ACTIONS(1990),
    [anon_sym_restrict] = ACTIONS(1990),
    [anon_sym_volatile] = ACTIONS(1990),
    [anon_sym__Atomic] = ACTIONS(1990),
    [anon_sym_mutable] = ACTIONS(1990),
    [anon_sym_explicit] = ACTIONS(1990),
    [anon_sym_constexpr] = ACTIONS(1990),
    [anon_sym_unsigned] = ACTIONS(1990),
    [anon_sym_long] = ACTIONS(1990),
    [anon_sym_short] = ACTIONS(1990),
    [sym_primitive_type] = ACTIONS(1990),
    [anon_sym_enum] = ACTIONS(1990),
    [anon_sym_struct] = ACTIONS(1990),
    [anon_sym_union] = ACTIONS(1990),
    [anon_sym_AMP] = ACTIONS(1990),
    [anon_sym_AMP_AMP] = ACTIONS(1988),
    [anon_sym_TILDE] = ACTIONS(1988),
    [sym_identifier] = ACTIONS(1990),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(1990),
    [anon_sym_public] = ACTIONS(1990),
    [sym_auto] = ACTIONS(1990),
    [anon_sym_typename] = ACTIONS(1990),
    [anon_sym_template] = ACTIONS(1990),
    [anon_sym_friend] = ACTIONS(1990),
    [anon_sym_private] = ACTIONS(1990),
    [anon_sym_protected] = ACTIONS(1990),
    [anon_sym_using] = ACTIONS(1990),
    [anon_sym_COLON_COLON] = ACTIONS(1988),
    [sym_operator_name] = ACTIONS(1988),
  },
  [1649] = {
    [sym_parameter_list] = STATE(513),
    [anon_sym_LPAREN] = ACTIONS(206),
    [anon_sym_SEMI] = ACTIONS(4892),
    [anon_sym_LBRACK] = ACTIONS(955),
    [sym_comment] = ACTIONS(49),
  },
  [1650] = {
    [anon_sym_LPAREN] = ACTIONS(522),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(524),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(522),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(522),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(522),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(522),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(522),
    [anon_sym_typedef] = ACTIONS(524),
    [anon_sym_extern] = ACTIONS(524),
    [anon_sym_RBRACE] = ACTIONS(522),
    [anon_sym_STAR] = ACTIONS(522),
    [anon_sym_static] = ACTIONS(524),
    [anon_sym_register] = ACTIONS(524),
    [anon_sym_inline] = ACTIONS(524),
    [anon_sym_const] = ACTIONS(524),
    [anon_sym_restrict] = ACTIONS(524),
    [anon_sym_volatile] = ACTIONS(524),
    [anon_sym__Atomic] = ACTIONS(524),
    [anon_sym_mutable] = ACTIONS(524),
    [anon_sym_explicit] = ACTIONS(524),
    [anon_sym_constexpr] = ACTIONS(524),
    [anon_sym_unsigned] = ACTIONS(524),
    [anon_sym_long] = ACTIONS(524),
    [anon_sym_short] = ACTIONS(524),
    [sym_primitive_type] = ACTIONS(524),
    [anon_sym_enum] = ACTIONS(524),
    [anon_sym_struct] = ACTIONS(524),
    [anon_sym_union] = ACTIONS(524),
    [anon_sym_AMP] = ACTIONS(524),
    [anon_sym_AMP_AMP] = ACTIONS(522),
    [anon_sym_TILDE] = ACTIONS(522),
    [sym_identifier] = ACTIONS(524),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(524),
    [anon_sym_public] = ACTIONS(524),
    [sym_auto] = ACTIONS(524),
    [anon_sym_typename] = ACTIONS(524),
    [anon_sym_template] = ACTIONS(524),
    [anon_sym_friend] = ACTIONS(524),
    [anon_sym_private] = ACTIONS(524),
    [anon_sym_protected] = ACTIONS(524),
    [anon_sym_using] = ACTIONS(524),
    [anon_sym_COLON_COLON] = ACTIONS(522),
    [sym_operator_name] = ACTIONS(522),
  },
  [1651] = {
    [anon_sym_LPAREN] = ACTIONS(1261),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1263),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(1261),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1261),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1261),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(1261),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(1261),
    [anon_sym_typedef] = ACTIONS(1263),
    [anon_sym_extern] = ACTIONS(1263),
    [anon_sym_RBRACE] = ACTIONS(1261),
    [anon_sym_STAR] = ACTIONS(1261),
    [anon_sym_static] = ACTIONS(1263),
    [anon_sym_register] = ACTIONS(1263),
    [anon_sym_inline] = ACTIONS(1263),
    [anon_sym_const] = ACTIONS(1263),
    [anon_sym_restrict] = ACTIONS(1263),
    [anon_sym_volatile] = ACTIONS(1263),
    [anon_sym__Atomic] = ACTIONS(1263),
    [anon_sym_mutable] = ACTIONS(1263),
    [anon_sym_explicit] = ACTIONS(1263),
    [anon_sym_constexpr] = ACTIONS(1263),
    [anon_sym_unsigned] = ACTIONS(1263),
    [anon_sym_long] = ACTIONS(1263),
    [anon_sym_short] = ACTIONS(1263),
    [sym_primitive_type] = ACTIONS(1263),
    [anon_sym_enum] = ACTIONS(1263),
    [anon_sym_struct] = ACTIONS(1263),
    [anon_sym_union] = ACTIONS(1263),
    [anon_sym_AMP] = ACTIONS(1263),
    [anon_sym_AMP_AMP] = ACTIONS(1261),
    [anon_sym_TILDE] = ACTIONS(1261),
    [sym_identifier] = ACTIONS(1263),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(1263),
    [anon_sym_public] = ACTIONS(1263),
    [sym_auto] = ACTIONS(1263),
    [anon_sym_typename] = ACTIONS(1263),
    [anon_sym_template] = ACTIONS(1263),
    [anon_sym_friend] = ACTIONS(1263),
    [anon_sym_private] = ACTIONS(1263),
    [anon_sym_protected] = ACTIONS(1263),
    [anon_sym_using] = ACTIONS(1263),
    [anon_sym_COLON_COLON] = ACTIONS(1261),
    [sym_operator_name] = ACTIONS(1261),
  },
  [1652] = {
    [sym_preproc_include] = STATE(1082),
    [sym_preproc_def] = STATE(1082),
    [sym_preproc_function_def] = STATE(1082),
    [sym_preproc_call] = STATE(1082),
    [sym_preproc_if_in_compound_statement] = STATE(410),
    [sym_preproc_ifdef_in_compound_statement] = STATE(411),
    [sym_declaration] = STATE(1082),
    [sym_type_definition] = STATE(1082),
    [sym__declaration_specifiers] = STATE(412),
    [sym_compound_statement] = STATE(1082),
    [sym_storage_class_specifier] = STATE(419),
    [sym_type_qualifier] = STATE(419),
    [sym__type_specifier] = STATE(30),
    [sym_sized_type_specifier] = STATE(30),
    [sym_enum_specifier] = STATE(30),
    [sym_struct_specifier] = STATE(30),
    [sym_union_specifier] = STATE(30),
    [sym_labeled_statement] = STATE(1082),
    [sym_expression_statement] = STATE(1082),
    [sym_if_statement] = STATE(1082),
    [sym_switch_statement] = STATE(1082),
    [sym_case_statement] = STATE(1082),
    [sym_while_statement] = STATE(1082),
    [sym_do_statement] = STATE(1082),
    [sym_for_statement] = STATE(1082),
    [sym_return_statement] = STATE(1082),
    [sym_break_statement] = STATE(1082),
    [sym_continue_statement] = STATE(1082),
    [sym_goto_statement] = STATE(1082),
    [sym__expression] = STATE(669),
    [sym_comma_expression] = STATE(414),
    [sym_conditional_expression] = STATE(669),
    [sym_assignment_expression] = STATE(669),
    [sym_pointer_expression] = STATE(669),
    [sym_logical_expression] = STATE(669),
    [sym_bitwise_expression] = STATE(669),
    [sym_equality_expression] = STATE(669),
    [sym_relational_expression] = STATE(669),
    [sym_shift_expression] = STATE(669),
    [sym_math_expression] = STATE(669),
    [sym_cast_expression] = STATE(669),
    [sym_sizeof_expression] = STATE(669),
    [sym_subscript_expression] = STATE(669),
    [sym_call_expression] = STATE(669),
    [sym_field_expression] = STATE(669),
    [sym_compound_literal_expression] = STATE(669),
    [sym_parenthesized_expression] = STATE(669),
    [sym_initializer_list] = STATE(670),
    [sym_initializer_pair] = STATE(670),
    [sym_subscript_designator] = STATE(671),
    [sym_field_designator] = STATE(671),
    [sym_concatenated_string] = STATE(669),
    [sym__empty_declaration] = STATE(1082),
    [sym_macro_type_specifier] = STATE(30),
    [sym_class_specifier] = STATE(30),
    [sym_dependent_type] = STATE(30),
    [sym_structured_binding_declaration] = STATE(1082),
    [sym_template_type] = STATE(415),
    [sym_template_function] = STATE(669),
    [sym_for_range_loop] = STATE(1082),
    [sym_new_expression] = STATE(669),
    [sym_delete_expression] = STATE(669),
    [sym_lambda_expression] = STATE(669),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(416),
    [sym_scoped_namespace_identifier] = STATE(417),
    [aux_sym_preproc_if_in_compound_statement_repeat1] = STATE(1082),
    [aux_sym__declaration_specifiers_repeat1] = STATE(419),
    [aux_sym_sized_type_specifier_repeat1] = STATE(38),
    [aux_sym_initializer_pair_repeat1] = STATE(671),
    [sym_raw_string_literal] = ACTIONS(1265),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(622),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(624),
    [anon_sym_LPAREN] = ACTIONS(1267),
    [anon_sym_COMMA] = ACTIONS(1269),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(628),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(630),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(632),
    [sym_preproc_directive] = ACTIONS(634),
    [anon_sym_SEMI] = ACTIONS(636),
    [anon_sym_typedef] = ACTIONS(638),
    [anon_sym_extern] = ACTIONS(154),
    [anon_sym_LBRACE] = ACTIONS(1271),
    [anon_sym_RBRACE] = ACTIONS(4894),
    [anon_sym_STAR] = ACTIONS(1275),
    [anon_sym_LBRACK] = ACTIONS(1277),
    [anon_sym_static] = ACTIONS(154),
    [anon_sym_register] = ACTIONS(154),
    [anon_sym_inline] = ACTIONS(154),
    [anon_sym_const] = ACTIONS(158),
    [anon_sym_restrict] = ACTIONS(158),
    [anon_sym_volatile] = ACTIONS(158),
    [anon_sym__Atomic] = ACTIONS(158),
    [anon_sym_mutable] = ACTIONS(158),
    [anon_sym_explicit] = ACTIONS(158),
    [anon_sym_constexpr] = ACTIONS(158),
    [anon_sym_unsigned] = ACTIONS(31),
    [anon_sym_long] = ACTIONS(31),
    [anon_sym_short] = ACTIONS(31),
    [sym_primitive_type] = ACTIONS(33),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_union] = ACTIONS(39),
    [anon_sym_if] = ACTIONS(646),
    [anon_sym_switch] = ACTIONS(648),
    [anon_sym_case] = ACTIONS(650),
    [anon_sym_default] = ACTIONS(652),
    [anon_sym_while] = ACTIONS(654),
    [anon_sym_do] = ACTIONS(656),
    [anon_sym_for] = ACTIONS(658),
    [anon_sym_return] = ACTIONS(660),
    [anon_sym_break] = ACTIONS(662),
    [anon_sym_continue] = ACTIONS(664),
    [anon_sym_goto] = ACTIONS(666),
    [anon_sym_AMP] = ACTIONS(1275),
    [anon_sym_BANG] = ACTIONS(1279),
    [anon_sym_TILDE] = ACTIONS(1281),
    [anon_sym_PLUS] = ACTIONS(1283),
    [anon_sym_DASH] = ACTIONS(1283),
    [anon_sym_DASH_DASH] = ACTIONS(1285),
    [anon_sym_PLUS_PLUS] = ACTIONS(1285),
    [anon_sym_sizeof] = ACTIONS(1287),
    [anon_sym_DOT] = ACTIONS(1289),
    [sym_number_literal] = ACTIONS(1265),
    [sym_char_literal] = ACTIONS(1265),
    [sym_string_literal] = ACTIONS(1291),
    [sym_true] = ACTIONS(1293),
    [sym_false] = ACTIONS(1293),
    [sym_null] = ACTIONS(1293),
    [sym_identifier] = ACTIONS(682),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(51),
    [sym_auto] = ACTIONS(33),
    [anon_sym_typename] = ACTIONS(53),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1295),
    [anon_sym_delete] = ACTIONS(1297),
    [sym_nullptr] = ACTIONS(1293),
  },
  [1653] = {
    [anon_sym_LPAREN] = ACTIONS(1305),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1307),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(1305),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1305),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1305),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(1305),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(1305),
    [anon_sym_typedef] = ACTIONS(1307),
    [anon_sym_extern] = ACTIONS(1307),
    [anon_sym_RBRACE] = ACTIONS(1305),
    [anon_sym_STAR] = ACTIONS(1305),
    [anon_sym_static] = ACTIONS(1307),
    [anon_sym_register] = ACTIONS(1307),
    [anon_sym_inline] = ACTIONS(1307),
    [anon_sym_const] = ACTIONS(1307),
    [anon_sym_restrict] = ACTIONS(1307),
    [anon_sym_volatile] = ACTIONS(1307),
    [anon_sym__Atomic] = ACTIONS(1307),
    [anon_sym_mutable] = ACTIONS(1307),
    [anon_sym_explicit] = ACTIONS(1307),
    [anon_sym_constexpr] = ACTIONS(1307),
    [anon_sym_unsigned] = ACTIONS(1307),
    [anon_sym_long] = ACTIONS(1307),
    [anon_sym_short] = ACTIONS(1307),
    [sym_primitive_type] = ACTIONS(1307),
    [anon_sym_enum] = ACTIONS(1307),
    [anon_sym_struct] = ACTIONS(1307),
    [anon_sym_union] = ACTIONS(1307),
    [anon_sym_AMP] = ACTIONS(1307),
    [anon_sym_AMP_AMP] = ACTIONS(1305),
    [anon_sym_TILDE] = ACTIONS(1305),
    [sym_identifier] = ACTIONS(1307),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(1307),
    [anon_sym_public] = ACTIONS(1307),
    [sym_auto] = ACTIONS(1307),
    [anon_sym_typename] = ACTIONS(1307),
    [anon_sym_template] = ACTIONS(1307),
    [anon_sym_friend] = ACTIONS(1307),
    [anon_sym_private] = ACTIONS(1307),
    [anon_sym_protected] = ACTIONS(1307),
    [anon_sym_using] = ACTIONS(1307),
    [anon_sym_COLON_COLON] = ACTIONS(1305),
    [sym_operator_name] = ACTIONS(1305),
  },
  [1654] = {
    [aux_sym_declaration_repeat1] = STATE(678),
    [anon_sym_COMMA] = ACTIONS(538),
    [anon_sym_SEMI] = ACTIONS(4896),
    [sym_comment] = ACTIONS(49),
  },
  [1655] = {
    [anon_sym_SEMI] = ACTIONS(4898),
    [sym_comment] = ACTIONS(49),
  },
  [1656] = {
    [anon_sym_LPAREN] = ACTIONS(2371),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(2373),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(2371),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(2371),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(2371),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(2371),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(2371),
    [anon_sym_typedef] = ACTIONS(2373),
    [anon_sym_extern] = ACTIONS(2373),
    [anon_sym_RBRACE] = ACTIONS(2371),
    [anon_sym_STAR] = ACTIONS(2371),
    [anon_sym_static] = ACTIONS(2373),
    [anon_sym_register] = ACTIONS(2373),
    [anon_sym_inline] = ACTIONS(2373),
    [anon_sym_const] = ACTIONS(2373),
    [anon_sym_restrict] = ACTIONS(2373),
    [anon_sym_volatile] = ACTIONS(2373),
    [anon_sym__Atomic] = ACTIONS(2373),
    [anon_sym_mutable] = ACTIONS(2373),
    [anon_sym_explicit] = ACTIONS(2373),
    [anon_sym_constexpr] = ACTIONS(2373),
    [anon_sym_unsigned] = ACTIONS(2373),
    [anon_sym_long] = ACTIONS(2373),
    [anon_sym_short] = ACTIONS(2373),
    [sym_primitive_type] = ACTIONS(2373),
    [anon_sym_enum] = ACTIONS(2373),
    [anon_sym_struct] = ACTIONS(2373),
    [anon_sym_union] = ACTIONS(2373),
    [anon_sym_AMP] = ACTIONS(2373),
    [anon_sym_AMP_AMP] = ACTIONS(2371),
    [anon_sym_TILDE] = ACTIONS(2371),
    [sym_identifier] = ACTIONS(2373),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(2373),
    [anon_sym_public] = ACTIONS(2373),
    [sym_auto] = ACTIONS(2373),
    [anon_sym_typename] = ACTIONS(2373),
    [anon_sym_template] = ACTIONS(2373),
    [anon_sym_friend] = ACTIONS(2373),
    [anon_sym_private] = ACTIONS(2373),
    [anon_sym_protected] = ACTIONS(2373),
    [anon_sym_using] = ACTIONS(2373),
    [anon_sym_COLON_COLON] = ACTIONS(2371),
    [sym_operator_name] = ACTIONS(2371),
  },
  [1657] = {
    [sym_parameter_list] = STATE(1660),
    [anon_sym_LPAREN] = ACTIONS(206),
    [anon_sym_RPAREN] = ACTIONS(3604),
    [anon_sym_LBRACK] = ACTIONS(2086),
    [sym_comment] = ACTIONS(49),
  },
  [1658] = {
    [sym_parameter_list] = STATE(1660),
    [anon_sym_LPAREN] = ACTIONS(206),
    [anon_sym_RPAREN] = ACTIONS(3608),
    [anon_sym_LBRACK] = ACTIONS(2086),
    [sym_comment] = ACTIONS(49),
  },
  [1659] = {
    [anon_sym_LPAREN] = ACTIONS(4900),
    [anon_sym_COMMA] = ACTIONS(4900),
    [anon_sym_RPAREN] = ACTIONS(4900),
    [anon_sym_SEMI] = ACTIONS(4900),
    [anon_sym_LBRACE] = ACTIONS(4900),
    [anon_sym_LBRACK] = ACTIONS(4900),
    [anon_sym_COLON] = ACTIONS(4900),
    [sym_comment] = ACTIONS(49),
  },
  [1660] = {
    [sym_type_qualifier] = STATE(2140),
    [sym_trailing_return_type] = STATE(2140),
    [aux_sym_function_declarator_repeat1] = STATE(2140),
    [anon_sym_LPAREN] = ACTIONS(3645),
    [anon_sym_RPAREN] = ACTIONS(3645),
    [anon_sym_LBRACK] = ACTIONS(3645),
    [anon_sym_const] = ACTIONS(612),
    [anon_sym_restrict] = ACTIONS(614),
    [anon_sym_volatile] = ACTIONS(614),
    [anon_sym__Atomic] = ACTIONS(614),
    [anon_sym_mutable] = ACTIONS(614),
    [anon_sym_explicit] = ACTIONS(614),
    [anon_sym_constexpr] = ACTIONS(614),
    [anon_sym_DASH_GT] = ACTIONS(845),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(4902),
  },
  [1661] = {
    [anon_sym_LPAREN] = ACTIONS(4904),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(4906),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(4904),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(4904),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(4904),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(4904),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(4904),
    [anon_sym_typedef] = ACTIONS(4906),
    [anon_sym_extern] = ACTIONS(4906),
    [anon_sym_RBRACE] = ACTIONS(4904),
    [anon_sym_STAR] = ACTIONS(4904),
    [anon_sym_static] = ACTIONS(4906),
    [anon_sym_register] = ACTIONS(4906),
    [anon_sym_inline] = ACTIONS(4906),
    [anon_sym_const] = ACTIONS(4906),
    [anon_sym_restrict] = ACTIONS(4906),
    [anon_sym_volatile] = ACTIONS(4906),
    [anon_sym__Atomic] = ACTIONS(4906),
    [anon_sym_mutable] = ACTIONS(4906),
    [anon_sym_explicit] = ACTIONS(4906),
    [anon_sym_constexpr] = ACTIONS(4906),
    [anon_sym_unsigned] = ACTIONS(4906),
    [anon_sym_long] = ACTIONS(4906),
    [anon_sym_short] = ACTIONS(4906),
    [sym_primitive_type] = ACTIONS(4906),
    [anon_sym_enum] = ACTIONS(4906),
    [anon_sym_struct] = ACTIONS(4906),
    [anon_sym_union] = ACTIONS(4906),
    [anon_sym_AMP] = ACTIONS(4906),
    [anon_sym_AMP_AMP] = ACTIONS(4904),
    [anon_sym_TILDE] = ACTIONS(4904),
    [sym_identifier] = ACTIONS(4906),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(4906),
    [anon_sym_public] = ACTIONS(4906),
    [sym_auto] = ACTIONS(4906),
    [anon_sym_typename] = ACTIONS(4906),
    [anon_sym_template] = ACTIONS(4906),
    [anon_sym_friend] = ACTIONS(4906),
    [anon_sym_private] = ACTIONS(4906),
    [anon_sym_protected] = ACTIONS(4906),
    [anon_sym_using] = ACTIONS(4906),
    [anon_sym_COLON_COLON] = ACTIONS(4904),
    [sym_operator_name] = ACTIONS(4904),
  },
  [1662] = {
    [anon_sym_LT] = ACTIONS(4908),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(1144),
  },
  [1663] = {
    [sym__field_declarator] = STATE(2141),
    [sym_pointer_field_declarator] = STATE(549),
    [sym_function_field_declarator] = STATE(550),
    [sym_array_field_declarator] = STATE(551),
    [sym_reference_field_declarator] = STATE(552),
    [sym_template_type] = STATE(553),
    [sym_template_method] = STATE(2141),
    [sym_scoped_field_identifier] = STATE(554),
    [sym_scoped_type_identifier] = STATE(47),
    [sym_scoped_namespace_identifier] = STATE(553),
    [anon_sym_LPAREN] = ACTIONS(1029),
    [anon_sym_STAR] = ACTIONS(3619),
    [anon_sym_AMP] = ACTIONS(3621),
    [anon_sym_AMP_AMP] = ACTIONS(3623),
    [sym_identifier] = ACTIONS(1041),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(1043),
    [sym_operator_name] = ACTIONS(4911),
  },
  [1664] = {
    [sym__field_declarator] = STATE(2142),
    [sym_pointer_field_declarator] = STATE(549),
    [sym_function_field_declarator] = STATE(550),
    [sym_array_field_declarator] = STATE(551),
    [sym_reference_field_declarator] = STATE(552),
    [sym_template_type] = STATE(553),
    [sym_template_method] = STATE(2142),
    [sym_scoped_field_identifier] = STATE(554),
    [sym_scoped_type_identifier] = STATE(47),
    [sym_scoped_namespace_identifier] = STATE(553),
    [anon_sym_LPAREN] = ACTIONS(1029),
    [anon_sym_STAR] = ACTIONS(3619),
    [anon_sym_AMP] = ACTIONS(3621),
    [anon_sym_AMP_AMP] = ACTIONS(3623),
    [sym_identifier] = ACTIONS(1041),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(1043),
    [sym_operator_name] = ACTIONS(4913),
  },
  [1665] = {
    [sym_parameter_list] = STATE(2143),
    [anon_sym_LPAREN] = ACTIONS(206),
    [anon_sym_COMMA] = ACTIONS(4915),
    [anon_sym_SEMI] = ACTIONS(4915),
    [anon_sym_LBRACK] = ACTIONS(2086),
    [anon_sym_COLON] = ACTIONS(4915),
    [sym_comment] = ACTIONS(49),
  },
  [1666] = {
    [anon_sym_LPAREN] = ACTIONS(4917),
    [anon_sym_COMMA] = ACTIONS(4917),
    [anon_sym_RPAREN] = ACTIONS(4917),
    [anon_sym_SEMI] = ACTIONS(4917),
    [anon_sym_LBRACE] = ACTIONS(4917),
    [anon_sym_LBRACK] = ACTIONS(4917),
    [anon_sym_COLON] = ACTIONS(4917),
    [sym_comment] = ACTIONS(49),
  },
  [1667] = {
    [sym__expression] = STATE(2145),
    [sym_conditional_expression] = STATE(2145),
    [sym_assignment_expression] = STATE(2145),
    [sym_pointer_expression] = STATE(2145),
    [sym_logical_expression] = STATE(2145),
    [sym_bitwise_expression] = STATE(2145),
    [sym_equality_expression] = STATE(2145),
    [sym_relational_expression] = STATE(2145),
    [sym_shift_expression] = STATE(2145),
    [sym_math_expression] = STATE(2145),
    [sym_cast_expression] = STATE(2145),
    [sym_sizeof_expression] = STATE(2145),
    [sym_subscript_expression] = STATE(2145),
    [sym_call_expression] = STATE(2145),
    [sym_field_expression] = STATE(2145),
    [sym_compound_literal_expression] = STATE(2145),
    [sym_parenthesized_expression] = STATE(2145),
    [sym_concatenated_string] = STATE(2145),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(2145),
    [sym_new_expression] = STATE(2145),
    [sym_delete_expression] = STATE(2145),
    [sym_lambda_expression] = STATE(2145),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(4919),
    [anon_sym_LPAREN] = ACTIONS(566),
    [anon_sym_STAR] = ACTIONS(568),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_RBRACK] = ACTIONS(4921),
    [anon_sym_AMP] = ACTIONS(568),
    [anon_sym_BANG] = ACTIONS(584),
    [anon_sym_TILDE] = ACTIONS(586),
    [anon_sym_PLUS] = ACTIONS(588),
    [anon_sym_DASH] = ACTIONS(588),
    [anon_sym_DASH_DASH] = ACTIONS(590),
    [anon_sym_PLUS_PLUS] = ACTIONS(590),
    [anon_sym_sizeof] = ACTIONS(592),
    [sym_number_literal] = ACTIONS(4919),
    [sym_char_literal] = ACTIONS(4919),
    [sym_string_literal] = ACTIONS(594),
    [sym_true] = ACTIONS(4923),
    [sym_false] = ACTIONS(4923),
    [sym_null] = ACTIONS(4923),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1415),
    [anon_sym_delete] = ACTIONS(608),
    [sym_nullptr] = ACTIONS(4923),
  },
  [1668] = {
    [sym_argument_list] = STATE(802),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_STAR] = ACTIONS(1522),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_RBRACK] = ACTIONS(4921),
    [anon_sym_EQ] = ACTIONS(1526),
    [anon_sym_QMARK] = ACTIONS(1528),
    [anon_sym_STAR_EQ] = ACTIONS(1530),
    [anon_sym_SLASH_EQ] = ACTIONS(1530),
    [anon_sym_PERCENT_EQ] = ACTIONS(1530),
    [anon_sym_PLUS_EQ] = ACTIONS(1530),
    [anon_sym_DASH_EQ] = ACTIONS(1530),
    [anon_sym_LT_LT_EQ] = ACTIONS(1530),
    [anon_sym_GT_GT_EQ] = ACTIONS(1530),
    [anon_sym_AMP_EQ] = ACTIONS(1530),
    [anon_sym_CARET_EQ] = ACTIONS(1530),
    [anon_sym_PIPE_EQ] = ACTIONS(1530),
    [anon_sym_AMP] = ACTIONS(1532),
    [anon_sym_PIPE_PIPE] = ACTIONS(1534),
    [anon_sym_AMP_AMP] = ACTIONS(1536),
    [anon_sym_PIPE] = ACTIONS(1538),
    [anon_sym_CARET] = ACTIONS(1540),
    [anon_sym_EQ_EQ] = ACTIONS(1542),
    [anon_sym_BANG_EQ] = ACTIONS(1542),
    [anon_sym_LT] = ACTIONS(1544),
    [anon_sym_GT] = ACTIONS(1544),
    [anon_sym_LT_EQ] = ACTIONS(1546),
    [anon_sym_GT_EQ] = ACTIONS(1546),
    [anon_sym_LT_LT] = ACTIONS(1548),
    [anon_sym_GT_GT] = ACTIONS(1548),
    [anon_sym_PLUS] = ACTIONS(1550),
    [anon_sym_DASH] = ACTIONS(1550),
    [anon_sym_SLASH] = ACTIONS(1522),
    [anon_sym_PERCENT] = ACTIONS(1522),
    [anon_sym_DASH_DASH] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(1554),
    [anon_sym_DASH_GT] = ACTIONS(1554),
    [sym_comment] = ACTIONS(49),
  },
  [1669] = {
    [sym_argument_list] = STATE(802),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_SEMI] = ACTIONS(4925),
    [anon_sym_STAR] = ACTIONS(2553),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_EQ] = ACTIONS(2555),
    [anon_sym_QMARK] = ACTIONS(2557),
    [anon_sym_STAR_EQ] = ACTIONS(2559),
    [anon_sym_SLASH_EQ] = ACTIONS(2559),
    [anon_sym_PERCENT_EQ] = ACTIONS(2559),
    [anon_sym_PLUS_EQ] = ACTIONS(2559),
    [anon_sym_DASH_EQ] = ACTIONS(2559),
    [anon_sym_LT_LT_EQ] = ACTIONS(2559),
    [anon_sym_GT_GT_EQ] = ACTIONS(2559),
    [anon_sym_AMP_EQ] = ACTIONS(2559),
    [anon_sym_CARET_EQ] = ACTIONS(2559),
    [anon_sym_PIPE_EQ] = ACTIONS(2559),
    [anon_sym_AMP] = ACTIONS(2561),
    [anon_sym_PIPE_PIPE] = ACTIONS(2563),
    [anon_sym_AMP_AMP] = ACTIONS(2565),
    [anon_sym_PIPE] = ACTIONS(2567),
    [anon_sym_CARET] = ACTIONS(2569),
    [anon_sym_EQ_EQ] = ACTIONS(2571),
    [anon_sym_BANG_EQ] = ACTIONS(2571),
    [anon_sym_LT] = ACTIONS(2573),
    [anon_sym_GT] = ACTIONS(2573),
    [anon_sym_LT_EQ] = ACTIONS(2575),
    [anon_sym_GT_EQ] = ACTIONS(2575),
    [anon_sym_LT_LT] = ACTIONS(2577),
    [anon_sym_GT_GT] = ACTIONS(2577),
    [anon_sym_PLUS] = ACTIONS(2579),
    [anon_sym_DASH] = ACTIONS(2579),
    [anon_sym_SLASH] = ACTIONS(2553),
    [anon_sym_PERCENT] = ACTIONS(2553),
    [anon_sym_DASH_DASH] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(1554),
    [anon_sym_DASH_GT] = ACTIONS(1554),
    [sym_comment] = ACTIONS(49),
  },
  [1670] = {
    [sym__type_specifier] = STATE(2148),
    [sym_sized_type_specifier] = STATE(2148),
    [sym_enum_specifier] = STATE(2148),
    [sym_struct_specifier] = STATE(2148),
    [sym_union_specifier] = STATE(2148),
    [sym_macro_type_specifier] = STATE(2148),
    [sym_class_specifier] = STATE(2148),
    [sym_dependent_type] = STATE(2148),
    [sym_template_type] = STATE(825),
    [sym_scoped_type_identifier] = STATE(826),
    [sym_scoped_namespace_identifier] = STATE(827),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2149),
    [anon_sym_unsigned] = ACTIONS(4927),
    [anon_sym_long] = ACTIONS(4927),
    [anon_sym_short] = ACTIONS(4927),
    [sym_primitive_type] = ACTIONS(4929),
    [anon_sym_enum] = ACTIONS(1582),
    [anon_sym_struct] = ACTIONS(1584),
    [anon_sym_union] = ACTIONS(1586),
    [sym_identifier] = ACTIONS(1588),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(1590),
    [sym_auto] = ACTIONS(4929),
    [anon_sym_typename] = ACTIONS(4931),
    [anon_sym_COLON_COLON] = ACTIONS(1594),
  },
  [1671] = {
    [sym_type_qualifier] = STATE(2150),
    [sym_trailing_return_type] = STATE(2150),
    [aux_sym_function_declarator_repeat1] = STATE(2150),
    [anon_sym_LPAREN] = ACTIONS(4933),
    [anon_sym_COMMA] = ACTIONS(4933),
    [anon_sym_SEMI] = ACTIONS(4933),
    [anon_sym_LBRACE] = ACTIONS(4933),
    [anon_sym_LBRACK] = ACTIONS(4933),
    [anon_sym_const] = ACTIONS(612),
    [anon_sym_restrict] = ACTIONS(614),
    [anon_sym_volatile] = ACTIONS(614),
    [anon_sym__Atomic] = ACTIONS(614),
    [anon_sym_mutable] = ACTIONS(614),
    [anon_sym_explicit] = ACTIONS(614),
    [anon_sym_constexpr] = ACTIONS(614),
    [anon_sym_COLON] = ACTIONS(4933),
    [anon_sym_DASH_GT] = ACTIONS(3647),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(4935),
  },
  [1672] = {
    [sym__expression] = STATE(2151),
    [sym_conditional_expression] = STATE(2151),
    [sym_assignment_expression] = STATE(2151),
    [sym_pointer_expression] = STATE(2151),
    [sym_logical_expression] = STATE(2151),
    [sym_bitwise_expression] = STATE(2151),
    [sym_equality_expression] = STATE(2151),
    [sym_relational_expression] = STATE(2151),
    [sym_shift_expression] = STATE(2151),
    [sym_math_expression] = STATE(2151),
    [sym_cast_expression] = STATE(2151),
    [sym_sizeof_expression] = STATE(2151),
    [sym_subscript_expression] = STATE(2151),
    [sym_call_expression] = STATE(2151),
    [sym_field_expression] = STATE(2151),
    [sym_compound_literal_expression] = STATE(2151),
    [sym_parenthesized_expression] = STATE(2151),
    [sym_concatenated_string] = STATE(2151),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(2151),
    [sym_new_expression] = STATE(2151),
    [sym_delete_expression] = STATE(2151),
    [sym_lambda_expression] = STATE(2151),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(4937),
    [anon_sym_LPAREN] = ACTIONS(1347),
    [anon_sym_STAR] = ACTIONS(1349),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_AMP] = ACTIONS(1349),
    [anon_sym_BANG] = ACTIONS(1351),
    [anon_sym_TILDE] = ACTIONS(1353),
    [anon_sym_PLUS] = ACTIONS(1355),
    [anon_sym_DASH] = ACTIONS(1355),
    [anon_sym_DASH_DASH] = ACTIONS(1357),
    [anon_sym_PLUS_PLUS] = ACTIONS(1357),
    [anon_sym_sizeof] = ACTIONS(1359),
    [sym_number_literal] = ACTIONS(4937),
    [sym_char_literal] = ACTIONS(4937),
    [sym_string_literal] = ACTIONS(1361),
    [sym_true] = ACTIONS(4939),
    [sym_false] = ACTIONS(4939),
    [sym_null] = ACTIONS(4939),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1365),
    [anon_sym_delete] = ACTIONS(1367),
    [sym_nullptr] = ACTIONS(4939),
  },
  [1673] = {
    [aux_sym_field_declaration_repeat1] = STATE(1673),
    [anon_sym_COMMA] = ACTIONS(4941),
    [anon_sym_SEMI] = ACTIONS(4915),
    [anon_sym_COLON] = ACTIONS(4915),
    [sym_comment] = ACTIONS(49),
  },
  [1674] = {
    [anon_sym_LT] = ACTIONS(4944),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(1805),
  },
  [1675] = {
    [anon_sym_LPAREN] = ACTIONS(1111),
    [anon_sym_COMMA] = ACTIONS(1111),
    [anon_sym_SEMI] = ACTIONS(1111),
    [anon_sym_LBRACE] = ACTIONS(1111),
    [anon_sym_STAR] = ACTIONS(1113),
    [anon_sym_LBRACK] = ACTIONS(1111),
    [anon_sym_EQ] = ACTIONS(1113),
    [anon_sym_COLON] = ACTIONS(1111),
    [anon_sym_QMARK] = ACTIONS(1111),
    [anon_sym_STAR_EQ] = ACTIONS(1111),
    [anon_sym_SLASH_EQ] = ACTIONS(1111),
    [anon_sym_PERCENT_EQ] = ACTIONS(1111),
    [anon_sym_PLUS_EQ] = ACTIONS(1111),
    [anon_sym_DASH_EQ] = ACTIONS(1111),
    [anon_sym_LT_LT_EQ] = ACTIONS(1111),
    [anon_sym_GT_GT_EQ] = ACTIONS(1111),
    [anon_sym_AMP_EQ] = ACTIONS(1111),
    [anon_sym_CARET_EQ] = ACTIONS(1111),
    [anon_sym_PIPE_EQ] = ACTIONS(1111),
    [anon_sym_AMP] = ACTIONS(1113),
    [anon_sym_PIPE_PIPE] = ACTIONS(1111),
    [anon_sym_AMP_AMP] = ACTIONS(1111),
    [anon_sym_PIPE] = ACTIONS(1113),
    [anon_sym_CARET] = ACTIONS(1113),
    [anon_sym_EQ_EQ] = ACTIONS(1111),
    [anon_sym_BANG_EQ] = ACTIONS(1111),
    [anon_sym_LT] = ACTIONS(1113),
    [anon_sym_GT] = ACTIONS(1113),
    [anon_sym_LT_EQ] = ACTIONS(1111),
    [anon_sym_GT_EQ] = ACTIONS(1111),
    [anon_sym_LT_LT] = ACTIONS(1113),
    [anon_sym_GT_GT] = ACTIONS(1113),
    [anon_sym_PLUS] = ACTIONS(1113),
    [anon_sym_DASH] = ACTIONS(1113),
    [anon_sym_SLASH] = ACTIONS(1113),
    [anon_sym_PERCENT] = ACTIONS(1113),
    [anon_sym_DASH_DASH] = ACTIONS(1111),
    [anon_sym_PLUS_PLUS] = ACTIONS(1111),
    [anon_sym_DOT] = ACTIONS(1111),
    [anon_sym_DASH_GT] = ACTIONS(1111),
    [sym_comment] = ACTIONS(49),
  },
  [1676] = {
    [aux_sym_template_argument_list_repeat1] = STATE(2153),
    [anon_sym_COMMA] = ACTIONS(1127),
    [anon_sym_GT] = ACTIONS(4947),
    [sym_comment] = ACTIONS(49),
  },
  [1677] = {
    [sym__type_specifier] = STATE(1375),
    [sym_sized_type_specifier] = STATE(1375),
    [sym_enum_specifier] = STATE(1375),
    [sym_struct_specifier] = STATE(1375),
    [sym_union_specifier] = STATE(1375),
    [sym_macro_type_specifier] = STATE(1375),
    [sym_class_specifier] = STATE(1375),
    [sym_dependent_type] = STATE(1375),
    [sym_template_type] = STATE(825),
    [sym_scoped_type_identifier] = STATE(826),
    [sym_scoped_namespace_identifier] = STATE(827),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1679),
    [anon_sym_unsigned] = ACTIONS(3661),
    [anon_sym_long] = ACTIONS(3661),
    [anon_sym_short] = ACTIONS(3661),
    [sym_primitive_type] = ACTIONS(2837),
    [anon_sym_enum] = ACTIONS(1582),
    [anon_sym_struct] = ACTIONS(1584),
    [anon_sym_union] = ACTIONS(1586),
    [sym_identifier] = ACTIONS(1588),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(1590),
    [sym_auto] = ACTIONS(2837),
    [anon_sym_typename] = ACTIONS(3665),
    [anon_sym_COLON_COLON] = ACTIONS(1594),
  },
  [1678] = {
    [sym__abstract_declarator] = STATE(2156),
    [sym_abstract_pointer_declarator] = STATE(2156),
    [sym_abstract_function_declarator] = STATE(2156),
    [sym_abstract_array_declarator] = STATE(2156),
    [sym_parameter_list] = STATE(2157),
    [sym_abstract_reference_declarator] = STATE(2156),
    [anon_sym_LPAREN] = ACTIONS(1115),
    [anon_sym_SEMI] = ACTIONS(2841),
    [anon_sym_LBRACE] = ACTIONS(2841),
    [anon_sym_STAR] = ACTIONS(4949),
    [anon_sym_LBRACK] = ACTIONS(1121),
    [anon_sym_const] = ACTIONS(2845),
    [anon_sym_restrict] = ACTIONS(2841),
    [anon_sym_volatile] = ACTIONS(2841),
    [anon_sym__Atomic] = ACTIONS(2841),
    [anon_sym_mutable] = ACTIONS(2841),
    [anon_sym_explicit] = ACTIONS(2841),
    [anon_sym_constexpr] = ACTIONS(2841),
    [anon_sym_COLON] = ACTIONS(2841),
    [anon_sym_AMP] = ACTIONS(4951),
    [anon_sym_AMP_AMP] = ACTIONS(4953),
    [anon_sym_DASH_GT] = ACTIONS(2841),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(2841),
  },
  [1679] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2158),
    [anon_sym_LPAREN] = ACTIONS(238),
    [anon_sym_SEMI] = ACTIONS(238),
    [anon_sym_LBRACE] = ACTIONS(238),
    [anon_sym_STAR] = ACTIONS(238),
    [anon_sym_LBRACK] = ACTIONS(238),
    [anon_sym_const] = ACTIONS(240),
    [anon_sym_restrict] = ACTIONS(240),
    [anon_sym_volatile] = ACTIONS(240),
    [anon_sym__Atomic] = ACTIONS(240),
    [anon_sym_mutable] = ACTIONS(240),
    [anon_sym_explicit] = ACTIONS(240),
    [anon_sym_constexpr] = ACTIONS(240),
    [anon_sym_unsigned] = ACTIONS(4955),
    [anon_sym_long] = ACTIONS(4955),
    [anon_sym_short] = ACTIONS(4955),
    [sym_primitive_type] = ACTIONS(2855),
    [anon_sym_COLON] = ACTIONS(238),
    [anon_sym_AMP] = ACTIONS(240),
    [anon_sym_AMP_AMP] = ACTIONS(238),
    [anon_sym_DASH_GT] = ACTIONS(238),
    [sym_identifier] = ACTIONS(2857),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(240),
  },
  [1680] = {
    [sym_type_qualifier] = STATE(1680),
    [sym_trailing_return_type] = STATE(1680),
    [aux_sym_function_declarator_repeat1] = STATE(1680),
    [anon_sym_LPAREN] = ACTIONS(2859),
    [anon_sym_SEMI] = ACTIONS(2859),
    [anon_sym_LBRACE] = ACTIONS(2859),
    [anon_sym_LBRACK] = ACTIONS(2859),
    [anon_sym_const] = ACTIONS(2861),
    [anon_sym_restrict] = ACTIONS(2864),
    [anon_sym_volatile] = ACTIONS(2864),
    [anon_sym__Atomic] = ACTIONS(2864),
    [anon_sym_mutable] = ACTIONS(2864),
    [anon_sym_explicit] = ACTIONS(2864),
    [anon_sym_constexpr] = ACTIONS(2864),
    [anon_sym_COLON] = ACTIONS(2859),
    [anon_sym_DASH_GT] = ACTIONS(4957),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(4960),
  },
  [1681] = {
    [anon_sym_LPAREN] = ACTIONS(3182),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3184),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3182),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3182),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3182),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(3182),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(3182),
    [anon_sym_typedef] = ACTIONS(3184),
    [anon_sym_extern] = ACTIONS(3184),
    [anon_sym_RBRACE] = ACTIONS(3182),
    [anon_sym_STAR] = ACTIONS(3182),
    [anon_sym_static] = ACTIONS(3184),
    [anon_sym_register] = ACTIONS(3184),
    [anon_sym_inline] = ACTIONS(3184),
    [anon_sym_const] = ACTIONS(3184),
    [anon_sym_restrict] = ACTIONS(3184),
    [anon_sym_volatile] = ACTIONS(3184),
    [anon_sym__Atomic] = ACTIONS(3184),
    [anon_sym_mutable] = ACTIONS(3184),
    [anon_sym_explicit] = ACTIONS(3184),
    [anon_sym_constexpr] = ACTIONS(3184),
    [anon_sym_unsigned] = ACTIONS(3184),
    [anon_sym_long] = ACTIONS(3184),
    [anon_sym_short] = ACTIONS(3184),
    [sym_primitive_type] = ACTIONS(3184),
    [anon_sym_enum] = ACTIONS(3184),
    [anon_sym_struct] = ACTIONS(3184),
    [anon_sym_union] = ACTIONS(3184),
    [anon_sym_AMP] = ACTIONS(3184),
    [anon_sym_AMP_AMP] = ACTIONS(3182),
    [anon_sym_TILDE] = ACTIONS(3182),
    [sym_identifier] = ACTIONS(3184),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(3184),
    [anon_sym_public] = ACTIONS(3184),
    [sym_auto] = ACTIONS(3184),
    [anon_sym_typename] = ACTIONS(3184),
    [anon_sym_template] = ACTIONS(3184),
    [anon_sym_friend] = ACTIONS(3184),
    [anon_sym_private] = ACTIONS(3184),
    [anon_sym_protected] = ACTIONS(3184),
    [anon_sym_using] = ACTIONS(3184),
    [anon_sym_COLON_COLON] = ACTIONS(3182),
    [sym_operator_name] = ACTIONS(3182),
  },
  [1682] = {
    [anon_sym_LPAREN] = ACTIONS(3338),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3340),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3338),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3338),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3338),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(3338),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(3338),
    [anon_sym_typedef] = ACTIONS(3340),
    [anon_sym_extern] = ACTIONS(3340),
    [anon_sym_RBRACE] = ACTIONS(3338),
    [anon_sym_STAR] = ACTIONS(3338),
    [anon_sym_static] = ACTIONS(3340),
    [anon_sym_register] = ACTIONS(3340),
    [anon_sym_inline] = ACTIONS(3340),
    [anon_sym_const] = ACTIONS(3340),
    [anon_sym_restrict] = ACTIONS(3340),
    [anon_sym_volatile] = ACTIONS(3340),
    [anon_sym__Atomic] = ACTIONS(3340),
    [anon_sym_mutable] = ACTIONS(3340),
    [anon_sym_explicit] = ACTIONS(3340),
    [anon_sym_constexpr] = ACTIONS(3340),
    [anon_sym_unsigned] = ACTIONS(3340),
    [anon_sym_long] = ACTIONS(3340),
    [anon_sym_short] = ACTIONS(3340),
    [sym_primitive_type] = ACTIONS(3340),
    [anon_sym_enum] = ACTIONS(3340),
    [anon_sym_struct] = ACTIONS(3340),
    [anon_sym_union] = ACTIONS(3340),
    [anon_sym_AMP] = ACTIONS(3340),
    [anon_sym_AMP_AMP] = ACTIONS(3338),
    [anon_sym_TILDE] = ACTIONS(3338),
    [sym_identifier] = ACTIONS(3340),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(3340),
    [anon_sym_public] = ACTIONS(3340),
    [sym_auto] = ACTIONS(3340),
    [anon_sym_typename] = ACTIONS(3340),
    [anon_sym_template] = ACTIONS(3340),
    [anon_sym_friend] = ACTIONS(3340),
    [anon_sym_private] = ACTIONS(3340),
    [anon_sym_protected] = ACTIONS(3340),
    [anon_sym_using] = ACTIONS(3340),
    [anon_sym_COLON_COLON] = ACTIONS(3338),
    [sym_operator_name] = ACTIONS(3338),
  },
  [1683] = {
    [anon_sym_COMMA] = ACTIONS(4963),
    [anon_sym_LBRACE] = ACTIONS(4963),
    [sym_comment] = ACTIONS(49),
  },
  [1684] = {
    [sym__expression] = STATE(1834),
    [sym_conditional_expression] = STATE(1834),
    [sym_assignment_expression] = STATE(1834),
    [sym_pointer_expression] = STATE(1834),
    [sym_logical_expression] = STATE(1834),
    [sym_bitwise_expression] = STATE(1834),
    [sym_equality_expression] = STATE(1834),
    [sym_relational_expression] = STATE(1834),
    [sym_shift_expression] = STATE(1834),
    [sym_math_expression] = STATE(1834),
    [sym_cast_expression] = STATE(1834),
    [sym_sizeof_expression] = STATE(1834),
    [sym_subscript_expression] = STATE(1834),
    [sym_call_expression] = STATE(1834),
    [sym_field_expression] = STATE(1834),
    [sym_compound_literal_expression] = STATE(1834),
    [sym_parenthesized_expression] = STATE(1834),
    [sym_initializer_list] = STATE(1835),
    [sym_concatenated_string] = STATE(1834),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(1834),
    [sym_new_expression] = STATE(1834),
    [sym_delete_expression] = STATE(1834),
    [sym_lambda_expression] = STATE(1834),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(4145),
    [anon_sym_LPAREN] = ACTIONS(1087),
    [anon_sym_LBRACE] = ACTIONS(548),
    [anon_sym_STAR] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_AMP] = ACTIONS(1089),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1093),
    [anon_sym_PLUS] = ACTIONS(1095),
    [anon_sym_DASH] = ACTIONS(1095),
    [anon_sym_DASH_DASH] = ACTIONS(1097),
    [anon_sym_PLUS_PLUS] = ACTIONS(1097),
    [anon_sym_sizeof] = ACTIONS(1099),
    [sym_number_literal] = ACTIONS(4145),
    [sym_char_literal] = ACTIONS(4145),
    [sym_string_literal] = ACTIONS(1101),
    [sym_true] = ACTIONS(4147),
    [sym_false] = ACTIONS(4147),
    [sym_null] = ACTIONS(4147),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_delete] = ACTIONS(1109),
    [sym_nullptr] = ACTIONS(4147),
  },
  [1685] = {
    [anon_sym_RPAREN] = ACTIONS(4965),
    [sym_comment] = ACTIONS(49),
  },
  [1686] = {
    [aux_sym_concatenated_string_repeat1] = STATE(1686),
    [anon_sym_LPAREN] = ACTIONS(4230),
    [anon_sym_COMMA] = ACTIONS(4230),
    [anon_sym_RPAREN] = ACTIONS(4230),
    [anon_sym_STAR] = ACTIONS(4232),
    [anon_sym_LBRACK] = ACTIONS(4230),
    [anon_sym_EQ] = ACTIONS(4232),
    [anon_sym_QMARK] = ACTIONS(4230),
    [anon_sym_STAR_EQ] = ACTIONS(4230),
    [anon_sym_SLASH_EQ] = ACTIONS(4230),
    [anon_sym_PERCENT_EQ] = ACTIONS(4230),
    [anon_sym_PLUS_EQ] = ACTIONS(4230),
    [anon_sym_DASH_EQ] = ACTIONS(4230),
    [anon_sym_LT_LT_EQ] = ACTIONS(4230),
    [anon_sym_GT_GT_EQ] = ACTIONS(4230),
    [anon_sym_AMP_EQ] = ACTIONS(4230),
    [anon_sym_CARET_EQ] = ACTIONS(4230),
    [anon_sym_PIPE_EQ] = ACTIONS(4230),
    [anon_sym_AMP] = ACTIONS(4232),
    [anon_sym_PIPE_PIPE] = ACTIONS(4230),
    [anon_sym_AMP_AMP] = ACTIONS(4230),
    [anon_sym_PIPE] = ACTIONS(4232),
    [anon_sym_CARET] = ACTIONS(4232),
    [anon_sym_EQ_EQ] = ACTIONS(4230),
    [anon_sym_BANG_EQ] = ACTIONS(4230),
    [anon_sym_LT] = ACTIONS(4232),
    [anon_sym_GT] = ACTIONS(4232),
    [anon_sym_LT_EQ] = ACTIONS(4230),
    [anon_sym_GT_EQ] = ACTIONS(4230),
    [anon_sym_LT_LT] = ACTIONS(4232),
    [anon_sym_GT_GT] = ACTIONS(4232),
    [anon_sym_PLUS] = ACTIONS(4232),
    [anon_sym_DASH] = ACTIONS(4232),
    [anon_sym_SLASH] = ACTIONS(4232),
    [anon_sym_PERCENT] = ACTIONS(4232),
    [anon_sym_DASH_DASH] = ACTIONS(4230),
    [anon_sym_PLUS_PLUS] = ACTIONS(4230),
    [anon_sym_DOT] = ACTIONS(4230),
    [anon_sym_DASH_GT] = ACTIONS(4230),
    [sym_string_literal] = ACTIONS(4967),
    [sym_comment] = ACTIONS(49),
  },
  [1687] = {
    [anon_sym_LPAREN] = ACTIONS(1146),
    [anon_sym_COMMA] = ACTIONS(1146),
    [anon_sym_RPAREN] = ACTIONS(1146),
    [anon_sym_SEMI] = ACTIONS(1146),
    [anon_sym_LBRACE] = ACTIONS(1140),
    [anon_sym_RBRACE] = ACTIONS(1146),
    [anon_sym_STAR] = ACTIONS(1148),
    [anon_sym_LBRACK] = ACTIONS(1146),
    [anon_sym_RBRACK] = ACTIONS(1146),
    [anon_sym_EQ] = ACTIONS(1148),
    [anon_sym_COLON] = ACTIONS(1148),
    [anon_sym_QMARK] = ACTIONS(1146),
    [anon_sym_STAR_EQ] = ACTIONS(1146),
    [anon_sym_SLASH_EQ] = ACTIONS(1146),
    [anon_sym_PERCENT_EQ] = ACTIONS(1146),
    [anon_sym_PLUS_EQ] = ACTIONS(1146),
    [anon_sym_DASH_EQ] = ACTIONS(1146),
    [anon_sym_LT_LT_EQ] = ACTIONS(1146),
    [anon_sym_GT_GT_EQ] = ACTIONS(1146),
    [anon_sym_AMP_EQ] = ACTIONS(1146),
    [anon_sym_CARET_EQ] = ACTIONS(1146),
    [anon_sym_PIPE_EQ] = ACTIONS(1146),
    [anon_sym_AMP] = ACTIONS(1148),
    [anon_sym_PIPE_PIPE] = ACTIONS(1146),
    [anon_sym_AMP_AMP] = ACTIONS(1146),
    [anon_sym_PIPE] = ACTIONS(1148),
    [anon_sym_CARET] = ACTIONS(1148),
    [anon_sym_EQ_EQ] = ACTIONS(1146),
    [anon_sym_BANG_EQ] = ACTIONS(1146),
    [anon_sym_LT] = ACTIONS(4239),
    [anon_sym_GT] = ACTIONS(1148),
    [anon_sym_LT_EQ] = ACTIONS(1146),
    [anon_sym_GT_EQ] = ACTIONS(1146),
    [anon_sym_LT_LT] = ACTIONS(1148),
    [anon_sym_GT_GT] = ACTIONS(1148),
    [anon_sym_PLUS] = ACTIONS(1148),
    [anon_sym_DASH] = ACTIONS(1148),
    [anon_sym_SLASH] = ACTIONS(1148),
    [anon_sym_PERCENT] = ACTIONS(1148),
    [anon_sym_DASH_DASH] = ACTIONS(1146),
    [anon_sym_PLUS_PLUS] = ACTIONS(1146),
    [anon_sym_DOT] = ACTIONS(1146),
    [anon_sym_DASH_GT] = ACTIONS(1146),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(1144),
  },
  [1688] = {
    [sym__expression] = STATE(740),
    [sym_conditional_expression] = STATE(740),
    [sym_assignment_expression] = STATE(740),
    [sym_pointer_expression] = STATE(740),
    [sym_logical_expression] = STATE(740),
    [sym_bitwise_expression] = STATE(740),
    [sym_equality_expression] = STATE(740),
    [sym_relational_expression] = STATE(740),
    [sym_shift_expression] = STATE(740),
    [sym_math_expression] = STATE(740),
    [sym_cast_expression] = STATE(740),
    [sym_sizeof_expression] = STATE(740),
    [sym_subscript_expression] = STATE(740),
    [sym_call_expression] = STATE(740),
    [sym_field_expression] = STATE(740),
    [sym_compound_literal_expression] = STATE(740),
    [sym_parenthesized_expression] = STATE(740),
    [sym_concatenated_string] = STATE(740),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(740),
    [sym_new_expression] = STATE(740),
    [sym_delete_expression] = STATE(740),
    [sym_lambda_expression] = STATE(740),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_lambda_default_capture] = STATE(741),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(1417),
    [anon_sym_LPAREN] = ACTIONS(1419),
    [anon_sym_STAR] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_RBRACK] = ACTIONS(4970),
    [anon_sym_EQ] = ACTIONS(1425),
    [anon_sym_AMP] = ACTIONS(1427),
    [anon_sym_BANG] = ACTIONS(1429),
    [anon_sym_TILDE] = ACTIONS(1431),
    [anon_sym_PLUS] = ACTIONS(1433),
    [anon_sym_DASH] = ACTIONS(1433),
    [anon_sym_DASH_DASH] = ACTIONS(1435),
    [anon_sym_PLUS_PLUS] = ACTIONS(1435),
    [anon_sym_sizeof] = ACTIONS(1437),
    [sym_number_literal] = ACTIONS(1417),
    [sym_char_literal] = ACTIONS(1417),
    [sym_string_literal] = ACTIONS(1439),
    [sym_true] = ACTIONS(1441),
    [sym_false] = ACTIONS(1441),
    [sym_null] = ACTIONS(1441),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1443),
    [anon_sym_delete] = ACTIONS(1445),
    [sym_nullptr] = ACTIONS(1441),
  },
  [1689] = {
    [sym_argument_list] = STATE(802),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_COMMA] = ACTIONS(4258),
    [anon_sym_RPAREN] = ACTIONS(4258),
    [anon_sym_STAR] = ACTIONS(2234),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_EQ] = ACTIONS(4260),
    [anon_sym_QMARK] = ACTIONS(4258),
    [anon_sym_STAR_EQ] = ACTIONS(4258),
    [anon_sym_SLASH_EQ] = ACTIONS(4258),
    [anon_sym_PERCENT_EQ] = ACTIONS(4258),
    [anon_sym_PLUS_EQ] = ACTIONS(4258),
    [anon_sym_DASH_EQ] = ACTIONS(4258),
    [anon_sym_LT_LT_EQ] = ACTIONS(4258),
    [anon_sym_GT_GT_EQ] = ACTIONS(4258),
    [anon_sym_AMP_EQ] = ACTIONS(4258),
    [anon_sym_CARET_EQ] = ACTIONS(4258),
    [anon_sym_PIPE_EQ] = ACTIONS(4258),
    [anon_sym_AMP] = ACTIONS(2242),
    [anon_sym_PIPE_PIPE] = ACTIONS(2244),
    [anon_sym_AMP_AMP] = ACTIONS(2246),
    [anon_sym_PIPE] = ACTIONS(2248),
    [anon_sym_CARET] = ACTIONS(2250),
    [anon_sym_EQ_EQ] = ACTIONS(2252),
    [anon_sym_BANG_EQ] = ACTIONS(2252),
    [anon_sym_LT] = ACTIONS(2254),
    [anon_sym_GT] = ACTIONS(2254),
    [anon_sym_LT_EQ] = ACTIONS(2256),
    [anon_sym_GT_EQ] = ACTIONS(2256),
    [anon_sym_LT_LT] = ACTIONS(2258),
    [anon_sym_GT_GT] = ACTIONS(2258),
    [anon_sym_PLUS] = ACTIONS(2260),
    [anon_sym_DASH] = ACTIONS(2260),
    [anon_sym_SLASH] = ACTIONS(2234),
    [anon_sym_PERCENT] = ACTIONS(2234),
    [anon_sym_DASH_DASH] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(1554),
    [anon_sym_DASH_GT] = ACTIONS(1554),
    [sym_comment] = ACTIONS(49),
  },
  [1690] = {
    [sym__expression] = STATE(2161),
    [sym_conditional_expression] = STATE(2161),
    [sym_assignment_expression] = STATE(2161),
    [sym_pointer_expression] = STATE(2161),
    [sym_logical_expression] = STATE(2161),
    [sym_bitwise_expression] = STATE(2161),
    [sym_equality_expression] = STATE(2161),
    [sym_relational_expression] = STATE(2161),
    [sym_shift_expression] = STATE(2161),
    [sym_math_expression] = STATE(2161),
    [sym_cast_expression] = STATE(2161),
    [sym_sizeof_expression] = STATE(2161),
    [sym_subscript_expression] = STATE(2161),
    [sym_call_expression] = STATE(2161),
    [sym_field_expression] = STATE(2161),
    [sym_compound_literal_expression] = STATE(2161),
    [sym_parenthesized_expression] = STATE(2161),
    [sym_concatenated_string] = STATE(2161),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(2161),
    [sym_new_expression] = STATE(2161),
    [sym_delete_expression] = STATE(2161),
    [sym_lambda_expression] = STATE(2161),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(4972),
    [anon_sym_LPAREN] = ACTIONS(2624),
    [anon_sym_STAR] = ACTIONS(2624),
    [anon_sym_LBRACK] = ACTIONS(2624),
    [anon_sym_AMP] = ACTIONS(2626),
    [anon_sym_AMP_AMP] = ACTIONS(2624),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1093),
    [anon_sym_PLUS] = ACTIONS(1095),
    [anon_sym_DASH] = ACTIONS(1095),
    [anon_sym_DASH_DASH] = ACTIONS(1097),
    [anon_sym_PLUS_PLUS] = ACTIONS(1097),
    [anon_sym_sizeof] = ACTIONS(1099),
    [sym_number_literal] = ACTIONS(4972),
    [sym_char_literal] = ACTIONS(4972),
    [sym_string_literal] = ACTIONS(1101),
    [sym_true] = ACTIONS(4974),
    [sym_false] = ACTIONS(4974),
    [sym_null] = ACTIONS(4974),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_delete] = ACTIONS(1109),
    [sym_nullptr] = ACTIONS(4974),
  },
  [1691] = {
    [sym_argument_list] = STATE(802),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_COMMA] = ACTIONS(2230),
    [anon_sym_RPAREN] = ACTIONS(4734),
    [anon_sym_STAR] = ACTIONS(2234),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_EQ] = ACTIONS(2236),
    [anon_sym_QMARK] = ACTIONS(2238),
    [anon_sym_STAR_EQ] = ACTIONS(2240),
    [anon_sym_SLASH_EQ] = ACTIONS(2240),
    [anon_sym_PERCENT_EQ] = ACTIONS(2240),
    [anon_sym_PLUS_EQ] = ACTIONS(2240),
    [anon_sym_DASH_EQ] = ACTIONS(2240),
    [anon_sym_LT_LT_EQ] = ACTIONS(2240),
    [anon_sym_GT_GT_EQ] = ACTIONS(2240),
    [anon_sym_AMP_EQ] = ACTIONS(2240),
    [anon_sym_CARET_EQ] = ACTIONS(2240),
    [anon_sym_PIPE_EQ] = ACTIONS(2240),
    [anon_sym_AMP] = ACTIONS(2242),
    [anon_sym_PIPE_PIPE] = ACTIONS(2244),
    [anon_sym_AMP_AMP] = ACTIONS(2246),
    [anon_sym_PIPE] = ACTIONS(2248),
    [anon_sym_CARET] = ACTIONS(2250),
    [anon_sym_EQ_EQ] = ACTIONS(2252),
    [anon_sym_BANG_EQ] = ACTIONS(2252),
    [anon_sym_LT] = ACTIONS(2254),
    [anon_sym_GT] = ACTIONS(2254),
    [anon_sym_LT_EQ] = ACTIONS(2256),
    [anon_sym_GT_EQ] = ACTIONS(2256),
    [anon_sym_LT_LT] = ACTIONS(2258),
    [anon_sym_GT_GT] = ACTIONS(2258),
    [anon_sym_PLUS] = ACTIONS(2260),
    [anon_sym_DASH] = ACTIONS(2260),
    [anon_sym_SLASH] = ACTIONS(2234),
    [anon_sym_PERCENT] = ACTIONS(2234),
    [anon_sym_DASH_DASH] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(1554),
    [anon_sym_DASH_GT] = ACTIONS(1554),
    [sym_comment] = ACTIONS(49),
  },
  [1692] = {
    [sym_argument_list] = STATE(802),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_COMMA] = ACTIONS(4280),
    [anon_sym_RPAREN] = ACTIONS(4280),
    [anon_sym_STAR] = ACTIONS(2234),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_EQ] = ACTIONS(2236),
    [anon_sym_QMARK] = ACTIONS(4280),
    [anon_sym_STAR_EQ] = ACTIONS(2240),
    [anon_sym_SLASH_EQ] = ACTIONS(2240),
    [anon_sym_PERCENT_EQ] = ACTIONS(2240),
    [anon_sym_PLUS_EQ] = ACTIONS(2240),
    [anon_sym_DASH_EQ] = ACTIONS(2240),
    [anon_sym_LT_LT_EQ] = ACTIONS(2240),
    [anon_sym_GT_GT_EQ] = ACTIONS(2240),
    [anon_sym_AMP_EQ] = ACTIONS(2240),
    [anon_sym_CARET_EQ] = ACTIONS(2240),
    [anon_sym_PIPE_EQ] = ACTIONS(2240),
    [anon_sym_AMP] = ACTIONS(2242),
    [anon_sym_PIPE_PIPE] = ACTIONS(2244),
    [anon_sym_AMP_AMP] = ACTIONS(2246),
    [anon_sym_PIPE] = ACTIONS(2248),
    [anon_sym_CARET] = ACTIONS(2250),
    [anon_sym_EQ_EQ] = ACTIONS(2252),
    [anon_sym_BANG_EQ] = ACTIONS(2252),
    [anon_sym_LT] = ACTIONS(2254),
    [anon_sym_GT] = ACTIONS(2254),
    [anon_sym_LT_EQ] = ACTIONS(2256),
    [anon_sym_GT_EQ] = ACTIONS(2256),
    [anon_sym_LT_LT] = ACTIONS(2258),
    [anon_sym_GT_GT] = ACTIONS(2258),
    [anon_sym_PLUS] = ACTIONS(2260),
    [anon_sym_DASH] = ACTIONS(2260),
    [anon_sym_SLASH] = ACTIONS(2234),
    [anon_sym_PERCENT] = ACTIONS(2234),
    [anon_sym_DASH_DASH] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(1554),
    [anon_sym_DASH_GT] = ACTIONS(1554),
    [sym_comment] = ACTIONS(49),
  },
  [1693] = {
    [sym_argument_list] = STATE(802),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_STAR] = ACTIONS(3003),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_EQ] = ACTIONS(3005),
    [anon_sym_COLON] = ACTIONS(4976),
    [anon_sym_QMARK] = ACTIONS(3009),
    [anon_sym_STAR_EQ] = ACTIONS(3011),
    [anon_sym_SLASH_EQ] = ACTIONS(3011),
    [anon_sym_PERCENT_EQ] = ACTIONS(3011),
    [anon_sym_PLUS_EQ] = ACTIONS(3011),
    [anon_sym_DASH_EQ] = ACTIONS(3011),
    [anon_sym_LT_LT_EQ] = ACTIONS(3011),
    [anon_sym_GT_GT_EQ] = ACTIONS(3011),
    [anon_sym_AMP_EQ] = ACTIONS(3011),
    [anon_sym_CARET_EQ] = ACTIONS(3011),
    [anon_sym_PIPE_EQ] = ACTIONS(3011),
    [anon_sym_AMP] = ACTIONS(3013),
    [anon_sym_PIPE_PIPE] = ACTIONS(3015),
    [anon_sym_AMP_AMP] = ACTIONS(3017),
    [anon_sym_PIPE] = ACTIONS(3019),
    [anon_sym_CARET] = ACTIONS(3021),
    [anon_sym_EQ_EQ] = ACTIONS(3023),
    [anon_sym_BANG_EQ] = ACTIONS(3023),
    [anon_sym_LT] = ACTIONS(3025),
    [anon_sym_GT] = ACTIONS(3025),
    [anon_sym_LT_EQ] = ACTIONS(3027),
    [anon_sym_GT_EQ] = ACTIONS(3027),
    [anon_sym_LT_LT] = ACTIONS(3029),
    [anon_sym_GT_GT] = ACTIONS(3029),
    [anon_sym_PLUS] = ACTIONS(3031),
    [anon_sym_DASH] = ACTIONS(3031),
    [anon_sym_SLASH] = ACTIONS(3003),
    [anon_sym_PERCENT] = ACTIONS(3003),
    [anon_sym_DASH_DASH] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(3033),
    [anon_sym_DASH_GT] = ACTIONS(3033),
    [sym_comment] = ACTIONS(49),
  },
  [1694] = {
    [sym_argument_list] = STATE(802),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_COMMA] = ACTIONS(4284),
    [anon_sym_RPAREN] = ACTIONS(4284),
    [anon_sym_STAR] = ACTIONS(2234),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_EQ] = ACTIONS(4286),
    [anon_sym_QMARK] = ACTIONS(4284),
    [anon_sym_STAR_EQ] = ACTIONS(4284),
    [anon_sym_SLASH_EQ] = ACTIONS(4284),
    [anon_sym_PERCENT_EQ] = ACTIONS(4284),
    [anon_sym_PLUS_EQ] = ACTIONS(4284),
    [anon_sym_DASH_EQ] = ACTIONS(4284),
    [anon_sym_LT_LT_EQ] = ACTIONS(4284),
    [anon_sym_GT_GT_EQ] = ACTIONS(4284),
    [anon_sym_AMP_EQ] = ACTIONS(4284),
    [anon_sym_CARET_EQ] = ACTIONS(4284),
    [anon_sym_PIPE_EQ] = ACTIONS(4284),
    [anon_sym_AMP] = ACTIONS(4286),
    [anon_sym_PIPE_PIPE] = ACTIONS(4284),
    [anon_sym_AMP_AMP] = ACTIONS(4284),
    [anon_sym_PIPE] = ACTIONS(4286),
    [anon_sym_CARET] = ACTIONS(4286),
    [anon_sym_EQ_EQ] = ACTIONS(2252),
    [anon_sym_BANG_EQ] = ACTIONS(2252),
    [anon_sym_LT] = ACTIONS(2254),
    [anon_sym_GT] = ACTIONS(2254),
    [anon_sym_LT_EQ] = ACTIONS(2256),
    [anon_sym_GT_EQ] = ACTIONS(2256),
    [anon_sym_LT_LT] = ACTIONS(2258),
    [anon_sym_GT_GT] = ACTIONS(2258),
    [anon_sym_PLUS] = ACTIONS(2260),
    [anon_sym_DASH] = ACTIONS(2260),
    [anon_sym_SLASH] = ACTIONS(2234),
    [anon_sym_PERCENT] = ACTIONS(2234),
    [anon_sym_DASH_DASH] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(1554),
    [anon_sym_DASH_GT] = ACTIONS(1554),
    [sym_comment] = ACTIONS(49),
  },
  [1695] = {
    [sym_argument_list] = STATE(802),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_COMMA] = ACTIONS(4288),
    [anon_sym_RPAREN] = ACTIONS(4288),
    [anon_sym_STAR] = ACTIONS(2234),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_EQ] = ACTIONS(4290),
    [anon_sym_QMARK] = ACTIONS(4288),
    [anon_sym_STAR_EQ] = ACTIONS(4288),
    [anon_sym_SLASH_EQ] = ACTIONS(4288),
    [anon_sym_PERCENT_EQ] = ACTIONS(4288),
    [anon_sym_PLUS_EQ] = ACTIONS(4288),
    [anon_sym_DASH_EQ] = ACTIONS(4288),
    [anon_sym_LT_LT_EQ] = ACTIONS(4288),
    [anon_sym_GT_GT_EQ] = ACTIONS(4288),
    [anon_sym_AMP_EQ] = ACTIONS(4288),
    [anon_sym_CARET_EQ] = ACTIONS(4288),
    [anon_sym_PIPE_EQ] = ACTIONS(4288),
    [anon_sym_AMP] = ACTIONS(2242),
    [anon_sym_PIPE_PIPE] = ACTIONS(4288),
    [anon_sym_AMP_AMP] = ACTIONS(2246),
    [anon_sym_PIPE] = ACTIONS(2248),
    [anon_sym_CARET] = ACTIONS(2250),
    [anon_sym_EQ_EQ] = ACTIONS(2252),
    [anon_sym_BANG_EQ] = ACTIONS(2252),
    [anon_sym_LT] = ACTIONS(2254),
    [anon_sym_GT] = ACTIONS(2254),
    [anon_sym_LT_EQ] = ACTIONS(2256),
    [anon_sym_GT_EQ] = ACTIONS(2256),
    [anon_sym_LT_LT] = ACTIONS(2258),
    [anon_sym_GT_GT] = ACTIONS(2258),
    [anon_sym_PLUS] = ACTIONS(2260),
    [anon_sym_DASH] = ACTIONS(2260),
    [anon_sym_SLASH] = ACTIONS(2234),
    [anon_sym_PERCENT] = ACTIONS(2234),
    [anon_sym_DASH_DASH] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(1554),
    [anon_sym_DASH_GT] = ACTIONS(1554),
    [sym_comment] = ACTIONS(49),
  },
  [1696] = {
    [sym_argument_list] = STATE(802),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_COMMA] = ACTIONS(4288),
    [anon_sym_RPAREN] = ACTIONS(4288),
    [anon_sym_STAR] = ACTIONS(2234),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_EQ] = ACTIONS(4290),
    [anon_sym_QMARK] = ACTIONS(4288),
    [anon_sym_STAR_EQ] = ACTIONS(4288),
    [anon_sym_SLASH_EQ] = ACTIONS(4288),
    [anon_sym_PERCENT_EQ] = ACTIONS(4288),
    [anon_sym_PLUS_EQ] = ACTIONS(4288),
    [anon_sym_DASH_EQ] = ACTIONS(4288),
    [anon_sym_LT_LT_EQ] = ACTIONS(4288),
    [anon_sym_GT_GT_EQ] = ACTIONS(4288),
    [anon_sym_AMP_EQ] = ACTIONS(4288),
    [anon_sym_CARET_EQ] = ACTIONS(4288),
    [anon_sym_PIPE_EQ] = ACTIONS(4288),
    [anon_sym_AMP] = ACTIONS(2242),
    [anon_sym_PIPE_PIPE] = ACTIONS(4288),
    [anon_sym_AMP_AMP] = ACTIONS(4288),
    [anon_sym_PIPE] = ACTIONS(2248),
    [anon_sym_CARET] = ACTIONS(2250),
    [anon_sym_EQ_EQ] = ACTIONS(2252),
    [anon_sym_BANG_EQ] = ACTIONS(2252),
    [anon_sym_LT] = ACTIONS(2254),
    [anon_sym_GT] = ACTIONS(2254),
    [anon_sym_LT_EQ] = ACTIONS(2256),
    [anon_sym_GT_EQ] = ACTIONS(2256),
    [anon_sym_LT_LT] = ACTIONS(2258),
    [anon_sym_GT_GT] = ACTIONS(2258),
    [anon_sym_PLUS] = ACTIONS(2260),
    [anon_sym_DASH] = ACTIONS(2260),
    [anon_sym_SLASH] = ACTIONS(2234),
    [anon_sym_PERCENT] = ACTIONS(2234),
    [anon_sym_DASH_DASH] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(1554),
    [anon_sym_DASH_GT] = ACTIONS(1554),
    [sym_comment] = ACTIONS(49),
  },
  [1697] = {
    [sym_argument_list] = STATE(802),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_COMMA] = ACTIONS(4284),
    [anon_sym_RPAREN] = ACTIONS(4284),
    [anon_sym_STAR] = ACTIONS(2234),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_EQ] = ACTIONS(4286),
    [anon_sym_QMARK] = ACTIONS(4284),
    [anon_sym_STAR_EQ] = ACTIONS(4284),
    [anon_sym_SLASH_EQ] = ACTIONS(4284),
    [anon_sym_PERCENT_EQ] = ACTIONS(4284),
    [anon_sym_PLUS_EQ] = ACTIONS(4284),
    [anon_sym_DASH_EQ] = ACTIONS(4284),
    [anon_sym_LT_LT_EQ] = ACTIONS(4284),
    [anon_sym_GT_GT_EQ] = ACTIONS(4284),
    [anon_sym_AMP_EQ] = ACTIONS(4284),
    [anon_sym_CARET_EQ] = ACTIONS(4284),
    [anon_sym_PIPE_EQ] = ACTIONS(4284),
    [anon_sym_AMP] = ACTIONS(2242),
    [anon_sym_PIPE_PIPE] = ACTIONS(4284),
    [anon_sym_AMP_AMP] = ACTIONS(4284),
    [anon_sym_PIPE] = ACTIONS(4286),
    [anon_sym_CARET] = ACTIONS(2250),
    [anon_sym_EQ_EQ] = ACTIONS(2252),
    [anon_sym_BANG_EQ] = ACTIONS(2252),
    [anon_sym_LT] = ACTIONS(2254),
    [anon_sym_GT] = ACTIONS(2254),
    [anon_sym_LT_EQ] = ACTIONS(2256),
    [anon_sym_GT_EQ] = ACTIONS(2256),
    [anon_sym_LT_LT] = ACTIONS(2258),
    [anon_sym_GT_GT] = ACTIONS(2258),
    [anon_sym_PLUS] = ACTIONS(2260),
    [anon_sym_DASH] = ACTIONS(2260),
    [anon_sym_SLASH] = ACTIONS(2234),
    [anon_sym_PERCENT] = ACTIONS(2234),
    [anon_sym_DASH_DASH] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(1554),
    [anon_sym_DASH_GT] = ACTIONS(1554),
    [sym_comment] = ACTIONS(49),
  },
  [1698] = {
    [sym_argument_list] = STATE(802),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_COMMA] = ACTIONS(4284),
    [anon_sym_RPAREN] = ACTIONS(4284),
    [anon_sym_STAR] = ACTIONS(2234),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_EQ] = ACTIONS(4286),
    [anon_sym_QMARK] = ACTIONS(4284),
    [anon_sym_STAR_EQ] = ACTIONS(4284),
    [anon_sym_SLASH_EQ] = ACTIONS(4284),
    [anon_sym_PERCENT_EQ] = ACTIONS(4284),
    [anon_sym_PLUS_EQ] = ACTIONS(4284),
    [anon_sym_DASH_EQ] = ACTIONS(4284),
    [anon_sym_LT_LT_EQ] = ACTIONS(4284),
    [anon_sym_GT_GT_EQ] = ACTIONS(4284),
    [anon_sym_AMP_EQ] = ACTIONS(4284),
    [anon_sym_CARET_EQ] = ACTIONS(4284),
    [anon_sym_PIPE_EQ] = ACTIONS(4284),
    [anon_sym_AMP] = ACTIONS(2242),
    [anon_sym_PIPE_PIPE] = ACTIONS(4284),
    [anon_sym_AMP_AMP] = ACTIONS(4284),
    [anon_sym_PIPE] = ACTIONS(4286),
    [anon_sym_CARET] = ACTIONS(4286),
    [anon_sym_EQ_EQ] = ACTIONS(2252),
    [anon_sym_BANG_EQ] = ACTIONS(2252),
    [anon_sym_LT] = ACTIONS(2254),
    [anon_sym_GT] = ACTIONS(2254),
    [anon_sym_LT_EQ] = ACTIONS(2256),
    [anon_sym_GT_EQ] = ACTIONS(2256),
    [anon_sym_LT_LT] = ACTIONS(2258),
    [anon_sym_GT_GT] = ACTIONS(2258),
    [anon_sym_PLUS] = ACTIONS(2260),
    [anon_sym_DASH] = ACTIONS(2260),
    [anon_sym_SLASH] = ACTIONS(2234),
    [anon_sym_PERCENT] = ACTIONS(2234),
    [anon_sym_DASH_DASH] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(1554),
    [anon_sym_DASH_GT] = ACTIONS(1554),
    [sym_comment] = ACTIONS(49),
  },
  [1699] = {
    [sym_argument_list] = STATE(802),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_COMMA] = ACTIONS(4292),
    [anon_sym_RPAREN] = ACTIONS(4292),
    [anon_sym_STAR] = ACTIONS(2234),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_EQ] = ACTIONS(4294),
    [anon_sym_QMARK] = ACTIONS(4292),
    [anon_sym_STAR_EQ] = ACTIONS(4292),
    [anon_sym_SLASH_EQ] = ACTIONS(4292),
    [anon_sym_PERCENT_EQ] = ACTIONS(4292),
    [anon_sym_PLUS_EQ] = ACTIONS(4292),
    [anon_sym_DASH_EQ] = ACTIONS(4292),
    [anon_sym_LT_LT_EQ] = ACTIONS(4292),
    [anon_sym_GT_GT_EQ] = ACTIONS(4292),
    [anon_sym_AMP_EQ] = ACTIONS(4292),
    [anon_sym_CARET_EQ] = ACTIONS(4292),
    [anon_sym_PIPE_EQ] = ACTIONS(4292),
    [anon_sym_AMP] = ACTIONS(4294),
    [anon_sym_PIPE_PIPE] = ACTIONS(4292),
    [anon_sym_AMP_AMP] = ACTIONS(4292),
    [anon_sym_PIPE] = ACTIONS(4294),
    [anon_sym_CARET] = ACTIONS(4294),
    [anon_sym_EQ_EQ] = ACTIONS(4292),
    [anon_sym_BANG_EQ] = ACTIONS(4292),
    [anon_sym_LT] = ACTIONS(2254),
    [anon_sym_GT] = ACTIONS(2254),
    [anon_sym_LT_EQ] = ACTIONS(2256),
    [anon_sym_GT_EQ] = ACTIONS(2256),
    [anon_sym_LT_LT] = ACTIONS(2258),
    [anon_sym_GT_GT] = ACTIONS(2258),
    [anon_sym_PLUS] = ACTIONS(2260),
    [anon_sym_DASH] = ACTIONS(2260),
    [anon_sym_SLASH] = ACTIONS(2234),
    [anon_sym_PERCENT] = ACTIONS(2234),
    [anon_sym_DASH_DASH] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(1554),
    [anon_sym_DASH_GT] = ACTIONS(1554),
    [sym_comment] = ACTIONS(49),
  },
  [1700] = {
    [sym_argument_list] = STATE(802),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_COMMA] = ACTIONS(4296),
    [anon_sym_RPAREN] = ACTIONS(4296),
    [anon_sym_STAR] = ACTIONS(2234),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_EQ] = ACTIONS(4298),
    [anon_sym_QMARK] = ACTIONS(4296),
    [anon_sym_STAR_EQ] = ACTIONS(4296),
    [anon_sym_SLASH_EQ] = ACTIONS(4296),
    [anon_sym_PERCENT_EQ] = ACTIONS(4296),
    [anon_sym_PLUS_EQ] = ACTIONS(4296),
    [anon_sym_DASH_EQ] = ACTIONS(4296),
    [anon_sym_LT_LT_EQ] = ACTIONS(4296),
    [anon_sym_GT_GT_EQ] = ACTIONS(4296),
    [anon_sym_AMP_EQ] = ACTIONS(4296),
    [anon_sym_CARET_EQ] = ACTIONS(4296),
    [anon_sym_PIPE_EQ] = ACTIONS(4296),
    [anon_sym_AMP] = ACTIONS(4298),
    [anon_sym_PIPE_PIPE] = ACTIONS(4296),
    [anon_sym_AMP_AMP] = ACTIONS(4296),
    [anon_sym_PIPE] = ACTIONS(4298),
    [anon_sym_CARET] = ACTIONS(4298),
    [anon_sym_EQ_EQ] = ACTIONS(4296),
    [anon_sym_BANG_EQ] = ACTIONS(4296),
    [anon_sym_LT] = ACTIONS(4298),
    [anon_sym_GT] = ACTIONS(4298),
    [anon_sym_LT_EQ] = ACTIONS(4296),
    [anon_sym_GT_EQ] = ACTIONS(4296),
    [anon_sym_LT_LT] = ACTIONS(2258),
    [anon_sym_GT_GT] = ACTIONS(2258),
    [anon_sym_PLUS] = ACTIONS(2260),
    [anon_sym_DASH] = ACTIONS(2260),
    [anon_sym_SLASH] = ACTIONS(2234),
    [anon_sym_PERCENT] = ACTIONS(2234),
    [anon_sym_DASH_DASH] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(1554),
    [anon_sym_DASH_GT] = ACTIONS(1554),
    [sym_comment] = ACTIONS(49),
  },
  [1701] = {
    [sym_argument_list] = STATE(802),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_COMMA] = ACTIONS(4300),
    [anon_sym_RPAREN] = ACTIONS(4300),
    [anon_sym_STAR] = ACTIONS(2234),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_EQ] = ACTIONS(4302),
    [anon_sym_QMARK] = ACTIONS(4300),
    [anon_sym_STAR_EQ] = ACTIONS(4300),
    [anon_sym_SLASH_EQ] = ACTIONS(4300),
    [anon_sym_PERCENT_EQ] = ACTIONS(4300),
    [anon_sym_PLUS_EQ] = ACTIONS(4300),
    [anon_sym_DASH_EQ] = ACTIONS(4300),
    [anon_sym_LT_LT_EQ] = ACTIONS(4300),
    [anon_sym_GT_GT_EQ] = ACTIONS(4300),
    [anon_sym_AMP_EQ] = ACTIONS(4300),
    [anon_sym_CARET_EQ] = ACTIONS(4300),
    [anon_sym_PIPE_EQ] = ACTIONS(4300),
    [anon_sym_AMP] = ACTIONS(4302),
    [anon_sym_PIPE_PIPE] = ACTIONS(4300),
    [anon_sym_AMP_AMP] = ACTIONS(4300),
    [anon_sym_PIPE] = ACTIONS(4302),
    [anon_sym_CARET] = ACTIONS(4302),
    [anon_sym_EQ_EQ] = ACTIONS(4300),
    [anon_sym_BANG_EQ] = ACTIONS(4300),
    [anon_sym_LT] = ACTIONS(4302),
    [anon_sym_GT] = ACTIONS(4302),
    [anon_sym_LT_EQ] = ACTIONS(4300),
    [anon_sym_GT_EQ] = ACTIONS(4300),
    [anon_sym_LT_LT] = ACTIONS(4302),
    [anon_sym_GT_GT] = ACTIONS(4302),
    [anon_sym_PLUS] = ACTIONS(2260),
    [anon_sym_DASH] = ACTIONS(2260),
    [anon_sym_SLASH] = ACTIONS(2234),
    [anon_sym_PERCENT] = ACTIONS(2234),
    [anon_sym_DASH_DASH] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(1554),
    [anon_sym_DASH_GT] = ACTIONS(1554),
    [sym_comment] = ACTIONS(49),
  },
  [1702] = {
    [sym_argument_list] = STATE(802),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_COMMA] = ACTIONS(4274),
    [anon_sym_RPAREN] = ACTIONS(4274),
    [anon_sym_STAR] = ACTIONS(2234),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_EQ] = ACTIONS(4276),
    [anon_sym_QMARK] = ACTIONS(4274),
    [anon_sym_STAR_EQ] = ACTIONS(4274),
    [anon_sym_SLASH_EQ] = ACTIONS(4274),
    [anon_sym_PERCENT_EQ] = ACTIONS(4274),
    [anon_sym_PLUS_EQ] = ACTIONS(4274),
    [anon_sym_DASH_EQ] = ACTIONS(4274),
    [anon_sym_LT_LT_EQ] = ACTIONS(4274),
    [anon_sym_GT_GT_EQ] = ACTIONS(4274),
    [anon_sym_AMP_EQ] = ACTIONS(4274),
    [anon_sym_CARET_EQ] = ACTIONS(4274),
    [anon_sym_PIPE_EQ] = ACTIONS(4274),
    [anon_sym_AMP] = ACTIONS(4276),
    [anon_sym_PIPE_PIPE] = ACTIONS(4274),
    [anon_sym_AMP_AMP] = ACTIONS(4274),
    [anon_sym_PIPE] = ACTIONS(4276),
    [anon_sym_CARET] = ACTIONS(4276),
    [anon_sym_EQ_EQ] = ACTIONS(4274),
    [anon_sym_BANG_EQ] = ACTIONS(4274),
    [anon_sym_LT] = ACTIONS(4276),
    [anon_sym_GT] = ACTIONS(4276),
    [anon_sym_LT_EQ] = ACTIONS(4274),
    [anon_sym_GT_EQ] = ACTIONS(4274),
    [anon_sym_LT_LT] = ACTIONS(4276),
    [anon_sym_GT_GT] = ACTIONS(4276),
    [anon_sym_PLUS] = ACTIONS(4276),
    [anon_sym_DASH] = ACTIONS(4276),
    [anon_sym_SLASH] = ACTIONS(2234),
    [anon_sym_PERCENT] = ACTIONS(2234),
    [anon_sym_DASH_DASH] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(1554),
    [anon_sym_DASH_GT] = ACTIONS(1554),
    [sym_comment] = ACTIONS(49),
  },
  [1703] = {
    [anon_sym_LPAREN] = ACTIONS(1807),
    [anon_sym_COMMA] = ACTIONS(1807),
    [anon_sym_RPAREN] = ACTIONS(1807),
    [anon_sym_SEMI] = ACTIONS(1807),
    [anon_sym_LBRACE] = ACTIONS(1801),
    [anon_sym_RBRACE] = ACTIONS(1807),
    [anon_sym_STAR] = ACTIONS(1809),
    [anon_sym_LBRACK] = ACTIONS(1807),
    [anon_sym_RBRACK] = ACTIONS(1807),
    [anon_sym_EQ] = ACTIONS(1809),
    [anon_sym_COLON] = ACTIONS(1809),
    [anon_sym_QMARK] = ACTIONS(1807),
    [anon_sym_STAR_EQ] = ACTIONS(1807),
    [anon_sym_SLASH_EQ] = ACTIONS(1807),
    [anon_sym_PERCENT_EQ] = ACTIONS(1807),
    [anon_sym_PLUS_EQ] = ACTIONS(1807),
    [anon_sym_DASH_EQ] = ACTIONS(1807),
    [anon_sym_LT_LT_EQ] = ACTIONS(1807),
    [anon_sym_GT_GT_EQ] = ACTIONS(1807),
    [anon_sym_AMP_EQ] = ACTIONS(1807),
    [anon_sym_CARET_EQ] = ACTIONS(1807),
    [anon_sym_PIPE_EQ] = ACTIONS(1807),
    [anon_sym_AMP] = ACTIONS(1809),
    [anon_sym_PIPE_PIPE] = ACTIONS(1807),
    [anon_sym_AMP_AMP] = ACTIONS(1807),
    [anon_sym_PIPE] = ACTIONS(1809),
    [anon_sym_CARET] = ACTIONS(1809),
    [anon_sym_EQ_EQ] = ACTIONS(1807),
    [anon_sym_BANG_EQ] = ACTIONS(1807),
    [anon_sym_LT] = ACTIONS(4317),
    [anon_sym_GT] = ACTIONS(1809),
    [anon_sym_LT_EQ] = ACTIONS(1807),
    [anon_sym_GT_EQ] = ACTIONS(1807),
    [anon_sym_LT_LT] = ACTIONS(1809),
    [anon_sym_GT_GT] = ACTIONS(1809),
    [anon_sym_PLUS] = ACTIONS(1809),
    [anon_sym_DASH] = ACTIONS(1809),
    [anon_sym_SLASH] = ACTIONS(1809),
    [anon_sym_PERCENT] = ACTIONS(1809),
    [anon_sym_DASH_DASH] = ACTIONS(1807),
    [anon_sym_PLUS_PLUS] = ACTIONS(1807),
    [anon_sym_DOT] = ACTIONS(1807),
    [anon_sym_DASH_GT] = ACTIONS(1807),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(1805),
  },
  [1704] = {
    [sym_parameter_list] = STATE(1707),
    [anon_sym_LPAREN] = ACTIONS(206),
    [anon_sym_RPAREN] = ACTIONS(3750),
    [anon_sym_LBRACK] = ACTIONS(2282),
    [sym_comment] = ACTIONS(49),
  },
  [1705] = {
    [sym_parameter_list] = STATE(1707),
    [anon_sym_LPAREN] = ACTIONS(206),
    [anon_sym_RPAREN] = ACTIONS(3762),
    [anon_sym_LBRACK] = ACTIONS(2282),
    [sym_comment] = ACTIONS(49),
  },
  [1706] = {
    [anon_sym_LPAREN] = ACTIONS(4978),
    [anon_sym_COMMA] = ACTIONS(4978),
    [anon_sym_RPAREN] = ACTIONS(4978),
    [anon_sym_SEMI] = ACTIONS(4978),
    [anon_sym_LBRACE] = ACTIONS(4978),
    [anon_sym_LBRACK] = ACTIONS(4978),
    [anon_sym_EQ] = ACTIONS(4978),
    [anon_sym_const] = ACTIONS(4980),
    [anon_sym_restrict] = ACTIONS(4978),
    [anon_sym_volatile] = ACTIONS(4978),
    [anon_sym__Atomic] = ACTIONS(4978),
    [anon_sym_mutable] = ACTIONS(4978),
    [anon_sym_explicit] = ACTIONS(4978),
    [anon_sym_constexpr] = ACTIONS(4978),
    [anon_sym_COLON] = ACTIONS(4978),
    [anon_sym_GT] = ACTIONS(4978),
    [anon_sym_DASH_GT] = ACTIONS(4978),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(4978),
  },
  [1707] = {
    [sym_type_qualifier] = STATE(2163),
    [sym_trailing_return_type] = STATE(1713),
    [aux_sym_abstract_function_declarator_repeat1] = STATE(2163),
    [anon_sym_LPAREN] = ACTIONS(3764),
    [anon_sym_RPAREN] = ACTIONS(3764),
    [anon_sym_LBRACK] = ACTIONS(3764),
    [anon_sym_const] = ACTIONS(612),
    [anon_sym_restrict] = ACTIONS(614),
    [anon_sym_volatile] = ACTIONS(614),
    [anon_sym__Atomic] = ACTIONS(614),
    [anon_sym_mutable] = ACTIONS(614),
    [anon_sym_explicit] = ACTIONS(614),
    [anon_sym_constexpr] = ACTIONS(614),
    [anon_sym_DASH_GT] = ACTIONS(3746),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(4982),
  },
  [1708] = {
    [sym__type_specifier] = STATE(2164),
    [sym_sized_type_specifier] = STATE(2164),
    [sym_enum_specifier] = STATE(2164),
    [sym_struct_specifier] = STATE(2164),
    [sym_union_specifier] = STATE(2164),
    [sym_macro_type_specifier] = STATE(2164),
    [sym_class_specifier] = STATE(2164),
    [sym_dependent_type] = STATE(2164),
    [sym_template_type] = STATE(62),
    [sym_scoped_type_identifier] = STATE(34),
    [sym_scoped_namespace_identifier] = STATE(64),
    [aux_sym_sized_type_specifier_repeat1] = STATE(725),
    [anon_sym_unsigned] = ACTIONS(1399),
    [anon_sym_long] = ACTIONS(1399),
    [anon_sym_short] = ACTIONS(1399),
    [sym_primitive_type] = ACTIONS(4984),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(428),
    [anon_sym_union] = ACTIONS(430),
    [sym_identifier] = ACTIONS(434),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(436),
    [sym_auto] = ACTIONS(4984),
    [anon_sym_typename] = ACTIONS(1407),
    [anon_sym_COLON_COLON] = ACTIONS(111),
  },
  [1709] = {
    [sym_type_qualifier] = STATE(2165),
    [sym_trailing_return_type] = STATE(1713),
    [aux_sym_abstract_function_declarator_repeat1] = STATE(2165),
    [anon_sym_LPAREN] = ACTIONS(3764),
    [anon_sym_RPAREN] = ACTIONS(3764),
    [anon_sym_LBRACK] = ACTIONS(3764),
    [anon_sym_const] = ACTIONS(612),
    [anon_sym_restrict] = ACTIONS(614),
    [anon_sym_volatile] = ACTIONS(614),
    [anon_sym__Atomic] = ACTIONS(614),
    [anon_sym_mutable] = ACTIONS(614),
    [anon_sym_explicit] = ACTIONS(614),
    [anon_sym_constexpr] = ACTIONS(614),
    [anon_sym_DASH_GT] = ACTIONS(3746),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(4986),
  },
  [1710] = {
    [anon_sym_LPAREN] = ACTIONS(4988),
    [anon_sym_COMMA] = ACTIONS(4988),
    [anon_sym_RPAREN] = ACTIONS(4988),
    [anon_sym_SEMI] = ACTIONS(4988),
    [anon_sym_LBRACE] = ACTIONS(4988),
    [anon_sym_LBRACK] = ACTIONS(4988),
    [anon_sym_EQ] = ACTIONS(4988),
    [anon_sym_const] = ACTIONS(4990),
    [anon_sym_restrict] = ACTIONS(4988),
    [anon_sym_volatile] = ACTIONS(4988),
    [anon_sym__Atomic] = ACTIONS(4988),
    [anon_sym_mutable] = ACTIONS(4988),
    [anon_sym_explicit] = ACTIONS(4988),
    [anon_sym_constexpr] = ACTIONS(4988),
    [anon_sym_COLON] = ACTIONS(4988),
    [anon_sym_GT] = ACTIONS(4988),
    [anon_sym_DASH_GT] = ACTIONS(4988),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(4988),
  },
  [1711] = {
    [sym_argument_list] = STATE(802),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_STAR] = ACTIONS(1522),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_RBRACK] = ACTIONS(4992),
    [anon_sym_EQ] = ACTIONS(1526),
    [anon_sym_QMARK] = ACTIONS(1528),
    [anon_sym_STAR_EQ] = ACTIONS(1530),
    [anon_sym_SLASH_EQ] = ACTIONS(1530),
    [anon_sym_PERCENT_EQ] = ACTIONS(1530),
    [anon_sym_PLUS_EQ] = ACTIONS(1530),
    [anon_sym_DASH_EQ] = ACTIONS(1530),
    [anon_sym_LT_LT_EQ] = ACTIONS(1530),
    [anon_sym_GT_GT_EQ] = ACTIONS(1530),
    [anon_sym_AMP_EQ] = ACTIONS(1530),
    [anon_sym_CARET_EQ] = ACTIONS(1530),
    [anon_sym_PIPE_EQ] = ACTIONS(1530),
    [anon_sym_AMP] = ACTIONS(1532),
    [anon_sym_PIPE_PIPE] = ACTIONS(1534),
    [anon_sym_AMP_AMP] = ACTIONS(1536),
    [anon_sym_PIPE] = ACTIONS(1538),
    [anon_sym_CARET] = ACTIONS(1540),
    [anon_sym_EQ_EQ] = ACTIONS(1542),
    [anon_sym_BANG_EQ] = ACTIONS(1542),
    [anon_sym_LT] = ACTIONS(1544),
    [anon_sym_GT] = ACTIONS(1544),
    [anon_sym_LT_EQ] = ACTIONS(1546),
    [anon_sym_GT_EQ] = ACTIONS(1546),
    [anon_sym_LT_LT] = ACTIONS(1548),
    [anon_sym_GT_GT] = ACTIONS(1548),
    [anon_sym_PLUS] = ACTIONS(1550),
    [anon_sym_DASH] = ACTIONS(1550),
    [anon_sym_SLASH] = ACTIONS(1522),
    [anon_sym_PERCENT] = ACTIONS(1522),
    [anon_sym_DASH_DASH] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(1554),
    [anon_sym_DASH_GT] = ACTIONS(1554),
    [sym_comment] = ACTIONS(49),
  },
  [1712] = {
    [sym__expression] = STATE(2167),
    [sym_conditional_expression] = STATE(2167),
    [sym_assignment_expression] = STATE(2167),
    [sym_pointer_expression] = STATE(2167),
    [sym_logical_expression] = STATE(2167),
    [sym_bitwise_expression] = STATE(2167),
    [sym_equality_expression] = STATE(2167),
    [sym_relational_expression] = STATE(2167),
    [sym_shift_expression] = STATE(2167),
    [sym_math_expression] = STATE(2167),
    [sym_cast_expression] = STATE(2167),
    [sym_sizeof_expression] = STATE(2167),
    [sym_subscript_expression] = STATE(2167),
    [sym_call_expression] = STATE(2167),
    [sym_field_expression] = STATE(2167),
    [sym_compound_literal_expression] = STATE(2167),
    [sym_parenthesized_expression] = STATE(2167),
    [sym_concatenated_string] = STATE(2167),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(2167),
    [sym_new_expression] = STATE(2167),
    [sym_delete_expression] = STATE(2167),
    [sym_lambda_expression] = STATE(2167),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(4994),
    [anon_sym_LPAREN] = ACTIONS(566),
    [anon_sym_STAR] = ACTIONS(568),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_RBRACK] = ACTIONS(4992),
    [anon_sym_AMP] = ACTIONS(568),
    [anon_sym_BANG] = ACTIONS(584),
    [anon_sym_TILDE] = ACTIONS(586),
    [anon_sym_PLUS] = ACTIONS(588),
    [anon_sym_DASH] = ACTIONS(588),
    [anon_sym_DASH_DASH] = ACTIONS(590),
    [anon_sym_PLUS_PLUS] = ACTIONS(590),
    [anon_sym_sizeof] = ACTIONS(592),
    [sym_number_literal] = ACTIONS(4994),
    [sym_char_literal] = ACTIONS(4994),
    [sym_string_literal] = ACTIONS(594),
    [sym_true] = ACTIONS(4996),
    [sym_false] = ACTIONS(4996),
    [sym_null] = ACTIONS(4996),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1415),
    [anon_sym_delete] = ACTIONS(608),
    [sym_nullptr] = ACTIONS(4996),
  },
  [1713] = {
    [anon_sym_LPAREN] = ACTIONS(4998),
    [anon_sym_COMMA] = ACTIONS(4998),
    [anon_sym_RPAREN] = ACTIONS(4998),
    [anon_sym_SEMI] = ACTIONS(4998),
    [anon_sym_LBRACE] = ACTIONS(4998),
    [anon_sym_LBRACK] = ACTIONS(4998),
    [anon_sym_EQ] = ACTIONS(4998),
    [anon_sym_const] = ACTIONS(5000),
    [anon_sym_restrict] = ACTIONS(4998),
    [anon_sym_volatile] = ACTIONS(4998),
    [anon_sym__Atomic] = ACTIONS(4998),
    [anon_sym_mutable] = ACTIONS(4998),
    [anon_sym_explicit] = ACTIONS(4998),
    [anon_sym_constexpr] = ACTIONS(4998),
    [anon_sym_COLON] = ACTIONS(4998),
    [anon_sym_GT] = ACTIONS(4998),
    [anon_sym_DASH_GT] = ACTIONS(4998),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(4998),
  },
  [1714] = {
    [sym_type_qualifier] = STATE(1716),
    [sym_trailing_return_type] = STATE(2168),
    [aux_sym_abstract_function_declarator_repeat1] = STATE(1716),
    [anon_sym_LPAREN] = ACTIONS(4998),
    [anon_sym_COMMA] = ACTIONS(4998),
    [anon_sym_LBRACK] = ACTIONS(4998),
    [anon_sym_const] = ACTIONS(612),
    [anon_sym_restrict] = ACTIONS(614),
    [anon_sym_volatile] = ACTIONS(614),
    [anon_sym__Atomic] = ACTIONS(614),
    [anon_sym_mutable] = ACTIONS(614),
    [anon_sym_explicit] = ACTIONS(614),
    [anon_sym_constexpr] = ACTIONS(614),
    [anon_sym_GT] = ACTIONS(4998),
    [anon_sym_DASH_GT] = ACTIONS(2286),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(3772),
  },
  [1715] = {
    [sym__abstract_declarator] = STATE(2169),
    [sym_abstract_pointer_declarator] = STATE(2169),
    [sym_abstract_function_declarator] = STATE(2169),
    [sym_abstract_array_declarator] = STATE(2169),
    [sym_parameter_list] = STATE(598),
    [sym_abstract_reference_declarator] = STATE(2169),
    [anon_sym_LPAREN] = ACTIONS(1115),
    [anon_sym_COMMA] = ACTIONS(2841),
    [anon_sym_STAR] = ACTIONS(1119),
    [anon_sym_LBRACK] = ACTIONS(1121),
    [anon_sym_AMP] = ACTIONS(1123),
    [anon_sym_AMP_AMP] = ACTIONS(1125),
    [anon_sym_GT] = ACTIONS(2841),
    [sym_comment] = ACTIONS(49),
  },
  [1716] = {
    [sym_type_qualifier] = STATE(1716),
    [aux_sym_abstract_function_declarator_repeat1] = STATE(1716),
    [anon_sym_LPAREN] = ACTIONS(5002),
    [anon_sym_COMMA] = ACTIONS(5002),
    [anon_sym_LBRACK] = ACTIONS(5002),
    [anon_sym_const] = ACTIONS(5004),
    [anon_sym_restrict] = ACTIONS(5007),
    [anon_sym_volatile] = ACTIONS(5007),
    [anon_sym__Atomic] = ACTIONS(5007),
    [anon_sym_mutable] = ACTIONS(5007),
    [anon_sym_explicit] = ACTIONS(5007),
    [anon_sym_constexpr] = ACTIONS(5007),
    [anon_sym_GT] = ACTIONS(5002),
    [anon_sym_DASH_GT] = ACTIONS(5002),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(5010),
  },
  [1717] = {
    [sym__type_specifier] = STATE(93),
    [sym_sized_type_specifier] = STATE(93),
    [sym_enum_specifier] = STATE(93),
    [sym_struct_specifier] = STATE(93),
    [sym_union_specifier] = STATE(93),
    [sym_macro_type_specifier] = STATE(93),
    [sym_class_specifier] = STATE(93),
    [sym_dependent_type] = STATE(93),
    [sym_template_type] = STATE(62),
    [sym_scoped_type_identifier] = STATE(34),
    [sym_scoped_namespace_identifier] = STATE(64),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1719),
    [anon_sym_unsigned] = ACTIONS(3785),
    [anon_sym_long] = ACTIONS(3785),
    [anon_sym_short] = ACTIONS(3785),
    [sym_primitive_type] = ACTIONS(150),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(428),
    [anon_sym_union] = ACTIONS(430),
    [sym_identifier] = ACTIONS(434),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(436),
    [sym_auto] = ACTIONS(150),
    [anon_sym_typename] = ACTIONS(3789),
    [anon_sym_COLON_COLON] = ACTIONS(111),
  },
  [1718] = {
    [anon_sym_COMMA] = ACTIONS(5013),
    [anon_sym_GT] = ACTIONS(5013),
    [sym_comment] = ACTIONS(49),
  },
  [1719] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2170),
    [anon_sym_COMMA] = ACTIONS(238),
    [anon_sym_unsigned] = ACTIONS(5015),
    [anon_sym_long] = ACTIONS(5015),
    [anon_sym_short] = ACTIONS(5015),
    [sym_primitive_type] = ACTIONS(244),
    [anon_sym_GT] = ACTIONS(238),
    [sym_identifier] = ACTIONS(1135),
    [sym_comment] = ACTIONS(49),
  },
  [1720] = {
    [anon_sym_LPAREN] = ACTIONS(1146),
    [anon_sym_COMMA] = ACTIONS(1146),
    [anon_sym_LBRACE] = ACTIONS(1146),
    [anon_sym_LBRACK] = ACTIONS(1146),
    [anon_sym_EQ] = ACTIONS(1146),
    [anon_sym_LT] = ACTIONS(1146),
    [anon_sym_GT] = ACTIONS(1146),
    [sym_comment] = ACTIONS(49),
  },
  [1721] = {
    [sym_argument_list] = STATE(802),
    [aux_sym_argument_list_repeat1] = STATE(2172),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_COMMA] = ACTIONS(2388),
    [anon_sym_RPAREN] = ACTIONS(5017),
    [anon_sym_STAR] = ACTIONS(2234),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_EQ] = ACTIONS(2236),
    [anon_sym_QMARK] = ACTIONS(2238),
    [anon_sym_STAR_EQ] = ACTIONS(2240),
    [anon_sym_SLASH_EQ] = ACTIONS(2240),
    [anon_sym_PERCENT_EQ] = ACTIONS(2240),
    [anon_sym_PLUS_EQ] = ACTIONS(2240),
    [anon_sym_DASH_EQ] = ACTIONS(2240),
    [anon_sym_LT_LT_EQ] = ACTIONS(2240),
    [anon_sym_GT_GT_EQ] = ACTIONS(2240),
    [anon_sym_AMP_EQ] = ACTIONS(2240),
    [anon_sym_CARET_EQ] = ACTIONS(2240),
    [anon_sym_PIPE_EQ] = ACTIONS(2240),
    [anon_sym_AMP] = ACTIONS(2242),
    [anon_sym_PIPE_PIPE] = ACTIONS(2244),
    [anon_sym_AMP_AMP] = ACTIONS(2246),
    [anon_sym_PIPE] = ACTIONS(2248),
    [anon_sym_CARET] = ACTIONS(2250),
    [anon_sym_EQ_EQ] = ACTIONS(2252),
    [anon_sym_BANG_EQ] = ACTIONS(2252),
    [anon_sym_LT] = ACTIONS(2254),
    [anon_sym_GT] = ACTIONS(2254),
    [anon_sym_LT_EQ] = ACTIONS(2256),
    [anon_sym_GT_EQ] = ACTIONS(2256),
    [anon_sym_LT_LT] = ACTIONS(2258),
    [anon_sym_GT_GT] = ACTIONS(2258),
    [anon_sym_PLUS] = ACTIONS(2260),
    [anon_sym_DASH] = ACTIONS(2260),
    [anon_sym_SLASH] = ACTIONS(2234),
    [anon_sym_PERCENT] = ACTIONS(2234),
    [anon_sym_DASH_DASH] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(1554),
    [anon_sym_DASH_GT] = ACTIONS(1554),
    [sym_comment] = ACTIONS(49),
  },
  [1722] = {
    [aux_sym_argument_list_repeat1] = STATE(2172),
    [anon_sym_COMMA] = ACTIONS(2388),
    [anon_sym_RPAREN] = ACTIONS(5017),
    [sym_comment] = ACTIONS(49),
  },
  [1723] = {
    [anon_sym_RBRACE] = ACTIONS(5019),
    [sym_comment] = ACTIONS(49),
  },
  [1724] = {
    [anon_sym_COMMA] = ACTIONS(2400),
    [anon_sym_GT] = ACTIONS(2400),
    [sym_comment] = ACTIONS(49),
  },
  [1725] = {
    [sym_argument_list] = STATE(802),
    [aux_sym_initializer_list_repeat1] = STATE(2175),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_COMMA] = ACTIONS(5021),
    [anon_sym_RBRACE] = ACTIONS(5019),
    [anon_sym_STAR] = ACTIONS(2507),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_EQ] = ACTIONS(2509),
    [anon_sym_QMARK] = ACTIONS(2511),
    [anon_sym_STAR_EQ] = ACTIONS(2513),
    [anon_sym_SLASH_EQ] = ACTIONS(2513),
    [anon_sym_PERCENT_EQ] = ACTIONS(2513),
    [anon_sym_PLUS_EQ] = ACTIONS(2513),
    [anon_sym_DASH_EQ] = ACTIONS(2513),
    [anon_sym_LT_LT_EQ] = ACTIONS(2513),
    [anon_sym_GT_GT_EQ] = ACTIONS(2513),
    [anon_sym_AMP_EQ] = ACTIONS(2513),
    [anon_sym_CARET_EQ] = ACTIONS(2513),
    [anon_sym_PIPE_EQ] = ACTIONS(2513),
    [anon_sym_AMP] = ACTIONS(2515),
    [anon_sym_PIPE_PIPE] = ACTIONS(2517),
    [anon_sym_AMP_AMP] = ACTIONS(2519),
    [anon_sym_PIPE] = ACTIONS(2521),
    [anon_sym_CARET] = ACTIONS(2523),
    [anon_sym_EQ_EQ] = ACTIONS(2525),
    [anon_sym_BANG_EQ] = ACTIONS(2525),
    [anon_sym_LT] = ACTIONS(2527),
    [anon_sym_GT] = ACTIONS(2527),
    [anon_sym_LT_EQ] = ACTIONS(2529),
    [anon_sym_GT_EQ] = ACTIONS(2529),
    [anon_sym_LT_LT] = ACTIONS(2531),
    [anon_sym_GT_GT] = ACTIONS(2531),
    [anon_sym_PLUS] = ACTIONS(2533),
    [anon_sym_DASH] = ACTIONS(2533),
    [anon_sym_SLASH] = ACTIONS(2507),
    [anon_sym_PERCENT] = ACTIONS(2507),
    [anon_sym_DASH_DASH] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(1554),
    [anon_sym_DASH_GT] = ACTIONS(1554),
    [sym_comment] = ACTIONS(49),
  },
  [1726] = {
    [aux_sym_initializer_list_repeat1] = STATE(2175),
    [anon_sym_COMMA] = ACTIONS(5021),
    [anon_sym_RBRACE] = ACTIONS(5019),
    [sym_comment] = ACTIONS(49),
  },
  [1727] = {
    [sym_type_qualifier] = STATE(724),
    [sym__type_specifier] = STATE(720),
    [sym_sized_type_specifier] = STATE(720),
    [sym_enum_specifier] = STATE(720),
    [sym_struct_specifier] = STATE(720),
    [sym_union_specifier] = STATE(720),
    [sym__expression] = STATE(721),
    [sym_comma_expression] = STATE(722),
    [sym_conditional_expression] = STATE(721),
    [sym_assignment_expression] = STATE(721),
    [sym_pointer_expression] = STATE(721),
    [sym_logical_expression] = STATE(721),
    [sym_bitwise_expression] = STATE(721),
    [sym_equality_expression] = STATE(721),
    [sym_relational_expression] = STATE(721),
    [sym_shift_expression] = STATE(721),
    [sym_math_expression] = STATE(721),
    [sym_cast_expression] = STATE(721),
    [sym_type_descriptor] = STATE(2176),
    [sym_sizeof_expression] = STATE(721),
    [sym_subscript_expression] = STATE(721),
    [sym_call_expression] = STATE(721),
    [sym_field_expression] = STATE(721),
    [sym_compound_literal_expression] = STATE(721),
    [sym_parenthesized_expression] = STATE(721),
    [sym_concatenated_string] = STATE(721),
    [sym_macro_type_specifier] = STATE(720),
    [sym_class_specifier] = STATE(720),
    [sym_dependent_type] = STATE(720),
    [sym_template_type] = STATE(415),
    [sym_template_function] = STATE(721),
    [sym_new_expression] = STATE(721),
    [sym_delete_expression] = STATE(721),
    [sym_lambda_expression] = STATE(721),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(416),
    [sym_scoped_namespace_identifier] = STATE(417),
    [aux_sym_type_definition_repeat1] = STATE(724),
    [aux_sym_sized_type_specifier_repeat1] = STATE(725),
    [sym_raw_string_literal] = ACTIONS(1397),
    [anon_sym_LPAREN] = ACTIONS(1087),
    [anon_sym_STAR] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_restrict] = ACTIONS(93),
    [anon_sym_volatile] = ACTIONS(93),
    [anon_sym__Atomic] = ACTIONS(93),
    [anon_sym_mutable] = ACTIONS(93),
    [anon_sym_explicit] = ACTIONS(93),
    [anon_sym_constexpr] = ACTIONS(93),
    [anon_sym_unsigned] = ACTIONS(1399),
    [anon_sym_long] = ACTIONS(1399),
    [anon_sym_short] = ACTIONS(1399),
    [sym_primitive_type] = ACTIONS(1401),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(428),
    [anon_sym_union] = ACTIONS(430),
    [anon_sym_AMP] = ACTIONS(1089),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1093),
    [anon_sym_PLUS] = ACTIONS(1095),
    [anon_sym_DASH] = ACTIONS(1095),
    [anon_sym_DASH_DASH] = ACTIONS(1097),
    [anon_sym_PLUS_PLUS] = ACTIONS(1097),
    [anon_sym_sizeof] = ACTIONS(1099),
    [sym_number_literal] = ACTIONS(1397),
    [sym_char_literal] = ACTIONS(1397),
    [sym_string_literal] = ACTIONS(1101),
    [sym_true] = ACTIONS(1403),
    [sym_false] = ACTIONS(1403),
    [sym_null] = ACTIONS(1403),
    [sym_identifier] = ACTIONS(1405),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(436),
    [sym_auto] = ACTIONS(1401),
    [anon_sym_typename] = ACTIONS(1407),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1409),
    [anon_sym_delete] = ACTIONS(1109),
    [sym_nullptr] = ACTIONS(1403),
  },
  [1728] = {
    [sym__expression] = STATE(727),
    [sym_conditional_expression] = STATE(727),
    [sym_assignment_expression] = STATE(727),
    [sym_pointer_expression] = STATE(727),
    [sym_logical_expression] = STATE(727),
    [sym_bitwise_expression] = STATE(727),
    [sym_equality_expression] = STATE(727),
    [sym_relational_expression] = STATE(727),
    [sym_shift_expression] = STATE(727),
    [sym_math_expression] = STATE(727),
    [sym_cast_expression] = STATE(727),
    [sym_sizeof_expression] = STATE(727),
    [sym_subscript_expression] = STATE(727),
    [sym_call_expression] = STATE(727),
    [sym_field_expression] = STATE(727),
    [sym_compound_literal_expression] = STATE(727),
    [sym_parenthesized_expression] = STATE(727),
    [sym_concatenated_string] = STATE(727),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(727),
    [sym_new_expression] = STATE(727),
    [sym_delete_expression] = STATE(727),
    [sym_lambda_expression] = STATE(727),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(1411),
    [anon_sym_LPAREN] = ACTIONS(3807),
    [anon_sym_STAR] = ACTIONS(3809),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_AMP] = ACTIONS(3809),
    [anon_sym_BANG] = ACTIONS(3811),
    [anon_sym_TILDE] = ACTIONS(3813),
    [anon_sym_PLUS] = ACTIONS(3815),
    [anon_sym_DASH] = ACTIONS(3815),
    [anon_sym_DASH_DASH] = ACTIONS(3817),
    [anon_sym_PLUS_PLUS] = ACTIONS(3817),
    [anon_sym_sizeof] = ACTIONS(3819),
    [sym_number_literal] = ACTIONS(1411),
    [sym_char_literal] = ACTIONS(1411),
    [sym_string_literal] = ACTIONS(3821),
    [sym_true] = ACTIONS(1413),
    [sym_false] = ACTIONS(1413),
    [sym_null] = ACTIONS(1413),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(3825),
    [anon_sym_delete] = ACTIONS(3827),
    [sym_nullptr] = ACTIONS(1413),
  },
  [1729] = {
    [sym__expression] = STATE(757),
    [sym_conditional_expression] = STATE(757),
    [sym_assignment_expression] = STATE(757),
    [sym_pointer_expression] = STATE(757),
    [sym_logical_expression] = STATE(757),
    [sym_bitwise_expression] = STATE(757),
    [sym_equality_expression] = STATE(757),
    [sym_relational_expression] = STATE(757),
    [sym_shift_expression] = STATE(757),
    [sym_math_expression] = STATE(757),
    [sym_cast_expression] = STATE(757),
    [sym_sizeof_expression] = STATE(757),
    [sym_subscript_expression] = STATE(757),
    [sym_call_expression] = STATE(757),
    [sym_field_expression] = STATE(757),
    [sym_compound_literal_expression] = STATE(757),
    [sym_parenthesized_expression] = STATE(757),
    [sym_concatenated_string] = STATE(757),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(757),
    [sym_new_expression] = STATE(757),
    [sym_delete_expression] = STATE(757),
    [sym_lambda_expression] = STATE(757),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(1459),
    [anon_sym_LPAREN] = ACTIONS(3807),
    [anon_sym_STAR] = ACTIONS(3809),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_AMP] = ACTIONS(3809),
    [anon_sym_BANG] = ACTIONS(3811),
    [anon_sym_TILDE] = ACTIONS(3813),
    [anon_sym_PLUS] = ACTIONS(3815),
    [anon_sym_DASH] = ACTIONS(3815),
    [anon_sym_DASH_DASH] = ACTIONS(3817),
    [anon_sym_PLUS_PLUS] = ACTIONS(3817),
    [anon_sym_sizeof] = ACTIONS(3819),
    [sym_number_literal] = ACTIONS(1459),
    [sym_char_literal] = ACTIONS(1459),
    [sym_string_literal] = ACTIONS(3821),
    [sym_true] = ACTIONS(1461),
    [sym_false] = ACTIONS(1461),
    [sym_null] = ACTIONS(1461),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(3825),
    [anon_sym_delete] = ACTIONS(3827),
    [sym_nullptr] = ACTIONS(1461),
  },
  [1730] = {
    [sym__expression] = STATE(758),
    [sym_conditional_expression] = STATE(758),
    [sym_assignment_expression] = STATE(758),
    [sym_pointer_expression] = STATE(758),
    [sym_logical_expression] = STATE(758),
    [sym_bitwise_expression] = STATE(758),
    [sym_equality_expression] = STATE(758),
    [sym_relational_expression] = STATE(758),
    [sym_shift_expression] = STATE(758),
    [sym_math_expression] = STATE(758),
    [sym_cast_expression] = STATE(758),
    [sym_sizeof_expression] = STATE(758),
    [sym_subscript_expression] = STATE(758),
    [sym_call_expression] = STATE(758),
    [sym_field_expression] = STATE(758),
    [sym_compound_literal_expression] = STATE(758),
    [sym_parenthesized_expression] = STATE(758),
    [sym_concatenated_string] = STATE(758),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(758),
    [sym_new_expression] = STATE(758),
    [sym_delete_expression] = STATE(758),
    [sym_lambda_expression] = STATE(758),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(1463),
    [anon_sym_LPAREN] = ACTIONS(3807),
    [anon_sym_STAR] = ACTIONS(3809),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_AMP] = ACTIONS(3809),
    [anon_sym_BANG] = ACTIONS(3811),
    [anon_sym_TILDE] = ACTIONS(3813),
    [anon_sym_PLUS] = ACTIONS(3815),
    [anon_sym_DASH] = ACTIONS(3815),
    [anon_sym_DASH_DASH] = ACTIONS(3817),
    [anon_sym_PLUS_PLUS] = ACTIONS(3817),
    [anon_sym_sizeof] = ACTIONS(3819),
    [sym_number_literal] = ACTIONS(1463),
    [sym_char_literal] = ACTIONS(1463),
    [sym_string_literal] = ACTIONS(3821),
    [sym_true] = ACTIONS(1465),
    [sym_false] = ACTIONS(1465),
    [sym_null] = ACTIONS(1465),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(3825),
    [anon_sym_delete] = ACTIONS(3827),
    [sym_nullptr] = ACTIONS(1465),
  },
  [1731] = {
    [sym__expression] = STATE(759),
    [sym_conditional_expression] = STATE(759),
    [sym_assignment_expression] = STATE(759),
    [sym_pointer_expression] = STATE(759),
    [sym_logical_expression] = STATE(759),
    [sym_bitwise_expression] = STATE(759),
    [sym_equality_expression] = STATE(759),
    [sym_relational_expression] = STATE(759),
    [sym_shift_expression] = STATE(759),
    [sym_math_expression] = STATE(759),
    [sym_cast_expression] = STATE(759),
    [sym_sizeof_expression] = STATE(759),
    [sym_subscript_expression] = STATE(759),
    [sym_call_expression] = STATE(759),
    [sym_field_expression] = STATE(759),
    [sym_compound_literal_expression] = STATE(759),
    [sym_parenthesized_expression] = STATE(759),
    [sym_concatenated_string] = STATE(759),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(759),
    [sym_new_expression] = STATE(759),
    [sym_delete_expression] = STATE(759),
    [sym_lambda_expression] = STATE(759),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(1467),
    [anon_sym_LPAREN] = ACTIONS(3807),
    [anon_sym_STAR] = ACTIONS(3809),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_AMP] = ACTIONS(3809),
    [anon_sym_BANG] = ACTIONS(3811),
    [anon_sym_TILDE] = ACTIONS(3813),
    [anon_sym_PLUS] = ACTIONS(3815),
    [anon_sym_DASH] = ACTIONS(3815),
    [anon_sym_DASH_DASH] = ACTIONS(3817),
    [anon_sym_PLUS_PLUS] = ACTIONS(3817),
    [anon_sym_sizeof] = ACTIONS(3819),
    [sym_number_literal] = ACTIONS(1467),
    [sym_char_literal] = ACTIONS(1467),
    [sym_string_literal] = ACTIONS(3821),
    [sym_true] = ACTIONS(1469),
    [sym_false] = ACTIONS(1469),
    [sym_null] = ACTIONS(1469),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(3825),
    [anon_sym_delete] = ACTIONS(3827),
    [sym_nullptr] = ACTIONS(1469),
  },
  [1732] = {
    [sym__expression] = STATE(2178),
    [sym_conditional_expression] = STATE(2178),
    [sym_assignment_expression] = STATE(2178),
    [sym_pointer_expression] = STATE(2178),
    [sym_logical_expression] = STATE(2178),
    [sym_bitwise_expression] = STATE(2178),
    [sym_equality_expression] = STATE(2178),
    [sym_relational_expression] = STATE(2178),
    [sym_shift_expression] = STATE(2178),
    [sym_math_expression] = STATE(2178),
    [sym_cast_expression] = STATE(2178),
    [sym_sizeof_expression] = STATE(2178),
    [sym_subscript_expression] = STATE(2178),
    [sym_call_expression] = STATE(2178),
    [sym_field_expression] = STATE(2178),
    [sym_compound_literal_expression] = STATE(2178),
    [sym_parenthesized_expression] = STATE(2178),
    [sym_concatenated_string] = STATE(2178),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(2178),
    [sym_new_expression] = STATE(2178),
    [sym_delete_expression] = STATE(2178),
    [sym_lambda_expression] = STATE(2178),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(5023),
    [anon_sym_LPAREN] = ACTIONS(5025),
    [anon_sym_STAR] = ACTIONS(3809),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_AMP] = ACTIONS(3809),
    [anon_sym_BANG] = ACTIONS(3811),
    [anon_sym_TILDE] = ACTIONS(3813),
    [anon_sym_PLUS] = ACTIONS(3815),
    [anon_sym_DASH] = ACTIONS(3815),
    [anon_sym_DASH_DASH] = ACTIONS(3817),
    [anon_sym_PLUS_PLUS] = ACTIONS(3817),
    [anon_sym_sizeof] = ACTIONS(3819),
    [sym_number_literal] = ACTIONS(5023),
    [sym_char_literal] = ACTIONS(5023),
    [sym_string_literal] = ACTIONS(3821),
    [sym_true] = ACTIONS(5027),
    [sym_false] = ACTIONS(5027),
    [sym_null] = ACTIONS(5027),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(3825),
    [anon_sym_delete] = ACTIONS(3827),
    [sym_nullptr] = ACTIONS(5027),
  },
  [1733] = {
    [aux_sym_concatenated_string_repeat1] = STATE(2179),
    [anon_sym_LPAREN] = ACTIONS(1477),
    [anon_sym_COMMA] = ACTIONS(1477),
    [anon_sym_STAR] = ACTIONS(1479),
    [anon_sym_LBRACK] = ACTIONS(1477),
    [anon_sym_EQ] = ACTIONS(1479),
    [anon_sym_QMARK] = ACTIONS(1477),
    [anon_sym_STAR_EQ] = ACTIONS(1477),
    [anon_sym_SLASH_EQ] = ACTIONS(1477),
    [anon_sym_PERCENT_EQ] = ACTIONS(1477),
    [anon_sym_PLUS_EQ] = ACTIONS(1477),
    [anon_sym_DASH_EQ] = ACTIONS(1477),
    [anon_sym_LT_LT_EQ] = ACTIONS(1477),
    [anon_sym_GT_GT_EQ] = ACTIONS(1477),
    [anon_sym_AMP_EQ] = ACTIONS(1477),
    [anon_sym_CARET_EQ] = ACTIONS(1477),
    [anon_sym_PIPE_EQ] = ACTIONS(1477),
    [anon_sym_AMP] = ACTIONS(1479),
    [anon_sym_PIPE_PIPE] = ACTIONS(1477),
    [anon_sym_AMP_AMP] = ACTIONS(1477),
    [anon_sym_PIPE] = ACTIONS(1479),
    [anon_sym_CARET] = ACTIONS(1479),
    [anon_sym_EQ_EQ] = ACTIONS(1477),
    [anon_sym_BANG_EQ] = ACTIONS(1477),
    [anon_sym_LT] = ACTIONS(1479),
    [anon_sym_GT] = ACTIONS(1479),
    [anon_sym_LT_EQ] = ACTIONS(1477),
    [anon_sym_GT_EQ] = ACTIONS(1477),
    [anon_sym_LT_LT] = ACTIONS(1479),
    [anon_sym_GT_GT] = ACTIONS(1479),
    [anon_sym_PLUS] = ACTIONS(1479),
    [anon_sym_DASH] = ACTIONS(1479),
    [anon_sym_SLASH] = ACTIONS(1479),
    [anon_sym_PERCENT] = ACTIONS(1479),
    [anon_sym_DASH_DASH] = ACTIONS(1477),
    [anon_sym_PLUS_PLUS] = ACTIONS(1477),
    [anon_sym_DOT] = ACTIONS(1477),
    [anon_sym_DASH_GT] = ACTIONS(1477),
    [sym_string_literal] = ACTIONS(5029),
    [sym_comment] = ACTIONS(49),
  },
  [1734] = {
    [sym_destructor_name] = STATE(120),
    [anon_sym_TILDE] = ACTIONS(1500),
    [sym_identifier] = ACTIONS(2220),
    [sym_comment] = ACTIONS(49),
    [anon_sym_delete] = ACTIONS(5031),
    [sym_operator_name] = ACTIONS(190),
  },
  [1735] = {
    [sym__expression] = STATE(2182),
    [sym_conditional_expression] = STATE(2182),
    [sym_assignment_expression] = STATE(2182),
    [sym_pointer_expression] = STATE(2182),
    [sym_logical_expression] = STATE(2182),
    [sym_bitwise_expression] = STATE(2182),
    [sym_equality_expression] = STATE(2182),
    [sym_relational_expression] = STATE(2182),
    [sym_shift_expression] = STATE(2182),
    [sym_math_expression] = STATE(2182),
    [sym_cast_expression] = STATE(2182),
    [sym_sizeof_expression] = STATE(2182),
    [sym_subscript_expression] = STATE(2182),
    [sym_call_expression] = STATE(2182),
    [sym_field_expression] = STATE(2182),
    [sym_compound_literal_expression] = STATE(2182),
    [sym_parenthesized_expression] = STATE(2182),
    [sym_concatenated_string] = STATE(2182),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(2182),
    [sym_new_expression] = STATE(2182),
    [sym_delete_expression] = STATE(2182),
    [sym_lambda_expression] = STATE(2182),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(5033),
    [anon_sym_LPAREN] = ACTIONS(3807),
    [anon_sym_STAR] = ACTIONS(3809),
    [anon_sym_LBRACK] = ACTIONS(5035),
    [anon_sym_AMP] = ACTIONS(3809),
    [anon_sym_BANG] = ACTIONS(3811),
    [anon_sym_TILDE] = ACTIONS(3813),
    [anon_sym_PLUS] = ACTIONS(3815),
    [anon_sym_DASH] = ACTIONS(3815),
    [anon_sym_DASH_DASH] = ACTIONS(3817),
    [anon_sym_PLUS_PLUS] = ACTIONS(3817),
    [anon_sym_sizeof] = ACTIONS(3819),
    [sym_number_literal] = ACTIONS(5033),
    [sym_char_literal] = ACTIONS(5033),
    [sym_string_literal] = ACTIONS(3821),
    [sym_true] = ACTIONS(5037),
    [sym_false] = ACTIONS(5037),
    [sym_null] = ACTIONS(5037),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(3825),
    [anon_sym_delete] = ACTIONS(3827),
    [sym_nullptr] = ACTIONS(5037),
  },
  [1736] = {
    [sym_argument_list] = STATE(802),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_COMMA] = ACTIONS(2462),
    [anon_sym_STAR] = ACTIONS(5039),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_EQ] = ACTIONS(5041),
    [anon_sym_QMARK] = ACTIONS(5043),
    [anon_sym_STAR_EQ] = ACTIONS(5045),
    [anon_sym_SLASH_EQ] = ACTIONS(5045),
    [anon_sym_PERCENT_EQ] = ACTIONS(5045),
    [anon_sym_PLUS_EQ] = ACTIONS(5045),
    [anon_sym_DASH_EQ] = ACTIONS(5045),
    [anon_sym_LT_LT_EQ] = ACTIONS(5045),
    [anon_sym_GT_GT_EQ] = ACTIONS(5045),
    [anon_sym_AMP_EQ] = ACTIONS(5045),
    [anon_sym_CARET_EQ] = ACTIONS(5045),
    [anon_sym_PIPE_EQ] = ACTIONS(5045),
    [anon_sym_AMP] = ACTIONS(5047),
    [anon_sym_PIPE_PIPE] = ACTIONS(5049),
    [anon_sym_AMP_AMP] = ACTIONS(5051),
    [anon_sym_PIPE] = ACTIONS(5053),
    [anon_sym_CARET] = ACTIONS(5055),
    [anon_sym_EQ_EQ] = ACTIONS(5057),
    [anon_sym_BANG_EQ] = ACTIONS(5057),
    [anon_sym_LT] = ACTIONS(5059),
    [anon_sym_GT] = ACTIONS(5059),
    [anon_sym_LT_EQ] = ACTIONS(5061),
    [anon_sym_GT_EQ] = ACTIONS(5061),
    [anon_sym_LT_LT] = ACTIONS(5063),
    [anon_sym_GT_GT] = ACTIONS(5063),
    [anon_sym_PLUS] = ACTIONS(5065),
    [anon_sym_DASH] = ACTIONS(5065),
    [anon_sym_SLASH] = ACTIONS(5039),
    [anon_sym_PERCENT] = ACTIONS(5039),
    [anon_sym_DASH_DASH] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(1554),
    [anon_sym_DASH_GT] = ACTIONS(1554),
    [sym_comment] = ACTIONS(49),
  },
  [1737] = {
    [sym__type_specifier] = STATE(2196),
    [sym_sized_type_specifier] = STATE(2196),
    [sym_enum_specifier] = STATE(2196),
    [sym_struct_specifier] = STATE(2196),
    [sym_union_specifier] = STATE(2196),
    [sym_macro_type_specifier] = STATE(2196),
    [sym_class_specifier] = STATE(2196),
    [sym_dependent_type] = STATE(2196),
    [sym_template_type] = STATE(825),
    [sym_scoped_type_identifier] = STATE(826),
    [sym_scoped_namespace_identifier] = STATE(827),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2197),
    [anon_sym_unsigned] = ACTIONS(5067),
    [anon_sym_long] = ACTIONS(5067),
    [anon_sym_short] = ACTIONS(5067),
    [sym_primitive_type] = ACTIONS(5069),
    [anon_sym_enum] = ACTIONS(1582),
    [anon_sym_struct] = ACTIONS(2468),
    [anon_sym_union] = ACTIONS(2470),
    [sym_identifier] = ACTIONS(1588),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(2472),
    [sym_auto] = ACTIONS(5069),
    [anon_sym_typename] = ACTIONS(5071),
    [anon_sym_COLON_COLON] = ACTIONS(1594),
  },
  [1738] = {
    [sym_type_qualifier] = STATE(2198),
    [sym_trailing_return_type] = STATE(2198),
    [aux_sym_function_declarator_repeat1] = STATE(2198),
    [anon_sym_LPAREN] = ACTIONS(1596),
    [anon_sym_COMMA] = ACTIONS(1596),
    [anon_sym_LBRACE] = ACTIONS(1596),
    [anon_sym_LBRACK] = ACTIONS(1596),
    [anon_sym_EQ] = ACTIONS(1596),
    [anon_sym_const] = ACTIONS(612),
    [anon_sym_restrict] = ACTIONS(614),
    [anon_sym_volatile] = ACTIONS(614),
    [anon_sym__Atomic] = ACTIONS(614),
    [anon_sym_mutable] = ACTIONS(614),
    [anon_sym_explicit] = ACTIONS(614),
    [anon_sym_constexpr] = ACTIONS(614),
    [anon_sym_GT] = ACTIONS(1596),
    [anon_sym_DASH_GT] = ACTIONS(3829),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(5073),
  },
  [1739] = {
    [anon_sym_LPAREN] = ACTIONS(1807),
    [anon_sym_COMMA] = ACTIONS(1807),
    [anon_sym_LBRACE] = ACTIONS(1807),
    [anon_sym_LBRACK] = ACTIONS(1807),
    [anon_sym_EQ] = ACTIONS(1807),
    [anon_sym_LT] = ACTIONS(1807),
    [anon_sym_GT] = ACTIONS(1807),
    [sym_comment] = ACTIONS(49),
  },
  [1740] = {
    [sym__abstract_declarator] = STATE(2199),
    [sym_abstract_pointer_declarator] = STATE(2199),
    [sym_abstract_function_declarator] = STATE(2199),
    [sym_abstract_array_declarator] = STATE(2199),
    [sym_parameter_list] = STATE(1743),
    [sym_abstract_reference_declarator] = STATE(2199),
    [anon_sym_LPAREN] = ACTIONS(1115),
    [anon_sym_SEMI] = ACTIONS(2270),
    [anon_sym_STAR] = ACTIONS(3844),
    [anon_sym_LBRACK] = ACTIONS(1121),
    [anon_sym_const] = ACTIONS(4360),
    [anon_sym_restrict] = ACTIONS(2270),
    [anon_sym_volatile] = ACTIONS(2270),
    [anon_sym__Atomic] = ACTIONS(2270),
    [anon_sym_mutable] = ACTIONS(2270),
    [anon_sym_explicit] = ACTIONS(2270),
    [anon_sym_constexpr] = ACTIONS(2270),
    [anon_sym_AMP] = ACTIONS(3846),
    [anon_sym_AMP_AMP] = ACTIONS(3848),
    [anon_sym_DASH_GT] = ACTIONS(2270),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(2270),
  },
  [1741] = {
    [sym__abstract_declarator] = STATE(2200),
    [sym_abstract_pointer_declarator] = STATE(2200),
    [sym_abstract_function_declarator] = STATE(2200),
    [sym_abstract_array_declarator] = STATE(2200),
    [sym_parameter_list] = STATE(1743),
    [sym_abstract_reference_declarator] = STATE(2200),
    [anon_sym_LPAREN] = ACTIONS(1115),
    [anon_sym_SEMI] = ACTIONS(2278),
    [anon_sym_STAR] = ACTIONS(3844),
    [anon_sym_LBRACK] = ACTIONS(1121),
    [anon_sym_const] = ACTIONS(4362),
    [anon_sym_restrict] = ACTIONS(2278),
    [anon_sym_volatile] = ACTIONS(2278),
    [anon_sym__Atomic] = ACTIONS(2278),
    [anon_sym_mutable] = ACTIONS(2278),
    [anon_sym_explicit] = ACTIONS(2278),
    [anon_sym_constexpr] = ACTIONS(2278),
    [anon_sym_AMP] = ACTIONS(3846),
    [anon_sym_AMP_AMP] = ACTIONS(3848),
    [anon_sym_DASH_GT] = ACTIONS(2278),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(2278),
  },
  [1742] = {
    [sym_parameter_list] = STATE(2201),
    [anon_sym_LPAREN] = ACTIONS(206),
    [anon_sym_SEMI] = ACTIONS(4364),
    [anon_sym_LBRACK] = ACTIONS(2282),
    [anon_sym_const] = ACTIONS(4366),
    [anon_sym_restrict] = ACTIONS(4364),
    [anon_sym_volatile] = ACTIONS(4364),
    [anon_sym__Atomic] = ACTIONS(4364),
    [anon_sym_mutable] = ACTIONS(4364),
    [anon_sym_explicit] = ACTIONS(4364),
    [anon_sym_constexpr] = ACTIONS(4364),
    [anon_sym_DASH_GT] = ACTIONS(4364),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(4364),
  },
  [1743] = {
    [sym_type_qualifier] = STATE(2202),
    [sym_trailing_return_type] = STATE(1129),
    [aux_sym_abstract_function_declarator_repeat1] = STATE(2202),
    [anon_sym_LPAREN] = ACTIONS(2284),
    [anon_sym_SEMI] = ACTIONS(2284),
    [anon_sym_LBRACK] = ACTIONS(2284),
    [anon_sym_const] = ACTIONS(4368),
    [anon_sym_restrict] = ACTIONS(2284),
    [anon_sym_volatile] = ACTIONS(2284),
    [anon_sym__Atomic] = ACTIONS(2284),
    [anon_sym_mutable] = ACTIONS(2284),
    [anon_sym_explicit] = ACTIONS(2284),
    [anon_sym_constexpr] = ACTIONS(2284),
    [anon_sym_DASH_GT] = ACTIONS(2284),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(2284),
  },
  [1744] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(1744),
    [anon_sym_LPAREN] = ACTIONS(816),
    [anon_sym_SEMI] = ACTIONS(816),
    [anon_sym_STAR] = ACTIONS(816),
    [anon_sym_LBRACK] = ACTIONS(816),
    [anon_sym_const] = ACTIONS(818),
    [anon_sym_restrict] = ACTIONS(818),
    [anon_sym_volatile] = ACTIONS(818),
    [anon_sym__Atomic] = ACTIONS(818),
    [anon_sym_mutable] = ACTIONS(818),
    [anon_sym_explicit] = ACTIONS(818),
    [anon_sym_constexpr] = ACTIONS(818),
    [anon_sym_unsigned] = ACTIONS(5075),
    [anon_sym_long] = ACTIONS(5075),
    [anon_sym_short] = ACTIONS(5075),
    [sym_primitive_type] = ACTIONS(818),
    [anon_sym_AMP] = ACTIONS(818),
    [anon_sym_AMP_AMP] = ACTIONS(816),
    [anon_sym_DASH_GT] = ACTIONS(816),
    [sym_identifier] = ACTIONS(818),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(818),
  },
  [1745] = {
    [sym_parameter_list] = STATE(1747),
    [anon_sym_LPAREN] = ACTIONS(206),
    [anon_sym_SEMI] = ACTIONS(3750),
    [anon_sym_LBRACK] = ACTIONS(2282),
    [sym_comment] = ACTIONS(49),
  },
  [1746] = {
    [sym_parameter_list] = STATE(1747),
    [anon_sym_LPAREN] = ACTIONS(206),
    [anon_sym_SEMI] = ACTIONS(3762),
    [anon_sym_LBRACK] = ACTIONS(2282),
    [sym_comment] = ACTIONS(49),
  },
  [1747] = {
    [sym_type_qualifier] = STATE(2203),
    [sym_trailing_return_type] = STATE(1713),
    [aux_sym_abstract_function_declarator_repeat1] = STATE(2203),
    [anon_sym_LPAREN] = ACTIONS(3764),
    [anon_sym_SEMI] = ACTIONS(3764),
    [anon_sym_LBRACK] = ACTIONS(3764),
    [anon_sym_const] = ACTIONS(612),
    [anon_sym_restrict] = ACTIONS(614),
    [anon_sym_volatile] = ACTIONS(614),
    [anon_sym__Atomic] = ACTIONS(614),
    [anon_sym_mutable] = ACTIONS(614),
    [anon_sym_explicit] = ACTIONS(614),
    [anon_sym_constexpr] = ACTIONS(614),
    [anon_sym_DASH_GT] = ACTIONS(3858),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(5078),
  },
  [1748] = {
    [sym__type_specifier] = STATE(2204),
    [sym_sized_type_specifier] = STATE(2204),
    [sym_enum_specifier] = STATE(2204),
    [sym_struct_specifier] = STATE(2204),
    [sym_union_specifier] = STATE(2204),
    [sym_macro_type_specifier] = STATE(2204),
    [sym_class_specifier] = STATE(2204),
    [sym_dependent_type] = STATE(2204),
    [sym_template_type] = STATE(62),
    [sym_scoped_type_identifier] = STATE(34),
    [sym_scoped_namespace_identifier] = STATE(64),
    [aux_sym_sized_type_specifier_repeat1] = STATE(639),
    [anon_sym_unsigned] = ACTIONS(1231),
    [anon_sym_long] = ACTIONS(1231),
    [anon_sym_short] = ACTIONS(1231),
    [sym_primitive_type] = ACTIONS(5080),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(428),
    [anon_sym_union] = ACTIONS(430),
    [sym_identifier] = ACTIONS(434),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(436),
    [sym_auto] = ACTIONS(5080),
    [anon_sym_typename] = ACTIONS(1235),
    [anon_sym_COLON_COLON] = ACTIONS(111),
  },
  [1749] = {
    [sym_type_qualifier] = STATE(2205),
    [sym_trailing_return_type] = STATE(1713),
    [aux_sym_abstract_function_declarator_repeat1] = STATE(2205),
    [anon_sym_LPAREN] = ACTIONS(3764),
    [anon_sym_SEMI] = ACTIONS(3764),
    [anon_sym_LBRACK] = ACTIONS(3764),
    [anon_sym_const] = ACTIONS(612),
    [anon_sym_restrict] = ACTIONS(614),
    [anon_sym_volatile] = ACTIONS(614),
    [anon_sym__Atomic] = ACTIONS(614),
    [anon_sym_mutable] = ACTIONS(614),
    [anon_sym_explicit] = ACTIONS(614),
    [anon_sym_constexpr] = ACTIONS(614),
    [anon_sym_DASH_GT] = ACTIONS(3858),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(5082),
  },
  [1750] = {
    [sym_parameter_list] = STATE(1747),
    [anon_sym_LPAREN] = ACTIONS(206),
    [anon_sym_SEMI] = ACTIONS(3783),
    [anon_sym_LBRACK] = ACTIONS(2282),
    [sym_comment] = ACTIONS(49),
  },
  [1751] = {
    [anon_sym_LPAREN] = ACTIONS(1137),
    [anon_sym_COMMA] = ACTIONS(1137),
    [anon_sym_RPAREN] = ACTIONS(1137),
    [anon_sym_extern] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(1140),
    [anon_sym_STAR] = ACTIONS(4239),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [anon_sym_EQ] = ACTIONS(1148),
    [anon_sym_static] = ACTIONS(1142),
    [anon_sym_register] = ACTIONS(1142),
    [anon_sym_inline] = ACTIONS(1142),
    [anon_sym_const] = ACTIONS(1142),
    [anon_sym_restrict] = ACTIONS(1142),
    [anon_sym_volatile] = ACTIONS(1142),
    [anon_sym__Atomic] = ACTIONS(1142),
    [anon_sym_mutable] = ACTIONS(1142),
    [anon_sym_explicit] = ACTIONS(1142),
    [anon_sym_constexpr] = ACTIONS(1142),
    [anon_sym_QMARK] = ACTIONS(1146),
    [anon_sym_STAR_EQ] = ACTIONS(1146),
    [anon_sym_SLASH_EQ] = ACTIONS(1146),
    [anon_sym_PERCENT_EQ] = ACTIONS(1146),
    [anon_sym_PLUS_EQ] = ACTIONS(1146),
    [anon_sym_DASH_EQ] = ACTIONS(1146),
    [anon_sym_LT_LT_EQ] = ACTIONS(1146),
    [anon_sym_GT_GT_EQ] = ACTIONS(1146),
    [anon_sym_AMP_EQ] = ACTIONS(1146),
    [anon_sym_CARET_EQ] = ACTIONS(1146),
    [anon_sym_PIPE_EQ] = ACTIONS(1146),
    [anon_sym_AMP] = ACTIONS(4239),
    [anon_sym_PIPE_PIPE] = ACTIONS(1146),
    [anon_sym_AMP_AMP] = ACTIONS(1137),
    [anon_sym_PIPE] = ACTIONS(1148),
    [anon_sym_CARET] = ACTIONS(1148),
    [anon_sym_TILDE] = ACTIONS(1140),
    [anon_sym_EQ_EQ] = ACTIONS(1146),
    [anon_sym_BANG_EQ] = ACTIONS(1146),
    [anon_sym_LT] = ACTIONS(4239),
    [anon_sym_GT] = ACTIONS(1148),
    [anon_sym_LT_EQ] = ACTIONS(1146),
    [anon_sym_GT_EQ] = ACTIONS(1146),
    [anon_sym_LT_LT] = ACTIONS(1148),
    [anon_sym_GT_GT] = ACTIONS(1148),
    [anon_sym_PLUS] = ACTIONS(1148),
    [anon_sym_DASH] = ACTIONS(1148),
    [anon_sym_SLASH] = ACTIONS(1148),
    [anon_sym_PERCENT] = ACTIONS(1148),
    [anon_sym_DASH_DASH] = ACTIONS(1146),
    [anon_sym_PLUS_PLUS] = ACTIONS(1146),
    [anon_sym_DOT] = ACTIONS(1146),
    [anon_sym_DASH_GT] = ACTIONS(1146),
    [sym_identifier] = ACTIONS(1142),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(1144),
    [sym_operator_name] = ACTIONS(1140),
  },
  [1752] = {
    [sym_argument_list] = STATE(802),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_COMMA] = ACTIONS(5084),
    [anon_sym_RPAREN] = ACTIONS(5084),
    [anon_sym_STAR] = ACTIONS(2234),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_EQ] = ACTIONS(2236),
    [anon_sym_QMARK] = ACTIONS(2238),
    [anon_sym_STAR_EQ] = ACTIONS(2240),
    [anon_sym_SLASH_EQ] = ACTIONS(2240),
    [anon_sym_PERCENT_EQ] = ACTIONS(2240),
    [anon_sym_PLUS_EQ] = ACTIONS(2240),
    [anon_sym_DASH_EQ] = ACTIONS(2240),
    [anon_sym_LT_LT_EQ] = ACTIONS(2240),
    [anon_sym_GT_GT_EQ] = ACTIONS(2240),
    [anon_sym_AMP_EQ] = ACTIONS(2240),
    [anon_sym_CARET_EQ] = ACTIONS(2240),
    [anon_sym_PIPE_EQ] = ACTIONS(2240),
    [anon_sym_AMP] = ACTIONS(2242),
    [anon_sym_PIPE_PIPE] = ACTIONS(2244),
    [anon_sym_AMP_AMP] = ACTIONS(2246),
    [anon_sym_PIPE] = ACTIONS(2248),
    [anon_sym_CARET] = ACTIONS(2250),
    [anon_sym_EQ_EQ] = ACTIONS(2252),
    [anon_sym_BANG_EQ] = ACTIONS(2252),
    [anon_sym_LT] = ACTIONS(2254),
    [anon_sym_GT] = ACTIONS(2254),
    [anon_sym_LT_EQ] = ACTIONS(2256),
    [anon_sym_GT_EQ] = ACTIONS(2256),
    [anon_sym_LT_LT] = ACTIONS(2258),
    [anon_sym_GT_GT] = ACTIONS(2258),
    [anon_sym_PLUS] = ACTIONS(2260),
    [anon_sym_DASH] = ACTIONS(2260),
    [anon_sym_SLASH] = ACTIONS(2234),
    [anon_sym_PERCENT] = ACTIONS(2234),
    [anon_sym_DASH_DASH] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(1554),
    [anon_sym_DASH_GT] = ACTIONS(1554),
    [sym_comment] = ACTIONS(49),
  },
  [1753] = {
    [anon_sym_COMMA] = ACTIONS(5084),
    [anon_sym_RPAREN] = ACTIONS(5084),
    [sym_comment] = ACTIONS(49),
  },
  [1754] = {
    [anon_sym_LPAREN] = ACTIONS(5086),
    [anon_sym_COMMA] = ACTIONS(5086),
    [anon_sym_RPAREN] = ACTIONS(5086),
    [anon_sym_SEMI] = ACTIONS(5086),
    [anon_sym_LBRACE] = ACTIONS(5086),
    [anon_sym_RBRACE] = ACTIONS(5086),
    [anon_sym_STAR] = ACTIONS(5088),
    [anon_sym_LBRACK] = ACTIONS(5086),
    [anon_sym_RBRACK] = ACTIONS(5086),
    [anon_sym_EQ] = ACTIONS(5088),
    [anon_sym_COLON] = ACTIONS(5086),
    [anon_sym_QMARK] = ACTIONS(5086),
    [anon_sym_STAR_EQ] = ACTIONS(5086),
    [anon_sym_SLASH_EQ] = ACTIONS(5086),
    [anon_sym_PERCENT_EQ] = ACTIONS(5086),
    [anon_sym_PLUS_EQ] = ACTIONS(5086),
    [anon_sym_DASH_EQ] = ACTIONS(5086),
    [anon_sym_LT_LT_EQ] = ACTIONS(5086),
    [anon_sym_GT_GT_EQ] = ACTIONS(5086),
    [anon_sym_AMP_EQ] = ACTIONS(5086),
    [anon_sym_CARET_EQ] = ACTIONS(5086),
    [anon_sym_PIPE_EQ] = ACTIONS(5086),
    [anon_sym_AMP] = ACTIONS(5088),
    [anon_sym_PIPE_PIPE] = ACTIONS(5086),
    [anon_sym_AMP_AMP] = ACTIONS(5086),
    [anon_sym_PIPE] = ACTIONS(5088),
    [anon_sym_CARET] = ACTIONS(5088),
    [anon_sym_EQ_EQ] = ACTIONS(5086),
    [anon_sym_BANG_EQ] = ACTIONS(5086),
    [anon_sym_LT] = ACTIONS(5088),
    [anon_sym_GT] = ACTIONS(5088),
    [anon_sym_LT_EQ] = ACTIONS(5086),
    [anon_sym_GT_EQ] = ACTIONS(5086),
    [anon_sym_LT_LT] = ACTIONS(5088),
    [anon_sym_GT_GT] = ACTIONS(5088),
    [anon_sym_PLUS] = ACTIONS(5088),
    [anon_sym_DASH] = ACTIONS(5088),
    [anon_sym_SLASH] = ACTIONS(5088),
    [anon_sym_PERCENT] = ACTIONS(5088),
    [anon_sym_DASH_DASH] = ACTIONS(5086),
    [anon_sym_PLUS_PLUS] = ACTIONS(5086),
    [anon_sym_DOT] = ACTIONS(5086),
    [anon_sym_DASH_GT] = ACTIONS(5086),
    [sym_comment] = ACTIONS(49),
  },
  [1755] = {
    [aux_sym_argument_list_repeat1] = STATE(1755),
    [anon_sym_COMMA] = ACTIONS(5090),
    [anon_sym_RPAREN] = ACTIONS(5084),
    [sym_comment] = ACTIONS(49),
  },
  [1756] = {
    [anon_sym_LPAREN] = ACTIONS(1798),
    [anon_sym_COMMA] = ACTIONS(1798),
    [anon_sym_RPAREN] = ACTIONS(1798),
    [anon_sym_extern] = ACTIONS(1803),
    [anon_sym_LBRACE] = ACTIONS(1801),
    [anon_sym_STAR] = ACTIONS(4317),
    [anon_sym_LBRACK] = ACTIONS(1798),
    [anon_sym_EQ] = ACTIONS(1809),
    [anon_sym_static] = ACTIONS(1803),
    [anon_sym_register] = ACTIONS(1803),
    [anon_sym_inline] = ACTIONS(1803),
    [anon_sym_const] = ACTIONS(1803),
    [anon_sym_restrict] = ACTIONS(1803),
    [anon_sym_volatile] = ACTIONS(1803),
    [anon_sym__Atomic] = ACTIONS(1803),
    [anon_sym_mutable] = ACTIONS(1803),
    [anon_sym_explicit] = ACTIONS(1803),
    [anon_sym_constexpr] = ACTIONS(1803),
    [anon_sym_QMARK] = ACTIONS(1807),
    [anon_sym_STAR_EQ] = ACTIONS(1807),
    [anon_sym_SLASH_EQ] = ACTIONS(1807),
    [anon_sym_PERCENT_EQ] = ACTIONS(1807),
    [anon_sym_PLUS_EQ] = ACTIONS(1807),
    [anon_sym_DASH_EQ] = ACTIONS(1807),
    [anon_sym_LT_LT_EQ] = ACTIONS(1807),
    [anon_sym_GT_GT_EQ] = ACTIONS(1807),
    [anon_sym_AMP_EQ] = ACTIONS(1807),
    [anon_sym_CARET_EQ] = ACTIONS(1807),
    [anon_sym_PIPE_EQ] = ACTIONS(1807),
    [anon_sym_AMP] = ACTIONS(4317),
    [anon_sym_PIPE_PIPE] = ACTIONS(1807),
    [anon_sym_AMP_AMP] = ACTIONS(1798),
    [anon_sym_PIPE] = ACTIONS(1809),
    [anon_sym_CARET] = ACTIONS(1809),
    [anon_sym_TILDE] = ACTIONS(1801),
    [anon_sym_EQ_EQ] = ACTIONS(1807),
    [anon_sym_BANG_EQ] = ACTIONS(1807),
    [anon_sym_LT] = ACTIONS(4317),
    [anon_sym_GT] = ACTIONS(1809),
    [anon_sym_LT_EQ] = ACTIONS(1807),
    [anon_sym_GT_EQ] = ACTIONS(1807),
    [anon_sym_LT_LT] = ACTIONS(1809),
    [anon_sym_GT_GT] = ACTIONS(1809),
    [anon_sym_PLUS] = ACTIONS(1809),
    [anon_sym_DASH] = ACTIONS(1809),
    [anon_sym_SLASH] = ACTIONS(1809),
    [anon_sym_PERCENT] = ACTIONS(1809),
    [anon_sym_DASH_DASH] = ACTIONS(1807),
    [anon_sym_PLUS_PLUS] = ACTIONS(1807),
    [anon_sym_DOT] = ACTIONS(1807),
    [anon_sym_DASH_GT] = ACTIONS(1807),
    [sym_identifier] = ACTIONS(1803),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(1805),
    [sym_operator_name] = ACTIONS(1801),
  },
  [1757] = {
    [sym__expression] = STATE(1834),
    [sym_conditional_expression] = STATE(1834),
    [sym_assignment_expression] = STATE(1834),
    [sym_pointer_expression] = STATE(1834),
    [sym_logical_expression] = STATE(1834),
    [sym_bitwise_expression] = STATE(1834),
    [sym_equality_expression] = STATE(1834),
    [sym_relational_expression] = STATE(1834),
    [sym_shift_expression] = STATE(1834),
    [sym_math_expression] = STATE(1834),
    [sym_cast_expression] = STATE(1834),
    [sym_sizeof_expression] = STATE(1834),
    [sym_subscript_expression] = STATE(1834),
    [sym_call_expression] = STATE(1834),
    [sym_field_expression] = STATE(1834),
    [sym_compound_literal_expression] = STATE(1834),
    [sym_parenthesized_expression] = STATE(1834),
    [sym_initializer_list] = STATE(1835),
    [sym_concatenated_string] = STATE(1834),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(1834),
    [sym_new_expression] = STATE(1834),
    [sym_delete_expression] = STATE(1834),
    [sym_lambda_expression] = STATE(1834),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(4145),
    [anon_sym_LPAREN] = ACTIONS(1267),
    [anon_sym_LBRACE] = ACTIONS(548),
    [anon_sym_STAR] = ACTIONS(1275),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_AMP] = ACTIONS(1275),
    [anon_sym_BANG] = ACTIONS(1279),
    [anon_sym_TILDE] = ACTIONS(1281),
    [anon_sym_PLUS] = ACTIONS(1283),
    [anon_sym_DASH] = ACTIONS(1283),
    [anon_sym_DASH_DASH] = ACTIONS(1285),
    [anon_sym_PLUS_PLUS] = ACTIONS(1285),
    [anon_sym_sizeof] = ACTIONS(1287),
    [sym_number_literal] = ACTIONS(4145),
    [sym_char_literal] = ACTIONS(4145),
    [sym_string_literal] = ACTIONS(1291),
    [sym_true] = ACTIONS(4147),
    [sym_false] = ACTIONS(4147),
    [sym_null] = ACTIONS(4147),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(2402),
    [anon_sym_delete] = ACTIONS(1297),
    [sym_nullptr] = ACTIONS(4147),
  },
  [1758] = {
    [anon_sym_LPAREN] = ACTIONS(4168),
    [anon_sym_STAR] = ACTIONS(4168),
    [anon_sym_LBRACK] = ACTIONS(4168),
    [anon_sym_EQ] = ACTIONS(5093),
    [anon_sym_AMP] = ACTIONS(4170),
    [anon_sym_AMP_AMP] = ACTIONS(4168),
    [anon_sym_DOT] = ACTIONS(5093),
    [sym_comment] = ACTIONS(49),
  },
  [1759] = {
    [anon_sym_RPAREN] = ACTIONS(5095),
    [sym_comment] = ACTIONS(49),
  },
  [1760] = {
    [aux_sym_concatenated_string_repeat1] = STATE(1760),
    [anon_sym_LPAREN] = ACTIONS(4230),
    [anon_sym_COMMA] = ACTIONS(4230),
    [anon_sym_SEMI] = ACTIONS(4230),
    [anon_sym_RBRACE] = ACTIONS(4230),
    [anon_sym_STAR] = ACTIONS(4232),
    [anon_sym_LBRACK] = ACTIONS(4230),
    [anon_sym_EQ] = ACTIONS(4232),
    [anon_sym_QMARK] = ACTIONS(4230),
    [anon_sym_STAR_EQ] = ACTIONS(4230),
    [anon_sym_SLASH_EQ] = ACTIONS(4230),
    [anon_sym_PERCENT_EQ] = ACTIONS(4230),
    [anon_sym_PLUS_EQ] = ACTIONS(4230),
    [anon_sym_DASH_EQ] = ACTIONS(4230),
    [anon_sym_LT_LT_EQ] = ACTIONS(4230),
    [anon_sym_GT_GT_EQ] = ACTIONS(4230),
    [anon_sym_AMP_EQ] = ACTIONS(4230),
    [anon_sym_CARET_EQ] = ACTIONS(4230),
    [anon_sym_PIPE_EQ] = ACTIONS(4230),
    [anon_sym_AMP] = ACTIONS(4232),
    [anon_sym_PIPE_PIPE] = ACTIONS(4230),
    [anon_sym_AMP_AMP] = ACTIONS(4230),
    [anon_sym_PIPE] = ACTIONS(4232),
    [anon_sym_CARET] = ACTIONS(4232),
    [anon_sym_EQ_EQ] = ACTIONS(4230),
    [anon_sym_BANG_EQ] = ACTIONS(4230),
    [anon_sym_LT] = ACTIONS(4232),
    [anon_sym_GT] = ACTIONS(4232),
    [anon_sym_LT_EQ] = ACTIONS(4230),
    [anon_sym_GT_EQ] = ACTIONS(4230),
    [anon_sym_LT_LT] = ACTIONS(4232),
    [anon_sym_GT_GT] = ACTIONS(4232),
    [anon_sym_PLUS] = ACTIONS(4232),
    [anon_sym_DASH] = ACTIONS(4232),
    [anon_sym_SLASH] = ACTIONS(4232),
    [anon_sym_PERCENT] = ACTIONS(4232),
    [anon_sym_DASH_DASH] = ACTIONS(4230),
    [anon_sym_PLUS_PLUS] = ACTIONS(4230),
    [anon_sym_DOT] = ACTIONS(4230),
    [anon_sym_DASH_GT] = ACTIONS(4230),
    [sym_string_literal] = ACTIONS(5097),
    [sym_comment] = ACTIONS(49),
  },
  [1761] = {
    [sym__expression] = STATE(740),
    [sym_conditional_expression] = STATE(740),
    [sym_assignment_expression] = STATE(740),
    [sym_pointer_expression] = STATE(740),
    [sym_logical_expression] = STATE(740),
    [sym_bitwise_expression] = STATE(740),
    [sym_equality_expression] = STATE(740),
    [sym_relational_expression] = STATE(740),
    [sym_shift_expression] = STATE(740),
    [sym_math_expression] = STATE(740),
    [sym_cast_expression] = STATE(740),
    [sym_sizeof_expression] = STATE(740),
    [sym_subscript_expression] = STATE(740),
    [sym_call_expression] = STATE(740),
    [sym_field_expression] = STATE(740),
    [sym_compound_literal_expression] = STATE(740),
    [sym_parenthesized_expression] = STATE(740),
    [sym_concatenated_string] = STATE(740),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(740),
    [sym_new_expression] = STATE(740),
    [sym_delete_expression] = STATE(740),
    [sym_lambda_expression] = STATE(740),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_lambda_default_capture] = STATE(741),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(1417),
    [anon_sym_LPAREN] = ACTIONS(1419),
    [anon_sym_STAR] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_RBRACK] = ACTIONS(5100),
    [anon_sym_EQ] = ACTIONS(1425),
    [anon_sym_AMP] = ACTIONS(1427),
    [anon_sym_BANG] = ACTIONS(1429),
    [anon_sym_TILDE] = ACTIONS(1431),
    [anon_sym_PLUS] = ACTIONS(1433),
    [anon_sym_DASH] = ACTIONS(1433),
    [anon_sym_DASH_DASH] = ACTIONS(1435),
    [anon_sym_PLUS_PLUS] = ACTIONS(1435),
    [anon_sym_sizeof] = ACTIONS(1437),
    [sym_number_literal] = ACTIONS(1417),
    [sym_char_literal] = ACTIONS(1417),
    [sym_string_literal] = ACTIONS(1439),
    [sym_true] = ACTIONS(1441),
    [sym_false] = ACTIONS(1441),
    [sym_null] = ACTIONS(1441),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1443),
    [anon_sym_delete] = ACTIONS(1445),
    [sym_nullptr] = ACTIONS(1441),
  },
  [1762] = {
    [sym_argument_list] = STATE(802),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_COMMA] = ACTIONS(4258),
    [anon_sym_SEMI] = ACTIONS(4258),
    [anon_sym_RBRACE] = ACTIONS(4258),
    [anon_sym_STAR] = ACTIONS(2428),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_EQ] = ACTIONS(4260),
    [anon_sym_QMARK] = ACTIONS(4258),
    [anon_sym_STAR_EQ] = ACTIONS(4258),
    [anon_sym_SLASH_EQ] = ACTIONS(4258),
    [anon_sym_PERCENT_EQ] = ACTIONS(4258),
    [anon_sym_PLUS_EQ] = ACTIONS(4258),
    [anon_sym_DASH_EQ] = ACTIONS(4258),
    [anon_sym_LT_LT_EQ] = ACTIONS(4258),
    [anon_sym_GT_GT_EQ] = ACTIONS(4258),
    [anon_sym_AMP_EQ] = ACTIONS(4258),
    [anon_sym_CARET_EQ] = ACTIONS(4258),
    [anon_sym_PIPE_EQ] = ACTIONS(4258),
    [anon_sym_AMP] = ACTIONS(2436),
    [anon_sym_PIPE_PIPE] = ACTIONS(2438),
    [anon_sym_AMP_AMP] = ACTIONS(2440),
    [anon_sym_PIPE] = ACTIONS(2442),
    [anon_sym_CARET] = ACTIONS(2444),
    [anon_sym_EQ_EQ] = ACTIONS(2446),
    [anon_sym_BANG_EQ] = ACTIONS(2446),
    [anon_sym_LT] = ACTIONS(2448),
    [anon_sym_GT] = ACTIONS(2448),
    [anon_sym_LT_EQ] = ACTIONS(2450),
    [anon_sym_GT_EQ] = ACTIONS(2450),
    [anon_sym_LT_LT] = ACTIONS(2452),
    [anon_sym_GT_GT] = ACTIONS(2452),
    [anon_sym_PLUS] = ACTIONS(2454),
    [anon_sym_DASH] = ACTIONS(2454),
    [anon_sym_SLASH] = ACTIONS(2428),
    [anon_sym_PERCENT] = ACTIONS(2428),
    [anon_sym_DASH_DASH] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(1554),
    [anon_sym_DASH_GT] = ACTIONS(1554),
    [sym_comment] = ACTIONS(49),
  },
  [1763] = {
    [sym__expression] = STATE(2208),
    [sym_conditional_expression] = STATE(2208),
    [sym_assignment_expression] = STATE(2208),
    [sym_pointer_expression] = STATE(2208),
    [sym_logical_expression] = STATE(2208),
    [sym_bitwise_expression] = STATE(2208),
    [sym_equality_expression] = STATE(2208),
    [sym_relational_expression] = STATE(2208),
    [sym_shift_expression] = STATE(2208),
    [sym_math_expression] = STATE(2208),
    [sym_cast_expression] = STATE(2208),
    [sym_sizeof_expression] = STATE(2208),
    [sym_subscript_expression] = STATE(2208),
    [sym_call_expression] = STATE(2208),
    [sym_field_expression] = STATE(2208),
    [sym_compound_literal_expression] = STATE(2208),
    [sym_parenthesized_expression] = STATE(2208),
    [sym_concatenated_string] = STATE(2208),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(2208),
    [sym_new_expression] = STATE(2208),
    [sym_delete_expression] = STATE(2208),
    [sym_lambda_expression] = STATE(2208),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(5102),
    [anon_sym_LPAREN] = ACTIONS(2624),
    [anon_sym_STAR] = ACTIONS(2624),
    [anon_sym_LBRACK] = ACTIONS(2624),
    [anon_sym_AMP] = ACTIONS(2626),
    [anon_sym_AMP_AMP] = ACTIONS(2624),
    [anon_sym_BANG] = ACTIONS(1279),
    [anon_sym_TILDE] = ACTIONS(1281),
    [anon_sym_PLUS] = ACTIONS(1283),
    [anon_sym_DASH] = ACTIONS(1283),
    [anon_sym_DASH_DASH] = ACTIONS(1285),
    [anon_sym_PLUS_PLUS] = ACTIONS(1285),
    [anon_sym_sizeof] = ACTIONS(1287),
    [sym_number_literal] = ACTIONS(5102),
    [sym_char_literal] = ACTIONS(5102),
    [sym_string_literal] = ACTIONS(1291),
    [sym_true] = ACTIONS(5104),
    [sym_false] = ACTIONS(5104),
    [sym_null] = ACTIONS(5104),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(2402),
    [anon_sym_delete] = ACTIONS(1297),
    [sym_nullptr] = ACTIONS(5104),
  },
  [1764] = {
    [anon_sym_LPAREN] = ACTIONS(5106),
    [anon_sym_COMMA] = ACTIONS(5106),
    [anon_sym_RPAREN] = ACTIONS(5106),
    [anon_sym_SEMI] = ACTIONS(5106),
    [anon_sym_LBRACE] = ACTIONS(5106),
    [anon_sym_RBRACE] = ACTIONS(5106),
    [anon_sym_STAR] = ACTIONS(5108),
    [anon_sym_LBRACK] = ACTIONS(5106),
    [anon_sym_RBRACK] = ACTIONS(5106),
    [anon_sym_EQ] = ACTIONS(5108),
    [anon_sym_COLON] = ACTIONS(5106),
    [anon_sym_QMARK] = ACTIONS(5106),
    [anon_sym_STAR_EQ] = ACTIONS(5106),
    [anon_sym_SLASH_EQ] = ACTIONS(5106),
    [anon_sym_PERCENT_EQ] = ACTIONS(5106),
    [anon_sym_PLUS_EQ] = ACTIONS(5106),
    [anon_sym_DASH_EQ] = ACTIONS(5106),
    [anon_sym_LT_LT_EQ] = ACTIONS(5106),
    [anon_sym_GT_GT_EQ] = ACTIONS(5106),
    [anon_sym_AMP_EQ] = ACTIONS(5106),
    [anon_sym_CARET_EQ] = ACTIONS(5106),
    [anon_sym_PIPE_EQ] = ACTIONS(5106),
    [anon_sym_AMP] = ACTIONS(5108),
    [anon_sym_PIPE_PIPE] = ACTIONS(5106),
    [anon_sym_AMP_AMP] = ACTIONS(5106),
    [anon_sym_PIPE] = ACTIONS(5108),
    [anon_sym_CARET] = ACTIONS(5108),
    [anon_sym_EQ_EQ] = ACTIONS(5106),
    [anon_sym_BANG_EQ] = ACTIONS(5106),
    [anon_sym_LT] = ACTIONS(5108),
    [anon_sym_GT] = ACTIONS(5108),
    [anon_sym_LT_EQ] = ACTIONS(5106),
    [anon_sym_GT_EQ] = ACTIONS(5106),
    [anon_sym_LT_LT] = ACTIONS(5108),
    [anon_sym_GT_GT] = ACTIONS(5108),
    [anon_sym_PLUS] = ACTIONS(5108),
    [anon_sym_DASH] = ACTIONS(5108),
    [anon_sym_SLASH] = ACTIONS(5108),
    [anon_sym_PERCENT] = ACTIONS(5108),
    [anon_sym_DASH_DASH] = ACTIONS(5106),
    [anon_sym_PLUS_PLUS] = ACTIONS(5106),
    [anon_sym_DOT] = ACTIONS(5106),
    [anon_sym_DASH_GT] = ACTIONS(5106),
    [sym_comment] = ACTIONS(49),
  },
  [1765] = {
    [sym_argument_list] = STATE(802),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_COMMA] = ACTIONS(5110),
    [anon_sym_SEMI] = ACTIONS(4734),
    [anon_sym_RBRACE] = ACTIONS(5113),
    [anon_sym_STAR] = ACTIONS(2428),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_EQ] = ACTIONS(2430),
    [anon_sym_QMARK] = ACTIONS(2432),
    [anon_sym_STAR_EQ] = ACTIONS(2434),
    [anon_sym_SLASH_EQ] = ACTIONS(2434),
    [anon_sym_PERCENT_EQ] = ACTIONS(2434),
    [anon_sym_PLUS_EQ] = ACTIONS(2434),
    [anon_sym_DASH_EQ] = ACTIONS(2434),
    [anon_sym_LT_LT_EQ] = ACTIONS(2434),
    [anon_sym_GT_GT_EQ] = ACTIONS(2434),
    [anon_sym_AMP_EQ] = ACTIONS(2434),
    [anon_sym_CARET_EQ] = ACTIONS(2434),
    [anon_sym_PIPE_EQ] = ACTIONS(2434),
    [anon_sym_AMP] = ACTIONS(2436),
    [anon_sym_PIPE_PIPE] = ACTIONS(2438),
    [anon_sym_AMP_AMP] = ACTIONS(2440),
    [anon_sym_PIPE] = ACTIONS(2442),
    [anon_sym_CARET] = ACTIONS(2444),
    [anon_sym_EQ_EQ] = ACTIONS(2446),
    [anon_sym_BANG_EQ] = ACTIONS(2446),
    [anon_sym_LT] = ACTIONS(2448),
    [anon_sym_GT] = ACTIONS(2448),
    [anon_sym_LT_EQ] = ACTIONS(2450),
    [anon_sym_GT_EQ] = ACTIONS(2450),
    [anon_sym_LT_LT] = ACTIONS(2452),
    [anon_sym_GT_GT] = ACTIONS(2452),
    [anon_sym_PLUS] = ACTIONS(2454),
    [anon_sym_DASH] = ACTIONS(2454),
    [anon_sym_SLASH] = ACTIONS(2428),
    [anon_sym_PERCENT] = ACTIONS(2428),
    [anon_sym_DASH_DASH] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(1554),
    [anon_sym_DASH_GT] = ACTIONS(1554),
    [sym_comment] = ACTIONS(49),
  },
  [1766] = {
    [anon_sym_COMMA] = ACTIONS(5113),
    [anon_sym_RBRACE] = ACTIONS(5113),
    [sym_comment] = ACTIONS(49),
  },
  [1767] = {
    [sym_argument_list] = STATE(802),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_COMMA] = ACTIONS(4280),
    [anon_sym_SEMI] = ACTIONS(4280),
    [anon_sym_RBRACE] = ACTIONS(4280),
    [anon_sym_STAR] = ACTIONS(2428),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_EQ] = ACTIONS(2430),
    [anon_sym_QMARK] = ACTIONS(4280),
    [anon_sym_STAR_EQ] = ACTIONS(2434),
    [anon_sym_SLASH_EQ] = ACTIONS(2434),
    [anon_sym_PERCENT_EQ] = ACTIONS(2434),
    [anon_sym_PLUS_EQ] = ACTIONS(2434),
    [anon_sym_DASH_EQ] = ACTIONS(2434),
    [anon_sym_LT_LT_EQ] = ACTIONS(2434),
    [anon_sym_GT_GT_EQ] = ACTIONS(2434),
    [anon_sym_AMP_EQ] = ACTIONS(2434),
    [anon_sym_CARET_EQ] = ACTIONS(2434),
    [anon_sym_PIPE_EQ] = ACTIONS(2434),
    [anon_sym_AMP] = ACTIONS(2436),
    [anon_sym_PIPE_PIPE] = ACTIONS(2438),
    [anon_sym_AMP_AMP] = ACTIONS(2440),
    [anon_sym_PIPE] = ACTIONS(2442),
    [anon_sym_CARET] = ACTIONS(2444),
    [anon_sym_EQ_EQ] = ACTIONS(2446),
    [anon_sym_BANG_EQ] = ACTIONS(2446),
    [anon_sym_LT] = ACTIONS(2448),
    [anon_sym_GT] = ACTIONS(2448),
    [anon_sym_LT_EQ] = ACTIONS(2450),
    [anon_sym_GT_EQ] = ACTIONS(2450),
    [anon_sym_LT_LT] = ACTIONS(2452),
    [anon_sym_GT_GT] = ACTIONS(2452),
    [anon_sym_PLUS] = ACTIONS(2454),
    [anon_sym_DASH] = ACTIONS(2454),
    [anon_sym_SLASH] = ACTIONS(2428),
    [anon_sym_PERCENT] = ACTIONS(2428),
    [anon_sym_DASH_DASH] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(1554),
    [anon_sym_DASH_GT] = ACTIONS(1554),
    [sym_comment] = ACTIONS(49),
  },
  [1768] = {
    [sym_argument_list] = STATE(802),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_STAR] = ACTIONS(3003),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_EQ] = ACTIONS(3005),
    [anon_sym_COLON] = ACTIONS(5115),
    [anon_sym_QMARK] = ACTIONS(3009),
    [anon_sym_STAR_EQ] = ACTIONS(3011),
    [anon_sym_SLASH_EQ] = ACTIONS(3011),
    [anon_sym_PERCENT_EQ] = ACTIONS(3011),
    [anon_sym_PLUS_EQ] = ACTIONS(3011),
    [anon_sym_DASH_EQ] = ACTIONS(3011),
    [anon_sym_LT_LT_EQ] = ACTIONS(3011),
    [anon_sym_GT_GT_EQ] = ACTIONS(3011),
    [anon_sym_AMP_EQ] = ACTIONS(3011),
    [anon_sym_CARET_EQ] = ACTIONS(3011),
    [anon_sym_PIPE_EQ] = ACTIONS(3011),
    [anon_sym_AMP] = ACTIONS(3013),
    [anon_sym_PIPE_PIPE] = ACTIONS(3015),
    [anon_sym_AMP_AMP] = ACTIONS(3017),
    [anon_sym_PIPE] = ACTIONS(3019),
    [anon_sym_CARET] = ACTIONS(3021),
    [anon_sym_EQ_EQ] = ACTIONS(3023),
    [anon_sym_BANG_EQ] = ACTIONS(3023),
    [anon_sym_LT] = ACTIONS(3025),
    [anon_sym_GT] = ACTIONS(3025),
    [anon_sym_LT_EQ] = ACTIONS(3027),
    [anon_sym_GT_EQ] = ACTIONS(3027),
    [anon_sym_LT_LT] = ACTIONS(3029),
    [anon_sym_GT_GT] = ACTIONS(3029),
    [anon_sym_PLUS] = ACTIONS(3031),
    [anon_sym_DASH] = ACTIONS(3031),
    [anon_sym_SLASH] = ACTIONS(3003),
    [anon_sym_PERCENT] = ACTIONS(3003),
    [anon_sym_DASH_DASH] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(3033),
    [anon_sym_DASH_GT] = ACTIONS(3033),
    [sym_comment] = ACTIONS(49),
  },
  [1769] = {
    [sym_argument_list] = STATE(802),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_COMMA] = ACTIONS(4284),
    [anon_sym_SEMI] = ACTIONS(4284),
    [anon_sym_RBRACE] = ACTIONS(4284),
    [anon_sym_STAR] = ACTIONS(2428),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_EQ] = ACTIONS(4286),
    [anon_sym_QMARK] = ACTIONS(4284),
    [anon_sym_STAR_EQ] = ACTIONS(4284),
    [anon_sym_SLASH_EQ] = ACTIONS(4284),
    [anon_sym_PERCENT_EQ] = ACTIONS(4284),
    [anon_sym_PLUS_EQ] = ACTIONS(4284),
    [anon_sym_DASH_EQ] = ACTIONS(4284),
    [anon_sym_LT_LT_EQ] = ACTIONS(4284),
    [anon_sym_GT_GT_EQ] = ACTIONS(4284),
    [anon_sym_AMP_EQ] = ACTIONS(4284),
    [anon_sym_CARET_EQ] = ACTIONS(4284),
    [anon_sym_PIPE_EQ] = ACTIONS(4284),
    [anon_sym_AMP] = ACTIONS(4286),
    [anon_sym_PIPE_PIPE] = ACTIONS(4284),
    [anon_sym_AMP_AMP] = ACTIONS(4284),
    [anon_sym_PIPE] = ACTIONS(4286),
    [anon_sym_CARET] = ACTIONS(4286),
    [anon_sym_EQ_EQ] = ACTIONS(2446),
    [anon_sym_BANG_EQ] = ACTIONS(2446),
    [anon_sym_LT] = ACTIONS(2448),
    [anon_sym_GT] = ACTIONS(2448),
    [anon_sym_LT_EQ] = ACTIONS(2450),
    [anon_sym_GT_EQ] = ACTIONS(2450),
    [anon_sym_LT_LT] = ACTIONS(2452),
    [anon_sym_GT_GT] = ACTIONS(2452),
    [anon_sym_PLUS] = ACTIONS(2454),
    [anon_sym_DASH] = ACTIONS(2454),
    [anon_sym_SLASH] = ACTIONS(2428),
    [anon_sym_PERCENT] = ACTIONS(2428),
    [anon_sym_DASH_DASH] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(1554),
    [anon_sym_DASH_GT] = ACTIONS(1554),
    [sym_comment] = ACTIONS(49),
  },
  [1770] = {
    [sym_argument_list] = STATE(802),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_COMMA] = ACTIONS(4288),
    [anon_sym_SEMI] = ACTIONS(4288),
    [anon_sym_RBRACE] = ACTIONS(4288),
    [anon_sym_STAR] = ACTIONS(2428),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_EQ] = ACTIONS(4290),
    [anon_sym_QMARK] = ACTIONS(4288),
    [anon_sym_STAR_EQ] = ACTIONS(4288),
    [anon_sym_SLASH_EQ] = ACTIONS(4288),
    [anon_sym_PERCENT_EQ] = ACTIONS(4288),
    [anon_sym_PLUS_EQ] = ACTIONS(4288),
    [anon_sym_DASH_EQ] = ACTIONS(4288),
    [anon_sym_LT_LT_EQ] = ACTIONS(4288),
    [anon_sym_GT_GT_EQ] = ACTIONS(4288),
    [anon_sym_AMP_EQ] = ACTIONS(4288),
    [anon_sym_CARET_EQ] = ACTIONS(4288),
    [anon_sym_PIPE_EQ] = ACTIONS(4288),
    [anon_sym_AMP] = ACTIONS(2436),
    [anon_sym_PIPE_PIPE] = ACTIONS(4288),
    [anon_sym_AMP_AMP] = ACTIONS(2440),
    [anon_sym_PIPE] = ACTIONS(2442),
    [anon_sym_CARET] = ACTIONS(2444),
    [anon_sym_EQ_EQ] = ACTIONS(2446),
    [anon_sym_BANG_EQ] = ACTIONS(2446),
    [anon_sym_LT] = ACTIONS(2448),
    [anon_sym_GT] = ACTIONS(2448),
    [anon_sym_LT_EQ] = ACTIONS(2450),
    [anon_sym_GT_EQ] = ACTIONS(2450),
    [anon_sym_LT_LT] = ACTIONS(2452),
    [anon_sym_GT_GT] = ACTIONS(2452),
    [anon_sym_PLUS] = ACTIONS(2454),
    [anon_sym_DASH] = ACTIONS(2454),
    [anon_sym_SLASH] = ACTIONS(2428),
    [anon_sym_PERCENT] = ACTIONS(2428),
    [anon_sym_DASH_DASH] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(1554),
    [anon_sym_DASH_GT] = ACTIONS(1554),
    [sym_comment] = ACTIONS(49),
  },
  [1771] = {
    [sym_argument_list] = STATE(802),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_COMMA] = ACTIONS(4288),
    [anon_sym_SEMI] = ACTIONS(4288),
    [anon_sym_RBRACE] = ACTIONS(4288),
    [anon_sym_STAR] = ACTIONS(2428),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_EQ] = ACTIONS(4290),
    [anon_sym_QMARK] = ACTIONS(4288),
    [anon_sym_STAR_EQ] = ACTIONS(4288),
    [anon_sym_SLASH_EQ] = ACTIONS(4288),
    [anon_sym_PERCENT_EQ] = ACTIONS(4288),
    [anon_sym_PLUS_EQ] = ACTIONS(4288),
    [anon_sym_DASH_EQ] = ACTIONS(4288),
    [anon_sym_LT_LT_EQ] = ACTIONS(4288),
    [anon_sym_GT_GT_EQ] = ACTIONS(4288),
    [anon_sym_AMP_EQ] = ACTIONS(4288),
    [anon_sym_CARET_EQ] = ACTIONS(4288),
    [anon_sym_PIPE_EQ] = ACTIONS(4288),
    [anon_sym_AMP] = ACTIONS(2436),
    [anon_sym_PIPE_PIPE] = ACTIONS(4288),
    [anon_sym_AMP_AMP] = ACTIONS(4288),
    [anon_sym_PIPE] = ACTIONS(2442),
    [anon_sym_CARET] = ACTIONS(2444),
    [anon_sym_EQ_EQ] = ACTIONS(2446),
    [anon_sym_BANG_EQ] = ACTIONS(2446),
    [anon_sym_LT] = ACTIONS(2448),
    [anon_sym_GT] = ACTIONS(2448),
    [anon_sym_LT_EQ] = ACTIONS(2450),
    [anon_sym_GT_EQ] = ACTIONS(2450),
    [anon_sym_LT_LT] = ACTIONS(2452),
    [anon_sym_GT_GT] = ACTIONS(2452),
    [anon_sym_PLUS] = ACTIONS(2454),
    [anon_sym_DASH] = ACTIONS(2454),
    [anon_sym_SLASH] = ACTIONS(2428),
    [anon_sym_PERCENT] = ACTIONS(2428),
    [anon_sym_DASH_DASH] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(1554),
    [anon_sym_DASH_GT] = ACTIONS(1554),
    [sym_comment] = ACTIONS(49),
  },
  [1772] = {
    [sym_argument_list] = STATE(802),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_COMMA] = ACTIONS(4284),
    [anon_sym_SEMI] = ACTIONS(4284),
    [anon_sym_RBRACE] = ACTIONS(4284),
    [anon_sym_STAR] = ACTIONS(2428),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_EQ] = ACTIONS(4286),
    [anon_sym_QMARK] = ACTIONS(4284),
    [anon_sym_STAR_EQ] = ACTIONS(4284),
    [anon_sym_SLASH_EQ] = ACTIONS(4284),
    [anon_sym_PERCENT_EQ] = ACTIONS(4284),
    [anon_sym_PLUS_EQ] = ACTIONS(4284),
    [anon_sym_DASH_EQ] = ACTIONS(4284),
    [anon_sym_LT_LT_EQ] = ACTIONS(4284),
    [anon_sym_GT_GT_EQ] = ACTIONS(4284),
    [anon_sym_AMP_EQ] = ACTIONS(4284),
    [anon_sym_CARET_EQ] = ACTIONS(4284),
    [anon_sym_PIPE_EQ] = ACTIONS(4284),
    [anon_sym_AMP] = ACTIONS(2436),
    [anon_sym_PIPE_PIPE] = ACTIONS(4284),
    [anon_sym_AMP_AMP] = ACTIONS(4284),
    [anon_sym_PIPE] = ACTIONS(4286),
    [anon_sym_CARET] = ACTIONS(2444),
    [anon_sym_EQ_EQ] = ACTIONS(2446),
    [anon_sym_BANG_EQ] = ACTIONS(2446),
    [anon_sym_LT] = ACTIONS(2448),
    [anon_sym_GT] = ACTIONS(2448),
    [anon_sym_LT_EQ] = ACTIONS(2450),
    [anon_sym_GT_EQ] = ACTIONS(2450),
    [anon_sym_LT_LT] = ACTIONS(2452),
    [anon_sym_GT_GT] = ACTIONS(2452),
    [anon_sym_PLUS] = ACTIONS(2454),
    [anon_sym_DASH] = ACTIONS(2454),
    [anon_sym_SLASH] = ACTIONS(2428),
    [anon_sym_PERCENT] = ACTIONS(2428),
    [anon_sym_DASH_DASH] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(1554),
    [anon_sym_DASH_GT] = ACTIONS(1554),
    [sym_comment] = ACTIONS(49),
  },
  [1773] = {
    [sym_argument_list] = STATE(802),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_COMMA] = ACTIONS(4284),
    [anon_sym_SEMI] = ACTIONS(4284),
    [anon_sym_RBRACE] = ACTIONS(4284),
    [anon_sym_STAR] = ACTIONS(2428),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_EQ] = ACTIONS(4286),
    [anon_sym_QMARK] = ACTIONS(4284),
    [anon_sym_STAR_EQ] = ACTIONS(4284),
    [anon_sym_SLASH_EQ] = ACTIONS(4284),
    [anon_sym_PERCENT_EQ] = ACTIONS(4284),
    [anon_sym_PLUS_EQ] = ACTIONS(4284),
    [anon_sym_DASH_EQ] = ACTIONS(4284),
    [anon_sym_LT_LT_EQ] = ACTIONS(4284),
    [anon_sym_GT_GT_EQ] = ACTIONS(4284),
    [anon_sym_AMP_EQ] = ACTIONS(4284),
    [anon_sym_CARET_EQ] = ACTIONS(4284),
    [anon_sym_PIPE_EQ] = ACTIONS(4284),
    [anon_sym_AMP] = ACTIONS(2436),
    [anon_sym_PIPE_PIPE] = ACTIONS(4284),
    [anon_sym_AMP_AMP] = ACTIONS(4284),
    [anon_sym_PIPE] = ACTIONS(4286),
    [anon_sym_CARET] = ACTIONS(4286),
    [anon_sym_EQ_EQ] = ACTIONS(2446),
    [anon_sym_BANG_EQ] = ACTIONS(2446),
    [anon_sym_LT] = ACTIONS(2448),
    [anon_sym_GT] = ACTIONS(2448),
    [anon_sym_LT_EQ] = ACTIONS(2450),
    [anon_sym_GT_EQ] = ACTIONS(2450),
    [anon_sym_LT_LT] = ACTIONS(2452),
    [anon_sym_GT_GT] = ACTIONS(2452),
    [anon_sym_PLUS] = ACTIONS(2454),
    [anon_sym_DASH] = ACTIONS(2454),
    [anon_sym_SLASH] = ACTIONS(2428),
    [anon_sym_PERCENT] = ACTIONS(2428),
    [anon_sym_DASH_DASH] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(1554),
    [anon_sym_DASH_GT] = ACTIONS(1554),
    [sym_comment] = ACTIONS(49),
  },
  [1774] = {
    [sym_argument_list] = STATE(802),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_COMMA] = ACTIONS(4292),
    [anon_sym_SEMI] = ACTIONS(4292),
    [anon_sym_RBRACE] = ACTIONS(4292),
    [anon_sym_STAR] = ACTIONS(2428),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_EQ] = ACTIONS(4294),
    [anon_sym_QMARK] = ACTIONS(4292),
    [anon_sym_STAR_EQ] = ACTIONS(4292),
    [anon_sym_SLASH_EQ] = ACTIONS(4292),
    [anon_sym_PERCENT_EQ] = ACTIONS(4292),
    [anon_sym_PLUS_EQ] = ACTIONS(4292),
    [anon_sym_DASH_EQ] = ACTIONS(4292),
    [anon_sym_LT_LT_EQ] = ACTIONS(4292),
    [anon_sym_GT_GT_EQ] = ACTIONS(4292),
    [anon_sym_AMP_EQ] = ACTIONS(4292),
    [anon_sym_CARET_EQ] = ACTIONS(4292),
    [anon_sym_PIPE_EQ] = ACTIONS(4292),
    [anon_sym_AMP] = ACTIONS(4294),
    [anon_sym_PIPE_PIPE] = ACTIONS(4292),
    [anon_sym_AMP_AMP] = ACTIONS(4292),
    [anon_sym_PIPE] = ACTIONS(4294),
    [anon_sym_CARET] = ACTIONS(4294),
    [anon_sym_EQ_EQ] = ACTIONS(4292),
    [anon_sym_BANG_EQ] = ACTIONS(4292),
    [anon_sym_LT] = ACTIONS(2448),
    [anon_sym_GT] = ACTIONS(2448),
    [anon_sym_LT_EQ] = ACTIONS(2450),
    [anon_sym_GT_EQ] = ACTIONS(2450),
    [anon_sym_LT_LT] = ACTIONS(2452),
    [anon_sym_GT_GT] = ACTIONS(2452),
    [anon_sym_PLUS] = ACTIONS(2454),
    [anon_sym_DASH] = ACTIONS(2454),
    [anon_sym_SLASH] = ACTIONS(2428),
    [anon_sym_PERCENT] = ACTIONS(2428),
    [anon_sym_DASH_DASH] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(1554),
    [anon_sym_DASH_GT] = ACTIONS(1554),
    [sym_comment] = ACTIONS(49),
  },
  [1775] = {
    [sym_argument_list] = STATE(802),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_COMMA] = ACTIONS(4296),
    [anon_sym_SEMI] = ACTIONS(4296),
    [anon_sym_RBRACE] = ACTIONS(4296),
    [anon_sym_STAR] = ACTIONS(2428),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_EQ] = ACTIONS(4298),
    [anon_sym_QMARK] = ACTIONS(4296),
    [anon_sym_STAR_EQ] = ACTIONS(4296),
    [anon_sym_SLASH_EQ] = ACTIONS(4296),
    [anon_sym_PERCENT_EQ] = ACTIONS(4296),
    [anon_sym_PLUS_EQ] = ACTIONS(4296),
    [anon_sym_DASH_EQ] = ACTIONS(4296),
    [anon_sym_LT_LT_EQ] = ACTIONS(4296),
    [anon_sym_GT_GT_EQ] = ACTIONS(4296),
    [anon_sym_AMP_EQ] = ACTIONS(4296),
    [anon_sym_CARET_EQ] = ACTIONS(4296),
    [anon_sym_PIPE_EQ] = ACTIONS(4296),
    [anon_sym_AMP] = ACTIONS(4298),
    [anon_sym_PIPE_PIPE] = ACTIONS(4296),
    [anon_sym_AMP_AMP] = ACTIONS(4296),
    [anon_sym_PIPE] = ACTIONS(4298),
    [anon_sym_CARET] = ACTIONS(4298),
    [anon_sym_EQ_EQ] = ACTIONS(4296),
    [anon_sym_BANG_EQ] = ACTIONS(4296),
    [anon_sym_LT] = ACTIONS(4298),
    [anon_sym_GT] = ACTIONS(4298),
    [anon_sym_LT_EQ] = ACTIONS(4296),
    [anon_sym_GT_EQ] = ACTIONS(4296),
    [anon_sym_LT_LT] = ACTIONS(2452),
    [anon_sym_GT_GT] = ACTIONS(2452),
    [anon_sym_PLUS] = ACTIONS(2454),
    [anon_sym_DASH] = ACTIONS(2454),
    [anon_sym_SLASH] = ACTIONS(2428),
    [anon_sym_PERCENT] = ACTIONS(2428),
    [anon_sym_DASH_DASH] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(1554),
    [anon_sym_DASH_GT] = ACTIONS(1554),
    [sym_comment] = ACTIONS(49),
  },
  [1776] = {
    [sym_argument_list] = STATE(802),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_COMMA] = ACTIONS(4300),
    [anon_sym_SEMI] = ACTIONS(4300),
    [anon_sym_RBRACE] = ACTIONS(4300),
    [anon_sym_STAR] = ACTIONS(2428),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_EQ] = ACTIONS(4302),
    [anon_sym_QMARK] = ACTIONS(4300),
    [anon_sym_STAR_EQ] = ACTIONS(4300),
    [anon_sym_SLASH_EQ] = ACTIONS(4300),
    [anon_sym_PERCENT_EQ] = ACTIONS(4300),
    [anon_sym_PLUS_EQ] = ACTIONS(4300),
    [anon_sym_DASH_EQ] = ACTIONS(4300),
    [anon_sym_LT_LT_EQ] = ACTIONS(4300),
    [anon_sym_GT_GT_EQ] = ACTIONS(4300),
    [anon_sym_AMP_EQ] = ACTIONS(4300),
    [anon_sym_CARET_EQ] = ACTIONS(4300),
    [anon_sym_PIPE_EQ] = ACTIONS(4300),
    [anon_sym_AMP] = ACTIONS(4302),
    [anon_sym_PIPE_PIPE] = ACTIONS(4300),
    [anon_sym_AMP_AMP] = ACTIONS(4300),
    [anon_sym_PIPE] = ACTIONS(4302),
    [anon_sym_CARET] = ACTIONS(4302),
    [anon_sym_EQ_EQ] = ACTIONS(4300),
    [anon_sym_BANG_EQ] = ACTIONS(4300),
    [anon_sym_LT] = ACTIONS(4302),
    [anon_sym_GT] = ACTIONS(4302),
    [anon_sym_LT_EQ] = ACTIONS(4300),
    [anon_sym_GT_EQ] = ACTIONS(4300),
    [anon_sym_LT_LT] = ACTIONS(4302),
    [anon_sym_GT_GT] = ACTIONS(4302),
    [anon_sym_PLUS] = ACTIONS(2454),
    [anon_sym_DASH] = ACTIONS(2454),
    [anon_sym_SLASH] = ACTIONS(2428),
    [anon_sym_PERCENT] = ACTIONS(2428),
    [anon_sym_DASH_DASH] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(1554),
    [anon_sym_DASH_GT] = ACTIONS(1554),
    [sym_comment] = ACTIONS(49),
  },
  [1777] = {
    [sym_argument_list] = STATE(802),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_COMMA] = ACTIONS(4274),
    [anon_sym_SEMI] = ACTIONS(4274),
    [anon_sym_RBRACE] = ACTIONS(4274),
    [anon_sym_STAR] = ACTIONS(2428),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_EQ] = ACTIONS(4276),
    [anon_sym_QMARK] = ACTIONS(4274),
    [anon_sym_STAR_EQ] = ACTIONS(4274),
    [anon_sym_SLASH_EQ] = ACTIONS(4274),
    [anon_sym_PERCENT_EQ] = ACTIONS(4274),
    [anon_sym_PLUS_EQ] = ACTIONS(4274),
    [anon_sym_DASH_EQ] = ACTIONS(4274),
    [anon_sym_LT_LT_EQ] = ACTIONS(4274),
    [anon_sym_GT_GT_EQ] = ACTIONS(4274),
    [anon_sym_AMP_EQ] = ACTIONS(4274),
    [anon_sym_CARET_EQ] = ACTIONS(4274),
    [anon_sym_PIPE_EQ] = ACTIONS(4274),
    [anon_sym_AMP] = ACTIONS(4276),
    [anon_sym_PIPE_PIPE] = ACTIONS(4274),
    [anon_sym_AMP_AMP] = ACTIONS(4274),
    [anon_sym_PIPE] = ACTIONS(4276),
    [anon_sym_CARET] = ACTIONS(4276),
    [anon_sym_EQ_EQ] = ACTIONS(4274),
    [anon_sym_BANG_EQ] = ACTIONS(4274),
    [anon_sym_LT] = ACTIONS(4276),
    [anon_sym_GT] = ACTIONS(4276),
    [anon_sym_LT_EQ] = ACTIONS(4274),
    [anon_sym_GT_EQ] = ACTIONS(4274),
    [anon_sym_LT_LT] = ACTIONS(4276),
    [anon_sym_GT_GT] = ACTIONS(4276),
    [anon_sym_PLUS] = ACTIONS(4276),
    [anon_sym_DASH] = ACTIONS(4276),
    [anon_sym_SLASH] = ACTIONS(2428),
    [anon_sym_PERCENT] = ACTIONS(2428),
    [anon_sym_DASH_DASH] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(1554),
    [anon_sym_DASH_GT] = ACTIONS(1554),
    [sym_comment] = ACTIONS(49),
  },
  [1778] = {
    [sym__expression] = STATE(1780),
    [sym_conditional_expression] = STATE(1780),
    [sym_assignment_expression] = STATE(1780),
    [sym_pointer_expression] = STATE(1780),
    [sym_logical_expression] = STATE(1780),
    [sym_bitwise_expression] = STATE(1780),
    [sym_equality_expression] = STATE(1780),
    [sym_relational_expression] = STATE(1780),
    [sym_shift_expression] = STATE(1780),
    [sym_math_expression] = STATE(1780),
    [sym_cast_expression] = STATE(1780),
    [sym_sizeof_expression] = STATE(1780),
    [sym_subscript_expression] = STATE(1780),
    [sym_call_expression] = STATE(1780),
    [sym_field_expression] = STATE(1780),
    [sym_compound_literal_expression] = STATE(1780),
    [sym_parenthesized_expression] = STATE(1780),
    [sym_initializer_list] = STATE(1766),
    [sym_initializer_pair] = STATE(1766),
    [sym_subscript_designator] = STATE(671),
    [sym_field_designator] = STATE(671),
    [sym_concatenated_string] = STATE(1780),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(1780),
    [sym_new_expression] = STATE(1780),
    [sym_delete_expression] = STATE(1780),
    [sym_lambda_expression] = STATE(1780),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [aux_sym_initializer_pair_repeat1] = STATE(671),
    [sym_raw_string_literal] = ACTIONS(3962),
    [anon_sym_LPAREN] = ACTIONS(1321),
    [anon_sym_LBRACE] = ACTIONS(548),
    [anon_sym_RBRACE] = ACTIONS(5117),
    [anon_sym_STAR] = ACTIONS(1325),
    [anon_sym_LBRACK] = ACTIONS(1277),
    [anon_sym_AMP] = ACTIONS(1325),
    [anon_sym_BANG] = ACTIONS(1327),
    [anon_sym_TILDE] = ACTIONS(1329),
    [anon_sym_PLUS] = ACTIONS(1331),
    [anon_sym_DASH] = ACTIONS(1331),
    [anon_sym_DASH_DASH] = ACTIONS(1333),
    [anon_sym_PLUS_PLUS] = ACTIONS(1333),
    [anon_sym_sizeof] = ACTIONS(1335),
    [anon_sym_DOT] = ACTIONS(1289),
    [sym_number_literal] = ACTIONS(3962),
    [sym_char_literal] = ACTIONS(3962),
    [sym_string_literal] = ACTIONS(1337),
    [sym_true] = ACTIONS(3964),
    [sym_false] = ACTIONS(3964),
    [sym_null] = ACTIONS(3964),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1341),
    [anon_sym_delete] = ACTIONS(1343),
    [sym_nullptr] = ACTIONS(3964),
  },
  [1779] = {
    [aux_sym_initializer_list_repeat1] = STATE(1779),
    [anon_sym_COMMA] = ACTIONS(5119),
    [anon_sym_RBRACE] = ACTIONS(5113),
    [sym_comment] = ACTIONS(49),
  },
  [1780] = {
    [sym_argument_list] = STATE(802),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_COMMA] = ACTIONS(5113),
    [anon_sym_RBRACE] = ACTIONS(5113),
    [anon_sym_STAR] = ACTIONS(2507),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_EQ] = ACTIONS(2509),
    [anon_sym_QMARK] = ACTIONS(2511),
    [anon_sym_STAR_EQ] = ACTIONS(2513),
    [anon_sym_SLASH_EQ] = ACTIONS(2513),
    [anon_sym_PERCENT_EQ] = ACTIONS(2513),
    [anon_sym_PLUS_EQ] = ACTIONS(2513),
    [anon_sym_DASH_EQ] = ACTIONS(2513),
    [anon_sym_LT_LT_EQ] = ACTIONS(2513),
    [anon_sym_GT_GT_EQ] = ACTIONS(2513),
    [anon_sym_AMP_EQ] = ACTIONS(2513),
    [anon_sym_CARET_EQ] = ACTIONS(2513),
    [anon_sym_PIPE_EQ] = ACTIONS(2513),
    [anon_sym_AMP] = ACTIONS(2515),
    [anon_sym_PIPE_PIPE] = ACTIONS(2517),
    [anon_sym_AMP_AMP] = ACTIONS(2519),
    [anon_sym_PIPE] = ACTIONS(2521),
    [anon_sym_CARET] = ACTIONS(2523),
    [anon_sym_EQ_EQ] = ACTIONS(2525),
    [anon_sym_BANG_EQ] = ACTIONS(2525),
    [anon_sym_LT] = ACTIONS(2527),
    [anon_sym_GT] = ACTIONS(2527),
    [anon_sym_LT_EQ] = ACTIONS(2529),
    [anon_sym_GT_EQ] = ACTIONS(2529),
    [anon_sym_LT_LT] = ACTIONS(2531),
    [anon_sym_GT_GT] = ACTIONS(2531),
    [anon_sym_PLUS] = ACTIONS(2533),
    [anon_sym_DASH] = ACTIONS(2533),
    [anon_sym_SLASH] = ACTIONS(2507),
    [anon_sym_PERCENT] = ACTIONS(2507),
    [anon_sym_DASH_DASH] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(1554),
    [anon_sym_DASH_GT] = ACTIONS(1554),
    [sym_comment] = ACTIONS(49),
  },
  [1781] = {
    [sym_argument_list] = STATE(802),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_STAR] = ACTIONS(1522),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_RBRACK] = ACTIONS(5122),
    [anon_sym_EQ] = ACTIONS(1526),
    [anon_sym_QMARK] = ACTIONS(1528),
    [anon_sym_STAR_EQ] = ACTIONS(1530),
    [anon_sym_SLASH_EQ] = ACTIONS(1530),
    [anon_sym_PERCENT_EQ] = ACTIONS(1530),
    [anon_sym_PLUS_EQ] = ACTIONS(1530),
    [anon_sym_DASH_EQ] = ACTIONS(1530),
    [anon_sym_LT_LT_EQ] = ACTIONS(1530),
    [anon_sym_GT_GT_EQ] = ACTIONS(1530),
    [anon_sym_AMP_EQ] = ACTIONS(1530),
    [anon_sym_CARET_EQ] = ACTIONS(1530),
    [anon_sym_PIPE_EQ] = ACTIONS(1530),
    [anon_sym_AMP] = ACTIONS(1532),
    [anon_sym_PIPE_PIPE] = ACTIONS(1534),
    [anon_sym_AMP_AMP] = ACTIONS(1536),
    [anon_sym_PIPE] = ACTIONS(1538),
    [anon_sym_CARET] = ACTIONS(1540),
    [anon_sym_EQ_EQ] = ACTIONS(1542),
    [anon_sym_BANG_EQ] = ACTIONS(1542),
    [anon_sym_LT] = ACTIONS(1544),
    [anon_sym_GT] = ACTIONS(1544),
    [anon_sym_LT_EQ] = ACTIONS(1546),
    [anon_sym_GT_EQ] = ACTIONS(1546),
    [anon_sym_LT_LT] = ACTIONS(1548),
    [anon_sym_GT_GT] = ACTIONS(1548),
    [anon_sym_PLUS] = ACTIONS(1550),
    [anon_sym_DASH] = ACTIONS(1550),
    [anon_sym_SLASH] = ACTIONS(1522),
    [anon_sym_PERCENT] = ACTIONS(1522),
    [anon_sym_DASH_DASH] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(1554),
    [anon_sym_DASH_GT] = ACTIONS(1554),
    [sym_comment] = ACTIONS(49),
  },
  [1782] = {
    [sym_argument_list] = STATE(802),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_COMMA] = ACTIONS(5124),
    [anon_sym_RBRACE] = ACTIONS(5124),
    [anon_sym_STAR] = ACTIONS(2507),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_EQ] = ACTIONS(2509),
    [anon_sym_QMARK] = ACTIONS(2511),
    [anon_sym_STAR_EQ] = ACTIONS(2513),
    [anon_sym_SLASH_EQ] = ACTIONS(2513),
    [anon_sym_PERCENT_EQ] = ACTIONS(2513),
    [anon_sym_PLUS_EQ] = ACTIONS(2513),
    [anon_sym_DASH_EQ] = ACTIONS(2513),
    [anon_sym_LT_LT_EQ] = ACTIONS(2513),
    [anon_sym_GT_GT_EQ] = ACTIONS(2513),
    [anon_sym_AMP_EQ] = ACTIONS(2513),
    [anon_sym_CARET_EQ] = ACTIONS(2513),
    [anon_sym_PIPE_EQ] = ACTIONS(2513),
    [anon_sym_AMP] = ACTIONS(2515),
    [anon_sym_PIPE_PIPE] = ACTIONS(2517),
    [anon_sym_AMP_AMP] = ACTIONS(2519),
    [anon_sym_PIPE] = ACTIONS(2521),
    [anon_sym_CARET] = ACTIONS(2523),
    [anon_sym_EQ_EQ] = ACTIONS(2525),
    [anon_sym_BANG_EQ] = ACTIONS(2525),
    [anon_sym_LT] = ACTIONS(2527),
    [anon_sym_GT] = ACTIONS(2527),
    [anon_sym_LT_EQ] = ACTIONS(2529),
    [anon_sym_GT_EQ] = ACTIONS(2529),
    [anon_sym_LT_LT] = ACTIONS(2531),
    [anon_sym_GT_GT] = ACTIONS(2531),
    [anon_sym_PLUS] = ACTIONS(2533),
    [anon_sym_DASH] = ACTIONS(2533),
    [anon_sym_SLASH] = ACTIONS(2507),
    [anon_sym_PERCENT] = ACTIONS(2507),
    [anon_sym_DASH_DASH] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(1554),
    [anon_sym_DASH_GT] = ACTIONS(1554),
    [sym_comment] = ACTIONS(49),
  },
  [1783] = {
    [anon_sym_COMMA] = ACTIONS(5124),
    [anon_sym_RBRACE] = ACTIONS(5124),
    [sym_comment] = ACTIONS(49),
  },
  [1784] = {
    [sym_field_declaration_list] = STATE(1901),
    [sym_base_class_clause] = STATE(1902),
    [anon_sym_LPAREN] = ACTIONS(406),
    [anon_sym_COMMA] = ACTIONS(406),
    [anon_sym_RPAREN] = ACTIONS(406),
    [anon_sym_SEMI] = ACTIONS(406),
    [anon_sym_LBRACE] = ACTIONS(406),
    [anon_sym_STAR] = ACTIONS(406),
    [anon_sym_LBRACK] = ACTIONS(406),
    [anon_sym_EQ] = ACTIONS(406),
    [anon_sym_const] = ACTIONS(408),
    [anon_sym_restrict] = ACTIONS(406),
    [anon_sym_volatile] = ACTIONS(406),
    [anon_sym__Atomic] = ACTIONS(406),
    [anon_sym_mutable] = ACTIONS(406),
    [anon_sym_explicit] = ACTIONS(406),
    [anon_sym_constexpr] = ACTIONS(406),
    [anon_sym_COLON] = ACTIONS(943),
    [anon_sym_AMP] = ACTIONS(408),
    [anon_sym_AMP_AMP] = ACTIONS(406),
    [anon_sym_GT] = ACTIONS(406),
    [anon_sym_DASH_GT] = ACTIONS(406),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(406),
  },
  [1785] = {
    [sym_field_declaration_list] = STATE(1903),
    [sym_base_class_clause] = STATE(1904),
    [anon_sym_LPAREN] = ACTIONS(416),
    [anon_sym_COMMA] = ACTIONS(416),
    [anon_sym_RPAREN] = ACTIONS(416),
    [anon_sym_SEMI] = ACTIONS(416),
    [anon_sym_LBRACE] = ACTIONS(416),
    [anon_sym_STAR] = ACTIONS(416),
    [anon_sym_LBRACK] = ACTIONS(416),
    [anon_sym_EQ] = ACTIONS(416),
    [anon_sym_const] = ACTIONS(418),
    [anon_sym_restrict] = ACTIONS(416),
    [anon_sym_volatile] = ACTIONS(416),
    [anon_sym__Atomic] = ACTIONS(416),
    [anon_sym_mutable] = ACTIONS(416),
    [anon_sym_explicit] = ACTIONS(416),
    [anon_sym_constexpr] = ACTIONS(416),
    [anon_sym_COLON] = ACTIONS(943),
    [anon_sym_AMP] = ACTIONS(418),
    [anon_sym_AMP_AMP] = ACTIONS(416),
    [anon_sym_GT] = ACTIONS(416),
    [anon_sym_DASH_GT] = ACTIONS(416),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(416),
  },
  [1786] = {
    [sym_field_declaration_list] = STATE(1908),
    [sym_base_class_clause] = STATE(1909),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_COMMA] = ACTIONS(451),
    [anon_sym_RPAREN] = ACTIONS(451),
    [anon_sym_SEMI] = ACTIONS(451),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_STAR] = ACTIONS(451),
    [anon_sym_LBRACK] = ACTIONS(451),
    [anon_sym_EQ] = ACTIONS(451),
    [anon_sym_const] = ACTIONS(453),
    [anon_sym_restrict] = ACTIONS(451),
    [anon_sym_volatile] = ACTIONS(451),
    [anon_sym__Atomic] = ACTIONS(451),
    [anon_sym_mutable] = ACTIONS(451),
    [anon_sym_explicit] = ACTIONS(451),
    [anon_sym_constexpr] = ACTIONS(451),
    [anon_sym_COLON] = ACTIONS(943),
    [anon_sym_AMP] = ACTIONS(453),
    [anon_sym_AMP_AMP] = ACTIONS(451),
    [anon_sym_GT] = ACTIONS(451),
    [anon_sym_DASH_GT] = ACTIONS(451),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(451),
  },
  [1787] = {
    [sym__abstract_declarator] = STATE(2213),
    [sym_abstract_pointer_declarator] = STATE(2213),
    [sym_abstract_function_declarator] = STATE(2213),
    [sym_abstract_array_declarator] = STATE(2213),
    [sym_parameter_list] = STATE(1790),
    [sym_abstract_reference_declarator] = STATE(2213),
    [anon_sym_LPAREN] = ACTIONS(1115),
    [anon_sym_COMMA] = ACTIONS(2270),
    [anon_sym_SEMI] = ACTIONS(2270),
    [anon_sym_LBRACE] = ACTIONS(2270),
    [anon_sym_STAR] = ACTIONS(3982),
    [anon_sym_LBRACK] = ACTIONS(1121),
    [anon_sym_EQ] = ACTIONS(2270),
    [anon_sym_const] = ACTIONS(4360),
    [anon_sym_restrict] = ACTIONS(2270),
    [anon_sym_volatile] = ACTIONS(2270),
    [anon_sym__Atomic] = ACTIONS(2270),
    [anon_sym_mutable] = ACTIONS(2270),
    [anon_sym_explicit] = ACTIONS(2270),
    [anon_sym_constexpr] = ACTIONS(2270),
    [anon_sym_AMP] = ACTIONS(3984),
    [anon_sym_AMP_AMP] = ACTIONS(3986),
    [anon_sym_DASH_GT] = ACTIONS(2270),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(2270),
  },
  [1788] = {
    [sym__abstract_declarator] = STATE(2214),
    [sym_abstract_pointer_declarator] = STATE(2214),
    [sym_abstract_function_declarator] = STATE(2214),
    [sym_abstract_array_declarator] = STATE(2214),
    [sym_parameter_list] = STATE(1790),
    [sym_abstract_reference_declarator] = STATE(2214),
    [anon_sym_LPAREN] = ACTIONS(1115),
    [anon_sym_COMMA] = ACTIONS(2278),
    [anon_sym_SEMI] = ACTIONS(2278),
    [anon_sym_LBRACE] = ACTIONS(2278),
    [anon_sym_STAR] = ACTIONS(3982),
    [anon_sym_LBRACK] = ACTIONS(1121),
    [anon_sym_EQ] = ACTIONS(2278),
    [anon_sym_const] = ACTIONS(4362),
    [anon_sym_restrict] = ACTIONS(2278),
    [anon_sym_volatile] = ACTIONS(2278),
    [anon_sym__Atomic] = ACTIONS(2278),
    [anon_sym_mutable] = ACTIONS(2278),
    [anon_sym_explicit] = ACTIONS(2278),
    [anon_sym_constexpr] = ACTIONS(2278),
    [anon_sym_AMP] = ACTIONS(3984),
    [anon_sym_AMP_AMP] = ACTIONS(3986),
    [anon_sym_DASH_GT] = ACTIONS(2278),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(2278),
  },
  [1789] = {
    [sym_parameter_list] = STATE(2215),
    [anon_sym_LPAREN] = ACTIONS(206),
    [anon_sym_COMMA] = ACTIONS(4364),
    [anon_sym_SEMI] = ACTIONS(4364),
    [anon_sym_LBRACE] = ACTIONS(4364),
    [anon_sym_LBRACK] = ACTIONS(2282),
    [anon_sym_EQ] = ACTIONS(4364),
    [anon_sym_const] = ACTIONS(4366),
    [anon_sym_restrict] = ACTIONS(4364),
    [anon_sym_volatile] = ACTIONS(4364),
    [anon_sym__Atomic] = ACTIONS(4364),
    [anon_sym_mutable] = ACTIONS(4364),
    [anon_sym_explicit] = ACTIONS(4364),
    [anon_sym_constexpr] = ACTIONS(4364),
    [anon_sym_DASH_GT] = ACTIONS(4364),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(4364),
  },
  [1790] = {
    [sym_type_qualifier] = STATE(2216),
    [sym_trailing_return_type] = STATE(1129),
    [aux_sym_abstract_function_declarator_repeat1] = STATE(2216),
    [anon_sym_LPAREN] = ACTIONS(2284),
    [anon_sym_COMMA] = ACTIONS(2284),
    [anon_sym_SEMI] = ACTIONS(2284),
    [anon_sym_LBRACE] = ACTIONS(2284),
    [anon_sym_LBRACK] = ACTIONS(2284),
    [anon_sym_EQ] = ACTIONS(2284),
    [anon_sym_const] = ACTIONS(4368),
    [anon_sym_restrict] = ACTIONS(2284),
    [anon_sym_volatile] = ACTIONS(2284),
    [anon_sym__Atomic] = ACTIONS(2284),
    [anon_sym_mutable] = ACTIONS(2284),
    [anon_sym_explicit] = ACTIONS(2284),
    [anon_sym_constexpr] = ACTIONS(2284),
    [anon_sym_DASH_GT] = ACTIONS(2284),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(2284),
  },
  [1791] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(1791),
    [anon_sym_LPAREN] = ACTIONS(816),
    [anon_sym_COMMA] = ACTIONS(816),
    [anon_sym_SEMI] = ACTIONS(816),
    [anon_sym_LBRACE] = ACTIONS(816),
    [anon_sym_STAR] = ACTIONS(816),
    [anon_sym_LBRACK] = ACTIONS(816),
    [anon_sym_EQ] = ACTIONS(816),
    [anon_sym_const] = ACTIONS(818),
    [anon_sym_restrict] = ACTIONS(818),
    [anon_sym_volatile] = ACTIONS(818),
    [anon_sym__Atomic] = ACTIONS(818),
    [anon_sym_mutable] = ACTIONS(818),
    [anon_sym_explicit] = ACTIONS(818),
    [anon_sym_constexpr] = ACTIONS(818),
    [anon_sym_unsigned] = ACTIONS(5126),
    [anon_sym_long] = ACTIONS(5126),
    [anon_sym_short] = ACTIONS(5126),
    [sym_primitive_type] = ACTIONS(818),
    [anon_sym_AMP] = ACTIONS(818),
    [anon_sym_AMP_AMP] = ACTIONS(816),
    [anon_sym_DASH_GT] = ACTIONS(816),
    [sym_identifier] = ACTIONS(818),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(818),
  },
  [1792] = {
    [sym__expression] = STATE(1834),
    [sym_conditional_expression] = STATE(1834),
    [sym_assignment_expression] = STATE(1834),
    [sym_pointer_expression] = STATE(1834),
    [sym_logical_expression] = STATE(1834),
    [sym_bitwise_expression] = STATE(1834),
    [sym_equality_expression] = STATE(1834),
    [sym_relational_expression] = STATE(1834),
    [sym_shift_expression] = STATE(1834),
    [sym_math_expression] = STATE(1834),
    [sym_cast_expression] = STATE(1834),
    [sym_sizeof_expression] = STATE(1834),
    [sym_subscript_expression] = STATE(1834),
    [sym_call_expression] = STATE(1834),
    [sym_field_expression] = STATE(1834),
    [sym_compound_literal_expression] = STATE(1834),
    [sym_parenthesized_expression] = STATE(1834),
    [sym_initializer_list] = STATE(1835),
    [sym_concatenated_string] = STATE(1834),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(1834),
    [sym_new_expression] = STATE(1834),
    [sym_delete_expression] = STATE(1834),
    [sym_lambda_expression] = STATE(1834),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(4145),
    [anon_sym_LPAREN] = ACTIONS(1321),
    [anon_sym_LBRACE] = ACTIONS(548),
    [anon_sym_STAR] = ACTIONS(1325),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_AMP] = ACTIONS(1325),
    [anon_sym_BANG] = ACTIONS(1327),
    [anon_sym_TILDE] = ACTIONS(1329),
    [anon_sym_PLUS] = ACTIONS(1331),
    [anon_sym_DASH] = ACTIONS(1331),
    [anon_sym_DASH_DASH] = ACTIONS(1333),
    [anon_sym_PLUS_PLUS] = ACTIONS(1333),
    [anon_sym_sizeof] = ACTIONS(1335),
    [sym_number_literal] = ACTIONS(4145),
    [sym_char_literal] = ACTIONS(4145),
    [sym_string_literal] = ACTIONS(1337),
    [sym_true] = ACTIONS(4147),
    [sym_false] = ACTIONS(4147),
    [sym_null] = ACTIONS(4147),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1341),
    [anon_sym_delete] = ACTIONS(1343),
    [sym_nullptr] = ACTIONS(4147),
  },
  [1793] = {
    [anon_sym_RPAREN] = ACTIONS(5129),
    [sym_comment] = ACTIONS(49),
  },
  [1794] = {
    [aux_sym_concatenated_string_repeat1] = STATE(1794),
    [anon_sym_LPAREN] = ACTIONS(4230),
    [anon_sym_COMMA] = ACTIONS(4230),
    [anon_sym_RBRACE] = ACTIONS(4230),
    [anon_sym_STAR] = ACTIONS(4232),
    [anon_sym_LBRACK] = ACTIONS(4230),
    [anon_sym_EQ] = ACTIONS(4232),
    [anon_sym_QMARK] = ACTIONS(4230),
    [anon_sym_STAR_EQ] = ACTIONS(4230),
    [anon_sym_SLASH_EQ] = ACTIONS(4230),
    [anon_sym_PERCENT_EQ] = ACTIONS(4230),
    [anon_sym_PLUS_EQ] = ACTIONS(4230),
    [anon_sym_DASH_EQ] = ACTIONS(4230),
    [anon_sym_LT_LT_EQ] = ACTIONS(4230),
    [anon_sym_GT_GT_EQ] = ACTIONS(4230),
    [anon_sym_AMP_EQ] = ACTIONS(4230),
    [anon_sym_CARET_EQ] = ACTIONS(4230),
    [anon_sym_PIPE_EQ] = ACTIONS(4230),
    [anon_sym_AMP] = ACTIONS(4232),
    [anon_sym_PIPE_PIPE] = ACTIONS(4230),
    [anon_sym_AMP_AMP] = ACTIONS(4230),
    [anon_sym_PIPE] = ACTIONS(4232),
    [anon_sym_CARET] = ACTIONS(4232),
    [anon_sym_EQ_EQ] = ACTIONS(4230),
    [anon_sym_BANG_EQ] = ACTIONS(4230),
    [anon_sym_LT] = ACTIONS(4232),
    [anon_sym_GT] = ACTIONS(4232),
    [anon_sym_LT_EQ] = ACTIONS(4230),
    [anon_sym_GT_EQ] = ACTIONS(4230),
    [anon_sym_LT_LT] = ACTIONS(4232),
    [anon_sym_GT_GT] = ACTIONS(4232),
    [anon_sym_PLUS] = ACTIONS(4232),
    [anon_sym_DASH] = ACTIONS(4232),
    [anon_sym_SLASH] = ACTIONS(4232),
    [anon_sym_PERCENT] = ACTIONS(4232),
    [anon_sym_DASH_DASH] = ACTIONS(4230),
    [anon_sym_PLUS_PLUS] = ACTIONS(4230),
    [anon_sym_DOT] = ACTIONS(4230),
    [anon_sym_DASH_GT] = ACTIONS(4230),
    [sym_string_literal] = ACTIONS(5131),
    [sym_comment] = ACTIONS(49),
  },
  [1795] = {
    [sym__expression] = STATE(740),
    [sym_conditional_expression] = STATE(740),
    [sym_assignment_expression] = STATE(740),
    [sym_pointer_expression] = STATE(740),
    [sym_logical_expression] = STATE(740),
    [sym_bitwise_expression] = STATE(740),
    [sym_equality_expression] = STATE(740),
    [sym_relational_expression] = STATE(740),
    [sym_shift_expression] = STATE(740),
    [sym_math_expression] = STATE(740),
    [sym_cast_expression] = STATE(740),
    [sym_sizeof_expression] = STATE(740),
    [sym_subscript_expression] = STATE(740),
    [sym_call_expression] = STATE(740),
    [sym_field_expression] = STATE(740),
    [sym_compound_literal_expression] = STATE(740),
    [sym_parenthesized_expression] = STATE(740),
    [sym_concatenated_string] = STATE(740),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(740),
    [sym_new_expression] = STATE(740),
    [sym_delete_expression] = STATE(740),
    [sym_lambda_expression] = STATE(740),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_lambda_default_capture] = STATE(741),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(1417),
    [anon_sym_LPAREN] = ACTIONS(1419),
    [anon_sym_STAR] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_RBRACK] = ACTIONS(5134),
    [anon_sym_EQ] = ACTIONS(1425),
    [anon_sym_AMP] = ACTIONS(1427),
    [anon_sym_BANG] = ACTIONS(1429),
    [anon_sym_TILDE] = ACTIONS(1431),
    [anon_sym_PLUS] = ACTIONS(1433),
    [anon_sym_DASH] = ACTIONS(1433),
    [anon_sym_DASH_DASH] = ACTIONS(1435),
    [anon_sym_PLUS_PLUS] = ACTIONS(1435),
    [anon_sym_sizeof] = ACTIONS(1437),
    [sym_number_literal] = ACTIONS(1417),
    [sym_char_literal] = ACTIONS(1417),
    [sym_string_literal] = ACTIONS(1439),
    [sym_true] = ACTIONS(1441),
    [sym_false] = ACTIONS(1441),
    [sym_null] = ACTIONS(1441),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1443),
    [anon_sym_delete] = ACTIONS(1445),
    [sym_nullptr] = ACTIONS(1441),
  },
  [1796] = {
    [sym_argument_list] = STATE(802),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_COMMA] = ACTIONS(4258),
    [anon_sym_RBRACE] = ACTIONS(4258),
    [anon_sym_STAR] = ACTIONS(2507),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_EQ] = ACTIONS(4260),
    [anon_sym_QMARK] = ACTIONS(4258),
    [anon_sym_STAR_EQ] = ACTIONS(4258),
    [anon_sym_SLASH_EQ] = ACTIONS(4258),
    [anon_sym_PERCENT_EQ] = ACTIONS(4258),
    [anon_sym_PLUS_EQ] = ACTIONS(4258),
    [anon_sym_DASH_EQ] = ACTIONS(4258),
    [anon_sym_LT_LT_EQ] = ACTIONS(4258),
    [anon_sym_GT_GT_EQ] = ACTIONS(4258),
    [anon_sym_AMP_EQ] = ACTIONS(4258),
    [anon_sym_CARET_EQ] = ACTIONS(4258),
    [anon_sym_PIPE_EQ] = ACTIONS(4258),
    [anon_sym_AMP] = ACTIONS(2515),
    [anon_sym_PIPE_PIPE] = ACTIONS(2517),
    [anon_sym_AMP_AMP] = ACTIONS(2519),
    [anon_sym_PIPE] = ACTIONS(2521),
    [anon_sym_CARET] = ACTIONS(2523),
    [anon_sym_EQ_EQ] = ACTIONS(2525),
    [anon_sym_BANG_EQ] = ACTIONS(2525),
    [anon_sym_LT] = ACTIONS(2527),
    [anon_sym_GT] = ACTIONS(2527),
    [anon_sym_LT_EQ] = ACTIONS(2529),
    [anon_sym_GT_EQ] = ACTIONS(2529),
    [anon_sym_LT_LT] = ACTIONS(2531),
    [anon_sym_GT_GT] = ACTIONS(2531),
    [anon_sym_PLUS] = ACTIONS(2533),
    [anon_sym_DASH] = ACTIONS(2533),
    [anon_sym_SLASH] = ACTIONS(2507),
    [anon_sym_PERCENT] = ACTIONS(2507),
    [anon_sym_DASH_DASH] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(1554),
    [anon_sym_DASH_GT] = ACTIONS(1554),
    [sym_comment] = ACTIONS(49),
  },
  [1797] = {
    [sym__expression] = STATE(2219),
    [sym_conditional_expression] = STATE(2219),
    [sym_assignment_expression] = STATE(2219),
    [sym_pointer_expression] = STATE(2219),
    [sym_logical_expression] = STATE(2219),
    [sym_bitwise_expression] = STATE(2219),
    [sym_equality_expression] = STATE(2219),
    [sym_relational_expression] = STATE(2219),
    [sym_shift_expression] = STATE(2219),
    [sym_math_expression] = STATE(2219),
    [sym_cast_expression] = STATE(2219),
    [sym_sizeof_expression] = STATE(2219),
    [sym_subscript_expression] = STATE(2219),
    [sym_call_expression] = STATE(2219),
    [sym_field_expression] = STATE(2219),
    [sym_compound_literal_expression] = STATE(2219),
    [sym_parenthesized_expression] = STATE(2219),
    [sym_concatenated_string] = STATE(2219),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(2219),
    [sym_new_expression] = STATE(2219),
    [sym_delete_expression] = STATE(2219),
    [sym_lambda_expression] = STATE(2219),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(5136),
    [anon_sym_LPAREN] = ACTIONS(2624),
    [anon_sym_STAR] = ACTIONS(2624),
    [anon_sym_LBRACK] = ACTIONS(2624),
    [anon_sym_AMP] = ACTIONS(2626),
    [anon_sym_AMP_AMP] = ACTIONS(2624),
    [anon_sym_BANG] = ACTIONS(1327),
    [anon_sym_TILDE] = ACTIONS(1329),
    [anon_sym_PLUS] = ACTIONS(1331),
    [anon_sym_DASH] = ACTIONS(1331),
    [anon_sym_DASH_DASH] = ACTIONS(1333),
    [anon_sym_PLUS_PLUS] = ACTIONS(1333),
    [anon_sym_sizeof] = ACTIONS(1335),
    [sym_number_literal] = ACTIONS(5136),
    [sym_char_literal] = ACTIONS(5136),
    [sym_string_literal] = ACTIONS(1337),
    [sym_true] = ACTIONS(5138),
    [sym_false] = ACTIONS(5138),
    [sym_null] = ACTIONS(5138),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1341),
    [anon_sym_delete] = ACTIONS(1343),
    [sym_nullptr] = ACTIONS(5138),
  },
  [1798] = {
    [sym_argument_list] = STATE(802),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_COMMA] = ACTIONS(4280),
    [anon_sym_RBRACE] = ACTIONS(4280),
    [anon_sym_STAR] = ACTIONS(2507),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_EQ] = ACTIONS(2509),
    [anon_sym_QMARK] = ACTIONS(4280),
    [anon_sym_STAR_EQ] = ACTIONS(2513),
    [anon_sym_SLASH_EQ] = ACTIONS(2513),
    [anon_sym_PERCENT_EQ] = ACTIONS(2513),
    [anon_sym_PLUS_EQ] = ACTIONS(2513),
    [anon_sym_DASH_EQ] = ACTIONS(2513),
    [anon_sym_LT_LT_EQ] = ACTIONS(2513),
    [anon_sym_GT_GT_EQ] = ACTIONS(2513),
    [anon_sym_AMP_EQ] = ACTIONS(2513),
    [anon_sym_CARET_EQ] = ACTIONS(2513),
    [anon_sym_PIPE_EQ] = ACTIONS(2513),
    [anon_sym_AMP] = ACTIONS(2515),
    [anon_sym_PIPE_PIPE] = ACTIONS(2517),
    [anon_sym_AMP_AMP] = ACTIONS(2519),
    [anon_sym_PIPE] = ACTIONS(2521),
    [anon_sym_CARET] = ACTIONS(2523),
    [anon_sym_EQ_EQ] = ACTIONS(2525),
    [anon_sym_BANG_EQ] = ACTIONS(2525),
    [anon_sym_LT] = ACTIONS(2527),
    [anon_sym_GT] = ACTIONS(2527),
    [anon_sym_LT_EQ] = ACTIONS(2529),
    [anon_sym_GT_EQ] = ACTIONS(2529),
    [anon_sym_LT_LT] = ACTIONS(2531),
    [anon_sym_GT_GT] = ACTIONS(2531),
    [anon_sym_PLUS] = ACTIONS(2533),
    [anon_sym_DASH] = ACTIONS(2533),
    [anon_sym_SLASH] = ACTIONS(2507),
    [anon_sym_PERCENT] = ACTIONS(2507),
    [anon_sym_DASH_DASH] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(1554),
    [anon_sym_DASH_GT] = ACTIONS(1554),
    [sym_comment] = ACTIONS(49),
  },
  [1799] = {
    [sym_argument_list] = STATE(802),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_STAR] = ACTIONS(3003),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_EQ] = ACTIONS(3005),
    [anon_sym_COLON] = ACTIONS(5140),
    [anon_sym_QMARK] = ACTIONS(3009),
    [anon_sym_STAR_EQ] = ACTIONS(3011),
    [anon_sym_SLASH_EQ] = ACTIONS(3011),
    [anon_sym_PERCENT_EQ] = ACTIONS(3011),
    [anon_sym_PLUS_EQ] = ACTIONS(3011),
    [anon_sym_DASH_EQ] = ACTIONS(3011),
    [anon_sym_LT_LT_EQ] = ACTIONS(3011),
    [anon_sym_GT_GT_EQ] = ACTIONS(3011),
    [anon_sym_AMP_EQ] = ACTIONS(3011),
    [anon_sym_CARET_EQ] = ACTIONS(3011),
    [anon_sym_PIPE_EQ] = ACTIONS(3011),
    [anon_sym_AMP] = ACTIONS(3013),
    [anon_sym_PIPE_PIPE] = ACTIONS(3015),
    [anon_sym_AMP_AMP] = ACTIONS(3017),
    [anon_sym_PIPE] = ACTIONS(3019),
    [anon_sym_CARET] = ACTIONS(3021),
    [anon_sym_EQ_EQ] = ACTIONS(3023),
    [anon_sym_BANG_EQ] = ACTIONS(3023),
    [anon_sym_LT] = ACTIONS(3025),
    [anon_sym_GT] = ACTIONS(3025),
    [anon_sym_LT_EQ] = ACTIONS(3027),
    [anon_sym_GT_EQ] = ACTIONS(3027),
    [anon_sym_LT_LT] = ACTIONS(3029),
    [anon_sym_GT_GT] = ACTIONS(3029),
    [anon_sym_PLUS] = ACTIONS(3031),
    [anon_sym_DASH] = ACTIONS(3031),
    [anon_sym_SLASH] = ACTIONS(3003),
    [anon_sym_PERCENT] = ACTIONS(3003),
    [anon_sym_DASH_DASH] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(3033),
    [anon_sym_DASH_GT] = ACTIONS(3033),
    [sym_comment] = ACTIONS(49),
  },
  [1800] = {
    [sym_argument_list] = STATE(802),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_COMMA] = ACTIONS(4284),
    [anon_sym_RBRACE] = ACTIONS(4284),
    [anon_sym_STAR] = ACTIONS(2507),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_EQ] = ACTIONS(4286),
    [anon_sym_QMARK] = ACTIONS(4284),
    [anon_sym_STAR_EQ] = ACTIONS(4284),
    [anon_sym_SLASH_EQ] = ACTIONS(4284),
    [anon_sym_PERCENT_EQ] = ACTIONS(4284),
    [anon_sym_PLUS_EQ] = ACTIONS(4284),
    [anon_sym_DASH_EQ] = ACTIONS(4284),
    [anon_sym_LT_LT_EQ] = ACTIONS(4284),
    [anon_sym_GT_GT_EQ] = ACTIONS(4284),
    [anon_sym_AMP_EQ] = ACTIONS(4284),
    [anon_sym_CARET_EQ] = ACTIONS(4284),
    [anon_sym_PIPE_EQ] = ACTIONS(4284),
    [anon_sym_AMP] = ACTIONS(4286),
    [anon_sym_PIPE_PIPE] = ACTIONS(4284),
    [anon_sym_AMP_AMP] = ACTIONS(4284),
    [anon_sym_PIPE] = ACTIONS(4286),
    [anon_sym_CARET] = ACTIONS(4286),
    [anon_sym_EQ_EQ] = ACTIONS(2525),
    [anon_sym_BANG_EQ] = ACTIONS(2525),
    [anon_sym_LT] = ACTIONS(2527),
    [anon_sym_GT] = ACTIONS(2527),
    [anon_sym_LT_EQ] = ACTIONS(2529),
    [anon_sym_GT_EQ] = ACTIONS(2529),
    [anon_sym_LT_LT] = ACTIONS(2531),
    [anon_sym_GT_GT] = ACTIONS(2531),
    [anon_sym_PLUS] = ACTIONS(2533),
    [anon_sym_DASH] = ACTIONS(2533),
    [anon_sym_SLASH] = ACTIONS(2507),
    [anon_sym_PERCENT] = ACTIONS(2507),
    [anon_sym_DASH_DASH] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(1554),
    [anon_sym_DASH_GT] = ACTIONS(1554),
    [sym_comment] = ACTIONS(49),
  },
  [1801] = {
    [sym_argument_list] = STATE(802),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_COMMA] = ACTIONS(4288),
    [anon_sym_RBRACE] = ACTIONS(4288),
    [anon_sym_STAR] = ACTIONS(2507),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_EQ] = ACTIONS(4290),
    [anon_sym_QMARK] = ACTIONS(4288),
    [anon_sym_STAR_EQ] = ACTIONS(4288),
    [anon_sym_SLASH_EQ] = ACTIONS(4288),
    [anon_sym_PERCENT_EQ] = ACTIONS(4288),
    [anon_sym_PLUS_EQ] = ACTIONS(4288),
    [anon_sym_DASH_EQ] = ACTIONS(4288),
    [anon_sym_LT_LT_EQ] = ACTIONS(4288),
    [anon_sym_GT_GT_EQ] = ACTIONS(4288),
    [anon_sym_AMP_EQ] = ACTIONS(4288),
    [anon_sym_CARET_EQ] = ACTIONS(4288),
    [anon_sym_PIPE_EQ] = ACTIONS(4288),
    [anon_sym_AMP] = ACTIONS(2515),
    [anon_sym_PIPE_PIPE] = ACTIONS(4288),
    [anon_sym_AMP_AMP] = ACTIONS(2519),
    [anon_sym_PIPE] = ACTIONS(2521),
    [anon_sym_CARET] = ACTIONS(2523),
    [anon_sym_EQ_EQ] = ACTIONS(2525),
    [anon_sym_BANG_EQ] = ACTIONS(2525),
    [anon_sym_LT] = ACTIONS(2527),
    [anon_sym_GT] = ACTIONS(2527),
    [anon_sym_LT_EQ] = ACTIONS(2529),
    [anon_sym_GT_EQ] = ACTIONS(2529),
    [anon_sym_LT_LT] = ACTIONS(2531),
    [anon_sym_GT_GT] = ACTIONS(2531),
    [anon_sym_PLUS] = ACTIONS(2533),
    [anon_sym_DASH] = ACTIONS(2533),
    [anon_sym_SLASH] = ACTIONS(2507),
    [anon_sym_PERCENT] = ACTIONS(2507),
    [anon_sym_DASH_DASH] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(1554),
    [anon_sym_DASH_GT] = ACTIONS(1554),
    [sym_comment] = ACTIONS(49),
  },
  [1802] = {
    [sym_argument_list] = STATE(802),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_COMMA] = ACTIONS(4288),
    [anon_sym_RBRACE] = ACTIONS(4288),
    [anon_sym_STAR] = ACTIONS(2507),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_EQ] = ACTIONS(4290),
    [anon_sym_QMARK] = ACTIONS(4288),
    [anon_sym_STAR_EQ] = ACTIONS(4288),
    [anon_sym_SLASH_EQ] = ACTIONS(4288),
    [anon_sym_PERCENT_EQ] = ACTIONS(4288),
    [anon_sym_PLUS_EQ] = ACTIONS(4288),
    [anon_sym_DASH_EQ] = ACTIONS(4288),
    [anon_sym_LT_LT_EQ] = ACTIONS(4288),
    [anon_sym_GT_GT_EQ] = ACTIONS(4288),
    [anon_sym_AMP_EQ] = ACTIONS(4288),
    [anon_sym_CARET_EQ] = ACTIONS(4288),
    [anon_sym_PIPE_EQ] = ACTIONS(4288),
    [anon_sym_AMP] = ACTIONS(2515),
    [anon_sym_PIPE_PIPE] = ACTIONS(4288),
    [anon_sym_AMP_AMP] = ACTIONS(4288),
    [anon_sym_PIPE] = ACTIONS(2521),
    [anon_sym_CARET] = ACTIONS(2523),
    [anon_sym_EQ_EQ] = ACTIONS(2525),
    [anon_sym_BANG_EQ] = ACTIONS(2525),
    [anon_sym_LT] = ACTIONS(2527),
    [anon_sym_GT] = ACTIONS(2527),
    [anon_sym_LT_EQ] = ACTIONS(2529),
    [anon_sym_GT_EQ] = ACTIONS(2529),
    [anon_sym_LT_LT] = ACTIONS(2531),
    [anon_sym_GT_GT] = ACTIONS(2531),
    [anon_sym_PLUS] = ACTIONS(2533),
    [anon_sym_DASH] = ACTIONS(2533),
    [anon_sym_SLASH] = ACTIONS(2507),
    [anon_sym_PERCENT] = ACTIONS(2507),
    [anon_sym_DASH_DASH] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(1554),
    [anon_sym_DASH_GT] = ACTIONS(1554),
    [sym_comment] = ACTIONS(49),
  },
  [1803] = {
    [sym_argument_list] = STATE(802),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_COMMA] = ACTIONS(4284),
    [anon_sym_RBRACE] = ACTIONS(4284),
    [anon_sym_STAR] = ACTIONS(2507),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_EQ] = ACTIONS(4286),
    [anon_sym_QMARK] = ACTIONS(4284),
    [anon_sym_STAR_EQ] = ACTIONS(4284),
    [anon_sym_SLASH_EQ] = ACTIONS(4284),
    [anon_sym_PERCENT_EQ] = ACTIONS(4284),
    [anon_sym_PLUS_EQ] = ACTIONS(4284),
    [anon_sym_DASH_EQ] = ACTIONS(4284),
    [anon_sym_LT_LT_EQ] = ACTIONS(4284),
    [anon_sym_GT_GT_EQ] = ACTIONS(4284),
    [anon_sym_AMP_EQ] = ACTIONS(4284),
    [anon_sym_CARET_EQ] = ACTIONS(4284),
    [anon_sym_PIPE_EQ] = ACTIONS(4284),
    [anon_sym_AMP] = ACTIONS(2515),
    [anon_sym_PIPE_PIPE] = ACTIONS(4284),
    [anon_sym_AMP_AMP] = ACTIONS(4284),
    [anon_sym_PIPE] = ACTIONS(4286),
    [anon_sym_CARET] = ACTIONS(2523),
    [anon_sym_EQ_EQ] = ACTIONS(2525),
    [anon_sym_BANG_EQ] = ACTIONS(2525),
    [anon_sym_LT] = ACTIONS(2527),
    [anon_sym_GT] = ACTIONS(2527),
    [anon_sym_LT_EQ] = ACTIONS(2529),
    [anon_sym_GT_EQ] = ACTIONS(2529),
    [anon_sym_LT_LT] = ACTIONS(2531),
    [anon_sym_GT_GT] = ACTIONS(2531),
    [anon_sym_PLUS] = ACTIONS(2533),
    [anon_sym_DASH] = ACTIONS(2533),
    [anon_sym_SLASH] = ACTIONS(2507),
    [anon_sym_PERCENT] = ACTIONS(2507),
    [anon_sym_DASH_DASH] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(1554),
    [anon_sym_DASH_GT] = ACTIONS(1554),
    [sym_comment] = ACTIONS(49),
  },
  [1804] = {
    [sym_argument_list] = STATE(802),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_COMMA] = ACTIONS(4284),
    [anon_sym_RBRACE] = ACTIONS(4284),
    [anon_sym_STAR] = ACTIONS(2507),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_EQ] = ACTIONS(4286),
    [anon_sym_QMARK] = ACTIONS(4284),
    [anon_sym_STAR_EQ] = ACTIONS(4284),
    [anon_sym_SLASH_EQ] = ACTIONS(4284),
    [anon_sym_PERCENT_EQ] = ACTIONS(4284),
    [anon_sym_PLUS_EQ] = ACTIONS(4284),
    [anon_sym_DASH_EQ] = ACTIONS(4284),
    [anon_sym_LT_LT_EQ] = ACTIONS(4284),
    [anon_sym_GT_GT_EQ] = ACTIONS(4284),
    [anon_sym_AMP_EQ] = ACTIONS(4284),
    [anon_sym_CARET_EQ] = ACTIONS(4284),
    [anon_sym_PIPE_EQ] = ACTIONS(4284),
    [anon_sym_AMP] = ACTIONS(2515),
    [anon_sym_PIPE_PIPE] = ACTIONS(4284),
    [anon_sym_AMP_AMP] = ACTIONS(4284),
    [anon_sym_PIPE] = ACTIONS(4286),
    [anon_sym_CARET] = ACTIONS(4286),
    [anon_sym_EQ_EQ] = ACTIONS(2525),
    [anon_sym_BANG_EQ] = ACTIONS(2525),
    [anon_sym_LT] = ACTIONS(2527),
    [anon_sym_GT] = ACTIONS(2527),
    [anon_sym_LT_EQ] = ACTIONS(2529),
    [anon_sym_GT_EQ] = ACTIONS(2529),
    [anon_sym_LT_LT] = ACTIONS(2531),
    [anon_sym_GT_GT] = ACTIONS(2531),
    [anon_sym_PLUS] = ACTIONS(2533),
    [anon_sym_DASH] = ACTIONS(2533),
    [anon_sym_SLASH] = ACTIONS(2507),
    [anon_sym_PERCENT] = ACTIONS(2507),
    [anon_sym_DASH_DASH] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(1554),
    [anon_sym_DASH_GT] = ACTIONS(1554),
    [sym_comment] = ACTIONS(49),
  },
  [1805] = {
    [sym_argument_list] = STATE(802),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_COMMA] = ACTIONS(4292),
    [anon_sym_RBRACE] = ACTIONS(4292),
    [anon_sym_STAR] = ACTIONS(2507),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_EQ] = ACTIONS(4294),
    [anon_sym_QMARK] = ACTIONS(4292),
    [anon_sym_STAR_EQ] = ACTIONS(4292),
    [anon_sym_SLASH_EQ] = ACTIONS(4292),
    [anon_sym_PERCENT_EQ] = ACTIONS(4292),
    [anon_sym_PLUS_EQ] = ACTIONS(4292),
    [anon_sym_DASH_EQ] = ACTIONS(4292),
    [anon_sym_LT_LT_EQ] = ACTIONS(4292),
    [anon_sym_GT_GT_EQ] = ACTIONS(4292),
    [anon_sym_AMP_EQ] = ACTIONS(4292),
    [anon_sym_CARET_EQ] = ACTIONS(4292),
    [anon_sym_PIPE_EQ] = ACTIONS(4292),
    [anon_sym_AMP] = ACTIONS(4294),
    [anon_sym_PIPE_PIPE] = ACTIONS(4292),
    [anon_sym_AMP_AMP] = ACTIONS(4292),
    [anon_sym_PIPE] = ACTIONS(4294),
    [anon_sym_CARET] = ACTIONS(4294),
    [anon_sym_EQ_EQ] = ACTIONS(4292),
    [anon_sym_BANG_EQ] = ACTIONS(4292),
    [anon_sym_LT] = ACTIONS(2527),
    [anon_sym_GT] = ACTIONS(2527),
    [anon_sym_LT_EQ] = ACTIONS(2529),
    [anon_sym_GT_EQ] = ACTIONS(2529),
    [anon_sym_LT_LT] = ACTIONS(2531),
    [anon_sym_GT_GT] = ACTIONS(2531),
    [anon_sym_PLUS] = ACTIONS(2533),
    [anon_sym_DASH] = ACTIONS(2533),
    [anon_sym_SLASH] = ACTIONS(2507),
    [anon_sym_PERCENT] = ACTIONS(2507),
    [anon_sym_DASH_DASH] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(1554),
    [anon_sym_DASH_GT] = ACTIONS(1554),
    [sym_comment] = ACTIONS(49),
  },
  [1806] = {
    [sym_argument_list] = STATE(802),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_COMMA] = ACTIONS(4296),
    [anon_sym_RBRACE] = ACTIONS(4296),
    [anon_sym_STAR] = ACTIONS(2507),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_EQ] = ACTIONS(4298),
    [anon_sym_QMARK] = ACTIONS(4296),
    [anon_sym_STAR_EQ] = ACTIONS(4296),
    [anon_sym_SLASH_EQ] = ACTIONS(4296),
    [anon_sym_PERCENT_EQ] = ACTIONS(4296),
    [anon_sym_PLUS_EQ] = ACTIONS(4296),
    [anon_sym_DASH_EQ] = ACTIONS(4296),
    [anon_sym_LT_LT_EQ] = ACTIONS(4296),
    [anon_sym_GT_GT_EQ] = ACTIONS(4296),
    [anon_sym_AMP_EQ] = ACTIONS(4296),
    [anon_sym_CARET_EQ] = ACTIONS(4296),
    [anon_sym_PIPE_EQ] = ACTIONS(4296),
    [anon_sym_AMP] = ACTIONS(4298),
    [anon_sym_PIPE_PIPE] = ACTIONS(4296),
    [anon_sym_AMP_AMP] = ACTIONS(4296),
    [anon_sym_PIPE] = ACTIONS(4298),
    [anon_sym_CARET] = ACTIONS(4298),
    [anon_sym_EQ_EQ] = ACTIONS(4296),
    [anon_sym_BANG_EQ] = ACTIONS(4296),
    [anon_sym_LT] = ACTIONS(4298),
    [anon_sym_GT] = ACTIONS(4298),
    [anon_sym_LT_EQ] = ACTIONS(4296),
    [anon_sym_GT_EQ] = ACTIONS(4296),
    [anon_sym_LT_LT] = ACTIONS(2531),
    [anon_sym_GT_GT] = ACTIONS(2531),
    [anon_sym_PLUS] = ACTIONS(2533),
    [anon_sym_DASH] = ACTIONS(2533),
    [anon_sym_SLASH] = ACTIONS(2507),
    [anon_sym_PERCENT] = ACTIONS(2507),
    [anon_sym_DASH_DASH] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(1554),
    [anon_sym_DASH_GT] = ACTIONS(1554),
    [sym_comment] = ACTIONS(49),
  },
  [1807] = {
    [sym_argument_list] = STATE(802),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_COMMA] = ACTIONS(4300),
    [anon_sym_RBRACE] = ACTIONS(4300),
    [anon_sym_STAR] = ACTIONS(2507),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_EQ] = ACTIONS(4302),
    [anon_sym_QMARK] = ACTIONS(4300),
    [anon_sym_STAR_EQ] = ACTIONS(4300),
    [anon_sym_SLASH_EQ] = ACTIONS(4300),
    [anon_sym_PERCENT_EQ] = ACTIONS(4300),
    [anon_sym_PLUS_EQ] = ACTIONS(4300),
    [anon_sym_DASH_EQ] = ACTIONS(4300),
    [anon_sym_LT_LT_EQ] = ACTIONS(4300),
    [anon_sym_GT_GT_EQ] = ACTIONS(4300),
    [anon_sym_AMP_EQ] = ACTIONS(4300),
    [anon_sym_CARET_EQ] = ACTIONS(4300),
    [anon_sym_PIPE_EQ] = ACTIONS(4300),
    [anon_sym_AMP] = ACTIONS(4302),
    [anon_sym_PIPE_PIPE] = ACTIONS(4300),
    [anon_sym_AMP_AMP] = ACTIONS(4300),
    [anon_sym_PIPE] = ACTIONS(4302),
    [anon_sym_CARET] = ACTIONS(4302),
    [anon_sym_EQ_EQ] = ACTIONS(4300),
    [anon_sym_BANG_EQ] = ACTIONS(4300),
    [anon_sym_LT] = ACTIONS(4302),
    [anon_sym_GT] = ACTIONS(4302),
    [anon_sym_LT_EQ] = ACTIONS(4300),
    [anon_sym_GT_EQ] = ACTIONS(4300),
    [anon_sym_LT_LT] = ACTIONS(4302),
    [anon_sym_GT_GT] = ACTIONS(4302),
    [anon_sym_PLUS] = ACTIONS(2533),
    [anon_sym_DASH] = ACTIONS(2533),
    [anon_sym_SLASH] = ACTIONS(2507),
    [anon_sym_PERCENT] = ACTIONS(2507),
    [anon_sym_DASH_DASH] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(1554),
    [anon_sym_DASH_GT] = ACTIONS(1554),
    [sym_comment] = ACTIONS(49),
  },
  [1808] = {
    [sym_argument_list] = STATE(802),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_COMMA] = ACTIONS(4274),
    [anon_sym_RBRACE] = ACTIONS(4274),
    [anon_sym_STAR] = ACTIONS(2507),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_EQ] = ACTIONS(4276),
    [anon_sym_QMARK] = ACTIONS(4274),
    [anon_sym_STAR_EQ] = ACTIONS(4274),
    [anon_sym_SLASH_EQ] = ACTIONS(4274),
    [anon_sym_PERCENT_EQ] = ACTIONS(4274),
    [anon_sym_PLUS_EQ] = ACTIONS(4274),
    [anon_sym_DASH_EQ] = ACTIONS(4274),
    [anon_sym_LT_LT_EQ] = ACTIONS(4274),
    [anon_sym_GT_GT_EQ] = ACTIONS(4274),
    [anon_sym_AMP_EQ] = ACTIONS(4274),
    [anon_sym_CARET_EQ] = ACTIONS(4274),
    [anon_sym_PIPE_EQ] = ACTIONS(4274),
    [anon_sym_AMP] = ACTIONS(4276),
    [anon_sym_PIPE_PIPE] = ACTIONS(4274),
    [anon_sym_AMP_AMP] = ACTIONS(4274),
    [anon_sym_PIPE] = ACTIONS(4276),
    [anon_sym_CARET] = ACTIONS(4276),
    [anon_sym_EQ_EQ] = ACTIONS(4274),
    [anon_sym_BANG_EQ] = ACTIONS(4274),
    [anon_sym_LT] = ACTIONS(4276),
    [anon_sym_GT] = ACTIONS(4276),
    [anon_sym_LT_EQ] = ACTIONS(4274),
    [anon_sym_GT_EQ] = ACTIONS(4274),
    [anon_sym_LT_LT] = ACTIONS(4276),
    [anon_sym_GT_GT] = ACTIONS(4276),
    [anon_sym_PLUS] = ACTIONS(4276),
    [anon_sym_DASH] = ACTIONS(4276),
    [anon_sym_SLASH] = ACTIONS(2507),
    [anon_sym_PERCENT] = ACTIONS(2507),
    [anon_sym_DASH_DASH] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(1554),
    [anon_sym_DASH_GT] = ACTIONS(1554),
    [sym_comment] = ACTIONS(49),
  },
  [1809] = {
    [sym__expression] = STATE(1834),
    [sym_conditional_expression] = STATE(1834),
    [sym_assignment_expression] = STATE(1834),
    [sym_pointer_expression] = STATE(1834),
    [sym_logical_expression] = STATE(1834),
    [sym_bitwise_expression] = STATE(1834),
    [sym_equality_expression] = STATE(1834),
    [sym_relational_expression] = STATE(1834),
    [sym_shift_expression] = STATE(1834),
    [sym_math_expression] = STATE(1834),
    [sym_cast_expression] = STATE(1834),
    [sym_sizeof_expression] = STATE(1834),
    [sym_subscript_expression] = STATE(1834),
    [sym_call_expression] = STATE(1834),
    [sym_field_expression] = STATE(1834),
    [sym_compound_literal_expression] = STATE(1834),
    [sym_parenthesized_expression] = STATE(1834),
    [sym_initializer_list] = STATE(1835),
    [sym_concatenated_string] = STATE(1834),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(1834),
    [sym_new_expression] = STATE(1834),
    [sym_delete_expression] = STATE(1834),
    [sym_lambda_expression] = STATE(1834),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(4145),
    [anon_sym_LPAREN] = ACTIONS(1347),
    [anon_sym_LBRACE] = ACTIONS(548),
    [anon_sym_STAR] = ACTIONS(1349),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_AMP] = ACTIONS(1349),
    [anon_sym_BANG] = ACTIONS(1351),
    [anon_sym_TILDE] = ACTIONS(1353),
    [anon_sym_PLUS] = ACTIONS(1355),
    [anon_sym_DASH] = ACTIONS(1355),
    [anon_sym_DASH_DASH] = ACTIONS(1357),
    [anon_sym_PLUS_PLUS] = ACTIONS(1357),
    [anon_sym_sizeof] = ACTIONS(1359),
    [sym_number_literal] = ACTIONS(4145),
    [sym_char_literal] = ACTIONS(4145),
    [sym_string_literal] = ACTIONS(1361),
    [sym_true] = ACTIONS(4147),
    [sym_false] = ACTIONS(4147),
    [sym_null] = ACTIONS(4147),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1365),
    [anon_sym_delete] = ACTIONS(1367),
    [sym_nullptr] = ACTIONS(4147),
  },
  [1810] = {
    [anon_sym_RPAREN] = ACTIONS(5142),
    [sym_comment] = ACTIONS(49),
  },
  [1811] = {
    [aux_sym_concatenated_string_repeat1] = STATE(1811),
    [anon_sym_LPAREN] = ACTIONS(4230),
    [anon_sym_SEMI] = ACTIONS(4230),
    [anon_sym_STAR] = ACTIONS(4232),
    [anon_sym_LBRACK] = ACTIONS(4230),
    [anon_sym_EQ] = ACTIONS(4232),
    [anon_sym_QMARK] = ACTIONS(4230),
    [anon_sym_STAR_EQ] = ACTIONS(4230),
    [anon_sym_SLASH_EQ] = ACTIONS(4230),
    [anon_sym_PERCENT_EQ] = ACTIONS(4230),
    [anon_sym_PLUS_EQ] = ACTIONS(4230),
    [anon_sym_DASH_EQ] = ACTIONS(4230),
    [anon_sym_LT_LT_EQ] = ACTIONS(4230),
    [anon_sym_GT_GT_EQ] = ACTIONS(4230),
    [anon_sym_AMP_EQ] = ACTIONS(4230),
    [anon_sym_CARET_EQ] = ACTIONS(4230),
    [anon_sym_PIPE_EQ] = ACTIONS(4230),
    [anon_sym_AMP] = ACTIONS(4232),
    [anon_sym_PIPE_PIPE] = ACTIONS(4230),
    [anon_sym_AMP_AMP] = ACTIONS(4230),
    [anon_sym_PIPE] = ACTIONS(4232),
    [anon_sym_CARET] = ACTIONS(4232),
    [anon_sym_EQ_EQ] = ACTIONS(4230),
    [anon_sym_BANG_EQ] = ACTIONS(4230),
    [anon_sym_LT] = ACTIONS(4232),
    [anon_sym_GT] = ACTIONS(4232),
    [anon_sym_LT_EQ] = ACTIONS(4230),
    [anon_sym_GT_EQ] = ACTIONS(4230),
    [anon_sym_LT_LT] = ACTIONS(4232),
    [anon_sym_GT_GT] = ACTIONS(4232),
    [anon_sym_PLUS] = ACTIONS(4232),
    [anon_sym_DASH] = ACTIONS(4232),
    [anon_sym_SLASH] = ACTIONS(4232),
    [anon_sym_PERCENT] = ACTIONS(4232),
    [anon_sym_DASH_DASH] = ACTIONS(4230),
    [anon_sym_PLUS_PLUS] = ACTIONS(4230),
    [anon_sym_DOT] = ACTIONS(4230),
    [anon_sym_DASH_GT] = ACTIONS(4230),
    [sym_string_literal] = ACTIONS(5144),
    [sym_comment] = ACTIONS(49),
  },
  [1812] = {
    [sym__expression] = STATE(740),
    [sym_conditional_expression] = STATE(740),
    [sym_assignment_expression] = STATE(740),
    [sym_pointer_expression] = STATE(740),
    [sym_logical_expression] = STATE(740),
    [sym_bitwise_expression] = STATE(740),
    [sym_equality_expression] = STATE(740),
    [sym_relational_expression] = STATE(740),
    [sym_shift_expression] = STATE(740),
    [sym_math_expression] = STATE(740),
    [sym_cast_expression] = STATE(740),
    [sym_sizeof_expression] = STATE(740),
    [sym_subscript_expression] = STATE(740),
    [sym_call_expression] = STATE(740),
    [sym_field_expression] = STATE(740),
    [sym_compound_literal_expression] = STATE(740),
    [sym_parenthesized_expression] = STATE(740),
    [sym_concatenated_string] = STATE(740),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(740),
    [sym_new_expression] = STATE(740),
    [sym_delete_expression] = STATE(740),
    [sym_lambda_expression] = STATE(740),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_lambda_default_capture] = STATE(741),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(1417),
    [anon_sym_LPAREN] = ACTIONS(1419),
    [anon_sym_STAR] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_RBRACK] = ACTIONS(5147),
    [anon_sym_EQ] = ACTIONS(1425),
    [anon_sym_AMP] = ACTIONS(1427),
    [anon_sym_BANG] = ACTIONS(1429),
    [anon_sym_TILDE] = ACTIONS(1431),
    [anon_sym_PLUS] = ACTIONS(1433),
    [anon_sym_DASH] = ACTIONS(1433),
    [anon_sym_DASH_DASH] = ACTIONS(1435),
    [anon_sym_PLUS_PLUS] = ACTIONS(1435),
    [anon_sym_sizeof] = ACTIONS(1437),
    [sym_number_literal] = ACTIONS(1417),
    [sym_char_literal] = ACTIONS(1417),
    [sym_string_literal] = ACTIONS(1439),
    [sym_true] = ACTIONS(1441),
    [sym_false] = ACTIONS(1441),
    [sym_null] = ACTIONS(1441),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1443),
    [anon_sym_delete] = ACTIONS(1445),
    [sym_nullptr] = ACTIONS(1441),
  },
  [1813] = {
    [sym_argument_list] = STATE(802),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_SEMI] = ACTIONS(4258),
    [anon_sym_STAR] = ACTIONS(2553),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_EQ] = ACTIONS(4260),
    [anon_sym_QMARK] = ACTIONS(4258),
    [anon_sym_STAR_EQ] = ACTIONS(4258),
    [anon_sym_SLASH_EQ] = ACTIONS(4258),
    [anon_sym_PERCENT_EQ] = ACTIONS(4258),
    [anon_sym_PLUS_EQ] = ACTIONS(4258),
    [anon_sym_DASH_EQ] = ACTIONS(4258),
    [anon_sym_LT_LT_EQ] = ACTIONS(4258),
    [anon_sym_GT_GT_EQ] = ACTIONS(4258),
    [anon_sym_AMP_EQ] = ACTIONS(4258),
    [anon_sym_CARET_EQ] = ACTIONS(4258),
    [anon_sym_PIPE_EQ] = ACTIONS(4258),
    [anon_sym_AMP] = ACTIONS(2561),
    [anon_sym_PIPE_PIPE] = ACTIONS(2563),
    [anon_sym_AMP_AMP] = ACTIONS(2565),
    [anon_sym_PIPE] = ACTIONS(2567),
    [anon_sym_CARET] = ACTIONS(2569),
    [anon_sym_EQ_EQ] = ACTIONS(2571),
    [anon_sym_BANG_EQ] = ACTIONS(2571),
    [anon_sym_LT] = ACTIONS(2573),
    [anon_sym_GT] = ACTIONS(2573),
    [anon_sym_LT_EQ] = ACTIONS(2575),
    [anon_sym_GT_EQ] = ACTIONS(2575),
    [anon_sym_LT_LT] = ACTIONS(2577),
    [anon_sym_GT_GT] = ACTIONS(2577),
    [anon_sym_PLUS] = ACTIONS(2579),
    [anon_sym_DASH] = ACTIONS(2579),
    [anon_sym_SLASH] = ACTIONS(2553),
    [anon_sym_PERCENT] = ACTIONS(2553),
    [anon_sym_DASH_DASH] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(1554),
    [anon_sym_DASH_GT] = ACTIONS(1554),
    [sym_comment] = ACTIONS(49),
  },
  [1814] = {
    [sym__expression] = STATE(2223),
    [sym_conditional_expression] = STATE(2223),
    [sym_assignment_expression] = STATE(2223),
    [sym_pointer_expression] = STATE(2223),
    [sym_logical_expression] = STATE(2223),
    [sym_bitwise_expression] = STATE(2223),
    [sym_equality_expression] = STATE(2223),
    [sym_relational_expression] = STATE(2223),
    [sym_shift_expression] = STATE(2223),
    [sym_math_expression] = STATE(2223),
    [sym_cast_expression] = STATE(2223),
    [sym_sizeof_expression] = STATE(2223),
    [sym_subscript_expression] = STATE(2223),
    [sym_call_expression] = STATE(2223),
    [sym_field_expression] = STATE(2223),
    [sym_compound_literal_expression] = STATE(2223),
    [sym_parenthesized_expression] = STATE(2223),
    [sym_concatenated_string] = STATE(2223),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(2223),
    [sym_new_expression] = STATE(2223),
    [sym_delete_expression] = STATE(2223),
    [sym_lambda_expression] = STATE(2223),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(5149),
    [anon_sym_LPAREN] = ACTIONS(2624),
    [anon_sym_STAR] = ACTIONS(2624),
    [anon_sym_LBRACK] = ACTIONS(2624),
    [anon_sym_AMP] = ACTIONS(2626),
    [anon_sym_AMP_AMP] = ACTIONS(2624),
    [anon_sym_BANG] = ACTIONS(1351),
    [anon_sym_TILDE] = ACTIONS(1353),
    [anon_sym_PLUS] = ACTIONS(1355),
    [anon_sym_DASH] = ACTIONS(1355),
    [anon_sym_DASH_DASH] = ACTIONS(1357),
    [anon_sym_PLUS_PLUS] = ACTIONS(1357),
    [anon_sym_sizeof] = ACTIONS(1359),
    [sym_number_literal] = ACTIONS(5149),
    [sym_char_literal] = ACTIONS(5149),
    [sym_string_literal] = ACTIONS(1361),
    [sym_true] = ACTIONS(5151),
    [sym_false] = ACTIONS(5151),
    [sym_null] = ACTIONS(5151),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1365),
    [anon_sym_delete] = ACTIONS(1367),
    [sym_nullptr] = ACTIONS(5151),
  },
  [1815] = {
    [sym_argument_list] = STATE(802),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_SEMI] = ACTIONS(4280),
    [anon_sym_STAR] = ACTIONS(2553),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_EQ] = ACTIONS(2555),
    [anon_sym_QMARK] = ACTIONS(4280),
    [anon_sym_STAR_EQ] = ACTIONS(2559),
    [anon_sym_SLASH_EQ] = ACTIONS(2559),
    [anon_sym_PERCENT_EQ] = ACTIONS(2559),
    [anon_sym_PLUS_EQ] = ACTIONS(2559),
    [anon_sym_DASH_EQ] = ACTIONS(2559),
    [anon_sym_LT_LT_EQ] = ACTIONS(2559),
    [anon_sym_GT_GT_EQ] = ACTIONS(2559),
    [anon_sym_AMP_EQ] = ACTIONS(2559),
    [anon_sym_CARET_EQ] = ACTIONS(2559),
    [anon_sym_PIPE_EQ] = ACTIONS(2559),
    [anon_sym_AMP] = ACTIONS(2561),
    [anon_sym_PIPE_PIPE] = ACTIONS(2563),
    [anon_sym_AMP_AMP] = ACTIONS(2565),
    [anon_sym_PIPE] = ACTIONS(2567),
    [anon_sym_CARET] = ACTIONS(2569),
    [anon_sym_EQ_EQ] = ACTIONS(2571),
    [anon_sym_BANG_EQ] = ACTIONS(2571),
    [anon_sym_LT] = ACTIONS(2573),
    [anon_sym_GT] = ACTIONS(2573),
    [anon_sym_LT_EQ] = ACTIONS(2575),
    [anon_sym_GT_EQ] = ACTIONS(2575),
    [anon_sym_LT_LT] = ACTIONS(2577),
    [anon_sym_GT_GT] = ACTIONS(2577),
    [anon_sym_PLUS] = ACTIONS(2579),
    [anon_sym_DASH] = ACTIONS(2579),
    [anon_sym_SLASH] = ACTIONS(2553),
    [anon_sym_PERCENT] = ACTIONS(2553),
    [anon_sym_DASH_DASH] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(1554),
    [anon_sym_DASH_GT] = ACTIONS(1554),
    [sym_comment] = ACTIONS(49),
  },
  [1816] = {
    [sym_argument_list] = STATE(802),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_STAR] = ACTIONS(3003),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_EQ] = ACTIONS(3005),
    [anon_sym_COLON] = ACTIONS(5153),
    [anon_sym_QMARK] = ACTIONS(3009),
    [anon_sym_STAR_EQ] = ACTIONS(3011),
    [anon_sym_SLASH_EQ] = ACTIONS(3011),
    [anon_sym_PERCENT_EQ] = ACTIONS(3011),
    [anon_sym_PLUS_EQ] = ACTIONS(3011),
    [anon_sym_DASH_EQ] = ACTIONS(3011),
    [anon_sym_LT_LT_EQ] = ACTIONS(3011),
    [anon_sym_GT_GT_EQ] = ACTIONS(3011),
    [anon_sym_AMP_EQ] = ACTIONS(3011),
    [anon_sym_CARET_EQ] = ACTIONS(3011),
    [anon_sym_PIPE_EQ] = ACTIONS(3011),
    [anon_sym_AMP] = ACTIONS(3013),
    [anon_sym_PIPE_PIPE] = ACTIONS(3015),
    [anon_sym_AMP_AMP] = ACTIONS(3017),
    [anon_sym_PIPE] = ACTIONS(3019),
    [anon_sym_CARET] = ACTIONS(3021),
    [anon_sym_EQ_EQ] = ACTIONS(3023),
    [anon_sym_BANG_EQ] = ACTIONS(3023),
    [anon_sym_LT] = ACTIONS(3025),
    [anon_sym_GT] = ACTIONS(3025),
    [anon_sym_LT_EQ] = ACTIONS(3027),
    [anon_sym_GT_EQ] = ACTIONS(3027),
    [anon_sym_LT_LT] = ACTIONS(3029),
    [anon_sym_GT_GT] = ACTIONS(3029),
    [anon_sym_PLUS] = ACTIONS(3031),
    [anon_sym_DASH] = ACTIONS(3031),
    [anon_sym_SLASH] = ACTIONS(3003),
    [anon_sym_PERCENT] = ACTIONS(3003),
    [anon_sym_DASH_DASH] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(3033),
    [anon_sym_DASH_GT] = ACTIONS(3033),
    [sym_comment] = ACTIONS(49),
  },
  [1817] = {
    [sym_argument_list] = STATE(802),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_SEMI] = ACTIONS(4284),
    [anon_sym_STAR] = ACTIONS(2553),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_EQ] = ACTIONS(4286),
    [anon_sym_QMARK] = ACTIONS(4284),
    [anon_sym_STAR_EQ] = ACTIONS(4284),
    [anon_sym_SLASH_EQ] = ACTIONS(4284),
    [anon_sym_PERCENT_EQ] = ACTIONS(4284),
    [anon_sym_PLUS_EQ] = ACTIONS(4284),
    [anon_sym_DASH_EQ] = ACTIONS(4284),
    [anon_sym_LT_LT_EQ] = ACTIONS(4284),
    [anon_sym_GT_GT_EQ] = ACTIONS(4284),
    [anon_sym_AMP_EQ] = ACTIONS(4284),
    [anon_sym_CARET_EQ] = ACTIONS(4284),
    [anon_sym_PIPE_EQ] = ACTIONS(4284),
    [anon_sym_AMP] = ACTIONS(4286),
    [anon_sym_PIPE_PIPE] = ACTIONS(4284),
    [anon_sym_AMP_AMP] = ACTIONS(4284),
    [anon_sym_PIPE] = ACTIONS(4286),
    [anon_sym_CARET] = ACTIONS(4286),
    [anon_sym_EQ_EQ] = ACTIONS(2571),
    [anon_sym_BANG_EQ] = ACTIONS(2571),
    [anon_sym_LT] = ACTIONS(2573),
    [anon_sym_GT] = ACTIONS(2573),
    [anon_sym_LT_EQ] = ACTIONS(2575),
    [anon_sym_GT_EQ] = ACTIONS(2575),
    [anon_sym_LT_LT] = ACTIONS(2577),
    [anon_sym_GT_GT] = ACTIONS(2577),
    [anon_sym_PLUS] = ACTIONS(2579),
    [anon_sym_DASH] = ACTIONS(2579),
    [anon_sym_SLASH] = ACTIONS(2553),
    [anon_sym_PERCENT] = ACTIONS(2553),
    [anon_sym_DASH_DASH] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(1554),
    [anon_sym_DASH_GT] = ACTIONS(1554),
    [sym_comment] = ACTIONS(49),
  },
  [1818] = {
    [sym_argument_list] = STATE(802),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_SEMI] = ACTIONS(4288),
    [anon_sym_STAR] = ACTIONS(2553),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_EQ] = ACTIONS(4290),
    [anon_sym_QMARK] = ACTIONS(4288),
    [anon_sym_STAR_EQ] = ACTIONS(4288),
    [anon_sym_SLASH_EQ] = ACTIONS(4288),
    [anon_sym_PERCENT_EQ] = ACTIONS(4288),
    [anon_sym_PLUS_EQ] = ACTIONS(4288),
    [anon_sym_DASH_EQ] = ACTIONS(4288),
    [anon_sym_LT_LT_EQ] = ACTIONS(4288),
    [anon_sym_GT_GT_EQ] = ACTIONS(4288),
    [anon_sym_AMP_EQ] = ACTIONS(4288),
    [anon_sym_CARET_EQ] = ACTIONS(4288),
    [anon_sym_PIPE_EQ] = ACTIONS(4288),
    [anon_sym_AMP] = ACTIONS(2561),
    [anon_sym_PIPE_PIPE] = ACTIONS(4288),
    [anon_sym_AMP_AMP] = ACTIONS(2565),
    [anon_sym_PIPE] = ACTIONS(2567),
    [anon_sym_CARET] = ACTIONS(2569),
    [anon_sym_EQ_EQ] = ACTIONS(2571),
    [anon_sym_BANG_EQ] = ACTIONS(2571),
    [anon_sym_LT] = ACTIONS(2573),
    [anon_sym_GT] = ACTIONS(2573),
    [anon_sym_LT_EQ] = ACTIONS(2575),
    [anon_sym_GT_EQ] = ACTIONS(2575),
    [anon_sym_LT_LT] = ACTIONS(2577),
    [anon_sym_GT_GT] = ACTIONS(2577),
    [anon_sym_PLUS] = ACTIONS(2579),
    [anon_sym_DASH] = ACTIONS(2579),
    [anon_sym_SLASH] = ACTIONS(2553),
    [anon_sym_PERCENT] = ACTIONS(2553),
    [anon_sym_DASH_DASH] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(1554),
    [anon_sym_DASH_GT] = ACTIONS(1554),
    [sym_comment] = ACTIONS(49),
  },
  [1819] = {
    [sym_argument_list] = STATE(802),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_SEMI] = ACTIONS(4288),
    [anon_sym_STAR] = ACTIONS(2553),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_EQ] = ACTIONS(4290),
    [anon_sym_QMARK] = ACTIONS(4288),
    [anon_sym_STAR_EQ] = ACTIONS(4288),
    [anon_sym_SLASH_EQ] = ACTIONS(4288),
    [anon_sym_PERCENT_EQ] = ACTIONS(4288),
    [anon_sym_PLUS_EQ] = ACTIONS(4288),
    [anon_sym_DASH_EQ] = ACTIONS(4288),
    [anon_sym_LT_LT_EQ] = ACTIONS(4288),
    [anon_sym_GT_GT_EQ] = ACTIONS(4288),
    [anon_sym_AMP_EQ] = ACTIONS(4288),
    [anon_sym_CARET_EQ] = ACTIONS(4288),
    [anon_sym_PIPE_EQ] = ACTIONS(4288),
    [anon_sym_AMP] = ACTIONS(2561),
    [anon_sym_PIPE_PIPE] = ACTIONS(4288),
    [anon_sym_AMP_AMP] = ACTIONS(4288),
    [anon_sym_PIPE] = ACTIONS(2567),
    [anon_sym_CARET] = ACTIONS(2569),
    [anon_sym_EQ_EQ] = ACTIONS(2571),
    [anon_sym_BANG_EQ] = ACTIONS(2571),
    [anon_sym_LT] = ACTIONS(2573),
    [anon_sym_GT] = ACTIONS(2573),
    [anon_sym_LT_EQ] = ACTIONS(2575),
    [anon_sym_GT_EQ] = ACTIONS(2575),
    [anon_sym_LT_LT] = ACTIONS(2577),
    [anon_sym_GT_GT] = ACTIONS(2577),
    [anon_sym_PLUS] = ACTIONS(2579),
    [anon_sym_DASH] = ACTIONS(2579),
    [anon_sym_SLASH] = ACTIONS(2553),
    [anon_sym_PERCENT] = ACTIONS(2553),
    [anon_sym_DASH_DASH] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(1554),
    [anon_sym_DASH_GT] = ACTIONS(1554),
    [sym_comment] = ACTIONS(49),
  },
  [1820] = {
    [sym_argument_list] = STATE(802),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_SEMI] = ACTIONS(4284),
    [anon_sym_STAR] = ACTIONS(2553),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_EQ] = ACTIONS(4286),
    [anon_sym_QMARK] = ACTIONS(4284),
    [anon_sym_STAR_EQ] = ACTIONS(4284),
    [anon_sym_SLASH_EQ] = ACTIONS(4284),
    [anon_sym_PERCENT_EQ] = ACTIONS(4284),
    [anon_sym_PLUS_EQ] = ACTIONS(4284),
    [anon_sym_DASH_EQ] = ACTIONS(4284),
    [anon_sym_LT_LT_EQ] = ACTIONS(4284),
    [anon_sym_GT_GT_EQ] = ACTIONS(4284),
    [anon_sym_AMP_EQ] = ACTIONS(4284),
    [anon_sym_CARET_EQ] = ACTIONS(4284),
    [anon_sym_PIPE_EQ] = ACTIONS(4284),
    [anon_sym_AMP] = ACTIONS(2561),
    [anon_sym_PIPE_PIPE] = ACTIONS(4284),
    [anon_sym_AMP_AMP] = ACTIONS(4284),
    [anon_sym_PIPE] = ACTIONS(4286),
    [anon_sym_CARET] = ACTIONS(2569),
    [anon_sym_EQ_EQ] = ACTIONS(2571),
    [anon_sym_BANG_EQ] = ACTIONS(2571),
    [anon_sym_LT] = ACTIONS(2573),
    [anon_sym_GT] = ACTIONS(2573),
    [anon_sym_LT_EQ] = ACTIONS(2575),
    [anon_sym_GT_EQ] = ACTIONS(2575),
    [anon_sym_LT_LT] = ACTIONS(2577),
    [anon_sym_GT_GT] = ACTIONS(2577),
    [anon_sym_PLUS] = ACTIONS(2579),
    [anon_sym_DASH] = ACTIONS(2579),
    [anon_sym_SLASH] = ACTIONS(2553),
    [anon_sym_PERCENT] = ACTIONS(2553),
    [anon_sym_DASH_DASH] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(1554),
    [anon_sym_DASH_GT] = ACTIONS(1554),
    [sym_comment] = ACTIONS(49),
  },
  [1821] = {
    [sym_argument_list] = STATE(802),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_SEMI] = ACTIONS(4284),
    [anon_sym_STAR] = ACTIONS(2553),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_EQ] = ACTIONS(4286),
    [anon_sym_QMARK] = ACTIONS(4284),
    [anon_sym_STAR_EQ] = ACTIONS(4284),
    [anon_sym_SLASH_EQ] = ACTIONS(4284),
    [anon_sym_PERCENT_EQ] = ACTIONS(4284),
    [anon_sym_PLUS_EQ] = ACTIONS(4284),
    [anon_sym_DASH_EQ] = ACTIONS(4284),
    [anon_sym_LT_LT_EQ] = ACTIONS(4284),
    [anon_sym_GT_GT_EQ] = ACTIONS(4284),
    [anon_sym_AMP_EQ] = ACTIONS(4284),
    [anon_sym_CARET_EQ] = ACTIONS(4284),
    [anon_sym_PIPE_EQ] = ACTIONS(4284),
    [anon_sym_AMP] = ACTIONS(2561),
    [anon_sym_PIPE_PIPE] = ACTIONS(4284),
    [anon_sym_AMP_AMP] = ACTIONS(4284),
    [anon_sym_PIPE] = ACTIONS(4286),
    [anon_sym_CARET] = ACTIONS(4286),
    [anon_sym_EQ_EQ] = ACTIONS(2571),
    [anon_sym_BANG_EQ] = ACTIONS(2571),
    [anon_sym_LT] = ACTIONS(2573),
    [anon_sym_GT] = ACTIONS(2573),
    [anon_sym_LT_EQ] = ACTIONS(2575),
    [anon_sym_GT_EQ] = ACTIONS(2575),
    [anon_sym_LT_LT] = ACTIONS(2577),
    [anon_sym_GT_GT] = ACTIONS(2577),
    [anon_sym_PLUS] = ACTIONS(2579),
    [anon_sym_DASH] = ACTIONS(2579),
    [anon_sym_SLASH] = ACTIONS(2553),
    [anon_sym_PERCENT] = ACTIONS(2553),
    [anon_sym_DASH_DASH] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(1554),
    [anon_sym_DASH_GT] = ACTIONS(1554),
    [sym_comment] = ACTIONS(49),
  },
  [1822] = {
    [sym_argument_list] = STATE(802),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_SEMI] = ACTIONS(4292),
    [anon_sym_STAR] = ACTIONS(2553),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_EQ] = ACTIONS(4294),
    [anon_sym_QMARK] = ACTIONS(4292),
    [anon_sym_STAR_EQ] = ACTIONS(4292),
    [anon_sym_SLASH_EQ] = ACTIONS(4292),
    [anon_sym_PERCENT_EQ] = ACTIONS(4292),
    [anon_sym_PLUS_EQ] = ACTIONS(4292),
    [anon_sym_DASH_EQ] = ACTIONS(4292),
    [anon_sym_LT_LT_EQ] = ACTIONS(4292),
    [anon_sym_GT_GT_EQ] = ACTIONS(4292),
    [anon_sym_AMP_EQ] = ACTIONS(4292),
    [anon_sym_CARET_EQ] = ACTIONS(4292),
    [anon_sym_PIPE_EQ] = ACTIONS(4292),
    [anon_sym_AMP] = ACTIONS(4294),
    [anon_sym_PIPE_PIPE] = ACTIONS(4292),
    [anon_sym_AMP_AMP] = ACTIONS(4292),
    [anon_sym_PIPE] = ACTIONS(4294),
    [anon_sym_CARET] = ACTIONS(4294),
    [anon_sym_EQ_EQ] = ACTIONS(4292),
    [anon_sym_BANG_EQ] = ACTIONS(4292),
    [anon_sym_LT] = ACTIONS(2573),
    [anon_sym_GT] = ACTIONS(2573),
    [anon_sym_LT_EQ] = ACTIONS(2575),
    [anon_sym_GT_EQ] = ACTIONS(2575),
    [anon_sym_LT_LT] = ACTIONS(2577),
    [anon_sym_GT_GT] = ACTIONS(2577),
    [anon_sym_PLUS] = ACTIONS(2579),
    [anon_sym_DASH] = ACTIONS(2579),
    [anon_sym_SLASH] = ACTIONS(2553),
    [anon_sym_PERCENT] = ACTIONS(2553),
    [anon_sym_DASH_DASH] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(1554),
    [anon_sym_DASH_GT] = ACTIONS(1554),
    [sym_comment] = ACTIONS(49),
  },
  [1823] = {
    [sym_argument_list] = STATE(802),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_SEMI] = ACTIONS(4296),
    [anon_sym_STAR] = ACTIONS(2553),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_EQ] = ACTIONS(4298),
    [anon_sym_QMARK] = ACTIONS(4296),
    [anon_sym_STAR_EQ] = ACTIONS(4296),
    [anon_sym_SLASH_EQ] = ACTIONS(4296),
    [anon_sym_PERCENT_EQ] = ACTIONS(4296),
    [anon_sym_PLUS_EQ] = ACTIONS(4296),
    [anon_sym_DASH_EQ] = ACTIONS(4296),
    [anon_sym_LT_LT_EQ] = ACTIONS(4296),
    [anon_sym_GT_GT_EQ] = ACTIONS(4296),
    [anon_sym_AMP_EQ] = ACTIONS(4296),
    [anon_sym_CARET_EQ] = ACTIONS(4296),
    [anon_sym_PIPE_EQ] = ACTIONS(4296),
    [anon_sym_AMP] = ACTIONS(4298),
    [anon_sym_PIPE_PIPE] = ACTIONS(4296),
    [anon_sym_AMP_AMP] = ACTIONS(4296),
    [anon_sym_PIPE] = ACTIONS(4298),
    [anon_sym_CARET] = ACTIONS(4298),
    [anon_sym_EQ_EQ] = ACTIONS(4296),
    [anon_sym_BANG_EQ] = ACTIONS(4296),
    [anon_sym_LT] = ACTIONS(4298),
    [anon_sym_GT] = ACTIONS(4298),
    [anon_sym_LT_EQ] = ACTIONS(4296),
    [anon_sym_GT_EQ] = ACTIONS(4296),
    [anon_sym_LT_LT] = ACTIONS(2577),
    [anon_sym_GT_GT] = ACTIONS(2577),
    [anon_sym_PLUS] = ACTIONS(2579),
    [anon_sym_DASH] = ACTIONS(2579),
    [anon_sym_SLASH] = ACTIONS(2553),
    [anon_sym_PERCENT] = ACTIONS(2553),
    [anon_sym_DASH_DASH] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(1554),
    [anon_sym_DASH_GT] = ACTIONS(1554),
    [sym_comment] = ACTIONS(49),
  },
  [1824] = {
    [sym_argument_list] = STATE(802),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_SEMI] = ACTIONS(4300),
    [anon_sym_STAR] = ACTIONS(2553),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_EQ] = ACTIONS(4302),
    [anon_sym_QMARK] = ACTIONS(4300),
    [anon_sym_STAR_EQ] = ACTIONS(4300),
    [anon_sym_SLASH_EQ] = ACTIONS(4300),
    [anon_sym_PERCENT_EQ] = ACTIONS(4300),
    [anon_sym_PLUS_EQ] = ACTIONS(4300),
    [anon_sym_DASH_EQ] = ACTIONS(4300),
    [anon_sym_LT_LT_EQ] = ACTIONS(4300),
    [anon_sym_GT_GT_EQ] = ACTIONS(4300),
    [anon_sym_AMP_EQ] = ACTIONS(4300),
    [anon_sym_CARET_EQ] = ACTIONS(4300),
    [anon_sym_PIPE_EQ] = ACTIONS(4300),
    [anon_sym_AMP] = ACTIONS(4302),
    [anon_sym_PIPE_PIPE] = ACTIONS(4300),
    [anon_sym_AMP_AMP] = ACTIONS(4300),
    [anon_sym_PIPE] = ACTIONS(4302),
    [anon_sym_CARET] = ACTIONS(4302),
    [anon_sym_EQ_EQ] = ACTIONS(4300),
    [anon_sym_BANG_EQ] = ACTIONS(4300),
    [anon_sym_LT] = ACTIONS(4302),
    [anon_sym_GT] = ACTIONS(4302),
    [anon_sym_LT_EQ] = ACTIONS(4300),
    [anon_sym_GT_EQ] = ACTIONS(4300),
    [anon_sym_LT_LT] = ACTIONS(4302),
    [anon_sym_GT_GT] = ACTIONS(4302),
    [anon_sym_PLUS] = ACTIONS(2579),
    [anon_sym_DASH] = ACTIONS(2579),
    [anon_sym_SLASH] = ACTIONS(2553),
    [anon_sym_PERCENT] = ACTIONS(2553),
    [anon_sym_DASH_DASH] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(1554),
    [anon_sym_DASH_GT] = ACTIONS(1554),
    [sym_comment] = ACTIONS(49),
  },
  [1825] = {
    [sym_argument_list] = STATE(802),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_SEMI] = ACTIONS(4274),
    [anon_sym_STAR] = ACTIONS(2553),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_EQ] = ACTIONS(4276),
    [anon_sym_QMARK] = ACTIONS(4274),
    [anon_sym_STAR_EQ] = ACTIONS(4274),
    [anon_sym_SLASH_EQ] = ACTIONS(4274),
    [anon_sym_PERCENT_EQ] = ACTIONS(4274),
    [anon_sym_PLUS_EQ] = ACTIONS(4274),
    [anon_sym_DASH_EQ] = ACTIONS(4274),
    [anon_sym_LT_LT_EQ] = ACTIONS(4274),
    [anon_sym_GT_GT_EQ] = ACTIONS(4274),
    [anon_sym_AMP_EQ] = ACTIONS(4274),
    [anon_sym_CARET_EQ] = ACTIONS(4274),
    [anon_sym_PIPE_EQ] = ACTIONS(4274),
    [anon_sym_AMP] = ACTIONS(4276),
    [anon_sym_PIPE_PIPE] = ACTIONS(4274),
    [anon_sym_AMP_AMP] = ACTIONS(4274),
    [anon_sym_PIPE] = ACTIONS(4276),
    [anon_sym_CARET] = ACTIONS(4276),
    [anon_sym_EQ_EQ] = ACTIONS(4274),
    [anon_sym_BANG_EQ] = ACTIONS(4274),
    [anon_sym_LT] = ACTIONS(4276),
    [anon_sym_GT] = ACTIONS(4276),
    [anon_sym_LT_EQ] = ACTIONS(4274),
    [anon_sym_GT_EQ] = ACTIONS(4274),
    [anon_sym_LT_LT] = ACTIONS(4276),
    [anon_sym_GT_GT] = ACTIONS(4276),
    [anon_sym_PLUS] = ACTIONS(4276),
    [anon_sym_DASH] = ACTIONS(4276),
    [anon_sym_SLASH] = ACTIONS(2553),
    [anon_sym_PERCENT] = ACTIONS(2553),
    [anon_sym_DASH_DASH] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(1554),
    [anon_sym_DASH_GT] = ACTIONS(1554),
    [sym_comment] = ACTIONS(49),
  },
  [1826] = {
    [sym_argument_list] = STATE(802),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_COMMA] = ACTIONS(2462),
    [anon_sym_RPAREN] = ACTIONS(2462),
    [anon_sym_STAR] = ACTIONS(2234),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_EQ] = ACTIONS(2236),
    [anon_sym_QMARK] = ACTIONS(2238),
    [anon_sym_STAR_EQ] = ACTIONS(2240),
    [anon_sym_SLASH_EQ] = ACTIONS(2240),
    [anon_sym_PERCENT_EQ] = ACTIONS(2240),
    [anon_sym_PLUS_EQ] = ACTIONS(2240),
    [anon_sym_DASH_EQ] = ACTIONS(2240),
    [anon_sym_LT_LT_EQ] = ACTIONS(2240),
    [anon_sym_GT_GT_EQ] = ACTIONS(2240),
    [anon_sym_AMP_EQ] = ACTIONS(2240),
    [anon_sym_CARET_EQ] = ACTIONS(2240),
    [anon_sym_PIPE_EQ] = ACTIONS(2240),
    [anon_sym_AMP] = ACTIONS(2242),
    [anon_sym_PIPE_PIPE] = ACTIONS(2244),
    [anon_sym_AMP_AMP] = ACTIONS(2246),
    [anon_sym_PIPE] = ACTIONS(2248),
    [anon_sym_CARET] = ACTIONS(2250),
    [anon_sym_EQ_EQ] = ACTIONS(2252),
    [anon_sym_BANG_EQ] = ACTIONS(2252),
    [anon_sym_LT] = ACTIONS(2254),
    [anon_sym_GT] = ACTIONS(2254),
    [anon_sym_LT_EQ] = ACTIONS(2256),
    [anon_sym_GT_EQ] = ACTIONS(2256),
    [anon_sym_LT_LT] = ACTIONS(2258),
    [anon_sym_GT_GT] = ACTIONS(2258),
    [anon_sym_PLUS] = ACTIONS(2260),
    [anon_sym_DASH] = ACTIONS(2260),
    [anon_sym_SLASH] = ACTIONS(2234),
    [anon_sym_PERCENT] = ACTIONS(2234),
    [anon_sym_DASH_DASH] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(1554),
    [anon_sym_DASH_GT] = ACTIONS(1554),
    [sym_comment] = ACTIONS(49),
  },
  [1827] = {
    [sym__type_specifier] = STATE(2226),
    [sym_sized_type_specifier] = STATE(2226),
    [sym_enum_specifier] = STATE(2226),
    [sym_struct_specifier] = STATE(2226),
    [sym_union_specifier] = STATE(2226),
    [sym_macro_type_specifier] = STATE(2226),
    [sym_class_specifier] = STATE(2226),
    [sym_dependent_type] = STATE(2226),
    [sym_template_type] = STATE(825),
    [sym_scoped_type_identifier] = STATE(826),
    [sym_scoped_namespace_identifier] = STATE(827),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2227),
    [anon_sym_unsigned] = ACTIONS(5155),
    [anon_sym_long] = ACTIONS(5155),
    [anon_sym_short] = ACTIONS(5155),
    [sym_primitive_type] = ACTIONS(5157),
    [anon_sym_enum] = ACTIONS(1582),
    [anon_sym_struct] = ACTIONS(2468),
    [anon_sym_union] = ACTIONS(2470),
    [sym_identifier] = ACTIONS(1588),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(2472),
    [sym_auto] = ACTIONS(5157),
    [anon_sym_typename] = ACTIONS(5159),
    [anon_sym_COLON_COLON] = ACTIONS(1594),
  },
  [1828] = {
    [sym_type_qualifier] = STATE(2228),
    [sym_trailing_return_type] = STATE(2228),
    [aux_sym_function_declarator_repeat1] = STATE(2228),
    [anon_sym_LPAREN] = ACTIONS(1596),
    [anon_sym_COMMA] = ACTIONS(1596),
    [anon_sym_RPAREN] = ACTIONS(1596),
    [anon_sym_LBRACE] = ACTIONS(1596),
    [anon_sym_LBRACK] = ACTIONS(1596),
    [anon_sym_EQ] = ACTIONS(1596),
    [anon_sym_const] = ACTIONS(612),
    [anon_sym_restrict] = ACTIONS(614),
    [anon_sym_volatile] = ACTIONS(614),
    [anon_sym__Atomic] = ACTIONS(614),
    [anon_sym_mutable] = ACTIONS(614),
    [anon_sym_explicit] = ACTIONS(614),
    [anon_sym_constexpr] = ACTIONS(614),
    [anon_sym_DASH_GT] = ACTIONS(4129),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(5161),
  },
  [1829] = {
    [sym_type_qualifier] = STATE(1833),
    [sym_trailing_return_type] = STATE(2168),
    [aux_sym_abstract_function_declarator_repeat1] = STATE(1833),
    [anon_sym_LPAREN] = ACTIONS(4998),
    [anon_sym_COMMA] = ACTIONS(4998),
    [anon_sym_RPAREN] = ACTIONS(4998),
    [anon_sym_LBRACK] = ACTIONS(4998),
    [anon_sym_const] = ACTIONS(612),
    [anon_sym_restrict] = ACTIONS(614),
    [anon_sym_volatile] = ACTIONS(614),
    [anon_sym__Atomic] = ACTIONS(614),
    [anon_sym_mutable] = ACTIONS(614),
    [anon_sym_explicit] = ACTIONS(614),
    [anon_sym_constexpr] = ACTIONS(614),
    [anon_sym_DASH_GT] = ACTIONS(2605),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(4141),
  },
  [1830] = {
    [sym__type_specifier] = STATE(93),
    [sym_sized_type_specifier] = STATE(93),
    [sym_enum_specifier] = STATE(93),
    [sym_struct_specifier] = STATE(93),
    [sym_union_specifier] = STATE(93),
    [sym_macro_type_specifier] = STATE(93),
    [sym_class_specifier] = STATE(93),
    [sym_dependent_type] = STATE(93),
    [sym_template_type] = STATE(62),
    [sym_scoped_type_identifier] = STATE(34),
    [sym_scoped_namespace_identifier] = STATE(64),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1832),
    [anon_sym_unsigned] = ACTIONS(4135),
    [anon_sym_long] = ACTIONS(4135),
    [anon_sym_short] = ACTIONS(4135),
    [sym_primitive_type] = ACTIONS(150),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(428),
    [anon_sym_union] = ACTIONS(430),
    [sym_identifier] = ACTIONS(434),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(436),
    [sym_auto] = ACTIONS(150),
    [anon_sym_typename] = ACTIONS(4139),
    [anon_sym_COLON_COLON] = ACTIONS(111),
  },
  [1831] = {
    [sym__abstract_declarator] = STATE(2231),
    [sym_abstract_pointer_declarator] = STATE(2231),
    [sym_abstract_function_declarator] = STATE(2231),
    [sym_abstract_array_declarator] = STATE(2231),
    [sym_parameter_list] = STATE(713),
    [sym_abstract_reference_declarator] = STATE(2231),
    [anon_sym_LPAREN] = ACTIONS(1115),
    [anon_sym_COMMA] = ACTIONS(2841),
    [anon_sym_RPAREN] = ACTIONS(2841),
    [anon_sym_STAR] = ACTIONS(5163),
    [anon_sym_LBRACK] = ACTIONS(1121),
    [anon_sym_AMP] = ACTIONS(5165),
    [anon_sym_AMP_AMP] = ACTIONS(5167),
    [sym_comment] = ACTIONS(49),
  },
  [1832] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2232),
    [anon_sym_LPAREN] = ACTIONS(238),
    [anon_sym_COMMA] = ACTIONS(238),
    [anon_sym_RPAREN] = ACTIONS(238),
    [anon_sym_STAR] = ACTIONS(238),
    [anon_sym_LBRACK] = ACTIONS(238),
    [anon_sym_unsigned] = ACTIONS(5169),
    [anon_sym_long] = ACTIONS(5169),
    [anon_sym_short] = ACTIONS(5169),
    [sym_primitive_type] = ACTIONS(244),
    [anon_sym_AMP] = ACTIONS(240),
    [anon_sym_AMP_AMP] = ACTIONS(238),
    [sym_identifier] = ACTIONS(1135),
    [sym_comment] = ACTIONS(49),
  },
  [1833] = {
    [sym_type_qualifier] = STATE(1833),
    [aux_sym_abstract_function_declarator_repeat1] = STATE(1833),
    [anon_sym_LPAREN] = ACTIONS(5002),
    [anon_sym_COMMA] = ACTIONS(5002),
    [anon_sym_RPAREN] = ACTIONS(5002),
    [anon_sym_LBRACK] = ACTIONS(5002),
    [anon_sym_const] = ACTIONS(5004),
    [anon_sym_restrict] = ACTIONS(5007),
    [anon_sym_volatile] = ACTIONS(5007),
    [anon_sym__Atomic] = ACTIONS(5007),
    [anon_sym_mutable] = ACTIONS(5007),
    [anon_sym_explicit] = ACTIONS(5007),
    [anon_sym_constexpr] = ACTIONS(5007),
    [anon_sym_DASH_GT] = ACTIONS(5002),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(5171),
  },
  [1834] = {
    [sym_argument_list] = STATE(802),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_COMMA] = ACTIONS(5174),
    [anon_sym_RPAREN] = ACTIONS(5174),
    [anon_sym_SEMI] = ACTIONS(5174),
    [anon_sym_RBRACE] = ACTIONS(5174),
    [anon_sym_STAR] = ACTIONS(5176),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_RBRACK] = ACTIONS(5174),
    [anon_sym_EQ] = ACTIONS(5176),
    [anon_sym_QMARK] = ACTIONS(5174),
    [anon_sym_STAR_EQ] = ACTIONS(5174),
    [anon_sym_SLASH_EQ] = ACTIONS(5174),
    [anon_sym_PERCENT_EQ] = ACTIONS(5174),
    [anon_sym_PLUS_EQ] = ACTIONS(5174),
    [anon_sym_DASH_EQ] = ACTIONS(5174),
    [anon_sym_LT_LT_EQ] = ACTIONS(5174),
    [anon_sym_GT_GT_EQ] = ACTIONS(5174),
    [anon_sym_AMP_EQ] = ACTIONS(5174),
    [anon_sym_CARET_EQ] = ACTIONS(5174),
    [anon_sym_PIPE_EQ] = ACTIONS(5174),
    [anon_sym_AMP] = ACTIONS(5176),
    [anon_sym_PIPE_PIPE] = ACTIONS(5174),
    [anon_sym_AMP_AMP] = ACTIONS(5174),
    [anon_sym_PIPE] = ACTIONS(5176),
    [anon_sym_CARET] = ACTIONS(5176),
    [anon_sym_EQ_EQ] = ACTIONS(5174),
    [anon_sym_BANG_EQ] = ACTIONS(5174),
    [anon_sym_LT] = ACTIONS(5176),
    [anon_sym_GT] = ACTIONS(5176),
    [anon_sym_LT_EQ] = ACTIONS(5174),
    [anon_sym_GT_EQ] = ACTIONS(5174),
    [anon_sym_LT_LT] = ACTIONS(5176),
    [anon_sym_GT_GT] = ACTIONS(5176),
    [anon_sym_PLUS] = ACTIONS(5176),
    [anon_sym_DASH] = ACTIONS(5176),
    [anon_sym_SLASH] = ACTIONS(5176),
    [anon_sym_PERCENT] = ACTIONS(5176),
    [anon_sym_DASH_DASH] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(1554),
    [anon_sym_DASH_GT] = ACTIONS(1554),
    [sym_comment] = ACTIONS(49),
  },
  [1835] = {
    [anon_sym_LPAREN] = ACTIONS(5178),
    [anon_sym_COMMA] = ACTIONS(5178),
    [anon_sym_RPAREN] = ACTIONS(5178),
    [anon_sym_SEMI] = ACTIONS(5178),
    [anon_sym_RBRACE] = ACTIONS(5178),
    [anon_sym_STAR] = ACTIONS(5180),
    [anon_sym_LBRACK] = ACTIONS(5178),
    [anon_sym_RBRACK] = ACTIONS(5178),
    [anon_sym_EQ] = ACTIONS(5180),
    [anon_sym_COLON] = ACTIONS(5178),
    [anon_sym_QMARK] = ACTIONS(5178),
    [anon_sym_STAR_EQ] = ACTIONS(5178),
    [anon_sym_SLASH_EQ] = ACTIONS(5178),
    [anon_sym_PERCENT_EQ] = ACTIONS(5178),
    [anon_sym_PLUS_EQ] = ACTIONS(5178),
    [anon_sym_DASH_EQ] = ACTIONS(5178),
    [anon_sym_LT_LT_EQ] = ACTIONS(5178),
    [anon_sym_GT_GT_EQ] = ACTIONS(5178),
    [anon_sym_AMP_EQ] = ACTIONS(5178),
    [anon_sym_CARET_EQ] = ACTIONS(5178),
    [anon_sym_PIPE_EQ] = ACTIONS(5178),
    [anon_sym_AMP] = ACTIONS(5180),
    [anon_sym_PIPE_PIPE] = ACTIONS(5178),
    [anon_sym_AMP_AMP] = ACTIONS(5178),
    [anon_sym_PIPE] = ACTIONS(5180),
    [anon_sym_CARET] = ACTIONS(5180),
    [anon_sym_EQ_EQ] = ACTIONS(5178),
    [anon_sym_BANG_EQ] = ACTIONS(5178),
    [anon_sym_LT] = ACTIONS(5180),
    [anon_sym_GT] = ACTIONS(5180),
    [anon_sym_LT_EQ] = ACTIONS(5178),
    [anon_sym_GT_EQ] = ACTIONS(5178),
    [anon_sym_LT_LT] = ACTIONS(5180),
    [anon_sym_GT_GT] = ACTIONS(5180),
    [anon_sym_PLUS] = ACTIONS(5180),
    [anon_sym_DASH] = ACTIONS(5180),
    [anon_sym_SLASH] = ACTIONS(5180),
    [anon_sym_PERCENT] = ACTIONS(5180),
    [anon_sym_DASH_DASH] = ACTIONS(5178),
    [anon_sym_PLUS_PLUS] = ACTIONS(5178),
    [anon_sym_DOT] = ACTIONS(5178),
    [anon_sym_DASH_GT] = ACTIONS(5178),
    [sym_comment] = ACTIONS(49),
  },
  [1836] = {
    [sym_parameter_list] = STATE(1707),
    [anon_sym_LPAREN] = ACTIONS(206),
    [anon_sym_RPAREN] = ACTIONS(3783),
    [anon_sym_LBRACK] = ACTIONS(2282),
    [sym_comment] = ACTIONS(49),
  },
  [1837] = {
    [sym__expression] = STATE(1834),
    [sym_conditional_expression] = STATE(1834),
    [sym_assignment_expression] = STATE(1834),
    [sym_pointer_expression] = STATE(1834),
    [sym_logical_expression] = STATE(1834),
    [sym_bitwise_expression] = STATE(1834),
    [sym_equality_expression] = STATE(1834),
    [sym_relational_expression] = STATE(1834),
    [sym_shift_expression] = STATE(1834),
    [sym_math_expression] = STATE(1834),
    [sym_cast_expression] = STATE(1834),
    [sym_sizeof_expression] = STATE(1834),
    [sym_subscript_expression] = STATE(1834),
    [sym_call_expression] = STATE(1834),
    [sym_field_expression] = STATE(1834),
    [sym_compound_literal_expression] = STATE(1834),
    [sym_parenthesized_expression] = STATE(1834),
    [sym_initializer_list] = STATE(1835),
    [sym_concatenated_string] = STATE(1834),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(1834),
    [sym_new_expression] = STATE(1834),
    [sym_delete_expression] = STATE(1834),
    [sym_lambda_expression] = STATE(1834),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(4145),
    [anon_sym_LPAREN] = ACTIONS(1419),
    [anon_sym_LBRACE] = ACTIONS(548),
    [anon_sym_STAR] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_AMP] = ACTIONS(1421),
    [anon_sym_BANG] = ACTIONS(1429),
    [anon_sym_TILDE] = ACTIONS(1431),
    [anon_sym_PLUS] = ACTIONS(1433),
    [anon_sym_DASH] = ACTIONS(1433),
    [anon_sym_DASH_DASH] = ACTIONS(1435),
    [anon_sym_PLUS_PLUS] = ACTIONS(1435),
    [anon_sym_sizeof] = ACTIONS(1437),
    [sym_number_literal] = ACTIONS(4145),
    [sym_char_literal] = ACTIONS(4145),
    [sym_string_literal] = ACTIONS(1439),
    [sym_true] = ACTIONS(4147),
    [sym_false] = ACTIONS(4147),
    [sym_null] = ACTIONS(4147),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1443),
    [anon_sym_delete] = ACTIONS(1445),
    [sym_nullptr] = ACTIONS(4147),
  },
  [1838] = {
    [anon_sym_RPAREN] = ACTIONS(5182),
    [sym_comment] = ACTIONS(49),
  },
  [1839] = {
    [aux_sym_concatenated_string_repeat1] = STATE(1839),
    [anon_sym_LPAREN] = ACTIONS(4230),
    [anon_sym_COMMA] = ACTIONS(4230),
    [anon_sym_STAR] = ACTIONS(4232),
    [anon_sym_LBRACK] = ACTIONS(4230),
    [anon_sym_RBRACK] = ACTIONS(4230),
    [anon_sym_EQ] = ACTIONS(4232),
    [anon_sym_QMARK] = ACTIONS(4230),
    [anon_sym_STAR_EQ] = ACTIONS(4230),
    [anon_sym_SLASH_EQ] = ACTIONS(4230),
    [anon_sym_PERCENT_EQ] = ACTIONS(4230),
    [anon_sym_PLUS_EQ] = ACTIONS(4230),
    [anon_sym_DASH_EQ] = ACTIONS(4230),
    [anon_sym_LT_LT_EQ] = ACTIONS(4230),
    [anon_sym_GT_GT_EQ] = ACTIONS(4230),
    [anon_sym_AMP_EQ] = ACTIONS(4230),
    [anon_sym_CARET_EQ] = ACTIONS(4230),
    [anon_sym_PIPE_EQ] = ACTIONS(4230),
    [anon_sym_AMP] = ACTIONS(4232),
    [anon_sym_PIPE_PIPE] = ACTIONS(4230),
    [anon_sym_AMP_AMP] = ACTIONS(4230),
    [anon_sym_PIPE] = ACTIONS(4232),
    [anon_sym_CARET] = ACTIONS(4232),
    [anon_sym_EQ_EQ] = ACTIONS(4230),
    [anon_sym_BANG_EQ] = ACTIONS(4230),
    [anon_sym_LT] = ACTIONS(4232),
    [anon_sym_GT] = ACTIONS(4232),
    [anon_sym_LT_EQ] = ACTIONS(4230),
    [anon_sym_GT_EQ] = ACTIONS(4230),
    [anon_sym_LT_LT] = ACTIONS(4232),
    [anon_sym_GT_GT] = ACTIONS(4232),
    [anon_sym_PLUS] = ACTIONS(4232),
    [anon_sym_DASH] = ACTIONS(4232),
    [anon_sym_SLASH] = ACTIONS(4232),
    [anon_sym_PERCENT] = ACTIONS(4232),
    [anon_sym_DASH_DASH] = ACTIONS(4230),
    [anon_sym_PLUS_PLUS] = ACTIONS(4230),
    [anon_sym_DOT] = ACTIONS(4230),
    [anon_sym_DASH_GT] = ACTIONS(4230),
    [sym_string_literal] = ACTIONS(5184),
    [sym_comment] = ACTIONS(49),
  },
  [1840] = {
    [sym__expression] = STATE(740),
    [sym_conditional_expression] = STATE(740),
    [sym_assignment_expression] = STATE(740),
    [sym_pointer_expression] = STATE(740),
    [sym_logical_expression] = STATE(740),
    [sym_bitwise_expression] = STATE(740),
    [sym_equality_expression] = STATE(740),
    [sym_relational_expression] = STATE(740),
    [sym_shift_expression] = STATE(740),
    [sym_math_expression] = STATE(740),
    [sym_cast_expression] = STATE(740),
    [sym_sizeof_expression] = STATE(740),
    [sym_subscript_expression] = STATE(740),
    [sym_call_expression] = STATE(740),
    [sym_field_expression] = STATE(740),
    [sym_compound_literal_expression] = STATE(740),
    [sym_parenthesized_expression] = STATE(740),
    [sym_concatenated_string] = STATE(740),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(740),
    [sym_new_expression] = STATE(740),
    [sym_delete_expression] = STATE(740),
    [sym_lambda_expression] = STATE(740),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_lambda_default_capture] = STATE(741),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(1417),
    [anon_sym_LPAREN] = ACTIONS(1419),
    [anon_sym_STAR] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_RBRACK] = ACTIONS(5187),
    [anon_sym_EQ] = ACTIONS(1425),
    [anon_sym_AMP] = ACTIONS(1427),
    [anon_sym_BANG] = ACTIONS(1429),
    [anon_sym_TILDE] = ACTIONS(1431),
    [anon_sym_PLUS] = ACTIONS(1433),
    [anon_sym_DASH] = ACTIONS(1433),
    [anon_sym_DASH_DASH] = ACTIONS(1435),
    [anon_sym_PLUS_PLUS] = ACTIONS(1435),
    [anon_sym_sizeof] = ACTIONS(1437),
    [sym_number_literal] = ACTIONS(1417),
    [sym_char_literal] = ACTIONS(1417),
    [sym_string_literal] = ACTIONS(1439),
    [sym_true] = ACTIONS(1441),
    [sym_false] = ACTIONS(1441),
    [sym_null] = ACTIONS(1441),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1443),
    [anon_sym_delete] = ACTIONS(1445),
    [sym_nullptr] = ACTIONS(1441),
  },
  [1841] = {
    [sym_argument_list] = STATE(802),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_COMMA] = ACTIONS(4258),
    [anon_sym_STAR] = ACTIONS(2648),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_RBRACK] = ACTIONS(4258),
    [anon_sym_EQ] = ACTIONS(4260),
    [anon_sym_QMARK] = ACTIONS(4258),
    [anon_sym_STAR_EQ] = ACTIONS(4258),
    [anon_sym_SLASH_EQ] = ACTIONS(4258),
    [anon_sym_PERCENT_EQ] = ACTIONS(4258),
    [anon_sym_PLUS_EQ] = ACTIONS(4258),
    [anon_sym_DASH_EQ] = ACTIONS(4258),
    [anon_sym_LT_LT_EQ] = ACTIONS(4258),
    [anon_sym_GT_GT_EQ] = ACTIONS(4258),
    [anon_sym_AMP_EQ] = ACTIONS(4258),
    [anon_sym_CARET_EQ] = ACTIONS(4258),
    [anon_sym_PIPE_EQ] = ACTIONS(4258),
    [anon_sym_AMP] = ACTIONS(2658),
    [anon_sym_PIPE_PIPE] = ACTIONS(2660),
    [anon_sym_AMP_AMP] = ACTIONS(2662),
    [anon_sym_PIPE] = ACTIONS(2664),
    [anon_sym_CARET] = ACTIONS(2666),
    [anon_sym_EQ_EQ] = ACTIONS(2668),
    [anon_sym_BANG_EQ] = ACTIONS(2668),
    [anon_sym_LT] = ACTIONS(2670),
    [anon_sym_GT] = ACTIONS(2670),
    [anon_sym_LT_EQ] = ACTIONS(2672),
    [anon_sym_GT_EQ] = ACTIONS(2672),
    [anon_sym_LT_LT] = ACTIONS(2674),
    [anon_sym_GT_GT] = ACTIONS(2674),
    [anon_sym_PLUS] = ACTIONS(2676),
    [anon_sym_DASH] = ACTIONS(2676),
    [anon_sym_SLASH] = ACTIONS(2648),
    [anon_sym_PERCENT] = ACTIONS(2648),
    [anon_sym_DASH_DASH] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(1554),
    [anon_sym_DASH_GT] = ACTIONS(1554),
    [sym_comment] = ACTIONS(49),
  },
  [1842] = {
    [sym__expression] = STATE(2235),
    [sym_conditional_expression] = STATE(2235),
    [sym_assignment_expression] = STATE(2235),
    [sym_pointer_expression] = STATE(2235),
    [sym_logical_expression] = STATE(2235),
    [sym_bitwise_expression] = STATE(2235),
    [sym_equality_expression] = STATE(2235),
    [sym_relational_expression] = STATE(2235),
    [sym_shift_expression] = STATE(2235),
    [sym_math_expression] = STATE(2235),
    [sym_cast_expression] = STATE(2235),
    [sym_sizeof_expression] = STATE(2235),
    [sym_subscript_expression] = STATE(2235),
    [sym_call_expression] = STATE(2235),
    [sym_field_expression] = STATE(2235),
    [sym_compound_literal_expression] = STATE(2235),
    [sym_parenthesized_expression] = STATE(2235),
    [sym_concatenated_string] = STATE(2235),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(2235),
    [sym_new_expression] = STATE(2235),
    [sym_delete_expression] = STATE(2235),
    [sym_lambda_expression] = STATE(2235),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(5189),
    [anon_sym_LPAREN] = ACTIONS(2624),
    [anon_sym_STAR] = ACTIONS(2624),
    [anon_sym_LBRACK] = ACTIONS(2624),
    [anon_sym_AMP] = ACTIONS(2626),
    [anon_sym_AMP_AMP] = ACTIONS(2624),
    [anon_sym_BANG] = ACTIONS(1429),
    [anon_sym_TILDE] = ACTIONS(1431),
    [anon_sym_PLUS] = ACTIONS(1433),
    [anon_sym_DASH] = ACTIONS(1433),
    [anon_sym_DASH_DASH] = ACTIONS(1435),
    [anon_sym_PLUS_PLUS] = ACTIONS(1435),
    [anon_sym_sizeof] = ACTIONS(1437),
    [sym_number_literal] = ACTIONS(5189),
    [sym_char_literal] = ACTIONS(5189),
    [sym_string_literal] = ACTIONS(1439),
    [sym_true] = ACTIONS(5191),
    [sym_false] = ACTIONS(5191),
    [sym_null] = ACTIONS(5191),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1443),
    [anon_sym_delete] = ACTIONS(1445),
    [sym_nullptr] = ACTIONS(5191),
  },
  [1843] = {
    [sym_argument_list] = STATE(802),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_COMMA] = ACTIONS(5193),
    [anon_sym_STAR] = ACTIONS(2648),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_RBRACK] = ACTIONS(5193),
    [anon_sym_EQ] = ACTIONS(2652),
    [anon_sym_QMARK] = ACTIONS(2654),
    [anon_sym_STAR_EQ] = ACTIONS(2656),
    [anon_sym_SLASH_EQ] = ACTIONS(2656),
    [anon_sym_PERCENT_EQ] = ACTIONS(2656),
    [anon_sym_PLUS_EQ] = ACTIONS(2656),
    [anon_sym_DASH_EQ] = ACTIONS(2656),
    [anon_sym_LT_LT_EQ] = ACTIONS(2656),
    [anon_sym_GT_GT_EQ] = ACTIONS(2656),
    [anon_sym_AMP_EQ] = ACTIONS(2656),
    [anon_sym_CARET_EQ] = ACTIONS(2656),
    [anon_sym_PIPE_EQ] = ACTIONS(2656),
    [anon_sym_AMP] = ACTIONS(2658),
    [anon_sym_PIPE_PIPE] = ACTIONS(2660),
    [anon_sym_AMP_AMP] = ACTIONS(2662),
    [anon_sym_PIPE] = ACTIONS(2664),
    [anon_sym_CARET] = ACTIONS(2666),
    [anon_sym_EQ_EQ] = ACTIONS(2668),
    [anon_sym_BANG_EQ] = ACTIONS(2668),
    [anon_sym_LT] = ACTIONS(2670),
    [anon_sym_GT] = ACTIONS(2670),
    [anon_sym_LT_EQ] = ACTIONS(2672),
    [anon_sym_GT_EQ] = ACTIONS(2672),
    [anon_sym_LT_LT] = ACTIONS(2674),
    [anon_sym_GT_GT] = ACTIONS(2674),
    [anon_sym_PLUS] = ACTIONS(2676),
    [anon_sym_DASH] = ACTIONS(2676),
    [anon_sym_SLASH] = ACTIONS(2648),
    [anon_sym_PERCENT] = ACTIONS(2648),
    [anon_sym_DASH_DASH] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(1554),
    [anon_sym_DASH_GT] = ACTIONS(1554),
    [sym_comment] = ACTIONS(49),
  },
  [1844] = {
    [sym_argument_list] = STATE(802),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_COMMA] = ACTIONS(4280),
    [anon_sym_STAR] = ACTIONS(2648),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_RBRACK] = ACTIONS(4280),
    [anon_sym_EQ] = ACTIONS(2652),
    [anon_sym_QMARK] = ACTIONS(4280),
    [anon_sym_STAR_EQ] = ACTIONS(2656),
    [anon_sym_SLASH_EQ] = ACTIONS(2656),
    [anon_sym_PERCENT_EQ] = ACTIONS(2656),
    [anon_sym_PLUS_EQ] = ACTIONS(2656),
    [anon_sym_DASH_EQ] = ACTIONS(2656),
    [anon_sym_LT_LT_EQ] = ACTIONS(2656),
    [anon_sym_GT_GT_EQ] = ACTIONS(2656),
    [anon_sym_AMP_EQ] = ACTIONS(2656),
    [anon_sym_CARET_EQ] = ACTIONS(2656),
    [anon_sym_PIPE_EQ] = ACTIONS(2656),
    [anon_sym_AMP] = ACTIONS(2658),
    [anon_sym_PIPE_PIPE] = ACTIONS(2660),
    [anon_sym_AMP_AMP] = ACTIONS(2662),
    [anon_sym_PIPE] = ACTIONS(2664),
    [anon_sym_CARET] = ACTIONS(2666),
    [anon_sym_EQ_EQ] = ACTIONS(2668),
    [anon_sym_BANG_EQ] = ACTIONS(2668),
    [anon_sym_LT] = ACTIONS(2670),
    [anon_sym_GT] = ACTIONS(2670),
    [anon_sym_LT_EQ] = ACTIONS(2672),
    [anon_sym_GT_EQ] = ACTIONS(2672),
    [anon_sym_LT_LT] = ACTIONS(2674),
    [anon_sym_GT_GT] = ACTIONS(2674),
    [anon_sym_PLUS] = ACTIONS(2676),
    [anon_sym_DASH] = ACTIONS(2676),
    [anon_sym_SLASH] = ACTIONS(2648),
    [anon_sym_PERCENT] = ACTIONS(2648),
    [anon_sym_DASH_DASH] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(1554),
    [anon_sym_DASH_GT] = ACTIONS(1554),
    [sym_comment] = ACTIONS(49),
  },
  [1845] = {
    [sym_argument_list] = STATE(802),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_STAR] = ACTIONS(3003),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_EQ] = ACTIONS(3005),
    [anon_sym_COLON] = ACTIONS(5195),
    [anon_sym_QMARK] = ACTIONS(3009),
    [anon_sym_STAR_EQ] = ACTIONS(3011),
    [anon_sym_SLASH_EQ] = ACTIONS(3011),
    [anon_sym_PERCENT_EQ] = ACTIONS(3011),
    [anon_sym_PLUS_EQ] = ACTIONS(3011),
    [anon_sym_DASH_EQ] = ACTIONS(3011),
    [anon_sym_LT_LT_EQ] = ACTIONS(3011),
    [anon_sym_GT_GT_EQ] = ACTIONS(3011),
    [anon_sym_AMP_EQ] = ACTIONS(3011),
    [anon_sym_CARET_EQ] = ACTIONS(3011),
    [anon_sym_PIPE_EQ] = ACTIONS(3011),
    [anon_sym_AMP] = ACTIONS(3013),
    [anon_sym_PIPE_PIPE] = ACTIONS(3015),
    [anon_sym_AMP_AMP] = ACTIONS(3017),
    [anon_sym_PIPE] = ACTIONS(3019),
    [anon_sym_CARET] = ACTIONS(3021),
    [anon_sym_EQ_EQ] = ACTIONS(3023),
    [anon_sym_BANG_EQ] = ACTIONS(3023),
    [anon_sym_LT] = ACTIONS(3025),
    [anon_sym_GT] = ACTIONS(3025),
    [anon_sym_LT_EQ] = ACTIONS(3027),
    [anon_sym_GT_EQ] = ACTIONS(3027),
    [anon_sym_LT_LT] = ACTIONS(3029),
    [anon_sym_GT_GT] = ACTIONS(3029),
    [anon_sym_PLUS] = ACTIONS(3031),
    [anon_sym_DASH] = ACTIONS(3031),
    [anon_sym_SLASH] = ACTIONS(3003),
    [anon_sym_PERCENT] = ACTIONS(3003),
    [anon_sym_DASH_DASH] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(3033),
    [anon_sym_DASH_GT] = ACTIONS(3033),
    [sym_comment] = ACTIONS(49),
  },
  [1846] = {
    [sym_argument_list] = STATE(802),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_COMMA] = ACTIONS(4284),
    [anon_sym_STAR] = ACTIONS(2648),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_RBRACK] = ACTIONS(4284),
    [anon_sym_EQ] = ACTIONS(4286),
    [anon_sym_QMARK] = ACTIONS(4284),
    [anon_sym_STAR_EQ] = ACTIONS(4284),
    [anon_sym_SLASH_EQ] = ACTIONS(4284),
    [anon_sym_PERCENT_EQ] = ACTIONS(4284),
    [anon_sym_PLUS_EQ] = ACTIONS(4284),
    [anon_sym_DASH_EQ] = ACTIONS(4284),
    [anon_sym_LT_LT_EQ] = ACTIONS(4284),
    [anon_sym_GT_GT_EQ] = ACTIONS(4284),
    [anon_sym_AMP_EQ] = ACTIONS(4284),
    [anon_sym_CARET_EQ] = ACTIONS(4284),
    [anon_sym_PIPE_EQ] = ACTIONS(4284),
    [anon_sym_AMP] = ACTIONS(4286),
    [anon_sym_PIPE_PIPE] = ACTIONS(4284),
    [anon_sym_AMP_AMP] = ACTIONS(4284),
    [anon_sym_PIPE] = ACTIONS(4286),
    [anon_sym_CARET] = ACTIONS(4286),
    [anon_sym_EQ_EQ] = ACTIONS(2668),
    [anon_sym_BANG_EQ] = ACTIONS(2668),
    [anon_sym_LT] = ACTIONS(2670),
    [anon_sym_GT] = ACTIONS(2670),
    [anon_sym_LT_EQ] = ACTIONS(2672),
    [anon_sym_GT_EQ] = ACTIONS(2672),
    [anon_sym_LT_LT] = ACTIONS(2674),
    [anon_sym_GT_GT] = ACTIONS(2674),
    [anon_sym_PLUS] = ACTIONS(2676),
    [anon_sym_DASH] = ACTIONS(2676),
    [anon_sym_SLASH] = ACTIONS(2648),
    [anon_sym_PERCENT] = ACTIONS(2648),
    [anon_sym_DASH_DASH] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(1554),
    [anon_sym_DASH_GT] = ACTIONS(1554),
    [sym_comment] = ACTIONS(49),
  },
  [1847] = {
    [sym_argument_list] = STATE(802),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_COMMA] = ACTIONS(4288),
    [anon_sym_STAR] = ACTIONS(2648),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_RBRACK] = ACTIONS(4288),
    [anon_sym_EQ] = ACTIONS(4290),
    [anon_sym_QMARK] = ACTIONS(4288),
    [anon_sym_STAR_EQ] = ACTIONS(4288),
    [anon_sym_SLASH_EQ] = ACTIONS(4288),
    [anon_sym_PERCENT_EQ] = ACTIONS(4288),
    [anon_sym_PLUS_EQ] = ACTIONS(4288),
    [anon_sym_DASH_EQ] = ACTIONS(4288),
    [anon_sym_LT_LT_EQ] = ACTIONS(4288),
    [anon_sym_GT_GT_EQ] = ACTIONS(4288),
    [anon_sym_AMP_EQ] = ACTIONS(4288),
    [anon_sym_CARET_EQ] = ACTIONS(4288),
    [anon_sym_PIPE_EQ] = ACTIONS(4288),
    [anon_sym_AMP] = ACTIONS(2658),
    [anon_sym_PIPE_PIPE] = ACTIONS(4288),
    [anon_sym_AMP_AMP] = ACTIONS(2662),
    [anon_sym_PIPE] = ACTIONS(2664),
    [anon_sym_CARET] = ACTIONS(2666),
    [anon_sym_EQ_EQ] = ACTIONS(2668),
    [anon_sym_BANG_EQ] = ACTIONS(2668),
    [anon_sym_LT] = ACTIONS(2670),
    [anon_sym_GT] = ACTIONS(2670),
    [anon_sym_LT_EQ] = ACTIONS(2672),
    [anon_sym_GT_EQ] = ACTIONS(2672),
    [anon_sym_LT_LT] = ACTIONS(2674),
    [anon_sym_GT_GT] = ACTIONS(2674),
    [anon_sym_PLUS] = ACTIONS(2676),
    [anon_sym_DASH] = ACTIONS(2676),
    [anon_sym_SLASH] = ACTIONS(2648),
    [anon_sym_PERCENT] = ACTIONS(2648),
    [anon_sym_DASH_DASH] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(1554),
    [anon_sym_DASH_GT] = ACTIONS(1554),
    [sym_comment] = ACTIONS(49),
  },
  [1848] = {
    [sym_argument_list] = STATE(802),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_COMMA] = ACTIONS(4288),
    [anon_sym_STAR] = ACTIONS(2648),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_RBRACK] = ACTIONS(4288),
    [anon_sym_EQ] = ACTIONS(4290),
    [anon_sym_QMARK] = ACTIONS(4288),
    [anon_sym_STAR_EQ] = ACTIONS(4288),
    [anon_sym_SLASH_EQ] = ACTIONS(4288),
    [anon_sym_PERCENT_EQ] = ACTIONS(4288),
    [anon_sym_PLUS_EQ] = ACTIONS(4288),
    [anon_sym_DASH_EQ] = ACTIONS(4288),
    [anon_sym_LT_LT_EQ] = ACTIONS(4288),
    [anon_sym_GT_GT_EQ] = ACTIONS(4288),
    [anon_sym_AMP_EQ] = ACTIONS(4288),
    [anon_sym_CARET_EQ] = ACTIONS(4288),
    [anon_sym_PIPE_EQ] = ACTIONS(4288),
    [anon_sym_AMP] = ACTIONS(2658),
    [anon_sym_PIPE_PIPE] = ACTIONS(4288),
    [anon_sym_AMP_AMP] = ACTIONS(4288),
    [anon_sym_PIPE] = ACTIONS(2664),
    [anon_sym_CARET] = ACTIONS(2666),
    [anon_sym_EQ_EQ] = ACTIONS(2668),
    [anon_sym_BANG_EQ] = ACTIONS(2668),
    [anon_sym_LT] = ACTIONS(2670),
    [anon_sym_GT] = ACTIONS(2670),
    [anon_sym_LT_EQ] = ACTIONS(2672),
    [anon_sym_GT_EQ] = ACTIONS(2672),
    [anon_sym_LT_LT] = ACTIONS(2674),
    [anon_sym_GT_GT] = ACTIONS(2674),
    [anon_sym_PLUS] = ACTIONS(2676),
    [anon_sym_DASH] = ACTIONS(2676),
    [anon_sym_SLASH] = ACTIONS(2648),
    [anon_sym_PERCENT] = ACTIONS(2648),
    [anon_sym_DASH_DASH] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(1554),
    [anon_sym_DASH_GT] = ACTIONS(1554),
    [sym_comment] = ACTIONS(49),
  },
  [1849] = {
    [sym_argument_list] = STATE(802),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_COMMA] = ACTIONS(4284),
    [anon_sym_STAR] = ACTIONS(2648),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_RBRACK] = ACTIONS(4284),
    [anon_sym_EQ] = ACTIONS(4286),
    [anon_sym_QMARK] = ACTIONS(4284),
    [anon_sym_STAR_EQ] = ACTIONS(4284),
    [anon_sym_SLASH_EQ] = ACTIONS(4284),
    [anon_sym_PERCENT_EQ] = ACTIONS(4284),
    [anon_sym_PLUS_EQ] = ACTIONS(4284),
    [anon_sym_DASH_EQ] = ACTIONS(4284),
    [anon_sym_LT_LT_EQ] = ACTIONS(4284),
    [anon_sym_GT_GT_EQ] = ACTIONS(4284),
    [anon_sym_AMP_EQ] = ACTIONS(4284),
    [anon_sym_CARET_EQ] = ACTIONS(4284),
    [anon_sym_PIPE_EQ] = ACTIONS(4284),
    [anon_sym_AMP] = ACTIONS(2658),
    [anon_sym_PIPE_PIPE] = ACTIONS(4284),
    [anon_sym_AMP_AMP] = ACTIONS(4284),
    [anon_sym_PIPE] = ACTIONS(4286),
    [anon_sym_CARET] = ACTIONS(2666),
    [anon_sym_EQ_EQ] = ACTIONS(2668),
    [anon_sym_BANG_EQ] = ACTIONS(2668),
    [anon_sym_LT] = ACTIONS(2670),
    [anon_sym_GT] = ACTIONS(2670),
    [anon_sym_LT_EQ] = ACTIONS(2672),
    [anon_sym_GT_EQ] = ACTIONS(2672),
    [anon_sym_LT_LT] = ACTIONS(2674),
    [anon_sym_GT_GT] = ACTIONS(2674),
    [anon_sym_PLUS] = ACTIONS(2676),
    [anon_sym_DASH] = ACTIONS(2676),
    [anon_sym_SLASH] = ACTIONS(2648),
    [anon_sym_PERCENT] = ACTIONS(2648),
    [anon_sym_DASH_DASH] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(1554),
    [anon_sym_DASH_GT] = ACTIONS(1554),
    [sym_comment] = ACTIONS(49),
  },
  [1850] = {
    [sym_argument_list] = STATE(802),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_COMMA] = ACTIONS(4284),
    [anon_sym_STAR] = ACTIONS(2648),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_RBRACK] = ACTIONS(4284),
    [anon_sym_EQ] = ACTIONS(4286),
    [anon_sym_QMARK] = ACTIONS(4284),
    [anon_sym_STAR_EQ] = ACTIONS(4284),
    [anon_sym_SLASH_EQ] = ACTIONS(4284),
    [anon_sym_PERCENT_EQ] = ACTIONS(4284),
    [anon_sym_PLUS_EQ] = ACTIONS(4284),
    [anon_sym_DASH_EQ] = ACTIONS(4284),
    [anon_sym_LT_LT_EQ] = ACTIONS(4284),
    [anon_sym_GT_GT_EQ] = ACTIONS(4284),
    [anon_sym_AMP_EQ] = ACTIONS(4284),
    [anon_sym_CARET_EQ] = ACTIONS(4284),
    [anon_sym_PIPE_EQ] = ACTIONS(4284),
    [anon_sym_AMP] = ACTIONS(2658),
    [anon_sym_PIPE_PIPE] = ACTIONS(4284),
    [anon_sym_AMP_AMP] = ACTIONS(4284),
    [anon_sym_PIPE] = ACTIONS(4286),
    [anon_sym_CARET] = ACTIONS(4286),
    [anon_sym_EQ_EQ] = ACTIONS(2668),
    [anon_sym_BANG_EQ] = ACTIONS(2668),
    [anon_sym_LT] = ACTIONS(2670),
    [anon_sym_GT] = ACTIONS(2670),
    [anon_sym_LT_EQ] = ACTIONS(2672),
    [anon_sym_GT_EQ] = ACTIONS(2672),
    [anon_sym_LT_LT] = ACTIONS(2674),
    [anon_sym_GT_GT] = ACTIONS(2674),
    [anon_sym_PLUS] = ACTIONS(2676),
    [anon_sym_DASH] = ACTIONS(2676),
    [anon_sym_SLASH] = ACTIONS(2648),
    [anon_sym_PERCENT] = ACTIONS(2648),
    [anon_sym_DASH_DASH] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(1554),
    [anon_sym_DASH_GT] = ACTIONS(1554),
    [sym_comment] = ACTIONS(49),
  },
  [1851] = {
    [sym_argument_list] = STATE(802),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_COMMA] = ACTIONS(4292),
    [anon_sym_STAR] = ACTIONS(2648),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_RBRACK] = ACTIONS(4292),
    [anon_sym_EQ] = ACTIONS(4294),
    [anon_sym_QMARK] = ACTIONS(4292),
    [anon_sym_STAR_EQ] = ACTIONS(4292),
    [anon_sym_SLASH_EQ] = ACTIONS(4292),
    [anon_sym_PERCENT_EQ] = ACTIONS(4292),
    [anon_sym_PLUS_EQ] = ACTIONS(4292),
    [anon_sym_DASH_EQ] = ACTIONS(4292),
    [anon_sym_LT_LT_EQ] = ACTIONS(4292),
    [anon_sym_GT_GT_EQ] = ACTIONS(4292),
    [anon_sym_AMP_EQ] = ACTIONS(4292),
    [anon_sym_CARET_EQ] = ACTIONS(4292),
    [anon_sym_PIPE_EQ] = ACTIONS(4292),
    [anon_sym_AMP] = ACTIONS(4294),
    [anon_sym_PIPE_PIPE] = ACTIONS(4292),
    [anon_sym_AMP_AMP] = ACTIONS(4292),
    [anon_sym_PIPE] = ACTIONS(4294),
    [anon_sym_CARET] = ACTIONS(4294),
    [anon_sym_EQ_EQ] = ACTIONS(4292),
    [anon_sym_BANG_EQ] = ACTIONS(4292),
    [anon_sym_LT] = ACTIONS(2670),
    [anon_sym_GT] = ACTIONS(2670),
    [anon_sym_LT_EQ] = ACTIONS(2672),
    [anon_sym_GT_EQ] = ACTIONS(2672),
    [anon_sym_LT_LT] = ACTIONS(2674),
    [anon_sym_GT_GT] = ACTIONS(2674),
    [anon_sym_PLUS] = ACTIONS(2676),
    [anon_sym_DASH] = ACTIONS(2676),
    [anon_sym_SLASH] = ACTIONS(2648),
    [anon_sym_PERCENT] = ACTIONS(2648),
    [anon_sym_DASH_DASH] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(1554),
    [anon_sym_DASH_GT] = ACTIONS(1554),
    [sym_comment] = ACTIONS(49),
  },
  [1852] = {
    [sym_argument_list] = STATE(802),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_COMMA] = ACTIONS(4296),
    [anon_sym_STAR] = ACTIONS(2648),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_RBRACK] = ACTIONS(4296),
    [anon_sym_EQ] = ACTIONS(4298),
    [anon_sym_QMARK] = ACTIONS(4296),
    [anon_sym_STAR_EQ] = ACTIONS(4296),
    [anon_sym_SLASH_EQ] = ACTIONS(4296),
    [anon_sym_PERCENT_EQ] = ACTIONS(4296),
    [anon_sym_PLUS_EQ] = ACTIONS(4296),
    [anon_sym_DASH_EQ] = ACTIONS(4296),
    [anon_sym_LT_LT_EQ] = ACTIONS(4296),
    [anon_sym_GT_GT_EQ] = ACTIONS(4296),
    [anon_sym_AMP_EQ] = ACTIONS(4296),
    [anon_sym_CARET_EQ] = ACTIONS(4296),
    [anon_sym_PIPE_EQ] = ACTIONS(4296),
    [anon_sym_AMP] = ACTIONS(4298),
    [anon_sym_PIPE_PIPE] = ACTIONS(4296),
    [anon_sym_AMP_AMP] = ACTIONS(4296),
    [anon_sym_PIPE] = ACTIONS(4298),
    [anon_sym_CARET] = ACTIONS(4298),
    [anon_sym_EQ_EQ] = ACTIONS(4296),
    [anon_sym_BANG_EQ] = ACTIONS(4296),
    [anon_sym_LT] = ACTIONS(4298),
    [anon_sym_GT] = ACTIONS(4298),
    [anon_sym_LT_EQ] = ACTIONS(4296),
    [anon_sym_GT_EQ] = ACTIONS(4296),
    [anon_sym_LT_LT] = ACTIONS(2674),
    [anon_sym_GT_GT] = ACTIONS(2674),
    [anon_sym_PLUS] = ACTIONS(2676),
    [anon_sym_DASH] = ACTIONS(2676),
    [anon_sym_SLASH] = ACTIONS(2648),
    [anon_sym_PERCENT] = ACTIONS(2648),
    [anon_sym_DASH_DASH] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(1554),
    [anon_sym_DASH_GT] = ACTIONS(1554),
    [sym_comment] = ACTIONS(49),
  },
  [1853] = {
    [sym_argument_list] = STATE(802),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_COMMA] = ACTIONS(4300),
    [anon_sym_STAR] = ACTIONS(2648),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_RBRACK] = ACTIONS(4300),
    [anon_sym_EQ] = ACTIONS(4302),
    [anon_sym_QMARK] = ACTIONS(4300),
    [anon_sym_STAR_EQ] = ACTIONS(4300),
    [anon_sym_SLASH_EQ] = ACTIONS(4300),
    [anon_sym_PERCENT_EQ] = ACTIONS(4300),
    [anon_sym_PLUS_EQ] = ACTIONS(4300),
    [anon_sym_DASH_EQ] = ACTIONS(4300),
    [anon_sym_LT_LT_EQ] = ACTIONS(4300),
    [anon_sym_GT_GT_EQ] = ACTIONS(4300),
    [anon_sym_AMP_EQ] = ACTIONS(4300),
    [anon_sym_CARET_EQ] = ACTIONS(4300),
    [anon_sym_PIPE_EQ] = ACTIONS(4300),
    [anon_sym_AMP] = ACTIONS(4302),
    [anon_sym_PIPE_PIPE] = ACTIONS(4300),
    [anon_sym_AMP_AMP] = ACTIONS(4300),
    [anon_sym_PIPE] = ACTIONS(4302),
    [anon_sym_CARET] = ACTIONS(4302),
    [anon_sym_EQ_EQ] = ACTIONS(4300),
    [anon_sym_BANG_EQ] = ACTIONS(4300),
    [anon_sym_LT] = ACTIONS(4302),
    [anon_sym_GT] = ACTIONS(4302),
    [anon_sym_LT_EQ] = ACTIONS(4300),
    [anon_sym_GT_EQ] = ACTIONS(4300),
    [anon_sym_LT_LT] = ACTIONS(4302),
    [anon_sym_GT_GT] = ACTIONS(4302),
    [anon_sym_PLUS] = ACTIONS(2676),
    [anon_sym_DASH] = ACTIONS(2676),
    [anon_sym_SLASH] = ACTIONS(2648),
    [anon_sym_PERCENT] = ACTIONS(2648),
    [anon_sym_DASH_DASH] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(1554),
    [anon_sym_DASH_GT] = ACTIONS(1554),
    [sym_comment] = ACTIONS(49),
  },
  [1854] = {
    [sym_argument_list] = STATE(802),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_COMMA] = ACTIONS(4274),
    [anon_sym_STAR] = ACTIONS(2648),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_RBRACK] = ACTIONS(4274),
    [anon_sym_EQ] = ACTIONS(4276),
    [anon_sym_QMARK] = ACTIONS(4274),
    [anon_sym_STAR_EQ] = ACTIONS(4274),
    [anon_sym_SLASH_EQ] = ACTIONS(4274),
    [anon_sym_PERCENT_EQ] = ACTIONS(4274),
    [anon_sym_PLUS_EQ] = ACTIONS(4274),
    [anon_sym_DASH_EQ] = ACTIONS(4274),
    [anon_sym_LT_LT_EQ] = ACTIONS(4274),
    [anon_sym_GT_GT_EQ] = ACTIONS(4274),
    [anon_sym_AMP_EQ] = ACTIONS(4274),
    [anon_sym_CARET_EQ] = ACTIONS(4274),
    [anon_sym_PIPE_EQ] = ACTIONS(4274),
    [anon_sym_AMP] = ACTIONS(4276),
    [anon_sym_PIPE_PIPE] = ACTIONS(4274),
    [anon_sym_AMP_AMP] = ACTIONS(4274),
    [anon_sym_PIPE] = ACTIONS(4276),
    [anon_sym_CARET] = ACTIONS(4276),
    [anon_sym_EQ_EQ] = ACTIONS(4274),
    [anon_sym_BANG_EQ] = ACTIONS(4274),
    [anon_sym_LT] = ACTIONS(4276),
    [anon_sym_GT] = ACTIONS(4276),
    [anon_sym_LT_EQ] = ACTIONS(4274),
    [anon_sym_GT_EQ] = ACTIONS(4274),
    [anon_sym_LT_LT] = ACTIONS(4276),
    [anon_sym_GT_GT] = ACTIONS(4276),
    [anon_sym_PLUS] = ACTIONS(4276),
    [anon_sym_DASH] = ACTIONS(4276),
    [anon_sym_SLASH] = ACTIONS(2648),
    [anon_sym_PERCENT] = ACTIONS(2648),
    [anon_sym_DASH_DASH] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(1554),
    [anon_sym_DASH_GT] = ACTIONS(1554),
    [sym_comment] = ACTIONS(49),
  },
  [1855] = {
    [anon_sym_LPAREN] = ACTIONS(5197),
    [anon_sym_STAR] = ACTIONS(5197),
    [anon_sym_LBRACK] = ACTIONS(5197),
    [anon_sym_AMP] = ACTIONS(5199),
    [anon_sym_AMP_AMP] = ACTIONS(5197),
    [sym_comment] = ACTIONS(49),
  },
  [1856] = {
    [aux_sym_for_statement_repeat1] = STATE(1856),
    [anon_sym_COMMA] = ACTIONS(5201),
    [anon_sym_RBRACK] = ACTIONS(5193),
    [sym_comment] = ACTIONS(49),
  },
  [1857] = {
    [sym_raw_string_literal] = ACTIONS(2010),
    [anon_sym_LPAREN] = ACTIONS(2010),
    [anon_sym_extern] = ACTIONS(2012),
    [anon_sym_STAR] = ACTIONS(2010),
    [anon_sym_LBRACK] = ACTIONS(2010),
    [anon_sym_RBRACK] = ACTIONS(2010),
    [anon_sym_static] = ACTIONS(2012),
    [anon_sym_register] = ACTIONS(2012),
    [anon_sym_inline] = ACTIONS(2012),
    [anon_sym_const] = ACTIONS(2012),
    [anon_sym_restrict] = ACTIONS(2012),
    [anon_sym_volatile] = ACTIONS(2012),
    [anon_sym__Atomic] = ACTIONS(2012),
    [anon_sym_mutable] = ACTIONS(2012),
    [anon_sym_explicit] = ACTIONS(2012),
    [anon_sym_constexpr] = ACTIONS(2012),
    [anon_sym_AMP] = ACTIONS(2010),
    [anon_sym_BANG] = ACTIONS(2010),
    [anon_sym_TILDE] = ACTIONS(2010),
    [anon_sym_PLUS] = ACTIONS(2012),
    [anon_sym_DASH] = ACTIONS(2012),
    [anon_sym_DASH_DASH] = ACTIONS(2010),
    [anon_sym_PLUS_PLUS] = ACTIONS(2010),
    [anon_sym_sizeof] = ACTIONS(2012),
    [sym_number_literal] = ACTIONS(2010),
    [sym_char_literal] = ACTIONS(2010),
    [sym_string_literal] = ACTIONS(2010),
    [sym_true] = ACTIONS(2012),
    [sym_false] = ACTIONS(2012),
    [sym_null] = ACTIONS(2012),
    [sym_identifier] = ACTIONS(2012),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(2012),
    [anon_sym_COLON_COLON] = ACTIONS(2010),
    [anon_sym_delete] = ACTIONS(2012),
    [sym_nullptr] = ACTIONS(2012),
  },
  [1858] = {
    [sym_enumerator] = STATE(1030),
    [anon_sym_RBRACE] = ACTIONS(5204),
    [sym_identifier] = ACTIONS(348),
    [sym_comment] = ACTIONS(49),
  },
  [1859] = {
    [aux_sym_enumerator_list_repeat1] = STATE(1032),
    [anon_sym_COMMA] = ACTIONS(5206),
    [anon_sym_RBRACE] = ACTIONS(5204),
    [sym_comment] = ACTIONS(49),
  },
  [1860] = {
    [sym_raw_string_literal] = ACTIONS(2114),
    [anon_sym_LPAREN] = ACTIONS(2114),
    [anon_sym_extern] = ACTIONS(2116),
    [anon_sym_STAR] = ACTIONS(2114),
    [anon_sym_LBRACK] = ACTIONS(2114),
    [anon_sym_RBRACK] = ACTIONS(2114),
    [anon_sym_static] = ACTIONS(2116),
    [anon_sym_register] = ACTIONS(2116),
    [anon_sym_inline] = ACTIONS(2116),
    [anon_sym_const] = ACTIONS(2116),
    [anon_sym_restrict] = ACTIONS(2116),
    [anon_sym_volatile] = ACTIONS(2116),
    [anon_sym__Atomic] = ACTIONS(2116),
    [anon_sym_mutable] = ACTIONS(2116),
    [anon_sym_explicit] = ACTIONS(2116),
    [anon_sym_constexpr] = ACTIONS(2116),
    [anon_sym_AMP] = ACTIONS(2114),
    [anon_sym_BANG] = ACTIONS(2114),
    [anon_sym_TILDE] = ACTIONS(2114),
    [anon_sym_PLUS] = ACTIONS(2116),
    [anon_sym_DASH] = ACTIONS(2116),
    [anon_sym_DASH_DASH] = ACTIONS(2114),
    [anon_sym_PLUS_PLUS] = ACTIONS(2114),
    [anon_sym_sizeof] = ACTIONS(2116),
    [sym_number_literal] = ACTIONS(2114),
    [sym_char_literal] = ACTIONS(2114),
    [sym_string_literal] = ACTIONS(2114),
    [sym_true] = ACTIONS(2116),
    [sym_false] = ACTIONS(2116),
    [sym_null] = ACTIONS(2116),
    [sym_identifier] = ACTIONS(2116),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(2116),
    [anon_sym_COLON_COLON] = ACTIONS(2114),
    [anon_sym_delete] = ACTIONS(2116),
    [sym_nullptr] = ACTIONS(2116),
  },
  [1861] = {
    [sym_raw_string_literal] = ACTIONS(1140),
    [anon_sym_LPAREN] = ACTIONS(1140),
    [anon_sym_extern] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(1140),
    [anon_sym_STAR] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1140),
    [anon_sym_RBRACK] = ACTIONS(1140),
    [anon_sym_static] = ACTIONS(1142),
    [anon_sym_register] = ACTIONS(1142),
    [anon_sym_inline] = ACTIONS(1142),
    [anon_sym_const] = ACTIONS(1142),
    [anon_sym_restrict] = ACTIONS(1142),
    [anon_sym_volatile] = ACTIONS(1142),
    [anon_sym__Atomic] = ACTIONS(1142),
    [anon_sym_mutable] = ACTIONS(1142),
    [anon_sym_explicit] = ACTIONS(1142),
    [anon_sym_constexpr] = ACTIONS(1142),
    [anon_sym_COLON] = ACTIONS(1142),
    [anon_sym_AMP] = ACTIONS(1140),
    [anon_sym_BANG] = ACTIONS(1140),
    [anon_sym_TILDE] = ACTIONS(1140),
    [anon_sym_LT] = ACTIONS(1140),
    [anon_sym_PLUS] = ACTIONS(1142),
    [anon_sym_DASH] = ACTIONS(1142),
    [anon_sym_DASH_DASH] = ACTIONS(1140),
    [anon_sym_PLUS_PLUS] = ACTIONS(1140),
    [anon_sym_sizeof] = ACTIONS(1142),
    [sym_number_literal] = ACTIONS(1140),
    [sym_char_literal] = ACTIONS(1140),
    [sym_string_literal] = ACTIONS(1140),
    [sym_true] = ACTIONS(1142),
    [sym_false] = ACTIONS(1142),
    [sym_null] = ACTIONS(1142),
    [sym_identifier] = ACTIONS(1142),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(1142),
    [anon_sym_COLON_COLON] = ACTIONS(1144),
    [anon_sym_delete] = ACTIONS(1142),
    [sym_nullptr] = ACTIONS(1142),
  },
  [1862] = {
    [sym_raw_string_literal] = ACTIONS(2202),
    [anon_sym_LPAREN] = ACTIONS(2202),
    [anon_sym_extern] = ACTIONS(2204),
    [anon_sym_STAR] = ACTIONS(2202),
    [anon_sym_LBRACK] = ACTIONS(2202),
    [anon_sym_RBRACK] = ACTIONS(2202),
    [anon_sym_static] = ACTIONS(2204),
    [anon_sym_register] = ACTIONS(2204),
    [anon_sym_inline] = ACTIONS(2204),
    [anon_sym_const] = ACTIONS(2204),
    [anon_sym_restrict] = ACTIONS(2204),
    [anon_sym_volatile] = ACTIONS(2204),
    [anon_sym__Atomic] = ACTIONS(2204),
    [anon_sym_mutable] = ACTIONS(2204),
    [anon_sym_explicit] = ACTIONS(2204),
    [anon_sym_constexpr] = ACTIONS(2204),
    [anon_sym_AMP] = ACTIONS(2202),
    [anon_sym_BANG] = ACTIONS(2202),
    [anon_sym_TILDE] = ACTIONS(2202),
    [anon_sym_PLUS] = ACTIONS(2204),
    [anon_sym_DASH] = ACTIONS(2204),
    [anon_sym_DASH_DASH] = ACTIONS(2202),
    [anon_sym_PLUS_PLUS] = ACTIONS(2202),
    [anon_sym_sizeof] = ACTIONS(2204),
    [sym_number_literal] = ACTIONS(2202),
    [sym_char_literal] = ACTIONS(2202),
    [sym_string_literal] = ACTIONS(2202),
    [sym_true] = ACTIONS(2204),
    [sym_false] = ACTIONS(2204),
    [sym_null] = ACTIONS(2204),
    [sym_identifier] = ACTIONS(2204),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(2204),
    [anon_sym_COLON_COLON] = ACTIONS(2202),
    [anon_sym_delete] = ACTIONS(2204),
    [sym_nullptr] = ACTIONS(2204),
  },
  [1863] = {
    [sym_raw_string_literal] = ACTIONS(1801),
    [anon_sym_LPAREN] = ACTIONS(1801),
    [anon_sym_extern] = ACTIONS(1803),
    [anon_sym_LBRACE] = ACTIONS(1801),
    [anon_sym_STAR] = ACTIONS(1801),
    [anon_sym_LBRACK] = ACTIONS(1801),
    [anon_sym_RBRACK] = ACTIONS(1801),
    [anon_sym_static] = ACTIONS(1803),
    [anon_sym_register] = ACTIONS(1803),
    [anon_sym_inline] = ACTIONS(1803),
    [anon_sym_const] = ACTIONS(1803),
    [anon_sym_restrict] = ACTIONS(1803),
    [anon_sym_volatile] = ACTIONS(1803),
    [anon_sym__Atomic] = ACTIONS(1803),
    [anon_sym_mutable] = ACTIONS(1803),
    [anon_sym_explicit] = ACTIONS(1803),
    [anon_sym_constexpr] = ACTIONS(1803),
    [anon_sym_COLON] = ACTIONS(1803),
    [anon_sym_AMP] = ACTIONS(1801),
    [anon_sym_BANG] = ACTIONS(1801),
    [anon_sym_TILDE] = ACTIONS(1801),
    [anon_sym_LT] = ACTIONS(1801),
    [anon_sym_PLUS] = ACTIONS(1803),
    [anon_sym_DASH] = ACTIONS(1803),
    [anon_sym_DASH_DASH] = ACTIONS(1801),
    [anon_sym_PLUS_PLUS] = ACTIONS(1801),
    [anon_sym_sizeof] = ACTIONS(1803),
    [sym_number_literal] = ACTIONS(1801),
    [sym_char_literal] = ACTIONS(1801),
    [sym_string_literal] = ACTIONS(1801),
    [sym_true] = ACTIONS(1803),
    [sym_false] = ACTIONS(1803),
    [sym_null] = ACTIONS(1803),
    [sym_identifier] = ACTIONS(1803),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(1803),
    [anon_sym_COLON_COLON] = ACTIONS(1805),
    [anon_sym_delete] = ACTIONS(1803),
    [sym_nullptr] = ACTIONS(1803),
  },
  [1864] = {
    [sym_raw_string_literal] = ACTIONS(2206),
    [anon_sym_LPAREN] = ACTIONS(2206),
    [anon_sym_extern] = ACTIONS(2208),
    [anon_sym_STAR] = ACTIONS(2206),
    [anon_sym_LBRACK] = ACTIONS(2206),
    [anon_sym_RBRACK] = ACTIONS(2206),
    [anon_sym_static] = ACTIONS(2208),
    [anon_sym_register] = ACTIONS(2208),
    [anon_sym_inline] = ACTIONS(2208),
    [anon_sym_const] = ACTIONS(2208),
    [anon_sym_restrict] = ACTIONS(2208),
    [anon_sym_volatile] = ACTIONS(2208),
    [anon_sym__Atomic] = ACTIONS(2208),
    [anon_sym_mutable] = ACTIONS(2208),
    [anon_sym_explicit] = ACTIONS(2208),
    [anon_sym_constexpr] = ACTIONS(2208),
    [anon_sym_AMP] = ACTIONS(2206),
    [anon_sym_BANG] = ACTIONS(2206),
    [anon_sym_TILDE] = ACTIONS(2206),
    [anon_sym_PLUS] = ACTIONS(2208),
    [anon_sym_DASH] = ACTIONS(2208),
    [anon_sym_DASH_DASH] = ACTIONS(2206),
    [anon_sym_PLUS_PLUS] = ACTIONS(2206),
    [anon_sym_sizeof] = ACTIONS(2208),
    [sym_number_literal] = ACTIONS(2206),
    [sym_char_literal] = ACTIONS(2206),
    [sym_string_literal] = ACTIONS(2206),
    [sym_true] = ACTIONS(2208),
    [sym_false] = ACTIONS(2208),
    [sym_null] = ACTIONS(2208),
    [sym_identifier] = ACTIONS(2208),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(2208),
    [anon_sym_COLON_COLON] = ACTIONS(2206),
    [anon_sym_delete] = ACTIONS(2208),
    [sym_nullptr] = ACTIONS(2208),
  },
  [1865] = {
    [sym__expression] = STATE(1834),
    [sym_conditional_expression] = STATE(1834),
    [sym_assignment_expression] = STATE(1834),
    [sym_pointer_expression] = STATE(1834),
    [sym_logical_expression] = STATE(1834),
    [sym_bitwise_expression] = STATE(1834),
    [sym_equality_expression] = STATE(1834),
    [sym_relational_expression] = STATE(1834),
    [sym_shift_expression] = STATE(1834),
    [sym_math_expression] = STATE(1834),
    [sym_cast_expression] = STATE(1834),
    [sym_sizeof_expression] = STATE(1834),
    [sym_subscript_expression] = STATE(1834),
    [sym_call_expression] = STATE(1834),
    [sym_field_expression] = STATE(1834),
    [sym_compound_literal_expression] = STATE(1834),
    [sym_parenthesized_expression] = STATE(1834),
    [sym_initializer_list] = STATE(1835),
    [sym_concatenated_string] = STATE(1834),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(1834),
    [sym_new_expression] = STATE(1834),
    [sym_delete_expression] = STATE(1834),
    [sym_lambda_expression] = STATE(1834),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(4145),
    [anon_sym_LPAREN] = ACTIONS(566),
    [anon_sym_LBRACE] = ACTIONS(548),
    [anon_sym_STAR] = ACTIONS(5208),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_RBRACK] = ACTIONS(5210),
    [anon_sym_EQ] = ACTIONS(5212),
    [anon_sym_QMARK] = ACTIONS(5210),
    [anon_sym_STAR_EQ] = ACTIONS(5210),
    [anon_sym_SLASH_EQ] = ACTIONS(5210),
    [anon_sym_PERCENT_EQ] = ACTIONS(5210),
    [anon_sym_PLUS_EQ] = ACTIONS(5210),
    [anon_sym_DASH_EQ] = ACTIONS(5210),
    [anon_sym_LT_LT_EQ] = ACTIONS(5210),
    [anon_sym_GT_GT_EQ] = ACTIONS(5210),
    [anon_sym_AMP_EQ] = ACTIONS(5210),
    [anon_sym_CARET_EQ] = ACTIONS(5210),
    [anon_sym_PIPE_EQ] = ACTIONS(5210),
    [anon_sym_AMP] = ACTIONS(5208),
    [anon_sym_PIPE_PIPE] = ACTIONS(5210),
    [anon_sym_AMP_AMP] = ACTIONS(5210),
    [anon_sym_BANG] = ACTIONS(5214),
    [anon_sym_PIPE] = ACTIONS(5212),
    [anon_sym_CARET] = ACTIONS(5212),
    [anon_sym_TILDE] = ACTIONS(586),
    [anon_sym_EQ_EQ] = ACTIONS(5210),
    [anon_sym_BANG_EQ] = ACTIONS(5210),
    [anon_sym_LT] = ACTIONS(5212),
    [anon_sym_GT] = ACTIONS(5212),
    [anon_sym_LT_EQ] = ACTIONS(5210),
    [anon_sym_GT_EQ] = ACTIONS(5210),
    [anon_sym_LT_LT] = ACTIONS(5212),
    [anon_sym_GT_GT] = ACTIONS(5212),
    [anon_sym_PLUS] = ACTIONS(588),
    [anon_sym_DASH] = ACTIONS(588),
    [anon_sym_SLASH] = ACTIONS(5212),
    [anon_sym_PERCENT] = ACTIONS(5212),
    [anon_sym_DASH_DASH] = ACTIONS(590),
    [anon_sym_PLUS_PLUS] = ACTIONS(590),
    [anon_sym_sizeof] = ACTIONS(592),
    [anon_sym_DOT] = ACTIONS(5210),
    [anon_sym_DASH_GT] = ACTIONS(5210),
    [sym_number_literal] = ACTIONS(4145),
    [sym_char_literal] = ACTIONS(4145),
    [sym_string_literal] = ACTIONS(594),
    [sym_true] = ACTIONS(4147),
    [sym_false] = ACTIONS(4147),
    [sym_null] = ACTIONS(4147),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1415),
    [anon_sym_delete] = ACTIONS(608),
    [sym_nullptr] = ACTIONS(4147),
  },
  [1866] = {
    [sym_raw_string_literal] = ACTIONS(2290),
    [anon_sym_LPAREN] = ACTIONS(2290),
    [anon_sym_extern] = ACTIONS(2292),
    [anon_sym_LBRACE] = ACTIONS(2290),
    [anon_sym_STAR] = ACTIONS(2292),
    [anon_sym_LBRACK] = ACTIONS(2290),
    [anon_sym_RBRACK] = ACTIONS(2290),
    [anon_sym_EQ] = ACTIONS(2292),
    [anon_sym_static] = ACTIONS(2292),
    [anon_sym_register] = ACTIONS(2292),
    [anon_sym_inline] = ACTIONS(2292),
    [anon_sym_const] = ACTIONS(2292),
    [anon_sym_restrict] = ACTIONS(2292),
    [anon_sym_volatile] = ACTIONS(2292),
    [anon_sym__Atomic] = ACTIONS(2292),
    [anon_sym_mutable] = ACTIONS(2292),
    [anon_sym_explicit] = ACTIONS(2292),
    [anon_sym_constexpr] = ACTIONS(2292),
    [anon_sym_QMARK] = ACTIONS(2290),
    [anon_sym_STAR_EQ] = ACTIONS(2290),
    [anon_sym_SLASH_EQ] = ACTIONS(2290),
    [anon_sym_PERCENT_EQ] = ACTIONS(2290),
    [anon_sym_PLUS_EQ] = ACTIONS(2290),
    [anon_sym_DASH_EQ] = ACTIONS(2290),
    [anon_sym_LT_LT_EQ] = ACTIONS(2290),
    [anon_sym_GT_GT_EQ] = ACTIONS(2290),
    [anon_sym_AMP_EQ] = ACTIONS(2290),
    [anon_sym_CARET_EQ] = ACTIONS(2290),
    [anon_sym_PIPE_EQ] = ACTIONS(2290),
    [anon_sym_AMP] = ACTIONS(2292),
    [anon_sym_PIPE_PIPE] = ACTIONS(2290),
    [anon_sym_AMP_AMP] = ACTIONS(2290),
    [anon_sym_BANG] = ACTIONS(2292),
    [anon_sym_PIPE] = ACTIONS(2292),
    [anon_sym_CARET] = ACTIONS(2292),
    [anon_sym_TILDE] = ACTIONS(2290),
    [anon_sym_EQ_EQ] = ACTIONS(2290),
    [anon_sym_BANG_EQ] = ACTIONS(2290),
    [anon_sym_LT] = ACTIONS(2292),
    [anon_sym_GT] = ACTIONS(2292),
    [anon_sym_LT_EQ] = ACTIONS(2290),
    [anon_sym_GT_EQ] = ACTIONS(2290),
    [anon_sym_LT_LT] = ACTIONS(2292),
    [anon_sym_GT_GT] = ACTIONS(2292),
    [anon_sym_PLUS] = ACTIONS(2292),
    [anon_sym_DASH] = ACTIONS(2292),
    [anon_sym_SLASH] = ACTIONS(2292),
    [anon_sym_PERCENT] = ACTIONS(2292),
    [anon_sym_DASH_DASH] = ACTIONS(2290),
    [anon_sym_PLUS_PLUS] = ACTIONS(2290),
    [anon_sym_sizeof] = ACTIONS(2292),
    [anon_sym_DOT] = ACTIONS(2290),
    [anon_sym_DASH_GT] = ACTIONS(2290),
    [sym_number_literal] = ACTIONS(2290),
    [sym_char_literal] = ACTIONS(2290),
    [sym_string_literal] = ACTIONS(2290),
    [sym_true] = ACTIONS(2292),
    [sym_false] = ACTIONS(2292),
    [sym_null] = ACTIONS(2292),
    [sym_identifier] = ACTIONS(2292),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(2292),
    [anon_sym_COLON_COLON] = ACTIONS(2290),
    [anon_sym_delete] = ACTIONS(2292),
    [sym_nullptr] = ACTIONS(2292),
  },
  [1867] = {
    [aux_sym_template_argument_list_repeat1] = STATE(1133),
    [anon_sym_COMMA] = ACTIONS(1127),
    [anon_sym_GT] = ACTIONS(5216),
    [sym_comment] = ACTIONS(49),
  },
  [1868] = {
    [sym_raw_string_literal] = ACTIONS(2299),
    [anon_sym_LPAREN] = ACTIONS(2299),
    [anon_sym_extern] = ACTIONS(2301),
    [anon_sym_STAR] = ACTIONS(2299),
    [anon_sym_LBRACK] = ACTIONS(2299),
    [anon_sym_RBRACK] = ACTIONS(2299),
    [anon_sym_static] = ACTIONS(2301),
    [anon_sym_register] = ACTIONS(2301),
    [anon_sym_inline] = ACTIONS(2301),
    [anon_sym_const] = ACTIONS(2301),
    [anon_sym_restrict] = ACTIONS(2301),
    [anon_sym_volatile] = ACTIONS(2301),
    [anon_sym__Atomic] = ACTIONS(2301),
    [anon_sym_mutable] = ACTIONS(2301),
    [anon_sym_explicit] = ACTIONS(2301),
    [anon_sym_constexpr] = ACTIONS(2301),
    [anon_sym_AMP] = ACTIONS(2299),
    [anon_sym_BANG] = ACTIONS(2299),
    [anon_sym_TILDE] = ACTIONS(2299),
    [anon_sym_PLUS] = ACTIONS(2301),
    [anon_sym_DASH] = ACTIONS(2301),
    [anon_sym_DASH_DASH] = ACTIONS(2299),
    [anon_sym_PLUS_PLUS] = ACTIONS(2299),
    [anon_sym_sizeof] = ACTIONS(2301),
    [sym_number_literal] = ACTIONS(2299),
    [sym_char_literal] = ACTIONS(2299),
    [sym_string_literal] = ACTIONS(2299),
    [sym_true] = ACTIONS(2301),
    [sym_false] = ACTIONS(2301),
    [sym_null] = ACTIONS(2301),
    [sym_identifier] = ACTIONS(2301),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(2301),
    [anon_sym_COLON_COLON] = ACTIONS(2299),
    [anon_sym_delete] = ACTIONS(2301),
    [sym_nullptr] = ACTIONS(2301),
  },
  [1869] = {
    [sym_argument_list] = STATE(802),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_STAR] = ACTIONS(1522),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_RBRACK] = ACTIONS(5218),
    [anon_sym_EQ] = ACTIONS(1526),
    [anon_sym_QMARK] = ACTIONS(1528),
    [anon_sym_STAR_EQ] = ACTIONS(1530),
    [anon_sym_SLASH_EQ] = ACTIONS(1530),
    [anon_sym_PERCENT_EQ] = ACTIONS(1530),
    [anon_sym_PLUS_EQ] = ACTIONS(1530),
    [anon_sym_DASH_EQ] = ACTIONS(1530),
    [anon_sym_LT_LT_EQ] = ACTIONS(1530),
    [anon_sym_GT_GT_EQ] = ACTIONS(1530),
    [anon_sym_AMP_EQ] = ACTIONS(1530),
    [anon_sym_CARET_EQ] = ACTIONS(1530),
    [anon_sym_PIPE_EQ] = ACTIONS(1530),
    [anon_sym_AMP] = ACTIONS(1532),
    [anon_sym_PIPE_PIPE] = ACTIONS(1534),
    [anon_sym_AMP_AMP] = ACTIONS(1536),
    [anon_sym_PIPE] = ACTIONS(1538),
    [anon_sym_CARET] = ACTIONS(1540),
    [anon_sym_EQ_EQ] = ACTIONS(1542),
    [anon_sym_BANG_EQ] = ACTIONS(1542),
    [anon_sym_LT] = ACTIONS(1544),
    [anon_sym_GT] = ACTIONS(1544),
    [anon_sym_LT_EQ] = ACTIONS(1546),
    [anon_sym_GT_EQ] = ACTIONS(1546),
    [anon_sym_LT_LT] = ACTIONS(1548),
    [anon_sym_GT_GT] = ACTIONS(1548),
    [anon_sym_PLUS] = ACTIONS(1550),
    [anon_sym_DASH] = ACTIONS(1550),
    [anon_sym_SLASH] = ACTIONS(1522),
    [anon_sym_PERCENT] = ACTIONS(1522),
    [anon_sym_DASH_DASH] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(1554),
    [anon_sym_DASH_GT] = ACTIONS(1554),
    [sym_comment] = ACTIONS(49),
  },
  [1870] = {
    [anon_sym_LPAREN] = ACTIONS(5220),
    [anon_sym_COMMA] = ACTIONS(5220),
    [anon_sym_RPAREN] = ACTIONS(5220),
    [anon_sym_SEMI] = ACTIONS(5220),
    [anon_sym_RBRACE] = ACTIONS(5220),
    [anon_sym_STAR] = ACTIONS(5222),
    [anon_sym_LBRACK] = ACTIONS(5220),
    [anon_sym_RBRACK] = ACTIONS(5220),
    [anon_sym_EQ] = ACTIONS(5222),
    [anon_sym_COLON] = ACTIONS(5220),
    [anon_sym_QMARK] = ACTIONS(5220),
    [anon_sym_STAR_EQ] = ACTIONS(5220),
    [anon_sym_SLASH_EQ] = ACTIONS(5220),
    [anon_sym_PERCENT_EQ] = ACTIONS(5220),
    [anon_sym_PLUS_EQ] = ACTIONS(5220),
    [anon_sym_DASH_EQ] = ACTIONS(5220),
    [anon_sym_LT_LT_EQ] = ACTIONS(5220),
    [anon_sym_GT_GT_EQ] = ACTIONS(5220),
    [anon_sym_AMP_EQ] = ACTIONS(5220),
    [anon_sym_CARET_EQ] = ACTIONS(5220),
    [anon_sym_PIPE_EQ] = ACTIONS(5220),
    [anon_sym_AMP] = ACTIONS(5222),
    [anon_sym_PIPE_PIPE] = ACTIONS(5220),
    [anon_sym_AMP_AMP] = ACTIONS(5220),
    [anon_sym_PIPE] = ACTIONS(5222),
    [anon_sym_CARET] = ACTIONS(5222),
    [anon_sym_EQ_EQ] = ACTIONS(5220),
    [anon_sym_BANG_EQ] = ACTIONS(5220),
    [anon_sym_LT] = ACTIONS(5222),
    [anon_sym_GT] = ACTIONS(5222),
    [anon_sym_LT_EQ] = ACTIONS(5220),
    [anon_sym_GT_EQ] = ACTIONS(5220),
    [anon_sym_LT_LT] = ACTIONS(5222),
    [anon_sym_GT_GT] = ACTIONS(5222),
    [anon_sym_PLUS] = ACTIONS(5222),
    [anon_sym_DASH] = ACTIONS(5222),
    [anon_sym_SLASH] = ACTIONS(5222),
    [anon_sym_PERCENT] = ACTIONS(5222),
    [anon_sym_DASH_DASH] = ACTIONS(5220),
    [anon_sym_PLUS_PLUS] = ACTIONS(5220),
    [anon_sym_DOT] = ACTIONS(5220),
    [anon_sym_DASH_GT] = ACTIONS(5220),
    [sym_comment] = ACTIONS(49),
  },
  [1871] = {
    [anon_sym_LPAREN] = ACTIONS(5224),
    [anon_sym_COMMA] = ACTIONS(5224),
    [anon_sym_RPAREN] = ACTIONS(5224),
    [anon_sym_SEMI] = ACTIONS(5224),
    [anon_sym_RBRACE] = ACTIONS(5224),
    [anon_sym_STAR] = ACTIONS(5226),
    [anon_sym_LBRACK] = ACTIONS(5224),
    [anon_sym_RBRACK] = ACTIONS(5224),
    [anon_sym_EQ] = ACTIONS(5226),
    [anon_sym_COLON] = ACTIONS(5224),
    [anon_sym_QMARK] = ACTIONS(5224),
    [anon_sym_STAR_EQ] = ACTIONS(5224),
    [anon_sym_SLASH_EQ] = ACTIONS(5224),
    [anon_sym_PERCENT_EQ] = ACTIONS(5224),
    [anon_sym_PLUS_EQ] = ACTIONS(5224),
    [anon_sym_DASH_EQ] = ACTIONS(5224),
    [anon_sym_LT_LT_EQ] = ACTIONS(5224),
    [anon_sym_GT_GT_EQ] = ACTIONS(5224),
    [anon_sym_AMP_EQ] = ACTIONS(5224),
    [anon_sym_CARET_EQ] = ACTIONS(5224),
    [anon_sym_PIPE_EQ] = ACTIONS(5224),
    [anon_sym_AMP] = ACTIONS(5226),
    [anon_sym_PIPE_PIPE] = ACTIONS(5224),
    [anon_sym_AMP_AMP] = ACTIONS(5224),
    [anon_sym_PIPE] = ACTIONS(5226),
    [anon_sym_CARET] = ACTIONS(5226),
    [anon_sym_EQ_EQ] = ACTIONS(5224),
    [anon_sym_BANG_EQ] = ACTIONS(5224),
    [anon_sym_LT] = ACTIONS(5226),
    [anon_sym_GT] = ACTIONS(5226),
    [anon_sym_LT_EQ] = ACTIONS(5224),
    [anon_sym_GT_EQ] = ACTIONS(5224),
    [anon_sym_LT_LT] = ACTIONS(5226),
    [anon_sym_GT_GT] = ACTIONS(5226),
    [anon_sym_PLUS] = ACTIONS(5226),
    [anon_sym_DASH] = ACTIONS(5226),
    [anon_sym_SLASH] = ACTIONS(5226),
    [anon_sym_PERCENT] = ACTIONS(5226),
    [anon_sym_DASH_DASH] = ACTIONS(5224),
    [anon_sym_PLUS_PLUS] = ACTIONS(5224),
    [anon_sym_DOT] = ACTIONS(5224),
    [anon_sym_DASH_GT] = ACTIONS(5224),
    [sym_comment] = ACTIONS(49),
  },
  [1872] = {
    [sym_argument_list] = STATE(2241),
    [sym_initializer_list] = STATE(2241),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_LBRACE] = ACTIONS(548),
    [sym_comment] = ACTIONS(49),
  },
  [1873] = {
    [anon_sym_LPAREN] = ACTIONS(5228),
    [anon_sym_COMMA] = ACTIONS(5228),
    [anon_sym_RPAREN] = ACTIONS(5228),
    [anon_sym_SEMI] = ACTIONS(5228),
    [anon_sym_RBRACE] = ACTIONS(5228),
    [anon_sym_STAR] = ACTIONS(5230),
    [anon_sym_LBRACK] = ACTIONS(5228),
    [anon_sym_RBRACK] = ACTIONS(5228),
    [anon_sym_EQ] = ACTIONS(5230),
    [anon_sym_COLON] = ACTIONS(5228),
    [anon_sym_QMARK] = ACTIONS(5228),
    [anon_sym_STAR_EQ] = ACTIONS(5228),
    [anon_sym_SLASH_EQ] = ACTIONS(5228),
    [anon_sym_PERCENT_EQ] = ACTIONS(5228),
    [anon_sym_PLUS_EQ] = ACTIONS(5228),
    [anon_sym_DASH_EQ] = ACTIONS(5228),
    [anon_sym_LT_LT_EQ] = ACTIONS(5228),
    [anon_sym_GT_GT_EQ] = ACTIONS(5228),
    [anon_sym_AMP_EQ] = ACTIONS(5228),
    [anon_sym_CARET_EQ] = ACTIONS(5228),
    [anon_sym_PIPE_EQ] = ACTIONS(5228),
    [anon_sym_AMP] = ACTIONS(5230),
    [anon_sym_PIPE_PIPE] = ACTIONS(5228),
    [anon_sym_AMP_AMP] = ACTIONS(5228),
    [anon_sym_PIPE] = ACTIONS(5230),
    [anon_sym_CARET] = ACTIONS(5230),
    [anon_sym_EQ_EQ] = ACTIONS(5228),
    [anon_sym_BANG_EQ] = ACTIONS(5228),
    [anon_sym_LT] = ACTIONS(5230),
    [anon_sym_GT] = ACTIONS(5230),
    [anon_sym_LT_EQ] = ACTIONS(5228),
    [anon_sym_GT_EQ] = ACTIONS(5228),
    [anon_sym_LT_LT] = ACTIONS(5230),
    [anon_sym_GT_GT] = ACTIONS(5230),
    [anon_sym_PLUS] = ACTIONS(5230),
    [anon_sym_DASH] = ACTIONS(5230),
    [anon_sym_SLASH] = ACTIONS(5230),
    [anon_sym_PERCENT] = ACTIONS(5230),
    [anon_sym_DASH_DASH] = ACTIONS(5228),
    [anon_sym_PLUS_PLUS] = ACTIONS(5228),
    [anon_sym_DOT] = ACTIONS(5228),
    [anon_sym_DASH_GT] = ACTIONS(5228),
    [sym_comment] = ACTIONS(49),
  },
  [1874] = {
    [sym_argument_list] = STATE(2242),
    [sym_initializer_list] = STATE(2242),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_LBRACE] = ACTIONS(548),
    [sym_comment] = ACTIONS(49),
  },
  [1875] = {
    [sym__expression] = STATE(2243),
    [sym_conditional_expression] = STATE(2243),
    [sym_assignment_expression] = STATE(2243),
    [sym_pointer_expression] = STATE(2243),
    [sym_logical_expression] = STATE(2243),
    [sym_bitwise_expression] = STATE(2243),
    [sym_equality_expression] = STATE(2243),
    [sym_relational_expression] = STATE(2243),
    [sym_shift_expression] = STATE(2243),
    [sym_math_expression] = STATE(2243),
    [sym_cast_expression] = STATE(2243),
    [sym_sizeof_expression] = STATE(2243),
    [sym_subscript_expression] = STATE(2243),
    [sym_call_expression] = STATE(2243),
    [sym_field_expression] = STATE(2243),
    [sym_compound_literal_expression] = STATE(2243),
    [sym_parenthesized_expression] = STATE(2243),
    [sym_concatenated_string] = STATE(2243),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(2243),
    [sym_new_expression] = STATE(2243),
    [sym_delete_expression] = STATE(2243),
    [sym_lambda_expression] = STATE(2243),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(5232),
    [anon_sym_LPAREN] = ACTIONS(2624),
    [anon_sym_STAR] = ACTIONS(2624),
    [anon_sym_LBRACK] = ACTIONS(2624),
    [anon_sym_AMP] = ACTIONS(2626),
    [anon_sym_AMP_AMP] = ACTIONS(2624),
    [anon_sym_BANG] = ACTIONS(584),
    [anon_sym_TILDE] = ACTIONS(586),
    [anon_sym_PLUS] = ACTIONS(588),
    [anon_sym_DASH] = ACTIONS(588),
    [anon_sym_DASH_DASH] = ACTIONS(590),
    [anon_sym_PLUS_PLUS] = ACTIONS(590),
    [anon_sym_sizeof] = ACTIONS(592),
    [sym_number_literal] = ACTIONS(5232),
    [sym_char_literal] = ACTIONS(5232),
    [sym_string_literal] = ACTIONS(594),
    [sym_true] = ACTIONS(5234),
    [sym_false] = ACTIONS(5234),
    [sym_null] = ACTIONS(5234),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1415),
    [anon_sym_delete] = ACTIONS(608),
    [sym_nullptr] = ACTIONS(5234),
  },
  [1876] = {
    [sym_argument_list] = STATE(802),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_STAR] = ACTIONS(1522),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_RBRACK] = ACTIONS(5236),
    [anon_sym_EQ] = ACTIONS(5238),
    [anon_sym_QMARK] = ACTIONS(5236),
    [anon_sym_STAR_EQ] = ACTIONS(5236),
    [anon_sym_SLASH_EQ] = ACTIONS(5236),
    [anon_sym_PERCENT_EQ] = ACTIONS(5236),
    [anon_sym_PLUS_EQ] = ACTIONS(5236),
    [anon_sym_DASH_EQ] = ACTIONS(5236),
    [anon_sym_LT_LT_EQ] = ACTIONS(5236),
    [anon_sym_GT_GT_EQ] = ACTIONS(5236),
    [anon_sym_AMP_EQ] = ACTIONS(5236),
    [anon_sym_CARET_EQ] = ACTIONS(5236),
    [anon_sym_PIPE_EQ] = ACTIONS(5236),
    [anon_sym_AMP] = ACTIONS(1532),
    [anon_sym_PIPE_PIPE] = ACTIONS(1534),
    [anon_sym_AMP_AMP] = ACTIONS(1536),
    [anon_sym_PIPE] = ACTIONS(1538),
    [anon_sym_CARET] = ACTIONS(1540),
    [anon_sym_EQ_EQ] = ACTIONS(1542),
    [anon_sym_BANG_EQ] = ACTIONS(1542),
    [anon_sym_LT] = ACTIONS(1544),
    [anon_sym_GT] = ACTIONS(1544),
    [anon_sym_LT_EQ] = ACTIONS(1546),
    [anon_sym_GT_EQ] = ACTIONS(1546),
    [anon_sym_LT_LT] = ACTIONS(1548),
    [anon_sym_GT_GT] = ACTIONS(1548),
    [anon_sym_PLUS] = ACTIONS(1550),
    [anon_sym_DASH] = ACTIONS(1550),
    [anon_sym_SLASH] = ACTIONS(1522),
    [anon_sym_PERCENT] = ACTIONS(1522),
    [anon_sym_DASH_DASH] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(1554),
    [anon_sym_DASH_GT] = ACTIONS(1554),
    [sym_comment] = ACTIONS(49),
  },
  [1877] = {
    [anon_sym_LPAREN] = ACTIONS(5240),
    [anon_sym_COMMA] = ACTIONS(5240),
    [anon_sym_RPAREN] = ACTIONS(5240),
    [anon_sym_SEMI] = ACTIONS(5240),
    [anon_sym_RBRACE] = ACTIONS(5240),
    [anon_sym_STAR] = ACTIONS(5242),
    [anon_sym_LBRACK] = ACTIONS(5240),
    [anon_sym_RBRACK] = ACTIONS(5240),
    [anon_sym_EQ] = ACTIONS(5242),
    [anon_sym_COLON] = ACTIONS(5240),
    [anon_sym_QMARK] = ACTIONS(5240),
    [anon_sym_STAR_EQ] = ACTIONS(5240),
    [anon_sym_SLASH_EQ] = ACTIONS(5240),
    [anon_sym_PERCENT_EQ] = ACTIONS(5240),
    [anon_sym_PLUS_EQ] = ACTIONS(5240),
    [anon_sym_DASH_EQ] = ACTIONS(5240),
    [anon_sym_LT_LT_EQ] = ACTIONS(5240),
    [anon_sym_GT_GT_EQ] = ACTIONS(5240),
    [anon_sym_AMP_EQ] = ACTIONS(5240),
    [anon_sym_CARET_EQ] = ACTIONS(5240),
    [anon_sym_PIPE_EQ] = ACTIONS(5240),
    [anon_sym_AMP] = ACTIONS(5242),
    [anon_sym_PIPE_PIPE] = ACTIONS(5240),
    [anon_sym_AMP_AMP] = ACTIONS(5240),
    [anon_sym_PIPE] = ACTIONS(5242),
    [anon_sym_CARET] = ACTIONS(5242),
    [anon_sym_EQ_EQ] = ACTIONS(5240),
    [anon_sym_BANG_EQ] = ACTIONS(5240),
    [anon_sym_LT] = ACTIONS(5242),
    [anon_sym_GT] = ACTIONS(5242),
    [anon_sym_LT_EQ] = ACTIONS(5240),
    [anon_sym_GT_EQ] = ACTIONS(5240),
    [anon_sym_LT_LT] = ACTIONS(5242),
    [anon_sym_GT_GT] = ACTIONS(5242),
    [anon_sym_PLUS] = ACTIONS(5242),
    [anon_sym_DASH] = ACTIONS(5242),
    [anon_sym_SLASH] = ACTIONS(5242),
    [anon_sym_PERCENT] = ACTIONS(5242),
    [anon_sym_DASH_DASH] = ACTIONS(5240),
    [anon_sym_PLUS_PLUS] = ACTIONS(5240),
    [anon_sym_DOT] = ACTIONS(5240),
    [anon_sym_DASH_GT] = ACTIONS(5240),
    [sym_comment] = ACTIONS(49),
  },
  [1878] = {
    [sym__expression] = STATE(2244),
    [sym_conditional_expression] = STATE(2244),
    [sym_assignment_expression] = STATE(2244),
    [sym_pointer_expression] = STATE(2244),
    [sym_logical_expression] = STATE(2244),
    [sym_bitwise_expression] = STATE(2244),
    [sym_equality_expression] = STATE(2244),
    [sym_relational_expression] = STATE(2244),
    [sym_shift_expression] = STATE(2244),
    [sym_math_expression] = STATE(2244),
    [sym_cast_expression] = STATE(2244),
    [sym_sizeof_expression] = STATE(2244),
    [sym_subscript_expression] = STATE(2244),
    [sym_call_expression] = STATE(2244),
    [sym_field_expression] = STATE(2244),
    [sym_compound_literal_expression] = STATE(2244),
    [sym_parenthesized_expression] = STATE(2244),
    [sym_concatenated_string] = STATE(2244),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(2244),
    [sym_new_expression] = STATE(2244),
    [sym_delete_expression] = STATE(2244),
    [sym_lambda_expression] = STATE(2244),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(5244),
    [anon_sym_LPAREN] = ACTIONS(566),
    [anon_sym_STAR] = ACTIONS(568),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_AMP] = ACTIONS(568),
    [anon_sym_BANG] = ACTIONS(584),
    [anon_sym_TILDE] = ACTIONS(586),
    [anon_sym_PLUS] = ACTIONS(588),
    [anon_sym_DASH] = ACTIONS(588),
    [anon_sym_DASH_DASH] = ACTIONS(590),
    [anon_sym_PLUS_PLUS] = ACTIONS(590),
    [anon_sym_sizeof] = ACTIONS(592),
    [sym_number_literal] = ACTIONS(5244),
    [sym_char_literal] = ACTIONS(5244),
    [sym_string_literal] = ACTIONS(594),
    [sym_true] = ACTIONS(5246),
    [sym_false] = ACTIONS(5246),
    [sym_null] = ACTIONS(5246),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1415),
    [anon_sym_delete] = ACTIONS(608),
    [sym_nullptr] = ACTIONS(5246),
  },
  [1879] = {
    [sym_type_qualifier] = STATE(2245),
    [sym_trailing_return_type] = STATE(1713),
    [aux_sym_abstract_function_declarator_repeat1] = STATE(2245),
    [anon_sym_LPAREN] = ACTIONS(3764),
    [anon_sym_LBRACK] = ACTIONS(3764),
    [anon_sym_const] = ACTIONS(612),
    [anon_sym_restrict] = ACTIONS(614),
    [anon_sym_volatile] = ACTIONS(614),
    [anon_sym__Atomic] = ACTIONS(614),
    [anon_sym_mutable] = ACTIONS(614),
    [anon_sym_explicit] = ACTIONS(614),
    [anon_sym_constexpr] = ACTIONS(614),
    [anon_sym_DASH_GT] = ACTIONS(4320),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(5248),
  },
  [1880] = {
    [sym__type_specifier] = STATE(2247),
    [sym_sized_type_specifier] = STATE(2247),
    [sym_enum_specifier] = STATE(2247),
    [sym_struct_specifier] = STATE(2247),
    [sym_union_specifier] = STATE(2247),
    [sym_macro_type_specifier] = STATE(2247),
    [sym_class_specifier] = STATE(2247),
    [sym_dependent_type] = STATE(2247),
    [sym_template_type] = STATE(62),
    [sym_scoped_type_identifier] = STATE(34),
    [sym_scoped_namespace_identifier] = STATE(64),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2248),
    [anon_sym_unsigned] = ACTIONS(5250),
    [anon_sym_long] = ACTIONS(5250),
    [anon_sym_short] = ACTIONS(5250),
    [sym_primitive_type] = ACTIONS(5252),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(428),
    [anon_sym_union] = ACTIONS(430),
    [sym_identifier] = ACTIONS(434),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(436),
    [sym_auto] = ACTIONS(5252),
    [anon_sym_typename] = ACTIONS(5254),
    [anon_sym_COLON_COLON] = ACTIONS(111),
  },
  [1881] = {
    [sym_type_qualifier] = STATE(2249),
    [sym_trailing_return_type] = STATE(1713),
    [aux_sym_abstract_function_declarator_repeat1] = STATE(2249),
    [anon_sym_LPAREN] = ACTIONS(3764),
    [anon_sym_LBRACK] = ACTIONS(3764),
    [anon_sym_const] = ACTIONS(612),
    [anon_sym_restrict] = ACTIONS(614),
    [anon_sym_volatile] = ACTIONS(614),
    [anon_sym__Atomic] = ACTIONS(614),
    [anon_sym_mutable] = ACTIONS(614),
    [anon_sym_explicit] = ACTIONS(614),
    [anon_sym_constexpr] = ACTIONS(614),
    [anon_sym_DASH_GT] = ACTIONS(4320),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(5256),
  },
  [1882] = {
    [sym_type_qualifier] = STATE(1890),
    [sym_trailing_return_type] = STATE(2168),
    [aux_sym_abstract_function_declarator_repeat1] = STATE(1890),
    [anon_sym_LPAREN] = ACTIONS(4998),
    [anon_sym_LBRACE] = ACTIONS(4998),
    [anon_sym_LBRACK] = ACTIONS(4998),
    [anon_sym_const] = ACTIONS(612),
    [anon_sym_restrict] = ACTIONS(614),
    [anon_sym_volatile] = ACTIONS(614),
    [anon_sym__Atomic] = ACTIONS(614),
    [anon_sym_mutable] = ACTIONS(614),
    [anon_sym_explicit] = ACTIONS(614),
    [anon_sym_constexpr] = ACTIONS(614),
    [anon_sym_DASH_GT] = ACTIONS(2814),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(4344),
  },
  [1883] = {
    [sym_enumerator_list] = STATE(71),
    [anon_sym_LBRACE] = ACTIONS(125),
    [sym_identifier] = ACTIONS(5258),
    [sym_comment] = ACTIONS(49),
  },
  [1884] = {
    [sym_field_declaration_list] = STATE(76),
    [sym__class_name] = STATE(2251),
    [sym_base_class_clause] = STATE(78),
    [sym_template_type] = STATE(196),
    [sym_scoped_type_identifier] = STATE(590),
    [sym_scoped_namespace_identifier] = STATE(64),
    [anon_sym_LBRACE] = ACTIONS(129),
    [anon_sym_COLON] = ACTIONS(131),
    [sym_identifier] = ACTIONS(1067),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(111),
  },
  [1885] = {
    [sym_field_declaration_list] = STATE(82),
    [sym__class_name] = STATE(2252),
    [sym_base_class_clause] = STATE(84),
    [sym_template_type] = STATE(196),
    [sym_scoped_type_identifier] = STATE(590),
    [sym_scoped_namespace_identifier] = STATE(64),
    [anon_sym_LBRACE] = ACTIONS(129),
    [anon_sym_COLON] = ACTIONS(131),
    [sym_identifier] = ACTIONS(1067),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(111),
  },
  [1886] = {
    [sym_field_declaration_list] = STATE(89),
    [sym__class_name] = STATE(2253),
    [sym_base_class_clause] = STATE(91),
    [sym_template_type] = STATE(196),
    [sym_scoped_type_identifier] = STATE(590),
    [sym_scoped_namespace_identifier] = STATE(64),
    [anon_sym_LBRACE] = ACTIONS(129),
    [anon_sym_COLON] = ACTIONS(131),
    [sym_identifier] = ACTIONS(1067),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(111),
  },
  [1887] = {
    [sym__type_specifier] = STATE(93),
    [sym_sized_type_specifier] = STATE(93),
    [sym_enum_specifier] = STATE(93),
    [sym_struct_specifier] = STATE(93),
    [sym_union_specifier] = STATE(93),
    [sym_macro_type_specifier] = STATE(93),
    [sym_class_specifier] = STATE(93),
    [sym_dependent_type] = STATE(93),
    [sym_template_type] = STATE(62),
    [sym_scoped_type_identifier] = STATE(34),
    [sym_scoped_namespace_identifier] = STATE(64),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1889),
    [anon_sym_unsigned] = ACTIONS(4330),
    [anon_sym_long] = ACTIONS(4330),
    [anon_sym_short] = ACTIONS(4330),
    [sym_primitive_type] = ACTIONS(150),
    [anon_sym_enum] = ACTIONS(4334),
    [anon_sym_struct] = ACTIONS(4336),
    [anon_sym_union] = ACTIONS(4338),
    [sym_identifier] = ACTIONS(434),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(4340),
    [sym_auto] = ACTIONS(150),
    [anon_sym_typename] = ACTIONS(4342),
    [anon_sym_COLON_COLON] = ACTIONS(111),
  },
  [1888] = {
    [sym__abstract_declarator] = STATE(2256),
    [sym_abstract_pointer_declarator] = STATE(2256),
    [sym_abstract_function_declarator] = STATE(2256),
    [sym_abstract_array_declarator] = STATE(2256),
    [sym_parameter_list] = STATE(809),
    [sym_abstract_reference_declarator] = STATE(2256),
    [anon_sym_LPAREN] = ACTIONS(1115),
    [anon_sym_LBRACE] = ACTIONS(2841),
    [anon_sym_STAR] = ACTIONS(5260),
    [anon_sym_LBRACK] = ACTIONS(1121),
    [anon_sym_AMP] = ACTIONS(5262),
    [anon_sym_AMP_AMP] = ACTIONS(5264),
    [sym_comment] = ACTIONS(49),
  },
  [1889] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2257),
    [anon_sym_LPAREN] = ACTIONS(238),
    [anon_sym_LBRACE] = ACTIONS(238),
    [anon_sym_STAR] = ACTIONS(238),
    [anon_sym_LBRACK] = ACTIONS(238),
    [anon_sym_unsigned] = ACTIONS(5266),
    [anon_sym_long] = ACTIONS(5266),
    [anon_sym_short] = ACTIONS(5266),
    [sym_primitive_type] = ACTIONS(244),
    [anon_sym_AMP] = ACTIONS(240),
    [anon_sym_AMP_AMP] = ACTIONS(238),
    [sym_identifier] = ACTIONS(1135),
    [sym_comment] = ACTIONS(49),
  },
  [1890] = {
    [sym_type_qualifier] = STATE(1890),
    [aux_sym_abstract_function_declarator_repeat1] = STATE(1890),
    [anon_sym_LPAREN] = ACTIONS(5002),
    [anon_sym_LBRACE] = ACTIONS(5002),
    [anon_sym_LBRACK] = ACTIONS(5002),
    [anon_sym_const] = ACTIONS(5004),
    [anon_sym_restrict] = ACTIONS(5007),
    [anon_sym_volatile] = ACTIONS(5007),
    [anon_sym__Atomic] = ACTIONS(5007),
    [anon_sym_mutable] = ACTIONS(5007),
    [anon_sym_explicit] = ACTIONS(5007),
    [anon_sym_constexpr] = ACTIONS(5007),
    [anon_sym_DASH_GT] = ACTIONS(5002),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(5268),
  },
  [1891] = {
    [anon_sym_LPAREN] = ACTIONS(2290),
    [anon_sym_COMMA] = ACTIONS(2290),
    [anon_sym_RPAREN] = ACTIONS(2290),
    [anon_sym_SEMI] = ACTIONS(2290),
    [anon_sym_extern] = ACTIONS(2292),
    [anon_sym_LBRACE] = ACTIONS(2290),
    [anon_sym_RBRACE] = ACTIONS(2290),
    [anon_sym_STAR] = ACTIONS(2292),
    [anon_sym_LBRACK] = ACTIONS(2290),
    [anon_sym_RBRACK] = ACTIONS(2290),
    [anon_sym_EQ] = ACTIONS(2292),
    [anon_sym_static] = ACTIONS(2292),
    [anon_sym_register] = ACTIONS(2292),
    [anon_sym_inline] = ACTIONS(2292),
    [anon_sym_const] = ACTIONS(2292),
    [anon_sym_restrict] = ACTIONS(2292),
    [anon_sym_volatile] = ACTIONS(2292),
    [anon_sym__Atomic] = ACTIONS(2292),
    [anon_sym_mutable] = ACTIONS(2292),
    [anon_sym_explicit] = ACTIONS(2292),
    [anon_sym_constexpr] = ACTIONS(2292),
    [anon_sym_COLON] = ACTIONS(2292),
    [anon_sym_QMARK] = ACTIONS(2290),
    [anon_sym_STAR_EQ] = ACTIONS(2290),
    [anon_sym_SLASH_EQ] = ACTIONS(2290),
    [anon_sym_PERCENT_EQ] = ACTIONS(2290),
    [anon_sym_PLUS_EQ] = ACTIONS(2290),
    [anon_sym_DASH_EQ] = ACTIONS(2290),
    [anon_sym_LT_LT_EQ] = ACTIONS(2290),
    [anon_sym_GT_GT_EQ] = ACTIONS(2290),
    [anon_sym_AMP_EQ] = ACTIONS(2290),
    [anon_sym_CARET_EQ] = ACTIONS(2290),
    [anon_sym_PIPE_EQ] = ACTIONS(2290),
    [anon_sym_AMP] = ACTIONS(2292),
    [anon_sym_PIPE_PIPE] = ACTIONS(2290),
    [anon_sym_AMP_AMP] = ACTIONS(2290),
    [anon_sym_PIPE] = ACTIONS(2292),
    [anon_sym_CARET] = ACTIONS(2292),
    [anon_sym_TILDE] = ACTIONS(2290),
    [anon_sym_EQ_EQ] = ACTIONS(2290),
    [anon_sym_BANG_EQ] = ACTIONS(2290),
    [anon_sym_LT] = ACTIONS(2292),
    [anon_sym_GT] = ACTIONS(2292),
    [anon_sym_LT_EQ] = ACTIONS(2290),
    [anon_sym_GT_EQ] = ACTIONS(2290),
    [anon_sym_LT_LT] = ACTIONS(2292),
    [anon_sym_GT_GT] = ACTIONS(2292),
    [anon_sym_PLUS] = ACTIONS(2292),
    [anon_sym_DASH] = ACTIONS(2292),
    [anon_sym_SLASH] = ACTIONS(2292),
    [anon_sym_PERCENT] = ACTIONS(2292),
    [anon_sym_DASH_DASH] = ACTIONS(2290),
    [anon_sym_PLUS_PLUS] = ACTIONS(2290),
    [anon_sym_DOT] = ACTIONS(2290),
    [anon_sym_DASH_GT] = ACTIONS(2290),
    [sym_identifier] = ACTIONS(2292),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(2290),
    [sym_operator_name] = ACTIONS(2290),
  },
  [1892] = {
    [aux_sym_template_argument_list_repeat1] = STATE(1133),
    [anon_sym_COMMA] = ACTIONS(1127),
    [anon_sym_GT] = ACTIONS(5271),
    [sym_comment] = ACTIONS(49),
  },
  [1893] = {
    [sym_raw_string_literal] = ACTIONS(2290),
    [anon_sym_LPAREN] = ACTIONS(2290),
    [anon_sym_extern] = ACTIONS(2292),
    [anon_sym_LBRACE] = ACTIONS(2290),
    [anon_sym_STAR] = ACTIONS(2290),
    [anon_sym_LBRACK] = ACTIONS(2290),
    [anon_sym_RBRACK] = ACTIONS(2290),
    [anon_sym_static] = ACTIONS(2292),
    [anon_sym_register] = ACTIONS(2292),
    [anon_sym_inline] = ACTIONS(2292),
    [anon_sym_const] = ACTIONS(2292),
    [anon_sym_restrict] = ACTIONS(2292),
    [anon_sym_volatile] = ACTIONS(2292),
    [anon_sym__Atomic] = ACTIONS(2292),
    [anon_sym_mutable] = ACTIONS(2292),
    [anon_sym_explicit] = ACTIONS(2292),
    [anon_sym_constexpr] = ACTIONS(2292),
    [anon_sym_COLON] = ACTIONS(2292),
    [anon_sym_AMP] = ACTIONS(2290),
    [anon_sym_BANG] = ACTIONS(2290),
    [anon_sym_TILDE] = ACTIONS(2290),
    [anon_sym_PLUS] = ACTIONS(2292),
    [anon_sym_DASH] = ACTIONS(2292),
    [anon_sym_DASH_DASH] = ACTIONS(2290),
    [anon_sym_PLUS_PLUS] = ACTIONS(2290),
    [anon_sym_sizeof] = ACTIONS(2292),
    [sym_number_literal] = ACTIONS(2290),
    [sym_char_literal] = ACTIONS(2290),
    [sym_string_literal] = ACTIONS(2290),
    [sym_true] = ACTIONS(2292),
    [sym_false] = ACTIONS(2292),
    [sym_null] = ACTIONS(2292),
    [sym_identifier] = ACTIONS(2292),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(2292),
    [anon_sym_COLON_COLON] = ACTIONS(2290),
    [anon_sym_delete] = ACTIONS(2292),
    [sym_nullptr] = ACTIONS(2292),
  },
  [1894] = {
    [aux_sym_template_argument_list_repeat1] = STATE(1133),
    [anon_sym_COMMA] = ACTIONS(1127),
    [anon_sym_GT] = ACTIONS(5273),
    [sym_comment] = ACTIONS(49),
  },
  [1895] = {
    [anon_sym_RBRACE] = ACTIONS(5275),
    [sym_comment] = ACTIONS(49),
  },
  [1896] = {
    [anon_sym_LPAREN] = ACTIONS(985),
    [anon_sym_COMMA] = ACTIONS(985),
    [anon_sym_RPAREN] = ACTIONS(985),
    [anon_sym_SEMI] = ACTIONS(985),
    [anon_sym_LBRACE] = ACTIONS(985),
    [anon_sym_STAR] = ACTIONS(985),
    [anon_sym_LBRACK] = ACTIONS(985),
    [anon_sym_EQ] = ACTIONS(985),
    [anon_sym_const] = ACTIONS(987),
    [anon_sym_restrict] = ACTIONS(985),
    [anon_sym_volatile] = ACTIONS(985),
    [anon_sym__Atomic] = ACTIONS(985),
    [anon_sym_mutable] = ACTIONS(985),
    [anon_sym_explicit] = ACTIONS(985),
    [anon_sym_constexpr] = ACTIONS(985),
    [anon_sym_COLON] = ACTIONS(985),
    [anon_sym_AMP] = ACTIONS(987),
    [anon_sym_AMP_AMP] = ACTIONS(985),
    [anon_sym_GT] = ACTIONS(985),
    [anon_sym_DASH_GT] = ACTIONS(985),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(985),
  },
  [1897] = {
    [aux_sym_enumerator_list_repeat1] = STATE(2262),
    [anon_sym_COMMA] = ACTIONS(5277),
    [anon_sym_RBRACE] = ACTIONS(5275),
    [sym_comment] = ACTIONS(49),
  },
  [1898] = {
    [anon_sym_LPAREN] = ACTIONS(995),
    [anon_sym_COMMA] = ACTIONS(995),
    [anon_sym_RPAREN] = ACTIONS(995),
    [anon_sym_SEMI] = ACTIONS(995),
    [anon_sym_LBRACE] = ACTIONS(995),
    [anon_sym_STAR] = ACTIONS(995),
    [anon_sym_LBRACK] = ACTIONS(995),
    [anon_sym_EQ] = ACTIONS(995),
    [anon_sym_const] = ACTIONS(997),
    [anon_sym_restrict] = ACTIONS(995),
    [anon_sym_volatile] = ACTIONS(995),
    [anon_sym__Atomic] = ACTIONS(995),
    [anon_sym_mutable] = ACTIONS(995),
    [anon_sym_explicit] = ACTIONS(995),
    [anon_sym_constexpr] = ACTIONS(995),
    [anon_sym_COLON] = ACTIONS(995),
    [anon_sym_AMP] = ACTIONS(997),
    [anon_sym_AMP_AMP] = ACTIONS(995),
    [anon_sym_GT] = ACTIONS(995),
    [anon_sym_DASH_GT] = ACTIONS(995),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(995),
  },
  [1899] = {
    [anon_sym_LPAREN] = ACTIONS(1007),
    [anon_sym_COMMA] = ACTIONS(1007),
    [anon_sym_RPAREN] = ACTIONS(1007),
    [anon_sym_SEMI] = ACTIONS(1007),
    [anon_sym_LBRACE] = ACTIONS(1007),
    [anon_sym_STAR] = ACTIONS(1007),
    [anon_sym_LBRACK] = ACTIONS(1007),
    [anon_sym_EQ] = ACTIONS(1007),
    [anon_sym_const] = ACTIONS(1009),
    [anon_sym_restrict] = ACTIONS(1007),
    [anon_sym_volatile] = ACTIONS(1007),
    [anon_sym__Atomic] = ACTIONS(1007),
    [anon_sym_mutable] = ACTIONS(1007),
    [anon_sym_explicit] = ACTIONS(1007),
    [anon_sym_constexpr] = ACTIONS(1007),
    [anon_sym_COLON] = ACTIONS(1007),
    [anon_sym_AMP] = ACTIONS(1009),
    [anon_sym_AMP_AMP] = ACTIONS(1007),
    [anon_sym_GT] = ACTIONS(1007),
    [anon_sym_DASH_GT] = ACTIONS(1007),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(1007),
  },
  [1900] = {
    [sym_preproc_if_in_field_declaration_list] = STATE(246),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(247),
    [sym_type_definition] = STATE(563),
    [sym__declaration_specifiers] = STATE(248),
    [sym__declarator] = STATE(249),
    [sym_pointer_declarator] = STATE(249),
    [sym_function_declarator] = STATE(250),
    [sym_array_declarator] = STATE(249),
    [sym_storage_class_specifier] = STATE(257),
    [sym_type_qualifier] = STATE(257),
    [sym__type_specifier] = STATE(251),
    [sym_sized_type_specifier] = STATE(251),
    [sym_enum_specifier] = STATE(251),
    [sym_struct_specifier] = STATE(251),
    [sym_union_specifier] = STATE(251),
    [sym__field_declaration_list_item] = STATE(563),
    [sym_field_declaration] = STATE(563),
    [sym_macro_type_specifier] = STATE(251),
    [sym_class_specifier] = STATE(251),
    [sym_dependent_type] = STATE(251),
    [sym_template_declaration] = STATE(563),
    [sym_inline_method_definition] = STATE(252),
    [sym_constructor_or_destructor_definition] = STATE(252),
    [sym_constructor_or_destructor_declaration] = STATE(253),
    [sym_friend_declaration] = STATE(563),
    [sym_access_specifier] = STATE(563),
    [sym_reference_declarator] = STATE(249),
    [sym_template_type] = STATE(254),
    [sym_template_function] = STATE(249),
    [sym_using_declaration] = STATE(563),
    [sym_alias_declaration] = STATE(563),
    [sym_destructor_name] = STATE(249),
    [sym_scoped_identifier] = STATE(33),
    [sym_scoped_type_identifier] = STATE(34),
    [sym_scoped_namespace_identifier] = STATE(255),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(563),
    [aux_sym__declaration_specifiers_repeat1] = STATE(257),
    [aux_sym_sized_type_specifier_repeat1] = STATE(258),
    [anon_sym_LPAREN] = ACTIONS(11),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(358),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(360),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(362),
    [anon_sym_typedef] = ACTIONS(364),
    [anon_sym_extern] = ACTIONS(27),
    [anon_sym_RBRACE] = ACTIONS(5279),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_static] = ACTIONS(27),
    [anon_sym_register] = ACTIONS(27),
    [anon_sym_inline] = ACTIONS(27),
    [anon_sym_const] = ACTIONS(29),
    [anon_sym_restrict] = ACTIONS(29),
    [anon_sym_volatile] = ACTIONS(29),
    [anon_sym__Atomic] = ACTIONS(29),
    [anon_sym_mutable] = ACTIONS(29),
    [anon_sym_explicit] = ACTIONS(29),
    [anon_sym_constexpr] = ACTIONS(29),
    [anon_sym_unsigned] = ACTIONS(368),
    [anon_sym_long] = ACTIONS(368),
    [anon_sym_short] = ACTIONS(368),
    [sym_primitive_type] = ACTIONS(370),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(372),
    [anon_sym_union] = ACTIONS(374),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(45),
    [sym_identifier] = ACTIONS(376),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(378),
    [anon_sym_public] = ACTIONS(380),
    [sym_auto] = ACTIONS(370),
    [anon_sym_typename] = ACTIONS(382),
    [anon_sym_template] = ACTIONS(384),
    [anon_sym_friend] = ACTIONS(386),
    [anon_sym_private] = ACTIONS(380),
    [anon_sym_protected] = ACTIONS(380),
    [anon_sym_using] = ACTIONS(388),
    [anon_sym_COLON_COLON] = ACTIONS(390),
    [sym_operator_name] = ACTIONS(392),
  },
  [1901] = {
    [anon_sym_LPAREN] = ACTIONS(1075),
    [anon_sym_COMMA] = ACTIONS(1075),
    [anon_sym_RPAREN] = ACTIONS(1075),
    [anon_sym_SEMI] = ACTIONS(1075),
    [anon_sym_LBRACE] = ACTIONS(1075),
    [anon_sym_STAR] = ACTIONS(1075),
    [anon_sym_LBRACK] = ACTIONS(1075),
    [anon_sym_EQ] = ACTIONS(1075),
    [anon_sym_const] = ACTIONS(1077),
    [anon_sym_restrict] = ACTIONS(1075),
    [anon_sym_volatile] = ACTIONS(1075),
    [anon_sym__Atomic] = ACTIONS(1075),
    [anon_sym_mutable] = ACTIONS(1075),
    [anon_sym_explicit] = ACTIONS(1075),
    [anon_sym_constexpr] = ACTIONS(1075),
    [anon_sym_COLON] = ACTIONS(1075),
    [anon_sym_AMP] = ACTIONS(1077),
    [anon_sym_AMP_AMP] = ACTIONS(1075),
    [anon_sym_GT] = ACTIONS(1075),
    [anon_sym_DASH_GT] = ACTIONS(1075),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(1075),
  },
  [1902] = {
    [sym_field_declaration_list] = STATE(2264),
    [anon_sym_LBRACE] = ACTIONS(2829),
    [sym_comment] = ACTIONS(49),
  },
  [1903] = {
    [anon_sym_LPAREN] = ACTIONS(1081),
    [anon_sym_COMMA] = ACTIONS(1081),
    [anon_sym_RPAREN] = ACTIONS(1081),
    [anon_sym_SEMI] = ACTIONS(1081),
    [anon_sym_LBRACE] = ACTIONS(1081),
    [anon_sym_STAR] = ACTIONS(1081),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_EQ] = ACTIONS(1081),
    [anon_sym_const] = ACTIONS(1083),
    [anon_sym_restrict] = ACTIONS(1081),
    [anon_sym_volatile] = ACTIONS(1081),
    [anon_sym__Atomic] = ACTIONS(1081),
    [anon_sym_mutable] = ACTIONS(1081),
    [anon_sym_explicit] = ACTIONS(1081),
    [anon_sym_constexpr] = ACTIONS(1081),
    [anon_sym_COLON] = ACTIONS(1081),
    [anon_sym_AMP] = ACTIONS(1083),
    [anon_sym_AMP_AMP] = ACTIONS(1081),
    [anon_sym_GT] = ACTIONS(1081),
    [anon_sym_DASH_GT] = ACTIONS(1081),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(1081),
  },
  [1904] = {
    [sym_field_declaration_list] = STATE(2265),
    [anon_sym_LBRACE] = ACTIONS(2829),
    [sym_comment] = ACTIONS(49),
  },
  [1905] = {
    [anon_sym_LPAREN] = ACTIONS(1111),
    [anon_sym_COMMA] = ACTIONS(1111),
    [anon_sym_RPAREN] = ACTIONS(1111),
    [anon_sym_SEMI] = ACTIONS(1111),
    [anon_sym_LBRACE] = ACTIONS(1111),
    [anon_sym_STAR] = ACTIONS(1111),
    [anon_sym_LBRACK] = ACTIONS(1111),
    [anon_sym_EQ] = ACTIONS(1111),
    [anon_sym_const] = ACTIONS(1113),
    [anon_sym_restrict] = ACTIONS(1111),
    [anon_sym_volatile] = ACTIONS(1111),
    [anon_sym__Atomic] = ACTIONS(1111),
    [anon_sym_mutable] = ACTIONS(1111),
    [anon_sym_explicit] = ACTIONS(1111),
    [anon_sym_constexpr] = ACTIONS(1111),
    [anon_sym_COLON] = ACTIONS(1113),
    [anon_sym_AMP] = ACTIONS(1113),
    [anon_sym_AMP_AMP] = ACTIONS(1111),
    [anon_sym_GT] = ACTIONS(1111),
    [anon_sym_DASH_GT] = ACTIONS(1111),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(1111),
    [anon_sym_COLON_COLON] = ACTIONS(1111),
  },
  [1906] = {
    [aux_sym_template_argument_list_repeat1] = STATE(2267),
    [anon_sym_COMMA] = ACTIONS(1127),
    [anon_sym_GT] = ACTIONS(5281),
    [sym_comment] = ACTIONS(49),
  },
  [1907] = {
    [anon_sym_LPAREN] = ACTIONS(1140),
    [anon_sym_COMMA] = ACTIONS(1140),
    [anon_sym_RPAREN] = ACTIONS(1140),
    [anon_sym_SEMI] = ACTIONS(1140),
    [anon_sym_LBRACE] = ACTIONS(1140),
    [anon_sym_STAR] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1140),
    [anon_sym_EQ] = ACTIONS(1140),
    [anon_sym_const] = ACTIONS(1142),
    [anon_sym_restrict] = ACTIONS(1140),
    [anon_sym_volatile] = ACTIONS(1140),
    [anon_sym__Atomic] = ACTIONS(1140),
    [anon_sym_mutable] = ACTIONS(1140),
    [anon_sym_explicit] = ACTIONS(1140),
    [anon_sym_constexpr] = ACTIONS(1140),
    [anon_sym_COLON] = ACTIONS(1142),
    [anon_sym_AMP] = ACTIONS(1142),
    [anon_sym_AMP_AMP] = ACTIONS(1140),
    [anon_sym_LT] = ACTIONS(1140),
    [anon_sym_GT] = ACTIONS(1140),
    [anon_sym_DASH_GT] = ACTIONS(1140),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(1140),
    [anon_sym_COLON_COLON] = ACTIONS(1144),
  },
  [1908] = {
    [anon_sym_LPAREN] = ACTIONS(1150),
    [anon_sym_COMMA] = ACTIONS(1150),
    [anon_sym_RPAREN] = ACTIONS(1150),
    [anon_sym_SEMI] = ACTIONS(1150),
    [anon_sym_LBRACE] = ACTIONS(1150),
    [anon_sym_STAR] = ACTIONS(1150),
    [anon_sym_LBRACK] = ACTIONS(1150),
    [anon_sym_EQ] = ACTIONS(1150),
    [anon_sym_const] = ACTIONS(1152),
    [anon_sym_restrict] = ACTIONS(1150),
    [anon_sym_volatile] = ACTIONS(1150),
    [anon_sym__Atomic] = ACTIONS(1150),
    [anon_sym_mutable] = ACTIONS(1150),
    [anon_sym_explicit] = ACTIONS(1150),
    [anon_sym_constexpr] = ACTIONS(1150),
    [anon_sym_COLON] = ACTIONS(1150),
    [anon_sym_AMP] = ACTIONS(1152),
    [anon_sym_AMP_AMP] = ACTIONS(1150),
    [anon_sym_GT] = ACTIONS(1150),
    [anon_sym_DASH_GT] = ACTIONS(1150),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(1150),
  },
  [1909] = {
    [sym_field_declaration_list] = STATE(2268),
    [anon_sym_LBRACE] = ACTIONS(2829),
    [sym_comment] = ACTIONS(49),
  },
  [1910] = {
    [sym_parameter_list] = STATE(1912),
    [anon_sym_LPAREN] = ACTIONS(206),
    [anon_sym_LBRACE] = ACTIONS(3750),
    [anon_sym_LBRACK] = ACTIONS(2282),
    [anon_sym_const] = ACTIONS(5283),
    [anon_sym_restrict] = ACTIONS(3750),
    [anon_sym_volatile] = ACTIONS(3750),
    [anon_sym__Atomic] = ACTIONS(3750),
    [anon_sym_mutable] = ACTIONS(3750),
    [anon_sym_explicit] = ACTIONS(3750),
    [anon_sym_constexpr] = ACTIONS(3750),
    [anon_sym_COLON] = ACTIONS(3750),
    [anon_sym_DASH_GT] = ACTIONS(3750),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(3750),
  },
  [1911] = {
    [sym_parameter_list] = STATE(1912),
    [anon_sym_LPAREN] = ACTIONS(206),
    [anon_sym_LBRACE] = ACTIONS(3762),
    [anon_sym_LBRACK] = ACTIONS(2282),
    [anon_sym_const] = ACTIONS(5285),
    [anon_sym_restrict] = ACTIONS(3762),
    [anon_sym_volatile] = ACTIONS(3762),
    [anon_sym__Atomic] = ACTIONS(3762),
    [anon_sym_mutable] = ACTIONS(3762),
    [anon_sym_explicit] = ACTIONS(3762),
    [anon_sym_constexpr] = ACTIONS(3762),
    [anon_sym_COLON] = ACTIONS(3762),
    [anon_sym_DASH_GT] = ACTIONS(3762),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(3762),
  },
  [1912] = {
    [sym_type_qualifier] = STATE(2269),
    [sym_trailing_return_type] = STATE(1713),
    [aux_sym_abstract_function_declarator_repeat1] = STATE(2269),
    [anon_sym_LPAREN] = ACTIONS(3764),
    [anon_sym_LBRACE] = ACTIONS(3764),
    [anon_sym_LBRACK] = ACTIONS(3764),
    [anon_sym_const] = ACTIONS(3770),
    [anon_sym_restrict] = ACTIONS(3764),
    [anon_sym_volatile] = ACTIONS(3764),
    [anon_sym__Atomic] = ACTIONS(3764),
    [anon_sym_mutable] = ACTIONS(3764),
    [anon_sym_explicit] = ACTIONS(3764),
    [anon_sym_constexpr] = ACTIONS(3764),
    [anon_sym_COLON] = ACTIONS(3764),
    [anon_sym_DASH_GT] = ACTIONS(3764),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(3764),
  },
  [1913] = {
    [sym_type_qualifier] = STATE(2270),
    [sym_trailing_return_type] = STATE(1713),
    [aux_sym_abstract_function_declarator_repeat1] = STATE(2270),
    [anon_sym_LPAREN] = ACTIONS(3764),
    [anon_sym_LBRACE] = ACTIONS(3764),
    [anon_sym_LBRACK] = ACTIONS(3764),
    [anon_sym_const] = ACTIONS(612),
    [anon_sym_restrict] = ACTIONS(614),
    [anon_sym_volatile] = ACTIONS(614),
    [anon_sym__Atomic] = ACTIONS(614),
    [anon_sym_mutable] = ACTIONS(614),
    [anon_sym_explicit] = ACTIONS(614),
    [anon_sym_constexpr] = ACTIONS(614),
    [anon_sym_COLON] = ACTIONS(3764),
    [anon_sym_DASH_GT] = ACTIONS(616),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(5287),
  },
  [1914] = {
    [anon_sym_LPAREN] = ACTIONS(1801),
    [anon_sym_COMMA] = ACTIONS(1801),
    [anon_sym_RPAREN] = ACTIONS(1801),
    [anon_sym_SEMI] = ACTIONS(1801),
    [anon_sym_LBRACE] = ACTIONS(1801),
    [anon_sym_STAR] = ACTIONS(1801),
    [anon_sym_LBRACK] = ACTIONS(1801),
    [anon_sym_EQ] = ACTIONS(1801),
    [anon_sym_const] = ACTIONS(1803),
    [anon_sym_restrict] = ACTIONS(1801),
    [anon_sym_volatile] = ACTIONS(1801),
    [anon_sym__Atomic] = ACTIONS(1801),
    [anon_sym_mutable] = ACTIONS(1801),
    [anon_sym_explicit] = ACTIONS(1801),
    [anon_sym_constexpr] = ACTIONS(1801),
    [anon_sym_COLON] = ACTIONS(1803),
    [anon_sym_AMP] = ACTIONS(1803),
    [anon_sym_AMP_AMP] = ACTIONS(1801),
    [anon_sym_LT] = ACTIONS(1801),
    [anon_sym_GT] = ACTIONS(1801),
    [anon_sym_DASH_GT] = ACTIONS(1801),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(1801),
    [anon_sym_COLON_COLON] = ACTIONS(1805),
  },
  [1915] = {
    [anon_sym_LF] = ACTIONS(5289),
    [sym_comment] = ACTIONS(83),
  },
  [1916] = {
    [sym_raw_string_literal] = ACTIONS(1823),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1825),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1825),
    [anon_sym_LPAREN] = ACTIONS(1823),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1825),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1825),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1825),
    [sym_preproc_directive] = ACTIONS(1825),
    [anon_sym_SEMI] = ACTIONS(1823),
    [anon_sym_typedef] = ACTIONS(1825),
    [anon_sym_extern] = ACTIONS(1825),
    [anon_sym_LBRACE] = ACTIONS(1823),
    [anon_sym_RBRACE] = ACTIONS(1823),
    [anon_sym_STAR] = ACTIONS(1823),
    [anon_sym_LBRACK] = ACTIONS(1823),
    [anon_sym_static] = ACTIONS(1825),
    [anon_sym_register] = ACTIONS(1825),
    [anon_sym_inline] = ACTIONS(1825),
    [anon_sym_const] = ACTIONS(1825),
    [anon_sym_restrict] = ACTIONS(1825),
    [anon_sym_volatile] = ACTIONS(1825),
    [anon_sym__Atomic] = ACTIONS(1825),
    [anon_sym_mutable] = ACTIONS(1825),
    [anon_sym_explicit] = ACTIONS(1825),
    [anon_sym_constexpr] = ACTIONS(1825),
    [anon_sym_unsigned] = ACTIONS(1825),
    [anon_sym_long] = ACTIONS(1825),
    [anon_sym_short] = ACTIONS(1825),
    [sym_primitive_type] = ACTIONS(1825),
    [anon_sym_enum] = ACTIONS(1825),
    [anon_sym_struct] = ACTIONS(1825),
    [anon_sym_union] = ACTIONS(1825),
    [anon_sym_if] = ACTIONS(1825),
    [anon_sym_switch] = ACTIONS(1825),
    [anon_sym_case] = ACTIONS(1825),
    [anon_sym_default] = ACTIONS(1825),
    [anon_sym_while] = ACTIONS(1825),
    [anon_sym_do] = ACTIONS(1825),
    [anon_sym_for] = ACTIONS(1825),
    [anon_sym_return] = ACTIONS(1825),
    [anon_sym_break] = ACTIONS(1825),
    [anon_sym_continue] = ACTIONS(1825),
    [anon_sym_goto] = ACTIONS(1825),
    [anon_sym_AMP] = ACTIONS(1823),
    [anon_sym_BANG] = ACTIONS(1823),
    [anon_sym_TILDE] = ACTIONS(1823),
    [anon_sym_PLUS] = ACTIONS(1825),
    [anon_sym_DASH] = ACTIONS(1825),
    [anon_sym_DASH_DASH] = ACTIONS(1823),
    [anon_sym_PLUS_PLUS] = ACTIONS(1823),
    [anon_sym_sizeof] = ACTIONS(1825),
    [sym_number_literal] = ACTIONS(1823),
    [sym_char_literal] = ACTIONS(1823),
    [sym_string_literal] = ACTIONS(1823),
    [sym_true] = ACTIONS(1825),
    [sym_false] = ACTIONS(1825),
    [sym_null] = ACTIONS(1825),
    [sym_identifier] = ACTIONS(1825),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(1825),
    [sym_auto] = ACTIONS(1825),
    [anon_sym_typename] = ACTIONS(1825),
    [anon_sym_new] = ACTIONS(1825),
    [anon_sym_COLON_COLON] = ACTIONS(1823),
    [anon_sym_delete] = ACTIONS(1825),
    [sym_nullptr] = ACTIONS(1825),
  },
  [1917] = {
    [anon_sym_LF] = ACTIONS(5291),
    [sym_comment] = ACTIONS(83),
  },
  [1918] = {
    [sym_raw_string_literal] = ACTIONS(249),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(251),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(251),
    [anon_sym_LPAREN] = ACTIONS(249),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(251),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(251),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(251),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(251),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(251),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(251),
    [sym_preproc_directive] = ACTIONS(251),
    [anon_sym_SEMI] = ACTIONS(249),
    [anon_sym_typedef] = ACTIONS(251),
    [anon_sym_extern] = ACTIONS(251),
    [anon_sym_LBRACE] = ACTIONS(249),
    [anon_sym_STAR] = ACTIONS(249),
    [anon_sym_LBRACK] = ACTIONS(249),
    [anon_sym_static] = ACTIONS(251),
    [anon_sym_register] = ACTIONS(251),
    [anon_sym_inline] = ACTIONS(251),
    [anon_sym_const] = ACTIONS(251),
    [anon_sym_restrict] = ACTIONS(251),
    [anon_sym_volatile] = ACTIONS(251),
    [anon_sym__Atomic] = ACTIONS(251),
    [anon_sym_mutable] = ACTIONS(251),
    [anon_sym_explicit] = ACTIONS(251),
    [anon_sym_constexpr] = ACTIONS(251),
    [anon_sym_unsigned] = ACTIONS(251),
    [anon_sym_long] = ACTIONS(251),
    [anon_sym_short] = ACTIONS(251),
    [sym_primitive_type] = ACTIONS(251),
    [anon_sym_enum] = ACTIONS(251),
    [anon_sym_struct] = ACTIONS(251),
    [anon_sym_union] = ACTIONS(251),
    [anon_sym_if] = ACTIONS(251),
    [anon_sym_switch] = ACTIONS(251),
    [anon_sym_case] = ACTIONS(251),
    [anon_sym_default] = ACTIONS(251),
    [anon_sym_while] = ACTIONS(251),
    [anon_sym_do] = ACTIONS(251),
    [anon_sym_for] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(251),
    [anon_sym_break] = ACTIONS(251),
    [anon_sym_continue] = ACTIONS(251),
    [anon_sym_goto] = ACTIONS(251),
    [anon_sym_AMP] = ACTIONS(249),
    [anon_sym_BANG] = ACTIONS(249),
    [anon_sym_TILDE] = ACTIONS(249),
    [anon_sym_PLUS] = ACTIONS(251),
    [anon_sym_DASH] = ACTIONS(251),
    [anon_sym_DASH_DASH] = ACTIONS(249),
    [anon_sym_PLUS_PLUS] = ACTIONS(249),
    [anon_sym_sizeof] = ACTIONS(251),
    [sym_number_literal] = ACTIONS(249),
    [sym_char_literal] = ACTIONS(249),
    [sym_string_literal] = ACTIONS(249),
    [sym_true] = ACTIONS(251),
    [sym_false] = ACTIONS(251),
    [sym_null] = ACTIONS(251),
    [sym_identifier] = ACTIONS(251),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(251),
    [sym_auto] = ACTIONS(251),
    [anon_sym_typename] = ACTIONS(251),
    [anon_sym_new] = ACTIONS(251),
    [anon_sym_COLON_COLON] = ACTIONS(249),
    [anon_sym_delete] = ACTIONS(251),
    [sym_nullptr] = ACTIONS(251),
  },
  [1919] = {
    [sym_preproc_params] = STATE(2275),
    [aux_sym_SLASH_LBRACK_BSLASHt_RBRACK_PLUS_SLASH] = ACTIONS(5293),
    [anon_sym_LF] = ACTIONS(5295),
    [anon_sym_LPAREN] = ACTIONS(257),
    [sym_comment] = ACTIONS(83),
  },
  [1920] = {
    [sym_preproc_include] = STATE(2279),
    [sym_preproc_def] = STATE(2279),
    [sym_preproc_function_def] = STATE(2279),
    [sym_preproc_call] = STATE(2279),
    [sym_preproc_if_in_compound_statement] = STATE(1414),
    [sym_preproc_ifdef_in_compound_statement] = STATE(1415),
    [sym_preproc_else_in_compound_statement] = STATE(2277),
    [sym_preproc_elif_in_compound_statement] = STATE(2278),
    [sym_declaration] = STATE(2279),
    [sym_type_definition] = STATE(2279),
    [sym__declaration_specifiers] = STATE(1418),
    [sym_compound_statement] = STATE(2279),
    [sym_storage_class_specifier] = STATE(419),
    [sym_type_qualifier] = STATE(419),
    [sym__type_specifier] = STATE(30),
    [sym_sized_type_specifier] = STATE(30),
    [sym_enum_specifier] = STATE(30),
    [sym_struct_specifier] = STATE(30),
    [sym_union_specifier] = STATE(30),
    [sym_labeled_statement] = STATE(2279),
    [sym_expression_statement] = STATE(2279),
    [sym_if_statement] = STATE(2279),
    [sym_switch_statement] = STATE(2279),
    [sym_case_statement] = STATE(2279),
    [sym_while_statement] = STATE(2279),
    [sym_do_statement] = STATE(2279),
    [sym_for_statement] = STATE(2279),
    [sym_return_statement] = STATE(2279),
    [sym_break_statement] = STATE(2279),
    [sym_continue_statement] = STATE(2279),
    [sym_goto_statement] = STATE(2279),
    [sym__expression] = STATE(1419),
    [sym_comma_expression] = STATE(1420),
    [sym_conditional_expression] = STATE(1419),
    [sym_assignment_expression] = STATE(1419),
    [sym_pointer_expression] = STATE(1419),
    [sym_logical_expression] = STATE(1419),
    [sym_bitwise_expression] = STATE(1419),
    [sym_equality_expression] = STATE(1419),
    [sym_relational_expression] = STATE(1419),
    [sym_shift_expression] = STATE(1419),
    [sym_math_expression] = STATE(1419),
    [sym_cast_expression] = STATE(1419),
    [sym_sizeof_expression] = STATE(1419),
    [sym_subscript_expression] = STATE(1419),
    [sym_call_expression] = STATE(1419),
    [sym_field_expression] = STATE(1419),
    [sym_compound_literal_expression] = STATE(1419),
    [sym_parenthesized_expression] = STATE(1419),
    [sym_concatenated_string] = STATE(1419),
    [sym__empty_declaration] = STATE(2279),
    [sym_macro_type_specifier] = STATE(30),
    [sym_class_specifier] = STATE(30),
    [sym_dependent_type] = STATE(30),
    [sym_structured_binding_declaration] = STATE(2279),
    [sym_template_type] = STATE(415),
    [sym_template_function] = STATE(1419),
    [sym_for_range_loop] = STATE(2279),
    [sym_new_expression] = STATE(1419),
    [sym_delete_expression] = STATE(1419),
    [sym_lambda_expression] = STATE(1419),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(416),
    [sym_scoped_namespace_identifier] = STATE(417),
    [aux_sym_preproc_if_in_compound_statement_repeat1] = STATE(2279),
    [aux_sym__declaration_specifiers_repeat1] = STATE(419),
    [aux_sym_sized_type_specifier_repeat1] = STATE(38),
    [sym_raw_string_literal] = ACTIONS(2879),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(2881),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(2883),
    [anon_sym_LPAREN] = ACTIONS(626),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(2885),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(5297),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(2889),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(2891),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(2893),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(2895),
    [sym_preproc_directive] = ACTIONS(2897),
    [anon_sym_SEMI] = ACTIONS(2899),
    [anon_sym_typedef] = ACTIONS(2901),
    [anon_sym_extern] = ACTIONS(154),
    [anon_sym_LBRACE] = ACTIONS(2903),
    [anon_sym_STAR] = ACTIONS(644),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_static] = ACTIONS(154),
    [anon_sym_register] = ACTIONS(154),
    [anon_sym_inline] = ACTIONS(154),
    [anon_sym_const] = ACTIONS(158),
    [anon_sym_restrict] = ACTIONS(158),
    [anon_sym_volatile] = ACTIONS(158),
    [anon_sym__Atomic] = ACTIONS(158),
    [anon_sym_mutable] = ACTIONS(158),
    [anon_sym_explicit] = ACTIONS(158),
    [anon_sym_constexpr] = ACTIONS(158),
    [anon_sym_unsigned] = ACTIONS(31),
    [anon_sym_long] = ACTIONS(31),
    [anon_sym_short] = ACTIONS(31),
    [sym_primitive_type] = ACTIONS(33),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_union] = ACTIONS(39),
    [anon_sym_if] = ACTIONS(2905),
    [anon_sym_switch] = ACTIONS(2907),
    [anon_sym_case] = ACTIONS(2909),
    [anon_sym_default] = ACTIONS(2911),
    [anon_sym_while] = ACTIONS(2913),
    [anon_sym_do] = ACTIONS(2915),
    [anon_sym_for] = ACTIONS(2917),
    [anon_sym_return] = ACTIONS(2919),
    [anon_sym_break] = ACTIONS(2921),
    [anon_sym_continue] = ACTIONS(2923),
    [anon_sym_goto] = ACTIONS(2925),
    [anon_sym_AMP] = ACTIONS(644),
    [anon_sym_BANG] = ACTIONS(668),
    [anon_sym_TILDE] = ACTIONS(670),
    [anon_sym_PLUS] = ACTIONS(672),
    [anon_sym_DASH] = ACTIONS(672),
    [anon_sym_DASH_DASH] = ACTIONS(674),
    [anon_sym_PLUS_PLUS] = ACTIONS(674),
    [anon_sym_sizeof] = ACTIONS(676),
    [sym_number_literal] = ACTIONS(2879),
    [sym_char_literal] = ACTIONS(2879),
    [sym_string_literal] = ACTIONS(678),
    [sym_true] = ACTIONS(2927),
    [sym_false] = ACTIONS(2927),
    [sym_null] = ACTIONS(2927),
    [sym_identifier] = ACTIONS(2929),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(51),
    [sym_auto] = ACTIONS(33),
    [anon_sym_typename] = ACTIONS(53),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(684),
    [anon_sym_delete] = ACTIONS(686),
    [sym_nullptr] = ACTIONS(2927),
  },
  [1921] = {
    [sym_preproc_include] = STATE(2283),
    [sym_preproc_def] = STATE(2283),
    [sym_preproc_function_def] = STATE(2283),
    [sym_preproc_call] = STATE(2283),
    [sym_preproc_if_in_compound_statement] = STATE(1414),
    [sym_preproc_ifdef_in_compound_statement] = STATE(1415),
    [sym_preproc_else_in_compound_statement] = STATE(2281),
    [sym_preproc_elif_in_compound_statement] = STATE(2282),
    [sym_declaration] = STATE(2283),
    [sym_type_definition] = STATE(2283),
    [sym__declaration_specifiers] = STATE(1418),
    [sym_compound_statement] = STATE(2283),
    [sym_storage_class_specifier] = STATE(419),
    [sym_type_qualifier] = STATE(419),
    [sym__type_specifier] = STATE(30),
    [sym_sized_type_specifier] = STATE(30),
    [sym_enum_specifier] = STATE(30),
    [sym_struct_specifier] = STATE(30),
    [sym_union_specifier] = STATE(30),
    [sym_labeled_statement] = STATE(2283),
    [sym_expression_statement] = STATE(2283),
    [sym_if_statement] = STATE(2283),
    [sym_switch_statement] = STATE(2283),
    [sym_case_statement] = STATE(2283),
    [sym_while_statement] = STATE(2283),
    [sym_do_statement] = STATE(2283),
    [sym_for_statement] = STATE(2283),
    [sym_return_statement] = STATE(2283),
    [sym_break_statement] = STATE(2283),
    [sym_continue_statement] = STATE(2283),
    [sym_goto_statement] = STATE(2283),
    [sym__expression] = STATE(1419),
    [sym_comma_expression] = STATE(1420),
    [sym_conditional_expression] = STATE(1419),
    [sym_assignment_expression] = STATE(1419),
    [sym_pointer_expression] = STATE(1419),
    [sym_logical_expression] = STATE(1419),
    [sym_bitwise_expression] = STATE(1419),
    [sym_equality_expression] = STATE(1419),
    [sym_relational_expression] = STATE(1419),
    [sym_shift_expression] = STATE(1419),
    [sym_math_expression] = STATE(1419),
    [sym_cast_expression] = STATE(1419),
    [sym_sizeof_expression] = STATE(1419),
    [sym_subscript_expression] = STATE(1419),
    [sym_call_expression] = STATE(1419),
    [sym_field_expression] = STATE(1419),
    [sym_compound_literal_expression] = STATE(1419),
    [sym_parenthesized_expression] = STATE(1419),
    [sym_concatenated_string] = STATE(1419),
    [sym__empty_declaration] = STATE(2283),
    [sym_macro_type_specifier] = STATE(30),
    [sym_class_specifier] = STATE(30),
    [sym_dependent_type] = STATE(30),
    [sym_structured_binding_declaration] = STATE(2283),
    [sym_template_type] = STATE(415),
    [sym_template_function] = STATE(1419),
    [sym_for_range_loop] = STATE(2283),
    [sym_new_expression] = STATE(1419),
    [sym_delete_expression] = STATE(1419),
    [sym_lambda_expression] = STATE(1419),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(416),
    [sym_scoped_namespace_identifier] = STATE(417),
    [aux_sym_preproc_if_in_compound_statement_repeat1] = STATE(2283),
    [aux_sym__declaration_specifiers_repeat1] = STATE(419),
    [aux_sym_sized_type_specifier_repeat1] = STATE(38),
    [sym_raw_string_literal] = ACTIONS(2879),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(2881),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(2883),
    [anon_sym_LPAREN] = ACTIONS(626),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(2885),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(5299),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(2889),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(2891),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(2893),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(2895),
    [sym_preproc_directive] = ACTIONS(2897),
    [anon_sym_SEMI] = ACTIONS(2899),
    [anon_sym_typedef] = ACTIONS(2901),
    [anon_sym_extern] = ACTIONS(154),
    [anon_sym_LBRACE] = ACTIONS(2903),
    [anon_sym_STAR] = ACTIONS(644),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_static] = ACTIONS(154),
    [anon_sym_register] = ACTIONS(154),
    [anon_sym_inline] = ACTIONS(154),
    [anon_sym_const] = ACTIONS(158),
    [anon_sym_restrict] = ACTIONS(158),
    [anon_sym_volatile] = ACTIONS(158),
    [anon_sym__Atomic] = ACTIONS(158),
    [anon_sym_mutable] = ACTIONS(158),
    [anon_sym_explicit] = ACTIONS(158),
    [anon_sym_constexpr] = ACTIONS(158),
    [anon_sym_unsigned] = ACTIONS(31),
    [anon_sym_long] = ACTIONS(31),
    [anon_sym_short] = ACTIONS(31),
    [sym_primitive_type] = ACTIONS(33),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_union] = ACTIONS(39),
    [anon_sym_if] = ACTIONS(2905),
    [anon_sym_switch] = ACTIONS(2907),
    [anon_sym_case] = ACTIONS(2909),
    [anon_sym_default] = ACTIONS(2911),
    [anon_sym_while] = ACTIONS(2913),
    [anon_sym_do] = ACTIONS(2915),
    [anon_sym_for] = ACTIONS(2917),
    [anon_sym_return] = ACTIONS(2919),
    [anon_sym_break] = ACTIONS(2921),
    [anon_sym_continue] = ACTIONS(2923),
    [anon_sym_goto] = ACTIONS(2925),
    [anon_sym_AMP] = ACTIONS(644),
    [anon_sym_BANG] = ACTIONS(668),
    [anon_sym_TILDE] = ACTIONS(670),
    [anon_sym_PLUS] = ACTIONS(672),
    [anon_sym_DASH] = ACTIONS(672),
    [anon_sym_DASH_DASH] = ACTIONS(674),
    [anon_sym_PLUS_PLUS] = ACTIONS(674),
    [anon_sym_sizeof] = ACTIONS(676),
    [sym_number_literal] = ACTIONS(2879),
    [sym_char_literal] = ACTIONS(2879),
    [sym_string_literal] = ACTIONS(678),
    [sym_true] = ACTIONS(2927),
    [sym_false] = ACTIONS(2927),
    [sym_null] = ACTIONS(2927),
    [sym_identifier] = ACTIONS(2929),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(51),
    [sym_auto] = ACTIONS(33),
    [anon_sym_typename] = ACTIONS(53),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(684),
    [anon_sym_delete] = ACTIONS(686),
    [sym_nullptr] = ACTIONS(2927),
  },
  [1922] = {
    [sym_preproc_include] = STATE(2287),
    [sym_preproc_def] = STATE(2287),
    [sym_preproc_function_def] = STATE(2287),
    [sym_preproc_call] = STATE(2287),
    [sym_preproc_if_in_compound_statement] = STATE(1414),
    [sym_preproc_ifdef_in_compound_statement] = STATE(1415),
    [sym_preproc_else_in_compound_statement] = STATE(2285),
    [sym_preproc_elif_in_compound_statement] = STATE(2286),
    [sym_declaration] = STATE(2287),
    [sym_type_definition] = STATE(2287),
    [sym__declaration_specifiers] = STATE(1418),
    [sym_compound_statement] = STATE(2287),
    [sym_storage_class_specifier] = STATE(419),
    [sym_type_qualifier] = STATE(419),
    [sym__type_specifier] = STATE(30),
    [sym_sized_type_specifier] = STATE(30),
    [sym_enum_specifier] = STATE(30),
    [sym_struct_specifier] = STATE(30),
    [sym_union_specifier] = STATE(30),
    [sym_labeled_statement] = STATE(2287),
    [sym_expression_statement] = STATE(2287),
    [sym_if_statement] = STATE(2287),
    [sym_switch_statement] = STATE(2287),
    [sym_case_statement] = STATE(2287),
    [sym_while_statement] = STATE(2287),
    [sym_do_statement] = STATE(2287),
    [sym_for_statement] = STATE(2287),
    [sym_return_statement] = STATE(2287),
    [sym_break_statement] = STATE(2287),
    [sym_continue_statement] = STATE(2287),
    [sym_goto_statement] = STATE(2287),
    [sym__expression] = STATE(1419),
    [sym_comma_expression] = STATE(1420),
    [sym_conditional_expression] = STATE(1419),
    [sym_assignment_expression] = STATE(1419),
    [sym_pointer_expression] = STATE(1419),
    [sym_logical_expression] = STATE(1419),
    [sym_bitwise_expression] = STATE(1419),
    [sym_equality_expression] = STATE(1419),
    [sym_relational_expression] = STATE(1419),
    [sym_shift_expression] = STATE(1419),
    [sym_math_expression] = STATE(1419),
    [sym_cast_expression] = STATE(1419),
    [sym_sizeof_expression] = STATE(1419),
    [sym_subscript_expression] = STATE(1419),
    [sym_call_expression] = STATE(1419),
    [sym_field_expression] = STATE(1419),
    [sym_compound_literal_expression] = STATE(1419),
    [sym_parenthesized_expression] = STATE(1419),
    [sym_concatenated_string] = STATE(1419),
    [sym__empty_declaration] = STATE(2287),
    [sym_macro_type_specifier] = STATE(30),
    [sym_class_specifier] = STATE(30),
    [sym_dependent_type] = STATE(30),
    [sym_structured_binding_declaration] = STATE(2287),
    [sym_template_type] = STATE(415),
    [sym_template_function] = STATE(1419),
    [sym_for_range_loop] = STATE(2287),
    [sym_new_expression] = STATE(1419),
    [sym_delete_expression] = STATE(1419),
    [sym_lambda_expression] = STATE(1419),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(416),
    [sym_scoped_namespace_identifier] = STATE(417),
    [aux_sym_preproc_if_in_compound_statement_repeat1] = STATE(2287),
    [aux_sym__declaration_specifiers_repeat1] = STATE(419),
    [aux_sym_sized_type_specifier_repeat1] = STATE(38),
    [sym_raw_string_literal] = ACTIONS(2879),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(2881),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(2883),
    [anon_sym_LPAREN] = ACTIONS(626),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(2885),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(5301),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(2889),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(2891),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(2893),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(2895),
    [sym_preproc_directive] = ACTIONS(2897),
    [anon_sym_SEMI] = ACTIONS(2899),
    [anon_sym_typedef] = ACTIONS(2901),
    [anon_sym_extern] = ACTIONS(154),
    [anon_sym_LBRACE] = ACTIONS(2903),
    [anon_sym_STAR] = ACTIONS(644),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_static] = ACTIONS(154),
    [anon_sym_register] = ACTIONS(154),
    [anon_sym_inline] = ACTIONS(154),
    [anon_sym_const] = ACTIONS(158),
    [anon_sym_restrict] = ACTIONS(158),
    [anon_sym_volatile] = ACTIONS(158),
    [anon_sym__Atomic] = ACTIONS(158),
    [anon_sym_mutable] = ACTIONS(158),
    [anon_sym_explicit] = ACTIONS(158),
    [anon_sym_constexpr] = ACTIONS(158),
    [anon_sym_unsigned] = ACTIONS(31),
    [anon_sym_long] = ACTIONS(31),
    [anon_sym_short] = ACTIONS(31),
    [sym_primitive_type] = ACTIONS(33),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_union] = ACTIONS(39),
    [anon_sym_if] = ACTIONS(2905),
    [anon_sym_switch] = ACTIONS(2907),
    [anon_sym_case] = ACTIONS(2909),
    [anon_sym_default] = ACTIONS(2911),
    [anon_sym_while] = ACTIONS(2913),
    [anon_sym_do] = ACTIONS(2915),
    [anon_sym_for] = ACTIONS(2917),
    [anon_sym_return] = ACTIONS(2919),
    [anon_sym_break] = ACTIONS(2921),
    [anon_sym_continue] = ACTIONS(2923),
    [anon_sym_goto] = ACTIONS(2925),
    [anon_sym_AMP] = ACTIONS(644),
    [anon_sym_BANG] = ACTIONS(668),
    [anon_sym_TILDE] = ACTIONS(670),
    [anon_sym_PLUS] = ACTIONS(672),
    [anon_sym_DASH] = ACTIONS(672),
    [anon_sym_DASH_DASH] = ACTIONS(674),
    [anon_sym_PLUS_PLUS] = ACTIONS(674),
    [anon_sym_sizeof] = ACTIONS(676),
    [sym_number_literal] = ACTIONS(2879),
    [sym_char_literal] = ACTIONS(2879),
    [sym_string_literal] = ACTIONS(678),
    [sym_true] = ACTIONS(2927),
    [sym_false] = ACTIONS(2927),
    [sym_null] = ACTIONS(2927),
    [sym_identifier] = ACTIONS(2929),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(51),
    [sym_auto] = ACTIONS(33),
    [anon_sym_typename] = ACTIONS(53),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(684),
    [anon_sym_delete] = ACTIONS(686),
    [sym_nullptr] = ACTIONS(2927),
  },
  [1923] = {
    [sym_string_literal] = ACTIONS(5303),
    [sym_system_lib_string] = ACTIONS(5303),
    [sym_comment] = ACTIONS(49),
  },
  [1924] = {
    [sym_identifier] = ACTIONS(5305),
    [sym_comment] = ACTIONS(49),
  },
  [1925] = {
    [sym_preproc_arg] = ACTIONS(5307),
    [sym_comment] = ACTIONS(83),
  },
  [1926] = {
    [sym_identifier] = ACTIONS(5309),
    [sym_comment] = ACTIONS(49),
  },
  [1927] = {
    [sym_identifier] = ACTIONS(5311),
    [sym_comment] = ACTIONS(49),
  },
  [1928] = {
    [aux_sym_SLASH_LBRACK_BSLASHt_RBRACK_PLUS_SLASH] = ACTIONS(5313),
    [anon_sym_LF] = ACTIONS(5315),
    [sym_comment] = ACTIONS(83),
  },
  [1929] = {
    [sym_raw_string_literal] = ACTIONS(1614),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1616),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1616),
    [anon_sym_LPAREN] = ACTIONS(1614),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1616),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(1616),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1616),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1616),
    [sym_preproc_directive] = ACTIONS(1616),
    [anon_sym_SEMI] = ACTIONS(1614),
    [anon_sym_typedef] = ACTIONS(1616),
    [anon_sym_extern] = ACTIONS(1616),
    [anon_sym_LBRACE] = ACTIONS(1614),
    [anon_sym_STAR] = ACTIONS(1614),
    [anon_sym_LBRACK] = ACTIONS(1614),
    [anon_sym_static] = ACTIONS(1616),
    [anon_sym_register] = ACTIONS(1616),
    [anon_sym_inline] = ACTIONS(1616),
    [anon_sym_const] = ACTIONS(1616),
    [anon_sym_restrict] = ACTIONS(1616),
    [anon_sym_volatile] = ACTIONS(1616),
    [anon_sym__Atomic] = ACTIONS(1616),
    [anon_sym_mutable] = ACTIONS(1616),
    [anon_sym_explicit] = ACTIONS(1616),
    [anon_sym_constexpr] = ACTIONS(1616),
    [anon_sym_unsigned] = ACTIONS(1616),
    [anon_sym_long] = ACTIONS(1616),
    [anon_sym_short] = ACTIONS(1616),
    [sym_primitive_type] = ACTIONS(1616),
    [anon_sym_enum] = ACTIONS(1616),
    [anon_sym_struct] = ACTIONS(1616),
    [anon_sym_union] = ACTIONS(1616),
    [anon_sym_if] = ACTIONS(1616),
    [anon_sym_switch] = ACTIONS(1616),
    [anon_sym_case] = ACTIONS(1616),
    [anon_sym_default] = ACTIONS(1616),
    [anon_sym_while] = ACTIONS(1616),
    [anon_sym_do] = ACTIONS(1616),
    [anon_sym_for] = ACTIONS(1616),
    [anon_sym_return] = ACTIONS(1616),
    [anon_sym_break] = ACTIONS(1616),
    [anon_sym_continue] = ACTIONS(1616),
    [anon_sym_goto] = ACTIONS(1616),
    [anon_sym_AMP] = ACTIONS(1614),
    [anon_sym_BANG] = ACTIONS(1614),
    [anon_sym_TILDE] = ACTIONS(1614),
    [anon_sym_PLUS] = ACTIONS(1616),
    [anon_sym_DASH] = ACTIONS(1616),
    [anon_sym_DASH_DASH] = ACTIONS(1614),
    [anon_sym_PLUS_PLUS] = ACTIONS(1614),
    [anon_sym_sizeof] = ACTIONS(1616),
    [sym_number_literal] = ACTIONS(1614),
    [sym_char_literal] = ACTIONS(1614),
    [sym_string_literal] = ACTIONS(1614),
    [sym_true] = ACTIONS(1616),
    [sym_false] = ACTIONS(1616),
    [sym_null] = ACTIONS(1616),
    [sym_identifier] = ACTIONS(1616),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(1616),
    [sym_auto] = ACTIONS(1616),
    [anon_sym_typename] = ACTIONS(1616),
    [anon_sym_new] = ACTIONS(1616),
    [anon_sym_COLON_COLON] = ACTIONS(1614),
    [anon_sym_delete] = ACTIONS(1616),
    [sym_nullptr] = ACTIONS(1616),
  },
  [1930] = {
    [sym_type_qualifier] = STATE(2296),
    [sym__type_specifier] = STATE(2295),
    [sym_sized_type_specifier] = STATE(2295),
    [sym_enum_specifier] = STATE(2295),
    [sym_struct_specifier] = STATE(2295),
    [sym_union_specifier] = STATE(2295),
    [sym_macro_type_specifier] = STATE(2295),
    [sym_class_specifier] = STATE(2295),
    [sym_dependent_type] = STATE(2295),
    [sym_template_type] = STATE(62),
    [sym_scoped_type_identifier] = STATE(63),
    [sym_scoped_namespace_identifier] = STATE(64),
    [aux_sym_type_definition_repeat1] = STATE(2296),
    [aux_sym_sized_type_specifier_repeat1] = STATE(66),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_restrict] = ACTIONS(93),
    [anon_sym_volatile] = ACTIONS(93),
    [anon_sym__Atomic] = ACTIONS(93),
    [anon_sym_mutable] = ACTIONS(93),
    [anon_sym_explicit] = ACTIONS(93),
    [anon_sym_constexpr] = ACTIONS(93),
    [anon_sym_unsigned] = ACTIONS(95),
    [anon_sym_long] = ACTIONS(95),
    [anon_sym_short] = ACTIONS(95),
    [sym_primitive_type] = ACTIONS(5317),
    [anon_sym_enum] = ACTIONS(99),
    [anon_sym_struct] = ACTIONS(101),
    [anon_sym_union] = ACTIONS(103),
    [sym_identifier] = ACTIONS(105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(107),
    [sym_auto] = ACTIONS(5317),
    [anon_sym_typename] = ACTIONS(109),
    [anon_sym_COLON_COLON] = ACTIONS(111),
  },
  [1931] = {
    [sym_preproc_include] = STATE(2298),
    [sym_preproc_def] = STATE(2298),
    [sym_preproc_function_def] = STATE(2298),
    [sym_preproc_call] = STATE(2298),
    [sym_preproc_if_in_compound_statement] = STATE(410),
    [sym_preproc_ifdef_in_compound_statement] = STATE(411),
    [sym_declaration] = STATE(2298),
    [sym_type_definition] = STATE(2298),
    [sym__declaration_specifiers] = STATE(412),
    [sym_compound_statement] = STATE(2298),
    [sym_storage_class_specifier] = STATE(419),
    [sym_type_qualifier] = STATE(419),
    [sym__type_specifier] = STATE(30),
    [sym_sized_type_specifier] = STATE(30),
    [sym_enum_specifier] = STATE(30),
    [sym_struct_specifier] = STATE(30),
    [sym_union_specifier] = STATE(30),
    [sym_labeled_statement] = STATE(2298),
    [sym_expression_statement] = STATE(2298),
    [sym_if_statement] = STATE(2298),
    [sym_switch_statement] = STATE(2298),
    [sym_case_statement] = STATE(2298),
    [sym_while_statement] = STATE(2298),
    [sym_do_statement] = STATE(2298),
    [sym_for_statement] = STATE(2298),
    [sym_return_statement] = STATE(2298),
    [sym_break_statement] = STATE(2298),
    [sym_continue_statement] = STATE(2298),
    [sym_goto_statement] = STATE(2298),
    [sym__expression] = STATE(413),
    [sym_comma_expression] = STATE(414),
    [sym_conditional_expression] = STATE(413),
    [sym_assignment_expression] = STATE(413),
    [sym_pointer_expression] = STATE(413),
    [sym_logical_expression] = STATE(413),
    [sym_bitwise_expression] = STATE(413),
    [sym_equality_expression] = STATE(413),
    [sym_relational_expression] = STATE(413),
    [sym_shift_expression] = STATE(413),
    [sym_math_expression] = STATE(413),
    [sym_cast_expression] = STATE(413),
    [sym_sizeof_expression] = STATE(413),
    [sym_subscript_expression] = STATE(413),
    [sym_call_expression] = STATE(413),
    [sym_field_expression] = STATE(413),
    [sym_compound_literal_expression] = STATE(413),
    [sym_parenthesized_expression] = STATE(413),
    [sym_concatenated_string] = STATE(413),
    [sym__empty_declaration] = STATE(2298),
    [sym_macro_type_specifier] = STATE(30),
    [sym_class_specifier] = STATE(30),
    [sym_dependent_type] = STATE(30),
    [sym_structured_binding_declaration] = STATE(2298),
    [sym_template_type] = STATE(415),
    [sym_template_function] = STATE(413),
    [sym_for_range_loop] = STATE(2298),
    [sym_new_expression] = STATE(413),
    [sym_delete_expression] = STATE(413),
    [sym_lambda_expression] = STATE(413),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(416),
    [sym_scoped_namespace_identifier] = STATE(417),
    [aux_sym_preproc_if_in_compound_statement_repeat1] = STATE(2298),
    [aux_sym__declaration_specifiers_repeat1] = STATE(419),
    [aux_sym_sized_type_specifier_repeat1] = STATE(38),
    [sym_raw_string_literal] = ACTIONS(620),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(622),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(624),
    [anon_sym_LPAREN] = ACTIONS(626),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(628),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(630),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(632),
    [sym_preproc_directive] = ACTIONS(634),
    [anon_sym_SEMI] = ACTIONS(636),
    [anon_sym_typedef] = ACTIONS(638),
    [anon_sym_extern] = ACTIONS(154),
    [anon_sym_LBRACE] = ACTIONS(640),
    [anon_sym_RBRACE] = ACTIONS(5319),
    [anon_sym_STAR] = ACTIONS(644),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_static] = ACTIONS(154),
    [anon_sym_register] = ACTIONS(154),
    [anon_sym_inline] = ACTIONS(154),
    [anon_sym_const] = ACTIONS(158),
    [anon_sym_restrict] = ACTIONS(158),
    [anon_sym_volatile] = ACTIONS(158),
    [anon_sym__Atomic] = ACTIONS(158),
    [anon_sym_mutable] = ACTIONS(158),
    [anon_sym_explicit] = ACTIONS(158),
    [anon_sym_constexpr] = ACTIONS(158),
    [anon_sym_unsigned] = ACTIONS(31),
    [anon_sym_long] = ACTIONS(31),
    [anon_sym_short] = ACTIONS(31),
    [sym_primitive_type] = ACTIONS(33),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_union] = ACTIONS(39),
    [anon_sym_if] = ACTIONS(646),
    [anon_sym_switch] = ACTIONS(648),
    [anon_sym_case] = ACTIONS(650),
    [anon_sym_default] = ACTIONS(652),
    [anon_sym_while] = ACTIONS(654),
    [anon_sym_do] = ACTIONS(656),
    [anon_sym_for] = ACTIONS(658),
    [anon_sym_return] = ACTIONS(660),
    [anon_sym_break] = ACTIONS(662),
    [anon_sym_continue] = ACTIONS(664),
    [anon_sym_goto] = ACTIONS(666),
    [anon_sym_AMP] = ACTIONS(644),
    [anon_sym_BANG] = ACTIONS(668),
    [anon_sym_TILDE] = ACTIONS(670),
    [anon_sym_PLUS] = ACTIONS(672),
    [anon_sym_DASH] = ACTIONS(672),
    [anon_sym_DASH_DASH] = ACTIONS(674),
    [anon_sym_PLUS_PLUS] = ACTIONS(674),
    [anon_sym_sizeof] = ACTIONS(676),
    [sym_number_literal] = ACTIONS(620),
    [sym_char_literal] = ACTIONS(620),
    [sym_string_literal] = ACTIONS(678),
    [sym_true] = ACTIONS(680),
    [sym_false] = ACTIONS(680),
    [sym_null] = ACTIONS(680),
    [sym_identifier] = ACTIONS(682),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(51),
    [sym_auto] = ACTIONS(33),
    [anon_sym_typename] = ACTIONS(53),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(684),
    [anon_sym_delete] = ACTIONS(686),
    [sym_nullptr] = ACTIONS(680),
  },
  [1932] = {
    [anon_sym_LPAREN] = ACTIONS(5321),
    [anon_sym_constexpr] = ACTIONS(5323),
    [sym_comment] = ACTIONS(49),
  },
  [1933] = {
    [anon_sym_LPAREN] = ACTIONS(5325),
    [sym_comment] = ACTIONS(49),
  },
  [1934] = {
    [sym__expression] = STATE(2302),
    [sym_conditional_expression] = STATE(2302),
    [sym_assignment_expression] = STATE(2302),
    [sym_pointer_expression] = STATE(2302),
    [sym_logical_expression] = STATE(2302),
    [sym_bitwise_expression] = STATE(2302),
    [sym_equality_expression] = STATE(2302),
    [sym_relational_expression] = STATE(2302),
    [sym_shift_expression] = STATE(2302),
    [sym_math_expression] = STATE(2302),
    [sym_cast_expression] = STATE(2302),
    [sym_sizeof_expression] = STATE(2302),
    [sym_subscript_expression] = STATE(2302),
    [sym_call_expression] = STATE(2302),
    [sym_field_expression] = STATE(2302),
    [sym_compound_literal_expression] = STATE(2302),
    [sym_parenthesized_expression] = STATE(2302),
    [sym_concatenated_string] = STATE(2302),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(2302),
    [sym_new_expression] = STATE(2302),
    [sym_delete_expression] = STATE(2302),
    [sym_lambda_expression] = STATE(2302),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(855),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(5327),
    [anon_sym_LPAREN] = ACTIONS(1634),
    [anon_sym_STAR] = ACTIONS(1636),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_AMP] = ACTIONS(1636),
    [anon_sym_BANG] = ACTIONS(1638),
    [anon_sym_TILDE] = ACTIONS(1640),
    [anon_sym_PLUS] = ACTIONS(1642),
    [anon_sym_DASH] = ACTIONS(1642),
    [anon_sym_DASH_DASH] = ACTIONS(1644),
    [anon_sym_PLUS_PLUS] = ACTIONS(1644),
    [anon_sym_sizeof] = ACTIONS(1646),
    [sym_number_literal] = ACTIONS(5327),
    [sym_char_literal] = ACTIONS(5327),
    [sym_string_literal] = ACTIONS(1648),
    [sym_true] = ACTIONS(5329),
    [sym_false] = ACTIONS(5329),
    [sym_null] = ACTIONS(5329),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1652),
    [anon_sym_delete] = ACTIONS(1654),
    [sym_nullptr] = ACTIONS(5329),
  },
  [1935] = {
    [anon_sym_COLON] = ACTIONS(5331),
    [sym_comment] = ACTIONS(49),
  },
  [1936] = {
    [anon_sym_LPAREN] = ACTIONS(5333),
    [sym_comment] = ACTIONS(49),
  },
  [1937] = {
    [sym_compound_statement] = STATE(2305),
    [sym_labeled_statement] = STATE(2305),
    [sym_expression_statement] = STATE(2305),
    [sym_if_statement] = STATE(2305),
    [sym_switch_statement] = STATE(2305),
    [sym_case_statement] = STATE(2305),
    [sym_while_statement] = STATE(2305),
    [sym_do_statement] = STATE(2305),
    [sym_for_statement] = STATE(2305),
    [sym_return_statement] = STATE(2305),
    [sym_break_statement] = STATE(2305),
    [sym_continue_statement] = STATE(2305),
    [sym_goto_statement] = STATE(2305),
    [sym__expression] = STATE(873),
    [sym_comma_expression] = STATE(874),
    [sym_conditional_expression] = STATE(873),
    [sym_assignment_expression] = STATE(873),
    [sym_pointer_expression] = STATE(873),
    [sym_logical_expression] = STATE(873),
    [sym_bitwise_expression] = STATE(873),
    [sym_equality_expression] = STATE(873),
    [sym_relational_expression] = STATE(873),
    [sym_shift_expression] = STATE(873),
    [sym_math_expression] = STATE(873),
    [sym_cast_expression] = STATE(873),
    [sym_sizeof_expression] = STATE(873),
    [sym_subscript_expression] = STATE(873),
    [sym_call_expression] = STATE(873),
    [sym_field_expression] = STATE(873),
    [sym_compound_literal_expression] = STATE(873),
    [sym_parenthesized_expression] = STATE(873),
    [sym_concatenated_string] = STATE(873),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(873),
    [sym_for_range_loop] = STATE(2305),
    [sym_new_expression] = STATE(873),
    [sym_delete_expression] = STATE(873),
    [sym_lambda_expression] = STATE(873),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(1660),
    [anon_sym_LPAREN] = ACTIONS(626),
    [anon_sym_SEMI] = ACTIONS(1662),
    [anon_sym_LBRACE] = ACTIONS(1664),
    [anon_sym_STAR] = ACTIONS(644),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_if] = ACTIONS(1666),
    [anon_sym_switch] = ACTIONS(1668),
    [anon_sym_case] = ACTIONS(1670),
    [anon_sym_default] = ACTIONS(1672),
    [anon_sym_while] = ACTIONS(1674),
    [anon_sym_do] = ACTIONS(1676),
    [anon_sym_for] = ACTIONS(1678),
    [anon_sym_return] = ACTIONS(1680),
    [anon_sym_break] = ACTIONS(1682),
    [anon_sym_continue] = ACTIONS(1684),
    [anon_sym_goto] = ACTIONS(1686),
    [anon_sym_AMP] = ACTIONS(644),
    [anon_sym_BANG] = ACTIONS(668),
    [anon_sym_TILDE] = ACTIONS(670),
    [anon_sym_PLUS] = ACTIONS(672),
    [anon_sym_DASH] = ACTIONS(672),
    [anon_sym_DASH_DASH] = ACTIONS(674),
    [anon_sym_PLUS_PLUS] = ACTIONS(674),
    [anon_sym_sizeof] = ACTIONS(676),
    [sym_number_literal] = ACTIONS(1660),
    [sym_char_literal] = ACTIONS(1660),
    [sym_string_literal] = ACTIONS(678),
    [sym_true] = ACTIONS(1688),
    [sym_false] = ACTIONS(1688),
    [sym_null] = ACTIONS(1688),
    [sym_identifier] = ACTIONS(1690),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1303),
    [anon_sym_delete] = ACTIONS(686),
    [sym_nullptr] = ACTIONS(1688),
  },
  [1938] = {
    [anon_sym_LPAREN] = ACTIONS(5335),
    [sym_comment] = ACTIONS(49),
  },
  [1939] = {
    [sym__expression] = STATE(2308),
    [sym_conditional_expression] = STATE(2308),
    [sym_assignment_expression] = STATE(2308),
    [sym_pointer_expression] = STATE(2308),
    [sym_logical_expression] = STATE(2308),
    [sym_bitwise_expression] = STATE(2308),
    [sym_equality_expression] = STATE(2308),
    [sym_relational_expression] = STATE(2308),
    [sym_shift_expression] = STATE(2308),
    [sym_math_expression] = STATE(2308),
    [sym_cast_expression] = STATE(2308),
    [sym_sizeof_expression] = STATE(2308),
    [sym_subscript_expression] = STATE(2308),
    [sym_call_expression] = STATE(2308),
    [sym_field_expression] = STATE(2308),
    [sym_compound_literal_expression] = STATE(2308),
    [sym_parenthesized_expression] = STATE(2308),
    [sym_initializer_list] = STATE(2309),
    [sym_concatenated_string] = STATE(2308),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(2308),
    [sym_new_expression] = STATE(2308),
    [sym_delete_expression] = STATE(2308),
    [sym_lambda_expression] = STATE(2308),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(5337),
    [anon_sym_LPAREN] = ACTIONS(1347),
    [anon_sym_SEMI] = ACTIONS(5339),
    [anon_sym_LBRACE] = ACTIONS(548),
    [anon_sym_STAR] = ACTIONS(1349),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_AMP] = ACTIONS(1349),
    [anon_sym_BANG] = ACTIONS(1351),
    [anon_sym_TILDE] = ACTIONS(1353),
    [anon_sym_PLUS] = ACTIONS(1355),
    [anon_sym_DASH] = ACTIONS(1355),
    [anon_sym_DASH_DASH] = ACTIONS(1357),
    [anon_sym_PLUS_PLUS] = ACTIONS(1357),
    [anon_sym_sizeof] = ACTIONS(1359),
    [sym_number_literal] = ACTIONS(5337),
    [sym_char_literal] = ACTIONS(5337),
    [sym_string_literal] = ACTIONS(1361),
    [sym_true] = ACTIONS(5341),
    [sym_false] = ACTIONS(5341),
    [sym_null] = ACTIONS(5341),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1365),
    [anon_sym_delete] = ACTIONS(1367),
    [sym_nullptr] = ACTIONS(5341),
  },
  [1940] = {
    [anon_sym_SEMI] = ACTIONS(5343),
    [sym_comment] = ACTIONS(49),
  },
  [1941] = {
    [anon_sym_SEMI] = ACTIONS(5345),
    [sym_comment] = ACTIONS(49),
  },
  [1942] = {
    [sym_identifier] = ACTIONS(5347),
    [sym_comment] = ACTIONS(49),
  },
  [1943] = {
    [sym_initializer_list] = STATE(765),
    [sym_template_argument_list] = STATE(887),
    [anon_sym_LPAREN] = ACTIONS(1483),
    [anon_sym_COMMA] = ACTIONS(1477),
    [anon_sym_SEMI] = ACTIONS(1483),
    [anon_sym_extern] = ACTIONS(144),
    [anon_sym_LBRACE] = ACTIONS(548),
    [anon_sym_STAR] = ACTIONS(1486),
    [anon_sym_LBRACK] = ACTIONS(1483),
    [anon_sym_EQ] = ACTIONS(1479),
    [anon_sym_static] = ACTIONS(144),
    [anon_sym_register] = ACTIONS(144),
    [anon_sym_inline] = ACTIONS(144),
    [anon_sym_const] = ACTIONS(144),
    [anon_sym_restrict] = ACTIONS(144),
    [anon_sym_volatile] = ACTIONS(144),
    [anon_sym__Atomic] = ACTIONS(144),
    [anon_sym_mutable] = ACTIONS(144),
    [anon_sym_explicit] = ACTIONS(144),
    [anon_sym_constexpr] = ACTIONS(144),
    [anon_sym_COLON] = ACTIONS(5349),
    [anon_sym_QMARK] = ACTIONS(1477),
    [anon_sym_STAR_EQ] = ACTIONS(1477),
    [anon_sym_SLASH_EQ] = ACTIONS(1477),
    [anon_sym_PERCENT_EQ] = ACTIONS(1477),
    [anon_sym_PLUS_EQ] = ACTIONS(1477),
    [anon_sym_DASH_EQ] = ACTIONS(1477),
    [anon_sym_LT_LT_EQ] = ACTIONS(1477),
    [anon_sym_GT_GT_EQ] = ACTIONS(1477),
    [anon_sym_AMP_EQ] = ACTIONS(1477),
    [anon_sym_CARET_EQ] = ACTIONS(1477),
    [anon_sym_PIPE_EQ] = ACTIONS(1477),
    [anon_sym_AMP] = ACTIONS(1486),
    [anon_sym_PIPE_PIPE] = ACTIONS(1477),
    [anon_sym_AMP_AMP] = ACTIONS(1483),
    [anon_sym_PIPE] = ACTIONS(1479),
    [anon_sym_CARET] = ACTIONS(1479),
    [anon_sym_TILDE] = ACTIONS(142),
    [anon_sym_EQ_EQ] = ACTIONS(1477),
    [anon_sym_BANG_EQ] = ACTIONS(1477),
    [anon_sym_LT] = ACTIONS(1564),
    [anon_sym_GT] = ACTIONS(1479),
    [anon_sym_LT_EQ] = ACTIONS(1477),
    [anon_sym_GT_EQ] = ACTIONS(1477),
    [anon_sym_LT_LT] = ACTIONS(1479),
    [anon_sym_GT_GT] = ACTIONS(1479),
    [anon_sym_PLUS] = ACTIONS(1479),
    [anon_sym_DASH] = ACTIONS(1479),
    [anon_sym_SLASH] = ACTIONS(1479),
    [anon_sym_PERCENT] = ACTIONS(1479),
    [anon_sym_DASH_DASH] = ACTIONS(1477),
    [anon_sym_PLUS_PLUS] = ACTIONS(1477),
    [anon_sym_DOT] = ACTIONS(1477),
    [anon_sym_DASH_GT] = ACTIONS(1477),
    [sym_identifier] = ACTIONS(144),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(1716),
    [sym_operator_name] = ACTIONS(142),
  },
  [1944] = {
    [sym_raw_string_literal] = ACTIONS(1728),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1730),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1730),
    [anon_sym_LPAREN] = ACTIONS(1728),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1730),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(1730),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1730),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1730),
    [sym_preproc_directive] = ACTIONS(1730),
    [anon_sym_SEMI] = ACTIONS(1728),
    [anon_sym_typedef] = ACTIONS(1730),
    [anon_sym_extern] = ACTIONS(1730),
    [anon_sym_LBRACE] = ACTIONS(1728),
    [anon_sym_STAR] = ACTIONS(1728),
    [anon_sym_LBRACK] = ACTIONS(1728),
    [anon_sym_static] = ACTIONS(1730),
    [anon_sym_register] = ACTIONS(1730),
    [anon_sym_inline] = ACTIONS(1730),
    [anon_sym_const] = ACTIONS(1730),
    [anon_sym_restrict] = ACTIONS(1730),
    [anon_sym_volatile] = ACTIONS(1730),
    [anon_sym__Atomic] = ACTIONS(1730),
    [anon_sym_mutable] = ACTIONS(1730),
    [anon_sym_explicit] = ACTIONS(1730),
    [anon_sym_constexpr] = ACTIONS(1730),
    [anon_sym_unsigned] = ACTIONS(1730),
    [anon_sym_long] = ACTIONS(1730),
    [anon_sym_short] = ACTIONS(1730),
    [sym_primitive_type] = ACTIONS(1730),
    [anon_sym_enum] = ACTIONS(1730),
    [anon_sym_struct] = ACTIONS(1730),
    [anon_sym_union] = ACTIONS(1730),
    [anon_sym_if] = ACTIONS(1730),
    [anon_sym_switch] = ACTIONS(1730),
    [anon_sym_case] = ACTIONS(1730),
    [anon_sym_default] = ACTIONS(1730),
    [anon_sym_while] = ACTIONS(1730),
    [anon_sym_do] = ACTIONS(1730),
    [anon_sym_for] = ACTIONS(1730),
    [anon_sym_return] = ACTIONS(1730),
    [anon_sym_break] = ACTIONS(1730),
    [anon_sym_continue] = ACTIONS(1730),
    [anon_sym_goto] = ACTIONS(1730),
    [anon_sym_AMP] = ACTIONS(1728),
    [anon_sym_BANG] = ACTIONS(1728),
    [anon_sym_TILDE] = ACTIONS(1728),
    [anon_sym_PLUS] = ACTIONS(1730),
    [anon_sym_DASH] = ACTIONS(1730),
    [anon_sym_DASH_DASH] = ACTIONS(1728),
    [anon_sym_PLUS_PLUS] = ACTIONS(1728),
    [anon_sym_sizeof] = ACTIONS(1730),
    [sym_number_literal] = ACTIONS(1728),
    [sym_char_literal] = ACTIONS(1728),
    [sym_string_literal] = ACTIONS(1728),
    [sym_true] = ACTIONS(1730),
    [sym_false] = ACTIONS(1730),
    [sym_null] = ACTIONS(1730),
    [sym_identifier] = ACTIONS(1730),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(1730),
    [sym_auto] = ACTIONS(1730),
    [anon_sym_typename] = ACTIONS(1730),
    [anon_sym_new] = ACTIONS(1730),
    [anon_sym_COLON_COLON] = ACTIONS(1728),
    [anon_sym_delete] = ACTIONS(1730),
    [sym_nullptr] = ACTIONS(1730),
  },
  [1945] = {
    [sym_raw_string_literal] = ACTIONS(1732),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1734),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1734),
    [anon_sym_LPAREN] = ACTIONS(1732),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1734),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(1734),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1734),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1734),
    [sym_preproc_directive] = ACTIONS(1734),
    [anon_sym_SEMI] = ACTIONS(1732),
    [anon_sym_typedef] = ACTIONS(1734),
    [anon_sym_extern] = ACTIONS(1734),
    [anon_sym_LBRACE] = ACTIONS(1732),
    [anon_sym_STAR] = ACTIONS(1732),
    [anon_sym_LBRACK] = ACTIONS(1732),
    [anon_sym_static] = ACTIONS(1734),
    [anon_sym_register] = ACTIONS(1734),
    [anon_sym_inline] = ACTIONS(1734),
    [anon_sym_const] = ACTIONS(1734),
    [anon_sym_restrict] = ACTIONS(1734),
    [anon_sym_volatile] = ACTIONS(1734),
    [anon_sym__Atomic] = ACTIONS(1734),
    [anon_sym_mutable] = ACTIONS(1734),
    [anon_sym_explicit] = ACTIONS(1734),
    [anon_sym_constexpr] = ACTIONS(1734),
    [anon_sym_unsigned] = ACTIONS(1734),
    [anon_sym_long] = ACTIONS(1734),
    [anon_sym_short] = ACTIONS(1734),
    [sym_primitive_type] = ACTIONS(1734),
    [anon_sym_enum] = ACTIONS(1734),
    [anon_sym_struct] = ACTIONS(1734),
    [anon_sym_union] = ACTIONS(1734),
    [anon_sym_if] = ACTIONS(1734),
    [anon_sym_switch] = ACTIONS(1734),
    [anon_sym_case] = ACTIONS(1734),
    [anon_sym_default] = ACTIONS(1734),
    [anon_sym_while] = ACTIONS(1734),
    [anon_sym_do] = ACTIONS(1734),
    [anon_sym_for] = ACTIONS(1734),
    [anon_sym_return] = ACTIONS(1734),
    [anon_sym_break] = ACTIONS(1734),
    [anon_sym_continue] = ACTIONS(1734),
    [anon_sym_goto] = ACTIONS(1734),
    [anon_sym_AMP] = ACTIONS(1732),
    [anon_sym_BANG] = ACTIONS(1732),
    [anon_sym_TILDE] = ACTIONS(1732),
    [anon_sym_PLUS] = ACTIONS(1734),
    [anon_sym_DASH] = ACTIONS(1734),
    [anon_sym_DASH_DASH] = ACTIONS(1732),
    [anon_sym_PLUS_PLUS] = ACTIONS(1732),
    [anon_sym_sizeof] = ACTIONS(1734),
    [sym_number_literal] = ACTIONS(1732),
    [sym_char_literal] = ACTIONS(1732),
    [sym_string_literal] = ACTIONS(1732),
    [sym_true] = ACTIONS(1734),
    [sym_false] = ACTIONS(1734),
    [sym_null] = ACTIONS(1734),
    [sym_identifier] = ACTIONS(1734),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(1734),
    [sym_auto] = ACTIONS(1734),
    [anon_sym_typename] = ACTIONS(1734),
    [anon_sym_new] = ACTIONS(1734),
    [anon_sym_COLON_COLON] = ACTIONS(1732),
    [anon_sym_delete] = ACTIONS(1734),
    [sym_nullptr] = ACTIONS(1734),
  },
  [1946] = {
    [sym__declarator] = STATE(2315),
    [sym_pointer_declarator] = STATE(2315),
    [sym_function_declarator] = STATE(2315),
    [sym_array_declarator] = STATE(2315),
    [sym_init_declarator] = STATE(2316),
    [sym_reference_declarator] = STATE(2315),
    [sym_structured_binding_reference_declarator] = STATE(2317),
    [sym_structured_binding_declarator] = STATE(2318),
    [sym_template_type] = STATE(46),
    [sym_template_function] = STATE(2315),
    [sym_destructor_name] = STATE(2315),
    [sym_scoped_identifier] = STATE(33),
    [sym_scoped_type_identifier] = STATE(47),
    [sym_scoped_namespace_identifier] = STATE(46),
    [anon_sym_LPAREN] = ACTIONS(11),
    [anon_sym_SEMI] = ACTIONS(5351),
    [anon_sym_STAR] = ACTIONS(196),
    [anon_sym_LBRACK] = ACTIONS(198),
    [anon_sym_AMP] = ACTIONS(200),
    [anon_sym_AMP_AMP] = ACTIONS(202),
    [anon_sym_TILDE] = ACTIONS(45),
    [sym_identifier] = ACTIONS(75),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(77),
    [sym_operator_name] = ACTIONS(5353),
  },
  [1947] = {
    [sym_argument_list] = STATE(802),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_COMMA] = ACTIONS(1740),
    [anon_sym_SEMI] = ACTIONS(5355),
    [anon_sym_STAR] = ACTIONS(1744),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_EQ] = ACTIONS(1746),
    [anon_sym_QMARK] = ACTIONS(1748),
    [anon_sym_STAR_EQ] = ACTIONS(1750),
    [anon_sym_SLASH_EQ] = ACTIONS(1750),
    [anon_sym_PERCENT_EQ] = ACTIONS(1750),
    [anon_sym_PLUS_EQ] = ACTIONS(1750),
    [anon_sym_DASH_EQ] = ACTIONS(1750),
    [anon_sym_LT_LT_EQ] = ACTIONS(1750),
    [anon_sym_GT_GT_EQ] = ACTIONS(1750),
    [anon_sym_AMP_EQ] = ACTIONS(1750),
    [anon_sym_CARET_EQ] = ACTIONS(1750),
    [anon_sym_PIPE_EQ] = ACTIONS(1750),
    [anon_sym_AMP] = ACTIONS(1752),
    [anon_sym_PIPE_PIPE] = ACTIONS(1754),
    [anon_sym_AMP_AMP] = ACTIONS(1756),
    [anon_sym_PIPE] = ACTIONS(1758),
    [anon_sym_CARET] = ACTIONS(1760),
    [anon_sym_EQ_EQ] = ACTIONS(1762),
    [anon_sym_BANG_EQ] = ACTIONS(1762),
    [anon_sym_LT] = ACTIONS(1764),
    [anon_sym_GT] = ACTIONS(1764),
    [anon_sym_LT_EQ] = ACTIONS(1766),
    [anon_sym_GT_EQ] = ACTIONS(1766),
    [anon_sym_LT_LT] = ACTIONS(1768),
    [anon_sym_GT_GT] = ACTIONS(1768),
    [anon_sym_PLUS] = ACTIONS(1770),
    [anon_sym_DASH] = ACTIONS(1770),
    [anon_sym_SLASH] = ACTIONS(1744),
    [anon_sym_PERCENT] = ACTIONS(1744),
    [anon_sym_DASH_DASH] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(1554),
    [anon_sym_DASH_GT] = ACTIONS(1554),
    [sym_comment] = ACTIONS(49),
  },
  [1948] = {
    [anon_sym_SEMI] = ACTIONS(5355),
    [sym_comment] = ACTIONS(49),
  },
  [1949] = {
    [sym_preproc_include] = STATE(2320),
    [sym_preproc_def] = STATE(2320),
    [sym_preproc_function_def] = STATE(2320),
    [sym_preproc_call] = STATE(2320),
    [sym_preproc_if_in_compound_statement] = STATE(1944),
    [sym_preproc_ifdef_in_compound_statement] = STATE(1945),
    [sym_declaration] = STATE(2320),
    [sym_type_definition] = STATE(2320),
    [sym__declaration_specifiers] = STATE(1946),
    [sym_compound_statement] = STATE(2320),
    [sym_storage_class_specifier] = STATE(419),
    [sym_type_qualifier] = STATE(419),
    [sym__type_specifier] = STATE(30),
    [sym_sized_type_specifier] = STATE(30),
    [sym_enum_specifier] = STATE(30),
    [sym_struct_specifier] = STATE(30),
    [sym_union_specifier] = STATE(30),
    [sym_labeled_statement] = STATE(2320),
    [sym_expression_statement] = STATE(2320),
    [sym_if_statement] = STATE(2320),
    [sym_switch_statement] = STATE(2320),
    [sym_case_statement] = STATE(2320),
    [sym_while_statement] = STATE(2320),
    [sym_do_statement] = STATE(2320),
    [sym_for_statement] = STATE(2320),
    [sym_return_statement] = STATE(2320),
    [sym_break_statement] = STATE(2320),
    [sym_continue_statement] = STATE(2320),
    [sym_goto_statement] = STATE(2320),
    [sym__expression] = STATE(1947),
    [sym_comma_expression] = STATE(1948),
    [sym_conditional_expression] = STATE(1947),
    [sym_assignment_expression] = STATE(1947),
    [sym_pointer_expression] = STATE(1947),
    [sym_logical_expression] = STATE(1947),
    [sym_bitwise_expression] = STATE(1947),
    [sym_equality_expression] = STATE(1947),
    [sym_relational_expression] = STATE(1947),
    [sym_shift_expression] = STATE(1947),
    [sym_math_expression] = STATE(1947),
    [sym_cast_expression] = STATE(1947),
    [sym_sizeof_expression] = STATE(1947),
    [sym_subscript_expression] = STATE(1947),
    [sym_call_expression] = STATE(1947),
    [sym_field_expression] = STATE(1947),
    [sym_compound_literal_expression] = STATE(1947),
    [sym_parenthesized_expression] = STATE(1947),
    [sym_concatenated_string] = STATE(1947),
    [sym__empty_declaration] = STATE(2320),
    [sym_macro_type_specifier] = STATE(30),
    [sym_class_specifier] = STATE(30),
    [sym_dependent_type] = STATE(30),
    [sym_structured_binding_declaration] = STATE(2320),
    [sym_template_type] = STATE(415),
    [sym_template_function] = STATE(1947),
    [sym_for_range_loop] = STATE(2320),
    [sym_new_expression] = STATE(1947),
    [sym_delete_expression] = STATE(1947),
    [sym_lambda_expression] = STATE(1947),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(416),
    [sym_scoped_namespace_identifier] = STATE(417),
    [aux_sym_preproc_if_in_compound_statement_repeat1] = STATE(2320),
    [aux_sym__declaration_specifiers_repeat1] = STATE(419),
    [aux_sym_sized_type_specifier_repeat1] = STATE(38),
    [sym_raw_string_literal] = ACTIONS(4395),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(4397),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(4399),
    [anon_sym_LPAREN] = ACTIONS(626),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(4401),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(5357),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(4405),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(4407),
    [sym_preproc_directive] = ACTIONS(4409),
    [anon_sym_SEMI] = ACTIONS(4411),
    [anon_sym_typedef] = ACTIONS(4413),
    [anon_sym_extern] = ACTIONS(154),
    [anon_sym_LBRACE] = ACTIONS(4415),
    [anon_sym_STAR] = ACTIONS(644),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_static] = ACTIONS(154),
    [anon_sym_register] = ACTIONS(154),
    [anon_sym_inline] = ACTIONS(154),
    [anon_sym_const] = ACTIONS(158),
    [anon_sym_restrict] = ACTIONS(158),
    [anon_sym_volatile] = ACTIONS(158),
    [anon_sym__Atomic] = ACTIONS(158),
    [anon_sym_mutable] = ACTIONS(158),
    [anon_sym_explicit] = ACTIONS(158),
    [anon_sym_constexpr] = ACTIONS(158),
    [anon_sym_unsigned] = ACTIONS(31),
    [anon_sym_long] = ACTIONS(31),
    [anon_sym_short] = ACTIONS(31),
    [sym_primitive_type] = ACTIONS(33),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_union] = ACTIONS(39),
    [anon_sym_if] = ACTIONS(4417),
    [anon_sym_switch] = ACTIONS(4419),
    [anon_sym_case] = ACTIONS(4421),
    [anon_sym_default] = ACTIONS(4423),
    [anon_sym_while] = ACTIONS(4425),
    [anon_sym_do] = ACTIONS(4427),
    [anon_sym_for] = ACTIONS(4429),
    [anon_sym_return] = ACTIONS(4431),
    [anon_sym_break] = ACTIONS(4433),
    [anon_sym_continue] = ACTIONS(4435),
    [anon_sym_goto] = ACTIONS(4437),
    [anon_sym_AMP] = ACTIONS(644),
    [anon_sym_BANG] = ACTIONS(668),
    [anon_sym_TILDE] = ACTIONS(670),
    [anon_sym_PLUS] = ACTIONS(672),
    [anon_sym_DASH] = ACTIONS(672),
    [anon_sym_DASH_DASH] = ACTIONS(674),
    [anon_sym_PLUS_PLUS] = ACTIONS(674),
    [anon_sym_sizeof] = ACTIONS(676),
    [sym_number_literal] = ACTIONS(4395),
    [sym_char_literal] = ACTIONS(4395),
    [sym_string_literal] = ACTIONS(678),
    [sym_true] = ACTIONS(4439),
    [sym_false] = ACTIONS(4439),
    [sym_null] = ACTIONS(4439),
    [sym_identifier] = ACTIONS(4441),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(51),
    [sym_auto] = ACTIONS(33),
    [anon_sym_typename] = ACTIONS(53),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(684),
    [anon_sym_delete] = ACTIONS(686),
    [sym_nullptr] = ACTIONS(4439),
  },
  [1950] = {
    [sym_preproc_include] = STATE(2323),
    [sym_preproc_def] = STATE(2323),
    [sym_preproc_function_def] = STATE(2323),
    [sym_preproc_call] = STATE(2323),
    [sym_preproc_if_in_compound_statement] = STATE(1414),
    [sym_preproc_ifdef_in_compound_statement] = STATE(1415),
    [sym_preproc_else_in_compound_statement] = STATE(2321),
    [sym_preproc_elif_in_compound_statement] = STATE(2322),
    [sym_declaration] = STATE(2323),
    [sym_type_definition] = STATE(2323),
    [sym__declaration_specifiers] = STATE(1418),
    [sym_compound_statement] = STATE(2323),
    [sym_storage_class_specifier] = STATE(419),
    [sym_type_qualifier] = STATE(419),
    [sym__type_specifier] = STATE(30),
    [sym_sized_type_specifier] = STATE(30),
    [sym_enum_specifier] = STATE(30),
    [sym_struct_specifier] = STATE(30),
    [sym_union_specifier] = STATE(30),
    [sym_labeled_statement] = STATE(2323),
    [sym_expression_statement] = STATE(2323),
    [sym_if_statement] = STATE(2323),
    [sym_switch_statement] = STATE(2323),
    [sym_case_statement] = STATE(2323),
    [sym_while_statement] = STATE(2323),
    [sym_do_statement] = STATE(2323),
    [sym_for_statement] = STATE(2323),
    [sym_return_statement] = STATE(2323),
    [sym_break_statement] = STATE(2323),
    [sym_continue_statement] = STATE(2323),
    [sym_goto_statement] = STATE(2323),
    [sym__expression] = STATE(1419),
    [sym_comma_expression] = STATE(1420),
    [sym_conditional_expression] = STATE(1419),
    [sym_assignment_expression] = STATE(1419),
    [sym_pointer_expression] = STATE(1419),
    [sym_logical_expression] = STATE(1419),
    [sym_bitwise_expression] = STATE(1419),
    [sym_equality_expression] = STATE(1419),
    [sym_relational_expression] = STATE(1419),
    [sym_shift_expression] = STATE(1419),
    [sym_math_expression] = STATE(1419),
    [sym_cast_expression] = STATE(1419),
    [sym_sizeof_expression] = STATE(1419),
    [sym_subscript_expression] = STATE(1419),
    [sym_call_expression] = STATE(1419),
    [sym_field_expression] = STATE(1419),
    [sym_compound_literal_expression] = STATE(1419),
    [sym_parenthesized_expression] = STATE(1419),
    [sym_concatenated_string] = STATE(1419),
    [sym__empty_declaration] = STATE(2323),
    [sym_macro_type_specifier] = STATE(30),
    [sym_class_specifier] = STATE(30),
    [sym_dependent_type] = STATE(30),
    [sym_structured_binding_declaration] = STATE(2323),
    [sym_template_type] = STATE(415),
    [sym_template_function] = STATE(1419),
    [sym_for_range_loop] = STATE(2323),
    [sym_new_expression] = STATE(1419),
    [sym_delete_expression] = STATE(1419),
    [sym_lambda_expression] = STATE(1419),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(416),
    [sym_scoped_namespace_identifier] = STATE(417),
    [aux_sym_preproc_if_in_compound_statement_repeat1] = STATE(2323),
    [aux_sym__declaration_specifiers_repeat1] = STATE(419),
    [aux_sym_sized_type_specifier_repeat1] = STATE(38),
    [sym_raw_string_literal] = ACTIONS(2879),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(2881),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(2883),
    [anon_sym_LPAREN] = ACTIONS(626),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(2885),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(5359),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(2889),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(2891),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(2893),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(2895),
    [sym_preproc_directive] = ACTIONS(2897),
    [anon_sym_SEMI] = ACTIONS(2899),
    [anon_sym_typedef] = ACTIONS(2901),
    [anon_sym_extern] = ACTIONS(154),
    [anon_sym_LBRACE] = ACTIONS(2903),
    [anon_sym_STAR] = ACTIONS(644),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_static] = ACTIONS(154),
    [anon_sym_register] = ACTIONS(154),
    [anon_sym_inline] = ACTIONS(154),
    [anon_sym_const] = ACTIONS(158),
    [anon_sym_restrict] = ACTIONS(158),
    [anon_sym_volatile] = ACTIONS(158),
    [anon_sym__Atomic] = ACTIONS(158),
    [anon_sym_mutable] = ACTIONS(158),
    [anon_sym_explicit] = ACTIONS(158),
    [anon_sym_constexpr] = ACTIONS(158),
    [anon_sym_unsigned] = ACTIONS(31),
    [anon_sym_long] = ACTIONS(31),
    [anon_sym_short] = ACTIONS(31),
    [sym_primitive_type] = ACTIONS(33),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_union] = ACTIONS(39),
    [anon_sym_if] = ACTIONS(2905),
    [anon_sym_switch] = ACTIONS(2907),
    [anon_sym_case] = ACTIONS(2909),
    [anon_sym_default] = ACTIONS(2911),
    [anon_sym_while] = ACTIONS(2913),
    [anon_sym_do] = ACTIONS(2915),
    [anon_sym_for] = ACTIONS(2917),
    [anon_sym_return] = ACTIONS(2919),
    [anon_sym_break] = ACTIONS(2921),
    [anon_sym_continue] = ACTIONS(2923),
    [anon_sym_goto] = ACTIONS(2925),
    [anon_sym_AMP] = ACTIONS(644),
    [anon_sym_BANG] = ACTIONS(668),
    [anon_sym_TILDE] = ACTIONS(670),
    [anon_sym_PLUS] = ACTIONS(672),
    [anon_sym_DASH] = ACTIONS(672),
    [anon_sym_DASH_DASH] = ACTIONS(674),
    [anon_sym_PLUS_PLUS] = ACTIONS(674),
    [anon_sym_sizeof] = ACTIONS(676),
    [sym_number_literal] = ACTIONS(2879),
    [sym_char_literal] = ACTIONS(2879),
    [sym_string_literal] = ACTIONS(678),
    [sym_true] = ACTIONS(2927),
    [sym_false] = ACTIONS(2927),
    [sym_null] = ACTIONS(2927),
    [sym_identifier] = ACTIONS(2929),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(51),
    [sym_auto] = ACTIONS(33),
    [anon_sym_typename] = ACTIONS(53),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(684),
    [anon_sym_delete] = ACTIONS(686),
    [sym_nullptr] = ACTIONS(2927),
  },
  [1951] = {
    [sym_preproc_arg] = ACTIONS(5361),
    [sym_comment] = ACTIONS(83),
  },
  [1952] = {
    [sym_raw_string_literal] = ACTIONS(307),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(309),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(309),
    [anon_sym_LPAREN] = ACTIONS(307),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(309),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(309),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(309),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(309),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(309),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(309),
    [sym_preproc_directive] = ACTIONS(309),
    [anon_sym_SEMI] = ACTIONS(307),
    [anon_sym_typedef] = ACTIONS(309),
    [anon_sym_extern] = ACTIONS(309),
    [anon_sym_LBRACE] = ACTIONS(307),
    [anon_sym_STAR] = ACTIONS(307),
    [anon_sym_LBRACK] = ACTIONS(307),
    [anon_sym_static] = ACTIONS(309),
    [anon_sym_register] = ACTIONS(309),
    [anon_sym_inline] = ACTIONS(309),
    [anon_sym_const] = ACTIONS(309),
    [anon_sym_restrict] = ACTIONS(309),
    [anon_sym_volatile] = ACTIONS(309),
    [anon_sym__Atomic] = ACTIONS(309),
    [anon_sym_mutable] = ACTIONS(309),
    [anon_sym_explicit] = ACTIONS(309),
    [anon_sym_constexpr] = ACTIONS(309),
    [anon_sym_unsigned] = ACTIONS(309),
    [anon_sym_long] = ACTIONS(309),
    [anon_sym_short] = ACTIONS(309),
    [sym_primitive_type] = ACTIONS(309),
    [anon_sym_enum] = ACTIONS(309),
    [anon_sym_struct] = ACTIONS(309),
    [anon_sym_union] = ACTIONS(309),
    [anon_sym_if] = ACTIONS(309),
    [anon_sym_switch] = ACTIONS(309),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_default] = ACTIONS(309),
    [anon_sym_while] = ACTIONS(309),
    [anon_sym_do] = ACTIONS(309),
    [anon_sym_for] = ACTIONS(309),
    [anon_sym_return] = ACTIONS(309),
    [anon_sym_break] = ACTIONS(309),
    [anon_sym_continue] = ACTIONS(309),
    [anon_sym_goto] = ACTIONS(309),
    [anon_sym_AMP] = ACTIONS(307),
    [anon_sym_BANG] = ACTIONS(307),
    [anon_sym_TILDE] = ACTIONS(307),
    [anon_sym_PLUS] = ACTIONS(309),
    [anon_sym_DASH] = ACTIONS(309),
    [anon_sym_DASH_DASH] = ACTIONS(307),
    [anon_sym_PLUS_PLUS] = ACTIONS(307),
    [anon_sym_sizeof] = ACTIONS(309),
    [sym_number_literal] = ACTIONS(307),
    [sym_char_literal] = ACTIONS(307),
    [sym_string_literal] = ACTIONS(307),
    [sym_true] = ACTIONS(309),
    [sym_false] = ACTIONS(309),
    [sym_null] = ACTIONS(309),
    [sym_identifier] = ACTIONS(309),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(309),
    [sym_auto] = ACTIONS(309),
    [anon_sym_typename] = ACTIONS(309),
    [anon_sym_new] = ACTIONS(309),
    [anon_sym_COLON_COLON] = ACTIONS(307),
    [anon_sym_delete] = ACTIONS(309),
    [sym_nullptr] = ACTIONS(309),
  },
  [1953] = {
    [sym__type_declarator] = STATE(2325),
    [sym_pointer_type_declarator] = STATE(213),
    [sym_function_type_declarator] = STATE(214),
    [sym_array_type_declarator] = STATE(215),
    [anon_sym_LPAREN] = ACTIONS(327),
    [anon_sym_STAR] = ACTIONS(329),
    [sym_identifier] = ACTIONS(331),
    [sym_comment] = ACTIONS(49),
  },
  [1954] = {
    [sym_type_qualifier] = STATE(219),
    [sym__type_specifier] = STATE(2326),
    [sym_sized_type_specifier] = STATE(2326),
    [sym_enum_specifier] = STATE(2326),
    [sym_struct_specifier] = STATE(2326),
    [sym_union_specifier] = STATE(2326),
    [sym_macro_type_specifier] = STATE(2326),
    [sym_class_specifier] = STATE(2326),
    [sym_dependent_type] = STATE(2326),
    [sym_template_type] = STATE(62),
    [sym_scoped_type_identifier] = STATE(63),
    [sym_scoped_namespace_identifier] = STATE(64),
    [aux_sym_type_definition_repeat1] = STATE(219),
    [aux_sym_sized_type_specifier_repeat1] = STATE(66),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_restrict] = ACTIONS(93),
    [anon_sym_volatile] = ACTIONS(93),
    [anon_sym__Atomic] = ACTIONS(93),
    [anon_sym_mutable] = ACTIONS(93),
    [anon_sym_explicit] = ACTIONS(93),
    [anon_sym_constexpr] = ACTIONS(93),
    [anon_sym_unsigned] = ACTIONS(95),
    [anon_sym_long] = ACTIONS(95),
    [anon_sym_short] = ACTIONS(95),
    [sym_primitive_type] = ACTIONS(5363),
    [anon_sym_enum] = ACTIONS(99),
    [anon_sym_struct] = ACTIONS(101),
    [anon_sym_union] = ACTIONS(103),
    [sym_identifier] = ACTIONS(105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(107),
    [sym_auto] = ACTIONS(5363),
    [anon_sym_typename] = ACTIONS(109),
    [anon_sym_COLON_COLON] = ACTIONS(111),
  },
  [1955] = {
    [sym_raw_string_literal] = ACTIONS(1622),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1624),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1624),
    [anon_sym_LPAREN] = ACTIONS(1622),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1624),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(1624),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1624),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1624),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(1624),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(1624),
    [sym_preproc_directive] = ACTIONS(1624),
    [anon_sym_SEMI] = ACTIONS(1622),
    [anon_sym_typedef] = ACTIONS(1624),
    [anon_sym_extern] = ACTIONS(1624),
    [anon_sym_LBRACE] = ACTIONS(1622),
    [anon_sym_STAR] = ACTIONS(1622),
    [anon_sym_LBRACK] = ACTIONS(1622),
    [anon_sym_static] = ACTIONS(1624),
    [anon_sym_register] = ACTIONS(1624),
    [anon_sym_inline] = ACTIONS(1624),
    [anon_sym_const] = ACTIONS(1624),
    [anon_sym_restrict] = ACTIONS(1624),
    [anon_sym_volatile] = ACTIONS(1624),
    [anon_sym__Atomic] = ACTIONS(1624),
    [anon_sym_mutable] = ACTIONS(1624),
    [anon_sym_explicit] = ACTIONS(1624),
    [anon_sym_constexpr] = ACTIONS(1624),
    [anon_sym_unsigned] = ACTIONS(1624),
    [anon_sym_long] = ACTIONS(1624),
    [anon_sym_short] = ACTIONS(1624),
    [sym_primitive_type] = ACTIONS(1624),
    [anon_sym_enum] = ACTIONS(1624),
    [anon_sym_struct] = ACTIONS(1624),
    [anon_sym_union] = ACTIONS(1624),
    [anon_sym_if] = ACTIONS(1624),
    [anon_sym_switch] = ACTIONS(1624),
    [anon_sym_case] = ACTIONS(1624),
    [anon_sym_default] = ACTIONS(1624),
    [anon_sym_while] = ACTIONS(1624),
    [anon_sym_do] = ACTIONS(1624),
    [anon_sym_for] = ACTIONS(1624),
    [anon_sym_return] = ACTIONS(1624),
    [anon_sym_break] = ACTIONS(1624),
    [anon_sym_continue] = ACTIONS(1624),
    [anon_sym_goto] = ACTIONS(1624),
    [anon_sym_AMP] = ACTIONS(1622),
    [anon_sym_BANG] = ACTIONS(1622),
    [anon_sym_TILDE] = ACTIONS(1622),
    [anon_sym_PLUS] = ACTIONS(1624),
    [anon_sym_DASH] = ACTIONS(1624),
    [anon_sym_DASH_DASH] = ACTIONS(1622),
    [anon_sym_PLUS_PLUS] = ACTIONS(1622),
    [anon_sym_sizeof] = ACTIONS(1624),
    [sym_number_literal] = ACTIONS(1622),
    [sym_char_literal] = ACTIONS(1622),
    [sym_string_literal] = ACTIONS(1622),
    [sym_true] = ACTIONS(1624),
    [sym_false] = ACTIONS(1624),
    [sym_null] = ACTIONS(1624),
    [sym_identifier] = ACTIONS(1624),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(1624),
    [sym_auto] = ACTIONS(1624),
    [anon_sym_typename] = ACTIONS(1624),
    [anon_sym_new] = ACTIONS(1624),
    [anon_sym_COLON_COLON] = ACTIONS(1622),
    [anon_sym_delete] = ACTIONS(1624),
    [sym_nullptr] = ACTIONS(1624),
  },
  [1956] = {
    [sym_preproc_include] = STATE(913),
    [sym_preproc_def] = STATE(913),
    [sym_preproc_function_def] = STATE(913),
    [sym_preproc_call] = STATE(913),
    [sym_preproc_if_in_compound_statement] = STATE(410),
    [sym_preproc_ifdef_in_compound_statement] = STATE(411),
    [sym_declaration] = STATE(913),
    [sym_type_definition] = STATE(913),
    [sym__declaration_specifiers] = STATE(412),
    [sym_compound_statement] = STATE(913),
    [sym_storage_class_specifier] = STATE(419),
    [sym_type_qualifier] = STATE(419),
    [sym__type_specifier] = STATE(30),
    [sym_sized_type_specifier] = STATE(30),
    [sym_enum_specifier] = STATE(30),
    [sym_struct_specifier] = STATE(30),
    [sym_union_specifier] = STATE(30),
    [sym_labeled_statement] = STATE(913),
    [sym_expression_statement] = STATE(913),
    [sym_if_statement] = STATE(913),
    [sym_switch_statement] = STATE(913),
    [sym_case_statement] = STATE(913),
    [sym_while_statement] = STATE(913),
    [sym_do_statement] = STATE(913),
    [sym_for_statement] = STATE(913),
    [sym_return_statement] = STATE(913),
    [sym_break_statement] = STATE(913),
    [sym_continue_statement] = STATE(913),
    [sym_goto_statement] = STATE(913),
    [sym__expression] = STATE(413),
    [sym_comma_expression] = STATE(414),
    [sym_conditional_expression] = STATE(413),
    [sym_assignment_expression] = STATE(413),
    [sym_pointer_expression] = STATE(413),
    [sym_logical_expression] = STATE(413),
    [sym_bitwise_expression] = STATE(413),
    [sym_equality_expression] = STATE(413),
    [sym_relational_expression] = STATE(413),
    [sym_shift_expression] = STATE(413),
    [sym_math_expression] = STATE(413),
    [sym_cast_expression] = STATE(413),
    [sym_sizeof_expression] = STATE(413),
    [sym_subscript_expression] = STATE(413),
    [sym_call_expression] = STATE(413),
    [sym_field_expression] = STATE(413),
    [sym_compound_literal_expression] = STATE(413),
    [sym_parenthesized_expression] = STATE(413),
    [sym_concatenated_string] = STATE(413),
    [sym__empty_declaration] = STATE(913),
    [sym_macro_type_specifier] = STATE(30),
    [sym_class_specifier] = STATE(30),
    [sym_dependent_type] = STATE(30),
    [sym_structured_binding_declaration] = STATE(913),
    [sym_template_type] = STATE(415),
    [sym_template_function] = STATE(413),
    [sym_for_range_loop] = STATE(913),
    [sym_new_expression] = STATE(413),
    [sym_delete_expression] = STATE(413),
    [sym_lambda_expression] = STATE(413),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(416),
    [sym_scoped_namespace_identifier] = STATE(417),
    [aux_sym_preproc_if_in_compound_statement_repeat1] = STATE(913),
    [aux_sym__declaration_specifiers_repeat1] = STATE(419),
    [aux_sym_sized_type_specifier_repeat1] = STATE(38),
    [sym_raw_string_literal] = ACTIONS(620),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(622),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(624),
    [anon_sym_LPAREN] = ACTIONS(626),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(628),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(630),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(632),
    [sym_preproc_directive] = ACTIONS(634),
    [anon_sym_SEMI] = ACTIONS(636),
    [anon_sym_typedef] = ACTIONS(638),
    [anon_sym_extern] = ACTIONS(154),
    [anon_sym_LBRACE] = ACTIONS(640),
    [anon_sym_RBRACE] = ACTIONS(5365),
    [anon_sym_STAR] = ACTIONS(644),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_static] = ACTIONS(154),
    [anon_sym_register] = ACTIONS(154),
    [anon_sym_inline] = ACTIONS(154),
    [anon_sym_const] = ACTIONS(158),
    [anon_sym_restrict] = ACTIONS(158),
    [anon_sym_volatile] = ACTIONS(158),
    [anon_sym__Atomic] = ACTIONS(158),
    [anon_sym_mutable] = ACTIONS(158),
    [anon_sym_explicit] = ACTIONS(158),
    [anon_sym_constexpr] = ACTIONS(158),
    [anon_sym_unsigned] = ACTIONS(31),
    [anon_sym_long] = ACTIONS(31),
    [anon_sym_short] = ACTIONS(31),
    [sym_primitive_type] = ACTIONS(33),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_union] = ACTIONS(39),
    [anon_sym_if] = ACTIONS(646),
    [anon_sym_switch] = ACTIONS(648),
    [anon_sym_case] = ACTIONS(650),
    [anon_sym_default] = ACTIONS(652),
    [anon_sym_while] = ACTIONS(654),
    [anon_sym_do] = ACTIONS(656),
    [anon_sym_for] = ACTIONS(658),
    [anon_sym_return] = ACTIONS(660),
    [anon_sym_break] = ACTIONS(662),
    [anon_sym_continue] = ACTIONS(664),
    [anon_sym_goto] = ACTIONS(666),
    [anon_sym_AMP] = ACTIONS(644),
    [anon_sym_BANG] = ACTIONS(668),
    [anon_sym_TILDE] = ACTIONS(670),
    [anon_sym_PLUS] = ACTIONS(672),
    [anon_sym_DASH] = ACTIONS(672),
    [anon_sym_DASH_DASH] = ACTIONS(674),
    [anon_sym_PLUS_PLUS] = ACTIONS(674),
    [anon_sym_sizeof] = ACTIONS(676),
    [sym_number_literal] = ACTIONS(620),
    [sym_char_literal] = ACTIONS(620),
    [sym_string_literal] = ACTIONS(678),
    [sym_true] = ACTIONS(680),
    [sym_false] = ACTIONS(680),
    [sym_null] = ACTIONS(680),
    [sym_identifier] = ACTIONS(682),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(51),
    [sym_auto] = ACTIONS(33),
    [anon_sym_typename] = ACTIONS(53),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(684),
    [anon_sym_delete] = ACTIONS(686),
    [sym_nullptr] = ACTIONS(680),
  },
  [1957] = {
    [sym__expression] = STATE(2328),
    [sym_conditional_expression] = STATE(2328),
    [sym_assignment_expression] = STATE(2328),
    [sym_pointer_expression] = STATE(2328),
    [sym_logical_expression] = STATE(2328),
    [sym_bitwise_expression] = STATE(2328),
    [sym_equality_expression] = STATE(2328),
    [sym_relational_expression] = STATE(2328),
    [sym_shift_expression] = STATE(2328),
    [sym_math_expression] = STATE(2328),
    [sym_cast_expression] = STATE(2328),
    [sym_sizeof_expression] = STATE(2328),
    [sym_subscript_expression] = STATE(2328),
    [sym_call_expression] = STATE(2328),
    [sym_field_expression] = STATE(2328),
    [sym_compound_literal_expression] = STATE(2328),
    [sym_parenthesized_expression] = STATE(2328),
    [sym_concatenated_string] = STATE(2328),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(2328),
    [sym_new_expression] = STATE(2328),
    [sym_delete_expression] = STATE(2328),
    [sym_lambda_expression] = STATE(2328),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(5367),
    [anon_sym_LPAREN] = ACTIONS(2943),
    [anon_sym_STAR] = ACTIONS(2945),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_AMP] = ACTIONS(2945),
    [anon_sym_BANG] = ACTIONS(2947),
    [anon_sym_TILDE] = ACTIONS(2949),
    [anon_sym_PLUS] = ACTIONS(2951),
    [anon_sym_DASH] = ACTIONS(2951),
    [anon_sym_DASH_DASH] = ACTIONS(2953),
    [anon_sym_PLUS_PLUS] = ACTIONS(2953),
    [anon_sym_sizeof] = ACTIONS(2955),
    [sym_number_literal] = ACTIONS(5367),
    [sym_char_literal] = ACTIONS(5367),
    [sym_string_literal] = ACTIONS(2957),
    [sym_true] = ACTIONS(5369),
    [sym_false] = ACTIONS(5369),
    [sym_null] = ACTIONS(5369),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(2961),
    [anon_sym_delete] = ACTIONS(2963),
    [sym_nullptr] = ACTIONS(5369),
  },
  [1958] = {
    [anon_sym_LPAREN] = ACTIONS(5371),
    [sym_comment] = ACTIONS(49),
  },
  [1959] = {
    [sym__expression] = STATE(2330),
    [sym_conditional_expression] = STATE(2330),
    [sym_assignment_expression] = STATE(2330),
    [sym_pointer_expression] = STATE(2330),
    [sym_logical_expression] = STATE(2330),
    [sym_bitwise_expression] = STATE(2330),
    [sym_equality_expression] = STATE(2330),
    [sym_relational_expression] = STATE(2330),
    [sym_shift_expression] = STATE(2330),
    [sym_math_expression] = STATE(2330),
    [sym_cast_expression] = STATE(2330),
    [sym_sizeof_expression] = STATE(2330),
    [sym_subscript_expression] = STATE(2330),
    [sym_call_expression] = STATE(2330),
    [sym_field_expression] = STATE(2330),
    [sym_compound_literal_expression] = STATE(2330),
    [sym_parenthesized_expression] = STATE(2330),
    [sym_concatenated_string] = STATE(2330),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(2330),
    [sym_new_expression] = STATE(2330),
    [sym_delete_expression] = STATE(2330),
    [sym_lambda_expression] = STATE(2330),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(5373),
    [anon_sym_LPAREN] = ACTIONS(2943),
    [anon_sym_STAR] = ACTIONS(2945),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_AMP] = ACTIONS(2945),
    [anon_sym_BANG] = ACTIONS(2947),
    [anon_sym_TILDE] = ACTIONS(2949),
    [anon_sym_PLUS] = ACTIONS(2951),
    [anon_sym_DASH] = ACTIONS(2951),
    [anon_sym_DASH_DASH] = ACTIONS(2953),
    [anon_sym_PLUS_PLUS] = ACTIONS(2953),
    [anon_sym_sizeof] = ACTIONS(2955),
    [sym_number_literal] = ACTIONS(5373),
    [sym_char_literal] = ACTIONS(5373),
    [sym_string_literal] = ACTIONS(2957),
    [sym_true] = ACTIONS(5375),
    [sym_false] = ACTIONS(5375),
    [sym_null] = ACTIONS(5375),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(2961),
    [anon_sym_delete] = ACTIONS(2963),
    [sym_nullptr] = ACTIONS(5375),
  },
  [1960] = {
    [sym_argument_list] = STATE(802),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_STAR] = ACTIONS(3003),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_EQ] = ACTIONS(3005),
    [anon_sym_COLON] = ACTIONS(5377),
    [anon_sym_QMARK] = ACTIONS(3009),
    [anon_sym_STAR_EQ] = ACTIONS(3011),
    [anon_sym_SLASH_EQ] = ACTIONS(3011),
    [anon_sym_PERCENT_EQ] = ACTIONS(3011),
    [anon_sym_PLUS_EQ] = ACTIONS(3011),
    [anon_sym_DASH_EQ] = ACTIONS(3011),
    [anon_sym_LT_LT_EQ] = ACTIONS(3011),
    [anon_sym_GT_GT_EQ] = ACTIONS(3011),
    [anon_sym_AMP_EQ] = ACTIONS(3011),
    [anon_sym_CARET_EQ] = ACTIONS(3011),
    [anon_sym_PIPE_EQ] = ACTIONS(3011),
    [anon_sym_AMP] = ACTIONS(3013),
    [anon_sym_PIPE_PIPE] = ACTIONS(3015),
    [anon_sym_AMP_AMP] = ACTIONS(3017),
    [anon_sym_PIPE] = ACTIONS(3019),
    [anon_sym_CARET] = ACTIONS(3021),
    [anon_sym_EQ_EQ] = ACTIONS(3023),
    [anon_sym_BANG_EQ] = ACTIONS(3023),
    [anon_sym_LT] = ACTIONS(3025),
    [anon_sym_GT] = ACTIONS(3025),
    [anon_sym_LT_EQ] = ACTIONS(3027),
    [anon_sym_GT_EQ] = ACTIONS(3027),
    [anon_sym_LT_LT] = ACTIONS(3029),
    [anon_sym_GT_GT] = ACTIONS(3029),
    [anon_sym_PLUS] = ACTIONS(3031),
    [anon_sym_DASH] = ACTIONS(3031),
    [anon_sym_SLASH] = ACTIONS(3003),
    [anon_sym_PERCENT] = ACTIONS(3003),
    [anon_sym_DASH_DASH] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(3033),
    [anon_sym_DASH_GT] = ACTIONS(3033),
    [sym_comment] = ACTIONS(49),
  },
  [1961] = {
    [sym_declaration] = STATE(2333),
    [sym_type_definition] = STATE(2333),
    [sym__declaration_specifiers] = STATE(2334),
    [sym_compound_statement] = STATE(2333),
    [sym_storage_class_specifier] = STATE(109),
    [sym_type_qualifier] = STATE(109),
    [sym__type_specifier] = STATE(105),
    [sym_sized_type_specifier] = STATE(105),
    [sym_enum_specifier] = STATE(105),
    [sym_struct_specifier] = STATE(105),
    [sym_union_specifier] = STATE(105),
    [sym_labeled_statement] = STATE(2333),
    [sym_expression_statement] = STATE(2333),
    [sym_if_statement] = STATE(2333),
    [sym_switch_statement] = STATE(2333),
    [sym_case_statement] = STATE(2333),
    [sym_while_statement] = STATE(2333),
    [sym_do_statement] = STATE(2333),
    [sym_for_statement] = STATE(2333),
    [sym_return_statement] = STATE(2333),
    [sym_break_statement] = STATE(2333),
    [sym_continue_statement] = STATE(2333),
    [sym_goto_statement] = STATE(2333),
    [sym__expression] = STATE(1419),
    [sym_comma_expression] = STATE(1420),
    [sym_conditional_expression] = STATE(1419),
    [sym_assignment_expression] = STATE(1419),
    [sym_pointer_expression] = STATE(1419),
    [sym_logical_expression] = STATE(1419),
    [sym_bitwise_expression] = STATE(1419),
    [sym_equality_expression] = STATE(1419),
    [sym_relational_expression] = STATE(1419),
    [sym_shift_expression] = STATE(1419),
    [sym_math_expression] = STATE(1419),
    [sym_cast_expression] = STATE(1419),
    [sym_sizeof_expression] = STATE(1419),
    [sym_subscript_expression] = STATE(1419),
    [sym_call_expression] = STATE(1419),
    [sym_field_expression] = STATE(1419),
    [sym_compound_literal_expression] = STATE(1419),
    [sym_parenthesized_expression] = STATE(1419),
    [sym_concatenated_string] = STATE(1419),
    [sym_macro_type_specifier] = STATE(105),
    [sym_class_specifier] = STATE(105),
    [sym_dependent_type] = STATE(105),
    [sym_template_type] = STATE(1475),
    [sym_template_function] = STATE(1419),
    [sym_for_range_loop] = STATE(2333),
    [sym_new_expression] = STATE(1419),
    [sym_delete_expression] = STATE(1419),
    [sym_lambda_expression] = STATE(1419),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(416),
    [sym_scoped_namespace_identifier] = STATE(1476),
    [aux_sym__declaration_specifiers_repeat1] = STATE(109),
    [aux_sym_sized_type_specifier_repeat1] = STATE(110),
    [sym_raw_string_literal] = ACTIONS(2879),
    [anon_sym_LPAREN] = ACTIONS(626),
    [anon_sym_SEMI] = ACTIONS(2899),
    [anon_sym_typedef] = ACTIONS(2901),
    [anon_sym_extern] = ACTIONS(154),
    [anon_sym_LBRACE] = ACTIONS(2903),
    [anon_sym_STAR] = ACTIONS(644),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_static] = ACTIONS(154),
    [anon_sym_register] = ACTIONS(154),
    [anon_sym_inline] = ACTIONS(154),
    [anon_sym_const] = ACTIONS(158),
    [anon_sym_restrict] = ACTIONS(158),
    [anon_sym_volatile] = ACTIONS(158),
    [anon_sym__Atomic] = ACTIONS(158),
    [anon_sym_mutable] = ACTIONS(158),
    [anon_sym_explicit] = ACTIONS(158),
    [anon_sym_constexpr] = ACTIONS(158),
    [anon_sym_unsigned] = ACTIONS(160),
    [anon_sym_long] = ACTIONS(160),
    [anon_sym_short] = ACTIONS(160),
    [sym_primitive_type] = ACTIONS(162),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_union] = ACTIONS(39),
    [anon_sym_if] = ACTIONS(2905),
    [anon_sym_switch] = ACTIONS(2907),
    [anon_sym_case] = ACTIONS(2909),
    [anon_sym_default] = ACTIONS(2911),
    [anon_sym_while] = ACTIONS(2913),
    [anon_sym_do] = ACTIONS(2915),
    [anon_sym_for] = ACTIONS(2917),
    [anon_sym_return] = ACTIONS(2919),
    [anon_sym_break] = ACTIONS(2921),
    [anon_sym_continue] = ACTIONS(2923),
    [anon_sym_goto] = ACTIONS(2925),
    [anon_sym_AMP] = ACTIONS(644),
    [anon_sym_BANG] = ACTIONS(668),
    [anon_sym_TILDE] = ACTIONS(670),
    [anon_sym_PLUS] = ACTIONS(672),
    [anon_sym_DASH] = ACTIONS(672),
    [anon_sym_DASH_DASH] = ACTIONS(674),
    [anon_sym_PLUS_PLUS] = ACTIONS(674),
    [anon_sym_sizeof] = ACTIONS(676),
    [sym_number_literal] = ACTIONS(2879),
    [sym_char_literal] = ACTIONS(2879),
    [sym_string_literal] = ACTIONS(678),
    [sym_true] = ACTIONS(2927),
    [sym_false] = ACTIONS(2927),
    [sym_null] = ACTIONS(2927),
    [sym_identifier] = ACTIONS(5379),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(51),
    [sym_auto] = ACTIONS(162),
    [anon_sym_typename] = ACTIONS(172),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(3040),
    [anon_sym_delete] = ACTIONS(686),
    [sym_nullptr] = ACTIONS(2927),
  },
  [1962] = {
    [sym__expression] = STATE(2335),
    [sym_conditional_expression] = STATE(2335),
    [sym_assignment_expression] = STATE(2335),
    [sym_pointer_expression] = STATE(2335),
    [sym_logical_expression] = STATE(2335),
    [sym_bitwise_expression] = STATE(2335),
    [sym_equality_expression] = STATE(2335),
    [sym_relational_expression] = STATE(2335),
    [sym_shift_expression] = STATE(2335),
    [sym_math_expression] = STATE(2335),
    [sym_cast_expression] = STATE(2335),
    [sym_sizeof_expression] = STATE(2335),
    [sym_subscript_expression] = STATE(2335),
    [sym_call_expression] = STATE(2335),
    [sym_field_expression] = STATE(2335),
    [sym_compound_literal_expression] = STATE(2335),
    [sym_parenthesized_expression] = STATE(2335),
    [sym_concatenated_string] = STATE(2335),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(2335),
    [sym_new_expression] = STATE(2335),
    [sym_delete_expression] = STATE(2335),
    [sym_lambda_expression] = STATE(2335),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(5381),
    [anon_sym_LPAREN] = ACTIONS(2943),
    [anon_sym_STAR] = ACTIONS(2945),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_AMP] = ACTIONS(2945),
    [anon_sym_BANG] = ACTIONS(2947),
    [anon_sym_TILDE] = ACTIONS(2949),
    [anon_sym_PLUS] = ACTIONS(2951),
    [anon_sym_DASH] = ACTIONS(2951),
    [anon_sym_DASH_DASH] = ACTIONS(2953),
    [anon_sym_PLUS_PLUS] = ACTIONS(2953),
    [anon_sym_sizeof] = ACTIONS(2955),
    [sym_number_literal] = ACTIONS(5381),
    [sym_char_literal] = ACTIONS(5381),
    [sym_string_literal] = ACTIONS(2957),
    [sym_true] = ACTIONS(5383),
    [sym_false] = ACTIONS(5383),
    [sym_null] = ACTIONS(5383),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(2961),
    [anon_sym_delete] = ACTIONS(2963),
    [sym_nullptr] = ACTIONS(5383),
  },
  [1963] = {
    [anon_sym_while] = ACTIONS(5385),
    [sym_comment] = ACTIONS(49),
  },
  [1964] = {
    [sym_declaration] = STATE(2337),
    [sym__declaration_specifiers] = STATE(1500),
    [sym_storage_class_specifier] = STATE(109),
    [sym_type_qualifier] = STATE(109),
    [sym__type_specifier] = STATE(105),
    [sym_sized_type_specifier] = STATE(105),
    [sym_enum_specifier] = STATE(105),
    [sym_struct_specifier] = STATE(105),
    [sym_union_specifier] = STATE(105),
    [sym__expression] = STATE(2338),
    [sym_conditional_expression] = STATE(2338),
    [sym_assignment_expression] = STATE(2338),
    [sym_pointer_expression] = STATE(2338),
    [sym_logical_expression] = STATE(2338),
    [sym_bitwise_expression] = STATE(2338),
    [sym_equality_expression] = STATE(2338),
    [sym_relational_expression] = STATE(2338),
    [sym_shift_expression] = STATE(2338),
    [sym_math_expression] = STATE(2338),
    [sym_cast_expression] = STATE(2338),
    [sym_sizeof_expression] = STATE(2338),
    [sym_subscript_expression] = STATE(2338),
    [sym_call_expression] = STATE(2338),
    [sym_field_expression] = STATE(2338),
    [sym_compound_literal_expression] = STATE(2338),
    [sym_parenthesized_expression] = STATE(2338),
    [sym_concatenated_string] = STATE(2338),
    [sym_macro_type_specifier] = STATE(105),
    [sym_class_specifier] = STATE(105),
    [sym_dependent_type] = STATE(105),
    [sym_template_type] = STATE(1475),
    [sym_template_function] = STATE(2338),
    [sym_for_range_declaration] = STATE(2339),
    [sym_new_expression] = STATE(2338),
    [sym_delete_expression] = STATE(2338),
    [sym_lambda_expression] = STATE(2338),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(416),
    [sym_scoped_namespace_identifier] = STATE(1476),
    [aux_sym__declaration_specifiers_repeat1] = STATE(109),
    [aux_sym_sized_type_specifier_repeat1] = STATE(110),
    [sym_raw_string_literal] = ACTIONS(5387),
    [anon_sym_LPAREN] = ACTIONS(1347),
    [anon_sym_SEMI] = ACTIONS(5389),
    [anon_sym_extern] = ACTIONS(154),
    [anon_sym_STAR] = ACTIONS(1349),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_static] = ACTIONS(154),
    [anon_sym_register] = ACTIONS(154),
    [anon_sym_inline] = ACTIONS(154),
    [anon_sym_const] = ACTIONS(158),
    [anon_sym_restrict] = ACTIONS(158),
    [anon_sym_volatile] = ACTIONS(158),
    [anon_sym__Atomic] = ACTIONS(158),
    [anon_sym_mutable] = ACTIONS(158),
    [anon_sym_explicit] = ACTIONS(158),
    [anon_sym_constexpr] = ACTIONS(158),
    [anon_sym_unsigned] = ACTIONS(160),
    [anon_sym_long] = ACTIONS(160),
    [anon_sym_short] = ACTIONS(160),
    [sym_primitive_type] = ACTIONS(162),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_union] = ACTIONS(39),
    [anon_sym_AMP] = ACTIONS(1349),
    [anon_sym_BANG] = ACTIONS(1351),
    [anon_sym_TILDE] = ACTIONS(1353),
    [anon_sym_PLUS] = ACTIONS(1355),
    [anon_sym_DASH] = ACTIONS(1355),
    [anon_sym_DASH_DASH] = ACTIONS(1357),
    [anon_sym_PLUS_PLUS] = ACTIONS(1357),
    [anon_sym_sizeof] = ACTIONS(1359),
    [sym_number_literal] = ACTIONS(5387),
    [sym_char_literal] = ACTIONS(5387),
    [sym_string_literal] = ACTIONS(1361),
    [sym_true] = ACTIONS(5391),
    [sym_false] = ACTIONS(5391),
    [sym_null] = ACTIONS(5391),
    [sym_identifier] = ACTIONS(3088),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(51),
    [sym_auto] = ACTIONS(162),
    [anon_sym_typename] = ACTIONS(172),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(3090),
    [anon_sym_delete] = ACTIONS(1367),
    [sym_nullptr] = ACTIONS(5391),
  },
  [1965] = {
    [sym_raw_string_literal] = ACTIONS(3092),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3094),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3094),
    [anon_sym_LPAREN] = ACTIONS(3092),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3094),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3094),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3094),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3094),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(3094),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(3094),
    [sym_preproc_directive] = ACTIONS(3094),
    [anon_sym_SEMI] = ACTIONS(3092),
    [anon_sym_typedef] = ACTIONS(3094),
    [anon_sym_extern] = ACTIONS(3094),
    [anon_sym_LBRACE] = ACTIONS(3092),
    [anon_sym_STAR] = ACTIONS(3092),
    [anon_sym_LBRACK] = ACTIONS(3092),
    [anon_sym_static] = ACTIONS(3094),
    [anon_sym_register] = ACTIONS(3094),
    [anon_sym_inline] = ACTIONS(3094),
    [anon_sym_const] = ACTIONS(3094),
    [anon_sym_restrict] = ACTIONS(3094),
    [anon_sym_volatile] = ACTIONS(3094),
    [anon_sym__Atomic] = ACTIONS(3094),
    [anon_sym_mutable] = ACTIONS(3094),
    [anon_sym_explicit] = ACTIONS(3094),
    [anon_sym_constexpr] = ACTIONS(3094),
    [anon_sym_unsigned] = ACTIONS(3094),
    [anon_sym_long] = ACTIONS(3094),
    [anon_sym_short] = ACTIONS(3094),
    [sym_primitive_type] = ACTIONS(3094),
    [anon_sym_enum] = ACTIONS(3094),
    [anon_sym_struct] = ACTIONS(3094),
    [anon_sym_union] = ACTIONS(3094),
    [anon_sym_if] = ACTIONS(3094),
    [anon_sym_switch] = ACTIONS(3094),
    [anon_sym_case] = ACTIONS(3094),
    [anon_sym_default] = ACTIONS(3094),
    [anon_sym_while] = ACTIONS(3094),
    [anon_sym_do] = ACTIONS(3094),
    [anon_sym_for] = ACTIONS(3094),
    [anon_sym_return] = ACTIONS(3094),
    [anon_sym_break] = ACTIONS(3094),
    [anon_sym_continue] = ACTIONS(3094),
    [anon_sym_goto] = ACTIONS(3094),
    [anon_sym_AMP] = ACTIONS(3092),
    [anon_sym_BANG] = ACTIONS(3092),
    [anon_sym_TILDE] = ACTIONS(3092),
    [anon_sym_PLUS] = ACTIONS(3094),
    [anon_sym_DASH] = ACTIONS(3094),
    [anon_sym_DASH_DASH] = ACTIONS(3092),
    [anon_sym_PLUS_PLUS] = ACTIONS(3092),
    [anon_sym_sizeof] = ACTIONS(3094),
    [sym_number_literal] = ACTIONS(3092),
    [sym_char_literal] = ACTIONS(3092),
    [sym_string_literal] = ACTIONS(3092),
    [sym_true] = ACTIONS(3094),
    [sym_false] = ACTIONS(3094),
    [sym_null] = ACTIONS(3094),
    [sym_identifier] = ACTIONS(3094),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(3094),
    [sym_auto] = ACTIONS(3094),
    [anon_sym_typename] = ACTIONS(3094),
    [anon_sym_new] = ACTIONS(3094),
    [anon_sym_COLON_COLON] = ACTIONS(3092),
    [anon_sym_delete] = ACTIONS(3094),
    [sym_nullptr] = ACTIONS(3094),
  },
  [1966] = {
    [sym_argument_list] = STATE(802),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_SEMI] = ACTIONS(5393),
    [anon_sym_STAR] = ACTIONS(2553),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_EQ] = ACTIONS(2555),
    [anon_sym_QMARK] = ACTIONS(2557),
    [anon_sym_STAR_EQ] = ACTIONS(2559),
    [anon_sym_SLASH_EQ] = ACTIONS(2559),
    [anon_sym_PERCENT_EQ] = ACTIONS(2559),
    [anon_sym_PLUS_EQ] = ACTIONS(2559),
    [anon_sym_DASH_EQ] = ACTIONS(2559),
    [anon_sym_LT_LT_EQ] = ACTIONS(2559),
    [anon_sym_GT_GT_EQ] = ACTIONS(2559),
    [anon_sym_AMP_EQ] = ACTIONS(2559),
    [anon_sym_CARET_EQ] = ACTIONS(2559),
    [anon_sym_PIPE_EQ] = ACTIONS(2559),
    [anon_sym_AMP] = ACTIONS(2561),
    [anon_sym_PIPE_PIPE] = ACTIONS(2563),
    [anon_sym_AMP_AMP] = ACTIONS(2565),
    [anon_sym_PIPE] = ACTIONS(2567),
    [anon_sym_CARET] = ACTIONS(2569),
    [anon_sym_EQ_EQ] = ACTIONS(2571),
    [anon_sym_BANG_EQ] = ACTIONS(2571),
    [anon_sym_LT] = ACTIONS(2573),
    [anon_sym_GT] = ACTIONS(2573),
    [anon_sym_LT_EQ] = ACTIONS(2575),
    [anon_sym_GT_EQ] = ACTIONS(2575),
    [anon_sym_LT_LT] = ACTIONS(2577),
    [anon_sym_GT_GT] = ACTIONS(2577),
    [anon_sym_PLUS] = ACTIONS(2579),
    [anon_sym_DASH] = ACTIONS(2579),
    [anon_sym_SLASH] = ACTIONS(2553),
    [anon_sym_PERCENT] = ACTIONS(2553),
    [anon_sym_DASH_DASH] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(1554),
    [anon_sym_DASH_GT] = ACTIONS(1554),
    [sym_comment] = ACTIONS(49),
  },
  [1967] = {
    [anon_sym_SEMI] = ACTIONS(5393),
    [sym_comment] = ACTIONS(49),
  },
  [1968] = {
    [sym_raw_string_literal] = ACTIONS(3098),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3100),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3100),
    [anon_sym_LPAREN] = ACTIONS(3098),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3100),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3100),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3100),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3100),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(3100),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(3100),
    [sym_preproc_directive] = ACTIONS(3100),
    [anon_sym_SEMI] = ACTIONS(3098),
    [anon_sym_typedef] = ACTIONS(3100),
    [anon_sym_extern] = ACTIONS(3100),
    [anon_sym_LBRACE] = ACTIONS(3098),
    [anon_sym_STAR] = ACTIONS(3098),
    [anon_sym_LBRACK] = ACTIONS(3098),
    [anon_sym_static] = ACTIONS(3100),
    [anon_sym_register] = ACTIONS(3100),
    [anon_sym_inline] = ACTIONS(3100),
    [anon_sym_const] = ACTIONS(3100),
    [anon_sym_restrict] = ACTIONS(3100),
    [anon_sym_volatile] = ACTIONS(3100),
    [anon_sym__Atomic] = ACTIONS(3100),
    [anon_sym_mutable] = ACTIONS(3100),
    [anon_sym_explicit] = ACTIONS(3100),
    [anon_sym_constexpr] = ACTIONS(3100),
    [anon_sym_unsigned] = ACTIONS(3100),
    [anon_sym_long] = ACTIONS(3100),
    [anon_sym_short] = ACTIONS(3100),
    [sym_primitive_type] = ACTIONS(3100),
    [anon_sym_enum] = ACTIONS(3100),
    [anon_sym_struct] = ACTIONS(3100),
    [anon_sym_union] = ACTIONS(3100),
    [anon_sym_if] = ACTIONS(3100),
    [anon_sym_switch] = ACTIONS(3100),
    [anon_sym_case] = ACTIONS(3100),
    [anon_sym_default] = ACTIONS(3100),
    [anon_sym_while] = ACTIONS(3100),
    [anon_sym_do] = ACTIONS(3100),
    [anon_sym_for] = ACTIONS(3100),
    [anon_sym_return] = ACTIONS(3100),
    [anon_sym_break] = ACTIONS(3100),
    [anon_sym_continue] = ACTIONS(3100),
    [anon_sym_goto] = ACTIONS(3100),
    [anon_sym_AMP] = ACTIONS(3098),
    [anon_sym_BANG] = ACTIONS(3098),
    [anon_sym_TILDE] = ACTIONS(3098),
    [anon_sym_PLUS] = ACTIONS(3100),
    [anon_sym_DASH] = ACTIONS(3100),
    [anon_sym_DASH_DASH] = ACTIONS(3098),
    [anon_sym_PLUS_PLUS] = ACTIONS(3098),
    [anon_sym_sizeof] = ACTIONS(3100),
    [sym_number_literal] = ACTIONS(3098),
    [sym_char_literal] = ACTIONS(3098),
    [sym_string_literal] = ACTIONS(3098),
    [sym_true] = ACTIONS(3100),
    [sym_false] = ACTIONS(3100),
    [sym_null] = ACTIONS(3100),
    [sym_identifier] = ACTIONS(3100),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(3100),
    [sym_auto] = ACTIONS(3100),
    [anon_sym_typename] = ACTIONS(3100),
    [anon_sym_new] = ACTIONS(3100),
    [anon_sym_COLON_COLON] = ACTIONS(3098),
    [anon_sym_delete] = ACTIONS(3100),
    [sym_nullptr] = ACTIONS(3100),
  },
  [1969] = {
    [sym_raw_string_literal] = ACTIONS(3102),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3104),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3104),
    [anon_sym_LPAREN] = ACTIONS(3102),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3104),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3104),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3104),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3104),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(3104),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(3104),
    [sym_preproc_directive] = ACTIONS(3104),
    [anon_sym_SEMI] = ACTIONS(3102),
    [anon_sym_typedef] = ACTIONS(3104),
    [anon_sym_extern] = ACTIONS(3104),
    [anon_sym_LBRACE] = ACTIONS(3102),
    [anon_sym_STAR] = ACTIONS(3102),
    [anon_sym_LBRACK] = ACTIONS(3102),
    [anon_sym_static] = ACTIONS(3104),
    [anon_sym_register] = ACTIONS(3104),
    [anon_sym_inline] = ACTIONS(3104),
    [anon_sym_const] = ACTIONS(3104),
    [anon_sym_restrict] = ACTIONS(3104),
    [anon_sym_volatile] = ACTIONS(3104),
    [anon_sym__Atomic] = ACTIONS(3104),
    [anon_sym_mutable] = ACTIONS(3104),
    [anon_sym_explicit] = ACTIONS(3104),
    [anon_sym_constexpr] = ACTIONS(3104),
    [anon_sym_unsigned] = ACTIONS(3104),
    [anon_sym_long] = ACTIONS(3104),
    [anon_sym_short] = ACTIONS(3104),
    [sym_primitive_type] = ACTIONS(3104),
    [anon_sym_enum] = ACTIONS(3104),
    [anon_sym_struct] = ACTIONS(3104),
    [anon_sym_union] = ACTIONS(3104),
    [anon_sym_if] = ACTIONS(3104),
    [anon_sym_switch] = ACTIONS(3104),
    [anon_sym_case] = ACTIONS(3104),
    [anon_sym_default] = ACTIONS(3104),
    [anon_sym_while] = ACTIONS(3104),
    [anon_sym_do] = ACTIONS(3104),
    [anon_sym_for] = ACTIONS(3104),
    [anon_sym_return] = ACTIONS(3104),
    [anon_sym_break] = ACTIONS(3104),
    [anon_sym_continue] = ACTIONS(3104),
    [anon_sym_goto] = ACTIONS(3104),
    [anon_sym_AMP] = ACTIONS(3102),
    [anon_sym_BANG] = ACTIONS(3102),
    [anon_sym_TILDE] = ACTIONS(3102),
    [anon_sym_PLUS] = ACTIONS(3104),
    [anon_sym_DASH] = ACTIONS(3104),
    [anon_sym_DASH_DASH] = ACTIONS(3102),
    [anon_sym_PLUS_PLUS] = ACTIONS(3102),
    [anon_sym_sizeof] = ACTIONS(3104),
    [sym_number_literal] = ACTIONS(3102),
    [sym_char_literal] = ACTIONS(3102),
    [sym_string_literal] = ACTIONS(3102),
    [sym_true] = ACTIONS(3104),
    [sym_false] = ACTIONS(3104),
    [sym_null] = ACTIONS(3104),
    [sym_identifier] = ACTIONS(3104),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(3104),
    [sym_auto] = ACTIONS(3104),
    [anon_sym_typename] = ACTIONS(3104),
    [anon_sym_new] = ACTIONS(3104),
    [anon_sym_COLON_COLON] = ACTIONS(3102),
    [anon_sym_delete] = ACTIONS(3104),
    [sym_nullptr] = ACTIONS(3104),
  },
  [1970] = {
    [anon_sym_SEMI] = ACTIONS(5395),
    [sym_comment] = ACTIONS(49),
  },
  [1971] = {
    [sym_compound_statement] = STATE(2343),
    [sym_labeled_statement] = STATE(2343),
    [sym_expression_statement] = STATE(2343),
    [sym_if_statement] = STATE(2343),
    [sym_switch_statement] = STATE(2343),
    [sym_case_statement] = STATE(2343),
    [sym_while_statement] = STATE(2343),
    [sym_do_statement] = STATE(2343),
    [sym_for_statement] = STATE(2343),
    [sym_return_statement] = STATE(2343),
    [sym_break_statement] = STATE(2343),
    [sym_continue_statement] = STATE(2343),
    [sym_goto_statement] = STATE(2343),
    [sym__expression] = STATE(1419),
    [sym_comma_expression] = STATE(1420),
    [sym_conditional_expression] = STATE(1419),
    [sym_assignment_expression] = STATE(1419),
    [sym_pointer_expression] = STATE(1419),
    [sym_logical_expression] = STATE(1419),
    [sym_bitwise_expression] = STATE(1419),
    [sym_equality_expression] = STATE(1419),
    [sym_relational_expression] = STATE(1419),
    [sym_shift_expression] = STATE(1419),
    [sym_math_expression] = STATE(1419),
    [sym_cast_expression] = STATE(1419),
    [sym_sizeof_expression] = STATE(1419),
    [sym_subscript_expression] = STATE(1419),
    [sym_call_expression] = STATE(1419),
    [sym_field_expression] = STATE(1419),
    [sym_compound_literal_expression] = STATE(1419),
    [sym_parenthesized_expression] = STATE(1419),
    [sym_concatenated_string] = STATE(1419),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(1419),
    [sym_for_range_loop] = STATE(2343),
    [sym_new_expression] = STATE(1419),
    [sym_delete_expression] = STATE(1419),
    [sym_lambda_expression] = STATE(1419),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(2879),
    [anon_sym_LPAREN] = ACTIONS(626),
    [anon_sym_SEMI] = ACTIONS(2899),
    [anon_sym_LBRACE] = ACTIONS(2903),
    [anon_sym_STAR] = ACTIONS(644),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_if] = ACTIONS(2905),
    [anon_sym_switch] = ACTIONS(2907),
    [anon_sym_case] = ACTIONS(2909),
    [anon_sym_default] = ACTIONS(2911),
    [anon_sym_while] = ACTIONS(2913),
    [anon_sym_do] = ACTIONS(2915),
    [anon_sym_for] = ACTIONS(2917),
    [anon_sym_return] = ACTIONS(2919),
    [anon_sym_break] = ACTIONS(2921),
    [anon_sym_continue] = ACTIONS(2923),
    [anon_sym_goto] = ACTIONS(2925),
    [anon_sym_AMP] = ACTIONS(644),
    [anon_sym_BANG] = ACTIONS(668),
    [anon_sym_TILDE] = ACTIONS(670),
    [anon_sym_PLUS] = ACTIONS(672),
    [anon_sym_DASH] = ACTIONS(672),
    [anon_sym_DASH_DASH] = ACTIONS(674),
    [anon_sym_PLUS_PLUS] = ACTIONS(674),
    [anon_sym_sizeof] = ACTIONS(676),
    [sym_number_literal] = ACTIONS(2879),
    [sym_char_literal] = ACTIONS(2879),
    [sym_string_literal] = ACTIONS(678),
    [sym_true] = ACTIONS(2927),
    [sym_false] = ACTIONS(2927),
    [sym_null] = ACTIONS(2927),
    [sym_identifier] = ACTIONS(5397),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1303),
    [anon_sym_delete] = ACTIONS(686),
    [sym_nullptr] = ACTIONS(2927),
  },
  [1972] = {
    [sym_raw_string_literal] = ACTIONS(5399),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(5401),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(5401),
    [anon_sym_LPAREN] = ACTIONS(5399),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(5401),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(5401),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(5401),
    [sym_preproc_directive] = ACTIONS(5401),
    [anon_sym_SEMI] = ACTIONS(5399),
    [anon_sym_typedef] = ACTIONS(5401),
    [anon_sym_extern] = ACTIONS(5401),
    [anon_sym_LBRACE] = ACTIONS(5399),
    [anon_sym_RBRACE] = ACTIONS(5399),
    [anon_sym_STAR] = ACTIONS(5399),
    [anon_sym_LBRACK] = ACTIONS(5399),
    [anon_sym_static] = ACTIONS(5401),
    [anon_sym_register] = ACTIONS(5401),
    [anon_sym_inline] = ACTIONS(5401),
    [anon_sym_const] = ACTIONS(5401),
    [anon_sym_restrict] = ACTIONS(5401),
    [anon_sym_volatile] = ACTIONS(5401),
    [anon_sym__Atomic] = ACTIONS(5401),
    [anon_sym_mutable] = ACTIONS(5401),
    [anon_sym_explicit] = ACTIONS(5401),
    [anon_sym_constexpr] = ACTIONS(5401),
    [anon_sym_unsigned] = ACTIONS(5401),
    [anon_sym_long] = ACTIONS(5401),
    [anon_sym_short] = ACTIONS(5401),
    [sym_primitive_type] = ACTIONS(5401),
    [anon_sym_enum] = ACTIONS(5401),
    [anon_sym_struct] = ACTIONS(5401),
    [anon_sym_union] = ACTIONS(5401),
    [anon_sym_if] = ACTIONS(5401),
    [anon_sym_switch] = ACTIONS(5401),
    [anon_sym_case] = ACTIONS(5401),
    [anon_sym_default] = ACTIONS(5401),
    [anon_sym_while] = ACTIONS(5401),
    [anon_sym_do] = ACTIONS(5401),
    [anon_sym_for] = ACTIONS(5401),
    [anon_sym_return] = ACTIONS(5401),
    [anon_sym_break] = ACTIONS(5401),
    [anon_sym_continue] = ACTIONS(5401),
    [anon_sym_goto] = ACTIONS(5401),
    [anon_sym_AMP] = ACTIONS(5399),
    [anon_sym_BANG] = ACTIONS(5399),
    [anon_sym_TILDE] = ACTIONS(5399),
    [anon_sym_PLUS] = ACTIONS(5401),
    [anon_sym_DASH] = ACTIONS(5401),
    [anon_sym_DASH_DASH] = ACTIONS(5399),
    [anon_sym_PLUS_PLUS] = ACTIONS(5399),
    [anon_sym_sizeof] = ACTIONS(5401),
    [sym_number_literal] = ACTIONS(5399),
    [sym_char_literal] = ACTIONS(5399),
    [sym_string_literal] = ACTIONS(5399),
    [sym_true] = ACTIONS(5401),
    [sym_false] = ACTIONS(5401),
    [sym_null] = ACTIONS(5401),
    [sym_identifier] = ACTIONS(5401),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(5401),
    [sym_auto] = ACTIONS(5401),
    [anon_sym_typename] = ACTIONS(5401),
    [anon_sym_new] = ACTIONS(5401),
    [anon_sym_COLON_COLON] = ACTIONS(5399),
    [anon_sym_delete] = ACTIONS(5401),
    [sym_nullptr] = ACTIONS(5401),
  },
  [1973] = {
    [sym_raw_string_literal] = ACTIONS(5403),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(5405),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(5405),
    [anon_sym_LPAREN] = ACTIONS(5403),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(5405),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(5405),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(5405),
    [sym_preproc_directive] = ACTIONS(5405),
    [anon_sym_SEMI] = ACTIONS(5403),
    [anon_sym_typedef] = ACTIONS(5405),
    [anon_sym_extern] = ACTIONS(5405),
    [anon_sym_LBRACE] = ACTIONS(5403),
    [anon_sym_RBRACE] = ACTIONS(5403),
    [anon_sym_STAR] = ACTIONS(5403),
    [anon_sym_LBRACK] = ACTIONS(5403),
    [anon_sym_static] = ACTIONS(5405),
    [anon_sym_register] = ACTIONS(5405),
    [anon_sym_inline] = ACTIONS(5405),
    [anon_sym_const] = ACTIONS(5405),
    [anon_sym_restrict] = ACTIONS(5405),
    [anon_sym_volatile] = ACTIONS(5405),
    [anon_sym__Atomic] = ACTIONS(5405),
    [anon_sym_mutable] = ACTIONS(5405),
    [anon_sym_explicit] = ACTIONS(5405),
    [anon_sym_constexpr] = ACTIONS(5405),
    [anon_sym_unsigned] = ACTIONS(5405),
    [anon_sym_long] = ACTIONS(5405),
    [anon_sym_short] = ACTIONS(5405),
    [sym_primitive_type] = ACTIONS(5405),
    [anon_sym_enum] = ACTIONS(5405),
    [anon_sym_struct] = ACTIONS(5405),
    [anon_sym_union] = ACTIONS(5405),
    [anon_sym_if] = ACTIONS(5405),
    [anon_sym_switch] = ACTIONS(5405),
    [anon_sym_case] = ACTIONS(5405),
    [anon_sym_default] = ACTIONS(5405),
    [anon_sym_while] = ACTIONS(5405),
    [anon_sym_do] = ACTIONS(5405),
    [anon_sym_for] = ACTIONS(5405),
    [anon_sym_return] = ACTIONS(5405),
    [anon_sym_break] = ACTIONS(5405),
    [anon_sym_continue] = ACTIONS(5405),
    [anon_sym_goto] = ACTIONS(5405),
    [anon_sym_AMP] = ACTIONS(5403),
    [anon_sym_BANG] = ACTIONS(5403),
    [anon_sym_TILDE] = ACTIONS(5403),
    [anon_sym_PLUS] = ACTIONS(5405),
    [anon_sym_DASH] = ACTIONS(5405),
    [anon_sym_DASH_DASH] = ACTIONS(5403),
    [anon_sym_PLUS_PLUS] = ACTIONS(5403),
    [anon_sym_sizeof] = ACTIONS(5405),
    [sym_number_literal] = ACTIONS(5403),
    [sym_char_literal] = ACTIONS(5403),
    [sym_string_literal] = ACTIONS(5403),
    [sym_true] = ACTIONS(5405),
    [sym_false] = ACTIONS(5405),
    [sym_null] = ACTIONS(5405),
    [sym_identifier] = ACTIONS(5405),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(5405),
    [sym_auto] = ACTIONS(5405),
    [anon_sym_typename] = ACTIONS(5405),
    [anon_sym_new] = ACTIONS(5405),
    [anon_sym_COLON_COLON] = ACTIONS(5403),
    [anon_sym_delete] = ACTIONS(5405),
    [sym_nullptr] = ACTIONS(5405),
  },
  [1974] = {
    [sym_raw_string_literal] = ACTIONS(522),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(524),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(524),
    [anon_sym_LPAREN] = ACTIONS(522),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(524),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(524),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(524),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(524),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(524),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(524),
    [sym_preproc_directive] = ACTIONS(524),
    [anon_sym_SEMI] = ACTIONS(522),
    [anon_sym_typedef] = ACTIONS(524),
    [anon_sym_extern] = ACTIONS(524),
    [anon_sym_LBRACE] = ACTIONS(522),
    [anon_sym_STAR] = ACTIONS(522),
    [anon_sym_LBRACK] = ACTIONS(522),
    [anon_sym_static] = ACTIONS(524),
    [anon_sym_register] = ACTIONS(524),
    [anon_sym_inline] = ACTIONS(524),
    [anon_sym_const] = ACTIONS(524),
    [anon_sym_restrict] = ACTIONS(524),
    [anon_sym_volatile] = ACTIONS(524),
    [anon_sym__Atomic] = ACTIONS(524),
    [anon_sym_mutable] = ACTIONS(524),
    [anon_sym_explicit] = ACTIONS(524),
    [anon_sym_constexpr] = ACTIONS(524),
    [anon_sym_unsigned] = ACTIONS(524),
    [anon_sym_long] = ACTIONS(524),
    [anon_sym_short] = ACTIONS(524),
    [sym_primitive_type] = ACTIONS(524),
    [anon_sym_enum] = ACTIONS(524),
    [anon_sym_struct] = ACTIONS(524),
    [anon_sym_union] = ACTIONS(524),
    [anon_sym_if] = ACTIONS(524),
    [anon_sym_switch] = ACTIONS(524),
    [anon_sym_case] = ACTIONS(524),
    [anon_sym_default] = ACTIONS(524),
    [anon_sym_while] = ACTIONS(524),
    [anon_sym_do] = ACTIONS(524),
    [anon_sym_for] = ACTIONS(524),
    [anon_sym_return] = ACTIONS(524),
    [anon_sym_break] = ACTIONS(524),
    [anon_sym_continue] = ACTIONS(524),
    [anon_sym_goto] = ACTIONS(524),
    [anon_sym_AMP] = ACTIONS(522),
    [anon_sym_BANG] = ACTIONS(522),
    [anon_sym_TILDE] = ACTIONS(522),
    [anon_sym_PLUS] = ACTIONS(524),
    [anon_sym_DASH] = ACTIONS(524),
    [anon_sym_DASH_DASH] = ACTIONS(522),
    [anon_sym_PLUS_PLUS] = ACTIONS(522),
    [anon_sym_sizeof] = ACTIONS(524),
    [sym_number_literal] = ACTIONS(522),
    [sym_char_literal] = ACTIONS(522),
    [sym_string_literal] = ACTIONS(522),
    [sym_true] = ACTIONS(524),
    [sym_false] = ACTIONS(524),
    [sym_null] = ACTIONS(524),
    [sym_identifier] = ACTIONS(524),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(524),
    [sym_auto] = ACTIONS(524),
    [anon_sym_typename] = ACTIONS(524),
    [anon_sym_new] = ACTIONS(524),
    [anon_sym_COLON_COLON] = ACTIONS(522),
    [anon_sym_delete] = ACTIONS(524),
    [sym_nullptr] = ACTIONS(524),
  },
  [1975] = {
    [sym_parameter_list] = STATE(332),
    [sym_argument_list] = STATE(333),
    [sym_initializer_list] = STATE(333),
    [aux_sym_declaration_repeat1] = STATE(2345),
    [anon_sym_LPAREN] = ACTIONS(536),
    [anon_sym_COMMA] = ACTIONS(538),
    [anon_sym_SEMI] = ACTIONS(5407),
    [anon_sym_LBRACE] = ACTIONS(548),
    [anon_sym_LBRACK] = ACTIONS(208),
    [anon_sym_EQ] = ACTIONS(544),
    [sym_comment] = ACTIONS(49),
  },
  [1976] = {
    [aux_sym_declaration_repeat1] = STATE(2345),
    [anon_sym_COMMA] = ACTIONS(538),
    [anon_sym_SEMI] = ACTIONS(5407),
    [sym_comment] = ACTIONS(49),
  },
  [1977] = {
    [sym_argument_list] = STATE(2347),
    [sym_initializer_list] = STATE(2347),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_LBRACE] = ACTIONS(548),
    [anon_sym_EQ] = ACTIONS(5409),
    [sym_comment] = ACTIONS(49),
  },
  [1978] = {
    [sym_argument_list] = STATE(2349),
    [sym_initializer_list] = STATE(2349),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_LBRACE] = ACTIONS(548),
    [anon_sym_EQ] = ACTIONS(5411),
    [sym_comment] = ACTIONS(49),
  },
  [1979] = {
    [sym_raw_string_literal] = ACTIONS(3132),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3134),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3134),
    [anon_sym_LPAREN] = ACTIONS(3132),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3134),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3134),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3134),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3134),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(3134),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(3134),
    [sym_preproc_directive] = ACTIONS(3134),
    [anon_sym_SEMI] = ACTIONS(3132),
    [anon_sym_typedef] = ACTIONS(3134),
    [anon_sym_extern] = ACTIONS(3134),
    [anon_sym_LBRACE] = ACTIONS(3132),
    [anon_sym_STAR] = ACTIONS(3132),
    [anon_sym_LBRACK] = ACTIONS(3132),
    [anon_sym_static] = ACTIONS(3134),
    [anon_sym_register] = ACTIONS(3134),
    [anon_sym_inline] = ACTIONS(3134),
    [anon_sym_const] = ACTIONS(3134),
    [anon_sym_restrict] = ACTIONS(3134),
    [anon_sym_volatile] = ACTIONS(3134),
    [anon_sym__Atomic] = ACTIONS(3134),
    [anon_sym_mutable] = ACTIONS(3134),
    [anon_sym_explicit] = ACTIONS(3134),
    [anon_sym_constexpr] = ACTIONS(3134),
    [anon_sym_unsigned] = ACTIONS(3134),
    [anon_sym_long] = ACTIONS(3134),
    [anon_sym_short] = ACTIONS(3134),
    [sym_primitive_type] = ACTIONS(3134),
    [anon_sym_enum] = ACTIONS(3134),
    [anon_sym_struct] = ACTIONS(3134),
    [anon_sym_union] = ACTIONS(3134),
    [anon_sym_if] = ACTIONS(3134),
    [anon_sym_switch] = ACTIONS(3134),
    [anon_sym_case] = ACTIONS(3134),
    [anon_sym_default] = ACTIONS(3134),
    [anon_sym_while] = ACTIONS(3134),
    [anon_sym_do] = ACTIONS(3134),
    [anon_sym_for] = ACTIONS(3134),
    [anon_sym_return] = ACTIONS(3134),
    [anon_sym_break] = ACTIONS(3134),
    [anon_sym_continue] = ACTIONS(3134),
    [anon_sym_goto] = ACTIONS(3134),
    [anon_sym_AMP] = ACTIONS(3132),
    [anon_sym_BANG] = ACTIONS(3132),
    [anon_sym_TILDE] = ACTIONS(3132),
    [anon_sym_PLUS] = ACTIONS(3134),
    [anon_sym_DASH] = ACTIONS(3134),
    [anon_sym_DASH_DASH] = ACTIONS(3132),
    [anon_sym_PLUS_PLUS] = ACTIONS(3132),
    [anon_sym_sizeof] = ACTIONS(3134),
    [sym_number_literal] = ACTIONS(3132),
    [sym_char_literal] = ACTIONS(3132),
    [sym_string_literal] = ACTIONS(3132),
    [sym_true] = ACTIONS(3134),
    [sym_false] = ACTIONS(3134),
    [sym_null] = ACTIONS(3134),
    [sym_identifier] = ACTIONS(3134),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(3134),
    [sym_auto] = ACTIONS(3134),
    [anon_sym_typename] = ACTIONS(3134),
    [anon_sym_new] = ACTIONS(3134),
    [anon_sym_COLON_COLON] = ACTIONS(3132),
    [anon_sym_delete] = ACTIONS(3134),
    [sym_nullptr] = ACTIONS(3134),
  },
  [1980] = {
    [sym_raw_string_literal] = ACTIONS(5413),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(5415),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(5415),
    [anon_sym_LPAREN] = ACTIONS(5413),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(5415),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(5415),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(5415),
    [sym_preproc_directive] = ACTIONS(5415),
    [anon_sym_SEMI] = ACTIONS(5413),
    [anon_sym_typedef] = ACTIONS(5415),
    [anon_sym_extern] = ACTIONS(5415),
    [anon_sym_LBRACE] = ACTIONS(5413),
    [anon_sym_RBRACE] = ACTIONS(5413),
    [anon_sym_STAR] = ACTIONS(5413),
    [anon_sym_LBRACK] = ACTIONS(5413),
    [anon_sym_static] = ACTIONS(5415),
    [anon_sym_register] = ACTIONS(5415),
    [anon_sym_inline] = ACTIONS(5415),
    [anon_sym_const] = ACTIONS(5415),
    [anon_sym_restrict] = ACTIONS(5415),
    [anon_sym_volatile] = ACTIONS(5415),
    [anon_sym__Atomic] = ACTIONS(5415),
    [anon_sym_mutable] = ACTIONS(5415),
    [anon_sym_explicit] = ACTIONS(5415),
    [anon_sym_constexpr] = ACTIONS(5415),
    [anon_sym_unsigned] = ACTIONS(5415),
    [anon_sym_long] = ACTIONS(5415),
    [anon_sym_short] = ACTIONS(5415),
    [sym_primitive_type] = ACTIONS(5415),
    [anon_sym_enum] = ACTIONS(5415),
    [anon_sym_struct] = ACTIONS(5415),
    [anon_sym_union] = ACTIONS(5415),
    [anon_sym_if] = ACTIONS(5415),
    [anon_sym_switch] = ACTIONS(5415),
    [anon_sym_case] = ACTIONS(5415),
    [anon_sym_default] = ACTIONS(5415),
    [anon_sym_while] = ACTIONS(5415),
    [anon_sym_do] = ACTIONS(5415),
    [anon_sym_for] = ACTIONS(5415),
    [anon_sym_return] = ACTIONS(5415),
    [anon_sym_break] = ACTIONS(5415),
    [anon_sym_continue] = ACTIONS(5415),
    [anon_sym_goto] = ACTIONS(5415),
    [anon_sym_AMP] = ACTIONS(5413),
    [anon_sym_BANG] = ACTIONS(5413),
    [anon_sym_TILDE] = ACTIONS(5413),
    [anon_sym_PLUS] = ACTIONS(5415),
    [anon_sym_DASH] = ACTIONS(5415),
    [anon_sym_DASH_DASH] = ACTIONS(5413),
    [anon_sym_PLUS_PLUS] = ACTIONS(5413),
    [anon_sym_sizeof] = ACTIONS(5415),
    [sym_number_literal] = ACTIONS(5413),
    [sym_char_literal] = ACTIONS(5413),
    [sym_string_literal] = ACTIONS(5413),
    [sym_true] = ACTIONS(5415),
    [sym_false] = ACTIONS(5415),
    [sym_null] = ACTIONS(5415),
    [sym_identifier] = ACTIONS(5415),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(5415),
    [sym_auto] = ACTIONS(5415),
    [anon_sym_typename] = ACTIONS(5415),
    [anon_sym_new] = ACTIONS(5415),
    [anon_sym_COLON_COLON] = ACTIONS(5413),
    [anon_sym_delete] = ACTIONS(5415),
    [sym_nullptr] = ACTIONS(5415),
  },
  [1981] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(5417),
    [sym_comment] = ACTIONS(49),
  },
  [1982] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(5419),
    [sym_comment] = ACTIONS(49),
  },
  [1983] = {
    [sym_preproc_include] = STATE(1983),
    [sym_preproc_def] = STATE(1983),
    [sym_preproc_function_def] = STATE(1983),
    [sym_preproc_call] = STATE(1983),
    [sym_preproc_if_in_compound_statement] = STATE(1414),
    [sym_preproc_ifdef_in_compound_statement] = STATE(1415),
    [sym_declaration] = STATE(1983),
    [sym_type_definition] = STATE(1983),
    [sym__declaration_specifiers] = STATE(1418),
    [sym_compound_statement] = STATE(1983),
    [sym_storage_class_specifier] = STATE(419),
    [sym_type_qualifier] = STATE(419),
    [sym__type_specifier] = STATE(30),
    [sym_sized_type_specifier] = STATE(30),
    [sym_enum_specifier] = STATE(30),
    [sym_struct_specifier] = STATE(30),
    [sym_union_specifier] = STATE(30),
    [sym_labeled_statement] = STATE(1983),
    [sym_expression_statement] = STATE(1983),
    [sym_if_statement] = STATE(1983),
    [sym_switch_statement] = STATE(1983),
    [sym_case_statement] = STATE(1983),
    [sym_while_statement] = STATE(1983),
    [sym_do_statement] = STATE(1983),
    [sym_for_statement] = STATE(1983),
    [sym_return_statement] = STATE(1983),
    [sym_break_statement] = STATE(1983),
    [sym_continue_statement] = STATE(1983),
    [sym_goto_statement] = STATE(1983),
    [sym__expression] = STATE(1419),
    [sym_comma_expression] = STATE(1420),
    [sym_conditional_expression] = STATE(1419),
    [sym_assignment_expression] = STATE(1419),
    [sym_pointer_expression] = STATE(1419),
    [sym_logical_expression] = STATE(1419),
    [sym_bitwise_expression] = STATE(1419),
    [sym_equality_expression] = STATE(1419),
    [sym_relational_expression] = STATE(1419),
    [sym_shift_expression] = STATE(1419),
    [sym_math_expression] = STATE(1419),
    [sym_cast_expression] = STATE(1419),
    [sym_sizeof_expression] = STATE(1419),
    [sym_subscript_expression] = STATE(1419),
    [sym_call_expression] = STATE(1419),
    [sym_field_expression] = STATE(1419),
    [sym_compound_literal_expression] = STATE(1419),
    [sym_parenthesized_expression] = STATE(1419),
    [sym_concatenated_string] = STATE(1419),
    [sym__empty_declaration] = STATE(1983),
    [sym_macro_type_specifier] = STATE(30),
    [sym_class_specifier] = STATE(30),
    [sym_dependent_type] = STATE(30),
    [sym_structured_binding_declaration] = STATE(1983),
    [sym_template_type] = STATE(415),
    [sym_template_function] = STATE(1419),
    [sym_for_range_loop] = STATE(1983),
    [sym_new_expression] = STATE(1419),
    [sym_delete_expression] = STATE(1419),
    [sym_lambda_expression] = STATE(1419),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(416),
    [sym_scoped_namespace_identifier] = STATE(417),
    [aux_sym_preproc_if_in_compound_statement_repeat1] = STATE(1983),
    [aux_sym__declaration_specifiers_repeat1] = STATE(419),
    [aux_sym_sized_type_specifier_repeat1] = STATE(38),
    [sym_raw_string_literal] = ACTIONS(5421),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(5424),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(5427),
    [anon_sym_LPAREN] = ACTIONS(3195),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(5430),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(5433),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(5435),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(5438),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(5433),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(5433),
    [sym_preproc_directive] = ACTIONS(5441),
    [anon_sym_SEMI] = ACTIONS(5444),
    [anon_sym_typedef] = ACTIONS(5447),
    [anon_sym_extern] = ACTIONS(3216),
    [anon_sym_LBRACE] = ACTIONS(5450),
    [anon_sym_STAR] = ACTIONS(3224),
    [anon_sym_LBRACK] = ACTIONS(3227),
    [anon_sym_static] = ACTIONS(3216),
    [anon_sym_register] = ACTIONS(3216),
    [anon_sym_inline] = ACTIONS(3216),
    [anon_sym_const] = ACTIONS(3230),
    [anon_sym_restrict] = ACTIONS(3230),
    [anon_sym_volatile] = ACTIONS(3230),
    [anon_sym__Atomic] = ACTIONS(3230),
    [anon_sym_mutable] = ACTIONS(3230),
    [anon_sym_explicit] = ACTIONS(3230),
    [anon_sym_constexpr] = ACTIONS(3230),
    [anon_sym_unsigned] = ACTIONS(3233),
    [anon_sym_long] = ACTIONS(3233),
    [anon_sym_short] = ACTIONS(3233),
    [sym_primitive_type] = ACTIONS(3236),
    [anon_sym_enum] = ACTIONS(3239),
    [anon_sym_struct] = ACTIONS(3242),
    [anon_sym_union] = ACTIONS(3245),
    [anon_sym_if] = ACTIONS(5453),
    [anon_sym_switch] = ACTIONS(5456),
    [anon_sym_case] = ACTIONS(5459),
    [anon_sym_default] = ACTIONS(5462),
    [anon_sym_while] = ACTIONS(5465),
    [anon_sym_do] = ACTIONS(5468),
    [anon_sym_for] = ACTIONS(5471),
    [anon_sym_return] = ACTIONS(5474),
    [anon_sym_break] = ACTIONS(5477),
    [anon_sym_continue] = ACTIONS(5480),
    [anon_sym_goto] = ACTIONS(5483),
    [anon_sym_AMP] = ACTIONS(3224),
    [anon_sym_BANG] = ACTIONS(3281),
    [anon_sym_TILDE] = ACTIONS(3284),
    [anon_sym_PLUS] = ACTIONS(3287),
    [anon_sym_DASH] = ACTIONS(3287),
    [anon_sym_DASH_DASH] = ACTIONS(3290),
    [anon_sym_PLUS_PLUS] = ACTIONS(3290),
    [anon_sym_sizeof] = ACTIONS(3293),
    [sym_number_literal] = ACTIONS(5421),
    [sym_char_literal] = ACTIONS(5421),
    [sym_string_literal] = ACTIONS(3296),
    [sym_true] = ACTIONS(5486),
    [sym_false] = ACTIONS(5486),
    [sym_null] = ACTIONS(5486),
    [sym_identifier] = ACTIONS(5489),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(3305),
    [sym_auto] = ACTIONS(3236),
    [anon_sym_typename] = ACTIONS(3308),
    [anon_sym_new] = ACTIONS(3311),
    [anon_sym_COLON_COLON] = ACTIONS(3314),
    [anon_sym_delete] = ACTIONS(3317),
    [sym_nullptr] = ACTIONS(5486),
  },
  [1984] = {
    [sym_raw_string_literal] = ACTIONS(5492),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(5494),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(5494),
    [anon_sym_LPAREN] = ACTIONS(5492),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(5494),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(5494),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(5494),
    [sym_preproc_directive] = ACTIONS(5494),
    [anon_sym_SEMI] = ACTIONS(5492),
    [anon_sym_typedef] = ACTIONS(5494),
    [anon_sym_extern] = ACTIONS(5494),
    [anon_sym_LBRACE] = ACTIONS(5492),
    [anon_sym_RBRACE] = ACTIONS(5492),
    [anon_sym_STAR] = ACTIONS(5492),
    [anon_sym_LBRACK] = ACTIONS(5492),
    [anon_sym_static] = ACTIONS(5494),
    [anon_sym_register] = ACTIONS(5494),
    [anon_sym_inline] = ACTIONS(5494),
    [anon_sym_const] = ACTIONS(5494),
    [anon_sym_restrict] = ACTIONS(5494),
    [anon_sym_volatile] = ACTIONS(5494),
    [anon_sym__Atomic] = ACTIONS(5494),
    [anon_sym_mutable] = ACTIONS(5494),
    [anon_sym_explicit] = ACTIONS(5494),
    [anon_sym_constexpr] = ACTIONS(5494),
    [anon_sym_unsigned] = ACTIONS(5494),
    [anon_sym_long] = ACTIONS(5494),
    [anon_sym_short] = ACTIONS(5494),
    [sym_primitive_type] = ACTIONS(5494),
    [anon_sym_enum] = ACTIONS(5494),
    [anon_sym_struct] = ACTIONS(5494),
    [anon_sym_union] = ACTIONS(5494),
    [anon_sym_if] = ACTIONS(5494),
    [anon_sym_switch] = ACTIONS(5494),
    [anon_sym_case] = ACTIONS(5494),
    [anon_sym_default] = ACTIONS(5494),
    [anon_sym_while] = ACTIONS(5494),
    [anon_sym_do] = ACTIONS(5494),
    [anon_sym_for] = ACTIONS(5494),
    [anon_sym_return] = ACTIONS(5494),
    [anon_sym_break] = ACTIONS(5494),
    [anon_sym_continue] = ACTIONS(5494),
    [anon_sym_goto] = ACTIONS(5494),
    [anon_sym_AMP] = ACTIONS(5492),
    [anon_sym_BANG] = ACTIONS(5492),
    [anon_sym_TILDE] = ACTIONS(5492),
    [anon_sym_PLUS] = ACTIONS(5494),
    [anon_sym_DASH] = ACTIONS(5494),
    [anon_sym_DASH_DASH] = ACTIONS(5492),
    [anon_sym_PLUS_PLUS] = ACTIONS(5492),
    [anon_sym_sizeof] = ACTIONS(5494),
    [sym_number_literal] = ACTIONS(5492),
    [sym_char_literal] = ACTIONS(5492),
    [sym_string_literal] = ACTIONS(5492),
    [sym_true] = ACTIONS(5494),
    [sym_false] = ACTIONS(5494),
    [sym_null] = ACTIONS(5494),
    [sym_identifier] = ACTIONS(5494),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(5494),
    [sym_auto] = ACTIONS(5494),
    [anon_sym_typename] = ACTIONS(5494),
    [anon_sym_new] = ACTIONS(5494),
    [anon_sym_COLON_COLON] = ACTIONS(5492),
    [anon_sym_delete] = ACTIONS(5494),
    [sym_nullptr] = ACTIONS(5494),
  },
  [1985] = {
    [sym_raw_string_literal] = ACTIONS(5496),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(5498),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(5498),
    [anon_sym_LPAREN] = ACTIONS(5496),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(5498),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(5498),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(5498),
    [sym_preproc_directive] = ACTIONS(5498),
    [anon_sym_SEMI] = ACTIONS(5496),
    [anon_sym_typedef] = ACTIONS(5498),
    [anon_sym_extern] = ACTIONS(5498),
    [anon_sym_LBRACE] = ACTIONS(5496),
    [anon_sym_RBRACE] = ACTIONS(5496),
    [anon_sym_STAR] = ACTIONS(5496),
    [anon_sym_LBRACK] = ACTIONS(5496),
    [anon_sym_static] = ACTIONS(5498),
    [anon_sym_register] = ACTIONS(5498),
    [anon_sym_inline] = ACTIONS(5498),
    [anon_sym_const] = ACTIONS(5498),
    [anon_sym_restrict] = ACTIONS(5498),
    [anon_sym_volatile] = ACTIONS(5498),
    [anon_sym__Atomic] = ACTIONS(5498),
    [anon_sym_mutable] = ACTIONS(5498),
    [anon_sym_explicit] = ACTIONS(5498),
    [anon_sym_constexpr] = ACTIONS(5498),
    [anon_sym_unsigned] = ACTIONS(5498),
    [anon_sym_long] = ACTIONS(5498),
    [anon_sym_short] = ACTIONS(5498),
    [sym_primitive_type] = ACTIONS(5498),
    [anon_sym_enum] = ACTIONS(5498),
    [anon_sym_struct] = ACTIONS(5498),
    [anon_sym_union] = ACTIONS(5498),
    [anon_sym_if] = ACTIONS(5498),
    [anon_sym_switch] = ACTIONS(5498),
    [anon_sym_case] = ACTIONS(5498),
    [anon_sym_default] = ACTIONS(5498),
    [anon_sym_while] = ACTIONS(5498),
    [anon_sym_do] = ACTIONS(5498),
    [anon_sym_for] = ACTIONS(5498),
    [anon_sym_return] = ACTIONS(5498),
    [anon_sym_break] = ACTIONS(5498),
    [anon_sym_continue] = ACTIONS(5498),
    [anon_sym_goto] = ACTIONS(5498),
    [anon_sym_AMP] = ACTIONS(5496),
    [anon_sym_BANG] = ACTIONS(5496),
    [anon_sym_TILDE] = ACTIONS(5496),
    [anon_sym_PLUS] = ACTIONS(5498),
    [anon_sym_DASH] = ACTIONS(5498),
    [anon_sym_DASH_DASH] = ACTIONS(5496),
    [anon_sym_PLUS_PLUS] = ACTIONS(5496),
    [anon_sym_sizeof] = ACTIONS(5498),
    [sym_number_literal] = ACTIONS(5496),
    [sym_char_literal] = ACTIONS(5496),
    [sym_string_literal] = ACTIONS(5496),
    [sym_true] = ACTIONS(5498),
    [sym_false] = ACTIONS(5498),
    [sym_null] = ACTIONS(5498),
    [sym_identifier] = ACTIONS(5498),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(5498),
    [sym_auto] = ACTIONS(5498),
    [anon_sym_typename] = ACTIONS(5498),
    [anon_sym_new] = ACTIONS(5498),
    [anon_sym_COLON_COLON] = ACTIONS(5496),
    [anon_sym_delete] = ACTIONS(5498),
    [sym_nullptr] = ACTIONS(5498),
  },
  [1986] = {
    [sym_raw_string_literal] = ACTIONS(5500),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(5502),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(5502),
    [anon_sym_LPAREN] = ACTIONS(5500),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(5502),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(5502),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(5502),
    [sym_preproc_directive] = ACTIONS(5502),
    [anon_sym_SEMI] = ACTIONS(5500),
    [anon_sym_typedef] = ACTIONS(5502),
    [anon_sym_extern] = ACTIONS(5502),
    [anon_sym_LBRACE] = ACTIONS(5500),
    [anon_sym_RBRACE] = ACTIONS(5500),
    [anon_sym_STAR] = ACTIONS(5500),
    [anon_sym_LBRACK] = ACTIONS(5500),
    [anon_sym_static] = ACTIONS(5502),
    [anon_sym_register] = ACTIONS(5502),
    [anon_sym_inline] = ACTIONS(5502),
    [anon_sym_const] = ACTIONS(5502),
    [anon_sym_restrict] = ACTIONS(5502),
    [anon_sym_volatile] = ACTIONS(5502),
    [anon_sym__Atomic] = ACTIONS(5502),
    [anon_sym_mutable] = ACTIONS(5502),
    [anon_sym_explicit] = ACTIONS(5502),
    [anon_sym_constexpr] = ACTIONS(5502),
    [anon_sym_unsigned] = ACTIONS(5502),
    [anon_sym_long] = ACTIONS(5502),
    [anon_sym_short] = ACTIONS(5502),
    [sym_primitive_type] = ACTIONS(5502),
    [anon_sym_enum] = ACTIONS(5502),
    [anon_sym_struct] = ACTIONS(5502),
    [anon_sym_union] = ACTIONS(5502),
    [anon_sym_if] = ACTIONS(5502),
    [anon_sym_switch] = ACTIONS(5502),
    [anon_sym_case] = ACTIONS(5502),
    [anon_sym_default] = ACTIONS(5502),
    [anon_sym_while] = ACTIONS(5502),
    [anon_sym_do] = ACTIONS(5502),
    [anon_sym_for] = ACTIONS(5502),
    [anon_sym_return] = ACTIONS(5502),
    [anon_sym_break] = ACTIONS(5502),
    [anon_sym_continue] = ACTIONS(5502),
    [anon_sym_goto] = ACTIONS(5502),
    [anon_sym_AMP] = ACTIONS(5500),
    [anon_sym_BANG] = ACTIONS(5500),
    [anon_sym_TILDE] = ACTIONS(5500),
    [anon_sym_PLUS] = ACTIONS(5502),
    [anon_sym_DASH] = ACTIONS(5502),
    [anon_sym_DASH_DASH] = ACTIONS(5500),
    [anon_sym_PLUS_PLUS] = ACTIONS(5500),
    [anon_sym_sizeof] = ACTIONS(5502),
    [sym_number_literal] = ACTIONS(5500),
    [sym_char_literal] = ACTIONS(5500),
    [sym_string_literal] = ACTIONS(5500),
    [sym_true] = ACTIONS(5502),
    [sym_false] = ACTIONS(5502),
    [sym_null] = ACTIONS(5502),
    [sym_identifier] = ACTIONS(5502),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(5502),
    [sym_auto] = ACTIONS(5502),
    [anon_sym_typename] = ACTIONS(5502),
    [anon_sym_new] = ACTIONS(5502),
    [anon_sym_COLON_COLON] = ACTIONS(5500),
    [anon_sym_delete] = ACTIONS(5502),
    [sym_nullptr] = ACTIONS(5502),
  },
  [1987] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(5504),
    [sym_comment] = ACTIONS(49),
  },
  [1988] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(5506),
    [sym_comment] = ACTIONS(49),
  },
  [1989] = {
    [sym_raw_string_literal] = ACTIONS(5508),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(5510),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(5510),
    [anon_sym_LPAREN] = ACTIONS(5508),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(5510),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(5510),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(5510),
    [sym_preproc_directive] = ACTIONS(5510),
    [anon_sym_SEMI] = ACTIONS(5508),
    [anon_sym_typedef] = ACTIONS(5510),
    [anon_sym_extern] = ACTIONS(5510),
    [anon_sym_LBRACE] = ACTIONS(5508),
    [anon_sym_RBRACE] = ACTIONS(5508),
    [anon_sym_STAR] = ACTIONS(5508),
    [anon_sym_LBRACK] = ACTIONS(5508),
    [anon_sym_static] = ACTIONS(5510),
    [anon_sym_register] = ACTIONS(5510),
    [anon_sym_inline] = ACTIONS(5510),
    [anon_sym_const] = ACTIONS(5510),
    [anon_sym_restrict] = ACTIONS(5510),
    [anon_sym_volatile] = ACTIONS(5510),
    [anon_sym__Atomic] = ACTIONS(5510),
    [anon_sym_mutable] = ACTIONS(5510),
    [anon_sym_explicit] = ACTIONS(5510),
    [anon_sym_constexpr] = ACTIONS(5510),
    [anon_sym_unsigned] = ACTIONS(5510),
    [anon_sym_long] = ACTIONS(5510),
    [anon_sym_short] = ACTIONS(5510),
    [sym_primitive_type] = ACTIONS(5510),
    [anon_sym_enum] = ACTIONS(5510),
    [anon_sym_struct] = ACTIONS(5510),
    [anon_sym_union] = ACTIONS(5510),
    [anon_sym_if] = ACTIONS(5510),
    [anon_sym_switch] = ACTIONS(5510),
    [anon_sym_case] = ACTIONS(5510),
    [anon_sym_default] = ACTIONS(5510),
    [anon_sym_while] = ACTIONS(5510),
    [anon_sym_do] = ACTIONS(5510),
    [anon_sym_for] = ACTIONS(5510),
    [anon_sym_return] = ACTIONS(5510),
    [anon_sym_break] = ACTIONS(5510),
    [anon_sym_continue] = ACTIONS(5510),
    [anon_sym_goto] = ACTIONS(5510),
    [anon_sym_AMP] = ACTIONS(5508),
    [anon_sym_BANG] = ACTIONS(5508),
    [anon_sym_TILDE] = ACTIONS(5508),
    [anon_sym_PLUS] = ACTIONS(5510),
    [anon_sym_DASH] = ACTIONS(5510),
    [anon_sym_DASH_DASH] = ACTIONS(5508),
    [anon_sym_PLUS_PLUS] = ACTIONS(5508),
    [anon_sym_sizeof] = ACTIONS(5510),
    [sym_number_literal] = ACTIONS(5508),
    [sym_char_literal] = ACTIONS(5508),
    [sym_string_literal] = ACTIONS(5508),
    [sym_true] = ACTIONS(5510),
    [sym_false] = ACTIONS(5510),
    [sym_null] = ACTIONS(5510),
    [sym_identifier] = ACTIONS(5510),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(5510),
    [sym_auto] = ACTIONS(5510),
    [anon_sym_typename] = ACTIONS(5510),
    [anon_sym_new] = ACTIONS(5510),
    [anon_sym_COLON_COLON] = ACTIONS(5508),
    [anon_sym_delete] = ACTIONS(5510),
    [sym_nullptr] = ACTIONS(5510),
  },
  [1990] = {
    [sym_raw_string_literal] = ACTIONS(5512),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(5514),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(5514),
    [anon_sym_LPAREN] = ACTIONS(5512),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(5514),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(5514),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(5514),
    [sym_preproc_directive] = ACTIONS(5514),
    [anon_sym_SEMI] = ACTIONS(5512),
    [anon_sym_typedef] = ACTIONS(5514),
    [anon_sym_extern] = ACTIONS(5514),
    [anon_sym_LBRACE] = ACTIONS(5512),
    [anon_sym_RBRACE] = ACTIONS(5512),
    [anon_sym_STAR] = ACTIONS(5512),
    [anon_sym_LBRACK] = ACTIONS(5512),
    [anon_sym_static] = ACTIONS(5514),
    [anon_sym_register] = ACTIONS(5514),
    [anon_sym_inline] = ACTIONS(5514),
    [anon_sym_const] = ACTIONS(5514),
    [anon_sym_restrict] = ACTIONS(5514),
    [anon_sym_volatile] = ACTIONS(5514),
    [anon_sym__Atomic] = ACTIONS(5514),
    [anon_sym_mutable] = ACTIONS(5514),
    [anon_sym_explicit] = ACTIONS(5514),
    [anon_sym_constexpr] = ACTIONS(5514),
    [anon_sym_unsigned] = ACTIONS(5514),
    [anon_sym_long] = ACTIONS(5514),
    [anon_sym_short] = ACTIONS(5514),
    [sym_primitive_type] = ACTIONS(5514),
    [anon_sym_enum] = ACTIONS(5514),
    [anon_sym_struct] = ACTIONS(5514),
    [anon_sym_union] = ACTIONS(5514),
    [anon_sym_if] = ACTIONS(5514),
    [anon_sym_switch] = ACTIONS(5514),
    [anon_sym_case] = ACTIONS(5514),
    [anon_sym_default] = ACTIONS(5514),
    [anon_sym_while] = ACTIONS(5514),
    [anon_sym_do] = ACTIONS(5514),
    [anon_sym_for] = ACTIONS(5514),
    [anon_sym_return] = ACTIONS(5514),
    [anon_sym_break] = ACTIONS(5514),
    [anon_sym_continue] = ACTIONS(5514),
    [anon_sym_goto] = ACTIONS(5514),
    [anon_sym_AMP] = ACTIONS(5512),
    [anon_sym_BANG] = ACTIONS(5512),
    [anon_sym_TILDE] = ACTIONS(5512),
    [anon_sym_PLUS] = ACTIONS(5514),
    [anon_sym_DASH] = ACTIONS(5514),
    [anon_sym_DASH_DASH] = ACTIONS(5512),
    [anon_sym_PLUS_PLUS] = ACTIONS(5512),
    [anon_sym_sizeof] = ACTIONS(5514),
    [sym_number_literal] = ACTIONS(5512),
    [sym_char_literal] = ACTIONS(5512),
    [sym_string_literal] = ACTIONS(5512),
    [sym_true] = ACTIONS(5514),
    [sym_false] = ACTIONS(5514),
    [sym_null] = ACTIONS(5514),
    [sym_identifier] = ACTIONS(5514),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(5514),
    [sym_auto] = ACTIONS(5514),
    [anon_sym_typename] = ACTIONS(5514),
    [anon_sym_new] = ACTIONS(5514),
    [anon_sym_COLON_COLON] = ACTIONS(5512),
    [anon_sym_delete] = ACTIONS(5514),
    [sym_nullptr] = ACTIONS(5514),
  },
  [1991] = {
    [sym_raw_string_literal] = ACTIONS(5516),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(5518),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(5518),
    [anon_sym_LPAREN] = ACTIONS(5516),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(5518),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(5518),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(5518),
    [sym_preproc_directive] = ACTIONS(5518),
    [anon_sym_SEMI] = ACTIONS(5516),
    [anon_sym_typedef] = ACTIONS(5518),
    [anon_sym_extern] = ACTIONS(5518),
    [anon_sym_LBRACE] = ACTIONS(5516),
    [anon_sym_RBRACE] = ACTIONS(5516),
    [anon_sym_STAR] = ACTIONS(5516),
    [anon_sym_LBRACK] = ACTIONS(5516),
    [anon_sym_static] = ACTIONS(5518),
    [anon_sym_register] = ACTIONS(5518),
    [anon_sym_inline] = ACTIONS(5518),
    [anon_sym_const] = ACTIONS(5518),
    [anon_sym_restrict] = ACTIONS(5518),
    [anon_sym_volatile] = ACTIONS(5518),
    [anon_sym__Atomic] = ACTIONS(5518),
    [anon_sym_mutable] = ACTIONS(5518),
    [anon_sym_explicit] = ACTIONS(5518),
    [anon_sym_constexpr] = ACTIONS(5518),
    [anon_sym_unsigned] = ACTIONS(5518),
    [anon_sym_long] = ACTIONS(5518),
    [anon_sym_short] = ACTIONS(5518),
    [sym_primitive_type] = ACTIONS(5518),
    [anon_sym_enum] = ACTIONS(5518),
    [anon_sym_struct] = ACTIONS(5518),
    [anon_sym_union] = ACTIONS(5518),
    [anon_sym_if] = ACTIONS(5518),
    [anon_sym_switch] = ACTIONS(5518),
    [anon_sym_case] = ACTIONS(5518),
    [anon_sym_default] = ACTIONS(5518),
    [anon_sym_while] = ACTIONS(5518),
    [anon_sym_do] = ACTIONS(5518),
    [anon_sym_for] = ACTIONS(5518),
    [anon_sym_return] = ACTIONS(5518),
    [anon_sym_break] = ACTIONS(5518),
    [anon_sym_continue] = ACTIONS(5518),
    [anon_sym_goto] = ACTIONS(5518),
    [anon_sym_AMP] = ACTIONS(5516),
    [anon_sym_BANG] = ACTIONS(5516),
    [anon_sym_TILDE] = ACTIONS(5516),
    [anon_sym_PLUS] = ACTIONS(5518),
    [anon_sym_DASH] = ACTIONS(5518),
    [anon_sym_DASH_DASH] = ACTIONS(5516),
    [anon_sym_PLUS_PLUS] = ACTIONS(5516),
    [anon_sym_sizeof] = ACTIONS(5518),
    [sym_number_literal] = ACTIONS(5516),
    [sym_char_literal] = ACTIONS(5516),
    [sym_string_literal] = ACTIONS(5516),
    [sym_true] = ACTIONS(5518),
    [sym_false] = ACTIONS(5518),
    [sym_null] = ACTIONS(5518),
    [sym_identifier] = ACTIONS(5518),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(5518),
    [sym_auto] = ACTIONS(5518),
    [anon_sym_typename] = ACTIONS(5518),
    [anon_sym_new] = ACTIONS(5518),
    [anon_sym_COLON_COLON] = ACTIONS(5516),
    [anon_sym_delete] = ACTIONS(5518),
    [sym_nullptr] = ACTIONS(5518),
  },
  [1992] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(5520),
    [sym_comment] = ACTIONS(49),
  },
  [1993] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(5522),
    [sym_comment] = ACTIONS(49),
  },
  [1994] = {
    [sym_raw_string_literal] = ACTIONS(1972),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1974),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1974),
    [anon_sym_LPAREN] = ACTIONS(1972),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1974),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1974),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1974),
    [sym_preproc_directive] = ACTIONS(1974),
    [anon_sym_SEMI] = ACTIONS(1972),
    [anon_sym_typedef] = ACTIONS(1974),
    [anon_sym_extern] = ACTIONS(1974),
    [anon_sym_LBRACE] = ACTIONS(1972),
    [anon_sym_RBRACE] = ACTIONS(1972),
    [anon_sym_STAR] = ACTIONS(1972),
    [anon_sym_LBRACK] = ACTIONS(1972),
    [anon_sym_static] = ACTIONS(1974),
    [anon_sym_register] = ACTIONS(1974),
    [anon_sym_inline] = ACTIONS(1974),
    [anon_sym_const] = ACTIONS(1974),
    [anon_sym_restrict] = ACTIONS(1974),
    [anon_sym_volatile] = ACTIONS(1974),
    [anon_sym__Atomic] = ACTIONS(1974),
    [anon_sym_mutable] = ACTIONS(1974),
    [anon_sym_explicit] = ACTIONS(1974),
    [anon_sym_constexpr] = ACTIONS(1974),
    [anon_sym_unsigned] = ACTIONS(1974),
    [anon_sym_long] = ACTIONS(1974),
    [anon_sym_short] = ACTIONS(1974),
    [sym_primitive_type] = ACTIONS(1974),
    [anon_sym_enum] = ACTIONS(1974),
    [anon_sym_struct] = ACTIONS(1974),
    [anon_sym_union] = ACTIONS(1974),
    [anon_sym_if] = ACTIONS(1974),
    [anon_sym_switch] = ACTIONS(1974),
    [anon_sym_case] = ACTIONS(1974),
    [anon_sym_default] = ACTIONS(1974),
    [anon_sym_while] = ACTIONS(1974),
    [anon_sym_do] = ACTIONS(1974),
    [anon_sym_for] = ACTIONS(1974),
    [anon_sym_return] = ACTIONS(1974),
    [anon_sym_break] = ACTIONS(1974),
    [anon_sym_continue] = ACTIONS(1974),
    [anon_sym_goto] = ACTIONS(1974),
    [anon_sym_AMP] = ACTIONS(1972),
    [anon_sym_BANG] = ACTIONS(1972),
    [anon_sym_TILDE] = ACTIONS(1972),
    [anon_sym_PLUS] = ACTIONS(1974),
    [anon_sym_DASH] = ACTIONS(1974),
    [anon_sym_DASH_DASH] = ACTIONS(1972),
    [anon_sym_PLUS_PLUS] = ACTIONS(1972),
    [anon_sym_sizeof] = ACTIONS(1974),
    [sym_number_literal] = ACTIONS(1972),
    [sym_char_literal] = ACTIONS(1972),
    [sym_string_literal] = ACTIONS(1972),
    [sym_true] = ACTIONS(1974),
    [sym_false] = ACTIONS(1974),
    [sym_null] = ACTIONS(1974),
    [sym_identifier] = ACTIONS(1974),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(1974),
    [sym_auto] = ACTIONS(1974),
    [anon_sym_typename] = ACTIONS(1974),
    [anon_sym_new] = ACTIONS(1974),
    [anon_sym_COLON_COLON] = ACTIONS(1972),
    [anon_sym_delete] = ACTIONS(1974),
    [sym_nullptr] = ACTIONS(1974),
  },
  [1995] = {
    [sym_raw_string_literal] = ACTIONS(1988),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1990),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1990),
    [anon_sym_LPAREN] = ACTIONS(1988),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1990),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1990),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1990),
    [sym_preproc_directive] = ACTIONS(1990),
    [anon_sym_SEMI] = ACTIONS(1988),
    [anon_sym_typedef] = ACTIONS(1990),
    [anon_sym_extern] = ACTIONS(1990),
    [anon_sym_LBRACE] = ACTIONS(1988),
    [anon_sym_RBRACE] = ACTIONS(1988),
    [anon_sym_STAR] = ACTIONS(1988),
    [anon_sym_LBRACK] = ACTIONS(1988),
    [anon_sym_static] = ACTIONS(1990),
    [anon_sym_register] = ACTIONS(1990),
    [anon_sym_inline] = ACTIONS(1990),
    [anon_sym_const] = ACTIONS(1990),
    [anon_sym_restrict] = ACTIONS(1990),
    [anon_sym_volatile] = ACTIONS(1990),
    [anon_sym__Atomic] = ACTIONS(1990),
    [anon_sym_mutable] = ACTIONS(1990),
    [anon_sym_explicit] = ACTIONS(1990),
    [anon_sym_constexpr] = ACTIONS(1990),
    [anon_sym_unsigned] = ACTIONS(1990),
    [anon_sym_long] = ACTIONS(1990),
    [anon_sym_short] = ACTIONS(1990),
    [sym_primitive_type] = ACTIONS(1990),
    [anon_sym_enum] = ACTIONS(1990),
    [anon_sym_struct] = ACTIONS(1990),
    [anon_sym_union] = ACTIONS(1990),
    [anon_sym_if] = ACTIONS(1990),
    [anon_sym_switch] = ACTIONS(1990),
    [anon_sym_case] = ACTIONS(1990),
    [anon_sym_default] = ACTIONS(1990),
    [anon_sym_while] = ACTIONS(1990),
    [anon_sym_do] = ACTIONS(1990),
    [anon_sym_for] = ACTIONS(1990),
    [anon_sym_return] = ACTIONS(1990),
    [anon_sym_break] = ACTIONS(1990),
    [anon_sym_continue] = ACTIONS(1990),
    [anon_sym_goto] = ACTIONS(1990),
    [anon_sym_AMP] = ACTIONS(1988),
    [anon_sym_BANG] = ACTIONS(1988),
    [anon_sym_TILDE] = ACTIONS(1988),
    [anon_sym_PLUS] = ACTIONS(1990),
    [anon_sym_DASH] = ACTIONS(1990),
    [anon_sym_DASH_DASH] = ACTIONS(1988),
    [anon_sym_PLUS_PLUS] = ACTIONS(1988),
    [anon_sym_sizeof] = ACTIONS(1990),
    [sym_number_literal] = ACTIONS(1988),
    [sym_char_literal] = ACTIONS(1988),
    [sym_string_literal] = ACTIONS(1988),
    [sym_true] = ACTIONS(1990),
    [sym_false] = ACTIONS(1990),
    [sym_null] = ACTIONS(1990),
    [sym_identifier] = ACTIONS(1990),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(1990),
    [sym_auto] = ACTIONS(1990),
    [anon_sym_typename] = ACTIONS(1990),
    [anon_sym_new] = ACTIONS(1990),
    [anon_sym_COLON_COLON] = ACTIONS(1988),
    [anon_sym_delete] = ACTIONS(1990),
    [sym_nullptr] = ACTIONS(1990),
  },
  [1996] = {
    [sym_parameter_list] = STATE(513),
    [anon_sym_LPAREN] = ACTIONS(206),
    [anon_sym_SEMI] = ACTIONS(5524),
    [anon_sym_LBRACK] = ACTIONS(955),
    [sym_comment] = ACTIONS(49),
  },
  [1997] = {
    [anon_sym_RPAREN] = ACTIONS(5526),
    [sym_comment] = ACTIONS(49),
  },
  [1998] = {
    [sym_type_qualifier] = STATE(724),
    [sym__type_specifier] = STATE(720),
    [sym_sized_type_specifier] = STATE(720),
    [sym_enum_specifier] = STATE(720),
    [sym_struct_specifier] = STATE(720),
    [sym_union_specifier] = STATE(720),
    [sym__expression] = STATE(721),
    [sym_comma_expression] = STATE(722),
    [sym_conditional_expression] = STATE(721),
    [sym_assignment_expression] = STATE(721),
    [sym_pointer_expression] = STATE(721),
    [sym_logical_expression] = STATE(721),
    [sym_bitwise_expression] = STATE(721),
    [sym_equality_expression] = STATE(721),
    [sym_relational_expression] = STATE(721),
    [sym_shift_expression] = STATE(721),
    [sym_math_expression] = STATE(721),
    [sym_cast_expression] = STATE(721),
    [sym_type_descriptor] = STATE(2358),
    [sym_sizeof_expression] = STATE(721),
    [sym_subscript_expression] = STATE(721),
    [sym_call_expression] = STATE(721),
    [sym_field_expression] = STATE(721),
    [sym_compound_literal_expression] = STATE(721),
    [sym_parenthesized_expression] = STATE(721),
    [sym_concatenated_string] = STATE(721),
    [sym_macro_type_specifier] = STATE(720),
    [sym_class_specifier] = STATE(720),
    [sym_dependent_type] = STATE(720),
    [sym_template_type] = STATE(415),
    [sym_template_function] = STATE(721),
    [sym_new_expression] = STATE(721),
    [sym_delete_expression] = STATE(721),
    [sym_lambda_expression] = STATE(721),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(416),
    [sym_scoped_namespace_identifier] = STATE(417),
    [aux_sym_type_definition_repeat1] = STATE(724),
    [aux_sym_sized_type_specifier_repeat1] = STATE(725),
    [sym_raw_string_literal] = ACTIONS(1397),
    [anon_sym_LPAREN] = ACTIONS(1087),
    [anon_sym_STAR] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_restrict] = ACTIONS(93),
    [anon_sym_volatile] = ACTIONS(93),
    [anon_sym__Atomic] = ACTIONS(93),
    [anon_sym_mutable] = ACTIONS(93),
    [anon_sym_explicit] = ACTIONS(93),
    [anon_sym_constexpr] = ACTIONS(93),
    [anon_sym_unsigned] = ACTIONS(1399),
    [anon_sym_long] = ACTIONS(1399),
    [anon_sym_short] = ACTIONS(1399),
    [sym_primitive_type] = ACTIONS(1401),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(428),
    [anon_sym_union] = ACTIONS(430),
    [anon_sym_AMP] = ACTIONS(1089),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1093),
    [anon_sym_PLUS] = ACTIONS(1095),
    [anon_sym_DASH] = ACTIONS(1095),
    [anon_sym_DASH_DASH] = ACTIONS(1097),
    [anon_sym_PLUS_PLUS] = ACTIONS(1097),
    [anon_sym_sizeof] = ACTIONS(1099),
    [sym_number_literal] = ACTIONS(1397),
    [sym_char_literal] = ACTIONS(1397),
    [sym_string_literal] = ACTIONS(1101),
    [sym_true] = ACTIONS(1403),
    [sym_false] = ACTIONS(1403),
    [sym_null] = ACTIONS(1403),
    [sym_identifier] = ACTIONS(1405),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(436),
    [sym_auto] = ACTIONS(1401),
    [anon_sym_typename] = ACTIONS(1407),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1409),
    [anon_sym_delete] = ACTIONS(1109),
    [sym_nullptr] = ACTIONS(1403),
  },
  [1999] = {
    [sym_argument_list] = STATE(802),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_RPAREN] = ACTIONS(2702),
    [anon_sym_STAR] = ACTIONS(4537),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_EQ] = ACTIONS(2704),
    [anon_sym_QMARK] = ACTIONS(2702),
    [anon_sym_STAR_EQ] = ACTIONS(2702),
    [anon_sym_SLASH_EQ] = ACTIONS(2702),
    [anon_sym_PERCENT_EQ] = ACTIONS(2702),
    [anon_sym_PLUS_EQ] = ACTIONS(2702),
    [anon_sym_DASH_EQ] = ACTIONS(2702),
    [anon_sym_LT_LT_EQ] = ACTIONS(2702),
    [anon_sym_GT_GT_EQ] = ACTIONS(2702),
    [anon_sym_AMP_EQ] = ACTIONS(2702),
    [anon_sym_CARET_EQ] = ACTIONS(2702),
    [anon_sym_PIPE_EQ] = ACTIONS(2702),
    [anon_sym_AMP] = ACTIONS(2704),
    [anon_sym_PIPE_PIPE] = ACTIONS(2702),
    [anon_sym_AMP_AMP] = ACTIONS(2702),
    [anon_sym_PIPE] = ACTIONS(2704),
    [anon_sym_CARET] = ACTIONS(2704),
    [anon_sym_EQ_EQ] = ACTIONS(2702),
    [anon_sym_BANG_EQ] = ACTIONS(2702),
    [anon_sym_LT] = ACTIONS(2704),
    [anon_sym_GT] = ACTIONS(2704),
    [anon_sym_LT_EQ] = ACTIONS(2702),
    [anon_sym_GT_EQ] = ACTIONS(2702),
    [anon_sym_LT_LT] = ACTIONS(4561),
    [anon_sym_GT_GT] = ACTIONS(4561),
    [anon_sym_PLUS] = ACTIONS(4563),
    [anon_sym_DASH] = ACTIONS(4563),
    [anon_sym_SLASH] = ACTIONS(4537),
    [anon_sym_PERCENT] = ACTIONS(4537),
    [anon_sym_DASH_DASH] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(1554),
    [anon_sym_DASH_GT] = ACTIONS(1554),
    [sym_comment] = ACTIONS(49),
  },
  [2000] = {
    [aux_sym_concatenated_string_repeat1] = STATE(2359),
    [anon_sym_LPAREN] = ACTIONS(2706),
    [anon_sym_RPAREN] = ACTIONS(2706),
    [anon_sym_STAR] = ACTIONS(2708),
    [anon_sym_LBRACK] = ACTIONS(2706),
    [anon_sym_EQ] = ACTIONS(2708),
    [anon_sym_QMARK] = ACTIONS(2706),
    [anon_sym_STAR_EQ] = ACTIONS(2706),
    [anon_sym_SLASH_EQ] = ACTIONS(2706),
    [anon_sym_PERCENT_EQ] = ACTIONS(2706),
    [anon_sym_PLUS_EQ] = ACTIONS(2706),
    [anon_sym_DASH_EQ] = ACTIONS(2706),
    [anon_sym_LT_LT_EQ] = ACTIONS(2706),
    [anon_sym_GT_GT_EQ] = ACTIONS(2706),
    [anon_sym_AMP_EQ] = ACTIONS(2706),
    [anon_sym_CARET_EQ] = ACTIONS(2706),
    [anon_sym_PIPE_EQ] = ACTIONS(2706),
    [anon_sym_AMP] = ACTIONS(2708),
    [anon_sym_PIPE_PIPE] = ACTIONS(2706),
    [anon_sym_AMP_AMP] = ACTIONS(2706),
    [anon_sym_PIPE] = ACTIONS(2708),
    [anon_sym_CARET] = ACTIONS(2708),
    [anon_sym_EQ_EQ] = ACTIONS(2706),
    [anon_sym_BANG_EQ] = ACTIONS(2706),
    [anon_sym_LT] = ACTIONS(2708),
    [anon_sym_GT] = ACTIONS(2708),
    [anon_sym_LT_EQ] = ACTIONS(2706),
    [anon_sym_GT_EQ] = ACTIONS(2706),
    [anon_sym_LT_LT] = ACTIONS(2708),
    [anon_sym_GT_GT] = ACTIONS(2708),
    [anon_sym_PLUS] = ACTIONS(2708),
    [anon_sym_DASH] = ACTIONS(2708),
    [anon_sym_SLASH] = ACTIONS(2708),
    [anon_sym_PERCENT] = ACTIONS(2708),
    [anon_sym_DASH_DASH] = ACTIONS(2706),
    [anon_sym_PLUS_PLUS] = ACTIONS(2706),
    [anon_sym_DOT] = ACTIONS(2706),
    [anon_sym_DASH_GT] = ACTIONS(2706),
    [sym_string_literal] = ACTIONS(5528),
    [sym_comment] = ACTIONS(49),
  },
  [2001] = {
    [sym__expression] = STATE(2361),
    [sym_conditional_expression] = STATE(2361),
    [sym_assignment_expression] = STATE(2361),
    [sym_pointer_expression] = STATE(2361),
    [sym_logical_expression] = STATE(2361),
    [sym_bitwise_expression] = STATE(2361),
    [sym_equality_expression] = STATE(2361),
    [sym_relational_expression] = STATE(2361),
    [sym_shift_expression] = STATE(2361),
    [sym_math_expression] = STATE(2361),
    [sym_cast_expression] = STATE(2361),
    [sym_sizeof_expression] = STATE(2361),
    [sym_subscript_expression] = STATE(2361),
    [sym_call_expression] = STATE(2361),
    [sym_field_expression] = STATE(2361),
    [sym_compound_literal_expression] = STATE(2361),
    [sym_parenthesized_expression] = STATE(2361),
    [sym_concatenated_string] = STATE(2361),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(2361),
    [sym_new_expression] = STATE(2361),
    [sym_delete_expression] = STATE(2361),
    [sym_lambda_expression] = STATE(2361),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(5530),
    [anon_sym_LPAREN] = ACTIONS(2943),
    [anon_sym_STAR] = ACTIONS(2945),
    [anon_sym_LBRACK] = ACTIONS(5532),
    [anon_sym_AMP] = ACTIONS(2945),
    [anon_sym_BANG] = ACTIONS(2947),
    [anon_sym_TILDE] = ACTIONS(2949),
    [anon_sym_PLUS] = ACTIONS(2951),
    [anon_sym_DASH] = ACTIONS(2951),
    [anon_sym_DASH_DASH] = ACTIONS(2953),
    [anon_sym_PLUS_PLUS] = ACTIONS(2953),
    [anon_sym_sizeof] = ACTIONS(2955),
    [sym_number_literal] = ACTIONS(5530),
    [sym_char_literal] = ACTIONS(5530),
    [sym_string_literal] = ACTIONS(2957),
    [sym_true] = ACTIONS(5534),
    [sym_false] = ACTIONS(5534),
    [sym_null] = ACTIONS(5534),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(2961),
    [anon_sym_delete] = ACTIONS(2963),
    [sym_nullptr] = ACTIONS(5534),
  },
  [2002] = {
    [sym__expression] = STATE(740),
    [sym_conditional_expression] = STATE(740),
    [sym_assignment_expression] = STATE(740),
    [sym_pointer_expression] = STATE(740),
    [sym_logical_expression] = STATE(740),
    [sym_bitwise_expression] = STATE(740),
    [sym_equality_expression] = STATE(740),
    [sym_relational_expression] = STATE(740),
    [sym_shift_expression] = STATE(740),
    [sym_math_expression] = STATE(740),
    [sym_cast_expression] = STATE(740),
    [sym_sizeof_expression] = STATE(740),
    [sym_subscript_expression] = STATE(740),
    [sym_call_expression] = STATE(740),
    [sym_field_expression] = STATE(740),
    [sym_compound_literal_expression] = STATE(740),
    [sym_parenthesized_expression] = STATE(740),
    [sym_concatenated_string] = STATE(740),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(740),
    [sym_new_expression] = STATE(740),
    [sym_delete_expression] = STATE(740),
    [sym_lambda_expression] = STATE(740),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_lambda_default_capture] = STATE(741),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(1417),
    [anon_sym_LPAREN] = ACTIONS(1419),
    [anon_sym_STAR] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_RBRACK] = ACTIONS(5536),
    [anon_sym_EQ] = ACTIONS(1425),
    [anon_sym_AMP] = ACTIONS(1427),
    [anon_sym_BANG] = ACTIONS(1429),
    [anon_sym_TILDE] = ACTIONS(1431),
    [anon_sym_PLUS] = ACTIONS(1433),
    [anon_sym_DASH] = ACTIONS(1433),
    [anon_sym_DASH_DASH] = ACTIONS(1435),
    [anon_sym_PLUS_PLUS] = ACTIONS(1435),
    [anon_sym_sizeof] = ACTIONS(1437),
    [sym_number_literal] = ACTIONS(1417),
    [sym_char_literal] = ACTIONS(1417),
    [sym_string_literal] = ACTIONS(1439),
    [sym_true] = ACTIONS(1441),
    [sym_false] = ACTIONS(1441),
    [sym_null] = ACTIONS(1441),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1443),
    [anon_sym_delete] = ACTIONS(1445),
    [sym_nullptr] = ACTIONS(1441),
  },
  [2003] = {
    [sym_argument_list] = STATE(802),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_RPAREN] = ACTIONS(2740),
    [anon_sym_STAR] = ACTIONS(4537),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_EQ] = ACTIONS(2742),
    [anon_sym_QMARK] = ACTIONS(2740),
    [anon_sym_STAR_EQ] = ACTIONS(2740),
    [anon_sym_SLASH_EQ] = ACTIONS(2740),
    [anon_sym_PERCENT_EQ] = ACTIONS(2740),
    [anon_sym_PLUS_EQ] = ACTIONS(2740),
    [anon_sym_DASH_EQ] = ACTIONS(2740),
    [anon_sym_LT_LT_EQ] = ACTIONS(2740),
    [anon_sym_GT_GT_EQ] = ACTIONS(2740),
    [anon_sym_AMP_EQ] = ACTIONS(2740),
    [anon_sym_CARET_EQ] = ACTIONS(2740),
    [anon_sym_PIPE_EQ] = ACTIONS(2740),
    [anon_sym_AMP] = ACTIONS(4545),
    [anon_sym_PIPE_PIPE] = ACTIONS(4547),
    [anon_sym_AMP_AMP] = ACTIONS(4549),
    [anon_sym_PIPE] = ACTIONS(4551),
    [anon_sym_CARET] = ACTIONS(4553),
    [anon_sym_EQ_EQ] = ACTIONS(4555),
    [anon_sym_BANG_EQ] = ACTIONS(4555),
    [anon_sym_LT] = ACTIONS(4557),
    [anon_sym_GT] = ACTIONS(4557),
    [anon_sym_LT_EQ] = ACTIONS(4559),
    [anon_sym_GT_EQ] = ACTIONS(4559),
    [anon_sym_LT_LT] = ACTIONS(4561),
    [anon_sym_GT_GT] = ACTIONS(4561),
    [anon_sym_PLUS] = ACTIONS(4563),
    [anon_sym_DASH] = ACTIONS(4563),
    [anon_sym_SLASH] = ACTIONS(4537),
    [anon_sym_PERCENT] = ACTIONS(4537),
    [anon_sym_DASH_DASH] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(1554),
    [anon_sym_DASH_GT] = ACTIONS(1554),
    [sym_comment] = ACTIONS(49),
  },
  [2004] = {
    [sym_compound_statement] = STATE(2377),
    [sym_labeled_statement] = STATE(2377),
    [sym_expression_statement] = STATE(2377),
    [sym_if_statement] = STATE(2377),
    [sym_switch_statement] = STATE(2377),
    [sym_case_statement] = STATE(2377),
    [sym_while_statement] = STATE(2377),
    [sym_do_statement] = STATE(2377),
    [sym_for_statement] = STATE(2377),
    [sym_return_statement] = STATE(2377),
    [sym_break_statement] = STATE(2377),
    [sym_continue_statement] = STATE(2377),
    [sym_goto_statement] = STATE(2377),
    [sym__expression] = STATE(2378),
    [sym_comma_expression] = STATE(2379),
    [sym_conditional_expression] = STATE(2378),
    [sym_assignment_expression] = STATE(2378),
    [sym_pointer_expression] = STATE(2378),
    [sym_logical_expression] = STATE(2378),
    [sym_bitwise_expression] = STATE(2378),
    [sym_equality_expression] = STATE(2378),
    [sym_relational_expression] = STATE(2378),
    [sym_shift_expression] = STATE(2378),
    [sym_math_expression] = STATE(2378),
    [sym_cast_expression] = STATE(2378),
    [sym_sizeof_expression] = STATE(2378),
    [sym_subscript_expression] = STATE(2378),
    [sym_call_expression] = STATE(2378),
    [sym_field_expression] = STATE(2378),
    [sym_compound_literal_expression] = STATE(2378),
    [sym_parenthesized_expression] = STATE(2378),
    [sym_concatenated_string] = STATE(2378),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(2378),
    [sym_for_range_loop] = STATE(2377),
    [sym_new_expression] = STATE(2378),
    [sym_delete_expression] = STATE(2378),
    [sym_lambda_expression] = STATE(2378),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(5538),
    [anon_sym_LPAREN] = ACTIONS(626),
    [anon_sym_SEMI] = ACTIONS(5540),
    [anon_sym_LBRACE] = ACTIONS(5542),
    [anon_sym_STAR] = ACTIONS(644),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_if] = ACTIONS(5544),
    [anon_sym_switch] = ACTIONS(5546),
    [anon_sym_case] = ACTIONS(5548),
    [anon_sym_default] = ACTIONS(5550),
    [anon_sym_while] = ACTIONS(5552),
    [anon_sym_do] = ACTIONS(5554),
    [anon_sym_for] = ACTIONS(5556),
    [anon_sym_return] = ACTIONS(5558),
    [anon_sym_break] = ACTIONS(5560),
    [anon_sym_continue] = ACTIONS(5562),
    [anon_sym_goto] = ACTIONS(5564),
    [anon_sym_AMP] = ACTIONS(644),
    [anon_sym_BANG] = ACTIONS(668),
    [anon_sym_TILDE] = ACTIONS(670),
    [anon_sym_PLUS] = ACTIONS(672),
    [anon_sym_DASH] = ACTIONS(672),
    [anon_sym_DASH_DASH] = ACTIONS(674),
    [anon_sym_PLUS_PLUS] = ACTIONS(674),
    [anon_sym_sizeof] = ACTIONS(676),
    [sym_number_literal] = ACTIONS(5538),
    [sym_char_literal] = ACTIONS(5538),
    [sym_string_literal] = ACTIONS(678),
    [sym_true] = ACTIONS(5566),
    [sym_false] = ACTIONS(5566),
    [sym_null] = ACTIONS(5566),
    [sym_identifier] = ACTIONS(5568),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1303),
    [anon_sym_delete] = ACTIONS(686),
    [sym_nullptr] = ACTIONS(5566),
  },
  [2005] = {
    [sym__expression] = STATE(1328),
    [sym_conditional_expression] = STATE(1328),
    [sym_assignment_expression] = STATE(1328),
    [sym_pointer_expression] = STATE(1328),
    [sym_logical_expression] = STATE(1328),
    [sym_bitwise_expression] = STATE(1328),
    [sym_equality_expression] = STATE(1328),
    [sym_relational_expression] = STATE(1328),
    [sym_shift_expression] = STATE(1328),
    [sym_math_expression] = STATE(1328),
    [sym_cast_expression] = STATE(1328),
    [sym_sizeof_expression] = STATE(1328),
    [sym_subscript_expression] = STATE(1328),
    [sym_call_expression] = STATE(1328),
    [sym_field_expression] = STATE(1328),
    [sym_compound_literal_expression] = STATE(1328),
    [sym_parenthesized_expression] = STATE(1328),
    [sym_concatenated_string] = STATE(1328),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(1328),
    [sym_new_expression] = STATE(1328),
    [sym_delete_expression] = STATE(1328),
    [sym_lambda_expression] = STATE(1328),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(2748),
    [anon_sym_LPAREN] = ACTIONS(2943),
    [anon_sym_STAR] = ACTIONS(2945),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_AMP] = ACTIONS(2945),
    [anon_sym_BANG] = ACTIONS(2947),
    [anon_sym_TILDE] = ACTIONS(2949),
    [anon_sym_PLUS] = ACTIONS(2951),
    [anon_sym_DASH] = ACTIONS(2951),
    [anon_sym_DASH_DASH] = ACTIONS(2953),
    [anon_sym_PLUS_PLUS] = ACTIONS(2953),
    [anon_sym_sizeof] = ACTIONS(2955),
    [sym_number_literal] = ACTIONS(2748),
    [sym_char_literal] = ACTIONS(2748),
    [sym_string_literal] = ACTIONS(2957),
    [sym_true] = ACTIONS(2750),
    [sym_false] = ACTIONS(2750),
    [sym_null] = ACTIONS(2750),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(2961),
    [anon_sym_delete] = ACTIONS(2963),
    [sym_nullptr] = ACTIONS(2750),
  },
  [2006] = {
    [sym__expression] = STATE(2380),
    [sym_conditional_expression] = STATE(2380),
    [sym_assignment_expression] = STATE(2380),
    [sym_pointer_expression] = STATE(2380),
    [sym_logical_expression] = STATE(2380),
    [sym_bitwise_expression] = STATE(2380),
    [sym_equality_expression] = STATE(2380),
    [sym_relational_expression] = STATE(2380),
    [sym_shift_expression] = STATE(2380),
    [sym_math_expression] = STATE(2380),
    [sym_cast_expression] = STATE(2380),
    [sym_sizeof_expression] = STATE(2380),
    [sym_subscript_expression] = STATE(2380),
    [sym_call_expression] = STATE(2380),
    [sym_field_expression] = STATE(2380),
    [sym_compound_literal_expression] = STATE(2380),
    [sym_parenthesized_expression] = STATE(2380),
    [sym_concatenated_string] = STATE(2380),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(2380),
    [sym_new_expression] = STATE(2380),
    [sym_delete_expression] = STATE(2380),
    [sym_lambda_expression] = STATE(2380),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(5570),
    [anon_sym_LPAREN] = ACTIONS(2943),
    [anon_sym_STAR] = ACTIONS(2945),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_AMP] = ACTIONS(2945),
    [anon_sym_BANG] = ACTIONS(2947),
    [anon_sym_TILDE] = ACTIONS(2949),
    [anon_sym_PLUS] = ACTIONS(2951),
    [anon_sym_DASH] = ACTIONS(2951),
    [anon_sym_DASH_DASH] = ACTIONS(2953),
    [anon_sym_PLUS_PLUS] = ACTIONS(2953),
    [anon_sym_sizeof] = ACTIONS(2955),
    [sym_number_literal] = ACTIONS(5570),
    [sym_char_literal] = ACTIONS(5570),
    [sym_string_literal] = ACTIONS(2957),
    [sym_true] = ACTIONS(5572),
    [sym_false] = ACTIONS(5572),
    [sym_null] = ACTIONS(5572),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(2961),
    [anon_sym_delete] = ACTIONS(2963),
    [sym_nullptr] = ACTIONS(5572),
  },
  [2007] = {
    [sym__expression] = STATE(2381),
    [sym_conditional_expression] = STATE(2381),
    [sym_assignment_expression] = STATE(2381),
    [sym_pointer_expression] = STATE(2381),
    [sym_logical_expression] = STATE(2381),
    [sym_bitwise_expression] = STATE(2381),
    [sym_equality_expression] = STATE(2381),
    [sym_relational_expression] = STATE(2381),
    [sym_shift_expression] = STATE(2381),
    [sym_math_expression] = STATE(2381),
    [sym_cast_expression] = STATE(2381),
    [sym_sizeof_expression] = STATE(2381),
    [sym_subscript_expression] = STATE(2381),
    [sym_call_expression] = STATE(2381),
    [sym_field_expression] = STATE(2381),
    [sym_compound_literal_expression] = STATE(2381),
    [sym_parenthesized_expression] = STATE(2381),
    [sym_concatenated_string] = STATE(2381),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(2381),
    [sym_new_expression] = STATE(2381),
    [sym_delete_expression] = STATE(2381),
    [sym_lambda_expression] = STATE(2381),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(855),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(5574),
    [anon_sym_LPAREN] = ACTIONS(1634),
    [anon_sym_STAR] = ACTIONS(1636),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_AMP] = ACTIONS(1636),
    [anon_sym_BANG] = ACTIONS(1638),
    [anon_sym_TILDE] = ACTIONS(1640),
    [anon_sym_PLUS] = ACTIONS(1642),
    [anon_sym_DASH] = ACTIONS(1642),
    [anon_sym_DASH_DASH] = ACTIONS(1644),
    [anon_sym_PLUS_PLUS] = ACTIONS(1644),
    [anon_sym_sizeof] = ACTIONS(1646),
    [sym_number_literal] = ACTIONS(5574),
    [sym_char_literal] = ACTIONS(5574),
    [sym_string_literal] = ACTIONS(1648),
    [sym_true] = ACTIONS(5576),
    [sym_false] = ACTIONS(5576),
    [sym_null] = ACTIONS(5576),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1652),
    [anon_sym_delete] = ACTIONS(1654),
    [sym_nullptr] = ACTIONS(5576),
  },
  [2008] = {
    [sym__expression] = STATE(2382),
    [sym_conditional_expression] = STATE(2382),
    [sym_assignment_expression] = STATE(2382),
    [sym_pointer_expression] = STATE(2382),
    [sym_logical_expression] = STATE(2382),
    [sym_bitwise_expression] = STATE(2382),
    [sym_equality_expression] = STATE(2382),
    [sym_relational_expression] = STATE(2382),
    [sym_shift_expression] = STATE(2382),
    [sym_math_expression] = STATE(2382),
    [sym_cast_expression] = STATE(2382),
    [sym_sizeof_expression] = STATE(2382),
    [sym_subscript_expression] = STATE(2382),
    [sym_call_expression] = STATE(2382),
    [sym_field_expression] = STATE(2382),
    [sym_compound_literal_expression] = STATE(2382),
    [sym_parenthesized_expression] = STATE(2382),
    [sym_concatenated_string] = STATE(2382),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(2382),
    [sym_new_expression] = STATE(2382),
    [sym_delete_expression] = STATE(2382),
    [sym_lambda_expression] = STATE(2382),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(5578),
    [anon_sym_LPAREN] = ACTIONS(2943),
    [anon_sym_STAR] = ACTIONS(2945),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_AMP] = ACTIONS(2945),
    [anon_sym_BANG] = ACTIONS(2947),
    [anon_sym_TILDE] = ACTIONS(2949),
    [anon_sym_PLUS] = ACTIONS(2951),
    [anon_sym_DASH] = ACTIONS(2951),
    [anon_sym_DASH_DASH] = ACTIONS(2953),
    [anon_sym_PLUS_PLUS] = ACTIONS(2953),
    [anon_sym_sizeof] = ACTIONS(2955),
    [sym_number_literal] = ACTIONS(5578),
    [sym_char_literal] = ACTIONS(5578),
    [sym_string_literal] = ACTIONS(2957),
    [sym_true] = ACTIONS(5580),
    [sym_false] = ACTIONS(5580),
    [sym_null] = ACTIONS(5580),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(2961),
    [anon_sym_delete] = ACTIONS(2963),
    [sym_nullptr] = ACTIONS(5580),
  },
  [2009] = {
    [sym__expression] = STATE(2383),
    [sym_conditional_expression] = STATE(2383),
    [sym_assignment_expression] = STATE(2383),
    [sym_pointer_expression] = STATE(2383),
    [sym_logical_expression] = STATE(2383),
    [sym_bitwise_expression] = STATE(2383),
    [sym_equality_expression] = STATE(2383),
    [sym_relational_expression] = STATE(2383),
    [sym_shift_expression] = STATE(2383),
    [sym_math_expression] = STATE(2383),
    [sym_cast_expression] = STATE(2383),
    [sym_sizeof_expression] = STATE(2383),
    [sym_subscript_expression] = STATE(2383),
    [sym_call_expression] = STATE(2383),
    [sym_field_expression] = STATE(2383),
    [sym_compound_literal_expression] = STATE(2383),
    [sym_parenthesized_expression] = STATE(2383),
    [sym_concatenated_string] = STATE(2383),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(2383),
    [sym_new_expression] = STATE(2383),
    [sym_delete_expression] = STATE(2383),
    [sym_lambda_expression] = STATE(2383),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(5582),
    [anon_sym_LPAREN] = ACTIONS(2943),
    [anon_sym_STAR] = ACTIONS(2945),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_AMP] = ACTIONS(2945),
    [anon_sym_BANG] = ACTIONS(2947),
    [anon_sym_TILDE] = ACTIONS(2949),
    [anon_sym_PLUS] = ACTIONS(2951),
    [anon_sym_DASH] = ACTIONS(2951),
    [anon_sym_DASH_DASH] = ACTIONS(2953),
    [anon_sym_PLUS_PLUS] = ACTIONS(2953),
    [anon_sym_sizeof] = ACTIONS(2955),
    [sym_number_literal] = ACTIONS(5582),
    [sym_char_literal] = ACTIONS(5582),
    [sym_string_literal] = ACTIONS(2957),
    [sym_true] = ACTIONS(5584),
    [sym_false] = ACTIONS(5584),
    [sym_null] = ACTIONS(5584),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(2961),
    [anon_sym_delete] = ACTIONS(2963),
    [sym_nullptr] = ACTIONS(5584),
  },
  [2010] = {
    [sym__expression] = STATE(2384),
    [sym_conditional_expression] = STATE(2384),
    [sym_assignment_expression] = STATE(2384),
    [sym_pointer_expression] = STATE(2384),
    [sym_logical_expression] = STATE(2384),
    [sym_bitwise_expression] = STATE(2384),
    [sym_equality_expression] = STATE(2384),
    [sym_relational_expression] = STATE(2384),
    [sym_shift_expression] = STATE(2384),
    [sym_math_expression] = STATE(2384),
    [sym_cast_expression] = STATE(2384),
    [sym_sizeof_expression] = STATE(2384),
    [sym_subscript_expression] = STATE(2384),
    [sym_call_expression] = STATE(2384),
    [sym_field_expression] = STATE(2384),
    [sym_compound_literal_expression] = STATE(2384),
    [sym_parenthesized_expression] = STATE(2384),
    [sym_concatenated_string] = STATE(2384),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(2384),
    [sym_new_expression] = STATE(2384),
    [sym_delete_expression] = STATE(2384),
    [sym_lambda_expression] = STATE(2384),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(5586),
    [anon_sym_LPAREN] = ACTIONS(2943),
    [anon_sym_STAR] = ACTIONS(2945),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_AMP] = ACTIONS(2945),
    [anon_sym_BANG] = ACTIONS(2947),
    [anon_sym_TILDE] = ACTIONS(2949),
    [anon_sym_PLUS] = ACTIONS(2951),
    [anon_sym_DASH] = ACTIONS(2951),
    [anon_sym_DASH_DASH] = ACTIONS(2953),
    [anon_sym_PLUS_PLUS] = ACTIONS(2953),
    [anon_sym_sizeof] = ACTIONS(2955),
    [sym_number_literal] = ACTIONS(5586),
    [sym_char_literal] = ACTIONS(5586),
    [sym_string_literal] = ACTIONS(2957),
    [sym_true] = ACTIONS(5588),
    [sym_false] = ACTIONS(5588),
    [sym_null] = ACTIONS(5588),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(2961),
    [anon_sym_delete] = ACTIONS(2963),
    [sym_nullptr] = ACTIONS(5588),
  },
  [2011] = {
    [sym__expression] = STATE(2385),
    [sym_conditional_expression] = STATE(2385),
    [sym_assignment_expression] = STATE(2385),
    [sym_pointer_expression] = STATE(2385),
    [sym_logical_expression] = STATE(2385),
    [sym_bitwise_expression] = STATE(2385),
    [sym_equality_expression] = STATE(2385),
    [sym_relational_expression] = STATE(2385),
    [sym_shift_expression] = STATE(2385),
    [sym_math_expression] = STATE(2385),
    [sym_cast_expression] = STATE(2385),
    [sym_sizeof_expression] = STATE(2385),
    [sym_subscript_expression] = STATE(2385),
    [sym_call_expression] = STATE(2385),
    [sym_field_expression] = STATE(2385),
    [sym_compound_literal_expression] = STATE(2385),
    [sym_parenthesized_expression] = STATE(2385),
    [sym_concatenated_string] = STATE(2385),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(2385),
    [sym_new_expression] = STATE(2385),
    [sym_delete_expression] = STATE(2385),
    [sym_lambda_expression] = STATE(2385),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(5590),
    [anon_sym_LPAREN] = ACTIONS(2943),
    [anon_sym_STAR] = ACTIONS(2945),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_AMP] = ACTIONS(2945),
    [anon_sym_BANG] = ACTIONS(2947),
    [anon_sym_TILDE] = ACTIONS(2949),
    [anon_sym_PLUS] = ACTIONS(2951),
    [anon_sym_DASH] = ACTIONS(2951),
    [anon_sym_DASH_DASH] = ACTIONS(2953),
    [anon_sym_PLUS_PLUS] = ACTIONS(2953),
    [anon_sym_sizeof] = ACTIONS(2955),
    [sym_number_literal] = ACTIONS(5590),
    [sym_char_literal] = ACTIONS(5590),
    [sym_string_literal] = ACTIONS(2957),
    [sym_true] = ACTIONS(5592),
    [sym_false] = ACTIONS(5592),
    [sym_null] = ACTIONS(5592),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(2961),
    [anon_sym_delete] = ACTIONS(2963),
    [sym_nullptr] = ACTIONS(5592),
  },
  [2012] = {
    [sym__expression] = STATE(2386),
    [sym_conditional_expression] = STATE(2386),
    [sym_assignment_expression] = STATE(2386),
    [sym_pointer_expression] = STATE(2386),
    [sym_logical_expression] = STATE(2386),
    [sym_bitwise_expression] = STATE(2386),
    [sym_equality_expression] = STATE(2386),
    [sym_relational_expression] = STATE(2386),
    [sym_shift_expression] = STATE(2386),
    [sym_math_expression] = STATE(2386),
    [sym_cast_expression] = STATE(2386),
    [sym_sizeof_expression] = STATE(2386),
    [sym_subscript_expression] = STATE(2386),
    [sym_call_expression] = STATE(2386),
    [sym_field_expression] = STATE(2386),
    [sym_compound_literal_expression] = STATE(2386),
    [sym_parenthesized_expression] = STATE(2386),
    [sym_concatenated_string] = STATE(2386),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(2386),
    [sym_new_expression] = STATE(2386),
    [sym_delete_expression] = STATE(2386),
    [sym_lambda_expression] = STATE(2386),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(5594),
    [anon_sym_LPAREN] = ACTIONS(2943),
    [anon_sym_STAR] = ACTIONS(2945),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_AMP] = ACTIONS(2945),
    [anon_sym_BANG] = ACTIONS(2947),
    [anon_sym_TILDE] = ACTIONS(2949),
    [anon_sym_PLUS] = ACTIONS(2951),
    [anon_sym_DASH] = ACTIONS(2951),
    [anon_sym_DASH_DASH] = ACTIONS(2953),
    [anon_sym_PLUS_PLUS] = ACTIONS(2953),
    [anon_sym_sizeof] = ACTIONS(2955),
    [sym_number_literal] = ACTIONS(5594),
    [sym_char_literal] = ACTIONS(5594),
    [sym_string_literal] = ACTIONS(2957),
    [sym_true] = ACTIONS(5596),
    [sym_false] = ACTIONS(5596),
    [sym_null] = ACTIONS(5596),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(2961),
    [anon_sym_delete] = ACTIONS(2963),
    [sym_nullptr] = ACTIONS(5596),
  },
  [2013] = {
    [sym__expression] = STATE(2387),
    [sym_conditional_expression] = STATE(2387),
    [sym_assignment_expression] = STATE(2387),
    [sym_pointer_expression] = STATE(2387),
    [sym_logical_expression] = STATE(2387),
    [sym_bitwise_expression] = STATE(2387),
    [sym_equality_expression] = STATE(2387),
    [sym_relational_expression] = STATE(2387),
    [sym_shift_expression] = STATE(2387),
    [sym_math_expression] = STATE(2387),
    [sym_cast_expression] = STATE(2387),
    [sym_sizeof_expression] = STATE(2387),
    [sym_subscript_expression] = STATE(2387),
    [sym_call_expression] = STATE(2387),
    [sym_field_expression] = STATE(2387),
    [sym_compound_literal_expression] = STATE(2387),
    [sym_parenthesized_expression] = STATE(2387),
    [sym_concatenated_string] = STATE(2387),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(2387),
    [sym_new_expression] = STATE(2387),
    [sym_delete_expression] = STATE(2387),
    [sym_lambda_expression] = STATE(2387),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(5598),
    [anon_sym_LPAREN] = ACTIONS(2943),
    [anon_sym_STAR] = ACTIONS(2945),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_AMP] = ACTIONS(2945),
    [anon_sym_BANG] = ACTIONS(2947),
    [anon_sym_TILDE] = ACTIONS(2949),
    [anon_sym_PLUS] = ACTIONS(2951),
    [anon_sym_DASH] = ACTIONS(2951),
    [anon_sym_DASH_DASH] = ACTIONS(2953),
    [anon_sym_PLUS_PLUS] = ACTIONS(2953),
    [anon_sym_sizeof] = ACTIONS(2955),
    [sym_number_literal] = ACTIONS(5598),
    [sym_char_literal] = ACTIONS(5598),
    [sym_string_literal] = ACTIONS(2957),
    [sym_true] = ACTIONS(5600),
    [sym_false] = ACTIONS(5600),
    [sym_null] = ACTIONS(5600),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(2961),
    [anon_sym_delete] = ACTIONS(2963),
    [sym_nullptr] = ACTIONS(5600),
  },
  [2014] = {
    [sym__expression] = STATE(2388),
    [sym_conditional_expression] = STATE(2388),
    [sym_assignment_expression] = STATE(2388),
    [sym_pointer_expression] = STATE(2388),
    [sym_logical_expression] = STATE(2388),
    [sym_bitwise_expression] = STATE(2388),
    [sym_equality_expression] = STATE(2388),
    [sym_relational_expression] = STATE(2388),
    [sym_shift_expression] = STATE(2388),
    [sym_math_expression] = STATE(2388),
    [sym_cast_expression] = STATE(2388),
    [sym_sizeof_expression] = STATE(2388),
    [sym_subscript_expression] = STATE(2388),
    [sym_call_expression] = STATE(2388),
    [sym_field_expression] = STATE(2388),
    [sym_compound_literal_expression] = STATE(2388),
    [sym_parenthesized_expression] = STATE(2388),
    [sym_concatenated_string] = STATE(2388),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(2388),
    [sym_new_expression] = STATE(2388),
    [sym_delete_expression] = STATE(2388),
    [sym_lambda_expression] = STATE(2388),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(5602),
    [anon_sym_LPAREN] = ACTIONS(2943),
    [anon_sym_STAR] = ACTIONS(2945),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_AMP] = ACTIONS(2945),
    [anon_sym_BANG] = ACTIONS(2947),
    [anon_sym_TILDE] = ACTIONS(2949),
    [anon_sym_PLUS] = ACTIONS(2951),
    [anon_sym_DASH] = ACTIONS(2951),
    [anon_sym_DASH_DASH] = ACTIONS(2953),
    [anon_sym_PLUS_PLUS] = ACTIONS(2953),
    [anon_sym_sizeof] = ACTIONS(2955),
    [sym_number_literal] = ACTIONS(5602),
    [sym_char_literal] = ACTIONS(5602),
    [sym_string_literal] = ACTIONS(2957),
    [sym_true] = ACTIONS(5604),
    [sym_false] = ACTIONS(5604),
    [sym_null] = ACTIONS(5604),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(2961),
    [anon_sym_delete] = ACTIONS(2963),
    [sym_nullptr] = ACTIONS(5604),
  },
  [2015] = {
    [sym__expression] = STATE(2389),
    [sym_conditional_expression] = STATE(2389),
    [sym_assignment_expression] = STATE(2389),
    [sym_pointer_expression] = STATE(2389),
    [sym_logical_expression] = STATE(2389),
    [sym_bitwise_expression] = STATE(2389),
    [sym_equality_expression] = STATE(2389),
    [sym_relational_expression] = STATE(2389),
    [sym_shift_expression] = STATE(2389),
    [sym_math_expression] = STATE(2389),
    [sym_cast_expression] = STATE(2389),
    [sym_sizeof_expression] = STATE(2389),
    [sym_subscript_expression] = STATE(2389),
    [sym_call_expression] = STATE(2389),
    [sym_field_expression] = STATE(2389),
    [sym_compound_literal_expression] = STATE(2389),
    [sym_parenthesized_expression] = STATE(2389),
    [sym_concatenated_string] = STATE(2389),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(2389),
    [sym_new_expression] = STATE(2389),
    [sym_delete_expression] = STATE(2389),
    [sym_lambda_expression] = STATE(2389),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(5606),
    [anon_sym_LPAREN] = ACTIONS(2943),
    [anon_sym_STAR] = ACTIONS(2945),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_AMP] = ACTIONS(2945),
    [anon_sym_BANG] = ACTIONS(2947),
    [anon_sym_TILDE] = ACTIONS(2949),
    [anon_sym_PLUS] = ACTIONS(2951),
    [anon_sym_DASH] = ACTIONS(2951),
    [anon_sym_DASH_DASH] = ACTIONS(2953),
    [anon_sym_PLUS_PLUS] = ACTIONS(2953),
    [anon_sym_sizeof] = ACTIONS(2955),
    [sym_number_literal] = ACTIONS(5606),
    [sym_char_literal] = ACTIONS(5606),
    [sym_string_literal] = ACTIONS(2957),
    [sym_true] = ACTIONS(5608),
    [sym_false] = ACTIONS(5608),
    [sym_null] = ACTIONS(5608),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(2961),
    [anon_sym_delete] = ACTIONS(2963),
    [sym_nullptr] = ACTIONS(5608),
  },
  [2016] = {
    [sym__expression] = STATE(2390),
    [sym_conditional_expression] = STATE(2390),
    [sym_assignment_expression] = STATE(2390),
    [sym_pointer_expression] = STATE(2390),
    [sym_logical_expression] = STATE(2390),
    [sym_bitwise_expression] = STATE(2390),
    [sym_equality_expression] = STATE(2390),
    [sym_relational_expression] = STATE(2390),
    [sym_shift_expression] = STATE(2390),
    [sym_math_expression] = STATE(2390),
    [sym_cast_expression] = STATE(2390),
    [sym_sizeof_expression] = STATE(2390),
    [sym_subscript_expression] = STATE(2390),
    [sym_call_expression] = STATE(2390),
    [sym_field_expression] = STATE(2390),
    [sym_compound_literal_expression] = STATE(2390),
    [sym_parenthesized_expression] = STATE(2390),
    [sym_concatenated_string] = STATE(2390),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(2390),
    [sym_new_expression] = STATE(2390),
    [sym_delete_expression] = STATE(2390),
    [sym_lambda_expression] = STATE(2390),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(5610),
    [anon_sym_LPAREN] = ACTIONS(2943),
    [anon_sym_STAR] = ACTIONS(2945),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_AMP] = ACTIONS(2945),
    [anon_sym_BANG] = ACTIONS(2947),
    [anon_sym_TILDE] = ACTIONS(2949),
    [anon_sym_PLUS] = ACTIONS(2951),
    [anon_sym_DASH] = ACTIONS(2951),
    [anon_sym_DASH_DASH] = ACTIONS(2953),
    [anon_sym_PLUS_PLUS] = ACTIONS(2953),
    [anon_sym_sizeof] = ACTIONS(2955),
    [sym_number_literal] = ACTIONS(5610),
    [sym_char_literal] = ACTIONS(5610),
    [sym_string_literal] = ACTIONS(2957),
    [sym_true] = ACTIONS(5612),
    [sym_false] = ACTIONS(5612),
    [sym_null] = ACTIONS(5612),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(2961),
    [anon_sym_delete] = ACTIONS(2963),
    [sym_nullptr] = ACTIONS(5612),
  },
  [2017] = {
    [sym_argument_list] = STATE(802),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_RPAREN] = ACTIONS(5614),
    [anon_sym_STAR] = ACTIONS(4537),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_EQ] = ACTIONS(4539),
    [anon_sym_QMARK] = ACTIONS(4541),
    [anon_sym_STAR_EQ] = ACTIONS(4543),
    [anon_sym_SLASH_EQ] = ACTIONS(4543),
    [anon_sym_PERCENT_EQ] = ACTIONS(4543),
    [anon_sym_PLUS_EQ] = ACTIONS(4543),
    [anon_sym_DASH_EQ] = ACTIONS(4543),
    [anon_sym_LT_LT_EQ] = ACTIONS(4543),
    [anon_sym_GT_GT_EQ] = ACTIONS(4543),
    [anon_sym_AMP_EQ] = ACTIONS(4543),
    [anon_sym_CARET_EQ] = ACTIONS(4543),
    [anon_sym_PIPE_EQ] = ACTIONS(4543),
    [anon_sym_AMP] = ACTIONS(4545),
    [anon_sym_PIPE_PIPE] = ACTIONS(4547),
    [anon_sym_AMP_AMP] = ACTIONS(4549),
    [anon_sym_PIPE] = ACTIONS(4551),
    [anon_sym_CARET] = ACTIONS(4553),
    [anon_sym_EQ_EQ] = ACTIONS(4555),
    [anon_sym_BANG_EQ] = ACTIONS(4555),
    [anon_sym_LT] = ACTIONS(4557),
    [anon_sym_GT] = ACTIONS(4557),
    [anon_sym_LT_EQ] = ACTIONS(4559),
    [anon_sym_GT_EQ] = ACTIONS(4559),
    [anon_sym_LT_LT] = ACTIONS(4561),
    [anon_sym_GT_GT] = ACTIONS(4561),
    [anon_sym_PLUS] = ACTIONS(4563),
    [anon_sym_DASH] = ACTIONS(4563),
    [anon_sym_SLASH] = ACTIONS(4537),
    [anon_sym_PERCENT] = ACTIONS(4537),
    [anon_sym_DASH_DASH] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(1554),
    [anon_sym_DASH_GT] = ACTIONS(1554),
    [sym_comment] = ACTIONS(49),
  },
  [2018] = {
    [sym_compound_statement] = STATE(2392),
    [sym_labeled_statement] = STATE(2392),
    [sym_expression_statement] = STATE(2392),
    [sym_if_statement] = STATE(2392),
    [sym_switch_statement] = STATE(2392),
    [sym_case_statement] = STATE(2392),
    [sym_while_statement] = STATE(2392),
    [sym_do_statement] = STATE(2392),
    [sym_for_statement] = STATE(2392),
    [sym_return_statement] = STATE(2392),
    [sym_break_statement] = STATE(2392),
    [sym_continue_statement] = STATE(2392),
    [sym_goto_statement] = STATE(2392),
    [sym__expression] = STATE(413),
    [sym_comma_expression] = STATE(414),
    [sym_conditional_expression] = STATE(413),
    [sym_assignment_expression] = STATE(413),
    [sym_pointer_expression] = STATE(413),
    [sym_logical_expression] = STATE(413),
    [sym_bitwise_expression] = STATE(413),
    [sym_equality_expression] = STATE(413),
    [sym_relational_expression] = STATE(413),
    [sym_shift_expression] = STATE(413),
    [sym_math_expression] = STATE(413),
    [sym_cast_expression] = STATE(413),
    [sym_sizeof_expression] = STATE(413),
    [sym_subscript_expression] = STATE(413),
    [sym_call_expression] = STATE(413),
    [sym_field_expression] = STATE(413),
    [sym_compound_literal_expression] = STATE(413),
    [sym_parenthesized_expression] = STATE(413),
    [sym_concatenated_string] = STATE(413),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(413),
    [sym_for_range_loop] = STATE(2392),
    [sym_new_expression] = STATE(413),
    [sym_delete_expression] = STATE(413),
    [sym_lambda_expression] = STATE(413),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(620),
    [anon_sym_LPAREN] = ACTIONS(626),
    [anon_sym_SEMI] = ACTIONS(636),
    [anon_sym_LBRACE] = ACTIONS(640),
    [anon_sym_STAR] = ACTIONS(644),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_if] = ACTIONS(646),
    [anon_sym_switch] = ACTIONS(648),
    [anon_sym_case] = ACTIONS(650),
    [anon_sym_default] = ACTIONS(652),
    [anon_sym_while] = ACTIONS(654),
    [anon_sym_do] = ACTIONS(656),
    [anon_sym_for] = ACTIONS(658),
    [anon_sym_return] = ACTIONS(660),
    [anon_sym_break] = ACTIONS(662),
    [anon_sym_continue] = ACTIONS(664),
    [anon_sym_goto] = ACTIONS(666),
    [anon_sym_AMP] = ACTIONS(644),
    [anon_sym_BANG] = ACTIONS(668),
    [anon_sym_TILDE] = ACTIONS(670),
    [anon_sym_PLUS] = ACTIONS(672),
    [anon_sym_DASH] = ACTIONS(672),
    [anon_sym_DASH_DASH] = ACTIONS(674),
    [anon_sym_PLUS_PLUS] = ACTIONS(674),
    [anon_sym_sizeof] = ACTIONS(676),
    [sym_number_literal] = ACTIONS(620),
    [sym_char_literal] = ACTIONS(620),
    [sym_string_literal] = ACTIONS(678),
    [sym_true] = ACTIONS(680),
    [sym_false] = ACTIONS(680),
    [sym_null] = ACTIONS(680),
    [sym_identifier] = ACTIONS(3110),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1303),
    [anon_sym_delete] = ACTIONS(686),
    [sym_nullptr] = ACTIONS(680),
  },
  [2019] = {
    [sym__expression] = STATE(2393),
    [sym_conditional_expression] = STATE(2393),
    [sym_assignment_expression] = STATE(2393),
    [sym_pointer_expression] = STATE(2393),
    [sym_logical_expression] = STATE(2393),
    [sym_bitwise_expression] = STATE(2393),
    [sym_equality_expression] = STATE(2393),
    [sym_relational_expression] = STATE(2393),
    [sym_shift_expression] = STATE(2393),
    [sym_math_expression] = STATE(2393),
    [sym_cast_expression] = STATE(2393),
    [sym_sizeof_expression] = STATE(2393),
    [sym_subscript_expression] = STATE(2393),
    [sym_call_expression] = STATE(2393),
    [sym_field_expression] = STATE(2393),
    [sym_compound_literal_expression] = STATE(2393),
    [sym_parenthesized_expression] = STATE(2393),
    [sym_initializer_list] = STATE(1835),
    [sym_concatenated_string] = STATE(2393),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(2393),
    [sym_new_expression] = STATE(2393),
    [sym_delete_expression] = STATE(2393),
    [sym_lambda_expression] = STATE(2393),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(855),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(5616),
    [anon_sym_LPAREN] = ACTIONS(1634),
    [anon_sym_LBRACE] = ACTIONS(548),
    [anon_sym_STAR] = ACTIONS(1636),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_AMP] = ACTIONS(1636),
    [anon_sym_BANG] = ACTIONS(1638),
    [anon_sym_TILDE] = ACTIONS(1640),
    [anon_sym_PLUS] = ACTIONS(1642),
    [anon_sym_DASH] = ACTIONS(1642),
    [anon_sym_DASH_DASH] = ACTIONS(1644),
    [anon_sym_PLUS_PLUS] = ACTIONS(1644),
    [anon_sym_sizeof] = ACTIONS(1646),
    [sym_number_literal] = ACTIONS(5616),
    [sym_char_literal] = ACTIONS(5616),
    [sym_string_literal] = ACTIONS(1648),
    [sym_true] = ACTIONS(5618),
    [sym_false] = ACTIONS(5618),
    [sym_null] = ACTIONS(5618),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1652),
    [anon_sym_delete] = ACTIONS(1654),
    [sym_nullptr] = ACTIONS(5618),
  },
  [2020] = {
    [anon_sym_RPAREN] = ACTIONS(5620),
    [sym_comment] = ACTIONS(49),
  },
  [2021] = {
    [aux_sym_concatenated_string_repeat1] = STATE(2021),
    [anon_sym_LPAREN] = ACTIONS(4230),
    [anon_sym_STAR] = ACTIONS(4232),
    [anon_sym_LBRACK] = ACTIONS(4230),
    [anon_sym_EQ] = ACTIONS(4232),
    [anon_sym_COLON] = ACTIONS(4230),
    [anon_sym_QMARK] = ACTIONS(4230),
    [anon_sym_STAR_EQ] = ACTIONS(4230),
    [anon_sym_SLASH_EQ] = ACTIONS(4230),
    [anon_sym_PERCENT_EQ] = ACTIONS(4230),
    [anon_sym_PLUS_EQ] = ACTIONS(4230),
    [anon_sym_DASH_EQ] = ACTIONS(4230),
    [anon_sym_LT_LT_EQ] = ACTIONS(4230),
    [anon_sym_GT_GT_EQ] = ACTIONS(4230),
    [anon_sym_AMP_EQ] = ACTIONS(4230),
    [anon_sym_CARET_EQ] = ACTIONS(4230),
    [anon_sym_PIPE_EQ] = ACTIONS(4230),
    [anon_sym_AMP] = ACTIONS(4232),
    [anon_sym_PIPE_PIPE] = ACTIONS(4230),
    [anon_sym_AMP_AMP] = ACTIONS(4230),
    [anon_sym_PIPE] = ACTIONS(4232),
    [anon_sym_CARET] = ACTIONS(4232),
    [anon_sym_EQ_EQ] = ACTIONS(4230),
    [anon_sym_BANG_EQ] = ACTIONS(4230),
    [anon_sym_LT] = ACTIONS(4232),
    [anon_sym_GT] = ACTIONS(4232),
    [anon_sym_LT_EQ] = ACTIONS(4230),
    [anon_sym_GT_EQ] = ACTIONS(4230),
    [anon_sym_LT_LT] = ACTIONS(4232),
    [anon_sym_GT_GT] = ACTIONS(4232),
    [anon_sym_PLUS] = ACTIONS(4232),
    [anon_sym_DASH] = ACTIONS(4232),
    [anon_sym_SLASH] = ACTIONS(4232),
    [anon_sym_PERCENT] = ACTIONS(4232),
    [anon_sym_DASH_DASH] = ACTIONS(4230),
    [anon_sym_PLUS_PLUS] = ACTIONS(4230),
    [anon_sym_DOT] = ACTIONS(4230),
    [anon_sym_DASH_GT] = ACTIONS(4230),
    [sym_string_literal] = ACTIONS(5622),
    [sym_comment] = ACTIONS(49),
  },
  [2022] = {
    [sym__expression] = STATE(740),
    [sym_conditional_expression] = STATE(740),
    [sym_assignment_expression] = STATE(740),
    [sym_pointer_expression] = STATE(740),
    [sym_logical_expression] = STATE(740),
    [sym_bitwise_expression] = STATE(740),
    [sym_equality_expression] = STATE(740),
    [sym_relational_expression] = STATE(740),
    [sym_shift_expression] = STATE(740),
    [sym_math_expression] = STATE(740),
    [sym_cast_expression] = STATE(740),
    [sym_sizeof_expression] = STATE(740),
    [sym_subscript_expression] = STATE(740),
    [sym_call_expression] = STATE(740),
    [sym_field_expression] = STATE(740),
    [sym_compound_literal_expression] = STATE(740),
    [sym_parenthesized_expression] = STATE(740),
    [sym_concatenated_string] = STATE(740),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(740),
    [sym_new_expression] = STATE(740),
    [sym_delete_expression] = STATE(740),
    [sym_lambda_expression] = STATE(740),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_lambda_default_capture] = STATE(741),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(1417),
    [anon_sym_LPAREN] = ACTIONS(1419),
    [anon_sym_STAR] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_RBRACK] = ACTIONS(5625),
    [anon_sym_EQ] = ACTIONS(1425),
    [anon_sym_AMP] = ACTIONS(1427),
    [anon_sym_BANG] = ACTIONS(1429),
    [anon_sym_TILDE] = ACTIONS(1431),
    [anon_sym_PLUS] = ACTIONS(1433),
    [anon_sym_DASH] = ACTIONS(1433),
    [anon_sym_DASH_DASH] = ACTIONS(1435),
    [anon_sym_PLUS_PLUS] = ACTIONS(1435),
    [anon_sym_sizeof] = ACTIONS(1437),
    [sym_number_literal] = ACTIONS(1417),
    [sym_char_literal] = ACTIONS(1417),
    [sym_string_literal] = ACTIONS(1439),
    [sym_true] = ACTIONS(1441),
    [sym_false] = ACTIONS(1441),
    [sym_null] = ACTIONS(1441),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1443),
    [anon_sym_delete] = ACTIONS(1445),
    [sym_nullptr] = ACTIONS(1441),
  },
  [2023] = {
    [sym_argument_list] = STATE(802),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_STAR] = ACTIONS(3003),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_EQ] = ACTIONS(4260),
    [anon_sym_COLON] = ACTIONS(4258),
    [anon_sym_QMARK] = ACTIONS(4258),
    [anon_sym_STAR_EQ] = ACTIONS(4258),
    [anon_sym_SLASH_EQ] = ACTIONS(4258),
    [anon_sym_PERCENT_EQ] = ACTIONS(4258),
    [anon_sym_PLUS_EQ] = ACTIONS(4258),
    [anon_sym_DASH_EQ] = ACTIONS(4258),
    [anon_sym_LT_LT_EQ] = ACTIONS(4258),
    [anon_sym_GT_GT_EQ] = ACTIONS(4258),
    [anon_sym_AMP_EQ] = ACTIONS(4258),
    [anon_sym_CARET_EQ] = ACTIONS(4258),
    [anon_sym_PIPE_EQ] = ACTIONS(4258),
    [anon_sym_AMP] = ACTIONS(3013),
    [anon_sym_PIPE_PIPE] = ACTIONS(3015),
    [anon_sym_AMP_AMP] = ACTIONS(3017),
    [anon_sym_PIPE] = ACTIONS(3019),
    [anon_sym_CARET] = ACTIONS(3021),
    [anon_sym_EQ_EQ] = ACTIONS(3023),
    [anon_sym_BANG_EQ] = ACTIONS(3023),
    [anon_sym_LT] = ACTIONS(3025),
    [anon_sym_GT] = ACTIONS(3025),
    [anon_sym_LT_EQ] = ACTIONS(3027),
    [anon_sym_GT_EQ] = ACTIONS(3027),
    [anon_sym_LT_LT] = ACTIONS(3029),
    [anon_sym_GT_GT] = ACTIONS(3029),
    [anon_sym_PLUS] = ACTIONS(3031),
    [anon_sym_DASH] = ACTIONS(3031),
    [anon_sym_SLASH] = ACTIONS(3003),
    [anon_sym_PERCENT] = ACTIONS(3003),
    [anon_sym_DASH_DASH] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(3033),
    [anon_sym_DASH_GT] = ACTIONS(3033),
    [sym_comment] = ACTIONS(49),
  },
  [2024] = {
    [sym__expression] = STATE(2396),
    [sym_conditional_expression] = STATE(2396),
    [sym_assignment_expression] = STATE(2396),
    [sym_pointer_expression] = STATE(2396),
    [sym_logical_expression] = STATE(2396),
    [sym_bitwise_expression] = STATE(2396),
    [sym_equality_expression] = STATE(2396),
    [sym_relational_expression] = STATE(2396),
    [sym_shift_expression] = STATE(2396),
    [sym_math_expression] = STATE(2396),
    [sym_cast_expression] = STATE(2396),
    [sym_sizeof_expression] = STATE(2396),
    [sym_subscript_expression] = STATE(2396),
    [sym_call_expression] = STATE(2396),
    [sym_field_expression] = STATE(2396),
    [sym_compound_literal_expression] = STATE(2396),
    [sym_parenthesized_expression] = STATE(2396),
    [sym_concatenated_string] = STATE(2396),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(2396),
    [sym_new_expression] = STATE(2396),
    [sym_delete_expression] = STATE(2396),
    [sym_lambda_expression] = STATE(2396),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(855),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(5627),
    [anon_sym_LPAREN] = ACTIONS(2624),
    [anon_sym_STAR] = ACTIONS(2624),
    [anon_sym_LBRACK] = ACTIONS(2624),
    [anon_sym_AMP] = ACTIONS(2626),
    [anon_sym_AMP_AMP] = ACTIONS(2624),
    [anon_sym_BANG] = ACTIONS(1638),
    [anon_sym_TILDE] = ACTIONS(1640),
    [anon_sym_PLUS] = ACTIONS(1642),
    [anon_sym_DASH] = ACTIONS(1642),
    [anon_sym_DASH_DASH] = ACTIONS(1644),
    [anon_sym_PLUS_PLUS] = ACTIONS(1644),
    [anon_sym_sizeof] = ACTIONS(1646),
    [sym_number_literal] = ACTIONS(5627),
    [sym_char_literal] = ACTIONS(5627),
    [sym_string_literal] = ACTIONS(1648),
    [sym_true] = ACTIONS(5629),
    [sym_false] = ACTIONS(5629),
    [sym_null] = ACTIONS(5629),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1652),
    [anon_sym_delete] = ACTIONS(1654),
    [sym_nullptr] = ACTIONS(5629),
  },
  [2025] = {
    [sym_argument_list] = STATE(802),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_STAR] = ACTIONS(4276),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_EQ] = ACTIONS(4276),
    [anon_sym_COLON] = ACTIONS(4274),
    [anon_sym_QMARK] = ACTIONS(4274),
    [anon_sym_STAR_EQ] = ACTIONS(4274),
    [anon_sym_SLASH_EQ] = ACTIONS(4274),
    [anon_sym_PERCENT_EQ] = ACTIONS(4274),
    [anon_sym_PLUS_EQ] = ACTIONS(4274),
    [anon_sym_DASH_EQ] = ACTIONS(4274),
    [anon_sym_LT_LT_EQ] = ACTIONS(4274),
    [anon_sym_GT_GT_EQ] = ACTIONS(4274),
    [anon_sym_AMP_EQ] = ACTIONS(4274),
    [anon_sym_CARET_EQ] = ACTIONS(4274),
    [anon_sym_PIPE_EQ] = ACTIONS(4274),
    [anon_sym_AMP] = ACTIONS(4276),
    [anon_sym_PIPE_PIPE] = ACTIONS(4274),
    [anon_sym_AMP_AMP] = ACTIONS(4274),
    [anon_sym_PIPE] = ACTIONS(4276),
    [anon_sym_CARET] = ACTIONS(4276),
    [anon_sym_EQ_EQ] = ACTIONS(4274),
    [anon_sym_BANG_EQ] = ACTIONS(4274),
    [anon_sym_LT] = ACTIONS(4276),
    [anon_sym_GT] = ACTIONS(4276),
    [anon_sym_LT_EQ] = ACTIONS(4274),
    [anon_sym_GT_EQ] = ACTIONS(4274),
    [anon_sym_LT_LT] = ACTIONS(4276),
    [anon_sym_GT_GT] = ACTIONS(4276),
    [anon_sym_PLUS] = ACTIONS(4276),
    [anon_sym_DASH] = ACTIONS(4276),
    [anon_sym_SLASH] = ACTIONS(4276),
    [anon_sym_PERCENT] = ACTIONS(4276),
    [anon_sym_DASH_DASH] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(3033),
    [anon_sym_DASH_GT] = ACTIONS(3033),
    [sym_comment] = ACTIONS(49),
  },
  [2026] = {
    [sym_argument_list] = STATE(802),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_STAR] = ACTIONS(3003),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_EQ] = ACTIONS(3005),
    [anon_sym_COLON] = ACTIONS(4280),
    [anon_sym_QMARK] = ACTIONS(4280),
    [anon_sym_STAR_EQ] = ACTIONS(3011),
    [anon_sym_SLASH_EQ] = ACTIONS(3011),
    [anon_sym_PERCENT_EQ] = ACTIONS(3011),
    [anon_sym_PLUS_EQ] = ACTIONS(3011),
    [anon_sym_DASH_EQ] = ACTIONS(3011),
    [anon_sym_LT_LT_EQ] = ACTIONS(3011),
    [anon_sym_GT_GT_EQ] = ACTIONS(3011),
    [anon_sym_AMP_EQ] = ACTIONS(3011),
    [anon_sym_CARET_EQ] = ACTIONS(3011),
    [anon_sym_PIPE_EQ] = ACTIONS(3011),
    [anon_sym_AMP] = ACTIONS(3013),
    [anon_sym_PIPE_PIPE] = ACTIONS(3015),
    [anon_sym_AMP_AMP] = ACTIONS(3017),
    [anon_sym_PIPE] = ACTIONS(3019),
    [anon_sym_CARET] = ACTIONS(3021),
    [anon_sym_EQ_EQ] = ACTIONS(3023),
    [anon_sym_BANG_EQ] = ACTIONS(3023),
    [anon_sym_LT] = ACTIONS(3025),
    [anon_sym_GT] = ACTIONS(3025),
    [anon_sym_LT_EQ] = ACTIONS(3027),
    [anon_sym_GT_EQ] = ACTIONS(3027),
    [anon_sym_LT_LT] = ACTIONS(3029),
    [anon_sym_GT_GT] = ACTIONS(3029),
    [anon_sym_PLUS] = ACTIONS(3031),
    [anon_sym_DASH] = ACTIONS(3031),
    [anon_sym_SLASH] = ACTIONS(3003),
    [anon_sym_PERCENT] = ACTIONS(3003),
    [anon_sym_DASH_DASH] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(3033),
    [anon_sym_DASH_GT] = ACTIONS(3033),
    [sym_comment] = ACTIONS(49),
  },
  [2027] = {
    [sym_raw_string_literal] = ACTIONS(5631),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(5633),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(5633),
    [anon_sym_LPAREN] = ACTIONS(5631),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(5633),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(5633),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(5633),
    [sym_preproc_directive] = ACTIONS(5633),
    [anon_sym_SEMI] = ACTIONS(5631),
    [anon_sym_typedef] = ACTIONS(5633),
    [anon_sym_extern] = ACTIONS(5633),
    [anon_sym_LBRACE] = ACTIONS(5631),
    [anon_sym_RBRACE] = ACTIONS(5631),
    [anon_sym_STAR] = ACTIONS(5631),
    [anon_sym_LBRACK] = ACTIONS(5631),
    [anon_sym_static] = ACTIONS(5633),
    [anon_sym_register] = ACTIONS(5633),
    [anon_sym_inline] = ACTIONS(5633),
    [anon_sym_const] = ACTIONS(5633),
    [anon_sym_restrict] = ACTIONS(5633),
    [anon_sym_volatile] = ACTIONS(5633),
    [anon_sym__Atomic] = ACTIONS(5633),
    [anon_sym_mutable] = ACTIONS(5633),
    [anon_sym_explicit] = ACTIONS(5633),
    [anon_sym_constexpr] = ACTIONS(5633),
    [anon_sym_unsigned] = ACTIONS(5633),
    [anon_sym_long] = ACTIONS(5633),
    [anon_sym_short] = ACTIONS(5633),
    [sym_primitive_type] = ACTIONS(5633),
    [anon_sym_enum] = ACTIONS(5633),
    [anon_sym_struct] = ACTIONS(5633),
    [anon_sym_union] = ACTIONS(5633),
    [anon_sym_if] = ACTIONS(5633),
    [anon_sym_switch] = ACTIONS(5633),
    [anon_sym_case] = ACTIONS(5633),
    [anon_sym_default] = ACTIONS(5633),
    [anon_sym_while] = ACTIONS(5633),
    [anon_sym_do] = ACTIONS(5633),
    [anon_sym_for] = ACTIONS(5633),
    [anon_sym_return] = ACTIONS(5633),
    [anon_sym_break] = ACTIONS(5633),
    [anon_sym_continue] = ACTIONS(5633),
    [anon_sym_goto] = ACTIONS(5633),
    [anon_sym_AMP] = ACTIONS(5631),
    [anon_sym_BANG] = ACTIONS(5631),
    [anon_sym_TILDE] = ACTIONS(5631),
    [anon_sym_PLUS] = ACTIONS(5633),
    [anon_sym_DASH] = ACTIONS(5633),
    [anon_sym_DASH_DASH] = ACTIONS(5631),
    [anon_sym_PLUS_PLUS] = ACTIONS(5631),
    [anon_sym_sizeof] = ACTIONS(5633),
    [sym_number_literal] = ACTIONS(5631),
    [sym_char_literal] = ACTIONS(5631),
    [sym_string_literal] = ACTIONS(5631),
    [sym_true] = ACTIONS(5633),
    [sym_false] = ACTIONS(5633),
    [sym_null] = ACTIONS(5633),
    [sym_identifier] = ACTIONS(5633),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(5633),
    [sym_auto] = ACTIONS(5633),
    [anon_sym_typename] = ACTIONS(5633),
    [anon_sym_new] = ACTIONS(5633),
    [anon_sym_COLON_COLON] = ACTIONS(5631),
    [anon_sym_delete] = ACTIONS(5633),
    [sym_nullptr] = ACTIONS(5633),
  },
  [2028] = {
    [sym_argument_list] = STATE(802),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_STAR] = ACTIONS(3003),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_EQ] = ACTIONS(3005),
    [anon_sym_COLON] = ACTIONS(5635),
    [anon_sym_QMARK] = ACTIONS(3009),
    [anon_sym_STAR_EQ] = ACTIONS(3011),
    [anon_sym_SLASH_EQ] = ACTIONS(3011),
    [anon_sym_PERCENT_EQ] = ACTIONS(3011),
    [anon_sym_PLUS_EQ] = ACTIONS(3011),
    [anon_sym_DASH_EQ] = ACTIONS(3011),
    [anon_sym_LT_LT_EQ] = ACTIONS(3011),
    [anon_sym_GT_GT_EQ] = ACTIONS(3011),
    [anon_sym_AMP_EQ] = ACTIONS(3011),
    [anon_sym_CARET_EQ] = ACTIONS(3011),
    [anon_sym_PIPE_EQ] = ACTIONS(3011),
    [anon_sym_AMP] = ACTIONS(3013),
    [anon_sym_PIPE_PIPE] = ACTIONS(3015),
    [anon_sym_AMP_AMP] = ACTIONS(3017),
    [anon_sym_PIPE] = ACTIONS(3019),
    [anon_sym_CARET] = ACTIONS(3021),
    [anon_sym_EQ_EQ] = ACTIONS(3023),
    [anon_sym_BANG_EQ] = ACTIONS(3023),
    [anon_sym_LT] = ACTIONS(3025),
    [anon_sym_GT] = ACTIONS(3025),
    [anon_sym_LT_EQ] = ACTIONS(3027),
    [anon_sym_GT_EQ] = ACTIONS(3027),
    [anon_sym_LT_LT] = ACTIONS(3029),
    [anon_sym_GT_GT] = ACTIONS(3029),
    [anon_sym_PLUS] = ACTIONS(3031),
    [anon_sym_DASH] = ACTIONS(3031),
    [anon_sym_SLASH] = ACTIONS(3003),
    [anon_sym_PERCENT] = ACTIONS(3003),
    [anon_sym_DASH_DASH] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(3033),
    [anon_sym_DASH_GT] = ACTIONS(3033),
    [sym_comment] = ACTIONS(49),
  },
  [2029] = {
    [sym_argument_list] = STATE(802),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_STAR] = ACTIONS(3003),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_EQ] = ACTIONS(4286),
    [anon_sym_COLON] = ACTIONS(4284),
    [anon_sym_QMARK] = ACTIONS(4284),
    [anon_sym_STAR_EQ] = ACTIONS(4284),
    [anon_sym_SLASH_EQ] = ACTIONS(4284),
    [anon_sym_PERCENT_EQ] = ACTIONS(4284),
    [anon_sym_PLUS_EQ] = ACTIONS(4284),
    [anon_sym_DASH_EQ] = ACTIONS(4284),
    [anon_sym_LT_LT_EQ] = ACTIONS(4284),
    [anon_sym_GT_GT_EQ] = ACTIONS(4284),
    [anon_sym_AMP_EQ] = ACTIONS(4284),
    [anon_sym_CARET_EQ] = ACTIONS(4284),
    [anon_sym_PIPE_EQ] = ACTIONS(4284),
    [anon_sym_AMP] = ACTIONS(4286),
    [anon_sym_PIPE_PIPE] = ACTIONS(4284),
    [anon_sym_AMP_AMP] = ACTIONS(4284),
    [anon_sym_PIPE] = ACTIONS(4286),
    [anon_sym_CARET] = ACTIONS(4286),
    [anon_sym_EQ_EQ] = ACTIONS(3023),
    [anon_sym_BANG_EQ] = ACTIONS(3023),
    [anon_sym_LT] = ACTIONS(3025),
    [anon_sym_GT] = ACTIONS(3025),
    [anon_sym_LT_EQ] = ACTIONS(3027),
    [anon_sym_GT_EQ] = ACTIONS(3027),
    [anon_sym_LT_LT] = ACTIONS(3029),
    [anon_sym_GT_GT] = ACTIONS(3029),
    [anon_sym_PLUS] = ACTIONS(3031),
    [anon_sym_DASH] = ACTIONS(3031),
    [anon_sym_SLASH] = ACTIONS(3003),
    [anon_sym_PERCENT] = ACTIONS(3003),
    [anon_sym_DASH_DASH] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(3033),
    [anon_sym_DASH_GT] = ACTIONS(3033),
    [sym_comment] = ACTIONS(49),
  },
  [2030] = {
    [sym_argument_list] = STATE(802),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_STAR] = ACTIONS(3003),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_EQ] = ACTIONS(4290),
    [anon_sym_COLON] = ACTIONS(4288),
    [anon_sym_QMARK] = ACTIONS(4288),
    [anon_sym_STAR_EQ] = ACTIONS(4288),
    [anon_sym_SLASH_EQ] = ACTIONS(4288),
    [anon_sym_PERCENT_EQ] = ACTIONS(4288),
    [anon_sym_PLUS_EQ] = ACTIONS(4288),
    [anon_sym_DASH_EQ] = ACTIONS(4288),
    [anon_sym_LT_LT_EQ] = ACTIONS(4288),
    [anon_sym_GT_GT_EQ] = ACTIONS(4288),
    [anon_sym_AMP_EQ] = ACTIONS(4288),
    [anon_sym_CARET_EQ] = ACTIONS(4288),
    [anon_sym_PIPE_EQ] = ACTIONS(4288),
    [anon_sym_AMP] = ACTIONS(3013),
    [anon_sym_PIPE_PIPE] = ACTIONS(4288),
    [anon_sym_AMP_AMP] = ACTIONS(3017),
    [anon_sym_PIPE] = ACTIONS(3019),
    [anon_sym_CARET] = ACTIONS(3021),
    [anon_sym_EQ_EQ] = ACTIONS(3023),
    [anon_sym_BANG_EQ] = ACTIONS(3023),
    [anon_sym_LT] = ACTIONS(3025),
    [anon_sym_GT] = ACTIONS(3025),
    [anon_sym_LT_EQ] = ACTIONS(3027),
    [anon_sym_GT_EQ] = ACTIONS(3027),
    [anon_sym_LT_LT] = ACTIONS(3029),
    [anon_sym_GT_GT] = ACTIONS(3029),
    [anon_sym_PLUS] = ACTIONS(3031),
    [anon_sym_DASH] = ACTIONS(3031),
    [anon_sym_SLASH] = ACTIONS(3003),
    [anon_sym_PERCENT] = ACTIONS(3003),
    [anon_sym_DASH_DASH] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(3033),
    [anon_sym_DASH_GT] = ACTIONS(3033),
    [sym_comment] = ACTIONS(49),
  },
  [2031] = {
    [sym_argument_list] = STATE(802),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_STAR] = ACTIONS(3003),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_EQ] = ACTIONS(4290),
    [anon_sym_COLON] = ACTIONS(4288),
    [anon_sym_QMARK] = ACTIONS(4288),
    [anon_sym_STAR_EQ] = ACTIONS(4288),
    [anon_sym_SLASH_EQ] = ACTIONS(4288),
    [anon_sym_PERCENT_EQ] = ACTIONS(4288),
    [anon_sym_PLUS_EQ] = ACTIONS(4288),
    [anon_sym_DASH_EQ] = ACTIONS(4288),
    [anon_sym_LT_LT_EQ] = ACTIONS(4288),
    [anon_sym_GT_GT_EQ] = ACTIONS(4288),
    [anon_sym_AMP_EQ] = ACTIONS(4288),
    [anon_sym_CARET_EQ] = ACTIONS(4288),
    [anon_sym_PIPE_EQ] = ACTIONS(4288),
    [anon_sym_AMP] = ACTIONS(3013),
    [anon_sym_PIPE_PIPE] = ACTIONS(4288),
    [anon_sym_AMP_AMP] = ACTIONS(4288),
    [anon_sym_PIPE] = ACTIONS(3019),
    [anon_sym_CARET] = ACTIONS(3021),
    [anon_sym_EQ_EQ] = ACTIONS(3023),
    [anon_sym_BANG_EQ] = ACTIONS(3023),
    [anon_sym_LT] = ACTIONS(3025),
    [anon_sym_GT] = ACTIONS(3025),
    [anon_sym_LT_EQ] = ACTIONS(3027),
    [anon_sym_GT_EQ] = ACTIONS(3027),
    [anon_sym_LT_LT] = ACTIONS(3029),
    [anon_sym_GT_GT] = ACTIONS(3029),
    [anon_sym_PLUS] = ACTIONS(3031),
    [anon_sym_DASH] = ACTIONS(3031),
    [anon_sym_SLASH] = ACTIONS(3003),
    [anon_sym_PERCENT] = ACTIONS(3003),
    [anon_sym_DASH_DASH] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(3033),
    [anon_sym_DASH_GT] = ACTIONS(3033),
    [sym_comment] = ACTIONS(49),
  },
  [2032] = {
    [sym_argument_list] = STATE(802),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_STAR] = ACTIONS(3003),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_EQ] = ACTIONS(4286),
    [anon_sym_COLON] = ACTIONS(4284),
    [anon_sym_QMARK] = ACTIONS(4284),
    [anon_sym_STAR_EQ] = ACTIONS(4284),
    [anon_sym_SLASH_EQ] = ACTIONS(4284),
    [anon_sym_PERCENT_EQ] = ACTIONS(4284),
    [anon_sym_PLUS_EQ] = ACTIONS(4284),
    [anon_sym_DASH_EQ] = ACTIONS(4284),
    [anon_sym_LT_LT_EQ] = ACTIONS(4284),
    [anon_sym_GT_GT_EQ] = ACTIONS(4284),
    [anon_sym_AMP_EQ] = ACTIONS(4284),
    [anon_sym_CARET_EQ] = ACTIONS(4284),
    [anon_sym_PIPE_EQ] = ACTIONS(4284),
    [anon_sym_AMP] = ACTIONS(3013),
    [anon_sym_PIPE_PIPE] = ACTIONS(4284),
    [anon_sym_AMP_AMP] = ACTIONS(4284),
    [anon_sym_PIPE] = ACTIONS(4286),
    [anon_sym_CARET] = ACTIONS(3021),
    [anon_sym_EQ_EQ] = ACTIONS(3023),
    [anon_sym_BANG_EQ] = ACTIONS(3023),
    [anon_sym_LT] = ACTIONS(3025),
    [anon_sym_GT] = ACTIONS(3025),
    [anon_sym_LT_EQ] = ACTIONS(3027),
    [anon_sym_GT_EQ] = ACTIONS(3027),
    [anon_sym_LT_LT] = ACTIONS(3029),
    [anon_sym_GT_GT] = ACTIONS(3029),
    [anon_sym_PLUS] = ACTIONS(3031),
    [anon_sym_DASH] = ACTIONS(3031),
    [anon_sym_SLASH] = ACTIONS(3003),
    [anon_sym_PERCENT] = ACTIONS(3003),
    [anon_sym_DASH_DASH] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(3033),
    [anon_sym_DASH_GT] = ACTIONS(3033),
    [sym_comment] = ACTIONS(49),
  },
  [2033] = {
    [sym_argument_list] = STATE(802),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_STAR] = ACTIONS(3003),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_EQ] = ACTIONS(4286),
    [anon_sym_COLON] = ACTIONS(4284),
    [anon_sym_QMARK] = ACTIONS(4284),
    [anon_sym_STAR_EQ] = ACTIONS(4284),
    [anon_sym_SLASH_EQ] = ACTIONS(4284),
    [anon_sym_PERCENT_EQ] = ACTIONS(4284),
    [anon_sym_PLUS_EQ] = ACTIONS(4284),
    [anon_sym_DASH_EQ] = ACTIONS(4284),
    [anon_sym_LT_LT_EQ] = ACTIONS(4284),
    [anon_sym_GT_GT_EQ] = ACTIONS(4284),
    [anon_sym_AMP_EQ] = ACTIONS(4284),
    [anon_sym_CARET_EQ] = ACTIONS(4284),
    [anon_sym_PIPE_EQ] = ACTIONS(4284),
    [anon_sym_AMP] = ACTIONS(3013),
    [anon_sym_PIPE_PIPE] = ACTIONS(4284),
    [anon_sym_AMP_AMP] = ACTIONS(4284),
    [anon_sym_PIPE] = ACTIONS(4286),
    [anon_sym_CARET] = ACTIONS(4286),
    [anon_sym_EQ_EQ] = ACTIONS(3023),
    [anon_sym_BANG_EQ] = ACTIONS(3023),
    [anon_sym_LT] = ACTIONS(3025),
    [anon_sym_GT] = ACTIONS(3025),
    [anon_sym_LT_EQ] = ACTIONS(3027),
    [anon_sym_GT_EQ] = ACTIONS(3027),
    [anon_sym_LT_LT] = ACTIONS(3029),
    [anon_sym_GT_GT] = ACTIONS(3029),
    [anon_sym_PLUS] = ACTIONS(3031),
    [anon_sym_DASH] = ACTIONS(3031),
    [anon_sym_SLASH] = ACTIONS(3003),
    [anon_sym_PERCENT] = ACTIONS(3003),
    [anon_sym_DASH_DASH] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(3033),
    [anon_sym_DASH_GT] = ACTIONS(3033),
    [sym_comment] = ACTIONS(49),
  },
  [2034] = {
    [sym_argument_list] = STATE(802),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_STAR] = ACTIONS(3003),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_EQ] = ACTIONS(4294),
    [anon_sym_COLON] = ACTIONS(4292),
    [anon_sym_QMARK] = ACTIONS(4292),
    [anon_sym_STAR_EQ] = ACTIONS(4292),
    [anon_sym_SLASH_EQ] = ACTIONS(4292),
    [anon_sym_PERCENT_EQ] = ACTIONS(4292),
    [anon_sym_PLUS_EQ] = ACTIONS(4292),
    [anon_sym_DASH_EQ] = ACTIONS(4292),
    [anon_sym_LT_LT_EQ] = ACTIONS(4292),
    [anon_sym_GT_GT_EQ] = ACTIONS(4292),
    [anon_sym_AMP_EQ] = ACTIONS(4292),
    [anon_sym_CARET_EQ] = ACTIONS(4292),
    [anon_sym_PIPE_EQ] = ACTIONS(4292),
    [anon_sym_AMP] = ACTIONS(4294),
    [anon_sym_PIPE_PIPE] = ACTIONS(4292),
    [anon_sym_AMP_AMP] = ACTIONS(4292),
    [anon_sym_PIPE] = ACTIONS(4294),
    [anon_sym_CARET] = ACTIONS(4294),
    [anon_sym_EQ_EQ] = ACTIONS(4292),
    [anon_sym_BANG_EQ] = ACTIONS(4292),
    [anon_sym_LT] = ACTIONS(3025),
    [anon_sym_GT] = ACTIONS(3025),
    [anon_sym_LT_EQ] = ACTIONS(3027),
    [anon_sym_GT_EQ] = ACTIONS(3027),
    [anon_sym_LT_LT] = ACTIONS(3029),
    [anon_sym_GT_GT] = ACTIONS(3029),
    [anon_sym_PLUS] = ACTIONS(3031),
    [anon_sym_DASH] = ACTIONS(3031),
    [anon_sym_SLASH] = ACTIONS(3003),
    [anon_sym_PERCENT] = ACTIONS(3003),
    [anon_sym_DASH_DASH] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(3033),
    [anon_sym_DASH_GT] = ACTIONS(3033),
    [sym_comment] = ACTIONS(49),
  },
  [2035] = {
    [sym_argument_list] = STATE(802),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_STAR] = ACTIONS(3003),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_EQ] = ACTIONS(4298),
    [anon_sym_COLON] = ACTIONS(4296),
    [anon_sym_QMARK] = ACTIONS(4296),
    [anon_sym_STAR_EQ] = ACTIONS(4296),
    [anon_sym_SLASH_EQ] = ACTIONS(4296),
    [anon_sym_PERCENT_EQ] = ACTIONS(4296),
    [anon_sym_PLUS_EQ] = ACTIONS(4296),
    [anon_sym_DASH_EQ] = ACTIONS(4296),
    [anon_sym_LT_LT_EQ] = ACTIONS(4296),
    [anon_sym_GT_GT_EQ] = ACTIONS(4296),
    [anon_sym_AMP_EQ] = ACTIONS(4296),
    [anon_sym_CARET_EQ] = ACTIONS(4296),
    [anon_sym_PIPE_EQ] = ACTIONS(4296),
    [anon_sym_AMP] = ACTIONS(4298),
    [anon_sym_PIPE_PIPE] = ACTIONS(4296),
    [anon_sym_AMP_AMP] = ACTIONS(4296),
    [anon_sym_PIPE] = ACTIONS(4298),
    [anon_sym_CARET] = ACTIONS(4298),
    [anon_sym_EQ_EQ] = ACTIONS(4296),
    [anon_sym_BANG_EQ] = ACTIONS(4296),
    [anon_sym_LT] = ACTIONS(4298),
    [anon_sym_GT] = ACTIONS(4298),
    [anon_sym_LT_EQ] = ACTIONS(4296),
    [anon_sym_GT_EQ] = ACTIONS(4296),
    [anon_sym_LT_LT] = ACTIONS(3029),
    [anon_sym_GT_GT] = ACTIONS(3029),
    [anon_sym_PLUS] = ACTIONS(3031),
    [anon_sym_DASH] = ACTIONS(3031),
    [anon_sym_SLASH] = ACTIONS(3003),
    [anon_sym_PERCENT] = ACTIONS(3003),
    [anon_sym_DASH_DASH] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(3033),
    [anon_sym_DASH_GT] = ACTIONS(3033),
    [sym_comment] = ACTIONS(49),
  },
  [2036] = {
    [sym_argument_list] = STATE(802),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_STAR] = ACTIONS(3003),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_EQ] = ACTIONS(4302),
    [anon_sym_COLON] = ACTIONS(4300),
    [anon_sym_QMARK] = ACTIONS(4300),
    [anon_sym_STAR_EQ] = ACTIONS(4300),
    [anon_sym_SLASH_EQ] = ACTIONS(4300),
    [anon_sym_PERCENT_EQ] = ACTIONS(4300),
    [anon_sym_PLUS_EQ] = ACTIONS(4300),
    [anon_sym_DASH_EQ] = ACTIONS(4300),
    [anon_sym_LT_LT_EQ] = ACTIONS(4300),
    [anon_sym_GT_GT_EQ] = ACTIONS(4300),
    [anon_sym_AMP_EQ] = ACTIONS(4300),
    [anon_sym_CARET_EQ] = ACTIONS(4300),
    [anon_sym_PIPE_EQ] = ACTIONS(4300),
    [anon_sym_AMP] = ACTIONS(4302),
    [anon_sym_PIPE_PIPE] = ACTIONS(4300),
    [anon_sym_AMP_AMP] = ACTIONS(4300),
    [anon_sym_PIPE] = ACTIONS(4302),
    [anon_sym_CARET] = ACTIONS(4302),
    [anon_sym_EQ_EQ] = ACTIONS(4300),
    [anon_sym_BANG_EQ] = ACTIONS(4300),
    [anon_sym_LT] = ACTIONS(4302),
    [anon_sym_GT] = ACTIONS(4302),
    [anon_sym_LT_EQ] = ACTIONS(4300),
    [anon_sym_GT_EQ] = ACTIONS(4300),
    [anon_sym_LT_LT] = ACTIONS(4302),
    [anon_sym_GT_GT] = ACTIONS(4302),
    [anon_sym_PLUS] = ACTIONS(3031),
    [anon_sym_DASH] = ACTIONS(3031),
    [anon_sym_SLASH] = ACTIONS(3003),
    [anon_sym_PERCENT] = ACTIONS(3003),
    [anon_sym_DASH_DASH] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(3033),
    [anon_sym_DASH_GT] = ACTIONS(3033),
    [sym_comment] = ACTIONS(49),
  },
  [2037] = {
    [sym_argument_list] = STATE(802),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_STAR] = ACTIONS(3003),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_EQ] = ACTIONS(4276),
    [anon_sym_COLON] = ACTIONS(4274),
    [anon_sym_QMARK] = ACTIONS(4274),
    [anon_sym_STAR_EQ] = ACTIONS(4274),
    [anon_sym_SLASH_EQ] = ACTIONS(4274),
    [anon_sym_PERCENT_EQ] = ACTIONS(4274),
    [anon_sym_PLUS_EQ] = ACTIONS(4274),
    [anon_sym_DASH_EQ] = ACTIONS(4274),
    [anon_sym_LT_LT_EQ] = ACTIONS(4274),
    [anon_sym_GT_GT_EQ] = ACTIONS(4274),
    [anon_sym_AMP_EQ] = ACTIONS(4274),
    [anon_sym_CARET_EQ] = ACTIONS(4274),
    [anon_sym_PIPE_EQ] = ACTIONS(4274),
    [anon_sym_AMP] = ACTIONS(4276),
    [anon_sym_PIPE_PIPE] = ACTIONS(4274),
    [anon_sym_AMP_AMP] = ACTIONS(4274),
    [anon_sym_PIPE] = ACTIONS(4276),
    [anon_sym_CARET] = ACTIONS(4276),
    [anon_sym_EQ_EQ] = ACTIONS(4274),
    [anon_sym_BANG_EQ] = ACTIONS(4274),
    [anon_sym_LT] = ACTIONS(4276),
    [anon_sym_GT] = ACTIONS(4276),
    [anon_sym_LT_EQ] = ACTIONS(4274),
    [anon_sym_GT_EQ] = ACTIONS(4274),
    [anon_sym_LT_LT] = ACTIONS(4276),
    [anon_sym_GT_GT] = ACTIONS(4276),
    [anon_sym_PLUS] = ACTIONS(4276),
    [anon_sym_DASH] = ACTIONS(4276),
    [anon_sym_SLASH] = ACTIONS(3003),
    [anon_sym_PERCENT] = ACTIONS(3003),
    [anon_sym_DASH_DASH] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(3033),
    [anon_sym_DASH_GT] = ACTIONS(3033),
    [sym_comment] = ACTIONS(49),
  },
  [2038] = {
    [sym_destructor_name] = STATE(282),
    [anon_sym_TILDE] = ACTIONS(1500),
    [sym_identifier] = ACTIONS(5637),
    [sym_comment] = ACTIONS(49),
    [sym_operator_name] = ACTIONS(442),
  },
  [2039] = {
    [anon_sym_LPAREN] = ACTIONS(444),
    [anon_sym_COMMA] = ACTIONS(704),
    [anon_sym_SEMI] = ACTIONS(704),
    [anon_sym_extern] = ACTIONS(449),
    [anon_sym_LBRACE] = ACTIONS(447),
    [anon_sym_STAR] = ACTIONS(2720),
    [anon_sym_LBRACK] = ACTIONS(704),
    [anon_sym_EQ] = ACTIONS(706),
    [anon_sym_static] = ACTIONS(449),
    [anon_sym_register] = ACTIONS(449),
    [anon_sym_inline] = ACTIONS(449),
    [anon_sym_const] = ACTIONS(449),
    [anon_sym_restrict] = ACTIONS(449),
    [anon_sym_volatile] = ACTIONS(449),
    [anon_sym__Atomic] = ACTIONS(449),
    [anon_sym_mutable] = ACTIONS(449),
    [anon_sym_explicit] = ACTIONS(449),
    [anon_sym_constexpr] = ACTIONS(449),
    [anon_sym_QMARK] = ACTIONS(704),
    [anon_sym_STAR_EQ] = ACTIONS(704),
    [anon_sym_SLASH_EQ] = ACTIONS(704),
    [anon_sym_PERCENT_EQ] = ACTIONS(704),
    [anon_sym_PLUS_EQ] = ACTIONS(704),
    [anon_sym_DASH_EQ] = ACTIONS(704),
    [anon_sym_LT_LT_EQ] = ACTIONS(704),
    [anon_sym_GT_GT_EQ] = ACTIONS(704),
    [anon_sym_AMP_EQ] = ACTIONS(704),
    [anon_sym_CARET_EQ] = ACTIONS(704),
    [anon_sym_PIPE_EQ] = ACTIONS(704),
    [anon_sym_AMP] = ACTIONS(2720),
    [anon_sym_PIPE_PIPE] = ACTIONS(704),
    [anon_sym_AMP_AMP] = ACTIONS(444),
    [anon_sym_PIPE] = ACTIONS(706),
    [anon_sym_CARET] = ACTIONS(706),
    [anon_sym_TILDE] = ACTIONS(447),
    [anon_sym_EQ_EQ] = ACTIONS(704),
    [anon_sym_BANG_EQ] = ACTIONS(704),
    [anon_sym_LT] = ACTIONS(706),
    [anon_sym_GT] = ACTIONS(706),
    [anon_sym_LT_EQ] = ACTIONS(704),
    [anon_sym_GT_EQ] = ACTIONS(704),
    [anon_sym_LT_LT] = ACTIONS(706),
    [anon_sym_GT_GT] = ACTIONS(706),
    [anon_sym_PLUS] = ACTIONS(706),
    [anon_sym_DASH] = ACTIONS(706),
    [anon_sym_SLASH] = ACTIONS(706),
    [anon_sym_PERCENT] = ACTIONS(706),
    [anon_sym_DASH_DASH] = ACTIONS(704),
    [anon_sym_PLUS_PLUS] = ACTIONS(704),
    [anon_sym_DOT] = ACTIONS(704),
    [anon_sym_DASH_GT] = ACTIONS(704),
    [sym_identifier] = ACTIONS(449),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(447),
    [sym_operator_name] = ACTIONS(447),
  },
  [2040] = {
    [anon_sym_LPAREN] = ACTIONS(509),
    [anon_sym_COMMA] = ACTIONS(518),
    [anon_sym_SEMI] = ACTIONS(518),
    [anon_sym_extern] = ACTIONS(514),
    [anon_sym_LBRACE] = ACTIONS(512),
    [anon_sym_STAR] = ACTIONS(2729),
    [anon_sym_LBRACK] = ACTIONS(518),
    [anon_sym_EQ] = ACTIONS(520),
    [anon_sym_static] = ACTIONS(514),
    [anon_sym_register] = ACTIONS(514),
    [anon_sym_inline] = ACTIONS(514),
    [anon_sym_const] = ACTIONS(514),
    [anon_sym_restrict] = ACTIONS(514),
    [anon_sym_volatile] = ACTIONS(514),
    [anon_sym__Atomic] = ACTIONS(514),
    [anon_sym_mutable] = ACTIONS(514),
    [anon_sym_explicit] = ACTIONS(514),
    [anon_sym_constexpr] = ACTIONS(514),
    [anon_sym_QMARK] = ACTIONS(518),
    [anon_sym_STAR_EQ] = ACTIONS(518),
    [anon_sym_SLASH_EQ] = ACTIONS(518),
    [anon_sym_PERCENT_EQ] = ACTIONS(518),
    [anon_sym_PLUS_EQ] = ACTIONS(518),
    [anon_sym_DASH_EQ] = ACTIONS(518),
    [anon_sym_LT_LT_EQ] = ACTIONS(518),
    [anon_sym_GT_GT_EQ] = ACTIONS(518),
    [anon_sym_AMP_EQ] = ACTIONS(518),
    [anon_sym_CARET_EQ] = ACTIONS(518),
    [anon_sym_PIPE_EQ] = ACTIONS(518),
    [anon_sym_AMP] = ACTIONS(2729),
    [anon_sym_PIPE_PIPE] = ACTIONS(518),
    [anon_sym_AMP_AMP] = ACTIONS(509),
    [anon_sym_PIPE] = ACTIONS(520),
    [anon_sym_CARET] = ACTIONS(520),
    [anon_sym_TILDE] = ACTIONS(512),
    [anon_sym_EQ_EQ] = ACTIONS(518),
    [anon_sym_BANG_EQ] = ACTIONS(518),
    [anon_sym_LT] = ACTIONS(2729),
    [anon_sym_GT] = ACTIONS(520),
    [anon_sym_LT_EQ] = ACTIONS(518),
    [anon_sym_GT_EQ] = ACTIONS(518),
    [anon_sym_LT_LT] = ACTIONS(520),
    [anon_sym_GT_GT] = ACTIONS(520),
    [anon_sym_PLUS] = ACTIONS(520),
    [anon_sym_DASH] = ACTIONS(520),
    [anon_sym_SLASH] = ACTIONS(520),
    [anon_sym_PERCENT] = ACTIONS(520),
    [anon_sym_DASH_DASH] = ACTIONS(518),
    [anon_sym_PLUS_PLUS] = ACTIONS(518),
    [anon_sym_DOT] = ACTIONS(518),
    [anon_sym_DASH_GT] = ACTIONS(518),
    [sym_identifier] = ACTIONS(514),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(516),
    [sym_operator_name] = ACTIONS(512),
  },
  [2041] = {
    [sym_destructor_name] = STATE(428),
    [anon_sym_TILDE] = ACTIONS(1500),
    [sym_identifier] = ACTIONS(5639),
    [sym_comment] = ACTIONS(49),
    [sym_operator_name] = ACTIONS(702),
  },
  [2042] = {
    [sym_compound_statement] = STATE(2400),
    [sym_labeled_statement] = STATE(2400),
    [sym_expression_statement] = STATE(2400),
    [sym_if_statement] = STATE(2400),
    [sym_switch_statement] = STATE(2400),
    [sym_case_statement] = STATE(2400),
    [sym_while_statement] = STATE(2400),
    [sym_do_statement] = STATE(2400),
    [sym_for_statement] = STATE(2400),
    [sym_return_statement] = STATE(2400),
    [sym_break_statement] = STATE(2400),
    [sym_continue_statement] = STATE(2400),
    [sym_goto_statement] = STATE(2400),
    [sym__expression] = STATE(413),
    [sym_comma_expression] = STATE(414),
    [sym_conditional_expression] = STATE(413),
    [sym_assignment_expression] = STATE(413),
    [sym_pointer_expression] = STATE(413),
    [sym_logical_expression] = STATE(413),
    [sym_bitwise_expression] = STATE(413),
    [sym_equality_expression] = STATE(413),
    [sym_relational_expression] = STATE(413),
    [sym_shift_expression] = STATE(413),
    [sym_math_expression] = STATE(413),
    [sym_cast_expression] = STATE(413),
    [sym_sizeof_expression] = STATE(413),
    [sym_subscript_expression] = STATE(413),
    [sym_call_expression] = STATE(413),
    [sym_field_expression] = STATE(413),
    [sym_compound_literal_expression] = STATE(413),
    [sym_parenthesized_expression] = STATE(413),
    [sym_concatenated_string] = STATE(413),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(413),
    [sym_for_range_loop] = STATE(2400),
    [sym_new_expression] = STATE(413),
    [sym_delete_expression] = STATE(413),
    [sym_lambda_expression] = STATE(413),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(620),
    [anon_sym_LPAREN] = ACTIONS(626),
    [anon_sym_SEMI] = ACTIONS(636),
    [anon_sym_LBRACE] = ACTIONS(640),
    [anon_sym_STAR] = ACTIONS(644),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_if] = ACTIONS(646),
    [anon_sym_switch] = ACTIONS(648),
    [anon_sym_case] = ACTIONS(650),
    [anon_sym_default] = ACTIONS(652),
    [anon_sym_while] = ACTIONS(654),
    [anon_sym_do] = ACTIONS(656),
    [anon_sym_for] = ACTIONS(658),
    [anon_sym_return] = ACTIONS(660),
    [anon_sym_break] = ACTIONS(662),
    [anon_sym_continue] = ACTIONS(664),
    [anon_sym_goto] = ACTIONS(666),
    [anon_sym_AMP] = ACTIONS(644),
    [anon_sym_BANG] = ACTIONS(668),
    [anon_sym_TILDE] = ACTIONS(670),
    [anon_sym_PLUS] = ACTIONS(672),
    [anon_sym_DASH] = ACTIONS(672),
    [anon_sym_DASH_DASH] = ACTIONS(674),
    [anon_sym_PLUS_PLUS] = ACTIONS(674),
    [anon_sym_sizeof] = ACTIONS(676),
    [sym_number_literal] = ACTIONS(620),
    [sym_char_literal] = ACTIONS(620),
    [sym_string_literal] = ACTIONS(678),
    [sym_true] = ACTIONS(680),
    [sym_false] = ACTIONS(680),
    [sym_null] = ACTIONS(680),
    [sym_identifier] = ACTIONS(3110),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1303),
    [anon_sym_delete] = ACTIONS(686),
    [sym_nullptr] = ACTIONS(680),
  },
  [2043] = {
    [anon_sym_LPAREN] = ACTIONS(3182),
    [anon_sym_COMMA] = ACTIONS(3182),
    [anon_sym_RPAREN] = ACTIONS(3182),
    [anon_sym_SEMI] = ACTIONS(3182),
    [anon_sym_RBRACE] = ACTIONS(3182),
    [anon_sym_STAR] = ACTIONS(3184),
    [anon_sym_LBRACK] = ACTIONS(3182),
    [anon_sym_RBRACK] = ACTIONS(3182),
    [anon_sym_EQ] = ACTIONS(3184),
    [anon_sym_COLON] = ACTIONS(3182),
    [anon_sym_else] = ACTIONS(3182),
    [anon_sym_while] = ACTIONS(3182),
    [anon_sym_QMARK] = ACTIONS(3182),
    [anon_sym_STAR_EQ] = ACTIONS(3182),
    [anon_sym_SLASH_EQ] = ACTIONS(3182),
    [anon_sym_PERCENT_EQ] = ACTIONS(3182),
    [anon_sym_PLUS_EQ] = ACTIONS(3182),
    [anon_sym_DASH_EQ] = ACTIONS(3182),
    [anon_sym_LT_LT_EQ] = ACTIONS(3182),
    [anon_sym_GT_GT_EQ] = ACTIONS(3182),
    [anon_sym_AMP_EQ] = ACTIONS(3182),
    [anon_sym_CARET_EQ] = ACTIONS(3182),
    [anon_sym_PIPE_EQ] = ACTIONS(3182),
    [anon_sym_AMP] = ACTIONS(3184),
    [anon_sym_PIPE_PIPE] = ACTIONS(3182),
    [anon_sym_AMP_AMP] = ACTIONS(3182),
    [anon_sym_PIPE] = ACTIONS(3184),
    [anon_sym_CARET] = ACTIONS(3184),
    [anon_sym_EQ_EQ] = ACTIONS(3182),
    [anon_sym_BANG_EQ] = ACTIONS(3182),
    [anon_sym_LT] = ACTIONS(3184),
    [anon_sym_GT] = ACTIONS(3184),
    [anon_sym_LT_EQ] = ACTIONS(3182),
    [anon_sym_GT_EQ] = ACTIONS(3182),
    [anon_sym_LT_LT] = ACTIONS(3184),
    [anon_sym_GT_GT] = ACTIONS(3184),
    [anon_sym_PLUS] = ACTIONS(3184),
    [anon_sym_DASH] = ACTIONS(3184),
    [anon_sym_SLASH] = ACTIONS(3184),
    [anon_sym_PERCENT] = ACTIONS(3184),
    [anon_sym_DASH_DASH] = ACTIONS(3182),
    [anon_sym_PLUS_PLUS] = ACTIONS(3182),
    [anon_sym_DOT] = ACTIONS(3182),
    [anon_sym_DASH_GT] = ACTIONS(3182),
    [sym_comment] = ACTIONS(49),
  },
  [2044] = {
    [sym_argument_list] = STATE(802),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_RPAREN] = ACTIONS(5641),
    [anon_sym_STAR] = ACTIONS(4537),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_EQ] = ACTIONS(4539),
    [anon_sym_QMARK] = ACTIONS(4541),
    [anon_sym_STAR_EQ] = ACTIONS(4543),
    [anon_sym_SLASH_EQ] = ACTIONS(4543),
    [anon_sym_PERCENT_EQ] = ACTIONS(4543),
    [anon_sym_PLUS_EQ] = ACTIONS(4543),
    [anon_sym_DASH_EQ] = ACTIONS(4543),
    [anon_sym_LT_LT_EQ] = ACTIONS(4543),
    [anon_sym_GT_GT_EQ] = ACTIONS(4543),
    [anon_sym_AMP_EQ] = ACTIONS(4543),
    [anon_sym_CARET_EQ] = ACTIONS(4543),
    [anon_sym_PIPE_EQ] = ACTIONS(4543),
    [anon_sym_AMP] = ACTIONS(4545),
    [anon_sym_PIPE_PIPE] = ACTIONS(4547),
    [anon_sym_AMP_AMP] = ACTIONS(4549),
    [anon_sym_PIPE] = ACTIONS(4551),
    [anon_sym_CARET] = ACTIONS(4553),
    [anon_sym_EQ_EQ] = ACTIONS(4555),
    [anon_sym_BANG_EQ] = ACTIONS(4555),
    [anon_sym_LT] = ACTIONS(4557),
    [anon_sym_GT] = ACTIONS(4557),
    [anon_sym_LT_EQ] = ACTIONS(4559),
    [anon_sym_GT_EQ] = ACTIONS(4559),
    [anon_sym_LT_LT] = ACTIONS(4561),
    [anon_sym_GT_GT] = ACTIONS(4561),
    [anon_sym_PLUS] = ACTIONS(4563),
    [anon_sym_DASH] = ACTIONS(4563),
    [anon_sym_SLASH] = ACTIONS(4537),
    [anon_sym_PERCENT] = ACTIONS(4537),
    [anon_sym_DASH_DASH] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(1554),
    [anon_sym_DASH_GT] = ACTIONS(1554),
    [sym_comment] = ACTIONS(49),
  },
  [2045] = {
    [sym__expression] = STATE(2402),
    [sym_conditional_expression] = STATE(2402),
    [sym_assignment_expression] = STATE(2402),
    [sym_pointer_expression] = STATE(2402),
    [sym_logical_expression] = STATE(2402),
    [sym_bitwise_expression] = STATE(2402),
    [sym_equality_expression] = STATE(2402),
    [sym_relational_expression] = STATE(2402),
    [sym_shift_expression] = STATE(2402),
    [sym_math_expression] = STATE(2402),
    [sym_cast_expression] = STATE(2402),
    [sym_sizeof_expression] = STATE(2402),
    [sym_subscript_expression] = STATE(2402),
    [sym_call_expression] = STATE(2402),
    [sym_field_expression] = STATE(2402),
    [sym_compound_literal_expression] = STATE(2402),
    [sym_parenthesized_expression] = STATE(2402),
    [sym_concatenated_string] = STATE(2402),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(2402),
    [sym_new_expression] = STATE(2402),
    [sym_delete_expression] = STATE(2402),
    [sym_lambda_expression] = STATE(2402),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(5643),
    [anon_sym_LPAREN] = ACTIONS(2943),
    [anon_sym_STAR] = ACTIONS(2945),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_AMP] = ACTIONS(2945),
    [anon_sym_BANG] = ACTIONS(2947),
    [anon_sym_TILDE] = ACTIONS(2949),
    [anon_sym_PLUS] = ACTIONS(2951),
    [anon_sym_DASH] = ACTIONS(2951),
    [anon_sym_DASH_DASH] = ACTIONS(2953),
    [anon_sym_PLUS_PLUS] = ACTIONS(2953),
    [anon_sym_sizeof] = ACTIONS(2955),
    [sym_number_literal] = ACTIONS(5643),
    [sym_char_literal] = ACTIONS(5643),
    [sym_string_literal] = ACTIONS(2957),
    [sym_true] = ACTIONS(5645),
    [sym_false] = ACTIONS(5645),
    [sym_null] = ACTIONS(5645),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(2961),
    [anon_sym_delete] = ACTIONS(2963),
    [sym_nullptr] = ACTIONS(5645),
  },
  [2046] = {
    [sym_argument_list] = STATE(802),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_RPAREN] = ACTIONS(5647),
    [anon_sym_STAR] = ACTIONS(4537),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_EQ] = ACTIONS(4539),
    [anon_sym_QMARK] = ACTIONS(4541),
    [anon_sym_STAR_EQ] = ACTIONS(4543),
    [anon_sym_SLASH_EQ] = ACTIONS(4543),
    [anon_sym_PERCENT_EQ] = ACTIONS(4543),
    [anon_sym_PLUS_EQ] = ACTIONS(4543),
    [anon_sym_DASH_EQ] = ACTIONS(4543),
    [anon_sym_LT_LT_EQ] = ACTIONS(4543),
    [anon_sym_GT_GT_EQ] = ACTIONS(4543),
    [anon_sym_AMP_EQ] = ACTIONS(4543),
    [anon_sym_CARET_EQ] = ACTIONS(4543),
    [anon_sym_PIPE_EQ] = ACTIONS(4543),
    [anon_sym_AMP] = ACTIONS(4545),
    [anon_sym_PIPE_PIPE] = ACTIONS(4547),
    [anon_sym_AMP_AMP] = ACTIONS(4549),
    [anon_sym_PIPE] = ACTIONS(4551),
    [anon_sym_CARET] = ACTIONS(4553),
    [anon_sym_EQ_EQ] = ACTIONS(4555),
    [anon_sym_BANG_EQ] = ACTIONS(4555),
    [anon_sym_LT] = ACTIONS(4557),
    [anon_sym_GT] = ACTIONS(4557),
    [anon_sym_LT_EQ] = ACTIONS(4559),
    [anon_sym_GT_EQ] = ACTIONS(4559),
    [anon_sym_LT_LT] = ACTIONS(4561),
    [anon_sym_GT_GT] = ACTIONS(4561),
    [anon_sym_PLUS] = ACTIONS(4563),
    [anon_sym_DASH] = ACTIONS(4563),
    [anon_sym_SLASH] = ACTIONS(4537),
    [anon_sym_PERCENT] = ACTIONS(4537),
    [anon_sym_DASH_DASH] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(1554),
    [anon_sym_DASH_GT] = ACTIONS(1554),
    [sym_comment] = ACTIONS(49),
  },
  [2047] = {
    [sym_declaration] = STATE(2404),
    [sym_type_definition] = STATE(2404),
    [sym__declaration_specifiers] = STATE(2051),
    [sym_compound_statement] = STATE(2404),
    [sym_storage_class_specifier] = STATE(109),
    [sym_type_qualifier] = STATE(109),
    [sym__type_specifier] = STATE(105),
    [sym_sized_type_specifier] = STATE(105),
    [sym_enum_specifier] = STATE(105),
    [sym_struct_specifier] = STATE(105),
    [sym_union_specifier] = STATE(105),
    [sym_labeled_statement] = STATE(2404),
    [sym_expression_statement] = STATE(2404),
    [sym_if_statement] = STATE(2404),
    [sym_switch_statement] = STATE(2404),
    [sym_case_statement] = STATE(2404),
    [sym_while_statement] = STATE(2404),
    [sym_do_statement] = STATE(2404),
    [sym_for_statement] = STATE(2404),
    [sym_return_statement] = STATE(2404),
    [sym_break_statement] = STATE(2404),
    [sym_continue_statement] = STATE(2404),
    [sym_goto_statement] = STATE(2404),
    [sym__expression] = STATE(873),
    [sym_comma_expression] = STATE(874),
    [sym_conditional_expression] = STATE(873),
    [sym_assignment_expression] = STATE(873),
    [sym_pointer_expression] = STATE(873),
    [sym_logical_expression] = STATE(873),
    [sym_bitwise_expression] = STATE(873),
    [sym_equality_expression] = STATE(873),
    [sym_relational_expression] = STATE(873),
    [sym_shift_expression] = STATE(873),
    [sym_math_expression] = STATE(873),
    [sym_cast_expression] = STATE(873),
    [sym_sizeof_expression] = STATE(873),
    [sym_subscript_expression] = STATE(873),
    [sym_call_expression] = STATE(873),
    [sym_field_expression] = STATE(873),
    [sym_compound_literal_expression] = STATE(873),
    [sym_parenthesized_expression] = STATE(873),
    [sym_concatenated_string] = STATE(873),
    [sym_macro_type_specifier] = STATE(105),
    [sym_class_specifier] = STATE(105),
    [sym_dependent_type] = STATE(105),
    [sym_template_type] = STATE(1475),
    [sym_template_function] = STATE(873),
    [sym_for_range_loop] = STATE(2404),
    [sym_new_expression] = STATE(873),
    [sym_delete_expression] = STATE(873),
    [sym_lambda_expression] = STATE(873),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(416),
    [sym_scoped_namespace_identifier] = STATE(1476),
    [aux_sym__declaration_specifiers_repeat1] = STATE(109),
    [aux_sym_sized_type_specifier_repeat1] = STATE(110),
    [sym_raw_string_literal] = ACTIONS(1660),
    [anon_sym_LPAREN] = ACTIONS(626),
    [anon_sym_SEMI] = ACTIONS(1662),
    [anon_sym_typedef] = ACTIONS(4657),
    [anon_sym_extern] = ACTIONS(154),
    [anon_sym_LBRACE] = ACTIONS(1664),
    [anon_sym_STAR] = ACTIONS(644),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_static] = ACTIONS(154),
    [anon_sym_register] = ACTIONS(154),
    [anon_sym_inline] = ACTIONS(154),
    [anon_sym_const] = ACTIONS(158),
    [anon_sym_restrict] = ACTIONS(158),
    [anon_sym_volatile] = ACTIONS(158),
    [anon_sym__Atomic] = ACTIONS(158),
    [anon_sym_mutable] = ACTIONS(158),
    [anon_sym_explicit] = ACTIONS(158),
    [anon_sym_constexpr] = ACTIONS(158),
    [anon_sym_unsigned] = ACTIONS(160),
    [anon_sym_long] = ACTIONS(160),
    [anon_sym_short] = ACTIONS(160),
    [sym_primitive_type] = ACTIONS(162),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_union] = ACTIONS(39),
    [anon_sym_if] = ACTIONS(1666),
    [anon_sym_switch] = ACTIONS(1668),
    [anon_sym_case] = ACTIONS(1670),
    [anon_sym_default] = ACTIONS(1672),
    [anon_sym_while] = ACTIONS(1674),
    [anon_sym_do] = ACTIONS(1676),
    [anon_sym_for] = ACTIONS(1678),
    [anon_sym_return] = ACTIONS(1680),
    [anon_sym_break] = ACTIONS(1682),
    [anon_sym_continue] = ACTIONS(1684),
    [anon_sym_goto] = ACTIONS(1686),
    [anon_sym_AMP] = ACTIONS(644),
    [anon_sym_BANG] = ACTIONS(668),
    [anon_sym_TILDE] = ACTIONS(670),
    [anon_sym_PLUS] = ACTIONS(672),
    [anon_sym_DASH] = ACTIONS(672),
    [anon_sym_DASH_DASH] = ACTIONS(674),
    [anon_sym_PLUS_PLUS] = ACTIONS(674),
    [anon_sym_sizeof] = ACTIONS(676),
    [sym_number_literal] = ACTIONS(1660),
    [sym_char_literal] = ACTIONS(1660),
    [sym_string_literal] = ACTIONS(678),
    [sym_true] = ACTIONS(1688),
    [sym_false] = ACTIONS(1688),
    [sym_null] = ACTIONS(1688),
    [sym_identifier] = ACTIONS(4659),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(51),
    [sym_auto] = ACTIONS(162),
    [anon_sym_typename] = ACTIONS(172),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(3040),
    [anon_sym_delete] = ACTIONS(686),
    [sym_nullptr] = ACTIONS(1688),
  },
  [2048] = {
    [sym_type_qualifier] = STATE(2406),
    [sym__type_specifier] = STATE(2405),
    [sym_sized_type_specifier] = STATE(2405),
    [sym_enum_specifier] = STATE(2405),
    [sym_struct_specifier] = STATE(2405),
    [sym_union_specifier] = STATE(2405),
    [sym_macro_type_specifier] = STATE(2405),
    [sym_class_specifier] = STATE(2405),
    [sym_dependent_type] = STATE(2405),
    [sym_template_type] = STATE(62),
    [sym_scoped_type_identifier] = STATE(63),
    [sym_scoped_namespace_identifier] = STATE(64),
    [aux_sym_type_definition_repeat1] = STATE(2406),
    [aux_sym_sized_type_specifier_repeat1] = STATE(66),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_restrict] = ACTIONS(93),
    [anon_sym_volatile] = ACTIONS(93),
    [anon_sym__Atomic] = ACTIONS(93),
    [anon_sym_mutable] = ACTIONS(93),
    [anon_sym_explicit] = ACTIONS(93),
    [anon_sym_constexpr] = ACTIONS(93),
    [anon_sym_unsigned] = ACTIONS(95),
    [anon_sym_long] = ACTIONS(95),
    [anon_sym_short] = ACTIONS(95),
    [sym_primitive_type] = ACTIONS(5649),
    [anon_sym_enum] = ACTIONS(99),
    [anon_sym_struct] = ACTIONS(101),
    [anon_sym_union] = ACTIONS(103),
    [sym_identifier] = ACTIONS(105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(107),
    [sym_auto] = ACTIONS(5649),
    [anon_sym_typename] = ACTIONS(109),
    [anon_sym_COLON_COLON] = ACTIONS(111),
  },
  [2049] = {
    [sym_initializer_list] = STATE(765),
    [sym_template_argument_list] = STATE(2039),
    [anon_sym_LPAREN] = ACTIONS(1483),
    [anon_sym_COMMA] = ACTIONS(1477),
    [anon_sym_SEMI] = ACTIONS(1477),
    [anon_sym_extern] = ACTIONS(144),
    [anon_sym_LBRACE] = ACTIONS(548),
    [anon_sym_STAR] = ACTIONS(1486),
    [anon_sym_LBRACK] = ACTIONS(1477),
    [anon_sym_EQ] = ACTIONS(1479),
    [anon_sym_static] = ACTIONS(144),
    [anon_sym_register] = ACTIONS(144),
    [anon_sym_inline] = ACTIONS(144),
    [anon_sym_const] = ACTIONS(144),
    [anon_sym_restrict] = ACTIONS(144),
    [anon_sym_volatile] = ACTIONS(144),
    [anon_sym__Atomic] = ACTIONS(144),
    [anon_sym_mutable] = ACTIONS(144),
    [anon_sym_explicit] = ACTIONS(144),
    [anon_sym_constexpr] = ACTIONS(144),
    [anon_sym_COLON] = ACTIONS(3076),
    [anon_sym_QMARK] = ACTIONS(1477),
    [anon_sym_STAR_EQ] = ACTIONS(1477),
    [anon_sym_SLASH_EQ] = ACTIONS(1477),
    [anon_sym_PERCENT_EQ] = ACTIONS(1477),
    [anon_sym_PLUS_EQ] = ACTIONS(1477),
    [anon_sym_DASH_EQ] = ACTIONS(1477),
    [anon_sym_LT_LT_EQ] = ACTIONS(1477),
    [anon_sym_GT_GT_EQ] = ACTIONS(1477),
    [anon_sym_AMP_EQ] = ACTIONS(1477),
    [anon_sym_CARET_EQ] = ACTIONS(1477),
    [anon_sym_PIPE_EQ] = ACTIONS(1477),
    [anon_sym_AMP] = ACTIONS(1486),
    [anon_sym_PIPE_PIPE] = ACTIONS(1477),
    [anon_sym_AMP_AMP] = ACTIONS(1483),
    [anon_sym_PIPE] = ACTIONS(1479),
    [anon_sym_CARET] = ACTIONS(1479),
    [anon_sym_TILDE] = ACTIONS(142),
    [anon_sym_EQ_EQ] = ACTIONS(1477),
    [anon_sym_BANG_EQ] = ACTIONS(1477),
    [anon_sym_LT] = ACTIONS(1564),
    [anon_sym_GT] = ACTIONS(1479),
    [anon_sym_LT_EQ] = ACTIONS(1477),
    [anon_sym_GT_EQ] = ACTIONS(1477),
    [anon_sym_LT_LT] = ACTIONS(1479),
    [anon_sym_GT_GT] = ACTIONS(1479),
    [anon_sym_PLUS] = ACTIONS(1479),
    [anon_sym_DASH] = ACTIONS(1479),
    [anon_sym_SLASH] = ACTIONS(1479),
    [anon_sym_PERCENT] = ACTIONS(1479),
    [anon_sym_DASH_DASH] = ACTIONS(1477),
    [anon_sym_PLUS_PLUS] = ACTIONS(1477),
    [anon_sym_DOT] = ACTIONS(1477),
    [anon_sym_DASH_GT] = ACTIONS(1477),
    [sym_identifier] = ACTIONS(144),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(4631),
    [sym_operator_name] = ACTIONS(142),
  },
  [2050] = {
    [anon_sym_else] = ACTIONS(4635),
    [anon_sym_while] = ACTIONS(4635),
    [sym_comment] = ACTIONS(49),
  },
  [2051] = {
    [sym__declarator] = STATE(2407),
    [sym_pointer_declarator] = STATE(2407),
    [sym_function_declarator] = STATE(2407),
    [sym_array_declarator] = STATE(2407),
    [sym_init_declarator] = STATE(2408),
    [sym_reference_declarator] = STATE(2407),
    [sym_template_type] = STATE(46),
    [sym_template_function] = STATE(2407),
    [sym_destructor_name] = STATE(2407),
    [sym_scoped_identifier] = STATE(33),
    [sym_scoped_type_identifier] = STATE(47),
    [sym_scoped_namespace_identifier] = STATE(46),
    [anon_sym_LPAREN] = ACTIONS(11),
    [anon_sym_STAR] = ACTIONS(196),
    [anon_sym_AMP] = ACTIONS(526),
    [anon_sym_AMP_AMP] = ACTIONS(528),
    [anon_sym_TILDE] = ACTIONS(45),
    [sym_identifier] = ACTIONS(75),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(77),
    [sym_operator_name] = ACTIONS(5651),
  },
  [2052] = {
    [sym_argument_list] = STATE(802),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_RPAREN] = ACTIONS(5653),
    [anon_sym_STAR] = ACTIONS(4537),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_EQ] = ACTIONS(4539),
    [anon_sym_QMARK] = ACTIONS(4541),
    [anon_sym_STAR_EQ] = ACTIONS(4543),
    [anon_sym_SLASH_EQ] = ACTIONS(4543),
    [anon_sym_PERCENT_EQ] = ACTIONS(4543),
    [anon_sym_PLUS_EQ] = ACTIONS(4543),
    [anon_sym_DASH_EQ] = ACTIONS(4543),
    [anon_sym_LT_LT_EQ] = ACTIONS(4543),
    [anon_sym_GT_GT_EQ] = ACTIONS(4543),
    [anon_sym_AMP_EQ] = ACTIONS(4543),
    [anon_sym_CARET_EQ] = ACTIONS(4543),
    [anon_sym_PIPE_EQ] = ACTIONS(4543),
    [anon_sym_AMP] = ACTIONS(4545),
    [anon_sym_PIPE_PIPE] = ACTIONS(4547),
    [anon_sym_AMP_AMP] = ACTIONS(4549),
    [anon_sym_PIPE] = ACTIONS(4551),
    [anon_sym_CARET] = ACTIONS(4553),
    [anon_sym_EQ_EQ] = ACTIONS(4555),
    [anon_sym_BANG_EQ] = ACTIONS(4555),
    [anon_sym_LT] = ACTIONS(4557),
    [anon_sym_GT] = ACTIONS(4557),
    [anon_sym_LT_EQ] = ACTIONS(4559),
    [anon_sym_GT_EQ] = ACTIONS(4559),
    [anon_sym_LT_LT] = ACTIONS(4561),
    [anon_sym_GT_GT] = ACTIONS(4561),
    [anon_sym_PLUS] = ACTIONS(4563),
    [anon_sym_DASH] = ACTIONS(4563),
    [anon_sym_SLASH] = ACTIONS(4537),
    [anon_sym_PERCENT] = ACTIONS(4537),
    [anon_sym_DASH_DASH] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(1554),
    [anon_sym_DASH_GT] = ACTIONS(1554),
    [sym_comment] = ACTIONS(49),
  },
  [2053] = {
    [anon_sym_LPAREN] = ACTIONS(5655),
    [sym_comment] = ACTIONS(49),
  },
  [2054] = {
    [sym__expression] = STATE(2412),
    [sym_conditional_expression] = STATE(2412),
    [sym_assignment_expression] = STATE(2412),
    [sym_pointer_expression] = STATE(2412),
    [sym_logical_expression] = STATE(2412),
    [sym_bitwise_expression] = STATE(2412),
    [sym_equality_expression] = STATE(2412),
    [sym_relational_expression] = STATE(2412),
    [sym_shift_expression] = STATE(2412),
    [sym_math_expression] = STATE(2412),
    [sym_cast_expression] = STATE(2412),
    [sym_sizeof_expression] = STATE(2412),
    [sym_subscript_expression] = STATE(2412),
    [sym_call_expression] = STATE(2412),
    [sym_field_expression] = STATE(2412),
    [sym_compound_literal_expression] = STATE(2412),
    [sym_parenthesized_expression] = STATE(2412),
    [sym_concatenated_string] = STATE(2412),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(2412),
    [sym_new_expression] = STATE(2412),
    [sym_delete_expression] = STATE(2412),
    [sym_lambda_expression] = STATE(2412),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(5657),
    [anon_sym_LPAREN] = ACTIONS(1347),
    [anon_sym_SEMI] = ACTIONS(5659),
    [anon_sym_STAR] = ACTIONS(1349),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_AMP] = ACTIONS(1349),
    [anon_sym_BANG] = ACTIONS(1351),
    [anon_sym_TILDE] = ACTIONS(1353),
    [anon_sym_PLUS] = ACTIONS(1355),
    [anon_sym_DASH] = ACTIONS(1355),
    [anon_sym_DASH_DASH] = ACTIONS(1357),
    [anon_sym_PLUS_PLUS] = ACTIONS(1357),
    [anon_sym_sizeof] = ACTIONS(1359),
    [sym_number_literal] = ACTIONS(5657),
    [sym_char_literal] = ACTIONS(5657),
    [sym_string_literal] = ACTIONS(1361),
    [sym_true] = ACTIONS(5661),
    [sym_false] = ACTIONS(5661),
    [sym_null] = ACTIONS(5661),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1365),
    [anon_sym_delete] = ACTIONS(1367),
    [sym_nullptr] = ACTIONS(5661),
  },
  [2055] = {
    [sym_argument_list] = STATE(802),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_SEMI] = ACTIONS(5663),
    [anon_sym_STAR] = ACTIONS(2553),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_EQ] = ACTIONS(2555),
    [anon_sym_QMARK] = ACTIONS(2557),
    [anon_sym_STAR_EQ] = ACTIONS(2559),
    [anon_sym_SLASH_EQ] = ACTIONS(2559),
    [anon_sym_PERCENT_EQ] = ACTIONS(2559),
    [anon_sym_PLUS_EQ] = ACTIONS(2559),
    [anon_sym_DASH_EQ] = ACTIONS(2559),
    [anon_sym_LT_LT_EQ] = ACTIONS(2559),
    [anon_sym_GT_GT_EQ] = ACTIONS(2559),
    [anon_sym_AMP_EQ] = ACTIONS(2559),
    [anon_sym_CARET_EQ] = ACTIONS(2559),
    [anon_sym_PIPE_EQ] = ACTIONS(2559),
    [anon_sym_AMP] = ACTIONS(2561),
    [anon_sym_PIPE_PIPE] = ACTIONS(2563),
    [anon_sym_AMP_AMP] = ACTIONS(2565),
    [anon_sym_PIPE] = ACTIONS(2567),
    [anon_sym_CARET] = ACTIONS(2569),
    [anon_sym_EQ_EQ] = ACTIONS(2571),
    [anon_sym_BANG_EQ] = ACTIONS(2571),
    [anon_sym_LT] = ACTIONS(2573),
    [anon_sym_GT] = ACTIONS(2573),
    [anon_sym_LT_EQ] = ACTIONS(2575),
    [anon_sym_GT_EQ] = ACTIONS(2575),
    [anon_sym_LT_LT] = ACTIONS(2577),
    [anon_sym_GT_GT] = ACTIONS(2577),
    [anon_sym_PLUS] = ACTIONS(2579),
    [anon_sym_DASH] = ACTIONS(2579),
    [anon_sym_SLASH] = ACTIONS(2553),
    [anon_sym_PERCENT] = ACTIONS(2553),
    [anon_sym_DASH_DASH] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(1554),
    [anon_sym_DASH_GT] = ACTIONS(1554),
    [sym_comment] = ACTIONS(49),
  },
  [2056] = {
    [anon_sym_COLON] = ACTIONS(5665),
    [sym_comment] = ACTIONS(49),
  },
  [2057] = {
    [anon_sym_else] = ACTIONS(4697),
    [anon_sym_while] = ACTIONS(4697),
    [sym_comment] = ACTIONS(49),
  },
  [2058] = {
    [anon_sym_else] = ACTIONS(4701),
    [anon_sym_while] = ACTIONS(4701),
    [sym_comment] = ACTIONS(49),
  },
  [2059] = {
    [anon_sym_else] = ACTIONS(4710),
    [anon_sym_while] = ACTIONS(4710),
    [sym_comment] = ACTIONS(49),
  },
  [2060] = {
    [sym__expression] = STATE(2415),
    [sym_conditional_expression] = STATE(2415),
    [sym_assignment_expression] = STATE(2415),
    [sym_pointer_expression] = STATE(2415),
    [sym_logical_expression] = STATE(2415),
    [sym_bitwise_expression] = STATE(2415),
    [sym_equality_expression] = STATE(2415),
    [sym_relational_expression] = STATE(2415),
    [sym_shift_expression] = STATE(2415),
    [sym_math_expression] = STATE(2415),
    [sym_cast_expression] = STATE(2415),
    [sym_sizeof_expression] = STATE(2415),
    [sym_subscript_expression] = STATE(2415),
    [sym_call_expression] = STATE(2415),
    [sym_field_expression] = STATE(2415),
    [sym_compound_literal_expression] = STATE(2415),
    [sym_parenthesized_expression] = STATE(2415),
    [sym_concatenated_string] = STATE(2415),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(2415),
    [sym_new_expression] = STATE(2415),
    [sym_delete_expression] = STATE(2415),
    [sym_lambda_expression] = STATE(2415),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(5667),
    [anon_sym_LPAREN] = ACTIONS(2943),
    [anon_sym_STAR] = ACTIONS(2945),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_AMP] = ACTIONS(2945),
    [anon_sym_BANG] = ACTIONS(2947),
    [anon_sym_TILDE] = ACTIONS(2949),
    [anon_sym_PLUS] = ACTIONS(2951),
    [anon_sym_DASH] = ACTIONS(2951),
    [anon_sym_DASH_DASH] = ACTIONS(2953),
    [anon_sym_PLUS_PLUS] = ACTIONS(2953),
    [anon_sym_sizeof] = ACTIONS(2955),
    [sym_number_literal] = ACTIONS(5667),
    [sym_char_literal] = ACTIONS(5667),
    [sym_string_literal] = ACTIONS(2957),
    [sym_true] = ACTIONS(5669),
    [sym_false] = ACTIONS(5669),
    [sym_null] = ACTIONS(5669),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(2961),
    [anon_sym_delete] = ACTIONS(2963),
    [sym_nullptr] = ACTIONS(5669),
  },
  [2061] = {
    [sym__expression] = STATE(2417),
    [sym_conditional_expression] = STATE(2417),
    [sym_assignment_expression] = STATE(2417),
    [sym_pointer_expression] = STATE(2417),
    [sym_logical_expression] = STATE(2417),
    [sym_bitwise_expression] = STATE(2417),
    [sym_equality_expression] = STATE(2417),
    [sym_relational_expression] = STATE(2417),
    [sym_shift_expression] = STATE(2417),
    [sym_math_expression] = STATE(2417),
    [sym_cast_expression] = STATE(2417),
    [sym_sizeof_expression] = STATE(2417),
    [sym_subscript_expression] = STATE(2417),
    [sym_call_expression] = STATE(2417),
    [sym_field_expression] = STATE(2417),
    [sym_compound_literal_expression] = STATE(2417),
    [sym_parenthesized_expression] = STATE(2417),
    [sym_concatenated_string] = STATE(2417),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(2417),
    [sym_new_expression] = STATE(2417),
    [sym_delete_expression] = STATE(2417),
    [sym_lambda_expression] = STATE(2417),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(5671),
    [anon_sym_LPAREN] = ACTIONS(1087),
    [anon_sym_RPAREN] = ACTIONS(5673),
    [anon_sym_STAR] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_AMP] = ACTIONS(1089),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1093),
    [anon_sym_PLUS] = ACTIONS(1095),
    [anon_sym_DASH] = ACTIONS(1095),
    [anon_sym_DASH_DASH] = ACTIONS(1097),
    [anon_sym_PLUS_PLUS] = ACTIONS(1097),
    [anon_sym_sizeof] = ACTIONS(1099),
    [sym_number_literal] = ACTIONS(5671),
    [sym_char_literal] = ACTIONS(5671),
    [sym_string_literal] = ACTIONS(1101),
    [sym_true] = ACTIONS(5675),
    [sym_false] = ACTIONS(5675),
    [sym_null] = ACTIONS(5675),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_delete] = ACTIONS(1109),
    [sym_nullptr] = ACTIONS(5675),
  },
  [2062] = {
    [sym_argument_list] = STATE(802),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_SEMI] = ACTIONS(5677),
    [anon_sym_STAR] = ACTIONS(2553),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_EQ] = ACTIONS(2555),
    [anon_sym_QMARK] = ACTIONS(2557),
    [anon_sym_STAR_EQ] = ACTIONS(2559),
    [anon_sym_SLASH_EQ] = ACTIONS(2559),
    [anon_sym_PERCENT_EQ] = ACTIONS(2559),
    [anon_sym_PLUS_EQ] = ACTIONS(2559),
    [anon_sym_DASH_EQ] = ACTIONS(2559),
    [anon_sym_LT_LT_EQ] = ACTIONS(2559),
    [anon_sym_GT_GT_EQ] = ACTIONS(2559),
    [anon_sym_AMP_EQ] = ACTIONS(2559),
    [anon_sym_CARET_EQ] = ACTIONS(2559),
    [anon_sym_PIPE_EQ] = ACTIONS(2559),
    [anon_sym_AMP] = ACTIONS(2561),
    [anon_sym_PIPE_PIPE] = ACTIONS(2563),
    [anon_sym_AMP_AMP] = ACTIONS(2565),
    [anon_sym_PIPE] = ACTIONS(2567),
    [anon_sym_CARET] = ACTIONS(2569),
    [anon_sym_EQ_EQ] = ACTIONS(2571),
    [anon_sym_BANG_EQ] = ACTIONS(2571),
    [anon_sym_LT] = ACTIONS(2573),
    [anon_sym_GT] = ACTIONS(2573),
    [anon_sym_LT_EQ] = ACTIONS(2575),
    [anon_sym_GT_EQ] = ACTIONS(2575),
    [anon_sym_LT_LT] = ACTIONS(2577),
    [anon_sym_GT_GT] = ACTIONS(2577),
    [anon_sym_PLUS] = ACTIONS(2579),
    [anon_sym_DASH] = ACTIONS(2579),
    [anon_sym_SLASH] = ACTIONS(2553),
    [anon_sym_PERCENT] = ACTIONS(2553),
    [anon_sym_DASH_DASH] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(1554),
    [anon_sym_DASH_GT] = ACTIONS(1554),
    [sym_comment] = ACTIONS(49),
  },
  [2063] = {
    [sym__declarator] = STATE(2419),
    [sym_pointer_declarator] = STATE(2419),
    [sym_function_declarator] = STATE(2419),
    [sym_array_declarator] = STATE(2419),
    [sym_reference_declarator] = STATE(2419),
    [sym_template_type] = STATE(46),
    [sym_template_function] = STATE(2419),
    [sym_destructor_name] = STATE(2419),
    [sym_scoped_identifier] = STATE(2067),
    [sym_scoped_type_identifier] = STATE(47),
    [sym_scoped_namespace_identifier] = STATE(46),
    [anon_sym_LPAREN] = ACTIONS(11),
    [anon_sym_STAR] = ACTIONS(4685),
    [anon_sym_AMP] = ACTIONS(4687),
    [anon_sym_AMP_AMP] = ACTIONS(4689),
    [anon_sym_TILDE] = ACTIONS(45),
    [sym_identifier] = ACTIONS(75),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(77),
    [sym_operator_name] = ACTIONS(5679),
  },
  [2064] = {
    [sym__declarator] = STATE(2420),
    [sym_pointer_declarator] = STATE(2420),
    [sym_function_declarator] = STATE(2420),
    [sym_array_declarator] = STATE(2420),
    [sym_reference_declarator] = STATE(2420),
    [sym_template_type] = STATE(46),
    [sym_template_function] = STATE(2420),
    [sym_destructor_name] = STATE(2420),
    [sym_scoped_identifier] = STATE(2067),
    [sym_scoped_type_identifier] = STATE(47),
    [sym_scoped_namespace_identifier] = STATE(46),
    [anon_sym_LPAREN] = ACTIONS(11),
    [anon_sym_STAR] = ACTIONS(4685),
    [anon_sym_AMP] = ACTIONS(4687),
    [anon_sym_AMP_AMP] = ACTIONS(4689),
    [anon_sym_TILDE] = ACTIONS(45),
    [sym_identifier] = ACTIONS(75),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(77),
    [sym_operator_name] = ACTIONS(5681),
  },
  [2065] = {
    [sym_parameter_list] = STATE(2422),
    [sym_argument_list] = STATE(333),
    [sym_initializer_list] = STATE(333),
    [aux_sym_declaration_repeat1] = STATE(2423),
    [anon_sym_LPAREN] = ACTIONS(536),
    [anon_sym_COMMA] = ACTIONS(538),
    [anon_sym_SEMI] = ACTIONS(5683),
    [anon_sym_LBRACE] = ACTIONS(548),
    [anon_sym_LBRACK] = ACTIONS(208),
    [anon_sym_EQ] = ACTIONS(544),
    [anon_sym_COLON] = ACTIONS(5685),
    [sym_comment] = ACTIONS(49),
  },
  [2066] = {
    [aux_sym_declaration_repeat1] = STATE(2423),
    [anon_sym_COMMA] = ACTIONS(538),
    [anon_sym_SEMI] = ACTIONS(5683),
    [sym_comment] = ACTIONS(49),
  },
  [2067] = {
    [sym_template_argument_list] = STATE(140),
    [anon_sym_LPAREN] = ACTIONS(210),
    [anon_sym_COMMA] = ACTIONS(210),
    [anon_sym_SEMI] = ACTIONS(210),
    [anon_sym_LBRACE] = ACTIONS(210),
    [anon_sym_LBRACK] = ACTIONS(210),
    [anon_sym_EQ] = ACTIONS(210),
    [anon_sym_COLON] = ACTIONS(210),
    [anon_sym_LT] = ACTIONS(2100),
    [sym_comment] = ACTIONS(49),
  },
  [2068] = {
    [sym__expression] = STATE(2424),
    [sym_conditional_expression] = STATE(2424),
    [sym_assignment_expression] = STATE(2424),
    [sym_pointer_expression] = STATE(2424),
    [sym_logical_expression] = STATE(2424),
    [sym_bitwise_expression] = STATE(2424),
    [sym_equality_expression] = STATE(2424),
    [sym_relational_expression] = STATE(2424),
    [sym_shift_expression] = STATE(2424),
    [sym_math_expression] = STATE(2424),
    [sym_cast_expression] = STATE(2424),
    [sym_sizeof_expression] = STATE(2424),
    [sym_subscript_expression] = STATE(2424),
    [sym_call_expression] = STATE(2424),
    [sym_field_expression] = STATE(2424),
    [sym_compound_literal_expression] = STATE(2424),
    [sym_parenthesized_expression] = STATE(2424),
    [sym_concatenated_string] = STATE(2424),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(2424),
    [sym_new_expression] = STATE(2424),
    [sym_delete_expression] = STATE(2424),
    [sym_lambda_expression] = STATE(2424),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(5687),
    [anon_sym_LPAREN] = ACTIONS(1347),
    [anon_sym_SEMI] = ACTIONS(5677),
    [anon_sym_STAR] = ACTIONS(1349),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_AMP] = ACTIONS(1349),
    [anon_sym_BANG] = ACTIONS(1351),
    [anon_sym_TILDE] = ACTIONS(1353),
    [anon_sym_PLUS] = ACTIONS(1355),
    [anon_sym_DASH] = ACTIONS(1355),
    [anon_sym_DASH_DASH] = ACTIONS(1357),
    [anon_sym_PLUS_PLUS] = ACTIONS(1357),
    [anon_sym_sizeof] = ACTIONS(1359),
    [sym_number_literal] = ACTIONS(5687),
    [sym_char_literal] = ACTIONS(5687),
    [sym_string_literal] = ACTIONS(1361),
    [sym_true] = ACTIONS(5689),
    [sym_false] = ACTIONS(5689),
    [sym_null] = ACTIONS(5689),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1365),
    [anon_sym_delete] = ACTIONS(1367),
    [sym_nullptr] = ACTIONS(5689),
  },
  [2069] = {
    [sym__expression] = STATE(2425),
    [sym_conditional_expression] = STATE(2425),
    [sym_assignment_expression] = STATE(2425),
    [sym_pointer_expression] = STATE(2425),
    [sym_logical_expression] = STATE(2425),
    [sym_bitwise_expression] = STATE(2425),
    [sym_equality_expression] = STATE(2425),
    [sym_relational_expression] = STATE(2425),
    [sym_shift_expression] = STATE(2425),
    [sym_math_expression] = STATE(2425),
    [sym_cast_expression] = STATE(2425),
    [sym_sizeof_expression] = STATE(2425),
    [sym_subscript_expression] = STATE(2425),
    [sym_call_expression] = STATE(2425),
    [sym_field_expression] = STATE(2425),
    [sym_compound_literal_expression] = STATE(2425),
    [sym_parenthesized_expression] = STATE(2425),
    [sym_concatenated_string] = STATE(2425),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(2425),
    [sym_new_expression] = STATE(2425),
    [sym_delete_expression] = STATE(2425),
    [sym_lambda_expression] = STATE(2425),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(5691),
    [anon_sym_LPAREN] = ACTIONS(2943),
    [anon_sym_STAR] = ACTIONS(2945),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_AMP] = ACTIONS(2945),
    [anon_sym_BANG] = ACTIONS(2947),
    [anon_sym_TILDE] = ACTIONS(2949),
    [anon_sym_PLUS] = ACTIONS(2951),
    [anon_sym_DASH] = ACTIONS(2951),
    [anon_sym_DASH_DASH] = ACTIONS(2953),
    [anon_sym_PLUS_PLUS] = ACTIONS(2953),
    [anon_sym_sizeof] = ACTIONS(2955),
    [sym_number_literal] = ACTIONS(5691),
    [sym_char_literal] = ACTIONS(5691),
    [sym_string_literal] = ACTIONS(2957),
    [sym_true] = ACTIONS(5693),
    [sym_false] = ACTIONS(5693),
    [sym_null] = ACTIONS(5693),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(2961),
    [anon_sym_delete] = ACTIONS(2963),
    [sym_nullptr] = ACTIONS(5693),
  },
  [2070] = {
    [sym__expression] = STATE(1834),
    [sym_conditional_expression] = STATE(1834),
    [sym_assignment_expression] = STATE(1834),
    [sym_pointer_expression] = STATE(1834),
    [sym_logical_expression] = STATE(1834),
    [sym_bitwise_expression] = STATE(1834),
    [sym_equality_expression] = STATE(1834),
    [sym_relational_expression] = STATE(1834),
    [sym_shift_expression] = STATE(1834),
    [sym_math_expression] = STATE(1834),
    [sym_cast_expression] = STATE(1834),
    [sym_sizeof_expression] = STATE(1834),
    [sym_subscript_expression] = STATE(1834),
    [sym_call_expression] = STATE(1834),
    [sym_field_expression] = STATE(1834),
    [sym_compound_literal_expression] = STATE(1834),
    [sym_parenthesized_expression] = STATE(1834),
    [sym_initializer_list] = STATE(1835),
    [sym_concatenated_string] = STATE(1834),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(1834),
    [sym_new_expression] = STATE(1834),
    [sym_delete_expression] = STATE(1834),
    [sym_lambda_expression] = STATE(1834),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(4145),
    [anon_sym_LPAREN] = ACTIONS(626),
    [anon_sym_COMMA] = ACTIONS(5210),
    [anon_sym_SEMI] = ACTIONS(5210),
    [anon_sym_LBRACE] = ACTIONS(548),
    [anon_sym_STAR] = ACTIONS(5695),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_EQ] = ACTIONS(5212),
    [anon_sym_QMARK] = ACTIONS(5210),
    [anon_sym_STAR_EQ] = ACTIONS(5210),
    [anon_sym_SLASH_EQ] = ACTIONS(5210),
    [anon_sym_PERCENT_EQ] = ACTIONS(5210),
    [anon_sym_PLUS_EQ] = ACTIONS(5210),
    [anon_sym_DASH_EQ] = ACTIONS(5210),
    [anon_sym_LT_LT_EQ] = ACTIONS(5210),
    [anon_sym_GT_GT_EQ] = ACTIONS(5210),
    [anon_sym_AMP_EQ] = ACTIONS(5210),
    [anon_sym_CARET_EQ] = ACTIONS(5210),
    [anon_sym_PIPE_EQ] = ACTIONS(5210),
    [anon_sym_AMP] = ACTIONS(5695),
    [anon_sym_PIPE_PIPE] = ACTIONS(5210),
    [anon_sym_AMP_AMP] = ACTIONS(5210),
    [anon_sym_BANG] = ACTIONS(5697),
    [anon_sym_PIPE] = ACTIONS(5212),
    [anon_sym_CARET] = ACTIONS(5212),
    [anon_sym_TILDE] = ACTIONS(670),
    [anon_sym_EQ_EQ] = ACTIONS(5210),
    [anon_sym_BANG_EQ] = ACTIONS(5210),
    [anon_sym_LT] = ACTIONS(5212),
    [anon_sym_GT] = ACTIONS(5212),
    [anon_sym_LT_EQ] = ACTIONS(5210),
    [anon_sym_GT_EQ] = ACTIONS(5210),
    [anon_sym_LT_LT] = ACTIONS(5212),
    [anon_sym_GT_GT] = ACTIONS(5212),
    [anon_sym_PLUS] = ACTIONS(672),
    [anon_sym_DASH] = ACTIONS(672),
    [anon_sym_SLASH] = ACTIONS(5212),
    [anon_sym_PERCENT] = ACTIONS(5212),
    [anon_sym_DASH_DASH] = ACTIONS(674),
    [anon_sym_PLUS_PLUS] = ACTIONS(674),
    [anon_sym_sizeof] = ACTIONS(676),
    [anon_sym_DOT] = ACTIONS(5210),
    [anon_sym_DASH_GT] = ACTIONS(5210),
    [sym_number_literal] = ACTIONS(4145),
    [sym_char_literal] = ACTIONS(4145),
    [sym_string_literal] = ACTIONS(678),
    [sym_true] = ACTIONS(4147),
    [sym_false] = ACTIONS(4147),
    [sym_null] = ACTIONS(4147),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1303),
    [anon_sym_delete] = ACTIONS(686),
    [sym_nullptr] = ACTIONS(4147),
  },
  [2071] = {
    [sym__expression] = STATE(2426),
    [sym_conditional_expression] = STATE(2426),
    [sym_assignment_expression] = STATE(2426),
    [sym_pointer_expression] = STATE(2426),
    [sym_logical_expression] = STATE(2426),
    [sym_bitwise_expression] = STATE(2426),
    [sym_equality_expression] = STATE(2426),
    [sym_relational_expression] = STATE(2426),
    [sym_shift_expression] = STATE(2426),
    [sym_math_expression] = STATE(2426),
    [sym_cast_expression] = STATE(2426),
    [sym_sizeof_expression] = STATE(2426),
    [sym_subscript_expression] = STATE(2426),
    [sym_call_expression] = STATE(2426),
    [sym_field_expression] = STATE(2426),
    [sym_compound_literal_expression] = STATE(2426),
    [sym_parenthesized_expression] = STATE(2426),
    [sym_concatenated_string] = STATE(2426),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(2426),
    [sym_new_expression] = STATE(2426),
    [sym_delete_expression] = STATE(2426),
    [sym_lambda_expression] = STATE(2426),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(5699),
    [anon_sym_LPAREN] = ACTIONS(2624),
    [anon_sym_STAR] = ACTIONS(2624),
    [anon_sym_LBRACK] = ACTIONS(2624),
    [anon_sym_AMP] = ACTIONS(2626),
    [anon_sym_AMP_AMP] = ACTIONS(2624),
    [anon_sym_BANG] = ACTIONS(668),
    [anon_sym_TILDE] = ACTIONS(670),
    [anon_sym_PLUS] = ACTIONS(672),
    [anon_sym_DASH] = ACTIONS(672),
    [anon_sym_DASH_DASH] = ACTIONS(674),
    [anon_sym_PLUS_PLUS] = ACTIONS(674),
    [anon_sym_sizeof] = ACTIONS(676),
    [sym_number_literal] = ACTIONS(5699),
    [sym_char_literal] = ACTIONS(5699),
    [sym_string_literal] = ACTIONS(678),
    [sym_true] = ACTIONS(5701),
    [sym_false] = ACTIONS(5701),
    [sym_null] = ACTIONS(5701),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1303),
    [anon_sym_delete] = ACTIONS(686),
    [sym_nullptr] = ACTIONS(5701),
  },
  [2072] = {
    [sym_argument_list] = STATE(802),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_COMMA] = ACTIONS(5236),
    [anon_sym_SEMI] = ACTIONS(5236),
    [anon_sym_STAR] = ACTIONS(1744),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_EQ] = ACTIONS(5238),
    [anon_sym_QMARK] = ACTIONS(5236),
    [anon_sym_STAR_EQ] = ACTIONS(5236),
    [anon_sym_SLASH_EQ] = ACTIONS(5236),
    [anon_sym_PERCENT_EQ] = ACTIONS(5236),
    [anon_sym_PLUS_EQ] = ACTIONS(5236),
    [anon_sym_DASH_EQ] = ACTIONS(5236),
    [anon_sym_LT_LT_EQ] = ACTIONS(5236),
    [anon_sym_GT_GT_EQ] = ACTIONS(5236),
    [anon_sym_AMP_EQ] = ACTIONS(5236),
    [anon_sym_CARET_EQ] = ACTIONS(5236),
    [anon_sym_PIPE_EQ] = ACTIONS(5236),
    [anon_sym_AMP] = ACTIONS(1752),
    [anon_sym_PIPE_PIPE] = ACTIONS(1754),
    [anon_sym_AMP_AMP] = ACTIONS(1756),
    [anon_sym_PIPE] = ACTIONS(1758),
    [anon_sym_CARET] = ACTIONS(1760),
    [anon_sym_EQ_EQ] = ACTIONS(1762),
    [anon_sym_BANG_EQ] = ACTIONS(1762),
    [anon_sym_LT] = ACTIONS(1764),
    [anon_sym_GT] = ACTIONS(1764),
    [anon_sym_LT_EQ] = ACTIONS(1766),
    [anon_sym_GT_EQ] = ACTIONS(1766),
    [anon_sym_LT_LT] = ACTIONS(1768),
    [anon_sym_GT_GT] = ACTIONS(1768),
    [anon_sym_PLUS] = ACTIONS(1770),
    [anon_sym_DASH] = ACTIONS(1770),
    [anon_sym_SLASH] = ACTIONS(1744),
    [anon_sym_PERCENT] = ACTIONS(1744),
    [anon_sym_DASH_DASH] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(1554),
    [anon_sym_DASH_GT] = ACTIONS(1554),
    [sym_comment] = ACTIONS(49),
  },
  [2073] = {
    [sym_raw_string_literal] = ACTIONS(2478),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(2480),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(2480),
    [anon_sym_LPAREN] = ACTIONS(2478),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(2480),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(2480),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(2480),
    [sym_preproc_directive] = ACTIONS(2480),
    [anon_sym_SEMI] = ACTIONS(2478),
    [anon_sym_typedef] = ACTIONS(2480),
    [anon_sym_extern] = ACTIONS(2480),
    [anon_sym_LBRACE] = ACTIONS(2478),
    [anon_sym_RBRACE] = ACTIONS(2478),
    [anon_sym_STAR] = ACTIONS(2478),
    [anon_sym_LBRACK] = ACTIONS(2478),
    [anon_sym_static] = ACTIONS(2480),
    [anon_sym_register] = ACTIONS(2480),
    [anon_sym_inline] = ACTIONS(2480),
    [anon_sym_const] = ACTIONS(2480),
    [anon_sym_restrict] = ACTIONS(2480),
    [anon_sym_volatile] = ACTIONS(2480),
    [anon_sym__Atomic] = ACTIONS(2480),
    [anon_sym_mutable] = ACTIONS(2480),
    [anon_sym_explicit] = ACTIONS(2480),
    [anon_sym_constexpr] = ACTIONS(2480),
    [anon_sym_unsigned] = ACTIONS(2480),
    [anon_sym_long] = ACTIONS(2480),
    [anon_sym_short] = ACTIONS(2480),
    [sym_primitive_type] = ACTIONS(2480),
    [anon_sym_enum] = ACTIONS(2480),
    [anon_sym_struct] = ACTIONS(2480),
    [anon_sym_union] = ACTIONS(2480),
    [anon_sym_if] = ACTIONS(2480),
    [anon_sym_switch] = ACTIONS(2480),
    [anon_sym_case] = ACTIONS(2480),
    [anon_sym_default] = ACTIONS(2480),
    [anon_sym_while] = ACTIONS(2480),
    [anon_sym_do] = ACTIONS(2480),
    [anon_sym_for] = ACTIONS(2480),
    [anon_sym_return] = ACTIONS(2480),
    [anon_sym_break] = ACTIONS(2480),
    [anon_sym_continue] = ACTIONS(2480),
    [anon_sym_goto] = ACTIONS(2480),
    [anon_sym_AMP] = ACTIONS(2478),
    [anon_sym_BANG] = ACTIONS(2478),
    [anon_sym_TILDE] = ACTIONS(2478),
    [anon_sym_PLUS] = ACTIONS(2480),
    [anon_sym_DASH] = ACTIONS(2480),
    [anon_sym_DASH_DASH] = ACTIONS(2478),
    [anon_sym_PLUS_PLUS] = ACTIONS(2478),
    [anon_sym_sizeof] = ACTIONS(2480),
    [sym_number_literal] = ACTIONS(2478),
    [sym_char_literal] = ACTIONS(2478),
    [sym_string_literal] = ACTIONS(2478),
    [sym_true] = ACTIONS(2480),
    [sym_false] = ACTIONS(2480),
    [sym_null] = ACTIONS(2480),
    [sym_identifier] = ACTIONS(2480),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(2480),
    [sym_auto] = ACTIONS(2480),
    [anon_sym_typename] = ACTIONS(2480),
    [anon_sym_new] = ACTIONS(2480),
    [anon_sym_COLON_COLON] = ACTIONS(2478),
    [anon_sym_delete] = ACTIONS(2480),
    [sym_nullptr] = ACTIONS(2480),
  },
  [2074] = {
    [sym_argument_list] = STATE(802),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_SEMI] = ACTIONS(5703),
    [anon_sym_STAR] = ACTIONS(2553),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_EQ] = ACTIONS(2555),
    [anon_sym_QMARK] = ACTIONS(2557),
    [anon_sym_STAR_EQ] = ACTIONS(2559),
    [anon_sym_SLASH_EQ] = ACTIONS(2559),
    [anon_sym_PERCENT_EQ] = ACTIONS(2559),
    [anon_sym_PLUS_EQ] = ACTIONS(2559),
    [anon_sym_DASH_EQ] = ACTIONS(2559),
    [anon_sym_LT_LT_EQ] = ACTIONS(2559),
    [anon_sym_GT_GT_EQ] = ACTIONS(2559),
    [anon_sym_AMP_EQ] = ACTIONS(2559),
    [anon_sym_CARET_EQ] = ACTIONS(2559),
    [anon_sym_PIPE_EQ] = ACTIONS(2559),
    [anon_sym_AMP] = ACTIONS(2561),
    [anon_sym_PIPE_PIPE] = ACTIONS(2563),
    [anon_sym_AMP_AMP] = ACTIONS(2565),
    [anon_sym_PIPE] = ACTIONS(2567),
    [anon_sym_CARET] = ACTIONS(2569),
    [anon_sym_EQ_EQ] = ACTIONS(2571),
    [anon_sym_BANG_EQ] = ACTIONS(2571),
    [anon_sym_LT] = ACTIONS(2573),
    [anon_sym_GT] = ACTIONS(2573),
    [anon_sym_LT_EQ] = ACTIONS(2575),
    [anon_sym_GT_EQ] = ACTIONS(2575),
    [anon_sym_LT_LT] = ACTIONS(2577),
    [anon_sym_GT_GT] = ACTIONS(2577),
    [anon_sym_PLUS] = ACTIONS(2579),
    [anon_sym_DASH] = ACTIONS(2579),
    [anon_sym_SLASH] = ACTIONS(2553),
    [anon_sym_PERCENT] = ACTIONS(2553),
    [anon_sym_DASH_DASH] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(1554),
    [anon_sym_DASH_GT] = ACTIONS(1554),
    [sym_comment] = ACTIONS(49),
  },
  [2075] = {
    [anon_sym_SEMI] = ACTIONS(5703),
    [sym_comment] = ACTIONS(49),
  },
  [2076] = {
    [sym_raw_string_literal] = ACTIONS(2581),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(2583),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(2583),
    [anon_sym_LPAREN] = ACTIONS(2581),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(2583),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(2583),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(2583),
    [sym_preproc_directive] = ACTIONS(2583),
    [anon_sym_SEMI] = ACTIONS(2581),
    [anon_sym_typedef] = ACTIONS(2583),
    [anon_sym_extern] = ACTIONS(2583),
    [anon_sym_LBRACE] = ACTIONS(2581),
    [anon_sym_RBRACE] = ACTIONS(2581),
    [anon_sym_STAR] = ACTIONS(2581),
    [anon_sym_LBRACK] = ACTIONS(2581),
    [anon_sym_static] = ACTIONS(2583),
    [anon_sym_register] = ACTIONS(2583),
    [anon_sym_inline] = ACTIONS(2583),
    [anon_sym_const] = ACTIONS(2583),
    [anon_sym_restrict] = ACTIONS(2583),
    [anon_sym_volatile] = ACTIONS(2583),
    [anon_sym__Atomic] = ACTIONS(2583),
    [anon_sym_mutable] = ACTIONS(2583),
    [anon_sym_explicit] = ACTIONS(2583),
    [anon_sym_constexpr] = ACTIONS(2583),
    [anon_sym_unsigned] = ACTIONS(2583),
    [anon_sym_long] = ACTIONS(2583),
    [anon_sym_short] = ACTIONS(2583),
    [sym_primitive_type] = ACTIONS(2583),
    [anon_sym_enum] = ACTIONS(2583),
    [anon_sym_struct] = ACTIONS(2583),
    [anon_sym_union] = ACTIONS(2583),
    [anon_sym_if] = ACTIONS(2583),
    [anon_sym_switch] = ACTIONS(2583),
    [anon_sym_case] = ACTIONS(2583),
    [anon_sym_default] = ACTIONS(2583),
    [anon_sym_while] = ACTIONS(2583),
    [anon_sym_do] = ACTIONS(2583),
    [anon_sym_for] = ACTIONS(2583),
    [anon_sym_return] = ACTIONS(2583),
    [anon_sym_break] = ACTIONS(2583),
    [anon_sym_continue] = ACTIONS(2583),
    [anon_sym_goto] = ACTIONS(2583),
    [anon_sym_AMP] = ACTIONS(2581),
    [anon_sym_BANG] = ACTIONS(2581),
    [anon_sym_TILDE] = ACTIONS(2581),
    [anon_sym_PLUS] = ACTIONS(2583),
    [anon_sym_DASH] = ACTIONS(2583),
    [anon_sym_DASH_DASH] = ACTIONS(2581),
    [anon_sym_PLUS_PLUS] = ACTIONS(2581),
    [anon_sym_sizeof] = ACTIONS(2583),
    [sym_number_literal] = ACTIONS(2581),
    [sym_char_literal] = ACTIONS(2581),
    [sym_string_literal] = ACTIONS(2581),
    [sym_true] = ACTIONS(2583),
    [sym_false] = ACTIONS(2583),
    [sym_null] = ACTIONS(2583),
    [sym_identifier] = ACTIONS(2583),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(2583),
    [sym_auto] = ACTIONS(2583),
    [anon_sym_typename] = ACTIONS(2583),
    [anon_sym_new] = ACTIONS(2583),
    [anon_sym_COLON_COLON] = ACTIONS(2581),
    [anon_sym_delete] = ACTIONS(2583),
    [sym_nullptr] = ACTIONS(2583),
  },
  [2077] = {
    [sym_argument_list] = STATE(802),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_SEMI] = ACTIONS(5705),
    [anon_sym_STAR] = ACTIONS(2553),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_EQ] = ACTIONS(2555),
    [anon_sym_QMARK] = ACTIONS(2557),
    [anon_sym_STAR_EQ] = ACTIONS(2559),
    [anon_sym_SLASH_EQ] = ACTIONS(2559),
    [anon_sym_PERCENT_EQ] = ACTIONS(2559),
    [anon_sym_PLUS_EQ] = ACTIONS(2559),
    [anon_sym_DASH_EQ] = ACTIONS(2559),
    [anon_sym_LT_LT_EQ] = ACTIONS(2559),
    [anon_sym_GT_GT_EQ] = ACTIONS(2559),
    [anon_sym_AMP_EQ] = ACTIONS(2559),
    [anon_sym_CARET_EQ] = ACTIONS(2559),
    [anon_sym_PIPE_EQ] = ACTIONS(2559),
    [anon_sym_AMP] = ACTIONS(2561),
    [anon_sym_PIPE_PIPE] = ACTIONS(2563),
    [anon_sym_AMP_AMP] = ACTIONS(2565),
    [anon_sym_PIPE] = ACTIONS(2567),
    [anon_sym_CARET] = ACTIONS(2569),
    [anon_sym_EQ_EQ] = ACTIONS(2571),
    [anon_sym_BANG_EQ] = ACTIONS(2571),
    [anon_sym_LT] = ACTIONS(2573),
    [anon_sym_GT] = ACTIONS(2573),
    [anon_sym_LT_EQ] = ACTIONS(2575),
    [anon_sym_GT_EQ] = ACTIONS(2575),
    [anon_sym_LT_LT] = ACTIONS(2577),
    [anon_sym_GT_GT] = ACTIONS(2577),
    [anon_sym_PLUS] = ACTIONS(2579),
    [anon_sym_DASH] = ACTIONS(2579),
    [anon_sym_SLASH] = ACTIONS(2553),
    [anon_sym_PERCENT] = ACTIONS(2553),
    [anon_sym_DASH_DASH] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(1554),
    [anon_sym_DASH_GT] = ACTIONS(1554),
    [sym_comment] = ACTIONS(49),
  },
  [2078] = {
    [anon_sym_SEMI] = ACTIONS(5705),
    [sym_comment] = ACTIONS(49),
  },
  [2079] = {
    [sym_raw_string_literal] = ACTIONS(2587),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(2589),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(2589),
    [anon_sym_LPAREN] = ACTIONS(2587),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(2589),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(2589),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(2589),
    [sym_preproc_directive] = ACTIONS(2589),
    [anon_sym_SEMI] = ACTIONS(2587),
    [anon_sym_typedef] = ACTIONS(2589),
    [anon_sym_extern] = ACTIONS(2589),
    [anon_sym_LBRACE] = ACTIONS(2587),
    [anon_sym_RBRACE] = ACTIONS(2587),
    [anon_sym_STAR] = ACTIONS(2587),
    [anon_sym_LBRACK] = ACTIONS(2587),
    [anon_sym_static] = ACTIONS(2589),
    [anon_sym_register] = ACTIONS(2589),
    [anon_sym_inline] = ACTIONS(2589),
    [anon_sym_const] = ACTIONS(2589),
    [anon_sym_restrict] = ACTIONS(2589),
    [anon_sym_volatile] = ACTIONS(2589),
    [anon_sym__Atomic] = ACTIONS(2589),
    [anon_sym_mutable] = ACTIONS(2589),
    [anon_sym_explicit] = ACTIONS(2589),
    [anon_sym_constexpr] = ACTIONS(2589),
    [anon_sym_unsigned] = ACTIONS(2589),
    [anon_sym_long] = ACTIONS(2589),
    [anon_sym_short] = ACTIONS(2589),
    [sym_primitive_type] = ACTIONS(2589),
    [anon_sym_enum] = ACTIONS(2589),
    [anon_sym_struct] = ACTIONS(2589),
    [anon_sym_union] = ACTIONS(2589),
    [anon_sym_if] = ACTIONS(2589),
    [anon_sym_switch] = ACTIONS(2589),
    [anon_sym_case] = ACTIONS(2589),
    [anon_sym_default] = ACTIONS(2589),
    [anon_sym_while] = ACTIONS(2589),
    [anon_sym_do] = ACTIONS(2589),
    [anon_sym_for] = ACTIONS(2589),
    [anon_sym_return] = ACTIONS(2589),
    [anon_sym_break] = ACTIONS(2589),
    [anon_sym_continue] = ACTIONS(2589),
    [anon_sym_goto] = ACTIONS(2589),
    [anon_sym_AMP] = ACTIONS(2587),
    [anon_sym_BANG] = ACTIONS(2587),
    [anon_sym_TILDE] = ACTIONS(2587),
    [anon_sym_PLUS] = ACTIONS(2589),
    [anon_sym_DASH] = ACTIONS(2589),
    [anon_sym_DASH_DASH] = ACTIONS(2587),
    [anon_sym_PLUS_PLUS] = ACTIONS(2587),
    [anon_sym_sizeof] = ACTIONS(2589),
    [sym_number_literal] = ACTIONS(2587),
    [sym_char_literal] = ACTIONS(2587),
    [sym_string_literal] = ACTIONS(2587),
    [sym_true] = ACTIONS(2589),
    [sym_false] = ACTIONS(2589),
    [sym_null] = ACTIONS(2589),
    [sym_identifier] = ACTIONS(2589),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(2589),
    [sym_auto] = ACTIONS(2589),
    [anon_sym_typename] = ACTIONS(2589),
    [anon_sym_new] = ACTIONS(2589),
    [anon_sym_COLON_COLON] = ACTIONS(2587),
    [anon_sym_delete] = ACTIONS(2589),
    [sym_nullptr] = ACTIONS(2589),
  },
  [2080] = {
    [sym__expression] = STATE(2429),
    [sym_conditional_expression] = STATE(2429),
    [sym_assignment_expression] = STATE(2429),
    [sym_pointer_expression] = STATE(2429),
    [sym_logical_expression] = STATE(2429),
    [sym_bitwise_expression] = STATE(2429),
    [sym_equality_expression] = STATE(2429),
    [sym_relational_expression] = STATE(2429),
    [sym_shift_expression] = STATE(2429),
    [sym_math_expression] = STATE(2429),
    [sym_cast_expression] = STATE(2429),
    [sym_sizeof_expression] = STATE(2429),
    [sym_subscript_expression] = STATE(2429),
    [sym_call_expression] = STATE(2429),
    [sym_field_expression] = STATE(2429),
    [sym_compound_literal_expression] = STATE(2429),
    [sym_parenthesized_expression] = STATE(2429),
    [sym_concatenated_string] = STATE(2429),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(2429),
    [sym_new_expression] = STATE(2429),
    [sym_delete_expression] = STATE(2429),
    [sym_lambda_expression] = STATE(2429),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(5707),
    [anon_sym_LPAREN] = ACTIONS(626),
    [anon_sym_STAR] = ACTIONS(644),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_AMP] = ACTIONS(644),
    [anon_sym_BANG] = ACTIONS(668),
    [anon_sym_TILDE] = ACTIONS(670),
    [anon_sym_PLUS] = ACTIONS(672),
    [anon_sym_DASH] = ACTIONS(672),
    [anon_sym_DASH_DASH] = ACTIONS(674),
    [anon_sym_PLUS_PLUS] = ACTIONS(674),
    [anon_sym_sizeof] = ACTIONS(676),
    [sym_number_literal] = ACTIONS(5707),
    [sym_char_literal] = ACTIONS(5707),
    [sym_string_literal] = ACTIONS(678),
    [sym_true] = ACTIONS(5709),
    [sym_false] = ACTIONS(5709),
    [sym_null] = ACTIONS(5709),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1303),
    [anon_sym_delete] = ACTIONS(686),
    [sym_nullptr] = ACTIONS(5709),
  },
  [2081] = {
    [sym_parameter_list] = STATE(2083),
    [anon_sym_LPAREN] = ACTIONS(206),
    [anon_sym_RPAREN] = ACTIONS(3750),
    [anon_sym_LBRACK] = ACTIONS(2282),
    [anon_sym_const] = ACTIONS(5283),
    [anon_sym_restrict] = ACTIONS(3750),
    [anon_sym_volatile] = ACTIONS(3750),
    [anon_sym__Atomic] = ACTIONS(3750),
    [anon_sym_mutable] = ACTIONS(3750),
    [anon_sym_explicit] = ACTIONS(3750),
    [anon_sym_constexpr] = ACTIONS(3750),
    [anon_sym_DASH_GT] = ACTIONS(3750),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(3750),
  },
  [2082] = {
    [sym_parameter_list] = STATE(2083),
    [anon_sym_LPAREN] = ACTIONS(206),
    [anon_sym_RPAREN] = ACTIONS(3762),
    [anon_sym_LBRACK] = ACTIONS(2282),
    [anon_sym_const] = ACTIONS(5285),
    [anon_sym_restrict] = ACTIONS(3762),
    [anon_sym_volatile] = ACTIONS(3762),
    [anon_sym__Atomic] = ACTIONS(3762),
    [anon_sym_mutable] = ACTIONS(3762),
    [anon_sym_explicit] = ACTIONS(3762),
    [anon_sym_constexpr] = ACTIONS(3762),
    [anon_sym_DASH_GT] = ACTIONS(3762),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(3762),
  },
  [2083] = {
    [sym_type_qualifier] = STATE(2430),
    [sym_trailing_return_type] = STATE(1713),
    [aux_sym_abstract_function_declarator_repeat1] = STATE(2430),
    [anon_sym_LPAREN] = ACTIONS(3764),
    [anon_sym_RPAREN] = ACTIONS(3764),
    [anon_sym_LBRACK] = ACTIONS(3764),
    [anon_sym_const] = ACTIONS(3770),
    [anon_sym_restrict] = ACTIONS(3764),
    [anon_sym_volatile] = ACTIONS(3764),
    [anon_sym__Atomic] = ACTIONS(3764),
    [anon_sym_mutable] = ACTIONS(3764),
    [anon_sym_explicit] = ACTIONS(3764),
    [anon_sym_constexpr] = ACTIONS(3764),
    [anon_sym_DASH_GT] = ACTIONS(3764),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(3764),
  },
  [2084] = {
    [sym_type_qualifier] = STATE(2165),
    [sym_trailing_return_type] = STATE(1713),
    [aux_sym_abstract_function_declarator_repeat1] = STATE(2165),
    [anon_sym_LPAREN] = ACTIONS(3764),
    [anon_sym_RPAREN] = ACTIONS(3764),
    [anon_sym_LBRACK] = ACTIONS(3764),
    [anon_sym_const] = ACTIONS(612),
    [anon_sym_restrict] = ACTIONS(614),
    [anon_sym_volatile] = ACTIONS(614),
    [anon_sym__Atomic] = ACTIONS(614),
    [anon_sym_mutable] = ACTIONS(614),
    [anon_sym_explicit] = ACTIONS(614),
    [anon_sym_constexpr] = ACTIONS(614),
    [anon_sym_DASH_GT] = ACTIONS(845),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(4986),
  },
  [2085] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3344),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3344),
    [anon_sym_LPAREN] = ACTIONS(3342),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3344),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3344),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3344),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3344),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(3344),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(3344),
    [sym_preproc_directive] = ACTIONS(3344),
    [anon_sym_typedef] = ACTIONS(3344),
    [anon_sym_extern] = ACTIONS(3344),
    [anon_sym_STAR] = ACTIONS(3342),
    [anon_sym_static] = ACTIONS(3344),
    [anon_sym_register] = ACTIONS(3344),
    [anon_sym_inline] = ACTIONS(3344),
    [anon_sym_const] = ACTIONS(3344),
    [anon_sym_restrict] = ACTIONS(3344),
    [anon_sym_volatile] = ACTIONS(3344),
    [anon_sym__Atomic] = ACTIONS(3344),
    [anon_sym_mutable] = ACTIONS(3344),
    [anon_sym_explicit] = ACTIONS(3344),
    [anon_sym_constexpr] = ACTIONS(3344),
    [anon_sym_unsigned] = ACTIONS(3344),
    [anon_sym_long] = ACTIONS(3344),
    [anon_sym_short] = ACTIONS(3344),
    [sym_primitive_type] = ACTIONS(3344),
    [anon_sym_enum] = ACTIONS(3344),
    [anon_sym_struct] = ACTIONS(3344),
    [anon_sym_union] = ACTIONS(3344),
    [anon_sym_AMP] = ACTIONS(3344),
    [anon_sym_AMP_AMP] = ACTIONS(3342),
    [anon_sym_TILDE] = ACTIONS(3342),
    [sym_identifier] = ACTIONS(3344),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(3344),
    [sym_auto] = ACTIONS(3344),
    [anon_sym_typename] = ACTIONS(3344),
    [anon_sym_template] = ACTIONS(3344),
    [anon_sym_namespace] = ACTIONS(3344),
    [anon_sym_using] = ACTIONS(3344),
    [anon_sym_COLON_COLON] = ACTIONS(3342),
    [sym_operator_name] = ACTIONS(3342),
  },
  [2086] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3354),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3354),
    [anon_sym_LPAREN] = ACTIONS(3352),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3354),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3354),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3354),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3354),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(3354),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(3354),
    [sym_preproc_directive] = ACTIONS(3354),
    [anon_sym_typedef] = ACTIONS(3354),
    [anon_sym_extern] = ACTIONS(3354),
    [anon_sym_STAR] = ACTIONS(3352),
    [anon_sym_static] = ACTIONS(3354),
    [anon_sym_register] = ACTIONS(3354),
    [anon_sym_inline] = ACTIONS(3354),
    [anon_sym_const] = ACTIONS(3354),
    [anon_sym_restrict] = ACTIONS(3354),
    [anon_sym_volatile] = ACTIONS(3354),
    [anon_sym__Atomic] = ACTIONS(3354),
    [anon_sym_mutable] = ACTIONS(3354),
    [anon_sym_explicit] = ACTIONS(3354),
    [anon_sym_constexpr] = ACTIONS(3354),
    [anon_sym_unsigned] = ACTIONS(3354),
    [anon_sym_long] = ACTIONS(3354),
    [anon_sym_short] = ACTIONS(3354),
    [sym_primitive_type] = ACTIONS(3354),
    [anon_sym_enum] = ACTIONS(3354),
    [anon_sym_struct] = ACTIONS(3354),
    [anon_sym_union] = ACTIONS(3354),
    [anon_sym_AMP] = ACTIONS(3354),
    [anon_sym_AMP_AMP] = ACTIONS(3352),
    [anon_sym_TILDE] = ACTIONS(3352),
    [sym_identifier] = ACTIONS(3354),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(3354),
    [sym_auto] = ACTIONS(3354),
    [anon_sym_typename] = ACTIONS(3354),
    [anon_sym_template] = ACTIONS(3354),
    [anon_sym_namespace] = ACTIONS(3354),
    [anon_sym_using] = ACTIONS(3354),
    [anon_sym_COLON_COLON] = ACTIONS(3352),
    [sym_operator_name] = ACTIONS(3352),
  },
  [2087] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3493),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3493),
    [anon_sym_LPAREN] = ACTIONS(3491),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3493),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3493),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3493),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3493),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(3493),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(3493),
    [sym_preproc_directive] = ACTIONS(3493),
    [anon_sym_typedef] = ACTIONS(3493),
    [anon_sym_extern] = ACTIONS(3493),
    [anon_sym_STAR] = ACTIONS(3491),
    [anon_sym_static] = ACTIONS(3493),
    [anon_sym_register] = ACTIONS(3493),
    [anon_sym_inline] = ACTIONS(3493),
    [anon_sym_const] = ACTIONS(3493),
    [anon_sym_restrict] = ACTIONS(3493),
    [anon_sym_volatile] = ACTIONS(3493),
    [anon_sym__Atomic] = ACTIONS(3493),
    [anon_sym_mutable] = ACTIONS(3493),
    [anon_sym_explicit] = ACTIONS(3493),
    [anon_sym_constexpr] = ACTIONS(3493),
    [anon_sym_unsigned] = ACTIONS(3493),
    [anon_sym_long] = ACTIONS(3493),
    [anon_sym_short] = ACTIONS(3493),
    [sym_primitive_type] = ACTIONS(3493),
    [anon_sym_enum] = ACTIONS(3493),
    [anon_sym_struct] = ACTIONS(3493),
    [anon_sym_union] = ACTIONS(3493),
    [anon_sym_AMP] = ACTIONS(3493),
    [anon_sym_AMP_AMP] = ACTIONS(3491),
    [anon_sym_TILDE] = ACTIONS(3491),
    [sym_identifier] = ACTIONS(3493),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(3493),
    [sym_auto] = ACTIONS(3493),
    [anon_sym_typename] = ACTIONS(3493),
    [anon_sym_template] = ACTIONS(3493),
    [anon_sym_namespace] = ACTIONS(3493),
    [anon_sym_using] = ACTIONS(3493),
    [anon_sym_COLON_COLON] = ACTIONS(3491),
    [sym_operator_name] = ACTIONS(3491),
  },
  [2088] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3497),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3497),
    [anon_sym_LPAREN] = ACTIONS(3495),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3497),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3497),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3497),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3497),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(3497),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(3497),
    [sym_preproc_directive] = ACTIONS(3497),
    [anon_sym_typedef] = ACTIONS(3497),
    [anon_sym_extern] = ACTIONS(3497),
    [anon_sym_STAR] = ACTIONS(3495),
    [anon_sym_static] = ACTIONS(3497),
    [anon_sym_register] = ACTIONS(3497),
    [anon_sym_inline] = ACTIONS(3497),
    [anon_sym_const] = ACTIONS(3497),
    [anon_sym_restrict] = ACTIONS(3497),
    [anon_sym_volatile] = ACTIONS(3497),
    [anon_sym__Atomic] = ACTIONS(3497),
    [anon_sym_mutable] = ACTIONS(3497),
    [anon_sym_explicit] = ACTIONS(3497),
    [anon_sym_constexpr] = ACTIONS(3497),
    [anon_sym_unsigned] = ACTIONS(3497),
    [anon_sym_long] = ACTIONS(3497),
    [anon_sym_short] = ACTIONS(3497),
    [sym_primitive_type] = ACTIONS(3497),
    [anon_sym_enum] = ACTIONS(3497),
    [anon_sym_struct] = ACTIONS(3497),
    [anon_sym_union] = ACTIONS(3497),
    [anon_sym_AMP] = ACTIONS(3497),
    [anon_sym_AMP_AMP] = ACTIONS(3495),
    [anon_sym_TILDE] = ACTIONS(3495),
    [sym_identifier] = ACTIONS(3497),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(3497),
    [sym_auto] = ACTIONS(3497),
    [anon_sym_typename] = ACTIONS(3497),
    [anon_sym_template] = ACTIONS(3497),
    [anon_sym_namespace] = ACTIONS(3497),
    [anon_sym_using] = ACTIONS(3497),
    [anon_sym_COLON_COLON] = ACTIONS(3495),
    [sym_operator_name] = ACTIONS(3495),
  },
  [2089] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3501),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3501),
    [anon_sym_LPAREN] = ACTIONS(3499),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3501),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3501),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3501),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3501),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(3501),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(3501),
    [sym_preproc_directive] = ACTIONS(3501),
    [anon_sym_typedef] = ACTIONS(3501),
    [anon_sym_extern] = ACTIONS(3501),
    [anon_sym_STAR] = ACTIONS(3499),
    [anon_sym_static] = ACTIONS(3501),
    [anon_sym_register] = ACTIONS(3501),
    [anon_sym_inline] = ACTIONS(3501),
    [anon_sym_const] = ACTIONS(3501),
    [anon_sym_restrict] = ACTIONS(3501),
    [anon_sym_volatile] = ACTIONS(3501),
    [anon_sym__Atomic] = ACTIONS(3501),
    [anon_sym_mutable] = ACTIONS(3501),
    [anon_sym_explicit] = ACTIONS(3501),
    [anon_sym_constexpr] = ACTIONS(3501),
    [anon_sym_unsigned] = ACTIONS(3501),
    [anon_sym_long] = ACTIONS(3501),
    [anon_sym_short] = ACTIONS(3501),
    [sym_primitive_type] = ACTIONS(3501),
    [anon_sym_enum] = ACTIONS(3501),
    [anon_sym_struct] = ACTIONS(3501),
    [anon_sym_union] = ACTIONS(3501),
    [anon_sym_AMP] = ACTIONS(3501),
    [anon_sym_AMP_AMP] = ACTIONS(3499),
    [anon_sym_TILDE] = ACTIONS(3499),
    [sym_identifier] = ACTIONS(3501),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(3501),
    [sym_auto] = ACTIONS(3501),
    [anon_sym_typename] = ACTIONS(3501),
    [anon_sym_template] = ACTIONS(3501),
    [anon_sym_namespace] = ACTIONS(3501),
    [anon_sym_using] = ACTIONS(3501),
    [anon_sym_COLON_COLON] = ACTIONS(3499),
    [sym_operator_name] = ACTIONS(3499),
  },
  [2090] = {
    [anon_sym_LF] = ACTIONS(5711),
    [sym_comment] = ACTIONS(83),
  },
  [2091] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1825),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1825),
    [anon_sym_LPAREN] = ACTIONS(1823),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1825),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(1825),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1825),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1825),
    [sym_preproc_directive] = ACTIONS(1825),
    [anon_sym_typedef] = ACTIONS(1825),
    [anon_sym_extern] = ACTIONS(1825),
    [anon_sym_STAR] = ACTIONS(1823),
    [anon_sym_static] = ACTIONS(1825),
    [anon_sym_register] = ACTIONS(1825),
    [anon_sym_inline] = ACTIONS(1825),
    [anon_sym_const] = ACTIONS(1825),
    [anon_sym_restrict] = ACTIONS(1825),
    [anon_sym_volatile] = ACTIONS(1825),
    [anon_sym__Atomic] = ACTIONS(1825),
    [anon_sym_mutable] = ACTIONS(1825),
    [anon_sym_explicit] = ACTIONS(1825),
    [anon_sym_constexpr] = ACTIONS(1825),
    [anon_sym_unsigned] = ACTIONS(1825),
    [anon_sym_long] = ACTIONS(1825),
    [anon_sym_short] = ACTIONS(1825),
    [sym_primitive_type] = ACTIONS(1825),
    [anon_sym_enum] = ACTIONS(1825),
    [anon_sym_struct] = ACTIONS(1825),
    [anon_sym_union] = ACTIONS(1825),
    [anon_sym_AMP] = ACTIONS(1825),
    [anon_sym_AMP_AMP] = ACTIONS(1823),
    [anon_sym_TILDE] = ACTIONS(1823),
    [sym_identifier] = ACTIONS(1825),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(1825),
    [sym_auto] = ACTIONS(1825),
    [anon_sym_typename] = ACTIONS(1825),
    [anon_sym_template] = ACTIONS(1825),
    [anon_sym_namespace] = ACTIONS(1825),
    [anon_sym_using] = ACTIONS(1825),
    [anon_sym_COLON_COLON] = ACTIONS(1823),
    [sym_operator_name] = ACTIONS(1823),
  },
  [2092] = {
    [anon_sym_LF] = ACTIONS(5713),
    [sym_comment] = ACTIONS(83),
  },
  [2093] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1911),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1911),
    [anon_sym_LPAREN] = ACTIONS(1909),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1911),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(1911),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1911),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1911),
    [sym_preproc_directive] = ACTIONS(1911),
    [anon_sym_typedef] = ACTIONS(1911),
    [anon_sym_extern] = ACTIONS(1911),
    [anon_sym_STAR] = ACTIONS(1909),
    [anon_sym_static] = ACTIONS(1911),
    [anon_sym_register] = ACTIONS(1911),
    [anon_sym_inline] = ACTIONS(1911),
    [anon_sym_const] = ACTIONS(1911),
    [anon_sym_restrict] = ACTIONS(1911),
    [anon_sym_volatile] = ACTIONS(1911),
    [anon_sym__Atomic] = ACTIONS(1911),
    [anon_sym_mutable] = ACTIONS(1911),
    [anon_sym_explicit] = ACTIONS(1911),
    [anon_sym_constexpr] = ACTIONS(1911),
    [anon_sym_unsigned] = ACTIONS(1911),
    [anon_sym_long] = ACTIONS(1911),
    [anon_sym_short] = ACTIONS(1911),
    [sym_primitive_type] = ACTIONS(1911),
    [anon_sym_enum] = ACTIONS(1911),
    [anon_sym_struct] = ACTIONS(1911),
    [anon_sym_union] = ACTIONS(1911),
    [anon_sym_AMP] = ACTIONS(1911),
    [anon_sym_AMP_AMP] = ACTIONS(1909),
    [anon_sym_TILDE] = ACTIONS(1909),
    [sym_identifier] = ACTIONS(1911),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(1911),
    [sym_auto] = ACTIONS(1911),
    [anon_sym_typename] = ACTIONS(1911),
    [anon_sym_template] = ACTIONS(1911),
    [anon_sym_namespace] = ACTIONS(1911),
    [anon_sym_using] = ACTIONS(1911),
    [anon_sym_COLON_COLON] = ACTIONS(1909),
    [sym_operator_name] = ACTIONS(1909),
  },
  [2094] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(5715),
    [sym_comment] = ACTIONS(49),
  },
  [2095] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1962),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1962),
    [anon_sym_LPAREN] = ACTIONS(1960),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1962),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(1962),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1962),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1962),
    [sym_preproc_directive] = ACTIONS(1962),
    [anon_sym_typedef] = ACTIONS(1962),
    [anon_sym_extern] = ACTIONS(1962),
    [anon_sym_STAR] = ACTIONS(1960),
    [anon_sym_static] = ACTIONS(1962),
    [anon_sym_register] = ACTIONS(1962),
    [anon_sym_inline] = ACTIONS(1962),
    [anon_sym_const] = ACTIONS(1962),
    [anon_sym_restrict] = ACTIONS(1962),
    [anon_sym_volatile] = ACTIONS(1962),
    [anon_sym__Atomic] = ACTIONS(1962),
    [anon_sym_mutable] = ACTIONS(1962),
    [anon_sym_explicit] = ACTIONS(1962),
    [anon_sym_constexpr] = ACTIONS(1962),
    [anon_sym_unsigned] = ACTIONS(1962),
    [anon_sym_long] = ACTIONS(1962),
    [anon_sym_short] = ACTIONS(1962),
    [sym_primitive_type] = ACTIONS(1962),
    [anon_sym_enum] = ACTIONS(1962),
    [anon_sym_struct] = ACTIONS(1962),
    [anon_sym_union] = ACTIONS(1962),
    [anon_sym_AMP] = ACTIONS(1962),
    [anon_sym_AMP_AMP] = ACTIONS(1960),
    [anon_sym_TILDE] = ACTIONS(1960),
    [sym_identifier] = ACTIONS(1962),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(1962),
    [sym_auto] = ACTIONS(1962),
    [anon_sym_typename] = ACTIONS(1962),
    [anon_sym_template] = ACTIONS(1962),
    [anon_sym_namespace] = ACTIONS(1962),
    [anon_sym_using] = ACTIONS(1962),
    [anon_sym_COLON_COLON] = ACTIONS(1960),
    [sym_operator_name] = ACTIONS(1960),
  },
  [2096] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(5717),
    [sym_comment] = ACTIONS(49),
  },
  [2097] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1968),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1968),
    [anon_sym_LPAREN] = ACTIONS(1966),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1968),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(1968),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1968),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1968),
    [sym_preproc_directive] = ACTIONS(1968),
    [anon_sym_typedef] = ACTIONS(1968),
    [anon_sym_extern] = ACTIONS(1968),
    [anon_sym_STAR] = ACTIONS(1966),
    [anon_sym_static] = ACTIONS(1968),
    [anon_sym_register] = ACTIONS(1968),
    [anon_sym_inline] = ACTIONS(1968),
    [anon_sym_const] = ACTIONS(1968),
    [anon_sym_restrict] = ACTIONS(1968),
    [anon_sym_volatile] = ACTIONS(1968),
    [anon_sym__Atomic] = ACTIONS(1968),
    [anon_sym_mutable] = ACTIONS(1968),
    [anon_sym_explicit] = ACTIONS(1968),
    [anon_sym_constexpr] = ACTIONS(1968),
    [anon_sym_unsigned] = ACTIONS(1968),
    [anon_sym_long] = ACTIONS(1968),
    [anon_sym_short] = ACTIONS(1968),
    [sym_primitive_type] = ACTIONS(1968),
    [anon_sym_enum] = ACTIONS(1968),
    [anon_sym_struct] = ACTIONS(1968),
    [anon_sym_union] = ACTIONS(1968),
    [anon_sym_AMP] = ACTIONS(1968),
    [anon_sym_AMP_AMP] = ACTIONS(1966),
    [anon_sym_TILDE] = ACTIONS(1966),
    [sym_identifier] = ACTIONS(1968),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(1968),
    [sym_auto] = ACTIONS(1968),
    [anon_sym_typename] = ACTIONS(1968),
    [anon_sym_template] = ACTIONS(1968),
    [anon_sym_namespace] = ACTIONS(1968),
    [anon_sym_using] = ACTIONS(1968),
    [anon_sym_COLON_COLON] = ACTIONS(1966),
    [sym_operator_name] = ACTIONS(1966),
  },
  [2098] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(5719),
    [sym_comment] = ACTIONS(49),
  },
  [2099] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1974),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1974),
    [anon_sym_LPAREN] = ACTIONS(1972),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1974),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(1974),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1974),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1974),
    [sym_preproc_directive] = ACTIONS(1974),
    [anon_sym_typedef] = ACTIONS(1974),
    [anon_sym_extern] = ACTIONS(1974),
    [anon_sym_STAR] = ACTIONS(1972),
    [anon_sym_static] = ACTIONS(1974),
    [anon_sym_register] = ACTIONS(1974),
    [anon_sym_inline] = ACTIONS(1974),
    [anon_sym_const] = ACTIONS(1974),
    [anon_sym_restrict] = ACTIONS(1974),
    [anon_sym_volatile] = ACTIONS(1974),
    [anon_sym__Atomic] = ACTIONS(1974),
    [anon_sym_mutable] = ACTIONS(1974),
    [anon_sym_explicit] = ACTIONS(1974),
    [anon_sym_constexpr] = ACTIONS(1974),
    [anon_sym_unsigned] = ACTIONS(1974),
    [anon_sym_long] = ACTIONS(1974),
    [anon_sym_short] = ACTIONS(1974),
    [sym_primitive_type] = ACTIONS(1974),
    [anon_sym_enum] = ACTIONS(1974),
    [anon_sym_struct] = ACTIONS(1974),
    [anon_sym_union] = ACTIONS(1974),
    [anon_sym_AMP] = ACTIONS(1974),
    [anon_sym_AMP_AMP] = ACTIONS(1972),
    [anon_sym_TILDE] = ACTIONS(1972),
    [sym_identifier] = ACTIONS(1974),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(1974),
    [sym_auto] = ACTIONS(1974),
    [anon_sym_typename] = ACTIONS(1974),
    [anon_sym_template] = ACTIONS(1974),
    [anon_sym_namespace] = ACTIONS(1974),
    [anon_sym_using] = ACTIONS(1974),
    [anon_sym_COLON_COLON] = ACTIONS(1972),
    [sym_operator_name] = ACTIONS(1972),
  },
  [2100] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1990),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1990),
    [anon_sym_LPAREN] = ACTIONS(1988),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1990),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(1990),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1990),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1990),
    [sym_preproc_directive] = ACTIONS(1990),
    [anon_sym_typedef] = ACTIONS(1990),
    [anon_sym_extern] = ACTIONS(1990),
    [anon_sym_STAR] = ACTIONS(1988),
    [anon_sym_static] = ACTIONS(1990),
    [anon_sym_register] = ACTIONS(1990),
    [anon_sym_inline] = ACTIONS(1990),
    [anon_sym_const] = ACTIONS(1990),
    [anon_sym_restrict] = ACTIONS(1990),
    [anon_sym_volatile] = ACTIONS(1990),
    [anon_sym__Atomic] = ACTIONS(1990),
    [anon_sym_mutable] = ACTIONS(1990),
    [anon_sym_explicit] = ACTIONS(1990),
    [anon_sym_constexpr] = ACTIONS(1990),
    [anon_sym_unsigned] = ACTIONS(1990),
    [anon_sym_long] = ACTIONS(1990),
    [anon_sym_short] = ACTIONS(1990),
    [sym_primitive_type] = ACTIONS(1990),
    [anon_sym_enum] = ACTIONS(1990),
    [anon_sym_struct] = ACTIONS(1990),
    [anon_sym_union] = ACTIONS(1990),
    [anon_sym_AMP] = ACTIONS(1990),
    [anon_sym_AMP_AMP] = ACTIONS(1988),
    [anon_sym_TILDE] = ACTIONS(1988),
    [sym_identifier] = ACTIONS(1990),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(1990),
    [sym_auto] = ACTIONS(1990),
    [anon_sym_typename] = ACTIONS(1990),
    [anon_sym_template] = ACTIONS(1990),
    [anon_sym_namespace] = ACTIONS(1990),
    [anon_sym_using] = ACTIONS(1990),
    [anon_sym_COLON_COLON] = ACTIONS(1988),
    [sym_operator_name] = ACTIONS(1988),
  },
  [2101] = {
    [sym_parameter_list] = STATE(513),
    [anon_sym_LPAREN] = ACTIONS(206),
    [anon_sym_SEMI] = ACTIONS(5721),
    [anon_sym_LBRACK] = ACTIONS(955),
    [sym_comment] = ACTIONS(49),
  },
  [2102] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(2342),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(2342),
    [anon_sym_LPAREN] = ACTIONS(2340),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(2342),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(2342),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(2342),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(2342),
    [sym_preproc_directive] = ACTIONS(2342),
    [anon_sym_typedef] = ACTIONS(2342),
    [anon_sym_extern] = ACTIONS(2342),
    [anon_sym_STAR] = ACTIONS(2340),
    [anon_sym_static] = ACTIONS(2342),
    [anon_sym_register] = ACTIONS(2342),
    [anon_sym_inline] = ACTIONS(2342),
    [anon_sym_const] = ACTIONS(2342),
    [anon_sym_restrict] = ACTIONS(2342),
    [anon_sym_volatile] = ACTIONS(2342),
    [anon_sym__Atomic] = ACTIONS(2342),
    [anon_sym_mutable] = ACTIONS(2342),
    [anon_sym_explicit] = ACTIONS(2342),
    [anon_sym_constexpr] = ACTIONS(2342),
    [anon_sym_unsigned] = ACTIONS(2342),
    [anon_sym_long] = ACTIONS(2342),
    [anon_sym_short] = ACTIONS(2342),
    [sym_primitive_type] = ACTIONS(2342),
    [anon_sym_enum] = ACTIONS(2342),
    [anon_sym_struct] = ACTIONS(2342),
    [anon_sym_union] = ACTIONS(2342),
    [anon_sym_AMP] = ACTIONS(2342),
    [anon_sym_AMP_AMP] = ACTIONS(2340),
    [anon_sym_TILDE] = ACTIONS(2340),
    [sym_identifier] = ACTIONS(2342),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(2342),
    [sym_auto] = ACTIONS(2342),
    [anon_sym_typename] = ACTIONS(2342),
    [anon_sym_template] = ACTIONS(2342),
    [anon_sym_namespace] = ACTIONS(2342),
    [anon_sym_using] = ACTIONS(2342),
    [anon_sym_COLON_COLON] = ACTIONS(2340),
    [sym_operator_name] = ACTIONS(2340),
  },
  [2103] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(2357),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(2357),
    [anon_sym_LPAREN] = ACTIONS(2355),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(2357),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(2357),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(2357),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(2357),
    [sym_preproc_directive] = ACTIONS(2357),
    [anon_sym_typedef] = ACTIONS(2357),
    [anon_sym_extern] = ACTIONS(2357),
    [anon_sym_STAR] = ACTIONS(2355),
    [anon_sym_static] = ACTIONS(2357),
    [anon_sym_register] = ACTIONS(2357),
    [anon_sym_inline] = ACTIONS(2357),
    [anon_sym_const] = ACTIONS(2357),
    [anon_sym_restrict] = ACTIONS(2357),
    [anon_sym_volatile] = ACTIONS(2357),
    [anon_sym__Atomic] = ACTIONS(2357),
    [anon_sym_mutable] = ACTIONS(2357),
    [anon_sym_explicit] = ACTIONS(2357),
    [anon_sym_constexpr] = ACTIONS(2357),
    [anon_sym_unsigned] = ACTIONS(2357),
    [anon_sym_long] = ACTIONS(2357),
    [anon_sym_short] = ACTIONS(2357),
    [sym_primitive_type] = ACTIONS(2357),
    [anon_sym_enum] = ACTIONS(2357),
    [anon_sym_struct] = ACTIONS(2357),
    [anon_sym_union] = ACTIONS(2357),
    [anon_sym_AMP] = ACTIONS(2357),
    [anon_sym_AMP_AMP] = ACTIONS(2355),
    [anon_sym_TILDE] = ACTIONS(2355),
    [sym_identifier] = ACTIONS(2357),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(2357),
    [sym_auto] = ACTIONS(2357),
    [anon_sym_typename] = ACTIONS(2357),
    [anon_sym_template] = ACTIONS(2357),
    [anon_sym_namespace] = ACTIONS(2357),
    [anon_sym_using] = ACTIONS(2357),
    [anon_sym_COLON_COLON] = ACTIONS(2355),
    [sym_operator_name] = ACTIONS(2355),
  },
  [2104] = {
    [anon_sym_SEMI] = ACTIONS(5723),
    [sym_comment] = ACTIONS(49),
  },
  [2105] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(2373),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(2373),
    [anon_sym_LPAREN] = ACTIONS(2371),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(2373),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(2373),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(2373),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(2373),
    [sym_preproc_directive] = ACTIONS(2373),
    [anon_sym_typedef] = ACTIONS(2373),
    [anon_sym_extern] = ACTIONS(2373),
    [anon_sym_STAR] = ACTIONS(2371),
    [anon_sym_static] = ACTIONS(2373),
    [anon_sym_register] = ACTIONS(2373),
    [anon_sym_inline] = ACTIONS(2373),
    [anon_sym_const] = ACTIONS(2373),
    [anon_sym_restrict] = ACTIONS(2373),
    [anon_sym_volatile] = ACTIONS(2373),
    [anon_sym__Atomic] = ACTIONS(2373),
    [anon_sym_mutable] = ACTIONS(2373),
    [anon_sym_explicit] = ACTIONS(2373),
    [anon_sym_constexpr] = ACTIONS(2373),
    [anon_sym_unsigned] = ACTIONS(2373),
    [anon_sym_long] = ACTIONS(2373),
    [anon_sym_short] = ACTIONS(2373),
    [sym_primitive_type] = ACTIONS(2373),
    [anon_sym_enum] = ACTIONS(2373),
    [anon_sym_struct] = ACTIONS(2373),
    [anon_sym_union] = ACTIONS(2373),
    [anon_sym_AMP] = ACTIONS(2373),
    [anon_sym_AMP_AMP] = ACTIONS(2371),
    [anon_sym_TILDE] = ACTIONS(2371),
    [sym_identifier] = ACTIONS(2373),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(2373),
    [sym_auto] = ACTIONS(2373),
    [anon_sym_typename] = ACTIONS(2373),
    [anon_sym_template] = ACTIONS(2373),
    [anon_sym_namespace] = ACTIONS(2373),
    [anon_sym_using] = ACTIONS(2373),
    [anon_sym_COLON_COLON] = ACTIONS(2371),
    [sym_operator_name] = ACTIONS(2371),
  },
  [2106] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1624),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1624),
    [anon_sym_LPAREN] = ACTIONS(1622),
    [anon_sym_COMMA] = ACTIONS(2400),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1624),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(1624),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1624),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1624),
    [sym_preproc_directive] = ACTIONS(1624),
    [anon_sym_SEMI] = ACTIONS(2400),
    [anon_sym_typedef] = ACTIONS(1624),
    [anon_sym_extern] = ACTIONS(1624),
    [anon_sym_STAR] = ACTIONS(1622),
    [anon_sym_static] = ACTIONS(1624),
    [anon_sym_register] = ACTIONS(1624),
    [anon_sym_inline] = ACTIONS(1624),
    [anon_sym_const] = ACTIONS(1624),
    [anon_sym_restrict] = ACTIONS(1624),
    [anon_sym_volatile] = ACTIONS(1624),
    [anon_sym__Atomic] = ACTIONS(1624),
    [anon_sym_mutable] = ACTIONS(1624),
    [anon_sym_explicit] = ACTIONS(1624),
    [anon_sym_constexpr] = ACTIONS(1624),
    [anon_sym_unsigned] = ACTIONS(1624),
    [anon_sym_long] = ACTIONS(1624),
    [anon_sym_short] = ACTIONS(1624),
    [sym_primitive_type] = ACTIONS(1624),
    [anon_sym_enum] = ACTIONS(1624),
    [anon_sym_struct] = ACTIONS(1624),
    [anon_sym_union] = ACTIONS(1624),
    [anon_sym_AMP] = ACTIONS(1624),
    [anon_sym_AMP_AMP] = ACTIONS(1622),
    [anon_sym_TILDE] = ACTIONS(1622),
    [sym_identifier] = ACTIONS(1624),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(1624),
    [sym_auto] = ACTIONS(1624),
    [anon_sym_typename] = ACTIONS(1624),
    [anon_sym_template] = ACTIONS(1624),
    [anon_sym_namespace] = ACTIONS(1624),
    [anon_sym_using] = ACTIONS(1624),
    [anon_sym_COLON_COLON] = ACTIONS(1622),
    [sym_operator_name] = ACTIONS(1622),
  },
  [2107] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(2480),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(2480),
    [anon_sym_LPAREN] = ACTIONS(2478),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(2480),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(2480),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(2480),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(2480),
    [sym_preproc_directive] = ACTIONS(2480),
    [anon_sym_typedef] = ACTIONS(2480),
    [anon_sym_extern] = ACTIONS(2480),
    [anon_sym_STAR] = ACTIONS(2478),
    [anon_sym_static] = ACTIONS(2480),
    [anon_sym_register] = ACTIONS(2480),
    [anon_sym_inline] = ACTIONS(2480),
    [anon_sym_const] = ACTIONS(2480),
    [anon_sym_restrict] = ACTIONS(2480),
    [anon_sym_volatile] = ACTIONS(2480),
    [anon_sym__Atomic] = ACTIONS(2480),
    [anon_sym_mutable] = ACTIONS(2480),
    [anon_sym_explicit] = ACTIONS(2480),
    [anon_sym_constexpr] = ACTIONS(2480),
    [anon_sym_unsigned] = ACTIONS(2480),
    [anon_sym_long] = ACTIONS(2480),
    [anon_sym_short] = ACTIONS(2480),
    [sym_primitive_type] = ACTIONS(2480),
    [anon_sym_enum] = ACTIONS(2480),
    [anon_sym_struct] = ACTIONS(2480),
    [anon_sym_union] = ACTIONS(2480),
    [anon_sym_AMP] = ACTIONS(2480),
    [anon_sym_AMP_AMP] = ACTIONS(2478),
    [anon_sym_TILDE] = ACTIONS(2478),
    [sym_identifier] = ACTIONS(2480),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(2480),
    [sym_auto] = ACTIONS(2480),
    [anon_sym_typename] = ACTIONS(2480),
    [anon_sym_template] = ACTIONS(2480),
    [anon_sym_namespace] = ACTIONS(2480),
    [anon_sym_using] = ACTIONS(2480),
    [anon_sym_COLON_COLON] = ACTIONS(2478),
    [sym_operator_name] = ACTIONS(2478),
  },
  [2108] = {
    [sym_argument_list] = STATE(802),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_SEMI] = ACTIONS(5725),
    [anon_sym_STAR] = ACTIONS(2553),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_EQ] = ACTIONS(2555),
    [anon_sym_QMARK] = ACTIONS(2557),
    [anon_sym_STAR_EQ] = ACTIONS(2559),
    [anon_sym_SLASH_EQ] = ACTIONS(2559),
    [anon_sym_PERCENT_EQ] = ACTIONS(2559),
    [anon_sym_PLUS_EQ] = ACTIONS(2559),
    [anon_sym_DASH_EQ] = ACTIONS(2559),
    [anon_sym_LT_LT_EQ] = ACTIONS(2559),
    [anon_sym_GT_GT_EQ] = ACTIONS(2559),
    [anon_sym_AMP_EQ] = ACTIONS(2559),
    [anon_sym_CARET_EQ] = ACTIONS(2559),
    [anon_sym_PIPE_EQ] = ACTIONS(2559),
    [anon_sym_AMP] = ACTIONS(2561),
    [anon_sym_PIPE_PIPE] = ACTIONS(2563),
    [anon_sym_AMP_AMP] = ACTIONS(2565),
    [anon_sym_PIPE] = ACTIONS(2567),
    [anon_sym_CARET] = ACTIONS(2569),
    [anon_sym_EQ_EQ] = ACTIONS(2571),
    [anon_sym_BANG_EQ] = ACTIONS(2571),
    [anon_sym_LT] = ACTIONS(2573),
    [anon_sym_GT] = ACTIONS(2573),
    [anon_sym_LT_EQ] = ACTIONS(2575),
    [anon_sym_GT_EQ] = ACTIONS(2575),
    [anon_sym_LT_LT] = ACTIONS(2577),
    [anon_sym_GT_GT] = ACTIONS(2577),
    [anon_sym_PLUS] = ACTIONS(2579),
    [anon_sym_DASH] = ACTIONS(2579),
    [anon_sym_SLASH] = ACTIONS(2553),
    [anon_sym_PERCENT] = ACTIONS(2553),
    [anon_sym_DASH_DASH] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(1554),
    [anon_sym_DASH_GT] = ACTIONS(1554),
    [sym_comment] = ACTIONS(49),
  },
  [2109] = {
    [anon_sym_SEMI] = ACTIONS(5725),
    [sym_comment] = ACTIONS(49),
  },
  [2110] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(2583),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(2583),
    [anon_sym_LPAREN] = ACTIONS(2581),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(2583),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(2583),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(2583),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(2583),
    [sym_preproc_directive] = ACTIONS(2583),
    [anon_sym_typedef] = ACTIONS(2583),
    [anon_sym_extern] = ACTIONS(2583),
    [anon_sym_STAR] = ACTIONS(2581),
    [anon_sym_static] = ACTIONS(2583),
    [anon_sym_register] = ACTIONS(2583),
    [anon_sym_inline] = ACTIONS(2583),
    [anon_sym_const] = ACTIONS(2583),
    [anon_sym_restrict] = ACTIONS(2583),
    [anon_sym_volatile] = ACTIONS(2583),
    [anon_sym__Atomic] = ACTIONS(2583),
    [anon_sym_mutable] = ACTIONS(2583),
    [anon_sym_explicit] = ACTIONS(2583),
    [anon_sym_constexpr] = ACTIONS(2583),
    [anon_sym_unsigned] = ACTIONS(2583),
    [anon_sym_long] = ACTIONS(2583),
    [anon_sym_short] = ACTIONS(2583),
    [sym_primitive_type] = ACTIONS(2583),
    [anon_sym_enum] = ACTIONS(2583),
    [anon_sym_struct] = ACTIONS(2583),
    [anon_sym_union] = ACTIONS(2583),
    [anon_sym_AMP] = ACTIONS(2583),
    [anon_sym_AMP_AMP] = ACTIONS(2581),
    [anon_sym_TILDE] = ACTIONS(2581),
    [sym_identifier] = ACTIONS(2583),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(2583),
    [sym_auto] = ACTIONS(2583),
    [anon_sym_typename] = ACTIONS(2583),
    [anon_sym_template] = ACTIONS(2583),
    [anon_sym_namespace] = ACTIONS(2583),
    [anon_sym_using] = ACTIONS(2583),
    [anon_sym_COLON_COLON] = ACTIONS(2581),
    [sym_operator_name] = ACTIONS(2581),
  },
  [2111] = {
    [sym_argument_list] = STATE(802),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_SEMI] = ACTIONS(5727),
    [anon_sym_STAR] = ACTIONS(2553),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_EQ] = ACTIONS(2555),
    [anon_sym_QMARK] = ACTIONS(2557),
    [anon_sym_STAR_EQ] = ACTIONS(2559),
    [anon_sym_SLASH_EQ] = ACTIONS(2559),
    [anon_sym_PERCENT_EQ] = ACTIONS(2559),
    [anon_sym_PLUS_EQ] = ACTIONS(2559),
    [anon_sym_DASH_EQ] = ACTIONS(2559),
    [anon_sym_LT_LT_EQ] = ACTIONS(2559),
    [anon_sym_GT_GT_EQ] = ACTIONS(2559),
    [anon_sym_AMP_EQ] = ACTIONS(2559),
    [anon_sym_CARET_EQ] = ACTIONS(2559),
    [anon_sym_PIPE_EQ] = ACTIONS(2559),
    [anon_sym_AMP] = ACTIONS(2561),
    [anon_sym_PIPE_PIPE] = ACTIONS(2563),
    [anon_sym_AMP_AMP] = ACTIONS(2565),
    [anon_sym_PIPE] = ACTIONS(2567),
    [anon_sym_CARET] = ACTIONS(2569),
    [anon_sym_EQ_EQ] = ACTIONS(2571),
    [anon_sym_BANG_EQ] = ACTIONS(2571),
    [anon_sym_LT] = ACTIONS(2573),
    [anon_sym_GT] = ACTIONS(2573),
    [anon_sym_LT_EQ] = ACTIONS(2575),
    [anon_sym_GT_EQ] = ACTIONS(2575),
    [anon_sym_LT_LT] = ACTIONS(2577),
    [anon_sym_GT_GT] = ACTIONS(2577),
    [anon_sym_PLUS] = ACTIONS(2579),
    [anon_sym_DASH] = ACTIONS(2579),
    [anon_sym_SLASH] = ACTIONS(2553),
    [anon_sym_PERCENT] = ACTIONS(2553),
    [anon_sym_DASH_DASH] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(1554),
    [anon_sym_DASH_GT] = ACTIONS(1554),
    [sym_comment] = ACTIONS(49),
  },
  [2112] = {
    [anon_sym_SEMI] = ACTIONS(5727),
    [sym_comment] = ACTIONS(49),
  },
  [2113] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(2589),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(2589),
    [anon_sym_LPAREN] = ACTIONS(2587),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(2589),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(2589),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(2589),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(2589),
    [sym_preproc_directive] = ACTIONS(2589),
    [anon_sym_typedef] = ACTIONS(2589),
    [anon_sym_extern] = ACTIONS(2589),
    [anon_sym_STAR] = ACTIONS(2587),
    [anon_sym_static] = ACTIONS(2589),
    [anon_sym_register] = ACTIONS(2589),
    [anon_sym_inline] = ACTIONS(2589),
    [anon_sym_const] = ACTIONS(2589),
    [anon_sym_restrict] = ACTIONS(2589),
    [anon_sym_volatile] = ACTIONS(2589),
    [anon_sym__Atomic] = ACTIONS(2589),
    [anon_sym_mutable] = ACTIONS(2589),
    [anon_sym_explicit] = ACTIONS(2589),
    [anon_sym_constexpr] = ACTIONS(2589),
    [anon_sym_unsigned] = ACTIONS(2589),
    [anon_sym_long] = ACTIONS(2589),
    [anon_sym_short] = ACTIONS(2589),
    [sym_primitive_type] = ACTIONS(2589),
    [anon_sym_enum] = ACTIONS(2589),
    [anon_sym_struct] = ACTIONS(2589),
    [anon_sym_union] = ACTIONS(2589),
    [anon_sym_AMP] = ACTIONS(2589),
    [anon_sym_AMP_AMP] = ACTIONS(2587),
    [anon_sym_TILDE] = ACTIONS(2587),
    [sym_identifier] = ACTIONS(2589),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(2589),
    [sym_auto] = ACTIONS(2589),
    [anon_sym_typename] = ACTIONS(2589),
    [anon_sym_template] = ACTIONS(2589),
    [anon_sym_namespace] = ACTIONS(2589),
    [anon_sym_using] = ACTIONS(2589),
    [anon_sym_COLON_COLON] = ACTIONS(2587),
    [sym_operator_name] = ACTIONS(2587),
  },
  [2114] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3184),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3184),
    [anon_sym_LPAREN] = ACTIONS(3182),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3184),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3184),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3184),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3184),
    [sym_preproc_directive] = ACTIONS(3184),
    [anon_sym_typedef] = ACTIONS(3184),
    [anon_sym_extern] = ACTIONS(3184),
    [anon_sym_STAR] = ACTIONS(3182),
    [anon_sym_static] = ACTIONS(3184),
    [anon_sym_register] = ACTIONS(3184),
    [anon_sym_inline] = ACTIONS(3184),
    [anon_sym_const] = ACTIONS(3184),
    [anon_sym_restrict] = ACTIONS(3184),
    [anon_sym_volatile] = ACTIONS(3184),
    [anon_sym__Atomic] = ACTIONS(3184),
    [anon_sym_mutable] = ACTIONS(3184),
    [anon_sym_explicit] = ACTIONS(3184),
    [anon_sym_constexpr] = ACTIONS(3184),
    [anon_sym_unsigned] = ACTIONS(3184),
    [anon_sym_long] = ACTIONS(3184),
    [anon_sym_short] = ACTIONS(3184),
    [sym_primitive_type] = ACTIONS(3184),
    [anon_sym_enum] = ACTIONS(3184),
    [anon_sym_struct] = ACTIONS(3184),
    [anon_sym_union] = ACTIONS(3184),
    [anon_sym_AMP] = ACTIONS(3184),
    [anon_sym_AMP_AMP] = ACTIONS(3182),
    [anon_sym_TILDE] = ACTIONS(3182),
    [sym_identifier] = ACTIONS(3184),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(3184),
    [sym_auto] = ACTIONS(3184),
    [anon_sym_typename] = ACTIONS(3184),
    [anon_sym_template] = ACTIONS(3184),
    [anon_sym_namespace] = ACTIONS(3184),
    [anon_sym_using] = ACTIONS(3184),
    [anon_sym_COLON_COLON] = ACTIONS(3182),
    [sym_operator_name] = ACTIONS(3182),
  },
  [2115] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3340),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3340),
    [anon_sym_LPAREN] = ACTIONS(3338),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3340),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3340),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3340),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3340),
    [sym_preproc_directive] = ACTIONS(3340),
    [anon_sym_typedef] = ACTIONS(3340),
    [anon_sym_extern] = ACTIONS(3340),
    [anon_sym_STAR] = ACTIONS(3338),
    [anon_sym_static] = ACTIONS(3340),
    [anon_sym_register] = ACTIONS(3340),
    [anon_sym_inline] = ACTIONS(3340),
    [anon_sym_const] = ACTIONS(3340),
    [anon_sym_restrict] = ACTIONS(3340),
    [anon_sym_volatile] = ACTIONS(3340),
    [anon_sym__Atomic] = ACTIONS(3340),
    [anon_sym_mutable] = ACTIONS(3340),
    [anon_sym_explicit] = ACTIONS(3340),
    [anon_sym_constexpr] = ACTIONS(3340),
    [anon_sym_unsigned] = ACTIONS(3340),
    [anon_sym_long] = ACTIONS(3340),
    [anon_sym_short] = ACTIONS(3340),
    [sym_primitive_type] = ACTIONS(3340),
    [anon_sym_enum] = ACTIONS(3340),
    [anon_sym_struct] = ACTIONS(3340),
    [anon_sym_union] = ACTIONS(3340),
    [anon_sym_AMP] = ACTIONS(3340),
    [anon_sym_AMP_AMP] = ACTIONS(3338),
    [anon_sym_TILDE] = ACTIONS(3338),
    [sym_identifier] = ACTIONS(3340),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(3340),
    [sym_auto] = ACTIONS(3340),
    [anon_sym_typename] = ACTIONS(3340),
    [anon_sym_template] = ACTIONS(3340),
    [anon_sym_namespace] = ACTIONS(3340),
    [anon_sym_using] = ACTIONS(3340),
    [anon_sym_COLON_COLON] = ACTIONS(3338),
    [sym_operator_name] = ACTIONS(3338),
  },
  [2116] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3521),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3521),
    [anon_sym_LPAREN] = ACTIONS(3519),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3521),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3521),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3521),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3521),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(3521),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(3521),
    [sym_preproc_directive] = ACTIONS(3521),
    [anon_sym_typedef] = ACTIONS(3521),
    [anon_sym_extern] = ACTIONS(3521),
    [anon_sym_STAR] = ACTIONS(3519),
    [anon_sym_static] = ACTIONS(3521),
    [anon_sym_register] = ACTIONS(3521),
    [anon_sym_inline] = ACTIONS(3521),
    [anon_sym_const] = ACTIONS(3521),
    [anon_sym_restrict] = ACTIONS(3521),
    [anon_sym_volatile] = ACTIONS(3521),
    [anon_sym__Atomic] = ACTIONS(3521),
    [anon_sym_mutable] = ACTIONS(3521),
    [anon_sym_explicit] = ACTIONS(3521),
    [anon_sym_constexpr] = ACTIONS(3521),
    [anon_sym_unsigned] = ACTIONS(3521),
    [anon_sym_long] = ACTIONS(3521),
    [anon_sym_short] = ACTIONS(3521),
    [sym_primitive_type] = ACTIONS(3521),
    [anon_sym_enum] = ACTIONS(3521),
    [anon_sym_struct] = ACTIONS(3521),
    [anon_sym_union] = ACTIONS(3521),
    [anon_sym_AMP] = ACTIONS(3521),
    [anon_sym_AMP_AMP] = ACTIONS(3519),
    [anon_sym_TILDE] = ACTIONS(3519),
    [sym_identifier] = ACTIONS(3521),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(3521),
    [sym_auto] = ACTIONS(3521),
    [anon_sym_typename] = ACTIONS(3521),
    [anon_sym_template] = ACTIONS(3521),
    [anon_sym_namespace] = ACTIONS(3521),
    [anon_sym_using] = ACTIONS(3521),
    [anon_sym_COLON_COLON] = ACTIONS(3519),
    [sym_operator_name] = ACTIONS(3519),
  },
  [2117] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3864),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3864),
    [anon_sym_LPAREN] = ACTIONS(3862),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3864),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3864),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3864),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3864),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(3864),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(3864),
    [sym_preproc_directive] = ACTIONS(3864),
    [anon_sym_typedef] = ACTIONS(3864),
    [anon_sym_extern] = ACTIONS(3864),
    [anon_sym_STAR] = ACTIONS(3862),
    [anon_sym_static] = ACTIONS(3864),
    [anon_sym_register] = ACTIONS(3864),
    [anon_sym_inline] = ACTIONS(3864),
    [anon_sym_const] = ACTIONS(3864),
    [anon_sym_restrict] = ACTIONS(3864),
    [anon_sym_volatile] = ACTIONS(3864),
    [anon_sym__Atomic] = ACTIONS(3864),
    [anon_sym_mutable] = ACTIONS(3864),
    [anon_sym_explicit] = ACTIONS(3864),
    [anon_sym_constexpr] = ACTIONS(3864),
    [anon_sym_unsigned] = ACTIONS(3864),
    [anon_sym_long] = ACTIONS(3864),
    [anon_sym_short] = ACTIONS(3864),
    [sym_primitive_type] = ACTIONS(3864),
    [anon_sym_enum] = ACTIONS(3864),
    [anon_sym_struct] = ACTIONS(3864),
    [anon_sym_union] = ACTIONS(3864),
    [anon_sym_AMP] = ACTIONS(3864),
    [anon_sym_AMP_AMP] = ACTIONS(3862),
    [anon_sym_TILDE] = ACTIONS(3862),
    [sym_identifier] = ACTIONS(3864),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(3864),
    [sym_auto] = ACTIONS(3864),
    [anon_sym_typename] = ACTIONS(3864),
    [anon_sym_template] = ACTIONS(3864),
    [anon_sym_namespace] = ACTIONS(3864),
    [anon_sym_using] = ACTIONS(3864),
    [anon_sym_COLON_COLON] = ACTIONS(3862),
    [sym_operator_name] = ACTIONS(3862),
  },
  [2118] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(4066),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(4066),
    [anon_sym_LPAREN] = ACTIONS(4064),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(4066),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(4066),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(4066),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(4066),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(4066),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(4066),
    [sym_preproc_directive] = ACTIONS(4066),
    [anon_sym_typedef] = ACTIONS(4066),
    [anon_sym_extern] = ACTIONS(4066),
    [anon_sym_STAR] = ACTIONS(4064),
    [anon_sym_static] = ACTIONS(4066),
    [anon_sym_register] = ACTIONS(4066),
    [anon_sym_inline] = ACTIONS(4066),
    [anon_sym_const] = ACTIONS(4066),
    [anon_sym_restrict] = ACTIONS(4066),
    [anon_sym_volatile] = ACTIONS(4066),
    [anon_sym__Atomic] = ACTIONS(4066),
    [anon_sym_mutable] = ACTIONS(4066),
    [anon_sym_explicit] = ACTIONS(4066),
    [anon_sym_constexpr] = ACTIONS(4066),
    [anon_sym_unsigned] = ACTIONS(4066),
    [anon_sym_long] = ACTIONS(4066),
    [anon_sym_short] = ACTIONS(4066),
    [sym_primitive_type] = ACTIONS(4066),
    [anon_sym_enum] = ACTIONS(4066),
    [anon_sym_struct] = ACTIONS(4066),
    [anon_sym_union] = ACTIONS(4066),
    [anon_sym_AMP] = ACTIONS(4066),
    [anon_sym_AMP_AMP] = ACTIONS(4064),
    [anon_sym_TILDE] = ACTIONS(4064),
    [sym_identifier] = ACTIONS(4066),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(4066),
    [sym_auto] = ACTIONS(4066),
    [anon_sym_typename] = ACTIONS(4066),
    [anon_sym_template] = ACTIONS(4066),
    [anon_sym_namespace] = ACTIONS(4066),
    [anon_sym_using] = ACTIONS(4066),
    [anon_sym_COLON_COLON] = ACTIONS(4064),
    [sym_operator_name] = ACTIONS(4064),
  },
  [2119] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(4114),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(4114),
    [anon_sym_LPAREN] = ACTIONS(4112),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(4114),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(4114),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(4114),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(4114),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(4114),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(4114),
    [sym_preproc_directive] = ACTIONS(4114),
    [anon_sym_typedef] = ACTIONS(4114),
    [anon_sym_extern] = ACTIONS(4114),
    [anon_sym_STAR] = ACTIONS(4112),
    [anon_sym_static] = ACTIONS(4114),
    [anon_sym_register] = ACTIONS(4114),
    [anon_sym_inline] = ACTIONS(4114),
    [anon_sym_const] = ACTIONS(4114),
    [anon_sym_restrict] = ACTIONS(4114),
    [anon_sym_volatile] = ACTIONS(4114),
    [anon_sym__Atomic] = ACTIONS(4114),
    [anon_sym_mutable] = ACTIONS(4114),
    [anon_sym_explicit] = ACTIONS(4114),
    [anon_sym_constexpr] = ACTIONS(4114),
    [anon_sym_unsigned] = ACTIONS(4114),
    [anon_sym_long] = ACTIONS(4114),
    [anon_sym_short] = ACTIONS(4114),
    [sym_primitive_type] = ACTIONS(4114),
    [anon_sym_enum] = ACTIONS(4114),
    [anon_sym_struct] = ACTIONS(4114),
    [anon_sym_union] = ACTIONS(4114),
    [anon_sym_AMP] = ACTIONS(4114),
    [anon_sym_AMP_AMP] = ACTIONS(4112),
    [anon_sym_TILDE] = ACTIONS(4112),
    [sym_identifier] = ACTIONS(4114),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(4114),
    [sym_auto] = ACTIONS(4114),
    [anon_sym_typename] = ACTIONS(4114),
    [anon_sym_template] = ACTIONS(4114),
    [anon_sym_namespace] = ACTIONS(4114),
    [anon_sym_using] = ACTIONS(4114),
    [anon_sym_COLON_COLON] = ACTIONS(4112),
    [sym_operator_name] = ACTIONS(4112),
  },
  [2120] = {
    [anon_sym_LPAREN] = ACTIONS(4836),
    [anon_sym_STAR] = ACTIONS(4836),
    [sym_identifier] = ACTIONS(4836),
    [sym_comment] = ACTIONS(49),
  },
  [2121] = {
    [anon_sym_LPAREN] = ACTIONS(5729),
    [anon_sym_RPAREN] = ACTIONS(5729),
    [anon_sym_SEMI] = ACTIONS(5729),
    [anon_sym_LBRACK] = ACTIONS(5729),
    [sym_comment] = ACTIONS(49),
  },
  [2122] = {
    [sym_parameter_list] = STATE(2124),
    [anon_sym_LPAREN] = ACTIONS(206),
    [anon_sym_LBRACK] = ACTIONS(2282),
    [anon_sym_const] = ACTIONS(5283),
    [anon_sym_restrict] = ACTIONS(3750),
    [anon_sym_volatile] = ACTIONS(3750),
    [anon_sym__Atomic] = ACTIONS(3750),
    [anon_sym_mutable] = ACTIONS(3750),
    [anon_sym_explicit] = ACTIONS(3750),
    [anon_sym_constexpr] = ACTIONS(3750),
    [anon_sym_DASH_GT] = ACTIONS(3750),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(3750),
  },
  [2123] = {
    [sym_parameter_list] = STATE(2124),
    [anon_sym_LPAREN] = ACTIONS(206),
    [anon_sym_LBRACK] = ACTIONS(2282),
    [anon_sym_const] = ACTIONS(5285),
    [anon_sym_restrict] = ACTIONS(3762),
    [anon_sym_volatile] = ACTIONS(3762),
    [anon_sym__Atomic] = ACTIONS(3762),
    [anon_sym_mutable] = ACTIONS(3762),
    [anon_sym_explicit] = ACTIONS(3762),
    [anon_sym_constexpr] = ACTIONS(3762),
    [anon_sym_DASH_GT] = ACTIONS(3762),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(3762),
  },
  [2124] = {
    [sym_type_qualifier] = STATE(2440),
    [sym_trailing_return_type] = STATE(1713),
    [aux_sym_abstract_function_declarator_repeat1] = STATE(2440),
    [anon_sym_LPAREN] = ACTIONS(3764),
    [anon_sym_LBRACK] = ACTIONS(3764),
    [anon_sym_const] = ACTIONS(3770),
    [anon_sym_restrict] = ACTIONS(3764),
    [anon_sym_volatile] = ACTIONS(3764),
    [anon_sym__Atomic] = ACTIONS(3764),
    [anon_sym_mutable] = ACTIONS(3764),
    [anon_sym_explicit] = ACTIONS(3764),
    [anon_sym_constexpr] = ACTIONS(3764),
    [anon_sym_DASH_GT] = ACTIONS(3764),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(3764),
  },
  [2125] = {
    [sym_type_qualifier] = STATE(2249),
    [sym_trailing_return_type] = STATE(1713),
    [aux_sym_abstract_function_declarator_repeat1] = STATE(2249),
    [anon_sym_LPAREN] = ACTIONS(3764),
    [anon_sym_LBRACK] = ACTIONS(3764),
    [anon_sym_const] = ACTIONS(612),
    [anon_sym_restrict] = ACTIONS(614),
    [anon_sym_volatile] = ACTIONS(614),
    [anon_sym__Atomic] = ACTIONS(614),
    [anon_sym_mutable] = ACTIONS(614),
    [anon_sym_explicit] = ACTIONS(614),
    [anon_sym_constexpr] = ACTIONS(614),
    [anon_sym_DASH_GT] = ACTIONS(979),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(5256),
  },
  [2126] = {
    [sym_preproc_if_in_field_declaration_list] = STATE(246),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(247),
    [sym_type_definition] = STATE(2126),
    [sym__declaration_specifiers] = STATE(248),
    [sym__declarator] = STATE(249),
    [sym_pointer_declarator] = STATE(249),
    [sym_function_declarator] = STATE(250),
    [sym_array_declarator] = STATE(249),
    [sym_storage_class_specifier] = STATE(257),
    [sym_type_qualifier] = STATE(257),
    [sym__type_specifier] = STATE(251),
    [sym_sized_type_specifier] = STATE(251),
    [sym_enum_specifier] = STATE(251),
    [sym_struct_specifier] = STATE(251),
    [sym_union_specifier] = STATE(251),
    [sym__field_declaration_list_item] = STATE(2126),
    [sym_field_declaration] = STATE(2126),
    [sym_macro_type_specifier] = STATE(251),
    [sym_class_specifier] = STATE(251),
    [sym_dependent_type] = STATE(251),
    [sym_template_declaration] = STATE(2126),
    [sym_inline_method_definition] = STATE(252),
    [sym_constructor_or_destructor_definition] = STATE(252),
    [sym_constructor_or_destructor_declaration] = STATE(253),
    [sym_friend_declaration] = STATE(2126),
    [sym_access_specifier] = STATE(2126),
    [sym_reference_declarator] = STATE(249),
    [sym_template_type] = STATE(254),
    [sym_template_function] = STATE(249),
    [sym_using_declaration] = STATE(2126),
    [sym_alias_declaration] = STATE(2126),
    [sym_destructor_name] = STATE(249),
    [sym_scoped_identifier] = STATE(33),
    [sym_scoped_type_identifier] = STATE(34),
    [sym_scoped_namespace_identifier] = STATE(255),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(2126),
    [aux_sym__declaration_specifiers_repeat1] = STATE(257),
    [aux_sym_sized_type_specifier_repeat1] = STATE(258),
    [anon_sym_LPAREN] = ACTIONS(2118),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(2121),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(2136),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(2124),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(2127),
    [anon_sym_typedef] = ACTIONS(2130),
    [anon_sym_extern] = ACTIONS(2133),
    [anon_sym_STAR] = ACTIONS(2138),
    [anon_sym_static] = ACTIONS(2133),
    [anon_sym_register] = ACTIONS(2133),
    [anon_sym_inline] = ACTIONS(2133),
    [anon_sym_const] = ACTIONS(2141),
    [anon_sym_restrict] = ACTIONS(2141),
    [anon_sym_volatile] = ACTIONS(2141),
    [anon_sym__Atomic] = ACTIONS(2141),
    [anon_sym_mutable] = ACTIONS(2141),
    [anon_sym_explicit] = ACTIONS(2141),
    [anon_sym_constexpr] = ACTIONS(2141),
    [anon_sym_unsigned] = ACTIONS(2144),
    [anon_sym_long] = ACTIONS(2144),
    [anon_sym_short] = ACTIONS(2144),
    [sym_primitive_type] = ACTIONS(2147),
    [anon_sym_enum] = ACTIONS(2150),
    [anon_sym_struct] = ACTIONS(2153),
    [anon_sym_union] = ACTIONS(2156),
    [anon_sym_AMP] = ACTIONS(2159),
    [anon_sym_AMP_AMP] = ACTIONS(2162),
    [anon_sym_TILDE] = ACTIONS(2165),
    [sym_identifier] = ACTIONS(2168),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(2171),
    [anon_sym_public] = ACTIONS(2174),
    [sym_auto] = ACTIONS(2147),
    [anon_sym_typename] = ACTIONS(2177),
    [anon_sym_template] = ACTIONS(2180),
    [anon_sym_friend] = ACTIONS(2183),
    [anon_sym_private] = ACTIONS(2174),
    [anon_sym_protected] = ACTIONS(2174),
    [anon_sym_using] = ACTIONS(2186),
    [anon_sym_COLON_COLON] = ACTIONS(2189),
    [sym_operator_name] = ACTIONS(2192),
  },
  [2127] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(5731),
    [sym_comment] = ACTIONS(49),
  },
  [2128] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(5733),
    [sym_comment] = ACTIONS(49),
  },
  [2129] = {
    [sym_preproc_if_in_field_declaration_list] = STATE(246),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(247),
    [sym_preproc_else_in_field_declaration_list] = STATE(2441),
    [sym_preproc_elif_in_field_declaration_list] = STATE(2442),
    [sym_type_definition] = STATE(1637),
    [sym__declaration_specifiers] = STATE(248),
    [sym__declarator] = STATE(249),
    [sym_pointer_declarator] = STATE(249),
    [sym_function_declarator] = STATE(250),
    [sym_array_declarator] = STATE(249),
    [sym_storage_class_specifier] = STATE(257),
    [sym_type_qualifier] = STATE(257),
    [sym__type_specifier] = STATE(251),
    [sym_sized_type_specifier] = STATE(251),
    [sym_enum_specifier] = STATE(251),
    [sym_struct_specifier] = STATE(251),
    [sym_union_specifier] = STATE(251),
    [sym__field_declaration_list_item] = STATE(1637),
    [sym_field_declaration] = STATE(1637),
    [sym_macro_type_specifier] = STATE(251),
    [sym_class_specifier] = STATE(251),
    [sym_dependent_type] = STATE(251),
    [sym_template_declaration] = STATE(1637),
    [sym_inline_method_definition] = STATE(252),
    [sym_constructor_or_destructor_definition] = STATE(252),
    [sym_constructor_or_destructor_declaration] = STATE(253),
    [sym_friend_declaration] = STATE(1637),
    [sym_access_specifier] = STATE(1637),
    [sym_reference_declarator] = STATE(249),
    [sym_template_type] = STATE(254),
    [sym_template_function] = STATE(249),
    [sym_using_declaration] = STATE(1637),
    [sym_alias_declaration] = STATE(1637),
    [sym_destructor_name] = STATE(249),
    [sym_scoped_identifier] = STATE(33),
    [sym_scoped_type_identifier] = STATE(34),
    [sym_scoped_namespace_identifier] = STATE(255),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(1637),
    [aux_sym__declaration_specifiers_repeat1] = STATE(257),
    [aux_sym_sized_type_specifier_repeat1] = STATE(258),
    [anon_sym_LPAREN] = ACTIONS(11),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(358),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(5735),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(360),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(362),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(2024),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(2026),
    [anon_sym_typedef] = ACTIONS(364),
    [anon_sym_extern] = ACTIONS(27),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_static] = ACTIONS(27),
    [anon_sym_register] = ACTIONS(27),
    [anon_sym_inline] = ACTIONS(27),
    [anon_sym_const] = ACTIONS(29),
    [anon_sym_restrict] = ACTIONS(29),
    [anon_sym_volatile] = ACTIONS(29),
    [anon_sym__Atomic] = ACTIONS(29),
    [anon_sym_mutable] = ACTIONS(29),
    [anon_sym_explicit] = ACTIONS(29),
    [anon_sym_constexpr] = ACTIONS(29),
    [anon_sym_unsigned] = ACTIONS(368),
    [anon_sym_long] = ACTIONS(368),
    [anon_sym_short] = ACTIONS(368),
    [sym_primitive_type] = ACTIONS(370),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(372),
    [anon_sym_union] = ACTIONS(374),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(45),
    [sym_identifier] = ACTIONS(376),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(378),
    [anon_sym_public] = ACTIONS(380),
    [sym_auto] = ACTIONS(370),
    [anon_sym_typename] = ACTIONS(382),
    [anon_sym_template] = ACTIONS(384),
    [anon_sym_friend] = ACTIONS(386),
    [anon_sym_private] = ACTIONS(380),
    [anon_sym_protected] = ACTIONS(380),
    [anon_sym_using] = ACTIONS(388),
    [anon_sym_COLON_COLON] = ACTIONS(390),
    [sym_operator_name] = ACTIONS(392),
  },
  [2130] = {
    [anon_sym_LPAREN] = ACTIONS(5737),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(5739),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(5737),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(5737),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(5737),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(5737),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(5737),
    [anon_sym_typedef] = ACTIONS(5739),
    [anon_sym_extern] = ACTIONS(5739),
    [anon_sym_RBRACE] = ACTIONS(5737),
    [anon_sym_STAR] = ACTIONS(5737),
    [anon_sym_static] = ACTIONS(5739),
    [anon_sym_register] = ACTIONS(5739),
    [anon_sym_inline] = ACTIONS(5739),
    [anon_sym_const] = ACTIONS(5739),
    [anon_sym_restrict] = ACTIONS(5739),
    [anon_sym_volatile] = ACTIONS(5739),
    [anon_sym__Atomic] = ACTIONS(5739),
    [anon_sym_mutable] = ACTIONS(5739),
    [anon_sym_explicit] = ACTIONS(5739),
    [anon_sym_constexpr] = ACTIONS(5739),
    [anon_sym_unsigned] = ACTIONS(5739),
    [anon_sym_long] = ACTIONS(5739),
    [anon_sym_short] = ACTIONS(5739),
    [sym_primitive_type] = ACTIONS(5739),
    [anon_sym_enum] = ACTIONS(5739),
    [anon_sym_struct] = ACTIONS(5739),
    [anon_sym_union] = ACTIONS(5739),
    [anon_sym_AMP] = ACTIONS(5739),
    [anon_sym_AMP_AMP] = ACTIONS(5737),
    [anon_sym_TILDE] = ACTIONS(5737),
    [sym_identifier] = ACTIONS(5739),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(5739),
    [anon_sym_public] = ACTIONS(5739),
    [sym_auto] = ACTIONS(5739),
    [anon_sym_typename] = ACTIONS(5739),
    [anon_sym_template] = ACTIONS(5739),
    [anon_sym_friend] = ACTIONS(5739),
    [anon_sym_private] = ACTIONS(5739),
    [anon_sym_protected] = ACTIONS(5739),
    [anon_sym_using] = ACTIONS(5739),
    [anon_sym_COLON_COLON] = ACTIONS(5737),
    [sym_operator_name] = ACTIONS(5737),
  },
  [2131] = {
    [anon_sym_LPAREN] = ACTIONS(5741),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(5743),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(5741),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(5741),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(5741),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(5741),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(5741),
    [anon_sym_typedef] = ACTIONS(5743),
    [anon_sym_extern] = ACTIONS(5743),
    [anon_sym_RBRACE] = ACTIONS(5741),
    [anon_sym_STAR] = ACTIONS(5741),
    [anon_sym_static] = ACTIONS(5743),
    [anon_sym_register] = ACTIONS(5743),
    [anon_sym_inline] = ACTIONS(5743),
    [anon_sym_const] = ACTIONS(5743),
    [anon_sym_restrict] = ACTIONS(5743),
    [anon_sym_volatile] = ACTIONS(5743),
    [anon_sym__Atomic] = ACTIONS(5743),
    [anon_sym_mutable] = ACTIONS(5743),
    [anon_sym_explicit] = ACTIONS(5743),
    [anon_sym_constexpr] = ACTIONS(5743),
    [anon_sym_unsigned] = ACTIONS(5743),
    [anon_sym_long] = ACTIONS(5743),
    [anon_sym_short] = ACTIONS(5743),
    [sym_primitive_type] = ACTIONS(5743),
    [anon_sym_enum] = ACTIONS(5743),
    [anon_sym_struct] = ACTIONS(5743),
    [anon_sym_union] = ACTIONS(5743),
    [anon_sym_AMP] = ACTIONS(5743),
    [anon_sym_AMP_AMP] = ACTIONS(5741),
    [anon_sym_TILDE] = ACTIONS(5741),
    [sym_identifier] = ACTIONS(5743),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(5743),
    [anon_sym_public] = ACTIONS(5743),
    [sym_auto] = ACTIONS(5743),
    [anon_sym_typename] = ACTIONS(5743),
    [anon_sym_template] = ACTIONS(5743),
    [anon_sym_friend] = ACTIONS(5743),
    [anon_sym_private] = ACTIONS(5743),
    [anon_sym_protected] = ACTIONS(5743),
    [anon_sym_using] = ACTIONS(5743),
    [anon_sym_COLON_COLON] = ACTIONS(5741),
    [sym_operator_name] = ACTIONS(5741),
  },
  [2132] = {
    [anon_sym_LPAREN] = ACTIONS(5745),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(5747),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(5745),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(5745),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(5745),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(5745),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(5745),
    [anon_sym_typedef] = ACTIONS(5747),
    [anon_sym_extern] = ACTIONS(5747),
    [anon_sym_RBRACE] = ACTIONS(5745),
    [anon_sym_STAR] = ACTIONS(5745),
    [anon_sym_static] = ACTIONS(5747),
    [anon_sym_register] = ACTIONS(5747),
    [anon_sym_inline] = ACTIONS(5747),
    [anon_sym_const] = ACTIONS(5747),
    [anon_sym_restrict] = ACTIONS(5747),
    [anon_sym_volatile] = ACTIONS(5747),
    [anon_sym__Atomic] = ACTIONS(5747),
    [anon_sym_mutable] = ACTIONS(5747),
    [anon_sym_explicit] = ACTIONS(5747),
    [anon_sym_constexpr] = ACTIONS(5747),
    [anon_sym_unsigned] = ACTIONS(5747),
    [anon_sym_long] = ACTIONS(5747),
    [anon_sym_short] = ACTIONS(5747),
    [sym_primitive_type] = ACTIONS(5747),
    [anon_sym_enum] = ACTIONS(5747),
    [anon_sym_struct] = ACTIONS(5747),
    [anon_sym_union] = ACTIONS(5747),
    [anon_sym_AMP] = ACTIONS(5747),
    [anon_sym_AMP_AMP] = ACTIONS(5745),
    [anon_sym_TILDE] = ACTIONS(5745),
    [sym_identifier] = ACTIONS(5747),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(5747),
    [anon_sym_public] = ACTIONS(5747),
    [sym_auto] = ACTIONS(5747),
    [anon_sym_typename] = ACTIONS(5747),
    [anon_sym_template] = ACTIONS(5747),
    [anon_sym_friend] = ACTIONS(5747),
    [anon_sym_private] = ACTIONS(5747),
    [anon_sym_protected] = ACTIONS(5747),
    [anon_sym_using] = ACTIONS(5747),
    [anon_sym_COLON_COLON] = ACTIONS(5745),
    [sym_operator_name] = ACTIONS(5745),
  },
  [2133] = {
    [anon_sym_LPAREN] = ACTIONS(5749),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(5751),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(5749),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(5749),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(5749),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(5749),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(5749),
    [anon_sym_typedef] = ACTIONS(5751),
    [anon_sym_extern] = ACTIONS(5751),
    [anon_sym_RBRACE] = ACTIONS(5749),
    [anon_sym_STAR] = ACTIONS(5749),
    [anon_sym_static] = ACTIONS(5751),
    [anon_sym_register] = ACTIONS(5751),
    [anon_sym_inline] = ACTIONS(5751),
    [anon_sym_const] = ACTIONS(5751),
    [anon_sym_restrict] = ACTIONS(5751),
    [anon_sym_volatile] = ACTIONS(5751),
    [anon_sym__Atomic] = ACTIONS(5751),
    [anon_sym_mutable] = ACTIONS(5751),
    [anon_sym_explicit] = ACTIONS(5751),
    [anon_sym_constexpr] = ACTIONS(5751),
    [anon_sym_unsigned] = ACTIONS(5751),
    [anon_sym_long] = ACTIONS(5751),
    [anon_sym_short] = ACTIONS(5751),
    [sym_primitive_type] = ACTIONS(5751),
    [anon_sym_enum] = ACTIONS(5751),
    [anon_sym_struct] = ACTIONS(5751),
    [anon_sym_union] = ACTIONS(5751),
    [anon_sym_AMP] = ACTIONS(5751),
    [anon_sym_AMP_AMP] = ACTIONS(5749),
    [anon_sym_TILDE] = ACTIONS(5749),
    [sym_identifier] = ACTIONS(5751),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(5751),
    [anon_sym_public] = ACTIONS(5751),
    [sym_auto] = ACTIONS(5751),
    [anon_sym_typename] = ACTIONS(5751),
    [anon_sym_template] = ACTIONS(5751),
    [anon_sym_friend] = ACTIONS(5751),
    [anon_sym_private] = ACTIONS(5751),
    [anon_sym_protected] = ACTIONS(5751),
    [anon_sym_using] = ACTIONS(5751),
    [anon_sym_COLON_COLON] = ACTIONS(5749),
    [sym_operator_name] = ACTIONS(5749),
  },
  [2134] = {
    [anon_sym_LPAREN] = ACTIONS(5753),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(5755),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(5753),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(5753),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(5753),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(5753),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(5753),
    [anon_sym_typedef] = ACTIONS(5755),
    [anon_sym_extern] = ACTIONS(5755),
    [anon_sym_RBRACE] = ACTIONS(5753),
    [anon_sym_STAR] = ACTIONS(5753),
    [anon_sym_static] = ACTIONS(5755),
    [anon_sym_register] = ACTIONS(5755),
    [anon_sym_inline] = ACTIONS(5755),
    [anon_sym_const] = ACTIONS(5755),
    [anon_sym_restrict] = ACTIONS(5755),
    [anon_sym_volatile] = ACTIONS(5755),
    [anon_sym__Atomic] = ACTIONS(5755),
    [anon_sym_mutable] = ACTIONS(5755),
    [anon_sym_explicit] = ACTIONS(5755),
    [anon_sym_constexpr] = ACTIONS(5755),
    [anon_sym_unsigned] = ACTIONS(5755),
    [anon_sym_long] = ACTIONS(5755),
    [anon_sym_short] = ACTIONS(5755),
    [sym_primitive_type] = ACTIONS(5755),
    [anon_sym_enum] = ACTIONS(5755),
    [anon_sym_struct] = ACTIONS(5755),
    [anon_sym_union] = ACTIONS(5755),
    [anon_sym_AMP] = ACTIONS(5755),
    [anon_sym_AMP_AMP] = ACTIONS(5753),
    [anon_sym_TILDE] = ACTIONS(5753),
    [sym_identifier] = ACTIONS(5755),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(5755),
    [anon_sym_public] = ACTIONS(5755),
    [sym_auto] = ACTIONS(5755),
    [anon_sym_typename] = ACTIONS(5755),
    [anon_sym_template] = ACTIONS(5755),
    [anon_sym_friend] = ACTIONS(5755),
    [anon_sym_private] = ACTIONS(5755),
    [anon_sym_protected] = ACTIONS(5755),
    [anon_sym_using] = ACTIONS(5755),
    [anon_sym_COLON_COLON] = ACTIONS(5753),
    [sym_operator_name] = ACTIONS(5753),
  },
  [2135] = {
    [anon_sym_LPAREN] = ACTIONS(5757),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(5759),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(5757),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(5757),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(5757),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(5757),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(5757),
    [anon_sym_typedef] = ACTIONS(5759),
    [anon_sym_extern] = ACTIONS(5759),
    [anon_sym_RBRACE] = ACTIONS(5757),
    [anon_sym_STAR] = ACTIONS(5757),
    [anon_sym_static] = ACTIONS(5759),
    [anon_sym_register] = ACTIONS(5759),
    [anon_sym_inline] = ACTIONS(5759),
    [anon_sym_const] = ACTIONS(5759),
    [anon_sym_restrict] = ACTIONS(5759),
    [anon_sym_volatile] = ACTIONS(5759),
    [anon_sym__Atomic] = ACTIONS(5759),
    [anon_sym_mutable] = ACTIONS(5759),
    [anon_sym_explicit] = ACTIONS(5759),
    [anon_sym_constexpr] = ACTIONS(5759),
    [anon_sym_unsigned] = ACTIONS(5759),
    [anon_sym_long] = ACTIONS(5759),
    [anon_sym_short] = ACTIONS(5759),
    [sym_primitive_type] = ACTIONS(5759),
    [anon_sym_enum] = ACTIONS(5759),
    [anon_sym_struct] = ACTIONS(5759),
    [anon_sym_union] = ACTIONS(5759),
    [anon_sym_AMP] = ACTIONS(5759),
    [anon_sym_AMP_AMP] = ACTIONS(5757),
    [anon_sym_TILDE] = ACTIONS(5757),
    [sym_identifier] = ACTIONS(5759),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(5759),
    [anon_sym_public] = ACTIONS(5759),
    [sym_auto] = ACTIONS(5759),
    [anon_sym_typename] = ACTIONS(5759),
    [anon_sym_template] = ACTIONS(5759),
    [anon_sym_friend] = ACTIONS(5759),
    [anon_sym_private] = ACTIONS(5759),
    [anon_sym_protected] = ACTIONS(5759),
    [anon_sym_using] = ACTIONS(5759),
    [anon_sym_COLON_COLON] = ACTIONS(5757),
    [sym_operator_name] = ACTIONS(5757),
  },
  [2136] = {
    [anon_sym_LPAREN] = ACTIONS(3519),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3521),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3519),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3519),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3519),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(3519),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(3519),
    [anon_sym_typedef] = ACTIONS(3521),
    [anon_sym_extern] = ACTIONS(3521),
    [anon_sym_RBRACE] = ACTIONS(3519),
    [anon_sym_STAR] = ACTIONS(3519),
    [anon_sym_static] = ACTIONS(3521),
    [anon_sym_register] = ACTIONS(3521),
    [anon_sym_inline] = ACTIONS(3521),
    [anon_sym_const] = ACTIONS(3521),
    [anon_sym_restrict] = ACTIONS(3521),
    [anon_sym_volatile] = ACTIONS(3521),
    [anon_sym__Atomic] = ACTIONS(3521),
    [anon_sym_mutable] = ACTIONS(3521),
    [anon_sym_explicit] = ACTIONS(3521),
    [anon_sym_constexpr] = ACTIONS(3521),
    [anon_sym_unsigned] = ACTIONS(3521),
    [anon_sym_long] = ACTIONS(3521),
    [anon_sym_short] = ACTIONS(3521),
    [sym_primitive_type] = ACTIONS(3521),
    [anon_sym_enum] = ACTIONS(3521),
    [anon_sym_struct] = ACTIONS(3521),
    [anon_sym_union] = ACTIONS(3521),
    [anon_sym_AMP] = ACTIONS(3521),
    [anon_sym_AMP_AMP] = ACTIONS(3519),
    [anon_sym_TILDE] = ACTIONS(3519),
    [sym_identifier] = ACTIONS(3521),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(3521),
    [anon_sym_public] = ACTIONS(3521),
    [sym_auto] = ACTIONS(3521),
    [anon_sym_typename] = ACTIONS(3521),
    [anon_sym_template] = ACTIONS(3521),
    [anon_sym_friend] = ACTIONS(3521),
    [anon_sym_private] = ACTIONS(3521),
    [anon_sym_protected] = ACTIONS(3521),
    [anon_sym_using] = ACTIONS(3521),
    [anon_sym_COLON_COLON] = ACTIONS(3519),
    [sym_operator_name] = ACTIONS(3519),
  },
  [2137] = {
    [anon_sym_LPAREN] = ACTIONS(1622),
    [anon_sym_COMMA] = ACTIONS(2400),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1624),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(1622),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1622),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1622),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(1622),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(1622),
    [anon_sym_SEMI] = ACTIONS(2400),
    [anon_sym_typedef] = ACTIONS(1624),
    [anon_sym_extern] = ACTIONS(1624),
    [anon_sym_RBRACE] = ACTIONS(1622),
    [anon_sym_STAR] = ACTIONS(1622),
    [anon_sym_static] = ACTIONS(1624),
    [anon_sym_register] = ACTIONS(1624),
    [anon_sym_inline] = ACTIONS(1624),
    [anon_sym_const] = ACTIONS(1624),
    [anon_sym_restrict] = ACTIONS(1624),
    [anon_sym_volatile] = ACTIONS(1624),
    [anon_sym__Atomic] = ACTIONS(1624),
    [anon_sym_mutable] = ACTIONS(1624),
    [anon_sym_explicit] = ACTIONS(1624),
    [anon_sym_constexpr] = ACTIONS(1624),
    [anon_sym_unsigned] = ACTIONS(1624),
    [anon_sym_long] = ACTIONS(1624),
    [anon_sym_short] = ACTIONS(1624),
    [sym_primitive_type] = ACTIONS(1624),
    [anon_sym_enum] = ACTIONS(1624),
    [anon_sym_struct] = ACTIONS(1624),
    [anon_sym_union] = ACTIONS(1624),
    [anon_sym_AMP] = ACTIONS(1624),
    [anon_sym_AMP_AMP] = ACTIONS(1622),
    [anon_sym_TILDE] = ACTIONS(1622),
    [sym_identifier] = ACTIONS(1624),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(1624),
    [anon_sym_public] = ACTIONS(1624),
    [sym_auto] = ACTIONS(1624),
    [anon_sym_typename] = ACTIONS(1624),
    [anon_sym_template] = ACTIONS(1624),
    [anon_sym_friend] = ACTIONS(1624),
    [anon_sym_private] = ACTIONS(1624),
    [anon_sym_protected] = ACTIONS(1624),
    [anon_sym_using] = ACTIONS(1624),
    [anon_sym_COLON_COLON] = ACTIONS(1622),
    [sym_operator_name] = ACTIONS(1622),
  },
  [2138] = {
    [anon_sym_LPAREN] = ACTIONS(2478),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(2480),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(2478),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(2478),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(2478),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(2478),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(2478),
    [anon_sym_typedef] = ACTIONS(2480),
    [anon_sym_extern] = ACTIONS(2480),
    [anon_sym_RBRACE] = ACTIONS(2478),
    [anon_sym_STAR] = ACTIONS(2478),
    [anon_sym_static] = ACTIONS(2480),
    [anon_sym_register] = ACTIONS(2480),
    [anon_sym_inline] = ACTIONS(2480),
    [anon_sym_const] = ACTIONS(2480),
    [anon_sym_restrict] = ACTIONS(2480),
    [anon_sym_volatile] = ACTIONS(2480),
    [anon_sym__Atomic] = ACTIONS(2480),
    [anon_sym_mutable] = ACTIONS(2480),
    [anon_sym_explicit] = ACTIONS(2480),
    [anon_sym_constexpr] = ACTIONS(2480),
    [anon_sym_unsigned] = ACTIONS(2480),
    [anon_sym_long] = ACTIONS(2480),
    [anon_sym_short] = ACTIONS(2480),
    [sym_primitive_type] = ACTIONS(2480),
    [anon_sym_enum] = ACTIONS(2480),
    [anon_sym_struct] = ACTIONS(2480),
    [anon_sym_union] = ACTIONS(2480),
    [anon_sym_AMP] = ACTIONS(2480),
    [anon_sym_AMP_AMP] = ACTIONS(2478),
    [anon_sym_TILDE] = ACTIONS(2478),
    [sym_identifier] = ACTIONS(2480),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(2480),
    [anon_sym_public] = ACTIONS(2480),
    [sym_auto] = ACTIONS(2480),
    [anon_sym_typename] = ACTIONS(2480),
    [anon_sym_template] = ACTIONS(2480),
    [anon_sym_friend] = ACTIONS(2480),
    [anon_sym_private] = ACTIONS(2480),
    [anon_sym_protected] = ACTIONS(2480),
    [anon_sym_using] = ACTIONS(2480),
    [anon_sym_COLON_COLON] = ACTIONS(2478),
    [sym_operator_name] = ACTIONS(2478),
  },
  [2139] = {
    [anon_sym_LPAREN] = ACTIONS(3862),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3864),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3862),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3862),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3862),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(3862),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(3862),
    [anon_sym_typedef] = ACTIONS(3864),
    [anon_sym_extern] = ACTIONS(3864),
    [anon_sym_RBRACE] = ACTIONS(3862),
    [anon_sym_STAR] = ACTIONS(3862),
    [anon_sym_static] = ACTIONS(3864),
    [anon_sym_register] = ACTIONS(3864),
    [anon_sym_inline] = ACTIONS(3864),
    [anon_sym_const] = ACTIONS(3864),
    [anon_sym_restrict] = ACTIONS(3864),
    [anon_sym_volatile] = ACTIONS(3864),
    [anon_sym__Atomic] = ACTIONS(3864),
    [anon_sym_mutable] = ACTIONS(3864),
    [anon_sym_explicit] = ACTIONS(3864),
    [anon_sym_constexpr] = ACTIONS(3864),
    [anon_sym_unsigned] = ACTIONS(3864),
    [anon_sym_long] = ACTIONS(3864),
    [anon_sym_short] = ACTIONS(3864),
    [sym_primitive_type] = ACTIONS(3864),
    [anon_sym_enum] = ACTIONS(3864),
    [anon_sym_struct] = ACTIONS(3864),
    [anon_sym_union] = ACTIONS(3864),
    [anon_sym_AMP] = ACTIONS(3864),
    [anon_sym_AMP_AMP] = ACTIONS(3862),
    [anon_sym_TILDE] = ACTIONS(3862),
    [sym_identifier] = ACTIONS(3864),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(3864),
    [anon_sym_public] = ACTIONS(3864),
    [sym_auto] = ACTIONS(3864),
    [anon_sym_typename] = ACTIONS(3864),
    [anon_sym_template] = ACTIONS(3864),
    [anon_sym_friend] = ACTIONS(3864),
    [anon_sym_private] = ACTIONS(3864),
    [anon_sym_protected] = ACTIONS(3864),
    [anon_sym_using] = ACTIONS(3864),
    [anon_sym_COLON_COLON] = ACTIONS(3862),
    [sym_operator_name] = ACTIONS(3862),
  },
  [2140] = {
    [sym_type_qualifier] = STATE(935),
    [sym_trailing_return_type] = STATE(935),
    [aux_sym_function_declarator_repeat1] = STATE(935),
    [anon_sym_LPAREN] = ACTIONS(4933),
    [anon_sym_RPAREN] = ACTIONS(4933),
    [anon_sym_LBRACK] = ACTIONS(4933),
    [anon_sym_const] = ACTIONS(612),
    [anon_sym_restrict] = ACTIONS(614),
    [anon_sym_volatile] = ACTIONS(614),
    [anon_sym__Atomic] = ACTIONS(614),
    [anon_sym_mutable] = ACTIONS(614),
    [anon_sym_explicit] = ACTIONS(614),
    [anon_sym_constexpr] = ACTIONS(614),
    [anon_sym_DASH_GT] = ACTIONS(845),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(1843),
  },
  [2141] = {
    [sym_parameter_list] = STATE(2143),
    [anon_sym_LPAREN] = ACTIONS(206),
    [anon_sym_COMMA] = ACTIONS(3604),
    [anon_sym_SEMI] = ACTIONS(3604),
    [anon_sym_LBRACK] = ACTIONS(2086),
    [anon_sym_COLON] = ACTIONS(3604),
    [sym_comment] = ACTIONS(49),
  },
  [2142] = {
    [sym_parameter_list] = STATE(2143),
    [anon_sym_LPAREN] = ACTIONS(206),
    [anon_sym_COMMA] = ACTIONS(3608),
    [anon_sym_SEMI] = ACTIONS(3608),
    [anon_sym_LBRACK] = ACTIONS(2086),
    [anon_sym_COLON] = ACTIONS(3608),
    [sym_comment] = ACTIONS(49),
  },
  [2143] = {
    [sym_type_qualifier] = STATE(2444),
    [sym_trailing_return_type] = STATE(2444),
    [aux_sym_function_declarator_repeat1] = STATE(2444),
    [anon_sym_LPAREN] = ACTIONS(3645),
    [anon_sym_COMMA] = ACTIONS(3645),
    [anon_sym_SEMI] = ACTIONS(3645),
    [anon_sym_LBRACK] = ACTIONS(3645),
    [anon_sym_const] = ACTIONS(612),
    [anon_sym_restrict] = ACTIONS(614),
    [anon_sym_volatile] = ACTIONS(614),
    [anon_sym__Atomic] = ACTIONS(614),
    [anon_sym_mutable] = ACTIONS(614),
    [anon_sym_explicit] = ACTIONS(614),
    [anon_sym_constexpr] = ACTIONS(614),
    [anon_sym_COLON] = ACTIONS(3645),
    [anon_sym_DASH_GT] = ACTIONS(5761),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(5763),
  },
  [2144] = {
    [anon_sym_LPAREN] = ACTIONS(5765),
    [anon_sym_COMMA] = ACTIONS(5765),
    [anon_sym_RPAREN] = ACTIONS(5765),
    [anon_sym_SEMI] = ACTIONS(5765),
    [anon_sym_LBRACE] = ACTIONS(5765),
    [anon_sym_LBRACK] = ACTIONS(5765),
    [anon_sym_COLON] = ACTIONS(5765),
    [sym_comment] = ACTIONS(49),
  },
  [2145] = {
    [sym_argument_list] = STATE(802),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_STAR] = ACTIONS(1522),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_RBRACK] = ACTIONS(5767),
    [anon_sym_EQ] = ACTIONS(1526),
    [anon_sym_QMARK] = ACTIONS(1528),
    [anon_sym_STAR_EQ] = ACTIONS(1530),
    [anon_sym_SLASH_EQ] = ACTIONS(1530),
    [anon_sym_PERCENT_EQ] = ACTIONS(1530),
    [anon_sym_PLUS_EQ] = ACTIONS(1530),
    [anon_sym_DASH_EQ] = ACTIONS(1530),
    [anon_sym_LT_LT_EQ] = ACTIONS(1530),
    [anon_sym_GT_GT_EQ] = ACTIONS(1530),
    [anon_sym_AMP_EQ] = ACTIONS(1530),
    [anon_sym_CARET_EQ] = ACTIONS(1530),
    [anon_sym_PIPE_EQ] = ACTIONS(1530),
    [anon_sym_AMP] = ACTIONS(1532),
    [anon_sym_PIPE_PIPE] = ACTIONS(1534),
    [anon_sym_AMP_AMP] = ACTIONS(1536),
    [anon_sym_PIPE] = ACTIONS(1538),
    [anon_sym_CARET] = ACTIONS(1540),
    [anon_sym_EQ_EQ] = ACTIONS(1542),
    [anon_sym_BANG_EQ] = ACTIONS(1542),
    [anon_sym_LT] = ACTIONS(1544),
    [anon_sym_GT] = ACTIONS(1544),
    [anon_sym_LT_EQ] = ACTIONS(1546),
    [anon_sym_GT_EQ] = ACTIONS(1546),
    [anon_sym_LT_LT] = ACTIONS(1548),
    [anon_sym_GT_GT] = ACTIONS(1548),
    [anon_sym_PLUS] = ACTIONS(1550),
    [anon_sym_DASH] = ACTIONS(1550),
    [anon_sym_SLASH] = ACTIONS(1522),
    [anon_sym_PERCENT] = ACTIONS(1522),
    [anon_sym_DASH_DASH] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(1554),
    [anon_sym_DASH_GT] = ACTIONS(1554),
    [sym_comment] = ACTIONS(49),
  },
  [2146] = {
    [anon_sym_LPAREN] = ACTIONS(5769),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(5771),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(5769),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(5769),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(5769),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(5769),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(5769),
    [anon_sym_typedef] = ACTIONS(5771),
    [anon_sym_extern] = ACTIONS(5771),
    [anon_sym_RBRACE] = ACTIONS(5769),
    [anon_sym_STAR] = ACTIONS(5769),
    [anon_sym_static] = ACTIONS(5771),
    [anon_sym_register] = ACTIONS(5771),
    [anon_sym_inline] = ACTIONS(5771),
    [anon_sym_const] = ACTIONS(5771),
    [anon_sym_restrict] = ACTIONS(5771),
    [anon_sym_volatile] = ACTIONS(5771),
    [anon_sym__Atomic] = ACTIONS(5771),
    [anon_sym_mutable] = ACTIONS(5771),
    [anon_sym_explicit] = ACTIONS(5771),
    [anon_sym_constexpr] = ACTIONS(5771),
    [anon_sym_unsigned] = ACTIONS(5771),
    [anon_sym_long] = ACTIONS(5771),
    [anon_sym_short] = ACTIONS(5771),
    [sym_primitive_type] = ACTIONS(5771),
    [anon_sym_enum] = ACTIONS(5771),
    [anon_sym_struct] = ACTIONS(5771),
    [anon_sym_union] = ACTIONS(5771),
    [anon_sym_AMP] = ACTIONS(5771),
    [anon_sym_AMP_AMP] = ACTIONS(5769),
    [anon_sym_TILDE] = ACTIONS(5769),
    [sym_identifier] = ACTIONS(5771),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(5771),
    [anon_sym_public] = ACTIONS(5771),
    [sym_auto] = ACTIONS(5771),
    [anon_sym_typename] = ACTIONS(5771),
    [anon_sym_template] = ACTIONS(5771),
    [anon_sym_friend] = ACTIONS(5771),
    [anon_sym_private] = ACTIONS(5771),
    [anon_sym_protected] = ACTIONS(5771),
    [anon_sym_using] = ACTIONS(5771),
    [anon_sym_COLON_COLON] = ACTIONS(5769),
    [sym_operator_name] = ACTIONS(5769),
  },
  [2147] = {
    [sym__type_specifier] = STATE(1375),
    [sym_sized_type_specifier] = STATE(1375),
    [sym_enum_specifier] = STATE(1375),
    [sym_struct_specifier] = STATE(1375),
    [sym_union_specifier] = STATE(1375),
    [sym_macro_type_specifier] = STATE(1375),
    [sym_class_specifier] = STATE(1375),
    [sym_dependent_type] = STATE(1375),
    [sym_template_type] = STATE(825),
    [sym_scoped_type_identifier] = STATE(826),
    [sym_scoped_namespace_identifier] = STATE(827),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2149),
    [anon_sym_unsigned] = ACTIONS(4927),
    [anon_sym_long] = ACTIONS(4927),
    [anon_sym_short] = ACTIONS(4927),
    [sym_primitive_type] = ACTIONS(2837),
    [anon_sym_enum] = ACTIONS(1582),
    [anon_sym_struct] = ACTIONS(1584),
    [anon_sym_union] = ACTIONS(1586),
    [sym_identifier] = ACTIONS(1588),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(1590),
    [sym_auto] = ACTIONS(2837),
    [anon_sym_typename] = ACTIONS(4931),
    [anon_sym_COLON_COLON] = ACTIONS(1594),
  },
  [2148] = {
    [sym__abstract_declarator] = STATE(2448),
    [sym_abstract_pointer_declarator] = STATE(2448),
    [sym_abstract_function_declarator] = STATE(2448),
    [sym_abstract_array_declarator] = STATE(2448),
    [sym_parameter_list] = STATE(2449),
    [sym_abstract_reference_declarator] = STATE(2448),
    [anon_sym_LPAREN] = ACTIONS(1115),
    [anon_sym_COMMA] = ACTIONS(2841),
    [anon_sym_SEMI] = ACTIONS(2841),
    [anon_sym_LBRACE] = ACTIONS(2841),
    [anon_sym_STAR] = ACTIONS(5773),
    [anon_sym_LBRACK] = ACTIONS(1121),
    [anon_sym_const] = ACTIONS(2845),
    [anon_sym_restrict] = ACTIONS(2841),
    [anon_sym_volatile] = ACTIONS(2841),
    [anon_sym__Atomic] = ACTIONS(2841),
    [anon_sym_mutable] = ACTIONS(2841),
    [anon_sym_explicit] = ACTIONS(2841),
    [anon_sym_constexpr] = ACTIONS(2841),
    [anon_sym_COLON] = ACTIONS(2841),
    [anon_sym_AMP] = ACTIONS(5775),
    [anon_sym_AMP_AMP] = ACTIONS(5777),
    [anon_sym_DASH_GT] = ACTIONS(2841),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(2841),
  },
  [2149] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2450),
    [anon_sym_LPAREN] = ACTIONS(238),
    [anon_sym_COMMA] = ACTIONS(238),
    [anon_sym_SEMI] = ACTIONS(238),
    [anon_sym_LBRACE] = ACTIONS(238),
    [anon_sym_STAR] = ACTIONS(238),
    [anon_sym_LBRACK] = ACTIONS(238),
    [anon_sym_const] = ACTIONS(240),
    [anon_sym_restrict] = ACTIONS(240),
    [anon_sym_volatile] = ACTIONS(240),
    [anon_sym__Atomic] = ACTIONS(240),
    [anon_sym_mutable] = ACTIONS(240),
    [anon_sym_explicit] = ACTIONS(240),
    [anon_sym_constexpr] = ACTIONS(240),
    [anon_sym_unsigned] = ACTIONS(5779),
    [anon_sym_long] = ACTIONS(5779),
    [anon_sym_short] = ACTIONS(5779),
    [sym_primitive_type] = ACTIONS(2855),
    [anon_sym_COLON] = ACTIONS(238),
    [anon_sym_AMP] = ACTIONS(240),
    [anon_sym_AMP_AMP] = ACTIONS(238),
    [anon_sym_DASH_GT] = ACTIONS(238),
    [sym_identifier] = ACTIONS(2857),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(240),
  },
  [2150] = {
    [sym_type_qualifier] = STATE(2150),
    [sym_trailing_return_type] = STATE(2150),
    [aux_sym_function_declarator_repeat1] = STATE(2150),
    [anon_sym_LPAREN] = ACTIONS(2859),
    [anon_sym_COMMA] = ACTIONS(2859),
    [anon_sym_SEMI] = ACTIONS(2859),
    [anon_sym_LBRACE] = ACTIONS(2859),
    [anon_sym_LBRACK] = ACTIONS(2859),
    [anon_sym_const] = ACTIONS(2861),
    [anon_sym_restrict] = ACTIONS(2864),
    [anon_sym_volatile] = ACTIONS(2864),
    [anon_sym__Atomic] = ACTIONS(2864),
    [anon_sym_mutable] = ACTIONS(2864),
    [anon_sym_explicit] = ACTIONS(2864),
    [anon_sym_constexpr] = ACTIONS(2864),
    [anon_sym_COLON] = ACTIONS(2859),
    [anon_sym_DASH_GT] = ACTIONS(5781),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(5784),
  },
  [2151] = {
    [sym_argument_list] = STATE(802),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_SEMI] = ACTIONS(5787),
    [anon_sym_STAR] = ACTIONS(2553),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_EQ] = ACTIONS(2555),
    [anon_sym_QMARK] = ACTIONS(2557),
    [anon_sym_STAR_EQ] = ACTIONS(2559),
    [anon_sym_SLASH_EQ] = ACTIONS(2559),
    [anon_sym_PERCENT_EQ] = ACTIONS(2559),
    [anon_sym_PLUS_EQ] = ACTIONS(2559),
    [anon_sym_DASH_EQ] = ACTIONS(2559),
    [anon_sym_LT_LT_EQ] = ACTIONS(2559),
    [anon_sym_GT_GT_EQ] = ACTIONS(2559),
    [anon_sym_AMP_EQ] = ACTIONS(2559),
    [anon_sym_CARET_EQ] = ACTIONS(2559),
    [anon_sym_PIPE_EQ] = ACTIONS(2559),
    [anon_sym_AMP] = ACTIONS(2561),
    [anon_sym_PIPE_PIPE] = ACTIONS(2563),
    [anon_sym_AMP_AMP] = ACTIONS(2565),
    [anon_sym_PIPE] = ACTIONS(2567),
    [anon_sym_CARET] = ACTIONS(2569),
    [anon_sym_EQ_EQ] = ACTIONS(2571),
    [anon_sym_BANG_EQ] = ACTIONS(2571),
    [anon_sym_LT] = ACTIONS(2573),
    [anon_sym_GT] = ACTIONS(2573),
    [anon_sym_LT_EQ] = ACTIONS(2575),
    [anon_sym_GT_EQ] = ACTIONS(2575),
    [anon_sym_LT_LT] = ACTIONS(2577),
    [anon_sym_GT_GT] = ACTIONS(2577),
    [anon_sym_PLUS] = ACTIONS(2579),
    [anon_sym_DASH] = ACTIONS(2579),
    [anon_sym_SLASH] = ACTIONS(2553),
    [anon_sym_PERCENT] = ACTIONS(2553),
    [anon_sym_DASH_DASH] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(1554),
    [anon_sym_DASH_GT] = ACTIONS(1554),
    [sym_comment] = ACTIONS(49),
  },
  [2152] = {
    [anon_sym_LPAREN] = ACTIONS(2290),
    [anon_sym_COMMA] = ACTIONS(2290),
    [anon_sym_SEMI] = ACTIONS(2290),
    [anon_sym_LBRACE] = ACTIONS(2290),
    [anon_sym_STAR] = ACTIONS(2292),
    [anon_sym_LBRACK] = ACTIONS(2290),
    [anon_sym_EQ] = ACTIONS(2292),
    [anon_sym_COLON] = ACTIONS(2290),
    [anon_sym_QMARK] = ACTIONS(2290),
    [anon_sym_STAR_EQ] = ACTIONS(2290),
    [anon_sym_SLASH_EQ] = ACTIONS(2290),
    [anon_sym_PERCENT_EQ] = ACTIONS(2290),
    [anon_sym_PLUS_EQ] = ACTIONS(2290),
    [anon_sym_DASH_EQ] = ACTIONS(2290),
    [anon_sym_LT_LT_EQ] = ACTIONS(2290),
    [anon_sym_GT_GT_EQ] = ACTIONS(2290),
    [anon_sym_AMP_EQ] = ACTIONS(2290),
    [anon_sym_CARET_EQ] = ACTIONS(2290),
    [anon_sym_PIPE_EQ] = ACTIONS(2290),
    [anon_sym_AMP] = ACTIONS(2292),
    [anon_sym_PIPE_PIPE] = ACTIONS(2290),
    [anon_sym_AMP_AMP] = ACTIONS(2290),
    [anon_sym_PIPE] = ACTIONS(2292),
    [anon_sym_CARET] = ACTIONS(2292),
    [anon_sym_EQ_EQ] = ACTIONS(2290),
    [anon_sym_BANG_EQ] = ACTIONS(2290),
    [anon_sym_LT] = ACTIONS(2292),
    [anon_sym_GT] = ACTIONS(2292),
    [anon_sym_LT_EQ] = ACTIONS(2290),
    [anon_sym_GT_EQ] = ACTIONS(2290),
    [anon_sym_LT_LT] = ACTIONS(2292),
    [anon_sym_GT_GT] = ACTIONS(2292),
    [anon_sym_PLUS] = ACTIONS(2292),
    [anon_sym_DASH] = ACTIONS(2292),
    [anon_sym_SLASH] = ACTIONS(2292),
    [anon_sym_PERCENT] = ACTIONS(2292),
    [anon_sym_DASH_DASH] = ACTIONS(2290),
    [anon_sym_PLUS_PLUS] = ACTIONS(2290),
    [anon_sym_DOT] = ACTIONS(2290),
    [anon_sym_DASH_GT] = ACTIONS(2290),
    [sym_comment] = ACTIONS(49),
  },
  [2153] = {
    [aux_sym_template_argument_list_repeat1] = STATE(1133),
    [anon_sym_COMMA] = ACTIONS(1127),
    [anon_sym_GT] = ACTIONS(5789),
    [sym_comment] = ACTIONS(49),
  },
  [2154] = {
    [sym__abstract_declarator] = STATE(2453),
    [sym_abstract_pointer_declarator] = STATE(2453),
    [sym_abstract_function_declarator] = STATE(2453),
    [sym_abstract_array_declarator] = STATE(2453),
    [sym_parameter_list] = STATE(2157),
    [sym_abstract_reference_declarator] = STATE(2453),
    [anon_sym_LPAREN] = ACTIONS(1115),
    [anon_sym_SEMI] = ACTIONS(2270),
    [anon_sym_LBRACE] = ACTIONS(2270),
    [anon_sym_STAR] = ACTIONS(4949),
    [anon_sym_LBRACK] = ACTIONS(1121),
    [anon_sym_const] = ACTIONS(4360),
    [anon_sym_restrict] = ACTIONS(2270),
    [anon_sym_volatile] = ACTIONS(2270),
    [anon_sym__Atomic] = ACTIONS(2270),
    [anon_sym_mutable] = ACTIONS(2270),
    [anon_sym_explicit] = ACTIONS(2270),
    [anon_sym_constexpr] = ACTIONS(2270),
    [anon_sym_COLON] = ACTIONS(2270),
    [anon_sym_AMP] = ACTIONS(4951),
    [anon_sym_AMP_AMP] = ACTIONS(4953),
    [anon_sym_DASH_GT] = ACTIONS(2270),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(2270),
  },
  [2155] = {
    [sym__abstract_declarator] = STATE(2454),
    [sym_abstract_pointer_declarator] = STATE(2454),
    [sym_abstract_function_declarator] = STATE(2454),
    [sym_abstract_array_declarator] = STATE(2454),
    [sym_parameter_list] = STATE(2157),
    [sym_abstract_reference_declarator] = STATE(2454),
    [anon_sym_LPAREN] = ACTIONS(1115),
    [anon_sym_SEMI] = ACTIONS(2278),
    [anon_sym_LBRACE] = ACTIONS(2278),
    [anon_sym_STAR] = ACTIONS(4949),
    [anon_sym_LBRACK] = ACTIONS(1121),
    [anon_sym_const] = ACTIONS(4362),
    [anon_sym_restrict] = ACTIONS(2278),
    [anon_sym_volatile] = ACTIONS(2278),
    [anon_sym__Atomic] = ACTIONS(2278),
    [anon_sym_mutable] = ACTIONS(2278),
    [anon_sym_explicit] = ACTIONS(2278),
    [anon_sym_constexpr] = ACTIONS(2278),
    [anon_sym_COLON] = ACTIONS(2278),
    [anon_sym_AMP] = ACTIONS(4951),
    [anon_sym_AMP_AMP] = ACTIONS(4953),
    [anon_sym_DASH_GT] = ACTIONS(2278),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(2278),
  },
  [2156] = {
    [sym_parameter_list] = STATE(2455),
    [anon_sym_LPAREN] = ACTIONS(206),
    [anon_sym_SEMI] = ACTIONS(4364),
    [anon_sym_LBRACE] = ACTIONS(4364),
    [anon_sym_LBRACK] = ACTIONS(2282),
    [anon_sym_const] = ACTIONS(4366),
    [anon_sym_restrict] = ACTIONS(4364),
    [anon_sym_volatile] = ACTIONS(4364),
    [anon_sym__Atomic] = ACTIONS(4364),
    [anon_sym_mutable] = ACTIONS(4364),
    [anon_sym_explicit] = ACTIONS(4364),
    [anon_sym_constexpr] = ACTIONS(4364),
    [anon_sym_COLON] = ACTIONS(4364),
    [anon_sym_DASH_GT] = ACTIONS(4364),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(4364),
  },
  [2157] = {
    [sym_type_qualifier] = STATE(2456),
    [sym_trailing_return_type] = STATE(1129),
    [aux_sym_abstract_function_declarator_repeat1] = STATE(2456),
    [anon_sym_LPAREN] = ACTIONS(2284),
    [anon_sym_SEMI] = ACTIONS(2284),
    [anon_sym_LBRACE] = ACTIONS(2284),
    [anon_sym_LBRACK] = ACTIONS(2284),
    [anon_sym_const] = ACTIONS(4368),
    [anon_sym_restrict] = ACTIONS(2284),
    [anon_sym_volatile] = ACTIONS(2284),
    [anon_sym__Atomic] = ACTIONS(2284),
    [anon_sym_mutable] = ACTIONS(2284),
    [anon_sym_explicit] = ACTIONS(2284),
    [anon_sym_constexpr] = ACTIONS(2284),
    [anon_sym_COLON] = ACTIONS(2284),
    [anon_sym_DASH_GT] = ACTIONS(2284),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(2284),
  },
  [2158] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2158),
    [anon_sym_LPAREN] = ACTIONS(816),
    [anon_sym_SEMI] = ACTIONS(816),
    [anon_sym_LBRACE] = ACTIONS(816),
    [anon_sym_STAR] = ACTIONS(816),
    [anon_sym_LBRACK] = ACTIONS(816),
    [anon_sym_const] = ACTIONS(818),
    [anon_sym_restrict] = ACTIONS(818),
    [anon_sym_volatile] = ACTIONS(818),
    [anon_sym__Atomic] = ACTIONS(818),
    [anon_sym_mutable] = ACTIONS(818),
    [anon_sym_explicit] = ACTIONS(818),
    [anon_sym_constexpr] = ACTIONS(818),
    [anon_sym_unsigned] = ACTIONS(5791),
    [anon_sym_long] = ACTIONS(5791),
    [anon_sym_short] = ACTIONS(5791),
    [sym_primitive_type] = ACTIONS(818),
    [anon_sym_COLON] = ACTIONS(816),
    [anon_sym_AMP] = ACTIONS(818),
    [anon_sym_AMP_AMP] = ACTIONS(816),
    [anon_sym_DASH_GT] = ACTIONS(816),
    [sym_identifier] = ACTIONS(818),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(818),
  },
  [2159] = {
    [sym__expression] = STATE(1834),
    [sym_conditional_expression] = STATE(1834),
    [sym_assignment_expression] = STATE(1834),
    [sym_pointer_expression] = STATE(1834),
    [sym_logical_expression] = STATE(1834),
    [sym_bitwise_expression] = STATE(1834),
    [sym_equality_expression] = STATE(1834),
    [sym_relational_expression] = STATE(1834),
    [sym_shift_expression] = STATE(1834),
    [sym_math_expression] = STATE(1834),
    [sym_cast_expression] = STATE(1834),
    [sym_sizeof_expression] = STATE(1834),
    [sym_subscript_expression] = STATE(1834),
    [sym_call_expression] = STATE(1834),
    [sym_field_expression] = STATE(1834),
    [sym_compound_literal_expression] = STATE(1834),
    [sym_parenthesized_expression] = STATE(1834),
    [sym_initializer_list] = STATE(1835),
    [sym_concatenated_string] = STATE(1834),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(1834),
    [sym_new_expression] = STATE(1834),
    [sym_delete_expression] = STATE(1834),
    [sym_lambda_expression] = STATE(1834),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(4145),
    [anon_sym_LPAREN] = ACTIONS(1087),
    [anon_sym_COMMA] = ACTIONS(5210),
    [anon_sym_RPAREN] = ACTIONS(5210),
    [anon_sym_LBRACE] = ACTIONS(548),
    [anon_sym_STAR] = ACTIONS(5794),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_EQ] = ACTIONS(5212),
    [anon_sym_QMARK] = ACTIONS(5210),
    [anon_sym_STAR_EQ] = ACTIONS(5210),
    [anon_sym_SLASH_EQ] = ACTIONS(5210),
    [anon_sym_PERCENT_EQ] = ACTIONS(5210),
    [anon_sym_PLUS_EQ] = ACTIONS(5210),
    [anon_sym_DASH_EQ] = ACTIONS(5210),
    [anon_sym_LT_LT_EQ] = ACTIONS(5210),
    [anon_sym_GT_GT_EQ] = ACTIONS(5210),
    [anon_sym_AMP_EQ] = ACTIONS(5210),
    [anon_sym_CARET_EQ] = ACTIONS(5210),
    [anon_sym_PIPE_EQ] = ACTIONS(5210),
    [anon_sym_AMP] = ACTIONS(5794),
    [anon_sym_PIPE_PIPE] = ACTIONS(5210),
    [anon_sym_AMP_AMP] = ACTIONS(5210),
    [anon_sym_BANG] = ACTIONS(5796),
    [anon_sym_PIPE] = ACTIONS(5212),
    [anon_sym_CARET] = ACTIONS(5212),
    [anon_sym_TILDE] = ACTIONS(1093),
    [anon_sym_EQ_EQ] = ACTIONS(5210),
    [anon_sym_BANG_EQ] = ACTIONS(5210),
    [anon_sym_LT] = ACTIONS(5212),
    [anon_sym_GT] = ACTIONS(5212),
    [anon_sym_LT_EQ] = ACTIONS(5210),
    [anon_sym_GT_EQ] = ACTIONS(5210),
    [anon_sym_LT_LT] = ACTIONS(5212),
    [anon_sym_GT_GT] = ACTIONS(5212),
    [anon_sym_PLUS] = ACTIONS(1095),
    [anon_sym_DASH] = ACTIONS(1095),
    [anon_sym_SLASH] = ACTIONS(5212),
    [anon_sym_PERCENT] = ACTIONS(5212),
    [anon_sym_DASH_DASH] = ACTIONS(1097),
    [anon_sym_PLUS_PLUS] = ACTIONS(1097),
    [anon_sym_sizeof] = ACTIONS(1099),
    [anon_sym_DOT] = ACTIONS(5210),
    [anon_sym_DASH_GT] = ACTIONS(5210),
    [sym_number_literal] = ACTIONS(4145),
    [sym_char_literal] = ACTIONS(4145),
    [sym_string_literal] = ACTIONS(1101),
    [sym_true] = ACTIONS(4147),
    [sym_false] = ACTIONS(4147),
    [sym_null] = ACTIONS(4147),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_delete] = ACTIONS(1109),
    [sym_nullptr] = ACTIONS(4147),
  },
  [2160] = {
    [sym__expression] = STATE(2457),
    [sym_conditional_expression] = STATE(2457),
    [sym_assignment_expression] = STATE(2457),
    [sym_pointer_expression] = STATE(2457),
    [sym_logical_expression] = STATE(2457),
    [sym_bitwise_expression] = STATE(2457),
    [sym_equality_expression] = STATE(2457),
    [sym_relational_expression] = STATE(2457),
    [sym_shift_expression] = STATE(2457),
    [sym_math_expression] = STATE(2457),
    [sym_cast_expression] = STATE(2457),
    [sym_sizeof_expression] = STATE(2457),
    [sym_subscript_expression] = STATE(2457),
    [sym_call_expression] = STATE(2457),
    [sym_field_expression] = STATE(2457),
    [sym_compound_literal_expression] = STATE(2457),
    [sym_parenthesized_expression] = STATE(2457),
    [sym_concatenated_string] = STATE(2457),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(2457),
    [sym_new_expression] = STATE(2457),
    [sym_delete_expression] = STATE(2457),
    [sym_lambda_expression] = STATE(2457),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(5798),
    [anon_sym_LPAREN] = ACTIONS(2624),
    [anon_sym_STAR] = ACTIONS(2624),
    [anon_sym_LBRACK] = ACTIONS(2624),
    [anon_sym_AMP] = ACTIONS(2626),
    [anon_sym_AMP_AMP] = ACTIONS(2624),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1093),
    [anon_sym_PLUS] = ACTIONS(1095),
    [anon_sym_DASH] = ACTIONS(1095),
    [anon_sym_DASH_DASH] = ACTIONS(1097),
    [anon_sym_PLUS_PLUS] = ACTIONS(1097),
    [anon_sym_sizeof] = ACTIONS(1099),
    [sym_number_literal] = ACTIONS(5798),
    [sym_char_literal] = ACTIONS(5798),
    [sym_string_literal] = ACTIONS(1101),
    [sym_true] = ACTIONS(5800),
    [sym_false] = ACTIONS(5800),
    [sym_null] = ACTIONS(5800),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_delete] = ACTIONS(1109),
    [sym_nullptr] = ACTIONS(5800),
  },
  [2161] = {
    [sym_argument_list] = STATE(802),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_COMMA] = ACTIONS(5236),
    [anon_sym_RPAREN] = ACTIONS(5236),
    [anon_sym_STAR] = ACTIONS(2234),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_EQ] = ACTIONS(5238),
    [anon_sym_QMARK] = ACTIONS(5236),
    [anon_sym_STAR_EQ] = ACTIONS(5236),
    [anon_sym_SLASH_EQ] = ACTIONS(5236),
    [anon_sym_PERCENT_EQ] = ACTIONS(5236),
    [anon_sym_PLUS_EQ] = ACTIONS(5236),
    [anon_sym_DASH_EQ] = ACTIONS(5236),
    [anon_sym_LT_LT_EQ] = ACTIONS(5236),
    [anon_sym_GT_GT_EQ] = ACTIONS(5236),
    [anon_sym_AMP_EQ] = ACTIONS(5236),
    [anon_sym_CARET_EQ] = ACTIONS(5236),
    [anon_sym_PIPE_EQ] = ACTIONS(5236),
    [anon_sym_AMP] = ACTIONS(2242),
    [anon_sym_PIPE_PIPE] = ACTIONS(2244),
    [anon_sym_AMP_AMP] = ACTIONS(2246),
    [anon_sym_PIPE] = ACTIONS(2248),
    [anon_sym_CARET] = ACTIONS(2250),
    [anon_sym_EQ_EQ] = ACTIONS(2252),
    [anon_sym_BANG_EQ] = ACTIONS(2252),
    [anon_sym_LT] = ACTIONS(2254),
    [anon_sym_GT] = ACTIONS(2254),
    [anon_sym_LT_EQ] = ACTIONS(2256),
    [anon_sym_GT_EQ] = ACTIONS(2256),
    [anon_sym_LT_LT] = ACTIONS(2258),
    [anon_sym_GT_GT] = ACTIONS(2258),
    [anon_sym_PLUS] = ACTIONS(2260),
    [anon_sym_DASH] = ACTIONS(2260),
    [anon_sym_SLASH] = ACTIONS(2234),
    [anon_sym_PERCENT] = ACTIONS(2234),
    [anon_sym_DASH_DASH] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(1554),
    [anon_sym_DASH_GT] = ACTIONS(1554),
    [sym_comment] = ACTIONS(49),
  },
  [2162] = {
    [sym__expression] = STATE(2458),
    [sym_conditional_expression] = STATE(2458),
    [sym_assignment_expression] = STATE(2458),
    [sym_pointer_expression] = STATE(2458),
    [sym_logical_expression] = STATE(2458),
    [sym_bitwise_expression] = STATE(2458),
    [sym_equality_expression] = STATE(2458),
    [sym_relational_expression] = STATE(2458),
    [sym_shift_expression] = STATE(2458),
    [sym_math_expression] = STATE(2458),
    [sym_cast_expression] = STATE(2458),
    [sym_sizeof_expression] = STATE(2458),
    [sym_subscript_expression] = STATE(2458),
    [sym_call_expression] = STATE(2458),
    [sym_field_expression] = STATE(2458),
    [sym_compound_literal_expression] = STATE(2458),
    [sym_parenthesized_expression] = STATE(2458),
    [sym_concatenated_string] = STATE(2458),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(2458),
    [sym_new_expression] = STATE(2458),
    [sym_delete_expression] = STATE(2458),
    [sym_lambda_expression] = STATE(2458),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(5802),
    [anon_sym_LPAREN] = ACTIONS(1087),
    [anon_sym_STAR] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_AMP] = ACTIONS(1089),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1093),
    [anon_sym_PLUS] = ACTIONS(1095),
    [anon_sym_DASH] = ACTIONS(1095),
    [anon_sym_DASH_DASH] = ACTIONS(1097),
    [anon_sym_PLUS_PLUS] = ACTIONS(1097),
    [anon_sym_sizeof] = ACTIONS(1099),
    [sym_number_literal] = ACTIONS(5802),
    [sym_char_literal] = ACTIONS(5802),
    [sym_string_literal] = ACTIONS(1101),
    [sym_true] = ACTIONS(5804),
    [sym_false] = ACTIONS(5804),
    [sym_null] = ACTIONS(5804),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_delete] = ACTIONS(1109),
    [sym_nullptr] = ACTIONS(5804),
  },
  [2163] = {
    [sym_type_qualifier] = STATE(2165),
    [sym_trailing_return_type] = STATE(2168),
    [aux_sym_abstract_function_declarator_repeat1] = STATE(2165),
    [anon_sym_LPAREN] = ACTIONS(4998),
    [anon_sym_RPAREN] = ACTIONS(4998),
    [anon_sym_LBRACK] = ACTIONS(4998),
    [anon_sym_const] = ACTIONS(612),
    [anon_sym_restrict] = ACTIONS(614),
    [anon_sym_volatile] = ACTIONS(614),
    [anon_sym__Atomic] = ACTIONS(614),
    [anon_sym_mutable] = ACTIONS(614),
    [anon_sym_explicit] = ACTIONS(614),
    [anon_sym_constexpr] = ACTIONS(614),
    [anon_sym_DASH_GT] = ACTIONS(3746),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(4986),
  },
  [2164] = {
    [sym__abstract_declarator] = STATE(2459),
    [sym_abstract_pointer_declarator] = STATE(2459),
    [sym_abstract_function_declarator] = STATE(2459),
    [sym_abstract_array_declarator] = STATE(2459),
    [sym_parameter_list] = STATE(1120),
    [sym_abstract_reference_declarator] = STATE(2459),
    [anon_sym_LPAREN] = ACTIONS(1115),
    [anon_sym_RPAREN] = ACTIONS(2841),
    [anon_sym_STAR] = ACTIONS(2264),
    [anon_sym_LBRACK] = ACTIONS(1121),
    [anon_sym_AMP] = ACTIONS(2266),
    [anon_sym_AMP_AMP] = ACTIONS(2268),
    [sym_comment] = ACTIONS(49),
  },
  [2165] = {
    [sym_type_qualifier] = STATE(2165),
    [aux_sym_abstract_function_declarator_repeat1] = STATE(2165),
    [anon_sym_LPAREN] = ACTIONS(5002),
    [anon_sym_RPAREN] = ACTIONS(5002),
    [anon_sym_LBRACK] = ACTIONS(5002),
    [anon_sym_const] = ACTIONS(5004),
    [anon_sym_restrict] = ACTIONS(5007),
    [anon_sym_volatile] = ACTIONS(5007),
    [anon_sym__Atomic] = ACTIONS(5007),
    [anon_sym_mutable] = ACTIONS(5007),
    [anon_sym_explicit] = ACTIONS(5007),
    [anon_sym_constexpr] = ACTIONS(5007),
    [anon_sym_DASH_GT] = ACTIONS(5002),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(5806),
  },
  [2166] = {
    [anon_sym_LPAREN] = ACTIONS(5809),
    [anon_sym_COMMA] = ACTIONS(5809),
    [anon_sym_RPAREN] = ACTIONS(5809),
    [anon_sym_SEMI] = ACTIONS(5809),
    [anon_sym_LBRACE] = ACTIONS(5809),
    [anon_sym_LBRACK] = ACTIONS(5809),
    [anon_sym_EQ] = ACTIONS(5809),
    [anon_sym_const] = ACTIONS(5811),
    [anon_sym_restrict] = ACTIONS(5809),
    [anon_sym_volatile] = ACTIONS(5809),
    [anon_sym__Atomic] = ACTIONS(5809),
    [anon_sym_mutable] = ACTIONS(5809),
    [anon_sym_explicit] = ACTIONS(5809),
    [anon_sym_constexpr] = ACTIONS(5809),
    [anon_sym_COLON] = ACTIONS(5809),
    [anon_sym_GT] = ACTIONS(5809),
    [anon_sym_DASH_GT] = ACTIONS(5809),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(5809),
  },
  [2167] = {
    [sym_argument_list] = STATE(802),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_STAR] = ACTIONS(1522),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_RBRACK] = ACTIONS(5813),
    [anon_sym_EQ] = ACTIONS(1526),
    [anon_sym_QMARK] = ACTIONS(1528),
    [anon_sym_STAR_EQ] = ACTIONS(1530),
    [anon_sym_SLASH_EQ] = ACTIONS(1530),
    [anon_sym_PERCENT_EQ] = ACTIONS(1530),
    [anon_sym_PLUS_EQ] = ACTIONS(1530),
    [anon_sym_DASH_EQ] = ACTIONS(1530),
    [anon_sym_LT_LT_EQ] = ACTIONS(1530),
    [anon_sym_GT_GT_EQ] = ACTIONS(1530),
    [anon_sym_AMP_EQ] = ACTIONS(1530),
    [anon_sym_CARET_EQ] = ACTIONS(1530),
    [anon_sym_PIPE_EQ] = ACTIONS(1530),
    [anon_sym_AMP] = ACTIONS(1532),
    [anon_sym_PIPE_PIPE] = ACTIONS(1534),
    [anon_sym_AMP_AMP] = ACTIONS(1536),
    [anon_sym_PIPE] = ACTIONS(1538),
    [anon_sym_CARET] = ACTIONS(1540),
    [anon_sym_EQ_EQ] = ACTIONS(1542),
    [anon_sym_BANG_EQ] = ACTIONS(1542),
    [anon_sym_LT] = ACTIONS(1544),
    [anon_sym_GT] = ACTIONS(1544),
    [anon_sym_LT_EQ] = ACTIONS(1546),
    [anon_sym_GT_EQ] = ACTIONS(1546),
    [anon_sym_LT_LT] = ACTIONS(1548),
    [anon_sym_GT_GT] = ACTIONS(1548),
    [anon_sym_PLUS] = ACTIONS(1550),
    [anon_sym_DASH] = ACTIONS(1550),
    [anon_sym_SLASH] = ACTIONS(1522),
    [anon_sym_PERCENT] = ACTIONS(1522),
    [anon_sym_DASH_DASH] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(1554),
    [anon_sym_DASH_GT] = ACTIONS(1554),
    [sym_comment] = ACTIONS(49),
  },
  [2168] = {
    [anon_sym_LPAREN] = ACTIONS(5815),
    [anon_sym_COMMA] = ACTIONS(5815),
    [anon_sym_RPAREN] = ACTIONS(5815),
    [anon_sym_SEMI] = ACTIONS(5815),
    [anon_sym_LBRACE] = ACTIONS(5815),
    [anon_sym_LBRACK] = ACTIONS(5815),
    [anon_sym_EQ] = ACTIONS(5815),
    [anon_sym_const] = ACTIONS(5817),
    [anon_sym_restrict] = ACTIONS(5815),
    [anon_sym_volatile] = ACTIONS(5815),
    [anon_sym__Atomic] = ACTIONS(5815),
    [anon_sym_mutable] = ACTIONS(5815),
    [anon_sym_explicit] = ACTIONS(5815),
    [anon_sym_constexpr] = ACTIONS(5815),
    [anon_sym_COLON] = ACTIONS(5815),
    [anon_sym_GT] = ACTIONS(5815),
    [anon_sym_DASH_GT] = ACTIONS(5815),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(5815),
  },
  [2169] = {
    [sym_parameter_list] = STATE(1127),
    [anon_sym_LPAREN] = ACTIONS(206),
    [anon_sym_COMMA] = ACTIONS(4364),
    [anon_sym_LBRACK] = ACTIONS(2282),
    [anon_sym_GT] = ACTIONS(4364),
    [sym_comment] = ACTIONS(49),
  },
  [2170] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2170),
    [anon_sym_COMMA] = ACTIONS(816),
    [anon_sym_unsigned] = ACTIONS(5819),
    [anon_sym_long] = ACTIONS(5819),
    [anon_sym_short] = ACTIONS(5819),
    [sym_primitive_type] = ACTIONS(818),
    [anon_sym_GT] = ACTIONS(816),
    [sym_identifier] = ACTIONS(818),
    [sym_comment] = ACTIONS(49),
  },
  [2171] = {
    [anon_sym_COMMA] = ACTIONS(3882),
    [anon_sym_GT] = ACTIONS(3882),
    [sym_comment] = ACTIONS(49),
  },
  [2172] = {
    [aux_sym_argument_list_repeat1] = STATE(1755),
    [anon_sym_COMMA] = ACTIONS(2388),
    [anon_sym_RPAREN] = ACTIONS(5822),
    [sym_comment] = ACTIONS(49),
  },
  [2173] = {
    [anon_sym_COMMA] = ACTIONS(3892),
    [anon_sym_GT] = ACTIONS(3892),
    [sym_comment] = ACTIONS(49),
  },
  [2174] = {
    [sym__expression] = STATE(1780),
    [sym_conditional_expression] = STATE(1780),
    [sym_assignment_expression] = STATE(1780),
    [sym_pointer_expression] = STATE(1780),
    [sym_logical_expression] = STATE(1780),
    [sym_bitwise_expression] = STATE(1780),
    [sym_equality_expression] = STATE(1780),
    [sym_relational_expression] = STATE(1780),
    [sym_shift_expression] = STATE(1780),
    [sym_math_expression] = STATE(1780),
    [sym_cast_expression] = STATE(1780),
    [sym_sizeof_expression] = STATE(1780),
    [sym_subscript_expression] = STATE(1780),
    [sym_call_expression] = STATE(1780),
    [sym_field_expression] = STATE(1780),
    [sym_compound_literal_expression] = STATE(1780),
    [sym_parenthesized_expression] = STATE(1780),
    [sym_initializer_list] = STATE(1766),
    [sym_initializer_pair] = STATE(1766),
    [sym_subscript_designator] = STATE(671),
    [sym_field_designator] = STATE(671),
    [sym_concatenated_string] = STATE(1780),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(1780),
    [sym_new_expression] = STATE(1780),
    [sym_delete_expression] = STATE(1780),
    [sym_lambda_expression] = STATE(1780),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [aux_sym_initializer_pair_repeat1] = STATE(671),
    [sym_raw_string_literal] = ACTIONS(3962),
    [anon_sym_LPAREN] = ACTIONS(1321),
    [anon_sym_LBRACE] = ACTIONS(548),
    [anon_sym_RBRACE] = ACTIONS(5824),
    [anon_sym_STAR] = ACTIONS(1325),
    [anon_sym_LBRACK] = ACTIONS(1277),
    [anon_sym_AMP] = ACTIONS(1325),
    [anon_sym_BANG] = ACTIONS(1327),
    [anon_sym_TILDE] = ACTIONS(1329),
    [anon_sym_PLUS] = ACTIONS(1331),
    [anon_sym_DASH] = ACTIONS(1331),
    [anon_sym_DASH_DASH] = ACTIONS(1333),
    [anon_sym_PLUS_PLUS] = ACTIONS(1333),
    [anon_sym_sizeof] = ACTIONS(1335),
    [anon_sym_DOT] = ACTIONS(1289),
    [sym_number_literal] = ACTIONS(3962),
    [sym_char_literal] = ACTIONS(3962),
    [sym_string_literal] = ACTIONS(1337),
    [sym_true] = ACTIONS(3964),
    [sym_false] = ACTIONS(3964),
    [sym_null] = ACTIONS(3964),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1341),
    [anon_sym_delete] = ACTIONS(1343),
    [sym_nullptr] = ACTIONS(3964),
  },
  [2175] = {
    [aux_sym_initializer_list_repeat1] = STATE(1779),
    [anon_sym_COMMA] = ACTIONS(5826),
    [anon_sym_RBRACE] = ACTIONS(5824),
    [sym_comment] = ACTIONS(49),
  },
  [2176] = {
    [anon_sym_RPAREN] = ACTIONS(5828),
    [sym_comment] = ACTIONS(49),
  },
  [2177] = {
    [sym_type_qualifier] = STATE(724),
    [sym__type_specifier] = STATE(720),
    [sym_sized_type_specifier] = STATE(720),
    [sym_enum_specifier] = STATE(720),
    [sym_struct_specifier] = STATE(720),
    [sym_union_specifier] = STATE(720),
    [sym__expression] = STATE(721),
    [sym_comma_expression] = STATE(722),
    [sym_conditional_expression] = STATE(721),
    [sym_assignment_expression] = STATE(721),
    [sym_pointer_expression] = STATE(721),
    [sym_logical_expression] = STATE(721),
    [sym_bitwise_expression] = STATE(721),
    [sym_equality_expression] = STATE(721),
    [sym_relational_expression] = STATE(721),
    [sym_shift_expression] = STATE(721),
    [sym_math_expression] = STATE(721),
    [sym_cast_expression] = STATE(721),
    [sym_type_descriptor] = STATE(2465),
    [sym_sizeof_expression] = STATE(721),
    [sym_subscript_expression] = STATE(721),
    [sym_call_expression] = STATE(721),
    [sym_field_expression] = STATE(721),
    [sym_compound_literal_expression] = STATE(721),
    [sym_parenthesized_expression] = STATE(721),
    [sym_concatenated_string] = STATE(721),
    [sym_macro_type_specifier] = STATE(720),
    [sym_class_specifier] = STATE(720),
    [sym_dependent_type] = STATE(720),
    [sym_template_type] = STATE(415),
    [sym_template_function] = STATE(721),
    [sym_new_expression] = STATE(721),
    [sym_delete_expression] = STATE(721),
    [sym_lambda_expression] = STATE(721),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(416),
    [sym_scoped_namespace_identifier] = STATE(417),
    [aux_sym_type_definition_repeat1] = STATE(724),
    [aux_sym_sized_type_specifier_repeat1] = STATE(725),
    [sym_raw_string_literal] = ACTIONS(1397),
    [anon_sym_LPAREN] = ACTIONS(1087),
    [anon_sym_STAR] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_restrict] = ACTIONS(93),
    [anon_sym_volatile] = ACTIONS(93),
    [anon_sym__Atomic] = ACTIONS(93),
    [anon_sym_mutable] = ACTIONS(93),
    [anon_sym_explicit] = ACTIONS(93),
    [anon_sym_constexpr] = ACTIONS(93),
    [anon_sym_unsigned] = ACTIONS(1399),
    [anon_sym_long] = ACTIONS(1399),
    [anon_sym_short] = ACTIONS(1399),
    [sym_primitive_type] = ACTIONS(1401),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(428),
    [anon_sym_union] = ACTIONS(430),
    [anon_sym_AMP] = ACTIONS(1089),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1093),
    [anon_sym_PLUS] = ACTIONS(1095),
    [anon_sym_DASH] = ACTIONS(1095),
    [anon_sym_DASH_DASH] = ACTIONS(1097),
    [anon_sym_PLUS_PLUS] = ACTIONS(1097),
    [anon_sym_sizeof] = ACTIONS(1099),
    [sym_number_literal] = ACTIONS(1397),
    [sym_char_literal] = ACTIONS(1397),
    [sym_string_literal] = ACTIONS(1101),
    [sym_true] = ACTIONS(1403),
    [sym_false] = ACTIONS(1403),
    [sym_null] = ACTIONS(1403),
    [sym_identifier] = ACTIONS(1405),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(436),
    [sym_auto] = ACTIONS(1401),
    [anon_sym_typename] = ACTIONS(1407),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1409),
    [anon_sym_delete] = ACTIONS(1109),
    [sym_nullptr] = ACTIONS(1403),
  },
  [2178] = {
    [sym_argument_list] = STATE(802),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_COMMA] = ACTIONS(2702),
    [anon_sym_STAR] = ACTIONS(5039),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_EQ] = ACTIONS(2704),
    [anon_sym_QMARK] = ACTIONS(2702),
    [anon_sym_STAR_EQ] = ACTIONS(2702),
    [anon_sym_SLASH_EQ] = ACTIONS(2702),
    [anon_sym_PERCENT_EQ] = ACTIONS(2702),
    [anon_sym_PLUS_EQ] = ACTIONS(2702),
    [anon_sym_DASH_EQ] = ACTIONS(2702),
    [anon_sym_LT_LT_EQ] = ACTIONS(2702),
    [anon_sym_GT_GT_EQ] = ACTIONS(2702),
    [anon_sym_AMP_EQ] = ACTIONS(2702),
    [anon_sym_CARET_EQ] = ACTIONS(2702),
    [anon_sym_PIPE_EQ] = ACTIONS(2702),
    [anon_sym_AMP] = ACTIONS(2704),
    [anon_sym_PIPE_PIPE] = ACTIONS(2702),
    [anon_sym_AMP_AMP] = ACTIONS(2702),
    [anon_sym_PIPE] = ACTIONS(2704),
    [anon_sym_CARET] = ACTIONS(2704),
    [anon_sym_EQ_EQ] = ACTIONS(2702),
    [anon_sym_BANG_EQ] = ACTIONS(2702),
    [anon_sym_LT] = ACTIONS(2704),
    [anon_sym_GT] = ACTIONS(2704),
    [anon_sym_LT_EQ] = ACTIONS(2702),
    [anon_sym_GT_EQ] = ACTIONS(2702),
    [anon_sym_LT_LT] = ACTIONS(5063),
    [anon_sym_GT_GT] = ACTIONS(5063),
    [anon_sym_PLUS] = ACTIONS(5065),
    [anon_sym_DASH] = ACTIONS(5065),
    [anon_sym_SLASH] = ACTIONS(5039),
    [anon_sym_PERCENT] = ACTIONS(5039),
    [anon_sym_DASH_DASH] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(1554),
    [anon_sym_DASH_GT] = ACTIONS(1554),
    [sym_comment] = ACTIONS(49),
  },
  [2179] = {
    [aux_sym_concatenated_string_repeat1] = STATE(2466),
    [anon_sym_LPAREN] = ACTIONS(2706),
    [anon_sym_COMMA] = ACTIONS(2706),
    [anon_sym_STAR] = ACTIONS(2708),
    [anon_sym_LBRACK] = ACTIONS(2706),
    [anon_sym_EQ] = ACTIONS(2708),
    [anon_sym_QMARK] = ACTIONS(2706),
    [anon_sym_STAR_EQ] = ACTIONS(2706),
    [anon_sym_SLASH_EQ] = ACTIONS(2706),
    [anon_sym_PERCENT_EQ] = ACTIONS(2706),
    [anon_sym_PLUS_EQ] = ACTIONS(2706),
    [anon_sym_DASH_EQ] = ACTIONS(2706),
    [anon_sym_LT_LT_EQ] = ACTIONS(2706),
    [anon_sym_GT_GT_EQ] = ACTIONS(2706),
    [anon_sym_AMP_EQ] = ACTIONS(2706),
    [anon_sym_CARET_EQ] = ACTIONS(2706),
    [anon_sym_PIPE_EQ] = ACTIONS(2706),
    [anon_sym_AMP] = ACTIONS(2708),
    [anon_sym_PIPE_PIPE] = ACTIONS(2706),
    [anon_sym_AMP_AMP] = ACTIONS(2706),
    [anon_sym_PIPE] = ACTIONS(2708),
    [anon_sym_CARET] = ACTIONS(2708),
    [anon_sym_EQ_EQ] = ACTIONS(2706),
    [anon_sym_BANG_EQ] = ACTIONS(2706),
    [anon_sym_LT] = ACTIONS(2708),
    [anon_sym_GT] = ACTIONS(2708),
    [anon_sym_LT_EQ] = ACTIONS(2706),
    [anon_sym_GT_EQ] = ACTIONS(2706),
    [anon_sym_LT_LT] = ACTIONS(2708),
    [anon_sym_GT_GT] = ACTIONS(2708),
    [anon_sym_PLUS] = ACTIONS(2708),
    [anon_sym_DASH] = ACTIONS(2708),
    [anon_sym_SLASH] = ACTIONS(2708),
    [anon_sym_PERCENT] = ACTIONS(2708),
    [anon_sym_DASH_DASH] = ACTIONS(2706),
    [anon_sym_PLUS_PLUS] = ACTIONS(2706),
    [anon_sym_DOT] = ACTIONS(2706),
    [anon_sym_DASH_GT] = ACTIONS(2706),
    [sym_string_literal] = ACTIONS(5830),
    [sym_comment] = ACTIONS(49),
  },
  [2180] = {
    [sym__expression] = STATE(2468),
    [sym_conditional_expression] = STATE(2468),
    [sym_assignment_expression] = STATE(2468),
    [sym_pointer_expression] = STATE(2468),
    [sym_logical_expression] = STATE(2468),
    [sym_bitwise_expression] = STATE(2468),
    [sym_equality_expression] = STATE(2468),
    [sym_relational_expression] = STATE(2468),
    [sym_shift_expression] = STATE(2468),
    [sym_math_expression] = STATE(2468),
    [sym_cast_expression] = STATE(2468),
    [sym_sizeof_expression] = STATE(2468),
    [sym_subscript_expression] = STATE(2468),
    [sym_call_expression] = STATE(2468),
    [sym_field_expression] = STATE(2468),
    [sym_compound_literal_expression] = STATE(2468),
    [sym_parenthesized_expression] = STATE(2468),
    [sym_concatenated_string] = STATE(2468),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(2468),
    [sym_new_expression] = STATE(2468),
    [sym_delete_expression] = STATE(2468),
    [sym_lambda_expression] = STATE(2468),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(5832),
    [anon_sym_LPAREN] = ACTIONS(3807),
    [anon_sym_STAR] = ACTIONS(3809),
    [anon_sym_LBRACK] = ACTIONS(5834),
    [anon_sym_AMP] = ACTIONS(3809),
    [anon_sym_BANG] = ACTIONS(3811),
    [anon_sym_TILDE] = ACTIONS(3813),
    [anon_sym_PLUS] = ACTIONS(3815),
    [anon_sym_DASH] = ACTIONS(3815),
    [anon_sym_DASH_DASH] = ACTIONS(3817),
    [anon_sym_PLUS_PLUS] = ACTIONS(3817),
    [anon_sym_sizeof] = ACTIONS(3819),
    [sym_number_literal] = ACTIONS(5832),
    [sym_char_literal] = ACTIONS(5832),
    [sym_string_literal] = ACTIONS(3821),
    [sym_true] = ACTIONS(5836),
    [sym_false] = ACTIONS(5836),
    [sym_null] = ACTIONS(5836),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(3825),
    [anon_sym_delete] = ACTIONS(3827),
    [sym_nullptr] = ACTIONS(5836),
  },
  [2181] = {
    [sym__expression] = STATE(740),
    [sym_conditional_expression] = STATE(740),
    [sym_assignment_expression] = STATE(740),
    [sym_pointer_expression] = STATE(740),
    [sym_logical_expression] = STATE(740),
    [sym_bitwise_expression] = STATE(740),
    [sym_equality_expression] = STATE(740),
    [sym_relational_expression] = STATE(740),
    [sym_shift_expression] = STATE(740),
    [sym_math_expression] = STATE(740),
    [sym_cast_expression] = STATE(740),
    [sym_sizeof_expression] = STATE(740),
    [sym_subscript_expression] = STATE(740),
    [sym_call_expression] = STATE(740),
    [sym_field_expression] = STATE(740),
    [sym_compound_literal_expression] = STATE(740),
    [sym_parenthesized_expression] = STATE(740),
    [sym_concatenated_string] = STATE(740),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(740),
    [sym_new_expression] = STATE(740),
    [sym_delete_expression] = STATE(740),
    [sym_lambda_expression] = STATE(740),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_lambda_default_capture] = STATE(741),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(1417),
    [anon_sym_LPAREN] = ACTIONS(1419),
    [anon_sym_STAR] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_RBRACK] = ACTIONS(5838),
    [anon_sym_EQ] = ACTIONS(1425),
    [anon_sym_AMP] = ACTIONS(1427),
    [anon_sym_BANG] = ACTIONS(1429),
    [anon_sym_TILDE] = ACTIONS(1431),
    [anon_sym_PLUS] = ACTIONS(1433),
    [anon_sym_DASH] = ACTIONS(1433),
    [anon_sym_DASH_DASH] = ACTIONS(1435),
    [anon_sym_PLUS_PLUS] = ACTIONS(1435),
    [anon_sym_sizeof] = ACTIONS(1437),
    [sym_number_literal] = ACTIONS(1417),
    [sym_char_literal] = ACTIONS(1417),
    [sym_string_literal] = ACTIONS(1439),
    [sym_true] = ACTIONS(1441),
    [sym_false] = ACTIONS(1441),
    [sym_null] = ACTIONS(1441),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1443),
    [anon_sym_delete] = ACTIONS(1445),
    [sym_nullptr] = ACTIONS(1441),
  },
  [2182] = {
    [sym_argument_list] = STATE(802),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_COMMA] = ACTIONS(2740),
    [anon_sym_STAR] = ACTIONS(5039),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_EQ] = ACTIONS(2742),
    [anon_sym_QMARK] = ACTIONS(2740),
    [anon_sym_STAR_EQ] = ACTIONS(2740),
    [anon_sym_SLASH_EQ] = ACTIONS(2740),
    [anon_sym_PERCENT_EQ] = ACTIONS(2740),
    [anon_sym_PLUS_EQ] = ACTIONS(2740),
    [anon_sym_DASH_EQ] = ACTIONS(2740),
    [anon_sym_LT_LT_EQ] = ACTIONS(2740),
    [anon_sym_GT_GT_EQ] = ACTIONS(2740),
    [anon_sym_AMP_EQ] = ACTIONS(2740),
    [anon_sym_CARET_EQ] = ACTIONS(2740),
    [anon_sym_PIPE_EQ] = ACTIONS(2740),
    [anon_sym_AMP] = ACTIONS(5047),
    [anon_sym_PIPE_PIPE] = ACTIONS(5049),
    [anon_sym_AMP_AMP] = ACTIONS(5051),
    [anon_sym_PIPE] = ACTIONS(5053),
    [anon_sym_CARET] = ACTIONS(5055),
    [anon_sym_EQ_EQ] = ACTIONS(5057),
    [anon_sym_BANG_EQ] = ACTIONS(5057),
    [anon_sym_LT] = ACTIONS(5059),
    [anon_sym_GT] = ACTIONS(5059),
    [anon_sym_LT_EQ] = ACTIONS(5061),
    [anon_sym_GT_EQ] = ACTIONS(5061),
    [anon_sym_LT_LT] = ACTIONS(5063),
    [anon_sym_GT_GT] = ACTIONS(5063),
    [anon_sym_PLUS] = ACTIONS(5065),
    [anon_sym_DASH] = ACTIONS(5065),
    [anon_sym_SLASH] = ACTIONS(5039),
    [anon_sym_PERCENT] = ACTIONS(5039),
    [anon_sym_DASH_DASH] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(1554),
    [anon_sym_DASH_GT] = ACTIONS(1554),
    [sym_comment] = ACTIONS(49),
  },
  [2183] = {
    [sym__expression] = STATE(1328),
    [sym_conditional_expression] = STATE(1328),
    [sym_assignment_expression] = STATE(1328),
    [sym_pointer_expression] = STATE(1328),
    [sym_logical_expression] = STATE(1328),
    [sym_bitwise_expression] = STATE(1328),
    [sym_equality_expression] = STATE(1328),
    [sym_relational_expression] = STATE(1328),
    [sym_shift_expression] = STATE(1328),
    [sym_math_expression] = STATE(1328),
    [sym_cast_expression] = STATE(1328),
    [sym_sizeof_expression] = STATE(1328),
    [sym_subscript_expression] = STATE(1328),
    [sym_call_expression] = STATE(1328),
    [sym_field_expression] = STATE(1328),
    [sym_compound_literal_expression] = STATE(1328),
    [sym_parenthesized_expression] = STATE(1328),
    [sym_concatenated_string] = STATE(1328),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(1328),
    [sym_new_expression] = STATE(1328),
    [sym_delete_expression] = STATE(1328),
    [sym_lambda_expression] = STATE(1328),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(2748),
    [anon_sym_LPAREN] = ACTIONS(3807),
    [anon_sym_STAR] = ACTIONS(3809),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_AMP] = ACTIONS(3809),
    [anon_sym_BANG] = ACTIONS(3811),
    [anon_sym_TILDE] = ACTIONS(3813),
    [anon_sym_PLUS] = ACTIONS(3815),
    [anon_sym_DASH] = ACTIONS(3815),
    [anon_sym_DASH_DASH] = ACTIONS(3817),
    [anon_sym_PLUS_PLUS] = ACTIONS(3817),
    [anon_sym_sizeof] = ACTIONS(3819),
    [sym_number_literal] = ACTIONS(2748),
    [sym_char_literal] = ACTIONS(2748),
    [sym_string_literal] = ACTIONS(3821),
    [sym_true] = ACTIONS(2750),
    [sym_false] = ACTIONS(2750),
    [sym_null] = ACTIONS(2750),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(3825),
    [anon_sym_delete] = ACTIONS(3827),
    [sym_nullptr] = ACTIONS(2750),
  },
  [2184] = {
    [sym__expression] = STATE(2470),
    [sym_conditional_expression] = STATE(2470),
    [sym_assignment_expression] = STATE(2470),
    [sym_pointer_expression] = STATE(2470),
    [sym_logical_expression] = STATE(2470),
    [sym_bitwise_expression] = STATE(2470),
    [sym_equality_expression] = STATE(2470),
    [sym_relational_expression] = STATE(2470),
    [sym_shift_expression] = STATE(2470),
    [sym_math_expression] = STATE(2470),
    [sym_cast_expression] = STATE(2470),
    [sym_sizeof_expression] = STATE(2470),
    [sym_subscript_expression] = STATE(2470),
    [sym_call_expression] = STATE(2470),
    [sym_field_expression] = STATE(2470),
    [sym_compound_literal_expression] = STATE(2470),
    [sym_parenthesized_expression] = STATE(2470),
    [sym_concatenated_string] = STATE(2470),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(2470),
    [sym_new_expression] = STATE(2470),
    [sym_delete_expression] = STATE(2470),
    [sym_lambda_expression] = STATE(2470),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(5840),
    [anon_sym_LPAREN] = ACTIONS(3807),
    [anon_sym_STAR] = ACTIONS(3809),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_AMP] = ACTIONS(3809),
    [anon_sym_BANG] = ACTIONS(3811),
    [anon_sym_TILDE] = ACTIONS(3813),
    [anon_sym_PLUS] = ACTIONS(3815),
    [anon_sym_DASH] = ACTIONS(3815),
    [anon_sym_DASH_DASH] = ACTIONS(3817),
    [anon_sym_PLUS_PLUS] = ACTIONS(3817),
    [anon_sym_sizeof] = ACTIONS(3819),
    [sym_number_literal] = ACTIONS(5840),
    [sym_char_literal] = ACTIONS(5840),
    [sym_string_literal] = ACTIONS(3821),
    [sym_true] = ACTIONS(5842),
    [sym_false] = ACTIONS(5842),
    [sym_null] = ACTIONS(5842),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(3825),
    [anon_sym_delete] = ACTIONS(3827),
    [sym_nullptr] = ACTIONS(5842),
  },
  [2185] = {
    [sym__expression] = STATE(2471),
    [sym_conditional_expression] = STATE(2471),
    [sym_assignment_expression] = STATE(2471),
    [sym_pointer_expression] = STATE(2471),
    [sym_logical_expression] = STATE(2471),
    [sym_bitwise_expression] = STATE(2471),
    [sym_equality_expression] = STATE(2471),
    [sym_relational_expression] = STATE(2471),
    [sym_shift_expression] = STATE(2471),
    [sym_math_expression] = STATE(2471),
    [sym_cast_expression] = STATE(2471),
    [sym_sizeof_expression] = STATE(2471),
    [sym_subscript_expression] = STATE(2471),
    [sym_call_expression] = STATE(2471),
    [sym_field_expression] = STATE(2471),
    [sym_compound_literal_expression] = STATE(2471),
    [sym_parenthesized_expression] = STATE(2471),
    [sym_concatenated_string] = STATE(2471),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(2471),
    [sym_new_expression] = STATE(2471),
    [sym_delete_expression] = STATE(2471),
    [sym_lambda_expression] = STATE(2471),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(855),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(5844),
    [anon_sym_LPAREN] = ACTIONS(1634),
    [anon_sym_STAR] = ACTIONS(1636),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_AMP] = ACTIONS(1636),
    [anon_sym_BANG] = ACTIONS(1638),
    [anon_sym_TILDE] = ACTIONS(1640),
    [anon_sym_PLUS] = ACTIONS(1642),
    [anon_sym_DASH] = ACTIONS(1642),
    [anon_sym_DASH_DASH] = ACTIONS(1644),
    [anon_sym_PLUS_PLUS] = ACTIONS(1644),
    [anon_sym_sizeof] = ACTIONS(1646),
    [sym_number_literal] = ACTIONS(5844),
    [sym_char_literal] = ACTIONS(5844),
    [sym_string_literal] = ACTIONS(1648),
    [sym_true] = ACTIONS(5846),
    [sym_false] = ACTIONS(5846),
    [sym_null] = ACTIONS(5846),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1652),
    [anon_sym_delete] = ACTIONS(1654),
    [sym_nullptr] = ACTIONS(5846),
  },
  [2186] = {
    [sym__expression] = STATE(2472),
    [sym_conditional_expression] = STATE(2472),
    [sym_assignment_expression] = STATE(2472),
    [sym_pointer_expression] = STATE(2472),
    [sym_logical_expression] = STATE(2472),
    [sym_bitwise_expression] = STATE(2472),
    [sym_equality_expression] = STATE(2472),
    [sym_relational_expression] = STATE(2472),
    [sym_shift_expression] = STATE(2472),
    [sym_math_expression] = STATE(2472),
    [sym_cast_expression] = STATE(2472),
    [sym_sizeof_expression] = STATE(2472),
    [sym_subscript_expression] = STATE(2472),
    [sym_call_expression] = STATE(2472),
    [sym_field_expression] = STATE(2472),
    [sym_compound_literal_expression] = STATE(2472),
    [sym_parenthesized_expression] = STATE(2472),
    [sym_concatenated_string] = STATE(2472),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(2472),
    [sym_new_expression] = STATE(2472),
    [sym_delete_expression] = STATE(2472),
    [sym_lambda_expression] = STATE(2472),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(5848),
    [anon_sym_LPAREN] = ACTIONS(3807),
    [anon_sym_STAR] = ACTIONS(3809),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_AMP] = ACTIONS(3809),
    [anon_sym_BANG] = ACTIONS(3811),
    [anon_sym_TILDE] = ACTIONS(3813),
    [anon_sym_PLUS] = ACTIONS(3815),
    [anon_sym_DASH] = ACTIONS(3815),
    [anon_sym_DASH_DASH] = ACTIONS(3817),
    [anon_sym_PLUS_PLUS] = ACTIONS(3817),
    [anon_sym_sizeof] = ACTIONS(3819),
    [sym_number_literal] = ACTIONS(5848),
    [sym_char_literal] = ACTIONS(5848),
    [sym_string_literal] = ACTIONS(3821),
    [sym_true] = ACTIONS(5850),
    [sym_false] = ACTIONS(5850),
    [sym_null] = ACTIONS(5850),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(3825),
    [anon_sym_delete] = ACTIONS(3827),
    [sym_nullptr] = ACTIONS(5850),
  },
  [2187] = {
    [sym__expression] = STATE(2473),
    [sym_conditional_expression] = STATE(2473),
    [sym_assignment_expression] = STATE(2473),
    [sym_pointer_expression] = STATE(2473),
    [sym_logical_expression] = STATE(2473),
    [sym_bitwise_expression] = STATE(2473),
    [sym_equality_expression] = STATE(2473),
    [sym_relational_expression] = STATE(2473),
    [sym_shift_expression] = STATE(2473),
    [sym_math_expression] = STATE(2473),
    [sym_cast_expression] = STATE(2473),
    [sym_sizeof_expression] = STATE(2473),
    [sym_subscript_expression] = STATE(2473),
    [sym_call_expression] = STATE(2473),
    [sym_field_expression] = STATE(2473),
    [sym_compound_literal_expression] = STATE(2473),
    [sym_parenthesized_expression] = STATE(2473),
    [sym_concatenated_string] = STATE(2473),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(2473),
    [sym_new_expression] = STATE(2473),
    [sym_delete_expression] = STATE(2473),
    [sym_lambda_expression] = STATE(2473),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(5852),
    [anon_sym_LPAREN] = ACTIONS(3807),
    [anon_sym_STAR] = ACTIONS(3809),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_AMP] = ACTIONS(3809),
    [anon_sym_BANG] = ACTIONS(3811),
    [anon_sym_TILDE] = ACTIONS(3813),
    [anon_sym_PLUS] = ACTIONS(3815),
    [anon_sym_DASH] = ACTIONS(3815),
    [anon_sym_DASH_DASH] = ACTIONS(3817),
    [anon_sym_PLUS_PLUS] = ACTIONS(3817),
    [anon_sym_sizeof] = ACTIONS(3819),
    [sym_number_literal] = ACTIONS(5852),
    [sym_char_literal] = ACTIONS(5852),
    [sym_string_literal] = ACTIONS(3821),
    [sym_true] = ACTIONS(5854),
    [sym_false] = ACTIONS(5854),
    [sym_null] = ACTIONS(5854),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(3825),
    [anon_sym_delete] = ACTIONS(3827),
    [sym_nullptr] = ACTIONS(5854),
  },
  [2188] = {
    [sym__expression] = STATE(2474),
    [sym_conditional_expression] = STATE(2474),
    [sym_assignment_expression] = STATE(2474),
    [sym_pointer_expression] = STATE(2474),
    [sym_logical_expression] = STATE(2474),
    [sym_bitwise_expression] = STATE(2474),
    [sym_equality_expression] = STATE(2474),
    [sym_relational_expression] = STATE(2474),
    [sym_shift_expression] = STATE(2474),
    [sym_math_expression] = STATE(2474),
    [sym_cast_expression] = STATE(2474),
    [sym_sizeof_expression] = STATE(2474),
    [sym_subscript_expression] = STATE(2474),
    [sym_call_expression] = STATE(2474),
    [sym_field_expression] = STATE(2474),
    [sym_compound_literal_expression] = STATE(2474),
    [sym_parenthesized_expression] = STATE(2474),
    [sym_concatenated_string] = STATE(2474),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(2474),
    [sym_new_expression] = STATE(2474),
    [sym_delete_expression] = STATE(2474),
    [sym_lambda_expression] = STATE(2474),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(5856),
    [anon_sym_LPAREN] = ACTIONS(3807),
    [anon_sym_STAR] = ACTIONS(3809),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_AMP] = ACTIONS(3809),
    [anon_sym_BANG] = ACTIONS(3811),
    [anon_sym_TILDE] = ACTIONS(3813),
    [anon_sym_PLUS] = ACTIONS(3815),
    [anon_sym_DASH] = ACTIONS(3815),
    [anon_sym_DASH_DASH] = ACTIONS(3817),
    [anon_sym_PLUS_PLUS] = ACTIONS(3817),
    [anon_sym_sizeof] = ACTIONS(3819),
    [sym_number_literal] = ACTIONS(5856),
    [sym_char_literal] = ACTIONS(5856),
    [sym_string_literal] = ACTIONS(3821),
    [sym_true] = ACTIONS(5858),
    [sym_false] = ACTIONS(5858),
    [sym_null] = ACTIONS(5858),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(3825),
    [anon_sym_delete] = ACTIONS(3827),
    [sym_nullptr] = ACTIONS(5858),
  },
  [2189] = {
    [sym__expression] = STATE(2475),
    [sym_conditional_expression] = STATE(2475),
    [sym_assignment_expression] = STATE(2475),
    [sym_pointer_expression] = STATE(2475),
    [sym_logical_expression] = STATE(2475),
    [sym_bitwise_expression] = STATE(2475),
    [sym_equality_expression] = STATE(2475),
    [sym_relational_expression] = STATE(2475),
    [sym_shift_expression] = STATE(2475),
    [sym_math_expression] = STATE(2475),
    [sym_cast_expression] = STATE(2475),
    [sym_sizeof_expression] = STATE(2475),
    [sym_subscript_expression] = STATE(2475),
    [sym_call_expression] = STATE(2475),
    [sym_field_expression] = STATE(2475),
    [sym_compound_literal_expression] = STATE(2475),
    [sym_parenthesized_expression] = STATE(2475),
    [sym_concatenated_string] = STATE(2475),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(2475),
    [sym_new_expression] = STATE(2475),
    [sym_delete_expression] = STATE(2475),
    [sym_lambda_expression] = STATE(2475),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(5860),
    [anon_sym_LPAREN] = ACTIONS(3807),
    [anon_sym_STAR] = ACTIONS(3809),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_AMP] = ACTIONS(3809),
    [anon_sym_BANG] = ACTIONS(3811),
    [anon_sym_TILDE] = ACTIONS(3813),
    [anon_sym_PLUS] = ACTIONS(3815),
    [anon_sym_DASH] = ACTIONS(3815),
    [anon_sym_DASH_DASH] = ACTIONS(3817),
    [anon_sym_PLUS_PLUS] = ACTIONS(3817),
    [anon_sym_sizeof] = ACTIONS(3819),
    [sym_number_literal] = ACTIONS(5860),
    [sym_char_literal] = ACTIONS(5860),
    [sym_string_literal] = ACTIONS(3821),
    [sym_true] = ACTIONS(5862),
    [sym_false] = ACTIONS(5862),
    [sym_null] = ACTIONS(5862),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(3825),
    [anon_sym_delete] = ACTIONS(3827),
    [sym_nullptr] = ACTIONS(5862),
  },
  [2190] = {
    [sym__expression] = STATE(2476),
    [sym_conditional_expression] = STATE(2476),
    [sym_assignment_expression] = STATE(2476),
    [sym_pointer_expression] = STATE(2476),
    [sym_logical_expression] = STATE(2476),
    [sym_bitwise_expression] = STATE(2476),
    [sym_equality_expression] = STATE(2476),
    [sym_relational_expression] = STATE(2476),
    [sym_shift_expression] = STATE(2476),
    [sym_math_expression] = STATE(2476),
    [sym_cast_expression] = STATE(2476),
    [sym_sizeof_expression] = STATE(2476),
    [sym_subscript_expression] = STATE(2476),
    [sym_call_expression] = STATE(2476),
    [sym_field_expression] = STATE(2476),
    [sym_compound_literal_expression] = STATE(2476),
    [sym_parenthesized_expression] = STATE(2476),
    [sym_concatenated_string] = STATE(2476),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(2476),
    [sym_new_expression] = STATE(2476),
    [sym_delete_expression] = STATE(2476),
    [sym_lambda_expression] = STATE(2476),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(5864),
    [anon_sym_LPAREN] = ACTIONS(3807),
    [anon_sym_STAR] = ACTIONS(3809),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_AMP] = ACTIONS(3809),
    [anon_sym_BANG] = ACTIONS(3811),
    [anon_sym_TILDE] = ACTIONS(3813),
    [anon_sym_PLUS] = ACTIONS(3815),
    [anon_sym_DASH] = ACTIONS(3815),
    [anon_sym_DASH_DASH] = ACTIONS(3817),
    [anon_sym_PLUS_PLUS] = ACTIONS(3817),
    [anon_sym_sizeof] = ACTIONS(3819),
    [sym_number_literal] = ACTIONS(5864),
    [sym_char_literal] = ACTIONS(5864),
    [sym_string_literal] = ACTIONS(3821),
    [sym_true] = ACTIONS(5866),
    [sym_false] = ACTIONS(5866),
    [sym_null] = ACTIONS(5866),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(3825),
    [anon_sym_delete] = ACTIONS(3827),
    [sym_nullptr] = ACTIONS(5866),
  },
  [2191] = {
    [sym__expression] = STATE(2477),
    [sym_conditional_expression] = STATE(2477),
    [sym_assignment_expression] = STATE(2477),
    [sym_pointer_expression] = STATE(2477),
    [sym_logical_expression] = STATE(2477),
    [sym_bitwise_expression] = STATE(2477),
    [sym_equality_expression] = STATE(2477),
    [sym_relational_expression] = STATE(2477),
    [sym_shift_expression] = STATE(2477),
    [sym_math_expression] = STATE(2477),
    [sym_cast_expression] = STATE(2477),
    [sym_sizeof_expression] = STATE(2477),
    [sym_subscript_expression] = STATE(2477),
    [sym_call_expression] = STATE(2477),
    [sym_field_expression] = STATE(2477),
    [sym_compound_literal_expression] = STATE(2477),
    [sym_parenthesized_expression] = STATE(2477),
    [sym_concatenated_string] = STATE(2477),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(2477),
    [sym_new_expression] = STATE(2477),
    [sym_delete_expression] = STATE(2477),
    [sym_lambda_expression] = STATE(2477),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(5868),
    [anon_sym_LPAREN] = ACTIONS(3807),
    [anon_sym_STAR] = ACTIONS(3809),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_AMP] = ACTIONS(3809),
    [anon_sym_BANG] = ACTIONS(3811),
    [anon_sym_TILDE] = ACTIONS(3813),
    [anon_sym_PLUS] = ACTIONS(3815),
    [anon_sym_DASH] = ACTIONS(3815),
    [anon_sym_DASH_DASH] = ACTIONS(3817),
    [anon_sym_PLUS_PLUS] = ACTIONS(3817),
    [anon_sym_sizeof] = ACTIONS(3819),
    [sym_number_literal] = ACTIONS(5868),
    [sym_char_literal] = ACTIONS(5868),
    [sym_string_literal] = ACTIONS(3821),
    [sym_true] = ACTIONS(5870),
    [sym_false] = ACTIONS(5870),
    [sym_null] = ACTIONS(5870),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(3825),
    [anon_sym_delete] = ACTIONS(3827),
    [sym_nullptr] = ACTIONS(5870),
  },
  [2192] = {
    [sym__expression] = STATE(2478),
    [sym_conditional_expression] = STATE(2478),
    [sym_assignment_expression] = STATE(2478),
    [sym_pointer_expression] = STATE(2478),
    [sym_logical_expression] = STATE(2478),
    [sym_bitwise_expression] = STATE(2478),
    [sym_equality_expression] = STATE(2478),
    [sym_relational_expression] = STATE(2478),
    [sym_shift_expression] = STATE(2478),
    [sym_math_expression] = STATE(2478),
    [sym_cast_expression] = STATE(2478),
    [sym_sizeof_expression] = STATE(2478),
    [sym_subscript_expression] = STATE(2478),
    [sym_call_expression] = STATE(2478),
    [sym_field_expression] = STATE(2478),
    [sym_compound_literal_expression] = STATE(2478),
    [sym_parenthesized_expression] = STATE(2478),
    [sym_concatenated_string] = STATE(2478),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(2478),
    [sym_new_expression] = STATE(2478),
    [sym_delete_expression] = STATE(2478),
    [sym_lambda_expression] = STATE(2478),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(5872),
    [anon_sym_LPAREN] = ACTIONS(3807),
    [anon_sym_STAR] = ACTIONS(3809),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_AMP] = ACTIONS(3809),
    [anon_sym_BANG] = ACTIONS(3811),
    [anon_sym_TILDE] = ACTIONS(3813),
    [anon_sym_PLUS] = ACTIONS(3815),
    [anon_sym_DASH] = ACTIONS(3815),
    [anon_sym_DASH_DASH] = ACTIONS(3817),
    [anon_sym_PLUS_PLUS] = ACTIONS(3817),
    [anon_sym_sizeof] = ACTIONS(3819),
    [sym_number_literal] = ACTIONS(5872),
    [sym_char_literal] = ACTIONS(5872),
    [sym_string_literal] = ACTIONS(3821),
    [sym_true] = ACTIONS(5874),
    [sym_false] = ACTIONS(5874),
    [sym_null] = ACTIONS(5874),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(3825),
    [anon_sym_delete] = ACTIONS(3827),
    [sym_nullptr] = ACTIONS(5874),
  },
  [2193] = {
    [sym__expression] = STATE(2479),
    [sym_conditional_expression] = STATE(2479),
    [sym_assignment_expression] = STATE(2479),
    [sym_pointer_expression] = STATE(2479),
    [sym_logical_expression] = STATE(2479),
    [sym_bitwise_expression] = STATE(2479),
    [sym_equality_expression] = STATE(2479),
    [sym_relational_expression] = STATE(2479),
    [sym_shift_expression] = STATE(2479),
    [sym_math_expression] = STATE(2479),
    [sym_cast_expression] = STATE(2479),
    [sym_sizeof_expression] = STATE(2479),
    [sym_subscript_expression] = STATE(2479),
    [sym_call_expression] = STATE(2479),
    [sym_field_expression] = STATE(2479),
    [sym_compound_literal_expression] = STATE(2479),
    [sym_parenthesized_expression] = STATE(2479),
    [sym_concatenated_string] = STATE(2479),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(2479),
    [sym_new_expression] = STATE(2479),
    [sym_delete_expression] = STATE(2479),
    [sym_lambda_expression] = STATE(2479),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(5876),
    [anon_sym_LPAREN] = ACTIONS(3807),
    [anon_sym_STAR] = ACTIONS(3809),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_AMP] = ACTIONS(3809),
    [anon_sym_BANG] = ACTIONS(3811),
    [anon_sym_TILDE] = ACTIONS(3813),
    [anon_sym_PLUS] = ACTIONS(3815),
    [anon_sym_DASH] = ACTIONS(3815),
    [anon_sym_DASH_DASH] = ACTIONS(3817),
    [anon_sym_PLUS_PLUS] = ACTIONS(3817),
    [anon_sym_sizeof] = ACTIONS(3819),
    [sym_number_literal] = ACTIONS(5876),
    [sym_char_literal] = ACTIONS(5876),
    [sym_string_literal] = ACTIONS(3821),
    [sym_true] = ACTIONS(5878),
    [sym_false] = ACTIONS(5878),
    [sym_null] = ACTIONS(5878),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(3825),
    [anon_sym_delete] = ACTIONS(3827),
    [sym_nullptr] = ACTIONS(5878),
  },
  [2194] = {
    [sym__expression] = STATE(2480),
    [sym_conditional_expression] = STATE(2480),
    [sym_assignment_expression] = STATE(2480),
    [sym_pointer_expression] = STATE(2480),
    [sym_logical_expression] = STATE(2480),
    [sym_bitwise_expression] = STATE(2480),
    [sym_equality_expression] = STATE(2480),
    [sym_relational_expression] = STATE(2480),
    [sym_shift_expression] = STATE(2480),
    [sym_math_expression] = STATE(2480),
    [sym_cast_expression] = STATE(2480),
    [sym_sizeof_expression] = STATE(2480),
    [sym_subscript_expression] = STATE(2480),
    [sym_call_expression] = STATE(2480),
    [sym_field_expression] = STATE(2480),
    [sym_compound_literal_expression] = STATE(2480),
    [sym_parenthesized_expression] = STATE(2480),
    [sym_concatenated_string] = STATE(2480),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(2480),
    [sym_new_expression] = STATE(2480),
    [sym_delete_expression] = STATE(2480),
    [sym_lambda_expression] = STATE(2480),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(5880),
    [anon_sym_LPAREN] = ACTIONS(3807),
    [anon_sym_STAR] = ACTIONS(3809),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_AMP] = ACTIONS(3809),
    [anon_sym_BANG] = ACTIONS(3811),
    [anon_sym_TILDE] = ACTIONS(3813),
    [anon_sym_PLUS] = ACTIONS(3815),
    [anon_sym_DASH] = ACTIONS(3815),
    [anon_sym_DASH_DASH] = ACTIONS(3817),
    [anon_sym_PLUS_PLUS] = ACTIONS(3817),
    [anon_sym_sizeof] = ACTIONS(3819),
    [sym_number_literal] = ACTIONS(5880),
    [sym_char_literal] = ACTIONS(5880),
    [sym_string_literal] = ACTIONS(3821),
    [sym_true] = ACTIONS(5882),
    [sym_false] = ACTIONS(5882),
    [sym_null] = ACTIONS(5882),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(3825),
    [anon_sym_delete] = ACTIONS(3827),
    [sym_nullptr] = ACTIONS(5882),
  },
  [2195] = {
    [sym__type_specifier] = STATE(1375),
    [sym_sized_type_specifier] = STATE(1375),
    [sym_enum_specifier] = STATE(1375),
    [sym_struct_specifier] = STATE(1375),
    [sym_union_specifier] = STATE(1375),
    [sym_macro_type_specifier] = STATE(1375),
    [sym_class_specifier] = STATE(1375),
    [sym_dependent_type] = STATE(1375),
    [sym_template_type] = STATE(825),
    [sym_scoped_type_identifier] = STATE(826),
    [sym_scoped_namespace_identifier] = STATE(827),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2197),
    [anon_sym_unsigned] = ACTIONS(5067),
    [anon_sym_long] = ACTIONS(5067),
    [anon_sym_short] = ACTIONS(5067),
    [sym_primitive_type] = ACTIONS(2837),
    [anon_sym_enum] = ACTIONS(1582),
    [anon_sym_struct] = ACTIONS(2468),
    [anon_sym_union] = ACTIONS(2470),
    [sym_identifier] = ACTIONS(1588),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(2472),
    [sym_auto] = ACTIONS(2837),
    [anon_sym_typename] = ACTIONS(5071),
    [anon_sym_COLON_COLON] = ACTIONS(1594),
  },
  [2196] = {
    [sym__abstract_declarator] = STATE(2483),
    [sym_abstract_pointer_declarator] = STATE(2483),
    [sym_abstract_function_declarator] = STATE(2483),
    [sym_abstract_array_declarator] = STATE(2483),
    [sym_parameter_list] = STATE(2484),
    [sym_abstract_reference_declarator] = STATE(2483),
    [anon_sym_LPAREN] = ACTIONS(1115),
    [anon_sym_COMMA] = ACTIONS(2841),
    [anon_sym_LBRACE] = ACTIONS(2841),
    [anon_sym_STAR] = ACTIONS(5884),
    [anon_sym_LBRACK] = ACTIONS(1121),
    [anon_sym_EQ] = ACTIONS(2841),
    [anon_sym_const] = ACTIONS(2845),
    [anon_sym_restrict] = ACTIONS(2841),
    [anon_sym_volatile] = ACTIONS(2841),
    [anon_sym__Atomic] = ACTIONS(2841),
    [anon_sym_mutable] = ACTIONS(2841),
    [anon_sym_explicit] = ACTIONS(2841),
    [anon_sym_constexpr] = ACTIONS(2841),
    [anon_sym_AMP] = ACTIONS(5886),
    [anon_sym_AMP_AMP] = ACTIONS(5888),
    [anon_sym_GT] = ACTIONS(2841),
    [anon_sym_DASH_GT] = ACTIONS(2841),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(2841),
  },
  [2197] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2485),
    [anon_sym_LPAREN] = ACTIONS(238),
    [anon_sym_COMMA] = ACTIONS(238),
    [anon_sym_LBRACE] = ACTIONS(238),
    [anon_sym_STAR] = ACTIONS(238),
    [anon_sym_LBRACK] = ACTIONS(238),
    [anon_sym_EQ] = ACTIONS(238),
    [anon_sym_const] = ACTIONS(240),
    [anon_sym_restrict] = ACTIONS(240),
    [anon_sym_volatile] = ACTIONS(240),
    [anon_sym__Atomic] = ACTIONS(240),
    [anon_sym_mutable] = ACTIONS(240),
    [anon_sym_explicit] = ACTIONS(240),
    [anon_sym_constexpr] = ACTIONS(240),
    [anon_sym_unsigned] = ACTIONS(5890),
    [anon_sym_long] = ACTIONS(5890),
    [anon_sym_short] = ACTIONS(5890),
    [sym_primitive_type] = ACTIONS(2855),
    [anon_sym_AMP] = ACTIONS(240),
    [anon_sym_AMP_AMP] = ACTIONS(238),
    [anon_sym_GT] = ACTIONS(238),
    [anon_sym_DASH_GT] = ACTIONS(238),
    [sym_identifier] = ACTIONS(2857),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(240),
  },
  [2198] = {
    [sym_type_qualifier] = STATE(2198),
    [sym_trailing_return_type] = STATE(2198),
    [aux_sym_function_declarator_repeat1] = STATE(2198),
    [anon_sym_LPAREN] = ACTIONS(2859),
    [anon_sym_COMMA] = ACTIONS(2859),
    [anon_sym_LBRACE] = ACTIONS(2859),
    [anon_sym_LBRACK] = ACTIONS(2859),
    [anon_sym_EQ] = ACTIONS(2859),
    [anon_sym_const] = ACTIONS(2861),
    [anon_sym_restrict] = ACTIONS(2864),
    [anon_sym_volatile] = ACTIONS(2864),
    [anon_sym__Atomic] = ACTIONS(2864),
    [anon_sym_mutable] = ACTIONS(2864),
    [anon_sym_explicit] = ACTIONS(2864),
    [anon_sym_constexpr] = ACTIONS(2864),
    [anon_sym_GT] = ACTIONS(2859),
    [anon_sym_DASH_GT] = ACTIONS(5892),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(5895),
  },
  [2199] = {
    [sym_parameter_list] = STATE(2201),
    [anon_sym_LPAREN] = ACTIONS(206),
    [anon_sym_SEMI] = ACTIONS(3750),
    [anon_sym_LBRACK] = ACTIONS(2282),
    [anon_sym_const] = ACTIONS(5283),
    [anon_sym_restrict] = ACTIONS(3750),
    [anon_sym_volatile] = ACTIONS(3750),
    [anon_sym__Atomic] = ACTIONS(3750),
    [anon_sym_mutable] = ACTIONS(3750),
    [anon_sym_explicit] = ACTIONS(3750),
    [anon_sym_constexpr] = ACTIONS(3750),
    [anon_sym_DASH_GT] = ACTIONS(3750),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(3750),
  },
  [2200] = {
    [sym_parameter_list] = STATE(2201),
    [anon_sym_LPAREN] = ACTIONS(206),
    [anon_sym_SEMI] = ACTIONS(3762),
    [anon_sym_LBRACK] = ACTIONS(2282),
    [anon_sym_const] = ACTIONS(5285),
    [anon_sym_restrict] = ACTIONS(3762),
    [anon_sym_volatile] = ACTIONS(3762),
    [anon_sym__Atomic] = ACTIONS(3762),
    [anon_sym_mutable] = ACTIONS(3762),
    [anon_sym_explicit] = ACTIONS(3762),
    [anon_sym_constexpr] = ACTIONS(3762),
    [anon_sym_DASH_GT] = ACTIONS(3762),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(3762),
  },
  [2201] = {
    [sym_type_qualifier] = STATE(2486),
    [sym_trailing_return_type] = STATE(1713),
    [aux_sym_abstract_function_declarator_repeat1] = STATE(2486),
    [anon_sym_LPAREN] = ACTIONS(3764),
    [anon_sym_SEMI] = ACTIONS(3764),
    [anon_sym_LBRACK] = ACTIONS(3764),
    [anon_sym_const] = ACTIONS(3770),
    [anon_sym_restrict] = ACTIONS(3764),
    [anon_sym_volatile] = ACTIONS(3764),
    [anon_sym__Atomic] = ACTIONS(3764),
    [anon_sym_mutable] = ACTIONS(3764),
    [anon_sym_explicit] = ACTIONS(3764),
    [anon_sym_constexpr] = ACTIONS(3764),
    [anon_sym_DASH_GT] = ACTIONS(3764),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(3764),
  },
  [2202] = {
    [sym_type_qualifier] = STATE(2205),
    [sym_trailing_return_type] = STATE(1713),
    [aux_sym_abstract_function_declarator_repeat1] = STATE(2205),
    [anon_sym_LPAREN] = ACTIONS(3764),
    [anon_sym_SEMI] = ACTIONS(3764),
    [anon_sym_LBRACK] = ACTIONS(3764),
    [anon_sym_const] = ACTIONS(612),
    [anon_sym_restrict] = ACTIONS(614),
    [anon_sym_volatile] = ACTIONS(614),
    [anon_sym__Atomic] = ACTIONS(614),
    [anon_sym_mutable] = ACTIONS(614),
    [anon_sym_explicit] = ACTIONS(614),
    [anon_sym_constexpr] = ACTIONS(614),
    [anon_sym_DASH_GT] = ACTIONS(1194),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(5082),
  },
  [2203] = {
    [sym_type_qualifier] = STATE(2205),
    [sym_trailing_return_type] = STATE(2168),
    [aux_sym_abstract_function_declarator_repeat1] = STATE(2205),
    [anon_sym_LPAREN] = ACTIONS(4998),
    [anon_sym_SEMI] = ACTIONS(4998),
    [anon_sym_LBRACK] = ACTIONS(4998),
    [anon_sym_const] = ACTIONS(612),
    [anon_sym_restrict] = ACTIONS(614),
    [anon_sym_volatile] = ACTIONS(614),
    [anon_sym__Atomic] = ACTIONS(614),
    [anon_sym_mutable] = ACTIONS(614),
    [anon_sym_explicit] = ACTIONS(614),
    [anon_sym_constexpr] = ACTIONS(614),
    [anon_sym_DASH_GT] = ACTIONS(3858),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(5082),
  },
  [2204] = {
    [sym__abstract_declarator] = STATE(2487),
    [sym_abstract_pointer_declarator] = STATE(2487),
    [sym_abstract_function_declarator] = STATE(2487),
    [sym_abstract_array_declarator] = STATE(2487),
    [sym_parameter_list] = STATE(1162),
    [sym_abstract_reference_declarator] = STATE(2487),
    [anon_sym_LPAREN] = ACTIONS(1115),
    [anon_sym_SEMI] = ACTIONS(2841),
    [anon_sym_STAR] = ACTIONS(2359),
    [anon_sym_LBRACK] = ACTIONS(1121),
    [anon_sym_AMP] = ACTIONS(2361),
    [anon_sym_AMP_AMP] = ACTIONS(2363),
    [sym_comment] = ACTIONS(49),
  },
  [2205] = {
    [sym_type_qualifier] = STATE(2205),
    [aux_sym_abstract_function_declarator_repeat1] = STATE(2205),
    [anon_sym_LPAREN] = ACTIONS(5002),
    [anon_sym_SEMI] = ACTIONS(5002),
    [anon_sym_LBRACK] = ACTIONS(5002),
    [anon_sym_const] = ACTIONS(5004),
    [anon_sym_restrict] = ACTIONS(5007),
    [anon_sym_volatile] = ACTIONS(5007),
    [anon_sym__Atomic] = ACTIONS(5007),
    [anon_sym_mutable] = ACTIONS(5007),
    [anon_sym_explicit] = ACTIONS(5007),
    [anon_sym_constexpr] = ACTIONS(5007),
    [anon_sym_DASH_GT] = ACTIONS(5002),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(5898),
  },
  [2206] = {
    [sym__expression] = STATE(1834),
    [sym_conditional_expression] = STATE(1834),
    [sym_assignment_expression] = STATE(1834),
    [sym_pointer_expression] = STATE(1834),
    [sym_logical_expression] = STATE(1834),
    [sym_bitwise_expression] = STATE(1834),
    [sym_equality_expression] = STATE(1834),
    [sym_relational_expression] = STATE(1834),
    [sym_shift_expression] = STATE(1834),
    [sym_math_expression] = STATE(1834),
    [sym_cast_expression] = STATE(1834),
    [sym_sizeof_expression] = STATE(1834),
    [sym_subscript_expression] = STATE(1834),
    [sym_call_expression] = STATE(1834),
    [sym_field_expression] = STATE(1834),
    [sym_compound_literal_expression] = STATE(1834),
    [sym_parenthesized_expression] = STATE(1834),
    [sym_initializer_list] = STATE(1835),
    [sym_concatenated_string] = STATE(1834),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(1834),
    [sym_new_expression] = STATE(1834),
    [sym_delete_expression] = STATE(1834),
    [sym_lambda_expression] = STATE(1834),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(4145),
    [anon_sym_LPAREN] = ACTIONS(1267),
    [anon_sym_COMMA] = ACTIONS(5210),
    [anon_sym_SEMI] = ACTIONS(5210),
    [anon_sym_LBRACE] = ACTIONS(548),
    [anon_sym_RBRACE] = ACTIONS(5210),
    [anon_sym_STAR] = ACTIONS(5901),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_EQ] = ACTIONS(5212),
    [anon_sym_QMARK] = ACTIONS(5210),
    [anon_sym_STAR_EQ] = ACTIONS(5210),
    [anon_sym_SLASH_EQ] = ACTIONS(5210),
    [anon_sym_PERCENT_EQ] = ACTIONS(5210),
    [anon_sym_PLUS_EQ] = ACTIONS(5210),
    [anon_sym_DASH_EQ] = ACTIONS(5210),
    [anon_sym_LT_LT_EQ] = ACTIONS(5210),
    [anon_sym_GT_GT_EQ] = ACTIONS(5210),
    [anon_sym_AMP_EQ] = ACTIONS(5210),
    [anon_sym_CARET_EQ] = ACTIONS(5210),
    [anon_sym_PIPE_EQ] = ACTIONS(5210),
    [anon_sym_AMP] = ACTIONS(5901),
    [anon_sym_PIPE_PIPE] = ACTIONS(5210),
    [anon_sym_AMP_AMP] = ACTIONS(5210),
    [anon_sym_BANG] = ACTIONS(5903),
    [anon_sym_PIPE] = ACTIONS(5212),
    [anon_sym_CARET] = ACTIONS(5212),
    [anon_sym_TILDE] = ACTIONS(1281),
    [anon_sym_EQ_EQ] = ACTIONS(5210),
    [anon_sym_BANG_EQ] = ACTIONS(5210),
    [anon_sym_LT] = ACTIONS(5212),
    [anon_sym_GT] = ACTIONS(5212),
    [anon_sym_LT_EQ] = ACTIONS(5210),
    [anon_sym_GT_EQ] = ACTIONS(5210),
    [anon_sym_LT_LT] = ACTIONS(5212),
    [anon_sym_GT_GT] = ACTIONS(5212),
    [anon_sym_PLUS] = ACTIONS(1283),
    [anon_sym_DASH] = ACTIONS(1283),
    [anon_sym_SLASH] = ACTIONS(5212),
    [anon_sym_PERCENT] = ACTIONS(5212),
    [anon_sym_DASH_DASH] = ACTIONS(1285),
    [anon_sym_PLUS_PLUS] = ACTIONS(1285),
    [anon_sym_sizeof] = ACTIONS(1287),
    [anon_sym_DOT] = ACTIONS(5210),
    [anon_sym_DASH_GT] = ACTIONS(5210),
    [sym_number_literal] = ACTIONS(4145),
    [sym_char_literal] = ACTIONS(4145),
    [sym_string_literal] = ACTIONS(1291),
    [sym_true] = ACTIONS(4147),
    [sym_false] = ACTIONS(4147),
    [sym_null] = ACTIONS(4147),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(2402),
    [anon_sym_delete] = ACTIONS(1297),
    [sym_nullptr] = ACTIONS(4147),
  },
  [2207] = {
    [sym__expression] = STATE(2488),
    [sym_conditional_expression] = STATE(2488),
    [sym_assignment_expression] = STATE(2488),
    [sym_pointer_expression] = STATE(2488),
    [sym_logical_expression] = STATE(2488),
    [sym_bitwise_expression] = STATE(2488),
    [sym_equality_expression] = STATE(2488),
    [sym_relational_expression] = STATE(2488),
    [sym_shift_expression] = STATE(2488),
    [sym_math_expression] = STATE(2488),
    [sym_cast_expression] = STATE(2488),
    [sym_sizeof_expression] = STATE(2488),
    [sym_subscript_expression] = STATE(2488),
    [sym_call_expression] = STATE(2488),
    [sym_field_expression] = STATE(2488),
    [sym_compound_literal_expression] = STATE(2488),
    [sym_parenthesized_expression] = STATE(2488),
    [sym_concatenated_string] = STATE(2488),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(2488),
    [sym_new_expression] = STATE(2488),
    [sym_delete_expression] = STATE(2488),
    [sym_lambda_expression] = STATE(2488),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(5905),
    [anon_sym_LPAREN] = ACTIONS(2624),
    [anon_sym_STAR] = ACTIONS(2624),
    [anon_sym_LBRACK] = ACTIONS(2624),
    [anon_sym_AMP] = ACTIONS(2626),
    [anon_sym_AMP_AMP] = ACTIONS(2624),
    [anon_sym_BANG] = ACTIONS(1279),
    [anon_sym_TILDE] = ACTIONS(1281),
    [anon_sym_PLUS] = ACTIONS(1283),
    [anon_sym_DASH] = ACTIONS(1283),
    [anon_sym_DASH_DASH] = ACTIONS(1285),
    [anon_sym_PLUS_PLUS] = ACTIONS(1285),
    [anon_sym_sizeof] = ACTIONS(1287),
    [sym_number_literal] = ACTIONS(5905),
    [sym_char_literal] = ACTIONS(5905),
    [sym_string_literal] = ACTIONS(1291),
    [sym_true] = ACTIONS(5907),
    [sym_false] = ACTIONS(5907),
    [sym_null] = ACTIONS(5907),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(2402),
    [anon_sym_delete] = ACTIONS(1297),
    [sym_nullptr] = ACTIONS(5907),
  },
  [2208] = {
    [sym_argument_list] = STATE(802),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_COMMA] = ACTIONS(5236),
    [anon_sym_SEMI] = ACTIONS(5236),
    [anon_sym_RBRACE] = ACTIONS(5236),
    [anon_sym_STAR] = ACTIONS(2428),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_EQ] = ACTIONS(5238),
    [anon_sym_QMARK] = ACTIONS(5236),
    [anon_sym_STAR_EQ] = ACTIONS(5236),
    [anon_sym_SLASH_EQ] = ACTIONS(5236),
    [anon_sym_PERCENT_EQ] = ACTIONS(5236),
    [anon_sym_PLUS_EQ] = ACTIONS(5236),
    [anon_sym_DASH_EQ] = ACTIONS(5236),
    [anon_sym_LT_LT_EQ] = ACTIONS(5236),
    [anon_sym_GT_GT_EQ] = ACTIONS(5236),
    [anon_sym_AMP_EQ] = ACTIONS(5236),
    [anon_sym_CARET_EQ] = ACTIONS(5236),
    [anon_sym_PIPE_EQ] = ACTIONS(5236),
    [anon_sym_AMP] = ACTIONS(2436),
    [anon_sym_PIPE_PIPE] = ACTIONS(2438),
    [anon_sym_AMP_AMP] = ACTIONS(2440),
    [anon_sym_PIPE] = ACTIONS(2442),
    [anon_sym_CARET] = ACTIONS(2444),
    [anon_sym_EQ_EQ] = ACTIONS(2446),
    [anon_sym_BANG_EQ] = ACTIONS(2446),
    [anon_sym_LT] = ACTIONS(2448),
    [anon_sym_GT] = ACTIONS(2448),
    [anon_sym_LT_EQ] = ACTIONS(2450),
    [anon_sym_GT_EQ] = ACTIONS(2450),
    [anon_sym_LT_LT] = ACTIONS(2452),
    [anon_sym_GT_GT] = ACTIONS(2452),
    [anon_sym_PLUS] = ACTIONS(2454),
    [anon_sym_DASH] = ACTIONS(2454),
    [anon_sym_SLASH] = ACTIONS(2428),
    [anon_sym_PERCENT] = ACTIONS(2428),
    [anon_sym_DASH_DASH] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(1554),
    [anon_sym_DASH_GT] = ACTIONS(1554),
    [sym_comment] = ACTIONS(49),
  },
  [2209] = {
    [sym__expression] = STATE(2489),
    [sym_conditional_expression] = STATE(2489),
    [sym_assignment_expression] = STATE(2489),
    [sym_pointer_expression] = STATE(2489),
    [sym_logical_expression] = STATE(2489),
    [sym_bitwise_expression] = STATE(2489),
    [sym_equality_expression] = STATE(2489),
    [sym_relational_expression] = STATE(2489),
    [sym_shift_expression] = STATE(2489),
    [sym_math_expression] = STATE(2489),
    [sym_cast_expression] = STATE(2489),
    [sym_sizeof_expression] = STATE(2489),
    [sym_subscript_expression] = STATE(2489),
    [sym_call_expression] = STATE(2489),
    [sym_field_expression] = STATE(2489),
    [sym_compound_literal_expression] = STATE(2489),
    [sym_parenthesized_expression] = STATE(2489),
    [sym_concatenated_string] = STATE(2489),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(2489),
    [sym_new_expression] = STATE(2489),
    [sym_delete_expression] = STATE(2489),
    [sym_lambda_expression] = STATE(2489),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(5909),
    [anon_sym_LPAREN] = ACTIONS(1267),
    [anon_sym_STAR] = ACTIONS(1275),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_AMP] = ACTIONS(1275),
    [anon_sym_BANG] = ACTIONS(1279),
    [anon_sym_TILDE] = ACTIONS(1281),
    [anon_sym_PLUS] = ACTIONS(1283),
    [anon_sym_DASH] = ACTIONS(1283),
    [anon_sym_DASH_DASH] = ACTIONS(1285),
    [anon_sym_PLUS_PLUS] = ACTIONS(1285),
    [anon_sym_sizeof] = ACTIONS(1287),
    [sym_number_literal] = ACTIONS(5909),
    [sym_char_literal] = ACTIONS(5909),
    [sym_string_literal] = ACTIONS(1291),
    [sym_true] = ACTIONS(5911),
    [sym_false] = ACTIONS(5911),
    [sym_null] = ACTIONS(5911),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(2402),
    [anon_sym_delete] = ACTIONS(1297),
    [sym_nullptr] = ACTIONS(5911),
  },
  [2210] = {
    [anon_sym_LPAREN] = ACTIONS(5913),
    [anon_sym_COMMA] = ACTIONS(5913),
    [anon_sym_RPAREN] = ACTIONS(5913),
    [anon_sym_SEMI] = ACTIONS(5913),
    [anon_sym_LBRACE] = ACTIONS(5913),
    [anon_sym_RBRACE] = ACTIONS(5913),
    [anon_sym_STAR] = ACTIONS(5915),
    [anon_sym_LBRACK] = ACTIONS(5913),
    [anon_sym_RBRACK] = ACTIONS(5913),
    [anon_sym_EQ] = ACTIONS(5915),
    [anon_sym_COLON] = ACTIONS(5913),
    [anon_sym_QMARK] = ACTIONS(5913),
    [anon_sym_STAR_EQ] = ACTIONS(5913),
    [anon_sym_SLASH_EQ] = ACTIONS(5913),
    [anon_sym_PERCENT_EQ] = ACTIONS(5913),
    [anon_sym_PLUS_EQ] = ACTIONS(5913),
    [anon_sym_DASH_EQ] = ACTIONS(5913),
    [anon_sym_LT_LT_EQ] = ACTIONS(5913),
    [anon_sym_GT_GT_EQ] = ACTIONS(5913),
    [anon_sym_AMP_EQ] = ACTIONS(5913),
    [anon_sym_CARET_EQ] = ACTIONS(5913),
    [anon_sym_PIPE_EQ] = ACTIONS(5913),
    [anon_sym_AMP] = ACTIONS(5915),
    [anon_sym_PIPE_PIPE] = ACTIONS(5913),
    [anon_sym_AMP_AMP] = ACTIONS(5913),
    [anon_sym_PIPE] = ACTIONS(5915),
    [anon_sym_CARET] = ACTIONS(5915),
    [anon_sym_EQ_EQ] = ACTIONS(5913),
    [anon_sym_BANG_EQ] = ACTIONS(5913),
    [anon_sym_LT] = ACTIONS(5915),
    [anon_sym_GT] = ACTIONS(5915),
    [anon_sym_LT_EQ] = ACTIONS(5913),
    [anon_sym_GT_EQ] = ACTIONS(5913),
    [anon_sym_LT_LT] = ACTIONS(5915),
    [anon_sym_GT_GT] = ACTIONS(5915),
    [anon_sym_PLUS] = ACTIONS(5915),
    [anon_sym_DASH] = ACTIONS(5915),
    [anon_sym_SLASH] = ACTIONS(5915),
    [anon_sym_PERCENT] = ACTIONS(5915),
    [anon_sym_DASH_DASH] = ACTIONS(5913),
    [anon_sym_PLUS_PLUS] = ACTIONS(5913),
    [anon_sym_DOT] = ACTIONS(5913),
    [anon_sym_DASH_GT] = ACTIONS(5913),
    [sym_comment] = ACTIONS(49),
  },
  [2211] = {
    [sym__expression] = STATE(1780),
    [sym_conditional_expression] = STATE(1780),
    [sym_assignment_expression] = STATE(1780),
    [sym_pointer_expression] = STATE(1780),
    [sym_logical_expression] = STATE(1780),
    [sym_bitwise_expression] = STATE(1780),
    [sym_equality_expression] = STATE(1780),
    [sym_relational_expression] = STATE(1780),
    [sym_shift_expression] = STATE(1780),
    [sym_math_expression] = STATE(1780),
    [sym_cast_expression] = STATE(1780),
    [sym_sizeof_expression] = STATE(1780),
    [sym_subscript_expression] = STATE(1780),
    [sym_call_expression] = STATE(1780),
    [sym_field_expression] = STATE(1780),
    [sym_compound_literal_expression] = STATE(1780),
    [sym_parenthesized_expression] = STATE(1780),
    [sym_initializer_list] = STATE(1766),
    [sym_initializer_pair] = STATE(1766),
    [sym_subscript_designator] = STATE(671),
    [sym_field_designator] = STATE(671),
    [sym_concatenated_string] = STATE(1780),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(1780),
    [sym_new_expression] = STATE(1780),
    [sym_delete_expression] = STATE(1780),
    [sym_lambda_expression] = STATE(1780),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [aux_sym_initializer_pair_repeat1] = STATE(671),
    [sym_raw_string_literal] = ACTIONS(3962),
    [anon_sym_LPAREN] = ACTIONS(1321),
    [anon_sym_LBRACE] = ACTIONS(548),
    [anon_sym_STAR] = ACTIONS(1325),
    [anon_sym_LBRACK] = ACTIONS(1277),
    [anon_sym_AMP] = ACTIONS(1325),
    [anon_sym_BANG] = ACTIONS(1327),
    [anon_sym_TILDE] = ACTIONS(1329),
    [anon_sym_PLUS] = ACTIONS(1331),
    [anon_sym_DASH] = ACTIONS(1331),
    [anon_sym_DASH_DASH] = ACTIONS(1333),
    [anon_sym_PLUS_PLUS] = ACTIONS(1333),
    [anon_sym_sizeof] = ACTIONS(1335),
    [anon_sym_DOT] = ACTIONS(1289),
    [sym_number_literal] = ACTIONS(3962),
    [sym_char_literal] = ACTIONS(3962),
    [sym_string_literal] = ACTIONS(1337),
    [sym_true] = ACTIONS(3964),
    [sym_false] = ACTIONS(3964),
    [sym_null] = ACTIONS(3964),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1341),
    [anon_sym_delete] = ACTIONS(1343),
    [sym_nullptr] = ACTIONS(3964),
  },
  [2212] = {
    [anon_sym_LBRACK] = ACTIONS(5093),
    [anon_sym_EQ] = ACTIONS(5093),
    [anon_sym_DOT] = ACTIONS(5093),
    [sym_comment] = ACTIONS(49),
  },
  [2213] = {
    [sym_parameter_list] = STATE(2215),
    [anon_sym_LPAREN] = ACTIONS(206),
    [anon_sym_COMMA] = ACTIONS(3750),
    [anon_sym_SEMI] = ACTIONS(3750),
    [anon_sym_LBRACE] = ACTIONS(3750),
    [anon_sym_LBRACK] = ACTIONS(2282),
    [anon_sym_EQ] = ACTIONS(3750),
    [anon_sym_const] = ACTIONS(5283),
    [anon_sym_restrict] = ACTIONS(3750),
    [anon_sym_volatile] = ACTIONS(3750),
    [anon_sym__Atomic] = ACTIONS(3750),
    [anon_sym_mutable] = ACTIONS(3750),
    [anon_sym_explicit] = ACTIONS(3750),
    [anon_sym_constexpr] = ACTIONS(3750),
    [anon_sym_DASH_GT] = ACTIONS(3750),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(3750),
  },
  [2214] = {
    [sym_parameter_list] = STATE(2215),
    [anon_sym_LPAREN] = ACTIONS(206),
    [anon_sym_COMMA] = ACTIONS(3762),
    [anon_sym_SEMI] = ACTIONS(3762),
    [anon_sym_LBRACE] = ACTIONS(3762),
    [anon_sym_LBRACK] = ACTIONS(2282),
    [anon_sym_EQ] = ACTIONS(3762),
    [anon_sym_const] = ACTIONS(5285),
    [anon_sym_restrict] = ACTIONS(3762),
    [anon_sym_volatile] = ACTIONS(3762),
    [anon_sym__Atomic] = ACTIONS(3762),
    [anon_sym_mutable] = ACTIONS(3762),
    [anon_sym_explicit] = ACTIONS(3762),
    [anon_sym_constexpr] = ACTIONS(3762),
    [anon_sym_DASH_GT] = ACTIONS(3762),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(3762),
  },
  [2215] = {
    [sym_type_qualifier] = STATE(2490),
    [sym_trailing_return_type] = STATE(1713),
    [aux_sym_abstract_function_declarator_repeat1] = STATE(2490),
    [anon_sym_LPAREN] = ACTIONS(3764),
    [anon_sym_COMMA] = ACTIONS(3764),
    [anon_sym_SEMI] = ACTIONS(3764),
    [anon_sym_LBRACE] = ACTIONS(3764),
    [anon_sym_LBRACK] = ACTIONS(3764),
    [anon_sym_EQ] = ACTIONS(3764),
    [anon_sym_const] = ACTIONS(3770),
    [anon_sym_restrict] = ACTIONS(3764),
    [anon_sym_volatile] = ACTIONS(3764),
    [anon_sym__Atomic] = ACTIONS(3764),
    [anon_sym_mutable] = ACTIONS(3764),
    [anon_sym_explicit] = ACTIONS(3764),
    [anon_sym_constexpr] = ACTIONS(3764),
    [anon_sym_DASH_GT] = ACTIONS(3764),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(3764),
  },
  [2216] = {
    [sym_type_qualifier] = STATE(2491),
    [sym_trailing_return_type] = STATE(1713),
    [aux_sym_abstract_function_declarator_repeat1] = STATE(2491),
    [anon_sym_LPAREN] = ACTIONS(3764),
    [anon_sym_COMMA] = ACTIONS(3764),
    [anon_sym_SEMI] = ACTIONS(3764),
    [anon_sym_LBRACE] = ACTIONS(3764),
    [anon_sym_LBRACK] = ACTIONS(3764),
    [anon_sym_EQ] = ACTIONS(3764),
    [anon_sym_const] = ACTIONS(612),
    [anon_sym_restrict] = ACTIONS(614),
    [anon_sym_volatile] = ACTIONS(614),
    [anon_sym__Atomic] = ACTIONS(614),
    [anon_sym_mutable] = ACTIONS(614),
    [anon_sym_explicit] = ACTIONS(614),
    [anon_sym_constexpr] = ACTIONS(614),
    [anon_sym_DASH_GT] = ACTIONS(1309),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(5917),
  },
  [2217] = {
    [sym__expression] = STATE(1834),
    [sym_conditional_expression] = STATE(1834),
    [sym_assignment_expression] = STATE(1834),
    [sym_pointer_expression] = STATE(1834),
    [sym_logical_expression] = STATE(1834),
    [sym_bitwise_expression] = STATE(1834),
    [sym_equality_expression] = STATE(1834),
    [sym_relational_expression] = STATE(1834),
    [sym_shift_expression] = STATE(1834),
    [sym_math_expression] = STATE(1834),
    [sym_cast_expression] = STATE(1834),
    [sym_sizeof_expression] = STATE(1834),
    [sym_subscript_expression] = STATE(1834),
    [sym_call_expression] = STATE(1834),
    [sym_field_expression] = STATE(1834),
    [sym_compound_literal_expression] = STATE(1834),
    [sym_parenthesized_expression] = STATE(1834),
    [sym_initializer_list] = STATE(1835),
    [sym_concatenated_string] = STATE(1834),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(1834),
    [sym_new_expression] = STATE(1834),
    [sym_delete_expression] = STATE(1834),
    [sym_lambda_expression] = STATE(1834),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(4145),
    [anon_sym_LPAREN] = ACTIONS(1321),
    [anon_sym_COMMA] = ACTIONS(5210),
    [anon_sym_LBRACE] = ACTIONS(548),
    [anon_sym_RBRACE] = ACTIONS(5210),
    [anon_sym_STAR] = ACTIONS(5919),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_EQ] = ACTIONS(5212),
    [anon_sym_QMARK] = ACTIONS(5210),
    [anon_sym_STAR_EQ] = ACTIONS(5210),
    [anon_sym_SLASH_EQ] = ACTIONS(5210),
    [anon_sym_PERCENT_EQ] = ACTIONS(5210),
    [anon_sym_PLUS_EQ] = ACTIONS(5210),
    [anon_sym_DASH_EQ] = ACTIONS(5210),
    [anon_sym_LT_LT_EQ] = ACTIONS(5210),
    [anon_sym_GT_GT_EQ] = ACTIONS(5210),
    [anon_sym_AMP_EQ] = ACTIONS(5210),
    [anon_sym_CARET_EQ] = ACTIONS(5210),
    [anon_sym_PIPE_EQ] = ACTIONS(5210),
    [anon_sym_AMP] = ACTIONS(5919),
    [anon_sym_PIPE_PIPE] = ACTIONS(5210),
    [anon_sym_AMP_AMP] = ACTIONS(5210),
    [anon_sym_BANG] = ACTIONS(5921),
    [anon_sym_PIPE] = ACTIONS(5212),
    [anon_sym_CARET] = ACTIONS(5212),
    [anon_sym_TILDE] = ACTIONS(1329),
    [anon_sym_EQ_EQ] = ACTIONS(5210),
    [anon_sym_BANG_EQ] = ACTIONS(5210),
    [anon_sym_LT] = ACTIONS(5212),
    [anon_sym_GT] = ACTIONS(5212),
    [anon_sym_LT_EQ] = ACTIONS(5210),
    [anon_sym_GT_EQ] = ACTIONS(5210),
    [anon_sym_LT_LT] = ACTIONS(5212),
    [anon_sym_GT_GT] = ACTIONS(5212),
    [anon_sym_PLUS] = ACTIONS(1331),
    [anon_sym_DASH] = ACTIONS(1331),
    [anon_sym_SLASH] = ACTIONS(5212),
    [anon_sym_PERCENT] = ACTIONS(5212),
    [anon_sym_DASH_DASH] = ACTIONS(1333),
    [anon_sym_PLUS_PLUS] = ACTIONS(1333),
    [anon_sym_sizeof] = ACTIONS(1335),
    [anon_sym_DOT] = ACTIONS(5210),
    [anon_sym_DASH_GT] = ACTIONS(5210),
    [sym_number_literal] = ACTIONS(4145),
    [sym_char_literal] = ACTIONS(4145),
    [sym_string_literal] = ACTIONS(1337),
    [sym_true] = ACTIONS(4147),
    [sym_false] = ACTIONS(4147),
    [sym_null] = ACTIONS(4147),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1341),
    [anon_sym_delete] = ACTIONS(1343),
    [sym_nullptr] = ACTIONS(4147),
  },
  [2218] = {
    [sym__expression] = STATE(2492),
    [sym_conditional_expression] = STATE(2492),
    [sym_assignment_expression] = STATE(2492),
    [sym_pointer_expression] = STATE(2492),
    [sym_logical_expression] = STATE(2492),
    [sym_bitwise_expression] = STATE(2492),
    [sym_equality_expression] = STATE(2492),
    [sym_relational_expression] = STATE(2492),
    [sym_shift_expression] = STATE(2492),
    [sym_math_expression] = STATE(2492),
    [sym_cast_expression] = STATE(2492),
    [sym_sizeof_expression] = STATE(2492),
    [sym_subscript_expression] = STATE(2492),
    [sym_call_expression] = STATE(2492),
    [sym_field_expression] = STATE(2492),
    [sym_compound_literal_expression] = STATE(2492),
    [sym_parenthesized_expression] = STATE(2492),
    [sym_concatenated_string] = STATE(2492),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(2492),
    [sym_new_expression] = STATE(2492),
    [sym_delete_expression] = STATE(2492),
    [sym_lambda_expression] = STATE(2492),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(5923),
    [anon_sym_LPAREN] = ACTIONS(2624),
    [anon_sym_STAR] = ACTIONS(2624),
    [anon_sym_LBRACK] = ACTIONS(2624),
    [anon_sym_AMP] = ACTIONS(2626),
    [anon_sym_AMP_AMP] = ACTIONS(2624),
    [anon_sym_BANG] = ACTIONS(1327),
    [anon_sym_TILDE] = ACTIONS(1329),
    [anon_sym_PLUS] = ACTIONS(1331),
    [anon_sym_DASH] = ACTIONS(1331),
    [anon_sym_DASH_DASH] = ACTIONS(1333),
    [anon_sym_PLUS_PLUS] = ACTIONS(1333),
    [anon_sym_sizeof] = ACTIONS(1335),
    [sym_number_literal] = ACTIONS(5923),
    [sym_char_literal] = ACTIONS(5923),
    [sym_string_literal] = ACTIONS(1337),
    [sym_true] = ACTIONS(5925),
    [sym_false] = ACTIONS(5925),
    [sym_null] = ACTIONS(5925),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1341),
    [anon_sym_delete] = ACTIONS(1343),
    [sym_nullptr] = ACTIONS(5925),
  },
  [2219] = {
    [sym_argument_list] = STATE(802),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_COMMA] = ACTIONS(5236),
    [anon_sym_RBRACE] = ACTIONS(5236),
    [anon_sym_STAR] = ACTIONS(2507),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_EQ] = ACTIONS(5238),
    [anon_sym_QMARK] = ACTIONS(5236),
    [anon_sym_STAR_EQ] = ACTIONS(5236),
    [anon_sym_SLASH_EQ] = ACTIONS(5236),
    [anon_sym_PERCENT_EQ] = ACTIONS(5236),
    [anon_sym_PLUS_EQ] = ACTIONS(5236),
    [anon_sym_DASH_EQ] = ACTIONS(5236),
    [anon_sym_LT_LT_EQ] = ACTIONS(5236),
    [anon_sym_GT_GT_EQ] = ACTIONS(5236),
    [anon_sym_AMP_EQ] = ACTIONS(5236),
    [anon_sym_CARET_EQ] = ACTIONS(5236),
    [anon_sym_PIPE_EQ] = ACTIONS(5236),
    [anon_sym_AMP] = ACTIONS(2515),
    [anon_sym_PIPE_PIPE] = ACTIONS(2517),
    [anon_sym_AMP_AMP] = ACTIONS(2519),
    [anon_sym_PIPE] = ACTIONS(2521),
    [anon_sym_CARET] = ACTIONS(2523),
    [anon_sym_EQ_EQ] = ACTIONS(2525),
    [anon_sym_BANG_EQ] = ACTIONS(2525),
    [anon_sym_LT] = ACTIONS(2527),
    [anon_sym_GT] = ACTIONS(2527),
    [anon_sym_LT_EQ] = ACTIONS(2529),
    [anon_sym_GT_EQ] = ACTIONS(2529),
    [anon_sym_LT_LT] = ACTIONS(2531),
    [anon_sym_GT_GT] = ACTIONS(2531),
    [anon_sym_PLUS] = ACTIONS(2533),
    [anon_sym_DASH] = ACTIONS(2533),
    [anon_sym_SLASH] = ACTIONS(2507),
    [anon_sym_PERCENT] = ACTIONS(2507),
    [anon_sym_DASH_DASH] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(1554),
    [anon_sym_DASH_GT] = ACTIONS(1554),
    [sym_comment] = ACTIONS(49),
  },
  [2220] = {
    [sym__expression] = STATE(2493),
    [sym_conditional_expression] = STATE(2493),
    [sym_assignment_expression] = STATE(2493),
    [sym_pointer_expression] = STATE(2493),
    [sym_logical_expression] = STATE(2493),
    [sym_bitwise_expression] = STATE(2493),
    [sym_equality_expression] = STATE(2493),
    [sym_relational_expression] = STATE(2493),
    [sym_shift_expression] = STATE(2493),
    [sym_math_expression] = STATE(2493),
    [sym_cast_expression] = STATE(2493),
    [sym_sizeof_expression] = STATE(2493),
    [sym_subscript_expression] = STATE(2493),
    [sym_call_expression] = STATE(2493),
    [sym_field_expression] = STATE(2493),
    [sym_compound_literal_expression] = STATE(2493),
    [sym_parenthesized_expression] = STATE(2493),
    [sym_concatenated_string] = STATE(2493),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(2493),
    [sym_new_expression] = STATE(2493),
    [sym_delete_expression] = STATE(2493),
    [sym_lambda_expression] = STATE(2493),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(5927),
    [anon_sym_LPAREN] = ACTIONS(1321),
    [anon_sym_STAR] = ACTIONS(1325),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_AMP] = ACTIONS(1325),
    [anon_sym_BANG] = ACTIONS(1327),
    [anon_sym_TILDE] = ACTIONS(1329),
    [anon_sym_PLUS] = ACTIONS(1331),
    [anon_sym_DASH] = ACTIONS(1331),
    [anon_sym_DASH_DASH] = ACTIONS(1333),
    [anon_sym_PLUS_PLUS] = ACTIONS(1333),
    [anon_sym_sizeof] = ACTIONS(1335),
    [sym_number_literal] = ACTIONS(5927),
    [sym_char_literal] = ACTIONS(5927),
    [sym_string_literal] = ACTIONS(1337),
    [sym_true] = ACTIONS(5929),
    [sym_false] = ACTIONS(5929),
    [sym_null] = ACTIONS(5929),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1341),
    [anon_sym_delete] = ACTIONS(1343),
    [sym_nullptr] = ACTIONS(5929),
  },
  [2221] = {
    [sym__expression] = STATE(1834),
    [sym_conditional_expression] = STATE(1834),
    [sym_assignment_expression] = STATE(1834),
    [sym_pointer_expression] = STATE(1834),
    [sym_logical_expression] = STATE(1834),
    [sym_bitwise_expression] = STATE(1834),
    [sym_equality_expression] = STATE(1834),
    [sym_relational_expression] = STATE(1834),
    [sym_shift_expression] = STATE(1834),
    [sym_math_expression] = STATE(1834),
    [sym_cast_expression] = STATE(1834),
    [sym_sizeof_expression] = STATE(1834),
    [sym_subscript_expression] = STATE(1834),
    [sym_call_expression] = STATE(1834),
    [sym_field_expression] = STATE(1834),
    [sym_compound_literal_expression] = STATE(1834),
    [sym_parenthesized_expression] = STATE(1834),
    [sym_initializer_list] = STATE(1835),
    [sym_concatenated_string] = STATE(1834),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(1834),
    [sym_new_expression] = STATE(1834),
    [sym_delete_expression] = STATE(1834),
    [sym_lambda_expression] = STATE(1834),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(4145),
    [anon_sym_LPAREN] = ACTIONS(1347),
    [anon_sym_SEMI] = ACTIONS(5210),
    [anon_sym_LBRACE] = ACTIONS(548),
    [anon_sym_STAR] = ACTIONS(5931),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_EQ] = ACTIONS(5212),
    [anon_sym_QMARK] = ACTIONS(5210),
    [anon_sym_STAR_EQ] = ACTIONS(5210),
    [anon_sym_SLASH_EQ] = ACTIONS(5210),
    [anon_sym_PERCENT_EQ] = ACTIONS(5210),
    [anon_sym_PLUS_EQ] = ACTIONS(5210),
    [anon_sym_DASH_EQ] = ACTIONS(5210),
    [anon_sym_LT_LT_EQ] = ACTIONS(5210),
    [anon_sym_GT_GT_EQ] = ACTIONS(5210),
    [anon_sym_AMP_EQ] = ACTIONS(5210),
    [anon_sym_CARET_EQ] = ACTIONS(5210),
    [anon_sym_PIPE_EQ] = ACTIONS(5210),
    [anon_sym_AMP] = ACTIONS(5931),
    [anon_sym_PIPE_PIPE] = ACTIONS(5210),
    [anon_sym_AMP_AMP] = ACTIONS(5210),
    [anon_sym_BANG] = ACTIONS(5933),
    [anon_sym_PIPE] = ACTIONS(5212),
    [anon_sym_CARET] = ACTIONS(5212),
    [anon_sym_TILDE] = ACTIONS(1353),
    [anon_sym_EQ_EQ] = ACTIONS(5210),
    [anon_sym_BANG_EQ] = ACTIONS(5210),
    [anon_sym_LT] = ACTIONS(5212),
    [anon_sym_GT] = ACTIONS(5212),
    [anon_sym_LT_EQ] = ACTIONS(5210),
    [anon_sym_GT_EQ] = ACTIONS(5210),
    [anon_sym_LT_LT] = ACTIONS(5212),
    [anon_sym_GT_GT] = ACTIONS(5212),
    [anon_sym_PLUS] = ACTIONS(1355),
    [anon_sym_DASH] = ACTIONS(1355),
    [anon_sym_SLASH] = ACTIONS(5212),
    [anon_sym_PERCENT] = ACTIONS(5212),
    [anon_sym_DASH_DASH] = ACTIONS(1357),
    [anon_sym_PLUS_PLUS] = ACTIONS(1357),
    [anon_sym_sizeof] = ACTIONS(1359),
    [anon_sym_DOT] = ACTIONS(5210),
    [anon_sym_DASH_GT] = ACTIONS(5210),
    [sym_number_literal] = ACTIONS(4145),
    [sym_char_literal] = ACTIONS(4145),
    [sym_string_literal] = ACTIONS(1361),
    [sym_true] = ACTIONS(4147),
    [sym_false] = ACTIONS(4147),
    [sym_null] = ACTIONS(4147),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1365),
    [anon_sym_delete] = ACTIONS(1367),
    [sym_nullptr] = ACTIONS(4147),
  },
  [2222] = {
    [sym__expression] = STATE(2494),
    [sym_conditional_expression] = STATE(2494),
    [sym_assignment_expression] = STATE(2494),
    [sym_pointer_expression] = STATE(2494),
    [sym_logical_expression] = STATE(2494),
    [sym_bitwise_expression] = STATE(2494),
    [sym_equality_expression] = STATE(2494),
    [sym_relational_expression] = STATE(2494),
    [sym_shift_expression] = STATE(2494),
    [sym_math_expression] = STATE(2494),
    [sym_cast_expression] = STATE(2494),
    [sym_sizeof_expression] = STATE(2494),
    [sym_subscript_expression] = STATE(2494),
    [sym_call_expression] = STATE(2494),
    [sym_field_expression] = STATE(2494),
    [sym_compound_literal_expression] = STATE(2494),
    [sym_parenthesized_expression] = STATE(2494),
    [sym_concatenated_string] = STATE(2494),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(2494),
    [sym_new_expression] = STATE(2494),
    [sym_delete_expression] = STATE(2494),
    [sym_lambda_expression] = STATE(2494),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(5935),
    [anon_sym_LPAREN] = ACTIONS(2624),
    [anon_sym_STAR] = ACTIONS(2624),
    [anon_sym_LBRACK] = ACTIONS(2624),
    [anon_sym_AMP] = ACTIONS(2626),
    [anon_sym_AMP_AMP] = ACTIONS(2624),
    [anon_sym_BANG] = ACTIONS(1351),
    [anon_sym_TILDE] = ACTIONS(1353),
    [anon_sym_PLUS] = ACTIONS(1355),
    [anon_sym_DASH] = ACTIONS(1355),
    [anon_sym_DASH_DASH] = ACTIONS(1357),
    [anon_sym_PLUS_PLUS] = ACTIONS(1357),
    [anon_sym_sizeof] = ACTIONS(1359),
    [sym_number_literal] = ACTIONS(5935),
    [sym_char_literal] = ACTIONS(5935),
    [sym_string_literal] = ACTIONS(1361),
    [sym_true] = ACTIONS(5937),
    [sym_false] = ACTIONS(5937),
    [sym_null] = ACTIONS(5937),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1365),
    [anon_sym_delete] = ACTIONS(1367),
    [sym_nullptr] = ACTIONS(5937),
  },
  [2223] = {
    [sym_argument_list] = STATE(802),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_SEMI] = ACTIONS(5236),
    [anon_sym_STAR] = ACTIONS(2553),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_EQ] = ACTIONS(5238),
    [anon_sym_QMARK] = ACTIONS(5236),
    [anon_sym_STAR_EQ] = ACTIONS(5236),
    [anon_sym_SLASH_EQ] = ACTIONS(5236),
    [anon_sym_PERCENT_EQ] = ACTIONS(5236),
    [anon_sym_PLUS_EQ] = ACTIONS(5236),
    [anon_sym_DASH_EQ] = ACTIONS(5236),
    [anon_sym_LT_LT_EQ] = ACTIONS(5236),
    [anon_sym_GT_GT_EQ] = ACTIONS(5236),
    [anon_sym_AMP_EQ] = ACTIONS(5236),
    [anon_sym_CARET_EQ] = ACTIONS(5236),
    [anon_sym_PIPE_EQ] = ACTIONS(5236),
    [anon_sym_AMP] = ACTIONS(2561),
    [anon_sym_PIPE_PIPE] = ACTIONS(2563),
    [anon_sym_AMP_AMP] = ACTIONS(2565),
    [anon_sym_PIPE] = ACTIONS(2567),
    [anon_sym_CARET] = ACTIONS(2569),
    [anon_sym_EQ_EQ] = ACTIONS(2571),
    [anon_sym_BANG_EQ] = ACTIONS(2571),
    [anon_sym_LT] = ACTIONS(2573),
    [anon_sym_GT] = ACTIONS(2573),
    [anon_sym_LT_EQ] = ACTIONS(2575),
    [anon_sym_GT_EQ] = ACTIONS(2575),
    [anon_sym_LT_LT] = ACTIONS(2577),
    [anon_sym_GT_GT] = ACTIONS(2577),
    [anon_sym_PLUS] = ACTIONS(2579),
    [anon_sym_DASH] = ACTIONS(2579),
    [anon_sym_SLASH] = ACTIONS(2553),
    [anon_sym_PERCENT] = ACTIONS(2553),
    [anon_sym_DASH_DASH] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(1554),
    [anon_sym_DASH_GT] = ACTIONS(1554),
    [sym_comment] = ACTIONS(49),
  },
  [2224] = {
    [sym__expression] = STATE(2495),
    [sym_conditional_expression] = STATE(2495),
    [sym_assignment_expression] = STATE(2495),
    [sym_pointer_expression] = STATE(2495),
    [sym_logical_expression] = STATE(2495),
    [sym_bitwise_expression] = STATE(2495),
    [sym_equality_expression] = STATE(2495),
    [sym_relational_expression] = STATE(2495),
    [sym_shift_expression] = STATE(2495),
    [sym_math_expression] = STATE(2495),
    [sym_cast_expression] = STATE(2495),
    [sym_sizeof_expression] = STATE(2495),
    [sym_subscript_expression] = STATE(2495),
    [sym_call_expression] = STATE(2495),
    [sym_field_expression] = STATE(2495),
    [sym_compound_literal_expression] = STATE(2495),
    [sym_parenthesized_expression] = STATE(2495),
    [sym_concatenated_string] = STATE(2495),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(2495),
    [sym_new_expression] = STATE(2495),
    [sym_delete_expression] = STATE(2495),
    [sym_lambda_expression] = STATE(2495),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(5939),
    [anon_sym_LPAREN] = ACTIONS(1347),
    [anon_sym_STAR] = ACTIONS(1349),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_AMP] = ACTIONS(1349),
    [anon_sym_BANG] = ACTIONS(1351),
    [anon_sym_TILDE] = ACTIONS(1353),
    [anon_sym_PLUS] = ACTIONS(1355),
    [anon_sym_DASH] = ACTIONS(1355),
    [anon_sym_DASH_DASH] = ACTIONS(1357),
    [anon_sym_PLUS_PLUS] = ACTIONS(1357),
    [anon_sym_sizeof] = ACTIONS(1359),
    [sym_number_literal] = ACTIONS(5939),
    [sym_char_literal] = ACTIONS(5939),
    [sym_string_literal] = ACTIONS(1361),
    [sym_true] = ACTIONS(5941),
    [sym_false] = ACTIONS(5941),
    [sym_null] = ACTIONS(5941),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1365),
    [anon_sym_delete] = ACTIONS(1367),
    [sym_nullptr] = ACTIONS(5941),
  },
  [2225] = {
    [sym__type_specifier] = STATE(1375),
    [sym_sized_type_specifier] = STATE(1375),
    [sym_enum_specifier] = STATE(1375),
    [sym_struct_specifier] = STATE(1375),
    [sym_union_specifier] = STATE(1375),
    [sym_macro_type_specifier] = STATE(1375),
    [sym_class_specifier] = STATE(1375),
    [sym_dependent_type] = STATE(1375),
    [sym_template_type] = STATE(825),
    [sym_scoped_type_identifier] = STATE(826),
    [sym_scoped_namespace_identifier] = STATE(827),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2227),
    [anon_sym_unsigned] = ACTIONS(5155),
    [anon_sym_long] = ACTIONS(5155),
    [anon_sym_short] = ACTIONS(5155),
    [sym_primitive_type] = ACTIONS(2837),
    [anon_sym_enum] = ACTIONS(1582),
    [anon_sym_struct] = ACTIONS(2468),
    [anon_sym_union] = ACTIONS(2470),
    [sym_identifier] = ACTIONS(1588),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(2472),
    [sym_auto] = ACTIONS(2837),
    [anon_sym_typename] = ACTIONS(5159),
    [anon_sym_COLON_COLON] = ACTIONS(1594),
  },
  [2226] = {
    [sym__abstract_declarator] = STATE(2498),
    [sym_abstract_pointer_declarator] = STATE(2498),
    [sym_abstract_function_declarator] = STATE(2498),
    [sym_abstract_array_declarator] = STATE(2498),
    [sym_parameter_list] = STATE(2499),
    [sym_abstract_reference_declarator] = STATE(2498),
    [anon_sym_LPAREN] = ACTIONS(1115),
    [anon_sym_COMMA] = ACTIONS(2841),
    [anon_sym_RPAREN] = ACTIONS(2841),
    [anon_sym_LBRACE] = ACTIONS(2841),
    [anon_sym_STAR] = ACTIONS(5943),
    [anon_sym_LBRACK] = ACTIONS(1121),
    [anon_sym_EQ] = ACTIONS(2841),
    [anon_sym_const] = ACTIONS(2845),
    [anon_sym_restrict] = ACTIONS(2841),
    [anon_sym_volatile] = ACTIONS(2841),
    [anon_sym__Atomic] = ACTIONS(2841),
    [anon_sym_mutable] = ACTIONS(2841),
    [anon_sym_explicit] = ACTIONS(2841),
    [anon_sym_constexpr] = ACTIONS(2841),
    [anon_sym_AMP] = ACTIONS(5945),
    [anon_sym_AMP_AMP] = ACTIONS(5947),
    [anon_sym_DASH_GT] = ACTIONS(2841),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(2841),
  },
  [2227] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2500),
    [anon_sym_LPAREN] = ACTIONS(238),
    [anon_sym_COMMA] = ACTIONS(238),
    [anon_sym_RPAREN] = ACTIONS(238),
    [anon_sym_LBRACE] = ACTIONS(238),
    [anon_sym_STAR] = ACTIONS(238),
    [anon_sym_LBRACK] = ACTIONS(238),
    [anon_sym_EQ] = ACTIONS(238),
    [anon_sym_const] = ACTIONS(240),
    [anon_sym_restrict] = ACTIONS(240),
    [anon_sym_volatile] = ACTIONS(240),
    [anon_sym__Atomic] = ACTIONS(240),
    [anon_sym_mutable] = ACTIONS(240),
    [anon_sym_explicit] = ACTIONS(240),
    [anon_sym_constexpr] = ACTIONS(240),
    [anon_sym_unsigned] = ACTIONS(5949),
    [anon_sym_long] = ACTIONS(5949),
    [anon_sym_short] = ACTIONS(5949),
    [sym_primitive_type] = ACTIONS(2855),
    [anon_sym_AMP] = ACTIONS(240),
    [anon_sym_AMP_AMP] = ACTIONS(238),
    [anon_sym_DASH_GT] = ACTIONS(238),
    [sym_identifier] = ACTIONS(2857),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(240),
  },
  [2228] = {
    [sym_type_qualifier] = STATE(2228),
    [sym_trailing_return_type] = STATE(2228),
    [aux_sym_function_declarator_repeat1] = STATE(2228),
    [anon_sym_LPAREN] = ACTIONS(2859),
    [anon_sym_COMMA] = ACTIONS(2859),
    [anon_sym_RPAREN] = ACTIONS(2859),
    [anon_sym_LBRACE] = ACTIONS(2859),
    [anon_sym_LBRACK] = ACTIONS(2859),
    [anon_sym_EQ] = ACTIONS(2859),
    [anon_sym_const] = ACTIONS(2861),
    [anon_sym_restrict] = ACTIONS(2864),
    [anon_sym_volatile] = ACTIONS(2864),
    [anon_sym__Atomic] = ACTIONS(2864),
    [anon_sym_mutable] = ACTIONS(2864),
    [anon_sym_explicit] = ACTIONS(2864),
    [anon_sym_constexpr] = ACTIONS(2864),
    [anon_sym_DASH_GT] = ACTIONS(5951),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(5954),
  },
  [2229] = {
    [sym__abstract_declarator] = STATE(1257),
    [sym_abstract_pointer_declarator] = STATE(1257),
    [sym_abstract_function_declarator] = STATE(1257),
    [sym_abstract_array_declarator] = STATE(1257),
    [sym_parameter_list] = STATE(713),
    [sym_abstract_reference_declarator] = STATE(1257),
    [anon_sym_LPAREN] = ACTIONS(1115),
    [anon_sym_COMMA] = ACTIONS(2270),
    [anon_sym_RPAREN] = ACTIONS(2270),
    [anon_sym_STAR] = ACTIONS(5163),
    [anon_sym_LBRACK] = ACTIONS(1121),
    [anon_sym_AMP] = ACTIONS(5165),
    [anon_sym_AMP_AMP] = ACTIONS(5167),
    [sym_comment] = ACTIONS(49),
  },
  [2230] = {
    [sym__abstract_declarator] = STATE(1259),
    [sym_abstract_pointer_declarator] = STATE(1259),
    [sym_abstract_function_declarator] = STATE(1259),
    [sym_abstract_array_declarator] = STATE(1259),
    [sym_parameter_list] = STATE(713),
    [sym_abstract_reference_declarator] = STATE(1259),
    [anon_sym_LPAREN] = ACTIONS(1115),
    [anon_sym_COMMA] = ACTIONS(2278),
    [anon_sym_RPAREN] = ACTIONS(2278),
    [anon_sym_STAR] = ACTIONS(5163),
    [anon_sym_LBRACK] = ACTIONS(1121),
    [anon_sym_AMP] = ACTIONS(5165),
    [anon_sym_AMP_AMP] = ACTIONS(5167),
    [sym_comment] = ACTIONS(49),
  },
  [2231] = {
    [sym_parameter_list] = STATE(1262),
    [anon_sym_LPAREN] = ACTIONS(206),
    [anon_sym_COMMA] = ACTIONS(4364),
    [anon_sym_RPAREN] = ACTIONS(4364),
    [anon_sym_LBRACK] = ACTIONS(2282),
    [sym_comment] = ACTIONS(49),
  },
  [2232] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2232),
    [anon_sym_LPAREN] = ACTIONS(816),
    [anon_sym_COMMA] = ACTIONS(816),
    [anon_sym_RPAREN] = ACTIONS(816),
    [anon_sym_STAR] = ACTIONS(816),
    [anon_sym_LBRACK] = ACTIONS(816),
    [anon_sym_unsigned] = ACTIONS(5957),
    [anon_sym_long] = ACTIONS(5957),
    [anon_sym_short] = ACTIONS(5957),
    [sym_primitive_type] = ACTIONS(818),
    [anon_sym_AMP] = ACTIONS(818),
    [anon_sym_AMP_AMP] = ACTIONS(816),
    [sym_identifier] = ACTIONS(818),
    [sym_comment] = ACTIONS(49),
  },
  [2233] = {
    [sym__expression] = STATE(1834),
    [sym_conditional_expression] = STATE(1834),
    [sym_assignment_expression] = STATE(1834),
    [sym_pointer_expression] = STATE(1834),
    [sym_logical_expression] = STATE(1834),
    [sym_bitwise_expression] = STATE(1834),
    [sym_equality_expression] = STATE(1834),
    [sym_relational_expression] = STATE(1834),
    [sym_shift_expression] = STATE(1834),
    [sym_math_expression] = STATE(1834),
    [sym_cast_expression] = STATE(1834),
    [sym_sizeof_expression] = STATE(1834),
    [sym_subscript_expression] = STATE(1834),
    [sym_call_expression] = STATE(1834),
    [sym_field_expression] = STATE(1834),
    [sym_compound_literal_expression] = STATE(1834),
    [sym_parenthesized_expression] = STATE(1834),
    [sym_initializer_list] = STATE(1835),
    [sym_concatenated_string] = STATE(1834),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(1834),
    [sym_new_expression] = STATE(1834),
    [sym_delete_expression] = STATE(1834),
    [sym_lambda_expression] = STATE(1834),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(4145),
    [anon_sym_LPAREN] = ACTIONS(1419),
    [anon_sym_COMMA] = ACTIONS(5210),
    [anon_sym_LBRACE] = ACTIONS(548),
    [anon_sym_STAR] = ACTIONS(5960),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_RBRACK] = ACTIONS(5210),
    [anon_sym_EQ] = ACTIONS(5212),
    [anon_sym_QMARK] = ACTIONS(5210),
    [anon_sym_STAR_EQ] = ACTIONS(5210),
    [anon_sym_SLASH_EQ] = ACTIONS(5210),
    [anon_sym_PERCENT_EQ] = ACTIONS(5210),
    [anon_sym_PLUS_EQ] = ACTIONS(5210),
    [anon_sym_DASH_EQ] = ACTIONS(5210),
    [anon_sym_LT_LT_EQ] = ACTIONS(5210),
    [anon_sym_GT_GT_EQ] = ACTIONS(5210),
    [anon_sym_AMP_EQ] = ACTIONS(5210),
    [anon_sym_CARET_EQ] = ACTIONS(5210),
    [anon_sym_PIPE_EQ] = ACTIONS(5210),
    [anon_sym_AMP] = ACTIONS(5960),
    [anon_sym_PIPE_PIPE] = ACTIONS(5210),
    [anon_sym_AMP_AMP] = ACTIONS(5210),
    [anon_sym_BANG] = ACTIONS(5962),
    [anon_sym_PIPE] = ACTIONS(5212),
    [anon_sym_CARET] = ACTIONS(5212),
    [anon_sym_TILDE] = ACTIONS(1431),
    [anon_sym_EQ_EQ] = ACTIONS(5210),
    [anon_sym_BANG_EQ] = ACTIONS(5210),
    [anon_sym_LT] = ACTIONS(5212),
    [anon_sym_GT] = ACTIONS(5212),
    [anon_sym_LT_EQ] = ACTIONS(5210),
    [anon_sym_GT_EQ] = ACTIONS(5210),
    [anon_sym_LT_LT] = ACTIONS(5212),
    [anon_sym_GT_GT] = ACTIONS(5212),
    [anon_sym_PLUS] = ACTIONS(1433),
    [anon_sym_DASH] = ACTIONS(1433),
    [anon_sym_SLASH] = ACTIONS(5212),
    [anon_sym_PERCENT] = ACTIONS(5212),
    [anon_sym_DASH_DASH] = ACTIONS(1435),
    [anon_sym_PLUS_PLUS] = ACTIONS(1435),
    [anon_sym_sizeof] = ACTIONS(1437),
    [anon_sym_DOT] = ACTIONS(5210),
    [anon_sym_DASH_GT] = ACTIONS(5210),
    [sym_number_literal] = ACTIONS(4145),
    [sym_char_literal] = ACTIONS(4145),
    [sym_string_literal] = ACTIONS(1439),
    [sym_true] = ACTIONS(4147),
    [sym_false] = ACTIONS(4147),
    [sym_null] = ACTIONS(4147),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1443),
    [anon_sym_delete] = ACTIONS(1445),
    [sym_nullptr] = ACTIONS(4147),
  },
  [2234] = {
    [sym__expression] = STATE(2501),
    [sym_conditional_expression] = STATE(2501),
    [sym_assignment_expression] = STATE(2501),
    [sym_pointer_expression] = STATE(2501),
    [sym_logical_expression] = STATE(2501),
    [sym_bitwise_expression] = STATE(2501),
    [sym_equality_expression] = STATE(2501),
    [sym_relational_expression] = STATE(2501),
    [sym_shift_expression] = STATE(2501),
    [sym_math_expression] = STATE(2501),
    [sym_cast_expression] = STATE(2501),
    [sym_sizeof_expression] = STATE(2501),
    [sym_subscript_expression] = STATE(2501),
    [sym_call_expression] = STATE(2501),
    [sym_field_expression] = STATE(2501),
    [sym_compound_literal_expression] = STATE(2501),
    [sym_parenthesized_expression] = STATE(2501),
    [sym_concatenated_string] = STATE(2501),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(2501),
    [sym_new_expression] = STATE(2501),
    [sym_delete_expression] = STATE(2501),
    [sym_lambda_expression] = STATE(2501),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(5964),
    [anon_sym_LPAREN] = ACTIONS(2624),
    [anon_sym_STAR] = ACTIONS(2624),
    [anon_sym_LBRACK] = ACTIONS(2624),
    [anon_sym_AMP] = ACTIONS(2626),
    [anon_sym_AMP_AMP] = ACTIONS(2624),
    [anon_sym_BANG] = ACTIONS(1429),
    [anon_sym_TILDE] = ACTIONS(1431),
    [anon_sym_PLUS] = ACTIONS(1433),
    [anon_sym_DASH] = ACTIONS(1433),
    [anon_sym_DASH_DASH] = ACTIONS(1435),
    [anon_sym_PLUS_PLUS] = ACTIONS(1435),
    [anon_sym_sizeof] = ACTIONS(1437),
    [sym_number_literal] = ACTIONS(5964),
    [sym_char_literal] = ACTIONS(5964),
    [sym_string_literal] = ACTIONS(1439),
    [sym_true] = ACTIONS(5966),
    [sym_false] = ACTIONS(5966),
    [sym_null] = ACTIONS(5966),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1443),
    [anon_sym_delete] = ACTIONS(1445),
    [sym_nullptr] = ACTIONS(5966),
  },
  [2235] = {
    [sym_argument_list] = STATE(802),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_COMMA] = ACTIONS(5236),
    [anon_sym_STAR] = ACTIONS(2648),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_RBRACK] = ACTIONS(5236),
    [anon_sym_EQ] = ACTIONS(5238),
    [anon_sym_QMARK] = ACTIONS(5236),
    [anon_sym_STAR_EQ] = ACTIONS(5236),
    [anon_sym_SLASH_EQ] = ACTIONS(5236),
    [anon_sym_PERCENT_EQ] = ACTIONS(5236),
    [anon_sym_PLUS_EQ] = ACTIONS(5236),
    [anon_sym_DASH_EQ] = ACTIONS(5236),
    [anon_sym_LT_LT_EQ] = ACTIONS(5236),
    [anon_sym_GT_GT_EQ] = ACTIONS(5236),
    [anon_sym_AMP_EQ] = ACTIONS(5236),
    [anon_sym_CARET_EQ] = ACTIONS(5236),
    [anon_sym_PIPE_EQ] = ACTIONS(5236),
    [anon_sym_AMP] = ACTIONS(2658),
    [anon_sym_PIPE_PIPE] = ACTIONS(2660),
    [anon_sym_AMP_AMP] = ACTIONS(2662),
    [anon_sym_PIPE] = ACTIONS(2664),
    [anon_sym_CARET] = ACTIONS(2666),
    [anon_sym_EQ_EQ] = ACTIONS(2668),
    [anon_sym_BANG_EQ] = ACTIONS(2668),
    [anon_sym_LT] = ACTIONS(2670),
    [anon_sym_GT] = ACTIONS(2670),
    [anon_sym_LT_EQ] = ACTIONS(2672),
    [anon_sym_GT_EQ] = ACTIONS(2672),
    [anon_sym_LT_LT] = ACTIONS(2674),
    [anon_sym_GT_GT] = ACTIONS(2674),
    [anon_sym_PLUS] = ACTIONS(2676),
    [anon_sym_DASH] = ACTIONS(2676),
    [anon_sym_SLASH] = ACTIONS(2648),
    [anon_sym_PERCENT] = ACTIONS(2648),
    [anon_sym_DASH_DASH] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(1554),
    [anon_sym_DASH_GT] = ACTIONS(1554),
    [sym_comment] = ACTIONS(49),
  },
  [2236] = {
    [sym__expression] = STATE(2502),
    [sym_conditional_expression] = STATE(2502),
    [sym_assignment_expression] = STATE(2502),
    [sym_pointer_expression] = STATE(2502),
    [sym_logical_expression] = STATE(2502),
    [sym_bitwise_expression] = STATE(2502),
    [sym_equality_expression] = STATE(2502),
    [sym_relational_expression] = STATE(2502),
    [sym_shift_expression] = STATE(2502),
    [sym_math_expression] = STATE(2502),
    [sym_cast_expression] = STATE(2502),
    [sym_sizeof_expression] = STATE(2502),
    [sym_subscript_expression] = STATE(2502),
    [sym_call_expression] = STATE(2502),
    [sym_field_expression] = STATE(2502),
    [sym_compound_literal_expression] = STATE(2502),
    [sym_parenthesized_expression] = STATE(2502),
    [sym_concatenated_string] = STATE(2502),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(2502),
    [sym_new_expression] = STATE(2502),
    [sym_delete_expression] = STATE(2502),
    [sym_lambda_expression] = STATE(2502),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(5968),
    [anon_sym_LPAREN] = ACTIONS(1419),
    [anon_sym_STAR] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_AMP] = ACTIONS(1421),
    [anon_sym_BANG] = ACTIONS(1429),
    [anon_sym_TILDE] = ACTIONS(1431),
    [anon_sym_PLUS] = ACTIONS(1433),
    [anon_sym_DASH] = ACTIONS(1433),
    [anon_sym_DASH_DASH] = ACTIONS(1435),
    [anon_sym_PLUS_PLUS] = ACTIONS(1435),
    [anon_sym_sizeof] = ACTIONS(1437),
    [sym_number_literal] = ACTIONS(5968),
    [sym_char_literal] = ACTIONS(5968),
    [sym_string_literal] = ACTIONS(1439),
    [sym_true] = ACTIONS(5970),
    [sym_false] = ACTIONS(5970),
    [sym_null] = ACTIONS(5970),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1443),
    [anon_sym_delete] = ACTIONS(1445),
    [sym_nullptr] = ACTIONS(5970),
  },
  [2237] = {
    [sym_raw_string_literal] = ACTIONS(3539),
    [anon_sym_LPAREN] = ACTIONS(3539),
    [anon_sym_extern] = ACTIONS(3541),
    [anon_sym_STAR] = ACTIONS(3539),
    [anon_sym_LBRACK] = ACTIONS(3539),
    [anon_sym_RBRACK] = ACTIONS(3539),
    [anon_sym_static] = ACTIONS(3541),
    [anon_sym_register] = ACTIONS(3541),
    [anon_sym_inline] = ACTIONS(3541),
    [anon_sym_const] = ACTIONS(3541),
    [anon_sym_restrict] = ACTIONS(3541),
    [anon_sym_volatile] = ACTIONS(3541),
    [anon_sym__Atomic] = ACTIONS(3541),
    [anon_sym_mutable] = ACTIONS(3541),
    [anon_sym_explicit] = ACTIONS(3541),
    [anon_sym_constexpr] = ACTIONS(3541),
    [anon_sym_AMP] = ACTIONS(3539),
    [anon_sym_BANG] = ACTIONS(3539),
    [anon_sym_TILDE] = ACTIONS(3539),
    [anon_sym_PLUS] = ACTIONS(3541),
    [anon_sym_DASH] = ACTIONS(3541),
    [anon_sym_DASH_DASH] = ACTIONS(3539),
    [anon_sym_PLUS_PLUS] = ACTIONS(3539),
    [anon_sym_sizeof] = ACTIONS(3541),
    [sym_number_literal] = ACTIONS(3539),
    [sym_char_literal] = ACTIONS(3539),
    [sym_string_literal] = ACTIONS(3539),
    [sym_true] = ACTIONS(3541),
    [sym_false] = ACTIONS(3541),
    [sym_null] = ACTIONS(3541),
    [sym_identifier] = ACTIONS(3541),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(3541),
    [anon_sym_COLON_COLON] = ACTIONS(3539),
    [anon_sym_delete] = ACTIONS(3541),
    [sym_nullptr] = ACTIONS(3541),
  },
  [2238] = {
    [sym_enumerator] = STATE(1030),
    [anon_sym_RBRACE] = ACTIONS(5972),
    [sym_identifier] = ACTIONS(348),
    [sym_comment] = ACTIONS(49),
  },
  [2239] = {
    [sym_raw_string_literal] = ACTIONS(3776),
    [anon_sym_LPAREN] = ACTIONS(3776),
    [anon_sym_extern] = ACTIONS(3778),
    [anon_sym_LBRACE] = ACTIONS(3776),
    [anon_sym_STAR] = ACTIONS(3778),
    [anon_sym_LBRACK] = ACTIONS(3776),
    [anon_sym_RBRACK] = ACTIONS(3776),
    [anon_sym_EQ] = ACTIONS(3778),
    [anon_sym_static] = ACTIONS(3778),
    [anon_sym_register] = ACTIONS(3778),
    [anon_sym_inline] = ACTIONS(3778),
    [anon_sym_const] = ACTIONS(3778),
    [anon_sym_restrict] = ACTIONS(3778),
    [anon_sym_volatile] = ACTIONS(3778),
    [anon_sym__Atomic] = ACTIONS(3778),
    [anon_sym_mutable] = ACTIONS(3778),
    [anon_sym_explicit] = ACTIONS(3778),
    [anon_sym_constexpr] = ACTIONS(3778),
    [anon_sym_QMARK] = ACTIONS(3776),
    [anon_sym_STAR_EQ] = ACTIONS(3776),
    [anon_sym_SLASH_EQ] = ACTIONS(3776),
    [anon_sym_PERCENT_EQ] = ACTIONS(3776),
    [anon_sym_PLUS_EQ] = ACTIONS(3776),
    [anon_sym_DASH_EQ] = ACTIONS(3776),
    [anon_sym_LT_LT_EQ] = ACTIONS(3776),
    [anon_sym_GT_GT_EQ] = ACTIONS(3776),
    [anon_sym_AMP_EQ] = ACTIONS(3776),
    [anon_sym_CARET_EQ] = ACTIONS(3776),
    [anon_sym_PIPE_EQ] = ACTIONS(3776),
    [anon_sym_AMP] = ACTIONS(3778),
    [anon_sym_PIPE_PIPE] = ACTIONS(3776),
    [anon_sym_AMP_AMP] = ACTIONS(3776),
    [anon_sym_BANG] = ACTIONS(3778),
    [anon_sym_PIPE] = ACTIONS(3778),
    [anon_sym_CARET] = ACTIONS(3778),
    [anon_sym_TILDE] = ACTIONS(3776),
    [anon_sym_EQ_EQ] = ACTIONS(3776),
    [anon_sym_BANG_EQ] = ACTIONS(3776),
    [anon_sym_LT] = ACTIONS(3778),
    [anon_sym_GT] = ACTIONS(3778),
    [anon_sym_LT_EQ] = ACTIONS(3776),
    [anon_sym_GT_EQ] = ACTIONS(3776),
    [anon_sym_LT_LT] = ACTIONS(3778),
    [anon_sym_GT_GT] = ACTIONS(3778),
    [anon_sym_PLUS] = ACTIONS(3778),
    [anon_sym_DASH] = ACTIONS(3778),
    [anon_sym_SLASH] = ACTIONS(3778),
    [anon_sym_PERCENT] = ACTIONS(3778),
    [anon_sym_DASH_DASH] = ACTIONS(3776),
    [anon_sym_PLUS_PLUS] = ACTIONS(3776),
    [anon_sym_sizeof] = ACTIONS(3778),
    [anon_sym_DOT] = ACTIONS(3776),
    [anon_sym_DASH_GT] = ACTIONS(3776),
    [sym_number_literal] = ACTIONS(3776),
    [sym_char_literal] = ACTIONS(3776),
    [sym_string_literal] = ACTIONS(3776),
    [sym_true] = ACTIONS(3778),
    [sym_false] = ACTIONS(3778),
    [sym_null] = ACTIONS(3778),
    [sym_identifier] = ACTIONS(3778),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(3778),
    [anon_sym_COLON_COLON] = ACTIONS(3776),
    [anon_sym_delete] = ACTIONS(3778),
    [sym_nullptr] = ACTIONS(3778),
  },
  [2240] = {
    [sym_new_declarator] = STATE(2504),
    [anon_sym_LPAREN] = ACTIONS(5974),
    [anon_sym_LBRACE] = ACTIONS(5974),
    [anon_sym_LBRACK] = ACTIONS(2723),
    [sym_comment] = ACTIONS(49),
  },
  [2241] = {
    [anon_sym_LPAREN] = ACTIONS(5976),
    [anon_sym_COMMA] = ACTIONS(5976),
    [anon_sym_RPAREN] = ACTIONS(5976),
    [anon_sym_SEMI] = ACTIONS(5976),
    [anon_sym_RBRACE] = ACTIONS(5976),
    [anon_sym_STAR] = ACTIONS(5978),
    [anon_sym_LBRACK] = ACTIONS(5976),
    [anon_sym_RBRACK] = ACTIONS(5976),
    [anon_sym_EQ] = ACTIONS(5978),
    [anon_sym_COLON] = ACTIONS(5976),
    [anon_sym_QMARK] = ACTIONS(5976),
    [anon_sym_STAR_EQ] = ACTIONS(5976),
    [anon_sym_SLASH_EQ] = ACTIONS(5976),
    [anon_sym_PERCENT_EQ] = ACTIONS(5976),
    [anon_sym_PLUS_EQ] = ACTIONS(5976),
    [anon_sym_DASH_EQ] = ACTIONS(5976),
    [anon_sym_LT_LT_EQ] = ACTIONS(5976),
    [anon_sym_GT_GT_EQ] = ACTIONS(5976),
    [anon_sym_AMP_EQ] = ACTIONS(5976),
    [anon_sym_CARET_EQ] = ACTIONS(5976),
    [anon_sym_PIPE_EQ] = ACTIONS(5976),
    [anon_sym_AMP] = ACTIONS(5978),
    [anon_sym_PIPE_PIPE] = ACTIONS(5976),
    [anon_sym_AMP_AMP] = ACTIONS(5976),
    [anon_sym_PIPE] = ACTIONS(5978),
    [anon_sym_CARET] = ACTIONS(5978),
    [anon_sym_EQ_EQ] = ACTIONS(5976),
    [anon_sym_BANG_EQ] = ACTIONS(5976),
    [anon_sym_LT] = ACTIONS(5978),
    [anon_sym_GT] = ACTIONS(5978),
    [anon_sym_LT_EQ] = ACTIONS(5976),
    [anon_sym_GT_EQ] = ACTIONS(5976),
    [anon_sym_LT_LT] = ACTIONS(5978),
    [anon_sym_GT_GT] = ACTIONS(5978),
    [anon_sym_PLUS] = ACTIONS(5978),
    [anon_sym_DASH] = ACTIONS(5978),
    [anon_sym_SLASH] = ACTIONS(5978),
    [anon_sym_PERCENT] = ACTIONS(5978),
    [anon_sym_DASH_DASH] = ACTIONS(5976),
    [anon_sym_PLUS_PLUS] = ACTIONS(5976),
    [anon_sym_DOT] = ACTIONS(5976),
    [anon_sym_DASH_GT] = ACTIONS(5976),
    [sym_comment] = ACTIONS(49),
  },
  [2242] = {
    [anon_sym_LPAREN] = ACTIONS(5980),
    [anon_sym_COMMA] = ACTIONS(5980),
    [anon_sym_RPAREN] = ACTIONS(5980),
    [anon_sym_SEMI] = ACTIONS(5980),
    [anon_sym_RBRACE] = ACTIONS(5980),
    [anon_sym_STAR] = ACTIONS(5982),
    [anon_sym_LBRACK] = ACTIONS(5980),
    [anon_sym_RBRACK] = ACTIONS(5980),
    [anon_sym_EQ] = ACTIONS(5982),
    [anon_sym_COLON] = ACTIONS(5980),
    [anon_sym_QMARK] = ACTIONS(5980),
    [anon_sym_STAR_EQ] = ACTIONS(5980),
    [anon_sym_SLASH_EQ] = ACTIONS(5980),
    [anon_sym_PERCENT_EQ] = ACTIONS(5980),
    [anon_sym_PLUS_EQ] = ACTIONS(5980),
    [anon_sym_DASH_EQ] = ACTIONS(5980),
    [anon_sym_LT_LT_EQ] = ACTIONS(5980),
    [anon_sym_GT_GT_EQ] = ACTIONS(5980),
    [anon_sym_AMP_EQ] = ACTIONS(5980),
    [anon_sym_CARET_EQ] = ACTIONS(5980),
    [anon_sym_PIPE_EQ] = ACTIONS(5980),
    [anon_sym_AMP] = ACTIONS(5982),
    [anon_sym_PIPE_PIPE] = ACTIONS(5980),
    [anon_sym_AMP_AMP] = ACTIONS(5980),
    [anon_sym_PIPE] = ACTIONS(5982),
    [anon_sym_CARET] = ACTIONS(5982),
    [anon_sym_EQ_EQ] = ACTIONS(5980),
    [anon_sym_BANG_EQ] = ACTIONS(5980),
    [anon_sym_LT] = ACTIONS(5982),
    [anon_sym_GT] = ACTIONS(5982),
    [anon_sym_LT_EQ] = ACTIONS(5980),
    [anon_sym_GT_EQ] = ACTIONS(5980),
    [anon_sym_LT_LT] = ACTIONS(5982),
    [anon_sym_GT_GT] = ACTIONS(5982),
    [anon_sym_PLUS] = ACTIONS(5982),
    [anon_sym_DASH] = ACTIONS(5982),
    [anon_sym_SLASH] = ACTIONS(5982),
    [anon_sym_PERCENT] = ACTIONS(5982),
    [anon_sym_DASH_DASH] = ACTIONS(5980),
    [anon_sym_PLUS_PLUS] = ACTIONS(5980),
    [anon_sym_DOT] = ACTIONS(5980),
    [anon_sym_DASH_GT] = ACTIONS(5980),
    [sym_comment] = ACTIONS(49),
  },
  [2243] = {
    [sym_argument_list] = STATE(802),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_STAR] = ACTIONS(1522),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_RBRACK] = ACTIONS(5984),
    [anon_sym_EQ] = ACTIONS(5986),
    [anon_sym_QMARK] = ACTIONS(5984),
    [anon_sym_STAR_EQ] = ACTIONS(5984),
    [anon_sym_SLASH_EQ] = ACTIONS(5984),
    [anon_sym_PERCENT_EQ] = ACTIONS(5984),
    [anon_sym_PLUS_EQ] = ACTIONS(5984),
    [anon_sym_DASH_EQ] = ACTIONS(5984),
    [anon_sym_LT_LT_EQ] = ACTIONS(5984),
    [anon_sym_GT_GT_EQ] = ACTIONS(5984),
    [anon_sym_AMP_EQ] = ACTIONS(5984),
    [anon_sym_CARET_EQ] = ACTIONS(5984),
    [anon_sym_PIPE_EQ] = ACTIONS(5984),
    [anon_sym_AMP] = ACTIONS(1532),
    [anon_sym_PIPE_PIPE] = ACTIONS(1534),
    [anon_sym_AMP_AMP] = ACTIONS(1536),
    [anon_sym_PIPE] = ACTIONS(1538),
    [anon_sym_CARET] = ACTIONS(1540),
    [anon_sym_EQ_EQ] = ACTIONS(1542),
    [anon_sym_BANG_EQ] = ACTIONS(1542),
    [anon_sym_LT] = ACTIONS(1544),
    [anon_sym_GT] = ACTIONS(1544),
    [anon_sym_LT_EQ] = ACTIONS(1546),
    [anon_sym_GT_EQ] = ACTIONS(1546),
    [anon_sym_LT_LT] = ACTIONS(1548),
    [anon_sym_GT_GT] = ACTIONS(1548),
    [anon_sym_PLUS] = ACTIONS(1550),
    [anon_sym_DASH] = ACTIONS(1550),
    [anon_sym_SLASH] = ACTIONS(1522),
    [anon_sym_PERCENT] = ACTIONS(1522),
    [anon_sym_DASH_DASH] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(1554),
    [anon_sym_DASH_GT] = ACTIONS(1554),
    [sym_comment] = ACTIONS(49),
  },
  [2244] = {
    [sym_argument_list] = STATE(802),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_STAR] = ACTIONS(1522),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_RBRACK] = ACTIONS(5988),
    [anon_sym_EQ] = ACTIONS(1526),
    [anon_sym_QMARK] = ACTIONS(1528),
    [anon_sym_STAR_EQ] = ACTIONS(1530),
    [anon_sym_SLASH_EQ] = ACTIONS(1530),
    [anon_sym_PERCENT_EQ] = ACTIONS(1530),
    [anon_sym_PLUS_EQ] = ACTIONS(1530),
    [anon_sym_DASH_EQ] = ACTIONS(1530),
    [anon_sym_LT_LT_EQ] = ACTIONS(1530),
    [anon_sym_GT_GT_EQ] = ACTIONS(1530),
    [anon_sym_AMP_EQ] = ACTIONS(1530),
    [anon_sym_CARET_EQ] = ACTIONS(1530),
    [anon_sym_PIPE_EQ] = ACTIONS(1530),
    [anon_sym_AMP] = ACTIONS(1532),
    [anon_sym_PIPE_PIPE] = ACTIONS(1534),
    [anon_sym_AMP_AMP] = ACTIONS(1536),
    [anon_sym_PIPE] = ACTIONS(1538),
    [anon_sym_CARET] = ACTIONS(1540),
    [anon_sym_EQ_EQ] = ACTIONS(1542),
    [anon_sym_BANG_EQ] = ACTIONS(1542),
    [anon_sym_LT] = ACTIONS(1544),
    [anon_sym_GT] = ACTIONS(1544),
    [anon_sym_LT_EQ] = ACTIONS(1546),
    [anon_sym_GT_EQ] = ACTIONS(1546),
    [anon_sym_LT_LT] = ACTIONS(1548),
    [anon_sym_GT_GT] = ACTIONS(1548),
    [anon_sym_PLUS] = ACTIONS(1550),
    [anon_sym_DASH] = ACTIONS(1550),
    [anon_sym_SLASH] = ACTIONS(1522),
    [anon_sym_PERCENT] = ACTIONS(1522),
    [anon_sym_DASH_DASH] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(1554),
    [anon_sym_DASH_GT] = ACTIONS(1554),
    [sym_comment] = ACTIONS(49),
  },
  [2245] = {
    [sym_type_qualifier] = STATE(2249),
    [sym_trailing_return_type] = STATE(2168),
    [aux_sym_abstract_function_declarator_repeat1] = STATE(2249),
    [anon_sym_LPAREN] = ACTIONS(4998),
    [anon_sym_LBRACK] = ACTIONS(4998),
    [anon_sym_const] = ACTIONS(612),
    [anon_sym_restrict] = ACTIONS(614),
    [anon_sym_volatile] = ACTIONS(614),
    [anon_sym__Atomic] = ACTIONS(614),
    [anon_sym_mutable] = ACTIONS(614),
    [anon_sym_explicit] = ACTIONS(614),
    [anon_sym_constexpr] = ACTIONS(614),
    [anon_sym_DASH_GT] = ACTIONS(4320),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(5256),
  },
  [2246] = {
    [sym__type_specifier] = STATE(93),
    [sym_sized_type_specifier] = STATE(93),
    [sym_enum_specifier] = STATE(93),
    [sym_struct_specifier] = STATE(93),
    [sym_union_specifier] = STATE(93),
    [sym_macro_type_specifier] = STATE(93),
    [sym_class_specifier] = STATE(93),
    [sym_dependent_type] = STATE(93),
    [sym_template_type] = STATE(62),
    [sym_scoped_type_identifier] = STATE(34),
    [sym_scoped_namespace_identifier] = STATE(64),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2248),
    [anon_sym_unsigned] = ACTIONS(5250),
    [anon_sym_long] = ACTIONS(5250),
    [anon_sym_short] = ACTIONS(5250),
    [sym_primitive_type] = ACTIONS(150),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(428),
    [anon_sym_union] = ACTIONS(430),
    [sym_identifier] = ACTIONS(434),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(436),
    [sym_auto] = ACTIONS(150),
    [anon_sym_typename] = ACTIONS(5254),
    [anon_sym_COLON_COLON] = ACTIONS(111),
  },
  [2247] = {
    [sym__abstract_declarator] = STATE(1345),
    [sym_abstract_pointer_declarator] = STATE(1345),
    [sym_abstract_function_declarator] = STATE(1345),
    [sym_abstract_array_declarator] = STATE(1345),
    [sym_parameter_list] = STATE(1346),
    [sym_abstract_reference_declarator] = STATE(1345),
    [anon_sym_LPAREN] = ACTIONS(1115),
    [anon_sym_STAR] = ACTIONS(1558),
    [anon_sym_LBRACK] = ACTIONS(1121),
    [anon_sym_AMP] = ACTIONS(1560),
    [anon_sym_AMP_AMP] = ACTIONS(1562),
    [sym_comment] = ACTIONS(49),
  },
  [2248] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2505),
    [anon_sym_LPAREN] = ACTIONS(238),
    [anon_sym_STAR] = ACTIONS(238),
    [anon_sym_LBRACK] = ACTIONS(238),
    [anon_sym_unsigned] = ACTIONS(5990),
    [anon_sym_long] = ACTIONS(5990),
    [anon_sym_short] = ACTIONS(5990),
    [sym_primitive_type] = ACTIONS(244),
    [anon_sym_AMP] = ACTIONS(240),
    [anon_sym_AMP_AMP] = ACTIONS(238),
    [sym_identifier] = ACTIONS(1135),
    [sym_comment] = ACTIONS(49),
  },
  [2249] = {
    [sym_type_qualifier] = STATE(2249),
    [aux_sym_abstract_function_declarator_repeat1] = STATE(2249),
    [anon_sym_LPAREN] = ACTIONS(5002),
    [anon_sym_LBRACK] = ACTIONS(5002),
    [anon_sym_const] = ACTIONS(5004),
    [anon_sym_restrict] = ACTIONS(5007),
    [anon_sym_volatile] = ACTIONS(5007),
    [anon_sym__Atomic] = ACTIONS(5007),
    [anon_sym_mutable] = ACTIONS(5007),
    [anon_sym_explicit] = ACTIONS(5007),
    [anon_sym_constexpr] = ACTIONS(5007),
    [anon_sym_DASH_GT] = ACTIONS(5002),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(5992),
  },
  [2250] = {
    [sym_enumerator_list] = STATE(230),
    [anon_sym_LPAREN] = ACTIONS(350),
    [anon_sym_LBRACE] = ACTIONS(350),
    [anon_sym_STAR] = ACTIONS(350),
    [anon_sym_LBRACK] = ACTIONS(350),
    [anon_sym_AMP] = ACTIONS(352),
    [anon_sym_AMP_AMP] = ACTIONS(350),
    [sym_comment] = ACTIONS(49),
  },
  [2251] = {
    [sym_field_declaration_list] = STATE(265),
    [sym_base_class_clause] = STATE(266),
    [anon_sym_LPAREN] = ACTIONS(406),
    [anon_sym_LBRACE] = ACTIONS(406),
    [anon_sym_STAR] = ACTIONS(406),
    [anon_sym_LBRACK] = ACTIONS(406),
    [anon_sym_COLON] = ACTIONS(943),
    [anon_sym_AMP] = ACTIONS(408),
    [anon_sym_AMP_AMP] = ACTIONS(406),
    [sym_comment] = ACTIONS(49),
  },
  [2252] = {
    [sym_field_declaration_list] = STATE(268),
    [sym_base_class_clause] = STATE(269),
    [anon_sym_LPAREN] = ACTIONS(416),
    [anon_sym_LBRACE] = ACTIONS(416),
    [anon_sym_STAR] = ACTIONS(416),
    [anon_sym_LBRACK] = ACTIONS(416),
    [anon_sym_COLON] = ACTIONS(943),
    [anon_sym_AMP] = ACTIONS(418),
    [anon_sym_AMP_AMP] = ACTIONS(416),
    [sym_comment] = ACTIONS(49),
  },
  [2253] = {
    [sym_field_declaration_list] = STATE(283),
    [sym_base_class_clause] = STATE(284),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_STAR] = ACTIONS(451),
    [anon_sym_LBRACK] = ACTIONS(451),
    [anon_sym_COLON] = ACTIONS(943),
    [anon_sym_AMP] = ACTIONS(453),
    [anon_sym_AMP_AMP] = ACTIONS(451),
    [sym_comment] = ACTIONS(49),
  },
  [2254] = {
    [sym__abstract_declarator] = STATE(2506),
    [sym_abstract_pointer_declarator] = STATE(2506),
    [sym_abstract_function_declarator] = STATE(2506),
    [sym_abstract_array_declarator] = STATE(2506),
    [sym_parameter_list] = STATE(809),
    [sym_abstract_reference_declarator] = STATE(2506),
    [anon_sym_LPAREN] = ACTIONS(1115),
    [anon_sym_LBRACE] = ACTIONS(2270),
    [anon_sym_STAR] = ACTIONS(5260),
    [anon_sym_LBRACK] = ACTIONS(1121),
    [anon_sym_AMP] = ACTIONS(5262),
    [anon_sym_AMP_AMP] = ACTIONS(5264),
    [sym_comment] = ACTIONS(49),
  },
  [2255] = {
    [sym__abstract_declarator] = STATE(2507),
    [sym_abstract_pointer_declarator] = STATE(2507),
    [sym_abstract_function_declarator] = STATE(2507),
    [sym_abstract_array_declarator] = STATE(2507),
    [sym_parameter_list] = STATE(809),
    [sym_abstract_reference_declarator] = STATE(2507),
    [anon_sym_LPAREN] = ACTIONS(1115),
    [anon_sym_LBRACE] = ACTIONS(2278),
    [anon_sym_STAR] = ACTIONS(5260),
    [anon_sym_LBRACK] = ACTIONS(1121),
    [anon_sym_AMP] = ACTIONS(5262),
    [anon_sym_AMP_AMP] = ACTIONS(5264),
    [sym_comment] = ACTIONS(49),
  },
  [2256] = {
    [sym_parameter_list] = STATE(1347),
    [anon_sym_LPAREN] = ACTIONS(206),
    [anon_sym_LBRACE] = ACTIONS(4364),
    [anon_sym_LBRACK] = ACTIONS(2282),
    [sym_comment] = ACTIONS(49),
  },
  [2257] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2257),
    [anon_sym_LPAREN] = ACTIONS(816),
    [anon_sym_LBRACE] = ACTIONS(816),
    [anon_sym_STAR] = ACTIONS(816),
    [anon_sym_LBRACK] = ACTIONS(816),
    [anon_sym_unsigned] = ACTIONS(5995),
    [anon_sym_long] = ACTIONS(5995),
    [anon_sym_short] = ACTIONS(5995),
    [sym_primitive_type] = ACTIONS(818),
    [anon_sym_AMP] = ACTIONS(818),
    [anon_sym_AMP_AMP] = ACTIONS(816),
    [sym_identifier] = ACTIONS(818),
    [sym_comment] = ACTIONS(49),
  },
  [2258] = {
    [anon_sym_LPAREN] = ACTIONS(3776),
    [anon_sym_COMMA] = ACTIONS(3776),
    [anon_sym_RPAREN] = ACTIONS(3776),
    [anon_sym_SEMI] = ACTIONS(3776),
    [anon_sym_extern] = ACTIONS(3778),
    [anon_sym_LBRACE] = ACTIONS(3776),
    [anon_sym_RBRACE] = ACTIONS(3776),
    [anon_sym_STAR] = ACTIONS(3778),
    [anon_sym_LBRACK] = ACTIONS(3776),
    [anon_sym_RBRACK] = ACTIONS(3776),
    [anon_sym_EQ] = ACTIONS(3778),
    [anon_sym_static] = ACTIONS(3778),
    [anon_sym_register] = ACTIONS(3778),
    [anon_sym_inline] = ACTIONS(3778),
    [anon_sym_const] = ACTIONS(3778),
    [anon_sym_restrict] = ACTIONS(3778),
    [anon_sym_volatile] = ACTIONS(3778),
    [anon_sym__Atomic] = ACTIONS(3778),
    [anon_sym_mutable] = ACTIONS(3778),
    [anon_sym_explicit] = ACTIONS(3778),
    [anon_sym_constexpr] = ACTIONS(3778),
    [anon_sym_COLON] = ACTIONS(3778),
    [anon_sym_QMARK] = ACTIONS(3776),
    [anon_sym_STAR_EQ] = ACTIONS(3776),
    [anon_sym_SLASH_EQ] = ACTIONS(3776),
    [anon_sym_PERCENT_EQ] = ACTIONS(3776),
    [anon_sym_PLUS_EQ] = ACTIONS(3776),
    [anon_sym_DASH_EQ] = ACTIONS(3776),
    [anon_sym_LT_LT_EQ] = ACTIONS(3776),
    [anon_sym_GT_GT_EQ] = ACTIONS(3776),
    [anon_sym_AMP_EQ] = ACTIONS(3776),
    [anon_sym_CARET_EQ] = ACTIONS(3776),
    [anon_sym_PIPE_EQ] = ACTIONS(3776),
    [anon_sym_AMP] = ACTIONS(3778),
    [anon_sym_PIPE_PIPE] = ACTIONS(3776),
    [anon_sym_AMP_AMP] = ACTIONS(3776),
    [anon_sym_PIPE] = ACTIONS(3778),
    [anon_sym_CARET] = ACTIONS(3778),
    [anon_sym_TILDE] = ACTIONS(3776),
    [anon_sym_EQ_EQ] = ACTIONS(3776),
    [anon_sym_BANG_EQ] = ACTIONS(3776),
    [anon_sym_LT] = ACTIONS(3778),
    [anon_sym_GT] = ACTIONS(3778),
    [anon_sym_LT_EQ] = ACTIONS(3776),
    [anon_sym_GT_EQ] = ACTIONS(3776),
    [anon_sym_LT_LT] = ACTIONS(3778),
    [anon_sym_GT_GT] = ACTIONS(3778),
    [anon_sym_PLUS] = ACTIONS(3778),
    [anon_sym_DASH] = ACTIONS(3778),
    [anon_sym_SLASH] = ACTIONS(3778),
    [anon_sym_PERCENT] = ACTIONS(3778),
    [anon_sym_DASH_DASH] = ACTIONS(3776),
    [anon_sym_PLUS_PLUS] = ACTIONS(3776),
    [anon_sym_DOT] = ACTIONS(3776),
    [anon_sym_DASH_GT] = ACTIONS(3776),
    [sym_identifier] = ACTIONS(3778),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(3776),
    [sym_operator_name] = ACTIONS(3776),
  },
  [2259] = {
    [sym_raw_string_literal] = ACTIONS(3776),
    [anon_sym_LPAREN] = ACTIONS(3776),
    [anon_sym_extern] = ACTIONS(3778),
    [anon_sym_LBRACE] = ACTIONS(3776),
    [anon_sym_STAR] = ACTIONS(3776),
    [anon_sym_LBRACK] = ACTIONS(3776),
    [anon_sym_RBRACK] = ACTIONS(3776),
    [anon_sym_static] = ACTIONS(3778),
    [anon_sym_register] = ACTIONS(3778),
    [anon_sym_inline] = ACTIONS(3778),
    [anon_sym_const] = ACTIONS(3778),
    [anon_sym_restrict] = ACTIONS(3778),
    [anon_sym_volatile] = ACTIONS(3778),
    [anon_sym__Atomic] = ACTIONS(3778),
    [anon_sym_mutable] = ACTIONS(3778),
    [anon_sym_explicit] = ACTIONS(3778),
    [anon_sym_constexpr] = ACTIONS(3778),
    [anon_sym_COLON] = ACTIONS(3778),
    [anon_sym_AMP] = ACTIONS(3776),
    [anon_sym_BANG] = ACTIONS(3776),
    [anon_sym_TILDE] = ACTIONS(3776),
    [anon_sym_PLUS] = ACTIONS(3778),
    [anon_sym_DASH] = ACTIONS(3778),
    [anon_sym_DASH_DASH] = ACTIONS(3776),
    [anon_sym_PLUS_PLUS] = ACTIONS(3776),
    [anon_sym_sizeof] = ACTIONS(3778),
    [sym_number_literal] = ACTIONS(3776),
    [sym_char_literal] = ACTIONS(3776),
    [sym_string_literal] = ACTIONS(3776),
    [sym_true] = ACTIONS(3778),
    [sym_false] = ACTIONS(3778),
    [sym_null] = ACTIONS(3778),
    [sym_identifier] = ACTIONS(3778),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(3778),
    [anon_sym_COLON_COLON] = ACTIONS(3776),
    [anon_sym_delete] = ACTIONS(3778),
    [sym_nullptr] = ACTIONS(3778),
  },
  [2260] = {
    [anon_sym_LPAREN] = ACTIONS(2010),
    [anon_sym_COMMA] = ACTIONS(2010),
    [anon_sym_RPAREN] = ACTIONS(2010),
    [anon_sym_SEMI] = ACTIONS(2010),
    [anon_sym_LBRACE] = ACTIONS(2010),
    [anon_sym_STAR] = ACTIONS(2010),
    [anon_sym_LBRACK] = ACTIONS(2010),
    [anon_sym_EQ] = ACTIONS(2010),
    [anon_sym_const] = ACTIONS(2012),
    [anon_sym_restrict] = ACTIONS(2010),
    [anon_sym_volatile] = ACTIONS(2010),
    [anon_sym__Atomic] = ACTIONS(2010),
    [anon_sym_mutable] = ACTIONS(2010),
    [anon_sym_explicit] = ACTIONS(2010),
    [anon_sym_constexpr] = ACTIONS(2010),
    [anon_sym_COLON] = ACTIONS(2010),
    [anon_sym_AMP] = ACTIONS(2012),
    [anon_sym_AMP_AMP] = ACTIONS(2010),
    [anon_sym_GT] = ACTIONS(2010),
    [anon_sym_DASH_GT] = ACTIONS(2010),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(2010),
  },
  [2261] = {
    [sym_enumerator] = STATE(1030),
    [anon_sym_RBRACE] = ACTIONS(5998),
    [sym_identifier] = ACTIONS(348),
    [sym_comment] = ACTIONS(49),
  },
  [2262] = {
    [aux_sym_enumerator_list_repeat1] = STATE(1032),
    [anon_sym_COMMA] = ACTIONS(6000),
    [anon_sym_RBRACE] = ACTIONS(5998),
    [sym_comment] = ACTIONS(49),
  },
  [2263] = {
    [anon_sym_LPAREN] = ACTIONS(2114),
    [anon_sym_COMMA] = ACTIONS(2114),
    [anon_sym_RPAREN] = ACTIONS(2114),
    [anon_sym_SEMI] = ACTIONS(2114),
    [anon_sym_LBRACE] = ACTIONS(2114),
    [anon_sym_STAR] = ACTIONS(2114),
    [anon_sym_LBRACK] = ACTIONS(2114),
    [anon_sym_EQ] = ACTIONS(2114),
    [anon_sym_const] = ACTIONS(2116),
    [anon_sym_restrict] = ACTIONS(2114),
    [anon_sym_volatile] = ACTIONS(2114),
    [anon_sym__Atomic] = ACTIONS(2114),
    [anon_sym_mutable] = ACTIONS(2114),
    [anon_sym_explicit] = ACTIONS(2114),
    [anon_sym_constexpr] = ACTIONS(2114),
    [anon_sym_COLON] = ACTIONS(2114),
    [anon_sym_AMP] = ACTIONS(2116),
    [anon_sym_AMP_AMP] = ACTIONS(2114),
    [anon_sym_GT] = ACTIONS(2114),
    [anon_sym_DASH_GT] = ACTIONS(2114),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(2114),
  },
  [2264] = {
    [anon_sym_LPAREN] = ACTIONS(2202),
    [anon_sym_COMMA] = ACTIONS(2202),
    [anon_sym_RPAREN] = ACTIONS(2202),
    [anon_sym_SEMI] = ACTIONS(2202),
    [anon_sym_LBRACE] = ACTIONS(2202),
    [anon_sym_STAR] = ACTIONS(2202),
    [anon_sym_LBRACK] = ACTIONS(2202),
    [anon_sym_EQ] = ACTIONS(2202),
    [anon_sym_const] = ACTIONS(2204),
    [anon_sym_restrict] = ACTIONS(2202),
    [anon_sym_volatile] = ACTIONS(2202),
    [anon_sym__Atomic] = ACTIONS(2202),
    [anon_sym_mutable] = ACTIONS(2202),
    [anon_sym_explicit] = ACTIONS(2202),
    [anon_sym_constexpr] = ACTIONS(2202),
    [anon_sym_COLON] = ACTIONS(2202),
    [anon_sym_AMP] = ACTIONS(2204),
    [anon_sym_AMP_AMP] = ACTIONS(2202),
    [anon_sym_GT] = ACTIONS(2202),
    [anon_sym_DASH_GT] = ACTIONS(2202),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(2202),
  },
  [2265] = {
    [anon_sym_LPAREN] = ACTIONS(2206),
    [anon_sym_COMMA] = ACTIONS(2206),
    [anon_sym_RPAREN] = ACTIONS(2206),
    [anon_sym_SEMI] = ACTIONS(2206),
    [anon_sym_LBRACE] = ACTIONS(2206),
    [anon_sym_STAR] = ACTIONS(2206),
    [anon_sym_LBRACK] = ACTIONS(2206),
    [anon_sym_EQ] = ACTIONS(2206),
    [anon_sym_const] = ACTIONS(2208),
    [anon_sym_restrict] = ACTIONS(2206),
    [anon_sym_volatile] = ACTIONS(2206),
    [anon_sym__Atomic] = ACTIONS(2206),
    [anon_sym_mutable] = ACTIONS(2206),
    [anon_sym_explicit] = ACTIONS(2206),
    [anon_sym_constexpr] = ACTIONS(2206),
    [anon_sym_COLON] = ACTIONS(2206),
    [anon_sym_AMP] = ACTIONS(2208),
    [anon_sym_AMP_AMP] = ACTIONS(2206),
    [anon_sym_GT] = ACTIONS(2206),
    [anon_sym_DASH_GT] = ACTIONS(2206),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(2206),
  },
  [2266] = {
    [anon_sym_LPAREN] = ACTIONS(2290),
    [anon_sym_COMMA] = ACTIONS(2290),
    [anon_sym_RPAREN] = ACTIONS(2290),
    [anon_sym_SEMI] = ACTIONS(2290),
    [anon_sym_LBRACE] = ACTIONS(2290),
    [anon_sym_STAR] = ACTIONS(2290),
    [anon_sym_LBRACK] = ACTIONS(2290),
    [anon_sym_EQ] = ACTIONS(2290),
    [anon_sym_const] = ACTIONS(2292),
    [anon_sym_restrict] = ACTIONS(2290),
    [anon_sym_volatile] = ACTIONS(2290),
    [anon_sym__Atomic] = ACTIONS(2290),
    [anon_sym_mutable] = ACTIONS(2290),
    [anon_sym_explicit] = ACTIONS(2290),
    [anon_sym_constexpr] = ACTIONS(2290),
    [anon_sym_COLON] = ACTIONS(2292),
    [anon_sym_AMP] = ACTIONS(2292),
    [anon_sym_AMP_AMP] = ACTIONS(2290),
    [anon_sym_GT] = ACTIONS(2290),
    [anon_sym_DASH_GT] = ACTIONS(2290),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(2290),
    [anon_sym_COLON_COLON] = ACTIONS(2290),
  },
  [2267] = {
    [aux_sym_template_argument_list_repeat1] = STATE(1133),
    [anon_sym_COMMA] = ACTIONS(1127),
    [anon_sym_GT] = ACTIONS(6002),
    [sym_comment] = ACTIONS(49),
  },
  [2268] = {
    [anon_sym_LPAREN] = ACTIONS(2299),
    [anon_sym_COMMA] = ACTIONS(2299),
    [anon_sym_RPAREN] = ACTIONS(2299),
    [anon_sym_SEMI] = ACTIONS(2299),
    [anon_sym_LBRACE] = ACTIONS(2299),
    [anon_sym_STAR] = ACTIONS(2299),
    [anon_sym_LBRACK] = ACTIONS(2299),
    [anon_sym_EQ] = ACTIONS(2299),
    [anon_sym_const] = ACTIONS(2301),
    [anon_sym_restrict] = ACTIONS(2299),
    [anon_sym_volatile] = ACTIONS(2299),
    [anon_sym__Atomic] = ACTIONS(2299),
    [anon_sym_mutable] = ACTIONS(2299),
    [anon_sym_explicit] = ACTIONS(2299),
    [anon_sym_constexpr] = ACTIONS(2299),
    [anon_sym_COLON] = ACTIONS(2299),
    [anon_sym_AMP] = ACTIONS(2301),
    [anon_sym_AMP_AMP] = ACTIONS(2299),
    [anon_sym_GT] = ACTIONS(2299),
    [anon_sym_DASH_GT] = ACTIONS(2299),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(2299),
  },
  [2269] = {
    [sym_type_qualifier] = STATE(2270),
    [sym_trailing_return_type] = STATE(2168),
    [aux_sym_abstract_function_declarator_repeat1] = STATE(2270),
    [anon_sym_LPAREN] = ACTIONS(4998),
    [anon_sym_LBRACE] = ACTIONS(4998),
    [anon_sym_LBRACK] = ACTIONS(4998),
    [anon_sym_const] = ACTIONS(612),
    [anon_sym_restrict] = ACTIONS(614),
    [anon_sym_volatile] = ACTIONS(614),
    [anon_sym__Atomic] = ACTIONS(614),
    [anon_sym_mutable] = ACTIONS(614),
    [anon_sym_explicit] = ACTIONS(614),
    [anon_sym_constexpr] = ACTIONS(614),
    [anon_sym_COLON] = ACTIONS(4998),
    [anon_sym_DASH_GT] = ACTIONS(616),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(5287),
  },
  [2270] = {
    [sym_type_qualifier] = STATE(2270),
    [aux_sym_abstract_function_declarator_repeat1] = STATE(2270),
    [anon_sym_LPAREN] = ACTIONS(5002),
    [anon_sym_LBRACE] = ACTIONS(5002),
    [anon_sym_LBRACK] = ACTIONS(5002),
    [anon_sym_const] = ACTIONS(5004),
    [anon_sym_restrict] = ACTIONS(5007),
    [anon_sym_volatile] = ACTIONS(5007),
    [anon_sym__Atomic] = ACTIONS(5007),
    [anon_sym_mutable] = ACTIONS(5007),
    [anon_sym_explicit] = ACTIONS(5007),
    [anon_sym_constexpr] = ACTIONS(5007),
    [anon_sym_COLON] = ACTIONS(5002),
    [anon_sym_DASH_GT] = ACTIONS(5002),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(6004),
  },
  [2271] = {
    [sym_raw_string_literal] = ACTIONS(3342),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3344),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3344),
    [anon_sym_LPAREN] = ACTIONS(3342),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3344),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3344),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3344),
    [sym_preproc_directive] = ACTIONS(3344),
    [anon_sym_SEMI] = ACTIONS(3342),
    [anon_sym_typedef] = ACTIONS(3344),
    [anon_sym_extern] = ACTIONS(3344),
    [anon_sym_LBRACE] = ACTIONS(3342),
    [anon_sym_RBRACE] = ACTIONS(3342),
    [anon_sym_STAR] = ACTIONS(3342),
    [anon_sym_LBRACK] = ACTIONS(3342),
    [anon_sym_static] = ACTIONS(3344),
    [anon_sym_register] = ACTIONS(3344),
    [anon_sym_inline] = ACTIONS(3344),
    [anon_sym_const] = ACTIONS(3344),
    [anon_sym_restrict] = ACTIONS(3344),
    [anon_sym_volatile] = ACTIONS(3344),
    [anon_sym__Atomic] = ACTIONS(3344),
    [anon_sym_mutable] = ACTIONS(3344),
    [anon_sym_explicit] = ACTIONS(3344),
    [anon_sym_constexpr] = ACTIONS(3344),
    [anon_sym_unsigned] = ACTIONS(3344),
    [anon_sym_long] = ACTIONS(3344),
    [anon_sym_short] = ACTIONS(3344),
    [sym_primitive_type] = ACTIONS(3344),
    [anon_sym_enum] = ACTIONS(3344),
    [anon_sym_struct] = ACTIONS(3344),
    [anon_sym_union] = ACTIONS(3344),
    [anon_sym_if] = ACTIONS(3344),
    [anon_sym_switch] = ACTIONS(3344),
    [anon_sym_case] = ACTIONS(3344),
    [anon_sym_default] = ACTIONS(3344),
    [anon_sym_while] = ACTIONS(3344),
    [anon_sym_do] = ACTIONS(3344),
    [anon_sym_for] = ACTIONS(3344),
    [anon_sym_return] = ACTIONS(3344),
    [anon_sym_break] = ACTIONS(3344),
    [anon_sym_continue] = ACTIONS(3344),
    [anon_sym_goto] = ACTIONS(3344),
    [anon_sym_AMP] = ACTIONS(3342),
    [anon_sym_BANG] = ACTIONS(3342),
    [anon_sym_TILDE] = ACTIONS(3342),
    [anon_sym_PLUS] = ACTIONS(3344),
    [anon_sym_DASH] = ACTIONS(3344),
    [anon_sym_DASH_DASH] = ACTIONS(3342),
    [anon_sym_PLUS_PLUS] = ACTIONS(3342),
    [anon_sym_sizeof] = ACTIONS(3344),
    [sym_number_literal] = ACTIONS(3342),
    [sym_char_literal] = ACTIONS(3342),
    [sym_string_literal] = ACTIONS(3342),
    [sym_true] = ACTIONS(3344),
    [sym_false] = ACTIONS(3344),
    [sym_null] = ACTIONS(3344),
    [sym_identifier] = ACTIONS(3344),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(3344),
    [sym_auto] = ACTIONS(3344),
    [anon_sym_typename] = ACTIONS(3344),
    [anon_sym_new] = ACTIONS(3344),
    [anon_sym_COLON_COLON] = ACTIONS(3342),
    [anon_sym_delete] = ACTIONS(3344),
    [sym_nullptr] = ACTIONS(3344),
  },
  [2272] = {
    [sym_raw_string_literal] = ACTIONS(3352),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3354),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3354),
    [anon_sym_LPAREN] = ACTIONS(3352),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3354),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3354),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3354),
    [sym_preproc_directive] = ACTIONS(3354),
    [anon_sym_SEMI] = ACTIONS(3352),
    [anon_sym_typedef] = ACTIONS(3354),
    [anon_sym_extern] = ACTIONS(3354),
    [anon_sym_LBRACE] = ACTIONS(3352),
    [anon_sym_RBRACE] = ACTIONS(3352),
    [anon_sym_STAR] = ACTIONS(3352),
    [anon_sym_LBRACK] = ACTIONS(3352),
    [anon_sym_static] = ACTIONS(3354),
    [anon_sym_register] = ACTIONS(3354),
    [anon_sym_inline] = ACTIONS(3354),
    [anon_sym_const] = ACTIONS(3354),
    [anon_sym_restrict] = ACTIONS(3354),
    [anon_sym_volatile] = ACTIONS(3354),
    [anon_sym__Atomic] = ACTIONS(3354),
    [anon_sym_mutable] = ACTIONS(3354),
    [anon_sym_explicit] = ACTIONS(3354),
    [anon_sym_constexpr] = ACTIONS(3354),
    [anon_sym_unsigned] = ACTIONS(3354),
    [anon_sym_long] = ACTIONS(3354),
    [anon_sym_short] = ACTIONS(3354),
    [sym_primitive_type] = ACTIONS(3354),
    [anon_sym_enum] = ACTIONS(3354),
    [anon_sym_struct] = ACTIONS(3354),
    [anon_sym_union] = ACTIONS(3354),
    [anon_sym_if] = ACTIONS(3354),
    [anon_sym_switch] = ACTIONS(3354),
    [anon_sym_case] = ACTIONS(3354),
    [anon_sym_default] = ACTIONS(3354),
    [anon_sym_while] = ACTIONS(3354),
    [anon_sym_do] = ACTIONS(3354),
    [anon_sym_for] = ACTIONS(3354),
    [anon_sym_return] = ACTIONS(3354),
    [anon_sym_break] = ACTIONS(3354),
    [anon_sym_continue] = ACTIONS(3354),
    [anon_sym_goto] = ACTIONS(3354),
    [anon_sym_AMP] = ACTIONS(3352),
    [anon_sym_BANG] = ACTIONS(3352),
    [anon_sym_TILDE] = ACTIONS(3352),
    [anon_sym_PLUS] = ACTIONS(3354),
    [anon_sym_DASH] = ACTIONS(3354),
    [anon_sym_DASH_DASH] = ACTIONS(3352),
    [anon_sym_PLUS_PLUS] = ACTIONS(3352),
    [anon_sym_sizeof] = ACTIONS(3354),
    [sym_number_literal] = ACTIONS(3352),
    [sym_char_literal] = ACTIONS(3352),
    [sym_string_literal] = ACTIONS(3352),
    [sym_true] = ACTIONS(3354),
    [sym_false] = ACTIONS(3354),
    [sym_null] = ACTIONS(3354),
    [sym_identifier] = ACTIONS(3354),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(3354),
    [sym_auto] = ACTIONS(3354),
    [anon_sym_typename] = ACTIONS(3354),
    [anon_sym_new] = ACTIONS(3354),
    [anon_sym_COLON_COLON] = ACTIONS(3352),
    [anon_sym_delete] = ACTIONS(3354),
    [sym_nullptr] = ACTIONS(3354),
  },
  [2273] = {
    [sym_preproc_arg] = ACTIONS(6007),
    [sym_comment] = ACTIONS(83),
  },
  [2274] = {
    [sym_raw_string_literal] = ACTIONS(825),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(827),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(827),
    [anon_sym_LPAREN] = ACTIONS(825),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(827),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(827),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(827),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(827),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(827),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(827),
    [sym_preproc_directive] = ACTIONS(827),
    [anon_sym_SEMI] = ACTIONS(825),
    [anon_sym_typedef] = ACTIONS(827),
    [anon_sym_extern] = ACTIONS(827),
    [anon_sym_LBRACE] = ACTIONS(825),
    [anon_sym_STAR] = ACTIONS(825),
    [anon_sym_LBRACK] = ACTIONS(825),
    [anon_sym_static] = ACTIONS(827),
    [anon_sym_register] = ACTIONS(827),
    [anon_sym_inline] = ACTIONS(827),
    [anon_sym_const] = ACTIONS(827),
    [anon_sym_restrict] = ACTIONS(827),
    [anon_sym_volatile] = ACTIONS(827),
    [anon_sym__Atomic] = ACTIONS(827),
    [anon_sym_mutable] = ACTIONS(827),
    [anon_sym_explicit] = ACTIONS(827),
    [anon_sym_constexpr] = ACTIONS(827),
    [anon_sym_unsigned] = ACTIONS(827),
    [anon_sym_long] = ACTIONS(827),
    [anon_sym_short] = ACTIONS(827),
    [sym_primitive_type] = ACTIONS(827),
    [anon_sym_enum] = ACTIONS(827),
    [anon_sym_struct] = ACTIONS(827),
    [anon_sym_union] = ACTIONS(827),
    [anon_sym_if] = ACTIONS(827),
    [anon_sym_switch] = ACTIONS(827),
    [anon_sym_case] = ACTIONS(827),
    [anon_sym_default] = ACTIONS(827),
    [anon_sym_while] = ACTIONS(827),
    [anon_sym_do] = ACTIONS(827),
    [anon_sym_for] = ACTIONS(827),
    [anon_sym_return] = ACTIONS(827),
    [anon_sym_break] = ACTIONS(827),
    [anon_sym_continue] = ACTIONS(827),
    [anon_sym_goto] = ACTIONS(827),
    [anon_sym_AMP] = ACTIONS(825),
    [anon_sym_BANG] = ACTIONS(825),
    [anon_sym_TILDE] = ACTIONS(825),
    [anon_sym_PLUS] = ACTIONS(827),
    [anon_sym_DASH] = ACTIONS(827),
    [anon_sym_DASH_DASH] = ACTIONS(825),
    [anon_sym_PLUS_PLUS] = ACTIONS(825),
    [anon_sym_sizeof] = ACTIONS(827),
    [sym_number_literal] = ACTIONS(825),
    [sym_char_literal] = ACTIONS(825),
    [sym_string_literal] = ACTIONS(825),
    [sym_true] = ACTIONS(827),
    [sym_false] = ACTIONS(827),
    [sym_null] = ACTIONS(827),
    [sym_identifier] = ACTIONS(827),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(827),
    [sym_auto] = ACTIONS(827),
    [anon_sym_typename] = ACTIONS(827),
    [anon_sym_new] = ACTIONS(827),
    [anon_sym_COLON_COLON] = ACTIONS(825),
    [anon_sym_delete] = ACTIONS(827),
    [sym_nullptr] = ACTIONS(827),
  },
  [2275] = {
    [anon_sym_LF] = ACTIONS(6009),
    [sym_preproc_arg] = ACTIONS(6011),
    [sym_comment] = ACTIONS(83),
  },
  [2276] = {
    [sym_raw_string_literal] = ACTIONS(4387),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(4389),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(4389),
    [anon_sym_LPAREN] = ACTIONS(4387),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(4389),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(4389),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(4389),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(4389),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(4389),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(4389),
    [sym_preproc_directive] = ACTIONS(4389),
    [anon_sym_SEMI] = ACTIONS(4387),
    [anon_sym_typedef] = ACTIONS(4389),
    [anon_sym_extern] = ACTIONS(4389),
    [anon_sym_LBRACE] = ACTIONS(4387),
    [anon_sym_STAR] = ACTIONS(4387),
    [anon_sym_LBRACK] = ACTIONS(4387),
    [anon_sym_static] = ACTIONS(4389),
    [anon_sym_register] = ACTIONS(4389),
    [anon_sym_inline] = ACTIONS(4389),
    [anon_sym_const] = ACTIONS(4389),
    [anon_sym_restrict] = ACTIONS(4389),
    [anon_sym_volatile] = ACTIONS(4389),
    [anon_sym__Atomic] = ACTIONS(4389),
    [anon_sym_mutable] = ACTIONS(4389),
    [anon_sym_explicit] = ACTIONS(4389),
    [anon_sym_constexpr] = ACTIONS(4389),
    [anon_sym_unsigned] = ACTIONS(4389),
    [anon_sym_long] = ACTIONS(4389),
    [anon_sym_short] = ACTIONS(4389),
    [sym_primitive_type] = ACTIONS(4389),
    [anon_sym_enum] = ACTIONS(4389),
    [anon_sym_struct] = ACTIONS(4389),
    [anon_sym_union] = ACTIONS(4389),
    [anon_sym_if] = ACTIONS(4389),
    [anon_sym_switch] = ACTIONS(4389),
    [anon_sym_case] = ACTIONS(4389),
    [anon_sym_default] = ACTIONS(4389),
    [anon_sym_while] = ACTIONS(4389),
    [anon_sym_do] = ACTIONS(4389),
    [anon_sym_for] = ACTIONS(4389),
    [anon_sym_return] = ACTIONS(4389),
    [anon_sym_break] = ACTIONS(4389),
    [anon_sym_continue] = ACTIONS(4389),
    [anon_sym_goto] = ACTIONS(4389),
    [anon_sym_AMP] = ACTIONS(4387),
    [anon_sym_BANG] = ACTIONS(4387),
    [anon_sym_TILDE] = ACTIONS(4387),
    [anon_sym_PLUS] = ACTIONS(4389),
    [anon_sym_DASH] = ACTIONS(4389),
    [anon_sym_DASH_DASH] = ACTIONS(4387),
    [anon_sym_PLUS_PLUS] = ACTIONS(4387),
    [anon_sym_sizeof] = ACTIONS(4389),
    [sym_number_literal] = ACTIONS(4387),
    [sym_char_literal] = ACTIONS(4387),
    [sym_string_literal] = ACTIONS(4387),
    [sym_true] = ACTIONS(4389),
    [sym_false] = ACTIONS(4389),
    [sym_null] = ACTIONS(4389),
    [sym_identifier] = ACTIONS(4389),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(4389),
    [sym_auto] = ACTIONS(4389),
    [anon_sym_typename] = ACTIONS(4389),
    [anon_sym_new] = ACTIONS(4389),
    [anon_sym_COLON_COLON] = ACTIONS(4387),
    [anon_sym_delete] = ACTIONS(4389),
    [sym_nullptr] = ACTIONS(4389),
  },
  [2277] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(6013),
    [sym_comment] = ACTIONS(49),
  },
  [2278] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(6015),
    [sym_comment] = ACTIONS(49),
  },
  [2279] = {
    [sym_preproc_include] = STATE(1983),
    [sym_preproc_def] = STATE(1983),
    [sym_preproc_function_def] = STATE(1983),
    [sym_preproc_call] = STATE(1983),
    [sym_preproc_if_in_compound_statement] = STATE(1414),
    [sym_preproc_ifdef_in_compound_statement] = STATE(1415),
    [sym_preproc_else_in_compound_statement] = STATE(2517),
    [sym_preproc_elif_in_compound_statement] = STATE(2518),
    [sym_declaration] = STATE(1983),
    [sym_type_definition] = STATE(1983),
    [sym__declaration_specifiers] = STATE(1418),
    [sym_compound_statement] = STATE(1983),
    [sym_storage_class_specifier] = STATE(419),
    [sym_type_qualifier] = STATE(419),
    [sym__type_specifier] = STATE(30),
    [sym_sized_type_specifier] = STATE(30),
    [sym_enum_specifier] = STATE(30),
    [sym_struct_specifier] = STATE(30),
    [sym_union_specifier] = STATE(30),
    [sym_labeled_statement] = STATE(1983),
    [sym_expression_statement] = STATE(1983),
    [sym_if_statement] = STATE(1983),
    [sym_switch_statement] = STATE(1983),
    [sym_case_statement] = STATE(1983),
    [sym_while_statement] = STATE(1983),
    [sym_do_statement] = STATE(1983),
    [sym_for_statement] = STATE(1983),
    [sym_return_statement] = STATE(1983),
    [sym_break_statement] = STATE(1983),
    [sym_continue_statement] = STATE(1983),
    [sym_goto_statement] = STATE(1983),
    [sym__expression] = STATE(1419),
    [sym_comma_expression] = STATE(1420),
    [sym_conditional_expression] = STATE(1419),
    [sym_assignment_expression] = STATE(1419),
    [sym_pointer_expression] = STATE(1419),
    [sym_logical_expression] = STATE(1419),
    [sym_bitwise_expression] = STATE(1419),
    [sym_equality_expression] = STATE(1419),
    [sym_relational_expression] = STATE(1419),
    [sym_shift_expression] = STATE(1419),
    [sym_math_expression] = STATE(1419),
    [sym_cast_expression] = STATE(1419),
    [sym_sizeof_expression] = STATE(1419),
    [sym_subscript_expression] = STATE(1419),
    [sym_call_expression] = STATE(1419),
    [sym_field_expression] = STATE(1419),
    [sym_compound_literal_expression] = STATE(1419),
    [sym_parenthesized_expression] = STATE(1419),
    [sym_concatenated_string] = STATE(1419),
    [sym__empty_declaration] = STATE(1983),
    [sym_macro_type_specifier] = STATE(30),
    [sym_class_specifier] = STATE(30),
    [sym_dependent_type] = STATE(30),
    [sym_structured_binding_declaration] = STATE(1983),
    [sym_template_type] = STATE(415),
    [sym_template_function] = STATE(1419),
    [sym_for_range_loop] = STATE(1983),
    [sym_new_expression] = STATE(1419),
    [sym_delete_expression] = STATE(1419),
    [sym_lambda_expression] = STATE(1419),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(416),
    [sym_scoped_namespace_identifier] = STATE(417),
    [aux_sym_preproc_if_in_compound_statement_repeat1] = STATE(1983),
    [aux_sym__declaration_specifiers_repeat1] = STATE(419),
    [aux_sym_sized_type_specifier_repeat1] = STATE(38),
    [sym_raw_string_literal] = ACTIONS(2879),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(2881),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(2883),
    [anon_sym_LPAREN] = ACTIONS(626),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(2885),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(6017),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(2889),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(2891),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(2893),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(2895),
    [sym_preproc_directive] = ACTIONS(2897),
    [anon_sym_SEMI] = ACTIONS(2899),
    [anon_sym_typedef] = ACTIONS(2901),
    [anon_sym_extern] = ACTIONS(154),
    [anon_sym_LBRACE] = ACTIONS(2903),
    [anon_sym_STAR] = ACTIONS(644),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_static] = ACTIONS(154),
    [anon_sym_register] = ACTIONS(154),
    [anon_sym_inline] = ACTIONS(154),
    [anon_sym_const] = ACTIONS(158),
    [anon_sym_restrict] = ACTIONS(158),
    [anon_sym_volatile] = ACTIONS(158),
    [anon_sym__Atomic] = ACTIONS(158),
    [anon_sym_mutable] = ACTIONS(158),
    [anon_sym_explicit] = ACTIONS(158),
    [anon_sym_constexpr] = ACTIONS(158),
    [anon_sym_unsigned] = ACTIONS(31),
    [anon_sym_long] = ACTIONS(31),
    [anon_sym_short] = ACTIONS(31),
    [sym_primitive_type] = ACTIONS(33),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_union] = ACTIONS(39),
    [anon_sym_if] = ACTIONS(2905),
    [anon_sym_switch] = ACTIONS(2907),
    [anon_sym_case] = ACTIONS(2909),
    [anon_sym_default] = ACTIONS(2911),
    [anon_sym_while] = ACTIONS(2913),
    [anon_sym_do] = ACTIONS(2915),
    [anon_sym_for] = ACTIONS(2917),
    [anon_sym_return] = ACTIONS(2919),
    [anon_sym_break] = ACTIONS(2921),
    [anon_sym_continue] = ACTIONS(2923),
    [anon_sym_goto] = ACTIONS(2925),
    [anon_sym_AMP] = ACTIONS(644),
    [anon_sym_BANG] = ACTIONS(668),
    [anon_sym_TILDE] = ACTIONS(670),
    [anon_sym_PLUS] = ACTIONS(672),
    [anon_sym_DASH] = ACTIONS(672),
    [anon_sym_DASH_DASH] = ACTIONS(674),
    [anon_sym_PLUS_PLUS] = ACTIONS(674),
    [anon_sym_sizeof] = ACTIONS(676),
    [sym_number_literal] = ACTIONS(2879),
    [sym_char_literal] = ACTIONS(2879),
    [sym_string_literal] = ACTIONS(678),
    [sym_true] = ACTIONS(2927),
    [sym_false] = ACTIONS(2927),
    [sym_null] = ACTIONS(2927),
    [sym_identifier] = ACTIONS(2929),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(51),
    [sym_auto] = ACTIONS(33),
    [anon_sym_typename] = ACTIONS(53),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(684),
    [anon_sym_delete] = ACTIONS(686),
    [sym_nullptr] = ACTIONS(2927),
  },
  [2280] = {
    [sym_raw_string_literal] = ACTIONS(4495),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(4497),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(4497),
    [anon_sym_LPAREN] = ACTIONS(4495),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(4497),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(4497),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(4497),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(4497),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(4497),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(4497),
    [sym_preproc_directive] = ACTIONS(4497),
    [anon_sym_SEMI] = ACTIONS(4495),
    [anon_sym_typedef] = ACTIONS(4497),
    [anon_sym_extern] = ACTIONS(4497),
    [anon_sym_LBRACE] = ACTIONS(4495),
    [anon_sym_STAR] = ACTIONS(4495),
    [anon_sym_LBRACK] = ACTIONS(4495),
    [anon_sym_static] = ACTIONS(4497),
    [anon_sym_register] = ACTIONS(4497),
    [anon_sym_inline] = ACTIONS(4497),
    [anon_sym_const] = ACTIONS(4497),
    [anon_sym_restrict] = ACTIONS(4497),
    [anon_sym_volatile] = ACTIONS(4497),
    [anon_sym__Atomic] = ACTIONS(4497),
    [anon_sym_mutable] = ACTIONS(4497),
    [anon_sym_explicit] = ACTIONS(4497),
    [anon_sym_constexpr] = ACTIONS(4497),
    [anon_sym_unsigned] = ACTIONS(4497),
    [anon_sym_long] = ACTIONS(4497),
    [anon_sym_short] = ACTIONS(4497),
    [sym_primitive_type] = ACTIONS(4497),
    [anon_sym_enum] = ACTIONS(4497),
    [anon_sym_struct] = ACTIONS(4497),
    [anon_sym_union] = ACTIONS(4497),
    [anon_sym_if] = ACTIONS(4497),
    [anon_sym_switch] = ACTIONS(4497),
    [anon_sym_case] = ACTIONS(4497),
    [anon_sym_default] = ACTIONS(4497),
    [anon_sym_while] = ACTIONS(4497),
    [anon_sym_do] = ACTIONS(4497),
    [anon_sym_for] = ACTIONS(4497),
    [anon_sym_return] = ACTIONS(4497),
    [anon_sym_break] = ACTIONS(4497),
    [anon_sym_continue] = ACTIONS(4497),
    [anon_sym_goto] = ACTIONS(4497),
    [anon_sym_AMP] = ACTIONS(4495),
    [anon_sym_BANG] = ACTIONS(4495),
    [anon_sym_TILDE] = ACTIONS(4495),
    [anon_sym_PLUS] = ACTIONS(4497),
    [anon_sym_DASH] = ACTIONS(4497),
    [anon_sym_DASH_DASH] = ACTIONS(4495),
    [anon_sym_PLUS_PLUS] = ACTIONS(4495),
    [anon_sym_sizeof] = ACTIONS(4497),
    [sym_number_literal] = ACTIONS(4495),
    [sym_char_literal] = ACTIONS(4495),
    [sym_string_literal] = ACTIONS(4495),
    [sym_true] = ACTIONS(4497),
    [sym_false] = ACTIONS(4497),
    [sym_null] = ACTIONS(4497),
    [sym_identifier] = ACTIONS(4497),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(4497),
    [sym_auto] = ACTIONS(4497),
    [anon_sym_typename] = ACTIONS(4497),
    [anon_sym_new] = ACTIONS(4497),
    [anon_sym_COLON_COLON] = ACTIONS(4495),
    [anon_sym_delete] = ACTIONS(4497),
    [sym_nullptr] = ACTIONS(4497),
  },
  [2281] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(6019),
    [sym_comment] = ACTIONS(49),
  },
  [2282] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(6021),
    [sym_comment] = ACTIONS(49),
  },
  [2283] = {
    [sym_preproc_include] = STATE(1983),
    [sym_preproc_def] = STATE(1983),
    [sym_preproc_function_def] = STATE(1983),
    [sym_preproc_call] = STATE(1983),
    [sym_preproc_if_in_compound_statement] = STATE(1414),
    [sym_preproc_ifdef_in_compound_statement] = STATE(1415),
    [sym_preproc_else_in_compound_statement] = STATE(2522),
    [sym_preproc_elif_in_compound_statement] = STATE(2523),
    [sym_declaration] = STATE(1983),
    [sym_type_definition] = STATE(1983),
    [sym__declaration_specifiers] = STATE(1418),
    [sym_compound_statement] = STATE(1983),
    [sym_storage_class_specifier] = STATE(419),
    [sym_type_qualifier] = STATE(419),
    [sym__type_specifier] = STATE(30),
    [sym_sized_type_specifier] = STATE(30),
    [sym_enum_specifier] = STATE(30),
    [sym_struct_specifier] = STATE(30),
    [sym_union_specifier] = STATE(30),
    [sym_labeled_statement] = STATE(1983),
    [sym_expression_statement] = STATE(1983),
    [sym_if_statement] = STATE(1983),
    [sym_switch_statement] = STATE(1983),
    [sym_case_statement] = STATE(1983),
    [sym_while_statement] = STATE(1983),
    [sym_do_statement] = STATE(1983),
    [sym_for_statement] = STATE(1983),
    [sym_return_statement] = STATE(1983),
    [sym_break_statement] = STATE(1983),
    [sym_continue_statement] = STATE(1983),
    [sym_goto_statement] = STATE(1983),
    [sym__expression] = STATE(1419),
    [sym_comma_expression] = STATE(1420),
    [sym_conditional_expression] = STATE(1419),
    [sym_assignment_expression] = STATE(1419),
    [sym_pointer_expression] = STATE(1419),
    [sym_logical_expression] = STATE(1419),
    [sym_bitwise_expression] = STATE(1419),
    [sym_equality_expression] = STATE(1419),
    [sym_relational_expression] = STATE(1419),
    [sym_shift_expression] = STATE(1419),
    [sym_math_expression] = STATE(1419),
    [sym_cast_expression] = STATE(1419),
    [sym_sizeof_expression] = STATE(1419),
    [sym_subscript_expression] = STATE(1419),
    [sym_call_expression] = STATE(1419),
    [sym_field_expression] = STATE(1419),
    [sym_compound_literal_expression] = STATE(1419),
    [sym_parenthesized_expression] = STATE(1419),
    [sym_concatenated_string] = STATE(1419),
    [sym__empty_declaration] = STATE(1983),
    [sym_macro_type_specifier] = STATE(30),
    [sym_class_specifier] = STATE(30),
    [sym_dependent_type] = STATE(30),
    [sym_structured_binding_declaration] = STATE(1983),
    [sym_template_type] = STATE(415),
    [sym_template_function] = STATE(1419),
    [sym_for_range_loop] = STATE(1983),
    [sym_new_expression] = STATE(1419),
    [sym_delete_expression] = STATE(1419),
    [sym_lambda_expression] = STATE(1419),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(416),
    [sym_scoped_namespace_identifier] = STATE(417),
    [aux_sym_preproc_if_in_compound_statement_repeat1] = STATE(1983),
    [aux_sym__declaration_specifiers_repeat1] = STATE(419),
    [aux_sym_sized_type_specifier_repeat1] = STATE(38),
    [sym_raw_string_literal] = ACTIONS(2879),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(2881),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(2883),
    [anon_sym_LPAREN] = ACTIONS(626),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(2885),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(6023),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(2889),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(2891),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(2893),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(2895),
    [sym_preproc_directive] = ACTIONS(2897),
    [anon_sym_SEMI] = ACTIONS(2899),
    [anon_sym_typedef] = ACTIONS(2901),
    [anon_sym_extern] = ACTIONS(154),
    [anon_sym_LBRACE] = ACTIONS(2903),
    [anon_sym_STAR] = ACTIONS(644),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_static] = ACTIONS(154),
    [anon_sym_register] = ACTIONS(154),
    [anon_sym_inline] = ACTIONS(154),
    [anon_sym_const] = ACTIONS(158),
    [anon_sym_restrict] = ACTIONS(158),
    [anon_sym_volatile] = ACTIONS(158),
    [anon_sym__Atomic] = ACTIONS(158),
    [anon_sym_mutable] = ACTIONS(158),
    [anon_sym_explicit] = ACTIONS(158),
    [anon_sym_constexpr] = ACTIONS(158),
    [anon_sym_unsigned] = ACTIONS(31),
    [anon_sym_long] = ACTIONS(31),
    [anon_sym_short] = ACTIONS(31),
    [sym_primitive_type] = ACTIONS(33),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_union] = ACTIONS(39),
    [anon_sym_if] = ACTIONS(2905),
    [anon_sym_switch] = ACTIONS(2907),
    [anon_sym_case] = ACTIONS(2909),
    [anon_sym_default] = ACTIONS(2911),
    [anon_sym_while] = ACTIONS(2913),
    [anon_sym_do] = ACTIONS(2915),
    [anon_sym_for] = ACTIONS(2917),
    [anon_sym_return] = ACTIONS(2919),
    [anon_sym_break] = ACTIONS(2921),
    [anon_sym_continue] = ACTIONS(2923),
    [anon_sym_goto] = ACTIONS(2925),
    [anon_sym_AMP] = ACTIONS(644),
    [anon_sym_BANG] = ACTIONS(668),
    [anon_sym_TILDE] = ACTIONS(670),
    [anon_sym_PLUS] = ACTIONS(672),
    [anon_sym_DASH] = ACTIONS(672),
    [anon_sym_DASH_DASH] = ACTIONS(674),
    [anon_sym_PLUS_PLUS] = ACTIONS(674),
    [anon_sym_sizeof] = ACTIONS(676),
    [sym_number_literal] = ACTIONS(2879),
    [sym_char_literal] = ACTIONS(2879),
    [sym_string_literal] = ACTIONS(678),
    [sym_true] = ACTIONS(2927),
    [sym_false] = ACTIONS(2927),
    [sym_null] = ACTIONS(2927),
    [sym_identifier] = ACTIONS(2929),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(51),
    [sym_auto] = ACTIONS(33),
    [anon_sym_typename] = ACTIONS(53),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(684),
    [anon_sym_delete] = ACTIONS(686),
    [sym_nullptr] = ACTIONS(2927),
  },
  [2284] = {
    [sym_raw_string_literal] = ACTIONS(4505),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(4507),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(4507),
    [anon_sym_LPAREN] = ACTIONS(4505),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(4507),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(4507),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(4507),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(4507),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(4507),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(4507),
    [sym_preproc_directive] = ACTIONS(4507),
    [anon_sym_SEMI] = ACTIONS(4505),
    [anon_sym_typedef] = ACTIONS(4507),
    [anon_sym_extern] = ACTIONS(4507),
    [anon_sym_LBRACE] = ACTIONS(4505),
    [anon_sym_STAR] = ACTIONS(4505),
    [anon_sym_LBRACK] = ACTIONS(4505),
    [anon_sym_static] = ACTIONS(4507),
    [anon_sym_register] = ACTIONS(4507),
    [anon_sym_inline] = ACTIONS(4507),
    [anon_sym_const] = ACTIONS(4507),
    [anon_sym_restrict] = ACTIONS(4507),
    [anon_sym_volatile] = ACTIONS(4507),
    [anon_sym__Atomic] = ACTIONS(4507),
    [anon_sym_mutable] = ACTIONS(4507),
    [anon_sym_explicit] = ACTIONS(4507),
    [anon_sym_constexpr] = ACTIONS(4507),
    [anon_sym_unsigned] = ACTIONS(4507),
    [anon_sym_long] = ACTIONS(4507),
    [anon_sym_short] = ACTIONS(4507),
    [sym_primitive_type] = ACTIONS(4507),
    [anon_sym_enum] = ACTIONS(4507),
    [anon_sym_struct] = ACTIONS(4507),
    [anon_sym_union] = ACTIONS(4507),
    [anon_sym_if] = ACTIONS(4507),
    [anon_sym_switch] = ACTIONS(4507),
    [anon_sym_case] = ACTIONS(4507),
    [anon_sym_default] = ACTIONS(4507),
    [anon_sym_while] = ACTIONS(4507),
    [anon_sym_do] = ACTIONS(4507),
    [anon_sym_for] = ACTIONS(4507),
    [anon_sym_return] = ACTIONS(4507),
    [anon_sym_break] = ACTIONS(4507),
    [anon_sym_continue] = ACTIONS(4507),
    [anon_sym_goto] = ACTIONS(4507),
    [anon_sym_AMP] = ACTIONS(4505),
    [anon_sym_BANG] = ACTIONS(4505),
    [anon_sym_TILDE] = ACTIONS(4505),
    [anon_sym_PLUS] = ACTIONS(4507),
    [anon_sym_DASH] = ACTIONS(4507),
    [anon_sym_DASH_DASH] = ACTIONS(4505),
    [anon_sym_PLUS_PLUS] = ACTIONS(4505),
    [anon_sym_sizeof] = ACTIONS(4507),
    [sym_number_literal] = ACTIONS(4505),
    [sym_char_literal] = ACTIONS(4505),
    [sym_string_literal] = ACTIONS(4505),
    [sym_true] = ACTIONS(4507),
    [sym_false] = ACTIONS(4507),
    [sym_null] = ACTIONS(4507),
    [sym_identifier] = ACTIONS(4507),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(4507),
    [sym_auto] = ACTIONS(4507),
    [anon_sym_typename] = ACTIONS(4507),
    [anon_sym_new] = ACTIONS(4507),
    [anon_sym_COLON_COLON] = ACTIONS(4505),
    [anon_sym_delete] = ACTIONS(4507),
    [sym_nullptr] = ACTIONS(4507),
  },
  [2285] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(6025),
    [sym_comment] = ACTIONS(49),
  },
  [2286] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(6027),
    [sym_comment] = ACTIONS(49),
  },
  [2287] = {
    [sym_preproc_include] = STATE(1983),
    [sym_preproc_def] = STATE(1983),
    [sym_preproc_function_def] = STATE(1983),
    [sym_preproc_call] = STATE(1983),
    [sym_preproc_if_in_compound_statement] = STATE(1414),
    [sym_preproc_ifdef_in_compound_statement] = STATE(1415),
    [sym_preproc_else_in_compound_statement] = STATE(2527),
    [sym_preproc_elif_in_compound_statement] = STATE(2528),
    [sym_declaration] = STATE(1983),
    [sym_type_definition] = STATE(1983),
    [sym__declaration_specifiers] = STATE(1418),
    [sym_compound_statement] = STATE(1983),
    [sym_storage_class_specifier] = STATE(419),
    [sym_type_qualifier] = STATE(419),
    [sym__type_specifier] = STATE(30),
    [sym_sized_type_specifier] = STATE(30),
    [sym_enum_specifier] = STATE(30),
    [sym_struct_specifier] = STATE(30),
    [sym_union_specifier] = STATE(30),
    [sym_labeled_statement] = STATE(1983),
    [sym_expression_statement] = STATE(1983),
    [sym_if_statement] = STATE(1983),
    [sym_switch_statement] = STATE(1983),
    [sym_case_statement] = STATE(1983),
    [sym_while_statement] = STATE(1983),
    [sym_do_statement] = STATE(1983),
    [sym_for_statement] = STATE(1983),
    [sym_return_statement] = STATE(1983),
    [sym_break_statement] = STATE(1983),
    [sym_continue_statement] = STATE(1983),
    [sym_goto_statement] = STATE(1983),
    [sym__expression] = STATE(1419),
    [sym_comma_expression] = STATE(1420),
    [sym_conditional_expression] = STATE(1419),
    [sym_assignment_expression] = STATE(1419),
    [sym_pointer_expression] = STATE(1419),
    [sym_logical_expression] = STATE(1419),
    [sym_bitwise_expression] = STATE(1419),
    [sym_equality_expression] = STATE(1419),
    [sym_relational_expression] = STATE(1419),
    [sym_shift_expression] = STATE(1419),
    [sym_math_expression] = STATE(1419),
    [sym_cast_expression] = STATE(1419),
    [sym_sizeof_expression] = STATE(1419),
    [sym_subscript_expression] = STATE(1419),
    [sym_call_expression] = STATE(1419),
    [sym_field_expression] = STATE(1419),
    [sym_compound_literal_expression] = STATE(1419),
    [sym_parenthesized_expression] = STATE(1419),
    [sym_concatenated_string] = STATE(1419),
    [sym__empty_declaration] = STATE(1983),
    [sym_macro_type_specifier] = STATE(30),
    [sym_class_specifier] = STATE(30),
    [sym_dependent_type] = STATE(30),
    [sym_structured_binding_declaration] = STATE(1983),
    [sym_template_type] = STATE(415),
    [sym_template_function] = STATE(1419),
    [sym_for_range_loop] = STATE(1983),
    [sym_new_expression] = STATE(1419),
    [sym_delete_expression] = STATE(1419),
    [sym_lambda_expression] = STATE(1419),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(416),
    [sym_scoped_namespace_identifier] = STATE(417),
    [aux_sym_preproc_if_in_compound_statement_repeat1] = STATE(1983),
    [aux_sym__declaration_specifiers_repeat1] = STATE(419),
    [aux_sym_sized_type_specifier_repeat1] = STATE(38),
    [sym_raw_string_literal] = ACTIONS(2879),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(2881),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(2883),
    [anon_sym_LPAREN] = ACTIONS(626),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(2885),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(6029),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(2889),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(2891),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(2893),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(2895),
    [sym_preproc_directive] = ACTIONS(2897),
    [anon_sym_SEMI] = ACTIONS(2899),
    [anon_sym_typedef] = ACTIONS(2901),
    [anon_sym_extern] = ACTIONS(154),
    [anon_sym_LBRACE] = ACTIONS(2903),
    [anon_sym_STAR] = ACTIONS(644),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_static] = ACTIONS(154),
    [anon_sym_register] = ACTIONS(154),
    [anon_sym_inline] = ACTIONS(154),
    [anon_sym_const] = ACTIONS(158),
    [anon_sym_restrict] = ACTIONS(158),
    [anon_sym_volatile] = ACTIONS(158),
    [anon_sym__Atomic] = ACTIONS(158),
    [anon_sym_mutable] = ACTIONS(158),
    [anon_sym_explicit] = ACTIONS(158),
    [anon_sym_constexpr] = ACTIONS(158),
    [anon_sym_unsigned] = ACTIONS(31),
    [anon_sym_long] = ACTIONS(31),
    [anon_sym_short] = ACTIONS(31),
    [sym_primitive_type] = ACTIONS(33),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_union] = ACTIONS(39),
    [anon_sym_if] = ACTIONS(2905),
    [anon_sym_switch] = ACTIONS(2907),
    [anon_sym_case] = ACTIONS(2909),
    [anon_sym_default] = ACTIONS(2911),
    [anon_sym_while] = ACTIONS(2913),
    [anon_sym_do] = ACTIONS(2915),
    [anon_sym_for] = ACTIONS(2917),
    [anon_sym_return] = ACTIONS(2919),
    [anon_sym_break] = ACTIONS(2921),
    [anon_sym_continue] = ACTIONS(2923),
    [anon_sym_goto] = ACTIONS(2925),
    [anon_sym_AMP] = ACTIONS(644),
    [anon_sym_BANG] = ACTIONS(668),
    [anon_sym_TILDE] = ACTIONS(670),
    [anon_sym_PLUS] = ACTIONS(672),
    [anon_sym_DASH] = ACTIONS(672),
    [anon_sym_DASH_DASH] = ACTIONS(674),
    [anon_sym_PLUS_PLUS] = ACTIONS(674),
    [anon_sym_sizeof] = ACTIONS(676),
    [sym_number_literal] = ACTIONS(2879),
    [sym_char_literal] = ACTIONS(2879),
    [sym_string_literal] = ACTIONS(678),
    [sym_true] = ACTIONS(2927),
    [sym_false] = ACTIONS(2927),
    [sym_null] = ACTIONS(2927),
    [sym_identifier] = ACTIONS(2929),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(51),
    [sym_auto] = ACTIONS(33),
    [anon_sym_typename] = ACTIONS(53),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(684),
    [anon_sym_delete] = ACTIONS(686),
    [sym_nullptr] = ACTIONS(2927),
  },
  [2288] = {
    [sym_raw_string_literal] = ACTIONS(249),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(251),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(251),
    [anon_sym_LPAREN] = ACTIONS(249),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(251),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(251),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(251),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(251),
    [sym_preproc_directive] = ACTIONS(251),
    [anon_sym_SEMI] = ACTIONS(249),
    [anon_sym_typedef] = ACTIONS(251),
    [anon_sym_extern] = ACTIONS(251),
    [anon_sym_LBRACE] = ACTIONS(249),
    [anon_sym_STAR] = ACTIONS(249),
    [anon_sym_LBRACK] = ACTIONS(249),
    [anon_sym_static] = ACTIONS(251),
    [anon_sym_register] = ACTIONS(251),
    [anon_sym_inline] = ACTIONS(251),
    [anon_sym_const] = ACTIONS(251),
    [anon_sym_restrict] = ACTIONS(251),
    [anon_sym_volatile] = ACTIONS(251),
    [anon_sym__Atomic] = ACTIONS(251),
    [anon_sym_mutable] = ACTIONS(251),
    [anon_sym_explicit] = ACTIONS(251),
    [anon_sym_constexpr] = ACTIONS(251),
    [anon_sym_unsigned] = ACTIONS(251),
    [anon_sym_long] = ACTIONS(251),
    [anon_sym_short] = ACTIONS(251),
    [sym_primitive_type] = ACTIONS(251),
    [anon_sym_enum] = ACTIONS(251),
    [anon_sym_struct] = ACTIONS(251),
    [anon_sym_union] = ACTIONS(251),
    [anon_sym_if] = ACTIONS(251),
    [anon_sym_switch] = ACTIONS(251),
    [anon_sym_case] = ACTIONS(251),
    [anon_sym_default] = ACTIONS(251),
    [anon_sym_while] = ACTIONS(251),
    [anon_sym_do] = ACTIONS(251),
    [anon_sym_for] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(251),
    [anon_sym_break] = ACTIONS(251),
    [anon_sym_continue] = ACTIONS(251),
    [anon_sym_goto] = ACTIONS(251),
    [anon_sym_AMP] = ACTIONS(249),
    [anon_sym_BANG] = ACTIONS(249),
    [anon_sym_TILDE] = ACTIONS(249),
    [anon_sym_PLUS] = ACTIONS(251),
    [anon_sym_DASH] = ACTIONS(251),
    [anon_sym_DASH_DASH] = ACTIONS(249),
    [anon_sym_PLUS_PLUS] = ACTIONS(249),
    [anon_sym_sizeof] = ACTIONS(251),
    [sym_number_literal] = ACTIONS(249),
    [sym_char_literal] = ACTIONS(249),
    [sym_string_literal] = ACTIONS(249),
    [sym_true] = ACTIONS(251),
    [sym_false] = ACTIONS(251),
    [sym_null] = ACTIONS(251),
    [sym_identifier] = ACTIONS(251),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(251),
    [sym_auto] = ACTIONS(251),
    [anon_sym_typename] = ACTIONS(251),
    [anon_sym_new] = ACTIONS(251),
    [anon_sym_COLON_COLON] = ACTIONS(249),
    [anon_sym_delete] = ACTIONS(251),
    [sym_nullptr] = ACTIONS(251),
  },
  [2289] = {
    [sym_preproc_params] = STATE(2531),
    [aux_sym_SLASH_LBRACK_BSLASHt_RBRACK_PLUS_SLASH] = ACTIONS(6031),
    [anon_sym_LF] = ACTIONS(6033),
    [anon_sym_LPAREN] = ACTIONS(257),
    [sym_comment] = ACTIONS(83),
  },
  [2290] = {
    [sym_preproc_include] = STATE(2535),
    [sym_preproc_def] = STATE(2535),
    [sym_preproc_function_def] = STATE(2535),
    [sym_preproc_call] = STATE(2535),
    [sym_preproc_if_in_compound_statement] = STATE(1414),
    [sym_preproc_ifdef_in_compound_statement] = STATE(1415),
    [sym_preproc_else_in_compound_statement] = STATE(2533),
    [sym_preproc_elif_in_compound_statement] = STATE(2534),
    [sym_declaration] = STATE(2535),
    [sym_type_definition] = STATE(2535),
    [sym__declaration_specifiers] = STATE(1418),
    [sym_compound_statement] = STATE(2535),
    [sym_storage_class_specifier] = STATE(419),
    [sym_type_qualifier] = STATE(419),
    [sym__type_specifier] = STATE(30),
    [sym_sized_type_specifier] = STATE(30),
    [sym_enum_specifier] = STATE(30),
    [sym_struct_specifier] = STATE(30),
    [sym_union_specifier] = STATE(30),
    [sym_labeled_statement] = STATE(2535),
    [sym_expression_statement] = STATE(2535),
    [sym_if_statement] = STATE(2535),
    [sym_switch_statement] = STATE(2535),
    [sym_case_statement] = STATE(2535),
    [sym_while_statement] = STATE(2535),
    [sym_do_statement] = STATE(2535),
    [sym_for_statement] = STATE(2535),
    [sym_return_statement] = STATE(2535),
    [sym_break_statement] = STATE(2535),
    [sym_continue_statement] = STATE(2535),
    [sym_goto_statement] = STATE(2535),
    [sym__expression] = STATE(1419),
    [sym_comma_expression] = STATE(1420),
    [sym_conditional_expression] = STATE(1419),
    [sym_assignment_expression] = STATE(1419),
    [sym_pointer_expression] = STATE(1419),
    [sym_logical_expression] = STATE(1419),
    [sym_bitwise_expression] = STATE(1419),
    [sym_equality_expression] = STATE(1419),
    [sym_relational_expression] = STATE(1419),
    [sym_shift_expression] = STATE(1419),
    [sym_math_expression] = STATE(1419),
    [sym_cast_expression] = STATE(1419),
    [sym_sizeof_expression] = STATE(1419),
    [sym_subscript_expression] = STATE(1419),
    [sym_call_expression] = STATE(1419),
    [sym_field_expression] = STATE(1419),
    [sym_compound_literal_expression] = STATE(1419),
    [sym_parenthesized_expression] = STATE(1419),
    [sym_concatenated_string] = STATE(1419),
    [sym__empty_declaration] = STATE(2535),
    [sym_macro_type_specifier] = STATE(30),
    [sym_class_specifier] = STATE(30),
    [sym_dependent_type] = STATE(30),
    [sym_structured_binding_declaration] = STATE(2535),
    [sym_template_type] = STATE(415),
    [sym_template_function] = STATE(1419),
    [sym_for_range_loop] = STATE(2535),
    [sym_new_expression] = STATE(1419),
    [sym_delete_expression] = STATE(1419),
    [sym_lambda_expression] = STATE(1419),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(416),
    [sym_scoped_namespace_identifier] = STATE(417),
    [aux_sym_preproc_if_in_compound_statement_repeat1] = STATE(2535),
    [aux_sym__declaration_specifiers_repeat1] = STATE(419),
    [aux_sym_sized_type_specifier_repeat1] = STATE(38),
    [sym_raw_string_literal] = ACTIONS(2879),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(2881),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(2883),
    [anon_sym_LPAREN] = ACTIONS(626),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(2885),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(6035),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(2889),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(2891),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(2893),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(2895),
    [sym_preproc_directive] = ACTIONS(2897),
    [anon_sym_SEMI] = ACTIONS(2899),
    [anon_sym_typedef] = ACTIONS(2901),
    [anon_sym_extern] = ACTIONS(154),
    [anon_sym_LBRACE] = ACTIONS(2903),
    [anon_sym_STAR] = ACTIONS(644),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_static] = ACTIONS(154),
    [anon_sym_register] = ACTIONS(154),
    [anon_sym_inline] = ACTIONS(154),
    [anon_sym_const] = ACTIONS(158),
    [anon_sym_restrict] = ACTIONS(158),
    [anon_sym_volatile] = ACTIONS(158),
    [anon_sym__Atomic] = ACTIONS(158),
    [anon_sym_mutable] = ACTIONS(158),
    [anon_sym_explicit] = ACTIONS(158),
    [anon_sym_constexpr] = ACTIONS(158),
    [anon_sym_unsigned] = ACTIONS(31),
    [anon_sym_long] = ACTIONS(31),
    [anon_sym_short] = ACTIONS(31),
    [sym_primitive_type] = ACTIONS(33),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_union] = ACTIONS(39),
    [anon_sym_if] = ACTIONS(2905),
    [anon_sym_switch] = ACTIONS(2907),
    [anon_sym_case] = ACTIONS(2909),
    [anon_sym_default] = ACTIONS(2911),
    [anon_sym_while] = ACTIONS(2913),
    [anon_sym_do] = ACTIONS(2915),
    [anon_sym_for] = ACTIONS(2917),
    [anon_sym_return] = ACTIONS(2919),
    [anon_sym_break] = ACTIONS(2921),
    [anon_sym_continue] = ACTIONS(2923),
    [anon_sym_goto] = ACTIONS(2925),
    [anon_sym_AMP] = ACTIONS(644),
    [anon_sym_BANG] = ACTIONS(668),
    [anon_sym_TILDE] = ACTIONS(670),
    [anon_sym_PLUS] = ACTIONS(672),
    [anon_sym_DASH] = ACTIONS(672),
    [anon_sym_DASH_DASH] = ACTIONS(674),
    [anon_sym_PLUS_PLUS] = ACTIONS(674),
    [anon_sym_sizeof] = ACTIONS(676),
    [sym_number_literal] = ACTIONS(2879),
    [sym_char_literal] = ACTIONS(2879),
    [sym_string_literal] = ACTIONS(678),
    [sym_true] = ACTIONS(2927),
    [sym_false] = ACTIONS(2927),
    [sym_null] = ACTIONS(2927),
    [sym_identifier] = ACTIONS(2929),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(51),
    [sym_auto] = ACTIONS(33),
    [anon_sym_typename] = ACTIONS(53),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(684),
    [anon_sym_delete] = ACTIONS(686),
    [sym_nullptr] = ACTIONS(2927),
  },
  [2291] = {
    [sym_preproc_include] = STATE(2539),
    [sym_preproc_def] = STATE(2539),
    [sym_preproc_function_def] = STATE(2539),
    [sym_preproc_call] = STATE(2539),
    [sym_preproc_if_in_compound_statement] = STATE(1414),
    [sym_preproc_ifdef_in_compound_statement] = STATE(1415),
    [sym_preproc_else_in_compound_statement] = STATE(2537),
    [sym_preproc_elif_in_compound_statement] = STATE(2538),
    [sym_declaration] = STATE(2539),
    [sym_type_definition] = STATE(2539),
    [sym__declaration_specifiers] = STATE(1418),
    [sym_compound_statement] = STATE(2539),
    [sym_storage_class_specifier] = STATE(419),
    [sym_type_qualifier] = STATE(419),
    [sym__type_specifier] = STATE(30),
    [sym_sized_type_specifier] = STATE(30),
    [sym_enum_specifier] = STATE(30),
    [sym_struct_specifier] = STATE(30),
    [sym_union_specifier] = STATE(30),
    [sym_labeled_statement] = STATE(2539),
    [sym_expression_statement] = STATE(2539),
    [sym_if_statement] = STATE(2539),
    [sym_switch_statement] = STATE(2539),
    [sym_case_statement] = STATE(2539),
    [sym_while_statement] = STATE(2539),
    [sym_do_statement] = STATE(2539),
    [sym_for_statement] = STATE(2539),
    [sym_return_statement] = STATE(2539),
    [sym_break_statement] = STATE(2539),
    [sym_continue_statement] = STATE(2539),
    [sym_goto_statement] = STATE(2539),
    [sym__expression] = STATE(1419),
    [sym_comma_expression] = STATE(1420),
    [sym_conditional_expression] = STATE(1419),
    [sym_assignment_expression] = STATE(1419),
    [sym_pointer_expression] = STATE(1419),
    [sym_logical_expression] = STATE(1419),
    [sym_bitwise_expression] = STATE(1419),
    [sym_equality_expression] = STATE(1419),
    [sym_relational_expression] = STATE(1419),
    [sym_shift_expression] = STATE(1419),
    [sym_math_expression] = STATE(1419),
    [sym_cast_expression] = STATE(1419),
    [sym_sizeof_expression] = STATE(1419),
    [sym_subscript_expression] = STATE(1419),
    [sym_call_expression] = STATE(1419),
    [sym_field_expression] = STATE(1419),
    [sym_compound_literal_expression] = STATE(1419),
    [sym_parenthesized_expression] = STATE(1419),
    [sym_concatenated_string] = STATE(1419),
    [sym__empty_declaration] = STATE(2539),
    [sym_macro_type_specifier] = STATE(30),
    [sym_class_specifier] = STATE(30),
    [sym_dependent_type] = STATE(30),
    [sym_structured_binding_declaration] = STATE(2539),
    [sym_template_type] = STATE(415),
    [sym_template_function] = STATE(1419),
    [sym_for_range_loop] = STATE(2539),
    [sym_new_expression] = STATE(1419),
    [sym_delete_expression] = STATE(1419),
    [sym_lambda_expression] = STATE(1419),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(416),
    [sym_scoped_namespace_identifier] = STATE(417),
    [aux_sym_preproc_if_in_compound_statement_repeat1] = STATE(2539),
    [aux_sym__declaration_specifiers_repeat1] = STATE(419),
    [aux_sym_sized_type_specifier_repeat1] = STATE(38),
    [sym_raw_string_literal] = ACTIONS(2879),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(2881),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(2883),
    [anon_sym_LPAREN] = ACTIONS(626),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(2885),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(6037),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(2889),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(2891),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(2893),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(2895),
    [sym_preproc_directive] = ACTIONS(2897),
    [anon_sym_SEMI] = ACTIONS(2899),
    [anon_sym_typedef] = ACTIONS(2901),
    [anon_sym_extern] = ACTIONS(154),
    [anon_sym_LBRACE] = ACTIONS(2903),
    [anon_sym_STAR] = ACTIONS(644),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_static] = ACTIONS(154),
    [anon_sym_register] = ACTIONS(154),
    [anon_sym_inline] = ACTIONS(154),
    [anon_sym_const] = ACTIONS(158),
    [anon_sym_restrict] = ACTIONS(158),
    [anon_sym_volatile] = ACTIONS(158),
    [anon_sym__Atomic] = ACTIONS(158),
    [anon_sym_mutable] = ACTIONS(158),
    [anon_sym_explicit] = ACTIONS(158),
    [anon_sym_constexpr] = ACTIONS(158),
    [anon_sym_unsigned] = ACTIONS(31),
    [anon_sym_long] = ACTIONS(31),
    [anon_sym_short] = ACTIONS(31),
    [sym_primitive_type] = ACTIONS(33),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_union] = ACTIONS(39),
    [anon_sym_if] = ACTIONS(2905),
    [anon_sym_switch] = ACTIONS(2907),
    [anon_sym_case] = ACTIONS(2909),
    [anon_sym_default] = ACTIONS(2911),
    [anon_sym_while] = ACTIONS(2913),
    [anon_sym_do] = ACTIONS(2915),
    [anon_sym_for] = ACTIONS(2917),
    [anon_sym_return] = ACTIONS(2919),
    [anon_sym_break] = ACTIONS(2921),
    [anon_sym_continue] = ACTIONS(2923),
    [anon_sym_goto] = ACTIONS(2925),
    [anon_sym_AMP] = ACTIONS(644),
    [anon_sym_BANG] = ACTIONS(668),
    [anon_sym_TILDE] = ACTIONS(670),
    [anon_sym_PLUS] = ACTIONS(672),
    [anon_sym_DASH] = ACTIONS(672),
    [anon_sym_DASH_DASH] = ACTIONS(674),
    [anon_sym_PLUS_PLUS] = ACTIONS(674),
    [anon_sym_sizeof] = ACTIONS(676),
    [sym_number_literal] = ACTIONS(2879),
    [sym_char_literal] = ACTIONS(2879),
    [sym_string_literal] = ACTIONS(678),
    [sym_true] = ACTIONS(2927),
    [sym_false] = ACTIONS(2927),
    [sym_null] = ACTIONS(2927),
    [sym_identifier] = ACTIONS(2929),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(51),
    [sym_auto] = ACTIONS(33),
    [anon_sym_typename] = ACTIONS(53),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(684),
    [anon_sym_delete] = ACTIONS(686),
    [sym_nullptr] = ACTIONS(2927),
  },
  [2292] = {
    [sym_preproc_include] = STATE(2543),
    [sym_preproc_def] = STATE(2543),
    [sym_preproc_function_def] = STATE(2543),
    [sym_preproc_call] = STATE(2543),
    [sym_preproc_if_in_compound_statement] = STATE(1414),
    [sym_preproc_ifdef_in_compound_statement] = STATE(1415),
    [sym_preproc_else_in_compound_statement] = STATE(2541),
    [sym_preproc_elif_in_compound_statement] = STATE(2542),
    [sym_declaration] = STATE(2543),
    [sym_type_definition] = STATE(2543),
    [sym__declaration_specifiers] = STATE(1418),
    [sym_compound_statement] = STATE(2543),
    [sym_storage_class_specifier] = STATE(419),
    [sym_type_qualifier] = STATE(419),
    [sym__type_specifier] = STATE(30),
    [sym_sized_type_specifier] = STATE(30),
    [sym_enum_specifier] = STATE(30),
    [sym_struct_specifier] = STATE(30),
    [sym_union_specifier] = STATE(30),
    [sym_labeled_statement] = STATE(2543),
    [sym_expression_statement] = STATE(2543),
    [sym_if_statement] = STATE(2543),
    [sym_switch_statement] = STATE(2543),
    [sym_case_statement] = STATE(2543),
    [sym_while_statement] = STATE(2543),
    [sym_do_statement] = STATE(2543),
    [sym_for_statement] = STATE(2543),
    [sym_return_statement] = STATE(2543),
    [sym_break_statement] = STATE(2543),
    [sym_continue_statement] = STATE(2543),
    [sym_goto_statement] = STATE(2543),
    [sym__expression] = STATE(1419),
    [sym_comma_expression] = STATE(1420),
    [sym_conditional_expression] = STATE(1419),
    [sym_assignment_expression] = STATE(1419),
    [sym_pointer_expression] = STATE(1419),
    [sym_logical_expression] = STATE(1419),
    [sym_bitwise_expression] = STATE(1419),
    [sym_equality_expression] = STATE(1419),
    [sym_relational_expression] = STATE(1419),
    [sym_shift_expression] = STATE(1419),
    [sym_math_expression] = STATE(1419),
    [sym_cast_expression] = STATE(1419),
    [sym_sizeof_expression] = STATE(1419),
    [sym_subscript_expression] = STATE(1419),
    [sym_call_expression] = STATE(1419),
    [sym_field_expression] = STATE(1419),
    [sym_compound_literal_expression] = STATE(1419),
    [sym_parenthesized_expression] = STATE(1419),
    [sym_concatenated_string] = STATE(1419),
    [sym__empty_declaration] = STATE(2543),
    [sym_macro_type_specifier] = STATE(30),
    [sym_class_specifier] = STATE(30),
    [sym_dependent_type] = STATE(30),
    [sym_structured_binding_declaration] = STATE(2543),
    [sym_template_type] = STATE(415),
    [sym_template_function] = STATE(1419),
    [sym_for_range_loop] = STATE(2543),
    [sym_new_expression] = STATE(1419),
    [sym_delete_expression] = STATE(1419),
    [sym_lambda_expression] = STATE(1419),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(416),
    [sym_scoped_namespace_identifier] = STATE(417),
    [aux_sym_preproc_if_in_compound_statement_repeat1] = STATE(2543),
    [aux_sym__declaration_specifiers_repeat1] = STATE(419),
    [aux_sym_sized_type_specifier_repeat1] = STATE(38),
    [sym_raw_string_literal] = ACTIONS(2879),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(2881),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(2883),
    [anon_sym_LPAREN] = ACTIONS(626),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(2885),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(6039),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(2889),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(2891),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(2893),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(2895),
    [sym_preproc_directive] = ACTIONS(2897),
    [anon_sym_SEMI] = ACTIONS(2899),
    [anon_sym_typedef] = ACTIONS(2901),
    [anon_sym_extern] = ACTIONS(154),
    [anon_sym_LBRACE] = ACTIONS(2903),
    [anon_sym_STAR] = ACTIONS(644),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_static] = ACTIONS(154),
    [anon_sym_register] = ACTIONS(154),
    [anon_sym_inline] = ACTIONS(154),
    [anon_sym_const] = ACTIONS(158),
    [anon_sym_restrict] = ACTIONS(158),
    [anon_sym_volatile] = ACTIONS(158),
    [anon_sym__Atomic] = ACTIONS(158),
    [anon_sym_mutable] = ACTIONS(158),
    [anon_sym_explicit] = ACTIONS(158),
    [anon_sym_constexpr] = ACTIONS(158),
    [anon_sym_unsigned] = ACTIONS(31),
    [anon_sym_long] = ACTIONS(31),
    [anon_sym_short] = ACTIONS(31),
    [sym_primitive_type] = ACTIONS(33),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_union] = ACTIONS(39),
    [anon_sym_if] = ACTIONS(2905),
    [anon_sym_switch] = ACTIONS(2907),
    [anon_sym_case] = ACTIONS(2909),
    [anon_sym_default] = ACTIONS(2911),
    [anon_sym_while] = ACTIONS(2913),
    [anon_sym_do] = ACTIONS(2915),
    [anon_sym_for] = ACTIONS(2917),
    [anon_sym_return] = ACTIONS(2919),
    [anon_sym_break] = ACTIONS(2921),
    [anon_sym_continue] = ACTIONS(2923),
    [anon_sym_goto] = ACTIONS(2925),
    [anon_sym_AMP] = ACTIONS(644),
    [anon_sym_BANG] = ACTIONS(668),
    [anon_sym_TILDE] = ACTIONS(670),
    [anon_sym_PLUS] = ACTIONS(672),
    [anon_sym_DASH] = ACTIONS(672),
    [anon_sym_DASH_DASH] = ACTIONS(674),
    [anon_sym_PLUS_PLUS] = ACTIONS(674),
    [anon_sym_sizeof] = ACTIONS(676),
    [sym_number_literal] = ACTIONS(2879),
    [sym_char_literal] = ACTIONS(2879),
    [sym_string_literal] = ACTIONS(678),
    [sym_true] = ACTIONS(2927),
    [sym_false] = ACTIONS(2927),
    [sym_null] = ACTIONS(2927),
    [sym_identifier] = ACTIONS(2929),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(51),
    [sym_auto] = ACTIONS(33),
    [anon_sym_typename] = ACTIONS(53),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(684),
    [anon_sym_delete] = ACTIONS(686),
    [sym_nullptr] = ACTIONS(2927),
  },
  [2293] = {
    [sym_preproc_arg] = ACTIONS(6041),
    [sym_comment] = ACTIONS(83),
  },
  [2294] = {
    [sym_raw_string_literal] = ACTIONS(307),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(309),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(309),
    [anon_sym_LPAREN] = ACTIONS(307),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(309),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(309),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(309),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(309),
    [sym_preproc_directive] = ACTIONS(309),
    [anon_sym_SEMI] = ACTIONS(307),
    [anon_sym_typedef] = ACTIONS(309),
    [anon_sym_extern] = ACTIONS(309),
    [anon_sym_LBRACE] = ACTIONS(307),
    [anon_sym_STAR] = ACTIONS(307),
    [anon_sym_LBRACK] = ACTIONS(307),
    [anon_sym_static] = ACTIONS(309),
    [anon_sym_register] = ACTIONS(309),
    [anon_sym_inline] = ACTIONS(309),
    [anon_sym_const] = ACTIONS(309),
    [anon_sym_restrict] = ACTIONS(309),
    [anon_sym_volatile] = ACTIONS(309),
    [anon_sym__Atomic] = ACTIONS(309),
    [anon_sym_mutable] = ACTIONS(309),
    [anon_sym_explicit] = ACTIONS(309),
    [anon_sym_constexpr] = ACTIONS(309),
    [anon_sym_unsigned] = ACTIONS(309),
    [anon_sym_long] = ACTIONS(309),
    [anon_sym_short] = ACTIONS(309),
    [sym_primitive_type] = ACTIONS(309),
    [anon_sym_enum] = ACTIONS(309),
    [anon_sym_struct] = ACTIONS(309),
    [anon_sym_union] = ACTIONS(309),
    [anon_sym_if] = ACTIONS(309),
    [anon_sym_switch] = ACTIONS(309),
    [anon_sym_case] = ACTIONS(309),
    [anon_sym_default] = ACTIONS(309),
    [anon_sym_while] = ACTIONS(309),
    [anon_sym_do] = ACTIONS(309),
    [anon_sym_for] = ACTIONS(309),
    [anon_sym_return] = ACTIONS(309),
    [anon_sym_break] = ACTIONS(309),
    [anon_sym_continue] = ACTIONS(309),
    [anon_sym_goto] = ACTIONS(309),
    [anon_sym_AMP] = ACTIONS(307),
    [anon_sym_BANG] = ACTIONS(307),
    [anon_sym_TILDE] = ACTIONS(307),
    [anon_sym_PLUS] = ACTIONS(309),
    [anon_sym_DASH] = ACTIONS(309),
    [anon_sym_DASH_DASH] = ACTIONS(307),
    [anon_sym_PLUS_PLUS] = ACTIONS(307),
    [anon_sym_sizeof] = ACTIONS(309),
    [sym_number_literal] = ACTIONS(307),
    [sym_char_literal] = ACTIONS(307),
    [sym_string_literal] = ACTIONS(307),
    [sym_true] = ACTIONS(309),
    [sym_false] = ACTIONS(309),
    [sym_null] = ACTIONS(309),
    [sym_identifier] = ACTIONS(309),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(309),
    [sym_auto] = ACTIONS(309),
    [anon_sym_typename] = ACTIONS(309),
    [anon_sym_new] = ACTIONS(309),
    [anon_sym_COLON_COLON] = ACTIONS(307),
    [anon_sym_delete] = ACTIONS(309),
    [sym_nullptr] = ACTIONS(309),
  },
  [2295] = {
    [sym__type_declarator] = STATE(2545),
    [sym_pointer_type_declarator] = STATE(213),
    [sym_function_type_declarator] = STATE(214),
    [sym_array_type_declarator] = STATE(215),
    [anon_sym_LPAREN] = ACTIONS(327),
    [anon_sym_STAR] = ACTIONS(329),
    [sym_identifier] = ACTIONS(331),
    [sym_comment] = ACTIONS(49),
  },
  [2296] = {
    [sym_type_qualifier] = STATE(219),
    [sym__type_specifier] = STATE(2546),
    [sym_sized_type_specifier] = STATE(2546),
    [sym_enum_specifier] = STATE(2546),
    [sym_struct_specifier] = STATE(2546),
    [sym_union_specifier] = STATE(2546),
    [sym_macro_type_specifier] = STATE(2546),
    [sym_class_specifier] = STATE(2546),
    [sym_dependent_type] = STATE(2546),
    [sym_template_type] = STATE(62),
    [sym_scoped_type_identifier] = STATE(63),
    [sym_scoped_namespace_identifier] = STATE(64),
    [aux_sym_type_definition_repeat1] = STATE(219),
    [aux_sym_sized_type_specifier_repeat1] = STATE(66),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_restrict] = ACTIONS(93),
    [anon_sym_volatile] = ACTIONS(93),
    [anon_sym__Atomic] = ACTIONS(93),
    [anon_sym_mutable] = ACTIONS(93),
    [anon_sym_explicit] = ACTIONS(93),
    [anon_sym_constexpr] = ACTIONS(93),
    [anon_sym_unsigned] = ACTIONS(95),
    [anon_sym_long] = ACTIONS(95),
    [anon_sym_short] = ACTIONS(95),
    [sym_primitive_type] = ACTIONS(6043),
    [anon_sym_enum] = ACTIONS(99),
    [anon_sym_struct] = ACTIONS(101),
    [anon_sym_union] = ACTIONS(103),
    [sym_identifier] = ACTIONS(105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(107),
    [sym_auto] = ACTIONS(6043),
    [anon_sym_typename] = ACTIONS(109),
    [anon_sym_COLON_COLON] = ACTIONS(111),
  },
  [2297] = {
    [sym_raw_string_literal] = ACTIONS(1622),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1624),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1624),
    [anon_sym_LPAREN] = ACTIONS(1622),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1624),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(1624),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1624),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1624),
    [sym_preproc_directive] = ACTIONS(1624),
    [anon_sym_SEMI] = ACTIONS(1622),
    [anon_sym_typedef] = ACTIONS(1624),
    [anon_sym_extern] = ACTIONS(1624),
    [anon_sym_LBRACE] = ACTIONS(1622),
    [anon_sym_STAR] = ACTIONS(1622),
    [anon_sym_LBRACK] = ACTIONS(1622),
    [anon_sym_static] = ACTIONS(1624),
    [anon_sym_register] = ACTIONS(1624),
    [anon_sym_inline] = ACTIONS(1624),
    [anon_sym_const] = ACTIONS(1624),
    [anon_sym_restrict] = ACTIONS(1624),
    [anon_sym_volatile] = ACTIONS(1624),
    [anon_sym__Atomic] = ACTIONS(1624),
    [anon_sym_mutable] = ACTIONS(1624),
    [anon_sym_explicit] = ACTIONS(1624),
    [anon_sym_constexpr] = ACTIONS(1624),
    [anon_sym_unsigned] = ACTIONS(1624),
    [anon_sym_long] = ACTIONS(1624),
    [anon_sym_short] = ACTIONS(1624),
    [sym_primitive_type] = ACTIONS(1624),
    [anon_sym_enum] = ACTIONS(1624),
    [anon_sym_struct] = ACTIONS(1624),
    [anon_sym_union] = ACTIONS(1624),
    [anon_sym_if] = ACTIONS(1624),
    [anon_sym_switch] = ACTIONS(1624),
    [anon_sym_case] = ACTIONS(1624),
    [anon_sym_default] = ACTIONS(1624),
    [anon_sym_while] = ACTIONS(1624),
    [anon_sym_do] = ACTIONS(1624),
    [anon_sym_for] = ACTIONS(1624),
    [anon_sym_return] = ACTIONS(1624),
    [anon_sym_break] = ACTIONS(1624),
    [anon_sym_continue] = ACTIONS(1624),
    [anon_sym_goto] = ACTIONS(1624),
    [anon_sym_AMP] = ACTIONS(1622),
    [anon_sym_BANG] = ACTIONS(1622),
    [anon_sym_TILDE] = ACTIONS(1622),
    [anon_sym_PLUS] = ACTIONS(1624),
    [anon_sym_DASH] = ACTIONS(1624),
    [anon_sym_DASH_DASH] = ACTIONS(1622),
    [anon_sym_PLUS_PLUS] = ACTIONS(1622),
    [anon_sym_sizeof] = ACTIONS(1624),
    [sym_number_literal] = ACTIONS(1622),
    [sym_char_literal] = ACTIONS(1622),
    [sym_string_literal] = ACTIONS(1622),
    [sym_true] = ACTIONS(1624),
    [sym_false] = ACTIONS(1624),
    [sym_null] = ACTIONS(1624),
    [sym_identifier] = ACTIONS(1624),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(1624),
    [sym_auto] = ACTIONS(1624),
    [anon_sym_typename] = ACTIONS(1624),
    [anon_sym_new] = ACTIONS(1624),
    [anon_sym_COLON_COLON] = ACTIONS(1622),
    [anon_sym_delete] = ACTIONS(1624),
    [sym_nullptr] = ACTIONS(1624),
  },
  [2298] = {
    [sym_preproc_include] = STATE(913),
    [sym_preproc_def] = STATE(913),
    [sym_preproc_function_def] = STATE(913),
    [sym_preproc_call] = STATE(913),
    [sym_preproc_if_in_compound_statement] = STATE(410),
    [sym_preproc_ifdef_in_compound_statement] = STATE(411),
    [sym_declaration] = STATE(913),
    [sym_type_definition] = STATE(913),
    [sym__declaration_specifiers] = STATE(412),
    [sym_compound_statement] = STATE(913),
    [sym_storage_class_specifier] = STATE(419),
    [sym_type_qualifier] = STATE(419),
    [sym__type_specifier] = STATE(30),
    [sym_sized_type_specifier] = STATE(30),
    [sym_enum_specifier] = STATE(30),
    [sym_struct_specifier] = STATE(30),
    [sym_union_specifier] = STATE(30),
    [sym_labeled_statement] = STATE(913),
    [sym_expression_statement] = STATE(913),
    [sym_if_statement] = STATE(913),
    [sym_switch_statement] = STATE(913),
    [sym_case_statement] = STATE(913),
    [sym_while_statement] = STATE(913),
    [sym_do_statement] = STATE(913),
    [sym_for_statement] = STATE(913),
    [sym_return_statement] = STATE(913),
    [sym_break_statement] = STATE(913),
    [sym_continue_statement] = STATE(913),
    [sym_goto_statement] = STATE(913),
    [sym__expression] = STATE(413),
    [sym_comma_expression] = STATE(414),
    [sym_conditional_expression] = STATE(413),
    [sym_assignment_expression] = STATE(413),
    [sym_pointer_expression] = STATE(413),
    [sym_logical_expression] = STATE(413),
    [sym_bitwise_expression] = STATE(413),
    [sym_equality_expression] = STATE(413),
    [sym_relational_expression] = STATE(413),
    [sym_shift_expression] = STATE(413),
    [sym_math_expression] = STATE(413),
    [sym_cast_expression] = STATE(413),
    [sym_sizeof_expression] = STATE(413),
    [sym_subscript_expression] = STATE(413),
    [sym_call_expression] = STATE(413),
    [sym_field_expression] = STATE(413),
    [sym_compound_literal_expression] = STATE(413),
    [sym_parenthesized_expression] = STATE(413),
    [sym_concatenated_string] = STATE(413),
    [sym__empty_declaration] = STATE(913),
    [sym_macro_type_specifier] = STATE(30),
    [sym_class_specifier] = STATE(30),
    [sym_dependent_type] = STATE(30),
    [sym_structured_binding_declaration] = STATE(913),
    [sym_template_type] = STATE(415),
    [sym_template_function] = STATE(413),
    [sym_for_range_loop] = STATE(913),
    [sym_new_expression] = STATE(413),
    [sym_delete_expression] = STATE(413),
    [sym_lambda_expression] = STATE(413),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(416),
    [sym_scoped_namespace_identifier] = STATE(417),
    [aux_sym_preproc_if_in_compound_statement_repeat1] = STATE(913),
    [aux_sym__declaration_specifiers_repeat1] = STATE(419),
    [aux_sym_sized_type_specifier_repeat1] = STATE(38),
    [sym_raw_string_literal] = ACTIONS(620),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(622),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(624),
    [anon_sym_LPAREN] = ACTIONS(626),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(628),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(630),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(632),
    [sym_preproc_directive] = ACTIONS(634),
    [anon_sym_SEMI] = ACTIONS(636),
    [anon_sym_typedef] = ACTIONS(638),
    [anon_sym_extern] = ACTIONS(154),
    [anon_sym_LBRACE] = ACTIONS(640),
    [anon_sym_RBRACE] = ACTIONS(6045),
    [anon_sym_STAR] = ACTIONS(644),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_static] = ACTIONS(154),
    [anon_sym_register] = ACTIONS(154),
    [anon_sym_inline] = ACTIONS(154),
    [anon_sym_const] = ACTIONS(158),
    [anon_sym_restrict] = ACTIONS(158),
    [anon_sym_volatile] = ACTIONS(158),
    [anon_sym__Atomic] = ACTIONS(158),
    [anon_sym_mutable] = ACTIONS(158),
    [anon_sym_explicit] = ACTIONS(158),
    [anon_sym_constexpr] = ACTIONS(158),
    [anon_sym_unsigned] = ACTIONS(31),
    [anon_sym_long] = ACTIONS(31),
    [anon_sym_short] = ACTIONS(31),
    [sym_primitive_type] = ACTIONS(33),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_union] = ACTIONS(39),
    [anon_sym_if] = ACTIONS(646),
    [anon_sym_switch] = ACTIONS(648),
    [anon_sym_case] = ACTIONS(650),
    [anon_sym_default] = ACTIONS(652),
    [anon_sym_while] = ACTIONS(654),
    [anon_sym_do] = ACTIONS(656),
    [anon_sym_for] = ACTIONS(658),
    [anon_sym_return] = ACTIONS(660),
    [anon_sym_break] = ACTIONS(662),
    [anon_sym_continue] = ACTIONS(664),
    [anon_sym_goto] = ACTIONS(666),
    [anon_sym_AMP] = ACTIONS(644),
    [anon_sym_BANG] = ACTIONS(668),
    [anon_sym_TILDE] = ACTIONS(670),
    [anon_sym_PLUS] = ACTIONS(672),
    [anon_sym_DASH] = ACTIONS(672),
    [anon_sym_DASH_DASH] = ACTIONS(674),
    [anon_sym_PLUS_PLUS] = ACTIONS(674),
    [anon_sym_sizeof] = ACTIONS(676),
    [sym_number_literal] = ACTIONS(620),
    [sym_char_literal] = ACTIONS(620),
    [sym_string_literal] = ACTIONS(678),
    [sym_true] = ACTIONS(680),
    [sym_false] = ACTIONS(680),
    [sym_null] = ACTIONS(680),
    [sym_identifier] = ACTIONS(682),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(51),
    [sym_auto] = ACTIONS(33),
    [anon_sym_typename] = ACTIONS(53),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(684),
    [anon_sym_delete] = ACTIONS(686),
    [sym_nullptr] = ACTIONS(680),
  },
  [2299] = {
    [sym__expression] = STATE(2548),
    [sym_conditional_expression] = STATE(2548),
    [sym_assignment_expression] = STATE(2548),
    [sym_pointer_expression] = STATE(2548),
    [sym_logical_expression] = STATE(2548),
    [sym_bitwise_expression] = STATE(2548),
    [sym_equality_expression] = STATE(2548),
    [sym_relational_expression] = STATE(2548),
    [sym_shift_expression] = STATE(2548),
    [sym_math_expression] = STATE(2548),
    [sym_cast_expression] = STATE(2548),
    [sym_sizeof_expression] = STATE(2548),
    [sym_subscript_expression] = STATE(2548),
    [sym_call_expression] = STATE(2548),
    [sym_field_expression] = STATE(2548),
    [sym_compound_literal_expression] = STATE(2548),
    [sym_parenthesized_expression] = STATE(2548),
    [sym_concatenated_string] = STATE(2548),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(2548),
    [sym_new_expression] = STATE(2548),
    [sym_delete_expression] = STATE(2548),
    [sym_lambda_expression] = STATE(2548),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(6047),
    [anon_sym_LPAREN] = ACTIONS(2943),
    [anon_sym_STAR] = ACTIONS(2945),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_AMP] = ACTIONS(2945),
    [anon_sym_BANG] = ACTIONS(2947),
    [anon_sym_TILDE] = ACTIONS(2949),
    [anon_sym_PLUS] = ACTIONS(2951),
    [anon_sym_DASH] = ACTIONS(2951),
    [anon_sym_DASH_DASH] = ACTIONS(2953),
    [anon_sym_PLUS_PLUS] = ACTIONS(2953),
    [anon_sym_sizeof] = ACTIONS(2955),
    [sym_number_literal] = ACTIONS(6047),
    [sym_char_literal] = ACTIONS(6047),
    [sym_string_literal] = ACTIONS(2957),
    [sym_true] = ACTIONS(6049),
    [sym_false] = ACTIONS(6049),
    [sym_null] = ACTIONS(6049),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(2961),
    [anon_sym_delete] = ACTIONS(2963),
    [sym_nullptr] = ACTIONS(6049),
  },
  [2300] = {
    [anon_sym_LPAREN] = ACTIONS(6051),
    [sym_comment] = ACTIONS(49),
  },
  [2301] = {
    [sym__expression] = STATE(2550),
    [sym_conditional_expression] = STATE(2550),
    [sym_assignment_expression] = STATE(2550),
    [sym_pointer_expression] = STATE(2550),
    [sym_logical_expression] = STATE(2550),
    [sym_bitwise_expression] = STATE(2550),
    [sym_equality_expression] = STATE(2550),
    [sym_relational_expression] = STATE(2550),
    [sym_shift_expression] = STATE(2550),
    [sym_math_expression] = STATE(2550),
    [sym_cast_expression] = STATE(2550),
    [sym_sizeof_expression] = STATE(2550),
    [sym_subscript_expression] = STATE(2550),
    [sym_call_expression] = STATE(2550),
    [sym_field_expression] = STATE(2550),
    [sym_compound_literal_expression] = STATE(2550),
    [sym_parenthesized_expression] = STATE(2550),
    [sym_concatenated_string] = STATE(2550),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(2550),
    [sym_new_expression] = STATE(2550),
    [sym_delete_expression] = STATE(2550),
    [sym_lambda_expression] = STATE(2550),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(6053),
    [anon_sym_LPAREN] = ACTIONS(2943),
    [anon_sym_STAR] = ACTIONS(2945),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_AMP] = ACTIONS(2945),
    [anon_sym_BANG] = ACTIONS(2947),
    [anon_sym_TILDE] = ACTIONS(2949),
    [anon_sym_PLUS] = ACTIONS(2951),
    [anon_sym_DASH] = ACTIONS(2951),
    [anon_sym_DASH_DASH] = ACTIONS(2953),
    [anon_sym_PLUS_PLUS] = ACTIONS(2953),
    [anon_sym_sizeof] = ACTIONS(2955),
    [sym_number_literal] = ACTIONS(6053),
    [sym_char_literal] = ACTIONS(6053),
    [sym_string_literal] = ACTIONS(2957),
    [sym_true] = ACTIONS(6055),
    [sym_false] = ACTIONS(6055),
    [sym_null] = ACTIONS(6055),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(2961),
    [anon_sym_delete] = ACTIONS(2963),
    [sym_nullptr] = ACTIONS(6055),
  },
  [2302] = {
    [sym_argument_list] = STATE(802),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_STAR] = ACTIONS(3003),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_EQ] = ACTIONS(3005),
    [anon_sym_COLON] = ACTIONS(6057),
    [anon_sym_QMARK] = ACTIONS(3009),
    [anon_sym_STAR_EQ] = ACTIONS(3011),
    [anon_sym_SLASH_EQ] = ACTIONS(3011),
    [anon_sym_PERCENT_EQ] = ACTIONS(3011),
    [anon_sym_PLUS_EQ] = ACTIONS(3011),
    [anon_sym_DASH_EQ] = ACTIONS(3011),
    [anon_sym_LT_LT_EQ] = ACTIONS(3011),
    [anon_sym_GT_GT_EQ] = ACTIONS(3011),
    [anon_sym_AMP_EQ] = ACTIONS(3011),
    [anon_sym_CARET_EQ] = ACTIONS(3011),
    [anon_sym_PIPE_EQ] = ACTIONS(3011),
    [anon_sym_AMP] = ACTIONS(3013),
    [anon_sym_PIPE_PIPE] = ACTIONS(3015),
    [anon_sym_AMP_AMP] = ACTIONS(3017),
    [anon_sym_PIPE] = ACTIONS(3019),
    [anon_sym_CARET] = ACTIONS(3021),
    [anon_sym_EQ_EQ] = ACTIONS(3023),
    [anon_sym_BANG_EQ] = ACTIONS(3023),
    [anon_sym_LT] = ACTIONS(3025),
    [anon_sym_GT] = ACTIONS(3025),
    [anon_sym_LT_EQ] = ACTIONS(3027),
    [anon_sym_GT_EQ] = ACTIONS(3027),
    [anon_sym_LT_LT] = ACTIONS(3029),
    [anon_sym_GT_GT] = ACTIONS(3029),
    [anon_sym_PLUS] = ACTIONS(3031),
    [anon_sym_DASH] = ACTIONS(3031),
    [anon_sym_SLASH] = ACTIONS(3003),
    [anon_sym_PERCENT] = ACTIONS(3003),
    [anon_sym_DASH_DASH] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(3033),
    [anon_sym_DASH_GT] = ACTIONS(3033),
    [sym_comment] = ACTIONS(49),
  },
  [2303] = {
    [sym_declaration] = STATE(2553),
    [sym_type_definition] = STATE(2553),
    [sym__declaration_specifiers] = STATE(2554),
    [sym_compound_statement] = STATE(2553),
    [sym_storage_class_specifier] = STATE(109),
    [sym_type_qualifier] = STATE(109),
    [sym__type_specifier] = STATE(105),
    [sym_sized_type_specifier] = STATE(105),
    [sym_enum_specifier] = STATE(105),
    [sym_struct_specifier] = STATE(105),
    [sym_union_specifier] = STATE(105),
    [sym_labeled_statement] = STATE(2553),
    [sym_expression_statement] = STATE(2553),
    [sym_if_statement] = STATE(2553),
    [sym_switch_statement] = STATE(2553),
    [sym_case_statement] = STATE(2553),
    [sym_while_statement] = STATE(2553),
    [sym_do_statement] = STATE(2553),
    [sym_for_statement] = STATE(2553),
    [sym_return_statement] = STATE(2553),
    [sym_break_statement] = STATE(2553),
    [sym_continue_statement] = STATE(2553),
    [sym_goto_statement] = STATE(2553),
    [sym__expression] = STATE(1947),
    [sym_comma_expression] = STATE(1948),
    [sym_conditional_expression] = STATE(1947),
    [sym_assignment_expression] = STATE(1947),
    [sym_pointer_expression] = STATE(1947),
    [sym_logical_expression] = STATE(1947),
    [sym_bitwise_expression] = STATE(1947),
    [sym_equality_expression] = STATE(1947),
    [sym_relational_expression] = STATE(1947),
    [sym_shift_expression] = STATE(1947),
    [sym_math_expression] = STATE(1947),
    [sym_cast_expression] = STATE(1947),
    [sym_sizeof_expression] = STATE(1947),
    [sym_subscript_expression] = STATE(1947),
    [sym_call_expression] = STATE(1947),
    [sym_field_expression] = STATE(1947),
    [sym_compound_literal_expression] = STATE(1947),
    [sym_parenthesized_expression] = STATE(1947),
    [sym_concatenated_string] = STATE(1947),
    [sym_macro_type_specifier] = STATE(105),
    [sym_class_specifier] = STATE(105),
    [sym_dependent_type] = STATE(105),
    [sym_template_type] = STATE(1475),
    [sym_template_function] = STATE(1947),
    [sym_for_range_loop] = STATE(2553),
    [sym_new_expression] = STATE(1947),
    [sym_delete_expression] = STATE(1947),
    [sym_lambda_expression] = STATE(1947),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(416),
    [sym_scoped_namespace_identifier] = STATE(1476),
    [aux_sym__declaration_specifiers_repeat1] = STATE(109),
    [aux_sym_sized_type_specifier_repeat1] = STATE(110),
    [sym_raw_string_literal] = ACTIONS(4395),
    [anon_sym_LPAREN] = ACTIONS(626),
    [anon_sym_SEMI] = ACTIONS(4411),
    [anon_sym_typedef] = ACTIONS(4413),
    [anon_sym_extern] = ACTIONS(154),
    [anon_sym_LBRACE] = ACTIONS(4415),
    [anon_sym_STAR] = ACTIONS(644),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_static] = ACTIONS(154),
    [anon_sym_register] = ACTIONS(154),
    [anon_sym_inline] = ACTIONS(154),
    [anon_sym_const] = ACTIONS(158),
    [anon_sym_restrict] = ACTIONS(158),
    [anon_sym_volatile] = ACTIONS(158),
    [anon_sym__Atomic] = ACTIONS(158),
    [anon_sym_mutable] = ACTIONS(158),
    [anon_sym_explicit] = ACTIONS(158),
    [anon_sym_constexpr] = ACTIONS(158),
    [anon_sym_unsigned] = ACTIONS(160),
    [anon_sym_long] = ACTIONS(160),
    [anon_sym_short] = ACTIONS(160),
    [sym_primitive_type] = ACTIONS(162),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_union] = ACTIONS(39),
    [anon_sym_if] = ACTIONS(4417),
    [anon_sym_switch] = ACTIONS(4419),
    [anon_sym_case] = ACTIONS(4421),
    [anon_sym_default] = ACTIONS(4423),
    [anon_sym_while] = ACTIONS(4425),
    [anon_sym_do] = ACTIONS(4427),
    [anon_sym_for] = ACTIONS(4429),
    [anon_sym_return] = ACTIONS(4431),
    [anon_sym_break] = ACTIONS(4433),
    [anon_sym_continue] = ACTIONS(4435),
    [anon_sym_goto] = ACTIONS(4437),
    [anon_sym_AMP] = ACTIONS(644),
    [anon_sym_BANG] = ACTIONS(668),
    [anon_sym_TILDE] = ACTIONS(670),
    [anon_sym_PLUS] = ACTIONS(672),
    [anon_sym_DASH] = ACTIONS(672),
    [anon_sym_DASH_DASH] = ACTIONS(674),
    [anon_sym_PLUS_PLUS] = ACTIONS(674),
    [anon_sym_sizeof] = ACTIONS(676),
    [sym_number_literal] = ACTIONS(4395),
    [sym_char_literal] = ACTIONS(4395),
    [sym_string_literal] = ACTIONS(678),
    [sym_true] = ACTIONS(4439),
    [sym_false] = ACTIONS(4439),
    [sym_null] = ACTIONS(4439),
    [sym_identifier] = ACTIONS(6059),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(51),
    [sym_auto] = ACTIONS(162),
    [anon_sym_typename] = ACTIONS(172),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(3040),
    [anon_sym_delete] = ACTIONS(686),
    [sym_nullptr] = ACTIONS(4439),
  },
  [2304] = {
    [sym__expression] = STATE(2555),
    [sym_conditional_expression] = STATE(2555),
    [sym_assignment_expression] = STATE(2555),
    [sym_pointer_expression] = STATE(2555),
    [sym_logical_expression] = STATE(2555),
    [sym_bitwise_expression] = STATE(2555),
    [sym_equality_expression] = STATE(2555),
    [sym_relational_expression] = STATE(2555),
    [sym_shift_expression] = STATE(2555),
    [sym_math_expression] = STATE(2555),
    [sym_cast_expression] = STATE(2555),
    [sym_sizeof_expression] = STATE(2555),
    [sym_subscript_expression] = STATE(2555),
    [sym_call_expression] = STATE(2555),
    [sym_field_expression] = STATE(2555),
    [sym_compound_literal_expression] = STATE(2555),
    [sym_parenthesized_expression] = STATE(2555),
    [sym_concatenated_string] = STATE(2555),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(2555),
    [sym_new_expression] = STATE(2555),
    [sym_delete_expression] = STATE(2555),
    [sym_lambda_expression] = STATE(2555),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(6061),
    [anon_sym_LPAREN] = ACTIONS(2943),
    [anon_sym_STAR] = ACTIONS(2945),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_AMP] = ACTIONS(2945),
    [anon_sym_BANG] = ACTIONS(2947),
    [anon_sym_TILDE] = ACTIONS(2949),
    [anon_sym_PLUS] = ACTIONS(2951),
    [anon_sym_DASH] = ACTIONS(2951),
    [anon_sym_DASH_DASH] = ACTIONS(2953),
    [anon_sym_PLUS_PLUS] = ACTIONS(2953),
    [anon_sym_sizeof] = ACTIONS(2955),
    [sym_number_literal] = ACTIONS(6061),
    [sym_char_literal] = ACTIONS(6061),
    [sym_string_literal] = ACTIONS(2957),
    [sym_true] = ACTIONS(6063),
    [sym_false] = ACTIONS(6063),
    [sym_null] = ACTIONS(6063),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(2961),
    [anon_sym_delete] = ACTIONS(2963),
    [sym_nullptr] = ACTIONS(6063),
  },
  [2305] = {
    [anon_sym_while] = ACTIONS(6065),
    [sym_comment] = ACTIONS(49),
  },
  [2306] = {
    [sym_declaration] = STATE(2557),
    [sym__declaration_specifiers] = STATE(1500),
    [sym_storage_class_specifier] = STATE(109),
    [sym_type_qualifier] = STATE(109),
    [sym__type_specifier] = STATE(105),
    [sym_sized_type_specifier] = STATE(105),
    [sym_enum_specifier] = STATE(105),
    [sym_struct_specifier] = STATE(105),
    [sym_union_specifier] = STATE(105),
    [sym__expression] = STATE(2558),
    [sym_conditional_expression] = STATE(2558),
    [sym_assignment_expression] = STATE(2558),
    [sym_pointer_expression] = STATE(2558),
    [sym_logical_expression] = STATE(2558),
    [sym_bitwise_expression] = STATE(2558),
    [sym_equality_expression] = STATE(2558),
    [sym_relational_expression] = STATE(2558),
    [sym_shift_expression] = STATE(2558),
    [sym_math_expression] = STATE(2558),
    [sym_cast_expression] = STATE(2558),
    [sym_sizeof_expression] = STATE(2558),
    [sym_subscript_expression] = STATE(2558),
    [sym_call_expression] = STATE(2558),
    [sym_field_expression] = STATE(2558),
    [sym_compound_literal_expression] = STATE(2558),
    [sym_parenthesized_expression] = STATE(2558),
    [sym_concatenated_string] = STATE(2558),
    [sym_macro_type_specifier] = STATE(105),
    [sym_class_specifier] = STATE(105),
    [sym_dependent_type] = STATE(105),
    [sym_template_type] = STATE(1475),
    [sym_template_function] = STATE(2558),
    [sym_for_range_declaration] = STATE(2559),
    [sym_new_expression] = STATE(2558),
    [sym_delete_expression] = STATE(2558),
    [sym_lambda_expression] = STATE(2558),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(416),
    [sym_scoped_namespace_identifier] = STATE(1476),
    [aux_sym__declaration_specifiers_repeat1] = STATE(109),
    [aux_sym_sized_type_specifier_repeat1] = STATE(110),
    [sym_raw_string_literal] = ACTIONS(6067),
    [anon_sym_LPAREN] = ACTIONS(1347),
    [anon_sym_SEMI] = ACTIONS(6069),
    [anon_sym_extern] = ACTIONS(154),
    [anon_sym_STAR] = ACTIONS(1349),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_static] = ACTIONS(154),
    [anon_sym_register] = ACTIONS(154),
    [anon_sym_inline] = ACTIONS(154),
    [anon_sym_const] = ACTIONS(158),
    [anon_sym_restrict] = ACTIONS(158),
    [anon_sym_volatile] = ACTIONS(158),
    [anon_sym__Atomic] = ACTIONS(158),
    [anon_sym_mutable] = ACTIONS(158),
    [anon_sym_explicit] = ACTIONS(158),
    [anon_sym_constexpr] = ACTIONS(158),
    [anon_sym_unsigned] = ACTIONS(160),
    [anon_sym_long] = ACTIONS(160),
    [anon_sym_short] = ACTIONS(160),
    [sym_primitive_type] = ACTIONS(162),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_union] = ACTIONS(39),
    [anon_sym_AMP] = ACTIONS(1349),
    [anon_sym_BANG] = ACTIONS(1351),
    [anon_sym_TILDE] = ACTIONS(1353),
    [anon_sym_PLUS] = ACTIONS(1355),
    [anon_sym_DASH] = ACTIONS(1355),
    [anon_sym_DASH_DASH] = ACTIONS(1357),
    [anon_sym_PLUS_PLUS] = ACTIONS(1357),
    [anon_sym_sizeof] = ACTIONS(1359),
    [sym_number_literal] = ACTIONS(6067),
    [sym_char_literal] = ACTIONS(6067),
    [sym_string_literal] = ACTIONS(1361),
    [sym_true] = ACTIONS(6071),
    [sym_false] = ACTIONS(6071),
    [sym_null] = ACTIONS(6071),
    [sym_identifier] = ACTIONS(3088),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(51),
    [sym_auto] = ACTIONS(162),
    [anon_sym_typename] = ACTIONS(172),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(3090),
    [anon_sym_delete] = ACTIONS(1367),
    [sym_nullptr] = ACTIONS(6071),
  },
  [2307] = {
    [sym_raw_string_literal] = ACTIONS(3092),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3094),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3094),
    [anon_sym_LPAREN] = ACTIONS(3092),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3094),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3094),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3094),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3094),
    [sym_preproc_directive] = ACTIONS(3094),
    [anon_sym_SEMI] = ACTIONS(3092),
    [anon_sym_typedef] = ACTIONS(3094),
    [anon_sym_extern] = ACTIONS(3094),
    [anon_sym_LBRACE] = ACTIONS(3092),
    [anon_sym_STAR] = ACTIONS(3092),
    [anon_sym_LBRACK] = ACTIONS(3092),
    [anon_sym_static] = ACTIONS(3094),
    [anon_sym_register] = ACTIONS(3094),
    [anon_sym_inline] = ACTIONS(3094),
    [anon_sym_const] = ACTIONS(3094),
    [anon_sym_restrict] = ACTIONS(3094),
    [anon_sym_volatile] = ACTIONS(3094),
    [anon_sym__Atomic] = ACTIONS(3094),
    [anon_sym_mutable] = ACTIONS(3094),
    [anon_sym_explicit] = ACTIONS(3094),
    [anon_sym_constexpr] = ACTIONS(3094),
    [anon_sym_unsigned] = ACTIONS(3094),
    [anon_sym_long] = ACTIONS(3094),
    [anon_sym_short] = ACTIONS(3094),
    [sym_primitive_type] = ACTIONS(3094),
    [anon_sym_enum] = ACTIONS(3094),
    [anon_sym_struct] = ACTIONS(3094),
    [anon_sym_union] = ACTIONS(3094),
    [anon_sym_if] = ACTIONS(3094),
    [anon_sym_switch] = ACTIONS(3094),
    [anon_sym_case] = ACTIONS(3094),
    [anon_sym_default] = ACTIONS(3094),
    [anon_sym_while] = ACTIONS(3094),
    [anon_sym_do] = ACTIONS(3094),
    [anon_sym_for] = ACTIONS(3094),
    [anon_sym_return] = ACTIONS(3094),
    [anon_sym_break] = ACTIONS(3094),
    [anon_sym_continue] = ACTIONS(3094),
    [anon_sym_goto] = ACTIONS(3094),
    [anon_sym_AMP] = ACTIONS(3092),
    [anon_sym_BANG] = ACTIONS(3092),
    [anon_sym_TILDE] = ACTIONS(3092),
    [anon_sym_PLUS] = ACTIONS(3094),
    [anon_sym_DASH] = ACTIONS(3094),
    [anon_sym_DASH_DASH] = ACTIONS(3092),
    [anon_sym_PLUS_PLUS] = ACTIONS(3092),
    [anon_sym_sizeof] = ACTIONS(3094),
    [sym_number_literal] = ACTIONS(3092),
    [sym_char_literal] = ACTIONS(3092),
    [sym_string_literal] = ACTIONS(3092),
    [sym_true] = ACTIONS(3094),
    [sym_false] = ACTIONS(3094),
    [sym_null] = ACTIONS(3094),
    [sym_identifier] = ACTIONS(3094),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(3094),
    [sym_auto] = ACTIONS(3094),
    [anon_sym_typename] = ACTIONS(3094),
    [anon_sym_new] = ACTIONS(3094),
    [anon_sym_COLON_COLON] = ACTIONS(3092),
    [anon_sym_delete] = ACTIONS(3094),
    [sym_nullptr] = ACTIONS(3094),
  },
  [2308] = {
    [sym_argument_list] = STATE(802),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_SEMI] = ACTIONS(6073),
    [anon_sym_STAR] = ACTIONS(2553),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_EQ] = ACTIONS(2555),
    [anon_sym_QMARK] = ACTIONS(2557),
    [anon_sym_STAR_EQ] = ACTIONS(2559),
    [anon_sym_SLASH_EQ] = ACTIONS(2559),
    [anon_sym_PERCENT_EQ] = ACTIONS(2559),
    [anon_sym_PLUS_EQ] = ACTIONS(2559),
    [anon_sym_DASH_EQ] = ACTIONS(2559),
    [anon_sym_LT_LT_EQ] = ACTIONS(2559),
    [anon_sym_GT_GT_EQ] = ACTIONS(2559),
    [anon_sym_AMP_EQ] = ACTIONS(2559),
    [anon_sym_CARET_EQ] = ACTIONS(2559),
    [anon_sym_PIPE_EQ] = ACTIONS(2559),
    [anon_sym_AMP] = ACTIONS(2561),
    [anon_sym_PIPE_PIPE] = ACTIONS(2563),
    [anon_sym_AMP_AMP] = ACTIONS(2565),
    [anon_sym_PIPE] = ACTIONS(2567),
    [anon_sym_CARET] = ACTIONS(2569),
    [anon_sym_EQ_EQ] = ACTIONS(2571),
    [anon_sym_BANG_EQ] = ACTIONS(2571),
    [anon_sym_LT] = ACTIONS(2573),
    [anon_sym_GT] = ACTIONS(2573),
    [anon_sym_LT_EQ] = ACTIONS(2575),
    [anon_sym_GT_EQ] = ACTIONS(2575),
    [anon_sym_LT_LT] = ACTIONS(2577),
    [anon_sym_GT_GT] = ACTIONS(2577),
    [anon_sym_PLUS] = ACTIONS(2579),
    [anon_sym_DASH] = ACTIONS(2579),
    [anon_sym_SLASH] = ACTIONS(2553),
    [anon_sym_PERCENT] = ACTIONS(2553),
    [anon_sym_DASH_DASH] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(1554),
    [anon_sym_DASH_GT] = ACTIONS(1554),
    [sym_comment] = ACTIONS(49),
  },
  [2309] = {
    [anon_sym_SEMI] = ACTIONS(6073),
    [sym_comment] = ACTIONS(49),
  },
  [2310] = {
    [sym_raw_string_literal] = ACTIONS(3098),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3100),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3100),
    [anon_sym_LPAREN] = ACTIONS(3098),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3100),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3100),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3100),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3100),
    [sym_preproc_directive] = ACTIONS(3100),
    [anon_sym_SEMI] = ACTIONS(3098),
    [anon_sym_typedef] = ACTIONS(3100),
    [anon_sym_extern] = ACTIONS(3100),
    [anon_sym_LBRACE] = ACTIONS(3098),
    [anon_sym_STAR] = ACTIONS(3098),
    [anon_sym_LBRACK] = ACTIONS(3098),
    [anon_sym_static] = ACTIONS(3100),
    [anon_sym_register] = ACTIONS(3100),
    [anon_sym_inline] = ACTIONS(3100),
    [anon_sym_const] = ACTIONS(3100),
    [anon_sym_restrict] = ACTIONS(3100),
    [anon_sym_volatile] = ACTIONS(3100),
    [anon_sym__Atomic] = ACTIONS(3100),
    [anon_sym_mutable] = ACTIONS(3100),
    [anon_sym_explicit] = ACTIONS(3100),
    [anon_sym_constexpr] = ACTIONS(3100),
    [anon_sym_unsigned] = ACTIONS(3100),
    [anon_sym_long] = ACTIONS(3100),
    [anon_sym_short] = ACTIONS(3100),
    [sym_primitive_type] = ACTIONS(3100),
    [anon_sym_enum] = ACTIONS(3100),
    [anon_sym_struct] = ACTIONS(3100),
    [anon_sym_union] = ACTIONS(3100),
    [anon_sym_if] = ACTIONS(3100),
    [anon_sym_switch] = ACTIONS(3100),
    [anon_sym_case] = ACTIONS(3100),
    [anon_sym_default] = ACTIONS(3100),
    [anon_sym_while] = ACTIONS(3100),
    [anon_sym_do] = ACTIONS(3100),
    [anon_sym_for] = ACTIONS(3100),
    [anon_sym_return] = ACTIONS(3100),
    [anon_sym_break] = ACTIONS(3100),
    [anon_sym_continue] = ACTIONS(3100),
    [anon_sym_goto] = ACTIONS(3100),
    [anon_sym_AMP] = ACTIONS(3098),
    [anon_sym_BANG] = ACTIONS(3098),
    [anon_sym_TILDE] = ACTIONS(3098),
    [anon_sym_PLUS] = ACTIONS(3100),
    [anon_sym_DASH] = ACTIONS(3100),
    [anon_sym_DASH_DASH] = ACTIONS(3098),
    [anon_sym_PLUS_PLUS] = ACTIONS(3098),
    [anon_sym_sizeof] = ACTIONS(3100),
    [sym_number_literal] = ACTIONS(3098),
    [sym_char_literal] = ACTIONS(3098),
    [sym_string_literal] = ACTIONS(3098),
    [sym_true] = ACTIONS(3100),
    [sym_false] = ACTIONS(3100),
    [sym_null] = ACTIONS(3100),
    [sym_identifier] = ACTIONS(3100),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(3100),
    [sym_auto] = ACTIONS(3100),
    [anon_sym_typename] = ACTIONS(3100),
    [anon_sym_new] = ACTIONS(3100),
    [anon_sym_COLON_COLON] = ACTIONS(3098),
    [anon_sym_delete] = ACTIONS(3100),
    [sym_nullptr] = ACTIONS(3100),
  },
  [2311] = {
    [sym_raw_string_literal] = ACTIONS(3102),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3104),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3104),
    [anon_sym_LPAREN] = ACTIONS(3102),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3104),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3104),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3104),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3104),
    [sym_preproc_directive] = ACTIONS(3104),
    [anon_sym_SEMI] = ACTIONS(3102),
    [anon_sym_typedef] = ACTIONS(3104),
    [anon_sym_extern] = ACTIONS(3104),
    [anon_sym_LBRACE] = ACTIONS(3102),
    [anon_sym_STAR] = ACTIONS(3102),
    [anon_sym_LBRACK] = ACTIONS(3102),
    [anon_sym_static] = ACTIONS(3104),
    [anon_sym_register] = ACTIONS(3104),
    [anon_sym_inline] = ACTIONS(3104),
    [anon_sym_const] = ACTIONS(3104),
    [anon_sym_restrict] = ACTIONS(3104),
    [anon_sym_volatile] = ACTIONS(3104),
    [anon_sym__Atomic] = ACTIONS(3104),
    [anon_sym_mutable] = ACTIONS(3104),
    [anon_sym_explicit] = ACTIONS(3104),
    [anon_sym_constexpr] = ACTIONS(3104),
    [anon_sym_unsigned] = ACTIONS(3104),
    [anon_sym_long] = ACTIONS(3104),
    [anon_sym_short] = ACTIONS(3104),
    [sym_primitive_type] = ACTIONS(3104),
    [anon_sym_enum] = ACTIONS(3104),
    [anon_sym_struct] = ACTIONS(3104),
    [anon_sym_union] = ACTIONS(3104),
    [anon_sym_if] = ACTIONS(3104),
    [anon_sym_switch] = ACTIONS(3104),
    [anon_sym_case] = ACTIONS(3104),
    [anon_sym_default] = ACTIONS(3104),
    [anon_sym_while] = ACTIONS(3104),
    [anon_sym_do] = ACTIONS(3104),
    [anon_sym_for] = ACTIONS(3104),
    [anon_sym_return] = ACTIONS(3104),
    [anon_sym_break] = ACTIONS(3104),
    [anon_sym_continue] = ACTIONS(3104),
    [anon_sym_goto] = ACTIONS(3104),
    [anon_sym_AMP] = ACTIONS(3102),
    [anon_sym_BANG] = ACTIONS(3102),
    [anon_sym_TILDE] = ACTIONS(3102),
    [anon_sym_PLUS] = ACTIONS(3104),
    [anon_sym_DASH] = ACTIONS(3104),
    [anon_sym_DASH_DASH] = ACTIONS(3102),
    [anon_sym_PLUS_PLUS] = ACTIONS(3102),
    [anon_sym_sizeof] = ACTIONS(3104),
    [sym_number_literal] = ACTIONS(3102),
    [sym_char_literal] = ACTIONS(3102),
    [sym_string_literal] = ACTIONS(3102),
    [sym_true] = ACTIONS(3104),
    [sym_false] = ACTIONS(3104),
    [sym_null] = ACTIONS(3104),
    [sym_identifier] = ACTIONS(3104),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(3104),
    [sym_auto] = ACTIONS(3104),
    [anon_sym_typename] = ACTIONS(3104),
    [anon_sym_new] = ACTIONS(3104),
    [anon_sym_COLON_COLON] = ACTIONS(3102),
    [anon_sym_delete] = ACTIONS(3104),
    [sym_nullptr] = ACTIONS(3104),
  },
  [2312] = {
    [anon_sym_SEMI] = ACTIONS(6075),
    [sym_comment] = ACTIONS(49),
  },
  [2313] = {
    [sym_compound_statement] = STATE(2563),
    [sym_labeled_statement] = STATE(2563),
    [sym_expression_statement] = STATE(2563),
    [sym_if_statement] = STATE(2563),
    [sym_switch_statement] = STATE(2563),
    [sym_case_statement] = STATE(2563),
    [sym_while_statement] = STATE(2563),
    [sym_do_statement] = STATE(2563),
    [sym_for_statement] = STATE(2563),
    [sym_return_statement] = STATE(2563),
    [sym_break_statement] = STATE(2563),
    [sym_continue_statement] = STATE(2563),
    [sym_goto_statement] = STATE(2563),
    [sym__expression] = STATE(1947),
    [sym_comma_expression] = STATE(1948),
    [sym_conditional_expression] = STATE(1947),
    [sym_assignment_expression] = STATE(1947),
    [sym_pointer_expression] = STATE(1947),
    [sym_logical_expression] = STATE(1947),
    [sym_bitwise_expression] = STATE(1947),
    [sym_equality_expression] = STATE(1947),
    [sym_relational_expression] = STATE(1947),
    [sym_shift_expression] = STATE(1947),
    [sym_math_expression] = STATE(1947),
    [sym_cast_expression] = STATE(1947),
    [sym_sizeof_expression] = STATE(1947),
    [sym_subscript_expression] = STATE(1947),
    [sym_call_expression] = STATE(1947),
    [sym_field_expression] = STATE(1947),
    [sym_compound_literal_expression] = STATE(1947),
    [sym_parenthesized_expression] = STATE(1947),
    [sym_concatenated_string] = STATE(1947),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(1947),
    [sym_for_range_loop] = STATE(2563),
    [sym_new_expression] = STATE(1947),
    [sym_delete_expression] = STATE(1947),
    [sym_lambda_expression] = STATE(1947),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(4395),
    [anon_sym_LPAREN] = ACTIONS(626),
    [anon_sym_SEMI] = ACTIONS(4411),
    [anon_sym_LBRACE] = ACTIONS(4415),
    [anon_sym_STAR] = ACTIONS(644),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_if] = ACTIONS(4417),
    [anon_sym_switch] = ACTIONS(4419),
    [anon_sym_case] = ACTIONS(4421),
    [anon_sym_default] = ACTIONS(4423),
    [anon_sym_while] = ACTIONS(4425),
    [anon_sym_do] = ACTIONS(4427),
    [anon_sym_for] = ACTIONS(4429),
    [anon_sym_return] = ACTIONS(4431),
    [anon_sym_break] = ACTIONS(4433),
    [anon_sym_continue] = ACTIONS(4435),
    [anon_sym_goto] = ACTIONS(4437),
    [anon_sym_AMP] = ACTIONS(644),
    [anon_sym_BANG] = ACTIONS(668),
    [anon_sym_TILDE] = ACTIONS(670),
    [anon_sym_PLUS] = ACTIONS(672),
    [anon_sym_DASH] = ACTIONS(672),
    [anon_sym_DASH_DASH] = ACTIONS(674),
    [anon_sym_PLUS_PLUS] = ACTIONS(674),
    [anon_sym_sizeof] = ACTIONS(676),
    [sym_number_literal] = ACTIONS(4395),
    [sym_char_literal] = ACTIONS(4395),
    [sym_string_literal] = ACTIONS(678),
    [sym_true] = ACTIONS(4439),
    [sym_false] = ACTIONS(4439),
    [sym_null] = ACTIONS(4439),
    [sym_identifier] = ACTIONS(6077),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1303),
    [anon_sym_delete] = ACTIONS(686),
    [sym_nullptr] = ACTIONS(4439),
  },
  [2314] = {
    [sym_raw_string_literal] = ACTIONS(522),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(524),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(524),
    [anon_sym_LPAREN] = ACTIONS(522),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(524),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(524),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(524),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(524),
    [sym_preproc_directive] = ACTIONS(524),
    [anon_sym_SEMI] = ACTIONS(522),
    [anon_sym_typedef] = ACTIONS(524),
    [anon_sym_extern] = ACTIONS(524),
    [anon_sym_LBRACE] = ACTIONS(522),
    [anon_sym_STAR] = ACTIONS(522),
    [anon_sym_LBRACK] = ACTIONS(522),
    [anon_sym_static] = ACTIONS(524),
    [anon_sym_register] = ACTIONS(524),
    [anon_sym_inline] = ACTIONS(524),
    [anon_sym_const] = ACTIONS(524),
    [anon_sym_restrict] = ACTIONS(524),
    [anon_sym_volatile] = ACTIONS(524),
    [anon_sym__Atomic] = ACTIONS(524),
    [anon_sym_mutable] = ACTIONS(524),
    [anon_sym_explicit] = ACTIONS(524),
    [anon_sym_constexpr] = ACTIONS(524),
    [anon_sym_unsigned] = ACTIONS(524),
    [anon_sym_long] = ACTIONS(524),
    [anon_sym_short] = ACTIONS(524),
    [sym_primitive_type] = ACTIONS(524),
    [anon_sym_enum] = ACTIONS(524),
    [anon_sym_struct] = ACTIONS(524),
    [anon_sym_union] = ACTIONS(524),
    [anon_sym_if] = ACTIONS(524),
    [anon_sym_switch] = ACTIONS(524),
    [anon_sym_case] = ACTIONS(524),
    [anon_sym_default] = ACTIONS(524),
    [anon_sym_while] = ACTIONS(524),
    [anon_sym_do] = ACTIONS(524),
    [anon_sym_for] = ACTIONS(524),
    [anon_sym_return] = ACTIONS(524),
    [anon_sym_break] = ACTIONS(524),
    [anon_sym_continue] = ACTIONS(524),
    [anon_sym_goto] = ACTIONS(524),
    [anon_sym_AMP] = ACTIONS(522),
    [anon_sym_BANG] = ACTIONS(522),
    [anon_sym_TILDE] = ACTIONS(522),
    [anon_sym_PLUS] = ACTIONS(524),
    [anon_sym_DASH] = ACTIONS(524),
    [anon_sym_DASH_DASH] = ACTIONS(522),
    [anon_sym_PLUS_PLUS] = ACTIONS(522),
    [anon_sym_sizeof] = ACTIONS(524),
    [sym_number_literal] = ACTIONS(522),
    [sym_char_literal] = ACTIONS(522),
    [sym_string_literal] = ACTIONS(522),
    [sym_true] = ACTIONS(524),
    [sym_false] = ACTIONS(524),
    [sym_null] = ACTIONS(524),
    [sym_identifier] = ACTIONS(524),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(524),
    [sym_auto] = ACTIONS(524),
    [anon_sym_typename] = ACTIONS(524),
    [anon_sym_new] = ACTIONS(524),
    [anon_sym_COLON_COLON] = ACTIONS(522),
    [anon_sym_delete] = ACTIONS(524),
    [sym_nullptr] = ACTIONS(524),
  },
  [2315] = {
    [sym_parameter_list] = STATE(332),
    [sym_argument_list] = STATE(333),
    [sym_initializer_list] = STATE(333),
    [aux_sym_declaration_repeat1] = STATE(2565),
    [anon_sym_LPAREN] = ACTIONS(536),
    [anon_sym_COMMA] = ACTIONS(538),
    [anon_sym_SEMI] = ACTIONS(6079),
    [anon_sym_LBRACE] = ACTIONS(548),
    [anon_sym_LBRACK] = ACTIONS(208),
    [anon_sym_EQ] = ACTIONS(544),
    [sym_comment] = ACTIONS(49),
  },
  [2316] = {
    [aux_sym_declaration_repeat1] = STATE(2565),
    [anon_sym_COMMA] = ACTIONS(538),
    [anon_sym_SEMI] = ACTIONS(6079),
    [sym_comment] = ACTIONS(49),
  },
  [2317] = {
    [sym_argument_list] = STATE(2567),
    [sym_initializer_list] = STATE(2567),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_LBRACE] = ACTIONS(548),
    [anon_sym_EQ] = ACTIONS(6081),
    [sym_comment] = ACTIONS(49),
  },
  [2318] = {
    [sym_argument_list] = STATE(2569),
    [sym_initializer_list] = STATE(2569),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_LBRACE] = ACTIONS(548),
    [anon_sym_EQ] = ACTIONS(6083),
    [sym_comment] = ACTIONS(49),
  },
  [2319] = {
    [sym_raw_string_literal] = ACTIONS(3132),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3134),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3134),
    [anon_sym_LPAREN] = ACTIONS(3132),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3134),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3134),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3134),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3134),
    [sym_preproc_directive] = ACTIONS(3134),
    [anon_sym_SEMI] = ACTIONS(3132),
    [anon_sym_typedef] = ACTIONS(3134),
    [anon_sym_extern] = ACTIONS(3134),
    [anon_sym_LBRACE] = ACTIONS(3132),
    [anon_sym_STAR] = ACTIONS(3132),
    [anon_sym_LBRACK] = ACTIONS(3132),
    [anon_sym_static] = ACTIONS(3134),
    [anon_sym_register] = ACTIONS(3134),
    [anon_sym_inline] = ACTIONS(3134),
    [anon_sym_const] = ACTIONS(3134),
    [anon_sym_restrict] = ACTIONS(3134),
    [anon_sym_volatile] = ACTIONS(3134),
    [anon_sym__Atomic] = ACTIONS(3134),
    [anon_sym_mutable] = ACTIONS(3134),
    [anon_sym_explicit] = ACTIONS(3134),
    [anon_sym_constexpr] = ACTIONS(3134),
    [anon_sym_unsigned] = ACTIONS(3134),
    [anon_sym_long] = ACTIONS(3134),
    [anon_sym_short] = ACTIONS(3134),
    [sym_primitive_type] = ACTIONS(3134),
    [anon_sym_enum] = ACTIONS(3134),
    [anon_sym_struct] = ACTIONS(3134),
    [anon_sym_union] = ACTIONS(3134),
    [anon_sym_if] = ACTIONS(3134),
    [anon_sym_switch] = ACTIONS(3134),
    [anon_sym_case] = ACTIONS(3134),
    [anon_sym_default] = ACTIONS(3134),
    [anon_sym_while] = ACTIONS(3134),
    [anon_sym_do] = ACTIONS(3134),
    [anon_sym_for] = ACTIONS(3134),
    [anon_sym_return] = ACTIONS(3134),
    [anon_sym_break] = ACTIONS(3134),
    [anon_sym_continue] = ACTIONS(3134),
    [anon_sym_goto] = ACTIONS(3134),
    [anon_sym_AMP] = ACTIONS(3132),
    [anon_sym_BANG] = ACTIONS(3132),
    [anon_sym_TILDE] = ACTIONS(3132),
    [anon_sym_PLUS] = ACTIONS(3134),
    [anon_sym_DASH] = ACTIONS(3134),
    [anon_sym_DASH_DASH] = ACTIONS(3132),
    [anon_sym_PLUS_PLUS] = ACTIONS(3132),
    [anon_sym_sizeof] = ACTIONS(3134),
    [sym_number_literal] = ACTIONS(3132),
    [sym_char_literal] = ACTIONS(3132),
    [sym_string_literal] = ACTIONS(3132),
    [sym_true] = ACTIONS(3134),
    [sym_false] = ACTIONS(3134),
    [sym_null] = ACTIONS(3134),
    [sym_identifier] = ACTIONS(3134),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(3134),
    [sym_auto] = ACTIONS(3134),
    [anon_sym_typename] = ACTIONS(3134),
    [anon_sym_new] = ACTIONS(3134),
    [anon_sym_COLON_COLON] = ACTIONS(3132),
    [anon_sym_delete] = ACTIONS(3134),
    [sym_nullptr] = ACTIONS(3134),
  },
  [2320] = {
    [sym_preproc_include] = STATE(2320),
    [sym_preproc_def] = STATE(2320),
    [sym_preproc_function_def] = STATE(2320),
    [sym_preproc_call] = STATE(2320),
    [sym_preproc_if_in_compound_statement] = STATE(1944),
    [sym_preproc_ifdef_in_compound_statement] = STATE(1945),
    [sym_declaration] = STATE(2320),
    [sym_type_definition] = STATE(2320),
    [sym__declaration_specifiers] = STATE(1946),
    [sym_compound_statement] = STATE(2320),
    [sym_storage_class_specifier] = STATE(419),
    [sym_type_qualifier] = STATE(419),
    [sym__type_specifier] = STATE(30),
    [sym_sized_type_specifier] = STATE(30),
    [sym_enum_specifier] = STATE(30),
    [sym_struct_specifier] = STATE(30),
    [sym_union_specifier] = STATE(30),
    [sym_labeled_statement] = STATE(2320),
    [sym_expression_statement] = STATE(2320),
    [sym_if_statement] = STATE(2320),
    [sym_switch_statement] = STATE(2320),
    [sym_case_statement] = STATE(2320),
    [sym_while_statement] = STATE(2320),
    [sym_do_statement] = STATE(2320),
    [sym_for_statement] = STATE(2320),
    [sym_return_statement] = STATE(2320),
    [sym_break_statement] = STATE(2320),
    [sym_continue_statement] = STATE(2320),
    [sym_goto_statement] = STATE(2320),
    [sym__expression] = STATE(1947),
    [sym_comma_expression] = STATE(1948),
    [sym_conditional_expression] = STATE(1947),
    [sym_assignment_expression] = STATE(1947),
    [sym_pointer_expression] = STATE(1947),
    [sym_logical_expression] = STATE(1947),
    [sym_bitwise_expression] = STATE(1947),
    [sym_equality_expression] = STATE(1947),
    [sym_relational_expression] = STATE(1947),
    [sym_shift_expression] = STATE(1947),
    [sym_math_expression] = STATE(1947),
    [sym_cast_expression] = STATE(1947),
    [sym_sizeof_expression] = STATE(1947),
    [sym_subscript_expression] = STATE(1947),
    [sym_call_expression] = STATE(1947),
    [sym_field_expression] = STATE(1947),
    [sym_compound_literal_expression] = STATE(1947),
    [sym_parenthesized_expression] = STATE(1947),
    [sym_concatenated_string] = STATE(1947),
    [sym__empty_declaration] = STATE(2320),
    [sym_macro_type_specifier] = STATE(30),
    [sym_class_specifier] = STATE(30),
    [sym_dependent_type] = STATE(30),
    [sym_structured_binding_declaration] = STATE(2320),
    [sym_template_type] = STATE(415),
    [sym_template_function] = STATE(1947),
    [sym_for_range_loop] = STATE(2320),
    [sym_new_expression] = STATE(1947),
    [sym_delete_expression] = STATE(1947),
    [sym_lambda_expression] = STATE(1947),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(416),
    [sym_scoped_namespace_identifier] = STATE(417),
    [aux_sym_preproc_if_in_compound_statement_repeat1] = STATE(2320),
    [aux_sym__declaration_specifiers_repeat1] = STATE(419),
    [aux_sym_sized_type_specifier_repeat1] = STATE(38),
    [sym_raw_string_literal] = ACTIONS(6085),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(6088),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(6091),
    [anon_sym_LPAREN] = ACTIONS(3195),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(6094),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(5433),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(6097),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(6100),
    [sym_preproc_directive] = ACTIONS(6103),
    [anon_sym_SEMI] = ACTIONS(6106),
    [anon_sym_typedef] = ACTIONS(6109),
    [anon_sym_extern] = ACTIONS(3216),
    [anon_sym_LBRACE] = ACTIONS(6112),
    [anon_sym_STAR] = ACTIONS(3224),
    [anon_sym_LBRACK] = ACTIONS(3227),
    [anon_sym_static] = ACTIONS(3216),
    [anon_sym_register] = ACTIONS(3216),
    [anon_sym_inline] = ACTIONS(3216),
    [anon_sym_const] = ACTIONS(3230),
    [anon_sym_restrict] = ACTIONS(3230),
    [anon_sym_volatile] = ACTIONS(3230),
    [anon_sym__Atomic] = ACTIONS(3230),
    [anon_sym_mutable] = ACTIONS(3230),
    [anon_sym_explicit] = ACTIONS(3230),
    [anon_sym_constexpr] = ACTIONS(3230),
    [anon_sym_unsigned] = ACTIONS(3233),
    [anon_sym_long] = ACTIONS(3233),
    [anon_sym_short] = ACTIONS(3233),
    [sym_primitive_type] = ACTIONS(3236),
    [anon_sym_enum] = ACTIONS(3239),
    [anon_sym_struct] = ACTIONS(3242),
    [anon_sym_union] = ACTIONS(3245),
    [anon_sym_if] = ACTIONS(6115),
    [anon_sym_switch] = ACTIONS(6118),
    [anon_sym_case] = ACTIONS(6121),
    [anon_sym_default] = ACTIONS(6124),
    [anon_sym_while] = ACTIONS(6127),
    [anon_sym_do] = ACTIONS(6130),
    [anon_sym_for] = ACTIONS(6133),
    [anon_sym_return] = ACTIONS(6136),
    [anon_sym_break] = ACTIONS(6139),
    [anon_sym_continue] = ACTIONS(6142),
    [anon_sym_goto] = ACTIONS(6145),
    [anon_sym_AMP] = ACTIONS(3224),
    [anon_sym_BANG] = ACTIONS(3281),
    [anon_sym_TILDE] = ACTIONS(3284),
    [anon_sym_PLUS] = ACTIONS(3287),
    [anon_sym_DASH] = ACTIONS(3287),
    [anon_sym_DASH_DASH] = ACTIONS(3290),
    [anon_sym_PLUS_PLUS] = ACTIONS(3290),
    [anon_sym_sizeof] = ACTIONS(3293),
    [sym_number_literal] = ACTIONS(6085),
    [sym_char_literal] = ACTIONS(6085),
    [sym_string_literal] = ACTIONS(3296),
    [sym_true] = ACTIONS(6148),
    [sym_false] = ACTIONS(6148),
    [sym_null] = ACTIONS(6148),
    [sym_identifier] = ACTIONS(6151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(3305),
    [sym_auto] = ACTIONS(3236),
    [anon_sym_typename] = ACTIONS(3308),
    [anon_sym_new] = ACTIONS(3311),
    [anon_sym_COLON_COLON] = ACTIONS(3314),
    [anon_sym_delete] = ACTIONS(3317),
    [sym_nullptr] = ACTIONS(6148),
  },
  [2321] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(6154),
    [sym_comment] = ACTIONS(49),
  },
  [2322] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(6156),
    [sym_comment] = ACTIONS(49),
  },
  [2323] = {
    [sym_preproc_include] = STATE(1983),
    [sym_preproc_def] = STATE(1983),
    [sym_preproc_function_def] = STATE(1983),
    [sym_preproc_call] = STATE(1983),
    [sym_preproc_if_in_compound_statement] = STATE(1414),
    [sym_preproc_ifdef_in_compound_statement] = STATE(1415),
    [sym_preproc_else_in_compound_statement] = STATE(2570),
    [sym_preproc_elif_in_compound_statement] = STATE(2571),
    [sym_declaration] = STATE(1983),
    [sym_type_definition] = STATE(1983),
    [sym__declaration_specifiers] = STATE(1418),
    [sym_compound_statement] = STATE(1983),
    [sym_storage_class_specifier] = STATE(419),
    [sym_type_qualifier] = STATE(419),
    [sym__type_specifier] = STATE(30),
    [sym_sized_type_specifier] = STATE(30),
    [sym_enum_specifier] = STATE(30),
    [sym_struct_specifier] = STATE(30),
    [sym_union_specifier] = STATE(30),
    [sym_labeled_statement] = STATE(1983),
    [sym_expression_statement] = STATE(1983),
    [sym_if_statement] = STATE(1983),
    [sym_switch_statement] = STATE(1983),
    [sym_case_statement] = STATE(1983),
    [sym_while_statement] = STATE(1983),
    [sym_do_statement] = STATE(1983),
    [sym_for_statement] = STATE(1983),
    [sym_return_statement] = STATE(1983),
    [sym_break_statement] = STATE(1983),
    [sym_continue_statement] = STATE(1983),
    [sym_goto_statement] = STATE(1983),
    [sym__expression] = STATE(1419),
    [sym_comma_expression] = STATE(1420),
    [sym_conditional_expression] = STATE(1419),
    [sym_assignment_expression] = STATE(1419),
    [sym_pointer_expression] = STATE(1419),
    [sym_logical_expression] = STATE(1419),
    [sym_bitwise_expression] = STATE(1419),
    [sym_equality_expression] = STATE(1419),
    [sym_relational_expression] = STATE(1419),
    [sym_shift_expression] = STATE(1419),
    [sym_math_expression] = STATE(1419),
    [sym_cast_expression] = STATE(1419),
    [sym_sizeof_expression] = STATE(1419),
    [sym_subscript_expression] = STATE(1419),
    [sym_call_expression] = STATE(1419),
    [sym_field_expression] = STATE(1419),
    [sym_compound_literal_expression] = STATE(1419),
    [sym_parenthesized_expression] = STATE(1419),
    [sym_concatenated_string] = STATE(1419),
    [sym__empty_declaration] = STATE(1983),
    [sym_macro_type_specifier] = STATE(30),
    [sym_class_specifier] = STATE(30),
    [sym_dependent_type] = STATE(30),
    [sym_structured_binding_declaration] = STATE(1983),
    [sym_template_type] = STATE(415),
    [sym_template_function] = STATE(1419),
    [sym_for_range_loop] = STATE(1983),
    [sym_new_expression] = STATE(1419),
    [sym_delete_expression] = STATE(1419),
    [sym_lambda_expression] = STATE(1419),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(416),
    [sym_scoped_namespace_identifier] = STATE(417),
    [aux_sym_preproc_if_in_compound_statement_repeat1] = STATE(1983),
    [aux_sym__declaration_specifiers_repeat1] = STATE(419),
    [aux_sym_sized_type_specifier_repeat1] = STATE(38),
    [sym_raw_string_literal] = ACTIONS(2879),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(2881),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(2883),
    [anon_sym_LPAREN] = ACTIONS(626),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(2885),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(6158),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(2889),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(2891),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(2893),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(2895),
    [sym_preproc_directive] = ACTIONS(2897),
    [anon_sym_SEMI] = ACTIONS(2899),
    [anon_sym_typedef] = ACTIONS(2901),
    [anon_sym_extern] = ACTIONS(154),
    [anon_sym_LBRACE] = ACTIONS(2903),
    [anon_sym_STAR] = ACTIONS(644),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_static] = ACTIONS(154),
    [anon_sym_register] = ACTIONS(154),
    [anon_sym_inline] = ACTIONS(154),
    [anon_sym_const] = ACTIONS(158),
    [anon_sym_restrict] = ACTIONS(158),
    [anon_sym_volatile] = ACTIONS(158),
    [anon_sym__Atomic] = ACTIONS(158),
    [anon_sym_mutable] = ACTIONS(158),
    [anon_sym_explicit] = ACTIONS(158),
    [anon_sym_constexpr] = ACTIONS(158),
    [anon_sym_unsigned] = ACTIONS(31),
    [anon_sym_long] = ACTIONS(31),
    [anon_sym_short] = ACTIONS(31),
    [sym_primitive_type] = ACTIONS(33),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_union] = ACTIONS(39),
    [anon_sym_if] = ACTIONS(2905),
    [anon_sym_switch] = ACTIONS(2907),
    [anon_sym_case] = ACTIONS(2909),
    [anon_sym_default] = ACTIONS(2911),
    [anon_sym_while] = ACTIONS(2913),
    [anon_sym_do] = ACTIONS(2915),
    [anon_sym_for] = ACTIONS(2917),
    [anon_sym_return] = ACTIONS(2919),
    [anon_sym_break] = ACTIONS(2921),
    [anon_sym_continue] = ACTIONS(2923),
    [anon_sym_goto] = ACTIONS(2925),
    [anon_sym_AMP] = ACTIONS(644),
    [anon_sym_BANG] = ACTIONS(668),
    [anon_sym_TILDE] = ACTIONS(670),
    [anon_sym_PLUS] = ACTIONS(672),
    [anon_sym_DASH] = ACTIONS(672),
    [anon_sym_DASH_DASH] = ACTIONS(674),
    [anon_sym_PLUS_PLUS] = ACTIONS(674),
    [anon_sym_sizeof] = ACTIONS(676),
    [sym_number_literal] = ACTIONS(2879),
    [sym_char_literal] = ACTIONS(2879),
    [sym_string_literal] = ACTIONS(678),
    [sym_true] = ACTIONS(2927),
    [sym_false] = ACTIONS(2927),
    [sym_null] = ACTIONS(2927),
    [sym_identifier] = ACTIONS(2929),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(51),
    [sym_auto] = ACTIONS(33),
    [anon_sym_typename] = ACTIONS(53),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(684),
    [anon_sym_delete] = ACTIONS(686),
    [sym_nullptr] = ACTIONS(2927),
  },
  [2324] = {
    [anon_sym_LF] = ACTIONS(6160),
    [sym_comment] = ACTIONS(83),
  },
  [2325] = {
    [sym_parameter_list] = STATE(513),
    [anon_sym_LPAREN] = ACTIONS(206),
    [anon_sym_SEMI] = ACTIONS(6162),
    [anon_sym_LBRACK] = ACTIONS(955),
    [sym_comment] = ACTIONS(49),
  },
  [2326] = {
    [sym__type_declarator] = STATE(2574),
    [sym_pointer_type_declarator] = STATE(213),
    [sym_function_type_declarator] = STATE(214),
    [sym_array_type_declarator] = STATE(215),
    [anon_sym_LPAREN] = ACTIONS(327),
    [anon_sym_STAR] = ACTIONS(329),
    [sym_identifier] = ACTIONS(331),
    [sym_comment] = ACTIONS(49),
  },
  [2327] = {
    [sym_raw_string_literal] = ACTIONS(3182),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3184),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3184),
    [anon_sym_LPAREN] = ACTIONS(3182),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3184),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3184),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3184),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3184),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(3184),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(3184),
    [sym_preproc_directive] = ACTIONS(3184),
    [anon_sym_SEMI] = ACTIONS(3182),
    [anon_sym_typedef] = ACTIONS(3184),
    [anon_sym_extern] = ACTIONS(3184),
    [anon_sym_LBRACE] = ACTIONS(3182),
    [anon_sym_STAR] = ACTIONS(3182),
    [anon_sym_LBRACK] = ACTIONS(3182),
    [anon_sym_static] = ACTIONS(3184),
    [anon_sym_register] = ACTIONS(3184),
    [anon_sym_inline] = ACTIONS(3184),
    [anon_sym_const] = ACTIONS(3184),
    [anon_sym_restrict] = ACTIONS(3184),
    [anon_sym_volatile] = ACTIONS(3184),
    [anon_sym__Atomic] = ACTIONS(3184),
    [anon_sym_mutable] = ACTIONS(3184),
    [anon_sym_explicit] = ACTIONS(3184),
    [anon_sym_constexpr] = ACTIONS(3184),
    [anon_sym_unsigned] = ACTIONS(3184),
    [anon_sym_long] = ACTIONS(3184),
    [anon_sym_short] = ACTIONS(3184),
    [sym_primitive_type] = ACTIONS(3184),
    [anon_sym_enum] = ACTIONS(3184),
    [anon_sym_struct] = ACTIONS(3184),
    [anon_sym_union] = ACTIONS(3184),
    [anon_sym_if] = ACTIONS(3184),
    [anon_sym_switch] = ACTIONS(3184),
    [anon_sym_case] = ACTIONS(3184),
    [anon_sym_default] = ACTIONS(3184),
    [anon_sym_while] = ACTIONS(3184),
    [anon_sym_do] = ACTIONS(3184),
    [anon_sym_for] = ACTIONS(3184),
    [anon_sym_return] = ACTIONS(3184),
    [anon_sym_break] = ACTIONS(3184),
    [anon_sym_continue] = ACTIONS(3184),
    [anon_sym_goto] = ACTIONS(3184),
    [anon_sym_AMP] = ACTIONS(3182),
    [anon_sym_BANG] = ACTIONS(3182),
    [anon_sym_TILDE] = ACTIONS(3182),
    [anon_sym_PLUS] = ACTIONS(3184),
    [anon_sym_DASH] = ACTIONS(3184),
    [anon_sym_DASH_DASH] = ACTIONS(3182),
    [anon_sym_PLUS_PLUS] = ACTIONS(3182),
    [anon_sym_sizeof] = ACTIONS(3184),
    [sym_number_literal] = ACTIONS(3182),
    [sym_char_literal] = ACTIONS(3182),
    [sym_string_literal] = ACTIONS(3182),
    [sym_true] = ACTIONS(3184),
    [sym_false] = ACTIONS(3184),
    [sym_null] = ACTIONS(3184),
    [sym_identifier] = ACTIONS(3184),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(3184),
    [sym_auto] = ACTIONS(3184),
    [anon_sym_typename] = ACTIONS(3184),
    [anon_sym_new] = ACTIONS(3184),
    [anon_sym_COLON_COLON] = ACTIONS(3182),
    [anon_sym_delete] = ACTIONS(3184),
    [sym_nullptr] = ACTIONS(3184),
  },
  [2328] = {
    [sym_argument_list] = STATE(802),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_RPAREN] = ACTIONS(6164),
    [anon_sym_STAR] = ACTIONS(4537),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_EQ] = ACTIONS(4539),
    [anon_sym_QMARK] = ACTIONS(4541),
    [anon_sym_STAR_EQ] = ACTIONS(4543),
    [anon_sym_SLASH_EQ] = ACTIONS(4543),
    [anon_sym_PERCENT_EQ] = ACTIONS(4543),
    [anon_sym_PLUS_EQ] = ACTIONS(4543),
    [anon_sym_DASH_EQ] = ACTIONS(4543),
    [anon_sym_LT_LT_EQ] = ACTIONS(4543),
    [anon_sym_GT_GT_EQ] = ACTIONS(4543),
    [anon_sym_AMP_EQ] = ACTIONS(4543),
    [anon_sym_CARET_EQ] = ACTIONS(4543),
    [anon_sym_PIPE_EQ] = ACTIONS(4543),
    [anon_sym_AMP] = ACTIONS(4545),
    [anon_sym_PIPE_PIPE] = ACTIONS(4547),
    [anon_sym_AMP_AMP] = ACTIONS(4549),
    [anon_sym_PIPE] = ACTIONS(4551),
    [anon_sym_CARET] = ACTIONS(4553),
    [anon_sym_EQ_EQ] = ACTIONS(4555),
    [anon_sym_BANG_EQ] = ACTIONS(4555),
    [anon_sym_LT] = ACTIONS(4557),
    [anon_sym_GT] = ACTIONS(4557),
    [anon_sym_LT_EQ] = ACTIONS(4559),
    [anon_sym_GT_EQ] = ACTIONS(4559),
    [anon_sym_LT_LT] = ACTIONS(4561),
    [anon_sym_GT_GT] = ACTIONS(4561),
    [anon_sym_PLUS] = ACTIONS(4563),
    [anon_sym_DASH] = ACTIONS(4563),
    [anon_sym_SLASH] = ACTIONS(4537),
    [anon_sym_PERCENT] = ACTIONS(4537),
    [anon_sym_DASH_DASH] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(1554),
    [anon_sym_DASH_GT] = ACTIONS(1554),
    [sym_comment] = ACTIONS(49),
  },
  [2329] = {
    [sym__expression] = STATE(2576),
    [sym_conditional_expression] = STATE(2576),
    [sym_assignment_expression] = STATE(2576),
    [sym_pointer_expression] = STATE(2576),
    [sym_logical_expression] = STATE(2576),
    [sym_bitwise_expression] = STATE(2576),
    [sym_equality_expression] = STATE(2576),
    [sym_relational_expression] = STATE(2576),
    [sym_shift_expression] = STATE(2576),
    [sym_math_expression] = STATE(2576),
    [sym_cast_expression] = STATE(2576),
    [sym_sizeof_expression] = STATE(2576),
    [sym_subscript_expression] = STATE(2576),
    [sym_call_expression] = STATE(2576),
    [sym_field_expression] = STATE(2576),
    [sym_compound_literal_expression] = STATE(2576),
    [sym_parenthesized_expression] = STATE(2576),
    [sym_concatenated_string] = STATE(2576),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(2576),
    [sym_new_expression] = STATE(2576),
    [sym_delete_expression] = STATE(2576),
    [sym_lambda_expression] = STATE(2576),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(6166),
    [anon_sym_LPAREN] = ACTIONS(2943),
    [anon_sym_STAR] = ACTIONS(2945),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_AMP] = ACTIONS(2945),
    [anon_sym_BANG] = ACTIONS(2947),
    [anon_sym_TILDE] = ACTIONS(2949),
    [anon_sym_PLUS] = ACTIONS(2951),
    [anon_sym_DASH] = ACTIONS(2951),
    [anon_sym_DASH_DASH] = ACTIONS(2953),
    [anon_sym_PLUS_PLUS] = ACTIONS(2953),
    [anon_sym_sizeof] = ACTIONS(2955),
    [sym_number_literal] = ACTIONS(6166),
    [sym_char_literal] = ACTIONS(6166),
    [sym_string_literal] = ACTIONS(2957),
    [sym_true] = ACTIONS(6168),
    [sym_false] = ACTIONS(6168),
    [sym_null] = ACTIONS(6168),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(2961),
    [anon_sym_delete] = ACTIONS(2963),
    [sym_nullptr] = ACTIONS(6168),
  },
  [2330] = {
    [sym_argument_list] = STATE(802),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_RPAREN] = ACTIONS(6170),
    [anon_sym_STAR] = ACTIONS(4537),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_EQ] = ACTIONS(4539),
    [anon_sym_QMARK] = ACTIONS(4541),
    [anon_sym_STAR_EQ] = ACTIONS(4543),
    [anon_sym_SLASH_EQ] = ACTIONS(4543),
    [anon_sym_PERCENT_EQ] = ACTIONS(4543),
    [anon_sym_PLUS_EQ] = ACTIONS(4543),
    [anon_sym_DASH_EQ] = ACTIONS(4543),
    [anon_sym_LT_LT_EQ] = ACTIONS(4543),
    [anon_sym_GT_GT_EQ] = ACTIONS(4543),
    [anon_sym_AMP_EQ] = ACTIONS(4543),
    [anon_sym_CARET_EQ] = ACTIONS(4543),
    [anon_sym_PIPE_EQ] = ACTIONS(4543),
    [anon_sym_AMP] = ACTIONS(4545),
    [anon_sym_PIPE_PIPE] = ACTIONS(4547),
    [anon_sym_AMP_AMP] = ACTIONS(4549),
    [anon_sym_PIPE] = ACTIONS(4551),
    [anon_sym_CARET] = ACTIONS(4553),
    [anon_sym_EQ_EQ] = ACTIONS(4555),
    [anon_sym_BANG_EQ] = ACTIONS(4555),
    [anon_sym_LT] = ACTIONS(4557),
    [anon_sym_GT] = ACTIONS(4557),
    [anon_sym_LT_EQ] = ACTIONS(4559),
    [anon_sym_GT_EQ] = ACTIONS(4559),
    [anon_sym_LT_LT] = ACTIONS(4561),
    [anon_sym_GT_GT] = ACTIONS(4561),
    [anon_sym_PLUS] = ACTIONS(4563),
    [anon_sym_DASH] = ACTIONS(4563),
    [anon_sym_SLASH] = ACTIONS(4537),
    [anon_sym_PERCENT] = ACTIONS(4537),
    [anon_sym_DASH_DASH] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(1554),
    [anon_sym_DASH_GT] = ACTIONS(1554),
    [sym_comment] = ACTIONS(49),
  },
  [2331] = {
    [sym_declaration] = STATE(2578),
    [sym_type_definition] = STATE(2578),
    [sym__declaration_specifiers] = STATE(2334),
    [sym_compound_statement] = STATE(2578),
    [sym_storage_class_specifier] = STATE(109),
    [sym_type_qualifier] = STATE(109),
    [sym__type_specifier] = STATE(105),
    [sym_sized_type_specifier] = STATE(105),
    [sym_enum_specifier] = STATE(105),
    [sym_struct_specifier] = STATE(105),
    [sym_union_specifier] = STATE(105),
    [sym_labeled_statement] = STATE(2578),
    [sym_expression_statement] = STATE(2578),
    [sym_if_statement] = STATE(2578),
    [sym_switch_statement] = STATE(2578),
    [sym_case_statement] = STATE(2578),
    [sym_while_statement] = STATE(2578),
    [sym_do_statement] = STATE(2578),
    [sym_for_statement] = STATE(2578),
    [sym_return_statement] = STATE(2578),
    [sym_break_statement] = STATE(2578),
    [sym_continue_statement] = STATE(2578),
    [sym_goto_statement] = STATE(2578),
    [sym__expression] = STATE(1419),
    [sym_comma_expression] = STATE(1420),
    [sym_conditional_expression] = STATE(1419),
    [sym_assignment_expression] = STATE(1419),
    [sym_pointer_expression] = STATE(1419),
    [sym_logical_expression] = STATE(1419),
    [sym_bitwise_expression] = STATE(1419),
    [sym_equality_expression] = STATE(1419),
    [sym_relational_expression] = STATE(1419),
    [sym_shift_expression] = STATE(1419),
    [sym_math_expression] = STATE(1419),
    [sym_cast_expression] = STATE(1419),
    [sym_sizeof_expression] = STATE(1419),
    [sym_subscript_expression] = STATE(1419),
    [sym_call_expression] = STATE(1419),
    [sym_field_expression] = STATE(1419),
    [sym_compound_literal_expression] = STATE(1419),
    [sym_parenthesized_expression] = STATE(1419),
    [sym_concatenated_string] = STATE(1419),
    [sym_macro_type_specifier] = STATE(105),
    [sym_class_specifier] = STATE(105),
    [sym_dependent_type] = STATE(105),
    [sym_template_type] = STATE(1475),
    [sym_template_function] = STATE(1419),
    [sym_for_range_loop] = STATE(2578),
    [sym_new_expression] = STATE(1419),
    [sym_delete_expression] = STATE(1419),
    [sym_lambda_expression] = STATE(1419),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(416),
    [sym_scoped_namespace_identifier] = STATE(1476),
    [aux_sym__declaration_specifiers_repeat1] = STATE(109),
    [aux_sym_sized_type_specifier_repeat1] = STATE(110),
    [sym_raw_string_literal] = ACTIONS(2879),
    [anon_sym_LPAREN] = ACTIONS(626),
    [anon_sym_SEMI] = ACTIONS(2899),
    [anon_sym_typedef] = ACTIONS(2901),
    [anon_sym_extern] = ACTIONS(154),
    [anon_sym_LBRACE] = ACTIONS(2903),
    [anon_sym_STAR] = ACTIONS(644),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_static] = ACTIONS(154),
    [anon_sym_register] = ACTIONS(154),
    [anon_sym_inline] = ACTIONS(154),
    [anon_sym_const] = ACTIONS(158),
    [anon_sym_restrict] = ACTIONS(158),
    [anon_sym_volatile] = ACTIONS(158),
    [anon_sym__Atomic] = ACTIONS(158),
    [anon_sym_mutable] = ACTIONS(158),
    [anon_sym_explicit] = ACTIONS(158),
    [anon_sym_constexpr] = ACTIONS(158),
    [anon_sym_unsigned] = ACTIONS(160),
    [anon_sym_long] = ACTIONS(160),
    [anon_sym_short] = ACTIONS(160),
    [sym_primitive_type] = ACTIONS(162),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_union] = ACTIONS(39),
    [anon_sym_if] = ACTIONS(2905),
    [anon_sym_switch] = ACTIONS(2907),
    [anon_sym_case] = ACTIONS(2909),
    [anon_sym_default] = ACTIONS(2911),
    [anon_sym_while] = ACTIONS(2913),
    [anon_sym_do] = ACTIONS(2915),
    [anon_sym_for] = ACTIONS(2917),
    [anon_sym_return] = ACTIONS(2919),
    [anon_sym_break] = ACTIONS(2921),
    [anon_sym_continue] = ACTIONS(2923),
    [anon_sym_goto] = ACTIONS(2925),
    [anon_sym_AMP] = ACTIONS(644),
    [anon_sym_BANG] = ACTIONS(668),
    [anon_sym_TILDE] = ACTIONS(670),
    [anon_sym_PLUS] = ACTIONS(672),
    [anon_sym_DASH] = ACTIONS(672),
    [anon_sym_DASH_DASH] = ACTIONS(674),
    [anon_sym_PLUS_PLUS] = ACTIONS(674),
    [anon_sym_sizeof] = ACTIONS(676),
    [sym_number_literal] = ACTIONS(2879),
    [sym_char_literal] = ACTIONS(2879),
    [sym_string_literal] = ACTIONS(678),
    [sym_true] = ACTIONS(2927),
    [sym_false] = ACTIONS(2927),
    [sym_null] = ACTIONS(2927),
    [sym_identifier] = ACTIONS(5379),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(51),
    [sym_auto] = ACTIONS(162),
    [anon_sym_typename] = ACTIONS(172),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(3040),
    [anon_sym_delete] = ACTIONS(686),
    [sym_nullptr] = ACTIONS(2927),
  },
  [2332] = {
    [sym_initializer_list] = STATE(765),
    [sym_template_argument_list] = STATE(2039),
    [anon_sym_LPAREN] = ACTIONS(1483),
    [anon_sym_COMMA] = ACTIONS(1477),
    [anon_sym_SEMI] = ACTIONS(1477),
    [anon_sym_extern] = ACTIONS(144),
    [anon_sym_LBRACE] = ACTIONS(548),
    [anon_sym_STAR] = ACTIONS(1486),
    [anon_sym_LBRACK] = ACTIONS(1477),
    [anon_sym_EQ] = ACTIONS(1479),
    [anon_sym_static] = ACTIONS(144),
    [anon_sym_register] = ACTIONS(144),
    [anon_sym_inline] = ACTIONS(144),
    [anon_sym_const] = ACTIONS(144),
    [anon_sym_restrict] = ACTIONS(144),
    [anon_sym_volatile] = ACTIONS(144),
    [anon_sym__Atomic] = ACTIONS(144),
    [anon_sym_mutable] = ACTIONS(144),
    [anon_sym_explicit] = ACTIONS(144),
    [anon_sym_constexpr] = ACTIONS(144),
    [anon_sym_COLON] = ACTIONS(4481),
    [anon_sym_QMARK] = ACTIONS(1477),
    [anon_sym_STAR_EQ] = ACTIONS(1477),
    [anon_sym_SLASH_EQ] = ACTIONS(1477),
    [anon_sym_PERCENT_EQ] = ACTIONS(1477),
    [anon_sym_PLUS_EQ] = ACTIONS(1477),
    [anon_sym_DASH_EQ] = ACTIONS(1477),
    [anon_sym_LT_LT_EQ] = ACTIONS(1477),
    [anon_sym_GT_GT_EQ] = ACTIONS(1477),
    [anon_sym_AMP_EQ] = ACTIONS(1477),
    [anon_sym_CARET_EQ] = ACTIONS(1477),
    [anon_sym_PIPE_EQ] = ACTIONS(1477),
    [anon_sym_AMP] = ACTIONS(1486),
    [anon_sym_PIPE_PIPE] = ACTIONS(1477),
    [anon_sym_AMP_AMP] = ACTIONS(1483),
    [anon_sym_PIPE] = ACTIONS(1479),
    [anon_sym_CARET] = ACTIONS(1479),
    [anon_sym_TILDE] = ACTIONS(142),
    [anon_sym_EQ_EQ] = ACTIONS(1477),
    [anon_sym_BANG_EQ] = ACTIONS(1477),
    [anon_sym_LT] = ACTIONS(1564),
    [anon_sym_GT] = ACTIONS(1479),
    [anon_sym_LT_EQ] = ACTIONS(1477),
    [anon_sym_GT_EQ] = ACTIONS(1477),
    [anon_sym_LT_LT] = ACTIONS(1479),
    [anon_sym_GT_GT] = ACTIONS(1479),
    [anon_sym_PLUS] = ACTIONS(1479),
    [anon_sym_DASH] = ACTIONS(1479),
    [anon_sym_SLASH] = ACTIONS(1479),
    [anon_sym_PERCENT] = ACTIONS(1479),
    [anon_sym_DASH_DASH] = ACTIONS(1477),
    [anon_sym_PLUS_PLUS] = ACTIONS(1477),
    [anon_sym_DOT] = ACTIONS(1477),
    [anon_sym_DASH_GT] = ACTIONS(1477),
    [sym_identifier] = ACTIONS(144),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(4631),
    [sym_operator_name] = ACTIONS(142),
  },
  [2333] = {
    [sym_raw_string_literal] = ACTIONS(4635),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(4637),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(4637),
    [anon_sym_LPAREN] = ACTIONS(4635),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(4637),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(4637),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(4637),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(4637),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(4637),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(4637),
    [sym_preproc_directive] = ACTIONS(4637),
    [anon_sym_SEMI] = ACTIONS(4635),
    [anon_sym_typedef] = ACTIONS(4637),
    [anon_sym_extern] = ACTIONS(4637),
    [anon_sym_LBRACE] = ACTIONS(4635),
    [anon_sym_STAR] = ACTIONS(4635),
    [anon_sym_LBRACK] = ACTIONS(4635),
    [anon_sym_static] = ACTIONS(4637),
    [anon_sym_register] = ACTIONS(4637),
    [anon_sym_inline] = ACTIONS(4637),
    [anon_sym_const] = ACTIONS(4637),
    [anon_sym_restrict] = ACTIONS(4637),
    [anon_sym_volatile] = ACTIONS(4637),
    [anon_sym__Atomic] = ACTIONS(4637),
    [anon_sym_mutable] = ACTIONS(4637),
    [anon_sym_explicit] = ACTIONS(4637),
    [anon_sym_constexpr] = ACTIONS(4637),
    [anon_sym_unsigned] = ACTIONS(4637),
    [anon_sym_long] = ACTIONS(4637),
    [anon_sym_short] = ACTIONS(4637),
    [sym_primitive_type] = ACTIONS(4637),
    [anon_sym_enum] = ACTIONS(4637),
    [anon_sym_struct] = ACTIONS(4637),
    [anon_sym_union] = ACTIONS(4637),
    [anon_sym_if] = ACTIONS(4637),
    [anon_sym_switch] = ACTIONS(4637),
    [anon_sym_case] = ACTIONS(4637),
    [anon_sym_default] = ACTIONS(4637),
    [anon_sym_while] = ACTIONS(4637),
    [anon_sym_do] = ACTIONS(4637),
    [anon_sym_for] = ACTIONS(4637),
    [anon_sym_return] = ACTIONS(4637),
    [anon_sym_break] = ACTIONS(4637),
    [anon_sym_continue] = ACTIONS(4637),
    [anon_sym_goto] = ACTIONS(4637),
    [anon_sym_AMP] = ACTIONS(4635),
    [anon_sym_BANG] = ACTIONS(4635),
    [anon_sym_TILDE] = ACTIONS(4635),
    [anon_sym_PLUS] = ACTIONS(4637),
    [anon_sym_DASH] = ACTIONS(4637),
    [anon_sym_DASH_DASH] = ACTIONS(4635),
    [anon_sym_PLUS_PLUS] = ACTIONS(4635),
    [anon_sym_sizeof] = ACTIONS(4637),
    [sym_number_literal] = ACTIONS(4635),
    [sym_char_literal] = ACTIONS(4635),
    [sym_string_literal] = ACTIONS(4635),
    [sym_true] = ACTIONS(4637),
    [sym_false] = ACTIONS(4637),
    [sym_null] = ACTIONS(4637),
    [sym_identifier] = ACTIONS(4637),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(4637),
    [sym_auto] = ACTIONS(4637),
    [anon_sym_typename] = ACTIONS(4637),
    [anon_sym_new] = ACTIONS(4637),
    [anon_sym_COLON_COLON] = ACTIONS(4635),
    [anon_sym_delete] = ACTIONS(4637),
    [sym_nullptr] = ACTIONS(4637),
  },
  [2334] = {
    [sym__declarator] = STATE(1975),
    [sym_pointer_declarator] = STATE(1975),
    [sym_function_declarator] = STATE(1975),
    [sym_array_declarator] = STATE(1975),
    [sym_init_declarator] = STATE(1976),
    [sym_reference_declarator] = STATE(1975),
    [sym_template_type] = STATE(46),
    [sym_template_function] = STATE(1975),
    [sym_destructor_name] = STATE(1975),
    [sym_scoped_identifier] = STATE(33),
    [sym_scoped_type_identifier] = STATE(47),
    [sym_scoped_namespace_identifier] = STATE(46),
    [anon_sym_LPAREN] = ACTIONS(11),
    [anon_sym_STAR] = ACTIONS(196),
    [anon_sym_AMP] = ACTIONS(526),
    [anon_sym_AMP_AMP] = ACTIONS(528),
    [anon_sym_TILDE] = ACTIONS(45),
    [sym_identifier] = ACTIONS(75),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(77),
    [sym_operator_name] = ACTIONS(4489),
  },
  [2335] = {
    [sym_argument_list] = STATE(802),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_RPAREN] = ACTIONS(6172),
    [anon_sym_STAR] = ACTIONS(4537),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_EQ] = ACTIONS(4539),
    [anon_sym_QMARK] = ACTIONS(4541),
    [anon_sym_STAR_EQ] = ACTIONS(4543),
    [anon_sym_SLASH_EQ] = ACTIONS(4543),
    [anon_sym_PERCENT_EQ] = ACTIONS(4543),
    [anon_sym_PLUS_EQ] = ACTIONS(4543),
    [anon_sym_DASH_EQ] = ACTIONS(4543),
    [anon_sym_LT_LT_EQ] = ACTIONS(4543),
    [anon_sym_GT_GT_EQ] = ACTIONS(4543),
    [anon_sym_AMP_EQ] = ACTIONS(4543),
    [anon_sym_CARET_EQ] = ACTIONS(4543),
    [anon_sym_PIPE_EQ] = ACTIONS(4543),
    [anon_sym_AMP] = ACTIONS(4545),
    [anon_sym_PIPE_PIPE] = ACTIONS(4547),
    [anon_sym_AMP_AMP] = ACTIONS(4549),
    [anon_sym_PIPE] = ACTIONS(4551),
    [anon_sym_CARET] = ACTIONS(4553),
    [anon_sym_EQ_EQ] = ACTIONS(4555),
    [anon_sym_BANG_EQ] = ACTIONS(4555),
    [anon_sym_LT] = ACTIONS(4557),
    [anon_sym_GT] = ACTIONS(4557),
    [anon_sym_LT_EQ] = ACTIONS(4559),
    [anon_sym_GT_EQ] = ACTIONS(4559),
    [anon_sym_LT_LT] = ACTIONS(4561),
    [anon_sym_GT_GT] = ACTIONS(4561),
    [anon_sym_PLUS] = ACTIONS(4563),
    [anon_sym_DASH] = ACTIONS(4563),
    [anon_sym_SLASH] = ACTIONS(4537),
    [anon_sym_PERCENT] = ACTIONS(4537),
    [anon_sym_DASH_DASH] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(1554),
    [anon_sym_DASH_GT] = ACTIONS(1554),
    [sym_comment] = ACTIONS(49),
  },
  [2336] = {
    [anon_sym_LPAREN] = ACTIONS(6174),
    [sym_comment] = ACTIONS(49),
  },
  [2337] = {
    [sym__expression] = STATE(2582),
    [sym_conditional_expression] = STATE(2582),
    [sym_assignment_expression] = STATE(2582),
    [sym_pointer_expression] = STATE(2582),
    [sym_logical_expression] = STATE(2582),
    [sym_bitwise_expression] = STATE(2582),
    [sym_equality_expression] = STATE(2582),
    [sym_relational_expression] = STATE(2582),
    [sym_shift_expression] = STATE(2582),
    [sym_math_expression] = STATE(2582),
    [sym_cast_expression] = STATE(2582),
    [sym_sizeof_expression] = STATE(2582),
    [sym_subscript_expression] = STATE(2582),
    [sym_call_expression] = STATE(2582),
    [sym_field_expression] = STATE(2582),
    [sym_compound_literal_expression] = STATE(2582),
    [sym_parenthesized_expression] = STATE(2582),
    [sym_concatenated_string] = STATE(2582),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(2582),
    [sym_new_expression] = STATE(2582),
    [sym_delete_expression] = STATE(2582),
    [sym_lambda_expression] = STATE(2582),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(6176),
    [anon_sym_LPAREN] = ACTIONS(1347),
    [anon_sym_SEMI] = ACTIONS(6178),
    [anon_sym_STAR] = ACTIONS(1349),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_AMP] = ACTIONS(1349),
    [anon_sym_BANG] = ACTIONS(1351),
    [anon_sym_TILDE] = ACTIONS(1353),
    [anon_sym_PLUS] = ACTIONS(1355),
    [anon_sym_DASH] = ACTIONS(1355),
    [anon_sym_DASH_DASH] = ACTIONS(1357),
    [anon_sym_PLUS_PLUS] = ACTIONS(1357),
    [anon_sym_sizeof] = ACTIONS(1359),
    [sym_number_literal] = ACTIONS(6176),
    [sym_char_literal] = ACTIONS(6176),
    [sym_string_literal] = ACTIONS(1361),
    [sym_true] = ACTIONS(6180),
    [sym_false] = ACTIONS(6180),
    [sym_null] = ACTIONS(6180),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1365),
    [anon_sym_delete] = ACTIONS(1367),
    [sym_nullptr] = ACTIONS(6180),
  },
  [2338] = {
    [sym_argument_list] = STATE(802),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_SEMI] = ACTIONS(6182),
    [anon_sym_STAR] = ACTIONS(2553),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_EQ] = ACTIONS(2555),
    [anon_sym_QMARK] = ACTIONS(2557),
    [anon_sym_STAR_EQ] = ACTIONS(2559),
    [anon_sym_SLASH_EQ] = ACTIONS(2559),
    [anon_sym_PERCENT_EQ] = ACTIONS(2559),
    [anon_sym_PLUS_EQ] = ACTIONS(2559),
    [anon_sym_DASH_EQ] = ACTIONS(2559),
    [anon_sym_LT_LT_EQ] = ACTIONS(2559),
    [anon_sym_GT_GT_EQ] = ACTIONS(2559),
    [anon_sym_AMP_EQ] = ACTIONS(2559),
    [anon_sym_CARET_EQ] = ACTIONS(2559),
    [anon_sym_PIPE_EQ] = ACTIONS(2559),
    [anon_sym_AMP] = ACTIONS(2561),
    [anon_sym_PIPE_PIPE] = ACTIONS(2563),
    [anon_sym_AMP_AMP] = ACTIONS(2565),
    [anon_sym_PIPE] = ACTIONS(2567),
    [anon_sym_CARET] = ACTIONS(2569),
    [anon_sym_EQ_EQ] = ACTIONS(2571),
    [anon_sym_BANG_EQ] = ACTIONS(2571),
    [anon_sym_LT] = ACTIONS(2573),
    [anon_sym_GT] = ACTIONS(2573),
    [anon_sym_LT_EQ] = ACTIONS(2575),
    [anon_sym_GT_EQ] = ACTIONS(2575),
    [anon_sym_LT_LT] = ACTIONS(2577),
    [anon_sym_GT_GT] = ACTIONS(2577),
    [anon_sym_PLUS] = ACTIONS(2579),
    [anon_sym_DASH] = ACTIONS(2579),
    [anon_sym_SLASH] = ACTIONS(2553),
    [anon_sym_PERCENT] = ACTIONS(2553),
    [anon_sym_DASH_DASH] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(1554),
    [anon_sym_DASH_GT] = ACTIONS(1554),
    [sym_comment] = ACTIONS(49),
  },
  [2339] = {
    [anon_sym_COLON] = ACTIONS(6184),
    [sym_comment] = ACTIONS(49),
  },
  [2340] = {
    [sym_raw_string_literal] = ACTIONS(4697),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(4699),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(4699),
    [anon_sym_LPAREN] = ACTIONS(4697),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(4699),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(4699),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(4699),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(4699),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(4699),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(4699),
    [sym_preproc_directive] = ACTIONS(4699),
    [anon_sym_SEMI] = ACTIONS(4697),
    [anon_sym_typedef] = ACTIONS(4699),
    [anon_sym_extern] = ACTIONS(4699),
    [anon_sym_LBRACE] = ACTIONS(4697),
    [anon_sym_STAR] = ACTIONS(4697),
    [anon_sym_LBRACK] = ACTIONS(4697),
    [anon_sym_static] = ACTIONS(4699),
    [anon_sym_register] = ACTIONS(4699),
    [anon_sym_inline] = ACTIONS(4699),
    [anon_sym_const] = ACTIONS(4699),
    [anon_sym_restrict] = ACTIONS(4699),
    [anon_sym_volatile] = ACTIONS(4699),
    [anon_sym__Atomic] = ACTIONS(4699),
    [anon_sym_mutable] = ACTIONS(4699),
    [anon_sym_explicit] = ACTIONS(4699),
    [anon_sym_constexpr] = ACTIONS(4699),
    [anon_sym_unsigned] = ACTIONS(4699),
    [anon_sym_long] = ACTIONS(4699),
    [anon_sym_short] = ACTIONS(4699),
    [sym_primitive_type] = ACTIONS(4699),
    [anon_sym_enum] = ACTIONS(4699),
    [anon_sym_struct] = ACTIONS(4699),
    [anon_sym_union] = ACTIONS(4699),
    [anon_sym_if] = ACTIONS(4699),
    [anon_sym_switch] = ACTIONS(4699),
    [anon_sym_case] = ACTIONS(4699),
    [anon_sym_default] = ACTIONS(4699),
    [anon_sym_while] = ACTIONS(4699),
    [anon_sym_do] = ACTIONS(4699),
    [anon_sym_for] = ACTIONS(4699),
    [anon_sym_return] = ACTIONS(4699),
    [anon_sym_break] = ACTIONS(4699),
    [anon_sym_continue] = ACTIONS(4699),
    [anon_sym_goto] = ACTIONS(4699),
    [anon_sym_AMP] = ACTIONS(4697),
    [anon_sym_BANG] = ACTIONS(4697),
    [anon_sym_TILDE] = ACTIONS(4697),
    [anon_sym_PLUS] = ACTIONS(4699),
    [anon_sym_DASH] = ACTIONS(4699),
    [anon_sym_DASH_DASH] = ACTIONS(4697),
    [anon_sym_PLUS_PLUS] = ACTIONS(4697),
    [anon_sym_sizeof] = ACTIONS(4699),
    [sym_number_literal] = ACTIONS(4697),
    [sym_char_literal] = ACTIONS(4697),
    [sym_string_literal] = ACTIONS(4697),
    [sym_true] = ACTIONS(4699),
    [sym_false] = ACTIONS(4699),
    [sym_null] = ACTIONS(4699),
    [sym_identifier] = ACTIONS(4699),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(4699),
    [sym_auto] = ACTIONS(4699),
    [anon_sym_typename] = ACTIONS(4699),
    [anon_sym_new] = ACTIONS(4699),
    [anon_sym_COLON_COLON] = ACTIONS(4697),
    [anon_sym_delete] = ACTIONS(4699),
    [sym_nullptr] = ACTIONS(4699),
  },
  [2341] = {
    [sym_raw_string_literal] = ACTIONS(4701),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(4703),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(4703),
    [anon_sym_LPAREN] = ACTIONS(4701),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(4703),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(4703),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(4703),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(4703),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(4703),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(4703),
    [sym_preproc_directive] = ACTIONS(4703),
    [anon_sym_SEMI] = ACTIONS(4701),
    [anon_sym_typedef] = ACTIONS(4703),
    [anon_sym_extern] = ACTIONS(4703),
    [anon_sym_LBRACE] = ACTIONS(4701),
    [anon_sym_STAR] = ACTIONS(4701),
    [anon_sym_LBRACK] = ACTIONS(4701),
    [anon_sym_static] = ACTIONS(4703),
    [anon_sym_register] = ACTIONS(4703),
    [anon_sym_inline] = ACTIONS(4703),
    [anon_sym_const] = ACTIONS(4703),
    [anon_sym_restrict] = ACTIONS(4703),
    [anon_sym_volatile] = ACTIONS(4703),
    [anon_sym__Atomic] = ACTIONS(4703),
    [anon_sym_mutable] = ACTIONS(4703),
    [anon_sym_explicit] = ACTIONS(4703),
    [anon_sym_constexpr] = ACTIONS(4703),
    [anon_sym_unsigned] = ACTIONS(4703),
    [anon_sym_long] = ACTIONS(4703),
    [anon_sym_short] = ACTIONS(4703),
    [sym_primitive_type] = ACTIONS(4703),
    [anon_sym_enum] = ACTIONS(4703),
    [anon_sym_struct] = ACTIONS(4703),
    [anon_sym_union] = ACTIONS(4703),
    [anon_sym_if] = ACTIONS(4703),
    [anon_sym_switch] = ACTIONS(4703),
    [anon_sym_case] = ACTIONS(4703),
    [anon_sym_default] = ACTIONS(4703),
    [anon_sym_while] = ACTIONS(4703),
    [anon_sym_do] = ACTIONS(4703),
    [anon_sym_for] = ACTIONS(4703),
    [anon_sym_return] = ACTIONS(4703),
    [anon_sym_break] = ACTIONS(4703),
    [anon_sym_continue] = ACTIONS(4703),
    [anon_sym_goto] = ACTIONS(4703),
    [anon_sym_AMP] = ACTIONS(4701),
    [anon_sym_BANG] = ACTIONS(4701),
    [anon_sym_TILDE] = ACTIONS(4701),
    [anon_sym_PLUS] = ACTIONS(4703),
    [anon_sym_DASH] = ACTIONS(4703),
    [anon_sym_DASH_DASH] = ACTIONS(4701),
    [anon_sym_PLUS_PLUS] = ACTIONS(4701),
    [anon_sym_sizeof] = ACTIONS(4703),
    [sym_number_literal] = ACTIONS(4701),
    [sym_char_literal] = ACTIONS(4701),
    [sym_string_literal] = ACTIONS(4701),
    [sym_true] = ACTIONS(4703),
    [sym_false] = ACTIONS(4703),
    [sym_null] = ACTIONS(4703),
    [sym_identifier] = ACTIONS(4703),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(4703),
    [sym_auto] = ACTIONS(4703),
    [anon_sym_typename] = ACTIONS(4703),
    [anon_sym_new] = ACTIONS(4703),
    [anon_sym_COLON_COLON] = ACTIONS(4701),
    [anon_sym_delete] = ACTIONS(4703),
    [sym_nullptr] = ACTIONS(4703),
  },
  [2342] = {
    [sym_initializer_list] = STATE(765),
    [sym_template_argument_list] = STATE(1097),
    [anon_sym_LPAREN] = ACTIONS(1477),
    [anon_sym_COMMA] = ACTIONS(1477),
    [anon_sym_SEMI] = ACTIONS(1477),
    [anon_sym_LBRACE] = ACTIONS(548),
    [anon_sym_STAR] = ACTIONS(1479),
    [anon_sym_LBRACK] = ACTIONS(1477),
    [anon_sym_EQ] = ACTIONS(1479),
    [anon_sym_COLON] = ACTIONS(4481),
    [anon_sym_QMARK] = ACTIONS(1477),
    [anon_sym_STAR_EQ] = ACTIONS(1477),
    [anon_sym_SLASH_EQ] = ACTIONS(1477),
    [anon_sym_PERCENT_EQ] = ACTIONS(1477),
    [anon_sym_PLUS_EQ] = ACTIONS(1477),
    [anon_sym_DASH_EQ] = ACTIONS(1477),
    [anon_sym_LT_LT_EQ] = ACTIONS(1477),
    [anon_sym_GT_GT_EQ] = ACTIONS(1477),
    [anon_sym_AMP_EQ] = ACTIONS(1477),
    [anon_sym_CARET_EQ] = ACTIONS(1477),
    [anon_sym_PIPE_EQ] = ACTIONS(1477),
    [anon_sym_AMP] = ACTIONS(1479),
    [anon_sym_PIPE_PIPE] = ACTIONS(1477),
    [anon_sym_AMP_AMP] = ACTIONS(1477),
    [anon_sym_PIPE] = ACTIONS(1479),
    [anon_sym_CARET] = ACTIONS(1479),
    [anon_sym_EQ_EQ] = ACTIONS(1477),
    [anon_sym_BANG_EQ] = ACTIONS(1477),
    [anon_sym_LT] = ACTIONS(1564),
    [anon_sym_GT] = ACTIONS(1479),
    [anon_sym_LT_EQ] = ACTIONS(1477),
    [anon_sym_GT_EQ] = ACTIONS(1477),
    [anon_sym_LT_LT] = ACTIONS(1479),
    [anon_sym_GT_GT] = ACTIONS(1479),
    [anon_sym_PLUS] = ACTIONS(1479),
    [anon_sym_DASH] = ACTIONS(1479),
    [anon_sym_SLASH] = ACTIONS(1479),
    [anon_sym_PERCENT] = ACTIONS(1479),
    [anon_sym_DASH_DASH] = ACTIONS(1477),
    [anon_sym_PLUS_PLUS] = ACTIONS(1477),
    [anon_sym_DOT] = ACTIONS(1477),
    [anon_sym_DASH_GT] = ACTIONS(1477),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(2218),
  },
  [2343] = {
    [sym_raw_string_literal] = ACTIONS(4710),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(4712),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(4712),
    [anon_sym_LPAREN] = ACTIONS(4710),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(4712),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(4712),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(4712),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(4712),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(4712),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(4712),
    [sym_preproc_directive] = ACTIONS(4712),
    [anon_sym_SEMI] = ACTIONS(4710),
    [anon_sym_typedef] = ACTIONS(4712),
    [anon_sym_extern] = ACTIONS(4712),
    [anon_sym_LBRACE] = ACTIONS(4710),
    [anon_sym_STAR] = ACTIONS(4710),
    [anon_sym_LBRACK] = ACTIONS(4710),
    [anon_sym_static] = ACTIONS(4712),
    [anon_sym_register] = ACTIONS(4712),
    [anon_sym_inline] = ACTIONS(4712),
    [anon_sym_const] = ACTIONS(4712),
    [anon_sym_restrict] = ACTIONS(4712),
    [anon_sym_volatile] = ACTIONS(4712),
    [anon_sym__Atomic] = ACTIONS(4712),
    [anon_sym_mutable] = ACTIONS(4712),
    [anon_sym_explicit] = ACTIONS(4712),
    [anon_sym_constexpr] = ACTIONS(4712),
    [anon_sym_unsigned] = ACTIONS(4712),
    [anon_sym_long] = ACTIONS(4712),
    [anon_sym_short] = ACTIONS(4712),
    [sym_primitive_type] = ACTIONS(4712),
    [anon_sym_enum] = ACTIONS(4712),
    [anon_sym_struct] = ACTIONS(4712),
    [anon_sym_union] = ACTIONS(4712),
    [anon_sym_if] = ACTIONS(4712),
    [anon_sym_switch] = ACTIONS(4712),
    [anon_sym_case] = ACTIONS(4712),
    [anon_sym_default] = ACTIONS(4712),
    [anon_sym_while] = ACTIONS(4712),
    [anon_sym_do] = ACTIONS(4712),
    [anon_sym_for] = ACTIONS(4712),
    [anon_sym_return] = ACTIONS(4712),
    [anon_sym_break] = ACTIONS(4712),
    [anon_sym_continue] = ACTIONS(4712),
    [anon_sym_goto] = ACTIONS(4712),
    [anon_sym_AMP] = ACTIONS(4710),
    [anon_sym_BANG] = ACTIONS(4710),
    [anon_sym_TILDE] = ACTIONS(4710),
    [anon_sym_PLUS] = ACTIONS(4712),
    [anon_sym_DASH] = ACTIONS(4712),
    [anon_sym_DASH_DASH] = ACTIONS(4710),
    [anon_sym_PLUS_PLUS] = ACTIONS(4710),
    [anon_sym_sizeof] = ACTIONS(4712),
    [sym_number_literal] = ACTIONS(4710),
    [sym_char_literal] = ACTIONS(4710),
    [sym_string_literal] = ACTIONS(4710),
    [sym_true] = ACTIONS(4712),
    [sym_false] = ACTIONS(4712),
    [sym_null] = ACTIONS(4712),
    [sym_identifier] = ACTIONS(4712),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(4712),
    [sym_auto] = ACTIONS(4712),
    [anon_sym_typename] = ACTIONS(4712),
    [anon_sym_new] = ACTIONS(4712),
    [anon_sym_COLON_COLON] = ACTIONS(4710),
    [anon_sym_delete] = ACTIONS(4712),
    [sym_nullptr] = ACTIONS(4712),
  },
  [2344] = {
    [sym_raw_string_literal] = ACTIONS(1261),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1263),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1263),
    [anon_sym_LPAREN] = ACTIONS(1261),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1263),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(1263),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1263),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1263),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(1263),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(1263),
    [sym_preproc_directive] = ACTIONS(1263),
    [anon_sym_SEMI] = ACTIONS(1261),
    [anon_sym_typedef] = ACTIONS(1263),
    [anon_sym_extern] = ACTIONS(1263),
    [anon_sym_LBRACE] = ACTIONS(1261),
    [anon_sym_STAR] = ACTIONS(1261),
    [anon_sym_LBRACK] = ACTIONS(1261),
    [anon_sym_static] = ACTIONS(1263),
    [anon_sym_register] = ACTIONS(1263),
    [anon_sym_inline] = ACTIONS(1263),
    [anon_sym_const] = ACTIONS(1263),
    [anon_sym_restrict] = ACTIONS(1263),
    [anon_sym_volatile] = ACTIONS(1263),
    [anon_sym__Atomic] = ACTIONS(1263),
    [anon_sym_mutable] = ACTIONS(1263),
    [anon_sym_explicit] = ACTIONS(1263),
    [anon_sym_constexpr] = ACTIONS(1263),
    [anon_sym_unsigned] = ACTIONS(1263),
    [anon_sym_long] = ACTIONS(1263),
    [anon_sym_short] = ACTIONS(1263),
    [sym_primitive_type] = ACTIONS(1263),
    [anon_sym_enum] = ACTIONS(1263),
    [anon_sym_struct] = ACTIONS(1263),
    [anon_sym_union] = ACTIONS(1263),
    [anon_sym_if] = ACTIONS(1263),
    [anon_sym_switch] = ACTIONS(1263),
    [anon_sym_case] = ACTIONS(1263),
    [anon_sym_default] = ACTIONS(1263),
    [anon_sym_while] = ACTIONS(1263),
    [anon_sym_do] = ACTIONS(1263),
    [anon_sym_for] = ACTIONS(1263),
    [anon_sym_return] = ACTIONS(1263),
    [anon_sym_break] = ACTIONS(1263),
    [anon_sym_continue] = ACTIONS(1263),
    [anon_sym_goto] = ACTIONS(1263),
    [anon_sym_AMP] = ACTIONS(1261),
    [anon_sym_BANG] = ACTIONS(1261),
    [anon_sym_TILDE] = ACTIONS(1261),
    [anon_sym_PLUS] = ACTIONS(1263),
    [anon_sym_DASH] = ACTIONS(1263),
    [anon_sym_DASH_DASH] = ACTIONS(1261),
    [anon_sym_PLUS_PLUS] = ACTIONS(1261),
    [anon_sym_sizeof] = ACTIONS(1263),
    [sym_number_literal] = ACTIONS(1261),
    [sym_char_literal] = ACTIONS(1261),
    [sym_string_literal] = ACTIONS(1261),
    [sym_true] = ACTIONS(1263),
    [sym_false] = ACTIONS(1263),
    [sym_null] = ACTIONS(1263),
    [sym_identifier] = ACTIONS(1263),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(1263),
    [sym_auto] = ACTIONS(1263),
    [anon_sym_typename] = ACTIONS(1263),
    [anon_sym_new] = ACTIONS(1263),
    [anon_sym_COLON_COLON] = ACTIONS(1261),
    [anon_sym_delete] = ACTIONS(1263),
    [sym_nullptr] = ACTIONS(1263),
  },
  [2345] = {
    [aux_sym_declaration_repeat1] = STATE(678),
    [anon_sym_COMMA] = ACTIONS(538),
    [anon_sym_SEMI] = ACTIONS(6186),
    [sym_comment] = ACTIONS(49),
  },
  [2346] = {
    [sym__expression] = STATE(2586),
    [sym_conditional_expression] = STATE(2586),
    [sym_assignment_expression] = STATE(2586),
    [sym_pointer_expression] = STATE(2586),
    [sym_logical_expression] = STATE(2586),
    [sym_bitwise_expression] = STATE(2586),
    [sym_equality_expression] = STATE(2586),
    [sym_relational_expression] = STATE(2586),
    [sym_shift_expression] = STATE(2586),
    [sym_math_expression] = STATE(2586),
    [sym_cast_expression] = STATE(2586),
    [sym_sizeof_expression] = STATE(2586),
    [sym_subscript_expression] = STATE(2586),
    [sym_call_expression] = STATE(2586),
    [sym_field_expression] = STATE(2586),
    [sym_compound_literal_expression] = STATE(2586),
    [sym_parenthesized_expression] = STATE(2586),
    [sym_initializer_list] = STATE(2587),
    [sym_concatenated_string] = STATE(2586),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(2586),
    [sym_new_expression] = STATE(2586),
    [sym_delete_expression] = STATE(2586),
    [sym_lambda_expression] = STATE(2586),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(6188),
    [anon_sym_LPAREN] = ACTIONS(1347),
    [anon_sym_LBRACE] = ACTIONS(548),
    [anon_sym_STAR] = ACTIONS(1349),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_AMP] = ACTIONS(1349),
    [anon_sym_BANG] = ACTIONS(1351),
    [anon_sym_TILDE] = ACTIONS(1353),
    [anon_sym_PLUS] = ACTIONS(1355),
    [anon_sym_DASH] = ACTIONS(1355),
    [anon_sym_DASH_DASH] = ACTIONS(1357),
    [anon_sym_PLUS_PLUS] = ACTIONS(1357),
    [anon_sym_sizeof] = ACTIONS(1359),
    [sym_number_literal] = ACTIONS(6188),
    [sym_char_literal] = ACTIONS(6188),
    [sym_string_literal] = ACTIONS(1361),
    [sym_true] = ACTIONS(6190),
    [sym_false] = ACTIONS(6190),
    [sym_null] = ACTIONS(6190),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1365),
    [anon_sym_delete] = ACTIONS(1367),
    [sym_nullptr] = ACTIONS(6190),
  },
  [2347] = {
    [anon_sym_SEMI] = ACTIONS(6192),
    [sym_comment] = ACTIONS(49),
  },
  [2348] = {
    [sym__expression] = STATE(2589),
    [sym_conditional_expression] = STATE(2589),
    [sym_assignment_expression] = STATE(2589),
    [sym_pointer_expression] = STATE(2589),
    [sym_logical_expression] = STATE(2589),
    [sym_bitwise_expression] = STATE(2589),
    [sym_equality_expression] = STATE(2589),
    [sym_relational_expression] = STATE(2589),
    [sym_shift_expression] = STATE(2589),
    [sym_math_expression] = STATE(2589),
    [sym_cast_expression] = STATE(2589),
    [sym_sizeof_expression] = STATE(2589),
    [sym_subscript_expression] = STATE(2589),
    [sym_call_expression] = STATE(2589),
    [sym_field_expression] = STATE(2589),
    [sym_compound_literal_expression] = STATE(2589),
    [sym_parenthesized_expression] = STATE(2589),
    [sym_initializer_list] = STATE(2590),
    [sym_concatenated_string] = STATE(2589),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(2589),
    [sym_new_expression] = STATE(2589),
    [sym_delete_expression] = STATE(2589),
    [sym_lambda_expression] = STATE(2589),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(6194),
    [anon_sym_LPAREN] = ACTIONS(1347),
    [anon_sym_LBRACE] = ACTIONS(548),
    [anon_sym_STAR] = ACTIONS(1349),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_AMP] = ACTIONS(1349),
    [anon_sym_BANG] = ACTIONS(1351),
    [anon_sym_TILDE] = ACTIONS(1353),
    [anon_sym_PLUS] = ACTIONS(1355),
    [anon_sym_DASH] = ACTIONS(1355),
    [anon_sym_DASH_DASH] = ACTIONS(1357),
    [anon_sym_PLUS_PLUS] = ACTIONS(1357),
    [anon_sym_sizeof] = ACTIONS(1359),
    [sym_number_literal] = ACTIONS(6194),
    [sym_char_literal] = ACTIONS(6194),
    [sym_string_literal] = ACTIONS(1361),
    [sym_true] = ACTIONS(6196),
    [sym_false] = ACTIONS(6196),
    [sym_null] = ACTIONS(6196),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1365),
    [anon_sym_delete] = ACTIONS(1367),
    [sym_nullptr] = ACTIONS(6196),
  },
  [2349] = {
    [anon_sym_SEMI] = ACTIONS(6198),
    [sym_comment] = ACTIONS(49),
  },
  [2350] = {
    [sym_raw_string_literal] = ACTIONS(6200),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(6202),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(6202),
    [anon_sym_LPAREN] = ACTIONS(6200),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(6202),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(6202),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(6202),
    [sym_preproc_directive] = ACTIONS(6202),
    [anon_sym_SEMI] = ACTIONS(6200),
    [anon_sym_typedef] = ACTIONS(6202),
    [anon_sym_extern] = ACTIONS(6202),
    [anon_sym_LBRACE] = ACTIONS(6200),
    [anon_sym_RBRACE] = ACTIONS(6200),
    [anon_sym_STAR] = ACTIONS(6200),
    [anon_sym_LBRACK] = ACTIONS(6200),
    [anon_sym_static] = ACTIONS(6202),
    [anon_sym_register] = ACTIONS(6202),
    [anon_sym_inline] = ACTIONS(6202),
    [anon_sym_const] = ACTIONS(6202),
    [anon_sym_restrict] = ACTIONS(6202),
    [anon_sym_volatile] = ACTIONS(6202),
    [anon_sym__Atomic] = ACTIONS(6202),
    [anon_sym_mutable] = ACTIONS(6202),
    [anon_sym_explicit] = ACTIONS(6202),
    [anon_sym_constexpr] = ACTIONS(6202),
    [anon_sym_unsigned] = ACTIONS(6202),
    [anon_sym_long] = ACTIONS(6202),
    [anon_sym_short] = ACTIONS(6202),
    [sym_primitive_type] = ACTIONS(6202),
    [anon_sym_enum] = ACTIONS(6202),
    [anon_sym_struct] = ACTIONS(6202),
    [anon_sym_union] = ACTIONS(6202),
    [anon_sym_if] = ACTIONS(6202),
    [anon_sym_switch] = ACTIONS(6202),
    [anon_sym_case] = ACTIONS(6202),
    [anon_sym_default] = ACTIONS(6202),
    [anon_sym_while] = ACTIONS(6202),
    [anon_sym_do] = ACTIONS(6202),
    [anon_sym_for] = ACTIONS(6202),
    [anon_sym_return] = ACTIONS(6202),
    [anon_sym_break] = ACTIONS(6202),
    [anon_sym_continue] = ACTIONS(6202),
    [anon_sym_goto] = ACTIONS(6202),
    [anon_sym_AMP] = ACTIONS(6200),
    [anon_sym_BANG] = ACTIONS(6200),
    [anon_sym_TILDE] = ACTIONS(6200),
    [anon_sym_PLUS] = ACTIONS(6202),
    [anon_sym_DASH] = ACTIONS(6202),
    [anon_sym_DASH_DASH] = ACTIONS(6200),
    [anon_sym_PLUS_PLUS] = ACTIONS(6200),
    [anon_sym_sizeof] = ACTIONS(6202),
    [sym_number_literal] = ACTIONS(6200),
    [sym_char_literal] = ACTIONS(6200),
    [sym_string_literal] = ACTIONS(6200),
    [sym_true] = ACTIONS(6202),
    [sym_false] = ACTIONS(6202),
    [sym_null] = ACTIONS(6202),
    [sym_identifier] = ACTIONS(6202),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(6202),
    [sym_auto] = ACTIONS(6202),
    [anon_sym_typename] = ACTIONS(6202),
    [anon_sym_new] = ACTIONS(6202),
    [anon_sym_COLON_COLON] = ACTIONS(6200),
    [anon_sym_delete] = ACTIONS(6202),
    [sym_nullptr] = ACTIONS(6202),
  },
  [2351] = {
    [sym_raw_string_literal] = ACTIONS(6204),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(6206),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(6206),
    [anon_sym_LPAREN] = ACTIONS(6204),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(6206),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(6206),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(6206),
    [sym_preproc_directive] = ACTIONS(6206),
    [anon_sym_SEMI] = ACTIONS(6204),
    [anon_sym_typedef] = ACTIONS(6206),
    [anon_sym_extern] = ACTIONS(6206),
    [anon_sym_LBRACE] = ACTIONS(6204),
    [anon_sym_RBRACE] = ACTIONS(6204),
    [anon_sym_STAR] = ACTIONS(6204),
    [anon_sym_LBRACK] = ACTIONS(6204),
    [anon_sym_static] = ACTIONS(6206),
    [anon_sym_register] = ACTIONS(6206),
    [anon_sym_inline] = ACTIONS(6206),
    [anon_sym_const] = ACTIONS(6206),
    [anon_sym_restrict] = ACTIONS(6206),
    [anon_sym_volatile] = ACTIONS(6206),
    [anon_sym__Atomic] = ACTIONS(6206),
    [anon_sym_mutable] = ACTIONS(6206),
    [anon_sym_explicit] = ACTIONS(6206),
    [anon_sym_constexpr] = ACTIONS(6206),
    [anon_sym_unsigned] = ACTIONS(6206),
    [anon_sym_long] = ACTIONS(6206),
    [anon_sym_short] = ACTIONS(6206),
    [sym_primitive_type] = ACTIONS(6206),
    [anon_sym_enum] = ACTIONS(6206),
    [anon_sym_struct] = ACTIONS(6206),
    [anon_sym_union] = ACTIONS(6206),
    [anon_sym_if] = ACTIONS(6206),
    [anon_sym_switch] = ACTIONS(6206),
    [anon_sym_case] = ACTIONS(6206),
    [anon_sym_default] = ACTIONS(6206),
    [anon_sym_while] = ACTIONS(6206),
    [anon_sym_do] = ACTIONS(6206),
    [anon_sym_for] = ACTIONS(6206),
    [anon_sym_return] = ACTIONS(6206),
    [anon_sym_break] = ACTIONS(6206),
    [anon_sym_continue] = ACTIONS(6206),
    [anon_sym_goto] = ACTIONS(6206),
    [anon_sym_AMP] = ACTIONS(6204),
    [anon_sym_BANG] = ACTIONS(6204),
    [anon_sym_TILDE] = ACTIONS(6204),
    [anon_sym_PLUS] = ACTIONS(6206),
    [anon_sym_DASH] = ACTIONS(6206),
    [anon_sym_DASH_DASH] = ACTIONS(6204),
    [anon_sym_PLUS_PLUS] = ACTIONS(6204),
    [anon_sym_sizeof] = ACTIONS(6206),
    [sym_number_literal] = ACTIONS(6204),
    [sym_char_literal] = ACTIONS(6204),
    [sym_string_literal] = ACTIONS(6204),
    [sym_true] = ACTIONS(6206),
    [sym_false] = ACTIONS(6206),
    [sym_null] = ACTIONS(6206),
    [sym_identifier] = ACTIONS(6206),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(6206),
    [sym_auto] = ACTIONS(6206),
    [anon_sym_typename] = ACTIONS(6206),
    [anon_sym_new] = ACTIONS(6206),
    [anon_sym_COLON_COLON] = ACTIONS(6204),
    [anon_sym_delete] = ACTIONS(6206),
    [sym_nullptr] = ACTIONS(6206),
  },
  [2352] = {
    [sym_raw_string_literal] = ACTIONS(6208),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(6210),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(6210),
    [anon_sym_LPAREN] = ACTIONS(6208),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(6210),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(6210),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(6210),
    [sym_preproc_directive] = ACTIONS(6210),
    [anon_sym_SEMI] = ACTIONS(6208),
    [anon_sym_typedef] = ACTIONS(6210),
    [anon_sym_extern] = ACTIONS(6210),
    [anon_sym_LBRACE] = ACTIONS(6208),
    [anon_sym_RBRACE] = ACTIONS(6208),
    [anon_sym_STAR] = ACTIONS(6208),
    [anon_sym_LBRACK] = ACTIONS(6208),
    [anon_sym_static] = ACTIONS(6210),
    [anon_sym_register] = ACTIONS(6210),
    [anon_sym_inline] = ACTIONS(6210),
    [anon_sym_const] = ACTIONS(6210),
    [anon_sym_restrict] = ACTIONS(6210),
    [anon_sym_volatile] = ACTIONS(6210),
    [anon_sym__Atomic] = ACTIONS(6210),
    [anon_sym_mutable] = ACTIONS(6210),
    [anon_sym_explicit] = ACTIONS(6210),
    [anon_sym_constexpr] = ACTIONS(6210),
    [anon_sym_unsigned] = ACTIONS(6210),
    [anon_sym_long] = ACTIONS(6210),
    [anon_sym_short] = ACTIONS(6210),
    [sym_primitive_type] = ACTIONS(6210),
    [anon_sym_enum] = ACTIONS(6210),
    [anon_sym_struct] = ACTIONS(6210),
    [anon_sym_union] = ACTIONS(6210),
    [anon_sym_if] = ACTIONS(6210),
    [anon_sym_switch] = ACTIONS(6210),
    [anon_sym_case] = ACTIONS(6210),
    [anon_sym_default] = ACTIONS(6210),
    [anon_sym_while] = ACTIONS(6210),
    [anon_sym_do] = ACTIONS(6210),
    [anon_sym_for] = ACTIONS(6210),
    [anon_sym_return] = ACTIONS(6210),
    [anon_sym_break] = ACTIONS(6210),
    [anon_sym_continue] = ACTIONS(6210),
    [anon_sym_goto] = ACTIONS(6210),
    [anon_sym_AMP] = ACTIONS(6208),
    [anon_sym_BANG] = ACTIONS(6208),
    [anon_sym_TILDE] = ACTIONS(6208),
    [anon_sym_PLUS] = ACTIONS(6210),
    [anon_sym_DASH] = ACTIONS(6210),
    [anon_sym_DASH_DASH] = ACTIONS(6208),
    [anon_sym_PLUS_PLUS] = ACTIONS(6208),
    [anon_sym_sizeof] = ACTIONS(6210),
    [sym_number_literal] = ACTIONS(6208),
    [sym_char_literal] = ACTIONS(6208),
    [sym_string_literal] = ACTIONS(6208),
    [sym_true] = ACTIONS(6210),
    [sym_false] = ACTIONS(6210),
    [sym_null] = ACTIONS(6210),
    [sym_identifier] = ACTIONS(6210),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(6210),
    [sym_auto] = ACTIONS(6210),
    [anon_sym_typename] = ACTIONS(6210),
    [anon_sym_new] = ACTIONS(6210),
    [anon_sym_COLON_COLON] = ACTIONS(6208),
    [anon_sym_delete] = ACTIONS(6210),
    [sym_nullptr] = ACTIONS(6210),
  },
  [2353] = {
    [sym_raw_string_literal] = ACTIONS(6212),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(6214),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(6214),
    [anon_sym_LPAREN] = ACTIONS(6212),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(6214),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(6214),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(6214),
    [sym_preproc_directive] = ACTIONS(6214),
    [anon_sym_SEMI] = ACTIONS(6212),
    [anon_sym_typedef] = ACTIONS(6214),
    [anon_sym_extern] = ACTIONS(6214),
    [anon_sym_LBRACE] = ACTIONS(6212),
    [anon_sym_RBRACE] = ACTIONS(6212),
    [anon_sym_STAR] = ACTIONS(6212),
    [anon_sym_LBRACK] = ACTIONS(6212),
    [anon_sym_static] = ACTIONS(6214),
    [anon_sym_register] = ACTIONS(6214),
    [anon_sym_inline] = ACTIONS(6214),
    [anon_sym_const] = ACTIONS(6214),
    [anon_sym_restrict] = ACTIONS(6214),
    [anon_sym_volatile] = ACTIONS(6214),
    [anon_sym__Atomic] = ACTIONS(6214),
    [anon_sym_mutable] = ACTIONS(6214),
    [anon_sym_explicit] = ACTIONS(6214),
    [anon_sym_constexpr] = ACTIONS(6214),
    [anon_sym_unsigned] = ACTIONS(6214),
    [anon_sym_long] = ACTIONS(6214),
    [anon_sym_short] = ACTIONS(6214),
    [sym_primitive_type] = ACTIONS(6214),
    [anon_sym_enum] = ACTIONS(6214),
    [anon_sym_struct] = ACTIONS(6214),
    [anon_sym_union] = ACTIONS(6214),
    [anon_sym_if] = ACTIONS(6214),
    [anon_sym_switch] = ACTIONS(6214),
    [anon_sym_case] = ACTIONS(6214),
    [anon_sym_default] = ACTIONS(6214),
    [anon_sym_while] = ACTIONS(6214),
    [anon_sym_do] = ACTIONS(6214),
    [anon_sym_for] = ACTIONS(6214),
    [anon_sym_return] = ACTIONS(6214),
    [anon_sym_break] = ACTIONS(6214),
    [anon_sym_continue] = ACTIONS(6214),
    [anon_sym_goto] = ACTIONS(6214),
    [anon_sym_AMP] = ACTIONS(6212),
    [anon_sym_BANG] = ACTIONS(6212),
    [anon_sym_TILDE] = ACTIONS(6212),
    [anon_sym_PLUS] = ACTIONS(6214),
    [anon_sym_DASH] = ACTIONS(6214),
    [anon_sym_DASH_DASH] = ACTIONS(6212),
    [anon_sym_PLUS_PLUS] = ACTIONS(6212),
    [anon_sym_sizeof] = ACTIONS(6214),
    [sym_number_literal] = ACTIONS(6212),
    [sym_char_literal] = ACTIONS(6212),
    [sym_string_literal] = ACTIONS(6212),
    [sym_true] = ACTIONS(6214),
    [sym_false] = ACTIONS(6214),
    [sym_null] = ACTIONS(6214),
    [sym_identifier] = ACTIONS(6214),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(6214),
    [sym_auto] = ACTIONS(6214),
    [anon_sym_typename] = ACTIONS(6214),
    [anon_sym_new] = ACTIONS(6214),
    [anon_sym_COLON_COLON] = ACTIONS(6212),
    [anon_sym_delete] = ACTIONS(6214),
    [sym_nullptr] = ACTIONS(6214),
  },
  [2354] = {
    [sym_raw_string_literal] = ACTIONS(6216),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(6218),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(6218),
    [anon_sym_LPAREN] = ACTIONS(6216),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(6218),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(6218),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(6218),
    [sym_preproc_directive] = ACTIONS(6218),
    [anon_sym_SEMI] = ACTIONS(6216),
    [anon_sym_typedef] = ACTIONS(6218),
    [anon_sym_extern] = ACTIONS(6218),
    [anon_sym_LBRACE] = ACTIONS(6216),
    [anon_sym_RBRACE] = ACTIONS(6216),
    [anon_sym_STAR] = ACTIONS(6216),
    [anon_sym_LBRACK] = ACTIONS(6216),
    [anon_sym_static] = ACTIONS(6218),
    [anon_sym_register] = ACTIONS(6218),
    [anon_sym_inline] = ACTIONS(6218),
    [anon_sym_const] = ACTIONS(6218),
    [anon_sym_restrict] = ACTIONS(6218),
    [anon_sym_volatile] = ACTIONS(6218),
    [anon_sym__Atomic] = ACTIONS(6218),
    [anon_sym_mutable] = ACTIONS(6218),
    [anon_sym_explicit] = ACTIONS(6218),
    [anon_sym_constexpr] = ACTIONS(6218),
    [anon_sym_unsigned] = ACTIONS(6218),
    [anon_sym_long] = ACTIONS(6218),
    [anon_sym_short] = ACTIONS(6218),
    [sym_primitive_type] = ACTIONS(6218),
    [anon_sym_enum] = ACTIONS(6218),
    [anon_sym_struct] = ACTIONS(6218),
    [anon_sym_union] = ACTIONS(6218),
    [anon_sym_if] = ACTIONS(6218),
    [anon_sym_switch] = ACTIONS(6218),
    [anon_sym_case] = ACTIONS(6218),
    [anon_sym_default] = ACTIONS(6218),
    [anon_sym_while] = ACTIONS(6218),
    [anon_sym_do] = ACTIONS(6218),
    [anon_sym_for] = ACTIONS(6218),
    [anon_sym_return] = ACTIONS(6218),
    [anon_sym_break] = ACTIONS(6218),
    [anon_sym_continue] = ACTIONS(6218),
    [anon_sym_goto] = ACTIONS(6218),
    [anon_sym_AMP] = ACTIONS(6216),
    [anon_sym_BANG] = ACTIONS(6216),
    [anon_sym_TILDE] = ACTIONS(6216),
    [anon_sym_PLUS] = ACTIONS(6218),
    [anon_sym_DASH] = ACTIONS(6218),
    [anon_sym_DASH_DASH] = ACTIONS(6216),
    [anon_sym_PLUS_PLUS] = ACTIONS(6216),
    [anon_sym_sizeof] = ACTIONS(6218),
    [sym_number_literal] = ACTIONS(6216),
    [sym_char_literal] = ACTIONS(6216),
    [sym_string_literal] = ACTIONS(6216),
    [sym_true] = ACTIONS(6218),
    [sym_false] = ACTIONS(6218),
    [sym_null] = ACTIONS(6218),
    [sym_identifier] = ACTIONS(6218),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(6218),
    [sym_auto] = ACTIONS(6218),
    [anon_sym_typename] = ACTIONS(6218),
    [anon_sym_new] = ACTIONS(6218),
    [anon_sym_COLON_COLON] = ACTIONS(6216),
    [anon_sym_delete] = ACTIONS(6218),
    [sym_nullptr] = ACTIONS(6218),
  },
  [2355] = {
    [sym_raw_string_literal] = ACTIONS(6220),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(6222),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(6222),
    [anon_sym_LPAREN] = ACTIONS(6220),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(6222),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(6222),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(6222),
    [sym_preproc_directive] = ACTIONS(6222),
    [anon_sym_SEMI] = ACTIONS(6220),
    [anon_sym_typedef] = ACTIONS(6222),
    [anon_sym_extern] = ACTIONS(6222),
    [anon_sym_LBRACE] = ACTIONS(6220),
    [anon_sym_RBRACE] = ACTIONS(6220),
    [anon_sym_STAR] = ACTIONS(6220),
    [anon_sym_LBRACK] = ACTIONS(6220),
    [anon_sym_static] = ACTIONS(6222),
    [anon_sym_register] = ACTIONS(6222),
    [anon_sym_inline] = ACTIONS(6222),
    [anon_sym_const] = ACTIONS(6222),
    [anon_sym_restrict] = ACTIONS(6222),
    [anon_sym_volatile] = ACTIONS(6222),
    [anon_sym__Atomic] = ACTIONS(6222),
    [anon_sym_mutable] = ACTIONS(6222),
    [anon_sym_explicit] = ACTIONS(6222),
    [anon_sym_constexpr] = ACTIONS(6222),
    [anon_sym_unsigned] = ACTIONS(6222),
    [anon_sym_long] = ACTIONS(6222),
    [anon_sym_short] = ACTIONS(6222),
    [sym_primitive_type] = ACTIONS(6222),
    [anon_sym_enum] = ACTIONS(6222),
    [anon_sym_struct] = ACTIONS(6222),
    [anon_sym_union] = ACTIONS(6222),
    [anon_sym_if] = ACTIONS(6222),
    [anon_sym_switch] = ACTIONS(6222),
    [anon_sym_case] = ACTIONS(6222),
    [anon_sym_default] = ACTIONS(6222),
    [anon_sym_while] = ACTIONS(6222),
    [anon_sym_do] = ACTIONS(6222),
    [anon_sym_for] = ACTIONS(6222),
    [anon_sym_return] = ACTIONS(6222),
    [anon_sym_break] = ACTIONS(6222),
    [anon_sym_continue] = ACTIONS(6222),
    [anon_sym_goto] = ACTIONS(6222),
    [anon_sym_AMP] = ACTIONS(6220),
    [anon_sym_BANG] = ACTIONS(6220),
    [anon_sym_TILDE] = ACTIONS(6220),
    [anon_sym_PLUS] = ACTIONS(6222),
    [anon_sym_DASH] = ACTIONS(6222),
    [anon_sym_DASH_DASH] = ACTIONS(6220),
    [anon_sym_PLUS_PLUS] = ACTIONS(6220),
    [anon_sym_sizeof] = ACTIONS(6222),
    [sym_number_literal] = ACTIONS(6220),
    [sym_char_literal] = ACTIONS(6220),
    [sym_string_literal] = ACTIONS(6220),
    [sym_true] = ACTIONS(6222),
    [sym_false] = ACTIONS(6222),
    [sym_null] = ACTIONS(6222),
    [sym_identifier] = ACTIONS(6222),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(6222),
    [sym_auto] = ACTIONS(6222),
    [anon_sym_typename] = ACTIONS(6222),
    [anon_sym_new] = ACTIONS(6222),
    [anon_sym_COLON_COLON] = ACTIONS(6220),
    [anon_sym_delete] = ACTIONS(6222),
    [sym_nullptr] = ACTIONS(6222),
  },
  [2356] = {
    [sym_raw_string_literal] = ACTIONS(3519),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3521),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3521),
    [anon_sym_LPAREN] = ACTIONS(3519),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3521),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3521),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3521),
    [sym_preproc_directive] = ACTIONS(3521),
    [anon_sym_SEMI] = ACTIONS(3519),
    [anon_sym_typedef] = ACTIONS(3521),
    [anon_sym_extern] = ACTIONS(3521),
    [anon_sym_LBRACE] = ACTIONS(3519),
    [anon_sym_RBRACE] = ACTIONS(3519),
    [anon_sym_STAR] = ACTIONS(3519),
    [anon_sym_LBRACK] = ACTIONS(3519),
    [anon_sym_static] = ACTIONS(3521),
    [anon_sym_register] = ACTIONS(3521),
    [anon_sym_inline] = ACTIONS(3521),
    [anon_sym_const] = ACTIONS(3521),
    [anon_sym_restrict] = ACTIONS(3521),
    [anon_sym_volatile] = ACTIONS(3521),
    [anon_sym__Atomic] = ACTIONS(3521),
    [anon_sym_mutable] = ACTIONS(3521),
    [anon_sym_explicit] = ACTIONS(3521),
    [anon_sym_constexpr] = ACTIONS(3521),
    [anon_sym_unsigned] = ACTIONS(3521),
    [anon_sym_long] = ACTIONS(3521),
    [anon_sym_short] = ACTIONS(3521),
    [sym_primitive_type] = ACTIONS(3521),
    [anon_sym_enum] = ACTIONS(3521),
    [anon_sym_struct] = ACTIONS(3521),
    [anon_sym_union] = ACTIONS(3521),
    [anon_sym_if] = ACTIONS(3521),
    [anon_sym_switch] = ACTIONS(3521),
    [anon_sym_case] = ACTIONS(3521),
    [anon_sym_default] = ACTIONS(3521),
    [anon_sym_while] = ACTIONS(3521),
    [anon_sym_do] = ACTIONS(3521),
    [anon_sym_for] = ACTIONS(3521),
    [anon_sym_return] = ACTIONS(3521),
    [anon_sym_break] = ACTIONS(3521),
    [anon_sym_continue] = ACTIONS(3521),
    [anon_sym_goto] = ACTIONS(3521),
    [anon_sym_AMP] = ACTIONS(3519),
    [anon_sym_BANG] = ACTIONS(3519),
    [anon_sym_TILDE] = ACTIONS(3519),
    [anon_sym_PLUS] = ACTIONS(3521),
    [anon_sym_DASH] = ACTIONS(3521),
    [anon_sym_DASH_DASH] = ACTIONS(3519),
    [anon_sym_PLUS_PLUS] = ACTIONS(3519),
    [anon_sym_sizeof] = ACTIONS(3521),
    [sym_number_literal] = ACTIONS(3519),
    [sym_char_literal] = ACTIONS(3519),
    [sym_string_literal] = ACTIONS(3519),
    [sym_true] = ACTIONS(3521),
    [sym_false] = ACTIONS(3521),
    [sym_null] = ACTIONS(3521),
    [sym_identifier] = ACTIONS(3521),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(3521),
    [sym_auto] = ACTIONS(3521),
    [anon_sym_typename] = ACTIONS(3521),
    [anon_sym_new] = ACTIONS(3521),
    [anon_sym_COLON_COLON] = ACTIONS(3519),
    [anon_sym_delete] = ACTIONS(3521),
    [sym_nullptr] = ACTIONS(3521),
  },
  [2357] = {
    [sym__expression] = STATE(1834),
    [sym_conditional_expression] = STATE(1834),
    [sym_assignment_expression] = STATE(1834),
    [sym_pointer_expression] = STATE(1834),
    [sym_logical_expression] = STATE(1834),
    [sym_bitwise_expression] = STATE(1834),
    [sym_equality_expression] = STATE(1834),
    [sym_relational_expression] = STATE(1834),
    [sym_shift_expression] = STATE(1834),
    [sym_math_expression] = STATE(1834),
    [sym_cast_expression] = STATE(1834),
    [sym_sizeof_expression] = STATE(1834),
    [sym_subscript_expression] = STATE(1834),
    [sym_call_expression] = STATE(1834),
    [sym_field_expression] = STATE(1834),
    [sym_compound_literal_expression] = STATE(1834),
    [sym_parenthesized_expression] = STATE(1834),
    [sym_initializer_list] = STATE(1835),
    [sym_concatenated_string] = STATE(1834),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(1834),
    [sym_new_expression] = STATE(1834),
    [sym_delete_expression] = STATE(1834),
    [sym_lambda_expression] = STATE(1834),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(4145),
    [anon_sym_LPAREN] = ACTIONS(2943),
    [anon_sym_LBRACE] = ACTIONS(548),
    [anon_sym_STAR] = ACTIONS(2945),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_AMP] = ACTIONS(2945),
    [anon_sym_BANG] = ACTIONS(2947),
    [anon_sym_TILDE] = ACTIONS(2949),
    [anon_sym_PLUS] = ACTIONS(2951),
    [anon_sym_DASH] = ACTIONS(2951),
    [anon_sym_DASH_DASH] = ACTIONS(2953),
    [anon_sym_PLUS_PLUS] = ACTIONS(2953),
    [anon_sym_sizeof] = ACTIONS(2955),
    [sym_number_literal] = ACTIONS(4145),
    [sym_char_literal] = ACTIONS(4145),
    [sym_string_literal] = ACTIONS(2957),
    [sym_true] = ACTIONS(4147),
    [sym_false] = ACTIONS(4147),
    [sym_null] = ACTIONS(4147),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(2961),
    [anon_sym_delete] = ACTIONS(2963),
    [sym_nullptr] = ACTIONS(4147),
  },
  [2358] = {
    [anon_sym_RPAREN] = ACTIONS(6224),
    [sym_comment] = ACTIONS(49),
  },
  [2359] = {
    [aux_sym_concatenated_string_repeat1] = STATE(2359),
    [anon_sym_LPAREN] = ACTIONS(4230),
    [anon_sym_RPAREN] = ACTIONS(4230),
    [anon_sym_STAR] = ACTIONS(4232),
    [anon_sym_LBRACK] = ACTIONS(4230),
    [anon_sym_EQ] = ACTIONS(4232),
    [anon_sym_QMARK] = ACTIONS(4230),
    [anon_sym_STAR_EQ] = ACTIONS(4230),
    [anon_sym_SLASH_EQ] = ACTIONS(4230),
    [anon_sym_PERCENT_EQ] = ACTIONS(4230),
    [anon_sym_PLUS_EQ] = ACTIONS(4230),
    [anon_sym_DASH_EQ] = ACTIONS(4230),
    [anon_sym_LT_LT_EQ] = ACTIONS(4230),
    [anon_sym_GT_GT_EQ] = ACTIONS(4230),
    [anon_sym_AMP_EQ] = ACTIONS(4230),
    [anon_sym_CARET_EQ] = ACTIONS(4230),
    [anon_sym_PIPE_EQ] = ACTIONS(4230),
    [anon_sym_AMP] = ACTIONS(4232),
    [anon_sym_PIPE_PIPE] = ACTIONS(4230),
    [anon_sym_AMP_AMP] = ACTIONS(4230),
    [anon_sym_PIPE] = ACTIONS(4232),
    [anon_sym_CARET] = ACTIONS(4232),
    [anon_sym_EQ_EQ] = ACTIONS(4230),
    [anon_sym_BANG_EQ] = ACTIONS(4230),
    [anon_sym_LT] = ACTIONS(4232),
    [anon_sym_GT] = ACTIONS(4232),
    [anon_sym_LT_EQ] = ACTIONS(4230),
    [anon_sym_GT_EQ] = ACTIONS(4230),
    [anon_sym_LT_LT] = ACTIONS(4232),
    [anon_sym_GT_GT] = ACTIONS(4232),
    [anon_sym_PLUS] = ACTIONS(4232),
    [anon_sym_DASH] = ACTIONS(4232),
    [anon_sym_SLASH] = ACTIONS(4232),
    [anon_sym_PERCENT] = ACTIONS(4232),
    [anon_sym_DASH_DASH] = ACTIONS(4230),
    [anon_sym_PLUS_PLUS] = ACTIONS(4230),
    [anon_sym_DOT] = ACTIONS(4230),
    [anon_sym_DASH_GT] = ACTIONS(4230),
    [sym_string_literal] = ACTIONS(6226),
    [sym_comment] = ACTIONS(49),
  },
  [2360] = {
    [sym__expression] = STATE(740),
    [sym_conditional_expression] = STATE(740),
    [sym_assignment_expression] = STATE(740),
    [sym_pointer_expression] = STATE(740),
    [sym_logical_expression] = STATE(740),
    [sym_bitwise_expression] = STATE(740),
    [sym_equality_expression] = STATE(740),
    [sym_relational_expression] = STATE(740),
    [sym_shift_expression] = STATE(740),
    [sym_math_expression] = STATE(740),
    [sym_cast_expression] = STATE(740),
    [sym_sizeof_expression] = STATE(740),
    [sym_subscript_expression] = STATE(740),
    [sym_call_expression] = STATE(740),
    [sym_field_expression] = STATE(740),
    [sym_compound_literal_expression] = STATE(740),
    [sym_parenthesized_expression] = STATE(740),
    [sym_concatenated_string] = STATE(740),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(740),
    [sym_new_expression] = STATE(740),
    [sym_delete_expression] = STATE(740),
    [sym_lambda_expression] = STATE(740),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_lambda_default_capture] = STATE(741),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(1417),
    [anon_sym_LPAREN] = ACTIONS(1419),
    [anon_sym_STAR] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_RBRACK] = ACTIONS(6229),
    [anon_sym_EQ] = ACTIONS(1425),
    [anon_sym_AMP] = ACTIONS(1427),
    [anon_sym_BANG] = ACTIONS(1429),
    [anon_sym_TILDE] = ACTIONS(1431),
    [anon_sym_PLUS] = ACTIONS(1433),
    [anon_sym_DASH] = ACTIONS(1433),
    [anon_sym_DASH_DASH] = ACTIONS(1435),
    [anon_sym_PLUS_PLUS] = ACTIONS(1435),
    [anon_sym_sizeof] = ACTIONS(1437),
    [sym_number_literal] = ACTIONS(1417),
    [sym_char_literal] = ACTIONS(1417),
    [sym_string_literal] = ACTIONS(1439),
    [sym_true] = ACTIONS(1441),
    [sym_false] = ACTIONS(1441),
    [sym_null] = ACTIONS(1441),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1443),
    [anon_sym_delete] = ACTIONS(1445),
    [sym_nullptr] = ACTIONS(1441),
  },
  [2361] = {
    [sym_argument_list] = STATE(802),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_RPAREN] = ACTIONS(4258),
    [anon_sym_STAR] = ACTIONS(4537),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_EQ] = ACTIONS(4260),
    [anon_sym_QMARK] = ACTIONS(4258),
    [anon_sym_STAR_EQ] = ACTIONS(4258),
    [anon_sym_SLASH_EQ] = ACTIONS(4258),
    [anon_sym_PERCENT_EQ] = ACTIONS(4258),
    [anon_sym_PLUS_EQ] = ACTIONS(4258),
    [anon_sym_DASH_EQ] = ACTIONS(4258),
    [anon_sym_LT_LT_EQ] = ACTIONS(4258),
    [anon_sym_GT_GT_EQ] = ACTIONS(4258),
    [anon_sym_AMP_EQ] = ACTIONS(4258),
    [anon_sym_CARET_EQ] = ACTIONS(4258),
    [anon_sym_PIPE_EQ] = ACTIONS(4258),
    [anon_sym_AMP] = ACTIONS(4545),
    [anon_sym_PIPE_PIPE] = ACTIONS(4547),
    [anon_sym_AMP_AMP] = ACTIONS(4549),
    [anon_sym_PIPE] = ACTIONS(4551),
    [anon_sym_CARET] = ACTIONS(4553),
    [anon_sym_EQ_EQ] = ACTIONS(4555),
    [anon_sym_BANG_EQ] = ACTIONS(4555),
    [anon_sym_LT] = ACTIONS(4557),
    [anon_sym_GT] = ACTIONS(4557),
    [anon_sym_LT_EQ] = ACTIONS(4559),
    [anon_sym_GT_EQ] = ACTIONS(4559),
    [anon_sym_LT_LT] = ACTIONS(4561),
    [anon_sym_GT_GT] = ACTIONS(4561),
    [anon_sym_PLUS] = ACTIONS(4563),
    [anon_sym_DASH] = ACTIONS(4563),
    [anon_sym_SLASH] = ACTIONS(4537),
    [anon_sym_PERCENT] = ACTIONS(4537),
    [anon_sym_DASH_DASH] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(1554),
    [anon_sym_DASH_GT] = ACTIONS(1554),
    [sym_comment] = ACTIONS(49),
  },
  [2362] = {
    [sym__expression] = STATE(2594),
    [sym_conditional_expression] = STATE(2594),
    [sym_assignment_expression] = STATE(2594),
    [sym_pointer_expression] = STATE(2594),
    [sym_logical_expression] = STATE(2594),
    [sym_bitwise_expression] = STATE(2594),
    [sym_equality_expression] = STATE(2594),
    [sym_relational_expression] = STATE(2594),
    [sym_shift_expression] = STATE(2594),
    [sym_math_expression] = STATE(2594),
    [sym_cast_expression] = STATE(2594),
    [sym_sizeof_expression] = STATE(2594),
    [sym_subscript_expression] = STATE(2594),
    [sym_call_expression] = STATE(2594),
    [sym_field_expression] = STATE(2594),
    [sym_compound_literal_expression] = STATE(2594),
    [sym_parenthesized_expression] = STATE(2594),
    [sym_concatenated_string] = STATE(2594),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(2594),
    [sym_new_expression] = STATE(2594),
    [sym_delete_expression] = STATE(2594),
    [sym_lambda_expression] = STATE(2594),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(6231),
    [anon_sym_LPAREN] = ACTIONS(2624),
    [anon_sym_STAR] = ACTIONS(2624),
    [anon_sym_LBRACK] = ACTIONS(2624),
    [anon_sym_AMP] = ACTIONS(2626),
    [anon_sym_AMP_AMP] = ACTIONS(2624),
    [anon_sym_BANG] = ACTIONS(2947),
    [anon_sym_TILDE] = ACTIONS(2949),
    [anon_sym_PLUS] = ACTIONS(2951),
    [anon_sym_DASH] = ACTIONS(2951),
    [anon_sym_DASH_DASH] = ACTIONS(2953),
    [anon_sym_PLUS_PLUS] = ACTIONS(2953),
    [anon_sym_sizeof] = ACTIONS(2955),
    [sym_number_literal] = ACTIONS(6231),
    [sym_char_literal] = ACTIONS(6231),
    [sym_string_literal] = ACTIONS(2957),
    [sym_true] = ACTIONS(6233),
    [sym_false] = ACTIONS(6233),
    [sym_null] = ACTIONS(6233),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(2961),
    [anon_sym_delete] = ACTIONS(2963),
    [sym_nullptr] = ACTIONS(6233),
  },
  [2363] = {
    [sym_raw_string_literal] = ACTIONS(1614),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1616),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1616),
    [anon_sym_LPAREN] = ACTIONS(1614),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1616),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1616),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1616),
    [sym_preproc_directive] = ACTIONS(1616),
    [anon_sym_SEMI] = ACTIONS(1614),
    [anon_sym_typedef] = ACTIONS(1616),
    [anon_sym_extern] = ACTIONS(1616),
    [anon_sym_LBRACE] = ACTIONS(1614),
    [anon_sym_RBRACE] = ACTIONS(1614),
    [anon_sym_STAR] = ACTIONS(1614),
    [anon_sym_LBRACK] = ACTIONS(1614),
    [anon_sym_static] = ACTIONS(1616),
    [anon_sym_register] = ACTIONS(1616),
    [anon_sym_inline] = ACTIONS(1616),
    [anon_sym_const] = ACTIONS(1616),
    [anon_sym_restrict] = ACTIONS(1616),
    [anon_sym_volatile] = ACTIONS(1616),
    [anon_sym__Atomic] = ACTIONS(1616),
    [anon_sym_mutable] = ACTIONS(1616),
    [anon_sym_explicit] = ACTIONS(1616),
    [anon_sym_constexpr] = ACTIONS(1616),
    [anon_sym_unsigned] = ACTIONS(1616),
    [anon_sym_long] = ACTIONS(1616),
    [anon_sym_short] = ACTIONS(1616),
    [sym_primitive_type] = ACTIONS(1616),
    [anon_sym_enum] = ACTIONS(1616),
    [anon_sym_struct] = ACTIONS(1616),
    [anon_sym_union] = ACTIONS(1616),
    [anon_sym_if] = ACTIONS(1616),
    [anon_sym_else] = ACTIONS(1616),
    [anon_sym_switch] = ACTIONS(1616),
    [anon_sym_case] = ACTIONS(1616),
    [anon_sym_default] = ACTIONS(1616),
    [anon_sym_while] = ACTIONS(1616),
    [anon_sym_do] = ACTIONS(1616),
    [anon_sym_for] = ACTIONS(1616),
    [anon_sym_return] = ACTIONS(1616),
    [anon_sym_break] = ACTIONS(1616),
    [anon_sym_continue] = ACTIONS(1616),
    [anon_sym_goto] = ACTIONS(1616),
    [anon_sym_AMP] = ACTIONS(1614),
    [anon_sym_BANG] = ACTIONS(1614),
    [anon_sym_TILDE] = ACTIONS(1614),
    [anon_sym_PLUS] = ACTIONS(1616),
    [anon_sym_DASH] = ACTIONS(1616),
    [anon_sym_DASH_DASH] = ACTIONS(1614),
    [anon_sym_PLUS_PLUS] = ACTIONS(1614),
    [anon_sym_sizeof] = ACTIONS(1616),
    [sym_number_literal] = ACTIONS(1614),
    [sym_char_literal] = ACTIONS(1614),
    [sym_string_literal] = ACTIONS(1614),
    [sym_true] = ACTIONS(1616),
    [sym_false] = ACTIONS(1616),
    [sym_null] = ACTIONS(1616),
    [sym_identifier] = ACTIONS(1616),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(1616),
    [sym_auto] = ACTIONS(1616),
    [anon_sym_typename] = ACTIONS(1616),
    [anon_sym_new] = ACTIONS(1616),
    [anon_sym_COLON_COLON] = ACTIONS(1614),
    [anon_sym_delete] = ACTIONS(1616),
    [sym_nullptr] = ACTIONS(1616),
  },
  [2364] = {
    [sym_preproc_include] = STATE(2596),
    [sym_preproc_def] = STATE(2596),
    [sym_preproc_function_def] = STATE(2596),
    [sym_preproc_call] = STATE(2596),
    [sym_preproc_if_in_compound_statement] = STATE(410),
    [sym_preproc_ifdef_in_compound_statement] = STATE(411),
    [sym_declaration] = STATE(2596),
    [sym_type_definition] = STATE(2596),
    [sym__declaration_specifiers] = STATE(412),
    [sym_compound_statement] = STATE(2596),
    [sym_storage_class_specifier] = STATE(419),
    [sym_type_qualifier] = STATE(419),
    [sym__type_specifier] = STATE(30),
    [sym_sized_type_specifier] = STATE(30),
    [sym_enum_specifier] = STATE(30),
    [sym_struct_specifier] = STATE(30),
    [sym_union_specifier] = STATE(30),
    [sym_labeled_statement] = STATE(2596),
    [sym_expression_statement] = STATE(2596),
    [sym_if_statement] = STATE(2596),
    [sym_switch_statement] = STATE(2596),
    [sym_case_statement] = STATE(2596),
    [sym_while_statement] = STATE(2596),
    [sym_do_statement] = STATE(2596),
    [sym_for_statement] = STATE(2596),
    [sym_return_statement] = STATE(2596),
    [sym_break_statement] = STATE(2596),
    [sym_continue_statement] = STATE(2596),
    [sym_goto_statement] = STATE(2596),
    [sym__expression] = STATE(413),
    [sym_comma_expression] = STATE(414),
    [sym_conditional_expression] = STATE(413),
    [sym_assignment_expression] = STATE(413),
    [sym_pointer_expression] = STATE(413),
    [sym_logical_expression] = STATE(413),
    [sym_bitwise_expression] = STATE(413),
    [sym_equality_expression] = STATE(413),
    [sym_relational_expression] = STATE(413),
    [sym_shift_expression] = STATE(413),
    [sym_math_expression] = STATE(413),
    [sym_cast_expression] = STATE(413),
    [sym_sizeof_expression] = STATE(413),
    [sym_subscript_expression] = STATE(413),
    [sym_call_expression] = STATE(413),
    [sym_field_expression] = STATE(413),
    [sym_compound_literal_expression] = STATE(413),
    [sym_parenthesized_expression] = STATE(413),
    [sym_concatenated_string] = STATE(413),
    [sym__empty_declaration] = STATE(2596),
    [sym_macro_type_specifier] = STATE(30),
    [sym_class_specifier] = STATE(30),
    [sym_dependent_type] = STATE(30),
    [sym_structured_binding_declaration] = STATE(2596),
    [sym_template_type] = STATE(415),
    [sym_template_function] = STATE(413),
    [sym_for_range_loop] = STATE(2596),
    [sym_new_expression] = STATE(413),
    [sym_delete_expression] = STATE(413),
    [sym_lambda_expression] = STATE(413),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(416),
    [sym_scoped_namespace_identifier] = STATE(417),
    [aux_sym_preproc_if_in_compound_statement_repeat1] = STATE(2596),
    [aux_sym__declaration_specifiers_repeat1] = STATE(419),
    [aux_sym_sized_type_specifier_repeat1] = STATE(38),
    [sym_raw_string_literal] = ACTIONS(620),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(622),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(624),
    [anon_sym_LPAREN] = ACTIONS(626),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(628),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(630),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(632),
    [sym_preproc_directive] = ACTIONS(634),
    [anon_sym_SEMI] = ACTIONS(636),
    [anon_sym_typedef] = ACTIONS(638),
    [anon_sym_extern] = ACTIONS(154),
    [anon_sym_LBRACE] = ACTIONS(640),
    [anon_sym_RBRACE] = ACTIONS(6235),
    [anon_sym_STAR] = ACTIONS(644),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_static] = ACTIONS(154),
    [anon_sym_register] = ACTIONS(154),
    [anon_sym_inline] = ACTIONS(154),
    [anon_sym_const] = ACTIONS(158),
    [anon_sym_restrict] = ACTIONS(158),
    [anon_sym_volatile] = ACTIONS(158),
    [anon_sym__Atomic] = ACTIONS(158),
    [anon_sym_mutable] = ACTIONS(158),
    [anon_sym_explicit] = ACTIONS(158),
    [anon_sym_constexpr] = ACTIONS(158),
    [anon_sym_unsigned] = ACTIONS(31),
    [anon_sym_long] = ACTIONS(31),
    [anon_sym_short] = ACTIONS(31),
    [sym_primitive_type] = ACTIONS(33),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_union] = ACTIONS(39),
    [anon_sym_if] = ACTIONS(646),
    [anon_sym_switch] = ACTIONS(648),
    [anon_sym_case] = ACTIONS(650),
    [anon_sym_default] = ACTIONS(652),
    [anon_sym_while] = ACTIONS(654),
    [anon_sym_do] = ACTIONS(656),
    [anon_sym_for] = ACTIONS(658),
    [anon_sym_return] = ACTIONS(660),
    [anon_sym_break] = ACTIONS(662),
    [anon_sym_continue] = ACTIONS(664),
    [anon_sym_goto] = ACTIONS(666),
    [anon_sym_AMP] = ACTIONS(644),
    [anon_sym_BANG] = ACTIONS(668),
    [anon_sym_TILDE] = ACTIONS(670),
    [anon_sym_PLUS] = ACTIONS(672),
    [anon_sym_DASH] = ACTIONS(672),
    [anon_sym_DASH_DASH] = ACTIONS(674),
    [anon_sym_PLUS_PLUS] = ACTIONS(674),
    [anon_sym_sizeof] = ACTIONS(676),
    [sym_number_literal] = ACTIONS(620),
    [sym_char_literal] = ACTIONS(620),
    [sym_string_literal] = ACTIONS(678),
    [sym_true] = ACTIONS(680),
    [sym_false] = ACTIONS(680),
    [sym_null] = ACTIONS(680),
    [sym_identifier] = ACTIONS(682),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(51),
    [sym_auto] = ACTIONS(33),
    [anon_sym_typename] = ACTIONS(53),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(684),
    [anon_sym_delete] = ACTIONS(686),
    [sym_nullptr] = ACTIONS(680),
  },
  [2365] = {
    [anon_sym_LPAREN] = ACTIONS(6237),
    [anon_sym_constexpr] = ACTIONS(6239),
    [sym_comment] = ACTIONS(49),
  },
  [2366] = {
    [anon_sym_LPAREN] = ACTIONS(6241),
    [sym_comment] = ACTIONS(49),
  },
  [2367] = {
    [sym__expression] = STATE(2600),
    [sym_conditional_expression] = STATE(2600),
    [sym_assignment_expression] = STATE(2600),
    [sym_pointer_expression] = STATE(2600),
    [sym_logical_expression] = STATE(2600),
    [sym_bitwise_expression] = STATE(2600),
    [sym_equality_expression] = STATE(2600),
    [sym_relational_expression] = STATE(2600),
    [sym_shift_expression] = STATE(2600),
    [sym_math_expression] = STATE(2600),
    [sym_cast_expression] = STATE(2600),
    [sym_sizeof_expression] = STATE(2600),
    [sym_subscript_expression] = STATE(2600),
    [sym_call_expression] = STATE(2600),
    [sym_field_expression] = STATE(2600),
    [sym_compound_literal_expression] = STATE(2600),
    [sym_parenthesized_expression] = STATE(2600),
    [sym_concatenated_string] = STATE(2600),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(2600),
    [sym_new_expression] = STATE(2600),
    [sym_delete_expression] = STATE(2600),
    [sym_lambda_expression] = STATE(2600),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(855),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(6243),
    [anon_sym_LPAREN] = ACTIONS(1634),
    [anon_sym_STAR] = ACTIONS(1636),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_AMP] = ACTIONS(1636),
    [anon_sym_BANG] = ACTIONS(1638),
    [anon_sym_TILDE] = ACTIONS(1640),
    [anon_sym_PLUS] = ACTIONS(1642),
    [anon_sym_DASH] = ACTIONS(1642),
    [anon_sym_DASH_DASH] = ACTIONS(1644),
    [anon_sym_PLUS_PLUS] = ACTIONS(1644),
    [anon_sym_sizeof] = ACTIONS(1646),
    [sym_number_literal] = ACTIONS(6243),
    [sym_char_literal] = ACTIONS(6243),
    [sym_string_literal] = ACTIONS(1648),
    [sym_true] = ACTIONS(6245),
    [sym_false] = ACTIONS(6245),
    [sym_null] = ACTIONS(6245),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1652),
    [anon_sym_delete] = ACTIONS(1654),
    [sym_nullptr] = ACTIONS(6245),
  },
  [2368] = {
    [anon_sym_COLON] = ACTIONS(6247),
    [sym_comment] = ACTIONS(49),
  },
  [2369] = {
    [anon_sym_LPAREN] = ACTIONS(6249),
    [sym_comment] = ACTIONS(49),
  },
  [2370] = {
    [sym_compound_statement] = STATE(2603),
    [sym_labeled_statement] = STATE(2603),
    [sym_expression_statement] = STATE(2603),
    [sym_if_statement] = STATE(2603),
    [sym_switch_statement] = STATE(2603),
    [sym_case_statement] = STATE(2603),
    [sym_while_statement] = STATE(2603),
    [sym_do_statement] = STATE(2603),
    [sym_for_statement] = STATE(2603),
    [sym_return_statement] = STATE(2603),
    [sym_break_statement] = STATE(2603),
    [sym_continue_statement] = STATE(2603),
    [sym_goto_statement] = STATE(2603),
    [sym__expression] = STATE(873),
    [sym_comma_expression] = STATE(874),
    [sym_conditional_expression] = STATE(873),
    [sym_assignment_expression] = STATE(873),
    [sym_pointer_expression] = STATE(873),
    [sym_logical_expression] = STATE(873),
    [sym_bitwise_expression] = STATE(873),
    [sym_equality_expression] = STATE(873),
    [sym_relational_expression] = STATE(873),
    [sym_shift_expression] = STATE(873),
    [sym_math_expression] = STATE(873),
    [sym_cast_expression] = STATE(873),
    [sym_sizeof_expression] = STATE(873),
    [sym_subscript_expression] = STATE(873),
    [sym_call_expression] = STATE(873),
    [sym_field_expression] = STATE(873),
    [sym_compound_literal_expression] = STATE(873),
    [sym_parenthesized_expression] = STATE(873),
    [sym_concatenated_string] = STATE(873),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(873),
    [sym_for_range_loop] = STATE(2603),
    [sym_new_expression] = STATE(873),
    [sym_delete_expression] = STATE(873),
    [sym_lambda_expression] = STATE(873),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(1660),
    [anon_sym_LPAREN] = ACTIONS(626),
    [anon_sym_SEMI] = ACTIONS(1662),
    [anon_sym_LBRACE] = ACTIONS(1664),
    [anon_sym_STAR] = ACTIONS(644),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_if] = ACTIONS(1666),
    [anon_sym_switch] = ACTIONS(1668),
    [anon_sym_case] = ACTIONS(1670),
    [anon_sym_default] = ACTIONS(1672),
    [anon_sym_while] = ACTIONS(1674),
    [anon_sym_do] = ACTIONS(1676),
    [anon_sym_for] = ACTIONS(1678),
    [anon_sym_return] = ACTIONS(1680),
    [anon_sym_break] = ACTIONS(1682),
    [anon_sym_continue] = ACTIONS(1684),
    [anon_sym_goto] = ACTIONS(1686),
    [anon_sym_AMP] = ACTIONS(644),
    [anon_sym_BANG] = ACTIONS(668),
    [anon_sym_TILDE] = ACTIONS(670),
    [anon_sym_PLUS] = ACTIONS(672),
    [anon_sym_DASH] = ACTIONS(672),
    [anon_sym_DASH_DASH] = ACTIONS(674),
    [anon_sym_PLUS_PLUS] = ACTIONS(674),
    [anon_sym_sizeof] = ACTIONS(676),
    [sym_number_literal] = ACTIONS(1660),
    [sym_char_literal] = ACTIONS(1660),
    [sym_string_literal] = ACTIONS(678),
    [sym_true] = ACTIONS(1688),
    [sym_false] = ACTIONS(1688),
    [sym_null] = ACTIONS(1688),
    [sym_identifier] = ACTIONS(1690),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1303),
    [anon_sym_delete] = ACTIONS(686),
    [sym_nullptr] = ACTIONS(1688),
  },
  [2371] = {
    [anon_sym_LPAREN] = ACTIONS(6251),
    [sym_comment] = ACTIONS(49),
  },
  [2372] = {
    [sym__expression] = STATE(2606),
    [sym_conditional_expression] = STATE(2606),
    [sym_assignment_expression] = STATE(2606),
    [sym_pointer_expression] = STATE(2606),
    [sym_logical_expression] = STATE(2606),
    [sym_bitwise_expression] = STATE(2606),
    [sym_equality_expression] = STATE(2606),
    [sym_relational_expression] = STATE(2606),
    [sym_shift_expression] = STATE(2606),
    [sym_math_expression] = STATE(2606),
    [sym_cast_expression] = STATE(2606),
    [sym_sizeof_expression] = STATE(2606),
    [sym_subscript_expression] = STATE(2606),
    [sym_call_expression] = STATE(2606),
    [sym_field_expression] = STATE(2606),
    [sym_compound_literal_expression] = STATE(2606),
    [sym_parenthesized_expression] = STATE(2606),
    [sym_initializer_list] = STATE(2607),
    [sym_concatenated_string] = STATE(2606),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(2606),
    [sym_new_expression] = STATE(2606),
    [sym_delete_expression] = STATE(2606),
    [sym_lambda_expression] = STATE(2606),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(6253),
    [anon_sym_LPAREN] = ACTIONS(1347),
    [anon_sym_SEMI] = ACTIONS(6255),
    [anon_sym_LBRACE] = ACTIONS(548),
    [anon_sym_STAR] = ACTIONS(1349),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_AMP] = ACTIONS(1349),
    [anon_sym_BANG] = ACTIONS(1351),
    [anon_sym_TILDE] = ACTIONS(1353),
    [anon_sym_PLUS] = ACTIONS(1355),
    [anon_sym_DASH] = ACTIONS(1355),
    [anon_sym_DASH_DASH] = ACTIONS(1357),
    [anon_sym_PLUS_PLUS] = ACTIONS(1357),
    [anon_sym_sizeof] = ACTIONS(1359),
    [sym_number_literal] = ACTIONS(6253),
    [sym_char_literal] = ACTIONS(6253),
    [sym_string_literal] = ACTIONS(1361),
    [sym_true] = ACTIONS(6257),
    [sym_false] = ACTIONS(6257),
    [sym_null] = ACTIONS(6257),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1365),
    [anon_sym_delete] = ACTIONS(1367),
    [sym_nullptr] = ACTIONS(6257),
  },
  [2373] = {
    [anon_sym_SEMI] = ACTIONS(6259),
    [sym_comment] = ACTIONS(49),
  },
  [2374] = {
    [anon_sym_SEMI] = ACTIONS(6261),
    [sym_comment] = ACTIONS(49),
  },
  [2375] = {
    [sym_identifier] = ACTIONS(6263),
    [sym_comment] = ACTIONS(49),
  },
  [2376] = {
    [sym_initializer_list] = STATE(765),
    [sym_template_argument_list] = STATE(1097),
    [anon_sym_LPAREN] = ACTIONS(1477),
    [anon_sym_COMMA] = ACTIONS(1477),
    [anon_sym_SEMI] = ACTIONS(1477),
    [anon_sym_LBRACE] = ACTIONS(548),
    [anon_sym_STAR] = ACTIONS(1479),
    [anon_sym_LBRACK] = ACTIONS(1477),
    [anon_sym_EQ] = ACTIONS(1479),
    [anon_sym_COLON] = ACTIONS(6265),
    [anon_sym_QMARK] = ACTIONS(1477),
    [anon_sym_STAR_EQ] = ACTIONS(1477),
    [anon_sym_SLASH_EQ] = ACTIONS(1477),
    [anon_sym_PERCENT_EQ] = ACTIONS(1477),
    [anon_sym_PLUS_EQ] = ACTIONS(1477),
    [anon_sym_DASH_EQ] = ACTIONS(1477),
    [anon_sym_LT_LT_EQ] = ACTIONS(1477),
    [anon_sym_GT_GT_EQ] = ACTIONS(1477),
    [anon_sym_AMP_EQ] = ACTIONS(1477),
    [anon_sym_CARET_EQ] = ACTIONS(1477),
    [anon_sym_PIPE_EQ] = ACTIONS(1477),
    [anon_sym_AMP] = ACTIONS(1479),
    [anon_sym_PIPE_PIPE] = ACTIONS(1477),
    [anon_sym_AMP_AMP] = ACTIONS(1477),
    [anon_sym_PIPE] = ACTIONS(1479),
    [anon_sym_CARET] = ACTIONS(1479),
    [anon_sym_EQ_EQ] = ACTIONS(1477),
    [anon_sym_BANG_EQ] = ACTIONS(1477),
    [anon_sym_LT] = ACTIONS(1564),
    [anon_sym_GT] = ACTIONS(1479),
    [anon_sym_LT_EQ] = ACTIONS(1477),
    [anon_sym_GT_EQ] = ACTIONS(1477),
    [anon_sym_LT_LT] = ACTIONS(1479),
    [anon_sym_GT_GT] = ACTIONS(1479),
    [anon_sym_PLUS] = ACTIONS(1479),
    [anon_sym_DASH] = ACTIONS(1479),
    [anon_sym_SLASH] = ACTIONS(1479),
    [anon_sym_PERCENT] = ACTIONS(1479),
    [anon_sym_DASH_DASH] = ACTIONS(1477),
    [anon_sym_PLUS_PLUS] = ACTIONS(1477),
    [anon_sym_DOT] = ACTIONS(1477),
    [anon_sym_DASH_GT] = ACTIONS(1477),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(2218),
  },
  [2377] = {
    [sym_raw_string_literal] = ACTIONS(6267),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(6269),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(6269),
    [anon_sym_LPAREN] = ACTIONS(6267),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(6269),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(6269),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(6269),
    [sym_preproc_directive] = ACTIONS(6269),
    [anon_sym_SEMI] = ACTIONS(6267),
    [anon_sym_typedef] = ACTIONS(6269),
    [anon_sym_extern] = ACTIONS(6269),
    [anon_sym_LBRACE] = ACTIONS(6267),
    [anon_sym_RBRACE] = ACTIONS(6267),
    [anon_sym_STAR] = ACTIONS(6267),
    [anon_sym_LBRACK] = ACTIONS(6267),
    [anon_sym_static] = ACTIONS(6269),
    [anon_sym_register] = ACTIONS(6269),
    [anon_sym_inline] = ACTIONS(6269),
    [anon_sym_const] = ACTIONS(6269),
    [anon_sym_restrict] = ACTIONS(6269),
    [anon_sym_volatile] = ACTIONS(6269),
    [anon_sym__Atomic] = ACTIONS(6269),
    [anon_sym_mutable] = ACTIONS(6269),
    [anon_sym_explicit] = ACTIONS(6269),
    [anon_sym_constexpr] = ACTIONS(6269),
    [anon_sym_unsigned] = ACTIONS(6269),
    [anon_sym_long] = ACTIONS(6269),
    [anon_sym_short] = ACTIONS(6269),
    [sym_primitive_type] = ACTIONS(6269),
    [anon_sym_enum] = ACTIONS(6269),
    [anon_sym_struct] = ACTIONS(6269),
    [anon_sym_union] = ACTIONS(6269),
    [anon_sym_if] = ACTIONS(6269),
    [anon_sym_else] = ACTIONS(6271),
    [anon_sym_switch] = ACTIONS(6269),
    [anon_sym_case] = ACTIONS(6269),
    [anon_sym_default] = ACTIONS(6269),
    [anon_sym_while] = ACTIONS(6269),
    [anon_sym_do] = ACTIONS(6269),
    [anon_sym_for] = ACTIONS(6269),
    [anon_sym_return] = ACTIONS(6269),
    [anon_sym_break] = ACTIONS(6269),
    [anon_sym_continue] = ACTIONS(6269),
    [anon_sym_goto] = ACTIONS(6269),
    [anon_sym_AMP] = ACTIONS(6267),
    [anon_sym_BANG] = ACTIONS(6267),
    [anon_sym_TILDE] = ACTIONS(6267),
    [anon_sym_PLUS] = ACTIONS(6269),
    [anon_sym_DASH] = ACTIONS(6269),
    [anon_sym_DASH_DASH] = ACTIONS(6267),
    [anon_sym_PLUS_PLUS] = ACTIONS(6267),
    [anon_sym_sizeof] = ACTIONS(6269),
    [sym_number_literal] = ACTIONS(6267),
    [sym_char_literal] = ACTIONS(6267),
    [sym_string_literal] = ACTIONS(6267),
    [sym_true] = ACTIONS(6269),
    [sym_false] = ACTIONS(6269),
    [sym_null] = ACTIONS(6269),
    [sym_identifier] = ACTIONS(6269),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(6269),
    [sym_auto] = ACTIONS(6269),
    [anon_sym_typename] = ACTIONS(6269),
    [anon_sym_new] = ACTIONS(6269),
    [anon_sym_COLON_COLON] = ACTIONS(6267),
    [anon_sym_delete] = ACTIONS(6269),
    [sym_nullptr] = ACTIONS(6269),
  },
  [2378] = {
    [sym_argument_list] = STATE(802),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_COMMA] = ACTIONS(1740),
    [anon_sym_SEMI] = ACTIONS(6273),
    [anon_sym_STAR] = ACTIONS(1744),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_EQ] = ACTIONS(1746),
    [anon_sym_QMARK] = ACTIONS(1748),
    [anon_sym_STAR_EQ] = ACTIONS(1750),
    [anon_sym_SLASH_EQ] = ACTIONS(1750),
    [anon_sym_PERCENT_EQ] = ACTIONS(1750),
    [anon_sym_PLUS_EQ] = ACTIONS(1750),
    [anon_sym_DASH_EQ] = ACTIONS(1750),
    [anon_sym_LT_LT_EQ] = ACTIONS(1750),
    [anon_sym_GT_GT_EQ] = ACTIONS(1750),
    [anon_sym_AMP_EQ] = ACTIONS(1750),
    [anon_sym_CARET_EQ] = ACTIONS(1750),
    [anon_sym_PIPE_EQ] = ACTIONS(1750),
    [anon_sym_AMP] = ACTIONS(1752),
    [anon_sym_PIPE_PIPE] = ACTIONS(1754),
    [anon_sym_AMP_AMP] = ACTIONS(1756),
    [anon_sym_PIPE] = ACTIONS(1758),
    [anon_sym_CARET] = ACTIONS(1760),
    [anon_sym_EQ_EQ] = ACTIONS(1762),
    [anon_sym_BANG_EQ] = ACTIONS(1762),
    [anon_sym_LT] = ACTIONS(1764),
    [anon_sym_GT] = ACTIONS(1764),
    [anon_sym_LT_EQ] = ACTIONS(1766),
    [anon_sym_GT_EQ] = ACTIONS(1766),
    [anon_sym_LT_LT] = ACTIONS(1768),
    [anon_sym_GT_GT] = ACTIONS(1768),
    [anon_sym_PLUS] = ACTIONS(1770),
    [anon_sym_DASH] = ACTIONS(1770),
    [anon_sym_SLASH] = ACTIONS(1744),
    [anon_sym_PERCENT] = ACTIONS(1744),
    [anon_sym_DASH_DASH] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(1554),
    [anon_sym_DASH_GT] = ACTIONS(1554),
    [sym_comment] = ACTIONS(49),
  },
  [2379] = {
    [anon_sym_SEMI] = ACTIONS(6273),
    [sym_comment] = ACTIONS(49),
  },
  [2380] = {
    [sym_argument_list] = STATE(802),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_RPAREN] = ACTIONS(4280),
    [anon_sym_STAR] = ACTIONS(4537),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_EQ] = ACTIONS(4539),
    [anon_sym_QMARK] = ACTIONS(4280),
    [anon_sym_STAR_EQ] = ACTIONS(4543),
    [anon_sym_SLASH_EQ] = ACTIONS(4543),
    [anon_sym_PERCENT_EQ] = ACTIONS(4543),
    [anon_sym_PLUS_EQ] = ACTIONS(4543),
    [anon_sym_DASH_EQ] = ACTIONS(4543),
    [anon_sym_LT_LT_EQ] = ACTIONS(4543),
    [anon_sym_GT_GT_EQ] = ACTIONS(4543),
    [anon_sym_AMP_EQ] = ACTIONS(4543),
    [anon_sym_CARET_EQ] = ACTIONS(4543),
    [anon_sym_PIPE_EQ] = ACTIONS(4543),
    [anon_sym_AMP] = ACTIONS(4545),
    [anon_sym_PIPE_PIPE] = ACTIONS(4547),
    [anon_sym_AMP_AMP] = ACTIONS(4549),
    [anon_sym_PIPE] = ACTIONS(4551),
    [anon_sym_CARET] = ACTIONS(4553),
    [anon_sym_EQ_EQ] = ACTIONS(4555),
    [anon_sym_BANG_EQ] = ACTIONS(4555),
    [anon_sym_LT] = ACTIONS(4557),
    [anon_sym_GT] = ACTIONS(4557),
    [anon_sym_LT_EQ] = ACTIONS(4559),
    [anon_sym_GT_EQ] = ACTIONS(4559),
    [anon_sym_LT_LT] = ACTIONS(4561),
    [anon_sym_GT_GT] = ACTIONS(4561),
    [anon_sym_PLUS] = ACTIONS(4563),
    [anon_sym_DASH] = ACTIONS(4563),
    [anon_sym_SLASH] = ACTIONS(4537),
    [anon_sym_PERCENT] = ACTIONS(4537),
    [anon_sym_DASH_DASH] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(1554),
    [anon_sym_DASH_GT] = ACTIONS(1554),
    [sym_comment] = ACTIONS(49),
  },
  [2381] = {
    [sym_argument_list] = STATE(802),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_STAR] = ACTIONS(3003),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_EQ] = ACTIONS(3005),
    [anon_sym_COLON] = ACTIONS(6275),
    [anon_sym_QMARK] = ACTIONS(3009),
    [anon_sym_STAR_EQ] = ACTIONS(3011),
    [anon_sym_SLASH_EQ] = ACTIONS(3011),
    [anon_sym_PERCENT_EQ] = ACTIONS(3011),
    [anon_sym_PLUS_EQ] = ACTIONS(3011),
    [anon_sym_DASH_EQ] = ACTIONS(3011),
    [anon_sym_LT_LT_EQ] = ACTIONS(3011),
    [anon_sym_GT_GT_EQ] = ACTIONS(3011),
    [anon_sym_AMP_EQ] = ACTIONS(3011),
    [anon_sym_CARET_EQ] = ACTIONS(3011),
    [anon_sym_PIPE_EQ] = ACTIONS(3011),
    [anon_sym_AMP] = ACTIONS(3013),
    [anon_sym_PIPE_PIPE] = ACTIONS(3015),
    [anon_sym_AMP_AMP] = ACTIONS(3017),
    [anon_sym_PIPE] = ACTIONS(3019),
    [anon_sym_CARET] = ACTIONS(3021),
    [anon_sym_EQ_EQ] = ACTIONS(3023),
    [anon_sym_BANG_EQ] = ACTIONS(3023),
    [anon_sym_LT] = ACTIONS(3025),
    [anon_sym_GT] = ACTIONS(3025),
    [anon_sym_LT_EQ] = ACTIONS(3027),
    [anon_sym_GT_EQ] = ACTIONS(3027),
    [anon_sym_LT_LT] = ACTIONS(3029),
    [anon_sym_GT_GT] = ACTIONS(3029),
    [anon_sym_PLUS] = ACTIONS(3031),
    [anon_sym_DASH] = ACTIONS(3031),
    [anon_sym_SLASH] = ACTIONS(3003),
    [anon_sym_PERCENT] = ACTIONS(3003),
    [anon_sym_DASH_DASH] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(3033),
    [anon_sym_DASH_GT] = ACTIONS(3033),
    [sym_comment] = ACTIONS(49),
  },
  [2382] = {
    [sym_argument_list] = STATE(802),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_RPAREN] = ACTIONS(4284),
    [anon_sym_STAR] = ACTIONS(4537),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_EQ] = ACTIONS(4286),
    [anon_sym_QMARK] = ACTIONS(4284),
    [anon_sym_STAR_EQ] = ACTIONS(4284),
    [anon_sym_SLASH_EQ] = ACTIONS(4284),
    [anon_sym_PERCENT_EQ] = ACTIONS(4284),
    [anon_sym_PLUS_EQ] = ACTIONS(4284),
    [anon_sym_DASH_EQ] = ACTIONS(4284),
    [anon_sym_LT_LT_EQ] = ACTIONS(4284),
    [anon_sym_GT_GT_EQ] = ACTIONS(4284),
    [anon_sym_AMP_EQ] = ACTIONS(4284),
    [anon_sym_CARET_EQ] = ACTIONS(4284),
    [anon_sym_PIPE_EQ] = ACTIONS(4284),
    [anon_sym_AMP] = ACTIONS(4286),
    [anon_sym_PIPE_PIPE] = ACTIONS(4284),
    [anon_sym_AMP_AMP] = ACTIONS(4284),
    [anon_sym_PIPE] = ACTIONS(4286),
    [anon_sym_CARET] = ACTIONS(4286),
    [anon_sym_EQ_EQ] = ACTIONS(4555),
    [anon_sym_BANG_EQ] = ACTIONS(4555),
    [anon_sym_LT] = ACTIONS(4557),
    [anon_sym_GT] = ACTIONS(4557),
    [anon_sym_LT_EQ] = ACTIONS(4559),
    [anon_sym_GT_EQ] = ACTIONS(4559),
    [anon_sym_LT_LT] = ACTIONS(4561),
    [anon_sym_GT_GT] = ACTIONS(4561),
    [anon_sym_PLUS] = ACTIONS(4563),
    [anon_sym_DASH] = ACTIONS(4563),
    [anon_sym_SLASH] = ACTIONS(4537),
    [anon_sym_PERCENT] = ACTIONS(4537),
    [anon_sym_DASH_DASH] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(1554),
    [anon_sym_DASH_GT] = ACTIONS(1554),
    [sym_comment] = ACTIONS(49),
  },
  [2383] = {
    [sym_argument_list] = STATE(802),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_RPAREN] = ACTIONS(4288),
    [anon_sym_STAR] = ACTIONS(4537),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_EQ] = ACTIONS(4290),
    [anon_sym_QMARK] = ACTIONS(4288),
    [anon_sym_STAR_EQ] = ACTIONS(4288),
    [anon_sym_SLASH_EQ] = ACTIONS(4288),
    [anon_sym_PERCENT_EQ] = ACTIONS(4288),
    [anon_sym_PLUS_EQ] = ACTIONS(4288),
    [anon_sym_DASH_EQ] = ACTIONS(4288),
    [anon_sym_LT_LT_EQ] = ACTIONS(4288),
    [anon_sym_GT_GT_EQ] = ACTIONS(4288),
    [anon_sym_AMP_EQ] = ACTIONS(4288),
    [anon_sym_CARET_EQ] = ACTIONS(4288),
    [anon_sym_PIPE_EQ] = ACTIONS(4288),
    [anon_sym_AMP] = ACTIONS(4545),
    [anon_sym_PIPE_PIPE] = ACTIONS(4288),
    [anon_sym_AMP_AMP] = ACTIONS(4549),
    [anon_sym_PIPE] = ACTIONS(4551),
    [anon_sym_CARET] = ACTIONS(4553),
    [anon_sym_EQ_EQ] = ACTIONS(4555),
    [anon_sym_BANG_EQ] = ACTIONS(4555),
    [anon_sym_LT] = ACTIONS(4557),
    [anon_sym_GT] = ACTIONS(4557),
    [anon_sym_LT_EQ] = ACTIONS(4559),
    [anon_sym_GT_EQ] = ACTIONS(4559),
    [anon_sym_LT_LT] = ACTIONS(4561),
    [anon_sym_GT_GT] = ACTIONS(4561),
    [anon_sym_PLUS] = ACTIONS(4563),
    [anon_sym_DASH] = ACTIONS(4563),
    [anon_sym_SLASH] = ACTIONS(4537),
    [anon_sym_PERCENT] = ACTIONS(4537),
    [anon_sym_DASH_DASH] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(1554),
    [anon_sym_DASH_GT] = ACTIONS(1554),
    [sym_comment] = ACTIONS(49),
  },
  [2384] = {
    [sym_argument_list] = STATE(802),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_RPAREN] = ACTIONS(4288),
    [anon_sym_STAR] = ACTIONS(4537),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_EQ] = ACTIONS(4290),
    [anon_sym_QMARK] = ACTIONS(4288),
    [anon_sym_STAR_EQ] = ACTIONS(4288),
    [anon_sym_SLASH_EQ] = ACTIONS(4288),
    [anon_sym_PERCENT_EQ] = ACTIONS(4288),
    [anon_sym_PLUS_EQ] = ACTIONS(4288),
    [anon_sym_DASH_EQ] = ACTIONS(4288),
    [anon_sym_LT_LT_EQ] = ACTIONS(4288),
    [anon_sym_GT_GT_EQ] = ACTIONS(4288),
    [anon_sym_AMP_EQ] = ACTIONS(4288),
    [anon_sym_CARET_EQ] = ACTIONS(4288),
    [anon_sym_PIPE_EQ] = ACTIONS(4288),
    [anon_sym_AMP] = ACTIONS(4545),
    [anon_sym_PIPE_PIPE] = ACTIONS(4288),
    [anon_sym_AMP_AMP] = ACTIONS(4288),
    [anon_sym_PIPE] = ACTIONS(4551),
    [anon_sym_CARET] = ACTIONS(4553),
    [anon_sym_EQ_EQ] = ACTIONS(4555),
    [anon_sym_BANG_EQ] = ACTIONS(4555),
    [anon_sym_LT] = ACTIONS(4557),
    [anon_sym_GT] = ACTIONS(4557),
    [anon_sym_LT_EQ] = ACTIONS(4559),
    [anon_sym_GT_EQ] = ACTIONS(4559),
    [anon_sym_LT_LT] = ACTIONS(4561),
    [anon_sym_GT_GT] = ACTIONS(4561),
    [anon_sym_PLUS] = ACTIONS(4563),
    [anon_sym_DASH] = ACTIONS(4563),
    [anon_sym_SLASH] = ACTIONS(4537),
    [anon_sym_PERCENT] = ACTIONS(4537),
    [anon_sym_DASH_DASH] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(1554),
    [anon_sym_DASH_GT] = ACTIONS(1554),
    [sym_comment] = ACTIONS(49),
  },
  [2385] = {
    [sym_argument_list] = STATE(802),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_RPAREN] = ACTIONS(4284),
    [anon_sym_STAR] = ACTIONS(4537),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_EQ] = ACTIONS(4286),
    [anon_sym_QMARK] = ACTIONS(4284),
    [anon_sym_STAR_EQ] = ACTIONS(4284),
    [anon_sym_SLASH_EQ] = ACTIONS(4284),
    [anon_sym_PERCENT_EQ] = ACTIONS(4284),
    [anon_sym_PLUS_EQ] = ACTIONS(4284),
    [anon_sym_DASH_EQ] = ACTIONS(4284),
    [anon_sym_LT_LT_EQ] = ACTIONS(4284),
    [anon_sym_GT_GT_EQ] = ACTIONS(4284),
    [anon_sym_AMP_EQ] = ACTIONS(4284),
    [anon_sym_CARET_EQ] = ACTIONS(4284),
    [anon_sym_PIPE_EQ] = ACTIONS(4284),
    [anon_sym_AMP] = ACTIONS(4545),
    [anon_sym_PIPE_PIPE] = ACTIONS(4284),
    [anon_sym_AMP_AMP] = ACTIONS(4284),
    [anon_sym_PIPE] = ACTIONS(4286),
    [anon_sym_CARET] = ACTIONS(4553),
    [anon_sym_EQ_EQ] = ACTIONS(4555),
    [anon_sym_BANG_EQ] = ACTIONS(4555),
    [anon_sym_LT] = ACTIONS(4557),
    [anon_sym_GT] = ACTIONS(4557),
    [anon_sym_LT_EQ] = ACTIONS(4559),
    [anon_sym_GT_EQ] = ACTIONS(4559),
    [anon_sym_LT_LT] = ACTIONS(4561),
    [anon_sym_GT_GT] = ACTIONS(4561),
    [anon_sym_PLUS] = ACTIONS(4563),
    [anon_sym_DASH] = ACTIONS(4563),
    [anon_sym_SLASH] = ACTIONS(4537),
    [anon_sym_PERCENT] = ACTIONS(4537),
    [anon_sym_DASH_DASH] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(1554),
    [anon_sym_DASH_GT] = ACTIONS(1554),
    [sym_comment] = ACTIONS(49),
  },
  [2386] = {
    [sym_argument_list] = STATE(802),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_RPAREN] = ACTIONS(4284),
    [anon_sym_STAR] = ACTIONS(4537),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_EQ] = ACTIONS(4286),
    [anon_sym_QMARK] = ACTIONS(4284),
    [anon_sym_STAR_EQ] = ACTIONS(4284),
    [anon_sym_SLASH_EQ] = ACTIONS(4284),
    [anon_sym_PERCENT_EQ] = ACTIONS(4284),
    [anon_sym_PLUS_EQ] = ACTIONS(4284),
    [anon_sym_DASH_EQ] = ACTIONS(4284),
    [anon_sym_LT_LT_EQ] = ACTIONS(4284),
    [anon_sym_GT_GT_EQ] = ACTIONS(4284),
    [anon_sym_AMP_EQ] = ACTIONS(4284),
    [anon_sym_CARET_EQ] = ACTIONS(4284),
    [anon_sym_PIPE_EQ] = ACTIONS(4284),
    [anon_sym_AMP] = ACTIONS(4545),
    [anon_sym_PIPE_PIPE] = ACTIONS(4284),
    [anon_sym_AMP_AMP] = ACTIONS(4284),
    [anon_sym_PIPE] = ACTIONS(4286),
    [anon_sym_CARET] = ACTIONS(4286),
    [anon_sym_EQ_EQ] = ACTIONS(4555),
    [anon_sym_BANG_EQ] = ACTIONS(4555),
    [anon_sym_LT] = ACTIONS(4557),
    [anon_sym_GT] = ACTIONS(4557),
    [anon_sym_LT_EQ] = ACTIONS(4559),
    [anon_sym_GT_EQ] = ACTIONS(4559),
    [anon_sym_LT_LT] = ACTIONS(4561),
    [anon_sym_GT_GT] = ACTIONS(4561),
    [anon_sym_PLUS] = ACTIONS(4563),
    [anon_sym_DASH] = ACTIONS(4563),
    [anon_sym_SLASH] = ACTIONS(4537),
    [anon_sym_PERCENT] = ACTIONS(4537),
    [anon_sym_DASH_DASH] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(1554),
    [anon_sym_DASH_GT] = ACTIONS(1554),
    [sym_comment] = ACTIONS(49),
  },
  [2387] = {
    [sym_argument_list] = STATE(802),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_RPAREN] = ACTIONS(4292),
    [anon_sym_STAR] = ACTIONS(4537),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_EQ] = ACTIONS(4294),
    [anon_sym_QMARK] = ACTIONS(4292),
    [anon_sym_STAR_EQ] = ACTIONS(4292),
    [anon_sym_SLASH_EQ] = ACTIONS(4292),
    [anon_sym_PERCENT_EQ] = ACTIONS(4292),
    [anon_sym_PLUS_EQ] = ACTIONS(4292),
    [anon_sym_DASH_EQ] = ACTIONS(4292),
    [anon_sym_LT_LT_EQ] = ACTIONS(4292),
    [anon_sym_GT_GT_EQ] = ACTIONS(4292),
    [anon_sym_AMP_EQ] = ACTIONS(4292),
    [anon_sym_CARET_EQ] = ACTIONS(4292),
    [anon_sym_PIPE_EQ] = ACTIONS(4292),
    [anon_sym_AMP] = ACTIONS(4294),
    [anon_sym_PIPE_PIPE] = ACTIONS(4292),
    [anon_sym_AMP_AMP] = ACTIONS(4292),
    [anon_sym_PIPE] = ACTIONS(4294),
    [anon_sym_CARET] = ACTIONS(4294),
    [anon_sym_EQ_EQ] = ACTIONS(4292),
    [anon_sym_BANG_EQ] = ACTIONS(4292),
    [anon_sym_LT] = ACTIONS(4557),
    [anon_sym_GT] = ACTIONS(4557),
    [anon_sym_LT_EQ] = ACTIONS(4559),
    [anon_sym_GT_EQ] = ACTIONS(4559),
    [anon_sym_LT_LT] = ACTIONS(4561),
    [anon_sym_GT_GT] = ACTIONS(4561),
    [anon_sym_PLUS] = ACTIONS(4563),
    [anon_sym_DASH] = ACTIONS(4563),
    [anon_sym_SLASH] = ACTIONS(4537),
    [anon_sym_PERCENT] = ACTIONS(4537),
    [anon_sym_DASH_DASH] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(1554),
    [anon_sym_DASH_GT] = ACTIONS(1554),
    [sym_comment] = ACTIONS(49),
  },
  [2388] = {
    [sym_argument_list] = STATE(802),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_RPAREN] = ACTIONS(4296),
    [anon_sym_STAR] = ACTIONS(4537),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_EQ] = ACTIONS(4298),
    [anon_sym_QMARK] = ACTIONS(4296),
    [anon_sym_STAR_EQ] = ACTIONS(4296),
    [anon_sym_SLASH_EQ] = ACTIONS(4296),
    [anon_sym_PERCENT_EQ] = ACTIONS(4296),
    [anon_sym_PLUS_EQ] = ACTIONS(4296),
    [anon_sym_DASH_EQ] = ACTIONS(4296),
    [anon_sym_LT_LT_EQ] = ACTIONS(4296),
    [anon_sym_GT_GT_EQ] = ACTIONS(4296),
    [anon_sym_AMP_EQ] = ACTIONS(4296),
    [anon_sym_CARET_EQ] = ACTIONS(4296),
    [anon_sym_PIPE_EQ] = ACTIONS(4296),
    [anon_sym_AMP] = ACTIONS(4298),
    [anon_sym_PIPE_PIPE] = ACTIONS(4296),
    [anon_sym_AMP_AMP] = ACTIONS(4296),
    [anon_sym_PIPE] = ACTIONS(4298),
    [anon_sym_CARET] = ACTIONS(4298),
    [anon_sym_EQ_EQ] = ACTIONS(4296),
    [anon_sym_BANG_EQ] = ACTIONS(4296),
    [anon_sym_LT] = ACTIONS(4298),
    [anon_sym_GT] = ACTIONS(4298),
    [anon_sym_LT_EQ] = ACTIONS(4296),
    [anon_sym_GT_EQ] = ACTIONS(4296),
    [anon_sym_LT_LT] = ACTIONS(4561),
    [anon_sym_GT_GT] = ACTIONS(4561),
    [anon_sym_PLUS] = ACTIONS(4563),
    [anon_sym_DASH] = ACTIONS(4563),
    [anon_sym_SLASH] = ACTIONS(4537),
    [anon_sym_PERCENT] = ACTIONS(4537),
    [anon_sym_DASH_DASH] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(1554),
    [anon_sym_DASH_GT] = ACTIONS(1554),
    [sym_comment] = ACTIONS(49),
  },
  [2389] = {
    [sym_argument_list] = STATE(802),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_RPAREN] = ACTIONS(4300),
    [anon_sym_STAR] = ACTIONS(4537),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_EQ] = ACTIONS(4302),
    [anon_sym_QMARK] = ACTIONS(4300),
    [anon_sym_STAR_EQ] = ACTIONS(4300),
    [anon_sym_SLASH_EQ] = ACTIONS(4300),
    [anon_sym_PERCENT_EQ] = ACTIONS(4300),
    [anon_sym_PLUS_EQ] = ACTIONS(4300),
    [anon_sym_DASH_EQ] = ACTIONS(4300),
    [anon_sym_LT_LT_EQ] = ACTIONS(4300),
    [anon_sym_GT_GT_EQ] = ACTIONS(4300),
    [anon_sym_AMP_EQ] = ACTIONS(4300),
    [anon_sym_CARET_EQ] = ACTIONS(4300),
    [anon_sym_PIPE_EQ] = ACTIONS(4300),
    [anon_sym_AMP] = ACTIONS(4302),
    [anon_sym_PIPE_PIPE] = ACTIONS(4300),
    [anon_sym_AMP_AMP] = ACTIONS(4300),
    [anon_sym_PIPE] = ACTIONS(4302),
    [anon_sym_CARET] = ACTIONS(4302),
    [anon_sym_EQ_EQ] = ACTIONS(4300),
    [anon_sym_BANG_EQ] = ACTIONS(4300),
    [anon_sym_LT] = ACTIONS(4302),
    [anon_sym_GT] = ACTIONS(4302),
    [anon_sym_LT_EQ] = ACTIONS(4300),
    [anon_sym_GT_EQ] = ACTIONS(4300),
    [anon_sym_LT_LT] = ACTIONS(4302),
    [anon_sym_GT_GT] = ACTIONS(4302),
    [anon_sym_PLUS] = ACTIONS(4563),
    [anon_sym_DASH] = ACTIONS(4563),
    [anon_sym_SLASH] = ACTIONS(4537),
    [anon_sym_PERCENT] = ACTIONS(4537),
    [anon_sym_DASH_DASH] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(1554),
    [anon_sym_DASH_GT] = ACTIONS(1554),
    [sym_comment] = ACTIONS(49),
  },
  [2390] = {
    [sym_argument_list] = STATE(802),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_RPAREN] = ACTIONS(4274),
    [anon_sym_STAR] = ACTIONS(4537),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_EQ] = ACTIONS(4276),
    [anon_sym_QMARK] = ACTIONS(4274),
    [anon_sym_STAR_EQ] = ACTIONS(4274),
    [anon_sym_SLASH_EQ] = ACTIONS(4274),
    [anon_sym_PERCENT_EQ] = ACTIONS(4274),
    [anon_sym_PLUS_EQ] = ACTIONS(4274),
    [anon_sym_DASH_EQ] = ACTIONS(4274),
    [anon_sym_LT_LT_EQ] = ACTIONS(4274),
    [anon_sym_GT_GT_EQ] = ACTIONS(4274),
    [anon_sym_AMP_EQ] = ACTIONS(4274),
    [anon_sym_CARET_EQ] = ACTIONS(4274),
    [anon_sym_PIPE_EQ] = ACTIONS(4274),
    [anon_sym_AMP] = ACTIONS(4276),
    [anon_sym_PIPE_PIPE] = ACTIONS(4274),
    [anon_sym_AMP_AMP] = ACTIONS(4274),
    [anon_sym_PIPE] = ACTIONS(4276),
    [anon_sym_CARET] = ACTIONS(4276),
    [anon_sym_EQ_EQ] = ACTIONS(4274),
    [anon_sym_BANG_EQ] = ACTIONS(4274),
    [anon_sym_LT] = ACTIONS(4276),
    [anon_sym_GT] = ACTIONS(4276),
    [anon_sym_LT_EQ] = ACTIONS(4274),
    [anon_sym_GT_EQ] = ACTIONS(4274),
    [anon_sym_LT_LT] = ACTIONS(4276),
    [anon_sym_GT_GT] = ACTIONS(4276),
    [anon_sym_PLUS] = ACTIONS(4276),
    [anon_sym_DASH] = ACTIONS(4276),
    [anon_sym_SLASH] = ACTIONS(4537),
    [anon_sym_PERCENT] = ACTIONS(4537),
    [anon_sym_DASH_DASH] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(1554),
    [anon_sym_DASH_GT] = ACTIONS(1554),
    [sym_comment] = ACTIONS(49),
  },
  [2391] = {
    [sym_compound_statement] = STATE(2615),
    [sym_labeled_statement] = STATE(2615),
    [sym_expression_statement] = STATE(2615),
    [sym_if_statement] = STATE(2615),
    [sym_switch_statement] = STATE(2615),
    [sym_case_statement] = STATE(2615),
    [sym_while_statement] = STATE(2615),
    [sym_do_statement] = STATE(2615),
    [sym_for_statement] = STATE(2615),
    [sym_return_statement] = STATE(2615),
    [sym_break_statement] = STATE(2615),
    [sym_continue_statement] = STATE(2615),
    [sym_goto_statement] = STATE(2615),
    [sym__expression] = STATE(2378),
    [sym_comma_expression] = STATE(2379),
    [sym_conditional_expression] = STATE(2378),
    [sym_assignment_expression] = STATE(2378),
    [sym_pointer_expression] = STATE(2378),
    [sym_logical_expression] = STATE(2378),
    [sym_bitwise_expression] = STATE(2378),
    [sym_equality_expression] = STATE(2378),
    [sym_relational_expression] = STATE(2378),
    [sym_shift_expression] = STATE(2378),
    [sym_math_expression] = STATE(2378),
    [sym_cast_expression] = STATE(2378),
    [sym_sizeof_expression] = STATE(2378),
    [sym_subscript_expression] = STATE(2378),
    [sym_call_expression] = STATE(2378),
    [sym_field_expression] = STATE(2378),
    [sym_compound_literal_expression] = STATE(2378),
    [sym_parenthesized_expression] = STATE(2378),
    [sym_concatenated_string] = STATE(2378),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(2378),
    [sym_for_range_loop] = STATE(2615),
    [sym_new_expression] = STATE(2378),
    [sym_delete_expression] = STATE(2378),
    [sym_lambda_expression] = STATE(2378),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(5538),
    [anon_sym_LPAREN] = ACTIONS(626),
    [anon_sym_SEMI] = ACTIONS(5540),
    [anon_sym_LBRACE] = ACTIONS(5542),
    [anon_sym_STAR] = ACTIONS(644),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_if] = ACTIONS(5544),
    [anon_sym_switch] = ACTIONS(5546),
    [anon_sym_case] = ACTIONS(5548),
    [anon_sym_default] = ACTIONS(5550),
    [anon_sym_while] = ACTIONS(5552),
    [anon_sym_do] = ACTIONS(5554),
    [anon_sym_for] = ACTIONS(5556),
    [anon_sym_return] = ACTIONS(5558),
    [anon_sym_break] = ACTIONS(5560),
    [anon_sym_continue] = ACTIONS(5562),
    [anon_sym_goto] = ACTIONS(5564),
    [anon_sym_AMP] = ACTIONS(644),
    [anon_sym_BANG] = ACTIONS(668),
    [anon_sym_TILDE] = ACTIONS(670),
    [anon_sym_PLUS] = ACTIONS(672),
    [anon_sym_DASH] = ACTIONS(672),
    [anon_sym_DASH_DASH] = ACTIONS(674),
    [anon_sym_PLUS_PLUS] = ACTIONS(674),
    [anon_sym_sizeof] = ACTIONS(676),
    [sym_number_literal] = ACTIONS(5538),
    [sym_char_literal] = ACTIONS(5538),
    [sym_string_literal] = ACTIONS(678),
    [sym_true] = ACTIONS(5566),
    [sym_false] = ACTIONS(5566),
    [sym_null] = ACTIONS(5566),
    [sym_identifier] = ACTIONS(5568),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1303),
    [anon_sym_delete] = ACTIONS(686),
    [sym_nullptr] = ACTIONS(5566),
  },
  [2392] = {
    [sym_raw_string_literal] = ACTIONS(6277),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(6279),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(6279),
    [anon_sym_LPAREN] = ACTIONS(6277),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(6279),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(6279),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(6279),
    [sym_preproc_directive] = ACTIONS(6279),
    [anon_sym_SEMI] = ACTIONS(6277),
    [anon_sym_typedef] = ACTIONS(6279),
    [anon_sym_extern] = ACTIONS(6279),
    [anon_sym_LBRACE] = ACTIONS(6277),
    [anon_sym_RBRACE] = ACTIONS(6277),
    [anon_sym_STAR] = ACTIONS(6277),
    [anon_sym_LBRACK] = ACTIONS(6277),
    [anon_sym_static] = ACTIONS(6279),
    [anon_sym_register] = ACTIONS(6279),
    [anon_sym_inline] = ACTIONS(6279),
    [anon_sym_const] = ACTIONS(6279),
    [anon_sym_restrict] = ACTIONS(6279),
    [anon_sym_volatile] = ACTIONS(6279),
    [anon_sym__Atomic] = ACTIONS(6279),
    [anon_sym_mutable] = ACTIONS(6279),
    [anon_sym_explicit] = ACTIONS(6279),
    [anon_sym_constexpr] = ACTIONS(6279),
    [anon_sym_unsigned] = ACTIONS(6279),
    [anon_sym_long] = ACTIONS(6279),
    [anon_sym_short] = ACTIONS(6279),
    [sym_primitive_type] = ACTIONS(6279),
    [anon_sym_enum] = ACTIONS(6279),
    [anon_sym_struct] = ACTIONS(6279),
    [anon_sym_union] = ACTIONS(6279),
    [anon_sym_if] = ACTIONS(6279),
    [anon_sym_switch] = ACTIONS(6279),
    [anon_sym_case] = ACTIONS(6279),
    [anon_sym_default] = ACTIONS(6279),
    [anon_sym_while] = ACTIONS(6279),
    [anon_sym_do] = ACTIONS(6279),
    [anon_sym_for] = ACTIONS(6279),
    [anon_sym_return] = ACTIONS(6279),
    [anon_sym_break] = ACTIONS(6279),
    [anon_sym_continue] = ACTIONS(6279),
    [anon_sym_goto] = ACTIONS(6279),
    [anon_sym_AMP] = ACTIONS(6277),
    [anon_sym_BANG] = ACTIONS(6277),
    [anon_sym_TILDE] = ACTIONS(6277),
    [anon_sym_PLUS] = ACTIONS(6279),
    [anon_sym_DASH] = ACTIONS(6279),
    [anon_sym_DASH_DASH] = ACTIONS(6277),
    [anon_sym_PLUS_PLUS] = ACTIONS(6277),
    [anon_sym_sizeof] = ACTIONS(6279),
    [sym_number_literal] = ACTIONS(6277),
    [sym_char_literal] = ACTIONS(6277),
    [sym_string_literal] = ACTIONS(6277),
    [sym_true] = ACTIONS(6279),
    [sym_false] = ACTIONS(6279),
    [sym_null] = ACTIONS(6279),
    [sym_identifier] = ACTIONS(6279),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(6279),
    [sym_auto] = ACTIONS(6279),
    [anon_sym_typename] = ACTIONS(6279),
    [anon_sym_new] = ACTIONS(6279),
    [anon_sym_COLON_COLON] = ACTIONS(6277),
    [anon_sym_delete] = ACTIONS(6279),
    [sym_nullptr] = ACTIONS(6279),
  },
  [2393] = {
    [sym_argument_list] = STATE(802),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_STAR] = ACTIONS(5176),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_EQ] = ACTIONS(5176),
    [anon_sym_COLON] = ACTIONS(5174),
    [anon_sym_QMARK] = ACTIONS(5174),
    [anon_sym_STAR_EQ] = ACTIONS(5174),
    [anon_sym_SLASH_EQ] = ACTIONS(5174),
    [anon_sym_PERCENT_EQ] = ACTIONS(5174),
    [anon_sym_PLUS_EQ] = ACTIONS(5174),
    [anon_sym_DASH_EQ] = ACTIONS(5174),
    [anon_sym_LT_LT_EQ] = ACTIONS(5174),
    [anon_sym_GT_GT_EQ] = ACTIONS(5174),
    [anon_sym_AMP_EQ] = ACTIONS(5174),
    [anon_sym_CARET_EQ] = ACTIONS(5174),
    [anon_sym_PIPE_EQ] = ACTIONS(5174),
    [anon_sym_AMP] = ACTIONS(5176),
    [anon_sym_PIPE_PIPE] = ACTIONS(5174),
    [anon_sym_AMP_AMP] = ACTIONS(5174),
    [anon_sym_PIPE] = ACTIONS(5176),
    [anon_sym_CARET] = ACTIONS(5176),
    [anon_sym_EQ_EQ] = ACTIONS(5174),
    [anon_sym_BANG_EQ] = ACTIONS(5174),
    [anon_sym_LT] = ACTIONS(5176),
    [anon_sym_GT] = ACTIONS(5176),
    [anon_sym_LT_EQ] = ACTIONS(5174),
    [anon_sym_GT_EQ] = ACTIONS(5174),
    [anon_sym_LT_LT] = ACTIONS(5176),
    [anon_sym_GT_GT] = ACTIONS(5176),
    [anon_sym_PLUS] = ACTIONS(5176),
    [anon_sym_DASH] = ACTIONS(5176),
    [anon_sym_SLASH] = ACTIONS(5176),
    [anon_sym_PERCENT] = ACTIONS(5176),
    [anon_sym_DASH_DASH] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(3033),
    [anon_sym_DASH_GT] = ACTIONS(3033),
    [sym_comment] = ACTIONS(49),
  },
  [2394] = {
    [sym__expression] = STATE(2393),
    [sym_conditional_expression] = STATE(2393),
    [sym_assignment_expression] = STATE(2393),
    [sym_pointer_expression] = STATE(2393),
    [sym_logical_expression] = STATE(2393),
    [sym_bitwise_expression] = STATE(2393),
    [sym_equality_expression] = STATE(2393),
    [sym_relational_expression] = STATE(2393),
    [sym_shift_expression] = STATE(2393),
    [sym_math_expression] = STATE(2393),
    [sym_cast_expression] = STATE(2393),
    [sym_sizeof_expression] = STATE(2393),
    [sym_subscript_expression] = STATE(2393),
    [sym_call_expression] = STATE(2393),
    [sym_field_expression] = STATE(2393),
    [sym_compound_literal_expression] = STATE(2393),
    [sym_parenthesized_expression] = STATE(2393),
    [sym_initializer_list] = STATE(1835),
    [sym_concatenated_string] = STATE(2393),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(2393),
    [sym_new_expression] = STATE(2393),
    [sym_delete_expression] = STATE(2393),
    [sym_lambda_expression] = STATE(2393),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(855),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(5616),
    [anon_sym_LPAREN] = ACTIONS(1634),
    [anon_sym_LBRACE] = ACTIONS(548),
    [anon_sym_STAR] = ACTIONS(6281),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_EQ] = ACTIONS(5212),
    [anon_sym_COLON] = ACTIONS(5212),
    [anon_sym_QMARK] = ACTIONS(5210),
    [anon_sym_STAR_EQ] = ACTIONS(5210),
    [anon_sym_SLASH_EQ] = ACTIONS(5210),
    [anon_sym_PERCENT_EQ] = ACTIONS(5210),
    [anon_sym_PLUS_EQ] = ACTIONS(5210),
    [anon_sym_DASH_EQ] = ACTIONS(5210),
    [anon_sym_LT_LT_EQ] = ACTIONS(5210),
    [anon_sym_GT_GT_EQ] = ACTIONS(5210),
    [anon_sym_AMP_EQ] = ACTIONS(5210),
    [anon_sym_CARET_EQ] = ACTIONS(5210),
    [anon_sym_PIPE_EQ] = ACTIONS(5210),
    [anon_sym_AMP] = ACTIONS(6281),
    [anon_sym_PIPE_PIPE] = ACTIONS(5210),
    [anon_sym_AMP_AMP] = ACTIONS(5210),
    [anon_sym_BANG] = ACTIONS(6283),
    [anon_sym_PIPE] = ACTIONS(5212),
    [anon_sym_CARET] = ACTIONS(5212),
    [anon_sym_TILDE] = ACTIONS(1640),
    [anon_sym_EQ_EQ] = ACTIONS(5210),
    [anon_sym_BANG_EQ] = ACTIONS(5210),
    [anon_sym_LT] = ACTIONS(5212),
    [anon_sym_GT] = ACTIONS(5212),
    [anon_sym_LT_EQ] = ACTIONS(5210),
    [anon_sym_GT_EQ] = ACTIONS(5210),
    [anon_sym_LT_LT] = ACTIONS(5212),
    [anon_sym_GT_GT] = ACTIONS(5212),
    [anon_sym_PLUS] = ACTIONS(1642),
    [anon_sym_DASH] = ACTIONS(1642),
    [anon_sym_SLASH] = ACTIONS(5212),
    [anon_sym_PERCENT] = ACTIONS(5212),
    [anon_sym_DASH_DASH] = ACTIONS(1644),
    [anon_sym_PLUS_PLUS] = ACTIONS(1644),
    [anon_sym_sizeof] = ACTIONS(1646),
    [anon_sym_DOT] = ACTIONS(5210),
    [anon_sym_DASH_GT] = ACTIONS(5210),
    [sym_number_literal] = ACTIONS(5616),
    [sym_char_literal] = ACTIONS(5616),
    [sym_string_literal] = ACTIONS(1648),
    [sym_true] = ACTIONS(5618),
    [sym_false] = ACTIONS(5618),
    [sym_null] = ACTIONS(5618),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1652),
    [anon_sym_delete] = ACTIONS(1654),
    [sym_nullptr] = ACTIONS(5618),
  },
  [2395] = {
    [sym__expression] = STATE(2616),
    [sym_conditional_expression] = STATE(2616),
    [sym_assignment_expression] = STATE(2616),
    [sym_pointer_expression] = STATE(2616),
    [sym_logical_expression] = STATE(2616),
    [sym_bitwise_expression] = STATE(2616),
    [sym_equality_expression] = STATE(2616),
    [sym_relational_expression] = STATE(2616),
    [sym_shift_expression] = STATE(2616),
    [sym_math_expression] = STATE(2616),
    [sym_cast_expression] = STATE(2616),
    [sym_sizeof_expression] = STATE(2616),
    [sym_subscript_expression] = STATE(2616),
    [sym_call_expression] = STATE(2616),
    [sym_field_expression] = STATE(2616),
    [sym_compound_literal_expression] = STATE(2616),
    [sym_parenthesized_expression] = STATE(2616),
    [sym_concatenated_string] = STATE(2616),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(2616),
    [sym_new_expression] = STATE(2616),
    [sym_delete_expression] = STATE(2616),
    [sym_lambda_expression] = STATE(2616),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(855),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(6285),
    [anon_sym_LPAREN] = ACTIONS(2624),
    [anon_sym_STAR] = ACTIONS(2624),
    [anon_sym_LBRACK] = ACTIONS(2624),
    [anon_sym_AMP] = ACTIONS(2626),
    [anon_sym_AMP_AMP] = ACTIONS(2624),
    [anon_sym_BANG] = ACTIONS(1638),
    [anon_sym_TILDE] = ACTIONS(1640),
    [anon_sym_PLUS] = ACTIONS(1642),
    [anon_sym_DASH] = ACTIONS(1642),
    [anon_sym_DASH_DASH] = ACTIONS(1644),
    [anon_sym_PLUS_PLUS] = ACTIONS(1644),
    [anon_sym_sizeof] = ACTIONS(1646),
    [sym_number_literal] = ACTIONS(6285),
    [sym_char_literal] = ACTIONS(6285),
    [sym_string_literal] = ACTIONS(1648),
    [sym_true] = ACTIONS(6287),
    [sym_false] = ACTIONS(6287),
    [sym_null] = ACTIONS(6287),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1652),
    [anon_sym_delete] = ACTIONS(1654),
    [sym_nullptr] = ACTIONS(6287),
  },
  [2396] = {
    [sym_argument_list] = STATE(802),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_STAR] = ACTIONS(3003),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_EQ] = ACTIONS(5238),
    [anon_sym_COLON] = ACTIONS(5236),
    [anon_sym_QMARK] = ACTIONS(5236),
    [anon_sym_STAR_EQ] = ACTIONS(5236),
    [anon_sym_SLASH_EQ] = ACTIONS(5236),
    [anon_sym_PERCENT_EQ] = ACTIONS(5236),
    [anon_sym_PLUS_EQ] = ACTIONS(5236),
    [anon_sym_DASH_EQ] = ACTIONS(5236),
    [anon_sym_LT_LT_EQ] = ACTIONS(5236),
    [anon_sym_GT_GT_EQ] = ACTIONS(5236),
    [anon_sym_AMP_EQ] = ACTIONS(5236),
    [anon_sym_CARET_EQ] = ACTIONS(5236),
    [anon_sym_PIPE_EQ] = ACTIONS(5236),
    [anon_sym_AMP] = ACTIONS(3013),
    [anon_sym_PIPE_PIPE] = ACTIONS(3015),
    [anon_sym_AMP_AMP] = ACTIONS(3017),
    [anon_sym_PIPE] = ACTIONS(3019),
    [anon_sym_CARET] = ACTIONS(3021),
    [anon_sym_EQ_EQ] = ACTIONS(3023),
    [anon_sym_BANG_EQ] = ACTIONS(3023),
    [anon_sym_LT] = ACTIONS(3025),
    [anon_sym_GT] = ACTIONS(3025),
    [anon_sym_LT_EQ] = ACTIONS(3027),
    [anon_sym_GT_EQ] = ACTIONS(3027),
    [anon_sym_LT_LT] = ACTIONS(3029),
    [anon_sym_GT_GT] = ACTIONS(3029),
    [anon_sym_PLUS] = ACTIONS(3031),
    [anon_sym_DASH] = ACTIONS(3031),
    [anon_sym_SLASH] = ACTIONS(3003),
    [anon_sym_PERCENT] = ACTIONS(3003),
    [anon_sym_DASH_DASH] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(3033),
    [anon_sym_DASH_GT] = ACTIONS(3033),
    [sym_comment] = ACTIONS(49),
  },
  [2397] = {
    [sym__expression] = STATE(2617),
    [sym_conditional_expression] = STATE(2617),
    [sym_assignment_expression] = STATE(2617),
    [sym_pointer_expression] = STATE(2617),
    [sym_logical_expression] = STATE(2617),
    [sym_bitwise_expression] = STATE(2617),
    [sym_equality_expression] = STATE(2617),
    [sym_relational_expression] = STATE(2617),
    [sym_shift_expression] = STATE(2617),
    [sym_math_expression] = STATE(2617),
    [sym_cast_expression] = STATE(2617),
    [sym_sizeof_expression] = STATE(2617),
    [sym_subscript_expression] = STATE(2617),
    [sym_call_expression] = STATE(2617),
    [sym_field_expression] = STATE(2617),
    [sym_compound_literal_expression] = STATE(2617),
    [sym_parenthesized_expression] = STATE(2617),
    [sym_concatenated_string] = STATE(2617),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(2617),
    [sym_new_expression] = STATE(2617),
    [sym_delete_expression] = STATE(2617),
    [sym_lambda_expression] = STATE(2617),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(855),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(6289),
    [anon_sym_LPAREN] = ACTIONS(1634),
    [anon_sym_STAR] = ACTIONS(1636),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_AMP] = ACTIONS(1636),
    [anon_sym_BANG] = ACTIONS(1638),
    [anon_sym_TILDE] = ACTIONS(1640),
    [anon_sym_PLUS] = ACTIONS(1642),
    [anon_sym_DASH] = ACTIONS(1642),
    [anon_sym_DASH_DASH] = ACTIONS(1644),
    [anon_sym_PLUS_PLUS] = ACTIONS(1644),
    [anon_sym_sizeof] = ACTIONS(1646),
    [sym_number_literal] = ACTIONS(6289),
    [sym_char_literal] = ACTIONS(6289),
    [sym_string_literal] = ACTIONS(1648),
    [sym_true] = ACTIONS(6291),
    [sym_false] = ACTIONS(6291),
    [sym_null] = ACTIONS(6291),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1652),
    [anon_sym_delete] = ACTIONS(1654),
    [sym_nullptr] = ACTIONS(6291),
  },
  [2398] = {
    [anon_sym_LPAREN] = ACTIONS(1137),
    [anon_sym_COMMA] = ACTIONS(1146),
    [anon_sym_SEMI] = ACTIONS(1146),
    [anon_sym_extern] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(1140),
    [anon_sym_STAR] = ACTIONS(4239),
    [anon_sym_LBRACK] = ACTIONS(1146),
    [anon_sym_EQ] = ACTIONS(1148),
    [anon_sym_static] = ACTIONS(1142),
    [anon_sym_register] = ACTIONS(1142),
    [anon_sym_inline] = ACTIONS(1142),
    [anon_sym_const] = ACTIONS(1142),
    [anon_sym_restrict] = ACTIONS(1142),
    [anon_sym_volatile] = ACTIONS(1142),
    [anon_sym__Atomic] = ACTIONS(1142),
    [anon_sym_mutable] = ACTIONS(1142),
    [anon_sym_explicit] = ACTIONS(1142),
    [anon_sym_constexpr] = ACTIONS(1142),
    [anon_sym_QMARK] = ACTIONS(1146),
    [anon_sym_STAR_EQ] = ACTIONS(1146),
    [anon_sym_SLASH_EQ] = ACTIONS(1146),
    [anon_sym_PERCENT_EQ] = ACTIONS(1146),
    [anon_sym_PLUS_EQ] = ACTIONS(1146),
    [anon_sym_DASH_EQ] = ACTIONS(1146),
    [anon_sym_LT_LT_EQ] = ACTIONS(1146),
    [anon_sym_GT_GT_EQ] = ACTIONS(1146),
    [anon_sym_AMP_EQ] = ACTIONS(1146),
    [anon_sym_CARET_EQ] = ACTIONS(1146),
    [anon_sym_PIPE_EQ] = ACTIONS(1146),
    [anon_sym_AMP] = ACTIONS(4239),
    [anon_sym_PIPE_PIPE] = ACTIONS(1146),
    [anon_sym_AMP_AMP] = ACTIONS(1137),
    [anon_sym_PIPE] = ACTIONS(1148),
    [anon_sym_CARET] = ACTIONS(1148),
    [anon_sym_TILDE] = ACTIONS(1140),
    [anon_sym_EQ_EQ] = ACTIONS(1146),
    [anon_sym_BANG_EQ] = ACTIONS(1146),
    [anon_sym_LT] = ACTIONS(4239),
    [anon_sym_GT] = ACTIONS(1148),
    [anon_sym_LT_EQ] = ACTIONS(1146),
    [anon_sym_GT_EQ] = ACTIONS(1146),
    [anon_sym_LT_LT] = ACTIONS(1148),
    [anon_sym_GT_GT] = ACTIONS(1148),
    [anon_sym_PLUS] = ACTIONS(1148),
    [anon_sym_DASH] = ACTIONS(1148),
    [anon_sym_SLASH] = ACTIONS(1148),
    [anon_sym_PERCENT] = ACTIONS(1148),
    [anon_sym_DASH_DASH] = ACTIONS(1146),
    [anon_sym_PLUS_PLUS] = ACTIONS(1146),
    [anon_sym_DOT] = ACTIONS(1146),
    [anon_sym_DASH_GT] = ACTIONS(1146),
    [sym_identifier] = ACTIONS(1142),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(1144),
    [sym_operator_name] = ACTIONS(1140),
  },
  [2399] = {
    [anon_sym_LPAREN] = ACTIONS(1798),
    [anon_sym_COMMA] = ACTIONS(1807),
    [anon_sym_SEMI] = ACTIONS(1807),
    [anon_sym_extern] = ACTIONS(1803),
    [anon_sym_LBRACE] = ACTIONS(1801),
    [anon_sym_STAR] = ACTIONS(4317),
    [anon_sym_LBRACK] = ACTIONS(1807),
    [anon_sym_EQ] = ACTIONS(1809),
    [anon_sym_static] = ACTIONS(1803),
    [anon_sym_register] = ACTIONS(1803),
    [anon_sym_inline] = ACTIONS(1803),
    [anon_sym_const] = ACTIONS(1803),
    [anon_sym_restrict] = ACTIONS(1803),
    [anon_sym_volatile] = ACTIONS(1803),
    [anon_sym__Atomic] = ACTIONS(1803),
    [anon_sym_mutable] = ACTIONS(1803),
    [anon_sym_explicit] = ACTIONS(1803),
    [anon_sym_constexpr] = ACTIONS(1803),
    [anon_sym_QMARK] = ACTIONS(1807),
    [anon_sym_STAR_EQ] = ACTIONS(1807),
    [anon_sym_SLASH_EQ] = ACTIONS(1807),
    [anon_sym_PERCENT_EQ] = ACTIONS(1807),
    [anon_sym_PLUS_EQ] = ACTIONS(1807),
    [anon_sym_DASH_EQ] = ACTIONS(1807),
    [anon_sym_LT_LT_EQ] = ACTIONS(1807),
    [anon_sym_GT_GT_EQ] = ACTIONS(1807),
    [anon_sym_AMP_EQ] = ACTIONS(1807),
    [anon_sym_CARET_EQ] = ACTIONS(1807),
    [anon_sym_PIPE_EQ] = ACTIONS(1807),
    [anon_sym_AMP] = ACTIONS(4317),
    [anon_sym_PIPE_PIPE] = ACTIONS(1807),
    [anon_sym_AMP_AMP] = ACTIONS(1798),
    [anon_sym_PIPE] = ACTIONS(1809),
    [anon_sym_CARET] = ACTIONS(1809),
    [anon_sym_TILDE] = ACTIONS(1801),
    [anon_sym_EQ_EQ] = ACTIONS(1807),
    [anon_sym_BANG_EQ] = ACTIONS(1807),
    [anon_sym_LT] = ACTIONS(4317),
    [anon_sym_GT] = ACTIONS(1809),
    [anon_sym_LT_EQ] = ACTIONS(1807),
    [anon_sym_GT_EQ] = ACTIONS(1807),
    [anon_sym_LT_LT] = ACTIONS(1809),
    [anon_sym_GT_GT] = ACTIONS(1809),
    [anon_sym_PLUS] = ACTIONS(1809),
    [anon_sym_DASH] = ACTIONS(1809),
    [anon_sym_SLASH] = ACTIONS(1809),
    [anon_sym_PERCENT] = ACTIONS(1809),
    [anon_sym_DASH_DASH] = ACTIONS(1807),
    [anon_sym_PLUS_PLUS] = ACTIONS(1807),
    [anon_sym_DOT] = ACTIONS(1807),
    [anon_sym_DASH_GT] = ACTIONS(1807),
    [sym_identifier] = ACTIONS(1803),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(1805),
    [sym_operator_name] = ACTIONS(1801),
  },
  [2400] = {
    [sym_raw_string_literal] = ACTIONS(6293),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(6295),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(6295),
    [anon_sym_LPAREN] = ACTIONS(6293),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(6295),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(6295),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(6295),
    [sym_preproc_directive] = ACTIONS(6295),
    [anon_sym_SEMI] = ACTIONS(6293),
    [anon_sym_typedef] = ACTIONS(6295),
    [anon_sym_extern] = ACTIONS(6295),
    [anon_sym_LBRACE] = ACTIONS(6293),
    [anon_sym_RBRACE] = ACTIONS(6293),
    [anon_sym_STAR] = ACTIONS(6293),
    [anon_sym_LBRACK] = ACTIONS(6293),
    [anon_sym_static] = ACTIONS(6295),
    [anon_sym_register] = ACTIONS(6295),
    [anon_sym_inline] = ACTIONS(6295),
    [anon_sym_const] = ACTIONS(6295),
    [anon_sym_restrict] = ACTIONS(6295),
    [anon_sym_volatile] = ACTIONS(6295),
    [anon_sym__Atomic] = ACTIONS(6295),
    [anon_sym_mutable] = ACTIONS(6295),
    [anon_sym_explicit] = ACTIONS(6295),
    [anon_sym_constexpr] = ACTIONS(6295),
    [anon_sym_unsigned] = ACTIONS(6295),
    [anon_sym_long] = ACTIONS(6295),
    [anon_sym_short] = ACTIONS(6295),
    [sym_primitive_type] = ACTIONS(6295),
    [anon_sym_enum] = ACTIONS(6295),
    [anon_sym_struct] = ACTIONS(6295),
    [anon_sym_union] = ACTIONS(6295),
    [anon_sym_if] = ACTIONS(6295),
    [anon_sym_switch] = ACTIONS(6295),
    [anon_sym_case] = ACTIONS(6295),
    [anon_sym_default] = ACTIONS(6295),
    [anon_sym_while] = ACTIONS(6295),
    [anon_sym_do] = ACTIONS(6295),
    [anon_sym_for] = ACTIONS(6295),
    [anon_sym_return] = ACTIONS(6295),
    [anon_sym_break] = ACTIONS(6295),
    [anon_sym_continue] = ACTIONS(6295),
    [anon_sym_goto] = ACTIONS(6295),
    [anon_sym_AMP] = ACTIONS(6293),
    [anon_sym_BANG] = ACTIONS(6293),
    [anon_sym_TILDE] = ACTIONS(6293),
    [anon_sym_PLUS] = ACTIONS(6295),
    [anon_sym_DASH] = ACTIONS(6295),
    [anon_sym_DASH_DASH] = ACTIONS(6293),
    [anon_sym_PLUS_PLUS] = ACTIONS(6293),
    [anon_sym_sizeof] = ACTIONS(6295),
    [sym_number_literal] = ACTIONS(6293),
    [sym_char_literal] = ACTIONS(6293),
    [sym_string_literal] = ACTIONS(6293),
    [sym_true] = ACTIONS(6295),
    [sym_false] = ACTIONS(6295),
    [sym_null] = ACTIONS(6295),
    [sym_identifier] = ACTIONS(6295),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(6295),
    [sym_auto] = ACTIONS(6295),
    [anon_sym_typename] = ACTIONS(6295),
    [anon_sym_new] = ACTIONS(6295),
    [anon_sym_COLON_COLON] = ACTIONS(6293),
    [anon_sym_delete] = ACTIONS(6295),
    [sym_nullptr] = ACTIONS(6295),
  },
  [2401] = {
    [sym_compound_statement] = STATE(2625),
    [sym_labeled_statement] = STATE(2625),
    [sym_expression_statement] = STATE(2625),
    [sym_if_statement] = STATE(2625),
    [sym_switch_statement] = STATE(2625),
    [sym_case_statement] = STATE(2625),
    [sym_while_statement] = STATE(2625),
    [sym_do_statement] = STATE(2625),
    [sym_for_statement] = STATE(2625),
    [sym_return_statement] = STATE(2625),
    [sym_break_statement] = STATE(2625),
    [sym_continue_statement] = STATE(2625),
    [sym_goto_statement] = STATE(2625),
    [sym__expression] = STATE(873),
    [sym_comma_expression] = STATE(874),
    [sym_conditional_expression] = STATE(873),
    [sym_assignment_expression] = STATE(873),
    [sym_pointer_expression] = STATE(873),
    [sym_logical_expression] = STATE(873),
    [sym_bitwise_expression] = STATE(873),
    [sym_equality_expression] = STATE(873),
    [sym_relational_expression] = STATE(873),
    [sym_shift_expression] = STATE(873),
    [sym_math_expression] = STATE(873),
    [sym_cast_expression] = STATE(873),
    [sym_sizeof_expression] = STATE(873),
    [sym_subscript_expression] = STATE(873),
    [sym_call_expression] = STATE(873),
    [sym_field_expression] = STATE(873),
    [sym_compound_literal_expression] = STATE(873),
    [sym_parenthesized_expression] = STATE(873),
    [sym_concatenated_string] = STATE(873),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(873),
    [sym_for_range_loop] = STATE(2625),
    [sym_new_expression] = STATE(873),
    [sym_delete_expression] = STATE(873),
    [sym_lambda_expression] = STATE(873),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(1660),
    [anon_sym_LPAREN] = ACTIONS(626),
    [anon_sym_SEMI] = ACTIONS(1662),
    [anon_sym_LBRACE] = ACTIONS(1664),
    [anon_sym_STAR] = ACTIONS(644),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_if] = ACTIONS(6297),
    [anon_sym_switch] = ACTIONS(6299),
    [anon_sym_case] = ACTIONS(6301),
    [anon_sym_default] = ACTIONS(6303),
    [anon_sym_while] = ACTIONS(6305),
    [anon_sym_do] = ACTIONS(1676),
    [anon_sym_for] = ACTIONS(6307),
    [anon_sym_return] = ACTIONS(1680),
    [anon_sym_break] = ACTIONS(1682),
    [anon_sym_continue] = ACTIONS(1684),
    [anon_sym_goto] = ACTIONS(1686),
    [anon_sym_AMP] = ACTIONS(644),
    [anon_sym_BANG] = ACTIONS(668),
    [anon_sym_TILDE] = ACTIONS(670),
    [anon_sym_PLUS] = ACTIONS(672),
    [anon_sym_DASH] = ACTIONS(672),
    [anon_sym_DASH_DASH] = ACTIONS(674),
    [anon_sym_PLUS_PLUS] = ACTIONS(674),
    [anon_sym_sizeof] = ACTIONS(676),
    [sym_number_literal] = ACTIONS(1660),
    [sym_char_literal] = ACTIONS(1660),
    [sym_string_literal] = ACTIONS(678),
    [sym_true] = ACTIONS(1688),
    [sym_false] = ACTIONS(1688),
    [sym_null] = ACTIONS(1688),
    [sym_identifier] = ACTIONS(6309),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1303),
    [anon_sym_delete] = ACTIONS(686),
    [sym_nullptr] = ACTIONS(1688),
  },
  [2402] = {
    [sym_argument_list] = STATE(802),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_RPAREN] = ACTIONS(6311),
    [anon_sym_STAR] = ACTIONS(4537),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_EQ] = ACTIONS(4539),
    [anon_sym_QMARK] = ACTIONS(4541),
    [anon_sym_STAR_EQ] = ACTIONS(4543),
    [anon_sym_SLASH_EQ] = ACTIONS(4543),
    [anon_sym_PERCENT_EQ] = ACTIONS(4543),
    [anon_sym_PLUS_EQ] = ACTIONS(4543),
    [anon_sym_DASH_EQ] = ACTIONS(4543),
    [anon_sym_LT_LT_EQ] = ACTIONS(4543),
    [anon_sym_GT_GT_EQ] = ACTIONS(4543),
    [anon_sym_AMP_EQ] = ACTIONS(4543),
    [anon_sym_CARET_EQ] = ACTIONS(4543),
    [anon_sym_PIPE_EQ] = ACTIONS(4543),
    [anon_sym_AMP] = ACTIONS(4545),
    [anon_sym_PIPE_PIPE] = ACTIONS(4547),
    [anon_sym_AMP_AMP] = ACTIONS(4549),
    [anon_sym_PIPE] = ACTIONS(4551),
    [anon_sym_CARET] = ACTIONS(4553),
    [anon_sym_EQ_EQ] = ACTIONS(4555),
    [anon_sym_BANG_EQ] = ACTIONS(4555),
    [anon_sym_LT] = ACTIONS(4557),
    [anon_sym_GT] = ACTIONS(4557),
    [anon_sym_LT_EQ] = ACTIONS(4559),
    [anon_sym_GT_EQ] = ACTIONS(4559),
    [anon_sym_LT_LT] = ACTIONS(4561),
    [anon_sym_GT_GT] = ACTIONS(4561),
    [anon_sym_PLUS] = ACTIONS(4563),
    [anon_sym_DASH] = ACTIONS(4563),
    [anon_sym_SLASH] = ACTIONS(4537),
    [anon_sym_PERCENT] = ACTIONS(4537),
    [anon_sym_DASH_DASH] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(1554),
    [anon_sym_DASH_GT] = ACTIONS(1554),
    [sym_comment] = ACTIONS(49),
  },
  [2403] = {
    [sym_compound_statement] = STATE(2627),
    [sym_labeled_statement] = STATE(2627),
    [sym_expression_statement] = STATE(2627),
    [sym_if_statement] = STATE(2627),
    [sym_switch_statement] = STATE(2627),
    [sym_case_statement] = STATE(2627),
    [sym_while_statement] = STATE(2627),
    [sym_do_statement] = STATE(2627),
    [sym_for_statement] = STATE(2627),
    [sym_return_statement] = STATE(2627),
    [sym_break_statement] = STATE(2627),
    [sym_continue_statement] = STATE(2627),
    [sym_goto_statement] = STATE(2627),
    [sym__expression] = STATE(873),
    [sym_comma_expression] = STATE(874),
    [sym_conditional_expression] = STATE(873),
    [sym_assignment_expression] = STATE(873),
    [sym_pointer_expression] = STATE(873),
    [sym_logical_expression] = STATE(873),
    [sym_bitwise_expression] = STATE(873),
    [sym_equality_expression] = STATE(873),
    [sym_relational_expression] = STATE(873),
    [sym_shift_expression] = STATE(873),
    [sym_math_expression] = STATE(873),
    [sym_cast_expression] = STATE(873),
    [sym_sizeof_expression] = STATE(873),
    [sym_subscript_expression] = STATE(873),
    [sym_call_expression] = STATE(873),
    [sym_field_expression] = STATE(873),
    [sym_compound_literal_expression] = STATE(873),
    [sym_parenthesized_expression] = STATE(873),
    [sym_concatenated_string] = STATE(873),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(873),
    [sym_for_range_loop] = STATE(2627),
    [sym_new_expression] = STATE(873),
    [sym_delete_expression] = STATE(873),
    [sym_lambda_expression] = STATE(873),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(1660),
    [anon_sym_LPAREN] = ACTIONS(626),
    [anon_sym_SEMI] = ACTIONS(1662),
    [anon_sym_LBRACE] = ACTIONS(1664),
    [anon_sym_STAR] = ACTIONS(644),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_if] = ACTIONS(1666),
    [anon_sym_switch] = ACTIONS(1668),
    [anon_sym_case] = ACTIONS(1670),
    [anon_sym_default] = ACTIONS(1672),
    [anon_sym_while] = ACTIONS(1674),
    [anon_sym_do] = ACTIONS(1676),
    [anon_sym_for] = ACTIONS(1678),
    [anon_sym_return] = ACTIONS(1680),
    [anon_sym_break] = ACTIONS(1682),
    [anon_sym_continue] = ACTIONS(1684),
    [anon_sym_goto] = ACTIONS(1686),
    [anon_sym_AMP] = ACTIONS(644),
    [anon_sym_BANG] = ACTIONS(668),
    [anon_sym_TILDE] = ACTIONS(670),
    [anon_sym_PLUS] = ACTIONS(672),
    [anon_sym_DASH] = ACTIONS(672),
    [anon_sym_DASH_DASH] = ACTIONS(674),
    [anon_sym_PLUS_PLUS] = ACTIONS(674),
    [anon_sym_sizeof] = ACTIONS(676),
    [sym_number_literal] = ACTIONS(1660),
    [sym_char_literal] = ACTIONS(1660),
    [sym_string_literal] = ACTIONS(678),
    [sym_true] = ACTIONS(1688),
    [sym_false] = ACTIONS(1688),
    [sym_null] = ACTIONS(1688),
    [sym_identifier] = ACTIONS(1690),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1303),
    [anon_sym_delete] = ACTIONS(686),
    [sym_nullptr] = ACTIONS(1688),
  },
  [2404] = {
    [anon_sym_else] = ACTIONS(5631),
    [anon_sym_while] = ACTIONS(5631),
    [sym_comment] = ACTIONS(49),
  },
  [2405] = {
    [sym__type_declarator] = STATE(2628),
    [sym_pointer_type_declarator] = STATE(213),
    [sym_function_type_declarator] = STATE(214),
    [sym_array_type_declarator] = STATE(215),
    [anon_sym_LPAREN] = ACTIONS(327),
    [anon_sym_STAR] = ACTIONS(329),
    [sym_identifier] = ACTIONS(331),
    [sym_comment] = ACTIONS(49),
  },
  [2406] = {
    [sym_type_qualifier] = STATE(219),
    [sym__type_specifier] = STATE(2629),
    [sym_sized_type_specifier] = STATE(2629),
    [sym_enum_specifier] = STATE(2629),
    [sym_struct_specifier] = STATE(2629),
    [sym_union_specifier] = STATE(2629),
    [sym_macro_type_specifier] = STATE(2629),
    [sym_class_specifier] = STATE(2629),
    [sym_dependent_type] = STATE(2629),
    [sym_template_type] = STATE(62),
    [sym_scoped_type_identifier] = STATE(63),
    [sym_scoped_namespace_identifier] = STATE(64),
    [aux_sym_type_definition_repeat1] = STATE(219),
    [aux_sym_sized_type_specifier_repeat1] = STATE(66),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_restrict] = ACTIONS(93),
    [anon_sym_volatile] = ACTIONS(93),
    [anon_sym__Atomic] = ACTIONS(93),
    [anon_sym_mutable] = ACTIONS(93),
    [anon_sym_explicit] = ACTIONS(93),
    [anon_sym_constexpr] = ACTIONS(93),
    [anon_sym_unsigned] = ACTIONS(95),
    [anon_sym_long] = ACTIONS(95),
    [anon_sym_short] = ACTIONS(95),
    [sym_primitive_type] = ACTIONS(6313),
    [anon_sym_enum] = ACTIONS(99),
    [anon_sym_struct] = ACTIONS(101),
    [anon_sym_union] = ACTIONS(103),
    [sym_identifier] = ACTIONS(105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(107),
    [sym_auto] = ACTIONS(6313),
    [anon_sym_typename] = ACTIONS(109),
    [anon_sym_COLON_COLON] = ACTIONS(111),
  },
  [2407] = {
    [sym_parameter_list] = STATE(332),
    [sym_argument_list] = STATE(333),
    [sym_initializer_list] = STATE(333),
    [aux_sym_declaration_repeat1] = STATE(2631),
    [anon_sym_LPAREN] = ACTIONS(536),
    [anon_sym_COMMA] = ACTIONS(538),
    [anon_sym_SEMI] = ACTIONS(6315),
    [anon_sym_LBRACE] = ACTIONS(548),
    [anon_sym_LBRACK] = ACTIONS(208),
    [anon_sym_EQ] = ACTIONS(544),
    [sym_comment] = ACTIONS(49),
  },
  [2408] = {
    [aux_sym_declaration_repeat1] = STATE(2631),
    [anon_sym_COMMA] = ACTIONS(538),
    [anon_sym_SEMI] = ACTIONS(6315),
    [sym_comment] = ACTIONS(49),
  },
  [2409] = {
    [sym_compound_statement] = STATE(2632),
    [sym_labeled_statement] = STATE(2632),
    [sym_expression_statement] = STATE(2632),
    [sym_if_statement] = STATE(2632),
    [sym_switch_statement] = STATE(2632),
    [sym_case_statement] = STATE(2632),
    [sym_while_statement] = STATE(2632),
    [sym_do_statement] = STATE(2632),
    [sym_for_statement] = STATE(2632),
    [sym_return_statement] = STATE(2632),
    [sym_break_statement] = STATE(2632),
    [sym_continue_statement] = STATE(2632),
    [sym_goto_statement] = STATE(2632),
    [sym__expression] = STATE(873),
    [sym_comma_expression] = STATE(874),
    [sym_conditional_expression] = STATE(873),
    [sym_assignment_expression] = STATE(873),
    [sym_pointer_expression] = STATE(873),
    [sym_logical_expression] = STATE(873),
    [sym_bitwise_expression] = STATE(873),
    [sym_equality_expression] = STATE(873),
    [sym_relational_expression] = STATE(873),
    [sym_shift_expression] = STATE(873),
    [sym_math_expression] = STATE(873),
    [sym_cast_expression] = STATE(873),
    [sym_sizeof_expression] = STATE(873),
    [sym_subscript_expression] = STATE(873),
    [sym_call_expression] = STATE(873),
    [sym_field_expression] = STATE(873),
    [sym_compound_literal_expression] = STATE(873),
    [sym_parenthesized_expression] = STATE(873),
    [sym_concatenated_string] = STATE(873),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(873),
    [sym_for_range_loop] = STATE(2632),
    [sym_new_expression] = STATE(873),
    [sym_delete_expression] = STATE(873),
    [sym_lambda_expression] = STATE(873),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(1660),
    [anon_sym_LPAREN] = ACTIONS(626),
    [anon_sym_SEMI] = ACTIONS(1662),
    [anon_sym_LBRACE] = ACTIONS(1664),
    [anon_sym_STAR] = ACTIONS(644),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_if] = ACTIONS(1666),
    [anon_sym_switch] = ACTIONS(1668),
    [anon_sym_case] = ACTIONS(1670),
    [anon_sym_default] = ACTIONS(1672),
    [anon_sym_while] = ACTIONS(1674),
    [anon_sym_do] = ACTIONS(1676),
    [anon_sym_for] = ACTIONS(1678),
    [anon_sym_return] = ACTIONS(1680),
    [anon_sym_break] = ACTIONS(1682),
    [anon_sym_continue] = ACTIONS(1684),
    [anon_sym_goto] = ACTIONS(1686),
    [anon_sym_AMP] = ACTIONS(644),
    [anon_sym_BANG] = ACTIONS(668),
    [anon_sym_TILDE] = ACTIONS(670),
    [anon_sym_PLUS] = ACTIONS(672),
    [anon_sym_DASH] = ACTIONS(672),
    [anon_sym_DASH_DASH] = ACTIONS(674),
    [anon_sym_PLUS_PLUS] = ACTIONS(674),
    [anon_sym_sizeof] = ACTIONS(676),
    [sym_number_literal] = ACTIONS(1660),
    [sym_char_literal] = ACTIONS(1660),
    [sym_string_literal] = ACTIONS(678),
    [sym_true] = ACTIONS(1688),
    [sym_false] = ACTIONS(1688),
    [sym_null] = ACTIONS(1688),
    [sym_identifier] = ACTIONS(1690),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1303),
    [anon_sym_delete] = ACTIONS(686),
    [sym_nullptr] = ACTIONS(1688),
  },
  [2410] = {
    [sym__expression] = STATE(2633),
    [sym_conditional_expression] = STATE(2633),
    [sym_assignment_expression] = STATE(2633),
    [sym_pointer_expression] = STATE(2633),
    [sym_logical_expression] = STATE(2633),
    [sym_bitwise_expression] = STATE(2633),
    [sym_equality_expression] = STATE(2633),
    [sym_relational_expression] = STATE(2633),
    [sym_shift_expression] = STATE(2633),
    [sym_math_expression] = STATE(2633),
    [sym_cast_expression] = STATE(2633),
    [sym_sizeof_expression] = STATE(2633),
    [sym_subscript_expression] = STATE(2633),
    [sym_call_expression] = STATE(2633),
    [sym_field_expression] = STATE(2633),
    [sym_compound_literal_expression] = STATE(2633),
    [sym_parenthesized_expression] = STATE(2633),
    [sym_concatenated_string] = STATE(2633),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(2633),
    [sym_new_expression] = STATE(2633),
    [sym_delete_expression] = STATE(2633),
    [sym_lambda_expression] = STATE(2633),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(6317),
    [anon_sym_LPAREN] = ACTIONS(2943),
    [anon_sym_STAR] = ACTIONS(2945),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_AMP] = ACTIONS(2945),
    [anon_sym_BANG] = ACTIONS(2947),
    [anon_sym_TILDE] = ACTIONS(2949),
    [anon_sym_PLUS] = ACTIONS(2951),
    [anon_sym_DASH] = ACTIONS(2951),
    [anon_sym_DASH_DASH] = ACTIONS(2953),
    [anon_sym_PLUS_PLUS] = ACTIONS(2953),
    [anon_sym_sizeof] = ACTIONS(2955),
    [sym_number_literal] = ACTIONS(6317),
    [sym_char_literal] = ACTIONS(6317),
    [sym_string_literal] = ACTIONS(2957),
    [sym_true] = ACTIONS(6319),
    [sym_false] = ACTIONS(6319),
    [sym_null] = ACTIONS(6319),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(2961),
    [anon_sym_delete] = ACTIONS(2963),
    [sym_nullptr] = ACTIONS(6319),
  },
  [2411] = {
    [sym__expression] = STATE(2635),
    [sym_conditional_expression] = STATE(2635),
    [sym_assignment_expression] = STATE(2635),
    [sym_pointer_expression] = STATE(2635),
    [sym_logical_expression] = STATE(2635),
    [sym_bitwise_expression] = STATE(2635),
    [sym_equality_expression] = STATE(2635),
    [sym_relational_expression] = STATE(2635),
    [sym_shift_expression] = STATE(2635),
    [sym_math_expression] = STATE(2635),
    [sym_cast_expression] = STATE(2635),
    [sym_sizeof_expression] = STATE(2635),
    [sym_subscript_expression] = STATE(2635),
    [sym_call_expression] = STATE(2635),
    [sym_field_expression] = STATE(2635),
    [sym_compound_literal_expression] = STATE(2635),
    [sym_parenthesized_expression] = STATE(2635),
    [sym_concatenated_string] = STATE(2635),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(2635),
    [sym_new_expression] = STATE(2635),
    [sym_delete_expression] = STATE(2635),
    [sym_lambda_expression] = STATE(2635),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(6321),
    [anon_sym_LPAREN] = ACTIONS(1087),
    [anon_sym_RPAREN] = ACTIONS(6323),
    [anon_sym_STAR] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_AMP] = ACTIONS(1089),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1093),
    [anon_sym_PLUS] = ACTIONS(1095),
    [anon_sym_DASH] = ACTIONS(1095),
    [anon_sym_DASH_DASH] = ACTIONS(1097),
    [anon_sym_PLUS_PLUS] = ACTIONS(1097),
    [anon_sym_sizeof] = ACTIONS(1099),
    [sym_number_literal] = ACTIONS(6321),
    [sym_char_literal] = ACTIONS(6321),
    [sym_string_literal] = ACTIONS(1101),
    [sym_true] = ACTIONS(6325),
    [sym_false] = ACTIONS(6325),
    [sym_null] = ACTIONS(6325),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_delete] = ACTIONS(1109),
    [sym_nullptr] = ACTIONS(6325),
  },
  [2412] = {
    [sym_argument_list] = STATE(802),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_SEMI] = ACTIONS(6327),
    [anon_sym_STAR] = ACTIONS(2553),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_EQ] = ACTIONS(2555),
    [anon_sym_QMARK] = ACTIONS(2557),
    [anon_sym_STAR_EQ] = ACTIONS(2559),
    [anon_sym_SLASH_EQ] = ACTIONS(2559),
    [anon_sym_PERCENT_EQ] = ACTIONS(2559),
    [anon_sym_PLUS_EQ] = ACTIONS(2559),
    [anon_sym_DASH_EQ] = ACTIONS(2559),
    [anon_sym_LT_LT_EQ] = ACTIONS(2559),
    [anon_sym_GT_GT_EQ] = ACTIONS(2559),
    [anon_sym_AMP_EQ] = ACTIONS(2559),
    [anon_sym_CARET_EQ] = ACTIONS(2559),
    [anon_sym_PIPE_EQ] = ACTIONS(2559),
    [anon_sym_AMP] = ACTIONS(2561),
    [anon_sym_PIPE_PIPE] = ACTIONS(2563),
    [anon_sym_AMP_AMP] = ACTIONS(2565),
    [anon_sym_PIPE] = ACTIONS(2567),
    [anon_sym_CARET] = ACTIONS(2569),
    [anon_sym_EQ_EQ] = ACTIONS(2571),
    [anon_sym_BANG_EQ] = ACTIONS(2571),
    [anon_sym_LT] = ACTIONS(2573),
    [anon_sym_GT] = ACTIONS(2573),
    [anon_sym_LT_EQ] = ACTIONS(2575),
    [anon_sym_GT_EQ] = ACTIONS(2575),
    [anon_sym_LT_LT] = ACTIONS(2577),
    [anon_sym_GT_GT] = ACTIONS(2577),
    [anon_sym_PLUS] = ACTIONS(2579),
    [anon_sym_DASH] = ACTIONS(2579),
    [anon_sym_SLASH] = ACTIONS(2553),
    [anon_sym_PERCENT] = ACTIONS(2553),
    [anon_sym_DASH_DASH] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(1554),
    [anon_sym_DASH_GT] = ACTIONS(1554),
    [sym_comment] = ACTIONS(49),
  },
  [2413] = {
    [sym__expression] = STATE(2637),
    [sym_conditional_expression] = STATE(2637),
    [sym_assignment_expression] = STATE(2637),
    [sym_pointer_expression] = STATE(2637),
    [sym_logical_expression] = STATE(2637),
    [sym_bitwise_expression] = STATE(2637),
    [sym_equality_expression] = STATE(2637),
    [sym_relational_expression] = STATE(2637),
    [sym_shift_expression] = STATE(2637),
    [sym_math_expression] = STATE(2637),
    [sym_cast_expression] = STATE(2637),
    [sym_sizeof_expression] = STATE(2637),
    [sym_subscript_expression] = STATE(2637),
    [sym_call_expression] = STATE(2637),
    [sym_field_expression] = STATE(2637),
    [sym_compound_literal_expression] = STATE(2637),
    [sym_parenthesized_expression] = STATE(2637),
    [sym_concatenated_string] = STATE(2637),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(2637),
    [sym_new_expression] = STATE(2637),
    [sym_delete_expression] = STATE(2637),
    [sym_lambda_expression] = STATE(2637),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(6329),
    [anon_sym_LPAREN] = ACTIONS(1347),
    [anon_sym_SEMI] = ACTIONS(6327),
    [anon_sym_STAR] = ACTIONS(1349),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_AMP] = ACTIONS(1349),
    [anon_sym_BANG] = ACTIONS(1351),
    [anon_sym_TILDE] = ACTIONS(1353),
    [anon_sym_PLUS] = ACTIONS(1355),
    [anon_sym_DASH] = ACTIONS(1355),
    [anon_sym_DASH_DASH] = ACTIONS(1357),
    [anon_sym_PLUS_PLUS] = ACTIONS(1357),
    [anon_sym_sizeof] = ACTIONS(1359),
    [sym_number_literal] = ACTIONS(6329),
    [sym_char_literal] = ACTIONS(6329),
    [sym_string_literal] = ACTIONS(1361),
    [sym_true] = ACTIONS(6331),
    [sym_false] = ACTIONS(6331),
    [sym_null] = ACTIONS(6331),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1365),
    [anon_sym_delete] = ACTIONS(1367),
    [sym_nullptr] = ACTIONS(6331),
  },
  [2414] = {
    [sym__expression] = STATE(2638),
    [sym_conditional_expression] = STATE(2638),
    [sym_assignment_expression] = STATE(2638),
    [sym_pointer_expression] = STATE(2638),
    [sym_logical_expression] = STATE(2638),
    [sym_bitwise_expression] = STATE(2638),
    [sym_equality_expression] = STATE(2638),
    [sym_relational_expression] = STATE(2638),
    [sym_shift_expression] = STATE(2638),
    [sym_math_expression] = STATE(2638),
    [sym_cast_expression] = STATE(2638),
    [sym_sizeof_expression] = STATE(2638),
    [sym_subscript_expression] = STATE(2638),
    [sym_call_expression] = STATE(2638),
    [sym_field_expression] = STATE(2638),
    [sym_compound_literal_expression] = STATE(2638),
    [sym_parenthesized_expression] = STATE(2638),
    [sym_concatenated_string] = STATE(2638),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(2638),
    [sym_new_expression] = STATE(2638),
    [sym_delete_expression] = STATE(2638),
    [sym_lambda_expression] = STATE(2638),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(6333),
    [anon_sym_LPAREN] = ACTIONS(2943),
    [anon_sym_STAR] = ACTIONS(2945),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_AMP] = ACTIONS(2945),
    [anon_sym_BANG] = ACTIONS(2947),
    [anon_sym_TILDE] = ACTIONS(2949),
    [anon_sym_PLUS] = ACTIONS(2951),
    [anon_sym_DASH] = ACTIONS(2951),
    [anon_sym_DASH_DASH] = ACTIONS(2953),
    [anon_sym_PLUS_PLUS] = ACTIONS(2953),
    [anon_sym_sizeof] = ACTIONS(2955),
    [sym_number_literal] = ACTIONS(6333),
    [sym_char_literal] = ACTIONS(6333),
    [sym_string_literal] = ACTIONS(2957),
    [sym_true] = ACTIONS(6335),
    [sym_false] = ACTIONS(6335),
    [sym_null] = ACTIONS(6335),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(2961),
    [anon_sym_delete] = ACTIONS(2963),
    [sym_nullptr] = ACTIONS(6335),
  },
  [2415] = {
    [sym_argument_list] = STATE(802),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_RPAREN] = ACTIONS(6337),
    [anon_sym_STAR] = ACTIONS(4537),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_EQ] = ACTIONS(4539),
    [anon_sym_QMARK] = ACTIONS(4541),
    [anon_sym_STAR_EQ] = ACTIONS(4543),
    [anon_sym_SLASH_EQ] = ACTIONS(4543),
    [anon_sym_PERCENT_EQ] = ACTIONS(4543),
    [anon_sym_PLUS_EQ] = ACTIONS(4543),
    [anon_sym_DASH_EQ] = ACTIONS(4543),
    [anon_sym_LT_LT_EQ] = ACTIONS(4543),
    [anon_sym_GT_GT_EQ] = ACTIONS(4543),
    [anon_sym_AMP_EQ] = ACTIONS(4543),
    [anon_sym_CARET_EQ] = ACTIONS(4543),
    [anon_sym_PIPE_EQ] = ACTIONS(4543),
    [anon_sym_AMP] = ACTIONS(4545),
    [anon_sym_PIPE_PIPE] = ACTIONS(4547),
    [anon_sym_AMP_AMP] = ACTIONS(4549),
    [anon_sym_PIPE] = ACTIONS(4551),
    [anon_sym_CARET] = ACTIONS(4553),
    [anon_sym_EQ_EQ] = ACTIONS(4555),
    [anon_sym_BANG_EQ] = ACTIONS(4555),
    [anon_sym_LT] = ACTIONS(4557),
    [anon_sym_GT] = ACTIONS(4557),
    [anon_sym_LT_EQ] = ACTIONS(4559),
    [anon_sym_GT_EQ] = ACTIONS(4559),
    [anon_sym_LT_LT] = ACTIONS(4561),
    [anon_sym_GT_GT] = ACTIONS(4561),
    [anon_sym_PLUS] = ACTIONS(4563),
    [anon_sym_DASH] = ACTIONS(4563),
    [anon_sym_SLASH] = ACTIONS(4537),
    [anon_sym_PERCENT] = ACTIONS(4537),
    [anon_sym_DASH_DASH] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(1554),
    [anon_sym_DASH_GT] = ACTIONS(1554),
    [sym_comment] = ACTIONS(49),
  },
  [2416] = {
    [sym_compound_statement] = STATE(2640),
    [sym_labeled_statement] = STATE(2640),
    [sym_expression_statement] = STATE(2640),
    [sym_if_statement] = STATE(2640),
    [sym_switch_statement] = STATE(2640),
    [sym_case_statement] = STATE(2640),
    [sym_while_statement] = STATE(2640),
    [sym_do_statement] = STATE(2640),
    [sym_for_statement] = STATE(2640),
    [sym_return_statement] = STATE(2640),
    [sym_break_statement] = STATE(2640),
    [sym_continue_statement] = STATE(2640),
    [sym_goto_statement] = STATE(2640),
    [sym__expression] = STATE(413),
    [sym_comma_expression] = STATE(414),
    [sym_conditional_expression] = STATE(413),
    [sym_assignment_expression] = STATE(413),
    [sym_pointer_expression] = STATE(413),
    [sym_logical_expression] = STATE(413),
    [sym_bitwise_expression] = STATE(413),
    [sym_equality_expression] = STATE(413),
    [sym_relational_expression] = STATE(413),
    [sym_shift_expression] = STATE(413),
    [sym_math_expression] = STATE(413),
    [sym_cast_expression] = STATE(413),
    [sym_sizeof_expression] = STATE(413),
    [sym_subscript_expression] = STATE(413),
    [sym_call_expression] = STATE(413),
    [sym_field_expression] = STATE(413),
    [sym_compound_literal_expression] = STATE(413),
    [sym_parenthesized_expression] = STATE(413),
    [sym_concatenated_string] = STATE(413),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(413),
    [sym_for_range_loop] = STATE(2640),
    [sym_new_expression] = STATE(413),
    [sym_delete_expression] = STATE(413),
    [sym_lambda_expression] = STATE(413),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(620),
    [anon_sym_LPAREN] = ACTIONS(626),
    [anon_sym_SEMI] = ACTIONS(636),
    [anon_sym_LBRACE] = ACTIONS(640),
    [anon_sym_STAR] = ACTIONS(644),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_if] = ACTIONS(646),
    [anon_sym_switch] = ACTIONS(648),
    [anon_sym_case] = ACTIONS(650),
    [anon_sym_default] = ACTIONS(652),
    [anon_sym_while] = ACTIONS(654),
    [anon_sym_do] = ACTIONS(656),
    [anon_sym_for] = ACTIONS(658),
    [anon_sym_return] = ACTIONS(660),
    [anon_sym_break] = ACTIONS(662),
    [anon_sym_continue] = ACTIONS(664),
    [anon_sym_goto] = ACTIONS(666),
    [anon_sym_AMP] = ACTIONS(644),
    [anon_sym_BANG] = ACTIONS(668),
    [anon_sym_TILDE] = ACTIONS(670),
    [anon_sym_PLUS] = ACTIONS(672),
    [anon_sym_DASH] = ACTIONS(672),
    [anon_sym_DASH_DASH] = ACTIONS(674),
    [anon_sym_PLUS_PLUS] = ACTIONS(674),
    [anon_sym_sizeof] = ACTIONS(676),
    [sym_number_literal] = ACTIONS(620),
    [sym_char_literal] = ACTIONS(620),
    [sym_string_literal] = ACTIONS(678),
    [sym_true] = ACTIONS(680),
    [sym_false] = ACTIONS(680),
    [sym_null] = ACTIONS(680),
    [sym_identifier] = ACTIONS(3110),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1303),
    [anon_sym_delete] = ACTIONS(686),
    [sym_nullptr] = ACTIONS(680),
  },
  [2417] = {
    [sym_argument_list] = STATE(802),
    [aux_sym_for_statement_repeat1] = STATE(2643),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_COMMA] = ACTIONS(6339),
    [anon_sym_RPAREN] = ACTIONS(6341),
    [anon_sym_STAR] = ACTIONS(2234),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_EQ] = ACTIONS(2236),
    [anon_sym_QMARK] = ACTIONS(2238),
    [anon_sym_STAR_EQ] = ACTIONS(2240),
    [anon_sym_SLASH_EQ] = ACTIONS(2240),
    [anon_sym_PERCENT_EQ] = ACTIONS(2240),
    [anon_sym_PLUS_EQ] = ACTIONS(2240),
    [anon_sym_DASH_EQ] = ACTIONS(2240),
    [anon_sym_LT_LT_EQ] = ACTIONS(2240),
    [anon_sym_GT_GT_EQ] = ACTIONS(2240),
    [anon_sym_AMP_EQ] = ACTIONS(2240),
    [anon_sym_CARET_EQ] = ACTIONS(2240),
    [anon_sym_PIPE_EQ] = ACTIONS(2240),
    [anon_sym_AMP] = ACTIONS(2242),
    [anon_sym_PIPE_PIPE] = ACTIONS(2244),
    [anon_sym_AMP_AMP] = ACTIONS(2246),
    [anon_sym_PIPE] = ACTIONS(2248),
    [anon_sym_CARET] = ACTIONS(2250),
    [anon_sym_EQ_EQ] = ACTIONS(2252),
    [anon_sym_BANG_EQ] = ACTIONS(2252),
    [anon_sym_LT] = ACTIONS(2254),
    [anon_sym_GT] = ACTIONS(2254),
    [anon_sym_LT_EQ] = ACTIONS(2256),
    [anon_sym_GT_EQ] = ACTIONS(2256),
    [anon_sym_LT_LT] = ACTIONS(2258),
    [anon_sym_GT_GT] = ACTIONS(2258),
    [anon_sym_PLUS] = ACTIONS(2260),
    [anon_sym_DASH] = ACTIONS(2260),
    [anon_sym_SLASH] = ACTIONS(2234),
    [anon_sym_PERCENT] = ACTIONS(2234),
    [anon_sym_DASH_DASH] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(1554),
    [anon_sym_DASH_GT] = ACTIONS(1554),
    [sym_comment] = ACTIONS(49),
  },
  [2418] = {
    [sym__expression] = STATE(2644),
    [sym_conditional_expression] = STATE(2644),
    [sym_assignment_expression] = STATE(2644),
    [sym_pointer_expression] = STATE(2644),
    [sym_logical_expression] = STATE(2644),
    [sym_bitwise_expression] = STATE(2644),
    [sym_equality_expression] = STATE(2644),
    [sym_relational_expression] = STATE(2644),
    [sym_shift_expression] = STATE(2644),
    [sym_math_expression] = STATE(2644),
    [sym_cast_expression] = STATE(2644),
    [sym_sizeof_expression] = STATE(2644),
    [sym_subscript_expression] = STATE(2644),
    [sym_call_expression] = STATE(2644),
    [sym_field_expression] = STATE(2644),
    [sym_compound_literal_expression] = STATE(2644),
    [sym_parenthesized_expression] = STATE(2644),
    [sym_concatenated_string] = STATE(2644),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(2644),
    [sym_new_expression] = STATE(2644),
    [sym_delete_expression] = STATE(2644),
    [sym_lambda_expression] = STATE(2644),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(6343),
    [anon_sym_LPAREN] = ACTIONS(1087),
    [anon_sym_RPAREN] = ACTIONS(6341),
    [anon_sym_STAR] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_AMP] = ACTIONS(1089),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1093),
    [anon_sym_PLUS] = ACTIONS(1095),
    [anon_sym_DASH] = ACTIONS(1095),
    [anon_sym_DASH_DASH] = ACTIONS(1097),
    [anon_sym_PLUS_PLUS] = ACTIONS(1097),
    [anon_sym_sizeof] = ACTIONS(1099),
    [sym_number_literal] = ACTIONS(6343),
    [sym_char_literal] = ACTIONS(6343),
    [sym_string_literal] = ACTIONS(1101),
    [sym_true] = ACTIONS(6345),
    [sym_false] = ACTIONS(6345),
    [sym_null] = ACTIONS(6345),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_delete] = ACTIONS(1109),
    [sym_nullptr] = ACTIONS(6345),
  },
  [2419] = {
    [sym_parameter_list] = STATE(2422),
    [anon_sym_LPAREN] = ACTIONS(206),
    [anon_sym_COMMA] = ACTIONS(837),
    [anon_sym_SEMI] = ACTIONS(837),
    [anon_sym_LBRACE] = ACTIONS(837),
    [anon_sym_LBRACK] = ACTIONS(208),
    [anon_sym_EQ] = ACTIONS(837),
    [anon_sym_COLON] = ACTIONS(837),
    [sym_comment] = ACTIONS(49),
  },
  [2420] = {
    [sym_parameter_list] = STATE(2422),
    [anon_sym_LPAREN] = ACTIONS(206),
    [anon_sym_COMMA] = ACTIONS(839),
    [anon_sym_SEMI] = ACTIONS(839),
    [anon_sym_LBRACE] = ACTIONS(839),
    [anon_sym_LBRACK] = ACTIONS(208),
    [anon_sym_EQ] = ACTIONS(839),
    [anon_sym_COLON] = ACTIONS(839),
    [sym_comment] = ACTIONS(49),
  },
  [2421] = {
    [sym_raw_string_literal] = ACTIONS(1261),
    [anon_sym_LPAREN] = ACTIONS(1261),
    [anon_sym_SEMI] = ACTIONS(1261),
    [anon_sym_STAR] = ACTIONS(1261),
    [anon_sym_LBRACK] = ACTIONS(1261),
    [anon_sym_AMP] = ACTIONS(1261),
    [anon_sym_BANG] = ACTIONS(1261),
    [anon_sym_TILDE] = ACTIONS(1261),
    [anon_sym_PLUS] = ACTIONS(1263),
    [anon_sym_DASH] = ACTIONS(1263),
    [anon_sym_DASH_DASH] = ACTIONS(1261),
    [anon_sym_PLUS_PLUS] = ACTIONS(1261),
    [anon_sym_sizeof] = ACTIONS(1263),
    [sym_number_literal] = ACTIONS(1261),
    [sym_char_literal] = ACTIONS(1261),
    [sym_string_literal] = ACTIONS(1261),
    [sym_true] = ACTIONS(1263),
    [sym_false] = ACTIONS(1263),
    [sym_null] = ACTIONS(1263),
    [sym_identifier] = ACTIONS(1263),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(1263),
    [anon_sym_COLON_COLON] = ACTIONS(1261),
    [anon_sym_delete] = ACTIONS(1263),
    [sym_nullptr] = ACTIONS(1263),
  },
  [2422] = {
    [sym_type_qualifier] = STATE(2646),
    [sym_trailing_return_type] = STATE(2646),
    [aux_sym_function_declarator_repeat1] = STATE(2646),
    [anon_sym_LPAREN] = ACTIONS(610),
    [anon_sym_COMMA] = ACTIONS(610),
    [anon_sym_SEMI] = ACTIONS(610),
    [anon_sym_LBRACE] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(610),
    [anon_sym_EQ] = ACTIONS(610),
    [anon_sym_const] = ACTIONS(612),
    [anon_sym_restrict] = ACTIONS(614),
    [anon_sym_volatile] = ACTIONS(614),
    [anon_sym__Atomic] = ACTIONS(614),
    [anon_sym_mutable] = ACTIONS(614),
    [anon_sym_explicit] = ACTIONS(614),
    [anon_sym_constexpr] = ACTIONS(614),
    [anon_sym_COLON] = ACTIONS(610),
    [anon_sym_DASH_GT] = ACTIONS(6347),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(6349),
  },
  [2423] = {
    [aux_sym_declaration_repeat1] = STATE(678),
    [anon_sym_COMMA] = ACTIONS(538),
    [anon_sym_SEMI] = ACTIONS(6351),
    [sym_comment] = ACTIONS(49),
  },
  [2424] = {
    [sym_argument_list] = STATE(802),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_SEMI] = ACTIONS(6353),
    [anon_sym_STAR] = ACTIONS(2553),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_EQ] = ACTIONS(2555),
    [anon_sym_QMARK] = ACTIONS(2557),
    [anon_sym_STAR_EQ] = ACTIONS(2559),
    [anon_sym_SLASH_EQ] = ACTIONS(2559),
    [anon_sym_PERCENT_EQ] = ACTIONS(2559),
    [anon_sym_PLUS_EQ] = ACTIONS(2559),
    [anon_sym_DASH_EQ] = ACTIONS(2559),
    [anon_sym_LT_LT_EQ] = ACTIONS(2559),
    [anon_sym_GT_GT_EQ] = ACTIONS(2559),
    [anon_sym_AMP_EQ] = ACTIONS(2559),
    [anon_sym_CARET_EQ] = ACTIONS(2559),
    [anon_sym_PIPE_EQ] = ACTIONS(2559),
    [anon_sym_AMP] = ACTIONS(2561),
    [anon_sym_PIPE_PIPE] = ACTIONS(2563),
    [anon_sym_AMP_AMP] = ACTIONS(2565),
    [anon_sym_PIPE] = ACTIONS(2567),
    [anon_sym_CARET] = ACTIONS(2569),
    [anon_sym_EQ_EQ] = ACTIONS(2571),
    [anon_sym_BANG_EQ] = ACTIONS(2571),
    [anon_sym_LT] = ACTIONS(2573),
    [anon_sym_GT] = ACTIONS(2573),
    [anon_sym_LT_EQ] = ACTIONS(2575),
    [anon_sym_GT_EQ] = ACTIONS(2575),
    [anon_sym_LT_LT] = ACTIONS(2577),
    [anon_sym_GT_GT] = ACTIONS(2577),
    [anon_sym_PLUS] = ACTIONS(2579),
    [anon_sym_DASH] = ACTIONS(2579),
    [anon_sym_SLASH] = ACTIONS(2553),
    [anon_sym_PERCENT] = ACTIONS(2553),
    [anon_sym_DASH_DASH] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(1554),
    [anon_sym_DASH_GT] = ACTIONS(1554),
    [sym_comment] = ACTIONS(49),
  },
  [2425] = {
    [sym_argument_list] = STATE(802),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_RPAREN] = ACTIONS(6355),
    [anon_sym_STAR] = ACTIONS(4537),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_EQ] = ACTIONS(4539),
    [anon_sym_QMARK] = ACTIONS(4541),
    [anon_sym_STAR_EQ] = ACTIONS(4543),
    [anon_sym_SLASH_EQ] = ACTIONS(4543),
    [anon_sym_PERCENT_EQ] = ACTIONS(4543),
    [anon_sym_PLUS_EQ] = ACTIONS(4543),
    [anon_sym_DASH_EQ] = ACTIONS(4543),
    [anon_sym_LT_LT_EQ] = ACTIONS(4543),
    [anon_sym_GT_GT_EQ] = ACTIONS(4543),
    [anon_sym_AMP_EQ] = ACTIONS(4543),
    [anon_sym_CARET_EQ] = ACTIONS(4543),
    [anon_sym_PIPE_EQ] = ACTIONS(4543),
    [anon_sym_AMP] = ACTIONS(4545),
    [anon_sym_PIPE_PIPE] = ACTIONS(4547),
    [anon_sym_AMP_AMP] = ACTIONS(4549),
    [anon_sym_PIPE] = ACTIONS(4551),
    [anon_sym_CARET] = ACTIONS(4553),
    [anon_sym_EQ_EQ] = ACTIONS(4555),
    [anon_sym_BANG_EQ] = ACTIONS(4555),
    [anon_sym_LT] = ACTIONS(4557),
    [anon_sym_GT] = ACTIONS(4557),
    [anon_sym_LT_EQ] = ACTIONS(4559),
    [anon_sym_GT_EQ] = ACTIONS(4559),
    [anon_sym_LT_LT] = ACTIONS(4561),
    [anon_sym_GT_GT] = ACTIONS(4561),
    [anon_sym_PLUS] = ACTIONS(4563),
    [anon_sym_DASH] = ACTIONS(4563),
    [anon_sym_SLASH] = ACTIONS(4537),
    [anon_sym_PERCENT] = ACTIONS(4537),
    [anon_sym_DASH_DASH] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(1554),
    [anon_sym_DASH_GT] = ACTIONS(1554),
    [sym_comment] = ACTIONS(49),
  },
  [2426] = {
    [sym_argument_list] = STATE(802),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_COMMA] = ACTIONS(5984),
    [anon_sym_SEMI] = ACTIONS(5984),
    [anon_sym_STAR] = ACTIONS(1744),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_EQ] = ACTIONS(5986),
    [anon_sym_QMARK] = ACTIONS(5984),
    [anon_sym_STAR_EQ] = ACTIONS(5984),
    [anon_sym_SLASH_EQ] = ACTIONS(5984),
    [anon_sym_PERCENT_EQ] = ACTIONS(5984),
    [anon_sym_PLUS_EQ] = ACTIONS(5984),
    [anon_sym_DASH_EQ] = ACTIONS(5984),
    [anon_sym_LT_LT_EQ] = ACTIONS(5984),
    [anon_sym_GT_GT_EQ] = ACTIONS(5984),
    [anon_sym_AMP_EQ] = ACTIONS(5984),
    [anon_sym_CARET_EQ] = ACTIONS(5984),
    [anon_sym_PIPE_EQ] = ACTIONS(5984),
    [anon_sym_AMP] = ACTIONS(1752),
    [anon_sym_PIPE_PIPE] = ACTIONS(1754),
    [anon_sym_AMP_AMP] = ACTIONS(1756),
    [anon_sym_PIPE] = ACTIONS(1758),
    [anon_sym_CARET] = ACTIONS(1760),
    [anon_sym_EQ_EQ] = ACTIONS(1762),
    [anon_sym_BANG_EQ] = ACTIONS(1762),
    [anon_sym_LT] = ACTIONS(1764),
    [anon_sym_GT] = ACTIONS(1764),
    [anon_sym_LT_EQ] = ACTIONS(1766),
    [anon_sym_GT_EQ] = ACTIONS(1766),
    [anon_sym_LT_LT] = ACTIONS(1768),
    [anon_sym_GT_GT] = ACTIONS(1768),
    [anon_sym_PLUS] = ACTIONS(1770),
    [anon_sym_DASH] = ACTIONS(1770),
    [anon_sym_SLASH] = ACTIONS(1744),
    [anon_sym_PERCENT] = ACTIONS(1744),
    [anon_sym_DASH_DASH] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(1554),
    [anon_sym_DASH_GT] = ACTIONS(1554),
    [sym_comment] = ACTIONS(49),
  },
  [2427] = {
    [sym_raw_string_literal] = ACTIONS(4064),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(4066),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(4066),
    [anon_sym_LPAREN] = ACTIONS(4064),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(4066),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(4066),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(4066),
    [sym_preproc_directive] = ACTIONS(4066),
    [anon_sym_SEMI] = ACTIONS(4064),
    [anon_sym_typedef] = ACTIONS(4066),
    [anon_sym_extern] = ACTIONS(4066),
    [anon_sym_LBRACE] = ACTIONS(4064),
    [anon_sym_RBRACE] = ACTIONS(4064),
    [anon_sym_STAR] = ACTIONS(4064),
    [anon_sym_LBRACK] = ACTIONS(4064),
    [anon_sym_static] = ACTIONS(4066),
    [anon_sym_register] = ACTIONS(4066),
    [anon_sym_inline] = ACTIONS(4066),
    [anon_sym_const] = ACTIONS(4066),
    [anon_sym_restrict] = ACTIONS(4066),
    [anon_sym_volatile] = ACTIONS(4066),
    [anon_sym__Atomic] = ACTIONS(4066),
    [anon_sym_mutable] = ACTIONS(4066),
    [anon_sym_explicit] = ACTIONS(4066),
    [anon_sym_constexpr] = ACTIONS(4066),
    [anon_sym_unsigned] = ACTIONS(4066),
    [anon_sym_long] = ACTIONS(4066),
    [anon_sym_short] = ACTIONS(4066),
    [sym_primitive_type] = ACTIONS(4066),
    [anon_sym_enum] = ACTIONS(4066),
    [anon_sym_struct] = ACTIONS(4066),
    [anon_sym_union] = ACTIONS(4066),
    [anon_sym_if] = ACTIONS(4066),
    [anon_sym_switch] = ACTIONS(4066),
    [anon_sym_case] = ACTIONS(4066),
    [anon_sym_default] = ACTIONS(4066),
    [anon_sym_while] = ACTIONS(4066),
    [anon_sym_do] = ACTIONS(4066),
    [anon_sym_for] = ACTIONS(4066),
    [anon_sym_return] = ACTIONS(4066),
    [anon_sym_break] = ACTIONS(4066),
    [anon_sym_continue] = ACTIONS(4066),
    [anon_sym_goto] = ACTIONS(4066),
    [anon_sym_AMP] = ACTIONS(4064),
    [anon_sym_BANG] = ACTIONS(4064),
    [anon_sym_TILDE] = ACTIONS(4064),
    [anon_sym_PLUS] = ACTIONS(4066),
    [anon_sym_DASH] = ACTIONS(4066),
    [anon_sym_DASH_DASH] = ACTIONS(4064),
    [anon_sym_PLUS_PLUS] = ACTIONS(4064),
    [anon_sym_sizeof] = ACTIONS(4066),
    [sym_number_literal] = ACTIONS(4064),
    [sym_char_literal] = ACTIONS(4064),
    [sym_string_literal] = ACTIONS(4064),
    [sym_true] = ACTIONS(4066),
    [sym_false] = ACTIONS(4066),
    [sym_null] = ACTIONS(4066),
    [sym_identifier] = ACTIONS(4066),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(4066),
    [sym_auto] = ACTIONS(4066),
    [anon_sym_typename] = ACTIONS(4066),
    [anon_sym_new] = ACTIONS(4066),
    [anon_sym_COLON_COLON] = ACTIONS(4064),
    [anon_sym_delete] = ACTIONS(4066),
    [sym_nullptr] = ACTIONS(4066),
  },
  [2428] = {
    [sym_raw_string_literal] = ACTIONS(4112),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(4114),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(4114),
    [anon_sym_LPAREN] = ACTIONS(4112),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(4114),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(4114),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(4114),
    [sym_preproc_directive] = ACTIONS(4114),
    [anon_sym_SEMI] = ACTIONS(4112),
    [anon_sym_typedef] = ACTIONS(4114),
    [anon_sym_extern] = ACTIONS(4114),
    [anon_sym_LBRACE] = ACTIONS(4112),
    [anon_sym_RBRACE] = ACTIONS(4112),
    [anon_sym_STAR] = ACTIONS(4112),
    [anon_sym_LBRACK] = ACTIONS(4112),
    [anon_sym_static] = ACTIONS(4114),
    [anon_sym_register] = ACTIONS(4114),
    [anon_sym_inline] = ACTIONS(4114),
    [anon_sym_const] = ACTIONS(4114),
    [anon_sym_restrict] = ACTIONS(4114),
    [anon_sym_volatile] = ACTIONS(4114),
    [anon_sym__Atomic] = ACTIONS(4114),
    [anon_sym_mutable] = ACTIONS(4114),
    [anon_sym_explicit] = ACTIONS(4114),
    [anon_sym_constexpr] = ACTIONS(4114),
    [anon_sym_unsigned] = ACTIONS(4114),
    [anon_sym_long] = ACTIONS(4114),
    [anon_sym_short] = ACTIONS(4114),
    [sym_primitive_type] = ACTIONS(4114),
    [anon_sym_enum] = ACTIONS(4114),
    [anon_sym_struct] = ACTIONS(4114),
    [anon_sym_union] = ACTIONS(4114),
    [anon_sym_if] = ACTIONS(4114),
    [anon_sym_switch] = ACTIONS(4114),
    [anon_sym_case] = ACTIONS(4114),
    [anon_sym_default] = ACTIONS(4114),
    [anon_sym_while] = ACTIONS(4114),
    [anon_sym_do] = ACTIONS(4114),
    [anon_sym_for] = ACTIONS(4114),
    [anon_sym_return] = ACTIONS(4114),
    [anon_sym_break] = ACTIONS(4114),
    [anon_sym_continue] = ACTIONS(4114),
    [anon_sym_goto] = ACTIONS(4114),
    [anon_sym_AMP] = ACTIONS(4112),
    [anon_sym_BANG] = ACTIONS(4112),
    [anon_sym_TILDE] = ACTIONS(4112),
    [anon_sym_PLUS] = ACTIONS(4114),
    [anon_sym_DASH] = ACTIONS(4114),
    [anon_sym_DASH_DASH] = ACTIONS(4112),
    [anon_sym_PLUS_PLUS] = ACTIONS(4112),
    [anon_sym_sizeof] = ACTIONS(4114),
    [sym_number_literal] = ACTIONS(4112),
    [sym_char_literal] = ACTIONS(4112),
    [sym_string_literal] = ACTIONS(4112),
    [sym_true] = ACTIONS(4114),
    [sym_false] = ACTIONS(4114),
    [sym_null] = ACTIONS(4114),
    [sym_identifier] = ACTIONS(4114),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(4114),
    [sym_auto] = ACTIONS(4114),
    [anon_sym_typename] = ACTIONS(4114),
    [anon_sym_new] = ACTIONS(4114),
    [anon_sym_COLON_COLON] = ACTIONS(4112),
    [anon_sym_delete] = ACTIONS(4114),
    [sym_nullptr] = ACTIONS(4114),
  },
  [2429] = {
    [sym_argument_list] = STATE(802),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_COMMA] = ACTIONS(5988),
    [anon_sym_SEMI] = ACTIONS(5988),
    [anon_sym_STAR] = ACTIONS(1744),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_EQ] = ACTIONS(1746),
    [anon_sym_QMARK] = ACTIONS(1748),
    [anon_sym_STAR_EQ] = ACTIONS(1750),
    [anon_sym_SLASH_EQ] = ACTIONS(1750),
    [anon_sym_PERCENT_EQ] = ACTIONS(1750),
    [anon_sym_PLUS_EQ] = ACTIONS(1750),
    [anon_sym_DASH_EQ] = ACTIONS(1750),
    [anon_sym_LT_LT_EQ] = ACTIONS(1750),
    [anon_sym_GT_GT_EQ] = ACTIONS(1750),
    [anon_sym_AMP_EQ] = ACTIONS(1750),
    [anon_sym_CARET_EQ] = ACTIONS(1750),
    [anon_sym_PIPE_EQ] = ACTIONS(1750),
    [anon_sym_AMP] = ACTIONS(1752),
    [anon_sym_PIPE_PIPE] = ACTIONS(1754),
    [anon_sym_AMP_AMP] = ACTIONS(1756),
    [anon_sym_PIPE] = ACTIONS(1758),
    [anon_sym_CARET] = ACTIONS(1760),
    [anon_sym_EQ_EQ] = ACTIONS(1762),
    [anon_sym_BANG_EQ] = ACTIONS(1762),
    [anon_sym_LT] = ACTIONS(1764),
    [anon_sym_GT] = ACTIONS(1764),
    [anon_sym_LT_EQ] = ACTIONS(1766),
    [anon_sym_GT_EQ] = ACTIONS(1766),
    [anon_sym_LT_LT] = ACTIONS(1768),
    [anon_sym_GT_GT] = ACTIONS(1768),
    [anon_sym_PLUS] = ACTIONS(1770),
    [anon_sym_DASH] = ACTIONS(1770),
    [anon_sym_SLASH] = ACTIONS(1744),
    [anon_sym_PERCENT] = ACTIONS(1744),
    [anon_sym_DASH_DASH] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(1554),
    [anon_sym_DASH_GT] = ACTIONS(1554),
    [sym_comment] = ACTIONS(49),
  },
  [2430] = {
    [sym_type_qualifier] = STATE(2165),
    [sym_trailing_return_type] = STATE(2168),
    [aux_sym_abstract_function_declarator_repeat1] = STATE(2165),
    [anon_sym_LPAREN] = ACTIONS(4998),
    [anon_sym_RPAREN] = ACTIONS(4998),
    [anon_sym_LBRACK] = ACTIONS(4998),
    [anon_sym_const] = ACTIONS(612),
    [anon_sym_restrict] = ACTIONS(614),
    [anon_sym_volatile] = ACTIONS(614),
    [anon_sym__Atomic] = ACTIONS(614),
    [anon_sym_mutable] = ACTIONS(614),
    [anon_sym_explicit] = ACTIONS(614),
    [anon_sym_constexpr] = ACTIONS(614),
    [anon_sym_DASH_GT] = ACTIONS(845),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(4986),
  },
  [2431] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3344),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3344),
    [anon_sym_LPAREN] = ACTIONS(3342),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3344),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3344),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3344),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3344),
    [sym_preproc_directive] = ACTIONS(3344),
    [anon_sym_typedef] = ACTIONS(3344),
    [anon_sym_extern] = ACTIONS(3344),
    [anon_sym_STAR] = ACTIONS(3342),
    [anon_sym_static] = ACTIONS(3344),
    [anon_sym_register] = ACTIONS(3344),
    [anon_sym_inline] = ACTIONS(3344),
    [anon_sym_const] = ACTIONS(3344),
    [anon_sym_restrict] = ACTIONS(3344),
    [anon_sym_volatile] = ACTIONS(3344),
    [anon_sym__Atomic] = ACTIONS(3344),
    [anon_sym_mutable] = ACTIONS(3344),
    [anon_sym_explicit] = ACTIONS(3344),
    [anon_sym_constexpr] = ACTIONS(3344),
    [anon_sym_unsigned] = ACTIONS(3344),
    [anon_sym_long] = ACTIONS(3344),
    [anon_sym_short] = ACTIONS(3344),
    [sym_primitive_type] = ACTIONS(3344),
    [anon_sym_enum] = ACTIONS(3344),
    [anon_sym_struct] = ACTIONS(3344),
    [anon_sym_union] = ACTIONS(3344),
    [anon_sym_AMP] = ACTIONS(3344),
    [anon_sym_AMP_AMP] = ACTIONS(3342),
    [anon_sym_TILDE] = ACTIONS(3342),
    [sym_identifier] = ACTIONS(3344),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(3344),
    [sym_auto] = ACTIONS(3344),
    [anon_sym_typename] = ACTIONS(3344),
    [anon_sym_template] = ACTIONS(3344),
    [anon_sym_namespace] = ACTIONS(3344),
    [anon_sym_using] = ACTIONS(3344),
    [anon_sym_COLON_COLON] = ACTIONS(3342),
    [sym_operator_name] = ACTIONS(3342),
  },
  [2432] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3354),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3354),
    [anon_sym_LPAREN] = ACTIONS(3352),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3354),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3354),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3354),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3354),
    [sym_preproc_directive] = ACTIONS(3354),
    [anon_sym_typedef] = ACTIONS(3354),
    [anon_sym_extern] = ACTIONS(3354),
    [anon_sym_STAR] = ACTIONS(3352),
    [anon_sym_static] = ACTIONS(3354),
    [anon_sym_register] = ACTIONS(3354),
    [anon_sym_inline] = ACTIONS(3354),
    [anon_sym_const] = ACTIONS(3354),
    [anon_sym_restrict] = ACTIONS(3354),
    [anon_sym_volatile] = ACTIONS(3354),
    [anon_sym__Atomic] = ACTIONS(3354),
    [anon_sym_mutable] = ACTIONS(3354),
    [anon_sym_explicit] = ACTIONS(3354),
    [anon_sym_constexpr] = ACTIONS(3354),
    [anon_sym_unsigned] = ACTIONS(3354),
    [anon_sym_long] = ACTIONS(3354),
    [anon_sym_short] = ACTIONS(3354),
    [sym_primitive_type] = ACTIONS(3354),
    [anon_sym_enum] = ACTIONS(3354),
    [anon_sym_struct] = ACTIONS(3354),
    [anon_sym_union] = ACTIONS(3354),
    [anon_sym_AMP] = ACTIONS(3354),
    [anon_sym_AMP_AMP] = ACTIONS(3352),
    [anon_sym_TILDE] = ACTIONS(3352),
    [sym_identifier] = ACTIONS(3354),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(3354),
    [sym_auto] = ACTIONS(3354),
    [anon_sym_typename] = ACTIONS(3354),
    [anon_sym_template] = ACTIONS(3354),
    [anon_sym_namespace] = ACTIONS(3354),
    [anon_sym_using] = ACTIONS(3354),
    [anon_sym_COLON_COLON] = ACTIONS(3352),
    [sym_operator_name] = ACTIONS(3352),
  },
  [2433] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3493),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3493),
    [anon_sym_LPAREN] = ACTIONS(3491),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3493),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3493),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3493),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3493),
    [sym_preproc_directive] = ACTIONS(3493),
    [anon_sym_typedef] = ACTIONS(3493),
    [anon_sym_extern] = ACTIONS(3493),
    [anon_sym_STAR] = ACTIONS(3491),
    [anon_sym_static] = ACTIONS(3493),
    [anon_sym_register] = ACTIONS(3493),
    [anon_sym_inline] = ACTIONS(3493),
    [anon_sym_const] = ACTIONS(3493),
    [anon_sym_restrict] = ACTIONS(3493),
    [anon_sym_volatile] = ACTIONS(3493),
    [anon_sym__Atomic] = ACTIONS(3493),
    [anon_sym_mutable] = ACTIONS(3493),
    [anon_sym_explicit] = ACTIONS(3493),
    [anon_sym_constexpr] = ACTIONS(3493),
    [anon_sym_unsigned] = ACTIONS(3493),
    [anon_sym_long] = ACTIONS(3493),
    [anon_sym_short] = ACTIONS(3493),
    [sym_primitive_type] = ACTIONS(3493),
    [anon_sym_enum] = ACTIONS(3493),
    [anon_sym_struct] = ACTIONS(3493),
    [anon_sym_union] = ACTIONS(3493),
    [anon_sym_AMP] = ACTIONS(3493),
    [anon_sym_AMP_AMP] = ACTIONS(3491),
    [anon_sym_TILDE] = ACTIONS(3491),
    [sym_identifier] = ACTIONS(3493),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(3493),
    [sym_auto] = ACTIONS(3493),
    [anon_sym_typename] = ACTIONS(3493),
    [anon_sym_template] = ACTIONS(3493),
    [anon_sym_namespace] = ACTIONS(3493),
    [anon_sym_using] = ACTIONS(3493),
    [anon_sym_COLON_COLON] = ACTIONS(3491),
    [sym_operator_name] = ACTIONS(3491),
  },
  [2434] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3497),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3497),
    [anon_sym_LPAREN] = ACTIONS(3495),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3497),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3497),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3497),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3497),
    [sym_preproc_directive] = ACTIONS(3497),
    [anon_sym_typedef] = ACTIONS(3497),
    [anon_sym_extern] = ACTIONS(3497),
    [anon_sym_STAR] = ACTIONS(3495),
    [anon_sym_static] = ACTIONS(3497),
    [anon_sym_register] = ACTIONS(3497),
    [anon_sym_inline] = ACTIONS(3497),
    [anon_sym_const] = ACTIONS(3497),
    [anon_sym_restrict] = ACTIONS(3497),
    [anon_sym_volatile] = ACTIONS(3497),
    [anon_sym__Atomic] = ACTIONS(3497),
    [anon_sym_mutable] = ACTIONS(3497),
    [anon_sym_explicit] = ACTIONS(3497),
    [anon_sym_constexpr] = ACTIONS(3497),
    [anon_sym_unsigned] = ACTIONS(3497),
    [anon_sym_long] = ACTIONS(3497),
    [anon_sym_short] = ACTIONS(3497),
    [sym_primitive_type] = ACTIONS(3497),
    [anon_sym_enum] = ACTIONS(3497),
    [anon_sym_struct] = ACTIONS(3497),
    [anon_sym_union] = ACTIONS(3497),
    [anon_sym_AMP] = ACTIONS(3497),
    [anon_sym_AMP_AMP] = ACTIONS(3495),
    [anon_sym_TILDE] = ACTIONS(3495),
    [sym_identifier] = ACTIONS(3497),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(3497),
    [sym_auto] = ACTIONS(3497),
    [anon_sym_typename] = ACTIONS(3497),
    [anon_sym_template] = ACTIONS(3497),
    [anon_sym_namespace] = ACTIONS(3497),
    [anon_sym_using] = ACTIONS(3497),
    [anon_sym_COLON_COLON] = ACTIONS(3495),
    [sym_operator_name] = ACTIONS(3495),
  },
  [2435] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3501),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3501),
    [anon_sym_LPAREN] = ACTIONS(3499),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3501),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3501),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3501),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3501),
    [sym_preproc_directive] = ACTIONS(3501),
    [anon_sym_typedef] = ACTIONS(3501),
    [anon_sym_extern] = ACTIONS(3501),
    [anon_sym_STAR] = ACTIONS(3499),
    [anon_sym_static] = ACTIONS(3501),
    [anon_sym_register] = ACTIONS(3501),
    [anon_sym_inline] = ACTIONS(3501),
    [anon_sym_const] = ACTIONS(3501),
    [anon_sym_restrict] = ACTIONS(3501),
    [anon_sym_volatile] = ACTIONS(3501),
    [anon_sym__Atomic] = ACTIONS(3501),
    [anon_sym_mutable] = ACTIONS(3501),
    [anon_sym_explicit] = ACTIONS(3501),
    [anon_sym_constexpr] = ACTIONS(3501),
    [anon_sym_unsigned] = ACTIONS(3501),
    [anon_sym_long] = ACTIONS(3501),
    [anon_sym_short] = ACTIONS(3501),
    [sym_primitive_type] = ACTIONS(3501),
    [anon_sym_enum] = ACTIONS(3501),
    [anon_sym_struct] = ACTIONS(3501),
    [anon_sym_union] = ACTIONS(3501),
    [anon_sym_AMP] = ACTIONS(3501),
    [anon_sym_AMP_AMP] = ACTIONS(3499),
    [anon_sym_TILDE] = ACTIONS(3499),
    [sym_identifier] = ACTIONS(3501),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(3501),
    [sym_auto] = ACTIONS(3501),
    [anon_sym_typename] = ACTIONS(3501),
    [anon_sym_template] = ACTIONS(3501),
    [anon_sym_namespace] = ACTIONS(3501),
    [anon_sym_using] = ACTIONS(3501),
    [anon_sym_COLON_COLON] = ACTIONS(3499),
    [sym_operator_name] = ACTIONS(3499),
  },
  [2436] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3521),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3521),
    [anon_sym_LPAREN] = ACTIONS(3519),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3521),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3521),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3521),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3521),
    [sym_preproc_directive] = ACTIONS(3521),
    [anon_sym_typedef] = ACTIONS(3521),
    [anon_sym_extern] = ACTIONS(3521),
    [anon_sym_STAR] = ACTIONS(3519),
    [anon_sym_static] = ACTIONS(3521),
    [anon_sym_register] = ACTIONS(3521),
    [anon_sym_inline] = ACTIONS(3521),
    [anon_sym_const] = ACTIONS(3521),
    [anon_sym_restrict] = ACTIONS(3521),
    [anon_sym_volatile] = ACTIONS(3521),
    [anon_sym__Atomic] = ACTIONS(3521),
    [anon_sym_mutable] = ACTIONS(3521),
    [anon_sym_explicit] = ACTIONS(3521),
    [anon_sym_constexpr] = ACTIONS(3521),
    [anon_sym_unsigned] = ACTIONS(3521),
    [anon_sym_long] = ACTIONS(3521),
    [anon_sym_short] = ACTIONS(3521),
    [sym_primitive_type] = ACTIONS(3521),
    [anon_sym_enum] = ACTIONS(3521),
    [anon_sym_struct] = ACTIONS(3521),
    [anon_sym_union] = ACTIONS(3521),
    [anon_sym_AMP] = ACTIONS(3521),
    [anon_sym_AMP_AMP] = ACTIONS(3519),
    [anon_sym_TILDE] = ACTIONS(3519),
    [sym_identifier] = ACTIONS(3521),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(3521),
    [sym_auto] = ACTIONS(3521),
    [anon_sym_typename] = ACTIONS(3521),
    [anon_sym_template] = ACTIONS(3521),
    [anon_sym_namespace] = ACTIONS(3521),
    [anon_sym_using] = ACTIONS(3521),
    [anon_sym_COLON_COLON] = ACTIONS(3519),
    [sym_operator_name] = ACTIONS(3519),
  },
  [2437] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3864),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3864),
    [anon_sym_LPAREN] = ACTIONS(3862),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3864),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3864),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3864),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3864),
    [sym_preproc_directive] = ACTIONS(3864),
    [anon_sym_typedef] = ACTIONS(3864),
    [anon_sym_extern] = ACTIONS(3864),
    [anon_sym_STAR] = ACTIONS(3862),
    [anon_sym_static] = ACTIONS(3864),
    [anon_sym_register] = ACTIONS(3864),
    [anon_sym_inline] = ACTIONS(3864),
    [anon_sym_const] = ACTIONS(3864),
    [anon_sym_restrict] = ACTIONS(3864),
    [anon_sym_volatile] = ACTIONS(3864),
    [anon_sym__Atomic] = ACTIONS(3864),
    [anon_sym_mutable] = ACTIONS(3864),
    [anon_sym_explicit] = ACTIONS(3864),
    [anon_sym_constexpr] = ACTIONS(3864),
    [anon_sym_unsigned] = ACTIONS(3864),
    [anon_sym_long] = ACTIONS(3864),
    [anon_sym_short] = ACTIONS(3864),
    [sym_primitive_type] = ACTIONS(3864),
    [anon_sym_enum] = ACTIONS(3864),
    [anon_sym_struct] = ACTIONS(3864),
    [anon_sym_union] = ACTIONS(3864),
    [anon_sym_AMP] = ACTIONS(3864),
    [anon_sym_AMP_AMP] = ACTIONS(3862),
    [anon_sym_TILDE] = ACTIONS(3862),
    [sym_identifier] = ACTIONS(3864),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(3864),
    [sym_auto] = ACTIONS(3864),
    [anon_sym_typename] = ACTIONS(3864),
    [anon_sym_template] = ACTIONS(3864),
    [anon_sym_namespace] = ACTIONS(3864),
    [anon_sym_using] = ACTIONS(3864),
    [anon_sym_COLON_COLON] = ACTIONS(3862),
    [sym_operator_name] = ACTIONS(3862),
  },
  [2438] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(4066),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(4066),
    [anon_sym_LPAREN] = ACTIONS(4064),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(4066),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(4066),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(4066),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(4066),
    [sym_preproc_directive] = ACTIONS(4066),
    [anon_sym_typedef] = ACTIONS(4066),
    [anon_sym_extern] = ACTIONS(4066),
    [anon_sym_STAR] = ACTIONS(4064),
    [anon_sym_static] = ACTIONS(4066),
    [anon_sym_register] = ACTIONS(4066),
    [anon_sym_inline] = ACTIONS(4066),
    [anon_sym_const] = ACTIONS(4066),
    [anon_sym_restrict] = ACTIONS(4066),
    [anon_sym_volatile] = ACTIONS(4066),
    [anon_sym__Atomic] = ACTIONS(4066),
    [anon_sym_mutable] = ACTIONS(4066),
    [anon_sym_explicit] = ACTIONS(4066),
    [anon_sym_constexpr] = ACTIONS(4066),
    [anon_sym_unsigned] = ACTIONS(4066),
    [anon_sym_long] = ACTIONS(4066),
    [anon_sym_short] = ACTIONS(4066),
    [sym_primitive_type] = ACTIONS(4066),
    [anon_sym_enum] = ACTIONS(4066),
    [anon_sym_struct] = ACTIONS(4066),
    [anon_sym_union] = ACTIONS(4066),
    [anon_sym_AMP] = ACTIONS(4066),
    [anon_sym_AMP_AMP] = ACTIONS(4064),
    [anon_sym_TILDE] = ACTIONS(4064),
    [sym_identifier] = ACTIONS(4066),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(4066),
    [sym_auto] = ACTIONS(4066),
    [anon_sym_typename] = ACTIONS(4066),
    [anon_sym_template] = ACTIONS(4066),
    [anon_sym_namespace] = ACTIONS(4066),
    [anon_sym_using] = ACTIONS(4066),
    [anon_sym_COLON_COLON] = ACTIONS(4064),
    [sym_operator_name] = ACTIONS(4064),
  },
  [2439] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(4114),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(4114),
    [anon_sym_LPAREN] = ACTIONS(4112),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(4114),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(4114),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(4114),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(4114),
    [sym_preproc_directive] = ACTIONS(4114),
    [anon_sym_typedef] = ACTIONS(4114),
    [anon_sym_extern] = ACTIONS(4114),
    [anon_sym_STAR] = ACTIONS(4112),
    [anon_sym_static] = ACTIONS(4114),
    [anon_sym_register] = ACTIONS(4114),
    [anon_sym_inline] = ACTIONS(4114),
    [anon_sym_const] = ACTIONS(4114),
    [anon_sym_restrict] = ACTIONS(4114),
    [anon_sym_volatile] = ACTIONS(4114),
    [anon_sym__Atomic] = ACTIONS(4114),
    [anon_sym_mutable] = ACTIONS(4114),
    [anon_sym_explicit] = ACTIONS(4114),
    [anon_sym_constexpr] = ACTIONS(4114),
    [anon_sym_unsigned] = ACTIONS(4114),
    [anon_sym_long] = ACTIONS(4114),
    [anon_sym_short] = ACTIONS(4114),
    [sym_primitive_type] = ACTIONS(4114),
    [anon_sym_enum] = ACTIONS(4114),
    [anon_sym_struct] = ACTIONS(4114),
    [anon_sym_union] = ACTIONS(4114),
    [anon_sym_AMP] = ACTIONS(4114),
    [anon_sym_AMP_AMP] = ACTIONS(4112),
    [anon_sym_TILDE] = ACTIONS(4112),
    [sym_identifier] = ACTIONS(4114),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(4114),
    [sym_auto] = ACTIONS(4114),
    [anon_sym_typename] = ACTIONS(4114),
    [anon_sym_template] = ACTIONS(4114),
    [anon_sym_namespace] = ACTIONS(4114),
    [anon_sym_using] = ACTIONS(4114),
    [anon_sym_COLON_COLON] = ACTIONS(4112),
    [sym_operator_name] = ACTIONS(4112),
  },
  [2440] = {
    [sym_type_qualifier] = STATE(2249),
    [sym_trailing_return_type] = STATE(2168),
    [aux_sym_abstract_function_declarator_repeat1] = STATE(2249),
    [anon_sym_LPAREN] = ACTIONS(4998),
    [anon_sym_LBRACK] = ACTIONS(4998),
    [anon_sym_const] = ACTIONS(612),
    [anon_sym_restrict] = ACTIONS(614),
    [anon_sym_volatile] = ACTIONS(614),
    [anon_sym__Atomic] = ACTIONS(614),
    [anon_sym_mutable] = ACTIONS(614),
    [anon_sym_explicit] = ACTIONS(614),
    [anon_sym_constexpr] = ACTIONS(614),
    [anon_sym_DASH_GT] = ACTIONS(979),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(5256),
  },
  [2441] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(6357),
    [sym_comment] = ACTIONS(49),
  },
  [2442] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(6359),
    [sym_comment] = ACTIONS(49),
  },
  [2443] = {
    [sym__type_specifier] = STATE(2654),
    [sym_sized_type_specifier] = STATE(2654),
    [sym_enum_specifier] = STATE(2654),
    [sym_struct_specifier] = STATE(2654),
    [sym_union_specifier] = STATE(2654),
    [sym_macro_type_specifier] = STATE(2654),
    [sym_class_specifier] = STATE(2654),
    [sym_dependent_type] = STATE(2654),
    [sym_template_type] = STATE(825),
    [sym_scoped_type_identifier] = STATE(826),
    [sym_scoped_namespace_identifier] = STATE(827),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2655),
    [anon_sym_unsigned] = ACTIONS(6361),
    [anon_sym_long] = ACTIONS(6361),
    [anon_sym_short] = ACTIONS(6361),
    [sym_primitive_type] = ACTIONS(6363),
    [anon_sym_enum] = ACTIONS(1833),
    [anon_sym_struct] = ACTIONS(6365),
    [anon_sym_union] = ACTIONS(6367),
    [sym_identifier] = ACTIONS(1588),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(6369),
    [sym_auto] = ACTIONS(6363),
    [anon_sym_typename] = ACTIONS(6371),
    [anon_sym_COLON_COLON] = ACTIONS(1594),
  },
  [2444] = {
    [sym_type_qualifier] = STATE(2656),
    [sym_trailing_return_type] = STATE(2656),
    [aux_sym_function_declarator_repeat1] = STATE(2656),
    [anon_sym_LPAREN] = ACTIONS(4933),
    [anon_sym_COMMA] = ACTIONS(4933),
    [anon_sym_SEMI] = ACTIONS(4933),
    [anon_sym_LBRACK] = ACTIONS(4933),
    [anon_sym_const] = ACTIONS(612),
    [anon_sym_restrict] = ACTIONS(614),
    [anon_sym_volatile] = ACTIONS(614),
    [anon_sym__Atomic] = ACTIONS(614),
    [anon_sym_mutable] = ACTIONS(614),
    [anon_sym_explicit] = ACTIONS(614),
    [anon_sym_constexpr] = ACTIONS(614),
    [anon_sym_COLON] = ACTIONS(4933),
    [anon_sym_DASH_GT] = ACTIONS(5761),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(6373),
  },
  [2445] = {
    [anon_sym_LPAREN] = ACTIONS(6375),
    [anon_sym_COMMA] = ACTIONS(6375),
    [anon_sym_RPAREN] = ACTIONS(6375),
    [anon_sym_SEMI] = ACTIONS(6375),
    [anon_sym_LBRACE] = ACTIONS(6375),
    [anon_sym_LBRACK] = ACTIONS(6375),
    [anon_sym_COLON] = ACTIONS(6375),
    [sym_comment] = ACTIONS(49),
  },
  [2446] = {
    [sym__abstract_declarator] = STATE(2657),
    [sym_abstract_pointer_declarator] = STATE(2657),
    [sym_abstract_function_declarator] = STATE(2657),
    [sym_abstract_array_declarator] = STATE(2657),
    [sym_parameter_list] = STATE(2449),
    [sym_abstract_reference_declarator] = STATE(2657),
    [anon_sym_LPAREN] = ACTIONS(1115),
    [anon_sym_COMMA] = ACTIONS(2270),
    [anon_sym_SEMI] = ACTIONS(2270),
    [anon_sym_LBRACE] = ACTIONS(2270),
    [anon_sym_STAR] = ACTIONS(5773),
    [anon_sym_LBRACK] = ACTIONS(1121),
    [anon_sym_const] = ACTIONS(4360),
    [anon_sym_restrict] = ACTIONS(2270),
    [anon_sym_volatile] = ACTIONS(2270),
    [anon_sym__Atomic] = ACTIONS(2270),
    [anon_sym_mutable] = ACTIONS(2270),
    [anon_sym_explicit] = ACTIONS(2270),
    [anon_sym_constexpr] = ACTIONS(2270),
    [anon_sym_COLON] = ACTIONS(2270),
    [anon_sym_AMP] = ACTIONS(5775),
    [anon_sym_AMP_AMP] = ACTIONS(5777),
    [anon_sym_DASH_GT] = ACTIONS(2270),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(2270),
  },
  [2447] = {
    [sym__abstract_declarator] = STATE(2658),
    [sym_abstract_pointer_declarator] = STATE(2658),
    [sym_abstract_function_declarator] = STATE(2658),
    [sym_abstract_array_declarator] = STATE(2658),
    [sym_parameter_list] = STATE(2449),
    [sym_abstract_reference_declarator] = STATE(2658),
    [anon_sym_LPAREN] = ACTIONS(1115),
    [anon_sym_COMMA] = ACTIONS(2278),
    [anon_sym_SEMI] = ACTIONS(2278),
    [anon_sym_LBRACE] = ACTIONS(2278),
    [anon_sym_STAR] = ACTIONS(5773),
    [anon_sym_LBRACK] = ACTIONS(1121),
    [anon_sym_const] = ACTIONS(4362),
    [anon_sym_restrict] = ACTIONS(2278),
    [anon_sym_volatile] = ACTIONS(2278),
    [anon_sym__Atomic] = ACTIONS(2278),
    [anon_sym_mutable] = ACTIONS(2278),
    [anon_sym_explicit] = ACTIONS(2278),
    [anon_sym_constexpr] = ACTIONS(2278),
    [anon_sym_COLON] = ACTIONS(2278),
    [anon_sym_AMP] = ACTIONS(5775),
    [anon_sym_AMP_AMP] = ACTIONS(5777),
    [anon_sym_DASH_GT] = ACTIONS(2278),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(2278),
  },
  [2448] = {
    [sym_parameter_list] = STATE(2659),
    [anon_sym_LPAREN] = ACTIONS(206),
    [anon_sym_COMMA] = ACTIONS(4364),
    [anon_sym_SEMI] = ACTIONS(4364),
    [anon_sym_LBRACE] = ACTIONS(4364),
    [anon_sym_LBRACK] = ACTIONS(2282),
    [anon_sym_const] = ACTIONS(4366),
    [anon_sym_restrict] = ACTIONS(4364),
    [anon_sym_volatile] = ACTIONS(4364),
    [anon_sym__Atomic] = ACTIONS(4364),
    [anon_sym_mutable] = ACTIONS(4364),
    [anon_sym_explicit] = ACTIONS(4364),
    [anon_sym_constexpr] = ACTIONS(4364),
    [anon_sym_COLON] = ACTIONS(4364),
    [anon_sym_DASH_GT] = ACTIONS(4364),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(4364),
  },
  [2449] = {
    [sym_type_qualifier] = STATE(2660),
    [sym_trailing_return_type] = STATE(1129),
    [aux_sym_abstract_function_declarator_repeat1] = STATE(2660),
    [anon_sym_LPAREN] = ACTIONS(2284),
    [anon_sym_COMMA] = ACTIONS(2284),
    [anon_sym_SEMI] = ACTIONS(2284),
    [anon_sym_LBRACE] = ACTIONS(2284),
    [anon_sym_LBRACK] = ACTIONS(2284),
    [anon_sym_const] = ACTIONS(4368),
    [anon_sym_restrict] = ACTIONS(2284),
    [anon_sym_volatile] = ACTIONS(2284),
    [anon_sym__Atomic] = ACTIONS(2284),
    [anon_sym_mutable] = ACTIONS(2284),
    [anon_sym_explicit] = ACTIONS(2284),
    [anon_sym_constexpr] = ACTIONS(2284),
    [anon_sym_COLON] = ACTIONS(2284),
    [anon_sym_DASH_GT] = ACTIONS(2284),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(2284),
  },
  [2450] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2450),
    [anon_sym_LPAREN] = ACTIONS(816),
    [anon_sym_COMMA] = ACTIONS(816),
    [anon_sym_SEMI] = ACTIONS(816),
    [anon_sym_LBRACE] = ACTIONS(816),
    [anon_sym_STAR] = ACTIONS(816),
    [anon_sym_LBRACK] = ACTIONS(816),
    [anon_sym_const] = ACTIONS(818),
    [anon_sym_restrict] = ACTIONS(818),
    [anon_sym_volatile] = ACTIONS(818),
    [anon_sym__Atomic] = ACTIONS(818),
    [anon_sym_mutable] = ACTIONS(818),
    [anon_sym_explicit] = ACTIONS(818),
    [anon_sym_constexpr] = ACTIONS(818),
    [anon_sym_unsigned] = ACTIONS(6377),
    [anon_sym_long] = ACTIONS(6377),
    [anon_sym_short] = ACTIONS(6377),
    [sym_primitive_type] = ACTIONS(818),
    [anon_sym_COLON] = ACTIONS(816),
    [anon_sym_AMP] = ACTIONS(818),
    [anon_sym_AMP_AMP] = ACTIONS(816),
    [anon_sym_DASH_GT] = ACTIONS(816),
    [sym_identifier] = ACTIONS(818),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(818),
  },
  [2451] = {
    [anon_sym_LPAREN] = ACTIONS(6380),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(6382),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(6380),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(6380),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(6380),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(6380),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(6380),
    [anon_sym_typedef] = ACTIONS(6382),
    [anon_sym_extern] = ACTIONS(6382),
    [anon_sym_RBRACE] = ACTIONS(6380),
    [anon_sym_STAR] = ACTIONS(6380),
    [anon_sym_static] = ACTIONS(6382),
    [anon_sym_register] = ACTIONS(6382),
    [anon_sym_inline] = ACTIONS(6382),
    [anon_sym_const] = ACTIONS(6382),
    [anon_sym_restrict] = ACTIONS(6382),
    [anon_sym_volatile] = ACTIONS(6382),
    [anon_sym__Atomic] = ACTIONS(6382),
    [anon_sym_mutable] = ACTIONS(6382),
    [anon_sym_explicit] = ACTIONS(6382),
    [anon_sym_constexpr] = ACTIONS(6382),
    [anon_sym_unsigned] = ACTIONS(6382),
    [anon_sym_long] = ACTIONS(6382),
    [anon_sym_short] = ACTIONS(6382),
    [sym_primitive_type] = ACTIONS(6382),
    [anon_sym_enum] = ACTIONS(6382),
    [anon_sym_struct] = ACTIONS(6382),
    [anon_sym_union] = ACTIONS(6382),
    [anon_sym_AMP] = ACTIONS(6382),
    [anon_sym_AMP_AMP] = ACTIONS(6380),
    [anon_sym_TILDE] = ACTIONS(6380),
    [sym_identifier] = ACTIONS(6382),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(6382),
    [anon_sym_public] = ACTIONS(6382),
    [sym_auto] = ACTIONS(6382),
    [anon_sym_typename] = ACTIONS(6382),
    [anon_sym_template] = ACTIONS(6382),
    [anon_sym_friend] = ACTIONS(6382),
    [anon_sym_private] = ACTIONS(6382),
    [anon_sym_protected] = ACTIONS(6382),
    [anon_sym_using] = ACTIONS(6382),
    [anon_sym_COLON_COLON] = ACTIONS(6380),
    [sym_operator_name] = ACTIONS(6380),
  },
  [2452] = {
    [anon_sym_LPAREN] = ACTIONS(3776),
    [anon_sym_COMMA] = ACTIONS(3776),
    [anon_sym_SEMI] = ACTIONS(3776),
    [anon_sym_LBRACE] = ACTIONS(3776),
    [anon_sym_STAR] = ACTIONS(3778),
    [anon_sym_LBRACK] = ACTIONS(3776),
    [anon_sym_EQ] = ACTIONS(3778),
    [anon_sym_COLON] = ACTIONS(3776),
    [anon_sym_QMARK] = ACTIONS(3776),
    [anon_sym_STAR_EQ] = ACTIONS(3776),
    [anon_sym_SLASH_EQ] = ACTIONS(3776),
    [anon_sym_PERCENT_EQ] = ACTIONS(3776),
    [anon_sym_PLUS_EQ] = ACTIONS(3776),
    [anon_sym_DASH_EQ] = ACTIONS(3776),
    [anon_sym_LT_LT_EQ] = ACTIONS(3776),
    [anon_sym_GT_GT_EQ] = ACTIONS(3776),
    [anon_sym_AMP_EQ] = ACTIONS(3776),
    [anon_sym_CARET_EQ] = ACTIONS(3776),
    [anon_sym_PIPE_EQ] = ACTIONS(3776),
    [anon_sym_AMP] = ACTIONS(3778),
    [anon_sym_PIPE_PIPE] = ACTIONS(3776),
    [anon_sym_AMP_AMP] = ACTIONS(3776),
    [anon_sym_PIPE] = ACTIONS(3778),
    [anon_sym_CARET] = ACTIONS(3778),
    [anon_sym_EQ_EQ] = ACTIONS(3776),
    [anon_sym_BANG_EQ] = ACTIONS(3776),
    [anon_sym_LT] = ACTIONS(3778),
    [anon_sym_GT] = ACTIONS(3778),
    [anon_sym_LT_EQ] = ACTIONS(3776),
    [anon_sym_GT_EQ] = ACTIONS(3776),
    [anon_sym_LT_LT] = ACTIONS(3778),
    [anon_sym_GT_GT] = ACTIONS(3778),
    [anon_sym_PLUS] = ACTIONS(3778),
    [anon_sym_DASH] = ACTIONS(3778),
    [anon_sym_SLASH] = ACTIONS(3778),
    [anon_sym_PERCENT] = ACTIONS(3778),
    [anon_sym_DASH_DASH] = ACTIONS(3776),
    [anon_sym_PLUS_PLUS] = ACTIONS(3776),
    [anon_sym_DOT] = ACTIONS(3776),
    [anon_sym_DASH_GT] = ACTIONS(3776),
    [sym_comment] = ACTIONS(49),
  },
  [2453] = {
    [sym_parameter_list] = STATE(2455),
    [anon_sym_LPAREN] = ACTIONS(206),
    [anon_sym_SEMI] = ACTIONS(3750),
    [anon_sym_LBRACE] = ACTIONS(3750),
    [anon_sym_LBRACK] = ACTIONS(2282),
    [anon_sym_const] = ACTIONS(5283),
    [anon_sym_restrict] = ACTIONS(3750),
    [anon_sym_volatile] = ACTIONS(3750),
    [anon_sym__Atomic] = ACTIONS(3750),
    [anon_sym_mutable] = ACTIONS(3750),
    [anon_sym_explicit] = ACTIONS(3750),
    [anon_sym_constexpr] = ACTIONS(3750),
    [anon_sym_COLON] = ACTIONS(3750),
    [anon_sym_DASH_GT] = ACTIONS(3750),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(3750),
  },
  [2454] = {
    [sym_parameter_list] = STATE(2455),
    [anon_sym_LPAREN] = ACTIONS(206),
    [anon_sym_SEMI] = ACTIONS(3762),
    [anon_sym_LBRACE] = ACTIONS(3762),
    [anon_sym_LBRACK] = ACTIONS(2282),
    [anon_sym_const] = ACTIONS(5285),
    [anon_sym_restrict] = ACTIONS(3762),
    [anon_sym_volatile] = ACTIONS(3762),
    [anon_sym__Atomic] = ACTIONS(3762),
    [anon_sym_mutable] = ACTIONS(3762),
    [anon_sym_explicit] = ACTIONS(3762),
    [anon_sym_constexpr] = ACTIONS(3762),
    [anon_sym_COLON] = ACTIONS(3762),
    [anon_sym_DASH_GT] = ACTIONS(3762),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(3762),
  },
  [2455] = {
    [sym_type_qualifier] = STATE(2661),
    [sym_trailing_return_type] = STATE(1713),
    [aux_sym_abstract_function_declarator_repeat1] = STATE(2661),
    [anon_sym_LPAREN] = ACTIONS(3764),
    [anon_sym_SEMI] = ACTIONS(3764),
    [anon_sym_LBRACE] = ACTIONS(3764),
    [anon_sym_LBRACK] = ACTIONS(3764),
    [anon_sym_const] = ACTIONS(3770),
    [anon_sym_restrict] = ACTIONS(3764),
    [anon_sym_volatile] = ACTIONS(3764),
    [anon_sym__Atomic] = ACTIONS(3764),
    [anon_sym_mutable] = ACTIONS(3764),
    [anon_sym_explicit] = ACTIONS(3764),
    [anon_sym_constexpr] = ACTIONS(3764),
    [anon_sym_COLON] = ACTIONS(3764),
    [anon_sym_DASH_GT] = ACTIONS(3764),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(3764),
  },
  [2456] = {
    [sym_type_qualifier] = STATE(2662),
    [sym_trailing_return_type] = STATE(1713),
    [aux_sym_abstract_function_declarator_repeat1] = STATE(2662),
    [anon_sym_LPAREN] = ACTIONS(3764),
    [anon_sym_SEMI] = ACTIONS(3764),
    [anon_sym_LBRACE] = ACTIONS(3764),
    [anon_sym_LBRACK] = ACTIONS(3764),
    [anon_sym_const] = ACTIONS(612),
    [anon_sym_restrict] = ACTIONS(614),
    [anon_sym_volatile] = ACTIONS(614),
    [anon_sym__Atomic] = ACTIONS(614),
    [anon_sym_mutable] = ACTIONS(614),
    [anon_sym_explicit] = ACTIONS(614),
    [anon_sym_constexpr] = ACTIONS(614),
    [anon_sym_COLON] = ACTIONS(3764),
    [anon_sym_DASH_GT] = ACTIONS(2102),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(6384),
  },
  [2457] = {
    [sym_argument_list] = STATE(802),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_COMMA] = ACTIONS(5984),
    [anon_sym_RPAREN] = ACTIONS(5984),
    [anon_sym_STAR] = ACTIONS(2234),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_EQ] = ACTIONS(5986),
    [anon_sym_QMARK] = ACTIONS(5984),
    [anon_sym_STAR_EQ] = ACTIONS(5984),
    [anon_sym_SLASH_EQ] = ACTIONS(5984),
    [anon_sym_PERCENT_EQ] = ACTIONS(5984),
    [anon_sym_PLUS_EQ] = ACTIONS(5984),
    [anon_sym_DASH_EQ] = ACTIONS(5984),
    [anon_sym_LT_LT_EQ] = ACTIONS(5984),
    [anon_sym_GT_GT_EQ] = ACTIONS(5984),
    [anon_sym_AMP_EQ] = ACTIONS(5984),
    [anon_sym_CARET_EQ] = ACTIONS(5984),
    [anon_sym_PIPE_EQ] = ACTIONS(5984),
    [anon_sym_AMP] = ACTIONS(2242),
    [anon_sym_PIPE_PIPE] = ACTIONS(2244),
    [anon_sym_AMP_AMP] = ACTIONS(2246),
    [anon_sym_PIPE] = ACTIONS(2248),
    [anon_sym_CARET] = ACTIONS(2250),
    [anon_sym_EQ_EQ] = ACTIONS(2252),
    [anon_sym_BANG_EQ] = ACTIONS(2252),
    [anon_sym_LT] = ACTIONS(2254),
    [anon_sym_GT] = ACTIONS(2254),
    [anon_sym_LT_EQ] = ACTIONS(2256),
    [anon_sym_GT_EQ] = ACTIONS(2256),
    [anon_sym_LT_LT] = ACTIONS(2258),
    [anon_sym_GT_GT] = ACTIONS(2258),
    [anon_sym_PLUS] = ACTIONS(2260),
    [anon_sym_DASH] = ACTIONS(2260),
    [anon_sym_SLASH] = ACTIONS(2234),
    [anon_sym_PERCENT] = ACTIONS(2234),
    [anon_sym_DASH_DASH] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(1554),
    [anon_sym_DASH_GT] = ACTIONS(1554),
    [sym_comment] = ACTIONS(49),
  },
  [2458] = {
    [sym_argument_list] = STATE(802),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_COMMA] = ACTIONS(5988),
    [anon_sym_RPAREN] = ACTIONS(5988),
    [anon_sym_STAR] = ACTIONS(2234),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_EQ] = ACTIONS(2236),
    [anon_sym_QMARK] = ACTIONS(2238),
    [anon_sym_STAR_EQ] = ACTIONS(2240),
    [anon_sym_SLASH_EQ] = ACTIONS(2240),
    [anon_sym_PERCENT_EQ] = ACTIONS(2240),
    [anon_sym_PLUS_EQ] = ACTIONS(2240),
    [anon_sym_DASH_EQ] = ACTIONS(2240),
    [anon_sym_LT_LT_EQ] = ACTIONS(2240),
    [anon_sym_GT_GT_EQ] = ACTIONS(2240),
    [anon_sym_AMP_EQ] = ACTIONS(2240),
    [anon_sym_CARET_EQ] = ACTIONS(2240),
    [anon_sym_PIPE_EQ] = ACTIONS(2240),
    [anon_sym_AMP] = ACTIONS(2242),
    [anon_sym_PIPE_PIPE] = ACTIONS(2244),
    [anon_sym_AMP_AMP] = ACTIONS(2246),
    [anon_sym_PIPE] = ACTIONS(2248),
    [anon_sym_CARET] = ACTIONS(2250),
    [anon_sym_EQ_EQ] = ACTIONS(2252),
    [anon_sym_BANG_EQ] = ACTIONS(2252),
    [anon_sym_LT] = ACTIONS(2254),
    [anon_sym_GT] = ACTIONS(2254),
    [anon_sym_LT_EQ] = ACTIONS(2256),
    [anon_sym_GT_EQ] = ACTIONS(2256),
    [anon_sym_LT_LT] = ACTIONS(2258),
    [anon_sym_GT_GT] = ACTIONS(2258),
    [anon_sym_PLUS] = ACTIONS(2260),
    [anon_sym_DASH] = ACTIONS(2260),
    [anon_sym_SLASH] = ACTIONS(2234),
    [anon_sym_PERCENT] = ACTIONS(2234),
    [anon_sym_DASH_DASH] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(1554),
    [anon_sym_DASH_GT] = ACTIONS(1554),
    [sym_comment] = ACTIONS(49),
  },
  [2459] = {
    [sym_parameter_list] = STATE(1707),
    [anon_sym_LPAREN] = ACTIONS(206),
    [anon_sym_RPAREN] = ACTIONS(4364),
    [anon_sym_LBRACK] = ACTIONS(2282),
    [sym_comment] = ACTIONS(49),
  },
  [2460] = {
    [anon_sym_LPAREN] = ACTIONS(6386),
    [anon_sym_COMMA] = ACTIONS(6386),
    [anon_sym_RPAREN] = ACTIONS(6386),
    [anon_sym_SEMI] = ACTIONS(6386),
    [anon_sym_LBRACE] = ACTIONS(6386),
    [anon_sym_LBRACK] = ACTIONS(6386),
    [anon_sym_EQ] = ACTIONS(6386),
    [anon_sym_const] = ACTIONS(6388),
    [anon_sym_restrict] = ACTIONS(6386),
    [anon_sym_volatile] = ACTIONS(6386),
    [anon_sym__Atomic] = ACTIONS(6386),
    [anon_sym_mutable] = ACTIONS(6386),
    [anon_sym_explicit] = ACTIONS(6386),
    [anon_sym_constexpr] = ACTIONS(6386),
    [anon_sym_COLON] = ACTIONS(6386),
    [anon_sym_GT] = ACTIONS(6386),
    [anon_sym_DASH_GT] = ACTIONS(6386),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(6386),
  },
  [2461] = {
    [anon_sym_COMMA] = ACTIONS(5086),
    [anon_sym_GT] = ACTIONS(5086),
    [sym_comment] = ACTIONS(49),
  },
  [2462] = {
    [anon_sym_COMMA] = ACTIONS(5106),
    [anon_sym_GT] = ACTIONS(5106),
    [sym_comment] = ACTIONS(49),
  },
  [2463] = {
    [sym__expression] = STATE(1780),
    [sym_conditional_expression] = STATE(1780),
    [sym_assignment_expression] = STATE(1780),
    [sym_pointer_expression] = STATE(1780),
    [sym_logical_expression] = STATE(1780),
    [sym_bitwise_expression] = STATE(1780),
    [sym_equality_expression] = STATE(1780),
    [sym_relational_expression] = STATE(1780),
    [sym_shift_expression] = STATE(1780),
    [sym_math_expression] = STATE(1780),
    [sym_cast_expression] = STATE(1780),
    [sym_sizeof_expression] = STATE(1780),
    [sym_subscript_expression] = STATE(1780),
    [sym_call_expression] = STATE(1780),
    [sym_field_expression] = STATE(1780),
    [sym_compound_literal_expression] = STATE(1780),
    [sym_parenthesized_expression] = STATE(1780),
    [sym_initializer_list] = STATE(1766),
    [sym_initializer_pair] = STATE(1766),
    [sym_subscript_designator] = STATE(671),
    [sym_field_designator] = STATE(671),
    [sym_concatenated_string] = STATE(1780),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(1780),
    [sym_new_expression] = STATE(1780),
    [sym_delete_expression] = STATE(1780),
    [sym_lambda_expression] = STATE(1780),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [aux_sym_initializer_pair_repeat1] = STATE(671),
    [sym_raw_string_literal] = ACTIONS(3962),
    [anon_sym_LPAREN] = ACTIONS(1321),
    [anon_sym_LBRACE] = ACTIONS(548),
    [anon_sym_RBRACE] = ACTIONS(6390),
    [anon_sym_STAR] = ACTIONS(1325),
    [anon_sym_LBRACK] = ACTIONS(1277),
    [anon_sym_AMP] = ACTIONS(1325),
    [anon_sym_BANG] = ACTIONS(1327),
    [anon_sym_TILDE] = ACTIONS(1329),
    [anon_sym_PLUS] = ACTIONS(1331),
    [anon_sym_DASH] = ACTIONS(1331),
    [anon_sym_DASH_DASH] = ACTIONS(1333),
    [anon_sym_PLUS_PLUS] = ACTIONS(1333),
    [anon_sym_sizeof] = ACTIONS(1335),
    [anon_sym_DOT] = ACTIONS(1289),
    [sym_number_literal] = ACTIONS(3962),
    [sym_char_literal] = ACTIONS(3962),
    [sym_string_literal] = ACTIONS(1337),
    [sym_true] = ACTIONS(3964),
    [sym_false] = ACTIONS(3964),
    [sym_null] = ACTIONS(3964),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1341),
    [anon_sym_delete] = ACTIONS(1343),
    [sym_nullptr] = ACTIONS(3964),
  },
  [2464] = {
    [sym__expression] = STATE(1834),
    [sym_conditional_expression] = STATE(1834),
    [sym_assignment_expression] = STATE(1834),
    [sym_pointer_expression] = STATE(1834),
    [sym_logical_expression] = STATE(1834),
    [sym_bitwise_expression] = STATE(1834),
    [sym_equality_expression] = STATE(1834),
    [sym_relational_expression] = STATE(1834),
    [sym_shift_expression] = STATE(1834),
    [sym_math_expression] = STATE(1834),
    [sym_cast_expression] = STATE(1834),
    [sym_sizeof_expression] = STATE(1834),
    [sym_subscript_expression] = STATE(1834),
    [sym_call_expression] = STATE(1834),
    [sym_field_expression] = STATE(1834),
    [sym_compound_literal_expression] = STATE(1834),
    [sym_parenthesized_expression] = STATE(1834),
    [sym_initializer_list] = STATE(1835),
    [sym_concatenated_string] = STATE(1834),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(1834),
    [sym_new_expression] = STATE(1834),
    [sym_delete_expression] = STATE(1834),
    [sym_lambda_expression] = STATE(1834),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(4145),
    [anon_sym_LPAREN] = ACTIONS(3807),
    [anon_sym_LBRACE] = ACTIONS(548),
    [anon_sym_STAR] = ACTIONS(3809),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_AMP] = ACTIONS(3809),
    [anon_sym_BANG] = ACTIONS(3811),
    [anon_sym_TILDE] = ACTIONS(3813),
    [anon_sym_PLUS] = ACTIONS(3815),
    [anon_sym_DASH] = ACTIONS(3815),
    [anon_sym_DASH_DASH] = ACTIONS(3817),
    [anon_sym_PLUS_PLUS] = ACTIONS(3817),
    [anon_sym_sizeof] = ACTIONS(3819),
    [sym_number_literal] = ACTIONS(4145),
    [sym_char_literal] = ACTIONS(4145),
    [sym_string_literal] = ACTIONS(3821),
    [sym_true] = ACTIONS(4147),
    [sym_false] = ACTIONS(4147),
    [sym_null] = ACTIONS(4147),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(3825),
    [anon_sym_delete] = ACTIONS(3827),
    [sym_nullptr] = ACTIONS(4147),
  },
  [2465] = {
    [anon_sym_RPAREN] = ACTIONS(6392),
    [sym_comment] = ACTIONS(49),
  },
  [2466] = {
    [aux_sym_concatenated_string_repeat1] = STATE(2466),
    [anon_sym_LPAREN] = ACTIONS(4230),
    [anon_sym_COMMA] = ACTIONS(4230),
    [anon_sym_STAR] = ACTIONS(4232),
    [anon_sym_LBRACK] = ACTIONS(4230),
    [anon_sym_EQ] = ACTIONS(4232),
    [anon_sym_QMARK] = ACTIONS(4230),
    [anon_sym_STAR_EQ] = ACTIONS(4230),
    [anon_sym_SLASH_EQ] = ACTIONS(4230),
    [anon_sym_PERCENT_EQ] = ACTIONS(4230),
    [anon_sym_PLUS_EQ] = ACTIONS(4230),
    [anon_sym_DASH_EQ] = ACTIONS(4230),
    [anon_sym_LT_LT_EQ] = ACTIONS(4230),
    [anon_sym_GT_GT_EQ] = ACTIONS(4230),
    [anon_sym_AMP_EQ] = ACTIONS(4230),
    [anon_sym_CARET_EQ] = ACTIONS(4230),
    [anon_sym_PIPE_EQ] = ACTIONS(4230),
    [anon_sym_AMP] = ACTIONS(4232),
    [anon_sym_PIPE_PIPE] = ACTIONS(4230),
    [anon_sym_AMP_AMP] = ACTIONS(4230),
    [anon_sym_PIPE] = ACTIONS(4232),
    [anon_sym_CARET] = ACTIONS(4232),
    [anon_sym_EQ_EQ] = ACTIONS(4230),
    [anon_sym_BANG_EQ] = ACTIONS(4230),
    [anon_sym_LT] = ACTIONS(4232),
    [anon_sym_GT] = ACTIONS(4232),
    [anon_sym_LT_EQ] = ACTIONS(4230),
    [anon_sym_GT_EQ] = ACTIONS(4230),
    [anon_sym_LT_LT] = ACTIONS(4232),
    [anon_sym_GT_GT] = ACTIONS(4232),
    [anon_sym_PLUS] = ACTIONS(4232),
    [anon_sym_DASH] = ACTIONS(4232),
    [anon_sym_SLASH] = ACTIONS(4232),
    [anon_sym_PERCENT] = ACTIONS(4232),
    [anon_sym_DASH_DASH] = ACTIONS(4230),
    [anon_sym_PLUS_PLUS] = ACTIONS(4230),
    [anon_sym_DOT] = ACTIONS(4230),
    [anon_sym_DASH_GT] = ACTIONS(4230),
    [sym_string_literal] = ACTIONS(6394),
    [sym_comment] = ACTIONS(49),
  },
  [2467] = {
    [sym__expression] = STATE(740),
    [sym_conditional_expression] = STATE(740),
    [sym_assignment_expression] = STATE(740),
    [sym_pointer_expression] = STATE(740),
    [sym_logical_expression] = STATE(740),
    [sym_bitwise_expression] = STATE(740),
    [sym_equality_expression] = STATE(740),
    [sym_relational_expression] = STATE(740),
    [sym_shift_expression] = STATE(740),
    [sym_math_expression] = STATE(740),
    [sym_cast_expression] = STATE(740),
    [sym_sizeof_expression] = STATE(740),
    [sym_subscript_expression] = STATE(740),
    [sym_call_expression] = STATE(740),
    [sym_field_expression] = STATE(740),
    [sym_compound_literal_expression] = STATE(740),
    [sym_parenthesized_expression] = STATE(740),
    [sym_concatenated_string] = STATE(740),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(740),
    [sym_new_expression] = STATE(740),
    [sym_delete_expression] = STATE(740),
    [sym_lambda_expression] = STATE(740),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_lambda_default_capture] = STATE(741),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(1417),
    [anon_sym_LPAREN] = ACTIONS(1419),
    [anon_sym_STAR] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_RBRACK] = ACTIONS(6397),
    [anon_sym_EQ] = ACTIONS(1425),
    [anon_sym_AMP] = ACTIONS(1427),
    [anon_sym_BANG] = ACTIONS(1429),
    [anon_sym_TILDE] = ACTIONS(1431),
    [anon_sym_PLUS] = ACTIONS(1433),
    [anon_sym_DASH] = ACTIONS(1433),
    [anon_sym_DASH_DASH] = ACTIONS(1435),
    [anon_sym_PLUS_PLUS] = ACTIONS(1435),
    [anon_sym_sizeof] = ACTIONS(1437),
    [sym_number_literal] = ACTIONS(1417),
    [sym_char_literal] = ACTIONS(1417),
    [sym_string_literal] = ACTIONS(1439),
    [sym_true] = ACTIONS(1441),
    [sym_false] = ACTIONS(1441),
    [sym_null] = ACTIONS(1441),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1443),
    [anon_sym_delete] = ACTIONS(1445),
    [sym_nullptr] = ACTIONS(1441),
  },
  [2468] = {
    [sym_argument_list] = STATE(802),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_COMMA] = ACTIONS(4258),
    [anon_sym_STAR] = ACTIONS(5039),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_EQ] = ACTIONS(4260),
    [anon_sym_QMARK] = ACTIONS(4258),
    [anon_sym_STAR_EQ] = ACTIONS(4258),
    [anon_sym_SLASH_EQ] = ACTIONS(4258),
    [anon_sym_PERCENT_EQ] = ACTIONS(4258),
    [anon_sym_PLUS_EQ] = ACTIONS(4258),
    [anon_sym_DASH_EQ] = ACTIONS(4258),
    [anon_sym_LT_LT_EQ] = ACTIONS(4258),
    [anon_sym_GT_GT_EQ] = ACTIONS(4258),
    [anon_sym_AMP_EQ] = ACTIONS(4258),
    [anon_sym_CARET_EQ] = ACTIONS(4258),
    [anon_sym_PIPE_EQ] = ACTIONS(4258),
    [anon_sym_AMP] = ACTIONS(5047),
    [anon_sym_PIPE_PIPE] = ACTIONS(5049),
    [anon_sym_AMP_AMP] = ACTIONS(5051),
    [anon_sym_PIPE] = ACTIONS(5053),
    [anon_sym_CARET] = ACTIONS(5055),
    [anon_sym_EQ_EQ] = ACTIONS(5057),
    [anon_sym_BANG_EQ] = ACTIONS(5057),
    [anon_sym_LT] = ACTIONS(5059),
    [anon_sym_GT] = ACTIONS(5059),
    [anon_sym_LT_EQ] = ACTIONS(5061),
    [anon_sym_GT_EQ] = ACTIONS(5061),
    [anon_sym_LT_LT] = ACTIONS(5063),
    [anon_sym_GT_GT] = ACTIONS(5063),
    [anon_sym_PLUS] = ACTIONS(5065),
    [anon_sym_DASH] = ACTIONS(5065),
    [anon_sym_SLASH] = ACTIONS(5039),
    [anon_sym_PERCENT] = ACTIONS(5039),
    [anon_sym_DASH_DASH] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(1554),
    [anon_sym_DASH_GT] = ACTIONS(1554),
    [sym_comment] = ACTIONS(49),
  },
  [2469] = {
    [sym__expression] = STATE(2666),
    [sym_conditional_expression] = STATE(2666),
    [sym_assignment_expression] = STATE(2666),
    [sym_pointer_expression] = STATE(2666),
    [sym_logical_expression] = STATE(2666),
    [sym_bitwise_expression] = STATE(2666),
    [sym_equality_expression] = STATE(2666),
    [sym_relational_expression] = STATE(2666),
    [sym_shift_expression] = STATE(2666),
    [sym_math_expression] = STATE(2666),
    [sym_cast_expression] = STATE(2666),
    [sym_sizeof_expression] = STATE(2666),
    [sym_subscript_expression] = STATE(2666),
    [sym_call_expression] = STATE(2666),
    [sym_field_expression] = STATE(2666),
    [sym_compound_literal_expression] = STATE(2666),
    [sym_parenthesized_expression] = STATE(2666),
    [sym_concatenated_string] = STATE(2666),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(2666),
    [sym_new_expression] = STATE(2666),
    [sym_delete_expression] = STATE(2666),
    [sym_lambda_expression] = STATE(2666),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(6399),
    [anon_sym_LPAREN] = ACTIONS(2624),
    [anon_sym_STAR] = ACTIONS(2624),
    [anon_sym_LBRACK] = ACTIONS(2624),
    [anon_sym_AMP] = ACTIONS(2626),
    [anon_sym_AMP_AMP] = ACTIONS(2624),
    [anon_sym_BANG] = ACTIONS(3811),
    [anon_sym_TILDE] = ACTIONS(3813),
    [anon_sym_PLUS] = ACTIONS(3815),
    [anon_sym_DASH] = ACTIONS(3815),
    [anon_sym_DASH_DASH] = ACTIONS(3817),
    [anon_sym_PLUS_PLUS] = ACTIONS(3817),
    [anon_sym_sizeof] = ACTIONS(3819),
    [sym_number_literal] = ACTIONS(6399),
    [sym_char_literal] = ACTIONS(6399),
    [sym_string_literal] = ACTIONS(3821),
    [sym_true] = ACTIONS(6401),
    [sym_false] = ACTIONS(6401),
    [sym_null] = ACTIONS(6401),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(3825),
    [anon_sym_delete] = ACTIONS(3827),
    [sym_nullptr] = ACTIONS(6401),
  },
  [2470] = {
    [sym_argument_list] = STATE(802),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_COMMA] = ACTIONS(4280),
    [anon_sym_STAR] = ACTIONS(5039),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_EQ] = ACTIONS(5041),
    [anon_sym_QMARK] = ACTIONS(4280),
    [anon_sym_STAR_EQ] = ACTIONS(5045),
    [anon_sym_SLASH_EQ] = ACTIONS(5045),
    [anon_sym_PERCENT_EQ] = ACTIONS(5045),
    [anon_sym_PLUS_EQ] = ACTIONS(5045),
    [anon_sym_DASH_EQ] = ACTIONS(5045),
    [anon_sym_LT_LT_EQ] = ACTIONS(5045),
    [anon_sym_GT_GT_EQ] = ACTIONS(5045),
    [anon_sym_AMP_EQ] = ACTIONS(5045),
    [anon_sym_CARET_EQ] = ACTIONS(5045),
    [anon_sym_PIPE_EQ] = ACTIONS(5045),
    [anon_sym_AMP] = ACTIONS(5047),
    [anon_sym_PIPE_PIPE] = ACTIONS(5049),
    [anon_sym_AMP_AMP] = ACTIONS(5051),
    [anon_sym_PIPE] = ACTIONS(5053),
    [anon_sym_CARET] = ACTIONS(5055),
    [anon_sym_EQ_EQ] = ACTIONS(5057),
    [anon_sym_BANG_EQ] = ACTIONS(5057),
    [anon_sym_LT] = ACTIONS(5059),
    [anon_sym_GT] = ACTIONS(5059),
    [anon_sym_LT_EQ] = ACTIONS(5061),
    [anon_sym_GT_EQ] = ACTIONS(5061),
    [anon_sym_LT_LT] = ACTIONS(5063),
    [anon_sym_GT_GT] = ACTIONS(5063),
    [anon_sym_PLUS] = ACTIONS(5065),
    [anon_sym_DASH] = ACTIONS(5065),
    [anon_sym_SLASH] = ACTIONS(5039),
    [anon_sym_PERCENT] = ACTIONS(5039),
    [anon_sym_DASH_DASH] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(1554),
    [anon_sym_DASH_GT] = ACTIONS(1554),
    [sym_comment] = ACTIONS(49),
  },
  [2471] = {
    [sym_argument_list] = STATE(802),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_STAR] = ACTIONS(3003),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_EQ] = ACTIONS(3005),
    [anon_sym_COLON] = ACTIONS(6403),
    [anon_sym_QMARK] = ACTIONS(3009),
    [anon_sym_STAR_EQ] = ACTIONS(3011),
    [anon_sym_SLASH_EQ] = ACTIONS(3011),
    [anon_sym_PERCENT_EQ] = ACTIONS(3011),
    [anon_sym_PLUS_EQ] = ACTIONS(3011),
    [anon_sym_DASH_EQ] = ACTIONS(3011),
    [anon_sym_LT_LT_EQ] = ACTIONS(3011),
    [anon_sym_GT_GT_EQ] = ACTIONS(3011),
    [anon_sym_AMP_EQ] = ACTIONS(3011),
    [anon_sym_CARET_EQ] = ACTIONS(3011),
    [anon_sym_PIPE_EQ] = ACTIONS(3011),
    [anon_sym_AMP] = ACTIONS(3013),
    [anon_sym_PIPE_PIPE] = ACTIONS(3015),
    [anon_sym_AMP_AMP] = ACTIONS(3017),
    [anon_sym_PIPE] = ACTIONS(3019),
    [anon_sym_CARET] = ACTIONS(3021),
    [anon_sym_EQ_EQ] = ACTIONS(3023),
    [anon_sym_BANG_EQ] = ACTIONS(3023),
    [anon_sym_LT] = ACTIONS(3025),
    [anon_sym_GT] = ACTIONS(3025),
    [anon_sym_LT_EQ] = ACTIONS(3027),
    [anon_sym_GT_EQ] = ACTIONS(3027),
    [anon_sym_LT_LT] = ACTIONS(3029),
    [anon_sym_GT_GT] = ACTIONS(3029),
    [anon_sym_PLUS] = ACTIONS(3031),
    [anon_sym_DASH] = ACTIONS(3031),
    [anon_sym_SLASH] = ACTIONS(3003),
    [anon_sym_PERCENT] = ACTIONS(3003),
    [anon_sym_DASH_DASH] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(3033),
    [anon_sym_DASH_GT] = ACTIONS(3033),
    [sym_comment] = ACTIONS(49),
  },
  [2472] = {
    [sym_argument_list] = STATE(802),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_COMMA] = ACTIONS(4284),
    [anon_sym_STAR] = ACTIONS(5039),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_EQ] = ACTIONS(4286),
    [anon_sym_QMARK] = ACTIONS(4284),
    [anon_sym_STAR_EQ] = ACTIONS(4284),
    [anon_sym_SLASH_EQ] = ACTIONS(4284),
    [anon_sym_PERCENT_EQ] = ACTIONS(4284),
    [anon_sym_PLUS_EQ] = ACTIONS(4284),
    [anon_sym_DASH_EQ] = ACTIONS(4284),
    [anon_sym_LT_LT_EQ] = ACTIONS(4284),
    [anon_sym_GT_GT_EQ] = ACTIONS(4284),
    [anon_sym_AMP_EQ] = ACTIONS(4284),
    [anon_sym_CARET_EQ] = ACTIONS(4284),
    [anon_sym_PIPE_EQ] = ACTIONS(4284),
    [anon_sym_AMP] = ACTIONS(4286),
    [anon_sym_PIPE_PIPE] = ACTIONS(4284),
    [anon_sym_AMP_AMP] = ACTIONS(4284),
    [anon_sym_PIPE] = ACTIONS(4286),
    [anon_sym_CARET] = ACTIONS(4286),
    [anon_sym_EQ_EQ] = ACTIONS(5057),
    [anon_sym_BANG_EQ] = ACTIONS(5057),
    [anon_sym_LT] = ACTIONS(5059),
    [anon_sym_GT] = ACTIONS(5059),
    [anon_sym_LT_EQ] = ACTIONS(5061),
    [anon_sym_GT_EQ] = ACTIONS(5061),
    [anon_sym_LT_LT] = ACTIONS(5063),
    [anon_sym_GT_GT] = ACTIONS(5063),
    [anon_sym_PLUS] = ACTIONS(5065),
    [anon_sym_DASH] = ACTIONS(5065),
    [anon_sym_SLASH] = ACTIONS(5039),
    [anon_sym_PERCENT] = ACTIONS(5039),
    [anon_sym_DASH_DASH] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(1554),
    [anon_sym_DASH_GT] = ACTIONS(1554),
    [sym_comment] = ACTIONS(49),
  },
  [2473] = {
    [sym_argument_list] = STATE(802),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_COMMA] = ACTIONS(4288),
    [anon_sym_STAR] = ACTIONS(5039),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_EQ] = ACTIONS(4290),
    [anon_sym_QMARK] = ACTIONS(4288),
    [anon_sym_STAR_EQ] = ACTIONS(4288),
    [anon_sym_SLASH_EQ] = ACTIONS(4288),
    [anon_sym_PERCENT_EQ] = ACTIONS(4288),
    [anon_sym_PLUS_EQ] = ACTIONS(4288),
    [anon_sym_DASH_EQ] = ACTIONS(4288),
    [anon_sym_LT_LT_EQ] = ACTIONS(4288),
    [anon_sym_GT_GT_EQ] = ACTIONS(4288),
    [anon_sym_AMP_EQ] = ACTIONS(4288),
    [anon_sym_CARET_EQ] = ACTIONS(4288),
    [anon_sym_PIPE_EQ] = ACTIONS(4288),
    [anon_sym_AMP] = ACTIONS(5047),
    [anon_sym_PIPE_PIPE] = ACTIONS(4288),
    [anon_sym_AMP_AMP] = ACTIONS(5051),
    [anon_sym_PIPE] = ACTIONS(5053),
    [anon_sym_CARET] = ACTIONS(5055),
    [anon_sym_EQ_EQ] = ACTIONS(5057),
    [anon_sym_BANG_EQ] = ACTIONS(5057),
    [anon_sym_LT] = ACTIONS(5059),
    [anon_sym_GT] = ACTIONS(5059),
    [anon_sym_LT_EQ] = ACTIONS(5061),
    [anon_sym_GT_EQ] = ACTIONS(5061),
    [anon_sym_LT_LT] = ACTIONS(5063),
    [anon_sym_GT_GT] = ACTIONS(5063),
    [anon_sym_PLUS] = ACTIONS(5065),
    [anon_sym_DASH] = ACTIONS(5065),
    [anon_sym_SLASH] = ACTIONS(5039),
    [anon_sym_PERCENT] = ACTIONS(5039),
    [anon_sym_DASH_DASH] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(1554),
    [anon_sym_DASH_GT] = ACTIONS(1554),
    [sym_comment] = ACTIONS(49),
  },
  [2474] = {
    [sym_argument_list] = STATE(802),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_COMMA] = ACTIONS(4288),
    [anon_sym_STAR] = ACTIONS(5039),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_EQ] = ACTIONS(4290),
    [anon_sym_QMARK] = ACTIONS(4288),
    [anon_sym_STAR_EQ] = ACTIONS(4288),
    [anon_sym_SLASH_EQ] = ACTIONS(4288),
    [anon_sym_PERCENT_EQ] = ACTIONS(4288),
    [anon_sym_PLUS_EQ] = ACTIONS(4288),
    [anon_sym_DASH_EQ] = ACTIONS(4288),
    [anon_sym_LT_LT_EQ] = ACTIONS(4288),
    [anon_sym_GT_GT_EQ] = ACTIONS(4288),
    [anon_sym_AMP_EQ] = ACTIONS(4288),
    [anon_sym_CARET_EQ] = ACTIONS(4288),
    [anon_sym_PIPE_EQ] = ACTIONS(4288),
    [anon_sym_AMP] = ACTIONS(5047),
    [anon_sym_PIPE_PIPE] = ACTIONS(4288),
    [anon_sym_AMP_AMP] = ACTIONS(4288),
    [anon_sym_PIPE] = ACTIONS(5053),
    [anon_sym_CARET] = ACTIONS(5055),
    [anon_sym_EQ_EQ] = ACTIONS(5057),
    [anon_sym_BANG_EQ] = ACTIONS(5057),
    [anon_sym_LT] = ACTIONS(5059),
    [anon_sym_GT] = ACTIONS(5059),
    [anon_sym_LT_EQ] = ACTIONS(5061),
    [anon_sym_GT_EQ] = ACTIONS(5061),
    [anon_sym_LT_LT] = ACTIONS(5063),
    [anon_sym_GT_GT] = ACTIONS(5063),
    [anon_sym_PLUS] = ACTIONS(5065),
    [anon_sym_DASH] = ACTIONS(5065),
    [anon_sym_SLASH] = ACTIONS(5039),
    [anon_sym_PERCENT] = ACTIONS(5039),
    [anon_sym_DASH_DASH] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(1554),
    [anon_sym_DASH_GT] = ACTIONS(1554),
    [sym_comment] = ACTIONS(49),
  },
  [2475] = {
    [sym_argument_list] = STATE(802),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_COMMA] = ACTIONS(4284),
    [anon_sym_STAR] = ACTIONS(5039),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_EQ] = ACTIONS(4286),
    [anon_sym_QMARK] = ACTIONS(4284),
    [anon_sym_STAR_EQ] = ACTIONS(4284),
    [anon_sym_SLASH_EQ] = ACTIONS(4284),
    [anon_sym_PERCENT_EQ] = ACTIONS(4284),
    [anon_sym_PLUS_EQ] = ACTIONS(4284),
    [anon_sym_DASH_EQ] = ACTIONS(4284),
    [anon_sym_LT_LT_EQ] = ACTIONS(4284),
    [anon_sym_GT_GT_EQ] = ACTIONS(4284),
    [anon_sym_AMP_EQ] = ACTIONS(4284),
    [anon_sym_CARET_EQ] = ACTIONS(4284),
    [anon_sym_PIPE_EQ] = ACTIONS(4284),
    [anon_sym_AMP] = ACTIONS(5047),
    [anon_sym_PIPE_PIPE] = ACTIONS(4284),
    [anon_sym_AMP_AMP] = ACTIONS(4284),
    [anon_sym_PIPE] = ACTIONS(4286),
    [anon_sym_CARET] = ACTIONS(5055),
    [anon_sym_EQ_EQ] = ACTIONS(5057),
    [anon_sym_BANG_EQ] = ACTIONS(5057),
    [anon_sym_LT] = ACTIONS(5059),
    [anon_sym_GT] = ACTIONS(5059),
    [anon_sym_LT_EQ] = ACTIONS(5061),
    [anon_sym_GT_EQ] = ACTIONS(5061),
    [anon_sym_LT_LT] = ACTIONS(5063),
    [anon_sym_GT_GT] = ACTIONS(5063),
    [anon_sym_PLUS] = ACTIONS(5065),
    [anon_sym_DASH] = ACTIONS(5065),
    [anon_sym_SLASH] = ACTIONS(5039),
    [anon_sym_PERCENT] = ACTIONS(5039),
    [anon_sym_DASH_DASH] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(1554),
    [anon_sym_DASH_GT] = ACTIONS(1554),
    [sym_comment] = ACTIONS(49),
  },
  [2476] = {
    [sym_argument_list] = STATE(802),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_COMMA] = ACTIONS(4284),
    [anon_sym_STAR] = ACTIONS(5039),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_EQ] = ACTIONS(4286),
    [anon_sym_QMARK] = ACTIONS(4284),
    [anon_sym_STAR_EQ] = ACTIONS(4284),
    [anon_sym_SLASH_EQ] = ACTIONS(4284),
    [anon_sym_PERCENT_EQ] = ACTIONS(4284),
    [anon_sym_PLUS_EQ] = ACTIONS(4284),
    [anon_sym_DASH_EQ] = ACTIONS(4284),
    [anon_sym_LT_LT_EQ] = ACTIONS(4284),
    [anon_sym_GT_GT_EQ] = ACTIONS(4284),
    [anon_sym_AMP_EQ] = ACTIONS(4284),
    [anon_sym_CARET_EQ] = ACTIONS(4284),
    [anon_sym_PIPE_EQ] = ACTIONS(4284),
    [anon_sym_AMP] = ACTIONS(5047),
    [anon_sym_PIPE_PIPE] = ACTIONS(4284),
    [anon_sym_AMP_AMP] = ACTIONS(4284),
    [anon_sym_PIPE] = ACTIONS(4286),
    [anon_sym_CARET] = ACTIONS(4286),
    [anon_sym_EQ_EQ] = ACTIONS(5057),
    [anon_sym_BANG_EQ] = ACTIONS(5057),
    [anon_sym_LT] = ACTIONS(5059),
    [anon_sym_GT] = ACTIONS(5059),
    [anon_sym_LT_EQ] = ACTIONS(5061),
    [anon_sym_GT_EQ] = ACTIONS(5061),
    [anon_sym_LT_LT] = ACTIONS(5063),
    [anon_sym_GT_GT] = ACTIONS(5063),
    [anon_sym_PLUS] = ACTIONS(5065),
    [anon_sym_DASH] = ACTIONS(5065),
    [anon_sym_SLASH] = ACTIONS(5039),
    [anon_sym_PERCENT] = ACTIONS(5039),
    [anon_sym_DASH_DASH] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(1554),
    [anon_sym_DASH_GT] = ACTIONS(1554),
    [sym_comment] = ACTIONS(49),
  },
  [2477] = {
    [sym_argument_list] = STATE(802),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_COMMA] = ACTIONS(4292),
    [anon_sym_STAR] = ACTIONS(5039),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_EQ] = ACTIONS(4294),
    [anon_sym_QMARK] = ACTIONS(4292),
    [anon_sym_STAR_EQ] = ACTIONS(4292),
    [anon_sym_SLASH_EQ] = ACTIONS(4292),
    [anon_sym_PERCENT_EQ] = ACTIONS(4292),
    [anon_sym_PLUS_EQ] = ACTIONS(4292),
    [anon_sym_DASH_EQ] = ACTIONS(4292),
    [anon_sym_LT_LT_EQ] = ACTIONS(4292),
    [anon_sym_GT_GT_EQ] = ACTIONS(4292),
    [anon_sym_AMP_EQ] = ACTIONS(4292),
    [anon_sym_CARET_EQ] = ACTIONS(4292),
    [anon_sym_PIPE_EQ] = ACTIONS(4292),
    [anon_sym_AMP] = ACTIONS(4294),
    [anon_sym_PIPE_PIPE] = ACTIONS(4292),
    [anon_sym_AMP_AMP] = ACTIONS(4292),
    [anon_sym_PIPE] = ACTIONS(4294),
    [anon_sym_CARET] = ACTIONS(4294),
    [anon_sym_EQ_EQ] = ACTIONS(4292),
    [anon_sym_BANG_EQ] = ACTIONS(4292),
    [anon_sym_LT] = ACTIONS(5059),
    [anon_sym_GT] = ACTIONS(5059),
    [anon_sym_LT_EQ] = ACTIONS(5061),
    [anon_sym_GT_EQ] = ACTIONS(5061),
    [anon_sym_LT_LT] = ACTIONS(5063),
    [anon_sym_GT_GT] = ACTIONS(5063),
    [anon_sym_PLUS] = ACTIONS(5065),
    [anon_sym_DASH] = ACTIONS(5065),
    [anon_sym_SLASH] = ACTIONS(5039),
    [anon_sym_PERCENT] = ACTIONS(5039),
    [anon_sym_DASH_DASH] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(1554),
    [anon_sym_DASH_GT] = ACTIONS(1554),
    [sym_comment] = ACTIONS(49),
  },
  [2478] = {
    [sym_argument_list] = STATE(802),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_COMMA] = ACTIONS(4296),
    [anon_sym_STAR] = ACTIONS(5039),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_EQ] = ACTIONS(4298),
    [anon_sym_QMARK] = ACTIONS(4296),
    [anon_sym_STAR_EQ] = ACTIONS(4296),
    [anon_sym_SLASH_EQ] = ACTIONS(4296),
    [anon_sym_PERCENT_EQ] = ACTIONS(4296),
    [anon_sym_PLUS_EQ] = ACTIONS(4296),
    [anon_sym_DASH_EQ] = ACTIONS(4296),
    [anon_sym_LT_LT_EQ] = ACTIONS(4296),
    [anon_sym_GT_GT_EQ] = ACTIONS(4296),
    [anon_sym_AMP_EQ] = ACTIONS(4296),
    [anon_sym_CARET_EQ] = ACTIONS(4296),
    [anon_sym_PIPE_EQ] = ACTIONS(4296),
    [anon_sym_AMP] = ACTIONS(4298),
    [anon_sym_PIPE_PIPE] = ACTIONS(4296),
    [anon_sym_AMP_AMP] = ACTIONS(4296),
    [anon_sym_PIPE] = ACTIONS(4298),
    [anon_sym_CARET] = ACTIONS(4298),
    [anon_sym_EQ_EQ] = ACTIONS(4296),
    [anon_sym_BANG_EQ] = ACTIONS(4296),
    [anon_sym_LT] = ACTIONS(4298),
    [anon_sym_GT] = ACTIONS(4298),
    [anon_sym_LT_EQ] = ACTIONS(4296),
    [anon_sym_GT_EQ] = ACTIONS(4296),
    [anon_sym_LT_LT] = ACTIONS(5063),
    [anon_sym_GT_GT] = ACTIONS(5063),
    [anon_sym_PLUS] = ACTIONS(5065),
    [anon_sym_DASH] = ACTIONS(5065),
    [anon_sym_SLASH] = ACTIONS(5039),
    [anon_sym_PERCENT] = ACTIONS(5039),
    [anon_sym_DASH_DASH] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(1554),
    [anon_sym_DASH_GT] = ACTIONS(1554),
    [sym_comment] = ACTIONS(49),
  },
  [2479] = {
    [sym_argument_list] = STATE(802),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_COMMA] = ACTIONS(4300),
    [anon_sym_STAR] = ACTIONS(5039),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_EQ] = ACTIONS(4302),
    [anon_sym_QMARK] = ACTIONS(4300),
    [anon_sym_STAR_EQ] = ACTIONS(4300),
    [anon_sym_SLASH_EQ] = ACTIONS(4300),
    [anon_sym_PERCENT_EQ] = ACTIONS(4300),
    [anon_sym_PLUS_EQ] = ACTIONS(4300),
    [anon_sym_DASH_EQ] = ACTIONS(4300),
    [anon_sym_LT_LT_EQ] = ACTIONS(4300),
    [anon_sym_GT_GT_EQ] = ACTIONS(4300),
    [anon_sym_AMP_EQ] = ACTIONS(4300),
    [anon_sym_CARET_EQ] = ACTIONS(4300),
    [anon_sym_PIPE_EQ] = ACTIONS(4300),
    [anon_sym_AMP] = ACTIONS(4302),
    [anon_sym_PIPE_PIPE] = ACTIONS(4300),
    [anon_sym_AMP_AMP] = ACTIONS(4300),
    [anon_sym_PIPE] = ACTIONS(4302),
    [anon_sym_CARET] = ACTIONS(4302),
    [anon_sym_EQ_EQ] = ACTIONS(4300),
    [anon_sym_BANG_EQ] = ACTIONS(4300),
    [anon_sym_LT] = ACTIONS(4302),
    [anon_sym_GT] = ACTIONS(4302),
    [anon_sym_LT_EQ] = ACTIONS(4300),
    [anon_sym_GT_EQ] = ACTIONS(4300),
    [anon_sym_LT_LT] = ACTIONS(4302),
    [anon_sym_GT_GT] = ACTIONS(4302),
    [anon_sym_PLUS] = ACTIONS(5065),
    [anon_sym_DASH] = ACTIONS(5065),
    [anon_sym_SLASH] = ACTIONS(5039),
    [anon_sym_PERCENT] = ACTIONS(5039),
    [anon_sym_DASH_DASH] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(1554),
    [anon_sym_DASH_GT] = ACTIONS(1554),
    [sym_comment] = ACTIONS(49),
  },
  [2480] = {
    [sym_argument_list] = STATE(802),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_COMMA] = ACTIONS(4274),
    [anon_sym_STAR] = ACTIONS(5039),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_EQ] = ACTIONS(4276),
    [anon_sym_QMARK] = ACTIONS(4274),
    [anon_sym_STAR_EQ] = ACTIONS(4274),
    [anon_sym_SLASH_EQ] = ACTIONS(4274),
    [anon_sym_PERCENT_EQ] = ACTIONS(4274),
    [anon_sym_PLUS_EQ] = ACTIONS(4274),
    [anon_sym_DASH_EQ] = ACTIONS(4274),
    [anon_sym_LT_LT_EQ] = ACTIONS(4274),
    [anon_sym_GT_GT_EQ] = ACTIONS(4274),
    [anon_sym_AMP_EQ] = ACTIONS(4274),
    [anon_sym_CARET_EQ] = ACTIONS(4274),
    [anon_sym_PIPE_EQ] = ACTIONS(4274),
    [anon_sym_AMP] = ACTIONS(4276),
    [anon_sym_PIPE_PIPE] = ACTIONS(4274),
    [anon_sym_AMP_AMP] = ACTIONS(4274),
    [anon_sym_PIPE] = ACTIONS(4276),
    [anon_sym_CARET] = ACTIONS(4276),
    [anon_sym_EQ_EQ] = ACTIONS(4274),
    [anon_sym_BANG_EQ] = ACTIONS(4274),
    [anon_sym_LT] = ACTIONS(4276),
    [anon_sym_GT] = ACTIONS(4276),
    [anon_sym_LT_EQ] = ACTIONS(4274),
    [anon_sym_GT_EQ] = ACTIONS(4274),
    [anon_sym_LT_LT] = ACTIONS(4276),
    [anon_sym_GT_GT] = ACTIONS(4276),
    [anon_sym_PLUS] = ACTIONS(4276),
    [anon_sym_DASH] = ACTIONS(4276),
    [anon_sym_SLASH] = ACTIONS(5039),
    [anon_sym_PERCENT] = ACTIONS(5039),
    [anon_sym_DASH_DASH] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(1554),
    [anon_sym_DASH_GT] = ACTIONS(1554),
    [sym_comment] = ACTIONS(49),
  },
  [2481] = {
    [sym__abstract_declarator] = STATE(2668),
    [sym_abstract_pointer_declarator] = STATE(2668),
    [sym_abstract_function_declarator] = STATE(2668),
    [sym_abstract_array_declarator] = STATE(2668),
    [sym_parameter_list] = STATE(2484),
    [sym_abstract_reference_declarator] = STATE(2668),
    [anon_sym_LPAREN] = ACTIONS(1115),
    [anon_sym_COMMA] = ACTIONS(2270),
    [anon_sym_LBRACE] = ACTIONS(2270),
    [anon_sym_STAR] = ACTIONS(5884),
    [anon_sym_LBRACK] = ACTIONS(1121),
    [anon_sym_EQ] = ACTIONS(2270),
    [anon_sym_const] = ACTIONS(4360),
    [anon_sym_restrict] = ACTIONS(2270),
    [anon_sym_volatile] = ACTIONS(2270),
    [anon_sym__Atomic] = ACTIONS(2270),
    [anon_sym_mutable] = ACTIONS(2270),
    [anon_sym_explicit] = ACTIONS(2270),
    [anon_sym_constexpr] = ACTIONS(2270),
    [anon_sym_AMP] = ACTIONS(5886),
    [anon_sym_AMP_AMP] = ACTIONS(5888),
    [anon_sym_GT] = ACTIONS(2270),
    [anon_sym_DASH_GT] = ACTIONS(2270),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(2270),
  },
  [2482] = {
    [sym__abstract_declarator] = STATE(2669),
    [sym_abstract_pointer_declarator] = STATE(2669),
    [sym_abstract_function_declarator] = STATE(2669),
    [sym_abstract_array_declarator] = STATE(2669),
    [sym_parameter_list] = STATE(2484),
    [sym_abstract_reference_declarator] = STATE(2669),
    [anon_sym_LPAREN] = ACTIONS(1115),
    [anon_sym_COMMA] = ACTIONS(2278),
    [anon_sym_LBRACE] = ACTIONS(2278),
    [anon_sym_STAR] = ACTIONS(5884),
    [anon_sym_LBRACK] = ACTIONS(1121),
    [anon_sym_EQ] = ACTIONS(2278),
    [anon_sym_const] = ACTIONS(4362),
    [anon_sym_restrict] = ACTIONS(2278),
    [anon_sym_volatile] = ACTIONS(2278),
    [anon_sym__Atomic] = ACTIONS(2278),
    [anon_sym_mutable] = ACTIONS(2278),
    [anon_sym_explicit] = ACTIONS(2278),
    [anon_sym_constexpr] = ACTIONS(2278),
    [anon_sym_AMP] = ACTIONS(5886),
    [anon_sym_AMP_AMP] = ACTIONS(5888),
    [anon_sym_GT] = ACTIONS(2278),
    [anon_sym_DASH_GT] = ACTIONS(2278),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(2278),
  },
  [2483] = {
    [sym_parameter_list] = STATE(2670),
    [anon_sym_LPAREN] = ACTIONS(206),
    [anon_sym_COMMA] = ACTIONS(4364),
    [anon_sym_LBRACE] = ACTIONS(4364),
    [anon_sym_LBRACK] = ACTIONS(2282),
    [anon_sym_EQ] = ACTIONS(4364),
    [anon_sym_const] = ACTIONS(4366),
    [anon_sym_restrict] = ACTIONS(4364),
    [anon_sym_volatile] = ACTIONS(4364),
    [anon_sym__Atomic] = ACTIONS(4364),
    [anon_sym_mutable] = ACTIONS(4364),
    [anon_sym_explicit] = ACTIONS(4364),
    [anon_sym_constexpr] = ACTIONS(4364),
    [anon_sym_GT] = ACTIONS(4364),
    [anon_sym_DASH_GT] = ACTIONS(4364),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(4364),
  },
  [2484] = {
    [sym_type_qualifier] = STATE(2671),
    [sym_trailing_return_type] = STATE(1129),
    [aux_sym_abstract_function_declarator_repeat1] = STATE(2671),
    [anon_sym_LPAREN] = ACTIONS(2284),
    [anon_sym_COMMA] = ACTIONS(2284),
    [anon_sym_LBRACE] = ACTIONS(2284),
    [anon_sym_LBRACK] = ACTIONS(2284),
    [anon_sym_EQ] = ACTIONS(2284),
    [anon_sym_const] = ACTIONS(4368),
    [anon_sym_restrict] = ACTIONS(2284),
    [anon_sym_volatile] = ACTIONS(2284),
    [anon_sym__Atomic] = ACTIONS(2284),
    [anon_sym_mutable] = ACTIONS(2284),
    [anon_sym_explicit] = ACTIONS(2284),
    [anon_sym_constexpr] = ACTIONS(2284),
    [anon_sym_GT] = ACTIONS(2284),
    [anon_sym_DASH_GT] = ACTIONS(2284),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(2284),
  },
  [2485] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2485),
    [anon_sym_LPAREN] = ACTIONS(816),
    [anon_sym_COMMA] = ACTIONS(816),
    [anon_sym_LBRACE] = ACTIONS(816),
    [anon_sym_STAR] = ACTIONS(816),
    [anon_sym_LBRACK] = ACTIONS(816),
    [anon_sym_EQ] = ACTIONS(816),
    [anon_sym_const] = ACTIONS(818),
    [anon_sym_restrict] = ACTIONS(818),
    [anon_sym_volatile] = ACTIONS(818),
    [anon_sym__Atomic] = ACTIONS(818),
    [anon_sym_mutable] = ACTIONS(818),
    [anon_sym_explicit] = ACTIONS(818),
    [anon_sym_constexpr] = ACTIONS(818),
    [anon_sym_unsigned] = ACTIONS(6405),
    [anon_sym_long] = ACTIONS(6405),
    [anon_sym_short] = ACTIONS(6405),
    [sym_primitive_type] = ACTIONS(818),
    [anon_sym_AMP] = ACTIONS(818),
    [anon_sym_AMP_AMP] = ACTIONS(816),
    [anon_sym_GT] = ACTIONS(816),
    [anon_sym_DASH_GT] = ACTIONS(816),
    [sym_identifier] = ACTIONS(818),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(818),
  },
  [2486] = {
    [sym_type_qualifier] = STATE(2205),
    [sym_trailing_return_type] = STATE(2168),
    [aux_sym_abstract_function_declarator_repeat1] = STATE(2205),
    [anon_sym_LPAREN] = ACTIONS(4998),
    [anon_sym_SEMI] = ACTIONS(4998),
    [anon_sym_LBRACK] = ACTIONS(4998),
    [anon_sym_const] = ACTIONS(612),
    [anon_sym_restrict] = ACTIONS(614),
    [anon_sym_volatile] = ACTIONS(614),
    [anon_sym__Atomic] = ACTIONS(614),
    [anon_sym_mutable] = ACTIONS(614),
    [anon_sym_explicit] = ACTIONS(614),
    [anon_sym_constexpr] = ACTIONS(614),
    [anon_sym_DASH_GT] = ACTIONS(1194),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(5082),
  },
  [2487] = {
    [sym_parameter_list] = STATE(1747),
    [anon_sym_LPAREN] = ACTIONS(206),
    [anon_sym_SEMI] = ACTIONS(4364),
    [anon_sym_LBRACK] = ACTIONS(2282),
    [sym_comment] = ACTIONS(49),
  },
  [2488] = {
    [sym_argument_list] = STATE(802),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_COMMA] = ACTIONS(5984),
    [anon_sym_SEMI] = ACTIONS(5984),
    [anon_sym_RBRACE] = ACTIONS(5984),
    [anon_sym_STAR] = ACTIONS(2428),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_EQ] = ACTIONS(5986),
    [anon_sym_QMARK] = ACTIONS(5984),
    [anon_sym_STAR_EQ] = ACTIONS(5984),
    [anon_sym_SLASH_EQ] = ACTIONS(5984),
    [anon_sym_PERCENT_EQ] = ACTIONS(5984),
    [anon_sym_PLUS_EQ] = ACTIONS(5984),
    [anon_sym_DASH_EQ] = ACTIONS(5984),
    [anon_sym_LT_LT_EQ] = ACTIONS(5984),
    [anon_sym_GT_GT_EQ] = ACTIONS(5984),
    [anon_sym_AMP_EQ] = ACTIONS(5984),
    [anon_sym_CARET_EQ] = ACTIONS(5984),
    [anon_sym_PIPE_EQ] = ACTIONS(5984),
    [anon_sym_AMP] = ACTIONS(2436),
    [anon_sym_PIPE_PIPE] = ACTIONS(2438),
    [anon_sym_AMP_AMP] = ACTIONS(2440),
    [anon_sym_PIPE] = ACTIONS(2442),
    [anon_sym_CARET] = ACTIONS(2444),
    [anon_sym_EQ_EQ] = ACTIONS(2446),
    [anon_sym_BANG_EQ] = ACTIONS(2446),
    [anon_sym_LT] = ACTIONS(2448),
    [anon_sym_GT] = ACTIONS(2448),
    [anon_sym_LT_EQ] = ACTIONS(2450),
    [anon_sym_GT_EQ] = ACTIONS(2450),
    [anon_sym_LT_LT] = ACTIONS(2452),
    [anon_sym_GT_GT] = ACTIONS(2452),
    [anon_sym_PLUS] = ACTIONS(2454),
    [anon_sym_DASH] = ACTIONS(2454),
    [anon_sym_SLASH] = ACTIONS(2428),
    [anon_sym_PERCENT] = ACTIONS(2428),
    [anon_sym_DASH_DASH] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(1554),
    [anon_sym_DASH_GT] = ACTIONS(1554),
    [sym_comment] = ACTIONS(49),
  },
  [2489] = {
    [sym_argument_list] = STATE(802),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_COMMA] = ACTIONS(5988),
    [anon_sym_SEMI] = ACTIONS(5988),
    [anon_sym_RBRACE] = ACTIONS(5988),
    [anon_sym_STAR] = ACTIONS(2428),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_EQ] = ACTIONS(2430),
    [anon_sym_QMARK] = ACTIONS(2432),
    [anon_sym_STAR_EQ] = ACTIONS(2434),
    [anon_sym_SLASH_EQ] = ACTIONS(2434),
    [anon_sym_PERCENT_EQ] = ACTIONS(2434),
    [anon_sym_PLUS_EQ] = ACTIONS(2434),
    [anon_sym_DASH_EQ] = ACTIONS(2434),
    [anon_sym_LT_LT_EQ] = ACTIONS(2434),
    [anon_sym_GT_GT_EQ] = ACTIONS(2434),
    [anon_sym_AMP_EQ] = ACTIONS(2434),
    [anon_sym_CARET_EQ] = ACTIONS(2434),
    [anon_sym_PIPE_EQ] = ACTIONS(2434),
    [anon_sym_AMP] = ACTIONS(2436),
    [anon_sym_PIPE_PIPE] = ACTIONS(2438),
    [anon_sym_AMP_AMP] = ACTIONS(2440),
    [anon_sym_PIPE] = ACTIONS(2442),
    [anon_sym_CARET] = ACTIONS(2444),
    [anon_sym_EQ_EQ] = ACTIONS(2446),
    [anon_sym_BANG_EQ] = ACTIONS(2446),
    [anon_sym_LT] = ACTIONS(2448),
    [anon_sym_GT] = ACTIONS(2448),
    [anon_sym_LT_EQ] = ACTIONS(2450),
    [anon_sym_GT_EQ] = ACTIONS(2450),
    [anon_sym_LT_LT] = ACTIONS(2452),
    [anon_sym_GT_GT] = ACTIONS(2452),
    [anon_sym_PLUS] = ACTIONS(2454),
    [anon_sym_DASH] = ACTIONS(2454),
    [anon_sym_SLASH] = ACTIONS(2428),
    [anon_sym_PERCENT] = ACTIONS(2428),
    [anon_sym_DASH_DASH] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(1554),
    [anon_sym_DASH_GT] = ACTIONS(1554),
    [sym_comment] = ACTIONS(49),
  },
  [2490] = {
    [sym_type_qualifier] = STATE(2491),
    [sym_trailing_return_type] = STATE(2168),
    [aux_sym_abstract_function_declarator_repeat1] = STATE(2491),
    [anon_sym_LPAREN] = ACTIONS(4998),
    [anon_sym_COMMA] = ACTIONS(4998),
    [anon_sym_SEMI] = ACTIONS(4998),
    [anon_sym_LBRACE] = ACTIONS(4998),
    [anon_sym_LBRACK] = ACTIONS(4998),
    [anon_sym_EQ] = ACTIONS(4998),
    [anon_sym_const] = ACTIONS(612),
    [anon_sym_restrict] = ACTIONS(614),
    [anon_sym_volatile] = ACTIONS(614),
    [anon_sym__Atomic] = ACTIONS(614),
    [anon_sym_mutable] = ACTIONS(614),
    [anon_sym_explicit] = ACTIONS(614),
    [anon_sym_constexpr] = ACTIONS(614),
    [anon_sym_DASH_GT] = ACTIONS(1309),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(5917),
  },
  [2491] = {
    [sym_type_qualifier] = STATE(2491),
    [aux_sym_abstract_function_declarator_repeat1] = STATE(2491),
    [anon_sym_LPAREN] = ACTIONS(5002),
    [anon_sym_COMMA] = ACTIONS(5002),
    [anon_sym_SEMI] = ACTIONS(5002),
    [anon_sym_LBRACE] = ACTIONS(5002),
    [anon_sym_LBRACK] = ACTIONS(5002),
    [anon_sym_EQ] = ACTIONS(5002),
    [anon_sym_const] = ACTIONS(5004),
    [anon_sym_restrict] = ACTIONS(5007),
    [anon_sym_volatile] = ACTIONS(5007),
    [anon_sym__Atomic] = ACTIONS(5007),
    [anon_sym_mutable] = ACTIONS(5007),
    [anon_sym_explicit] = ACTIONS(5007),
    [anon_sym_constexpr] = ACTIONS(5007),
    [anon_sym_DASH_GT] = ACTIONS(5002),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(6408),
  },
  [2492] = {
    [sym_argument_list] = STATE(802),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_COMMA] = ACTIONS(5984),
    [anon_sym_RBRACE] = ACTIONS(5984),
    [anon_sym_STAR] = ACTIONS(2507),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_EQ] = ACTIONS(5986),
    [anon_sym_QMARK] = ACTIONS(5984),
    [anon_sym_STAR_EQ] = ACTIONS(5984),
    [anon_sym_SLASH_EQ] = ACTIONS(5984),
    [anon_sym_PERCENT_EQ] = ACTIONS(5984),
    [anon_sym_PLUS_EQ] = ACTIONS(5984),
    [anon_sym_DASH_EQ] = ACTIONS(5984),
    [anon_sym_LT_LT_EQ] = ACTIONS(5984),
    [anon_sym_GT_GT_EQ] = ACTIONS(5984),
    [anon_sym_AMP_EQ] = ACTIONS(5984),
    [anon_sym_CARET_EQ] = ACTIONS(5984),
    [anon_sym_PIPE_EQ] = ACTIONS(5984),
    [anon_sym_AMP] = ACTIONS(2515),
    [anon_sym_PIPE_PIPE] = ACTIONS(2517),
    [anon_sym_AMP_AMP] = ACTIONS(2519),
    [anon_sym_PIPE] = ACTIONS(2521),
    [anon_sym_CARET] = ACTIONS(2523),
    [anon_sym_EQ_EQ] = ACTIONS(2525),
    [anon_sym_BANG_EQ] = ACTIONS(2525),
    [anon_sym_LT] = ACTIONS(2527),
    [anon_sym_GT] = ACTIONS(2527),
    [anon_sym_LT_EQ] = ACTIONS(2529),
    [anon_sym_GT_EQ] = ACTIONS(2529),
    [anon_sym_LT_LT] = ACTIONS(2531),
    [anon_sym_GT_GT] = ACTIONS(2531),
    [anon_sym_PLUS] = ACTIONS(2533),
    [anon_sym_DASH] = ACTIONS(2533),
    [anon_sym_SLASH] = ACTIONS(2507),
    [anon_sym_PERCENT] = ACTIONS(2507),
    [anon_sym_DASH_DASH] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(1554),
    [anon_sym_DASH_GT] = ACTIONS(1554),
    [sym_comment] = ACTIONS(49),
  },
  [2493] = {
    [sym_argument_list] = STATE(802),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_COMMA] = ACTIONS(5988),
    [anon_sym_RBRACE] = ACTIONS(5988),
    [anon_sym_STAR] = ACTIONS(2507),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_EQ] = ACTIONS(2509),
    [anon_sym_QMARK] = ACTIONS(2511),
    [anon_sym_STAR_EQ] = ACTIONS(2513),
    [anon_sym_SLASH_EQ] = ACTIONS(2513),
    [anon_sym_PERCENT_EQ] = ACTIONS(2513),
    [anon_sym_PLUS_EQ] = ACTIONS(2513),
    [anon_sym_DASH_EQ] = ACTIONS(2513),
    [anon_sym_LT_LT_EQ] = ACTIONS(2513),
    [anon_sym_GT_GT_EQ] = ACTIONS(2513),
    [anon_sym_AMP_EQ] = ACTIONS(2513),
    [anon_sym_CARET_EQ] = ACTIONS(2513),
    [anon_sym_PIPE_EQ] = ACTIONS(2513),
    [anon_sym_AMP] = ACTIONS(2515),
    [anon_sym_PIPE_PIPE] = ACTIONS(2517),
    [anon_sym_AMP_AMP] = ACTIONS(2519),
    [anon_sym_PIPE] = ACTIONS(2521),
    [anon_sym_CARET] = ACTIONS(2523),
    [anon_sym_EQ_EQ] = ACTIONS(2525),
    [anon_sym_BANG_EQ] = ACTIONS(2525),
    [anon_sym_LT] = ACTIONS(2527),
    [anon_sym_GT] = ACTIONS(2527),
    [anon_sym_LT_EQ] = ACTIONS(2529),
    [anon_sym_GT_EQ] = ACTIONS(2529),
    [anon_sym_LT_LT] = ACTIONS(2531),
    [anon_sym_GT_GT] = ACTIONS(2531),
    [anon_sym_PLUS] = ACTIONS(2533),
    [anon_sym_DASH] = ACTIONS(2533),
    [anon_sym_SLASH] = ACTIONS(2507),
    [anon_sym_PERCENT] = ACTIONS(2507),
    [anon_sym_DASH_DASH] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(1554),
    [anon_sym_DASH_GT] = ACTIONS(1554),
    [sym_comment] = ACTIONS(49),
  },
  [2494] = {
    [sym_argument_list] = STATE(802),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_SEMI] = ACTIONS(5984),
    [anon_sym_STAR] = ACTIONS(2553),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_EQ] = ACTIONS(5986),
    [anon_sym_QMARK] = ACTIONS(5984),
    [anon_sym_STAR_EQ] = ACTIONS(5984),
    [anon_sym_SLASH_EQ] = ACTIONS(5984),
    [anon_sym_PERCENT_EQ] = ACTIONS(5984),
    [anon_sym_PLUS_EQ] = ACTIONS(5984),
    [anon_sym_DASH_EQ] = ACTIONS(5984),
    [anon_sym_LT_LT_EQ] = ACTIONS(5984),
    [anon_sym_GT_GT_EQ] = ACTIONS(5984),
    [anon_sym_AMP_EQ] = ACTIONS(5984),
    [anon_sym_CARET_EQ] = ACTIONS(5984),
    [anon_sym_PIPE_EQ] = ACTIONS(5984),
    [anon_sym_AMP] = ACTIONS(2561),
    [anon_sym_PIPE_PIPE] = ACTIONS(2563),
    [anon_sym_AMP_AMP] = ACTIONS(2565),
    [anon_sym_PIPE] = ACTIONS(2567),
    [anon_sym_CARET] = ACTIONS(2569),
    [anon_sym_EQ_EQ] = ACTIONS(2571),
    [anon_sym_BANG_EQ] = ACTIONS(2571),
    [anon_sym_LT] = ACTIONS(2573),
    [anon_sym_GT] = ACTIONS(2573),
    [anon_sym_LT_EQ] = ACTIONS(2575),
    [anon_sym_GT_EQ] = ACTIONS(2575),
    [anon_sym_LT_LT] = ACTIONS(2577),
    [anon_sym_GT_GT] = ACTIONS(2577),
    [anon_sym_PLUS] = ACTIONS(2579),
    [anon_sym_DASH] = ACTIONS(2579),
    [anon_sym_SLASH] = ACTIONS(2553),
    [anon_sym_PERCENT] = ACTIONS(2553),
    [anon_sym_DASH_DASH] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(1554),
    [anon_sym_DASH_GT] = ACTIONS(1554),
    [sym_comment] = ACTIONS(49),
  },
  [2495] = {
    [sym_argument_list] = STATE(802),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_SEMI] = ACTIONS(5988),
    [anon_sym_STAR] = ACTIONS(2553),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_EQ] = ACTIONS(2555),
    [anon_sym_QMARK] = ACTIONS(2557),
    [anon_sym_STAR_EQ] = ACTIONS(2559),
    [anon_sym_SLASH_EQ] = ACTIONS(2559),
    [anon_sym_PERCENT_EQ] = ACTIONS(2559),
    [anon_sym_PLUS_EQ] = ACTIONS(2559),
    [anon_sym_DASH_EQ] = ACTIONS(2559),
    [anon_sym_LT_LT_EQ] = ACTIONS(2559),
    [anon_sym_GT_GT_EQ] = ACTIONS(2559),
    [anon_sym_AMP_EQ] = ACTIONS(2559),
    [anon_sym_CARET_EQ] = ACTIONS(2559),
    [anon_sym_PIPE_EQ] = ACTIONS(2559),
    [anon_sym_AMP] = ACTIONS(2561),
    [anon_sym_PIPE_PIPE] = ACTIONS(2563),
    [anon_sym_AMP_AMP] = ACTIONS(2565),
    [anon_sym_PIPE] = ACTIONS(2567),
    [anon_sym_CARET] = ACTIONS(2569),
    [anon_sym_EQ_EQ] = ACTIONS(2571),
    [anon_sym_BANG_EQ] = ACTIONS(2571),
    [anon_sym_LT] = ACTIONS(2573),
    [anon_sym_GT] = ACTIONS(2573),
    [anon_sym_LT_EQ] = ACTIONS(2575),
    [anon_sym_GT_EQ] = ACTIONS(2575),
    [anon_sym_LT_LT] = ACTIONS(2577),
    [anon_sym_GT_GT] = ACTIONS(2577),
    [anon_sym_PLUS] = ACTIONS(2579),
    [anon_sym_DASH] = ACTIONS(2579),
    [anon_sym_SLASH] = ACTIONS(2553),
    [anon_sym_PERCENT] = ACTIONS(2553),
    [anon_sym_DASH_DASH] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(1554),
    [anon_sym_DASH_GT] = ACTIONS(1554),
    [sym_comment] = ACTIONS(49),
  },
  [2496] = {
    [sym__abstract_declarator] = STATE(2672),
    [sym_abstract_pointer_declarator] = STATE(2672),
    [sym_abstract_function_declarator] = STATE(2672),
    [sym_abstract_array_declarator] = STATE(2672),
    [sym_parameter_list] = STATE(2499),
    [sym_abstract_reference_declarator] = STATE(2672),
    [anon_sym_LPAREN] = ACTIONS(1115),
    [anon_sym_COMMA] = ACTIONS(2270),
    [anon_sym_RPAREN] = ACTIONS(2270),
    [anon_sym_LBRACE] = ACTIONS(2270),
    [anon_sym_STAR] = ACTIONS(5943),
    [anon_sym_LBRACK] = ACTIONS(1121),
    [anon_sym_EQ] = ACTIONS(2270),
    [anon_sym_const] = ACTIONS(4360),
    [anon_sym_restrict] = ACTIONS(2270),
    [anon_sym_volatile] = ACTIONS(2270),
    [anon_sym__Atomic] = ACTIONS(2270),
    [anon_sym_mutable] = ACTIONS(2270),
    [anon_sym_explicit] = ACTIONS(2270),
    [anon_sym_constexpr] = ACTIONS(2270),
    [anon_sym_AMP] = ACTIONS(5945),
    [anon_sym_AMP_AMP] = ACTIONS(5947),
    [anon_sym_DASH_GT] = ACTIONS(2270),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(2270),
  },
  [2497] = {
    [sym__abstract_declarator] = STATE(2673),
    [sym_abstract_pointer_declarator] = STATE(2673),
    [sym_abstract_function_declarator] = STATE(2673),
    [sym_abstract_array_declarator] = STATE(2673),
    [sym_parameter_list] = STATE(2499),
    [sym_abstract_reference_declarator] = STATE(2673),
    [anon_sym_LPAREN] = ACTIONS(1115),
    [anon_sym_COMMA] = ACTIONS(2278),
    [anon_sym_RPAREN] = ACTIONS(2278),
    [anon_sym_LBRACE] = ACTIONS(2278),
    [anon_sym_STAR] = ACTIONS(5943),
    [anon_sym_LBRACK] = ACTIONS(1121),
    [anon_sym_EQ] = ACTIONS(2278),
    [anon_sym_const] = ACTIONS(4362),
    [anon_sym_restrict] = ACTIONS(2278),
    [anon_sym_volatile] = ACTIONS(2278),
    [anon_sym__Atomic] = ACTIONS(2278),
    [anon_sym_mutable] = ACTIONS(2278),
    [anon_sym_explicit] = ACTIONS(2278),
    [anon_sym_constexpr] = ACTIONS(2278),
    [anon_sym_AMP] = ACTIONS(5945),
    [anon_sym_AMP_AMP] = ACTIONS(5947),
    [anon_sym_DASH_GT] = ACTIONS(2278),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(2278),
  },
  [2498] = {
    [sym_parameter_list] = STATE(2674),
    [anon_sym_LPAREN] = ACTIONS(206),
    [anon_sym_COMMA] = ACTIONS(4364),
    [anon_sym_RPAREN] = ACTIONS(4364),
    [anon_sym_LBRACE] = ACTIONS(4364),
    [anon_sym_LBRACK] = ACTIONS(2282),
    [anon_sym_EQ] = ACTIONS(4364),
    [anon_sym_const] = ACTIONS(4366),
    [anon_sym_restrict] = ACTIONS(4364),
    [anon_sym_volatile] = ACTIONS(4364),
    [anon_sym__Atomic] = ACTIONS(4364),
    [anon_sym_mutable] = ACTIONS(4364),
    [anon_sym_explicit] = ACTIONS(4364),
    [anon_sym_constexpr] = ACTIONS(4364),
    [anon_sym_DASH_GT] = ACTIONS(4364),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(4364),
  },
  [2499] = {
    [sym_type_qualifier] = STATE(2675),
    [sym_trailing_return_type] = STATE(1129),
    [aux_sym_abstract_function_declarator_repeat1] = STATE(2675),
    [anon_sym_LPAREN] = ACTIONS(2284),
    [anon_sym_COMMA] = ACTIONS(2284),
    [anon_sym_RPAREN] = ACTIONS(2284),
    [anon_sym_LBRACE] = ACTIONS(2284),
    [anon_sym_LBRACK] = ACTIONS(2284),
    [anon_sym_EQ] = ACTIONS(2284),
    [anon_sym_const] = ACTIONS(4368),
    [anon_sym_restrict] = ACTIONS(2284),
    [anon_sym_volatile] = ACTIONS(2284),
    [anon_sym__Atomic] = ACTIONS(2284),
    [anon_sym_mutable] = ACTIONS(2284),
    [anon_sym_explicit] = ACTIONS(2284),
    [anon_sym_constexpr] = ACTIONS(2284),
    [anon_sym_DASH_GT] = ACTIONS(2284),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(2284),
  },
  [2500] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2500),
    [anon_sym_LPAREN] = ACTIONS(816),
    [anon_sym_COMMA] = ACTIONS(816),
    [anon_sym_RPAREN] = ACTIONS(816),
    [anon_sym_LBRACE] = ACTIONS(816),
    [anon_sym_STAR] = ACTIONS(816),
    [anon_sym_LBRACK] = ACTIONS(816),
    [anon_sym_EQ] = ACTIONS(816),
    [anon_sym_const] = ACTIONS(818),
    [anon_sym_restrict] = ACTIONS(818),
    [anon_sym_volatile] = ACTIONS(818),
    [anon_sym__Atomic] = ACTIONS(818),
    [anon_sym_mutable] = ACTIONS(818),
    [anon_sym_explicit] = ACTIONS(818),
    [anon_sym_constexpr] = ACTIONS(818),
    [anon_sym_unsigned] = ACTIONS(6411),
    [anon_sym_long] = ACTIONS(6411),
    [anon_sym_short] = ACTIONS(6411),
    [sym_primitive_type] = ACTIONS(818),
    [anon_sym_AMP] = ACTIONS(818),
    [anon_sym_AMP_AMP] = ACTIONS(816),
    [anon_sym_DASH_GT] = ACTIONS(816),
    [sym_identifier] = ACTIONS(818),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(818),
  },
  [2501] = {
    [sym_argument_list] = STATE(802),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_COMMA] = ACTIONS(5984),
    [anon_sym_STAR] = ACTIONS(2648),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_RBRACK] = ACTIONS(5984),
    [anon_sym_EQ] = ACTIONS(5986),
    [anon_sym_QMARK] = ACTIONS(5984),
    [anon_sym_STAR_EQ] = ACTIONS(5984),
    [anon_sym_SLASH_EQ] = ACTIONS(5984),
    [anon_sym_PERCENT_EQ] = ACTIONS(5984),
    [anon_sym_PLUS_EQ] = ACTIONS(5984),
    [anon_sym_DASH_EQ] = ACTIONS(5984),
    [anon_sym_LT_LT_EQ] = ACTIONS(5984),
    [anon_sym_GT_GT_EQ] = ACTIONS(5984),
    [anon_sym_AMP_EQ] = ACTIONS(5984),
    [anon_sym_CARET_EQ] = ACTIONS(5984),
    [anon_sym_PIPE_EQ] = ACTIONS(5984),
    [anon_sym_AMP] = ACTIONS(2658),
    [anon_sym_PIPE_PIPE] = ACTIONS(2660),
    [anon_sym_AMP_AMP] = ACTIONS(2662),
    [anon_sym_PIPE] = ACTIONS(2664),
    [anon_sym_CARET] = ACTIONS(2666),
    [anon_sym_EQ_EQ] = ACTIONS(2668),
    [anon_sym_BANG_EQ] = ACTIONS(2668),
    [anon_sym_LT] = ACTIONS(2670),
    [anon_sym_GT] = ACTIONS(2670),
    [anon_sym_LT_EQ] = ACTIONS(2672),
    [anon_sym_GT_EQ] = ACTIONS(2672),
    [anon_sym_LT_LT] = ACTIONS(2674),
    [anon_sym_GT_GT] = ACTIONS(2674),
    [anon_sym_PLUS] = ACTIONS(2676),
    [anon_sym_DASH] = ACTIONS(2676),
    [anon_sym_SLASH] = ACTIONS(2648),
    [anon_sym_PERCENT] = ACTIONS(2648),
    [anon_sym_DASH_DASH] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(1554),
    [anon_sym_DASH_GT] = ACTIONS(1554),
    [sym_comment] = ACTIONS(49),
  },
  [2502] = {
    [sym_argument_list] = STATE(802),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_COMMA] = ACTIONS(5988),
    [anon_sym_STAR] = ACTIONS(2648),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_RBRACK] = ACTIONS(5988),
    [anon_sym_EQ] = ACTIONS(2652),
    [anon_sym_QMARK] = ACTIONS(2654),
    [anon_sym_STAR_EQ] = ACTIONS(2656),
    [anon_sym_SLASH_EQ] = ACTIONS(2656),
    [anon_sym_PERCENT_EQ] = ACTIONS(2656),
    [anon_sym_PLUS_EQ] = ACTIONS(2656),
    [anon_sym_DASH_EQ] = ACTIONS(2656),
    [anon_sym_LT_LT_EQ] = ACTIONS(2656),
    [anon_sym_GT_GT_EQ] = ACTIONS(2656),
    [anon_sym_AMP_EQ] = ACTIONS(2656),
    [anon_sym_CARET_EQ] = ACTIONS(2656),
    [anon_sym_PIPE_EQ] = ACTIONS(2656),
    [anon_sym_AMP] = ACTIONS(2658),
    [anon_sym_PIPE_PIPE] = ACTIONS(2660),
    [anon_sym_AMP_AMP] = ACTIONS(2662),
    [anon_sym_PIPE] = ACTIONS(2664),
    [anon_sym_CARET] = ACTIONS(2666),
    [anon_sym_EQ_EQ] = ACTIONS(2668),
    [anon_sym_BANG_EQ] = ACTIONS(2668),
    [anon_sym_LT] = ACTIONS(2670),
    [anon_sym_GT] = ACTIONS(2670),
    [anon_sym_LT_EQ] = ACTIONS(2672),
    [anon_sym_GT_EQ] = ACTIONS(2672),
    [anon_sym_LT_LT] = ACTIONS(2674),
    [anon_sym_GT_GT] = ACTIONS(2674),
    [anon_sym_PLUS] = ACTIONS(2676),
    [anon_sym_DASH] = ACTIONS(2676),
    [anon_sym_SLASH] = ACTIONS(2648),
    [anon_sym_PERCENT] = ACTIONS(2648),
    [anon_sym_DASH_DASH] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(1554),
    [anon_sym_DASH_GT] = ACTIONS(1554),
    [sym_comment] = ACTIONS(49),
  },
  [2503] = {
    [sym_raw_string_literal] = ACTIONS(4836),
    [anon_sym_LPAREN] = ACTIONS(4836),
    [anon_sym_extern] = ACTIONS(4838),
    [anon_sym_STAR] = ACTIONS(4836),
    [anon_sym_LBRACK] = ACTIONS(4836),
    [anon_sym_RBRACK] = ACTIONS(4836),
    [anon_sym_static] = ACTIONS(4838),
    [anon_sym_register] = ACTIONS(4838),
    [anon_sym_inline] = ACTIONS(4838),
    [anon_sym_const] = ACTIONS(4838),
    [anon_sym_restrict] = ACTIONS(4838),
    [anon_sym_volatile] = ACTIONS(4838),
    [anon_sym__Atomic] = ACTIONS(4838),
    [anon_sym_mutable] = ACTIONS(4838),
    [anon_sym_explicit] = ACTIONS(4838),
    [anon_sym_constexpr] = ACTIONS(4838),
    [anon_sym_AMP] = ACTIONS(4836),
    [anon_sym_BANG] = ACTIONS(4836),
    [anon_sym_TILDE] = ACTIONS(4836),
    [anon_sym_PLUS] = ACTIONS(4838),
    [anon_sym_DASH] = ACTIONS(4838),
    [anon_sym_DASH_DASH] = ACTIONS(4836),
    [anon_sym_PLUS_PLUS] = ACTIONS(4836),
    [anon_sym_sizeof] = ACTIONS(4838),
    [sym_number_literal] = ACTIONS(4836),
    [sym_char_literal] = ACTIONS(4836),
    [sym_string_literal] = ACTIONS(4836),
    [sym_true] = ACTIONS(4838),
    [sym_false] = ACTIONS(4838),
    [sym_null] = ACTIONS(4838),
    [sym_identifier] = ACTIONS(4838),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(4838),
    [anon_sym_COLON_COLON] = ACTIONS(4836),
    [anon_sym_delete] = ACTIONS(4838),
    [sym_nullptr] = ACTIONS(4838),
  },
  [2504] = {
    [anon_sym_LPAREN] = ACTIONS(6414),
    [anon_sym_LBRACE] = ACTIONS(6414),
    [sym_comment] = ACTIONS(49),
  },
  [2505] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2505),
    [anon_sym_LPAREN] = ACTIONS(816),
    [anon_sym_STAR] = ACTIONS(816),
    [anon_sym_LBRACK] = ACTIONS(816),
    [anon_sym_unsigned] = ACTIONS(6416),
    [anon_sym_long] = ACTIONS(6416),
    [anon_sym_short] = ACTIONS(6416),
    [sym_primitive_type] = ACTIONS(818),
    [anon_sym_AMP] = ACTIONS(818),
    [anon_sym_AMP_AMP] = ACTIONS(816),
    [sym_identifier] = ACTIONS(818),
    [sym_comment] = ACTIONS(49),
  },
  [2506] = {
    [sym_parameter_list] = STATE(1347),
    [anon_sym_LPAREN] = ACTIONS(206),
    [anon_sym_LBRACE] = ACTIONS(3750),
    [anon_sym_LBRACK] = ACTIONS(2282),
    [sym_comment] = ACTIONS(49),
  },
  [2507] = {
    [sym_parameter_list] = STATE(1347),
    [anon_sym_LPAREN] = ACTIONS(206),
    [anon_sym_LBRACE] = ACTIONS(3762),
    [anon_sym_LBRACK] = ACTIONS(2282),
    [sym_comment] = ACTIONS(49),
  },
  [2508] = {
    [anon_sym_LPAREN] = ACTIONS(3539),
    [anon_sym_COMMA] = ACTIONS(3539),
    [anon_sym_RPAREN] = ACTIONS(3539),
    [anon_sym_SEMI] = ACTIONS(3539),
    [anon_sym_LBRACE] = ACTIONS(3539),
    [anon_sym_STAR] = ACTIONS(3539),
    [anon_sym_LBRACK] = ACTIONS(3539),
    [anon_sym_EQ] = ACTIONS(3539),
    [anon_sym_const] = ACTIONS(3541),
    [anon_sym_restrict] = ACTIONS(3539),
    [anon_sym_volatile] = ACTIONS(3539),
    [anon_sym__Atomic] = ACTIONS(3539),
    [anon_sym_mutable] = ACTIONS(3539),
    [anon_sym_explicit] = ACTIONS(3539),
    [anon_sym_constexpr] = ACTIONS(3539),
    [anon_sym_COLON] = ACTIONS(3539),
    [anon_sym_AMP] = ACTIONS(3541),
    [anon_sym_AMP_AMP] = ACTIONS(3539),
    [anon_sym_GT] = ACTIONS(3539),
    [anon_sym_DASH_GT] = ACTIONS(3539),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(3539),
  },
  [2509] = {
    [sym_enumerator] = STATE(1030),
    [anon_sym_RBRACE] = ACTIONS(6419),
    [sym_identifier] = ACTIONS(348),
    [sym_comment] = ACTIONS(49),
  },
  [2510] = {
    [anon_sym_LPAREN] = ACTIONS(3776),
    [anon_sym_COMMA] = ACTIONS(3776),
    [anon_sym_RPAREN] = ACTIONS(3776),
    [anon_sym_SEMI] = ACTIONS(3776),
    [anon_sym_LBRACE] = ACTIONS(3776),
    [anon_sym_STAR] = ACTIONS(3776),
    [anon_sym_LBRACK] = ACTIONS(3776),
    [anon_sym_EQ] = ACTIONS(3776),
    [anon_sym_const] = ACTIONS(3778),
    [anon_sym_restrict] = ACTIONS(3776),
    [anon_sym_volatile] = ACTIONS(3776),
    [anon_sym__Atomic] = ACTIONS(3776),
    [anon_sym_mutable] = ACTIONS(3776),
    [anon_sym_explicit] = ACTIONS(3776),
    [anon_sym_constexpr] = ACTIONS(3776),
    [anon_sym_COLON] = ACTIONS(3778),
    [anon_sym_AMP] = ACTIONS(3778),
    [anon_sym_AMP_AMP] = ACTIONS(3776),
    [anon_sym_GT] = ACTIONS(3776),
    [anon_sym_DASH_GT] = ACTIONS(3776),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(3776),
    [anon_sym_COLON_COLON] = ACTIONS(3776),
  },
  [2511] = {
    [anon_sym_LF] = ACTIONS(6421),
    [sym_comment] = ACTIONS(83),
  },
  [2512] = {
    [sym_raw_string_literal] = ACTIONS(1823),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1825),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1825),
    [anon_sym_LPAREN] = ACTIONS(1823),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1825),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(1825),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1825),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1825),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(1825),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(1825),
    [sym_preproc_directive] = ACTIONS(1825),
    [anon_sym_SEMI] = ACTIONS(1823),
    [anon_sym_typedef] = ACTIONS(1825),
    [anon_sym_extern] = ACTIONS(1825),
    [anon_sym_LBRACE] = ACTIONS(1823),
    [anon_sym_STAR] = ACTIONS(1823),
    [anon_sym_LBRACK] = ACTIONS(1823),
    [anon_sym_static] = ACTIONS(1825),
    [anon_sym_register] = ACTIONS(1825),
    [anon_sym_inline] = ACTIONS(1825),
    [anon_sym_const] = ACTIONS(1825),
    [anon_sym_restrict] = ACTIONS(1825),
    [anon_sym_volatile] = ACTIONS(1825),
    [anon_sym__Atomic] = ACTIONS(1825),
    [anon_sym_mutable] = ACTIONS(1825),
    [anon_sym_explicit] = ACTIONS(1825),
    [anon_sym_constexpr] = ACTIONS(1825),
    [anon_sym_unsigned] = ACTIONS(1825),
    [anon_sym_long] = ACTIONS(1825),
    [anon_sym_short] = ACTIONS(1825),
    [sym_primitive_type] = ACTIONS(1825),
    [anon_sym_enum] = ACTIONS(1825),
    [anon_sym_struct] = ACTIONS(1825),
    [anon_sym_union] = ACTIONS(1825),
    [anon_sym_if] = ACTIONS(1825),
    [anon_sym_switch] = ACTIONS(1825),
    [anon_sym_case] = ACTIONS(1825),
    [anon_sym_default] = ACTIONS(1825),
    [anon_sym_while] = ACTIONS(1825),
    [anon_sym_do] = ACTIONS(1825),
    [anon_sym_for] = ACTIONS(1825),
    [anon_sym_return] = ACTIONS(1825),
    [anon_sym_break] = ACTIONS(1825),
    [anon_sym_continue] = ACTIONS(1825),
    [anon_sym_goto] = ACTIONS(1825),
    [anon_sym_AMP] = ACTIONS(1823),
    [anon_sym_BANG] = ACTIONS(1823),
    [anon_sym_TILDE] = ACTIONS(1823),
    [anon_sym_PLUS] = ACTIONS(1825),
    [anon_sym_DASH] = ACTIONS(1825),
    [anon_sym_DASH_DASH] = ACTIONS(1823),
    [anon_sym_PLUS_PLUS] = ACTIONS(1823),
    [anon_sym_sizeof] = ACTIONS(1825),
    [sym_number_literal] = ACTIONS(1823),
    [sym_char_literal] = ACTIONS(1823),
    [sym_string_literal] = ACTIONS(1823),
    [sym_true] = ACTIONS(1825),
    [sym_false] = ACTIONS(1825),
    [sym_null] = ACTIONS(1825),
    [sym_identifier] = ACTIONS(1825),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(1825),
    [sym_auto] = ACTIONS(1825),
    [anon_sym_typename] = ACTIONS(1825),
    [anon_sym_new] = ACTIONS(1825),
    [anon_sym_COLON_COLON] = ACTIONS(1823),
    [anon_sym_delete] = ACTIONS(1825),
    [sym_nullptr] = ACTIONS(1825),
  },
  [2513] = {
    [anon_sym_LF] = ACTIONS(6423),
    [sym_comment] = ACTIONS(83),
  },
  [2514] = {
    [sym_raw_string_literal] = ACTIONS(5399),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(5401),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(5401),
    [anon_sym_LPAREN] = ACTIONS(5399),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(5401),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(5401),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(5401),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(5401),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(5401),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(5401),
    [sym_preproc_directive] = ACTIONS(5401),
    [anon_sym_SEMI] = ACTIONS(5399),
    [anon_sym_typedef] = ACTIONS(5401),
    [anon_sym_extern] = ACTIONS(5401),
    [anon_sym_LBRACE] = ACTIONS(5399),
    [anon_sym_STAR] = ACTIONS(5399),
    [anon_sym_LBRACK] = ACTIONS(5399),
    [anon_sym_static] = ACTIONS(5401),
    [anon_sym_register] = ACTIONS(5401),
    [anon_sym_inline] = ACTIONS(5401),
    [anon_sym_const] = ACTIONS(5401),
    [anon_sym_restrict] = ACTIONS(5401),
    [anon_sym_volatile] = ACTIONS(5401),
    [anon_sym__Atomic] = ACTIONS(5401),
    [anon_sym_mutable] = ACTIONS(5401),
    [anon_sym_explicit] = ACTIONS(5401),
    [anon_sym_constexpr] = ACTIONS(5401),
    [anon_sym_unsigned] = ACTIONS(5401),
    [anon_sym_long] = ACTIONS(5401),
    [anon_sym_short] = ACTIONS(5401),
    [sym_primitive_type] = ACTIONS(5401),
    [anon_sym_enum] = ACTIONS(5401),
    [anon_sym_struct] = ACTIONS(5401),
    [anon_sym_union] = ACTIONS(5401),
    [anon_sym_if] = ACTIONS(5401),
    [anon_sym_switch] = ACTIONS(5401),
    [anon_sym_case] = ACTIONS(5401),
    [anon_sym_default] = ACTIONS(5401),
    [anon_sym_while] = ACTIONS(5401),
    [anon_sym_do] = ACTIONS(5401),
    [anon_sym_for] = ACTIONS(5401),
    [anon_sym_return] = ACTIONS(5401),
    [anon_sym_break] = ACTIONS(5401),
    [anon_sym_continue] = ACTIONS(5401),
    [anon_sym_goto] = ACTIONS(5401),
    [anon_sym_AMP] = ACTIONS(5399),
    [anon_sym_BANG] = ACTIONS(5399),
    [anon_sym_TILDE] = ACTIONS(5399),
    [anon_sym_PLUS] = ACTIONS(5401),
    [anon_sym_DASH] = ACTIONS(5401),
    [anon_sym_DASH_DASH] = ACTIONS(5399),
    [anon_sym_PLUS_PLUS] = ACTIONS(5399),
    [anon_sym_sizeof] = ACTIONS(5401),
    [sym_number_literal] = ACTIONS(5399),
    [sym_char_literal] = ACTIONS(5399),
    [sym_string_literal] = ACTIONS(5399),
    [sym_true] = ACTIONS(5401),
    [sym_false] = ACTIONS(5401),
    [sym_null] = ACTIONS(5401),
    [sym_identifier] = ACTIONS(5401),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(5401),
    [sym_auto] = ACTIONS(5401),
    [anon_sym_typename] = ACTIONS(5401),
    [anon_sym_new] = ACTIONS(5401),
    [anon_sym_COLON_COLON] = ACTIONS(5399),
    [anon_sym_delete] = ACTIONS(5401),
    [sym_nullptr] = ACTIONS(5401),
  },
  [2515] = {
    [sym_raw_string_literal] = ACTIONS(5403),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(5405),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(5405),
    [anon_sym_LPAREN] = ACTIONS(5403),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(5405),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(5405),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(5405),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(5405),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(5405),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(5405),
    [sym_preproc_directive] = ACTIONS(5405),
    [anon_sym_SEMI] = ACTIONS(5403),
    [anon_sym_typedef] = ACTIONS(5405),
    [anon_sym_extern] = ACTIONS(5405),
    [anon_sym_LBRACE] = ACTIONS(5403),
    [anon_sym_STAR] = ACTIONS(5403),
    [anon_sym_LBRACK] = ACTIONS(5403),
    [anon_sym_static] = ACTIONS(5405),
    [anon_sym_register] = ACTIONS(5405),
    [anon_sym_inline] = ACTIONS(5405),
    [anon_sym_const] = ACTIONS(5405),
    [anon_sym_restrict] = ACTIONS(5405),
    [anon_sym_volatile] = ACTIONS(5405),
    [anon_sym__Atomic] = ACTIONS(5405),
    [anon_sym_mutable] = ACTIONS(5405),
    [anon_sym_explicit] = ACTIONS(5405),
    [anon_sym_constexpr] = ACTIONS(5405),
    [anon_sym_unsigned] = ACTIONS(5405),
    [anon_sym_long] = ACTIONS(5405),
    [anon_sym_short] = ACTIONS(5405),
    [sym_primitive_type] = ACTIONS(5405),
    [anon_sym_enum] = ACTIONS(5405),
    [anon_sym_struct] = ACTIONS(5405),
    [anon_sym_union] = ACTIONS(5405),
    [anon_sym_if] = ACTIONS(5405),
    [anon_sym_switch] = ACTIONS(5405),
    [anon_sym_case] = ACTIONS(5405),
    [anon_sym_default] = ACTIONS(5405),
    [anon_sym_while] = ACTIONS(5405),
    [anon_sym_do] = ACTIONS(5405),
    [anon_sym_for] = ACTIONS(5405),
    [anon_sym_return] = ACTIONS(5405),
    [anon_sym_break] = ACTIONS(5405),
    [anon_sym_continue] = ACTIONS(5405),
    [anon_sym_goto] = ACTIONS(5405),
    [anon_sym_AMP] = ACTIONS(5403),
    [anon_sym_BANG] = ACTIONS(5403),
    [anon_sym_TILDE] = ACTIONS(5403),
    [anon_sym_PLUS] = ACTIONS(5405),
    [anon_sym_DASH] = ACTIONS(5405),
    [anon_sym_DASH_DASH] = ACTIONS(5403),
    [anon_sym_PLUS_PLUS] = ACTIONS(5403),
    [anon_sym_sizeof] = ACTIONS(5405),
    [sym_number_literal] = ACTIONS(5403),
    [sym_char_literal] = ACTIONS(5403),
    [sym_string_literal] = ACTIONS(5403),
    [sym_true] = ACTIONS(5405),
    [sym_false] = ACTIONS(5405),
    [sym_null] = ACTIONS(5405),
    [sym_identifier] = ACTIONS(5405),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(5405),
    [sym_auto] = ACTIONS(5405),
    [anon_sym_typename] = ACTIONS(5405),
    [anon_sym_new] = ACTIONS(5405),
    [anon_sym_COLON_COLON] = ACTIONS(5403),
    [anon_sym_delete] = ACTIONS(5405),
    [sym_nullptr] = ACTIONS(5405),
  },
  [2516] = {
    [sym_raw_string_literal] = ACTIONS(5413),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(5415),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(5415),
    [anon_sym_LPAREN] = ACTIONS(5413),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(5415),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(5415),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(5415),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(5415),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(5415),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(5415),
    [sym_preproc_directive] = ACTIONS(5415),
    [anon_sym_SEMI] = ACTIONS(5413),
    [anon_sym_typedef] = ACTIONS(5415),
    [anon_sym_extern] = ACTIONS(5415),
    [anon_sym_LBRACE] = ACTIONS(5413),
    [anon_sym_STAR] = ACTIONS(5413),
    [anon_sym_LBRACK] = ACTIONS(5413),
    [anon_sym_static] = ACTIONS(5415),
    [anon_sym_register] = ACTIONS(5415),
    [anon_sym_inline] = ACTIONS(5415),
    [anon_sym_const] = ACTIONS(5415),
    [anon_sym_restrict] = ACTIONS(5415),
    [anon_sym_volatile] = ACTIONS(5415),
    [anon_sym__Atomic] = ACTIONS(5415),
    [anon_sym_mutable] = ACTIONS(5415),
    [anon_sym_explicit] = ACTIONS(5415),
    [anon_sym_constexpr] = ACTIONS(5415),
    [anon_sym_unsigned] = ACTIONS(5415),
    [anon_sym_long] = ACTIONS(5415),
    [anon_sym_short] = ACTIONS(5415),
    [sym_primitive_type] = ACTIONS(5415),
    [anon_sym_enum] = ACTIONS(5415),
    [anon_sym_struct] = ACTIONS(5415),
    [anon_sym_union] = ACTIONS(5415),
    [anon_sym_if] = ACTIONS(5415),
    [anon_sym_switch] = ACTIONS(5415),
    [anon_sym_case] = ACTIONS(5415),
    [anon_sym_default] = ACTIONS(5415),
    [anon_sym_while] = ACTIONS(5415),
    [anon_sym_do] = ACTIONS(5415),
    [anon_sym_for] = ACTIONS(5415),
    [anon_sym_return] = ACTIONS(5415),
    [anon_sym_break] = ACTIONS(5415),
    [anon_sym_continue] = ACTIONS(5415),
    [anon_sym_goto] = ACTIONS(5415),
    [anon_sym_AMP] = ACTIONS(5413),
    [anon_sym_BANG] = ACTIONS(5413),
    [anon_sym_TILDE] = ACTIONS(5413),
    [anon_sym_PLUS] = ACTIONS(5415),
    [anon_sym_DASH] = ACTIONS(5415),
    [anon_sym_DASH_DASH] = ACTIONS(5413),
    [anon_sym_PLUS_PLUS] = ACTIONS(5413),
    [anon_sym_sizeof] = ACTIONS(5415),
    [sym_number_literal] = ACTIONS(5413),
    [sym_char_literal] = ACTIONS(5413),
    [sym_string_literal] = ACTIONS(5413),
    [sym_true] = ACTIONS(5415),
    [sym_false] = ACTIONS(5415),
    [sym_null] = ACTIONS(5415),
    [sym_identifier] = ACTIONS(5415),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(5415),
    [sym_auto] = ACTIONS(5415),
    [anon_sym_typename] = ACTIONS(5415),
    [anon_sym_new] = ACTIONS(5415),
    [anon_sym_COLON_COLON] = ACTIONS(5413),
    [anon_sym_delete] = ACTIONS(5415),
    [sym_nullptr] = ACTIONS(5415),
  },
  [2517] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(6425),
    [sym_comment] = ACTIONS(49),
  },
  [2518] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(6427),
    [sym_comment] = ACTIONS(49),
  },
  [2519] = {
    [sym_raw_string_literal] = ACTIONS(5492),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(5494),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(5494),
    [anon_sym_LPAREN] = ACTIONS(5492),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(5494),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(5494),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(5494),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(5494),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(5494),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(5494),
    [sym_preproc_directive] = ACTIONS(5494),
    [anon_sym_SEMI] = ACTIONS(5492),
    [anon_sym_typedef] = ACTIONS(5494),
    [anon_sym_extern] = ACTIONS(5494),
    [anon_sym_LBRACE] = ACTIONS(5492),
    [anon_sym_STAR] = ACTIONS(5492),
    [anon_sym_LBRACK] = ACTIONS(5492),
    [anon_sym_static] = ACTIONS(5494),
    [anon_sym_register] = ACTIONS(5494),
    [anon_sym_inline] = ACTIONS(5494),
    [anon_sym_const] = ACTIONS(5494),
    [anon_sym_restrict] = ACTIONS(5494),
    [anon_sym_volatile] = ACTIONS(5494),
    [anon_sym__Atomic] = ACTIONS(5494),
    [anon_sym_mutable] = ACTIONS(5494),
    [anon_sym_explicit] = ACTIONS(5494),
    [anon_sym_constexpr] = ACTIONS(5494),
    [anon_sym_unsigned] = ACTIONS(5494),
    [anon_sym_long] = ACTIONS(5494),
    [anon_sym_short] = ACTIONS(5494),
    [sym_primitive_type] = ACTIONS(5494),
    [anon_sym_enum] = ACTIONS(5494),
    [anon_sym_struct] = ACTIONS(5494),
    [anon_sym_union] = ACTIONS(5494),
    [anon_sym_if] = ACTIONS(5494),
    [anon_sym_switch] = ACTIONS(5494),
    [anon_sym_case] = ACTIONS(5494),
    [anon_sym_default] = ACTIONS(5494),
    [anon_sym_while] = ACTIONS(5494),
    [anon_sym_do] = ACTIONS(5494),
    [anon_sym_for] = ACTIONS(5494),
    [anon_sym_return] = ACTIONS(5494),
    [anon_sym_break] = ACTIONS(5494),
    [anon_sym_continue] = ACTIONS(5494),
    [anon_sym_goto] = ACTIONS(5494),
    [anon_sym_AMP] = ACTIONS(5492),
    [anon_sym_BANG] = ACTIONS(5492),
    [anon_sym_TILDE] = ACTIONS(5492),
    [anon_sym_PLUS] = ACTIONS(5494),
    [anon_sym_DASH] = ACTIONS(5494),
    [anon_sym_DASH_DASH] = ACTIONS(5492),
    [anon_sym_PLUS_PLUS] = ACTIONS(5492),
    [anon_sym_sizeof] = ACTIONS(5494),
    [sym_number_literal] = ACTIONS(5492),
    [sym_char_literal] = ACTIONS(5492),
    [sym_string_literal] = ACTIONS(5492),
    [sym_true] = ACTIONS(5494),
    [sym_false] = ACTIONS(5494),
    [sym_null] = ACTIONS(5494),
    [sym_identifier] = ACTIONS(5494),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(5494),
    [sym_auto] = ACTIONS(5494),
    [anon_sym_typename] = ACTIONS(5494),
    [anon_sym_new] = ACTIONS(5494),
    [anon_sym_COLON_COLON] = ACTIONS(5492),
    [anon_sym_delete] = ACTIONS(5494),
    [sym_nullptr] = ACTIONS(5494),
  },
  [2520] = {
    [sym_raw_string_literal] = ACTIONS(5496),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(5498),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(5498),
    [anon_sym_LPAREN] = ACTIONS(5496),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(5498),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(5498),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(5498),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(5498),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(5498),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(5498),
    [sym_preproc_directive] = ACTIONS(5498),
    [anon_sym_SEMI] = ACTIONS(5496),
    [anon_sym_typedef] = ACTIONS(5498),
    [anon_sym_extern] = ACTIONS(5498),
    [anon_sym_LBRACE] = ACTIONS(5496),
    [anon_sym_STAR] = ACTIONS(5496),
    [anon_sym_LBRACK] = ACTIONS(5496),
    [anon_sym_static] = ACTIONS(5498),
    [anon_sym_register] = ACTIONS(5498),
    [anon_sym_inline] = ACTIONS(5498),
    [anon_sym_const] = ACTIONS(5498),
    [anon_sym_restrict] = ACTIONS(5498),
    [anon_sym_volatile] = ACTIONS(5498),
    [anon_sym__Atomic] = ACTIONS(5498),
    [anon_sym_mutable] = ACTIONS(5498),
    [anon_sym_explicit] = ACTIONS(5498),
    [anon_sym_constexpr] = ACTIONS(5498),
    [anon_sym_unsigned] = ACTIONS(5498),
    [anon_sym_long] = ACTIONS(5498),
    [anon_sym_short] = ACTIONS(5498),
    [sym_primitive_type] = ACTIONS(5498),
    [anon_sym_enum] = ACTIONS(5498),
    [anon_sym_struct] = ACTIONS(5498),
    [anon_sym_union] = ACTIONS(5498),
    [anon_sym_if] = ACTIONS(5498),
    [anon_sym_switch] = ACTIONS(5498),
    [anon_sym_case] = ACTIONS(5498),
    [anon_sym_default] = ACTIONS(5498),
    [anon_sym_while] = ACTIONS(5498),
    [anon_sym_do] = ACTIONS(5498),
    [anon_sym_for] = ACTIONS(5498),
    [anon_sym_return] = ACTIONS(5498),
    [anon_sym_break] = ACTIONS(5498),
    [anon_sym_continue] = ACTIONS(5498),
    [anon_sym_goto] = ACTIONS(5498),
    [anon_sym_AMP] = ACTIONS(5496),
    [anon_sym_BANG] = ACTIONS(5496),
    [anon_sym_TILDE] = ACTIONS(5496),
    [anon_sym_PLUS] = ACTIONS(5498),
    [anon_sym_DASH] = ACTIONS(5498),
    [anon_sym_DASH_DASH] = ACTIONS(5496),
    [anon_sym_PLUS_PLUS] = ACTIONS(5496),
    [anon_sym_sizeof] = ACTIONS(5498),
    [sym_number_literal] = ACTIONS(5496),
    [sym_char_literal] = ACTIONS(5496),
    [sym_string_literal] = ACTIONS(5496),
    [sym_true] = ACTIONS(5498),
    [sym_false] = ACTIONS(5498),
    [sym_null] = ACTIONS(5498),
    [sym_identifier] = ACTIONS(5498),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(5498),
    [sym_auto] = ACTIONS(5498),
    [anon_sym_typename] = ACTIONS(5498),
    [anon_sym_new] = ACTIONS(5498),
    [anon_sym_COLON_COLON] = ACTIONS(5496),
    [anon_sym_delete] = ACTIONS(5498),
    [sym_nullptr] = ACTIONS(5498),
  },
  [2521] = {
    [sym_raw_string_literal] = ACTIONS(5500),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(5502),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(5502),
    [anon_sym_LPAREN] = ACTIONS(5500),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(5502),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(5502),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(5502),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(5502),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(5502),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(5502),
    [sym_preproc_directive] = ACTIONS(5502),
    [anon_sym_SEMI] = ACTIONS(5500),
    [anon_sym_typedef] = ACTIONS(5502),
    [anon_sym_extern] = ACTIONS(5502),
    [anon_sym_LBRACE] = ACTIONS(5500),
    [anon_sym_STAR] = ACTIONS(5500),
    [anon_sym_LBRACK] = ACTIONS(5500),
    [anon_sym_static] = ACTIONS(5502),
    [anon_sym_register] = ACTIONS(5502),
    [anon_sym_inline] = ACTIONS(5502),
    [anon_sym_const] = ACTIONS(5502),
    [anon_sym_restrict] = ACTIONS(5502),
    [anon_sym_volatile] = ACTIONS(5502),
    [anon_sym__Atomic] = ACTIONS(5502),
    [anon_sym_mutable] = ACTIONS(5502),
    [anon_sym_explicit] = ACTIONS(5502),
    [anon_sym_constexpr] = ACTIONS(5502),
    [anon_sym_unsigned] = ACTIONS(5502),
    [anon_sym_long] = ACTIONS(5502),
    [anon_sym_short] = ACTIONS(5502),
    [sym_primitive_type] = ACTIONS(5502),
    [anon_sym_enum] = ACTIONS(5502),
    [anon_sym_struct] = ACTIONS(5502),
    [anon_sym_union] = ACTIONS(5502),
    [anon_sym_if] = ACTIONS(5502),
    [anon_sym_switch] = ACTIONS(5502),
    [anon_sym_case] = ACTIONS(5502),
    [anon_sym_default] = ACTIONS(5502),
    [anon_sym_while] = ACTIONS(5502),
    [anon_sym_do] = ACTIONS(5502),
    [anon_sym_for] = ACTIONS(5502),
    [anon_sym_return] = ACTIONS(5502),
    [anon_sym_break] = ACTIONS(5502),
    [anon_sym_continue] = ACTIONS(5502),
    [anon_sym_goto] = ACTIONS(5502),
    [anon_sym_AMP] = ACTIONS(5500),
    [anon_sym_BANG] = ACTIONS(5500),
    [anon_sym_TILDE] = ACTIONS(5500),
    [anon_sym_PLUS] = ACTIONS(5502),
    [anon_sym_DASH] = ACTIONS(5502),
    [anon_sym_DASH_DASH] = ACTIONS(5500),
    [anon_sym_PLUS_PLUS] = ACTIONS(5500),
    [anon_sym_sizeof] = ACTIONS(5502),
    [sym_number_literal] = ACTIONS(5500),
    [sym_char_literal] = ACTIONS(5500),
    [sym_string_literal] = ACTIONS(5500),
    [sym_true] = ACTIONS(5502),
    [sym_false] = ACTIONS(5502),
    [sym_null] = ACTIONS(5502),
    [sym_identifier] = ACTIONS(5502),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(5502),
    [sym_auto] = ACTIONS(5502),
    [anon_sym_typename] = ACTIONS(5502),
    [anon_sym_new] = ACTIONS(5502),
    [anon_sym_COLON_COLON] = ACTIONS(5500),
    [anon_sym_delete] = ACTIONS(5502),
    [sym_nullptr] = ACTIONS(5502),
  },
  [2522] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(6429),
    [sym_comment] = ACTIONS(49),
  },
  [2523] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(6431),
    [sym_comment] = ACTIONS(49),
  },
  [2524] = {
    [sym_raw_string_literal] = ACTIONS(5508),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(5510),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(5510),
    [anon_sym_LPAREN] = ACTIONS(5508),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(5510),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(5510),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(5510),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(5510),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(5510),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(5510),
    [sym_preproc_directive] = ACTIONS(5510),
    [anon_sym_SEMI] = ACTIONS(5508),
    [anon_sym_typedef] = ACTIONS(5510),
    [anon_sym_extern] = ACTIONS(5510),
    [anon_sym_LBRACE] = ACTIONS(5508),
    [anon_sym_STAR] = ACTIONS(5508),
    [anon_sym_LBRACK] = ACTIONS(5508),
    [anon_sym_static] = ACTIONS(5510),
    [anon_sym_register] = ACTIONS(5510),
    [anon_sym_inline] = ACTIONS(5510),
    [anon_sym_const] = ACTIONS(5510),
    [anon_sym_restrict] = ACTIONS(5510),
    [anon_sym_volatile] = ACTIONS(5510),
    [anon_sym__Atomic] = ACTIONS(5510),
    [anon_sym_mutable] = ACTIONS(5510),
    [anon_sym_explicit] = ACTIONS(5510),
    [anon_sym_constexpr] = ACTIONS(5510),
    [anon_sym_unsigned] = ACTIONS(5510),
    [anon_sym_long] = ACTIONS(5510),
    [anon_sym_short] = ACTIONS(5510),
    [sym_primitive_type] = ACTIONS(5510),
    [anon_sym_enum] = ACTIONS(5510),
    [anon_sym_struct] = ACTIONS(5510),
    [anon_sym_union] = ACTIONS(5510),
    [anon_sym_if] = ACTIONS(5510),
    [anon_sym_switch] = ACTIONS(5510),
    [anon_sym_case] = ACTIONS(5510),
    [anon_sym_default] = ACTIONS(5510),
    [anon_sym_while] = ACTIONS(5510),
    [anon_sym_do] = ACTIONS(5510),
    [anon_sym_for] = ACTIONS(5510),
    [anon_sym_return] = ACTIONS(5510),
    [anon_sym_break] = ACTIONS(5510),
    [anon_sym_continue] = ACTIONS(5510),
    [anon_sym_goto] = ACTIONS(5510),
    [anon_sym_AMP] = ACTIONS(5508),
    [anon_sym_BANG] = ACTIONS(5508),
    [anon_sym_TILDE] = ACTIONS(5508),
    [anon_sym_PLUS] = ACTIONS(5510),
    [anon_sym_DASH] = ACTIONS(5510),
    [anon_sym_DASH_DASH] = ACTIONS(5508),
    [anon_sym_PLUS_PLUS] = ACTIONS(5508),
    [anon_sym_sizeof] = ACTIONS(5510),
    [sym_number_literal] = ACTIONS(5508),
    [sym_char_literal] = ACTIONS(5508),
    [sym_string_literal] = ACTIONS(5508),
    [sym_true] = ACTIONS(5510),
    [sym_false] = ACTIONS(5510),
    [sym_null] = ACTIONS(5510),
    [sym_identifier] = ACTIONS(5510),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(5510),
    [sym_auto] = ACTIONS(5510),
    [anon_sym_typename] = ACTIONS(5510),
    [anon_sym_new] = ACTIONS(5510),
    [anon_sym_COLON_COLON] = ACTIONS(5508),
    [anon_sym_delete] = ACTIONS(5510),
    [sym_nullptr] = ACTIONS(5510),
  },
  [2525] = {
    [sym_raw_string_literal] = ACTIONS(5512),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(5514),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(5514),
    [anon_sym_LPAREN] = ACTIONS(5512),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(5514),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(5514),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(5514),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(5514),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(5514),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(5514),
    [sym_preproc_directive] = ACTIONS(5514),
    [anon_sym_SEMI] = ACTIONS(5512),
    [anon_sym_typedef] = ACTIONS(5514),
    [anon_sym_extern] = ACTIONS(5514),
    [anon_sym_LBRACE] = ACTIONS(5512),
    [anon_sym_STAR] = ACTIONS(5512),
    [anon_sym_LBRACK] = ACTIONS(5512),
    [anon_sym_static] = ACTIONS(5514),
    [anon_sym_register] = ACTIONS(5514),
    [anon_sym_inline] = ACTIONS(5514),
    [anon_sym_const] = ACTIONS(5514),
    [anon_sym_restrict] = ACTIONS(5514),
    [anon_sym_volatile] = ACTIONS(5514),
    [anon_sym__Atomic] = ACTIONS(5514),
    [anon_sym_mutable] = ACTIONS(5514),
    [anon_sym_explicit] = ACTIONS(5514),
    [anon_sym_constexpr] = ACTIONS(5514),
    [anon_sym_unsigned] = ACTIONS(5514),
    [anon_sym_long] = ACTIONS(5514),
    [anon_sym_short] = ACTIONS(5514),
    [sym_primitive_type] = ACTIONS(5514),
    [anon_sym_enum] = ACTIONS(5514),
    [anon_sym_struct] = ACTIONS(5514),
    [anon_sym_union] = ACTIONS(5514),
    [anon_sym_if] = ACTIONS(5514),
    [anon_sym_switch] = ACTIONS(5514),
    [anon_sym_case] = ACTIONS(5514),
    [anon_sym_default] = ACTIONS(5514),
    [anon_sym_while] = ACTIONS(5514),
    [anon_sym_do] = ACTIONS(5514),
    [anon_sym_for] = ACTIONS(5514),
    [anon_sym_return] = ACTIONS(5514),
    [anon_sym_break] = ACTIONS(5514),
    [anon_sym_continue] = ACTIONS(5514),
    [anon_sym_goto] = ACTIONS(5514),
    [anon_sym_AMP] = ACTIONS(5512),
    [anon_sym_BANG] = ACTIONS(5512),
    [anon_sym_TILDE] = ACTIONS(5512),
    [anon_sym_PLUS] = ACTIONS(5514),
    [anon_sym_DASH] = ACTIONS(5514),
    [anon_sym_DASH_DASH] = ACTIONS(5512),
    [anon_sym_PLUS_PLUS] = ACTIONS(5512),
    [anon_sym_sizeof] = ACTIONS(5514),
    [sym_number_literal] = ACTIONS(5512),
    [sym_char_literal] = ACTIONS(5512),
    [sym_string_literal] = ACTIONS(5512),
    [sym_true] = ACTIONS(5514),
    [sym_false] = ACTIONS(5514),
    [sym_null] = ACTIONS(5514),
    [sym_identifier] = ACTIONS(5514),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(5514),
    [sym_auto] = ACTIONS(5514),
    [anon_sym_typename] = ACTIONS(5514),
    [anon_sym_new] = ACTIONS(5514),
    [anon_sym_COLON_COLON] = ACTIONS(5512),
    [anon_sym_delete] = ACTIONS(5514),
    [sym_nullptr] = ACTIONS(5514),
  },
  [2526] = {
    [sym_raw_string_literal] = ACTIONS(5516),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(5518),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(5518),
    [anon_sym_LPAREN] = ACTIONS(5516),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(5518),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(5518),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(5518),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(5518),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(5518),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(5518),
    [sym_preproc_directive] = ACTIONS(5518),
    [anon_sym_SEMI] = ACTIONS(5516),
    [anon_sym_typedef] = ACTIONS(5518),
    [anon_sym_extern] = ACTIONS(5518),
    [anon_sym_LBRACE] = ACTIONS(5516),
    [anon_sym_STAR] = ACTIONS(5516),
    [anon_sym_LBRACK] = ACTIONS(5516),
    [anon_sym_static] = ACTIONS(5518),
    [anon_sym_register] = ACTIONS(5518),
    [anon_sym_inline] = ACTIONS(5518),
    [anon_sym_const] = ACTIONS(5518),
    [anon_sym_restrict] = ACTIONS(5518),
    [anon_sym_volatile] = ACTIONS(5518),
    [anon_sym__Atomic] = ACTIONS(5518),
    [anon_sym_mutable] = ACTIONS(5518),
    [anon_sym_explicit] = ACTIONS(5518),
    [anon_sym_constexpr] = ACTIONS(5518),
    [anon_sym_unsigned] = ACTIONS(5518),
    [anon_sym_long] = ACTIONS(5518),
    [anon_sym_short] = ACTIONS(5518),
    [sym_primitive_type] = ACTIONS(5518),
    [anon_sym_enum] = ACTIONS(5518),
    [anon_sym_struct] = ACTIONS(5518),
    [anon_sym_union] = ACTIONS(5518),
    [anon_sym_if] = ACTIONS(5518),
    [anon_sym_switch] = ACTIONS(5518),
    [anon_sym_case] = ACTIONS(5518),
    [anon_sym_default] = ACTIONS(5518),
    [anon_sym_while] = ACTIONS(5518),
    [anon_sym_do] = ACTIONS(5518),
    [anon_sym_for] = ACTIONS(5518),
    [anon_sym_return] = ACTIONS(5518),
    [anon_sym_break] = ACTIONS(5518),
    [anon_sym_continue] = ACTIONS(5518),
    [anon_sym_goto] = ACTIONS(5518),
    [anon_sym_AMP] = ACTIONS(5516),
    [anon_sym_BANG] = ACTIONS(5516),
    [anon_sym_TILDE] = ACTIONS(5516),
    [anon_sym_PLUS] = ACTIONS(5518),
    [anon_sym_DASH] = ACTIONS(5518),
    [anon_sym_DASH_DASH] = ACTIONS(5516),
    [anon_sym_PLUS_PLUS] = ACTIONS(5516),
    [anon_sym_sizeof] = ACTIONS(5518),
    [sym_number_literal] = ACTIONS(5516),
    [sym_char_literal] = ACTIONS(5516),
    [sym_string_literal] = ACTIONS(5516),
    [sym_true] = ACTIONS(5518),
    [sym_false] = ACTIONS(5518),
    [sym_null] = ACTIONS(5518),
    [sym_identifier] = ACTIONS(5518),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(5518),
    [sym_auto] = ACTIONS(5518),
    [anon_sym_typename] = ACTIONS(5518),
    [anon_sym_new] = ACTIONS(5518),
    [anon_sym_COLON_COLON] = ACTIONS(5516),
    [anon_sym_delete] = ACTIONS(5518),
    [sym_nullptr] = ACTIONS(5518),
  },
  [2527] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(6433),
    [sym_comment] = ACTIONS(49),
  },
  [2528] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(6435),
    [sym_comment] = ACTIONS(49),
  },
  [2529] = {
    [sym_preproc_arg] = ACTIONS(6437),
    [sym_comment] = ACTIONS(83),
  },
  [2530] = {
    [sym_raw_string_literal] = ACTIONS(825),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(827),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(827),
    [anon_sym_LPAREN] = ACTIONS(825),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(827),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(827),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(827),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(827),
    [sym_preproc_directive] = ACTIONS(827),
    [anon_sym_SEMI] = ACTIONS(825),
    [anon_sym_typedef] = ACTIONS(827),
    [anon_sym_extern] = ACTIONS(827),
    [anon_sym_LBRACE] = ACTIONS(825),
    [anon_sym_STAR] = ACTIONS(825),
    [anon_sym_LBRACK] = ACTIONS(825),
    [anon_sym_static] = ACTIONS(827),
    [anon_sym_register] = ACTIONS(827),
    [anon_sym_inline] = ACTIONS(827),
    [anon_sym_const] = ACTIONS(827),
    [anon_sym_restrict] = ACTIONS(827),
    [anon_sym_volatile] = ACTIONS(827),
    [anon_sym__Atomic] = ACTIONS(827),
    [anon_sym_mutable] = ACTIONS(827),
    [anon_sym_explicit] = ACTIONS(827),
    [anon_sym_constexpr] = ACTIONS(827),
    [anon_sym_unsigned] = ACTIONS(827),
    [anon_sym_long] = ACTIONS(827),
    [anon_sym_short] = ACTIONS(827),
    [sym_primitive_type] = ACTIONS(827),
    [anon_sym_enum] = ACTIONS(827),
    [anon_sym_struct] = ACTIONS(827),
    [anon_sym_union] = ACTIONS(827),
    [anon_sym_if] = ACTIONS(827),
    [anon_sym_switch] = ACTIONS(827),
    [anon_sym_case] = ACTIONS(827),
    [anon_sym_default] = ACTIONS(827),
    [anon_sym_while] = ACTIONS(827),
    [anon_sym_do] = ACTIONS(827),
    [anon_sym_for] = ACTIONS(827),
    [anon_sym_return] = ACTIONS(827),
    [anon_sym_break] = ACTIONS(827),
    [anon_sym_continue] = ACTIONS(827),
    [anon_sym_goto] = ACTIONS(827),
    [anon_sym_AMP] = ACTIONS(825),
    [anon_sym_BANG] = ACTIONS(825),
    [anon_sym_TILDE] = ACTIONS(825),
    [anon_sym_PLUS] = ACTIONS(827),
    [anon_sym_DASH] = ACTIONS(827),
    [anon_sym_DASH_DASH] = ACTIONS(825),
    [anon_sym_PLUS_PLUS] = ACTIONS(825),
    [anon_sym_sizeof] = ACTIONS(827),
    [sym_number_literal] = ACTIONS(825),
    [sym_char_literal] = ACTIONS(825),
    [sym_string_literal] = ACTIONS(825),
    [sym_true] = ACTIONS(827),
    [sym_false] = ACTIONS(827),
    [sym_null] = ACTIONS(827),
    [sym_identifier] = ACTIONS(827),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(827),
    [sym_auto] = ACTIONS(827),
    [anon_sym_typename] = ACTIONS(827),
    [anon_sym_new] = ACTIONS(827),
    [anon_sym_COLON_COLON] = ACTIONS(825),
    [anon_sym_delete] = ACTIONS(827),
    [sym_nullptr] = ACTIONS(827),
  },
  [2531] = {
    [anon_sym_LF] = ACTIONS(6439),
    [sym_preproc_arg] = ACTIONS(6441),
    [sym_comment] = ACTIONS(83),
  },
  [2532] = {
    [sym_raw_string_literal] = ACTIONS(4387),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(4389),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(4389),
    [anon_sym_LPAREN] = ACTIONS(4387),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(4389),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(4389),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(4389),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(4389),
    [sym_preproc_directive] = ACTIONS(4389),
    [anon_sym_SEMI] = ACTIONS(4387),
    [anon_sym_typedef] = ACTIONS(4389),
    [anon_sym_extern] = ACTIONS(4389),
    [anon_sym_LBRACE] = ACTIONS(4387),
    [anon_sym_STAR] = ACTIONS(4387),
    [anon_sym_LBRACK] = ACTIONS(4387),
    [anon_sym_static] = ACTIONS(4389),
    [anon_sym_register] = ACTIONS(4389),
    [anon_sym_inline] = ACTIONS(4389),
    [anon_sym_const] = ACTIONS(4389),
    [anon_sym_restrict] = ACTIONS(4389),
    [anon_sym_volatile] = ACTIONS(4389),
    [anon_sym__Atomic] = ACTIONS(4389),
    [anon_sym_mutable] = ACTIONS(4389),
    [anon_sym_explicit] = ACTIONS(4389),
    [anon_sym_constexpr] = ACTIONS(4389),
    [anon_sym_unsigned] = ACTIONS(4389),
    [anon_sym_long] = ACTIONS(4389),
    [anon_sym_short] = ACTIONS(4389),
    [sym_primitive_type] = ACTIONS(4389),
    [anon_sym_enum] = ACTIONS(4389),
    [anon_sym_struct] = ACTIONS(4389),
    [anon_sym_union] = ACTIONS(4389),
    [anon_sym_if] = ACTIONS(4389),
    [anon_sym_switch] = ACTIONS(4389),
    [anon_sym_case] = ACTIONS(4389),
    [anon_sym_default] = ACTIONS(4389),
    [anon_sym_while] = ACTIONS(4389),
    [anon_sym_do] = ACTIONS(4389),
    [anon_sym_for] = ACTIONS(4389),
    [anon_sym_return] = ACTIONS(4389),
    [anon_sym_break] = ACTIONS(4389),
    [anon_sym_continue] = ACTIONS(4389),
    [anon_sym_goto] = ACTIONS(4389),
    [anon_sym_AMP] = ACTIONS(4387),
    [anon_sym_BANG] = ACTIONS(4387),
    [anon_sym_TILDE] = ACTIONS(4387),
    [anon_sym_PLUS] = ACTIONS(4389),
    [anon_sym_DASH] = ACTIONS(4389),
    [anon_sym_DASH_DASH] = ACTIONS(4387),
    [anon_sym_PLUS_PLUS] = ACTIONS(4387),
    [anon_sym_sizeof] = ACTIONS(4389),
    [sym_number_literal] = ACTIONS(4387),
    [sym_char_literal] = ACTIONS(4387),
    [sym_string_literal] = ACTIONS(4387),
    [sym_true] = ACTIONS(4389),
    [sym_false] = ACTIONS(4389),
    [sym_null] = ACTIONS(4389),
    [sym_identifier] = ACTIONS(4389),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(4389),
    [sym_auto] = ACTIONS(4389),
    [anon_sym_typename] = ACTIONS(4389),
    [anon_sym_new] = ACTIONS(4389),
    [anon_sym_COLON_COLON] = ACTIONS(4387),
    [anon_sym_delete] = ACTIONS(4389),
    [sym_nullptr] = ACTIONS(4389),
  },
  [2533] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(6443),
    [sym_comment] = ACTIONS(49),
  },
  [2534] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(6445),
    [sym_comment] = ACTIONS(49),
  },
  [2535] = {
    [sym_preproc_include] = STATE(1983),
    [sym_preproc_def] = STATE(1983),
    [sym_preproc_function_def] = STATE(1983),
    [sym_preproc_call] = STATE(1983),
    [sym_preproc_if_in_compound_statement] = STATE(1414),
    [sym_preproc_ifdef_in_compound_statement] = STATE(1415),
    [sym_preproc_else_in_compound_statement] = STATE(2691),
    [sym_preproc_elif_in_compound_statement] = STATE(2692),
    [sym_declaration] = STATE(1983),
    [sym_type_definition] = STATE(1983),
    [sym__declaration_specifiers] = STATE(1418),
    [sym_compound_statement] = STATE(1983),
    [sym_storage_class_specifier] = STATE(419),
    [sym_type_qualifier] = STATE(419),
    [sym__type_specifier] = STATE(30),
    [sym_sized_type_specifier] = STATE(30),
    [sym_enum_specifier] = STATE(30),
    [sym_struct_specifier] = STATE(30),
    [sym_union_specifier] = STATE(30),
    [sym_labeled_statement] = STATE(1983),
    [sym_expression_statement] = STATE(1983),
    [sym_if_statement] = STATE(1983),
    [sym_switch_statement] = STATE(1983),
    [sym_case_statement] = STATE(1983),
    [sym_while_statement] = STATE(1983),
    [sym_do_statement] = STATE(1983),
    [sym_for_statement] = STATE(1983),
    [sym_return_statement] = STATE(1983),
    [sym_break_statement] = STATE(1983),
    [sym_continue_statement] = STATE(1983),
    [sym_goto_statement] = STATE(1983),
    [sym__expression] = STATE(1419),
    [sym_comma_expression] = STATE(1420),
    [sym_conditional_expression] = STATE(1419),
    [sym_assignment_expression] = STATE(1419),
    [sym_pointer_expression] = STATE(1419),
    [sym_logical_expression] = STATE(1419),
    [sym_bitwise_expression] = STATE(1419),
    [sym_equality_expression] = STATE(1419),
    [sym_relational_expression] = STATE(1419),
    [sym_shift_expression] = STATE(1419),
    [sym_math_expression] = STATE(1419),
    [sym_cast_expression] = STATE(1419),
    [sym_sizeof_expression] = STATE(1419),
    [sym_subscript_expression] = STATE(1419),
    [sym_call_expression] = STATE(1419),
    [sym_field_expression] = STATE(1419),
    [sym_compound_literal_expression] = STATE(1419),
    [sym_parenthesized_expression] = STATE(1419),
    [sym_concatenated_string] = STATE(1419),
    [sym__empty_declaration] = STATE(1983),
    [sym_macro_type_specifier] = STATE(30),
    [sym_class_specifier] = STATE(30),
    [sym_dependent_type] = STATE(30),
    [sym_structured_binding_declaration] = STATE(1983),
    [sym_template_type] = STATE(415),
    [sym_template_function] = STATE(1419),
    [sym_for_range_loop] = STATE(1983),
    [sym_new_expression] = STATE(1419),
    [sym_delete_expression] = STATE(1419),
    [sym_lambda_expression] = STATE(1419),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(416),
    [sym_scoped_namespace_identifier] = STATE(417),
    [aux_sym_preproc_if_in_compound_statement_repeat1] = STATE(1983),
    [aux_sym__declaration_specifiers_repeat1] = STATE(419),
    [aux_sym_sized_type_specifier_repeat1] = STATE(38),
    [sym_raw_string_literal] = ACTIONS(2879),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(2881),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(2883),
    [anon_sym_LPAREN] = ACTIONS(626),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(2885),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(6447),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(2889),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(2891),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(2893),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(2895),
    [sym_preproc_directive] = ACTIONS(2897),
    [anon_sym_SEMI] = ACTIONS(2899),
    [anon_sym_typedef] = ACTIONS(2901),
    [anon_sym_extern] = ACTIONS(154),
    [anon_sym_LBRACE] = ACTIONS(2903),
    [anon_sym_STAR] = ACTIONS(644),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_static] = ACTIONS(154),
    [anon_sym_register] = ACTIONS(154),
    [anon_sym_inline] = ACTIONS(154),
    [anon_sym_const] = ACTIONS(158),
    [anon_sym_restrict] = ACTIONS(158),
    [anon_sym_volatile] = ACTIONS(158),
    [anon_sym__Atomic] = ACTIONS(158),
    [anon_sym_mutable] = ACTIONS(158),
    [anon_sym_explicit] = ACTIONS(158),
    [anon_sym_constexpr] = ACTIONS(158),
    [anon_sym_unsigned] = ACTIONS(31),
    [anon_sym_long] = ACTIONS(31),
    [anon_sym_short] = ACTIONS(31),
    [sym_primitive_type] = ACTIONS(33),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_union] = ACTIONS(39),
    [anon_sym_if] = ACTIONS(2905),
    [anon_sym_switch] = ACTIONS(2907),
    [anon_sym_case] = ACTIONS(2909),
    [anon_sym_default] = ACTIONS(2911),
    [anon_sym_while] = ACTIONS(2913),
    [anon_sym_do] = ACTIONS(2915),
    [anon_sym_for] = ACTIONS(2917),
    [anon_sym_return] = ACTIONS(2919),
    [anon_sym_break] = ACTIONS(2921),
    [anon_sym_continue] = ACTIONS(2923),
    [anon_sym_goto] = ACTIONS(2925),
    [anon_sym_AMP] = ACTIONS(644),
    [anon_sym_BANG] = ACTIONS(668),
    [anon_sym_TILDE] = ACTIONS(670),
    [anon_sym_PLUS] = ACTIONS(672),
    [anon_sym_DASH] = ACTIONS(672),
    [anon_sym_DASH_DASH] = ACTIONS(674),
    [anon_sym_PLUS_PLUS] = ACTIONS(674),
    [anon_sym_sizeof] = ACTIONS(676),
    [sym_number_literal] = ACTIONS(2879),
    [sym_char_literal] = ACTIONS(2879),
    [sym_string_literal] = ACTIONS(678),
    [sym_true] = ACTIONS(2927),
    [sym_false] = ACTIONS(2927),
    [sym_null] = ACTIONS(2927),
    [sym_identifier] = ACTIONS(2929),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(51),
    [sym_auto] = ACTIONS(33),
    [anon_sym_typename] = ACTIONS(53),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(684),
    [anon_sym_delete] = ACTIONS(686),
    [sym_nullptr] = ACTIONS(2927),
  },
  [2536] = {
    [sym_raw_string_literal] = ACTIONS(4495),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(4497),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(4497),
    [anon_sym_LPAREN] = ACTIONS(4495),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(4497),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(4497),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(4497),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(4497),
    [sym_preproc_directive] = ACTIONS(4497),
    [anon_sym_SEMI] = ACTIONS(4495),
    [anon_sym_typedef] = ACTIONS(4497),
    [anon_sym_extern] = ACTIONS(4497),
    [anon_sym_LBRACE] = ACTIONS(4495),
    [anon_sym_STAR] = ACTIONS(4495),
    [anon_sym_LBRACK] = ACTIONS(4495),
    [anon_sym_static] = ACTIONS(4497),
    [anon_sym_register] = ACTIONS(4497),
    [anon_sym_inline] = ACTIONS(4497),
    [anon_sym_const] = ACTIONS(4497),
    [anon_sym_restrict] = ACTIONS(4497),
    [anon_sym_volatile] = ACTIONS(4497),
    [anon_sym__Atomic] = ACTIONS(4497),
    [anon_sym_mutable] = ACTIONS(4497),
    [anon_sym_explicit] = ACTIONS(4497),
    [anon_sym_constexpr] = ACTIONS(4497),
    [anon_sym_unsigned] = ACTIONS(4497),
    [anon_sym_long] = ACTIONS(4497),
    [anon_sym_short] = ACTIONS(4497),
    [sym_primitive_type] = ACTIONS(4497),
    [anon_sym_enum] = ACTIONS(4497),
    [anon_sym_struct] = ACTIONS(4497),
    [anon_sym_union] = ACTIONS(4497),
    [anon_sym_if] = ACTIONS(4497),
    [anon_sym_switch] = ACTIONS(4497),
    [anon_sym_case] = ACTIONS(4497),
    [anon_sym_default] = ACTIONS(4497),
    [anon_sym_while] = ACTIONS(4497),
    [anon_sym_do] = ACTIONS(4497),
    [anon_sym_for] = ACTIONS(4497),
    [anon_sym_return] = ACTIONS(4497),
    [anon_sym_break] = ACTIONS(4497),
    [anon_sym_continue] = ACTIONS(4497),
    [anon_sym_goto] = ACTIONS(4497),
    [anon_sym_AMP] = ACTIONS(4495),
    [anon_sym_BANG] = ACTIONS(4495),
    [anon_sym_TILDE] = ACTIONS(4495),
    [anon_sym_PLUS] = ACTIONS(4497),
    [anon_sym_DASH] = ACTIONS(4497),
    [anon_sym_DASH_DASH] = ACTIONS(4495),
    [anon_sym_PLUS_PLUS] = ACTIONS(4495),
    [anon_sym_sizeof] = ACTIONS(4497),
    [sym_number_literal] = ACTIONS(4495),
    [sym_char_literal] = ACTIONS(4495),
    [sym_string_literal] = ACTIONS(4495),
    [sym_true] = ACTIONS(4497),
    [sym_false] = ACTIONS(4497),
    [sym_null] = ACTIONS(4497),
    [sym_identifier] = ACTIONS(4497),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(4497),
    [sym_auto] = ACTIONS(4497),
    [anon_sym_typename] = ACTIONS(4497),
    [anon_sym_new] = ACTIONS(4497),
    [anon_sym_COLON_COLON] = ACTIONS(4495),
    [anon_sym_delete] = ACTIONS(4497),
    [sym_nullptr] = ACTIONS(4497),
  },
  [2537] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(6449),
    [sym_comment] = ACTIONS(49),
  },
  [2538] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(6451),
    [sym_comment] = ACTIONS(49),
  },
  [2539] = {
    [sym_preproc_include] = STATE(1983),
    [sym_preproc_def] = STATE(1983),
    [sym_preproc_function_def] = STATE(1983),
    [sym_preproc_call] = STATE(1983),
    [sym_preproc_if_in_compound_statement] = STATE(1414),
    [sym_preproc_ifdef_in_compound_statement] = STATE(1415),
    [sym_preproc_else_in_compound_statement] = STATE(2696),
    [sym_preproc_elif_in_compound_statement] = STATE(2697),
    [sym_declaration] = STATE(1983),
    [sym_type_definition] = STATE(1983),
    [sym__declaration_specifiers] = STATE(1418),
    [sym_compound_statement] = STATE(1983),
    [sym_storage_class_specifier] = STATE(419),
    [sym_type_qualifier] = STATE(419),
    [sym__type_specifier] = STATE(30),
    [sym_sized_type_specifier] = STATE(30),
    [sym_enum_specifier] = STATE(30),
    [sym_struct_specifier] = STATE(30),
    [sym_union_specifier] = STATE(30),
    [sym_labeled_statement] = STATE(1983),
    [sym_expression_statement] = STATE(1983),
    [sym_if_statement] = STATE(1983),
    [sym_switch_statement] = STATE(1983),
    [sym_case_statement] = STATE(1983),
    [sym_while_statement] = STATE(1983),
    [sym_do_statement] = STATE(1983),
    [sym_for_statement] = STATE(1983),
    [sym_return_statement] = STATE(1983),
    [sym_break_statement] = STATE(1983),
    [sym_continue_statement] = STATE(1983),
    [sym_goto_statement] = STATE(1983),
    [sym__expression] = STATE(1419),
    [sym_comma_expression] = STATE(1420),
    [sym_conditional_expression] = STATE(1419),
    [sym_assignment_expression] = STATE(1419),
    [sym_pointer_expression] = STATE(1419),
    [sym_logical_expression] = STATE(1419),
    [sym_bitwise_expression] = STATE(1419),
    [sym_equality_expression] = STATE(1419),
    [sym_relational_expression] = STATE(1419),
    [sym_shift_expression] = STATE(1419),
    [sym_math_expression] = STATE(1419),
    [sym_cast_expression] = STATE(1419),
    [sym_sizeof_expression] = STATE(1419),
    [sym_subscript_expression] = STATE(1419),
    [sym_call_expression] = STATE(1419),
    [sym_field_expression] = STATE(1419),
    [sym_compound_literal_expression] = STATE(1419),
    [sym_parenthesized_expression] = STATE(1419),
    [sym_concatenated_string] = STATE(1419),
    [sym__empty_declaration] = STATE(1983),
    [sym_macro_type_specifier] = STATE(30),
    [sym_class_specifier] = STATE(30),
    [sym_dependent_type] = STATE(30),
    [sym_structured_binding_declaration] = STATE(1983),
    [sym_template_type] = STATE(415),
    [sym_template_function] = STATE(1419),
    [sym_for_range_loop] = STATE(1983),
    [sym_new_expression] = STATE(1419),
    [sym_delete_expression] = STATE(1419),
    [sym_lambda_expression] = STATE(1419),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(416),
    [sym_scoped_namespace_identifier] = STATE(417),
    [aux_sym_preproc_if_in_compound_statement_repeat1] = STATE(1983),
    [aux_sym__declaration_specifiers_repeat1] = STATE(419),
    [aux_sym_sized_type_specifier_repeat1] = STATE(38),
    [sym_raw_string_literal] = ACTIONS(2879),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(2881),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(2883),
    [anon_sym_LPAREN] = ACTIONS(626),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(2885),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(6453),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(2889),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(2891),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(2893),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(2895),
    [sym_preproc_directive] = ACTIONS(2897),
    [anon_sym_SEMI] = ACTIONS(2899),
    [anon_sym_typedef] = ACTIONS(2901),
    [anon_sym_extern] = ACTIONS(154),
    [anon_sym_LBRACE] = ACTIONS(2903),
    [anon_sym_STAR] = ACTIONS(644),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_static] = ACTIONS(154),
    [anon_sym_register] = ACTIONS(154),
    [anon_sym_inline] = ACTIONS(154),
    [anon_sym_const] = ACTIONS(158),
    [anon_sym_restrict] = ACTIONS(158),
    [anon_sym_volatile] = ACTIONS(158),
    [anon_sym__Atomic] = ACTIONS(158),
    [anon_sym_mutable] = ACTIONS(158),
    [anon_sym_explicit] = ACTIONS(158),
    [anon_sym_constexpr] = ACTIONS(158),
    [anon_sym_unsigned] = ACTIONS(31),
    [anon_sym_long] = ACTIONS(31),
    [anon_sym_short] = ACTIONS(31),
    [sym_primitive_type] = ACTIONS(33),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_union] = ACTIONS(39),
    [anon_sym_if] = ACTIONS(2905),
    [anon_sym_switch] = ACTIONS(2907),
    [anon_sym_case] = ACTIONS(2909),
    [anon_sym_default] = ACTIONS(2911),
    [anon_sym_while] = ACTIONS(2913),
    [anon_sym_do] = ACTIONS(2915),
    [anon_sym_for] = ACTIONS(2917),
    [anon_sym_return] = ACTIONS(2919),
    [anon_sym_break] = ACTIONS(2921),
    [anon_sym_continue] = ACTIONS(2923),
    [anon_sym_goto] = ACTIONS(2925),
    [anon_sym_AMP] = ACTIONS(644),
    [anon_sym_BANG] = ACTIONS(668),
    [anon_sym_TILDE] = ACTIONS(670),
    [anon_sym_PLUS] = ACTIONS(672),
    [anon_sym_DASH] = ACTIONS(672),
    [anon_sym_DASH_DASH] = ACTIONS(674),
    [anon_sym_PLUS_PLUS] = ACTIONS(674),
    [anon_sym_sizeof] = ACTIONS(676),
    [sym_number_literal] = ACTIONS(2879),
    [sym_char_literal] = ACTIONS(2879),
    [sym_string_literal] = ACTIONS(678),
    [sym_true] = ACTIONS(2927),
    [sym_false] = ACTIONS(2927),
    [sym_null] = ACTIONS(2927),
    [sym_identifier] = ACTIONS(2929),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(51),
    [sym_auto] = ACTIONS(33),
    [anon_sym_typename] = ACTIONS(53),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(684),
    [anon_sym_delete] = ACTIONS(686),
    [sym_nullptr] = ACTIONS(2927),
  },
  [2540] = {
    [sym_raw_string_literal] = ACTIONS(4505),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(4507),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(4507),
    [anon_sym_LPAREN] = ACTIONS(4505),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(4507),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(4507),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(4507),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(4507),
    [sym_preproc_directive] = ACTIONS(4507),
    [anon_sym_SEMI] = ACTIONS(4505),
    [anon_sym_typedef] = ACTIONS(4507),
    [anon_sym_extern] = ACTIONS(4507),
    [anon_sym_LBRACE] = ACTIONS(4505),
    [anon_sym_STAR] = ACTIONS(4505),
    [anon_sym_LBRACK] = ACTIONS(4505),
    [anon_sym_static] = ACTIONS(4507),
    [anon_sym_register] = ACTIONS(4507),
    [anon_sym_inline] = ACTIONS(4507),
    [anon_sym_const] = ACTIONS(4507),
    [anon_sym_restrict] = ACTIONS(4507),
    [anon_sym_volatile] = ACTIONS(4507),
    [anon_sym__Atomic] = ACTIONS(4507),
    [anon_sym_mutable] = ACTIONS(4507),
    [anon_sym_explicit] = ACTIONS(4507),
    [anon_sym_constexpr] = ACTIONS(4507),
    [anon_sym_unsigned] = ACTIONS(4507),
    [anon_sym_long] = ACTIONS(4507),
    [anon_sym_short] = ACTIONS(4507),
    [sym_primitive_type] = ACTIONS(4507),
    [anon_sym_enum] = ACTIONS(4507),
    [anon_sym_struct] = ACTIONS(4507),
    [anon_sym_union] = ACTIONS(4507),
    [anon_sym_if] = ACTIONS(4507),
    [anon_sym_switch] = ACTIONS(4507),
    [anon_sym_case] = ACTIONS(4507),
    [anon_sym_default] = ACTIONS(4507),
    [anon_sym_while] = ACTIONS(4507),
    [anon_sym_do] = ACTIONS(4507),
    [anon_sym_for] = ACTIONS(4507),
    [anon_sym_return] = ACTIONS(4507),
    [anon_sym_break] = ACTIONS(4507),
    [anon_sym_continue] = ACTIONS(4507),
    [anon_sym_goto] = ACTIONS(4507),
    [anon_sym_AMP] = ACTIONS(4505),
    [anon_sym_BANG] = ACTIONS(4505),
    [anon_sym_TILDE] = ACTIONS(4505),
    [anon_sym_PLUS] = ACTIONS(4507),
    [anon_sym_DASH] = ACTIONS(4507),
    [anon_sym_DASH_DASH] = ACTIONS(4505),
    [anon_sym_PLUS_PLUS] = ACTIONS(4505),
    [anon_sym_sizeof] = ACTIONS(4507),
    [sym_number_literal] = ACTIONS(4505),
    [sym_char_literal] = ACTIONS(4505),
    [sym_string_literal] = ACTIONS(4505),
    [sym_true] = ACTIONS(4507),
    [sym_false] = ACTIONS(4507),
    [sym_null] = ACTIONS(4507),
    [sym_identifier] = ACTIONS(4507),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(4507),
    [sym_auto] = ACTIONS(4507),
    [anon_sym_typename] = ACTIONS(4507),
    [anon_sym_new] = ACTIONS(4507),
    [anon_sym_COLON_COLON] = ACTIONS(4505),
    [anon_sym_delete] = ACTIONS(4507),
    [sym_nullptr] = ACTIONS(4507),
  },
  [2541] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(6455),
    [sym_comment] = ACTIONS(49),
  },
  [2542] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(6457),
    [sym_comment] = ACTIONS(49),
  },
  [2543] = {
    [sym_preproc_include] = STATE(1983),
    [sym_preproc_def] = STATE(1983),
    [sym_preproc_function_def] = STATE(1983),
    [sym_preproc_call] = STATE(1983),
    [sym_preproc_if_in_compound_statement] = STATE(1414),
    [sym_preproc_ifdef_in_compound_statement] = STATE(1415),
    [sym_preproc_else_in_compound_statement] = STATE(2701),
    [sym_preproc_elif_in_compound_statement] = STATE(2702),
    [sym_declaration] = STATE(1983),
    [sym_type_definition] = STATE(1983),
    [sym__declaration_specifiers] = STATE(1418),
    [sym_compound_statement] = STATE(1983),
    [sym_storage_class_specifier] = STATE(419),
    [sym_type_qualifier] = STATE(419),
    [sym__type_specifier] = STATE(30),
    [sym_sized_type_specifier] = STATE(30),
    [sym_enum_specifier] = STATE(30),
    [sym_struct_specifier] = STATE(30),
    [sym_union_specifier] = STATE(30),
    [sym_labeled_statement] = STATE(1983),
    [sym_expression_statement] = STATE(1983),
    [sym_if_statement] = STATE(1983),
    [sym_switch_statement] = STATE(1983),
    [sym_case_statement] = STATE(1983),
    [sym_while_statement] = STATE(1983),
    [sym_do_statement] = STATE(1983),
    [sym_for_statement] = STATE(1983),
    [sym_return_statement] = STATE(1983),
    [sym_break_statement] = STATE(1983),
    [sym_continue_statement] = STATE(1983),
    [sym_goto_statement] = STATE(1983),
    [sym__expression] = STATE(1419),
    [sym_comma_expression] = STATE(1420),
    [sym_conditional_expression] = STATE(1419),
    [sym_assignment_expression] = STATE(1419),
    [sym_pointer_expression] = STATE(1419),
    [sym_logical_expression] = STATE(1419),
    [sym_bitwise_expression] = STATE(1419),
    [sym_equality_expression] = STATE(1419),
    [sym_relational_expression] = STATE(1419),
    [sym_shift_expression] = STATE(1419),
    [sym_math_expression] = STATE(1419),
    [sym_cast_expression] = STATE(1419),
    [sym_sizeof_expression] = STATE(1419),
    [sym_subscript_expression] = STATE(1419),
    [sym_call_expression] = STATE(1419),
    [sym_field_expression] = STATE(1419),
    [sym_compound_literal_expression] = STATE(1419),
    [sym_parenthesized_expression] = STATE(1419),
    [sym_concatenated_string] = STATE(1419),
    [sym__empty_declaration] = STATE(1983),
    [sym_macro_type_specifier] = STATE(30),
    [sym_class_specifier] = STATE(30),
    [sym_dependent_type] = STATE(30),
    [sym_structured_binding_declaration] = STATE(1983),
    [sym_template_type] = STATE(415),
    [sym_template_function] = STATE(1419),
    [sym_for_range_loop] = STATE(1983),
    [sym_new_expression] = STATE(1419),
    [sym_delete_expression] = STATE(1419),
    [sym_lambda_expression] = STATE(1419),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(416),
    [sym_scoped_namespace_identifier] = STATE(417),
    [aux_sym_preproc_if_in_compound_statement_repeat1] = STATE(1983),
    [aux_sym__declaration_specifiers_repeat1] = STATE(419),
    [aux_sym_sized_type_specifier_repeat1] = STATE(38),
    [sym_raw_string_literal] = ACTIONS(2879),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(2881),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(2883),
    [anon_sym_LPAREN] = ACTIONS(626),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(2885),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(6459),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(2889),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(2891),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(2893),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(2895),
    [sym_preproc_directive] = ACTIONS(2897),
    [anon_sym_SEMI] = ACTIONS(2899),
    [anon_sym_typedef] = ACTIONS(2901),
    [anon_sym_extern] = ACTIONS(154),
    [anon_sym_LBRACE] = ACTIONS(2903),
    [anon_sym_STAR] = ACTIONS(644),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_static] = ACTIONS(154),
    [anon_sym_register] = ACTIONS(154),
    [anon_sym_inline] = ACTIONS(154),
    [anon_sym_const] = ACTIONS(158),
    [anon_sym_restrict] = ACTIONS(158),
    [anon_sym_volatile] = ACTIONS(158),
    [anon_sym__Atomic] = ACTIONS(158),
    [anon_sym_mutable] = ACTIONS(158),
    [anon_sym_explicit] = ACTIONS(158),
    [anon_sym_constexpr] = ACTIONS(158),
    [anon_sym_unsigned] = ACTIONS(31),
    [anon_sym_long] = ACTIONS(31),
    [anon_sym_short] = ACTIONS(31),
    [sym_primitive_type] = ACTIONS(33),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_union] = ACTIONS(39),
    [anon_sym_if] = ACTIONS(2905),
    [anon_sym_switch] = ACTIONS(2907),
    [anon_sym_case] = ACTIONS(2909),
    [anon_sym_default] = ACTIONS(2911),
    [anon_sym_while] = ACTIONS(2913),
    [anon_sym_do] = ACTIONS(2915),
    [anon_sym_for] = ACTIONS(2917),
    [anon_sym_return] = ACTIONS(2919),
    [anon_sym_break] = ACTIONS(2921),
    [anon_sym_continue] = ACTIONS(2923),
    [anon_sym_goto] = ACTIONS(2925),
    [anon_sym_AMP] = ACTIONS(644),
    [anon_sym_BANG] = ACTIONS(668),
    [anon_sym_TILDE] = ACTIONS(670),
    [anon_sym_PLUS] = ACTIONS(672),
    [anon_sym_DASH] = ACTIONS(672),
    [anon_sym_DASH_DASH] = ACTIONS(674),
    [anon_sym_PLUS_PLUS] = ACTIONS(674),
    [anon_sym_sizeof] = ACTIONS(676),
    [sym_number_literal] = ACTIONS(2879),
    [sym_char_literal] = ACTIONS(2879),
    [sym_string_literal] = ACTIONS(678),
    [sym_true] = ACTIONS(2927),
    [sym_false] = ACTIONS(2927),
    [sym_null] = ACTIONS(2927),
    [sym_identifier] = ACTIONS(2929),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(51),
    [sym_auto] = ACTIONS(33),
    [anon_sym_typename] = ACTIONS(53),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(684),
    [anon_sym_delete] = ACTIONS(686),
    [sym_nullptr] = ACTIONS(2927),
  },
  [2544] = {
    [anon_sym_LF] = ACTIONS(6461),
    [sym_comment] = ACTIONS(83),
  },
  [2545] = {
    [sym_parameter_list] = STATE(513),
    [anon_sym_LPAREN] = ACTIONS(206),
    [anon_sym_SEMI] = ACTIONS(6463),
    [anon_sym_LBRACK] = ACTIONS(955),
    [sym_comment] = ACTIONS(49),
  },
  [2546] = {
    [sym__type_declarator] = STATE(2705),
    [sym_pointer_type_declarator] = STATE(213),
    [sym_function_type_declarator] = STATE(214),
    [sym_array_type_declarator] = STATE(215),
    [anon_sym_LPAREN] = ACTIONS(327),
    [anon_sym_STAR] = ACTIONS(329),
    [sym_identifier] = ACTIONS(331),
    [sym_comment] = ACTIONS(49),
  },
  [2547] = {
    [sym_raw_string_literal] = ACTIONS(3182),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3184),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3184),
    [anon_sym_LPAREN] = ACTIONS(3182),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3184),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3184),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3184),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3184),
    [sym_preproc_directive] = ACTIONS(3184),
    [anon_sym_SEMI] = ACTIONS(3182),
    [anon_sym_typedef] = ACTIONS(3184),
    [anon_sym_extern] = ACTIONS(3184),
    [anon_sym_LBRACE] = ACTIONS(3182),
    [anon_sym_STAR] = ACTIONS(3182),
    [anon_sym_LBRACK] = ACTIONS(3182),
    [anon_sym_static] = ACTIONS(3184),
    [anon_sym_register] = ACTIONS(3184),
    [anon_sym_inline] = ACTIONS(3184),
    [anon_sym_const] = ACTIONS(3184),
    [anon_sym_restrict] = ACTIONS(3184),
    [anon_sym_volatile] = ACTIONS(3184),
    [anon_sym__Atomic] = ACTIONS(3184),
    [anon_sym_mutable] = ACTIONS(3184),
    [anon_sym_explicit] = ACTIONS(3184),
    [anon_sym_constexpr] = ACTIONS(3184),
    [anon_sym_unsigned] = ACTIONS(3184),
    [anon_sym_long] = ACTIONS(3184),
    [anon_sym_short] = ACTIONS(3184),
    [sym_primitive_type] = ACTIONS(3184),
    [anon_sym_enum] = ACTIONS(3184),
    [anon_sym_struct] = ACTIONS(3184),
    [anon_sym_union] = ACTIONS(3184),
    [anon_sym_if] = ACTIONS(3184),
    [anon_sym_switch] = ACTIONS(3184),
    [anon_sym_case] = ACTIONS(3184),
    [anon_sym_default] = ACTIONS(3184),
    [anon_sym_while] = ACTIONS(3184),
    [anon_sym_do] = ACTIONS(3184),
    [anon_sym_for] = ACTIONS(3184),
    [anon_sym_return] = ACTIONS(3184),
    [anon_sym_break] = ACTIONS(3184),
    [anon_sym_continue] = ACTIONS(3184),
    [anon_sym_goto] = ACTIONS(3184),
    [anon_sym_AMP] = ACTIONS(3182),
    [anon_sym_BANG] = ACTIONS(3182),
    [anon_sym_TILDE] = ACTIONS(3182),
    [anon_sym_PLUS] = ACTIONS(3184),
    [anon_sym_DASH] = ACTIONS(3184),
    [anon_sym_DASH_DASH] = ACTIONS(3182),
    [anon_sym_PLUS_PLUS] = ACTIONS(3182),
    [anon_sym_sizeof] = ACTIONS(3184),
    [sym_number_literal] = ACTIONS(3182),
    [sym_char_literal] = ACTIONS(3182),
    [sym_string_literal] = ACTIONS(3182),
    [sym_true] = ACTIONS(3184),
    [sym_false] = ACTIONS(3184),
    [sym_null] = ACTIONS(3184),
    [sym_identifier] = ACTIONS(3184),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(3184),
    [sym_auto] = ACTIONS(3184),
    [anon_sym_typename] = ACTIONS(3184),
    [anon_sym_new] = ACTIONS(3184),
    [anon_sym_COLON_COLON] = ACTIONS(3182),
    [anon_sym_delete] = ACTIONS(3184),
    [sym_nullptr] = ACTIONS(3184),
  },
  [2548] = {
    [sym_argument_list] = STATE(802),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_RPAREN] = ACTIONS(6465),
    [anon_sym_STAR] = ACTIONS(4537),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_EQ] = ACTIONS(4539),
    [anon_sym_QMARK] = ACTIONS(4541),
    [anon_sym_STAR_EQ] = ACTIONS(4543),
    [anon_sym_SLASH_EQ] = ACTIONS(4543),
    [anon_sym_PERCENT_EQ] = ACTIONS(4543),
    [anon_sym_PLUS_EQ] = ACTIONS(4543),
    [anon_sym_DASH_EQ] = ACTIONS(4543),
    [anon_sym_LT_LT_EQ] = ACTIONS(4543),
    [anon_sym_GT_GT_EQ] = ACTIONS(4543),
    [anon_sym_AMP_EQ] = ACTIONS(4543),
    [anon_sym_CARET_EQ] = ACTIONS(4543),
    [anon_sym_PIPE_EQ] = ACTIONS(4543),
    [anon_sym_AMP] = ACTIONS(4545),
    [anon_sym_PIPE_PIPE] = ACTIONS(4547),
    [anon_sym_AMP_AMP] = ACTIONS(4549),
    [anon_sym_PIPE] = ACTIONS(4551),
    [anon_sym_CARET] = ACTIONS(4553),
    [anon_sym_EQ_EQ] = ACTIONS(4555),
    [anon_sym_BANG_EQ] = ACTIONS(4555),
    [anon_sym_LT] = ACTIONS(4557),
    [anon_sym_GT] = ACTIONS(4557),
    [anon_sym_LT_EQ] = ACTIONS(4559),
    [anon_sym_GT_EQ] = ACTIONS(4559),
    [anon_sym_LT_LT] = ACTIONS(4561),
    [anon_sym_GT_GT] = ACTIONS(4561),
    [anon_sym_PLUS] = ACTIONS(4563),
    [anon_sym_DASH] = ACTIONS(4563),
    [anon_sym_SLASH] = ACTIONS(4537),
    [anon_sym_PERCENT] = ACTIONS(4537),
    [anon_sym_DASH_DASH] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(1554),
    [anon_sym_DASH_GT] = ACTIONS(1554),
    [sym_comment] = ACTIONS(49),
  },
  [2549] = {
    [sym__expression] = STATE(2707),
    [sym_conditional_expression] = STATE(2707),
    [sym_assignment_expression] = STATE(2707),
    [sym_pointer_expression] = STATE(2707),
    [sym_logical_expression] = STATE(2707),
    [sym_bitwise_expression] = STATE(2707),
    [sym_equality_expression] = STATE(2707),
    [sym_relational_expression] = STATE(2707),
    [sym_shift_expression] = STATE(2707),
    [sym_math_expression] = STATE(2707),
    [sym_cast_expression] = STATE(2707),
    [sym_sizeof_expression] = STATE(2707),
    [sym_subscript_expression] = STATE(2707),
    [sym_call_expression] = STATE(2707),
    [sym_field_expression] = STATE(2707),
    [sym_compound_literal_expression] = STATE(2707),
    [sym_parenthesized_expression] = STATE(2707),
    [sym_concatenated_string] = STATE(2707),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(2707),
    [sym_new_expression] = STATE(2707),
    [sym_delete_expression] = STATE(2707),
    [sym_lambda_expression] = STATE(2707),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(6467),
    [anon_sym_LPAREN] = ACTIONS(2943),
    [anon_sym_STAR] = ACTIONS(2945),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_AMP] = ACTIONS(2945),
    [anon_sym_BANG] = ACTIONS(2947),
    [anon_sym_TILDE] = ACTIONS(2949),
    [anon_sym_PLUS] = ACTIONS(2951),
    [anon_sym_DASH] = ACTIONS(2951),
    [anon_sym_DASH_DASH] = ACTIONS(2953),
    [anon_sym_PLUS_PLUS] = ACTIONS(2953),
    [anon_sym_sizeof] = ACTIONS(2955),
    [sym_number_literal] = ACTIONS(6467),
    [sym_char_literal] = ACTIONS(6467),
    [sym_string_literal] = ACTIONS(2957),
    [sym_true] = ACTIONS(6469),
    [sym_false] = ACTIONS(6469),
    [sym_null] = ACTIONS(6469),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(2961),
    [anon_sym_delete] = ACTIONS(2963),
    [sym_nullptr] = ACTIONS(6469),
  },
  [2550] = {
    [sym_argument_list] = STATE(802),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_RPAREN] = ACTIONS(6471),
    [anon_sym_STAR] = ACTIONS(4537),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_EQ] = ACTIONS(4539),
    [anon_sym_QMARK] = ACTIONS(4541),
    [anon_sym_STAR_EQ] = ACTIONS(4543),
    [anon_sym_SLASH_EQ] = ACTIONS(4543),
    [anon_sym_PERCENT_EQ] = ACTIONS(4543),
    [anon_sym_PLUS_EQ] = ACTIONS(4543),
    [anon_sym_DASH_EQ] = ACTIONS(4543),
    [anon_sym_LT_LT_EQ] = ACTIONS(4543),
    [anon_sym_GT_GT_EQ] = ACTIONS(4543),
    [anon_sym_AMP_EQ] = ACTIONS(4543),
    [anon_sym_CARET_EQ] = ACTIONS(4543),
    [anon_sym_PIPE_EQ] = ACTIONS(4543),
    [anon_sym_AMP] = ACTIONS(4545),
    [anon_sym_PIPE_PIPE] = ACTIONS(4547),
    [anon_sym_AMP_AMP] = ACTIONS(4549),
    [anon_sym_PIPE] = ACTIONS(4551),
    [anon_sym_CARET] = ACTIONS(4553),
    [anon_sym_EQ_EQ] = ACTIONS(4555),
    [anon_sym_BANG_EQ] = ACTIONS(4555),
    [anon_sym_LT] = ACTIONS(4557),
    [anon_sym_GT] = ACTIONS(4557),
    [anon_sym_LT_EQ] = ACTIONS(4559),
    [anon_sym_GT_EQ] = ACTIONS(4559),
    [anon_sym_LT_LT] = ACTIONS(4561),
    [anon_sym_GT_GT] = ACTIONS(4561),
    [anon_sym_PLUS] = ACTIONS(4563),
    [anon_sym_DASH] = ACTIONS(4563),
    [anon_sym_SLASH] = ACTIONS(4537),
    [anon_sym_PERCENT] = ACTIONS(4537),
    [anon_sym_DASH_DASH] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(1554),
    [anon_sym_DASH_GT] = ACTIONS(1554),
    [sym_comment] = ACTIONS(49),
  },
  [2551] = {
    [sym_declaration] = STATE(2709),
    [sym_type_definition] = STATE(2709),
    [sym__declaration_specifiers] = STATE(2554),
    [sym_compound_statement] = STATE(2709),
    [sym_storage_class_specifier] = STATE(109),
    [sym_type_qualifier] = STATE(109),
    [sym__type_specifier] = STATE(105),
    [sym_sized_type_specifier] = STATE(105),
    [sym_enum_specifier] = STATE(105),
    [sym_struct_specifier] = STATE(105),
    [sym_union_specifier] = STATE(105),
    [sym_labeled_statement] = STATE(2709),
    [sym_expression_statement] = STATE(2709),
    [sym_if_statement] = STATE(2709),
    [sym_switch_statement] = STATE(2709),
    [sym_case_statement] = STATE(2709),
    [sym_while_statement] = STATE(2709),
    [sym_do_statement] = STATE(2709),
    [sym_for_statement] = STATE(2709),
    [sym_return_statement] = STATE(2709),
    [sym_break_statement] = STATE(2709),
    [sym_continue_statement] = STATE(2709),
    [sym_goto_statement] = STATE(2709),
    [sym__expression] = STATE(1947),
    [sym_comma_expression] = STATE(1948),
    [sym_conditional_expression] = STATE(1947),
    [sym_assignment_expression] = STATE(1947),
    [sym_pointer_expression] = STATE(1947),
    [sym_logical_expression] = STATE(1947),
    [sym_bitwise_expression] = STATE(1947),
    [sym_equality_expression] = STATE(1947),
    [sym_relational_expression] = STATE(1947),
    [sym_shift_expression] = STATE(1947),
    [sym_math_expression] = STATE(1947),
    [sym_cast_expression] = STATE(1947),
    [sym_sizeof_expression] = STATE(1947),
    [sym_subscript_expression] = STATE(1947),
    [sym_call_expression] = STATE(1947),
    [sym_field_expression] = STATE(1947),
    [sym_compound_literal_expression] = STATE(1947),
    [sym_parenthesized_expression] = STATE(1947),
    [sym_concatenated_string] = STATE(1947),
    [sym_macro_type_specifier] = STATE(105),
    [sym_class_specifier] = STATE(105),
    [sym_dependent_type] = STATE(105),
    [sym_template_type] = STATE(1475),
    [sym_template_function] = STATE(1947),
    [sym_for_range_loop] = STATE(2709),
    [sym_new_expression] = STATE(1947),
    [sym_delete_expression] = STATE(1947),
    [sym_lambda_expression] = STATE(1947),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(416),
    [sym_scoped_namespace_identifier] = STATE(1476),
    [aux_sym__declaration_specifiers_repeat1] = STATE(109),
    [aux_sym_sized_type_specifier_repeat1] = STATE(110),
    [sym_raw_string_literal] = ACTIONS(4395),
    [anon_sym_LPAREN] = ACTIONS(626),
    [anon_sym_SEMI] = ACTIONS(4411),
    [anon_sym_typedef] = ACTIONS(4413),
    [anon_sym_extern] = ACTIONS(154),
    [anon_sym_LBRACE] = ACTIONS(4415),
    [anon_sym_STAR] = ACTIONS(644),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_static] = ACTIONS(154),
    [anon_sym_register] = ACTIONS(154),
    [anon_sym_inline] = ACTIONS(154),
    [anon_sym_const] = ACTIONS(158),
    [anon_sym_restrict] = ACTIONS(158),
    [anon_sym_volatile] = ACTIONS(158),
    [anon_sym__Atomic] = ACTIONS(158),
    [anon_sym_mutable] = ACTIONS(158),
    [anon_sym_explicit] = ACTIONS(158),
    [anon_sym_constexpr] = ACTIONS(158),
    [anon_sym_unsigned] = ACTIONS(160),
    [anon_sym_long] = ACTIONS(160),
    [anon_sym_short] = ACTIONS(160),
    [sym_primitive_type] = ACTIONS(162),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_union] = ACTIONS(39),
    [anon_sym_if] = ACTIONS(4417),
    [anon_sym_switch] = ACTIONS(4419),
    [anon_sym_case] = ACTIONS(4421),
    [anon_sym_default] = ACTIONS(4423),
    [anon_sym_while] = ACTIONS(4425),
    [anon_sym_do] = ACTIONS(4427),
    [anon_sym_for] = ACTIONS(4429),
    [anon_sym_return] = ACTIONS(4431),
    [anon_sym_break] = ACTIONS(4433),
    [anon_sym_continue] = ACTIONS(4435),
    [anon_sym_goto] = ACTIONS(4437),
    [anon_sym_AMP] = ACTIONS(644),
    [anon_sym_BANG] = ACTIONS(668),
    [anon_sym_TILDE] = ACTIONS(670),
    [anon_sym_PLUS] = ACTIONS(672),
    [anon_sym_DASH] = ACTIONS(672),
    [anon_sym_DASH_DASH] = ACTIONS(674),
    [anon_sym_PLUS_PLUS] = ACTIONS(674),
    [anon_sym_sizeof] = ACTIONS(676),
    [sym_number_literal] = ACTIONS(4395),
    [sym_char_literal] = ACTIONS(4395),
    [sym_string_literal] = ACTIONS(678),
    [sym_true] = ACTIONS(4439),
    [sym_false] = ACTIONS(4439),
    [sym_null] = ACTIONS(4439),
    [sym_identifier] = ACTIONS(6059),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(51),
    [sym_auto] = ACTIONS(162),
    [anon_sym_typename] = ACTIONS(172),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(3040),
    [anon_sym_delete] = ACTIONS(686),
    [sym_nullptr] = ACTIONS(4439),
  },
  [2552] = {
    [sym_initializer_list] = STATE(765),
    [sym_template_argument_list] = STATE(2039),
    [anon_sym_LPAREN] = ACTIONS(1483),
    [anon_sym_COMMA] = ACTIONS(1477),
    [anon_sym_SEMI] = ACTIONS(1477),
    [anon_sym_extern] = ACTIONS(144),
    [anon_sym_LBRACE] = ACTIONS(548),
    [anon_sym_STAR] = ACTIONS(1486),
    [anon_sym_LBRACK] = ACTIONS(1477),
    [anon_sym_EQ] = ACTIONS(1479),
    [anon_sym_static] = ACTIONS(144),
    [anon_sym_register] = ACTIONS(144),
    [anon_sym_inline] = ACTIONS(144),
    [anon_sym_const] = ACTIONS(144),
    [anon_sym_restrict] = ACTIONS(144),
    [anon_sym_volatile] = ACTIONS(144),
    [anon_sym__Atomic] = ACTIONS(144),
    [anon_sym_mutable] = ACTIONS(144),
    [anon_sym_explicit] = ACTIONS(144),
    [anon_sym_constexpr] = ACTIONS(144),
    [anon_sym_COLON] = ACTIONS(5349),
    [anon_sym_QMARK] = ACTIONS(1477),
    [anon_sym_STAR_EQ] = ACTIONS(1477),
    [anon_sym_SLASH_EQ] = ACTIONS(1477),
    [anon_sym_PERCENT_EQ] = ACTIONS(1477),
    [anon_sym_PLUS_EQ] = ACTIONS(1477),
    [anon_sym_DASH_EQ] = ACTIONS(1477),
    [anon_sym_LT_LT_EQ] = ACTIONS(1477),
    [anon_sym_GT_GT_EQ] = ACTIONS(1477),
    [anon_sym_AMP_EQ] = ACTIONS(1477),
    [anon_sym_CARET_EQ] = ACTIONS(1477),
    [anon_sym_PIPE_EQ] = ACTIONS(1477),
    [anon_sym_AMP] = ACTIONS(1486),
    [anon_sym_PIPE_PIPE] = ACTIONS(1477),
    [anon_sym_AMP_AMP] = ACTIONS(1483),
    [anon_sym_PIPE] = ACTIONS(1479),
    [anon_sym_CARET] = ACTIONS(1479),
    [anon_sym_TILDE] = ACTIONS(142),
    [anon_sym_EQ_EQ] = ACTIONS(1477),
    [anon_sym_BANG_EQ] = ACTIONS(1477),
    [anon_sym_LT] = ACTIONS(1564),
    [anon_sym_GT] = ACTIONS(1479),
    [anon_sym_LT_EQ] = ACTIONS(1477),
    [anon_sym_GT_EQ] = ACTIONS(1477),
    [anon_sym_LT_LT] = ACTIONS(1479),
    [anon_sym_GT_GT] = ACTIONS(1479),
    [anon_sym_PLUS] = ACTIONS(1479),
    [anon_sym_DASH] = ACTIONS(1479),
    [anon_sym_SLASH] = ACTIONS(1479),
    [anon_sym_PERCENT] = ACTIONS(1479),
    [anon_sym_DASH_DASH] = ACTIONS(1477),
    [anon_sym_PLUS_PLUS] = ACTIONS(1477),
    [anon_sym_DOT] = ACTIONS(1477),
    [anon_sym_DASH_GT] = ACTIONS(1477),
    [sym_identifier] = ACTIONS(144),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(4631),
    [sym_operator_name] = ACTIONS(142),
  },
  [2553] = {
    [sym_raw_string_literal] = ACTIONS(4635),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(4637),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(4637),
    [anon_sym_LPAREN] = ACTIONS(4635),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(4637),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(4637),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(4637),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(4637),
    [sym_preproc_directive] = ACTIONS(4637),
    [anon_sym_SEMI] = ACTIONS(4635),
    [anon_sym_typedef] = ACTIONS(4637),
    [anon_sym_extern] = ACTIONS(4637),
    [anon_sym_LBRACE] = ACTIONS(4635),
    [anon_sym_STAR] = ACTIONS(4635),
    [anon_sym_LBRACK] = ACTIONS(4635),
    [anon_sym_static] = ACTIONS(4637),
    [anon_sym_register] = ACTIONS(4637),
    [anon_sym_inline] = ACTIONS(4637),
    [anon_sym_const] = ACTIONS(4637),
    [anon_sym_restrict] = ACTIONS(4637),
    [anon_sym_volatile] = ACTIONS(4637),
    [anon_sym__Atomic] = ACTIONS(4637),
    [anon_sym_mutable] = ACTIONS(4637),
    [anon_sym_explicit] = ACTIONS(4637),
    [anon_sym_constexpr] = ACTIONS(4637),
    [anon_sym_unsigned] = ACTIONS(4637),
    [anon_sym_long] = ACTIONS(4637),
    [anon_sym_short] = ACTIONS(4637),
    [sym_primitive_type] = ACTIONS(4637),
    [anon_sym_enum] = ACTIONS(4637),
    [anon_sym_struct] = ACTIONS(4637),
    [anon_sym_union] = ACTIONS(4637),
    [anon_sym_if] = ACTIONS(4637),
    [anon_sym_switch] = ACTIONS(4637),
    [anon_sym_case] = ACTIONS(4637),
    [anon_sym_default] = ACTIONS(4637),
    [anon_sym_while] = ACTIONS(4637),
    [anon_sym_do] = ACTIONS(4637),
    [anon_sym_for] = ACTIONS(4637),
    [anon_sym_return] = ACTIONS(4637),
    [anon_sym_break] = ACTIONS(4637),
    [anon_sym_continue] = ACTIONS(4637),
    [anon_sym_goto] = ACTIONS(4637),
    [anon_sym_AMP] = ACTIONS(4635),
    [anon_sym_BANG] = ACTIONS(4635),
    [anon_sym_TILDE] = ACTIONS(4635),
    [anon_sym_PLUS] = ACTIONS(4637),
    [anon_sym_DASH] = ACTIONS(4637),
    [anon_sym_DASH_DASH] = ACTIONS(4635),
    [anon_sym_PLUS_PLUS] = ACTIONS(4635),
    [anon_sym_sizeof] = ACTIONS(4637),
    [sym_number_literal] = ACTIONS(4635),
    [sym_char_literal] = ACTIONS(4635),
    [sym_string_literal] = ACTIONS(4635),
    [sym_true] = ACTIONS(4637),
    [sym_false] = ACTIONS(4637),
    [sym_null] = ACTIONS(4637),
    [sym_identifier] = ACTIONS(4637),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(4637),
    [sym_auto] = ACTIONS(4637),
    [anon_sym_typename] = ACTIONS(4637),
    [anon_sym_new] = ACTIONS(4637),
    [anon_sym_COLON_COLON] = ACTIONS(4635),
    [anon_sym_delete] = ACTIONS(4637),
    [sym_nullptr] = ACTIONS(4637),
  },
  [2554] = {
    [sym__declarator] = STATE(2315),
    [sym_pointer_declarator] = STATE(2315),
    [sym_function_declarator] = STATE(2315),
    [sym_array_declarator] = STATE(2315),
    [sym_init_declarator] = STATE(2316),
    [sym_reference_declarator] = STATE(2315),
    [sym_template_type] = STATE(46),
    [sym_template_function] = STATE(2315),
    [sym_destructor_name] = STATE(2315),
    [sym_scoped_identifier] = STATE(33),
    [sym_scoped_type_identifier] = STATE(47),
    [sym_scoped_namespace_identifier] = STATE(46),
    [anon_sym_LPAREN] = ACTIONS(11),
    [anon_sym_STAR] = ACTIONS(196),
    [anon_sym_AMP] = ACTIONS(526),
    [anon_sym_AMP_AMP] = ACTIONS(528),
    [anon_sym_TILDE] = ACTIONS(45),
    [sym_identifier] = ACTIONS(75),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(77),
    [sym_operator_name] = ACTIONS(5353),
  },
  [2555] = {
    [sym_argument_list] = STATE(802),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_RPAREN] = ACTIONS(6473),
    [anon_sym_STAR] = ACTIONS(4537),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_EQ] = ACTIONS(4539),
    [anon_sym_QMARK] = ACTIONS(4541),
    [anon_sym_STAR_EQ] = ACTIONS(4543),
    [anon_sym_SLASH_EQ] = ACTIONS(4543),
    [anon_sym_PERCENT_EQ] = ACTIONS(4543),
    [anon_sym_PLUS_EQ] = ACTIONS(4543),
    [anon_sym_DASH_EQ] = ACTIONS(4543),
    [anon_sym_LT_LT_EQ] = ACTIONS(4543),
    [anon_sym_GT_GT_EQ] = ACTIONS(4543),
    [anon_sym_AMP_EQ] = ACTIONS(4543),
    [anon_sym_CARET_EQ] = ACTIONS(4543),
    [anon_sym_PIPE_EQ] = ACTIONS(4543),
    [anon_sym_AMP] = ACTIONS(4545),
    [anon_sym_PIPE_PIPE] = ACTIONS(4547),
    [anon_sym_AMP_AMP] = ACTIONS(4549),
    [anon_sym_PIPE] = ACTIONS(4551),
    [anon_sym_CARET] = ACTIONS(4553),
    [anon_sym_EQ_EQ] = ACTIONS(4555),
    [anon_sym_BANG_EQ] = ACTIONS(4555),
    [anon_sym_LT] = ACTIONS(4557),
    [anon_sym_GT] = ACTIONS(4557),
    [anon_sym_LT_EQ] = ACTIONS(4559),
    [anon_sym_GT_EQ] = ACTIONS(4559),
    [anon_sym_LT_LT] = ACTIONS(4561),
    [anon_sym_GT_GT] = ACTIONS(4561),
    [anon_sym_PLUS] = ACTIONS(4563),
    [anon_sym_DASH] = ACTIONS(4563),
    [anon_sym_SLASH] = ACTIONS(4537),
    [anon_sym_PERCENT] = ACTIONS(4537),
    [anon_sym_DASH_DASH] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(1554),
    [anon_sym_DASH_GT] = ACTIONS(1554),
    [sym_comment] = ACTIONS(49),
  },
  [2556] = {
    [anon_sym_LPAREN] = ACTIONS(6475),
    [sym_comment] = ACTIONS(49),
  },
  [2557] = {
    [sym__expression] = STATE(2713),
    [sym_conditional_expression] = STATE(2713),
    [sym_assignment_expression] = STATE(2713),
    [sym_pointer_expression] = STATE(2713),
    [sym_logical_expression] = STATE(2713),
    [sym_bitwise_expression] = STATE(2713),
    [sym_equality_expression] = STATE(2713),
    [sym_relational_expression] = STATE(2713),
    [sym_shift_expression] = STATE(2713),
    [sym_math_expression] = STATE(2713),
    [sym_cast_expression] = STATE(2713),
    [sym_sizeof_expression] = STATE(2713),
    [sym_subscript_expression] = STATE(2713),
    [sym_call_expression] = STATE(2713),
    [sym_field_expression] = STATE(2713),
    [sym_compound_literal_expression] = STATE(2713),
    [sym_parenthesized_expression] = STATE(2713),
    [sym_concatenated_string] = STATE(2713),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(2713),
    [sym_new_expression] = STATE(2713),
    [sym_delete_expression] = STATE(2713),
    [sym_lambda_expression] = STATE(2713),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(6477),
    [anon_sym_LPAREN] = ACTIONS(1347),
    [anon_sym_SEMI] = ACTIONS(6479),
    [anon_sym_STAR] = ACTIONS(1349),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_AMP] = ACTIONS(1349),
    [anon_sym_BANG] = ACTIONS(1351),
    [anon_sym_TILDE] = ACTIONS(1353),
    [anon_sym_PLUS] = ACTIONS(1355),
    [anon_sym_DASH] = ACTIONS(1355),
    [anon_sym_DASH_DASH] = ACTIONS(1357),
    [anon_sym_PLUS_PLUS] = ACTIONS(1357),
    [anon_sym_sizeof] = ACTIONS(1359),
    [sym_number_literal] = ACTIONS(6477),
    [sym_char_literal] = ACTIONS(6477),
    [sym_string_literal] = ACTIONS(1361),
    [sym_true] = ACTIONS(6481),
    [sym_false] = ACTIONS(6481),
    [sym_null] = ACTIONS(6481),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1365),
    [anon_sym_delete] = ACTIONS(1367),
    [sym_nullptr] = ACTIONS(6481),
  },
  [2558] = {
    [sym_argument_list] = STATE(802),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_SEMI] = ACTIONS(6483),
    [anon_sym_STAR] = ACTIONS(2553),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_EQ] = ACTIONS(2555),
    [anon_sym_QMARK] = ACTIONS(2557),
    [anon_sym_STAR_EQ] = ACTIONS(2559),
    [anon_sym_SLASH_EQ] = ACTIONS(2559),
    [anon_sym_PERCENT_EQ] = ACTIONS(2559),
    [anon_sym_PLUS_EQ] = ACTIONS(2559),
    [anon_sym_DASH_EQ] = ACTIONS(2559),
    [anon_sym_LT_LT_EQ] = ACTIONS(2559),
    [anon_sym_GT_GT_EQ] = ACTIONS(2559),
    [anon_sym_AMP_EQ] = ACTIONS(2559),
    [anon_sym_CARET_EQ] = ACTIONS(2559),
    [anon_sym_PIPE_EQ] = ACTIONS(2559),
    [anon_sym_AMP] = ACTIONS(2561),
    [anon_sym_PIPE_PIPE] = ACTIONS(2563),
    [anon_sym_AMP_AMP] = ACTIONS(2565),
    [anon_sym_PIPE] = ACTIONS(2567),
    [anon_sym_CARET] = ACTIONS(2569),
    [anon_sym_EQ_EQ] = ACTIONS(2571),
    [anon_sym_BANG_EQ] = ACTIONS(2571),
    [anon_sym_LT] = ACTIONS(2573),
    [anon_sym_GT] = ACTIONS(2573),
    [anon_sym_LT_EQ] = ACTIONS(2575),
    [anon_sym_GT_EQ] = ACTIONS(2575),
    [anon_sym_LT_LT] = ACTIONS(2577),
    [anon_sym_GT_GT] = ACTIONS(2577),
    [anon_sym_PLUS] = ACTIONS(2579),
    [anon_sym_DASH] = ACTIONS(2579),
    [anon_sym_SLASH] = ACTIONS(2553),
    [anon_sym_PERCENT] = ACTIONS(2553),
    [anon_sym_DASH_DASH] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(1554),
    [anon_sym_DASH_GT] = ACTIONS(1554),
    [sym_comment] = ACTIONS(49),
  },
  [2559] = {
    [anon_sym_COLON] = ACTIONS(6485),
    [sym_comment] = ACTIONS(49),
  },
  [2560] = {
    [sym_raw_string_literal] = ACTIONS(4697),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(4699),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(4699),
    [anon_sym_LPAREN] = ACTIONS(4697),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(4699),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(4699),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(4699),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(4699),
    [sym_preproc_directive] = ACTIONS(4699),
    [anon_sym_SEMI] = ACTIONS(4697),
    [anon_sym_typedef] = ACTIONS(4699),
    [anon_sym_extern] = ACTIONS(4699),
    [anon_sym_LBRACE] = ACTIONS(4697),
    [anon_sym_STAR] = ACTIONS(4697),
    [anon_sym_LBRACK] = ACTIONS(4697),
    [anon_sym_static] = ACTIONS(4699),
    [anon_sym_register] = ACTIONS(4699),
    [anon_sym_inline] = ACTIONS(4699),
    [anon_sym_const] = ACTIONS(4699),
    [anon_sym_restrict] = ACTIONS(4699),
    [anon_sym_volatile] = ACTIONS(4699),
    [anon_sym__Atomic] = ACTIONS(4699),
    [anon_sym_mutable] = ACTIONS(4699),
    [anon_sym_explicit] = ACTIONS(4699),
    [anon_sym_constexpr] = ACTIONS(4699),
    [anon_sym_unsigned] = ACTIONS(4699),
    [anon_sym_long] = ACTIONS(4699),
    [anon_sym_short] = ACTIONS(4699),
    [sym_primitive_type] = ACTIONS(4699),
    [anon_sym_enum] = ACTIONS(4699),
    [anon_sym_struct] = ACTIONS(4699),
    [anon_sym_union] = ACTIONS(4699),
    [anon_sym_if] = ACTIONS(4699),
    [anon_sym_switch] = ACTIONS(4699),
    [anon_sym_case] = ACTIONS(4699),
    [anon_sym_default] = ACTIONS(4699),
    [anon_sym_while] = ACTIONS(4699),
    [anon_sym_do] = ACTIONS(4699),
    [anon_sym_for] = ACTIONS(4699),
    [anon_sym_return] = ACTIONS(4699),
    [anon_sym_break] = ACTIONS(4699),
    [anon_sym_continue] = ACTIONS(4699),
    [anon_sym_goto] = ACTIONS(4699),
    [anon_sym_AMP] = ACTIONS(4697),
    [anon_sym_BANG] = ACTIONS(4697),
    [anon_sym_TILDE] = ACTIONS(4697),
    [anon_sym_PLUS] = ACTIONS(4699),
    [anon_sym_DASH] = ACTIONS(4699),
    [anon_sym_DASH_DASH] = ACTIONS(4697),
    [anon_sym_PLUS_PLUS] = ACTIONS(4697),
    [anon_sym_sizeof] = ACTIONS(4699),
    [sym_number_literal] = ACTIONS(4697),
    [sym_char_literal] = ACTIONS(4697),
    [sym_string_literal] = ACTIONS(4697),
    [sym_true] = ACTIONS(4699),
    [sym_false] = ACTIONS(4699),
    [sym_null] = ACTIONS(4699),
    [sym_identifier] = ACTIONS(4699),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(4699),
    [sym_auto] = ACTIONS(4699),
    [anon_sym_typename] = ACTIONS(4699),
    [anon_sym_new] = ACTIONS(4699),
    [anon_sym_COLON_COLON] = ACTIONS(4697),
    [anon_sym_delete] = ACTIONS(4699),
    [sym_nullptr] = ACTIONS(4699),
  },
  [2561] = {
    [sym_raw_string_literal] = ACTIONS(4701),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(4703),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(4703),
    [anon_sym_LPAREN] = ACTIONS(4701),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(4703),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(4703),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(4703),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(4703),
    [sym_preproc_directive] = ACTIONS(4703),
    [anon_sym_SEMI] = ACTIONS(4701),
    [anon_sym_typedef] = ACTIONS(4703),
    [anon_sym_extern] = ACTIONS(4703),
    [anon_sym_LBRACE] = ACTIONS(4701),
    [anon_sym_STAR] = ACTIONS(4701),
    [anon_sym_LBRACK] = ACTIONS(4701),
    [anon_sym_static] = ACTIONS(4703),
    [anon_sym_register] = ACTIONS(4703),
    [anon_sym_inline] = ACTIONS(4703),
    [anon_sym_const] = ACTIONS(4703),
    [anon_sym_restrict] = ACTIONS(4703),
    [anon_sym_volatile] = ACTIONS(4703),
    [anon_sym__Atomic] = ACTIONS(4703),
    [anon_sym_mutable] = ACTIONS(4703),
    [anon_sym_explicit] = ACTIONS(4703),
    [anon_sym_constexpr] = ACTIONS(4703),
    [anon_sym_unsigned] = ACTIONS(4703),
    [anon_sym_long] = ACTIONS(4703),
    [anon_sym_short] = ACTIONS(4703),
    [sym_primitive_type] = ACTIONS(4703),
    [anon_sym_enum] = ACTIONS(4703),
    [anon_sym_struct] = ACTIONS(4703),
    [anon_sym_union] = ACTIONS(4703),
    [anon_sym_if] = ACTIONS(4703),
    [anon_sym_switch] = ACTIONS(4703),
    [anon_sym_case] = ACTIONS(4703),
    [anon_sym_default] = ACTIONS(4703),
    [anon_sym_while] = ACTIONS(4703),
    [anon_sym_do] = ACTIONS(4703),
    [anon_sym_for] = ACTIONS(4703),
    [anon_sym_return] = ACTIONS(4703),
    [anon_sym_break] = ACTIONS(4703),
    [anon_sym_continue] = ACTIONS(4703),
    [anon_sym_goto] = ACTIONS(4703),
    [anon_sym_AMP] = ACTIONS(4701),
    [anon_sym_BANG] = ACTIONS(4701),
    [anon_sym_TILDE] = ACTIONS(4701),
    [anon_sym_PLUS] = ACTIONS(4703),
    [anon_sym_DASH] = ACTIONS(4703),
    [anon_sym_DASH_DASH] = ACTIONS(4701),
    [anon_sym_PLUS_PLUS] = ACTIONS(4701),
    [anon_sym_sizeof] = ACTIONS(4703),
    [sym_number_literal] = ACTIONS(4701),
    [sym_char_literal] = ACTIONS(4701),
    [sym_string_literal] = ACTIONS(4701),
    [sym_true] = ACTIONS(4703),
    [sym_false] = ACTIONS(4703),
    [sym_null] = ACTIONS(4703),
    [sym_identifier] = ACTIONS(4703),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(4703),
    [sym_auto] = ACTIONS(4703),
    [anon_sym_typename] = ACTIONS(4703),
    [anon_sym_new] = ACTIONS(4703),
    [anon_sym_COLON_COLON] = ACTIONS(4701),
    [anon_sym_delete] = ACTIONS(4703),
    [sym_nullptr] = ACTIONS(4703),
  },
  [2562] = {
    [sym_initializer_list] = STATE(765),
    [sym_template_argument_list] = STATE(1097),
    [anon_sym_LPAREN] = ACTIONS(1477),
    [anon_sym_COMMA] = ACTIONS(1477),
    [anon_sym_SEMI] = ACTIONS(1477),
    [anon_sym_LBRACE] = ACTIONS(548),
    [anon_sym_STAR] = ACTIONS(1479),
    [anon_sym_LBRACK] = ACTIONS(1477),
    [anon_sym_EQ] = ACTIONS(1479),
    [anon_sym_COLON] = ACTIONS(5349),
    [anon_sym_QMARK] = ACTIONS(1477),
    [anon_sym_STAR_EQ] = ACTIONS(1477),
    [anon_sym_SLASH_EQ] = ACTIONS(1477),
    [anon_sym_PERCENT_EQ] = ACTIONS(1477),
    [anon_sym_PLUS_EQ] = ACTIONS(1477),
    [anon_sym_DASH_EQ] = ACTIONS(1477),
    [anon_sym_LT_LT_EQ] = ACTIONS(1477),
    [anon_sym_GT_GT_EQ] = ACTIONS(1477),
    [anon_sym_AMP_EQ] = ACTIONS(1477),
    [anon_sym_CARET_EQ] = ACTIONS(1477),
    [anon_sym_PIPE_EQ] = ACTIONS(1477),
    [anon_sym_AMP] = ACTIONS(1479),
    [anon_sym_PIPE_PIPE] = ACTIONS(1477),
    [anon_sym_AMP_AMP] = ACTIONS(1477),
    [anon_sym_PIPE] = ACTIONS(1479),
    [anon_sym_CARET] = ACTIONS(1479),
    [anon_sym_EQ_EQ] = ACTIONS(1477),
    [anon_sym_BANG_EQ] = ACTIONS(1477),
    [anon_sym_LT] = ACTIONS(1564),
    [anon_sym_GT] = ACTIONS(1479),
    [anon_sym_LT_EQ] = ACTIONS(1477),
    [anon_sym_GT_EQ] = ACTIONS(1477),
    [anon_sym_LT_LT] = ACTIONS(1479),
    [anon_sym_GT_GT] = ACTIONS(1479),
    [anon_sym_PLUS] = ACTIONS(1479),
    [anon_sym_DASH] = ACTIONS(1479),
    [anon_sym_SLASH] = ACTIONS(1479),
    [anon_sym_PERCENT] = ACTIONS(1479),
    [anon_sym_DASH_DASH] = ACTIONS(1477),
    [anon_sym_PLUS_PLUS] = ACTIONS(1477),
    [anon_sym_DOT] = ACTIONS(1477),
    [anon_sym_DASH_GT] = ACTIONS(1477),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(2218),
  },
  [2563] = {
    [sym_raw_string_literal] = ACTIONS(4710),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(4712),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(4712),
    [anon_sym_LPAREN] = ACTIONS(4710),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(4712),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(4712),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(4712),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(4712),
    [sym_preproc_directive] = ACTIONS(4712),
    [anon_sym_SEMI] = ACTIONS(4710),
    [anon_sym_typedef] = ACTIONS(4712),
    [anon_sym_extern] = ACTIONS(4712),
    [anon_sym_LBRACE] = ACTIONS(4710),
    [anon_sym_STAR] = ACTIONS(4710),
    [anon_sym_LBRACK] = ACTIONS(4710),
    [anon_sym_static] = ACTIONS(4712),
    [anon_sym_register] = ACTIONS(4712),
    [anon_sym_inline] = ACTIONS(4712),
    [anon_sym_const] = ACTIONS(4712),
    [anon_sym_restrict] = ACTIONS(4712),
    [anon_sym_volatile] = ACTIONS(4712),
    [anon_sym__Atomic] = ACTIONS(4712),
    [anon_sym_mutable] = ACTIONS(4712),
    [anon_sym_explicit] = ACTIONS(4712),
    [anon_sym_constexpr] = ACTIONS(4712),
    [anon_sym_unsigned] = ACTIONS(4712),
    [anon_sym_long] = ACTIONS(4712),
    [anon_sym_short] = ACTIONS(4712),
    [sym_primitive_type] = ACTIONS(4712),
    [anon_sym_enum] = ACTIONS(4712),
    [anon_sym_struct] = ACTIONS(4712),
    [anon_sym_union] = ACTIONS(4712),
    [anon_sym_if] = ACTIONS(4712),
    [anon_sym_switch] = ACTIONS(4712),
    [anon_sym_case] = ACTIONS(4712),
    [anon_sym_default] = ACTIONS(4712),
    [anon_sym_while] = ACTIONS(4712),
    [anon_sym_do] = ACTIONS(4712),
    [anon_sym_for] = ACTIONS(4712),
    [anon_sym_return] = ACTIONS(4712),
    [anon_sym_break] = ACTIONS(4712),
    [anon_sym_continue] = ACTIONS(4712),
    [anon_sym_goto] = ACTIONS(4712),
    [anon_sym_AMP] = ACTIONS(4710),
    [anon_sym_BANG] = ACTIONS(4710),
    [anon_sym_TILDE] = ACTIONS(4710),
    [anon_sym_PLUS] = ACTIONS(4712),
    [anon_sym_DASH] = ACTIONS(4712),
    [anon_sym_DASH_DASH] = ACTIONS(4710),
    [anon_sym_PLUS_PLUS] = ACTIONS(4710),
    [anon_sym_sizeof] = ACTIONS(4712),
    [sym_number_literal] = ACTIONS(4710),
    [sym_char_literal] = ACTIONS(4710),
    [sym_string_literal] = ACTIONS(4710),
    [sym_true] = ACTIONS(4712),
    [sym_false] = ACTIONS(4712),
    [sym_null] = ACTIONS(4712),
    [sym_identifier] = ACTIONS(4712),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(4712),
    [sym_auto] = ACTIONS(4712),
    [anon_sym_typename] = ACTIONS(4712),
    [anon_sym_new] = ACTIONS(4712),
    [anon_sym_COLON_COLON] = ACTIONS(4710),
    [anon_sym_delete] = ACTIONS(4712),
    [sym_nullptr] = ACTIONS(4712),
  },
  [2564] = {
    [sym_raw_string_literal] = ACTIONS(1261),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1263),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1263),
    [anon_sym_LPAREN] = ACTIONS(1261),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1263),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(1263),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1263),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1263),
    [sym_preproc_directive] = ACTIONS(1263),
    [anon_sym_SEMI] = ACTIONS(1261),
    [anon_sym_typedef] = ACTIONS(1263),
    [anon_sym_extern] = ACTIONS(1263),
    [anon_sym_LBRACE] = ACTIONS(1261),
    [anon_sym_STAR] = ACTIONS(1261),
    [anon_sym_LBRACK] = ACTIONS(1261),
    [anon_sym_static] = ACTIONS(1263),
    [anon_sym_register] = ACTIONS(1263),
    [anon_sym_inline] = ACTIONS(1263),
    [anon_sym_const] = ACTIONS(1263),
    [anon_sym_restrict] = ACTIONS(1263),
    [anon_sym_volatile] = ACTIONS(1263),
    [anon_sym__Atomic] = ACTIONS(1263),
    [anon_sym_mutable] = ACTIONS(1263),
    [anon_sym_explicit] = ACTIONS(1263),
    [anon_sym_constexpr] = ACTIONS(1263),
    [anon_sym_unsigned] = ACTIONS(1263),
    [anon_sym_long] = ACTIONS(1263),
    [anon_sym_short] = ACTIONS(1263),
    [sym_primitive_type] = ACTIONS(1263),
    [anon_sym_enum] = ACTIONS(1263),
    [anon_sym_struct] = ACTIONS(1263),
    [anon_sym_union] = ACTIONS(1263),
    [anon_sym_if] = ACTIONS(1263),
    [anon_sym_switch] = ACTIONS(1263),
    [anon_sym_case] = ACTIONS(1263),
    [anon_sym_default] = ACTIONS(1263),
    [anon_sym_while] = ACTIONS(1263),
    [anon_sym_do] = ACTIONS(1263),
    [anon_sym_for] = ACTIONS(1263),
    [anon_sym_return] = ACTIONS(1263),
    [anon_sym_break] = ACTIONS(1263),
    [anon_sym_continue] = ACTIONS(1263),
    [anon_sym_goto] = ACTIONS(1263),
    [anon_sym_AMP] = ACTIONS(1261),
    [anon_sym_BANG] = ACTIONS(1261),
    [anon_sym_TILDE] = ACTIONS(1261),
    [anon_sym_PLUS] = ACTIONS(1263),
    [anon_sym_DASH] = ACTIONS(1263),
    [anon_sym_DASH_DASH] = ACTIONS(1261),
    [anon_sym_PLUS_PLUS] = ACTIONS(1261),
    [anon_sym_sizeof] = ACTIONS(1263),
    [sym_number_literal] = ACTIONS(1261),
    [sym_char_literal] = ACTIONS(1261),
    [sym_string_literal] = ACTIONS(1261),
    [sym_true] = ACTIONS(1263),
    [sym_false] = ACTIONS(1263),
    [sym_null] = ACTIONS(1263),
    [sym_identifier] = ACTIONS(1263),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(1263),
    [sym_auto] = ACTIONS(1263),
    [anon_sym_typename] = ACTIONS(1263),
    [anon_sym_new] = ACTIONS(1263),
    [anon_sym_COLON_COLON] = ACTIONS(1261),
    [anon_sym_delete] = ACTIONS(1263),
    [sym_nullptr] = ACTIONS(1263),
  },
  [2565] = {
    [aux_sym_declaration_repeat1] = STATE(678),
    [anon_sym_COMMA] = ACTIONS(538),
    [anon_sym_SEMI] = ACTIONS(6487),
    [sym_comment] = ACTIONS(49),
  },
  [2566] = {
    [sym__expression] = STATE(2717),
    [sym_conditional_expression] = STATE(2717),
    [sym_assignment_expression] = STATE(2717),
    [sym_pointer_expression] = STATE(2717),
    [sym_logical_expression] = STATE(2717),
    [sym_bitwise_expression] = STATE(2717),
    [sym_equality_expression] = STATE(2717),
    [sym_relational_expression] = STATE(2717),
    [sym_shift_expression] = STATE(2717),
    [sym_math_expression] = STATE(2717),
    [sym_cast_expression] = STATE(2717),
    [sym_sizeof_expression] = STATE(2717),
    [sym_subscript_expression] = STATE(2717),
    [sym_call_expression] = STATE(2717),
    [sym_field_expression] = STATE(2717),
    [sym_compound_literal_expression] = STATE(2717),
    [sym_parenthesized_expression] = STATE(2717),
    [sym_initializer_list] = STATE(2718),
    [sym_concatenated_string] = STATE(2717),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(2717),
    [sym_new_expression] = STATE(2717),
    [sym_delete_expression] = STATE(2717),
    [sym_lambda_expression] = STATE(2717),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(6489),
    [anon_sym_LPAREN] = ACTIONS(1347),
    [anon_sym_LBRACE] = ACTIONS(548),
    [anon_sym_STAR] = ACTIONS(1349),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_AMP] = ACTIONS(1349),
    [anon_sym_BANG] = ACTIONS(1351),
    [anon_sym_TILDE] = ACTIONS(1353),
    [anon_sym_PLUS] = ACTIONS(1355),
    [anon_sym_DASH] = ACTIONS(1355),
    [anon_sym_DASH_DASH] = ACTIONS(1357),
    [anon_sym_PLUS_PLUS] = ACTIONS(1357),
    [anon_sym_sizeof] = ACTIONS(1359),
    [sym_number_literal] = ACTIONS(6489),
    [sym_char_literal] = ACTIONS(6489),
    [sym_string_literal] = ACTIONS(1361),
    [sym_true] = ACTIONS(6491),
    [sym_false] = ACTIONS(6491),
    [sym_null] = ACTIONS(6491),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1365),
    [anon_sym_delete] = ACTIONS(1367),
    [sym_nullptr] = ACTIONS(6491),
  },
  [2567] = {
    [anon_sym_SEMI] = ACTIONS(6493),
    [sym_comment] = ACTIONS(49),
  },
  [2568] = {
    [sym__expression] = STATE(2720),
    [sym_conditional_expression] = STATE(2720),
    [sym_assignment_expression] = STATE(2720),
    [sym_pointer_expression] = STATE(2720),
    [sym_logical_expression] = STATE(2720),
    [sym_bitwise_expression] = STATE(2720),
    [sym_equality_expression] = STATE(2720),
    [sym_relational_expression] = STATE(2720),
    [sym_shift_expression] = STATE(2720),
    [sym_math_expression] = STATE(2720),
    [sym_cast_expression] = STATE(2720),
    [sym_sizeof_expression] = STATE(2720),
    [sym_subscript_expression] = STATE(2720),
    [sym_call_expression] = STATE(2720),
    [sym_field_expression] = STATE(2720),
    [sym_compound_literal_expression] = STATE(2720),
    [sym_parenthesized_expression] = STATE(2720),
    [sym_initializer_list] = STATE(2721),
    [sym_concatenated_string] = STATE(2720),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(2720),
    [sym_new_expression] = STATE(2720),
    [sym_delete_expression] = STATE(2720),
    [sym_lambda_expression] = STATE(2720),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(6495),
    [anon_sym_LPAREN] = ACTIONS(1347),
    [anon_sym_LBRACE] = ACTIONS(548),
    [anon_sym_STAR] = ACTIONS(1349),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_AMP] = ACTIONS(1349),
    [anon_sym_BANG] = ACTIONS(1351),
    [anon_sym_TILDE] = ACTIONS(1353),
    [anon_sym_PLUS] = ACTIONS(1355),
    [anon_sym_DASH] = ACTIONS(1355),
    [anon_sym_DASH_DASH] = ACTIONS(1357),
    [anon_sym_PLUS_PLUS] = ACTIONS(1357),
    [anon_sym_sizeof] = ACTIONS(1359),
    [sym_number_literal] = ACTIONS(6495),
    [sym_char_literal] = ACTIONS(6495),
    [sym_string_literal] = ACTIONS(1361),
    [sym_true] = ACTIONS(6497),
    [sym_false] = ACTIONS(6497),
    [sym_null] = ACTIONS(6497),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1365),
    [anon_sym_delete] = ACTIONS(1367),
    [sym_nullptr] = ACTIONS(6497),
  },
  [2569] = {
    [anon_sym_SEMI] = ACTIONS(6499),
    [sym_comment] = ACTIONS(49),
  },
  [2570] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(6501),
    [sym_comment] = ACTIONS(49),
  },
  [2571] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(6503),
    [sym_comment] = ACTIONS(49),
  },
  [2572] = {
    [sym_raw_string_literal] = ACTIONS(1972),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1974),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1974),
    [anon_sym_LPAREN] = ACTIONS(1972),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1974),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(1974),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1974),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1974),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(1974),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(1974),
    [sym_preproc_directive] = ACTIONS(1974),
    [anon_sym_SEMI] = ACTIONS(1972),
    [anon_sym_typedef] = ACTIONS(1974),
    [anon_sym_extern] = ACTIONS(1974),
    [anon_sym_LBRACE] = ACTIONS(1972),
    [anon_sym_STAR] = ACTIONS(1972),
    [anon_sym_LBRACK] = ACTIONS(1972),
    [anon_sym_static] = ACTIONS(1974),
    [anon_sym_register] = ACTIONS(1974),
    [anon_sym_inline] = ACTIONS(1974),
    [anon_sym_const] = ACTIONS(1974),
    [anon_sym_restrict] = ACTIONS(1974),
    [anon_sym_volatile] = ACTIONS(1974),
    [anon_sym__Atomic] = ACTIONS(1974),
    [anon_sym_mutable] = ACTIONS(1974),
    [anon_sym_explicit] = ACTIONS(1974),
    [anon_sym_constexpr] = ACTIONS(1974),
    [anon_sym_unsigned] = ACTIONS(1974),
    [anon_sym_long] = ACTIONS(1974),
    [anon_sym_short] = ACTIONS(1974),
    [sym_primitive_type] = ACTIONS(1974),
    [anon_sym_enum] = ACTIONS(1974),
    [anon_sym_struct] = ACTIONS(1974),
    [anon_sym_union] = ACTIONS(1974),
    [anon_sym_if] = ACTIONS(1974),
    [anon_sym_switch] = ACTIONS(1974),
    [anon_sym_case] = ACTIONS(1974),
    [anon_sym_default] = ACTIONS(1974),
    [anon_sym_while] = ACTIONS(1974),
    [anon_sym_do] = ACTIONS(1974),
    [anon_sym_for] = ACTIONS(1974),
    [anon_sym_return] = ACTIONS(1974),
    [anon_sym_break] = ACTIONS(1974),
    [anon_sym_continue] = ACTIONS(1974),
    [anon_sym_goto] = ACTIONS(1974),
    [anon_sym_AMP] = ACTIONS(1972),
    [anon_sym_BANG] = ACTIONS(1972),
    [anon_sym_TILDE] = ACTIONS(1972),
    [anon_sym_PLUS] = ACTIONS(1974),
    [anon_sym_DASH] = ACTIONS(1974),
    [anon_sym_DASH_DASH] = ACTIONS(1972),
    [anon_sym_PLUS_PLUS] = ACTIONS(1972),
    [anon_sym_sizeof] = ACTIONS(1974),
    [sym_number_literal] = ACTIONS(1972),
    [sym_char_literal] = ACTIONS(1972),
    [sym_string_literal] = ACTIONS(1972),
    [sym_true] = ACTIONS(1974),
    [sym_false] = ACTIONS(1974),
    [sym_null] = ACTIONS(1974),
    [sym_identifier] = ACTIONS(1974),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(1974),
    [sym_auto] = ACTIONS(1974),
    [anon_sym_typename] = ACTIONS(1974),
    [anon_sym_new] = ACTIONS(1974),
    [anon_sym_COLON_COLON] = ACTIONS(1972),
    [anon_sym_delete] = ACTIONS(1974),
    [sym_nullptr] = ACTIONS(1974),
  },
  [2573] = {
    [sym_raw_string_literal] = ACTIONS(1988),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1990),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1990),
    [anon_sym_LPAREN] = ACTIONS(1988),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1990),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(1990),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1990),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1990),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(1990),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(1990),
    [sym_preproc_directive] = ACTIONS(1990),
    [anon_sym_SEMI] = ACTIONS(1988),
    [anon_sym_typedef] = ACTIONS(1990),
    [anon_sym_extern] = ACTIONS(1990),
    [anon_sym_LBRACE] = ACTIONS(1988),
    [anon_sym_STAR] = ACTIONS(1988),
    [anon_sym_LBRACK] = ACTIONS(1988),
    [anon_sym_static] = ACTIONS(1990),
    [anon_sym_register] = ACTIONS(1990),
    [anon_sym_inline] = ACTIONS(1990),
    [anon_sym_const] = ACTIONS(1990),
    [anon_sym_restrict] = ACTIONS(1990),
    [anon_sym_volatile] = ACTIONS(1990),
    [anon_sym__Atomic] = ACTIONS(1990),
    [anon_sym_mutable] = ACTIONS(1990),
    [anon_sym_explicit] = ACTIONS(1990),
    [anon_sym_constexpr] = ACTIONS(1990),
    [anon_sym_unsigned] = ACTIONS(1990),
    [anon_sym_long] = ACTIONS(1990),
    [anon_sym_short] = ACTIONS(1990),
    [sym_primitive_type] = ACTIONS(1990),
    [anon_sym_enum] = ACTIONS(1990),
    [anon_sym_struct] = ACTIONS(1990),
    [anon_sym_union] = ACTIONS(1990),
    [anon_sym_if] = ACTIONS(1990),
    [anon_sym_switch] = ACTIONS(1990),
    [anon_sym_case] = ACTIONS(1990),
    [anon_sym_default] = ACTIONS(1990),
    [anon_sym_while] = ACTIONS(1990),
    [anon_sym_do] = ACTIONS(1990),
    [anon_sym_for] = ACTIONS(1990),
    [anon_sym_return] = ACTIONS(1990),
    [anon_sym_break] = ACTIONS(1990),
    [anon_sym_continue] = ACTIONS(1990),
    [anon_sym_goto] = ACTIONS(1990),
    [anon_sym_AMP] = ACTIONS(1988),
    [anon_sym_BANG] = ACTIONS(1988),
    [anon_sym_TILDE] = ACTIONS(1988),
    [anon_sym_PLUS] = ACTIONS(1990),
    [anon_sym_DASH] = ACTIONS(1990),
    [anon_sym_DASH_DASH] = ACTIONS(1988),
    [anon_sym_PLUS_PLUS] = ACTIONS(1988),
    [anon_sym_sizeof] = ACTIONS(1990),
    [sym_number_literal] = ACTIONS(1988),
    [sym_char_literal] = ACTIONS(1988),
    [sym_string_literal] = ACTIONS(1988),
    [sym_true] = ACTIONS(1990),
    [sym_false] = ACTIONS(1990),
    [sym_null] = ACTIONS(1990),
    [sym_identifier] = ACTIONS(1990),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(1990),
    [sym_auto] = ACTIONS(1990),
    [anon_sym_typename] = ACTIONS(1990),
    [anon_sym_new] = ACTIONS(1990),
    [anon_sym_COLON_COLON] = ACTIONS(1988),
    [anon_sym_delete] = ACTIONS(1990),
    [sym_nullptr] = ACTIONS(1990),
  },
  [2574] = {
    [sym_parameter_list] = STATE(513),
    [anon_sym_LPAREN] = ACTIONS(206),
    [anon_sym_SEMI] = ACTIONS(6505),
    [anon_sym_LBRACK] = ACTIONS(955),
    [sym_comment] = ACTIONS(49),
  },
  [2575] = {
    [sym_compound_statement] = STATE(2738),
    [sym_labeled_statement] = STATE(2738),
    [sym_expression_statement] = STATE(2738),
    [sym_if_statement] = STATE(2738),
    [sym_switch_statement] = STATE(2738),
    [sym_case_statement] = STATE(2738),
    [sym_while_statement] = STATE(2738),
    [sym_do_statement] = STATE(2738),
    [sym_for_statement] = STATE(2738),
    [sym_return_statement] = STATE(2738),
    [sym_break_statement] = STATE(2738),
    [sym_continue_statement] = STATE(2738),
    [sym_goto_statement] = STATE(2738),
    [sym__expression] = STATE(2739),
    [sym_comma_expression] = STATE(2740),
    [sym_conditional_expression] = STATE(2739),
    [sym_assignment_expression] = STATE(2739),
    [sym_pointer_expression] = STATE(2739),
    [sym_logical_expression] = STATE(2739),
    [sym_bitwise_expression] = STATE(2739),
    [sym_equality_expression] = STATE(2739),
    [sym_relational_expression] = STATE(2739),
    [sym_shift_expression] = STATE(2739),
    [sym_math_expression] = STATE(2739),
    [sym_cast_expression] = STATE(2739),
    [sym_sizeof_expression] = STATE(2739),
    [sym_subscript_expression] = STATE(2739),
    [sym_call_expression] = STATE(2739),
    [sym_field_expression] = STATE(2739),
    [sym_compound_literal_expression] = STATE(2739),
    [sym_parenthesized_expression] = STATE(2739),
    [sym_concatenated_string] = STATE(2739),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(2739),
    [sym_for_range_loop] = STATE(2738),
    [sym_new_expression] = STATE(2739),
    [sym_delete_expression] = STATE(2739),
    [sym_lambda_expression] = STATE(2739),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(6507),
    [anon_sym_LPAREN] = ACTIONS(626),
    [anon_sym_SEMI] = ACTIONS(6509),
    [anon_sym_LBRACE] = ACTIONS(6511),
    [anon_sym_STAR] = ACTIONS(644),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_if] = ACTIONS(6513),
    [anon_sym_switch] = ACTIONS(6515),
    [anon_sym_case] = ACTIONS(6517),
    [anon_sym_default] = ACTIONS(6519),
    [anon_sym_while] = ACTIONS(6521),
    [anon_sym_do] = ACTIONS(6523),
    [anon_sym_for] = ACTIONS(6525),
    [anon_sym_return] = ACTIONS(6527),
    [anon_sym_break] = ACTIONS(6529),
    [anon_sym_continue] = ACTIONS(6531),
    [anon_sym_goto] = ACTIONS(6533),
    [anon_sym_AMP] = ACTIONS(644),
    [anon_sym_BANG] = ACTIONS(668),
    [anon_sym_TILDE] = ACTIONS(670),
    [anon_sym_PLUS] = ACTIONS(672),
    [anon_sym_DASH] = ACTIONS(672),
    [anon_sym_DASH_DASH] = ACTIONS(674),
    [anon_sym_PLUS_PLUS] = ACTIONS(674),
    [anon_sym_sizeof] = ACTIONS(676),
    [sym_number_literal] = ACTIONS(6507),
    [sym_char_literal] = ACTIONS(6507),
    [sym_string_literal] = ACTIONS(678),
    [sym_true] = ACTIONS(6535),
    [sym_false] = ACTIONS(6535),
    [sym_null] = ACTIONS(6535),
    [sym_identifier] = ACTIONS(6537),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1303),
    [anon_sym_delete] = ACTIONS(686),
    [sym_nullptr] = ACTIONS(6535),
  },
  [2576] = {
    [sym_argument_list] = STATE(802),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_RPAREN] = ACTIONS(6539),
    [anon_sym_STAR] = ACTIONS(4537),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_EQ] = ACTIONS(4539),
    [anon_sym_QMARK] = ACTIONS(4541),
    [anon_sym_STAR_EQ] = ACTIONS(4543),
    [anon_sym_SLASH_EQ] = ACTIONS(4543),
    [anon_sym_PERCENT_EQ] = ACTIONS(4543),
    [anon_sym_PLUS_EQ] = ACTIONS(4543),
    [anon_sym_DASH_EQ] = ACTIONS(4543),
    [anon_sym_LT_LT_EQ] = ACTIONS(4543),
    [anon_sym_GT_GT_EQ] = ACTIONS(4543),
    [anon_sym_AMP_EQ] = ACTIONS(4543),
    [anon_sym_CARET_EQ] = ACTIONS(4543),
    [anon_sym_PIPE_EQ] = ACTIONS(4543),
    [anon_sym_AMP] = ACTIONS(4545),
    [anon_sym_PIPE_PIPE] = ACTIONS(4547),
    [anon_sym_AMP_AMP] = ACTIONS(4549),
    [anon_sym_PIPE] = ACTIONS(4551),
    [anon_sym_CARET] = ACTIONS(4553),
    [anon_sym_EQ_EQ] = ACTIONS(4555),
    [anon_sym_BANG_EQ] = ACTIONS(4555),
    [anon_sym_LT] = ACTIONS(4557),
    [anon_sym_GT] = ACTIONS(4557),
    [anon_sym_LT_EQ] = ACTIONS(4559),
    [anon_sym_GT_EQ] = ACTIONS(4559),
    [anon_sym_LT_LT] = ACTIONS(4561),
    [anon_sym_GT_GT] = ACTIONS(4561),
    [anon_sym_PLUS] = ACTIONS(4563),
    [anon_sym_DASH] = ACTIONS(4563),
    [anon_sym_SLASH] = ACTIONS(4537),
    [anon_sym_PERCENT] = ACTIONS(4537),
    [anon_sym_DASH_DASH] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(1554),
    [anon_sym_DASH_GT] = ACTIONS(1554),
    [sym_comment] = ACTIONS(49),
  },
  [2577] = {
    [sym_compound_statement] = STATE(2742),
    [sym_labeled_statement] = STATE(2742),
    [sym_expression_statement] = STATE(2742),
    [sym_if_statement] = STATE(2742),
    [sym_switch_statement] = STATE(2742),
    [sym_case_statement] = STATE(2742),
    [sym_while_statement] = STATE(2742),
    [sym_do_statement] = STATE(2742),
    [sym_for_statement] = STATE(2742),
    [sym_return_statement] = STATE(2742),
    [sym_break_statement] = STATE(2742),
    [sym_continue_statement] = STATE(2742),
    [sym_goto_statement] = STATE(2742),
    [sym__expression] = STATE(1419),
    [sym_comma_expression] = STATE(1420),
    [sym_conditional_expression] = STATE(1419),
    [sym_assignment_expression] = STATE(1419),
    [sym_pointer_expression] = STATE(1419),
    [sym_logical_expression] = STATE(1419),
    [sym_bitwise_expression] = STATE(1419),
    [sym_equality_expression] = STATE(1419),
    [sym_relational_expression] = STATE(1419),
    [sym_shift_expression] = STATE(1419),
    [sym_math_expression] = STATE(1419),
    [sym_cast_expression] = STATE(1419),
    [sym_sizeof_expression] = STATE(1419),
    [sym_subscript_expression] = STATE(1419),
    [sym_call_expression] = STATE(1419),
    [sym_field_expression] = STATE(1419),
    [sym_compound_literal_expression] = STATE(1419),
    [sym_parenthesized_expression] = STATE(1419),
    [sym_concatenated_string] = STATE(1419),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(1419),
    [sym_for_range_loop] = STATE(2742),
    [sym_new_expression] = STATE(1419),
    [sym_delete_expression] = STATE(1419),
    [sym_lambda_expression] = STATE(1419),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(2879),
    [anon_sym_LPAREN] = ACTIONS(626),
    [anon_sym_SEMI] = ACTIONS(2899),
    [anon_sym_LBRACE] = ACTIONS(2903),
    [anon_sym_STAR] = ACTIONS(644),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_if] = ACTIONS(2905),
    [anon_sym_switch] = ACTIONS(2907),
    [anon_sym_case] = ACTIONS(2909),
    [anon_sym_default] = ACTIONS(2911),
    [anon_sym_while] = ACTIONS(2913),
    [anon_sym_do] = ACTIONS(2915),
    [anon_sym_for] = ACTIONS(2917),
    [anon_sym_return] = ACTIONS(2919),
    [anon_sym_break] = ACTIONS(2921),
    [anon_sym_continue] = ACTIONS(2923),
    [anon_sym_goto] = ACTIONS(2925),
    [anon_sym_AMP] = ACTIONS(644),
    [anon_sym_BANG] = ACTIONS(668),
    [anon_sym_TILDE] = ACTIONS(670),
    [anon_sym_PLUS] = ACTIONS(672),
    [anon_sym_DASH] = ACTIONS(672),
    [anon_sym_DASH_DASH] = ACTIONS(674),
    [anon_sym_PLUS_PLUS] = ACTIONS(674),
    [anon_sym_sizeof] = ACTIONS(676),
    [sym_number_literal] = ACTIONS(2879),
    [sym_char_literal] = ACTIONS(2879),
    [sym_string_literal] = ACTIONS(678),
    [sym_true] = ACTIONS(2927),
    [sym_false] = ACTIONS(2927),
    [sym_null] = ACTIONS(2927),
    [sym_identifier] = ACTIONS(5397),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1303),
    [anon_sym_delete] = ACTIONS(686),
    [sym_nullptr] = ACTIONS(2927),
  },
  [2578] = {
    [sym_raw_string_literal] = ACTIONS(5631),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(5633),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(5633),
    [anon_sym_LPAREN] = ACTIONS(5631),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(5633),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(5633),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(5633),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(5633),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(5633),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(5633),
    [sym_preproc_directive] = ACTIONS(5633),
    [anon_sym_SEMI] = ACTIONS(5631),
    [anon_sym_typedef] = ACTIONS(5633),
    [anon_sym_extern] = ACTIONS(5633),
    [anon_sym_LBRACE] = ACTIONS(5631),
    [anon_sym_STAR] = ACTIONS(5631),
    [anon_sym_LBRACK] = ACTIONS(5631),
    [anon_sym_static] = ACTIONS(5633),
    [anon_sym_register] = ACTIONS(5633),
    [anon_sym_inline] = ACTIONS(5633),
    [anon_sym_const] = ACTIONS(5633),
    [anon_sym_restrict] = ACTIONS(5633),
    [anon_sym_volatile] = ACTIONS(5633),
    [anon_sym__Atomic] = ACTIONS(5633),
    [anon_sym_mutable] = ACTIONS(5633),
    [anon_sym_explicit] = ACTIONS(5633),
    [anon_sym_constexpr] = ACTIONS(5633),
    [anon_sym_unsigned] = ACTIONS(5633),
    [anon_sym_long] = ACTIONS(5633),
    [anon_sym_short] = ACTIONS(5633),
    [sym_primitive_type] = ACTIONS(5633),
    [anon_sym_enum] = ACTIONS(5633),
    [anon_sym_struct] = ACTIONS(5633),
    [anon_sym_union] = ACTIONS(5633),
    [anon_sym_if] = ACTIONS(5633),
    [anon_sym_switch] = ACTIONS(5633),
    [anon_sym_case] = ACTIONS(5633),
    [anon_sym_default] = ACTIONS(5633),
    [anon_sym_while] = ACTIONS(5633),
    [anon_sym_do] = ACTIONS(5633),
    [anon_sym_for] = ACTIONS(5633),
    [anon_sym_return] = ACTIONS(5633),
    [anon_sym_break] = ACTIONS(5633),
    [anon_sym_continue] = ACTIONS(5633),
    [anon_sym_goto] = ACTIONS(5633),
    [anon_sym_AMP] = ACTIONS(5631),
    [anon_sym_BANG] = ACTIONS(5631),
    [anon_sym_TILDE] = ACTIONS(5631),
    [anon_sym_PLUS] = ACTIONS(5633),
    [anon_sym_DASH] = ACTIONS(5633),
    [anon_sym_DASH_DASH] = ACTIONS(5631),
    [anon_sym_PLUS_PLUS] = ACTIONS(5631),
    [anon_sym_sizeof] = ACTIONS(5633),
    [sym_number_literal] = ACTIONS(5631),
    [sym_char_literal] = ACTIONS(5631),
    [sym_string_literal] = ACTIONS(5631),
    [sym_true] = ACTIONS(5633),
    [sym_false] = ACTIONS(5633),
    [sym_null] = ACTIONS(5633),
    [sym_identifier] = ACTIONS(5633),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(5633),
    [sym_auto] = ACTIONS(5633),
    [anon_sym_typename] = ACTIONS(5633),
    [anon_sym_new] = ACTIONS(5633),
    [anon_sym_COLON_COLON] = ACTIONS(5631),
    [anon_sym_delete] = ACTIONS(5633),
    [sym_nullptr] = ACTIONS(5633),
  },
  [2579] = {
    [sym_compound_statement] = STATE(2743),
    [sym_labeled_statement] = STATE(2743),
    [sym_expression_statement] = STATE(2743),
    [sym_if_statement] = STATE(2743),
    [sym_switch_statement] = STATE(2743),
    [sym_case_statement] = STATE(2743),
    [sym_while_statement] = STATE(2743),
    [sym_do_statement] = STATE(2743),
    [sym_for_statement] = STATE(2743),
    [sym_return_statement] = STATE(2743),
    [sym_break_statement] = STATE(2743),
    [sym_continue_statement] = STATE(2743),
    [sym_goto_statement] = STATE(2743),
    [sym__expression] = STATE(1419),
    [sym_comma_expression] = STATE(1420),
    [sym_conditional_expression] = STATE(1419),
    [sym_assignment_expression] = STATE(1419),
    [sym_pointer_expression] = STATE(1419),
    [sym_logical_expression] = STATE(1419),
    [sym_bitwise_expression] = STATE(1419),
    [sym_equality_expression] = STATE(1419),
    [sym_relational_expression] = STATE(1419),
    [sym_shift_expression] = STATE(1419),
    [sym_math_expression] = STATE(1419),
    [sym_cast_expression] = STATE(1419),
    [sym_sizeof_expression] = STATE(1419),
    [sym_subscript_expression] = STATE(1419),
    [sym_call_expression] = STATE(1419),
    [sym_field_expression] = STATE(1419),
    [sym_compound_literal_expression] = STATE(1419),
    [sym_parenthesized_expression] = STATE(1419),
    [sym_concatenated_string] = STATE(1419),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(1419),
    [sym_for_range_loop] = STATE(2743),
    [sym_new_expression] = STATE(1419),
    [sym_delete_expression] = STATE(1419),
    [sym_lambda_expression] = STATE(1419),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(2879),
    [anon_sym_LPAREN] = ACTIONS(626),
    [anon_sym_SEMI] = ACTIONS(2899),
    [anon_sym_LBRACE] = ACTIONS(2903),
    [anon_sym_STAR] = ACTIONS(644),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_if] = ACTIONS(2905),
    [anon_sym_switch] = ACTIONS(2907),
    [anon_sym_case] = ACTIONS(2909),
    [anon_sym_default] = ACTIONS(2911),
    [anon_sym_while] = ACTIONS(2913),
    [anon_sym_do] = ACTIONS(2915),
    [anon_sym_for] = ACTIONS(2917),
    [anon_sym_return] = ACTIONS(2919),
    [anon_sym_break] = ACTIONS(2921),
    [anon_sym_continue] = ACTIONS(2923),
    [anon_sym_goto] = ACTIONS(2925),
    [anon_sym_AMP] = ACTIONS(644),
    [anon_sym_BANG] = ACTIONS(668),
    [anon_sym_TILDE] = ACTIONS(670),
    [anon_sym_PLUS] = ACTIONS(672),
    [anon_sym_DASH] = ACTIONS(672),
    [anon_sym_DASH_DASH] = ACTIONS(674),
    [anon_sym_PLUS_PLUS] = ACTIONS(674),
    [anon_sym_sizeof] = ACTIONS(676),
    [sym_number_literal] = ACTIONS(2879),
    [sym_char_literal] = ACTIONS(2879),
    [sym_string_literal] = ACTIONS(678),
    [sym_true] = ACTIONS(2927),
    [sym_false] = ACTIONS(2927),
    [sym_null] = ACTIONS(2927),
    [sym_identifier] = ACTIONS(5397),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1303),
    [anon_sym_delete] = ACTIONS(686),
    [sym_nullptr] = ACTIONS(2927),
  },
  [2580] = {
    [sym__expression] = STATE(2744),
    [sym_conditional_expression] = STATE(2744),
    [sym_assignment_expression] = STATE(2744),
    [sym_pointer_expression] = STATE(2744),
    [sym_logical_expression] = STATE(2744),
    [sym_bitwise_expression] = STATE(2744),
    [sym_equality_expression] = STATE(2744),
    [sym_relational_expression] = STATE(2744),
    [sym_shift_expression] = STATE(2744),
    [sym_math_expression] = STATE(2744),
    [sym_cast_expression] = STATE(2744),
    [sym_sizeof_expression] = STATE(2744),
    [sym_subscript_expression] = STATE(2744),
    [sym_call_expression] = STATE(2744),
    [sym_field_expression] = STATE(2744),
    [sym_compound_literal_expression] = STATE(2744),
    [sym_parenthesized_expression] = STATE(2744),
    [sym_concatenated_string] = STATE(2744),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(2744),
    [sym_new_expression] = STATE(2744),
    [sym_delete_expression] = STATE(2744),
    [sym_lambda_expression] = STATE(2744),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(6541),
    [anon_sym_LPAREN] = ACTIONS(2943),
    [anon_sym_STAR] = ACTIONS(2945),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_AMP] = ACTIONS(2945),
    [anon_sym_BANG] = ACTIONS(2947),
    [anon_sym_TILDE] = ACTIONS(2949),
    [anon_sym_PLUS] = ACTIONS(2951),
    [anon_sym_DASH] = ACTIONS(2951),
    [anon_sym_DASH_DASH] = ACTIONS(2953),
    [anon_sym_PLUS_PLUS] = ACTIONS(2953),
    [anon_sym_sizeof] = ACTIONS(2955),
    [sym_number_literal] = ACTIONS(6541),
    [sym_char_literal] = ACTIONS(6541),
    [sym_string_literal] = ACTIONS(2957),
    [sym_true] = ACTIONS(6543),
    [sym_false] = ACTIONS(6543),
    [sym_null] = ACTIONS(6543),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(2961),
    [anon_sym_delete] = ACTIONS(2963),
    [sym_nullptr] = ACTIONS(6543),
  },
  [2581] = {
    [sym__expression] = STATE(2746),
    [sym_conditional_expression] = STATE(2746),
    [sym_assignment_expression] = STATE(2746),
    [sym_pointer_expression] = STATE(2746),
    [sym_logical_expression] = STATE(2746),
    [sym_bitwise_expression] = STATE(2746),
    [sym_equality_expression] = STATE(2746),
    [sym_relational_expression] = STATE(2746),
    [sym_shift_expression] = STATE(2746),
    [sym_math_expression] = STATE(2746),
    [sym_cast_expression] = STATE(2746),
    [sym_sizeof_expression] = STATE(2746),
    [sym_subscript_expression] = STATE(2746),
    [sym_call_expression] = STATE(2746),
    [sym_field_expression] = STATE(2746),
    [sym_compound_literal_expression] = STATE(2746),
    [sym_parenthesized_expression] = STATE(2746),
    [sym_concatenated_string] = STATE(2746),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(2746),
    [sym_new_expression] = STATE(2746),
    [sym_delete_expression] = STATE(2746),
    [sym_lambda_expression] = STATE(2746),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(6545),
    [anon_sym_LPAREN] = ACTIONS(1087),
    [anon_sym_RPAREN] = ACTIONS(6547),
    [anon_sym_STAR] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_AMP] = ACTIONS(1089),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1093),
    [anon_sym_PLUS] = ACTIONS(1095),
    [anon_sym_DASH] = ACTIONS(1095),
    [anon_sym_DASH_DASH] = ACTIONS(1097),
    [anon_sym_PLUS_PLUS] = ACTIONS(1097),
    [anon_sym_sizeof] = ACTIONS(1099),
    [sym_number_literal] = ACTIONS(6545),
    [sym_char_literal] = ACTIONS(6545),
    [sym_string_literal] = ACTIONS(1101),
    [sym_true] = ACTIONS(6549),
    [sym_false] = ACTIONS(6549),
    [sym_null] = ACTIONS(6549),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_delete] = ACTIONS(1109),
    [sym_nullptr] = ACTIONS(6549),
  },
  [2582] = {
    [sym_argument_list] = STATE(802),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_SEMI] = ACTIONS(6551),
    [anon_sym_STAR] = ACTIONS(2553),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_EQ] = ACTIONS(2555),
    [anon_sym_QMARK] = ACTIONS(2557),
    [anon_sym_STAR_EQ] = ACTIONS(2559),
    [anon_sym_SLASH_EQ] = ACTIONS(2559),
    [anon_sym_PERCENT_EQ] = ACTIONS(2559),
    [anon_sym_PLUS_EQ] = ACTIONS(2559),
    [anon_sym_DASH_EQ] = ACTIONS(2559),
    [anon_sym_LT_LT_EQ] = ACTIONS(2559),
    [anon_sym_GT_GT_EQ] = ACTIONS(2559),
    [anon_sym_AMP_EQ] = ACTIONS(2559),
    [anon_sym_CARET_EQ] = ACTIONS(2559),
    [anon_sym_PIPE_EQ] = ACTIONS(2559),
    [anon_sym_AMP] = ACTIONS(2561),
    [anon_sym_PIPE_PIPE] = ACTIONS(2563),
    [anon_sym_AMP_AMP] = ACTIONS(2565),
    [anon_sym_PIPE] = ACTIONS(2567),
    [anon_sym_CARET] = ACTIONS(2569),
    [anon_sym_EQ_EQ] = ACTIONS(2571),
    [anon_sym_BANG_EQ] = ACTIONS(2571),
    [anon_sym_LT] = ACTIONS(2573),
    [anon_sym_GT] = ACTIONS(2573),
    [anon_sym_LT_EQ] = ACTIONS(2575),
    [anon_sym_GT_EQ] = ACTIONS(2575),
    [anon_sym_LT_LT] = ACTIONS(2577),
    [anon_sym_GT_GT] = ACTIONS(2577),
    [anon_sym_PLUS] = ACTIONS(2579),
    [anon_sym_DASH] = ACTIONS(2579),
    [anon_sym_SLASH] = ACTIONS(2553),
    [anon_sym_PERCENT] = ACTIONS(2553),
    [anon_sym_DASH_DASH] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(1554),
    [anon_sym_DASH_GT] = ACTIONS(1554),
    [sym_comment] = ACTIONS(49),
  },
  [2583] = {
    [sym__expression] = STATE(2748),
    [sym_conditional_expression] = STATE(2748),
    [sym_assignment_expression] = STATE(2748),
    [sym_pointer_expression] = STATE(2748),
    [sym_logical_expression] = STATE(2748),
    [sym_bitwise_expression] = STATE(2748),
    [sym_equality_expression] = STATE(2748),
    [sym_relational_expression] = STATE(2748),
    [sym_shift_expression] = STATE(2748),
    [sym_math_expression] = STATE(2748),
    [sym_cast_expression] = STATE(2748),
    [sym_sizeof_expression] = STATE(2748),
    [sym_subscript_expression] = STATE(2748),
    [sym_call_expression] = STATE(2748),
    [sym_field_expression] = STATE(2748),
    [sym_compound_literal_expression] = STATE(2748),
    [sym_parenthesized_expression] = STATE(2748),
    [sym_concatenated_string] = STATE(2748),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(2748),
    [sym_new_expression] = STATE(2748),
    [sym_delete_expression] = STATE(2748),
    [sym_lambda_expression] = STATE(2748),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(6553),
    [anon_sym_LPAREN] = ACTIONS(1347),
    [anon_sym_SEMI] = ACTIONS(6551),
    [anon_sym_STAR] = ACTIONS(1349),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_AMP] = ACTIONS(1349),
    [anon_sym_BANG] = ACTIONS(1351),
    [anon_sym_TILDE] = ACTIONS(1353),
    [anon_sym_PLUS] = ACTIONS(1355),
    [anon_sym_DASH] = ACTIONS(1355),
    [anon_sym_DASH_DASH] = ACTIONS(1357),
    [anon_sym_PLUS_PLUS] = ACTIONS(1357),
    [anon_sym_sizeof] = ACTIONS(1359),
    [sym_number_literal] = ACTIONS(6553),
    [sym_char_literal] = ACTIONS(6553),
    [sym_string_literal] = ACTIONS(1361),
    [sym_true] = ACTIONS(6555),
    [sym_false] = ACTIONS(6555),
    [sym_null] = ACTIONS(6555),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1365),
    [anon_sym_delete] = ACTIONS(1367),
    [sym_nullptr] = ACTIONS(6555),
  },
  [2584] = {
    [sym__expression] = STATE(2749),
    [sym_conditional_expression] = STATE(2749),
    [sym_assignment_expression] = STATE(2749),
    [sym_pointer_expression] = STATE(2749),
    [sym_logical_expression] = STATE(2749),
    [sym_bitwise_expression] = STATE(2749),
    [sym_equality_expression] = STATE(2749),
    [sym_relational_expression] = STATE(2749),
    [sym_shift_expression] = STATE(2749),
    [sym_math_expression] = STATE(2749),
    [sym_cast_expression] = STATE(2749),
    [sym_sizeof_expression] = STATE(2749),
    [sym_subscript_expression] = STATE(2749),
    [sym_call_expression] = STATE(2749),
    [sym_field_expression] = STATE(2749),
    [sym_compound_literal_expression] = STATE(2749),
    [sym_parenthesized_expression] = STATE(2749),
    [sym_concatenated_string] = STATE(2749),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(2749),
    [sym_new_expression] = STATE(2749),
    [sym_delete_expression] = STATE(2749),
    [sym_lambda_expression] = STATE(2749),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(6557),
    [anon_sym_LPAREN] = ACTIONS(2943),
    [anon_sym_STAR] = ACTIONS(2945),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_AMP] = ACTIONS(2945),
    [anon_sym_BANG] = ACTIONS(2947),
    [anon_sym_TILDE] = ACTIONS(2949),
    [anon_sym_PLUS] = ACTIONS(2951),
    [anon_sym_DASH] = ACTIONS(2951),
    [anon_sym_DASH_DASH] = ACTIONS(2953),
    [anon_sym_PLUS_PLUS] = ACTIONS(2953),
    [anon_sym_sizeof] = ACTIONS(2955),
    [sym_number_literal] = ACTIONS(6557),
    [sym_char_literal] = ACTIONS(6557),
    [sym_string_literal] = ACTIONS(2957),
    [sym_true] = ACTIONS(6559),
    [sym_false] = ACTIONS(6559),
    [sym_null] = ACTIONS(6559),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(2961),
    [anon_sym_delete] = ACTIONS(2963),
    [sym_nullptr] = ACTIONS(6559),
  },
  [2585] = {
    [sym_raw_string_literal] = ACTIONS(2478),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(2480),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(2480),
    [anon_sym_LPAREN] = ACTIONS(2478),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(2480),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(2480),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(2480),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(2480),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(2480),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(2480),
    [sym_preproc_directive] = ACTIONS(2480),
    [anon_sym_SEMI] = ACTIONS(2478),
    [anon_sym_typedef] = ACTIONS(2480),
    [anon_sym_extern] = ACTIONS(2480),
    [anon_sym_LBRACE] = ACTIONS(2478),
    [anon_sym_STAR] = ACTIONS(2478),
    [anon_sym_LBRACK] = ACTIONS(2478),
    [anon_sym_static] = ACTIONS(2480),
    [anon_sym_register] = ACTIONS(2480),
    [anon_sym_inline] = ACTIONS(2480),
    [anon_sym_const] = ACTIONS(2480),
    [anon_sym_restrict] = ACTIONS(2480),
    [anon_sym_volatile] = ACTIONS(2480),
    [anon_sym__Atomic] = ACTIONS(2480),
    [anon_sym_mutable] = ACTIONS(2480),
    [anon_sym_explicit] = ACTIONS(2480),
    [anon_sym_constexpr] = ACTIONS(2480),
    [anon_sym_unsigned] = ACTIONS(2480),
    [anon_sym_long] = ACTIONS(2480),
    [anon_sym_short] = ACTIONS(2480),
    [sym_primitive_type] = ACTIONS(2480),
    [anon_sym_enum] = ACTIONS(2480),
    [anon_sym_struct] = ACTIONS(2480),
    [anon_sym_union] = ACTIONS(2480),
    [anon_sym_if] = ACTIONS(2480),
    [anon_sym_switch] = ACTIONS(2480),
    [anon_sym_case] = ACTIONS(2480),
    [anon_sym_default] = ACTIONS(2480),
    [anon_sym_while] = ACTIONS(2480),
    [anon_sym_do] = ACTIONS(2480),
    [anon_sym_for] = ACTIONS(2480),
    [anon_sym_return] = ACTIONS(2480),
    [anon_sym_break] = ACTIONS(2480),
    [anon_sym_continue] = ACTIONS(2480),
    [anon_sym_goto] = ACTIONS(2480),
    [anon_sym_AMP] = ACTIONS(2478),
    [anon_sym_BANG] = ACTIONS(2478),
    [anon_sym_TILDE] = ACTIONS(2478),
    [anon_sym_PLUS] = ACTIONS(2480),
    [anon_sym_DASH] = ACTIONS(2480),
    [anon_sym_DASH_DASH] = ACTIONS(2478),
    [anon_sym_PLUS_PLUS] = ACTIONS(2478),
    [anon_sym_sizeof] = ACTIONS(2480),
    [sym_number_literal] = ACTIONS(2478),
    [sym_char_literal] = ACTIONS(2478),
    [sym_string_literal] = ACTIONS(2478),
    [sym_true] = ACTIONS(2480),
    [sym_false] = ACTIONS(2480),
    [sym_null] = ACTIONS(2480),
    [sym_identifier] = ACTIONS(2480),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(2480),
    [sym_auto] = ACTIONS(2480),
    [anon_sym_typename] = ACTIONS(2480),
    [anon_sym_new] = ACTIONS(2480),
    [anon_sym_COLON_COLON] = ACTIONS(2478),
    [anon_sym_delete] = ACTIONS(2480),
    [sym_nullptr] = ACTIONS(2480),
  },
  [2586] = {
    [sym_argument_list] = STATE(802),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_SEMI] = ACTIONS(6561),
    [anon_sym_STAR] = ACTIONS(2553),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_EQ] = ACTIONS(2555),
    [anon_sym_QMARK] = ACTIONS(2557),
    [anon_sym_STAR_EQ] = ACTIONS(2559),
    [anon_sym_SLASH_EQ] = ACTIONS(2559),
    [anon_sym_PERCENT_EQ] = ACTIONS(2559),
    [anon_sym_PLUS_EQ] = ACTIONS(2559),
    [anon_sym_DASH_EQ] = ACTIONS(2559),
    [anon_sym_LT_LT_EQ] = ACTIONS(2559),
    [anon_sym_GT_GT_EQ] = ACTIONS(2559),
    [anon_sym_AMP_EQ] = ACTIONS(2559),
    [anon_sym_CARET_EQ] = ACTIONS(2559),
    [anon_sym_PIPE_EQ] = ACTIONS(2559),
    [anon_sym_AMP] = ACTIONS(2561),
    [anon_sym_PIPE_PIPE] = ACTIONS(2563),
    [anon_sym_AMP_AMP] = ACTIONS(2565),
    [anon_sym_PIPE] = ACTIONS(2567),
    [anon_sym_CARET] = ACTIONS(2569),
    [anon_sym_EQ_EQ] = ACTIONS(2571),
    [anon_sym_BANG_EQ] = ACTIONS(2571),
    [anon_sym_LT] = ACTIONS(2573),
    [anon_sym_GT] = ACTIONS(2573),
    [anon_sym_LT_EQ] = ACTIONS(2575),
    [anon_sym_GT_EQ] = ACTIONS(2575),
    [anon_sym_LT_LT] = ACTIONS(2577),
    [anon_sym_GT_GT] = ACTIONS(2577),
    [anon_sym_PLUS] = ACTIONS(2579),
    [anon_sym_DASH] = ACTIONS(2579),
    [anon_sym_SLASH] = ACTIONS(2553),
    [anon_sym_PERCENT] = ACTIONS(2553),
    [anon_sym_DASH_DASH] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(1554),
    [anon_sym_DASH_GT] = ACTIONS(1554),
    [sym_comment] = ACTIONS(49),
  },
  [2587] = {
    [anon_sym_SEMI] = ACTIONS(6561),
    [sym_comment] = ACTIONS(49),
  },
  [2588] = {
    [sym_raw_string_literal] = ACTIONS(2581),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(2583),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(2583),
    [anon_sym_LPAREN] = ACTIONS(2581),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(2583),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(2583),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(2583),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(2583),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(2583),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(2583),
    [sym_preproc_directive] = ACTIONS(2583),
    [anon_sym_SEMI] = ACTIONS(2581),
    [anon_sym_typedef] = ACTIONS(2583),
    [anon_sym_extern] = ACTIONS(2583),
    [anon_sym_LBRACE] = ACTIONS(2581),
    [anon_sym_STAR] = ACTIONS(2581),
    [anon_sym_LBRACK] = ACTIONS(2581),
    [anon_sym_static] = ACTIONS(2583),
    [anon_sym_register] = ACTIONS(2583),
    [anon_sym_inline] = ACTIONS(2583),
    [anon_sym_const] = ACTIONS(2583),
    [anon_sym_restrict] = ACTIONS(2583),
    [anon_sym_volatile] = ACTIONS(2583),
    [anon_sym__Atomic] = ACTIONS(2583),
    [anon_sym_mutable] = ACTIONS(2583),
    [anon_sym_explicit] = ACTIONS(2583),
    [anon_sym_constexpr] = ACTIONS(2583),
    [anon_sym_unsigned] = ACTIONS(2583),
    [anon_sym_long] = ACTIONS(2583),
    [anon_sym_short] = ACTIONS(2583),
    [sym_primitive_type] = ACTIONS(2583),
    [anon_sym_enum] = ACTIONS(2583),
    [anon_sym_struct] = ACTIONS(2583),
    [anon_sym_union] = ACTIONS(2583),
    [anon_sym_if] = ACTIONS(2583),
    [anon_sym_switch] = ACTIONS(2583),
    [anon_sym_case] = ACTIONS(2583),
    [anon_sym_default] = ACTIONS(2583),
    [anon_sym_while] = ACTIONS(2583),
    [anon_sym_do] = ACTIONS(2583),
    [anon_sym_for] = ACTIONS(2583),
    [anon_sym_return] = ACTIONS(2583),
    [anon_sym_break] = ACTIONS(2583),
    [anon_sym_continue] = ACTIONS(2583),
    [anon_sym_goto] = ACTIONS(2583),
    [anon_sym_AMP] = ACTIONS(2581),
    [anon_sym_BANG] = ACTIONS(2581),
    [anon_sym_TILDE] = ACTIONS(2581),
    [anon_sym_PLUS] = ACTIONS(2583),
    [anon_sym_DASH] = ACTIONS(2583),
    [anon_sym_DASH_DASH] = ACTIONS(2581),
    [anon_sym_PLUS_PLUS] = ACTIONS(2581),
    [anon_sym_sizeof] = ACTIONS(2583),
    [sym_number_literal] = ACTIONS(2581),
    [sym_char_literal] = ACTIONS(2581),
    [sym_string_literal] = ACTIONS(2581),
    [sym_true] = ACTIONS(2583),
    [sym_false] = ACTIONS(2583),
    [sym_null] = ACTIONS(2583),
    [sym_identifier] = ACTIONS(2583),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(2583),
    [sym_auto] = ACTIONS(2583),
    [anon_sym_typename] = ACTIONS(2583),
    [anon_sym_new] = ACTIONS(2583),
    [anon_sym_COLON_COLON] = ACTIONS(2581),
    [anon_sym_delete] = ACTIONS(2583),
    [sym_nullptr] = ACTIONS(2583),
  },
  [2589] = {
    [sym_argument_list] = STATE(802),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_SEMI] = ACTIONS(6563),
    [anon_sym_STAR] = ACTIONS(2553),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_EQ] = ACTIONS(2555),
    [anon_sym_QMARK] = ACTIONS(2557),
    [anon_sym_STAR_EQ] = ACTIONS(2559),
    [anon_sym_SLASH_EQ] = ACTIONS(2559),
    [anon_sym_PERCENT_EQ] = ACTIONS(2559),
    [anon_sym_PLUS_EQ] = ACTIONS(2559),
    [anon_sym_DASH_EQ] = ACTIONS(2559),
    [anon_sym_LT_LT_EQ] = ACTIONS(2559),
    [anon_sym_GT_GT_EQ] = ACTIONS(2559),
    [anon_sym_AMP_EQ] = ACTIONS(2559),
    [anon_sym_CARET_EQ] = ACTIONS(2559),
    [anon_sym_PIPE_EQ] = ACTIONS(2559),
    [anon_sym_AMP] = ACTIONS(2561),
    [anon_sym_PIPE_PIPE] = ACTIONS(2563),
    [anon_sym_AMP_AMP] = ACTIONS(2565),
    [anon_sym_PIPE] = ACTIONS(2567),
    [anon_sym_CARET] = ACTIONS(2569),
    [anon_sym_EQ_EQ] = ACTIONS(2571),
    [anon_sym_BANG_EQ] = ACTIONS(2571),
    [anon_sym_LT] = ACTIONS(2573),
    [anon_sym_GT] = ACTIONS(2573),
    [anon_sym_LT_EQ] = ACTIONS(2575),
    [anon_sym_GT_EQ] = ACTIONS(2575),
    [anon_sym_LT_LT] = ACTIONS(2577),
    [anon_sym_GT_GT] = ACTIONS(2577),
    [anon_sym_PLUS] = ACTIONS(2579),
    [anon_sym_DASH] = ACTIONS(2579),
    [anon_sym_SLASH] = ACTIONS(2553),
    [anon_sym_PERCENT] = ACTIONS(2553),
    [anon_sym_DASH_DASH] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(1554),
    [anon_sym_DASH_GT] = ACTIONS(1554),
    [sym_comment] = ACTIONS(49),
  },
  [2590] = {
    [anon_sym_SEMI] = ACTIONS(6563),
    [sym_comment] = ACTIONS(49),
  },
  [2591] = {
    [sym_raw_string_literal] = ACTIONS(2587),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(2589),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(2589),
    [anon_sym_LPAREN] = ACTIONS(2587),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(2589),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(2589),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(2589),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(2589),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(2589),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(2589),
    [sym_preproc_directive] = ACTIONS(2589),
    [anon_sym_SEMI] = ACTIONS(2587),
    [anon_sym_typedef] = ACTIONS(2589),
    [anon_sym_extern] = ACTIONS(2589),
    [anon_sym_LBRACE] = ACTIONS(2587),
    [anon_sym_STAR] = ACTIONS(2587),
    [anon_sym_LBRACK] = ACTIONS(2587),
    [anon_sym_static] = ACTIONS(2589),
    [anon_sym_register] = ACTIONS(2589),
    [anon_sym_inline] = ACTIONS(2589),
    [anon_sym_const] = ACTIONS(2589),
    [anon_sym_restrict] = ACTIONS(2589),
    [anon_sym_volatile] = ACTIONS(2589),
    [anon_sym__Atomic] = ACTIONS(2589),
    [anon_sym_mutable] = ACTIONS(2589),
    [anon_sym_explicit] = ACTIONS(2589),
    [anon_sym_constexpr] = ACTIONS(2589),
    [anon_sym_unsigned] = ACTIONS(2589),
    [anon_sym_long] = ACTIONS(2589),
    [anon_sym_short] = ACTIONS(2589),
    [sym_primitive_type] = ACTIONS(2589),
    [anon_sym_enum] = ACTIONS(2589),
    [anon_sym_struct] = ACTIONS(2589),
    [anon_sym_union] = ACTIONS(2589),
    [anon_sym_if] = ACTIONS(2589),
    [anon_sym_switch] = ACTIONS(2589),
    [anon_sym_case] = ACTIONS(2589),
    [anon_sym_default] = ACTIONS(2589),
    [anon_sym_while] = ACTIONS(2589),
    [anon_sym_do] = ACTIONS(2589),
    [anon_sym_for] = ACTIONS(2589),
    [anon_sym_return] = ACTIONS(2589),
    [anon_sym_break] = ACTIONS(2589),
    [anon_sym_continue] = ACTIONS(2589),
    [anon_sym_goto] = ACTIONS(2589),
    [anon_sym_AMP] = ACTIONS(2587),
    [anon_sym_BANG] = ACTIONS(2587),
    [anon_sym_TILDE] = ACTIONS(2587),
    [anon_sym_PLUS] = ACTIONS(2589),
    [anon_sym_DASH] = ACTIONS(2589),
    [anon_sym_DASH_DASH] = ACTIONS(2587),
    [anon_sym_PLUS_PLUS] = ACTIONS(2587),
    [anon_sym_sizeof] = ACTIONS(2589),
    [sym_number_literal] = ACTIONS(2587),
    [sym_char_literal] = ACTIONS(2587),
    [sym_string_literal] = ACTIONS(2587),
    [sym_true] = ACTIONS(2589),
    [sym_false] = ACTIONS(2589),
    [sym_null] = ACTIONS(2589),
    [sym_identifier] = ACTIONS(2589),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(2589),
    [sym_auto] = ACTIONS(2589),
    [anon_sym_typename] = ACTIONS(2589),
    [anon_sym_new] = ACTIONS(2589),
    [anon_sym_COLON_COLON] = ACTIONS(2587),
    [anon_sym_delete] = ACTIONS(2589),
    [sym_nullptr] = ACTIONS(2589),
  },
  [2592] = {
    [sym__expression] = STATE(1834),
    [sym_conditional_expression] = STATE(1834),
    [sym_assignment_expression] = STATE(1834),
    [sym_pointer_expression] = STATE(1834),
    [sym_logical_expression] = STATE(1834),
    [sym_bitwise_expression] = STATE(1834),
    [sym_equality_expression] = STATE(1834),
    [sym_relational_expression] = STATE(1834),
    [sym_shift_expression] = STATE(1834),
    [sym_math_expression] = STATE(1834),
    [sym_cast_expression] = STATE(1834),
    [sym_sizeof_expression] = STATE(1834),
    [sym_subscript_expression] = STATE(1834),
    [sym_call_expression] = STATE(1834),
    [sym_field_expression] = STATE(1834),
    [sym_compound_literal_expression] = STATE(1834),
    [sym_parenthesized_expression] = STATE(1834),
    [sym_initializer_list] = STATE(1835),
    [sym_concatenated_string] = STATE(1834),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(1834),
    [sym_new_expression] = STATE(1834),
    [sym_delete_expression] = STATE(1834),
    [sym_lambda_expression] = STATE(1834),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(4145),
    [anon_sym_LPAREN] = ACTIONS(2943),
    [anon_sym_RPAREN] = ACTIONS(5210),
    [anon_sym_LBRACE] = ACTIONS(548),
    [anon_sym_STAR] = ACTIONS(6565),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_EQ] = ACTIONS(5212),
    [anon_sym_QMARK] = ACTIONS(5210),
    [anon_sym_STAR_EQ] = ACTIONS(5210),
    [anon_sym_SLASH_EQ] = ACTIONS(5210),
    [anon_sym_PERCENT_EQ] = ACTIONS(5210),
    [anon_sym_PLUS_EQ] = ACTIONS(5210),
    [anon_sym_DASH_EQ] = ACTIONS(5210),
    [anon_sym_LT_LT_EQ] = ACTIONS(5210),
    [anon_sym_GT_GT_EQ] = ACTIONS(5210),
    [anon_sym_AMP_EQ] = ACTIONS(5210),
    [anon_sym_CARET_EQ] = ACTIONS(5210),
    [anon_sym_PIPE_EQ] = ACTIONS(5210),
    [anon_sym_AMP] = ACTIONS(6565),
    [anon_sym_PIPE_PIPE] = ACTIONS(5210),
    [anon_sym_AMP_AMP] = ACTIONS(5210),
    [anon_sym_BANG] = ACTIONS(6567),
    [anon_sym_PIPE] = ACTIONS(5212),
    [anon_sym_CARET] = ACTIONS(5212),
    [anon_sym_TILDE] = ACTIONS(2949),
    [anon_sym_EQ_EQ] = ACTIONS(5210),
    [anon_sym_BANG_EQ] = ACTIONS(5210),
    [anon_sym_LT] = ACTIONS(5212),
    [anon_sym_GT] = ACTIONS(5212),
    [anon_sym_LT_EQ] = ACTIONS(5210),
    [anon_sym_GT_EQ] = ACTIONS(5210),
    [anon_sym_LT_LT] = ACTIONS(5212),
    [anon_sym_GT_GT] = ACTIONS(5212),
    [anon_sym_PLUS] = ACTIONS(2951),
    [anon_sym_DASH] = ACTIONS(2951),
    [anon_sym_SLASH] = ACTIONS(5212),
    [anon_sym_PERCENT] = ACTIONS(5212),
    [anon_sym_DASH_DASH] = ACTIONS(2953),
    [anon_sym_PLUS_PLUS] = ACTIONS(2953),
    [anon_sym_sizeof] = ACTIONS(2955),
    [anon_sym_DOT] = ACTIONS(5210),
    [anon_sym_DASH_GT] = ACTIONS(5210),
    [sym_number_literal] = ACTIONS(4145),
    [sym_char_literal] = ACTIONS(4145),
    [sym_string_literal] = ACTIONS(2957),
    [sym_true] = ACTIONS(4147),
    [sym_false] = ACTIONS(4147),
    [sym_null] = ACTIONS(4147),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(2961),
    [anon_sym_delete] = ACTIONS(2963),
    [sym_nullptr] = ACTIONS(4147),
  },
  [2593] = {
    [sym__expression] = STATE(2752),
    [sym_conditional_expression] = STATE(2752),
    [sym_assignment_expression] = STATE(2752),
    [sym_pointer_expression] = STATE(2752),
    [sym_logical_expression] = STATE(2752),
    [sym_bitwise_expression] = STATE(2752),
    [sym_equality_expression] = STATE(2752),
    [sym_relational_expression] = STATE(2752),
    [sym_shift_expression] = STATE(2752),
    [sym_math_expression] = STATE(2752),
    [sym_cast_expression] = STATE(2752),
    [sym_sizeof_expression] = STATE(2752),
    [sym_subscript_expression] = STATE(2752),
    [sym_call_expression] = STATE(2752),
    [sym_field_expression] = STATE(2752),
    [sym_compound_literal_expression] = STATE(2752),
    [sym_parenthesized_expression] = STATE(2752),
    [sym_concatenated_string] = STATE(2752),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(2752),
    [sym_new_expression] = STATE(2752),
    [sym_delete_expression] = STATE(2752),
    [sym_lambda_expression] = STATE(2752),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(6569),
    [anon_sym_LPAREN] = ACTIONS(2624),
    [anon_sym_STAR] = ACTIONS(2624),
    [anon_sym_LBRACK] = ACTIONS(2624),
    [anon_sym_AMP] = ACTIONS(2626),
    [anon_sym_AMP_AMP] = ACTIONS(2624),
    [anon_sym_BANG] = ACTIONS(2947),
    [anon_sym_TILDE] = ACTIONS(2949),
    [anon_sym_PLUS] = ACTIONS(2951),
    [anon_sym_DASH] = ACTIONS(2951),
    [anon_sym_DASH_DASH] = ACTIONS(2953),
    [anon_sym_PLUS_PLUS] = ACTIONS(2953),
    [anon_sym_sizeof] = ACTIONS(2955),
    [sym_number_literal] = ACTIONS(6569),
    [sym_char_literal] = ACTIONS(6569),
    [sym_string_literal] = ACTIONS(2957),
    [sym_true] = ACTIONS(6571),
    [sym_false] = ACTIONS(6571),
    [sym_null] = ACTIONS(6571),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(2961),
    [anon_sym_delete] = ACTIONS(2963),
    [sym_nullptr] = ACTIONS(6571),
  },
  [2594] = {
    [sym_argument_list] = STATE(802),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_RPAREN] = ACTIONS(5236),
    [anon_sym_STAR] = ACTIONS(4537),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_EQ] = ACTIONS(5238),
    [anon_sym_QMARK] = ACTIONS(5236),
    [anon_sym_STAR_EQ] = ACTIONS(5236),
    [anon_sym_SLASH_EQ] = ACTIONS(5236),
    [anon_sym_PERCENT_EQ] = ACTIONS(5236),
    [anon_sym_PLUS_EQ] = ACTIONS(5236),
    [anon_sym_DASH_EQ] = ACTIONS(5236),
    [anon_sym_LT_LT_EQ] = ACTIONS(5236),
    [anon_sym_GT_GT_EQ] = ACTIONS(5236),
    [anon_sym_AMP_EQ] = ACTIONS(5236),
    [anon_sym_CARET_EQ] = ACTIONS(5236),
    [anon_sym_PIPE_EQ] = ACTIONS(5236),
    [anon_sym_AMP] = ACTIONS(4545),
    [anon_sym_PIPE_PIPE] = ACTIONS(4547),
    [anon_sym_AMP_AMP] = ACTIONS(4549),
    [anon_sym_PIPE] = ACTIONS(4551),
    [anon_sym_CARET] = ACTIONS(4553),
    [anon_sym_EQ_EQ] = ACTIONS(4555),
    [anon_sym_BANG_EQ] = ACTIONS(4555),
    [anon_sym_LT] = ACTIONS(4557),
    [anon_sym_GT] = ACTIONS(4557),
    [anon_sym_LT_EQ] = ACTIONS(4559),
    [anon_sym_GT_EQ] = ACTIONS(4559),
    [anon_sym_LT_LT] = ACTIONS(4561),
    [anon_sym_GT_GT] = ACTIONS(4561),
    [anon_sym_PLUS] = ACTIONS(4563),
    [anon_sym_DASH] = ACTIONS(4563),
    [anon_sym_SLASH] = ACTIONS(4537),
    [anon_sym_PERCENT] = ACTIONS(4537),
    [anon_sym_DASH_DASH] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(1554),
    [anon_sym_DASH_GT] = ACTIONS(1554),
    [sym_comment] = ACTIONS(49),
  },
  [2595] = {
    [sym_raw_string_literal] = ACTIONS(1622),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1624),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1624),
    [anon_sym_LPAREN] = ACTIONS(1622),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1624),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1624),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1624),
    [sym_preproc_directive] = ACTIONS(1624),
    [anon_sym_SEMI] = ACTIONS(1622),
    [anon_sym_typedef] = ACTIONS(1624),
    [anon_sym_extern] = ACTIONS(1624),
    [anon_sym_LBRACE] = ACTIONS(1622),
    [anon_sym_RBRACE] = ACTIONS(1622),
    [anon_sym_STAR] = ACTIONS(1622),
    [anon_sym_LBRACK] = ACTIONS(1622),
    [anon_sym_static] = ACTIONS(1624),
    [anon_sym_register] = ACTIONS(1624),
    [anon_sym_inline] = ACTIONS(1624),
    [anon_sym_const] = ACTIONS(1624),
    [anon_sym_restrict] = ACTIONS(1624),
    [anon_sym_volatile] = ACTIONS(1624),
    [anon_sym__Atomic] = ACTIONS(1624),
    [anon_sym_mutable] = ACTIONS(1624),
    [anon_sym_explicit] = ACTIONS(1624),
    [anon_sym_constexpr] = ACTIONS(1624),
    [anon_sym_unsigned] = ACTIONS(1624),
    [anon_sym_long] = ACTIONS(1624),
    [anon_sym_short] = ACTIONS(1624),
    [sym_primitive_type] = ACTIONS(1624),
    [anon_sym_enum] = ACTIONS(1624),
    [anon_sym_struct] = ACTIONS(1624),
    [anon_sym_union] = ACTIONS(1624),
    [anon_sym_if] = ACTIONS(1624),
    [anon_sym_else] = ACTIONS(1624),
    [anon_sym_switch] = ACTIONS(1624),
    [anon_sym_case] = ACTIONS(1624),
    [anon_sym_default] = ACTIONS(1624),
    [anon_sym_while] = ACTIONS(1624),
    [anon_sym_do] = ACTIONS(1624),
    [anon_sym_for] = ACTIONS(1624),
    [anon_sym_return] = ACTIONS(1624),
    [anon_sym_break] = ACTIONS(1624),
    [anon_sym_continue] = ACTIONS(1624),
    [anon_sym_goto] = ACTIONS(1624),
    [anon_sym_AMP] = ACTIONS(1622),
    [anon_sym_BANG] = ACTIONS(1622),
    [anon_sym_TILDE] = ACTIONS(1622),
    [anon_sym_PLUS] = ACTIONS(1624),
    [anon_sym_DASH] = ACTIONS(1624),
    [anon_sym_DASH_DASH] = ACTIONS(1622),
    [anon_sym_PLUS_PLUS] = ACTIONS(1622),
    [anon_sym_sizeof] = ACTIONS(1624),
    [sym_number_literal] = ACTIONS(1622),
    [sym_char_literal] = ACTIONS(1622),
    [sym_string_literal] = ACTIONS(1622),
    [sym_true] = ACTIONS(1624),
    [sym_false] = ACTIONS(1624),
    [sym_null] = ACTIONS(1624),
    [sym_identifier] = ACTIONS(1624),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(1624),
    [sym_auto] = ACTIONS(1624),
    [anon_sym_typename] = ACTIONS(1624),
    [anon_sym_new] = ACTIONS(1624),
    [anon_sym_COLON_COLON] = ACTIONS(1622),
    [anon_sym_delete] = ACTIONS(1624),
    [sym_nullptr] = ACTIONS(1624),
  },
  [2596] = {
    [sym_preproc_include] = STATE(913),
    [sym_preproc_def] = STATE(913),
    [sym_preproc_function_def] = STATE(913),
    [sym_preproc_call] = STATE(913),
    [sym_preproc_if_in_compound_statement] = STATE(410),
    [sym_preproc_ifdef_in_compound_statement] = STATE(411),
    [sym_declaration] = STATE(913),
    [sym_type_definition] = STATE(913),
    [sym__declaration_specifiers] = STATE(412),
    [sym_compound_statement] = STATE(913),
    [sym_storage_class_specifier] = STATE(419),
    [sym_type_qualifier] = STATE(419),
    [sym__type_specifier] = STATE(30),
    [sym_sized_type_specifier] = STATE(30),
    [sym_enum_specifier] = STATE(30),
    [sym_struct_specifier] = STATE(30),
    [sym_union_specifier] = STATE(30),
    [sym_labeled_statement] = STATE(913),
    [sym_expression_statement] = STATE(913),
    [sym_if_statement] = STATE(913),
    [sym_switch_statement] = STATE(913),
    [sym_case_statement] = STATE(913),
    [sym_while_statement] = STATE(913),
    [sym_do_statement] = STATE(913),
    [sym_for_statement] = STATE(913),
    [sym_return_statement] = STATE(913),
    [sym_break_statement] = STATE(913),
    [sym_continue_statement] = STATE(913),
    [sym_goto_statement] = STATE(913),
    [sym__expression] = STATE(413),
    [sym_comma_expression] = STATE(414),
    [sym_conditional_expression] = STATE(413),
    [sym_assignment_expression] = STATE(413),
    [sym_pointer_expression] = STATE(413),
    [sym_logical_expression] = STATE(413),
    [sym_bitwise_expression] = STATE(413),
    [sym_equality_expression] = STATE(413),
    [sym_relational_expression] = STATE(413),
    [sym_shift_expression] = STATE(413),
    [sym_math_expression] = STATE(413),
    [sym_cast_expression] = STATE(413),
    [sym_sizeof_expression] = STATE(413),
    [sym_subscript_expression] = STATE(413),
    [sym_call_expression] = STATE(413),
    [sym_field_expression] = STATE(413),
    [sym_compound_literal_expression] = STATE(413),
    [sym_parenthesized_expression] = STATE(413),
    [sym_concatenated_string] = STATE(413),
    [sym__empty_declaration] = STATE(913),
    [sym_macro_type_specifier] = STATE(30),
    [sym_class_specifier] = STATE(30),
    [sym_dependent_type] = STATE(30),
    [sym_structured_binding_declaration] = STATE(913),
    [sym_template_type] = STATE(415),
    [sym_template_function] = STATE(413),
    [sym_for_range_loop] = STATE(913),
    [sym_new_expression] = STATE(413),
    [sym_delete_expression] = STATE(413),
    [sym_lambda_expression] = STATE(413),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(416),
    [sym_scoped_namespace_identifier] = STATE(417),
    [aux_sym_preproc_if_in_compound_statement_repeat1] = STATE(913),
    [aux_sym__declaration_specifiers_repeat1] = STATE(419),
    [aux_sym_sized_type_specifier_repeat1] = STATE(38),
    [sym_raw_string_literal] = ACTIONS(620),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(622),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(624),
    [anon_sym_LPAREN] = ACTIONS(626),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(628),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(630),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(632),
    [sym_preproc_directive] = ACTIONS(634),
    [anon_sym_SEMI] = ACTIONS(636),
    [anon_sym_typedef] = ACTIONS(638),
    [anon_sym_extern] = ACTIONS(154),
    [anon_sym_LBRACE] = ACTIONS(640),
    [anon_sym_RBRACE] = ACTIONS(6573),
    [anon_sym_STAR] = ACTIONS(644),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_static] = ACTIONS(154),
    [anon_sym_register] = ACTIONS(154),
    [anon_sym_inline] = ACTIONS(154),
    [anon_sym_const] = ACTIONS(158),
    [anon_sym_restrict] = ACTIONS(158),
    [anon_sym_volatile] = ACTIONS(158),
    [anon_sym__Atomic] = ACTIONS(158),
    [anon_sym_mutable] = ACTIONS(158),
    [anon_sym_explicit] = ACTIONS(158),
    [anon_sym_constexpr] = ACTIONS(158),
    [anon_sym_unsigned] = ACTIONS(31),
    [anon_sym_long] = ACTIONS(31),
    [anon_sym_short] = ACTIONS(31),
    [sym_primitive_type] = ACTIONS(33),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_union] = ACTIONS(39),
    [anon_sym_if] = ACTIONS(646),
    [anon_sym_switch] = ACTIONS(648),
    [anon_sym_case] = ACTIONS(650),
    [anon_sym_default] = ACTIONS(652),
    [anon_sym_while] = ACTIONS(654),
    [anon_sym_do] = ACTIONS(656),
    [anon_sym_for] = ACTIONS(658),
    [anon_sym_return] = ACTIONS(660),
    [anon_sym_break] = ACTIONS(662),
    [anon_sym_continue] = ACTIONS(664),
    [anon_sym_goto] = ACTIONS(666),
    [anon_sym_AMP] = ACTIONS(644),
    [anon_sym_BANG] = ACTIONS(668),
    [anon_sym_TILDE] = ACTIONS(670),
    [anon_sym_PLUS] = ACTIONS(672),
    [anon_sym_DASH] = ACTIONS(672),
    [anon_sym_DASH_DASH] = ACTIONS(674),
    [anon_sym_PLUS_PLUS] = ACTIONS(674),
    [anon_sym_sizeof] = ACTIONS(676),
    [sym_number_literal] = ACTIONS(620),
    [sym_char_literal] = ACTIONS(620),
    [sym_string_literal] = ACTIONS(678),
    [sym_true] = ACTIONS(680),
    [sym_false] = ACTIONS(680),
    [sym_null] = ACTIONS(680),
    [sym_identifier] = ACTIONS(682),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(51),
    [sym_auto] = ACTIONS(33),
    [anon_sym_typename] = ACTIONS(53),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(684),
    [anon_sym_delete] = ACTIONS(686),
    [sym_nullptr] = ACTIONS(680),
  },
  [2597] = {
    [sym__expression] = STATE(2754),
    [sym_conditional_expression] = STATE(2754),
    [sym_assignment_expression] = STATE(2754),
    [sym_pointer_expression] = STATE(2754),
    [sym_logical_expression] = STATE(2754),
    [sym_bitwise_expression] = STATE(2754),
    [sym_equality_expression] = STATE(2754),
    [sym_relational_expression] = STATE(2754),
    [sym_shift_expression] = STATE(2754),
    [sym_math_expression] = STATE(2754),
    [sym_cast_expression] = STATE(2754),
    [sym_sizeof_expression] = STATE(2754),
    [sym_subscript_expression] = STATE(2754),
    [sym_call_expression] = STATE(2754),
    [sym_field_expression] = STATE(2754),
    [sym_compound_literal_expression] = STATE(2754),
    [sym_parenthesized_expression] = STATE(2754),
    [sym_concatenated_string] = STATE(2754),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(2754),
    [sym_new_expression] = STATE(2754),
    [sym_delete_expression] = STATE(2754),
    [sym_lambda_expression] = STATE(2754),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(6575),
    [anon_sym_LPAREN] = ACTIONS(2943),
    [anon_sym_STAR] = ACTIONS(2945),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_AMP] = ACTIONS(2945),
    [anon_sym_BANG] = ACTIONS(2947),
    [anon_sym_TILDE] = ACTIONS(2949),
    [anon_sym_PLUS] = ACTIONS(2951),
    [anon_sym_DASH] = ACTIONS(2951),
    [anon_sym_DASH_DASH] = ACTIONS(2953),
    [anon_sym_PLUS_PLUS] = ACTIONS(2953),
    [anon_sym_sizeof] = ACTIONS(2955),
    [sym_number_literal] = ACTIONS(6575),
    [sym_char_literal] = ACTIONS(6575),
    [sym_string_literal] = ACTIONS(2957),
    [sym_true] = ACTIONS(6577),
    [sym_false] = ACTIONS(6577),
    [sym_null] = ACTIONS(6577),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(2961),
    [anon_sym_delete] = ACTIONS(2963),
    [sym_nullptr] = ACTIONS(6577),
  },
  [2598] = {
    [anon_sym_LPAREN] = ACTIONS(6579),
    [sym_comment] = ACTIONS(49),
  },
  [2599] = {
    [sym__expression] = STATE(2756),
    [sym_conditional_expression] = STATE(2756),
    [sym_assignment_expression] = STATE(2756),
    [sym_pointer_expression] = STATE(2756),
    [sym_logical_expression] = STATE(2756),
    [sym_bitwise_expression] = STATE(2756),
    [sym_equality_expression] = STATE(2756),
    [sym_relational_expression] = STATE(2756),
    [sym_shift_expression] = STATE(2756),
    [sym_math_expression] = STATE(2756),
    [sym_cast_expression] = STATE(2756),
    [sym_sizeof_expression] = STATE(2756),
    [sym_subscript_expression] = STATE(2756),
    [sym_call_expression] = STATE(2756),
    [sym_field_expression] = STATE(2756),
    [sym_compound_literal_expression] = STATE(2756),
    [sym_parenthesized_expression] = STATE(2756),
    [sym_concatenated_string] = STATE(2756),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(2756),
    [sym_new_expression] = STATE(2756),
    [sym_delete_expression] = STATE(2756),
    [sym_lambda_expression] = STATE(2756),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(6581),
    [anon_sym_LPAREN] = ACTIONS(2943),
    [anon_sym_STAR] = ACTIONS(2945),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_AMP] = ACTIONS(2945),
    [anon_sym_BANG] = ACTIONS(2947),
    [anon_sym_TILDE] = ACTIONS(2949),
    [anon_sym_PLUS] = ACTIONS(2951),
    [anon_sym_DASH] = ACTIONS(2951),
    [anon_sym_DASH_DASH] = ACTIONS(2953),
    [anon_sym_PLUS_PLUS] = ACTIONS(2953),
    [anon_sym_sizeof] = ACTIONS(2955),
    [sym_number_literal] = ACTIONS(6581),
    [sym_char_literal] = ACTIONS(6581),
    [sym_string_literal] = ACTIONS(2957),
    [sym_true] = ACTIONS(6583),
    [sym_false] = ACTIONS(6583),
    [sym_null] = ACTIONS(6583),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(2961),
    [anon_sym_delete] = ACTIONS(2963),
    [sym_nullptr] = ACTIONS(6583),
  },
  [2600] = {
    [sym_argument_list] = STATE(802),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_STAR] = ACTIONS(3003),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_EQ] = ACTIONS(3005),
    [anon_sym_COLON] = ACTIONS(6585),
    [anon_sym_QMARK] = ACTIONS(3009),
    [anon_sym_STAR_EQ] = ACTIONS(3011),
    [anon_sym_SLASH_EQ] = ACTIONS(3011),
    [anon_sym_PERCENT_EQ] = ACTIONS(3011),
    [anon_sym_PLUS_EQ] = ACTIONS(3011),
    [anon_sym_DASH_EQ] = ACTIONS(3011),
    [anon_sym_LT_LT_EQ] = ACTIONS(3011),
    [anon_sym_GT_GT_EQ] = ACTIONS(3011),
    [anon_sym_AMP_EQ] = ACTIONS(3011),
    [anon_sym_CARET_EQ] = ACTIONS(3011),
    [anon_sym_PIPE_EQ] = ACTIONS(3011),
    [anon_sym_AMP] = ACTIONS(3013),
    [anon_sym_PIPE_PIPE] = ACTIONS(3015),
    [anon_sym_AMP_AMP] = ACTIONS(3017),
    [anon_sym_PIPE] = ACTIONS(3019),
    [anon_sym_CARET] = ACTIONS(3021),
    [anon_sym_EQ_EQ] = ACTIONS(3023),
    [anon_sym_BANG_EQ] = ACTIONS(3023),
    [anon_sym_LT] = ACTIONS(3025),
    [anon_sym_GT] = ACTIONS(3025),
    [anon_sym_LT_EQ] = ACTIONS(3027),
    [anon_sym_GT_EQ] = ACTIONS(3027),
    [anon_sym_LT_LT] = ACTIONS(3029),
    [anon_sym_GT_GT] = ACTIONS(3029),
    [anon_sym_PLUS] = ACTIONS(3031),
    [anon_sym_DASH] = ACTIONS(3031),
    [anon_sym_SLASH] = ACTIONS(3003),
    [anon_sym_PERCENT] = ACTIONS(3003),
    [anon_sym_DASH_DASH] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(3033),
    [anon_sym_DASH_GT] = ACTIONS(3033),
    [sym_comment] = ACTIONS(49),
  },
  [2601] = {
    [sym_declaration] = STATE(2760),
    [sym_type_definition] = STATE(2760),
    [sym__declaration_specifiers] = STATE(2761),
    [sym_compound_statement] = STATE(2760),
    [sym_storage_class_specifier] = STATE(109),
    [sym_type_qualifier] = STATE(109),
    [sym__type_specifier] = STATE(105),
    [sym_sized_type_specifier] = STATE(105),
    [sym_enum_specifier] = STATE(105),
    [sym_struct_specifier] = STATE(105),
    [sym_union_specifier] = STATE(105),
    [sym_labeled_statement] = STATE(2760),
    [sym_expression_statement] = STATE(2760),
    [sym_if_statement] = STATE(2760),
    [sym_switch_statement] = STATE(2760),
    [sym_case_statement] = STATE(2760),
    [sym_while_statement] = STATE(2760),
    [sym_do_statement] = STATE(2760),
    [sym_for_statement] = STATE(2760),
    [sym_return_statement] = STATE(2760),
    [sym_break_statement] = STATE(2760),
    [sym_continue_statement] = STATE(2760),
    [sym_goto_statement] = STATE(2760),
    [sym__expression] = STATE(2378),
    [sym_comma_expression] = STATE(2379),
    [sym_conditional_expression] = STATE(2378),
    [sym_assignment_expression] = STATE(2378),
    [sym_pointer_expression] = STATE(2378),
    [sym_logical_expression] = STATE(2378),
    [sym_bitwise_expression] = STATE(2378),
    [sym_equality_expression] = STATE(2378),
    [sym_relational_expression] = STATE(2378),
    [sym_shift_expression] = STATE(2378),
    [sym_math_expression] = STATE(2378),
    [sym_cast_expression] = STATE(2378),
    [sym_sizeof_expression] = STATE(2378),
    [sym_subscript_expression] = STATE(2378),
    [sym_call_expression] = STATE(2378),
    [sym_field_expression] = STATE(2378),
    [sym_compound_literal_expression] = STATE(2378),
    [sym_parenthesized_expression] = STATE(2378),
    [sym_concatenated_string] = STATE(2378),
    [sym_macro_type_specifier] = STATE(105),
    [sym_class_specifier] = STATE(105),
    [sym_dependent_type] = STATE(105),
    [sym_template_type] = STATE(1475),
    [sym_template_function] = STATE(2378),
    [sym_for_range_loop] = STATE(2760),
    [sym_new_expression] = STATE(2378),
    [sym_delete_expression] = STATE(2378),
    [sym_lambda_expression] = STATE(2378),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(416),
    [sym_scoped_namespace_identifier] = STATE(1476),
    [aux_sym__declaration_specifiers_repeat1] = STATE(109),
    [aux_sym_sized_type_specifier_repeat1] = STATE(110),
    [sym_raw_string_literal] = ACTIONS(5538),
    [anon_sym_LPAREN] = ACTIONS(626),
    [anon_sym_SEMI] = ACTIONS(5540),
    [anon_sym_typedef] = ACTIONS(6587),
    [anon_sym_extern] = ACTIONS(154),
    [anon_sym_LBRACE] = ACTIONS(5542),
    [anon_sym_STAR] = ACTIONS(644),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_static] = ACTIONS(154),
    [anon_sym_register] = ACTIONS(154),
    [anon_sym_inline] = ACTIONS(154),
    [anon_sym_const] = ACTIONS(158),
    [anon_sym_restrict] = ACTIONS(158),
    [anon_sym_volatile] = ACTIONS(158),
    [anon_sym__Atomic] = ACTIONS(158),
    [anon_sym_mutable] = ACTIONS(158),
    [anon_sym_explicit] = ACTIONS(158),
    [anon_sym_constexpr] = ACTIONS(158),
    [anon_sym_unsigned] = ACTIONS(160),
    [anon_sym_long] = ACTIONS(160),
    [anon_sym_short] = ACTIONS(160),
    [sym_primitive_type] = ACTIONS(162),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_union] = ACTIONS(39),
    [anon_sym_if] = ACTIONS(5544),
    [anon_sym_switch] = ACTIONS(5546),
    [anon_sym_case] = ACTIONS(5548),
    [anon_sym_default] = ACTIONS(5550),
    [anon_sym_while] = ACTIONS(5552),
    [anon_sym_do] = ACTIONS(5554),
    [anon_sym_for] = ACTIONS(5556),
    [anon_sym_return] = ACTIONS(5558),
    [anon_sym_break] = ACTIONS(5560),
    [anon_sym_continue] = ACTIONS(5562),
    [anon_sym_goto] = ACTIONS(5564),
    [anon_sym_AMP] = ACTIONS(644),
    [anon_sym_BANG] = ACTIONS(668),
    [anon_sym_TILDE] = ACTIONS(670),
    [anon_sym_PLUS] = ACTIONS(672),
    [anon_sym_DASH] = ACTIONS(672),
    [anon_sym_DASH_DASH] = ACTIONS(674),
    [anon_sym_PLUS_PLUS] = ACTIONS(674),
    [anon_sym_sizeof] = ACTIONS(676),
    [sym_number_literal] = ACTIONS(5538),
    [sym_char_literal] = ACTIONS(5538),
    [sym_string_literal] = ACTIONS(678),
    [sym_true] = ACTIONS(5566),
    [sym_false] = ACTIONS(5566),
    [sym_null] = ACTIONS(5566),
    [sym_identifier] = ACTIONS(6589),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(51),
    [sym_auto] = ACTIONS(162),
    [anon_sym_typename] = ACTIONS(172),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(3040),
    [anon_sym_delete] = ACTIONS(686),
    [sym_nullptr] = ACTIONS(5566),
  },
  [2602] = {
    [sym__expression] = STATE(2762),
    [sym_conditional_expression] = STATE(2762),
    [sym_assignment_expression] = STATE(2762),
    [sym_pointer_expression] = STATE(2762),
    [sym_logical_expression] = STATE(2762),
    [sym_bitwise_expression] = STATE(2762),
    [sym_equality_expression] = STATE(2762),
    [sym_relational_expression] = STATE(2762),
    [sym_shift_expression] = STATE(2762),
    [sym_math_expression] = STATE(2762),
    [sym_cast_expression] = STATE(2762),
    [sym_sizeof_expression] = STATE(2762),
    [sym_subscript_expression] = STATE(2762),
    [sym_call_expression] = STATE(2762),
    [sym_field_expression] = STATE(2762),
    [sym_compound_literal_expression] = STATE(2762),
    [sym_parenthesized_expression] = STATE(2762),
    [sym_concatenated_string] = STATE(2762),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(2762),
    [sym_new_expression] = STATE(2762),
    [sym_delete_expression] = STATE(2762),
    [sym_lambda_expression] = STATE(2762),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(6591),
    [anon_sym_LPAREN] = ACTIONS(2943),
    [anon_sym_STAR] = ACTIONS(2945),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_AMP] = ACTIONS(2945),
    [anon_sym_BANG] = ACTIONS(2947),
    [anon_sym_TILDE] = ACTIONS(2949),
    [anon_sym_PLUS] = ACTIONS(2951),
    [anon_sym_DASH] = ACTIONS(2951),
    [anon_sym_DASH_DASH] = ACTIONS(2953),
    [anon_sym_PLUS_PLUS] = ACTIONS(2953),
    [anon_sym_sizeof] = ACTIONS(2955),
    [sym_number_literal] = ACTIONS(6591),
    [sym_char_literal] = ACTIONS(6591),
    [sym_string_literal] = ACTIONS(2957),
    [sym_true] = ACTIONS(6593),
    [sym_false] = ACTIONS(6593),
    [sym_null] = ACTIONS(6593),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(2961),
    [anon_sym_delete] = ACTIONS(2963),
    [sym_nullptr] = ACTIONS(6593),
  },
  [2603] = {
    [anon_sym_while] = ACTIONS(6595),
    [sym_comment] = ACTIONS(49),
  },
  [2604] = {
    [sym_declaration] = STATE(2764),
    [sym__declaration_specifiers] = STATE(1500),
    [sym_storage_class_specifier] = STATE(109),
    [sym_type_qualifier] = STATE(109),
    [sym__type_specifier] = STATE(105),
    [sym_sized_type_specifier] = STATE(105),
    [sym_enum_specifier] = STATE(105),
    [sym_struct_specifier] = STATE(105),
    [sym_union_specifier] = STATE(105),
    [sym__expression] = STATE(2765),
    [sym_conditional_expression] = STATE(2765),
    [sym_assignment_expression] = STATE(2765),
    [sym_pointer_expression] = STATE(2765),
    [sym_logical_expression] = STATE(2765),
    [sym_bitwise_expression] = STATE(2765),
    [sym_equality_expression] = STATE(2765),
    [sym_relational_expression] = STATE(2765),
    [sym_shift_expression] = STATE(2765),
    [sym_math_expression] = STATE(2765),
    [sym_cast_expression] = STATE(2765),
    [sym_sizeof_expression] = STATE(2765),
    [sym_subscript_expression] = STATE(2765),
    [sym_call_expression] = STATE(2765),
    [sym_field_expression] = STATE(2765),
    [sym_compound_literal_expression] = STATE(2765),
    [sym_parenthesized_expression] = STATE(2765),
    [sym_concatenated_string] = STATE(2765),
    [sym_macro_type_specifier] = STATE(105),
    [sym_class_specifier] = STATE(105),
    [sym_dependent_type] = STATE(105),
    [sym_template_type] = STATE(1475),
    [sym_template_function] = STATE(2765),
    [sym_for_range_declaration] = STATE(2766),
    [sym_new_expression] = STATE(2765),
    [sym_delete_expression] = STATE(2765),
    [sym_lambda_expression] = STATE(2765),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(416),
    [sym_scoped_namespace_identifier] = STATE(1476),
    [aux_sym__declaration_specifiers_repeat1] = STATE(109),
    [aux_sym_sized_type_specifier_repeat1] = STATE(110),
    [sym_raw_string_literal] = ACTIONS(6597),
    [anon_sym_LPAREN] = ACTIONS(1347),
    [anon_sym_SEMI] = ACTIONS(6599),
    [anon_sym_extern] = ACTIONS(154),
    [anon_sym_STAR] = ACTIONS(1349),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_static] = ACTIONS(154),
    [anon_sym_register] = ACTIONS(154),
    [anon_sym_inline] = ACTIONS(154),
    [anon_sym_const] = ACTIONS(158),
    [anon_sym_restrict] = ACTIONS(158),
    [anon_sym_volatile] = ACTIONS(158),
    [anon_sym__Atomic] = ACTIONS(158),
    [anon_sym_mutable] = ACTIONS(158),
    [anon_sym_explicit] = ACTIONS(158),
    [anon_sym_constexpr] = ACTIONS(158),
    [anon_sym_unsigned] = ACTIONS(160),
    [anon_sym_long] = ACTIONS(160),
    [anon_sym_short] = ACTIONS(160),
    [sym_primitive_type] = ACTIONS(162),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_union] = ACTIONS(39),
    [anon_sym_AMP] = ACTIONS(1349),
    [anon_sym_BANG] = ACTIONS(1351),
    [anon_sym_TILDE] = ACTIONS(1353),
    [anon_sym_PLUS] = ACTIONS(1355),
    [anon_sym_DASH] = ACTIONS(1355),
    [anon_sym_DASH_DASH] = ACTIONS(1357),
    [anon_sym_PLUS_PLUS] = ACTIONS(1357),
    [anon_sym_sizeof] = ACTIONS(1359),
    [sym_number_literal] = ACTIONS(6597),
    [sym_char_literal] = ACTIONS(6597),
    [sym_string_literal] = ACTIONS(1361),
    [sym_true] = ACTIONS(6601),
    [sym_false] = ACTIONS(6601),
    [sym_null] = ACTIONS(6601),
    [sym_identifier] = ACTIONS(3088),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(51),
    [sym_auto] = ACTIONS(162),
    [anon_sym_typename] = ACTIONS(172),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(3090),
    [anon_sym_delete] = ACTIONS(1367),
    [sym_nullptr] = ACTIONS(6601),
  },
  [2605] = {
    [sym_raw_string_literal] = ACTIONS(3092),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3094),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3094),
    [anon_sym_LPAREN] = ACTIONS(3092),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3094),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3094),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3094),
    [sym_preproc_directive] = ACTIONS(3094),
    [anon_sym_SEMI] = ACTIONS(3092),
    [anon_sym_typedef] = ACTIONS(3094),
    [anon_sym_extern] = ACTIONS(3094),
    [anon_sym_LBRACE] = ACTIONS(3092),
    [anon_sym_RBRACE] = ACTIONS(3092),
    [anon_sym_STAR] = ACTIONS(3092),
    [anon_sym_LBRACK] = ACTIONS(3092),
    [anon_sym_static] = ACTIONS(3094),
    [anon_sym_register] = ACTIONS(3094),
    [anon_sym_inline] = ACTIONS(3094),
    [anon_sym_const] = ACTIONS(3094),
    [anon_sym_restrict] = ACTIONS(3094),
    [anon_sym_volatile] = ACTIONS(3094),
    [anon_sym__Atomic] = ACTIONS(3094),
    [anon_sym_mutable] = ACTIONS(3094),
    [anon_sym_explicit] = ACTIONS(3094),
    [anon_sym_constexpr] = ACTIONS(3094),
    [anon_sym_unsigned] = ACTIONS(3094),
    [anon_sym_long] = ACTIONS(3094),
    [anon_sym_short] = ACTIONS(3094),
    [sym_primitive_type] = ACTIONS(3094),
    [anon_sym_enum] = ACTIONS(3094),
    [anon_sym_struct] = ACTIONS(3094),
    [anon_sym_union] = ACTIONS(3094),
    [anon_sym_if] = ACTIONS(3094),
    [anon_sym_else] = ACTIONS(3094),
    [anon_sym_switch] = ACTIONS(3094),
    [anon_sym_case] = ACTIONS(3094),
    [anon_sym_default] = ACTIONS(3094),
    [anon_sym_while] = ACTIONS(3094),
    [anon_sym_do] = ACTIONS(3094),
    [anon_sym_for] = ACTIONS(3094),
    [anon_sym_return] = ACTIONS(3094),
    [anon_sym_break] = ACTIONS(3094),
    [anon_sym_continue] = ACTIONS(3094),
    [anon_sym_goto] = ACTIONS(3094),
    [anon_sym_AMP] = ACTIONS(3092),
    [anon_sym_BANG] = ACTIONS(3092),
    [anon_sym_TILDE] = ACTIONS(3092),
    [anon_sym_PLUS] = ACTIONS(3094),
    [anon_sym_DASH] = ACTIONS(3094),
    [anon_sym_DASH_DASH] = ACTIONS(3092),
    [anon_sym_PLUS_PLUS] = ACTIONS(3092),
    [anon_sym_sizeof] = ACTIONS(3094),
    [sym_number_literal] = ACTIONS(3092),
    [sym_char_literal] = ACTIONS(3092),
    [sym_string_literal] = ACTIONS(3092),
    [sym_true] = ACTIONS(3094),
    [sym_false] = ACTIONS(3094),
    [sym_null] = ACTIONS(3094),
    [sym_identifier] = ACTIONS(3094),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(3094),
    [sym_auto] = ACTIONS(3094),
    [anon_sym_typename] = ACTIONS(3094),
    [anon_sym_new] = ACTIONS(3094),
    [anon_sym_COLON_COLON] = ACTIONS(3092),
    [anon_sym_delete] = ACTIONS(3094),
    [sym_nullptr] = ACTIONS(3094),
  },
  [2606] = {
    [sym_argument_list] = STATE(802),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_SEMI] = ACTIONS(6603),
    [anon_sym_STAR] = ACTIONS(2553),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_EQ] = ACTIONS(2555),
    [anon_sym_QMARK] = ACTIONS(2557),
    [anon_sym_STAR_EQ] = ACTIONS(2559),
    [anon_sym_SLASH_EQ] = ACTIONS(2559),
    [anon_sym_PERCENT_EQ] = ACTIONS(2559),
    [anon_sym_PLUS_EQ] = ACTIONS(2559),
    [anon_sym_DASH_EQ] = ACTIONS(2559),
    [anon_sym_LT_LT_EQ] = ACTIONS(2559),
    [anon_sym_GT_GT_EQ] = ACTIONS(2559),
    [anon_sym_AMP_EQ] = ACTIONS(2559),
    [anon_sym_CARET_EQ] = ACTIONS(2559),
    [anon_sym_PIPE_EQ] = ACTIONS(2559),
    [anon_sym_AMP] = ACTIONS(2561),
    [anon_sym_PIPE_PIPE] = ACTIONS(2563),
    [anon_sym_AMP_AMP] = ACTIONS(2565),
    [anon_sym_PIPE] = ACTIONS(2567),
    [anon_sym_CARET] = ACTIONS(2569),
    [anon_sym_EQ_EQ] = ACTIONS(2571),
    [anon_sym_BANG_EQ] = ACTIONS(2571),
    [anon_sym_LT] = ACTIONS(2573),
    [anon_sym_GT] = ACTIONS(2573),
    [anon_sym_LT_EQ] = ACTIONS(2575),
    [anon_sym_GT_EQ] = ACTIONS(2575),
    [anon_sym_LT_LT] = ACTIONS(2577),
    [anon_sym_GT_GT] = ACTIONS(2577),
    [anon_sym_PLUS] = ACTIONS(2579),
    [anon_sym_DASH] = ACTIONS(2579),
    [anon_sym_SLASH] = ACTIONS(2553),
    [anon_sym_PERCENT] = ACTIONS(2553),
    [anon_sym_DASH_DASH] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(1554),
    [anon_sym_DASH_GT] = ACTIONS(1554),
    [sym_comment] = ACTIONS(49),
  },
  [2607] = {
    [anon_sym_SEMI] = ACTIONS(6603),
    [sym_comment] = ACTIONS(49),
  },
  [2608] = {
    [sym_raw_string_literal] = ACTIONS(3098),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3100),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3100),
    [anon_sym_LPAREN] = ACTIONS(3098),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3100),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3100),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3100),
    [sym_preproc_directive] = ACTIONS(3100),
    [anon_sym_SEMI] = ACTIONS(3098),
    [anon_sym_typedef] = ACTIONS(3100),
    [anon_sym_extern] = ACTIONS(3100),
    [anon_sym_LBRACE] = ACTIONS(3098),
    [anon_sym_RBRACE] = ACTIONS(3098),
    [anon_sym_STAR] = ACTIONS(3098),
    [anon_sym_LBRACK] = ACTIONS(3098),
    [anon_sym_static] = ACTIONS(3100),
    [anon_sym_register] = ACTIONS(3100),
    [anon_sym_inline] = ACTIONS(3100),
    [anon_sym_const] = ACTIONS(3100),
    [anon_sym_restrict] = ACTIONS(3100),
    [anon_sym_volatile] = ACTIONS(3100),
    [anon_sym__Atomic] = ACTIONS(3100),
    [anon_sym_mutable] = ACTIONS(3100),
    [anon_sym_explicit] = ACTIONS(3100),
    [anon_sym_constexpr] = ACTIONS(3100),
    [anon_sym_unsigned] = ACTIONS(3100),
    [anon_sym_long] = ACTIONS(3100),
    [anon_sym_short] = ACTIONS(3100),
    [sym_primitive_type] = ACTIONS(3100),
    [anon_sym_enum] = ACTIONS(3100),
    [anon_sym_struct] = ACTIONS(3100),
    [anon_sym_union] = ACTIONS(3100),
    [anon_sym_if] = ACTIONS(3100),
    [anon_sym_else] = ACTIONS(3100),
    [anon_sym_switch] = ACTIONS(3100),
    [anon_sym_case] = ACTIONS(3100),
    [anon_sym_default] = ACTIONS(3100),
    [anon_sym_while] = ACTIONS(3100),
    [anon_sym_do] = ACTIONS(3100),
    [anon_sym_for] = ACTIONS(3100),
    [anon_sym_return] = ACTIONS(3100),
    [anon_sym_break] = ACTIONS(3100),
    [anon_sym_continue] = ACTIONS(3100),
    [anon_sym_goto] = ACTIONS(3100),
    [anon_sym_AMP] = ACTIONS(3098),
    [anon_sym_BANG] = ACTIONS(3098),
    [anon_sym_TILDE] = ACTIONS(3098),
    [anon_sym_PLUS] = ACTIONS(3100),
    [anon_sym_DASH] = ACTIONS(3100),
    [anon_sym_DASH_DASH] = ACTIONS(3098),
    [anon_sym_PLUS_PLUS] = ACTIONS(3098),
    [anon_sym_sizeof] = ACTIONS(3100),
    [sym_number_literal] = ACTIONS(3098),
    [sym_char_literal] = ACTIONS(3098),
    [sym_string_literal] = ACTIONS(3098),
    [sym_true] = ACTIONS(3100),
    [sym_false] = ACTIONS(3100),
    [sym_null] = ACTIONS(3100),
    [sym_identifier] = ACTIONS(3100),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(3100),
    [sym_auto] = ACTIONS(3100),
    [anon_sym_typename] = ACTIONS(3100),
    [anon_sym_new] = ACTIONS(3100),
    [anon_sym_COLON_COLON] = ACTIONS(3098),
    [anon_sym_delete] = ACTIONS(3100),
    [sym_nullptr] = ACTIONS(3100),
  },
  [2609] = {
    [sym_raw_string_literal] = ACTIONS(3102),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3104),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3104),
    [anon_sym_LPAREN] = ACTIONS(3102),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3104),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3104),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3104),
    [sym_preproc_directive] = ACTIONS(3104),
    [anon_sym_SEMI] = ACTIONS(3102),
    [anon_sym_typedef] = ACTIONS(3104),
    [anon_sym_extern] = ACTIONS(3104),
    [anon_sym_LBRACE] = ACTIONS(3102),
    [anon_sym_RBRACE] = ACTIONS(3102),
    [anon_sym_STAR] = ACTIONS(3102),
    [anon_sym_LBRACK] = ACTIONS(3102),
    [anon_sym_static] = ACTIONS(3104),
    [anon_sym_register] = ACTIONS(3104),
    [anon_sym_inline] = ACTIONS(3104),
    [anon_sym_const] = ACTIONS(3104),
    [anon_sym_restrict] = ACTIONS(3104),
    [anon_sym_volatile] = ACTIONS(3104),
    [anon_sym__Atomic] = ACTIONS(3104),
    [anon_sym_mutable] = ACTIONS(3104),
    [anon_sym_explicit] = ACTIONS(3104),
    [anon_sym_constexpr] = ACTIONS(3104),
    [anon_sym_unsigned] = ACTIONS(3104),
    [anon_sym_long] = ACTIONS(3104),
    [anon_sym_short] = ACTIONS(3104),
    [sym_primitive_type] = ACTIONS(3104),
    [anon_sym_enum] = ACTIONS(3104),
    [anon_sym_struct] = ACTIONS(3104),
    [anon_sym_union] = ACTIONS(3104),
    [anon_sym_if] = ACTIONS(3104),
    [anon_sym_else] = ACTIONS(3104),
    [anon_sym_switch] = ACTIONS(3104),
    [anon_sym_case] = ACTIONS(3104),
    [anon_sym_default] = ACTIONS(3104),
    [anon_sym_while] = ACTIONS(3104),
    [anon_sym_do] = ACTIONS(3104),
    [anon_sym_for] = ACTIONS(3104),
    [anon_sym_return] = ACTIONS(3104),
    [anon_sym_break] = ACTIONS(3104),
    [anon_sym_continue] = ACTIONS(3104),
    [anon_sym_goto] = ACTIONS(3104),
    [anon_sym_AMP] = ACTIONS(3102),
    [anon_sym_BANG] = ACTIONS(3102),
    [anon_sym_TILDE] = ACTIONS(3102),
    [anon_sym_PLUS] = ACTIONS(3104),
    [anon_sym_DASH] = ACTIONS(3104),
    [anon_sym_DASH_DASH] = ACTIONS(3102),
    [anon_sym_PLUS_PLUS] = ACTIONS(3102),
    [anon_sym_sizeof] = ACTIONS(3104),
    [sym_number_literal] = ACTIONS(3102),
    [sym_char_literal] = ACTIONS(3102),
    [sym_string_literal] = ACTIONS(3102),
    [sym_true] = ACTIONS(3104),
    [sym_false] = ACTIONS(3104),
    [sym_null] = ACTIONS(3104),
    [sym_identifier] = ACTIONS(3104),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(3104),
    [sym_auto] = ACTIONS(3104),
    [anon_sym_typename] = ACTIONS(3104),
    [anon_sym_new] = ACTIONS(3104),
    [anon_sym_COLON_COLON] = ACTIONS(3102),
    [anon_sym_delete] = ACTIONS(3104),
    [sym_nullptr] = ACTIONS(3104),
  },
  [2610] = {
    [anon_sym_SEMI] = ACTIONS(6605),
    [sym_comment] = ACTIONS(49),
  },
  [2611] = {
    [sym_compound_statement] = STATE(2769),
    [sym_labeled_statement] = STATE(2769),
    [sym_expression_statement] = STATE(2769),
    [sym_if_statement] = STATE(2769),
    [sym_switch_statement] = STATE(2769),
    [sym_case_statement] = STATE(2769),
    [sym_while_statement] = STATE(2769),
    [sym_do_statement] = STATE(2769),
    [sym_for_statement] = STATE(2769),
    [sym_return_statement] = STATE(2769),
    [sym_break_statement] = STATE(2769),
    [sym_continue_statement] = STATE(2769),
    [sym_goto_statement] = STATE(2769),
    [sym__expression] = STATE(2378),
    [sym_comma_expression] = STATE(2379),
    [sym_conditional_expression] = STATE(2378),
    [sym_assignment_expression] = STATE(2378),
    [sym_pointer_expression] = STATE(2378),
    [sym_logical_expression] = STATE(2378),
    [sym_bitwise_expression] = STATE(2378),
    [sym_equality_expression] = STATE(2378),
    [sym_relational_expression] = STATE(2378),
    [sym_shift_expression] = STATE(2378),
    [sym_math_expression] = STATE(2378),
    [sym_cast_expression] = STATE(2378),
    [sym_sizeof_expression] = STATE(2378),
    [sym_subscript_expression] = STATE(2378),
    [sym_call_expression] = STATE(2378),
    [sym_field_expression] = STATE(2378),
    [sym_compound_literal_expression] = STATE(2378),
    [sym_parenthesized_expression] = STATE(2378),
    [sym_concatenated_string] = STATE(2378),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(2378),
    [sym_for_range_loop] = STATE(2769),
    [sym_new_expression] = STATE(2378),
    [sym_delete_expression] = STATE(2378),
    [sym_lambda_expression] = STATE(2378),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(5538),
    [anon_sym_LPAREN] = ACTIONS(626),
    [anon_sym_SEMI] = ACTIONS(5540),
    [anon_sym_LBRACE] = ACTIONS(5542),
    [anon_sym_STAR] = ACTIONS(644),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_if] = ACTIONS(5544),
    [anon_sym_switch] = ACTIONS(5546),
    [anon_sym_case] = ACTIONS(5548),
    [anon_sym_default] = ACTIONS(5550),
    [anon_sym_while] = ACTIONS(5552),
    [anon_sym_do] = ACTIONS(5554),
    [anon_sym_for] = ACTIONS(5556),
    [anon_sym_return] = ACTIONS(5558),
    [anon_sym_break] = ACTIONS(5560),
    [anon_sym_continue] = ACTIONS(5562),
    [anon_sym_goto] = ACTIONS(5564),
    [anon_sym_AMP] = ACTIONS(644),
    [anon_sym_BANG] = ACTIONS(668),
    [anon_sym_TILDE] = ACTIONS(670),
    [anon_sym_PLUS] = ACTIONS(672),
    [anon_sym_DASH] = ACTIONS(672),
    [anon_sym_DASH_DASH] = ACTIONS(674),
    [anon_sym_PLUS_PLUS] = ACTIONS(674),
    [anon_sym_sizeof] = ACTIONS(676),
    [sym_number_literal] = ACTIONS(5538),
    [sym_char_literal] = ACTIONS(5538),
    [sym_string_literal] = ACTIONS(678),
    [sym_true] = ACTIONS(5566),
    [sym_false] = ACTIONS(5566),
    [sym_null] = ACTIONS(5566),
    [sym_identifier] = ACTIONS(5568),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1303),
    [anon_sym_delete] = ACTIONS(686),
    [sym_nullptr] = ACTIONS(5566),
  },
  [2612] = {
    [sym_compound_statement] = STATE(2770),
    [sym_labeled_statement] = STATE(2770),
    [sym_expression_statement] = STATE(2770),
    [sym_if_statement] = STATE(2770),
    [sym_switch_statement] = STATE(2770),
    [sym_case_statement] = STATE(2770),
    [sym_while_statement] = STATE(2770),
    [sym_do_statement] = STATE(2770),
    [sym_for_statement] = STATE(2770),
    [sym_return_statement] = STATE(2770),
    [sym_break_statement] = STATE(2770),
    [sym_continue_statement] = STATE(2770),
    [sym_goto_statement] = STATE(2770),
    [sym__expression] = STATE(413),
    [sym_comma_expression] = STATE(414),
    [sym_conditional_expression] = STATE(413),
    [sym_assignment_expression] = STATE(413),
    [sym_pointer_expression] = STATE(413),
    [sym_logical_expression] = STATE(413),
    [sym_bitwise_expression] = STATE(413),
    [sym_equality_expression] = STATE(413),
    [sym_relational_expression] = STATE(413),
    [sym_shift_expression] = STATE(413),
    [sym_math_expression] = STATE(413),
    [sym_cast_expression] = STATE(413),
    [sym_sizeof_expression] = STATE(413),
    [sym_subscript_expression] = STATE(413),
    [sym_call_expression] = STATE(413),
    [sym_field_expression] = STATE(413),
    [sym_compound_literal_expression] = STATE(413),
    [sym_parenthesized_expression] = STATE(413),
    [sym_concatenated_string] = STATE(413),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(413),
    [sym_for_range_loop] = STATE(2770),
    [sym_new_expression] = STATE(413),
    [sym_delete_expression] = STATE(413),
    [sym_lambda_expression] = STATE(413),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(620),
    [anon_sym_LPAREN] = ACTIONS(626),
    [anon_sym_SEMI] = ACTIONS(636),
    [anon_sym_LBRACE] = ACTIONS(640),
    [anon_sym_STAR] = ACTIONS(644),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_if] = ACTIONS(646),
    [anon_sym_switch] = ACTIONS(648),
    [anon_sym_case] = ACTIONS(650),
    [anon_sym_default] = ACTIONS(652),
    [anon_sym_while] = ACTIONS(654),
    [anon_sym_do] = ACTIONS(656),
    [anon_sym_for] = ACTIONS(658),
    [anon_sym_return] = ACTIONS(660),
    [anon_sym_break] = ACTIONS(662),
    [anon_sym_continue] = ACTIONS(664),
    [anon_sym_goto] = ACTIONS(666),
    [anon_sym_AMP] = ACTIONS(644),
    [anon_sym_BANG] = ACTIONS(668),
    [anon_sym_TILDE] = ACTIONS(670),
    [anon_sym_PLUS] = ACTIONS(672),
    [anon_sym_DASH] = ACTIONS(672),
    [anon_sym_DASH_DASH] = ACTIONS(674),
    [anon_sym_PLUS_PLUS] = ACTIONS(674),
    [anon_sym_sizeof] = ACTIONS(676),
    [sym_number_literal] = ACTIONS(620),
    [sym_char_literal] = ACTIONS(620),
    [sym_string_literal] = ACTIONS(678),
    [sym_true] = ACTIONS(680),
    [sym_false] = ACTIONS(680),
    [sym_null] = ACTIONS(680),
    [sym_identifier] = ACTIONS(3110),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1303),
    [anon_sym_delete] = ACTIONS(686),
    [sym_nullptr] = ACTIONS(680),
  },
  [2613] = {
    [sym_raw_string_literal] = ACTIONS(3132),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3134),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3134),
    [anon_sym_LPAREN] = ACTIONS(3132),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3134),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3134),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3134),
    [sym_preproc_directive] = ACTIONS(3134),
    [anon_sym_SEMI] = ACTIONS(3132),
    [anon_sym_typedef] = ACTIONS(3134),
    [anon_sym_extern] = ACTIONS(3134),
    [anon_sym_LBRACE] = ACTIONS(3132),
    [anon_sym_RBRACE] = ACTIONS(3132),
    [anon_sym_STAR] = ACTIONS(3132),
    [anon_sym_LBRACK] = ACTIONS(3132),
    [anon_sym_static] = ACTIONS(3134),
    [anon_sym_register] = ACTIONS(3134),
    [anon_sym_inline] = ACTIONS(3134),
    [anon_sym_const] = ACTIONS(3134),
    [anon_sym_restrict] = ACTIONS(3134),
    [anon_sym_volatile] = ACTIONS(3134),
    [anon_sym__Atomic] = ACTIONS(3134),
    [anon_sym_mutable] = ACTIONS(3134),
    [anon_sym_explicit] = ACTIONS(3134),
    [anon_sym_constexpr] = ACTIONS(3134),
    [anon_sym_unsigned] = ACTIONS(3134),
    [anon_sym_long] = ACTIONS(3134),
    [anon_sym_short] = ACTIONS(3134),
    [sym_primitive_type] = ACTIONS(3134),
    [anon_sym_enum] = ACTIONS(3134),
    [anon_sym_struct] = ACTIONS(3134),
    [anon_sym_union] = ACTIONS(3134),
    [anon_sym_if] = ACTIONS(3134),
    [anon_sym_else] = ACTIONS(3134),
    [anon_sym_switch] = ACTIONS(3134),
    [anon_sym_case] = ACTIONS(3134),
    [anon_sym_default] = ACTIONS(3134),
    [anon_sym_while] = ACTIONS(3134),
    [anon_sym_do] = ACTIONS(3134),
    [anon_sym_for] = ACTIONS(3134),
    [anon_sym_return] = ACTIONS(3134),
    [anon_sym_break] = ACTIONS(3134),
    [anon_sym_continue] = ACTIONS(3134),
    [anon_sym_goto] = ACTIONS(3134),
    [anon_sym_AMP] = ACTIONS(3132),
    [anon_sym_BANG] = ACTIONS(3132),
    [anon_sym_TILDE] = ACTIONS(3132),
    [anon_sym_PLUS] = ACTIONS(3134),
    [anon_sym_DASH] = ACTIONS(3134),
    [anon_sym_DASH_DASH] = ACTIONS(3132),
    [anon_sym_PLUS_PLUS] = ACTIONS(3132),
    [anon_sym_sizeof] = ACTIONS(3134),
    [sym_number_literal] = ACTIONS(3132),
    [sym_char_literal] = ACTIONS(3132),
    [sym_string_literal] = ACTIONS(3132),
    [sym_true] = ACTIONS(3134),
    [sym_false] = ACTIONS(3134),
    [sym_null] = ACTIONS(3134),
    [sym_identifier] = ACTIONS(3134),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(3134),
    [sym_auto] = ACTIONS(3134),
    [anon_sym_typename] = ACTIONS(3134),
    [anon_sym_new] = ACTIONS(3134),
    [anon_sym_COLON_COLON] = ACTIONS(3132),
    [anon_sym_delete] = ACTIONS(3134),
    [sym_nullptr] = ACTIONS(3134),
  },
  [2614] = {
    [sym__expression] = STATE(2771),
    [sym_conditional_expression] = STATE(2771),
    [sym_assignment_expression] = STATE(2771),
    [sym_pointer_expression] = STATE(2771),
    [sym_logical_expression] = STATE(2771),
    [sym_bitwise_expression] = STATE(2771),
    [sym_equality_expression] = STATE(2771),
    [sym_relational_expression] = STATE(2771),
    [sym_shift_expression] = STATE(2771),
    [sym_math_expression] = STATE(2771),
    [sym_cast_expression] = STATE(2771),
    [sym_sizeof_expression] = STATE(2771),
    [sym_subscript_expression] = STATE(2771),
    [sym_call_expression] = STATE(2771),
    [sym_field_expression] = STATE(2771),
    [sym_compound_literal_expression] = STATE(2771),
    [sym_parenthesized_expression] = STATE(2771),
    [sym_concatenated_string] = STATE(2771),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(2771),
    [sym_new_expression] = STATE(2771),
    [sym_delete_expression] = STATE(2771),
    [sym_lambda_expression] = STATE(2771),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(6607),
    [anon_sym_LPAREN] = ACTIONS(2943),
    [anon_sym_STAR] = ACTIONS(2945),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_AMP] = ACTIONS(2945),
    [anon_sym_BANG] = ACTIONS(2947),
    [anon_sym_TILDE] = ACTIONS(2949),
    [anon_sym_PLUS] = ACTIONS(2951),
    [anon_sym_DASH] = ACTIONS(2951),
    [anon_sym_DASH_DASH] = ACTIONS(2953),
    [anon_sym_PLUS_PLUS] = ACTIONS(2953),
    [anon_sym_sizeof] = ACTIONS(2955),
    [sym_number_literal] = ACTIONS(6607),
    [sym_char_literal] = ACTIONS(6607),
    [sym_string_literal] = ACTIONS(2957),
    [sym_true] = ACTIONS(6609),
    [sym_false] = ACTIONS(6609),
    [sym_null] = ACTIONS(6609),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(2961),
    [anon_sym_delete] = ACTIONS(2963),
    [sym_nullptr] = ACTIONS(6609),
  },
  [2615] = {
    [sym_raw_string_literal] = ACTIONS(6611),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(6613),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(6613),
    [anon_sym_LPAREN] = ACTIONS(6611),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(6613),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(6613),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(6613),
    [sym_preproc_directive] = ACTIONS(6613),
    [anon_sym_SEMI] = ACTIONS(6611),
    [anon_sym_typedef] = ACTIONS(6613),
    [anon_sym_extern] = ACTIONS(6613),
    [anon_sym_LBRACE] = ACTIONS(6611),
    [anon_sym_RBRACE] = ACTIONS(6611),
    [anon_sym_STAR] = ACTIONS(6611),
    [anon_sym_LBRACK] = ACTIONS(6611),
    [anon_sym_static] = ACTIONS(6613),
    [anon_sym_register] = ACTIONS(6613),
    [anon_sym_inline] = ACTIONS(6613),
    [anon_sym_const] = ACTIONS(6613),
    [anon_sym_restrict] = ACTIONS(6613),
    [anon_sym_volatile] = ACTIONS(6613),
    [anon_sym__Atomic] = ACTIONS(6613),
    [anon_sym_mutable] = ACTIONS(6613),
    [anon_sym_explicit] = ACTIONS(6613),
    [anon_sym_constexpr] = ACTIONS(6613),
    [anon_sym_unsigned] = ACTIONS(6613),
    [anon_sym_long] = ACTIONS(6613),
    [anon_sym_short] = ACTIONS(6613),
    [sym_primitive_type] = ACTIONS(6613),
    [anon_sym_enum] = ACTIONS(6613),
    [anon_sym_struct] = ACTIONS(6613),
    [anon_sym_union] = ACTIONS(6613),
    [anon_sym_if] = ACTIONS(6613),
    [anon_sym_else] = ACTIONS(6615),
    [anon_sym_switch] = ACTIONS(6613),
    [anon_sym_case] = ACTIONS(6613),
    [anon_sym_default] = ACTIONS(6613),
    [anon_sym_while] = ACTIONS(6613),
    [anon_sym_do] = ACTIONS(6613),
    [anon_sym_for] = ACTIONS(6613),
    [anon_sym_return] = ACTIONS(6613),
    [anon_sym_break] = ACTIONS(6613),
    [anon_sym_continue] = ACTIONS(6613),
    [anon_sym_goto] = ACTIONS(6613),
    [anon_sym_AMP] = ACTIONS(6611),
    [anon_sym_BANG] = ACTIONS(6611),
    [anon_sym_TILDE] = ACTIONS(6611),
    [anon_sym_PLUS] = ACTIONS(6613),
    [anon_sym_DASH] = ACTIONS(6613),
    [anon_sym_DASH_DASH] = ACTIONS(6611),
    [anon_sym_PLUS_PLUS] = ACTIONS(6611),
    [anon_sym_sizeof] = ACTIONS(6613),
    [sym_number_literal] = ACTIONS(6611),
    [sym_char_literal] = ACTIONS(6611),
    [sym_string_literal] = ACTIONS(6611),
    [sym_true] = ACTIONS(6613),
    [sym_false] = ACTIONS(6613),
    [sym_null] = ACTIONS(6613),
    [sym_identifier] = ACTIONS(6613),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(6613),
    [sym_auto] = ACTIONS(6613),
    [anon_sym_typename] = ACTIONS(6613),
    [anon_sym_new] = ACTIONS(6613),
    [anon_sym_COLON_COLON] = ACTIONS(6611),
    [anon_sym_delete] = ACTIONS(6613),
    [sym_nullptr] = ACTIONS(6613),
  },
  [2616] = {
    [sym_argument_list] = STATE(802),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_STAR] = ACTIONS(3003),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_EQ] = ACTIONS(5986),
    [anon_sym_COLON] = ACTIONS(5984),
    [anon_sym_QMARK] = ACTIONS(5984),
    [anon_sym_STAR_EQ] = ACTIONS(5984),
    [anon_sym_SLASH_EQ] = ACTIONS(5984),
    [anon_sym_PERCENT_EQ] = ACTIONS(5984),
    [anon_sym_PLUS_EQ] = ACTIONS(5984),
    [anon_sym_DASH_EQ] = ACTIONS(5984),
    [anon_sym_LT_LT_EQ] = ACTIONS(5984),
    [anon_sym_GT_GT_EQ] = ACTIONS(5984),
    [anon_sym_AMP_EQ] = ACTIONS(5984),
    [anon_sym_CARET_EQ] = ACTIONS(5984),
    [anon_sym_PIPE_EQ] = ACTIONS(5984),
    [anon_sym_AMP] = ACTIONS(3013),
    [anon_sym_PIPE_PIPE] = ACTIONS(3015),
    [anon_sym_AMP_AMP] = ACTIONS(3017),
    [anon_sym_PIPE] = ACTIONS(3019),
    [anon_sym_CARET] = ACTIONS(3021),
    [anon_sym_EQ_EQ] = ACTIONS(3023),
    [anon_sym_BANG_EQ] = ACTIONS(3023),
    [anon_sym_LT] = ACTIONS(3025),
    [anon_sym_GT] = ACTIONS(3025),
    [anon_sym_LT_EQ] = ACTIONS(3027),
    [anon_sym_GT_EQ] = ACTIONS(3027),
    [anon_sym_LT_LT] = ACTIONS(3029),
    [anon_sym_GT_GT] = ACTIONS(3029),
    [anon_sym_PLUS] = ACTIONS(3031),
    [anon_sym_DASH] = ACTIONS(3031),
    [anon_sym_SLASH] = ACTIONS(3003),
    [anon_sym_PERCENT] = ACTIONS(3003),
    [anon_sym_DASH_DASH] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(3033),
    [anon_sym_DASH_GT] = ACTIONS(3033),
    [sym_comment] = ACTIONS(49),
  },
  [2617] = {
    [sym_argument_list] = STATE(802),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_STAR] = ACTIONS(3003),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_EQ] = ACTIONS(3005),
    [anon_sym_COLON] = ACTIONS(5988),
    [anon_sym_QMARK] = ACTIONS(3009),
    [anon_sym_STAR_EQ] = ACTIONS(3011),
    [anon_sym_SLASH_EQ] = ACTIONS(3011),
    [anon_sym_PERCENT_EQ] = ACTIONS(3011),
    [anon_sym_PLUS_EQ] = ACTIONS(3011),
    [anon_sym_DASH_EQ] = ACTIONS(3011),
    [anon_sym_LT_LT_EQ] = ACTIONS(3011),
    [anon_sym_GT_GT_EQ] = ACTIONS(3011),
    [anon_sym_AMP_EQ] = ACTIONS(3011),
    [anon_sym_CARET_EQ] = ACTIONS(3011),
    [anon_sym_PIPE_EQ] = ACTIONS(3011),
    [anon_sym_AMP] = ACTIONS(3013),
    [anon_sym_PIPE_PIPE] = ACTIONS(3015),
    [anon_sym_AMP_AMP] = ACTIONS(3017),
    [anon_sym_PIPE] = ACTIONS(3019),
    [anon_sym_CARET] = ACTIONS(3021),
    [anon_sym_EQ_EQ] = ACTIONS(3023),
    [anon_sym_BANG_EQ] = ACTIONS(3023),
    [anon_sym_LT] = ACTIONS(3025),
    [anon_sym_GT] = ACTIONS(3025),
    [anon_sym_LT_EQ] = ACTIONS(3027),
    [anon_sym_GT_EQ] = ACTIONS(3027),
    [anon_sym_LT_LT] = ACTIONS(3029),
    [anon_sym_GT_GT] = ACTIONS(3029),
    [anon_sym_PLUS] = ACTIONS(3031),
    [anon_sym_DASH] = ACTIONS(3031),
    [anon_sym_SLASH] = ACTIONS(3003),
    [anon_sym_PERCENT] = ACTIONS(3003),
    [anon_sym_DASH_DASH] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(3033),
    [anon_sym_DASH_GT] = ACTIONS(3033),
    [sym_comment] = ACTIONS(49),
  },
  [2618] = {
    [anon_sym_LPAREN] = ACTIONS(6617),
    [anon_sym_constexpr] = ACTIONS(6619),
    [sym_comment] = ACTIONS(49),
  },
  [2619] = {
    [anon_sym_LPAREN] = ACTIONS(6621),
    [sym_comment] = ACTIONS(49),
  },
  [2620] = {
    [sym__expression] = STATE(2776),
    [sym_conditional_expression] = STATE(2776),
    [sym_assignment_expression] = STATE(2776),
    [sym_pointer_expression] = STATE(2776),
    [sym_logical_expression] = STATE(2776),
    [sym_bitwise_expression] = STATE(2776),
    [sym_equality_expression] = STATE(2776),
    [sym_relational_expression] = STATE(2776),
    [sym_shift_expression] = STATE(2776),
    [sym_math_expression] = STATE(2776),
    [sym_cast_expression] = STATE(2776),
    [sym_sizeof_expression] = STATE(2776),
    [sym_subscript_expression] = STATE(2776),
    [sym_call_expression] = STATE(2776),
    [sym_field_expression] = STATE(2776),
    [sym_compound_literal_expression] = STATE(2776),
    [sym_parenthesized_expression] = STATE(2776),
    [sym_concatenated_string] = STATE(2776),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(2776),
    [sym_new_expression] = STATE(2776),
    [sym_delete_expression] = STATE(2776),
    [sym_lambda_expression] = STATE(2776),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(855),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(6623),
    [anon_sym_LPAREN] = ACTIONS(1634),
    [anon_sym_STAR] = ACTIONS(1636),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_AMP] = ACTIONS(1636),
    [anon_sym_BANG] = ACTIONS(1638),
    [anon_sym_TILDE] = ACTIONS(1640),
    [anon_sym_PLUS] = ACTIONS(1642),
    [anon_sym_DASH] = ACTIONS(1642),
    [anon_sym_DASH_DASH] = ACTIONS(1644),
    [anon_sym_PLUS_PLUS] = ACTIONS(1644),
    [anon_sym_sizeof] = ACTIONS(1646),
    [sym_number_literal] = ACTIONS(6623),
    [sym_char_literal] = ACTIONS(6623),
    [sym_string_literal] = ACTIONS(1648),
    [sym_true] = ACTIONS(6625),
    [sym_false] = ACTIONS(6625),
    [sym_null] = ACTIONS(6625),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1652),
    [anon_sym_delete] = ACTIONS(1654),
    [sym_nullptr] = ACTIONS(6625),
  },
  [2621] = {
    [anon_sym_COLON] = ACTIONS(6627),
    [sym_comment] = ACTIONS(49),
  },
  [2622] = {
    [anon_sym_LPAREN] = ACTIONS(6629),
    [sym_comment] = ACTIONS(49),
  },
  [2623] = {
    [anon_sym_LPAREN] = ACTIONS(6631),
    [sym_comment] = ACTIONS(49),
  },
  [2624] = {
    [sym_initializer_list] = STATE(765),
    [sym_template_argument_list] = STATE(1097),
    [anon_sym_LPAREN] = ACTIONS(1477),
    [anon_sym_COMMA] = ACTIONS(1477),
    [anon_sym_SEMI] = ACTIONS(1477),
    [anon_sym_LBRACE] = ACTIONS(548),
    [anon_sym_STAR] = ACTIONS(1479),
    [anon_sym_LBRACK] = ACTIONS(1477),
    [anon_sym_EQ] = ACTIONS(1479),
    [anon_sym_COLON] = ACTIONS(6633),
    [anon_sym_QMARK] = ACTIONS(1477),
    [anon_sym_STAR_EQ] = ACTIONS(1477),
    [anon_sym_SLASH_EQ] = ACTIONS(1477),
    [anon_sym_PERCENT_EQ] = ACTIONS(1477),
    [anon_sym_PLUS_EQ] = ACTIONS(1477),
    [anon_sym_DASH_EQ] = ACTIONS(1477),
    [anon_sym_LT_LT_EQ] = ACTIONS(1477),
    [anon_sym_GT_GT_EQ] = ACTIONS(1477),
    [anon_sym_AMP_EQ] = ACTIONS(1477),
    [anon_sym_CARET_EQ] = ACTIONS(1477),
    [anon_sym_PIPE_EQ] = ACTIONS(1477),
    [anon_sym_AMP] = ACTIONS(1479),
    [anon_sym_PIPE_PIPE] = ACTIONS(1477),
    [anon_sym_AMP_AMP] = ACTIONS(1477),
    [anon_sym_PIPE] = ACTIONS(1479),
    [anon_sym_CARET] = ACTIONS(1479),
    [anon_sym_EQ_EQ] = ACTIONS(1477),
    [anon_sym_BANG_EQ] = ACTIONS(1477),
    [anon_sym_LT] = ACTIONS(1564),
    [anon_sym_GT] = ACTIONS(1479),
    [anon_sym_LT_EQ] = ACTIONS(1477),
    [anon_sym_GT_EQ] = ACTIONS(1477),
    [anon_sym_LT_LT] = ACTIONS(1479),
    [anon_sym_GT_GT] = ACTIONS(1479),
    [anon_sym_PLUS] = ACTIONS(1479),
    [anon_sym_DASH] = ACTIONS(1479),
    [anon_sym_SLASH] = ACTIONS(1479),
    [anon_sym_PERCENT] = ACTIONS(1479),
    [anon_sym_DASH_DASH] = ACTIONS(1477),
    [anon_sym_PLUS_PLUS] = ACTIONS(1477),
    [anon_sym_DOT] = ACTIONS(1477),
    [anon_sym_DASH_GT] = ACTIONS(1477),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(2218),
  },
  [2625] = {
    [anon_sym_else] = ACTIONS(6635),
    [anon_sym_while] = ACTIONS(6267),
    [sym_comment] = ACTIONS(49),
  },
  [2626] = {
    [sym_compound_statement] = STATE(2782),
    [sym_labeled_statement] = STATE(2782),
    [sym_expression_statement] = STATE(2782),
    [sym_if_statement] = STATE(2782),
    [sym_switch_statement] = STATE(2782),
    [sym_case_statement] = STATE(2782),
    [sym_while_statement] = STATE(2782),
    [sym_do_statement] = STATE(2782),
    [sym_for_statement] = STATE(2782),
    [sym_return_statement] = STATE(2782),
    [sym_break_statement] = STATE(2782),
    [sym_continue_statement] = STATE(2782),
    [sym_goto_statement] = STATE(2782),
    [sym__expression] = STATE(873),
    [sym_comma_expression] = STATE(874),
    [sym_conditional_expression] = STATE(873),
    [sym_assignment_expression] = STATE(873),
    [sym_pointer_expression] = STATE(873),
    [sym_logical_expression] = STATE(873),
    [sym_bitwise_expression] = STATE(873),
    [sym_equality_expression] = STATE(873),
    [sym_relational_expression] = STATE(873),
    [sym_shift_expression] = STATE(873),
    [sym_math_expression] = STATE(873),
    [sym_cast_expression] = STATE(873),
    [sym_sizeof_expression] = STATE(873),
    [sym_subscript_expression] = STATE(873),
    [sym_call_expression] = STATE(873),
    [sym_field_expression] = STATE(873),
    [sym_compound_literal_expression] = STATE(873),
    [sym_parenthesized_expression] = STATE(873),
    [sym_concatenated_string] = STATE(873),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(873),
    [sym_for_range_loop] = STATE(2782),
    [sym_new_expression] = STATE(873),
    [sym_delete_expression] = STATE(873),
    [sym_lambda_expression] = STATE(873),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(1660),
    [anon_sym_LPAREN] = ACTIONS(626),
    [anon_sym_SEMI] = ACTIONS(1662),
    [anon_sym_LBRACE] = ACTIONS(1664),
    [anon_sym_STAR] = ACTIONS(644),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_if] = ACTIONS(6297),
    [anon_sym_switch] = ACTIONS(6299),
    [anon_sym_case] = ACTIONS(6301),
    [anon_sym_default] = ACTIONS(6303),
    [anon_sym_while] = ACTIONS(6305),
    [anon_sym_do] = ACTIONS(1676),
    [anon_sym_for] = ACTIONS(6307),
    [anon_sym_return] = ACTIONS(1680),
    [anon_sym_break] = ACTIONS(1682),
    [anon_sym_continue] = ACTIONS(1684),
    [anon_sym_goto] = ACTIONS(1686),
    [anon_sym_AMP] = ACTIONS(644),
    [anon_sym_BANG] = ACTIONS(668),
    [anon_sym_TILDE] = ACTIONS(670),
    [anon_sym_PLUS] = ACTIONS(672),
    [anon_sym_DASH] = ACTIONS(672),
    [anon_sym_DASH_DASH] = ACTIONS(674),
    [anon_sym_PLUS_PLUS] = ACTIONS(674),
    [anon_sym_sizeof] = ACTIONS(676),
    [sym_number_literal] = ACTIONS(1660),
    [sym_char_literal] = ACTIONS(1660),
    [sym_string_literal] = ACTIONS(678),
    [sym_true] = ACTIONS(1688),
    [sym_false] = ACTIONS(1688),
    [sym_null] = ACTIONS(1688),
    [sym_identifier] = ACTIONS(6309),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1303),
    [anon_sym_delete] = ACTIONS(686),
    [sym_nullptr] = ACTIONS(1688),
  },
  [2627] = {
    [anon_sym_else] = ACTIONS(6277),
    [anon_sym_while] = ACTIONS(6277),
    [sym_comment] = ACTIONS(49),
  },
  [2628] = {
    [sym_parameter_list] = STATE(513),
    [anon_sym_LPAREN] = ACTIONS(206),
    [anon_sym_SEMI] = ACTIONS(6637),
    [anon_sym_LBRACK] = ACTIONS(955),
    [sym_comment] = ACTIONS(49),
  },
  [2629] = {
    [sym__type_declarator] = STATE(2784),
    [sym_pointer_type_declarator] = STATE(213),
    [sym_function_type_declarator] = STATE(214),
    [sym_array_type_declarator] = STATE(215),
    [anon_sym_LPAREN] = ACTIONS(327),
    [anon_sym_STAR] = ACTIONS(329),
    [sym_identifier] = ACTIONS(331),
    [sym_comment] = ACTIONS(49),
  },
  [2630] = {
    [anon_sym_else] = ACTIONS(1261),
    [anon_sym_while] = ACTIONS(1261),
    [sym_comment] = ACTIONS(49),
  },
  [2631] = {
    [aux_sym_declaration_repeat1] = STATE(678),
    [anon_sym_COMMA] = ACTIONS(538),
    [anon_sym_SEMI] = ACTIONS(6639),
    [sym_comment] = ACTIONS(49),
  },
  [2632] = {
    [anon_sym_else] = ACTIONS(6293),
    [anon_sym_while] = ACTIONS(6293),
    [sym_comment] = ACTIONS(49),
  },
  [2633] = {
    [sym_argument_list] = STATE(802),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_RPAREN] = ACTIONS(6641),
    [anon_sym_STAR] = ACTIONS(4537),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_EQ] = ACTIONS(4539),
    [anon_sym_QMARK] = ACTIONS(4541),
    [anon_sym_STAR_EQ] = ACTIONS(4543),
    [anon_sym_SLASH_EQ] = ACTIONS(4543),
    [anon_sym_PERCENT_EQ] = ACTIONS(4543),
    [anon_sym_PLUS_EQ] = ACTIONS(4543),
    [anon_sym_DASH_EQ] = ACTIONS(4543),
    [anon_sym_LT_LT_EQ] = ACTIONS(4543),
    [anon_sym_GT_GT_EQ] = ACTIONS(4543),
    [anon_sym_AMP_EQ] = ACTIONS(4543),
    [anon_sym_CARET_EQ] = ACTIONS(4543),
    [anon_sym_PIPE_EQ] = ACTIONS(4543),
    [anon_sym_AMP] = ACTIONS(4545),
    [anon_sym_PIPE_PIPE] = ACTIONS(4547),
    [anon_sym_AMP_AMP] = ACTIONS(4549),
    [anon_sym_PIPE] = ACTIONS(4551),
    [anon_sym_CARET] = ACTIONS(4553),
    [anon_sym_EQ_EQ] = ACTIONS(4555),
    [anon_sym_BANG_EQ] = ACTIONS(4555),
    [anon_sym_LT] = ACTIONS(4557),
    [anon_sym_GT] = ACTIONS(4557),
    [anon_sym_LT_EQ] = ACTIONS(4559),
    [anon_sym_GT_EQ] = ACTIONS(4559),
    [anon_sym_LT_LT] = ACTIONS(4561),
    [anon_sym_GT_GT] = ACTIONS(4561),
    [anon_sym_PLUS] = ACTIONS(4563),
    [anon_sym_DASH] = ACTIONS(4563),
    [anon_sym_SLASH] = ACTIONS(4537),
    [anon_sym_PERCENT] = ACTIONS(4537),
    [anon_sym_DASH_DASH] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(1554),
    [anon_sym_DASH_GT] = ACTIONS(1554),
    [sym_comment] = ACTIONS(49),
  },
  [2634] = {
    [sym_compound_statement] = STATE(2787),
    [sym_labeled_statement] = STATE(2787),
    [sym_expression_statement] = STATE(2787),
    [sym_if_statement] = STATE(2787),
    [sym_switch_statement] = STATE(2787),
    [sym_case_statement] = STATE(2787),
    [sym_while_statement] = STATE(2787),
    [sym_do_statement] = STATE(2787),
    [sym_for_statement] = STATE(2787),
    [sym_return_statement] = STATE(2787),
    [sym_break_statement] = STATE(2787),
    [sym_continue_statement] = STATE(2787),
    [sym_goto_statement] = STATE(2787),
    [sym__expression] = STATE(873),
    [sym_comma_expression] = STATE(874),
    [sym_conditional_expression] = STATE(873),
    [sym_assignment_expression] = STATE(873),
    [sym_pointer_expression] = STATE(873),
    [sym_logical_expression] = STATE(873),
    [sym_bitwise_expression] = STATE(873),
    [sym_equality_expression] = STATE(873),
    [sym_relational_expression] = STATE(873),
    [sym_shift_expression] = STATE(873),
    [sym_math_expression] = STATE(873),
    [sym_cast_expression] = STATE(873),
    [sym_sizeof_expression] = STATE(873),
    [sym_subscript_expression] = STATE(873),
    [sym_call_expression] = STATE(873),
    [sym_field_expression] = STATE(873),
    [sym_compound_literal_expression] = STATE(873),
    [sym_parenthesized_expression] = STATE(873),
    [sym_concatenated_string] = STATE(873),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(873),
    [sym_for_range_loop] = STATE(2787),
    [sym_new_expression] = STATE(873),
    [sym_delete_expression] = STATE(873),
    [sym_lambda_expression] = STATE(873),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(1660),
    [anon_sym_LPAREN] = ACTIONS(626),
    [anon_sym_SEMI] = ACTIONS(1662),
    [anon_sym_LBRACE] = ACTIONS(1664),
    [anon_sym_STAR] = ACTIONS(644),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_if] = ACTIONS(1666),
    [anon_sym_switch] = ACTIONS(1668),
    [anon_sym_case] = ACTIONS(1670),
    [anon_sym_default] = ACTIONS(1672),
    [anon_sym_while] = ACTIONS(1674),
    [anon_sym_do] = ACTIONS(1676),
    [anon_sym_for] = ACTIONS(1678),
    [anon_sym_return] = ACTIONS(1680),
    [anon_sym_break] = ACTIONS(1682),
    [anon_sym_continue] = ACTIONS(1684),
    [anon_sym_goto] = ACTIONS(1686),
    [anon_sym_AMP] = ACTIONS(644),
    [anon_sym_BANG] = ACTIONS(668),
    [anon_sym_TILDE] = ACTIONS(670),
    [anon_sym_PLUS] = ACTIONS(672),
    [anon_sym_DASH] = ACTIONS(672),
    [anon_sym_DASH_DASH] = ACTIONS(674),
    [anon_sym_PLUS_PLUS] = ACTIONS(674),
    [anon_sym_sizeof] = ACTIONS(676),
    [sym_number_literal] = ACTIONS(1660),
    [sym_char_literal] = ACTIONS(1660),
    [sym_string_literal] = ACTIONS(678),
    [sym_true] = ACTIONS(1688),
    [sym_false] = ACTIONS(1688),
    [sym_null] = ACTIONS(1688),
    [sym_identifier] = ACTIONS(1690),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1303),
    [anon_sym_delete] = ACTIONS(686),
    [sym_nullptr] = ACTIONS(1688),
  },
  [2635] = {
    [sym_argument_list] = STATE(802),
    [aux_sym_for_statement_repeat1] = STATE(2789),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_COMMA] = ACTIONS(6339),
    [anon_sym_RPAREN] = ACTIONS(6643),
    [anon_sym_STAR] = ACTIONS(2234),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_EQ] = ACTIONS(2236),
    [anon_sym_QMARK] = ACTIONS(2238),
    [anon_sym_STAR_EQ] = ACTIONS(2240),
    [anon_sym_SLASH_EQ] = ACTIONS(2240),
    [anon_sym_PERCENT_EQ] = ACTIONS(2240),
    [anon_sym_PLUS_EQ] = ACTIONS(2240),
    [anon_sym_DASH_EQ] = ACTIONS(2240),
    [anon_sym_LT_LT_EQ] = ACTIONS(2240),
    [anon_sym_GT_GT_EQ] = ACTIONS(2240),
    [anon_sym_AMP_EQ] = ACTIONS(2240),
    [anon_sym_CARET_EQ] = ACTIONS(2240),
    [anon_sym_PIPE_EQ] = ACTIONS(2240),
    [anon_sym_AMP] = ACTIONS(2242),
    [anon_sym_PIPE_PIPE] = ACTIONS(2244),
    [anon_sym_AMP_AMP] = ACTIONS(2246),
    [anon_sym_PIPE] = ACTIONS(2248),
    [anon_sym_CARET] = ACTIONS(2250),
    [anon_sym_EQ_EQ] = ACTIONS(2252),
    [anon_sym_BANG_EQ] = ACTIONS(2252),
    [anon_sym_LT] = ACTIONS(2254),
    [anon_sym_GT] = ACTIONS(2254),
    [anon_sym_LT_EQ] = ACTIONS(2256),
    [anon_sym_GT_EQ] = ACTIONS(2256),
    [anon_sym_LT_LT] = ACTIONS(2258),
    [anon_sym_GT_GT] = ACTIONS(2258),
    [anon_sym_PLUS] = ACTIONS(2260),
    [anon_sym_DASH] = ACTIONS(2260),
    [anon_sym_SLASH] = ACTIONS(2234),
    [anon_sym_PERCENT] = ACTIONS(2234),
    [anon_sym_DASH_DASH] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(1554),
    [anon_sym_DASH_GT] = ACTIONS(1554),
    [sym_comment] = ACTIONS(49),
  },
  [2636] = {
    [sym__expression] = STATE(2790),
    [sym_conditional_expression] = STATE(2790),
    [sym_assignment_expression] = STATE(2790),
    [sym_pointer_expression] = STATE(2790),
    [sym_logical_expression] = STATE(2790),
    [sym_bitwise_expression] = STATE(2790),
    [sym_equality_expression] = STATE(2790),
    [sym_relational_expression] = STATE(2790),
    [sym_shift_expression] = STATE(2790),
    [sym_math_expression] = STATE(2790),
    [sym_cast_expression] = STATE(2790),
    [sym_sizeof_expression] = STATE(2790),
    [sym_subscript_expression] = STATE(2790),
    [sym_call_expression] = STATE(2790),
    [sym_field_expression] = STATE(2790),
    [sym_compound_literal_expression] = STATE(2790),
    [sym_parenthesized_expression] = STATE(2790),
    [sym_concatenated_string] = STATE(2790),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(2790),
    [sym_new_expression] = STATE(2790),
    [sym_delete_expression] = STATE(2790),
    [sym_lambda_expression] = STATE(2790),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(6645),
    [anon_sym_LPAREN] = ACTIONS(1087),
    [anon_sym_RPAREN] = ACTIONS(6643),
    [anon_sym_STAR] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_AMP] = ACTIONS(1089),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1093),
    [anon_sym_PLUS] = ACTIONS(1095),
    [anon_sym_DASH] = ACTIONS(1095),
    [anon_sym_DASH_DASH] = ACTIONS(1097),
    [anon_sym_PLUS_PLUS] = ACTIONS(1097),
    [anon_sym_sizeof] = ACTIONS(1099),
    [sym_number_literal] = ACTIONS(6645),
    [sym_char_literal] = ACTIONS(6645),
    [sym_string_literal] = ACTIONS(1101),
    [sym_true] = ACTIONS(6647),
    [sym_false] = ACTIONS(6647),
    [sym_null] = ACTIONS(6647),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_delete] = ACTIONS(1109),
    [sym_nullptr] = ACTIONS(6647),
  },
  [2637] = {
    [sym_argument_list] = STATE(802),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_SEMI] = ACTIONS(6649),
    [anon_sym_STAR] = ACTIONS(2553),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_EQ] = ACTIONS(2555),
    [anon_sym_QMARK] = ACTIONS(2557),
    [anon_sym_STAR_EQ] = ACTIONS(2559),
    [anon_sym_SLASH_EQ] = ACTIONS(2559),
    [anon_sym_PERCENT_EQ] = ACTIONS(2559),
    [anon_sym_PLUS_EQ] = ACTIONS(2559),
    [anon_sym_DASH_EQ] = ACTIONS(2559),
    [anon_sym_LT_LT_EQ] = ACTIONS(2559),
    [anon_sym_GT_GT_EQ] = ACTIONS(2559),
    [anon_sym_AMP_EQ] = ACTIONS(2559),
    [anon_sym_CARET_EQ] = ACTIONS(2559),
    [anon_sym_PIPE_EQ] = ACTIONS(2559),
    [anon_sym_AMP] = ACTIONS(2561),
    [anon_sym_PIPE_PIPE] = ACTIONS(2563),
    [anon_sym_AMP_AMP] = ACTIONS(2565),
    [anon_sym_PIPE] = ACTIONS(2567),
    [anon_sym_CARET] = ACTIONS(2569),
    [anon_sym_EQ_EQ] = ACTIONS(2571),
    [anon_sym_BANG_EQ] = ACTIONS(2571),
    [anon_sym_LT] = ACTIONS(2573),
    [anon_sym_GT] = ACTIONS(2573),
    [anon_sym_LT_EQ] = ACTIONS(2575),
    [anon_sym_GT_EQ] = ACTIONS(2575),
    [anon_sym_LT_LT] = ACTIONS(2577),
    [anon_sym_GT_GT] = ACTIONS(2577),
    [anon_sym_PLUS] = ACTIONS(2579),
    [anon_sym_DASH] = ACTIONS(2579),
    [anon_sym_SLASH] = ACTIONS(2553),
    [anon_sym_PERCENT] = ACTIONS(2553),
    [anon_sym_DASH_DASH] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(1554),
    [anon_sym_DASH_GT] = ACTIONS(1554),
    [sym_comment] = ACTIONS(49),
  },
  [2638] = {
    [sym_argument_list] = STATE(802),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_RPAREN] = ACTIONS(6651),
    [anon_sym_STAR] = ACTIONS(4537),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_EQ] = ACTIONS(4539),
    [anon_sym_QMARK] = ACTIONS(4541),
    [anon_sym_STAR_EQ] = ACTIONS(4543),
    [anon_sym_SLASH_EQ] = ACTIONS(4543),
    [anon_sym_PERCENT_EQ] = ACTIONS(4543),
    [anon_sym_PLUS_EQ] = ACTIONS(4543),
    [anon_sym_DASH_EQ] = ACTIONS(4543),
    [anon_sym_LT_LT_EQ] = ACTIONS(4543),
    [anon_sym_GT_GT_EQ] = ACTIONS(4543),
    [anon_sym_AMP_EQ] = ACTIONS(4543),
    [anon_sym_CARET_EQ] = ACTIONS(4543),
    [anon_sym_PIPE_EQ] = ACTIONS(4543),
    [anon_sym_AMP] = ACTIONS(4545),
    [anon_sym_PIPE_PIPE] = ACTIONS(4547),
    [anon_sym_AMP_AMP] = ACTIONS(4549),
    [anon_sym_PIPE] = ACTIONS(4551),
    [anon_sym_CARET] = ACTIONS(4553),
    [anon_sym_EQ_EQ] = ACTIONS(4555),
    [anon_sym_BANG_EQ] = ACTIONS(4555),
    [anon_sym_LT] = ACTIONS(4557),
    [anon_sym_GT] = ACTIONS(4557),
    [anon_sym_LT_EQ] = ACTIONS(4559),
    [anon_sym_GT_EQ] = ACTIONS(4559),
    [anon_sym_LT_LT] = ACTIONS(4561),
    [anon_sym_GT_GT] = ACTIONS(4561),
    [anon_sym_PLUS] = ACTIONS(4563),
    [anon_sym_DASH] = ACTIONS(4563),
    [anon_sym_SLASH] = ACTIONS(4537),
    [anon_sym_PERCENT] = ACTIONS(4537),
    [anon_sym_DASH_DASH] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(1554),
    [anon_sym_DASH_GT] = ACTIONS(1554),
    [sym_comment] = ACTIONS(49),
  },
  [2639] = {
    [sym_raw_string_literal] = ACTIONS(6653),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(6655),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(6655),
    [anon_sym_LPAREN] = ACTIONS(6653),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(6655),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(6655),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(6655),
    [sym_preproc_directive] = ACTIONS(6655),
    [anon_sym_SEMI] = ACTIONS(6653),
    [anon_sym_typedef] = ACTIONS(6655),
    [anon_sym_extern] = ACTIONS(6655),
    [anon_sym_LBRACE] = ACTIONS(6653),
    [anon_sym_RBRACE] = ACTIONS(6653),
    [anon_sym_STAR] = ACTIONS(6653),
    [anon_sym_LBRACK] = ACTIONS(6653),
    [anon_sym_static] = ACTIONS(6655),
    [anon_sym_register] = ACTIONS(6655),
    [anon_sym_inline] = ACTIONS(6655),
    [anon_sym_const] = ACTIONS(6655),
    [anon_sym_restrict] = ACTIONS(6655),
    [anon_sym_volatile] = ACTIONS(6655),
    [anon_sym__Atomic] = ACTIONS(6655),
    [anon_sym_mutable] = ACTIONS(6655),
    [anon_sym_explicit] = ACTIONS(6655),
    [anon_sym_constexpr] = ACTIONS(6655),
    [anon_sym_unsigned] = ACTIONS(6655),
    [anon_sym_long] = ACTIONS(6655),
    [anon_sym_short] = ACTIONS(6655),
    [sym_primitive_type] = ACTIONS(6655),
    [anon_sym_enum] = ACTIONS(6655),
    [anon_sym_struct] = ACTIONS(6655),
    [anon_sym_union] = ACTIONS(6655),
    [anon_sym_if] = ACTIONS(6655),
    [anon_sym_switch] = ACTIONS(6655),
    [anon_sym_case] = ACTIONS(6655),
    [anon_sym_default] = ACTIONS(6655),
    [anon_sym_while] = ACTIONS(6655),
    [anon_sym_do] = ACTIONS(6655),
    [anon_sym_for] = ACTIONS(6655),
    [anon_sym_return] = ACTIONS(6655),
    [anon_sym_break] = ACTIONS(6655),
    [anon_sym_continue] = ACTIONS(6655),
    [anon_sym_goto] = ACTIONS(6655),
    [anon_sym_AMP] = ACTIONS(6653),
    [anon_sym_BANG] = ACTIONS(6653),
    [anon_sym_TILDE] = ACTIONS(6653),
    [anon_sym_PLUS] = ACTIONS(6655),
    [anon_sym_DASH] = ACTIONS(6655),
    [anon_sym_DASH_DASH] = ACTIONS(6653),
    [anon_sym_PLUS_PLUS] = ACTIONS(6653),
    [anon_sym_sizeof] = ACTIONS(6655),
    [sym_number_literal] = ACTIONS(6653),
    [sym_char_literal] = ACTIONS(6653),
    [sym_string_literal] = ACTIONS(6653),
    [sym_true] = ACTIONS(6655),
    [sym_false] = ACTIONS(6655),
    [sym_null] = ACTIONS(6655),
    [sym_identifier] = ACTIONS(6655),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(6655),
    [sym_auto] = ACTIONS(6655),
    [anon_sym_typename] = ACTIONS(6655),
    [anon_sym_new] = ACTIONS(6655),
    [anon_sym_COLON_COLON] = ACTIONS(6653),
    [anon_sym_delete] = ACTIONS(6655),
    [sym_nullptr] = ACTIONS(6655),
  },
  [2640] = {
    [sym_raw_string_literal] = ACTIONS(6657),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(6659),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(6659),
    [anon_sym_LPAREN] = ACTIONS(6657),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(6659),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(6659),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(6659),
    [sym_preproc_directive] = ACTIONS(6659),
    [anon_sym_SEMI] = ACTIONS(6657),
    [anon_sym_typedef] = ACTIONS(6659),
    [anon_sym_extern] = ACTIONS(6659),
    [anon_sym_LBRACE] = ACTIONS(6657),
    [anon_sym_RBRACE] = ACTIONS(6657),
    [anon_sym_STAR] = ACTIONS(6657),
    [anon_sym_LBRACK] = ACTIONS(6657),
    [anon_sym_static] = ACTIONS(6659),
    [anon_sym_register] = ACTIONS(6659),
    [anon_sym_inline] = ACTIONS(6659),
    [anon_sym_const] = ACTIONS(6659),
    [anon_sym_restrict] = ACTIONS(6659),
    [anon_sym_volatile] = ACTIONS(6659),
    [anon_sym__Atomic] = ACTIONS(6659),
    [anon_sym_mutable] = ACTIONS(6659),
    [anon_sym_explicit] = ACTIONS(6659),
    [anon_sym_constexpr] = ACTIONS(6659),
    [anon_sym_unsigned] = ACTIONS(6659),
    [anon_sym_long] = ACTIONS(6659),
    [anon_sym_short] = ACTIONS(6659),
    [sym_primitive_type] = ACTIONS(6659),
    [anon_sym_enum] = ACTIONS(6659),
    [anon_sym_struct] = ACTIONS(6659),
    [anon_sym_union] = ACTIONS(6659),
    [anon_sym_if] = ACTIONS(6659),
    [anon_sym_switch] = ACTIONS(6659),
    [anon_sym_case] = ACTIONS(6659),
    [anon_sym_default] = ACTIONS(6659),
    [anon_sym_while] = ACTIONS(6659),
    [anon_sym_do] = ACTIONS(6659),
    [anon_sym_for] = ACTIONS(6659),
    [anon_sym_return] = ACTIONS(6659),
    [anon_sym_break] = ACTIONS(6659),
    [anon_sym_continue] = ACTIONS(6659),
    [anon_sym_goto] = ACTIONS(6659),
    [anon_sym_AMP] = ACTIONS(6657),
    [anon_sym_BANG] = ACTIONS(6657),
    [anon_sym_TILDE] = ACTIONS(6657),
    [anon_sym_PLUS] = ACTIONS(6659),
    [anon_sym_DASH] = ACTIONS(6659),
    [anon_sym_DASH_DASH] = ACTIONS(6657),
    [anon_sym_PLUS_PLUS] = ACTIONS(6657),
    [anon_sym_sizeof] = ACTIONS(6659),
    [sym_number_literal] = ACTIONS(6657),
    [sym_char_literal] = ACTIONS(6657),
    [sym_string_literal] = ACTIONS(6657),
    [sym_true] = ACTIONS(6659),
    [sym_false] = ACTIONS(6659),
    [sym_null] = ACTIONS(6659),
    [sym_identifier] = ACTIONS(6659),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(6659),
    [sym_auto] = ACTIONS(6659),
    [anon_sym_typename] = ACTIONS(6659),
    [anon_sym_new] = ACTIONS(6659),
    [anon_sym_COLON_COLON] = ACTIONS(6657),
    [anon_sym_delete] = ACTIONS(6659),
    [sym_nullptr] = ACTIONS(6659),
  },
  [2641] = {
    [sym__expression] = STATE(2793),
    [sym_conditional_expression] = STATE(2793),
    [sym_assignment_expression] = STATE(2793),
    [sym_pointer_expression] = STATE(2793),
    [sym_logical_expression] = STATE(2793),
    [sym_bitwise_expression] = STATE(2793),
    [sym_equality_expression] = STATE(2793),
    [sym_relational_expression] = STATE(2793),
    [sym_shift_expression] = STATE(2793),
    [sym_math_expression] = STATE(2793),
    [sym_cast_expression] = STATE(2793),
    [sym_sizeof_expression] = STATE(2793),
    [sym_subscript_expression] = STATE(2793),
    [sym_call_expression] = STATE(2793),
    [sym_field_expression] = STATE(2793),
    [sym_compound_literal_expression] = STATE(2793),
    [sym_parenthesized_expression] = STATE(2793),
    [sym_concatenated_string] = STATE(2793),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(2793),
    [sym_new_expression] = STATE(2793),
    [sym_delete_expression] = STATE(2793),
    [sym_lambda_expression] = STATE(2793),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(6661),
    [anon_sym_LPAREN] = ACTIONS(1087),
    [anon_sym_STAR] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_AMP] = ACTIONS(1089),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1093),
    [anon_sym_PLUS] = ACTIONS(1095),
    [anon_sym_DASH] = ACTIONS(1095),
    [anon_sym_DASH_DASH] = ACTIONS(1097),
    [anon_sym_PLUS_PLUS] = ACTIONS(1097),
    [anon_sym_sizeof] = ACTIONS(1099),
    [sym_number_literal] = ACTIONS(6661),
    [sym_char_literal] = ACTIONS(6661),
    [sym_string_literal] = ACTIONS(1101),
    [sym_true] = ACTIONS(6663),
    [sym_false] = ACTIONS(6663),
    [sym_null] = ACTIONS(6663),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_delete] = ACTIONS(1109),
    [sym_nullptr] = ACTIONS(6663),
  },
  [2642] = {
    [sym_compound_statement] = STATE(2794),
    [sym_labeled_statement] = STATE(2794),
    [sym_expression_statement] = STATE(2794),
    [sym_if_statement] = STATE(2794),
    [sym_switch_statement] = STATE(2794),
    [sym_case_statement] = STATE(2794),
    [sym_while_statement] = STATE(2794),
    [sym_do_statement] = STATE(2794),
    [sym_for_statement] = STATE(2794),
    [sym_return_statement] = STATE(2794),
    [sym_break_statement] = STATE(2794),
    [sym_continue_statement] = STATE(2794),
    [sym_goto_statement] = STATE(2794),
    [sym__expression] = STATE(413),
    [sym_comma_expression] = STATE(414),
    [sym_conditional_expression] = STATE(413),
    [sym_assignment_expression] = STATE(413),
    [sym_pointer_expression] = STATE(413),
    [sym_logical_expression] = STATE(413),
    [sym_bitwise_expression] = STATE(413),
    [sym_equality_expression] = STATE(413),
    [sym_relational_expression] = STATE(413),
    [sym_shift_expression] = STATE(413),
    [sym_math_expression] = STATE(413),
    [sym_cast_expression] = STATE(413),
    [sym_sizeof_expression] = STATE(413),
    [sym_subscript_expression] = STATE(413),
    [sym_call_expression] = STATE(413),
    [sym_field_expression] = STATE(413),
    [sym_compound_literal_expression] = STATE(413),
    [sym_parenthesized_expression] = STATE(413),
    [sym_concatenated_string] = STATE(413),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(413),
    [sym_for_range_loop] = STATE(2794),
    [sym_new_expression] = STATE(413),
    [sym_delete_expression] = STATE(413),
    [sym_lambda_expression] = STATE(413),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(620),
    [anon_sym_LPAREN] = ACTIONS(626),
    [anon_sym_SEMI] = ACTIONS(636),
    [anon_sym_LBRACE] = ACTIONS(640),
    [anon_sym_STAR] = ACTIONS(644),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_if] = ACTIONS(646),
    [anon_sym_switch] = ACTIONS(648),
    [anon_sym_case] = ACTIONS(650),
    [anon_sym_default] = ACTIONS(652),
    [anon_sym_while] = ACTIONS(654),
    [anon_sym_do] = ACTIONS(656),
    [anon_sym_for] = ACTIONS(658),
    [anon_sym_return] = ACTIONS(660),
    [anon_sym_break] = ACTIONS(662),
    [anon_sym_continue] = ACTIONS(664),
    [anon_sym_goto] = ACTIONS(666),
    [anon_sym_AMP] = ACTIONS(644),
    [anon_sym_BANG] = ACTIONS(668),
    [anon_sym_TILDE] = ACTIONS(670),
    [anon_sym_PLUS] = ACTIONS(672),
    [anon_sym_DASH] = ACTIONS(672),
    [anon_sym_DASH_DASH] = ACTIONS(674),
    [anon_sym_PLUS_PLUS] = ACTIONS(674),
    [anon_sym_sizeof] = ACTIONS(676),
    [sym_number_literal] = ACTIONS(620),
    [sym_char_literal] = ACTIONS(620),
    [sym_string_literal] = ACTIONS(678),
    [sym_true] = ACTIONS(680),
    [sym_false] = ACTIONS(680),
    [sym_null] = ACTIONS(680),
    [sym_identifier] = ACTIONS(3110),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1303),
    [anon_sym_delete] = ACTIONS(686),
    [sym_nullptr] = ACTIONS(680),
  },
  [2643] = {
    [aux_sym_for_statement_repeat1] = STATE(2796),
    [anon_sym_COMMA] = ACTIONS(6339),
    [anon_sym_RPAREN] = ACTIONS(6665),
    [sym_comment] = ACTIONS(49),
  },
  [2644] = {
    [sym_argument_list] = STATE(802),
    [aux_sym_for_statement_repeat1] = STATE(2797),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_COMMA] = ACTIONS(6339),
    [anon_sym_RPAREN] = ACTIONS(6665),
    [anon_sym_STAR] = ACTIONS(2234),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_EQ] = ACTIONS(2236),
    [anon_sym_QMARK] = ACTIONS(2238),
    [anon_sym_STAR_EQ] = ACTIONS(2240),
    [anon_sym_SLASH_EQ] = ACTIONS(2240),
    [anon_sym_PERCENT_EQ] = ACTIONS(2240),
    [anon_sym_PLUS_EQ] = ACTIONS(2240),
    [anon_sym_DASH_EQ] = ACTIONS(2240),
    [anon_sym_LT_LT_EQ] = ACTIONS(2240),
    [anon_sym_GT_GT_EQ] = ACTIONS(2240),
    [anon_sym_AMP_EQ] = ACTIONS(2240),
    [anon_sym_CARET_EQ] = ACTIONS(2240),
    [anon_sym_PIPE_EQ] = ACTIONS(2240),
    [anon_sym_AMP] = ACTIONS(2242),
    [anon_sym_PIPE_PIPE] = ACTIONS(2244),
    [anon_sym_AMP_AMP] = ACTIONS(2246),
    [anon_sym_PIPE] = ACTIONS(2248),
    [anon_sym_CARET] = ACTIONS(2250),
    [anon_sym_EQ_EQ] = ACTIONS(2252),
    [anon_sym_BANG_EQ] = ACTIONS(2252),
    [anon_sym_LT] = ACTIONS(2254),
    [anon_sym_GT] = ACTIONS(2254),
    [anon_sym_LT_EQ] = ACTIONS(2256),
    [anon_sym_GT_EQ] = ACTIONS(2256),
    [anon_sym_LT_LT] = ACTIONS(2258),
    [anon_sym_GT_GT] = ACTIONS(2258),
    [anon_sym_PLUS] = ACTIONS(2260),
    [anon_sym_DASH] = ACTIONS(2260),
    [anon_sym_SLASH] = ACTIONS(2234),
    [anon_sym_PERCENT] = ACTIONS(2234),
    [anon_sym_DASH_DASH] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(1554),
    [anon_sym_DASH_GT] = ACTIONS(1554),
    [sym_comment] = ACTIONS(49),
  },
  [2645] = {
    [sym__type_specifier] = STATE(2799),
    [sym_sized_type_specifier] = STATE(2799),
    [sym_enum_specifier] = STATE(2799),
    [sym_struct_specifier] = STATE(2799),
    [sym_union_specifier] = STATE(2799),
    [sym_macro_type_specifier] = STATE(2799),
    [sym_class_specifier] = STATE(2799),
    [sym_dependent_type] = STATE(2799),
    [sym_template_type] = STATE(825),
    [sym_scoped_type_identifier] = STATE(826),
    [sym_scoped_namespace_identifier] = STATE(827),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2800),
    [anon_sym_unsigned] = ACTIONS(6667),
    [anon_sym_long] = ACTIONS(6667),
    [anon_sym_short] = ACTIONS(6667),
    [sym_primitive_type] = ACTIONS(6669),
    [anon_sym_enum] = ACTIONS(1582),
    [anon_sym_struct] = ACTIONS(1584),
    [anon_sym_union] = ACTIONS(1586),
    [sym_identifier] = ACTIONS(1588),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(1590),
    [sym_auto] = ACTIONS(6669),
    [anon_sym_typename] = ACTIONS(6671),
    [anon_sym_COLON_COLON] = ACTIONS(1594),
  },
  [2646] = {
    [sym_type_qualifier] = STATE(2801),
    [sym_trailing_return_type] = STATE(2801),
    [aux_sym_function_declarator_repeat1] = STATE(2801),
    [anon_sym_LPAREN] = ACTIONS(1596),
    [anon_sym_COMMA] = ACTIONS(1596),
    [anon_sym_SEMI] = ACTIONS(1596),
    [anon_sym_LBRACE] = ACTIONS(1596),
    [anon_sym_LBRACK] = ACTIONS(1596),
    [anon_sym_EQ] = ACTIONS(1596),
    [anon_sym_const] = ACTIONS(612),
    [anon_sym_restrict] = ACTIONS(614),
    [anon_sym_volatile] = ACTIONS(614),
    [anon_sym__Atomic] = ACTIONS(614),
    [anon_sym_mutable] = ACTIONS(614),
    [anon_sym_explicit] = ACTIONS(614),
    [anon_sym_constexpr] = ACTIONS(614),
    [anon_sym_COLON] = ACTIONS(1596),
    [anon_sym_DASH_GT] = ACTIONS(6347),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(6673),
  },
  [2647] = {
    [sym_raw_string_literal] = ACTIONS(2478),
    [anon_sym_LPAREN] = ACTIONS(2478),
    [anon_sym_SEMI] = ACTIONS(2478),
    [anon_sym_STAR] = ACTIONS(2478),
    [anon_sym_LBRACK] = ACTIONS(2478),
    [anon_sym_AMP] = ACTIONS(2478),
    [anon_sym_BANG] = ACTIONS(2478),
    [anon_sym_TILDE] = ACTIONS(2478),
    [anon_sym_PLUS] = ACTIONS(2480),
    [anon_sym_DASH] = ACTIONS(2480),
    [anon_sym_DASH_DASH] = ACTIONS(2478),
    [anon_sym_PLUS_PLUS] = ACTIONS(2478),
    [anon_sym_sizeof] = ACTIONS(2480),
    [sym_number_literal] = ACTIONS(2478),
    [sym_char_literal] = ACTIONS(2478),
    [sym_string_literal] = ACTIONS(2478),
    [sym_true] = ACTIONS(2480),
    [sym_false] = ACTIONS(2480),
    [sym_null] = ACTIONS(2480),
    [sym_identifier] = ACTIONS(2480),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(2480),
    [anon_sym_COLON_COLON] = ACTIONS(2478),
    [anon_sym_delete] = ACTIONS(2480),
    [sym_nullptr] = ACTIONS(2480),
  },
  [2648] = {
    [sym__expression] = STATE(2802),
    [sym_conditional_expression] = STATE(2802),
    [sym_assignment_expression] = STATE(2802),
    [sym_pointer_expression] = STATE(2802),
    [sym_logical_expression] = STATE(2802),
    [sym_bitwise_expression] = STATE(2802),
    [sym_equality_expression] = STATE(2802),
    [sym_relational_expression] = STATE(2802),
    [sym_shift_expression] = STATE(2802),
    [sym_math_expression] = STATE(2802),
    [sym_cast_expression] = STATE(2802),
    [sym_sizeof_expression] = STATE(2802),
    [sym_subscript_expression] = STATE(2802),
    [sym_call_expression] = STATE(2802),
    [sym_field_expression] = STATE(2802),
    [sym_compound_literal_expression] = STATE(2802),
    [sym_parenthesized_expression] = STATE(2802),
    [sym_concatenated_string] = STATE(2802),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(2802),
    [sym_new_expression] = STATE(2802),
    [sym_delete_expression] = STATE(2802),
    [sym_lambda_expression] = STATE(2802),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(6675),
    [anon_sym_LPAREN] = ACTIONS(1087),
    [anon_sym_RPAREN] = ACTIONS(6665),
    [anon_sym_STAR] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_AMP] = ACTIONS(1089),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1093),
    [anon_sym_PLUS] = ACTIONS(1095),
    [anon_sym_DASH] = ACTIONS(1095),
    [anon_sym_DASH_DASH] = ACTIONS(1097),
    [anon_sym_PLUS_PLUS] = ACTIONS(1097),
    [anon_sym_sizeof] = ACTIONS(1099),
    [sym_number_literal] = ACTIONS(6675),
    [sym_char_literal] = ACTIONS(6675),
    [sym_string_literal] = ACTIONS(1101),
    [sym_true] = ACTIONS(6677),
    [sym_false] = ACTIONS(6677),
    [sym_null] = ACTIONS(6677),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_delete] = ACTIONS(1109),
    [sym_nullptr] = ACTIONS(6677),
  },
  [2649] = {
    [sym_compound_statement] = STATE(2803),
    [sym_labeled_statement] = STATE(2803),
    [sym_expression_statement] = STATE(2803),
    [sym_if_statement] = STATE(2803),
    [sym_switch_statement] = STATE(2803),
    [sym_case_statement] = STATE(2803),
    [sym_while_statement] = STATE(2803),
    [sym_do_statement] = STATE(2803),
    [sym_for_statement] = STATE(2803),
    [sym_return_statement] = STATE(2803),
    [sym_break_statement] = STATE(2803),
    [sym_continue_statement] = STATE(2803),
    [sym_goto_statement] = STATE(2803),
    [sym__expression] = STATE(413),
    [sym_comma_expression] = STATE(414),
    [sym_conditional_expression] = STATE(413),
    [sym_assignment_expression] = STATE(413),
    [sym_pointer_expression] = STATE(413),
    [sym_logical_expression] = STATE(413),
    [sym_bitwise_expression] = STATE(413),
    [sym_equality_expression] = STATE(413),
    [sym_relational_expression] = STATE(413),
    [sym_shift_expression] = STATE(413),
    [sym_math_expression] = STATE(413),
    [sym_cast_expression] = STATE(413),
    [sym_sizeof_expression] = STATE(413),
    [sym_subscript_expression] = STATE(413),
    [sym_call_expression] = STATE(413),
    [sym_field_expression] = STATE(413),
    [sym_compound_literal_expression] = STATE(413),
    [sym_parenthesized_expression] = STATE(413),
    [sym_concatenated_string] = STATE(413),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(413),
    [sym_for_range_loop] = STATE(2803),
    [sym_new_expression] = STATE(413),
    [sym_delete_expression] = STATE(413),
    [sym_lambda_expression] = STATE(413),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(620),
    [anon_sym_LPAREN] = ACTIONS(626),
    [anon_sym_SEMI] = ACTIONS(636),
    [anon_sym_LBRACE] = ACTIONS(640),
    [anon_sym_STAR] = ACTIONS(644),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_if] = ACTIONS(646),
    [anon_sym_switch] = ACTIONS(648),
    [anon_sym_case] = ACTIONS(650),
    [anon_sym_default] = ACTIONS(652),
    [anon_sym_while] = ACTIONS(654),
    [anon_sym_do] = ACTIONS(656),
    [anon_sym_for] = ACTIONS(658),
    [anon_sym_return] = ACTIONS(660),
    [anon_sym_break] = ACTIONS(662),
    [anon_sym_continue] = ACTIONS(664),
    [anon_sym_goto] = ACTIONS(666),
    [anon_sym_AMP] = ACTIONS(644),
    [anon_sym_BANG] = ACTIONS(668),
    [anon_sym_TILDE] = ACTIONS(670),
    [anon_sym_PLUS] = ACTIONS(672),
    [anon_sym_DASH] = ACTIONS(672),
    [anon_sym_DASH_DASH] = ACTIONS(674),
    [anon_sym_PLUS_PLUS] = ACTIONS(674),
    [anon_sym_sizeof] = ACTIONS(676),
    [sym_number_literal] = ACTIONS(620),
    [sym_char_literal] = ACTIONS(620),
    [sym_string_literal] = ACTIONS(678),
    [sym_true] = ACTIONS(680),
    [sym_false] = ACTIONS(680),
    [sym_null] = ACTIONS(680),
    [sym_identifier] = ACTIONS(3110),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1303),
    [anon_sym_delete] = ACTIONS(686),
    [sym_nullptr] = ACTIONS(680),
  },
  [2650] = {
    [sym_field_declaration_list] = STATE(1361),
    [sym__class_name] = STATE(2804),
    [sym_base_class_clause] = STATE(1363),
    [sym_template_type] = STATE(1364),
    [sym_scoped_type_identifier] = STATE(1365),
    [sym_scoped_namespace_identifier] = STATE(827),
    [anon_sym_LBRACE] = ACTIONS(2829),
    [anon_sym_COLON] = ACTIONS(131),
    [sym_identifier] = ACTIONS(2831),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(1594),
  },
  [2651] = {
    [sym_field_declaration_list] = STATE(1366),
    [sym__class_name] = STATE(2805),
    [sym_base_class_clause] = STATE(1368),
    [sym_template_type] = STATE(1364),
    [sym_scoped_type_identifier] = STATE(1365),
    [sym_scoped_namespace_identifier] = STATE(827),
    [anon_sym_LBRACE] = ACTIONS(2829),
    [anon_sym_COLON] = ACTIONS(131),
    [sym_identifier] = ACTIONS(2831),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(1594),
  },
  [2652] = {
    [sym_field_declaration_list] = STATE(1372),
    [sym__class_name] = STATE(2806),
    [sym_base_class_clause] = STATE(1374),
    [sym_template_type] = STATE(1364),
    [sym_scoped_type_identifier] = STATE(1365),
    [sym_scoped_namespace_identifier] = STATE(827),
    [anon_sym_LBRACE] = ACTIONS(2829),
    [anon_sym_COLON] = ACTIONS(131),
    [sym_identifier] = ACTIONS(2831),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(1594),
  },
  [2653] = {
    [sym__type_specifier] = STATE(1375),
    [sym_sized_type_specifier] = STATE(1375),
    [sym_enum_specifier] = STATE(1375),
    [sym_struct_specifier] = STATE(1375),
    [sym_union_specifier] = STATE(1375),
    [sym_macro_type_specifier] = STATE(1375),
    [sym_class_specifier] = STATE(1375),
    [sym_dependent_type] = STATE(1375),
    [sym_template_type] = STATE(825),
    [sym_scoped_type_identifier] = STATE(826),
    [sym_scoped_namespace_identifier] = STATE(827),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2655),
    [anon_sym_unsigned] = ACTIONS(6361),
    [anon_sym_long] = ACTIONS(6361),
    [anon_sym_short] = ACTIONS(6361),
    [sym_primitive_type] = ACTIONS(2837),
    [anon_sym_enum] = ACTIONS(1833),
    [anon_sym_struct] = ACTIONS(6365),
    [anon_sym_union] = ACTIONS(6367),
    [sym_identifier] = ACTIONS(1588),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(6369),
    [sym_auto] = ACTIONS(2837),
    [anon_sym_typename] = ACTIONS(6371),
    [anon_sym_COLON_COLON] = ACTIONS(1594),
  },
  [2654] = {
    [sym__abstract_declarator] = STATE(2809),
    [sym_abstract_pointer_declarator] = STATE(2809),
    [sym_abstract_function_declarator] = STATE(2809),
    [sym_abstract_array_declarator] = STATE(2809),
    [sym_parameter_list] = STATE(2810),
    [sym_abstract_reference_declarator] = STATE(2809),
    [anon_sym_LPAREN] = ACTIONS(1115),
    [anon_sym_COMMA] = ACTIONS(2841),
    [anon_sym_SEMI] = ACTIONS(2841),
    [anon_sym_STAR] = ACTIONS(6679),
    [anon_sym_LBRACK] = ACTIONS(1121),
    [anon_sym_const] = ACTIONS(2845),
    [anon_sym_restrict] = ACTIONS(2841),
    [anon_sym_volatile] = ACTIONS(2841),
    [anon_sym__Atomic] = ACTIONS(2841),
    [anon_sym_mutable] = ACTIONS(2841),
    [anon_sym_explicit] = ACTIONS(2841),
    [anon_sym_constexpr] = ACTIONS(2841),
    [anon_sym_COLON] = ACTIONS(2841),
    [anon_sym_AMP] = ACTIONS(6681),
    [anon_sym_AMP_AMP] = ACTIONS(6683),
    [anon_sym_DASH_GT] = ACTIONS(2841),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(2841),
  },
  [2655] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2811),
    [anon_sym_LPAREN] = ACTIONS(238),
    [anon_sym_COMMA] = ACTIONS(238),
    [anon_sym_SEMI] = ACTIONS(238),
    [anon_sym_STAR] = ACTIONS(238),
    [anon_sym_LBRACK] = ACTIONS(238),
    [anon_sym_const] = ACTIONS(240),
    [anon_sym_restrict] = ACTIONS(240),
    [anon_sym_volatile] = ACTIONS(240),
    [anon_sym__Atomic] = ACTIONS(240),
    [anon_sym_mutable] = ACTIONS(240),
    [anon_sym_explicit] = ACTIONS(240),
    [anon_sym_constexpr] = ACTIONS(240),
    [anon_sym_unsigned] = ACTIONS(6685),
    [anon_sym_long] = ACTIONS(6685),
    [anon_sym_short] = ACTIONS(6685),
    [sym_primitive_type] = ACTIONS(2855),
    [anon_sym_COLON] = ACTIONS(238),
    [anon_sym_AMP] = ACTIONS(240),
    [anon_sym_AMP_AMP] = ACTIONS(238),
    [anon_sym_DASH_GT] = ACTIONS(238),
    [sym_identifier] = ACTIONS(2857),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(240),
  },
  [2656] = {
    [sym_type_qualifier] = STATE(2656),
    [sym_trailing_return_type] = STATE(2656),
    [aux_sym_function_declarator_repeat1] = STATE(2656),
    [anon_sym_LPAREN] = ACTIONS(2859),
    [anon_sym_COMMA] = ACTIONS(2859),
    [anon_sym_SEMI] = ACTIONS(2859),
    [anon_sym_LBRACK] = ACTIONS(2859),
    [anon_sym_const] = ACTIONS(2861),
    [anon_sym_restrict] = ACTIONS(2864),
    [anon_sym_volatile] = ACTIONS(2864),
    [anon_sym__Atomic] = ACTIONS(2864),
    [anon_sym_mutable] = ACTIONS(2864),
    [anon_sym_explicit] = ACTIONS(2864),
    [anon_sym_constexpr] = ACTIONS(2864),
    [anon_sym_COLON] = ACTIONS(2859),
    [anon_sym_DASH_GT] = ACTIONS(6687),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(6690),
  },
  [2657] = {
    [sym_parameter_list] = STATE(2659),
    [anon_sym_LPAREN] = ACTIONS(206),
    [anon_sym_COMMA] = ACTIONS(3750),
    [anon_sym_SEMI] = ACTIONS(3750),
    [anon_sym_LBRACE] = ACTIONS(3750),
    [anon_sym_LBRACK] = ACTIONS(2282),
    [anon_sym_const] = ACTIONS(5283),
    [anon_sym_restrict] = ACTIONS(3750),
    [anon_sym_volatile] = ACTIONS(3750),
    [anon_sym__Atomic] = ACTIONS(3750),
    [anon_sym_mutable] = ACTIONS(3750),
    [anon_sym_explicit] = ACTIONS(3750),
    [anon_sym_constexpr] = ACTIONS(3750),
    [anon_sym_COLON] = ACTIONS(3750),
    [anon_sym_DASH_GT] = ACTIONS(3750),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(3750),
  },
  [2658] = {
    [sym_parameter_list] = STATE(2659),
    [anon_sym_LPAREN] = ACTIONS(206),
    [anon_sym_COMMA] = ACTIONS(3762),
    [anon_sym_SEMI] = ACTIONS(3762),
    [anon_sym_LBRACE] = ACTIONS(3762),
    [anon_sym_LBRACK] = ACTIONS(2282),
    [anon_sym_const] = ACTIONS(5285),
    [anon_sym_restrict] = ACTIONS(3762),
    [anon_sym_volatile] = ACTIONS(3762),
    [anon_sym__Atomic] = ACTIONS(3762),
    [anon_sym_mutable] = ACTIONS(3762),
    [anon_sym_explicit] = ACTIONS(3762),
    [anon_sym_constexpr] = ACTIONS(3762),
    [anon_sym_COLON] = ACTIONS(3762),
    [anon_sym_DASH_GT] = ACTIONS(3762),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(3762),
  },
  [2659] = {
    [sym_type_qualifier] = STATE(2812),
    [sym_trailing_return_type] = STATE(1713),
    [aux_sym_abstract_function_declarator_repeat1] = STATE(2812),
    [anon_sym_LPAREN] = ACTIONS(3764),
    [anon_sym_COMMA] = ACTIONS(3764),
    [anon_sym_SEMI] = ACTIONS(3764),
    [anon_sym_LBRACE] = ACTIONS(3764),
    [anon_sym_LBRACK] = ACTIONS(3764),
    [anon_sym_const] = ACTIONS(3770),
    [anon_sym_restrict] = ACTIONS(3764),
    [anon_sym_volatile] = ACTIONS(3764),
    [anon_sym__Atomic] = ACTIONS(3764),
    [anon_sym_mutable] = ACTIONS(3764),
    [anon_sym_explicit] = ACTIONS(3764),
    [anon_sym_constexpr] = ACTIONS(3764),
    [anon_sym_COLON] = ACTIONS(3764),
    [anon_sym_DASH_GT] = ACTIONS(3764),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(3764),
  },
  [2660] = {
    [sym_type_qualifier] = STATE(2813),
    [sym_trailing_return_type] = STATE(1713),
    [aux_sym_abstract_function_declarator_repeat1] = STATE(2813),
    [anon_sym_LPAREN] = ACTIONS(3764),
    [anon_sym_COMMA] = ACTIONS(3764),
    [anon_sym_SEMI] = ACTIONS(3764),
    [anon_sym_LBRACE] = ACTIONS(3764),
    [anon_sym_LBRACK] = ACTIONS(3764),
    [anon_sym_const] = ACTIONS(612),
    [anon_sym_restrict] = ACTIONS(614),
    [anon_sym_volatile] = ACTIONS(614),
    [anon_sym__Atomic] = ACTIONS(614),
    [anon_sym_mutable] = ACTIONS(614),
    [anon_sym_explicit] = ACTIONS(614),
    [anon_sym_constexpr] = ACTIONS(614),
    [anon_sym_COLON] = ACTIONS(3764),
    [anon_sym_DASH_GT] = ACTIONS(3647),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(6693),
  },
  [2661] = {
    [sym_type_qualifier] = STATE(2662),
    [sym_trailing_return_type] = STATE(2168),
    [aux_sym_abstract_function_declarator_repeat1] = STATE(2662),
    [anon_sym_LPAREN] = ACTIONS(4998),
    [anon_sym_SEMI] = ACTIONS(4998),
    [anon_sym_LBRACE] = ACTIONS(4998),
    [anon_sym_LBRACK] = ACTIONS(4998),
    [anon_sym_const] = ACTIONS(612),
    [anon_sym_restrict] = ACTIONS(614),
    [anon_sym_volatile] = ACTIONS(614),
    [anon_sym__Atomic] = ACTIONS(614),
    [anon_sym_mutable] = ACTIONS(614),
    [anon_sym_explicit] = ACTIONS(614),
    [anon_sym_constexpr] = ACTIONS(614),
    [anon_sym_COLON] = ACTIONS(4998),
    [anon_sym_DASH_GT] = ACTIONS(2102),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(6384),
  },
  [2662] = {
    [sym_type_qualifier] = STATE(2662),
    [aux_sym_abstract_function_declarator_repeat1] = STATE(2662),
    [anon_sym_LPAREN] = ACTIONS(5002),
    [anon_sym_SEMI] = ACTIONS(5002),
    [anon_sym_LBRACE] = ACTIONS(5002),
    [anon_sym_LBRACK] = ACTIONS(5002),
    [anon_sym_const] = ACTIONS(5004),
    [anon_sym_restrict] = ACTIONS(5007),
    [anon_sym_volatile] = ACTIONS(5007),
    [anon_sym__Atomic] = ACTIONS(5007),
    [anon_sym_mutable] = ACTIONS(5007),
    [anon_sym_explicit] = ACTIONS(5007),
    [anon_sym_constexpr] = ACTIONS(5007),
    [anon_sym_COLON] = ACTIONS(5002),
    [anon_sym_DASH_GT] = ACTIONS(5002),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(6695),
  },
  [2663] = {
    [anon_sym_COMMA] = ACTIONS(5913),
    [anon_sym_GT] = ACTIONS(5913),
    [sym_comment] = ACTIONS(49),
  },
  [2664] = {
    [sym__expression] = STATE(1834),
    [sym_conditional_expression] = STATE(1834),
    [sym_assignment_expression] = STATE(1834),
    [sym_pointer_expression] = STATE(1834),
    [sym_logical_expression] = STATE(1834),
    [sym_bitwise_expression] = STATE(1834),
    [sym_equality_expression] = STATE(1834),
    [sym_relational_expression] = STATE(1834),
    [sym_shift_expression] = STATE(1834),
    [sym_math_expression] = STATE(1834),
    [sym_cast_expression] = STATE(1834),
    [sym_sizeof_expression] = STATE(1834),
    [sym_subscript_expression] = STATE(1834),
    [sym_call_expression] = STATE(1834),
    [sym_field_expression] = STATE(1834),
    [sym_compound_literal_expression] = STATE(1834),
    [sym_parenthesized_expression] = STATE(1834),
    [sym_initializer_list] = STATE(1835),
    [sym_concatenated_string] = STATE(1834),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(1834),
    [sym_new_expression] = STATE(1834),
    [sym_delete_expression] = STATE(1834),
    [sym_lambda_expression] = STATE(1834),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(4145),
    [anon_sym_LPAREN] = ACTIONS(3807),
    [anon_sym_COMMA] = ACTIONS(5210),
    [anon_sym_LBRACE] = ACTIONS(548),
    [anon_sym_STAR] = ACTIONS(6698),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_EQ] = ACTIONS(5212),
    [anon_sym_QMARK] = ACTIONS(5210),
    [anon_sym_STAR_EQ] = ACTIONS(5210),
    [anon_sym_SLASH_EQ] = ACTIONS(5210),
    [anon_sym_PERCENT_EQ] = ACTIONS(5210),
    [anon_sym_PLUS_EQ] = ACTIONS(5210),
    [anon_sym_DASH_EQ] = ACTIONS(5210),
    [anon_sym_LT_LT_EQ] = ACTIONS(5210),
    [anon_sym_GT_GT_EQ] = ACTIONS(5210),
    [anon_sym_AMP_EQ] = ACTIONS(5210),
    [anon_sym_CARET_EQ] = ACTIONS(5210),
    [anon_sym_PIPE_EQ] = ACTIONS(5210),
    [anon_sym_AMP] = ACTIONS(6698),
    [anon_sym_PIPE_PIPE] = ACTIONS(5210),
    [anon_sym_AMP_AMP] = ACTIONS(5210),
    [anon_sym_BANG] = ACTIONS(6700),
    [anon_sym_PIPE] = ACTIONS(5212),
    [anon_sym_CARET] = ACTIONS(5212),
    [anon_sym_TILDE] = ACTIONS(3813),
    [anon_sym_EQ_EQ] = ACTIONS(5210),
    [anon_sym_BANG_EQ] = ACTIONS(5210),
    [anon_sym_LT] = ACTIONS(5212),
    [anon_sym_GT] = ACTIONS(5212),
    [anon_sym_LT_EQ] = ACTIONS(5210),
    [anon_sym_GT_EQ] = ACTIONS(5210),
    [anon_sym_LT_LT] = ACTIONS(5212),
    [anon_sym_GT_GT] = ACTIONS(5212),
    [anon_sym_PLUS] = ACTIONS(3815),
    [anon_sym_DASH] = ACTIONS(3815),
    [anon_sym_SLASH] = ACTIONS(5212),
    [anon_sym_PERCENT] = ACTIONS(5212),
    [anon_sym_DASH_DASH] = ACTIONS(3817),
    [anon_sym_PLUS_PLUS] = ACTIONS(3817),
    [anon_sym_sizeof] = ACTIONS(3819),
    [anon_sym_DOT] = ACTIONS(5210),
    [anon_sym_DASH_GT] = ACTIONS(5210),
    [sym_number_literal] = ACTIONS(4145),
    [sym_char_literal] = ACTIONS(4145),
    [sym_string_literal] = ACTIONS(3821),
    [sym_true] = ACTIONS(4147),
    [sym_false] = ACTIONS(4147),
    [sym_null] = ACTIONS(4147),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(3825),
    [anon_sym_delete] = ACTIONS(3827),
    [sym_nullptr] = ACTIONS(4147),
  },
  [2665] = {
    [sym__expression] = STATE(2814),
    [sym_conditional_expression] = STATE(2814),
    [sym_assignment_expression] = STATE(2814),
    [sym_pointer_expression] = STATE(2814),
    [sym_logical_expression] = STATE(2814),
    [sym_bitwise_expression] = STATE(2814),
    [sym_equality_expression] = STATE(2814),
    [sym_relational_expression] = STATE(2814),
    [sym_shift_expression] = STATE(2814),
    [sym_math_expression] = STATE(2814),
    [sym_cast_expression] = STATE(2814),
    [sym_sizeof_expression] = STATE(2814),
    [sym_subscript_expression] = STATE(2814),
    [sym_call_expression] = STATE(2814),
    [sym_field_expression] = STATE(2814),
    [sym_compound_literal_expression] = STATE(2814),
    [sym_parenthesized_expression] = STATE(2814),
    [sym_concatenated_string] = STATE(2814),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(2814),
    [sym_new_expression] = STATE(2814),
    [sym_delete_expression] = STATE(2814),
    [sym_lambda_expression] = STATE(2814),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(6702),
    [anon_sym_LPAREN] = ACTIONS(2624),
    [anon_sym_STAR] = ACTIONS(2624),
    [anon_sym_LBRACK] = ACTIONS(2624),
    [anon_sym_AMP] = ACTIONS(2626),
    [anon_sym_AMP_AMP] = ACTIONS(2624),
    [anon_sym_BANG] = ACTIONS(3811),
    [anon_sym_TILDE] = ACTIONS(3813),
    [anon_sym_PLUS] = ACTIONS(3815),
    [anon_sym_DASH] = ACTIONS(3815),
    [anon_sym_DASH_DASH] = ACTIONS(3817),
    [anon_sym_PLUS_PLUS] = ACTIONS(3817),
    [anon_sym_sizeof] = ACTIONS(3819),
    [sym_number_literal] = ACTIONS(6702),
    [sym_char_literal] = ACTIONS(6702),
    [sym_string_literal] = ACTIONS(3821),
    [sym_true] = ACTIONS(6704),
    [sym_false] = ACTIONS(6704),
    [sym_null] = ACTIONS(6704),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(3825),
    [anon_sym_delete] = ACTIONS(3827),
    [sym_nullptr] = ACTIONS(6704),
  },
  [2666] = {
    [sym_argument_list] = STATE(802),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_COMMA] = ACTIONS(5236),
    [anon_sym_STAR] = ACTIONS(5039),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_EQ] = ACTIONS(5238),
    [anon_sym_QMARK] = ACTIONS(5236),
    [anon_sym_STAR_EQ] = ACTIONS(5236),
    [anon_sym_SLASH_EQ] = ACTIONS(5236),
    [anon_sym_PERCENT_EQ] = ACTIONS(5236),
    [anon_sym_PLUS_EQ] = ACTIONS(5236),
    [anon_sym_DASH_EQ] = ACTIONS(5236),
    [anon_sym_LT_LT_EQ] = ACTIONS(5236),
    [anon_sym_GT_GT_EQ] = ACTIONS(5236),
    [anon_sym_AMP_EQ] = ACTIONS(5236),
    [anon_sym_CARET_EQ] = ACTIONS(5236),
    [anon_sym_PIPE_EQ] = ACTIONS(5236),
    [anon_sym_AMP] = ACTIONS(5047),
    [anon_sym_PIPE_PIPE] = ACTIONS(5049),
    [anon_sym_AMP_AMP] = ACTIONS(5051),
    [anon_sym_PIPE] = ACTIONS(5053),
    [anon_sym_CARET] = ACTIONS(5055),
    [anon_sym_EQ_EQ] = ACTIONS(5057),
    [anon_sym_BANG_EQ] = ACTIONS(5057),
    [anon_sym_LT] = ACTIONS(5059),
    [anon_sym_GT] = ACTIONS(5059),
    [anon_sym_LT_EQ] = ACTIONS(5061),
    [anon_sym_GT_EQ] = ACTIONS(5061),
    [anon_sym_LT_LT] = ACTIONS(5063),
    [anon_sym_GT_GT] = ACTIONS(5063),
    [anon_sym_PLUS] = ACTIONS(5065),
    [anon_sym_DASH] = ACTIONS(5065),
    [anon_sym_SLASH] = ACTIONS(5039),
    [anon_sym_PERCENT] = ACTIONS(5039),
    [anon_sym_DASH_DASH] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(1554),
    [anon_sym_DASH_GT] = ACTIONS(1554),
    [sym_comment] = ACTIONS(49),
  },
  [2667] = {
    [sym__expression] = STATE(2815),
    [sym_conditional_expression] = STATE(2815),
    [sym_assignment_expression] = STATE(2815),
    [sym_pointer_expression] = STATE(2815),
    [sym_logical_expression] = STATE(2815),
    [sym_bitwise_expression] = STATE(2815),
    [sym_equality_expression] = STATE(2815),
    [sym_relational_expression] = STATE(2815),
    [sym_shift_expression] = STATE(2815),
    [sym_math_expression] = STATE(2815),
    [sym_cast_expression] = STATE(2815),
    [sym_sizeof_expression] = STATE(2815),
    [sym_subscript_expression] = STATE(2815),
    [sym_call_expression] = STATE(2815),
    [sym_field_expression] = STATE(2815),
    [sym_compound_literal_expression] = STATE(2815),
    [sym_parenthesized_expression] = STATE(2815),
    [sym_concatenated_string] = STATE(2815),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(2815),
    [sym_new_expression] = STATE(2815),
    [sym_delete_expression] = STATE(2815),
    [sym_lambda_expression] = STATE(2815),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(6706),
    [anon_sym_LPAREN] = ACTIONS(3807),
    [anon_sym_STAR] = ACTIONS(3809),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_AMP] = ACTIONS(3809),
    [anon_sym_BANG] = ACTIONS(3811),
    [anon_sym_TILDE] = ACTIONS(3813),
    [anon_sym_PLUS] = ACTIONS(3815),
    [anon_sym_DASH] = ACTIONS(3815),
    [anon_sym_DASH_DASH] = ACTIONS(3817),
    [anon_sym_PLUS_PLUS] = ACTIONS(3817),
    [anon_sym_sizeof] = ACTIONS(3819),
    [sym_number_literal] = ACTIONS(6706),
    [sym_char_literal] = ACTIONS(6706),
    [sym_string_literal] = ACTIONS(3821),
    [sym_true] = ACTIONS(6708),
    [sym_false] = ACTIONS(6708),
    [sym_null] = ACTIONS(6708),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(3825),
    [anon_sym_delete] = ACTIONS(3827),
    [sym_nullptr] = ACTIONS(6708),
  },
  [2668] = {
    [sym_parameter_list] = STATE(2670),
    [anon_sym_LPAREN] = ACTIONS(206),
    [anon_sym_COMMA] = ACTIONS(3750),
    [anon_sym_LBRACE] = ACTIONS(3750),
    [anon_sym_LBRACK] = ACTIONS(2282),
    [anon_sym_EQ] = ACTIONS(3750),
    [anon_sym_const] = ACTIONS(5283),
    [anon_sym_restrict] = ACTIONS(3750),
    [anon_sym_volatile] = ACTIONS(3750),
    [anon_sym__Atomic] = ACTIONS(3750),
    [anon_sym_mutable] = ACTIONS(3750),
    [anon_sym_explicit] = ACTIONS(3750),
    [anon_sym_constexpr] = ACTIONS(3750),
    [anon_sym_GT] = ACTIONS(3750),
    [anon_sym_DASH_GT] = ACTIONS(3750),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(3750),
  },
  [2669] = {
    [sym_parameter_list] = STATE(2670),
    [anon_sym_LPAREN] = ACTIONS(206),
    [anon_sym_COMMA] = ACTIONS(3762),
    [anon_sym_LBRACE] = ACTIONS(3762),
    [anon_sym_LBRACK] = ACTIONS(2282),
    [anon_sym_EQ] = ACTIONS(3762),
    [anon_sym_const] = ACTIONS(5285),
    [anon_sym_restrict] = ACTIONS(3762),
    [anon_sym_volatile] = ACTIONS(3762),
    [anon_sym__Atomic] = ACTIONS(3762),
    [anon_sym_mutable] = ACTIONS(3762),
    [anon_sym_explicit] = ACTIONS(3762),
    [anon_sym_constexpr] = ACTIONS(3762),
    [anon_sym_GT] = ACTIONS(3762),
    [anon_sym_DASH_GT] = ACTIONS(3762),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(3762),
  },
  [2670] = {
    [sym_type_qualifier] = STATE(2816),
    [sym_trailing_return_type] = STATE(1713),
    [aux_sym_abstract_function_declarator_repeat1] = STATE(2816),
    [anon_sym_LPAREN] = ACTIONS(3764),
    [anon_sym_COMMA] = ACTIONS(3764),
    [anon_sym_LBRACE] = ACTIONS(3764),
    [anon_sym_LBRACK] = ACTIONS(3764),
    [anon_sym_EQ] = ACTIONS(3764),
    [anon_sym_const] = ACTIONS(3770),
    [anon_sym_restrict] = ACTIONS(3764),
    [anon_sym_volatile] = ACTIONS(3764),
    [anon_sym__Atomic] = ACTIONS(3764),
    [anon_sym_mutable] = ACTIONS(3764),
    [anon_sym_explicit] = ACTIONS(3764),
    [anon_sym_constexpr] = ACTIONS(3764),
    [anon_sym_GT] = ACTIONS(3764),
    [anon_sym_DASH_GT] = ACTIONS(3764),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(3764),
  },
  [2671] = {
    [sym_type_qualifier] = STATE(2817),
    [sym_trailing_return_type] = STATE(1713),
    [aux_sym_abstract_function_declarator_repeat1] = STATE(2817),
    [anon_sym_LPAREN] = ACTIONS(3764),
    [anon_sym_COMMA] = ACTIONS(3764),
    [anon_sym_LBRACE] = ACTIONS(3764),
    [anon_sym_LBRACK] = ACTIONS(3764),
    [anon_sym_EQ] = ACTIONS(3764),
    [anon_sym_const] = ACTIONS(612),
    [anon_sym_restrict] = ACTIONS(614),
    [anon_sym_volatile] = ACTIONS(614),
    [anon_sym__Atomic] = ACTIONS(614),
    [anon_sym_mutable] = ACTIONS(614),
    [anon_sym_explicit] = ACTIONS(614),
    [anon_sym_constexpr] = ACTIONS(614),
    [anon_sym_GT] = ACTIONS(3764),
    [anon_sym_DASH_GT] = ACTIONS(3829),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(6710),
  },
  [2672] = {
    [sym_parameter_list] = STATE(2674),
    [anon_sym_LPAREN] = ACTIONS(206),
    [anon_sym_COMMA] = ACTIONS(3750),
    [anon_sym_RPAREN] = ACTIONS(3750),
    [anon_sym_LBRACE] = ACTIONS(3750),
    [anon_sym_LBRACK] = ACTIONS(2282),
    [anon_sym_EQ] = ACTIONS(3750),
    [anon_sym_const] = ACTIONS(5283),
    [anon_sym_restrict] = ACTIONS(3750),
    [anon_sym_volatile] = ACTIONS(3750),
    [anon_sym__Atomic] = ACTIONS(3750),
    [anon_sym_mutable] = ACTIONS(3750),
    [anon_sym_explicit] = ACTIONS(3750),
    [anon_sym_constexpr] = ACTIONS(3750),
    [anon_sym_DASH_GT] = ACTIONS(3750),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(3750),
  },
  [2673] = {
    [sym_parameter_list] = STATE(2674),
    [anon_sym_LPAREN] = ACTIONS(206),
    [anon_sym_COMMA] = ACTIONS(3762),
    [anon_sym_RPAREN] = ACTIONS(3762),
    [anon_sym_LBRACE] = ACTIONS(3762),
    [anon_sym_LBRACK] = ACTIONS(2282),
    [anon_sym_EQ] = ACTIONS(3762),
    [anon_sym_const] = ACTIONS(5285),
    [anon_sym_restrict] = ACTIONS(3762),
    [anon_sym_volatile] = ACTIONS(3762),
    [anon_sym__Atomic] = ACTIONS(3762),
    [anon_sym_mutable] = ACTIONS(3762),
    [anon_sym_explicit] = ACTIONS(3762),
    [anon_sym_constexpr] = ACTIONS(3762),
    [anon_sym_DASH_GT] = ACTIONS(3762),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(3762),
  },
  [2674] = {
    [sym_type_qualifier] = STATE(2818),
    [sym_trailing_return_type] = STATE(1713),
    [aux_sym_abstract_function_declarator_repeat1] = STATE(2818),
    [anon_sym_LPAREN] = ACTIONS(3764),
    [anon_sym_COMMA] = ACTIONS(3764),
    [anon_sym_RPAREN] = ACTIONS(3764),
    [anon_sym_LBRACE] = ACTIONS(3764),
    [anon_sym_LBRACK] = ACTIONS(3764),
    [anon_sym_EQ] = ACTIONS(3764),
    [anon_sym_const] = ACTIONS(3770),
    [anon_sym_restrict] = ACTIONS(3764),
    [anon_sym_volatile] = ACTIONS(3764),
    [anon_sym__Atomic] = ACTIONS(3764),
    [anon_sym_mutable] = ACTIONS(3764),
    [anon_sym_explicit] = ACTIONS(3764),
    [anon_sym_constexpr] = ACTIONS(3764),
    [anon_sym_DASH_GT] = ACTIONS(3764),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(3764),
  },
  [2675] = {
    [sym_type_qualifier] = STATE(2819),
    [sym_trailing_return_type] = STATE(1713),
    [aux_sym_abstract_function_declarator_repeat1] = STATE(2819),
    [anon_sym_LPAREN] = ACTIONS(3764),
    [anon_sym_COMMA] = ACTIONS(3764),
    [anon_sym_RPAREN] = ACTIONS(3764),
    [anon_sym_LBRACE] = ACTIONS(3764),
    [anon_sym_LBRACK] = ACTIONS(3764),
    [anon_sym_EQ] = ACTIONS(3764),
    [anon_sym_const] = ACTIONS(612),
    [anon_sym_restrict] = ACTIONS(614),
    [anon_sym_volatile] = ACTIONS(614),
    [anon_sym__Atomic] = ACTIONS(614),
    [anon_sym_mutable] = ACTIONS(614),
    [anon_sym_explicit] = ACTIONS(614),
    [anon_sym_constexpr] = ACTIONS(614),
    [anon_sym_DASH_GT] = ACTIONS(4129),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(6712),
  },
  [2676] = {
    [anon_sym_LPAREN] = ACTIONS(4836),
    [anon_sym_COMMA] = ACTIONS(4836),
    [anon_sym_RPAREN] = ACTIONS(4836),
    [anon_sym_SEMI] = ACTIONS(4836),
    [anon_sym_LBRACE] = ACTIONS(4836),
    [anon_sym_STAR] = ACTIONS(4836),
    [anon_sym_LBRACK] = ACTIONS(4836),
    [anon_sym_EQ] = ACTIONS(4836),
    [anon_sym_const] = ACTIONS(4838),
    [anon_sym_restrict] = ACTIONS(4836),
    [anon_sym_volatile] = ACTIONS(4836),
    [anon_sym__Atomic] = ACTIONS(4836),
    [anon_sym_mutable] = ACTIONS(4836),
    [anon_sym_explicit] = ACTIONS(4836),
    [anon_sym_constexpr] = ACTIONS(4836),
    [anon_sym_COLON] = ACTIONS(4836),
    [anon_sym_AMP] = ACTIONS(4838),
    [anon_sym_AMP_AMP] = ACTIONS(4836),
    [anon_sym_GT] = ACTIONS(4836),
    [anon_sym_DASH_GT] = ACTIONS(4836),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(4836),
  },
  [2677] = {
    [sym_raw_string_literal] = ACTIONS(3342),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3344),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3344),
    [anon_sym_LPAREN] = ACTIONS(3342),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3344),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3344),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3344),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3344),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(3344),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(3344),
    [sym_preproc_directive] = ACTIONS(3344),
    [anon_sym_SEMI] = ACTIONS(3342),
    [anon_sym_typedef] = ACTIONS(3344),
    [anon_sym_extern] = ACTIONS(3344),
    [anon_sym_LBRACE] = ACTIONS(3342),
    [anon_sym_STAR] = ACTIONS(3342),
    [anon_sym_LBRACK] = ACTIONS(3342),
    [anon_sym_static] = ACTIONS(3344),
    [anon_sym_register] = ACTIONS(3344),
    [anon_sym_inline] = ACTIONS(3344),
    [anon_sym_const] = ACTIONS(3344),
    [anon_sym_restrict] = ACTIONS(3344),
    [anon_sym_volatile] = ACTIONS(3344),
    [anon_sym__Atomic] = ACTIONS(3344),
    [anon_sym_mutable] = ACTIONS(3344),
    [anon_sym_explicit] = ACTIONS(3344),
    [anon_sym_constexpr] = ACTIONS(3344),
    [anon_sym_unsigned] = ACTIONS(3344),
    [anon_sym_long] = ACTIONS(3344),
    [anon_sym_short] = ACTIONS(3344),
    [sym_primitive_type] = ACTIONS(3344),
    [anon_sym_enum] = ACTIONS(3344),
    [anon_sym_struct] = ACTIONS(3344),
    [anon_sym_union] = ACTIONS(3344),
    [anon_sym_if] = ACTIONS(3344),
    [anon_sym_switch] = ACTIONS(3344),
    [anon_sym_case] = ACTIONS(3344),
    [anon_sym_default] = ACTIONS(3344),
    [anon_sym_while] = ACTIONS(3344),
    [anon_sym_do] = ACTIONS(3344),
    [anon_sym_for] = ACTIONS(3344),
    [anon_sym_return] = ACTIONS(3344),
    [anon_sym_break] = ACTIONS(3344),
    [anon_sym_continue] = ACTIONS(3344),
    [anon_sym_goto] = ACTIONS(3344),
    [anon_sym_AMP] = ACTIONS(3342),
    [anon_sym_BANG] = ACTIONS(3342),
    [anon_sym_TILDE] = ACTIONS(3342),
    [anon_sym_PLUS] = ACTIONS(3344),
    [anon_sym_DASH] = ACTIONS(3344),
    [anon_sym_DASH_DASH] = ACTIONS(3342),
    [anon_sym_PLUS_PLUS] = ACTIONS(3342),
    [anon_sym_sizeof] = ACTIONS(3344),
    [sym_number_literal] = ACTIONS(3342),
    [sym_char_literal] = ACTIONS(3342),
    [sym_string_literal] = ACTIONS(3342),
    [sym_true] = ACTIONS(3344),
    [sym_false] = ACTIONS(3344),
    [sym_null] = ACTIONS(3344),
    [sym_identifier] = ACTIONS(3344),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(3344),
    [sym_auto] = ACTIONS(3344),
    [anon_sym_typename] = ACTIONS(3344),
    [anon_sym_new] = ACTIONS(3344),
    [anon_sym_COLON_COLON] = ACTIONS(3342),
    [anon_sym_delete] = ACTIONS(3344),
    [sym_nullptr] = ACTIONS(3344),
  },
  [2678] = {
    [sym_raw_string_literal] = ACTIONS(3352),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3354),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3354),
    [anon_sym_LPAREN] = ACTIONS(3352),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3354),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3354),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3354),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3354),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(3354),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(3354),
    [sym_preproc_directive] = ACTIONS(3354),
    [anon_sym_SEMI] = ACTIONS(3352),
    [anon_sym_typedef] = ACTIONS(3354),
    [anon_sym_extern] = ACTIONS(3354),
    [anon_sym_LBRACE] = ACTIONS(3352),
    [anon_sym_STAR] = ACTIONS(3352),
    [anon_sym_LBRACK] = ACTIONS(3352),
    [anon_sym_static] = ACTIONS(3354),
    [anon_sym_register] = ACTIONS(3354),
    [anon_sym_inline] = ACTIONS(3354),
    [anon_sym_const] = ACTIONS(3354),
    [anon_sym_restrict] = ACTIONS(3354),
    [anon_sym_volatile] = ACTIONS(3354),
    [anon_sym__Atomic] = ACTIONS(3354),
    [anon_sym_mutable] = ACTIONS(3354),
    [anon_sym_explicit] = ACTIONS(3354),
    [anon_sym_constexpr] = ACTIONS(3354),
    [anon_sym_unsigned] = ACTIONS(3354),
    [anon_sym_long] = ACTIONS(3354),
    [anon_sym_short] = ACTIONS(3354),
    [sym_primitive_type] = ACTIONS(3354),
    [anon_sym_enum] = ACTIONS(3354),
    [anon_sym_struct] = ACTIONS(3354),
    [anon_sym_union] = ACTIONS(3354),
    [anon_sym_if] = ACTIONS(3354),
    [anon_sym_switch] = ACTIONS(3354),
    [anon_sym_case] = ACTIONS(3354),
    [anon_sym_default] = ACTIONS(3354),
    [anon_sym_while] = ACTIONS(3354),
    [anon_sym_do] = ACTIONS(3354),
    [anon_sym_for] = ACTIONS(3354),
    [anon_sym_return] = ACTIONS(3354),
    [anon_sym_break] = ACTIONS(3354),
    [anon_sym_continue] = ACTIONS(3354),
    [anon_sym_goto] = ACTIONS(3354),
    [anon_sym_AMP] = ACTIONS(3352),
    [anon_sym_BANG] = ACTIONS(3352),
    [anon_sym_TILDE] = ACTIONS(3352),
    [anon_sym_PLUS] = ACTIONS(3354),
    [anon_sym_DASH] = ACTIONS(3354),
    [anon_sym_DASH_DASH] = ACTIONS(3352),
    [anon_sym_PLUS_PLUS] = ACTIONS(3352),
    [anon_sym_sizeof] = ACTIONS(3354),
    [sym_number_literal] = ACTIONS(3352),
    [sym_char_literal] = ACTIONS(3352),
    [sym_string_literal] = ACTIONS(3352),
    [sym_true] = ACTIONS(3354),
    [sym_false] = ACTIONS(3354),
    [sym_null] = ACTIONS(3354),
    [sym_identifier] = ACTIONS(3354),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(3354),
    [sym_auto] = ACTIONS(3354),
    [anon_sym_typename] = ACTIONS(3354),
    [anon_sym_new] = ACTIONS(3354),
    [anon_sym_COLON_COLON] = ACTIONS(3352),
    [anon_sym_delete] = ACTIONS(3354),
    [sym_nullptr] = ACTIONS(3354),
  },
  [2679] = {
    [sym_raw_string_literal] = ACTIONS(6200),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(6202),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(6202),
    [anon_sym_LPAREN] = ACTIONS(6200),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(6202),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(6202),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(6202),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(6202),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(6202),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(6202),
    [sym_preproc_directive] = ACTIONS(6202),
    [anon_sym_SEMI] = ACTIONS(6200),
    [anon_sym_typedef] = ACTIONS(6202),
    [anon_sym_extern] = ACTIONS(6202),
    [anon_sym_LBRACE] = ACTIONS(6200),
    [anon_sym_STAR] = ACTIONS(6200),
    [anon_sym_LBRACK] = ACTIONS(6200),
    [anon_sym_static] = ACTIONS(6202),
    [anon_sym_register] = ACTIONS(6202),
    [anon_sym_inline] = ACTIONS(6202),
    [anon_sym_const] = ACTIONS(6202),
    [anon_sym_restrict] = ACTIONS(6202),
    [anon_sym_volatile] = ACTIONS(6202),
    [anon_sym__Atomic] = ACTIONS(6202),
    [anon_sym_mutable] = ACTIONS(6202),
    [anon_sym_explicit] = ACTIONS(6202),
    [anon_sym_constexpr] = ACTIONS(6202),
    [anon_sym_unsigned] = ACTIONS(6202),
    [anon_sym_long] = ACTIONS(6202),
    [anon_sym_short] = ACTIONS(6202),
    [sym_primitive_type] = ACTIONS(6202),
    [anon_sym_enum] = ACTIONS(6202),
    [anon_sym_struct] = ACTIONS(6202),
    [anon_sym_union] = ACTIONS(6202),
    [anon_sym_if] = ACTIONS(6202),
    [anon_sym_switch] = ACTIONS(6202),
    [anon_sym_case] = ACTIONS(6202),
    [anon_sym_default] = ACTIONS(6202),
    [anon_sym_while] = ACTIONS(6202),
    [anon_sym_do] = ACTIONS(6202),
    [anon_sym_for] = ACTIONS(6202),
    [anon_sym_return] = ACTIONS(6202),
    [anon_sym_break] = ACTIONS(6202),
    [anon_sym_continue] = ACTIONS(6202),
    [anon_sym_goto] = ACTIONS(6202),
    [anon_sym_AMP] = ACTIONS(6200),
    [anon_sym_BANG] = ACTIONS(6200),
    [anon_sym_TILDE] = ACTIONS(6200),
    [anon_sym_PLUS] = ACTIONS(6202),
    [anon_sym_DASH] = ACTIONS(6202),
    [anon_sym_DASH_DASH] = ACTIONS(6200),
    [anon_sym_PLUS_PLUS] = ACTIONS(6200),
    [anon_sym_sizeof] = ACTIONS(6202),
    [sym_number_literal] = ACTIONS(6200),
    [sym_char_literal] = ACTIONS(6200),
    [sym_string_literal] = ACTIONS(6200),
    [sym_true] = ACTIONS(6202),
    [sym_false] = ACTIONS(6202),
    [sym_null] = ACTIONS(6202),
    [sym_identifier] = ACTIONS(6202),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(6202),
    [sym_auto] = ACTIONS(6202),
    [anon_sym_typename] = ACTIONS(6202),
    [anon_sym_new] = ACTIONS(6202),
    [anon_sym_COLON_COLON] = ACTIONS(6200),
    [anon_sym_delete] = ACTIONS(6202),
    [sym_nullptr] = ACTIONS(6202),
  },
  [2680] = {
    [sym_raw_string_literal] = ACTIONS(6204),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(6206),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(6206),
    [anon_sym_LPAREN] = ACTIONS(6204),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(6206),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(6206),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(6206),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(6206),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(6206),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(6206),
    [sym_preproc_directive] = ACTIONS(6206),
    [anon_sym_SEMI] = ACTIONS(6204),
    [anon_sym_typedef] = ACTIONS(6206),
    [anon_sym_extern] = ACTIONS(6206),
    [anon_sym_LBRACE] = ACTIONS(6204),
    [anon_sym_STAR] = ACTIONS(6204),
    [anon_sym_LBRACK] = ACTIONS(6204),
    [anon_sym_static] = ACTIONS(6206),
    [anon_sym_register] = ACTIONS(6206),
    [anon_sym_inline] = ACTIONS(6206),
    [anon_sym_const] = ACTIONS(6206),
    [anon_sym_restrict] = ACTIONS(6206),
    [anon_sym_volatile] = ACTIONS(6206),
    [anon_sym__Atomic] = ACTIONS(6206),
    [anon_sym_mutable] = ACTIONS(6206),
    [anon_sym_explicit] = ACTIONS(6206),
    [anon_sym_constexpr] = ACTIONS(6206),
    [anon_sym_unsigned] = ACTIONS(6206),
    [anon_sym_long] = ACTIONS(6206),
    [anon_sym_short] = ACTIONS(6206),
    [sym_primitive_type] = ACTIONS(6206),
    [anon_sym_enum] = ACTIONS(6206),
    [anon_sym_struct] = ACTIONS(6206),
    [anon_sym_union] = ACTIONS(6206),
    [anon_sym_if] = ACTIONS(6206),
    [anon_sym_switch] = ACTIONS(6206),
    [anon_sym_case] = ACTIONS(6206),
    [anon_sym_default] = ACTIONS(6206),
    [anon_sym_while] = ACTIONS(6206),
    [anon_sym_do] = ACTIONS(6206),
    [anon_sym_for] = ACTIONS(6206),
    [anon_sym_return] = ACTIONS(6206),
    [anon_sym_break] = ACTIONS(6206),
    [anon_sym_continue] = ACTIONS(6206),
    [anon_sym_goto] = ACTIONS(6206),
    [anon_sym_AMP] = ACTIONS(6204),
    [anon_sym_BANG] = ACTIONS(6204),
    [anon_sym_TILDE] = ACTIONS(6204),
    [anon_sym_PLUS] = ACTIONS(6206),
    [anon_sym_DASH] = ACTIONS(6206),
    [anon_sym_DASH_DASH] = ACTIONS(6204),
    [anon_sym_PLUS_PLUS] = ACTIONS(6204),
    [anon_sym_sizeof] = ACTIONS(6206),
    [sym_number_literal] = ACTIONS(6204),
    [sym_char_literal] = ACTIONS(6204),
    [sym_string_literal] = ACTIONS(6204),
    [sym_true] = ACTIONS(6206),
    [sym_false] = ACTIONS(6206),
    [sym_null] = ACTIONS(6206),
    [sym_identifier] = ACTIONS(6206),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(6206),
    [sym_auto] = ACTIONS(6206),
    [anon_sym_typename] = ACTIONS(6206),
    [anon_sym_new] = ACTIONS(6206),
    [anon_sym_COLON_COLON] = ACTIONS(6204),
    [anon_sym_delete] = ACTIONS(6206),
    [sym_nullptr] = ACTIONS(6206),
  },
  [2681] = {
    [sym_raw_string_literal] = ACTIONS(6208),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(6210),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(6210),
    [anon_sym_LPAREN] = ACTIONS(6208),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(6210),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(6210),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(6210),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(6210),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(6210),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(6210),
    [sym_preproc_directive] = ACTIONS(6210),
    [anon_sym_SEMI] = ACTIONS(6208),
    [anon_sym_typedef] = ACTIONS(6210),
    [anon_sym_extern] = ACTIONS(6210),
    [anon_sym_LBRACE] = ACTIONS(6208),
    [anon_sym_STAR] = ACTIONS(6208),
    [anon_sym_LBRACK] = ACTIONS(6208),
    [anon_sym_static] = ACTIONS(6210),
    [anon_sym_register] = ACTIONS(6210),
    [anon_sym_inline] = ACTIONS(6210),
    [anon_sym_const] = ACTIONS(6210),
    [anon_sym_restrict] = ACTIONS(6210),
    [anon_sym_volatile] = ACTIONS(6210),
    [anon_sym__Atomic] = ACTIONS(6210),
    [anon_sym_mutable] = ACTIONS(6210),
    [anon_sym_explicit] = ACTIONS(6210),
    [anon_sym_constexpr] = ACTIONS(6210),
    [anon_sym_unsigned] = ACTIONS(6210),
    [anon_sym_long] = ACTIONS(6210),
    [anon_sym_short] = ACTIONS(6210),
    [sym_primitive_type] = ACTIONS(6210),
    [anon_sym_enum] = ACTIONS(6210),
    [anon_sym_struct] = ACTIONS(6210),
    [anon_sym_union] = ACTIONS(6210),
    [anon_sym_if] = ACTIONS(6210),
    [anon_sym_switch] = ACTIONS(6210),
    [anon_sym_case] = ACTIONS(6210),
    [anon_sym_default] = ACTIONS(6210),
    [anon_sym_while] = ACTIONS(6210),
    [anon_sym_do] = ACTIONS(6210),
    [anon_sym_for] = ACTIONS(6210),
    [anon_sym_return] = ACTIONS(6210),
    [anon_sym_break] = ACTIONS(6210),
    [anon_sym_continue] = ACTIONS(6210),
    [anon_sym_goto] = ACTIONS(6210),
    [anon_sym_AMP] = ACTIONS(6208),
    [anon_sym_BANG] = ACTIONS(6208),
    [anon_sym_TILDE] = ACTIONS(6208),
    [anon_sym_PLUS] = ACTIONS(6210),
    [anon_sym_DASH] = ACTIONS(6210),
    [anon_sym_DASH_DASH] = ACTIONS(6208),
    [anon_sym_PLUS_PLUS] = ACTIONS(6208),
    [anon_sym_sizeof] = ACTIONS(6210),
    [sym_number_literal] = ACTIONS(6208),
    [sym_char_literal] = ACTIONS(6208),
    [sym_string_literal] = ACTIONS(6208),
    [sym_true] = ACTIONS(6210),
    [sym_false] = ACTIONS(6210),
    [sym_null] = ACTIONS(6210),
    [sym_identifier] = ACTIONS(6210),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(6210),
    [sym_auto] = ACTIONS(6210),
    [anon_sym_typename] = ACTIONS(6210),
    [anon_sym_new] = ACTIONS(6210),
    [anon_sym_COLON_COLON] = ACTIONS(6208),
    [anon_sym_delete] = ACTIONS(6210),
    [sym_nullptr] = ACTIONS(6210),
  },
  [2682] = {
    [sym_raw_string_literal] = ACTIONS(6212),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(6214),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(6214),
    [anon_sym_LPAREN] = ACTIONS(6212),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(6214),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(6214),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(6214),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(6214),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(6214),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(6214),
    [sym_preproc_directive] = ACTIONS(6214),
    [anon_sym_SEMI] = ACTIONS(6212),
    [anon_sym_typedef] = ACTIONS(6214),
    [anon_sym_extern] = ACTIONS(6214),
    [anon_sym_LBRACE] = ACTIONS(6212),
    [anon_sym_STAR] = ACTIONS(6212),
    [anon_sym_LBRACK] = ACTIONS(6212),
    [anon_sym_static] = ACTIONS(6214),
    [anon_sym_register] = ACTIONS(6214),
    [anon_sym_inline] = ACTIONS(6214),
    [anon_sym_const] = ACTIONS(6214),
    [anon_sym_restrict] = ACTIONS(6214),
    [anon_sym_volatile] = ACTIONS(6214),
    [anon_sym__Atomic] = ACTIONS(6214),
    [anon_sym_mutable] = ACTIONS(6214),
    [anon_sym_explicit] = ACTIONS(6214),
    [anon_sym_constexpr] = ACTIONS(6214),
    [anon_sym_unsigned] = ACTIONS(6214),
    [anon_sym_long] = ACTIONS(6214),
    [anon_sym_short] = ACTIONS(6214),
    [sym_primitive_type] = ACTIONS(6214),
    [anon_sym_enum] = ACTIONS(6214),
    [anon_sym_struct] = ACTIONS(6214),
    [anon_sym_union] = ACTIONS(6214),
    [anon_sym_if] = ACTIONS(6214),
    [anon_sym_switch] = ACTIONS(6214),
    [anon_sym_case] = ACTIONS(6214),
    [anon_sym_default] = ACTIONS(6214),
    [anon_sym_while] = ACTIONS(6214),
    [anon_sym_do] = ACTIONS(6214),
    [anon_sym_for] = ACTIONS(6214),
    [anon_sym_return] = ACTIONS(6214),
    [anon_sym_break] = ACTIONS(6214),
    [anon_sym_continue] = ACTIONS(6214),
    [anon_sym_goto] = ACTIONS(6214),
    [anon_sym_AMP] = ACTIONS(6212),
    [anon_sym_BANG] = ACTIONS(6212),
    [anon_sym_TILDE] = ACTIONS(6212),
    [anon_sym_PLUS] = ACTIONS(6214),
    [anon_sym_DASH] = ACTIONS(6214),
    [anon_sym_DASH_DASH] = ACTIONS(6212),
    [anon_sym_PLUS_PLUS] = ACTIONS(6212),
    [anon_sym_sizeof] = ACTIONS(6214),
    [sym_number_literal] = ACTIONS(6212),
    [sym_char_literal] = ACTIONS(6212),
    [sym_string_literal] = ACTIONS(6212),
    [sym_true] = ACTIONS(6214),
    [sym_false] = ACTIONS(6214),
    [sym_null] = ACTIONS(6214),
    [sym_identifier] = ACTIONS(6214),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(6214),
    [sym_auto] = ACTIONS(6214),
    [anon_sym_typename] = ACTIONS(6214),
    [anon_sym_new] = ACTIONS(6214),
    [anon_sym_COLON_COLON] = ACTIONS(6212),
    [anon_sym_delete] = ACTIONS(6214),
    [sym_nullptr] = ACTIONS(6214),
  },
  [2683] = {
    [sym_raw_string_literal] = ACTIONS(6216),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(6218),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(6218),
    [anon_sym_LPAREN] = ACTIONS(6216),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(6218),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(6218),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(6218),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(6218),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(6218),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(6218),
    [sym_preproc_directive] = ACTIONS(6218),
    [anon_sym_SEMI] = ACTIONS(6216),
    [anon_sym_typedef] = ACTIONS(6218),
    [anon_sym_extern] = ACTIONS(6218),
    [anon_sym_LBRACE] = ACTIONS(6216),
    [anon_sym_STAR] = ACTIONS(6216),
    [anon_sym_LBRACK] = ACTIONS(6216),
    [anon_sym_static] = ACTIONS(6218),
    [anon_sym_register] = ACTIONS(6218),
    [anon_sym_inline] = ACTIONS(6218),
    [anon_sym_const] = ACTIONS(6218),
    [anon_sym_restrict] = ACTIONS(6218),
    [anon_sym_volatile] = ACTIONS(6218),
    [anon_sym__Atomic] = ACTIONS(6218),
    [anon_sym_mutable] = ACTIONS(6218),
    [anon_sym_explicit] = ACTIONS(6218),
    [anon_sym_constexpr] = ACTIONS(6218),
    [anon_sym_unsigned] = ACTIONS(6218),
    [anon_sym_long] = ACTIONS(6218),
    [anon_sym_short] = ACTIONS(6218),
    [sym_primitive_type] = ACTIONS(6218),
    [anon_sym_enum] = ACTIONS(6218),
    [anon_sym_struct] = ACTIONS(6218),
    [anon_sym_union] = ACTIONS(6218),
    [anon_sym_if] = ACTIONS(6218),
    [anon_sym_switch] = ACTIONS(6218),
    [anon_sym_case] = ACTIONS(6218),
    [anon_sym_default] = ACTIONS(6218),
    [anon_sym_while] = ACTIONS(6218),
    [anon_sym_do] = ACTIONS(6218),
    [anon_sym_for] = ACTIONS(6218),
    [anon_sym_return] = ACTIONS(6218),
    [anon_sym_break] = ACTIONS(6218),
    [anon_sym_continue] = ACTIONS(6218),
    [anon_sym_goto] = ACTIONS(6218),
    [anon_sym_AMP] = ACTIONS(6216),
    [anon_sym_BANG] = ACTIONS(6216),
    [anon_sym_TILDE] = ACTIONS(6216),
    [anon_sym_PLUS] = ACTIONS(6218),
    [anon_sym_DASH] = ACTIONS(6218),
    [anon_sym_DASH_DASH] = ACTIONS(6216),
    [anon_sym_PLUS_PLUS] = ACTIONS(6216),
    [anon_sym_sizeof] = ACTIONS(6218),
    [sym_number_literal] = ACTIONS(6216),
    [sym_char_literal] = ACTIONS(6216),
    [sym_string_literal] = ACTIONS(6216),
    [sym_true] = ACTIONS(6218),
    [sym_false] = ACTIONS(6218),
    [sym_null] = ACTIONS(6218),
    [sym_identifier] = ACTIONS(6218),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(6218),
    [sym_auto] = ACTIONS(6218),
    [anon_sym_typename] = ACTIONS(6218),
    [anon_sym_new] = ACTIONS(6218),
    [anon_sym_COLON_COLON] = ACTIONS(6216),
    [anon_sym_delete] = ACTIONS(6218),
    [sym_nullptr] = ACTIONS(6218),
  },
  [2684] = {
    [sym_raw_string_literal] = ACTIONS(6220),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(6222),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(6222),
    [anon_sym_LPAREN] = ACTIONS(6220),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(6222),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(6222),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(6222),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(6222),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(6222),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(6222),
    [sym_preproc_directive] = ACTIONS(6222),
    [anon_sym_SEMI] = ACTIONS(6220),
    [anon_sym_typedef] = ACTIONS(6222),
    [anon_sym_extern] = ACTIONS(6222),
    [anon_sym_LBRACE] = ACTIONS(6220),
    [anon_sym_STAR] = ACTIONS(6220),
    [anon_sym_LBRACK] = ACTIONS(6220),
    [anon_sym_static] = ACTIONS(6222),
    [anon_sym_register] = ACTIONS(6222),
    [anon_sym_inline] = ACTIONS(6222),
    [anon_sym_const] = ACTIONS(6222),
    [anon_sym_restrict] = ACTIONS(6222),
    [anon_sym_volatile] = ACTIONS(6222),
    [anon_sym__Atomic] = ACTIONS(6222),
    [anon_sym_mutable] = ACTIONS(6222),
    [anon_sym_explicit] = ACTIONS(6222),
    [anon_sym_constexpr] = ACTIONS(6222),
    [anon_sym_unsigned] = ACTIONS(6222),
    [anon_sym_long] = ACTIONS(6222),
    [anon_sym_short] = ACTIONS(6222),
    [sym_primitive_type] = ACTIONS(6222),
    [anon_sym_enum] = ACTIONS(6222),
    [anon_sym_struct] = ACTIONS(6222),
    [anon_sym_union] = ACTIONS(6222),
    [anon_sym_if] = ACTIONS(6222),
    [anon_sym_switch] = ACTIONS(6222),
    [anon_sym_case] = ACTIONS(6222),
    [anon_sym_default] = ACTIONS(6222),
    [anon_sym_while] = ACTIONS(6222),
    [anon_sym_do] = ACTIONS(6222),
    [anon_sym_for] = ACTIONS(6222),
    [anon_sym_return] = ACTIONS(6222),
    [anon_sym_break] = ACTIONS(6222),
    [anon_sym_continue] = ACTIONS(6222),
    [anon_sym_goto] = ACTIONS(6222),
    [anon_sym_AMP] = ACTIONS(6220),
    [anon_sym_BANG] = ACTIONS(6220),
    [anon_sym_TILDE] = ACTIONS(6220),
    [anon_sym_PLUS] = ACTIONS(6222),
    [anon_sym_DASH] = ACTIONS(6222),
    [anon_sym_DASH_DASH] = ACTIONS(6220),
    [anon_sym_PLUS_PLUS] = ACTIONS(6220),
    [anon_sym_sizeof] = ACTIONS(6222),
    [sym_number_literal] = ACTIONS(6220),
    [sym_char_literal] = ACTIONS(6220),
    [sym_string_literal] = ACTIONS(6220),
    [sym_true] = ACTIONS(6222),
    [sym_false] = ACTIONS(6222),
    [sym_null] = ACTIONS(6222),
    [sym_identifier] = ACTIONS(6222),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(6222),
    [sym_auto] = ACTIONS(6222),
    [anon_sym_typename] = ACTIONS(6222),
    [anon_sym_new] = ACTIONS(6222),
    [anon_sym_COLON_COLON] = ACTIONS(6220),
    [anon_sym_delete] = ACTIONS(6222),
    [sym_nullptr] = ACTIONS(6222),
  },
  [2685] = {
    [anon_sym_LF] = ACTIONS(6714),
    [sym_comment] = ACTIONS(83),
  },
  [2686] = {
    [sym_raw_string_literal] = ACTIONS(1823),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1825),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1825),
    [anon_sym_LPAREN] = ACTIONS(1823),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1825),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(1825),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1825),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1825),
    [sym_preproc_directive] = ACTIONS(1825),
    [anon_sym_SEMI] = ACTIONS(1823),
    [anon_sym_typedef] = ACTIONS(1825),
    [anon_sym_extern] = ACTIONS(1825),
    [anon_sym_LBRACE] = ACTIONS(1823),
    [anon_sym_STAR] = ACTIONS(1823),
    [anon_sym_LBRACK] = ACTIONS(1823),
    [anon_sym_static] = ACTIONS(1825),
    [anon_sym_register] = ACTIONS(1825),
    [anon_sym_inline] = ACTIONS(1825),
    [anon_sym_const] = ACTIONS(1825),
    [anon_sym_restrict] = ACTIONS(1825),
    [anon_sym_volatile] = ACTIONS(1825),
    [anon_sym__Atomic] = ACTIONS(1825),
    [anon_sym_mutable] = ACTIONS(1825),
    [anon_sym_explicit] = ACTIONS(1825),
    [anon_sym_constexpr] = ACTIONS(1825),
    [anon_sym_unsigned] = ACTIONS(1825),
    [anon_sym_long] = ACTIONS(1825),
    [anon_sym_short] = ACTIONS(1825),
    [sym_primitive_type] = ACTIONS(1825),
    [anon_sym_enum] = ACTIONS(1825),
    [anon_sym_struct] = ACTIONS(1825),
    [anon_sym_union] = ACTIONS(1825),
    [anon_sym_if] = ACTIONS(1825),
    [anon_sym_switch] = ACTIONS(1825),
    [anon_sym_case] = ACTIONS(1825),
    [anon_sym_default] = ACTIONS(1825),
    [anon_sym_while] = ACTIONS(1825),
    [anon_sym_do] = ACTIONS(1825),
    [anon_sym_for] = ACTIONS(1825),
    [anon_sym_return] = ACTIONS(1825),
    [anon_sym_break] = ACTIONS(1825),
    [anon_sym_continue] = ACTIONS(1825),
    [anon_sym_goto] = ACTIONS(1825),
    [anon_sym_AMP] = ACTIONS(1823),
    [anon_sym_BANG] = ACTIONS(1823),
    [anon_sym_TILDE] = ACTIONS(1823),
    [anon_sym_PLUS] = ACTIONS(1825),
    [anon_sym_DASH] = ACTIONS(1825),
    [anon_sym_DASH_DASH] = ACTIONS(1823),
    [anon_sym_PLUS_PLUS] = ACTIONS(1823),
    [anon_sym_sizeof] = ACTIONS(1825),
    [sym_number_literal] = ACTIONS(1823),
    [sym_char_literal] = ACTIONS(1823),
    [sym_string_literal] = ACTIONS(1823),
    [sym_true] = ACTIONS(1825),
    [sym_false] = ACTIONS(1825),
    [sym_null] = ACTIONS(1825),
    [sym_identifier] = ACTIONS(1825),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(1825),
    [sym_auto] = ACTIONS(1825),
    [anon_sym_typename] = ACTIONS(1825),
    [anon_sym_new] = ACTIONS(1825),
    [anon_sym_COLON_COLON] = ACTIONS(1823),
    [anon_sym_delete] = ACTIONS(1825),
    [sym_nullptr] = ACTIONS(1825),
  },
  [2687] = {
    [anon_sym_LF] = ACTIONS(6716),
    [sym_comment] = ACTIONS(83),
  },
  [2688] = {
    [sym_raw_string_literal] = ACTIONS(5399),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(5401),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(5401),
    [anon_sym_LPAREN] = ACTIONS(5399),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(5401),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(5401),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(5401),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(5401),
    [sym_preproc_directive] = ACTIONS(5401),
    [anon_sym_SEMI] = ACTIONS(5399),
    [anon_sym_typedef] = ACTIONS(5401),
    [anon_sym_extern] = ACTIONS(5401),
    [anon_sym_LBRACE] = ACTIONS(5399),
    [anon_sym_STAR] = ACTIONS(5399),
    [anon_sym_LBRACK] = ACTIONS(5399),
    [anon_sym_static] = ACTIONS(5401),
    [anon_sym_register] = ACTIONS(5401),
    [anon_sym_inline] = ACTIONS(5401),
    [anon_sym_const] = ACTIONS(5401),
    [anon_sym_restrict] = ACTIONS(5401),
    [anon_sym_volatile] = ACTIONS(5401),
    [anon_sym__Atomic] = ACTIONS(5401),
    [anon_sym_mutable] = ACTIONS(5401),
    [anon_sym_explicit] = ACTIONS(5401),
    [anon_sym_constexpr] = ACTIONS(5401),
    [anon_sym_unsigned] = ACTIONS(5401),
    [anon_sym_long] = ACTIONS(5401),
    [anon_sym_short] = ACTIONS(5401),
    [sym_primitive_type] = ACTIONS(5401),
    [anon_sym_enum] = ACTIONS(5401),
    [anon_sym_struct] = ACTIONS(5401),
    [anon_sym_union] = ACTIONS(5401),
    [anon_sym_if] = ACTIONS(5401),
    [anon_sym_switch] = ACTIONS(5401),
    [anon_sym_case] = ACTIONS(5401),
    [anon_sym_default] = ACTIONS(5401),
    [anon_sym_while] = ACTIONS(5401),
    [anon_sym_do] = ACTIONS(5401),
    [anon_sym_for] = ACTIONS(5401),
    [anon_sym_return] = ACTIONS(5401),
    [anon_sym_break] = ACTIONS(5401),
    [anon_sym_continue] = ACTIONS(5401),
    [anon_sym_goto] = ACTIONS(5401),
    [anon_sym_AMP] = ACTIONS(5399),
    [anon_sym_BANG] = ACTIONS(5399),
    [anon_sym_TILDE] = ACTIONS(5399),
    [anon_sym_PLUS] = ACTIONS(5401),
    [anon_sym_DASH] = ACTIONS(5401),
    [anon_sym_DASH_DASH] = ACTIONS(5399),
    [anon_sym_PLUS_PLUS] = ACTIONS(5399),
    [anon_sym_sizeof] = ACTIONS(5401),
    [sym_number_literal] = ACTIONS(5399),
    [sym_char_literal] = ACTIONS(5399),
    [sym_string_literal] = ACTIONS(5399),
    [sym_true] = ACTIONS(5401),
    [sym_false] = ACTIONS(5401),
    [sym_null] = ACTIONS(5401),
    [sym_identifier] = ACTIONS(5401),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(5401),
    [sym_auto] = ACTIONS(5401),
    [anon_sym_typename] = ACTIONS(5401),
    [anon_sym_new] = ACTIONS(5401),
    [anon_sym_COLON_COLON] = ACTIONS(5399),
    [anon_sym_delete] = ACTIONS(5401),
    [sym_nullptr] = ACTIONS(5401),
  },
  [2689] = {
    [sym_raw_string_literal] = ACTIONS(5403),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(5405),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(5405),
    [anon_sym_LPAREN] = ACTIONS(5403),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(5405),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(5405),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(5405),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(5405),
    [sym_preproc_directive] = ACTIONS(5405),
    [anon_sym_SEMI] = ACTIONS(5403),
    [anon_sym_typedef] = ACTIONS(5405),
    [anon_sym_extern] = ACTIONS(5405),
    [anon_sym_LBRACE] = ACTIONS(5403),
    [anon_sym_STAR] = ACTIONS(5403),
    [anon_sym_LBRACK] = ACTIONS(5403),
    [anon_sym_static] = ACTIONS(5405),
    [anon_sym_register] = ACTIONS(5405),
    [anon_sym_inline] = ACTIONS(5405),
    [anon_sym_const] = ACTIONS(5405),
    [anon_sym_restrict] = ACTIONS(5405),
    [anon_sym_volatile] = ACTIONS(5405),
    [anon_sym__Atomic] = ACTIONS(5405),
    [anon_sym_mutable] = ACTIONS(5405),
    [anon_sym_explicit] = ACTIONS(5405),
    [anon_sym_constexpr] = ACTIONS(5405),
    [anon_sym_unsigned] = ACTIONS(5405),
    [anon_sym_long] = ACTIONS(5405),
    [anon_sym_short] = ACTIONS(5405),
    [sym_primitive_type] = ACTIONS(5405),
    [anon_sym_enum] = ACTIONS(5405),
    [anon_sym_struct] = ACTIONS(5405),
    [anon_sym_union] = ACTIONS(5405),
    [anon_sym_if] = ACTIONS(5405),
    [anon_sym_switch] = ACTIONS(5405),
    [anon_sym_case] = ACTIONS(5405),
    [anon_sym_default] = ACTIONS(5405),
    [anon_sym_while] = ACTIONS(5405),
    [anon_sym_do] = ACTIONS(5405),
    [anon_sym_for] = ACTIONS(5405),
    [anon_sym_return] = ACTIONS(5405),
    [anon_sym_break] = ACTIONS(5405),
    [anon_sym_continue] = ACTIONS(5405),
    [anon_sym_goto] = ACTIONS(5405),
    [anon_sym_AMP] = ACTIONS(5403),
    [anon_sym_BANG] = ACTIONS(5403),
    [anon_sym_TILDE] = ACTIONS(5403),
    [anon_sym_PLUS] = ACTIONS(5405),
    [anon_sym_DASH] = ACTIONS(5405),
    [anon_sym_DASH_DASH] = ACTIONS(5403),
    [anon_sym_PLUS_PLUS] = ACTIONS(5403),
    [anon_sym_sizeof] = ACTIONS(5405),
    [sym_number_literal] = ACTIONS(5403),
    [sym_char_literal] = ACTIONS(5403),
    [sym_string_literal] = ACTIONS(5403),
    [sym_true] = ACTIONS(5405),
    [sym_false] = ACTIONS(5405),
    [sym_null] = ACTIONS(5405),
    [sym_identifier] = ACTIONS(5405),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(5405),
    [sym_auto] = ACTIONS(5405),
    [anon_sym_typename] = ACTIONS(5405),
    [anon_sym_new] = ACTIONS(5405),
    [anon_sym_COLON_COLON] = ACTIONS(5403),
    [anon_sym_delete] = ACTIONS(5405),
    [sym_nullptr] = ACTIONS(5405),
  },
  [2690] = {
    [sym_raw_string_literal] = ACTIONS(5413),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(5415),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(5415),
    [anon_sym_LPAREN] = ACTIONS(5413),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(5415),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(5415),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(5415),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(5415),
    [sym_preproc_directive] = ACTIONS(5415),
    [anon_sym_SEMI] = ACTIONS(5413),
    [anon_sym_typedef] = ACTIONS(5415),
    [anon_sym_extern] = ACTIONS(5415),
    [anon_sym_LBRACE] = ACTIONS(5413),
    [anon_sym_STAR] = ACTIONS(5413),
    [anon_sym_LBRACK] = ACTIONS(5413),
    [anon_sym_static] = ACTIONS(5415),
    [anon_sym_register] = ACTIONS(5415),
    [anon_sym_inline] = ACTIONS(5415),
    [anon_sym_const] = ACTIONS(5415),
    [anon_sym_restrict] = ACTIONS(5415),
    [anon_sym_volatile] = ACTIONS(5415),
    [anon_sym__Atomic] = ACTIONS(5415),
    [anon_sym_mutable] = ACTIONS(5415),
    [anon_sym_explicit] = ACTIONS(5415),
    [anon_sym_constexpr] = ACTIONS(5415),
    [anon_sym_unsigned] = ACTIONS(5415),
    [anon_sym_long] = ACTIONS(5415),
    [anon_sym_short] = ACTIONS(5415),
    [sym_primitive_type] = ACTIONS(5415),
    [anon_sym_enum] = ACTIONS(5415),
    [anon_sym_struct] = ACTIONS(5415),
    [anon_sym_union] = ACTIONS(5415),
    [anon_sym_if] = ACTIONS(5415),
    [anon_sym_switch] = ACTIONS(5415),
    [anon_sym_case] = ACTIONS(5415),
    [anon_sym_default] = ACTIONS(5415),
    [anon_sym_while] = ACTIONS(5415),
    [anon_sym_do] = ACTIONS(5415),
    [anon_sym_for] = ACTIONS(5415),
    [anon_sym_return] = ACTIONS(5415),
    [anon_sym_break] = ACTIONS(5415),
    [anon_sym_continue] = ACTIONS(5415),
    [anon_sym_goto] = ACTIONS(5415),
    [anon_sym_AMP] = ACTIONS(5413),
    [anon_sym_BANG] = ACTIONS(5413),
    [anon_sym_TILDE] = ACTIONS(5413),
    [anon_sym_PLUS] = ACTIONS(5415),
    [anon_sym_DASH] = ACTIONS(5415),
    [anon_sym_DASH_DASH] = ACTIONS(5413),
    [anon_sym_PLUS_PLUS] = ACTIONS(5413),
    [anon_sym_sizeof] = ACTIONS(5415),
    [sym_number_literal] = ACTIONS(5413),
    [sym_char_literal] = ACTIONS(5413),
    [sym_string_literal] = ACTIONS(5413),
    [sym_true] = ACTIONS(5415),
    [sym_false] = ACTIONS(5415),
    [sym_null] = ACTIONS(5415),
    [sym_identifier] = ACTIONS(5415),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(5415),
    [sym_auto] = ACTIONS(5415),
    [anon_sym_typename] = ACTIONS(5415),
    [anon_sym_new] = ACTIONS(5415),
    [anon_sym_COLON_COLON] = ACTIONS(5413),
    [anon_sym_delete] = ACTIONS(5415),
    [sym_nullptr] = ACTIONS(5415),
  },
  [2691] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(6718),
    [sym_comment] = ACTIONS(49),
  },
  [2692] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(6720),
    [sym_comment] = ACTIONS(49),
  },
  [2693] = {
    [sym_raw_string_literal] = ACTIONS(5492),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(5494),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(5494),
    [anon_sym_LPAREN] = ACTIONS(5492),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(5494),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(5494),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(5494),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(5494),
    [sym_preproc_directive] = ACTIONS(5494),
    [anon_sym_SEMI] = ACTIONS(5492),
    [anon_sym_typedef] = ACTIONS(5494),
    [anon_sym_extern] = ACTIONS(5494),
    [anon_sym_LBRACE] = ACTIONS(5492),
    [anon_sym_STAR] = ACTIONS(5492),
    [anon_sym_LBRACK] = ACTIONS(5492),
    [anon_sym_static] = ACTIONS(5494),
    [anon_sym_register] = ACTIONS(5494),
    [anon_sym_inline] = ACTIONS(5494),
    [anon_sym_const] = ACTIONS(5494),
    [anon_sym_restrict] = ACTIONS(5494),
    [anon_sym_volatile] = ACTIONS(5494),
    [anon_sym__Atomic] = ACTIONS(5494),
    [anon_sym_mutable] = ACTIONS(5494),
    [anon_sym_explicit] = ACTIONS(5494),
    [anon_sym_constexpr] = ACTIONS(5494),
    [anon_sym_unsigned] = ACTIONS(5494),
    [anon_sym_long] = ACTIONS(5494),
    [anon_sym_short] = ACTIONS(5494),
    [sym_primitive_type] = ACTIONS(5494),
    [anon_sym_enum] = ACTIONS(5494),
    [anon_sym_struct] = ACTIONS(5494),
    [anon_sym_union] = ACTIONS(5494),
    [anon_sym_if] = ACTIONS(5494),
    [anon_sym_switch] = ACTIONS(5494),
    [anon_sym_case] = ACTIONS(5494),
    [anon_sym_default] = ACTIONS(5494),
    [anon_sym_while] = ACTIONS(5494),
    [anon_sym_do] = ACTIONS(5494),
    [anon_sym_for] = ACTIONS(5494),
    [anon_sym_return] = ACTIONS(5494),
    [anon_sym_break] = ACTIONS(5494),
    [anon_sym_continue] = ACTIONS(5494),
    [anon_sym_goto] = ACTIONS(5494),
    [anon_sym_AMP] = ACTIONS(5492),
    [anon_sym_BANG] = ACTIONS(5492),
    [anon_sym_TILDE] = ACTIONS(5492),
    [anon_sym_PLUS] = ACTIONS(5494),
    [anon_sym_DASH] = ACTIONS(5494),
    [anon_sym_DASH_DASH] = ACTIONS(5492),
    [anon_sym_PLUS_PLUS] = ACTIONS(5492),
    [anon_sym_sizeof] = ACTIONS(5494),
    [sym_number_literal] = ACTIONS(5492),
    [sym_char_literal] = ACTIONS(5492),
    [sym_string_literal] = ACTIONS(5492),
    [sym_true] = ACTIONS(5494),
    [sym_false] = ACTIONS(5494),
    [sym_null] = ACTIONS(5494),
    [sym_identifier] = ACTIONS(5494),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(5494),
    [sym_auto] = ACTIONS(5494),
    [anon_sym_typename] = ACTIONS(5494),
    [anon_sym_new] = ACTIONS(5494),
    [anon_sym_COLON_COLON] = ACTIONS(5492),
    [anon_sym_delete] = ACTIONS(5494),
    [sym_nullptr] = ACTIONS(5494),
  },
  [2694] = {
    [sym_raw_string_literal] = ACTIONS(5496),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(5498),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(5498),
    [anon_sym_LPAREN] = ACTIONS(5496),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(5498),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(5498),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(5498),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(5498),
    [sym_preproc_directive] = ACTIONS(5498),
    [anon_sym_SEMI] = ACTIONS(5496),
    [anon_sym_typedef] = ACTIONS(5498),
    [anon_sym_extern] = ACTIONS(5498),
    [anon_sym_LBRACE] = ACTIONS(5496),
    [anon_sym_STAR] = ACTIONS(5496),
    [anon_sym_LBRACK] = ACTIONS(5496),
    [anon_sym_static] = ACTIONS(5498),
    [anon_sym_register] = ACTIONS(5498),
    [anon_sym_inline] = ACTIONS(5498),
    [anon_sym_const] = ACTIONS(5498),
    [anon_sym_restrict] = ACTIONS(5498),
    [anon_sym_volatile] = ACTIONS(5498),
    [anon_sym__Atomic] = ACTIONS(5498),
    [anon_sym_mutable] = ACTIONS(5498),
    [anon_sym_explicit] = ACTIONS(5498),
    [anon_sym_constexpr] = ACTIONS(5498),
    [anon_sym_unsigned] = ACTIONS(5498),
    [anon_sym_long] = ACTIONS(5498),
    [anon_sym_short] = ACTIONS(5498),
    [sym_primitive_type] = ACTIONS(5498),
    [anon_sym_enum] = ACTIONS(5498),
    [anon_sym_struct] = ACTIONS(5498),
    [anon_sym_union] = ACTIONS(5498),
    [anon_sym_if] = ACTIONS(5498),
    [anon_sym_switch] = ACTIONS(5498),
    [anon_sym_case] = ACTIONS(5498),
    [anon_sym_default] = ACTIONS(5498),
    [anon_sym_while] = ACTIONS(5498),
    [anon_sym_do] = ACTIONS(5498),
    [anon_sym_for] = ACTIONS(5498),
    [anon_sym_return] = ACTIONS(5498),
    [anon_sym_break] = ACTIONS(5498),
    [anon_sym_continue] = ACTIONS(5498),
    [anon_sym_goto] = ACTIONS(5498),
    [anon_sym_AMP] = ACTIONS(5496),
    [anon_sym_BANG] = ACTIONS(5496),
    [anon_sym_TILDE] = ACTIONS(5496),
    [anon_sym_PLUS] = ACTIONS(5498),
    [anon_sym_DASH] = ACTIONS(5498),
    [anon_sym_DASH_DASH] = ACTIONS(5496),
    [anon_sym_PLUS_PLUS] = ACTIONS(5496),
    [anon_sym_sizeof] = ACTIONS(5498),
    [sym_number_literal] = ACTIONS(5496),
    [sym_char_literal] = ACTIONS(5496),
    [sym_string_literal] = ACTIONS(5496),
    [sym_true] = ACTIONS(5498),
    [sym_false] = ACTIONS(5498),
    [sym_null] = ACTIONS(5498),
    [sym_identifier] = ACTIONS(5498),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(5498),
    [sym_auto] = ACTIONS(5498),
    [anon_sym_typename] = ACTIONS(5498),
    [anon_sym_new] = ACTIONS(5498),
    [anon_sym_COLON_COLON] = ACTIONS(5496),
    [anon_sym_delete] = ACTIONS(5498),
    [sym_nullptr] = ACTIONS(5498),
  },
  [2695] = {
    [sym_raw_string_literal] = ACTIONS(5500),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(5502),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(5502),
    [anon_sym_LPAREN] = ACTIONS(5500),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(5502),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(5502),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(5502),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(5502),
    [sym_preproc_directive] = ACTIONS(5502),
    [anon_sym_SEMI] = ACTIONS(5500),
    [anon_sym_typedef] = ACTIONS(5502),
    [anon_sym_extern] = ACTIONS(5502),
    [anon_sym_LBRACE] = ACTIONS(5500),
    [anon_sym_STAR] = ACTIONS(5500),
    [anon_sym_LBRACK] = ACTIONS(5500),
    [anon_sym_static] = ACTIONS(5502),
    [anon_sym_register] = ACTIONS(5502),
    [anon_sym_inline] = ACTIONS(5502),
    [anon_sym_const] = ACTIONS(5502),
    [anon_sym_restrict] = ACTIONS(5502),
    [anon_sym_volatile] = ACTIONS(5502),
    [anon_sym__Atomic] = ACTIONS(5502),
    [anon_sym_mutable] = ACTIONS(5502),
    [anon_sym_explicit] = ACTIONS(5502),
    [anon_sym_constexpr] = ACTIONS(5502),
    [anon_sym_unsigned] = ACTIONS(5502),
    [anon_sym_long] = ACTIONS(5502),
    [anon_sym_short] = ACTIONS(5502),
    [sym_primitive_type] = ACTIONS(5502),
    [anon_sym_enum] = ACTIONS(5502),
    [anon_sym_struct] = ACTIONS(5502),
    [anon_sym_union] = ACTIONS(5502),
    [anon_sym_if] = ACTIONS(5502),
    [anon_sym_switch] = ACTIONS(5502),
    [anon_sym_case] = ACTIONS(5502),
    [anon_sym_default] = ACTIONS(5502),
    [anon_sym_while] = ACTIONS(5502),
    [anon_sym_do] = ACTIONS(5502),
    [anon_sym_for] = ACTIONS(5502),
    [anon_sym_return] = ACTIONS(5502),
    [anon_sym_break] = ACTIONS(5502),
    [anon_sym_continue] = ACTIONS(5502),
    [anon_sym_goto] = ACTIONS(5502),
    [anon_sym_AMP] = ACTIONS(5500),
    [anon_sym_BANG] = ACTIONS(5500),
    [anon_sym_TILDE] = ACTIONS(5500),
    [anon_sym_PLUS] = ACTIONS(5502),
    [anon_sym_DASH] = ACTIONS(5502),
    [anon_sym_DASH_DASH] = ACTIONS(5500),
    [anon_sym_PLUS_PLUS] = ACTIONS(5500),
    [anon_sym_sizeof] = ACTIONS(5502),
    [sym_number_literal] = ACTIONS(5500),
    [sym_char_literal] = ACTIONS(5500),
    [sym_string_literal] = ACTIONS(5500),
    [sym_true] = ACTIONS(5502),
    [sym_false] = ACTIONS(5502),
    [sym_null] = ACTIONS(5502),
    [sym_identifier] = ACTIONS(5502),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(5502),
    [sym_auto] = ACTIONS(5502),
    [anon_sym_typename] = ACTIONS(5502),
    [anon_sym_new] = ACTIONS(5502),
    [anon_sym_COLON_COLON] = ACTIONS(5500),
    [anon_sym_delete] = ACTIONS(5502),
    [sym_nullptr] = ACTIONS(5502),
  },
  [2696] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(6722),
    [sym_comment] = ACTIONS(49),
  },
  [2697] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(6724),
    [sym_comment] = ACTIONS(49),
  },
  [2698] = {
    [sym_raw_string_literal] = ACTIONS(5508),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(5510),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(5510),
    [anon_sym_LPAREN] = ACTIONS(5508),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(5510),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(5510),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(5510),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(5510),
    [sym_preproc_directive] = ACTIONS(5510),
    [anon_sym_SEMI] = ACTIONS(5508),
    [anon_sym_typedef] = ACTIONS(5510),
    [anon_sym_extern] = ACTIONS(5510),
    [anon_sym_LBRACE] = ACTIONS(5508),
    [anon_sym_STAR] = ACTIONS(5508),
    [anon_sym_LBRACK] = ACTIONS(5508),
    [anon_sym_static] = ACTIONS(5510),
    [anon_sym_register] = ACTIONS(5510),
    [anon_sym_inline] = ACTIONS(5510),
    [anon_sym_const] = ACTIONS(5510),
    [anon_sym_restrict] = ACTIONS(5510),
    [anon_sym_volatile] = ACTIONS(5510),
    [anon_sym__Atomic] = ACTIONS(5510),
    [anon_sym_mutable] = ACTIONS(5510),
    [anon_sym_explicit] = ACTIONS(5510),
    [anon_sym_constexpr] = ACTIONS(5510),
    [anon_sym_unsigned] = ACTIONS(5510),
    [anon_sym_long] = ACTIONS(5510),
    [anon_sym_short] = ACTIONS(5510),
    [sym_primitive_type] = ACTIONS(5510),
    [anon_sym_enum] = ACTIONS(5510),
    [anon_sym_struct] = ACTIONS(5510),
    [anon_sym_union] = ACTIONS(5510),
    [anon_sym_if] = ACTIONS(5510),
    [anon_sym_switch] = ACTIONS(5510),
    [anon_sym_case] = ACTIONS(5510),
    [anon_sym_default] = ACTIONS(5510),
    [anon_sym_while] = ACTIONS(5510),
    [anon_sym_do] = ACTIONS(5510),
    [anon_sym_for] = ACTIONS(5510),
    [anon_sym_return] = ACTIONS(5510),
    [anon_sym_break] = ACTIONS(5510),
    [anon_sym_continue] = ACTIONS(5510),
    [anon_sym_goto] = ACTIONS(5510),
    [anon_sym_AMP] = ACTIONS(5508),
    [anon_sym_BANG] = ACTIONS(5508),
    [anon_sym_TILDE] = ACTIONS(5508),
    [anon_sym_PLUS] = ACTIONS(5510),
    [anon_sym_DASH] = ACTIONS(5510),
    [anon_sym_DASH_DASH] = ACTIONS(5508),
    [anon_sym_PLUS_PLUS] = ACTIONS(5508),
    [anon_sym_sizeof] = ACTIONS(5510),
    [sym_number_literal] = ACTIONS(5508),
    [sym_char_literal] = ACTIONS(5508),
    [sym_string_literal] = ACTIONS(5508),
    [sym_true] = ACTIONS(5510),
    [sym_false] = ACTIONS(5510),
    [sym_null] = ACTIONS(5510),
    [sym_identifier] = ACTIONS(5510),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(5510),
    [sym_auto] = ACTIONS(5510),
    [anon_sym_typename] = ACTIONS(5510),
    [anon_sym_new] = ACTIONS(5510),
    [anon_sym_COLON_COLON] = ACTIONS(5508),
    [anon_sym_delete] = ACTIONS(5510),
    [sym_nullptr] = ACTIONS(5510),
  },
  [2699] = {
    [sym_raw_string_literal] = ACTIONS(5512),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(5514),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(5514),
    [anon_sym_LPAREN] = ACTIONS(5512),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(5514),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(5514),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(5514),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(5514),
    [sym_preproc_directive] = ACTIONS(5514),
    [anon_sym_SEMI] = ACTIONS(5512),
    [anon_sym_typedef] = ACTIONS(5514),
    [anon_sym_extern] = ACTIONS(5514),
    [anon_sym_LBRACE] = ACTIONS(5512),
    [anon_sym_STAR] = ACTIONS(5512),
    [anon_sym_LBRACK] = ACTIONS(5512),
    [anon_sym_static] = ACTIONS(5514),
    [anon_sym_register] = ACTIONS(5514),
    [anon_sym_inline] = ACTIONS(5514),
    [anon_sym_const] = ACTIONS(5514),
    [anon_sym_restrict] = ACTIONS(5514),
    [anon_sym_volatile] = ACTIONS(5514),
    [anon_sym__Atomic] = ACTIONS(5514),
    [anon_sym_mutable] = ACTIONS(5514),
    [anon_sym_explicit] = ACTIONS(5514),
    [anon_sym_constexpr] = ACTIONS(5514),
    [anon_sym_unsigned] = ACTIONS(5514),
    [anon_sym_long] = ACTIONS(5514),
    [anon_sym_short] = ACTIONS(5514),
    [sym_primitive_type] = ACTIONS(5514),
    [anon_sym_enum] = ACTIONS(5514),
    [anon_sym_struct] = ACTIONS(5514),
    [anon_sym_union] = ACTIONS(5514),
    [anon_sym_if] = ACTIONS(5514),
    [anon_sym_switch] = ACTIONS(5514),
    [anon_sym_case] = ACTIONS(5514),
    [anon_sym_default] = ACTIONS(5514),
    [anon_sym_while] = ACTIONS(5514),
    [anon_sym_do] = ACTIONS(5514),
    [anon_sym_for] = ACTIONS(5514),
    [anon_sym_return] = ACTIONS(5514),
    [anon_sym_break] = ACTIONS(5514),
    [anon_sym_continue] = ACTIONS(5514),
    [anon_sym_goto] = ACTIONS(5514),
    [anon_sym_AMP] = ACTIONS(5512),
    [anon_sym_BANG] = ACTIONS(5512),
    [anon_sym_TILDE] = ACTIONS(5512),
    [anon_sym_PLUS] = ACTIONS(5514),
    [anon_sym_DASH] = ACTIONS(5514),
    [anon_sym_DASH_DASH] = ACTIONS(5512),
    [anon_sym_PLUS_PLUS] = ACTIONS(5512),
    [anon_sym_sizeof] = ACTIONS(5514),
    [sym_number_literal] = ACTIONS(5512),
    [sym_char_literal] = ACTIONS(5512),
    [sym_string_literal] = ACTIONS(5512),
    [sym_true] = ACTIONS(5514),
    [sym_false] = ACTIONS(5514),
    [sym_null] = ACTIONS(5514),
    [sym_identifier] = ACTIONS(5514),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(5514),
    [sym_auto] = ACTIONS(5514),
    [anon_sym_typename] = ACTIONS(5514),
    [anon_sym_new] = ACTIONS(5514),
    [anon_sym_COLON_COLON] = ACTIONS(5512),
    [anon_sym_delete] = ACTIONS(5514),
    [sym_nullptr] = ACTIONS(5514),
  },
  [2700] = {
    [sym_raw_string_literal] = ACTIONS(5516),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(5518),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(5518),
    [anon_sym_LPAREN] = ACTIONS(5516),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(5518),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(5518),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(5518),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(5518),
    [sym_preproc_directive] = ACTIONS(5518),
    [anon_sym_SEMI] = ACTIONS(5516),
    [anon_sym_typedef] = ACTIONS(5518),
    [anon_sym_extern] = ACTIONS(5518),
    [anon_sym_LBRACE] = ACTIONS(5516),
    [anon_sym_STAR] = ACTIONS(5516),
    [anon_sym_LBRACK] = ACTIONS(5516),
    [anon_sym_static] = ACTIONS(5518),
    [anon_sym_register] = ACTIONS(5518),
    [anon_sym_inline] = ACTIONS(5518),
    [anon_sym_const] = ACTIONS(5518),
    [anon_sym_restrict] = ACTIONS(5518),
    [anon_sym_volatile] = ACTIONS(5518),
    [anon_sym__Atomic] = ACTIONS(5518),
    [anon_sym_mutable] = ACTIONS(5518),
    [anon_sym_explicit] = ACTIONS(5518),
    [anon_sym_constexpr] = ACTIONS(5518),
    [anon_sym_unsigned] = ACTIONS(5518),
    [anon_sym_long] = ACTIONS(5518),
    [anon_sym_short] = ACTIONS(5518),
    [sym_primitive_type] = ACTIONS(5518),
    [anon_sym_enum] = ACTIONS(5518),
    [anon_sym_struct] = ACTIONS(5518),
    [anon_sym_union] = ACTIONS(5518),
    [anon_sym_if] = ACTIONS(5518),
    [anon_sym_switch] = ACTIONS(5518),
    [anon_sym_case] = ACTIONS(5518),
    [anon_sym_default] = ACTIONS(5518),
    [anon_sym_while] = ACTIONS(5518),
    [anon_sym_do] = ACTIONS(5518),
    [anon_sym_for] = ACTIONS(5518),
    [anon_sym_return] = ACTIONS(5518),
    [anon_sym_break] = ACTIONS(5518),
    [anon_sym_continue] = ACTIONS(5518),
    [anon_sym_goto] = ACTIONS(5518),
    [anon_sym_AMP] = ACTIONS(5516),
    [anon_sym_BANG] = ACTIONS(5516),
    [anon_sym_TILDE] = ACTIONS(5516),
    [anon_sym_PLUS] = ACTIONS(5518),
    [anon_sym_DASH] = ACTIONS(5518),
    [anon_sym_DASH_DASH] = ACTIONS(5516),
    [anon_sym_PLUS_PLUS] = ACTIONS(5516),
    [anon_sym_sizeof] = ACTIONS(5518),
    [sym_number_literal] = ACTIONS(5516),
    [sym_char_literal] = ACTIONS(5516),
    [sym_string_literal] = ACTIONS(5516),
    [sym_true] = ACTIONS(5518),
    [sym_false] = ACTIONS(5518),
    [sym_null] = ACTIONS(5518),
    [sym_identifier] = ACTIONS(5518),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(5518),
    [sym_auto] = ACTIONS(5518),
    [anon_sym_typename] = ACTIONS(5518),
    [anon_sym_new] = ACTIONS(5518),
    [anon_sym_COLON_COLON] = ACTIONS(5516),
    [anon_sym_delete] = ACTIONS(5518),
    [sym_nullptr] = ACTIONS(5518),
  },
  [2701] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(6726),
    [sym_comment] = ACTIONS(49),
  },
  [2702] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(6728),
    [sym_comment] = ACTIONS(49),
  },
  [2703] = {
    [sym_raw_string_literal] = ACTIONS(1972),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1974),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1974),
    [anon_sym_LPAREN] = ACTIONS(1972),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1974),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(1974),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1974),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1974),
    [sym_preproc_directive] = ACTIONS(1974),
    [anon_sym_SEMI] = ACTIONS(1972),
    [anon_sym_typedef] = ACTIONS(1974),
    [anon_sym_extern] = ACTIONS(1974),
    [anon_sym_LBRACE] = ACTIONS(1972),
    [anon_sym_STAR] = ACTIONS(1972),
    [anon_sym_LBRACK] = ACTIONS(1972),
    [anon_sym_static] = ACTIONS(1974),
    [anon_sym_register] = ACTIONS(1974),
    [anon_sym_inline] = ACTIONS(1974),
    [anon_sym_const] = ACTIONS(1974),
    [anon_sym_restrict] = ACTIONS(1974),
    [anon_sym_volatile] = ACTIONS(1974),
    [anon_sym__Atomic] = ACTIONS(1974),
    [anon_sym_mutable] = ACTIONS(1974),
    [anon_sym_explicit] = ACTIONS(1974),
    [anon_sym_constexpr] = ACTIONS(1974),
    [anon_sym_unsigned] = ACTIONS(1974),
    [anon_sym_long] = ACTIONS(1974),
    [anon_sym_short] = ACTIONS(1974),
    [sym_primitive_type] = ACTIONS(1974),
    [anon_sym_enum] = ACTIONS(1974),
    [anon_sym_struct] = ACTIONS(1974),
    [anon_sym_union] = ACTIONS(1974),
    [anon_sym_if] = ACTIONS(1974),
    [anon_sym_switch] = ACTIONS(1974),
    [anon_sym_case] = ACTIONS(1974),
    [anon_sym_default] = ACTIONS(1974),
    [anon_sym_while] = ACTIONS(1974),
    [anon_sym_do] = ACTIONS(1974),
    [anon_sym_for] = ACTIONS(1974),
    [anon_sym_return] = ACTIONS(1974),
    [anon_sym_break] = ACTIONS(1974),
    [anon_sym_continue] = ACTIONS(1974),
    [anon_sym_goto] = ACTIONS(1974),
    [anon_sym_AMP] = ACTIONS(1972),
    [anon_sym_BANG] = ACTIONS(1972),
    [anon_sym_TILDE] = ACTIONS(1972),
    [anon_sym_PLUS] = ACTIONS(1974),
    [anon_sym_DASH] = ACTIONS(1974),
    [anon_sym_DASH_DASH] = ACTIONS(1972),
    [anon_sym_PLUS_PLUS] = ACTIONS(1972),
    [anon_sym_sizeof] = ACTIONS(1974),
    [sym_number_literal] = ACTIONS(1972),
    [sym_char_literal] = ACTIONS(1972),
    [sym_string_literal] = ACTIONS(1972),
    [sym_true] = ACTIONS(1974),
    [sym_false] = ACTIONS(1974),
    [sym_null] = ACTIONS(1974),
    [sym_identifier] = ACTIONS(1974),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(1974),
    [sym_auto] = ACTIONS(1974),
    [anon_sym_typename] = ACTIONS(1974),
    [anon_sym_new] = ACTIONS(1974),
    [anon_sym_COLON_COLON] = ACTIONS(1972),
    [anon_sym_delete] = ACTIONS(1974),
    [sym_nullptr] = ACTIONS(1974),
  },
  [2704] = {
    [sym_raw_string_literal] = ACTIONS(1988),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1990),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1990),
    [anon_sym_LPAREN] = ACTIONS(1988),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1990),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(1990),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1990),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1990),
    [sym_preproc_directive] = ACTIONS(1990),
    [anon_sym_SEMI] = ACTIONS(1988),
    [anon_sym_typedef] = ACTIONS(1990),
    [anon_sym_extern] = ACTIONS(1990),
    [anon_sym_LBRACE] = ACTIONS(1988),
    [anon_sym_STAR] = ACTIONS(1988),
    [anon_sym_LBRACK] = ACTIONS(1988),
    [anon_sym_static] = ACTIONS(1990),
    [anon_sym_register] = ACTIONS(1990),
    [anon_sym_inline] = ACTIONS(1990),
    [anon_sym_const] = ACTIONS(1990),
    [anon_sym_restrict] = ACTIONS(1990),
    [anon_sym_volatile] = ACTIONS(1990),
    [anon_sym__Atomic] = ACTIONS(1990),
    [anon_sym_mutable] = ACTIONS(1990),
    [anon_sym_explicit] = ACTIONS(1990),
    [anon_sym_constexpr] = ACTIONS(1990),
    [anon_sym_unsigned] = ACTIONS(1990),
    [anon_sym_long] = ACTIONS(1990),
    [anon_sym_short] = ACTIONS(1990),
    [sym_primitive_type] = ACTIONS(1990),
    [anon_sym_enum] = ACTIONS(1990),
    [anon_sym_struct] = ACTIONS(1990),
    [anon_sym_union] = ACTIONS(1990),
    [anon_sym_if] = ACTIONS(1990),
    [anon_sym_switch] = ACTIONS(1990),
    [anon_sym_case] = ACTIONS(1990),
    [anon_sym_default] = ACTIONS(1990),
    [anon_sym_while] = ACTIONS(1990),
    [anon_sym_do] = ACTIONS(1990),
    [anon_sym_for] = ACTIONS(1990),
    [anon_sym_return] = ACTIONS(1990),
    [anon_sym_break] = ACTIONS(1990),
    [anon_sym_continue] = ACTIONS(1990),
    [anon_sym_goto] = ACTIONS(1990),
    [anon_sym_AMP] = ACTIONS(1988),
    [anon_sym_BANG] = ACTIONS(1988),
    [anon_sym_TILDE] = ACTIONS(1988),
    [anon_sym_PLUS] = ACTIONS(1990),
    [anon_sym_DASH] = ACTIONS(1990),
    [anon_sym_DASH_DASH] = ACTIONS(1988),
    [anon_sym_PLUS_PLUS] = ACTIONS(1988),
    [anon_sym_sizeof] = ACTIONS(1990),
    [sym_number_literal] = ACTIONS(1988),
    [sym_char_literal] = ACTIONS(1988),
    [sym_string_literal] = ACTIONS(1988),
    [sym_true] = ACTIONS(1990),
    [sym_false] = ACTIONS(1990),
    [sym_null] = ACTIONS(1990),
    [sym_identifier] = ACTIONS(1990),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(1990),
    [sym_auto] = ACTIONS(1990),
    [anon_sym_typename] = ACTIONS(1990),
    [anon_sym_new] = ACTIONS(1990),
    [anon_sym_COLON_COLON] = ACTIONS(1988),
    [anon_sym_delete] = ACTIONS(1990),
    [sym_nullptr] = ACTIONS(1990),
  },
  [2705] = {
    [sym_parameter_list] = STATE(513),
    [anon_sym_LPAREN] = ACTIONS(206),
    [anon_sym_SEMI] = ACTIONS(6730),
    [anon_sym_LBRACK] = ACTIONS(955),
    [sym_comment] = ACTIONS(49),
  },
  [2706] = {
    [sym_compound_statement] = STATE(2843),
    [sym_labeled_statement] = STATE(2843),
    [sym_expression_statement] = STATE(2843),
    [sym_if_statement] = STATE(2843),
    [sym_switch_statement] = STATE(2843),
    [sym_case_statement] = STATE(2843),
    [sym_while_statement] = STATE(2843),
    [sym_do_statement] = STATE(2843),
    [sym_for_statement] = STATE(2843),
    [sym_return_statement] = STATE(2843),
    [sym_break_statement] = STATE(2843),
    [sym_continue_statement] = STATE(2843),
    [sym_goto_statement] = STATE(2843),
    [sym__expression] = STATE(2844),
    [sym_comma_expression] = STATE(2845),
    [sym_conditional_expression] = STATE(2844),
    [sym_assignment_expression] = STATE(2844),
    [sym_pointer_expression] = STATE(2844),
    [sym_logical_expression] = STATE(2844),
    [sym_bitwise_expression] = STATE(2844),
    [sym_equality_expression] = STATE(2844),
    [sym_relational_expression] = STATE(2844),
    [sym_shift_expression] = STATE(2844),
    [sym_math_expression] = STATE(2844),
    [sym_cast_expression] = STATE(2844),
    [sym_sizeof_expression] = STATE(2844),
    [sym_subscript_expression] = STATE(2844),
    [sym_call_expression] = STATE(2844),
    [sym_field_expression] = STATE(2844),
    [sym_compound_literal_expression] = STATE(2844),
    [sym_parenthesized_expression] = STATE(2844),
    [sym_concatenated_string] = STATE(2844),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(2844),
    [sym_for_range_loop] = STATE(2843),
    [sym_new_expression] = STATE(2844),
    [sym_delete_expression] = STATE(2844),
    [sym_lambda_expression] = STATE(2844),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(6732),
    [anon_sym_LPAREN] = ACTIONS(626),
    [anon_sym_SEMI] = ACTIONS(6734),
    [anon_sym_LBRACE] = ACTIONS(6736),
    [anon_sym_STAR] = ACTIONS(644),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_if] = ACTIONS(6738),
    [anon_sym_switch] = ACTIONS(6740),
    [anon_sym_case] = ACTIONS(6742),
    [anon_sym_default] = ACTIONS(6744),
    [anon_sym_while] = ACTIONS(6746),
    [anon_sym_do] = ACTIONS(6748),
    [anon_sym_for] = ACTIONS(6750),
    [anon_sym_return] = ACTIONS(6752),
    [anon_sym_break] = ACTIONS(6754),
    [anon_sym_continue] = ACTIONS(6756),
    [anon_sym_goto] = ACTIONS(6758),
    [anon_sym_AMP] = ACTIONS(644),
    [anon_sym_BANG] = ACTIONS(668),
    [anon_sym_TILDE] = ACTIONS(670),
    [anon_sym_PLUS] = ACTIONS(672),
    [anon_sym_DASH] = ACTIONS(672),
    [anon_sym_DASH_DASH] = ACTIONS(674),
    [anon_sym_PLUS_PLUS] = ACTIONS(674),
    [anon_sym_sizeof] = ACTIONS(676),
    [sym_number_literal] = ACTIONS(6732),
    [sym_char_literal] = ACTIONS(6732),
    [sym_string_literal] = ACTIONS(678),
    [sym_true] = ACTIONS(6760),
    [sym_false] = ACTIONS(6760),
    [sym_null] = ACTIONS(6760),
    [sym_identifier] = ACTIONS(6762),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1303),
    [anon_sym_delete] = ACTIONS(686),
    [sym_nullptr] = ACTIONS(6760),
  },
  [2707] = {
    [sym_argument_list] = STATE(802),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_RPAREN] = ACTIONS(6764),
    [anon_sym_STAR] = ACTIONS(4537),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_EQ] = ACTIONS(4539),
    [anon_sym_QMARK] = ACTIONS(4541),
    [anon_sym_STAR_EQ] = ACTIONS(4543),
    [anon_sym_SLASH_EQ] = ACTIONS(4543),
    [anon_sym_PERCENT_EQ] = ACTIONS(4543),
    [anon_sym_PLUS_EQ] = ACTIONS(4543),
    [anon_sym_DASH_EQ] = ACTIONS(4543),
    [anon_sym_LT_LT_EQ] = ACTIONS(4543),
    [anon_sym_GT_GT_EQ] = ACTIONS(4543),
    [anon_sym_AMP_EQ] = ACTIONS(4543),
    [anon_sym_CARET_EQ] = ACTIONS(4543),
    [anon_sym_PIPE_EQ] = ACTIONS(4543),
    [anon_sym_AMP] = ACTIONS(4545),
    [anon_sym_PIPE_PIPE] = ACTIONS(4547),
    [anon_sym_AMP_AMP] = ACTIONS(4549),
    [anon_sym_PIPE] = ACTIONS(4551),
    [anon_sym_CARET] = ACTIONS(4553),
    [anon_sym_EQ_EQ] = ACTIONS(4555),
    [anon_sym_BANG_EQ] = ACTIONS(4555),
    [anon_sym_LT] = ACTIONS(4557),
    [anon_sym_GT] = ACTIONS(4557),
    [anon_sym_LT_EQ] = ACTIONS(4559),
    [anon_sym_GT_EQ] = ACTIONS(4559),
    [anon_sym_LT_LT] = ACTIONS(4561),
    [anon_sym_GT_GT] = ACTIONS(4561),
    [anon_sym_PLUS] = ACTIONS(4563),
    [anon_sym_DASH] = ACTIONS(4563),
    [anon_sym_SLASH] = ACTIONS(4537),
    [anon_sym_PERCENT] = ACTIONS(4537),
    [anon_sym_DASH_DASH] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(1554),
    [anon_sym_DASH_GT] = ACTIONS(1554),
    [sym_comment] = ACTIONS(49),
  },
  [2708] = {
    [sym_compound_statement] = STATE(2847),
    [sym_labeled_statement] = STATE(2847),
    [sym_expression_statement] = STATE(2847),
    [sym_if_statement] = STATE(2847),
    [sym_switch_statement] = STATE(2847),
    [sym_case_statement] = STATE(2847),
    [sym_while_statement] = STATE(2847),
    [sym_do_statement] = STATE(2847),
    [sym_for_statement] = STATE(2847),
    [sym_return_statement] = STATE(2847),
    [sym_break_statement] = STATE(2847),
    [sym_continue_statement] = STATE(2847),
    [sym_goto_statement] = STATE(2847),
    [sym__expression] = STATE(1947),
    [sym_comma_expression] = STATE(1948),
    [sym_conditional_expression] = STATE(1947),
    [sym_assignment_expression] = STATE(1947),
    [sym_pointer_expression] = STATE(1947),
    [sym_logical_expression] = STATE(1947),
    [sym_bitwise_expression] = STATE(1947),
    [sym_equality_expression] = STATE(1947),
    [sym_relational_expression] = STATE(1947),
    [sym_shift_expression] = STATE(1947),
    [sym_math_expression] = STATE(1947),
    [sym_cast_expression] = STATE(1947),
    [sym_sizeof_expression] = STATE(1947),
    [sym_subscript_expression] = STATE(1947),
    [sym_call_expression] = STATE(1947),
    [sym_field_expression] = STATE(1947),
    [sym_compound_literal_expression] = STATE(1947),
    [sym_parenthesized_expression] = STATE(1947),
    [sym_concatenated_string] = STATE(1947),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(1947),
    [sym_for_range_loop] = STATE(2847),
    [sym_new_expression] = STATE(1947),
    [sym_delete_expression] = STATE(1947),
    [sym_lambda_expression] = STATE(1947),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(4395),
    [anon_sym_LPAREN] = ACTIONS(626),
    [anon_sym_SEMI] = ACTIONS(4411),
    [anon_sym_LBRACE] = ACTIONS(4415),
    [anon_sym_STAR] = ACTIONS(644),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_if] = ACTIONS(4417),
    [anon_sym_switch] = ACTIONS(4419),
    [anon_sym_case] = ACTIONS(4421),
    [anon_sym_default] = ACTIONS(4423),
    [anon_sym_while] = ACTIONS(4425),
    [anon_sym_do] = ACTIONS(4427),
    [anon_sym_for] = ACTIONS(4429),
    [anon_sym_return] = ACTIONS(4431),
    [anon_sym_break] = ACTIONS(4433),
    [anon_sym_continue] = ACTIONS(4435),
    [anon_sym_goto] = ACTIONS(4437),
    [anon_sym_AMP] = ACTIONS(644),
    [anon_sym_BANG] = ACTIONS(668),
    [anon_sym_TILDE] = ACTIONS(670),
    [anon_sym_PLUS] = ACTIONS(672),
    [anon_sym_DASH] = ACTIONS(672),
    [anon_sym_DASH_DASH] = ACTIONS(674),
    [anon_sym_PLUS_PLUS] = ACTIONS(674),
    [anon_sym_sizeof] = ACTIONS(676),
    [sym_number_literal] = ACTIONS(4395),
    [sym_char_literal] = ACTIONS(4395),
    [sym_string_literal] = ACTIONS(678),
    [sym_true] = ACTIONS(4439),
    [sym_false] = ACTIONS(4439),
    [sym_null] = ACTIONS(4439),
    [sym_identifier] = ACTIONS(6077),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1303),
    [anon_sym_delete] = ACTIONS(686),
    [sym_nullptr] = ACTIONS(4439),
  },
  [2709] = {
    [sym_raw_string_literal] = ACTIONS(5631),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(5633),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(5633),
    [anon_sym_LPAREN] = ACTIONS(5631),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(5633),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(5633),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(5633),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(5633),
    [sym_preproc_directive] = ACTIONS(5633),
    [anon_sym_SEMI] = ACTIONS(5631),
    [anon_sym_typedef] = ACTIONS(5633),
    [anon_sym_extern] = ACTIONS(5633),
    [anon_sym_LBRACE] = ACTIONS(5631),
    [anon_sym_STAR] = ACTIONS(5631),
    [anon_sym_LBRACK] = ACTIONS(5631),
    [anon_sym_static] = ACTIONS(5633),
    [anon_sym_register] = ACTIONS(5633),
    [anon_sym_inline] = ACTIONS(5633),
    [anon_sym_const] = ACTIONS(5633),
    [anon_sym_restrict] = ACTIONS(5633),
    [anon_sym_volatile] = ACTIONS(5633),
    [anon_sym__Atomic] = ACTIONS(5633),
    [anon_sym_mutable] = ACTIONS(5633),
    [anon_sym_explicit] = ACTIONS(5633),
    [anon_sym_constexpr] = ACTIONS(5633),
    [anon_sym_unsigned] = ACTIONS(5633),
    [anon_sym_long] = ACTIONS(5633),
    [anon_sym_short] = ACTIONS(5633),
    [sym_primitive_type] = ACTIONS(5633),
    [anon_sym_enum] = ACTIONS(5633),
    [anon_sym_struct] = ACTIONS(5633),
    [anon_sym_union] = ACTIONS(5633),
    [anon_sym_if] = ACTIONS(5633),
    [anon_sym_switch] = ACTIONS(5633),
    [anon_sym_case] = ACTIONS(5633),
    [anon_sym_default] = ACTIONS(5633),
    [anon_sym_while] = ACTIONS(5633),
    [anon_sym_do] = ACTIONS(5633),
    [anon_sym_for] = ACTIONS(5633),
    [anon_sym_return] = ACTIONS(5633),
    [anon_sym_break] = ACTIONS(5633),
    [anon_sym_continue] = ACTIONS(5633),
    [anon_sym_goto] = ACTIONS(5633),
    [anon_sym_AMP] = ACTIONS(5631),
    [anon_sym_BANG] = ACTIONS(5631),
    [anon_sym_TILDE] = ACTIONS(5631),
    [anon_sym_PLUS] = ACTIONS(5633),
    [anon_sym_DASH] = ACTIONS(5633),
    [anon_sym_DASH_DASH] = ACTIONS(5631),
    [anon_sym_PLUS_PLUS] = ACTIONS(5631),
    [anon_sym_sizeof] = ACTIONS(5633),
    [sym_number_literal] = ACTIONS(5631),
    [sym_char_literal] = ACTIONS(5631),
    [sym_string_literal] = ACTIONS(5631),
    [sym_true] = ACTIONS(5633),
    [sym_false] = ACTIONS(5633),
    [sym_null] = ACTIONS(5633),
    [sym_identifier] = ACTIONS(5633),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(5633),
    [sym_auto] = ACTIONS(5633),
    [anon_sym_typename] = ACTIONS(5633),
    [anon_sym_new] = ACTIONS(5633),
    [anon_sym_COLON_COLON] = ACTIONS(5631),
    [anon_sym_delete] = ACTIONS(5633),
    [sym_nullptr] = ACTIONS(5633),
  },
  [2710] = {
    [sym_compound_statement] = STATE(2848),
    [sym_labeled_statement] = STATE(2848),
    [sym_expression_statement] = STATE(2848),
    [sym_if_statement] = STATE(2848),
    [sym_switch_statement] = STATE(2848),
    [sym_case_statement] = STATE(2848),
    [sym_while_statement] = STATE(2848),
    [sym_do_statement] = STATE(2848),
    [sym_for_statement] = STATE(2848),
    [sym_return_statement] = STATE(2848),
    [sym_break_statement] = STATE(2848),
    [sym_continue_statement] = STATE(2848),
    [sym_goto_statement] = STATE(2848),
    [sym__expression] = STATE(1947),
    [sym_comma_expression] = STATE(1948),
    [sym_conditional_expression] = STATE(1947),
    [sym_assignment_expression] = STATE(1947),
    [sym_pointer_expression] = STATE(1947),
    [sym_logical_expression] = STATE(1947),
    [sym_bitwise_expression] = STATE(1947),
    [sym_equality_expression] = STATE(1947),
    [sym_relational_expression] = STATE(1947),
    [sym_shift_expression] = STATE(1947),
    [sym_math_expression] = STATE(1947),
    [sym_cast_expression] = STATE(1947),
    [sym_sizeof_expression] = STATE(1947),
    [sym_subscript_expression] = STATE(1947),
    [sym_call_expression] = STATE(1947),
    [sym_field_expression] = STATE(1947),
    [sym_compound_literal_expression] = STATE(1947),
    [sym_parenthesized_expression] = STATE(1947),
    [sym_concatenated_string] = STATE(1947),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(1947),
    [sym_for_range_loop] = STATE(2848),
    [sym_new_expression] = STATE(1947),
    [sym_delete_expression] = STATE(1947),
    [sym_lambda_expression] = STATE(1947),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(4395),
    [anon_sym_LPAREN] = ACTIONS(626),
    [anon_sym_SEMI] = ACTIONS(4411),
    [anon_sym_LBRACE] = ACTIONS(4415),
    [anon_sym_STAR] = ACTIONS(644),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_if] = ACTIONS(4417),
    [anon_sym_switch] = ACTIONS(4419),
    [anon_sym_case] = ACTIONS(4421),
    [anon_sym_default] = ACTIONS(4423),
    [anon_sym_while] = ACTIONS(4425),
    [anon_sym_do] = ACTIONS(4427),
    [anon_sym_for] = ACTIONS(4429),
    [anon_sym_return] = ACTIONS(4431),
    [anon_sym_break] = ACTIONS(4433),
    [anon_sym_continue] = ACTIONS(4435),
    [anon_sym_goto] = ACTIONS(4437),
    [anon_sym_AMP] = ACTIONS(644),
    [anon_sym_BANG] = ACTIONS(668),
    [anon_sym_TILDE] = ACTIONS(670),
    [anon_sym_PLUS] = ACTIONS(672),
    [anon_sym_DASH] = ACTIONS(672),
    [anon_sym_DASH_DASH] = ACTIONS(674),
    [anon_sym_PLUS_PLUS] = ACTIONS(674),
    [anon_sym_sizeof] = ACTIONS(676),
    [sym_number_literal] = ACTIONS(4395),
    [sym_char_literal] = ACTIONS(4395),
    [sym_string_literal] = ACTIONS(678),
    [sym_true] = ACTIONS(4439),
    [sym_false] = ACTIONS(4439),
    [sym_null] = ACTIONS(4439),
    [sym_identifier] = ACTIONS(6077),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1303),
    [anon_sym_delete] = ACTIONS(686),
    [sym_nullptr] = ACTIONS(4439),
  },
  [2711] = {
    [sym__expression] = STATE(2849),
    [sym_conditional_expression] = STATE(2849),
    [sym_assignment_expression] = STATE(2849),
    [sym_pointer_expression] = STATE(2849),
    [sym_logical_expression] = STATE(2849),
    [sym_bitwise_expression] = STATE(2849),
    [sym_equality_expression] = STATE(2849),
    [sym_relational_expression] = STATE(2849),
    [sym_shift_expression] = STATE(2849),
    [sym_math_expression] = STATE(2849),
    [sym_cast_expression] = STATE(2849),
    [sym_sizeof_expression] = STATE(2849),
    [sym_subscript_expression] = STATE(2849),
    [sym_call_expression] = STATE(2849),
    [sym_field_expression] = STATE(2849),
    [sym_compound_literal_expression] = STATE(2849),
    [sym_parenthesized_expression] = STATE(2849),
    [sym_concatenated_string] = STATE(2849),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(2849),
    [sym_new_expression] = STATE(2849),
    [sym_delete_expression] = STATE(2849),
    [sym_lambda_expression] = STATE(2849),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(6766),
    [anon_sym_LPAREN] = ACTIONS(2943),
    [anon_sym_STAR] = ACTIONS(2945),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_AMP] = ACTIONS(2945),
    [anon_sym_BANG] = ACTIONS(2947),
    [anon_sym_TILDE] = ACTIONS(2949),
    [anon_sym_PLUS] = ACTIONS(2951),
    [anon_sym_DASH] = ACTIONS(2951),
    [anon_sym_DASH_DASH] = ACTIONS(2953),
    [anon_sym_PLUS_PLUS] = ACTIONS(2953),
    [anon_sym_sizeof] = ACTIONS(2955),
    [sym_number_literal] = ACTIONS(6766),
    [sym_char_literal] = ACTIONS(6766),
    [sym_string_literal] = ACTIONS(2957),
    [sym_true] = ACTIONS(6768),
    [sym_false] = ACTIONS(6768),
    [sym_null] = ACTIONS(6768),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(2961),
    [anon_sym_delete] = ACTIONS(2963),
    [sym_nullptr] = ACTIONS(6768),
  },
  [2712] = {
    [sym__expression] = STATE(2851),
    [sym_conditional_expression] = STATE(2851),
    [sym_assignment_expression] = STATE(2851),
    [sym_pointer_expression] = STATE(2851),
    [sym_logical_expression] = STATE(2851),
    [sym_bitwise_expression] = STATE(2851),
    [sym_equality_expression] = STATE(2851),
    [sym_relational_expression] = STATE(2851),
    [sym_shift_expression] = STATE(2851),
    [sym_math_expression] = STATE(2851),
    [sym_cast_expression] = STATE(2851),
    [sym_sizeof_expression] = STATE(2851),
    [sym_subscript_expression] = STATE(2851),
    [sym_call_expression] = STATE(2851),
    [sym_field_expression] = STATE(2851),
    [sym_compound_literal_expression] = STATE(2851),
    [sym_parenthesized_expression] = STATE(2851),
    [sym_concatenated_string] = STATE(2851),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(2851),
    [sym_new_expression] = STATE(2851),
    [sym_delete_expression] = STATE(2851),
    [sym_lambda_expression] = STATE(2851),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(6770),
    [anon_sym_LPAREN] = ACTIONS(1087),
    [anon_sym_RPAREN] = ACTIONS(6772),
    [anon_sym_STAR] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_AMP] = ACTIONS(1089),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1093),
    [anon_sym_PLUS] = ACTIONS(1095),
    [anon_sym_DASH] = ACTIONS(1095),
    [anon_sym_DASH_DASH] = ACTIONS(1097),
    [anon_sym_PLUS_PLUS] = ACTIONS(1097),
    [anon_sym_sizeof] = ACTIONS(1099),
    [sym_number_literal] = ACTIONS(6770),
    [sym_char_literal] = ACTIONS(6770),
    [sym_string_literal] = ACTIONS(1101),
    [sym_true] = ACTIONS(6774),
    [sym_false] = ACTIONS(6774),
    [sym_null] = ACTIONS(6774),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_delete] = ACTIONS(1109),
    [sym_nullptr] = ACTIONS(6774),
  },
  [2713] = {
    [sym_argument_list] = STATE(802),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_SEMI] = ACTIONS(6776),
    [anon_sym_STAR] = ACTIONS(2553),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_EQ] = ACTIONS(2555),
    [anon_sym_QMARK] = ACTIONS(2557),
    [anon_sym_STAR_EQ] = ACTIONS(2559),
    [anon_sym_SLASH_EQ] = ACTIONS(2559),
    [anon_sym_PERCENT_EQ] = ACTIONS(2559),
    [anon_sym_PLUS_EQ] = ACTIONS(2559),
    [anon_sym_DASH_EQ] = ACTIONS(2559),
    [anon_sym_LT_LT_EQ] = ACTIONS(2559),
    [anon_sym_GT_GT_EQ] = ACTIONS(2559),
    [anon_sym_AMP_EQ] = ACTIONS(2559),
    [anon_sym_CARET_EQ] = ACTIONS(2559),
    [anon_sym_PIPE_EQ] = ACTIONS(2559),
    [anon_sym_AMP] = ACTIONS(2561),
    [anon_sym_PIPE_PIPE] = ACTIONS(2563),
    [anon_sym_AMP_AMP] = ACTIONS(2565),
    [anon_sym_PIPE] = ACTIONS(2567),
    [anon_sym_CARET] = ACTIONS(2569),
    [anon_sym_EQ_EQ] = ACTIONS(2571),
    [anon_sym_BANG_EQ] = ACTIONS(2571),
    [anon_sym_LT] = ACTIONS(2573),
    [anon_sym_GT] = ACTIONS(2573),
    [anon_sym_LT_EQ] = ACTIONS(2575),
    [anon_sym_GT_EQ] = ACTIONS(2575),
    [anon_sym_LT_LT] = ACTIONS(2577),
    [anon_sym_GT_GT] = ACTIONS(2577),
    [anon_sym_PLUS] = ACTIONS(2579),
    [anon_sym_DASH] = ACTIONS(2579),
    [anon_sym_SLASH] = ACTIONS(2553),
    [anon_sym_PERCENT] = ACTIONS(2553),
    [anon_sym_DASH_DASH] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(1554),
    [anon_sym_DASH_GT] = ACTIONS(1554),
    [sym_comment] = ACTIONS(49),
  },
  [2714] = {
    [sym__expression] = STATE(2853),
    [sym_conditional_expression] = STATE(2853),
    [sym_assignment_expression] = STATE(2853),
    [sym_pointer_expression] = STATE(2853),
    [sym_logical_expression] = STATE(2853),
    [sym_bitwise_expression] = STATE(2853),
    [sym_equality_expression] = STATE(2853),
    [sym_relational_expression] = STATE(2853),
    [sym_shift_expression] = STATE(2853),
    [sym_math_expression] = STATE(2853),
    [sym_cast_expression] = STATE(2853),
    [sym_sizeof_expression] = STATE(2853),
    [sym_subscript_expression] = STATE(2853),
    [sym_call_expression] = STATE(2853),
    [sym_field_expression] = STATE(2853),
    [sym_compound_literal_expression] = STATE(2853),
    [sym_parenthesized_expression] = STATE(2853),
    [sym_concatenated_string] = STATE(2853),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(2853),
    [sym_new_expression] = STATE(2853),
    [sym_delete_expression] = STATE(2853),
    [sym_lambda_expression] = STATE(2853),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(6778),
    [anon_sym_LPAREN] = ACTIONS(1347),
    [anon_sym_SEMI] = ACTIONS(6776),
    [anon_sym_STAR] = ACTIONS(1349),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_AMP] = ACTIONS(1349),
    [anon_sym_BANG] = ACTIONS(1351),
    [anon_sym_TILDE] = ACTIONS(1353),
    [anon_sym_PLUS] = ACTIONS(1355),
    [anon_sym_DASH] = ACTIONS(1355),
    [anon_sym_DASH_DASH] = ACTIONS(1357),
    [anon_sym_PLUS_PLUS] = ACTIONS(1357),
    [anon_sym_sizeof] = ACTIONS(1359),
    [sym_number_literal] = ACTIONS(6778),
    [sym_char_literal] = ACTIONS(6778),
    [sym_string_literal] = ACTIONS(1361),
    [sym_true] = ACTIONS(6780),
    [sym_false] = ACTIONS(6780),
    [sym_null] = ACTIONS(6780),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1365),
    [anon_sym_delete] = ACTIONS(1367),
    [sym_nullptr] = ACTIONS(6780),
  },
  [2715] = {
    [sym__expression] = STATE(2854),
    [sym_conditional_expression] = STATE(2854),
    [sym_assignment_expression] = STATE(2854),
    [sym_pointer_expression] = STATE(2854),
    [sym_logical_expression] = STATE(2854),
    [sym_bitwise_expression] = STATE(2854),
    [sym_equality_expression] = STATE(2854),
    [sym_relational_expression] = STATE(2854),
    [sym_shift_expression] = STATE(2854),
    [sym_math_expression] = STATE(2854),
    [sym_cast_expression] = STATE(2854),
    [sym_sizeof_expression] = STATE(2854),
    [sym_subscript_expression] = STATE(2854),
    [sym_call_expression] = STATE(2854),
    [sym_field_expression] = STATE(2854),
    [sym_compound_literal_expression] = STATE(2854),
    [sym_parenthesized_expression] = STATE(2854),
    [sym_concatenated_string] = STATE(2854),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(2854),
    [sym_new_expression] = STATE(2854),
    [sym_delete_expression] = STATE(2854),
    [sym_lambda_expression] = STATE(2854),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(6782),
    [anon_sym_LPAREN] = ACTIONS(2943),
    [anon_sym_STAR] = ACTIONS(2945),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_AMP] = ACTIONS(2945),
    [anon_sym_BANG] = ACTIONS(2947),
    [anon_sym_TILDE] = ACTIONS(2949),
    [anon_sym_PLUS] = ACTIONS(2951),
    [anon_sym_DASH] = ACTIONS(2951),
    [anon_sym_DASH_DASH] = ACTIONS(2953),
    [anon_sym_PLUS_PLUS] = ACTIONS(2953),
    [anon_sym_sizeof] = ACTIONS(2955),
    [sym_number_literal] = ACTIONS(6782),
    [sym_char_literal] = ACTIONS(6782),
    [sym_string_literal] = ACTIONS(2957),
    [sym_true] = ACTIONS(6784),
    [sym_false] = ACTIONS(6784),
    [sym_null] = ACTIONS(6784),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(2961),
    [anon_sym_delete] = ACTIONS(2963),
    [sym_nullptr] = ACTIONS(6784),
  },
  [2716] = {
    [sym_raw_string_literal] = ACTIONS(2478),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(2480),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(2480),
    [anon_sym_LPAREN] = ACTIONS(2478),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(2480),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(2480),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(2480),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(2480),
    [sym_preproc_directive] = ACTIONS(2480),
    [anon_sym_SEMI] = ACTIONS(2478),
    [anon_sym_typedef] = ACTIONS(2480),
    [anon_sym_extern] = ACTIONS(2480),
    [anon_sym_LBRACE] = ACTIONS(2478),
    [anon_sym_STAR] = ACTIONS(2478),
    [anon_sym_LBRACK] = ACTIONS(2478),
    [anon_sym_static] = ACTIONS(2480),
    [anon_sym_register] = ACTIONS(2480),
    [anon_sym_inline] = ACTIONS(2480),
    [anon_sym_const] = ACTIONS(2480),
    [anon_sym_restrict] = ACTIONS(2480),
    [anon_sym_volatile] = ACTIONS(2480),
    [anon_sym__Atomic] = ACTIONS(2480),
    [anon_sym_mutable] = ACTIONS(2480),
    [anon_sym_explicit] = ACTIONS(2480),
    [anon_sym_constexpr] = ACTIONS(2480),
    [anon_sym_unsigned] = ACTIONS(2480),
    [anon_sym_long] = ACTIONS(2480),
    [anon_sym_short] = ACTIONS(2480),
    [sym_primitive_type] = ACTIONS(2480),
    [anon_sym_enum] = ACTIONS(2480),
    [anon_sym_struct] = ACTIONS(2480),
    [anon_sym_union] = ACTIONS(2480),
    [anon_sym_if] = ACTIONS(2480),
    [anon_sym_switch] = ACTIONS(2480),
    [anon_sym_case] = ACTIONS(2480),
    [anon_sym_default] = ACTIONS(2480),
    [anon_sym_while] = ACTIONS(2480),
    [anon_sym_do] = ACTIONS(2480),
    [anon_sym_for] = ACTIONS(2480),
    [anon_sym_return] = ACTIONS(2480),
    [anon_sym_break] = ACTIONS(2480),
    [anon_sym_continue] = ACTIONS(2480),
    [anon_sym_goto] = ACTIONS(2480),
    [anon_sym_AMP] = ACTIONS(2478),
    [anon_sym_BANG] = ACTIONS(2478),
    [anon_sym_TILDE] = ACTIONS(2478),
    [anon_sym_PLUS] = ACTIONS(2480),
    [anon_sym_DASH] = ACTIONS(2480),
    [anon_sym_DASH_DASH] = ACTIONS(2478),
    [anon_sym_PLUS_PLUS] = ACTIONS(2478),
    [anon_sym_sizeof] = ACTIONS(2480),
    [sym_number_literal] = ACTIONS(2478),
    [sym_char_literal] = ACTIONS(2478),
    [sym_string_literal] = ACTIONS(2478),
    [sym_true] = ACTIONS(2480),
    [sym_false] = ACTIONS(2480),
    [sym_null] = ACTIONS(2480),
    [sym_identifier] = ACTIONS(2480),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(2480),
    [sym_auto] = ACTIONS(2480),
    [anon_sym_typename] = ACTIONS(2480),
    [anon_sym_new] = ACTIONS(2480),
    [anon_sym_COLON_COLON] = ACTIONS(2478),
    [anon_sym_delete] = ACTIONS(2480),
    [sym_nullptr] = ACTIONS(2480),
  },
  [2717] = {
    [sym_argument_list] = STATE(802),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_SEMI] = ACTIONS(6786),
    [anon_sym_STAR] = ACTIONS(2553),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_EQ] = ACTIONS(2555),
    [anon_sym_QMARK] = ACTIONS(2557),
    [anon_sym_STAR_EQ] = ACTIONS(2559),
    [anon_sym_SLASH_EQ] = ACTIONS(2559),
    [anon_sym_PERCENT_EQ] = ACTIONS(2559),
    [anon_sym_PLUS_EQ] = ACTIONS(2559),
    [anon_sym_DASH_EQ] = ACTIONS(2559),
    [anon_sym_LT_LT_EQ] = ACTIONS(2559),
    [anon_sym_GT_GT_EQ] = ACTIONS(2559),
    [anon_sym_AMP_EQ] = ACTIONS(2559),
    [anon_sym_CARET_EQ] = ACTIONS(2559),
    [anon_sym_PIPE_EQ] = ACTIONS(2559),
    [anon_sym_AMP] = ACTIONS(2561),
    [anon_sym_PIPE_PIPE] = ACTIONS(2563),
    [anon_sym_AMP_AMP] = ACTIONS(2565),
    [anon_sym_PIPE] = ACTIONS(2567),
    [anon_sym_CARET] = ACTIONS(2569),
    [anon_sym_EQ_EQ] = ACTIONS(2571),
    [anon_sym_BANG_EQ] = ACTIONS(2571),
    [anon_sym_LT] = ACTIONS(2573),
    [anon_sym_GT] = ACTIONS(2573),
    [anon_sym_LT_EQ] = ACTIONS(2575),
    [anon_sym_GT_EQ] = ACTIONS(2575),
    [anon_sym_LT_LT] = ACTIONS(2577),
    [anon_sym_GT_GT] = ACTIONS(2577),
    [anon_sym_PLUS] = ACTIONS(2579),
    [anon_sym_DASH] = ACTIONS(2579),
    [anon_sym_SLASH] = ACTIONS(2553),
    [anon_sym_PERCENT] = ACTIONS(2553),
    [anon_sym_DASH_DASH] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(1554),
    [anon_sym_DASH_GT] = ACTIONS(1554),
    [sym_comment] = ACTIONS(49),
  },
  [2718] = {
    [anon_sym_SEMI] = ACTIONS(6786),
    [sym_comment] = ACTIONS(49),
  },
  [2719] = {
    [sym_raw_string_literal] = ACTIONS(2581),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(2583),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(2583),
    [anon_sym_LPAREN] = ACTIONS(2581),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(2583),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(2583),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(2583),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(2583),
    [sym_preproc_directive] = ACTIONS(2583),
    [anon_sym_SEMI] = ACTIONS(2581),
    [anon_sym_typedef] = ACTIONS(2583),
    [anon_sym_extern] = ACTIONS(2583),
    [anon_sym_LBRACE] = ACTIONS(2581),
    [anon_sym_STAR] = ACTIONS(2581),
    [anon_sym_LBRACK] = ACTIONS(2581),
    [anon_sym_static] = ACTIONS(2583),
    [anon_sym_register] = ACTIONS(2583),
    [anon_sym_inline] = ACTIONS(2583),
    [anon_sym_const] = ACTIONS(2583),
    [anon_sym_restrict] = ACTIONS(2583),
    [anon_sym_volatile] = ACTIONS(2583),
    [anon_sym__Atomic] = ACTIONS(2583),
    [anon_sym_mutable] = ACTIONS(2583),
    [anon_sym_explicit] = ACTIONS(2583),
    [anon_sym_constexpr] = ACTIONS(2583),
    [anon_sym_unsigned] = ACTIONS(2583),
    [anon_sym_long] = ACTIONS(2583),
    [anon_sym_short] = ACTIONS(2583),
    [sym_primitive_type] = ACTIONS(2583),
    [anon_sym_enum] = ACTIONS(2583),
    [anon_sym_struct] = ACTIONS(2583),
    [anon_sym_union] = ACTIONS(2583),
    [anon_sym_if] = ACTIONS(2583),
    [anon_sym_switch] = ACTIONS(2583),
    [anon_sym_case] = ACTIONS(2583),
    [anon_sym_default] = ACTIONS(2583),
    [anon_sym_while] = ACTIONS(2583),
    [anon_sym_do] = ACTIONS(2583),
    [anon_sym_for] = ACTIONS(2583),
    [anon_sym_return] = ACTIONS(2583),
    [anon_sym_break] = ACTIONS(2583),
    [anon_sym_continue] = ACTIONS(2583),
    [anon_sym_goto] = ACTIONS(2583),
    [anon_sym_AMP] = ACTIONS(2581),
    [anon_sym_BANG] = ACTIONS(2581),
    [anon_sym_TILDE] = ACTIONS(2581),
    [anon_sym_PLUS] = ACTIONS(2583),
    [anon_sym_DASH] = ACTIONS(2583),
    [anon_sym_DASH_DASH] = ACTIONS(2581),
    [anon_sym_PLUS_PLUS] = ACTIONS(2581),
    [anon_sym_sizeof] = ACTIONS(2583),
    [sym_number_literal] = ACTIONS(2581),
    [sym_char_literal] = ACTIONS(2581),
    [sym_string_literal] = ACTIONS(2581),
    [sym_true] = ACTIONS(2583),
    [sym_false] = ACTIONS(2583),
    [sym_null] = ACTIONS(2583),
    [sym_identifier] = ACTIONS(2583),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(2583),
    [sym_auto] = ACTIONS(2583),
    [anon_sym_typename] = ACTIONS(2583),
    [anon_sym_new] = ACTIONS(2583),
    [anon_sym_COLON_COLON] = ACTIONS(2581),
    [anon_sym_delete] = ACTIONS(2583),
    [sym_nullptr] = ACTIONS(2583),
  },
  [2720] = {
    [sym_argument_list] = STATE(802),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_SEMI] = ACTIONS(6788),
    [anon_sym_STAR] = ACTIONS(2553),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_EQ] = ACTIONS(2555),
    [anon_sym_QMARK] = ACTIONS(2557),
    [anon_sym_STAR_EQ] = ACTIONS(2559),
    [anon_sym_SLASH_EQ] = ACTIONS(2559),
    [anon_sym_PERCENT_EQ] = ACTIONS(2559),
    [anon_sym_PLUS_EQ] = ACTIONS(2559),
    [anon_sym_DASH_EQ] = ACTIONS(2559),
    [anon_sym_LT_LT_EQ] = ACTIONS(2559),
    [anon_sym_GT_GT_EQ] = ACTIONS(2559),
    [anon_sym_AMP_EQ] = ACTIONS(2559),
    [anon_sym_CARET_EQ] = ACTIONS(2559),
    [anon_sym_PIPE_EQ] = ACTIONS(2559),
    [anon_sym_AMP] = ACTIONS(2561),
    [anon_sym_PIPE_PIPE] = ACTIONS(2563),
    [anon_sym_AMP_AMP] = ACTIONS(2565),
    [anon_sym_PIPE] = ACTIONS(2567),
    [anon_sym_CARET] = ACTIONS(2569),
    [anon_sym_EQ_EQ] = ACTIONS(2571),
    [anon_sym_BANG_EQ] = ACTIONS(2571),
    [anon_sym_LT] = ACTIONS(2573),
    [anon_sym_GT] = ACTIONS(2573),
    [anon_sym_LT_EQ] = ACTIONS(2575),
    [anon_sym_GT_EQ] = ACTIONS(2575),
    [anon_sym_LT_LT] = ACTIONS(2577),
    [anon_sym_GT_GT] = ACTIONS(2577),
    [anon_sym_PLUS] = ACTIONS(2579),
    [anon_sym_DASH] = ACTIONS(2579),
    [anon_sym_SLASH] = ACTIONS(2553),
    [anon_sym_PERCENT] = ACTIONS(2553),
    [anon_sym_DASH_DASH] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(1554),
    [anon_sym_DASH_GT] = ACTIONS(1554),
    [sym_comment] = ACTIONS(49),
  },
  [2721] = {
    [anon_sym_SEMI] = ACTIONS(6788),
    [sym_comment] = ACTIONS(49),
  },
  [2722] = {
    [sym_raw_string_literal] = ACTIONS(2587),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(2589),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(2589),
    [anon_sym_LPAREN] = ACTIONS(2587),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(2589),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(2589),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(2589),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(2589),
    [sym_preproc_directive] = ACTIONS(2589),
    [anon_sym_SEMI] = ACTIONS(2587),
    [anon_sym_typedef] = ACTIONS(2589),
    [anon_sym_extern] = ACTIONS(2589),
    [anon_sym_LBRACE] = ACTIONS(2587),
    [anon_sym_STAR] = ACTIONS(2587),
    [anon_sym_LBRACK] = ACTIONS(2587),
    [anon_sym_static] = ACTIONS(2589),
    [anon_sym_register] = ACTIONS(2589),
    [anon_sym_inline] = ACTIONS(2589),
    [anon_sym_const] = ACTIONS(2589),
    [anon_sym_restrict] = ACTIONS(2589),
    [anon_sym_volatile] = ACTIONS(2589),
    [anon_sym__Atomic] = ACTIONS(2589),
    [anon_sym_mutable] = ACTIONS(2589),
    [anon_sym_explicit] = ACTIONS(2589),
    [anon_sym_constexpr] = ACTIONS(2589),
    [anon_sym_unsigned] = ACTIONS(2589),
    [anon_sym_long] = ACTIONS(2589),
    [anon_sym_short] = ACTIONS(2589),
    [sym_primitive_type] = ACTIONS(2589),
    [anon_sym_enum] = ACTIONS(2589),
    [anon_sym_struct] = ACTIONS(2589),
    [anon_sym_union] = ACTIONS(2589),
    [anon_sym_if] = ACTIONS(2589),
    [anon_sym_switch] = ACTIONS(2589),
    [anon_sym_case] = ACTIONS(2589),
    [anon_sym_default] = ACTIONS(2589),
    [anon_sym_while] = ACTIONS(2589),
    [anon_sym_do] = ACTIONS(2589),
    [anon_sym_for] = ACTIONS(2589),
    [anon_sym_return] = ACTIONS(2589),
    [anon_sym_break] = ACTIONS(2589),
    [anon_sym_continue] = ACTIONS(2589),
    [anon_sym_goto] = ACTIONS(2589),
    [anon_sym_AMP] = ACTIONS(2587),
    [anon_sym_BANG] = ACTIONS(2587),
    [anon_sym_TILDE] = ACTIONS(2587),
    [anon_sym_PLUS] = ACTIONS(2589),
    [anon_sym_DASH] = ACTIONS(2589),
    [anon_sym_DASH_DASH] = ACTIONS(2587),
    [anon_sym_PLUS_PLUS] = ACTIONS(2587),
    [anon_sym_sizeof] = ACTIONS(2589),
    [sym_number_literal] = ACTIONS(2587),
    [sym_char_literal] = ACTIONS(2587),
    [sym_string_literal] = ACTIONS(2587),
    [sym_true] = ACTIONS(2589),
    [sym_false] = ACTIONS(2589),
    [sym_null] = ACTIONS(2589),
    [sym_identifier] = ACTIONS(2589),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(2589),
    [sym_auto] = ACTIONS(2589),
    [anon_sym_typename] = ACTIONS(2589),
    [anon_sym_new] = ACTIONS(2589),
    [anon_sym_COLON_COLON] = ACTIONS(2587),
    [anon_sym_delete] = ACTIONS(2589),
    [sym_nullptr] = ACTIONS(2589),
  },
  [2723] = {
    [sym_raw_string_literal] = ACTIONS(3519),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3521),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3521),
    [anon_sym_LPAREN] = ACTIONS(3519),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3521),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3521),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3521),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3521),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(3521),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(3521),
    [sym_preproc_directive] = ACTIONS(3521),
    [anon_sym_SEMI] = ACTIONS(3519),
    [anon_sym_typedef] = ACTIONS(3521),
    [anon_sym_extern] = ACTIONS(3521),
    [anon_sym_LBRACE] = ACTIONS(3519),
    [anon_sym_STAR] = ACTIONS(3519),
    [anon_sym_LBRACK] = ACTIONS(3519),
    [anon_sym_static] = ACTIONS(3521),
    [anon_sym_register] = ACTIONS(3521),
    [anon_sym_inline] = ACTIONS(3521),
    [anon_sym_const] = ACTIONS(3521),
    [anon_sym_restrict] = ACTIONS(3521),
    [anon_sym_volatile] = ACTIONS(3521),
    [anon_sym__Atomic] = ACTIONS(3521),
    [anon_sym_mutable] = ACTIONS(3521),
    [anon_sym_explicit] = ACTIONS(3521),
    [anon_sym_constexpr] = ACTIONS(3521),
    [anon_sym_unsigned] = ACTIONS(3521),
    [anon_sym_long] = ACTIONS(3521),
    [anon_sym_short] = ACTIONS(3521),
    [sym_primitive_type] = ACTIONS(3521),
    [anon_sym_enum] = ACTIONS(3521),
    [anon_sym_struct] = ACTIONS(3521),
    [anon_sym_union] = ACTIONS(3521),
    [anon_sym_if] = ACTIONS(3521),
    [anon_sym_switch] = ACTIONS(3521),
    [anon_sym_case] = ACTIONS(3521),
    [anon_sym_default] = ACTIONS(3521),
    [anon_sym_while] = ACTIONS(3521),
    [anon_sym_do] = ACTIONS(3521),
    [anon_sym_for] = ACTIONS(3521),
    [anon_sym_return] = ACTIONS(3521),
    [anon_sym_break] = ACTIONS(3521),
    [anon_sym_continue] = ACTIONS(3521),
    [anon_sym_goto] = ACTIONS(3521),
    [anon_sym_AMP] = ACTIONS(3519),
    [anon_sym_BANG] = ACTIONS(3519),
    [anon_sym_TILDE] = ACTIONS(3519),
    [anon_sym_PLUS] = ACTIONS(3521),
    [anon_sym_DASH] = ACTIONS(3521),
    [anon_sym_DASH_DASH] = ACTIONS(3519),
    [anon_sym_PLUS_PLUS] = ACTIONS(3519),
    [anon_sym_sizeof] = ACTIONS(3521),
    [sym_number_literal] = ACTIONS(3519),
    [sym_char_literal] = ACTIONS(3519),
    [sym_string_literal] = ACTIONS(3519),
    [sym_true] = ACTIONS(3521),
    [sym_false] = ACTIONS(3521),
    [sym_null] = ACTIONS(3521),
    [sym_identifier] = ACTIONS(3521),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(3521),
    [sym_auto] = ACTIONS(3521),
    [anon_sym_typename] = ACTIONS(3521),
    [anon_sym_new] = ACTIONS(3521),
    [anon_sym_COLON_COLON] = ACTIONS(3519),
    [anon_sym_delete] = ACTIONS(3521),
    [sym_nullptr] = ACTIONS(3521),
  },
  [2724] = {
    [sym_raw_string_literal] = ACTIONS(1614),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1616),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1616),
    [anon_sym_LPAREN] = ACTIONS(1614),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1616),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(1616),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1616),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1616),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(1616),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(1616),
    [sym_preproc_directive] = ACTIONS(1616),
    [anon_sym_SEMI] = ACTIONS(1614),
    [anon_sym_typedef] = ACTIONS(1616),
    [anon_sym_extern] = ACTIONS(1616),
    [anon_sym_LBRACE] = ACTIONS(1614),
    [anon_sym_STAR] = ACTIONS(1614),
    [anon_sym_LBRACK] = ACTIONS(1614),
    [anon_sym_static] = ACTIONS(1616),
    [anon_sym_register] = ACTIONS(1616),
    [anon_sym_inline] = ACTIONS(1616),
    [anon_sym_const] = ACTIONS(1616),
    [anon_sym_restrict] = ACTIONS(1616),
    [anon_sym_volatile] = ACTIONS(1616),
    [anon_sym__Atomic] = ACTIONS(1616),
    [anon_sym_mutable] = ACTIONS(1616),
    [anon_sym_explicit] = ACTIONS(1616),
    [anon_sym_constexpr] = ACTIONS(1616),
    [anon_sym_unsigned] = ACTIONS(1616),
    [anon_sym_long] = ACTIONS(1616),
    [anon_sym_short] = ACTIONS(1616),
    [sym_primitive_type] = ACTIONS(1616),
    [anon_sym_enum] = ACTIONS(1616),
    [anon_sym_struct] = ACTIONS(1616),
    [anon_sym_union] = ACTIONS(1616),
    [anon_sym_if] = ACTIONS(1616),
    [anon_sym_else] = ACTIONS(1616),
    [anon_sym_switch] = ACTIONS(1616),
    [anon_sym_case] = ACTIONS(1616),
    [anon_sym_default] = ACTIONS(1616),
    [anon_sym_while] = ACTIONS(1616),
    [anon_sym_do] = ACTIONS(1616),
    [anon_sym_for] = ACTIONS(1616),
    [anon_sym_return] = ACTIONS(1616),
    [anon_sym_break] = ACTIONS(1616),
    [anon_sym_continue] = ACTIONS(1616),
    [anon_sym_goto] = ACTIONS(1616),
    [anon_sym_AMP] = ACTIONS(1614),
    [anon_sym_BANG] = ACTIONS(1614),
    [anon_sym_TILDE] = ACTIONS(1614),
    [anon_sym_PLUS] = ACTIONS(1616),
    [anon_sym_DASH] = ACTIONS(1616),
    [anon_sym_DASH_DASH] = ACTIONS(1614),
    [anon_sym_PLUS_PLUS] = ACTIONS(1614),
    [anon_sym_sizeof] = ACTIONS(1616),
    [sym_number_literal] = ACTIONS(1614),
    [sym_char_literal] = ACTIONS(1614),
    [sym_string_literal] = ACTIONS(1614),
    [sym_true] = ACTIONS(1616),
    [sym_false] = ACTIONS(1616),
    [sym_null] = ACTIONS(1616),
    [sym_identifier] = ACTIONS(1616),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(1616),
    [sym_auto] = ACTIONS(1616),
    [anon_sym_typename] = ACTIONS(1616),
    [anon_sym_new] = ACTIONS(1616),
    [anon_sym_COLON_COLON] = ACTIONS(1614),
    [anon_sym_delete] = ACTIONS(1616),
    [sym_nullptr] = ACTIONS(1616),
  },
  [2725] = {
    [sym_preproc_include] = STATE(2858),
    [sym_preproc_def] = STATE(2858),
    [sym_preproc_function_def] = STATE(2858),
    [sym_preproc_call] = STATE(2858),
    [sym_preproc_if_in_compound_statement] = STATE(410),
    [sym_preproc_ifdef_in_compound_statement] = STATE(411),
    [sym_declaration] = STATE(2858),
    [sym_type_definition] = STATE(2858),
    [sym__declaration_specifiers] = STATE(412),
    [sym_compound_statement] = STATE(2858),
    [sym_storage_class_specifier] = STATE(419),
    [sym_type_qualifier] = STATE(419),
    [sym__type_specifier] = STATE(30),
    [sym_sized_type_specifier] = STATE(30),
    [sym_enum_specifier] = STATE(30),
    [sym_struct_specifier] = STATE(30),
    [sym_union_specifier] = STATE(30),
    [sym_labeled_statement] = STATE(2858),
    [sym_expression_statement] = STATE(2858),
    [sym_if_statement] = STATE(2858),
    [sym_switch_statement] = STATE(2858),
    [sym_case_statement] = STATE(2858),
    [sym_while_statement] = STATE(2858),
    [sym_do_statement] = STATE(2858),
    [sym_for_statement] = STATE(2858),
    [sym_return_statement] = STATE(2858),
    [sym_break_statement] = STATE(2858),
    [sym_continue_statement] = STATE(2858),
    [sym_goto_statement] = STATE(2858),
    [sym__expression] = STATE(413),
    [sym_comma_expression] = STATE(414),
    [sym_conditional_expression] = STATE(413),
    [sym_assignment_expression] = STATE(413),
    [sym_pointer_expression] = STATE(413),
    [sym_logical_expression] = STATE(413),
    [sym_bitwise_expression] = STATE(413),
    [sym_equality_expression] = STATE(413),
    [sym_relational_expression] = STATE(413),
    [sym_shift_expression] = STATE(413),
    [sym_math_expression] = STATE(413),
    [sym_cast_expression] = STATE(413),
    [sym_sizeof_expression] = STATE(413),
    [sym_subscript_expression] = STATE(413),
    [sym_call_expression] = STATE(413),
    [sym_field_expression] = STATE(413),
    [sym_compound_literal_expression] = STATE(413),
    [sym_parenthesized_expression] = STATE(413),
    [sym_concatenated_string] = STATE(413),
    [sym__empty_declaration] = STATE(2858),
    [sym_macro_type_specifier] = STATE(30),
    [sym_class_specifier] = STATE(30),
    [sym_dependent_type] = STATE(30),
    [sym_structured_binding_declaration] = STATE(2858),
    [sym_template_type] = STATE(415),
    [sym_template_function] = STATE(413),
    [sym_for_range_loop] = STATE(2858),
    [sym_new_expression] = STATE(413),
    [sym_delete_expression] = STATE(413),
    [sym_lambda_expression] = STATE(413),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(416),
    [sym_scoped_namespace_identifier] = STATE(417),
    [aux_sym_preproc_if_in_compound_statement_repeat1] = STATE(2858),
    [aux_sym__declaration_specifiers_repeat1] = STATE(419),
    [aux_sym_sized_type_specifier_repeat1] = STATE(38),
    [sym_raw_string_literal] = ACTIONS(620),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(622),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(624),
    [anon_sym_LPAREN] = ACTIONS(626),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(628),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(630),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(632),
    [sym_preproc_directive] = ACTIONS(634),
    [anon_sym_SEMI] = ACTIONS(636),
    [anon_sym_typedef] = ACTIONS(638),
    [anon_sym_extern] = ACTIONS(154),
    [anon_sym_LBRACE] = ACTIONS(640),
    [anon_sym_RBRACE] = ACTIONS(6790),
    [anon_sym_STAR] = ACTIONS(644),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_static] = ACTIONS(154),
    [anon_sym_register] = ACTIONS(154),
    [anon_sym_inline] = ACTIONS(154),
    [anon_sym_const] = ACTIONS(158),
    [anon_sym_restrict] = ACTIONS(158),
    [anon_sym_volatile] = ACTIONS(158),
    [anon_sym__Atomic] = ACTIONS(158),
    [anon_sym_mutable] = ACTIONS(158),
    [anon_sym_explicit] = ACTIONS(158),
    [anon_sym_constexpr] = ACTIONS(158),
    [anon_sym_unsigned] = ACTIONS(31),
    [anon_sym_long] = ACTIONS(31),
    [anon_sym_short] = ACTIONS(31),
    [sym_primitive_type] = ACTIONS(33),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_union] = ACTIONS(39),
    [anon_sym_if] = ACTIONS(646),
    [anon_sym_switch] = ACTIONS(648),
    [anon_sym_case] = ACTIONS(650),
    [anon_sym_default] = ACTIONS(652),
    [anon_sym_while] = ACTIONS(654),
    [anon_sym_do] = ACTIONS(656),
    [anon_sym_for] = ACTIONS(658),
    [anon_sym_return] = ACTIONS(660),
    [anon_sym_break] = ACTIONS(662),
    [anon_sym_continue] = ACTIONS(664),
    [anon_sym_goto] = ACTIONS(666),
    [anon_sym_AMP] = ACTIONS(644),
    [anon_sym_BANG] = ACTIONS(668),
    [anon_sym_TILDE] = ACTIONS(670),
    [anon_sym_PLUS] = ACTIONS(672),
    [anon_sym_DASH] = ACTIONS(672),
    [anon_sym_DASH_DASH] = ACTIONS(674),
    [anon_sym_PLUS_PLUS] = ACTIONS(674),
    [anon_sym_sizeof] = ACTIONS(676),
    [sym_number_literal] = ACTIONS(620),
    [sym_char_literal] = ACTIONS(620),
    [sym_string_literal] = ACTIONS(678),
    [sym_true] = ACTIONS(680),
    [sym_false] = ACTIONS(680),
    [sym_null] = ACTIONS(680),
    [sym_identifier] = ACTIONS(682),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(51),
    [sym_auto] = ACTIONS(33),
    [anon_sym_typename] = ACTIONS(53),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(684),
    [anon_sym_delete] = ACTIONS(686),
    [sym_nullptr] = ACTIONS(680),
  },
  [2726] = {
    [anon_sym_LPAREN] = ACTIONS(6792),
    [anon_sym_constexpr] = ACTIONS(6794),
    [sym_comment] = ACTIONS(49),
  },
  [2727] = {
    [anon_sym_LPAREN] = ACTIONS(6796),
    [sym_comment] = ACTIONS(49),
  },
  [2728] = {
    [sym__expression] = STATE(2862),
    [sym_conditional_expression] = STATE(2862),
    [sym_assignment_expression] = STATE(2862),
    [sym_pointer_expression] = STATE(2862),
    [sym_logical_expression] = STATE(2862),
    [sym_bitwise_expression] = STATE(2862),
    [sym_equality_expression] = STATE(2862),
    [sym_relational_expression] = STATE(2862),
    [sym_shift_expression] = STATE(2862),
    [sym_math_expression] = STATE(2862),
    [sym_cast_expression] = STATE(2862),
    [sym_sizeof_expression] = STATE(2862),
    [sym_subscript_expression] = STATE(2862),
    [sym_call_expression] = STATE(2862),
    [sym_field_expression] = STATE(2862),
    [sym_compound_literal_expression] = STATE(2862),
    [sym_parenthesized_expression] = STATE(2862),
    [sym_concatenated_string] = STATE(2862),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(2862),
    [sym_new_expression] = STATE(2862),
    [sym_delete_expression] = STATE(2862),
    [sym_lambda_expression] = STATE(2862),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(855),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(6798),
    [anon_sym_LPAREN] = ACTIONS(1634),
    [anon_sym_STAR] = ACTIONS(1636),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_AMP] = ACTIONS(1636),
    [anon_sym_BANG] = ACTIONS(1638),
    [anon_sym_TILDE] = ACTIONS(1640),
    [anon_sym_PLUS] = ACTIONS(1642),
    [anon_sym_DASH] = ACTIONS(1642),
    [anon_sym_DASH_DASH] = ACTIONS(1644),
    [anon_sym_PLUS_PLUS] = ACTIONS(1644),
    [anon_sym_sizeof] = ACTIONS(1646),
    [sym_number_literal] = ACTIONS(6798),
    [sym_char_literal] = ACTIONS(6798),
    [sym_string_literal] = ACTIONS(1648),
    [sym_true] = ACTIONS(6800),
    [sym_false] = ACTIONS(6800),
    [sym_null] = ACTIONS(6800),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1652),
    [anon_sym_delete] = ACTIONS(1654),
    [sym_nullptr] = ACTIONS(6800),
  },
  [2729] = {
    [anon_sym_COLON] = ACTIONS(6802),
    [sym_comment] = ACTIONS(49),
  },
  [2730] = {
    [anon_sym_LPAREN] = ACTIONS(6804),
    [sym_comment] = ACTIONS(49),
  },
  [2731] = {
    [sym_compound_statement] = STATE(2865),
    [sym_labeled_statement] = STATE(2865),
    [sym_expression_statement] = STATE(2865),
    [sym_if_statement] = STATE(2865),
    [sym_switch_statement] = STATE(2865),
    [sym_case_statement] = STATE(2865),
    [sym_while_statement] = STATE(2865),
    [sym_do_statement] = STATE(2865),
    [sym_for_statement] = STATE(2865),
    [sym_return_statement] = STATE(2865),
    [sym_break_statement] = STATE(2865),
    [sym_continue_statement] = STATE(2865),
    [sym_goto_statement] = STATE(2865),
    [sym__expression] = STATE(873),
    [sym_comma_expression] = STATE(874),
    [sym_conditional_expression] = STATE(873),
    [sym_assignment_expression] = STATE(873),
    [sym_pointer_expression] = STATE(873),
    [sym_logical_expression] = STATE(873),
    [sym_bitwise_expression] = STATE(873),
    [sym_equality_expression] = STATE(873),
    [sym_relational_expression] = STATE(873),
    [sym_shift_expression] = STATE(873),
    [sym_math_expression] = STATE(873),
    [sym_cast_expression] = STATE(873),
    [sym_sizeof_expression] = STATE(873),
    [sym_subscript_expression] = STATE(873),
    [sym_call_expression] = STATE(873),
    [sym_field_expression] = STATE(873),
    [sym_compound_literal_expression] = STATE(873),
    [sym_parenthesized_expression] = STATE(873),
    [sym_concatenated_string] = STATE(873),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(873),
    [sym_for_range_loop] = STATE(2865),
    [sym_new_expression] = STATE(873),
    [sym_delete_expression] = STATE(873),
    [sym_lambda_expression] = STATE(873),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(1660),
    [anon_sym_LPAREN] = ACTIONS(626),
    [anon_sym_SEMI] = ACTIONS(1662),
    [anon_sym_LBRACE] = ACTIONS(1664),
    [anon_sym_STAR] = ACTIONS(644),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_if] = ACTIONS(1666),
    [anon_sym_switch] = ACTIONS(1668),
    [anon_sym_case] = ACTIONS(1670),
    [anon_sym_default] = ACTIONS(1672),
    [anon_sym_while] = ACTIONS(1674),
    [anon_sym_do] = ACTIONS(1676),
    [anon_sym_for] = ACTIONS(1678),
    [anon_sym_return] = ACTIONS(1680),
    [anon_sym_break] = ACTIONS(1682),
    [anon_sym_continue] = ACTIONS(1684),
    [anon_sym_goto] = ACTIONS(1686),
    [anon_sym_AMP] = ACTIONS(644),
    [anon_sym_BANG] = ACTIONS(668),
    [anon_sym_TILDE] = ACTIONS(670),
    [anon_sym_PLUS] = ACTIONS(672),
    [anon_sym_DASH] = ACTIONS(672),
    [anon_sym_DASH_DASH] = ACTIONS(674),
    [anon_sym_PLUS_PLUS] = ACTIONS(674),
    [anon_sym_sizeof] = ACTIONS(676),
    [sym_number_literal] = ACTIONS(1660),
    [sym_char_literal] = ACTIONS(1660),
    [sym_string_literal] = ACTIONS(678),
    [sym_true] = ACTIONS(1688),
    [sym_false] = ACTIONS(1688),
    [sym_null] = ACTIONS(1688),
    [sym_identifier] = ACTIONS(1690),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1303),
    [anon_sym_delete] = ACTIONS(686),
    [sym_nullptr] = ACTIONS(1688),
  },
  [2732] = {
    [anon_sym_LPAREN] = ACTIONS(6806),
    [sym_comment] = ACTIONS(49),
  },
  [2733] = {
    [sym__expression] = STATE(2868),
    [sym_conditional_expression] = STATE(2868),
    [sym_assignment_expression] = STATE(2868),
    [sym_pointer_expression] = STATE(2868),
    [sym_logical_expression] = STATE(2868),
    [sym_bitwise_expression] = STATE(2868),
    [sym_equality_expression] = STATE(2868),
    [sym_relational_expression] = STATE(2868),
    [sym_shift_expression] = STATE(2868),
    [sym_math_expression] = STATE(2868),
    [sym_cast_expression] = STATE(2868),
    [sym_sizeof_expression] = STATE(2868),
    [sym_subscript_expression] = STATE(2868),
    [sym_call_expression] = STATE(2868),
    [sym_field_expression] = STATE(2868),
    [sym_compound_literal_expression] = STATE(2868),
    [sym_parenthesized_expression] = STATE(2868),
    [sym_initializer_list] = STATE(2869),
    [sym_concatenated_string] = STATE(2868),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(2868),
    [sym_new_expression] = STATE(2868),
    [sym_delete_expression] = STATE(2868),
    [sym_lambda_expression] = STATE(2868),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(6808),
    [anon_sym_LPAREN] = ACTIONS(1347),
    [anon_sym_SEMI] = ACTIONS(6810),
    [anon_sym_LBRACE] = ACTIONS(548),
    [anon_sym_STAR] = ACTIONS(1349),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_AMP] = ACTIONS(1349),
    [anon_sym_BANG] = ACTIONS(1351),
    [anon_sym_TILDE] = ACTIONS(1353),
    [anon_sym_PLUS] = ACTIONS(1355),
    [anon_sym_DASH] = ACTIONS(1355),
    [anon_sym_DASH_DASH] = ACTIONS(1357),
    [anon_sym_PLUS_PLUS] = ACTIONS(1357),
    [anon_sym_sizeof] = ACTIONS(1359),
    [sym_number_literal] = ACTIONS(6808),
    [sym_char_literal] = ACTIONS(6808),
    [sym_string_literal] = ACTIONS(1361),
    [sym_true] = ACTIONS(6812),
    [sym_false] = ACTIONS(6812),
    [sym_null] = ACTIONS(6812),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1365),
    [anon_sym_delete] = ACTIONS(1367),
    [sym_nullptr] = ACTIONS(6812),
  },
  [2734] = {
    [anon_sym_SEMI] = ACTIONS(6814),
    [sym_comment] = ACTIONS(49),
  },
  [2735] = {
    [anon_sym_SEMI] = ACTIONS(6816),
    [sym_comment] = ACTIONS(49),
  },
  [2736] = {
    [sym_identifier] = ACTIONS(6818),
    [sym_comment] = ACTIONS(49),
  },
  [2737] = {
    [sym_initializer_list] = STATE(765),
    [sym_template_argument_list] = STATE(1097),
    [anon_sym_LPAREN] = ACTIONS(1477),
    [anon_sym_COMMA] = ACTIONS(1477),
    [anon_sym_SEMI] = ACTIONS(1477),
    [anon_sym_LBRACE] = ACTIONS(548),
    [anon_sym_STAR] = ACTIONS(1479),
    [anon_sym_LBRACK] = ACTIONS(1477),
    [anon_sym_EQ] = ACTIONS(1479),
    [anon_sym_COLON] = ACTIONS(6820),
    [anon_sym_QMARK] = ACTIONS(1477),
    [anon_sym_STAR_EQ] = ACTIONS(1477),
    [anon_sym_SLASH_EQ] = ACTIONS(1477),
    [anon_sym_PERCENT_EQ] = ACTIONS(1477),
    [anon_sym_PLUS_EQ] = ACTIONS(1477),
    [anon_sym_DASH_EQ] = ACTIONS(1477),
    [anon_sym_LT_LT_EQ] = ACTIONS(1477),
    [anon_sym_GT_GT_EQ] = ACTIONS(1477),
    [anon_sym_AMP_EQ] = ACTIONS(1477),
    [anon_sym_CARET_EQ] = ACTIONS(1477),
    [anon_sym_PIPE_EQ] = ACTIONS(1477),
    [anon_sym_AMP] = ACTIONS(1479),
    [anon_sym_PIPE_PIPE] = ACTIONS(1477),
    [anon_sym_AMP_AMP] = ACTIONS(1477),
    [anon_sym_PIPE] = ACTIONS(1479),
    [anon_sym_CARET] = ACTIONS(1479),
    [anon_sym_EQ_EQ] = ACTIONS(1477),
    [anon_sym_BANG_EQ] = ACTIONS(1477),
    [anon_sym_LT] = ACTIONS(1564),
    [anon_sym_GT] = ACTIONS(1479),
    [anon_sym_LT_EQ] = ACTIONS(1477),
    [anon_sym_GT_EQ] = ACTIONS(1477),
    [anon_sym_LT_LT] = ACTIONS(1479),
    [anon_sym_GT_GT] = ACTIONS(1479),
    [anon_sym_PLUS] = ACTIONS(1479),
    [anon_sym_DASH] = ACTIONS(1479),
    [anon_sym_SLASH] = ACTIONS(1479),
    [anon_sym_PERCENT] = ACTIONS(1479),
    [anon_sym_DASH_DASH] = ACTIONS(1477),
    [anon_sym_PLUS_PLUS] = ACTIONS(1477),
    [anon_sym_DOT] = ACTIONS(1477),
    [anon_sym_DASH_GT] = ACTIONS(1477),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(2218),
  },
  [2738] = {
    [sym_raw_string_literal] = ACTIONS(6267),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(6269),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(6269),
    [anon_sym_LPAREN] = ACTIONS(6267),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(6269),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(6269),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(6269),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(6269),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(6269),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(6269),
    [sym_preproc_directive] = ACTIONS(6269),
    [anon_sym_SEMI] = ACTIONS(6267),
    [anon_sym_typedef] = ACTIONS(6269),
    [anon_sym_extern] = ACTIONS(6269),
    [anon_sym_LBRACE] = ACTIONS(6267),
    [anon_sym_STAR] = ACTIONS(6267),
    [anon_sym_LBRACK] = ACTIONS(6267),
    [anon_sym_static] = ACTIONS(6269),
    [anon_sym_register] = ACTIONS(6269),
    [anon_sym_inline] = ACTIONS(6269),
    [anon_sym_const] = ACTIONS(6269),
    [anon_sym_restrict] = ACTIONS(6269),
    [anon_sym_volatile] = ACTIONS(6269),
    [anon_sym__Atomic] = ACTIONS(6269),
    [anon_sym_mutable] = ACTIONS(6269),
    [anon_sym_explicit] = ACTIONS(6269),
    [anon_sym_constexpr] = ACTIONS(6269),
    [anon_sym_unsigned] = ACTIONS(6269),
    [anon_sym_long] = ACTIONS(6269),
    [anon_sym_short] = ACTIONS(6269),
    [sym_primitive_type] = ACTIONS(6269),
    [anon_sym_enum] = ACTIONS(6269),
    [anon_sym_struct] = ACTIONS(6269),
    [anon_sym_union] = ACTIONS(6269),
    [anon_sym_if] = ACTIONS(6269),
    [anon_sym_else] = ACTIONS(6822),
    [anon_sym_switch] = ACTIONS(6269),
    [anon_sym_case] = ACTIONS(6269),
    [anon_sym_default] = ACTIONS(6269),
    [anon_sym_while] = ACTIONS(6269),
    [anon_sym_do] = ACTIONS(6269),
    [anon_sym_for] = ACTIONS(6269),
    [anon_sym_return] = ACTIONS(6269),
    [anon_sym_break] = ACTIONS(6269),
    [anon_sym_continue] = ACTIONS(6269),
    [anon_sym_goto] = ACTIONS(6269),
    [anon_sym_AMP] = ACTIONS(6267),
    [anon_sym_BANG] = ACTIONS(6267),
    [anon_sym_TILDE] = ACTIONS(6267),
    [anon_sym_PLUS] = ACTIONS(6269),
    [anon_sym_DASH] = ACTIONS(6269),
    [anon_sym_DASH_DASH] = ACTIONS(6267),
    [anon_sym_PLUS_PLUS] = ACTIONS(6267),
    [anon_sym_sizeof] = ACTIONS(6269),
    [sym_number_literal] = ACTIONS(6267),
    [sym_char_literal] = ACTIONS(6267),
    [sym_string_literal] = ACTIONS(6267),
    [sym_true] = ACTIONS(6269),
    [sym_false] = ACTIONS(6269),
    [sym_null] = ACTIONS(6269),
    [sym_identifier] = ACTIONS(6269),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(6269),
    [sym_auto] = ACTIONS(6269),
    [anon_sym_typename] = ACTIONS(6269),
    [anon_sym_new] = ACTIONS(6269),
    [anon_sym_COLON_COLON] = ACTIONS(6267),
    [anon_sym_delete] = ACTIONS(6269),
    [sym_nullptr] = ACTIONS(6269),
  },
  [2739] = {
    [sym_argument_list] = STATE(802),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_COMMA] = ACTIONS(1740),
    [anon_sym_SEMI] = ACTIONS(6824),
    [anon_sym_STAR] = ACTIONS(1744),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_EQ] = ACTIONS(1746),
    [anon_sym_QMARK] = ACTIONS(1748),
    [anon_sym_STAR_EQ] = ACTIONS(1750),
    [anon_sym_SLASH_EQ] = ACTIONS(1750),
    [anon_sym_PERCENT_EQ] = ACTIONS(1750),
    [anon_sym_PLUS_EQ] = ACTIONS(1750),
    [anon_sym_DASH_EQ] = ACTIONS(1750),
    [anon_sym_LT_LT_EQ] = ACTIONS(1750),
    [anon_sym_GT_GT_EQ] = ACTIONS(1750),
    [anon_sym_AMP_EQ] = ACTIONS(1750),
    [anon_sym_CARET_EQ] = ACTIONS(1750),
    [anon_sym_PIPE_EQ] = ACTIONS(1750),
    [anon_sym_AMP] = ACTIONS(1752),
    [anon_sym_PIPE_PIPE] = ACTIONS(1754),
    [anon_sym_AMP_AMP] = ACTIONS(1756),
    [anon_sym_PIPE] = ACTIONS(1758),
    [anon_sym_CARET] = ACTIONS(1760),
    [anon_sym_EQ_EQ] = ACTIONS(1762),
    [anon_sym_BANG_EQ] = ACTIONS(1762),
    [anon_sym_LT] = ACTIONS(1764),
    [anon_sym_GT] = ACTIONS(1764),
    [anon_sym_LT_EQ] = ACTIONS(1766),
    [anon_sym_GT_EQ] = ACTIONS(1766),
    [anon_sym_LT_LT] = ACTIONS(1768),
    [anon_sym_GT_GT] = ACTIONS(1768),
    [anon_sym_PLUS] = ACTIONS(1770),
    [anon_sym_DASH] = ACTIONS(1770),
    [anon_sym_SLASH] = ACTIONS(1744),
    [anon_sym_PERCENT] = ACTIONS(1744),
    [anon_sym_DASH_DASH] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(1554),
    [anon_sym_DASH_GT] = ACTIONS(1554),
    [sym_comment] = ACTIONS(49),
  },
  [2740] = {
    [anon_sym_SEMI] = ACTIONS(6824),
    [sym_comment] = ACTIONS(49),
  },
  [2741] = {
    [sym_compound_statement] = STATE(2876),
    [sym_labeled_statement] = STATE(2876),
    [sym_expression_statement] = STATE(2876),
    [sym_if_statement] = STATE(2876),
    [sym_switch_statement] = STATE(2876),
    [sym_case_statement] = STATE(2876),
    [sym_while_statement] = STATE(2876),
    [sym_do_statement] = STATE(2876),
    [sym_for_statement] = STATE(2876),
    [sym_return_statement] = STATE(2876),
    [sym_break_statement] = STATE(2876),
    [sym_continue_statement] = STATE(2876),
    [sym_goto_statement] = STATE(2876),
    [sym__expression] = STATE(2739),
    [sym_comma_expression] = STATE(2740),
    [sym_conditional_expression] = STATE(2739),
    [sym_assignment_expression] = STATE(2739),
    [sym_pointer_expression] = STATE(2739),
    [sym_logical_expression] = STATE(2739),
    [sym_bitwise_expression] = STATE(2739),
    [sym_equality_expression] = STATE(2739),
    [sym_relational_expression] = STATE(2739),
    [sym_shift_expression] = STATE(2739),
    [sym_math_expression] = STATE(2739),
    [sym_cast_expression] = STATE(2739),
    [sym_sizeof_expression] = STATE(2739),
    [sym_subscript_expression] = STATE(2739),
    [sym_call_expression] = STATE(2739),
    [sym_field_expression] = STATE(2739),
    [sym_compound_literal_expression] = STATE(2739),
    [sym_parenthesized_expression] = STATE(2739),
    [sym_concatenated_string] = STATE(2739),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(2739),
    [sym_for_range_loop] = STATE(2876),
    [sym_new_expression] = STATE(2739),
    [sym_delete_expression] = STATE(2739),
    [sym_lambda_expression] = STATE(2739),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(6507),
    [anon_sym_LPAREN] = ACTIONS(626),
    [anon_sym_SEMI] = ACTIONS(6509),
    [anon_sym_LBRACE] = ACTIONS(6511),
    [anon_sym_STAR] = ACTIONS(644),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_if] = ACTIONS(6513),
    [anon_sym_switch] = ACTIONS(6515),
    [anon_sym_case] = ACTIONS(6517),
    [anon_sym_default] = ACTIONS(6519),
    [anon_sym_while] = ACTIONS(6521),
    [anon_sym_do] = ACTIONS(6523),
    [anon_sym_for] = ACTIONS(6525),
    [anon_sym_return] = ACTIONS(6527),
    [anon_sym_break] = ACTIONS(6529),
    [anon_sym_continue] = ACTIONS(6531),
    [anon_sym_goto] = ACTIONS(6533),
    [anon_sym_AMP] = ACTIONS(644),
    [anon_sym_BANG] = ACTIONS(668),
    [anon_sym_TILDE] = ACTIONS(670),
    [anon_sym_PLUS] = ACTIONS(672),
    [anon_sym_DASH] = ACTIONS(672),
    [anon_sym_DASH_DASH] = ACTIONS(674),
    [anon_sym_PLUS_PLUS] = ACTIONS(674),
    [anon_sym_sizeof] = ACTIONS(676),
    [sym_number_literal] = ACTIONS(6507),
    [sym_char_literal] = ACTIONS(6507),
    [sym_string_literal] = ACTIONS(678),
    [sym_true] = ACTIONS(6535),
    [sym_false] = ACTIONS(6535),
    [sym_null] = ACTIONS(6535),
    [sym_identifier] = ACTIONS(6537),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1303),
    [anon_sym_delete] = ACTIONS(686),
    [sym_nullptr] = ACTIONS(6535),
  },
  [2742] = {
    [sym_raw_string_literal] = ACTIONS(6277),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(6279),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(6279),
    [anon_sym_LPAREN] = ACTIONS(6277),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(6279),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(6279),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(6279),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(6279),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(6279),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(6279),
    [sym_preproc_directive] = ACTIONS(6279),
    [anon_sym_SEMI] = ACTIONS(6277),
    [anon_sym_typedef] = ACTIONS(6279),
    [anon_sym_extern] = ACTIONS(6279),
    [anon_sym_LBRACE] = ACTIONS(6277),
    [anon_sym_STAR] = ACTIONS(6277),
    [anon_sym_LBRACK] = ACTIONS(6277),
    [anon_sym_static] = ACTIONS(6279),
    [anon_sym_register] = ACTIONS(6279),
    [anon_sym_inline] = ACTIONS(6279),
    [anon_sym_const] = ACTIONS(6279),
    [anon_sym_restrict] = ACTIONS(6279),
    [anon_sym_volatile] = ACTIONS(6279),
    [anon_sym__Atomic] = ACTIONS(6279),
    [anon_sym_mutable] = ACTIONS(6279),
    [anon_sym_explicit] = ACTIONS(6279),
    [anon_sym_constexpr] = ACTIONS(6279),
    [anon_sym_unsigned] = ACTIONS(6279),
    [anon_sym_long] = ACTIONS(6279),
    [anon_sym_short] = ACTIONS(6279),
    [sym_primitive_type] = ACTIONS(6279),
    [anon_sym_enum] = ACTIONS(6279),
    [anon_sym_struct] = ACTIONS(6279),
    [anon_sym_union] = ACTIONS(6279),
    [anon_sym_if] = ACTIONS(6279),
    [anon_sym_switch] = ACTIONS(6279),
    [anon_sym_case] = ACTIONS(6279),
    [anon_sym_default] = ACTIONS(6279),
    [anon_sym_while] = ACTIONS(6279),
    [anon_sym_do] = ACTIONS(6279),
    [anon_sym_for] = ACTIONS(6279),
    [anon_sym_return] = ACTIONS(6279),
    [anon_sym_break] = ACTIONS(6279),
    [anon_sym_continue] = ACTIONS(6279),
    [anon_sym_goto] = ACTIONS(6279),
    [anon_sym_AMP] = ACTIONS(6277),
    [anon_sym_BANG] = ACTIONS(6277),
    [anon_sym_TILDE] = ACTIONS(6277),
    [anon_sym_PLUS] = ACTIONS(6279),
    [anon_sym_DASH] = ACTIONS(6279),
    [anon_sym_DASH_DASH] = ACTIONS(6277),
    [anon_sym_PLUS_PLUS] = ACTIONS(6277),
    [anon_sym_sizeof] = ACTIONS(6279),
    [sym_number_literal] = ACTIONS(6277),
    [sym_char_literal] = ACTIONS(6277),
    [sym_string_literal] = ACTIONS(6277),
    [sym_true] = ACTIONS(6279),
    [sym_false] = ACTIONS(6279),
    [sym_null] = ACTIONS(6279),
    [sym_identifier] = ACTIONS(6279),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(6279),
    [sym_auto] = ACTIONS(6279),
    [anon_sym_typename] = ACTIONS(6279),
    [anon_sym_new] = ACTIONS(6279),
    [anon_sym_COLON_COLON] = ACTIONS(6277),
    [anon_sym_delete] = ACTIONS(6279),
    [sym_nullptr] = ACTIONS(6279),
  },
  [2743] = {
    [sym_raw_string_literal] = ACTIONS(6293),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(6295),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(6295),
    [anon_sym_LPAREN] = ACTIONS(6293),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(6295),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(6295),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(6295),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(6295),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(6295),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(6295),
    [sym_preproc_directive] = ACTIONS(6295),
    [anon_sym_SEMI] = ACTIONS(6293),
    [anon_sym_typedef] = ACTIONS(6295),
    [anon_sym_extern] = ACTIONS(6295),
    [anon_sym_LBRACE] = ACTIONS(6293),
    [anon_sym_STAR] = ACTIONS(6293),
    [anon_sym_LBRACK] = ACTIONS(6293),
    [anon_sym_static] = ACTIONS(6295),
    [anon_sym_register] = ACTIONS(6295),
    [anon_sym_inline] = ACTIONS(6295),
    [anon_sym_const] = ACTIONS(6295),
    [anon_sym_restrict] = ACTIONS(6295),
    [anon_sym_volatile] = ACTIONS(6295),
    [anon_sym__Atomic] = ACTIONS(6295),
    [anon_sym_mutable] = ACTIONS(6295),
    [anon_sym_explicit] = ACTIONS(6295),
    [anon_sym_constexpr] = ACTIONS(6295),
    [anon_sym_unsigned] = ACTIONS(6295),
    [anon_sym_long] = ACTIONS(6295),
    [anon_sym_short] = ACTIONS(6295),
    [sym_primitive_type] = ACTIONS(6295),
    [anon_sym_enum] = ACTIONS(6295),
    [anon_sym_struct] = ACTIONS(6295),
    [anon_sym_union] = ACTIONS(6295),
    [anon_sym_if] = ACTIONS(6295),
    [anon_sym_switch] = ACTIONS(6295),
    [anon_sym_case] = ACTIONS(6295),
    [anon_sym_default] = ACTIONS(6295),
    [anon_sym_while] = ACTIONS(6295),
    [anon_sym_do] = ACTIONS(6295),
    [anon_sym_for] = ACTIONS(6295),
    [anon_sym_return] = ACTIONS(6295),
    [anon_sym_break] = ACTIONS(6295),
    [anon_sym_continue] = ACTIONS(6295),
    [anon_sym_goto] = ACTIONS(6295),
    [anon_sym_AMP] = ACTIONS(6293),
    [anon_sym_BANG] = ACTIONS(6293),
    [anon_sym_TILDE] = ACTIONS(6293),
    [anon_sym_PLUS] = ACTIONS(6295),
    [anon_sym_DASH] = ACTIONS(6295),
    [anon_sym_DASH_DASH] = ACTIONS(6293),
    [anon_sym_PLUS_PLUS] = ACTIONS(6293),
    [anon_sym_sizeof] = ACTIONS(6295),
    [sym_number_literal] = ACTIONS(6293),
    [sym_char_literal] = ACTIONS(6293),
    [sym_string_literal] = ACTIONS(6293),
    [sym_true] = ACTIONS(6295),
    [sym_false] = ACTIONS(6295),
    [sym_null] = ACTIONS(6295),
    [sym_identifier] = ACTIONS(6295),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(6295),
    [sym_auto] = ACTIONS(6295),
    [anon_sym_typename] = ACTIONS(6295),
    [anon_sym_new] = ACTIONS(6295),
    [anon_sym_COLON_COLON] = ACTIONS(6293),
    [anon_sym_delete] = ACTIONS(6295),
    [sym_nullptr] = ACTIONS(6295),
  },
  [2744] = {
    [sym_argument_list] = STATE(802),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_RPAREN] = ACTIONS(6826),
    [anon_sym_STAR] = ACTIONS(4537),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_EQ] = ACTIONS(4539),
    [anon_sym_QMARK] = ACTIONS(4541),
    [anon_sym_STAR_EQ] = ACTIONS(4543),
    [anon_sym_SLASH_EQ] = ACTIONS(4543),
    [anon_sym_PERCENT_EQ] = ACTIONS(4543),
    [anon_sym_PLUS_EQ] = ACTIONS(4543),
    [anon_sym_DASH_EQ] = ACTIONS(4543),
    [anon_sym_LT_LT_EQ] = ACTIONS(4543),
    [anon_sym_GT_GT_EQ] = ACTIONS(4543),
    [anon_sym_AMP_EQ] = ACTIONS(4543),
    [anon_sym_CARET_EQ] = ACTIONS(4543),
    [anon_sym_PIPE_EQ] = ACTIONS(4543),
    [anon_sym_AMP] = ACTIONS(4545),
    [anon_sym_PIPE_PIPE] = ACTIONS(4547),
    [anon_sym_AMP_AMP] = ACTIONS(4549),
    [anon_sym_PIPE] = ACTIONS(4551),
    [anon_sym_CARET] = ACTIONS(4553),
    [anon_sym_EQ_EQ] = ACTIONS(4555),
    [anon_sym_BANG_EQ] = ACTIONS(4555),
    [anon_sym_LT] = ACTIONS(4557),
    [anon_sym_GT] = ACTIONS(4557),
    [anon_sym_LT_EQ] = ACTIONS(4559),
    [anon_sym_GT_EQ] = ACTIONS(4559),
    [anon_sym_LT_LT] = ACTIONS(4561),
    [anon_sym_GT_GT] = ACTIONS(4561),
    [anon_sym_PLUS] = ACTIONS(4563),
    [anon_sym_DASH] = ACTIONS(4563),
    [anon_sym_SLASH] = ACTIONS(4537),
    [anon_sym_PERCENT] = ACTIONS(4537),
    [anon_sym_DASH_DASH] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(1554),
    [anon_sym_DASH_GT] = ACTIONS(1554),
    [sym_comment] = ACTIONS(49),
  },
  [2745] = {
    [sym_compound_statement] = STATE(2878),
    [sym_labeled_statement] = STATE(2878),
    [sym_expression_statement] = STATE(2878),
    [sym_if_statement] = STATE(2878),
    [sym_switch_statement] = STATE(2878),
    [sym_case_statement] = STATE(2878),
    [sym_while_statement] = STATE(2878),
    [sym_do_statement] = STATE(2878),
    [sym_for_statement] = STATE(2878),
    [sym_return_statement] = STATE(2878),
    [sym_break_statement] = STATE(2878),
    [sym_continue_statement] = STATE(2878),
    [sym_goto_statement] = STATE(2878),
    [sym__expression] = STATE(1419),
    [sym_comma_expression] = STATE(1420),
    [sym_conditional_expression] = STATE(1419),
    [sym_assignment_expression] = STATE(1419),
    [sym_pointer_expression] = STATE(1419),
    [sym_logical_expression] = STATE(1419),
    [sym_bitwise_expression] = STATE(1419),
    [sym_equality_expression] = STATE(1419),
    [sym_relational_expression] = STATE(1419),
    [sym_shift_expression] = STATE(1419),
    [sym_math_expression] = STATE(1419),
    [sym_cast_expression] = STATE(1419),
    [sym_sizeof_expression] = STATE(1419),
    [sym_subscript_expression] = STATE(1419),
    [sym_call_expression] = STATE(1419),
    [sym_field_expression] = STATE(1419),
    [sym_compound_literal_expression] = STATE(1419),
    [sym_parenthesized_expression] = STATE(1419),
    [sym_concatenated_string] = STATE(1419),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(1419),
    [sym_for_range_loop] = STATE(2878),
    [sym_new_expression] = STATE(1419),
    [sym_delete_expression] = STATE(1419),
    [sym_lambda_expression] = STATE(1419),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(2879),
    [anon_sym_LPAREN] = ACTIONS(626),
    [anon_sym_SEMI] = ACTIONS(2899),
    [anon_sym_LBRACE] = ACTIONS(2903),
    [anon_sym_STAR] = ACTIONS(644),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_if] = ACTIONS(2905),
    [anon_sym_switch] = ACTIONS(2907),
    [anon_sym_case] = ACTIONS(2909),
    [anon_sym_default] = ACTIONS(2911),
    [anon_sym_while] = ACTIONS(2913),
    [anon_sym_do] = ACTIONS(2915),
    [anon_sym_for] = ACTIONS(2917),
    [anon_sym_return] = ACTIONS(2919),
    [anon_sym_break] = ACTIONS(2921),
    [anon_sym_continue] = ACTIONS(2923),
    [anon_sym_goto] = ACTIONS(2925),
    [anon_sym_AMP] = ACTIONS(644),
    [anon_sym_BANG] = ACTIONS(668),
    [anon_sym_TILDE] = ACTIONS(670),
    [anon_sym_PLUS] = ACTIONS(672),
    [anon_sym_DASH] = ACTIONS(672),
    [anon_sym_DASH_DASH] = ACTIONS(674),
    [anon_sym_PLUS_PLUS] = ACTIONS(674),
    [anon_sym_sizeof] = ACTIONS(676),
    [sym_number_literal] = ACTIONS(2879),
    [sym_char_literal] = ACTIONS(2879),
    [sym_string_literal] = ACTIONS(678),
    [sym_true] = ACTIONS(2927),
    [sym_false] = ACTIONS(2927),
    [sym_null] = ACTIONS(2927),
    [sym_identifier] = ACTIONS(5397),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1303),
    [anon_sym_delete] = ACTIONS(686),
    [sym_nullptr] = ACTIONS(2927),
  },
  [2746] = {
    [sym_argument_list] = STATE(802),
    [aux_sym_for_statement_repeat1] = STATE(2880),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_COMMA] = ACTIONS(6339),
    [anon_sym_RPAREN] = ACTIONS(6828),
    [anon_sym_STAR] = ACTIONS(2234),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_EQ] = ACTIONS(2236),
    [anon_sym_QMARK] = ACTIONS(2238),
    [anon_sym_STAR_EQ] = ACTIONS(2240),
    [anon_sym_SLASH_EQ] = ACTIONS(2240),
    [anon_sym_PERCENT_EQ] = ACTIONS(2240),
    [anon_sym_PLUS_EQ] = ACTIONS(2240),
    [anon_sym_DASH_EQ] = ACTIONS(2240),
    [anon_sym_LT_LT_EQ] = ACTIONS(2240),
    [anon_sym_GT_GT_EQ] = ACTIONS(2240),
    [anon_sym_AMP_EQ] = ACTIONS(2240),
    [anon_sym_CARET_EQ] = ACTIONS(2240),
    [anon_sym_PIPE_EQ] = ACTIONS(2240),
    [anon_sym_AMP] = ACTIONS(2242),
    [anon_sym_PIPE_PIPE] = ACTIONS(2244),
    [anon_sym_AMP_AMP] = ACTIONS(2246),
    [anon_sym_PIPE] = ACTIONS(2248),
    [anon_sym_CARET] = ACTIONS(2250),
    [anon_sym_EQ_EQ] = ACTIONS(2252),
    [anon_sym_BANG_EQ] = ACTIONS(2252),
    [anon_sym_LT] = ACTIONS(2254),
    [anon_sym_GT] = ACTIONS(2254),
    [anon_sym_LT_EQ] = ACTIONS(2256),
    [anon_sym_GT_EQ] = ACTIONS(2256),
    [anon_sym_LT_LT] = ACTIONS(2258),
    [anon_sym_GT_GT] = ACTIONS(2258),
    [anon_sym_PLUS] = ACTIONS(2260),
    [anon_sym_DASH] = ACTIONS(2260),
    [anon_sym_SLASH] = ACTIONS(2234),
    [anon_sym_PERCENT] = ACTIONS(2234),
    [anon_sym_DASH_DASH] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(1554),
    [anon_sym_DASH_GT] = ACTIONS(1554),
    [sym_comment] = ACTIONS(49),
  },
  [2747] = {
    [sym__expression] = STATE(2881),
    [sym_conditional_expression] = STATE(2881),
    [sym_assignment_expression] = STATE(2881),
    [sym_pointer_expression] = STATE(2881),
    [sym_logical_expression] = STATE(2881),
    [sym_bitwise_expression] = STATE(2881),
    [sym_equality_expression] = STATE(2881),
    [sym_relational_expression] = STATE(2881),
    [sym_shift_expression] = STATE(2881),
    [sym_math_expression] = STATE(2881),
    [sym_cast_expression] = STATE(2881),
    [sym_sizeof_expression] = STATE(2881),
    [sym_subscript_expression] = STATE(2881),
    [sym_call_expression] = STATE(2881),
    [sym_field_expression] = STATE(2881),
    [sym_compound_literal_expression] = STATE(2881),
    [sym_parenthesized_expression] = STATE(2881),
    [sym_concatenated_string] = STATE(2881),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(2881),
    [sym_new_expression] = STATE(2881),
    [sym_delete_expression] = STATE(2881),
    [sym_lambda_expression] = STATE(2881),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(6830),
    [anon_sym_LPAREN] = ACTIONS(1087),
    [anon_sym_RPAREN] = ACTIONS(6828),
    [anon_sym_STAR] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_AMP] = ACTIONS(1089),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1093),
    [anon_sym_PLUS] = ACTIONS(1095),
    [anon_sym_DASH] = ACTIONS(1095),
    [anon_sym_DASH_DASH] = ACTIONS(1097),
    [anon_sym_PLUS_PLUS] = ACTIONS(1097),
    [anon_sym_sizeof] = ACTIONS(1099),
    [sym_number_literal] = ACTIONS(6830),
    [sym_char_literal] = ACTIONS(6830),
    [sym_string_literal] = ACTIONS(1101),
    [sym_true] = ACTIONS(6832),
    [sym_false] = ACTIONS(6832),
    [sym_null] = ACTIONS(6832),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_delete] = ACTIONS(1109),
    [sym_nullptr] = ACTIONS(6832),
  },
  [2748] = {
    [sym_argument_list] = STATE(802),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_SEMI] = ACTIONS(6834),
    [anon_sym_STAR] = ACTIONS(2553),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_EQ] = ACTIONS(2555),
    [anon_sym_QMARK] = ACTIONS(2557),
    [anon_sym_STAR_EQ] = ACTIONS(2559),
    [anon_sym_SLASH_EQ] = ACTIONS(2559),
    [anon_sym_PERCENT_EQ] = ACTIONS(2559),
    [anon_sym_PLUS_EQ] = ACTIONS(2559),
    [anon_sym_DASH_EQ] = ACTIONS(2559),
    [anon_sym_LT_LT_EQ] = ACTIONS(2559),
    [anon_sym_GT_GT_EQ] = ACTIONS(2559),
    [anon_sym_AMP_EQ] = ACTIONS(2559),
    [anon_sym_CARET_EQ] = ACTIONS(2559),
    [anon_sym_PIPE_EQ] = ACTIONS(2559),
    [anon_sym_AMP] = ACTIONS(2561),
    [anon_sym_PIPE_PIPE] = ACTIONS(2563),
    [anon_sym_AMP_AMP] = ACTIONS(2565),
    [anon_sym_PIPE] = ACTIONS(2567),
    [anon_sym_CARET] = ACTIONS(2569),
    [anon_sym_EQ_EQ] = ACTIONS(2571),
    [anon_sym_BANG_EQ] = ACTIONS(2571),
    [anon_sym_LT] = ACTIONS(2573),
    [anon_sym_GT] = ACTIONS(2573),
    [anon_sym_LT_EQ] = ACTIONS(2575),
    [anon_sym_GT_EQ] = ACTIONS(2575),
    [anon_sym_LT_LT] = ACTIONS(2577),
    [anon_sym_GT_GT] = ACTIONS(2577),
    [anon_sym_PLUS] = ACTIONS(2579),
    [anon_sym_DASH] = ACTIONS(2579),
    [anon_sym_SLASH] = ACTIONS(2553),
    [anon_sym_PERCENT] = ACTIONS(2553),
    [anon_sym_DASH_DASH] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(1554),
    [anon_sym_DASH_GT] = ACTIONS(1554),
    [sym_comment] = ACTIONS(49),
  },
  [2749] = {
    [sym_argument_list] = STATE(802),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_RPAREN] = ACTIONS(6836),
    [anon_sym_STAR] = ACTIONS(4537),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_EQ] = ACTIONS(4539),
    [anon_sym_QMARK] = ACTIONS(4541),
    [anon_sym_STAR_EQ] = ACTIONS(4543),
    [anon_sym_SLASH_EQ] = ACTIONS(4543),
    [anon_sym_PERCENT_EQ] = ACTIONS(4543),
    [anon_sym_PLUS_EQ] = ACTIONS(4543),
    [anon_sym_DASH_EQ] = ACTIONS(4543),
    [anon_sym_LT_LT_EQ] = ACTIONS(4543),
    [anon_sym_GT_GT_EQ] = ACTIONS(4543),
    [anon_sym_AMP_EQ] = ACTIONS(4543),
    [anon_sym_CARET_EQ] = ACTIONS(4543),
    [anon_sym_PIPE_EQ] = ACTIONS(4543),
    [anon_sym_AMP] = ACTIONS(4545),
    [anon_sym_PIPE_PIPE] = ACTIONS(4547),
    [anon_sym_AMP_AMP] = ACTIONS(4549),
    [anon_sym_PIPE] = ACTIONS(4551),
    [anon_sym_CARET] = ACTIONS(4553),
    [anon_sym_EQ_EQ] = ACTIONS(4555),
    [anon_sym_BANG_EQ] = ACTIONS(4555),
    [anon_sym_LT] = ACTIONS(4557),
    [anon_sym_GT] = ACTIONS(4557),
    [anon_sym_LT_EQ] = ACTIONS(4559),
    [anon_sym_GT_EQ] = ACTIONS(4559),
    [anon_sym_LT_LT] = ACTIONS(4561),
    [anon_sym_GT_GT] = ACTIONS(4561),
    [anon_sym_PLUS] = ACTIONS(4563),
    [anon_sym_DASH] = ACTIONS(4563),
    [anon_sym_SLASH] = ACTIONS(4537),
    [anon_sym_PERCENT] = ACTIONS(4537),
    [anon_sym_DASH_DASH] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(1554),
    [anon_sym_DASH_GT] = ACTIONS(1554),
    [sym_comment] = ACTIONS(49),
  },
  [2750] = {
    [sym_raw_string_literal] = ACTIONS(4064),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(4066),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(4066),
    [anon_sym_LPAREN] = ACTIONS(4064),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(4066),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(4066),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(4066),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(4066),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(4066),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(4066),
    [sym_preproc_directive] = ACTIONS(4066),
    [anon_sym_SEMI] = ACTIONS(4064),
    [anon_sym_typedef] = ACTIONS(4066),
    [anon_sym_extern] = ACTIONS(4066),
    [anon_sym_LBRACE] = ACTIONS(4064),
    [anon_sym_STAR] = ACTIONS(4064),
    [anon_sym_LBRACK] = ACTIONS(4064),
    [anon_sym_static] = ACTIONS(4066),
    [anon_sym_register] = ACTIONS(4066),
    [anon_sym_inline] = ACTIONS(4066),
    [anon_sym_const] = ACTIONS(4066),
    [anon_sym_restrict] = ACTIONS(4066),
    [anon_sym_volatile] = ACTIONS(4066),
    [anon_sym__Atomic] = ACTIONS(4066),
    [anon_sym_mutable] = ACTIONS(4066),
    [anon_sym_explicit] = ACTIONS(4066),
    [anon_sym_constexpr] = ACTIONS(4066),
    [anon_sym_unsigned] = ACTIONS(4066),
    [anon_sym_long] = ACTIONS(4066),
    [anon_sym_short] = ACTIONS(4066),
    [sym_primitive_type] = ACTIONS(4066),
    [anon_sym_enum] = ACTIONS(4066),
    [anon_sym_struct] = ACTIONS(4066),
    [anon_sym_union] = ACTIONS(4066),
    [anon_sym_if] = ACTIONS(4066),
    [anon_sym_switch] = ACTIONS(4066),
    [anon_sym_case] = ACTIONS(4066),
    [anon_sym_default] = ACTIONS(4066),
    [anon_sym_while] = ACTIONS(4066),
    [anon_sym_do] = ACTIONS(4066),
    [anon_sym_for] = ACTIONS(4066),
    [anon_sym_return] = ACTIONS(4066),
    [anon_sym_break] = ACTIONS(4066),
    [anon_sym_continue] = ACTIONS(4066),
    [anon_sym_goto] = ACTIONS(4066),
    [anon_sym_AMP] = ACTIONS(4064),
    [anon_sym_BANG] = ACTIONS(4064),
    [anon_sym_TILDE] = ACTIONS(4064),
    [anon_sym_PLUS] = ACTIONS(4066),
    [anon_sym_DASH] = ACTIONS(4066),
    [anon_sym_DASH_DASH] = ACTIONS(4064),
    [anon_sym_PLUS_PLUS] = ACTIONS(4064),
    [anon_sym_sizeof] = ACTIONS(4066),
    [sym_number_literal] = ACTIONS(4064),
    [sym_char_literal] = ACTIONS(4064),
    [sym_string_literal] = ACTIONS(4064),
    [sym_true] = ACTIONS(4066),
    [sym_false] = ACTIONS(4066),
    [sym_null] = ACTIONS(4066),
    [sym_identifier] = ACTIONS(4066),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(4066),
    [sym_auto] = ACTIONS(4066),
    [anon_sym_typename] = ACTIONS(4066),
    [anon_sym_new] = ACTIONS(4066),
    [anon_sym_COLON_COLON] = ACTIONS(4064),
    [anon_sym_delete] = ACTIONS(4066),
    [sym_nullptr] = ACTIONS(4066),
  },
  [2751] = {
    [sym_raw_string_literal] = ACTIONS(4112),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(4114),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(4114),
    [anon_sym_LPAREN] = ACTIONS(4112),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(4114),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(4114),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(4114),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(4114),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(4114),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(4114),
    [sym_preproc_directive] = ACTIONS(4114),
    [anon_sym_SEMI] = ACTIONS(4112),
    [anon_sym_typedef] = ACTIONS(4114),
    [anon_sym_extern] = ACTIONS(4114),
    [anon_sym_LBRACE] = ACTIONS(4112),
    [anon_sym_STAR] = ACTIONS(4112),
    [anon_sym_LBRACK] = ACTIONS(4112),
    [anon_sym_static] = ACTIONS(4114),
    [anon_sym_register] = ACTIONS(4114),
    [anon_sym_inline] = ACTIONS(4114),
    [anon_sym_const] = ACTIONS(4114),
    [anon_sym_restrict] = ACTIONS(4114),
    [anon_sym_volatile] = ACTIONS(4114),
    [anon_sym__Atomic] = ACTIONS(4114),
    [anon_sym_mutable] = ACTIONS(4114),
    [anon_sym_explicit] = ACTIONS(4114),
    [anon_sym_constexpr] = ACTIONS(4114),
    [anon_sym_unsigned] = ACTIONS(4114),
    [anon_sym_long] = ACTIONS(4114),
    [anon_sym_short] = ACTIONS(4114),
    [sym_primitive_type] = ACTIONS(4114),
    [anon_sym_enum] = ACTIONS(4114),
    [anon_sym_struct] = ACTIONS(4114),
    [anon_sym_union] = ACTIONS(4114),
    [anon_sym_if] = ACTIONS(4114),
    [anon_sym_switch] = ACTIONS(4114),
    [anon_sym_case] = ACTIONS(4114),
    [anon_sym_default] = ACTIONS(4114),
    [anon_sym_while] = ACTIONS(4114),
    [anon_sym_do] = ACTIONS(4114),
    [anon_sym_for] = ACTIONS(4114),
    [anon_sym_return] = ACTIONS(4114),
    [anon_sym_break] = ACTIONS(4114),
    [anon_sym_continue] = ACTIONS(4114),
    [anon_sym_goto] = ACTIONS(4114),
    [anon_sym_AMP] = ACTIONS(4112),
    [anon_sym_BANG] = ACTIONS(4112),
    [anon_sym_TILDE] = ACTIONS(4112),
    [anon_sym_PLUS] = ACTIONS(4114),
    [anon_sym_DASH] = ACTIONS(4114),
    [anon_sym_DASH_DASH] = ACTIONS(4112),
    [anon_sym_PLUS_PLUS] = ACTIONS(4112),
    [anon_sym_sizeof] = ACTIONS(4114),
    [sym_number_literal] = ACTIONS(4112),
    [sym_char_literal] = ACTIONS(4112),
    [sym_string_literal] = ACTIONS(4112),
    [sym_true] = ACTIONS(4114),
    [sym_false] = ACTIONS(4114),
    [sym_null] = ACTIONS(4114),
    [sym_identifier] = ACTIONS(4114),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(4114),
    [sym_auto] = ACTIONS(4114),
    [anon_sym_typename] = ACTIONS(4114),
    [anon_sym_new] = ACTIONS(4114),
    [anon_sym_COLON_COLON] = ACTIONS(4112),
    [anon_sym_delete] = ACTIONS(4114),
    [sym_nullptr] = ACTIONS(4114),
  },
  [2752] = {
    [sym_argument_list] = STATE(802),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_RPAREN] = ACTIONS(5984),
    [anon_sym_STAR] = ACTIONS(4537),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_EQ] = ACTIONS(5986),
    [anon_sym_QMARK] = ACTIONS(5984),
    [anon_sym_STAR_EQ] = ACTIONS(5984),
    [anon_sym_SLASH_EQ] = ACTIONS(5984),
    [anon_sym_PERCENT_EQ] = ACTIONS(5984),
    [anon_sym_PLUS_EQ] = ACTIONS(5984),
    [anon_sym_DASH_EQ] = ACTIONS(5984),
    [anon_sym_LT_LT_EQ] = ACTIONS(5984),
    [anon_sym_GT_GT_EQ] = ACTIONS(5984),
    [anon_sym_AMP_EQ] = ACTIONS(5984),
    [anon_sym_CARET_EQ] = ACTIONS(5984),
    [anon_sym_PIPE_EQ] = ACTIONS(5984),
    [anon_sym_AMP] = ACTIONS(4545),
    [anon_sym_PIPE_PIPE] = ACTIONS(4547),
    [anon_sym_AMP_AMP] = ACTIONS(4549),
    [anon_sym_PIPE] = ACTIONS(4551),
    [anon_sym_CARET] = ACTIONS(4553),
    [anon_sym_EQ_EQ] = ACTIONS(4555),
    [anon_sym_BANG_EQ] = ACTIONS(4555),
    [anon_sym_LT] = ACTIONS(4557),
    [anon_sym_GT] = ACTIONS(4557),
    [anon_sym_LT_EQ] = ACTIONS(4559),
    [anon_sym_GT_EQ] = ACTIONS(4559),
    [anon_sym_LT_LT] = ACTIONS(4561),
    [anon_sym_GT_GT] = ACTIONS(4561),
    [anon_sym_PLUS] = ACTIONS(4563),
    [anon_sym_DASH] = ACTIONS(4563),
    [anon_sym_SLASH] = ACTIONS(4537),
    [anon_sym_PERCENT] = ACTIONS(4537),
    [anon_sym_DASH_DASH] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(1554),
    [anon_sym_DASH_GT] = ACTIONS(1554),
    [sym_comment] = ACTIONS(49),
  },
  [2753] = {
    [sym_raw_string_literal] = ACTIONS(3182),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3184),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3184),
    [anon_sym_LPAREN] = ACTIONS(3182),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3184),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3184),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3184),
    [sym_preproc_directive] = ACTIONS(3184),
    [anon_sym_SEMI] = ACTIONS(3182),
    [anon_sym_typedef] = ACTIONS(3184),
    [anon_sym_extern] = ACTIONS(3184),
    [anon_sym_LBRACE] = ACTIONS(3182),
    [anon_sym_RBRACE] = ACTIONS(3182),
    [anon_sym_STAR] = ACTIONS(3182),
    [anon_sym_LBRACK] = ACTIONS(3182),
    [anon_sym_static] = ACTIONS(3184),
    [anon_sym_register] = ACTIONS(3184),
    [anon_sym_inline] = ACTIONS(3184),
    [anon_sym_const] = ACTIONS(3184),
    [anon_sym_restrict] = ACTIONS(3184),
    [anon_sym_volatile] = ACTIONS(3184),
    [anon_sym__Atomic] = ACTIONS(3184),
    [anon_sym_mutable] = ACTIONS(3184),
    [anon_sym_explicit] = ACTIONS(3184),
    [anon_sym_constexpr] = ACTIONS(3184),
    [anon_sym_unsigned] = ACTIONS(3184),
    [anon_sym_long] = ACTIONS(3184),
    [anon_sym_short] = ACTIONS(3184),
    [sym_primitive_type] = ACTIONS(3184),
    [anon_sym_enum] = ACTIONS(3184),
    [anon_sym_struct] = ACTIONS(3184),
    [anon_sym_union] = ACTIONS(3184),
    [anon_sym_if] = ACTIONS(3184),
    [anon_sym_else] = ACTIONS(3184),
    [anon_sym_switch] = ACTIONS(3184),
    [anon_sym_case] = ACTIONS(3184),
    [anon_sym_default] = ACTIONS(3184),
    [anon_sym_while] = ACTIONS(3184),
    [anon_sym_do] = ACTIONS(3184),
    [anon_sym_for] = ACTIONS(3184),
    [anon_sym_return] = ACTIONS(3184),
    [anon_sym_break] = ACTIONS(3184),
    [anon_sym_continue] = ACTIONS(3184),
    [anon_sym_goto] = ACTIONS(3184),
    [anon_sym_AMP] = ACTIONS(3182),
    [anon_sym_BANG] = ACTIONS(3182),
    [anon_sym_TILDE] = ACTIONS(3182),
    [anon_sym_PLUS] = ACTIONS(3184),
    [anon_sym_DASH] = ACTIONS(3184),
    [anon_sym_DASH_DASH] = ACTIONS(3182),
    [anon_sym_PLUS_PLUS] = ACTIONS(3182),
    [anon_sym_sizeof] = ACTIONS(3184),
    [sym_number_literal] = ACTIONS(3182),
    [sym_char_literal] = ACTIONS(3182),
    [sym_string_literal] = ACTIONS(3182),
    [sym_true] = ACTIONS(3184),
    [sym_false] = ACTIONS(3184),
    [sym_null] = ACTIONS(3184),
    [sym_identifier] = ACTIONS(3184),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(3184),
    [sym_auto] = ACTIONS(3184),
    [anon_sym_typename] = ACTIONS(3184),
    [anon_sym_new] = ACTIONS(3184),
    [anon_sym_COLON_COLON] = ACTIONS(3182),
    [anon_sym_delete] = ACTIONS(3184),
    [sym_nullptr] = ACTIONS(3184),
  },
  [2754] = {
    [sym_argument_list] = STATE(802),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_RPAREN] = ACTIONS(6838),
    [anon_sym_STAR] = ACTIONS(4537),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_EQ] = ACTIONS(4539),
    [anon_sym_QMARK] = ACTIONS(4541),
    [anon_sym_STAR_EQ] = ACTIONS(4543),
    [anon_sym_SLASH_EQ] = ACTIONS(4543),
    [anon_sym_PERCENT_EQ] = ACTIONS(4543),
    [anon_sym_PLUS_EQ] = ACTIONS(4543),
    [anon_sym_DASH_EQ] = ACTIONS(4543),
    [anon_sym_LT_LT_EQ] = ACTIONS(4543),
    [anon_sym_GT_GT_EQ] = ACTIONS(4543),
    [anon_sym_AMP_EQ] = ACTIONS(4543),
    [anon_sym_CARET_EQ] = ACTIONS(4543),
    [anon_sym_PIPE_EQ] = ACTIONS(4543),
    [anon_sym_AMP] = ACTIONS(4545),
    [anon_sym_PIPE_PIPE] = ACTIONS(4547),
    [anon_sym_AMP_AMP] = ACTIONS(4549),
    [anon_sym_PIPE] = ACTIONS(4551),
    [anon_sym_CARET] = ACTIONS(4553),
    [anon_sym_EQ_EQ] = ACTIONS(4555),
    [anon_sym_BANG_EQ] = ACTIONS(4555),
    [anon_sym_LT] = ACTIONS(4557),
    [anon_sym_GT] = ACTIONS(4557),
    [anon_sym_LT_EQ] = ACTIONS(4559),
    [anon_sym_GT_EQ] = ACTIONS(4559),
    [anon_sym_LT_LT] = ACTIONS(4561),
    [anon_sym_GT_GT] = ACTIONS(4561),
    [anon_sym_PLUS] = ACTIONS(4563),
    [anon_sym_DASH] = ACTIONS(4563),
    [anon_sym_SLASH] = ACTIONS(4537),
    [anon_sym_PERCENT] = ACTIONS(4537),
    [anon_sym_DASH_DASH] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(1554),
    [anon_sym_DASH_GT] = ACTIONS(1554),
    [sym_comment] = ACTIONS(49),
  },
  [2755] = {
    [sym__expression] = STATE(2885),
    [sym_conditional_expression] = STATE(2885),
    [sym_assignment_expression] = STATE(2885),
    [sym_pointer_expression] = STATE(2885),
    [sym_logical_expression] = STATE(2885),
    [sym_bitwise_expression] = STATE(2885),
    [sym_equality_expression] = STATE(2885),
    [sym_relational_expression] = STATE(2885),
    [sym_shift_expression] = STATE(2885),
    [sym_math_expression] = STATE(2885),
    [sym_cast_expression] = STATE(2885),
    [sym_sizeof_expression] = STATE(2885),
    [sym_subscript_expression] = STATE(2885),
    [sym_call_expression] = STATE(2885),
    [sym_field_expression] = STATE(2885),
    [sym_compound_literal_expression] = STATE(2885),
    [sym_parenthesized_expression] = STATE(2885),
    [sym_concatenated_string] = STATE(2885),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(2885),
    [sym_new_expression] = STATE(2885),
    [sym_delete_expression] = STATE(2885),
    [sym_lambda_expression] = STATE(2885),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(6840),
    [anon_sym_LPAREN] = ACTIONS(2943),
    [anon_sym_STAR] = ACTIONS(2945),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_AMP] = ACTIONS(2945),
    [anon_sym_BANG] = ACTIONS(2947),
    [anon_sym_TILDE] = ACTIONS(2949),
    [anon_sym_PLUS] = ACTIONS(2951),
    [anon_sym_DASH] = ACTIONS(2951),
    [anon_sym_DASH_DASH] = ACTIONS(2953),
    [anon_sym_PLUS_PLUS] = ACTIONS(2953),
    [anon_sym_sizeof] = ACTIONS(2955),
    [sym_number_literal] = ACTIONS(6840),
    [sym_char_literal] = ACTIONS(6840),
    [sym_string_literal] = ACTIONS(2957),
    [sym_true] = ACTIONS(6842),
    [sym_false] = ACTIONS(6842),
    [sym_null] = ACTIONS(6842),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(2961),
    [anon_sym_delete] = ACTIONS(2963),
    [sym_nullptr] = ACTIONS(6842),
  },
  [2756] = {
    [sym_argument_list] = STATE(802),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_RPAREN] = ACTIONS(6844),
    [anon_sym_STAR] = ACTIONS(4537),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_EQ] = ACTIONS(4539),
    [anon_sym_QMARK] = ACTIONS(4541),
    [anon_sym_STAR_EQ] = ACTIONS(4543),
    [anon_sym_SLASH_EQ] = ACTIONS(4543),
    [anon_sym_PERCENT_EQ] = ACTIONS(4543),
    [anon_sym_PLUS_EQ] = ACTIONS(4543),
    [anon_sym_DASH_EQ] = ACTIONS(4543),
    [anon_sym_LT_LT_EQ] = ACTIONS(4543),
    [anon_sym_GT_GT_EQ] = ACTIONS(4543),
    [anon_sym_AMP_EQ] = ACTIONS(4543),
    [anon_sym_CARET_EQ] = ACTIONS(4543),
    [anon_sym_PIPE_EQ] = ACTIONS(4543),
    [anon_sym_AMP] = ACTIONS(4545),
    [anon_sym_PIPE_PIPE] = ACTIONS(4547),
    [anon_sym_AMP_AMP] = ACTIONS(4549),
    [anon_sym_PIPE] = ACTIONS(4551),
    [anon_sym_CARET] = ACTIONS(4553),
    [anon_sym_EQ_EQ] = ACTIONS(4555),
    [anon_sym_BANG_EQ] = ACTIONS(4555),
    [anon_sym_LT] = ACTIONS(4557),
    [anon_sym_GT] = ACTIONS(4557),
    [anon_sym_LT_EQ] = ACTIONS(4559),
    [anon_sym_GT_EQ] = ACTIONS(4559),
    [anon_sym_LT_LT] = ACTIONS(4561),
    [anon_sym_GT_GT] = ACTIONS(4561),
    [anon_sym_PLUS] = ACTIONS(4563),
    [anon_sym_DASH] = ACTIONS(4563),
    [anon_sym_SLASH] = ACTIONS(4537),
    [anon_sym_PERCENT] = ACTIONS(4537),
    [anon_sym_DASH_DASH] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(1554),
    [anon_sym_DASH_GT] = ACTIONS(1554),
    [sym_comment] = ACTIONS(49),
  },
  [2757] = {
    [sym_declaration] = STATE(2887),
    [sym_type_definition] = STATE(2887),
    [sym__declaration_specifiers] = STATE(2761),
    [sym_compound_statement] = STATE(2887),
    [sym_storage_class_specifier] = STATE(109),
    [sym_type_qualifier] = STATE(109),
    [sym__type_specifier] = STATE(105),
    [sym_sized_type_specifier] = STATE(105),
    [sym_enum_specifier] = STATE(105),
    [sym_struct_specifier] = STATE(105),
    [sym_union_specifier] = STATE(105),
    [sym_labeled_statement] = STATE(2887),
    [sym_expression_statement] = STATE(2887),
    [sym_if_statement] = STATE(2887),
    [sym_switch_statement] = STATE(2887),
    [sym_case_statement] = STATE(2887),
    [sym_while_statement] = STATE(2887),
    [sym_do_statement] = STATE(2887),
    [sym_for_statement] = STATE(2887),
    [sym_return_statement] = STATE(2887),
    [sym_break_statement] = STATE(2887),
    [sym_continue_statement] = STATE(2887),
    [sym_goto_statement] = STATE(2887),
    [sym__expression] = STATE(2378),
    [sym_comma_expression] = STATE(2379),
    [sym_conditional_expression] = STATE(2378),
    [sym_assignment_expression] = STATE(2378),
    [sym_pointer_expression] = STATE(2378),
    [sym_logical_expression] = STATE(2378),
    [sym_bitwise_expression] = STATE(2378),
    [sym_equality_expression] = STATE(2378),
    [sym_relational_expression] = STATE(2378),
    [sym_shift_expression] = STATE(2378),
    [sym_math_expression] = STATE(2378),
    [sym_cast_expression] = STATE(2378),
    [sym_sizeof_expression] = STATE(2378),
    [sym_subscript_expression] = STATE(2378),
    [sym_call_expression] = STATE(2378),
    [sym_field_expression] = STATE(2378),
    [sym_compound_literal_expression] = STATE(2378),
    [sym_parenthesized_expression] = STATE(2378),
    [sym_concatenated_string] = STATE(2378),
    [sym_macro_type_specifier] = STATE(105),
    [sym_class_specifier] = STATE(105),
    [sym_dependent_type] = STATE(105),
    [sym_template_type] = STATE(1475),
    [sym_template_function] = STATE(2378),
    [sym_for_range_loop] = STATE(2887),
    [sym_new_expression] = STATE(2378),
    [sym_delete_expression] = STATE(2378),
    [sym_lambda_expression] = STATE(2378),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(416),
    [sym_scoped_namespace_identifier] = STATE(1476),
    [aux_sym__declaration_specifiers_repeat1] = STATE(109),
    [aux_sym_sized_type_specifier_repeat1] = STATE(110),
    [sym_raw_string_literal] = ACTIONS(5538),
    [anon_sym_LPAREN] = ACTIONS(626),
    [anon_sym_SEMI] = ACTIONS(5540),
    [anon_sym_typedef] = ACTIONS(6587),
    [anon_sym_extern] = ACTIONS(154),
    [anon_sym_LBRACE] = ACTIONS(5542),
    [anon_sym_STAR] = ACTIONS(644),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_static] = ACTIONS(154),
    [anon_sym_register] = ACTIONS(154),
    [anon_sym_inline] = ACTIONS(154),
    [anon_sym_const] = ACTIONS(158),
    [anon_sym_restrict] = ACTIONS(158),
    [anon_sym_volatile] = ACTIONS(158),
    [anon_sym__Atomic] = ACTIONS(158),
    [anon_sym_mutable] = ACTIONS(158),
    [anon_sym_explicit] = ACTIONS(158),
    [anon_sym_constexpr] = ACTIONS(158),
    [anon_sym_unsigned] = ACTIONS(160),
    [anon_sym_long] = ACTIONS(160),
    [anon_sym_short] = ACTIONS(160),
    [sym_primitive_type] = ACTIONS(162),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_union] = ACTIONS(39),
    [anon_sym_if] = ACTIONS(5544),
    [anon_sym_switch] = ACTIONS(5546),
    [anon_sym_case] = ACTIONS(5548),
    [anon_sym_default] = ACTIONS(5550),
    [anon_sym_while] = ACTIONS(5552),
    [anon_sym_do] = ACTIONS(5554),
    [anon_sym_for] = ACTIONS(5556),
    [anon_sym_return] = ACTIONS(5558),
    [anon_sym_break] = ACTIONS(5560),
    [anon_sym_continue] = ACTIONS(5562),
    [anon_sym_goto] = ACTIONS(5564),
    [anon_sym_AMP] = ACTIONS(644),
    [anon_sym_BANG] = ACTIONS(668),
    [anon_sym_TILDE] = ACTIONS(670),
    [anon_sym_PLUS] = ACTIONS(672),
    [anon_sym_DASH] = ACTIONS(672),
    [anon_sym_DASH_DASH] = ACTIONS(674),
    [anon_sym_PLUS_PLUS] = ACTIONS(674),
    [anon_sym_sizeof] = ACTIONS(676),
    [sym_number_literal] = ACTIONS(5538),
    [sym_char_literal] = ACTIONS(5538),
    [sym_string_literal] = ACTIONS(678),
    [sym_true] = ACTIONS(5566),
    [sym_false] = ACTIONS(5566),
    [sym_null] = ACTIONS(5566),
    [sym_identifier] = ACTIONS(6589),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(51),
    [sym_auto] = ACTIONS(162),
    [anon_sym_typename] = ACTIONS(172),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(3040),
    [anon_sym_delete] = ACTIONS(686),
    [sym_nullptr] = ACTIONS(5566),
  },
  [2758] = {
    [sym_type_qualifier] = STATE(2889),
    [sym__type_specifier] = STATE(2888),
    [sym_sized_type_specifier] = STATE(2888),
    [sym_enum_specifier] = STATE(2888),
    [sym_struct_specifier] = STATE(2888),
    [sym_union_specifier] = STATE(2888),
    [sym_macro_type_specifier] = STATE(2888),
    [sym_class_specifier] = STATE(2888),
    [sym_dependent_type] = STATE(2888),
    [sym_template_type] = STATE(62),
    [sym_scoped_type_identifier] = STATE(63),
    [sym_scoped_namespace_identifier] = STATE(64),
    [aux_sym_type_definition_repeat1] = STATE(2889),
    [aux_sym_sized_type_specifier_repeat1] = STATE(66),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_restrict] = ACTIONS(93),
    [anon_sym_volatile] = ACTIONS(93),
    [anon_sym__Atomic] = ACTIONS(93),
    [anon_sym_mutable] = ACTIONS(93),
    [anon_sym_explicit] = ACTIONS(93),
    [anon_sym_constexpr] = ACTIONS(93),
    [anon_sym_unsigned] = ACTIONS(95),
    [anon_sym_long] = ACTIONS(95),
    [anon_sym_short] = ACTIONS(95),
    [sym_primitive_type] = ACTIONS(6846),
    [anon_sym_enum] = ACTIONS(99),
    [anon_sym_struct] = ACTIONS(101),
    [anon_sym_union] = ACTIONS(103),
    [sym_identifier] = ACTIONS(105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(107),
    [sym_auto] = ACTIONS(6846),
    [anon_sym_typename] = ACTIONS(109),
    [anon_sym_COLON_COLON] = ACTIONS(111),
  },
  [2759] = {
    [sym_initializer_list] = STATE(765),
    [sym_template_argument_list] = STATE(2039),
    [anon_sym_LPAREN] = ACTIONS(1483),
    [anon_sym_COMMA] = ACTIONS(1477),
    [anon_sym_SEMI] = ACTIONS(1477),
    [anon_sym_extern] = ACTIONS(144),
    [anon_sym_LBRACE] = ACTIONS(548),
    [anon_sym_STAR] = ACTIONS(1486),
    [anon_sym_LBRACK] = ACTIONS(1477),
    [anon_sym_EQ] = ACTIONS(1479),
    [anon_sym_static] = ACTIONS(144),
    [anon_sym_register] = ACTIONS(144),
    [anon_sym_inline] = ACTIONS(144),
    [anon_sym_const] = ACTIONS(144),
    [anon_sym_restrict] = ACTIONS(144),
    [anon_sym_volatile] = ACTIONS(144),
    [anon_sym__Atomic] = ACTIONS(144),
    [anon_sym_mutable] = ACTIONS(144),
    [anon_sym_explicit] = ACTIONS(144),
    [anon_sym_constexpr] = ACTIONS(144),
    [anon_sym_COLON] = ACTIONS(6265),
    [anon_sym_QMARK] = ACTIONS(1477),
    [anon_sym_STAR_EQ] = ACTIONS(1477),
    [anon_sym_SLASH_EQ] = ACTIONS(1477),
    [anon_sym_PERCENT_EQ] = ACTIONS(1477),
    [anon_sym_PLUS_EQ] = ACTIONS(1477),
    [anon_sym_DASH_EQ] = ACTIONS(1477),
    [anon_sym_LT_LT_EQ] = ACTIONS(1477),
    [anon_sym_GT_GT_EQ] = ACTIONS(1477),
    [anon_sym_AMP_EQ] = ACTIONS(1477),
    [anon_sym_CARET_EQ] = ACTIONS(1477),
    [anon_sym_PIPE_EQ] = ACTIONS(1477),
    [anon_sym_AMP] = ACTIONS(1486),
    [anon_sym_PIPE_PIPE] = ACTIONS(1477),
    [anon_sym_AMP_AMP] = ACTIONS(1483),
    [anon_sym_PIPE] = ACTIONS(1479),
    [anon_sym_CARET] = ACTIONS(1479),
    [anon_sym_TILDE] = ACTIONS(142),
    [anon_sym_EQ_EQ] = ACTIONS(1477),
    [anon_sym_BANG_EQ] = ACTIONS(1477),
    [anon_sym_LT] = ACTIONS(1564),
    [anon_sym_GT] = ACTIONS(1479),
    [anon_sym_LT_EQ] = ACTIONS(1477),
    [anon_sym_GT_EQ] = ACTIONS(1477),
    [anon_sym_LT_LT] = ACTIONS(1479),
    [anon_sym_GT_GT] = ACTIONS(1479),
    [anon_sym_PLUS] = ACTIONS(1479),
    [anon_sym_DASH] = ACTIONS(1479),
    [anon_sym_SLASH] = ACTIONS(1479),
    [anon_sym_PERCENT] = ACTIONS(1479),
    [anon_sym_DASH_DASH] = ACTIONS(1477),
    [anon_sym_PLUS_PLUS] = ACTIONS(1477),
    [anon_sym_DOT] = ACTIONS(1477),
    [anon_sym_DASH_GT] = ACTIONS(1477),
    [sym_identifier] = ACTIONS(144),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(4631),
    [sym_operator_name] = ACTIONS(142),
  },
  [2760] = {
    [sym_raw_string_literal] = ACTIONS(4635),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(4637),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(4637),
    [anon_sym_LPAREN] = ACTIONS(4635),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(4637),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(4637),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(4637),
    [sym_preproc_directive] = ACTIONS(4637),
    [anon_sym_SEMI] = ACTIONS(4635),
    [anon_sym_typedef] = ACTIONS(4637),
    [anon_sym_extern] = ACTIONS(4637),
    [anon_sym_LBRACE] = ACTIONS(4635),
    [anon_sym_RBRACE] = ACTIONS(4635),
    [anon_sym_STAR] = ACTIONS(4635),
    [anon_sym_LBRACK] = ACTIONS(4635),
    [anon_sym_static] = ACTIONS(4637),
    [anon_sym_register] = ACTIONS(4637),
    [anon_sym_inline] = ACTIONS(4637),
    [anon_sym_const] = ACTIONS(4637),
    [anon_sym_restrict] = ACTIONS(4637),
    [anon_sym_volatile] = ACTIONS(4637),
    [anon_sym__Atomic] = ACTIONS(4637),
    [anon_sym_mutable] = ACTIONS(4637),
    [anon_sym_explicit] = ACTIONS(4637),
    [anon_sym_constexpr] = ACTIONS(4637),
    [anon_sym_unsigned] = ACTIONS(4637),
    [anon_sym_long] = ACTIONS(4637),
    [anon_sym_short] = ACTIONS(4637),
    [sym_primitive_type] = ACTIONS(4637),
    [anon_sym_enum] = ACTIONS(4637),
    [anon_sym_struct] = ACTIONS(4637),
    [anon_sym_union] = ACTIONS(4637),
    [anon_sym_if] = ACTIONS(4637),
    [anon_sym_else] = ACTIONS(4637),
    [anon_sym_switch] = ACTIONS(4637),
    [anon_sym_case] = ACTIONS(4637),
    [anon_sym_default] = ACTIONS(4637),
    [anon_sym_while] = ACTIONS(4637),
    [anon_sym_do] = ACTIONS(4637),
    [anon_sym_for] = ACTIONS(4637),
    [anon_sym_return] = ACTIONS(4637),
    [anon_sym_break] = ACTIONS(4637),
    [anon_sym_continue] = ACTIONS(4637),
    [anon_sym_goto] = ACTIONS(4637),
    [anon_sym_AMP] = ACTIONS(4635),
    [anon_sym_BANG] = ACTIONS(4635),
    [anon_sym_TILDE] = ACTIONS(4635),
    [anon_sym_PLUS] = ACTIONS(4637),
    [anon_sym_DASH] = ACTIONS(4637),
    [anon_sym_DASH_DASH] = ACTIONS(4635),
    [anon_sym_PLUS_PLUS] = ACTIONS(4635),
    [anon_sym_sizeof] = ACTIONS(4637),
    [sym_number_literal] = ACTIONS(4635),
    [sym_char_literal] = ACTIONS(4635),
    [sym_string_literal] = ACTIONS(4635),
    [sym_true] = ACTIONS(4637),
    [sym_false] = ACTIONS(4637),
    [sym_null] = ACTIONS(4637),
    [sym_identifier] = ACTIONS(4637),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(4637),
    [sym_auto] = ACTIONS(4637),
    [anon_sym_typename] = ACTIONS(4637),
    [anon_sym_new] = ACTIONS(4637),
    [anon_sym_COLON_COLON] = ACTIONS(4635),
    [anon_sym_delete] = ACTIONS(4637),
    [sym_nullptr] = ACTIONS(4637),
  },
  [2761] = {
    [sym__declarator] = STATE(2890),
    [sym_pointer_declarator] = STATE(2890),
    [sym_function_declarator] = STATE(2890),
    [sym_array_declarator] = STATE(2890),
    [sym_init_declarator] = STATE(2891),
    [sym_reference_declarator] = STATE(2890),
    [sym_template_type] = STATE(46),
    [sym_template_function] = STATE(2890),
    [sym_destructor_name] = STATE(2890),
    [sym_scoped_identifier] = STATE(33),
    [sym_scoped_type_identifier] = STATE(47),
    [sym_scoped_namespace_identifier] = STATE(46),
    [anon_sym_LPAREN] = ACTIONS(11),
    [anon_sym_STAR] = ACTIONS(196),
    [anon_sym_AMP] = ACTIONS(526),
    [anon_sym_AMP_AMP] = ACTIONS(528),
    [anon_sym_TILDE] = ACTIONS(45),
    [sym_identifier] = ACTIONS(75),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(77),
    [sym_operator_name] = ACTIONS(6848),
  },
  [2762] = {
    [sym_argument_list] = STATE(802),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_RPAREN] = ACTIONS(6850),
    [anon_sym_STAR] = ACTIONS(4537),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_EQ] = ACTIONS(4539),
    [anon_sym_QMARK] = ACTIONS(4541),
    [anon_sym_STAR_EQ] = ACTIONS(4543),
    [anon_sym_SLASH_EQ] = ACTIONS(4543),
    [anon_sym_PERCENT_EQ] = ACTIONS(4543),
    [anon_sym_PLUS_EQ] = ACTIONS(4543),
    [anon_sym_DASH_EQ] = ACTIONS(4543),
    [anon_sym_LT_LT_EQ] = ACTIONS(4543),
    [anon_sym_GT_GT_EQ] = ACTIONS(4543),
    [anon_sym_AMP_EQ] = ACTIONS(4543),
    [anon_sym_CARET_EQ] = ACTIONS(4543),
    [anon_sym_PIPE_EQ] = ACTIONS(4543),
    [anon_sym_AMP] = ACTIONS(4545),
    [anon_sym_PIPE_PIPE] = ACTIONS(4547),
    [anon_sym_AMP_AMP] = ACTIONS(4549),
    [anon_sym_PIPE] = ACTIONS(4551),
    [anon_sym_CARET] = ACTIONS(4553),
    [anon_sym_EQ_EQ] = ACTIONS(4555),
    [anon_sym_BANG_EQ] = ACTIONS(4555),
    [anon_sym_LT] = ACTIONS(4557),
    [anon_sym_GT] = ACTIONS(4557),
    [anon_sym_LT_EQ] = ACTIONS(4559),
    [anon_sym_GT_EQ] = ACTIONS(4559),
    [anon_sym_LT_LT] = ACTIONS(4561),
    [anon_sym_GT_GT] = ACTIONS(4561),
    [anon_sym_PLUS] = ACTIONS(4563),
    [anon_sym_DASH] = ACTIONS(4563),
    [anon_sym_SLASH] = ACTIONS(4537),
    [anon_sym_PERCENT] = ACTIONS(4537),
    [anon_sym_DASH_DASH] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(1554),
    [anon_sym_DASH_GT] = ACTIONS(1554),
    [sym_comment] = ACTIONS(49),
  },
  [2763] = {
    [anon_sym_LPAREN] = ACTIONS(6852),
    [sym_comment] = ACTIONS(49),
  },
  [2764] = {
    [sym__expression] = STATE(2895),
    [sym_conditional_expression] = STATE(2895),
    [sym_assignment_expression] = STATE(2895),
    [sym_pointer_expression] = STATE(2895),
    [sym_logical_expression] = STATE(2895),
    [sym_bitwise_expression] = STATE(2895),
    [sym_equality_expression] = STATE(2895),
    [sym_relational_expression] = STATE(2895),
    [sym_shift_expression] = STATE(2895),
    [sym_math_expression] = STATE(2895),
    [sym_cast_expression] = STATE(2895),
    [sym_sizeof_expression] = STATE(2895),
    [sym_subscript_expression] = STATE(2895),
    [sym_call_expression] = STATE(2895),
    [sym_field_expression] = STATE(2895),
    [sym_compound_literal_expression] = STATE(2895),
    [sym_parenthesized_expression] = STATE(2895),
    [sym_concatenated_string] = STATE(2895),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(2895),
    [sym_new_expression] = STATE(2895),
    [sym_delete_expression] = STATE(2895),
    [sym_lambda_expression] = STATE(2895),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(6854),
    [anon_sym_LPAREN] = ACTIONS(1347),
    [anon_sym_SEMI] = ACTIONS(6856),
    [anon_sym_STAR] = ACTIONS(1349),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_AMP] = ACTIONS(1349),
    [anon_sym_BANG] = ACTIONS(1351),
    [anon_sym_TILDE] = ACTIONS(1353),
    [anon_sym_PLUS] = ACTIONS(1355),
    [anon_sym_DASH] = ACTIONS(1355),
    [anon_sym_DASH_DASH] = ACTIONS(1357),
    [anon_sym_PLUS_PLUS] = ACTIONS(1357),
    [anon_sym_sizeof] = ACTIONS(1359),
    [sym_number_literal] = ACTIONS(6854),
    [sym_char_literal] = ACTIONS(6854),
    [sym_string_literal] = ACTIONS(1361),
    [sym_true] = ACTIONS(6858),
    [sym_false] = ACTIONS(6858),
    [sym_null] = ACTIONS(6858),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1365),
    [anon_sym_delete] = ACTIONS(1367),
    [sym_nullptr] = ACTIONS(6858),
  },
  [2765] = {
    [sym_argument_list] = STATE(802),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_SEMI] = ACTIONS(6860),
    [anon_sym_STAR] = ACTIONS(2553),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_EQ] = ACTIONS(2555),
    [anon_sym_QMARK] = ACTIONS(2557),
    [anon_sym_STAR_EQ] = ACTIONS(2559),
    [anon_sym_SLASH_EQ] = ACTIONS(2559),
    [anon_sym_PERCENT_EQ] = ACTIONS(2559),
    [anon_sym_PLUS_EQ] = ACTIONS(2559),
    [anon_sym_DASH_EQ] = ACTIONS(2559),
    [anon_sym_LT_LT_EQ] = ACTIONS(2559),
    [anon_sym_GT_GT_EQ] = ACTIONS(2559),
    [anon_sym_AMP_EQ] = ACTIONS(2559),
    [anon_sym_CARET_EQ] = ACTIONS(2559),
    [anon_sym_PIPE_EQ] = ACTIONS(2559),
    [anon_sym_AMP] = ACTIONS(2561),
    [anon_sym_PIPE_PIPE] = ACTIONS(2563),
    [anon_sym_AMP_AMP] = ACTIONS(2565),
    [anon_sym_PIPE] = ACTIONS(2567),
    [anon_sym_CARET] = ACTIONS(2569),
    [anon_sym_EQ_EQ] = ACTIONS(2571),
    [anon_sym_BANG_EQ] = ACTIONS(2571),
    [anon_sym_LT] = ACTIONS(2573),
    [anon_sym_GT] = ACTIONS(2573),
    [anon_sym_LT_EQ] = ACTIONS(2575),
    [anon_sym_GT_EQ] = ACTIONS(2575),
    [anon_sym_LT_LT] = ACTIONS(2577),
    [anon_sym_GT_GT] = ACTIONS(2577),
    [anon_sym_PLUS] = ACTIONS(2579),
    [anon_sym_DASH] = ACTIONS(2579),
    [anon_sym_SLASH] = ACTIONS(2553),
    [anon_sym_PERCENT] = ACTIONS(2553),
    [anon_sym_DASH_DASH] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(1554),
    [anon_sym_DASH_GT] = ACTIONS(1554),
    [sym_comment] = ACTIONS(49),
  },
  [2766] = {
    [anon_sym_COLON] = ACTIONS(6862),
    [sym_comment] = ACTIONS(49),
  },
  [2767] = {
    [sym_raw_string_literal] = ACTIONS(4697),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(4699),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(4699),
    [anon_sym_LPAREN] = ACTIONS(4697),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(4699),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(4699),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(4699),
    [sym_preproc_directive] = ACTIONS(4699),
    [anon_sym_SEMI] = ACTIONS(4697),
    [anon_sym_typedef] = ACTIONS(4699),
    [anon_sym_extern] = ACTIONS(4699),
    [anon_sym_LBRACE] = ACTIONS(4697),
    [anon_sym_RBRACE] = ACTIONS(4697),
    [anon_sym_STAR] = ACTIONS(4697),
    [anon_sym_LBRACK] = ACTIONS(4697),
    [anon_sym_static] = ACTIONS(4699),
    [anon_sym_register] = ACTIONS(4699),
    [anon_sym_inline] = ACTIONS(4699),
    [anon_sym_const] = ACTIONS(4699),
    [anon_sym_restrict] = ACTIONS(4699),
    [anon_sym_volatile] = ACTIONS(4699),
    [anon_sym__Atomic] = ACTIONS(4699),
    [anon_sym_mutable] = ACTIONS(4699),
    [anon_sym_explicit] = ACTIONS(4699),
    [anon_sym_constexpr] = ACTIONS(4699),
    [anon_sym_unsigned] = ACTIONS(4699),
    [anon_sym_long] = ACTIONS(4699),
    [anon_sym_short] = ACTIONS(4699),
    [sym_primitive_type] = ACTIONS(4699),
    [anon_sym_enum] = ACTIONS(4699),
    [anon_sym_struct] = ACTIONS(4699),
    [anon_sym_union] = ACTIONS(4699),
    [anon_sym_if] = ACTIONS(4699),
    [anon_sym_else] = ACTIONS(4699),
    [anon_sym_switch] = ACTIONS(4699),
    [anon_sym_case] = ACTIONS(4699),
    [anon_sym_default] = ACTIONS(4699),
    [anon_sym_while] = ACTIONS(4699),
    [anon_sym_do] = ACTIONS(4699),
    [anon_sym_for] = ACTIONS(4699),
    [anon_sym_return] = ACTIONS(4699),
    [anon_sym_break] = ACTIONS(4699),
    [anon_sym_continue] = ACTIONS(4699),
    [anon_sym_goto] = ACTIONS(4699),
    [anon_sym_AMP] = ACTIONS(4697),
    [anon_sym_BANG] = ACTIONS(4697),
    [anon_sym_TILDE] = ACTIONS(4697),
    [anon_sym_PLUS] = ACTIONS(4699),
    [anon_sym_DASH] = ACTIONS(4699),
    [anon_sym_DASH_DASH] = ACTIONS(4697),
    [anon_sym_PLUS_PLUS] = ACTIONS(4697),
    [anon_sym_sizeof] = ACTIONS(4699),
    [sym_number_literal] = ACTIONS(4697),
    [sym_char_literal] = ACTIONS(4697),
    [sym_string_literal] = ACTIONS(4697),
    [sym_true] = ACTIONS(4699),
    [sym_false] = ACTIONS(4699),
    [sym_null] = ACTIONS(4699),
    [sym_identifier] = ACTIONS(4699),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(4699),
    [sym_auto] = ACTIONS(4699),
    [anon_sym_typename] = ACTIONS(4699),
    [anon_sym_new] = ACTIONS(4699),
    [anon_sym_COLON_COLON] = ACTIONS(4697),
    [anon_sym_delete] = ACTIONS(4699),
    [sym_nullptr] = ACTIONS(4699),
  },
  [2768] = {
    [sym_raw_string_literal] = ACTIONS(4701),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(4703),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(4703),
    [anon_sym_LPAREN] = ACTIONS(4701),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(4703),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(4703),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(4703),
    [sym_preproc_directive] = ACTIONS(4703),
    [anon_sym_SEMI] = ACTIONS(4701),
    [anon_sym_typedef] = ACTIONS(4703),
    [anon_sym_extern] = ACTIONS(4703),
    [anon_sym_LBRACE] = ACTIONS(4701),
    [anon_sym_RBRACE] = ACTIONS(4701),
    [anon_sym_STAR] = ACTIONS(4701),
    [anon_sym_LBRACK] = ACTIONS(4701),
    [anon_sym_static] = ACTIONS(4703),
    [anon_sym_register] = ACTIONS(4703),
    [anon_sym_inline] = ACTIONS(4703),
    [anon_sym_const] = ACTIONS(4703),
    [anon_sym_restrict] = ACTIONS(4703),
    [anon_sym_volatile] = ACTIONS(4703),
    [anon_sym__Atomic] = ACTIONS(4703),
    [anon_sym_mutable] = ACTIONS(4703),
    [anon_sym_explicit] = ACTIONS(4703),
    [anon_sym_constexpr] = ACTIONS(4703),
    [anon_sym_unsigned] = ACTIONS(4703),
    [anon_sym_long] = ACTIONS(4703),
    [anon_sym_short] = ACTIONS(4703),
    [sym_primitive_type] = ACTIONS(4703),
    [anon_sym_enum] = ACTIONS(4703),
    [anon_sym_struct] = ACTIONS(4703),
    [anon_sym_union] = ACTIONS(4703),
    [anon_sym_if] = ACTIONS(4703),
    [anon_sym_else] = ACTIONS(4703),
    [anon_sym_switch] = ACTIONS(4703),
    [anon_sym_case] = ACTIONS(4703),
    [anon_sym_default] = ACTIONS(4703),
    [anon_sym_while] = ACTIONS(4703),
    [anon_sym_do] = ACTIONS(4703),
    [anon_sym_for] = ACTIONS(4703),
    [anon_sym_return] = ACTIONS(4703),
    [anon_sym_break] = ACTIONS(4703),
    [anon_sym_continue] = ACTIONS(4703),
    [anon_sym_goto] = ACTIONS(4703),
    [anon_sym_AMP] = ACTIONS(4701),
    [anon_sym_BANG] = ACTIONS(4701),
    [anon_sym_TILDE] = ACTIONS(4701),
    [anon_sym_PLUS] = ACTIONS(4703),
    [anon_sym_DASH] = ACTIONS(4703),
    [anon_sym_DASH_DASH] = ACTIONS(4701),
    [anon_sym_PLUS_PLUS] = ACTIONS(4701),
    [anon_sym_sizeof] = ACTIONS(4703),
    [sym_number_literal] = ACTIONS(4701),
    [sym_char_literal] = ACTIONS(4701),
    [sym_string_literal] = ACTIONS(4701),
    [sym_true] = ACTIONS(4703),
    [sym_false] = ACTIONS(4703),
    [sym_null] = ACTIONS(4703),
    [sym_identifier] = ACTIONS(4703),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(4703),
    [sym_auto] = ACTIONS(4703),
    [anon_sym_typename] = ACTIONS(4703),
    [anon_sym_new] = ACTIONS(4703),
    [anon_sym_COLON_COLON] = ACTIONS(4701),
    [anon_sym_delete] = ACTIONS(4703),
    [sym_nullptr] = ACTIONS(4703),
  },
  [2769] = {
    [sym_raw_string_literal] = ACTIONS(4710),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(4712),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(4712),
    [anon_sym_LPAREN] = ACTIONS(4710),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(4712),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(4712),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(4712),
    [sym_preproc_directive] = ACTIONS(4712),
    [anon_sym_SEMI] = ACTIONS(4710),
    [anon_sym_typedef] = ACTIONS(4712),
    [anon_sym_extern] = ACTIONS(4712),
    [anon_sym_LBRACE] = ACTIONS(4710),
    [anon_sym_RBRACE] = ACTIONS(4710),
    [anon_sym_STAR] = ACTIONS(4710),
    [anon_sym_LBRACK] = ACTIONS(4710),
    [anon_sym_static] = ACTIONS(4712),
    [anon_sym_register] = ACTIONS(4712),
    [anon_sym_inline] = ACTIONS(4712),
    [anon_sym_const] = ACTIONS(4712),
    [anon_sym_restrict] = ACTIONS(4712),
    [anon_sym_volatile] = ACTIONS(4712),
    [anon_sym__Atomic] = ACTIONS(4712),
    [anon_sym_mutable] = ACTIONS(4712),
    [anon_sym_explicit] = ACTIONS(4712),
    [anon_sym_constexpr] = ACTIONS(4712),
    [anon_sym_unsigned] = ACTIONS(4712),
    [anon_sym_long] = ACTIONS(4712),
    [anon_sym_short] = ACTIONS(4712),
    [sym_primitive_type] = ACTIONS(4712),
    [anon_sym_enum] = ACTIONS(4712),
    [anon_sym_struct] = ACTIONS(4712),
    [anon_sym_union] = ACTIONS(4712),
    [anon_sym_if] = ACTIONS(4712),
    [anon_sym_else] = ACTIONS(4712),
    [anon_sym_switch] = ACTIONS(4712),
    [anon_sym_case] = ACTIONS(4712),
    [anon_sym_default] = ACTIONS(4712),
    [anon_sym_while] = ACTIONS(4712),
    [anon_sym_do] = ACTIONS(4712),
    [anon_sym_for] = ACTIONS(4712),
    [anon_sym_return] = ACTIONS(4712),
    [anon_sym_break] = ACTIONS(4712),
    [anon_sym_continue] = ACTIONS(4712),
    [anon_sym_goto] = ACTIONS(4712),
    [anon_sym_AMP] = ACTIONS(4710),
    [anon_sym_BANG] = ACTIONS(4710),
    [anon_sym_TILDE] = ACTIONS(4710),
    [anon_sym_PLUS] = ACTIONS(4712),
    [anon_sym_DASH] = ACTIONS(4712),
    [anon_sym_DASH_DASH] = ACTIONS(4710),
    [anon_sym_PLUS_PLUS] = ACTIONS(4710),
    [anon_sym_sizeof] = ACTIONS(4712),
    [sym_number_literal] = ACTIONS(4710),
    [sym_char_literal] = ACTIONS(4710),
    [sym_string_literal] = ACTIONS(4710),
    [sym_true] = ACTIONS(4712),
    [sym_false] = ACTIONS(4712),
    [sym_null] = ACTIONS(4712),
    [sym_identifier] = ACTIONS(4712),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(4712),
    [sym_auto] = ACTIONS(4712),
    [anon_sym_typename] = ACTIONS(4712),
    [anon_sym_new] = ACTIONS(4712),
    [anon_sym_COLON_COLON] = ACTIONS(4710),
    [anon_sym_delete] = ACTIONS(4712),
    [sym_nullptr] = ACTIONS(4712),
  },
  [2770] = {
    [sym_raw_string_literal] = ACTIONS(6864),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(6866),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(6866),
    [anon_sym_LPAREN] = ACTIONS(6864),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(6866),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(6866),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(6866),
    [sym_preproc_directive] = ACTIONS(6866),
    [anon_sym_SEMI] = ACTIONS(6864),
    [anon_sym_typedef] = ACTIONS(6866),
    [anon_sym_extern] = ACTIONS(6866),
    [anon_sym_LBRACE] = ACTIONS(6864),
    [anon_sym_RBRACE] = ACTIONS(6864),
    [anon_sym_STAR] = ACTIONS(6864),
    [anon_sym_LBRACK] = ACTIONS(6864),
    [anon_sym_static] = ACTIONS(6866),
    [anon_sym_register] = ACTIONS(6866),
    [anon_sym_inline] = ACTIONS(6866),
    [anon_sym_const] = ACTIONS(6866),
    [anon_sym_restrict] = ACTIONS(6866),
    [anon_sym_volatile] = ACTIONS(6866),
    [anon_sym__Atomic] = ACTIONS(6866),
    [anon_sym_mutable] = ACTIONS(6866),
    [anon_sym_explicit] = ACTIONS(6866),
    [anon_sym_constexpr] = ACTIONS(6866),
    [anon_sym_unsigned] = ACTIONS(6866),
    [anon_sym_long] = ACTIONS(6866),
    [anon_sym_short] = ACTIONS(6866),
    [sym_primitive_type] = ACTIONS(6866),
    [anon_sym_enum] = ACTIONS(6866),
    [anon_sym_struct] = ACTIONS(6866),
    [anon_sym_union] = ACTIONS(6866),
    [anon_sym_if] = ACTIONS(6866),
    [anon_sym_switch] = ACTIONS(6866),
    [anon_sym_case] = ACTIONS(6866),
    [anon_sym_default] = ACTIONS(6866),
    [anon_sym_while] = ACTIONS(6866),
    [anon_sym_do] = ACTIONS(6866),
    [anon_sym_for] = ACTIONS(6866),
    [anon_sym_return] = ACTIONS(6866),
    [anon_sym_break] = ACTIONS(6866),
    [anon_sym_continue] = ACTIONS(6866),
    [anon_sym_goto] = ACTIONS(6866),
    [anon_sym_AMP] = ACTIONS(6864),
    [anon_sym_BANG] = ACTIONS(6864),
    [anon_sym_TILDE] = ACTIONS(6864),
    [anon_sym_PLUS] = ACTIONS(6866),
    [anon_sym_DASH] = ACTIONS(6866),
    [anon_sym_DASH_DASH] = ACTIONS(6864),
    [anon_sym_PLUS_PLUS] = ACTIONS(6864),
    [anon_sym_sizeof] = ACTIONS(6866),
    [sym_number_literal] = ACTIONS(6864),
    [sym_char_literal] = ACTIONS(6864),
    [sym_string_literal] = ACTIONS(6864),
    [sym_true] = ACTIONS(6866),
    [sym_false] = ACTIONS(6866),
    [sym_null] = ACTIONS(6866),
    [sym_identifier] = ACTIONS(6866),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(6866),
    [sym_auto] = ACTIONS(6866),
    [anon_sym_typename] = ACTIONS(6866),
    [anon_sym_new] = ACTIONS(6866),
    [anon_sym_COLON_COLON] = ACTIONS(6864),
    [anon_sym_delete] = ACTIONS(6866),
    [sym_nullptr] = ACTIONS(6866),
  },
  [2771] = {
    [sym_argument_list] = STATE(802),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_RPAREN] = ACTIONS(5988),
    [anon_sym_STAR] = ACTIONS(4537),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_EQ] = ACTIONS(4539),
    [anon_sym_QMARK] = ACTIONS(4541),
    [anon_sym_STAR_EQ] = ACTIONS(4543),
    [anon_sym_SLASH_EQ] = ACTIONS(4543),
    [anon_sym_PERCENT_EQ] = ACTIONS(4543),
    [anon_sym_PLUS_EQ] = ACTIONS(4543),
    [anon_sym_DASH_EQ] = ACTIONS(4543),
    [anon_sym_LT_LT_EQ] = ACTIONS(4543),
    [anon_sym_GT_GT_EQ] = ACTIONS(4543),
    [anon_sym_AMP_EQ] = ACTIONS(4543),
    [anon_sym_CARET_EQ] = ACTIONS(4543),
    [anon_sym_PIPE_EQ] = ACTIONS(4543),
    [anon_sym_AMP] = ACTIONS(4545),
    [anon_sym_PIPE_PIPE] = ACTIONS(4547),
    [anon_sym_AMP_AMP] = ACTIONS(4549),
    [anon_sym_PIPE] = ACTIONS(4551),
    [anon_sym_CARET] = ACTIONS(4553),
    [anon_sym_EQ_EQ] = ACTIONS(4555),
    [anon_sym_BANG_EQ] = ACTIONS(4555),
    [anon_sym_LT] = ACTIONS(4557),
    [anon_sym_GT] = ACTIONS(4557),
    [anon_sym_LT_EQ] = ACTIONS(4559),
    [anon_sym_GT_EQ] = ACTIONS(4559),
    [anon_sym_LT_LT] = ACTIONS(4561),
    [anon_sym_GT_GT] = ACTIONS(4561),
    [anon_sym_PLUS] = ACTIONS(4563),
    [anon_sym_DASH] = ACTIONS(4563),
    [anon_sym_SLASH] = ACTIONS(4537),
    [anon_sym_PERCENT] = ACTIONS(4537),
    [anon_sym_DASH_DASH] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(1554),
    [anon_sym_DASH_GT] = ACTIONS(1554),
    [sym_comment] = ACTIONS(49),
  },
  [2772] = {
    [sym_compound_statement] = STATE(2898),
    [sym_labeled_statement] = STATE(2898),
    [sym_expression_statement] = STATE(2898),
    [sym_if_statement] = STATE(2898),
    [sym_switch_statement] = STATE(2898),
    [sym_case_statement] = STATE(2898),
    [sym_while_statement] = STATE(2898),
    [sym_do_statement] = STATE(2898),
    [sym_for_statement] = STATE(2898),
    [sym_return_statement] = STATE(2898),
    [sym_break_statement] = STATE(2898),
    [sym_continue_statement] = STATE(2898),
    [sym_goto_statement] = STATE(2898),
    [sym__expression] = STATE(413),
    [sym_comma_expression] = STATE(414),
    [sym_conditional_expression] = STATE(413),
    [sym_assignment_expression] = STATE(413),
    [sym_pointer_expression] = STATE(413),
    [sym_logical_expression] = STATE(413),
    [sym_bitwise_expression] = STATE(413),
    [sym_equality_expression] = STATE(413),
    [sym_relational_expression] = STATE(413),
    [sym_shift_expression] = STATE(413),
    [sym_math_expression] = STATE(413),
    [sym_cast_expression] = STATE(413),
    [sym_sizeof_expression] = STATE(413),
    [sym_subscript_expression] = STATE(413),
    [sym_call_expression] = STATE(413),
    [sym_field_expression] = STATE(413),
    [sym_compound_literal_expression] = STATE(413),
    [sym_parenthesized_expression] = STATE(413),
    [sym_concatenated_string] = STATE(413),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(413),
    [sym_for_range_loop] = STATE(2898),
    [sym_new_expression] = STATE(413),
    [sym_delete_expression] = STATE(413),
    [sym_lambda_expression] = STATE(413),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(620),
    [anon_sym_LPAREN] = ACTIONS(626),
    [anon_sym_SEMI] = ACTIONS(636),
    [anon_sym_LBRACE] = ACTIONS(640),
    [anon_sym_STAR] = ACTIONS(644),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_if] = ACTIONS(646),
    [anon_sym_switch] = ACTIONS(648),
    [anon_sym_case] = ACTIONS(650),
    [anon_sym_default] = ACTIONS(652),
    [anon_sym_while] = ACTIONS(654),
    [anon_sym_do] = ACTIONS(656),
    [anon_sym_for] = ACTIONS(658),
    [anon_sym_return] = ACTIONS(660),
    [anon_sym_break] = ACTIONS(662),
    [anon_sym_continue] = ACTIONS(664),
    [anon_sym_goto] = ACTIONS(666),
    [anon_sym_AMP] = ACTIONS(644),
    [anon_sym_BANG] = ACTIONS(668),
    [anon_sym_TILDE] = ACTIONS(670),
    [anon_sym_PLUS] = ACTIONS(672),
    [anon_sym_DASH] = ACTIONS(672),
    [anon_sym_DASH_DASH] = ACTIONS(674),
    [anon_sym_PLUS_PLUS] = ACTIONS(674),
    [anon_sym_sizeof] = ACTIONS(676),
    [sym_number_literal] = ACTIONS(620),
    [sym_char_literal] = ACTIONS(620),
    [sym_string_literal] = ACTIONS(678),
    [sym_true] = ACTIONS(680),
    [sym_false] = ACTIONS(680),
    [sym_null] = ACTIONS(680),
    [sym_identifier] = ACTIONS(3110),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1303),
    [anon_sym_delete] = ACTIONS(686),
    [sym_nullptr] = ACTIONS(680),
  },
  [2773] = {
    [sym__expression] = STATE(2899),
    [sym_conditional_expression] = STATE(2899),
    [sym_assignment_expression] = STATE(2899),
    [sym_pointer_expression] = STATE(2899),
    [sym_logical_expression] = STATE(2899),
    [sym_bitwise_expression] = STATE(2899),
    [sym_equality_expression] = STATE(2899),
    [sym_relational_expression] = STATE(2899),
    [sym_shift_expression] = STATE(2899),
    [sym_math_expression] = STATE(2899),
    [sym_cast_expression] = STATE(2899),
    [sym_sizeof_expression] = STATE(2899),
    [sym_subscript_expression] = STATE(2899),
    [sym_call_expression] = STATE(2899),
    [sym_field_expression] = STATE(2899),
    [sym_compound_literal_expression] = STATE(2899),
    [sym_parenthesized_expression] = STATE(2899),
    [sym_concatenated_string] = STATE(2899),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(2899),
    [sym_new_expression] = STATE(2899),
    [sym_delete_expression] = STATE(2899),
    [sym_lambda_expression] = STATE(2899),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(6868),
    [anon_sym_LPAREN] = ACTIONS(2943),
    [anon_sym_STAR] = ACTIONS(2945),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_AMP] = ACTIONS(2945),
    [anon_sym_BANG] = ACTIONS(2947),
    [anon_sym_TILDE] = ACTIONS(2949),
    [anon_sym_PLUS] = ACTIONS(2951),
    [anon_sym_DASH] = ACTIONS(2951),
    [anon_sym_DASH_DASH] = ACTIONS(2953),
    [anon_sym_PLUS_PLUS] = ACTIONS(2953),
    [anon_sym_sizeof] = ACTIONS(2955),
    [sym_number_literal] = ACTIONS(6868),
    [sym_char_literal] = ACTIONS(6868),
    [sym_string_literal] = ACTIONS(2957),
    [sym_true] = ACTIONS(6870),
    [sym_false] = ACTIONS(6870),
    [sym_null] = ACTIONS(6870),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(2961),
    [anon_sym_delete] = ACTIONS(2963),
    [sym_nullptr] = ACTIONS(6870),
  },
  [2774] = {
    [anon_sym_LPAREN] = ACTIONS(6872),
    [sym_comment] = ACTIONS(49),
  },
  [2775] = {
    [sym__expression] = STATE(2901),
    [sym_conditional_expression] = STATE(2901),
    [sym_assignment_expression] = STATE(2901),
    [sym_pointer_expression] = STATE(2901),
    [sym_logical_expression] = STATE(2901),
    [sym_bitwise_expression] = STATE(2901),
    [sym_equality_expression] = STATE(2901),
    [sym_relational_expression] = STATE(2901),
    [sym_shift_expression] = STATE(2901),
    [sym_math_expression] = STATE(2901),
    [sym_cast_expression] = STATE(2901),
    [sym_sizeof_expression] = STATE(2901),
    [sym_subscript_expression] = STATE(2901),
    [sym_call_expression] = STATE(2901),
    [sym_field_expression] = STATE(2901),
    [sym_compound_literal_expression] = STATE(2901),
    [sym_parenthesized_expression] = STATE(2901),
    [sym_concatenated_string] = STATE(2901),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(2901),
    [sym_new_expression] = STATE(2901),
    [sym_delete_expression] = STATE(2901),
    [sym_lambda_expression] = STATE(2901),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(6874),
    [anon_sym_LPAREN] = ACTIONS(2943),
    [anon_sym_STAR] = ACTIONS(2945),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_AMP] = ACTIONS(2945),
    [anon_sym_BANG] = ACTIONS(2947),
    [anon_sym_TILDE] = ACTIONS(2949),
    [anon_sym_PLUS] = ACTIONS(2951),
    [anon_sym_DASH] = ACTIONS(2951),
    [anon_sym_DASH_DASH] = ACTIONS(2953),
    [anon_sym_PLUS_PLUS] = ACTIONS(2953),
    [anon_sym_sizeof] = ACTIONS(2955),
    [sym_number_literal] = ACTIONS(6874),
    [sym_char_literal] = ACTIONS(6874),
    [sym_string_literal] = ACTIONS(2957),
    [sym_true] = ACTIONS(6876),
    [sym_false] = ACTIONS(6876),
    [sym_null] = ACTIONS(6876),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(2961),
    [anon_sym_delete] = ACTIONS(2963),
    [sym_nullptr] = ACTIONS(6876),
  },
  [2776] = {
    [sym_argument_list] = STATE(802),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_STAR] = ACTIONS(3003),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_EQ] = ACTIONS(3005),
    [anon_sym_COLON] = ACTIONS(6878),
    [anon_sym_QMARK] = ACTIONS(3009),
    [anon_sym_STAR_EQ] = ACTIONS(3011),
    [anon_sym_SLASH_EQ] = ACTIONS(3011),
    [anon_sym_PERCENT_EQ] = ACTIONS(3011),
    [anon_sym_PLUS_EQ] = ACTIONS(3011),
    [anon_sym_DASH_EQ] = ACTIONS(3011),
    [anon_sym_LT_LT_EQ] = ACTIONS(3011),
    [anon_sym_GT_GT_EQ] = ACTIONS(3011),
    [anon_sym_AMP_EQ] = ACTIONS(3011),
    [anon_sym_CARET_EQ] = ACTIONS(3011),
    [anon_sym_PIPE_EQ] = ACTIONS(3011),
    [anon_sym_AMP] = ACTIONS(3013),
    [anon_sym_PIPE_PIPE] = ACTIONS(3015),
    [anon_sym_AMP_AMP] = ACTIONS(3017),
    [anon_sym_PIPE] = ACTIONS(3019),
    [anon_sym_CARET] = ACTIONS(3021),
    [anon_sym_EQ_EQ] = ACTIONS(3023),
    [anon_sym_BANG_EQ] = ACTIONS(3023),
    [anon_sym_LT] = ACTIONS(3025),
    [anon_sym_GT] = ACTIONS(3025),
    [anon_sym_LT_EQ] = ACTIONS(3027),
    [anon_sym_GT_EQ] = ACTIONS(3027),
    [anon_sym_LT_LT] = ACTIONS(3029),
    [anon_sym_GT_GT] = ACTIONS(3029),
    [anon_sym_PLUS] = ACTIONS(3031),
    [anon_sym_DASH] = ACTIONS(3031),
    [anon_sym_SLASH] = ACTIONS(3003),
    [anon_sym_PERCENT] = ACTIONS(3003),
    [anon_sym_DASH_DASH] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(3033),
    [anon_sym_DASH_GT] = ACTIONS(3033),
    [sym_comment] = ACTIONS(49),
  },
  [2777] = {
    [sym_declaration] = STATE(2050),
    [sym_type_definition] = STATE(2050),
    [sym__declaration_specifiers] = STATE(2051),
    [sym_compound_statement] = STATE(2050),
    [sym_storage_class_specifier] = STATE(109),
    [sym_type_qualifier] = STATE(109),
    [sym__type_specifier] = STATE(105),
    [sym_sized_type_specifier] = STATE(105),
    [sym_enum_specifier] = STATE(105),
    [sym_struct_specifier] = STATE(105),
    [sym_union_specifier] = STATE(105),
    [sym_labeled_statement] = STATE(2050),
    [sym_expression_statement] = STATE(2050),
    [sym_if_statement] = STATE(2050),
    [sym_switch_statement] = STATE(2050),
    [sym_case_statement] = STATE(2050),
    [sym_while_statement] = STATE(2050),
    [sym_do_statement] = STATE(2050),
    [sym_for_statement] = STATE(2050),
    [sym_return_statement] = STATE(2050),
    [sym_break_statement] = STATE(2050),
    [sym_continue_statement] = STATE(2050),
    [sym_goto_statement] = STATE(2050),
    [sym__expression] = STATE(873),
    [sym_comma_expression] = STATE(874),
    [sym_conditional_expression] = STATE(873),
    [sym_assignment_expression] = STATE(873),
    [sym_pointer_expression] = STATE(873),
    [sym_logical_expression] = STATE(873),
    [sym_bitwise_expression] = STATE(873),
    [sym_equality_expression] = STATE(873),
    [sym_relational_expression] = STATE(873),
    [sym_shift_expression] = STATE(873),
    [sym_math_expression] = STATE(873),
    [sym_cast_expression] = STATE(873),
    [sym_sizeof_expression] = STATE(873),
    [sym_subscript_expression] = STATE(873),
    [sym_call_expression] = STATE(873),
    [sym_field_expression] = STATE(873),
    [sym_compound_literal_expression] = STATE(873),
    [sym_parenthesized_expression] = STATE(873),
    [sym_concatenated_string] = STATE(873),
    [sym_macro_type_specifier] = STATE(105),
    [sym_class_specifier] = STATE(105),
    [sym_dependent_type] = STATE(105),
    [sym_template_type] = STATE(1475),
    [sym_template_function] = STATE(873),
    [sym_for_range_loop] = STATE(2050),
    [sym_new_expression] = STATE(873),
    [sym_delete_expression] = STATE(873),
    [sym_lambda_expression] = STATE(873),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(416),
    [sym_scoped_namespace_identifier] = STATE(1476),
    [aux_sym__declaration_specifiers_repeat1] = STATE(109),
    [aux_sym_sized_type_specifier_repeat1] = STATE(110),
    [sym_raw_string_literal] = ACTIONS(1660),
    [anon_sym_LPAREN] = ACTIONS(626),
    [anon_sym_SEMI] = ACTIONS(1662),
    [anon_sym_typedef] = ACTIONS(4657),
    [anon_sym_extern] = ACTIONS(154),
    [anon_sym_LBRACE] = ACTIONS(1664),
    [anon_sym_STAR] = ACTIONS(644),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_static] = ACTIONS(154),
    [anon_sym_register] = ACTIONS(154),
    [anon_sym_inline] = ACTIONS(154),
    [anon_sym_const] = ACTIONS(158),
    [anon_sym_restrict] = ACTIONS(158),
    [anon_sym_volatile] = ACTIONS(158),
    [anon_sym__Atomic] = ACTIONS(158),
    [anon_sym_mutable] = ACTIONS(158),
    [anon_sym_explicit] = ACTIONS(158),
    [anon_sym_constexpr] = ACTIONS(158),
    [anon_sym_unsigned] = ACTIONS(160),
    [anon_sym_long] = ACTIONS(160),
    [anon_sym_short] = ACTIONS(160),
    [sym_primitive_type] = ACTIONS(162),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_union] = ACTIONS(39),
    [anon_sym_if] = ACTIONS(6297),
    [anon_sym_switch] = ACTIONS(6299),
    [anon_sym_case] = ACTIONS(6301),
    [anon_sym_default] = ACTIONS(6303),
    [anon_sym_while] = ACTIONS(6305),
    [anon_sym_do] = ACTIONS(1676),
    [anon_sym_for] = ACTIONS(6307),
    [anon_sym_return] = ACTIONS(1680),
    [anon_sym_break] = ACTIONS(1682),
    [anon_sym_continue] = ACTIONS(1684),
    [anon_sym_goto] = ACTIONS(1686),
    [anon_sym_AMP] = ACTIONS(644),
    [anon_sym_BANG] = ACTIONS(668),
    [anon_sym_TILDE] = ACTIONS(670),
    [anon_sym_PLUS] = ACTIONS(672),
    [anon_sym_DASH] = ACTIONS(672),
    [anon_sym_DASH_DASH] = ACTIONS(674),
    [anon_sym_PLUS_PLUS] = ACTIONS(674),
    [anon_sym_sizeof] = ACTIONS(676),
    [sym_number_literal] = ACTIONS(1660),
    [sym_char_literal] = ACTIONS(1660),
    [sym_string_literal] = ACTIONS(678),
    [sym_true] = ACTIONS(1688),
    [sym_false] = ACTIONS(1688),
    [sym_null] = ACTIONS(1688),
    [sym_identifier] = ACTIONS(6880),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(51),
    [sym_auto] = ACTIONS(162),
    [anon_sym_typename] = ACTIONS(172),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(3040),
    [anon_sym_delete] = ACTIONS(686),
    [sym_nullptr] = ACTIONS(1688),
  },
  [2778] = {
    [sym__expression] = STATE(2904),
    [sym_conditional_expression] = STATE(2904),
    [sym_assignment_expression] = STATE(2904),
    [sym_pointer_expression] = STATE(2904),
    [sym_logical_expression] = STATE(2904),
    [sym_bitwise_expression] = STATE(2904),
    [sym_equality_expression] = STATE(2904),
    [sym_relational_expression] = STATE(2904),
    [sym_shift_expression] = STATE(2904),
    [sym_math_expression] = STATE(2904),
    [sym_cast_expression] = STATE(2904),
    [sym_sizeof_expression] = STATE(2904),
    [sym_subscript_expression] = STATE(2904),
    [sym_call_expression] = STATE(2904),
    [sym_field_expression] = STATE(2904),
    [sym_compound_literal_expression] = STATE(2904),
    [sym_parenthesized_expression] = STATE(2904),
    [sym_concatenated_string] = STATE(2904),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(2904),
    [sym_new_expression] = STATE(2904),
    [sym_delete_expression] = STATE(2904),
    [sym_lambda_expression] = STATE(2904),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(6882),
    [anon_sym_LPAREN] = ACTIONS(2943),
    [anon_sym_STAR] = ACTIONS(2945),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_AMP] = ACTIONS(2945),
    [anon_sym_BANG] = ACTIONS(2947),
    [anon_sym_TILDE] = ACTIONS(2949),
    [anon_sym_PLUS] = ACTIONS(2951),
    [anon_sym_DASH] = ACTIONS(2951),
    [anon_sym_DASH_DASH] = ACTIONS(2953),
    [anon_sym_PLUS_PLUS] = ACTIONS(2953),
    [anon_sym_sizeof] = ACTIONS(2955),
    [sym_number_literal] = ACTIONS(6882),
    [sym_char_literal] = ACTIONS(6882),
    [sym_string_literal] = ACTIONS(2957),
    [sym_true] = ACTIONS(6884),
    [sym_false] = ACTIONS(6884),
    [sym_null] = ACTIONS(6884),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(2961),
    [anon_sym_delete] = ACTIONS(2963),
    [sym_nullptr] = ACTIONS(6884),
  },
  [2779] = {
    [sym_declaration] = STATE(2905),
    [sym__declaration_specifiers] = STATE(1500),
    [sym_storage_class_specifier] = STATE(109),
    [sym_type_qualifier] = STATE(109),
    [sym__type_specifier] = STATE(105),
    [sym_sized_type_specifier] = STATE(105),
    [sym_enum_specifier] = STATE(105),
    [sym_struct_specifier] = STATE(105),
    [sym_union_specifier] = STATE(105),
    [sym__expression] = STATE(2906),
    [sym_conditional_expression] = STATE(2906),
    [sym_assignment_expression] = STATE(2906),
    [sym_pointer_expression] = STATE(2906),
    [sym_logical_expression] = STATE(2906),
    [sym_bitwise_expression] = STATE(2906),
    [sym_equality_expression] = STATE(2906),
    [sym_relational_expression] = STATE(2906),
    [sym_shift_expression] = STATE(2906),
    [sym_math_expression] = STATE(2906),
    [sym_cast_expression] = STATE(2906),
    [sym_sizeof_expression] = STATE(2906),
    [sym_subscript_expression] = STATE(2906),
    [sym_call_expression] = STATE(2906),
    [sym_field_expression] = STATE(2906),
    [sym_compound_literal_expression] = STATE(2906),
    [sym_parenthesized_expression] = STATE(2906),
    [sym_concatenated_string] = STATE(2906),
    [sym_macro_type_specifier] = STATE(105),
    [sym_class_specifier] = STATE(105),
    [sym_dependent_type] = STATE(105),
    [sym_template_type] = STATE(1475),
    [sym_template_function] = STATE(2906),
    [sym_for_range_declaration] = STATE(2907),
    [sym_new_expression] = STATE(2906),
    [sym_delete_expression] = STATE(2906),
    [sym_lambda_expression] = STATE(2906),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(416),
    [sym_scoped_namespace_identifier] = STATE(1476),
    [aux_sym__declaration_specifiers_repeat1] = STATE(109),
    [aux_sym_sized_type_specifier_repeat1] = STATE(110),
    [sym_raw_string_literal] = ACTIONS(6886),
    [anon_sym_LPAREN] = ACTIONS(1347),
    [anon_sym_SEMI] = ACTIONS(6888),
    [anon_sym_extern] = ACTIONS(154),
    [anon_sym_STAR] = ACTIONS(1349),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_static] = ACTIONS(154),
    [anon_sym_register] = ACTIONS(154),
    [anon_sym_inline] = ACTIONS(154),
    [anon_sym_const] = ACTIONS(158),
    [anon_sym_restrict] = ACTIONS(158),
    [anon_sym_volatile] = ACTIONS(158),
    [anon_sym__Atomic] = ACTIONS(158),
    [anon_sym_mutable] = ACTIONS(158),
    [anon_sym_explicit] = ACTIONS(158),
    [anon_sym_constexpr] = ACTIONS(158),
    [anon_sym_unsigned] = ACTIONS(160),
    [anon_sym_long] = ACTIONS(160),
    [anon_sym_short] = ACTIONS(160),
    [sym_primitive_type] = ACTIONS(162),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_union] = ACTIONS(39),
    [anon_sym_AMP] = ACTIONS(1349),
    [anon_sym_BANG] = ACTIONS(1351),
    [anon_sym_TILDE] = ACTIONS(1353),
    [anon_sym_PLUS] = ACTIONS(1355),
    [anon_sym_DASH] = ACTIONS(1355),
    [anon_sym_DASH_DASH] = ACTIONS(1357),
    [anon_sym_PLUS_PLUS] = ACTIONS(1357),
    [anon_sym_sizeof] = ACTIONS(1359),
    [sym_number_literal] = ACTIONS(6886),
    [sym_char_literal] = ACTIONS(6886),
    [sym_string_literal] = ACTIONS(1361),
    [sym_true] = ACTIONS(6890),
    [sym_false] = ACTIONS(6890),
    [sym_null] = ACTIONS(6890),
    [sym_identifier] = ACTIONS(3088),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(51),
    [sym_auto] = ACTIONS(162),
    [anon_sym_typename] = ACTIONS(172),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(3090),
    [anon_sym_delete] = ACTIONS(1367),
    [sym_nullptr] = ACTIONS(6890),
  },
  [2780] = {
    [sym_compound_statement] = STATE(2059),
    [sym_labeled_statement] = STATE(2059),
    [sym_expression_statement] = STATE(2059),
    [sym_if_statement] = STATE(2059),
    [sym_switch_statement] = STATE(2059),
    [sym_case_statement] = STATE(2059),
    [sym_while_statement] = STATE(2059),
    [sym_do_statement] = STATE(2059),
    [sym_for_statement] = STATE(2059),
    [sym_return_statement] = STATE(2059),
    [sym_break_statement] = STATE(2059),
    [sym_continue_statement] = STATE(2059),
    [sym_goto_statement] = STATE(2059),
    [sym__expression] = STATE(873),
    [sym_comma_expression] = STATE(874),
    [sym_conditional_expression] = STATE(873),
    [sym_assignment_expression] = STATE(873),
    [sym_pointer_expression] = STATE(873),
    [sym_logical_expression] = STATE(873),
    [sym_bitwise_expression] = STATE(873),
    [sym_equality_expression] = STATE(873),
    [sym_relational_expression] = STATE(873),
    [sym_shift_expression] = STATE(873),
    [sym_math_expression] = STATE(873),
    [sym_cast_expression] = STATE(873),
    [sym_sizeof_expression] = STATE(873),
    [sym_subscript_expression] = STATE(873),
    [sym_call_expression] = STATE(873),
    [sym_field_expression] = STATE(873),
    [sym_compound_literal_expression] = STATE(873),
    [sym_parenthesized_expression] = STATE(873),
    [sym_concatenated_string] = STATE(873),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(873),
    [sym_for_range_loop] = STATE(2059),
    [sym_new_expression] = STATE(873),
    [sym_delete_expression] = STATE(873),
    [sym_lambda_expression] = STATE(873),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(1660),
    [anon_sym_LPAREN] = ACTIONS(626),
    [anon_sym_SEMI] = ACTIONS(1662),
    [anon_sym_LBRACE] = ACTIONS(1664),
    [anon_sym_STAR] = ACTIONS(644),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_if] = ACTIONS(6297),
    [anon_sym_switch] = ACTIONS(6299),
    [anon_sym_case] = ACTIONS(6301),
    [anon_sym_default] = ACTIONS(6303),
    [anon_sym_while] = ACTIONS(6305),
    [anon_sym_do] = ACTIONS(1676),
    [anon_sym_for] = ACTIONS(6307),
    [anon_sym_return] = ACTIONS(1680),
    [anon_sym_break] = ACTIONS(1682),
    [anon_sym_continue] = ACTIONS(1684),
    [anon_sym_goto] = ACTIONS(1686),
    [anon_sym_AMP] = ACTIONS(644),
    [anon_sym_BANG] = ACTIONS(668),
    [anon_sym_TILDE] = ACTIONS(670),
    [anon_sym_PLUS] = ACTIONS(672),
    [anon_sym_DASH] = ACTIONS(672),
    [anon_sym_DASH_DASH] = ACTIONS(674),
    [anon_sym_PLUS_PLUS] = ACTIONS(674),
    [anon_sym_sizeof] = ACTIONS(676),
    [sym_number_literal] = ACTIONS(1660),
    [sym_char_literal] = ACTIONS(1660),
    [sym_string_literal] = ACTIONS(678),
    [sym_true] = ACTIONS(1688),
    [sym_false] = ACTIONS(1688),
    [sym_null] = ACTIONS(1688),
    [sym_identifier] = ACTIONS(6309),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1303),
    [anon_sym_delete] = ACTIONS(686),
    [sym_nullptr] = ACTIONS(1688),
  },
  [2781] = {
    [sym_compound_statement] = STATE(2908),
    [sym_labeled_statement] = STATE(2908),
    [sym_expression_statement] = STATE(2908),
    [sym_if_statement] = STATE(2908),
    [sym_switch_statement] = STATE(2908),
    [sym_case_statement] = STATE(2908),
    [sym_while_statement] = STATE(2908),
    [sym_do_statement] = STATE(2908),
    [sym_for_statement] = STATE(2908),
    [sym_return_statement] = STATE(2908),
    [sym_break_statement] = STATE(2908),
    [sym_continue_statement] = STATE(2908),
    [sym_goto_statement] = STATE(2908),
    [sym__expression] = STATE(873),
    [sym_comma_expression] = STATE(874),
    [sym_conditional_expression] = STATE(873),
    [sym_assignment_expression] = STATE(873),
    [sym_pointer_expression] = STATE(873),
    [sym_logical_expression] = STATE(873),
    [sym_bitwise_expression] = STATE(873),
    [sym_equality_expression] = STATE(873),
    [sym_relational_expression] = STATE(873),
    [sym_shift_expression] = STATE(873),
    [sym_math_expression] = STATE(873),
    [sym_cast_expression] = STATE(873),
    [sym_sizeof_expression] = STATE(873),
    [sym_subscript_expression] = STATE(873),
    [sym_call_expression] = STATE(873),
    [sym_field_expression] = STATE(873),
    [sym_compound_literal_expression] = STATE(873),
    [sym_parenthesized_expression] = STATE(873),
    [sym_concatenated_string] = STATE(873),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(873),
    [sym_for_range_loop] = STATE(2908),
    [sym_new_expression] = STATE(873),
    [sym_delete_expression] = STATE(873),
    [sym_lambda_expression] = STATE(873),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(1660),
    [anon_sym_LPAREN] = ACTIONS(626),
    [anon_sym_SEMI] = ACTIONS(1662),
    [anon_sym_LBRACE] = ACTIONS(1664),
    [anon_sym_STAR] = ACTIONS(644),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_if] = ACTIONS(1666),
    [anon_sym_switch] = ACTIONS(1668),
    [anon_sym_case] = ACTIONS(1670),
    [anon_sym_default] = ACTIONS(1672),
    [anon_sym_while] = ACTIONS(1674),
    [anon_sym_do] = ACTIONS(1676),
    [anon_sym_for] = ACTIONS(1678),
    [anon_sym_return] = ACTIONS(1680),
    [anon_sym_break] = ACTIONS(1682),
    [anon_sym_continue] = ACTIONS(1684),
    [anon_sym_goto] = ACTIONS(1686),
    [anon_sym_AMP] = ACTIONS(644),
    [anon_sym_BANG] = ACTIONS(668),
    [anon_sym_TILDE] = ACTIONS(670),
    [anon_sym_PLUS] = ACTIONS(672),
    [anon_sym_DASH] = ACTIONS(672),
    [anon_sym_DASH_DASH] = ACTIONS(674),
    [anon_sym_PLUS_PLUS] = ACTIONS(674),
    [anon_sym_sizeof] = ACTIONS(676),
    [sym_number_literal] = ACTIONS(1660),
    [sym_char_literal] = ACTIONS(1660),
    [sym_string_literal] = ACTIONS(678),
    [sym_true] = ACTIONS(1688),
    [sym_false] = ACTIONS(1688),
    [sym_null] = ACTIONS(1688),
    [sym_identifier] = ACTIONS(1690),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1303),
    [anon_sym_delete] = ACTIONS(686),
    [sym_nullptr] = ACTIONS(1688),
  },
  [2782] = {
    [anon_sym_else] = ACTIONS(6892),
    [anon_sym_while] = ACTIONS(6611),
    [sym_comment] = ACTIONS(49),
  },
  [2783] = {
    [anon_sym_else] = ACTIONS(1988),
    [anon_sym_while] = ACTIONS(1988),
    [sym_comment] = ACTIONS(49),
  },
  [2784] = {
    [sym_parameter_list] = STATE(513),
    [anon_sym_LPAREN] = ACTIONS(206),
    [anon_sym_SEMI] = ACTIONS(6894),
    [anon_sym_LBRACK] = ACTIONS(955),
    [sym_comment] = ACTIONS(49),
  },
  [2785] = {
    [anon_sym_else] = ACTIONS(2478),
    [anon_sym_while] = ACTIONS(2478),
    [sym_comment] = ACTIONS(49),
  },
  [2786] = {
    [anon_sym_else] = ACTIONS(6653),
    [anon_sym_while] = ACTIONS(6653),
    [sym_comment] = ACTIONS(49),
  },
  [2787] = {
    [anon_sym_else] = ACTIONS(6657),
    [anon_sym_while] = ACTIONS(6657),
    [sym_comment] = ACTIONS(49),
  },
  [2788] = {
    [sym_compound_statement] = STATE(2911),
    [sym_labeled_statement] = STATE(2911),
    [sym_expression_statement] = STATE(2911),
    [sym_if_statement] = STATE(2911),
    [sym_switch_statement] = STATE(2911),
    [sym_case_statement] = STATE(2911),
    [sym_while_statement] = STATE(2911),
    [sym_do_statement] = STATE(2911),
    [sym_for_statement] = STATE(2911),
    [sym_return_statement] = STATE(2911),
    [sym_break_statement] = STATE(2911),
    [sym_continue_statement] = STATE(2911),
    [sym_goto_statement] = STATE(2911),
    [sym__expression] = STATE(873),
    [sym_comma_expression] = STATE(874),
    [sym_conditional_expression] = STATE(873),
    [sym_assignment_expression] = STATE(873),
    [sym_pointer_expression] = STATE(873),
    [sym_logical_expression] = STATE(873),
    [sym_bitwise_expression] = STATE(873),
    [sym_equality_expression] = STATE(873),
    [sym_relational_expression] = STATE(873),
    [sym_shift_expression] = STATE(873),
    [sym_math_expression] = STATE(873),
    [sym_cast_expression] = STATE(873),
    [sym_sizeof_expression] = STATE(873),
    [sym_subscript_expression] = STATE(873),
    [sym_call_expression] = STATE(873),
    [sym_field_expression] = STATE(873),
    [sym_compound_literal_expression] = STATE(873),
    [sym_parenthesized_expression] = STATE(873),
    [sym_concatenated_string] = STATE(873),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(873),
    [sym_for_range_loop] = STATE(2911),
    [sym_new_expression] = STATE(873),
    [sym_delete_expression] = STATE(873),
    [sym_lambda_expression] = STATE(873),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(1660),
    [anon_sym_LPAREN] = ACTIONS(626),
    [anon_sym_SEMI] = ACTIONS(1662),
    [anon_sym_LBRACE] = ACTIONS(1664),
    [anon_sym_STAR] = ACTIONS(644),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_if] = ACTIONS(1666),
    [anon_sym_switch] = ACTIONS(1668),
    [anon_sym_case] = ACTIONS(1670),
    [anon_sym_default] = ACTIONS(1672),
    [anon_sym_while] = ACTIONS(1674),
    [anon_sym_do] = ACTIONS(1676),
    [anon_sym_for] = ACTIONS(1678),
    [anon_sym_return] = ACTIONS(1680),
    [anon_sym_break] = ACTIONS(1682),
    [anon_sym_continue] = ACTIONS(1684),
    [anon_sym_goto] = ACTIONS(1686),
    [anon_sym_AMP] = ACTIONS(644),
    [anon_sym_BANG] = ACTIONS(668),
    [anon_sym_TILDE] = ACTIONS(670),
    [anon_sym_PLUS] = ACTIONS(672),
    [anon_sym_DASH] = ACTIONS(672),
    [anon_sym_DASH_DASH] = ACTIONS(674),
    [anon_sym_PLUS_PLUS] = ACTIONS(674),
    [anon_sym_sizeof] = ACTIONS(676),
    [sym_number_literal] = ACTIONS(1660),
    [sym_char_literal] = ACTIONS(1660),
    [sym_string_literal] = ACTIONS(678),
    [sym_true] = ACTIONS(1688),
    [sym_false] = ACTIONS(1688),
    [sym_null] = ACTIONS(1688),
    [sym_identifier] = ACTIONS(1690),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1303),
    [anon_sym_delete] = ACTIONS(686),
    [sym_nullptr] = ACTIONS(1688),
  },
  [2789] = {
    [aux_sym_for_statement_repeat1] = STATE(2796),
    [anon_sym_COMMA] = ACTIONS(6339),
    [anon_sym_RPAREN] = ACTIONS(6896),
    [sym_comment] = ACTIONS(49),
  },
  [2790] = {
    [sym_argument_list] = STATE(802),
    [aux_sym_for_statement_repeat1] = STATE(2913),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_COMMA] = ACTIONS(6339),
    [anon_sym_RPAREN] = ACTIONS(6896),
    [anon_sym_STAR] = ACTIONS(2234),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_EQ] = ACTIONS(2236),
    [anon_sym_QMARK] = ACTIONS(2238),
    [anon_sym_STAR_EQ] = ACTIONS(2240),
    [anon_sym_SLASH_EQ] = ACTIONS(2240),
    [anon_sym_PERCENT_EQ] = ACTIONS(2240),
    [anon_sym_PLUS_EQ] = ACTIONS(2240),
    [anon_sym_DASH_EQ] = ACTIONS(2240),
    [anon_sym_LT_LT_EQ] = ACTIONS(2240),
    [anon_sym_GT_GT_EQ] = ACTIONS(2240),
    [anon_sym_AMP_EQ] = ACTIONS(2240),
    [anon_sym_CARET_EQ] = ACTIONS(2240),
    [anon_sym_PIPE_EQ] = ACTIONS(2240),
    [anon_sym_AMP] = ACTIONS(2242),
    [anon_sym_PIPE_PIPE] = ACTIONS(2244),
    [anon_sym_AMP_AMP] = ACTIONS(2246),
    [anon_sym_PIPE] = ACTIONS(2248),
    [anon_sym_CARET] = ACTIONS(2250),
    [anon_sym_EQ_EQ] = ACTIONS(2252),
    [anon_sym_BANG_EQ] = ACTIONS(2252),
    [anon_sym_LT] = ACTIONS(2254),
    [anon_sym_GT] = ACTIONS(2254),
    [anon_sym_LT_EQ] = ACTIONS(2256),
    [anon_sym_GT_EQ] = ACTIONS(2256),
    [anon_sym_LT_LT] = ACTIONS(2258),
    [anon_sym_GT_GT] = ACTIONS(2258),
    [anon_sym_PLUS] = ACTIONS(2260),
    [anon_sym_DASH] = ACTIONS(2260),
    [anon_sym_SLASH] = ACTIONS(2234),
    [anon_sym_PERCENT] = ACTIONS(2234),
    [anon_sym_DASH_DASH] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(1554),
    [anon_sym_DASH_GT] = ACTIONS(1554),
    [sym_comment] = ACTIONS(49),
  },
  [2791] = {
    [sym__expression] = STATE(2914),
    [sym_conditional_expression] = STATE(2914),
    [sym_assignment_expression] = STATE(2914),
    [sym_pointer_expression] = STATE(2914),
    [sym_logical_expression] = STATE(2914),
    [sym_bitwise_expression] = STATE(2914),
    [sym_equality_expression] = STATE(2914),
    [sym_relational_expression] = STATE(2914),
    [sym_shift_expression] = STATE(2914),
    [sym_math_expression] = STATE(2914),
    [sym_cast_expression] = STATE(2914),
    [sym_sizeof_expression] = STATE(2914),
    [sym_subscript_expression] = STATE(2914),
    [sym_call_expression] = STATE(2914),
    [sym_field_expression] = STATE(2914),
    [sym_compound_literal_expression] = STATE(2914),
    [sym_parenthesized_expression] = STATE(2914),
    [sym_concatenated_string] = STATE(2914),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(2914),
    [sym_new_expression] = STATE(2914),
    [sym_delete_expression] = STATE(2914),
    [sym_lambda_expression] = STATE(2914),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(6898),
    [anon_sym_LPAREN] = ACTIONS(1087),
    [anon_sym_RPAREN] = ACTIONS(6896),
    [anon_sym_STAR] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_AMP] = ACTIONS(1089),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1093),
    [anon_sym_PLUS] = ACTIONS(1095),
    [anon_sym_DASH] = ACTIONS(1095),
    [anon_sym_DASH_DASH] = ACTIONS(1097),
    [anon_sym_PLUS_PLUS] = ACTIONS(1097),
    [anon_sym_sizeof] = ACTIONS(1099),
    [sym_number_literal] = ACTIONS(6898),
    [sym_char_literal] = ACTIONS(6898),
    [sym_string_literal] = ACTIONS(1101),
    [sym_true] = ACTIONS(6900),
    [sym_false] = ACTIONS(6900),
    [sym_null] = ACTIONS(6900),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_delete] = ACTIONS(1109),
    [sym_nullptr] = ACTIONS(6900),
  },
  [2792] = {
    [sym_compound_statement] = STATE(2915),
    [sym_labeled_statement] = STATE(2915),
    [sym_expression_statement] = STATE(2915),
    [sym_if_statement] = STATE(2915),
    [sym_switch_statement] = STATE(2915),
    [sym_case_statement] = STATE(2915),
    [sym_while_statement] = STATE(2915),
    [sym_do_statement] = STATE(2915),
    [sym_for_statement] = STATE(2915),
    [sym_return_statement] = STATE(2915),
    [sym_break_statement] = STATE(2915),
    [sym_continue_statement] = STATE(2915),
    [sym_goto_statement] = STATE(2915),
    [sym__expression] = STATE(873),
    [sym_comma_expression] = STATE(874),
    [sym_conditional_expression] = STATE(873),
    [sym_assignment_expression] = STATE(873),
    [sym_pointer_expression] = STATE(873),
    [sym_logical_expression] = STATE(873),
    [sym_bitwise_expression] = STATE(873),
    [sym_equality_expression] = STATE(873),
    [sym_relational_expression] = STATE(873),
    [sym_shift_expression] = STATE(873),
    [sym_math_expression] = STATE(873),
    [sym_cast_expression] = STATE(873),
    [sym_sizeof_expression] = STATE(873),
    [sym_subscript_expression] = STATE(873),
    [sym_call_expression] = STATE(873),
    [sym_field_expression] = STATE(873),
    [sym_compound_literal_expression] = STATE(873),
    [sym_parenthesized_expression] = STATE(873),
    [sym_concatenated_string] = STATE(873),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(873),
    [sym_for_range_loop] = STATE(2915),
    [sym_new_expression] = STATE(873),
    [sym_delete_expression] = STATE(873),
    [sym_lambda_expression] = STATE(873),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(1660),
    [anon_sym_LPAREN] = ACTIONS(626),
    [anon_sym_SEMI] = ACTIONS(1662),
    [anon_sym_LBRACE] = ACTIONS(1664),
    [anon_sym_STAR] = ACTIONS(644),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_if] = ACTIONS(1666),
    [anon_sym_switch] = ACTIONS(1668),
    [anon_sym_case] = ACTIONS(1670),
    [anon_sym_default] = ACTIONS(1672),
    [anon_sym_while] = ACTIONS(1674),
    [anon_sym_do] = ACTIONS(1676),
    [anon_sym_for] = ACTIONS(1678),
    [anon_sym_return] = ACTIONS(1680),
    [anon_sym_break] = ACTIONS(1682),
    [anon_sym_continue] = ACTIONS(1684),
    [anon_sym_goto] = ACTIONS(1686),
    [anon_sym_AMP] = ACTIONS(644),
    [anon_sym_BANG] = ACTIONS(668),
    [anon_sym_TILDE] = ACTIONS(670),
    [anon_sym_PLUS] = ACTIONS(672),
    [anon_sym_DASH] = ACTIONS(672),
    [anon_sym_DASH_DASH] = ACTIONS(674),
    [anon_sym_PLUS_PLUS] = ACTIONS(674),
    [anon_sym_sizeof] = ACTIONS(676),
    [sym_number_literal] = ACTIONS(1660),
    [sym_char_literal] = ACTIONS(1660),
    [sym_string_literal] = ACTIONS(678),
    [sym_true] = ACTIONS(1688),
    [sym_false] = ACTIONS(1688),
    [sym_null] = ACTIONS(1688),
    [sym_identifier] = ACTIONS(1690),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1303),
    [anon_sym_delete] = ACTIONS(686),
    [sym_nullptr] = ACTIONS(1688),
  },
  [2793] = {
    [sym_argument_list] = STATE(802),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_COMMA] = ACTIONS(5193),
    [anon_sym_RPAREN] = ACTIONS(5193),
    [anon_sym_STAR] = ACTIONS(2234),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_EQ] = ACTIONS(2236),
    [anon_sym_QMARK] = ACTIONS(2238),
    [anon_sym_STAR_EQ] = ACTIONS(2240),
    [anon_sym_SLASH_EQ] = ACTIONS(2240),
    [anon_sym_PERCENT_EQ] = ACTIONS(2240),
    [anon_sym_PLUS_EQ] = ACTIONS(2240),
    [anon_sym_DASH_EQ] = ACTIONS(2240),
    [anon_sym_LT_LT_EQ] = ACTIONS(2240),
    [anon_sym_GT_GT_EQ] = ACTIONS(2240),
    [anon_sym_AMP_EQ] = ACTIONS(2240),
    [anon_sym_CARET_EQ] = ACTIONS(2240),
    [anon_sym_PIPE_EQ] = ACTIONS(2240),
    [anon_sym_AMP] = ACTIONS(2242),
    [anon_sym_PIPE_PIPE] = ACTIONS(2244),
    [anon_sym_AMP_AMP] = ACTIONS(2246),
    [anon_sym_PIPE] = ACTIONS(2248),
    [anon_sym_CARET] = ACTIONS(2250),
    [anon_sym_EQ_EQ] = ACTIONS(2252),
    [anon_sym_BANG_EQ] = ACTIONS(2252),
    [anon_sym_LT] = ACTIONS(2254),
    [anon_sym_GT] = ACTIONS(2254),
    [anon_sym_LT_EQ] = ACTIONS(2256),
    [anon_sym_GT_EQ] = ACTIONS(2256),
    [anon_sym_LT_LT] = ACTIONS(2258),
    [anon_sym_GT_GT] = ACTIONS(2258),
    [anon_sym_PLUS] = ACTIONS(2260),
    [anon_sym_DASH] = ACTIONS(2260),
    [anon_sym_SLASH] = ACTIONS(2234),
    [anon_sym_PERCENT] = ACTIONS(2234),
    [anon_sym_DASH_DASH] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(1554),
    [anon_sym_DASH_GT] = ACTIONS(1554),
    [sym_comment] = ACTIONS(49),
  },
  [2794] = {
    [sym_raw_string_literal] = ACTIONS(6902),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(6904),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(6904),
    [anon_sym_LPAREN] = ACTIONS(6902),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(6904),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(6904),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(6904),
    [sym_preproc_directive] = ACTIONS(6904),
    [anon_sym_SEMI] = ACTIONS(6902),
    [anon_sym_typedef] = ACTIONS(6904),
    [anon_sym_extern] = ACTIONS(6904),
    [anon_sym_LBRACE] = ACTIONS(6902),
    [anon_sym_RBRACE] = ACTIONS(6902),
    [anon_sym_STAR] = ACTIONS(6902),
    [anon_sym_LBRACK] = ACTIONS(6902),
    [anon_sym_static] = ACTIONS(6904),
    [anon_sym_register] = ACTIONS(6904),
    [anon_sym_inline] = ACTIONS(6904),
    [anon_sym_const] = ACTIONS(6904),
    [anon_sym_restrict] = ACTIONS(6904),
    [anon_sym_volatile] = ACTIONS(6904),
    [anon_sym__Atomic] = ACTIONS(6904),
    [anon_sym_mutable] = ACTIONS(6904),
    [anon_sym_explicit] = ACTIONS(6904),
    [anon_sym_constexpr] = ACTIONS(6904),
    [anon_sym_unsigned] = ACTIONS(6904),
    [anon_sym_long] = ACTIONS(6904),
    [anon_sym_short] = ACTIONS(6904),
    [sym_primitive_type] = ACTIONS(6904),
    [anon_sym_enum] = ACTIONS(6904),
    [anon_sym_struct] = ACTIONS(6904),
    [anon_sym_union] = ACTIONS(6904),
    [anon_sym_if] = ACTIONS(6904),
    [anon_sym_switch] = ACTIONS(6904),
    [anon_sym_case] = ACTIONS(6904),
    [anon_sym_default] = ACTIONS(6904),
    [anon_sym_while] = ACTIONS(6904),
    [anon_sym_do] = ACTIONS(6904),
    [anon_sym_for] = ACTIONS(6904),
    [anon_sym_return] = ACTIONS(6904),
    [anon_sym_break] = ACTIONS(6904),
    [anon_sym_continue] = ACTIONS(6904),
    [anon_sym_goto] = ACTIONS(6904),
    [anon_sym_AMP] = ACTIONS(6902),
    [anon_sym_BANG] = ACTIONS(6902),
    [anon_sym_TILDE] = ACTIONS(6902),
    [anon_sym_PLUS] = ACTIONS(6904),
    [anon_sym_DASH] = ACTIONS(6904),
    [anon_sym_DASH_DASH] = ACTIONS(6902),
    [anon_sym_PLUS_PLUS] = ACTIONS(6902),
    [anon_sym_sizeof] = ACTIONS(6904),
    [sym_number_literal] = ACTIONS(6902),
    [sym_char_literal] = ACTIONS(6902),
    [sym_string_literal] = ACTIONS(6902),
    [sym_true] = ACTIONS(6904),
    [sym_false] = ACTIONS(6904),
    [sym_null] = ACTIONS(6904),
    [sym_identifier] = ACTIONS(6904),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(6904),
    [sym_auto] = ACTIONS(6904),
    [anon_sym_typename] = ACTIONS(6904),
    [anon_sym_new] = ACTIONS(6904),
    [anon_sym_COLON_COLON] = ACTIONS(6902),
    [anon_sym_delete] = ACTIONS(6904),
    [sym_nullptr] = ACTIONS(6904),
  },
  [2795] = {
    [sym_compound_statement] = STATE(2916),
    [sym_labeled_statement] = STATE(2916),
    [sym_expression_statement] = STATE(2916),
    [sym_if_statement] = STATE(2916),
    [sym_switch_statement] = STATE(2916),
    [sym_case_statement] = STATE(2916),
    [sym_while_statement] = STATE(2916),
    [sym_do_statement] = STATE(2916),
    [sym_for_statement] = STATE(2916),
    [sym_return_statement] = STATE(2916),
    [sym_break_statement] = STATE(2916),
    [sym_continue_statement] = STATE(2916),
    [sym_goto_statement] = STATE(2916),
    [sym__expression] = STATE(413),
    [sym_comma_expression] = STATE(414),
    [sym_conditional_expression] = STATE(413),
    [sym_assignment_expression] = STATE(413),
    [sym_pointer_expression] = STATE(413),
    [sym_logical_expression] = STATE(413),
    [sym_bitwise_expression] = STATE(413),
    [sym_equality_expression] = STATE(413),
    [sym_relational_expression] = STATE(413),
    [sym_shift_expression] = STATE(413),
    [sym_math_expression] = STATE(413),
    [sym_cast_expression] = STATE(413),
    [sym_sizeof_expression] = STATE(413),
    [sym_subscript_expression] = STATE(413),
    [sym_call_expression] = STATE(413),
    [sym_field_expression] = STATE(413),
    [sym_compound_literal_expression] = STATE(413),
    [sym_parenthesized_expression] = STATE(413),
    [sym_concatenated_string] = STATE(413),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(413),
    [sym_for_range_loop] = STATE(2916),
    [sym_new_expression] = STATE(413),
    [sym_delete_expression] = STATE(413),
    [sym_lambda_expression] = STATE(413),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(620),
    [anon_sym_LPAREN] = ACTIONS(626),
    [anon_sym_SEMI] = ACTIONS(636),
    [anon_sym_LBRACE] = ACTIONS(640),
    [anon_sym_STAR] = ACTIONS(644),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_if] = ACTIONS(646),
    [anon_sym_switch] = ACTIONS(648),
    [anon_sym_case] = ACTIONS(650),
    [anon_sym_default] = ACTIONS(652),
    [anon_sym_while] = ACTIONS(654),
    [anon_sym_do] = ACTIONS(656),
    [anon_sym_for] = ACTIONS(658),
    [anon_sym_return] = ACTIONS(660),
    [anon_sym_break] = ACTIONS(662),
    [anon_sym_continue] = ACTIONS(664),
    [anon_sym_goto] = ACTIONS(666),
    [anon_sym_AMP] = ACTIONS(644),
    [anon_sym_BANG] = ACTIONS(668),
    [anon_sym_TILDE] = ACTIONS(670),
    [anon_sym_PLUS] = ACTIONS(672),
    [anon_sym_DASH] = ACTIONS(672),
    [anon_sym_DASH_DASH] = ACTIONS(674),
    [anon_sym_PLUS_PLUS] = ACTIONS(674),
    [anon_sym_sizeof] = ACTIONS(676),
    [sym_number_literal] = ACTIONS(620),
    [sym_char_literal] = ACTIONS(620),
    [sym_string_literal] = ACTIONS(678),
    [sym_true] = ACTIONS(680),
    [sym_false] = ACTIONS(680),
    [sym_null] = ACTIONS(680),
    [sym_identifier] = ACTIONS(3110),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1303),
    [anon_sym_delete] = ACTIONS(686),
    [sym_nullptr] = ACTIONS(680),
  },
  [2796] = {
    [aux_sym_for_statement_repeat1] = STATE(2796),
    [anon_sym_COMMA] = ACTIONS(6906),
    [anon_sym_RPAREN] = ACTIONS(5193),
    [sym_comment] = ACTIONS(49),
  },
  [2797] = {
    [aux_sym_for_statement_repeat1] = STATE(2796),
    [anon_sym_COMMA] = ACTIONS(6339),
    [anon_sym_RPAREN] = ACTIONS(6909),
    [sym_comment] = ACTIONS(49),
  },
  [2798] = {
    [sym__type_specifier] = STATE(1375),
    [sym_sized_type_specifier] = STATE(1375),
    [sym_enum_specifier] = STATE(1375),
    [sym_struct_specifier] = STATE(1375),
    [sym_union_specifier] = STATE(1375),
    [sym_macro_type_specifier] = STATE(1375),
    [sym_class_specifier] = STATE(1375),
    [sym_dependent_type] = STATE(1375),
    [sym_template_type] = STATE(825),
    [sym_scoped_type_identifier] = STATE(826),
    [sym_scoped_namespace_identifier] = STATE(827),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2800),
    [anon_sym_unsigned] = ACTIONS(6667),
    [anon_sym_long] = ACTIONS(6667),
    [anon_sym_short] = ACTIONS(6667),
    [sym_primitive_type] = ACTIONS(2837),
    [anon_sym_enum] = ACTIONS(1582),
    [anon_sym_struct] = ACTIONS(1584),
    [anon_sym_union] = ACTIONS(1586),
    [sym_identifier] = ACTIONS(1588),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(1590),
    [sym_auto] = ACTIONS(2837),
    [anon_sym_typename] = ACTIONS(6671),
    [anon_sym_COLON_COLON] = ACTIONS(1594),
  },
  [2799] = {
    [sym__abstract_declarator] = STATE(2920),
    [sym_abstract_pointer_declarator] = STATE(2920),
    [sym_abstract_function_declarator] = STATE(2920),
    [sym_abstract_array_declarator] = STATE(2920),
    [sym_parameter_list] = STATE(2921),
    [sym_abstract_reference_declarator] = STATE(2920),
    [anon_sym_LPAREN] = ACTIONS(1115),
    [anon_sym_COMMA] = ACTIONS(2841),
    [anon_sym_SEMI] = ACTIONS(2841),
    [anon_sym_LBRACE] = ACTIONS(2841),
    [anon_sym_STAR] = ACTIONS(6911),
    [anon_sym_LBRACK] = ACTIONS(1121),
    [anon_sym_EQ] = ACTIONS(2841),
    [anon_sym_const] = ACTIONS(2845),
    [anon_sym_restrict] = ACTIONS(2841),
    [anon_sym_volatile] = ACTIONS(2841),
    [anon_sym__Atomic] = ACTIONS(2841),
    [anon_sym_mutable] = ACTIONS(2841),
    [anon_sym_explicit] = ACTIONS(2841),
    [anon_sym_constexpr] = ACTIONS(2841),
    [anon_sym_COLON] = ACTIONS(2841),
    [anon_sym_AMP] = ACTIONS(6913),
    [anon_sym_AMP_AMP] = ACTIONS(6915),
    [anon_sym_DASH_GT] = ACTIONS(2841),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(2841),
  },
  [2800] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2922),
    [anon_sym_LPAREN] = ACTIONS(238),
    [anon_sym_COMMA] = ACTIONS(238),
    [anon_sym_SEMI] = ACTIONS(238),
    [anon_sym_LBRACE] = ACTIONS(238),
    [anon_sym_STAR] = ACTIONS(238),
    [anon_sym_LBRACK] = ACTIONS(238),
    [anon_sym_EQ] = ACTIONS(238),
    [anon_sym_const] = ACTIONS(240),
    [anon_sym_restrict] = ACTIONS(240),
    [anon_sym_volatile] = ACTIONS(240),
    [anon_sym__Atomic] = ACTIONS(240),
    [anon_sym_mutable] = ACTIONS(240),
    [anon_sym_explicit] = ACTIONS(240),
    [anon_sym_constexpr] = ACTIONS(240),
    [anon_sym_unsigned] = ACTIONS(6917),
    [anon_sym_long] = ACTIONS(6917),
    [anon_sym_short] = ACTIONS(6917),
    [sym_primitive_type] = ACTIONS(2855),
    [anon_sym_COLON] = ACTIONS(238),
    [anon_sym_AMP] = ACTIONS(240),
    [anon_sym_AMP_AMP] = ACTIONS(238),
    [anon_sym_DASH_GT] = ACTIONS(238),
    [sym_identifier] = ACTIONS(2857),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(240),
  },
  [2801] = {
    [sym_type_qualifier] = STATE(2801),
    [sym_trailing_return_type] = STATE(2801),
    [aux_sym_function_declarator_repeat1] = STATE(2801),
    [anon_sym_LPAREN] = ACTIONS(2859),
    [anon_sym_COMMA] = ACTIONS(2859),
    [anon_sym_SEMI] = ACTIONS(2859),
    [anon_sym_LBRACE] = ACTIONS(2859),
    [anon_sym_LBRACK] = ACTIONS(2859),
    [anon_sym_EQ] = ACTIONS(2859),
    [anon_sym_const] = ACTIONS(2861),
    [anon_sym_restrict] = ACTIONS(2864),
    [anon_sym_volatile] = ACTIONS(2864),
    [anon_sym__Atomic] = ACTIONS(2864),
    [anon_sym_mutable] = ACTIONS(2864),
    [anon_sym_explicit] = ACTIONS(2864),
    [anon_sym_constexpr] = ACTIONS(2864),
    [anon_sym_COLON] = ACTIONS(2859),
    [anon_sym_DASH_GT] = ACTIONS(6919),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(6922),
  },
  [2802] = {
    [sym_argument_list] = STATE(802),
    [aux_sym_for_statement_repeat1] = STATE(2923),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_COMMA] = ACTIONS(6339),
    [anon_sym_RPAREN] = ACTIONS(6909),
    [anon_sym_STAR] = ACTIONS(2234),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_EQ] = ACTIONS(2236),
    [anon_sym_QMARK] = ACTIONS(2238),
    [anon_sym_STAR_EQ] = ACTIONS(2240),
    [anon_sym_SLASH_EQ] = ACTIONS(2240),
    [anon_sym_PERCENT_EQ] = ACTIONS(2240),
    [anon_sym_PLUS_EQ] = ACTIONS(2240),
    [anon_sym_DASH_EQ] = ACTIONS(2240),
    [anon_sym_LT_LT_EQ] = ACTIONS(2240),
    [anon_sym_GT_GT_EQ] = ACTIONS(2240),
    [anon_sym_AMP_EQ] = ACTIONS(2240),
    [anon_sym_CARET_EQ] = ACTIONS(2240),
    [anon_sym_PIPE_EQ] = ACTIONS(2240),
    [anon_sym_AMP] = ACTIONS(2242),
    [anon_sym_PIPE_PIPE] = ACTIONS(2244),
    [anon_sym_AMP_AMP] = ACTIONS(2246),
    [anon_sym_PIPE] = ACTIONS(2248),
    [anon_sym_CARET] = ACTIONS(2250),
    [anon_sym_EQ_EQ] = ACTIONS(2252),
    [anon_sym_BANG_EQ] = ACTIONS(2252),
    [anon_sym_LT] = ACTIONS(2254),
    [anon_sym_GT] = ACTIONS(2254),
    [anon_sym_LT_EQ] = ACTIONS(2256),
    [anon_sym_GT_EQ] = ACTIONS(2256),
    [anon_sym_LT_LT] = ACTIONS(2258),
    [anon_sym_GT_GT] = ACTIONS(2258),
    [anon_sym_PLUS] = ACTIONS(2260),
    [anon_sym_DASH] = ACTIONS(2260),
    [anon_sym_SLASH] = ACTIONS(2234),
    [anon_sym_PERCENT] = ACTIONS(2234),
    [anon_sym_DASH_DASH] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(1554),
    [anon_sym_DASH_GT] = ACTIONS(1554),
    [sym_comment] = ACTIONS(49),
  },
  [2803] = {
    [sym_raw_string_literal] = ACTIONS(6925),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(6927),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(6927),
    [anon_sym_LPAREN] = ACTIONS(6925),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(6927),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(6927),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(6927),
    [sym_preproc_directive] = ACTIONS(6927),
    [anon_sym_SEMI] = ACTIONS(6925),
    [anon_sym_typedef] = ACTIONS(6927),
    [anon_sym_extern] = ACTIONS(6927),
    [anon_sym_LBRACE] = ACTIONS(6925),
    [anon_sym_RBRACE] = ACTIONS(6925),
    [anon_sym_STAR] = ACTIONS(6925),
    [anon_sym_LBRACK] = ACTIONS(6925),
    [anon_sym_static] = ACTIONS(6927),
    [anon_sym_register] = ACTIONS(6927),
    [anon_sym_inline] = ACTIONS(6927),
    [anon_sym_const] = ACTIONS(6927),
    [anon_sym_restrict] = ACTIONS(6927),
    [anon_sym_volatile] = ACTIONS(6927),
    [anon_sym__Atomic] = ACTIONS(6927),
    [anon_sym_mutable] = ACTIONS(6927),
    [anon_sym_explicit] = ACTIONS(6927),
    [anon_sym_constexpr] = ACTIONS(6927),
    [anon_sym_unsigned] = ACTIONS(6927),
    [anon_sym_long] = ACTIONS(6927),
    [anon_sym_short] = ACTIONS(6927),
    [sym_primitive_type] = ACTIONS(6927),
    [anon_sym_enum] = ACTIONS(6927),
    [anon_sym_struct] = ACTIONS(6927),
    [anon_sym_union] = ACTIONS(6927),
    [anon_sym_if] = ACTIONS(6927),
    [anon_sym_switch] = ACTIONS(6927),
    [anon_sym_case] = ACTIONS(6927),
    [anon_sym_default] = ACTIONS(6927),
    [anon_sym_while] = ACTIONS(6927),
    [anon_sym_do] = ACTIONS(6927),
    [anon_sym_for] = ACTIONS(6927),
    [anon_sym_return] = ACTIONS(6927),
    [anon_sym_break] = ACTIONS(6927),
    [anon_sym_continue] = ACTIONS(6927),
    [anon_sym_goto] = ACTIONS(6927),
    [anon_sym_AMP] = ACTIONS(6925),
    [anon_sym_BANG] = ACTIONS(6925),
    [anon_sym_TILDE] = ACTIONS(6925),
    [anon_sym_PLUS] = ACTIONS(6927),
    [anon_sym_DASH] = ACTIONS(6927),
    [anon_sym_DASH_DASH] = ACTIONS(6925),
    [anon_sym_PLUS_PLUS] = ACTIONS(6925),
    [anon_sym_sizeof] = ACTIONS(6927),
    [sym_number_literal] = ACTIONS(6925),
    [sym_char_literal] = ACTIONS(6925),
    [sym_string_literal] = ACTIONS(6925),
    [sym_true] = ACTIONS(6927),
    [sym_false] = ACTIONS(6927),
    [sym_null] = ACTIONS(6927),
    [sym_identifier] = ACTIONS(6927),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(6927),
    [sym_auto] = ACTIONS(6927),
    [anon_sym_typename] = ACTIONS(6927),
    [anon_sym_new] = ACTIONS(6927),
    [anon_sym_COLON_COLON] = ACTIONS(6925),
    [anon_sym_delete] = ACTIONS(6927),
    [sym_nullptr] = ACTIONS(6927),
  },
  [2804] = {
    [sym_field_declaration_list] = STATE(1901),
    [sym_base_class_clause] = STATE(1902),
    [anon_sym_LPAREN] = ACTIONS(406),
    [anon_sym_COMMA] = ACTIONS(406),
    [anon_sym_SEMI] = ACTIONS(406),
    [anon_sym_LBRACE] = ACTIONS(2829),
    [anon_sym_STAR] = ACTIONS(406),
    [anon_sym_LBRACK] = ACTIONS(406),
    [anon_sym_const] = ACTIONS(408),
    [anon_sym_restrict] = ACTIONS(406),
    [anon_sym_volatile] = ACTIONS(406),
    [anon_sym__Atomic] = ACTIONS(406),
    [anon_sym_mutable] = ACTIONS(406),
    [anon_sym_explicit] = ACTIONS(406),
    [anon_sym_constexpr] = ACTIONS(406),
    [anon_sym_COLON] = ACTIONS(406),
    [anon_sym_AMP] = ACTIONS(408),
    [anon_sym_AMP_AMP] = ACTIONS(406),
    [anon_sym_DASH_GT] = ACTIONS(406),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(406),
  },
  [2805] = {
    [sym_field_declaration_list] = STATE(1903),
    [sym_base_class_clause] = STATE(1904),
    [anon_sym_LPAREN] = ACTIONS(416),
    [anon_sym_COMMA] = ACTIONS(416),
    [anon_sym_SEMI] = ACTIONS(416),
    [anon_sym_LBRACE] = ACTIONS(2829),
    [anon_sym_STAR] = ACTIONS(416),
    [anon_sym_LBRACK] = ACTIONS(416),
    [anon_sym_const] = ACTIONS(418),
    [anon_sym_restrict] = ACTIONS(416),
    [anon_sym_volatile] = ACTIONS(416),
    [anon_sym__Atomic] = ACTIONS(416),
    [anon_sym_mutable] = ACTIONS(416),
    [anon_sym_explicit] = ACTIONS(416),
    [anon_sym_constexpr] = ACTIONS(416),
    [anon_sym_COLON] = ACTIONS(416),
    [anon_sym_AMP] = ACTIONS(418),
    [anon_sym_AMP_AMP] = ACTIONS(416),
    [anon_sym_DASH_GT] = ACTIONS(416),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(416),
  },
  [2806] = {
    [sym_field_declaration_list] = STATE(1908),
    [sym_base_class_clause] = STATE(1909),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_COMMA] = ACTIONS(451),
    [anon_sym_SEMI] = ACTIONS(451),
    [anon_sym_LBRACE] = ACTIONS(2829),
    [anon_sym_STAR] = ACTIONS(451),
    [anon_sym_LBRACK] = ACTIONS(451),
    [anon_sym_const] = ACTIONS(453),
    [anon_sym_restrict] = ACTIONS(451),
    [anon_sym_volatile] = ACTIONS(451),
    [anon_sym__Atomic] = ACTIONS(451),
    [anon_sym_mutable] = ACTIONS(451),
    [anon_sym_explicit] = ACTIONS(451),
    [anon_sym_constexpr] = ACTIONS(451),
    [anon_sym_COLON] = ACTIONS(451),
    [anon_sym_AMP] = ACTIONS(453),
    [anon_sym_AMP_AMP] = ACTIONS(451),
    [anon_sym_DASH_GT] = ACTIONS(451),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(451),
  },
  [2807] = {
    [sym__abstract_declarator] = STATE(2924),
    [sym_abstract_pointer_declarator] = STATE(2924),
    [sym_abstract_function_declarator] = STATE(2924),
    [sym_abstract_array_declarator] = STATE(2924),
    [sym_parameter_list] = STATE(2810),
    [sym_abstract_reference_declarator] = STATE(2924),
    [anon_sym_LPAREN] = ACTIONS(1115),
    [anon_sym_COMMA] = ACTIONS(2270),
    [anon_sym_SEMI] = ACTIONS(2270),
    [anon_sym_STAR] = ACTIONS(6679),
    [anon_sym_LBRACK] = ACTIONS(1121),
    [anon_sym_const] = ACTIONS(4360),
    [anon_sym_restrict] = ACTIONS(2270),
    [anon_sym_volatile] = ACTIONS(2270),
    [anon_sym__Atomic] = ACTIONS(2270),
    [anon_sym_mutable] = ACTIONS(2270),
    [anon_sym_explicit] = ACTIONS(2270),
    [anon_sym_constexpr] = ACTIONS(2270),
    [anon_sym_COLON] = ACTIONS(2270),
    [anon_sym_AMP] = ACTIONS(6681),
    [anon_sym_AMP_AMP] = ACTIONS(6683),
    [anon_sym_DASH_GT] = ACTIONS(2270),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(2270),
  },
  [2808] = {
    [sym__abstract_declarator] = STATE(2925),
    [sym_abstract_pointer_declarator] = STATE(2925),
    [sym_abstract_function_declarator] = STATE(2925),
    [sym_abstract_array_declarator] = STATE(2925),
    [sym_parameter_list] = STATE(2810),
    [sym_abstract_reference_declarator] = STATE(2925),
    [anon_sym_LPAREN] = ACTIONS(1115),
    [anon_sym_COMMA] = ACTIONS(2278),
    [anon_sym_SEMI] = ACTIONS(2278),
    [anon_sym_STAR] = ACTIONS(6679),
    [anon_sym_LBRACK] = ACTIONS(1121),
    [anon_sym_const] = ACTIONS(4362),
    [anon_sym_restrict] = ACTIONS(2278),
    [anon_sym_volatile] = ACTIONS(2278),
    [anon_sym__Atomic] = ACTIONS(2278),
    [anon_sym_mutable] = ACTIONS(2278),
    [anon_sym_explicit] = ACTIONS(2278),
    [anon_sym_constexpr] = ACTIONS(2278),
    [anon_sym_COLON] = ACTIONS(2278),
    [anon_sym_AMP] = ACTIONS(6681),
    [anon_sym_AMP_AMP] = ACTIONS(6683),
    [anon_sym_DASH_GT] = ACTIONS(2278),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(2278),
  },
  [2809] = {
    [sym_parameter_list] = STATE(2926),
    [anon_sym_LPAREN] = ACTIONS(206),
    [anon_sym_COMMA] = ACTIONS(4364),
    [anon_sym_SEMI] = ACTIONS(4364),
    [anon_sym_LBRACK] = ACTIONS(2282),
    [anon_sym_const] = ACTIONS(4366),
    [anon_sym_restrict] = ACTIONS(4364),
    [anon_sym_volatile] = ACTIONS(4364),
    [anon_sym__Atomic] = ACTIONS(4364),
    [anon_sym_mutable] = ACTIONS(4364),
    [anon_sym_explicit] = ACTIONS(4364),
    [anon_sym_constexpr] = ACTIONS(4364),
    [anon_sym_COLON] = ACTIONS(4364),
    [anon_sym_DASH_GT] = ACTIONS(4364),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(4364),
  },
  [2810] = {
    [sym_type_qualifier] = STATE(2927),
    [sym_trailing_return_type] = STATE(1129),
    [aux_sym_abstract_function_declarator_repeat1] = STATE(2927),
    [anon_sym_LPAREN] = ACTIONS(2284),
    [anon_sym_COMMA] = ACTIONS(2284),
    [anon_sym_SEMI] = ACTIONS(2284),
    [anon_sym_LBRACK] = ACTIONS(2284),
    [anon_sym_const] = ACTIONS(4368),
    [anon_sym_restrict] = ACTIONS(2284),
    [anon_sym_volatile] = ACTIONS(2284),
    [anon_sym__Atomic] = ACTIONS(2284),
    [anon_sym_mutable] = ACTIONS(2284),
    [anon_sym_explicit] = ACTIONS(2284),
    [anon_sym_constexpr] = ACTIONS(2284),
    [anon_sym_COLON] = ACTIONS(2284),
    [anon_sym_DASH_GT] = ACTIONS(2284),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(2284),
  },
  [2811] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2811),
    [anon_sym_LPAREN] = ACTIONS(816),
    [anon_sym_COMMA] = ACTIONS(816),
    [anon_sym_SEMI] = ACTIONS(816),
    [anon_sym_STAR] = ACTIONS(816),
    [anon_sym_LBRACK] = ACTIONS(816),
    [anon_sym_const] = ACTIONS(818),
    [anon_sym_restrict] = ACTIONS(818),
    [anon_sym_volatile] = ACTIONS(818),
    [anon_sym__Atomic] = ACTIONS(818),
    [anon_sym_mutable] = ACTIONS(818),
    [anon_sym_explicit] = ACTIONS(818),
    [anon_sym_constexpr] = ACTIONS(818),
    [anon_sym_unsigned] = ACTIONS(6929),
    [anon_sym_long] = ACTIONS(6929),
    [anon_sym_short] = ACTIONS(6929),
    [sym_primitive_type] = ACTIONS(818),
    [anon_sym_COLON] = ACTIONS(816),
    [anon_sym_AMP] = ACTIONS(818),
    [anon_sym_AMP_AMP] = ACTIONS(816),
    [anon_sym_DASH_GT] = ACTIONS(816),
    [sym_identifier] = ACTIONS(818),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(818),
  },
  [2812] = {
    [sym_type_qualifier] = STATE(2813),
    [sym_trailing_return_type] = STATE(2168),
    [aux_sym_abstract_function_declarator_repeat1] = STATE(2813),
    [anon_sym_LPAREN] = ACTIONS(4998),
    [anon_sym_COMMA] = ACTIONS(4998),
    [anon_sym_SEMI] = ACTIONS(4998),
    [anon_sym_LBRACE] = ACTIONS(4998),
    [anon_sym_LBRACK] = ACTIONS(4998),
    [anon_sym_const] = ACTIONS(612),
    [anon_sym_restrict] = ACTIONS(614),
    [anon_sym_volatile] = ACTIONS(614),
    [anon_sym__Atomic] = ACTIONS(614),
    [anon_sym_mutable] = ACTIONS(614),
    [anon_sym_explicit] = ACTIONS(614),
    [anon_sym_constexpr] = ACTIONS(614),
    [anon_sym_COLON] = ACTIONS(4998),
    [anon_sym_DASH_GT] = ACTIONS(3647),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(6693),
  },
  [2813] = {
    [sym_type_qualifier] = STATE(2813),
    [aux_sym_abstract_function_declarator_repeat1] = STATE(2813),
    [anon_sym_LPAREN] = ACTIONS(5002),
    [anon_sym_COMMA] = ACTIONS(5002),
    [anon_sym_SEMI] = ACTIONS(5002),
    [anon_sym_LBRACE] = ACTIONS(5002),
    [anon_sym_LBRACK] = ACTIONS(5002),
    [anon_sym_const] = ACTIONS(5004),
    [anon_sym_restrict] = ACTIONS(5007),
    [anon_sym_volatile] = ACTIONS(5007),
    [anon_sym__Atomic] = ACTIONS(5007),
    [anon_sym_mutable] = ACTIONS(5007),
    [anon_sym_explicit] = ACTIONS(5007),
    [anon_sym_constexpr] = ACTIONS(5007),
    [anon_sym_COLON] = ACTIONS(5002),
    [anon_sym_DASH_GT] = ACTIONS(5002),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(6932),
  },
  [2814] = {
    [sym_argument_list] = STATE(802),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_COMMA] = ACTIONS(5984),
    [anon_sym_STAR] = ACTIONS(5039),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_EQ] = ACTIONS(5986),
    [anon_sym_QMARK] = ACTIONS(5984),
    [anon_sym_STAR_EQ] = ACTIONS(5984),
    [anon_sym_SLASH_EQ] = ACTIONS(5984),
    [anon_sym_PERCENT_EQ] = ACTIONS(5984),
    [anon_sym_PLUS_EQ] = ACTIONS(5984),
    [anon_sym_DASH_EQ] = ACTIONS(5984),
    [anon_sym_LT_LT_EQ] = ACTIONS(5984),
    [anon_sym_GT_GT_EQ] = ACTIONS(5984),
    [anon_sym_AMP_EQ] = ACTIONS(5984),
    [anon_sym_CARET_EQ] = ACTIONS(5984),
    [anon_sym_PIPE_EQ] = ACTIONS(5984),
    [anon_sym_AMP] = ACTIONS(5047),
    [anon_sym_PIPE_PIPE] = ACTIONS(5049),
    [anon_sym_AMP_AMP] = ACTIONS(5051),
    [anon_sym_PIPE] = ACTIONS(5053),
    [anon_sym_CARET] = ACTIONS(5055),
    [anon_sym_EQ_EQ] = ACTIONS(5057),
    [anon_sym_BANG_EQ] = ACTIONS(5057),
    [anon_sym_LT] = ACTIONS(5059),
    [anon_sym_GT] = ACTIONS(5059),
    [anon_sym_LT_EQ] = ACTIONS(5061),
    [anon_sym_GT_EQ] = ACTIONS(5061),
    [anon_sym_LT_LT] = ACTIONS(5063),
    [anon_sym_GT_GT] = ACTIONS(5063),
    [anon_sym_PLUS] = ACTIONS(5065),
    [anon_sym_DASH] = ACTIONS(5065),
    [anon_sym_SLASH] = ACTIONS(5039),
    [anon_sym_PERCENT] = ACTIONS(5039),
    [anon_sym_DASH_DASH] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(1554),
    [anon_sym_DASH_GT] = ACTIONS(1554),
    [sym_comment] = ACTIONS(49),
  },
  [2815] = {
    [sym_argument_list] = STATE(802),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_COMMA] = ACTIONS(5988),
    [anon_sym_STAR] = ACTIONS(5039),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_EQ] = ACTIONS(5041),
    [anon_sym_QMARK] = ACTIONS(5043),
    [anon_sym_STAR_EQ] = ACTIONS(5045),
    [anon_sym_SLASH_EQ] = ACTIONS(5045),
    [anon_sym_PERCENT_EQ] = ACTIONS(5045),
    [anon_sym_PLUS_EQ] = ACTIONS(5045),
    [anon_sym_DASH_EQ] = ACTIONS(5045),
    [anon_sym_LT_LT_EQ] = ACTIONS(5045),
    [anon_sym_GT_GT_EQ] = ACTIONS(5045),
    [anon_sym_AMP_EQ] = ACTIONS(5045),
    [anon_sym_CARET_EQ] = ACTIONS(5045),
    [anon_sym_PIPE_EQ] = ACTIONS(5045),
    [anon_sym_AMP] = ACTIONS(5047),
    [anon_sym_PIPE_PIPE] = ACTIONS(5049),
    [anon_sym_AMP_AMP] = ACTIONS(5051),
    [anon_sym_PIPE] = ACTIONS(5053),
    [anon_sym_CARET] = ACTIONS(5055),
    [anon_sym_EQ_EQ] = ACTIONS(5057),
    [anon_sym_BANG_EQ] = ACTIONS(5057),
    [anon_sym_LT] = ACTIONS(5059),
    [anon_sym_GT] = ACTIONS(5059),
    [anon_sym_LT_EQ] = ACTIONS(5061),
    [anon_sym_GT_EQ] = ACTIONS(5061),
    [anon_sym_LT_LT] = ACTIONS(5063),
    [anon_sym_GT_GT] = ACTIONS(5063),
    [anon_sym_PLUS] = ACTIONS(5065),
    [anon_sym_DASH] = ACTIONS(5065),
    [anon_sym_SLASH] = ACTIONS(5039),
    [anon_sym_PERCENT] = ACTIONS(5039),
    [anon_sym_DASH_DASH] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(1554),
    [anon_sym_DASH_GT] = ACTIONS(1554),
    [sym_comment] = ACTIONS(49),
  },
  [2816] = {
    [sym_type_qualifier] = STATE(2817),
    [sym_trailing_return_type] = STATE(2168),
    [aux_sym_abstract_function_declarator_repeat1] = STATE(2817),
    [anon_sym_LPAREN] = ACTIONS(4998),
    [anon_sym_COMMA] = ACTIONS(4998),
    [anon_sym_LBRACE] = ACTIONS(4998),
    [anon_sym_LBRACK] = ACTIONS(4998),
    [anon_sym_EQ] = ACTIONS(4998),
    [anon_sym_const] = ACTIONS(612),
    [anon_sym_restrict] = ACTIONS(614),
    [anon_sym_volatile] = ACTIONS(614),
    [anon_sym__Atomic] = ACTIONS(614),
    [anon_sym_mutable] = ACTIONS(614),
    [anon_sym_explicit] = ACTIONS(614),
    [anon_sym_constexpr] = ACTIONS(614),
    [anon_sym_GT] = ACTIONS(4998),
    [anon_sym_DASH_GT] = ACTIONS(3829),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(6710),
  },
  [2817] = {
    [sym_type_qualifier] = STATE(2817),
    [aux_sym_abstract_function_declarator_repeat1] = STATE(2817),
    [anon_sym_LPAREN] = ACTIONS(5002),
    [anon_sym_COMMA] = ACTIONS(5002),
    [anon_sym_LBRACE] = ACTIONS(5002),
    [anon_sym_LBRACK] = ACTIONS(5002),
    [anon_sym_EQ] = ACTIONS(5002),
    [anon_sym_const] = ACTIONS(5004),
    [anon_sym_restrict] = ACTIONS(5007),
    [anon_sym_volatile] = ACTIONS(5007),
    [anon_sym__Atomic] = ACTIONS(5007),
    [anon_sym_mutable] = ACTIONS(5007),
    [anon_sym_explicit] = ACTIONS(5007),
    [anon_sym_constexpr] = ACTIONS(5007),
    [anon_sym_GT] = ACTIONS(5002),
    [anon_sym_DASH_GT] = ACTIONS(5002),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(6935),
  },
  [2818] = {
    [sym_type_qualifier] = STATE(2819),
    [sym_trailing_return_type] = STATE(2168),
    [aux_sym_abstract_function_declarator_repeat1] = STATE(2819),
    [anon_sym_LPAREN] = ACTIONS(4998),
    [anon_sym_COMMA] = ACTIONS(4998),
    [anon_sym_RPAREN] = ACTIONS(4998),
    [anon_sym_LBRACE] = ACTIONS(4998),
    [anon_sym_LBRACK] = ACTIONS(4998),
    [anon_sym_EQ] = ACTIONS(4998),
    [anon_sym_const] = ACTIONS(612),
    [anon_sym_restrict] = ACTIONS(614),
    [anon_sym_volatile] = ACTIONS(614),
    [anon_sym__Atomic] = ACTIONS(614),
    [anon_sym_mutable] = ACTIONS(614),
    [anon_sym_explicit] = ACTIONS(614),
    [anon_sym_constexpr] = ACTIONS(614),
    [anon_sym_DASH_GT] = ACTIONS(4129),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(6712),
  },
  [2819] = {
    [sym_type_qualifier] = STATE(2819),
    [aux_sym_abstract_function_declarator_repeat1] = STATE(2819),
    [anon_sym_LPAREN] = ACTIONS(5002),
    [anon_sym_COMMA] = ACTIONS(5002),
    [anon_sym_RPAREN] = ACTIONS(5002),
    [anon_sym_LBRACE] = ACTIONS(5002),
    [anon_sym_LBRACK] = ACTIONS(5002),
    [anon_sym_EQ] = ACTIONS(5002),
    [anon_sym_const] = ACTIONS(5004),
    [anon_sym_restrict] = ACTIONS(5007),
    [anon_sym_volatile] = ACTIONS(5007),
    [anon_sym__Atomic] = ACTIONS(5007),
    [anon_sym_mutable] = ACTIONS(5007),
    [anon_sym_explicit] = ACTIONS(5007),
    [anon_sym_constexpr] = ACTIONS(5007),
    [anon_sym_DASH_GT] = ACTIONS(5002),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(6938),
  },
  [2820] = {
    [sym_raw_string_literal] = ACTIONS(3342),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3344),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3344),
    [anon_sym_LPAREN] = ACTIONS(3342),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3344),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3344),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3344),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3344),
    [sym_preproc_directive] = ACTIONS(3344),
    [anon_sym_SEMI] = ACTIONS(3342),
    [anon_sym_typedef] = ACTIONS(3344),
    [anon_sym_extern] = ACTIONS(3344),
    [anon_sym_LBRACE] = ACTIONS(3342),
    [anon_sym_STAR] = ACTIONS(3342),
    [anon_sym_LBRACK] = ACTIONS(3342),
    [anon_sym_static] = ACTIONS(3344),
    [anon_sym_register] = ACTIONS(3344),
    [anon_sym_inline] = ACTIONS(3344),
    [anon_sym_const] = ACTIONS(3344),
    [anon_sym_restrict] = ACTIONS(3344),
    [anon_sym_volatile] = ACTIONS(3344),
    [anon_sym__Atomic] = ACTIONS(3344),
    [anon_sym_mutable] = ACTIONS(3344),
    [anon_sym_explicit] = ACTIONS(3344),
    [anon_sym_constexpr] = ACTIONS(3344),
    [anon_sym_unsigned] = ACTIONS(3344),
    [anon_sym_long] = ACTIONS(3344),
    [anon_sym_short] = ACTIONS(3344),
    [sym_primitive_type] = ACTIONS(3344),
    [anon_sym_enum] = ACTIONS(3344),
    [anon_sym_struct] = ACTIONS(3344),
    [anon_sym_union] = ACTIONS(3344),
    [anon_sym_if] = ACTIONS(3344),
    [anon_sym_switch] = ACTIONS(3344),
    [anon_sym_case] = ACTIONS(3344),
    [anon_sym_default] = ACTIONS(3344),
    [anon_sym_while] = ACTIONS(3344),
    [anon_sym_do] = ACTIONS(3344),
    [anon_sym_for] = ACTIONS(3344),
    [anon_sym_return] = ACTIONS(3344),
    [anon_sym_break] = ACTIONS(3344),
    [anon_sym_continue] = ACTIONS(3344),
    [anon_sym_goto] = ACTIONS(3344),
    [anon_sym_AMP] = ACTIONS(3342),
    [anon_sym_BANG] = ACTIONS(3342),
    [anon_sym_TILDE] = ACTIONS(3342),
    [anon_sym_PLUS] = ACTIONS(3344),
    [anon_sym_DASH] = ACTIONS(3344),
    [anon_sym_DASH_DASH] = ACTIONS(3342),
    [anon_sym_PLUS_PLUS] = ACTIONS(3342),
    [anon_sym_sizeof] = ACTIONS(3344),
    [sym_number_literal] = ACTIONS(3342),
    [sym_char_literal] = ACTIONS(3342),
    [sym_string_literal] = ACTIONS(3342),
    [sym_true] = ACTIONS(3344),
    [sym_false] = ACTIONS(3344),
    [sym_null] = ACTIONS(3344),
    [sym_identifier] = ACTIONS(3344),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(3344),
    [sym_auto] = ACTIONS(3344),
    [anon_sym_typename] = ACTIONS(3344),
    [anon_sym_new] = ACTIONS(3344),
    [anon_sym_COLON_COLON] = ACTIONS(3342),
    [anon_sym_delete] = ACTIONS(3344),
    [sym_nullptr] = ACTIONS(3344),
  },
  [2821] = {
    [sym_raw_string_literal] = ACTIONS(3352),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3354),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3354),
    [anon_sym_LPAREN] = ACTIONS(3352),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3354),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3354),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3354),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3354),
    [sym_preproc_directive] = ACTIONS(3354),
    [anon_sym_SEMI] = ACTIONS(3352),
    [anon_sym_typedef] = ACTIONS(3354),
    [anon_sym_extern] = ACTIONS(3354),
    [anon_sym_LBRACE] = ACTIONS(3352),
    [anon_sym_STAR] = ACTIONS(3352),
    [anon_sym_LBRACK] = ACTIONS(3352),
    [anon_sym_static] = ACTIONS(3354),
    [anon_sym_register] = ACTIONS(3354),
    [anon_sym_inline] = ACTIONS(3354),
    [anon_sym_const] = ACTIONS(3354),
    [anon_sym_restrict] = ACTIONS(3354),
    [anon_sym_volatile] = ACTIONS(3354),
    [anon_sym__Atomic] = ACTIONS(3354),
    [anon_sym_mutable] = ACTIONS(3354),
    [anon_sym_explicit] = ACTIONS(3354),
    [anon_sym_constexpr] = ACTIONS(3354),
    [anon_sym_unsigned] = ACTIONS(3354),
    [anon_sym_long] = ACTIONS(3354),
    [anon_sym_short] = ACTIONS(3354),
    [sym_primitive_type] = ACTIONS(3354),
    [anon_sym_enum] = ACTIONS(3354),
    [anon_sym_struct] = ACTIONS(3354),
    [anon_sym_union] = ACTIONS(3354),
    [anon_sym_if] = ACTIONS(3354),
    [anon_sym_switch] = ACTIONS(3354),
    [anon_sym_case] = ACTIONS(3354),
    [anon_sym_default] = ACTIONS(3354),
    [anon_sym_while] = ACTIONS(3354),
    [anon_sym_do] = ACTIONS(3354),
    [anon_sym_for] = ACTIONS(3354),
    [anon_sym_return] = ACTIONS(3354),
    [anon_sym_break] = ACTIONS(3354),
    [anon_sym_continue] = ACTIONS(3354),
    [anon_sym_goto] = ACTIONS(3354),
    [anon_sym_AMP] = ACTIONS(3352),
    [anon_sym_BANG] = ACTIONS(3352),
    [anon_sym_TILDE] = ACTIONS(3352),
    [anon_sym_PLUS] = ACTIONS(3354),
    [anon_sym_DASH] = ACTIONS(3354),
    [anon_sym_DASH_DASH] = ACTIONS(3352),
    [anon_sym_PLUS_PLUS] = ACTIONS(3352),
    [anon_sym_sizeof] = ACTIONS(3354),
    [sym_number_literal] = ACTIONS(3352),
    [sym_char_literal] = ACTIONS(3352),
    [sym_string_literal] = ACTIONS(3352),
    [sym_true] = ACTIONS(3354),
    [sym_false] = ACTIONS(3354),
    [sym_null] = ACTIONS(3354),
    [sym_identifier] = ACTIONS(3354),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(3354),
    [sym_auto] = ACTIONS(3354),
    [anon_sym_typename] = ACTIONS(3354),
    [anon_sym_new] = ACTIONS(3354),
    [anon_sym_COLON_COLON] = ACTIONS(3352),
    [anon_sym_delete] = ACTIONS(3354),
    [sym_nullptr] = ACTIONS(3354),
  },
  [2822] = {
    [sym_raw_string_literal] = ACTIONS(6200),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(6202),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(6202),
    [anon_sym_LPAREN] = ACTIONS(6200),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(6202),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(6202),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(6202),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(6202),
    [sym_preproc_directive] = ACTIONS(6202),
    [anon_sym_SEMI] = ACTIONS(6200),
    [anon_sym_typedef] = ACTIONS(6202),
    [anon_sym_extern] = ACTIONS(6202),
    [anon_sym_LBRACE] = ACTIONS(6200),
    [anon_sym_STAR] = ACTIONS(6200),
    [anon_sym_LBRACK] = ACTIONS(6200),
    [anon_sym_static] = ACTIONS(6202),
    [anon_sym_register] = ACTIONS(6202),
    [anon_sym_inline] = ACTIONS(6202),
    [anon_sym_const] = ACTIONS(6202),
    [anon_sym_restrict] = ACTIONS(6202),
    [anon_sym_volatile] = ACTIONS(6202),
    [anon_sym__Atomic] = ACTIONS(6202),
    [anon_sym_mutable] = ACTIONS(6202),
    [anon_sym_explicit] = ACTIONS(6202),
    [anon_sym_constexpr] = ACTIONS(6202),
    [anon_sym_unsigned] = ACTIONS(6202),
    [anon_sym_long] = ACTIONS(6202),
    [anon_sym_short] = ACTIONS(6202),
    [sym_primitive_type] = ACTIONS(6202),
    [anon_sym_enum] = ACTIONS(6202),
    [anon_sym_struct] = ACTIONS(6202),
    [anon_sym_union] = ACTIONS(6202),
    [anon_sym_if] = ACTIONS(6202),
    [anon_sym_switch] = ACTIONS(6202),
    [anon_sym_case] = ACTIONS(6202),
    [anon_sym_default] = ACTIONS(6202),
    [anon_sym_while] = ACTIONS(6202),
    [anon_sym_do] = ACTIONS(6202),
    [anon_sym_for] = ACTIONS(6202),
    [anon_sym_return] = ACTIONS(6202),
    [anon_sym_break] = ACTIONS(6202),
    [anon_sym_continue] = ACTIONS(6202),
    [anon_sym_goto] = ACTIONS(6202),
    [anon_sym_AMP] = ACTIONS(6200),
    [anon_sym_BANG] = ACTIONS(6200),
    [anon_sym_TILDE] = ACTIONS(6200),
    [anon_sym_PLUS] = ACTIONS(6202),
    [anon_sym_DASH] = ACTIONS(6202),
    [anon_sym_DASH_DASH] = ACTIONS(6200),
    [anon_sym_PLUS_PLUS] = ACTIONS(6200),
    [anon_sym_sizeof] = ACTIONS(6202),
    [sym_number_literal] = ACTIONS(6200),
    [sym_char_literal] = ACTIONS(6200),
    [sym_string_literal] = ACTIONS(6200),
    [sym_true] = ACTIONS(6202),
    [sym_false] = ACTIONS(6202),
    [sym_null] = ACTIONS(6202),
    [sym_identifier] = ACTIONS(6202),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(6202),
    [sym_auto] = ACTIONS(6202),
    [anon_sym_typename] = ACTIONS(6202),
    [anon_sym_new] = ACTIONS(6202),
    [anon_sym_COLON_COLON] = ACTIONS(6200),
    [anon_sym_delete] = ACTIONS(6202),
    [sym_nullptr] = ACTIONS(6202),
  },
  [2823] = {
    [sym_raw_string_literal] = ACTIONS(6204),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(6206),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(6206),
    [anon_sym_LPAREN] = ACTIONS(6204),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(6206),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(6206),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(6206),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(6206),
    [sym_preproc_directive] = ACTIONS(6206),
    [anon_sym_SEMI] = ACTIONS(6204),
    [anon_sym_typedef] = ACTIONS(6206),
    [anon_sym_extern] = ACTIONS(6206),
    [anon_sym_LBRACE] = ACTIONS(6204),
    [anon_sym_STAR] = ACTIONS(6204),
    [anon_sym_LBRACK] = ACTIONS(6204),
    [anon_sym_static] = ACTIONS(6206),
    [anon_sym_register] = ACTIONS(6206),
    [anon_sym_inline] = ACTIONS(6206),
    [anon_sym_const] = ACTIONS(6206),
    [anon_sym_restrict] = ACTIONS(6206),
    [anon_sym_volatile] = ACTIONS(6206),
    [anon_sym__Atomic] = ACTIONS(6206),
    [anon_sym_mutable] = ACTIONS(6206),
    [anon_sym_explicit] = ACTIONS(6206),
    [anon_sym_constexpr] = ACTIONS(6206),
    [anon_sym_unsigned] = ACTIONS(6206),
    [anon_sym_long] = ACTIONS(6206),
    [anon_sym_short] = ACTIONS(6206),
    [sym_primitive_type] = ACTIONS(6206),
    [anon_sym_enum] = ACTIONS(6206),
    [anon_sym_struct] = ACTIONS(6206),
    [anon_sym_union] = ACTIONS(6206),
    [anon_sym_if] = ACTIONS(6206),
    [anon_sym_switch] = ACTIONS(6206),
    [anon_sym_case] = ACTIONS(6206),
    [anon_sym_default] = ACTIONS(6206),
    [anon_sym_while] = ACTIONS(6206),
    [anon_sym_do] = ACTIONS(6206),
    [anon_sym_for] = ACTIONS(6206),
    [anon_sym_return] = ACTIONS(6206),
    [anon_sym_break] = ACTIONS(6206),
    [anon_sym_continue] = ACTIONS(6206),
    [anon_sym_goto] = ACTIONS(6206),
    [anon_sym_AMP] = ACTIONS(6204),
    [anon_sym_BANG] = ACTIONS(6204),
    [anon_sym_TILDE] = ACTIONS(6204),
    [anon_sym_PLUS] = ACTIONS(6206),
    [anon_sym_DASH] = ACTIONS(6206),
    [anon_sym_DASH_DASH] = ACTIONS(6204),
    [anon_sym_PLUS_PLUS] = ACTIONS(6204),
    [anon_sym_sizeof] = ACTIONS(6206),
    [sym_number_literal] = ACTIONS(6204),
    [sym_char_literal] = ACTIONS(6204),
    [sym_string_literal] = ACTIONS(6204),
    [sym_true] = ACTIONS(6206),
    [sym_false] = ACTIONS(6206),
    [sym_null] = ACTIONS(6206),
    [sym_identifier] = ACTIONS(6206),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(6206),
    [sym_auto] = ACTIONS(6206),
    [anon_sym_typename] = ACTIONS(6206),
    [anon_sym_new] = ACTIONS(6206),
    [anon_sym_COLON_COLON] = ACTIONS(6204),
    [anon_sym_delete] = ACTIONS(6206),
    [sym_nullptr] = ACTIONS(6206),
  },
  [2824] = {
    [sym_raw_string_literal] = ACTIONS(6208),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(6210),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(6210),
    [anon_sym_LPAREN] = ACTIONS(6208),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(6210),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(6210),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(6210),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(6210),
    [sym_preproc_directive] = ACTIONS(6210),
    [anon_sym_SEMI] = ACTIONS(6208),
    [anon_sym_typedef] = ACTIONS(6210),
    [anon_sym_extern] = ACTIONS(6210),
    [anon_sym_LBRACE] = ACTIONS(6208),
    [anon_sym_STAR] = ACTIONS(6208),
    [anon_sym_LBRACK] = ACTIONS(6208),
    [anon_sym_static] = ACTIONS(6210),
    [anon_sym_register] = ACTIONS(6210),
    [anon_sym_inline] = ACTIONS(6210),
    [anon_sym_const] = ACTIONS(6210),
    [anon_sym_restrict] = ACTIONS(6210),
    [anon_sym_volatile] = ACTIONS(6210),
    [anon_sym__Atomic] = ACTIONS(6210),
    [anon_sym_mutable] = ACTIONS(6210),
    [anon_sym_explicit] = ACTIONS(6210),
    [anon_sym_constexpr] = ACTIONS(6210),
    [anon_sym_unsigned] = ACTIONS(6210),
    [anon_sym_long] = ACTIONS(6210),
    [anon_sym_short] = ACTIONS(6210),
    [sym_primitive_type] = ACTIONS(6210),
    [anon_sym_enum] = ACTIONS(6210),
    [anon_sym_struct] = ACTIONS(6210),
    [anon_sym_union] = ACTIONS(6210),
    [anon_sym_if] = ACTIONS(6210),
    [anon_sym_switch] = ACTIONS(6210),
    [anon_sym_case] = ACTIONS(6210),
    [anon_sym_default] = ACTIONS(6210),
    [anon_sym_while] = ACTIONS(6210),
    [anon_sym_do] = ACTIONS(6210),
    [anon_sym_for] = ACTIONS(6210),
    [anon_sym_return] = ACTIONS(6210),
    [anon_sym_break] = ACTIONS(6210),
    [anon_sym_continue] = ACTIONS(6210),
    [anon_sym_goto] = ACTIONS(6210),
    [anon_sym_AMP] = ACTIONS(6208),
    [anon_sym_BANG] = ACTIONS(6208),
    [anon_sym_TILDE] = ACTIONS(6208),
    [anon_sym_PLUS] = ACTIONS(6210),
    [anon_sym_DASH] = ACTIONS(6210),
    [anon_sym_DASH_DASH] = ACTIONS(6208),
    [anon_sym_PLUS_PLUS] = ACTIONS(6208),
    [anon_sym_sizeof] = ACTIONS(6210),
    [sym_number_literal] = ACTIONS(6208),
    [sym_char_literal] = ACTIONS(6208),
    [sym_string_literal] = ACTIONS(6208),
    [sym_true] = ACTIONS(6210),
    [sym_false] = ACTIONS(6210),
    [sym_null] = ACTIONS(6210),
    [sym_identifier] = ACTIONS(6210),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(6210),
    [sym_auto] = ACTIONS(6210),
    [anon_sym_typename] = ACTIONS(6210),
    [anon_sym_new] = ACTIONS(6210),
    [anon_sym_COLON_COLON] = ACTIONS(6208),
    [anon_sym_delete] = ACTIONS(6210),
    [sym_nullptr] = ACTIONS(6210),
  },
  [2825] = {
    [sym_raw_string_literal] = ACTIONS(6212),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(6214),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(6214),
    [anon_sym_LPAREN] = ACTIONS(6212),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(6214),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(6214),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(6214),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(6214),
    [sym_preproc_directive] = ACTIONS(6214),
    [anon_sym_SEMI] = ACTIONS(6212),
    [anon_sym_typedef] = ACTIONS(6214),
    [anon_sym_extern] = ACTIONS(6214),
    [anon_sym_LBRACE] = ACTIONS(6212),
    [anon_sym_STAR] = ACTIONS(6212),
    [anon_sym_LBRACK] = ACTIONS(6212),
    [anon_sym_static] = ACTIONS(6214),
    [anon_sym_register] = ACTIONS(6214),
    [anon_sym_inline] = ACTIONS(6214),
    [anon_sym_const] = ACTIONS(6214),
    [anon_sym_restrict] = ACTIONS(6214),
    [anon_sym_volatile] = ACTIONS(6214),
    [anon_sym__Atomic] = ACTIONS(6214),
    [anon_sym_mutable] = ACTIONS(6214),
    [anon_sym_explicit] = ACTIONS(6214),
    [anon_sym_constexpr] = ACTIONS(6214),
    [anon_sym_unsigned] = ACTIONS(6214),
    [anon_sym_long] = ACTIONS(6214),
    [anon_sym_short] = ACTIONS(6214),
    [sym_primitive_type] = ACTIONS(6214),
    [anon_sym_enum] = ACTIONS(6214),
    [anon_sym_struct] = ACTIONS(6214),
    [anon_sym_union] = ACTIONS(6214),
    [anon_sym_if] = ACTIONS(6214),
    [anon_sym_switch] = ACTIONS(6214),
    [anon_sym_case] = ACTIONS(6214),
    [anon_sym_default] = ACTIONS(6214),
    [anon_sym_while] = ACTIONS(6214),
    [anon_sym_do] = ACTIONS(6214),
    [anon_sym_for] = ACTIONS(6214),
    [anon_sym_return] = ACTIONS(6214),
    [anon_sym_break] = ACTIONS(6214),
    [anon_sym_continue] = ACTIONS(6214),
    [anon_sym_goto] = ACTIONS(6214),
    [anon_sym_AMP] = ACTIONS(6212),
    [anon_sym_BANG] = ACTIONS(6212),
    [anon_sym_TILDE] = ACTIONS(6212),
    [anon_sym_PLUS] = ACTIONS(6214),
    [anon_sym_DASH] = ACTIONS(6214),
    [anon_sym_DASH_DASH] = ACTIONS(6212),
    [anon_sym_PLUS_PLUS] = ACTIONS(6212),
    [anon_sym_sizeof] = ACTIONS(6214),
    [sym_number_literal] = ACTIONS(6212),
    [sym_char_literal] = ACTIONS(6212),
    [sym_string_literal] = ACTIONS(6212),
    [sym_true] = ACTIONS(6214),
    [sym_false] = ACTIONS(6214),
    [sym_null] = ACTIONS(6214),
    [sym_identifier] = ACTIONS(6214),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(6214),
    [sym_auto] = ACTIONS(6214),
    [anon_sym_typename] = ACTIONS(6214),
    [anon_sym_new] = ACTIONS(6214),
    [anon_sym_COLON_COLON] = ACTIONS(6212),
    [anon_sym_delete] = ACTIONS(6214),
    [sym_nullptr] = ACTIONS(6214),
  },
  [2826] = {
    [sym_raw_string_literal] = ACTIONS(6216),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(6218),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(6218),
    [anon_sym_LPAREN] = ACTIONS(6216),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(6218),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(6218),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(6218),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(6218),
    [sym_preproc_directive] = ACTIONS(6218),
    [anon_sym_SEMI] = ACTIONS(6216),
    [anon_sym_typedef] = ACTIONS(6218),
    [anon_sym_extern] = ACTIONS(6218),
    [anon_sym_LBRACE] = ACTIONS(6216),
    [anon_sym_STAR] = ACTIONS(6216),
    [anon_sym_LBRACK] = ACTIONS(6216),
    [anon_sym_static] = ACTIONS(6218),
    [anon_sym_register] = ACTIONS(6218),
    [anon_sym_inline] = ACTIONS(6218),
    [anon_sym_const] = ACTIONS(6218),
    [anon_sym_restrict] = ACTIONS(6218),
    [anon_sym_volatile] = ACTIONS(6218),
    [anon_sym__Atomic] = ACTIONS(6218),
    [anon_sym_mutable] = ACTIONS(6218),
    [anon_sym_explicit] = ACTIONS(6218),
    [anon_sym_constexpr] = ACTIONS(6218),
    [anon_sym_unsigned] = ACTIONS(6218),
    [anon_sym_long] = ACTIONS(6218),
    [anon_sym_short] = ACTIONS(6218),
    [sym_primitive_type] = ACTIONS(6218),
    [anon_sym_enum] = ACTIONS(6218),
    [anon_sym_struct] = ACTIONS(6218),
    [anon_sym_union] = ACTIONS(6218),
    [anon_sym_if] = ACTIONS(6218),
    [anon_sym_switch] = ACTIONS(6218),
    [anon_sym_case] = ACTIONS(6218),
    [anon_sym_default] = ACTIONS(6218),
    [anon_sym_while] = ACTIONS(6218),
    [anon_sym_do] = ACTIONS(6218),
    [anon_sym_for] = ACTIONS(6218),
    [anon_sym_return] = ACTIONS(6218),
    [anon_sym_break] = ACTIONS(6218),
    [anon_sym_continue] = ACTIONS(6218),
    [anon_sym_goto] = ACTIONS(6218),
    [anon_sym_AMP] = ACTIONS(6216),
    [anon_sym_BANG] = ACTIONS(6216),
    [anon_sym_TILDE] = ACTIONS(6216),
    [anon_sym_PLUS] = ACTIONS(6218),
    [anon_sym_DASH] = ACTIONS(6218),
    [anon_sym_DASH_DASH] = ACTIONS(6216),
    [anon_sym_PLUS_PLUS] = ACTIONS(6216),
    [anon_sym_sizeof] = ACTIONS(6218),
    [sym_number_literal] = ACTIONS(6216),
    [sym_char_literal] = ACTIONS(6216),
    [sym_string_literal] = ACTIONS(6216),
    [sym_true] = ACTIONS(6218),
    [sym_false] = ACTIONS(6218),
    [sym_null] = ACTIONS(6218),
    [sym_identifier] = ACTIONS(6218),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(6218),
    [sym_auto] = ACTIONS(6218),
    [anon_sym_typename] = ACTIONS(6218),
    [anon_sym_new] = ACTIONS(6218),
    [anon_sym_COLON_COLON] = ACTIONS(6216),
    [anon_sym_delete] = ACTIONS(6218),
    [sym_nullptr] = ACTIONS(6218),
  },
  [2827] = {
    [sym_raw_string_literal] = ACTIONS(6220),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(6222),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(6222),
    [anon_sym_LPAREN] = ACTIONS(6220),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(6222),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(6222),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(6222),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(6222),
    [sym_preproc_directive] = ACTIONS(6222),
    [anon_sym_SEMI] = ACTIONS(6220),
    [anon_sym_typedef] = ACTIONS(6222),
    [anon_sym_extern] = ACTIONS(6222),
    [anon_sym_LBRACE] = ACTIONS(6220),
    [anon_sym_STAR] = ACTIONS(6220),
    [anon_sym_LBRACK] = ACTIONS(6220),
    [anon_sym_static] = ACTIONS(6222),
    [anon_sym_register] = ACTIONS(6222),
    [anon_sym_inline] = ACTIONS(6222),
    [anon_sym_const] = ACTIONS(6222),
    [anon_sym_restrict] = ACTIONS(6222),
    [anon_sym_volatile] = ACTIONS(6222),
    [anon_sym__Atomic] = ACTIONS(6222),
    [anon_sym_mutable] = ACTIONS(6222),
    [anon_sym_explicit] = ACTIONS(6222),
    [anon_sym_constexpr] = ACTIONS(6222),
    [anon_sym_unsigned] = ACTIONS(6222),
    [anon_sym_long] = ACTIONS(6222),
    [anon_sym_short] = ACTIONS(6222),
    [sym_primitive_type] = ACTIONS(6222),
    [anon_sym_enum] = ACTIONS(6222),
    [anon_sym_struct] = ACTIONS(6222),
    [anon_sym_union] = ACTIONS(6222),
    [anon_sym_if] = ACTIONS(6222),
    [anon_sym_switch] = ACTIONS(6222),
    [anon_sym_case] = ACTIONS(6222),
    [anon_sym_default] = ACTIONS(6222),
    [anon_sym_while] = ACTIONS(6222),
    [anon_sym_do] = ACTIONS(6222),
    [anon_sym_for] = ACTIONS(6222),
    [anon_sym_return] = ACTIONS(6222),
    [anon_sym_break] = ACTIONS(6222),
    [anon_sym_continue] = ACTIONS(6222),
    [anon_sym_goto] = ACTIONS(6222),
    [anon_sym_AMP] = ACTIONS(6220),
    [anon_sym_BANG] = ACTIONS(6220),
    [anon_sym_TILDE] = ACTIONS(6220),
    [anon_sym_PLUS] = ACTIONS(6222),
    [anon_sym_DASH] = ACTIONS(6222),
    [anon_sym_DASH_DASH] = ACTIONS(6220),
    [anon_sym_PLUS_PLUS] = ACTIONS(6220),
    [anon_sym_sizeof] = ACTIONS(6222),
    [sym_number_literal] = ACTIONS(6220),
    [sym_char_literal] = ACTIONS(6220),
    [sym_string_literal] = ACTIONS(6220),
    [sym_true] = ACTIONS(6222),
    [sym_false] = ACTIONS(6222),
    [sym_null] = ACTIONS(6222),
    [sym_identifier] = ACTIONS(6222),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(6222),
    [sym_auto] = ACTIONS(6222),
    [anon_sym_typename] = ACTIONS(6222),
    [anon_sym_new] = ACTIONS(6222),
    [anon_sym_COLON_COLON] = ACTIONS(6220),
    [anon_sym_delete] = ACTIONS(6222),
    [sym_nullptr] = ACTIONS(6222),
  },
  [2828] = {
    [sym_raw_string_literal] = ACTIONS(3519),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3521),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3521),
    [anon_sym_LPAREN] = ACTIONS(3519),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3521),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3521),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3521),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3521),
    [sym_preproc_directive] = ACTIONS(3521),
    [anon_sym_SEMI] = ACTIONS(3519),
    [anon_sym_typedef] = ACTIONS(3521),
    [anon_sym_extern] = ACTIONS(3521),
    [anon_sym_LBRACE] = ACTIONS(3519),
    [anon_sym_STAR] = ACTIONS(3519),
    [anon_sym_LBRACK] = ACTIONS(3519),
    [anon_sym_static] = ACTIONS(3521),
    [anon_sym_register] = ACTIONS(3521),
    [anon_sym_inline] = ACTIONS(3521),
    [anon_sym_const] = ACTIONS(3521),
    [anon_sym_restrict] = ACTIONS(3521),
    [anon_sym_volatile] = ACTIONS(3521),
    [anon_sym__Atomic] = ACTIONS(3521),
    [anon_sym_mutable] = ACTIONS(3521),
    [anon_sym_explicit] = ACTIONS(3521),
    [anon_sym_constexpr] = ACTIONS(3521),
    [anon_sym_unsigned] = ACTIONS(3521),
    [anon_sym_long] = ACTIONS(3521),
    [anon_sym_short] = ACTIONS(3521),
    [sym_primitive_type] = ACTIONS(3521),
    [anon_sym_enum] = ACTIONS(3521),
    [anon_sym_struct] = ACTIONS(3521),
    [anon_sym_union] = ACTIONS(3521),
    [anon_sym_if] = ACTIONS(3521),
    [anon_sym_switch] = ACTIONS(3521),
    [anon_sym_case] = ACTIONS(3521),
    [anon_sym_default] = ACTIONS(3521),
    [anon_sym_while] = ACTIONS(3521),
    [anon_sym_do] = ACTIONS(3521),
    [anon_sym_for] = ACTIONS(3521),
    [anon_sym_return] = ACTIONS(3521),
    [anon_sym_break] = ACTIONS(3521),
    [anon_sym_continue] = ACTIONS(3521),
    [anon_sym_goto] = ACTIONS(3521),
    [anon_sym_AMP] = ACTIONS(3519),
    [anon_sym_BANG] = ACTIONS(3519),
    [anon_sym_TILDE] = ACTIONS(3519),
    [anon_sym_PLUS] = ACTIONS(3521),
    [anon_sym_DASH] = ACTIONS(3521),
    [anon_sym_DASH_DASH] = ACTIONS(3519),
    [anon_sym_PLUS_PLUS] = ACTIONS(3519),
    [anon_sym_sizeof] = ACTIONS(3521),
    [sym_number_literal] = ACTIONS(3519),
    [sym_char_literal] = ACTIONS(3519),
    [sym_string_literal] = ACTIONS(3519),
    [sym_true] = ACTIONS(3521),
    [sym_false] = ACTIONS(3521),
    [sym_null] = ACTIONS(3521),
    [sym_identifier] = ACTIONS(3521),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(3521),
    [sym_auto] = ACTIONS(3521),
    [anon_sym_typename] = ACTIONS(3521),
    [anon_sym_new] = ACTIONS(3521),
    [anon_sym_COLON_COLON] = ACTIONS(3519),
    [anon_sym_delete] = ACTIONS(3521),
    [sym_nullptr] = ACTIONS(3521),
  },
  [2829] = {
    [sym_raw_string_literal] = ACTIONS(1614),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1616),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1616),
    [anon_sym_LPAREN] = ACTIONS(1614),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1616),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(1616),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1616),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1616),
    [sym_preproc_directive] = ACTIONS(1616),
    [anon_sym_SEMI] = ACTIONS(1614),
    [anon_sym_typedef] = ACTIONS(1616),
    [anon_sym_extern] = ACTIONS(1616),
    [anon_sym_LBRACE] = ACTIONS(1614),
    [anon_sym_STAR] = ACTIONS(1614),
    [anon_sym_LBRACK] = ACTIONS(1614),
    [anon_sym_static] = ACTIONS(1616),
    [anon_sym_register] = ACTIONS(1616),
    [anon_sym_inline] = ACTIONS(1616),
    [anon_sym_const] = ACTIONS(1616),
    [anon_sym_restrict] = ACTIONS(1616),
    [anon_sym_volatile] = ACTIONS(1616),
    [anon_sym__Atomic] = ACTIONS(1616),
    [anon_sym_mutable] = ACTIONS(1616),
    [anon_sym_explicit] = ACTIONS(1616),
    [anon_sym_constexpr] = ACTIONS(1616),
    [anon_sym_unsigned] = ACTIONS(1616),
    [anon_sym_long] = ACTIONS(1616),
    [anon_sym_short] = ACTIONS(1616),
    [sym_primitive_type] = ACTIONS(1616),
    [anon_sym_enum] = ACTIONS(1616),
    [anon_sym_struct] = ACTIONS(1616),
    [anon_sym_union] = ACTIONS(1616),
    [anon_sym_if] = ACTIONS(1616),
    [anon_sym_else] = ACTIONS(1616),
    [anon_sym_switch] = ACTIONS(1616),
    [anon_sym_case] = ACTIONS(1616),
    [anon_sym_default] = ACTIONS(1616),
    [anon_sym_while] = ACTIONS(1616),
    [anon_sym_do] = ACTIONS(1616),
    [anon_sym_for] = ACTIONS(1616),
    [anon_sym_return] = ACTIONS(1616),
    [anon_sym_break] = ACTIONS(1616),
    [anon_sym_continue] = ACTIONS(1616),
    [anon_sym_goto] = ACTIONS(1616),
    [anon_sym_AMP] = ACTIONS(1614),
    [anon_sym_BANG] = ACTIONS(1614),
    [anon_sym_TILDE] = ACTIONS(1614),
    [anon_sym_PLUS] = ACTIONS(1616),
    [anon_sym_DASH] = ACTIONS(1616),
    [anon_sym_DASH_DASH] = ACTIONS(1614),
    [anon_sym_PLUS_PLUS] = ACTIONS(1614),
    [anon_sym_sizeof] = ACTIONS(1616),
    [sym_number_literal] = ACTIONS(1614),
    [sym_char_literal] = ACTIONS(1614),
    [sym_string_literal] = ACTIONS(1614),
    [sym_true] = ACTIONS(1616),
    [sym_false] = ACTIONS(1616),
    [sym_null] = ACTIONS(1616),
    [sym_identifier] = ACTIONS(1616),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(1616),
    [sym_auto] = ACTIONS(1616),
    [anon_sym_typename] = ACTIONS(1616),
    [anon_sym_new] = ACTIONS(1616),
    [anon_sym_COLON_COLON] = ACTIONS(1614),
    [anon_sym_delete] = ACTIONS(1616),
    [sym_nullptr] = ACTIONS(1616),
  },
  [2830] = {
    [sym_preproc_include] = STATE(2929),
    [sym_preproc_def] = STATE(2929),
    [sym_preproc_function_def] = STATE(2929),
    [sym_preproc_call] = STATE(2929),
    [sym_preproc_if_in_compound_statement] = STATE(410),
    [sym_preproc_ifdef_in_compound_statement] = STATE(411),
    [sym_declaration] = STATE(2929),
    [sym_type_definition] = STATE(2929),
    [sym__declaration_specifiers] = STATE(412),
    [sym_compound_statement] = STATE(2929),
    [sym_storage_class_specifier] = STATE(419),
    [sym_type_qualifier] = STATE(419),
    [sym__type_specifier] = STATE(30),
    [sym_sized_type_specifier] = STATE(30),
    [sym_enum_specifier] = STATE(30),
    [sym_struct_specifier] = STATE(30),
    [sym_union_specifier] = STATE(30),
    [sym_labeled_statement] = STATE(2929),
    [sym_expression_statement] = STATE(2929),
    [sym_if_statement] = STATE(2929),
    [sym_switch_statement] = STATE(2929),
    [sym_case_statement] = STATE(2929),
    [sym_while_statement] = STATE(2929),
    [sym_do_statement] = STATE(2929),
    [sym_for_statement] = STATE(2929),
    [sym_return_statement] = STATE(2929),
    [sym_break_statement] = STATE(2929),
    [sym_continue_statement] = STATE(2929),
    [sym_goto_statement] = STATE(2929),
    [sym__expression] = STATE(413),
    [sym_comma_expression] = STATE(414),
    [sym_conditional_expression] = STATE(413),
    [sym_assignment_expression] = STATE(413),
    [sym_pointer_expression] = STATE(413),
    [sym_logical_expression] = STATE(413),
    [sym_bitwise_expression] = STATE(413),
    [sym_equality_expression] = STATE(413),
    [sym_relational_expression] = STATE(413),
    [sym_shift_expression] = STATE(413),
    [sym_math_expression] = STATE(413),
    [sym_cast_expression] = STATE(413),
    [sym_sizeof_expression] = STATE(413),
    [sym_subscript_expression] = STATE(413),
    [sym_call_expression] = STATE(413),
    [sym_field_expression] = STATE(413),
    [sym_compound_literal_expression] = STATE(413),
    [sym_parenthesized_expression] = STATE(413),
    [sym_concatenated_string] = STATE(413),
    [sym__empty_declaration] = STATE(2929),
    [sym_macro_type_specifier] = STATE(30),
    [sym_class_specifier] = STATE(30),
    [sym_dependent_type] = STATE(30),
    [sym_structured_binding_declaration] = STATE(2929),
    [sym_template_type] = STATE(415),
    [sym_template_function] = STATE(413),
    [sym_for_range_loop] = STATE(2929),
    [sym_new_expression] = STATE(413),
    [sym_delete_expression] = STATE(413),
    [sym_lambda_expression] = STATE(413),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(416),
    [sym_scoped_namespace_identifier] = STATE(417),
    [aux_sym_preproc_if_in_compound_statement_repeat1] = STATE(2929),
    [aux_sym__declaration_specifiers_repeat1] = STATE(419),
    [aux_sym_sized_type_specifier_repeat1] = STATE(38),
    [sym_raw_string_literal] = ACTIONS(620),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(622),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(624),
    [anon_sym_LPAREN] = ACTIONS(626),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(628),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(630),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(632),
    [sym_preproc_directive] = ACTIONS(634),
    [anon_sym_SEMI] = ACTIONS(636),
    [anon_sym_typedef] = ACTIONS(638),
    [anon_sym_extern] = ACTIONS(154),
    [anon_sym_LBRACE] = ACTIONS(640),
    [anon_sym_RBRACE] = ACTIONS(6941),
    [anon_sym_STAR] = ACTIONS(644),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_static] = ACTIONS(154),
    [anon_sym_register] = ACTIONS(154),
    [anon_sym_inline] = ACTIONS(154),
    [anon_sym_const] = ACTIONS(158),
    [anon_sym_restrict] = ACTIONS(158),
    [anon_sym_volatile] = ACTIONS(158),
    [anon_sym__Atomic] = ACTIONS(158),
    [anon_sym_mutable] = ACTIONS(158),
    [anon_sym_explicit] = ACTIONS(158),
    [anon_sym_constexpr] = ACTIONS(158),
    [anon_sym_unsigned] = ACTIONS(31),
    [anon_sym_long] = ACTIONS(31),
    [anon_sym_short] = ACTIONS(31),
    [sym_primitive_type] = ACTIONS(33),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_union] = ACTIONS(39),
    [anon_sym_if] = ACTIONS(646),
    [anon_sym_switch] = ACTIONS(648),
    [anon_sym_case] = ACTIONS(650),
    [anon_sym_default] = ACTIONS(652),
    [anon_sym_while] = ACTIONS(654),
    [anon_sym_do] = ACTIONS(656),
    [anon_sym_for] = ACTIONS(658),
    [anon_sym_return] = ACTIONS(660),
    [anon_sym_break] = ACTIONS(662),
    [anon_sym_continue] = ACTIONS(664),
    [anon_sym_goto] = ACTIONS(666),
    [anon_sym_AMP] = ACTIONS(644),
    [anon_sym_BANG] = ACTIONS(668),
    [anon_sym_TILDE] = ACTIONS(670),
    [anon_sym_PLUS] = ACTIONS(672),
    [anon_sym_DASH] = ACTIONS(672),
    [anon_sym_DASH_DASH] = ACTIONS(674),
    [anon_sym_PLUS_PLUS] = ACTIONS(674),
    [anon_sym_sizeof] = ACTIONS(676),
    [sym_number_literal] = ACTIONS(620),
    [sym_char_literal] = ACTIONS(620),
    [sym_string_literal] = ACTIONS(678),
    [sym_true] = ACTIONS(680),
    [sym_false] = ACTIONS(680),
    [sym_null] = ACTIONS(680),
    [sym_identifier] = ACTIONS(682),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(51),
    [sym_auto] = ACTIONS(33),
    [anon_sym_typename] = ACTIONS(53),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(684),
    [anon_sym_delete] = ACTIONS(686),
    [sym_nullptr] = ACTIONS(680),
  },
  [2831] = {
    [anon_sym_LPAREN] = ACTIONS(6943),
    [anon_sym_constexpr] = ACTIONS(6945),
    [sym_comment] = ACTIONS(49),
  },
  [2832] = {
    [anon_sym_LPAREN] = ACTIONS(6947),
    [sym_comment] = ACTIONS(49),
  },
  [2833] = {
    [sym__expression] = STATE(2933),
    [sym_conditional_expression] = STATE(2933),
    [sym_assignment_expression] = STATE(2933),
    [sym_pointer_expression] = STATE(2933),
    [sym_logical_expression] = STATE(2933),
    [sym_bitwise_expression] = STATE(2933),
    [sym_equality_expression] = STATE(2933),
    [sym_relational_expression] = STATE(2933),
    [sym_shift_expression] = STATE(2933),
    [sym_math_expression] = STATE(2933),
    [sym_cast_expression] = STATE(2933),
    [sym_sizeof_expression] = STATE(2933),
    [sym_subscript_expression] = STATE(2933),
    [sym_call_expression] = STATE(2933),
    [sym_field_expression] = STATE(2933),
    [sym_compound_literal_expression] = STATE(2933),
    [sym_parenthesized_expression] = STATE(2933),
    [sym_concatenated_string] = STATE(2933),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(2933),
    [sym_new_expression] = STATE(2933),
    [sym_delete_expression] = STATE(2933),
    [sym_lambda_expression] = STATE(2933),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(855),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(6949),
    [anon_sym_LPAREN] = ACTIONS(1634),
    [anon_sym_STAR] = ACTIONS(1636),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_AMP] = ACTIONS(1636),
    [anon_sym_BANG] = ACTIONS(1638),
    [anon_sym_TILDE] = ACTIONS(1640),
    [anon_sym_PLUS] = ACTIONS(1642),
    [anon_sym_DASH] = ACTIONS(1642),
    [anon_sym_DASH_DASH] = ACTIONS(1644),
    [anon_sym_PLUS_PLUS] = ACTIONS(1644),
    [anon_sym_sizeof] = ACTIONS(1646),
    [sym_number_literal] = ACTIONS(6949),
    [sym_char_literal] = ACTIONS(6949),
    [sym_string_literal] = ACTIONS(1648),
    [sym_true] = ACTIONS(6951),
    [sym_false] = ACTIONS(6951),
    [sym_null] = ACTIONS(6951),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1652),
    [anon_sym_delete] = ACTIONS(1654),
    [sym_nullptr] = ACTIONS(6951),
  },
  [2834] = {
    [anon_sym_COLON] = ACTIONS(6953),
    [sym_comment] = ACTIONS(49),
  },
  [2835] = {
    [anon_sym_LPAREN] = ACTIONS(6955),
    [sym_comment] = ACTIONS(49),
  },
  [2836] = {
    [sym_compound_statement] = STATE(2936),
    [sym_labeled_statement] = STATE(2936),
    [sym_expression_statement] = STATE(2936),
    [sym_if_statement] = STATE(2936),
    [sym_switch_statement] = STATE(2936),
    [sym_case_statement] = STATE(2936),
    [sym_while_statement] = STATE(2936),
    [sym_do_statement] = STATE(2936),
    [sym_for_statement] = STATE(2936),
    [sym_return_statement] = STATE(2936),
    [sym_break_statement] = STATE(2936),
    [sym_continue_statement] = STATE(2936),
    [sym_goto_statement] = STATE(2936),
    [sym__expression] = STATE(873),
    [sym_comma_expression] = STATE(874),
    [sym_conditional_expression] = STATE(873),
    [sym_assignment_expression] = STATE(873),
    [sym_pointer_expression] = STATE(873),
    [sym_logical_expression] = STATE(873),
    [sym_bitwise_expression] = STATE(873),
    [sym_equality_expression] = STATE(873),
    [sym_relational_expression] = STATE(873),
    [sym_shift_expression] = STATE(873),
    [sym_math_expression] = STATE(873),
    [sym_cast_expression] = STATE(873),
    [sym_sizeof_expression] = STATE(873),
    [sym_subscript_expression] = STATE(873),
    [sym_call_expression] = STATE(873),
    [sym_field_expression] = STATE(873),
    [sym_compound_literal_expression] = STATE(873),
    [sym_parenthesized_expression] = STATE(873),
    [sym_concatenated_string] = STATE(873),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(873),
    [sym_for_range_loop] = STATE(2936),
    [sym_new_expression] = STATE(873),
    [sym_delete_expression] = STATE(873),
    [sym_lambda_expression] = STATE(873),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(1660),
    [anon_sym_LPAREN] = ACTIONS(626),
    [anon_sym_SEMI] = ACTIONS(1662),
    [anon_sym_LBRACE] = ACTIONS(1664),
    [anon_sym_STAR] = ACTIONS(644),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_if] = ACTIONS(1666),
    [anon_sym_switch] = ACTIONS(1668),
    [anon_sym_case] = ACTIONS(1670),
    [anon_sym_default] = ACTIONS(1672),
    [anon_sym_while] = ACTIONS(1674),
    [anon_sym_do] = ACTIONS(1676),
    [anon_sym_for] = ACTIONS(1678),
    [anon_sym_return] = ACTIONS(1680),
    [anon_sym_break] = ACTIONS(1682),
    [anon_sym_continue] = ACTIONS(1684),
    [anon_sym_goto] = ACTIONS(1686),
    [anon_sym_AMP] = ACTIONS(644),
    [anon_sym_BANG] = ACTIONS(668),
    [anon_sym_TILDE] = ACTIONS(670),
    [anon_sym_PLUS] = ACTIONS(672),
    [anon_sym_DASH] = ACTIONS(672),
    [anon_sym_DASH_DASH] = ACTIONS(674),
    [anon_sym_PLUS_PLUS] = ACTIONS(674),
    [anon_sym_sizeof] = ACTIONS(676),
    [sym_number_literal] = ACTIONS(1660),
    [sym_char_literal] = ACTIONS(1660),
    [sym_string_literal] = ACTIONS(678),
    [sym_true] = ACTIONS(1688),
    [sym_false] = ACTIONS(1688),
    [sym_null] = ACTIONS(1688),
    [sym_identifier] = ACTIONS(1690),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1303),
    [anon_sym_delete] = ACTIONS(686),
    [sym_nullptr] = ACTIONS(1688),
  },
  [2837] = {
    [anon_sym_LPAREN] = ACTIONS(6957),
    [sym_comment] = ACTIONS(49),
  },
  [2838] = {
    [sym__expression] = STATE(2939),
    [sym_conditional_expression] = STATE(2939),
    [sym_assignment_expression] = STATE(2939),
    [sym_pointer_expression] = STATE(2939),
    [sym_logical_expression] = STATE(2939),
    [sym_bitwise_expression] = STATE(2939),
    [sym_equality_expression] = STATE(2939),
    [sym_relational_expression] = STATE(2939),
    [sym_shift_expression] = STATE(2939),
    [sym_math_expression] = STATE(2939),
    [sym_cast_expression] = STATE(2939),
    [sym_sizeof_expression] = STATE(2939),
    [sym_subscript_expression] = STATE(2939),
    [sym_call_expression] = STATE(2939),
    [sym_field_expression] = STATE(2939),
    [sym_compound_literal_expression] = STATE(2939),
    [sym_parenthesized_expression] = STATE(2939),
    [sym_initializer_list] = STATE(2940),
    [sym_concatenated_string] = STATE(2939),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(2939),
    [sym_new_expression] = STATE(2939),
    [sym_delete_expression] = STATE(2939),
    [sym_lambda_expression] = STATE(2939),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(6959),
    [anon_sym_LPAREN] = ACTIONS(1347),
    [anon_sym_SEMI] = ACTIONS(6961),
    [anon_sym_LBRACE] = ACTIONS(548),
    [anon_sym_STAR] = ACTIONS(1349),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_AMP] = ACTIONS(1349),
    [anon_sym_BANG] = ACTIONS(1351),
    [anon_sym_TILDE] = ACTIONS(1353),
    [anon_sym_PLUS] = ACTIONS(1355),
    [anon_sym_DASH] = ACTIONS(1355),
    [anon_sym_DASH_DASH] = ACTIONS(1357),
    [anon_sym_PLUS_PLUS] = ACTIONS(1357),
    [anon_sym_sizeof] = ACTIONS(1359),
    [sym_number_literal] = ACTIONS(6959),
    [sym_char_literal] = ACTIONS(6959),
    [sym_string_literal] = ACTIONS(1361),
    [sym_true] = ACTIONS(6963),
    [sym_false] = ACTIONS(6963),
    [sym_null] = ACTIONS(6963),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1365),
    [anon_sym_delete] = ACTIONS(1367),
    [sym_nullptr] = ACTIONS(6963),
  },
  [2839] = {
    [anon_sym_SEMI] = ACTIONS(6965),
    [sym_comment] = ACTIONS(49),
  },
  [2840] = {
    [anon_sym_SEMI] = ACTIONS(6967),
    [sym_comment] = ACTIONS(49),
  },
  [2841] = {
    [sym_identifier] = ACTIONS(6969),
    [sym_comment] = ACTIONS(49),
  },
  [2842] = {
    [sym_initializer_list] = STATE(765),
    [sym_template_argument_list] = STATE(1097),
    [anon_sym_LPAREN] = ACTIONS(1477),
    [anon_sym_COMMA] = ACTIONS(1477),
    [anon_sym_SEMI] = ACTIONS(1477),
    [anon_sym_LBRACE] = ACTIONS(548),
    [anon_sym_STAR] = ACTIONS(1479),
    [anon_sym_LBRACK] = ACTIONS(1477),
    [anon_sym_EQ] = ACTIONS(1479),
    [anon_sym_COLON] = ACTIONS(6971),
    [anon_sym_QMARK] = ACTIONS(1477),
    [anon_sym_STAR_EQ] = ACTIONS(1477),
    [anon_sym_SLASH_EQ] = ACTIONS(1477),
    [anon_sym_PERCENT_EQ] = ACTIONS(1477),
    [anon_sym_PLUS_EQ] = ACTIONS(1477),
    [anon_sym_DASH_EQ] = ACTIONS(1477),
    [anon_sym_LT_LT_EQ] = ACTIONS(1477),
    [anon_sym_GT_GT_EQ] = ACTIONS(1477),
    [anon_sym_AMP_EQ] = ACTIONS(1477),
    [anon_sym_CARET_EQ] = ACTIONS(1477),
    [anon_sym_PIPE_EQ] = ACTIONS(1477),
    [anon_sym_AMP] = ACTIONS(1479),
    [anon_sym_PIPE_PIPE] = ACTIONS(1477),
    [anon_sym_AMP_AMP] = ACTIONS(1477),
    [anon_sym_PIPE] = ACTIONS(1479),
    [anon_sym_CARET] = ACTIONS(1479),
    [anon_sym_EQ_EQ] = ACTIONS(1477),
    [anon_sym_BANG_EQ] = ACTIONS(1477),
    [anon_sym_LT] = ACTIONS(1564),
    [anon_sym_GT] = ACTIONS(1479),
    [anon_sym_LT_EQ] = ACTIONS(1477),
    [anon_sym_GT_EQ] = ACTIONS(1477),
    [anon_sym_LT_LT] = ACTIONS(1479),
    [anon_sym_GT_GT] = ACTIONS(1479),
    [anon_sym_PLUS] = ACTIONS(1479),
    [anon_sym_DASH] = ACTIONS(1479),
    [anon_sym_SLASH] = ACTIONS(1479),
    [anon_sym_PERCENT] = ACTIONS(1479),
    [anon_sym_DASH_DASH] = ACTIONS(1477),
    [anon_sym_PLUS_PLUS] = ACTIONS(1477),
    [anon_sym_DOT] = ACTIONS(1477),
    [anon_sym_DASH_GT] = ACTIONS(1477),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(2218),
  },
  [2843] = {
    [sym_raw_string_literal] = ACTIONS(6267),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(6269),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(6269),
    [anon_sym_LPAREN] = ACTIONS(6267),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(6269),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(6269),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(6269),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(6269),
    [sym_preproc_directive] = ACTIONS(6269),
    [anon_sym_SEMI] = ACTIONS(6267),
    [anon_sym_typedef] = ACTIONS(6269),
    [anon_sym_extern] = ACTIONS(6269),
    [anon_sym_LBRACE] = ACTIONS(6267),
    [anon_sym_STAR] = ACTIONS(6267),
    [anon_sym_LBRACK] = ACTIONS(6267),
    [anon_sym_static] = ACTIONS(6269),
    [anon_sym_register] = ACTIONS(6269),
    [anon_sym_inline] = ACTIONS(6269),
    [anon_sym_const] = ACTIONS(6269),
    [anon_sym_restrict] = ACTIONS(6269),
    [anon_sym_volatile] = ACTIONS(6269),
    [anon_sym__Atomic] = ACTIONS(6269),
    [anon_sym_mutable] = ACTIONS(6269),
    [anon_sym_explicit] = ACTIONS(6269),
    [anon_sym_constexpr] = ACTIONS(6269),
    [anon_sym_unsigned] = ACTIONS(6269),
    [anon_sym_long] = ACTIONS(6269),
    [anon_sym_short] = ACTIONS(6269),
    [sym_primitive_type] = ACTIONS(6269),
    [anon_sym_enum] = ACTIONS(6269),
    [anon_sym_struct] = ACTIONS(6269),
    [anon_sym_union] = ACTIONS(6269),
    [anon_sym_if] = ACTIONS(6269),
    [anon_sym_else] = ACTIONS(6973),
    [anon_sym_switch] = ACTIONS(6269),
    [anon_sym_case] = ACTIONS(6269),
    [anon_sym_default] = ACTIONS(6269),
    [anon_sym_while] = ACTIONS(6269),
    [anon_sym_do] = ACTIONS(6269),
    [anon_sym_for] = ACTIONS(6269),
    [anon_sym_return] = ACTIONS(6269),
    [anon_sym_break] = ACTIONS(6269),
    [anon_sym_continue] = ACTIONS(6269),
    [anon_sym_goto] = ACTIONS(6269),
    [anon_sym_AMP] = ACTIONS(6267),
    [anon_sym_BANG] = ACTIONS(6267),
    [anon_sym_TILDE] = ACTIONS(6267),
    [anon_sym_PLUS] = ACTIONS(6269),
    [anon_sym_DASH] = ACTIONS(6269),
    [anon_sym_DASH_DASH] = ACTIONS(6267),
    [anon_sym_PLUS_PLUS] = ACTIONS(6267),
    [anon_sym_sizeof] = ACTIONS(6269),
    [sym_number_literal] = ACTIONS(6267),
    [sym_char_literal] = ACTIONS(6267),
    [sym_string_literal] = ACTIONS(6267),
    [sym_true] = ACTIONS(6269),
    [sym_false] = ACTIONS(6269),
    [sym_null] = ACTIONS(6269),
    [sym_identifier] = ACTIONS(6269),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(6269),
    [sym_auto] = ACTIONS(6269),
    [anon_sym_typename] = ACTIONS(6269),
    [anon_sym_new] = ACTIONS(6269),
    [anon_sym_COLON_COLON] = ACTIONS(6267),
    [anon_sym_delete] = ACTIONS(6269),
    [sym_nullptr] = ACTIONS(6269),
  },
  [2844] = {
    [sym_argument_list] = STATE(802),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_COMMA] = ACTIONS(1740),
    [anon_sym_SEMI] = ACTIONS(6975),
    [anon_sym_STAR] = ACTIONS(1744),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_EQ] = ACTIONS(1746),
    [anon_sym_QMARK] = ACTIONS(1748),
    [anon_sym_STAR_EQ] = ACTIONS(1750),
    [anon_sym_SLASH_EQ] = ACTIONS(1750),
    [anon_sym_PERCENT_EQ] = ACTIONS(1750),
    [anon_sym_PLUS_EQ] = ACTIONS(1750),
    [anon_sym_DASH_EQ] = ACTIONS(1750),
    [anon_sym_LT_LT_EQ] = ACTIONS(1750),
    [anon_sym_GT_GT_EQ] = ACTIONS(1750),
    [anon_sym_AMP_EQ] = ACTIONS(1750),
    [anon_sym_CARET_EQ] = ACTIONS(1750),
    [anon_sym_PIPE_EQ] = ACTIONS(1750),
    [anon_sym_AMP] = ACTIONS(1752),
    [anon_sym_PIPE_PIPE] = ACTIONS(1754),
    [anon_sym_AMP_AMP] = ACTIONS(1756),
    [anon_sym_PIPE] = ACTIONS(1758),
    [anon_sym_CARET] = ACTIONS(1760),
    [anon_sym_EQ_EQ] = ACTIONS(1762),
    [anon_sym_BANG_EQ] = ACTIONS(1762),
    [anon_sym_LT] = ACTIONS(1764),
    [anon_sym_GT] = ACTIONS(1764),
    [anon_sym_LT_EQ] = ACTIONS(1766),
    [anon_sym_GT_EQ] = ACTIONS(1766),
    [anon_sym_LT_LT] = ACTIONS(1768),
    [anon_sym_GT_GT] = ACTIONS(1768),
    [anon_sym_PLUS] = ACTIONS(1770),
    [anon_sym_DASH] = ACTIONS(1770),
    [anon_sym_SLASH] = ACTIONS(1744),
    [anon_sym_PERCENT] = ACTIONS(1744),
    [anon_sym_DASH_DASH] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(1554),
    [anon_sym_DASH_GT] = ACTIONS(1554),
    [sym_comment] = ACTIONS(49),
  },
  [2845] = {
    [anon_sym_SEMI] = ACTIONS(6975),
    [sym_comment] = ACTIONS(49),
  },
  [2846] = {
    [sym_compound_statement] = STATE(2947),
    [sym_labeled_statement] = STATE(2947),
    [sym_expression_statement] = STATE(2947),
    [sym_if_statement] = STATE(2947),
    [sym_switch_statement] = STATE(2947),
    [sym_case_statement] = STATE(2947),
    [sym_while_statement] = STATE(2947),
    [sym_do_statement] = STATE(2947),
    [sym_for_statement] = STATE(2947),
    [sym_return_statement] = STATE(2947),
    [sym_break_statement] = STATE(2947),
    [sym_continue_statement] = STATE(2947),
    [sym_goto_statement] = STATE(2947),
    [sym__expression] = STATE(2844),
    [sym_comma_expression] = STATE(2845),
    [sym_conditional_expression] = STATE(2844),
    [sym_assignment_expression] = STATE(2844),
    [sym_pointer_expression] = STATE(2844),
    [sym_logical_expression] = STATE(2844),
    [sym_bitwise_expression] = STATE(2844),
    [sym_equality_expression] = STATE(2844),
    [sym_relational_expression] = STATE(2844),
    [sym_shift_expression] = STATE(2844),
    [sym_math_expression] = STATE(2844),
    [sym_cast_expression] = STATE(2844),
    [sym_sizeof_expression] = STATE(2844),
    [sym_subscript_expression] = STATE(2844),
    [sym_call_expression] = STATE(2844),
    [sym_field_expression] = STATE(2844),
    [sym_compound_literal_expression] = STATE(2844),
    [sym_parenthesized_expression] = STATE(2844),
    [sym_concatenated_string] = STATE(2844),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(2844),
    [sym_for_range_loop] = STATE(2947),
    [sym_new_expression] = STATE(2844),
    [sym_delete_expression] = STATE(2844),
    [sym_lambda_expression] = STATE(2844),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(6732),
    [anon_sym_LPAREN] = ACTIONS(626),
    [anon_sym_SEMI] = ACTIONS(6734),
    [anon_sym_LBRACE] = ACTIONS(6736),
    [anon_sym_STAR] = ACTIONS(644),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_if] = ACTIONS(6738),
    [anon_sym_switch] = ACTIONS(6740),
    [anon_sym_case] = ACTIONS(6742),
    [anon_sym_default] = ACTIONS(6744),
    [anon_sym_while] = ACTIONS(6746),
    [anon_sym_do] = ACTIONS(6748),
    [anon_sym_for] = ACTIONS(6750),
    [anon_sym_return] = ACTIONS(6752),
    [anon_sym_break] = ACTIONS(6754),
    [anon_sym_continue] = ACTIONS(6756),
    [anon_sym_goto] = ACTIONS(6758),
    [anon_sym_AMP] = ACTIONS(644),
    [anon_sym_BANG] = ACTIONS(668),
    [anon_sym_TILDE] = ACTIONS(670),
    [anon_sym_PLUS] = ACTIONS(672),
    [anon_sym_DASH] = ACTIONS(672),
    [anon_sym_DASH_DASH] = ACTIONS(674),
    [anon_sym_PLUS_PLUS] = ACTIONS(674),
    [anon_sym_sizeof] = ACTIONS(676),
    [sym_number_literal] = ACTIONS(6732),
    [sym_char_literal] = ACTIONS(6732),
    [sym_string_literal] = ACTIONS(678),
    [sym_true] = ACTIONS(6760),
    [sym_false] = ACTIONS(6760),
    [sym_null] = ACTIONS(6760),
    [sym_identifier] = ACTIONS(6762),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1303),
    [anon_sym_delete] = ACTIONS(686),
    [sym_nullptr] = ACTIONS(6760),
  },
  [2847] = {
    [sym_raw_string_literal] = ACTIONS(6277),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(6279),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(6279),
    [anon_sym_LPAREN] = ACTIONS(6277),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(6279),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(6279),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(6279),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(6279),
    [sym_preproc_directive] = ACTIONS(6279),
    [anon_sym_SEMI] = ACTIONS(6277),
    [anon_sym_typedef] = ACTIONS(6279),
    [anon_sym_extern] = ACTIONS(6279),
    [anon_sym_LBRACE] = ACTIONS(6277),
    [anon_sym_STAR] = ACTIONS(6277),
    [anon_sym_LBRACK] = ACTIONS(6277),
    [anon_sym_static] = ACTIONS(6279),
    [anon_sym_register] = ACTIONS(6279),
    [anon_sym_inline] = ACTIONS(6279),
    [anon_sym_const] = ACTIONS(6279),
    [anon_sym_restrict] = ACTIONS(6279),
    [anon_sym_volatile] = ACTIONS(6279),
    [anon_sym__Atomic] = ACTIONS(6279),
    [anon_sym_mutable] = ACTIONS(6279),
    [anon_sym_explicit] = ACTIONS(6279),
    [anon_sym_constexpr] = ACTIONS(6279),
    [anon_sym_unsigned] = ACTIONS(6279),
    [anon_sym_long] = ACTIONS(6279),
    [anon_sym_short] = ACTIONS(6279),
    [sym_primitive_type] = ACTIONS(6279),
    [anon_sym_enum] = ACTIONS(6279),
    [anon_sym_struct] = ACTIONS(6279),
    [anon_sym_union] = ACTIONS(6279),
    [anon_sym_if] = ACTIONS(6279),
    [anon_sym_switch] = ACTIONS(6279),
    [anon_sym_case] = ACTIONS(6279),
    [anon_sym_default] = ACTIONS(6279),
    [anon_sym_while] = ACTIONS(6279),
    [anon_sym_do] = ACTIONS(6279),
    [anon_sym_for] = ACTIONS(6279),
    [anon_sym_return] = ACTIONS(6279),
    [anon_sym_break] = ACTIONS(6279),
    [anon_sym_continue] = ACTIONS(6279),
    [anon_sym_goto] = ACTIONS(6279),
    [anon_sym_AMP] = ACTIONS(6277),
    [anon_sym_BANG] = ACTIONS(6277),
    [anon_sym_TILDE] = ACTIONS(6277),
    [anon_sym_PLUS] = ACTIONS(6279),
    [anon_sym_DASH] = ACTIONS(6279),
    [anon_sym_DASH_DASH] = ACTIONS(6277),
    [anon_sym_PLUS_PLUS] = ACTIONS(6277),
    [anon_sym_sizeof] = ACTIONS(6279),
    [sym_number_literal] = ACTIONS(6277),
    [sym_char_literal] = ACTIONS(6277),
    [sym_string_literal] = ACTIONS(6277),
    [sym_true] = ACTIONS(6279),
    [sym_false] = ACTIONS(6279),
    [sym_null] = ACTIONS(6279),
    [sym_identifier] = ACTIONS(6279),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(6279),
    [sym_auto] = ACTIONS(6279),
    [anon_sym_typename] = ACTIONS(6279),
    [anon_sym_new] = ACTIONS(6279),
    [anon_sym_COLON_COLON] = ACTIONS(6277),
    [anon_sym_delete] = ACTIONS(6279),
    [sym_nullptr] = ACTIONS(6279),
  },
  [2848] = {
    [sym_raw_string_literal] = ACTIONS(6293),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(6295),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(6295),
    [anon_sym_LPAREN] = ACTIONS(6293),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(6295),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(6295),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(6295),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(6295),
    [sym_preproc_directive] = ACTIONS(6295),
    [anon_sym_SEMI] = ACTIONS(6293),
    [anon_sym_typedef] = ACTIONS(6295),
    [anon_sym_extern] = ACTIONS(6295),
    [anon_sym_LBRACE] = ACTIONS(6293),
    [anon_sym_STAR] = ACTIONS(6293),
    [anon_sym_LBRACK] = ACTIONS(6293),
    [anon_sym_static] = ACTIONS(6295),
    [anon_sym_register] = ACTIONS(6295),
    [anon_sym_inline] = ACTIONS(6295),
    [anon_sym_const] = ACTIONS(6295),
    [anon_sym_restrict] = ACTIONS(6295),
    [anon_sym_volatile] = ACTIONS(6295),
    [anon_sym__Atomic] = ACTIONS(6295),
    [anon_sym_mutable] = ACTIONS(6295),
    [anon_sym_explicit] = ACTIONS(6295),
    [anon_sym_constexpr] = ACTIONS(6295),
    [anon_sym_unsigned] = ACTIONS(6295),
    [anon_sym_long] = ACTIONS(6295),
    [anon_sym_short] = ACTIONS(6295),
    [sym_primitive_type] = ACTIONS(6295),
    [anon_sym_enum] = ACTIONS(6295),
    [anon_sym_struct] = ACTIONS(6295),
    [anon_sym_union] = ACTIONS(6295),
    [anon_sym_if] = ACTIONS(6295),
    [anon_sym_switch] = ACTIONS(6295),
    [anon_sym_case] = ACTIONS(6295),
    [anon_sym_default] = ACTIONS(6295),
    [anon_sym_while] = ACTIONS(6295),
    [anon_sym_do] = ACTIONS(6295),
    [anon_sym_for] = ACTIONS(6295),
    [anon_sym_return] = ACTIONS(6295),
    [anon_sym_break] = ACTIONS(6295),
    [anon_sym_continue] = ACTIONS(6295),
    [anon_sym_goto] = ACTIONS(6295),
    [anon_sym_AMP] = ACTIONS(6293),
    [anon_sym_BANG] = ACTIONS(6293),
    [anon_sym_TILDE] = ACTIONS(6293),
    [anon_sym_PLUS] = ACTIONS(6295),
    [anon_sym_DASH] = ACTIONS(6295),
    [anon_sym_DASH_DASH] = ACTIONS(6293),
    [anon_sym_PLUS_PLUS] = ACTIONS(6293),
    [anon_sym_sizeof] = ACTIONS(6295),
    [sym_number_literal] = ACTIONS(6293),
    [sym_char_literal] = ACTIONS(6293),
    [sym_string_literal] = ACTIONS(6293),
    [sym_true] = ACTIONS(6295),
    [sym_false] = ACTIONS(6295),
    [sym_null] = ACTIONS(6295),
    [sym_identifier] = ACTIONS(6295),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(6295),
    [sym_auto] = ACTIONS(6295),
    [anon_sym_typename] = ACTIONS(6295),
    [anon_sym_new] = ACTIONS(6295),
    [anon_sym_COLON_COLON] = ACTIONS(6293),
    [anon_sym_delete] = ACTIONS(6295),
    [sym_nullptr] = ACTIONS(6295),
  },
  [2849] = {
    [sym_argument_list] = STATE(802),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_RPAREN] = ACTIONS(6977),
    [anon_sym_STAR] = ACTIONS(4537),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_EQ] = ACTIONS(4539),
    [anon_sym_QMARK] = ACTIONS(4541),
    [anon_sym_STAR_EQ] = ACTIONS(4543),
    [anon_sym_SLASH_EQ] = ACTIONS(4543),
    [anon_sym_PERCENT_EQ] = ACTIONS(4543),
    [anon_sym_PLUS_EQ] = ACTIONS(4543),
    [anon_sym_DASH_EQ] = ACTIONS(4543),
    [anon_sym_LT_LT_EQ] = ACTIONS(4543),
    [anon_sym_GT_GT_EQ] = ACTIONS(4543),
    [anon_sym_AMP_EQ] = ACTIONS(4543),
    [anon_sym_CARET_EQ] = ACTIONS(4543),
    [anon_sym_PIPE_EQ] = ACTIONS(4543),
    [anon_sym_AMP] = ACTIONS(4545),
    [anon_sym_PIPE_PIPE] = ACTIONS(4547),
    [anon_sym_AMP_AMP] = ACTIONS(4549),
    [anon_sym_PIPE] = ACTIONS(4551),
    [anon_sym_CARET] = ACTIONS(4553),
    [anon_sym_EQ_EQ] = ACTIONS(4555),
    [anon_sym_BANG_EQ] = ACTIONS(4555),
    [anon_sym_LT] = ACTIONS(4557),
    [anon_sym_GT] = ACTIONS(4557),
    [anon_sym_LT_EQ] = ACTIONS(4559),
    [anon_sym_GT_EQ] = ACTIONS(4559),
    [anon_sym_LT_LT] = ACTIONS(4561),
    [anon_sym_GT_GT] = ACTIONS(4561),
    [anon_sym_PLUS] = ACTIONS(4563),
    [anon_sym_DASH] = ACTIONS(4563),
    [anon_sym_SLASH] = ACTIONS(4537),
    [anon_sym_PERCENT] = ACTIONS(4537),
    [anon_sym_DASH_DASH] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(1554),
    [anon_sym_DASH_GT] = ACTIONS(1554),
    [sym_comment] = ACTIONS(49),
  },
  [2850] = {
    [sym_compound_statement] = STATE(2949),
    [sym_labeled_statement] = STATE(2949),
    [sym_expression_statement] = STATE(2949),
    [sym_if_statement] = STATE(2949),
    [sym_switch_statement] = STATE(2949),
    [sym_case_statement] = STATE(2949),
    [sym_while_statement] = STATE(2949),
    [sym_do_statement] = STATE(2949),
    [sym_for_statement] = STATE(2949),
    [sym_return_statement] = STATE(2949),
    [sym_break_statement] = STATE(2949),
    [sym_continue_statement] = STATE(2949),
    [sym_goto_statement] = STATE(2949),
    [sym__expression] = STATE(1947),
    [sym_comma_expression] = STATE(1948),
    [sym_conditional_expression] = STATE(1947),
    [sym_assignment_expression] = STATE(1947),
    [sym_pointer_expression] = STATE(1947),
    [sym_logical_expression] = STATE(1947),
    [sym_bitwise_expression] = STATE(1947),
    [sym_equality_expression] = STATE(1947),
    [sym_relational_expression] = STATE(1947),
    [sym_shift_expression] = STATE(1947),
    [sym_math_expression] = STATE(1947),
    [sym_cast_expression] = STATE(1947),
    [sym_sizeof_expression] = STATE(1947),
    [sym_subscript_expression] = STATE(1947),
    [sym_call_expression] = STATE(1947),
    [sym_field_expression] = STATE(1947),
    [sym_compound_literal_expression] = STATE(1947),
    [sym_parenthesized_expression] = STATE(1947),
    [sym_concatenated_string] = STATE(1947),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(1947),
    [sym_for_range_loop] = STATE(2949),
    [sym_new_expression] = STATE(1947),
    [sym_delete_expression] = STATE(1947),
    [sym_lambda_expression] = STATE(1947),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(4395),
    [anon_sym_LPAREN] = ACTIONS(626),
    [anon_sym_SEMI] = ACTIONS(4411),
    [anon_sym_LBRACE] = ACTIONS(4415),
    [anon_sym_STAR] = ACTIONS(644),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_if] = ACTIONS(4417),
    [anon_sym_switch] = ACTIONS(4419),
    [anon_sym_case] = ACTIONS(4421),
    [anon_sym_default] = ACTIONS(4423),
    [anon_sym_while] = ACTIONS(4425),
    [anon_sym_do] = ACTIONS(4427),
    [anon_sym_for] = ACTIONS(4429),
    [anon_sym_return] = ACTIONS(4431),
    [anon_sym_break] = ACTIONS(4433),
    [anon_sym_continue] = ACTIONS(4435),
    [anon_sym_goto] = ACTIONS(4437),
    [anon_sym_AMP] = ACTIONS(644),
    [anon_sym_BANG] = ACTIONS(668),
    [anon_sym_TILDE] = ACTIONS(670),
    [anon_sym_PLUS] = ACTIONS(672),
    [anon_sym_DASH] = ACTIONS(672),
    [anon_sym_DASH_DASH] = ACTIONS(674),
    [anon_sym_PLUS_PLUS] = ACTIONS(674),
    [anon_sym_sizeof] = ACTIONS(676),
    [sym_number_literal] = ACTIONS(4395),
    [sym_char_literal] = ACTIONS(4395),
    [sym_string_literal] = ACTIONS(678),
    [sym_true] = ACTIONS(4439),
    [sym_false] = ACTIONS(4439),
    [sym_null] = ACTIONS(4439),
    [sym_identifier] = ACTIONS(6077),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1303),
    [anon_sym_delete] = ACTIONS(686),
    [sym_nullptr] = ACTIONS(4439),
  },
  [2851] = {
    [sym_argument_list] = STATE(802),
    [aux_sym_for_statement_repeat1] = STATE(2951),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_COMMA] = ACTIONS(6339),
    [anon_sym_RPAREN] = ACTIONS(6979),
    [anon_sym_STAR] = ACTIONS(2234),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_EQ] = ACTIONS(2236),
    [anon_sym_QMARK] = ACTIONS(2238),
    [anon_sym_STAR_EQ] = ACTIONS(2240),
    [anon_sym_SLASH_EQ] = ACTIONS(2240),
    [anon_sym_PERCENT_EQ] = ACTIONS(2240),
    [anon_sym_PLUS_EQ] = ACTIONS(2240),
    [anon_sym_DASH_EQ] = ACTIONS(2240),
    [anon_sym_LT_LT_EQ] = ACTIONS(2240),
    [anon_sym_GT_GT_EQ] = ACTIONS(2240),
    [anon_sym_AMP_EQ] = ACTIONS(2240),
    [anon_sym_CARET_EQ] = ACTIONS(2240),
    [anon_sym_PIPE_EQ] = ACTIONS(2240),
    [anon_sym_AMP] = ACTIONS(2242),
    [anon_sym_PIPE_PIPE] = ACTIONS(2244),
    [anon_sym_AMP_AMP] = ACTIONS(2246),
    [anon_sym_PIPE] = ACTIONS(2248),
    [anon_sym_CARET] = ACTIONS(2250),
    [anon_sym_EQ_EQ] = ACTIONS(2252),
    [anon_sym_BANG_EQ] = ACTIONS(2252),
    [anon_sym_LT] = ACTIONS(2254),
    [anon_sym_GT] = ACTIONS(2254),
    [anon_sym_LT_EQ] = ACTIONS(2256),
    [anon_sym_GT_EQ] = ACTIONS(2256),
    [anon_sym_LT_LT] = ACTIONS(2258),
    [anon_sym_GT_GT] = ACTIONS(2258),
    [anon_sym_PLUS] = ACTIONS(2260),
    [anon_sym_DASH] = ACTIONS(2260),
    [anon_sym_SLASH] = ACTIONS(2234),
    [anon_sym_PERCENT] = ACTIONS(2234),
    [anon_sym_DASH_DASH] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(1554),
    [anon_sym_DASH_GT] = ACTIONS(1554),
    [sym_comment] = ACTIONS(49),
  },
  [2852] = {
    [sym__expression] = STATE(2952),
    [sym_conditional_expression] = STATE(2952),
    [sym_assignment_expression] = STATE(2952),
    [sym_pointer_expression] = STATE(2952),
    [sym_logical_expression] = STATE(2952),
    [sym_bitwise_expression] = STATE(2952),
    [sym_equality_expression] = STATE(2952),
    [sym_relational_expression] = STATE(2952),
    [sym_shift_expression] = STATE(2952),
    [sym_math_expression] = STATE(2952),
    [sym_cast_expression] = STATE(2952),
    [sym_sizeof_expression] = STATE(2952),
    [sym_subscript_expression] = STATE(2952),
    [sym_call_expression] = STATE(2952),
    [sym_field_expression] = STATE(2952),
    [sym_compound_literal_expression] = STATE(2952),
    [sym_parenthesized_expression] = STATE(2952),
    [sym_concatenated_string] = STATE(2952),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(2952),
    [sym_new_expression] = STATE(2952),
    [sym_delete_expression] = STATE(2952),
    [sym_lambda_expression] = STATE(2952),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(6981),
    [anon_sym_LPAREN] = ACTIONS(1087),
    [anon_sym_RPAREN] = ACTIONS(6979),
    [anon_sym_STAR] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_AMP] = ACTIONS(1089),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1093),
    [anon_sym_PLUS] = ACTIONS(1095),
    [anon_sym_DASH] = ACTIONS(1095),
    [anon_sym_DASH_DASH] = ACTIONS(1097),
    [anon_sym_PLUS_PLUS] = ACTIONS(1097),
    [anon_sym_sizeof] = ACTIONS(1099),
    [sym_number_literal] = ACTIONS(6981),
    [sym_char_literal] = ACTIONS(6981),
    [sym_string_literal] = ACTIONS(1101),
    [sym_true] = ACTIONS(6983),
    [sym_false] = ACTIONS(6983),
    [sym_null] = ACTIONS(6983),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_delete] = ACTIONS(1109),
    [sym_nullptr] = ACTIONS(6983),
  },
  [2853] = {
    [sym_argument_list] = STATE(802),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_SEMI] = ACTIONS(6985),
    [anon_sym_STAR] = ACTIONS(2553),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_EQ] = ACTIONS(2555),
    [anon_sym_QMARK] = ACTIONS(2557),
    [anon_sym_STAR_EQ] = ACTIONS(2559),
    [anon_sym_SLASH_EQ] = ACTIONS(2559),
    [anon_sym_PERCENT_EQ] = ACTIONS(2559),
    [anon_sym_PLUS_EQ] = ACTIONS(2559),
    [anon_sym_DASH_EQ] = ACTIONS(2559),
    [anon_sym_LT_LT_EQ] = ACTIONS(2559),
    [anon_sym_GT_GT_EQ] = ACTIONS(2559),
    [anon_sym_AMP_EQ] = ACTIONS(2559),
    [anon_sym_CARET_EQ] = ACTIONS(2559),
    [anon_sym_PIPE_EQ] = ACTIONS(2559),
    [anon_sym_AMP] = ACTIONS(2561),
    [anon_sym_PIPE_PIPE] = ACTIONS(2563),
    [anon_sym_AMP_AMP] = ACTIONS(2565),
    [anon_sym_PIPE] = ACTIONS(2567),
    [anon_sym_CARET] = ACTIONS(2569),
    [anon_sym_EQ_EQ] = ACTIONS(2571),
    [anon_sym_BANG_EQ] = ACTIONS(2571),
    [anon_sym_LT] = ACTIONS(2573),
    [anon_sym_GT] = ACTIONS(2573),
    [anon_sym_LT_EQ] = ACTIONS(2575),
    [anon_sym_GT_EQ] = ACTIONS(2575),
    [anon_sym_LT_LT] = ACTIONS(2577),
    [anon_sym_GT_GT] = ACTIONS(2577),
    [anon_sym_PLUS] = ACTIONS(2579),
    [anon_sym_DASH] = ACTIONS(2579),
    [anon_sym_SLASH] = ACTIONS(2553),
    [anon_sym_PERCENT] = ACTIONS(2553),
    [anon_sym_DASH_DASH] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(1554),
    [anon_sym_DASH_GT] = ACTIONS(1554),
    [sym_comment] = ACTIONS(49),
  },
  [2854] = {
    [sym_argument_list] = STATE(802),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_RPAREN] = ACTIONS(6987),
    [anon_sym_STAR] = ACTIONS(4537),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_EQ] = ACTIONS(4539),
    [anon_sym_QMARK] = ACTIONS(4541),
    [anon_sym_STAR_EQ] = ACTIONS(4543),
    [anon_sym_SLASH_EQ] = ACTIONS(4543),
    [anon_sym_PERCENT_EQ] = ACTIONS(4543),
    [anon_sym_PLUS_EQ] = ACTIONS(4543),
    [anon_sym_DASH_EQ] = ACTIONS(4543),
    [anon_sym_LT_LT_EQ] = ACTIONS(4543),
    [anon_sym_GT_GT_EQ] = ACTIONS(4543),
    [anon_sym_AMP_EQ] = ACTIONS(4543),
    [anon_sym_CARET_EQ] = ACTIONS(4543),
    [anon_sym_PIPE_EQ] = ACTIONS(4543),
    [anon_sym_AMP] = ACTIONS(4545),
    [anon_sym_PIPE_PIPE] = ACTIONS(4547),
    [anon_sym_AMP_AMP] = ACTIONS(4549),
    [anon_sym_PIPE] = ACTIONS(4551),
    [anon_sym_CARET] = ACTIONS(4553),
    [anon_sym_EQ_EQ] = ACTIONS(4555),
    [anon_sym_BANG_EQ] = ACTIONS(4555),
    [anon_sym_LT] = ACTIONS(4557),
    [anon_sym_GT] = ACTIONS(4557),
    [anon_sym_LT_EQ] = ACTIONS(4559),
    [anon_sym_GT_EQ] = ACTIONS(4559),
    [anon_sym_LT_LT] = ACTIONS(4561),
    [anon_sym_GT_GT] = ACTIONS(4561),
    [anon_sym_PLUS] = ACTIONS(4563),
    [anon_sym_DASH] = ACTIONS(4563),
    [anon_sym_SLASH] = ACTIONS(4537),
    [anon_sym_PERCENT] = ACTIONS(4537),
    [anon_sym_DASH_DASH] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(1554),
    [anon_sym_DASH_GT] = ACTIONS(1554),
    [sym_comment] = ACTIONS(49),
  },
  [2855] = {
    [sym_raw_string_literal] = ACTIONS(4064),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(4066),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(4066),
    [anon_sym_LPAREN] = ACTIONS(4064),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(4066),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(4066),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(4066),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(4066),
    [sym_preproc_directive] = ACTIONS(4066),
    [anon_sym_SEMI] = ACTIONS(4064),
    [anon_sym_typedef] = ACTIONS(4066),
    [anon_sym_extern] = ACTIONS(4066),
    [anon_sym_LBRACE] = ACTIONS(4064),
    [anon_sym_STAR] = ACTIONS(4064),
    [anon_sym_LBRACK] = ACTIONS(4064),
    [anon_sym_static] = ACTIONS(4066),
    [anon_sym_register] = ACTIONS(4066),
    [anon_sym_inline] = ACTIONS(4066),
    [anon_sym_const] = ACTIONS(4066),
    [anon_sym_restrict] = ACTIONS(4066),
    [anon_sym_volatile] = ACTIONS(4066),
    [anon_sym__Atomic] = ACTIONS(4066),
    [anon_sym_mutable] = ACTIONS(4066),
    [anon_sym_explicit] = ACTIONS(4066),
    [anon_sym_constexpr] = ACTIONS(4066),
    [anon_sym_unsigned] = ACTIONS(4066),
    [anon_sym_long] = ACTIONS(4066),
    [anon_sym_short] = ACTIONS(4066),
    [sym_primitive_type] = ACTIONS(4066),
    [anon_sym_enum] = ACTIONS(4066),
    [anon_sym_struct] = ACTIONS(4066),
    [anon_sym_union] = ACTIONS(4066),
    [anon_sym_if] = ACTIONS(4066),
    [anon_sym_switch] = ACTIONS(4066),
    [anon_sym_case] = ACTIONS(4066),
    [anon_sym_default] = ACTIONS(4066),
    [anon_sym_while] = ACTIONS(4066),
    [anon_sym_do] = ACTIONS(4066),
    [anon_sym_for] = ACTIONS(4066),
    [anon_sym_return] = ACTIONS(4066),
    [anon_sym_break] = ACTIONS(4066),
    [anon_sym_continue] = ACTIONS(4066),
    [anon_sym_goto] = ACTIONS(4066),
    [anon_sym_AMP] = ACTIONS(4064),
    [anon_sym_BANG] = ACTIONS(4064),
    [anon_sym_TILDE] = ACTIONS(4064),
    [anon_sym_PLUS] = ACTIONS(4066),
    [anon_sym_DASH] = ACTIONS(4066),
    [anon_sym_DASH_DASH] = ACTIONS(4064),
    [anon_sym_PLUS_PLUS] = ACTIONS(4064),
    [anon_sym_sizeof] = ACTIONS(4066),
    [sym_number_literal] = ACTIONS(4064),
    [sym_char_literal] = ACTIONS(4064),
    [sym_string_literal] = ACTIONS(4064),
    [sym_true] = ACTIONS(4066),
    [sym_false] = ACTIONS(4066),
    [sym_null] = ACTIONS(4066),
    [sym_identifier] = ACTIONS(4066),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(4066),
    [sym_auto] = ACTIONS(4066),
    [anon_sym_typename] = ACTIONS(4066),
    [anon_sym_new] = ACTIONS(4066),
    [anon_sym_COLON_COLON] = ACTIONS(4064),
    [anon_sym_delete] = ACTIONS(4066),
    [sym_nullptr] = ACTIONS(4066),
  },
  [2856] = {
    [sym_raw_string_literal] = ACTIONS(4112),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(4114),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(4114),
    [anon_sym_LPAREN] = ACTIONS(4112),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(4114),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(4114),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(4114),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(4114),
    [sym_preproc_directive] = ACTIONS(4114),
    [anon_sym_SEMI] = ACTIONS(4112),
    [anon_sym_typedef] = ACTIONS(4114),
    [anon_sym_extern] = ACTIONS(4114),
    [anon_sym_LBRACE] = ACTIONS(4112),
    [anon_sym_STAR] = ACTIONS(4112),
    [anon_sym_LBRACK] = ACTIONS(4112),
    [anon_sym_static] = ACTIONS(4114),
    [anon_sym_register] = ACTIONS(4114),
    [anon_sym_inline] = ACTIONS(4114),
    [anon_sym_const] = ACTIONS(4114),
    [anon_sym_restrict] = ACTIONS(4114),
    [anon_sym_volatile] = ACTIONS(4114),
    [anon_sym__Atomic] = ACTIONS(4114),
    [anon_sym_mutable] = ACTIONS(4114),
    [anon_sym_explicit] = ACTIONS(4114),
    [anon_sym_constexpr] = ACTIONS(4114),
    [anon_sym_unsigned] = ACTIONS(4114),
    [anon_sym_long] = ACTIONS(4114),
    [anon_sym_short] = ACTIONS(4114),
    [sym_primitive_type] = ACTIONS(4114),
    [anon_sym_enum] = ACTIONS(4114),
    [anon_sym_struct] = ACTIONS(4114),
    [anon_sym_union] = ACTIONS(4114),
    [anon_sym_if] = ACTIONS(4114),
    [anon_sym_switch] = ACTIONS(4114),
    [anon_sym_case] = ACTIONS(4114),
    [anon_sym_default] = ACTIONS(4114),
    [anon_sym_while] = ACTIONS(4114),
    [anon_sym_do] = ACTIONS(4114),
    [anon_sym_for] = ACTIONS(4114),
    [anon_sym_return] = ACTIONS(4114),
    [anon_sym_break] = ACTIONS(4114),
    [anon_sym_continue] = ACTIONS(4114),
    [anon_sym_goto] = ACTIONS(4114),
    [anon_sym_AMP] = ACTIONS(4112),
    [anon_sym_BANG] = ACTIONS(4112),
    [anon_sym_TILDE] = ACTIONS(4112),
    [anon_sym_PLUS] = ACTIONS(4114),
    [anon_sym_DASH] = ACTIONS(4114),
    [anon_sym_DASH_DASH] = ACTIONS(4112),
    [anon_sym_PLUS_PLUS] = ACTIONS(4112),
    [anon_sym_sizeof] = ACTIONS(4114),
    [sym_number_literal] = ACTIONS(4112),
    [sym_char_literal] = ACTIONS(4112),
    [sym_string_literal] = ACTIONS(4112),
    [sym_true] = ACTIONS(4114),
    [sym_false] = ACTIONS(4114),
    [sym_null] = ACTIONS(4114),
    [sym_identifier] = ACTIONS(4114),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(4114),
    [sym_auto] = ACTIONS(4114),
    [anon_sym_typename] = ACTIONS(4114),
    [anon_sym_new] = ACTIONS(4114),
    [anon_sym_COLON_COLON] = ACTIONS(4112),
    [anon_sym_delete] = ACTIONS(4114),
    [sym_nullptr] = ACTIONS(4114),
  },
  [2857] = {
    [sym_raw_string_literal] = ACTIONS(1622),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1624),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1624),
    [anon_sym_LPAREN] = ACTIONS(1622),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1624),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(1624),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1624),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1624),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(1624),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(1624),
    [sym_preproc_directive] = ACTIONS(1624),
    [anon_sym_SEMI] = ACTIONS(1622),
    [anon_sym_typedef] = ACTIONS(1624),
    [anon_sym_extern] = ACTIONS(1624),
    [anon_sym_LBRACE] = ACTIONS(1622),
    [anon_sym_STAR] = ACTIONS(1622),
    [anon_sym_LBRACK] = ACTIONS(1622),
    [anon_sym_static] = ACTIONS(1624),
    [anon_sym_register] = ACTIONS(1624),
    [anon_sym_inline] = ACTIONS(1624),
    [anon_sym_const] = ACTIONS(1624),
    [anon_sym_restrict] = ACTIONS(1624),
    [anon_sym_volatile] = ACTIONS(1624),
    [anon_sym__Atomic] = ACTIONS(1624),
    [anon_sym_mutable] = ACTIONS(1624),
    [anon_sym_explicit] = ACTIONS(1624),
    [anon_sym_constexpr] = ACTIONS(1624),
    [anon_sym_unsigned] = ACTIONS(1624),
    [anon_sym_long] = ACTIONS(1624),
    [anon_sym_short] = ACTIONS(1624),
    [sym_primitive_type] = ACTIONS(1624),
    [anon_sym_enum] = ACTIONS(1624),
    [anon_sym_struct] = ACTIONS(1624),
    [anon_sym_union] = ACTIONS(1624),
    [anon_sym_if] = ACTIONS(1624),
    [anon_sym_else] = ACTIONS(1624),
    [anon_sym_switch] = ACTIONS(1624),
    [anon_sym_case] = ACTIONS(1624),
    [anon_sym_default] = ACTIONS(1624),
    [anon_sym_while] = ACTIONS(1624),
    [anon_sym_do] = ACTIONS(1624),
    [anon_sym_for] = ACTIONS(1624),
    [anon_sym_return] = ACTIONS(1624),
    [anon_sym_break] = ACTIONS(1624),
    [anon_sym_continue] = ACTIONS(1624),
    [anon_sym_goto] = ACTIONS(1624),
    [anon_sym_AMP] = ACTIONS(1622),
    [anon_sym_BANG] = ACTIONS(1622),
    [anon_sym_TILDE] = ACTIONS(1622),
    [anon_sym_PLUS] = ACTIONS(1624),
    [anon_sym_DASH] = ACTIONS(1624),
    [anon_sym_DASH_DASH] = ACTIONS(1622),
    [anon_sym_PLUS_PLUS] = ACTIONS(1622),
    [anon_sym_sizeof] = ACTIONS(1624),
    [sym_number_literal] = ACTIONS(1622),
    [sym_char_literal] = ACTIONS(1622),
    [sym_string_literal] = ACTIONS(1622),
    [sym_true] = ACTIONS(1624),
    [sym_false] = ACTIONS(1624),
    [sym_null] = ACTIONS(1624),
    [sym_identifier] = ACTIONS(1624),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(1624),
    [sym_auto] = ACTIONS(1624),
    [anon_sym_typename] = ACTIONS(1624),
    [anon_sym_new] = ACTIONS(1624),
    [anon_sym_COLON_COLON] = ACTIONS(1622),
    [anon_sym_delete] = ACTIONS(1624),
    [sym_nullptr] = ACTIONS(1624),
  },
  [2858] = {
    [sym_preproc_include] = STATE(913),
    [sym_preproc_def] = STATE(913),
    [sym_preproc_function_def] = STATE(913),
    [sym_preproc_call] = STATE(913),
    [sym_preproc_if_in_compound_statement] = STATE(410),
    [sym_preproc_ifdef_in_compound_statement] = STATE(411),
    [sym_declaration] = STATE(913),
    [sym_type_definition] = STATE(913),
    [sym__declaration_specifiers] = STATE(412),
    [sym_compound_statement] = STATE(913),
    [sym_storage_class_specifier] = STATE(419),
    [sym_type_qualifier] = STATE(419),
    [sym__type_specifier] = STATE(30),
    [sym_sized_type_specifier] = STATE(30),
    [sym_enum_specifier] = STATE(30),
    [sym_struct_specifier] = STATE(30),
    [sym_union_specifier] = STATE(30),
    [sym_labeled_statement] = STATE(913),
    [sym_expression_statement] = STATE(913),
    [sym_if_statement] = STATE(913),
    [sym_switch_statement] = STATE(913),
    [sym_case_statement] = STATE(913),
    [sym_while_statement] = STATE(913),
    [sym_do_statement] = STATE(913),
    [sym_for_statement] = STATE(913),
    [sym_return_statement] = STATE(913),
    [sym_break_statement] = STATE(913),
    [sym_continue_statement] = STATE(913),
    [sym_goto_statement] = STATE(913),
    [sym__expression] = STATE(413),
    [sym_comma_expression] = STATE(414),
    [sym_conditional_expression] = STATE(413),
    [sym_assignment_expression] = STATE(413),
    [sym_pointer_expression] = STATE(413),
    [sym_logical_expression] = STATE(413),
    [sym_bitwise_expression] = STATE(413),
    [sym_equality_expression] = STATE(413),
    [sym_relational_expression] = STATE(413),
    [sym_shift_expression] = STATE(413),
    [sym_math_expression] = STATE(413),
    [sym_cast_expression] = STATE(413),
    [sym_sizeof_expression] = STATE(413),
    [sym_subscript_expression] = STATE(413),
    [sym_call_expression] = STATE(413),
    [sym_field_expression] = STATE(413),
    [sym_compound_literal_expression] = STATE(413),
    [sym_parenthesized_expression] = STATE(413),
    [sym_concatenated_string] = STATE(413),
    [sym__empty_declaration] = STATE(913),
    [sym_macro_type_specifier] = STATE(30),
    [sym_class_specifier] = STATE(30),
    [sym_dependent_type] = STATE(30),
    [sym_structured_binding_declaration] = STATE(913),
    [sym_template_type] = STATE(415),
    [sym_template_function] = STATE(413),
    [sym_for_range_loop] = STATE(913),
    [sym_new_expression] = STATE(413),
    [sym_delete_expression] = STATE(413),
    [sym_lambda_expression] = STATE(413),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(416),
    [sym_scoped_namespace_identifier] = STATE(417),
    [aux_sym_preproc_if_in_compound_statement_repeat1] = STATE(913),
    [aux_sym__declaration_specifiers_repeat1] = STATE(419),
    [aux_sym_sized_type_specifier_repeat1] = STATE(38),
    [sym_raw_string_literal] = ACTIONS(620),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(622),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(624),
    [anon_sym_LPAREN] = ACTIONS(626),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(628),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(630),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(632),
    [sym_preproc_directive] = ACTIONS(634),
    [anon_sym_SEMI] = ACTIONS(636),
    [anon_sym_typedef] = ACTIONS(638),
    [anon_sym_extern] = ACTIONS(154),
    [anon_sym_LBRACE] = ACTIONS(640),
    [anon_sym_RBRACE] = ACTIONS(6989),
    [anon_sym_STAR] = ACTIONS(644),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_static] = ACTIONS(154),
    [anon_sym_register] = ACTIONS(154),
    [anon_sym_inline] = ACTIONS(154),
    [anon_sym_const] = ACTIONS(158),
    [anon_sym_restrict] = ACTIONS(158),
    [anon_sym_volatile] = ACTIONS(158),
    [anon_sym__Atomic] = ACTIONS(158),
    [anon_sym_mutable] = ACTIONS(158),
    [anon_sym_explicit] = ACTIONS(158),
    [anon_sym_constexpr] = ACTIONS(158),
    [anon_sym_unsigned] = ACTIONS(31),
    [anon_sym_long] = ACTIONS(31),
    [anon_sym_short] = ACTIONS(31),
    [sym_primitive_type] = ACTIONS(33),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_union] = ACTIONS(39),
    [anon_sym_if] = ACTIONS(646),
    [anon_sym_switch] = ACTIONS(648),
    [anon_sym_case] = ACTIONS(650),
    [anon_sym_default] = ACTIONS(652),
    [anon_sym_while] = ACTIONS(654),
    [anon_sym_do] = ACTIONS(656),
    [anon_sym_for] = ACTIONS(658),
    [anon_sym_return] = ACTIONS(660),
    [anon_sym_break] = ACTIONS(662),
    [anon_sym_continue] = ACTIONS(664),
    [anon_sym_goto] = ACTIONS(666),
    [anon_sym_AMP] = ACTIONS(644),
    [anon_sym_BANG] = ACTIONS(668),
    [anon_sym_TILDE] = ACTIONS(670),
    [anon_sym_PLUS] = ACTIONS(672),
    [anon_sym_DASH] = ACTIONS(672),
    [anon_sym_DASH_DASH] = ACTIONS(674),
    [anon_sym_PLUS_PLUS] = ACTIONS(674),
    [anon_sym_sizeof] = ACTIONS(676),
    [sym_number_literal] = ACTIONS(620),
    [sym_char_literal] = ACTIONS(620),
    [sym_string_literal] = ACTIONS(678),
    [sym_true] = ACTIONS(680),
    [sym_false] = ACTIONS(680),
    [sym_null] = ACTIONS(680),
    [sym_identifier] = ACTIONS(682),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(51),
    [sym_auto] = ACTIONS(33),
    [anon_sym_typename] = ACTIONS(53),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(684),
    [anon_sym_delete] = ACTIONS(686),
    [sym_nullptr] = ACTIONS(680),
  },
  [2859] = {
    [sym__expression] = STATE(2956),
    [sym_conditional_expression] = STATE(2956),
    [sym_assignment_expression] = STATE(2956),
    [sym_pointer_expression] = STATE(2956),
    [sym_logical_expression] = STATE(2956),
    [sym_bitwise_expression] = STATE(2956),
    [sym_equality_expression] = STATE(2956),
    [sym_relational_expression] = STATE(2956),
    [sym_shift_expression] = STATE(2956),
    [sym_math_expression] = STATE(2956),
    [sym_cast_expression] = STATE(2956),
    [sym_sizeof_expression] = STATE(2956),
    [sym_subscript_expression] = STATE(2956),
    [sym_call_expression] = STATE(2956),
    [sym_field_expression] = STATE(2956),
    [sym_compound_literal_expression] = STATE(2956),
    [sym_parenthesized_expression] = STATE(2956),
    [sym_concatenated_string] = STATE(2956),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(2956),
    [sym_new_expression] = STATE(2956),
    [sym_delete_expression] = STATE(2956),
    [sym_lambda_expression] = STATE(2956),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(6991),
    [anon_sym_LPAREN] = ACTIONS(2943),
    [anon_sym_STAR] = ACTIONS(2945),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_AMP] = ACTIONS(2945),
    [anon_sym_BANG] = ACTIONS(2947),
    [anon_sym_TILDE] = ACTIONS(2949),
    [anon_sym_PLUS] = ACTIONS(2951),
    [anon_sym_DASH] = ACTIONS(2951),
    [anon_sym_DASH_DASH] = ACTIONS(2953),
    [anon_sym_PLUS_PLUS] = ACTIONS(2953),
    [anon_sym_sizeof] = ACTIONS(2955),
    [sym_number_literal] = ACTIONS(6991),
    [sym_char_literal] = ACTIONS(6991),
    [sym_string_literal] = ACTIONS(2957),
    [sym_true] = ACTIONS(6993),
    [sym_false] = ACTIONS(6993),
    [sym_null] = ACTIONS(6993),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(2961),
    [anon_sym_delete] = ACTIONS(2963),
    [sym_nullptr] = ACTIONS(6993),
  },
  [2860] = {
    [anon_sym_LPAREN] = ACTIONS(6995),
    [sym_comment] = ACTIONS(49),
  },
  [2861] = {
    [sym__expression] = STATE(2958),
    [sym_conditional_expression] = STATE(2958),
    [sym_assignment_expression] = STATE(2958),
    [sym_pointer_expression] = STATE(2958),
    [sym_logical_expression] = STATE(2958),
    [sym_bitwise_expression] = STATE(2958),
    [sym_equality_expression] = STATE(2958),
    [sym_relational_expression] = STATE(2958),
    [sym_shift_expression] = STATE(2958),
    [sym_math_expression] = STATE(2958),
    [sym_cast_expression] = STATE(2958),
    [sym_sizeof_expression] = STATE(2958),
    [sym_subscript_expression] = STATE(2958),
    [sym_call_expression] = STATE(2958),
    [sym_field_expression] = STATE(2958),
    [sym_compound_literal_expression] = STATE(2958),
    [sym_parenthesized_expression] = STATE(2958),
    [sym_concatenated_string] = STATE(2958),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(2958),
    [sym_new_expression] = STATE(2958),
    [sym_delete_expression] = STATE(2958),
    [sym_lambda_expression] = STATE(2958),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(6997),
    [anon_sym_LPAREN] = ACTIONS(2943),
    [anon_sym_STAR] = ACTIONS(2945),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_AMP] = ACTIONS(2945),
    [anon_sym_BANG] = ACTIONS(2947),
    [anon_sym_TILDE] = ACTIONS(2949),
    [anon_sym_PLUS] = ACTIONS(2951),
    [anon_sym_DASH] = ACTIONS(2951),
    [anon_sym_DASH_DASH] = ACTIONS(2953),
    [anon_sym_PLUS_PLUS] = ACTIONS(2953),
    [anon_sym_sizeof] = ACTIONS(2955),
    [sym_number_literal] = ACTIONS(6997),
    [sym_char_literal] = ACTIONS(6997),
    [sym_string_literal] = ACTIONS(2957),
    [sym_true] = ACTIONS(6999),
    [sym_false] = ACTIONS(6999),
    [sym_null] = ACTIONS(6999),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(2961),
    [anon_sym_delete] = ACTIONS(2963),
    [sym_nullptr] = ACTIONS(6999),
  },
  [2862] = {
    [sym_argument_list] = STATE(802),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_STAR] = ACTIONS(3003),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_EQ] = ACTIONS(3005),
    [anon_sym_COLON] = ACTIONS(7001),
    [anon_sym_QMARK] = ACTIONS(3009),
    [anon_sym_STAR_EQ] = ACTIONS(3011),
    [anon_sym_SLASH_EQ] = ACTIONS(3011),
    [anon_sym_PERCENT_EQ] = ACTIONS(3011),
    [anon_sym_PLUS_EQ] = ACTIONS(3011),
    [anon_sym_DASH_EQ] = ACTIONS(3011),
    [anon_sym_LT_LT_EQ] = ACTIONS(3011),
    [anon_sym_GT_GT_EQ] = ACTIONS(3011),
    [anon_sym_AMP_EQ] = ACTIONS(3011),
    [anon_sym_CARET_EQ] = ACTIONS(3011),
    [anon_sym_PIPE_EQ] = ACTIONS(3011),
    [anon_sym_AMP] = ACTIONS(3013),
    [anon_sym_PIPE_PIPE] = ACTIONS(3015),
    [anon_sym_AMP_AMP] = ACTIONS(3017),
    [anon_sym_PIPE] = ACTIONS(3019),
    [anon_sym_CARET] = ACTIONS(3021),
    [anon_sym_EQ_EQ] = ACTIONS(3023),
    [anon_sym_BANG_EQ] = ACTIONS(3023),
    [anon_sym_LT] = ACTIONS(3025),
    [anon_sym_GT] = ACTIONS(3025),
    [anon_sym_LT_EQ] = ACTIONS(3027),
    [anon_sym_GT_EQ] = ACTIONS(3027),
    [anon_sym_LT_LT] = ACTIONS(3029),
    [anon_sym_GT_GT] = ACTIONS(3029),
    [anon_sym_PLUS] = ACTIONS(3031),
    [anon_sym_DASH] = ACTIONS(3031),
    [anon_sym_SLASH] = ACTIONS(3003),
    [anon_sym_PERCENT] = ACTIONS(3003),
    [anon_sym_DASH_DASH] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(3033),
    [anon_sym_DASH_GT] = ACTIONS(3033),
    [sym_comment] = ACTIONS(49),
  },
  [2863] = {
    [sym_declaration] = STATE(2962),
    [sym_type_definition] = STATE(2962),
    [sym__declaration_specifiers] = STATE(2963),
    [sym_compound_statement] = STATE(2962),
    [sym_storage_class_specifier] = STATE(109),
    [sym_type_qualifier] = STATE(109),
    [sym__type_specifier] = STATE(105),
    [sym_sized_type_specifier] = STATE(105),
    [sym_enum_specifier] = STATE(105),
    [sym_struct_specifier] = STATE(105),
    [sym_union_specifier] = STATE(105),
    [sym_labeled_statement] = STATE(2962),
    [sym_expression_statement] = STATE(2962),
    [sym_if_statement] = STATE(2962),
    [sym_switch_statement] = STATE(2962),
    [sym_case_statement] = STATE(2962),
    [sym_while_statement] = STATE(2962),
    [sym_do_statement] = STATE(2962),
    [sym_for_statement] = STATE(2962),
    [sym_return_statement] = STATE(2962),
    [sym_break_statement] = STATE(2962),
    [sym_continue_statement] = STATE(2962),
    [sym_goto_statement] = STATE(2962),
    [sym__expression] = STATE(2739),
    [sym_comma_expression] = STATE(2740),
    [sym_conditional_expression] = STATE(2739),
    [sym_assignment_expression] = STATE(2739),
    [sym_pointer_expression] = STATE(2739),
    [sym_logical_expression] = STATE(2739),
    [sym_bitwise_expression] = STATE(2739),
    [sym_equality_expression] = STATE(2739),
    [sym_relational_expression] = STATE(2739),
    [sym_shift_expression] = STATE(2739),
    [sym_math_expression] = STATE(2739),
    [sym_cast_expression] = STATE(2739),
    [sym_sizeof_expression] = STATE(2739),
    [sym_subscript_expression] = STATE(2739),
    [sym_call_expression] = STATE(2739),
    [sym_field_expression] = STATE(2739),
    [sym_compound_literal_expression] = STATE(2739),
    [sym_parenthesized_expression] = STATE(2739),
    [sym_concatenated_string] = STATE(2739),
    [sym_macro_type_specifier] = STATE(105),
    [sym_class_specifier] = STATE(105),
    [sym_dependent_type] = STATE(105),
    [sym_template_type] = STATE(1475),
    [sym_template_function] = STATE(2739),
    [sym_for_range_loop] = STATE(2962),
    [sym_new_expression] = STATE(2739),
    [sym_delete_expression] = STATE(2739),
    [sym_lambda_expression] = STATE(2739),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(416),
    [sym_scoped_namespace_identifier] = STATE(1476),
    [aux_sym__declaration_specifiers_repeat1] = STATE(109),
    [aux_sym_sized_type_specifier_repeat1] = STATE(110),
    [sym_raw_string_literal] = ACTIONS(6507),
    [anon_sym_LPAREN] = ACTIONS(626),
    [anon_sym_SEMI] = ACTIONS(6509),
    [anon_sym_typedef] = ACTIONS(7003),
    [anon_sym_extern] = ACTIONS(154),
    [anon_sym_LBRACE] = ACTIONS(6511),
    [anon_sym_STAR] = ACTIONS(644),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_static] = ACTIONS(154),
    [anon_sym_register] = ACTIONS(154),
    [anon_sym_inline] = ACTIONS(154),
    [anon_sym_const] = ACTIONS(158),
    [anon_sym_restrict] = ACTIONS(158),
    [anon_sym_volatile] = ACTIONS(158),
    [anon_sym__Atomic] = ACTIONS(158),
    [anon_sym_mutable] = ACTIONS(158),
    [anon_sym_explicit] = ACTIONS(158),
    [anon_sym_constexpr] = ACTIONS(158),
    [anon_sym_unsigned] = ACTIONS(160),
    [anon_sym_long] = ACTIONS(160),
    [anon_sym_short] = ACTIONS(160),
    [sym_primitive_type] = ACTIONS(162),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_union] = ACTIONS(39),
    [anon_sym_if] = ACTIONS(6513),
    [anon_sym_switch] = ACTIONS(6515),
    [anon_sym_case] = ACTIONS(6517),
    [anon_sym_default] = ACTIONS(6519),
    [anon_sym_while] = ACTIONS(6521),
    [anon_sym_do] = ACTIONS(6523),
    [anon_sym_for] = ACTIONS(6525),
    [anon_sym_return] = ACTIONS(6527),
    [anon_sym_break] = ACTIONS(6529),
    [anon_sym_continue] = ACTIONS(6531),
    [anon_sym_goto] = ACTIONS(6533),
    [anon_sym_AMP] = ACTIONS(644),
    [anon_sym_BANG] = ACTIONS(668),
    [anon_sym_TILDE] = ACTIONS(670),
    [anon_sym_PLUS] = ACTIONS(672),
    [anon_sym_DASH] = ACTIONS(672),
    [anon_sym_DASH_DASH] = ACTIONS(674),
    [anon_sym_PLUS_PLUS] = ACTIONS(674),
    [anon_sym_sizeof] = ACTIONS(676),
    [sym_number_literal] = ACTIONS(6507),
    [sym_char_literal] = ACTIONS(6507),
    [sym_string_literal] = ACTIONS(678),
    [sym_true] = ACTIONS(6535),
    [sym_false] = ACTIONS(6535),
    [sym_null] = ACTIONS(6535),
    [sym_identifier] = ACTIONS(7005),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(51),
    [sym_auto] = ACTIONS(162),
    [anon_sym_typename] = ACTIONS(172),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(3040),
    [anon_sym_delete] = ACTIONS(686),
    [sym_nullptr] = ACTIONS(6535),
  },
  [2864] = {
    [sym__expression] = STATE(2964),
    [sym_conditional_expression] = STATE(2964),
    [sym_assignment_expression] = STATE(2964),
    [sym_pointer_expression] = STATE(2964),
    [sym_logical_expression] = STATE(2964),
    [sym_bitwise_expression] = STATE(2964),
    [sym_equality_expression] = STATE(2964),
    [sym_relational_expression] = STATE(2964),
    [sym_shift_expression] = STATE(2964),
    [sym_math_expression] = STATE(2964),
    [sym_cast_expression] = STATE(2964),
    [sym_sizeof_expression] = STATE(2964),
    [sym_subscript_expression] = STATE(2964),
    [sym_call_expression] = STATE(2964),
    [sym_field_expression] = STATE(2964),
    [sym_compound_literal_expression] = STATE(2964),
    [sym_parenthesized_expression] = STATE(2964),
    [sym_concatenated_string] = STATE(2964),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(2964),
    [sym_new_expression] = STATE(2964),
    [sym_delete_expression] = STATE(2964),
    [sym_lambda_expression] = STATE(2964),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(7007),
    [anon_sym_LPAREN] = ACTIONS(2943),
    [anon_sym_STAR] = ACTIONS(2945),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_AMP] = ACTIONS(2945),
    [anon_sym_BANG] = ACTIONS(2947),
    [anon_sym_TILDE] = ACTIONS(2949),
    [anon_sym_PLUS] = ACTIONS(2951),
    [anon_sym_DASH] = ACTIONS(2951),
    [anon_sym_DASH_DASH] = ACTIONS(2953),
    [anon_sym_PLUS_PLUS] = ACTIONS(2953),
    [anon_sym_sizeof] = ACTIONS(2955),
    [sym_number_literal] = ACTIONS(7007),
    [sym_char_literal] = ACTIONS(7007),
    [sym_string_literal] = ACTIONS(2957),
    [sym_true] = ACTIONS(7009),
    [sym_false] = ACTIONS(7009),
    [sym_null] = ACTIONS(7009),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(2961),
    [anon_sym_delete] = ACTIONS(2963),
    [sym_nullptr] = ACTIONS(7009),
  },
  [2865] = {
    [anon_sym_while] = ACTIONS(7011),
    [sym_comment] = ACTIONS(49),
  },
  [2866] = {
    [sym_declaration] = STATE(2966),
    [sym__declaration_specifiers] = STATE(1500),
    [sym_storage_class_specifier] = STATE(109),
    [sym_type_qualifier] = STATE(109),
    [sym__type_specifier] = STATE(105),
    [sym_sized_type_specifier] = STATE(105),
    [sym_enum_specifier] = STATE(105),
    [sym_struct_specifier] = STATE(105),
    [sym_union_specifier] = STATE(105),
    [sym__expression] = STATE(2967),
    [sym_conditional_expression] = STATE(2967),
    [sym_assignment_expression] = STATE(2967),
    [sym_pointer_expression] = STATE(2967),
    [sym_logical_expression] = STATE(2967),
    [sym_bitwise_expression] = STATE(2967),
    [sym_equality_expression] = STATE(2967),
    [sym_relational_expression] = STATE(2967),
    [sym_shift_expression] = STATE(2967),
    [sym_math_expression] = STATE(2967),
    [sym_cast_expression] = STATE(2967),
    [sym_sizeof_expression] = STATE(2967),
    [sym_subscript_expression] = STATE(2967),
    [sym_call_expression] = STATE(2967),
    [sym_field_expression] = STATE(2967),
    [sym_compound_literal_expression] = STATE(2967),
    [sym_parenthesized_expression] = STATE(2967),
    [sym_concatenated_string] = STATE(2967),
    [sym_macro_type_specifier] = STATE(105),
    [sym_class_specifier] = STATE(105),
    [sym_dependent_type] = STATE(105),
    [sym_template_type] = STATE(1475),
    [sym_template_function] = STATE(2967),
    [sym_for_range_declaration] = STATE(2968),
    [sym_new_expression] = STATE(2967),
    [sym_delete_expression] = STATE(2967),
    [sym_lambda_expression] = STATE(2967),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(416),
    [sym_scoped_namespace_identifier] = STATE(1476),
    [aux_sym__declaration_specifiers_repeat1] = STATE(109),
    [aux_sym_sized_type_specifier_repeat1] = STATE(110),
    [sym_raw_string_literal] = ACTIONS(7013),
    [anon_sym_LPAREN] = ACTIONS(1347),
    [anon_sym_SEMI] = ACTIONS(7015),
    [anon_sym_extern] = ACTIONS(154),
    [anon_sym_STAR] = ACTIONS(1349),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_static] = ACTIONS(154),
    [anon_sym_register] = ACTIONS(154),
    [anon_sym_inline] = ACTIONS(154),
    [anon_sym_const] = ACTIONS(158),
    [anon_sym_restrict] = ACTIONS(158),
    [anon_sym_volatile] = ACTIONS(158),
    [anon_sym__Atomic] = ACTIONS(158),
    [anon_sym_mutable] = ACTIONS(158),
    [anon_sym_explicit] = ACTIONS(158),
    [anon_sym_constexpr] = ACTIONS(158),
    [anon_sym_unsigned] = ACTIONS(160),
    [anon_sym_long] = ACTIONS(160),
    [anon_sym_short] = ACTIONS(160),
    [sym_primitive_type] = ACTIONS(162),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_union] = ACTIONS(39),
    [anon_sym_AMP] = ACTIONS(1349),
    [anon_sym_BANG] = ACTIONS(1351),
    [anon_sym_TILDE] = ACTIONS(1353),
    [anon_sym_PLUS] = ACTIONS(1355),
    [anon_sym_DASH] = ACTIONS(1355),
    [anon_sym_DASH_DASH] = ACTIONS(1357),
    [anon_sym_PLUS_PLUS] = ACTIONS(1357),
    [anon_sym_sizeof] = ACTIONS(1359),
    [sym_number_literal] = ACTIONS(7013),
    [sym_char_literal] = ACTIONS(7013),
    [sym_string_literal] = ACTIONS(1361),
    [sym_true] = ACTIONS(7017),
    [sym_false] = ACTIONS(7017),
    [sym_null] = ACTIONS(7017),
    [sym_identifier] = ACTIONS(3088),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(51),
    [sym_auto] = ACTIONS(162),
    [anon_sym_typename] = ACTIONS(172),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(3090),
    [anon_sym_delete] = ACTIONS(1367),
    [sym_nullptr] = ACTIONS(7017),
  },
  [2867] = {
    [sym_raw_string_literal] = ACTIONS(3092),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3094),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3094),
    [anon_sym_LPAREN] = ACTIONS(3092),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3094),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3094),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3094),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3094),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(3094),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(3094),
    [sym_preproc_directive] = ACTIONS(3094),
    [anon_sym_SEMI] = ACTIONS(3092),
    [anon_sym_typedef] = ACTIONS(3094),
    [anon_sym_extern] = ACTIONS(3094),
    [anon_sym_LBRACE] = ACTIONS(3092),
    [anon_sym_STAR] = ACTIONS(3092),
    [anon_sym_LBRACK] = ACTIONS(3092),
    [anon_sym_static] = ACTIONS(3094),
    [anon_sym_register] = ACTIONS(3094),
    [anon_sym_inline] = ACTIONS(3094),
    [anon_sym_const] = ACTIONS(3094),
    [anon_sym_restrict] = ACTIONS(3094),
    [anon_sym_volatile] = ACTIONS(3094),
    [anon_sym__Atomic] = ACTIONS(3094),
    [anon_sym_mutable] = ACTIONS(3094),
    [anon_sym_explicit] = ACTIONS(3094),
    [anon_sym_constexpr] = ACTIONS(3094),
    [anon_sym_unsigned] = ACTIONS(3094),
    [anon_sym_long] = ACTIONS(3094),
    [anon_sym_short] = ACTIONS(3094),
    [sym_primitive_type] = ACTIONS(3094),
    [anon_sym_enum] = ACTIONS(3094),
    [anon_sym_struct] = ACTIONS(3094),
    [anon_sym_union] = ACTIONS(3094),
    [anon_sym_if] = ACTIONS(3094),
    [anon_sym_else] = ACTIONS(3094),
    [anon_sym_switch] = ACTIONS(3094),
    [anon_sym_case] = ACTIONS(3094),
    [anon_sym_default] = ACTIONS(3094),
    [anon_sym_while] = ACTIONS(3094),
    [anon_sym_do] = ACTIONS(3094),
    [anon_sym_for] = ACTIONS(3094),
    [anon_sym_return] = ACTIONS(3094),
    [anon_sym_break] = ACTIONS(3094),
    [anon_sym_continue] = ACTIONS(3094),
    [anon_sym_goto] = ACTIONS(3094),
    [anon_sym_AMP] = ACTIONS(3092),
    [anon_sym_BANG] = ACTIONS(3092),
    [anon_sym_TILDE] = ACTIONS(3092),
    [anon_sym_PLUS] = ACTIONS(3094),
    [anon_sym_DASH] = ACTIONS(3094),
    [anon_sym_DASH_DASH] = ACTIONS(3092),
    [anon_sym_PLUS_PLUS] = ACTIONS(3092),
    [anon_sym_sizeof] = ACTIONS(3094),
    [sym_number_literal] = ACTIONS(3092),
    [sym_char_literal] = ACTIONS(3092),
    [sym_string_literal] = ACTIONS(3092),
    [sym_true] = ACTIONS(3094),
    [sym_false] = ACTIONS(3094),
    [sym_null] = ACTIONS(3094),
    [sym_identifier] = ACTIONS(3094),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(3094),
    [sym_auto] = ACTIONS(3094),
    [anon_sym_typename] = ACTIONS(3094),
    [anon_sym_new] = ACTIONS(3094),
    [anon_sym_COLON_COLON] = ACTIONS(3092),
    [anon_sym_delete] = ACTIONS(3094),
    [sym_nullptr] = ACTIONS(3094),
  },
  [2868] = {
    [sym_argument_list] = STATE(802),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_SEMI] = ACTIONS(7019),
    [anon_sym_STAR] = ACTIONS(2553),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_EQ] = ACTIONS(2555),
    [anon_sym_QMARK] = ACTIONS(2557),
    [anon_sym_STAR_EQ] = ACTIONS(2559),
    [anon_sym_SLASH_EQ] = ACTIONS(2559),
    [anon_sym_PERCENT_EQ] = ACTIONS(2559),
    [anon_sym_PLUS_EQ] = ACTIONS(2559),
    [anon_sym_DASH_EQ] = ACTIONS(2559),
    [anon_sym_LT_LT_EQ] = ACTIONS(2559),
    [anon_sym_GT_GT_EQ] = ACTIONS(2559),
    [anon_sym_AMP_EQ] = ACTIONS(2559),
    [anon_sym_CARET_EQ] = ACTIONS(2559),
    [anon_sym_PIPE_EQ] = ACTIONS(2559),
    [anon_sym_AMP] = ACTIONS(2561),
    [anon_sym_PIPE_PIPE] = ACTIONS(2563),
    [anon_sym_AMP_AMP] = ACTIONS(2565),
    [anon_sym_PIPE] = ACTIONS(2567),
    [anon_sym_CARET] = ACTIONS(2569),
    [anon_sym_EQ_EQ] = ACTIONS(2571),
    [anon_sym_BANG_EQ] = ACTIONS(2571),
    [anon_sym_LT] = ACTIONS(2573),
    [anon_sym_GT] = ACTIONS(2573),
    [anon_sym_LT_EQ] = ACTIONS(2575),
    [anon_sym_GT_EQ] = ACTIONS(2575),
    [anon_sym_LT_LT] = ACTIONS(2577),
    [anon_sym_GT_GT] = ACTIONS(2577),
    [anon_sym_PLUS] = ACTIONS(2579),
    [anon_sym_DASH] = ACTIONS(2579),
    [anon_sym_SLASH] = ACTIONS(2553),
    [anon_sym_PERCENT] = ACTIONS(2553),
    [anon_sym_DASH_DASH] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(1554),
    [anon_sym_DASH_GT] = ACTIONS(1554),
    [sym_comment] = ACTIONS(49),
  },
  [2869] = {
    [anon_sym_SEMI] = ACTIONS(7019),
    [sym_comment] = ACTIONS(49),
  },
  [2870] = {
    [sym_raw_string_literal] = ACTIONS(3098),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3100),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3100),
    [anon_sym_LPAREN] = ACTIONS(3098),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3100),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3100),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3100),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3100),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(3100),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(3100),
    [sym_preproc_directive] = ACTIONS(3100),
    [anon_sym_SEMI] = ACTIONS(3098),
    [anon_sym_typedef] = ACTIONS(3100),
    [anon_sym_extern] = ACTIONS(3100),
    [anon_sym_LBRACE] = ACTIONS(3098),
    [anon_sym_STAR] = ACTIONS(3098),
    [anon_sym_LBRACK] = ACTIONS(3098),
    [anon_sym_static] = ACTIONS(3100),
    [anon_sym_register] = ACTIONS(3100),
    [anon_sym_inline] = ACTIONS(3100),
    [anon_sym_const] = ACTIONS(3100),
    [anon_sym_restrict] = ACTIONS(3100),
    [anon_sym_volatile] = ACTIONS(3100),
    [anon_sym__Atomic] = ACTIONS(3100),
    [anon_sym_mutable] = ACTIONS(3100),
    [anon_sym_explicit] = ACTIONS(3100),
    [anon_sym_constexpr] = ACTIONS(3100),
    [anon_sym_unsigned] = ACTIONS(3100),
    [anon_sym_long] = ACTIONS(3100),
    [anon_sym_short] = ACTIONS(3100),
    [sym_primitive_type] = ACTIONS(3100),
    [anon_sym_enum] = ACTIONS(3100),
    [anon_sym_struct] = ACTIONS(3100),
    [anon_sym_union] = ACTIONS(3100),
    [anon_sym_if] = ACTIONS(3100),
    [anon_sym_else] = ACTIONS(3100),
    [anon_sym_switch] = ACTIONS(3100),
    [anon_sym_case] = ACTIONS(3100),
    [anon_sym_default] = ACTIONS(3100),
    [anon_sym_while] = ACTIONS(3100),
    [anon_sym_do] = ACTIONS(3100),
    [anon_sym_for] = ACTIONS(3100),
    [anon_sym_return] = ACTIONS(3100),
    [anon_sym_break] = ACTIONS(3100),
    [anon_sym_continue] = ACTIONS(3100),
    [anon_sym_goto] = ACTIONS(3100),
    [anon_sym_AMP] = ACTIONS(3098),
    [anon_sym_BANG] = ACTIONS(3098),
    [anon_sym_TILDE] = ACTIONS(3098),
    [anon_sym_PLUS] = ACTIONS(3100),
    [anon_sym_DASH] = ACTIONS(3100),
    [anon_sym_DASH_DASH] = ACTIONS(3098),
    [anon_sym_PLUS_PLUS] = ACTIONS(3098),
    [anon_sym_sizeof] = ACTIONS(3100),
    [sym_number_literal] = ACTIONS(3098),
    [sym_char_literal] = ACTIONS(3098),
    [sym_string_literal] = ACTIONS(3098),
    [sym_true] = ACTIONS(3100),
    [sym_false] = ACTIONS(3100),
    [sym_null] = ACTIONS(3100),
    [sym_identifier] = ACTIONS(3100),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(3100),
    [sym_auto] = ACTIONS(3100),
    [anon_sym_typename] = ACTIONS(3100),
    [anon_sym_new] = ACTIONS(3100),
    [anon_sym_COLON_COLON] = ACTIONS(3098),
    [anon_sym_delete] = ACTIONS(3100),
    [sym_nullptr] = ACTIONS(3100),
  },
  [2871] = {
    [sym_raw_string_literal] = ACTIONS(3102),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3104),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3104),
    [anon_sym_LPAREN] = ACTIONS(3102),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3104),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3104),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3104),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3104),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(3104),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(3104),
    [sym_preproc_directive] = ACTIONS(3104),
    [anon_sym_SEMI] = ACTIONS(3102),
    [anon_sym_typedef] = ACTIONS(3104),
    [anon_sym_extern] = ACTIONS(3104),
    [anon_sym_LBRACE] = ACTIONS(3102),
    [anon_sym_STAR] = ACTIONS(3102),
    [anon_sym_LBRACK] = ACTIONS(3102),
    [anon_sym_static] = ACTIONS(3104),
    [anon_sym_register] = ACTIONS(3104),
    [anon_sym_inline] = ACTIONS(3104),
    [anon_sym_const] = ACTIONS(3104),
    [anon_sym_restrict] = ACTIONS(3104),
    [anon_sym_volatile] = ACTIONS(3104),
    [anon_sym__Atomic] = ACTIONS(3104),
    [anon_sym_mutable] = ACTIONS(3104),
    [anon_sym_explicit] = ACTIONS(3104),
    [anon_sym_constexpr] = ACTIONS(3104),
    [anon_sym_unsigned] = ACTIONS(3104),
    [anon_sym_long] = ACTIONS(3104),
    [anon_sym_short] = ACTIONS(3104),
    [sym_primitive_type] = ACTIONS(3104),
    [anon_sym_enum] = ACTIONS(3104),
    [anon_sym_struct] = ACTIONS(3104),
    [anon_sym_union] = ACTIONS(3104),
    [anon_sym_if] = ACTIONS(3104),
    [anon_sym_else] = ACTIONS(3104),
    [anon_sym_switch] = ACTIONS(3104),
    [anon_sym_case] = ACTIONS(3104),
    [anon_sym_default] = ACTIONS(3104),
    [anon_sym_while] = ACTIONS(3104),
    [anon_sym_do] = ACTIONS(3104),
    [anon_sym_for] = ACTIONS(3104),
    [anon_sym_return] = ACTIONS(3104),
    [anon_sym_break] = ACTIONS(3104),
    [anon_sym_continue] = ACTIONS(3104),
    [anon_sym_goto] = ACTIONS(3104),
    [anon_sym_AMP] = ACTIONS(3102),
    [anon_sym_BANG] = ACTIONS(3102),
    [anon_sym_TILDE] = ACTIONS(3102),
    [anon_sym_PLUS] = ACTIONS(3104),
    [anon_sym_DASH] = ACTIONS(3104),
    [anon_sym_DASH_DASH] = ACTIONS(3102),
    [anon_sym_PLUS_PLUS] = ACTIONS(3102),
    [anon_sym_sizeof] = ACTIONS(3104),
    [sym_number_literal] = ACTIONS(3102),
    [sym_char_literal] = ACTIONS(3102),
    [sym_string_literal] = ACTIONS(3102),
    [sym_true] = ACTIONS(3104),
    [sym_false] = ACTIONS(3104),
    [sym_null] = ACTIONS(3104),
    [sym_identifier] = ACTIONS(3104),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(3104),
    [sym_auto] = ACTIONS(3104),
    [anon_sym_typename] = ACTIONS(3104),
    [anon_sym_new] = ACTIONS(3104),
    [anon_sym_COLON_COLON] = ACTIONS(3102),
    [anon_sym_delete] = ACTIONS(3104),
    [sym_nullptr] = ACTIONS(3104),
  },
  [2872] = {
    [anon_sym_SEMI] = ACTIONS(7021),
    [sym_comment] = ACTIONS(49),
  },
  [2873] = {
    [sym_compound_statement] = STATE(2971),
    [sym_labeled_statement] = STATE(2971),
    [sym_expression_statement] = STATE(2971),
    [sym_if_statement] = STATE(2971),
    [sym_switch_statement] = STATE(2971),
    [sym_case_statement] = STATE(2971),
    [sym_while_statement] = STATE(2971),
    [sym_do_statement] = STATE(2971),
    [sym_for_statement] = STATE(2971),
    [sym_return_statement] = STATE(2971),
    [sym_break_statement] = STATE(2971),
    [sym_continue_statement] = STATE(2971),
    [sym_goto_statement] = STATE(2971),
    [sym__expression] = STATE(2739),
    [sym_comma_expression] = STATE(2740),
    [sym_conditional_expression] = STATE(2739),
    [sym_assignment_expression] = STATE(2739),
    [sym_pointer_expression] = STATE(2739),
    [sym_logical_expression] = STATE(2739),
    [sym_bitwise_expression] = STATE(2739),
    [sym_equality_expression] = STATE(2739),
    [sym_relational_expression] = STATE(2739),
    [sym_shift_expression] = STATE(2739),
    [sym_math_expression] = STATE(2739),
    [sym_cast_expression] = STATE(2739),
    [sym_sizeof_expression] = STATE(2739),
    [sym_subscript_expression] = STATE(2739),
    [sym_call_expression] = STATE(2739),
    [sym_field_expression] = STATE(2739),
    [sym_compound_literal_expression] = STATE(2739),
    [sym_parenthesized_expression] = STATE(2739),
    [sym_concatenated_string] = STATE(2739),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(2739),
    [sym_for_range_loop] = STATE(2971),
    [sym_new_expression] = STATE(2739),
    [sym_delete_expression] = STATE(2739),
    [sym_lambda_expression] = STATE(2739),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(6507),
    [anon_sym_LPAREN] = ACTIONS(626),
    [anon_sym_SEMI] = ACTIONS(6509),
    [anon_sym_LBRACE] = ACTIONS(6511),
    [anon_sym_STAR] = ACTIONS(644),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_if] = ACTIONS(6513),
    [anon_sym_switch] = ACTIONS(6515),
    [anon_sym_case] = ACTIONS(6517),
    [anon_sym_default] = ACTIONS(6519),
    [anon_sym_while] = ACTIONS(6521),
    [anon_sym_do] = ACTIONS(6523),
    [anon_sym_for] = ACTIONS(6525),
    [anon_sym_return] = ACTIONS(6527),
    [anon_sym_break] = ACTIONS(6529),
    [anon_sym_continue] = ACTIONS(6531),
    [anon_sym_goto] = ACTIONS(6533),
    [anon_sym_AMP] = ACTIONS(644),
    [anon_sym_BANG] = ACTIONS(668),
    [anon_sym_TILDE] = ACTIONS(670),
    [anon_sym_PLUS] = ACTIONS(672),
    [anon_sym_DASH] = ACTIONS(672),
    [anon_sym_DASH_DASH] = ACTIONS(674),
    [anon_sym_PLUS_PLUS] = ACTIONS(674),
    [anon_sym_sizeof] = ACTIONS(676),
    [sym_number_literal] = ACTIONS(6507),
    [sym_char_literal] = ACTIONS(6507),
    [sym_string_literal] = ACTIONS(678),
    [sym_true] = ACTIONS(6535),
    [sym_false] = ACTIONS(6535),
    [sym_null] = ACTIONS(6535),
    [sym_identifier] = ACTIONS(6537),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1303),
    [anon_sym_delete] = ACTIONS(686),
    [sym_nullptr] = ACTIONS(6535),
  },
  [2874] = {
    [sym_compound_statement] = STATE(2972),
    [sym_labeled_statement] = STATE(2972),
    [sym_expression_statement] = STATE(2972),
    [sym_if_statement] = STATE(2972),
    [sym_switch_statement] = STATE(2972),
    [sym_case_statement] = STATE(2972),
    [sym_while_statement] = STATE(2972),
    [sym_do_statement] = STATE(2972),
    [sym_for_statement] = STATE(2972),
    [sym_return_statement] = STATE(2972),
    [sym_break_statement] = STATE(2972),
    [sym_continue_statement] = STATE(2972),
    [sym_goto_statement] = STATE(2972),
    [sym__expression] = STATE(1419),
    [sym_comma_expression] = STATE(1420),
    [sym_conditional_expression] = STATE(1419),
    [sym_assignment_expression] = STATE(1419),
    [sym_pointer_expression] = STATE(1419),
    [sym_logical_expression] = STATE(1419),
    [sym_bitwise_expression] = STATE(1419),
    [sym_equality_expression] = STATE(1419),
    [sym_relational_expression] = STATE(1419),
    [sym_shift_expression] = STATE(1419),
    [sym_math_expression] = STATE(1419),
    [sym_cast_expression] = STATE(1419),
    [sym_sizeof_expression] = STATE(1419),
    [sym_subscript_expression] = STATE(1419),
    [sym_call_expression] = STATE(1419),
    [sym_field_expression] = STATE(1419),
    [sym_compound_literal_expression] = STATE(1419),
    [sym_parenthesized_expression] = STATE(1419),
    [sym_concatenated_string] = STATE(1419),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(1419),
    [sym_for_range_loop] = STATE(2972),
    [sym_new_expression] = STATE(1419),
    [sym_delete_expression] = STATE(1419),
    [sym_lambda_expression] = STATE(1419),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(2879),
    [anon_sym_LPAREN] = ACTIONS(626),
    [anon_sym_SEMI] = ACTIONS(2899),
    [anon_sym_LBRACE] = ACTIONS(2903),
    [anon_sym_STAR] = ACTIONS(644),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_if] = ACTIONS(2905),
    [anon_sym_switch] = ACTIONS(2907),
    [anon_sym_case] = ACTIONS(2909),
    [anon_sym_default] = ACTIONS(2911),
    [anon_sym_while] = ACTIONS(2913),
    [anon_sym_do] = ACTIONS(2915),
    [anon_sym_for] = ACTIONS(2917),
    [anon_sym_return] = ACTIONS(2919),
    [anon_sym_break] = ACTIONS(2921),
    [anon_sym_continue] = ACTIONS(2923),
    [anon_sym_goto] = ACTIONS(2925),
    [anon_sym_AMP] = ACTIONS(644),
    [anon_sym_BANG] = ACTIONS(668),
    [anon_sym_TILDE] = ACTIONS(670),
    [anon_sym_PLUS] = ACTIONS(672),
    [anon_sym_DASH] = ACTIONS(672),
    [anon_sym_DASH_DASH] = ACTIONS(674),
    [anon_sym_PLUS_PLUS] = ACTIONS(674),
    [anon_sym_sizeof] = ACTIONS(676),
    [sym_number_literal] = ACTIONS(2879),
    [sym_char_literal] = ACTIONS(2879),
    [sym_string_literal] = ACTIONS(678),
    [sym_true] = ACTIONS(2927),
    [sym_false] = ACTIONS(2927),
    [sym_null] = ACTIONS(2927),
    [sym_identifier] = ACTIONS(5397),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1303),
    [anon_sym_delete] = ACTIONS(686),
    [sym_nullptr] = ACTIONS(2927),
  },
  [2875] = {
    [sym_raw_string_literal] = ACTIONS(3132),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3134),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3134),
    [anon_sym_LPAREN] = ACTIONS(3132),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3134),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3134),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3134),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3134),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(3134),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(3134),
    [sym_preproc_directive] = ACTIONS(3134),
    [anon_sym_SEMI] = ACTIONS(3132),
    [anon_sym_typedef] = ACTIONS(3134),
    [anon_sym_extern] = ACTIONS(3134),
    [anon_sym_LBRACE] = ACTIONS(3132),
    [anon_sym_STAR] = ACTIONS(3132),
    [anon_sym_LBRACK] = ACTIONS(3132),
    [anon_sym_static] = ACTIONS(3134),
    [anon_sym_register] = ACTIONS(3134),
    [anon_sym_inline] = ACTIONS(3134),
    [anon_sym_const] = ACTIONS(3134),
    [anon_sym_restrict] = ACTIONS(3134),
    [anon_sym_volatile] = ACTIONS(3134),
    [anon_sym__Atomic] = ACTIONS(3134),
    [anon_sym_mutable] = ACTIONS(3134),
    [anon_sym_explicit] = ACTIONS(3134),
    [anon_sym_constexpr] = ACTIONS(3134),
    [anon_sym_unsigned] = ACTIONS(3134),
    [anon_sym_long] = ACTIONS(3134),
    [anon_sym_short] = ACTIONS(3134),
    [sym_primitive_type] = ACTIONS(3134),
    [anon_sym_enum] = ACTIONS(3134),
    [anon_sym_struct] = ACTIONS(3134),
    [anon_sym_union] = ACTIONS(3134),
    [anon_sym_if] = ACTIONS(3134),
    [anon_sym_else] = ACTIONS(3134),
    [anon_sym_switch] = ACTIONS(3134),
    [anon_sym_case] = ACTIONS(3134),
    [anon_sym_default] = ACTIONS(3134),
    [anon_sym_while] = ACTIONS(3134),
    [anon_sym_do] = ACTIONS(3134),
    [anon_sym_for] = ACTIONS(3134),
    [anon_sym_return] = ACTIONS(3134),
    [anon_sym_break] = ACTIONS(3134),
    [anon_sym_continue] = ACTIONS(3134),
    [anon_sym_goto] = ACTIONS(3134),
    [anon_sym_AMP] = ACTIONS(3132),
    [anon_sym_BANG] = ACTIONS(3132),
    [anon_sym_TILDE] = ACTIONS(3132),
    [anon_sym_PLUS] = ACTIONS(3134),
    [anon_sym_DASH] = ACTIONS(3134),
    [anon_sym_DASH_DASH] = ACTIONS(3132),
    [anon_sym_PLUS_PLUS] = ACTIONS(3132),
    [anon_sym_sizeof] = ACTIONS(3134),
    [sym_number_literal] = ACTIONS(3132),
    [sym_char_literal] = ACTIONS(3132),
    [sym_string_literal] = ACTIONS(3132),
    [sym_true] = ACTIONS(3134),
    [sym_false] = ACTIONS(3134),
    [sym_null] = ACTIONS(3134),
    [sym_identifier] = ACTIONS(3134),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(3134),
    [sym_auto] = ACTIONS(3134),
    [anon_sym_typename] = ACTIONS(3134),
    [anon_sym_new] = ACTIONS(3134),
    [anon_sym_COLON_COLON] = ACTIONS(3132),
    [anon_sym_delete] = ACTIONS(3134),
    [sym_nullptr] = ACTIONS(3134),
  },
  [2876] = {
    [sym_raw_string_literal] = ACTIONS(6611),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(6613),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(6613),
    [anon_sym_LPAREN] = ACTIONS(6611),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(6613),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(6613),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(6613),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(6613),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(6613),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(6613),
    [sym_preproc_directive] = ACTIONS(6613),
    [anon_sym_SEMI] = ACTIONS(6611),
    [anon_sym_typedef] = ACTIONS(6613),
    [anon_sym_extern] = ACTIONS(6613),
    [anon_sym_LBRACE] = ACTIONS(6611),
    [anon_sym_STAR] = ACTIONS(6611),
    [anon_sym_LBRACK] = ACTIONS(6611),
    [anon_sym_static] = ACTIONS(6613),
    [anon_sym_register] = ACTIONS(6613),
    [anon_sym_inline] = ACTIONS(6613),
    [anon_sym_const] = ACTIONS(6613),
    [anon_sym_restrict] = ACTIONS(6613),
    [anon_sym_volatile] = ACTIONS(6613),
    [anon_sym__Atomic] = ACTIONS(6613),
    [anon_sym_mutable] = ACTIONS(6613),
    [anon_sym_explicit] = ACTIONS(6613),
    [anon_sym_constexpr] = ACTIONS(6613),
    [anon_sym_unsigned] = ACTIONS(6613),
    [anon_sym_long] = ACTIONS(6613),
    [anon_sym_short] = ACTIONS(6613),
    [sym_primitive_type] = ACTIONS(6613),
    [anon_sym_enum] = ACTIONS(6613),
    [anon_sym_struct] = ACTIONS(6613),
    [anon_sym_union] = ACTIONS(6613),
    [anon_sym_if] = ACTIONS(6613),
    [anon_sym_else] = ACTIONS(7023),
    [anon_sym_switch] = ACTIONS(6613),
    [anon_sym_case] = ACTIONS(6613),
    [anon_sym_default] = ACTIONS(6613),
    [anon_sym_while] = ACTIONS(6613),
    [anon_sym_do] = ACTIONS(6613),
    [anon_sym_for] = ACTIONS(6613),
    [anon_sym_return] = ACTIONS(6613),
    [anon_sym_break] = ACTIONS(6613),
    [anon_sym_continue] = ACTIONS(6613),
    [anon_sym_goto] = ACTIONS(6613),
    [anon_sym_AMP] = ACTIONS(6611),
    [anon_sym_BANG] = ACTIONS(6611),
    [anon_sym_TILDE] = ACTIONS(6611),
    [anon_sym_PLUS] = ACTIONS(6613),
    [anon_sym_DASH] = ACTIONS(6613),
    [anon_sym_DASH_DASH] = ACTIONS(6611),
    [anon_sym_PLUS_PLUS] = ACTIONS(6611),
    [anon_sym_sizeof] = ACTIONS(6613),
    [sym_number_literal] = ACTIONS(6611),
    [sym_char_literal] = ACTIONS(6611),
    [sym_string_literal] = ACTIONS(6611),
    [sym_true] = ACTIONS(6613),
    [sym_false] = ACTIONS(6613),
    [sym_null] = ACTIONS(6613),
    [sym_identifier] = ACTIONS(6613),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(6613),
    [sym_auto] = ACTIONS(6613),
    [anon_sym_typename] = ACTIONS(6613),
    [anon_sym_new] = ACTIONS(6613),
    [anon_sym_COLON_COLON] = ACTIONS(6611),
    [anon_sym_delete] = ACTIONS(6613),
    [sym_nullptr] = ACTIONS(6613),
  },
  [2877] = {
    [sym_raw_string_literal] = ACTIONS(6653),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(6655),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(6655),
    [anon_sym_LPAREN] = ACTIONS(6653),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(6655),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(6655),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(6655),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(6655),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(6655),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(6655),
    [sym_preproc_directive] = ACTIONS(6655),
    [anon_sym_SEMI] = ACTIONS(6653),
    [anon_sym_typedef] = ACTIONS(6655),
    [anon_sym_extern] = ACTIONS(6655),
    [anon_sym_LBRACE] = ACTIONS(6653),
    [anon_sym_STAR] = ACTIONS(6653),
    [anon_sym_LBRACK] = ACTIONS(6653),
    [anon_sym_static] = ACTIONS(6655),
    [anon_sym_register] = ACTIONS(6655),
    [anon_sym_inline] = ACTIONS(6655),
    [anon_sym_const] = ACTIONS(6655),
    [anon_sym_restrict] = ACTIONS(6655),
    [anon_sym_volatile] = ACTIONS(6655),
    [anon_sym__Atomic] = ACTIONS(6655),
    [anon_sym_mutable] = ACTIONS(6655),
    [anon_sym_explicit] = ACTIONS(6655),
    [anon_sym_constexpr] = ACTIONS(6655),
    [anon_sym_unsigned] = ACTIONS(6655),
    [anon_sym_long] = ACTIONS(6655),
    [anon_sym_short] = ACTIONS(6655),
    [sym_primitive_type] = ACTIONS(6655),
    [anon_sym_enum] = ACTIONS(6655),
    [anon_sym_struct] = ACTIONS(6655),
    [anon_sym_union] = ACTIONS(6655),
    [anon_sym_if] = ACTIONS(6655),
    [anon_sym_switch] = ACTIONS(6655),
    [anon_sym_case] = ACTIONS(6655),
    [anon_sym_default] = ACTIONS(6655),
    [anon_sym_while] = ACTIONS(6655),
    [anon_sym_do] = ACTIONS(6655),
    [anon_sym_for] = ACTIONS(6655),
    [anon_sym_return] = ACTIONS(6655),
    [anon_sym_break] = ACTIONS(6655),
    [anon_sym_continue] = ACTIONS(6655),
    [anon_sym_goto] = ACTIONS(6655),
    [anon_sym_AMP] = ACTIONS(6653),
    [anon_sym_BANG] = ACTIONS(6653),
    [anon_sym_TILDE] = ACTIONS(6653),
    [anon_sym_PLUS] = ACTIONS(6655),
    [anon_sym_DASH] = ACTIONS(6655),
    [anon_sym_DASH_DASH] = ACTIONS(6653),
    [anon_sym_PLUS_PLUS] = ACTIONS(6653),
    [anon_sym_sizeof] = ACTIONS(6655),
    [sym_number_literal] = ACTIONS(6653),
    [sym_char_literal] = ACTIONS(6653),
    [sym_string_literal] = ACTIONS(6653),
    [sym_true] = ACTIONS(6655),
    [sym_false] = ACTIONS(6655),
    [sym_null] = ACTIONS(6655),
    [sym_identifier] = ACTIONS(6655),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(6655),
    [sym_auto] = ACTIONS(6655),
    [anon_sym_typename] = ACTIONS(6655),
    [anon_sym_new] = ACTIONS(6655),
    [anon_sym_COLON_COLON] = ACTIONS(6653),
    [anon_sym_delete] = ACTIONS(6655),
    [sym_nullptr] = ACTIONS(6655),
  },
  [2878] = {
    [sym_raw_string_literal] = ACTIONS(6657),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(6659),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(6659),
    [anon_sym_LPAREN] = ACTIONS(6657),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(6659),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(6659),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(6659),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(6659),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(6659),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(6659),
    [sym_preproc_directive] = ACTIONS(6659),
    [anon_sym_SEMI] = ACTIONS(6657),
    [anon_sym_typedef] = ACTIONS(6659),
    [anon_sym_extern] = ACTIONS(6659),
    [anon_sym_LBRACE] = ACTIONS(6657),
    [anon_sym_STAR] = ACTIONS(6657),
    [anon_sym_LBRACK] = ACTIONS(6657),
    [anon_sym_static] = ACTIONS(6659),
    [anon_sym_register] = ACTIONS(6659),
    [anon_sym_inline] = ACTIONS(6659),
    [anon_sym_const] = ACTIONS(6659),
    [anon_sym_restrict] = ACTIONS(6659),
    [anon_sym_volatile] = ACTIONS(6659),
    [anon_sym__Atomic] = ACTIONS(6659),
    [anon_sym_mutable] = ACTIONS(6659),
    [anon_sym_explicit] = ACTIONS(6659),
    [anon_sym_constexpr] = ACTIONS(6659),
    [anon_sym_unsigned] = ACTIONS(6659),
    [anon_sym_long] = ACTIONS(6659),
    [anon_sym_short] = ACTIONS(6659),
    [sym_primitive_type] = ACTIONS(6659),
    [anon_sym_enum] = ACTIONS(6659),
    [anon_sym_struct] = ACTIONS(6659),
    [anon_sym_union] = ACTIONS(6659),
    [anon_sym_if] = ACTIONS(6659),
    [anon_sym_switch] = ACTIONS(6659),
    [anon_sym_case] = ACTIONS(6659),
    [anon_sym_default] = ACTIONS(6659),
    [anon_sym_while] = ACTIONS(6659),
    [anon_sym_do] = ACTIONS(6659),
    [anon_sym_for] = ACTIONS(6659),
    [anon_sym_return] = ACTIONS(6659),
    [anon_sym_break] = ACTIONS(6659),
    [anon_sym_continue] = ACTIONS(6659),
    [anon_sym_goto] = ACTIONS(6659),
    [anon_sym_AMP] = ACTIONS(6657),
    [anon_sym_BANG] = ACTIONS(6657),
    [anon_sym_TILDE] = ACTIONS(6657),
    [anon_sym_PLUS] = ACTIONS(6659),
    [anon_sym_DASH] = ACTIONS(6659),
    [anon_sym_DASH_DASH] = ACTIONS(6657),
    [anon_sym_PLUS_PLUS] = ACTIONS(6657),
    [anon_sym_sizeof] = ACTIONS(6659),
    [sym_number_literal] = ACTIONS(6657),
    [sym_char_literal] = ACTIONS(6657),
    [sym_string_literal] = ACTIONS(6657),
    [sym_true] = ACTIONS(6659),
    [sym_false] = ACTIONS(6659),
    [sym_null] = ACTIONS(6659),
    [sym_identifier] = ACTIONS(6659),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(6659),
    [sym_auto] = ACTIONS(6659),
    [anon_sym_typename] = ACTIONS(6659),
    [anon_sym_new] = ACTIONS(6659),
    [anon_sym_COLON_COLON] = ACTIONS(6657),
    [anon_sym_delete] = ACTIONS(6659),
    [sym_nullptr] = ACTIONS(6659),
  },
  [2879] = {
    [sym_compound_statement] = STATE(2974),
    [sym_labeled_statement] = STATE(2974),
    [sym_expression_statement] = STATE(2974),
    [sym_if_statement] = STATE(2974),
    [sym_switch_statement] = STATE(2974),
    [sym_case_statement] = STATE(2974),
    [sym_while_statement] = STATE(2974),
    [sym_do_statement] = STATE(2974),
    [sym_for_statement] = STATE(2974),
    [sym_return_statement] = STATE(2974),
    [sym_break_statement] = STATE(2974),
    [sym_continue_statement] = STATE(2974),
    [sym_goto_statement] = STATE(2974),
    [sym__expression] = STATE(1419),
    [sym_comma_expression] = STATE(1420),
    [sym_conditional_expression] = STATE(1419),
    [sym_assignment_expression] = STATE(1419),
    [sym_pointer_expression] = STATE(1419),
    [sym_logical_expression] = STATE(1419),
    [sym_bitwise_expression] = STATE(1419),
    [sym_equality_expression] = STATE(1419),
    [sym_relational_expression] = STATE(1419),
    [sym_shift_expression] = STATE(1419),
    [sym_math_expression] = STATE(1419),
    [sym_cast_expression] = STATE(1419),
    [sym_sizeof_expression] = STATE(1419),
    [sym_subscript_expression] = STATE(1419),
    [sym_call_expression] = STATE(1419),
    [sym_field_expression] = STATE(1419),
    [sym_compound_literal_expression] = STATE(1419),
    [sym_parenthesized_expression] = STATE(1419),
    [sym_concatenated_string] = STATE(1419),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(1419),
    [sym_for_range_loop] = STATE(2974),
    [sym_new_expression] = STATE(1419),
    [sym_delete_expression] = STATE(1419),
    [sym_lambda_expression] = STATE(1419),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(2879),
    [anon_sym_LPAREN] = ACTIONS(626),
    [anon_sym_SEMI] = ACTIONS(2899),
    [anon_sym_LBRACE] = ACTIONS(2903),
    [anon_sym_STAR] = ACTIONS(644),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_if] = ACTIONS(2905),
    [anon_sym_switch] = ACTIONS(2907),
    [anon_sym_case] = ACTIONS(2909),
    [anon_sym_default] = ACTIONS(2911),
    [anon_sym_while] = ACTIONS(2913),
    [anon_sym_do] = ACTIONS(2915),
    [anon_sym_for] = ACTIONS(2917),
    [anon_sym_return] = ACTIONS(2919),
    [anon_sym_break] = ACTIONS(2921),
    [anon_sym_continue] = ACTIONS(2923),
    [anon_sym_goto] = ACTIONS(2925),
    [anon_sym_AMP] = ACTIONS(644),
    [anon_sym_BANG] = ACTIONS(668),
    [anon_sym_TILDE] = ACTIONS(670),
    [anon_sym_PLUS] = ACTIONS(672),
    [anon_sym_DASH] = ACTIONS(672),
    [anon_sym_DASH_DASH] = ACTIONS(674),
    [anon_sym_PLUS_PLUS] = ACTIONS(674),
    [anon_sym_sizeof] = ACTIONS(676),
    [sym_number_literal] = ACTIONS(2879),
    [sym_char_literal] = ACTIONS(2879),
    [sym_string_literal] = ACTIONS(678),
    [sym_true] = ACTIONS(2927),
    [sym_false] = ACTIONS(2927),
    [sym_null] = ACTIONS(2927),
    [sym_identifier] = ACTIONS(5397),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1303),
    [anon_sym_delete] = ACTIONS(686),
    [sym_nullptr] = ACTIONS(2927),
  },
  [2880] = {
    [aux_sym_for_statement_repeat1] = STATE(2796),
    [anon_sym_COMMA] = ACTIONS(6339),
    [anon_sym_RPAREN] = ACTIONS(7025),
    [sym_comment] = ACTIONS(49),
  },
  [2881] = {
    [sym_argument_list] = STATE(802),
    [aux_sym_for_statement_repeat1] = STATE(2976),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_COMMA] = ACTIONS(6339),
    [anon_sym_RPAREN] = ACTIONS(7025),
    [anon_sym_STAR] = ACTIONS(2234),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_EQ] = ACTIONS(2236),
    [anon_sym_QMARK] = ACTIONS(2238),
    [anon_sym_STAR_EQ] = ACTIONS(2240),
    [anon_sym_SLASH_EQ] = ACTIONS(2240),
    [anon_sym_PERCENT_EQ] = ACTIONS(2240),
    [anon_sym_PLUS_EQ] = ACTIONS(2240),
    [anon_sym_DASH_EQ] = ACTIONS(2240),
    [anon_sym_LT_LT_EQ] = ACTIONS(2240),
    [anon_sym_GT_GT_EQ] = ACTIONS(2240),
    [anon_sym_AMP_EQ] = ACTIONS(2240),
    [anon_sym_CARET_EQ] = ACTIONS(2240),
    [anon_sym_PIPE_EQ] = ACTIONS(2240),
    [anon_sym_AMP] = ACTIONS(2242),
    [anon_sym_PIPE_PIPE] = ACTIONS(2244),
    [anon_sym_AMP_AMP] = ACTIONS(2246),
    [anon_sym_PIPE] = ACTIONS(2248),
    [anon_sym_CARET] = ACTIONS(2250),
    [anon_sym_EQ_EQ] = ACTIONS(2252),
    [anon_sym_BANG_EQ] = ACTIONS(2252),
    [anon_sym_LT] = ACTIONS(2254),
    [anon_sym_GT] = ACTIONS(2254),
    [anon_sym_LT_EQ] = ACTIONS(2256),
    [anon_sym_GT_EQ] = ACTIONS(2256),
    [anon_sym_LT_LT] = ACTIONS(2258),
    [anon_sym_GT_GT] = ACTIONS(2258),
    [anon_sym_PLUS] = ACTIONS(2260),
    [anon_sym_DASH] = ACTIONS(2260),
    [anon_sym_SLASH] = ACTIONS(2234),
    [anon_sym_PERCENT] = ACTIONS(2234),
    [anon_sym_DASH_DASH] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(1554),
    [anon_sym_DASH_GT] = ACTIONS(1554),
    [sym_comment] = ACTIONS(49),
  },
  [2882] = {
    [sym__expression] = STATE(2977),
    [sym_conditional_expression] = STATE(2977),
    [sym_assignment_expression] = STATE(2977),
    [sym_pointer_expression] = STATE(2977),
    [sym_logical_expression] = STATE(2977),
    [sym_bitwise_expression] = STATE(2977),
    [sym_equality_expression] = STATE(2977),
    [sym_relational_expression] = STATE(2977),
    [sym_shift_expression] = STATE(2977),
    [sym_math_expression] = STATE(2977),
    [sym_cast_expression] = STATE(2977),
    [sym_sizeof_expression] = STATE(2977),
    [sym_subscript_expression] = STATE(2977),
    [sym_call_expression] = STATE(2977),
    [sym_field_expression] = STATE(2977),
    [sym_compound_literal_expression] = STATE(2977),
    [sym_parenthesized_expression] = STATE(2977),
    [sym_concatenated_string] = STATE(2977),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(2977),
    [sym_new_expression] = STATE(2977),
    [sym_delete_expression] = STATE(2977),
    [sym_lambda_expression] = STATE(2977),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(7027),
    [anon_sym_LPAREN] = ACTIONS(1087),
    [anon_sym_RPAREN] = ACTIONS(7025),
    [anon_sym_STAR] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_AMP] = ACTIONS(1089),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1093),
    [anon_sym_PLUS] = ACTIONS(1095),
    [anon_sym_DASH] = ACTIONS(1095),
    [anon_sym_DASH_DASH] = ACTIONS(1097),
    [anon_sym_PLUS_PLUS] = ACTIONS(1097),
    [anon_sym_sizeof] = ACTIONS(1099),
    [sym_number_literal] = ACTIONS(7027),
    [sym_char_literal] = ACTIONS(7027),
    [sym_string_literal] = ACTIONS(1101),
    [sym_true] = ACTIONS(7029),
    [sym_false] = ACTIONS(7029),
    [sym_null] = ACTIONS(7029),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_delete] = ACTIONS(1109),
    [sym_nullptr] = ACTIONS(7029),
  },
  [2883] = {
    [sym_compound_statement] = STATE(2978),
    [sym_labeled_statement] = STATE(2978),
    [sym_expression_statement] = STATE(2978),
    [sym_if_statement] = STATE(2978),
    [sym_switch_statement] = STATE(2978),
    [sym_case_statement] = STATE(2978),
    [sym_while_statement] = STATE(2978),
    [sym_do_statement] = STATE(2978),
    [sym_for_statement] = STATE(2978),
    [sym_return_statement] = STATE(2978),
    [sym_break_statement] = STATE(2978),
    [sym_continue_statement] = STATE(2978),
    [sym_goto_statement] = STATE(2978),
    [sym__expression] = STATE(1419),
    [sym_comma_expression] = STATE(1420),
    [sym_conditional_expression] = STATE(1419),
    [sym_assignment_expression] = STATE(1419),
    [sym_pointer_expression] = STATE(1419),
    [sym_logical_expression] = STATE(1419),
    [sym_bitwise_expression] = STATE(1419),
    [sym_equality_expression] = STATE(1419),
    [sym_relational_expression] = STATE(1419),
    [sym_shift_expression] = STATE(1419),
    [sym_math_expression] = STATE(1419),
    [sym_cast_expression] = STATE(1419),
    [sym_sizeof_expression] = STATE(1419),
    [sym_subscript_expression] = STATE(1419),
    [sym_call_expression] = STATE(1419),
    [sym_field_expression] = STATE(1419),
    [sym_compound_literal_expression] = STATE(1419),
    [sym_parenthesized_expression] = STATE(1419),
    [sym_concatenated_string] = STATE(1419),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(1419),
    [sym_for_range_loop] = STATE(2978),
    [sym_new_expression] = STATE(1419),
    [sym_delete_expression] = STATE(1419),
    [sym_lambda_expression] = STATE(1419),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(2879),
    [anon_sym_LPAREN] = ACTIONS(626),
    [anon_sym_SEMI] = ACTIONS(2899),
    [anon_sym_LBRACE] = ACTIONS(2903),
    [anon_sym_STAR] = ACTIONS(644),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_if] = ACTIONS(2905),
    [anon_sym_switch] = ACTIONS(2907),
    [anon_sym_case] = ACTIONS(2909),
    [anon_sym_default] = ACTIONS(2911),
    [anon_sym_while] = ACTIONS(2913),
    [anon_sym_do] = ACTIONS(2915),
    [anon_sym_for] = ACTIONS(2917),
    [anon_sym_return] = ACTIONS(2919),
    [anon_sym_break] = ACTIONS(2921),
    [anon_sym_continue] = ACTIONS(2923),
    [anon_sym_goto] = ACTIONS(2925),
    [anon_sym_AMP] = ACTIONS(644),
    [anon_sym_BANG] = ACTIONS(668),
    [anon_sym_TILDE] = ACTIONS(670),
    [anon_sym_PLUS] = ACTIONS(672),
    [anon_sym_DASH] = ACTIONS(672),
    [anon_sym_DASH_DASH] = ACTIONS(674),
    [anon_sym_PLUS_PLUS] = ACTIONS(674),
    [anon_sym_sizeof] = ACTIONS(676),
    [sym_number_literal] = ACTIONS(2879),
    [sym_char_literal] = ACTIONS(2879),
    [sym_string_literal] = ACTIONS(678),
    [sym_true] = ACTIONS(2927),
    [sym_false] = ACTIONS(2927),
    [sym_null] = ACTIONS(2927),
    [sym_identifier] = ACTIONS(5397),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1303),
    [anon_sym_delete] = ACTIONS(686),
    [sym_nullptr] = ACTIONS(2927),
  },
  [2884] = {
    [sym_compound_statement] = STATE(2979),
    [sym_labeled_statement] = STATE(2979),
    [sym_expression_statement] = STATE(2979),
    [sym_if_statement] = STATE(2979),
    [sym_switch_statement] = STATE(2979),
    [sym_case_statement] = STATE(2979),
    [sym_while_statement] = STATE(2979),
    [sym_do_statement] = STATE(2979),
    [sym_for_statement] = STATE(2979),
    [sym_return_statement] = STATE(2979),
    [sym_break_statement] = STATE(2979),
    [sym_continue_statement] = STATE(2979),
    [sym_goto_statement] = STATE(2979),
    [sym__expression] = STATE(2378),
    [sym_comma_expression] = STATE(2379),
    [sym_conditional_expression] = STATE(2378),
    [sym_assignment_expression] = STATE(2378),
    [sym_pointer_expression] = STATE(2378),
    [sym_logical_expression] = STATE(2378),
    [sym_bitwise_expression] = STATE(2378),
    [sym_equality_expression] = STATE(2378),
    [sym_relational_expression] = STATE(2378),
    [sym_shift_expression] = STATE(2378),
    [sym_math_expression] = STATE(2378),
    [sym_cast_expression] = STATE(2378),
    [sym_sizeof_expression] = STATE(2378),
    [sym_subscript_expression] = STATE(2378),
    [sym_call_expression] = STATE(2378),
    [sym_field_expression] = STATE(2378),
    [sym_compound_literal_expression] = STATE(2378),
    [sym_parenthesized_expression] = STATE(2378),
    [sym_concatenated_string] = STATE(2378),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(2378),
    [sym_for_range_loop] = STATE(2979),
    [sym_new_expression] = STATE(2378),
    [sym_delete_expression] = STATE(2378),
    [sym_lambda_expression] = STATE(2378),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(5538),
    [anon_sym_LPAREN] = ACTIONS(626),
    [anon_sym_SEMI] = ACTIONS(5540),
    [anon_sym_LBRACE] = ACTIONS(5542),
    [anon_sym_STAR] = ACTIONS(644),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_if] = ACTIONS(5544),
    [anon_sym_switch] = ACTIONS(5546),
    [anon_sym_case] = ACTIONS(5548),
    [anon_sym_default] = ACTIONS(5550),
    [anon_sym_while] = ACTIONS(5552),
    [anon_sym_do] = ACTIONS(5554),
    [anon_sym_for] = ACTIONS(5556),
    [anon_sym_return] = ACTIONS(5558),
    [anon_sym_break] = ACTIONS(5560),
    [anon_sym_continue] = ACTIONS(5562),
    [anon_sym_goto] = ACTIONS(5564),
    [anon_sym_AMP] = ACTIONS(644),
    [anon_sym_BANG] = ACTIONS(668),
    [anon_sym_TILDE] = ACTIONS(670),
    [anon_sym_PLUS] = ACTIONS(672),
    [anon_sym_DASH] = ACTIONS(672),
    [anon_sym_DASH_DASH] = ACTIONS(674),
    [anon_sym_PLUS_PLUS] = ACTIONS(674),
    [anon_sym_sizeof] = ACTIONS(676),
    [sym_number_literal] = ACTIONS(5538),
    [sym_char_literal] = ACTIONS(5538),
    [sym_string_literal] = ACTIONS(678),
    [sym_true] = ACTIONS(5566),
    [sym_false] = ACTIONS(5566),
    [sym_null] = ACTIONS(5566),
    [sym_identifier] = ACTIONS(5568),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1303),
    [anon_sym_delete] = ACTIONS(686),
    [sym_nullptr] = ACTIONS(5566),
  },
  [2885] = {
    [sym_argument_list] = STATE(802),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_RPAREN] = ACTIONS(7031),
    [anon_sym_STAR] = ACTIONS(4537),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_EQ] = ACTIONS(4539),
    [anon_sym_QMARK] = ACTIONS(4541),
    [anon_sym_STAR_EQ] = ACTIONS(4543),
    [anon_sym_SLASH_EQ] = ACTIONS(4543),
    [anon_sym_PERCENT_EQ] = ACTIONS(4543),
    [anon_sym_PLUS_EQ] = ACTIONS(4543),
    [anon_sym_DASH_EQ] = ACTIONS(4543),
    [anon_sym_LT_LT_EQ] = ACTIONS(4543),
    [anon_sym_GT_GT_EQ] = ACTIONS(4543),
    [anon_sym_AMP_EQ] = ACTIONS(4543),
    [anon_sym_CARET_EQ] = ACTIONS(4543),
    [anon_sym_PIPE_EQ] = ACTIONS(4543),
    [anon_sym_AMP] = ACTIONS(4545),
    [anon_sym_PIPE_PIPE] = ACTIONS(4547),
    [anon_sym_AMP_AMP] = ACTIONS(4549),
    [anon_sym_PIPE] = ACTIONS(4551),
    [anon_sym_CARET] = ACTIONS(4553),
    [anon_sym_EQ_EQ] = ACTIONS(4555),
    [anon_sym_BANG_EQ] = ACTIONS(4555),
    [anon_sym_LT] = ACTIONS(4557),
    [anon_sym_GT] = ACTIONS(4557),
    [anon_sym_LT_EQ] = ACTIONS(4559),
    [anon_sym_GT_EQ] = ACTIONS(4559),
    [anon_sym_LT_LT] = ACTIONS(4561),
    [anon_sym_GT_GT] = ACTIONS(4561),
    [anon_sym_PLUS] = ACTIONS(4563),
    [anon_sym_DASH] = ACTIONS(4563),
    [anon_sym_SLASH] = ACTIONS(4537),
    [anon_sym_PERCENT] = ACTIONS(4537),
    [anon_sym_DASH_DASH] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(1554),
    [anon_sym_DASH_GT] = ACTIONS(1554),
    [sym_comment] = ACTIONS(49),
  },
  [2886] = {
    [sym_compound_statement] = STATE(2981),
    [sym_labeled_statement] = STATE(2981),
    [sym_expression_statement] = STATE(2981),
    [sym_if_statement] = STATE(2981),
    [sym_switch_statement] = STATE(2981),
    [sym_case_statement] = STATE(2981),
    [sym_while_statement] = STATE(2981),
    [sym_do_statement] = STATE(2981),
    [sym_for_statement] = STATE(2981),
    [sym_return_statement] = STATE(2981),
    [sym_break_statement] = STATE(2981),
    [sym_continue_statement] = STATE(2981),
    [sym_goto_statement] = STATE(2981),
    [sym__expression] = STATE(2378),
    [sym_comma_expression] = STATE(2379),
    [sym_conditional_expression] = STATE(2378),
    [sym_assignment_expression] = STATE(2378),
    [sym_pointer_expression] = STATE(2378),
    [sym_logical_expression] = STATE(2378),
    [sym_bitwise_expression] = STATE(2378),
    [sym_equality_expression] = STATE(2378),
    [sym_relational_expression] = STATE(2378),
    [sym_shift_expression] = STATE(2378),
    [sym_math_expression] = STATE(2378),
    [sym_cast_expression] = STATE(2378),
    [sym_sizeof_expression] = STATE(2378),
    [sym_subscript_expression] = STATE(2378),
    [sym_call_expression] = STATE(2378),
    [sym_field_expression] = STATE(2378),
    [sym_compound_literal_expression] = STATE(2378),
    [sym_parenthesized_expression] = STATE(2378),
    [sym_concatenated_string] = STATE(2378),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(2378),
    [sym_for_range_loop] = STATE(2981),
    [sym_new_expression] = STATE(2378),
    [sym_delete_expression] = STATE(2378),
    [sym_lambda_expression] = STATE(2378),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(5538),
    [anon_sym_LPAREN] = ACTIONS(626),
    [anon_sym_SEMI] = ACTIONS(5540),
    [anon_sym_LBRACE] = ACTIONS(5542),
    [anon_sym_STAR] = ACTIONS(644),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_if] = ACTIONS(5544),
    [anon_sym_switch] = ACTIONS(5546),
    [anon_sym_case] = ACTIONS(5548),
    [anon_sym_default] = ACTIONS(5550),
    [anon_sym_while] = ACTIONS(5552),
    [anon_sym_do] = ACTIONS(5554),
    [anon_sym_for] = ACTIONS(5556),
    [anon_sym_return] = ACTIONS(5558),
    [anon_sym_break] = ACTIONS(5560),
    [anon_sym_continue] = ACTIONS(5562),
    [anon_sym_goto] = ACTIONS(5564),
    [anon_sym_AMP] = ACTIONS(644),
    [anon_sym_BANG] = ACTIONS(668),
    [anon_sym_TILDE] = ACTIONS(670),
    [anon_sym_PLUS] = ACTIONS(672),
    [anon_sym_DASH] = ACTIONS(672),
    [anon_sym_DASH_DASH] = ACTIONS(674),
    [anon_sym_PLUS_PLUS] = ACTIONS(674),
    [anon_sym_sizeof] = ACTIONS(676),
    [sym_number_literal] = ACTIONS(5538),
    [sym_char_literal] = ACTIONS(5538),
    [sym_string_literal] = ACTIONS(678),
    [sym_true] = ACTIONS(5566),
    [sym_false] = ACTIONS(5566),
    [sym_null] = ACTIONS(5566),
    [sym_identifier] = ACTIONS(5568),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1303),
    [anon_sym_delete] = ACTIONS(686),
    [sym_nullptr] = ACTIONS(5566),
  },
  [2887] = {
    [sym_raw_string_literal] = ACTIONS(5631),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(5633),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(5633),
    [anon_sym_LPAREN] = ACTIONS(5631),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(5633),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(5633),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(5633),
    [sym_preproc_directive] = ACTIONS(5633),
    [anon_sym_SEMI] = ACTIONS(5631),
    [anon_sym_typedef] = ACTIONS(5633),
    [anon_sym_extern] = ACTIONS(5633),
    [anon_sym_LBRACE] = ACTIONS(5631),
    [anon_sym_RBRACE] = ACTIONS(5631),
    [anon_sym_STAR] = ACTIONS(5631),
    [anon_sym_LBRACK] = ACTIONS(5631),
    [anon_sym_static] = ACTIONS(5633),
    [anon_sym_register] = ACTIONS(5633),
    [anon_sym_inline] = ACTIONS(5633),
    [anon_sym_const] = ACTIONS(5633),
    [anon_sym_restrict] = ACTIONS(5633),
    [anon_sym_volatile] = ACTIONS(5633),
    [anon_sym__Atomic] = ACTIONS(5633),
    [anon_sym_mutable] = ACTIONS(5633),
    [anon_sym_explicit] = ACTIONS(5633),
    [anon_sym_constexpr] = ACTIONS(5633),
    [anon_sym_unsigned] = ACTIONS(5633),
    [anon_sym_long] = ACTIONS(5633),
    [anon_sym_short] = ACTIONS(5633),
    [sym_primitive_type] = ACTIONS(5633),
    [anon_sym_enum] = ACTIONS(5633),
    [anon_sym_struct] = ACTIONS(5633),
    [anon_sym_union] = ACTIONS(5633),
    [anon_sym_if] = ACTIONS(5633),
    [anon_sym_else] = ACTIONS(5633),
    [anon_sym_switch] = ACTIONS(5633),
    [anon_sym_case] = ACTIONS(5633),
    [anon_sym_default] = ACTIONS(5633),
    [anon_sym_while] = ACTIONS(5633),
    [anon_sym_do] = ACTIONS(5633),
    [anon_sym_for] = ACTIONS(5633),
    [anon_sym_return] = ACTIONS(5633),
    [anon_sym_break] = ACTIONS(5633),
    [anon_sym_continue] = ACTIONS(5633),
    [anon_sym_goto] = ACTIONS(5633),
    [anon_sym_AMP] = ACTIONS(5631),
    [anon_sym_BANG] = ACTIONS(5631),
    [anon_sym_TILDE] = ACTIONS(5631),
    [anon_sym_PLUS] = ACTIONS(5633),
    [anon_sym_DASH] = ACTIONS(5633),
    [anon_sym_DASH_DASH] = ACTIONS(5631),
    [anon_sym_PLUS_PLUS] = ACTIONS(5631),
    [anon_sym_sizeof] = ACTIONS(5633),
    [sym_number_literal] = ACTIONS(5631),
    [sym_char_literal] = ACTIONS(5631),
    [sym_string_literal] = ACTIONS(5631),
    [sym_true] = ACTIONS(5633),
    [sym_false] = ACTIONS(5633),
    [sym_null] = ACTIONS(5633),
    [sym_identifier] = ACTIONS(5633),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(5633),
    [sym_auto] = ACTIONS(5633),
    [anon_sym_typename] = ACTIONS(5633),
    [anon_sym_new] = ACTIONS(5633),
    [anon_sym_COLON_COLON] = ACTIONS(5631),
    [anon_sym_delete] = ACTIONS(5633),
    [sym_nullptr] = ACTIONS(5633),
  },
  [2888] = {
    [sym__type_declarator] = STATE(2982),
    [sym_pointer_type_declarator] = STATE(213),
    [sym_function_type_declarator] = STATE(214),
    [sym_array_type_declarator] = STATE(215),
    [anon_sym_LPAREN] = ACTIONS(327),
    [anon_sym_STAR] = ACTIONS(329),
    [sym_identifier] = ACTIONS(331),
    [sym_comment] = ACTIONS(49),
  },
  [2889] = {
    [sym_type_qualifier] = STATE(219),
    [sym__type_specifier] = STATE(2983),
    [sym_sized_type_specifier] = STATE(2983),
    [sym_enum_specifier] = STATE(2983),
    [sym_struct_specifier] = STATE(2983),
    [sym_union_specifier] = STATE(2983),
    [sym_macro_type_specifier] = STATE(2983),
    [sym_class_specifier] = STATE(2983),
    [sym_dependent_type] = STATE(2983),
    [sym_template_type] = STATE(62),
    [sym_scoped_type_identifier] = STATE(63),
    [sym_scoped_namespace_identifier] = STATE(64),
    [aux_sym_type_definition_repeat1] = STATE(219),
    [aux_sym_sized_type_specifier_repeat1] = STATE(66),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_restrict] = ACTIONS(93),
    [anon_sym_volatile] = ACTIONS(93),
    [anon_sym__Atomic] = ACTIONS(93),
    [anon_sym_mutable] = ACTIONS(93),
    [anon_sym_explicit] = ACTIONS(93),
    [anon_sym_constexpr] = ACTIONS(93),
    [anon_sym_unsigned] = ACTIONS(95),
    [anon_sym_long] = ACTIONS(95),
    [anon_sym_short] = ACTIONS(95),
    [sym_primitive_type] = ACTIONS(7033),
    [anon_sym_enum] = ACTIONS(99),
    [anon_sym_struct] = ACTIONS(101),
    [anon_sym_union] = ACTIONS(103),
    [sym_identifier] = ACTIONS(105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(107),
    [sym_auto] = ACTIONS(7033),
    [anon_sym_typename] = ACTIONS(109),
    [anon_sym_COLON_COLON] = ACTIONS(111),
  },
  [2890] = {
    [sym_parameter_list] = STATE(332),
    [sym_argument_list] = STATE(333),
    [sym_initializer_list] = STATE(333),
    [aux_sym_declaration_repeat1] = STATE(2985),
    [anon_sym_LPAREN] = ACTIONS(536),
    [anon_sym_COMMA] = ACTIONS(538),
    [anon_sym_SEMI] = ACTIONS(7035),
    [anon_sym_LBRACE] = ACTIONS(548),
    [anon_sym_LBRACK] = ACTIONS(208),
    [anon_sym_EQ] = ACTIONS(544),
    [sym_comment] = ACTIONS(49),
  },
  [2891] = {
    [aux_sym_declaration_repeat1] = STATE(2985),
    [anon_sym_COMMA] = ACTIONS(538),
    [anon_sym_SEMI] = ACTIONS(7035),
    [sym_comment] = ACTIONS(49),
  },
  [2892] = {
    [sym_compound_statement] = STATE(2986),
    [sym_labeled_statement] = STATE(2986),
    [sym_expression_statement] = STATE(2986),
    [sym_if_statement] = STATE(2986),
    [sym_switch_statement] = STATE(2986),
    [sym_case_statement] = STATE(2986),
    [sym_while_statement] = STATE(2986),
    [sym_do_statement] = STATE(2986),
    [sym_for_statement] = STATE(2986),
    [sym_return_statement] = STATE(2986),
    [sym_break_statement] = STATE(2986),
    [sym_continue_statement] = STATE(2986),
    [sym_goto_statement] = STATE(2986),
    [sym__expression] = STATE(2378),
    [sym_comma_expression] = STATE(2379),
    [sym_conditional_expression] = STATE(2378),
    [sym_assignment_expression] = STATE(2378),
    [sym_pointer_expression] = STATE(2378),
    [sym_logical_expression] = STATE(2378),
    [sym_bitwise_expression] = STATE(2378),
    [sym_equality_expression] = STATE(2378),
    [sym_relational_expression] = STATE(2378),
    [sym_shift_expression] = STATE(2378),
    [sym_math_expression] = STATE(2378),
    [sym_cast_expression] = STATE(2378),
    [sym_sizeof_expression] = STATE(2378),
    [sym_subscript_expression] = STATE(2378),
    [sym_call_expression] = STATE(2378),
    [sym_field_expression] = STATE(2378),
    [sym_compound_literal_expression] = STATE(2378),
    [sym_parenthesized_expression] = STATE(2378),
    [sym_concatenated_string] = STATE(2378),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(2378),
    [sym_for_range_loop] = STATE(2986),
    [sym_new_expression] = STATE(2378),
    [sym_delete_expression] = STATE(2378),
    [sym_lambda_expression] = STATE(2378),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(5538),
    [anon_sym_LPAREN] = ACTIONS(626),
    [anon_sym_SEMI] = ACTIONS(5540),
    [anon_sym_LBRACE] = ACTIONS(5542),
    [anon_sym_STAR] = ACTIONS(644),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_if] = ACTIONS(5544),
    [anon_sym_switch] = ACTIONS(5546),
    [anon_sym_case] = ACTIONS(5548),
    [anon_sym_default] = ACTIONS(5550),
    [anon_sym_while] = ACTIONS(5552),
    [anon_sym_do] = ACTIONS(5554),
    [anon_sym_for] = ACTIONS(5556),
    [anon_sym_return] = ACTIONS(5558),
    [anon_sym_break] = ACTIONS(5560),
    [anon_sym_continue] = ACTIONS(5562),
    [anon_sym_goto] = ACTIONS(5564),
    [anon_sym_AMP] = ACTIONS(644),
    [anon_sym_BANG] = ACTIONS(668),
    [anon_sym_TILDE] = ACTIONS(670),
    [anon_sym_PLUS] = ACTIONS(672),
    [anon_sym_DASH] = ACTIONS(672),
    [anon_sym_DASH_DASH] = ACTIONS(674),
    [anon_sym_PLUS_PLUS] = ACTIONS(674),
    [anon_sym_sizeof] = ACTIONS(676),
    [sym_number_literal] = ACTIONS(5538),
    [sym_char_literal] = ACTIONS(5538),
    [sym_string_literal] = ACTIONS(678),
    [sym_true] = ACTIONS(5566),
    [sym_false] = ACTIONS(5566),
    [sym_null] = ACTIONS(5566),
    [sym_identifier] = ACTIONS(5568),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1303),
    [anon_sym_delete] = ACTIONS(686),
    [sym_nullptr] = ACTIONS(5566),
  },
  [2893] = {
    [sym__expression] = STATE(2987),
    [sym_conditional_expression] = STATE(2987),
    [sym_assignment_expression] = STATE(2987),
    [sym_pointer_expression] = STATE(2987),
    [sym_logical_expression] = STATE(2987),
    [sym_bitwise_expression] = STATE(2987),
    [sym_equality_expression] = STATE(2987),
    [sym_relational_expression] = STATE(2987),
    [sym_shift_expression] = STATE(2987),
    [sym_math_expression] = STATE(2987),
    [sym_cast_expression] = STATE(2987),
    [sym_sizeof_expression] = STATE(2987),
    [sym_subscript_expression] = STATE(2987),
    [sym_call_expression] = STATE(2987),
    [sym_field_expression] = STATE(2987),
    [sym_compound_literal_expression] = STATE(2987),
    [sym_parenthesized_expression] = STATE(2987),
    [sym_concatenated_string] = STATE(2987),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(2987),
    [sym_new_expression] = STATE(2987),
    [sym_delete_expression] = STATE(2987),
    [sym_lambda_expression] = STATE(2987),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(7037),
    [anon_sym_LPAREN] = ACTIONS(2943),
    [anon_sym_STAR] = ACTIONS(2945),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_AMP] = ACTIONS(2945),
    [anon_sym_BANG] = ACTIONS(2947),
    [anon_sym_TILDE] = ACTIONS(2949),
    [anon_sym_PLUS] = ACTIONS(2951),
    [anon_sym_DASH] = ACTIONS(2951),
    [anon_sym_DASH_DASH] = ACTIONS(2953),
    [anon_sym_PLUS_PLUS] = ACTIONS(2953),
    [anon_sym_sizeof] = ACTIONS(2955),
    [sym_number_literal] = ACTIONS(7037),
    [sym_char_literal] = ACTIONS(7037),
    [sym_string_literal] = ACTIONS(2957),
    [sym_true] = ACTIONS(7039),
    [sym_false] = ACTIONS(7039),
    [sym_null] = ACTIONS(7039),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(2961),
    [anon_sym_delete] = ACTIONS(2963),
    [sym_nullptr] = ACTIONS(7039),
  },
  [2894] = {
    [sym__expression] = STATE(2989),
    [sym_conditional_expression] = STATE(2989),
    [sym_assignment_expression] = STATE(2989),
    [sym_pointer_expression] = STATE(2989),
    [sym_logical_expression] = STATE(2989),
    [sym_bitwise_expression] = STATE(2989),
    [sym_equality_expression] = STATE(2989),
    [sym_relational_expression] = STATE(2989),
    [sym_shift_expression] = STATE(2989),
    [sym_math_expression] = STATE(2989),
    [sym_cast_expression] = STATE(2989),
    [sym_sizeof_expression] = STATE(2989),
    [sym_subscript_expression] = STATE(2989),
    [sym_call_expression] = STATE(2989),
    [sym_field_expression] = STATE(2989),
    [sym_compound_literal_expression] = STATE(2989),
    [sym_parenthesized_expression] = STATE(2989),
    [sym_concatenated_string] = STATE(2989),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(2989),
    [sym_new_expression] = STATE(2989),
    [sym_delete_expression] = STATE(2989),
    [sym_lambda_expression] = STATE(2989),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(7041),
    [anon_sym_LPAREN] = ACTIONS(1087),
    [anon_sym_RPAREN] = ACTIONS(7043),
    [anon_sym_STAR] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_AMP] = ACTIONS(1089),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1093),
    [anon_sym_PLUS] = ACTIONS(1095),
    [anon_sym_DASH] = ACTIONS(1095),
    [anon_sym_DASH_DASH] = ACTIONS(1097),
    [anon_sym_PLUS_PLUS] = ACTIONS(1097),
    [anon_sym_sizeof] = ACTIONS(1099),
    [sym_number_literal] = ACTIONS(7041),
    [sym_char_literal] = ACTIONS(7041),
    [sym_string_literal] = ACTIONS(1101),
    [sym_true] = ACTIONS(7045),
    [sym_false] = ACTIONS(7045),
    [sym_null] = ACTIONS(7045),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_delete] = ACTIONS(1109),
    [sym_nullptr] = ACTIONS(7045),
  },
  [2895] = {
    [sym_argument_list] = STATE(802),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_SEMI] = ACTIONS(7047),
    [anon_sym_STAR] = ACTIONS(2553),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_EQ] = ACTIONS(2555),
    [anon_sym_QMARK] = ACTIONS(2557),
    [anon_sym_STAR_EQ] = ACTIONS(2559),
    [anon_sym_SLASH_EQ] = ACTIONS(2559),
    [anon_sym_PERCENT_EQ] = ACTIONS(2559),
    [anon_sym_PLUS_EQ] = ACTIONS(2559),
    [anon_sym_DASH_EQ] = ACTIONS(2559),
    [anon_sym_LT_LT_EQ] = ACTIONS(2559),
    [anon_sym_GT_GT_EQ] = ACTIONS(2559),
    [anon_sym_AMP_EQ] = ACTIONS(2559),
    [anon_sym_CARET_EQ] = ACTIONS(2559),
    [anon_sym_PIPE_EQ] = ACTIONS(2559),
    [anon_sym_AMP] = ACTIONS(2561),
    [anon_sym_PIPE_PIPE] = ACTIONS(2563),
    [anon_sym_AMP_AMP] = ACTIONS(2565),
    [anon_sym_PIPE] = ACTIONS(2567),
    [anon_sym_CARET] = ACTIONS(2569),
    [anon_sym_EQ_EQ] = ACTIONS(2571),
    [anon_sym_BANG_EQ] = ACTIONS(2571),
    [anon_sym_LT] = ACTIONS(2573),
    [anon_sym_GT] = ACTIONS(2573),
    [anon_sym_LT_EQ] = ACTIONS(2575),
    [anon_sym_GT_EQ] = ACTIONS(2575),
    [anon_sym_LT_LT] = ACTIONS(2577),
    [anon_sym_GT_GT] = ACTIONS(2577),
    [anon_sym_PLUS] = ACTIONS(2579),
    [anon_sym_DASH] = ACTIONS(2579),
    [anon_sym_SLASH] = ACTIONS(2553),
    [anon_sym_PERCENT] = ACTIONS(2553),
    [anon_sym_DASH_DASH] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(1554),
    [anon_sym_DASH_GT] = ACTIONS(1554),
    [sym_comment] = ACTIONS(49),
  },
  [2896] = {
    [sym__expression] = STATE(2991),
    [sym_conditional_expression] = STATE(2991),
    [sym_assignment_expression] = STATE(2991),
    [sym_pointer_expression] = STATE(2991),
    [sym_logical_expression] = STATE(2991),
    [sym_bitwise_expression] = STATE(2991),
    [sym_equality_expression] = STATE(2991),
    [sym_relational_expression] = STATE(2991),
    [sym_shift_expression] = STATE(2991),
    [sym_math_expression] = STATE(2991),
    [sym_cast_expression] = STATE(2991),
    [sym_sizeof_expression] = STATE(2991),
    [sym_subscript_expression] = STATE(2991),
    [sym_call_expression] = STATE(2991),
    [sym_field_expression] = STATE(2991),
    [sym_compound_literal_expression] = STATE(2991),
    [sym_parenthesized_expression] = STATE(2991),
    [sym_concatenated_string] = STATE(2991),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(2991),
    [sym_new_expression] = STATE(2991),
    [sym_delete_expression] = STATE(2991),
    [sym_lambda_expression] = STATE(2991),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(7049),
    [anon_sym_LPAREN] = ACTIONS(1347),
    [anon_sym_SEMI] = ACTIONS(7047),
    [anon_sym_STAR] = ACTIONS(1349),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_AMP] = ACTIONS(1349),
    [anon_sym_BANG] = ACTIONS(1351),
    [anon_sym_TILDE] = ACTIONS(1353),
    [anon_sym_PLUS] = ACTIONS(1355),
    [anon_sym_DASH] = ACTIONS(1355),
    [anon_sym_DASH_DASH] = ACTIONS(1357),
    [anon_sym_PLUS_PLUS] = ACTIONS(1357),
    [anon_sym_sizeof] = ACTIONS(1359),
    [sym_number_literal] = ACTIONS(7049),
    [sym_char_literal] = ACTIONS(7049),
    [sym_string_literal] = ACTIONS(1361),
    [sym_true] = ACTIONS(7051),
    [sym_false] = ACTIONS(7051),
    [sym_null] = ACTIONS(7051),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1365),
    [anon_sym_delete] = ACTIONS(1367),
    [sym_nullptr] = ACTIONS(7051),
  },
  [2897] = {
    [sym__expression] = STATE(2992),
    [sym_conditional_expression] = STATE(2992),
    [sym_assignment_expression] = STATE(2992),
    [sym_pointer_expression] = STATE(2992),
    [sym_logical_expression] = STATE(2992),
    [sym_bitwise_expression] = STATE(2992),
    [sym_equality_expression] = STATE(2992),
    [sym_relational_expression] = STATE(2992),
    [sym_shift_expression] = STATE(2992),
    [sym_math_expression] = STATE(2992),
    [sym_cast_expression] = STATE(2992),
    [sym_sizeof_expression] = STATE(2992),
    [sym_subscript_expression] = STATE(2992),
    [sym_call_expression] = STATE(2992),
    [sym_field_expression] = STATE(2992),
    [sym_compound_literal_expression] = STATE(2992),
    [sym_parenthesized_expression] = STATE(2992),
    [sym_concatenated_string] = STATE(2992),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(2992),
    [sym_new_expression] = STATE(2992),
    [sym_delete_expression] = STATE(2992),
    [sym_lambda_expression] = STATE(2992),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(7053),
    [anon_sym_LPAREN] = ACTIONS(2943),
    [anon_sym_STAR] = ACTIONS(2945),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_AMP] = ACTIONS(2945),
    [anon_sym_BANG] = ACTIONS(2947),
    [anon_sym_TILDE] = ACTIONS(2949),
    [anon_sym_PLUS] = ACTIONS(2951),
    [anon_sym_DASH] = ACTIONS(2951),
    [anon_sym_DASH_DASH] = ACTIONS(2953),
    [anon_sym_PLUS_PLUS] = ACTIONS(2953),
    [anon_sym_sizeof] = ACTIONS(2955),
    [sym_number_literal] = ACTIONS(7053),
    [sym_char_literal] = ACTIONS(7053),
    [sym_string_literal] = ACTIONS(2957),
    [sym_true] = ACTIONS(7055),
    [sym_false] = ACTIONS(7055),
    [sym_null] = ACTIONS(7055),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(2961),
    [anon_sym_delete] = ACTIONS(2963),
    [sym_nullptr] = ACTIONS(7055),
  },
  [2898] = {
    [sym_raw_string_literal] = ACTIONS(7057),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(7059),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(7059),
    [anon_sym_LPAREN] = ACTIONS(7057),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(7059),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(7059),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(7059),
    [sym_preproc_directive] = ACTIONS(7059),
    [anon_sym_SEMI] = ACTIONS(7057),
    [anon_sym_typedef] = ACTIONS(7059),
    [anon_sym_extern] = ACTIONS(7059),
    [anon_sym_LBRACE] = ACTIONS(7057),
    [anon_sym_RBRACE] = ACTIONS(7057),
    [anon_sym_STAR] = ACTIONS(7057),
    [anon_sym_LBRACK] = ACTIONS(7057),
    [anon_sym_static] = ACTIONS(7059),
    [anon_sym_register] = ACTIONS(7059),
    [anon_sym_inline] = ACTIONS(7059),
    [anon_sym_const] = ACTIONS(7059),
    [anon_sym_restrict] = ACTIONS(7059),
    [anon_sym_volatile] = ACTIONS(7059),
    [anon_sym__Atomic] = ACTIONS(7059),
    [anon_sym_mutable] = ACTIONS(7059),
    [anon_sym_explicit] = ACTIONS(7059),
    [anon_sym_constexpr] = ACTIONS(7059),
    [anon_sym_unsigned] = ACTIONS(7059),
    [anon_sym_long] = ACTIONS(7059),
    [anon_sym_short] = ACTIONS(7059),
    [sym_primitive_type] = ACTIONS(7059),
    [anon_sym_enum] = ACTIONS(7059),
    [anon_sym_struct] = ACTIONS(7059),
    [anon_sym_union] = ACTIONS(7059),
    [anon_sym_if] = ACTIONS(7059),
    [anon_sym_switch] = ACTIONS(7059),
    [anon_sym_case] = ACTIONS(7059),
    [anon_sym_default] = ACTIONS(7059),
    [anon_sym_while] = ACTIONS(7059),
    [anon_sym_do] = ACTIONS(7059),
    [anon_sym_for] = ACTIONS(7059),
    [anon_sym_return] = ACTIONS(7059),
    [anon_sym_break] = ACTIONS(7059),
    [anon_sym_continue] = ACTIONS(7059),
    [anon_sym_goto] = ACTIONS(7059),
    [anon_sym_AMP] = ACTIONS(7057),
    [anon_sym_BANG] = ACTIONS(7057),
    [anon_sym_TILDE] = ACTIONS(7057),
    [anon_sym_PLUS] = ACTIONS(7059),
    [anon_sym_DASH] = ACTIONS(7059),
    [anon_sym_DASH_DASH] = ACTIONS(7057),
    [anon_sym_PLUS_PLUS] = ACTIONS(7057),
    [anon_sym_sizeof] = ACTIONS(7059),
    [sym_number_literal] = ACTIONS(7057),
    [sym_char_literal] = ACTIONS(7057),
    [sym_string_literal] = ACTIONS(7057),
    [sym_true] = ACTIONS(7059),
    [sym_false] = ACTIONS(7059),
    [sym_null] = ACTIONS(7059),
    [sym_identifier] = ACTIONS(7059),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(7059),
    [sym_auto] = ACTIONS(7059),
    [anon_sym_typename] = ACTIONS(7059),
    [anon_sym_new] = ACTIONS(7059),
    [anon_sym_COLON_COLON] = ACTIONS(7057),
    [anon_sym_delete] = ACTIONS(7059),
    [sym_nullptr] = ACTIONS(7059),
  },
  [2899] = {
    [sym_argument_list] = STATE(802),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_RPAREN] = ACTIONS(7061),
    [anon_sym_STAR] = ACTIONS(4537),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_EQ] = ACTIONS(4539),
    [anon_sym_QMARK] = ACTIONS(4541),
    [anon_sym_STAR_EQ] = ACTIONS(4543),
    [anon_sym_SLASH_EQ] = ACTIONS(4543),
    [anon_sym_PERCENT_EQ] = ACTIONS(4543),
    [anon_sym_PLUS_EQ] = ACTIONS(4543),
    [anon_sym_DASH_EQ] = ACTIONS(4543),
    [anon_sym_LT_LT_EQ] = ACTIONS(4543),
    [anon_sym_GT_GT_EQ] = ACTIONS(4543),
    [anon_sym_AMP_EQ] = ACTIONS(4543),
    [anon_sym_CARET_EQ] = ACTIONS(4543),
    [anon_sym_PIPE_EQ] = ACTIONS(4543),
    [anon_sym_AMP] = ACTIONS(4545),
    [anon_sym_PIPE_PIPE] = ACTIONS(4547),
    [anon_sym_AMP_AMP] = ACTIONS(4549),
    [anon_sym_PIPE] = ACTIONS(4551),
    [anon_sym_CARET] = ACTIONS(4553),
    [anon_sym_EQ_EQ] = ACTIONS(4555),
    [anon_sym_BANG_EQ] = ACTIONS(4555),
    [anon_sym_LT] = ACTIONS(4557),
    [anon_sym_GT] = ACTIONS(4557),
    [anon_sym_LT_EQ] = ACTIONS(4559),
    [anon_sym_GT_EQ] = ACTIONS(4559),
    [anon_sym_LT_LT] = ACTIONS(4561),
    [anon_sym_GT_GT] = ACTIONS(4561),
    [anon_sym_PLUS] = ACTIONS(4563),
    [anon_sym_DASH] = ACTIONS(4563),
    [anon_sym_SLASH] = ACTIONS(4537),
    [anon_sym_PERCENT] = ACTIONS(4537),
    [anon_sym_DASH_DASH] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(1554),
    [anon_sym_DASH_GT] = ACTIONS(1554),
    [sym_comment] = ACTIONS(49),
  },
  [2900] = {
    [sym__expression] = STATE(2994),
    [sym_conditional_expression] = STATE(2994),
    [sym_assignment_expression] = STATE(2994),
    [sym_pointer_expression] = STATE(2994),
    [sym_logical_expression] = STATE(2994),
    [sym_bitwise_expression] = STATE(2994),
    [sym_equality_expression] = STATE(2994),
    [sym_relational_expression] = STATE(2994),
    [sym_shift_expression] = STATE(2994),
    [sym_math_expression] = STATE(2994),
    [sym_cast_expression] = STATE(2994),
    [sym_sizeof_expression] = STATE(2994),
    [sym_subscript_expression] = STATE(2994),
    [sym_call_expression] = STATE(2994),
    [sym_field_expression] = STATE(2994),
    [sym_compound_literal_expression] = STATE(2994),
    [sym_parenthesized_expression] = STATE(2994),
    [sym_concatenated_string] = STATE(2994),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(2994),
    [sym_new_expression] = STATE(2994),
    [sym_delete_expression] = STATE(2994),
    [sym_lambda_expression] = STATE(2994),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(7063),
    [anon_sym_LPAREN] = ACTIONS(2943),
    [anon_sym_STAR] = ACTIONS(2945),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_AMP] = ACTIONS(2945),
    [anon_sym_BANG] = ACTIONS(2947),
    [anon_sym_TILDE] = ACTIONS(2949),
    [anon_sym_PLUS] = ACTIONS(2951),
    [anon_sym_DASH] = ACTIONS(2951),
    [anon_sym_DASH_DASH] = ACTIONS(2953),
    [anon_sym_PLUS_PLUS] = ACTIONS(2953),
    [anon_sym_sizeof] = ACTIONS(2955),
    [sym_number_literal] = ACTIONS(7063),
    [sym_char_literal] = ACTIONS(7063),
    [sym_string_literal] = ACTIONS(2957),
    [sym_true] = ACTIONS(7065),
    [sym_false] = ACTIONS(7065),
    [sym_null] = ACTIONS(7065),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(2961),
    [anon_sym_delete] = ACTIONS(2963),
    [sym_nullptr] = ACTIONS(7065),
  },
  [2901] = {
    [sym_argument_list] = STATE(802),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_RPAREN] = ACTIONS(7067),
    [anon_sym_STAR] = ACTIONS(4537),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_EQ] = ACTIONS(4539),
    [anon_sym_QMARK] = ACTIONS(4541),
    [anon_sym_STAR_EQ] = ACTIONS(4543),
    [anon_sym_SLASH_EQ] = ACTIONS(4543),
    [anon_sym_PERCENT_EQ] = ACTIONS(4543),
    [anon_sym_PLUS_EQ] = ACTIONS(4543),
    [anon_sym_DASH_EQ] = ACTIONS(4543),
    [anon_sym_LT_LT_EQ] = ACTIONS(4543),
    [anon_sym_GT_GT_EQ] = ACTIONS(4543),
    [anon_sym_AMP_EQ] = ACTIONS(4543),
    [anon_sym_CARET_EQ] = ACTIONS(4543),
    [anon_sym_PIPE_EQ] = ACTIONS(4543),
    [anon_sym_AMP] = ACTIONS(4545),
    [anon_sym_PIPE_PIPE] = ACTIONS(4547),
    [anon_sym_AMP_AMP] = ACTIONS(4549),
    [anon_sym_PIPE] = ACTIONS(4551),
    [anon_sym_CARET] = ACTIONS(4553),
    [anon_sym_EQ_EQ] = ACTIONS(4555),
    [anon_sym_BANG_EQ] = ACTIONS(4555),
    [anon_sym_LT] = ACTIONS(4557),
    [anon_sym_GT] = ACTIONS(4557),
    [anon_sym_LT_EQ] = ACTIONS(4559),
    [anon_sym_GT_EQ] = ACTIONS(4559),
    [anon_sym_LT_LT] = ACTIONS(4561),
    [anon_sym_GT_GT] = ACTIONS(4561),
    [anon_sym_PLUS] = ACTIONS(4563),
    [anon_sym_DASH] = ACTIONS(4563),
    [anon_sym_SLASH] = ACTIONS(4537),
    [anon_sym_PERCENT] = ACTIONS(4537),
    [anon_sym_DASH_DASH] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(1554),
    [anon_sym_DASH_GT] = ACTIONS(1554),
    [sym_comment] = ACTIONS(49),
  },
  [2902] = {
    [sym_declaration] = STATE(2404),
    [sym_type_definition] = STATE(2404),
    [sym__declaration_specifiers] = STATE(2051),
    [sym_compound_statement] = STATE(2404),
    [sym_storage_class_specifier] = STATE(109),
    [sym_type_qualifier] = STATE(109),
    [sym__type_specifier] = STATE(105),
    [sym_sized_type_specifier] = STATE(105),
    [sym_enum_specifier] = STATE(105),
    [sym_struct_specifier] = STATE(105),
    [sym_union_specifier] = STATE(105),
    [sym_labeled_statement] = STATE(2404),
    [sym_expression_statement] = STATE(2404),
    [sym_if_statement] = STATE(2404),
    [sym_switch_statement] = STATE(2404),
    [sym_case_statement] = STATE(2404),
    [sym_while_statement] = STATE(2404),
    [sym_do_statement] = STATE(2404),
    [sym_for_statement] = STATE(2404),
    [sym_return_statement] = STATE(2404),
    [sym_break_statement] = STATE(2404),
    [sym_continue_statement] = STATE(2404),
    [sym_goto_statement] = STATE(2404),
    [sym__expression] = STATE(873),
    [sym_comma_expression] = STATE(874),
    [sym_conditional_expression] = STATE(873),
    [sym_assignment_expression] = STATE(873),
    [sym_pointer_expression] = STATE(873),
    [sym_logical_expression] = STATE(873),
    [sym_bitwise_expression] = STATE(873),
    [sym_equality_expression] = STATE(873),
    [sym_relational_expression] = STATE(873),
    [sym_shift_expression] = STATE(873),
    [sym_math_expression] = STATE(873),
    [sym_cast_expression] = STATE(873),
    [sym_sizeof_expression] = STATE(873),
    [sym_subscript_expression] = STATE(873),
    [sym_call_expression] = STATE(873),
    [sym_field_expression] = STATE(873),
    [sym_compound_literal_expression] = STATE(873),
    [sym_parenthesized_expression] = STATE(873),
    [sym_concatenated_string] = STATE(873),
    [sym_macro_type_specifier] = STATE(105),
    [sym_class_specifier] = STATE(105),
    [sym_dependent_type] = STATE(105),
    [sym_template_type] = STATE(1475),
    [sym_template_function] = STATE(873),
    [sym_for_range_loop] = STATE(2404),
    [sym_new_expression] = STATE(873),
    [sym_delete_expression] = STATE(873),
    [sym_lambda_expression] = STATE(873),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(416),
    [sym_scoped_namespace_identifier] = STATE(1476),
    [aux_sym__declaration_specifiers_repeat1] = STATE(109),
    [aux_sym_sized_type_specifier_repeat1] = STATE(110),
    [sym_raw_string_literal] = ACTIONS(1660),
    [anon_sym_LPAREN] = ACTIONS(626),
    [anon_sym_SEMI] = ACTIONS(1662),
    [anon_sym_typedef] = ACTIONS(4657),
    [anon_sym_extern] = ACTIONS(154),
    [anon_sym_LBRACE] = ACTIONS(1664),
    [anon_sym_STAR] = ACTIONS(644),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_static] = ACTIONS(154),
    [anon_sym_register] = ACTIONS(154),
    [anon_sym_inline] = ACTIONS(154),
    [anon_sym_const] = ACTIONS(158),
    [anon_sym_restrict] = ACTIONS(158),
    [anon_sym_volatile] = ACTIONS(158),
    [anon_sym__Atomic] = ACTIONS(158),
    [anon_sym_mutable] = ACTIONS(158),
    [anon_sym_explicit] = ACTIONS(158),
    [anon_sym_constexpr] = ACTIONS(158),
    [anon_sym_unsigned] = ACTIONS(160),
    [anon_sym_long] = ACTIONS(160),
    [anon_sym_short] = ACTIONS(160),
    [sym_primitive_type] = ACTIONS(162),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_union] = ACTIONS(39),
    [anon_sym_if] = ACTIONS(6297),
    [anon_sym_switch] = ACTIONS(6299),
    [anon_sym_case] = ACTIONS(6301),
    [anon_sym_default] = ACTIONS(6303),
    [anon_sym_while] = ACTIONS(6305),
    [anon_sym_do] = ACTIONS(1676),
    [anon_sym_for] = ACTIONS(6307),
    [anon_sym_return] = ACTIONS(1680),
    [anon_sym_break] = ACTIONS(1682),
    [anon_sym_continue] = ACTIONS(1684),
    [anon_sym_goto] = ACTIONS(1686),
    [anon_sym_AMP] = ACTIONS(644),
    [anon_sym_BANG] = ACTIONS(668),
    [anon_sym_TILDE] = ACTIONS(670),
    [anon_sym_PLUS] = ACTIONS(672),
    [anon_sym_DASH] = ACTIONS(672),
    [anon_sym_DASH_DASH] = ACTIONS(674),
    [anon_sym_PLUS_PLUS] = ACTIONS(674),
    [anon_sym_sizeof] = ACTIONS(676),
    [sym_number_literal] = ACTIONS(1660),
    [sym_char_literal] = ACTIONS(1660),
    [sym_string_literal] = ACTIONS(678),
    [sym_true] = ACTIONS(1688),
    [sym_false] = ACTIONS(1688),
    [sym_null] = ACTIONS(1688),
    [sym_identifier] = ACTIONS(6880),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(51),
    [sym_auto] = ACTIONS(162),
    [anon_sym_typename] = ACTIONS(172),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(3040),
    [anon_sym_delete] = ACTIONS(686),
    [sym_nullptr] = ACTIONS(1688),
  },
  [2903] = {
    [sym_initializer_list] = STATE(765),
    [sym_template_argument_list] = STATE(2039),
    [anon_sym_LPAREN] = ACTIONS(1483),
    [anon_sym_COMMA] = ACTIONS(1477),
    [anon_sym_SEMI] = ACTIONS(1477),
    [anon_sym_extern] = ACTIONS(144),
    [anon_sym_LBRACE] = ACTIONS(548),
    [anon_sym_STAR] = ACTIONS(1486),
    [anon_sym_LBRACK] = ACTIONS(1477),
    [anon_sym_EQ] = ACTIONS(1479),
    [anon_sym_static] = ACTIONS(144),
    [anon_sym_register] = ACTIONS(144),
    [anon_sym_inline] = ACTIONS(144),
    [anon_sym_const] = ACTIONS(144),
    [anon_sym_restrict] = ACTIONS(144),
    [anon_sym_volatile] = ACTIONS(144),
    [anon_sym__Atomic] = ACTIONS(144),
    [anon_sym_mutable] = ACTIONS(144),
    [anon_sym_explicit] = ACTIONS(144),
    [anon_sym_constexpr] = ACTIONS(144),
    [anon_sym_COLON] = ACTIONS(6633),
    [anon_sym_QMARK] = ACTIONS(1477),
    [anon_sym_STAR_EQ] = ACTIONS(1477),
    [anon_sym_SLASH_EQ] = ACTIONS(1477),
    [anon_sym_PERCENT_EQ] = ACTIONS(1477),
    [anon_sym_PLUS_EQ] = ACTIONS(1477),
    [anon_sym_DASH_EQ] = ACTIONS(1477),
    [anon_sym_LT_LT_EQ] = ACTIONS(1477),
    [anon_sym_GT_GT_EQ] = ACTIONS(1477),
    [anon_sym_AMP_EQ] = ACTIONS(1477),
    [anon_sym_CARET_EQ] = ACTIONS(1477),
    [anon_sym_PIPE_EQ] = ACTIONS(1477),
    [anon_sym_AMP] = ACTIONS(1486),
    [anon_sym_PIPE_PIPE] = ACTIONS(1477),
    [anon_sym_AMP_AMP] = ACTIONS(1483),
    [anon_sym_PIPE] = ACTIONS(1479),
    [anon_sym_CARET] = ACTIONS(1479),
    [anon_sym_TILDE] = ACTIONS(142),
    [anon_sym_EQ_EQ] = ACTIONS(1477),
    [anon_sym_BANG_EQ] = ACTIONS(1477),
    [anon_sym_LT] = ACTIONS(1564),
    [anon_sym_GT] = ACTIONS(1479),
    [anon_sym_LT_EQ] = ACTIONS(1477),
    [anon_sym_GT_EQ] = ACTIONS(1477),
    [anon_sym_LT_LT] = ACTIONS(1479),
    [anon_sym_GT_GT] = ACTIONS(1479),
    [anon_sym_PLUS] = ACTIONS(1479),
    [anon_sym_DASH] = ACTIONS(1479),
    [anon_sym_SLASH] = ACTIONS(1479),
    [anon_sym_PERCENT] = ACTIONS(1479),
    [anon_sym_DASH_DASH] = ACTIONS(1477),
    [anon_sym_PLUS_PLUS] = ACTIONS(1477),
    [anon_sym_DOT] = ACTIONS(1477),
    [anon_sym_DASH_GT] = ACTIONS(1477),
    [sym_identifier] = ACTIONS(144),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(4631),
    [sym_operator_name] = ACTIONS(142),
  },
  [2904] = {
    [sym_argument_list] = STATE(802),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_RPAREN] = ACTIONS(7069),
    [anon_sym_STAR] = ACTIONS(4537),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_EQ] = ACTIONS(4539),
    [anon_sym_QMARK] = ACTIONS(4541),
    [anon_sym_STAR_EQ] = ACTIONS(4543),
    [anon_sym_SLASH_EQ] = ACTIONS(4543),
    [anon_sym_PERCENT_EQ] = ACTIONS(4543),
    [anon_sym_PLUS_EQ] = ACTIONS(4543),
    [anon_sym_DASH_EQ] = ACTIONS(4543),
    [anon_sym_LT_LT_EQ] = ACTIONS(4543),
    [anon_sym_GT_GT_EQ] = ACTIONS(4543),
    [anon_sym_AMP_EQ] = ACTIONS(4543),
    [anon_sym_CARET_EQ] = ACTIONS(4543),
    [anon_sym_PIPE_EQ] = ACTIONS(4543),
    [anon_sym_AMP] = ACTIONS(4545),
    [anon_sym_PIPE_PIPE] = ACTIONS(4547),
    [anon_sym_AMP_AMP] = ACTIONS(4549),
    [anon_sym_PIPE] = ACTIONS(4551),
    [anon_sym_CARET] = ACTIONS(4553),
    [anon_sym_EQ_EQ] = ACTIONS(4555),
    [anon_sym_BANG_EQ] = ACTIONS(4555),
    [anon_sym_LT] = ACTIONS(4557),
    [anon_sym_GT] = ACTIONS(4557),
    [anon_sym_LT_EQ] = ACTIONS(4559),
    [anon_sym_GT_EQ] = ACTIONS(4559),
    [anon_sym_LT_LT] = ACTIONS(4561),
    [anon_sym_GT_GT] = ACTIONS(4561),
    [anon_sym_PLUS] = ACTIONS(4563),
    [anon_sym_DASH] = ACTIONS(4563),
    [anon_sym_SLASH] = ACTIONS(4537),
    [anon_sym_PERCENT] = ACTIONS(4537),
    [anon_sym_DASH_DASH] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(1554),
    [anon_sym_DASH_GT] = ACTIONS(1554),
    [sym_comment] = ACTIONS(49),
  },
  [2905] = {
    [sym__expression] = STATE(2998),
    [sym_conditional_expression] = STATE(2998),
    [sym_assignment_expression] = STATE(2998),
    [sym_pointer_expression] = STATE(2998),
    [sym_logical_expression] = STATE(2998),
    [sym_bitwise_expression] = STATE(2998),
    [sym_equality_expression] = STATE(2998),
    [sym_relational_expression] = STATE(2998),
    [sym_shift_expression] = STATE(2998),
    [sym_math_expression] = STATE(2998),
    [sym_cast_expression] = STATE(2998),
    [sym_sizeof_expression] = STATE(2998),
    [sym_subscript_expression] = STATE(2998),
    [sym_call_expression] = STATE(2998),
    [sym_field_expression] = STATE(2998),
    [sym_compound_literal_expression] = STATE(2998),
    [sym_parenthesized_expression] = STATE(2998),
    [sym_concatenated_string] = STATE(2998),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(2998),
    [sym_new_expression] = STATE(2998),
    [sym_delete_expression] = STATE(2998),
    [sym_lambda_expression] = STATE(2998),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(7071),
    [anon_sym_LPAREN] = ACTIONS(1347),
    [anon_sym_SEMI] = ACTIONS(7073),
    [anon_sym_STAR] = ACTIONS(1349),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_AMP] = ACTIONS(1349),
    [anon_sym_BANG] = ACTIONS(1351),
    [anon_sym_TILDE] = ACTIONS(1353),
    [anon_sym_PLUS] = ACTIONS(1355),
    [anon_sym_DASH] = ACTIONS(1355),
    [anon_sym_DASH_DASH] = ACTIONS(1357),
    [anon_sym_PLUS_PLUS] = ACTIONS(1357),
    [anon_sym_sizeof] = ACTIONS(1359),
    [sym_number_literal] = ACTIONS(7071),
    [sym_char_literal] = ACTIONS(7071),
    [sym_string_literal] = ACTIONS(1361),
    [sym_true] = ACTIONS(7075),
    [sym_false] = ACTIONS(7075),
    [sym_null] = ACTIONS(7075),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1365),
    [anon_sym_delete] = ACTIONS(1367),
    [sym_nullptr] = ACTIONS(7075),
  },
  [2906] = {
    [sym_argument_list] = STATE(802),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_SEMI] = ACTIONS(7077),
    [anon_sym_STAR] = ACTIONS(2553),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_EQ] = ACTIONS(2555),
    [anon_sym_QMARK] = ACTIONS(2557),
    [anon_sym_STAR_EQ] = ACTIONS(2559),
    [anon_sym_SLASH_EQ] = ACTIONS(2559),
    [anon_sym_PERCENT_EQ] = ACTIONS(2559),
    [anon_sym_PLUS_EQ] = ACTIONS(2559),
    [anon_sym_DASH_EQ] = ACTIONS(2559),
    [anon_sym_LT_LT_EQ] = ACTIONS(2559),
    [anon_sym_GT_GT_EQ] = ACTIONS(2559),
    [anon_sym_AMP_EQ] = ACTIONS(2559),
    [anon_sym_CARET_EQ] = ACTIONS(2559),
    [anon_sym_PIPE_EQ] = ACTIONS(2559),
    [anon_sym_AMP] = ACTIONS(2561),
    [anon_sym_PIPE_PIPE] = ACTIONS(2563),
    [anon_sym_AMP_AMP] = ACTIONS(2565),
    [anon_sym_PIPE] = ACTIONS(2567),
    [anon_sym_CARET] = ACTIONS(2569),
    [anon_sym_EQ_EQ] = ACTIONS(2571),
    [anon_sym_BANG_EQ] = ACTIONS(2571),
    [anon_sym_LT] = ACTIONS(2573),
    [anon_sym_GT] = ACTIONS(2573),
    [anon_sym_LT_EQ] = ACTIONS(2575),
    [anon_sym_GT_EQ] = ACTIONS(2575),
    [anon_sym_LT_LT] = ACTIONS(2577),
    [anon_sym_GT_GT] = ACTIONS(2577),
    [anon_sym_PLUS] = ACTIONS(2579),
    [anon_sym_DASH] = ACTIONS(2579),
    [anon_sym_SLASH] = ACTIONS(2553),
    [anon_sym_PERCENT] = ACTIONS(2553),
    [anon_sym_DASH_DASH] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(1554),
    [anon_sym_DASH_GT] = ACTIONS(1554),
    [sym_comment] = ACTIONS(49),
  },
  [2907] = {
    [anon_sym_COLON] = ACTIONS(7079),
    [sym_comment] = ACTIONS(49),
  },
  [2908] = {
    [anon_sym_else] = ACTIONS(6864),
    [anon_sym_while] = ACTIONS(6864),
    [sym_comment] = ACTIONS(49),
  },
  [2909] = {
    [sym_compound_statement] = STATE(3001),
    [sym_labeled_statement] = STATE(3001),
    [sym_expression_statement] = STATE(3001),
    [sym_if_statement] = STATE(3001),
    [sym_switch_statement] = STATE(3001),
    [sym_case_statement] = STATE(3001),
    [sym_while_statement] = STATE(3001),
    [sym_do_statement] = STATE(3001),
    [sym_for_statement] = STATE(3001),
    [sym_return_statement] = STATE(3001),
    [sym_break_statement] = STATE(3001),
    [sym_continue_statement] = STATE(3001),
    [sym_goto_statement] = STATE(3001),
    [sym__expression] = STATE(873),
    [sym_comma_expression] = STATE(874),
    [sym_conditional_expression] = STATE(873),
    [sym_assignment_expression] = STATE(873),
    [sym_pointer_expression] = STATE(873),
    [sym_logical_expression] = STATE(873),
    [sym_bitwise_expression] = STATE(873),
    [sym_equality_expression] = STATE(873),
    [sym_relational_expression] = STATE(873),
    [sym_shift_expression] = STATE(873),
    [sym_math_expression] = STATE(873),
    [sym_cast_expression] = STATE(873),
    [sym_sizeof_expression] = STATE(873),
    [sym_subscript_expression] = STATE(873),
    [sym_call_expression] = STATE(873),
    [sym_field_expression] = STATE(873),
    [sym_compound_literal_expression] = STATE(873),
    [sym_parenthesized_expression] = STATE(873),
    [sym_concatenated_string] = STATE(873),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(873),
    [sym_for_range_loop] = STATE(3001),
    [sym_new_expression] = STATE(873),
    [sym_delete_expression] = STATE(873),
    [sym_lambda_expression] = STATE(873),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(1660),
    [anon_sym_LPAREN] = ACTIONS(626),
    [anon_sym_SEMI] = ACTIONS(1662),
    [anon_sym_LBRACE] = ACTIONS(1664),
    [anon_sym_STAR] = ACTIONS(644),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_if] = ACTIONS(1666),
    [anon_sym_switch] = ACTIONS(1668),
    [anon_sym_case] = ACTIONS(1670),
    [anon_sym_default] = ACTIONS(1672),
    [anon_sym_while] = ACTIONS(1674),
    [anon_sym_do] = ACTIONS(1676),
    [anon_sym_for] = ACTIONS(1678),
    [anon_sym_return] = ACTIONS(1680),
    [anon_sym_break] = ACTIONS(1682),
    [anon_sym_continue] = ACTIONS(1684),
    [anon_sym_goto] = ACTIONS(1686),
    [anon_sym_AMP] = ACTIONS(644),
    [anon_sym_BANG] = ACTIONS(668),
    [anon_sym_TILDE] = ACTIONS(670),
    [anon_sym_PLUS] = ACTIONS(672),
    [anon_sym_DASH] = ACTIONS(672),
    [anon_sym_DASH_DASH] = ACTIONS(674),
    [anon_sym_PLUS_PLUS] = ACTIONS(674),
    [anon_sym_sizeof] = ACTIONS(676),
    [sym_number_literal] = ACTIONS(1660),
    [sym_char_literal] = ACTIONS(1660),
    [sym_string_literal] = ACTIONS(678),
    [sym_true] = ACTIONS(1688),
    [sym_false] = ACTIONS(1688),
    [sym_null] = ACTIONS(1688),
    [sym_identifier] = ACTIONS(1690),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1303),
    [anon_sym_delete] = ACTIONS(686),
    [sym_nullptr] = ACTIONS(1688),
  },
  [2910] = {
    [anon_sym_else] = ACTIONS(3519),
    [anon_sym_while] = ACTIONS(3519),
    [sym_comment] = ACTIONS(49),
  },
  [2911] = {
    [anon_sym_else] = ACTIONS(6902),
    [anon_sym_while] = ACTIONS(6902),
    [sym_comment] = ACTIONS(49),
  },
  [2912] = {
    [sym_compound_statement] = STATE(3002),
    [sym_labeled_statement] = STATE(3002),
    [sym_expression_statement] = STATE(3002),
    [sym_if_statement] = STATE(3002),
    [sym_switch_statement] = STATE(3002),
    [sym_case_statement] = STATE(3002),
    [sym_while_statement] = STATE(3002),
    [sym_do_statement] = STATE(3002),
    [sym_for_statement] = STATE(3002),
    [sym_return_statement] = STATE(3002),
    [sym_break_statement] = STATE(3002),
    [sym_continue_statement] = STATE(3002),
    [sym_goto_statement] = STATE(3002),
    [sym__expression] = STATE(873),
    [sym_comma_expression] = STATE(874),
    [sym_conditional_expression] = STATE(873),
    [sym_assignment_expression] = STATE(873),
    [sym_pointer_expression] = STATE(873),
    [sym_logical_expression] = STATE(873),
    [sym_bitwise_expression] = STATE(873),
    [sym_equality_expression] = STATE(873),
    [sym_relational_expression] = STATE(873),
    [sym_shift_expression] = STATE(873),
    [sym_math_expression] = STATE(873),
    [sym_cast_expression] = STATE(873),
    [sym_sizeof_expression] = STATE(873),
    [sym_subscript_expression] = STATE(873),
    [sym_call_expression] = STATE(873),
    [sym_field_expression] = STATE(873),
    [sym_compound_literal_expression] = STATE(873),
    [sym_parenthesized_expression] = STATE(873),
    [sym_concatenated_string] = STATE(873),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(873),
    [sym_for_range_loop] = STATE(3002),
    [sym_new_expression] = STATE(873),
    [sym_delete_expression] = STATE(873),
    [sym_lambda_expression] = STATE(873),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(1660),
    [anon_sym_LPAREN] = ACTIONS(626),
    [anon_sym_SEMI] = ACTIONS(1662),
    [anon_sym_LBRACE] = ACTIONS(1664),
    [anon_sym_STAR] = ACTIONS(644),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_if] = ACTIONS(1666),
    [anon_sym_switch] = ACTIONS(1668),
    [anon_sym_case] = ACTIONS(1670),
    [anon_sym_default] = ACTIONS(1672),
    [anon_sym_while] = ACTIONS(1674),
    [anon_sym_do] = ACTIONS(1676),
    [anon_sym_for] = ACTIONS(1678),
    [anon_sym_return] = ACTIONS(1680),
    [anon_sym_break] = ACTIONS(1682),
    [anon_sym_continue] = ACTIONS(1684),
    [anon_sym_goto] = ACTIONS(1686),
    [anon_sym_AMP] = ACTIONS(644),
    [anon_sym_BANG] = ACTIONS(668),
    [anon_sym_TILDE] = ACTIONS(670),
    [anon_sym_PLUS] = ACTIONS(672),
    [anon_sym_DASH] = ACTIONS(672),
    [anon_sym_DASH_DASH] = ACTIONS(674),
    [anon_sym_PLUS_PLUS] = ACTIONS(674),
    [anon_sym_sizeof] = ACTIONS(676),
    [sym_number_literal] = ACTIONS(1660),
    [sym_char_literal] = ACTIONS(1660),
    [sym_string_literal] = ACTIONS(678),
    [sym_true] = ACTIONS(1688),
    [sym_false] = ACTIONS(1688),
    [sym_null] = ACTIONS(1688),
    [sym_identifier] = ACTIONS(1690),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1303),
    [anon_sym_delete] = ACTIONS(686),
    [sym_nullptr] = ACTIONS(1688),
  },
  [2913] = {
    [aux_sym_for_statement_repeat1] = STATE(2796),
    [anon_sym_COMMA] = ACTIONS(6339),
    [anon_sym_RPAREN] = ACTIONS(7081),
    [sym_comment] = ACTIONS(49),
  },
  [2914] = {
    [sym_argument_list] = STATE(802),
    [aux_sym_for_statement_repeat1] = STATE(3004),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_COMMA] = ACTIONS(6339),
    [anon_sym_RPAREN] = ACTIONS(7081),
    [anon_sym_STAR] = ACTIONS(2234),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_EQ] = ACTIONS(2236),
    [anon_sym_QMARK] = ACTIONS(2238),
    [anon_sym_STAR_EQ] = ACTIONS(2240),
    [anon_sym_SLASH_EQ] = ACTIONS(2240),
    [anon_sym_PERCENT_EQ] = ACTIONS(2240),
    [anon_sym_PLUS_EQ] = ACTIONS(2240),
    [anon_sym_DASH_EQ] = ACTIONS(2240),
    [anon_sym_LT_LT_EQ] = ACTIONS(2240),
    [anon_sym_GT_GT_EQ] = ACTIONS(2240),
    [anon_sym_AMP_EQ] = ACTIONS(2240),
    [anon_sym_CARET_EQ] = ACTIONS(2240),
    [anon_sym_PIPE_EQ] = ACTIONS(2240),
    [anon_sym_AMP] = ACTIONS(2242),
    [anon_sym_PIPE_PIPE] = ACTIONS(2244),
    [anon_sym_AMP_AMP] = ACTIONS(2246),
    [anon_sym_PIPE] = ACTIONS(2248),
    [anon_sym_CARET] = ACTIONS(2250),
    [anon_sym_EQ_EQ] = ACTIONS(2252),
    [anon_sym_BANG_EQ] = ACTIONS(2252),
    [anon_sym_LT] = ACTIONS(2254),
    [anon_sym_GT] = ACTIONS(2254),
    [anon_sym_LT_EQ] = ACTIONS(2256),
    [anon_sym_GT_EQ] = ACTIONS(2256),
    [anon_sym_LT_LT] = ACTIONS(2258),
    [anon_sym_GT_GT] = ACTIONS(2258),
    [anon_sym_PLUS] = ACTIONS(2260),
    [anon_sym_DASH] = ACTIONS(2260),
    [anon_sym_SLASH] = ACTIONS(2234),
    [anon_sym_PERCENT] = ACTIONS(2234),
    [anon_sym_DASH_DASH] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(1554),
    [anon_sym_DASH_GT] = ACTIONS(1554),
    [sym_comment] = ACTIONS(49),
  },
  [2915] = {
    [anon_sym_else] = ACTIONS(6925),
    [anon_sym_while] = ACTIONS(6925),
    [sym_comment] = ACTIONS(49),
  },
  [2916] = {
    [sym_raw_string_literal] = ACTIONS(7083),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(7085),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(7085),
    [anon_sym_LPAREN] = ACTIONS(7083),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(7085),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(7085),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(7085),
    [sym_preproc_directive] = ACTIONS(7085),
    [anon_sym_SEMI] = ACTIONS(7083),
    [anon_sym_typedef] = ACTIONS(7085),
    [anon_sym_extern] = ACTIONS(7085),
    [anon_sym_LBRACE] = ACTIONS(7083),
    [anon_sym_RBRACE] = ACTIONS(7083),
    [anon_sym_STAR] = ACTIONS(7083),
    [anon_sym_LBRACK] = ACTIONS(7083),
    [anon_sym_static] = ACTIONS(7085),
    [anon_sym_register] = ACTIONS(7085),
    [anon_sym_inline] = ACTIONS(7085),
    [anon_sym_const] = ACTIONS(7085),
    [anon_sym_restrict] = ACTIONS(7085),
    [anon_sym_volatile] = ACTIONS(7085),
    [anon_sym__Atomic] = ACTIONS(7085),
    [anon_sym_mutable] = ACTIONS(7085),
    [anon_sym_explicit] = ACTIONS(7085),
    [anon_sym_constexpr] = ACTIONS(7085),
    [anon_sym_unsigned] = ACTIONS(7085),
    [anon_sym_long] = ACTIONS(7085),
    [anon_sym_short] = ACTIONS(7085),
    [sym_primitive_type] = ACTIONS(7085),
    [anon_sym_enum] = ACTIONS(7085),
    [anon_sym_struct] = ACTIONS(7085),
    [anon_sym_union] = ACTIONS(7085),
    [anon_sym_if] = ACTIONS(7085),
    [anon_sym_switch] = ACTIONS(7085),
    [anon_sym_case] = ACTIONS(7085),
    [anon_sym_default] = ACTIONS(7085),
    [anon_sym_while] = ACTIONS(7085),
    [anon_sym_do] = ACTIONS(7085),
    [anon_sym_for] = ACTIONS(7085),
    [anon_sym_return] = ACTIONS(7085),
    [anon_sym_break] = ACTIONS(7085),
    [anon_sym_continue] = ACTIONS(7085),
    [anon_sym_goto] = ACTIONS(7085),
    [anon_sym_AMP] = ACTIONS(7083),
    [anon_sym_BANG] = ACTIONS(7083),
    [anon_sym_TILDE] = ACTIONS(7083),
    [anon_sym_PLUS] = ACTIONS(7085),
    [anon_sym_DASH] = ACTIONS(7085),
    [anon_sym_DASH_DASH] = ACTIONS(7083),
    [anon_sym_PLUS_PLUS] = ACTIONS(7083),
    [anon_sym_sizeof] = ACTIONS(7085),
    [sym_number_literal] = ACTIONS(7083),
    [sym_char_literal] = ACTIONS(7083),
    [sym_string_literal] = ACTIONS(7083),
    [sym_true] = ACTIONS(7085),
    [sym_false] = ACTIONS(7085),
    [sym_null] = ACTIONS(7085),
    [sym_identifier] = ACTIONS(7085),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(7085),
    [sym_auto] = ACTIONS(7085),
    [anon_sym_typename] = ACTIONS(7085),
    [anon_sym_new] = ACTIONS(7085),
    [anon_sym_COLON_COLON] = ACTIONS(7083),
    [anon_sym_delete] = ACTIONS(7085),
    [sym_nullptr] = ACTIONS(7085),
  },
  [2917] = {
    [sym_compound_statement] = STATE(3005),
    [sym_labeled_statement] = STATE(3005),
    [sym_expression_statement] = STATE(3005),
    [sym_if_statement] = STATE(3005),
    [sym_switch_statement] = STATE(3005),
    [sym_case_statement] = STATE(3005),
    [sym_while_statement] = STATE(3005),
    [sym_do_statement] = STATE(3005),
    [sym_for_statement] = STATE(3005),
    [sym_return_statement] = STATE(3005),
    [sym_break_statement] = STATE(3005),
    [sym_continue_statement] = STATE(3005),
    [sym_goto_statement] = STATE(3005),
    [sym__expression] = STATE(413),
    [sym_comma_expression] = STATE(414),
    [sym_conditional_expression] = STATE(413),
    [sym_assignment_expression] = STATE(413),
    [sym_pointer_expression] = STATE(413),
    [sym_logical_expression] = STATE(413),
    [sym_bitwise_expression] = STATE(413),
    [sym_equality_expression] = STATE(413),
    [sym_relational_expression] = STATE(413),
    [sym_shift_expression] = STATE(413),
    [sym_math_expression] = STATE(413),
    [sym_cast_expression] = STATE(413),
    [sym_sizeof_expression] = STATE(413),
    [sym_subscript_expression] = STATE(413),
    [sym_call_expression] = STATE(413),
    [sym_field_expression] = STATE(413),
    [sym_compound_literal_expression] = STATE(413),
    [sym_parenthesized_expression] = STATE(413),
    [sym_concatenated_string] = STATE(413),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(413),
    [sym_for_range_loop] = STATE(3005),
    [sym_new_expression] = STATE(413),
    [sym_delete_expression] = STATE(413),
    [sym_lambda_expression] = STATE(413),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(620),
    [anon_sym_LPAREN] = ACTIONS(626),
    [anon_sym_SEMI] = ACTIONS(636),
    [anon_sym_LBRACE] = ACTIONS(640),
    [anon_sym_STAR] = ACTIONS(644),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_if] = ACTIONS(646),
    [anon_sym_switch] = ACTIONS(648),
    [anon_sym_case] = ACTIONS(650),
    [anon_sym_default] = ACTIONS(652),
    [anon_sym_while] = ACTIONS(654),
    [anon_sym_do] = ACTIONS(656),
    [anon_sym_for] = ACTIONS(658),
    [anon_sym_return] = ACTIONS(660),
    [anon_sym_break] = ACTIONS(662),
    [anon_sym_continue] = ACTIONS(664),
    [anon_sym_goto] = ACTIONS(666),
    [anon_sym_AMP] = ACTIONS(644),
    [anon_sym_BANG] = ACTIONS(668),
    [anon_sym_TILDE] = ACTIONS(670),
    [anon_sym_PLUS] = ACTIONS(672),
    [anon_sym_DASH] = ACTIONS(672),
    [anon_sym_DASH_DASH] = ACTIONS(674),
    [anon_sym_PLUS_PLUS] = ACTIONS(674),
    [anon_sym_sizeof] = ACTIONS(676),
    [sym_number_literal] = ACTIONS(620),
    [sym_char_literal] = ACTIONS(620),
    [sym_string_literal] = ACTIONS(678),
    [sym_true] = ACTIONS(680),
    [sym_false] = ACTIONS(680),
    [sym_null] = ACTIONS(680),
    [sym_identifier] = ACTIONS(3110),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1303),
    [anon_sym_delete] = ACTIONS(686),
    [sym_nullptr] = ACTIONS(680),
  },
  [2918] = {
    [sym__abstract_declarator] = STATE(3006),
    [sym_abstract_pointer_declarator] = STATE(3006),
    [sym_abstract_function_declarator] = STATE(3006),
    [sym_abstract_array_declarator] = STATE(3006),
    [sym_parameter_list] = STATE(2921),
    [sym_abstract_reference_declarator] = STATE(3006),
    [anon_sym_LPAREN] = ACTIONS(1115),
    [anon_sym_COMMA] = ACTIONS(2270),
    [anon_sym_SEMI] = ACTIONS(2270),
    [anon_sym_LBRACE] = ACTIONS(2270),
    [anon_sym_STAR] = ACTIONS(6911),
    [anon_sym_LBRACK] = ACTIONS(1121),
    [anon_sym_EQ] = ACTIONS(2270),
    [anon_sym_const] = ACTIONS(4360),
    [anon_sym_restrict] = ACTIONS(2270),
    [anon_sym_volatile] = ACTIONS(2270),
    [anon_sym__Atomic] = ACTIONS(2270),
    [anon_sym_mutable] = ACTIONS(2270),
    [anon_sym_explicit] = ACTIONS(2270),
    [anon_sym_constexpr] = ACTIONS(2270),
    [anon_sym_COLON] = ACTIONS(2270),
    [anon_sym_AMP] = ACTIONS(6913),
    [anon_sym_AMP_AMP] = ACTIONS(6915),
    [anon_sym_DASH_GT] = ACTIONS(2270),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(2270),
  },
  [2919] = {
    [sym__abstract_declarator] = STATE(3007),
    [sym_abstract_pointer_declarator] = STATE(3007),
    [sym_abstract_function_declarator] = STATE(3007),
    [sym_abstract_array_declarator] = STATE(3007),
    [sym_parameter_list] = STATE(2921),
    [sym_abstract_reference_declarator] = STATE(3007),
    [anon_sym_LPAREN] = ACTIONS(1115),
    [anon_sym_COMMA] = ACTIONS(2278),
    [anon_sym_SEMI] = ACTIONS(2278),
    [anon_sym_LBRACE] = ACTIONS(2278),
    [anon_sym_STAR] = ACTIONS(6911),
    [anon_sym_LBRACK] = ACTIONS(1121),
    [anon_sym_EQ] = ACTIONS(2278),
    [anon_sym_const] = ACTIONS(4362),
    [anon_sym_restrict] = ACTIONS(2278),
    [anon_sym_volatile] = ACTIONS(2278),
    [anon_sym__Atomic] = ACTIONS(2278),
    [anon_sym_mutable] = ACTIONS(2278),
    [anon_sym_explicit] = ACTIONS(2278),
    [anon_sym_constexpr] = ACTIONS(2278),
    [anon_sym_COLON] = ACTIONS(2278),
    [anon_sym_AMP] = ACTIONS(6913),
    [anon_sym_AMP_AMP] = ACTIONS(6915),
    [anon_sym_DASH_GT] = ACTIONS(2278),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(2278),
  },
  [2920] = {
    [sym_parameter_list] = STATE(3008),
    [anon_sym_LPAREN] = ACTIONS(206),
    [anon_sym_COMMA] = ACTIONS(4364),
    [anon_sym_SEMI] = ACTIONS(4364),
    [anon_sym_LBRACE] = ACTIONS(4364),
    [anon_sym_LBRACK] = ACTIONS(2282),
    [anon_sym_EQ] = ACTIONS(4364),
    [anon_sym_const] = ACTIONS(4366),
    [anon_sym_restrict] = ACTIONS(4364),
    [anon_sym_volatile] = ACTIONS(4364),
    [anon_sym__Atomic] = ACTIONS(4364),
    [anon_sym_mutable] = ACTIONS(4364),
    [anon_sym_explicit] = ACTIONS(4364),
    [anon_sym_constexpr] = ACTIONS(4364),
    [anon_sym_COLON] = ACTIONS(4364),
    [anon_sym_DASH_GT] = ACTIONS(4364),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(4364),
  },
  [2921] = {
    [sym_type_qualifier] = STATE(3009),
    [sym_trailing_return_type] = STATE(1129),
    [aux_sym_abstract_function_declarator_repeat1] = STATE(3009),
    [anon_sym_LPAREN] = ACTIONS(2284),
    [anon_sym_COMMA] = ACTIONS(2284),
    [anon_sym_SEMI] = ACTIONS(2284),
    [anon_sym_LBRACE] = ACTIONS(2284),
    [anon_sym_LBRACK] = ACTIONS(2284),
    [anon_sym_EQ] = ACTIONS(2284),
    [anon_sym_const] = ACTIONS(4368),
    [anon_sym_restrict] = ACTIONS(2284),
    [anon_sym_volatile] = ACTIONS(2284),
    [anon_sym__Atomic] = ACTIONS(2284),
    [anon_sym_mutable] = ACTIONS(2284),
    [anon_sym_explicit] = ACTIONS(2284),
    [anon_sym_constexpr] = ACTIONS(2284),
    [anon_sym_COLON] = ACTIONS(2284),
    [anon_sym_DASH_GT] = ACTIONS(2284),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(2284),
  },
  [2922] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2922),
    [anon_sym_LPAREN] = ACTIONS(816),
    [anon_sym_COMMA] = ACTIONS(816),
    [anon_sym_SEMI] = ACTIONS(816),
    [anon_sym_LBRACE] = ACTIONS(816),
    [anon_sym_STAR] = ACTIONS(816),
    [anon_sym_LBRACK] = ACTIONS(816),
    [anon_sym_EQ] = ACTIONS(816),
    [anon_sym_const] = ACTIONS(818),
    [anon_sym_restrict] = ACTIONS(818),
    [anon_sym_volatile] = ACTIONS(818),
    [anon_sym__Atomic] = ACTIONS(818),
    [anon_sym_mutable] = ACTIONS(818),
    [anon_sym_explicit] = ACTIONS(818),
    [anon_sym_constexpr] = ACTIONS(818),
    [anon_sym_unsigned] = ACTIONS(7087),
    [anon_sym_long] = ACTIONS(7087),
    [anon_sym_short] = ACTIONS(7087),
    [sym_primitive_type] = ACTIONS(818),
    [anon_sym_COLON] = ACTIONS(816),
    [anon_sym_AMP] = ACTIONS(818),
    [anon_sym_AMP_AMP] = ACTIONS(816),
    [anon_sym_DASH_GT] = ACTIONS(816),
    [sym_identifier] = ACTIONS(818),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(818),
  },
  [2923] = {
    [aux_sym_for_statement_repeat1] = STATE(2796),
    [anon_sym_COMMA] = ACTIONS(6339),
    [anon_sym_RPAREN] = ACTIONS(7090),
    [sym_comment] = ACTIONS(49),
  },
  [2924] = {
    [sym_parameter_list] = STATE(2926),
    [anon_sym_LPAREN] = ACTIONS(206),
    [anon_sym_COMMA] = ACTIONS(3750),
    [anon_sym_SEMI] = ACTIONS(3750),
    [anon_sym_LBRACK] = ACTIONS(2282),
    [anon_sym_const] = ACTIONS(5283),
    [anon_sym_restrict] = ACTIONS(3750),
    [anon_sym_volatile] = ACTIONS(3750),
    [anon_sym__Atomic] = ACTIONS(3750),
    [anon_sym_mutable] = ACTIONS(3750),
    [anon_sym_explicit] = ACTIONS(3750),
    [anon_sym_constexpr] = ACTIONS(3750),
    [anon_sym_COLON] = ACTIONS(3750),
    [anon_sym_DASH_GT] = ACTIONS(3750),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(3750),
  },
  [2925] = {
    [sym_parameter_list] = STATE(2926),
    [anon_sym_LPAREN] = ACTIONS(206),
    [anon_sym_COMMA] = ACTIONS(3762),
    [anon_sym_SEMI] = ACTIONS(3762),
    [anon_sym_LBRACK] = ACTIONS(2282),
    [anon_sym_const] = ACTIONS(5285),
    [anon_sym_restrict] = ACTIONS(3762),
    [anon_sym_volatile] = ACTIONS(3762),
    [anon_sym__Atomic] = ACTIONS(3762),
    [anon_sym_mutable] = ACTIONS(3762),
    [anon_sym_explicit] = ACTIONS(3762),
    [anon_sym_constexpr] = ACTIONS(3762),
    [anon_sym_COLON] = ACTIONS(3762),
    [anon_sym_DASH_GT] = ACTIONS(3762),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(3762),
  },
  [2926] = {
    [sym_type_qualifier] = STATE(3011),
    [sym_trailing_return_type] = STATE(1713),
    [aux_sym_abstract_function_declarator_repeat1] = STATE(3011),
    [anon_sym_LPAREN] = ACTIONS(3764),
    [anon_sym_COMMA] = ACTIONS(3764),
    [anon_sym_SEMI] = ACTIONS(3764),
    [anon_sym_LBRACK] = ACTIONS(3764),
    [anon_sym_const] = ACTIONS(3770),
    [anon_sym_restrict] = ACTIONS(3764),
    [anon_sym_volatile] = ACTIONS(3764),
    [anon_sym__Atomic] = ACTIONS(3764),
    [anon_sym_mutable] = ACTIONS(3764),
    [anon_sym_explicit] = ACTIONS(3764),
    [anon_sym_constexpr] = ACTIONS(3764),
    [anon_sym_COLON] = ACTIONS(3764),
    [anon_sym_DASH_GT] = ACTIONS(3764),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(3764),
  },
  [2927] = {
    [sym_type_qualifier] = STATE(3012),
    [sym_trailing_return_type] = STATE(1713),
    [aux_sym_abstract_function_declarator_repeat1] = STATE(3012),
    [anon_sym_LPAREN] = ACTIONS(3764),
    [anon_sym_COMMA] = ACTIONS(3764),
    [anon_sym_SEMI] = ACTIONS(3764),
    [anon_sym_LBRACK] = ACTIONS(3764),
    [anon_sym_const] = ACTIONS(612),
    [anon_sym_restrict] = ACTIONS(614),
    [anon_sym_volatile] = ACTIONS(614),
    [anon_sym__Atomic] = ACTIONS(614),
    [anon_sym_mutable] = ACTIONS(614),
    [anon_sym_explicit] = ACTIONS(614),
    [anon_sym_constexpr] = ACTIONS(614),
    [anon_sym_COLON] = ACTIONS(3764),
    [anon_sym_DASH_GT] = ACTIONS(5761),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(7092),
  },
  [2928] = {
    [sym_raw_string_literal] = ACTIONS(1622),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1624),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1624),
    [anon_sym_LPAREN] = ACTIONS(1622),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1624),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(1624),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1624),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1624),
    [sym_preproc_directive] = ACTIONS(1624),
    [anon_sym_SEMI] = ACTIONS(1622),
    [anon_sym_typedef] = ACTIONS(1624),
    [anon_sym_extern] = ACTIONS(1624),
    [anon_sym_LBRACE] = ACTIONS(1622),
    [anon_sym_STAR] = ACTIONS(1622),
    [anon_sym_LBRACK] = ACTIONS(1622),
    [anon_sym_static] = ACTIONS(1624),
    [anon_sym_register] = ACTIONS(1624),
    [anon_sym_inline] = ACTIONS(1624),
    [anon_sym_const] = ACTIONS(1624),
    [anon_sym_restrict] = ACTIONS(1624),
    [anon_sym_volatile] = ACTIONS(1624),
    [anon_sym__Atomic] = ACTIONS(1624),
    [anon_sym_mutable] = ACTIONS(1624),
    [anon_sym_explicit] = ACTIONS(1624),
    [anon_sym_constexpr] = ACTIONS(1624),
    [anon_sym_unsigned] = ACTIONS(1624),
    [anon_sym_long] = ACTIONS(1624),
    [anon_sym_short] = ACTIONS(1624),
    [sym_primitive_type] = ACTIONS(1624),
    [anon_sym_enum] = ACTIONS(1624),
    [anon_sym_struct] = ACTIONS(1624),
    [anon_sym_union] = ACTIONS(1624),
    [anon_sym_if] = ACTIONS(1624),
    [anon_sym_else] = ACTIONS(1624),
    [anon_sym_switch] = ACTIONS(1624),
    [anon_sym_case] = ACTIONS(1624),
    [anon_sym_default] = ACTIONS(1624),
    [anon_sym_while] = ACTIONS(1624),
    [anon_sym_do] = ACTIONS(1624),
    [anon_sym_for] = ACTIONS(1624),
    [anon_sym_return] = ACTIONS(1624),
    [anon_sym_break] = ACTIONS(1624),
    [anon_sym_continue] = ACTIONS(1624),
    [anon_sym_goto] = ACTIONS(1624),
    [anon_sym_AMP] = ACTIONS(1622),
    [anon_sym_BANG] = ACTIONS(1622),
    [anon_sym_TILDE] = ACTIONS(1622),
    [anon_sym_PLUS] = ACTIONS(1624),
    [anon_sym_DASH] = ACTIONS(1624),
    [anon_sym_DASH_DASH] = ACTIONS(1622),
    [anon_sym_PLUS_PLUS] = ACTIONS(1622),
    [anon_sym_sizeof] = ACTIONS(1624),
    [sym_number_literal] = ACTIONS(1622),
    [sym_char_literal] = ACTIONS(1622),
    [sym_string_literal] = ACTIONS(1622),
    [sym_true] = ACTIONS(1624),
    [sym_false] = ACTIONS(1624),
    [sym_null] = ACTIONS(1624),
    [sym_identifier] = ACTIONS(1624),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(1624),
    [sym_auto] = ACTIONS(1624),
    [anon_sym_typename] = ACTIONS(1624),
    [anon_sym_new] = ACTIONS(1624),
    [anon_sym_COLON_COLON] = ACTIONS(1622),
    [anon_sym_delete] = ACTIONS(1624),
    [sym_nullptr] = ACTIONS(1624),
  },
  [2929] = {
    [sym_preproc_include] = STATE(913),
    [sym_preproc_def] = STATE(913),
    [sym_preproc_function_def] = STATE(913),
    [sym_preproc_call] = STATE(913),
    [sym_preproc_if_in_compound_statement] = STATE(410),
    [sym_preproc_ifdef_in_compound_statement] = STATE(411),
    [sym_declaration] = STATE(913),
    [sym_type_definition] = STATE(913),
    [sym__declaration_specifiers] = STATE(412),
    [sym_compound_statement] = STATE(913),
    [sym_storage_class_specifier] = STATE(419),
    [sym_type_qualifier] = STATE(419),
    [sym__type_specifier] = STATE(30),
    [sym_sized_type_specifier] = STATE(30),
    [sym_enum_specifier] = STATE(30),
    [sym_struct_specifier] = STATE(30),
    [sym_union_specifier] = STATE(30),
    [sym_labeled_statement] = STATE(913),
    [sym_expression_statement] = STATE(913),
    [sym_if_statement] = STATE(913),
    [sym_switch_statement] = STATE(913),
    [sym_case_statement] = STATE(913),
    [sym_while_statement] = STATE(913),
    [sym_do_statement] = STATE(913),
    [sym_for_statement] = STATE(913),
    [sym_return_statement] = STATE(913),
    [sym_break_statement] = STATE(913),
    [sym_continue_statement] = STATE(913),
    [sym_goto_statement] = STATE(913),
    [sym__expression] = STATE(413),
    [sym_comma_expression] = STATE(414),
    [sym_conditional_expression] = STATE(413),
    [sym_assignment_expression] = STATE(413),
    [sym_pointer_expression] = STATE(413),
    [sym_logical_expression] = STATE(413),
    [sym_bitwise_expression] = STATE(413),
    [sym_equality_expression] = STATE(413),
    [sym_relational_expression] = STATE(413),
    [sym_shift_expression] = STATE(413),
    [sym_math_expression] = STATE(413),
    [sym_cast_expression] = STATE(413),
    [sym_sizeof_expression] = STATE(413),
    [sym_subscript_expression] = STATE(413),
    [sym_call_expression] = STATE(413),
    [sym_field_expression] = STATE(413),
    [sym_compound_literal_expression] = STATE(413),
    [sym_parenthesized_expression] = STATE(413),
    [sym_concatenated_string] = STATE(413),
    [sym__empty_declaration] = STATE(913),
    [sym_macro_type_specifier] = STATE(30),
    [sym_class_specifier] = STATE(30),
    [sym_dependent_type] = STATE(30),
    [sym_structured_binding_declaration] = STATE(913),
    [sym_template_type] = STATE(415),
    [sym_template_function] = STATE(413),
    [sym_for_range_loop] = STATE(913),
    [sym_new_expression] = STATE(413),
    [sym_delete_expression] = STATE(413),
    [sym_lambda_expression] = STATE(413),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(416),
    [sym_scoped_namespace_identifier] = STATE(417),
    [aux_sym_preproc_if_in_compound_statement_repeat1] = STATE(913),
    [aux_sym__declaration_specifiers_repeat1] = STATE(419),
    [aux_sym_sized_type_specifier_repeat1] = STATE(38),
    [sym_raw_string_literal] = ACTIONS(620),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(622),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(624),
    [anon_sym_LPAREN] = ACTIONS(626),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(628),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(630),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(632),
    [sym_preproc_directive] = ACTIONS(634),
    [anon_sym_SEMI] = ACTIONS(636),
    [anon_sym_typedef] = ACTIONS(638),
    [anon_sym_extern] = ACTIONS(154),
    [anon_sym_LBRACE] = ACTIONS(640),
    [anon_sym_RBRACE] = ACTIONS(7094),
    [anon_sym_STAR] = ACTIONS(644),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_static] = ACTIONS(154),
    [anon_sym_register] = ACTIONS(154),
    [anon_sym_inline] = ACTIONS(154),
    [anon_sym_const] = ACTIONS(158),
    [anon_sym_restrict] = ACTIONS(158),
    [anon_sym_volatile] = ACTIONS(158),
    [anon_sym__Atomic] = ACTIONS(158),
    [anon_sym_mutable] = ACTIONS(158),
    [anon_sym_explicit] = ACTIONS(158),
    [anon_sym_constexpr] = ACTIONS(158),
    [anon_sym_unsigned] = ACTIONS(31),
    [anon_sym_long] = ACTIONS(31),
    [anon_sym_short] = ACTIONS(31),
    [sym_primitive_type] = ACTIONS(33),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_union] = ACTIONS(39),
    [anon_sym_if] = ACTIONS(646),
    [anon_sym_switch] = ACTIONS(648),
    [anon_sym_case] = ACTIONS(650),
    [anon_sym_default] = ACTIONS(652),
    [anon_sym_while] = ACTIONS(654),
    [anon_sym_do] = ACTIONS(656),
    [anon_sym_for] = ACTIONS(658),
    [anon_sym_return] = ACTIONS(660),
    [anon_sym_break] = ACTIONS(662),
    [anon_sym_continue] = ACTIONS(664),
    [anon_sym_goto] = ACTIONS(666),
    [anon_sym_AMP] = ACTIONS(644),
    [anon_sym_BANG] = ACTIONS(668),
    [anon_sym_TILDE] = ACTIONS(670),
    [anon_sym_PLUS] = ACTIONS(672),
    [anon_sym_DASH] = ACTIONS(672),
    [anon_sym_DASH_DASH] = ACTIONS(674),
    [anon_sym_PLUS_PLUS] = ACTIONS(674),
    [anon_sym_sizeof] = ACTIONS(676),
    [sym_number_literal] = ACTIONS(620),
    [sym_char_literal] = ACTIONS(620),
    [sym_string_literal] = ACTIONS(678),
    [sym_true] = ACTIONS(680),
    [sym_false] = ACTIONS(680),
    [sym_null] = ACTIONS(680),
    [sym_identifier] = ACTIONS(682),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(51),
    [sym_auto] = ACTIONS(33),
    [anon_sym_typename] = ACTIONS(53),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(684),
    [anon_sym_delete] = ACTIONS(686),
    [sym_nullptr] = ACTIONS(680),
  },
  [2930] = {
    [sym__expression] = STATE(3014),
    [sym_conditional_expression] = STATE(3014),
    [sym_assignment_expression] = STATE(3014),
    [sym_pointer_expression] = STATE(3014),
    [sym_logical_expression] = STATE(3014),
    [sym_bitwise_expression] = STATE(3014),
    [sym_equality_expression] = STATE(3014),
    [sym_relational_expression] = STATE(3014),
    [sym_shift_expression] = STATE(3014),
    [sym_math_expression] = STATE(3014),
    [sym_cast_expression] = STATE(3014),
    [sym_sizeof_expression] = STATE(3014),
    [sym_subscript_expression] = STATE(3014),
    [sym_call_expression] = STATE(3014),
    [sym_field_expression] = STATE(3014),
    [sym_compound_literal_expression] = STATE(3014),
    [sym_parenthesized_expression] = STATE(3014),
    [sym_concatenated_string] = STATE(3014),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(3014),
    [sym_new_expression] = STATE(3014),
    [sym_delete_expression] = STATE(3014),
    [sym_lambda_expression] = STATE(3014),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(7096),
    [anon_sym_LPAREN] = ACTIONS(2943),
    [anon_sym_STAR] = ACTIONS(2945),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_AMP] = ACTIONS(2945),
    [anon_sym_BANG] = ACTIONS(2947),
    [anon_sym_TILDE] = ACTIONS(2949),
    [anon_sym_PLUS] = ACTIONS(2951),
    [anon_sym_DASH] = ACTIONS(2951),
    [anon_sym_DASH_DASH] = ACTIONS(2953),
    [anon_sym_PLUS_PLUS] = ACTIONS(2953),
    [anon_sym_sizeof] = ACTIONS(2955),
    [sym_number_literal] = ACTIONS(7096),
    [sym_char_literal] = ACTIONS(7096),
    [sym_string_literal] = ACTIONS(2957),
    [sym_true] = ACTIONS(7098),
    [sym_false] = ACTIONS(7098),
    [sym_null] = ACTIONS(7098),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(2961),
    [anon_sym_delete] = ACTIONS(2963),
    [sym_nullptr] = ACTIONS(7098),
  },
  [2931] = {
    [anon_sym_LPAREN] = ACTIONS(7100),
    [sym_comment] = ACTIONS(49),
  },
  [2932] = {
    [sym__expression] = STATE(3016),
    [sym_conditional_expression] = STATE(3016),
    [sym_assignment_expression] = STATE(3016),
    [sym_pointer_expression] = STATE(3016),
    [sym_logical_expression] = STATE(3016),
    [sym_bitwise_expression] = STATE(3016),
    [sym_equality_expression] = STATE(3016),
    [sym_relational_expression] = STATE(3016),
    [sym_shift_expression] = STATE(3016),
    [sym_math_expression] = STATE(3016),
    [sym_cast_expression] = STATE(3016),
    [sym_sizeof_expression] = STATE(3016),
    [sym_subscript_expression] = STATE(3016),
    [sym_call_expression] = STATE(3016),
    [sym_field_expression] = STATE(3016),
    [sym_compound_literal_expression] = STATE(3016),
    [sym_parenthesized_expression] = STATE(3016),
    [sym_concatenated_string] = STATE(3016),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(3016),
    [sym_new_expression] = STATE(3016),
    [sym_delete_expression] = STATE(3016),
    [sym_lambda_expression] = STATE(3016),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(7102),
    [anon_sym_LPAREN] = ACTIONS(2943),
    [anon_sym_STAR] = ACTIONS(2945),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_AMP] = ACTIONS(2945),
    [anon_sym_BANG] = ACTIONS(2947),
    [anon_sym_TILDE] = ACTIONS(2949),
    [anon_sym_PLUS] = ACTIONS(2951),
    [anon_sym_DASH] = ACTIONS(2951),
    [anon_sym_DASH_DASH] = ACTIONS(2953),
    [anon_sym_PLUS_PLUS] = ACTIONS(2953),
    [anon_sym_sizeof] = ACTIONS(2955),
    [sym_number_literal] = ACTIONS(7102),
    [sym_char_literal] = ACTIONS(7102),
    [sym_string_literal] = ACTIONS(2957),
    [sym_true] = ACTIONS(7104),
    [sym_false] = ACTIONS(7104),
    [sym_null] = ACTIONS(7104),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(2961),
    [anon_sym_delete] = ACTIONS(2963),
    [sym_nullptr] = ACTIONS(7104),
  },
  [2933] = {
    [sym_argument_list] = STATE(802),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_STAR] = ACTIONS(3003),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_EQ] = ACTIONS(3005),
    [anon_sym_COLON] = ACTIONS(7106),
    [anon_sym_QMARK] = ACTIONS(3009),
    [anon_sym_STAR_EQ] = ACTIONS(3011),
    [anon_sym_SLASH_EQ] = ACTIONS(3011),
    [anon_sym_PERCENT_EQ] = ACTIONS(3011),
    [anon_sym_PLUS_EQ] = ACTIONS(3011),
    [anon_sym_DASH_EQ] = ACTIONS(3011),
    [anon_sym_LT_LT_EQ] = ACTIONS(3011),
    [anon_sym_GT_GT_EQ] = ACTIONS(3011),
    [anon_sym_AMP_EQ] = ACTIONS(3011),
    [anon_sym_CARET_EQ] = ACTIONS(3011),
    [anon_sym_PIPE_EQ] = ACTIONS(3011),
    [anon_sym_AMP] = ACTIONS(3013),
    [anon_sym_PIPE_PIPE] = ACTIONS(3015),
    [anon_sym_AMP_AMP] = ACTIONS(3017),
    [anon_sym_PIPE] = ACTIONS(3019),
    [anon_sym_CARET] = ACTIONS(3021),
    [anon_sym_EQ_EQ] = ACTIONS(3023),
    [anon_sym_BANG_EQ] = ACTIONS(3023),
    [anon_sym_LT] = ACTIONS(3025),
    [anon_sym_GT] = ACTIONS(3025),
    [anon_sym_LT_EQ] = ACTIONS(3027),
    [anon_sym_GT_EQ] = ACTIONS(3027),
    [anon_sym_LT_LT] = ACTIONS(3029),
    [anon_sym_GT_GT] = ACTIONS(3029),
    [anon_sym_PLUS] = ACTIONS(3031),
    [anon_sym_DASH] = ACTIONS(3031),
    [anon_sym_SLASH] = ACTIONS(3003),
    [anon_sym_PERCENT] = ACTIONS(3003),
    [anon_sym_DASH_DASH] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(3033),
    [anon_sym_DASH_GT] = ACTIONS(3033),
    [sym_comment] = ACTIONS(49),
  },
  [2934] = {
    [sym_declaration] = STATE(3020),
    [sym_type_definition] = STATE(3020),
    [sym__declaration_specifiers] = STATE(3021),
    [sym_compound_statement] = STATE(3020),
    [sym_storage_class_specifier] = STATE(109),
    [sym_type_qualifier] = STATE(109),
    [sym__type_specifier] = STATE(105),
    [sym_sized_type_specifier] = STATE(105),
    [sym_enum_specifier] = STATE(105),
    [sym_struct_specifier] = STATE(105),
    [sym_union_specifier] = STATE(105),
    [sym_labeled_statement] = STATE(3020),
    [sym_expression_statement] = STATE(3020),
    [sym_if_statement] = STATE(3020),
    [sym_switch_statement] = STATE(3020),
    [sym_case_statement] = STATE(3020),
    [sym_while_statement] = STATE(3020),
    [sym_do_statement] = STATE(3020),
    [sym_for_statement] = STATE(3020),
    [sym_return_statement] = STATE(3020),
    [sym_break_statement] = STATE(3020),
    [sym_continue_statement] = STATE(3020),
    [sym_goto_statement] = STATE(3020),
    [sym__expression] = STATE(2844),
    [sym_comma_expression] = STATE(2845),
    [sym_conditional_expression] = STATE(2844),
    [sym_assignment_expression] = STATE(2844),
    [sym_pointer_expression] = STATE(2844),
    [sym_logical_expression] = STATE(2844),
    [sym_bitwise_expression] = STATE(2844),
    [sym_equality_expression] = STATE(2844),
    [sym_relational_expression] = STATE(2844),
    [sym_shift_expression] = STATE(2844),
    [sym_math_expression] = STATE(2844),
    [sym_cast_expression] = STATE(2844),
    [sym_sizeof_expression] = STATE(2844),
    [sym_subscript_expression] = STATE(2844),
    [sym_call_expression] = STATE(2844),
    [sym_field_expression] = STATE(2844),
    [sym_compound_literal_expression] = STATE(2844),
    [sym_parenthesized_expression] = STATE(2844),
    [sym_concatenated_string] = STATE(2844),
    [sym_macro_type_specifier] = STATE(105),
    [sym_class_specifier] = STATE(105),
    [sym_dependent_type] = STATE(105),
    [sym_template_type] = STATE(1475),
    [sym_template_function] = STATE(2844),
    [sym_for_range_loop] = STATE(3020),
    [sym_new_expression] = STATE(2844),
    [sym_delete_expression] = STATE(2844),
    [sym_lambda_expression] = STATE(2844),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(416),
    [sym_scoped_namespace_identifier] = STATE(1476),
    [aux_sym__declaration_specifiers_repeat1] = STATE(109),
    [aux_sym_sized_type_specifier_repeat1] = STATE(110),
    [sym_raw_string_literal] = ACTIONS(6732),
    [anon_sym_LPAREN] = ACTIONS(626),
    [anon_sym_SEMI] = ACTIONS(6734),
    [anon_sym_typedef] = ACTIONS(7108),
    [anon_sym_extern] = ACTIONS(154),
    [anon_sym_LBRACE] = ACTIONS(6736),
    [anon_sym_STAR] = ACTIONS(644),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_static] = ACTIONS(154),
    [anon_sym_register] = ACTIONS(154),
    [anon_sym_inline] = ACTIONS(154),
    [anon_sym_const] = ACTIONS(158),
    [anon_sym_restrict] = ACTIONS(158),
    [anon_sym_volatile] = ACTIONS(158),
    [anon_sym__Atomic] = ACTIONS(158),
    [anon_sym_mutable] = ACTIONS(158),
    [anon_sym_explicit] = ACTIONS(158),
    [anon_sym_constexpr] = ACTIONS(158),
    [anon_sym_unsigned] = ACTIONS(160),
    [anon_sym_long] = ACTIONS(160),
    [anon_sym_short] = ACTIONS(160),
    [sym_primitive_type] = ACTIONS(162),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_union] = ACTIONS(39),
    [anon_sym_if] = ACTIONS(6738),
    [anon_sym_switch] = ACTIONS(6740),
    [anon_sym_case] = ACTIONS(6742),
    [anon_sym_default] = ACTIONS(6744),
    [anon_sym_while] = ACTIONS(6746),
    [anon_sym_do] = ACTIONS(6748),
    [anon_sym_for] = ACTIONS(6750),
    [anon_sym_return] = ACTIONS(6752),
    [anon_sym_break] = ACTIONS(6754),
    [anon_sym_continue] = ACTIONS(6756),
    [anon_sym_goto] = ACTIONS(6758),
    [anon_sym_AMP] = ACTIONS(644),
    [anon_sym_BANG] = ACTIONS(668),
    [anon_sym_TILDE] = ACTIONS(670),
    [anon_sym_PLUS] = ACTIONS(672),
    [anon_sym_DASH] = ACTIONS(672),
    [anon_sym_DASH_DASH] = ACTIONS(674),
    [anon_sym_PLUS_PLUS] = ACTIONS(674),
    [anon_sym_sizeof] = ACTIONS(676),
    [sym_number_literal] = ACTIONS(6732),
    [sym_char_literal] = ACTIONS(6732),
    [sym_string_literal] = ACTIONS(678),
    [sym_true] = ACTIONS(6760),
    [sym_false] = ACTIONS(6760),
    [sym_null] = ACTIONS(6760),
    [sym_identifier] = ACTIONS(7110),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(51),
    [sym_auto] = ACTIONS(162),
    [anon_sym_typename] = ACTIONS(172),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(3040),
    [anon_sym_delete] = ACTIONS(686),
    [sym_nullptr] = ACTIONS(6760),
  },
  [2935] = {
    [sym__expression] = STATE(3022),
    [sym_conditional_expression] = STATE(3022),
    [sym_assignment_expression] = STATE(3022),
    [sym_pointer_expression] = STATE(3022),
    [sym_logical_expression] = STATE(3022),
    [sym_bitwise_expression] = STATE(3022),
    [sym_equality_expression] = STATE(3022),
    [sym_relational_expression] = STATE(3022),
    [sym_shift_expression] = STATE(3022),
    [sym_math_expression] = STATE(3022),
    [sym_cast_expression] = STATE(3022),
    [sym_sizeof_expression] = STATE(3022),
    [sym_subscript_expression] = STATE(3022),
    [sym_call_expression] = STATE(3022),
    [sym_field_expression] = STATE(3022),
    [sym_compound_literal_expression] = STATE(3022),
    [sym_parenthesized_expression] = STATE(3022),
    [sym_concatenated_string] = STATE(3022),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(3022),
    [sym_new_expression] = STATE(3022),
    [sym_delete_expression] = STATE(3022),
    [sym_lambda_expression] = STATE(3022),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(7112),
    [anon_sym_LPAREN] = ACTIONS(2943),
    [anon_sym_STAR] = ACTIONS(2945),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_AMP] = ACTIONS(2945),
    [anon_sym_BANG] = ACTIONS(2947),
    [anon_sym_TILDE] = ACTIONS(2949),
    [anon_sym_PLUS] = ACTIONS(2951),
    [anon_sym_DASH] = ACTIONS(2951),
    [anon_sym_DASH_DASH] = ACTIONS(2953),
    [anon_sym_PLUS_PLUS] = ACTIONS(2953),
    [anon_sym_sizeof] = ACTIONS(2955),
    [sym_number_literal] = ACTIONS(7112),
    [sym_char_literal] = ACTIONS(7112),
    [sym_string_literal] = ACTIONS(2957),
    [sym_true] = ACTIONS(7114),
    [sym_false] = ACTIONS(7114),
    [sym_null] = ACTIONS(7114),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(2961),
    [anon_sym_delete] = ACTIONS(2963),
    [sym_nullptr] = ACTIONS(7114),
  },
  [2936] = {
    [anon_sym_while] = ACTIONS(7116),
    [sym_comment] = ACTIONS(49),
  },
  [2937] = {
    [sym_declaration] = STATE(3024),
    [sym__declaration_specifiers] = STATE(1500),
    [sym_storage_class_specifier] = STATE(109),
    [sym_type_qualifier] = STATE(109),
    [sym__type_specifier] = STATE(105),
    [sym_sized_type_specifier] = STATE(105),
    [sym_enum_specifier] = STATE(105),
    [sym_struct_specifier] = STATE(105),
    [sym_union_specifier] = STATE(105),
    [sym__expression] = STATE(3025),
    [sym_conditional_expression] = STATE(3025),
    [sym_assignment_expression] = STATE(3025),
    [sym_pointer_expression] = STATE(3025),
    [sym_logical_expression] = STATE(3025),
    [sym_bitwise_expression] = STATE(3025),
    [sym_equality_expression] = STATE(3025),
    [sym_relational_expression] = STATE(3025),
    [sym_shift_expression] = STATE(3025),
    [sym_math_expression] = STATE(3025),
    [sym_cast_expression] = STATE(3025),
    [sym_sizeof_expression] = STATE(3025),
    [sym_subscript_expression] = STATE(3025),
    [sym_call_expression] = STATE(3025),
    [sym_field_expression] = STATE(3025),
    [sym_compound_literal_expression] = STATE(3025),
    [sym_parenthesized_expression] = STATE(3025),
    [sym_concatenated_string] = STATE(3025),
    [sym_macro_type_specifier] = STATE(105),
    [sym_class_specifier] = STATE(105),
    [sym_dependent_type] = STATE(105),
    [sym_template_type] = STATE(1475),
    [sym_template_function] = STATE(3025),
    [sym_for_range_declaration] = STATE(3026),
    [sym_new_expression] = STATE(3025),
    [sym_delete_expression] = STATE(3025),
    [sym_lambda_expression] = STATE(3025),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(416),
    [sym_scoped_namespace_identifier] = STATE(1476),
    [aux_sym__declaration_specifiers_repeat1] = STATE(109),
    [aux_sym_sized_type_specifier_repeat1] = STATE(110),
    [sym_raw_string_literal] = ACTIONS(7118),
    [anon_sym_LPAREN] = ACTIONS(1347),
    [anon_sym_SEMI] = ACTIONS(7120),
    [anon_sym_extern] = ACTIONS(154),
    [anon_sym_STAR] = ACTIONS(1349),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_static] = ACTIONS(154),
    [anon_sym_register] = ACTIONS(154),
    [anon_sym_inline] = ACTIONS(154),
    [anon_sym_const] = ACTIONS(158),
    [anon_sym_restrict] = ACTIONS(158),
    [anon_sym_volatile] = ACTIONS(158),
    [anon_sym__Atomic] = ACTIONS(158),
    [anon_sym_mutable] = ACTIONS(158),
    [anon_sym_explicit] = ACTIONS(158),
    [anon_sym_constexpr] = ACTIONS(158),
    [anon_sym_unsigned] = ACTIONS(160),
    [anon_sym_long] = ACTIONS(160),
    [anon_sym_short] = ACTIONS(160),
    [sym_primitive_type] = ACTIONS(162),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_union] = ACTIONS(39),
    [anon_sym_AMP] = ACTIONS(1349),
    [anon_sym_BANG] = ACTIONS(1351),
    [anon_sym_TILDE] = ACTIONS(1353),
    [anon_sym_PLUS] = ACTIONS(1355),
    [anon_sym_DASH] = ACTIONS(1355),
    [anon_sym_DASH_DASH] = ACTIONS(1357),
    [anon_sym_PLUS_PLUS] = ACTIONS(1357),
    [anon_sym_sizeof] = ACTIONS(1359),
    [sym_number_literal] = ACTIONS(7118),
    [sym_char_literal] = ACTIONS(7118),
    [sym_string_literal] = ACTIONS(1361),
    [sym_true] = ACTIONS(7122),
    [sym_false] = ACTIONS(7122),
    [sym_null] = ACTIONS(7122),
    [sym_identifier] = ACTIONS(3088),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(51),
    [sym_auto] = ACTIONS(162),
    [anon_sym_typename] = ACTIONS(172),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(3090),
    [anon_sym_delete] = ACTIONS(1367),
    [sym_nullptr] = ACTIONS(7122),
  },
  [2938] = {
    [sym_raw_string_literal] = ACTIONS(3092),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3094),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3094),
    [anon_sym_LPAREN] = ACTIONS(3092),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3094),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3094),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3094),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3094),
    [sym_preproc_directive] = ACTIONS(3094),
    [anon_sym_SEMI] = ACTIONS(3092),
    [anon_sym_typedef] = ACTIONS(3094),
    [anon_sym_extern] = ACTIONS(3094),
    [anon_sym_LBRACE] = ACTIONS(3092),
    [anon_sym_STAR] = ACTIONS(3092),
    [anon_sym_LBRACK] = ACTIONS(3092),
    [anon_sym_static] = ACTIONS(3094),
    [anon_sym_register] = ACTIONS(3094),
    [anon_sym_inline] = ACTIONS(3094),
    [anon_sym_const] = ACTIONS(3094),
    [anon_sym_restrict] = ACTIONS(3094),
    [anon_sym_volatile] = ACTIONS(3094),
    [anon_sym__Atomic] = ACTIONS(3094),
    [anon_sym_mutable] = ACTIONS(3094),
    [anon_sym_explicit] = ACTIONS(3094),
    [anon_sym_constexpr] = ACTIONS(3094),
    [anon_sym_unsigned] = ACTIONS(3094),
    [anon_sym_long] = ACTIONS(3094),
    [anon_sym_short] = ACTIONS(3094),
    [sym_primitive_type] = ACTIONS(3094),
    [anon_sym_enum] = ACTIONS(3094),
    [anon_sym_struct] = ACTIONS(3094),
    [anon_sym_union] = ACTIONS(3094),
    [anon_sym_if] = ACTIONS(3094),
    [anon_sym_else] = ACTIONS(3094),
    [anon_sym_switch] = ACTIONS(3094),
    [anon_sym_case] = ACTIONS(3094),
    [anon_sym_default] = ACTIONS(3094),
    [anon_sym_while] = ACTIONS(3094),
    [anon_sym_do] = ACTIONS(3094),
    [anon_sym_for] = ACTIONS(3094),
    [anon_sym_return] = ACTIONS(3094),
    [anon_sym_break] = ACTIONS(3094),
    [anon_sym_continue] = ACTIONS(3094),
    [anon_sym_goto] = ACTIONS(3094),
    [anon_sym_AMP] = ACTIONS(3092),
    [anon_sym_BANG] = ACTIONS(3092),
    [anon_sym_TILDE] = ACTIONS(3092),
    [anon_sym_PLUS] = ACTIONS(3094),
    [anon_sym_DASH] = ACTIONS(3094),
    [anon_sym_DASH_DASH] = ACTIONS(3092),
    [anon_sym_PLUS_PLUS] = ACTIONS(3092),
    [anon_sym_sizeof] = ACTIONS(3094),
    [sym_number_literal] = ACTIONS(3092),
    [sym_char_literal] = ACTIONS(3092),
    [sym_string_literal] = ACTIONS(3092),
    [sym_true] = ACTIONS(3094),
    [sym_false] = ACTIONS(3094),
    [sym_null] = ACTIONS(3094),
    [sym_identifier] = ACTIONS(3094),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(3094),
    [sym_auto] = ACTIONS(3094),
    [anon_sym_typename] = ACTIONS(3094),
    [anon_sym_new] = ACTIONS(3094),
    [anon_sym_COLON_COLON] = ACTIONS(3092),
    [anon_sym_delete] = ACTIONS(3094),
    [sym_nullptr] = ACTIONS(3094),
  },
  [2939] = {
    [sym_argument_list] = STATE(802),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_SEMI] = ACTIONS(7124),
    [anon_sym_STAR] = ACTIONS(2553),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_EQ] = ACTIONS(2555),
    [anon_sym_QMARK] = ACTIONS(2557),
    [anon_sym_STAR_EQ] = ACTIONS(2559),
    [anon_sym_SLASH_EQ] = ACTIONS(2559),
    [anon_sym_PERCENT_EQ] = ACTIONS(2559),
    [anon_sym_PLUS_EQ] = ACTIONS(2559),
    [anon_sym_DASH_EQ] = ACTIONS(2559),
    [anon_sym_LT_LT_EQ] = ACTIONS(2559),
    [anon_sym_GT_GT_EQ] = ACTIONS(2559),
    [anon_sym_AMP_EQ] = ACTIONS(2559),
    [anon_sym_CARET_EQ] = ACTIONS(2559),
    [anon_sym_PIPE_EQ] = ACTIONS(2559),
    [anon_sym_AMP] = ACTIONS(2561),
    [anon_sym_PIPE_PIPE] = ACTIONS(2563),
    [anon_sym_AMP_AMP] = ACTIONS(2565),
    [anon_sym_PIPE] = ACTIONS(2567),
    [anon_sym_CARET] = ACTIONS(2569),
    [anon_sym_EQ_EQ] = ACTIONS(2571),
    [anon_sym_BANG_EQ] = ACTIONS(2571),
    [anon_sym_LT] = ACTIONS(2573),
    [anon_sym_GT] = ACTIONS(2573),
    [anon_sym_LT_EQ] = ACTIONS(2575),
    [anon_sym_GT_EQ] = ACTIONS(2575),
    [anon_sym_LT_LT] = ACTIONS(2577),
    [anon_sym_GT_GT] = ACTIONS(2577),
    [anon_sym_PLUS] = ACTIONS(2579),
    [anon_sym_DASH] = ACTIONS(2579),
    [anon_sym_SLASH] = ACTIONS(2553),
    [anon_sym_PERCENT] = ACTIONS(2553),
    [anon_sym_DASH_DASH] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(1554),
    [anon_sym_DASH_GT] = ACTIONS(1554),
    [sym_comment] = ACTIONS(49),
  },
  [2940] = {
    [anon_sym_SEMI] = ACTIONS(7124),
    [sym_comment] = ACTIONS(49),
  },
  [2941] = {
    [sym_raw_string_literal] = ACTIONS(3098),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3100),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3100),
    [anon_sym_LPAREN] = ACTIONS(3098),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3100),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3100),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3100),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3100),
    [sym_preproc_directive] = ACTIONS(3100),
    [anon_sym_SEMI] = ACTIONS(3098),
    [anon_sym_typedef] = ACTIONS(3100),
    [anon_sym_extern] = ACTIONS(3100),
    [anon_sym_LBRACE] = ACTIONS(3098),
    [anon_sym_STAR] = ACTIONS(3098),
    [anon_sym_LBRACK] = ACTIONS(3098),
    [anon_sym_static] = ACTIONS(3100),
    [anon_sym_register] = ACTIONS(3100),
    [anon_sym_inline] = ACTIONS(3100),
    [anon_sym_const] = ACTIONS(3100),
    [anon_sym_restrict] = ACTIONS(3100),
    [anon_sym_volatile] = ACTIONS(3100),
    [anon_sym__Atomic] = ACTIONS(3100),
    [anon_sym_mutable] = ACTIONS(3100),
    [anon_sym_explicit] = ACTIONS(3100),
    [anon_sym_constexpr] = ACTIONS(3100),
    [anon_sym_unsigned] = ACTIONS(3100),
    [anon_sym_long] = ACTIONS(3100),
    [anon_sym_short] = ACTIONS(3100),
    [sym_primitive_type] = ACTIONS(3100),
    [anon_sym_enum] = ACTIONS(3100),
    [anon_sym_struct] = ACTIONS(3100),
    [anon_sym_union] = ACTIONS(3100),
    [anon_sym_if] = ACTIONS(3100),
    [anon_sym_else] = ACTIONS(3100),
    [anon_sym_switch] = ACTIONS(3100),
    [anon_sym_case] = ACTIONS(3100),
    [anon_sym_default] = ACTIONS(3100),
    [anon_sym_while] = ACTIONS(3100),
    [anon_sym_do] = ACTIONS(3100),
    [anon_sym_for] = ACTIONS(3100),
    [anon_sym_return] = ACTIONS(3100),
    [anon_sym_break] = ACTIONS(3100),
    [anon_sym_continue] = ACTIONS(3100),
    [anon_sym_goto] = ACTIONS(3100),
    [anon_sym_AMP] = ACTIONS(3098),
    [anon_sym_BANG] = ACTIONS(3098),
    [anon_sym_TILDE] = ACTIONS(3098),
    [anon_sym_PLUS] = ACTIONS(3100),
    [anon_sym_DASH] = ACTIONS(3100),
    [anon_sym_DASH_DASH] = ACTIONS(3098),
    [anon_sym_PLUS_PLUS] = ACTIONS(3098),
    [anon_sym_sizeof] = ACTIONS(3100),
    [sym_number_literal] = ACTIONS(3098),
    [sym_char_literal] = ACTIONS(3098),
    [sym_string_literal] = ACTIONS(3098),
    [sym_true] = ACTIONS(3100),
    [sym_false] = ACTIONS(3100),
    [sym_null] = ACTIONS(3100),
    [sym_identifier] = ACTIONS(3100),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(3100),
    [sym_auto] = ACTIONS(3100),
    [anon_sym_typename] = ACTIONS(3100),
    [anon_sym_new] = ACTIONS(3100),
    [anon_sym_COLON_COLON] = ACTIONS(3098),
    [anon_sym_delete] = ACTIONS(3100),
    [sym_nullptr] = ACTIONS(3100),
  },
  [2942] = {
    [sym_raw_string_literal] = ACTIONS(3102),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3104),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3104),
    [anon_sym_LPAREN] = ACTIONS(3102),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3104),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3104),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3104),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3104),
    [sym_preproc_directive] = ACTIONS(3104),
    [anon_sym_SEMI] = ACTIONS(3102),
    [anon_sym_typedef] = ACTIONS(3104),
    [anon_sym_extern] = ACTIONS(3104),
    [anon_sym_LBRACE] = ACTIONS(3102),
    [anon_sym_STAR] = ACTIONS(3102),
    [anon_sym_LBRACK] = ACTIONS(3102),
    [anon_sym_static] = ACTIONS(3104),
    [anon_sym_register] = ACTIONS(3104),
    [anon_sym_inline] = ACTIONS(3104),
    [anon_sym_const] = ACTIONS(3104),
    [anon_sym_restrict] = ACTIONS(3104),
    [anon_sym_volatile] = ACTIONS(3104),
    [anon_sym__Atomic] = ACTIONS(3104),
    [anon_sym_mutable] = ACTIONS(3104),
    [anon_sym_explicit] = ACTIONS(3104),
    [anon_sym_constexpr] = ACTIONS(3104),
    [anon_sym_unsigned] = ACTIONS(3104),
    [anon_sym_long] = ACTIONS(3104),
    [anon_sym_short] = ACTIONS(3104),
    [sym_primitive_type] = ACTIONS(3104),
    [anon_sym_enum] = ACTIONS(3104),
    [anon_sym_struct] = ACTIONS(3104),
    [anon_sym_union] = ACTIONS(3104),
    [anon_sym_if] = ACTIONS(3104),
    [anon_sym_else] = ACTIONS(3104),
    [anon_sym_switch] = ACTIONS(3104),
    [anon_sym_case] = ACTIONS(3104),
    [anon_sym_default] = ACTIONS(3104),
    [anon_sym_while] = ACTIONS(3104),
    [anon_sym_do] = ACTIONS(3104),
    [anon_sym_for] = ACTIONS(3104),
    [anon_sym_return] = ACTIONS(3104),
    [anon_sym_break] = ACTIONS(3104),
    [anon_sym_continue] = ACTIONS(3104),
    [anon_sym_goto] = ACTIONS(3104),
    [anon_sym_AMP] = ACTIONS(3102),
    [anon_sym_BANG] = ACTIONS(3102),
    [anon_sym_TILDE] = ACTIONS(3102),
    [anon_sym_PLUS] = ACTIONS(3104),
    [anon_sym_DASH] = ACTIONS(3104),
    [anon_sym_DASH_DASH] = ACTIONS(3102),
    [anon_sym_PLUS_PLUS] = ACTIONS(3102),
    [anon_sym_sizeof] = ACTIONS(3104),
    [sym_number_literal] = ACTIONS(3102),
    [sym_char_literal] = ACTIONS(3102),
    [sym_string_literal] = ACTIONS(3102),
    [sym_true] = ACTIONS(3104),
    [sym_false] = ACTIONS(3104),
    [sym_null] = ACTIONS(3104),
    [sym_identifier] = ACTIONS(3104),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(3104),
    [sym_auto] = ACTIONS(3104),
    [anon_sym_typename] = ACTIONS(3104),
    [anon_sym_new] = ACTIONS(3104),
    [anon_sym_COLON_COLON] = ACTIONS(3102),
    [anon_sym_delete] = ACTIONS(3104),
    [sym_nullptr] = ACTIONS(3104),
  },
  [2943] = {
    [anon_sym_SEMI] = ACTIONS(7126),
    [sym_comment] = ACTIONS(49),
  },
  [2944] = {
    [sym_compound_statement] = STATE(3029),
    [sym_labeled_statement] = STATE(3029),
    [sym_expression_statement] = STATE(3029),
    [sym_if_statement] = STATE(3029),
    [sym_switch_statement] = STATE(3029),
    [sym_case_statement] = STATE(3029),
    [sym_while_statement] = STATE(3029),
    [sym_do_statement] = STATE(3029),
    [sym_for_statement] = STATE(3029),
    [sym_return_statement] = STATE(3029),
    [sym_break_statement] = STATE(3029),
    [sym_continue_statement] = STATE(3029),
    [sym_goto_statement] = STATE(3029),
    [sym__expression] = STATE(2844),
    [sym_comma_expression] = STATE(2845),
    [sym_conditional_expression] = STATE(2844),
    [sym_assignment_expression] = STATE(2844),
    [sym_pointer_expression] = STATE(2844),
    [sym_logical_expression] = STATE(2844),
    [sym_bitwise_expression] = STATE(2844),
    [sym_equality_expression] = STATE(2844),
    [sym_relational_expression] = STATE(2844),
    [sym_shift_expression] = STATE(2844),
    [sym_math_expression] = STATE(2844),
    [sym_cast_expression] = STATE(2844),
    [sym_sizeof_expression] = STATE(2844),
    [sym_subscript_expression] = STATE(2844),
    [sym_call_expression] = STATE(2844),
    [sym_field_expression] = STATE(2844),
    [sym_compound_literal_expression] = STATE(2844),
    [sym_parenthesized_expression] = STATE(2844),
    [sym_concatenated_string] = STATE(2844),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(2844),
    [sym_for_range_loop] = STATE(3029),
    [sym_new_expression] = STATE(2844),
    [sym_delete_expression] = STATE(2844),
    [sym_lambda_expression] = STATE(2844),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(6732),
    [anon_sym_LPAREN] = ACTIONS(626),
    [anon_sym_SEMI] = ACTIONS(6734),
    [anon_sym_LBRACE] = ACTIONS(6736),
    [anon_sym_STAR] = ACTIONS(644),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_if] = ACTIONS(6738),
    [anon_sym_switch] = ACTIONS(6740),
    [anon_sym_case] = ACTIONS(6742),
    [anon_sym_default] = ACTIONS(6744),
    [anon_sym_while] = ACTIONS(6746),
    [anon_sym_do] = ACTIONS(6748),
    [anon_sym_for] = ACTIONS(6750),
    [anon_sym_return] = ACTIONS(6752),
    [anon_sym_break] = ACTIONS(6754),
    [anon_sym_continue] = ACTIONS(6756),
    [anon_sym_goto] = ACTIONS(6758),
    [anon_sym_AMP] = ACTIONS(644),
    [anon_sym_BANG] = ACTIONS(668),
    [anon_sym_TILDE] = ACTIONS(670),
    [anon_sym_PLUS] = ACTIONS(672),
    [anon_sym_DASH] = ACTIONS(672),
    [anon_sym_DASH_DASH] = ACTIONS(674),
    [anon_sym_PLUS_PLUS] = ACTIONS(674),
    [anon_sym_sizeof] = ACTIONS(676),
    [sym_number_literal] = ACTIONS(6732),
    [sym_char_literal] = ACTIONS(6732),
    [sym_string_literal] = ACTIONS(678),
    [sym_true] = ACTIONS(6760),
    [sym_false] = ACTIONS(6760),
    [sym_null] = ACTIONS(6760),
    [sym_identifier] = ACTIONS(6762),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1303),
    [anon_sym_delete] = ACTIONS(686),
    [sym_nullptr] = ACTIONS(6760),
  },
  [2945] = {
    [sym_compound_statement] = STATE(3030),
    [sym_labeled_statement] = STATE(3030),
    [sym_expression_statement] = STATE(3030),
    [sym_if_statement] = STATE(3030),
    [sym_switch_statement] = STATE(3030),
    [sym_case_statement] = STATE(3030),
    [sym_while_statement] = STATE(3030),
    [sym_do_statement] = STATE(3030),
    [sym_for_statement] = STATE(3030),
    [sym_return_statement] = STATE(3030),
    [sym_break_statement] = STATE(3030),
    [sym_continue_statement] = STATE(3030),
    [sym_goto_statement] = STATE(3030),
    [sym__expression] = STATE(1947),
    [sym_comma_expression] = STATE(1948),
    [sym_conditional_expression] = STATE(1947),
    [sym_assignment_expression] = STATE(1947),
    [sym_pointer_expression] = STATE(1947),
    [sym_logical_expression] = STATE(1947),
    [sym_bitwise_expression] = STATE(1947),
    [sym_equality_expression] = STATE(1947),
    [sym_relational_expression] = STATE(1947),
    [sym_shift_expression] = STATE(1947),
    [sym_math_expression] = STATE(1947),
    [sym_cast_expression] = STATE(1947),
    [sym_sizeof_expression] = STATE(1947),
    [sym_subscript_expression] = STATE(1947),
    [sym_call_expression] = STATE(1947),
    [sym_field_expression] = STATE(1947),
    [sym_compound_literal_expression] = STATE(1947),
    [sym_parenthesized_expression] = STATE(1947),
    [sym_concatenated_string] = STATE(1947),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(1947),
    [sym_for_range_loop] = STATE(3030),
    [sym_new_expression] = STATE(1947),
    [sym_delete_expression] = STATE(1947),
    [sym_lambda_expression] = STATE(1947),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(4395),
    [anon_sym_LPAREN] = ACTIONS(626),
    [anon_sym_SEMI] = ACTIONS(4411),
    [anon_sym_LBRACE] = ACTIONS(4415),
    [anon_sym_STAR] = ACTIONS(644),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_if] = ACTIONS(4417),
    [anon_sym_switch] = ACTIONS(4419),
    [anon_sym_case] = ACTIONS(4421),
    [anon_sym_default] = ACTIONS(4423),
    [anon_sym_while] = ACTIONS(4425),
    [anon_sym_do] = ACTIONS(4427),
    [anon_sym_for] = ACTIONS(4429),
    [anon_sym_return] = ACTIONS(4431),
    [anon_sym_break] = ACTIONS(4433),
    [anon_sym_continue] = ACTIONS(4435),
    [anon_sym_goto] = ACTIONS(4437),
    [anon_sym_AMP] = ACTIONS(644),
    [anon_sym_BANG] = ACTIONS(668),
    [anon_sym_TILDE] = ACTIONS(670),
    [anon_sym_PLUS] = ACTIONS(672),
    [anon_sym_DASH] = ACTIONS(672),
    [anon_sym_DASH_DASH] = ACTIONS(674),
    [anon_sym_PLUS_PLUS] = ACTIONS(674),
    [anon_sym_sizeof] = ACTIONS(676),
    [sym_number_literal] = ACTIONS(4395),
    [sym_char_literal] = ACTIONS(4395),
    [sym_string_literal] = ACTIONS(678),
    [sym_true] = ACTIONS(4439),
    [sym_false] = ACTIONS(4439),
    [sym_null] = ACTIONS(4439),
    [sym_identifier] = ACTIONS(6077),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1303),
    [anon_sym_delete] = ACTIONS(686),
    [sym_nullptr] = ACTIONS(4439),
  },
  [2946] = {
    [sym_raw_string_literal] = ACTIONS(3132),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3134),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3134),
    [anon_sym_LPAREN] = ACTIONS(3132),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3134),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3134),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3134),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3134),
    [sym_preproc_directive] = ACTIONS(3134),
    [anon_sym_SEMI] = ACTIONS(3132),
    [anon_sym_typedef] = ACTIONS(3134),
    [anon_sym_extern] = ACTIONS(3134),
    [anon_sym_LBRACE] = ACTIONS(3132),
    [anon_sym_STAR] = ACTIONS(3132),
    [anon_sym_LBRACK] = ACTIONS(3132),
    [anon_sym_static] = ACTIONS(3134),
    [anon_sym_register] = ACTIONS(3134),
    [anon_sym_inline] = ACTIONS(3134),
    [anon_sym_const] = ACTIONS(3134),
    [anon_sym_restrict] = ACTIONS(3134),
    [anon_sym_volatile] = ACTIONS(3134),
    [anon_sym__Atomic] = ACTIONS(3134),
    [anon_sym_mutable] = ACTIONS(3134),
    [anon_sym_explicit] = ACTIONS(3134),
    [anon_sym_constexpr] = ACTIONS(3134),
    [anon_sym_unsigned] = ACTIONS(3134),
    [anon_sym_long] = ACTIONS(3134),
    [anon_sym_short] = ACTIONS(3134),
    [sym_primitive_type] = ACTIONS(3134),
    [anon_sym_enum] = ACTIONS(3134),
    [anon_sym_struct] = ACTIONS(3134),
    [anon_sym_union] = ACTIONS(3134),
    [anon_sym_if] = ACTIONS(3134),
    [anon_sym_else] = ACTIONS(3134),
    [anon_sym_switch] = ACTIONS(3134),
    [anon_sym_case] = ACTIONS(3134),
    [anon_sym_default] = ACTIONS(3134),
    [anon_sym_while] = ACTIONS(3134),
    [anon_sym_do] = ACTIONS(3134),
    [anon_sym_for] = ACTIONS(3134),
    [anon_sym_return] = ACTIONS(3134),
    [anon_sym_break] = ACTIONS(3134),
    [anon_sym_continue] = ACTIONS(3134),
    [anon_sym_goto] = ACTIONS(3134),
    [anon_sym_AMP] = ACTIONS(3132),
    [anon_sym_BANG] = ACTIONS(3132),
    [anon_sym_TILDE] = ACTIONS(3132),
    [anon_sym_PLUS] = ACTIONS(3134),
    [anon_sym_DASH] = ACTIONS(3134),
    [anon_sym_DASH_DASH] = ACTIONS(3132),
    [anon_sym_PLUS_PLUS] = ACTIONS(3132),
    [anon_sym_sizeof] = ACTIONS(3134),
    [sym_number_literal] = ACTIONS(3132),
    [sym_char_literal] = ACTIONS(3132),
    [sym_string_literal] = ACTIONS(3132),
    [sym_true] = ACTIONS(3134),
    [sym_false] = ACTIONS(3134),
    [sym_null] = ACTIONS(3134),
    [sym_identifier] = ACTIONS(3134),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(3134),
    [sym_auto] = ACTIONS(3134),
    [anon_sym_typename] = ACTIONS(3134),
    [anon_sym_new] = ACTIONS(3134),
    [anon_sym_COLON_COLON] = ACTIONS(3132),
    [anon_sym_delete] = ACTIONS(3134),
    [sym_nullptr] = ACTIONS(3134),
  },
  [2947] = {
    [sym_raw_string_literal] = ACTIONS(6611),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(6613),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(6613),
    [anon_sym_LPAREN] = ACTIONS(6611),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(6613),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(6613),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(6613),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(6613),
    [sym_preproc_directive] = ACTIONS(6613),
    [anon_sym_SEMI] = ACTIONS(6611),
    [anon_sym_typedef] = ACTIONS(6613),
    [anon_sym_extern] = ACTIONS(6613),
    [anon_sym_LBRACE] = ACTIONS(6611),
    [anon_sym_STAR] = ACTIONS(6611),
    [anon_sym_LBRACK] = ACTIONS(6611),
    [anon_sym_static] = ACTIONS(6613),
    [anon_sym_register] = ACTIONS(6613),
    [anon_sym_inline] = ACTIONS(6613),
    [anon_sym_const] = ACTIONS(6613),
    [anon_sym_restrict] = ACTIONS(6613),
    [anon_sym_volatile] = ACTIONS(6613),
    [anon_sym__Atomic] = ACTIONS(6613),
    [anon_sym_mutable] = ACTIONS(6613),
    [anon_sym_explicit] = ACTIONS(6613),
    [anon_sym_constexpr] = ACTIONS(6613),
    [anon_sym_unsigned] = ACTIONS(6613),
    [anon_sym_long] = ACTIONS(6613),
    [anon_sym_short] = ACTIONS(6613),
    [sym_primitive_type] = ACTIONS(6613),
    [anon_sym_enum] = ACTIONS(6613),
    [anon_sym_struct] = ACTIONS(6613),
    [anon_sym_union] = ACTIONS(6613),
    [anon_sym_if] = ACTIONS(6613),
    [anon_sym_else] = ACTIONS(7128),
    [anon_sym_switch] = ACTIONS(6613),
    [anon_sym_case] = ACTIONS(6613),
    [anon_sym_default] = ACTIONS(6613),
    [anon_sym_while] = ACTIONS(6613),
    [anon_sym_do] = ACTIONS(6613),
    [anon_sym_for] = ACTIONS(6613),
    [anon_sym_return] = ACTIONS(6613),
    [anon_sym_break] = ACTIONS(6613),
    [anon_sym_continue] = ACTIONS(6613),
    [anon_sym_goto] = ACTIONS(6613),
    [anon_sym_AMP] = ACTIONS(6611),
    [anon_sym_BANG] = ACTIONS(6611),
    [anon_sym_TILDE] = ACTIONS(6611),
    [anon_sym_PLUS] = ACTIONS(6613),
    [anon_sym_DASH] = ACTIONS(6613),
    [anon_sym_DASH_DASH] = ACTIONS(6611),
    [anon_sym_PLUS_PLUS] = ACTIONS(6611),
    [anon_sym_sizeof] = ACTIONS(6613),
    [sym_number_literal] = ACTIONS(6611),
    [sym_char_literal] = ACTIONS(6611),
    [sym_string_literal] = ACTIONS(6611),
    [sym_true] = ACTIONS(6613),
    [sym_false] = ACTIONS(6613),
    [sym_null] = ACTIONS(6613),
    [sym_identifier] = ACTIONS(6613),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(6613),
    [sym_auto] = ACTIONS(6613),
    [anon_sym_typename] = ACTIONS(6613),
    [anon_sym_new] = ACTIONS(6613),
    [anon_sym_COLON_COLON] = ACTIONS(6611),
    [anon_sym_delete] = ACTIONS(6613),
    [sym_nullptr] = ACTIONS(6613),
  },
  [2948] = {
    [sym_raw_string_literal] = ACTIONS(6653),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(6655),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(6655),
    [anon_sym_LPAREN] = ACTIONS(6653),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(6655),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(6655),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(6655),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(6655),
    [sym_preproc_directive] = ACTIONS(6655),
    [anon_sym_SEMI] = ACTIONS(6653),
    [anon_sym_typedef] = ACTIONS(6655),
    [anon_sym_extern] = ACTIONS(6655),
    [anon_sym_LBRACE] = ACTIONS(6653),
    [anon_sym_STAR] = ACTIONS(6653),
    [anon_sym_LBRACK] = ACTIONS(6653),
    [anon_sym_static] = ACTIONS(6655),
    [anon_sym_register] = ACTIONS(6655),
    [anon_sym_inline] = ACTIONS(6655),
    [anon_sym_const] = ACTIONS(6655),
    [anon_sym_restrict] = ACTIONS(6655),
    [anon_sym_volatile] = ACTIONS(6655),
    [anon_sym__Atomic] = ACTIONS(6655),
    [anon_sym_mutable] = ACTIONS(6655),
    [anon_sym_explicit] = ACTIONS(6655),
    [anon_sym_constexpr] = ACTIONS(6655),
    [anon_sym_unsigned] = ACTIONS(6655),
    [anon_sym_long] = ACTIONS(6655),
    [anon_sym_short] = ACTIONS(6655),
    [sym_primitive_type] = ACTIONS(6655),
    [anon_sym_enum] = ACTIONS(6655),
    [anon_sym_struct] = ACTIONS(6655),
    [anon_sym_union] = ACTIONS(6655),
    [anon_sym_if] = ACTIONS(6655),
    [anon_sym_switch] = ACTIONS(6655),
    [anon_sym_case] = ACTIONS(6655),
    [anon_sym_default] = ACTIONS(6655),
    [anon_sym_while] = ACTIONS(6655),
    [anon_sym_do] = ACTIONS(6655),
    [anon_sym_for] = ACTIONS(6655),
    [anon_sym_return] = ACTIONS(6655),
    [anon_sym_break] = ACTIONS(6655),
    [anon_sym_continue] = ACTIONS(6655),
    [anon_sym_goto] = ACTIONS(6655),
    [anon_sym_AMP] = ACTIONS(6653),
    [anon_sym_BANG] = ACTIONS(6653),
    [anon_sym_TILDE] = ACTIONS(6653),
    [anon_sym_PLUS] = ACTIONS(6655),
    [anon_sym_DASH] = ACTIONS(6655),
    [anon_sym_DASH_DASH] = ACTIONS(6653),
    [anon_sym_PLUS_PLUS] = ACTIONS(6653),
    [anon_sym_sizeof] = ACTIONS(6655),
    [sym_number_literal] = ACTIONS(6653),
    [sym_char_literal] = ACTIONS(6653),
    [sym_string_literal] = ACTIONS(6653),
    [sym_true] = ACTIONS(6655),
    [sym_false] = ACTIONS(6655),
    [sym_null] = ACTIONS(6655),
    [sym_identifier] = ACTIONS(6655),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(6655),
    [sym_auto] = ACTIONS(6655),
    [anon_sym_typename] = ACTIONS(6655),
    [anon_sym_new] = ACTIONS(6655),
    [anon_sym_COLON_COLON] = ACTIONS(6653),
    [anon_sym_delete] = ACTIONS(6655),
    [sym_nullptr] = ACTIONS(6655),
  },
  [2949] = {
    [sym_raw_string_literal] = ACTIONS(6657),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(6659),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(6659),
    [anon_sym_LPAREN] = ACTIONS(6657),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(6659),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(6659),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(6659),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(6659),
    [sym_preproc_directive] = ACTIONS(6659),
    [anon_sym_SEMI] = ACTIONS(6657),
    [anon_sym_typedef] = ACTIONS(6659),
    [anon_sym_extern] = ACTIONS(6659),
    [anon_sym_LBRACE] = ACTIONS(6657),
    [anon_sym_STAR] = ACTIONS(6657),
    [anon_sym_LBRACK] = ACTIONS(6657),
    [anon_sym_static] = ACTIONS(6659),
    [anon_sym_register] = ACTIONS(6659),
    [anon_sym_inline] = ACTIONS(6659),
    [anon_sym_const] = ACTIONS(6659),
    [anon_sym_restrict] = ACTIONS(6659),
    [anon_sym_volatile] = ACTIONS(6659),
    [anon_sym__Atomic] = ACTIONS(6659),
    [anon_sym_mutable] = ACTIONS(6659),
    [anon_sym_explicit] = ACTIONS(6659),
    [anon_sym_constexpr] = ACTIONS(6659),
    [anon_sym_unsigned] = ACTIONS(6659),
    [anon_sym_long] = ACTIONS(6659),
    [anon_sym_short] = ACTIONS(6659),
    [sym_primitive_type] = ACTIONS(6659),
    [anon_sym_enum] = ACTIONS(6659),
    [anon_sym_struct] = ACTIONS(6659),
    [anon_sym_union] = ACTIONS(6659),
    [anon_sym_if] = ACTIONS(6659),
    [anon_sym_switch] = ACTIONS(6659),
    [anon_sym_case] = ACTIONS(6659),
    [anon_sym_default] = ACTIONS(6659),
    [anon_sym_while] = ACTIONS(6659),
    [anon_sym_do] = ACTIONS(6659),
    [anon_sym_for] = ACTIONS(6659),
    [anon_sym_return] = ACTIONS(6659),
    [anon_sym_break] = ACTIONS(6659),
    [anon_sym_continue] = ACTIONS(6659),
    [anon_sym_goto] = ACTIONS(6659),
    [anon_sym_AMP] = ACTIONS(6657),
    [anon_sym_BANG] = ACTIONS(6657),
    [anon_sym_TILDE] = ACTIONS(6657),
    [anon_sym_PLUS] = ACTIONS(6659),
    [anon_sym_DASH] = ACTIONS(6659),
    [anon_sym_DASH_DASH] = ACTIONS(6657),
    [anon_sym_PLUS_PLUS] = ACTIONS(6657),
    [anon_sym_sizeof] = ACTIONS(6659),
    [sym_number_literal] = ACTIONS(6657),
    [sym_char_literal] = ACTIONS(6657),
    [sym_string_literal] = ACTIONS(6657),
    [sym_true] = ACTIONS(6659),
    [sym_false] = ACTIONS(6659),
    [sym_null] = ACTIONS(6659),
    [sym_identifier] = ACTIONS(6659),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(6659),
    [sym_auto] = ACTIONS(6659),
    [anon_sym_typename] = ACTIONS(6659),
    [anon_sym_new] = ACTIONS(6659),
    [anon_sym_COLON_COLON] = ACTIONS(6657),
    [anon_sym_delete] = ACTIONS(6659),
    [sym_nullptr] = ACTIONS(6659),
  },
  [2950] = {
    [sym_compound_statement] = STATE(3032),
    [sym_labeled_statement] = STATE(3032),
    [sym_expression_statement] = STATE(3032),
    [sym_if_statement] = STATE(3032),
    [sym_switch_statement] = STATE(3032),
    [sym_case_statement] = STATE(3032),
    [sym_while_statement] = STATE(3032),
    [sym_do_statement] = STATE(3032),
    [sym_for_statement] = STATE(3032),
    [sym_return_statement] = STATE(3032),
    [sym_break_statement] = STATE(3032),
    [sym_continue_statement] = STATE(3032),
    [sym_goto_statement] = STATE(3032),
    [sym__expression] = STATE(1947),
    [sym_comma_expression] = STATE(1948),
    [sym_conditional_expression] = STATE(1947),
    [sym_assignment_expression] = STATE(1947),
    [sym_pointer_expression] = STATE(1947),
    [sym_logical_expression] = STATE(1947),
    [sym_bitwise_expression] = STATE(1947),
    [sym_equality_expression] = STATE(1947),
    [sym_relational_expression] = STATE(1947),
    [sym_shift_expression] = STATE(1947),
    [sym_math_expression] = STATE(1947),
    [sym_cast_expression] = STATE(1947),
    [sym_sizeof_expression] = STATE(1947),
    [sym_subscript_expression] = STATE(1947),
    [sym_call_expression] = STATE(1947),
    [sym_field_expression] = STATE(1947),
    [sym_compound_literal_expression] = STATE(1947),
    [sym_parenthesized_expression] = STATE(1947),
    [sym_concatenated_string] = STATE(1947),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(1947),
    [sym_for_range_loop] = STATE(3032),
    [sym_new_expression] = STATE(1947),
    [sym_delete_expression] = STATE(1947),
    [sym_lambda_expression] = STATE(1947),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(4395),
    [anon_sym_LPAREN] = ACTIONS(626),
    [anon_sym_SEMI] = ACTIONS(4411),
    [anon_sym_LBRACE] = ACTIONS(4415),
    [anon_sym_STAR] = ACTIONS(644),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_if] = ACTIONS(4417),
    [anon_sym_switch] = ACTIONS(4419),
    [anon_sym_case] = ACTIONS(4421),
    [anon_sym_default] = ACTIONS(4423),
    [anon_sym_while] = ACTIONS(4425),
    [anon_sym_do] = ACTIONS(4427),
    [anon_sym_for] = ACTIONS(4429),
    [anon_sym_return] = ACTIONS(4431),
    [anon_sym_break] = ACTIONS(4433),
    [anon_sym_continue] = ACTIONS(4435),
    [anon_sym_goto] = ACTIONS(4437),
    [anon_sym_AMP] = ACTIONS(644),
    [anon_sym_BANG] = ACTIONS(668),
    [anon_sym_TILDE] = ACTIONS(670),
    [anon_sym_PLUS] = ACTIONS(672),
    [anon_sym_DASH] = ACTIONS(672),
    [anon_sym_DASH_DASH] = ACTIONS(674),
    [anon_sym_PLUS_PLUS] = ACTIONS(674),
    [anon_sym_sizeof] = ACTIONS(676),
    [sym_number_literal] = ACTIONS(4395),
    [sym_char_literal] = ACTIONS(4395),
    [sym_string_literal] = ACTIONS(678),
    [sym_true] = ACTIONS(4439),
    [sym_false] = ACTIONS(4439),
    [sym_null] = ACTIONS(4439),
    [sym_identifier] = ACTIONS(6077),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1303),
    [anon_sym_delete] = ACTIONS(686),
    [sym_nullptr] = ACTIONS(4439),
  },
  [2951] = {
    [aux_sym_for_statement_repeat1] = STATE(2796),
    [anon_sym_COMMA] = ACTIONS(6339),
    [anon_sym_RPAREN] = ACTIONS(7130),
    [sym_comment] = ACTIONS(49),
  },
  [2952] = {
    [sym_argument_list] = STATE(802),
    [aux_sym_for_statement_repeat1] = STATE(3034),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_COMMA] = ACTIONS(6339),
    [anon_sym_RPAREN] = ACTIONS(7130),
    [anon_sym_STAR] = ACTIONS(2234),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_EQ] = ACTIONS(2236),
    [anon_sym_QMARK] = ACTIONS(2238),
    [anon_sym_STAR_EQ] = ACTIONS(2240),
    [anon_sym_SLASH_EQ] = ACTIONS(2240),
    [anon_sym_PERCENT_EQ] = ACTIONS(2240),
    [anon_sym_PLUS_EQ] = ACTIONS(2240),
    [anon_sym_DASH_EQ] = ACTIONS(2240),
    [anon_sym_LT_LT_EQ] = ACTIONS(2240),
    [anon_sym_GT_GT_EQ] = ACTIONS(2240),
    [anon_sym_AMP_EQ] = ACTIONS(2240),
    [anon_sym_CARET_EQ] = ACTIONS(2240),
    [anon_sym_PIPE_EQ] = ACTIONS(2240),
    [anon_sym_AMP] = ACTIONS(2242),
    [anon_sym_PIPE_PIPE] = ACTIONS(2244),
    [anon_sym_AMP_AMP] = ACTIONS(2246),
    [anon_sym_PIPE] = ACTIONS(2248),
    [anon_sym_CARET] = ACTIONS(2250),
    [anon_sym_EQ_EQ] = ACTIONS(2252),
    [anon_sym_BANG_EQ] = ACTIONS(2252),
    [anon_sym_LT] = ACTIONS(2254),
    [anon_sym_GT] = ACTIONS(2254),
    [anon_sym_LT_EQ] = ACTIONS(2256),
    [anon_sym_GT_EQ] = ACTIONS(2256),
    [anon_sym_LT_LT] = ACTIONS(2258),
    [anon_sym_GT_GT] = ACTIONS(2258),
    [anon_sym_PLUS] = ACTIONS(2260),
    [anon_sym_DASH] = ACTIONS(2260),
    [anon_sym_SLASH] = ACTIONS(2234),
    [anon_sym_PERCENT] = ACTIONS(2234),
    [anon_sym_DASH_DASH] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(1554),
    [anon_sym_DASH_GT] = ACTIONS(1554),
    [sym_comment] = ACTIONS(49),
  },
  [2953] = {
    [sym__expression] = STATE(3035),
    [sym_conditional_expression] = STATE(3035),
    [sym_assignment_expression] = STATE(3035),
    [sym_pointer_expression] = STATE(3035),
    [sym_logical_expression] = STATE(3035),
    [sym_bitwise_expression] = STATE(3035),
    [sym_equality_expression] = STATE(3035),
    [sym_relational_expression] = STATE(3035),
    [sym_shift_expression] = STATE(3035),
    [sym_math_expression] = STATE(3035),
    [sym_cast_expression] = STATE(3035),
    [sym_sizeof_expression] = STATE(3035),
    [sym_subscript_expression] = STATE(3035),
    [sym_call_expression] = STATE(3035),
    [sym_field_expression] = STATE(3035),
    [sym_compound_literal_expression] = STATE(3035),
    [sym_parenthesized_expression] = STATE(3035),
    [sym_concatenated_string] = STATE(3035),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(3035),
    [sym_new_expression] = STATE(3035),
    [sym_delete_expression] = STATE(3035),
    [sym_lambda_expression] = STATE(3035),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(7132),
    [anon_sym_LPAREN] = ACTIONS(1087),
    [anon_sym_RPAREN] = ACTIONS(7130),
    [anon_sym_STAR] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_AMP] = ACTIONS(1089),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1093),
    [anon_sym_PLUS] = ACTIONS(1095),
    [anon_sym_DASH] = ACTIONS(1095),
    [anon_sym_DASH_DASH] = ACTIONS(1097),
    [anon_sym_PLUS_PLUS] = ACTIONS(1097),
    [anon_sym_sizeof] = ACTIONS(1099),
    [sym_number_literal] = ACTIONS(7132),
    [sym_char_literal] = ACTIONS(7132),
    [sym_string_literal] = ACTIONS(1101),
    [sym_true] = ACTIONS(7134),
    [sym_false] = ACTIONS(7134),
    [sym_null] = ACTIONS(7134),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_delete] = ACTIONS(1109),
    [sym_nullptr] = ACTIONS(7134),
  },
  [2954] = {
    [sym_compound_statement] = STATE(3036),
    [sym_labeled_statement] = STATE(3036),
    [sym_expression_statement] = STATE(3036),
    [sym_if_statement] = STATE(3036),
    [sym_switch_statement] = STATE(3036),
    [sym_case_statement] = STATE(3036),
    [sym_while_statement] = STATE(3036),
    [sym_do_statement] = STATE(3036),
    [sym_for_statement] = STATE(3036),
    [sym_return_statement] = STATE(3036),
    [sym_break_statement] = STATE(3036),
    [sym_continue_statement] = STATE(3036),
    [sym_goto_statement] = STATE(3036),
    [sym__expression] = STATE(1947),
    [sym_comma_expression] = STATE(1948),
    [sym_conditional_expression] = STATE(1947),
    [sym_assignment_expression] = STATE(1947),
    [sym_pointer_expression] = STATE(1947),
    [sym_logical_expression] = STATE(1947),
    [sym_bitwise_expression] = STATE(1947),
    [sym_equality_expression] = STATE(1947),
    [sym_relational_expression] = STATE(1947),
    [sym_shift_expression] = STATE(1947),
    [sym_math_expression] = STATE(1947),
    [sym_cast_expression] = STATE(1947),
    [sym_sizeof_expression] = STATE(1947),
    [sym_subscript_expression] = STATE(1947),
    [sym_call_expression] = STATE(1947),
    [sym_field_expression] = STATE(1947),
    [sym_compound_literal_expression] = STATE(1947),
    [sym_parenthesized_expression] = STATE(1947),
    [sym_concatenated_string] = STATE(1947),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(1947),
    [sym_for_range_loop] = STATE(3036),
    [sym_new_expression] = STATE(1947),
    [sym_delete_expression] = STATE(1947),
    [sym_lambda_expression] = STATE(1947),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(4395),
    [anon_sym_LPAREN] = ACTIONS(626),
    [anon_sym_SEMI] = ACTIONS(4411),
    [anon_sym_LBRACE] = ACTIONS(4415),
    [anon_sym_STAR] = ACTIONS(644),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_if] = ACTIONS(4417),
    [anon_sym_switch] = ACTIONS(4419),
    [anon_sym_case] = ACTIONS(4421),
    [anon_sym_default] = ACTIONS(4423),
    [anon_sym_while] = ACTIONS(4425),
    [anon_sym_do] = ACTIONS(4427),
    [anon_sym_for] = ACTIONS(4429),
    [anon_sym_return] = ACTIONS(4431),
    [anon_sym_break] = ACTIONS(4433),
    [anon_sym_continue] = ACTIONS(4435),
    [anon_sym_goto] = ACTIONS(4437),
    [anon_sym_AMP] = ACTIONS(644),
    [anon_sym_BANG] = ACTIONS(668),
    [anon_sym_TILDE] = ACTIONS(670),
    [anon_sym_PLUS] = ACTIONS(672),
    [anon_sym_DASH] = ACTIONS(672),
    [anon_sym_DASH_DASH] = ACTIONS(674),
    [anon_sym_PLUS_PLUS] = ACTIONS(674),
    [anon_sym_sizeof] = ACTIONS(676),
    [sym_number_literal] = ACTIONS(4395),
    [sym_char_literal] = ACTIONS(4395),
    [sym_string_literal] = ACTIONS(678),
    [sym_true] = ACTIONS(4439),
    [sym_false] = ACTIONS(4439),
    [sym_null] = ACTIONS(4439),
    [sym_identifier] = ACTIONS(6077),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1303),
    [anon_sym_delete] = ACTIONS(686),
    [sym_nullptr] = ACTIONS(4439),
  },
  [2955] = {
    [sym_raw_string_literal] = ACTIONS(3182),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3184),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3184),
    [anon_sym_LPAREN] = ACTIONS(3182),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3184),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3184),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3184),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3184),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(3184),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(3184),
    [sym_preproc_directive] = ACTIONS(3184),
    [anon_sym_SEMI] = ACTIONS(3182),
    [anon_sym_typedef] = ACTIONS(3184),
    [anon_sym_extern] = ACTIONS(3184),
    [anon_sym_LBRACE] = ACTIONS(3182),
    [anon_sym_STAR] = ACTIONS(3182),
    [anon_sym_LBRACK] = ACTIONS(3182),
    [anon_sym_static] = ACTIONS(3184),
    [anon_sym_register] = ACTIONS(3184),
    [anon_sym_inline] = ACTIONS(3184),
    [anon_sym_const] = ACTIONS(3184),
    [anon_sym_restrict] = ACTIONS(3184),
    [anon_sym_volatile] = ACTIONS(3184),
    [anon_sym__Atomic] = ACTIONS(3184),
    [anon_sym_mutable] = ACTIONS(3184),
    [anon_sym_explicit] = ACTIONS(3184),
    [anon_sym_constexpr] = ACTIONS(3184),
    [anon_sym_unsigned] = ACTIONS(3184),
    [anon_sym_long] = ACTIONS(3184),
    [anon_sym_short] = ACTIONS(3184),
    [sym_primitive_type] = ACTIONS(3184),
    [anon_sym_enum] = ACTIONS(3184),
    [anon_sym_struct] = ACTIONS(3184),
    [anon_sym_union] = ACTIONS(3184),
    [anon_sym_if] = ACTIONS(3184),
    [anon_sym_else] = ACTIONS(3184),
    [anon_sym_switch] = ACTIONS(3184),
    [anon_sym_case] = ACTIONS(3184),
    [anon_sym_default] = ACTIONS(3184),
    [anon_sym_while] = ACTIONS(3184),
    [anon_sym_do] = ACTIONS(3184),
    [anon_sym_for] = ACTIONS(3184),
    [anon_sym_return] = ACTIONS(3184),
    [anon_sym_break] = ACTIONS(3184),
    [anon_sym_continue] = ACTIONS(3184),
    [anon_sym_goto] = ACTIONS(3184),
    [anon_sym_AMP] = ACTIONS(3182),
    [anon_sym_BANG] = ACTIONS(3182),
    [anon_sym_TILDE] = ACTIONS(3182),
    [anon_sym_PLUS] = ACTIONS(3184),
    [anon_sym_DASH] = ACTIONS(3184),
    [anon_sym_DASH_DASH] = ACTIONS(3182),
    [anon_sym_PLUS_PLUS] = ACTIONS(3182),
    [anon_sym_sizeof] = ACTIONS(3184),
    [sym_number_literal] = ACTIONS(3182),
    [sym_char_literal] = ACTIONS(3182),
    [sym_string_literal] = ACTIONS(3182),
    [sym_true] = ACTIONS(3184),
    [sym_false] = ACTIONS(3184),
    [sym_null] = ACTIONS(3184),
    [sym_identifier] = ACTIONS(3184),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(3184),
    [sym_auto] = ACTIONS(3184),
    [anon_sym_typename] = ACTIONS(3184),
    [anon_sym_new] = ACTIONS(3184),
    [anon_sym_COLON_COLON] = ACTIONS(3182),
    [anon_sym_delete] = ACTIONS(3184),
    [sym_nullptr] = ACTIONS(3184),
  },
  [2956] = {
    [sym_argument_list] = STATE(802),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_RPAREN] = ACTIONS(7136),
    [anon_sym_STAR] = ACTIONS(4537),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_EQ] = ACTIONS(4539),
    [anon_sym_QMARK] = ACTIONS(4541),
    [anon_sym_STAR_EQ] = ACTIONS(4543),
    [anon_sym_SLASH_EQ] = ACTIONS(4543),
    [anon_sym_PERCENT_EQ] = ACTIONS(4543),
    [anon_sym_PLUS_EQ] = ACTIONS(4543),
    [anon_sym_DASH_EQ] = ACTIONS(4543),
    [anon_sym_LT_LT_EQ] = ACTIONS(4543),
    [anon_sym_GT_GT_EQ] = ACTIONS(4543),
    [anon_sym_AMP_EQ] = ACTIONS(4543),
    [anon_sym_CARET_EQ] = ACTIONS(4543),
    [anon_sym_PIPE_EQ] = ACTIONS(4543),
    [anon_sym_AMP] = ACTIONS(4545),
    [anon_sym_PIPE_PIPE] = ACTIONS(4547),
    [anon_sym_AMP_AMP] = ACTIONS(4549),
    [anon_sym_PIPE] = ACTIONS(4551),
    [anon_sym_CARET] = ACTIONS(4553),
    [anon_sym_EQ_EQ] = ACTIONS(4555),
    [anon_sym_BANG_EQ] = ACTIONS(4555),
    [anon_sym_LT] = ACTIONS(4557),
    [anon_sym_GT] = ACTIONS(4557),
    [anon_sym_LT_EQ] = ACTIONS(4559),
    [anon_sym_GT_EQ] = ACTIONS(4559),
    [anon_sym_LT_LT] = ACTIONS(4561),
    [anon_sym_GT_GT] = ACTIONS(4561),
    [anon_sym_PLUS] = ACTIONS(4563),
    [anon_sym_DASH] = ACTIONS(4563),
    [anon_sym_SLASH] = ACTIONS(4537),
    [anon_sym_PERCENT] = ACTIONS(4537),
    [anon_sym_DASH_DASH] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(1554),
    [anon_sym_DASH_GT] = ACTIONS(1554),
    [sym_comment] = ACTIONS(49),
  },
  [2957] = {
    [sym__expression] = STATE(3038),
    [sym_conditional_expression] = STATE(3038),
    [sym_assignment_expression] = STATE(3038),
    [sym_pointer_expression] = STATE(3038),
    [sym_logical_expression] = STATE(3038),
    [sym_bitwise_expression] = STATE(3038),
    [sym_equality_expression] = STATE(3038),
    [sym_relational_expression] = STATE(3038),
    [sym_shift_expression] = STATE(3038),
    [sym_math_expression] = STATE(3038),
    [sym_cast_expression] = STATE(3038),
    [sym_sizeof_expression] = STATE(3038),
    [sym_subscript_expression] = STATE(3038),
    [sym_call_expression] = STATE(3038),
    [sym_field_expression] = STATE(3038),
    [sym_compound_literal_expression] = STATE(3038),
    [sym_parenthesized_expression] = STATE(3038),
    [sym_concatenated_string] = STATE(3038),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(3038),
    [sym_new_expression] = STATE(3038),
    [sym_delete_expression] = STATE(3038),
    [sym_lambda_expression] = STATE(3038),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(7138),
    [anon_sym_LPAREN] = ACTIONS(2943),
    [anon_sym_STAR] = ACTIONS(2945),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_AMP] = ACTIONS(2945),
    [anon_sym_BANG] = ACTIONS(2947),
    [anon_sym_TILDE] = ACTIONS(2949),
    [anon_sym_PLUS] = ACTIONS(2951),
    [anon_sym_DASH] = ACTIONS(2951),
    [anon_sym_DASH_DASH] = ACTIONS(2953),
    [anon_sym_PLUS_PLUS] = ACTIONS(2953),
    [anon_sym_sizeof] = ACTIONS(2955),
    [sym_number_literal] = ACTIONS(7138),
    [sym_char_literal] = ACTIONS(7138),
    [sym_string_literal] = ACTIONS(2957),
    [sym_true] = ACTIONS(7140),
    [sym_false] = ACTIONS(7140),
    [sym_null] = ACTIONS(7140),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(2961),
    [anon_sym_delete] = ACTIONS(2963),
    [sym_nullptr] = ACTIONS(7140),
  },
  [2958] = {
    [sym_argument_list] = STATE(802),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_RPAREN] = ACTIONS(7142),
    [anon_sym_STAR] = ACTIONS(4537),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_EQ] = ACTIONS(4539),
    [anon_sym_QMARK] = ACTIONS(4541),
    [anon_sym_STAR_EQ] = ACTIONS(4543),
    [anon_sym_SLASH_EQ] = ACTIONS(4543),
    [anon_sym_PERCENT_EQ] = ACTIONS(4543),
    [anon_sym_PLUS_EQ] = ACTIONS(4543),
    [anon_sym_DASH_EQ] = ACTIONS(4543),
    [anon_sym_LT_LT_EQ] = ACTIONS(4543),
    [anon_sym_GT_GT_EQ] = ACTIONS(4543),
    [anon_sym_AMP_EQ] = ACTIONS(4543),
    [anon_sym_CARET_EQ] = ACTIONS(4543),
    [anon_sym_PIPE_EQ] = ACTIONS(4543),
    [anon_sym_AMP] = ACTIONS(4545),
    [anon_sym_PIPE_PIPE] = ACTIONS(4547),
    [anon_sym_AMP_AMP] = ACTIONS(4549),
    [anon_sym_PIPE] = ACTIONS(4551),
    [anon_sym_CARET] = ACTIONS(4553),
    [anon_sym_EQ_EQ] = ACTIONS(4555),
    [anon_sym_BANG_EQ] = ACTIONS(4555),
    [anon_sym_LT] = ACTIONS(4557),
    [anon_sym_GT] = ACTIONS(4557),
    [anon_sym_LT_EQ] = ACTIONS(4559),
    [anon_sym_GT_EQ] = ACTIONS(4559),
    [anon_sym_LT_LT] = ACTIONS(4561),
    [anon_sym_GT_GT] = ACTIONS(4561),
    [anon_sym_PLUS] = ACTIONS(4563),
    [anon_sym_DASH] = ACTIONS(4563),
    [anon_sym_SLASH] = ACTIONS(4537),
    [anon_sym_PERCENT] = ACTIONS(4537),
    [anon_sym_DASH_DASH] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(1554),
    [anon_sym_DASH_GT] = ACTIONS(1554),
    [sym_comment] = ACTIONS(49),
  },
  [2959] = {
    [sym_declaration] = STATE(3040),
    [sym_type_definition] = STATE(3040),
    [sym__declaration_specifiers] = STATE(2963),
    [sym_compound_statement] = STATE(3040),
    [sym_storage_class_specifier] = STATE(109),
    [sym_type_qualifier] = STATE(109),
    [sym__type_specifier] = STATE(105),
    [sym_sized_type_specifier] = STATE(105),
    [sym_enum_specifier] = STATE(105),
    [sym_struct_specifier] = STATE(105),
    [sym_union_specifier] = STATE(105),
    [sym_labeled_statement] = STATE(3040),
    [sym_expression_statement] = STATE(3040),
    [sym_if_statement] = STATE(3040),
    [sym_switch_statement] = STATE(3040),
    [sym_case_statement] = STATE(3040),
    [sym_while_statement] = STATE(3040),
    [sym_do_statement] = STATE(3040),
    [sym_for_statement] = STATE(3040),
    [sym_return_statement] = STATE(3040),
    [sym_break_statement] = STATE(3040),
    [sym_continue_statement] = STATE(3040),
    [sym_goto_statement] = STATE(3040),
    [sym__expression] = STATE(2739),
    [sym_comma_expression] = STATE(2740),
    [sym_conditional_expression] = STATE(2739),
    [sym_assignment_expression] = STATE(2739),
    [sym_pointer_expression] = STATE(2739),
    [sym_logical_expression] = STATE(2739),
    [sym_bitwise_expression] = STATE(2739),
    [sym_equality_expression] = STATE(2739),
    [sym_relational_expression] = STATE(2739),
    [sym_shift_expression] = STATE(2739),
    [sym_math_expression] = STATE(2739),
    [sym_cast_expression] = STATE(2739),
    [sym_sizeof_expression] = STATE(2739),
    [sym_subscript_expression] = STATE(2739),
    [sym_call_expression] = STATE(2739),
    [sym_field_expression] = STATE(2739),
    [sym_compound_literal_expression] = STATE(2739),
    [sym_parenthesized_expression] = STATE(2739),
    [sym_concatenated_string] = STATE(2739),
    [sym_macro_type_specifier] = STATE(105),
    [sym_class_specifier] = STATE(105),
    [sym_dependent_type] = STATE(105),
    [sym_template_type] = STATE(1475),
    [sym_template_function] = STATE(2739),
    [sym_for_range_loop] = STATE(3040),
    [sym_new_expression] = STATE(2739),
    [sym_delete_expression] = STATE(2739),
    [sym_lambda_expression] = STATE(2739),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(416),
    [sym_scoped_namespace_identifier] = STATE(1476),
    [aux_sym__declaration_specifiers_repeat1] = STATE(109),
    [aux_sym_sized_type_specifier_repeat1] = STATE(110),
    [sym_raw_string_literal] = ACTIONS(6507),
    [anon_sym_LPAREN] = ACTIONS(626),
    [anon_sym_SEMI] = ACTIONS(6509),
    [anon_sym_typedef] = ACTIONS(7003),
    [anon_sym_extern] = ACTIONS(154),
    [anon_sym_LBRACE] = ACTIONS(6511),
    [anon_sym_STAR] = ACTIONS(644),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_static] = ACTIONS(154),
    [anon_sym_register] = ACTIONS(154),
    [anon_sym_inline] = ACTIONS(154),
    [anon_sym_const] = ACTIONS(158),
    [anon_sym_restrict] = ACTIONS(158),
    [anon_sym_volatile] = ACTIONS(158),
    [anon_sym__Atomic] = ACTIONS(158),
    [anon_sym_mutable] = ACTIONS(158),
    [anon_sym_explicit] = ACTIONS(158),
    [anon_sym_constexpr] = ACTIONS(158),
    [anon_sym_unsigned] = ACTIONS(160),
    [anon_sym_long] = ACTIONS(160),
    [anon_sym_short] = ACTIONS(160),
    [sym_primitive_type] = ACTIONS(162),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_union] = ACTIONS(39),
    [anon_sym_if] = ACTIONS(6513),
    [anon_sym_switch] = ACTIONS(6515),
    [anon_sym_case] = ACTIONS(6517),
    [anon_sym_default] = ACTIONS(6519),
    [anon_sym_while] = ACTIONS(6521),
    [anon_sym_do] = ACTIONS(6523),
    [anon_sym_for] = ACTIONS(6525),
    [anon_sym_return] = ACTIONS(6527),
    [anon_sym_break] = ACTIONS(6529),
    [anon_sym_continue] = ACTIONS(6531),
    [anon_sym_goto] = ACTIONS(6533),
    [anon_sym_AMP] = ACTIONS(644),
    [anon_sym_BANG] = ACTIONS(668),
    [anon_sym_TILDE] = ACTIONS(670),
    [anon_sym_PLUS] = ACTIONS(672),
    [anon_sym_DASH] = ACTIONS(672),
    [anon_sym_DASH_DASH] = ACTIONS(674),
    [anon_sym_PLUS_PLUS] = ACTIONS(674),
    [anon_sym_sizeof] = ACTIONS(676),
    [sym_number_literal] = ACTIONS(6507),
    [sym_char_literal] = ACTIONS(6507),
    [sym_string_literal] = ACTIONS(678),
    [sym_true] = ACTIONS(6535),
    [sym_false] = ACTIONS(6535),
    [sym_null] = ACTIONS(6535),
    [sym_identifier] = ACTIONS(7005),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(51),
    [sym_auto] = ACTIONS(162),
    [anon_sym_typename] = ACTIONS(172),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(3040),
    [anon_sym_delete] = ACTIONS(686),
    [sym_nullptr] = ACTIONS(6535),
  },
  [2960] = {
    [sym_type_qualifier] = STATE(3042),
    [sym__type_specifier] = STATE(3041),
    [sym_sized_type_specifier] = STATE(3041),
    [sym_enum_specifier] = STATE(3041),
    [sym_struct_specifier] = STATE(3041),
    [sym_union_specifier] = STATE(3041),
    [sym_macro_type_specifier] = STATE(3041),
    [sym_class_specifier] = STATE(3041),
    [sym_dependent_type] = STATE(3041),
    [sym_template_type] = STATE(62),
    [sym_scoped_type_identifier] = STATE(63),
    [sym_scoped_namespace_identifier] = STATE(64),
    [aux_sym_type_definition_repeat1] = STATE(3042),
    [aux_sym_sized_type_specifier_repeat1] = STATE(66),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_restrict] = ACTIONS(93),
    [anon_sym_volatile] = ACTIONS(93),
    [anon_sym__Atomic] = ACTIONS(93),
    [anon_sym_mutable] = ACTIONS(93),
    [anon_sym_explicit] = ACTIONS(93),
    [anon_sym_constexpr] = ACTIONS(93),
    [anon_sym_unsigned] = ACTIONS(95),
    [anon_sym_long] = ACTIONS(95),
    [anon_sym_short] = ACTIONS(95),
    [sym_primitive_type] = ACTIONS(7144),
    [anon_sym_enum] = ACTIONS(99),
    [anon_sym_struct] = ACTIONS(101),
    [anon_sym_union] = ACTIONS(103),
    [sym_identifier] = ACTIONS(105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(107),
    [sym_auto] = ACTIONS(7144),
    [anon_sym_typename] = ACTIONS(109),
    [anon_sym_COLON_COLON] = ACTIONS(111),
  },
  [2961] = {
    [sym_initializer_list] = STATE(765),
    [sym_template_argument_list] = STATE(2039),
    [anon_sym_LPAREN] = ACTIONS(1483),
    [anon_sym_COMMA] = ACTIONS(1477),
    [anon_sym_SEMI] = ACTIONS(1477),
    [anon_sym_extern] = ACTIONS(144),
    [anon_sym_LBRACE] = ACTIONS(548),
    [anon_sym_STAR] = ACTIONS(1486),
    [anon_sym_LBRACK] = ACTIONS(1477),
    [anon_sym_EQ] = ACTIONS(1479),
    [anon_sym_static] = ACTIONS(144),
    [anon_sym_register] = ACTIONS(144),
    [anon_sym_inline] = ACTIONS(144),
    [anon_sym_const] = ACTIONS(144),
    [anon_sym_restrict] = ACTIONS(144),
    [anon_sym_volatile] = ACTIONS(144),
    [anon_sym__Atomic] = ACTIONS(144),
    [anon_sym_mutable] = ACTIONS(144),
    [anon_sym_explicit] = ACTIONS(144),
    [anon_sym_constexpr] = ACTIONS(144),
    [anon_sym_COLON] = ACTIONS(6820),
    [anon_sym_QMARK] = ACTIONS(1477),
    [anon_sym_STAR_EQ] = ACTIONS(1477),
    [anon_sym_SLASH_EQ] = ACTIONS(1477),
    [anon_sym_PERCENT_EQ] = ACTIONS(1477),
    [anon_sym_PLUS_EQ] = ACTIONS(1477),
    [anon_sym_DASH_EQ] = ACTIONS(1477),
    [anon_sym_LT_LT_EQ] = ACTIONS(1477),
    [anon_sym_GT_GT_EQ] = ACTIONS(1477),
    [anon_sym_AMP_EQ] = ACTIONS(1477),
    [anon_sym_CARET_EQ] = ACTIONS(1477),
    [anon_sym_PIPE_EQ] = ACTIONS(1477),
    [anon_sym_AMP] = ACTIONS(1486),
    [anon_sym_PIPE_PIPE] = ACTIONS(1477),
    [anon_sym_AMP_AMP] = ACTIONS(1483),
    [anon_sym_PIPE] = ACTIONS(1479),
    [anon_sym_CARET] = ACTIONS(1479),
    [anon_sym_TILDE] = ACTIONS(142),
    [anon_sym_EQ_EQ] = ACTIONS(1477),
    [anon_sym_BANG_EQ] = ACTIONS(1477),
    [anon_sym_LT] = ACTIONS(1564),
    [anon_sym_GT] = ACTIONS(1479),
    [anon_sym_LT_EQ] = ACTIONS(1477),
    [anon_sym_GT_EQ] = ACTIONS(1477),
    [anon_sym_LT_LT] = ACTIONS(1479),
    [anon_sym_GT_GT] = ACTIONS(1479),
    [anon_sym_PLUS] = ACTIONS(1479),
    [anon_sym_DASH] = ACTIONS(1479),
    [anon_sym_SLASH] = ACTIONS(1479),
    [anon_sym_PERCENT] = ACTIONS(1479),
    [anon_sym_DASH_DASH] = ACTIONS(1477),
    [anon_sym_PLUS_PLUS] = ACTIONS(1477),
    [anon_sym_DOT] = ACTIONS(1477),
    [anon_sym_DASH_GT] = ACTIONS(1477),
    [sym_identifier] = ACTIONS(144),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(4631),
    [sym_operator_name] = ACTIONS(142),
  },
  [2962] = {
    [sym_raw_string_literal] = ACTIONS(4635),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(4637),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(4637),
    [anon_sym_LPAREN] = ACTIONS(4635),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(4637),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(4637),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(4637),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(4637),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(4637),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(4637),
    [sym_preproc_directive] = ACTIONS(4637),
    [anon_sym_SEMI] = ACTIONS(4635),
    [anon_sym_typedef] = ACTIONS(4637),
    [anon_sym_extern] = ACTIONS(4637),
    [anon_sym_LBRACE] = ACTIONS(4635),
    [anon_sym_STAR] = ACTIONS(4635),
    [anon_sym_LBRACK] = ACTIONS(4635),
    [anon_sym_static] = ACTIONS(4637),
    [anon_sym_register] = ACTIONS(4637),
    [anon_sym_inline] = ACTIONS(4637),
    [anon_sym_const] = ACTIONS(4637),
    [anon_sym_restrict] = ACTIONS(4637),
    [anon_sym_volatile] = ACTIONS(4637),
    [anon_sym__Atomic] = ACTIONS(4637),
    [anon_sym_mutable] = ACTIONS(4637),
    [anon_sym_explicit] = ACTIONS(4637),
    [anon_sym_constexpr] = ACTIONS(4637),
    [anon_sym_unsigned] = ACTIONS(4637),
    [anon_sym_long] = ACTIONS(4637),
    [anon_sym_short] = ACTIONS(4637),
    [sym_primitive_type] = ACTIONS(4637),
    [anon_sym_enum] = ACTIONS(4637),
    [anon_sym_struct] = ACTIONS(4637),
    [anon_sym_union] = ACTIONS(4637),
    [anon_sym_if] = ACTIONS(4637),
    [anon_sym_else] = ACTIONS(4637),
    [anon_sym_switch] = ACTIONS(4637),
    [anon_sym_case] = ACTIONS(4637),
    [anon_sym_default] = ACTIONS(4637),
    [anon_sym_while] = ACTIONS(4637),
    [anon_sym_do] = ACTIONS(4637),
    [anon_sym_for] = ACTIONS(4637),
    [anon_sym_return] = ACTIONS(4637),
    [anon_sym_break] = ACTIONS(4637),
    [anon_sym_continue] = ACTIONS(4637),
    [anon_sym_goto] = ACTIONS(4637),
    [anon_sym_AMP] = ACTIONS(4635),
    [anon_sym_BANG] = ACTIONS(4635),
    [anon_sym_TILDE] = ACTIONS(4635),
    [anon_sym_PLUS] = ACTIONS(4637),
    [anon_sym_DASH] = ACTIONS(4637),
    [anon_sym_DASH_DASH] = ACTIONS(4635),
    [anon_sym_PLUS_PLUS] = ACTIONS(4635),
    [anon_sym_sizeof] = ACTIONS(4637),
    [sym_number_literal] = ACTIONS(4635),
    [sym_char_literal] = ACTIONS(4635),
    [sym_string_literal] = ACTIONS(4635),
    [sym_true] = ACTIONS(4637),
    [sym_false] = ACTIONS(4637),
    [sym_null] = ACTIONS(4637),
    [sym_identifier] = ACTIONS(4637),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(4637),
    [sym_auto] = ACTIONS(4637),
    [anon_sym_typename] = ACTIONS(4637),
    [anon_sym_new] = ACTIONS(4637),
    [anon_sym_COLON_COLON] = ACTIONS(4635),
    [anon_sym_delete] = ACTIONS(4637),
    [sym_nullptr] = ACTIONS(4637),
  },
  [2963] = {
    [sym__declarator] = STATE(3043),
    [sym_pointer_declarator] = STATE(3043),
    [sym_function_declarator] = STATE(3043),
    [sym_array_declarator] = STATE(3043),
    [sym_init_declarator] = STATE(3044),
    [sym_reference_declarator] = STATE(3043),
    [sym_template_type] = STATE(46),
    [sym_template_function] = STATE(3043),
    [sym_destructor_name] = STATE(3043),
    [sym_scoped_identifier] = STATE(33),
    [sym_scoped_type_identifier] = STATE(47),
    [sym_scoped_namespace_identifier] = STATE(46),
    [anon_sym_LPAREN] = ACTIONS(11),
    [anon_sym_STAR] = ACTIONS(196),
    [anon_sym_AMP] = ACTIONS(526),
    [anon_sym_AMP_AMP] = ACTIONS(528),
    [anon_sym_TILDE] = ACTIONS(45),
    [sym_identifier] = ACTIONS(75),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(77),
    [sym_operator_name] = ACTIONS(7146),
  },
  [2964] = {
    [sym_argument_list] = STATE(802),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_RPAREN] = ACTIONS(7148),
    [anon_sym_STAR] = ACTIONS(4537),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_EQ] = ACTIONS(4539),
    [anon_sym_QMARK] = ACTIONS(4541),
    [anon_sym_STAR_EQ] = ACTIONS(4543),
    [anon_sym_SLASH_EQ] = ACTIONS(4543),
    [anon_sym_PERCENT_EQ] = ACTIONS(4543),
    [anon_sym_PLUS_EQ] = ACTIONS(4543),
    [anon_sym_DASH_EQ] = ACTIONS(4543),
    [anon_sym_LT_LT_EQ] = ACTIONS(4543),
    [anon_sym_GT_GT_EQ] = ACTIONS(4543),
    [anon_sym_AMP_EQ] = ACTIONS(4543),
    [anon_sym_CARET_EQ] = ACTIONS(4543),
    [anon_sym_PIPE_EQ] = ACTIONS(4543),
    [anon_sym_AMP] = ACTIONS(4545),
    [anon_sym_PIPE_PIPE] = ACTIONS(4547),
    [anon_sym_AMP_AMP] = ACTIONS(4549),
    [anon_sym_PIPE] = ACTIONS(4551),
    [anon_sym_CARET] = ACTIONS(4553),
    [anon_sym_EQ_EQ] = ACTIONS(4555),
    [anon_sym_BANG_EQ] = ACTIONS(4555),
    [anon_sym_LT] = ACTIONS(4557),
    [anon_sym_GT] = ACTIONS(4557),
    [anon_sym_LT_EQ] = ACTIONS(4559),
    [anon_sym_GT_EQ] = ACTIONS(4559),
    [anon_sym_LT_LT] = ACTIONS(4561),
    [anon_sym_GT_GT] = ACTIONS(4561),
    [anon_sym_PLUS] = ACTIONS(4563),
    [anon_sym_DASH] = ACTIONS(4563),
    [anon_sym_SLASH] = ACTIONS(4537),
    [anon_sym_PERCENT] = ACTIONS(4537),
    [anon_sym_DASH_DASH] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(1554),
    [anon_sym_DASH_GT] = ACTIONS(1554),
    [sym_comment] = ACTIONS(49),
  },
  [2965] = {
    [anon_sym_LPAREN] = ACTIONS(7150),
    [sym_comment] = ACTIONS(49),
  },
  [2966] = {
    [sym__expression] = STATE(3048),
    [sym_conditional_expression] = STATE(3048),
    [sym_assignment_expression] = STATE(3048),
    [sym_pointer_expression] = STATE(3048),
    [sym_logical_expression] = STATE(3048),
    [sym_bitwise_expression] = STATE(3048),
    [sym_equality_expression] = STATE(3048),
    [sym_relational_expression] = STATE(3048),
    [sym_shift_expression] = STATE(3048),
    [sym_math_expression] = STATE(3048),
    [sym_cast_expression] = STATE(3048),
    [sym_sizeof_expression] = STATE(3048),
    [sym_subscript_expression] = STATE(3048),
    [sym_call_expression] = STATE(3048),
    [sym_field_expression] = STATE(3048),
    [sym_compound_literal_expression] = STATE(3048),
    [sym_parenthesized_expression] = STATE(3048),
    [sym_concatenated_string] = STATE(3048),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(3048),
    [sym_new_expression] = STATE(3048),
    [sym_delete_expression] = STATE(3048),
    [sym_lambda_expression] = STATE(3048),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(7152),
    [anon_sym_LPAREN] = ACTIONS(1347),
    [anon_sym_SEMI] = ACTIONS(7154),
    [anon_sym_STAR] = ACTIONS(1349),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_AMP] = ACTIONS(1349),
    [anon_sym_BANG] = ACTIONS(1351),
    [anon_sym_TILDE] = ACTIONS(1353),
    [anon_sym_PLUS] = ACTIONS(1355),
    [anon_sym_DASH] = ACTIONS(1355),
    [anon_sym_DASH_DASH] = ACTIONS(1357),
    [anon_sym_PLUS_PLUS] = ACTIONS(1357),
    [anon_sym_sizeof] = ACTIONS(1359),
    [sym_number_literal] = ACTIONS(7152),
    [sym_char_literal] = ACTIONS(7152),
    [sym_string_literal] = ACTIONS(1361),
    [sym_true] = ACTIONS(7156),
    [sym_false] = ACTIONS(7156),
    [sym_null] = ACTIONS(7156),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1365),
    [anon_sym_delete] = ACTIONS(1367),
    [sym_nullptr] = ACTIONS(7156),
  },
  [2967] = {
    [sym_argument_list] = STATE(802),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_SEMI] = ACTIONS(7158),
    [anon_sym_STAR] = ACTIONS(2553),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_EQ] = ACTIONS(2555),
    [anon_sym_QMARK] = ACTIONS(2557),
    [anon_sym_STAR_EQ] = ACTIONS(2559),
    [anon_sym_SLASH_EQ] = ACTIONS(2559),
    [anon_sym_PERCENT_EQ] = ACTIONS(2559),
    [anon_sym_PLUS_EQ] = ACTIONS(2559),
    [anon_sym_DASH_EQ] = ACTIONS(2559),
    [anon_sym_LT_LT_EQ] = ACTIONS(2559),
    [anon_sym_GT_GT_EQ] = ACTIONS(2559),
    [anon_sym_AMP_EQ] = ACTIONS(2559),
    [anon_sym_CARET_EQ] = ACTIONS(2559),
    [anon_sym_PIPE_EQ] = ACTIONS(2559),
    [anon_sym_AMP] = ACTIONS(2561),
    [anon_sym_PIPE_PIPE] = ACTIONS(2563),
    [anon_sym_AMP_AMP] = ACTIONS(2565),
    [anon_sym_PIPE] = ACTIONS(2567),
    [anon_sym_CARET] = ACTIONS(2569),
    [anon_sym_EQ_EQ] = ACTIONS(2571),
    [anon_sym_BANG_EQ] = ACTIONS(2571),
    [anon_sym_LT] = ACTIONS(2573),
    [anon_sym_GT] = ACTIONS(2573),
    [anon_sym_LT_EQ] = ACTIONS(2575),
    [anon_sym_GT_EQ] = ACTIONS(2575),
    [anon_sym_LT_LT] = ACTIONS(2577),
    [anon_sym_GT_GT] = ACTIONS(2577),
    [anon_sym_PLUS] = ACTIONS(2579),
    [anon_sym_DASH] = ACTIONS(2579),
    [anon_sym_SLASH] = ACTIONS(2553),
    [anon_sym_PERCENT] = ACTIONS(2553),
    [anon_sym_DASH_DASH] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(1554),
    [anon_sym_DASH_GT] = ACTIONS(1554),
    [sym_comment] = ACTIONS(49),
  },
  [2968] = {
    [anon_sym_COLON] = ACTIONS(7160),
    [sym_comment] = ACTIONS(49),
  },
  [2969] = {
    [sym_raw_string_literal] = ACTIONS(4697),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(4699),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(4699),
    [anon_sym_LPAREN] = ACTIONS(4697),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(4699),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(4699),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(4699),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(4699),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(4699),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(4699),
    [sym_preproc_directive] = ACTIONS(4699),
    [anon_sym_SEMI] = ACTIONS(4697),
    [anon_sym_typedef] = ACTIONS(4699),
    [anon_sym_extern] = ACTIONS(4699),
    [anon_sym_LBRACE] = ACTIONS(4697),
    [anon_sym_STAR] = ACTIONS(4697),
    [anon_sym_LBRACK] = ACTIONS(4697),
    [anon_sym_static] = ACTIONS(4699),
    [anon_sym_register] = ACTIONS(4699),
    [anon_sym_inline] = ACTIONS(4699),
    [anon_sym_const] = ACTIONS(4699),
    [anon_sym_restrict] = ACTIONS(4699),
    [anon_sym_volatile] = ACTIONS(4699),
    [anon_sym__Atomic] = ACTIONS(4699),
    [anon_sym_mutable] = ACTIONS(4699),
    [anon_sym_explicit] = ACTIONS(4699),
    [anon_sym_constexpr] = ACTIONS(4699),
    [anon_sym_unsigned] = ACTIONS(4699),
    [anon_sym_long] = ACTIONS(4699),
    [anon_sym_short] = ACTIONS(4699),
    [sym_primitive_type] = ACTIONS(4699),
    [anon_sym_enum] = ACTIONS(4699),
    [anon_sym_struct] = ACTIONS(4699),
    [anon_sym_union] = ACTIONS(4699),
    [anon_sym_if] = ACTIONS(4699),
    [anon_sym_else] = ACTIONS(4699),
    [anon_sym_switch] = ACTIONS(4699),
    [anon_sym_case] = ACTIONS(4699),
    [anon_sym_default] = ACTIONS(4699),
    [anon_sym_while] = ACTIONS(4699),
    [anon_sym_do] = ACTIONS(4699),
    [anon_sym_for] = ACTIONS(4699),
    [anon_sym_return] = ACTIONS(4699),
    [anon_sym_break] = ACTIONS(4699),
    [anon_sym_continue] = ACTIONS(4699),
    [anon_sym_goto] = ACTIONS(4699),
    [anon_sym_AMP] = ACTIONS(4697),
    [anon_sym_BANG] = ACTIONS(4697),
    [anon_sym_TILDE] = ACTIONS(4697),
    [anon_sym_PLUS] = ACTIONS(4699),
    [anon_sym_DASH] = ACTIONS(4699),
    [anon_sym_DASH_DASH] = ACTIONS(4697),
    [anon_sym_PLUS_PLUS] = ACTIONS(4697),
    [anon_sym_sizeof] = ACTIONS(4699),
    [sym_number_literal] = ACTIONS(4697),
    [sym_char_literal] = ACTIONS(4697),
    [sym_string_literal] = ACTIONS(4697),
    [sym_true] = ACTIONS(4699),
    [sym_false] = ACTIONS(4699),
    [sym_null] = ACTIONS(4699),
    [sym_identifier] = ACTIONS(4699),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(4699),
    [sym_auto] = ACTIONS(4699),
    [anon_sym_typename] = ACTIONS(4699),
    [anon_sym_new] = ACTIONS(4699),
    [anon_sym_COLON_COLON] = ACTIONS(4697),
    [anon_sym_delete] = ACTIONS(4699),
    [sym_nullptr] = ACTIONS(4699),
  },
  [2970] = {
    [sym_raw_string_literal] = ACTIONS(4701),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(4703),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(4703),
    [anon_sym_LPAREN] = ACTIONS(4701),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(4703),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(4703),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(4703),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(4703),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(4703),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(4703),
    [sym_preproc_directive] = ACTIONS(4703),
    [anon_sym_SEMI] = ACTIONS(4701),
    [anon_sym_typedef] = ACTIONS(4703),
    [anon_sym_extern] = ACTIONS(4703),
    [anon_sym_LBRACE] = ACTIONS(4701),
    [anon_sym_STAR] = ACTIONS(4701),
    [anon_sym_LBRACK] = ACTIONS(4701),
    [anon_sym_static] = ACTIONS(4703),
    [anon_sym_register] = ACTIONS(4703),
    [anon_sym_inline] = ACTIONS(4703),
    [anon_sym_const] = ACTIONS(4703),
    [anon_sym_restrict] = ACTIONS(4703),
    [anon_sym_volatile] = ACTIONS(4703),
    [anon_sym__Atomic] = ACTIONS(4703),
    [anon_sym_mutable] = ACTIONS(4703),
    [anon_sym_explicit] = ACTIONS(4703),
    [anon_sym_constexpr] = ACTIONS(4703),
    [anon_sym_unsigned] = ACTIONS(4703),
    [anon_sym_long] = ACTIONS(4703),
    [anon_sym_short] = ACTIONS(4703),
    [sym_primitive_type] = ACTIONS(4703),
    [anon_sym_enum] = ACTIONS(4703),
    [anon_sym_struct] = ACTIONS(4703),
    [anon_sym_union] = ACTIONS(4703),
    [anon_sym_if] = ACTIONS(4703),
    [anon_sym_else] = ACTIONS(4703),
    [anon_sym_switch] = ACTIONS(4703),
    [anon_sym_case] = ACTIONS(4703),
    [anon_sym_default] = ACTIONS(4703),
    [anon_sym_while] = ACTIONS(4703),
    [anon_sym_do] = ACTIONS(4703),
    [anon_sym_for] = ACTIONS(4703),
    [anon_sym_return] = ACTIONS(4703),
    [anon_sym_break] = ACTIONS(4703),
    [anon_sym_continue] = ACTIONS(4703),
    [anon_sym_goto] = ACTIONS(4703),
    [anon_sym_AMP] = ACTIONS(4701),
    [anon_sym_BANG] = ACTIONS(4701),
    [anon_sym_TILDE] = ACTIONS(4701),
    [anon_sym_PLUS] = ACTIONS(4703),
    [anon_sym_DASH] = ACTIONS(4703),
    [anon_sym_DASH_DASH] = ACTIONS(4701),
    [anon_sym_PLUS_PLUS] = ACTIONS(4701),
    [anon_sym_sizeof] = ACTIONS(4703),
    [sym_number_literal] = ACTIONS(4701),
    [sym_char_literal] = ACTIONS(4701),
    [sym_string_literal] = ACTIONS(4701),
    [sym_true] = ACTIONS(4703),
    [sym_false] = ACTIONS(4703),
    [sym_null] = ACTIONS(4703),
    [sym_identifier] = ACTIONS(4703),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(4703),
    [sym_auto] = ACTIONS(4703),
    [anon_sym_typename] = ACTIONS(4703),
    [anon_sym_new] = ACTIONS(4703),
    [anon_sym_COLON_COLON] = ACTIONS(4701),
    [anon_sym_delete] = ACTIONS(4703),
    [sym_nullptr] = ACTIONS(4703),
  },
  [2971] = {
    [sym_raw_string_literal] = ACTIONS(4710),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(4712),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(4712),
    [anon_sym_LPAREN] = ACTIONS(4710),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(4712),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(4712),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(4712),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(4712),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(4712),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(4712),
    [sym_preproc_directive] = ACTIONS(4712),
    [anon_sym_SEMI] = ACTIONS(4710),
    [anon_sym_typedef] = ACTIONS(4712),
    [anon_sym_extern] = ACTIONS(4712),
    [anon_sym_LBRACE] = ACTIONS(4710),
    [anon_sym_STAR] = ACTIONS(4710),
    [anon_sym_LBRACK] = ACTIONS(4710),
    [anon_sym_static] = ACTIONS(4712),
    [anon_sym_register] = ACTIONS(4712),
    [anon_sym_inline] = ACTIONS(4712),
    [anon_sym_const] = ACTIONS(4712),
    [anon_sym_restrict] = ACTIONS(4712),
    [anon_sym_volatile] = ACTIONS(4712),
    [anon_sym__Atomic] = ACTIONS(4712),
    [anon_sym_mutable] = ACTIONS(4712),
    [anon_sym_explicit] = ACTIONS(4712),
    [anon_sym_constexpr] = ACTIONS(4712),
    [anon_sym_unsigned] = ACTIONS(4712),
    [anon_sym_long] = ACTIONS(4712),
    [anon_sym_short] = ACTIONS(4712),
    [sym_primitive_type] = ACTIONS(4712),
    [anon_sym_enum] = ACTIONS(4712),
    [anon_sym_struct] = ACTIONS(4712),
    [anon_sym_union] = ACTIONS(4712),
    [anon_sym_if] = ACTIONS(4712),
    [anon_sym_else] = ACTIONS(4712),
    [anon_sym_switch] = ACTIONS(4712),
    [anon_sym_case] = ACTIONS(4712),
    [anon_sym_default] = ACTIONS(4712),
    [anon_sym_while] = ACTIONS(4712),
    [anon_sym_do] = ACTIONS(4712),
    [anon_sym_for] = ACTIONS(4712),
    [anon_sym_return] = ACTIONS(4712),
    [anon_sym_break] = ACTIONS(4712),
    [anon_sym_continue] = ACTIONS(4712),
    [anon_sym_goto] = ACTIONS(4712),
    [anon_sym_AMP] = ACTIONS(4710),
    [anon_sym_BANG] = ACTIONS(4710),
    [anon_sym_TILDE] = ACTIONS(4710),
    [anon_sym_PLUS] = ACTIONS(4712),
    [anon_sym_DASH] = ACTIONS(4712),
    [anon_sym_DASH_DASH] = ACTIONS(4710),
    [anon_sym_PLUS_PLUS] = ACTIONS(4710),
    [anon_sym_sizeof] = ACTIONS(4712),
    [sym_number_literal] = ACTIONS(4710),
    [sym_char_literal] = ACTIONS(4710),
    [sym_string_literal] = ACTIONS(4710),
    [sym_true] = ACTIONS(4712),
    [sym_false] = ACTIONS(4712),
    [sym_null] = ACTIONS(4712),
    [sym_identifier] = ACTIONS(4712),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(4712),
    [sym_auto] = ACTIONS(4712),
    [anon_sym_typename] = ACTIONS(4712),
    [anon_sym_new] = ACTIONS(4712),
    [anon_sym_COLON_COLON] = ACTIONS(4710),
    [anon_sym_delete] = ACTIONS(4712),
    [sym_nullptr] = ACTIONS(4712),
  },
  [2972] = {
    [sym_raw_string_literal] = ACTIONS(6864),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(6866),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(6866),
    [anon_sym_LPAREN] = ACTIONS(6864),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(6866),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(6866),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(6866),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(6866),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(6866),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(6866),
    [sym_preproc_directive] = ACTIONS(6866),
    [anon_sym_SEMI] = ACTIONS(6864),
    [anon_sym_typedef] = ACTIONS(6866),
    [anon_sym_extern] = ACTIONS(6866),
    [anon_sym_LBRACE] = ACTIONS(6864),
    [anon_sym_STAR] = ACTIONS(6864),
    [anon_sym_LBRACK] = ACTIONS(6864),
    [anon_sym_static] = ACTIONS(6866),
    [anon_sym_register] = ACTIONS(6866),
    [anon_sym_inline] = ACTIONS(6866),
    [anon_sym_const] = ACTIONS(6866),
    [anon_sym_restrict] = ACTIONS(6866),
    [anon_sym_volatile] = ACTIONS(6866),
    [anon_sym__Atomic] = ACTIONS(6866),
    [anon_sym_mutable] = ACTIONS(6866),
    [anon_sym_explicit] = ACTIONS(6866),
    [anon_sym_constexpr] = ACTIONS(6866),
    [anon_sym_unsigned] = ACTIONS(6866),
    [anon_sym_long] = ACTIONS(6866),
    [anon_sym_short] = ACTIONS(6866),
    [sym_primitive_type] = ACTIONS(6866),
    [anon_sym_enum] = ACTIONS(6866),
    [anon_sym_struct] = ACTIONS(6866),
    [anon_sym_union] = ACTIONS(6866),
    [anon_sym_if] = ACTIONS(6866),
    [anon_sym_switch] = ACTIONS(6866),
    [anon_sym_case] = ACTIONS(6866),
    [anon_sym_default] = ACTIONS(6866),
    [anon_sym_while] = ACTIONS(6866),
    [anon_sym_do] = ACTIONS(6866),
    [anon_sym_for] = ACTIONS(6866),
    [anon_sym_return] = ACTIONS(6866),
    [anon_sym_break] = ACTIONS(6866),
    [anon_sym_continue] = ACTIONS(6866),
    [anon_sym_goto] = ACTIONS(6866),
    [anon_sym_AMP] = ACTIONS(6864),
    [anon_sym_BANG] = ACTIONS(6864),
    [anon_sym_TILDE] = ACTIONS(6864),
    [anon_sym_PLUS] = ACTIONS(6866),
    [anon_sym_DASH] = ACTIONS(6866),
    [anon_sym_DASH_DASH] = ACTIONS(6864),
    [anon_sym_PLUS_PLUS] = ACTIONS(6864),
    [anon_sym_sizeof] = ACTIONS(6866),
    [sym_number_literal] = ACTIONS(6864),
    [sym_char_literal] = ACTIONS(6864),
    [sym_string_literal] = ACTIONS(6864),
    [sym_true] = ACTIONS(6866),
    [sym_false] = ACTIONS(6866),
    [sym_null] = ACTIONS(6866),
    [sym_identifier] = ACTIONS(6866),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(6866),
    [sym_auto] = ACTIONS(6866),
    [anon_sym_typename] = ACTIONS(6866),
    [anon_sym_new] = ACTIONS(6866),
    [anon_sym_COLON_COLON] = ACTIONS(6864),
    [anon_sym_delete] = ACTIONS(6866),
    [sym_nullptr] = ACTIONS(6866),
  },
  [2973] = {
    [sym_compound_statement] = STATE(3051),
    [sym_labeled_statement] = STATE(3051),
    [sym_expression_statement] = STATE(3051),
    [sym_if_statement] = STATE(3051),
    [sym_switch_statement] = STATE(3051),
    [sym_case_statement] = STATE(3051),
    [sym_while_statement] = STATE(3051),
    [sym_do_statement] = STATE(3051),
    [sym_for_statement] = STATE(3051),
    [sym_return_statement] = STATE(3051),
    [sym_break_statement] = STATE(3051),
    [sym_continue_statement] = STATE(3051),
    [sym_goto_statement] = STATE(3051),
    [sym__expression] = STATE(1419),
    [sym_comma_expression] = STATE(1420),
    [sym_conditional_expression] = STATE(1419),
    [sym_assignment_expression] = STATE(1419),
    [sym_pointer_expression] = STATE(1419),
    [sym_logical_expression] = STATE(1419),
    [sym_bitwise_expression] = STATE(1419),
    [sym_equality_expression] = STATE(1419),
    [sym_relational_expression] = STATE(1419),
    [sym_shift_expression] = STATE(1419),
    [sym_math_expression] = STATE(1419),
    [sym_cast_expression] = STATE(1419),
    [sym_sizeof_expression] = STATE(1419),
    [sym_subscript_expression] = STATE(1419),
    [sym_call_expression] = STATE(1419),
    [sym_field_expression] = STATE(1419),
    [sym_compound_literal_expression] = STATE(1419),
    [sym_parenthesized_expression] = STATE(1419),
    [sym_concatenated_string] = STATE(1419),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(1419),
    [sym_for_range_loop] = STATE(3051),
    [sym_new_expression] = STATE(1419),
    [sym_delete_expression] = STATE(1419),
    [sym_lambda_expression] = STATE(1419),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(2879),
    [anon_sym_LPAREN] = ACTIONS(626),
    [anon_sym_SEMI] = ACTIONS(2899),
    [anon_sym_LBRACE] = ACTIONS(2903),
    [anon_sym_STAR] = ACTIONS(644),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_if] = ACTIONS(2905),
    [anon_sym_switch] = ACTIONS(2907),
    [anon_sym_case] = ACTIONS(2909),
    [anon_sym_default] = ACTIONS(2911),
    [anon_sym_while] = ACTIONS(2913),
    [anon_sym_do] = ACTIONS(2915),
    [anon_sym_for] = ACTIONS(2917),
    [anon_sym_return] = ACTIONS(2919),
    [anon_sym_break] = ACTIONS(2921),
    [anon_sym_continue] = ACTIONS(2923),
    [anon_sym_goto] = ACTIONS(2925),
    [anon_sym_AMP] = ACTIONS(644),
    [anon_sym_BANG] = ACTIONS(668),
    [anon_sym_TILDE] = ACTIONS(670),
    [anon_sym_PLUS] = ACTIONS(672),
    [anon_sym_DASH] = ACTIONS(672),
    [anon_sym_DASH_DASH] = ACTIONS(674),
    [anon_sym_PLUS_PLUS] = ACTIONS(674),
    [anon_sym_sizeof] = ACTIONS(676),
    [sym_number_literal] = ACTIONS(2879),
    [sym_char_literal] = ACTIONS(2879),
    [sym_string_literal] = ACTIONS(678),
    [sym_true] = ACTIONS(2927),
    [sym_false] = ACTIONS(2927),
    [sym_null] = ACTIONS(2927),
    [sym_identifier] = ACTIONS(5397),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1303),
    [anon_sym_delete] = ACTIONS(686),
    [sym_nullptr] = ACTIONS(2927),
  },
  [2974] = {
    [sym_raw_string_literal] = ACTIONS(6902),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(6904),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(6904),
    [anon_sym_LPAREN] = ACTIONS(6902),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(6904),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(6904),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(6904),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(6904),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(6904),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(6904),
    [sym_preproc_directive] = ACTIONS(6904),
    [anon_sym_SEMI] = ACTIONS(6902),
    [anon_sym_typedef] = ACTIONS(6904),
    [anon_sym_extern] = ACTIONS(6904),
    [anon_sym_LBRACE] = ACTIONS(6902),
    [anon_sym_STAR] = ACTIONS(6902),
    [anon_sym_LBRACK] = ACTIONS(6902),
    [anon_sym_static] = ACTIONS(6904),
    [anon_sym_register] = ACTIONS(6904),
    [anon_sym_inline] = ACTIONS(6904),
    [anon_sym_const] = ACTIONS(6904),
    [anon_sym_restrict] = ACTIONS(6904),
    [anon_sym_volatile] = ACTIONS(6904),
    [anon_sym__Atomic] = ACTIONS(6904),
    [anon_sym_mutable] = ACTIONS(6904),
    [anon_sym_explicit] = ACTIONS(6904),
    [anon_sym_constexpr] = ACTIONS(6904),
    [anon_sym_unsigned] = ACTIONS(6904),
    [anon_sym_long] = ACTIONS(6904),
    [anon_sym_short] = ACTIONS(6904),
    [sym_primitive_type] = ACTIONS(6904),
    [anon_sym_enum] = ACTIONS(6904),
    [anon_sym_struct] = ACTIONS(6904),
    [anon_sym_union] = ACTIONS(6904),
    [anon_sym_if] = ACTIONS(6904),
    [anon_sym_switch] = ACTIONS(6904),
    [anon_sym_case] = ACTIONS(6904),
    [anon_sym_default] = ACTIONS(6904),
    [anon_sym_while] = ACTIONS(6904),
    [anon_sym_do] = ACTIONS(6904),
    [anon_sym_for] = ACTIONS(6904),
    [anon_sym_return] = ACTIONS(6904),
    [anon_sym_break] = ACTIONS(6904),
    [anon_sym_continue] = ACTIONS(6904),
    [anon_sym_goto] = ACTIONS(6904),
    [anon_sym_AMP] = ACTIONS(6902),
    [anon_sym_BANG] = ACTIONS(6902),
    [anon_sym_TILDE] = ACTIONS(6902),
    [anon_sym_PLUS] = ACTIONS(6904),
    [anon_sym_DASH] = ACTIONS(6904),
    [anon_sym_DASH_DASH] = ACTIONS(6902),
    [anon_sym_PLUS_PLUS] = ACTIONS(6902),
    [anon_sym_sizeof] = ACTIONS(6904),
    [sym_number_literal] = ACTIONS(6902),
    [sym_char_literal] = ACTIONS(6902),
    [sym_string_literal] = ACTIONS(6902),
    [sym_true] = ACTIONS(6904),
    [sym_false] = ACTIONS(6904),
    [sym_null] = ACTIONS(6904),
    [sym_identifier] = ACTIONS(6904),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(6904),
    [sym_auto] = ACTIONS(6904),
    [anon_sym_typename] = ACTIONS(6904),
    [anon_sym_new] = ACTIONS(6904),
    [anon_sym_COLON_COLON] = ACTIONS(6902),
    [anon_sym_delete] = ACTIONS(6904),
    [sym_nullptr] = ACTIONS(6904),
  },
  [2975] = {
    [sym_compound_statement] = STATE(3052),
    [sym_labeled_statement] = STATE(3052),
    [sym_expression_statement] = STATE(3052),
    [sym_if_statement] = STATE(3052),
    [sym_switch_statement] = STATE(3052),
    [sym_case_statement] = STATE(3052),
    [sym_while_statement] = STATE(3052),
    [sym_do_statement] = STATE(3052),
    [sym_for_statement] = STATE(3052),
    [sym_return_statement] = STATE(3052),
    [sym_break_statement] = STATE(3052),
    [sym_continue_statement] = STATE(3052),
    [sym_goto_statement] = STATE(3052),
    [sym__expression] = STATE(1419),
    [sym_comma_expression] = STATE(1420),
    [sym_conditional_expression] = STATE(1419),
    [sym_assignment_expression] = STATE(1419),
    [sym_pointer_expression] = STATE(1419),
    [sym_logical_expression] = STATE(1419),
    [sym_bitwise_expression] = STATE(1419),
    [sym_equality_expression] = STATE(1419),
    [sym_relational_expression] = STATE(1419),
    [sym_shift_expression] = STATE(1419),
    [sym_math_expression] = STATE(1419),
    [sym_cast_expression] = STATE(1419),
    [sym_sizeof_expression] = STATE(1419),
    [sym_subscript_expression] = STATE(1419),
    [sym_call_expression] = STATE(1419),
    [sym_field_expression] = STATE(1419),
    [sym_compound_literal_expression] = STATE(1419),
    [sym_parenthesized_expression] = STATE(1419),
    [sym_concatenated_string] = STATE(1419),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(1419),
    [sym_for_range_loop] = STATE(3052),
    [sym_new_expression] = STATE(1419),
    [sym_delete_expression] = STATE(1419),
    [sym_lambda_expression] = STATE(1419),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(2879),
    [anon_sym_LPAREN] = ACTIONS(626),
    [anon_sym_SEMI] = ACTIONS(2899),
    [anon_sym_LBRACE] = ACTIONS(2903),
    [anon_sym_STAR] = ACTIONS(644),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_if] = ACTIONS(2905),
    [anon_sym_switch] = ACTIONS(2907),
    [anon_sym_case] = ACTIONS(2909),
    [anon_sym_default] = ACTIONS(2911),
    [anon_sym_while] = ACTIONS(2913),
    [anon_sym_do] = ACTIONS(2915),
    [anon_sym_for] = ACTIONS(2917),
    [anon_sym_return] = ACTIONS(2919),
    [anon_sym_break] = ACTIONS(2921),
    [anon_sym_continue] = ACTIONS(2923),
    [anon_sym_goto] = ACTIONS(2925),
    [anon_sym_AMP] = ACTIONS(644),
    [anon_sym_BANG] = ACTIONS(668),
    [anon_sym_TILDE] = ACTIONS(670),
    [anon_sym_PLUS] = ACTIONS(672),
    [anon_sym_DASH] = ACTIONS(672),
    [anon_sym_DASH_DASH] = ACTIONS(674),
    [anon_sym_PLUS_PLUS] = ACTIONS(674),
    [anon_sym_sizeof] = ACTIONS(676),
    [sym_number_literal] = ACTIONS(2879),
    [sym_char_literal] = ACTIONS(2879),
    [sym_string_literal] = ACTIONS(678),
    [sym_true] = ACTIONS(2927),
    [sym_false] = ACTIONS(2927),
    [sym_null] = ACTIONS(2927),
    [sym_identifier] = ACTIONS(5397),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1303),
    [anon_sym_delete] = ACTIONS(686),
    [sym_nullptr] = ACTIONS(2927),
  },
  [2976] = {
    [aux_sym_for_statement_repeat1] = STATE(2796),
    [anon_sym_COMMA] = ACTIONS(6339),
    [anon_sym_RPAREN] = ACTIONS(7162),
    [sym_comment] = ACTIONS(49),
  },
  [2977] = {
    [sym_argument_list] = STATE(802),
    [aux_sym_for_statement_repeat1] = STATE(3054),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_COMMA] = ACTIONS(6339),
    [anon_sym_RPAREN] = ACTIONS(7162),
    [anon_sym_STAR] = ACTIONS(2234),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_EQ] = ACTIONS(2236),
    [anon_sym_QMARK] = ACTIONS(2238),
    [anon_sym_STAR_EQ] = ACTIONS(2240),
    [anon_sym_SLASH_EQ] = ACTIONS(2240),
    [anon_sym_PERCENT_EQ] = ACTIONS(2240),
    [anon_sym_PLUS_EQ] = ACTIONS(2240),
    [anon_sym_DASH_EQ] = ACTIONS(2240),
    [anon_sym_LT_LT_EQ] = ACTIONS(2240),
    [anon_sym_GT_GT_EQ] = ACTIONS(2240),
    [anon_sym_AMP_EQ] = ACTIONS(2240),
    [anon_sym_CARET_EQ] = ACTIONS(2240),
    [anon_sym_PIPE_EQ] = ACTIONS(2240),
    [anon_sym_AMP] = ACTIONS(2242),
    [anon_sym_PIPE_PIPE] = ACTIONS(2244),
    [anon_sym_AMP_AMP] = ACTIONS(2246),
    [anon_sym_PIPE] = ACTIONS(2248),
    [anon_sym_CARET] = ACTIONS(2250),
    [anon_sym_EQ_EQ] = ACTIONS(2252),
    [anon_sym_BANG_EQ] = ACTIONS(2252),
    [anon_sym_LT] = ACTIONS(2254),
    [anon_sym_GT] = ACTIONS(2254),
    [anon_sym_LT_EQ] = ACTIONS(2256),
    [anon_sym_GT_EQ] = ACTIONS(2256),
    [anon_sym_LT_LT] = ACTIONS(2258),
    [anon_sym_GT_GT] = ACTIONS(2258),
    [anon_sym_PLUS] = ACTIONS(2260),
    [anon_sym_DASH] = ACTIONS(2260),
    [anon_sym_SLASH] = ACTIONS(2234),
    [anon_sym_PERCENT] = ACTIONS(2234),
    [anon_sym_DASH_DASH] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(1554),
    [anon_sym_DASH_GT] = ACTIONS(1554),
    [sym_comment] = ACTIONS(49),
  },
  [2978] = {
    [sym_raw_string_literal] = ACTIONS(6925),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(6927),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(6927),
    [anon_sym_LPAREN] = ACTIONS(6925),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(6927),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(6927),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(6927),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(6927),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(6927),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(6927),
    [sym_preproc_directive] = ACTIONS(6927),
    [anon_sym_SEMI] = ACTIONS(6925),
    [anon_sym_typedef] = ACTIONS(6927),
    [anon_sym_extern] = ACTIONS(6927),
    [anon_sym_LBRACE] = ACTIONS(6925),
    [anon_sym_STAR] = ACTIONS(6925),
    [anon_sym_LBRACK] = ACTIONS(6925),
    [anon_sym_static] = ACTIONS(6927),
    [anon_sym_register] = ACTIONS(6927),
    [anon_sym_inline] = ACTIONS(6927),
    [anon_sym_const] = ACTIONS(6927),
    [anon_sym_restrict] = ACTIONS(6927),
    [anon_sym_volatile] = ACTIONS(6927),
    [anon_sym__Atomic] = ACTIONS(6927),
    [anon_sym_mutable] = ACTIONS(6927),
    [anon_sym_explicit] = ACTIONS(6927),
    [anon_sym_constexpr] = ACTIONS(6927),
    [anon_sym_unsigned] = ACTIONS(6927),
    [anon_sym_long] = ACTIONS(6927),
    [anon_sym_short] = ACTIONS(6927),
    [sym_primitive_type] = ACTIONS(6927),
    [anon_sym_enum] = ACTIONS(6927),
    [anon_sym_struct] = ACTIONS(6927),
    [anon_sym_union] = ACTIONS(6927),
    [anon_sym_if] = ACTIONS(6927),
    [anon_sym_switch] = ACTIONS(6927),
    [anon_sym_case] = ACTIONS(6927),
    [anon_sym_default] = ACTIONS(6927),
    [anon_sym_while] = ACTIONS(6927),
    [anon_sym_do] = ACTIONS(6927),
    [anon_sym_for] = ACTIONS(6927),
    [anon_sym_return] = ACTIONS(6927),
    [anon_sym_break] = ACTIONS(6927),
    [anon_sym_continue] = ACTIONS(6927),
    [anon_sym_goto] = ACTIONS(6927),
    [anon_sym_AMP] = ACTIONS(6925),
    [anon_sym_BANG] = ACTIONS(6925),
    [anon_sym_TILDE] = ACTIONS(6925),
    [anon_sym_PLUS] = ACTIONS(6927),
    [anon_sym_DASH] = ACTIONS(6927),
    [anon_sym_DASH_DASH] = ACTIONS(6925),
    [anon_sym_PLUS_PLUS] = ACTIONS(6925),
    [anon_sym_sizeof] = ACTIONS(6927),
    [sym_number_literal] = ACTIONS(6925),
    [sym_char_literal] = ACTIONS(6925),
    [sym_string_literal] = ACTIONS(6925),
    [sym_true] = ACTIONS(6927),
    [sym_false] = ACTIONS(6927),
    [sym_null] = ACTIONS(6927),
    [sym_identifier] = ACTIONS(6927),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(6927),
    [sym_auto] = ACTIONS(6927),
    [anon_sym_typename] = ACTIONS(6927),
    [anon_sym_new] = ACTIONS(6927),
    [anon_sym_COLON_COLON] = ACTIONS(6925),
    [anon_sym_delete] = ACTIONS(6927),
    [sym_nullptr] = ACTIONS(6927),
  },
  [2979] = {
    [sym_raw_string_literal] = ACTIONS(6267),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(6269),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(6269),
    [anon_sym_LPAREN] = ACTIONS(6267),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(6269),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(6269),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(6269),
    [sym_preproc_directive] = ACTIONS(6269),
    [anon_sym_SEMI] = ACTIONS(6267),
    [anon_sym_typedef] = ACTIONS(6269),
    [anon_sym_extern] = ACTIONS(6269),
    [anon_sym_LBRACE] = ACTIONS(6267),
    [anon_sym_RBRACE] = ACTIONS(6267),
    [anon_sym_STAR] = ACTIONS(6267),
    [anon_sym_LBRACK] = ACTIONS(6267),
    [anon_sym_static] = ACTIONS(6269),
    [anon_sym_register] = ACTIONS(6269),
    [anon_sym_inline] = ACTIONS(6269),
    [anon_sym_const] = ACTIONS(6269),
    [anon_sym_restrict] = ACTIONS(6269),
    [anon_sym_volatile] = ACTIONS(6269),
    [anon_sym__Atomic] = ACTIONS(6269),
    [anon_sym_mutable] = ACTIONS(6269),
    [anon_sym_explicit] = ACTIONS(6269),
    [anon_sym_constexpr] = ACTIONS(6269),
    [anon_sym_unsigned] = ACTIONS(6269),
    [anon_sym_long] = ACTIONS(6269),
    [anon_sym_short] = ACTIONS(6269),
    [sym_primitive_type] = ACTIONS(6269),
    [anon_sym_enum] = ACTIONS(6269),
    [anon_sym_struct] = ACTIONS(6269),
    [anon_sym_union] = ACTIONS(6269),
    [anon_sym_if] = ACTIONS(6269),
    [anon_sym_else] = ACTIONS(7164),
    [anon_sym_switch] = ACTIONS(6269),
    [anon_sym_case] = ACTIONS(6269),
    [anon_sym_default] = ACTIONS(6269),
    [anon_sym_while] = ACTIONS(6269),
    [anon_sym_do] = ACTIONS(6269),
    [anon_sym_for] = ACTIONS(6269),
    [anon_sym_return] = ACTIONS(6269),
    [anon_sym_break] = ACTIONS(6269),
    [anon_sym_continue] = ACTIONS(6269),
    [anon_sym_goto] = ACTIONS(6269),
    [anon_sym_AMP] = ACTIONS(6267),
    [anon_sym_BANG] = ACTIONS(6267),
    [anon_sym_TILDE] = ACTIONS(6267),
    [anon_sym_PLUS] = ACTIONS(6269),
    [anon_sym_DASH] = ACTIONS(6269),
    [anon_sym_DASH_DASH] = ACTIONS(6267),
    [anon_sym_PLUS_PLUS] = ACTIONS(6267),
    [anon_sym_sizeof] = ACTIONS(6269),
    [sym_number_literal] = ACTIONS(6267),
    [sym_char_literal] = ACTIONS(6267),
    [sym_string_literal] = ACTIONS(6267),
    [sym_true] = ACTIONS(6269),
    [sym_false] = ACTIONS(6269),
    [sym_null] = ACTIONS(6269),
    [sym_identifier] = ACTIONS(6269),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(6269),
    [sym_auto] = ACTIONS(6269),
    [anon_sym_typename] = ACTIONS(6269),
    [anon_sym_new] = ACTIONS(6269),
    [anon_sym_COLON_COLON] = ACTIONS(6267),
    [anon_sym_delete] = ACTIONS(6269),
    [sym_nullptr] = ACTIONS(6269),
  },
  [2980] = {
    [sym_compound_statement] = STATE(3056),
    [sym_labeled_statement] = STATE(3056),
    [sym_expression_statement] = STATE(3056),
    [sym_if_statement] = STATE(3056),
    [sym_switch_statement] = STATE(3056),
    [sym_case_statement] = STATE(3056),
    [sym_while_statement] = STATE(3056),
    [sym_do_statement] = STATE(3056),
    [sym_for_statement] = STATE(3056),
    [sym_return_statement] = STATE(3056),
    [sym_break_statement] = STATE(3056),
    [sym_continue_statement] = STATE(3056),
    [sym_goto_statement] = STATE(3056),
    [sym__expression] = STATE(2378),
    [sym_comma_expression] = STATE(2379),
    [sym_conditional_expression] = STATE(2378),
    [sym_assignment_expression] = STATE(2378),
    [sym_pointer_expression] = STATE(2378),
    [sym_logical_expression] = STATE(2378),
    [sym_bitwise_expression] = STATE(2378),
    [sym_equality_expression] = STATE(2378),
    [sym_relational_expression] = STATE(2378),
    [sym_shift_expression] = STATE(2378),
    [sym_math_expression] = STATE(2378),
    [sym_cast_expression] = STATE(2378),
    [sym_sizeof_expression] = STATE(2378),
    [sym_subscript_expression] = STATE(2378),
    [sym_call_expression] = STATE(2378),
    [sym_field_expression] = STATE(2378),
    [sym_compound_literal_expression] = STATE(2378),
    [sym_parenthesized_expression] = STATE(2378),
    [sym_concatenated_string] = STATE(2378),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(2378),
    [sym_for_range_loop] = STATE(3056),
    [sym_new_expression] = STATE(2378),
    [sym_delete_expression] = STATE(2378),
    [sym_lambda_expression] = STATE(2378),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(5538),
    [anon_sym_LPAREN] = ACTIONS(626),
    [anon_sym_SEMI] = ACTIONS(5540),
    [anon_sym_LBRACE] = ACTIONS(5542),
    [anon_sym_STAR] = ACTIONS(644),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_if] = ACTIONS(5544),
    [anon_sym_switch] = ACTIONS(5546),
    [anon_sym_case] = ACTIONS(5548),
    [anon_sym_default] = ACTIONS(5550),
    [anon_sym_while] = ACTIONS(5552),
    [anon_sym_do] = ACTIONS(5554),
    [anon_sym_for] = ACTIONS(5556),
    [anon_sym_return] = ACTIONS(5558),
    [anon_sym_break] = ACTIONS(5560),
    [anon_sym_continue] = ACTIONS(5562),
    [anon_sym_goto] = ACTIONS(5564),
    [anon_sym_AMP] = ACTIONS(644),
    [anon_sym_BANG] = ACTIONS(668),
    [anon_sym_TILDE] = ACTIONS(670),
    [anon_sym_PLUS] = ACTIONS(672),
    [anon_sym_DASH] = ACTIONS(672),
    [anon_sym_DASH_DASH] = ACTIONS(674),
    [anon_sym_PLUS_PLUS] = ACTIONS(674),
    [anon_sym_sizeof] = ACTIONS(676),
    [sym_number_literal] = ACTIONS(5538),
    [sym_char_literal] = ACTIONS(5538),
    [sym_string_literal] = ACTIONS(678),
    [sym_true] = ACTIONS(5566),
    [sym_false] = ACTIONS(5566),
    [sym_null] = ACTIONS(5566),
    [sym_identifier] = ACTIONS(5568),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1303),
    [anon_sym_delete] = ACTIONS(686),
    [sym_nullptr] = ACTIONS(5566),
  },
  [2981] = {
    [sym_raw_string_literal] = ACTIONS(6277),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(6279),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(6279),
    [anon_sym_LPAREN] = ACTIONS(6277),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(6279),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(6279),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(6279),
    [sym_preproc_directive] = ACTIONS(6279),
    [anon_sym_SEMI] = ACTIONS(6277),
    [anon_sym_typedef] = ACTIONS(6279),
    [anon_sym_extern] = ACTIONS(6279),
    [anon_sym_LBRACE] = ACTIONS(6277),
    [anon_sym_RBRACE] = ACTIONS(6277),
    [anon_sym_STAR] = ACTIONS(6277),
    [anon_sym_LBRACK] = ACTIONS(6277),
    [anon_sym_static] = ACTIONS(6279),
    [anon_sym_register] = ACTIONS(6279),
    [anon_sym_inline] = ACTIONS(6279),
    [anon_sym_const] = ACTIONS(6279),
    [anon_sym_restrict] = ACTIONS(6279),
    [anon_sym_volatile] = ACTIONS(6279),
    [anon_sym__Atomic] = ACTIONS(6279),
    [anon_sym_mutable] = ACTIONS(6279),
    [anon_sym_explicit] = ACTIONS(6279),
    [anon_sym_constexpr] = ACTIONS(6279),
    [anon_sym_unsigned] = ACTIONS(6279),
    [anon_sym_long] = ACTIONS(6279),
    [anon_sym_short] = ACTIONS(6279),
    [sym_primitive_type] = ACTIONS(6279),
    [anon_sym_enum] = ACTIONS(6279),
    [anon_sym_struct] = ACTIONS(6279),
    [anon_sym_union] = ACTIONS(6279),
    [anon_sym_if] = ACTIONS(6279),
    [anon_sym_else] = ACTIONS(6279),
    [anon_sym_switch] = ACTIONS(6279),
    [anon_sym_case] = ACTIONS(6279),
    [anon_sym_default] = ACTIONS(6279),
    [anon_sym_while] = ACTIONS(6279),
    [anon_sym_do] = ACTIONS(6279),
    [anon_sym_for] = ACTIONS(6279),
    [anon_sym_return] = ACTIONS(6279),
    [anon_sym_break] = ACTIONS(6279),
    [anon_sym_continue] = ACTIONS(6279),
    [anon_sym_goto] = ACTIONS(6279),
    [anon_sym_AMP] = ACTIONS(6277),
    [anon_sym_BANG] = ACTIONS(6277),
    [anon_sym_TILDE] = ACTIONS(6277),
    [anon_sym_PLUS] = ACTIONS(6279),
    [anon_sym_DASH] = ACTIONS(6279),
    [anon_sym_DASH_DASH] = ACTIONS(6277),
    [anon_sym_PLUS_PLUS] = ACTIONS(6277),
    [anon_sym_sizeof] = ACTIONS(6279),
    [sym_number_literal] = ACTIONS(6277),
    [sym_char_literal] = ACTIONS(6277),
    [sym_string_literal] = ACTIONS(6277),
    [sym_true] = ACTIONS(6279),
    [sym_false] = ACTIONS(6279),
    [sym_null] = ACTIONS(6279),
    [sym_identifier] = ACTIONS(6279),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(6279),
    [sym_auto] = ACTIONS(6279),
    [anon_sym_typename] = ACTIONS(6279),
    [anon_sym_new] = ACTIONS(6279),
    [anon_sym_COLON_COLON] = ACTIONS(6277),
    [anon_sym_delete] = ACTIONS(6279),
    [sym_nullptr] = ACTIONS(6279),
  },
  [2982] = {
    [sym_parameter_list] = STATE(513),
    [anon_sym_LPAREN] = ACTIONS(206),
    [anon_sym_SEMI] = ACTIONS(7166),
    [anon_sym_LBRACK] = ACTIONS(955),
    [sym_comment] = ACTIONS(49),
  },
  [2983] = {
    [sym__type_declarator] = STATE(3058),
    [sym_pointer_type_declarator] = STATE(213),
    [sym_function_type_declarator] = STATE(214),
    [sym_array_type_declarator] = STATE(215),
    [anon_sym_LPAREN] = ACTIONS(327),
    [anon_sym_STAR] = ACTIONS(329),
    [sym_identifier] = ACTIONS(331),
    [sym_comment] = ACTIONS(49),
  },
  [2984] = {
    [sym_raw_string_literal] = ACTIONS(1261),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1263),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1263),
    [anon_sym_LPAREN] = ACTIONS(1261),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1263),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1263),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1263),
    [sym_preproc_directive] = ACTIONS(1263),
    [anon_sym_SEMI] = ACTIONS(1261),
    [anon_sym_typedef] = ACTIONS(1263),
    [anon_sym_extern] = ACTIONS(1263),
    [anon_sym_LBRACE] = ACTIONS(1261),
    [anon_sym_RBRACE] = ACTIONS(1261),
    [anon_sym_STAR] = ACTIONS(1261),
    [anon_sym_LBRACK] = ACTIONS(1261),
    [anon_sym_static] = ACTIONS(1263),
    [anon_sym_register] = ACTIONS(1263),
    [anon_sym_inline] = ACTIONS(1263),
    [anon_sym_const] = ACTIONS(1263),
    [anon_sym_restrict] = ACTIONS(1263),
    [anon_sym_volatile] = ACTIONS(1263),
    [anon_sym__Atomic] = ACTIONS(1263),
    [anon_sym_mutable] = ACTIONS(1263),
    [anon_sym_explicit] = ACTIONS(1263),
    [anon_sym_constexpr] = ACTIONS(1263),
    [anon_sym_unsigned] = ACTIONS(1263),
    [anon_sym_long] = ACTIONS(1263),
    [anon_sym_short] = ACTIONS(1263),
    [sym_primitive_type] = ACTIONS(1263),
    [anon_sym_enum] = ACTIONS(1263),
    [anon_sym_struct] = ACTIONS(1263),
    [anon_sym_union] = ACTIONS(1263),
    [anon_sym_if] = ACTIONS(1263),
    [anon_sym_else] = ACTIONS(1263),
    [anon_sym_switch] = ACTIONS(1263),
    [anon_sym_case] = ACTIONS(1263),
    [anon_sym_default] = ACTIONS(1263),
    [anon_sym_while] = ACTIONS(1263),
    [anon_sym_do] = ACTIONS(1263),
    [anon_sym_for] = ACTIONS(1263),
    [anon_sym_return] = ACTIONS(1263),
    [anon_sym_break] = ACTIONS(1263),
    [anon_sym_continue] = ACTIONS(1263),
    [anon_sym_goto] = ACTIONS(1263),
    [anon_sym_AMP] = ACTIONS(1261),
    [anon_sym_BANG] = ACTIONS(1261),
    [anon_sym_TILDE] = ACTIONS(1261),
    [anon_sym_PLUS] = ACTIONS(1263),
    [anon_sym_DASH] = ACTIONS(1263),
    [anon_sym_DASH_DASH] = ACTIONS(1261),
    [anon_sym_PLUS_PLUS] = ACTIONS(1261),
    [anon_sym_sizeof] = ACTIONS(1263),
    [sym_number_literal] = ACTIONS(1261),
    [sym_char_literal] = ACTIONS(1261),
    [sym_string_literal] = ACTIONS(1261),
    [sym_true] = ACTIONS(1263),
    [sym_false] = ACTIONS(1263),
    [sym_null] = ACTIONS(1263),
    [sym_identifier] = ACTIONS(1263),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(1263),
    [sym_auto] = ACTIONS(1263),
    [anon_sym_typename] = ACTIONS(1263),
    [anon_sym_new] = ACTIONS(1263),
    [anon_sym_COLON_COLON] = ACTIONS(1261),
    [anon_sym_delete] = ACTIONS(1263),
    [sym_nullptr] = ACTIONS(1263),
  },
  [2985] = {
    [aux_sym_declaration_repeat1] = STATE(678),
    [anon_sym_COMMA] = ACTIONS(538),
    [anon_sym_SEMI] = ACTIONS(7168),
    [sym_comment] = ACTIONS(49),
  },
  [2986] = {
    [sym_raw_string_literal] = ACTIONS(6293),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(6295),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(6295),
    [anon_sym_LPAREN] = ACTIONS(6293),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(6295),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(6295),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(6295),
    [sym_preproc_directive] = ACTIONS(6295),
    [anon_sym_SEMI] = ACTIONS(6293),
    [anon_sym_typedef] = ACTIONS(6295),
    [anon_sym_extern] = ACTIONS(6295),
    [anon_sym_LBRACE] = ACTIONS(6293),
    [anon_sym_RBRACE] = ACTIONS(6293),
    [anon_sym_STAR] = ACTIONS(6293),
    [anon_sym_LBRACK] = ACTIONS(6293),
    [anon_sym_static] = ACTIONS(6295),
    [anon_sym_register] = ACTIONS(6295),
    [anon_sym_inline] = ACTIONS(6295),
    [anon_sym_const] = ACTIONS(6295),
    [anon_sym_restrict] = ACTIONS(6295),
    [anon_sym_volatile] = ACTIONS(6295),
    [anon_sym__Atomic] = ACTIONS(6295),
    [anon_sym_mutable] = ACTIONS(6295),
    [anon_sym_explicit] = ACTIONS(6295),
    [anon_sym_constexpr] = ACTIONS(6295),
    [anon_sym_unsigned] = ACTIONS(6295),
    [anon_sym_long] = ACTIONS(6295),
    [anon_sym_short] = ACTIONS(6295),
    [sym_primitive_type] = ACTIONS(6295),
    [anon_sym_enum] = ACTIONS(6295),
    [anon_sym_struct] = ACTIONS(6295),
    [anon_sym_union] = ACTIONS(6295),
    [anon_sym_if] = ACTIONS(6295),
    [anon_sym_else] = ACTIONS(6295),
    [anon_sym_switch] = ACTIONS(6295),
    [anon_sym_case] = ACTIONS(6295),
    [anon_sym_default] = ACTIONS(6295),
    [anon_sym_while] = ACTIONS(6295),
    [anon_sym_do] = ACTIONS(6295),
    [anon_sym_for] = ACTIONS(6295),
    [anon_sym_return] = ACTIONS(6295),
    [anon_sym_break] = ACTIONS(6295),
    [anon_sym_continue] = ACTIONS(6295),
    [anon_sym_goto] = ACTIONS(6295),
    [anon_sym_AMP] = ACTIONS(6293),
    [anon_sym_BANG] = ACTIONS(6293),
    [anon_sym_TILDE] = ACTIONS(6293),
    [anon_sym_PLUS] = ACTIONS(6295),
    [anon_sym_DASH] = ACTIONS(6295),
    [anon_sym_DASH_DASH] = ACTIONS(6293),
    [anon_sym_PLUS_PLUS] = ACTIONS(6293),
    [anon_sym_sizeof] = ACTIONS(6295),
    [sym_number_literal] = ACTIONS(6293),
    [sym_char_literal] = ACTIONS(6293),
    [sym_string_literal] = ACTIONS(6293),
    [sym_true] = ACTIONS(6295),
    [sym_false] = ACTIONS(6295),
    [sym_null] = ACTIONS(6295),
    [sym_identifier] = ACTIONS(6295),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(6295),
    [sym_auto] = ACTIONS(6295),
    [anon_sym_typename] = ACTIONS(6295),
    [anon_sym_new] = ACTIONS(6295),
    [anon_sym_COLON_COLON] = ACTIONS(6293),
    [anon_sym_delete] = ACTIONS(6295),
    [sym_nullptr] = ACTIONS(6295),
  },
  [2987] = {
    [sym_argument_list] = STATE(802),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_RPAREN] = ACTIONS(7170),
    [anon_sym_STAR] = ACTIONS(4537),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_EQ] = ACTIONS(4539),
    [anon_sym_QMARK] = ACTIONS(4541),
    [anon_sym_STAR_EQ] = ACTIONS(4543),
    [anon_sym_SLASH_EQ] = ACTIONS(4543),
    [anon_sym_PERCENT_EQ] = ACTIONS(4543),
    [anon_sym_PLUS_EQ] = ACTIONS(4543),
    [anon_sym_DASH_EQ] = ACTIONS(4543),
    [anon_sym_LT_LT_EQ] = ACTIONS(4543),
    [anon_sym_GT_GT_EQ] = ACTIONS(4543),
    [anon_sym_AMP_EQ] = ACTIONS(4543),
    [anon_sym_CARET_EQ] = ACTIONS(4543),
    [anon_sym_PIPE_EQ] = ACTIONS(4543),
    [anon_sym_AMP] = ACTIONS(4545),
    [anon_sym_PIPE_PIPE] = ACTIONS(4547),
    [anon_sym_AMP_AMP] = ACTIONS(4549),
    [anon_sym_PIPE] = ACTIONS(4551),
    [anon_sym_CARET] = ACTIONS(4553),
    [anon_sym_EQ_EQ] = ACTIONS(4555),
    [anon_sym_BANG_EQ] = ACTIONS(4555),
    [anon_sym_LT] = ACTIONS(4557),
    [anon_sym_GT] = ACTIONS(4557),
    [anon_sym_LT_EQ] = ACTIONS(4559),
    [anon_sym_GT_EQ] = ACTIONS(4559),
    [anon_sym_LT_LT] = ACTIONS(4561),
    [anon_sym_GT_GT] = ACTIONS(4561),
    [anon_sym_PLUS] = ACTIONS(4563),
    [anon_sym_DASH] = ACTIONS(4563),
    [anon_sym_SLASH] = ACTIONS(4537),
    [anon_sym_PERCENT] = ACTIONS(4537),
    [anon_sym_DASH_DASH] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(1554),
    [anon_sym_DASH_GT] = ACTIONS(1554),
    [sym_comment] = ACTIONS(49),
  },
  [2988] = {
    [sym_compound_statement] = STATE(3061),
    [sym_labeled_statement] = STATE(3061),
    [sym_expression_statement] = STATE(3061),
    [sym_if_statement] = STATE(3061),
    [sym_switch_statement] = STATE(3061),
    [sym_case_statement] = STATE(3061),
    [sym_while_statement] = STATE(3061),
    [sym_do_statement] = STATE(3061),
    [sym_for_statement] = STATE(3061),
    [sym_return_statement] = STATE(3061),
    [sym_break_statement] = STATE(3061),
    [sym_continue_statement] = STATE(3061),
    [sym_goto_statement] = STATE(3061),
    [sym__expression] = STATE(2378),
    [sym_comma_expression] = STATE(2379),
    [sym_conditional_expression] = STATE(2378),
    [sym_assignment_expression] = STATE(2378),
    [sym_pointer_expression] = STATE(2378),
    [sym_logical_expression] = STATE(2378),
    [sym_bitwise_expression] = STATE(2378),
    [sym_equality_expression] = STATE(2378),
    [sym_relational_expression] = STATE(2378),
    [sym_shift_expression] = STATE(2378),
    [sym_math_expression] = STATE(2378),
    [sym_cast_expression] = STATE(2378),
    [sym_sizeof_expression] = STATE(2378),
    [sym_subscript_expression] = STATE(2378),
    [sym_call_expression] = STATE(2378),
    [sym_field_expression] = STATE(2378),
    [sym_compound_literal_expression] = STATE(2378),
    [sym_parenthesized_expression] = STATE(2378),
    [sym_concatenated_string] = STATE(2378),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(2378),
    [sym_for_range_loop] = STATE(3061),
    [sym_new_expression] = STATE(2378),
    [sym_delete_expression] = STATE(2378),
    [sym_lambda_expression] = STATE(2378),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(5538),
    [anon_sym_LPAREN] = ACTIONS(626),
    [anon_sym_SEMI] = ACTIONS(5540),
    [anon_sym_LBRACE] = ACTIONS(5542),
    [anon_sym_STAR] = ACTIONS(644),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_if] = ACTIONS(5544),
    [anon_sym_switch] = ACTIONS(5546),
    [anon_sym_case] = ACTIONS(5548),
    [anon_sym_default] = ACTIONS(5550),
    [anon_sym_while] = ACTIONS(5552),
    [anon_sym_do] = ACTIONS(5554),
    [anon_sym_for] = ACTIONS(5556),
    [anon_sym_return] = ACTIONS(5558),
    [anon_sym_break] = ACTIONS(5560),
    [anon_sym_continue] = ACTIONS(5562),
    [anon_sym_goto] = ACTIONS(5564),
    [anon_sym_AMP] = ACTIONS(644),
    [anon_sym_BANG] = ACTIONS(668),
    [anon_sym_TILDE] = ACTIONS(670),
    [anon_sym_PLUS] = ACTIONS(672),
    [anon_sym_DASH] = ACTIONS(672),
    [anon_sym_DASH_DASH] = ACTIONS(674),
    [anon_sym_PLUS_PLUS] = ACTIONS(674),
    [anon_sym_sizeof] = ACTIONS(676),
    [sym_number_literal] = ACTIONS(5538),
    [sym_char_literal] = ACTIONS(5538),
    [sym_string_literal] = ACTIONS(678),
    [sym_true] = ACTIONS(5566),
    [sym_false] = ACTIONS(5566),
    [sym_null] = ACTIONS(5566),
    [sym_identifier] = ACTIONS(5568),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1303),
    [anon_sym_delete] = ACTIONS(686),
    [sym_nullptr] = ACTIONS(5566),
  },
  [2989] = {
    [sym_argument_list] = STATE(802),
    [aux_sym_for_statement_repeat1] = STATE(3063),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_COMMA] = ACTIONS(6339),
    [anon_sym_RPAREN] = ACTIONS(7172),
    [anon_sym_STAR] = ACTIONS(2234),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_EQ] = ACTIONS(2236),
    [anon_sym_QMARK] = ACTIONS(2238),
    [anon_sym_STAR_EQ] = ACTIONS(2240),
    [anon_sym_SLASH_EQ] = ACTIONS(2240),
    [anon_sym_PERCENT_EQ] = ACTIONS(2240),
    [anon_sym_PLUS_EQ] = ACTIONS(2240),
    [anon_sym_DASH_EQ] = ACTIONS(2240),
    [anon_sym_LT_LT_EQ] = ACTIONS(2240),
    [anon_sym_GT_GT_EQ] = ACTIONS(2240),
    [anon_sym_AMP_EQ] = ACTIONS(2240),
    [anon_sym_CARET_EQ] = ACTIONS(2240),
    [anon_sym_PIPE_EQ] = ACTIONS(2240),
    [anon_sym_AMP] = ACTIONS(2242),
    [anon_sym_PIPE_PIPE] = ACTIONS(2244),
    [anon_sym_AMP_AMP] = ACTIONS(2246),
    [anon_sym_PIPE] = ACTIONS(2248),
    [anon_sym_CARET] = ACTIONS(2250),
    [anon_sym_EQ_EQ] = ACTIONS(2252),
    [anon_sym_BANG_EQ] = ACTIONS(2252),
    [anon_sym_LT] = ACTIONS(2254),
    [anon_sym_GT] = ACTIONS(2254),
    [anon_sym_LT_EQ] = ACTIONS(2256),
    [anon_sym_GT_EQ] = ACTIONS(2256),
    [anon_sym_LT_LT] = ACTIONS(2258),
    [anon_sym_GT_GT] = ACTIONS(2258),
    [anon_sym_PLUS] = ACTIONS(2260),
    [anon_sym_DASH] = ACTIONS(2260),
    [anon_sym_SLASH] = ACTIONS(2234),
    [anon_sym_PERCENT] = ACTIONS(2234),
    [anon_sym_DASH_DASH] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(1554),
    [anon_sym_DASH_GT] = ACTIONS(1554),
    [sym_comment] = ACTIONS(49),
  },
  [2990] = {
    [sym__expression] = STATE(3064),
    [sym_conditional_expression] = STATE(3064),
    [sym_assignment_expression] = STATE(3064),
    [sym_pointer_expression] = STATE(3064),
    [sym_logical_expression] = STATE(3064),
    [sym_bitwise_expression] = STATE(3064),
    [sym_equality_expression] = STATE(3064),
    [sym_relational_expression] = STATE(3064),
    [sym_shift_expression] = STATE(3064),
    [sym_math_expression] = STATE(3064),
    [sym_cast_expression] = STATE(3064),
    [sym_sizeof_expression] = STATE(3064),
    [sym_subscript_expression] = STATE(3064),
    [sym_call_expression] = STATE(3064),
    [sym_field_expression] = STATE(3064),
    [sym_compound_literal_expression] = STATE(3064),
    [sym_parenthesized_expression] = STATE(3064),
    [sym_concatenated_string] = STATE(3064),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(3064),
    [sym_new_expression] = STATE(3064),
    [sym_delete_expression] = STATE(3064),
    [sym_lambda_expression] = STATE(3064),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(7174),
    [anon_sym_LPAREN] = ACTIONS(1087),
    [anon_sym_RPAREN] = ACTIONS(7172),
    [anon_sym_STAR] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_AMP] = ACTIONS(1089),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1093),
    [anon_sym_PLUS] = ACTIONS(1095),
    [anon_sym_DASH] = ACTIONS(1095),
    [anon_sym_DASH_DASH] = ACTIONS(1097),
    [anon_sym_PLUS_PLUS] = ACTIONS(1097),
    [anon_sym_sizeof] = ACTIONS(1099),
    [sym_number_literal] = ACTIONS(7174),
    [sym_char_literal] = ACTIONS(7174),
    [sym_string_literal] = ACTIONS(1101),
    [sym_true] = ACTIONS(7176),
    [sym_false] = ACTIONS(7176),
    [sym_null] = ACTIONS(7176),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_delete] = ACTIONS(1109),
    [sym_nullptr] = ACTIONS(7176),
  },
  [2991] = {
    [sym_argument_list] = STATE(802),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_SEMI] = ACTIONS(7178),
    [anon_sym_STAR] = ACTIONS(2553),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_EQ] = ACTIONS(2555),
    [anon_sym_QMARK] = ACTIONS(2557),
    [anon_sym_STAR_EQ] = ACTIONS(2559),
    [anon_sym_SLASH_EQ] = ACTIONS(2559),
    [anon_sym_PERCENT_EQ] = ACTIONS(2559),
    [anon_sym_PLUS_EQ] = ACTIONS(2559),
    [anon_sym_DASH_EQ] = ACTIONS(2559),
    [anon_sym_LT_LT_EQ] = ACTIONS(2559),
    [anon_sym_GT_GT_EQ] = ACTIONS(2559),
    [anon_sym_AMP_EQ] = ACTIONS(2559),
    [anon_sym_CARET_EQ] = ACTIONS(2559),
    [anon_sym_PIPE_EQ] = ACTIONS(2559),
    [anon_sym_AMP] = ACTIONS(2561),
    [anon_sym_PIPE_PIPE] = ACTIONS(2563),
    [anon_sym_AMP_AMP] = ACTIONS(2565),
    [anon_sym_PIPE] = ACTIONS(2567),
    [anon_sym_CARET] = ACTIONS(2569),
    [anon_sym_EQ_EQ] = ACTIONS(2571),
    [anon_sym_BANG_EQ] = ACTIONS(2571),
    [anon_sym_LT] = ACTIONS(2573),
    [anon_sym_GT] = ACTIONS(2573),
    [anon_sym_LT_EQ] = ACTIONS(2575),
    [anon_sym_GT_EQ] = ACTIONS(2575),
    [anon_sym_LT_LT] = ACTIONS(2577),
    [anon_sym_GT_GT] = ACTIONS(2577),
    [anon_sym_PLUS] = ACTIONS(2579),
    [anon_sym_DASH] = ACTIONS(2579),
    [anon_sym_SLASH] = ACTIONS(2553),
    [anon_sym_PERCENT] = ACTIONS(2553),
    [anon_sym_DASH_DASH] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(1554),
    [anon_sym_DASH_GT] = ACTIONS(1554),
    [sym_comment] = ACTIONS(49),
  },
  [2992] = {
    [sym_argument_list] = STATE(802),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_RPAREN] = ACTIONS(7180),
    [anon_sym_STAR] = ACTIONS(4537),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_EQ] = ACTIONS(4539),
    [anon_sym_QMARK] = ACTIONS(4541),
    [anon_sym_STAR_EQ] = ACTIONS(4543),
    [anon_sym_SLASH_EQ] = ACTIONS(4543),
    [anon_sym_PERCENT_EQ] = ACTIONS(4543),
    [anon_sym_PLUS_EQ] = ACTIONS(4543),
    [anon_sym_DASH_EQ] = ACTIONS(4543),
    [anon_sym_LT_LT_EQ] = ACTIONS(4543),
    [anon_sym_GT_GT_EQ] = ACTIONS(4543),
    [anon_sym_AMP_EQ] = ACTIONS(4543),
    [anon_sym_CARET_EQ] = ACTIONS(4543),
    [anon_sym_PIPE_EQ] = ACTIONS(4543),
    [anon_sym_AMP] = ACTIONS(4545),
    [anon_sym_PIPE_PIPE] = ACTIONS(4547),
    [anon_sym_AMP_AMP] = ACTIONS(4549),
    [anon_sym_PIPE] = ACTIONS(4551),
    [anon_sym_CARET] = ACTIONS(4553),
    [anon_sym_EQ_EQ] = ACTIONS(4555),
    [anon_sym_BANG_EQ] = ACTIONS(4555),
    [anon_sym_LT] = ACTIONS(4557),
    [anon_sym_GT] = ACTIONS(4557),
    [anon_sym_LT_EQ] = ACTIONS(4559),
    [anon_sym_GT_EQ] = ACTIONS(4559),
    [anon_sym_LT_LT] = ACTIONS(4561),
    [anon_sym_GT_GT] = ACTIONS(4561),
    [anon_sym_PLUS] = ACTIONS(4563),
    [anon_sym_DASH] = ACTIONS(4563),
    [anon_sym_SLASH] = ACTIONS(4537),
    [anon_sym_PERCENT] = ACTIONS(4537),
    [anon_sym_DASH_DASH] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(1554),
    [anon_sym_DASH_GT] = ACTIONS(1554),
    [sym_comment] = ACTIONS(49),
  },
  [2993] = {
    [sym_compound_statement] = STATE(3067),
    [sym_labeled_statement] = STATE(3067),
    [sym_expression_statement] = STATE(3067),
    [sym_if_statement] = STATE(3067),
    [sym_switch_statement] = STATE(3067),
    [sym_case_statement] = STATE(3067),
    [sym_while_statement] = STATE(3067),
    [sym_do_statement] = STATE(3067),
    [sym_for_statement] = STATE(3067),
    [sym_return_statement] = STATE(3067),
    [sym_break_statement] = STATE(3067),
    [sym_continue_statement] = STATE(3067),
    [sym_goto_statement] = STATE(3067),
    [sym__expression] = STATE(873),
    [sym_comma_expression] = STATE(874),
    [sym_conditional_expression] = STATE(873),
    [sym_assignment_expression] = STATE(873),
    [sym_pointer_expression] = STATE(873),
    [sym_logical_expression] = STATE(873),
    [sym_bitwise_expression] = STATE(873),
    [sym_equality_expression] = STATE(873),
    [sym_relational_expression] = STATE(873),
    [sym_shift_expression] = STATE(873),
    [sym_math_expression] = STATE(873),
    [sym_cast_expression] = STATE(873),
    [sym_sizeof_expression] = STATE(873),
    [sym_subscript_expression] = STATE(873),
    [sym_call_expression] = STATE(873),
    [sym_field_expression] = STATE(873),
    [sym_compound_literal_expression] = STATE(873),
    [sym_parenthesized_expression] = STATE(873),
    [sym_concatenated_string] = STATE(873),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(873),
    [sym_for_range_loop] = STATE(3067),
    [sym_new_expression] = STATE(873),
    [sym_delete_expression] = STATE(873),
    [sym_lambda_expression] = STATE(873),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(1660),
    [anon_sym_LPAREN] = ACTIONS(626),
    [anon_sym_SEMI] = ACTIONS(1662),
    [anon_sym_LBRACE] = ACTIONS(1664),
    [anon_sym_STAR] = ACTIONS(644),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_if] = ACTIONS(6297),
    [anon_sym_switch] = ACTIONS(6299),
    [anon_sym_case] = ACTIONS(6301),
    [anon_sym_default] = ACTIONS(6303),
    [anon_sym_while] = ACTIONS(6305),
    [anon_sym_do] = ACTIONS(1676),
    [anon_sym_for] = ACTIONS(6307),
    [anon_sym_return] = ACTIONS(1680),
    [anon_sym_break] = ACTIONS(1682),
    [anon_sym_continue] = ACTIONS(1684),
    [anon_sym_goto] = ACTIONS(1686),
    [anon_sym_AMP] = ACTIONS(644),
    [anon_sym_BANG] = ACTIONS(668),
    [anon_sym_TILDE] = ACTIONS(670),
    [anon_sym_PLUS] = ACTIONS(672),
    [anon_sym_DASH] = ACTIONS(672),
    [anon_sym_DASH_DASH] = ACTIONS(674),
    [anon_sym_PLUS_PLUS] = ACTIONS(674),
    [anon_sym_sizeof] = ACTIONS(676),
    [sym_number_literal] = ACTIONS(1660),
    [sym_char_literal] = ACTIONS(1660),
    [sym_string_literal] = ACTIONS(678),
    [sym_true] = ACTIONS(1688),
    [sym_false] = ACTIONS(1688),
    [sym_null] = ACTIONS(1688),
    [sym_identifier] = ACTIONS(6309),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1303),
    [anon_sym_delete] = ACTIONS(686),
    [sym_nullptr] = ACTIONS(1688),
  },
  [2994] = {
    [sym_argument_list] = STATE(802),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_RPAREN] = ACTIONS(7182),
    [anon_sym_STAR] = ACTIONS(4537),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_EQ] = ACTIONS(4539),
    [anon_sym_QMARK] = ACTIONS(4541),
    [anon_sym_STAR_EQ] = ACTIONS(4543),
    [anon_sym_SLASH_EQ] = ACTIONS(4543),
    [anon_sym_PERCENT_EQ] = ACTIONS(4543),
    [anon_sym_PLUS_EQ] = ACTIONS(4543),
    [anon_sym_DASH_EQ] = ACTIONS(4543),
    [anon_sym_LT_LT_EQ] = ACTIONS(4543),
    [anon_sym_GT_GT_EQ] = ACTIONS(4543),
    [anon_sym_AMP_EQ] = ACTIONS(4543),
    [anon_sym_CARET_EQ] = ACTIONS(4543),
    [anon_sym_PIPE_EQ] = ACTIONS(4543),
    [anon_sym_AMP] = ACTIONS(4545),
    [anon_sym_PIPE_PIPE] = ACTIONS(4547),
    [anon_sym_AMP_AMP] = ACTIONS(4549),
    [anon_sym_PIPE] = ACTIONS(4551),
    [anon_sym_CARET] = ACTIONS(4553),
    [anon_sym_EQ_EQ] = ACTIONS(4555),
    [anon_sym_BANG_EQ] = ACTIONS(4555),
    [anon_sym_LT] = ACTIONS(4557),
    [anon_sym_GT] = ACTIONS(4557),
    [anon_sym_LT_EQ] = ACTIONS(4559),
    [anon_sym_GT_EQ] = ACTIONS(4559),
    [anon_sym_LT_LT] = ACTIONS(4561),
    [anon_sym_GT_GT] = ACTIONS(4561),
    [anon_sym_PLUS] = ACTIONS(4563),
    [anon_sym_DASH] = ACTIONS(4563),
    [anon_sym_SLASH] = ACTIONS(4537),
    [anon_sym_PERCENT] = ACTIONS(4537),
    [anon_sym_DASH_DASH] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(1554),
    [anon_sym_DASH_GT] = ACTIONS(1554),
    [sym_comment] = ACTIONS(49),
  },
  [2995] = {
    [sym_compound_statement] = STATE(2627),
    [sym_labeled_statement] = STATE(2627),
    [sym_expression_statement] = STATE(2627),
    [sym_if_statement] = STATE(2627),
    [sym_switch_statement] = STATE(2627),
    [sym_case_statement] = STATE(2627),
    [sym_while_statement] = STATE(2627),
    [sym_do_statement] = STATE(2627),
    [sym_for_statement] = STATE(2627),
    [sym_return_statement] = STATE(2627),
    [sym_break_statement] = STATE(2627),
    [sym_continue_statement] = STATE(2627),
    [sym_goto_statement] = STATE(2627),
    [sym__expression] = STATE(873),
    [sym_comma_expression] = STATE(874),
    [sym_conditional_expression] = STATE(873),
    [sym_assignment_expression] = STATE(873),
    [sym_pointer_expression] = STATE(873),
    [sym_logical_expression] = STATE(873),
    [sym_bitwise_expression] = STATE(873),
    [sym_equality_expression] = STATE(873),
    [sym_relational_expression] = STATE(873),
    [sym_shift_expression] = STATE(873),
    [sym_math_expression] = STATE(873),
    [sym_cast_expression] = STATE(873),
    [sym_sizeof_expression] = STATE(873),
    [sym_subscript_expression] = STATE(873),
    [sym_call_expression] = STATE(873),
    [sym_field_expression] = STATE(873),
    [sym_compound_literal_expression] = STATE(873),
    [sym_parenthesized_expression] = STATE(873),
    [sym_concatenated_string] = STATE(873),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(873),
    [sym_for_range_loop] = STATE(2627),
    [sym_new_expression] = STATE(873),
    [sym_delete_expression] = STATE(873),
    [sym_lambda_expression] = STATE(873),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(1660),
    [anon_sym_LPAREN] = ACTIONS(626),
    [anon_sym_SEMI] = ACTIONS(1662),
    [anon_sym_LBRACE] = ACTIONS(1664),
    [anon_sym_STAR] = ACTIONS(644),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_if] = ACTIONS(6297),
    [anon_sym_switch] = ACTIONS(6299),
    [anon_sym_case] = ACTIONS(6301),
    [anon_sym_default] = ACTIONS(6303),
    [anon_sym_while] = ACTIONS(6305),
    [anon_sym_do] = ACTIONS(1676),
    [anon_sym_for] = ACTIONS(6307),
    [anon_sym_return] = ACTIONS(1680),
    [anon_sym_break] = ACTIONS(1682),
    [anon_sym_continue] = ACTIONS(1684),
    [anon_sym_goto] = ACTIONS(1686),
    [anon_sym_AMP] = ACTIONS(644),
    [anon_sym_BANG] = ACTIONS(668),
    [anon_sym_TILDE] = ACTIONS(670),
    [anon_sym_PLUS] = ACTIONS(672),
    [anon_sym_DASH] = ACTIONS(672),
    [anon_sym_DASH_DASH] = ACTIONS(674),
    [anon_sym_PLUS_PLUS] = ACTIONS(674),
    [anon_sym_sizeof] = ACTIONS(676),
    [sym_number_literal] = ACTIONS(1660),
    [sym_char_literal] = ACTIONS(1660),
    [sym_string_literal] = ACTIONS(678),
    [sym_true] = ACTIONS(1688),
    [sym_false] = ACTIONS(1688),
    [sym_null] = ACTIONS(1688),
    [sym_identifier] = ACTIONS(6309),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1303),
    [anon_sym_delete] = ACTIONS(686),
    [sym_nullptr] = ACTIONS(1688),
  },
  [2996] = {
    [sym_compound_statement] = STATE(2632),
    [sym_labeled_statement] = STATE(2632),
    [sym_expression_statement] = STATE(2632),
    [sym_if_statement] = STATE(2632),
    [sym_switch_statement] = STATE(2632),
    [sym_case_statement] = STATE(2632),
    [sym_while_statement] = STATE(2632),
    [sym_do_statement] = STATE(2632),
    [sym_for_statement] = STATE(2632),
    [sym_return_statement] = STATE(2632),
    [sym_break_statement] = STATE(2632),
    [sym_continue_statement] = STATE(2632),
    [sym_goto_statement] = STATE(2632),
    [sym__expression] = STATE(873),
    [sym_comma_expression] = STATE(874),
    [sym_conditional_expression] = STATE(873),
    [sym_assignment_expression] = STATE(873),
    [sym_pointer_expression] = STATE(873),
    [sym_logical_expression] = STATE(873),
    [sym_bitwise_expression] = STATE(873),
    [sym_equality_expression] = STATE(873),
    [sym_relational_expression] = STATE(873),
    [sym_shift_expression] = STATE(873),
    [sym_math_expression] = STATE(873),
    [sym_cast_expression] = STATE(873),
    [sym_sizeof_expression] = STATE(873),
    [sym_subscript_expression] = STATE(873),
    [sym_call_expression] = STATE(873),
    [sym_field_expression] = STATE(873),
    [sym_compound_literal_expression] = STATE(873),
    [sym_parenthesized_expression] = STATE(873),
    [sym_concatenated_string] = STATE(873),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(873),
    [sym_for_range_loop] = STATE(2632),
    [sym_new_expression] = STATE(873),
    [sym_delete_expression] = STATE(873),
    [sym_lambda_expression] = STATE(873),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(1660),
    [anon_sym_LPAREN] = ACTIONS(626),
    [anon_sym_SEMI] = ACTIONS(1662),
    [anon_sym_LBRACE] = ACTIONS(1664),
    [anon_sym_STAR] = ACTIONS(644),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_if] = ACTIONS(6297),
    [anon_sym_switch] = ACTIONS(6299),
    [anon_sym_case] = ACTIONS(6301),
    [anon_sym_default] = ACTIONS(6303),
    [anon_sym_while] = ACTIONS(6305),
    [anon_sym_do] = ACTIONS(1676),
    [anon_sym_for] = ACTIONS(6307),
    [anon_sym_return] = ACTIONS(1680),
    [anon_sym_break] = ACTIONS(1682),
    [anon_sym_continue] = ACTIONS(1684),
    [anon_sym_goto] = ACTIONS(1686),
    [anon_sym_AMP] = ACTIONS(644),
    [anon_sym_BANG] = ACTIONS(668),
    [anon_sym_TILDE] = ACTIONS(670),
    [anon_sym_PLUS] = ACTIONS(672),
    [anon_sym_DASH] = ACTIONS(672),
    [anon_sym_DASH_DASH] = ACTIONS(674),
    [anon_sym_PLUS_PLUS] = ACTIONS(674),
    [anon_sym_sizeof] = ACTIONS(676),
    [sym_number_literal] = ACTIONS(1660),
    [sym_char_literal] = ACTIONS(1660),
    [sym_string_literal] = ACTIONS(678),
    [sym_true] = ACTIONS(1688),
    [sym_false] = ACTIONS(1688),
    [sym_null] = ACTIONS(1688),
    [sym_identifier] = ACTIONS(6309),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1303),
    [anon_sym_delete] = ACTIONS(686),
    [sym_nullptr] = ACTIONS(1688),
  },
  [2997] = {
    [sym__expression] = STATE(3070),
    [sym_conditional_expression] = STATE(3070),
    [sym_assignment_expression] = STATE(3070),
    [sym_pointer_expression] = STATE(3070),
    [sym_logical_expression] = STATE(3070),
    [sym_bitwise_expression] = STATE(3070),
    [sym_equality_expression] = STATE(3070),
    [sym_relational_expression] = STATE(3070),
    [sym_shift_expression] = STATE(3070),
    [sym_math_expression] = STATE(3070),
    [sym_cast_expression] = STATE(3070),
    [sym_sizeof_expression] = STATE(3070),
    [sym_subscript_expression] = STATE(3070),
    [sym_call_expression] = STATE(3070),
    [sym_field_expression] = STATE(3070),
    [sym_compound_literal_expression] = STATE(3070),
    [sym_parenthesized_expression] = STATE(3070),
    [sym_concatenated_string] = STATE(3070),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(3070),
    [sym_new_expression] = STATE(3070),
    [sym_delete_expression] = STATE(3070),
    [sym_lambda_expression] = STATE(3070),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(7184),
    [anon_sym_LPAREN] = ACTIONS(1087),
    [anon_sym_RPAREN] = ACTIONS(7186),
    [anon_sym_STAR] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_AMP] = ACTIONS(1089),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1093),
    [anon_sym_PLUS] = ACTIONS(1095),
    [anon_sym_DASH] = ACTIONS(1095),
    [anon_sym_DASH_DASH] = ACTIONS(1097),
    [anon_sym_PLUS_PLUS] = ACTIONS(1097),
    [anon_sym_sizeof] = ACTIONS(1099),
    [sym_number_literal] = ACTIONS(7184),
    [sym_char_literal] = ACTIONS(7184),
    [sym_string_literal] = ACTIONS(1101),
    [sym_true] = ACTIONS(7188),
    [sym_false] = ACTIONS(7188),
    [sym_null] = ACTIONS(7188),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_delete] = ACTIONS(1109),
    [sym_nullptr] = ACTIONS(7188),
  },
  [2998] = {
    [sym_argument_list] = STATE(802),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_SEMI] = ACTIONS(7190),
    [anon_sym_STAR] = ACTIONS(2553),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_EQ] = ACTIONS(2555),
    [anon_sym_QMARK] = ACTIONS(2557),
    [anon_sym_STAR_EQ] = ACTIONS(2559),
    [anon_sym_SLASH_EQ] = ACTIONS(2559),
    [anon_sym_PERCENT_EQ] = ACTIONS(2559),
    [anon_sym_PLUS_EQ] = ACTIONS(2559),
    [anon_sym_DASH_EQ] = ACTIONS(2559),
    [anon_sym_LT_LT_EQ] = ACTIONS(2559),
    [anon_sym_GT_GT_EQ] = ACTIONS(2559),
    [anon_sym_AMP_EQ] = ACTIONS(2559),
    [anon_sym_CARET_EQ] = ACTIONS(2559),
    [anon_sym_PIPE_EQ] = ACTIONS(2559),
    [anon_sym_AMP] = ACTIONS(2561),
    [anon_sym_PIPE_PIPE] = ACTIONS(2563),
    [anon_sym_AMP_AMP] = ACTIONS(2565),
    [anon_sym_PIPE] = ACTIONS(2567),
    [anon_sym_CARET] = ACTIONS(2569),
    [anon_sym_EQ_EQ] = ACTIONS(2571),
    [anon_sym_BANG_EQ] = ACTIONS(2571),
    [anon_sym_LT] = ACTIONS(2573),
    [anon_sym_GT] = ACTIONS(2573),
    [anon_sym_LT_EQ] = ACTIONS(2575),
    [anon_sym_GT_EQ] = ACTIONS(2575),
    [anon_sym_LT_LT] = ACTIONS(2577),
    [anon_sym_GT_GT] = ACTIONS(2577),
    [anon_sym_PLUS] = ACTIONS(2579),
    [anon_sym_DASH] = ACTIONS(2579),
    [anon_sym_SLASH] = ACTIONS(2553),
    [anon_sym_PERCENT] = ACTIONS(2553),
    [anon_sym_DASH_DASH] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(1554),
    [anon_sym_DASH_GT] = ACTIONS(1554),
    [sym_comment] = ACTIONS(49),
  },
  [2999] = {
    [sym__expression] = STATE(3072),
    [sym_conditional_expression] = STATE(3072),
    [sym_assignment_expression] = STATE(3072),
    [sym_pointer_expression] = STATE(3072),
    [sym_logical_expression] = STATE(3072),
    [sym_bitwise_expression] = STATE(3072),
    [sym_equality_expression] = STATE(3072),
    [sym_relational_expression] = STATE(3072),
    [sym_shift_expression] = STATE(3072),
    [sym_math_expression] = STATE(3072),
    [sym_cast_expression] = STATE(3072),
    [sym_sizeof_expression] = STATE(3072),
    [sym_subscript_expression] = STATE(3072),
    [sym_call_expression] = STATE(3072),
    [sym_field_expression] = STATE(3072),
    [sym_compound_literal_expression] = STATE(3072),
    [sym_parenthesized_expression] = STATE(3072),
    [sym_concatenated_string] = STATE(3072),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(3072),
    [sym_new_expression] = STATE(3072),
    [sym_delete_expression] = STATE(3072),
    [sym_lambda_expression] = STATE(3072),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(7192),
    [anon_sym_LPAREN] = ACTIONS(1347),
    [anon_sym_SEMI] = ACTIONS(7190),
    [anon_sym_STAR] = ACTIONS(1349),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_AMP] = ACTIONS(1349),
    [anon_sym_BANG] = ACTIONS(1351),
    [anon_sym_TILDE] = ACTIONS(1353),
    [anon_sym_PLUS] = ACTIONS(1355),
    [anon_sym_DASH] = ACTIONS(1355),
    [anon_sym_DASH_DASH] = ACTIONS(1357),
    [anon_sym_PLUS_PLUS] = ACTIONS(1357),
    [anon_sym_sizeof] = ACTIONS(1359),
    [sym_number_literal] = ACTIONS(7192),
    [sym_char_literal] = ACTIONS(7192),
    [sym_string_literal] = ACTIONS(1361),
    [sym_true] = ACTIONS(7194),
    [sym_false] = ACTIONS(7194),
    [sym_null] = ACTIONS(7194),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1365),
    [anon_sym_delete] = ACTIONS(1367),
    [sym_nullptr] = ACTIONS(7194),
  },
  [3000] = {
    [sym__expression] = STATE(3073),
    [sym_conditional_expression] = STATE(3073),
    [sym_assignment_expression] = STATE(3073),
    [sym_pointer_expression] = STATE(3073),
    [sym_logical_expression] = STATE(3073),
    [sym_bitwise_expression] = STATE(3073),
    [sym_equality_expression] = STATE(3073),
    [sym_relational_expression] = STATE(3073),
    [sym_shift_expression] = STATE(3073),
    [sym_math_expression] = STATE(3073),
    [sym_cast_expression] = STATE(3073),
    [sym_sizeof_expression] = STATE(3073),
    [sym_subscript_expression] = STATE(3073),
    [sym_call_expression] = STATE(3073),
    [sym_field_expression] = STATE(3073),
    [sym_compound_literal_expression] = STATE(3073),
    [sym_parenthesized_expression] = STATE(3073),
    [sym_concatenated_string] = STATE(3073),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(3073),
    [sym_new_expression] = STATE(3073),
    [sym_delete_expression] = STATE(3073),
    [sym_lambda_expression] = STATE(3073),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(7196),
    [anon_sym_LPAREN] = ACTIONS(2943),
    [anon_sym_STAR] = ACTIONS(2945),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_AMP] = ACTIONS(2945),
    [anon_sym_BANG] = ACTIONS(2947),
    [anon_sym_TILDE] = ACTIONS(2949),
    [anon_sym_PLUS] = ACTIONS(2951),
    [anon_sym_DASH] = ACTIONS(2951),
    [anon_sym_DASH_DASH] = ACTIONS(2953),
    [anon_sym_PLUS_PLUS] = ACTIONS(2953),
    [anon_sym_sizeof] = ACTIONS(2955),
    [sym_number_literal] = ACTIONS(7196),
    [sym_char_literal] = ACTIONS(7196),
    [sym_string_literal] = ACTIONS(2957),
    [sym_true] = ACTIONS(7198),
    [sym_false] = ACTIONS(7198),
    [sym_null] = ACTIONS(7198),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(2961),
    [anon_sym_delete] = ACTIONS(2963),
    [sym_nullptr] = ACTIONS(7198),
  },
  [3001] = {
    [anon_sym_else] = ACTIONS(7057),
    [anon_sym_while] = ACTIONS(7057),
    [sym_comment] = ACTIONS(49),
  },
  [3002] = {
    [anon_sym_else] = ACTIONS(7083),
    [anon_sym_while] = ACTIONS(7083),
    [sym_comment] = ACTIONS(49),
  },
  [3003] = {
    [sym_compound_statement] = STATE(3074),
    [sym_labeled_statement] = STATE(3074),
    [sym_expression_statement] = STATE(3074),
    [sym_if_statement] = STATE(3074),
    [sym_switch_statement] = STATE(3074),
    [sym_case_statement] = STATE(3074),
    [sym_while_statement] = STATE(3074),
    [sym_do_statement] = STATE(3074),
    [sym_for_statement] = STATE(3074),
    [sym_return_statement] = STATE(3074),
    [sym_break_statement] = STATE(3074),
    [sym_continue_statement] = STATE(3074),
    [sym_goto_statement] = STATE(3074),
    [sym__expression] = STATE(873),
    [sym_comma_expression] = STATE(874),
    [sym_conditional_expression] = STATE(873),
    [sym_assignment_expression] = STATE(873),
    [sym_pointer_expression] = STATE(873),
    [sym_logical_expression] = STATE(873),
    [sym_bitwise_expression] = STATE(873),
    [sym_equality_expression] = STATE(873),
    [sym_relational_expression] = STATE(873),
    [sym_shift_expression] = STATE(873),
    [sym_math_expression] = STATE(873),
    [sym_cast_expression] = STATE(873),
    [sym_sizeof_expression] = STATE(873),
    [sym_subscript_expression] = STATE(873),
    [sym_call_expression] = STATE(873),
    [sym_field_expression] = STATE(873),
    [sym_compound_literal_expression] = STATE(873),
    [sym_parenthesized_expression] = STATE(873),
    [sym_concatenated_string] = STATE(873),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(873),
    [sym_for_range_loop] = STATE(3074),
    [sym_new_expression] = STATE(873),
    [sym_delete_expression] = STATE(873),
    [sym_lambda_expression] = STATE(873),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(1660),
    [anon_sym_LPAREN] = ACTIONS(626),
    [anon_sym_SEMI] = ACTIONS(1662),
    [anon_sym_LBRACE] = ACTIONS(1664),
    [anon_sym_STAR] = ACTIONS(644),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_if] = ACTIONS(1666),
    [anon_sym_switch] = ACTIONS(1668),
    [anon_sym_case] = ACTIONS(1670),
    [anon_sym_default] = ACTIONS(1672),
    [anon_sym_while] = ACTIONS(1674),
    [anon_sym_do] = ACTIONS(1676),
    [anon_sym_for] = ACTIONS(1678),
    [anon_sym_return] = ACTIONS(1680),
    [anon_sym_break] = ACTIONS(1682),
    [anon_sym_continue] = ACTIONS(1684),
    [anon_sym_goto] = ACTIONS(1686),
    [anon_sym_AMP] = ACTIONS(644),
    [anon_sym_BANG] = ACTIONS(668),
    [anon_sym_TILDE] = ACTIONS(670),
    [anon_sym_PLUS] = ACTIONS(672),
    [anon_sym_DASH] = ACTIONS(672),
    [anon_sym_DASH_DASH] = ACTIONS(674),
    [anon_sym_PLUS_PLUS] = ACTIONS(674),
    [anon_sym_sizeof] = ACTIONS(676),
    [sym_number_literal] = ACTIONS(1660),
    [sym_char_literal] = ACTIONS(1660),
    [sym_string_literal] = ACTIONS(678),
    [sym_true] = ACTIONS(1688),
    [sym_false] = ACTIONS(1688),
    [sym_null] = ACTIONS(1688),
    [sym_identifier] = ACTIONS(1690),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1303),
    [anon_sym_delete] = ACTIONS(686),
    [sym_nullptr] = ACTIONS(1688),
  },
  [3004] = {
    [aux_sym_for_statement_repeat1] = STATE(2796),
    [anon_sym_COMMA] = ACTIONS(6339),
    [anon_sym_RPAREN] = ACTIONS(7200),
    [sym_comment] = ACTIONS(49),
  },
  [3005] = {
    [sym_raw_string_literal] = ACTIONS(7202),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(7204),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(7204),
    [anon_sym_LPAREN] = ACTIONS(7202),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(7204),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(7204),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(7204),
    [sym_preproc_directive] = ACTIONS(7204),
    [anon_sym_SEMI] = ACTIONS(7202),
    [anon_sym_typedef] = ACTIONS(7204),
    [anon_sym_extern] = ACTIONS(7204),
    [anon_sym_LBRACE] = ACTIONS(7202),
    [anon_sym_RBRACE] = ACTIONS(7202),
    [anon_sym_STAR] = ACTIONS(7202),
    [anon_sym_LBRACK] = ACTIONS(7202),
    [anon_sym_static] = ACTIONS(7204),
    [anon_sym_register] = ACTIONS(7204),
    [anon_sym_inline] = ACTIONS(7204),
    [anon_sym_const] = ACTIONS(7204),
    [anon_sym_restrict] = ACTIONS(7204),
    [anon_sym_volatile] = ACTIONS(7204),
    [anon_sym__Atomic] = ACTIONS(7204),
    [anon_sym_mutable] = ACTIONS(7204),
    [anon_sym_explicit] = ACTIONS(7204),
    [anon_sym_constexpr] = ACTIONS(7204),
    [anon_sym_unsigned] = ACTIONS(7204),
    [anon_sym_long] = ACTIONS(7204),
    [anon_sym_short] = ACTIONS(7204),
    [sym_primitive_type] = ACTIONS(7204),
    [anon_sym_enum] = ACTIONS(7204),
    [anon_sym_struct] = ACTIONS(7204),
    [anon_sym_union] = ACTIONS(7204),
    [anon_sym_if] = ACTIONS(7204),
    [anon_sym_switch] = ACTIONS(7204),
    [anon_sym_case] = ACTIONS(7204),
    [anon_sym_default] = ACTIONS(7204),
    [anon_sym_while] = ACTIONS(7204),
    [anon_sym_do] = ACTIONS(7204),
    [anon_sym_for] = ACTIONS(7204),
    [anon_sym_return] = ACTIONS(7204),
    [anon_sym_break] = ACTIONS(7204),
    [anon_sym_continue] = ACTIONS(7204),
    [anon_sym_goto] = ACTIONS(7204),
    [anon_sym_AMP] = ACTIONS(7202),
    [anon_sym_BANG] = ACTIONS(7202),
    [anon_sym_TILDE] = ACTIONS(7202),
    [anon_sym_PLUS] = ACTIONS(7204),
    [anon_sym_DASH] = ACTIONS(7204),
    [anon_sym_DASH_DASH] = ACTIONS(7202),
    [anon_sym_PLUS_PLUS] = ACTIONS(7202),
    [anon_sym_sizeof] = ACTIONS(7204),
    [sym_number_literal] = ACTIONS(7202),
    [sym_char_literal] = ACTIONS(7202),
    [sym_string_literal] = ACTIONS(7202),
    [sym_true] = ACTIONS(7204),
    [sym_false] = ACTIONS(7204),
    [sym_null] = ACTIONS(7204),
    [sym_identifier] = ACTIONS(7204),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(7204),
    [sym_auto] = ACTIONS(7204),
    [anon_sym_typename] = ACTIONS(7204),
    [anon_sym_new] = ACTIONS(7204),
    [anon_sym_COLON_COLON] = ACTIONS(7202),
    [anon_sym_delete] = ACTIONS(7204),
    [sym_nullptr] = ACTIONS(7204),
  },
  [3006] = {
    [sym_parameter_list] = STATE(3008),
    [anon_sym_LPAREN] = ACTIONS(206),
    [anon_sym_COMMA] = ACTIONS(3750),
    [anon_sym_SEMI] = ACTIONS(3750),
    [anon_sym_LBRACE] = ACTIONS(3750),
    [anon_sym_LBRACK] = ACTIONS(2282),
    [anon_sym_EQ] = ACTIONS(3750),
    [anon_sym_const] = ACTIONS(5283),
    [anon_sym_restrict] = ACTIONS(3750),
    [anon_sym_volatile] = ACTIONS(3750),
    [anon_sym__Atomic] = ACTIONS(3750),
    [anon_sym_mutable] = ACTIONS(3750),
    [anon_sym_explicit] = ACTIONS(3750),
    [anon_sym_constexpr] = ACTIONS(3750),
    [anon_sym_COLON] = ACTIONS(3750),
    [anon_sym_DASH_GT] = ACTIONS(3750),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(3750),
  },
  [3007] = {
    [sym_parameter_list] = STATE(3008),
    [anon_sym_LPAREN] = ACTIONS(206),
    [anon_sym_COMMA] = ACTIONS(3762),
    [anon_sym_SEMI] = ACTIONS(3762),
    [anon_sym_LBRACE] = ACTIONS(3762),
    [anon_sym_LBRACK] = ACTIONS(2282),
    [anon_sym_EQ] = ACTIONS(3762),
    [anon_sym_const] = ACTIONS(5285),
    [anon_sym_restrict] = ACTIONS(3762),
    [anon_sym_volatile] = ACTIONS(3762),
    [anon_sym__Atomic] = ACTIONS(3762),
    [anon_sym_mutable] = ACTIONS(3762),
    [anon_sym_explicit] = ACTIONS(3762),
    [anon_sym_constexpr] = ACTIONS(3762),
    [anon_sym_COLON] = ACTIONS(3762),
    [anon_sym_DASH_GT] = ACTIONS(3762),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(3762),
  },
  [3008] = {
    [sym_type_qualifier] = STATE(3076),
    [sym_trailing_return_type] = STATE(1713),
    [aux_sym_abstract_function_declarator_repeat1] = STATE(3076),
    [anon_sym_LPAREN] = ACTIONS(3764),
    [anon_sym_COMMA] = ACTIONS(3764),
    [anon_sym_SEMI] = ACTIONS(3764),
    [anon_sym_LBRACE] = ACTIONS(3764),
    [anon_sym_LBRACK] = ACTIONS(3764),
    [anon_sym_EQ] = ACTIONS(3764),
    [anon_sym_const] = ACTIONS(3770),
    [anon_sym_restrict] = ACTIONS(3764),
    [anon_sym_volatile] = ACTIONS(3764),
    [anon_sym__Atomic] = ACTIONS(3764),
    [anon_sym_mutable] = ACTIONS(3764),
    [anon_sym_explicit] = ACTIONS(3764),
    [anon_sym_constexpr] = ACTIONS(3764),
    [anon_sym_COLON] = ACTIONS(3764),
    [anon_sym_DASH_GT] = ACTIONS(3764),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(3764),
  },
  [3009] = {
    [sym_type_qualifier] = STATE(3077),
    [sym_trailing_return_type] = STATE(1713),
    [aux_sym_abstract_function_declarator_repeat1] = STATE(3077),
    [anon_sym_LPAREN] = ACTIONS(3764),
    [anon_sym_COMMA] = ACTIONS(3764),
    [anon_sym_SEMI] = ACTIONS(3764),
    [anon_sym_LBRACE] = ACTIONS(3764),
    [anon_sym_LBRACK] = ACTIONS(3764),
    [anon_sym_EQ] = ACTIONS(3764),
    [anon_sym_const] = ACTIONS(612),
    [anon_sym_restrict] = ACTIONS(614),
    [anon_sym_volatile] = ACTIONS(614),
    [anon_sym__Atomic] = ACTIONS(614),
    [anon_sym_mutable] = ACTIONS(614),
    [anon_sym_explicit] = ACTIONS(614),
    [anon_sym_constexpr] = ACTIONS(614),
    [anon_sym_COLON] = ACTIONS(3764),
    [anon_sym_DASH_GT] = ACTIONS(6347),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(7206),
  },
  [3010] = {
    [sym_compound_statement] = STATE(3078),
    [sym_labeled_statement] = STATE(3078),
    [sym_expression_statement] = STATE(3078),
    [sym_if_statement] = STATE(3078),
    [sym_switch_statement] = STATE(3078),
    [sym_case_statement] = STATE(3078),
    [sym_while_statement] = STATE(3078),
    [sym_do_statement] = STATE(3078),
    [sym_for_statement] = STATE(3078),
    [sym_return_statement] = STATE(3078),
    [sym_break_statement] = STATE(3078),
    [sym_continue_statement] = STATE(3078),
    [sym_goto_statement] = STATE(3078),
    [sym__expression] = STATE(413),
    [sym_comma_expression] = STATE(414),
    [sym_conditional_expression] = STATE(413),
    [sym_assignment_expression] = STATE(413),
    [sym_pointer_expression] = STATE(413),
    [sym_logical_expression] = STATE(413),
    [sym_bitwise_expression] = STATE(413),
    [sym_equality_expression] = STATE(413),
    [sym_relational_expression] = STATE(413),
    [sym_shift_expression] = STATE(413),
    [sym_math_expression] = STATE(413),
    [sym_cast_expression] = STATE(413),
    [sym_sizeof_expression] = STATE(413),
    [sym_subscript_expression] = STATE(413),
    [sym_call_expression] = STATE(413),
    [sym_field_expression] = STATE(413),
    [sym_compound_literal_expression] = STATE(413),
    [sym_parenthesized_expression] = STATE(413),
    [sym_concatenated_string] = STATE(413),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(413),
    [sym_for_range_loop] = STATE(3078),
    [sym_new_expression] = STATE(413),
    [sym_delete_expression] = STATE(413),
    [sym_lambda_expression] = STATE(413),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(620),
    [anon_sym_LPAREN] = ACTIONS(626),
    [anon_sym_SEMI] = ACTIONS(636),
    [anon_sym_LBRACE] = ACTIONS(640),
    [anon_sym_STAR] = ACTIONS(644),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_if] = ACTIONS(646),
    [anon_sym_switch] = ACTIONS(648),
    [anon_sym_case] = ACTIONS(650),
    [anon_sym_default] = ACTIONS(652),
    [anon_sym_while] = ACTIONS(654),
    [anon_sym_do] = ACTIONS(656),
    [anon_sym_for] = ACTIONS(658),
    [anon_sym_return] = ACTIONS(660),
    [anon_sym_break] = ACTIONS(662),
    [anon_sym_continue] = ACTIONS(664),
    [anon_sym_goto] = ACTIONS(666),
    [anon_sym_AMP] = ACTIONS(644),
    [anon_sym_BANG] = ACTIONS(668),
    [anon_sym_TILDE] = ACTIONS(670),
    [anon_sym_PLUS] = ACTIONS(672),
    [anon_sym_DASH] = ACTIONS(672),
    [anon_sym_DASH_DASH] = ACTIONS(674),
    [anon_sym_PLUS_PLUS] = ACTIONS(674),
    [anon_sym_sizeof] = ACTIONS(676),
    [sym_number_literal] = ACTIONS(620),
    [sym_char_literal] = ACTIONS(620),
    [sym_string_literal] = ACTIONS(678),
    [sym_true] = ACTIONS(680),
    [sym_false] = ACTIONS(680),
    [sym_null] = ACTIONS(680),
    [sym_identifier] = ACTIONS(3110),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1303),
    [anon_sym_delete] = ACTIONS(686),
    [sym_nullptr] = ACTIONS(680),
  },
  [3011] = {
    [sym_type_qualifier] = STATE(3012),
    [sym_trailing_return_type] = STATE(2168),
    [aux_sym_abstract_function_declarator_repeat1] = STATE(3012),
    [anon_sym_LPAREN] = ACTIONS(4998),
    [anon_sym_COMMA] = ACTIONS(4998),
    [anon_sym_SEMI] = ACTIONS(4998),
    [anon_sym_LBRACK] = ACTIONS(4998),
    [anon_sym_const] = ACTIONS(612),
    [anon_sym_restrict] = ACTIONS(614),
    [anon_sym_volatile] = ACTIONS(614),
    [anon_sym__Atomic] = ACTIONS(614),
    [anon_sym_mutable] = ACTIONS(614),
    [anon_sym_explicit] = ACTIONS(614),
    [anon_sym_constexpr] = ACTIONS(614),
    [anon_sym_COLON] = ACTIONS(4998),
    [anon_sym_DASH_GT] = ACTIONS(5761),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(7092),
  },
  [3012] = {
    [sym_type_qualifier] = STATE(3012),
    [aux_sym_abstract_function_declarator_repeat1] = STATE(3012),
    [anon_sym_LPAREN] = ACTIONS(5002),
    [anon_sym_COMMA] = ACTIONS(5002),
    [anon_sym_SEMI] = ACTIONS(5002),
    [anon_sym_LBRACK] = ACTIONS(5002),
    [anon_sym_const] = ACTIONS(5004),
    [anon_sym_restrict] = ACTIONS(5007),
    [anon_sym_volatile] = ACTIONS(5007),
    [anon_sym__Atomic] = ACTIONS(5007),
    [anon_sym_mutable] = ACTIONS(5007),
    [anon_sym_explicit] = ACTIONS(5007),
    [anon_sym_constexpr] = ACTIONS(5007),
    [anon_sym_COLON] = ACTIONS(5002),
    [anon_sym_DASH_GT] = ACTIONS(5002),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(7208),
  },
  [3013] = {
    [sym_raw_string_literal] = ACTIONS(3182),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3184),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3184),
    [anon_sym_LPAREN] = ACTIONS(3182),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3184),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3184),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3184),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3184),
    [sym_preproc_directive] = ACTIONS(3184),
    [anon_sym_SEMI] = ACTIONS(3182),
    [anon_sym_typedef] = ACTIONS(3184),
    [anon_sym_extern] = ACTIONS(3184),
    [anon_sym_LBRACE] = ACTIONS(3182),
    [anon_sym_STAR] = ACTIONS(3182),
    [anon_sym_LBRACK] = ACTIONS(3182),
    [anon_sym_static] = ACTIONS(3184),
    [anon_sym_register] = ACTIONS(3184),
    [anon_sym_inline] = ACTIONS(3184),
    [anon_sym_const] = ACTIONS(3184),
    [anon_sym_restrict] = ACTIONS(3184),
    [anon_sym_volatile] = ACTIONS(3184),
    [anon_sym__Atomic] = ACTIONS(3184),
    [anon_sym_mutable] = ACTIONS(3184),
    [anon_sym_explicit] = ACTIONS(3184),
    [anon_sym_constexpr] = ACTIONS(3184),
    [anon_sym_unsigned] = ACTIONS(3184),
    [anon_sym_long] = ACTIONS(3184),
    [anon_sym_short] = ACTIONS(3184),
    [sym_primitive_type] = ACTIONS(3184),
    [anon_sym_enum] = ACTIONS(3184),
    [anon_sym_struct] = ACTIONS(3184),
    [anon_sym_union] = ACTIONS(3184),
    [anon_sym_if] = ACTIONS(3184),
    [anon_sym_else] = ACTIONS(3184),
    [anon_sym_switch] = ACTIONS(3184),
    [anon_sym_case] = ACTIONS(3184),
    [anon_sym_default] = ACTIONS(3184),
    [anon_sym_while] = ACTIONS(3184),
    [anon_sym_do] = ACTIONS(3184),
    [anon_sym_for] = ACTIONS(3184),
    [anon_sym_return] = ACTIONS(3184),
    [anon_sym_break] = ACTIONS(3184),
    [anon_sym_continue] = ACTIONS(3184),
    [anon_sym_goto] = ACTIONS(3184),
    [anon_sym_AMP] = ACTIONS(3182),
    [anon_sym_BANG] = ACTIONS(3182),
    [anon_sym_TILDE] = ACTIONS(3182),
    [anon_sym_PLUS] = ACTIONS(3184),
    [anon_sym_DASH] = ACTIONS(3184),
    [anon_sym_DASH_DASH] = ACTIONS(3182),
    [anon_sym_PLUS_PLUS] = ACTIONS(3182),
    [anon_sym_sizeof] = ACTIONS(3184),
    [sym_number_literal] = ACTIONS(3182),
    [sym_char_literal] = ACTIONS(3182),
    [sym_string_literal] = ACTIONS(3182),
    [sym_true] = ACTIONS(3184),
    [sym_false] = ACTIONS(3184),
    [sym_null] = ACTIONS(3184),
    [sym_identifier] = ACTIONS(3184),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(3184),
    [sym_auto] = ACTIONS(3184),
    [anon_sym_typename] = ACTIONS(3184),
    [anon_sym_new] = ACTIONS(3184),
    [anon_sym_COLON_COLON] = ACTIONS(3182),
    [anon_sym_delete] = ACTIONS(3184),
    [sym_nullptr] = ACTIONS(3184),
  },
  [3014] = {
    [sym_argument_list] = STATE(802),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_RPAREN] = ACTIONS(7211),
    [anon_sym_STAR] = ACTIONS(4537),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_EQ] = ACTIONS(4539),
    [anon_sym_QMARK] = ACTIONS(4541),
    [anon_sym_STAR_EQ] = ACTIONS(4543),
    [anon_sym_SLASH_EQ] = ACTIONS(4543),
    [anon_sym_PERCENT_EQ] = ACTIONS(4543),
    [anon_sym_PLUS_EQ] = ACTIONS(4543),
    [anon_sym_DASH_EQ] = ACTIONS(4543),
    [anon_sym_LT_LT_EQ] = ACTIONS(4543),
    [anon_sym_GT_GT_EQ] = ACTIONS(4543),
    [anon_sym_AMP_EQ] = ACTIONS(4543),
    [anon_sym_CARET_EQ] = ACTIONS(4543),
    [anon_sym_PIPE_EQ] = ACTIONS(4543),
    [anon_sym_AMP] = ACTIONS(4545),
    [anon_sym_PIPE_PIPE] = ACTIONS(4547),
    [anon_sym_AMP_AMP] = ACTIONS(4549),
    [anon_sym_PIPE] = ACTIONS(4551),
    [anon_sym_CARET] = ACTIONS(4553),
    [anon_sym_EQ_EQ] = ACTIONS(4555),
    [anon_sym_BANG_EQ] = ACTIONS(4555),
    [anon_sym_LT] = ACTIONS(4557),
    [anon_sym_GT] = ACTIONS(4557),
    [anon_sym_LT_EQ] = ACTIONS(4559),
    [anon_sym_GT_EQ] = ACTIONS(4559),
    [anon_sym_LT_LT] = ACTIONS(4561),
    [anon_sym_GT_GT] = ACTIONS(4561),
    [anon_sym_PLUS] = ACTIONS(4563),
    [anon_sym_DASH] = ACTIONS(4563),
    [anon_sym_SLASH] = ACTIONS(4537),
    [anon_sym_PERCENT] = ACTIONS(4537),
    [anon_sym_DASH_DASH] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(1554),
    [anon_sym_DASH_GT] = ACTIONS(1554),
    [sym_comment] = ACTIONS(49),
  },
  [3015] = {
    [sym__expression] = STATE(3080),
    [sym_conditional_expression] = STATE(3080),
    [sym_assignment_expression] = STATE(3080),
    [sym_pointer_expression] = STATE(3080),
    [sym_logical_expression] = STATE(3080),
    [sym_bitwise_expression] = STATE(3080),
    [sym_equality_expression] = STATE(3080),
    [sym_relational_expression] = STATE(3080),
    [sym_shift_expression] = STATE(3080),
    [sym_math_expression] = STATE(3080),
    [sym_cast_expression] = STATE(3080),
    [sym_sizeof_expression] = STATE(3080),
    [sym_subscript_expression] = STATE(3080),
    [sym_call_expression] = STATE(3080),
    [sym_field_expression] = STATE(3080),
    [sym_compound_literal_expression] = STATE(3080),
    [sym_parenthesized_expression] = STATE(3080),
    [sym_concatenated_string] = STATE(3080),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(3080),
    [sym_new_expression] = STATE(3080),
    [sym_delete_expression] = STATE(3080),
    [sym_lambda_expression] = STATE(3080),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(7213),
    [anon_sym_LPAREN] = ACTIONS(2943),
    [anon_sym_STAR] = ACTIONS(2945),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_AMP] = ACTIONS(2945),
    [anon_sym_BANG] = ACTIONS(2947),
    [anon_sym_TILDE] = ACTIONS(2949),
    [anon_sym_PLUS] = ACTIONS(2951),
    [anon_sym_DASH] = ACTIONS(2951),
    [anon_sym_DASH_DASH] = ACTIONS(2953),
    [anon_sym_PLUS_PLUS] = ACTIONS(2953),
    [anon_sym_sizeof] = ACTIONS(2955),
    [sym_number_literal] = ACTIONS(7213),
    [sym_char_literal] = ACTIONS(7213),
    [sym_string_literal] = ACTIONS(2957),
    [sym_true] = ACTIONS(7215),
    [sym_false] = ACTIONS(7215),
    [sym_null] = ACTIONS(7215),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(2961),
    [anon_sym_delete] = ACTIONS(2963),
    [sym_nullptr] = ACTIONS(7215),
  },
  [3016] = {
    [sym_argument_list] = STATE(802),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_RPAREN] = ACTIONS(7217),
    [anon_sym_STAR] = ACTIONS(4537),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_EQ] = ACTIONS(4539),
    [anon_sym_QMARK] = ACTIONS(4541),
    [anon_sym_STAR_EQ] = ACTIONS(4543),
    [anon_sym_SLASH_EQ] = ACTIONS(4543),
    [anon_sym_PERCENT_EQ] = ACTIONS(4543),
    [anon_sym_PLUS_EQ] = ACTIONS(4543),
    [anon_sym_DASH_EQ] = ACTIONS(4543),
    [anon_sym_LT_LT_EQ] = ACTIONS(4543),
    [anon_sym_GT_GT_EQ] = ACTIONS(4543),
    [anon_sym_AMP_EQ] = ACTIONS(4543),
    [anon_sym_CARET_EQ] = ACTIONS(4543),
    [anon_sym_PIPE_EQ] = ACTIONS(4543),
    [anon_sym_AMP] = ACTIONS(4545),
    [anon_sym_PIPE_PIPE] = ACTIONS(4547),
    [anon_sym_AMP_AMP] = ACTIONS(4549),
    [anon_sym_PIPE] = ACTIONS(4551),
    [anon_sym_CARET] = ACTIONS(4553),
    [anon_sym_EQ_EQ] = ACTIONS(4555),
    [anon_sym_BANG_EQ] = ACTIONS(4555),
    [anon_sym_LT] = ACTIONS(4557),
    [anon_sym_GT] = ACTIONS(4557),
    [anon_sym_LT_EQ] = ACTIONS(4559),
    [anon_sym_GT_EQ] = ACTIONS(4559),
    [anon_sym_LT_LT] = ACTIONS(4561),
    [anon_sym_GT_GT] = ACTIONS(4561),
    [anon_sym_PLUS] = ACTIONS(4563),
    [anon_sym_DASH] = ACTIONS(4563),
    [anon_sym_SLASH] = ACTIONS(4537),
    [anon_sym_PERCENT] = ACTIONS(4537),
    [anon_sym_DASH_DASH] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(1554),
    [anon_sym_DASH_GT] = ACTIONS(1554),
    [sym_comment] = ACTIONS(49),
  },
  [3017] = {
    [sym_declaration] = STATE(3082),
    [sym_type_definition] = STATE(3082),
    [sym__declaration_specifiers] = STATE(3021),
    [sym_compound_statement] = STATE(3082),
    [sym_storage_class_specifier] = STATE(109),
    [sym_type_qualifier] = STATE(109),
    [sym__type_specifier] = STATE(105),
    [sym_sized_type_specifier] = STATE(105),
    [sym_enum_specifier] = STATE(105),
    [sym_struct_specifier] = STATE(105),
    [sym_union_specifier] = STATE(105),
    [sym_labeled_statement] = STATE(3082),
    [sym_expression_statement] = STATE(3082),
    [sym_if_statement] = STATE(3082),
    [sym_switch_statement] = STATE(3082),
    [sym_case_statement] = STATE(3082),
    [sym_while_statement] = STATE(3082),
    [sym_do_statement] = STATE(3082),
    [sym_for_statement] = STATE(3082),
    [sym_return_statement] = STATE(3082),
    [sym_break_statement] = STATE(3082),
    [sym_continue_statement] = STATE(3082),
    [sym_goto_statement] = STATE(3082),
    [sym__expression] = STATE(2844),
    [sym_comma_expression] = STATE(2845),
    [sym_conditional_expression] = STATE(2844),
    [sym_assignment_expression] = STATE(2844),
    [sym_pointer_expression] = STATE(2844),
    [sym_logical_expression] = STATE(2844),
    [sym_bitwise_expression] = STATE(2844),
    [sym_equality_expression] = STATE(2844),
    [sym_relational_expression] = STATE(2844),
    [sym_shift_expression] = STATE(2844),
    [sym_math_expression] = STATE(2844),
    [sym_cast_expression] = STATE(2844),
    [sym_sizeof_expression] = STATE(2844),
    [sym_subscript_expression] = STATE(2844),
    [sym_call_expression] = STATE(2844),
    [sym_field_expression] = STATE(2844),
    [sym_compound_literal_expression] = STATE(2844),
    [sym_parenthesized_expression] = STATE(2844),
    [sym_concatenated_string] = STATE(2844),
    [sym_macro_type_specifier] = STATE(105),
    [sym_class_specifier] = STATE(105),
    [sym_dependent_type] = STATE(105),
    [sym_template_type] = STATE(1475),
    [sym_template_function] = STATE(2844),
    [sym_for_range_loop] = STATE(3082),
    [sym_new_expression] = STATE(2844),
    [sym_delete_expression] = STATE(2844),
    [sym_lambda_expression] = STATE(2844),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(416),
    [sym_scoped_namespace_identifier] = STATE(1476),
    [aux_sym__declaration_specifiers_repeat1] = STATE(109),
    [aux_sym_sized_type_specifier_repeat1] = STATE(110),
    [sym_raw_string_literal] = ACTIONS(6732),
    [anon_sym_LPAREN] = ACTIONS(626),
    [anon_sym_SEMI] = ACTIONS(6734),
    [anon_sym_typedef] = ACTIONS(7108),
    [anon_sym_extern] = ACTIONS(154),
    [anon_sym_LBRACE] = ACTIONS(6736),
    [anon_sym_STAR] = ACTIONS(644),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_static] = ACTIONS(154),
    [anon_sym_register] = ACTIONS(154),
    [anon_sym_inline] = ACTIONS(154),
    [anon_sym_const] = ACTIONS(158),
    [anon_sym_restrict] = ACTIONS(158),
    [anon_sym_volatile] = ACTIONS(158),
    [anon_sym__Atomic] = ACTIONS(158),
    [anon_sym_mutable] = ACTIONS(158),
    [anon_sym_explicit] = ACTIONS(158),
    [anon_sym_constexpr] = ACTIONS(158),
    [anon_sym_unsigned] = ACTIONS(160),
    [anon_sym_long] = ACTIONS(160),
    [anon_sym_short] = ACTIONS(160),
    [sym_primitive_type] = ACTIONS(162),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_union] = ACTIONS(39),
    [anon_sym_if] = ACTIONS(6738),
    [anon_sym_switch] = ACTIONS(6740),
    [anon_sym_case] = ACTIONS(6742),
    [anon_sym_default] = ACTIONS(6744),
    [anon_sym_while] = ACTIONS(6746),
    [anon_sym_do] = ACTIONS(6748),
    [anon_sym_for] = ACTIONS(6750),
    [anon_sym_return] = ACTIONS(6752),
    [anon_sym_break] = ACTIONS(6754),
    [anon_sym_continue] = ACTIONS(6756),
    [anon_sym_goto] = ACTIONS(6758),
    [anon_sym_AMP] = ACTIONS(644),
    [anon_sym_BANG] = ACTIONS(668),
    [anon_sym_TILDE] = ACTIONS(670),
    [anon_sym_PLUS] = ACTIONS(672),
    [anon_sym_DASH] = ACTIONS(672),
    [anon_sym_DASH_DASH] = ACTIONS(674),
    [anon_sym_PLUS_PLUS] = ACTIONS(674),
    [anon_sym_sizeof] = ACTIONS(676),
    [sym_number_literal] = ACTIONS(6732),
    [sym_char_literal] = ACTIONS(6732),
    [sym_string_literal] = ACTIONS(678),
    [sym_true] = ACTIONS(6760),
    [sym_false] = ACTIONS(6760),
    [sym_null] = ACTIONS(6760),
    [sym_identifier] = ACTIONS(7110),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(51),
    [sym_auto] = ACTIONS(162),
    [anon_sym_typename] = ACTIONS(172),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(3040),
    [anon_sym_delete] = ACTIONS(686),
    [sym_nullptr] = ACTIONS(6760),
  },
  [3018] = {
    [sym_type_qualifier] = STATE(3084),
    [sym__type_specifier] = STATE(3083),
    [sym_sized_type_specifier] = STATE(3083),
    [sym_enum_specifier] = STATE(3083),
    [sym_struct_specifier] = STATE(3083),
    [sym_union_specifier] = STATE(3083),
    [sym_macro_type_specifier] = STATE(3083),
    [sym_class_specifier] = STATE(3083),
    [sym_dependent_type] = STATE(3083),
    [sym_template_type] = STATE(62),
    [sym_scoped_type_identifier] = STATE(63),
    [sym_scoped_namespace_identifier] = STATE(64),
    [aux_sym_type_definition_repeat1] = STATE(3084),
    [aux_sym_sized_type_specifier_repeat1] = STATE(66),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_restrict] = ACTIONS(93),
    [anon_sym_volatile] = ACTIONS(93),
    [anon_sym__Atomic] = ACTIONS(93),
    [anon_sym_mutable] = ACTIONS(93),
    [anon_sym_explicit] = ACTIONS(93),
    [anon_sym_constexpr] = ACTIONS(93),
    [anon_sym_unsigned] = ACTIONS(95),
    [anon_sym_long] = ACTIONS(95),
    [anon_sym_short] = ACTIONS(95),
    [sym_primitive_type] = ACTIONS(7219),
    [anon_sym_enum] = ACTIONS(99),
    [anon_sym_struct] = ACTIONS(101),
    [anon_sym_union] = ACTIONS(103),
    [sym_identifier] = ACTIONS(105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(107),
    [sym_auto] = ACTIONS(7219),
    [anon_sym_typename] = ACTIONS(109),
    [anon_sym_COLON_COLON] = ACTIONS(111),
  },
  [3019] = {
    [sym_initializer_list] = STATE(765),
    [sym_template_argument_list] = STATE(2039),
    [anon_sym_LPAREN] = ACTIONS(1483),
    [anon_sym_COMMA] = ACTIONS(1477),
    [anon_sym_SEMI] = ACTIONS(1477),
    [anon_sym_extern] = ACTIONS(144),
    [anon_sym_LBRACE] = ACTIONS(548),
    [anon_sym_STAR] = ACTIONS(1486),
    [anon_sym_LBRACK] = ACTIONS(1477),
    [anon_sym_EQ] = ACTIONS(1479),
    [anon_sym_static] = ACTIONS(144),
    [anon_sym_register] = ACTIONS(144),
    [anon_sym_inline] = ACTIONS(144),
    [anon_sym_const] = ACTIONS(144),
    [anon_sym_restrict] = ACTIONS(144),
    [anon_sym_volatile] = ACTIONS(144),
    [anon_sym__Atomic] = ACTIONS(144),
    [anon_sym_mutable] = ACTIONS(144),
    [anon_sym_explicit] = ACTIONS(144),
    [anon_sym_constexpr] = ACTIONS(144),
    [anon_sym_COLON] = ACTIONS(6971),
    [anon_sym_QMARK] = ACTIONS(1477),
    [anon_sym_STAR_EQ] = ACTIONS(1477),
    [anon_sym_SLASH_EQ] = ACTIONS(1477),
    [anon_sym_PERCENT_EQ] = ACTIONS(1477),
    [anon_sym_PLUS_EQ] = ACTIONS(1477),
    [anon_sym_DASH_EQ] = ACTIONS(1477),
    [anon_sym_LT_LT_EQ] = ACTIONS(1477),
    [anon_sym_GT_GT_EQ] = ACTIONS(1477),
    [anon_sym_AMP_EQ] = ACTIONS(1477),
    [anon_sym_CARET_EQ] = ACTIONS(1477),
    [anon_sym_PIPE_EQ] = ACTIONS(1477),
    [anon_sym_AMP] = ACTIONS(1486),
    [anon_sym_PIPE_PIPE] = ACTIONS(1477),
    [anon_sym_AMP_AMP] = ACTIONS(1483),
    [anon_sym_PIPE] = ACTIONS(1479),
    [anon_sym_CARET] = ACTIONS(1479),
    [anon_sym_TILDE] = ACTIONS(142),
    [anon_sym_EQ_EQ] = ACTIONS(1477),
    [anon_sym_BANG_EQ] = ACTIONS(1477),
    [anon_sym_LT] = ACTIONS(1564),
    [anon_sym_GT] = ACTIONS(1479),
    [anon_sym_LT_EQ] = ACTIONS(1477),
    [anon_sym_GT_EQ] = ACTIONS(1477),
    [anon_sym_LT_LT] = ACTIONS(1479),
    [anon_sym_GT_GT] = ACTIONS(1479),
    [anon_sym_PLUS] = ACTIONS(1479),
    [anon_sym_DASH] = ACTIONS(1479),
    [anon_sym_SLASH] = ACTIONS(1479),
    [anon_sym_PERCENT] = ACTIONS(1479),
    [anon_sym_DASH_DASH] = ACTIONS(1477),
    [anon_sym_PLUS_PLUS] = ACTIONS(1477),
    [anon_sym_DOT] = ACTIONS(1477),
    [anon_sym_DASH_GT] = ACTIONS(1477),
    [sym_identifier] = ACTIONS(144),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(4631),
    [sym_operator_name] = ACTIONS(142),
  },
  [3020] = {
    [sym_raw_string_literal] = ACTIONS(4635),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(4637),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(4637),
    [anon_sym_LPAREN] = ACTIONS(4635),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(4637),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(4637),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(4637),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(4637),
    [sym_preproc_directive] = ACTIONS(4637),
    [anon_sym_SEMI] = ACTIONS(4635),
    [anon_sym_typedef] = ACTIONS(4637),
    [anon_sym_extern] = ACTIONS(4637),
    [anon_sym_LBRACE] = ACTIONS(4635),
    [anon_sym_STAR] = ACTIONS(4635),
    [anon_sym_LBRACK] = ACTIONS(4635),
    [anon_sym_static] = ACTIONS(4637),
    [anon_sym_register] = ACTIONS(4637),
    [anon_sym_inline] = ACTIONS(4637),
    [anon_sym_const] = ACTIONS(4637),
    [anon_sym_restrict] = ACTIONS(4637),
    [anon_sym_volatile] = ACTIONS(4637),
    [anon_sym__Atomic] = ACTIONS(4637),
    [anon_sym_mutable] = ACTIONS(4637),
    [anon_sym_explicit] = ACTIONS(4637),
    [anon_sym_constexpr] = ACTIONS(4637),
    [anon_sym_unsigned] = ACTIONS(4637),
    [anon_sym_long] = ACTIONS(4637),
    [anon_sym_short] = ACTIONS(4637),
    [sym_primitive_type] = ACTIONS(4637),
    [anon_sym_enum] = ACTIONS(4637),
    [anon_sym_struct] = ACTIONS(4637),
    [anon_sym_union] = ACTIONS(4637),
    [anon_sym_if] = ACTIONS(4637),
    [anon_sym_else] = ACTIONS(4637),
    [anon_sym_switch] = ACTIONS(4637),
    [anon_sym_case] = ACTIONS(4637),
    [anon_sym_default] = ACTIONS(4637),
    [anon_sym_while] = ACTIONS(4637),
    [anon_sym_do] = ACTIONS(4637),
    [anon_sym_for] = ACTIONS(4637),
    [anon_sym_return] = ACTIONS(4637),
    [anon_sym_break] = ACTIONS(4637),
    [anon_sym_continue] = ACTIONS(4637),
    [anon_sym_goto] = ACTIONS(4637),
    [anon_sym_AMP] = ACTIONS(4635),
    [anon_sym_BANG] = ACTIONS(4635),
    [anon_sym_TILDE] = ACTIONS(4635),
    [anon_sym_PLUS] = ACTIONS(4637),
    [anon_sym_DASH] = ACTIONS(4637),
    [anon_sym_DASH_DASH] = ACTIONS(4635),
    [anon_sym_PLUS_PLUS] = ACTIONS(4635),
    [anon_sym_sizeof] = ACTIONS(4637),
    [sym_number_literal] = ACTIONS(4635),
    [sym_char_literal] = ACTIONS(4635),
    [sym_string_literal] = ACTIONS(4635),
    [sym_true] = ACTIONS(4637),
    [sym_false] = ACTIONS(4637),
    [sym_null] = ACTIONS(4637),
    [sym_identifier] = ACTIONS(4637),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(4637),
    [sym_auto] = ACTIONS(4637),
    [anon_sym_typename] = ACTIONS(4637),
    [anon_sym_new] = ACTIONS(4637),
    [anon_sym_COLON_COLON] = ACTIONS(4635),
    [anon_sym_delete] = ACTIONS(4637),
    [sym_nullptr] = ACTIONS(4637),
  },
  [3021] = {
    [sym__declarator] = STATE(3085),
    [sym_pointer_declarator] = STATE(3085),
    [sym_function_declarator] = STATE(3085),
    [sym_array_declarator] = STATE(3085),
    [sym_init_declarator] = STATE(3086),
    [sym_reference_declarator] = STATE(3085),
    [sym_template_type] = STATE(46),
    [sym_template_function] = STATE(3085),
    [sym_destructor_name] = STATE(3085),
    [sym_scoped_identifier] = STATE(33),
    [sym_scoped_type_identifier] = STATE(47),
    [sym_scoped_namespace_identifier] = STATE(46),
    [anon_sym_LPAREN] = ACTIONS(11),
    [anon_sym_STAR] = ACTIONS(196),
    [anon_sym_AMP] = ACTIONS(526),
    [anon_sym_AMP_AMP] = ACTIONS(528),
    [anon_sym_TILDE] = ACTIONS(45),
    [sym_identifier] = ACTIONS(75),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(77),
    [sym_operator_name] = ACTIONS(7221),
  },
  [3022] = {
    [sym_argument_list] = STATE(802),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_RPAREN] = ACTIONS(7223),
    [anon_sym_STAR] = ACTIONS(4537),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_EQ] = ACTIONS(4539),
    [anon_sym_QMARK] = ACTIONS(4541),
    [anon_sym_STAR_EQ] = ACTIONS(4543),
    [anon_sym_SLASH_EQ] = ACTIONS(4543),
    [anon_sym_PERCENT_EQ] = ACTIONS(4543),
    [anon_sym_PLUS_EQ] = ACTIONS(4543),
    [anon_sym_DASH_EQ] = ACTIONS(4543),
    [anon_sym_LT_LT_EQ] = ACTIONS(4543),
    [anon_sym_GT_GT_EQ] = ACTIONS(4543),
    [anon_sym_AMP_EQ] = ACTIONS(4543),
    [anon_sym_CARET_EQ] = ACTIONS(4543),
    [anon_sym_PIPE_EQ] = ACTIONS(4543),
    [anon_sym_AMP] = ACTIONS(4545),
    [anon_sym_PIPE_PIPE] = ACTIONS(4547),
    [anon_sym_AMP_AMP] = ACTIONS(4549),
    [anon_sym_PIPE] = ACTIONS(4551),
    [anon_sym_CARET] = ACTIONS(4553),
    [anon_sym_EQ_EQ] = ACTIONS(4555),
    [anon_sym_BANG_EQ] = ACTIONS(4555),
    [anon_sym_LT] = ACTIONS(4557),
    [anon_sym_GT] = ACTIONS(4557),
    [anon_sym_LT_EQ] = ACTIONS(4559),
    [anon_sym_GT_EQ] = ACTIONS(4559),
    [anon_sym_LT_LT] = ACTIONS(4561),
    [anon_sym_GT_GT] = ACTIONS(4561),
    [anon_sym_PLUS] = ACTIONS(4563),
    [anon_sym_DASH] = ACTIONS(4563),
    [anon_sym_SLASH] = ACTIONS(4537),
    [anon_sym_PERCENT] = ACTIONS(4537),
    [anon_sym_DASH_DASH] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(1554),
    [anon_sym_DASH_GT] = ACTIONS(1554),
    [sym_comment] = ACTIONS(49),
  },
  [3023] = {
    [anon_sym_LPAREN] = ACTIONS(7225),
    [sym_comment] = ACTIONS(49),
  },
  [3024] = {
    [sym__expression] = STATE(3090),
    [sym_conditional_expression] = STATE(3090),
    [sym_assignment_expression] = STATE(3090),
    [sym_pointer_expression] = STATE(3090),
    [sym_logical_expression] = STATE(3090),
    [sym_bitwise_expression] = STATE(3090),
    [sym_equality_expression] = STATE(3090),
    [sym_relational_expression] = STATE(3090),
    [sym_shift_expression] = STATE(3090),
    [sym_math_expression] = STATE(3090),
    [sym_cast_expression] = STATE(3090),
    [sym_sizeof_expression] = STATE(3090),
    [sym_subscript_expression] = STATE(3090),
    [sym_call_expression] = STATE(3090),
    [sym_field_expression] = STATE(3090),
    [sym_compound_literal_expression] = STATE(3090),
    [sym_parenthesized_expression] = STATE(3090),
    [sym_concatenated_string] = STATE(3090),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(3090),
    [sym_new_expression] = STATE(3090),
    [sym_delete_expression] = STATE(3090),
    [sym_lambda_expression] = STATE(3090),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(7227),
    [anon_sym_LPAREN] = ACTIONS(1347),
    [anon_sym_SEMI] = ACTIONS(7229),
    [anon_sym_STAR] = ACTIONS(1349),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_AMP] = ACTIONS(1349),
    [anon_sym_BANG] = ACTIONS(1351),
    [anon_sym_TILDE] = ACTIONS(1353),
    [anon_sym_PLUS] = ACTIONS(1355),
    [anon_sym_DASH] = ACTIONS(1355),
    [anon_sym_DASH_DASH] = ACTIONS(1357),
    [anon_sym_PLUS_PLUS] = ACTIONS(1357),
    [anon_sym_sizeof] = ACTIONS(1359),
    [sym_number_literal] = ACTIONS(7227),
    [sym_char_literal] = ACTIONS(7227),
    [sym_string_literal] = ACTIONS(1361),
    [sym_true] = ACTIONS(7231),
    [sym_false] = ACTIONS(7231),
    [sym_null] = ACTIONS(7231),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1365),
    [anon_sym_delete] = ACTIONS(1367),
    [sym_nullptr] = ACTIONS(7231),
  },
  [3025] = {
    [sym_argument_list] = STATE(802),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_SEMI] = ACTIONS(7233),
    [anon_sym_STAR] = ACTIONS(2553),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_EQ] = ACTIONS(2555),
    [anon_sym_QMARK] = ACTIONS(2557),
    [anon_sym_STAR_EQ] = ACTIONS(2559),
    [anon_sym_SLASH_EQ] = ACTIONS(2559),
    [anon_sym_PERCENT_EQ] = ACTIONS(2559),
    [anon_sym_PLUS_EQ] = ACTIONS(2559),
    [anon_sym_DASH_EQ] = ACTIONS(2559),
    [anon_sym_LT_LT_EQ] = ACTIONS(2559),
    [anon_sym_GT_GT_EQ] = ACTIONS(2559),
    [anon_sym_AMP_EQ] = ACTIONS(2559),
    [anon_sym_CARET_EQ] = ACTIONS(2559),
    [anon_sym_PIPE_EQ] = ACTIONS(2559),
    [anon_sym_AMP] = ACTIONS(2561),
    [anon_sym_PIPE_PIPE] = ACTIONS(2563),
    [anon_sym_AMP_AMP] = ACTIONS(2565),
    [anon_sym_PIPE] = ACTIONS(2567),
    [anon_sym_CARET] = ACTIONS(2569),
    [anon_sym_EQ_EQ] = ACTIONS(2571),
    [anon_sym_BANG_EQ] = ACTIONS(2571),
    [anon_sym_LT] = ACTIONS(2573),
    [anon_sym_GT] = ACTIONS(2573),
    [anon_sym_LT_EQ] = ACTIONS(2575),
    [anon_sym_GT_EQ] = ACTIONS(2575),
    [anon_sym_LT_LT] = ACTIONS(2577),
    [anon_sym_GT_GT] = ACTIONS(2577),
    [anon_sym_PLUS] = ACTIONS(2579),
    [anon_sym_DASH] = ACTIONS(2579),
    [anon_sym_SLASH] = ACTIONS(2553),
    [anon_sym_PERCENT] = ACTIONS(2553),
    [anon_sym_DASH_DASH] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(1554),
    [anon_sym_DASH_GT] = ACTIONS(1554),
    [sym_comment] = ACTIONS(49),
  },
  [3026] = {
    [anon_sym_COLON] = ACTIONS(7235),
    [sym_comment] = ACTIONS(49),
  },
  [3027] = {
    [sym_raw_string_literal] = ACTIONS(4697),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(4699),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(4699),
    [anon_sym_LPAREN] = ACTIONS(4697),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(4699),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(4699),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(4699),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(4699),
    [sym_preproc_directive] = ACTIONS(4699),
    [anon_sym_SEMI] = ACTIONS(4697),
    [anon_sym_typedef] = ACTIONS(4699),
    [anon_sym_extern] = ACTIONS(4699),
    [anon_sym_LBRACE] = ACTIONS(4697),
    [anon_sym_STAR] = ACTIONS(4697),
    [anon_sym_LBRACK] = ACTIONS(4697),
    [anon_sym_static] = ACTIONS(4699),
    [anon_sym_register] = ACTIONS(4699),
    [anon_sym_inline] = ACTIONS(4699),
    [anon_sym_const] = ACTIONS(4699),
    [anon_sym_restrict] = ACTIONS(4699),
    [anon_sym_volatile] = ACTIONS(4699),
    [anon_sym__Atomic] = ACTIONS(4699),
    [anon_sym_mutable] = ACTIONS(4699),
    [anon_sym_explicit] = ACTIONS(4699),
    [anon_sym_constexpr] = ACTIONS(4699),
    [anon_sym_unsigned] = ACTIONS(4699),
    [anon_sym_long] = ACTIONS(4699),
    [anon_sym_short] = ACTIONS(4699),
    [sym_primitive_type] = ACTIONS(4699),
    [anon_sym_enum] = ACTIONS(4699),
    [anon_sym_struct] = ACTIONS(4699),
    [anon_sym_union] = ACTIONS(4699),
    [anon_sym_if] = ACTIONS(4699),
    [anon_sym_else] = ACTIONS(4699),
    [anon_sym_switch] = ACTIONS(4699),
    [anon_sym_case] = ACTIONS(4699),
    [anon_sym_default] = ACTIONS(4699),
    [anon_sym_while] = ACTIONS(4699),
    [anon_sym_do] = ACTIONS(4699),
    [anon_sym_for] = ACTIONS(4699),
    [anon_sym_return] = ACTIONS(4699),
    [anon_sym_break] = ACTIONS(4699),
    [anon_sym_continue] = ACTIONS(4699),
    [anon_sym_goto] = ACTIONS(4699),
    [anon_sym_AMP] = ACTIONS(4697),
    [anon_sym_BANG] = ACTIONS(4697),
    [anon_sym_TILDE] = ACTIONS(4697),
    [anon_sym_PLUS] = ACTIONS(4699),
    [anon_sym_DASH] = ACTIONS(4699),
    [anon_sym_DASH_DASH] = ACTIONS(4697),
    [anon_sym_PLUS_PLUS] = ACTIONS(4697),
    [anon_sym_sizeof] = ACTIONS(4699),
    [sym_number_literal] = ACTIONS(4697),
    [sym_char_literal] = ACTIONS(4697),
    [sym_string_literal] = ACTIONS(4697),
    [sym_true] = ACTIONS(4699),
    [sym_false] = ACTIONS(4699),
    [sym_null] = ACTIONS(4699),
    [sym_identifier] = ACTIONS(4699),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(4699),
    [sym_auto] = ACTIONS(4699),
    [anon_sym_typename] = ACTIONS(4699),
    [anon_sym_new] = ACTIONS(4699),
    [anon_sym_COLON_COLON] = ACTIONS(4697),
    [anon_sym_delete] = ACTIONS(4699),
    [sym_nullptr] = ACTIONS(4699),
  },
  [3028] = {
    [sym_raw_string_literal] = ACTIONS(4701),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(4703),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(4703),
    [anon_sym_LPAREN] = ACTIONS(4701),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(4703),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(4703),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(4703),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(4703),
    [sym_preproc_directive] = ACTIONS(4703),
    [anon_sym_SEMI] = ACTIONS(4701),
    [anon_sym_typedef] = ACTIONS(4703),
    [anon_sym_extern] = ACTIONS(4703),
    [anon_sym_LBRACE] = ACTIONS(4701),
    [anon_sym_STAR] = ACTIONS(4701),
    [anon_sym_LBRACK] = ACTIONS(4701),
    [anon_sym_static] = ACTIONS(4703),
    [anon_sym_register] = ACTIONS(4703),
    [anon_sym_inline] = ACTIONS(4703),
    [anon_sym_const] = ACTIONS(4703),
    [anon_sym_restrict] = ACTIONS(4703),
    [anon_sym_volatile] = ACTIONS(4703),
    [anon_sym__Atomic] = ACTIONS(4703),
    [anon_sym_mutable] = ACTIONS(4703),
    [anon_sym_explicit] = ACTIONS(4703),
    [anon_sym_constexpr] = ACTIONS(4703),
    [anon_sym_unsigned] = ACTIONS(4703),
    [anon_sym_long] = ACTIONS(4703),
    [anon_sym_short] = ACTIONS(4703),
    [sym_primitive_type] = ACTIONS(4703),
    [anon_sym_enum] = ACTIONS(4703),
    [anon_sym_struct] = ACTIONS(4703),
    [anon_sym_union] = ACTIONS(4703),
    [anon_sym_if] = ACTIONS(4703),
    [anon_sym_else] = ACTIONS(4703),
    [anon_sym_switch] = ACTIONS(4703),
    [anon_sym_case] = ACTIONS(4703),
    [anon_sym_default] = ACTIONS(4703),
    [anon_sym_while] = ACTIONS(4703),
    [anon_sym_do] = ACTIONS(4703),
    [anon_sym_for] = ACTIONS(4703),
    [anon_sym_return] = ACTIONS(4703),
    [anon_sym_break] = ACTIONS(4703),
    [anon_sym_continue] = ACTIONS(4703),
    [anon_sym_goto] = ACTIONS(4703),
    [anon_sym_AMP] = ACTIONS(4701),
    [anon_sym_BANG] = ACTIONS(4701),
    [anon_sym_TILDE] = ACTIONS(4701),
    [anon_sym_PLUS] = ACTIONS(4703),
    [anon_sym_DASH] = ACTIONS(4703),
    [anon_sym_DASH_DASH] = ACTIONS(4701),
    [anon_sym_PLUS_PLUS] = ACTIONS(4701),
    [anon_sym_sizeof] = ACTIONS(4703),
    [sym_number_literal] = ACTIONS(4701),
    [sym_char_literal] = ACTIONS(4701),
    [sym_string_literal] = ACTIONS(4701),
    [sym_true] = ACTIONS(4703),
    [sym_false] = ACTIONS(4703),
    [sym_null] = ACTIONS(4703),
    [sym_identifier] = ACTIONS(4703),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(4703),
    [sym_auto] = ACTIONS(4703),
    [anon_sym_typename] = ACTIONS(4703),
    [anon_sym_new] = ACTIONS(4703),
    [anon_sym_COLON_COLON] = ACTIONS(4701),
    [anon_sym_delete] = ACTIONS(4703),
    [sym_nullptr] = ACTIONS(4703),
  },
  [3029] = {
    [sym_raw_string_literal] = ACTIONS(4710),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(4712),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(4712),
    [anon_sym_LPAREN] = ACTIONS(4710),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(4712),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(4712),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(4712),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(4712),
    [sym_preproc_directive] = ACTIONS(4712),
    [anon_sym_SEMI] = ACTIONS(4710),
    [anon_sym_typedef] = ACTIONS(4712),
    [anon_sym_extern] = ACTIONS(4712),
    [anon_sym_LBRACE] = ACTIONS(4710),
    [anon_sym_STAR] = ACTIONS(4710),
    [anon_sym_LBRACK] = ACTIONS(4710),
    [anon_sym_static] = ACTIONS(4712),
    [anon_sym_register] = ACTIONS(4712),
    [anon_sym_inline] = ACTIONS(4712),
    [anon_sym_const] = ACTIONS(4712),
    [anon_sym_restrict] = ACTIONS(4712),
    [anon_sym_volatile] = ACTIONS(4712),
    [anon_sym__Atomic] = ACTIONS(4712),
    [anon_sym_mutable] = ACTIONS(4712),
    [anon_sym_explicit] = ACTIONS(4712),
    [anon_sym_constexpr] = ACTIONS(4712),
    [anon_sym_unsigned] = ACTIONS(4712),
    [anon_sym_long] = ACTIONS(4712),
    [anon_sym_short] = ACTIONS(4712),
    [sym_primitive_type] = ACTIONS(4712),
    [anon_sym_enum] = ACTIONS(4712),
    [anon_sym_struct] = ACTIONS(4712),
    [anon_sym_union] = ACTIONS(4712),
    [anon_sym_if] = ACTIONS(4712),
    [anon_sym_else] = ACTIONS(4712),
    [anon_sym_switch] = ACTIONS(4712),
    [anon_sym_case] = ACTIONS(4712),
    [anon_sym_default] = ACTIONS(4712),
    [anon_sym_while] = ACTIONS(4712),
    [anon_sym_do] = ACTIONS(4712),
    [anon_sym_for] = ACTIONS(4712),
    [anon_sym_return] = ACTIONS(4712),
    [anon_sym_break] = ACTIONS(4712),
    [anon_sym_continue] = ACTIONS(4712),
    [anon_sym_goto] = ACTIONS(4712),
    [anon_sym_AMP] = ACTIONS(4710),
    [anon_sym_BANG] = ACTIONS(4710),
    [anon_sym_TILDE] = ACTIONS(4710),
    [anon_sym_PLUS] = ACTIONS(4712),
    [anon_sym_DASH] = ACTIONS(4712),
    [anon_sym_DASH_DASH] = ACTIONS(4710),
    [anon_sym_PLUS_PLUS] = ACTIONS(4710),
    [anon_sym_sizeof] = ACTIONS(4712),
    [sym_number_literal] = ACTIONS(4710),
    [sym_char_literal] = ACTIONS(4710),
    [sym_string_literal] = ACTIONS(4710),
    [sym_true] = ACTIONS(4712),
    [sym_false] = ACTIONS(4712),
    [sym_null] = ACTIONS(4712),
    [sym_identifier] = ACTIONS(4712),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(4712),
    [sym_auto] = ACTIONS(4712),
    [anon_sym_typename] = ACTIONS(4712),
    [anon_sym_new] = ACTIONS(4712),
    [anon_sym_COLON_COLON] = ACTIONS(4710),
    [anon_sym_delete] = ACTIONS(4712),
    [sym_nullptr] = ACTIONS(4712),
  },
  [3030] = {
    [sym_raw_string_literal] = ACTIONS(6864),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(6866),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(6866),
    [anon_sym_LPAREN] = ACTIONS(6864),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(6866),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(6866),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(6866),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(6866),
    [sym_preproc_directive] = ACTIONS(6866),
    [anon_sym_SEMI] = ACTIONS(6864),
    [anon_sym_typedef] = ACTIONS(6866),
    [anon_sym_extern] = ACTIONS(6866),
    [anon_sym_LBRACE] = ACTIONS(6864),
    [anon_sym_STAR] = ACTIONS(6864),
    [anon_sym_LBRACK] = ACTIONS(6864),
    [anon_sym_static] = ACTIONS(6866),
    [anon_sym_register] = ACTIONS(6866),
    [anon_sym_inline] = ACTIONS(6866),
    [anon_sym_const] = ACTIONS(6866),
    [anon_sym_restrict] = ACTIONS(6866),
    [anon_sym_volatile] = ACTIONS(6866),
    [anon_sym__Atomic] = ACTIONS(6866),
    [anon_sym_mutable] = ACTIONS(6866),
    [anon_sym_explicit] = ACTIONS(6866),
    [anon_sym_constexpr] = ACTIONS(6866),
    [anon_sym_unsigned] = ACTIONS(6866),
    [anon_sym_long] = ACTIONS(6866),
    [anon_sym_short] = ACTIONS(6866),
    [sym_primitive_type] = ACTIONS(6866),
    [anon_sym_enum] = ACTIONS(6866),
    [anon_sym_struct] = ACTIONS(6866),
    [anon_sym_union] = ACTIONS(6866),
    [anon_sym_if] = ACTIONS(6866),
    [anon_sym_switch] = ACTIONS(6866),
    [anon_sym_case] = ACTIONS(6866),
    [anon_sym_default] = ACTIONS(6866),
    [anon_sym_while] = ACTIONS(6866),
    [anon_sym_do] = ACTIONS(6866),
    [anon_sym_for] = ACTIONS(6866),
    [anon_sym_return] = ACTIONS(6866),
    [anon_sym_break] = ACTIONS(6866),
    [anon_sym_continue] = ACTIONS(6866),
    [anon_sym_goto] = ACTIONS(6866),
    [anon_sym_AMP] = ACTIONS(6864),
    [anon_sym_BANG] = ACTIONS(6864),
    [anon_sym_TILDE] = ACTIONS(6864),
    [anon_sym_PLUS] = ACTIONS(6866),
    [anon_sym_DASH] = ACTIONS(6866),
    [anon_sym_DASH_DASH] = ACTIONS(6864),
    [anon_sym_PLUS_PLUS] = ACTIONS(6864),
    [anon_sym_sizeof] = ACTIONS(6866),
    [sym_number_literal] = ACTIONS(6864),
    [sym_char_literal] = ACTIONS(6864),
    [sym_string_literal] = ACTIONS(6864),
    [sym_true] = ACTIONS(6866),
    [sym_false] = ACTIONS(6866),
    [sym_null] = ACTIONS(6866),
    [sym_identifier] = ACTIONS(6866),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(6866),
    [sym_auto] = ACTIONS(6866),
    [anon_sym_typename] = ACTIONS(6866),
    [anon_sym_new] = ACTIONS(6866),
    [anon_sym_COLON_COLON] = ACTIONS(6864),
    [anon_sym_delete] = ACTIONS(6866),
    [sym_nullptr] = ACTIONS(6866),
  },
  [3031] = {
    [sym_compound_statement] = STATE(3093),
    [sym_labeled_statement] = STATE(3093),
    [sym_expression_statement] = STATE(3093),
    [sym_if_statement] = STATE(3093),
    [sym_switch_statement] = STATE(3093),
    [sym_case_statement] = STATE(3093),
    [sym_while_statement] = STATE(3093),
    [sym_do_statement] = STATE(3093),
    [sym_for_statement] = STATE(3093),
    [sym_return_statement] = STATE(3093),
    [sym_break_statement] = STATE(3093),
    [sym_continue_statement] = STATE(3093),
    [sym_goto_statement] = STATE(3093),
    [sym__expression] = STATE(1947),
    [sym_comma_expression] = STATE(1948),
    [sym_conditional_expression] = STATE(1947),
    [sym_assignment_expression] = STATE(1947),
    [sym_pointer_expression] = STATE(1947),
    [sym_logical_expression] = STATE(1947),
    [sym_bitwise_expression] = STATE(1947),
    [sym_equality_expression] = STATE(1947),
    [sym_relational_expression] = STATE(1947),
    [sym_shift_expression] = STATE(1947),
    [sym_math_expression] = STATE(1947),
    [sym_cast_expression] = STATE(1947),
    [sym_sizeof_expression] = STATE(1947),
    [sym_subscript_expression] = STATE(1947),
    [sym_call_expression] = STATE(1947),
    [sym_field_expression] = STATE(1947),
    [sym_compound_literal_expression] = STATE(1947),
    [sym_parenthesized_expression] = STATE(1947),
    [sym_concatenated_string] = STATE(1947),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(1947),
    [sym_for_range_loop] = STATE(3093),
    [sym_new_expression] = STATE(1947),
    [sym_delete_expression] = STATE(1947),
    [sym_lambda_expression] = STATE(1947),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(4395),
    [anon_sym_LPAREN] = ACTIONS(626),
    [anon_sym_SEMI] = ACTIONS(4411),
    [anon_sym_LBRACE] = ACTIONS(4415),
    [anon_sym_STAR] = ACTIONS(644),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_if] = ACTIONS(4417),
    [anon_sym_switch] = ACTIONS(4419),
    [anon_sym_case] = ACTIONS(4421),
    [anon_sym_default] = ACTIONS(4423),
    [anon_sym_while] = ACTIONS(4425),
    [anon_sym_do] = ACTIONS(4427),
    [anon_sym_for] = ACTIONS(4429),
    [anon_sym_return] = ACTIONS(4431),
    [anon_sym_break] = ACTIONS(4433),
    [anon_sym_continue] = ACTIONS(4435),
    [anon_sym_goto] = ACTIONS(4437),
    [anon_sym_AMP] = ACTIONS(644),
    [anon_sym_BANG] = ACTIONS(668),
    [anon_sym_TILDE] = ACTIONS(670),
    [anon_sym_PLUS] = ACTIONS(672),
    [anon_sym_DASH] = ACTIONS(672),
    [anon_sym_DASH_DASH] = ACTIONS(674),
    [anon_sym_PLUS_PLUS] = ACTIONS(674),
    [anon_sym_sizeof] = ACTIONS(676),
    [sym_number_literal] = ACTIONS(4395),
    [sym_char_literal] = ACTIONS(4395),
    [sym_string_literal] = ACTIONS(678),
    [sym_true] = ACTIONS(4439),
    [sym_false] = ACTIONS(4439),
    [sym_null] = ACTIONS(4439),
    [sym_identifier] = ACTIONS(6077),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1303),
    [anon_sym_delete] = ACTIONS(686),
    [sym_nullptr] = ACTIONS(4439),
  },
  [3032] = {
    [sym_raw_string_literal] = ACTIONS(6902),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(6904),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(6904),
    [anon_sym_LPAREN] = ACTIONS(6902),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(6904),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(6904),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(6904),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(6904),
    [sym_preproc_directive] = ACTIONS(6904),
    [anon_sym_SEMI] = ACTIONS(6902),
    [anon_sym_typedef] = ACTIONS(6904),
    [anon_sym_extern] = ACTIONS(6904),
    [anon_sym_LBRACE] = ACTIONS(6902),
    [anon_sym_STAR] = ACTIONS(6902),
    [anon_sym_LBRACK] = ACTIONS(6902),
    [anon_sym_static] = ACTIONS(6904),
    [anon_sym_register] = ACTIONS(6904),
    [anon_sym_inline] = ACTIONS(6904),
    [anon_sym_const] = ACTIONS(6904),
    [anon_sym_restrict] = ACTIONS(6904),
    [anon_sym_volatile] = ACTIONS(6904),
    [anon_sym__Atomic] = ACTIONS(6904),
    [anon_sym_mutable] = ACTIONS(6904),
    [anon_sym_explicit] = ACTIONS(6904),
    [anon_sym_constexpr] = ACTIONS(6904),
    [anon_sym_unsigned] = ACTIONS(6904),
    [anon_sym_long] = ACTIONS(6904),
    [anon_sym_short] = ACTIONS(6904),
    [sym_primitive_type] = ACTIONS(6904),
    [anon_sym_enum] = ACTIONS(6904),
    [anon_sym_struct] = ACTIONS(6904),
    [anon_sym_union] = ACTIONS(6904),
    [anon_sym_if] = ACTIONS(6904),
    [anon_sym_switch] = ACTIONS(6904),
    [anon_sym_case] = ACTIONS(6904),
    [anon_sym_default] = ACTIONS(6904),
    [anon_sym_while] = ACTIONS(6904),
    [anon_sym_do] = ACTIONS(6904),
    [anon_sym_for] = ACTIONS(6904),
    [anon_sym_return] = ACTIONS(6904),
    [anon_sym_break] = ACTIONS(6904),
    [anon_sym_continue] = ACTIONS(6904),
    [anon_sym_goto] = ACTIONS(6904),
    [anon_sym_AMP] = ACTIONS(6902),
    [anon_sym_BANG] = ACTIONS(6902),
    [anon_sym_TILDE] = ACTIONS(6902),
    [anon_sym_PLUS] = ACTIONS(6904),
    [anon_sym_DASH] = ACTIONS(6904),
    [anon_sym_DASH_DASH] = ACTIONS(6902),
    [anon_sym_PLUS_PLUS] = ACTIONS(6902),
    [anon_sym_sizeof] = ACTIONS(6904),
    [sym_number_literal] = ACTIONS(6902),
    [sym_char_literal] = ACTIONS(6902),
    [sym_string_literal] = ACTIONS(6902),
    [sym_true] = ACTIONS(6904),
    [sym_false] = ACTIONS(6904),
    [sym_null] = ACTIONS(6904),
    [sym_identifier] = ACTIONS(6904),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(6904),
    [sym_auto] = ACTIONS(6904),
    [anon_sym_typename] = ACTIONS(6904),
    [anon_sym_new] = ACTIONS(6904),
    [anon_sym_COLON_COLON] = ACTIONS(6902),
    [anon_sym_delete] = ACTIONS(6904),
    [sym_nullptr] = ACTIONS(6904),
  },
  [3033] = {
    [sym_compound_statement] = STATE(3094),
    [sym_labeled_statement] = STATE(3094),
    [sym_expression_statement] = STATE(3094),
    [sym_if_statement] = STATE(3094),
    [sym_switch_statement] = STATE(3094),
    [sym_case_statement] = STATE(3094),
    [sym_while_statement] = STATE(3094),
    [sym_do_statement] = STATE(3094),
    [sym_for_statement] = STATE(3094),
    [sym_return_statement] = STATE(3094),
    [sym_break_statement] = STATE(3094),
    [sym_continue_statement] = STATE(3094),
    [sym_goto_statement] = STATE(3094),
    [sym__expression] = STATE(1947),
    [sym_comma_expression] = STATE(1948),
    [sym_conditional_expression] = STATE(1947),
    [sym_assignment_expression] = STATE(1947),
    [sym_pointer_expression] = STATE(1947),
    [sym_logical_expression] = STATE(1947),
    [sym_bitwise_expression] = STATE(1947),
    [sym_equality_expression] = STATE(1947),
    [sym_relational_expression] = STATE(1947),
    [sym_shift_expression] = STATE(1947),
    [sym_math_expression] = STATE(1947),
    [sym_cast_expression] = STATE(1947),
    [sym_sizeof_expression] = STATE(1947),
    [sym_subscript_expression] = STATE(1947),
    [sym_call_expression] = STATE(1947),
    [sym_field_expression] = STATE(1947),
    [sym_compound_literal_expression] = STATE(1947),
    [sym_parenthesized_expression] = STATE(1947),
    [sym_concatenated_string] = STATE(1947),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(1947),
    [sym_for_range_loop] = STATE(3094),
    [sym_new_expression] = STATE(1947),
    [sym_delete_expression] = STATE(1947),
    [sym_lambda_expression] = STATE(1947),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(4395),
    [anon_sym_LPAREN] = ACTIONS(626),
    [anon_sym_SEMI] = ACTIONS(4411),
    [anon_sym_LBRACE] = ACTIONS(4415),
    [anon_sym_STAR] = ACTIONS(644),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_if] = ACTIONS(4417),
    [anon_sym_switch] = ACTIONS(4419),
    [anon_sym_case] = ACTIONS(4421),
    [anon_sym_default] = ACTIONS(4423),
    [anon_sym_while] = ACTIONS(4425),
    [anon_sym_do] = ACTIONS(4427),
    [anon_sym_for] = ACTIONS(4429),
    [anon_sym_return] = ACTIONS(4431),
    [anon_sym_break] = ACTIONS(4433),
    [anon_sym_continue] = ACTIONS(4435),
    [anon_sym_goto] = ACTIONS(4437),
    [anon_sym_AMP] = ACTIONS(644),
    [anon_sym_BANG] = ACTIONS(668),
    [anon_sym_TILDE] = ACTIONS(670),
    [anon_sym_PLUS] = ACTIONS(672),
    [anon_sym_DASH] = ACTIONS(672),
    [anon_sym_DASH_DASH] = ACTIONS(674),
    [anon_sym_PLUS_PLUS] = ACTIONS(674),
    [anon_sym_sizeof] = ACTIONS(676),
    [sym_number_literal] = ACTIONS(4395),
    [sym_char_literal] = ACTIONS(4395),
    [sym_string_literal] = ACTIONS(678),
    [sym_true] = ACTIONS(4439),
    [sym_false] = ACTIONS(4439),
    [sym_null] = ACTIONS(4439),
    [sym_identifier] = ACTIONS(6077),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1303),
    [anon_sym_delete] = ACTIONS(686),
    [sym_nullptr] = ACTIONS(4439),
  },
  [3034] = {
    [aux_sym_for_statement_repeat1] = STATE(2796),
    [anon_sym_COMMA] = ACTIONS(6339),
    [anon_sym_RPAREN] = ACTIONS(7237),
    [sym_comment] = ACTIONS(49),
  },
  [3035] = {
    [sym_argument_list] = STATE(802),
    [aux_sym_for_statement_repeat1] = STATE(3096),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_COMMA] = ACTIONS(6339),
    [anon_sym_RPAREN] = ACTIONS(7237),
    [anon_sym_STAR] = ACTIONS(2234),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_EQ] = ACTIONS(2236),
    [anon_sym_QMARK] = ACTIONS(2238),
    [anon_sym_STAR_EQ] = ACTIONS(2240),
    [anon_sym_SLASH_EQ] = ACTIONS(2240),
    [anon_sym_PERCENT_EQ] = ACTIONS(2240),
    [anon_sym_PLUS_EQ] = ACTIONS(2240),
    [anon_sym_DASH_EQ] = ACTIONS(2240),
    [anon_sym_LT_LT_EQ] = ACTIONS(2240),
    [anon_sym_GT_GT_EQ] = ACTIONS(2240),
    [anon_sym_AMP_EQ] = ACTIONS(2240),
    [anon_sym_CARET_EQ] = ACTIONS(2240),
    [anon_sym_PIPE_EQ] = ACTIONS(2240),
    [anon_sym_AMP] = ACTIONS(2242),
    [anon_sym_PIPE_PIPE] = ACTIONS(2244),
    [anon_sym_AMP_AMP] = ACTIONS(2246),
    [anon_sym_PIPE] = ACTIONS(2248),
    [anon_sym_CARET] = ACTIONS(2250),
    [anon_sym_EQ_EQ] = ACTIONS(2252),
    [anon_sym_BANG_EQ] = ACTIONS(2252),
    [anon_sym_LT] = ACTIONS(2254),
    [anon_sym_GT] = ACTIONS(2254),
    [anon_sym_LT_EQ] = ACTIONS(2256),
    [anon_sym_GT_EQ] = ACTIONS(2256),
    [anon_sym_LT_LT] = ACTIONS(2258),
    [anon_sym_GT_GT] = ACTIONS(2258),
    [anon_sym_PLUS] = ACTIONS(2260),
    [anon_sym_DASH] = ACTIONS(2260),
    [anon_sym_SLASH] = ACTIONS(2234),
    [anon_sym_PERCENT] = ACTIONS(2234),
    [anon_sym_DASH_DASH] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(1554),
    [anon_sym_DASH_GT] = ACTIONS(1554),
    [sym_comment] = ACTIONS(49),
  },
  [3036] = {
    [sym_raw_string_literal] = ACTIONS(6925),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(6927),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(6927),
    [anon_sym_LPAREN] = ACTIONS(6925),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(6927),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(6927),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(6927),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(6927),
    [sym_preproc_directive] = ACTIONS(6927),
    [anon_sym_SEMI] = ACTIONS(6925),
    [anon_sym_typedef] = ACTIONS(6927),
    [anon_sym_extern] = ACTIONS(6927),
    [anon_sym_LBRACE] = ACTIONS(6925),
    [anon_sym_STAR] = ACTIONS(6925),
    [anon_sym_LBRACK] = ACTIONS(6925),
    [anon_sym_static] = ACTIONS(6927),
    [anon_sym_register] = ACTIONS(6927),
    [anon_sym_inline] = ACTIONS(6927),
    [anon_sym_const] = ACTIONS(6927),
    [anon_sym_restrict] = ACTIONS(6927),
    [anon_sym_volatile] = ACTIONS(6927),
    [anon_sym__Atomic] = ACTIONS(6927),
    [anon_sym_mutable] = ACTIONS(6927),
    [anon_sym_explicit] = ACTIONS(6927),
    [anon_sym_constexpr] = ACTIONS(6927),
    [anon_sym_unsigned] = ACTIONS(6927),
    [anon_sym_long] = ACTIONS(6927),
    [anon_sym_short] = ACTIONS(6927),
    [sym_primitive_type] = ACTIONS(6927),
    [anon_sym_enum] = ACTIONS(6927),
    [anon_sym_struct] = ACTIONS(6927),
    [anon_sym_union] = ACTIONS(6927),
    [anon_sym_if] = ACTIONS(6927),
    [anon_sym_switch] = ACTIONS(6927),
    [anon_sym_case] = ACTIONS(6927),
    [anon_sym_default] = ACTIONS(6927),
    [anon_sym_while] = ACTIONS(6927),
    [anon_sym_do] = ACTIONS(6927),
    [anon_sym_for] = ACTIONS(6927),
    [anon_sym_return] = ACTIONS(6927),
    [anon_sym_break] = ACTIONS(6927),
    [anon_sym_continue] = ACTIONS(6927),
    [anon_sym_goto] = ACTIONS(6927),
    [anon_sym_AMP] = ACTIONS(6925),
    [anon_sym_BANG] = ACTIONS(6925),
    [anon_sym_TILDE] = ACTIONS(6925),
    [anon_sym_PLUS] = ACTIONS(6927),
    [anon_sym_DASH] = ACTIONS(6927),
    [anon_sym_DASH_DASH] = ACTIONS(6925),
    [anon_sym_PLUS_PLUS] = ACTIONS(6925),
    [anon_sym_sizeof] = ACTIONS(6927),
    [sym_number_literal] = ACTIONS(6925),
    [sym_char_literal] = ACTIONS(6925),
    [sym_string_literal] = ACTIONS(6925),
    [sym_true] = ACTIONS(6927),
    [sym_false] = ACTIONS(6927),
    [sym_null] = ACTIONS(6927),
    [sym_identifier] = ACTIONS(6927),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(6927),
    [sym_auto] = ACTIONS(6927),
    [anon_sym_typename] = ACTIONS(6927),
    [anon_sym_new] = ACTIONS(6927),
    [anon_sym_COLON_COLON] = ACTIONS(6925),
    [anon_sym_delete] = ACTIONS(6927),
    [sym_nullptr] = ACTIONS(6927),
  },
  [3037] = {
    [sym_compound_statement] = STATE(3097),
    [sym_labeled_statement] = STATE(3097),
    [sym_expression_statement] = STATE(3097),
    [sym_if_statement] = STATE(3097),
    [sym_switch_statement] = STATE(3097),
    [sym_case_statement] = STATE(3097),
    [sym_while_statement] = STATE(3097),
    [sym_do_statement] = STATE(3097),
    [sym_for_statement] = STATE(3097),
    [sym_return_statement] = STATE(3097),
    [sym_break_statement] = STATE(3097),
    [sym_continue_statement] = STATE(3097),
    [sym_goto_statement] = STATE(3097),
    [sym__expression] = STATE(2739),
    [sym_comma_expression] = STATE(2740),
    [sym_conditional_expression] = STATE(2739),
    [sym_assignment_expression] = STATE(2739),
    [sym_pointer_expression] = STATE(2739),
    [sym_logical_expression] = STATE(2739),
    [sym_bitwise_expression] = STATE(2739),
    [sym_equality_expression] = STATE(2739),
    [sym_relational_expression] = STATE(2739),
    [sym_shift_expression] = STATE(2739),
    [sym_math_expression] = STATE(2739),
    [sym_cast_expression] = STATE(2739),
    [sym_sizeof_expression] = STATE(2739),
    [sym_subscript_expression] = STATE(2739),
    [sym_call_expression] = STATE(2739),
    [sym_field_expression] = STATE(2739),
    [sym_compound_literal_expression] = STATE(2739),
    [sym_parenthesized_expression] = STATE(2739),
    [sym_concatenated_string] = STATE(2739),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(2739),
    [sym_for_range_loop] = STATE(3097),
    [sym_new_expression] = STATE(2739),
    [sym_delete_expression] = STATE(2739),
    [sym_lambda_expression] = STATE(2739),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(6507),
    [anon_sym_LPAREN] = ACTIONS(626),
    [anon_sym_SEMI] = ACTIONS(6509),
    [anon_sym_LBRACE] = ACTIONS(6511),
    [anon_sym_STAR] = ACTIONS(644),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_if] = ACTIONS(6513),
    [anon_sym_switch] = ACTIONS(6515),
    [anon_sym_case] = ACTIONS(6517),
    [anon_sym_default] = ACTIONS(6519),
    [anon_sym_while] = ACTIONS(6521),
    [anon_sym_do] = ACTIONS(6523),
    [anon_sym_for] = ACTIONS(6525),
    [anon_sym_return] = ACTIONS(6527),
    [anon_sym_break] = ACTIONS(6529),
    [anon_sym_continue] = ACTIONS(6531),
    [anon_sym_goto] = ACTIONS(6533),
    [anon_sym_AMP] = ACTIONS(644),
    [anon_sym_BANG] = ACTIONS(668),
    [anon_sym_TILDE] = ACTIONS(670),
    [anon_sym_PLUS] = ACTIONS(672),
    [anon_sym_DASH] = ACTIONS(672),
    [anon_sym_DASH_DASH] = ACTIONS(674),
    [anon_sym_PLUS_PLUS] = ACTIONS(674),
    [anon_sym_sizeof] = ACTIONS(676),
    [sym_number_literal] = ACTIONS(6507),
    [sym_char_literal] = ACTIONS(6507),
    [sym_string_literal] = ACTIONS(678),
    [sym_true] = ACTIONS(6535),
    [sym_false] = ACTIONS(6535),
    [sym_null] = ACTIONS(6535),
    [sym_identifier] = ACTIONS(6537),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1303),
    [anon_sym_delete] = ACTIONS(686),
    [sym_nullptr] = ACTIONS(6535),
  },
  [3038] = {
    [sym_argument_list] = STATE(802),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_RPAREN] = ACTIONS(7239),
    [anon_sym_STAR] = ACTIONS(4537),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_EQ] = ACTIONS(4539),
    [anon_sym_QMARK] = ACTIONS(4541),
    [anon_sym_STAR_EQ] = ACTIONS(4543),
    [anon_sym_SLASH_EQ] = ACTIONS(4543),
    [anon_sym_PERCENT_EQ] = ACTIONS(4543),
    [anon_sym_PLUS_EQ] = ACTIONS(4543),
    [anon_sym_DASH_EQ] = ACTIONS(4543),
    [anon_sym_LT_LT_EQ] = ACTIONS(4543),
    [anon_sym_GT_GT_EQ] = ACTIONS(4543),
    [anon_sym_AMP_EQ] = ACTIONS(4543),
    [anon_sym_CARET_EQ] = ACTIONS(4543),
    [anon_sym_PIPE_EQ] = ACTIONS(4543),
    [anon_sym_AMP] = ACTIONS(4545),
    [anon_sym_PIPE_PIPE] = ACTIONS(4547),
    [anon_sym_AMP_AMP] = ACTIONS(4549),
    [anon_sym_PIPE] = ACTIONS(4551),
    [anon_sym_CARET] = ACTIONS(4553),
    [anon_sym_EQ_EQ] = ACTIONS(4555),
    [anon_sym_BANG_EQ] = ACTIONS(4555),
    [anon_sym_LT] = ACTIONS(4557),
    [anon_sym_GT] = ACTIONS(4557),
    [anon_sym_LT_EQ] = ACTIONS(4559),
    [anon_sym_GT_EQ] = ACTIONS(4559),
    [anon_sym_LT_LT] = ACTIONS(4561),
    [anon_sym_GT_GT] = ACTIONS(4561),
    [anon_sym_PLUS] = ACTIONS(4563),
    [anon_sym_DASH] = ACTIONS(4563),
    [anon_sym_SLASH] = ACTIONS(4537),
    [anon_sym_PERCENT] = ACTIONS(4537),
    [anon_sym_DASH_DASH] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(1554),
    [anon_sym_DASH_GT] = ACTIONS(1554),
    [sym_comment] = ACTIONS(49),
  },
  [3039] = {
    [sym_compound_statement] = STATE(3099),
    [sym_labeled_statement] = STATE(3099),
    [sym_expression_statement] = STATE(3099),
    [sym_if_statement] = STATE(3099),
    [sym_switch_statement] = STATE(3099),
    [sym_case_statement] = STATE(3099),
    [sym_while_statement] = STATE(3099),
    [sym_do_statement] = STATE(3099),
    [sym_for_statement] = STATE(3099),
    [sym_return_statement] = STATE(3099),
    [sym_break_statement] = STATE(3099),
    [sym_continue_statement] = STATE(3099),
    [sym_goto_statement] = STATE(3099),
    [sym__expression] = STATE(2739),
    [sym_comma_expression] = STATE(2740),
    [sym_conditional_expression] = STATE(2739),
    [sym_assignment_expression] = STATE(2739),
    [sym_pointer_expression] = STATE(2739),
    [sym_logical_expression] = STATE(2739),
    [sym_bitwise_expression] = STATE(2739),
    [sym_equality_expression] = STATE(2739),
    [sym_relational_expression] = STATE(2739),
    [sym_shift_expression] = STATE(2739),
    [sym_math_expression] = STATE(2739),
    [sym_cast_expression] = STATE(2739),
    [sym_sizeof_expression] = STATE(2739),
    [sym_subscript_expression] = STATE(2739),
    [sym_call_expression] = STATE(2739),
    [sym_field_expression] = STATE(2739),
    [sym_compound_literal_expression] = STATE(2739),
    [sym_parenthesized_expression] = STATE(2739),
    [sym_concatenated_string] = STATE(2739),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(2739),
    [sym_for_range_loop] = STATE(3099),
    [sym_new_expression] = STATE(2739),
    [sym_delete_expression] = STATE(2739),
    [sym_lambda_expression] = STATE(2739),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(6507),
    [anon_sym_LPAREN] = ACTIONS(626),
    [anon_sym_SEMI] = ACTIONS(6509),
    [anon_sym_LBRACE] = ACTIONS(6511),
    [anon_sym_STAR] = ACTIONS(644),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_if] = ACTIONS(6513),
    [anon_sym_switch] = ACTIONS(6515),
    [anon_sym_case] = ACTIONS(6517),
    [anon_sym_default] = ACTIONS(6519),
    [anon_sym_while] = ACTIONS(6521),
    [anon_sym_do] = ACTIONS(6523),
    [anon_sym_for] = ACTIONS(6525),
    [anon_sym_return] = ACTIONS(6527),
    [anon_sym_break] = ACTIONS(6529),
    [anon_sym_continue] = ACTIONS(6531),
    [anon_sym_goto] = ACTIONS(6533),
    [anon_sym_AMP] = ACTIONS(644),
    [anon_sym_BANG] = ACTIONS(668),
    [anon_sym_TILDE] = ACTIONS(670),
    [anon_sym_PLUS] = ACTIONS(672),
    [anon_sym_DASH] = ACTIONS(672),
    [anon_sym_DASH_DASH] = ACTIONS(674),
    [anon_sym_PLUS_PLUS] = ACTIONS(674),
    [anon_sym_sizeof] = ACTIONS(676),
    [sym_number_literal] = ACTIONS(6507),
    [sym_char_literal] = ACTIONS(6507),
    [sym_string_literal] = ACTIONS(678),
    [sym_true] = ACTIONS(6535),
    [sym_false] = ACTIONS(6535),
    [sym_null] = ACTIONS(6535),
    [sym_identifier] = ACTIONS(6537),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1303),
    [anon_sym_delete] = ACTIONS(686),
    [sym_nullptr] = ACTIONS(6535),
  },
  [3040] = {
    [sym_raw_string_literal] = ACTIONS(5631),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(5633),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(5633),
    [anon_sym_LPAREN] = ACTIONS(5631),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(5633),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(5633),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(5633),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(5633),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(5633),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(5633),
    [sym_preproc_directive] = ACTIONS(5633),
    [anon_sym_SEMI] = ACTIONS(5631),
    [anon_sym_typedef] = ACTIONS(5633),
    [anon_sym_extern] = ACTIONS(5633),
    [anon_sym_LBRACE] = ACTIONS(5631),
    [anon_sym_STAR] = ACTIONS(5631),
    [anon_sym_LBRACK] = ACTIONS(5631),
    [anon_sym_static] = ACTIONS(5633),
    [anon_sym_register] = ACTIONS(5633),
    [anon_sym_inline] = ACTIONS(5633),
    [anon_sym_const] = ACTIONS(5633),
    [anon_sym_restrict] = ACTIONS(5633),
    [anon_sym_volatile] = ACTIONS(5633),
    [anon_sym__Atomic] = ACTIONS(5633),
    [anon_sym_mutable] = ACTIONS(5633),
    [anon_sym_explicit] = ACTIONS(5633),
    [anon_sym_constexpr] = ACTIONS(5633),
    [anon_sym_unsigned] = ACTIONS(5633),
    [anon_sym_long] = ACTIONS(5633),
    [anon_sym_short] = ACTIONS(5633),
    [sym_primitive_type] = ACTIONS(5633),
    [anon_sym_enum] = ACTIONS(5633),
    [anon_sym_struct] = ACTIONS(5633),
    [anon_sym_union] = ACTIONS(5633),
    [anon_sym_if] = ACTIONS(5633),
    [anon_sym_else] = ACTIONS(5633),
    [anon_sym_switch] = ACTIONS(5633),
    [anon_sym_case] = ACTIONS(5633),
    [anon_sym_default] = ACTIONS(5633),
    [anon_sym_while] = ACTIONS(5633),
    [anon_sym_do] = ACTIONS(5633),
    [anon_sym_for] = ACTIONS(5633),
    [anon_sym_return] = ACTIONS(5633),
    [anon_sym_break] = ACTIONS(5633),
    [anon_sym_continue] = ACTIONS(5633),
    [anon_sym_goto] = ACTIONS(5633),
    [anon_sym_AMP] = ACTIONS(5631),
    [anon_sym_BANG] = ACTIONS(5631),
    [anon_sym_TILDE] = ACTIONS(5631),
    [anon_sym_PLUS] = ACTIONS(5633),
    [anon_sym_DASH] = ACTIONS(5633),
    [anon_sym_DASH_DASH] = ACTIONS(5631),
    [anon_sym_PLUS_PLUS] = ACTIONS(5631),
    [anon_sym_sizeof] = ACTIONS(5633),
    [sym_number_literal] = ACTIONS(5631),
    [sym_char_literal] = ACTIONS(5631),
    [sym_string_literal] = ACTIONS(5631),
    [sym_true] = ACTIONS(5633),
    [sym_false] = ACTIONS(5633),
    [sym_null] = ACTIONS(5633),
    [sym_identifier] = ACTIONS(5633),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(5633),
    [sym_auto] = ACTIONS(5633),
    [anon_sym_typename] = ACTIONS(5633),
    [anon_sym_new] = ACTIONS(5633),
    [anon_sym_COLON_COLON] = ACTIONS(5631),
    [anon_sym_delete] = ACTIONS(5633),
    [sym_nullptr] = ACTIONS(5633),
  },
  [3041] = {
    [sym__type_declarator] = STATE(3100),
    [sym_pointer_type_declarator] = STATE(213),
    [sym_function_type_declarator] = STATE(214),
    [sym_array_type_declarator] = STATE(215),
    [anon_sym_LPAREN] = ACTIONS(327),
    [anon_sym_STAR] = ACTIONS(329),
    [sym_identifier] = ACTIONS(331),
    [sym_comment] = ACTIONS(49),
  },
  [3042] = {
    [sym_type_qualifier] = STATE(219),
    [sym__type_specifier] = STATE(3101),
    [sym_sized_type_specifier] = STATE(3101),
    [sym_enum_specifier] = STATE(3101),
    [sym_struct_specifier] = STATE(3101),
    [sym_union_specifier] = STATE(3101),
    [sym_macro_type_specifier] = STATE(3101),
    [sym_class_specifier] = STATE(3101),
    [sym_dependent_type] = STATE(3101),
    [sym_template_type] = STATE(62),
    [sym_scoped_type_identifier] = STATE(63),
    [sym_scoped_namespace_identifier] = STATE(64),
    [aux_sym_type_definition_repeat1] = STATE(219),
    [aux_sym_sized_type_specifier_repeat1] = STATE(66),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_restrict] = ACTIONS(93),
    [anon_sym_volatile] = ACTIONS(93),
    [anon_sym__Atomic] = ACTIONS(93),
    [anon_sym_mutable] = ACTIONS(93),
    [anon_sym_explicit] = ACTIONS(93),
    [anon_sym_constexpr] = ACTIONS(93),
    [anon_sym_unsigned] = ACTIONS(95),
    [anon_sym_long] = ACTIONS(95),
    [anon_sym_short] = ACTIONS(95),
    [sym_primitive_type] = ACTIONS(7241),
    [anon_sym_enum] = ACTIONS(99),
    [anon_sym_struct] = ACTIONS(101),
    [anon_sym_union] = ACTIONS(103),
    [sym_identifier] = ACTIONS(105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(107),
    [sym_auto] = ACTIONS(7241),
    [anon_sym_typename] = ACTIONS(109),
    [anon_sym_COLON_COLON] = ACTIONS(111),
  },
  [3043] = {
    [sym_parameter_list] = STATE(332),
    [sym_argument_list] = STATE(333),
    [sym_initializer_list] = STATE(333),
    [aux_sym_declaration_repeat1] = STATE(3103),
    [anon_sym_LPAREN] = ACTIONS(536),
    [anon_sym_COMMA] = ACTIONS(538),
    [anon_sym_SEMI] = ACTIONS(7243),
    [anon_sym_LBRACE] = ACTIONS(548),
    [anon_sym_LBRACK] = ACTIONS(208),
    [anon_sym_EQ] = ACTIONS(544),
    [sym_comment] = ACTIONS(49),
  },
  [3044] = {
    [aux_sym_declaration_repeat1] = STATE(3103),
    [anon_sym_COMMA] = ACTIONS(538),
    [anon_sym_SEMI] = ACTIONS(7243),
    [sym_comment] = ACTIONS(49),
  },
  [3045] = {
    [sym_compound_statement] = STATE(3104),
    [sym_labeled_statement] = STATE(3104),
    [sym_expression_statement] = STATE(3104),
    [sym_if_statement] = STATE(3104),
    [sym_switch_statement] = STATE(3104),
    [sym_case_statement] = STATE(3104),
    [sym_while_statement] = STATE(3104),
    [sym_do_statement] = STATE(3104),
    [sym_for_statement] = STATE(3104),
    [sym_return_statement] = STATE(3104),
    [sym_break_statement] = STATE(3104),
    [sym_continue_statement] = STATE(3104),
    [sym_goto_statement] = STATE(3104),
    [sym__expression] = STATE(2739),
    [sym_comma_expression] = STATE(2740),
    [sym_conditional_expression] = STATE(2739),
    [sym_assignment_expression] = STATE(2739),
    [sym_pointer_expression] = STATE(2739),
    [sym_logical_expression] = STATE(2739),
    [sym_bitwise_expression] = STATE(2739),
    [sym_equality_expression] = STATE(2739),
    [sym_relational_expression] = STATE(2739),
    [sym_shift_expression] = STATE(2739),
    [sym_math_expression] = STATE(2739),
    [sym_cast_expression] = STATE(2739),
    [sym_sizeof_expression] = STATE(2739),
    [sym_subscript_expression] = STATE(2739),
    [sym_call_expression] = STATE(2739),
    [sym_field_expression] = STATE(2739),
    [sym_compound_literal_expression] = STATE(2739),
    [sym_parenthesized_expression] = STATE(2739),
    [sym_concatenated_string] = STATE(2739),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(2739),
    [sym_for_range_loop] = STATE(3104),
    [sym_new_expression] = STATE(2739),
    [sym_delete_expression] = STATE(2739),
    [sym_lambda_expression] = STATE(2739),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(6507),
    [anon_sym_LPAREN] = ACTIONS(626),
    [anon_sym_SEMI] = ACTIONS(6509),
    [anon_sym_LBRACE] = ACTIONS(6511),
    [anon_sym_STAR] = ACTIONS(644),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_if] = ACTIONS(6513),
    [anon_sym_switch] = ACTIONS(6515),
    [anon_sym_case] = ACTIONS(6517),
    [anon_sym_default] = ACTIONS(6519),
    [anon_sym_while] = ACTIONS(6521),
    [anon_sym_do] = ACTIONS(6523),
    [anon_sym_for] = ACTIONS(6525),
    [anon_sym_return] = ACTIONS(6527),
    [anon_sym_break] = ACTIONS(6529),
    [anon_sym_continue] = ACTIONS(6531),
    [anon_sym_goto] = ACTIONS(6533),
    [anon_sym_AMP] = ACTIONS(644),
    [anon_sym_BANG] = ACTIONS(668),
    [anon_sym_TILDE] = ACTIONS(670),
    [anon_sym_PLUS] = ACTIONS(672),
    [anon_sym_DASH] = ACTIONS(672),
    [anon_sym_DASH_DASH] = ACTIONS(674),
    [anon_sym_PLUS_PLUS] = ACTIONS(674),
    [anon_sym_sizeof] = ACTIONS(676),
    [sym_number_literal] = ACTIONS(6507),
    [sym_char_literal] = ACTIONS(6507),
    [sym_string_literal] = ACTIONS(678),
    [sym_true] = ACTIONS(6535),
    [sym_false] = ACTIONS(6535),
    [sym_null] = ACTIONS(6535),
    [sym_identifier] = ACTIONS(6537),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1303),
    [anon_sym_delete] = ACTIONS(686),
    [sym_nullptr] = ACTIONS(6535),
  },
  [3046] = {
    [sym__expression] = STATE(3105),
    [sym_conditional_expression] = STATE(3105),
    [sym_assignment_expression] = STATE(3105),
    [sym_pointer_expression] = STATE(3105),
    [sym_logical_expression] = STATE(3105),
    [sym_bitwise_expression] = STATE(3105),
    [sym_equality_expression] = STATE(3105),
    [sym_relational_expression] = STATE(3105),
    [sym_shift_expression] = STATE(3105),
    [sym_math_expression] = STATE(3105),
    [sym_cast_expression] = STATE(3105),
    [sym_sizeof_expression] = STATE(3105),
    [sym_subscript_expression] = STATE(3105),
    [sym_call_expression] = STATE(3105),
    [sym_field_expression] = STATE(3105),
    [sym_compound_literal_expression] = STATE(3105),
    [sym_parenthesized_expression] = STATE(3105),
    [sym_concatenated_string] = STATE(3105),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(3105),
    [sym_new_expression] = STATE(3105),
    [sym_delete_expression] = STATE(3105),
    [sym_lambda_expression] = STATE(3105),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(7245),
    [anon_sym_LPAREN] = ACTIONS(2943),
    [anon_sym_STAR] = ACTIONS(2945),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_AMP] = ACTIONS(2945),
    [anon_sym_BANG] = ACTIONS(2947),
    [anon_sym_TILDE] = ACTIONS(2949),
    [anon_sym_PLUS] = ACTIONS(2951),
    [anon_sym_DASH] = ACTIONS(2951),
    [anon_sym_DASH_DASH] = ACTIONS(2953),
    [anon_sym_PLUS_PLUS] = ACTIONS(2953),
    [anon_sym_sizeof] = ACTIONS(2955),
    [sym_number_literal] = ACTIONS(7245),
    [sym_char_literal] = ACTIONS(7245),
    [sym_string_literal] = ACTIONS(2957),
    [sym_true] = ACTIONS(7247),
    [sym_false] = ACTIONS(7247),
    [sym_null] = ACTIONS(7247),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(2961),
    [anon_sym_delete] = ACTIONS(2963),
    [sym_nullptr] = ACTIONS(7247),
  },
  [3047] = {
    [sym__expression] = STATE(3107),
    [sym_conditional_expression] = STATE(3107),
    [sym_assignment_expression] = STATE(3107),
    [sym_pointer_expression] = STATE(3107),
    [sym_logical_expression] = STATE(3107),
    [sym_bitwise_expression] = STATE(3107),
    [sym_equality_expression] = STATE(3107),
    [sym_relational_expression] = STATE(3107),
    [sym_shift_expression] = STATE(3107),
    [sym_math_expression] = STATE(3107),
    [sym_cast_expression] = STATE(3107),
    [sym_sizeof_expression] = STATE(3107),
    [sym_subscript_expression] = STATE(3107),
    [sym_call_expression] = STATE(3107),
    [sym_field_expression] = STATE(3107),
    [sym_compound_literal_expression] = STATE(3107),
    [sym_parenthesized_expression] = STATE(3107),
    [sym_concatenated_string] = STATE(3107),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(3107),
    [sym_new_expression] = STATE(3107),
    [sym_delete_expression] = STATE(3107),
    [sym_lambda_expression] = STATE(3107),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(7249),
    [anon_sym_LPAREN] = ACTIONS(1087),
    [anon_sym_RPAREN] = ACTIONS(7251),
    [anon_sym_STAR] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_AMP] = ACTIONS(1089),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1093),
    [anon_sym_PLUS] = ACTIONS(1095),
    [anon_sym_DASH] = ACTIONS(1095),
    [anon_sym_DASH_DASH] = ACTIONS(1097),
    [anon_sym_PLUS_PLUS] = ACTIONS(1097),
    [anon_sym_sizeof] = ACTIONS(1099),
    [sym_number_literal] = ACTIONS(7249),
    [sym_char_literal] = ACTIONS(7249),
    [sym_string_literal] = ACTIONS(1101),
    [sym_true] = ACTIONS(7253),
    [sym_false] = ACTIONS(7253),
    [sym_null] = ACTIONS(7253),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_delete] = ACTIONS(1109),
    [sym_nullptr] = ACTIONS(7253),
  },
  [3048] = {
    [sym_argument_list] = STATE(802),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_SEMI] = ACTIONS(7255),
    [anon_sym_STAR] = ACTIONS(2553),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_EQ] = ACTIONS(2555),
    [anon_sym_QMARK] = ACTIONS(2557),
    [anon_sym_STAR_EQ] = ACTIONS(2559),
    [anon_sym_SLASH_EQ] = ACTIONS(2559),
    [anon_sym_PERCENT_EQ] = ACTIONS(2559),
    [anon_sym_PLUS_EQ] = ACTIONS(2559),
    [anon_sym_DASH_EQ] = ACTIONS(2559),
    [anon_sym_LT_LT_EQ] = ACTIONS(2559),
    [anon_sym_GT_GT_EQ] = ACTIONS(2559),
    [anon_sym_AMP_EQ] = ACTIONS(2559),
    [anon_sym_CARET_EQ] = ACTIONS(2559),
    [anon_sym_PIPE_EQ] = ACTIONS(2559),
    [anon_sym_AMP] = ACTIONS(2561),
    [anon_sym_PIPE_PIPE] = ACTIONS(2563),
    [anon_sym_AMP_AMP] = ACTIONS(2565),
    [anon_sym_PIPE] = ACTIONS(2567),
    [anon_sym_CARET] = ACTIONS(2569),
    [anon_sym_EQ_EQ] = ACTIONS(2571),
    [anon_sym_BANG_EQ] = ACTIONS(2571),
    [anon_sym_LT] = ACTIONS(2573),
    [anon_sym_GT] = ACTIONS(2573),
    [anon_sym_LT_EQ] = ACTIONS(2575),
    [anon_sym_GT_EQ] = ACTIONS(2575),
    [anon_sym_LT_LT] = ACTIONS(2577),
    [anon_sym_GT_GT] = ACTIONS(2577),
    [anon_sym_PLUS] = ACTIONS(2579),
    [anon_sym_DASH] = ACTIONS(2579),
    [anon_sym_SLASH] = ACTIONS(2553),
    [anon_sym_PERCENT] = ACTIONS(2553),
    [anon_sym_DASH_DASH] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(1554),
    [anon_sym_DASH_GT] = ACTIONS(1554),
    [sym_comment] = ACTIONS(49),
  },
  [3049] = {
    [sym__expression] = STATE(3109),
    [sym_conditional_expression] = STATE(3109),
    [sym_assignment_expression] = STATE(3109),
    [sym_pointer_expression] = STATE(3109),
    [sym_logical_expression] = STATE(3109),
    [sym_bitwise_expression] = STATE(3109),
    [sym_equality_expression] = STATE(3109),
    [sym_relational_expression] = STATE(3109),
    [sym_shift_expression] = STATE(3109),
    [sym_math_expression] = STATE(3109),
    [sym_cast_expression] = STATE(3109),
    [sym_sizeof_expression] = STATE(3109),
    [sym_subscript_expression] = STATE(3109),
    [sym_call_expression] = STATE(3109),
    [sym_field_expression] = STATE(3109),
    [sym_compound_literal_expression] = STATE(3109),
    [sym_parenthesized_expression] = STATE(3109),
    [sym_concatenated_string] = STATE(3109),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(3109),
    [sym_new_expression] = STATE(3109),
    [sym_delete_expression] = STATE(3109),
    [sym_lambda_expression] = STATE(3109),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(7257),
    [anon_sym_LPAREN] = ACTIONS(1347),
    [anon_sym_SEMI] = ACTIONS(7255),
    [anon_sym_STAR] = ACTIONS(1349),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_AMP] = ACTIONS(1349),
    [anon_sym_BANG] = ACTIONS(1351),
    [anon_sym_TILDE] = ACTIONS(1353),
    [anon_sym_PLUS] = ACTIONS(1355),
    [anon_sym_DASH] = ACTIONS(1355),
    [anon_sym_DASH_DASH] = ACTIONS(1357),
    [anon_sym_PLUS_PLUS] = ACTIONS(1357),
    [anon_sym_sizeof] = ACTIONS(1359),
    [sym_number_literal] = ACTIONS(7257),
    [sym_char_literal] = ACTIONS(7257),
    [sym_string_literal] = ACTIONS(1361),
    [sym_true] = ACTIONS(7259),
    [sym_false] = ACTIONS(7259),
    [sym_null] = ACTIONS(7259),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1365),
    [anon_sym_delete] = ACTIONS(1367),
    [sym_nullptr] = ACTIONS(7259),
  },
  [3050] = {
    [sym__expression] = STATE(3110),
    [sym_conditional_expression] = STATE(3110),
    [sym_assignment_expression] = STATE(3110),
    [sym_pointer_expression] = STATE(3110),
    [sym_logical_expression] = STATE(3110),
    [sym_bitwise_expression] = STATE(3110),
    [sym_equality_expression] = STATE(3110),
    [sym_relational_expression] = STATE(3110),
    [sym_shift_expression] = STATE(3110),
    [sym_math_expression] = STATE(3110),
    [sym_cast_expression] = STATE(3110),
    [sym_sizeof_expression] = STATE(3110),
    [sym_subscript_expression] = STATE(3110),
    [sym_call_expression] = STATE(3110),
    [sym_field_expression] = STATE(3110),
    [sym_compound_literal_expression] = STATE(3110),
    [sym_parenthesized_expression] = STATE(3110),
    [sym_concatenated_string] = STATE(3110),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(3110),
    [sym_new_expression] = STATE(3110),
    [sym_delete_expression] = STATE(3110),
    [sym_lambda_expression] = STATE(3110),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(7261),
    [anon_sym_LPAREN] = ACTIONS(2943),
    [anon_sym_STAR] = ACTIONS(2945),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_AMP] = ACTIONS(2945),
    [anon_sym_BANG] = ACTIONS(2947),
    [anon_sym_TILDE] = ACTIONS(2949),
    [anon_sym_PLUS] = ACTIONS(2951),
    [anon_sym_DASH] = ACTIONS(2951),
    [anon_sym_DASH_DASH] = ACTIONS(2953),
    [anon_sym_PLUS_PLUS] = ACTIONS(2953),
    [anon_sym_sizeof] = ACTIONS(2955),
    [sym_number_literal] = ACTIONS(7261),
    [sym_char_literal] = ACTIONS(7261),
    [sym_string_literal] = ACTIONS(2957),
    [sym_true] = ACTIONS(7263),
    [sym_false] = ACTIONS(7263),
    [sym_null] = ACTIONS(7263),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(2961),
    [anon_sym_delete] = ACTIONS(2963),
    [sym_nullptr] = ACTIONS(7263),
  },
  [3051] = {
    [sym_raw_string_literal] = ACTIONS(7057),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(7059),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(7059),
    [anon_sym_LPAREN] = ACTIONS(7057),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(7059),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(7059),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(7059),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(7059),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(7059),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(7059),
    [sym_preproc_directive] = ACTIONS(7059),
    [anon_sym_SEMI] = ACTIONS(7057),
    [anon_sym_typedef] = ACTIONS(7059),
    [anon_sym_extern] = ACTIONS(7059),
    [anon_sym_LBRACE] = ACTIONS(7057),
    [anon_sym_STAR] = ACTIONS(7057),
    [anon_sym_LBRACK] = ACTIONS(7057),
    [anon_sym_static] = ACTIONS(7059),
    [anon_sym_register] = ACTIONS(7059),
    [anon_sym_inline] = ACTIONS(7059),
    [anon_sym_const] = ACTIONS(7059),
    [anon_sym_restrict] = ACTIONS(7059),
    [anon_sym_volatile] = ACTIONS(7059),
    [anon_sym__Atomic] = ACTIONS(7059),
    [anon_sym_mutable] = ACTIONS(7059),
    [anon_sym_explicit] = ACTIONS(7059),
    [anon_sym_constexpr] = ACTIONS(7059),
    [anon_sym_unsigned] = ACTIONS(7059),
    [anon_sym_long] = ACTIONS(7059),
    [anon_sym_short] = ACTIONS(7059),
    [sym_primitive_type] = ACTIONS(7059),
    [anon_sym_enum] = ACTIONS(7059),
    [anon_sym_struct] = ACTIONS(7059),
    [anon_sym_union] = ACTIONS(7059),
    [anon_sym_if] = ACTIONS(7059),
    [anon_sym_switch] = ACTIONS(7059),
    [anon_sym_case] = ACTIONS(7059),
    [anon_sym_default] = ACTIONS(7059),
    [anon_sym_while] = ACTIONS(7059),
    [anon_sym_do] = ACTIONS(7059),
    [anon_sym_for] = ACTIONS(7059),
    [anon_sym_return] = ACTIONS(7059),
    [anon_sym_break] = ACTIONS(7059),
    [anon_sym_continue] = ACTIONS(7059),
    [anon_sym_goto] = ACTIONS(7059),
    [anon_sym_AMP] = ACTIONS(7057),
    [anon_sym_BANG] = ACTIONS(7057),
    [anon_sym_TILDE] = ACTIONS(7057),
    [anon_sym_PLUS] = ACTIONS(7059),
    [anon_sym_DASH] = ACTIONS(7059),
    [anon_sym_DASH_DASH] = ACTIONS(7057),
    [anon_sym_PLUS_PLUS] = ACTIONS(7057),
    [anon_sym_sizeof] = ACTIONS(7059),
    [sym_number_literal] = ACTIONS(7057),
    [sym_char_literal] = ACTIONS(7057),
    [sym_string_literal] = ACTIONS(7057),
    [sym_true] = ACTIONS(7059),
    [sym_false] = ACTIONS(7059),
    [sym_null] = ACTIONS(7059),
    [sym_identifier] = ACTIONS(7059),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(7059),
    [sym_auto] = ACTIONS(7059),
    [anon_sym_typename] = ACTIONS(7059),
    [anon_sym_new] = ACTIONS(7059),
    [anon_sym_COLON_COLON] = ACTIONS(7057),
    [anon_sym_delete] = ACTIONS(7059),
    [sym_nullptr] = ACTIONS(7059),
  },
  [3052] = {
    [sym_raw_string_literal] = ACTIONS(7083),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(7085),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(7085),
    [anon_sym_LPAREN] = ACTIONS(7083),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(7085),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(7085),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(7085),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(7085),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(7085),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(7085),
    [sym_preproc_directive] = ACTIONS(7085),
    [anon_sym_SEMI] = ACTIONS(7083),
    [anon_sym_typedef] = ACTIONS(7085),
    [anon_sym_extern] = ACTIONS(7085),
    [anon_sym_LBRACE] = ACTIONS(7083),
    [anon_sym_STAR] = ACTIONS(7083),
    [anon_sym_LBRACK] = ACTIONS(7083),
    [anon_sym_static] = ACTIONS(7085),
    [anon_sym_register] = ACTIONS(7085),
    [anon_sym_inline] = ACTIONS(7085),
    [anon_sym_const] = ACTIONS(7085),
    [anon_sym_restrict] = ACTIONS(7085),
    [anon_sym_volatile] = ACTIONS(7085),
    [anon_sym__Atomic] = ACTIONS(7085),
    [anon_sym_mutable] = ACTIONS(7085),
    [anon_sym_explicit] = ACTIONS(7085),
    [anon_sym_constexpr] = ACTIONS(7085),
    [anon_sym_unsigned] = ACTIONS(7085),
    [anon_sym_long] = ACTIONS(7085),
    [anon_sym_short] = ACTIONS(7085),
    [sym_primitive_type] = ACTIONS(7085),
    [anon_sym_enum] = ACTIONS(7085),
    [anon_sym_struct] = ACTIONS(7085),
    [anon_sym_union] = ACTIONS(7085),
    [anon_sym_if] = ACTIONS(7085),
    [anon_sym_switch] = ACTIONS(7085),
    [anon_sym_case] = ACTIONS(7085),
    [anon_sym_default] = ACTIONS(7085),
    [anon_sym_while] = ACTIONS(7085),
    [anon_sym_do] = ACTIONS(7085),
    [anon_sym_for] = ACTIONS(7085),
    [anon_sym_return] = ACTIONS(7085),
    [anon_sym_break] = ACTIONS(7085),
    [anon_sym_continue] = ACTIONS(7085),
    [anon_sym_goto] = ACTIONS(7085),
    [anon_sym_AMP] = ACTIONS(7083),
    [anon_sym_BANG] = ACTIONS(7083),
    [anon_sym_TILDE] = ACTIONS(7083),
    [anon_sym_PLUS] = ACTIONS(7085),
    [anon_sym_DASH] = ACTIONS(7085),
    [anon_sym_DASH_DASH] = ACTIONS(7083),
    [anon_sym_PLUS_PLUS] = ACTIONS(7083),
    [anon_sym_sizeof] = ACTIONS(7085),
    [sym_number_literal] = ACTIONS(7083),
    [sym_char_literal] = ACTIONS(7083),
    [sym_string_literal] = ACTIONS(7083),
    [sym_true] = ACTIONS(7085),
    [sym_false] = ACTIONS(7085),
    [sym_null] = ACTIONS(7085),
    [sym_identifier] = ACTIONS(7085),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(7085),
    [sym_auto] = ACTIONS(7085),
    [anon_sym_typename] = ACTIONS(7085),
    [anon_sym_new] = ACTIONS(7085),
    [anon_sym_COLON_COLON] = ACTIONS(7083),
    [anon_sym_delete] = ACTIONS(7085),
    [sym_nullptr] = ACTIONS(7085),
  },
  [3053] = {
    [sym_compound_statement] = STATE(3111),
    [sym_labeled_statement] = STATE(3111),
    [sym_expression_statement] = STATE(3111),
    [sym_if_statement] = STATE(3111),
    [sym_switch_statement] = STATE(3111),
    [sym_case_statement] = STATE(3111),
    [sym_while_statement] = STATE(3111),
    [sym_do_statement] = STATE(3111),
    [sym_for_statement] = STATE(3111),
    [sym_return_statement] = STATE(3111),
    [sym_break_statement] = STATE(3111),
    [sym_continue_statement] = STATE(3111),
    [sym_goto_statement] = STATE(3111),
    [sym__expression] = STATE(1419),
    [sym_comma_expression] = STATE(1420),
    [sym_conditional_expression] = STATE(1419),
    [sym_assignment_expression] = STATE(1419),
    [sym_pointer_expression] = STATE(1419),
    [sym_logical_expression] = STATE(1419),
    [sym_bitwise_expression] = STATE(1419),
    [sym_equality_expression] = STATE(1419),
    [sym_relational_expression] = STATE(1419),
    [sym_shift_expression] = STATE(1419),
    [sym_math_expression] = STATE(1419),
    [sym_cast_expression] = STATE(1419),
    [sym_sizeof_expression] = STATE(1419),
    [sym_subscript_expression] = STATE(1419),
    [sym_call_expression] = STATE(1419),
    [sym_field_expression] = STATE(1419),
    [sym_compound_literal_expression] = STATE(1419),
    [sym_parenthesized_expression] = STATE(1419),
    [sym_concatenated_string] = STATE(1419),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(1419),
    [sym_for_range_loop] = STATE(3111),
    [sym_new_expression] = STATE(1419),
    [sym_delete_expression] = STATE(1419),
    [sym_lambda_expression] = STATE(1419),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(2879),
    [anon_sym_LPAREN] = ACTIONS(626),
    [anon_sym_SEMI] = ACTIONS(2899),
    [anon_sym_LBRACE] = ACTIONS(2903),
    [anon_sym_STAR] = ACTIONS(644),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_if] = ACTIONS(2905),
    [anon_sym_switch] = ACTIONS(2907),
    [anon_sym_case] = ACTIONS(2909),
    [anon_sym_default] = ACTIONS(2911),
    [anon_sym_while] = ACTIONS(2913),
    [anon_sym_do] = ACTIONS(2915),
    [anon_sym_for] = ACTIONS(2917),
    [anon_sym_return] = ACTIONS(2919),
    [anon_sym_break] = ACTIONS(2921),
    [anon_sym_continue] = ACTIONS(2923),
    [anon_sym_goto] = ACTIONS(2925),
    [anon_sym_AMP] = ACTIONS(644),
    [anon_sym_BANG] = ACTIONS(668),
    [anon_sym_TILDE] = ACTIONS(670),
    [anon_sym_PLUS] = ACTIONS(672),
    [anon_sym_DASH] = ACTIONS(672),
    [anon_sym_DASH_DASH] = ACTIONS(674),
    [anon_sym_PLUS_PLUS] = ACTIONS(674),
    [anon_sym_sizeof] = ACTIONS(676),
    [sym_number_literal] = ACTIONS(2879),
    [sym_char_literal] = ACTIONS(2879),
    [sym_string_literal] = ACTIONS(678),
    [sym_true] = ACTIONS(2927),
    [sym_false] = ACTIONS(2927),
    [sym_null] = ACTIONS(2927),
    [sym_identifier] = ACTIONS(5397),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1303),
    [anon_sym_delete] = ACTIONS(686),
    [sym_nullptr] = ACTIONS(2927),
  },
  [3054] = {
    [aux_sym_for_statement_repeat1] = STATE(2796),
    [anon_sym_COMMA] = ACTIONS(6339),
    [anon_sym_RPAREN] = ACTIONS(7265),
    [sym_comment] = ACTIONS(49),
  },
  [3055] = {
    [sym_compound_statement] = STATE(3113),
    [sym_labeled_statement] = STATE(3113),
    [sym_expression_statement] = STATE(3113),
    [sym_if_statement] = STATE(3113),
    [sym_switch_statement] = STATE(3113),
    [sym_case_statement] = STATE(3113),
    [sym_while_statement] = STATE(3113),
    [sym_do_statement] = STATE(3113),
    [sym_for_statement] = STATE(3113),
    [sym_return_statement] = STATE(3113),
    [sym_break_statement] = STATE(3113),
    [sym_continue_statement] = STATE(3113),
    [sym_goto_statement] = STATE(3113),
    [sym__expression] = STATE(2378),
    [sym_comma_expression] = STATE(2379),
    [sym_conditional_expression] = STATE(2378),
    [sym_assignment_expression] = STATE(2378),
    [sym_pointer_expression] = STATE(2378),
    [sym_logical_expression] = STATE(2378),
    [sym_bitwise_expression] = STATE(2378),
    [sym_equality_expression] = STATE(2378),
    [sym_relational_expression] = STATE(2378),
    [sym_shift_expression] = STATE(2378),
    [sym_math_expression] = STATE(2378),
    [sym_cast_expression] = STATE(2378),
    [sym_sizeof_expression] = STATE(2378),
    [sym_subscript_expression] = STATE(2378),
    [sym_call_expression] = STATE(2378),
    [sym_field_expression] = STATE(2378),
    [sym_compound_literal_expression] = STATE(2378),
    [sym_parenthesized_expression] = STATE(2378),
    [sym_concatenated_string] = STATE(2378),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(2378),
    [sym_for_range_loop] = STATE(3113),
    [sym_new_expression] = STATE(2378),
    [sym_delete_expression] = STATE(2378),
    [sym_lambda_expression] = STATE(2378),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(5538),
    [anon_sym_LPAREN] = ACTIONS(626),
    [anon_sym_SEMI] = ACTIONS(5540),
    [anon_sym_LBRACE] = ACTIONS(5542),
    [anon_sym_STAR] = ACTIONS(644),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_if] = ACTIONS(5544),
    [anon_sym_switch] = ACTIONS(5546),
    [anon_sym_case] = ACTIONS(5548),
    [anon_sym_default] = ACTIONS(5550),
    [anon_sym_while] = ACTIONS(5552),
    [anon_sym_do] = ACTIONS(5554),
    [anon_sym_for] = ACTIONS(5556),
    [anon_sym_return] = ACTIONS(5558),
    [anon_sym_break] = ACTIONS(5560),
    [anon_sym_continue] = ACTIONS(5562),
    [anon_sym_goto] = ACTIONS(5564),
    [anon_sym_AMP] = ACTIONS(644),
    [anon_sym_BANG] = ACTIONS(668),
    [anon_sym_TILDE] = ACTIONS(670),
    [anon_sym_PLUS] = ACTIONS(672),
    [anon_sym_DASH] = ACTIONS(672),
    [anon_sym_DASH_DASH] = ACTIONS(674),
    [anon_sym_PLUS_PLUS] = ACTIONS(674),
    [anon_sym_sizeof] = ACTIONS(676),
    [sym_number_literal] = ACTIONS(5538),
    [sym_char_literal] = ACTIONS(5538),
    [sym_string_literal] = ACTIONS(678),
    [sym_true] = ACTIONS(5566),
    [sym_false] = ACTIONS(5566),
    [sym_null] = ACTIONS(5566),
    [sym_identifier] = ACTIONS(5568),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1303),
    [anon_sym_delete] = ACTIONS(686),
    [sym_nullptr] = ACTIONS(5566),
  },
  [3056] = {
    [sym_raw_string_literal] = ACTIONS(6611),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(6613),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(6613),
    [anon_sym_LPAREN] = ACTIONS(6611),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(6613),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(6613),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(6613),
    [sym_preproc_directive] = ACTIONS(6613),
    [anon_sym_SEMI] = ACTIONS(6611),
    [anon_sym_typedef] = ACTIONS(6613),
    [anon_sym_extern] = ACTIONS(6613),
    [anon_sym_LBRACE] = ACTIONS(6611),
    [anon_sym_RBRACE] = ACTIONS(6611),
    [anon_sym_STAR] = ACTIONS(6611),
    [anon_sym_LBRACK] = ACTIONS(6611),
    [anon_sym_static] = ACTIONS(6613),
    [anon_sym_register] = ACTIONS(6613),
    [anon_sym_inline] = ACTIONS(6613),
    [anon_sym_const] = ACTIONS(6613),
    [anon_sym_restrict] = ACTIONS(6613),
    [anon_sym_volatile] = ACTIONS(6613),
    [anon_sym__Atomic] = ACTIONS(6613),
    [anon_sym_mutable] = ACTIONS(6613),
    [anon_sym_explicit] = ACTIONS(6613),
    [anon_sym_constexpr] = ACTIONS(6613),
    [anon_sym_unsigned] = ACTIONS(6613),
    [anon_sym_long] = ACTIONS(6613),
    [anon_sym_short] = ACTIONS(6613),
    [sym_primitive_type] = ACTIONS(6613),
    [anon_sym_enum] = ACTIONS(6613),
    [anon_sym_struct] = ACTIONS(6613),
    [anon_sym_union] = ACTIONS(6613),
    [anon_sym_if] = ACTIONS(6613),
    [anon_sym_else] = ACTIONS(7267),
    [anon_sym_switch] = ACTIONS(6613),
    [anon_sym_case] = ACTIONS(6613),
    [anon_sym_default] = ACTIONS(6613),
    [anon_sym_while] = ACTIONS(6613),
    [anon_sym_do] = ACTIONS(6613),
    [anon_sym_for] = ACTIONS(6613),
    [anon_sym_return] = ACTIONS(6613),
    [anon_sym_break] = ACTIONS(6613),
    [anon_sym_continue] = ACTIONS(6613),
    [anon_sym_goto] = ACTIONS(6613),
    [anon_sym_AMP] = ACTIONS(6611),
    [anon_sym_BANG] = ACTIONS(6611),
    [anon_sym_TILDE] = ACTIONS(6611),
    [anon_sym_PLUS] = ACTIONS(6613),
    [anon_sym_DASH] = ACTIONS(6613),
    [anon_sym_DASH_DASH] = ACTIONS(6611),
    [anon_sym_PLUS_PLUS] = ACTIONS(6611),
    [anon_sym_sizeof] = ACTIONS(6613),
    [sym_number_literal] = ACTIONS(6611),
    [sym_char_literal] = ACTIONS(6611),
    [sym_string_literal] = ACTIONS(6611),
    [sym_true] = ACTIONS(6613),
    [sym_false] = ACTIONS(6613),
    [sym_null] = ACTIONS(6613),
    [sym_identifier] = ACTIONS(6613),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(6613),
    [sym_auto] = ACTIONS(6613),
    [anon_sym_typename] = ACTIONS(6613),
    [anon_sym_new] = ACTIONS(6613),
    [anon_sym_COLON_COLON] = ACTIONS(6611),
    [anon_sym_delete] = ACTIONS(6613),
    [sym_nullptr] = ACTIONS(6613),
  },
  [3057] = {
    [sym_raw_string_literal] = ACTIONS(1988),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1990),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1990),
    [anon_sym_LPAREN] = ACTIONS(1988),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1990),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1990),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1990),
    [sym_preproc_directive] = ACTIONS(1990),
    [anon_sym_SEMI] = ACTIONS(1988),
    [anon_sym_typedef] = ACTIONS(1990),
    [anon_sym_extern] = ACTIONS(1990),
    [anon_sym_LBRACE] = ACTIONS(1988),
    [anon_sym_RBRACE] = ACTIONS(1988),
    [anon_sym_STAR] = ACTIONS(1988),
    [anon_sym_LBRACK] = ACTIONS(1988),
    [anon_sym_static] = ACTIONS(1990),
    [anon_sym_register] = ACTIONS(1990),
    [anon_sym_inline] = ACTIONS(1990),
    [anon_sym_const] = ACTIONS(1990),
    [anon_sym_restrict] = ACTIONS(1990),
    [anon_sym_volatile] = ACTIONS(1990),
    [anon_sym__Atomic] = ACTIONS(1990),
    [anon_sym_mutable] = ACTIONS(1990),
    [anon_sym_explicit] = ACTIONS(1990),
    [anon_sym_constexpr] = ACTIONS(1990),
    [anon_sym_unsigned] = ACTIONS(1990),
    [anon_sym_long] = ACTIONS(1990),
    [anon_sym_short] = ACTIONS(1990),
    [sym_primitive_type] = ACTIONS(1990),
    [anon_sym_enum] = ACTIONS(1990),
    [anon_sym_struct] = ACTIONS(1990),
    [anon_sym_union] = ACTIONS(1990),
    [anon_sym_if] = ACTIONS(1990),
    [anon_sym_else] = ACTIONS(1990),
    [anon_sym_switch] = ACTIONS(1990),
    [anon_sym_case] = ACTIONS(1990),
    [anon_sym_default] = ACTIONS(1990),
    [anon_sym_while] = ACTIONS(1990),
    [anon_sym_do] = ACTIONS(1990),
    [anon_sym_for] = ACTIONS(1990),
    [anon_sym_return] = ACTIONS(1990),
    [anon_sym_break] = ACTIONS(1990),
    [anon_sym_continue] = ACTIONS(1990),
    [anon_sym_goto] = ACTIONS(1990),
    [anon_sym_AMP] = ACTIONS(1988),
    [anon_sym_BANG] = ACTIONS(1988),
    [anon_sym_TILDE] = ACTIONS(1988),
    [anon_sym_PLUS] = ACTIONS(1990),
    [anon_sym_DASH] = ACTIONS(1990),
    [anon_sym_DASH_DASH] = ACTIONS(1988),
    [anon_sym_PLUS_PLUS] = ACTIONS(1988),
    [anon_sym_sizeof] = ACTIONS(1990),
    [sym_number_literal] = ACTIONS(1988),
    [sym_char_literal] = ACTIONS(1988),
    [sym_string_literal] = ACTIONS(1988),
    [sym_true] = ACTIONS(1990),
    [sym_false] = ACTIONS(1990),
    [sym_null] = ACTIONS(1990),
    [sym_identifier] = ACTIONS(1990),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(1990),
    [sym_auto] = ACTIONS(1990),
    [anon_sym_typename] = ACTIONS(1990),
    [anon_sym_new] = ACTIONS(1990),
    [anon_sym_COLON_COLON] = ACTIONS(1988),
    [anon_sym_delete] = ACTIONS(1990),
    [sym_nullptr] = ACTIONS(1990),
  },
  [3058] = {
    [sym_parameter_list] = STATE(513),
    [anon_sym_LPAREN] = ACTIONS(206),
    [anon_sym_SEMI] = ACTIONS(7269),
    [anon_sym_LBRACK] = ACTIONS(955),
    [sym_comment] = ACTIONS(49),
  },
  [3059] = {
    [sym_raw_string_literal] = ACTIONS(2478),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(2480),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(2480),
    [anon_sym_LPAREN] = ACTIONS(2478),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(2480),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(2480),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(2480),
    [sym_preproc_directive] = ACTIONS(2480),
    [anon_sym_SEMI] = ACTIONS(2478),
    [anon_sym_typedef] = ACTIONS(2480),
    [anon_sym_extern] = ACTIONS(2480),
    [anon_sym_LBRACE] = ACTIONS(2478),
    [anon_sym_RBRACE] = ACTIONS(2478),
    [anon_sym_STAR] = ACTIONS(2478),
    [anon_sym_LBRACK] = ACTIONS(2478),
    [anon_sym_static] = ACTIONS(2480),
    [anon_sym_register] = ACTIONS(2480),
    [anon_sym_inline] = ACTIONS(2480),
    [anon_sym_const] = ACTIONS(2480),
    [anon_sym_restrict] = ACTIONS(2480),
    [anon_sym_volatile] = ACTIONS(2480),
    [anon_sym__Atomic] = ACTIONS(2480),
    [anon_sym_mutable] = ACTIONS(2480),
    [anon_sym_explicit] = ACTIONS(2480),
    [anon_sym_constexpr] = ACTIONS(2480),
    [anon_sym_unsigned] = ACTIONS(2480),
    [anon_sym_long] = ACTIONS(2480),
    [anon_sym_short] = ACTIONS(2480),
    [sym_primitive_type] = ACTIONS(2480),
    [anon_sym_enum] = ACTIONS(2480),
    [anon_sym_struct] = ACTIONS(2480),
    [anon_sym_union] = ACTIONS(2480),
    [anon_sym_if] = ACTIONS(2480),
    [anon_sym_else] = ACTIONS(2480),
    [anon_sym_switch] = ACTIONS(2480),
    [anon_sym_case] = ACTIONS(2480),
    [anon_sym_default] = ACTIONS(2480),
    [anon_sym_while] = ACTIONS(2480),
    [anon_sym_do] = ACTIONS(2480),
    [anon_sym_for] = ACTIONS(2480),
    [anon_sym_return] = ACTIONS(2480),
    [anon_sym_break] = ACTIONS(2480),
    [anon_sym_continue] = ACTIONS(2480),
    [anon_sym_goto] = ACTIONS(2480),
    [anon_sym_AMP] = ACTIONS(2478),
    [anon_sym_BANG] = ACTIONS(2478),
    [anon_sym_TILDE] = ACTIONS(2478),
    [anon_sym_PLUS] = ACTIONS(2480),
    [anon_sym_DASH] = ACTIONS(2480),
    [anon_sym_DASH_DASH] = ACTIONS(2478),
    [anon_sym_PLUS_PLUS] = ACTIONS(2478),
    [anon_sym_sizeof] = ACTIONS(2480),
    [sym_number_literal] = ACTIONS(2478),
    [sym_char_literal] = ACTIONS(2478),
    [sym_string_literal] = ACTIONS(2478),
    [sym_true] = ACTIONS(2480),
    [sym_false] = ACTIONS(2480),
    [sym_null] = ACTIONS(2480),
    [sym_identifier] = ACTIONS(2480),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(2480),
    [sym_auto] = ACTIONS(2480),
    [anon_sym_typename] = ACTIONS(2480),
    [anon_sym_new] = ACTIONS(2480),
    [anon_sym_COLON_COLON] = ACTIONS(2478),
    [anon_sym_delete] = ACTIONS(2480),
    [sym_nullptr] = ACTIONS(2480),
  },
  [3060] = {
    [sym_raw_string_literal] = ACTIONS(6653),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(6655),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(6655),
    [anon_sym_LPAREN] = ACTIONS(6653),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(6655),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(6655),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(6655),
    [sym_preproc_directive] = ACTIONS(6655),
    [anon_sym_SEMI] = ACTIONS(6653),
    [anon_sym_typedef] = ACTIONS(6655),
    [anon_sym_extern] = ACTIONS(6655),
    [anon_sym_LBRACE] = ACTIONS(6653),
    [anon_sym_RBRACE] = ACTIONS(6653),
    [anon_sym_STAR] = ACTIONS(6653),
    [anon_sym_LBRACK] = ACTIONS(6653),
    [anon_sym_static] = ACTIONS(6655),
    [anon_sym_register] = ACTIONS(6655),
    [anon_sym_inline] = ACTIONS(6655),
    [anon_sym_const] = ACTIONS(6655),
    [anon_sym_restrict] = ACTIONS(6655),
    [anon_sym_volatile] = ACTIONS(6655),
    [anon_sym__Atomic] = ACTIONS(6655),
    [anon_sym_mutable] = ACTIONS(6655),
    [anon_sym_explicit] = ACTIONS(6655),
    [anon_sym_constexpr] = ACTIONS(6655),
    [anon_sym_unsigned] = ACTIONS(6655),
    [anon_sym_long] = ACTIONS(6655),
    [anon_sym_short] = ACTIONS(6655),
    [sym_primitive_type] = ACTIONS(6655),
    [anon_sym_enum] = ACTIONS(6655),
    [anon_sym_struct] = ACTIONS(6655),
    [anon_sym_union] = ACTIONS(6655),
    [anon_sym_if] = ACTIONS(6655),
    [anon_sym_else] = ACTIONS(6655),
    [anon_sym_switch] = ACTIONS(6655),
    [anon_sym_case] = ACTIONS(6655),
    [anon_sym_default] = ACTIONS(6655),
    [anon_sym_while] = ACTIONS(6655),
    [anon_sym_do] = ACTIONS(6655),
    [anon_sym_for] = ACTIONS(6655),
    [anon_sym_return] = ACTIONS(6655),
    [anon_sym_break] = ACTIONS(6655),
    [anon_sym_continue] = ACTIONS(6655),
    [anon_sym_goto] = ACTIONS(6655),
    [anon_sym_AMP] = ACTIONS(6653),
    [anon_sym_BANG] = ACTIONS(6653),
    [anon_sym_TILDE] = ACTIONS(6653),
    [anon_sym_PLUS] = ACTIONS(6655),
    [anon_sym_DASH] = ACTIONS(6655),
    [anon_sym_DASH_DASH] = ACTIONS(6653),
    [anon_sym_PLUS_PLUS] = ACTIONS(6653),
    [anon_sym_sizeof] = ACTIONS(6655),
    [sym_number_literal] = ACTIONS(6653),
    [sym_char_literal] = ACTIONS(6653),
    [sym_string_literal] = ACTIONS(6653),
    [sym_true] = ACTIONS(6655),
    [sym_false] = ACTIONS(6655),
    [sym_null] = ACTIONS(6655),
    [sym_identifier] = ACTIONS(6655),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(6655),
    [sym_auto] = ACTIONS(6655),
    [anon_sym_typename] = ACTIONS(6655),
    [anon_sym_new] = ACTIONS(6655),
    [anon_sym_COLON_COLON] = ACTIONS(6653),
    [anon_sym_delete] = ACTIONS(6655),
    [sym_nullptr] = ACTIONS(6655),
  },
  [3061] = {
    [sym_raw_string_literal] = ACTIONS(6657),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(6659),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(6659),
    [anon_sym_LPAREN] = ACTIONS(6657),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(6659),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(6659),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(6659),
    [sym_preproc_directive] = ACTIONS(6659),
    [anon_sym_SEMI] = ACTIONS(6657),
    [anon_sym_typedef] = ACTIONS(6659),
    [anon_sym_extern] = ACTIONS(6659),
    [anon_sym_LBRACE] = ACTIONS(6657),
    [anon_sym_RBRACE] = ACTIONS(6657),
    [anon_sym_STAR] = ACTIONS(6657),
    [anon_sym_LBRACK] = ACTIONS(6657),
    [anon_sym_static] = ACTIONS(6659),
    [anon_sym_register] = ACTIONS(6659),
    [anon_sym_inline] = ACTIONS(6659),
    [anon_sym_const] = ACTIONS(6659),
    [anon_sym_restrict] = ACTIONS(6659),
    [anon_sym_volatile] = ACTIONS(6659),
    [anon_sym__Atomic] = ACTIONS(6659),
    [anon_sym_mutable] = ACTIONS(6659),
    [anon_sym_explicit] = ACTIONS(6659),
    [anon_sym_constexpr] = ACTIONS(6659),
    [anon_sym_unsigned] = ACTIONS(6659),
    [anon_sym_long] = ACTIONS(6659),
    [anon_sym_short] = ACTIONS(6659),
    [sym_primitive_type] = ACTIONS(6659),
    [anon_sym_enum] = ACTIONS(6659),
    [anon_sym_struct] = ACTIONS(6659),
    [anon_sym_union] = ACTIONS(6659),
    [anon_sym_if] = ACTIONS(6659),
    [anon_sym_else] = ACTIONS(6659),
    [anon_sym_switch] = ACTIONS(6659),
    [anon_sym_case] = ACTIONS(6659),
    [anon_sym_default] = ACTIONS(6659),
    [anon_sym_while] = ACTIONS(6659),
    [anon_sym_do] = ACTIONS(6659),
    [anon_sym_for] = ACTIONS(6659),
    [anon_sym_return] = ACTIONS(6659),
    [anon_sym_break] = ACTIONS(6659),
    [anon_sym_continue] = ACTIONS(6659),
    [anon_sym_goto] = ACTIONS(6659),
    [anon_sym_AMP] = ACTIONS(6657),
    [anon_sym_BANG] = ACTIONS(6657),
    [anon_sym_TILDE] = ACTIONS(6657),
    [anon_sym_PLUS] = ACTIONS(6659),
    [anon_sym_DASH] = ACTIONS(6659),
    [anon_sym_DASH_DASH] = ACTIONS(6657),
    [anon_sym_PLUS_PLUS] = ACTIONS(6657),
    [anon_sym_sizeof] = ACTIONS(6659),
    [sym_number_literal] = ACTIONS(6657),
    [sym_char_literal] = ACTIONS(6657),
    [sym_string_literal] = ACTIONS(6657),
    [sym_true] = ACTIONS(6659),
    [sym_false] = ACTIONS(6659),
    [sym_null] = ACTIONS(6659),
    [sym_identifier] = ACTIONS(6659),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(6659),
    [sym_auto] = ACTIONS(6659),
    [anon_sym_typename] = ACTIONS(6659),
    [anon_sym_new] = ACTIONS(6659),
    [anon_sym_COLON_COLON] = ACTIONS(6657),
    [anon_sym_delete] = ACTIONS(6659),
    [sym_nullptr] = ACTIONS(6659),
  },
  [3062] = {
    [sym_compound_statement] = STATE(3116),
    [sym_labeled_statement] = STATE(3116),
    [sym_expression_statement] = STATE(3116),
    [sym_if_statement] = STATE(3116),
    [sym_switch_statement] = STATE(3116),
    [sym_case_statement] = STATE(3116),
    [sym_while_statement] = STATE(3116),
    [sym_do_statement] = STATE(3116),
    [sym_for_statement] = STATE(3116),
    [sym_return_statement] = STATE(3116),
    [sym_break_statement] = STATE(3116),
    [sym_continue_statement] = STATE(3116),
    [sym_goto_statement] = STATE(3116),
    [sym__expression] = STATE(2378),
    [sym_comma_expression] = STATE(2379),
    [sym_conditional_expression] = STATE(2378),
    [sym_assignment_expression] = STATE(2378),
    [sym_pointer_expression] = STATE(2378),
    [sym_logical_expression] = STATE(2378),
    [sym_bitwise_expression] = STATE(2378),
    [sym_equality_expression] = STATE(2378),
    [sym_relational_expression] = STATE(2378),
    [sym_shift_expression] = STATE(2378),
    [sym_math_expression] = STATE(2378),
    [sym_cast_expression] = STATE(2378),
    [sym_sizeof_expression] = STATE(2378),
    [sym_subscript_expression] = STATE(2378),
    [sym_call_expression] = STATE(2378),
    [sym_field_expression] = STATE(2378),
    [sym_compound_literal_expression] = STATE(2378),
    [sym_parenthesized_expression] = STATE(2378),
    [sym_concatenated_string] = STATE(2378),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(2378),
    [sym_for_range_loop] = STATE(3116),
    [sym_new_expression] = STATE(2378),
    [sym_delete_expression] = STATE(2378),
    [sym_lambda_expression] = STATE(2378),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(5538),
    [anon_sym_LPAREN] = ACTIONS(626),
    [anon_sym_SEMI] = ACTIONS(5540),
    [anon_sym_LBRACE] = ACTIONS(5542),
    [anon_sym_STAR] = ACTIONS(644),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_if] = ACTIONS(5544),
    [anon_sym_switch] = ACTIONS(5546),
    [anon_sym_case] = ACTIONS(5548),
    [anon_sym_default] = ACTIONS(5550),
    [anon_sym_while] = ACTIONS(5552),
    [anon_sym_do] = ACTIONS(5554),
    [anon_sym_for] = ACTIONS(5556),
    [anon_sym_return] = ACTIONS(5558),
    [anon_sym_break] = ACTIONS(5560),
    [anon_sym_continue] = ACTIONS(5562),
    [anon_sym_goto] = ACTIONS(5564),
    [anon_sym_AMP] = ACTIONS(644),
    [anon_sym_BANG] = ACTIONS(668),
    [anon_sym_TILDE] = ACTIONS(670),
    [anon_sym_PLUS] = ACTIONS(672),
    [anon_sym_DASH] = ACTIONS(672),
    [anon_sym_DASH_DASH] = ACTIONS(674),
    [anon_sym_PLUS_PLUS] = ACTIONS(674),
    [anon_sym_sizeof] = ACTIONS(676),
    [sym_number_literal] = ACTIONS(5538),
    [sym_char_literal] = ACTIONS(5538),
    [sym_string_literal] = ACTIONS(678),
    [sym_true] = ACTIONS(5566),
    [sym_false] = ACTIONS(5566),
    [sym_null] = ACTIONS(5566),
    [sym_identifier] = ACTIONS(5568),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1303),
    [anon_sym_delete] = ACTIONS(686),
    [sym_nullptr] = ACTIONS(5566),
  },
  [3063] = {
    [aux_sym_for_statement_repeat1] = STATE(2796),
    [anon_sym_COMMA] = ACTIONS(6339),
    [anon_sym_RPAREN] = ACTIONS(7271),
    [sym_comment] = ACTIONS(49),
  },
  [3064] = {
    [sym_argument_list] = STATE(802),
    [aux_sym_for_statement_repeat1] = STATE(3118),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_COMMA] = ACTIONS(6339),
    [anon_sym_RPAREN] = ACTIONS(7271),
    [anon_sym_STAR] = ACTIONS(2234),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_EQ] = ACTIONS(2236),
    [anon_sym_QMARK] = ACTIONS(2238),
    [anon_sym_STAR_EQ] = ACTIONS(2240),
    [anon_sym_SLASH_EQ] = ACTIONS(2240),
    [anon_sym_PERCENT_EQ] = ACTIONS(2240),
    [anon_sym_PLUS_EQ] = ACTIONS(2240),
    [anon_sym_DASH_EQ] = ACTIONS(2240),
    [anon_sym_LT_LT_EQ] = ACTIONS(2240),
    [anon_sym_GT_GT_EQ] = ACTIONS(2240),
    [anon_sym_AMP_EQ] = ACTIONS(2240),
    [anon_sym_CARET_EQ] = ACTIONS(2240),
    [anon_sym_PIPE_EQ] = ACTIONS(2240),
    [anon_sym_AMP] = ACTIONS(2242),
    [anon_sym_PIPE_PIPE] = ACTIONS(2244),
    [anon_sym_AMP_AMP] = ACTIONS(2246),
    [anon_sym_PIPE] = ACTIONS(2248),
    [anon_sym_CARET] = ACTIONS(2250),
    [anon_sym_EQ_EQ] = ACTIONS(2252),
    [anon_sym_BANG_EQ] = ACTIONS(2252),
    [anon_sym_LT] = ACTIONS(2254),
    [anon_sym_GT] = ACTIONS(2254),
    [anon_sym_LT_EQ] = ACTIONS(2256),
    [anon_sym_GT_EQ] = ACTIONS(2256),
    [anon_sym_LT_LT] = ACTIONS(2258),
    [anon_sym_GT_GT] = ACTIONS(2258),
    [anon_sym_PLUS] = ACTIONS(2260),
    [anon_sym_DASH] = ACTIONS(2260),
    [anon_sym_SLASH] = ACTIONS(2234),
    [anon_sym_PERCENT] = ACTIONS(2234),
    [anon_sym_DASH_DASH] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(1554),
    [anon_sym_DASH_GT] = ACTIONS(1554),
    [sym_comment] = ACTIONS(49),
  },
  [3065] = {
    [sym__expression] = STATE(3119),
    [sym_conditional_expression] = STATE(3119),
    [sym_assignment_expression] = STATE(3119),
    [sym_pointer_expression] = STATE(3119),
    [sym_logical_expression] = STATE(3119),
    [sym_bitwise_expression] = STATE(3119),
    [sym_equality_expression] = STATE(3119),
    [sym_relational_expression] = STATE(3119),
    [sym_shift_expression] = STATE(3119),
    [sym_math_expression] = STATE(3119),
    [sym_cast_expression] = STATE(3119),
    [sym_sizeof_expression] = STATE(3119),
    [sym_subscript_expression] = STATE(3119),
    [sym_call_expression] = STATE(3119),
    [sym_field_expression] = STATE(3119),
    [sym_compound_literal_expression] = STATE(3119),
    [sym_parenthesized_expression] = STATE(3119),
    [sym_concatenated_string] = STATE(3119),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(3119),
    [sym_new_expression] = STATE(3119),
    [sym_delete_expression] = STATE(3119),
    [sym_lambda_expression] = STATE(3119),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(7273),
    [anon_sym_LPAREN] = ACTIONS(1087),
    [anon_sym_RPAREN] = ACTIONS(7271),
    [anon_sym_STAR] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_AMP] = ACTIONS(1089),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1093),
    [anon_sym_PLUS] = ACTIONS(1095),
    [anon_sym_DASH] = ACTIONS(1095),
    [anon_sym_DASH_DASH] = ACTIONS(1097),
    [anon_sym_PLUS_PLUS] = ACTIONS(1097),
    [anon_sym_sizeof] = ACTIONS(1099),
    [sym_number_literal] = ACTIONS(7273),
    [sym_char_literal] = ACTIONS(7273),
    [sym_string_literal] = ACTIONS(1101),
    [sym_true] = ACTIONS(7275),
    [sym_false] = ACTIONS(7275),
    [sym_null] = ACTIONS(7275),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_delete] = ACTIONS(1109),
    [sym_nullptr] = ACTIONS(7275),
  },
  [3066] = {
    [sym_compound_statement] = STATE(3120),
    [sym_labeled_statement] = STATE(3120),
    [sym_expression_statement] = STATE(3120),
    [sym_if_statement] = STATE(3120),
    [sym_switch_statement] = STATE(3120),
    [sym_case_statement] = STATE(3120),
    [sym_while_statement] = STATE(3120),
    [sym_do_statement] = STATE(3120),
    [sym_for_statement] = STATE(3120),
    [sym_return_statement] = STATE(3120),
    [sym_break_statement] = STATE(3120),
    [sym_continue_statement] = STATE(3120),
    [sym_goto_statement] = STATE(3120),
    [sym__expression] = STATE(2378),
    [sym_comma_expression] = STATE(2379),
    [sym_conditional_expression] = STATE(2378),
    [sym_assignment_expression] = STATE(2378),
    [sym_pointer_expression] = STATE(2378),
    [sym_logical_expression] = STATE(2378),
    [sym_bitwise_expression] = STATE(2378),
    [sym_equality_expression] = STATE(2378),
    [sym_relational_expression] = STATE(2378),
    [sym_shift_expression] = STATE(2378),
    [sym_math_expression] = STATE(2378),
    [sym_cast_expression] = STATE(2378),
    [sym_sizeof_expression] = STATE(2378),
    [sym_subscript_expression] = STATE(2378),
    [sym_call_expression] = STATE(2378),
    [sym_field_expression] = STATE(2378),
    [sym_compound_literal_expression] = STATE(2378),
    [sym_parenthesized_expression] = STATE(2378),
    [sym_concatenated_string] = STATE(2378),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(2378),
    [sym_for_range_loop] = STATE(3120),
    [sym_new_expression] = STATE(2378),
    [sym_delete_expression] = STATE(2378),
    [sym_lambda_expression] = STATE(2378),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(5538),
    [anon_sym_LPAREN] = ACTIONS(626),
    [anon_sym_SEMI] = ACTIONS(5540),
    [anon_sym_LBRACE] = ACTIONS(5542),
    [anon_sym_STAR] = ACTIONS(644),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_if] = ACTIONS(5544),
    [anon_sym_switch] = ACTIONS(5546),
    [anon_sym_case] = ACTIONS(5548),
    [anon_sym_default] = ACTIONS(5550),
    [anon_sym_while] = ACTIONS(5552),
    [anon_sym_do] = ACTIONS(5554),
    [anon_sym_for] = ACTIONS(5556),
    [anon_sym_return] = ACTIONS(5558),
    [anon_sym_break] = ACTIONS(5560),
    [anon_sym_continue] = ACTIONS(5562),
    [anon_sym_goto] = ACTIONS(5564),
    [anon_sym_AMP] = ACTIONS(644),
    [anon_sym_BANG] = ACTIONS(668),
    [anon_sym_TILDE] = ACTIONS(670),
    [anon_sym_PLUS] = ACTIONS(672),
    [anon_sym_DASH] = ACTIONS(672),
    [anon_sym_DASH_DASH] = ACTIONS(674),
    [anon_sym_PLUS_PLUS] = ACTIONS(674),
    [anon_sym_sizeof] = ACTIONS(676),
    [sym_number_literal] = ACTIONS(5538),
    [sym_char_literal] = ACTIONS(5538),
    [sym_string_literal] = ACTIONS(678),
    [sym_true] = ACTIONS(5566),
    [sym_false] = ACTIONS(5566),
    [sym_null] = ACTIONS(5566),
    [sym_identifier] = ACTIONS(5568),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1303),
    [anon_sym_delete] = ACTIONS(686),
    [sym_nullptr] = ACTIONS(5566),
  },
  [3067] = {
    [anon_sym_else] = ACTIONS(7277),
    [anon_sym_while] = ACTIONS(6267),
    [sym_comment] = ACTIONS(49),
  },
  [3068] = {
    [sym_compound_statement] = STATE(3122),
    [sym_labeled_statement] = STATE(3122),
    [sym_expression_statement] = STATE(3122),
    [sym_if_statement] = STATE(3122),
    [sym_switch_statement] = STATE(3122),
    [sym_case_statement] = STATE(3122),
    [sym_while_statement] = STATE(3122),
    [sym_do_statement] = STATE(3122),
    [sym_for_statement] = STATE(3122),
    [sym_return_statement] = STATE(3122),
    [sym_break_statement] = STATE(3122),
    [sym_continue_statement] = STATE(3122),
    [sym_goto_statement] = STATE(3122),
    [sym__expression] = STATE(873),
    [sym_comma_expression] = STATE(874),
    [sym_conditional_expression] = STATE(873),
    [sym_assignment_expression] = STATE(873),
    [sym_pointer_expression] = STATE(873),
    [sym_logical_expression] = STATE(873),
    [sym_bitwise_expression] = STATE(873),
    [sym_equality_expression] = STATE(873),
    [sym_relational_expression] = STATE(873),
    [sym_shift_expression] = STATE(873),
    [sym_math_expression] = STATE(873),
    [sym_cast_expression] = STATE(873),
    [sym_sizeof_expression] = STATE(873),
    [sym_subscript_expression] = STATE(873),
    [sym_call_expression] = STATE(873),
    [sym_field_expression] = STATE(873),
    [sym_compound_literal_expression] = STATE(873),
    [sym_parenthesized_expression] = STATE(873),
    [sym_concatenated_string] = STATE(873),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(873),
    [sym_for_range_loop] = STATE(3122),
    [sym_new_expression] = STATE(873),
    [sym_delete_expression] = STATE(873),
    [sym_lambda_expression] = STATE(873),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(1660),
    [anon_sym_LPAREN] = ACTIONS(626),
    [anon_sym_SEMI] = ACTIONS(1662),
    [anon_sym_LBRACE] = ACTIONS(1664),
    [anon_sym_STAR] = ACTIONS(644),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_if] = ACTIONS(6297),
    [anon_sym_switch] = ACTIONS(6299),
    [anon_sym_case] = ACTIONS(6301),
    [anon_sym_default] = ACTIONS(6303),
    [anon_sym_while] = ACTIONS(6305),
    [anon_sym_do] = ACTIONS(1676),
    [anon_sym_for] = ACTIONS(6307),
    [anon_sym_return] = ACTIONS(1680),
    [anon_sym_break] = ACTIONS(1682),
    [anon_sym_continue] = ACTIONS(1684),
    [anon_sym_goto] = ACTIONS(1686),
    [anon_sym_AMP] = ACTIONS(644),
    [anon_sym_BANG] = ACTIONS(668),
    [anon_sym_TILDE] = ACTIONS(670),
    [anon_sym_PLUS] = ACTIONS(672),
    [anon_sym_DASH] = ACTIONS(672),
    [anon_sym_DASH_DASH] = ACTIONS(674),
    [anon_sym_PLUS_PLUS] = ACTIONS(674),
    [anon_sym_sizeof] = ACTIONS(676),
    [sym_number_literal] = ACTIONS(1660),
    [sym_char_literal] = ACTIONS(1660),
    [sym_string_literal] = ACTIONS(678),
    [sym_true] = ACTIONS(1688),
    [sym_false] = ACTIONS(1688),
    [sym_null] = ACTIONS(1688),
    [sym_identifier] = ACTIONS(6309),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1303),
    [anon_sym_delete] = ACTIONS(686),
    [sym_nullptr] = ACTIONS(1688),
  },
  [3069] = {
    [sym_compound_statement] = STATE(2787),
    [sym_labeled_statement] = STATE(2787),
    [sym_expression_statement] = STATE(2787),
    [sym_if_statement] = STATE(2787),
    [sym_switch_statement] = STATE(2787),
    [sym_case_statement] = STATE(2787),
    [sym_while_statement] = STATE(2787),
    [sym_do_statement] = STATE(2787),
    [sym_for_statement] = STATE(2787),
    [sym_return_statement] = STATE(2787),
    [sym_break_statement] = STATE(2787),
    [sym_continue_statement] = STATE(2787),
    [sym_goto_statement] = STATE(2787),
    [sym__expression] = STATE(873),
    [sym_comma_expression] = STATE(874),
    [sym_conditional_expression] = STATE(873),
    [sym_assignment_expression] = STATE(873),
    [sym_pointer_expression] = STATE(873),
    [sym_logical_expression] = STATE(873),
    [sym_bitwise_expression] = STATE(873),
    [sym_equality_expression] = STATE(873),
    [sym_relational_expression] = STATE(873),
    [sym_shift_expression] = STATE(873),
    [sym_math_expression] = STATE(873),
    [sym_cast_expression] = STATE(873),
    [sym_sizeof_expression] = STATE(873),
    [sym_subscript_expression] = STATE(873),
    [sym_call_expression] = STATE(873),
    [sym_field_expression] = STATE(873),
    [sym_compound_literal_expression] = STATE(873),
    [sym_parenthesized_expression] = STATE(873),
    [sym_concatenated_string] = STATE(873),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(873),
    [sym_for_range_loop] = STATE(2787),
    [sym_new_expression] = STATE(873),
    [sym_delete_expression] = STATE(873),
    [sym_lambda_expression] = STATE(873),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(1660),
    [anon_sym_LPAREN] = ACTIONS(626),
    [anon_sym_SEMI] = ACTIONS(1662),
    [anon_sym_LBRACE] = ACTIONS(1664),
    [anon_sym_STAR] = ACTIONS(644),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_if] = ACTIONS(6297),
    [anon_sym_switch] = ACTIONS(6299),
    [anon_sym_case] = ACTIONS(6301),
    [anon_sym_default] = ACTIONS(6303),
    [anon_sym_while] = ACTIONS(6305),
    [anon_sym_do] = ACTIONS(1676),
    [anon_sym_for] = ACTIONS(6307),
    [anon_sym_return] = ACTIONS(1680),
    [anon_sym_break] = ACTIONS(1682),
    [anon_sym_continue] = ACTIONS(1684),
    [anon_sym_goto] = ACTIONS(1686),
    [anon_sym_AMP] = ACTIONS(644),
    [anon_sym_BANG] = ACTIONS(668),
    [anon_sym_TILDE] = ACTIONS(670),
    [anon_sym_PLUS] = ACTIONS(672),
    [anon_sym_DASH] = ACTIONS(672),
    [anon_sym_DASH_DASH] = ACTIONS(674),
    [anon_sym_PLUS_PLUS] = ACTIONS(674),
    [anon_sym_sizeof] = ACTIONS(676),
    [sym_number_literal] = ACTIONS(1660),
    [sym_char_literal] = ACTIONS(1660),
    [sym_string_literal] = ACTIONS(678),
    [sym_true] = ACTIONS(1688),
    [sym_false] = ACTIONS(1688),
    [sym_null] = ACTIONS(1688),
    [sym_identifier] = ACTIONS(6309),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1303),
    [anon_sym_delete] = ACTIONS(686),
    [sym_nullptr] = ACTIONS(1688),
  },
  [3070] = {
    [sym_argument_list] = STATE(802),
    [aux_sym_for_statement_repeat1] = STATE(3124),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_COMMA] = ACTIONS(6339),
    [anon_sym_RPAREN] = ACTIONS(7279),
    [anon_sym_STAR] = ACTIONS(2234),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_EQ] = ACTIONS(2236),
    [anon_sym_QMARK] = ACTIONS(2238),
    [anon_sym_STAR_EQ] = ACTIONS(2240),
    [anon_sym_SLASH_EQ] = ACTIONS(2240),
    [anon_sym_PERCENT_EQ] = ACTIONS(2240),
    [anon_sym_PLUS_EQ] = ACTIONS(2240),
    [anon_sym_DASH_EQ] = ACTIONS(2240),
    [anon_sym_LT_LT_EQ] = ACTIONS(2240),
    [anon_sym_GT_GT_EQ] = ACTIONS(2240),
    [anon_sym_AMP_EQ] = ACTIONS(2240),
    [anon_sym_CARET_EQ] = ACTIONS(2240),
    [anon_sym_PIPE_EQ] = ACTIONS(2240),
    [anon_sym_AMP] = ACTIONS(2242),
    [anon_sym_PIPE_PIPE] = ACTIONS(2244),
    [anon_sym_AMP_AMP] = ACTIONS(2246),
    [anon_sym_PIPE] = ACTIONS(2248),
    [anon_sym_CARET] = ACTIONS(2250),
    [anon_sym_EQ_EQ] = ACTIONS(2252),
    [anon_sym_BANG_EQ] = ACTIONS(2252),
    [anon_sym_LT] = ACTIONS(2254),
    [anon_sym_GT] = ACTIONS(2254),
    [anon_sym_LT_EQ] = ACTIONS(2256),
    [anon_sym_GT_EQ] = ACTIONS(2256),
    [anon_sym_LT_LT] = ACTIONS(2258),
    [anon_sym_GT_GT] = ACTIONS(2258),
    [anon_sym_PLUS] = ACTIONS(2260),
    [anon_sym_DASH] = ACTIONS(2260),
    [anon_sym_SLASH] = ACTIONS(2234),
    [anon_sym_PERCENT] = ACTIONS(2234),
    [anon_sym_DASH_DASH] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(1554),
    [anon_sym_DASH_GT] = ACTIONS(1554),
    [sym_comment] = ACTIONS(49),
  },
  [3071] = {
    [sym__expression] = STATE(3125),
    [sym_conditional_expression] = STATE(3125),
    [sym_assignment_expression] = STATE(3125),
    [sym_pointer_expression] = STATE(3125),
    [sym_logical_expression] = STATE(3125),
    [sym_bitwise_expression] = STATE(3125),
    [sym_equality_expression] = STATE(3125),
    [sym_relational_expression] = STATE(3125),
    [sym_shift_expression] = STATE(3125),
    [sym_math_expression] = STATE(3125),
    [sym_cast_expression] = STATE(3125),
    [sym_sizeof_expression] = STATE(3125),
    [sym_subscript_expression] = STATE(3125),
    [sym_call_expression] = STATE(3125),
    [sym_field_expression] = STATE(3125),
    [sym_compound_literal_expression] = STATE(3125),
    [sym_parenthesized_expression] = STATE(3125),
    [sym_concatenated_string] = STATE(3125),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(3125),
    [sym_new_expression] = STATE(3125),
    [sym_delete_expression] = STATE(3125),
    [sym_lambda_expression] = STATE(3125),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(7281),
    [anon_sym_LPAREN] = ACTIONS(1087),
    [anon_sym_RPAREN] = ACTIONS(7279),
    [anon_sym_STAR] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_AMP] = ACTIONS(1089),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1093),
    [anon_sym_PLUS] = ACTIONS(1095),
    [anon_sym_DASH] = ACTIONS(1095),
    [anon_sym_DASH_DASH] = ACTIONS(1097),
    [anon_sym_PLUS_PLUS] = ACTIONS(1097),
    [anon_sym_sizeof] = ACTIONS(1099),
    [sym_number_literal] = ACTIONS(7281),
    [sym_char_literal] = ACTIONS(7281),
    [sym_string_literal] = ACTIONS(1101),
    [sym_true] = ACTIONS(7283),
    [sym_false] = ACTIONS(7283),
    [sym_null] = ACTIONS(7283),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_delete] = ACTIONS(1109),
    [sym_nullptr] = ACTIONS(7283),
  },
  [3072] = {
    [sym_argument_list] = STATE(802),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_SEMI] = ACTIONS(7285),
    [anon_sym_STAR] = ACTIONS(2553),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_EQ] = ACTIONS(2555),
    [anon_sym_QMARK] = ACTIONS(2557),
    [anon_sym_STAR_EQ] = ACTIONS(2559),
    [anon_sym_SLASH_EQ] = ACTIONS(2559),
    [anon_sym_PERCENT_EQ] = ACTIONS(2559),
    [anon_sym_PLUS_EQ] = ACTIONS(2559),
    [anon_sym_DASH_EQ] = ACTIONS(2559),
    [anon_sym_LT_LT_EQ] = ACTIONS(2559),
    [anon_sym_GT_GT_EQ] = ACTIONS(2559),
    [anon_sym_AMP_EQ] = ACTIONS(2559),
    [anon_sym_CARET_EQ] = ACTIONS(2559),
    [anon_sym_PIPE_EQ] = ACTIONS(2559),
    [anon_sym_AMP] = ACTIONS(2561),
    [anon_sym_PIPE_PIPE] = ACTIONS(2563),
    [anon_sym_AMP_AMP] = ACTIONS(2565),
    [anon_sym_PIPE] = ACTIONS(2567),
    [anon_sym_CARET] = ACTIONS(2569),
    [anon_sym_EQ_EQ] = ACTIONS(2571),
    [anon_sym_BANG_EQ] = ACTIONS(2571),
    [anon_sym_LT] = ACTIONS(2573),
    [anon_sym_GT] = ACTIONS(2573),
    [anon_sym_LT_EQ] = ACTIONS(2575),
    [anon_sym_GT_EQ] = ACTIONS(2575),
    [anon_sym_LT_LT] = ACTIONS(2577),
    [anon_sym_GT_GT] = ACTIONS(2577),
    [anon_sym_PLUS] = ACTIONS(2579),
    [anon_sym_DASH] = ACTIONS(2579),
    [anon_sym_SLASH] = ACTIONS(2553),
    [anon_sym_PERCENT] = ACTIONS(2553),
    [anon_sym_DASH_DASH] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(1554),
    [anon_sym_DASH_GT] = ACTIONS(1554),
    [sym_comment] = ACTIONS(49),
  },
  [3073] = {
    [sym_argument_list] = STATE(802),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_RPAREN] = ACTIONS(7287),
    [anon_sym_STAR] = ACTIONS(4537),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_EQ] = ACTIONS(4539),
    [anon_sym_QMARK] = ACTIONS(4541),
    [anon_sym_STAR_EQ] = ACTIONS(4543),
    [anon_sym_SLASH_EQ] = ACTIONS(4543),
    [anon_sym_PERCENT_EQ] = ACTIONS(4543),
    [anon_sym_PLUS_EQ] = ACTIONS(4543),
    [anon_sym_DASH_EQ] = ACTIONS(4543),
    [anon_sym_LT_LT_EQ] = ACTIONS(4543),
    [anon_sym_GT_GT_EQ] = ACTIONS(4543),
    [anon_sym_AMP_EQ] = ACTIONS(4543),
    [anon_sym_CARET_EQ] = ACTIONS(4543),
    [anon_sym_PIPE_EQ] = ACTIONS(4543),
    [anon_sym_AMP] = ACTIONS(4545),
    [anon_sym_PIPE_PIPE] = ACTIONS(4547),
    [anon_sym_AMP_AMP] = ACTIONS(4549),
    [anon_sym_PIPE] = ACTIONS(4551),
    [anon_sym_CARET] = ACTIONS(4553),
    [anon_sym_EQ_EQ] = ACTIONS(4555),
    [anon_sym_BANG_EQ] = ACTIONS(4555),
    [anon_sym_LT] = ACTIONS(4557),
    [anon_sym_GT] = ACTIONS(4557),
    [anon_sym_LT_EQ] = ACTIONS(4559),
    [anon_sym_GT_EQ] = ACTIONS(4559),
    [anon_sym_LT_LT] = ACTIONS(4561),
    [anon_sym_GT_GT] = ACTIONS(4561),
    [anon_sym_PLUS] = ACTIONS(4563),
    [anon_sym_DASH] = ACTIONS(4563),
    [anon_sym_SLASH] = ACTIONS(4537),
    [anon_sym_PERCENT] = ACTIONS(4537),
    [anon_sym_DASH_DASH] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(1554),
    [anon_sym_DASH_GT] = ACTIONS(1554),
    [sym_comment] = ACTIONS(49),
  },
  [3074] = {
    [anon_sym_else] = ACTIONS(7202),
    [anon_sym_while] = ACTIONS(7202),
    [sym_comment] = ACTIONS(49),
  },
  [3075] = {
    [sym_compound_statement] = STATE(3128),
    [sym_labeled_statement] = STATE(3128),
    [sym_expression_statement] = STATE(3128),
    [sym_if_statement] = STATE(3128),
    [sym_switch_statement] = STATE(3128),
    [sym_case_statement] = STATE(3128),
    [sym_while_statement] = STATE(3128),
    [sym_do_statement] = STATE(3128),
    [sym_for_statement] = STATE(3128),
    [sym_return_statement] = STATE(3128),
    [sym_break_statement] = STATE(3128),
    [sym_continue_statement] = STATE(3128),
    [sym_goto_statement] = STATE(3128),
    [sym__expression] = STATE(873),
    [sym_comma_expression] = STATE(874),
    [sym_conditional_expression] = STATE(873),
    [sym_assignment_expression] = STATE(873),
    [sym_pointer_expression] = STATE(873),
    [sym_logical_expression] = STATE(873),
    [sym_bitwise_expression] = STATE(873),
    [sym_equality_expression] = STATE(873),
    [sym_relational_expression] = STATE(873),
    [sym_shift_expression] = STATE(873),
    [sym_math_expression] = STATE(873),
    [sym_cast_expression] = STATE(873),
    [sym_sizeof_expression] = STATE(873),
    [sym_subscript_expression] = STATE(873),
    [sym_call_expression] = STATE(873),
    [sym_field_expression] = STATE(873),
    [sym_compound_literal_expression] = STATE(873),
    [sym_parenthesized_expression] = STATE(873),
    [sym_concatenated_string] = STATE(873),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(873),
    [sym_for_range_loop] = STATE(3128),
    [sym_new_expression] = STATE(873),
    [sym_delete_expression] = STATE(873),
    [sym_lambda_expression] = STATE(873),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(1660),
    [anon_sym_LPAREN] = ACTIONS(626),
    [anon_sym_SEMI] = ACTIONS(1662),
    [anon_sym_LBRACE] = ACTIONS(1664),
    [anon_sym_STAR] = ACTIONS(644),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_if] = ACTIONS(1666),
    [anon_sym_switch] = ACTIONS(1668),
    [anon_sym_case] = ACTIONS(1670),
    [anon_sym_default] = ACTIONS(1672),
    [anon_sym_while] = ACTIONS(1674),
    [anon_sym_do] = ACTIONS(1676),
    [anon_sym_for] = ACTIONS(1678),
    [anon_sym_return] = ACTIONS(1680),
    [anon_sym_break] = ACTIONS(1682),
    [anon_sym_continue] = ACTIONS(1684),
    [anon_sym_goto] = ACTIONS(1686),
    [anon_sym_AMP] = ACTIONS(644),
    [anon_sym_BANG] = ACTIONS(668),
    [anon_sym_TILDE] = ACTIONS(670),
    [anon_sym_PLUS] = ACTIONS(672),
    [anon_sym_DASH] = ACTIONS(672),
    [anon_sym_DASH_DASH] = ACTIONS(674),
    [anon_sym_PLUS_PLUS] = ACTIONS(674),
    [anon_sym_sizeof] = ACTIONS(676),
    [sym_number_literal] = ACTIONS(1660),
    [sym_char_literal] = ACTIONS(1660),
    [sym_string_literal] = ACTIONS(678),
    [sym_true] = ACTIONS(1688),
    [sym_false] = ACTIONS(1688),
    [sym_null] = ACTIONS(1688),
    [sym_identifier] = ACTIONS(1690),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1303),
    [anon_sym_delete] = ACTIONS(686),
    [sym_nullptr] = ACTIONS(1688),
  },
  [3076] = {
    [sym_type_qualifier] = STATE(3077),
    [sym_trailing_return_type] = STATE(2168),
    [aux_sym_abstract_function_declarator_repeat1] = STATE(3077),
    [anon_sym_LPAREN] = ACTIONS(4998),
    [anon_sym_COMMA] = ACTIONS(4998),
    [anon_sym_SEMI] = ACTIONS(4998),
    [anon_sym_LBRACE] = ACTIONS(4998),
    [anon_sym_LBRACK] = ACTIONS(4998),
    [anon_sym_EQ] = ACTIONS(4998),
    [anon_sym_const] = ACTIONS(612),
    [anon_sym_restrict] = ACTIONS(614),
    [anon_sym_volatile] = ACTIONS(614),
    [anon_sym__Atomic] = ACTIONS(614),
    [anon_sym_mutable] = ACTIONS(614),
    [anon_sym_explicit] = ACTIONS(614),
    [anon_sym_constexpr] = ACTIONS(614),
    [anon_sym_COLON] = ACTIONS(4998),
    [anon_sym_DASH_GT] = ACTIONS(6347),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(7206),
  },
  [3077] = {
    [sym_type_qualifier] = STATE(3077),
    [aux_sym_abstract_function_declarator_repeat1] = STATE(3077),
    [anon_sym_LPAREN] = ACTIONS(5002),
    [anon_sym_COMMA] = ACTIONS(5002),
    [anon_sym_SEMI] = ACTIONS(5002),
    [anon_sym_LBRACE] = ACTIONS(5002),
    [anon_sym_LBRACK] = ACTIONS(5002),
    [anon_sym_EQ] = ACTIONS(5002),
    [anon_sym_const] = ACTIONS(5004),
    [anon_sym_restrict] = ACTIONS(5007),
    [anon_sym_volatile] = ACTIONS(5007),
    [anon_sym__Atomic] = ACTIONS(5007),
    [anon_sym_mutable] = ACTIONS(5007),
    [anon_sym_explicit] = ACTIONS(5007),
    [anon_sym_constexpr] = ACTIONS(5007),
    [anon_sym_COLON] = ACTIONS(5002),
    [anon_sym_DASH_GT] = ACTIONS(5002),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(7289),
  },
  [3078] = {
    [sym_raw_string_literal] = ACTIONS(7292),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(7294),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(7294),
    [anon_sym_LPAREN] = ACTIONS(7292),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(7294),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(7294),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(7294),
    [sym_preproc_directive] = ACTIONS(7294),
    [anon_sym_SEMI] = ACTIONS(7292),
    [anon_sym_typedef] = ACTIONS(7294),
    [anon_sym_extern] = ACTIONS(7294),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [anon_sym_RBRACE] = ACTIONS(7292),
    [anon_sym_STAR] = ACTIONS(7292),
    [anon_sym_LBRACK] = ACTIONS(7292),
    [anon_sym_static] = ACTIONS(7294),
    [anon_sym_register] = ACTIONS(7294),
    [anon_sym_inline] = ACTIONS(7294),
    [anon_sym_const] = ACTIONS(7294),
    [anon_sym_restrict] = ACTIONS(7294),
    [anon_sym_volatile] = ACTIONS(7294),
    [anon_sym__Atomic] = ACTIONS(7294),
    [anon_sym_mutable] = ACTIONS(7294),
    [anon_sym_explicit] = ACTIONS(7294),
    [anon_sym_constexpr] = ACTIONS(7294),
    [anon_sym_unsigned] = ACTIONS(7294),
    [anon_sym_long] = ACTIONS(7294),
    [anon_sym_short] = ACTIONS(7294),
    [sym_primitive_type] = ACTIONS(7294),
    [anon_sym_enum] = ACTIONS(7294),
    [anon_sym_struct] = ACTIONS(7294),
    [anon_sym_union] = ACTIONS(7294),
    [anon_sym_if] = ACTIONS(7294),
    [anon_sym_switch] = ACTIONS(7294),
    [anon_sym_case] = ACTIONS(7294),
    [anon_sym_default] = ACTIONS(7294),
    [anon_sym_while] = ACTIONS(7294),
    [anon_sym_do] = ACTIONS(7294),
    [anon_sym_for] = ACTIONS(7294),
    [anon_sym_return] = ACTIONS(7294),
    [anon_sym_break] = ACTIONS(7294),
    [anon_sym_continue] = ACTIONS(7294),
    [anon_sym_goto] = ACTIONS(7294),
    [anon_sym_AMP] = ACTIONS(7292),
    [anon_sym_BANG] = ACTIONS(7292),
    [anon_sym_TILDE] = ACTIONS(7292),
    [anon_sym_PLUS] = ACTIONS(7294),
    [anon_sym_DASH] = ACTIONS(7294),
    [anon_sym_DASH_DASH] = ACTIONS(7292),
    [anon_sym_PLUS_PLUS] = ACTIONS(7292),
    [anon_sym_sizeof] = ACTIONS(7294),
    [sym_number_literal] = ACTIONS(7292),
    [sym_char_literal] = ACTIONS(7292),
    [sym_string_literal] = ACTIONS(7292),
    [sym_true] = ACTIONS(7294),
    [sym_false] = ACTIONS(7294),
    [sym_null] = ACTIONS(7294),
    [sym_identifier] = ACTIONS(7294),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(7294),
    [sym_auto] = ACTIONS(7294),
    [anon_sym_typename] = ACTIONS(7294),
    [anon_sym_new] = ACTIONS(7294),
    [anon_sym_COLON_COLON] = ACTIONS(7292),
    [anon_sym_delete] = ACTIONS(7294),
    [sym_nullptr] = ACTIONS(7294),
  },
  [3079] = {
    [sym_compound_statement] = STATE(3129),
    [sym_labeled_statement] = STATE(3129),
    [sym_expression_statement] = STATE(3129),
    [sym_if_statement] = STATE(3129),
    [sym_switch_statement] = STATE(3129),
    [sym_case_statement] = STATE(3129),
    [sym_while_statement] = STATE(3129),
    [sym_do_statement] = STATE(3129),
    [sym_for_statement] = STATE(3129),
    [sym_return_statement] = STATE(3129),
    [sym_break_statement] = STATE(3129),
    [sym_continue_statement] = STATE(3129),
    [sym_goto_statement] = STATE(3129),
    [sym__expression] = STATE(2844),
    [sym_comma_expression] = STATE(2845),
    [sym_conditional_expression] = STATE(2844),
    [sym_assignment_expression] = STATE(2844),
    [sym_pointer_expression] = STATE(2844),
    [sym_logical_expression] = STATE(2844),
    [sym_bitwise_expression] = STATE(2844),
    [sym_equality_expression] = STATE(2844),
    [sym_relational_expression] = STATE(2844),
    [sym_shift_expression] = STATE(2844),
    [sym_math_expression] = STATE(2844),
    [sym_cast_expression] = STATE(2844),
    [sym_sizeof_expression] = STATE(2844),
    [sym_subscript_expression] = STATE(2844),
    [sym_call_expression] = STATE(2844),
    [sym_field_expression] = STATE(2844),
    [sym_compound_literal_expression] = STATE(2844),
    [sym_parenthesized_expression] = STATE(2844),
    [sym_concatenated_string] = STATE(2844),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(2844),
    [sym_for_range_loop] = STATE(3129),
    [sym_new_expression] = STATE(2844),
    [sym_delete_expression] = STATE(2844),
    [sym_lambda_expression] = STATE(2844),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(6732),
    [anon_sym_LPAREN] = ACTIONS(626),
    [anon_sym_SEMI] = ACTIONS(6734),
    [anon_sym_LBRACE] = ACTIONS(6736),
    [anon_sym_STAR] = ACTIONS(644),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_if] = ACTIONS(6738),
    [anon_sym_switch] = ACTIONS(6740),
    [anon_sym_case] = ACTIONS(6742),
    [anon_sym_default] = ACTIONS(6744),
    [anon_sym_while] = ACTIONS(6746),
    [anon_sym_do] = ACTIONS(6748),
    [anon_sym_for] = ACTIONS(6750),
    [anon_sym_return] = ACTIONS(6752),
    [anon_sym_break] = ACTIONS(6754),
    [anon_sym_continue] = ACTIONS(6756),
    [anon_sym_goto] = ACTIONS(6758),
    [anon_sym_AMP] = ACTIONS(644),
    [anon_sym_BANG] = ACTIONS(668),
    [anon_sym_TILDE] = ACTIONS(670),
    [anon_sym_PLUS] = ACTIONS(672),
    [anon_sym_DASH] = ACTIONS(672),
    [anon_sym_DASH_DASH] = ACTIONS(674),
    [anon_sym_PLUS_PLUS] = ACTIONS(674),
    [anon_sym_sizeof] = ACTIONS(676),
    [sym_number_literal] = ACTIONS(6732),
    [sym_char_literal] = ACTIONS(6732),
    [sym_string_literal] = ACTIONS(678),
    [sym_true] = ACTIONS(6760),
    [sym_false] = ACTIONS(6760),
    [sym_null] = ACTIONS(6760),
    [sym_identifier] = ACTIONS(6762),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1303),
    [anon_sym_delete] = ACTIONS(686),
    [sym_nullptr] = ACTIONS(6760),
  },
  [3080] = {
    [sym_argument_list] = STATE(802),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_RPAREN] = ACTIONS(7296),
    [anon_sym_STAR] = ACTIONS(4537),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_EQ] = ACTIONS(4539),
    [anon_sym_QMARK] = ACTIONS(4541),
    [anon_sym_STAR_EQ] = ACTIONS(4543),
    [anon_sym_SLASH_EQ] = ACTIONS(4543),
    [anon_sym_PERCENT_EQ] = ACTIONS(4543),
    [anon_sym_PLUS_EQ] = ACTIONS(4543),
    [anon_sym_DASH_EQ] = ACTIONS(4543),
    [anon_sym_LT_LT_EQ] = ACTIONS(4543),
    [anon_sym_GT_GT_EQ] = ACTIONS(4543),
    [anon_sym_AMP_EQ] = ACTIONS(4543),
    [anon_sym_CARET_EQ] = ACTIONS(4543),
    [anon_sym_PIPE_EQ] = ACTIONS(4543),
    [anon_sym_AMP] = ACTIONS(4545),
    [anon_sym_PIPE_PIPE] = ACTIONS(4547),
    [anon_sym_AMP_AMP] = ACTIONS(4549),
    [anon_sym_PIPE] = ACTIONS(4551),
    [anon_sym_CARET] = ACTIONS(4553),
    [anon_sym_EQ_EQ] = ACTIONS(4555),
    [anon_sym_BANG_EQ] = ACTIONS(4555),
    [anon_sym_LT] = ACTIONS(4557),
    [anon_sym_GT] = ACTIONS(4557),
    [anon_sym_LT_EQ] = ACTIONS(4559),
    [anon_sym_GT_EQ] = ACTIONS(4559),
    [anon_sym_LT_LT] = ACTIONS(4561),
    [anon_sym_GT_GT] = ACTIONS(4561),
    [anon_sym_PLUS] = ACTIONS(4563),
    [anon_sym_DASH] = ACTIONS(4563),
    [anon_sym_SLASH] = ACTIONS(4537),
    [anon_sym_PERCENT] = ACTIONS(4537),
    [anon_sym_DASH_DASH] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(1554),
    [anon_sym_DASH_GT] = ACTIONS(1554),
    [sym_comment] = ACTIONS(49),
  },
  [3081] = {
    [sym_compound_statement] = STATE(3131),
    [sym_labeled_statement] = STATE(3131),
    [sym_expression_statement] = STATE(3131),
    [sym_if_statement] = STATE(3131),
    [sym_switch_statement] = STATE(3131),
    [sym_case_statement] = STATE(3131),
    [sym_while_statement] = STATE(3131),
    [sym_do_statement] = STATE(3131),
    [sym_for_statement] = STATE(3131),
    [sym_return_statement] = STATE(3131),
    [sym_break_statement] = STATE(3131),
    [sym_continue_statement] = STATE(3131),
    [sym_goto_statement] = STATE(3131),
    [sym__expression] = STATE(2844),
    [sym_comma_expression] = STATE(2845),
    [sym_conditional_expression] = STATE(2844),
    [sym_assignment_expression] = STATE(2844),
    [sym_pointer_expression] = STATE(2844),
    [sym_logical_expression] = STATE(2844),
    [sym_bitwise_expression] = STATE(2844),
    [sym_equality_expression] = STATE(2844),
    [sym_relational_expression] = STATE(2844),
    [sym_shift_expression] = STATE(2844),
    [sym_math_expression] = STATE(2844),
    [sym_cast_expression] = STATE(2844),
    [sym_sizeof_expression] = STATE(2844),
    [sym_subscript_expression] = STATE(2844),
    [sym_call_expression] = STATE(2844),
    [sym_field_expression] = STATE(2844),
    [sym_compound_literal_expression] = STATE(2844),
    [sym_parenthesized_expression] = STATE(2844),
    [sym_concatenated_string] = STATE(2844),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(2844),
    [sym_for_range_loop] = STATE(3131),
    [sym_new_expression] = STATE(2844),
    [sym_delete_expression] = STATE(2844),
    [sym_lambda_expression] = STATE(2844),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(6732),
    [anon_sym_LPAREN] = ACTIONS(626),
    [anon_sym_SEMI] = ACTIONS(6734),
    [anon_sym_LBRACE] = ACTIONS(6736),
    [anon_sym_STAR] = ACTIONS(644),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_if] = ACTIONS(6738),
    [anon_sym_switch] = ACTIONS(6740),
    [anon_sym_case] = ACTIONS(6742),
    [anon_sym_default] = ACTIONS(6744),
    [anon_sym_while] = ACTIONS(6746),
    [anon_sym_do] = ACTIONS(6748),
    [anon_sym_for] = ACTIONS(6750),
    [anon_sym_return] = ACTIONS(6752),
    [anon_sym_break] = ACTIONS(6754),
    [anon_sym_continue] = ACTIONS(6756),
    [anon_sym_goto] = ACTIONS(6758),
    [anon_sym_AMP] = ACTIONS(644),
    [anon_sym_BANG] = ACTIONS(668),
    [anon_sym_TILDE] = ACTIONS(670),
    [anon_sym_PLUS] = ACTIONS(672),
    [anon_sym_DASH] = ACTIONS(672),
    [anon_sym_DASH_DASH] = ACTIONS(674),
    [anon_sym_PLUS_PLUS] = ACTIONS(674),
    [anon_sym_sizeof] = ACTIONS(676),
    [sym_number_literal] = ACTIONS(6732),
    [sym_char_literal] = ACTIONS(6732),
    [sym_string_literal] = ACTIONS(678),
    [sym_true] = ACTIONS(6760),
    [sym_false] = ACTIONS(6760),
    [sym_null] = ACTIONS(6760),
    [sym_identifier] = ACTIONS(6762),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1303),
    [anon_sym_delete] = ACTIONS(686),
    [sym_nullptr] = ACTIONS(6760),
  },
  [3082] = {
    [sym_raw_string_literal] = ACTIONS(5631),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(5633),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(5633),
    [anon_sym_LPAREN] = ACTIONS(5631),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(5633),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(5633),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(5633),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(5633),
    [sym_preproc_directive] = ACTIONS(5633),
    [anon_sym_SEMI] = ACTIONS(5631),
    [anon_sym_typedef] = ACTIONS(5633),
    [anon_sym_extern] = ACTIONS(5633),
    [anon_sym_LBRACE] = ACTIONS(5631),
    [anon_sym_STAR] = ACTIONS(5631),
    [anon_sym_LBRACK] = ACTIONS(5631),
    [anon_sym_static] = ACTIONS(5633),
    [anon_sym_register] = ACTIONS(5633),
    [anon_sym_inline] = ACTIONS(5633),
    [anon_sym_const] = ACTIONS(5633),
    [anon_sym_restrict] = ACTIONS(5633),
    [anon_sym_volatile] = ACTIONS(5633),
    [anon_sym__Atomic] = ACTIONS(5633),
    [anon_sym_mutable] = ACTIONS(5633),
    [anon_sym_explicit] = ACTIONS(5633),
    [anon_sym_constexpr] = ACTIONS(5633),
    [anon_sym_unsigned] = ACTIONS(5633),
    [anon_sym_long] = ACTIONS(5633),
    [anon_sym_short] = ACTIONS(5633),
    [sym_primitive_type] = ACTIONS(5633),
    [anon_sym_enum] = ACTIONS(5633),
    [anon_sym_struct] = ACTIONS(5633),
    [anon_sym_union] = ACTIONS(5633),
    [anon_sym_if] = ACTIONS(5633),
    [anon_sym_else] = ACTIONS(5633),
    [anon_sym_switch] = ACTIONS(5633),
    [anon_sym_case] = ACTIONS(5633),
    [anon_sym_default] = ACTIONS(5633),
    [anon_sym_while] = ACTIONS(5633),
    [anon_sym_do] = ACTIONS(5633),
    [anon_sym_for] = ACTIONS(5633),
    [anon_sym_return] = ACTIONS(5633),
    [anon_sym_break] = ACTIONS(5633),
    [anon_sym_continue] = ACTIONS(5633),
    [anon_sym_goto] = ACTIONS(5633),
    [anon_sym_AMP] = ACTIONS(5631),
    [anon_sym_BANG] = ACTIONS(5631),
    [anon_sym_TILDE] = ACTIONS(5631),
    [anon_sym_PLUS] = ACTIONS(5633),
    [anon_sym_DASH] = ACTIONS(5633),
    [anon_sym_DASH_DASH] = ACTIONS(5631),
    [anon_sym_PLUS_PLUS] = ACTIONS(5631),
    [anon_sym_sizeof] = ACTIONS(5633),
    [sym_number_literal] = ACTIONS(5631),
    [sym_char_literal] = ACTIONS(5631),
    [sym_string_literal] = ACTIONS(5631),
    [sym_true] = ACTIONS(5633),
    [sym_false] = ACTIONS(5633),
    [sym_null] = ACTIONS(5633),
    [sym_identifier] = ACTIONS(5633),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(5633),
    [sym_auto] = ACTIONS(5633),
    [anon_sym_typename] = ACTIONS(5633),
    [anon_sym_new] = ACTIONS(5633),
    [anon_sym_COLON_COLON] = ACTIONS(5631),
    [anon_sym_delete] = ACTIONS(5633),
    [sym_nullptr] = ACTIONS(5633),
  },
  [3083] = {
    [sym__type_declarator] = STATE(3132),
    [sym_pointer_type_declarator] = STATE(213),
    [sym_function_type_declarator] = STATE(214),
    [sym_array_type_declarator] = STATE(215),
    [anon_sym_LPAREN] = ACTIONS(327),
    [anon_sym_STAR] = ACTIONS(329),
    [sym_identifier] = ACTIONS(331),
    [sym_comment] = ACTIONS(49),
  },
  [3084] = {
    [sym_type_qualifier] = STATE(219),
    [sym__type_specifier] = STATE(3133),
    [sym_sized_type_specifier] = STATE(3133),
    [sym_enum_specifier] = STATE(3133),
    [sym_struct_specifier] = STATE(3133),
    [sym_union_specifier] = STATE(3133),
    [sym_macro_type_specifier] = STATE(3133),
    [sym_class_specifier] = STATE(3133),
    [sym_dependent_type] = STATE(3133),
    [sym_template_type] = STATE(62),
    [sym_scoped_type_identifier] = STATE(63),
    [sym_scoped_namespace_identifier] = STATE(64),
    [aux_sym_type_definition_repeat1] = STATE(219),
    [aux_sym_sized_type_specifier_repeat1] = STATE(66),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_restrict] = ACTIONS(93),
    [anon_sym_volatile] = ACTIONS(93),
    [anon_sym__Atomic] = ACTIONS(93),
    [anon_sym_mutable] = ACTIONS(93),
    [anon_sym_explicit] = ACTIONS(93),
    [anon_sym_constexpr] = ACTIONS(93),
    [anon_sym_unsigned] = ACTIONS(95),
    [anon_sym_long] = ACTIONS(95),
    [anon_sym_short] = ACTIONS(95),
    [sym_primitive_type] = ACTIONS(7298),
    [anon_sym_enum] = ACTIONS(99),
    [anon_sym_struct] = ACTIONS(101),
    [anon_sym_union] = ACTIONS(103),
    [sym_identifier] = ACTIONS(105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(107),
    [sym_auto] = ACTIONS(7298),
    [anon_sym_typename] = ACTIONS(109),
    [anon_sym_COLON_COLON] = ACTIONS(111),
  },
  [3085] = {
    [sym_parameter_list] = STATE(332),
    [sym_argument_list] = STATE(333),
    [sym_initializer_list] = STATE(333),
    [aux_sym_declaration_repeat1] = STATE(3135),
    [anon_sym_LPAREN] = ACTIONS(536),
    [anon_sym_COMMA] = ACTIONS(538),
    [anon_sym_SEMI] = ACTIONS(7300),
    [anon_sym_LBRACE] = ACTIONS(548),
    [anon_sym_LBRACK] = ACTIONS(208),
    [anon_sym_EQ] = ACTIONS(544),
    [sym_comment] = ACTIONS(49),
  },
  [3086] = {
    [aux_sym_declaration_repeat1] = STATE(3135),
    [anon_sym_COMMA] = ACTIONS(538),
    [anon_sym_SEMI] = ACTIONS(7300),
    [sym_comment] = ACTIONS(49),
  },
  [3087] = {
    [sym_compound_statement] = STATE(3136),
    [sym_labeled_statement] = STATE(3136),
    [sym_expression_statement] = STATE(3136),
    [sym_if_statement] = STATE(3136),
    [sym_switch_statement] = STATE(3136),
    [sym_case_statement] = STATE(3136),
    [sym_while_statement] = STATE(3136),
    [sym_do_statement] = STATE(3136),
    [sym_for_statement] = STATE(3136),
    [sym_return_statement] = STATE(3136),
    [sym_break_statement] = STATE(3136),
    [sym_continue_statement] = STATE(3136),
    [sym_goto_statement] = STATE(3136),
    [sym__expression] = STATE(2844),
    [sym_comma_expression] = STATE(2845),
    [sym_conditional_expression] = STATE(2844),
    [sym_assignment_expression] = STATE(2844),
    [sym_pointer_expression] = STATE(2844),
    [sym_logical_expression] = STATE(2844),
    [sym_bitwise_expression] = STATE(2844),
    [sym_equality_expression] = STATE(2844),
    [sym_relational_expression] = STATE(2844),
    [sym_shift_expression] = STATE(2844),
    [sym_math_expression] = STATE(2844),
    [sym_cast_expression] = STATE(2844),
    [sym_sizeof_expression] = STATE(2844),
    [sym_subscript_expression] = STATE(2844),
    [sym_call_expression] = STATE(2844),
    [sym_field_expression] = STATE(2844),
    [sym_compound_literal_expression] = STATE(2844),
    [sym_parenthesized_expression] = STATE(2844),
    [sym_concatenated_string] = STATE(2844),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(2844),
    [sym_for_range_loop] = STATE(3136),
    [sym_new_expression] = STATE(2844),
    [sym_delete_expression] = STATE(2844),
    [sym_lambda_expression] = STATE(2844),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(6732),
    [anon_sym_LPAREN] = ACTIONS(626),
    [anon_sym_SEMI] = ACTIONS(6734),
    [anon_sym_LBRACE] = ACTIONS(6736),
    [anon_sym_STAR] = ACTIONS(644),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_if] = ACTIONS(6738),
    [anon_sym_switch] = ACTIONS(6740),
    [anon_sym_case] = ACTIONS(6742),
    [anon_sym_default] = ACTIONS(6744),
    [anon_sym_while] = ACTIONS(6746),
    [anon_sym_do] = ACTIONS(6748),
    [anon_sym_for] = ACTIONS(6750),
    [anon_sym_return] = ACTIONS(6752),
    [anon_sym_break] = ACTIONS(6754),
    [anon_sym_continue] = ACTIONS(6756),
    [anon_sym_goto] = ACTIONS(6758),
    [anon_sym_AMP] = ACTIONS(644),
    [anon_sym_BANG] = ACTIONS(668),
    [anon_sym_TILDE] = ACTIONS(670),
    [anon_sym_PLUS] = ACTIONS(672),
    [anon_sym_DASH] = ACTIONS(672),
    [anon_sym_DASH_DASH] = ACTIONS(674),
    [anon_sym_PLUS_PLUS] = ACTIONS(674),
    [anon_sym_sizeof] = ACTIONS(676),
    [sym_number_literal] = ACTIONS(6732),
    [sym_char_literal] = ACTIONS(6732),
    [sym_string_literal] = ACTIONS(678),
    [sym_true] = ACTIONS(6760),
    [sym_false] = ACTIONS(6760),
    [sym_null] = ACTIONS(6760),
    [sym_identifier] = ACTIONS(6762),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1303),
    [anon_sym_delete] = ACTIONS(686),
    [sym_nullptr] = ACTIONS(6760),
  },
  [3088] = {
    [sym__expression] = STATE(3137),
    [sym_conditional_expression] = STATE(3137),
    [sym_assignment_expression] = STATE(3137),
    [sym_pointer_expression] = STATE(3137),
    [sym_logical_expression] = STATE(3137),
    [sym_bitwise_expression] = STATE(3137),
    [sym_equality_expression] = STATE(3137),
    [sym_relational_expression] = STATE(3137),
    [sym_shift_expression] = STATE(3137),
    [sym_math_expression] = STATE(3137),
    [sym_cast_expression] = STATE(3137),
    [sym_sizeof_expression] = STATE(3137),
    [sym_subscript_expression] = STATE(3137),
    [sym_call_expression] = STATE(3137),
    [sym_field_expression] = STATE(3137),
    [sym_compound_literal_expression] = STATE(3137),
    [sym_parenthesized_expression] = STATE(3137),
    [sym_concatenated_string] = STATE(3137),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(3137),
    [sym_new_expression] = STATE(3137),
    [sym_delete_expression] = STATE(3137),
    [sym_lambda_expression] = STATE(3137),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(7302),
    [anon_sym_LPAREN] = ACTIONS(2943),
    [anon_sym_STAR] = ACTIONS(2945),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_AMP] = ACTIONS(2945),
    [anon_sym_BANG] = ACTIONS(2947),
    [anon_sym_TILDE] = ACTIONS(2949),
    [anon_sym_PLUS] = ACTIONS(2951),
    [anon_sym_DASH] = ACTIONS(2951),
    [anon_sym_DASH_DASH] = ACTIONS(2953),
    [anon_sym_PLUS_PLUS] = ACTIONS(2953),
    [anon_sym_sizeof] = ACTIONS(2955),
    [sym_number_literal] = ACTIONS(7302),
    [sym_char_literal] = ACTIONS(7302),
    [sym_string_literal] = ACTIONS(2957),
    [sym_true] = ACTIONS(7304),
    [sym_false] = ACTIONS(7304),
    [sym_null] = ACTIONS(7304),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(2961),
    [anon_sym_delete] = ACTIONS(2963),
    [sym_nullptr] = ACTIONS(7304),
  },
  [3089] = {
    [sym__expression] = STATE(3139),
    [sym_conditional_expression] = STATE(3139),
    [sym_assignment_expression] = STATE(3139),
    [sym_pointer_expression] = STATE(3139),
    [sym_logical_expression] = STATE(3139),
    [sym_bitwise_expression] = STATE(3139),
    [sym_equality_expression] = STATE(3139),
    [sym_relational_expression] = STATE(3139),
    [sym_shift_expression] = STATE(3139),
    [sym_math_expression] = STATE(3139),
    [sym_cast_expression] = STATE(3139),
    [sym_sizeof_expression] = STATE(3139),
    [sym_subscript_expression] = STATE(3139),
    [sym_call_expression] = STATE(3139),
    [sym_field_expression] = STATE(3139),
    [sym_compound_literal_expression] = STATE(3139),
    [sym_parenthesized_expression] = STATE(3139),
    [sym_concatenated_string] = STATE(3139),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(3139),
    [sym_new_expression] = STATE(3139),
    [sym_delete_expression] = STATE(3139),
    [sym_lambda_expression] = STATE(3139),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(7306),
    [anon_sym_LPAREN] = ACTIONS(1087),
    [anon_sym_RPAREN] = ACTIONS(7308),
    [anon_sym_STAR] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_AMP] = ACTIONS(1089),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1093),
    [anon_sym_PLUS] = ACTIONS(1095),
    [anon_sym_DASH] = ACTIONS(1095),
    [anon_sym_DASH_DASH] = ACTIONS(1097),
    [anon_sym_PLUS_PLUS] = ACTIONS(1097),
    [anon_sym_sizeof] = ACTIONS(1099),
    [sym_number_literal] = ACTIONS(7306),
    [sym_char_literal] = ACTIONS(7306),
    [sym_string_literal] = ACTIONS(1101),
    [sym_true] = ACTIONS(7310),
    [sym_false] = ACTIONS(7310),
    [sym_null] = ACTIONS(7310),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_delete] = ACTIONS(1109),
    [sym_nullptr] = ACTIONS(7310),
  },
  [3090] = {
    [sym_argument_list] = STATE(802),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_SEMI] = ACTIONS(7312),
    [anon_sym_STAR] = ACTIONS(2553),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_EQ] = ACTIONS(2555),
    [anon_sym_QMARK] = ACTIONS(2557),
    [anon_sym_STAR_EQ] = ACTIONS(2559),
    [anon_sym_SLASH_EQ] = ACTIONS(2559),
    [anon_sym_PERCENT_EQ] = ACTIONS(2559),
    [anon_sym_PLUS_EQ] = ACTIONS(2559),
    [anon_sym_DASH_EQ] = ACTIONS(2559),
    [anon_sym_LT_LT_EQ] = ACTIONS(2559),
    [anon_sym_GT_GT_EQ] = ACTIONS(2559),
    [anon_sym_AMP_EQ] = ACTIONS(2559),
    [anon_sym_CARET_EQ] = ACTIONS(2559),
    [anon_sym_PIPE_EQ] = ACTIONS(2559),
    [anon_sym_AMP] = ACTIONS(2561),
    [anon_sym_PIPE_PIPE] = ACTIONS(2563),
    [anon_sym_AMP_AMP] = ACTIONS(2565),
    [anon_sym_PIPE] = ACTIONS(2567),
    [anon_sym_CARET] = ACTIONS(2569),
    [anon_sym_EQ_EQ] = ACTIONS(2571),
    [anon_sym_BANG_EQ] = ACTIONS(2571),
    [anon_sym_LT] = ACTIONS(2573),
    [anon_sym_GT] = ACTIONS(2573),
    [anon_sym_LT_EQ] = ACTIONS(2575),
    [anon_sym_GT_EQ] = ACTIONS(2575),
    [anon_sym_LT_LT] = ACTIONS(2577),
    [anon_sym_GT_GT] = ACTIONS(2577),
    [anon_sym_PLUS] = ACTIONS(2579),
    [anon_sym_DASH] = ACTIONS(2579),
    [anon_sym_SLASH] = ACTIONS(2553),
    [anon_sym_PERCENT] = ACTIONS(2553),
    [anon_sym_DASH_DASH] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(1554),
    [anon_sym_DASH_GT] = ACTIONS(1554),
    [sym_comment] = ACTIONS(49),
  },
  [3091] = {
    [sym__expression] = STATE(3141),
    [sym_conditional_expression] = STATE(3141),
    [sym_assignment_expression] = STATE(3141),
    [sym_pointer_expression] = STATE(3141),
    [sym_logical_expression] = STATE(3141),
    [sym_bitwise_expression] = STATE(3141),
    [sym_equality_expression] = STATE(3141),
    [sym_relational_expression] = STATE(3141),
    [sym_shift_expression] = STATE(3141),
    [sym_math_expression] = STATE(3141),
    [sym_cast_expression] = STATE(3141),
    [sym_sizeof_expression] = STATE(3141),
    [sym_subscript_expression] = STATE(3141),
    [sym_call_expression] = STATE(3141),
    [sym_field_expression] = STATE(3141),
    [sym_compound_literal_expression] = STATE(3141),
    [sym_parenthesized_expression] = STATE(3141),
    [sym_concatenated_string] = STATE(3141),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(3141),
    [sym_new_expression] = STATE(3141),
    [sym_delete_expression] = STATE(3141),
    [sym_lambda_expression] = STATE(3141),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(7314),
    [anon_sym_LPAREN] = ACTIONS(1347),
    [anon_sym_SEMI] = ACTIONS(7312),
    [anon_sym_STAR] = ACTIONS(1349),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_AMP] = ACTIONS(1349),
    [anon_sym_BANG] = ACTIONS(1351),
    [anon_sym_TILDE] = ACTIONS(1353),
    [anon_sym_PLUS] = ACTIONS(1355),
    [anon_sym_DASH] = ACTIONS(1355),
    [anon_sym_DASH_DASH] = ACTIONS(1357),
    [anon_sym_PLUS_PLUS] = ACTIONS(1357),
    [anon_sym_sizeof] = ACTIONS(1359),
    [sym_number_literal] = ACTIONS(7314),
    [sym_char_literal] = ACTIONS(7314),
    [sym_string_literal] = ACTIONS(1361),
    [sym_true] = ACTIONS(7316),
    [sym_false] = ACTIONS(7316),
    [sym_null] = ACTIONS(7316),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1365),
    [anon_sym_delete] = ACTIONS(1367),
    [sym_nullptr] = ACTIONS(7316),
  },
  [3092] = {
    [sym__expression] = STATE(3142),
    [sym_conditional_expression] = STATE(3142),
    [sym_assignment_expression] = STATE(3142),
    [sym_pointer_expression] = STATE(3142),
    [sym_logical_expression] = STATE(3142),
    [sym_bitwise_expression] = STATE(3142),
    [sym_equality_expression] = STATE(3142),
    [sym_relational_expression] = STATE(3142),
    [sym_shift_expression] = STATE(3142),
    [sym_math_expression] = STATE(3142),
    [sym_cast_expression] = STATE(3142),
    [sym_sizeof_expression] = STATE(3142),
    [sym_subscript_expression] = STATE(3142),
    [sym_call_expression] = STATE(3142),
    [sym_field_expression] = STATE(3142),
    [sym_compound_literal_expression] = STATE(3142),
    [sym_parenthesized_expression] = STATE(3142),
    [sym_concatenated_string] = STATE(3142),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(3142),
    [sym_new_expression] = STATE(3142),
    [sym_delete_expression] = STATE(3142),
    [sym_lambda_expression] = STATE(3142),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(7318),
    [anon_sym_LPAREN] = ACTIONS(2943),
    [anon_sym_STAR] = ACTIONS(2945),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_AMP] = ACTIONS(2945),
    [anon_sym_BANG] = ACTIONS(2947),
    [anon_sym_TILDE] = ACTIONS(2949),
    [anon_sym_PLUS] = ACTIONS(2951),
    [anon_sym_DASH] = ACTIONS(2951),
    [anon_sym_DASH_DASH] = ACTIONS(2953),
    [anon_sym_PLUS_PLUS] = ACTIONS(2953),
    [anon_sym_sizeof] = ACTIONS(2955),
    [sym_number_literal] = ACTIONS(7318),
    [sym_char_literal] = ACTIONS(7318),
    [sym_string_literal] = ACTIONS(2957),
    [sym_true] = ACTIONS(7320),
    [sym_false] = ACTIONS(7320),
    [sym_null] = ACTIONS(7320),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(2961),
    [anon_sym_delete] = ACTIONS(2963),
    [sym_nullptr] = ACTIONS(7320),
  },
  [3093] = {
    [sym_raw_string_literal] = ACTIONS(7057),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(7059),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(7059),
    [anon_sym_LPAREN] = ACTIONS(7057),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(7059),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(7059),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(7059),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(7059),
    [sym_preproc_directive] = ACTIONS(7059),
    [anon_sym_SEMI] = ACTIONS(7057),
    [anon_sym_typedef] = ACTIONS(7059),
    [anon_sym_extern] = ACTIONS(7059),
    [anon_sym_LBRACE] = ACTIONS(7057),
    [anon_sym_STAR] = ACTIONS(7057),
    [anon_sym_LBRACK] = ACTIONS(7057),
    [anon_sym_static] = ACTIONS(7059),
    [anon_sym_register] = ACTIONS(7059),
    [anon_sym_inline] = ACTIONS(7059),
    [anon_sym_const] = ACTIONS(7059),
    [anon_sym_restrict] = ACTIONS(7059),
    [anon_sym_volatile] = ACTIONS(7059),
    [anon_sym__Atomic] = ACTIONS(7059),
    [anon_sym_mutable] = ACTIONS(7059),
    [anon_sym_explicit] = ACTIONS(7059),
    [anon_sym_constexpr] = ACTIONS(7059),
    [anon_sym_unsigned] = ACTIONS(7059),
    [anon_sym_long] = ACTIONS(7059),
    [anon_sym_short] = ACTIONS(7059),
    [sym_primitive_type] = ACTIONS(7059),
    [anon_sym_enum] = ACTIONS(7059),
    [anon_sym_struct] = ACTIONS(7059),
    [anon_sym_union] = ACTIONS(7059),
    [anon_sym_if] = ACTIONS(7059),
    [anon_sym_switch] = ACTIONS(7059),
    [anon_sym_case] = ACTIONS(7059),
    [anon_sym_default] = ACTIONS(7059),
    [anon_sym_while] = ACTIONS(7059),
    [anon_sym_do] = ACTIONS(7059),
    [anon_sym_for] = ACTIONS(7059),
    [anon_sym_return] = ACTIONS(7059),
    [anon_sym_break] = ACTIONS(7059),
    [anon_sym_continue] = ACTIONS(7059),
    [anon_sym_goto] = ACTIONS(7059),
    [anon_sym_AMP] = ACTIONS(7057),
    [anon_sym_BANG] = ACTIONS(7057),
    [anon_sym_TILDE] = ACTIONS(7057),
    [anon_sym_PLUS] = ACTIONS(7059),
    [anon_sym_DASH] = ACTIONS(7059),
    [anon_sym_DASH_DASH] = ACTIONS(7057),
    [anon_sym_PLUS_PLUS] = ACTIONS(7057),
    [anon_sym_sizeof] = ACTIONS(7059),
    [sym_number_literal] = ACTIONS(7057),
    [sym_char_literal] = ACTIONS(7057),
    [sym_string_literal] = ACTIONS(7057),
    [sym_true] = ACTIONS(7059),
    [sym_false] = ACTIONS(7059),
    [sym_null] = ACTIONS(7059),
    [sym_identifier] = ACTIONS(7059),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(7059),
    [sym_auto] = ACTIONS(7059),
    [anon_sym_typename] = ACTIONS(7059),
    [anon_sym_new] = ACTIONS(7059),
    [anon_sym_COLON_COLON] = ACTIONS(7057),
    [anon_sym_delete] = ACTIONS(7059),
    [sym_nullptr] = ACTIONS(7059),
  },
  [3094] = {
    [sym_raw_string_literal] = ACTIONS(7083),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(7085),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(7085),
    [anon_sym_LPAREN] = ACTIONS(7083),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(7085),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(7085),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(7085),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(7085),
    [sym_preproc_directive] = ACTIONS(7085),
    [anon_sym_SEMI] = ACTIONS(7083),
    [anon_sym_typedef] = ACTIONS(7085),
    [anon_sym_extern] = ACTIONS(7085),
    [anon_sym_LBRACE] = ACTIONS(7083),
    [anon_sym_STAR] = ACTIONS(7083),
    [anon_sym_LBRACK] = ACTIONS(7083),
    [anon_sym_static] = ACTIONS(7085),
    [anon_sym_register] = ACTIONS(7085),
    [anon_sym_inline] = ACTIONS(7085),
    [anon_sym_const] = ACTIONS(7085),
    [anon_sym_restrict] = ACTIONS(7085),
    [anon_sym_volatile] = ACTIONS(7085),
    [anon_sym__Atomic] = ACTIONS(7085),
    [anon_sym_mutable] = ACTIONS(7085),
    [anon_sym_explicit] = ACTIONS(7085),
    [anon_sym_constexpr] = ACTIONS(7085),
    [anon_sym_unsigned] = ACTIONS(7085),
    [anon_sym_long] = ACTIONS(7085),
    [anon_sym_short] = ACTIONS(7085),
    [sym_primitive_type] = ACTIONS(7085),
    [anon_sym_enum] = ACTIONS(7085),
    [anon_sym_struct] = ACTIONS(7085),
    [anon_sym_union] = ACTIONS(7085),
    [anon_sym_if] = ACTIONS(7085),
    [anon_sym_switch] = ACTIONS(7085),
    [anon_sym_case] = ACTIONS(7085),
    [anon_sym_default] = ACTIONS(7085),
    [anon_sym_while] = ACTIONS(7085),
    [anon_sym_do] = ACTIONS(7085),
    [anon_sym_for] = ACTIONS(7085),
    [anon_sym_return] = ACTIONS(7085),
    [anon_sym_break] = ACTIONS(7085),
    [anon_sym_continue] = ACTIONS(7085),
    [anon_sym_goto] = ACTIONS(7085),
    [anon_sym_AMP] = ACTIONS(7083),
    [anon_sym_BANG] = ACTIONS(7083),
    [anon_sym_TILDE] = ACTIONS(7083),
    [anon_sym_PLUS] = ACTIONS(7085),
    [anon_sym_DASH] = ACTIONS(7085),
    [anon_sym_DASH_DASH] = ACTIONS(7083),
    [anon_sym_PLUS_PLUS] = ACTIONS(7083),
    [anon_sym_sizeof] = ACTIONS(7085),
    [sym_number_literal] = ACTIONS(7083),
    [sym_char_literal] = ACTIONS(7083),
    [sym_string_literal] = ACTIONS(7083),
    [sym_true] = ACTIONS(7085),
    [sym_false] = ACTIONS(7085),
    [sym_null] = ACTIONS(7085),
    [sym_identifier] = ACTIONS(7085),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(7085),
    [sym_auto] = ACTIONS(7085),
    [anon_sym_typename] = ACTIONS(7085),
    [anon_sym_new] = ACTIONS(7085),
    [anon_sym_COLON_COLON] = ACTIONS(7083),
    [anon_sym_delete] = ACTIONS(7085),
    [sym_nullptr] = ACTIONS(7085),
  },
  [3095] = {
    [sym_compound_statement] = STATE(3143),
    [sym_labeled_statement] = STATE(3143),
    [sym_expression_statement] = STATE(3143),
    [sym_if_statement] = STATE(3143),
    [sym_switch_statement] = STATE(3143),
    [sym_case_statement] = STATE(3143),
    [sym_while_statement] = STATE(3143),
    [sym_do_statement] = STATE(3143),
    [sym_for_statement] = STATE(3143),
    [sym_return_statement] = STATE(3143),
    [sym_break_statement] = STATE(3143),
    [sym_continue_statement] = STATE(3143),
    [sym_goto_statement] = STATE(3143),
    [sym__expression] = STATE(1947),
    [sym_comma_expression] = STATE(1948),
    [sym_conditional_expression] = STATE(1947),
    [sym_assignment_expression] = STATE(1947),
    [sym_pointer_expression] = STATE(1947),
    [sym_logical_expression] = STATE(1947),
    [sym_bitwise_expression] = STATE(1947),
    [sym_equality_expression] = STATE(1947),
    [sym_relational_expression] = STATE(1947),
    [sym_shift_expression] = STATE(1947),
    [sym_math_expression] = STATE(1947),
    [sym_cast_expression] = STATE(1947),
    [sym_sizeof_expression] = STATE(1947),
    [sym_subscript_expression] = STATE(1947),
    [sym_call_expression] = STATE(1947),
    [sym_field_expression] = STATE(1947),
    [sym_compound_literal_expression] = STATE(1947),
    [sym_parenthesized_expression] = STATE(1947),
    [sym_concatenated_string] = STATE(1947),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(1947),
    [sym_for_range_loop] = STATE(3143),
    [sym_new_expression] = STATE(1947),
    [sym_delete_expression] = STATE(1947),
    [sym_lambda_expression] = STATE(1947),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(4395),
    [anon_sym_LPAREN] = ACTIONS(626),
    [anon_sym_SEMI] = ACTIONS(4411),
    [anon_sym_LBRACE] = ACTIONS(4415),
    [anon_sym_STAR] = ACTIONS(644),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_if] = ACTIONS(4417),
    [anon_sym_switch] = ACTIONS(4419),
    [anon_sym_case] = ACTIONS(4421),
    [anon_sym_default] = ACTIONS(4423),
    [anon_sym_while] = ACTIONS(4425),
    [anon_sym_do] = ACTIONS(4427),
    [anon_sym_for] = ACTIONS(4429),
    [anon_sym_return] = ACTIONS(4431),
    [anon_sym_break] = ACTIONS(4433),
    [anon_sym_continue] = ACTIONS(4435),
    [anon_sym_goto] = ACTIONS(4437),
    [anon_sym_AMP] = ACTIONS(644),
    [anon_sym_BANG] = ACTIONS(668),
    [anon_sym_TILDE] = ACTIONS(670),
    [anon_sym_PLUS] = ACTIONS(672),
    [anon_sym_DASH] = ACTIONS(672),
    [anon_sym_DASH_DASH] = ACTIONS(674),
    [anon_sym_PLUS_PLUS] = ACTIONS(674),
    [anon_sym_sizeof] = ACTIONS(676),
    [sym_number_literal] = ACTIONS(4395),
    [sym_char_literal] = ACTIONS(4395),
    [sym_string_literal] = ACTIONS(678),
    [sym_true] = ACTIONS(4439),
    [sym_false] = ACTIONS(4439),
    [sym_null] = ACTIONS(4439),
    [sym_identifier] = ACTIONS(6077),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1303),
    [anon_sym_delete] = ACTIONS(686),
    [sym_nullptr] = ACTIONS(4439),
  },
  [3096] = {
    [aux_sym_for_statement_repeat1] = STATE(2796),
    [anon_sym_COMMA] = ACTIONS(6339),
    [anon_sym_RPAREN] = ACTIONS(7322),
    [sym_comment] = ACTIONS(49),
  },
  [3097] = {
    [sym_raw_string_literal] = ACTIONS(6267),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(6269),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(6269),
    [anon_sym_LPAREN] = ACTIONS(6267),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(6269),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(6269),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(6269),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(6269),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(6269),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(6269),
    [sym_preproc_directive] = ACTIONS(6269),
    [anon_sym_SEMI] = ACTIONS(6267),
    [anon_sym_typedef] = ACTIONS(6269),
    [anon_sym_extern] = ACTIONS(6269),
    [anon_sym_LBRACE] = ACTIONS(6267),
    [anon_sym_STAR] = ACTIONS(6267),
    [anon_sym_LBRACK] = ACTIONS(6267),
    [anon_sym_static] = ACTIONS(6269),
    [anon_sym_register] = ACTIONS(6269),
    [anon_sym_inline] = ACTIONS(6269),
    [anon_sym_const] = ACTIONS(6269),
    [anon_sym_restrict] = ACTIONS(6269),
    [anon_sym_volatile] = ACTIONS(6269),
    [anon_sym__Atomic] = ACTIONS(6269),
    [anon_sym_mutable] = ACTIONS(6269),
    [anon_sym_explicit] = ACTIONS(6269),
    [anon_sym_constexpr] = ACTIONS(6269),
    [anon_sym_unsigned] = ACTIONS(6269),
    [anon_sym_long] = ACTIONS(6269),
    [anon_sym_short] = ACTIONS(6269),
    [sym_primitive_type] = ACTIONS(6269),
    [anon_sym_enum] = ACTIONS(6269),
    [anon_sym_struct] = ACTIONS(6269),
    [anon_sym_union] = ACTIONS(6269),
    [anon_sym_if] = ACTIONS(6269),
    [anon_sym_else] = ACTIONS(7324),
    [anon_sym_switch] = ACTIONS(6269),
    [anon_sym_case] = ACTIONS(6269),
    [anon_sym_default] = ACTIONS(6269),
    [anon_sym_while] = ACTIONS(6269),
    [anon_sym_do] = ACTIONS(6269),
    [anon_sym_for] = ACTIONS(6269),
    [anon_sym_return] = ACTIONS(6269),
    [anon_sym_break] = ACTIONS(6269),
    [anon_sym_continue] = ACTIONS(6269),
    [anon_sym_goto] = ACTIONS(6269),
    [anon_sym_AMP] = ACTIONS(6267),
    [anon_sym_BANG] = ACTIONS(6267),
    [anon_sym_TILDE] = ACTIONS(6267),
    [anon_sym_PLUS] = ACTIONS(6269),
    [anon_sym_DASH] = ACTIONS(6269),
    [anon_sym_DASH_DASH] = ACTIONS(6267),
    [anon_sym_PLUS_PLUS] = ACTIONS(6267),
    [anon_sym_sizeof] = ACTIONS(6269),
    [sym_number_literal] = ACTIONS(6267),
    [sym_char_literal] = ACTIONS(6267),
    [sym_string_literal] = ACTIONS(6267),
    [sym_true] = ACTIONS(6269),
    [sym_false] = ACTIONS(6269),
    [sym_null] = ACTIONS(6269),
    [sym_identifier] = ACTIONS(6269),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(6269),
    [sym_auto] = ACTIONS(6269),
    [anon_sym_typename] = ACTIONS(6269),
    [anon_sym_new] = ACTIONS(6269),
    [anon_sym_COLON_COLON] = ACTIONS(6267),
    [anon_sym_delete] = ACTIONS(6269),
    [sym_nullptr] = ACTIONS(6269),
  },
  [3098] = {
    [sym_compound_statement] = STATE(3146),
    [sym_labeled_statement] = STATE(3146),
    [sym_expression_statement] = STATE(3146),
    [sym_if_statement] = STATE(3146),
    [sym_switch_statement] = STATE(3146),
    [sym_case_statement] = STATE(3146),
    [sym_while_statement] = STATE(3146),
    [sym_do_statement] = STATE(3146),
    [sym_for_statement] = STATE(3146),
    [sym_return_statement] = STATE(3146),
    [sym_break_statement] = STATE(3146),
    [sym_continue_statement] = STATE(3146),
    [sym_goto_statement] = STATE(3146),
    [sym__expression] = STATE(2739),
    [sym_comma_expression] = STATE(2740),
    [sym_conditional_expression] = STATE(2739),
    [sym_assignment_expression] = STATE(2739),
    [sym_pointer_expression] = STATE(2739),
    [sym_logical_expression] = STATE(2739),
    [sym_bitwise_expression] = STATE(2739),
    [sym_equality_expression] = STATE(2739),
    [sym_relational_expression] = STATE(2739),
    [sym_shift_expression] = STATE(2739),
    [sym_math_expression] = STATE(2739),
    [sym_cast_expression] = STATE(2739),
    [sym_sizeof_expression] = STATE(2739),
    [sym_subscript_expression] = STATE(2739),
    [sym_call_expression] = STATE(2739),
    [sym_field_expression] = STATE(2739),
    [sym_compound_literal_expression] = STATE(2739),
    [sym_parenthesized_expression] = STATE(2739),
    [sym_concatenated_string] = STATE(2739),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(2739),
    [sym_for_range_loop] = STATE(3146),
    [sym_new_expression] = STATE(2739),
    [sym_delete_expression] = STATE(2739),
    [sym_lambda_expression] = STATE(2739),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(6507),
    [anon_sym_LPAREN] = ACTIONS(626),
    [anon_sym_SEMI] = ACTIONS(6509),
    [anon_sym_LBRACE] = ACTIONS(6511),
    [anon_sym_STAR] = ACTIONS(644),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_if] = ACTIONS(6513),
    [anon_sym_switch] = ACTIONS(6515),
    [anon_sym_case] = ACTIONS(6517),
    [anon_sym_default] = ACTIONS(6519),
    [anon_sym_while] = ACTIONS(6521),
    [anon_sym_do] = ACTIONS(6523),
    [anon_sym_for] = ACTIONS(6525),
    [anon_sym_return] = ACTIONS(6527),
    [anon_sym_break] = ACTIONS(6529),
    [anon_sym_continue] = ACTIONS(6531),
    [anon_sym_goto] = ACTIONS(6533),
    [anon_sym_AMP] = ACTIONS(644),
    [anon_sym_BANG] = ACTIONS(668),
    [anon_sym_TILDE] = ACTIONS(670),
    [anon_sym_PLUS] = ACTIONS(672),
    [anon_sym_DASH] = ACTIONS(672),
    [anon_sym_DASH_DASH] = ACTIONS(674),
    [anon_sym_PLUS_PLUS] = ACTIONS(674),
    [anon_sym_sizeof] = ACTIONS(676),
    [sym_number_literal] = ACTIONS(6507),
    [sym_char_literal] = ACTIONS(6507),
    [sym_string_literal] = ACTIONS(678),
    [sym_true] = ACTIONS(6535),
    [sym_false] = ACTIONS(6535),
    [sym_null] = ACTIONS(6535),
    [sym_identifier] = ACTIONS(6537),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1303),
    [anon_sym_delete] = ACTIONS(686),
    [sym_nullptr] = ACTIONS(6535),
  },
  [3099] = {
    [sym_raw_string_literal] = ACTIONS(6277),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(6279),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(6279),
    [anon_sym_LPAREN] = ACTIONS(6277),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(6279),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(6279),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(6279),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(6279),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(6279),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(6279),
    [sym_preproc_directive] = ACTIONS(6279),
    [anon_sym_SEMI] = ACTIONS(6277),
    [anon_sym_typedef] = ACTIONS(6279),
    [anon_sym_extern] = ACTIONS(6279),
    [anon_sym_LBRACE] = ACTIONS(6277),
    [anon_sym_STAR] = ACTIONS(6277),
    [anon_sym_LBRACK] = ACTIONS(6277),
    [anon_sym_static] = ACTIONS(6279),
    [anon_sym_register] = ACTIONS(6279),
    [anon_sym_inline] = ACTIONS(6279),
    [anon_sym_const] = ACTIONS(6279),
    [anon_sym_restrict] = ACTIONS(6279),
    [anon_sym_volatile] = ACTIONS(6279),
    [anon_sym__Atomic] = ACTIONS(6279),
    [anon_sym_mutable] = ACTIONS(6279),
    [anon_sym_explicit] = ACTIONS(6279),
    [anon_sym_constexpr] = ACTIONS(6279),
    [anon_sym_unsigned] = ACTIONS(6279),
    [anon_sym_long] = ACTIONS(6279),
    [anon_sym_short] = ACTIONS(6279),
    [sym_primitive_type] = ACTIONS(6279),
    [anon_sym_enum] = ACTIONS(6279),
    [anon_sym_struct] = ACTIONS(6279),
    [anon_sym_union] = ACTIONS(6279),
    [anon_sym_if] = ACTIONS(6279),
    [anon_sym_else] = ACTIONS(6279),
    [anon_sym_switch] = ACTIONS(6279),
    [anon_sym_case] = ACTIONS(6279),
    [anon_sym_default] = ACTIONS(6279),
    [anon_sym_while] = ACTIONS(6279),
    [anon_sym_do] = ACTIONS(6279),
    [anon_sym_for] = ACTIONS(6279),
    [anon_sym_return] = ACTIONS(6279),
    [anon_sym_break] = ACTIONS(6279),
    [anon_sym_continue] = ACTIONS(6279),
    [anon_sym_goto] = ACTIONS(6279),
    [anon_sym_AMP] = ACTIONS(6277),
    [anon_sym_BANG] = ACTIONS(6277),
    [anon_sym_TILDE] = ACTIONS(6277),
    [anon_sym_PLUS] = ACTIONS(6279),
    [anon_sym_DASH] = ACTIONS(6279),
    [anon_sym_DASH_DASH] = ACTIONS(6277),
    [anon_sym_PLUS_PLUS] = ACTIONS(6277),
    [anon_sym_sizeof] = ACTIONS(6279),
    [sym_number_literal] = ACTIONS(6277),
    [sym_char_literal] = ACTIONS(6277),
    [sym_string_literal] = ACTIONS(6277),
    [sym_true] = ACTIONS(6279),
    [sym_false] = ACTIONS(6279),
    [sym_null] = ACTIONS(6279),
    [sym_identifier] = ACTIONS(6279),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(6279),
    [sym_auto] = ACTIONS(6279),
    [anon_sym_typename] = ACTIONS(6279),
    [anon_sym_new] = ACTIONS(6279),
    [anon_sym_COLON_COLON] = ACTIONS(6277),
    [anon_sym_delete] = ACTIONS(6279),
    [sym_nullptr] = ACTIONS(6279),
  },
  [3100] = {
    [sym_parameter_list] = STATE(513),
    [anon_sym_LPAREN] = ACTIONS(206),
    [anon_sym_SEMI] = ACTIONS(7326),
    [anon_sym_LBRACK] = ACTIONS(955),
    [sym_comment] = ACTIONS(49),
  },
  [3101] = {
    [sym__type_declarator] = STATE(3148),
    [sym_pointer_type_declarator] = STATE(213),
    [sym_function_type_declarator] = STATE(214),
    [sym_array_type_declarator] = STATE(215),
    [anon_sym_LPAREN] = ACTIONS(327),
    [anon_sym_STAR] = ACTIONS(329),
    [sym_identifier] = ACTIONS(331),
    [sym_comment] = ACTIONS(49),
  },
  [3102] = {
    [sym_raw_string_literal] = ACTIONS(1261),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1263),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1263),
    [anon_sym_LPAREN] = ACTIONS(1261),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1263),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(1263),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1263),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1263),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(1263),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(1263),
    [sym_preproc_directive] = ACTIONS(1263),
    [anon_sym_SEMI] = ACTIONS(1261),
    [anon_sym_typedef] = ACTIONS(1263),
    [anon_sym_extern] = ACTIONS(1263),
    [anon_sym_LBRACE] = ACTIONS(1261),
    [anon_sym_STAR] = ACTIONS(1261),
    [anon_sym_LBRACK] = ACTIONS(1261),
    [anon_sym_static] = ACTIONS(1263),
    [anon_sym_register] = ACTIONS(1263),
    [anon_sym_inline] = ACTIONS(1263),
    [anon_sym_const] = ACTIONS(1263),
    [anon_sym_restrict] = ACTIONS(1263),
    [anon_sym_volatile] = ACTIONS(1263),
    [anon_sym__Atomic] = ACTIONS(1263),
    [anon_sym_mutable] = ACTIONS(1263),
    [anon_sym_explicit] = ACTIONS(1263),
    [anon_sym_constexpr] = ACTIONS(1263),
    [anon_sym_unsigned] = ACTIONS(1263),
    [anon_sym_long] = ACTIONS(1263),
    [anon_sym_short] = ACTIONS(1263),
    [sym_primitive_type] = ACTIONS(1263),
    [anon_sym_enum] = ACTIONS(1263),
    [anon_sym_struct] = ACTIONS(1263),
    [anon_sym_union] = ACTIONS(1263),
    [anon_sym_if] = ACTIONS(1263),
    [anon_sym_else] = ACTIONS(1263),
    [anon_sym_switch] = ACTIONS(1263),
    [anon_sym_case] = ACTIONS(1263),
    [anon_sym_default] = ACTIONS(1263),
    [anon_sym_while] = ACTIONS(1263),
    [anon_sym_do] = ACTIONS(1263),
    [anon_sym_for] = ACTIONS(1263),
    [anon_sym_return] = ACTIONS(1263),
    [anon_sym_break] = ACTIONS(1263),
    [anon_sym_continue] = ACTIONS(1263),
    [anon_sym_goto] = ACTIONS(1263),
    [anon_sym_AMP] = ACTIONS(1261),
    [anon_sym_BANG] = ACTIONS(1261),
    [anon_sym_TILDE] = ACTIONS(1261),
    [anon_sym_PLUS] = ACTIONS(1263),
    [anon_sym_DASH] = ACTIONS(1263),
    [anon_sym_DASH_DASH] = ACTIONS(1261),
    [anon_sym_PLUS_PLUS] = ACTIONS(1261),
    [anon_sym_sizeof] = ACTIONS(1263),
    [sym_number_literal] = ACTIONS(1261),
    [sym_char_literal] = ACTIONS(1261),
    [sym_string_literal] = ACTIONS(1261),
    [sym_true] = ACTIONS(1263),
    [sym_false] = ACTIONS(1263),
    [sym_null] = ACTIONS(1263),
    [sym_identifier] = ACTIONS(1263),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(1263),
    [sym_auto] = ACTIONS(1263),
    [anon_sym_typename] = ACTIONS(1263),
    [anon_sym_new] = ACTIONS(1263),
    [anon_sym_COLON_COLON] = ACTIONS(1261),
    [anon_sym_delete] = ACTIONS(1263),
    [sym_nullptr] = ACTIONS(1263),
  },
  [3103] = {
    [aux_sym_declaration_repeat1] = STATE(678),
    [anon_sym_COMMA] = ACTIONS(538),
    [anon_sym_SEMI] = ACTIONS(7328),
    [sym_comment] = ACTIONS(49),
  },
  [3104] = {
    [sym_raw_string_literal] = ACTIONS(6293),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(6295),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(6295),
    [anon_sym_LPAREN] = ACTIONS(6293),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(6295),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(6295),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(6295),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(6295),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(6295),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(6295),
    [sym_preproc_directive] = ACTIONS(6295),
    [anon_sym_SEMI] = ACTIONS(6293),
    [anon_sym_typedef] = ACTIONS(6295),
    [anon_sym_extern] = ACTIONS(6295),
    [anon_sym_LBRACE] = ACTIONS(6293),
    [anon_sym_STAR] = ACTIONS(6293),
    [anon_sym_LBRACK] = ACTIONS(6293),
    [anon_sym_static] = ACTIONS(6295),
    [anon_sym_register] = ACTIONS(6295),
    [anon_sym_inline] = ACTIONS(6295),
    [anon_sym_const] = ACTIONS(6295),
    [anon_sym_restrict] = ACTIONS(6295),
    [anon_sym_volatile] = ACTIONS(6295),
    [anon_sym__Atomic] = ACTIONS(6295),
    [anon_sym_mutable] = ACTIONS(6295),
    [anon_sym_explicit] = ACTIONS(6295),
    [anon_sym_constexpr] = ACTIONS(6295),
    [anon_sym_unsigned] = ACTIONS(6295),
    [anon_sym_long] = ACTIONS(6295),
    [anon_sym_short] = ACTIONS(6295),
    [sym_primitive_type] = ACTIONS(6295),
    [anon_sym_enum] = ACTIONS(6295),
    [anon_sym_struct] = ACTIONS(6295),
    [anon_sym_union] = ACTIONS(6295),
    [anon_sym_if] = ACTIONS(6295),
    [anon_sym_else] = ACTIONS(6295),
    [anon_sym_switch] = ACTIONS(6295),
    [anon_sym_case] = ACTIONS(6295),
    [anon_sym_default] = ACTIONS(6295),
    [anon_sym_while] = ACTIONS(6295),
    [anon_sym_do] = ACTIONS(6295),
    [anon_sym_for] = ACTIONS(6295),
    [anon_sym_return] = ACTIONS(6295),
    [anon_sym_break] = ACTIONS(6295),
    [anon_sym_continue] = ACTIONS(6295),
    [anon_sym_goto] = ACTIONS(6295),
    [anon_sym_AMP] = ACTIONS(6293),
    [anon_sym_BANG] = ACTIONS(6293),
    [anon_sym_TILDE] = ACTIONS(6293),
    [anon_sym_PLUS] = ACTIONS(6295),
    [anon_sym_DASH] = ACTIONS(6295),
    [anon_sym_DASH_DASH] = ACTIONS(6293),
    [anon_sym_PLUS_PLUS] = ACTIONS(6293),
    [anon_sym_sizeof] = ACTIONS(6295),
    [sym_number_literal] = ACTIONS(6293),
    [sym_char_literal] = ACTIONS(6293),
    [sym_string_literal] = ACTIONS(6293),
    [sym_true] = ACTIONS(6295),
    [sym_false] = ACTIONS(6295),
    [sym_null] = ACTIONS(6295),
    [sym_identifier] = ACTIONS(6295),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(6295),
    [sym_auto] = ACTIONS(6295),
    [anon_sym_typename] = ACTIONS(6295),
    [anon_sym_new] = ACTIONS(6295),
    [anon_sym_COLON_COLON] = ACTIONS(6293),
    [anon_sym_delete] = ACTIONS(6295),
    [sym_nullptr] = ACTIONS(6295),
  },
  [3105] = {
    [sym_argument_list] = STATE(802),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_RPAREN] = ACTIONS(7330),
    [anon_sym_STAR] = ACTIONS(4537),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_EQ] = ACTIONS(4539),
    [anon_sym_QMARK] = ACTIONS(4541),
    [anon_sym_STAR_EQ] = ACTIONS(4543),
    [anon_sym_SLASH_EQ] = ACTIONS(4543),
    [anon_sym_PERCENT_EQ] = ACTIONS(4543),
    [anon_sym_PLUS_EQ] = ACTIONS(4543),
    [anon_sym_DASH_EQ] = ACTIONS(4543),
    [anon_sym_LT_LT_EQ] = ACTIONS(4543),
    [anon_sym_GT_GT_EQ] = ACTIONS(4543),
    [anon_sym_AMP_EQ] = ACTIONS(4543),
    [anon_sym_CARET_EQ] = ACTIONS(4543),
    [anon_sym_PIPE_EQ] = ACTIONS(4543),
    [anon_sym_AMP] = ACTIONS(4545),
    [anon_sym_PIPE_PIPE] = ACTIONS(4547),
    [anon_sym_AMP_AMP] = ACTIONS(4549),
    [anon_sym_PIPE] = ACTIONS(4551),
    [anon_sym_CARET] = ACTIONS(4553),
    [anon_sym_EQ_EQ] = ACTIONS(4555),
    [anon_sym_BANG_EQ] = ACTIONS(4555),
    [anon_sym_LT] = ACTIONS(4557),
    [anon_sym_GT] = ACTIONS(4557),
    [anon_sym_LT_EQ] = ACTIONS(4559),
    [anon_sym_GT_EQ] = ACTIONS(4559),
    [anon_sym_LT_LT] = ACTIONS(4561),
    [anon_sym_GT_GT] = ACTIONS(4561),
    [anon_sym_PLUS] = ACTIONS(4563),
    [anon_sym_DASH] = ACTIONS(4563),
    [anon_sym_SLASH] = ACTIONS(4537),
    [anon_sym_PERCENT] = ACTIONS(4537),
    [anon_sym_DASH_DASH] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(1554),
    [anon_sym_DASH_GT] = ACTIONS(1554),
    [sym_comment] = ACTIONS(49),
  },
  [3106] = {
    [sym_compound_statement] = STATE(3151),
    [sym_labeled_statement] = STATE(3151),
    [sym_expression_statement] = STATE(3151),
    [sym_if_statement] = STATE(3151),
    [sym_switch_statement] = STATE(3151),
    [sym_case_statement] = STATE(3151),
    [sym_while_statement] = STATE(3151),
    [sym_do_statement] = STATE(3151),
    [sym_for_statement] = STATE(3151),
    [sym_return_statement] = STATE(3151),
    [sym_break_statement] = STATE(3151),
    [sym_continue_statement] = STATE(3151),
    [sym_goto_statement] = STATE(3151),
    [sym__expression] = STATE(2739),
    [sym_comma_expression] = STATE(2740),
    [sym_conditional_expression] = STATE(2739),
    [sym_assignment_expression] = STATE(2739),
    [sym_pointer_expression] = STATE(2739),
    [sym_logical_expression] = STATE(2739),
    [sym_bitwise_expression] = STATE(2739),
    [sym_equality_expression] = STATE(2739),
    [sym_relational_expression] = STATE(2739),
    [sym_shift_expression] = STATE(2739),
    [sym_math_expression] = STATE(2739),
    [sym_cast_expression] = STATE(2739),
    [sym_sizeof_expression] = STATE(2739),
    [sym_subscript_expression] = STATE(2739),
    [sym_call_expression] = STATE(2739),
    [sym_field_expression] = STATE(2739),
    [sym_compound_literal_expression] = STATE(2739),
    [sym_parenthesized_expression] = STATE(2739),
    [sym_concatenated_string] = STATE(2739),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(2739),
    [sym_for_range_loop] = STATE(3151),
    [sym_new_expression] = STATE(2739),
    [sym_delete_expression] = STATE(2739),
    [sym_lambda_expression] = STATE(2739),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(6507),
    [anon_sym_LPAREN] = ACTIONS(626),
    [anon_sym_SEMI] = ACTIONS(6509),
    [anon_sym_LBRACE] = ACTIONS(6511),
    [anon_sym_STAR] = ACTIONS(644),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_if] = ACTIONS(6513),
    [anon_sym_switch] = ACTIONS(6515),
    [anon_sym_case] = ACTIONS(6517),
    [anon_sym_default] = ACTIONS(6519),
    [anon_sym_while] = ACTIONS(6521),
    [anon_sym_do] = ACTIONS(6523),
    [anon_sym_for] = ACTIONS(6525),
    [anon_sym_return] = ACTIONS(6527),
    [anon_sym_break] = ACTIONS(6529),
    [anon_sym_continue] = ACTIONS(6531),
    [anon_sym_goto] = ACTIONS(6533),
    [anon_sym_AMP] = ACTIONS(644),
    [anon_sym_BANG] = ACTIONS(668),
    [anon_sym_TILDE] = ACTIONS(670),
    [anon_sym_PLUS] = ACTIONS(672),
    [anon_sym_DASH] = ACTIONS(672),
    [anon_sym_DASH_DASH] = ACTIONS(674),
    [anon_sym_PLUS_PLUS] = ACTIONS(674),
    [anon_sym_sizeof] = ACTIONS(676),
    [sym_number_literal] = ACTIONS(6507),
    [sym_char_literal] = ACTIONS(6507),
    [sym_string_literal] = ACTIONS(678),
    [sym_true] = ACTIONS(6535),
    [sym_false] = ACTIONS(6535),
    [sym_null] = ACTIONS(6535),
    [sym_identifier] = ACTIONS(6537),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1303),
    [anon_sym_delete] = ACTIONS(686),
    [sym_nullptr] = ACTIONS(6535),
  },
  [3107] = {
    [sym_argument_list] = STATE(802),
    [aux_sym_for_statement_repeat1] = STATE(3153),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_COMMA] = ACTIONS(6339),
    [anon_sym_RPAREN] = ACTIONS(7332),
    [anon_sym_STAR] = ACTIONS(2234),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_EQ] = ACTIONS(2236),
    [anon_sym_QMARK] = ACTIONS(2238),
    [anon_sym_STAR_EQ] = ACTIONS(2240),
    [anon_sym_SLASH_EQ] = ACTIONS(2240),
    [anon_sym_PERCENT_EQ] = ACTIONS(2240),
    [anon_sym_PLUS_EQ] = ACTIONS(2240),
    [anon_sym_DASH_EQ] = ACTIONS(2240),
    [anon_sym_LT_LT_EQ] = ACTIONS(2240),
    [anon_sym_GT_GT_EQ] = ACTIONS(2240),
    [anon_sym_AMP_EQ] = ACTIONS(2240),
    [anon_sym_CARET_EQ] = ACTIONS(2240),
    [anon_sym_PIPE_EQ] = ACTIONS(2240),
    [anon_sym_AMP] = ACTIONS(2242),
    [anon_sym_PIPE_PIPE] = ACTIONS(2244),
    [anon_sym_AMP_AMP] = ACTIONS(2246),
    [anon_sym_PIPE] = ACTIONS(2248),
    [anon_sym_CARET] = ACTIONS(2250),
    [anon_sym_EQ_EQ] = ACTIONS(2252),
    [anon_sym_BANG_EQ] = ACTIONS(2252),
    [anon_sym_LT] = ACTIONS(2254),
    [anon_sym_GT] = ACTIONS(2254),
    [anon_sym_LT_EQ] = ACTIONS(2256),
    [anon_sym_GT_EQ] = ACTIONS(2256),
    [anon_sym_LT_LT] = ACTIONS(2258),
    [anon_sym_GT_GT] = ACTIONS(2258),
    [anon_sym_PLUS] = ACTIONS(2260),
    [anon_sym_DASH] = ACTIONS(2260),
    [anon_sym_SLASH] = ACTIONS(2234),
    [anon_sym_PERCENT] = ACTIONS(2234),
    [anon_sym_DASH_DASH] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(1554),
    [anon_sym_DASH_GT] = ACTIONS(1554),
    [sym_comment] = ACTIONS(49),
  },
  [3108] = {
    [sym__expression] = STATE(3154),
    [sym_conditional_expression] = STATE(3154),
    [sym_assignment_expression] = STATE(3154),
    [sym_pointer_expression] = STATE(3154),
    [sym_logical_expression] = STATE(3154),
    [sym_bitwise_expression] = STATE(3154),
    [sym_equality_expression] = STATE(3154),
    [sym_relational_expression] = STATE(3154),
    [sym_shift_expression] = STATE(3154),
    [sym_math_expression] = STATE(3154),
    [sym_cast_expression] = STATE(3154),
    [sym_sizeof_expression] = STATE(3154),
    [sym_subscript_expression] = STATE(3154),
    [sym_call_expression] = STATE(3154),
    [sym_field_expression] = STATE(3154),
    [sym_compound_literal_expression] = STATE(3154),
    [sym_parenthesized_expression] = STATE(3154),
    [sym_concatenated_string] = STATE(3154),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(3154),
    [sym_new_expression] = STATE(3154),
    [sym_delete_expression] = STATE(3154),
    [sym_lambda_expression] = STATE(3154),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(7334),
    [anon_sym_LPAREN] = ACTIONS(1087),
    [anon_sym_RPAREN] = ACTIONS(7332),
    [anon_sym_STAR] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_AMP] = ACTIONS(1089),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1093),
    [anon_sym_PLUS] = ACTIONS(1095),
    [anon_sym_DASH] = ACTIONS(1095),
    [anon_sym_DASH_DASH] = ACTIONS(1097),
    [anon_sym_PLUS_PLUS] = ACTIONS(1097),
    [anon_sym_sizeof] = ACTIONS(1099),
    [sym_number_literal] = ACTIONS(7334),
    [sym_char_literal] = ACTIONS(7334),
    [sym_string_literal] = ACTIONS(1101),
    [sym_true] = ACTIONS(7336),
    [sym_false] = ACTIONS(7336),
    [sym_null] = ACTIONS(7336),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_delete] = ACTIONS(1109),
    [sym_nullptr] = ACTIONS(7336),
  },
  [3109] = {
    [sym_argument_list] = STATE(802),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_SEMI] = ACTIONS(7338),
    [anon_sym_STAR] = ACTIONS(2553),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_EQ] = ACTIONS(2555),
    [anon_sym_QMARK] = ACTIONS(2557),
    [anon_sym_STAR_EQ] = ACTIONS(2559),
    [anon_sym_SLASH_EQ] = ACTIONS(2559),
    [anon_sym_PERCENT_EQ] = ACTIONS(2559),
    [anon_sym_PLUS_EQ] = ACTIONS(2559),
    [anon_sym_DASH_EQ] = ACTIONS(2559),
    [anon_sym_LT_LT_EQ] = ACTIONS(2559),
    [anon_sym_GT_GT_EQ] = ACTIONS(2559),
    [anon_sym_AMP_EQ] = ACTIONS(2559),
    [anon_sym_CARET_EQ] = ACTIONS(2559),
    [anon_sym_PIPE_EQ] = ACTIONS(2559),
    [anon_sym_AMP] = ACTIONS(2561),
    [anon_sym_PIPE_PIPE] = ACTIONS(2563),
    [anon_sym_AMP_AMP] = ACTIONS(2565),
    [anon_sym_PIPE] = ACTIONS(2567),
    [anon_sym_CARET] = ACTIONS(2569),
    [anon_sym_EQ_EQ] = ACTIONS(2571),
    [anon_sym_BANG_EQ] = ACTIONS(2571),
    [anon_sym_LT] = ACTIONS(2573),
    [anon_sym_GT] = ACTIONS(2573),
    [anon_sym_LT_EQ] = ACTIONS(2575),
    [anon_sym_GT_EQ] = ACTIONS(2575),
    [anon_sym_LT_LT] = ACTIONS(2577),
    [anon_sym_GT_GT] = ACTIONS(2577),
    [anon_sym_PLUS] = ACTIONS(2579),
    [anon_sym_DASH] = ACTIONS(2579),
    [anon_sym_SLASH] = ACTIONS(2553),
    [anon_sym_PERCENT] = ACTIONS(2553),
    [anon_sym_DASH_DASH] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(1554),
    [anon_sym_DASH_GT] = ACTIONS(1554),
    [sym_comment] = ACTIONS(49),
  },
  [3110] = {
    [sym_argument_list] = STATE(802),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_RPAREN] = ACTIONS(7340),
    [anon_sym_STAR] = ACTIONS(4537),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_EQ] = ACTIONS(4539),
    [anon_sym_QMARK] = ACTIONS(4541),
    [anon_sym_STAR_EQ] = ACTIONS(4543),
    [anon_sym_SLASH_EQ] = ACTIONS(4543),
    [anon_sym_PERCENT_EQ] = ACTIONS(4543),
    [anon_sym_PLUS_EQ] = ACTIONS(4543),
    [anon_sym_DASH_EQ] = ACTIONS(4543),
    [anon_sym_LT_LT_EQ] = ACTIONS(4543),
    [anon_sym_GT_GT_EQ] = ACTIONS(4543),
    [anon_sym_AMP_EQ] = ACTIONS(4543),
    [anon_sym_CARET_EQ] = ACTIONS(4543),
    [anon_sym_PIPE_EQ] = ACTIONS(4543),
    [anon_sym_AMP] = ACTIONS(4545),
    [anon_sym_PIPE_PIPE] = ACTIONS(4547),
    [anon_sym_AMP_AMP] = ACTIONS(4549),
    [anon_sym_PIPE] = ACTIONS(4551),
    [anon_sym_CARET] = ACTIONS(4553),
    [anon_sym_EQ_EQ] = ACTIONS(4555),
    [anon_sym_BANG_EQ] = ACTIONS(4555),
    [anon_sym_LT] = ACTIONS(4557),
    [anon_sym_GT] = ACTIONS(4557),
    [anon_sym_LT_EQ] = ACTIONS(4559),
    [anon_sym_GT_EQ] = ACTIONS(4559),
    [anon_sym_LT_LT] = ACTIONS(4561),
    [anon_sym_GT_GT] = ACTIONS(4561),
    [anon_sym_PLUS] = ACTIONS(4563),
    [anon_sym_DASH] = ACTIONS(4563),
    [anon_sym_SLASH] = ACTIONS(4537),
    [anon_sym_PERCENT] = ACTIONS(4537),
    [anon_sym_DASH_DASH] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(1554),
    [anon_sym_DASH_GT] = ACTIONS(1554),
    [sym_comment] = ACTIONS(49),
  },
  [3111] = {
    [sym_raw_string_literal] = ACTIONS(7202),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(7204),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(7204),
    [anon_sym_LPAREN] = ACTIONS(7202),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(7204),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(7204),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(7204),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(7204),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(7204),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(7204),
    [sym_preproc_directive] = ACTIONS(7204),
    [anon_sym_SEMI] = ACTIONS(7202),
    [anon_sym_typedef] = ACTIONS(7204),
    [anon_sym_extern] = ACTIONS(7204),
    [anon_sym_LBRACE] = ACTIONS(7202),
    [anon_sym_STAR] = ACTIONS(7202),
    [anon_sym_LBRACK] = ACTIONS(7202),
    [anon_sym_static] = ACTIONS(7204),
    [anon_sym_register] = ACTIONS(7204),
    [anon_sym_inline] = ACTIONS(7204),
    [anon_sym_const] = ACTIONS(7204),
    [anon_sym_restrict] = ACTIONS(7204),
    [anon_sym_volatile] = ACTIONS(7204),
    [anon_sym__Atomic] = ACTIONS(7204),
    [anon_sym_mutable] = ACTIONS(7204),
    [anon_sym_explicit] = ACTIONS(7204),
    [anon_sym_constexpr] = ACTIONS(7204),
    [anon_sym_unsigned] = ACTIONS(7204),
    [anon_sym_long] = ACTIONS(7204),
    [anon_sym_short] = ACTIONS(7204),
    [sym_primitive_type] = ACTIONS(7204),
    [anon_sym_enum] = ACTIONS(7204),
    [anon_sym_struct] = ACTIONS(7204),
    [anon_sym_union] = ACTIONS(7204),
    [anon_sym_if] = ACTIONS(7204),
    [anon_sym_switch] = ACTIONS(7204),
    [anon_sym_case] = ACTIONS(7204),
    [anon_sym_default] = ACTIONS(7204),
    [anon_sym_while] = ACTIONS(7204),
    [anon_sym_do] = ACTIONS(7204),
    [anon_sym_for] = ACTIONS(7204),
    [anon_sym_return] = ACTIONS(7204),
    [anon_sym_break] = ACTIONS(7204),
    [anon_sym_continue] = ACTIONS(7204),
    [anon_sym_goto] = ACTIONS(7204),
    [anon_sym_AMP] = ACTIONS(7202),
    [anon_sym_BANG] = ACTIONS(7202),
    [anon_sym_TILDE] = ACTIONS(7202),
    [anon_sym_PLUS] = ACTIONS(7204),
    [anon_sym_DASH] = ACTIONS(7204),
    [anon_sym_DASH_DASH] = ACTIONS(7202),
    [anon_sym_PLUS_PLUS] = ACTIONS(7202),
    [anon_sym_sizeof] = ACTIONS(7204),
    [sym_number_literal] = ACTIONS(7202),
    [sym_char_literal] = ACTIONS(7202),
    [sym_string_literal] = ACTIONS(7202),
    [sym_true] = ACTIONS(7204),
    [sym_false] = ACTIONS(7204),
    [sym_null] = ACTIONS(7204),
    [sym_identifier] = ACTIONS(7204),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(7204),
    [sym_auto] = ACTIONS(7204),
    [anon_sym_typename] = ACTIONS(7204),
    [anon_sym_new] = ACTIONS(7204),
    [anon_sym_COLON_COLON] = ACTIONS(7202),
    [anon_sym_delete] = ACTIONS(7204),
    [sym_nullptr] = ACTIONS(7204),
  },
  [3112] = {
    [sym_compound_statement] = STATE(3157),
    [sym_labeled_statement] = STATE(3157),
    [sym_expression_statement] = STATE(3157),
    [sym_if_statement] = STATE(3157),
    [sym_switch_statement] = STATE(3157),
    [sym_case_statement] = STATE(3157),
    [sym_while_statement] = STATE(3157),
    [sym_do_statement] = STATE(3157),
    [sym_for_statement] = STATE(3157),
    [sym_return_statement] = STATE(3157),
    [sym_break_statement] = STATE(3157),
    [sym_continue_statement] = STATE(3157),
    [sym_goto_statement] = STATE(3157),
    [sym__expression] = STATE(1419),
    [sym_comma_expression] = STATE(1420),
    [sym_conditional_expression] = STATE(1419),
    [sym_assignment_expression] = STATE(1419),
    [sym_pointer_expression] = STATE(1419),
    [sym_logical_expression] = STATE(1419),
    [sym_bitwise_expression] = STATE(1419),
    [sym_equality_expression] = STATE(1419),
    [sym_relational_expression] = STATE(1419),
    [sym_shift_expression] = STATE(1419),
    [sym_math_expression] = STATE(1419),
    [sym_cast_expression] = STATE(1419),
    [sym_sizeof_expression] = STATE(1419),
    [sym_subscript_expression] = STATE(1419),
    [sym_call_expression] = STATE(1419),
    [sym_field_expression] = STATE(1419),
    [sym_compound_literal_expression] = STATE(1419),
    [sym_parenthesized_expression] = STATE(1419),
    [sym_concatenated_string] = STATE(1419),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(1419),
    [sym_for_range_loop] = STATE(3157),
    [sym_new_expression] = STATE(1419),
    [sym_delete_expression] = STATE(1419),
    [sym_lambda_expression] = STATE(1419),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(2879),
    [anon_sym_LPAREN] = ACTIONS(626),
    [anon_sym_SEMI] = ACTIONS(2899),
    [anon_sym_LBRACE] = ACTIONS(2903),
    [anon_sym_STAR] = ACTIONS(644),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_if] = ACTIONS(2905),
    [anon_sym_switch] = ACTIONS(2907),
    [anon_sym_case] = ACTIONS(2909),
    [anon_sym_default] = ACTIONS(2911),
    [anon_sym_while] = ACTIONS(2913),
    [anon_sym_do] = ACTIONS(2915),
    [anon_sym_for] = ACTIONS(2917),
    [anon_sym_return] = ACTIONS(2919),
    [anon_sym_break] = ACTIONS(2921),
    [anon_sym_continue] = ACTIONS(2923),
    [anon_sym_goto] = ACTIONS(2925),
    [anon_sym_AMP] = ACTIONS(644),
    [anon_sym_BANG] = ACTIONS(668),
    [anon_sym_TILDE] = ACTIONS(670),
    [anon_sym_PLUS] = ACTIONS(672),
    [anon_sym_DASH] = ACTIONS(672),
    [anon_sym_DASH_DASH] = ACTIONS(674),
    [anon_sym_PLUS_PLUS] = ACTIONS(674),
    [anon_sym_sizeof] = ACTIONS(676),
    [sym_number_literal] = ACTIONS(2879),
    [sym_char_literal] = ACTIONS(2879),
    [sym_string_literal] = ACTIONS(678),
    [sym_true] = ACTIONS(2927),
    [sym_false] = ACTIONS(2927),
    [sym_null] = ACTIONS(2927),
    [sym_identifier] = ACTIONS(5397),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1303),
    [anon_sym_delete] = ACTIONS(686),
    [sym_nullptr] = ACTIONS(2927),
  },
  [3113] = {
    [sym_raw_string_literal] = ACTIONS(6864),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(6866),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(6866),
    [anon_sym_LPAREN] = ACTIONS(6864),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(6866),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(6866),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(6866),
    [sym_preproc_directive] = ACTIONS(6866),
    [anon_sym_SEMI] = ACTIONS(6864),
    [anon_sym_typedef] = ACTIONS(6866),
    [anon_sym_extern] = ACTIONS(6866),
    [anon_sym_LBRACE] = ACTIONS(6864),
    [anon_sym_RBRACE] = ACTIONS(6864),
    [anon_sym_STAR] = ACTIONS(6864),
    [anon_sym_LBRACK] = ACTIONS(6864),
    [anon_sym_static] = ACTIONS(6866),
    [anon_sym_register] = ACTIONS(6866),
    [anon_sym_inline] = ACTIONS(6866),
    [anon_sym_const] = ACTIONS(6866),
    [anon_sym_restrict] = ACTIONS(6866),
    [anon_sym_volatile] = ACTIONS(6866),
    [anon_sym__Atomic] = ACTIONS(6866),
    [anon_sym_mutable] = ACTIONS(6866),
    [anon_sym_explicit] = ACTIONS(6866),
    [anon_sym_constexpr] = ACTIONS(6866),
    [anon_sym_unsigned] = ACTIONS(6866),
    [anon_sym_long] = ACTIONS(6866),
    [anon_sym_short] = ACTIONS(6866),
    [sym_primitive_type] = ACTIONS(6866),
    [anon_sym_enum] = ACTIONS(6866),
    [anon_sym_struct] = ACTIONS(6866),
    [anon_sym_union] = ACTIONS(6866),
    [anon_sym_if] = ACTIONS(6866),
    [anon_sym_else] = ACTIONS(6866),
    [anon_sym_switch] = ACTIONS(6866),
    [anon_sym_case] = ACTIONS(6866),
    [anon_sym_default] = ACTIONS(6866),
    [anon_sym_while] = ACTIONS(6866),
    [anon_sym_do] = ACTIONS(6866),
    [anon_sym_for] = ACTIONS(6866),
    [anon_sym_return] = ACTIONS(6866),
    [anon_sym_break] = ACTIONS(6866),
    [anon_sym_continue] = ACTIONS(6866),
    [anon_sym_goto] = ACTIONS(6866),
    [anon_sym_AMP] = ACTIONS(6864),
    [anon_sym_BANG] = ACTIONS(6864),
    [anon_sym_TILDE] = ACTIONS(6864),
    [anon_sym_PLUS] = ACTIONS(6866),
    [anon_sym_DASH] = ACTIONS(6866),
    [anon_sym_DASH_DASH] = ACTIONS(6864),
    [anon_sym_PLUS_PLUS] = ACTIONS(6864),
    [anon_sym_sizeof] = ACTIONS(6866),
    [sym_number_literal] = ACTIONS(6864),
    [sym_char_literal] = ACTIONS(6864),
    [sym_string_literal] = ACTIONS(6864),
    [sym_true] = ACTIONS(6866),
    [sym_false] = ACTIONS(6866),
    [sym_null] = ACTIONS(6866),
    [sym_identifier] = ACTIONS(6866),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(6866),
    [sym_auto] = ACTIONS(6866),
    [anon_sym_typename] = ACTIONS(6866),
    [anon_sym_new] = ACTIONS(6866),
    [anon_sym_COLON_COLON] = ACTIONS(6864),
    [anon_sym_delete] = ACTIONS(6866),
    [sym_nullptr] = ACTIONS(6866),
  },
  [3114] = {
    [sym_compound_statement] = STATE(3158),
    [sym_labeled_statement] = STATE(3158),
    [sym_expression_statement] = STATE(3158),
    [sym_if_statement] = STATE(3158),
    [sym_switch_statement] = STATE(3158),
    [sym_case_statement] = STATE(3158),
    [sym_while_statement] = STATE(3158),
    [sym_do_statement] = STATE(3158),
    [sym_for_statement] = STATE(3158),
    [sym_return_statement] = STATE(3158),
    [sym_break_statement] = STATE(3158),
    [sym_continue_statement] = STATE(3158),
    [sym_goto_statement] = STATE(3158),
    [sym__expression] = STATE(2378),
    [sym_comma_expression] = STATE(2379),
    [sym_conditional_expression] = STATE(2378),
    [sym_assignment_expression] = STATE(2378),
    [sym_pointer_expression] = STATE(2378),
    [sym_logical_expression] = STATE(2378),
    [sym_bitwise_expression] = STATE(2378),
    [sym_equality_expression] = STATE(2378),
    [sym_relational_expression] = STATE(2378),
    [sym_shift_expression] = STATE(2378),
    [sym_math_expression] = STATE(2378),
    [sym_cast_expression] = STATE(2378),
    [sym_sizeof_expression] = STATE(2378),
    [sym_subscript_expression] = STATE(2378),
    [sym_call_expression] = STATE(2378),
    [sym_field_expression] = STATE(2378),
    [sym_compound_literal_expression] = STATE(2378),
    [sym_parenthesized_expression] = STATE(2378),
    [sym_concatenated_string] = STATE(2378),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(2378),
    [sym_for_range_loop] = STATE(3158),
    [sym_new_expression] = STATE(2378),
    [sym_delete_expression] = STATE(2378),
    [sym_lambda_expression] = STATE(2378),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(5538),
    [anon_sym_LPAREN] = ACTIONS(626),
    [anon_sym_SEMI] = ACTIONS(5540),
    [anon_sym_LBRACE] = ACTIONS(5542),
    [anon_sym_STAR] = ACTIONS(644),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_if] = ACTIONS(5544),
    [anon_sym_switch] = ACTIONS(5546),
    [anon_sym_case] = ACTIONS(5548),
    [anon_sym_default] = ACTIONS(5550),
    [anon_sym_while] = ACTIONS(5552),
    [anon_sym_do] = ACTIONS(5554),
    [anon_sym_for] = ACTIONS(5556),
    [anon_sym_return] = ACTIONS(5558),
    [anon_sym_break] = ACTIONS(5560),
    [anon_sym_continue] = ACTIONS(5562),
    [anon_sym_goto] = ACTIONS(5564),
    [anon_sym_AMP] = ACTIONS(644),
    [anon_sym_BANG] = ACTIONS(668),
    [anon_sym_TILDE] = ACTIONS(670),
    [anon_sym_PLUS] = ACTIONS(672),
    [anon_sym_DASH] = ACTIONS(672),
    [anon_sym_DASH_DASH] = ACTIONS(674),
    [anon_sym_PLUS_PLUS] = ACTIONS(674),
    [anon_sym_sizeof] = ACTIONS(676),
    [sym_number_literal] = ACTIONS(5538),
    [sym_char_literal] = ACTIONS(5538),
    [sym_string_literal] = ACTIONS(678),
    [sym_true] = ACTIONS(5566),
    [sym_false] = ACTIONS(5566),
    [sym_null] = ACTIONS(5566),
    [sym_identifier] = ACTIONS(5568),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1303),
    [anon_sym_delete] = ACTIONS(686),
    [sym_nullptr] = ACTIONS(5566),
  },
  [3115] = {
    [sym_raw_string_literal] = ACTIONS(3519),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3521),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3521),
    [anon_sym_LPAREN] = ACTIONS(3519),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3521),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3521),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3521),
    [sym_preproc_directive] = ACTIONS(3521),
    [anon_sym_SEMI] = ACTIONS(3519),
    [anon_sym_typedef] = ACTIONS(3521),
    [anon_sym_extern] = ACTIONS(3521),
    [anon_sym_LBRACE] = ACTIONS(3519),
    [anon_sym_RBRACE] = ACTIONS(3519),
    [anon_sym_STAR] = ACTIONS(3519),
    [anon_sym_LBRACK] = ACTIONS(3519),
    [anon_sym_static] = ACTIONS(3521),
    [anon_sym_register] = ACTIONS(3521),
    [anon_sym_inline] = ACTIONS(3521),
    [anon_sym_const] = ACTIONS(3521),
    [anon_sym_restrict] = ACTIONS(3521),
    [anon_sym_volatile] = ACTIONS(3521),
    [anon_sym__Atomic] = ACTIONS(3521),
    [anon_sym_mutable] = ACTIONS(3521),
    [anon_sym_explicit] = ACTIONS(3521),
    [anon_sym_constexpr] = ACTIONS(3521),
    [anon_sym_unsigned] = ACTIONS(3521),
    [anon_sym_long] = ACTIONS(3521),
    [anon_sym_short] = ACTIONS(3521),
    [sym_primitive_type] = ACTIONS(3521),
    [anon_sym_enum] = ACTIONS(3521),
    [anon_sym_struct] = ACTIONS(3521),
    [anon_sym_union] = ACTIONS(3521),
    [anon_sym_if] = ACTIONS(3521),
    [anon_sym_else] = ACTIONS(3521),
    [anon_sym_switch] = ACTIONS(3521),
    [anon_sym_case] = ACTIONS(3521),
    [anon_sym_default] = ACTIONS(3521),
    [anon_sym_while] = ACTIONS(3521),
    [anon_sym_do] = ACTIONS(3521),
    [anon_sym_for] = ACTIONS(3521),
    [anon_sym_return] = ACTIONS(3521),
    [anon_sym_break] = ACTIONS(3521),
    [anon_sym_continue] = ACTIONS(3521),
    [anon_sym_goto] = ACTIONS(3521),
    [anon_sym_AMP] = ACTIONS(3519),
    [anon_sym_BANG] = ACTIONS(3519),
    [anon_sym_TILDE] = ACTIONS(3519),
    [anon_sym_PLUS] = ACTIONS(3521),
    [anon_sym_DASH] = ACTIONS(3521),
    [anon_sym_DASH_DASH] = ACTIONS(3519),
    [anon_sym_PLUS_PLUS] = ACTIONS(3519),
    [anon_sym_sizeof] = ACTIONS(3521),
    [sym_number_literal] = ACTIONS(3519),
    [sym_char_literal] = ACTIONS(3519),
    [sym_string_literal] = ACTIONS(3519),
    [sym_true] = ACTIONS(3521),
    [sym_false] = ACTIONS(3521),
    [sym_null] = ACTIONS(3521),
    [sym_identifier] = ACTIONS(3521),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(3521),
    [sym_auto] = ACTIONS(3521),
    [anon_sym_typename] = ACTIONS(3521),
    [anon_sym_new] = ACTIONS(3521),
    [anon_sym_COLON_COLON] = ACTIONS(3519),
    [anon_sym_delete] = ACTIONS(3521),
    [sym_nullptr] = ACTIONS(3521),
  },
  [3116] = {
    [sym_raw_string_literal] = ACTIONS(6902),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(6904),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(6904),
    [anon_sym_LPAREN] = ACTIONS(6902),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(6904),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(6904),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(6904),
    [sym_preproc_directive] = ACTIONS(6904),
    [anon_sym_SEMI] = ACTIONS(6902),
    [anon_sym_typedef] = ACTIONS(6904),
    [anon_sym_extern] = ACTIONS(6904),
    [anon_sym_LBRACE] = ACTIONS(6902),
    [anon_sym_RBRACE] = ACTIONS(6902),
    [anon_sym_STAR] = ACTIONS(6902),
    [anon_sym_LBRACK] = ACTIONS(6902),
    [anon_sym_static] = ACTIONS(6904),
    [anon_sym_register] = ACTIONS(6904),
    [anon_sym_inline] = ACTIONS(6904),
    [anon_sym_const] = ACTIONS(6904),
    [anon_sym_restrict] = ACTIONS(6904),
    [anon_sym_volatile] = ACTIONS(6904),
    [anon_sym__Atomic] = ACTIONS(6904),
    [anon_sym_mutable] = ACTIONS(6904),
    [anon_sym_explicit] = ACTIONS(6904),
    [anon_sym_constexpr] = ACTIONS(6904),
    [anon_sym_unsigned] = ACTIONS(6904),
    [anon_sym_long] = ACTIONS(6904),
    [anon_sym_short] = ACTIONS(6904),
    [sym_primitive_type] = ACTIONS(6904),
    [anon_sym_enum] = ACTIONS(6904),
    [anon_sym_struct] = ACTIONS(6904),
    [anon_sym_union] = ACTIONS(6904),
    [anon_sym_if] = ACTIONS(6904),
    [anon_sym_else] = ACTIONS(6904),
    [anon_sym_switch] = ACTIONS(6904),
    [anon_sym_case] = ACTIONS(6904),
    [anon_sym_default] = ACTIONS(6904),
    [anon_sym_while] = ACTIONS(6904),
    [anon_sym_do] = ACTIONS(6904),
    [anon_sym_for] = ACTIONS(6904),
    [anon_sym_return] = ACTIONS(6904),
    [anon_sym_break] = ACTIONS(6904),
    [anon_sym_continue] = ACTIONS(6904),
    [anon_sym_goto] = ACTIONS(6904),
    [anon_sym_AMP] = ACTIONS(6902),
    [anon_sym_BANG] = ACTIONS(6902),
    [anon_sym_TILDE] = ACTIONS(6902),
    [anon_sym_PLUS] = ACTIONS(6904),
    [anon_sym_DASH] = ACTIONS(6904),
    [anon_sym_DASH_DASH] = ACTIONS(6902),
    [anon_sym_PLUS_PLUS] = ACTIONS(6902),
    [anon_sym_sizeof] = ACTIONS(6904),
    [sym_number_literal] = ACTIONS(6902),
    [sym_char_literal] = ACTIONS(6902),
    [sym_string_literal] = ACTIONS(6902),
    [sym_true] = ACTIONS(6904),
    [sym_false] = ACTIONS(6904),
    [sym_null] = ACTIONS(6904),
    [sym_identifier] = ACTIONS(6904),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(6904),
    [sym_auto] = ACTIONS(6904),
    [anon_sym_typename] = ACTIONS(6904),
    [anon_sym_new] = ACTIONS(6904),
    [anon_sym_COLON_COLON] = ACTIONS(6902),
    [anon_sym_delete] = ACTIONS(6904),
    [sym_nullptr] = ACTIONS(6904),
  },
  [3117] = {
    [sym_compound_statement] = STATE(3159),
    [sym_labeled_statement] = STATE(3159),
    [sym_expression_statement] = STATE(3159),
    [sym_if_statement] = STATE(3159),
    [sym_switch_statement] = STATE(3159),
    [sym_case_statement] = STATE(3159),
    [sym_while_statement] = STATE(3159),
    [sym_do_statement] = STATE(3159),
    [sym_for_statement] = STATE(3159),
    [sym_return_statement] = STATE(3159),
    [sym_break_statement] = STATE(3159),
    [sym_continue_statement] = STATE(3159),
    [sym_goto_statement] = STATE(3159),
    [sym__expression] = STATE(2378),
    [sym_comma_expression] = STATE(2379),
    [sym_conditional_expression] = STATE(2378),
    [sym_assignment_expression] = STATE(2378),
    [sym_pointer_expression] = STATE(2378),
    [sym_logical_expression] = STATE(2378),
    [sym_bitwise_expression] = STATE(2378),
    [sym_equality_expression] = STATE(2378),
    [sym_relational_expression] = STATE(2378),
    [sym_shift_expression] = STATE(2378),
    [sym_math_expression] = STATE(2378),
    [sym_cast_expression] = STATE(2378),
    [sym_sizeof_expression] = STATE(2378),
    [sym_subscript_expression] = STATE(2378),
    [sym_call_expression] = STATE(2378),
    [sym_field_expression] = STATE(2378),
    [sym_compound_literal_expression] = STATE(2378),
    [sym_parenthesized_expression] = STATE(2378),
    [sym_concatenated_string] = STATE(2378),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(2378),
    [sym_for_range_loop] = STATE(3159),
    [sym_new_expression] = STATE(2378),
    [sym_delete_expression] = STATE(2378),
    [sym_lambda_expression] = STATE(2378),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(5538),
    [anon_sym_LPAREN] = ACTIONS(626),
    [anon_sym_SEMI] = ACTIONS(5540),
    [anon_sym_LBRACE] = ACTIONS(5542),
    [anon_sym_STAR] = ACTIONS(644),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_if] = ACTIONS(5544),
    [anon_sym_switch] = ACTIONS(5546),
    [anon_sym_case] = ACTIONS(5548),
    [anon_sym_default] = ACTIONS(5550),
    [anon_sym_while] = ACTIONS(5552),
    [anon_sym_do] = ACTIONS(5554),
    [anon_sym_for] = ACTIONS(5556),
    [anon_sym_return] = ACTIONS(5558),
    [anon_sym_break] = ACTIONS(5560),
    [anon_sym_continue] = ACTIONS(5562),
    [anon_sym_goto] = ACTIONS(5564),
    [anon_sym_AMP] = ACTIONS(644),
    [anon_sym_BANG] = ACTIONS(668),
    [anon_sym_TILDE] = ACTIONS(670),
    [anon_sym_PLUS] = ACTIONS(672),
    [anon_sym_DASH] = ACTIONS(672),
    [anon_sym_DASH_DASH] = ACTIONS(674),
    [anon_sym_PLUS_PLUS] = ACTIONS(674),
    [anon_sym_sizeof] = ACTIONS(676),
    [sym_number_literal] = ACTIONS(5538),
    [sym_char_literal] = ACTIONS(5538),
    [sym_string_literal] = ACTIONS(678),
    [sym_true] = ACTIONS(5566),
    [sym_false] = ACTIONS(5566),
    [sym_null] = ACTIONS(5566),
    [sym_identifier] = ACTIONS(5568),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1303),
    [anon_sym_delete] = ACTIONS(686),
    [sym_nullptr] = ACTIONS(5566),
  },
  [3118] = {
    [aux_sym_for_statement_repeat1] = STATE(2796),
    [anon_sym_COMMA] = ACTIONS(6339),
    [anon_sym_RPAREN] = ACTIONS(7342),
    [sym_comment] = ACTIONS(49),
  },
  [3119] = {
    [sym_argument_list] = STATE(802),
    [aux_sym_for_statement_repeat1] = STATE(3161),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_COMMA] = ACTIONS(6339),
    [anon_sym_RPAREN] = ACTIONS(7342),
    [anon_sym_STAR] = ACTIONS(2234),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_EQ] = ACTIONS(2236),
    [anon_sym_QMARK] = ACTIONS(2238),
    [anon_sym_STAR_EQ] = ACTIONS(2240),
    [anon_sym_SLASH_EQ] = ACTIONS(2240),
    [anon_sym_PERCENT_EQ] = ACTIONS(2240),
    [anon_sym_PLUS_EQ] = ACTIONS(2240),
    [anon_sym_DASH_EQ] = ACTIONS(2240),
    [anon_sym_LT_LT_EQ] = ACTIONS(2240),
    [anon_sym_GT_GT_EQ] = ACTIONS(2240),
    [anon_sym_AMP_EQ] = ACTIONS(2240),
    [anon_sym_CARET_EQ] = ACTIONS(2240),
    [anon_sym_PIPE_EQ] = ACTIONS(2240),
    [anon_sym_AMP] = ACTIONS(2242),
    [anon_sym_PIPE_PIPE] = ACTIONS(2244),
    [anon_sym_AMP_AMP] = ACTIONS(2246),
    [anon_sym_PIPE] = ACTIONS(2248),
    [anon_sym_CARET] = ACTIONS(2250),
    [anon_sym_EQ_EQ] = ACTIONS(2252),
    [anon_sym_BANG_EQ] = ACTIONS(2252),
    [anon_sym_LT] = ACTIONS(2254),
    [anon_sym_GT] = ACTIONS(2254),
    [anon_sym_LT_EQ] = ACTIONS(2256),
    [anon_sym_GT_EQ] = ACTIONS(2256),
    [anon_sym_LT_LT] = ACTIONS(2258),
    [anon_sym_GT_GT] = ACTIONS(2258),
    [anon_sym_PLUS] = ACTIONS(2260),
    [anon_sym_DASH] = ACTIONS(2260),
    [anon_sym_SLASH] = ACTIONS(2234),
    [anon_sym_PERCENT] = ACTIONS(2234),
    [anon_sym_DASH_DASH] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(1554),
    [anon_sym_DASH_GT] = ACTIONS(1554),
    [sym_comment] = ACTIONS(49),
  },
  [3120] = {
    [sym_raw_string_literal] = ACTIONS(6925),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(6927),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(6927),
    [anon_sym_LPAREN] = ACTIONS(6925),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(6927),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(6927),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(6927),
    [sym_preproc_directive] = ACTIONS(6927),
    [anon_sym_SEMI] = ACTIONS(6925),
    [anon_sym_typedef] = ACTIONS(6927),
    [anon_sym_extern] = ACTIONS(6927),
    [anon_sym_LBRACE] = ACTIONS(6925),
    [anon_sym_RBRACE] = ACTIONS(6925),
    [anon_sym_STAR] = ACTIONS(6925),
    [anon_sym_LBRACK] = ACTIONS(6925),
    [anon_sym_static] = ACTIONS(6927),
    [anon_sym_register] = ACTIONS(6927),
    [anon_sym_inline] = ACTIONS(6927),
    [anon_sym_const] = ACTIONS(6927),
    [anon_sym_restrict] = ACTIONS(6927),
    [anon_sym_volatile] = ACTIONS(6927),
    [anon_sym__Atomic] = ACTIONS(6927),
    [anon_sym_mutable] = ACTIONS(6927),
    [anon_sym_explicit] = ACTIONS(6927),
    [anon_sym_constexpr] = ACTIONS(6927),
    [anon_sym_unsigned] = ACTIONS(6927),
    [anon_sym_long] = ACTIONS(6927),
    [anon_sym_short] = ACTIONS(6927),
    [sym_primitive_type] = ACTIONS(6927),
    [anon_sym_enum] = ACTIONS(6927),
    [anon_sym_struct] = ACTIONS(6927),
    [anon_sym_union] = ACTIONS(6927),
    [anon_sym_if] = ACTIONS(6927),
    [anon_sym_else] = ACTIONS(6927),
    [anon_sym_switch] = ACTIONS(6927),
    [anon_sym_case] = ACTIONS(6927),
    [anon_sym_default] = ACTIONS(6927),
    [anon_sym_while] = ACTIONS(6927),
    [anon_sym_do] = ACTIONS(6927),
    [anon_sym_for] = ACTIONS(6927),
    [anon_sym_return] = ACTIONS(6927),
    [anon_sym_break] = ACTIONS(6927),
    [anon_sym_continue] = ACTIONS(6927),
    [anon_sym_goto] = ACTIONS(6927),
    [anon_sym_AMP] = ACTIONS(6925),
    [anon_sym_BANG] = ACTIONS(6925),
    [anon_sym_TILDE] = ACTIONS(6925),
    [anon_sym_PLUS] = ACTIONS(6927),
    [anon_sym_DASH] = ACTIONS(6927),
    [anon_sym_DASH_DASH] = ACTIONS(6925),
    [anon_sym_PLUS_PLUS] = ACTIONS(6925),
    [anon_sym_sizeof] = ACTIONS(6927),
    [sym_number_literal] = ACTIONS(6925),
    [sym_char_literal] = ACTIONS(6925),
    [sym_string_literal] = ACTIONS(6925),
    [sym_true] = ACTIONS(6927),
    [sym_false] = ACTIONS(6927),
    [sym_null] = ACTIONS(6927),
    [sym_identifier] = ACTIONS(6927),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(6927),
    [sym_auto] = ACTIONS(6927),
    [anon_sym_typename] = ACTIONS(6927),
    [anon_sym_new] = ACTIONS(6927),
    [anon_sym_COLON_COLON] = ACTIONS(6925),
    [anon_sym_delete] = ACTIONS(6927),
    [sym_nullptr] = ACTIONS(6927),
  },
  [3121] = {
    [sym_compound_statement] = STATE(2908),
    [sym_labeled_statement] = STATE(2908),
    [sym_expression_statement] = STATE(2908),
    [sym_if_statement] = STATE(2908),
    [sym_switch_statement] = STATE(2908),
    [sym_case_statement] = STATE(2908),
    [sym_while_statement] = STATE(2908),
    [sym_do_statement] = STATE(2908),
    [sym_for_statement] = STATE(2908),
    [sym_return_statement] = STATE(2908),
    [sym_break_statement] = STATE(2908),
    [sym_continue_statement] = STATE(2908),
    [sym_goto_statement] = STATE(2908),
    [sym__expression] = STATE(873),
    [sym_comma_expression] = STATE(874),
    [sym_conditional_expression] = STATE(873),
    [sym_assignment_expression] = STATE(873),
    [sym_pointer_expression] = STATE(873),
    [sym_logical_expression] = STATE(873),
    [sym_bitwise_expression] = STATE(873),
    [sym_equality_expression] = STATE(873),
    [sym_relational_expression] = STATE(873),
    [sym_shift_expression] = STATE(873),
    [sym_math_expression] = STATE(873),
    [sym_cast_expression] = STATE(873),
    [sym_sizeof_expression] = STATE(873),
    [sym_subscript_expression] = STATE(873),
    [sym_call_expression] = STATE(873),
    [sym_field_expression] = STATE(873),
    [sym_compound_literal_expression] = STATE(873),
    [sym_parenthesized_expression] = STATE(873),
    [sym_concatenated_string] = STATE(873),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(873),
    [sym_for_range_loop] = STATE(2908),
    [sym_new_expression] = STATE(873),
    [sym_delete_expression] = STATE(873),
    [sym_lambda_expression] = STATE(873),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(1660),
    [anon_sym_LPAREN] = ACTIONS(626),
    [anon_sym_SEMI] = ACTIONS(1662),
    [anon_sym_LBRACE] = ACTIONS(1664),
    [anon_sym_STAR] = ACTIONS(644),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_if] = ACTIONS(6297),
    [anon_sym_switch] = ACTIONS(6299),
    [anon_sym_case] = ACTIONS(6301),
    [anon_sym_default] = ACTIONS(6303),
    [anon_sym_while] = ACTIONS(6305),
    [anon_sym_do] = ACTIONS(1676),
    [anon_sym_for] = ACTIONS(6307),
    [anon_sym_return] = ACTIONS(1680),
    [anon_sym_break] = ACTIONS(1682),
    [anon_sym_continue] = ACTIONS(1684),
    [anon_sym_goto] = ACTIONS(1686),
    [anon_sym_AMP] = ACTIONS(644),
    [anon_sym_BANG] = ACTIONS(668),
    [anon_sym_TILDE] = ACTIONS(670),
    [anon_sym_PLUS] = ACTIONS(672),
    [anon_sym_DASH] = ACTIONS(672),
    [anon_sym_DASH_DASH] = ACTIONS(674),
    [anon_sym_PLUS_PLUS] = ACTIONS(674),
    [anon_sym_sizeof] = ACTIONS(676),
    [sym_number_literal] = ACTIONS(1660),
    [sym_char_literal] = ACTIONS(1660),
    [sym_string_literal] = ACTIONS(678),
    [sym_true] = ACTIONS(1688),
    [sym_false] = ACTIONS(1688),
    [sym_null] = ACTIONS(1688),
    [sym_identifier] = ACTIONS(6309),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1303),
    [anon_sym_delete] = ACTIONS(686),
    [sym_nullptr] = ACTIONS(1688),
  },
  [3122] = {
    [anon_sym_else] = ACTIONS(7344),
    [anon_sym_while] = ACTIONS(6611),
    [sym_comment] = ACTIONS(49),
  },
  [3123] = {
    [sym_compound_statement] = STATE(2911),
    [sym_labeled_statement] = STATE(2911),
    [sym_expression_statement] = STATE(2911),
    [sym_if_statement] = STATE(2911),
    [sym_switch_statement] = STATE(2911),
    [sym_case_statement] = STATE(2911),
    [sym_while_statement] = STATE(2911),
    [sym_do_statement] = STATE(2911),
    [sym_for_statement] = STATE(2911),
    [sym_return_statement] = STATE(2911),
    [sym_break_statement] = STATE(2911),
    [sym_continue_statement] = STATE(2911),
    [sym_goto_statement] = STATE(2911),
    [sym__expression] = STATE(873),
    [sym_comma_expression] = STATE(874),
    [sym_conditional_expression] = STATE(873),
    [sym_assignment_expression] = STATE(873),
    [sym_pointer_expression] = STATE(873),
    [sym_logical_expression] = STATE(873),
    [sym_bitwise_expression] = STATE(873),
    [sym_equality_expression] = STATE(873),
    [sym_relational_expression] = STATE(873),
    [sym_shift_expression] = STATE(873),
    [sym_math_expression] = STATE(873),
    [sym_cast_expression] = STATE(873),
    [sym_sizeof_expression] = STATE(873),
    [sym_subscript_expression] = STATE(873),
    [sym_call_expression] = STATE(873),
    [sym_field_expression] = STATE(873),
    [sym_compound_literal_expression] = STATE(873),
    [sym_parenthesized_expression] = STATE(873),
    [sym_concatenated_string] = STATE(873),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(873),
    [sym_for_range_loop] = STATE(2911),
    [sym_new_expression] = STATE(873),
    [sym_delete_expression] = STATE(873),
    [sym_lambda_expression] = STATE(873),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(1660),
    [anon_sym_LPAREN] = ACTIONS(626),
    [anon_sym_SEMI] = ACTIONS(1662),
    [anon_sym_LBRACE] = ACTIONS(1664),
    [anon_sym_STAR] = ACTIONS(644),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_if] = ACTIONS(6297),
    [anon_sym_switch] = ACTIONS(6299),
    [anon_sym_case] = ACTIONS(6301),
    [anon_sym_default] = ACTIONS(6303),
    [anon_sym_while] = ACTIONS(6305),
    [anon_sym_do] = ACTIONS(1676),
    [anon_sym_for] = ACTIONS(6307),
    [anon_sym_return] = ACTIONS(1680),
    [anon_sym_break] = ACTIONS(1682),
    [anon_sym_continue] = ACTIONS(1684),
    [anon_sym_goto] = ACTIONS(1686),
    [anon_sym_AMP] = ACTIONS(644),
    [anon_sym_BANG] = ACTIONS(668),
    [anon_sym_TILDE] = ACTIONS(670),
    [anon_sym_PLUS] = ACTIONS(672),
    [anon_sym_DASH] = ACTIONS(672),
    [anon_sym_DASH_DASH] = ACTIONS(674),
    [anon_sym_PLUS_PLUS] = ACTIONS(674),
    [anon_sym_sizeof] = ACTIONS(676),
    [sym_number_literal] = ACTIONS(1660),
    [sym_char_literal] = ACTIONS(1660),
    [sym_string_literal] = ACTIONS(678),
    [sym_true] = ACTIONS(1688),
    [sym_false] = ACTIONS(1688),
    [sym_null] = ACTIONS(1688),
    [sym_identifier] = ACTIONS(6309),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1303),
    [anon_sym_delete] = ACTIONS(686),
    [sym_nullptr] = ACTIONS(1688),
  },
  [3124] = {
    [aux_sym_for_statement_repeat1] = STATE(2796),
    [anon_sym_COMMA] = ACTIONS(6339),
    [anon_sym_RPAREN] = ACTIONS(7346),
    [sym_comment] = ACTIONS(49),
  },
  [3125] = {
    [sym_argument_list] = STATE(802),
    [aux_sym_for_statement_repeat1] = STATE(3164),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_COMMA] = ACTIONS(6339),
    [anon_sym_RPAREN] = ACTIONS(7346),
    [anon_sym_STAR] = ACTIONS(2234),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_EQ] = ACTIONS(2236),
    [anon_sym_QMARK] = ACTIONS(2238),
    [anon_sym_STAR_EQ] = ACTIONS(2240),
    [anon_sym_SLASH_EQ] = ACTIONS(2240),
    [anon_sym_PERCENT_EQ] = ACTIONS(2240),
    [anon_sym_PLUS_EQ] = ACTIONS(2240),
    [anon_sym_DASH_EQ] = ACTIONS(2240),
    [anon_sym_LT_LT_EQ] = ACTIONS(2240),
    [anon_sym_GT_GT_EQ] = ACTIONS(2240),
    [anon_sym_AMP_EQ] = ACTIONS(2240),
    [anon_sym_CARET_EQ] = ACTIONS(2240),
    [anon_sym_PIPE_EQ] = ACTIONS(2240),
    [anon_sym_AMP] = ACTIONS(2242),
    [anon_sym_PIPE_PIPE] = ACTIONS(2244),
    [anon_sym_AMP_AMP] = ACTIONS(2246),
    [anon_sym_PIPE] = ACTIONS(2248),
    [anon_sym_CARET] = ACTIONS(2250),
    [anon_sym_EQ_EQ] = ACTIONS(2252),
    [anon_sym_BANG_EQ] = ACTIONS(2252),
    [anon_sym_LT] = ACTIONS(2254),
    [anon_sym_GT] = ACTIONS(2254),
    [anon_sym_LT_EQ] = ACTIONS(2256),
    [anon_sym_GT_EQ] = ACTIONS(2256),
    [anon_sym_LT_LT] = ACTIONS(2258),
    [anon_sym_GT_GT] = ACTIONS(2258),
    [anon_sym_PLUS] = ACTIONS(2260),
    [anon_sym_DASH] = ACTIONS(2260),
    [anon_sym_SLASH] = ACTIONS(2234),
    [anon_sym_PERCENT] = ACTIONS(2234),
    [anon_sym_DASH_DASH] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(1554),
    [anon_sym_DASH_GT] = ACTIONS(1554),
    [sym_comment] = ACTIONS(49),
  },
  [3126] = {
    [sym__expression] = STATE(3165),
    [sym_conditional_expression] = STATE(3165),
    [sym_assignment_expression] = STATE(3165),
    [sym_pointer_expression] = STATE(3165),
    [sym_logical_expression] = STATE(3165),
    [sym_bitwise_expression] = STATE(3165),
    [sym_equality_expression] = STATE(3165),
    [sym_relational_expression] = STATE(3165),
    [sym_shift_expression] = STATE(3165),
    [sym_math_expression] = STATE(3165),
    [sym_cast_expression] = STATE(3165),
    [sym_sizeof_expression] = STATE(3165),
    [sym_subscript_expression] = STATE(3165),
    [sym_call_expression] = STATE(3165),
    [sym_field_expression] = STATE(3165),
    [sym_compound_literal_expression] = STATE(3165),
    [sym_parenthesized_expression] = STATE(3165),
    [sym_concatenated_string] = STATE(3165),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(3165),
    [sym_new_expression] = STATE(3165),
    [sym_delete_expression] = STATE(3165),
    [sym_lambda_expression] = STATE(3165),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(7348),
    [anon_sym_LPAREN] = ACTIONS(1087),
    [anon_sym_RPAREN] = ACTIONS(7346),
    [anon_sym_STAR] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_AMP] = ACTIONS(1089),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1093),
    [anon_sym_PLUS] = ACTIONS(1095),
    [anon_sym_DASH] = ACTIONS(1095),
    [anon_sym_DASH_DASH] = ACTIONS(1097),
    [anon_sym_PLUS_PLUS] = ACTIONS(1097),
    [anon_sym_sizeof] = ACTIONS(1099),
    [sym_number_literal] = ACTIONS(7348),
    [sym_char_literal] = ACTIONS(7348),
    [sym_string_literal] = ACTIONS(1101),
    [sym_true] = ACTIONS(7350),
    [sym_false] = ACTIONS(7350),
    [sym_null] = ACTIONS(7350),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_delete] = ACTIONS(1109),
    [sym_nullptr] = ACTIONS(7350),
  },
  [3127] = {
    [sym_compound_statement] = STATE(2915),
    [sym_labeled_statement] = STATE(2915),
    [sym_expression_statement] = STATE(2915),
    [sym_if_statement] = STATE(2915),
    [sym_switch_statement] = STATE(2915),
    [sym_case_statement] = STATE(2915),
    [sym_while_statement] = STATE(2915),
    [sym_do_statement] = STATE(2915),
    [sym_for_statement] = STATE(2915),
    [sym_return_statement] = STATE(2915),
    [sym_break_statement] = STATE(2915),
    [sym_continue_statement] = STATE(2915),
    [sym_goto_statement] = STATE(2915),
    [sym__expression] = STATE(873),
    [sym_comma_expression] = STATE(874),
    [sym_conditional_expression] = STATE(873),
    [sym_assignment_expression] = STATE(873),
    [sym_pointer_expression] = STATE(873),
    [sym_logical_expression] = STATE(873),
    [sym_bitwise_expression] = STATE(873),
    [sym_equality_expression] = STATE(873),
    [sym_relational_expression] = STATE(873),
    [sym_shift_expression] = STATE(873),
    [sym_math_expression] = STATE(873),
    [sym_cast_expression] = STATE(873),
    [sym_sizeof_expression] = STATE(873),
    [sym_subscript_expression] = STATE(873),
    [sym_call_expression] = STATE(873),
    [sym_field_expression] = STATE(873),
    [sym_compound_literal_expression] = STATE(873),
    [sym_parenthesized_expression] = STATE(873),
    [sym_concatenated_string] = STATE(873),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(873),
    [sym_for_range_loop] = STATE(2915),
    [sym_new_expression] = STATE(873),
    [sym_delete_expression] = STATE(873),
    [sym_lambda_expression] = STATE(873),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(1660),
    [anon_sym_LPAREN] = ACTIONS(626),
    [anon_sym_SEMI] = ACTIONS(1662),
    [anon_sym_LBRACE] = ACTIONS(1664),
    [anon_sym_STAR] = ACTIONS(644),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_if] = ACTIONS(6297),
    [anon_sym_switch] = ACTIONS(6299),
    [anon_sym_case] = ACTIONS(6301),
    [anon_sym_default] = ACTIONS(6303),
    [anon_sym_while] = ACTIONS(6305),
    [anon_sym_do] = ACTIONS(1676),
    [anon_sym_for] = ACTIONS(6307),
    [anon_sym_return] = ACTIONS(1680),
    [anon_sym_break] = ACTIONS(1682),
    [anon_sym_continue] = ACTIONS(1684),
    [anon_sym_goto] = ACTIONS(1686),
    [anon_sym_AMP] = ACTIONS(644),
    [anon_sym_BANG] = ACTIONS(668),
    [anon_sym_TILDE] = ACTIONS(670),
    [anon_sym_PLUS] = ACTIONS(672),
    [anon_sym_DASH] = ACTIONS(672),
    [anon_sym_DASH_DASH] = ACTIONS(674),
    [anon_sym_PLUS_PLUS] = ACTIONS(674),
    [anon_sym_sizeof] = ACTIONS(676),
    [sym_number_literal] = ACTIONS(1660),
    [sym_char_literal] = ACTIONS(1660),
    [sym_string_literal] = ACTIONS(678),
    [sym_true] = ACTIONS(1688),
    [sym_false] = ACTIONS(1688),
    [sym_null] = ACTIONS(1688),
    [sym_identifier] = ACTIONS(6309),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1303),
    [anon_sym_delete] = ACTIONS(686),
    [sym_nullptr] = ACTIONS(1688),
  },
  [3128] = {
    [anon_sym_else] = ACTIONS(7292),
    [anon_sym_while] = ACTIONS(7292),
    [sym_comment] = ACTIONS(49),
  },
  [3129] = {
    [sym_raw_string_literal] = ACTIONS(6267),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(6269),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(6269),
    [anon_sym_LPAREN] = ACTIONS(6267),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(6269),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(6269),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(6269),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(6269),
    [sym_preproc_directive] = ACTIONS(6269),
    [anon_sym_SEMI] = ACTIONS(6267),
    [anon_sym_typedef] = ACTIONS(6269),
    [anon_sym_extern] = ACTIONS(6269),
    [anon_sym_LBRACE] = ACTIONS(6267),
    [anon_sym_STAR] = ACTIONS(6267),
    [anon_sym_LBRACK] = ACTIONS(6267),
    [anon_sym_static] = ACTIONS(6269),
    [anon_sym_register] = ACTIONS(6269),
    [anon_sym_inline] = ACTIONS(6269),
    [anon_sym_const] = ACTIONS(6269),
    [anon_sym_restrict] = ACTIONS(6269),
    [anon_sym_volatile] = ACTIONS(6269),
    [anon_sym__Atomic] = ACTIONS(6269),
    [anon_sym_mutable] = ACTIONS(6269),
    [anon_sym_explicit] = ACTIONS(6269),
    [anon_sym_constexpr] = ACTIONS(6269),
    [anon_sym_unsigned] = ACTIONS(6269),
    [anon_sym_long] = ACTIONS(6269),
    [anon_sym_short] = ACTIONS(6269),
    [sym_primitive_type] = ACTIONS(6269),
    [anon_sym_enum] = ACTIONS(6269),
    [anon_sym_struct] = ACTIONS(6269),
    [anon_sym_union] = ACTIONS(6269),
    [anon_sym_if] = ACTIONS(6269),
    [anon_sym_else] = ACTIONS(7352),
    [anon_sym_switch] = ACTIONS(6269),
    [anon_sym_case] = ACTIONS(6269),
    [anon_sym_default] = ACTIONS(6269),
    [anon_sym_while] = ACTIONS(6269),
    [anon_sym_do] = ACTIONS(6269),
    [anon_sym_for] = ACTIONS(6269),
    [anon_sym_return] = ACTIONS(6269),
    [anon_sym_break] = ACTIONS(6269),
    [anon_sym_continue] = ACTIONS(6269),
    [anon_sym_goto] = ACTIONS(6269),
    [anon_sym_AMP] = ACTIONS(6267),
    [anon_sym_BANG] = ACTIONS(6267),
    [anon_sym_TILDE] = ACTIONS(6267),
    [anon_sym_PLUS] = ACTIONS(6269),
    [anon_sym_DASH] = ACTIONS(6269),
    [anon_sym_DASH_DASH] = ACTIONS(6267),
    [anon_sym_PLUS_PLUS] = ACTIONS(6267),
    [anon_sym_sizeof] = ACTIONS(6269),
    [sym_number_literal] = ACTIONS(6267),
    [sym_char_literal] = ACTIONS(6267),
    [sym_string_literal] = ACTIONS(6267),
    [sym_true] = ACTIONS(6269),
    [sym_false] = ACTIONS(6269),
    [sym_null] = ACTIONS(6269),
    [sym_identifier] = ACTIONS(6269),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(6269),
    [sym_auto] = ACTIONS(6269),
    [anon_sym_typename] = ACTIONS(6269),
    [anon_sym_new] = ACTIONS(6269),
    [anon_sym_COLON_COLON] = ACTIONS(6267),
    [anon_sym_delete] = ACTIONS(6269),
    [sym_nullptr] = ACTIONS(6269),
  },
  [3130] = {
    [sym_compound_statement] = STATE(3167),
    [sym_labeled_statement] = STATE(3167),
    [sym_expression_statement] = STATE(3167),
    [sym_if_statement] = STATE(3167),
    [sym_switch_statement] = STATE(3167),
    [sym_case_statement] = STATE(3167),
    [sym_while_statement] = STATE(3167),
    [sym_do_statement] = STATE(3167),
    [sym_for_statement] = STATE(3167),
    [sym_return_statement] = STATE(3167),
    [sym_break_statement] = STATE(3167),
    [sym_continue_statement] = STATE(3167),
    [sym_goto_statement] = STATE(3167),
    [sym__expression] = STATE(2844),
    [sym_comma_expression] = STATE(2845),
    [sym_conditional_expression] = STATE(2844),
    [sym_assignment_expression] = STATE(2844),
    [sym_pointer_expression] = STATE(2844),
    [sym_logical_expression] = STATE(2844),
    [sym_bitwise_expression] = STATE(2844),
    [sym_equality_expression] = STATE(2844),
    [sym_relational_expression] = STATE(2844),
    [sym_shift_expression] = STATE(2844),
    [sym_math_expression] = STATE(2844),
    [sym_cast_expression] = STATE(2844),
    [sym_sizeof_expression] = STATE(2844),
    [sym_subscript_expression] = STATE(2844),
    [sym_call_expression] = STATE(2844),
    [sym_field_expression] = STATE(2844),
    [sym_compound_literal_expression] = STATE(2844),
    [sym_parenthesized_expression] = STATE(2844),
    [sym_concatenated_string] = STATE(2844),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(2844),
    [sym_for_range_loop] = STATE(3167),
    [sym_new_expression] = STATE(2844),
    [sym_delete_expression] = STATE(2844),
    [sym_lambda_expression] = STATE(2844),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(6732),
    [anon_sym_LPAREN] = ACTIONS(626),
    [anon_sym_SEMI] = ACTIONS(6734),
    [anon_sym_LBRACE] = ACTIONS(6736),
    [anon_sym_STAR] = ACTIONS(644),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_if] = ACTIONS(6738),
    [anon_sym_switch] = ACTIONS(6740),
    [anon_sym_case] = ACTIONS(6742),
    [anon_sym_default] = ACTIONS(6744),
    [anon_sym_while] = ACTIONS(6746),
    [anon_sym_do] = ACTIONS(6748),
    [anon_sym_for] = ACTIONS(6750),
    [anon_sym_return] = ACTIONS(6752),
    [anon_sym_break] = ACTIONS(6754),
    [anon_sym_continue] = ACTIONS(6756),
    [anon_sym_goto] = ACTIONS(6758),
    [anon_sym_AMP] = ACTIONS(644),
    [anon_sym_BANG] = ACTIONS(668),
    [anon_sym_TILDE] = ACTIONS(670),
    [anon_sym_PLUS] = ACTIONS(672),
    [anon_sym_DASH] = ACTIONS(672),
    [anon_sym_DASH_DASH] = ACTIONS(674),
    [anon_sym_PLUS_PLUS] = ACTIONS(674),
    [anon_sym_sizeof] = ACTIONS(676),
    [sym_number_literal] = ACTIONS(6732),
    [sym_char_literal] = ACTIONS(6732),
    [sym_string_literal] = ACTIONS(678),
    [sym_true] = ACTIONS(6760),
    [sym_false] = ACTIONS(6760),
    [sym_null] = ACTIONS(6760),
    [sym_identifier] = ACTIONS(6762),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1303),
    [anon_sym_delete] = ACTIONS(686),
    [sym_nullptr] = ACTIONS(6760),
  },
  [3131] = {
    [sym_raw_string_literal] = ACTIONS(6277),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(6279),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(6279),
    [anon_sym_LPAREN] = ACTIONS(6277),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(6279),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(6279),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(6279),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(6279),
    [sym_preproc_directive] = ACTIONS(6279),
    [anon_sym_SEMI] = ACTIONS(6277),
    [anon_sym_typedef] = ACTIONS(6279),
    [anon_sym_extern] = ACTIONS(6279),
    [anon_sym_LBRACE] = ACTIONS(6277),
    [anon_sym_STAR] = ACTIONS(6277),
    [anon_sym_LBRACK] = ACTIONS(6277),
    [anon_sym_static] = ACTIONS(6279),
    [anon_sym_register] = ACTIONS(6279),
    [anon_sym_inline] = ACTIONS(6279),
    [anon_sym_const] = ACTIONS(6279),
    [anon_sym_restrict] = ACTIONS(6279),
    [anon_sym_volatile] = ACTIONS(6279),
    [anon_sym__Atomic] = ACTIONS(6279),
    [anon_sym_mutable] = ACTIONS(6279),
    [anon_sym_explicit] = ACTIONS(6279),
    [anon_sym_constexpr] = ACTIONS(6279),
    [anon_sym_unsigned] = ACTIONS(6279),
    [anon_sym_long] = ACTIONS(6279),
    [anon_sym_short] = ACTIONS(6279),
    [sym_primitive_type] = ACTIONS(6279),
    [anon_sym_enum] = ACTIONS(6279),
    [anon_sym_struct] = ACTIONS(6279),
    [anon_sym_union] = ACTIONS(6279),
    [anon_sym_if] = ACTIONS(6279),
    [anon_sym_else] = ACTIONS(6279),
    [anon_sym_switch] = ACTIONS(6279),
    [anon_sym_case] = ACTIONS(6279),
    [anon_sym_default] = ACTIONS(6279),
    [anon_sym_while] = ACTIONS(6279),
    [anon_sym_do] = ACTIONS(6279),
    [anon_sym_for] = ACTIONS(6279),
    [anon_sym_return] = ACTIONS(6279),
    [anon_sym_break] = ACTIONS(6279),
    [anon_sym_continue] = ACTIONS(6279),
    [anon_sym_goto] = ACTIONS(6279),
    [anon_sym_AMP] = ACTIONS(6277),
    [anon_sym_BANG] = ACTIONS(6277),
    [anon_sym_TILDE] = ACTIONS(6277),
    [anon_sym_PLUS] = ACTIONS(6279),
    [anon_sym_DASH] = ACTIONS(6279),
    [anon_sym_DASH_DASH] = ACTIONS(6277),
    [anon_sym_PLUS_PLUS] = ACTIONS(6277),
    [anon_sym_sizeof] = ACTIONS(6279),
    [sym_number_literal] = ACTIONS(6277),
    [sym_char_literal] = ACTIONS(6277),
    [sym_string_literal] = ACTIONS(6277),
    [sym_true] = ACTIONS(6279),
    [sym_false] = ACTIONS(6279),
    [sym_null] = ACTIONS(6279),
    [sym_identifier] = ACTIONS(6279),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(6279),
    [sym_auto] = ACTIONS(6279),
    [anon_sym_typename] = ACTIONS(6279),
    [anon_sym_new] = ACTIONS(6279),
    [anon_sym_COLON_COLON] = ACTIONS(6277),
    [anon_sym_delete] = ACTIONS(6279),
    [sym_nullptr] = ACTIONS(6279),
  },
  [3132] = {
    [sym_parameter_list] = STATE(513),
    [anon_sym_LPAREN] = ACTIONS(206),
    [anon_sym_SEMI] = ACTIONS(7354),
    [anon_sym_LBRACK] = ACTIONS(955),
    [sym_comment] = ACTIONS(49),
  },
  [3133] = {
    [sym__type_declarator] = STATE(3169),
    [sym_pointer_type_declarator] = STATE(213),
    [sym_function_type_declarator] = STATE(214),
    [sym_array_type_declarator] = STATE(215),
    [anon_sym_LPAREN] = ACTIONS(327),
    [anon_sym_STAR] = ACTIONS(329),
    [sym_identifier] = ACTIONS(331),
    [sym_comment] = ACTIONS(49),
  },
  [3134] = {
    [sym_raw_string_literal] = ACTIONS(1261),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1263),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1263),
    [anon_sym_LPAREN] = ACTIONS(1261),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1263),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(1263),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1263),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1263),
    [sym_preproc_directive] = ACTIONS(1263),
    [anon_sym_SEMI] = ACTIONS(1261),
    [anon_sym_typedef] = ACTIONS(1263),
    [anon_sym_extern] = ACTIONS(1263),
    [anon_sym_LBRACE] = ACTIONS(1261),
    [anon_sym_STAR] = ACTIONS(1261),
    [anon_sym_LBRACK] = ACTIONS(1261),
    [anon_sym_static] = ACTIONS(1263),
    [anon_sym_register] = ACTIONS(1263),
    [anon_sym_inline] = ACTIONS(1263),
    [anon_sym_const] = ACTIONS(1263),
    [anon_sym_restrict] = ACTIONS(1263),
    [anon_sym_volatile] = ACTIONS(1263),
    [anon_sym__Atomic] = ACTIONS(1263),
    [anon_sym_mutable] = ACTIONS(1263),
    [anon_sym_explicit] = ACTIONS(1263),
    [anon_sym_constexpr] = ACTIONS(1263),
    [anon_sym_unsigned] = ACTIONS(1263),
    [anon_sym_long] = ACTIONS(1263),
    [anon_sym_short] = ACTIONS(1263),
    [sym_primitive_type] = ACTIONS(1263),
    [anon_sym_enum] = ACTIONS(1263),
    [anon_sym_struct] = ACTIONS(1263),
    [anon_sym_union] = ACTIONS(1263),
    [anon_sym_if] = ACTIONS(1263),
    [anon_sym_else] = ACTIONS(1263),
    [anon_sym_switch] = ACTIONS(1263),
    [anon_sym_case] = ACTIONS(1263),
    [anon_sym_default] = ACTIONS(1263),
    [anon_sym_while] = ACTIONS(1263),
    [anon_sym_do] = ACTIONS(1263),
    [anon_sym_for] = ACTIONS(1263),
    [anon_sym_return] = ACTIONS(1263),
    [anon_sym_break] = ACTIONS(1263),
    [anon_sym_continue] = ACTIONS(1263),
    [anon_sym_goto] = ACTIONS(1263),
    [anon_sym_AMP] = ACTIONS(1261),
    [anon_sym_BANG] = ACTIONS(1261),
    [anon_sym_TILDE] = ACTIONS(1261),
    [anon_sym_PLUS] = ACTIONS(1263),
    [anon_sym_DASH] = ACTIONS(1263),
    [anon_sym_DASH_DASH] = ACTIONS(1261),
    [anon_sym_PLUS_PLUS] = ACTIONS(1261),
    [anon_sym_sizeof] = ACTIONS(1263),
    [sym_number_literal] = ACTIONS(1261),
    [sym_char_literal] = ACTIONS(1261),
    [sym_string_literal] = ACTIONS(1261),
    [sym_true] = ACTIONS(1263),
    [sym_false] = ACTIONS(1263),
    [sym_null] = ACTIONS(1263),
    [sym_identifier] = ACTIONS(1263),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(1263),
    [sym_auto] = ACTIONS(1263),
    [anon_sym_typename] = ACTIONS(1263),
    [anon_sym_new] = ACTIONS(1263),
    [anon_sym_COLON_COLON] = ACTIONS(1261),
    [anon_sym_delete] = ACTIONS(1263),
    [sym_nullptr] = ACTIONS(1263),
  },
  [3135] = {
    [aux_sym_declaration_repeat1] = STATE(678),
    [anon_sym_COMMA] = ACTIONS(538),
    [anon_sym_SEMI] = ACTIONS(7356),
    [sym_comment] = ACTIONS(49),
  },
  [3136] = {
    [sym_raw_string_literal] = ACTIONS(6293),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(6295),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(6295),
    [anon_sym_LPAREN] = ACTIONS(6293),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(6295),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(6295),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(6295),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(6295),
    [sym_preproc_directive] = ACTIONS(6295),
    [anon_sym_SEMI] = ACTIONS(6293),
    [anon_sym_typedef] = ACTIONS(6295),
    [anon_sym_extern] = ACTIONS(6295),
    [anon_sym_LBRACE] = ACTIONS(6293),
    [anon_sym_STAR] = ACTIONS(6293),
    [anon_sym_LBRACK] = ACTIONS(6293),
    [anon_sym_static] = ACTIONS(6295),
    [anon_sym_register] = ACTIONS(6295),
    [anon_sym_inline] = ACTIONS(6295),
    [anon_sym_const] = ACTIONS(6295),
    [anon_sym_restrict] = ACTIONS(6295),
    [anon_sym_volatile] = ACTIONS(6295),
    [anon_sym__Atomic] = ACTIONS(6295),
    [anon_sym_mutable] = ACTIONS(6295),
    [anon_sym_explicit] = ACTIONS(6295),
    [anon_sym_constexpr] = ACTIONS(6295),
    [anon_sym_unsigned] = ACTIONS(6295),
    [anon_sym_long] = ACTIONS(6295),
    [anon_sym_short] = ACTIONS(6295),
    [sym_primitive_type] = ACTIONS(6295),
    [anon_sym_enum] = ACTIONS(6295),
    [anon_sym_struct] = ACTIONS(6295),
    [anon_sym_union] = ACTIONS(6295),
    [anon_sym_if] = ACTIONS(6295),
    [anon_sym_else] = ACTIONS(6295),
    [anon_sym_switch] = ACTIONS(6295),
    [anon_sym_case] = ACTIONS(6295),
    [anon_sym_default] = ACTIONS(6295),
    [anon_sym_while] = ACTIONS(6295),
    [anon_sym_do] = ACTIONS(6295),
    [anon_sym_for] = ACTIONS(6295),
    [anon_sym_return] = ACTIONS(6295),
    [anon_sym_break] = ACTIONS(6295),
    [anon_sym_continue] = ACTIONS(6295),
    [anon_sym_goto] = ACTIONS(6295),
    [anon_sym_AMP] = ACTIONS(6293),
    [anon_sym_BANG] = ACTIONS(6293),
    [anon_sym_TILDE] = ACTIONS(6293),
    [anon_sym_PLUS] = ACTIONS(6295),
    [anon_sym_DASH] = ACTIONS(6295),
    [anon_sym_DASH_DASH] = ACTIONS(6293),
    [anon_sym_PLUS_PLUS] = ACTIONS(6293),
    [anon_sym_sizeof] = ACTIONS(6295),
    [sym_number_literal] = ACTIONS(6293),
    [sym_char_literal] = ACTIONS(6293),
    [sym_string_literal] = ACTIONS(6293),
    [sym_true] = ACTIONS(6295),
    [sym_false] = ACTIONS(6295),
    [sym_null] = ACTIONS(6295),
    [sym_identifier] = ACTIONS(6295),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(6295),
    [sym_auto] = ACTIONS(6295),
    [anon_sym_typename] = ACTIONS(6295),
    [anon_sym_new] = ACTIONS(6295),
    [anon_sym_COLON_COLON] = ACTIONS(6293),
    [anon_sym_delete] = ACTIONS(6295),
    [sym_nullptr] = ACTIONS(6295),
  },
  [3137] = {
    [sym_argument_list] = STATE(802),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_RPAREN] = ACTIONS(7358),
    [anon_sym_STAR] = ACTIONS(4537),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_EQ] = ACTIONS(4539),
    [anon_sym_QMARK] = ACTIONS(4541),
    [anon_sym_STAR_EQ] = ACTIONS(4543),
    [anon_sym_SLASH_EQ] = ACTIONS(4543),
    [anon_sym_PERCENT_EQ] = ACTIONS(4543),
    [anon_sym_PLUS_EQ] = ACTIONS(4543),
    [anon_sym_DASH_EQ] = ACTIONS(4543),
    [anon_sym_LT_LT_EQ] = ACTIONS(4543),
    [anon_sym_GT_GT_EQ] = ACTIONS(4543),
    [anon_sym_AMP_EQ] = ACTIONS(4543),
    [anon_sym_CARET_EQ] = ACTIONS(4543),
    [anon_sym_PIPE_EQ] = ACTIONS(4543),
    [anon_sym_AMP] = ACTIONS(4545),
    [anon_sym_PIPE_PIPE] = ACTIONS(4547),
    [anon_sym_AMP_AMP] = ACTIONS(4549),
    [anon_sym_PIPE] = ACTIONS(4551),
    [anon_sym_CARET] = ACTIONS(4553),
    [anon_sym_EQ_EQ] = ACTIONS(4555),
    [anon_sym_BANG_EQ] = ACTIONS(4555),
    [anon_sym_LT] = ACTIONS(4557),
    [anon_sym_GT] = ACTIONS(4557),
    [anon_sym_LT_EQ] = ACTIONS(4559),
    [anon_sym_GT_EQ] = ACTIONS(4559),
    [anon_sym_LT_LT] = ACTIONS(4561),
    [anon_sym_GT_GT] = ACTIONS(4561),
    [anon_sym_PLUS] = ACTIONS(4563),
    [anon_sym_DASH] = ACTIONS(4563),
    [anon_sym_SLASH] = ACTIONS(4537),
    [anon_sym_PERCENT] = ACTIONS(4537),
    [anon_sym_DASH_DASH] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(1554),
    [anon_sym_DASH_GT] = ACTIONS(1554),
    [sym_comment] = ACTIONS(49),
  },
  [3138] = {
    [sym_compound_statement] = STATE(3172),
    [sym_labeled_statement] = STATE(3172),
    [sym_expression_statement] = STATE(3172),
    [sym_if_statement] = STATE(3172),
    [sym_switch_statement] = STATE(3172),
    [sym_case_statement] = STATE(3172),
    [sym_while_statement] = STATE(3172),
    [sym_do_statement] = STATE(3172),
    [sym_for_statement] = STATE(3172),
    [sym_return_statement] = STATE(3172),
    [sym_break_statement] = STATE(3172),
    [sym_continue_statement] = STATE(3172),
    [sym_goto_statement] = STATE(3172),
    [sym__expression] = STATE(2844),
    [sym_comma_expression] = STATE(2845),
    [sym_conditional_expression] = STATE(2844),
    [sym_assignment_expression] = STATE(2844),
    [sym_pointer_expression] = STATE(2844),
    [sym_logical_expression] = STATE(2844),
    [sym_bitwise_expression] = STATE(2844),
    [sym_equality_expression] = STATE(2844),
    [sym_relational_expression] = STATE(2844),
    [sym_shift_expression] = STATE(2844),
    [sym_math_expression] = STATE(2844),
    [sym_cast_expression] = STATE(2844),
    [sym_sizeof_expression] = STATE(2844),
    [sym_subscript_expression] = STATE(2844),
    [sym_call_expression] = STATE(2844),
    [sym_field_expression] = STATE(2844),
    [sym_compound_literal_expression] = STATE(2844),
    [sym_parenthesized_expression] = STATE(2844),
    [sym_concatenated_string] = STATE(2844),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(2844),
    [sym_for_range_loop] = STATE(3172),
    [sym_new_expression] = STATE(2844),
    [sym_delete_expression] = STATE(2844),
    [sym_lambda_expression] = STATE(2844),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(6732),
    [anon_sym_LPAREN] = ACTIONS(626),
    [anon_sym_SEMI] = ACTIONS(6734),
    [anon_sym_LBRACE] = ACTIONS(6736),
    [anon_sym_STAR] = ACTIONS(644),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_if] = ACTIONS(6738),
    [anon_sym_switch] = ACTIONS(6740),
    [anon_sym_case] = ACTIONS(6742),
    [anon_sym_default] = ACTIONS(6744),
    [anon_sym_while] = ACTIONS(6746),
    [anon_sym_do] = ACTIONS(6748),
    [anon_sym_for] = ACTIONS(6750),
    [anon_sym_return] = ACTIONS(6752),
    [anon_sym_break] = ACTIONS(6754),
    [anon_sym_continue] = ACTIONS(6756),
    [anon_sym_goto] = ACTIONS(6758),
    [anon_sym_AMP] = ACTIONS(644),
    [anon_sym_BANG] = ACTIONS(668),
    [anon_sym_TILDE] = ACTIONS(670),
    [anon_sym_PLUS] = ACTIONS(672),
    [anon_sym_DASH] = ACTIONS(672),
    [anon_sym_DASH_DASH] = ACTIONS(674),
    [anon_sym_PLUS_PLUS] = ACTIONS(674),
    [anon_sym_sizeof] = ACTIONS(676),
    [sym_number_literal] = ACTIONS(6732),
    [sym_char_literal] = ACTIONS(6732),
    [sym_string_literal] = ACTIONS(678),
    [sym_true] = ACTIONS(6760),
    [sym_false] = ACTIONS(6760),
    [sym_null] = ACTIONS(6760),
    [sym_identifier] = ACTIONS(6762),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1303),
    [anon_sym_delete] = ACTIONS(686),
    [sym_nullptr] = ACTIONS(6760),
  },
  [3139] = {
    [sym_argument_list] = STATE(802),
    [aux_sym_for_statement_repeat1] = STATE(3174),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_COMMA] = ACTIONS(6339),
    [anon_sym_RPAREN] = ACTIONS(7360),
    [anon_sym_STAR] = ACTIONS(2234),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_EQ] = ACTIONS(2236),
    [anon_sym_QMARK] = ACTIONS(2238),
    [anon_sym_STAR_EQ] = ACTIONS(2240),
    [anon_sym_SLASH_EQ] = ACTIONS(2240),
    [anon_sym_PERCENT_EQ] = ACTIONS(2240),
    [anon_sym_PLUS_EQ] = ACTIONS(2240),
    [anon_sym_DASH_EQ] = ACTIONS(2240),
    [anon_sym_LT_LT_EQ] = ACTIONS(2240),
    [anon_sym_GT_GT_EQ] = ACTIONS(2240),
    [anon_sym_AMP_EQ] = ACTIONS(2240),
    [anon_sym_CARET_EQ] = ACTIONS(2240),
    [anon_sym_PIPE_EQ] = ACTIONS(2240),
    [anon_sym_AMP] = ACTIONS(2242),
    [anon_sym_PIPE_PIPE] = ACTIONS(2244),
    [anon_sym_AMP_AMP] = ACTIONS(2246),
    [anon_sym_PIPE] = ACTIONS(2248),
    [anon_sym_CARET] = ACTIONS(2250),
    [anon_sym_EQ_EQ] = ACTIONS(2252),
    [anon_sym_BANG_EQ] = ACTIONS(2252),
    [anon_sym_LT] = ACTIONS(2254),
    [anon_sym_GT] = ACTIONS(2254),
    [anon_sym_LT_EQ] = ACTIONS(2256),
    [anon_sym_GT_EQ] = ACTIONS(2256),
    [anon_sym_LT_LT] = ACTIONS(2258),
    [anon_sym_GT_GT] = ACTIONS(2258),
    [anon_sym_PLUS] = ACTIONS(2260),
    [anon_sym_DASH] = ACTIONS(2260),
    [anon_sym_SLASH] = ACTIONS(2234),
    [anon_sym_PERCENT] = ACTIONS(2234),
    [anon_sym_DASH_DASH] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(1554),
    [anon_sym_DASH_GT] = ACTIONS(1554),
    [sym_comment] = ACTIONS(49),
  },
  [3140] = {
    [sym__expression] = STATE(3175),
    [sym_conditional_expression] = STATE(3175),
    [sym_assignment_expression] = STATE(3175),
    [sym_pointer_expression] = STATE(3175),
    [sym_logical_expression] = STATE(3175),
    [sym_bitwise_expression] = STATE(3175),
    [sym_equality_expression] = STATE(3175),
    [sym_relational_expression] = STATE(3175),
    [sym_shift_expression] = STATE(3175),
    [sym_math_expression] = STATE(3175),
    [sym_cast_expression] = STATE(3175),
    [sym_sizeof_expression] = STATE(3175),
    [sym_subscript_expression] = STATE(3175),
    [sym_call_expression] = STATE(3175),
    [sym_field_expression] = STATE(3175),
    [sym_compound_literal_expression] = STATE(3175),
    [sym_parenthesized_expression] = STATE(3175),
    [sym_concatenated_string] = STATE(3175),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(3175),
    [sym_new_expression] = STATE(3175),
    [sym_delete_expression] = STATE(3175),
    [sym_lambda_expression] = STATE(3175),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(7362),
    [anon_sym_LPAREN] = ACTIONS(1087),
    [anon_sym_RPAREN] = ACTIONS(7360),
    [anon_sym_STAR] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_AMP] = ACTIONS(1089),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1093),
    [anon_sym_PLUS] = ACTIONS(1095),
    [anon_sym_DASH] = ACTIONS(1095),
    [anon_sym_DASH_DASH] = ACTIONS(1097),
    [anon_sym_PLUS_PLUS] = ACTIONS(1097),
    [anon_sym_sizeof] = ACTIONS(1099),
    [sym_number_literal] = ACTIONS(7362),
    [sym_char_literal] = ACTIONS(7362),
    [sym_string_literal] = ACTIONS(1101),
    [sym_true] = ACTIONS(7364),
    [sym_false] = ACTIONS(7364),
    [sym_null] = ACTIONS(7364),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_delete] = ACTIONS(1109),
    [sym_nullptr] = ACTIONS(7364),
  },
  [3141] = {
    [sym_argument_list] = STATE(802),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_SEMI] = ACTIONS(7366),
    [anon_sym_STAR] = ACTIONS(2553),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_EQ] = ACTIONS(2555),
    [anon_sym_QMARK] = ACTIONS(2557),
    [anon_sym_STAR_EQ] = ACTIONS(2559),
    [anon_sym_SLASH_EQ] = ACTIONS(2559),
    [anon_sym_PERCENT_EQ] = ACTIONS(2559),
    [anon_sym_PLUS_EQ] = ACTIONS(2559),
    [anon_sym_DASH_EQ] = ACTIONS(2559),
    [anon_sym_LT_LT_EQ] = ACTIONS(2559),
    [anon_sym_GT_GT_EQ] = ACTIONS(2559),
    [anon_sym_AMP_EQ] = ACTIONS(2559),
    [anon_sym_CARET_EQ] = ACTIONS(2559),
    [anon_sym_PIPE_EQ] = ACTIONS(2559),
    [anon_sym_AMP] = ACTIONS(2561),
    [anon_sym_PIPE_PIPE] = ACTIONS(2563),
    [anon_sym_AMP_AMP] = ACTIONS(2565),
    [anon_sym_PIPE] = ACTIONS(2567),
    [anon_sym_CARET] = ACTIONS(2569),
    [anon_sym_EQ_EQ] = ACTIONS(2571),
    [anon_sym_BANG_EQ] = ACTIONS(2571),
    [anon_sym_LT] = ACTIONS(2573),
    [anon_sym_GT] = ACTIONS(2573),
    [anon_sym_LT_EQ] = ACTIONS(2575),
    [anon_sym_GT_EQ] = ACTIONS(2575),
    [anon_sym_LT_LT] = ACTIONS(2577),
    [anon_sym_GT_GT] = ACTIONS(2577),
    [anon_sym_PLUS] = ACTIONS(2579),
    [anon_sym_DASH] = ACTIONS(2579),
    [anon_sym_SLASH] = ACTIONS(2553),
    [anon_sym_PERCENT] = ACTIONS(2553),
    [anon_sym_DASH_DASH] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(1554),
    [anon_sym_DASH_GT] = ACTIONS(1554),
    [sym_comment] = ACTIONS(49),
  },
  [3142] = {
    [sym_argument_list] = STATE(802),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_RPAREN] = ACTIONS(7368),
    [anon_sym_STAR] = ACTIONS(4537),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_EQ] = ACTIONS(4539),
    [anon_sym_QMARK] = ACTIONS(4541),
    [anon_sym_STAR_EQ] = ACTIONS(4543),
    [anon_sym_SLASH_EQ] = ACTIONS(4543),
    [anon_sym_PERCENT_EQ] = ACTIONS(4543),
    [anon_sym_PLUS_EQ] = ACTIONS(4543),
    [anon_sym_DASH_EQ] = ACTIONS(4543),
    [anon_sym_LT_LT_EQ] = ACTIONS(4543),
    [anon_sym_GT_GT_EQ] = ACTIONS(4543),
    [anon_sym_AMP_EQ] = ACTIONS(4543),
    [anon_sym_CARET_EQ] = ACTIONS(4543),
    [anon_sym_PIPE_EQ] = ACTIONS(4543),
    [anon_sym_AMP] = ACTIONS(4545),
    [anon_sym_PIPE_PIPE] = ACTIONS(4547),
    [anon_sym_AMP_AMP] = ACTIONS(4549),
    [anon_sym_PIPE] = ACTIONS(4551),
    [anon_sym_CARET] = ACTIONS(4553),
    [anon_sym_EQ_EQ] = ACTIONS(4555),
    [anon_sym_BANG_EQ] = ACTIONS(4555),
    [anon_sym_LT] = ACTIONS(4557),
    [anon_sym_GT] = ACTIONS(4557),
    [anon_sym_LT_EQ] = ACTIONS(4559),
    [anon_sym_GT_EQ] = ACTIONS(4559),
    [anon_sym_LT_LT] = ACTIONS(4561),
    [anon_sym_GT_GT] = ACTIONS(4561),
    [anon_sym_PLUS] = ACTIONS(4563),
    [anon_sym_DASH] = ACTIONS(4563),
    [anon_sym_SLASH] = ACTIONS(4537),
    [anon_sym_PERCENT] = ACTIONS(4537),
    [anon_sym_DASH_DASH] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(1554),
    [anon_sym_DASH_GT] = ACTIONS(1554),
    [sym_comment] = ACTIONS(49),
  },
  [3143] = {
    [sym_raw_string_literal] = ACTIONS(7202),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(7204),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(7204),
    [anon_sym_LPAREN] = ACTIONS(7202),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(7204),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(7204),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(7204),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(7204),
    [sym_preproc_directive] = ACTIONS(7204),
    [anon_sym_SEMI] = ACTIONS(7202),
    [anon_sym_typedef] = ACTIONS(7204),
    [anon_sym_extern] = ACTIONS(7204),
    [anon_sym_LBRACE] = ACTIONS(7202),
    [anon_sym_STAR] = ACTIONS(7202),
    [anon_sym_LBRACK] = ACTIONS(7202),
    [anon_sym_static] = ACTIONS(7204),
    [anon_sym_register] = ACTIONS(7204),
    [anon_sym_inline] = ACTIONS(7204),
    [anon_sym_const] = ACTIONS(7204),
    [anon_sym_restrict] = ACTIONS(7204),
    [anon_sym_volatile] = ACTIONS(7204),
    [anon_sym__Atomic] = ACTIONS(7204),
    [anon_sym_mutable] = ACTIONS(7204),
    [anon_sym_explicit] = ACTIONS(7204),
    [anon_sym_constexpr] = ACTIONS(7204),
    [anon_sym_unsigned] = ACTIONS(7204),
    [anon_sym_long] = ACTIONS(7204),
    [anon_sym_short] = ACTIONS(7204),
    [sym_primitive_type] = ACTIONS(7204),
    [anon_sym_enum] = ACTIONS(7204),
    [anon_sym_struct] = ACTIONS(7204),
    [anon_sym_union] = ACTIONS(7204),
    [anon_sym_if] = ACTIONS(7204),
    [anon_sym_switch] = ACTIONS(7204),
    [anon_sym_case] = ACTIONS(7204),
    [anon_sym_default] = ACTIONS(7204),
    [anon_sym_while] = ACTIONS(7204),
    [anon_sym_do] = ACTIONS(7204),
    [anon_sym_for] = ACTIONS(7204),
    [anon_sym_return] = ACTIONS(7204),
    [anon_sym_break] = ACTIONS(7204),
    [anon_sym_continue] = ACTIONS(7204),
    [anon_sym_goto] = ACTIONS(7204),
    [anon_sym_AMP] = ACTIONS(7202),
    [anon_sym_BANG] = ACTIONS(7202),
    [anon_sym_TILDE] = ACTIONS(7202),
    [anon_sym_PLUS] = ACTIONS(7204),
    [anon_sym_DASH] = ACTIONS(7204),
    [anon_sym_DASH_DASH] = ACTIONS(7202),
    [anon_sym_PLUS_PLUS] = ACTIONS(7202),
    [anon_sym_sizeof] = ACTIONS(7204),
    [sym_number_literal] = ACTIONS(7202),
    [sym_char_literal] = ACTIONS(7202),
    [sym_string_literal] = ACTIONS(7202),
    [sym_true] = ACTIONS(7204),
    [sym_false] = ACTIONS(7204),
    [sym_null] = ACTIONS(7204),
    [sym_identifier] = ACTIONS(7204),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(7204),
    [sym_auto] = ACTIONS(7204),
    [anon_sym_typename] = ACTIONS(7204),
    [anon_sym_new] = ACTIONS(7204),
    [anon_sym_COLON_COLON] = ACTIONS(7202),
    [anon_sym_delete] = ACTIONS(7204),
    [sym_nullptr] = ACTIONS(7204),
  },
  [3144] = {
    [sym_compound_statement] = STATE(3178),
    [sym_labeled_statement] = STATE(3178),
    [sym_expression_statement] = STATE(3178),
    [sym_if_statement] = STATE(3178),
    [sym_switch_statement] = STATE(3178),
    [sym_case_statement] = STATE(3178),
    [sym_while_statement] = STATE(3178),
    [sym_do_statement] = STATE(3178),
    [sym_for_statement] = STATE(3178),
    [sym_return_statement] = STATE(3178),
    [sym_break_statement] = STATE(3178),
    [sym_continue_statement] = STATE(3178),
    [sym_goto_statement] = STATE(3178),
    [sym__expression] = STATE(1947),
    [sym_comma_expression] = STATE(1948),
    [sym_conditional_expression] = STATE(1947),
    [sym_assignment_expression] = STATE(1947),
    [sym_pointer_expression] = STATE(1947),
    [sym_logical_expression] = STATE(1947),
    [sym_bitwise_expression] = STATE(1947),
    [sym_equality_expression] = STATE(1947),
    [sym_relational_expression] = STATE(1947),
    [sym_shift_expression] = STATE(1947),
    [sym_math_expression] = STATE(1947),
    [sym_cast_expression] = STATE(1947),
    [sym_sizeof_expression] = STATE(1947),
    [sym_subscript_expression] = STATE(1947),
    [sym_call_expression] = STATE(1947),
    [sym_field_expression] = STATE(1947),
    [sym_compound_literal_expression] = STATE(1947),
    [sym_parenthesized_expression] = STATE(1947),
    [sym_concatenated_string] = STATE(1947),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(1947),
    [sym_for_range_loop] = STATE(3178),
    [sym_new_expression] = STATE(1947),
    [sym_delete_expression] = STATE(1947),
    [sym_lambda_expression] = STATE(1947),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(4395),
    [anon_sym_LPAREN] = ACTIONS(626),
    [anon_sym_SEMI] = ACTIONS(4411),
    [anon_sym_LBRACE] = ACTIONS(4415),
    [anon_sym_STAR] = ACTIONS(644),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_if] = ACTIONS(4417),
    [anon_sym_switch] = ACTIONS(4419),
    [anon_sym_case] = ACTIONS(4421),
    [anon_sym_default] = ACTIONS(4423),
    [anon_sym_while] = ACTIONS(4425),
    [anon_sym_do] = ACTIONS(4427),
    [anon_sym_for] = ACTIONS(4429),
    [anon_sym_return] = ACTIONS(4431),
    [anon_sym_break] = ACTIONS(4433),
    [anon_sym_continue] = ACTIONS(4435),
    [anon_sym_goto] = ACTIONS(4437),
    [anon_sym_AMP] = ACTIONS(644),
    [anon_sym_BANG] = ACTIONS(668),
    [anon_sym_TILDE] = ACTIONS(670),
    [anon_sym_PLUS] = ACTIONS(672),
    [anon_sym_DASH] = ACTIONS(672),
    [anon_sym_DASH_DASH] = ACTIONS(674),
    [anon_sym_PLUS_PLUS] = ACTIONS(674),
    [anon_sym_sizeof] = ACTIONS(676),
    [sym_number_literal] = ACTIONS(4395),
    [sym_char_literal] = ACTIONS(4395),
    [sym_string_literal] = ACTIONS(678),
    [sym_true] = ACTIONS(4439),
    [sym_false] = ACTIONS(4439),
    [sym_null] = ACTIONS(4439),
    [sym_identifier] = ACTIONS(6077),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1303),
    [anon_sym_delete] = ACTIONS(686),
    [sym_nullptr] = ACTIONS(4439),
  },
  [3145] = {
    [sym_compound_statement] = STATE(3179),
    [sym_labeled_statement] = STATE(3179),
    [sym_expression_statement] = STATE(3179),
    [sym_if_statement] = STATE(3179),
    [sym_switch_statement] = STATE(3179),
    [sym_case_statement] = STATE(3179),
    [sym_while_statement] = STATE(3179),
    [sym_do_statement] = STATE(3179),
    [sym_for_statement] = STATE(3179),
    [sym_return_statement] = STATE(3179),
    [sym_break_statement] = STATE(3179),
    [sym_continue_statement] = STATE(3179),
    [sym_goto_statement] = STATE(3179),
    [sym__expression] = STATE(2739),
    [sym_comma_expression] = STATE(2740),
    [sym_conditional_expression] = STATE(2739),
    [sym_assignment_expression] = STATE(2739),
    [sym_pointer_expression] = STATE(2739),
    [sym_logical_expression] = STATE(2739),
    [sym_bitwise_expression] = STATE(2739),
    [sym_equality_expression] = STATE(2739),
    [sym_relational_expression] = STATE(2739),
    [sym_shift_expression] = STATE(2739),
    [sym_math_expression] = STATE(2739),
    [sym_cast_expression] = STATE(2739),
    [sym_sizeof_expression] = STATE(2739),
    [sym_subscript_expression] = STATE(2739),
    [sym_call_expression] = STATE(2739),
    [sym_field_expression] = STATE(2739),
    [sym_compound_literal_expression] = STATE(2739),
    [sym_parenthesized_expression] = STATE(2739),
    [sym_concatenated_string] = STATE(2739),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(2739),
    [sym_for_range_loop] = STATE(3179),
    [sym_new_expression] = STATE(2739),
    [sym_delete_expression] = STATE(2739),
    [sym_lambda_expression] = STATE(2739),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(6507),
    [anon_sym_LPAREN] = ACTIONS(626),
    [anon_sym_SEMI] = ACTIONS(6509),
    [anon_sym_LBRACE] = ACTIONS(6511),
    [anon_sym_STAR] = ACTIONS(644),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_if] = ACTIONS(6513),
    [anon_sym_switch] = ACTIONS(6515),
    [anon_sym_case] = ACTIONS(6517),
    [anon_sym_default] = ACTIONS(6519),
    [anon_sym_while] = ACTIONS(6521),
    [anon_sym_do] = ACTIONS(6523),
    [anon_sym_for] = ACTIONS(6525),
    [anon_sym_return] = ACTIONS(6527),
    [anon_sym_break] = ACTIONS(6529),
    [anon_sym_continue] = ACTIONS(6531),
    [anon_sym_goto] = ACTIONS(6533),
    [anon_sym_AMP] = ACTIONS(644),
    [anon_sym_BANG] = ACTIONS(668),
    [anon_sym_TILDE] = ACTIONS(670),
    [anon_sym_PLUS] = ACTIONS(672),
    [anon_sym_DASH] = ACTIONS(672),
    [anon_sym_DASH_DASH] = ACTIONS(674),
    [anon_sym_PLUS_PLUS] = ACTIONS(674),
    [anon_sym_sizeof] = ACTIONS(676),
    [sym_number_literal] = ACTIONS(6507),
    [sym_char_literal] = ACTIONS(6507),
    [sym_string_literal] = ACTIONS(678),
    [sym_true] = ACTIONS(6535),
    [sym_false] = ACTIONS(6535),
    [sym_null] = ACTIONS(6535),
    [sym_identifier] = ACTIONS(6537),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1303),
    [anon_sym_delete] = ACTIONS(686),
    [sym_nullptr] = ACTIONS(6535),
  },
  [3146] = {
    [sym_raw_string_literal] = ACTIONS(6611),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(6613),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(6613),
    [anon_sym_LPAREN] = ACTIONS(6611),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(6613),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(6613),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(6613),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(6613),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(6613),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(6613),
    [sym_preproc_directive] = ACTIONS(6613),
    [anon_sym_SEMI] = ACTIONS(6611),
    [anon_sym_typedef] = ACTIONS(6613),
    [anon_sym_extern] = ACTIONS(6613),
    [anon_sym_LBRACE] = ACTIONS(6611),
    [anon_sym_STAR] = ACTIONS(6611),
    [anon_sym_LBRACK] = ACTIONS(6611),
    [anon_sym_static] = ACTIONS(6613),
    [anon_sym_register] = ACTIONS(6613),
    [anon_sym_inline] = ACTIONS(6613),
    [anon_sym_const] = ACTIONS(6613),
    [anon_sym_restrict] = ACTIONS(6613),
    [anon_sym_volatile] = ACTIONS(6613),
    [anon_sym__Atomic] = ACTIONS(6613),
    [anon_sym_mutable] = ACTIONS(6613),
    [anon_sym_explicit] = ACTIONS(6613),
    [anon_sym_constexpr] = ACTIONS(6613),
    [anon_sym_unsigned] = ACTIONS(6613),
    [anon_sym_long] = ACTIONS(6613),
    [anon_sym_short] = ACTIONS(6613),
    [sym_primitive_type] = ACTIONS(6613),
    [anon_sym_enum] = ACTIONS(6613),
    [anon_sym_struct] = ACTIONS(6613),
    [anon_sym_union] = ACTIONS(6613),
    [anon_sym_if] = ACTIONS(6613),
    [anon_sym_else] = ACTIONS(7370),
    [anon_sym_switch] = ACTIONS(6613),
    [anon_sym_case] = ACTIONS(6613),
    [anon_sym_default] = ACTIONS(6613),
    [anon_sym_while] = ACTIONS(6613),
    [anon_sym_do] = ACTIONS(6613),
    [anon_sym_for] = ACTIONS(6613),
    [anon_sym_return] = ACTIONS(6613),
    [anon_sym_break] = ACTIONS(6613),
    [anon_sym_continue] = ACTIONS(6613),
    [anon_sym_goto] = ACTIONS(6613),
    [anon_sym_AMP] = ACTIONS(6611),
    [anon_sym_BANG] = ACTIONS(6611),
    [anon_sym_TILDE] = ACTIONS(6611),
    [anon_sym_PLUS] = ACTIONS(6613),
    [anon_sym_DASH] = ACTIONS(6613),
    [anon_sym_DASH_DASH] = ACTIONS(6611),
    [anon_sym_PLUS_PLUS] = ACTIONS(6611),
    [anon_sym_sizeof] = ACTIONS(6613),
    [sym_number_literal] = ACTIONS(6611),
    [sym_char_literal] = ACTIONS(6611),
    [sym_string_literal] = ACTIONS(6611),
    [sym_true] = ACTIONS(6613),
    [sym_false] = ACTIONS(6613),
    [sym_null] = ACTIONS(6613),
    [sym_identifier] = ACTIONS(6613),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(6613),
    [sym_auto] = ACTIONS(6613),
    [anon_sym_typename] = ACTIONS(6613),
    [anon_sym_new] = ACTIONS(6613),
    [anon_sym_COLON_COLON] = ACTIONS(6611),
    [anon_sym_delete] = ACTIONS(6613),
    [sym_nullptr] = ACTIONS(6613),
  },
  [3147] = {
    [sym_raw_string_literal] = ACTIONS(1988),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1990),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1990),
    [anon_sym_LPAREN] = ACTIONS(1988),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1990),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(1990),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1990),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1990),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(1990),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(1990),
    [sym_preproc_directive] = ACTIONS(1990),
    [anon_sym_SEMI] = ACTIONS(1988),
    [anon_sym_typedef] = ACTIONS(1990),
    [anon_sym_extern] = ACTIONS(1990),
    [anon_sym_LBRACE] = ACTIONS(1988),
    [anon_sym_STAR] = ACTIONS(1988),
    [anon_sym_LBRACK] = ACTIONS(1988),
    [anon_sym_static] = ACTIONS(1990),
    [anon_sym_register] = ACTIONS(1990),
    [anon_sym_inline] = ACTIONS(1990),
    [anon_sym_const] = ACTIONS(1990),
    [anon_sym_restrict] = ACTIONS(1990),
    [anon_sym_volatile] = ACTIONS(1990),
    [anon_sym__Atomic] = ACTIONS(1990),
    [anon_sym_mutable] = ACTIONS(1990),
    [anon_sym_explicit] = ACTIONS(1990),
    [anon_sym_constexpr] = ACTIONS(1990),
    [anon_sym_unsigned] = ACTIONS(1990),
    [anon_sym_long] = ACTIONS(1990),
    [anon_sym_short] = ACTIONS(1990),
    [sym_primitive_type] = ACTIONS(1990),
    [anon_sym_enum] = ACTIONS(1990),
    [anon_sym_struct] = ACTIONS(1990),
    [anon_sym_union] = ACTIONS(1990),
    [anon_sym_if] = ACTIONS(1990),
    [anon_sym_else] = ACTIONS(1990),
    [anon_sym_switch] = ACTIONS(1990),
    [anon_sym_case] = ACTIONS(1990),
    [anon_sym_default] = ACTIONS(1990),
    [anon_sym_while] = ACTIONS(1990),
    [anon_sym_do] = ACTIONS(1990),
    [anon_sym_for] = ACTIONS(1990),
    [anon_sym_return] = ACTIONS(1990),
    [anon_sym_break] = ACTIONS(1990),
    [anon_sym_continue] = ACTIONS(1990),
    [anon_sym_goto] = ACTIONS(1990),
    [anon_sym_AMP] = ACTIONS(1988),
    [anon_sym_BANG] = ACTIONS(1988),
    [anon_sym_TILDE] = ACTIONS(1988),
    [anon_sym_PLUS] = ACTIONS(1990),
    [anon_sym_DASH] = ACTIONS(1990),
    [anon_sym_DASH_DASH] = ACTIONS(1988),
    [anon_sym_PLUS_PLUS] = ACTIONS(1988),
    [anon_sym_sizeof] = ACTIONS(1990),
    [sym_number_literal] = ACTIONS(1988),
    [sym_char_literal] = ACTIONS(1988),
    [sym_string_literal] = ACTIONS(1988),
    [sym_true] = ACTIONS(1990),
    [sym_false] = ACTIONS(1990),
    [sym_null] = ACTIONS(1990),
    [sym_identifier] = ACTIONS(1990),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(1990),
    [sym_auto] = ACTIONS(1990),
    [anon_sym_typename] = ACTIONS(1990),
    [anon_sym_new] = ACTIONS(1990),
    [anon_sym_COLON_COLON] = ACTIONS(1988),
    [anon_sym_delete] = ACTIONS(1990),
    [sym_nullptr] = ACTIONS(1990),
  },
  [3148] = {
    [sym_parameter_list] = STATE(513),
    [anon_sym_LPAREN] = ACTIONS(206),
    [anon_sym_SEMI] = ACTIONS(7372),
    [anon_sym_LBRACK] = ACTIONS(955),
    [sym_comment] = ACTIONS(49),
  },
  [3149] = {
    [sym_raw_string_literal] = ACTIONS(2478),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(2480),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(2480),
    [anon_sym_LPAREN] = ACTIONS(2478),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(2480),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(2480),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(2480),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(2480),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(2480),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(2480),
    [sym_preproc_directive] = ACTIONS(2480),
    [anon_sym_SEMI] = ACTIONS(2478),
    [anon_sym_typedef] = ACTIONS(2480),
    [anon_sym_extern] = ACTIONS(2480),
    [anon_sym_LBRACE] = ACTIONS(2478),
    [anon_sym_STAR] = ACTIONS(2478),
    [anon_sym_LBRACK] = ACTIONS(2478),
    [anon_sym_static] = ACTIONS(2480),
    [anon_sym_register] = ACTIONS(2480),
    [anon_sym_inline] = ACTIONS(2480),
    [anon_sym_const] = ACTIONS(2480),
    [anon_sym_restrict] = ACTIONS(2480),
    [anon_sym_volatile] = ACTIONS(2480),
    [anon_sym__Atomic] = ACTIONS(2480),
    [anon_sym_mutable] = ACTIONS(2480),
    [anon_sym_explicit] = ACTIONS(2480),
    [anon_sym_constexpr] = ACTIONS(2480),
    [anon_sym_unsigned] = ACTIONS(2480),
    [anon_sym_long] = ACTIONS(2480),
    [anon_sym_short] = ACTIONS(2480),
    [sym_primitive_type] = ACTIONS(2480),
    [anon_sym_enum] = ACTIONS(2480),
    [anon_sym_struct] = ACTIONS(2480),
    [anon_sym_union] = ACTIONS(2480),
    [anon_sym_if] = ACTIONS(2480),
    [anon_sym_else] = ACTIONS(2480),
    [anon_sym_switch] = ACTIONS(2480),
    [anon_sym_case] = ACTIONS(2480),
    [anon_sym_default] = ACTIONS(2480),
    [anon_sym_while] = ACTIONS(2480),
    [anon_sym_do] = ACTIONS(2480),
    [anon_sym_for] = ACTIONS(2480),
    [anon_sym_return] = ACTIONS(2480),
    [anon_sym_break] = ACTIONS(2480),
    [anon_sym_continue] = ACTIONS(2480),
    [anon_sym_goto] = ACTIONS(2480),
    [anon_sym_AMP] = ACTIONS(2478),
    [anon_sym_BANG] = ACTIONS(2478),
    [anon_sym_TILDE] = ACTIONS(2478),
    [anon_sym_PLUS] = ACTIONS(2480),
    [anon_sym_DASH] = ACTIONS(2480),
    [anon_sym_DASH_DASH] = ACTIONS(2478),
    [anon_sym_PLUS_PLUS] = ACTIONS(2478),
    [anon_sym_sizeof] = ACTIONS(2480),
    [sym_number_literal] = ACTIONS(2478),
    [sym_char_literal] = ACTIONS(2478),
    [sym_string_literal] = ACTIONS(2478),
    [sym_true] = ACTIONS(2480),
    [sym_false] = ACTIONS(2480),
    [sym_null] = ACTIONS(2480),
    [sym_identifier] = ACTIONS(2480),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(2480),
    [sym_auto] = ACTIONS(2480),
    [anon_sym_typename] = ACTIONS(2480),
    [anon_sym_new] = ACTIONS(2480),
    [anon_sym_COLON_COLON] = ACTIONS(2478),
    [anon_sym_delete] = ACTIONS(2480),
    [sym_nullptr] = ACTIONS(2480),
  },
  [3150] = {
    [sym_raw_string_literal] = ACTIONS(6653),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(6655),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(6655),
    [anon_sym_LPAREN] = ACTIONS(6653),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(6655),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(6655),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(6655),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(6655),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(6655),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(6655),
    [sym_preproc_directive] = ACTIONS(6655),
    [anon_sym_SEMI] = ACTIONS(6653),
    [anon_sym_typedef] = ACTIONS(6655),
    [anon_sym_extern] = ACTIONS(6655),
    [anon_sym_LBRACE] = ACTIONS(6653),
    [anon_sym_STAR] = ACTIONS(6653),
    [anon_sym_LBRACK] = ACTIONS(6653),
    [anon_sym_static] = ACTIONS(6655),
    [anon_sym_register] = ACTIONS(6655),
    [anon_sym_inline] = ACTIONS(6655),
    [anon_sym_const] = ACTIONS(6655),
    [anon_sym_restrict] = ACTIONS(6655),
    [anon_sym_volatile] = ACTIONS(6655),
    [anon_sym__Atomic] = ACTIONS(6655),
    [anon_sym_mutable] = ACTIONS(6655),
    [anon_sym_explicit] = ACTIONS(6655),
    [anon_sym_constexpr] = ACTIONS(6655),
    [anon_sym_unsigned] = ACTIONS(6655),
    [anon_sym_long] = ACTIONS(6655),
    [anon_sym_short] = ACTIONS(6655),
    [sym_primitive_type] = ACTIONS(6655),
    [anon_sym_enum] = ACTIONS(6655),
    [anon_sym_struct] = ACTIONS(6655),
    [anon_sym_union] = ACTIONS(6655),
    [anon_sym_if] = ACTIONS(6655),
    [anon_sym_else] = ACTIONS(6655),
    [anon_sym_switch] = ACTIONS(6655),
    [anon_sym_case] = ACTIONS(6655),
    [anon_sym_default] = ACTIONS(6655),
    [anon_sym_while] = ACTIONS(6655),
    [anon_sym_do] = ACTIONS(6655),
    [anon_sym_for] = ACTIONS(6655),
    [anon_sym_return] = ACTIONS(6655),
    [anon_sym_break] = ACTIONS(6655),
    [anon_sym_continue] = ACTIONS(6655),
    [anon_sym_goto] = ACTIONS(6655),
    [anon_sym_AMP] = ACTIONS(6653),
    [anon_sym_BANG] = ACTIONS(6653),
    [anon_sym_TILDE] = ACTIONS(6653),
    [anon_sym_PLUS] = ACTIONS(6655),
    [anon_sym_DASH] = ACTIONS(6655),
    [anon_sym_DASH_DASH] = ACTIONS(6653),
    [anon_sym_PLUS_PLUS] = ACTIONS(6653),
    [anon_sym_sizeof] = ACTIONS(6655),
    [sym_number_literal] = ACTIONS(6653),
    [sym_char_literal] = ACTIONS(6653),
    [sym_string_literal] = ACTIONS(6653),
    [sym_true] = ACTIONS(6655),
    [sym_false] = ACTIONS(6655),
    [sym_null] = ACTIONS(6655),
    [sym_identifier] = ACTIONS(6655),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(6655),
    [sym_auto] = ACTIONS(6655),
    [anon_sym_typename] = ACTIONS(6655),
    [anon_sym_new] = ACTIONS(6655),
    [anon_sym_COLON_COLON] = ACTIONS(6653),
    [anon_sym_delete] = ACTIONS(6655),
    [sym_nullptr] = ACTIONS(6655),
  },
  [3151] = {
    [sym_raw_string_literal] = ACTIONS(6657),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(6659),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(6659),
    [anon_sym_LPAREN] = ACTIONS(6657),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(6659),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(6659),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(6659),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(6659),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(6659),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(6659),
    [sym_preproc_directive] = ACTIONS(6659),
    [anon_sym_SEMI] = ACTIONS(6657),
    [anon_sym_typedef] = ACTIONS(6659),
    [anon_sym_extern] = ACTIONS(6659),
    [anon_sym_LBRACE] = ACTIONS(6657),
    [anon_sym_STAR] = ACTIONS(6657),
    [anon_sym_LBRACK] = ACTIONS(6657),
    [anon_sym_static] = ACTIONS(6659),
    [anon_sym_register] = ACTIONS(6659),
    [anon_sym_inline] = ACTIONS(6659),
    [anon_sym_const] = ACTIONS(6659),
    [anon_sym_restrict] = ACTIONS(6659),
    [anon_sym_volatile] = ACTIONS(6659),
    [anon_sym__Atomic] = ACTIONS(6659),
    [anon_sym_mutable] = ACTIONS(6659),
    [anon_sym_explicit] = ACTIONS(6659),
    [anon_sym_constexpr] = ACTIONS(6659),
    [anon_sym_unsigned] = ACTIONS(6659),
    [anon_sym_long] = ACTIONS(6659),
    [anon_sym_short] = ACTIONS(6659),
    [sym_primitive_type] = ACTIONS(6659),
    [anon_sym_enum] = ACTIONS(6659),
    [anon_sym_struct] = ACTIONS(6659),
    [anon_sym_union] = ACTIONS(6659),
    [anon_sym_if] = ACTIONS(6659),
    [anon_sym_else] = ACTIONS(6659),
    [anon_sym_switch] = ACTIONS(6659),
    [anon_sym_case] = ACTIONS(6659),
    [anon_sym_default] = ACTIONS(6659),
    [anon_sym_while] = ACTIONS(6659),
    [anon_sym_do] = ACTIONS(6659),
    [anon_sym_for] = ACTIONS(6659),
    [anon_sym_return] = ACTIONS(6659),
    [anon_sym_break] = ACTIONS(6659),
    [anon_sym_continue] = ACTIONS(6659),
    [anon_sym_goto] = ACTIONS(6659),
    [anon_sym_AMP] = ACTIONS(6657),
    [anon_sym_BANG] = ACTIONS(6657),
    [anon_sym_TILDE] = ACTIONS(6657),
    [anon_sym_PLUS] = ACTIONS(6659),
    [anon_sym_DASH] = ACTIONS(6659),
    [anon_sym_DASH_DASH] = ACTIONS(6657),
    [anon_sym_PLUS_PLUS] = ACTIONS(6657),
    [anon_sym_sizeof] = ACTIONS(6659),
    [sym_number_literal] = ACTIONS(6657),
    [sym_char_literal] = ACTIONS(6657),
    [sym_string_literal] = ACTIONS(6657),
    [sym_true] = ACTIONS(6659),
    [sym_false] = ACTIONS(6659),
    [sym_null] = ACTIONS(6659),
    [sym_identifier] = ACTIONS(6659),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(6659),
    [sym_auto] = ACTIONS(6659),
    [anon_sym_typename] = ACTIONS(6659),
    [anon_sym_new] = ACTIONS(6659),
    [anon_sym_COLON_COLON] = ACTIONS(6657),
    [anon_sym_delete] = ACTIONS(6659),
    [sym_nullptr] = ACTIONS(6659),
  },
  [3152] = {
    [sym_compound_statement] = STATE(3182),
    [sym_labeled_statement] = STATE(3182),
    [sym_expression_statement] = STATE(3182),
    [sym_if_statement] = STATE(3182),
    [sym_switch_statement] = STATE(3182),
    [sym_case_statement] = STATE(3182),
    [sym_while_statement] = STATE(3182),
    [sym_do_statement] = STATE(3182),
    [sym_for_statement] = STATE(3182),
    [sym_return_statement] = STATE(3182),
    [sym_break_statement] = STATE(3182),
    [sym_continue_statement] = STATE(3182),
    [sym_goto_statement] = STATE(3182),
    [sym__expression] = STATE(2739),
    [sym_comma_expression] = STATE(2740),
    [sym_conditional_expression] = STATE(2739),
    [sym_assignment_expression] = STATE(2739),
    [sym_pointer_expression] = STATE(2739),
    [sym_logical_expression] = STATE(2739),
    [sym_bitwise_expression] = STATE(2739),
    [sym_equality_expression] = STATE(2739),
    [sym_relational_expression] = STATE(2739),
    [sym_shift_expression] = STATE(2739),
    [sym_math_expression] = STATE(2739),
    [sym_cast_expression] = STATE(2739),
    [sym_sizeof_expression] = STATE(2739),
    [sym_subscript_expression] = STATE(2739),
    [sym_call_expression] = STATE(2739),
    [sym_field_expression] = STATE(2739),
    [sym_compound_literal_expression] = STATE(2739),
    [sym_parenthesized_expression] = STATE(2739),
    [sym_concatenated_string] = STATE(2739),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(2739),
    [sym_for_range_loop] = STATE(3182),
    [sym_new_expression] = STATE(2739),
    [sym_delete_expression] = STATE(2739),
    [sym_lambda_expression] = STATE(2739),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(6507),
    [anon_sym_LPAREN] = ACTIONS(626),
    [anon_sym_SEMI] = ACTIONS(6509),
    [anon_sym_LBRACE] = ACTIONS(6511),
    [anon_sym_STAR] = ACTIONS(644),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_if] = ACTIONS(6513),
    [anon_sym_switch] = ACTIONS(6515),
    [anon_sym_case] = ACTIONS(6517),
    [anon_sym_default] = ACTIONS(6519),
    [anon_sym_while] = ACTIONS(6521),
    [anon_sym_do] = ACTIONS(6523),
    [anon_sym_for] = ACTIONS(6525),
    [anon_sym_return] = ACTIONS(6527),
    [anon_sym_break] = ACTIONS(6529),
    [anon_sym_continue] = ACTIONS(6531),
    [anon_sym_goto] = ACTIONS(6533),
    [anon_sym_AMP] = ACTIONS(644),
    [anon_sym_BANG] = ACTIONS(668),
    [anon_sym_TILDE] = ACTIONS(670),
    [anon_sym_PLUS] = ACTIONS(672),
    [anon_sym_DASH] = ACTIONS(672),
    [anon_sym_DASH_DASH] = ACTIONS(674),
    [anon_sym_PLUS_PLUS] = ACTIONS(674),
    [anon_sym_sizeof] = ACTIONS(676),
    [sym_number_literal] = ACTIONS(6507),
    [sym_char_literal] = ACTIONS(6507),
    [sym_string_literal] = ACTIONS(678),
    [sym_true] = ACTIONS(6535),
    [sym_false] = ACTIONS(6535),
    [sym_null] = ACTIONS(6535),
    [sym_identifier] = ACTIONS(6537),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1303),
    [anon_sym_delete] = ACTIONS(686),
    [sym_nullptr] = ACTIONS(6535),
  },
  [3153] = {
    [aux_sym_for_statement_repeat1] = STATE(2796),
    [anon_sym_COMMA] = ACTIONS(6339),
    [anon_sym_RPAREN] = ACTIONS(7374),
    [sym_comment] = ACTIONS(49),
  },
  [3154] = {
    [sym_argument_list] = STATE(802),
    [aux_sym_for_statement_repeat1] = STATE(3184),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_COMMA] = ACTIONS(6339),
    [anon_sym_RPAREN] = ACTIONS(7374),
    [anon_sym_STAR] = ACTIONS(2234),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_EQ] = ACTIONS(2236),
    [anon_sym_QMARK] = ACTIONS(2238),
    [anon_sym_STAR_EQ] = ACTIONS(2240),
    [anon_sym_SLASH_EQ] = ACTIONS(2240),
    [anon_sym_PERCENT_EQ] = ACTIONS(2240),
    [anon_sym_PLUS_EQ] = ACTIONS(2240),
    [anon_sym_DASH_EQ] = ACTIONS(2240),
    [anon_sym_LT_LT_EQ] = ACTIONS(2240),
    [anon_sym_GT_GT_EQ] = ACTIONS(2240),
    [anon_sym_AMP_EQ] = ACTIONS(2240),
    [anon_sym_CARET_EQ] = ACTIONS(2240),
    [anon_sym_PIPE_EQ] = ACTIONS(2240),
    [anon_sym_AMP] = ACTIONS(2242),
    [anon_sym_PIPE_PIPE] = ACTIONS(2244),
    [anon_sym_AMP_AMP] = ACTIONS(2246),
    [anon_sym_PIPE] = ACTIONS(2248),
    [anon_sym_CARET] = ACTIONS(2250),
    [anon_sym_EQ_EQ] = ACTIONS(2252),
    [anon_sym_BANG_EQ] = ACTIONS(2252),
    [anon_sym_LT] = ACTIONS(2254),
    [anon_sym_GT] = ACTIONS(2254),
    [anon_sym_LT_EQ] = ACTIONS(2256),
    [anon_sym_GT_EQ] = ACTIONS(2256),
    [anon_sym_LT_LT] = ACTIONS(2258),
    [anon_sym_GT_GT] = ACTIONS(2258),
    [anon_sym_PLUS] = ACTIONS(2260),
    [anon_sym_DASH] = ACTIONS(2260),
    [anon_sym_SLASH] = ACTIONS(2234),
    [anon_sym_PERCENT] = ACTIONS(2234),
    [anon_sym_DASH_DASH] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(1554),
    [anon_sym_DASH_GT] = ACTIONS(1554),
    [sym_comment] = ACTIONS(49),
  },
  [3155] = {
    [sym__expression] = STATE(3185),
    [sym_conditional_expression] = STATE(3185),
    [sym_assignment_expression] = STATE(3185),
    [sym_pointer_expression] = STATE(3185),
    [sym_logical_expression] = STATE(3185),
    [sym_bitwise_expression] = STATE(3185),
    [sym_equality_expression] = STATE(3185),
    [sym_relational_expression] = STATE(3185),
    [sym_shift_expression] = STATE(3185),
    [sym_math_expression] = STATE(3185),
    [sym_cast_expression] = STATE(3185),
    [sym_sizeof_expression] = STATE(3185),
    [sym_subscript_expression] = STATE(3185),
    [sym_call_expression] = STATE(3185),
    [sym_field_expression] = STATE(3185),
    [sym_compound_literal_expression] = STATE(3185),
    [sym_parenthesized_expression] = STATE(3185),
    [sym_concatenated_string] = STATE(3185),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(3185),
    [sym_new_expression] = STATE(3185),
    [sym_delete_expression] = STATE(3185),
    [sym_lambda_expression] = STATE(3185),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(7376),
    [anon_sym_LPAREN] = ACTIONS(1087),
    [anon_sym_RPAREN] = ACTIONS(7374),
    [anon_sym_STAR] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_AMP] = ACTIONS(1089),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1093),
    [anon_sym_PLUS] = ACTIONS(1095),
    [anon_sym_DASH] = ACTIONS(1095),
    [anon_sym_DASH_DASH] = ACTIONS(1097),
    [anon_sym_PLUS_PLUS] = ACTIONS(1097),
    [anon_sym_sizeof] = ACTIONS(1099),
    [sym_number_literal] = ACTIONS(7376),
    [sym_char_literal] = ACTIONS(7376),
    [sym_string_literal] = ACTIONS(1101),
    [sym_true] = ACTIONS(7378),
    [sym_false] = ACTIONS(7378),
    [sym_null] = ACTIONS(7378),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_delete] = ACTIONS(1109),
    [sym_nullptr] = ACTIONS(7378),
  },
  [3156] = {
    [sym_compound_statement] = STATE(3186),
    [sym_labeled_statement] = STATE(3186),
    [sym_expression_statement] = STATE(3186),
    [sym_if_statement] = STATE(3186),
    [sym_switch_statement] = STATE(3186),
    [sym_case_statement] = STATE(3186),
    [sym_while_statement] = STATE(3186),
    [sym_do_statement] = STATE(3186),
    [sym_for_statement] = STATE(3186),
    [sym_return_statement] = STATE(3186),
    [sym_break_statement] = STATE(3186),
    [sym_continue_statement] = STATE(3186),
    [sym_goto_statement] = STATE(3186),
    [sym__expression] = STATE(2739),
    [sym_comma_expression] = STATE(2740),
    [sym_conditional_expression] = STATE(2739),
    [sym_assignment_expression] = STATE(2739),
    [sym_pointer_expression] = STATE(2739),
    [sym_logical_expression] = STATE(2739),
    [sym_bitwise_expression] = STATE(2739),
    [sym_equality_expression] = STATE(2739),
    [sym_relational_expression] = STATE(2739),
    [sym_shift_expression] = STATE(2739),
    [sym_math_expression] = STATE(2739),
    [sym_cast_expression] = STATE(2739),
    [sym_sizeof_expression] = STATE(2739),
    [sym_subscript_expression] = STATE(2739),
    [sym_call_expression] = STATE(2739),
    [sym_field_expression] = STATE(2739),
    [sym_compound_literal_expression] = STATE(2739),
    [sym_parenthesized_expression] = STATE(2739),
    [sym_concatenated_string] = STATE(2739),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(2739),
    [sym_for_range_loop] = STATE(3186),
    [sym_new_expression] = STATE(2739),
    [sym_delete_expression] = STATE(2739),
    [sym_lambda_expression] = STATE(2739),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(6507),
    [anon_sym_LPAREN] = ACTIONS(626),
    [anon_sym_SEMI] = ACTIONS(6509),
    [anon_sym_LBRACE] = ACTIONS(6511),
    [anon_sym_STAR] = ACTIONS(644),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_if] = ACTIONS(6513),
    [anon_sym_switch] = ACTIONS(6515),
    [anon_sym_case] = ACTIONS(6517),
    [anon_sym_default] = ACTIONS(6519),
    [anon_sym_while] = ACTIONS(6521),
    [anon_sym_do] = ACTIONS(6523),
    [anon_sym_for] = ACTIONS(6525),
    [anon_sym_return] = ACTIONS(6527),
    [anon_sym_break] = ACTIONS(6529),
    [anon_sym_continue] = ACTIONS(6531),
    [anon_sym_goto] = ACTIONS(6533),
    [anon_sym_AMP] = ACTIONS(644),
    [anon_sym_BANG] = ACTIONS(668),
    [anon_sym_TILDE] = ACTIONS(670),
    [anon_sym_PLUS] = ACTIONS(672),
    [anon_sym_DASH] = ACTIONS(672),
    [anon_sym_DASH_DASH] = ACTIONS(674),
    [anon_sym_PLUS_PLUS] = ACTIONS(674),
    [anon_sym_sizeof] = ACTIONS(676),
    [sym_number_literal] = ACTIONS(6507),
    [sym_char_literal] = ACTIONS(6507),
    [sym_string_literal] = ACTIONS(678),
    [sym_true] = ACTIONS(6535),
    [sym_false] = ACTIONS(6535),
    [sym_null] = ACTIONS(6535),
    [sym_identifier] = ACTIONS(6537),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1303),
    [anon_sym_delete] = ACTIONS(686),
    [sym_nullptr] = ACTIONS(6535),
  },
  [3157] = {
    [sym_raw_string_literal] = ACTIONS(7292),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(7294),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(7294),
    [anon_sym_LPAREN] = ACTIONS(7292),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(7294),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(7294),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(7294),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(7294),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(7294),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(7294),
    [sym_preproc_directive] = ACTIONS(7294),
    [anon_sym_SEMI] = ACTIONS(7292),
    [anon_sym_typedef] = ACTIONS(7294),
    [anon_sym_extern] = ACTIONS(7294),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [anon_sym_STAR] = ACTIONS(7292),
    [anon_sym_LBRACK] = ACTIONS(7292),
    [anon_sym_static] = ACTIONS(7294),
    [anon_sym_register] = ACTIONS(7294),
    [anon_sym_inline] = ACTIONS(7294),
    [anon_sym_const] = ACTIONS(7294),
    [anon_sym_restrict] = ACTIONS(7294),
    [anon_sym_volatile] = ACTIONS(7294),
    [anon_sym__Atomic] = ACTIONS(7294),
    [anon_sym_mutable] = ACTIONS(7294),
    [anon_sym_explicit] = ACTIONS(7294),
    [anon_sym_constexpr] = ACTIONS(7294),
    [anon_sym_unsigned] = ACTIONS(7294),
    [anon_sym_long] = ACTIONS(7294),
    [anon_sym_short] = ACTIONS(7294),
    [sym_primitive_type] = ACTIONS(7294),
    [anon_sym_enum] = ACTIONS(7294),
    [anon_sym_struct] = ACTIONS(7294),
    [anon_sym_union] = ACTIONS(7294),
    [anon_sym_if] = ACTIONS(7294),
    [anon_sym_switch] = ACTIONS(7294),
    [anon_sym_case] = ACTIONS(7294),
    [anon_sym_default] = ACTIONS(7294),
    [anon_sym_while] = ACTIONS(7294),
    [anon_sym_do] = ACTIONS(7294),
    [anon_sym_for] = ACTIONS(7294),
    [anon_sym_return] = ACTIONS(7294),
    [anon_sym_break] = ACTIONS(7294),
    [anon_sym_continue] = ACTIONS(7294),
    [anon_sym_goto] = ACTIONS(7294),
    [anon_sym_AMP] = ACTIONS(7292),
    [anon_sym_BANG] = ACTIONS(7292),
    [anon_sym_TILDE] = ACTIONS(7292),
    [anon_sym_PLUS] = ACTIONS(7294),
    [anon_sym_DASH] = ACTIONS(7294),
    [anon_sym_DASH_DASH] = ACTIONS(7292),
    [anon_sym_PLUS_PLUS] = ACTIONS(7292),
    [anon_sym_sizeof] = ACTIONS(7294),
    [sym_number_literal] = ACTIONS(7292),
    [sym_char_literal] = ACTIONS(7292),
    [sym_string_literal] = ACTIONS(7292),
    [sym_true] = ACTIONS(7294),
    [sym_false] = ACTIONS(7294),
    [sym_null] = ACTIONS(7294),
    [sym_identifier] = ACTIONS(7294),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(7294),
    [sym_auto] = ACTIONS(7294),
    [anon_sym_typename] = ACTIONS(7294),
    [anon_sym_new] = ACTIONS(7294),
    [anon_sym_COLON_COLON] = ACTIONS(7292),
    [anon_sym_delete] = ACTIONS(7294),
    [sym_nullptr] = ACTIONS(7294),
  },
  [3158] = {
    [sym_raw_string_literal] = ACTIONS(7057),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(7059),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(7059),
    [anon_sym_LPAREN] = ACTIONS(7057),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(7059),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(7059),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(7059),
    [sym_preproc_directive] = ACTIONS(7059),
    [anon_sym_SEMI] = ACTIONS(7057),
    [anon_sym_typedef] = ACTIONS(7059),
    [anon_sym_extern] = ACTIONS(7059),
    [anon_sym_LBRACE] = ACTIONS(7057),
    [anon_sym_RBRACE] = ACTIONS(7057),
    [anon_sym_STAR] = ACTIONS(7057),
    [anon_sym_LBRACK] = ACTIONS(7057),
    [anon_sym_static] = ACTIONS(7059),
    [anon_sym_register] = ACTIONS(7059),
    [anon_sym_inline] = ACTIONS(7059),
    [anon_sym_const] = ACTIONS(7059),
    [anon_sym_restrict] = ACTIONS(7059),
    [anon_sym_volatile] = ACTIONS(7059),
    [anon_sym__Atomic] = ACTIONS(7059),
    [anon_sym_mutable] = ACTIONS(7059),
    [anon_sym_explicit] = ACTIONS(7059),
    [anon_sym_constexpr] = ACTIONS(7059),
    [anon_sym_unsigned] = ACTIONS(7059),
    [anon_sym_long] = ACTIONS(7059),
    [anon_sym_short] = ACTIONS(7059),
    [sym_primitive_type] = ACTIONS(7059),
    [anon_sym_enum] = ACTIONS(7059),
    [anon_sym_struct] = ACTIONS(7059),
    [anon_sym_union] = ACTIONS(7059),
    [anon_sym_if] = ACTIONS(7059),
    [anon_sym_else] = ACTIONS(7059),
    [anon_sym_switch] = ACTIONS(7059),
    [anon_sym_case] = ACTIONS(7059),
    [anon_sym_default] = ACTIONS(7059),
    [anon_sym_while] = ACTIONS(7059),
    [anon_sym_do] = ACTIONS(7059),
    [anon_sym_for] = ACTIONS(7059),
    [anon_sym_return] = ACTIONS(7059),
    [anon_sym_break] = ACTIONS(7059),
    [anon_sym_continue] = ACTIONS(7059),
    [anon_sym_goto] = ACTIONS(7059),
    [anon_sym_AMP] = ACTIONS(7057),
    [anon_sym_BANG] = ACTIONS(7057),
    [anon_sym_TILDE] = ACTIONS(7057),
    [anon_sym_PLUS] = ACTIONS(7059),
    [anon_sym_DASH] = ACTIONS(7059),
    [anon_sym_DASH_DASH] = ACTIONS(7057),
    [anon_sym_PLUS_PLUS] = ACTIONS(7057),
    [anon_sym_sizeof] = ACTIONS(7059),
    [sym_number_literal] = ACTIONS(7057),
    [sym_char_literal] = ACTIONS(7057),
    [sym_string_literal] = ACTIONS(7057),
    [sym_true] = ACTIONS(7059),
    [sym_false] = ACTIONS(7059),
    [sym_null] = ACTIONS(7059),
    [sym_identifier] = ACTIONS(7059),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(7059),
    [sym_auto] = ACTIONS(7059),
    [anon_sym_typename] = ACTIONS(7059),
    [anon_sym_new] = ACTIONS(7059),
    [anon_sym_COLON_COLON] = ACTIONS(7057),
    [anon_sym_delete] = ACTIONS(7059),
    [sym_nullptr] = ACTIONS(7059),
  },
  [3159] = {
    [sym_raw_string_literal] = ACTIONS(7083),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(7085),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(7085),
    [anon_sym_LPAREN] = ACTIONS(7083),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(7085),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(7085),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(7085),
    [sym_preproc_directive] = ACTIONS(7085),
    [anon_sym_SEMI] = ACTIONS(7083),
    [anon_sym_typedef] = ACTIONS(7085),
    [anon_sym_extern] = ACTIONS(7085),
    [anon_sym_LBRACE] = ACTIONS(7083),
    [anon_sym_RBRACE] = ACTIONS(7083),
    [anon_sym_STAR] = ACTIONS(7083),
    [anon_sym_LBRACK] = ACTIONS(7083),
    [anon_sym_static] = ACTIONS(7085),
    [anon_sym_register] = ACTIONS(7085),
    [anon_sym_inline] = ACTIONS(7085),
    [anon_sym_const] = ACTIONS(7085),
    [anon_sym_restrict] = ACTIONS(7085),
    [anon_sym_volatile] = ACTIONS(7085),
    [anon_sym__Atomic] = ACTIONS(7085),
    [anon_sym_mutable] = ACTIONS(7085),
    [anon_sym_explicit] = ACTIONS(7085),
    [anon_sym_constexpr] = ACTIONS(7085),
    [anon_sym_unsigned] = ACTIONS(7085),
    [anon_sym_long] = ACTIONS(7085),
    [anon_sym_short] = ACTIONS(7085),
    [sym_primitive_type] = ACTIONS(7085),
    [anon_sym_enum] = ACTIONS(7085),
    [anon_sym_struct] = ACTIONS(7085),
    [anon_sym_union] = ACTIONS(7085),
    [anon_sym_if] = ACTIONS(7085),
    [anon_sym_else] = ACTIONS(7085),
    [anon_sym_switch] = ACTIONS(7085),
    [anon_sym_case] = ACTIONS(7085),
    [anon_sym_default] = ACTIONS(7085),
    [anon_sym_while] = ACTIONS(7085),
    [anon_sym_do] = ACTIONS(7085),
    [anon_sym_for] = ACTIONS(7085),
    [anon_sym_return] = ACTIONS(7085),
    [anon_sym_break] = ACTIONS(7085),
    [anon_sym_continue] = ACTIONS(7085),
    [anon_sym_goto] = ACTIONS(7085),
    [anon_sym_AMP] = ACTIONS(7083),
    [anon_sym_BANG] = ACTIONS(7083),
    [anon_sym_TILDE] = ACTIONS(7083),
    [anon_sym_PLUS] = ACTIONS(7085),
    [anon_sym_DASH] = ACTIONS(7085),
    [anon_sym_DASH_DASH] = ACTIONS(7083),
    [anon_sym_PLUS_PLUS] = ACTIONS(7083),
    [anon_sym_sizeof] = ACTIONS(7085),
    [sym_number_literal] = ACTIONS(7083),
    [sym_char_literal] = ACTIONS(7083),
    [sym_string_literal] = ACTIONS(7083),
    [sym_true] = ACTIONS(7085),
    [sym_false] = ACTIONS(7085),
    [sym_null] = ACTIONS(7085),
    [sym_identifier] = ACTIONS(7085),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(7085),
    [sym_auto] = ACTIONS(7085),
    [anon_sym_typename] = ACTIONS(7085),
    [anon_sym_new] = ACTIONS(7085),
    [anon_sym_COLON_COLON] = ACTIONS(7083),
    [anon_sym_delete] = ACTIONS(7085),
    [sym_nullptr] = ACTIONS(7085),
  },
  [3160] = {
    [sym_compound_statement] = STATE(3187),
    [sym_labeled_statement] = STATE(3187),
    [sym_expression_statement] = STATE(3187),
    [sym_if_statement] = STATE(3187),
    [sym_switch_statement] = STATE(3187),
    [sym_case_statement] = STATE(3187),
    [sym_while_statement] = STATE(3187),
    [sym_do_statement] = STATE(3187),
    [sym_for_statement] = STATE(3187),
    [sym_return_statement] = STATE(3187),
    [sym_break_statement] = STATE(3187),
    [sym_continue_statement] = STATE(3187),
    [sym_goto_statement] = STATE(3187),
    [sym__expression] = STATE(2378),
    [sym_comma_expression] = STATE(2379),
    [sym_conditional_expression] = STATE(2378),
    [sym_assignment_expression] = STATE(2378),
    [sym_pointer_expression] = STATE(2378),
    [sym_logical_expression] = STATE(2378),
    [sym_bitwise_expression] = STATE(2378),
    [sym_equality_expression] = STATE(2378),
    [sym_relational_expression] = STATE(2378),
    [sym_shift_expression] = STATE(2378),
    [sym_math_expression] = STATE(2378),
    [sym_cast_expression] = STATE(2378),
    [sym_sizeof_expression] = STATE(2378),
    [sym_subscript_expression] = STATE(2378),
    [sym_call_expression] = STATE(2378),
    [sym_field_expression] = STATE(2378),
    [sym_compound_literal_expression] = STATE(2378),
    [sym_parenthesized_expression] = STATE(2378),
    [sym_concatenated_string] = STATE(2378),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(2378),
    [sym_for_range_loop] = STATE(3187),
    [sym_new_expression] = STATE(2378),
    [sym_delete_expression] = STATE(2378),
    [sym_lambda_expression] = STATE(2378),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(5538),
    [anon_sym_LPAREN] = ACTIONS(626),
    [anon_sym_SEMI] = ACTIONS(5540),
    [anon_sym_LBRACE] = ACTIONS(5542),
    [anon_sym_STAR] = ACTIONS(644),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_if] = ACTIONS(5544),
    [anon_sym_switch] = ACTIONS(5546),
    [anon_sym_case] = ACTIONS(5548),
    [anon_sym_default] = ACTIONS(5550),
    [anon_sym_while] = ACTIONS(5552),
    [anon_sym_do] = ACTIONS(5554),
    [anon_sym_for] = ACTIONS(5556),
    [anon_sym_return] = ACTIONS(5558),
    [anon_sym_break] = ACTIONS(5560),
    [anon_sym_continue] = ACTIONS(5562),
    [anon_sym_goto] = ACTIONS(5564),
    [anon_sym_AMP] = ACTIONS(644),
    [anon_sym_BANG] = ACTIONS(668),
    [anon_sym_TILDE] = ACTIONS(670),
    [anon_sym_PLUS] = ACTIONS(672),
    [anon_sym_DASH] = ACTIONS(672),
    [anon_sym_DASH_DASH] = ACTIONS(674),
    [anon_sym_PLUS_PLUS] = ACTIONS(674),
    [anon_sym_sizeof] = ACTIONS(676),
    [sym_number_literal] = ACTIONS(5538),
    [sym_char_literal] = ACTIONS(5538),
    [sym_string_literal] = ACTIONS(678),
    [sym_true] = ACTIONS(5566),
    [sym_false] = ACTIONS(5566),
    [sym_null] = ACTIONS(5566),
    [sym_identifier] = ACTIONS(5568),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1303),
    [anon_sym_delete] = ACTIONS(686),
    [sym_nullptr] = ACTIONS(5566),
  },
  [3161] = {
    [aux_sym_for_statement_repeat1] = STATE(2796),
    [anon_sym_COMMA] = ACTIONS(6339),
    [anon_sym_RPAREN] = ACTIONS(7380),
    [sym_comment] = ACTIONS(49),
  },
  [3162] = {
    [sym_compound_statement] = STATE(3001),
    [sym_labeled_statement] = STATE(3001),
    [sym_expression_statement] = STATE(3001),
    [sym_if_statement] = STATE(3001),
    [sym_switch_statement] = STATE(3001),
    [sym_case_statement] = STATE(3001),
    [sym_while_statement] = STATE(3001),
    [sym_do_statement] = STATE(3001),
    [sym_for_statement] = STATE(3001),
    [sym_return_statement] = STATE(3001),
    [sym_break_statement] = STATE(3001),
    [sym_continue_statement] = STATE(3001),
    [sym_goto_statement] = STATE(3001),
    [sym__expression] = STATE(873),
    [sym_comma_expression] = STATE(874),
    [sym_conditional_expression] = STATE(873),
    [sym_assignment_expression] = STATE(873),
    [sym_pointer_expression] = STATE(873),
    [sym_logical_expression] = STATE(873),
    [sym_bitwise_expression] = STATE(873),
    [sym_equality_expression] = STATE(873),
    [sym_relational_expression] = STATE(873),
    [sym_shift_expression] = STATE(873),
    [sym_math_expression] = STATE(873),
    [sym_cast_expression] = STATE(873),
    [sym_sizeof_expression] = STATE(873),
    [sym_subscript_expression] = STATE(873),
    [sym_call_expression] = STATE(873),
    [sym_field_expression] = STATE(873),
    [sym_compound_literal_expression] = STATE(873),
    [sym_parenthesized_expression] = STATE(873),
    [sym_concatenated_string] = STATE(873),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(873),
    [sym_for_range_loop] = STATE(3001),
    [sym_new_expression] = STATE(873),
    [sym_delete_expression] = STATE(873),
    [sym_lambda_expression] = STATE(873),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(1660),
    [anon_sym_LPAREN] = ACTIONS(626),
    [anon_sym_SEMI] = ACTIONS(1662),
    [anon_sym_LBRACE] = ACTIONS(1664),
    [anon_sym_STAR] = ACTIONS(644),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_if] = ACTIONS(6297),
    [anon_sym_switch] = ACTIONS(6299),
    [anon_sym_case] = ACTIONS(6301),
    [anon_sym_default] = ACTIONS(6303),
    [anon_sym_while] = ACTIONS(6305),
    [anon_sym_do] = ACTIONS(1676),
    [anon_sym_for] = ACTIONS(6307),
    [anon_sym_return] = ACTIONS(1680),
    [anon_sym_break] = ACTIONS(1682),
    [anon_sym_continue] = ACTIONS(1684),
    [anon_sym_goto] = ACTIONS(1686),
    [anon_sym_AMP] = ACTIONS(644),
    [anon_sym_BANG] = ACTIONS(668),
    [anon_sym_TILDE] = ACTIONS(670),
    [anon_sym_PLUS] = ACTIONS(672),
    [anon_sym_DASH] = ACTIONS(672),
    [anon_sym_DASH_DASH] = ACTIONS(674),
    [anon_sym_PLUS_PLUS] = ACTIONS(674),
    [anon_sym_sizeof] = ACTIONS(676),
    [sym_number_literal] = ACTIONS(1660),
    [sym_char_literal] = ACTIONS(1660),
    [sym_string_literal] = ACTIONS(678),
    [sym_true] = ACTIONS(1688),
    [sym_false] = ACTIONS(1688),
    [sym_null] = ACTIONS(1688),
    [sym_identifier] = ACTIONS(6309),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1303),
    [anon_sym_delete] = ACTIONS(686),
    [sym_nullptr] = ACTIONS(1688),
  },
  [3163] = {
    [sym_compound_statement] = STATE(3002),
    [sym_labeled_statement] = STATE(3002),
    [sym_expression_statement] = STATE(3002),
    [sym_if_statement] = STATE(3002),
    [sym_switch_statement] = STATE(3002),
    [sym_case_statement] = STATE(3002),
    [sym_while_statement] = STATE(3002),
    [sym_do_statement] = STATE(3002),
    [sym_for_statement] = STATE(3002),
    [sym_return_statement] = STATE(3002),
    [sym_break_statement] = STATE(3002),
    [sym_continue_statement] = STATE(3002),
    [sym_goto_statement] = STATE(3002),
    [sym__expression] = STATE(873),
    [sym_comma_expression] = STATE(874),
    [sym_conditional_expression] = STATE(873),
    [sym_assignment_expression] = STATE(873),
    [sym_pointer_expression] = STATE(873),
    [sym_logical_expression] = STATE(873),
    [sym_bitwise_expression] = STATE(873),
    [sym_equality_expression] = STATE(873),
    [sym_relational_expression] = STATE(873),
    [sym_shift_expression] = STATE(873),
    [sym_math_expression] = STATE(873),
    [sym_cast_expression] = STATE(873),
    [sym_sizeof_expression] = STATE(873),
    [sym_subscript_expression] = STATE(873),
    [sym_call_expression] = STATE(873),
    [sym_field_expression] = STATE(873),
    [sym_compound_literal_expression] = STATE(873),
    [sym_parenthesized_expression] = STATE(873),
    [sym_concatenated_string] = STATE(873),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(873),
    [sym_for_range_loop] = STATE(3002),
    [sym_new_expression] = STATE(873),
    [sym_delete_expression] = STATE(873),
    [sym_lambda_expression] = STATE(873),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(1660),
    [anon_sym_LPAREN] = ACTIONS(626),
    [anon_sym_SEMI] = ACTIONS(1662),
    [anon_sym_LBRACE] = ACTIONS(1664),
    [anon_sym_STAR] = ACTIONS(644),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_if] = ACTIONS(6297),
    [anon_sym_switch] = ACTIONS(6299),
    [anon_sym_case] = ACTIONS(6301),
    [anon_sym_default] = ACTIONS(6303),
    [anon_sym_while] = ACTIONS(6305),
    [anon_sym_do] = ACTIONS(1676),
    [anon_sym_for] = ACTIONS(6307),
    [anon_sym_return] = ACTIONS(1680),
    [anon_sym_break] = ACTIONS(1682),
    [anon_sym_continue] = ACTIONS(1684),
    [anon_sym_goto] = ACTIONS(1686),
    [anon_sym_AMP] = ACTIONS(644),
    [anon_sym_BANG] = ACTIONS(668),
    [anon_sym_TILDE] = ACTIONS(670),
    [anon_sym_PLUS] = ACTIONS(672),
    [anon_sym_DASH] = ACTIONS(672),
    [anon_sym_DASH_DASH] = ACTIONS(674),
    [anon_sym_PLUS_PLUS] = ACTIONS(674),
    [anon_sym_sizeof] = ACTIONS(676),
    [sym_number_literal] = ACTIONS(1660),
    [sym_char_literal] = ACTIONS(1660),
    [sym_string_literal] = ACTIONS(678),
    [sym_true] = ACTIONS(1688),
    [sym_false] = ACTIONS(1688),
    [sym_null] = ACTIONS(1688),
    [sym_identifier] = ACTIONS(6309),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1303),
    [anon_sym_delete] = ACTIONS(686),
    [sym_nullptr] = ACTIONS(1688),
  },
  [3164] = {
    [aux_sym_for_statement_repeat1] = STATE(2796),
    [anon_sym_COMMA] = ACTIONS(6339),
    [anon_sym_RPAREN] = ACTIONS(7382),
    [sym_comment] = ACTIONS(49),
  },
  [3165] = {
    [sym_argument_list] = STATE(802),
    [aux_sym_for_statement_repeat1] = STATE(3190),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_COMMA] = ACTIONS(6339),
    [anon_sym_RPAREN] = ACTIONS(7382),
    [anon_sym_STAR] = ACTIONS(2234),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_EQ] = ACTIONS(2236),
    [anon_sym_QMARK] = ACTIONS(2238),
    [anon_sym_STAR_EQ] = ACTIONS(2240),
    [anon_sym_SLASH_EQ] = ACTIONS(2240),
    [anon_sym_PERCENT_EQ] = ACTIONS(2240),
    [anon_sym_PLUS_EQ] = ACTIONS(2240),
    [anon_sym_DASH_EQ] = ACTIONS(2240),
    [anon_sym_LT_LT_EQ] = ACTIONS(2240),
    [anon_sym_GT_GT_EQ] = ACTIONS(2240),
    [anon_sym_AMP_EQ] = ACTIONS(2240),
    [anon_sym_CARET_EQ] = ACTIONS(2240),
    [anon_sym_PIPE_EQ] = ACTIONS(2240),
    [anon_sym_AMP] = ACTIONS(2242),
    [anon_sym_PIPE_PIPE] = ACTIONS(2244),
    [anon_sym_AMP_AMP] = ACTIONS(2246),
    [anon_sym_PIPE] = ACTIONS(2248),
    [anon_sym_CARET] = ACTIONS(2250),
    [anon_sym_EQ_EQ] = ACTIONS(2252),
    [anon_sym_BANG_EQ] = ACTIONS(2252),
    [anon_sym_LT] = ACTIONS(2254),
    [anon_sym_GT] = ACTIONS(2254),
    [anon_sym_LT_EQ] = ACTIONS(2256),
    [anon_sym_GT_EQ] = ACTIONS(2256),
    [anon_sym_LT_LT] = ACTIONS(2258),
    [anon_sym_GT_GT] = ACTIONS(2258),
    [anon_sym_PLUS] = ACTIONS(2260),
    [anon_sym_DASH] = ACTIONS(2260),
    [anon_sym_SLASH] = ACTIONS(2234),
    [anon_sym_PERCENT] = ACTIONS(2234),
    [anon_sym_DASH_DASH] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(1554),
    [anon_sym_DASH_GT] = ACTIONS(1554),
    [sym_comment] = ACTIONS(49),
  },
  [3166] = {
    [sym_compound_statement] = STATE(3191),
    [sym_labeled_statement] = STATE(3191),
    [sym_expression_statement] = STATE(3191),
    [sym_if_statement] = STATE(3191),
    [sym_switch_statement] = STATE(3191),
    [sym_case_statement] = STATE(3191),
    [sym_while_statement] = STATE(3191),
    [sym_do_statement] = STATE(3191),
    [sym_for_statement] = STATE(3191),
    [sym_return_statement] = STATE(3191),
    [sym_break_statement] = STATE(3191),
    [sym_continue_statement] = STATE(3191),
    [sym_goto_statement] = STATE(3191),
    [sym__expression] = STATE(2844),
    [sym_comma_expression] = STATE(2845),
    [sym_conditional_expression] = STATE(2844),
    [sym_assignment_expression] = STATE(2844),
    [sym_pointer_expression] = STATE(2844),
    [sym_logical_expression] = STATE(2844),
    [sym_bitwise_expression] = STATE(2844),
    [sym_equality_expression] = STATE(2844),
    [sym_relational_expression] = STATE(2844),
    [sym_shift_expression] = STATE(2844),
    [sym_math_expression] = STATE(2844),
    [sym_cast_expression] = STATE(2844),
    [sym_sizeof_expression] = STATE(2844),
    [sym_subscript_expression] = STATE(2844),
    [sym_call_expression] = STATE(2844),
    [sym_field_expression] = STATE(2844),
    [sym_compound_literal_expression] = STATE(2844),
    [sym_parenthesized_expression] = STATE(2844),
    [sym_concatenated_string] = STATE(2844),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(2844),
    [sym_for_range_loop] = STATE(3191),
    [sym_new_expression] = STATE(2844),
    [sym_delete_expression] = STATE(2844),
    [sym_lambda_expression] = STATE(2844),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(6732),
    [anon_sym_LPAREN] = ACTIONS(626),
    [anon_sym_SEMI] = ACTIONS(6734),
    [anon_sym_LBRACE] = ACTIONS(6736),
    [anon_sym_STAR] = ACTIONS(644),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_if] = ACTIONS(6738),
    [anon_sym_switch] = ACTIONS(6740),
    [anon_sym_case] = ACTIONS(6742),
    [anon_sym_default] = ACTIONS(6744),
    [anon_sym_while] = ACTIONS(6746),
    [anon_sym_do] = ACTIONS(6748),
    [anon_sym_for] = ACTIONS(6750),
    [anon_sym_return] = ACTIONS(6752),
    [anon_sym_break] = ACTIONS(6754),
    [anon_sym_continue] = ACTIONS(6756),
    [anon_sym_goto] = ACTIONS(6758),
    [anon_sym_AMP] = ACTIONS(644),
    [anon_sym_BANG] = ACTIONS(668),
    [anon_sym_TILDE] = ACTIONS(670),
    [anon_sym_PLUS] = ACTIONS(672),
    [anon_sym_DASH] = ACTIONS(672),
    [anon_sym_DASH_DASH] = ACTIONS(674),
    [anon_sym_PLUS_PLUS] = ACTIONS(674),
    [anon_sym_sizeof] = ACTIONS(676),
    [sym_number_literal] = ACTIONS(6732),
    [sym_char_literal] = ACTIONS(6732),
    [sym_string_literal] = ACTIONS(678),
    [sym_true] = ACTIONS(6760),
    [sym_false] = ACTIONS(6760),
    [sym_null] = ACTIONS(6760),
    [sym_identifier] = ACTIONS(6762),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1303),
    [anon_sym_delete] = ACTIONS(686),
    [sym_nullptr] = ACTIONS(6760),
  },
  [3167] = {
    [sym_raw_string_literal] = ACTIONS(6611),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(6613),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(6613),
    [anon_sym_LPAREN] = ACTIONS(6611),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(6613),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(6613),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(6613),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(6613),
    [sym_preproc_directive] = ACTIONS(6613),
    [anon_sym_SEMI] = ACTIONS(6611),
    [anon_sym_typedef] = ACTIONS(6613),
    [anon_sym_extern] = ACTIONS(6613),
    [anon_sym_LBRACE] = ACTIONS(6611),
    [anon_sym_STAR] = ACTIONS(6611),
    [anon_sym_LBRACK] = ACTIONS(6611),
    [anon_sym_static] = ACTIONS(6613),
    [anon_sym_register] = ACTIONS(6613),
    [anon_sym_inline] = ACTIONS(6613),
    [anon_sym_const] = ACTIONS(6613),
    [anon_sym_restrict] = ACTIONS(6613),
    [anon_sym_volatile] = ACTIONS(6613),
    [anon_sym__Atomic] = ACTIONS(6613),
    [anon_sym_mutable] = ACTIONS(6613),
    [anon_sym_explicit] = ACTIONS(6613),
    [anon_sym_constexpr] = ACTIONS(6613),
    [anon_sym_unsigned] = ACTIONS(6613),
    [anon_sym_long] = ACTIONS(6613),
    [anon_sym_short] = ACTIONS(6613),
    [sym_primitive_type] = ACTIONS(6613),
    [anon_sym_enum] = ACTIONS(6613),
    [anon_sym_struct] = ACTIONS(6613),
    [anon_sym_union] = ACTIONS(6613),
    [anon_sym_if] = ACTIONS(6613),
    [anon_sym_else] = ACTIONS(7384),
    [anon_sym_switch] = ACTIONS(6613),
    [anon_sym_case] = ACTIONS(6613),
    [anon_sym_default] = ACTIONS(6613),
    [anon_sym_while] = ACTIONS(6613),
    [anon_sym_do] = ACTIONS(6613),
    [anon_sym_for] = ACTIONS(6613),
    [anon_sym_return] = ACTIONS(6613),
    [anon_sym_break] = ACTIONS(6613),
    [anon_sym_continue] = ACTIONS(6613),
    [anon_sym_goto] = ACTIONS(6613),
    [anon_sym_AMP] = ACTIONS(6611),
    [anon_sym_BANG] = ACTIONS(6611),
    [anon_sym_TILDE] = ACTIONS(6611),
    [anon_sym_PLUS] = ACTIONS(6613),
    [anon_sym_DASH] = ACTIONS(6613),
    [anon_sym_DASH_DASH] = ACTIONS(6611),
    [anon_sym_PLUS_PLUS] = ACTIONS(6611),
    [anon_sym_sizeof] = ACTIONS(6613),
    [sym_number_literal] = ACTIONS(6611),
    [sym_char_literal] = ACTIONS(6611),
    [sym_string_literal] = ACTIONS(6611),
    [sym_true] = ACTIONS(6613),
    [sym_false] = ACTIONS(6613),
    [sym_null] = ACTIONS(6613),
    [sym_identifier] = ACTIONS(6613),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(6613),
    [sym_auto] = ACTIONS(6613),
    [anon_sym_typename] = ACTIONS(6613),
    [anon_sym_new] = ACTIONS(6613),
    [anon_sym_COLON_COLON] = ACTIONS(6611),
    [anon_sym_delete] = ACTIONS(6613),
    [sym_nullptr] = ACTIONS(6613),
  },
  [3168] = {
    [sym_raw_string_literal] = ACTIONS(1988),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1990),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1990),
    [anon_sym_LPAREN] = ACTIONS(1988),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1990),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(1990),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1990),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1990),
    [sym_preproc_directive] = ACTIONS(1990),
    [anon_sym_SEMI] = ACTIONS(1988),
    [anon_sym_typedef] = ACTIONS(1990),
    [anon_sym_extern] = ACTIONS(1990),
    [anon_sym_LBRACE] = ACTIONS(1988),
    [anon_sym_STAR] = ACTIONS(1988),
    [anon_sym_LBRACK] = ACTIONS(1988),
    [anon_sym_static] = ACTIONS(1990),
    [anon_sym_register] = ACTIONS(1990),
    [anon_sym_inline] = ACTIONS(1990),
    [anon_sym_const] = ACTIONS(1990),
    [anon_sym_restrict] = ACTIONS(1990),
    [anon_sym_volatile] = ACTIONS(1990),
    [anon_sym__Atomic] = ACTIONS(1990),
    [anon_sym_mutable] = ACTIONS(1990),
    [anon_sym_explicit] = ACTIONS(1990),
    [anon_sym_constexpr] = ACTIONS(1990),
    [anon_sym_unsigned] = ACTIONS(1990),
    [anon_sym_long] = ACTIONS(1990),
    [anon_sym_short] = ACTIONS(1990),
    [sym_primitive_type] = ACTIONS(1990),
    [anon_sym_enum] = ACTIONS(1990),
    [anon_sym_struct] = ACTIONS(1990),
    [anon_sym_union] = ACTIONS(1990),
    [anon_sym_if] = ACTIONS(1990),
    [anon_sym_else] = ACTIONS(1990),
    [anon_sym_switch] = ACTIONS(1990),
    [anon_sym_case] = ACTIONS(1990),
    [anon_sym_default] = ACTIONS(1990),
    [anon_sym_while] = ACTIONS(1990),
    [anon_sym_do] = ACTIONS(1990),
    [anon_sym_for] = ACTIONS(1990),
    [anon_sym_return] = ACTIONS(1990),
    [anon_sym_break] = ACTIONS(1990),
    [anon_sym_continue] = ACTIONS(1990),
    [anon_sym_goto] = ACTIONS(1990),
    [anon_sym_AMP] = ACTIONS(1988),
    [anon_sym_BANG] = ACTIONS(1988),
    [anon_sym_TILDE] = ACTIONS(1988),
    [anon_sym_PLUS] = ACTIONS(1990),
    [anon_sym_DASH] = ACTIONS(1990),
    [anon_sym_DASH_DASH] = ACTIONS(1988),
    [anon_sym_PLUS_PLUS] = ACTIONS(1988),
    [anon_sym_sizeof] = ACTIONS(1990),
    [sym_number_literal] = ACTIONS(1988),
    [sym_char_literal] = ACTIONS(1988),
    [sym_string_literal] = ACTIONS(1988),
    [sym_true] = ACTIONS(1990),
    [sym_false] = ACTIONS(1990),
    [sym_null] = ACTIONS(1990),
    [sym_identifier] = ACTIONS(1990),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(1990),
    [sym_auto] = ACTIONS(1990),
    [anon_sym_typename] = ACTIONS(1990),
    [anon_sym_new] = ACTIONS(1990),
    [anon_sym_COLON_COLON] = ACTIONS(1988),
    [anon_sym_delete] = ACTIONS(1990),
    [sym_nullptr] = ACTIONS(1990),
  },
  [3169] = {
    [sym_parameter_list] = STATE(513),
    [anon_sym_LPAREN] = ACTIONS(206),
    [anon_sym_SEMI] = ACTIONS(7386),
    [anon_sym_LBRACK] = ACTIONS(955),
    [sym_comment] = ACTIONS(49),
  },
  [3170] = {
    [sym_raw_string_literal] = ACTIONS(2478),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(2480),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(2480),
    [anon_sym_LPAREN] = ACTIONS(2478),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(2480),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(2480),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(2480),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(2480),
    [sym_preproc_directive] = ACTIONS(2480),
    [anon_sym_SEMI] = ACTIONS(2478),
    [anon_sym_typedef] = ACTIONS(2480),
    [anon_sym_extern] = ACTIONS(2480),
    [anon_sym_LBRACE] = ACTIONS(2478),
    [anon_sym_STAR] = ACTIONS(2478),
    [anon_sym_LBRACK] = ACTIONS(2478),
    [anon_sym_static] = ACTIONS(2480),
    [anon_sym_register] = ACTIONS(2480),
    [anon_sym_inline] = ACTIONS(2480),
    [anon_sym_const] = ACTIONS(2480),
    [anon_sym_restrict] = ACTIONS(2480),
    [anon_sym_volatile] = ACTIONS(2480),
    [anon_sym__Atomic] = ACTIONS(2480),
    [anon_sym_mutable] = ACTIONS(2480),
    [anon_sym_explicit] = ACTIONS(2480),
    [anon_sym_constexpr] = ACTIONS(2480),
    [anon_sym_unsigned] = ACTIONS(2480),
    [anon_sym_long] = ACTIONS(2480),
    [anon_sym_short] = ACTIONS(2480),
    [sym_primitive_type] = ACTIONS(2480),
    [anon_sym_enum] = ACTIONS(2480),
    [anon_sym_struct] = ACTIONS(2480),
    [anon_sym_union] = ACTIONS(2480),
    [anon_sym_if] = ACTIONS(2480),
    [anon_sym_else] = ACTIONS(2480),
    [anon_sym_switch] = ACTIONS(2480),
    [anon_sym_case] = ACTIONS(2480),
    [anon_sym_default] = ACTIONS(2480),
    [anon_sym_while] = ACTIONS(2480),
    [anon_sym_do] = ACTIONS(2480),
    [anon_sym_for] = ACTIONS(2480),
    [anon_sym_return] = ACTIONS(2480),
    [anon_sym_break] = ACTIONS(2480),
    [anon_sym_continue] = ACTIONS(2480),
    [anon_sym_goto] = ACTIONS(2480),
    [anon_sym_AMP] = ACTIONS(2478),
    [anon_sym_BANG] = ACTIONS(2478),
    [anon_sym_TILDE] = ACTIONS(2478),
    [anon_sym_PLUS] = ACTIONS(2480),
    [anon_sym_DASH] = ACTIONS(2480),
    [anon_sym_DASH_DASH] = ACTIONS(2478),
    [anon_sym_PLUS_PLUS] = ACTIONS(2478),
    [anon_sym_sizeof] = ACTIONS(2480),
    [sym_number_literal] = ACTIONS(2478),
    [sym_char_literal] = ACTIONS(2478),
    [sym_string_literal] = ACTIONS(2478),
    [sym_true] = ACTIONS(2480),
    [sym_false] = ACTIONS(2480),
    [sym_null] = ACTIONS(2480),
    [sym_identifier] = ACTIONS(2480),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(2480),
    [sym_auto] = ACTIONS(2480),
    [anon_sym_typename] = ACTIONS(2480),
    [anon_sym_new] = ACTIONS(2480),
    [anon_sym_COLON_COLON] = ACTIONS(2478),
    [anon_sym_delete] = ACTIONS(2480),
    [sym_nullptr] = ACTIONS(2480),
  },
  [3171] = {
    [sym_raw_string_literal] = ACTIONS(6653),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(6655),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(6655),
    [anon_sym_LPAREN] = ACTIONS(6653),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(6655),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(6655),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(6655),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(6655),
    [sym_preproc_directive] = ACTIONS(6655),
    [anon_sym_SEMI] = ACTIONS(6653),
    [anon_sym_typedef] = ACTIONS(6655),
    [anon_sym_extern] = ACTIONS(6655),
    [anon_sym_LBRACE] = ACTIONS(6653),
    [anon_sym_STAR] = ACTIONS(6653),
    [anon_sym_LBRACK] = ACTIONS(6653),
    [anon_sym_static] = ACTIONS(6655),
    [anon_sym_register] = ACTIONS(6655),
    [anon_sym_inline] = ACTIONS(6655),
    [anon_sym_const] = ACTIONS(6655),
    [anon_sym_restrict] = ACTIONS(6655),
    [anon_sym_volatile] = ACTIONS(6655),
    [anon_sym__Atomic] = ACTIONS(6655),
    [anon_sym_mutable] = ACTIONS(6655),
    [anon_sym_explicit] = ACTIONS(6655),
    [anon_sym_constexpr] = ACTIONS(6655),
    [anon_sym_unsigned] = ACTIONS(6655),
    [anon_sym_long] = ACTIONS(6655),
    [anon_sym_short] = ACTIONS(6655),
    [sym_primitive_type] = ACTIONS(6655),
    [anon_sym_enum] = ACTIONS(6655),
    [anon_sym_struct] = ACTIONS(6655),
    [anon_sym_union] = ACTIONS(6655),
    [anon_sym_if] = ACTIONS(6655),
    [anon_sym_else] = ACTIONS(6655),
    [anon_sym_switch] = ACTIONS(6655),
    [anon_sym_case] = ACTIONS(6655),
    [anon_sym_default] = ACTIONS(6655),
    [anon_sym_while] = ACTIONS(6655),
    [anon_sym_do] = ACTIONS(6655),
    [anon_sym_for] = ACTIONS(6655),
    [anon_sym_return] = ACTIONS(6655),
    [anon_sym_break] = ACTIONS(6655),
    [anon_sym_continue] = ACTIONS(6655),
    [anon_sym_goto] = ACTIONS(6655),
    [anon_sym_AMP] = ACTIONS(6653),
    [anon_sym_BANG] = ACTIONS(6653),
    [anon_sym_TILDE] = ACTIONS(6653),
    [anon_sym_PLUS] = ACTIONS(6655),
    [anon_sym_DASH] = ACTIONS(6655),
    [anon_sym_DASH_DASH] = ACTIONS(6653),
    [anon_sym_PLUS_PLUS] = ACTIONS(6653),
    [anon_sym_sizeof] = ACTIONS(6655),
    [sym_number_literal] = ACTIONS(6653),
    [sym_char_literal] = ACTIONS(6653),
    [sym_string_literal] = ACTIONS(6653),
    [sym_true] = ACTIONS(6655),
    [sym_false] = ACTIONS(6655),
    [sym_null] = ACTIONS(6655),
    [sym_identifier] = ACTIONS(6655),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(6655),
    [sym_auto] = ACTIONS(6655),
    [anon_sym_typename] = ACTIONS(6655),
    [anon_sym_new] = ACTIONS(6655),
    [anon_sym_COLON_COLON] = ACTIONS(6653),
    [anon_sym_delete] = ACTIONS(6655),
    [sym_nullptr] = ACTIONS(6655),
  },
  [3172] = {
    [sym_raw_string_literal] = ACTIONS(6657),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(6659),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(6659),
    [anon_sym_LPAREN] = ACTIONS(6657),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(6659),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(6659),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(6659),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(6659),
    [sym_preproc_directive] = ACTIONS(6659),
    [anon_sym_SEMI] = ACTIONS(6657),
    [anon_sym_typedef] = ACTIONS(6659),
    [anon_sym_extern] = ACTIONS(6659),
    [anon_sym_LBRACE] = ACTIONS(6657),
    [anon_sym_STAR] = ACTIONS(6657),
    [anon_sym_LBRACK] = ACTIONS(6657),
    [anon_sym_static] = ACTIONS(6659),
    [anon_sym_register] = ACTIONS(6659),
    [anon_sym_inline] = ACTIONS(6659),
    [anon_sym_const] = ACTIONS(6659),
    [anon_sym_restrict] = ACTIONS(6659),
    [anon_sym_volatile] = ACTIONS(6659),
    [anon_sym__Atomic] = ACTIONS(6659),
    [anon_sym_mutable] = ACTIONS(6659),
    [anon_sym_explicit] = ACTIONS(6659),
    [anon_sym_constexpr] = ACTIONS(6659),
    [anon_sym_unsigned] = ACTIONS(6659),
    [anon_sym_long] = ACTIONS(6659),
    [anon_sym_short] = ACTIONS(6659),
    [sym_primitive_type] = ACTIONS(6659),
    [anon_sym_enum] = ACTIONS(6659),
    [anon_sym_struct] = ACTIONS(6659),
    [anon_sym_union] = ACTIONS(6659),
    [anon_sym_if] = ACTIONS(6659),
    [anon_sym_else] = ACTIONS(6659),
    [anon_sym_switch] = ACTIONS(6659),
    [anon_sym_case] = ACTIONS(6659),
    [anon_sym_default] = ACTIONS(6659),
    [anon_sym_while] = ACTIONS(6659),
    [anon_sym_do] = ACTIONS(6659),
    [anon_sym_for] = ACTIONS(6659),
    [anon_sym_return] = ACTIONS(6659),
    [anon_sym_break] = ACTIONS(6659),
    [anon_sym_continue] = ACTIONS(6659),
    [anon_sym_goto] = ACTIONS(6659),
    [anon_sym_AMP] = ACTIONS(6657),
    [anon_sym_BANG] = ACTIONS(6657),
    [anon_sym_TILDE] = ACTIONS(6657),
    [anon_sym_PLUS] = ACTIONS(6659),
    [anon_sym_DASH] = ACTIONS(6659),
    [anon_sym_DASH_DASH] = ACTIONS(6657),
    [anon_sym_PLUS_PLUS] = ACTIONS(6657),
    [anon_sym_sizeof] = ACTIONS(6659),
    [sym_number_literal] = ACTIONS(6657),
    [sym_char_literal] = ACTIONS(6657),
    [sym_string_literal] = ACTIONS(6657),
    [sym_true] = ACTIONS(6659),
    [sym_false] = ACTIONS(6659),
    [sym_null] = ACTIONS(6659),
    [sym_identifier] = ACTIONS(6659),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(6659),
    [sym_auto] = ACTIONS(6659),
    [anon_sym_typename] = ACTIONS(6659),
    [anon_sym_new] = ACTIONS(6659),
    [anon_sym_COLON_COLON] = ACTIONS(6657),
    [anon_sym_delete] = ACTIONS(6659),
    [sym_nullptr] = ACTIONS(6659),
  },
  [3173] = {
    [sym_compound_statement] = STATE(3194),
    [sym_labeled_statement] = STATE(3194),
    [sym_expression_statement] = STATE(3194),
    [sym_if_statement] = STATE(3194),
    [sym_switch_statement] = STATE(3194),
    [sym_case_statement] = STATE(3194),
    [sym_while_statement] = STATE(3194),
    [sym_do_statement] = STATE(3194),
    [sym_for_statement] = STATE(3194),
    [sym_return_statement] = STATE(3194),
    [sym_break_statement] = STATE(3194),
    [sym_continue_statement] = STATE(3194),
    [sym_goto_statement] = STATE(3194),
    [sym__expression] = STATE(2844),
    [sym_comma_expression] = STATE(2845),
    [sym_conditional_expression] = STATE(2844),
    [sym_assignment_expression] = STATE(2844),
    [sym_pointer_expression] = STATE(2844),
    [sym_logical_expression] = STATE(2844),
    [sym_bitwise_expression] = STATE(2844),
    [sym_equality_expression] = STATE(2844),
    [sym_relational_expression] = STATE(2844),
    [sym_shift_expression] = STATE(2844),
    [sym_math_expression] = STATE(2844),
    [sym_cast_expression] = STATE(2844),
    [sym_sizeof_expression] = STATE(2844),
    [sym_subscript_expression] = STATE(2844),
    [sym_call_expression] = STATE(2844),
    [sym_field_expression] = STATE(2844),
    [sym_compound_literal_expression] = STATE(2844),
    [sym_parenthesized_expression] = STATE(2844),
    [sym_concatenated_string] = STATE(2844),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(2844),
    [sym_for_range_loop] = STATE(3194),
    [sym_new_expression] = STATE(2844),
    [sym_delete_expression] = STATE(2844),
    [sym_lambda_expression] = STATE(2844),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(6732),
    [anon_sym_LPAREN] = ACTIONS(626),
    [anon_sym_SEMI] = ACTIONS(6734),
    [anon_sym_LBRACE] = ACTIONS(6736),
    [anon_sym_STAR] = ACTIONS(644),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_if] = ACTIONS(6738),
    [anon_sym_switch] = ACTIONS(6740),
    [anon_sym_case] = ACTIONS(6742),
    [anon_sym_default] = ACTIONS(6744),
    [anon_sym_while] = ACTIONS(6746),
    [anon_sym_do] = ACTIONS(6748),
    [anon_sym_for] = ACTIONS(6750),
    [anon_sym_return] = ACTIONS(6752),
    [anon_sym_break] = ACTIONS(6754),
    [anon_sym_continue] = ACTIONS(6756),
    [anon_sym_goto] = ACTIONS(6758),
    [anon_sym_AMP] = ACTIONS(644),
    [anon_sym_BANG] = ACTIONS(668),
    [anon_sym_TILDE] = ACTIONS(670),
    [anon_sym_PLUS] = ACTIONS(672),
    [anon_sym_DASH] = ACTIONS(672),
    [anon_sym_DASH_DASH] = ACTIONS(674),
    [anon_sym_PLUS_PLUS] = ACTIONS(674),
    [anon_sym_sizeof] = ACTIONS(676),
    [sym_number_literal] = ACTIONS(6732),
    [sym_char_literal] = ACTIONS(6732),
    [sym_string_literal] = ACTIONS(678),
    [sym_true] = ACTIONS(6760),
    [sym_false] = ACTIONS(6760),
    [sym_null] = ACTIONS(6760),
    [sym_identifier] = ACTIONS(6762),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1303),
    [anon_sym_delete] = ACTIONS(686),
    [sym_nullptr] = ACTIONS(6760),
  },
  [3174] = {
    [aux_sym_for_statement_repeat1] = STATE(2796),
    [anon_sym_COMMA] = ACTIONS(6339),
    [anon_sym_RPAREN] = ACTIONS(7388),
    [sym_comment] = ACTIONS(49),
  },
  [3175] = {
    [sym_argument_list] = STATE(802),
    [aux_sym_for_statement_repeat1] = STATE(3196),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_COMMA] = ACTIONS(6339),
    [anon_sym_RPAREN] = ACTIONS(7388),
    [anon_sym_STAR] = ACTIONS(2234),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_EQ] = ACTIONS(2236),
    [anon_sym_QMARK] = ACTIONS(2238),
    [anon_sym_STAR_EQ] = ACTIONS(2240),
    [anon_sym_SLASH_EQ] = ACTIONS(2240),
    [anon_sym_PERCENT_EQ] = ACTIONS(2240),
    [anon_sym_PLUS_EQ] = ACTIONS(2240),
    [anon_sym_DASH_EQ] = ACTIONS(2240),
    [anon_sym_LT_LT_EQ] = ACTIONS(2240),
    [anon_sym_GT_GT_EQ] = ACTIONS(2240),
    [anon_sym_AMP_EQ] = ACTIONS(2240),
    [anon_sym_CARET_EQ] = ACTIONS(2240),
    [anon_sym_PIPE_EQ] = ACTIONS(2240),
    [anon_sym_AMP] = ACTIONS(2242),
    [anon_sym_PIPE_PIPE] = ACTIONS(2244),
    [anon_sym_AMP_AMP] = ACTIONS(2246),
    [anon_sym_PIPE] = ACTIONS(2248),
    [anon_sym_CARET] = ACTIONS(2250),
    [anon_sym_EQ_EQ] = ACTIONS(2252),
    [anon_sym_BANG_EQ] = ACTIONS(2252),
    [anon_sym_LT] = ACTIONS(2254),
    [anon_sym_GT] = ACTIONS(2254),
    [anon_sym_LT_EQ] = ACTIONS(2256),
    [anon_sym_GT_EQ] = ACTIONS(2256),
    [anon_sym_LT_LT] = ACTIONS(2258),
    [anon_sym_GT_GT] = ACTIONS(2258),
    [anon_sym_PLUS] = ACTIONS(2260),
    [anon_sym_DASH] = ACTIONS(2260),
    [anon_sym_SLASH] = ACTIONS(2234),
    [anon_sym_PERCENT] = ACTIONS(2234),
    [anon_sym_DASH_DASH] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(1554),
    [anon_sym_DASH_GT] = ACTIONS(1554),
    [sym_comment] = ACTIONS(49),
  },
  [3176] = {
    [sym__expression] = STATE(3197),
    [sym_conditional_expression] = STATE(3197),
    [sym_assignment_expression] = STATE(3197),
    [sym_pointer_expression] = STATE(3197),
    [sym_logical_expression] = STATE(3197),
    [sym_bitwise_expression] = STATE(3197),
    [sym_equality_expression] = STATE(3197),
    [sym_relational_expression] = STATE(3197),
    [sym_shift_expression] = STATE(3197),
    [sym_math_expression] = STATE(3197),
    [sym_cast_expression] = STATE(3197),
    [sym_sizeof_expression] = STATE(3197),
    [sym_subscript_expression] = STATE(3197),
    [sym_call_expression] = STATE(3197),
    [sym_field_expression] = STATE(3197),
    [sym_compound_literal_expression] = STATE(3197),
    [sym_parenthesized_expression] = STATE(3197),
    [sym_concatenated_string] = STATE(3197),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(3197),
    [sym_new_expression] = STATE(3197),
    [sym_delete_expression] = STATE(3197),
    [sym_lambda_expression] = STATE(3197),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(7390),
    [anon_sym_LPAREN] = ACTIONS(1087),
    [anon_sym_RPAREN] = ACTIONS(7388),
    [anon_sym_STAR] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_AMP] = ACTIONS(1089),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1093),
    [anon_sym_PLUS] = ACTIONS(1095),
    [anon_sym_DASH] = ACTIONS(1095),
    [anon_sym_DASH_DASH] = ACTIONS(1097),
    [anon_sym_PLUS_PLUS] = ACTIONS(1097),
    [anon_sym_sizeof] = ACTIONS(1099),
    [sym_number_literal] = ACTIONS(7390),
    [sym_char_literal] = ACTIONS(7390),
    [sym_string_literal] = ACTIONS(1101),
    [sym_true] = ACTIONS(7392),
    [sym_false] = ACTIONS(7392),
    [sym_null] = ACTIONS(7392),
    [sym_identifier] = ACTIONS(1105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_delete] = ACTIONS(1109),
    [sym_nullptr] = ACTIONS(7392),
  },
  [3177] = {
    [sym_compound_statement] = STATE(3198),
    [sym_labeled_statement] = STATE(3198),
    [sym_expression_statement] = STATE(3198),
    [sym_if_statement] = STATE(3198),
    [sym_switch_statement] = STATE(3198),
    [sym_case_statement] = STATE(3198),
    [sym_while_statement] = STATE(3198),
    [sym_do_statement] = STATE(3198),
    [sym_for_statement] = STATE(3198),
    [sym_return_statement] = STATE(3198),
    [sym_break_statement] = STATE(3198),
    [sym_continue_statement] = STATE(3198),
    [sym_goto_statement] = STATE(3198),
    [sym__expression] = STATE(2844),
    [sym_comma_expression] = STATE(2845),
    [sym_conditional_expression] = STATE(2844),
    [sym_assignment_expression] = STATE(2844),
    [sym_pointer_expression] = STATE(2844),
    [sym_logical_expression] = STATE(2844),
    [sym_bitwise_expression] = STATE(2844),
    [sym_equality_expression] = STATE(2844),
    [sym_relational_expression] = STATE(2844),
    [sym_shift_expression] = STATE(2844),
    [sym_math_expression] = STATE(2844),
    [sym_cast_expression] = STATE(2844),
    [sym_sizeof_expression] = STATE(2844),
    [sym_subscript_expression] = STATE(2844),
    [sym_call_expression] = STATE(2844),
    [sym_field_expression] = STATE(2844),
    [sym_compound_literal_expression] = STATE(2844),
    [sym_parenthesized_expression] = STATE(2844),
    [sym_concatenated_string] = STATE(2844),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(2844),
    [sym_for_range_loop] = STATE(3198),
    [sym_new_expression] = STATE(2844),
    [sym_delete_expression] = STATE(2844),
    [sym_lambda_expression] = STATE(2844),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(6732),
    [anon_sym_LPAREN] = ACTIONS(626),
    [anon_sym_SEMI] = ACTIONS(6734),
    [anon_sym_LBRACE] = ACTIONS(6736),
    [anon_sym_STAR] = ACTIONS(644),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_if] = ACTIONS(6738),
    [anon_sym_switch] = ACTIONS(6740),
    [anon_sym_case] = ACTIONS(6742),
    [anon_sym_default] = ACTIONS(6744),
    [anon_sym_while] = ACTIONS(6746),
    [anon_sym_do] = ACTIONS(6748),
    [anon_sym_for] = ACTIONS(6750),
    [anon_sym_return] = ACTIONS(6752),
    [anon_sym_break] = ACTIONS(6754),
    [anon_sym_continue] = ACTIONS(6756),
    [anon_sym_goto] = ACTIONS(6758),
    [anon_sym_AMP] = ACTIONS(644),
    [anon_sym_BANG] = ACTIONS(668),
    [anon_sym_TILDE] = ACTIONS(670),
    [anon_sym_PLUS] = ACTIONS(672),
    [anon_sym_DASH] = ACTIONS(672),
    [anon_sym_DASH_DASH] = ACTIONS(674),
    [anon_sym_PLUS_PLUS] = ACTIONS(674),
    [anon_sym_sizeof] = ACTIONS(676),
    [sym_number_literal] = ACTIONS(6732),
    [sym_char_literal] = ACTIONS(6732),
    [sym_string_literal] = ACTIONS(678),
    [sym_true] = ACTIONS(6760),
    [sym_false] = ACTIONS(6760),
    [sym_null] = ACTIONS(6760),
    [sym_identifier] = ACTIONS(6762),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1303),
    [anon_sym_delete] = ACTIONS(686),
    [sym_nullptr] = ACTIONS(6760),
  },
  [3178] = {
    [sym_raw_string_literal] = ACTIONS(7292),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(7294),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(7294),
    [anon_sym_LPAREN] = ACTIONS(7292),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(7294),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(7294),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(7294),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(7294),
    [sym_preproc_directive] = ACTIONS(7294),
    [anon_sym_SEMI] = ACTIONS(7292),
    [anon_sym_typedef] = ACTIONS(7294),
    [anon_sym_extern] = ACTIONS(7294),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [anon_sym_STAR] = ACTIONS(7292),
    [anon_sym_LBRACK] = ACTIONS(7292),
    [anon_sym_static] = ACTIONS(7294),
    [anon_sym_register] = ACTIONS(7294),
    [anon_sym_inline] = ACTIONS(7294),
    [anon_sym_const] = ACTIONS(7294),
    [anon_sym_restrict] = ACTIONS(7294),
    [anon_sym_volatile] = ACTIONS(7294),
    [anon_sym__Atomic] = ACTIONS(7294),
    [anon_sym_mutable] = ACTIONS(7294),
    [anon_sym_explicit] = ACTIONS(7294),
    [anon_sym_constexpr] = ACTIONS(7294),
    [anon_sym_unsigned] = ACTIONS(7294),
    [anon_sym_long] = ACTIONS(7294),
    [anon_sym_short] = ACTIONS(7294),
    [sym_primitive_type] = ACTIONS(7294),
    [anon_sym_enum] = ACTIONS(7294),
    [anon_sym_struct] = ACTIONS(7294),
    [anon_sym_union] = ACTIONS(7294),
    [anon_sym_if] = ACTIONS(7294),
    [anon_sym_switch] = ACTIONS(7294),
    [anon_sym_case] = ACTIONS(7294),
    [anon_sym_default] = ACTIONS(7294),
    [anon_sym_while] = ACTIONS(7294),
    [anon_sym_do] = ACTIONS(7294),
    [anon_sym_for] = ACTIONS(7294),
    [anon_sym_return] = ACTIONS(7294),
    [anon_sym_break] = ACTIONS(7294),
    [anon_sym_continue] = ACTIONS(7294),
    [anon_sym_goto] = ACTIONS(7294),
    [anon_sym_AMP] = ACTIONS(7292),
    [anon_sym_BANG] = ACTIONS(7292),
    [anon_sym_TILDE] = ACTIONS(7292),
    [anon_sym_PLUS] = ACTIONS(7294),
    [anon_sym_DASH] = ACTIONS(7294),
    [anon_sym_DASH_DASH] = ACTIONS(7292),
    [anon_sym_PLUS_PLUS] = ACTIONS(7292),
    [anon_sym_sizeof] = ACTIONS(7294),
    [sym_number_literal] = ACTIONS(7292),
    [sym_char_literal] = ACTIONS(7292),
    [sym_string_literal] = ACTIONS(7292),
    [sym_true] = ACTIONS(7294),
    [sym_false] = ACTIONS(7294),
    [sym_null] = ACTIONS(7294),
    [sym_identifier] = ACTIONS(7294),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(7294),
    [sym_auto] = ACTIONS(7294),
    [anon_sym_typename] = ACTIONS(7294),
    [anon_sym_new] = ACTIONS(7294),
    [anon_sym_COLON_COLON] = ACTIONS(7292),
    [anon_sym_delete] = ACTIONS(7294),
    [sym_nullptr] = ACTIONS(7294),
  },
  [3179] = {
    [sym_raw_string_literal] = ACTIONS(6864),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(6866),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(6866),
    [anon_sym_LPAREN] = ACTIONS(6864),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(6866),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(6866),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(6866),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(6866),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(6866),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(6866),
    [sym_preproc_directive] = ACTIONS(6866),
    [anon_sym_SEMI] = ACTIONS(6864),
    [anon_sym_typedef] = ACTIONS(6866),
    [anon_sym_extern] = ACTIONS(6866),
    [anon_sym_LBRACE] = ACTIONS(6864),
    [anon_sym_STAR] = ACTIONS(6864),
    [anon_sym_LBRACK] = ACTIONS(6864),
    [anon_sym_static] = ACTIONS(6866),
    [anon_sym_register] = ACTIONS(6866),
    [anon_sym_inline] = ACTIONS(6866),
    [anon_sym_const] = ACTIONS(6866),
    [anon_sym_restrict] = ACTIONS(6866),
    [anon_sym_volatile] = ACTIONS(6866),
    [anon_sym__Atomic] = ACTIONS(6866),
    [anon_sym_mutable] = ACTIONS(6866),
    [anon_sym_explicit] = ACTIONS(6866),
    [anon_sym_constexpr] = ACTIONS(6866),
    [anon_sym_unsigned] = ACTIONS(6866),
    [anon_sym_long] = ACTIONS(6866),
    [anon_sym_short] = ACTIONS(6866),
    [sym_primitive_type] = ACTIONS(6866),
    [anon_sym_enum] = ACTIONS(6866),
    [anon_sym_struct] = ACTIONS(6866),
    [anon_sym_union] = ACTIONS(6866),
    [anon_sym_if] = ACTIONS(6866),
    [anon_sym_else] = ACTIONS(6866),
    [anon_sym_switch] = ACTIONS(6866),
    [anon_sym_case] = ACTIONS(6866),
    [anon_sym_default] = ACTIONS(6866),
    [anon_sym_while] = ACTIONS(6866),
    [anon_sym_do] = ACTIONS(6866),
    [anon_sym_for] = ACTIONS(6866),
    [anon_sym_return] = ACTIONS(6866),
    [anon_sym_break] = ACTIONS(6866),
    [anon_sym_continue] = ACTIONS(6866),
    [anon_sym_goto] = ACTIONS(6866),
    [anon_sym_AMP] = ACTIONS(6864),
    [anon_sym_BANG] = ACTIONS(6864),
    [anon_sym_TILDE] = ACTIONS(6864),
    [anon_sym_PLUS] = ACTIONS(6866),
    [anon_sym_DASH] = ACTIONS(6866),
    [anon_sym_DASH_DASH] = ACTIONS(6864),
    [anon_sym_PLUS_PLUS] = ACTIONS(6864),
    [anon_sym_sizeof] = ACTIONS(6866),
    [sym_number_literal] = ACTIONS(6864),
    [sym_char_literal] = ACTIONS(6864),
    [sym_string_literal] = ACTIONS(6864),
    [sym_true] = ACTIONS(6866),
    [sym_false] = ACTIONS(6866),
    [sym_null] = ACTIONS(6866),
    [sym_identifier] = ACTIONS(6866),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(6866),
    [sym_auto] = ACTIONS(6866),
    [anon_sym_typename] = ACTIONS(6866),
    [anon_sym_new] = ACTIONS(6866),
    [anon_sym_COLON_COLON] = ACTIONS(6864),
    [anon_sym_delete] = ACTIONS(6866),
    [sym_nullptr] = ACTIONS(6866),
  },
  [3180] = {
    [sym_compound_statement] = STATE(3199),
    [sym_labeled_statement] = STATE(3199),
    [sym_expression_statement] = STATE(3199),
    [sym_if_statement] = STATE(3199),
    [sym_switch_statement] = STATE(3199),
    [sym_case_statement] = STATE(3199),
    [sym_while_statement] = STATE(3199),
    [sym_do_statement] = STATE(3199),
    [sym_for_statement] = STATE(3199),
    [sym_return_statement] = STATE(3199),
    [sym_break_statement] = STATE(3199),
    [sym_continue_statement] = STATE(3199),
    [sym_goto_statement] = STATE(3199),
    [sym__expression] = STATE(2739),
    [sym_comma_expression] = STATE(2740),
    [sym_conditional_expression] = STATE(2739),
    [sym_assignment_expression] = STATE(2739),
    [sym_pointer_expression] = STATE(2739),
    [sym_logical_expression] = STATE(2739),
    [sym_bitwise_expression] = STATE(2739),
    [sym_equality_expression] = STATE(2739),
    [sym_relational_expression] = STATE(2739),
    [sym_shift_expression] = STATE(2739),
    [sym_math_expression] = STATE(2739),
    [sym_cast_expression] = STATE(2739),
    [sym_sizeof_expression] = STATE(2739),
    [sym_subscript_expression] = STATE(2739),
    [sym_call_expression] = STATE(2739),
    [sym_field_expression] = STATE(2739),
    [sym_compound_literal_expression] = STATE(2739),
    [sym_parenthesized_expression] = STATE(2739),
    [sym_concatenated_string] = STATE(2739),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(2739),
    [sym_for_range_loop] = STATE(3199),
    [sym_new_expression] = STATE(2739),
    [sym_delete_expression] = STATE(2739),
    [sym_lambda_expression] = STATE(2739),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(6507),
    [anon_sym_LPAREN] = ACTIONS(626),
    [anon_sym_SEMI] = ACTIONS(6509),
    [anon_sym_LBRACE] = ACTIONS(6511),
    [anon_sym_STAR] = ACTIONS(644),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_if] = ACTIONS(6513),
    [anon_sym_switch] = ACTIONS(6515),
    [anon_sym_case] = ACTIONS(6517),
    [anon_sym_default] = ACTIONS(6519),
    [anon_sym_while] = ACTIONS(6521),
    [anon_sym_do] = ACTIONS(6523),
    [anon_sym_for] = ACTIONS(6525),
    [anon_sym_return] = ACTIONS(6527),
    [anon_sym_break] = ACTIONS(6529),
    [anon_sym_continue] = ACTIONS(6531),
    [anon_sym_goto] = ACTIONS(6533),
    [anon_sym_AMP] = ACTIONS(644),
    [anon_sym_BANG] = ACTIONS(668),
    [anon_sym_TILDE] = ACTIONS(670),
    [anon_sym_PLUS] = ACTIONS(672),
    [anon_sym_DASH] = ACTIONS(672),
    [anon_sym_DASH_DASH] = ACTIONS(674),
    [anon_sym_PLUS_PLUS] = ACTIONS(674),
    [anon_sym_sizeof] = ACTIONS(676),
    [sym_number_literal] = ACTIONS(6507),
    [sym_char_literal] = ACTIONS(6507),
    [sym_string_literal] = ACTIONS(678),
    [sym_true] = ACTIONS(6535),
    [sym_false] = ACTIONS(6535),
    [sym_null] = ACTIONS(6535),
    [sym_identifier] = ACTIONS(6537),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1303),
    [anon_sym_delete] = ACTIONS(686),
    [sym_nullptr] = ACTIONS(6535),
  },
  [3181] = {
    [sym_raw_string_literal] = ACTIONS(3519),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3521),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3521),
    [anon_sym_LPAREN] = ACTIONS(3519),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3521),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3521),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3521),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3521),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(3521),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(3521),
    [sym_preproc_directive] = ACTIONS(3521),
    [anon_sym_SEMI] = ACTIONS(3519),
    [anon_sym_typedef] = ACTIONS(3521),
    [anon_sym_extern] = ACTIONS(3521),
    [anon_sym_LBRACE] = ACTIONS(3519),
    [anon_sym_STAR] = ACTIONS(3519),
    [anon_sym_LBRACK] = ACTIONS(3519),
    [anon_sym_static] = ACTIONS(3521),
    [anon_sym_register] = ACTIONS(3521),
    [anon_sym_inline] = ACTIONS(3521),
    [anon_sym_const] = ACTIONS(3521),
    [anon_sym_restrict] = ACTIONS(3521),
    [anon_sym_volatile] = ACTIONS(3521),
    [anon_sym__Atomic] = ACTIONS(3521),
    [anon_sym_mutable] = ACTIONS(3521),
    [anon_sym_explicit] = ACTIONS(3521),
    [anon_sym_constexpr] = ACTIONS(3521),
    [anon_sym_unsigned] = ACTIONS(3521),
    [anon_sym_long] = ACTIONS(3521),
    [anon_sym_short] = ACTIONS(3521),
    [sym_primitive_type] = ACTIONS(3521),
    [anon_sym_enum] = ACTIONS(3521),
    [anon_sym_struct] = ACTIONS(3521),
    [anon_sym_union] = ACTIONS(3521),
    [anon_sym_if] = ACTIONS(3521),
    [anon_sym_else] = ACTIONS(3521),
    [anon_sym_switch] = ACTIONS(3521),
    [anon_sym_case] = ACTIONS(3521),
    [anon_sym_default] = ACTIONS(3521),
    [anon_sym_while] = ACTIONS(3521),
    [anon_sym_do] = ACTIONS(3521),
    [anon_sym_for] = ACTIONS(3521),
    [anon_sym_return] = ACTIONS(3521),
    [anon_sym_break] = ACTIONS(3521),
    [anon_sym_continue] = ACTIONS(3521),
    [anon_sym_goto] = ACTIONS(3521),
    [anon_sym_AMP] = ACTIONS(3519),
    [anon_sym_BANG] = ACTIONS(3519),
    [anon_sym_TILDE] = ACTIONS(3519),
    [anon_sym_PLUS] = ACTIONS(3521),
    [anon_sym_DASH] = ACTIONS(3521),
    [anon_sym_DASH_DASH] = ACTIONS(3519),
    [anon_sym_PLUS_PLUS] = ACTIONS(3519),
    [anon_sym_sizeof] = ACTIONS(3521),
    [sym_number_literal] = ACTIONS(3519),
    [sym_char_literal] = ACTIONS(3519),
    [sym_string_literal] = ACTIONS(3519),
    [sym_true] = ACTIONS(3521),
    [sym_false] = ACTIONS(3521),
    [sym_null] = ACTIONS(3521),
    [sym_identifier] = ACTIONS(3521),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(3521),
    [sym_auto] = ACTIONS(3521),
    [anon_sym_typename] = ACTIONS(3521),
    [anon_sym_new] = ACTIONS(3521),
    [anon_sym_COLON_COLON] = ACTIONS(3519),
    [anon_sym_delete] = ACTIONS(3521),
    [sym_nullptr] = ACTIONS(3521),
  },
  [3182] = {
    [sym_raw_string_literal] = ACTIONS(6902),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(6904),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(6904),
    [anon_sym_LPAREN] = ACTIONS(6902),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(6904),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(6904),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(6904),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(6904),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(6904),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(6904),
    [sym_preproc_directive] = ACTIONS(6904),
    [anon_sym_SEMI] = ACTIONS(6902),
    [anon_sym_typedef] = ACTIONS(6904),
    [anon_sym_extern] = ACTIONS(6904),
    [anon_sym_LBRACE] = ACTIONS(6902),
    [anon_sym_STAR] = ACTIONS(6902),
    [anon_sym_LBRACK] = ACTIONS(6902),
    [anon_sym_static] = ACTIONS(6904),
    [anon_sym_register] = ACTIONS(6904),
    [anon_sym_inline] = ACTIONS(6904),
    [anon_sym_const] = ACTIONS(6904),
    [anon_sym_restrict] = ACTIONS(6904),
    [anon_sym_volatile] = ACTIONS(6904),
    [anon_sym__Atomic] = ACTIONS(6904),
    [anon_sym_mutable] = ACTIONS(6904),
    [anon_sym_explicit] = ACTIONS(6904),
    [anon_sym_constexpr] = ACTIONS(6904),
    [anon_sym_unsigned] = ACTIONS(6904),
    [anon_sym_long] = ACTIONS(6904),
    [anon_sym_short] = ACTIONS(6904),
    [sym_primitive_type] = ACTIONS(6904),
    [anon_sym_enum] = ACTIONS(6904),
    [anon_sym_struct] = ACTIONS(6904),
    [anon_sym_union] = ACTIONS(6904),
    [anon_sym_if] = ACTIONS(6904),
    [anon_sym_else] = ACTIONS(6904),
    [anon_sym_switch] = ACTIONS(6904),
    [anon_sym_case] = ACTIONS(6904),
    [anon_sym_default] = ACTIONS(6904),
    [anon_sym_while] = ACTIONS(6904),
    [anon_sym_do] = ACTIONS(6904),
    [anon_sym_for] = ACTIONS(6904),
    [anon_sym_return] = ACTIONS(6904),
    [anon_sym_break] = ACTIONS(6904),
    [anon_sym_continue] = ACTIONS(6904),
    [anon_sym_goto] = ACTIONS(6904),
    [anon_sym_AMP] = ACTIONS(6902),
    [anon_sym_BANG] = ACTIONS(6902),
    [anon_sym_TILDE] = ACTIONS(6902),
    [anon_sym_PLUS] = ACTIONS(6904),
    [anon_sym_DASH] = ACTIONS(6904),
    [anon_sym_DASH_DASH] = ACTIONS(6902),
    [anon_sym_PLUS_PLUS] = ACTIONS(6902),
    [anon_sym_sizeof] = ACTIONS(6904),
    [sym_number_literal] = ACTIONS(6902),
    [sym_char_literal] = ACTIONS(6902),
    [sym_string_literal] = ACTIONS(6902),
    [sym_true] = ACTIONS(6904),
    [sym_false] = ACTIONS(6904),
    [sym_null] = ACTIONS(6904),
    [sym_identifier] = ACTIONS(6904),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(6904),
    [sym_auto] = ACTIONS(6904),
    [anon_sym_typename] = ACTIONS(6904),
    [anon_sym_new] = ACTIONS(6904),
    [anon_sym_COLON_COLON] = ACTIONS(6902),
    [anon_sym_delete] = ACTIONS(6904),
    [sym_nullptr] = ACTIONS(6904),
  },
  [3183] = {
    [sym_compound_statement] = STATE(3200),
    [sym_labeled_statement] = STATE(3200),
    [sym_expression_statement] = STATE(3200),
    [sym_if_statement] = STATE(3200),
    [sym_switch_statement] = STATE(3200),
    [sym_case_statement] = STATE(3200),
    [sym_while_statement] = STATE(3200),
    [sym_do_statement] = STATE(3200),
    [sym_for_statement] = STATE(3200),
    [sym_return_statement] = STATE(3200),
    [sym_break_statement] = STATE(3200),
    [sym_continue_statement] = STATE(3200),
    [sym_goto_statement] = STATE(3200),
    [sym__expression] = STATE(2739),
    [sym_comma_expression] = STATE(2740),
    [sym_conditional_expression] = STATE(2739),
    [sym_assignment_expression] = STATE(2739),
    [sym_pointer_expression] = STATE(2739),
    [sym_logical_expression] = STATE(2739),
    [sym_bitwise_expression] = STATE(2739),
    [sym_equality_expression] = STATE(2739),
    [sym_relational_expression] = STATE(2739),
    [sym_shift_expression] = STATE(2739),
    [sym_math_expression] = STATE(2739),
    [sym_cast_expression] = STATE(2739),
    [sym_sizeof_expression] = STATE(2739),
    [sym_subscript_expression] = STATE(2739),
    [sym_call_expression] = STATE(2739),
    [sym_field_expression] = STATE(2739),
    [sym_compound_literal_expression] = STATE(2739),
    [sym_parenthesized_expression] = STATE(2739),
    [sym_concatenated_string] = STATE(2739),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(2739),
    [sym_for_range_loop] = STATE(3200),
    [sym_new_expression] = STATE(2739),
    [sym_delete_expression] = STATE(2739),
    [sym_lambda_expression] = STATE(2739),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(6507),
    [anon_sym_LPAREN] = ACTIONS(626),
    [anon_sym_SEMI] = ACTIONS(6509),
    [anon_sym_LBRACE] = ACTIONS(6511),
    [anon_sym_STAR] = ACTIONS(644),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_if] = ACTIONS(6513),
    [anon_sym_switch] = ACTIONS(6515),
    [anon_sym_case] = ACTIONS(6517),
    [anon_sym_default] = ACTIONS(6519),
    [anon_sym_while] = ACTIONS(6521),
    [anon_sym_do] = ACTIONS(6523),
    [anon_sym_for] = ACTIONS(6525),
    [anon_sym_return] = ACTIONS(6527),
    [anon_sym_break] = ACTIONS(6529),
    [anon_sym_continue] = ACTIONS(6531),
    [anon_sym_goto] = ACTIONS(6533),
    [anon_sym_AMP] = ACTIONS(644),
    [anon_sym_BANG] = ACTIONS(668),
    [anon_sym_TILDE] = ACTIONS(670),
    [anon_sym_PLUS] = ACTIONS(672),
    [anon_sym_DASH] = ACTIONS(672),
    [anon_sym_DASH_DASH] = ACTIONS(674),
    [anon_sym_PLUS_PLUS] = ACTIONS(674),
    [anon_sym_sizeof] = ACTIONS(676),
    [sym_number_literal] = ACTIONS(6507),
    [sym_char_literal] = ACTIONS(6507),
    [sym_string_literal] = ACTIONS(678),
    [sym_true] = ACTIONS(6535),
    [sym_false] = ACTIONS(6535),
    [sym_null] = ACTIONS(6535),
    [sym_identifier] = ACTIONS(6537),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1303),
    [anon_sym_delete] = ACTIONS(686),
    [sym_nullptr] = ACTIONS(6535),
  },
  [3184] = {
    [aux_sym_for_statement_repeat1] = STATE(2796),
    [anon_sym_COMMA] = ACTIONS(6339),
    [anon_sym_RPAREN] = ACTIONS(7394),
    [sym_comment] = ACTIONS(49),
  },
  [3185] = {
    [sym_argument_list] = STATE(802),
    [aux_sym_for_statement_repeat1] = STATE(3202),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_COMMA] = ACTIONS(6339),
    [anon_sym_RPAREN] = ACTIONS(7394),
    [anon_sym_STAR] = ACTIONS(2234),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_EQ] = ACTIONS(2236),
    [anon_sym_QMARK] = ACTIONS(2238),
    [anon_sym_STAR_EQ] = ACTIONS(2240),
    [anon_sym_SLASH_EQ] = ACTIONS(2240),
    [anon_sym_PERCENT_EQ] = ACTIONS(2240),
    [anon_sym_PLUS_EQ] = ACTIONS(2240),
    [anon_sym_DASH_EQ] = ACTIONS(2240),
    [anon_sym_LT_LT_EQ] = ACTIONS(2240),
    [anon_sym_GT_GT_EQ] = ACTIONS(2240),
    [anon_sym_AMP_EQ] = ACTIONS(2240),
    [anon_sym_CARET_EQ] = ACTIONS(2240),
    [anon_sym_PIPE_EQ] = ACTIONS(2240),
    [anon_sym_AMP] = ACTIONS(2242),
    [anon_sym_PIPE_PIPE] = ACTIONS(2244),
    [anon_sym_AMP_AMP] = ACTIONS(2246),
    [anon_sym_PIPE] = ACTIONS(2248),
    [anon_sym_CARET] = ACTIONS(2250),
    [anon_sym_EQ_EQ] = ACTIONS(2252),
    [anon_sym_BANG_EQ] = ACTIONS(2252),
    [anon_sym_LT] = ACTIONS(2254),
    [anon_sym_GT] = ACTIONS(2254),
    [anon_sym_LT_EQ] = ACTIONS(2256),
    [anon_sym_GT_EQ] = ACTIONS(2256),
    [anon_sym_LT_LT] = ACTIONS(2258),
    [anon_sym_GT_GT] = ACTIONS(2258),
    [anon_sym_PLUS] = ACTIONS(2260),
    [anon_sym_DASH] = ACTIONS(2260),
    [anon_sym_SLASH] = ACTIONS(2234),
    [anon_sym_PERCENT] = ACTIONS(2234),
    [anon_sym_DASH_DASH] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(1554),
    [anon_sym_DASH_GT] = ACTIONS(1554),
    [sym_comment] = ACTIONS(49),
  },
  [3186] = {
    [sym_raw_string_literal] = ACTIONS(6925),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(6927),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(6927),
    [anon_sym_LPAREN] = ACTIONS(6925),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(6927),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(6927),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(6927),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(6927),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(6927),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(6927),
    [sym_preproc_directive] = ACTIONS(6927),
    [anon_sym_SEMI] = ACTIONS(6925),
    [anon_sym_typedef] = ACTIONS(6927),
    [anon_sym_extern] = ACTIONS(6927),
    [anon_sym_LBRACE] = ACTIONS(6925),
    [anon_sym_STAR] = ACTIONS(6925),
    [anon_sym_LBRACK] = ACTIONS(6925),
    [anon_sym_static] = ACTIONS(6927),
    [anon_sym_register] = ACTIONS(6927),
    [anon_sym_inline] = ACTIONS(6927),
    [anon_sym_const] = ACTIONS(6927),
    [anon_sym_restrict] = ACTIONS(6927),
    [anon_sym_volatile] = ACTIONS(6927),
    [anon_sym__Atomic] = ACTIONS(6927),
    [anon_sym_mutable] = ACTIONS(6927),
    [anon_sym_explicit] = ACTIONS(6927),
    [anon_sym_constexpr] = ACTIONS(6927),
    [anon_sym_unsigned] = ACTIONS(6927),
    [anon_sym_long] = ACTIONS(6927),
    [anon_sym_short] = ACTIONS(6927),
    [sym_primitive_type] = ACTIONS(6927),
    [anon_sym_enum] = ACTIONS(6927),
    [anon_sym_struct] = ACTIONS(6927),
    [anon_sym_union] = ACTIONS(6927),
    [anon_sym_if] = ACTIONS(6927),
    [anon_sym_else] = ACTIONS(6927),
    [anon_sym_switch] = ACTIONS(6927),
    [anon_sym_case] = ACTIONS(6927),
    [anon_sym_default] = ACTIONS(6927),
    [anon_sym_while] = ACTIONS(6927),
    [anon_sym_do] = ACTIONS(6927),
    [anon_sym_for] = ACTIONS(6927),
    [anon_sym_return] = ACTIONS(6927),
    [anon_sym_break] = ACTIONS(6927),
    [anon_sym_continue] = ACTIONS(6927),
    [anon_sym_goto] = ACTIONS(6927),
    [anon_sym_AMP] = ACTIONS(6925),
    [anon_sym_BANG] = ACTIONS(6925),
    [anon_sym_TILDE] = ACTIONS(6925),
    [anon_sym_PLUS] = ACTIONS(6927),
    [anon_sym_DASH] = ACTIONS(6927),
    [anon_sym_DASH_DASH] = ACTIONS(6925),
    [anon_sym_PLUS_PLUS] = ACTIONS(6925),
    [anon_sym_sizeof] = ACTIONS(6927),
    [sym_number_literal] = ACTIONS(6925),
    [sym_char_literal] = ACTIONS(6925),
    [sym_string_literal] = ACTIONS(6925),
    [sym_true] = ACTIONS(6927),
    [sym_false] = ACTIONS(6927),
    [sym_null] = ACTIONS(6927),
    [sym_identifier] = ACTIONS(6927),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(6927),
    [sym_auto] = ACTIONS(6927),
    [anon_sym_typename] = ACTIONS(6927),
    [anon_sym_new] = ACTIONS(6927),
    [anon_sym_COLON_COLON] = ACTIONS(6925),
    [anon_sym_delete] = ACTIONS(6927),
    [sym_nullptr] = ACTIONS(6927),
  },
  [3187] = {
    [sym_raw_string_literal] = ACTIONS(7202),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(7204),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(7204),
    [anon_sym_LPAREN] = ACTIONS(7202),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(7204),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(7204),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(7204),
    [sym_preproc_directive] = ACTIONS(7204),
    [anon_sym_SEMI] = ACTIONS(7202),
    [anon_sym_typedef] = ACTIONS(7204),
    [anon_sym_extern] = ACTIONS(7204),
    [anon_sym_LBRACE] = ACTIONS(7202),
    [anon_sym_RBRACE] = ACTIONS(7202),
    [anon_sym_STAR] = ACTIONS(7202),
    [anon_sym_LBRACK] = ACTIONS(7202),
    [anon_sym_static] = ACTIONS(7204),
    [anon_sym_register] = ACTIONS(7204),
    [anon_sym_inline] = ACTIONS(7204),
    [anon_sym_const] = ACTIONS(7204),
    [anon_sym_restrict] = ACTIONS(7204),
    [anon_sym_volatile] = ACTIONS(7204),
    [anon_sym__Atomic] = ACTIONS(7204),
    [anon_sym_mutable] = ACTIONS(7204),
    [anon_sym_explicit] = ACTIONS(7204),
    [anon_sym_constexpr] = ACTIONS(7204),
    [anon_sym_unsigned] = ACTIONS(7204),
    [anon_sym_long] = ACTIONS(7204),
    [anon_sym_short] = ACTIONS(7204),
    [sym_primitive_type] = ACTIONS(7204),
    [anon_sym_enum] = ACTIONS(7204),
    [anon_sym_struct] = ACTIONS(7204),
    [anon_sym_union] = ACTIONS(7204),
    [anon_sym_if] = ACTIONS(7204),
    [anon_sym_else] = ACTIONS(7204),
    [anon_sym_switch] = ACTIONS(7204),
    [anon_sym_case] = ACTIONS(7204),
    [anon_sym_default] = ACTIONS(7204),
    [anon_sym_while] = ACTIONS(7204),
    [anon_sym_do] = ACTIONS(7204),
    [anon_sym_for] = ACTIONS(7204),
    [anon_sym_return] = ACTIONS(7204),
    [anon_sym_break] = ACTIONS(7204),
    [anon_sym_continue] = ACTIONS(7204),
    [anon_sym_goto] = ACTIONS(7204),
    [anon_sym_AMP] = ACTIONS(7202),
    [anon_sym_BANG] = ACTIONS(7202),
    [anon_sym_TILDE] = ACTIONS(7202),
    [anon_sym_PLUS] = ACTIONS(7204),
    [anon_sym_DASH] = ACTIONS(7204),
    [anon_sym_DASH_DASH] = ACTIONS(7202),
    [anon_sym_PLUS_PLUS] = ACTIONS(7202),
    [anon_sym_sizeof] = ACTIONS(7204),
    [sym_number_literal] = ACTIONS(7202),
    [sym_char_literal] = ACTIONS(7202),
    [sym_string_literal] = ACTIONS(7202),
    [sym_true] = ACTIONS(7204),
    [sym_false] = ACTIONS(7204),
    [sym_null] = ACTIONS(7204),
    [sym_identifier] = ACTIONS(7204),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(7204),
    [sym_auto] = ACTIONS(7204),
    [anon_sym_typename] = ACTIONS(7204),
    [anon_sym_new] = ACTIONS(7204),
    [anon_sym_COLON_COLON] = ACTIONS(7202),
    [anon_sym_delete] = ACTIONS(7204),
    [sym_nullptr] = ACTIONS(7204),
  },
  [3188] = {
    [sym_compound_statement] = STATE(3203),
    [sym_labeled_statement] = STATE(3203),
    [sym_expression_statement] = STATE(3203),
    [sym_if_statement] = STATE(3203),
    [sym_switch_statement] = STATE(3203),
    [sym_case_statement] = STATE(3203),
    [sym_while_statement] = STATE(3203),
    [sym_do_statement] = STATE(3203),
    [sym_for_statement] = STATE(3203),
    [sym_return_statement] = STATE(3203),
    [sym_break_statement] = STATE(3203),
    [sym_continue_statement] = STATE(3203),
    [sym_goto_statement] = STATE(3203),
    [sym__expression] = STATE(2378),
    [sym_comma_expression] = STATE(2379),
    [sym_conditional_expression] = STATE(2378),
    [sym_assignment_expression] = STATE(2378),
    [sym_pointer_expression] = STATE(2378),
    [sym_logical_expression] = STATE(2378),
    [sym_bitwise_expression] = STATE(2378),
    [sym_equality_expression] = STATE(2378),
    [sym_relational_expression] = STATE(2378),
    [sym_shift_expression] = STATE(2378),
    [sym_math_expression] = STATE(2378),
    [sym_cast_expression] = STATE(2378),
    [sym_sizeof_expression] = STATE(2378),
    [sym_subscript_expression] = STATE(2378),
    [sym_call_expression] = STATE(2378),
    [sym_field_expression] = STATE(2378),
    [sym_compound_literal_expression] = STATE(2378),
    [sym_parenthesized_expression] = STATE(2378),
    [sym_concatenated_string] = STATE(2378),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(2378),
    [sym_for_range_loop] = STATE(3203),
    [sym_new_expression] = STATE(2378),
    [sym_delete_expression] = STATE(2378),
    [sym_lambda_expression] = STATE(2378),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(5538),
    [anon_sym_LPAREN] = ACTIONS(626),
    [anon_sym_SEMI] = ACTIONS(5540),
    [anon_sym_LBRACE] = ACTIONS(5542),
    [anon_sym_STAR] = ACTIONS(644),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_if] = ACTIONS(5544),
    [anon_sym_switch] = ACTIONS(5546),
    [anon_sym_case] = ACTIONS(5548),
    [anon_sym_default] = ACTIONS(5550),
    [anon_sym_while] = ACTIONS(5552),
    [anon_sym_do] = ACTIONS(5554),
    [anon_sym_for] = ACTIONS(5556),
    [anon_sym_return] = ACTIONS(5558),
    [anon_sym_break] = ACTIONS(5560),
    [anon_sym_continue] = ACTIONS(5562),
    [anon_sym_goto] = ACTIONS(5564),
    [anon_sym_AMP] = ACTIONS(644),
    [anon_sym_BANG] = ACTIONS(668),
    [anon_sym_TILDE] = ACTIONS(670),
    [anon_sym_PLUS] = ACTIONS(672),
    [anon_sym_DASH] = ACTIONS(672),
    [anon_sym_DASH_DASH] = ACTIONS(674),
    [anon_sym_PLUS_PLUS] = ACTIONS(674),
    [anon_sym_sizeof] = ACTIONS(676),
    [sym_number_literal] = ACTIONS(5538),
    [sym_char_literal] = ACTIONS(5538),
    [sym_string_literal] = ACTIONS(678),
    [sym_true] = ACTIONS(5566),
    [sym_false] = ACTIONS(5566),
    [sym_null] = ACTIONS(5566),
    [sym_identifier] = ACTIONS(5568),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1303),
    [anon_sym_delete] = ACTIONS(686),
    [sym_nullptr] = ACTIONS(5566),
  },
  [3189] = {
    [sym_compound_statement] = STATE(3074),
    [sym_labeled_statement] = STATE(3074),
    [sym_expression_statement] = STATE(3074),
    [sym_if_statement] = STATE(3074),
    [sym_switch_statement] = STATE(3074),
    [sym_case_statement] = STATE(3074),
    [sym_while_statement] = STATE(3074),
    [sym_do_statement] = STATE(3074),
    [sym_for_statement] = STATE(3074),
    [sym_return_statement] = STATE(3074),
    [sym_break_statement] = STATE(3074),
    [sym_continue_statement] = STATE(3074),
    [sym_goto_statement] = STATE(3074),
    [sym__expression] = STATE(873),
    [sym_comma_expression] = STATE(874),
    [sym_conditional_expression] = STATE(873),
    [sym_assignment_expression] = STATE(873),
    [sym_pointer_expression] = STATE(873),
    [sym_logical_expression] = STATE(873),
    [sym_bitwise_expression] = STATE(873),
    [sym_equality_expression] = STATE(873),
    [sym_relational_expression] = STATE(873),
    [sym_shift_expression] = STATE(873),
    [sym_math_expression] = STATE(873),
    [sym_cast_expression] = STATE(873),
    [sym_sizeof_expression] = STATE(873),
    [sym_subscript_expression] = STATE(873),
    [sym_call_expression] = STATE(873),
    [sym_field_expression] = STATE(873),
    [sym_compound_literal_expression] = STATE(873),
    [sym_parenthesized_expression] = STATE(873),
    [sym_concatenated_string] = STATE(873),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(873),
    [sym_for_range_loop] = STATE(3074),
    [sym_new_expression] = STATE(873),
    [sym_delete_expression] = STATE(873),
    [sym_lambda_expression] = STATE(873),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(1660),
    [anon_sym_LPAREN] = ACTIONS(626),
    [anon_sym_SEMI] = ACTIONS(1662),
    [anon_sym_LBRACE] = ACTIONS(1664),
    [anon_sym_STAR] = ACTIONS(644),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_if] = ACTIONS(6297),
    [anon_sym_switch] = ACTIONS(6299),
    [anon_sym_case] = ACTIONS(6301),
    [anon_sym_default] = ACTIONS(6303),
    [anon_sym_while] = ACTIONS(6305),
    [anon_sym_do] = ACTIONS(1676),
    [anon_sym_for] = ACTIONS(6307),
    [anon_sym_return] = ACTIONS(1680),
    [anon_sym_break] = ACTIONS(1682),
    [anon_sym_continue] = ACTIONS(1684),
    [anon_sym_goto] = ACTIONS(1686),
    [anon_sym_AMP] = ACTIONS(644),
    [anon_sym_BANG] = ACTIONS(668),
    [anon_sym_TILDE] = ACTIONS(670),
    [anon_sym_PLUS] = ACTIONS(672),
    [anon_sym_DASH] = ACTIONS(672),
    [anon_sym_DASH_DASH] = ACTIONS(674),
    [anon_sym_PLUS_PLUS] = ACTIONS(674),
    [anon_sym_sizeof] = ACTIONS(676),
    [sym_number_literal] = ACTIONS(1660),
    [sym_char_literal] = ACTIONS(1660),
    [sym_string_literal] = ACTIONS(678),
    [sym_true] = ACTIONS(1688),
    [sym_false] = ACTIONS(1688),
    [sym_null] = ACTIONS(1688),
    [sym_identifier] = ACTIONS(6309),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1303),
    [anon_sym_delete] = ACTIONS(686),
    [sym_nullptr] = ACTIONS(1688),
  },
  [3190] = {
    [aux_sym_for_statement_repeat1] = STATE(2796),
    [anon_sym_COMMA] = ACTIONS(6339),
    [anon_sym_RPAREN] = ACTIONS(7396),
    [sym_comment] = ACTIONS(49),
  },
  [3191] = {
    [sym_raw_string_literal] = ACTIONS(6864),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(6866),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(6866),
    [anon_sym_LPAREN] = ACTIONS(6864),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(6866),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(6866),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(6866),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(6866),
    [sym_preproc_directive] = ACTIONS(6866),
    [anon_sym_SEMI] = ACTIONS(6864),
    [anon_sym_typedef] = ACTIONS(6866),
    [anon_sym_extern] = ACTIONS(6866),
    [anon_sym_LBRACE] = ACTIONS(6864),
    [anon_sym_STAR] = ACTIONS(6864),
    [anon_sym_LBRACK] = ACTIONS(6864),
    [anon_sym_static] = ACTIONS(6866),
    [anon_sym_register] = ACTIONS(6866),
    [anon_sym_inline] = ACTIONS(6866),
    [anon_sym_const] = ACTIONS(6866),
    [anon_sym_restrict] = ACTIONS(6866),
    [anon_sym_volatile] = ACTIONS(6866),
    [anon_sym__Atomic] = ACTIONS(6866),
    [anon_sym_mutable] = ACTIONS(6866),
    [anon_sym_explicit] = ACTIONS(6866),
    [anon_sym_constexpr] = ACTIONS(6866),
    [anon_sym_unsigned] = ACTIONS(6866),
    [anon_sym_long] = ACTIONS(6866),
    [anon_sym_short] = ACTIONS(6866),
    [sym_primitive_type] = ACTIONS(6866),
    [anon_sym_enum] = ACTIONS(6866),
    [anon_sym_struct] = ACTIONS(6866),
    [anon_sym_union] = ACTIONS(6866),
    [anon_sym_if] = ACTIONS(6866),
    [anon_sym_else] = ACTIONS(6866),
    [anon_sym_switch] = ACTIONS(6866),
    [anon_sym_case] = ACTIONS(6866),
    [anon_sym_default] = ACTIONS(6866),
    [anon_sym_while] = ACTIONS(6866),
    [anon_sym_do] = ACTIONS(6866),
    [anon_sym_for] = ACTIONS(6866),
    [anon_sym_return] = ACTIONS(6866),
    [anon_sym_break] = ACTIONS(6866),
    [anon_sym_continue] = ACTIONS(6866),
    [anon_sym_goto] = ACTIONS(6866),
    [anon_sym_AMP] = ACTIONS(6864),
    [anon_sym_BANG] = ACTIONS(6864),
    [anon_sym_TILDE] = ACTIONS(6864),
    [anon_sym_PLUS] = ACTIONS(6866),
    [anon_sym_DASH] = ACTIONS(6866),
    [anon_sym_DASH_DASH] = ACTIONS(6864),
    [anon_sym_PLUS_PLUS] = ACTIONS(6864),
    [anon_sym_sizeof] = ACTIONS(6866),
    [sym_number_literal] = ACTIONS(6864),
    [sym_char_literal] = ACTIONS(6864),
    [sym_string_literal] = ACTIONS(6864),
    [sym_true] = ACTIONS(6866),
    [sym_false] = ACTIONS(6866),
    [sym_null] = ACTIONS(6866),
    [sym_identifier] = ACTIONS(6866),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(6866),
    [sym_auto] = ACTIONS(6866),
    [anon_sym_typename] = ACTIONS(6866),
    [anon_sym_new] = ACTIONS(6866),
    [anon_sym_COLON_COLON] = ACTIONS(6864),
    [anon_sym_delete] = ACTIONS(6866),
    [sym_nullptr] = ACTIONS(6866),
  },
  [3192] = {
    [sym_compound_statement] = STATE(3205),
    [sym_labeled_statement] = STATE(3205),
    [sym_expression_statement] = STATE(3205),
    [sym_if_statement] = STATE(3205),
    [sym_switch_statement] = STATE(3205),
    [sym_case_statement] = STATE(3205),
    [sym_while_statement] = STATE(3205),
    [sym_do_statement] = STATE(3205),
    [sym_for_statement] = STATE(3205),
    [sym_return_statement] = STATE(3205),
    [sym_break_statement] = STATE(3205),
    [sym_continue_statement] = STATE(3205),
    [sym_goto_statement] = STATE(3205),
    [sym__expression] = STATE(2844),
    [sym_comma_expression] = STATE(2845),
    [sym_conditional_expression] = STATE(2844),
    [sym_assignment_expression] = STATE(2844),
    [sym_pointer_expression] = STATE(2844),
    [sym_logical_expression] = STATE(2844),
    [sym_bitwise_expression] = STATE(2844),
    [sym_equality_expression] = STATE(2844),
    [sym_relational_expression] = STATE(2844),
    [sym_shift_expression] = STATE(2844),
    [sym_math_expression] = STATE(2844),
    [sym_cast_expression] = STATE(2844),
    [sym_sizeof_expression] = STATE(2844),
    [sym_subscript_expression] = STATE(2844),
    [sym_call_expression] = STATE(2844),
    [sym_field_expression] = STATE(2844),
    [sym_compound_literal_expression] = STATE(2844),
    [sym_parenthesized_expression] = STATE(2844),
    [sym_concatenated_string] = STATE(2844),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(2844),
    [sym_for_range_loop] = STATE(3205),
    [sym_new_expression] = STATE(2844),
    [sym_delete_expression] = STATE(2844),
    [sym_lambda_expression] = STATE(2844),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(6732),
    [anon_sym_LPAREN] = ACTIONS(626),
    [anon_sym_SEMI] = ACTIONS(6734),
    [anon_sym_LBRACE] = ACTIONS(6736),
    [anon_sym_STAR] = ACTIONS(644),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_if] = ACTIONS(6738),
    [anon_sym_switch] = ACTIONS(6740),
    [anon_sym_case] = ACTIONS(6742),
    [anon_sym_default] = ACTIONS(6744),
    [anon_sym_while] = ACTIONS(6746),
    [anon_sym_do] = ACTIONS(6748),
    [anon_sym_for] = ACTIONS(6750),
    [anon_sym_return] = ACTIONS(6752),
    [anon_sym_break] = ACTIONS(6754),
    [anon_sym_continue] = ACTIONS(6756),
    [anon_sym_goto] = ACTIONS(6758),
    [anon_sym_AMP] = ACTIONS(644),
    [anon_sym_BANG] = ACTIONS(668),
    [anon_sym_TILDE] = ACTIONS(670),
    [anon_sym_PLUS] = ACTIONS(672),
    [anon_sym_DASH] = ACTIONS(672),
    [anon_sym_DASH_DASH] = ACTIONS(674),
    [anon_sym_PLUS_PLUS] = ACTIONS(674),
    [anon_sym_sizeof] = ACTIONS(676),
    [sym_number_literal] = ACTIONS(6732),
    [sym_char_literal] = ACTIONS(6732),
    [sym_string_literal] = ACTIONS(678),
    [sym_true] = ACTIONS(6760),
    [sym_false] = ACTIONS(6760),
    [sym_null] = ACTIONS(6760),
    [sym_identifier] = ACTIONS(6762),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1303),
    [anon_sym_delete] = ACTIONS(686),
    [sym_nullptr] = ACTIONS(6760),
  },
  [3193] = {
    [sym_raw_string_literal] = ACTIONS(3519),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3521),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3521),
    [anon_sym_LPAREN] = ACTIONS(3519),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3521),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3521),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3521),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3521),
    [sym_preproc_directive] = ACTIONS(3521),
    [anon_sym_SEMI] = ACTIONS(3519),
    [anon_sym_typedef] = ACTIONS(3521),
    [anon_sym_extern] = ACTIONS(3521),
    [anon_sym_LBRACE] = ACTIONS(3519),
    [anon_sym_STAR] = ACTIONS(3519),
    [anon_sym_LBRACK] = ACTIONS(3519),
    [anon_sym_static] = ACTIONS(3521),
    [anon_sym_register] = ACTIONS(3521),
    [anon_sym_inline] = ACTIONS(3521),
    [anon_sym_const] = ACTIONS(3521),
    [anon_sym_restrict] = ACTIONS(3521),
    [anon_sym_volatile] = ACTIONS(3521),
    [anon_sym__Atomic] = ACTIONS(3521),
    [anon_sym_mutable] = ACTIONS(3521),
    [anon_sym_explicit] = ACTIONS(3521),
    [anon_sym_constexpr] = ACTIONS(3521),
    [anon_sym_unsigned] = ACTIONS(3521),
    [anon_sym_long] = ACTIONS(3521),
    [anon_sym_short] = ACTIONS(3521),
    [sym_primitive_type] = ACTIONS(3521),
    [anon_sym_enum] = ACTIONS(3521),
    [anon_sym_struct] = ACTIONS(3521),
    [anon_sym_union] = ACTIONS(3521),
    [anon_sym_if] = ACTIONS(3521),
    [anon_sym_else] = ACTIONS(3521),
    [anon_sym_switch] = ACTIONS(3521),
    [anon_sym_case] = ACTIONS(3521),
    [anon_sym_default] = ACTIONS(3521),
    [anon_sym_while] = ACTIONS(3521),
    [anon_sym_do] = ACTIONS(3521),
    [anon_sym_for] = ACTIONS(3521),
    [anon_sym_return] = ACTIONS(3521),
    [anon_sym_break] = ACTIONS(3521),
    [anon_sym_continue] = ACTIONS(3521),
    [anon_sym_goto] = ACTIONS(3521),
    [anon_sym_AMP] = ACTIONS(3519),
    [anon_sym_BANG] = ACTIONS(3519),
    [anon_sym_TILDE] = ACTIONS(3519),
    [anon_sym_PLUS] = ACTIONS(3521),
    [anon_sym_DASH] = ACTIONS(3521),
    [anon_sym_DASH_DASH] = ACTIONS(3519),
    [anon_sym_PLUS_PLUS] = ACTIONS(3519),
    [anon_sym_sizeof] = ACTIONS(3521),
    [sym_number_literal] = ACTIONS(3519),
    [sym_char_literal] = ACTIONS(3519),
    [sym_string_literal] = ACTIONS(3519),
    [sym_true] = ACTIONS(3521),
    [sym_false] = ACTIONS(3521),
    [sym_null] = ACTIONS(3521),
    [sym_identifier] = ACTIONS(3521),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(3521),
    [sym_auto] = ACTIONS(3521),
    [anon_sym_typename] = ACTIONS(3521),
    [anon_sym_new] = ACTIONS(3521),
    [anon_sym_COLON_COLON] = ACTIONS(3519),
    [anon_sym_delete] = ACTIONS(3521),
    [sym_nullptr] = ACTIONS(3521),
  },
  [3194] = {
    [sym_raw_string_literal] = ACTIONS(6902),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(6904),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(6904),
    [anon_sym_LPAREN] = ACTIONS(6902),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(6904),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(6904),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(6904),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(6904),
    [sym_preproc_directive] = ACTIONS(6904),
    [anon_sym_SEMI] = ACTIONS(6902),
    [anon_sym_typedef] = ACTIONS(6904),
    [anon_sym_extern] = ACTIONS(6904),
    [anon_sym_LBRACE] = ACTIONS(6902),
    [anon_sym_STAR] = ACTIONS(6902),
    [anon_sym_LBRACK] = ACTIONS(6902),
    [anon_sym_static] = ACTIONS(6904),
    [anon_sym_register] = ACTIONS(6904),
    [anon_sym_inline] = ACTIONS(6904),
    [anon_sym_const] = ACTIONS(6904),
    [anon_sym_restrict] = ACTIONS(6904),
    [anon_sym_volatile] = ACTIONS(6904),
    [anon_sym__Atomic] = ACTIONS(6904),
    [anon_sym_mutable] = ACTIONS(6904),
    [anon_sym_explicit] = ACTIONS(6904),
    [anon_sym_constexpr] = ACTIONS(6904),
    [anon_sym_unsigned] = ACTIONS(6904),
    [anon_sym_long] = ACTIONS(6904),
    [anon_sym_short] = ACTIONS(6904),
    [sym_primitive_type] = ACTIONS(6904),
    [anon_sym_enum] = ACTIONS(6904),
    [anon_sym_struct] = ACTIONS(6904),
    [anon_sym_union] = ACTIONS(6904),
    [anon_sym_if] = ACTIONS(6904),
    [anon_sym_else] = ACTIONS(6904),
    [anon_sym_switch] = ACTIONS(6904),
    [anon_sym_case] = ACTIONS(6904),
    [anon_sym_default] = ACTIONS(6904),
    [anon_sym_while] = ACTIONS(6904),
    [anon_sym_do] = ACTIONS(6904),
    [anon_sym_for] = ACTIONS(6904),
    [anon_sym_return] = ACTIONS(6904),
    [anon_sym_break] = ACTIONS(6904),
    [anon_sym_continue] = ACTIONS(6904),
    [anon_sym_goto] = ACTIONS(6904),
    [anon_sym_AMP] = ACTIONS(6902),
    [anon_sym_BANG] = ACTIONS(6902),
    [anon_sym_TILDE] = ACTIONS(6902),
    [anon_sym_PLUS] = ACTIONS(6904),
    [anon_sym_DASH] = ACTIONS(6904),
    [anon_sym_DASH_DASH] = ACTIONS(6902),
    [anon_sym_PLUS_PLUS] = ACTIONS(6902),
    [anon_sym_sizeof] = ACTIONS(6904),
    [sym_number_literal] = ACTIONS(6902),
    [sym_char_literal] = ACTIONS(6902),
    [sym_string_literal] = ACTIONS(6902),
    [sym_true] = ACTIONS(6904),
    [sym_false] = ACTIONS(6904),
    [sym_null] = ACTIONS(6904),
    [sym_identifier] = ACTIONS(6904),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(6904),
    [sym_auto] = ACTIONS(6904),
    [anon_sym_typename] = ACTIONS(6904),
    [anon_sym_new] = ACTIONS(6904),
    [anon_sym_COLON_COLON] = ACTIONS(6902),
    [anon_sym_delete] = ACTIONS(6904),
    [sym_nullptr] = ACTIONS(6904),
  },
  [3195] = {
    [sym_compound_statement] = STATE(3206),
    [sym_labeled_statement] = STATE(3206),
    [sym_expression_statement] = STATE(3206),
    [sym_if_statement] = STATE(3206),
    [sym_switch_statement] = STATE(3206),
    [sym_case_statement] = STATE(3206),
    [sym_while_statement] = STATE(3206),
    [sym_do_statement] = STATE(3206),
    [sym_for_statement] = STATE(3206),
    [sym_return_statement] = STATE(3206),
    [sym_break_statement] = STATE(3206),
    [sym_continue_statement] = STATE(3206),
    [sym_goto_statement] = STATE(3206),
    [sym__expression] = STATE(2844),
    [sym_comma_expression] = STATE(2845),
    [sym_conditional_expression] = STATE(2844),
    [sym_assignment_expression] = STATE(2844),
    [sym_pointer_expression] = STATE(2844),
    [sym_logical_expression] = STATE(2844),
    [sym_bitwise_expression] = STATE(2844),
    [sym_equality_expression] = STATE(2844),
    [sym_relational_expression] = STATE(2844),
    [sym_shift_expression] = STATE(2844),
    [sym_math_expression] = STATE(2844),
    [sym_cast_expression] = STATE(2844),
    [sym_sizeof_expression] = STATE(2844),
    [sym_subscript_expression] = STATE(2844),
    [sym_call_expression] = STATE(2844),
    [sym_field_expression] = STATE(2844),
    [sym_compound_literal_expression] = STATE(2844),
    [sym_parenthesized_expression] = STATE(2844),
    [sym_concatenated_string] = STATE(2844),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(2844),
    [sym_for_range_loop] = STATE(3206),
    [sym_new_expression] = STATE(2844),
    [sym_delete_expression] = STATE(2844),
    [sym_lambda_expression] = STATE(2844),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(6732),
    [anon_sym_LPAREN] = ACTIONS(626),
    [anon_sym_SEMI] = ACTIONS(6734),
    [anon_sym_LBRACE] = ACTIONS(6736),
    [anon_sym_STAR] = ACTIONS(644),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_if] = ACTIONS(6738),
    [anon_sym_switch] = ACTIONS(6740),
    [anon_sym_case] = ACTIONS(6742),
    [anon_sym_default] = ACTIONS(6744),
    [anon_sym_while] = ACTIONS(6746),
    [anon_sym_do] = ACTIONS(6748),
    [anon_sym_for] = ACTIONS(6750),
    [anon_sym_return] = ACTIONS(6752),
    [anon_sym_break] = ACTIONS(6754),
    [anon_sym_continue] = ACTIONS(6756),
    [anon_sym_goto] = ACTIONS(6758),
    [anon_sym_AMP] = ACTIONS(644),
    [anon_sym_BANG] = ACTIONS(668),
    [anon_sym_TILDE] = ACTIONS(670),
    [anon_sym_PLUS] = ACTIONS(672),
    [anon_sym_DASH] = ACTIONS(672),
    [anon_sym_DASH_DASH] = ACTIONS(674),
    [anon_sym_PLUS_PLUS] = ACTIONS(674),
    [anon_sym_sizeof] = ACTIONS(676),
    [sym_number_literal] = ACTIONS(6732),
    [sym_char_literal] = ACTIONS(6732),
    [sym_string_literal] = ACTIONS(678),
    [sym_true] = ACTIONS(6760),
    [sym_false] = ACTIONS(6760),
    [sym_null] = ACTIONS(6760),
    [sym_identifier] = ACTIONS(6762),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1303),
    [anon_sym_delete] = ACTIONS(686),
    [sym_nullptr] = ACTIONS(6760),
  },
  [3196] = {
    [aux_sym_for_statement_repeat1] = STATE(2796),
    [anon_sym_COMMA] = ACTIONS(6339),
    [anon_sym_RPAREN] = ACTIONS(7398),
    [sym_comment] = ACTIONS(49),
  },
  [3197] = {
    [sym_argument_list] = STATE(802),
    [aux_sym_for_statement_repeat1] = STATE(3208),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_COMMA] = ACTIONS(6339),
    [anon_sym_RPAREN] = ACTIONS(7398),
    [anon_sym_STAR] = ACTIONS(2234),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_EQ] = ACTIONS(2236),
    [anon_sym_QMARK] = ACTIONS(2238),
    [anon_sym_STAR_EQ] = ACTIONS(2240),
    [anon_sym_SLASH_EQ] = ACTIONS(2240),
    [anon_sym_PERCENT_EQ] = ACTIONS(2240),
    [anon_sym_PLUS_EQ] = ACTIONS(2240),
    [anon_sym_DASH_EQ] = ACTIONS(2240),
    [anon_sym_LT_LT_EQ] = ACTIONS(2240),
    [anon_sym_GT_GT_EQ] = ACTIONS(2240),
    [anon_sym_AMP_EQ] = ACTIONS(2240),
    [anon_sym_CARET_EQ] = ACTIONS(2240),
    [anon_sym_PIPE_EQ] = ACTIONS(2240),
    [anon_sym_AMP] = ACTIONS(2242),
    [anon_sym_PIPE_PIPE] = ACTIONS(2244),
    [anon_sym_AMP_AMP] = ACTIONS(2246),
    [anon_sym_PIPE] = ACTIONS(2248),
    [anon_sym_CARET] = ACTIONS(2250),
    [anon_sym_EQ_EQ] = ACTIONS(2252),
    [anon_sym_BANG_EQ] = ACTIONS(2252),
    [anon_sym_LT] = ACTIONS(2254),
    [anon_sym_GT] = ACTIONS(2254),
    [anon_sym_LT_EQ] = ACTIONS(2256),
    [anon_sym_GT_EQ] = ACTIONS(2256),
    [anon_sym_LT_LT] = ACTIONS(2258),
    [anon_sym_GT_GT] = ACTIONS(2258),
    [anon_sym_PLUS] = ACTIONS(2260),
    [anon_sym_DASH] = ACTIONS(2260),
    [anon_sym_SLASH] = ACTIONS(2234),
    [anon_sym_PERCENT] = ACTIONS(2234),
    [anon_sym_DASH_DASH] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(1554),
    [anon_sym_DASH_GT] = ACTIONS(1554),
    [sym_comment] = ACTIONS(49),
  },
  [3198] = {
    [sym_raw_string_literal] = ACTIONS(6925),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(6927),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(6927),
    [anon_sym_LPAREN] = ACTIONS(6925),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(6927),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(6927),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(6927),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(6927),
    [sym_preproc_directive] = ACTIONS(6927),
    [anon_sym_SEMI] = ACTIONS(6925),
    [anon_sym_typedef] = ACTIONS(6927),
    [anon_sym_extern] = ACTIONS(6927),
    [anon_sym_LBRACE] = ACTIONS(6925),
    [anon_sym_STAR] = ACTIONS(6925),
    [anon_sym_LBRACK] = ACTIONS(6925),
    [anon_sym_static] = ACTIONS(6927),
    [anon_sym_register] = ACTIONS(6927),
    [anon_sym_inline] = ACTIONS(6927),
    [anon_sym_const] = ACTIONS(6927),
    [anon_sym_restrict] = ACTIONS(6927),
    [anon_sym_volatile] = ACTIONS(6927),
    [anon_sym__Atomic] = ACTIONS(6927),
    [anon_sym_mutable] = ACTIONS(6927),
    [anon_sym_explicit] = ACTIONS(6927),
    [anon_sym_constexpr] = ACTIONS(6927),
    [anon_sym_unsigned] = ACTIONS(6927),
    [anon_sym_long] = ACTIONS(6927),
    [anon_sym_short] = ACTIONS(6927),
    [sym_primitive_type] = ACTIONS(6927),
    [anon_sym_enum] = ACTIONS(6927),
    [anon_sym_struct] = ACTIONS(6927),
    [anon_sym_union] = ACTIONS(6927),
    [anon_sym_if] = ACTIONS(6927),
    [anon_sym_else] = ACTIONS(6927),
    [anon_sym_switch] = ACTIONS(6927),
    [anon_sym_case] = ACTIONS(6927),
    [anon_sym_default] = ACTIONS(6927),
    [anon_sym_while] = ACTIONS(6927),
    [anon_sym_do] = ACTIONS(6927),
    [anon_sym_for] = ACTIONS(6927),
    [anon_sym_return] = ACTIONS(6927),
    [anon_sym_break] = ACTIONS(6927),
    [anon_sym_continue] = ACTIONS(6927),
    [anon_sym_goto] = ACTIONS(6927),
    [anon_sym_AMP] = ACTIONS(6925),
    [anon_sym_BANG] = ACTIONS(6925),
    [anon_sym_TILDE] = ACTIONS(6925),
    [anon_sym_PLUS] = ACTIONS(6927),
    [anon_sym_DASH] = ACTIONS(6927),
    [anon_sym_DASH_DASH] = ACTIONS(6925),
    [anon_sym_PLUS_PLUS] = ACTIONS(6925),
    [anon_sym_sizeof] = ACTIONS(6927),
    [sym_number_literal] = ACTIONS(6925),
    [sym_char_literal] = ACTIONS(6925),
    [sym_string_literal] = ACTIONS(6925),
    [sym_true] = ACTIONS(6927),
    [sym_false] = ACTIONS(6927),
    [sym_null] = ACTIONS(6927),
    [sym_identifier] = ACTIONS(6927),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(6927),
    [sym_auto] = ACTIONS(6927),
    [anon_sym_typename] = ACTIONS(6927),
    [anon_sym_new] = ACTIONS(6927),
    [anon_sym_COLON_COLON] = ACTIONS(6925),
    [anon_sym_delete] = ACTIONS(6927),
    [sym_nullptr] = ACTIONS(6927),
  },
  [3199] = {
    [sym_raw_string_literal] = ACTIONS(7057),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(7059),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(7059),
    [anon_sym_LPAREN] = ACTIONS(7057),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(7059),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(7059),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(7059),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(7059),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(7059),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(7059),
    [sym_preproc_directive] = ACTIONS(7059),
    [anon_sym_SEMI] = ACTIONS(7057),
    [anon_sym_typedef] = ACTIONS(7059),
    [anon_sym_extern] = ACTIONS(7059),
    [anon_sym_LBRACE] = ACTIONS(7057),
    [anon_sym_STAR] = ACTIONS(7057),
    [anon_sym_LBRACK] = ACTIONS(7057),
    [anon_sym_static] = ACTIONS(7059),
    [anon_sym_register] = ACTIONS(7059),
    [anon_sym_inline] = ACTIONS(7059),
    [anon_sym_const] = ACTIONS(7059),
    [anon_sym_restrict] = ACTIONS(7059),
    [anon_sym_volatile] = ACTIONS(7059),
    [anon_sym__Atomic] = ACTIONS(7059),
    [anon_sym_mutable] = ACTIONS(7059),
    [anon_sym_explicit] = ACTIONS(7059),
    [anon_sym_constexpr] = ACTIONS(7059),
    [anon_sym_unsigned] = ACTIONS(7059),
    [anon_sym_long] = ACTIONS(7059),
    [anon_sym_short] = ACTIONS(7059),
    [sym_primitive_type] = ACTIONS(7059),
    [anon_sym_enum] = ACTIONS(7059),
    [anon_sym_struct] = ACTIONS(7059),
    [anon_sym_union] = ACTIONS(7059),
    [anon_sym_if] = ACTIONS(7059),
    [anon_sym_else] = ACTIONS(7059),
    [anon_sym_switch] = ACTIONS(7059),
    [anon_sym_case] = ACTIONS(7059),
    [anon_sym_default] = ACTIONS(7059),
    [anon_sym_while] = ACTIONS(7059),
    [anon_sym_do] = ACTIONS(7059),
    [anon_sym_for] = ACTIONS(7059),
    [anon_sym_return] = ACTIONS(7059),
    [anon_sym_break] = ACTIONS(7059),
    [anon_sym_continue] = ACTIONS(7059),
    [anon_sym_goto] = ACTIONS(7059),
    [anon_sym_AMP] = ACTIONS(7057),
    [anon_sym_BANG] = ACTIONS(7057),
    [anon_sym_TILDE] = ACTIONS(7057),
    [anon_sym_PLUS] = ACTIONS(7059),
    [anon_sym_DASH] = ACTIONS(7059),
    [anon_sym_DASH_DASH] = ACTIONS(7057),
    [anon_sym_PLUS_PLUS] = ACTIONS(7057),
    [anon_sym_sizeof] = ACTIONS(7059),
    [sym_number_literal] = ACTIONS(7057),
    [sym_char_literal] = ACTIONS(7057),
    [sym_string_literal] = ACTIONS(7057),
    [sym_true] = ACTIONS(7059),
    [sym_false] = ACTIONS(7059),
    [sym_null] = ACTIONS(7059),
    [sym_identifier] = ACTIONS(7059),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(7059),
    [sym_auto] = ACTIONS(7059),
    [anon_sym_typename] = ACTIONS(7059),
    [anon_sym_new] = ACTIONS(7059),
    [anon_sym_COLON_COLON] = ACTIONS(7057),
    [anon_sym_delete] = ACTIONS(7059),
    [sym_nullptr] = ACTIONS(7059),
  },
  [3200] = {
    [sym_raw_string_literal] = ACTIONS(7083),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(7085),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(7085),
    [anon_sym_LPAREN] = ACTIONS(7083),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(7085),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(7085),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(7085),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(7085),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(7085),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(7085),
    [sym_preproc_directive] = ACTIONS(7085),
    [anon_sym_SEMI] = ACTIONS(7083),
    [anon_sym_typedef] = ACTIONS(7085),
    [anon_sym_extern] = ACTIONS(7085),
    [anon_sym_LBRACE] = ACTIONS(7083),
    [anon_sym_STAR] = ACTIONS(7083),
    [anon_sym_LBRACK] = ACTIONS(7083),
    [anon_sym_static] = ACTIONS(7085),
    [anon_sym_register] = ACTIONS(7085),
    [anon_sym_inline] = ACTIONS(7085),
    [anon_sym_const] = ACTIONS(7085),
    [anon_sym_restrict] = ACTIONS(7085),
    [anon_sym_volatile] = ACTIONS(7085),
    [anon_sym__Atomic] = ACTIONS(7085),
    [anon_sym_mutable] = ACTIONS(7085),
    [anon_sym_explicit] = ACTIONS(7085),
    [anon_sym_constexpr] = ACTIONS(7085),
    [anon_sym_unsigned] = ACTIONS(7085),
    [anon_sym_long] = ACTIONS(7085),
    [anon_sym_short] = ACTIONS(7085),
    [sym_primitive_type] = ACTIONS(7085),
    [anon_sym_enum] = ACTIONS(7085),
    [anon_sym_struct] = ACTIONS(7085),
    [anon_sym_union] = ACTIONS(7085),
    [anon_sym_if] = ACTIONS(7085),
    [anon_sym_else] = ACTIONS(7085),
    [anon_sym_switch] = ACTIONS(7085),
    [anon_sym_case] = ACTIONS(7085),
    [anon_sym_default] = ACTIONS(7085),
    [anon_sym_while] = ACTIONS(7085),
    [anon_sym_do] = ACTIONS(7085),
    [anon_sym_for] = ACTIONS(7085),
    [anon_sym_return] = ACTIONS(7085),
    [anon_sym_break] = ACTIONS(7085),
    [anon_sym_continue] = ACTIONS(7085),
    [anon_sym_goto] = ACTIONS(7085),
    [anon_sym_AMP] = ACTIONS(7083),
    [anon_sym_BANG] = ACTIONS(7083),
    [anon_sym_TILDE] = ACTIONS(7083),
    [anon_sym_PLUS] = ACTIONS(7085),
    [anon_sym_DASH] = ACTIONS(7085),
    [anon_sym_DASH_DASH] = ACTIONS(7083),
    [anon_sym_PLUS_PLUS] = ACTIONS(7083),
    [anon_sym_sizeof] = ACTIONS(7085),
    [sym_number_literal] = ACTIONS(7083),
    [sym_char_literal] = ACTIONS(7083),
    [sym_string_literal] = ACTIONS(7083),
    [sym_true] = ACTIONS(7085),
    [sym_false] = ACTIONS(7085),
    [sym_null] = ACTIONS(7085),
    [sym_identifier] = ACTIONS(7085),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(7085),
    [sym_auto] = ACTIONS(7085),
    [anon_sym_typename] = ACTIONS(7085),
    [anon_sym_new] = ACTIONS(7085),
    [anon_sym_COLON_COLON] = ACTIONS(7083),
    [anon_sym_delete] = ACTIONS(7085),
    [sym_nullptr] = ACTIONS(7085),
  },
  [3201] = {
    [sym_compound_statement] = STATE(3209),
    [sym_labeled_statement] = STATE(3209),
    [sym_expression_statement] = STATE(3209),
    [sym_if_statement] = STATE(3209),
    [sym_switch_statement] = STATE(3209),
    [sym_case_statement] = STATE(3209),
    [sym_while_statement] = STATE(3209),
    [sym_do_statement] = STATE(3209),
    [sym_for_statement] = STATE(3209),
    [sym_return_statement] = STATE(3209),
    [sym_break_statement] = STATE(3209),
    [sym_continue_statement] = STATE(3209),
    [sym_goto_statement] = STATE(3209),
    [sym__expression] = STATE(2739),
    [sym_comma_expression] = STATE(2740),
    [sym_conditional_expression] = STATE(2739),
    [sym_assignment_expression] = STATE(2739),
    [sym_pointer_expression] = STATE(2739),
    [sym_logical_expression] = STATE(2739),
    [sym_bitwise_expression] = STATE(2739),
    [sym_equality_expression] = STATE(2739),
    [sym_relational_expression] = STATE(2739),
    [sym_shift_expression] = STATE(2739),
    [sym_math_expression] = STATE(2739),
    [sym_cast_expression] = STATE(2739),
    [sym_sizeof_expression] = STATE(2739),
    [sym_subscript_expression] = STATE(2739),
    [sym_call_expression] = STATE(2739),
    [sym_field_expression] = STATE(2739),
    [sym_compound_literal_expression] = STATE(2739),
    [sym_parenthesized_expression] = STATE(2739),
    [sym_concatenated_string] = STATE(2739),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(2739),
    [sym_for_range_loop] = STATE(3209),
    [sym_new_expression] = STATE(2739),
    [sym_delete_expression] = STATE(2739),
    [sym_lambda_expression] = STATE(2739),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(6507),
    [anon_sym_LPAREN] = ACTIONS(626),
    [anon_sym_SEMI] = ACTIONS(6509),
    [anon_sym_LBRACE] = ACTIONS(6511),
    [anon_sym_STAR] = ACTIONS(644),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_if] = ACTIONS(6513),
    [anon_sym_switch] = ACTIONS(6515),
    [anon_sym_case] = ACTIONS(6517),
    [anon_sym_default] = ACTIONS(6519),
    [anon_sym_while] = ACTIONS(6521),
    [anon_sym_do] = ACTIONS(6523),
    [anon_sym_for] = ACTIONS(6525),
    [anon_sym_return] = ACTIONS(6527),
    [anon_sym_break] = ACTIONS(6529),
    [anon_sym_continue] = ACTIONS(6531),
    [anon_sym_goto] = ACTIONS(6533),
    [anon_sym_AMP] = ACTIONS(644),
    [anon_sym_BANG] = ACTIONS(668),
    [anon_sym_TILDE] = ACTIONS(670),
    [anon_sym_PLUS] = ACTIONS(672),
    [anon_sym_DASH] = ACTIONS(672),
    [anon_sym_DASH_DASH] = ACTIONS(674),
    [anon_sym_PLUS_PLUS] = ACTIONS(674),
    [anon_sym_sizeof] = ACTIONS(676),
    [sym_number_literal] = ACTIONS(6507),
    [sym_char_literal] = ACTIONS(6507),
    [sym_string_literal] = ACTIONS(678),
    [sym_true] = ACTIONS(6535),
    [sym_false] = ACTIONS(6535),
    [sym_null] = ACTIONS(6535),
    [sym_identifier] = ACTIONS(6537),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1303),
    [anon_sym_delete] = ACTIONS(686),
    [sym_nullptr] = ACTIONS(6535),
  },
  [3202] = {
    [aux_sym_for_statement_repeat1] = STATE(2796),
    [anon_sym_COMMA] = ACTIONS(6339),
    [anon_sym_RPAREN] = ACTIONS(7400),
    [sym_comment] = ACTIONS(49),
  },
  [3203] = {
    [sym_raw_string_literal] = ACTIONS(7292),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(7294),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(7294),
    [anon_sym_LPAREN] = ACTIONS(7292),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(7294),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(7294),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(7294),
    [sym_preproc_directive] = ACTIONS(7294),
    [anon_sym_SEMI] = ACTIONS(7292),
    [anon_sym_typedef] = ACTIONS(7294),
    [anon_sym_extern] = ACTIONS(7294),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [anon_sym_RBRACE] = ACTIONS(7292),
    [anon_sym_STAR] = ACTIONS(7292),
    [anon_sym_LBRACK] = ACTIONS(7292),
    [anon_sym_static] = ACTIONS(7294),
    [anon_sym_register] = ACTIONS(7294),
    [anon_sym_inline] = ACTIONS(7294),
    [anon_sym_const] = ACTIONS(7294),
    [anon_sym_restrict] = ACTIONS(7294),
    [anon_sym_volatile] = ACTIONS(7294),
    [anon_sym__Atomic] = ACTIONS(7294),
    [anon_sym_mutable] = ACTIONS(7294),
    [anon_sym_explicit] = ACTIONS(7294),
    [anon_sym_constexpr] = ACTIONS(7294),
    [anon_sym_unsigned] = ACTIONS(7294),
    [anon_sym_long] = ACTIONS(7294),
    [anon_sym_short] = ACTIONS(7294),
    [sym_primitive_type] = ACTIONS(7294),
    [anon_sym_enum] = ACTIONS(7294),
    [anon_sym_struct] = ACTIONS(7294),
    [anon_sym_union] = ACTIONS(7294),
    [anon_sym_if] = ACTIONS(7294),
    [anon_sym_else] = ACTIONS(7294),
    [anon_sym_switch] = ACTIONS(7294),
    [anon_sym_case] = ACTIONS(7294),
    [anon_sym_default] = ACTIONS(7294),
    [anon_sym_while] = ACTIONS(7294),
    [anon_sym_do] = ACTIONS(7294),
    [anon_sym_for] = ACTIONS(7294),
    [anon_sym_return] = ACTIONS(7294),
    [anon_sym_break] = ACTIONS(7294),
    [anon_sym_continue] = ACTIONS(7294),
    [anon_sym_goto] = ACTIONS(7294),
    [anon_sym_AMP] = ACTIONS(7292),
    [anon_sym_BANG] = ACTIONS(7292),
    [anon_sym_TILDE] = ACTIONS(7292),
    [anon_sym_PLUS] = ACTIONS(7294),
    [anon_sym_DASH] = ACTIONS(7294),
    [anon_sym_DASH_DASH] = ACTIONS(7292),
    [anon_sym_PLUS_PLUS] = ACTIONS(7292),
    [anon_sym_sizeof] = ACTIONS(7294),
    [sym_number_literal] = ACTIONS(7292),
    [sym_char_literal] = ACTIONS(7292),
    [sym_string_literal] = ACTIONS(7292),
    [sym_true] = ACTIONS(7294),
    [sym_false] = ACTIONS(7294),
    [sym_null] = ACTIONS(7294),
    [sym_identifier] = ACTIONS(7294),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(7294),
    [sym_auto] = ACTIONS(7294),
    [anon_sym_typename] = ACTIONS(7294),
    [anon_sym_new] = ACTIONS(7294),
    [anon_sym_COLON_COLON] = ACTIONS(7292),
    [anon_sym_delete] = ACTIONS(7294),
    [sym_nullptr] = ACTIONS(7294),
  },
  [3204] = {
    [sym_compound_statement] = STATE(3128),
    [sym_labeled_statement] = STATE(3128),
    [sym_expression_statement] = STATE(3128),
    [sym_if_statement] = STATE(3128),
    [sym_switch_statement] = STATE(3128),
    [sym_case_statement] = STATE(3128),
    [sym_while_statement] = STATE(3128),
    [sym_do_statement] = STATE(3128),
    [sym_for_statement] = STATE(3128),
    [sym_return_statement] = STATE(3128),
    [sym_break_statement] = STATE(3128),
    [sym_continue_statement] = STATE(3128),
    [sym_goto_statement] = STATE(3128),
    [sym__expression] = STATE(873),
    [sym_comma_expression] = STATE(874),
    [sym_conditional_expression] = STATE(873),
    [sym_assignment_expression] = STATE(873),
    [sym_pointer_expression] = STATE(873),
    [sym_logical_expression] = STATE(873),
    [sym_bitwise_expression] = STATE(873),
    [sym_equality_expression] = STATE(873),
    [sym_relational_expression] = STATE(873),
    [sym_shift_expression] = STATE(873),
    [sym_math_expression] = STATE(873),
    [sym_cast_expression] = STATE(873),
    [sym_sizeof_expression] = STATE(873),
    [sym_subscript_expression] = STATE(873),
    [sym_call_expression] = STATE(873),
    [sym_field_expression] = STATE(873),
    [sym_compound_literal_expression] = STATE(873),
    [sym_parenthesized_expression] = STATE(873),
    [sym_concatenated_string] = STATE(873),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(873),
    [sym_for_range_loop] = STATE(3128),
    [sym_new_expression] = STATE(873),
    [sym_delete_expression] = STATE(873),
    [sym_lambda_expression] = STATE(873),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(1660),
    [anon_sym_LPAREN] = ACTIONS(626),
    [anon_sym_SEMI] = ACTIONS(1662),
    [anon_sym_LBRACE] = ACTIONS(1664),
    [anon_sym_STAR] = ACTIONS(644),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_if] = ACTIONS(6297),
    [anon_sym_switch] = ACTIONS(6299),
    [anon_sym_case] = ACTIONS(6301),
    [anon_sym_default] = ACTIONS(6303),
    [anon_sym_while] = ACTIONS(6305),
    [anon_sym_do] = ACTIONS(1676),
    [anon_sym_for] = ACTIONS(6307),
    [anon_sym_return] = ACTIONS(1680),
    [anon_sym_break] = ACTIONS(1682),
    [anon_sym_continue] = ACTIONS(1684),
    [anon_sym_goto] = ACTIONS(1686),
    [anon_sym_AMP] = ACTIONS(644),
    [anon_sym_BANG] = ACTIONS(668),
    [anon_sym_TILDE] = ACTIONS(670),
    [anon_sym_PLUS] = ACTIONS(672),
    [anon_sym_DASH] = ACTIONS(672),
    [anon_sym_DASH_DASH] = ACTIONS(674),
    [anon_sym_PLUS_PLUS] = ACTIONS(674),
    [anon_sym_sizeof] = ACTIONS(676),
    [sym_number_literal] = ACTIONS(1660),
    [sym_char_literal] = ACTIONS(1660),
    [sym_string_literal] = ACTIONS(678),
    [sym_true] = ACTIONS(1688),
    [sym_false] = ACTIONS(1688),
    [sym_null] = ACTIONS(1688),
    [sym_identifier] = ACTIONS(6309),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1303),
    [anon_sym_delete] = ACTIONS(686),
    [sym_nullptr] = ACTIONS(1688),
  },
  [3205] = {
    [sym_raw_string_literal] = ACTIONS(7057),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(7059),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(7059),
    [anon_sym_LPAREN] = ACTIONS(7057),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(7059),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(7059),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(7059),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(7059),
    [sym_preproc_directive] = ACTIONS(7059),
    [anon_sym_SEMI] = ACTIONS(7057),
    [anon_sym_typedef] = ACTIONS(7059),
    [anon_sym_extern] = ACTIONS(7059),
    [anon_sym_LBRACE] = ACTIONS(7057),
    [anon_sym_STAR] = ACTIONS(7057),
    [anon_sym_LBRACK] = ACTIONS(7057),
    [anon_sym_static] = ACTIONS(7059),
    [anon_sym_register] = ACTIONS(7059),
    [anon_sym_inline] = ACTIONS(7059),
    [anon_sym_const] = ACTIONS(7059),
    [anon_sym_restrict] = ACTIONS(7059),
    [anon_sym_volatile] = ACTIONS(7059),
    [anon_sym__Atomic] = ACTIONS(7059),
    [anon_sym_mutable] = ACTIONS(7059),
    [anon_sym_explicit] = ACTIONS(7059),
    [anon_sym_constexpr] = ACTIONS(7059),
    [anon_sym_unsigned] = ACTIONS(7059),
    [anon_sym_long] = ACTIONS(7059),
    [anon_sym_short] = ACTIONS(7059),
    [sym_primitive_type] = ACTIONS(7059),
    [anon_sym_enum] = ACTIONS(7059),
    [anon_sym_struct] = ACTIONS(7059),
    [anon_sym_union] = ACTIONS(7059),
    [anon_sym_if] = ACTIONS(7059),
    [anon_sym_else] = ACTIONS(7059),
    [anon_sym_switch] = ACTIONS(7059),
    [anon_sym_case] = ACTIONS(7059),
    [anon_sym_default] = ACTIONS(7059),
    [anon_sym_while] = ACTIONS(7059),
    [anon_sym_do] = ACTIONS(7059),
    [anon_sym_for] = ACTIONS(7059),
    [anon_sym_return] = ACTIONS(7059),
    [anon_sym_break] = ACTIONS(7059),
    [anon_sym_continue] = ACTIONS(7059),
    [anon_sym_goto] = ACTIONS(7059),
    [anon_sym_AMP] = ACTIONS(7057),
    [anon_sym_BANG] = ACTIONS(7057),
    [anon_sym_TILDE] = ACTIONS(7057),
    [anon_sym_PLUS] = ACTIONS(7059),
    [anon_sym_DASH] = ACTIONS(7059),
    [anon_sym_DASH_DASH] = ACTIONS(7057),
    [anon_sym_PLUS_PLUS] = ACTIONS(7057),
    [anon_sym_sizeof] = ACTIONS(7059),
    [sym_number_literal] = ACTIONS(7057),
    [sym_char_literal] = ACTIONS(7057),
    [sym_string_literal] = ACTIONS(7057),
    [sym_true] = ACTIONS(7059),
    [sym_false] = ACTIONS(7059),
    [sym_null] = ACTIONS(7059),
    [sym_identifier] = ACTIONS(7059),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(7059),
    [sym_auto] = ACTIONS(7059),
    [anon_sym_typename] = ACTIONS(7059),
    [anon_sym_new] = ACTIONS(7059),
    [anon_sym_COLON_COLON] = ACTIONS(7057),
    [anon_sym_delete] = ACTIONS(7059),
    [sym_nullptr] = ACTIONS(7059),
  },
  [3206] = {
    [sym_raw_string_literal] = ACTIONS(7083),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(7085),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(7085),
    [anon_sym_LPAREN] = ACTIONS(7083),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(7085),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(7085),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(7085),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(7085),
    [sym_preproc_directive] = ACTIONS(7085),
    [anon_sym_SEMI] = ACTIONS(7083),
    [anon_sym_typedef] = ACTIONS(7085),
    [anon_sym_extern] = ACTIONS(7085),
    [anon_sym_LBRACE] = ACTIONS(7083),
    [anon_sym_STAR] = ACTIONS(7083),
    [anon_sym_LBRACK] = ACTIONS(7083),
    [anon_sym_static] = ACTIONS(7085),
    [anon_sym_register] = ACTIONS(7085),
    [anon_sym_inline] = ACTIONS(7085),
    [anon_sym_const] = ACTIONS(7085),
    [anon_sym_restrict] = ACTIONS(7085),
    [anon_sym_volatile] = ACTIONS(7085),
    [anon_sym__Atomic] = ACTIONS(7085),
    [anon_sym_mutable] = ACTIONS(7085),
    [anon_sym_explicit] = ACTIONS(7085),
    [anon_sym_constexpr] = ACTIONS(7085),
    [anon_sym_unsigned] = ACTIONS(7085),
    [anon_sym_long] = ACTIONS(7085),
    [anon_sym_short] = ACTIONS(7085),
    [sym_primitive_type] = ACTIONS(7085),
    [anon_sym_enum] = ACTIONS(7085),
    [anon_sym_struct] = ACTIONS(7085),
    [anon_sym_union] = ACTIONS(7085),
    [anon_sym_if] = ACTIONS(7085),
    [anon_sym_else] = ACTIONS(7085),
    [anon_sym_switch] = ACTIONS(7085),
    [anon_sym_case] = ACTIONS(7085),
    [anon_sym_default] = ACTIONS(7085),
    [anon_sym_while] = ACTIONS(7085),
    [anon_sym_do] = ACTIONS(7085),
    [anon_sym_for] = ACTIONS(7085),
    [anon_sym_return] = ACTIONS(7085),
    [anon_sym_break] = ACTIONS(7085),
    [anon_sym_continue] = ACTIONS(7085),
    [anon_sym_goto] = ACTIONS(7085),
    [anon_sym_AMP] = ACTIONS(7083),
    [anon_sym_BANG] = ACTIONS(7083),
    [anon_sym_TILDE] = ACTIONS(7083),
    [anon_sym_PLUS] = ACTIONS(7085),
    [anon_sym_DASH] = ACTIONS(7085),
    [anon_sym_DASH_DASH] = ACTIONS(7083),
    [anon_sym_PLUS_PLUS] = ACTIONS(7083),
    [anon_sym_sizeof] = ACTIONS(7085),
    [sym_number_literal] = ACTIONS(7083),
    [sym_char_literal] = ACTIONS(7083),
    [sym_string_literal] = ACTIONS(7083),
    [sym_true] = ACTIONS(7085),
    [sym_false] = ACTIONS(7085),
    [sym_null] = ACTIONS(7085),
    [sym_identifier] = ACTIONS(7085),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(7085),
    [sym_auto] = ACTIONS(7085),
    [anon_sym_typename] = ACTIONS(7085),
    [anon_sym_new] = ACTIONS(7085),
    [anon_sym_COLON_COLON] = ACTIONS(7083),
    [anon_sym_delete] = ACTIONS(7085),
    [sym_nullptr] = ACTIONS(7085),
  },
  [3207] = {
    [sym_compound_statement] = STATE(3211),
    [sym_labeled_statement] = STATE(3211),
    [sym_expression_statement] = STATE(3211),
    [sym_if_statement] = STATE(3211),
    [sym_switch_statement] = STATE(3211),
    [sym_case_statement] = STATE(3211),
    [sym_while_statement] = STATE(3211),
    [sym_do_statement] = STATE(3211),
    [sym_for_statement] = STATE(3211),
    [sym_return_statement] = STATE(3211),
    [sym_break_statement] = STATE(3211),
    [sym_continue_statement] = STATE(3211),
    [sym_goto_statement] = STATE(3211),
    [sym__expression] = STATE(2844),
    [sym_comma_expression] = STATE(2845),
    [sym_conditional_expression] = STATE(2844),
    [sym_assignment_expression] = STATE(2844),
    [sym_pointer_expression] = STATE(2844),
    [sym_logical_expression] = STATE(2844),
    [sym_bitwise_expression] = STATE(2844),
    [sym_equality_expression] = STATE(2844),
    [sym_relational_expression] = STATE(2844),
    [sym_shift_expression] = STATE(2844),
    [sym_math_expression] = STATE(2844),
    [sym_cast_expression] = STATE(2844),
    [sym_sizeof_expression] = STATE(2844),
    [sym_subscript_expression] = STATE(2844),
    [sym_call_expression] = STATE(2844),
    [sym_field_expression] = STATE(2844),
    [sym_compound_literal_expression] = STATE(2844),
    [sym_parenthesized_expression] = STATE(2844),
    [sym_concatenated_string] = STATE(2844),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(2844),
    [sym_for_range_loop] = STATE(3211),
    [sym_new_expression] = STATE(2844),
    [sym_delete_expression] = STATE(2844),
    [sym_lambda_expression] = STATE(2844),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(6732),
    [anon_sym_LPAREN] = ACTIONS(626),
    [anon_sym_SEMI] = ACTIONS(6734),
    [anon_sym_LBRACE] = ACTIONS(6736),
    [anon_sym_STAR] = ACTIONS(644),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_if] = ACTIONS(6738),
    [anon_sym_switch] = ACTIONS(6740),
    [anon_sym_case] = ACTIONS(6742),
    [anon_sym_default] = ACTIONS(6744),
    [anon_sym_while] = ACTIONS(6746),
    [anon_sym_do] = ACTIONS(6748),
    [anon_sym_for] = ACTIONS(6750),
    [anon_sym_return] = ACTIONS(6752),
    [anon_sym_break] = ACTIONS(6754),
    [anon_sym_continue] = ACTIONS(6756),
    [anon_sym_goto] = ACTIONS(6758),
    [anon_sym_AMP] = ACTIONS(644),
    [anon_sym_BANG] = ACTIONS(668),
    [anon_sym_TILDE] = ACTIONS(670),
    [anon_sym_PLUS] = ACTIONS(672),
    [anon_sym_DASH] = ACTIONS(672),
    [anon_sym_DASH_DASH] = ACTIONS(674),
    [anon_sym_PLUS_PLUS] = ACTIONS(674),
    [anon_sym_sizeof] = ACTIONS(676),
    [sym_number_literal] = ACTIONS(6732),
    [sym_char_literal] = ACTIONS(6732),
    [sym_string_literal] = ACTIONS(678),
    [sym_true] = ACTIONS(6760),
    [sym_false] = ACTIONS(6760),
    [sym_null] = ACTIONS(6760),
    [sym_identifier] = ACTIONS(6762),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1303),
    [anon_sym_delete] = ACTIONS(686),
    [sym_nullptr] = ACTIONS(6760),
  },
  [3208] = {
    [aux_sym_for_statement_repeat1] = STATE(2796),
    [anon_sym_COMMA] = ACTIONS(6339),
    [anon_sym_RPAREN] = ACTIONS(7402),
    [sym_comment] = ACTIONS(49),
  },
  [3209] = {
    [sym_raw_string_literal] = ACTIONS(7202),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(7204),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(7204),
    [anon_sym_LPAREN] = ACTIONS(7202),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(7204),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(7204),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(7204),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(7204),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(7204),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(7204),
    [sym_preproc_directive] = ACTIONS(7204),
    [anon_sym_SEMI] = ACTIONS(7202),
    [anon_sym_typedef] = ACTIONS(7204),
    [anon_sym_extern] = ACTIONS(7204),
    [anon_sym_LBRACE] = ACTIONS(7202),
    [anon_sym_STAR] = ACTIONS(7202),
    [anon_sym_LBRACK] = ACTIONS(7202),
    [anon_sym_static] = ACTIONS(7204),
    [anon_sym_register] = ACTIONS(7204),
    [anon_sym_inline] = ACTIONS(7204),
    [anon_sym_const] = ACTIONS(7204),
    [anon_sym_restrict] = ACTIONS(7204),
    [anon_sym_volatile] = ACTIONS(7204),
    [anon_sym__Atomic] = ACTIONS(7204),
    [anon_sym_mutable] = ACTIONS(7204),
    [anon_sym_explicit] = ACTIONS(7204),
    [anon_sym_constexpr] = ACTIONS(7204),
    [anon_sym_unsigned] = ACTIONS(7204),
    [anon_sym_long] = ACTIONS(7204),
    [anon_sym_short] = ACTIONS(7204),
    [sym_primitive_type] = ACTIONS(7204),
    [anon_sym_enum] = ACTIONS(7204),
    [anon_sym_struct] = ACTIONS(7204),
    [anon_sym_union] = ACTIONS(7204),
    [anon_sym_if] = ACTIONS(7204),
    [anon_sym_else] = ACTIONS(7204),
    [anon_sym_switch] = ACTIONS(7204),
    [anon_sym_case] = ACTIONS(7204),
    [anon_sym_default] = ACTIONS(7204),
    [anon_sym_while] = ACTIONS(7204),
    [anon_sym_do] = ACTIONS(7204),
    [anon_sym_for] = ACTIONS(7204),
    [anon_sym_return] = ACTIONS(7204),
    [anon_sym_break] = ACTIONS(7204),
    [anon_sym_continue] = ACTIONS(7204),
    [anon_sym_goto] = ACTIONS(7204),
    [anon_sym_AMP] = ACTIONS(7202),
    [anon_sym_BANG] = ACTIONS(7202),
    [anon_sym_TILDE] = ACTIONS(7202),
    [anon_sym_PLUS] = ACTIONS(7204),
    [anon_sym_DASH] = ACTIONS(7204),
    [anon_sym_DASH_DASH] = ACTIONS(7202),
    [anon_sym_PLUS_PLUS] = ACTIONS(7202),
    [anon_sym_sizeof] = ACTIONS(7204),
    [sym_number_literal] = ACTIONS(7202),
    [sym_char_literal] = ACTIONS(7202),
    [sym_string_literal] = ACTIONS(7202),
    [sym_true] = ACTIONS(7204),
    [sym_false] = ACTIONS(7204),
    [sym_null] = ACTIONS(7204),
    [sym_identifier] = ACTIONS(7204),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(7204),
    [sym_auto] = ACTIONS(7204),
    [anon_sym_typename] = ACTIONS(7204),
    [anon_sym_new] = ACTIONS(7204),
    [anon_sym_COLON_COLON] = ACTIONS(7202),
    [anon_sym_delete] = ACTIONS(7204),
    [sym_nullptr] = ACTIONS(7204),
  },
  [3210] = {
    [sym_compound_statement] = STATE(3213),
    [sym_labeled_statement] = STATE(3213),
    [sym_expression_statement] = STATE(3213),
    [sym_if_statement] = STATE(3213),
    [sym_switch_statement] = STATE(3213),
    [sym_case_statement] = STATE(3213),
    [sym_while_statement] = STATE(3213),
    [sym_do_statement] = STATE(3213),
    [sym_for_statement] = STATE(3213),
    [sym_return_statement] = STATE(3213),
    [sym_break_statement] = STATE(3213),
    [sym_continue_statement] = STATE(3213),
    [sym_goto_statement] = STATE(3213),
    [sym__expression] = STATE(2739),
    [sym_comma_expression] = STATE(2740),
    [sym_conditional_expression] = STATE(2739),
    [sym_assignment_expression] = STATE(2739),
    [sym_pointer_expression] = STATE(2739),
    [sym_logical_expression] = STATE(2739),
    [sym_bitwise_expression] = STATE(2739),
    [sym_equality_expression] = STATE(2739),
    [sym_relational_expression] = STATE(2739),
    [sym_shift_expression] = STATE(2739),
    [sym_math_expression] = STATE(2739),
    [sym_cast_expression] = STATE(2739),
    [sym_sizeof_expression] = STATE(2739),
    [sym_subscript_expression] = STATE(2739),
    [sym_call_expression] = STATE(2739),
    [sym_field_expression] = STATE(2739),
    [sym_compound_literal_expression] = STATE(2739),
    [sym_parenthesized_expression] = STATE(2739),
    [sym_concatenated_string] = STATE(2739),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(2739),
    [sym_for_range_loop] = STATE(3213),
    [sym_new_expression] = STATE(2739),
    [sym_delete_expression] = STATE(2739),
    [sym_lambda_expression] = STATE(2739),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(6507),
    [anon_sym_LPAREN] = ACTIONS(626),
    [anon_sym_SEMI] = ACTIONS(6509),
    [anon_sym_LBRACE] = ACTIONS(6511),
    [anon_sym_STAR] = ACTIONS(644),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_if] = ACTIONS(6513),
    [anon_sym_switch] = ACTIONS(6515),
    [anon_sym_case] = ACTIONS(6517),
    [anon_sym_default] = ACTIONS(6519),
    [anon_sym_while] = ACTIONS(6521),
    [anon_sym_do] = ACTIONS(6523),
    [anon_sym_for] = ACTIONS(6525),
    [anon_sym_return] = ACTIONS(6527),
    [anon_sym_break] = ACTIONS(6529),
    [anon_sym_continue] = ACTIONS(6531),
    [anon_sym_goto] = ACTIONS(6533),
    [anon_sym_AMP] = ACTIONS(644),
    [anon_sym_BANG] = ACTIONS(668),
    [anon_sym_TILDE] = ACTIONS(670),
    [anon_sym_PLUS] = ACTIONS(672),
    [anon_sym_DASH] = ACTIONS(672),
    [anon_sym_DASH_DASH] = ACTIONS(674),
    [anon_sym_PLUS_PLUS] = ACTIONS(674),
    [anon_sym_sizeof] = ACTIONS(676),
    [sym_number_literal] = ACTIONS(6507),
    [sym_char_literal] = ACTIONS(6507),
    [sym_string_literal] = ACTIONS(678),
    [sym_true] = ACTIONS(6535),
    [sym_false] = ACTIONS(6535),
    [sym_null] = ACTIONS(6535),
    [sym_identifier] = ACTIONS(6537),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1303),
    [anon_sym_delete] = ACTIONS(686),
    [sym_nullptr] = ACTIONS(6535),
  },
  [3211] = {
    [sym_raw_string_literal] = ACTIONS(7202),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(7204),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(7204),
    [anon_sym_LPAREN] = ACTIONS(7202),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(7204),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(7204),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(7204),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(7204),
    [sym_preproc_directive] = ACTIONS(7204),
    [anon_sym_SEMI] = ACTIONS(7202),
    [anon_sym_typedef] = ACTIONS(7204),
    [anon_sym_extern] = ACTIONS(7204),
    [anon_sym_LBRACE] = ACTIONS(7202),
    [anon_sym_STAR] = ACTIONS(7202),
    [anon_sym_LBRACK] = ACTIONS(7202),
    [anon_sym_static] = ACTIONS(7204),
    [anon_sym_register] = ACTIONS(7204),
    [anon_sym_inline] = ACTIONS(7204),
    [anon_sym_const] = ACTIONS(7204),
    [anon_sym_restrict] = ACTIONS(7204),
    [anon_sym_volatile] = ACTIONS(7204),
    [anon_sym__Atomic] = ACTIONS(7204),
    [anon_sym_mutable] = ACTIONS(7204),
    [anon_sym_explicit] = ACTIONS(7204),
    [anon_sym_constexpr] = ACTIONS(7204),
    [anon_sym_unsigned] = ACTIONS(7204),
    [anon_sym_long] = ACTIONS(7204),
    [anon_sym_short] = ACTIONS(7204),
    [sym_primitive_type] = ACTIONS(7204),
    [anon_sym_enum] = ACTIONS(7204),
    [anon_sym_struct] = ACTIONS(7204),
    [anon_sym_union] = ACTIONS(7204),
    [anon_sym_if] = ACTIONS(7204),
    [anon_sym_else] = ACTIONS(7204),
    [anon_sym_switch] = ACTIONS(7204),
    [anon_sym_case] = ACTIONS(7204),
    [anon_sym_default] = ACTIONS(7204),
    [anon_sym_while] = ACTIONS(7204),
    [anon_sym_do] = ACTIONS(7204),
    [anon_sym_for] = ACTIONS(7204),
    [anon_sym_return] = ACTIONS(7204),
    [anon_sym_break] = ACTIONS(7204),
    [anon_sym_continue] = ACTIONS(7204),
    [anon_sym_goto] = ACTIONS(7204),
    [anon_sym_AMP] = ACTIONS(7202),
    [anon_sym_BANG] = ACTIONS(7202),
    [anon_sym_TILDE] = ACTIONS(7202),
    [anon_sym_PLUS] = ACTIONS(7204),
    [anon_sym_DASH] = ACTIONS(7204),
    [anon_sym_DASH_DASH] = ACTIONS(7202),
    [anon_sym_PLUS_PLUS] = ACTIONS(7202),
    [anon_sym_sizeof] = ACTIONS(7204),
    [sym_number_literal] = ACTIONS(7202),
    [sym_char_literal] = ACTIONS(7202),
    [sym_string_literal] = ACTIONS(7202),
    [sym_true] = ACTIONS(7204),
    [sym_false] = ACTIONS(7204),
    [sym_null] = ACTIONS(7204),
    [sym_identifier] = ACTIONS(7204),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(7204),
    [sym_auto] = ACTIONS(7204),
    [anon_sym_typename] = ACTIONS(7204),
    [anon_sym_new] = ACTIONS(7204),
    [anon_sym_COLON_COLON] = ACTIONS(7202),
    [anon_sym_delete] = ACTIONS(7204),
    [sym_nullptr] = ACTIONS(7204),
  },
  [3212] = {
    [sym_compound_statement] = STATE(3214),
    [sym_labeled_statement] = STATE(3214),
    [sym_expression_statement] = STATE(3214),
    [sym_if_statement] = STATE(3214),
    [sym_switch_statement] = STATE(3214),
    [sym_case_statement] = STATE(3214),
    [sym_while_statement] = STATE(3214),
    [sym_do_statement] = STATE(3214),
    [sym_for_statement] = STATE(3214),
    [sym_return_statement] = STATE(3214),
    [sym_break_statement] = STATE(3214),
    [sym_continue_statement] = STATE(3214),
    [sym_goto_statement] = STATE(3214),
    [sym__expression] = STATE(2844),
    [sym_comma_expression] = STATE(2845),
    [sym_conditional_expression] = STATE(2844),
    [sym_assignment_expression] = STATE(2844),
    [sym_pointer_expression] = STATE(2844),
    [sym_logical_expression] = STATE(2844),
    [sym_bitwise_expression] = STATE(2844),
    [sym_equality_expression] = STATE(2844),
    [sym_relational_expression] = STATE(2844),
    [sym_shift_expression] = STATE(2844),
    [sym_math_expression] = STATE(2844),
    [sym_cast_expression] = STATE(2844),
    [sym_sizeof_expression] = STATE(2844),
    [sym_subscript_expression] = STATE(2844),
    [sym_call_expression] = STATE(2844),
    [sym_field_expression] = STATE(2844),
    [sym_compound_literal_expression] = STATE(2844),
    [sym_parenthesized_expression] = STATE(2844),
    [sym_concatenated_string] = STATE(2844),
    [sym_template_type] = STATE(586),
    [sym_template_function] = STATE(2844),
    [sym_for_range_loop] = STATE(3214),
    [sym_new_expression] = STATE(2844),
    [sym_delete_expression] = STATE(2844),
    [sym_lambda_expression] = STATE(2844),
    [sym_lambda_capture_specifier] = STATE(370),
    [sym_scoped_identifier] = STATE(371),
    [sym_scoped_type_identifier] = STATE(587),
    [sym_scoped_namespace_identifier] = STATE(588),
    [sym_raw_string_literal] = ACTIONS(6732),
    [anon_sym_LPAREN] = ACTIONS(626),
    [anon_sym_SEMI] = ACTIONS(6734),
    [anon_sym_LBRACE] = ACTIONS(6736),
    [anon_sym_STAR] = ACTIONS(644),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_if] = ACTIONS(6738),
    [anon_sym_switch] = ACTIONS(6740),
    [anon_sym_case] = ACTIONS(6742),
    [anon_sym_default] = ACTIONS(6744),
    [anon_sym_while] = ACTIONS(6746),
    [anon_sym_do] = ACTIONS(6748),
    [anon_sym_for] = ACTIONS(6750),
    [anon_sym_return] = ACTIONS(6752),
    [anon_sym_break] = ACTIONS(6754),
    [anon_sym_continue] = ACTIONS(6756),
    [anon_sym_goto] = ACTIONS(6758),
    [anon_sym_AMP] = ACTIONS(644),
    [anon_sym_BANG] = ACTIONS(668),
    [anon_sym_TILDE] = ACTIONS(670),
    [anon_sym_PLUS] = ACTIONS(672),
    [anon_sym_DASH] = ACTIONS(672),
    [anon_sym_DASH_DASH] = ACTIONS(674),
    [anon_sym_PLUS_PLUS] = ACTIONS(674),
    [anon_sym_sizeof] = ACTIONS(676),
    [sym_number_literal] = ACTIONS(6732),
    [sym_char_literal] = ACTIONS(6732),
    [sym_string_literal] = ACTIONS(678),
    [sym_true] = ACTIONS(6760),
    [sym_false] = ACTIONS(6760),
    [sym_null] = ACTIONS(6760),
    [sym_identifier] = ACTIONS(6762),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_COLON_COLON] = ACTIONS(1303),
    [anon_sym_delete] = ACTIONS(686),
    [sym_nullptr] = ACTIONS(6760),
  },
  [3213] = {
    [sym_raw_string_literal] = ACTIONS(7292),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(7294),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(7294),
    [anon_sym_LPAREN] = ACTIONS(7292),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(7294),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(7294),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(7294),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(7294),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(7294),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(7294),
    [sym_preproc_directive] = ACTIONS(7294),
    [anon_sym_SEMI] = ACTIONS(7292),
    [anon_sym_typedef] = ACTIONS(7294),
    [anon_sym_extern] = ACTIONS(7294),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [anon_sym_STAR] = ACTIONS(7292),
    [anon_sym_LBRACK] = ACTIONS(7292),
    [anon_sym_static] = ACTIONS(7294),
    [anon_sym_register] = ACTIONS(7294),
    [anon_sym_inline] = ACTIONS(7294),
    [anon_sym_const] = ACTIONS(7294),
    [anon_sym_restrict] = ACTIONS(7294),
    [anon_sym_volatile] = ACTIONS(7294),
    [anon_sym__Atomic] = ACTIONS(7294),
    [anon_sym_mutable] = ACTIONS(7294),
    [anon_sym_explicit] = ACTIONS(7294),
    [anon_sym_constexpr] = ACTIONS(7294),
    [anon_sym_unsigned] = ACTIONS(7294),
    [anon_sym_long] = ACTIONS(7294),
    [anon_sym_short] = ACTIONS(7294),
    [sym_primitive_type] = ACTIONS(7294),
    [anon_sym_enum] = ACTIONS(7294),
    [anon_sym_struct] = ACTIONS(7294),
    [anon_sym_union] = ACTIONS(7294),
    [anon_sym_if] = ACTIONS(7294),
    [anon_sym_else] = ACTIONS(7294),
    [anon_sym_switch] = ACTIONS(7294),
    [anon_sym_case] = ACTIONS(7294),
    [anon_sym_default] = ACTIONS(7294),
    [anon_sym_while] = ACTIONS(7294),
    [anon_sym_do] = ACTIONS(7294),
    [anon_sym_for] = ACTIONS(7294),
    [anon_sym_return] = ACTIONS(7294),
    [anon_sym_break] = ACTIONS(7294),
    [anon_sym_continue] = ACTIONS(7294),
    [anon_sym_goto] = ACTIONS(7294),
    [anon_sym_AMP] = ACTIONS(7292),
    [anon_sym_BANG] = ACTIONS(7292),
    [anon_sym_TILDE] = ACTIONS(7292),
    [anon_sym_PLUS] = ACTIONS(7294),
    [anon_sym_DASH] = ACTIONS(7294),
    [anon_sym_DASH_DASH] = ACTIONS(7292),
    [anon_sym_PLUS_PLUS] = ACTIONS(7292),
    [anon_sym_sizeof] = ACTIONS(7294),
    [sym_number_literal] = ACTIONS(7292),
    [sym_char_literal] = ACTIONS(7292),
    [sym_string_literal] = ACTIONS(7292),
    [sym_true] = ACTIONS(7294),
    [sym_false] = ACTIONS(7294),
    [sym_null] = ACTIONS(7294),
    [sym_identifier] = ACTIONS(7294),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(7294),
    [sym_auto] = ACTIONS(7294),
    [anon_sym_typename] = ACTIONS(7294),
    [anon_sym_new] = ACTIONS(7294),
    [anon_sym_COLON_COLON] = ACTIONS(7292),
    [anon_sym_delete] = ACTIONS(7294),
    [sym_nullptr] = ACTIONS(7294),
  },
  [3214] = {
    [sym_raw_string_literal] = ACTIONS(7292),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(7294),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(7294),
    [anon_sym_LPAREN] = ACTIONS(7292),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(7294),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(7294),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(7294),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(7294),
    [sym_preproc_directive] = ACTIONS(7294),
    [anon_sym_SEMI] = ACTIONS(7292),
    [anon_sym_typedef] = ACTIONS(7294),
    [anon_sym_extern] = ACTIONS(7294),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [anon_sym_STAR] = ACTIONS(7292),
    [anon_sym_LBRACK] = ACTIONS(7292),
    [anon_sym_static] = ACTIONS(7294),
    [anon_sym_register] = ACTIONS(7294),
    [anon_sym_inline] = ACTIONS(7294),
    [anon_sym_const] = ACTIONS(7294),
    [anon_sym_restrict] = ACTIONS(7294),
    [anon_sym_volatile] = ACTIONS(7294),
    [anon_sym__Atomic] = ACTIONS(7294),
    [anon_sym_mutable] = ACTIONS(7294),
    [anon_sym_explicit] = ACTIONS(7294),
    [anon_sym_constexpr] = ACTIONS(7294),
    [anon_sym_unsigned] = ACTIONS(7294),
    [anon_sym_long] = ACTIONS(7294),
    [anon_sym_short] = ACTIONS(7294),
    [sym_primitive_type] = ACTIONS(7294),
    [anon_sym_enum] = ACTIONS(7294),
    [anon_sym_struct] = ACTIONS(7294),
    [anon_sym_union] = ACTIONS(7294),
    [anon_sym_if] = ACTIONS(7294),
    [anon_sym_else] = ACTIONS(7294),
    [anon_sym_switch] = ACTIONS(7294),
    [anon_sym_case] = ACTIONS(7294),
    [anon_sym_default] = ACTIONS(7294),
    [anon_sym_while] = ACTIONS(7294),
    [anon_sym_do] = ACTIONS(7294),
    [anon_sym_for] = ACTIONS(7294),
    [anon_sym_return] = ACTIONS(7294),
    [anon_sym_break] = ACTIONS(7294),
    [anon_sym_continue] = ACTIONS(7294),
    [anon_sym_goto] = ACTIONS(7294),
    [anon_sym_AMP] = ACTIONS(7292),
    [anon_sym_BANG] = ACTIONS(7292),
    [anon_sym_TILDE] = ACTIONS(7292),
    [anon_sym_PLUS] = ACTIONS(7294),
    [anon_sym_DASH] = ACTIONS(7294),
    [anon_sym_DASH_DASH] = ACTIONS(7292),
    [anon_sym_PLUS_PLUS] = ACTIONS(7292),
    [anon_sym_sizeof] = ACTIONS(7294),
    [sym_number_literal] = ACTIONS(7292),
    [sym_char_literal] = ACTIONS(7292),
    [sym_string_literal] = ACTIONS(7292),
    [sym_true] = ACTIONS(7294),
    [sym_false] = ACTIONS(7294),
    [sym_null] = ACTIONS(7294),
    [sym_identifier] = ACTIONS(7294),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(7294),
    [sym_auto] = ACTIONS(7294),
    [anon_sym_typename] = ACTIONS(7294),
    [anon_sym_new] = ACTIONS(7294),
    [anon_sym_COLON_COLON] = ACTIONS(7292),
    [anon_sym_delete] = ACTIONS(7294),
    [sym_nullptr] = ACTIONS(7294),
  },
};

static TSParseActionEntry ts_parse_actions[] = {
  [0] = {.count = 0, .reusable = false},
  [1] = {.count = 1, .reusable = true}, RECOVER(),
  [3] = {.count = 1, .reusable = false}, RECOVER(),
  [5] = {.count = 1, .reusable = true}, REDUCE(sym_translation_unit, 0),
  [7] = {.count = 1, .reusable = false}, SHIFT(2),
  [9] = {.count = 1, .reusable = false}, SHIFT(3),
  [11] = {.count = 1, .reusable = true}, SHIFT(4),
  [13] = {.count = 1, .reusable = false}, SHIFT(5),
  [15] = {.count = 1, .reusable = false}, SHIFT(6),
  [17] = {.count = 1, .reusable = false}, SHIFT(7),
  [19] = {.count = 1, .reusable = false}, SHIFT(8),
  [21] = {.count = 1, .reusable = false}, SHIFT(9),
  [23] = {.count = 1, .reusable = false}, SHIFT(10),
  [25] = {.count = 1, .reusable = true}, SHIFT(11),
  [27] = {.count = 1, .reusable = false}, SHIFT(12),
  [29] = {.count = 1, .reusable = false}, SHIFT(13),
  [31] = {.count = 1, .reusable = false}, SHIFT(38),
  [33] = {.count = 1, .reusable = false}, SHIFT(30),
  [35] = {.count = 1, .reusable = false}, SHIFT(14),
  [37] = {.count = 1, .reusable = false}, SHIFT(15),
  [39] = {.count = 1, .reusable = false}, SHIFT(16),
  [41] = {.count = 1, .reusable = false}, SHIFT(17),
  [43] = {.count = 1, .reusable = true}, SHIFT(17),
  [45] = {.count = 1, .reusable = true}, SHIFT(18),
  [47] = {.count = 1, .reusable = false}, SHIFT(19),
  [49] = {.count = 1, .reusable = true}, SHIFT_EXTRA(),
  [51] = {.count = 1, .reusable = false}, SHIFT(20),
  [53] = {.count = 1, .reusable = false}, SHIFT(21),
  [55] = {.count = 1, .reusable = false}, SHIFT(22),
  [57] = {.count = 1, .reusable = false}, SHIFT(23),
  [59] = {.count = 1, .reusable = false}, SHIFT(24),
  [61] = {.count = 1, .reusable = true}, SHIFT(25),
  [63] = {.count = 1, .reusable = true}, SHIFT(28),
  [65] = {.count = 1, .reusable = true}, SHIFT(39),
  [67] = {.count = 1, .reusable = true}, SHIFT(40),
  [69] = {.count = 1, .reusable = true}, SHIFT(41),
  [71] = {.count = 1, .reusable = false}, SHIFT(42),
  [73] = {.count = 1, .reusable = true}, SHIFT(42),
  [75] = {.count = 1, .reusable = false}, SHIFT(43),
  [77] = {.count = 1, .reusable = true}, SHIFT(44),
  [79] = {.count = 1, .reusable = true}, SHIFT(45),
  [81] = {.count = 1, .reusable = false}, SHIFT(48),
  [83] = {.count = 1, .reusable = false}, SHIFT_EXTRA(),
  [85] = {.count = 1, .reusable = true}, SHIFT(49),
  [87] = {.count = 1, .reusable = true}, SHIFT(50),
  [89] = {.count = 1, .reusable = false}, SHIFT(51),
  [91] = {.count = 1, .reusable = false}, SHIFT(52),
  [93] = {.count = 1, .reusable = false}, SHIFT(53),
  [95] = {.count = 1, .reusable = false}, SHIFT(66),
  [97] = {.count = 1, .reusable = false}, SHIFT(61),
  [99] = {.count = 1, .reusable = false}, SHIFT(54),
  [101] = {.count = 1, .reusable = false}, SHIFT(55),
  [103] = {.count = 1, .reusable = false}, SHIFT(56),
  [105] = {.count = 1, .reusable = false}, SHIFT(57),
  [107] = {.count = 1, .reusable = false}, SHIFT(58),
  [109] = {.count = 1, .reusable = false}, SHIFT(59),
  [111] = {.count = 1, .reusable = true}, SHIFT(60),
  [113] = {.count = 1, .reusable = true}, REDUCE(sym_storage_class_specifier, 1),
  [115] = {.count = 1, .reusable = false}, REDUCE(sym_storage_class_specifier, 1),
  [117] = {.count = 1, .reusable = true}, SHIFT(67),
  [119] = {.count = 1, .reusable = true}, SHIFT(68),
  [121] = {.count = 1, .reusable = true}, REDUCE(sym_type_qualifier, 1),
  [123] = {.count = 1, .reusable = false}, REDUCE(sym_type_qualifier, 1),
  [125] = {.count = 1, .reusable = true}, SHIFT(69),
  [127] = {.count = 1, .reusable = true}, SHIFT(70),
  [129] = {.count = 1, .reusable = true}, SHIFT(72),
  [131] = {.count = 1, .reusable = false}, SHIFT(73),
  [133] = {.count = 1, .reusable = true}, SHIFT(74),
  [135] = {.count = 1, .reusable = true}, SHIFT(75),
  [137] = {.count = 1, .reusable = true}, SHIFT(85),
  [139] = {.count = 2, .reusable = true}, REDUCE(sym__declarator, 1), REDUCE(sym__type_specifier, 1, .alias_sequence_id = 1),
  [142] = {.count = 1, .reusable = true}, REDUCE(sym__type_specifier, 1, .alias_sequence_id = 1),
  [144] = {.count = 1, .reusable = false}, REDUCE(sym__type_specifier, 1, .alias_sequence_id = 1),
  [146] = {.count = 1, .reusable = true}, SHIFT(86),
  [148] = {.count = 1, .reusable = true}, SHIFT(87),
  [150] = {.count = 1, .reusable = false}, SHIFT(93),
  [152] = {.count = 1, .reusable = false}, SHIFT(92),
  [154] = {.count = 1, .reusable = false}, SHIFT(95),
  [156] = {.count = 1, .reusable = true}, SHIFT(96),
  [158] = {.count = 1, .reusable = false}, SHIFT(97),
  [160] = {.count = 1, .reusable = false}, SHIFT(110),
  [162] = {.count = 1, .reusable = false}, SHIFT(105),
  [164] = {.count = 1, .reusable = false}, SHIFT(98),
  [166] = {.count = 1, .reusable = true}, SHIFT(98),
  [168] = {.count = 1, .reusable = true}, SHIFT(99),
  [170] = {.count = 1, .reusable = false}, SHIFT(100),
  [172] = {.count = 1, .reusable = false}, SHIFT(101),
  [174] = {.count = 1, .reusable = true}, SHIFT(102),
  [176] = {.count = 1, .reusable = true}, SHIFT(104),
  [178] = {.count = 1, .reusable = true}, SHIFT(111),
  [180] = {.count = 1, .reusable = true}, SHIFT(112),
  [182] = {.count = 1, .reusable = false}, SHIFT(114),
  [184] = {.count = 1, .reusable = false}, SHIFT(115),
  [186] = {.count = 1, .reusable = true}, SHIFT(116),
  [188] = {.count = 1, .reusable = false}, SHIFT(119),
  [190] = {.count = 1, .reusable = true}, SHIFT(120),
  [192] = {.count = 1, .reusable = true}, ACCEPT_INPUT(),
  [194] = {.count = 1, .reusable = true}, SHIFT(121),
  [196] = {.count = 1, .reusable = true}, SHIFT(122),
  [198] = {.count = 1, .reusable = true}, SHIFT(123),
  [200] = {.count = 1, .reusable = false}, SHIFT(124),
  [202] = {.count = 1, .reusable = true}, SHIFT(124),
  [204] = {.count = 1, .reusable = true}, SHIFT(125),
  [206] = {.count = 1, .reusable = true}, SHIFT(129),
  [208] = {.count = 1, .reusable = true}, SHIFT(130),
  [210] = {.count = 1, .reusable = true}, REDUCE(sym__declarator, 1),
  [212] = {.count = 1, .reusable = true}, SHIFT(132),
  [214] = {.count = 1, .reusable = true}, SHIFT(133),
  [216] = {.count = 1, .reusable = true}, REDUCE(sym__declaration_specifiers, 1),
  [218] = {.count = 1, .reusable = false}, SHIFT(136),
  [220] = {.count = 1, .reusable = false}, SHIFT(137),
  [222] = {.count = 1, .reusable = false}, REDUCE(sym__declaration_specifiers, 1),
  [224] = {.count = 1, .reusable = true}, REDUCE(aux_sym_translation_unit_repeat1, 1, .alias_sequence_id = 2),
  [226] = {.count = 1, .reusable = false}, REDUCE(aux_sym_translation_unit_repeat1, 1, .alias_sequence_id = 2),
  [228] = {.count = 1, .reusable = true}, REDUCE(sym__type_specifier, 1),
  [230] = {.count = 1, .reusable = false}, REDUCE(sym__type_specifier, 1),
  [232] = {.count = 1, .reusable = true}, SHIFT(139),
  [234] = {.count = 1, .reusable = true}, REDUCE(sym_translation_unit, 1),
  [236] = {.count = 1, .reusable = false}, SHIFT(144),
  [238] = {.count = 1, .reusable = true}, REDUCE(sym_sized_type_specifier, 1),
  [240] = {.count = 1, .reusable = false}, REDUCE(sym_sized_type_specifier, 1),
  [242] = {.count = 1, .reusable = false}, SHIFT(148),
  [244] = {.count = 1, .reusable = false}, SHIFT(146),
  [246] = {.count = 2, .reusable = false}, REDUCE(sym_sized_type_specifier, 1), SHIFT(147),
  [249] = {.count = 1, .reusable = true}, REDUCE(sym_preproc_include, 2, .alias_sequence_id = 3),
  [251] = {.count = 1, .reusable = false}, REDUCE(sym_preproc_include, 2, .alias_sequence_id = 3),
  [253] = {.count = 1, .reusable = false}, SHIFT(149),
  [255] = {.count = 1, .reusable = false}, SHIFT(150),
  [257] = {.count = 1, .reusable = false}, SHIFT(151),
  [259] = {.count = 1, .reusable = true}, SHIFT(153),
  [261] = {.count = 1, .reusable = true}, SHIFT(154),
  [263] = {.count = 1, .reusable = false}, REDUCE(sym__declarator, 1),
  [265] = {.count = 1, .reusable = true}, SHIFT(155),
  [267] = {.count = 1, .reusable = false}, SHIFT(157),
  [269] = {.count = 1, .reusable = true}, SHIFT(158),
  [271] = {.count = 1, .reusable = true}, SHIFT(160),
  [273] = {.count = 1, .reusable = false}, SHIFT(161),
  [275] = {.count = 1, .reusable = false}, SHIFT(162),
  [277] = {.count = 1, .reusable = false}, SHIFT(163),
  [279] = {.count = 1, .reusable = false}, SHIFT(164),
  [281] = {.count = 1, .reusable = false}, SHIFT(165),
  [283] = {.count = 1, .reusable = false}, SHIFT(166),
  [285] = {.count = 1, .reusable = false}, SHIFT(167),
  [287] = {.count = 1, .reusable = false}, SHIFT(168),
  [289] = {.count = 1, .reusable = false}, SHIFT(169),
  [291] = {.count = 1, .reusable = false}, SHIFT(170),
  [293] = {.count = 1, .reusable = false}, SHIFT(171),
  [295] = {.count = 1, .reusable = false}, SHIFT(172),
  [297] = {.count = 1, .reusable = false}, SHIFT(173),
  [299] = {.count = 1, .reusable = false}, SHIFT(174),
  [301] = {.count = 1, .reusable = false}, SHIFT(181),
  [303] = {.count = 1, .reusable = false}, SHIFT(184),
  [305] = {.count = 1, .reusable = false}, SHIFT(187),
  [307] = {.count = 1, .reusable = true}, REDUCE(sym_preproc_call, 2),
  [309] = {.count = 1, .reusable = false}, REDUCE(sym_preproc_call, 2),
  [311] = {.count = 1, .reusable = true}, SHIFT(188),
  [313] = {.count = 1, .reusable = true}, SHIFT(189),
  [315] = {.count = 1, .reusable = true}, SHIFT(191),
  [317] = {.count = 1, .reusable = true}, SHIFT(192),
  [319] = {.count = 1, .reusable = true}, SHIFT(201),
  [321] = {.count = 1, .reusable = true}, SHIFT(202),
  [323] = {.count = 1, .reusable = false}, SHIFT(207),
  [325] = {.count = 1, .reusable = true}, SHIFT(208),
  [327] = {.count = 1, .reusable = true}, SHIFT(209),
  [329] = {.count = 1, .reusable = true}, SHIFT(210),
  [331] = {.count = 1, .reusable = true}, SHIFT(211),
  [333] = {.count = 1, .reusable = true}, SHIFT(216),
  [335] = {.count = 1, .reusable = false}, SHIFT(218),
  [337] = {.count = 1, .reusable = false}, SHIFT(222),
  [339] = {.count = 1, .reusable = false}, SHIFT(220),
  [341] = {.count = 2, .reusable = false}, REDUCE(sym_sized_type_specifier, 1), SHIFT(221),
  [344] = {.count = 1, .reusable = true}, SHIFT(226),
  [346] = {.count = 1, .reusable = true}, SHIFT(227),
  [348] = {.count = 1, .reusable = true}, SHIFT(228),
  [350] = {.count = 1, .reusable = true}, REDUCE(sym_enum_specifier, 2, .alias_sequence_id = 4),
  [352] = {.count = 1, .reusable = false}, REDUCE(sym_enum_specifier, 2, .alias_sequence_id = 4),
  [354] = {.count = 1, .reusable = true}, REDUCE(sym_enum_specifier, 2),
  [356] = {.count = 1, .reusable = false}, REDUCE(sym_enum_specifier, 2),
  [358] = {.count = 1, .reusable = false}, SHIFT(231),
  [360] = {.count = 1, .reusable = true}, SHIFT(232),
  [362] = {.count = 1, .reusable = true}, SHIFT(233),
  [364] = {.count = 1, .reusable = false}, SHIFT(234),
  [366] = {.count = 1, .reusable = true}, SHIFT(235),
  [368] = {.count = 1, .reusable = false}, SHIFT(258),
  [370] = {.count = 1, .reusable = false}, SHIFT(251),
  [372] = {.count = 1, .reusable = false}, SHIFT(236),
  [374] = {.count = 1, .reusable = false}, SHIFT(237),
  [376] = {.count = 1, .reusable = false}, SHIFT(238),
  [378] = {.count = 1, .reusable = false}, SHIFT(239),
  [380] = {.count = 1, .reusable = false}, SHIFT(240),
  [382] = {.count = 1, .reusable = false}, SHIFT(241),
  [384] = {.count = 1, .reusable = false}, SHIFT(242),
  [386] = {.count = 1, .reusable = false}, SHIFT(243),
  [388] = {.count = 1, .reusable = false}, SHIFT(244),
  [390] = {.count = 1, .reusable = true}, SHIFT(245),
  [392] = {.count = 1, .reusable = true}, SHIFT(249),
  [394] = {.count = 1, .reusable = false}, SHIFT(259),
  [396] = {.count = 1, .reusable = false}, SHIFT(260),
  [398] = {.count = 1, .reusable = true}, REDUCE(sym__class_name, 1, .alias_sequence_id = 1),
  [400] = {.count = 1, .reusable = false}, REDUCE(sym__class_name, 1, .alias_sequence_id = 1),
  [402] = {.count = 1, .reusable = true}, SHIFT(262),
  [404] = {.count = 1, .reusable = true}, SHIFT(264),
  [406] = {.count = 1, .reusable = true}, REDUCE(sym_struct_specifier, 2),
  [408] = {.count = 1, .reusable = false}, REDUCE(sym_struct_specifier, 2),
  [410] = {.count = 1, .reusable = true}, REDUCE(sym__class_name, 1),
  [412] = {.count = 1, .reusable = false}, REDUCE(sym__class_name, 1),
  [414] = {.count = 1, .reusable = true}, SHIFT(267),
  [416] = {.count = 1, .reusable = true}, REDUCE(sym_union_specifier, 2),
  [418] = {.count = 1, .reusable = false}, REDUCE(sym_union_specifier, 2),
  [420] = {.count = 1, .reusable = true}, REDUCE(sym_destructor_name, 2),
  [422] = {.count = 1, .reusable = true}, SHIFT(270),
  [424] = {.count = 1, .reusable = false}, SHIFT(280),
  [426] = {.count = 1, .reusable = false}, SHIFT(277),
  [428] = {.count = 1, .reusable = false}, SHIFT(271),
  [430] = {.count = 1, .reusable = false}, SHIFT(272),
  [432] = {.count = 1, .reusable = true}, SHIFT(273),
  [434] = {.count = 1, .reusable = false}, SHIFT(274),
  [436] = {.count = 1, .reusable = false}, SHIFT(275),
  [438] = {.count = 1, .reusable = false}, SHIFT(276),
  [440] = {.count = 1, .reusable = false}, SHIFT(281),
  [442] = {.count = 1, .reusable = true}, SHIFT(282),
  [444] = {.count = 2, .reusable = true}, REDUCE(sym_template_type, 2, .alias_sequence_id = 1), REDUCE(sym_template_function, 2),
  [447] = {.count = 1, .reusable = true}, REDUCE(sym_template_type, 2, .alias_sequence_id = 1),
  [449] = {.count = 1, .reusable = false}, REDUCE(sym_template_type, 2, .alias_sequence_id = 1),
  [451] = {.count = 1, .reusable = true}, REDUCE(sym_class_specifier, 2),
  [453] = {.count = 1, .reusable = false}, REDUCE(sym_class_specifier, 2),
  [455] = {.count = 1, .reusable = true}, REDUCE(sym_dependent_type, 2),
  [457] = {.count = 1, .reusable = false}, REDUCE(sym_dependent_type, 2),
  [459] = {.count = 1, .reusable = true}, SHIFT(285),
  [461] = {.count = 1, .reusable = true}, SHIFT(286),
  [463] = {.count = 1, .reusable = false}, SHIFT(293),
  [465] = {.count = 1, .reusable = false}, SHIFT(290),
  [467] = {.count = 1, .reusable = true}, SHIFT(287),
  [469] = {.count = 1, .reusable = false}, SHIFT(288),
  [471] = {.count = 1, .reusable = true}, SHIFT(294),
  [473] = {.count = 1, .reusable = false}, SHIFT(296),
  [475] = {.count = 1, .reusable = true}, SHIFT(297),
  [477] = {.count = 1, .reusable = true}, SHIFT(298),
  [479] = {.count = 1, .reusable = false}, SHIFT(306),
  [481] = {.count = 1, .reusable = false}, SHIFT(304),
  [483] = {.count = 1, .reusable = false}, SHIFT(301),
  [485] = {.count = 1, .reusable = true}, SHIFT(307),
  [487] = {.count = 1, .reusable = false}, SHIFT(308),
  [489] = {.count = 1, .reusable = false}, SHIFT(310),
  [491] = {.count = 1, .reusable = true}, SHIFT(311),
  [493] = {.count = 1, .reusable = true}, REDUCE(sym_namespace_definition, 2),
  [495] = {.count = 1, .reusable = false}, REDUCE(sym_namespace_definition, 2),
  [497] = {.count = 1, .reusable = true}, SHIFT(314),
  [499] = {.count = 1, .reusable = true}, SHIFT(315),
  [501] = {.count = 1, .reusable = true}, SHIFT(316),
  [503] = {.count = 1, .reusable = true}, SHIFT(317),
  [505] = {.count = 1, .reusable = false}, SHIFT(319),
  [507] = {.count = 1, .reusable = true}, SHIFT(320),
  [509] = {.count = 2, .reusable = true}, REDUCE(sym_scoped_identifier, 2), REDUCE(sym_scoped_type_identifier, 2, .alias_sequence_id = 4),
  [512] = {.count = 1, .reusable = true}, REDUCE(sym_scoped_type_identifier, 2, .alias_sequence_id = 4),
  [514] = {.count = 1, .reusable = false}, REDUCE(sym_scoped_type_identifier, 2, .alias_sequence_id = 4),
  [516] = {.count = 1, .reusable = true}, REDUCE(sym_scoped_namespace_identifier, 2, .alias_sequence_id = 5),
  [518] = {.count = 1, .reusable = true}, REDUCE(sym_scoped_identifier, 2),
  [520] = {.count = 1, .reusable = false}, REDUCE(sym_scoped_identifier, 2),
  [522] = {.count = 1, .reusable = true}, REDUCE(sym__empty_declaration, 2),
  [524] = {.count = 1, .reusable = false}, REDUCE(sym__empty_declaration, 2),
  [526] = {.count = 1, .reusable = false}, SHIFT(321),
  [528] = {.count = 1, .reusable = true}, SHIFT(321),
  [530] = {.count = 1, .reusable = true}, SHIFT(322),
  [532] = {.count = 1, .reusable = true}, SHIFT(323),
  [534] = {.count = 1, .reusable = true}, SHIFT(324),
  [536] = {.count = 1, .reusable = true}, SHIFT(326),
  [538] = {.count = 1, .reusable = true}, SHIFT(327),
  [540] = {.count = 1, .reusable = true}, SHIFT(328),
  [542] = {.count = 1, .reusable = true}, SHIFT(329),
  [544] = {.count = 1, .reusable = true}, SHIFT(330),
  [546] = {.count = 1, .reusable = true}, SHIFT(335),
  [548] = {.count = 1, .reusable = true}, SHIFT(336),
  [550] = {.count = 1, .reusable = true}, SHIFT(337),
  [552] = {.count = 1, .reusable = true}, SHIFT(339),
  [554] = {.count = 1, .reusable = true}, SHIFT(341),
  [556] = {.count = 1, .reusable = true}, SHIFT(342),
  [558] = {.count = 1, .reusable = false}, SHIFT(347),
  [560] = {.count = 1, .reusable = false}, SHIFT(345),
  [562] = {.count = 1, .reusable = false}, SHIFT(343),
  [564] = {.count = 1, .reusable = true}, SHIFT(368),
  [566] = {.count = 1, .reusable = true}, SHIFT(348),
  [568] = {.count = 1, .reusable = true}, SHIFT(349),
  [570] = {.count = 1, .reusable = true}, SHIFT(350),
  [572] = {.count = 1, .reusable = true}, SHIFT(351),
  [574] = {.count = 1, .reusable = false}, SHIFT(375),
  [576] = {.count = 1, .reusable = false}, SHIFT(367),
  [578] = {.count = 1, .reusable = false}, SHIFT(352),
  [580] = {.count = 1, .reusable = false}, SHIFT(353),
  [582] = {.count = 1, .reusable = false}, SHIFT(354),
  [584] = {.count = 1, .reusable = true}, SHIFT(355),
  [586] = {.count = 1, .reusable = true}, SHIFT(356),
  [588] = {.count = 1, .reusable = false}, SHIFT(357),
  [590] = {.count = 1, .reusable = true}, SHIFT(357),
  [592] = {.count = 1, .reusable = false}, SHIFT(358),
  [594] = {.count = 1, .reusable = true}, SHIFT(359),
  [596] = {.count = 1, .reusable = false}, SHIFT(368),
  [598] = {.count = 1, .reusable = false}, SHIFT(360),
  [600] = {.count = 1, .reusable = false}, SHIFT(361),
  [602] = {.count = 1, .reusable = false}, SHIFT(362),
  [604] = {.count = 1, .reusable = false}, SHIFT(363),
  [606] = {.count = 1, .reusable = true}, SHIFT(364),
  [608] = {.count = 1, .reusable = false}, SHIFT(365),
  [610] = {.count = 1, .reusable = true}, REDUCE(sym_function_declarator, 2),
  [612] = {.count = 1, .reusable = false}, SHIFT(376),
  [614] = {.count = 1, .reusable = true}, SHIFT(376),
  [616] = {.count = 1, .reusable = true}, SHIFT(377),
  [618] = {.count = 1, .reusable = true}, SHIFT(378),
  [620] = {.count = 1, .reusable = true}, SHIFT(413),
  [622] = {.count = 1, .reusable = false}, SHIFT(379),
  [624] = {.count = 1, .reusable = false}, SHIFT(380),
  [626] = {.count = 1, .reusable = true}, SHIFT(381),
  [628] = {.count = 1, .reusable = false}, SHIFT(382),
  [630] = {.count = 1, .reusable = false}, SHIFT(383),
  [632] = {.count = 1, .reusable = false}, SHIFT(384),
  [634] = {.count = 1, .reusable = false}, SHIFT(385),
  [636] = {.count = 1, .reusable = true}, SHIFT(386),
  [638] = {.count = 1, .reusable = false}, SHIFT(387),
  [640] = {.count = 1, .reusable = true}, SHIFT(388),
  [642] = {.count = 1, .reusable = true}, SHIFT(389),
  [644] = {.count = 1, .reusable = true}, SHIFT(390),
  [646] = {.count = 1, .reusable = false}, SHIFT(391),
  [648] = {.count = 1, .reusable = false}, SHIFT(392),
  [650] = {.count = 1, .reusable = false}, SHIFT(393),
  [652] = {.count = 1, .reusable = false}, SHIFT(394),
  [654] = {.count = 1, .reusable = false}, SHIFT(395),
  [656] = {.count = 1, .reusable = false}, SHIFT(396),
  [658] = {.count = 1, .reusable = false}, SHIFT(397),
  [660] = {.count = 1, .reusable = false}, SHIFT(398),
  [662] = {.count = 1, .reusable = false}, SHIFT(399),
  [664] = {.count = 1, .reusable = false}, SHIFT(400),
  [666] = {.count = 1, .reusable = false}, SHIFT(401),
  [668] = {.count = 1, .reusable = true}, SHIFT(402),
  [670] = {.count = 1, .reusable = true}, SHIFT(403),
  [672] = {.count = 1, .reusable = false}, SHIFT(404),
  [674] = {.count = 1, .reusable = true}, SHIFT(404),
  [676] = {.count = 1, .reusable = false}, SHIFT(405),
  [678] = {.count = 1, .reusable = true}, SHIFT(406),
  [680] = {.count = 1, .reusable = false}, SHIFT(413),
  [682] = {.count = 1, .reusable = false}, SHIFT(407),
  [684] = {.count = 1, .reusable = true}, SHIFT(408),
  [686] = {.count = 1, .reusable = false}, SHIFT(409),
  [688] = {.count = 1, .reusable = true}, SHIFT(420),
  [690] = {.count = 1, .reusable = true}, SHIFT(421),
  [692] = {.count = 1, .reusable = true}, REDUCE(sym_constructor_or_destructor_definition, 2),
  [694] = {.count = 1, .reusable = false}, REDUCE(sym_constructor_or_destructor_definition, 2),
  [696] = {.count = 1, .reusable = true}, REDUCE(sym__declaration_specifiers, 2),
  [698] = {.count = 1, .reusable = false}, REDUCE(sym__declaration_specifiers, 2),
  [700] = {.count = 1, .reusable = false}, SHIFT(427),
  [702] = {.count = 1, .reusable = true}, SHIFT(428),
  [704] = {.count = 1, .reusable = true}, REDUCE(sym_template_function, 2),
  [706] = {.count = 1, .reusable = false}, REDUCE(sym_template_function, 2),
  [708] = {.count = 1, .reusable = true}, REDUCE(sym_template_type, 2),
  [710] = {.count = 1, .reusable = false}, REDUCE(sym_template_type, 2),
  [712] = {.count = 1, .reusable = true}, REDUCE(aux_sym_translation_unit_repeat1, 2),
  [714] = {.count = 2, .reusable = false}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(2),
  [717] = {.count = 2, .reusable = false}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(3),
  [720] = {.count = 2, .reusable = true}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(4),
  [723] = {.count = 2, .reusable = false}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(5),
  [726] = {.count = 2, .reusable = false}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(6),
  [729] = {.count = 2, .reusable = false}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(7),
  [732] = {.count = 2, .reusable = false}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(8),
  [735] = {.count = 2, .reusable = false}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(9),
  [738] = {.count = 2, .reusable = false}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(10),
  [741] = {.count = 2, .reusable = true}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(11),
  [744] = {.count = 2, .reusable = false}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(12),
  [747] = {.count = 2, .reusable = false}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(13),
  [750] = {.count = 2, .reusable = false}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(38),
  [753] = {.count = 2, .reusable = false}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(30),
  [756] = {.count = 2, .reusable = false}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(14),
  [759] = {.count = 2, .reusable = false}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(15),
  [762] = {.count = 2, .reusable = false}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(16),
  [765] = {.count = 2, .reusable = false}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(17),
  [768] = {.count = 2, .reusable = true}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(17),
  [771] = {.count = 2, .reusable = true}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(18),
  [774] = {.count = 2, .reusable = false}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(19),
  [777] = {.count = 2, .reusable = false}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(20),
  [780] = {.count = 2, .reusable = false}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(21),
  [783] = {.count = 2, .reusable = false}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(22),
  [786] = {.count = 2, .reusable = false}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(23),
  [789] = {.count = 2, .reusable = false}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(24),
  [792] = {.count = 2, .reusable = true}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(25),
  [795] = {.count = 2, .reusable = true}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(28),
  [798] = {.count = 1, .reusable = true}, REDUCE(aux_sym__declaration_specifiers_repeat1, 2),
  [800] = {.count = 2, .reusable = false}, REDUCE(aux_sym__declaration_specifiers_repeat1, 2), SHIFT_REPEAT(12),
  [803] = {.count = 2, .reusable = false}, REDUCE(aux_sym__declaration_specifiers_repeat1, 2), SHIFT_REPEAT(13),
  [806] = {.count = 1, .reusable = false}, REDUCE(aux_sym__declaration_specifiers_repeat1, 2),
  [808] = {.count = 1, .reusable = true}, REDUCE(sym_sized_type_specifier, 2),
  [810] = {.count = 1, .reusable = false}, REDUCE(sym_sized_type_specifier, 2),
  [812] = {.count = 1, .reusable = true}, REDUCE(sym_sized_type_specifier, 2, .dynamic_precedence = -1, .alias_sequence_id = 4),
  [814] = {.count = 1, .reusable = false}, REDUCE(sym_sized_type_specifier, 2, .dynamic_precedence = -1, .alias_sequence_id = 4),
  [816] = {.count = 1, .reusable = true}, REDUCE(aux_sym_sized_type_specifier_repeat1, 2),
  [818] = {.count = 1, .reusable = false}, REDUCE(aux_sym_sized_type_specifier_repeat1, 2),
  [820] = {.count = 2, .reusable = false}, REDUCE(aux_sym_sized_type_specifier_repeat1, 2), SHIFT_REPEAT(148),
  [823] = {.count = 1, .reusable = false}, SHIFT(431),
  [825] = {.count = 1, .reusable = true}, REDUCE(sym_preproc_def, 3, .alias_sequence_id = 6),
  [827] = {.count = 1, .reusable = false}, REDUCE(sym_preproc_def, 3, .alias_sequence_id = 6),
  [829] = {.count = 1, .reusable = true}, SHIFT(432),
  [831] = {.count = 1, .reusable = true}, SHIFT(433),
  [833] = {.count = 1, .reusable = false}, SHIFT(434),
  [835] = {.count = 1, .reusable = false}, SHIFT(435),
  [837] = {.count = 1, .reusable = true}, REDUCE(sym_pointer_declarator, 2),
  [839] = {.count = 1, .reusable = true}, REDUCE(sym_reference_declarator, 2),
  [841] = {.count = 1, .reusable = false}, SHIFT(436),
  [843] = {.count = 1, .reusable = true}, REDUCE(sym__declarator, 3),
  [845] = {.count = 1, .reusable = true}, SHIFT(437),
  [847] = {.count = 1, .reusable = true}, SHIFT(438),
  [849] = {.count = 1, .reusable = false}, SHIFT(439),
  [851] = {.count = 1, .reusable = true}, SHIFT(440),
  [853] = {.count = 1, .reusable = true}, SHIFT(441),
  [855] = {.count = 1, .reusable = false}, SHIFT(442),
  [857] = {.count = 1, .reusable = true}, REDUCE(sym_preproc_if, 3, .alias_sequence_id = 7),
  [859] = {.count = 1, .reusable = false}, REDUCE(sym_preproc_if, 3, .alias_sequence_id = 7),
  [861] = {.count = 1, .reusable = true}, SHIFT(443),
  [863] = {.count = 1, .reusable = true}, SHIFT(444),
  [865] = {.count = 1, .reusable = false}, SHIFT(445),
  [867] = {.count = 1, .reusable = false}, SHIFT(446),
  [869] = {.count = 1, .reusable = false}, SHIFT(447),
  [871] = {.count = 1, .reusable = false}, REDUCE(sym_preproc_else, 1, .alias_sequence_id = 8),
  [873] = {.count = 1, .reusable = false}, SHIFT(448),
  [875] = {.count = 1, .reusable = false}, SHIFT(449),
  [877] = {.count = 1, .reusable = false}, SHIFT(450),
  [879] = {.count = 1, .reusable = false}, SHIFT(451),
  [881] = {.count = 1, .reusable = false}, SHIFT(452),
  [883] = {.count = 1, .reusable = false}, SHIFT(453),
  [885] = {.count = 1, .reusable = false}, SHIFT(454),
  [887] = {.count = 1, .reusable = false}, SHIFT(455),
  [889] = {.count = 1, .reusable = false}, SHIFT(461),
  [891] = {.count = 1, .reusable = false}, SHIFT(462),
  [893] = {.count = 1, .reusable = false}, SHIFT(463),
  [895] = {.count = 1, .reusable = false}, SHIFT(464),
  [897] = {.count = 1, .reusable = true}, SHIFT(466),
  [899] = {.count = 1, .reusable = true}, SHIFT(468),
  [901] = {.count = 1, .reusable = true}, SHIFT(470),
  [903] = {.count = 1, .reusable = true}, SHIFT(471),
  [905] = {.count = 1, .reusable = false}, SHIFT(473),
  [907] = {.count = 1, .reusable = false}, SHIFT(474),
  [909] = {.count = 1, .reusable = true}, SHIFT(476),
  [911] = {.count = 1, .reusable = true}, SHIFT(477),
  [913] = {.count = 1, .reusable = true}, SHIFT(478),
  [915] = {.count = 1, .reusable = true}, SHIFT(482),
  [917] = {.count = 1, .reusable = false}, SHIFT(476),
  [919] = {.count = 1, .reusable = true}, REDUCE(sym_preproc_ifdef, 3, .alias_sequence_id = 9),
  [921] = {.count = 1, .reusable = false}, REDUCE(sym_preproc_ifdef, 3, .alias_sequence_id = 9),
  [923] = {.count = 1, .reusable = true}, SHIFT(488),
  [925] = {.count = 1, .reusable = false}, SHIFT(488),
  [927] = {.count = 1, .reusable = true}, REDUCE(sym_preproc_ifdef, 3, .alias_sequence_id = 10),
  [929] = {.count = 1, .reusable = false}, REDUCE(sym_preproc_ifdef, 3, .alias_sequence_id = 10),
  [931] = {.count = 1, .reusable = true}, SHIFT(490),
  [933] = {.count = 1, .reusable = false}, SHIFT(490),
  [935] = {.count = 1, .reusable = true}, SHIFT(492),
  [937] = {.count = 1, .reusable = true}, SHIFT(493),
  [939] = {.count = 1, .reusable = true}, SHIFT(494),
  [941] = {.count = 1, .reusable = true}, SHIFT(497),
  [943] = {.count = 1, .reusable = true}, SHIFT(73),
  [945] = {.count = 1, .reusable = true}, SHIFT(503),
  [947] = {.count = 1, .reusable = true}, SHIFT(505),
  [949] = {.count = 1, .reusable = true}, SHIFT(508),
  [951] = {.count = 1, .reusable = true}, REDUCE(sym__type_declarator, 1, .alias_sequence_id = 1),
  [953] = {.count = 1, .reusable = true}, SHIFT(511),
  [955] = {.count = 1, .reusable = true}, SHIFT(512),
  [957] = {.count = 1, .reusable = true}, REDUCE(sym__type_declarator, 1, .alias_sequence_id = 11),
  [959] = {.count = 1, .reusable = true}, REDUCE(sym__type_declarator, 1, .alias_sequence_id = 12),
  [961] = {.count = 1, .reusable = true}, REDUCE(sym__type_declarator, 1, .alias_sequence_id = 13),
  [963] = {.count = 1, .reusable = true}, SHIFT(514),
  [965] = {.count = 2, .reusable = false}, REDUCE(aux_sym_type_definition_repeat1, 2), SHIFT_REPEAT(53),
  [968] = {.count = 1, .reusable = false}, REDUCE(aux_sym_type_definition_repeat1, 2),
  [970] = {.count = 1, .reusable = true}, REDUCE(aux_sym_type_definition_repeat1, 2),
  [972] = {.count = 2, .reusable = false}, REDUCE(aux_sym_sized_type_specifier_repeat1, 2), SHIFT_REPEAT(222),
  [975] = {.count = 1, .reusable = true}, REDUCE(sym_linkage_specification, 3),
  [977] = {.count = 1, .reusable = false}, REDUCE(sym_linkage_specification, 3),
  [979] = {.count = 1, .reusable = true}, SHIFT(516),
  [981] = {.count = 1, .reusable = true}, SHIFT(517),
  [983] = {.count = 1, .reusable = true}, SHIFT(518),
  [985] = {.count = 1, .reusable = true}, REDUCE(sym_enumerator_list, 2),
  [987] = {.count = 1, .reusable = false}, REDUCE(sym_enumerator_list, 2),
  [989] = {.count = 1, .reusable = true}, REDUCE(sym_enumerator, 1),
  [991] = {.count = 1, .reusable = true}, SHIFT(519),
  [993] = {.count = 1, .reusable = true}, SHIFT(520),
  [995] = {.count = 1, .reusable = true}, REDUCE(sym_enum_specifier, 3, .alias_sequence_id = 4),
  [997] = {.count = 1, .reusable = false}, REDUCE(sym_enum_specifier, 3, .alias_sequence_id = 4),
  [999] = {.count = 1, .reusable = false}, SHIFT(522),
  [1001] = {.count = 1, .reusable = true}, SHIFT(523),
  [1003] = {.count = 1, .reusable = true}, SHIFT(524),
  [1005] = {.count = 1, .reusable = false}, SHIFT(525),
  [1007] = {.count = 1, .reusable = true}, REDUCE(sym_field_declaration_list, 2),
  [1009] = {.count = 1, .reusable = false}, REDUCE(sym_field_declaration_list, 2),
  [1011] = {.count = 1, .reusable = true}, SHIFT(529),
  [1013] = {.count = 1, .reusable = true}, SHIFT(532),
  [1015] = {.count = 1, .reusable = false}, SHIFT(537),
  [1017] = {.count = 1, .reusable = false}, SHIFT(538),
  [1019] = {.count = 1, .reusable = false}, SHIFT(540),
  [1021] = {.count = 1, .reusable = true}, REDUCE(sym__field_declaration_list_item, 1, .alias_sequence_id = 14),
  [1023] = {.count = 1, .reusable = false}, REDUCE(sym__field_declaration_list_item, 1, .alias_sequence_id = 14),
  [1025] = {.count = 1, .reusable = true}, REDUCE(sym__field_declaration_list_item, 1, .alias_sequence_id = 15),
  [1027] = {.count = 1, .reusable = false}, REDUCE(sym__field_declaration_list_item, 1, .alias_sequence_id = 15),
  [1029] = {.count = 1, .reusable = true}, SHIFT(541),
  [1031] = {.count = 1, .reusable = true}, SHIFT(542),
  [1033] = {.count = 1, .reusable = true}, SHIFT(543),
  [1035] = {.count = 1, .reusable = false}, SHIFT(544),
  [1037] = {.count = 1, .reusable = false}, SHIFT(545),
  [1039] = {.count = 1, .reusable = true}, SHIFT(545),
  [1041] = {.count = 1, .reusable = false}, SHIFT(546),
  [1043] = {.count = 1, .reusable = true}, SHIFT(547),
  [1045] = {.count = 1, .reusable = true}, SHIFT(548),
  [1047] = {.count = 1, .reusable = true}, SHIFT(556),
  [1049] = {.count = 1, .reusable = true}, SHIFT(557),
  [1051] = {.count = 1, .reusable = true}, REDUCE(sym__field_declaration_list_item, 1, .alias_sequence_id = 2),
  [1053] = {.count = 1, .reusable = false}, REDUCE(sym__field_declaration_list_item, 1, .alias_sequence_id = 2),
  [1055] = {.count = 1, .reusable = true}, REDUCE(sym__field_declaration_list_item, 1, .alias_sequence_id = 16),
  [1057] = {.count = 1, .reusable = false}, REDUCE(sym__field_declaration_list_item, 1, .alias_sequence_id = 16),
  [1059] = {.count = 1, .reusable = true}, SHIFT(561),
  [1061] = {.count = 1, .reusable = true}, SHIFT(562),
  [1063] = {.count = 1, .reusable = false}, SHIFT(565),
  [1065] = {.count = 1, .reusable = false}, SHIFT(566),
  [1067] = {.count = 1, .reusable = true}, SHIFT(259),
  [1069] = {.count = 1, .reusable = true}, SHIFT(568),
  [1071] = {.count = 1, .reusable = true}, REDUCE(sym_base_class_clause, 2),
  [1073] = {.count = 1, .reusable = true}, SHIFT(570),
  [1075] = {.count = 1, .reusable = true}, REDUCE(sym_struct_specifier, 3),
  [1077] = {.count = 1, .reusable = false}, REDUCE(sym_struct_specifier, 3),
  [1079] = {.count = 1, .reusable = true}, SHIFT(572),
  [1081] = {.count = 1, .reusable = true}, REDUCE(sym_union_specifier, 3),
  [1083] = {.count = 1, .reusable = false}, REDUCE(sym_union_specifier, 3),
  [1085] = {.count = 1, .reusable = true}, SHIFT(584),
  [1087] = {.count = 1, .reusable = true}, SHIFT(574),
  [1089] = {.count = 1, .reusable = true}, SHIFT(575),
  [1091] = {.count = 1, .reusable = true}, SHIFT(576),
  [1093] = {.count = 1, .reusable = true}, SHIFT(577),
  [1095] = {.count = 1, .reusable = false}, SHIFT(578),
  [1097] = {.count = 1, .reusable = true}, SHIFT(578),
  [1099] = {.count = 1, .reusable = false}, SHIFT(579),
  [1101] = {.count = 1, .reusable = true}, SHIFT(580),
  [1103] = {.count = 1, .reusable = false}, SHIFT(584),
  [1105] = {.count = 1, .reusable = false}, SHIFT(581),
  [1107] = {.count = 1, .reusable = true}, SHIFT(582),
  [1109] = {.count = 1, .reusable = false}, SHIFT(583),
  [1111] = {.count = 1, .reusable = true}, REDUCE(sym_template_argument_list, 2),
  [1113] = {.count = 1, .reusable = false}, REDUCE(sym_template_argument_list, 2),
  [1115] = {.count = 1, .reusable = true}, SHIFT(593),
  [1117] = {.count = 1, .reusable = true}, REDUCE(sym_type_descriptor, 1),
  [1119] = {.count = 1, .reusable = true}, SHIFT(594),
  [1121] = {.count = 1, .reusable = true}, SHIFT(595),
  [1123] = {.count = 1, .reusable = false}, SHIFT(596),
  [1125] = {.count = 1, .reusable = true}, SHIFT(596),
  [1127] = {.count = 1, .reusable = true}, SHIFT(599),
  [1129] = {.count = 1, .reusable = true}, SHIFT(600),
  [1131] = {.count = 1, .reusable = false}, SHIFT(602),
  [1133] = {.count = 1, .reusable = false}, SHIFT(603),
  [1135] = {.count = 1, .reusable = false}, SHIFT(147),
  [1137] = {.count = 2, .reusable = true}, REDUCE(sym_scoped_identifier, 3, .alias_sequence_id = 17), REDUCE(sym_scoped_type_identifier, 3, .alias_sequence_id = 18),
  [1140] = {.count = 1, .reusable = true}, REDUCE(sym_scoped_type_identifier, 3, .alias_sequence_id = 18),
  [1142] = {.count = 1, .reusable = false}, REDUCE(sym_scoped_type_identifier, 3, .alias_sequence_id = 18),
  [1144] = {.count = 1, .reusable = true}, REDUCE(sym_scoped_namespace_identifier, 3, .alias_sequence_id = 19),
  [1146] = {.count = 1, .reusable = true}, REDUCE(sym_scoped_identifier, 3, .alias_sequence_id = 17),
  [1148] = {.count = 1, .reusable = false}, REDUCE(sym_scoped_identifier, 3, .alias_sequence_id = 17),
  [1150] = {.count = 1, .reusable = true}, REDUCE(sym_class_specifier, 3),
  [1152] = {.count = 1, .reusable = false}, REDUCE(sym_class_specifier, 3),
  [1154] = {.count = 1, .reusable = false}, REDUCE(sym_template_parameter_list, 2),
  [1156] = {.count = 1, .reusable = true}, REDUCE(sym_template_parameter_list, 2),
  [1158] = {.count = 1, .reusable = false}, SHIFT(605),
  [1160] = {.count = 1, .reusable = false}, SHIFT(606),
  [1162] = {.count = 1, .reusable = true}, SHIFT(607),
  [1164] = {.count = 1, .reusable = true}, REDUCE(sym_parameter_declaration, 1),
  [1166] = {.count = 1, .reusable = true}, SHIFT(608),
  [1168] = {.count = 1, .reusable = false}, SHIFT(609),
  [1170] = {.count = 1, .reusable = true}, SHIFT(609),
  [1172] = {.count = 1, .reusable = false}, SHIFT(610),
  [1174] = {.count = 1, .reusable = true}, SHIFT(611),
  [1176] = {.count = 1, .reusable = true}, SHIFT(612),
  [1178] = {.count = 1, .reusable = true}, SHIFT(618),
  [1180] = {.count = 1, .reusable = true}, SHIFT(619),
  [1182] = {.count = 1, .reusable = false}, SHIFT(621),
  [1184] = {.count = 1, .reusable = false}, SHIFT(622),
  [1186] = {.count = 1, .reusable = false}, SHIFT(623),
  [1188] = {.count = 1, .reusable = true}, SHIFT(624),
  [1190] = {.count = 1, .reusable = true}, REDUCE(sym_template_instantiation, 3),
  [1192] = {.count = 1, .reusable = false}, REDUCE(sym_template_instantiation, 3),
  [1194] = {.count = 1, .reusable = true}, SHIFT(625),
  [1196] = {.count = 1, .reusable = true}, SHIFT(626),
  [1198] = {.count = 1, .reusable = true}, REDUCE(sym_template_declaration, 3),
  [1200] = {.count = 1, .reusable = false}, REDUCE(sym_template_declaration, 3),
  [1202] = {.count = 1, .reusable = false}, SHIFT(629),
  [1204] = {.count = 1, .reusable = false}, SHIFT(630),
  [1206] = {.count = 1, .reusable = false}, SHIFT(631),
  [1208] = {.count = 2, .reusable = false}, REDUCE(aux_sym__declaration_specifiers_repeat1, 2), SHIFT_REPEAT(95),
  [1211] = {.count = 2, .reusable = false}, REDUCE(aux_sym__declaration_specifiers_repeat1, 2), SHIFT_REPEAT(97),
  [1214] = {.count = 2, .reusable = false}, REDUCE(aux_sym_sized_type_specifier_repeat1, 2), SHIFT_REPEAT(310),
  [1217] = {.count = 1, .reusable = true}, REDUCE(sym_declaration_list, 2),
  [1219] = {.count = 1, .reusable = false}, REDUCE(sym_declaration_list, 2),
  [1221] = {.count = 1, .reusable = true}, SHIFT(633),
  [1223] = {.count = 1, .reusable = true}, REDUCE(sym_namespace_definition, 3),
  [1225] = {.count = 1, .reusable = false}, REDUCE(sym_namespace_definition, 3),
  [1227] = {.count = 1, .reusable = true}, REDUCE(sym_using_declaration, 3),
  [1229] = {.count = 1, .reusable = false}, REDUCE(sym_using_declaration, 3),
  [1231] = {.count = 1, .reusable = false}, SHIFT(639),
  [1233] = {.count = 1, .reusable = false}, SHIFT(636),
  [1235] = {.count = 1, .reusable = false}, SHIFT(635),
  [1237] = {.count = 1, .reusable = false}, SHIFT(640),
  [1239] = {.count = 1, .reusable = true}, SHIFT(641),
  [1241] = {.count = 1, .reusable = false}, SHIFT(642),
  [1243] = {.count = 1, .reusable = true}, SHIFT(643),
  [1245] = {.count = 1, .reusable = true}, SHIFT(644),
  [1247] = {.count = 1, .reusable = true}, REDUCE(sym_structured_binding_reference_declarator, 2),
  [1249] = {.count = 1, .reusable = true}, SHIFT(649),
  [1251] = {.count = 1, .reusable = true}, SHIFT(646),
  [1253] = {.count = 1, .reusable = false}, SHIFT(649),
  [1255] = {.count = 1, .reusable = false}, SHIFT(647),
  [1257] = {.count = 1, .reusable = true}, SHIFT(648),
  [1259] = {.count = 1, .reusable = true}, SHIFT(653),
  [1261] = {.count = 1, .reusable = true}, REDUCE(sym_declaration, 3),
  [1263] = {.count = 1, .reusable = false}, REDUCE(sym_declaration, 3),
  [1265] = {.count = 1, .reusable = true}, SHIFT(669),
  [1267] = {.count = 1, .reusable = true}, SHIFT(655),
  [1269] = {.count = 1, .reusable = true}, SHIFT(656),
  [1271] = {.count = 1, .reusable = true}, SHIFT(657),
  [1273] = {.count = 1, .reusable = true}, SHIFT(658),
  [1275] = {.count = 1, .reusable = true}, SHIFT(659),
  [1277] = {.count = 1, .reusable = true}, SHIFT(660),
  [1279] = {.count = 1, .reusable = true}, SHIFT(661),
  [1281] = {.count = 1, .reusable = true}, SHIFT(662),
  [1283] = {.count = 1, .reusable = false}, SHIFT(663),
  [1285] = {.count = 1, .reusable = true}, SHIFT(663),
  [1287] = {.count = 1, .reusable = false}, SHIFT(664),
  [1289] = {.count = 1, .reusable = true}, SHIFT(665),
  [1291] = {.count = 1, .reusable = true}, SHIFT(666),
  [1293] = {.count = 1, .reusable = false}, SHIFT(669),
  [1295] = {.count = 1, .reusable = true}, SHIFT(667),
  [1297] = {.count = 1, .reusable = false}, SHIFT(668),
  [1299] = {.count = 1, .reusable = true}, SHIFT(673),
  [1301] = {.count = 1, .reusable = false}, SHIFT(673),
  [1303] = {.count = 1, .reusable = true}, SHIFT(672),
  [1305] = {.count = 1, .reusable = true}, REDUCE(sym_function_definition, 3),
  [1307] = {.count = 1, .reusable = false}, REDUCE(sym_function_definition, 3),
  [1309] = {.count = 1, .reusable = true}, SHIFT(675),
  [1311] = {.count = 1, .reusable = true}, SHIFT(676),
  [1313] = {.count = 1, .reusable = true}, REDUCE(sym_init_declarator, 2),
  [1315] = {.count = 1, .reusable = true}, SHIFT(677),
  [1317] = {.count = 1, .reusable = true}, SHIFT(679),
  [1319] = {.count = 1, .reusable = true}, SHIFT(690),
  [1321] = {.count = 1, .reusable = true}, SHIFT(680),
  [1323] = {.count = 1, .reusable = true}, SHIFT(681),
  [1325] = {.count = 1, .reusable = true}, SHIFT(682),
  [1327] = {.count = 1, .reusable = true}, SHIFT(683),
  [1329] = {.count = 1, .reusable = true}, SHIFT(684),
  [1331] = {.count = 1, .reusable = false}, SHIFT(685),
  [1333] = {.count = 1, .reusable = true}, SHIFT(685),
  [1335] = {.count = 1, .reusable = false}, SHIFT(686),
  [1337] = {.count = 1, .reusable = true}, SHIFT(687),
  [1339] = {.count = 1, .reusable = false}, SHIFT(690),
  [1341] = {.count = 1, .reusable = true}, SHIFT(688),
  [1343] = {.count = 1, .reusable = false}, SHIFT(689),
  [1345] = {.count = 1, .reusable = true}, SHIFT(700),
  [1347] = {.count = 1, .reusable = true}, SHIFT(691),
  [1349] = {.count = 1, .reusable = true}, SHIFT(692),
  [1351] = {.count = 1, .reusable = true}, SHIFT(693),
  [1353] = {.count = 1, .reusable = true}, SHIFT(694),
  [1355] = {.count = 1, .reusable = false}, SHIFT(695),
  [1357] = {.count = 1, .reusable = true}, SHIFT(695),
  [1359] = {.count = 1, .reusable = false}, SHIFT(696),
  [1361] = {.count = 1, .reusable = true}, SHIFT(697),
  [1363] = {.count = 1, .reusable = false}, SHIFT(700),
  [1365] = {.count = 1, .reusable = true}, SHIFT(698),
  [1367] = {.count = 1, .reusable = false}, SHIFT(699),
  [1369] = {.count = 1, .reusable = true}, SHIFT(702),
  [1371] = {.count = 1, .reusable = true}, SHIFT(703),
  [1373] = {.count = 1, .reusable = false}, SHIFT(703),
  [1375] = {.count = 1, .reusable = true}, SHIFT(705),
  [1377] = {.count = 1, .reusable = true}, SHIFT(706),
  [1379] = {.count = 1, .reusable = true}, SHIFT(707),
  [1381] = {.count = 1, .reusable = true}, REDUCE(sym_parameter_list, 2, .dynamic_precedence = 1),
  [1383] = {.count = 1, .reusable = false}, REDUCE(sym_parameter_list, 2, .dynamic_precedence = 1),
  [1385] = {.count = 1, .reusable = true}, SHIFT(709),
  [1387] = {.count = 1, .reusable = false}, SHIFT(710),
  [1389] = {.count = 1, .reusable = true}, SHIFT(710),
  [1391] = {.count = 1, .reusable = true}, SHIFT(711),
  [1393] = {.count = 1, .reusable = false}, SHIFT(715),
  [1395] = {.count = 1, .reusable = false}, SHIFT(716),
  [1397] = {.count = 1, .reusable = true}, SHIFT(721),
  [1399] = {.count = 1, .reusable = false}, SHIFT(725),
  [1401] = {.count = 1, .reusable = false}, SHIFT(720),
  [1403] = {.count = 1, .reusable = false}, SHIFT(721),
  [1405] = {.count = 1, .reusable = false}, SHIFT(717),
  [1407] = {.count = 1, .reusable = false}, SHIFT(718),
  [1409] = {.count = 1, .reusable = true}, SHIFT(719),
  [1411] = {.count = 1, .reusable = true}, SHIFT(727),
  [1413] = {.count = 1, .reusable = false}, SHIFT(727),
  [1415] = {.count = 1, .reusable = true}, SHIFT(726),
  [1417] = {.count = 1, .reusable = true}, SHIFT(740),
  [1419] = {.count = 1, .reusable = true}, SHIFT(728),
  [1421] = {.count = 1, .reusable = true}, SHIFT(729),
  [1423] = {.count = 1, .reusable = true}, SHIFT(730),
  [1425] = {.count = 1, .reusable = true}, SHIFT(731),
  [1427] = {.count = 1, .reusable = true}, SHIFT(732),
  [1429] = {.count = 1, .reusable = true}, SHIFT(733),
  [1431] = {.count = 1, .reusable = true}, SHIFT(734),
  [1433] = {.count = 1, .reusable = false}, SHIFT(735),
  [1435] = {.count = 1, .reusable = true}, SHIFT(735),
  [1437] = {.count = 1, .reusable = false}, SHIFT(736),
  [1439] = {.count = 1, .reusable = true}, SHIFT(737),
  [1441] = {.count = 1, .reusable = false}, SHIFT(740),
  [1443] = {.count = 1, .reusable = true}, SHIFT(738),
  [1445] = {.count = 1, .reusable = false}, SHIFT(739),
  [1447] = {.count = 1, .reusable = true}, REDUCE(sym_array_declarator, 3),
  [1449] = {.count = 1, .reusable = true}, SHIFT(742),
  [1451] = {.count = 1, .reusable = true}, SHIFT(743),
  [1453] = {.count = 1, .reusable = true}, SHIFT(745),
  [1455] = {.count = 1, .reusable = true}, SHIFT(746),
  [1457] = {.count = 1, .reusable = true}, SHIFT(747),
  [1459] = {.count = 1, .reusable = true}, SHIFT(757),
  [1461] = {.count = 1, .reusable = false}, SHIFT(757),
  [1463] = {.count = 1, .reusable = true}, SHIFT(758),
  [1465] = {.count = 1, .reusable = false}, SHIFT(758),
  [1467] = {.count = 1, .reusable = true}, SHIFT(759),
  [1469] = {.count = 1, .reusable = false}, SHIFT(759),
  [1471] = {.count = 1, .reusable = true}, SHIFT(761),
  [1473] = {.count = 1, .reusable = true}, SHIFT(760),
  [1475] = {.count = 1, .reusable = false}, SHIFT(761),
  [1477] = {.count = 1, .reusable = true}, REDUCE(sym__expression, 1),
  [1479] = {.count = 1, .reusable = false}, REDUCE(sym__expression, 1),
  [1481] = {.count = 1, .reusable = true}, SHIFT(762),
  [1483] = {.count = 2, .reusable = true}, REDUCE(sym__type_specifier, 1, .alias_sequence_id = 1), REDUCE(sym__expression, 1),
  [1486] = {.count = 2, .reusable = false}, REDUCE(sym__type_specifier, 1, .alias_sequence_id = 1), REDUCE(sym__expression, 1),
  [1489] = {.count = 2, .reusable = false}, REDUCE(sym__expression, 1), SHIFT(763),
  [1492] = {.count = 1, .reusable = true}, SHIFT(764),
  [1494] = {.count = 1, .reusable = false}, SHIFT(771),
  [1496] = {.count = 1, .reusable = false}, SHIFT(770),
  [1498] = {.count = 1, .reusable = true}, SHIFT(774),
  [1500] = {.count = 1, .reusable = true}, SHIFT(777),
  [1502] = {.count = 1, .reusable = false}, SHIFT(778),
  [1504] = {.count = 1, .reusable = false}, SHIFT(779),
  [1506] = {.count = 1, .reusable = true}, SHIFT(781),
  [1508] = {.count = 1, .reusable = true}, SHIFT(780),
  [1510] = {.count = 1, .reusable = false}, SHIFT(781),
  [1512] = {.count = 1, .reusable = true}, SHIFT(783),
  [1514] = {.count = 1, .reusable = true}, SHIFT(782),
  [1516] = {.count = 1, .reusable = false}, SHIFT(783),
  [1518] = {.count = 1, .reusable = false}, SHIFT(784),
  [1520] = {.count = 1, .reusable = false}, SHIFT(785),
  [1522] = {.count = 1, .reusable = false}, SHIFT(787),
  [1524] = {.count = 1, .reusable = true}, SHIFT(788),
  [1526] = {.count = 1, .reusable = false}, SHIFT(789),
  [1528] = {.count = 1, .reusable = true}, SHIFT(790),
  [1530] = {.count = 1, .reusable = true}, SHIFT(789),
  [1532] = {.count = 1, .reusable = false}, SHIFT(791),
  [1534] = {.count = 1, .reusable = true}, SHIFT(792),
  [1536] = {.count = 1, .reusable = true}, SHIFT(793),
  [1538] = {.count = 1, .reusable = false}, SHIFT(794),
  [1540] = {.count = 1, .reusable = false}, SHIFT(795),
  [1542] = {.count = 1, .reusable = true}, SHIFT(796),
  [1544] = {.count = 1, .reusable = false}, SHIFT(797),
  [1546] = {.count = 1, .reusable = true}, SHIFT(797),
  [1548] = {.count = 1, .reusable = false}, SHIFT(798),
  [1550] = {.count = 1, .reusable = false}, SHIFT(799),
  [1552] = {.count = 1, .reusable = true}, SHIFT(800),
  [1554] = {.count = 1, .reusable = true}, SHIFT(801),
  [1556] = {.count = 1, .reusable = true}, SHIFT(803),
  [1558] = {.count = 1, .reusable = true}, SHIFT(805),
  [1560] = {.count = 1, .reusable = false}, SHIFT(806),
  [1562] = {.count = 1, .reusable = true}, SHIFT(806),
  [1564] = {.count = 2, .reusable = false}, REDUCE(sym__expression, 1), SHIFT(810),
  [1567] = {.count = 1, .reusable = true}, SHIFT(811),
  [1569] = {.count = 1, .reusable = false}, SHIFT(813),
  [1571] = {.count = 1, .reusable = false}, SHIFT(816),
  [1573] = {.count = 1, .reusable = false}, SHIFT(814),
  [1575] = {.count = 2, .reusable = false}, REDUCE(sym_sized_type_specifier, 1), SHIFT(815),
  [1578] = {.count = 1, .reusable = false}, SHIFT(828),
  [1580] = {.count = 1, .reusable = false}, SHIFT(824),
  [1582] = {.count = 1, .reusable = false}, SHIFT(817),
  [1584] = {.count = 1, .reusable = false}, SHIFT(818),
  [1586] = {.count = 1, .reusable = false}, SHIFT(819),
  [1588] = {.count = 1, .reusable = false}, SHIFT(820),
  [1590] = {.count = 1, .reusable = false}, SHIFT(821),
  [1592] = {.count = 1, .reusable = false}, SHIFT(822),
  [1594] = {.count = 1, .reusable = true}, SHIFT(823),
  [1596] = {.count = 1, .reusable = true}, REDUCE(sym_function_declarator, 3),
  [1598] = {.count = 1, .reusable = true}, SHIFT(829),
  [1600] = {.count = 1, .reusable = true}, SHIFT(830),
  [1602] = {.count = 1, .reusable = true}, SHIFT(831),
  [1604] = {.count = 1, .reusable = false}, SHIFT(833),
  [1606] = {.count = 1, .reusable = true}, SHIFT(834),
  [1608] = {.count = 1, .reusable = true}, SHIFT(835),
  [1610] = {.count = 1, .reusable = false}, SHIFT(836),
  [1612] = {.count = 1, .reusable = false}, SHIFT(837),
  [1614] = {.count = 1, .reusable = true}, REDUCE(sym_expression_statement, 1),
  [1616] = {.count = 1, .reusable = false}, REDUCE(sym_expression_statement, 1),
  [1618] = {.count = 1, .reusable = false}, SHIFT(838),
  [1620] = {.count = 1, .reusable = true}, SHIFT(840),
  [1622] = {.count = 1, .reusable = true}, REDUCE(sym_compound_statement, 2),
  [1624] = {.count = 1, .reusable = false}, REDUCE(sym_compound_statement, 2),
  [1626] = {.count = 1, .reusable = true}, SHIFT(842),
  [1628] = {.count = 1, .reusable = true}, SHIFT(843),
  [1630] = {.count = 1, .reusable = true}, SHIFT(844),
  [1632] = {.count = 1, .reusable = true}, SHIFT(854),
  [1634] = {.count = 1, .reusable = true}, SHIFT(845),
  [1636] = {.count = 1, .reusable = true}, SHIFT(846),
  [1638] = {.count = 1, .reusable = true}, SHIFT(847),
  [1640] = {.count = 1, .reusable = true}, SHIFT(848),
  [1642] = {.count = 1, .reusable = false}, SHIFT(849),
  [1644] = {.count = 1, .reusable = true}, SHIFT(849),
  [1646] = {.count = 1, .reusable = false}, SHIFT(850),
  [1648] = {.count = 1, .reusable = true}, SHIFT(851),
  [1650] = {.count = 1, .reusable = false}, SHIFT(854),
  [1652] = {.count = 1, .reusable = true}, SHIFT(852),
  [1654] = {.count = 1, .reusable = false}, SHIFT(853),
  [1656] = {.count = 1, .reusable = true}, SHIFT(856),
  [1658] = {.count = 1, .reusable = true}, SHIFT(857),
  [1660] = {.count = 1, .reusable = true}, SHIFT(873),
  [1662] = {.count = 1, .reusable = true}, SHIFT(858),
  [1664] = {.count = 1, .reusable = true}, SHIFT(859),
  [1666] = {.count = 1, .reusable = false}, SHIFT(860),
  [1668] = {.count = 1, .reusable = false}, SHIFT(861),
  [1670] = {.count = 1, .reusable = false}, SHIFT(862),
  [1672] = {.count = 1, .reusable = false}, SHIFT(863),
  [1674] = {.count = 1, .reusable = false}, SHIFT(864),
  [1676] = {.count = 1, .reusable = false}, SHIFT(865),
  [1678] = {.count = 1, .reusable = false}, SHIFT(866),
  [1680] = {.count = 1, .reusable = false}, SHIFT(867),
  [1682] = {.count = 1, .reusable = false}, SHIFT(868),
  [1684] = {.count = 1, .reusable = false}, SHIFT(869),
  [1686] = {.count = 1, .reusable = false}, SHIFT(870),
  [1688] = {.count = 1, .reusable = false}, SHIFT(873),
  [1690] = {.count = 1, .reusable = false}, SHIFT(871),
  [1692] = {.count = 1, .reusable = true}, SHIFT(875),
  [1694] = {.count = 1, .reusable = true}, SHIFT(877),
  [1696] = {.count = 1, .reusable = true}, SHIFT(876),
  [1698] = {.count = 1, .reusable = false}, SHIFT(877),
  [1700] = {.count = 1, .reusable = true}, SHIFT(879),
  [1702] = {.count = 1, .reusable = true}, SHIFT(880),
  [1704] = {.count = 1, .reusable = true}, SHIFT(881),
  [1706] = {.count = 1, .reusable = true}, SHIFT(883),
  [1708] = {.count = 1, .reusable = true}, SHIFT(882),
  [1710] = {.count = 1, .reusable = false}, SHIFT(883),
  [1712] = {.count = 1, .reusable = true}, SHIFT(884),
  [1714] = {.count = 1, .reusable = false}, SHIFT(885),
  [1716] = {.count = 1, .reusable = true}, SHIFT(886),
  [1718] = {.count = 1, .reusable = false}, SHIFT(888),
  [1720] = {.count = 1, .reusable = false}, SHIFT(889),
  [1722] = {.count = 1, .reusable = true}, SHIFT(891),
  [1724] = {.count = 1, .reusable = true}, SHIFT(890),
  [1726] = {.count = 1, .reusable = false}, SHIFT(891),
  [1728] = {.count = 1, .reusable = true}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 1, .alias_sequence_id = 14),
  [1730] = {.count = 1, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 1, .alias_sequence_id = 14),
  [1732] = {.count = 1, .reusable = true}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 1, .alias_sequence_id = 15),
  [1734] = {.count = 1, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 1, .alias_sequence_id = 15),
  [1736] = {.count = 1, .reusable = true}, SHIFT(892),
  [1738] = {.count = 1, .reusable = true}, SHIFT(893),
  [1740] = {.count = 1, .reusable = true}, SHIFT(897),
  [1742] = {.count = 1, .reusable = true}, SHIFT(898),
  [1744] = {.count = 1, .reusable = false}, SHIFT(899),
  [1746] = {.count = 1, .reusable = false}, SHIFT(900),
  [1748] = {.count = 1, .reusable = true}, SHIFT(901),
  [1750] = {.count = 1, .reusable = true}, SHIFT(900),
  [1752] = {.count = 1, .reusable = false}, SHIFT(902),
  [1754] = {.count = 1, .reusable = true}, SHIFT(903),
  [1756] = {.count = 1, .reusable = true}, SHIFT(904),
  [1758] = {.count = 1, .reusable = false}, SHIFT(905),
  [1760] = {.count = 1, .reusable = false}, SHIFT(906),
  [1762] = {.count = 1, .reusable = true}, SHIFT(907),
  [1764] = {.count = 1, .reusable = false}, SHIFT(908),
  [1766] = {.count = 1, .reusable = true}, SHIFT(908),
  [1768] = {.count = 1, .reusable = false}, SHIFT(909),
  [1770] = {.count = 1, .reusable = false}, SHIFT(910),
  [1772] = {.count = 1, .reusable = true}, SHIFT(911),
  [1774] = {.count = 1, .reusable = true}, SHIFT(912),
  [1776] = {.count = 1, .reusable = true}, SHIFT(914),
  [1778] = {.count = 1, .reusable = false}, SHIFT(916),
  [1780] = {.count = 1, .reusable = true}, SHIFT(917),
  [1782] = {.count = 1, .reusable = true}, SHIFT(918),
  [1784] = {.count = 1, .reusable = true}, REDUCE(sym_field_initializer_list, 2),
  [1786] = {.count = 1, .reusable = true}, SHIFT(920),
  [1788] = {.count = 1, .reusable = true}, REDUCE(sym_constructor_or_destructor_definition, 3),
  [1790] = {.count = 1, .reusable = false}, REDUCE(sym_constructor_or_destructor_definition, 3),
  [1792] = {.count = 2, .reusable = false}, REDUCE(aux_sym__declaration_specifiers_repeat1, 2), SHIFT_REPEAT(136),
  [1795] = {.count = 2, .reusable = false}, REDUCE(aux_sym__declaration_specifiers_repeat1, 2), SHIFT_REPEAT(137),
  [1798] = {.count = 2, .reusable = true}, REDUCE(sym_scoped_identifier, 3), REDUCE(sym_scoped_type_identifier, 3, .alias_sequence_id = 20),
  [1801] = {.count = 1, .reusable = true}, REDUCE(sym_scoped_type_identifier, 3, .alias_sequence_id = 20),
  [1803] = {.count = 1, .reusable = false}, REDUCE(sym_scoped_type_identifier, 3, .alias_sequence_id = 20),
  [1805] = {.count = 1, .reusable = true}, REDUCE(sym_scoped_namespace_identifier, 3, .alias_sequence_id = 21),
  [1807] = {.count = 1, .reusable = true}, REDUCE(sym_scoped_identifier, 3),
  [1809] = {.count = 1, .reusable = false}, REDUCE(sym_scoped_identifier, 3),
  [1811] = {.count = 1, .reusable = true}, REDUCE(sym__declaration_specifiers, 3),
  [1813] = {.count = 1, .reusable = false}, REDUCE(sym__declaration_specifiers, 3),
  [1815] = {.count = 1, .reusable = true}, SHIFT(923),
  [1817] = {.count = 1, .reusable = true}, SHIFT(924),
  [1819] = {.count = 1, .reusable = true}, SHIFT(925),
  [1821] = {.count = 1, .reusable = false}, REDUCE(sym_preproc_params, 2),
  [1823] = {.count = 1, .reusable = true}, REDUCE(sym_preproc_function_def, 4, .alias_sequence_id = 6),
  [1825] = {.count = 1, .reusable = false}, REDUCE(sym_preproc_function_def, 4, .alias_sequence_id = 6),
  [1827] = {.count = 1, .reusable = true}, SHIFT(927),
  [1829] = {.count = 1, .reusable = false}, SHIFT(934),
  [1831] = {.count = 1, .reusable = false}, SHIFT(933),
  [1833] = {.count = 1, .reusable = false}, SHIFT(928),
  [1835] = {.count = 1, .reusable = false}, SHIFT(929),
  [1837] = {.count = 1, .reusable = false}, SHIFT(930),
  [1839] = {.count = 1, .reusable = false}, SHIFT(931),
  [1841] = {.count = 1, .reusable = false}, SHIFT(932),
  [1843] = {.count = 1, .reusable = true}, SHIFT(935),
  [1845] = {.count = 1, .reusable = false}, SHIFT(936),
  [1847] = {.count = 1, .reusable = false}, SHIFT(937),
  [1849] = {.count = 1, .reusable = false}, SHIFT(939),
  [1851] = {.count = 1, .reusable = false}, SHIFT(942),
  [1853] = {.count = 1, .reusable = false}, SHIFT(945),
  [1855] = {.count = 1, .reusable = true}, SHIFT(948),
  [1857] = {.count = 1, .reusable = true}, SHIFT(949),
  [1859] = {.count = 1, .reusable = false}, SHIFT(950),
  [1861] = {.count = 1, .reusable = true}, SHIFT(951),
  [1863] = {.count = 1, .reusable = true}, SHIFT(952),
  [1865] = {.count = 1, .reusable = false}, SHIFT(953),
  [1867] = {.count = 1, .reusable = false}, SHIFT(954),
  [1869] = {.count = 1, .reusable = false}, SHIFT(955),
  [1871] = {.count = 1, .reusable = true}, SHIFT(957),
  [1873] = {.count = 1, .reusable = true}, SHIFT(959),
  [1875] = {.count = 1, .reusable = true}, SHIFT(961),
  [1877] = {.count = 1, .reusable = true}, SHIFT(962),
  [1879] = {.count = 1, .reusable = false}, SHIFT(964),
  [1881] = {.count = 1, .reusable = false}, SHIFT(965),
  [1883] = {.count = 1, .reusable = true}, SHIFT(967),
  [1885] = {.count = 1, .reusable = true}, SHIFT(968),
  [1887] = {.count = 1, .reusable = true}, SHIFT(972),
  [1889] = {.count = 1, .reusable = false}, REDUCE(sym_preproc_else, 2, .alias_sequence_id = 8),
  [1891] = {.count = 1, .reusable = false}, REDUCE(sym_preproc_elif, 2, .alias_sequence_id = 22),
  [1893] = {.count = 1, .reusable = false}, SHIFT(979),
  [1895] = {.count = 1, .reusable = false}, SHIFT(981),
  [1897] = {.count = 1, .reusable = true}, SHIFT(984),
  [1899] = {.count = 1, .reusable = true}, SHIFT(985),
  [1901] = {.count = 1, .reusable = true}, SHIFT(988),
  [1903] = {.count = 1, .reusable = true}, SHIFT(991),
  [1905] = {.count = 1, .reusable = true}, SHIFT(992),
  [1907] = {.count = 1, .reusable = true}, SHIFT(993),
  [1909] = {.count = 1, .reusable = true}, REDUCE(sym_preproc_if, 4, .alias_sequence_id = 23),
  [1911] = {.count = 1, .reusable = false}, REDUCE(sym_preproc_if, 4, .alias_sequence_id = 23),
  [1913] = {.count = 1, .reusable = true}, SHIFT(995),
  [1915] = {.count = 1, .reusable = true}, SHIFT(996),
  [1917] = {.count = 1, .reusable = true}, SHIFT(999),
  [1919] = {.count = 1, .reusable = true}, SHIFT(1001),
  [1921] = {.count = 1, .reusable = true}, SHIFT(1003),
  [1923] = {.count = 1, .reusable = true}, SHIFT(1006),
  [1925] = {.count = 2, .reusable = false}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(161),
  [1928] = {.count = 2, .reusable = false}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(162),
  [1931] = {.count = 2, .reusable = false}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(163),
  [1934] = {.count = 1, .reusable = false}, REDUCE(aux_sym_translation_unit_repeat1, 2),
  [1936] = {.count = 2, .reusable = false}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(165),
  [1939] = {.count = 2, .reusable = false}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(166),
  [1942] = {.count = 2, .reusable = false}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(169),
  [1945] = {.count = 2, .reusable = false}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(170),
  [1948] = {.count = 2, .reusable = false}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(171),
  [1951] = {.count = 2, .reusable = false}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(172),
  [1954] = {.count = 2, .reusable = false}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(173),
  [1957] = {.count = 2, .reusable = false}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(174),
  [1960] = {.count = 1, .reusable = true}, REDUCE(sym_preproc_ifdef, 4, .alias_sequence_id = 24),
  [1962] = {.count = 1, .reusable = false}, REDUCE(sym_preproc_ifdef, 4, .alias_sequence_id = 24),
  [1964] = {.count = 1, .reusable = true}, SHIFT(1008),
  [1966] = {.count = 1, .reusable = true}, REDUCE(sym_preproc_ifdef, 4, .alias_sequence_id = 25),
  [1968] = {.count = 1, .reusable = false}, REDUCE(sym_preproc_ifdef, 4, .alias_sequence_id = 25),
  [1970] = {.count = 1, .reusable = true}, SHIFT(1009),
  [1972] = {.count = 1, .reusable = true}, REDUCE(sym_preproc_call, 4),
  [1974] = {.count = 1, .reusable = false}, REDUCE(sym_preproc_call, 4),
  [1976] = {.count = 1, .reusable = true}, SHIFT(1010),
  [1978] = {.count = 1, .reusable = true}, SHIFT(1011),
  [1980] = {.count = 1, .reusable = true}, SHIFT(1013),
  [1982] = {.count = 1, .reusable = true}, SHIFT(1016),
  [1984] = {.count = 1, .reusable = true}, SHIFT(1019),
  [1986] = {.count = 1, .reusable = true}, REDUCE(sym_pointer_type_declarator, 2),
  [1988] = {.count = 1, .reusable = true}, REDUCE(sym_type_definition, 4),
  [1990] = {.count = 1, .reusable = false}, REDUCE(sym_type_definition, 4),
  [1992] = {.count = 1, .reusable = true}, SHIFT(1022),
  [1994] = {.count = 1, .reusable = true}, SHIFT(1020),
  [1996] = {.count = 1, .reusable = false}, SHIFT(1022),
  [1998] = {.count = 1, .reusable = true}, REDUCE(sym_function_type_declarator, 2),
  [2000] = {.count = 1, .reusable = true}, SHIFT(1023),
  [2002] = {.count = 1, .reusable = false}, SHIFT(1026),
  [2004] = {.count = 1, .reusable = false}, SHIFT(1025),
  [2006] = {.count = 1, .reusable = false}, SHIFT(1024),
  [2008] = {.count = 1, .reusable = true}, SHIFT(1027),
  [2010] = {.count = 1, .reusable = true}, REDUCE(sym_enumerator_list, 3),
  [2012] = {.count = 1, .reusable = false}, REDUCE(sym_enumerator_list, 3),
  [2014] = {.count = 1, .reusable = true}, SHIFT(1028),
  [2016] = {.count = 1, .reusable = false}, SHIFT(1028),
  [2018] = {.count = 1, .reusable = true}, SHIFT(1029),
  [2020] = {.count = 1, .reusable = true}, SHIFT(1031),
  [2022] = {.count = 1, .reusable = true}, SHIFT(1033),
  [2024] = {.count = 1, .reusable = true}, SHIFT(1034),
  [2026] = {.count = 1, .reusable = true}, SHIFT(1035),
  [2028] = {.count = 1, .reusable = true}, SHIFT(1039),
  [2030] = {.count = 1, .reusable = true}, SHIFT(1043),
  [2032] = {.count = 1, .reusable = false}, SHIFT(1048),
  [2034] = {.count = 1, .reusable = false}, SHIFT(1049),
  [2036] = {.count = 1, .reusable = true}, REDUCE(sym_access_specifier, 2),
  [2038] = {.count = 1, .reusable = false}, REDUCE(sym_access_specifier, 2),
  [2040] = {.count = 1, .reusable = true}, REDUCE(sym_friend_declaration, 2),
  [2042] = {.count = 1, .reusable = false}, REDUCE(sym_friend_declaration, 2),
  [2044] = {.count = 1, .reusable = true}, SHIFT(1052),
  [2046] = {.count = 1, .reusable = true}, SHIFT(1054),
  [2048] = {.count = 1, .reusable = true}, SHIFT(1055),
  [2050] = {.count = 1, .reusable = true}, SHIFT(1056),
  [2052] = {.count = 1, .reusable = true}, SHIFT(1057),
  [2054] = {.count = 1, .reusable = true}, SHIFT(1059),
  [2056] = {.count = 1, .reusable = false}, SHIFT(1060),
  [2058] = {.count = 1, .reusable = true}, SHIFT(1060),
  [2060] = {.count = 1, .reusable = true}, SHIFT(1061),
  [2062] = {.count = 1, .reusable = true}, REDUCE(sym_field_declaration, 2),
  [2064] = {.count = 1, .reusable = false}, REDUCE(sym_field_declaration, 2),
  [2066] = {.count = 1, .reusable = true}, SHIFT(1063),
  [2068] = {.count = 1, .reusable = true}, SHIFT(1064),
  [2070] = {.count = 1, .reusable = false}, SHIFT(1064),
  [2072] = {.count = 1, .reusable = true}, SHIFT(1065),
  [2074] = {.count = 1, .reusable = true}, REDUCE(sym__field_declarator, 1, .alias_sequence_id = 26),
  [2076] = {.count = 1, .reusable = false}, REDUCE(sym__field_declarator, 1, .alias_sequence_id = 26),
  [2078] = {.count = 1, .reusable = true}, SHIFT(1066),
  [2080] = {.count = 1, .reusable = false}, SHIFT(1068),
  [2082] = {.count = 1, .reusable = true}, SHIFT(1069),
  [2084] = {.count = 1, .reusable = true}, SHIFT(1070),
  [2086] = {.count = 1, .reusable = true}, SHIFT(1071),
  [2088] = {.count = 1, .reusable = true}, SHIFT(1072),
  [2090] = {.count = 1, .reusable = true}, REDUCE(sym__field_declarator, 1, .alias_sequence_id = 11),
  [2092] = {.count = 1, .reusable = true}, REDUCE(sym__field_declarator, 1, .alias_sequence_id = 12),
  [2094] = {.count = 1, .reusable = true}, REDUCE(sym__field_declarator, 1, .alias_sequence_id = 13),
  [2096] = {.count = 1, .reusable = true}, REDUCE(sym__field_declarator, 1, .alias_sequence_id = 27),
  [2098] = {.count = 1, .reusable = true}, SHIFT(1076),
  [2100] = {.count = 1, .reusable = true}, SHIFT(1077),
  [2102] = {.count = 1, .reusable = true}, SHIFT(1079),
  [2104] = {.count = 1, .reusable = true}, SHIFT(1080),
  [2106] = {.count = 1, .reusable = true}, REDUCE(sym_constructor_or_destructor_declaration, 2),
  [2108] = {.count = 1, .reusable = false}, REDUCE(sym_constructor_or_destructor_declaration, 2),
  [2110] = {.count = 1, .reusable = true}, SHIFT(1081),
  [2112] = {.count = 1, .reusable = false}, SHIFT(1085),
  [2114] = {.count = 1, .reusable = true}, REDUCE(sym_field_declaration_list, 3),
  [2116] = {.count = 1, .reusable = false}, REDUCE(sym_field_declaration_list, 3),
  [2118] = {.count = 2, .reusable = true}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2), SHIFT_REPEAT(4),
  [2121] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2), SHIFT_REPEAT(231),
  [2124] = {.count = 2, .reusable = true}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2), SHIFT_REPEAT(232),
  [2127] = {.count = 2, .reusable = true}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2), SHIFT_REPEAT(233),
  [2130] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2), SHIFT_REPEAT(234),
  [2133] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2), SHIFT_REPEAT(12),
  [2136] = {.count = 1, .reusable = true}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2),
  [2138] = {.count = 2, .reusable = true}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2), SHIFT_REPEAT(11),
  [2141] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2), SHIFT_REPEAT(13),
  [2144] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2), SHIFT_REPEAT(258),
  [2147] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2), SHIFT_REPEAT(251),
  [2150] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2), SHIFT_REPEAT(14),
  [2153] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2), SHIFT_REPEAT(236),
  [2156] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2), SHIFT_REPEAT(237),
  [2159] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2), SHIFT_REPEAT(17),
  [2162] = {.count = 2, .reusable = true}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2), SHIFT_REPEAT(17),
  [2165] = {.count = 2, .reusable = true}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2), SHIFT_REPEAT(18),
  [2168] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2), SHIFT_REPEAT(238),
  [2171] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2), SHIFT_REPEAT(239),
  [2174] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2), SHIFT_REPEAT(240),
  [2177] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2), SHIFT_REPEAT(241),
  [2180] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2), SHIFT_REPEAT(242),
  [2183] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2), SHIFT_REPEAT(243),
  [2186] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2), SHIFT_REPEAT(244),
  [2189] = {.count = 2, .reusable = true}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2), SHIFT_REPEAT(245),
  [2192] = {.count = 2, .reusable = true}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2), SHIFT_REPEAT(249),
  [2195] = {.count = 2, .reusable = false}, REDUCE(aux_sym_sized_type_specifier_repeat1, 2), SHIFT_REPEAT(566),
  [2198] = {.count = 1, .reusable = true}, REDUCE(sym_base_class_clause, 3),
  [2200] = {.count = 1, .reusable = false}, SHIFT(1089),
  [2202] = {.count = 1, .reusable = true}, REDUCE(sym_struct_specifier, 4),
  [2204] = {.count = 1, .reusable = false}, REDUCE(sym_struct_specifier, 4),
  [2206] = {.count = 1, .reusable = true}, REDUCE(sym_union_specifier, 4),
  [2208] = {.count = 1, .reusable = false}, REDUCE(sym_union_specifier, 4),
  [2210] = {.count = 1, .reusable = true}, SHIFT(1094),
  [2212] = {.count = 1, .reusable = true}, SHIFT(1093),
  [2214] = {.count = 1, .reusable = false}, SHIFT(1094),
  [2216] = {.count = 1, .reusable = true}, SHIFT(1095),
  [2218] = {.count = 1, .reusable = true}, SHIFT(1096),
  [2220] = {.count = 1, .reusable = false}, SHIFT(1098),
  [2222] = {.count = 1, .reusable = false}, SHIFT(1099),
  [2224] = {.count = 1, .reusable = true}, SHIFT(1101),
  [2226] = {.count = 1, .reusable = true}, SHIFT(1100),
  [2228] = {.count = 1, .reusable = false}, SHIFT(1101),
  [2230] = {.count = 1, .reusable = true}, SHIFT(1102),
  [2232] = {.count = 1, .reusable = true}, SHIFT(1103),
  [2234] = {.count = 1, .reusable = false}, SHIFT(1104),
  [2236] = {.count = 1, .reusable = false}, SHIFT(1105),
  [2238] = {.count = 1, .reusable = true}, SHIFT(1106),
  [2240] = {.count = 1, .reusable = true}, SHIFT(1105),
  [2242] = {.count = 1, .reusable = false}, SHIFT(1107),
  [2244] = {.count = 1, .reusable = true}, SHIFT(1108),
  [2246] = {.count = 1, .reusable = true}, SHIFT(1109),
  [2248] = {.count = 1, .reusable = false}, SHIFT(1110),
  [2250] = {.count = 1, .reusable = false}, SHIFT(1111),
  [2252] = {.count = 1, .reusable = true}, SHIFT(1112),
  [2254] = {.count = 1, .reusable = false}, SHIFT(1113),
  [2256] = {.count = 1, .reusable = true}, SHIFT(1113),
  [2258] = {.count = 1, .reusable = false}, SHIFT(1114),
  [2260] = {.count = 1, .reusable = false}, SHIFT(1115),
  [2262] = {.count = 1, .reusable = true}, SHIFT(1116),
  [2264] = {.count = 1, .reusable = true}, SHIFT(1117),
  [2266] = {.count = 1, .reusable = false}, SHIFT(1118),
  [2268] = {.count = 1, .reusable = true}, SHIFT(1118),
  [2270] = {.count = 1, .reusable = true}, REDUCE(sym_abstract_pointer_declarator, 1),
  [2272] = {.count = 1, .reusable = true}, SHIFT(1124),
  [2274] = {.count = 1, .reusable = true}, SHIFT(1122),
  [2276] = {.count = 1, .reusable = false}, SHIFT(1124),
  [2278] = {.count = 1, .reusable = true}, REDUCE(sym_abstract_reference_declarator, 1),
  [2280] = {.count = 1, .reusable = true}, REDUCE(sym_type_descriptor, 2),
  [2282] = {.count = 1, .reusable = true}, SHIFT(1126),
  [2284] = {.count = 1, .reusable = true}, REDUCE(sym_abstract_function_declarator, 1),
  [2286] = {.count = 1, .reusable = true}, SHIFT(1128),
  [2288] = {.count = 1, .reusable = true}, SHIFT(1130),
  [2290] = {.count = 1, .reusable = true}, REDUCE(sym_template_argument_list, 3),
  [2292] = {.count = 1, .reusable = false}, REDUCE(sym_template_argument_list, 3),
  [2294] = {.count = 1, .reusable = true}, SHIFT(1132),
  [2296] = {.count = 2, .reusable = false}, REDUCE(aux_sym_sized_type_specifier_repeat1, 2), SHIFT_REPEAT(603),
  [2299] = {.count = 1, .reusable = true}, REDUCE(sym_class_specifier, 4),
  [2301] = {.count = 1, .reusable = false}, REDUCE(sym_class_specifier, 4),
  [2303] = {.count = 1, .reusable = true}, REDUCE(sym_type_parameter_declaration, 2, .alias_sequence_id = 4),
  [2305] = {.count = 1, .reusable = true}, SHIFT(1135),
  [2307] = {.count = 1, .reusable = true}, SHIFT(1136),
  [2309] = {.count = 1, .reusable = false}, SHIFT(1137),
  [2311] = {.count = 1, .reusable = true}, SHIFT(1137),
  [2313] = {.count = 1, .reusable = true}, SHIFT(1138),
  [2315] = {.count = 1, .reusable = true}, SHIFT(1139),
  [2317] = {.count = 1, .reusable = true}, SHIFT(1140),
  [2319] = {.count = 1, .reusable = true}, SHIFT(1141),
  [2321] = {.count = 1, .reusable = true}, SHIFT(1142),
  [2323] = {.count = 1, .reusable = true}, REDUCE(sym_parameter_declaration, 2),
  [2325] = {.count = 1, .reusable = true}, SHIFT(1143),
  [2327] = {.count = 1, .reusable = true}, SHIFT(1144),
  [2329] = {.count = 1, .reusable = true}, SHIFT(1146),
  [2331] = {.count = 1, .reusable = false}, REDUCE(sym_template_parameter_list, 3),
  [2333] = {.count = 1, .reusable = true}, REDUCE(sym_template_parameter_list, 3),
  [2335] = {.count = 1, .reusable = true}, SHIFT(1150),
  [2337] = {.count = 2, .reusable = false}, REDUCE(aux_sym_sized_type_specifier_repeat1, 2), SHIFT_REPEAT(622),
  [2340] = {.count = 1, .reusable = true}, REDUCE(sym_template_instantiation, 4),
  [2342] = {.count = 1, .reusable = false}, REDUCE(sym_template_instantiation, 4),
  [2344] = {.count = 1, .reusable = false}, SHIFT(1155),
  [2346] = {.count = 1, .reusable = false}, SHIFT(1154),
  [2348] = {.count = 1, .reusable = false}, SHIFT(1153),
  [2350] = {.count = 1, .reusable = true}, SHIFT(1156),
  [2352] = {.count = 2, .reusable = false}, REDUCE(aux_sym_sized_type_specifier_repeat1, 2), SHIFT_REPEAT(630),
  [2355] = {.count = 1, .reusable = true}, REDUCE(sym_declaration_list, 3),
  [2357] = {.count = 1, .reusable = false}, REDUCE(sym_declaration_list, 3),
  [2359] = {.count = 1, .reusable = true}, SHIFT(1159),
  [2361] = {.count = 1, .reusable = false}, SHIFT(1160),
  [2363] = {.count = 1, .reusable = true}, SHIFT(1160),
  [2365] = {.count = 1, .reusable = true}, SHIFT(1163),
  [2367] = {.count = 1, .reusable = false}, SHIFT(1164),
  [2369] = {.count = 1, .reusable = false}, SHIFT(1165),
  [2371] = {.count = 1, .reusable = true}, REDUCE(sym_using_declaration, 4),
  [2373] = {.count = 1, .reusable = false}, REDUCE(sym_using_declaration, 4),
  [2375] = {.count = 1, .reusable = true}, SHIFT(1166),
  [2377] = {.count = 1, .reusable = true}, REDUCE(sym_structured_binding_declarator, 3),
  [2379] = {.count = 1, .reusable = true}, SHIFT(1167),
  [2381] = {.count = 2, .reusable = true}, REDUCE(sym_parameter_list, 2, .dynamic_precedence = 1), REDUCE(sym_argument_list, 2, .dynamic_precedence = 1),
  [2384] = {.count = 1, .reusable = true}, SHIFT(1169),
  [2386] = {.count = 1, .reusable = false}, SHIFT(1171),
  [2388] = {.count = 1, .reusable = true}, SHIFT(1172),
  [2390] = {.count = 1, .reusable = true}, SHIFT(1173),
  [2392] = {.count = 1, .reusable = true}, SHIFT(1175),
  [2394] = {.count = 1, .reusable = true}, REDUCE(aux_sym_declaration_repeat1, 2),
  [2396] = {.count = 1, .reusable = true}, SHIFT(1177),
  [2398] = {.count = 1, .reusable = true}, SHIFT(1178),
  [2400] = {.count = 1, .reusable = true}, REDUCE(sym_initializer_list, 2),
  [2402] = {.count = 1, .reusable = true}, SHIFT(1179),
  [2404] = {.count = 1, .reusable = true}, SHIFT(1180),
  [2406] = {.count = 1, .reusable = false}, SHIFT(1180),
  [2408] = {.count = 1, .reusable = true}, SHIFT(1182),
  [2410] = {.count = 1, .reusable = true}, SHIFT(1181),
  [2412] = {.count = 1, .reusable = false}, SHIFT(1182),
  [2414] = {.count = 1, .reusable = true}, SHIFT(1183),
  [2416] = {.count = 1, .reusable = true}, SHIFT(1184),
  [2418] = {.count = 1, .reusable = false}, SHIFT(1185),
  [2420] = {.count = 1, .reusable = true}, SHIFT(1187),
  [2422] = {.count = 1, .reusable = true}, SHIFT(1186),
  [2424] = {.count = 1, .reusable = false}, SHIFT(1187),
  [2426] = {.count = 1, .reusable = true}, SHIFT(1188),
  [2428] = {.count = 1, .reusable = false}, SHIFT(1189),
  [2430] = {.count = 1, .reusable = false}, SHIFT(1190),
  [2432] = {.count = 1, .reusable = true}, SHIFT(1191),
  [2434] = {.count = 1, .reusable = true}, SHIFT(1190),
  [2436] = {.count = 1, .reusable = false}, SHIFT(1192),
  [2438] = {.count = 1, .reusable = true}, SHIFT(1193),
  [2440] = {.count = 1, .reusable = true}, SHIFT(1194),
  [2442] = {.count = 1, .reusable = false}, SHIFT(1195),
  [2444] = {.count = 1, .reusable = false}, SHIFT(1196),
  [2446] = {.count = 1, .reusable = true}, SHIFT(1197),
  [2448] = {.count = 1, .reusable = false}, SHIFT(1198),
  [2450] = {.count = 1, .reusable = true}, SHIFT(1198),
  [2452] = {.count = 1, .reusable = false}, SHIFT(1199),
  [2454] = {.count = 1, .reusable = false}, SHIFT(1200),
  [2456] = {.count = 1, .reusable = true}, SHIFT(1202),
  [2458] = {.count = 1, .reusable = true}, SHIFT(1203),
  [2460] = {.count = 1, .reusable = true}, SHIFT(1204),
  [2462] = {.count = 1, .reusable = true}, REDUCE(sym_init_declarator, 3),
  [2464] = {.count = 1, .reusable = false}, SHIFT(1211),
  [2466] = {.count = 1, .reusable = false}, SHIFT(1210),
  [2468] = {.count = 1, .reusable = false}, SHIFT(1206),
  [2470] = {.count = 1, .reusable = false}, SHIFT(1207),
  [2472] = {.count = 1, .reusable = false}, SHIFT(1208),
  [2474] = {.count = 1, .reusable = false}, SHIFT(1209),
  [2476] = {.count = 1, .reusable = true}, SHIFT(1212),
  [2478] = {.count = 1, .reusable = true}, REDUCE(sym_declaration, 4),
  [2480] = {.count = 1, .reusable = false}, REDUCE(sym_declaration, 4),
  [2482] = {.count = 2, .reusable = true}, REDUCE(aux_sym_declaration_repeat1, 2), SHIFT_REPEAT(327),
  [2485] = {.count = 1, .reusable = true}, REDUCE(sym_argument_list, 2, .dynamic_precedence = 1),
  [2487] = {.count = 1, .reusable = false}, REDUCE(sym_argument_list, 2, .dynamic_precedence = 1),
  [2489] = {.count = 1, .reusable = false}, REDUCE(sym_initializer_list, 2),
  [2491] = {.count = 1, .reusable = true}, SHIFT(1215),
  [2493] = {.count = 1, .reusable = true}, SHIFT(1214),
  [2495] = {.count = 1, .reusable = false}, SHIFT(1215),
  [2497] = {.count = 1, .reusable = true}, SHIFT(1216),
  [2499] = {.count = 1, .reusable = false}, SHIFT(1217),
  [2501] = {.count = 1, .reusable = true}, SHIFT(1219),
  [2503] = {.count = 1, .reusable = true}, SHIFT(1218),
  [2505] = {.count = 1, .reusable = false}, SHIFT(1219),
  [2507] = {.count = 1, .reusable = false}, SHIFT(1220),
  [2509] = {.count = 1, .reusable = false}, SHIFT(1221),
  [2511] = {.count = 1, .reusable = true}, SHIFT(1222),
  [2513] = {.count = 1, .reusable = true}, SHIFT(1221),
  [2515] = {.count = 1, .reusable = false}, SHIFT(1223),
  [2517] = {.count = 1, .reusable = true}, SHIFT(1224),
  [2519] = {.count = 1, .reusable = true}, SHIFT(1225),
  [2521] = {.count = 1, .reusable = false}, SHIFT(1226),
  [2523] = {.count = 1, .reusable = false}, SHIFT(1227),
  [2525] = {.count = 1, .reusable = true}, SHIFT(1228),
  [2527] = {.count = 1, .reusable = false}, SHIFT(1229),
  [2529] = {.count = 1, .reusable = true}, SHIFT(1229),
  [2531] = {.count = 1, .reusable = false}, SHIFT(1230),
  [2533] = {.count = 1, .reusable = false}, SHIFT(1231),
  [2535] = {.count = 1, .reusable = true}, SHIFT(1234),
  [2537] = {.count = 1, .reusable = true}, SHIFT(1233),
  [2539] = {.count = 1, .reusable = false}, SHIFT(1234),
  [2541] = {.count = 1, .reusable = true}, SHIFT(1235),
  [2543] = {.count = 1, .reusable = false}, SHIFT(1236),
  [2545] = {.count = 1, .reusable = true}, SHIFT(1238),
  [2547] = {.count = 1, .reusable = true}, SHIFT(1237),
  [2549] = {.count = 1, .reusable = false}, SHIFT(1238),
  [2551] = {.count = 1, .reusable = true}, SHIFT(1239),
  [2553] = {.count = 1, .reusable = false}, SHIFT(1240),
  [2555] = {.count = 1, .reusable = false}, SHIFT(1241),
  [2557] = {.count = 1, .reusable = true}, SHIFT(1242),
  [2559] = {.count = 1, .reusable = true}, SHIFT(1241),
  [2561] = {.count = 1, .reusable = false}, SHIFT(1243),
  [2563] = {.count = 1, .reusable = true}, SHIFT(1244),
  [2565] = {.count = 1, .reusable = true}, SHIFT(1245),
  [2567] = {.count = 1, .reusable = false}, SHIFT(1246),
  [2569] = {.count = 1, .reusable = false}, SHIFT(1247),
  [2571] = {.count = 1, .reusable = true}, SHIFT(1248),
  [2573] = {.count = 1, .reusable = false}, SHIFT(1249),
  [2575] = {.count = 1, .reusable = true}, SHIFT(1249),
  [2577] = {.count = 1, .reusable = false}, SHIFT(1250),
  [2579] = {.count = 1, .reusable = false}, SHIFT(1251),
  [2581] = {.count = 1, .reusable = true}, REDUCE(sym_structured_binding_declaration, 4, .alias_sequence_id = 28),
  [2583] = {.count = 1, .reusable = false}, REDUCE(sym_structured_binding_declaration, 4, .alias_sequence_id = 28),
  [2585] = {.count = 1, .reusable = true}, SHIFT(1252),
  [2587] = {.count = 1, .reusable = true}, REDUCE(sym_structured_binding_declaration, 4),
  [2589] = {.count = 1, .reusable = false}, REDUCE(sym_structured_binding_declaration, 4),
  [2591] = {.count = 1, .reusable = true}, SHIFT(1253),
  [2593] = {.count = 1, .reusable = true}, REDUCE(sym_parameter_list, 3, .dynamic_precedence = 1),
  [2595] = {.count = 1, .reusable = false}, REDUCE(sym_parameter_list, 3, .dynamic_precedence = 1),
  [2597] = {.count = 1, .reusable = true}, SHIFT(1254),
  [2599] = {.count = 1, .reusable = true}, SHIFT(1256),
  [2601] = {.count = 1, .reusable = true}, SHIFT(1258),
  [2603] = {.count = 1, .reusable = true}, SHIFT(1260),
  [2605] = {.count = 1, .reusable = true}, SHIFT(1263),
  [2607] = {.count = 1, .reusable = true}, SHIFT(1264),
  [2609] = {.count = 2, .reusable = false}, REDUCE(aux_sym_sized_type_specifier_repeat1, 2), SHIFT_REPEAT(716),
  [2612] = {.count = 1, .reusable = true}, SHIFT(1268),
  [2614] = {.count = 1, .reusable = true}, SHIFT(1269),
  [2616] = {.count = 1, .reusable = false}, SHIFT(1270),
  [2618] = {.count = 1, .reusable = false}, SHIFT(1271),
  [2620] = {.count = 1, .reusable = true}, REDUCE(sym_pointer_expression, 2),
  [2622] = {.count = 1, .reusable = false}, REDUCE(sym_pointer_expression, 2),
  [2624] = {.count = 1, .reusable = true}, REDUCE(sym_lambda_capture_specifier, 2),
  [2626] = {.count = 1, .reusable = false}, REDUCE(sym_lambda_capture_specifier, 2),
  [2628] = {.count = 1, .reusable = true}, REDUCE(sym_lambda_default_capture, 1),
  [2630] = {.count = 1, .reusable = true}, SHIFT(1274),
  [2632] = {.count = 1, .reusable = true}, SHIFT(1273),
  [2634] = {.count = 1, .reusable = false}, SHIFT(1274),
  [2636] = {.count = 1, .reusable = true}, SHIFT(1275),
  [2638] = {.count = 1, .reusable = false}, SHIFT(1276),
  [2640] = {.count = 1, .reusable = true}, SHIFT(1278),
  [2642] = {.count = 1, .reusable = true}, SHIFT(1277),
  [2644] = {.count = 1, .reusable = false}, SHIFT(1278),
  [2646] = {.count = 1, .reusable = true}, SHIFT(1279),
  [2648] = {.count = 1, .reusable = false}, SHIFT(1280),
  [2650] = {.count = 1, .reusable = true}, SHIFT(1281),
  [2652] = {.count = 1, .reusable = false}, SHIFT(1282),
  [2654] = {.count = 1, .reusable = true}, SHIFT(1283),
  [2656] = {.count = 1, .reusable = true}, SHIFT(1282),
  [2658] = {.count = 1, .reusable = false}, SHIFT(1284),
  [2660] = {.count = 1, .reusable = true}, SHIFT(1285),
  [2662] = {.count = 1, .reusable = true}, SHIFT(1286),
  [2664] = {.count = 1, .reusable = false}, SHIFT(1287),
  [2666] = {.count = 1, .reusable = false}, SHIFT(1288),
  [2668] = {.count = 1, .reusable = true}, SHIFT(1289),
  [2670] = {.count = 1, .reusable = false}, SHIFT(1290),
  [2672] = {.count = 1, .reusable = true}, SHIFT(1290),
  [2674] = {.count = 1, .reusable = false}, SHIFT(1291),
  [2676] = {.count = 1, .reusable = false}, SHIFT(1292),
  [2678] = {.count = 1, .reusable = true}, SHIFT(1294),
  [2680] = {.count = 1, .reusable = true}, SHIFT(1295),
  [2682] = {.count = 1, .reusable = true}, SHIFT(1298),
  [2684] = {.count = 1, .reusable = true}, SHIFT(1300),
  [2686] = {.count = 1, .reusable = true}, SHIFT(1302),
  [2688] = {.count = 1, .reusable = true}, SHIFT(1305),
  [2690] = {.count = 1, .reusable = true}, REDUCE(sym_logical_expression, 2),
  [2692] = {.count = 1, .reusable = false}, REDUCE(sym_logical_expression, 2),
  [2694] = {.count = 1, .reusable = true}, REDUCE(sym_bitwise_expression, 2),
  [2696] = {.count = 1, .reusable = false}, REDUCE(sym_bitwise_expression, 2),
  [2698] = {.count = 1, .reusable = true}, REDUCE(sym_math_expression, 2),
  [2700] = {.count = 1, .reusable = false}, REDUCE(sym_math_expression, 2),
  [2702] = {.count = 1, .reusable = true}, REDUCE(sym_sizeof_expression, 2),
  [2704] = {.count = 1, .reusable = false}, REDUCE(sym_sizeof_expression, 2),
  [2706] = {.count = 1, .reusable = true}, REDUCE(sym_concatenated_string, 2),
  [2708] = {.count = 1, .reusable = false}, REDUCE(sym_concatenated_string, 2),
  [2710] = {.count = 1, .reusable = true}, SHIFT(1309),
  [2712] = {.count = 1, .reusable = true}, SHIFT(1310),
  [2714] = {.count = 1, .reusable = false}, SHIFT(1312),
  [2716] = {.count = 1, .reusable = true}, REDUCE(sym_compound_literal_expression, 2, .alias_sequence_id = 1),
  [2718] = {.count = 1, .reusable = false}, REDUCE(sym_compound_literal_expression, 2, .alias_sequence_id = 1),
  [2720] = {.count = 2, .reusable = false}, REDUCE(sym_template_type, 2, .alias_sequence_id = 1), REDUCE(sym_template_function, 2),
  [2723] = {.count = 1, .reusable = true}, SHIFT(1315),
  [2725] = {.count = 1, .reusable = true}, SHIFT(1318),
  [2727] = {.count = 1, .reusable = true}, SHIFT(1322),
  [2729] = {.count = 2, .reusable = false}, REDUCE(sym_scoped_identifier, 2), REDUCE(sym_scoped_type_identifier, 2, .alias_sequence_id = 4),
  [2732] = {.count = 1, .reusable = true}, SHIFT(1324),
  [2734] = {.count = 1, .reusable = true}, SHIFT(1323),
  [2736] = {.count = 1, .reusable = false}, SHIFT(1324),
  [2738] = {.count = 1, .reusable = true}, SHIFT(1325),
  [2740] = {.count = 1, .reusable = true}, REDUCE(sym_delete_expression, 2),
  [2742] = {.count = 1, .reusable = false}, REDUCE(sym_delete_expression, 2),
  [2744] = {.count = 1, .reusable = true}, REDUCE(sym_array_declarator, 4),
  [2746] = {.count = 1, .reusable = true}, SHIFT(1326),
  [2748] = {.count = 1, .reusable = true}, SHIFT(1328),
  [2750] = {.count = 1, .reusable = false}, SHIFT(1328),
  [2752] = {.count = 1, .reusable = true}, SHIFT(1329),
  [2754] = {.count = 1, .reusable = false}, SHIFT(1329),
  [2756] = {.count = 1, .reusable = true}, SHIFT(1330),
  [2758] = {.count = 1, .reusable = false}, SHIFT(1330),
  [2760] = {.count = 1, .reusable = true}, SHIFT(1331),
  [2762] = {.count = 1, .reusable = false}, SHIFT(1331),
  [2764] = {.count = 1, .reusable = true}, SHIFT(1332),
  [2766] = {.count = 1, .reusable = false}, SHIFT(1332),
  [2768] = {.count = 1, .reusable = true}, SHIFT(1333),
  [2770] = {.count = 1, .reusable = false}, SHIFT(1333),
  [2772] = {.count = 1, .reusable = true}, SHIFT(1334),
  [2774] = {.count = 1, .reusable = false}, SHIFT(1334),
  [2776] = {.count = 1, .reusable = true}, SHIFT(1335),
  [2778] = {.count = 1, .reusable = false}, SHIFT(1335),
  [2780] = {.count = 1, .reusable = true}, SHIFT(1336),
  [2782] = {.count = 1, .reusable = false}, SHIFT(1336),
  [2784] = {.count = 1, .reusable = true}, SHIFT(1337),
  [2786] = {.count = 1, .reusable = false}, SHIFT(1337),
  [2788] = {.count = 1, .reusable = true}, SHIFT(1338),
  [2790] = {.count = 1, .reusable = false}, SHIFT(1338),
  [2792] = {.count = 1, .reusable = true}, SHIFT(1339),
  [2794] = {.count = 1, .reusable = false}, SHIFT(1339),
  [2796] = {.count = 1, .reusable = true}, SHIFT(1340),
  [2798] = {.count = 1, .reusable = false}, SHIFT(1340),
  [2800] = {.count = 1, .reusable = true}, SHIFT(1341),
  [2802] = {.count = 1, .reusable = true}, REDUCE(sym_call_expression, 2),
  [2804] = {.count = 1, .reusable = false}, REDUCE(sym_call_expression, 2),
  [2806] = {.count = 1, .reusable = false}, SHIFT(1344),
  [2808] = {.count = 1, .reusable = true}, REDUCE(sym_compound_literal_expression, 2),
  [2810] = {.count = 1, .reusable = false}, REDUCE(sym_compound_literal_expression, 2),
  [2812] = {.count = 1, .reusable = true}, REDUCE(sym__abstract_declarator, 1),
  [2814] = {.count = 1, .reusable = true}, SHIFT(1349),
  [2816] = {.count = 1, .reusable = true}, SHIFT(1350),
  [2818] = {.count = 1, .reusable = true}, SHIFT(1351),
  [2820] = {.count = 1, .reusable = true}, SHIFT(1353),
  [2822] = {.count = 2, .reusable = false}, REDUCE(aux_sym_sized_type_specifier_repeat1, 2), SHIFT_REPEAT(816),
  [2825] = {.count = 1, .reusable = true}, SHIFT(1356),
  [2827] = {.count = 1, .reusable = true}, SHIFT(1357),
  [2829] = {.count = 1, .reusable = true}, SHIFT(1359),
  [2831] = {.count = 1, .reusable = true}, SHIFT(1360),
  [2833] = {.count = 1, .reusable = true}, SHIFT(1369),
  [2835] = {.count = 1, .reusable = true}, SHIFT(1370),
  [2837] = {.count = 1, .reusable = false}, SHIFT(1375),
  [2839] = {.count = 1, .reusable = true}, SHIFT(1376),
  [2841] = {.count = 1, .reusable = true}, REDUCE(sym_trailing_return_type, 2),
  [2843] = {.count = 1, .reusable = true}, SHIFT(1377),
  [2845] = {.count = 1, .reusable = false}, REDUCE(sym_trailing_return_type, 2),
  [2847] = {.count = 1, .reusable = false}, SHIFT(1378),
  [2849] = {.count = 1, .reusable = true}, SHIFT(1378),
  [2851] = {.count = 1, .reusable = true}, SHIFT(1381),
  [2853] = {.count = 1, .reusable = false}, SHIFT(1385),
  [2855] = {.count = 1, .reusable = false}, SHIFT(1383),
  [2857] = {.count = 1, .reusable = false}, SHIFT(1384),
  [2859] = {.count = 1, .reusable = true}, REDUCE(aux_sym_function_declarator_repeat1, 2),
  [2861] = {.count = 2, .reusable = false}, REDUCE(aux_sym_function_declarator_repeat1, 2), SHIFT_REPEAT(376),
  [2864] = {.count = 2, .reusable = true}, REDUCE(aux_sym_function_declarator_repeat1, 2), SHIFT_REPEAT(376),
  [2867] = {.count = 2, .reusable = true}, REDUCE(aux_sym_function_declarator_repeat1, 2), SHIFT_REPEAT(377),
  [2870] = {.count = 2, .reusable = true}, REDUCE(aux_sym_function_declarator_repeat1, 2), SHIFT_REPEAT(829),
  [2873] = {.count = 1, .reusable = false}, SHIFT(1386),
  [2875] = {.count = 1, .reusable = false}, SHIFT(1387),
  [2877] = {.count = 1, .reusable = true}, SHIFT(1389),
  [2879] = {.count = 1, .reusable = true}, SHIFT(1419),
  [2881] = {.count = 1, .reusable = false}, SHIFT(1390),
  [2883] = {.count = 1, .reusable = false}, SHIFT(1391),
  [2885] = {.count = 1, .reusable = false}, SHIFT(1392),
  [2887] = {.count = 1, .reusable = false}, SHIFT(1393),
  [2889] = {.count = 1, .reusable = false}, SHIFT(1394),
  [2891] = {.count = 1, .reusable = false}, SHIFT(1395),
  [2893] = {.count = 1, .reusable = false}, SHIFT(1396),
  [2895] = {.count = 1, .reusable = false}, SHIFT(1397),
  [2897] = {.count = 1, .reusable = false}, SHIFT(1398),
  [2899] = {.count = 1, .reusable = true}, SHIFT(1399),
  [2901] = {.count = 1, .reusable = false}, SHIFT(1400),
  [2903] = {.count = 1, .reusable = true}, SHIFT(1401),
  [2905] = {.count = 1, .reusable = false}, SHIFT(1402),
  [2907] = {.count = 1, .reusable = false}, SHIFT(1403),
  [2909] = {.count = 1, .reusable = false}, SHIFT(1404),
  [2911] = {.count = 1, .reusable = false}, SHIFT(1405),
  [2913] = {.count = 1, .reusable = false}, SHIFT(1406),
  [2915] = {.count = 1, .reusable = false}, SHIFT(1407),
  [2917] = {.count = 1, .reusable = false}, SHIFT(1408),
  [2919] = {.count = 1, .reusable = false}, SHIFT(1409),
  [2921] = {.count = 1, .reusable = false}, SHIFT(1410),
  [2923] = {.count = 1, .reusable = false}, SHIFT(1411),
  [2925] = {.count = 1, .reusable = false}, SHIFT(1412),
  [2927] = {.count = 1, .reusable = false}, SHIFT(1419),
  [2929] = {.count = 1, .reusable = false}, SHIFT(1413),
  [2931] = {.count = 1, .reusable = false}, SHIFT(1422),
  [2933] = {.count = 1, .reusable = false}, SHIFT(1426),
  [2935] = {.count = 1, .reusable = false}, SHIFT(1430),
  [2937] = {.count = 1, .reusable = false}, SHIFT(1432),
  [2939] = {.count = 1, .reusable = true}, SHIFT(1433),
  [2941] = {.count = 1, .reusable = true}, SHIFT(1443),
  [2943] = {.count = 1, .reusable = true}, SHIFT(1434),
  [2945] = {.count = 1, .reusable = true}, SHIFT(1435),
  [2947] = {.count = 1, .reusable = true}, SHIFT(1436),
  [2949] = {.count = 1, .reusable = true}, SHIFT(1437),
  [2951] = {.count = 1, .reusable = false}, SHIFT(1438),
  [2953] = {.count = 1, .reusable = true}, SHIFT(1438),
  [2955] = {.count = 1, .reusable = false}, SHIFT(1439),
  [2957] = {.count = 1, .reusable = true}, SHIFT(1440),
  [2959] = {.count = 1, .reusable = false}, SHIFT(1443),
  [2961] = {.count = 1, .reusable = true}, SHIFT(1441),
  [2963] = {.count = 1, .reusable = false}, SHIFT(1442),
  [2965] = {.count = 1, .reusable = true}, SHIFT(1444),
  [2967] = {.count = 1, .reusable = true}, SHIFT(1445),
  [2969] = {.count = 1, .reusable = false}, SHIFT(1445),
  [2971] = {.count = 1, .reusable = true}, SHIFT(1447),
  [2973] = {.count = 1, .reusable = false}, SHIFT(1447),
  [2975] = {.count = 1, .reusable = true}, SHIFT(1448),
  [2977] = {.count = 1, .reusable = false}, SHIFT(1448),
  [2979] = {.count = 1, .reusable = true}, SHIFT(1449),
  [2981] = {.count = 1, .reusable = false}, SHIFT(1449),
  [2983] = {.count = 1, .reusable = true}, SHIFT(1450),
  [2985] = {.count = 1, .reusable = false}, SHIFT(1450),
  [2987] = {.count = 1, .reusable = true}, SHIFT(1452),
  [2989] = {.count = 1, .reusable = true}, SHIFT(1451),
  [2991] = {.count = 1, .reusable = false}, SHIFT(1452),
  [2993] = {.count = 1, .reusable = true}, SHIFT(1453),
  [2995] = {.count = 1, .reusable = false}, SHIFT(1454),
  [2997] = {.count = 1, .reusable = true}, SHIFT(1456),
  [2999] = {.count = 1, .reusable = true}, SHIFT(1455),
  [3001] = {.count = 1, .reusable = false}, SHIFT(1456),
  [3003] = {.count = 1, .reusable = false}, SHIFT(1457),
  [3005] = {.count = 1, .reusable = false}, SHIFT(1458),
  [3007] = {.count = 1, .reusable = true}, SHIFT(1459),
  [3009] = {.count = 1, .reusable = true}, SHIFT(1460),
  [3011] = {.count = 1, .reusable = true}, SHIFT(1458),
  [3013] = {.count = 1, .reusable = false}, SHIFT(1461),
  [3015] = {.count = 1, .reusable = true}, SHIFT(1462),
  [3017] = {.count = 1, .reusable = true}, SHIFT(1463),
  [3019] = {.count = 1, .reusable = false}, SHIFT(1464),
  [3021] = {.count = 1, .reusable = false}, SHIFT(1465),
  [3023] = {.count = 1, .reusable = true}, SHIFT(1466),
  [3025] = {.count = 1, .reusable = false}, SHIFT(1467),
  [3027] = {.count = 1, .reusable = true}, SHIFT(1467),
  [3029] = {.count = 1, .reusable = false}, SHIFT(1468),
  [3031] = {.count = 1, .reusable = false}, SHIFT(1469),
  [3033] = {.count = 1, .reusable = true}, SHIFT(1470),
  [3035] = {.count = 2, .reusable = false}, REDUCE(sym__expression, 1), SHIFT(1077),
  [3038] = {.count = 1, .reusable = false}, SHIFT(1471),
  [3040] = {.count = 1, .reusable = true}, SHIFT(1472),
  [3042] = {.count = 1, .reusable = true}, SHIFT(1477),
  [3044] = {.count = 1, .reusable = false}, SHIFT(1477),
  [3046] = {.count = 1, .reusable = true}, SHIFT(1478),
  [3048] = {.count = 1, .reusable = true}, SHIFT(1480),
  [3050] = {.count = 1, .reusable = true}, SHIFT(1481),
  [3052] = {.count = 1, .reusable = true}, SHIFT(1482),
  [3054] = {.count = 1, .reusable = true}, SHIFT(1483),
  [3056] = {.count = 1, .reusable = false}, SHIFT(1483),
  [3058] = {.count = 1, .reusable = true}, SHIFT(1484),
  [3060] = {.count = 1, .reusable = true}, SHIFT(1485),
  [3062] = {.count = 1, .reusable = true}, SHIFT(1487),
  [3064] = {.count = 1, .reusable = true}, SHIFT(1489),
  [3066] = {.count = 1, .reusable = true}, SHIFT(1488),
  [3068] = {.count = 1, .reusable = false}, SHIFT(1489),
  [3070] = {.count = 1, .reusable = true}, SHIFT(1491),
  [3072] = {.count = 1, .reusable = true}, SHIFT(1492),
  [3074] = {.count = 1, .reusable = true}, SHIFT(1493),
  [3076] = {.count = 1, .reusable = false}, SHIFT(1494),
  [3078] = {.count = 1, .reusable = true}, SHIFT(1495),
  [3080] = {.count = 1, .reusable = true}, SHIFT(1496),
  [3082] = {.count = 1, .reusable = true}, SHIFT(1501),
  [3084] = {.count = 1, .reusable = true}, SHIFT(1497),
  [3086] = {.count = 1, .reusable = false}, SHIFT(1501),
  [3088] = {.count = 1, .reusable = false}, SHIFT(1498),
  [3090] = {.count = 1, .reusable = true}, SHIFT(1499),
  [3092] = {.count = 1, .reusable = true}, REDUCE(sym_return_statement, 2),
  [3094] = {.count = 1, .reusable = false}, REDUCE(sym_return_statement, 2),
  [3096] = {.count = 1, .reusable = true}, SHIFT(1503),
  [3098] = {.count = 1, .reusable = true}, REDUCE(sym_break_statement, 2),
  [3100] = {.count = 1, .reusable = false}, REDUCE(sym_break_statement, 2),
  [3102] = {.count = 1, .reusable = true}, REDUCE(sym_continue_statement, 2),
  [3104] = {.count = 1, .reusable = false}, REDUCE(sym_continue_statement, 2),
  [3106] = {.count = 1, .reusable = true}, SHIFT(1504),
  [3108] = {.count = 1, .reusable = true}, SHIFT(1506),
  [3110] = {.count = 1, .reusable = false}, SHIFT(1507),
  [3112] = {.count = 1, .reusable = false}, SHIFT(1509),
  [3114] = {.count = 1, .reusable = true}, SHIFT(1511),
  [3116] = {.count = 1, .reusable = true}, SHIFT(1510),
  [3118] = {.count = 1, .reusable = false}, SHIFT(1511),
  [3120] = {.count = 1, .reusable = true}, SHIFT(1512),
  [3122] = {.count = 1, .reusable = true}, SHIFT(1513),
  [3124] = {.count = 1, .reusable = true}, SHIFT(1515),
  [3126] = {.count = 1, .reusable = true}, SHIFT(1517),
  [3128] = {.count = 1, .reusable = true}, SHIFT(1519),
  [3130] = {.count = 1, .reusable = false}, SHIFT(1519),
  [3132] = {.count = 1, .reusable = true}, REDUCE(sym_expression_statement, 2),
  [3134] = {.count = 1, .reusable = false}, REDUCE(sym_expression_statement, 2),
  [3136] = {.count = 1, .reusable = true}, SHIFT(1521),
  [3138] = {.count = 1, .reusable = false}, SHIFT(1521),
  [3140] = {.count = 1, .reusable = true}, SHIFT(1522),
  [3142] = {.count = 1, .reusable = false}, SHIFT(1522),
  [3144] = {.count = 1, .reusable = true}, SHIFT(1523),
  [3146] = {.count = 1, .reusable = false}, SHIFT(1523),
  [3148] = {.count = 1, .reusable = true}, SHIFT(1524),
  [3150] = {.count = 1, .reusable = false}, SHIFT(1524),
  [3152] = {.count = 1, .reusable = true}, SHIFT(1525),
  [3154] = {.count = 1, .reusable = false}, SHIFT(1525),
  [3156] = {.count = 1, .reusable = true}, SHIFT(1526),
  [3158] = {.count = 1, .reusable = false}, SHIFT(1526),
  [3160] = {.count = 1, .reusable = true}, SHIFT(1527),
  [3162] = {.count = 1, .reusable = false}, SHIFT(1527),
  [3164] = {.count = 1, .reusable = true}, SHIFT(1528),
  [3166] = {.count = 1, .reusable = false}, SHIFT(1528),
  [3168] = {.count = 1, .reusable = true}, SHIFT(1529),
  [3170] = {.count = 1, .reusable = false}, SHIFT(1529),
  [3172] = {.count = 1, .reusable = true}, SHIFT(1530),
  [3174] = {.count = 1, .reusable = false}, SHIFT(1530),
  [3176] = {.count = 1, .reusable = true}, SHIFT(1531),
  [3178] = {.count = 1, .reusable = false}, SHIFT(1531),
  [3180] = {.count = 1, .reusable = false}, SHIFT(1532),
  [3182] = {.count = 1, .reusable = true}, REDUCE(sym_compound_statement, 3),
  [3184] = {.count = 1, .reusable = false}, REDUCE(sym_compound_statement, 3),
  [3186] = {.count = 2, .reusable = true}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(413),
  [3189] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(379),
  [3192] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(380),
  [3195] = {.count = 2, .reusable = true}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(381),
  [3198] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(382),
  [3201] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(383),
  [3204] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(384),
  [3207] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(385),
  [3210] = {.count = 2, .reusable = true}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(386),
  [3213] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(387),
  [3216] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(95),
  [3219] = {.count = 2, .reusable = true}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(388),
  [3222] = {.count = 1, .reusable = true}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2),
  [3224] = {.count = 2, .reusable = true}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(390),
  [3227] = {.count = 2, .reusable = true}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(350),
  [3230] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(97),
  [3233] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(38),
  [3236] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(30),
  [3239] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(14),
  [3242] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(15),
  [3245] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(16),
  [3248] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(391),
  [3251] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(392),
  [3254] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(393),
  [3257] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(394),
  [3260] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(395),
  [3263] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(396),
  [3266] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(397),
  [3269] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(398),
  [3272] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(399),
  [3275] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(400),
  [3278] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(401),
  [3281] = {.count = 2, .reusable = true}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(402),
  [3284] = {.count = 2, .reusable = true}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(403),
  [3287] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(404),
  [3290] = {.count = 2, .reusable = true}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(404),
  [3293] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(405),
  [3296] = {.count = 2, .reusable = true}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(406),
  [3299] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(413),
  [3302] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(407),
  [3305] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(20),
  [3308] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(21),
  [3311] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(363),
  [3314] = {.count = 2, .reusable = true}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(408),
  [3317] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(409),
  [3320] = {.count = 1, .reusable = false}, SHIFT(1533),
  [3322] = {.count = 1, .reusable = true}, SHIFT(1534),
  [3324] = {.count = 1, .reusable = true}, REDUCE(sym_field_initializer, 2, .alias_sequence_id = 26),
  [3326] = {.count = 1, .reusable = true}, REDUCE(sym_scoped_field_identifier, 2, .alias_sequence_id = 29),
  [3328] = {.count = 1, .reusable = true}, REDUCE(sym_scoped_field_identifier, 2),
  [3330] = {.count = 1, .reusable = true}, REDUCE(sym_field_initializer_list, 3),
  [3332] = {.count = 1, .reusable = false}, SHIFT(1537),
  [3334] = {.count = 1, .reusable = true}, SHIFT(1538),
  [3336] = {.count = 1, .reusable = true}, REDUCE(sym_field_initializer, 2),
  [3338] = {.count = 1, .reusable = true}, REDUCE(sym_constructor_or_destructor_definition, 4),
  [3340] = {.count = 1, .reusable = false}, REDUCE(sym_constructor_or_destructor_definition, 4),
  [3342] = {.count = 1, .reusable = true}, REDUCE(sym_preproc_def, 5, .alias_sequence_id = 6),
  [3344] = {.count = 1, .reusable = false}, REDUCE(sym_preproc_def, 5, .alias_sequence_id = 6),
  [3346] = {.count = 1, .reusable = true}, SHIFT(1539),
  [3348] = {.count = 1, .reusable = false}, REDUCE(sym_preproc_params, 3),
  [3350] = {.count = 1, .reusable = true}, SHIFT(1540),
  [3352] = {.count = 1, .reusable = true}, REDUCE(sym_preproc_function_def, 5, .alias_sequence_id = 6),
  [3354] = {.count = 1, .reusable = false}, REDUCE(sym_preproc_function_def, 5, .alias_sequence_id = 6),
  [3356] = {.count = 1, .reusable = true}, SHIFT(1542),
  [3358] = {.count = 1, .reusable = true}, SHIFT(1546),
  [3360] = {.count = 1, .reusable = false}, SHIFT(1547),
  [3362] = {.count = 1, .reusable = true}, SHIFT(1547),
  [3364] = {.count = 1, .reusable = false}, SHIFT(1550),
  [3366] = {.count = 2, .reusable = true}, REDUCE(aux_sym_function_declarator_repeat1, 2), SHIFT_REPEAT(437),
  [3369] = {.count = 2, .reusable = true}, REDUCE(aux_sym_function_declarator_repeat1, 2), SHIFT_REPEAT(935),
  [3372] = {.count = 1, .reusable = false}, SHIFT(1551),
  [3374] = {.count = 1, .reusable = false}, SHIFT(1552),
  [3376] = {.count = 1, .reusable = false}, SHIFT(1553),
  [3378] = {.count = 1, .reusable = true}, SHIFT(1554),
  [3380] = {.count = 1, .reusable = false}, SHIFT(1554),
  [3382] = {.count = 1, .reusable = true}, SHIFT(1556),
  [3384] = {.count = 1, .reusable = false}, SHIFT(1556),
  [3386] = {.count = 1, .reusable = true}, SHIFT(1558),
  [3388] = {.count = 1, .reusable = false}, SHIFT(1558),
  [3390] = {.count = 1, .reusable = false}, SHIFT(1560),
  [3392] = {.count = 1, .reusable = false}, SHIFT(1561),
  [3394] = {.count = 1, .reusable = false}, SHIFT(1563),
  [3396] = {.count = 1, .reusable = false}, SHIFT(1566),
  [3398] = {.count = 1, .reusable = false}, SHIFT(1569),
  [3400] = {.count = 1, .reusable = false}, SHIFT(1572),
  [3402] = {.count = 1, .reusable = false}, SHIFT(1574),
  [3404] = {.count = 1, .reusable = true}, SHIFT(1577),
  [3406] = {.count = 1, .reusable = true}, SHIFT(1578),
  [3408] = {.count = 1, .reusable = true}, SHIFT(1581),
  [3410] = {.count = 1, .reusable = true}, SHIFT(1584),
  [3412] = {.count = 1, .reusable = true}, SHIFT(1585),
  [3414] = {.count = 1, .reusable = true}, SHIFT(1586),
  [3416] = {.count = 1, .reusable = true}, SHIFT(1588),
  [3418] = {.count = 1, .reusable = true}, SHIFT(1589),
  [3420] = {.count = 1, .reusable = true}, SHIFT(1592),
  [3422] = {.count = 1, .reusable = true}, SHIFT(1594),
  [3424] = {.count = 1, .reusable = true}, SHIFT(1596),
  [3426] = {.count = 2, .reusable = false}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(445),
  [3429] = {.count = 2, .reusable = false}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(446),
  [3432] = {.count = 2, .reusable = false}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(447),
  [3435] = {.count = 2, .reusable = false}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(448),
  [3438] = {.count = 2, .reusable = false}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(449),
  [3441] = {.count = 2, .reusable = false}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(450),
  [3444] = {.count = 2, .reusable = false}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(451),
  [3447] = {.count = 2, .reusable = false}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(452),
  [3450] = {.count = 2, .reusable = false}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(453),
  [3453] = {.count = 2, .reusable = false}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(454),
  [3456] = {.count = 2, .reusable = false}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(455),
  [3459] = {.count = 1, .reusable = true}, REDUCE(sym_preproc_elif, 3, .alias_sequence_id = 22),
  [3461] = {.count = 1, .reusable = false}, REDUCE(sym_preproc_elif, 3, .alias_sequence_id = 22),
  [3463] = {.count = 1, .reusable = true}, SHIFT(1601),
  [3465] = {.count = 1, .reusable = true}, SHIFT(1602),
  [3467] = {.count = 1, .reusable = true}, SHIFT(1604),
  [3469] = {.count = 1, .reusable = true}, SHIFT(1605),
  [3471] = {.count = 1, .reusable = true}, SHIFT(1607),
  [3473] = {.count = 1, .reusable = true}, SHIFT(1608),
  [3475] = {.count = 1, .reusable = true}, SHIFT(1609),
  [3477] = {.count = 1, .reusable = true}, SHIFT(1610),
  [3479] = {.count = 1, .reusable = false}, SHIFT(1610),
  [3481] = {.count = 1, .reusable = true}, SHIFT(1612),
  [3483] = {.count = 1, .reusable = true}, SHIFT(1613),
  [3485] = {.count = 1, .reusable = false}, SHIFT(1613),
  [3487] = {.count = 1, .reusable = true}, SHIFT(1615),
  [3489] = {.count = 1, .reusable = true}, SHIFT(1616),
  [3491] = {.count = 1, .reusable = true}, REDUCE(sym_preproc_if, 5, .alias_sequence_id = 30),
  [3493] = {.count = 1, .reusable = false}, REDUCE(sym_preproc_if, 5, .alias_sequence_id = 30),
  [3495] = {.count = 1, .reusable = true}, REDUCE(sym_preproc_ifdef, 5, .alias_sequence_id = 31),
  [3497] = {.count = 1, .reusable = false}, REDUCE(sym_preproc_ifdef, 5, .alias_sequence_id = 31),
  [3499] = {.count = 1, .reusable = true}, REDUCE(sym_preproc_ifdef, 5, .alias_sequence_id = 32),
  [3501] = {.count = 1, .reusable = false}, REDUCE(sym_preproc_ifdef, 5, .alias_sequence_id = 32),
  [3503] = {.count = 1, .reusable = true}, SHIFT(1618),
  [3505] = {.count = 1, .reusable = true}, SHIFT(1619),
  [3507] = {.count = 1, .reusable = true}, SHIFT(1620),
  [3509] = {.count = 1, .reusable = true}, REDUCE(sym__type_declarator, 3),
  [3511] = {.count = 1, .reusable = true}, REDUCE(sym_array_type_declarator, 3),
  [3513] = {.count = 1, .reusable = true}, SHIFT(1622),
  [3515] = {.count = 1, .reusable = true}, SHIFT(1621),
  [3517] = {.count = 1, .reusable = false}, SHIFT(1622),
  [3519] = {.count = 1, .reusable = true}, REDUCE(sym_type_definition, 5),
  [3521] = {.count = 1, .reusable = false}, REDUCE(sym_type_definition, 5),
  [3523] = {.count = 1, .reusable = true}, SHIFT(1623),
  [3525] = {.count = 1, .reusable = false}, SHIFT(1624),
  [3527] = {.count = 1, .reusable = true}, SHIFT(1624),
  [3529] = {.count = 1, .reusable = false}, SHIFT(1627),
  [3531] = {.count = 2, .reusable = true}, REDUCE(aux_sym_function_declarator_repeat1, 2), SHIFT_REPEAT(516),
  [3534] = {.count = 2, .reusable = true}, REDUCE(aux_sym_function_declarator_repeat1, 2), SHIFT_REPEAT(1027),
  [3537] = {.count = 1, .reusable = true}, REDUCE(sym_enumerator, 3),
  [3539] = {.count = 1, .reusable = true}, REDUCE(sym_enumerator_list, 4),
  [3541] = {.count = 1, .reusable = false}, REDUCE(sym_enumerator_list, 4),
  [3543] = {.count = 1, .reusable = true}, REDUCE(aux_sym_enumerator_list_repeat1, 2),
  [3545] = {.count = 1, .reusable = true}, SHIFT(1628),
  [3547] = {.count = 2, .reusable = true}, REDUCE(aux_sym_enumerator_list_repeat1, 2), SHIFT_REPEAT(1629),
  [3550] = {.count = 1, .reusable = true}, REDUCE(sym_preproc_if_in_field_declaration_list, 3, .alias_sequence_id = 7),
  [3552] = {.count = 1, .reusable = false}, REDUCE(sym_preproc_if_in_field_declaration_list, 3, .alias_sequence_id = 7),
  [3554] = {.count = 1, .reusable = true}, REDUCE(sym_preproc_else_in_field_declaration_list, 1, .alias_sequence_id = 8),
  [3556] = {.count = 1, .reusable = false}, SHIFT(1631),
  [3558] = {.count = 1, .reusable = true}, SHIFT(1632),
  [3560] = {.count = 1, .reusable = true}, SHIFT(1633),
  [3562] = {.count = 1, .reusable = true}, SHIFT(1634),
  [3564] = {.count = 1, .reusable = true}, REDUCE(sym_preproc_ifdef_in_field_declaration_list, 3, .alias_sequence_id = 9),
  [3566] = {.count = 1, .reusable = false}, REDUCE(sym_preproc_ifdef_in_field_declaration_list, 3, .alias_sequence_id = 9),
  [3568] = {.count = 1, .reusable = true}, SHIFT(1638),
  [3570] = {.count = 1, .reusable = true}, SHIFT(1639),
  [3572] = {.count = 1, .reusable = true}, SHIFT(1640),
  [3574] = {.count = 1, .reusable = true}, REDUCE(sym_preproc_ifdef_in_field_declaration_list, 3, .alias_sequence_id = 10),
  [3576] = {.count = 1, .reusable = false}, REDUCE(sym_preproc_ifdef_in_field_declaration_list, 3, .alias_sequence_id = 10),
  [3578] = {.count = 1, .reusable = true}, SHIFT(1643),
  [3580] = {.count = 1, .reusable = true}, SHIFT(1644),
  [3582] = {.count = 1, .reusable = true}, SHIFT(1645),
  [3584] = {.count = 1, .reusable = true}, SHIFT(1648),
  [3586] = {.count = 1, .reusable = true}, SHIFT(1650),
  [3588] = {.count = 1, .reusable = true}, SHIFT(1651),
  [3590] = {.count = 1, .reusable = true}, SHIFT(1652),
  [3592] = {.count = 1, .reusable = true}, REDUCE(sym_friend_declaration, 3),
  [3594] = {.count = 1, .reusable = false}, REDUCE(sym_friend_declaration, 3),
  [3596] = {.count = 1, .reusable = true}, SHIFT(1656),
  [3598] = {.count = 1, .reusable = true}, SHIFT(1657),
  [3600] = {.count = 1, .reusable = true}, SHIFT(1658),
  [3602] = {.count = 1, .reusable = true}, SHIFT(1659),
  [3604] = {.count = 1, .reusable = true}, REDUCE(sym_pointer_field_declarator, 2),
  [3606] = {.count = 1, .reusable = true}, SHIFT(1661),
  [3608] = {.count = 1, .reusable = true}, REDUCE(sym_reference_field_declarator, 2),
  [3610] = {.count = 1, .reusable = false}, SHIFT(1662),
  [3612] = {.count = 1, .reusable = true}, REDUCE(sym_template_method, 2, .alias_sequence_id = 26),
  [3614] = {.count = 1, .reusable = false}, REDUCE(sym_template_method, 2, .alias_sequence_id = 26),
  [3616] = {.count = 2, .reusable = true}, REDUCE(sym_scoped_field_identifier, 2, .alias_sequence_id = 29), REDUCE(sym_scoped_type_identifier, 2, .alias_sequence_id = 4),
  [3619] = {.count = 1, .reusable = true}, SHIFT(1663),
  [3621] = {.count = 1, .reusable = false}, SHIFT(1664),
  [3623] = {.count = 1, .reusable = true}, SHIFT(1664),
  [3625] = {.count = 1, .reusable = true}, SHIFT(1665),
  [3627] = {.count = 1, .reusable = true}, REDUCE(sym_field_declaration, 3),
  [3629] = {.count = 1, .reusable = false}, REDUCE(sym_field_declaration, 3),
  [3631] = {.count = 1, .reusable = true}, SHIFT(1668),
  [3633] = {.count = 1, .reusable = true}, SHIFT(1666),
  [3635] = {.count = 1, .reusable = false}, SHIFT(1668),
  [3637] = {.count = 1, .reusable = true}, SHIFT(1669),
  [3639] = {.count = 1, .reusable = false}, SHIFT(1669),
  [3641] = {.count = 1, .reusable = true}, REDUCE(sym_inline_method_definition, 3),
  [3643] = {.count = 1, .reusable = false}, REDUCE(sym_inline_method_definition, 3),
  [3645] = {.count = 1, .reusable = true}, REDUCE(sym_function_field_declarator, 2),
  [3647] = {.count = 1, .reusable = true}, SHIFT(1670),
  [3649] = {.count = 1, .reusable = true}, SHIFT(1671),
  [3651] = {.count = 1, .reusable = true}, SHIFT(1672),
  [3653] = {.count = 1, .reusable = false}, SHIFT(1674),
  [3655] = {.count = 1, .reusable = true}, SHIFT(1675),
  [3657] = {.count = 1, .reusable = true}, REDUCE(sym_template_method, 2),
  [3659] = {.count = 1, .reusable = false}, REDUCE(sym_template_method, 2),
  [3661] = {.count = 1, .reusable = false}, SHIFT(1679),
  [3663] = {.count = 1, .reusable = false}, SHIFT(1678),
  [3665] = {.count = 1, .reusable = false}, SHIFT(1677),
  [3667] = {.count = 1, .reusable = true}, SHIFT(1680),
  [3669] = {.count = 1, .reusable = true}, SHIFT(1681),
  [3671] = {.count = 1, .reusable = true}, REDUCE(sym_base_class_clause, 4),
  [3673] = {.count = 1, .reusable = true}, REDUCE(aux_sym_base_class_clause_repeat1, 2),
  [3675] = {.count = 2, .reusable = true}, REDUCE(aux_sym_base_class_clause_repeat1, 2), SHIFT_REPEAT(568),
  [3678] = {.count = 1, .reusable = true}, SHIFT(1684),
  [3680] = {.count = 1, .reusable = true}, SHIFT(1686),
  [3682] = {.count = 1, .reusable = false}, SHIFT(1687),
  [3684] = {.count = 1, .reusable = true}, SHIFT(1689),
  [3686] = {.count = 1, .reusable = true}, SHIFT(1688),
  [3688] = {.count = 1, .reusable = false}, SHIFT(1689),
  [3690] = {.count = 1, .reusable = true}, SHIFT(1690),
  [3692] = {.count = 1, .reusable = true}, SHIFT(1691),
  [3694] = {.count = 1, .reusable = false}, SHIFT(1691),
  [3696] = {.count = 1, .reusable = true}, REDUCE(sym_parenthesized_expression, 3),
  [3698] = {.count = 1, .reusable = true}, SHIFT(1692),
  [3700] = {.count = 1, .reusable = false}, SHIFT(1692),
  [3702] = {.count = 1, .reusable = true}, SHIFT(1693),
  [3704] = {.count = 1, .reusable = false}, SHIFT(1693),
  [3706] = {.count = 1, .reusable = true}, SHIFT(1694),
  [3708] = {.count = 1, .reusable = false}, SHIFT(1694),
  [3710] = {.count = 1, .reusable = true}, SHIFT(1695),
  [3712] = {.count = 1, .reusable = false}, SHIFT(1695),
  [3714] = {.count = 1, .reusable = true}, SHIFT(1696),
  [3716] = {.count = 1, .reusable = false}, SHIFT(1696),
  [3718] = {.count = 1, .reusable = true}, SHIFT(1697),
  [3720] = {.count = 1, .reusable = false}, SHIFT(1697),
  [3722] = {.count = 1, .reusable = true}, SHIFT(1698),
  [3724] = {.count = 1, .reusable = false}, SHIFT(1698),
  [3726] = {.count = 1, .reusable = true}, SHIFT(1699),
  [3728] = {.count = 1, .reusable = false}, SHIFT(1699),
  [3730] = {.count = 1, .reusable = true}, SHIFT(1700),
  [3732] = {.count = 1, .reusable = false}, SHIFT(1700),
  [3734] = {.count = 1, .reusable = true}, SHIFT(1701),
  [3736] = {.count = 1, .reusable = false}, SHIFT(1701),
  [3738] = {.count = 1, .reusable = true}, SHIFT(1702),
  [3740] = {.count = 1, .reusable = false}, SHIFT(1702),
  [3742] = {.count = 1, .reusable = false}, SHIFT(1703),
  [3744] = {.count = 1, .reusable = true}, SHIFT(1706),
  [3746] = {.count = 1, .reusable = true}, SHIFT(1708),
  [3748] = {.count = 1, .reusable = true}, SHIFT(1709),
  [3750] = {.count = 1, .reusable = true}, REDUCE(sym_abstract_pointer_declarator, 2),
  [3752] = {.count = 1, .reusable = true}, REDUCE(sym_abstract_array_declarator, 2),
  [3754] = {.count = 1, .reusable = false}, REDUCE(sym_abstract_array_declarator, 2),
  [3756] = {.count = 1, .reusable = true}, SHIFT(1711),
  [3758] = {.count = 1, .reusable = true}, SHIFT(1710),
  [3760] = {.count = 1, .reusable = false}, SHIFT(1711),
  [3762] = {.count = 1, .reusable = true}, REDUCE(sym_abstract_reference_declarator, 2),
  [3764] = {.count = 1, .reusable = true}, REDUCE(sym_abstract_function_declarator, 2),
  [3766] = {.count = 1, .reusable = true}, SHIFT(1714),
  [3768] = {.count = 1, .reusable = false}, SHIFT(1715),
  [3770] = {.count = 1, .reusable = false}, REDUCE(sym_abstract_function_declarator, 2),
  [3772] = {.count = 1, .reusable = true}, SHIFT(1716),
  [3774] = {.count = 1, .reusable = true}, REDUCE(aux_sym_template_argument_list_repeat1, 2),
  [3776] = {.count = 1, .reusable = true}, REDUCE(sym_template_argument_list, 4),
  [3778] = {.count = 1, .reusable = false}, REDUCE(sym_template_argument_list, 4),
  [3780] = {.count = 2, .reusable = true}, REDUCE(aux_sym_template_argument_list_repeat1, 2), SHIFT_REPEAT(599),
  [3783] = {.count = 1, .reusable = true}, REDUCE(sym_type_descriptor, 3),
  [3785] = {.count = 1, .reusable = false}, SHIFT(1719),
  [3787] = {.count = 1, .reusable = false}, SHIFT(1718),
  [3789] = {.count = 1, .reusable = false}, SHIFT(1717),
  [3791] = {.count = 1, .reusable = true}, SHIFT(1720),
  [3793] = {.count = 1, .reusable = true}, SHIFT(1721),
  [3795] = {.count = 1, .reusable = false}, SHIFT(1721),
  [3797] = {.count = 1, .reusable = true}, SHIFT(1725),
  [3799] = {.count = 1, .reusable = true}, SHIFT(1723),
  [3801] = {.count = 1, .reusable = true}, SHIFT(1724),
  [3803] = {.count = 1, .reusable = false}, SHIFT(1725),
  [3805] = {.count = 1, .reusable = true}, SHIFT(1736),
  [3807] = {.count = 1, .reusable = true}, SHIFT(1727),
  [3809] = {.count = 1, .reusable = true}, SHIFT(1728),
  [3811] = {.count = 1, .reusable = true}, SHIFT(1729),
  [3813] = {.count = 1, .reusable = true}, SHIFT(1730),
  [3815] = {.count = 1, .reusable = false}, SHIFT(1731),
  [3817] = {.count = 1, .reusable = true}, SHIFT(1731),
  [3819] = {.count = 1, .reusable = false}, SHIFT(1732),
  [3821] = {.count = 1, .reusable = true}, SHIFT(1733),
  [3823] = {.count = 1, .reusable = false}, SHIFT(1736),
  [3825] = {.count = 1, .reusable = true}, SHIFT(1734),
  [3827] = {.count = 1, .reusable = false}, SHIFT(1735),
  [3829] = {.count = 1, .reusable = true}, SHIFT(1737),
  [3831] = {.count = 1, .reusable = true}, SHIFT(1738),
  [3833] = {.count = 1, .reusable = true}, SHIFT(1739),
  [3835] = {.count = 1, .reusable = true}, REDUCE(aux_sym_template_parameter_list_repeat1, 2),
  [3837] = {.count = 1, .reusable = false}, REDUCE(sym_template_parameter_list, 4),
  [3839] = {.count = 1, .reusable = true}, REDUCE(sym_template_parameter_list, 4),
  [3841] = {.count = 2, .reusable = true}, REDUCE(aux_sym_template_parameter_list_repeat1, 2), SHIFT_REPEAT(618),
  [3844] = {.count = 1, .reusable = true}, SHIFT(1740),
  [3846] = {.count = 1, .reusable = false}, SHIFT(1741),
  [3848] = {.count = 1, .reusable = true}, SHIFT(1741),
  [3850] = {.count = 1, .reusable = false}, SHIFT(1744),
  [3852] = {.count = 2, .reusable = true}, REDUCE(aux_sym_function_declarator_repeat1, 2), SHIFT_REPEAT(625),
  [3855] = {.count = 2, .reusable = true}, REDUCE(aux_sym_function_declarator_repeat1, 2), SHIFT_REPEAT(1156),
  [3858] = {.count = 1, .reusable = true}, SHIFT(1748),
  [3860] = {.count = 1, .reusable = true}, SHIFT(1749),
  [3862] = {.count = 1, .reusable = true}, REDUCE(sym_alias_declaration, 5, .alias_sequence_id = 4),
  [3864] = {.count = 1, .reusable = false}, REDUCE(sym_alias_declaration, 5, .alias_sequence_id = 4),
  [3866] = {.count = 2, .reusable = false}, REDUCE(aux_sym_sized_type_specifier_repeat1, 2), SHIFT_REPEAT(1165),
  [3869] = {.count = 1, .reusable = true}, REDUCE(aux_sym_structured_binding_declarator_repeat1, 2),
  [3871] = {.count = 1, .reusable = true}, REDUCE(sym_structured_binding_declarator, 4),
  [3873] = {.count = 2, .reusable = true}, REDUCE(aux_sym_structured_binding_declarator_repeat1, 2), SHIFT_REPEAT(643),
  [3876] = {.count = 1, .reusable = false}, SHIFT(1751),
  [3878] = {.count = 1, .reusable = true}, SHIFT(1752),
  [3880] = {.count = 1, .reusable = false}, SHIFT(1752),
  [3882] = {.count = 1, .reusable = true}, REDUCE(sym_argument_list, 3, .dynamic_precedence = 1),
  [3884] = {.count = 1, .reusable = false}, REDUCE(sym_argument_list, 3, .dynamic_precedence = 1),
  [3886] = {.count = 1, .reusable = true}, SHIFT(1754),
  [3888] = {.count = 1, .reusable = false}, SHIFT(1756),
  [3890] = {.count = 1, .reusable = true}, SHIFT(1757),
  [3892] = {.count = 1, .reusable = true}, REDUCE(sym_initializer_list, 3),
  [3894] = {.count = 1, .reusable = false}, REDUCE(sym_initializer_list, 3),
  [3896] = {.count = 1, .reusable = true}, SHIFT(1758),
  [3898] = {.count = 1, .reusable = true}, REDUCE(sym_field_designator, 2, .alias_sequence_id = 29),
  [3900] = {.count = 1, .reusable = true}, SHIFT(1760),
  [3902] = {.count = 1, .reusable = true}, SHIFT(1762),
  [3904] = {.count = 1, .reusable = true}, SHIFT(1761),
  [3906] = {.count = 1, .reusable = false}, SHIFT(1762),
  [3908] = {.count = 1, .reusable = true}, SHIFT(1763),
  [3910] = {.count = 1, .reusable = true}, SHIFT(1765),
  [3912] = {.count = 1, .reusable = true}, SHIFT(1764),
  [3914] = {.count = 1, .reusable = false}, SHIFT(1765),
  [3916] = {.count = 1, .reusable = true}, SHIFT(1767),
  [3918] = {.count = 1, .reusable = false}, SHIFT(1767),
  [3920] = {.count = 1, .reusable = true}, SHIFT(1768),
  [3922] = {.count = 1, .reusable = false}, SHIFT(1768),
  [3924] = {.count = 1, .reusable = true}, SHIFT(1769),
  [3926] = {.count = 1, .reusable = false}, SHIFT(1769),
  [3928] = {.count = 1, .reusable = true}, SHIFT(1770),
  [3930] = {.count = 1, .reusable = false}, SHIFT(1770),
  [3932] = {.count = 1, .reusable = true}, SHIFT(1771),
  [3934] = {.count = 1, .reusable = false}, SHIFT(1771),
  [3936] = {.count = 1, .reusable = true}, SHIFT(1772),
  [3938] = {.count = 1, .reusable = false}, SHIFT(1772),
  [3940] = {.count = 1, .reusable = true}, SHIFT(1773),
  [3942] = {.count = 1, .reusable = false}, SHIFT(1773),
  [3944] = {.count = 1, .reusable = true}, SHIFT(1774),
  [3946] = {.count = 1, .reusable = false}, SHIFT(1774),
  [3948] = {.count = 1, .reusable = true}, SHIFT(1775),
  [3950] = {.count = 1, .reusable = false}, SHIFT(1775),
  [3952] = {.count = 1, .reusable = true}, SHIFT(1776),
  [3954] = {.count = 1, .reusable = false}, SHIFT(1776),
  [3956] = {.count = 1, .reusable = true}, SHIFT(1777),
  [3958] = {.count = 1, .reusable = false}, SHIFT(1777),
  [3960] = {.count = 1, .reusable = true}, SHIFT(1778),
  [3962] = {.count = 1, .reusable = true}, SHIFT(1780),
  [3964] = {.count = 1, .reusable = false}, SHIFT(1780),
  [3966] = {.count = 1, .reusable = true}, SHIFT(1781),
  [3968] = {.count = 1, .reusable = false}, SHIFT(1781),
  [3970] = {.count = 1, .reusable = true}, SHIFT(1782),
  [3972] = {.count = 1, .reusable = false}, SHIFT(1782),
  [3974] = {.count = 2, .reusable = true}, REDUCE(aux_sym_initializer_pair_repeat1, 2), SHIFT_REPEAT(1203),
  [3977] = {.count = 1, .reusable = true}, REDUCE(aux_sym_initializer_pair_repeat1, 2),
  [3979] = {.count = 2, .reusable = true}, REDUCE(aux_sym_initializer_pair_repeat1, 2), SHIFT_REPEAT(665),
  [3982] = {.count = 1, .reusable = true}, SHIFT(1787),
  [3984] = {.count = 1, .reusable = false}, SHIFT(1788),
  [3986] = {.count = 1, .reusable = true}, SHIFT(1788),
  [3988] = {.count = 1, .reusable = false}, SHIFT(1791),
  [3990] = {.count = 2, .reusable = true}, REDUCE(aux_sym_function_declarator_repeat1, 2), SHIFT_REPEAT(675),
  [3993] = {.count = 2, .reusable = true}, REDUCE(aux_sym_function_declarator_repeat1, 2), SHIFT_REPEAT(1212),
  [3996] = {.count = 1, .reusable = true}, SHIFT(1792),
  [3998] = {.count = 1, .reusable = true}, SHIFT(1794),
  [4000] = {.count = 1, .reusable = true}, SHIFT(1796),
  [4002] = {.count = 1, .reusable = true}, SHIFT(1795),
  [4004] = {.count = 1, .reusable = false}, SHIFT(1796),
  [4006] = {.count = 1, .reusable = true}, SHIFT(1797),
  [4008] = {.count = 1, .reusable = true}, SHIFT(1798),
  [4010] = {.count = 1, .reusable = false}, SHIFT(1798),
  [4012] = {.count = 1, .reusable = true}, SHIFT(1799),
  [4014] = {.count = 1, .reusable = false}, SHIFT(1799),
  [4016] = {.count = 1, .reusable = true}, SHIFT(1800),
  [4018] = {.count = 1, .reusable = false}, SHIFT(1800),
  [4020] = {.count = 1, .reusable = true}, SHIFT(1801),
  [4022] = {.count = 1, .reusable = false}, SHIFT(1801),
  [4024] = {.count = 1, .reusable = true}, SHIFT(1802),
  [4026] = {.count = 1, .reusable = false}, SHIFT(1802),
  [4028] = {.count = 1, .reusable = true}, SHIFT(1803),
  [4030] = {.count = 1, .reusable = false}, SHIFT(1803),
  [4032] = {.count = 1, .reusable = true}, SHIFT(1804),
  [4034] = {.count = 1, .reusable = false}, SHIFT(1804),
  [4036] = {.count = 1, .reusable = true}, SHIFT(1805),
  [4038] = {.count = 1, .reusable = false}, SHIFT(1805),
  [4040] = {.count = 1, .reusable = true}, SHIFT(1806),
  [4042] = {.count = 1, .reusable = false}, SHIFT(1806),
  [4044] = {.count = 1, .reusable = true}, SHIFT(1807),
  [4046] = {.count = 1, .reusable = false}, SHIFT(1807),
  [4048] = {.count = 1, .reusable = true}, SHIFT(1808),
  [4050] = {.count = 1, .reusable = false}, SHIFT(1808),
  [4052] = {.count = 1, .reusable = true}, SHIFT(1809),
  [4054] = {.count = 1, .reusable = true}, SHIFT(1811),
  [4056] = {.count = 1, .reusable = true}, SHIFT(1813),
  [4058] = {.count = 1, .reusable = true}, SHIFT(1812),
  [4060] = {.count = 1, .reusable = false}, SHIFT(1813),
  [4062] = {.count = 1, .reusable = true}, SHIFT(1814),
  [4064] = {.count = 1, .reusable = true}, REDUCE(sym_structured_binding_declaration, 5, .alias_sequence_id = 28),
  [4066] = {.count = 1, .reusable = false}, REDUCE(sym_structured_binding_declaration, 5, .alias_sequence_id = 28),
  [4068] = {.count = 1, .reusable = true}, SHIFT(1815),
  [4070] = {.count = 1, .reusable = false}, SHIFT(1815),
  [4072] = {.count = 1, .reusable = true}, SHIFT(1816),
  [4074] = {.count = 1, .reusable = false}, SHIFT(1816),
  [4076] = {.count = 1, .reusable = true}, SHIFT(1817),
  [4078] = {.count = 1, .reusable = false}, SHIFT(1817),
  [4080] = {.count = 1, .reusable = true}, SHIFT(1818),
  [4082] = {.count = 1, .reusable = false}, SHIFT(1818),
  [4084] = {.count = 1, .reusable = true}, SHIFT(1819),
  [4086] = {.count = 1, .reusable = false}, SHIFT(1819),
  [4088] = {.count = 1, .reusable = true}, SHIFT(1820),
  [4090] = {.count = 1, .reusable = false}, SHIFT(1820),
  [4092] = {.count = 1, .reusable = true}, SHIFT(1821),
  [4094] = {.count = 1, .reusable = false}, SHIFT(1821),
  [4096] = {.count = 1, .reusable = true}, SHIFT(1822),
  [4098] = {.count = 1, .reusable = false}, SHIFT(1822),
  [4100] = {.count = 1, .reusable = true}, SHIFT(1823),
  [4102] = {.count = 1, .reusable = false}, SHIFT(1823),
  [4104] = {.count = 1, .reusable = true}, SHIFT(1824),
  [4106] = {.count = 1, .reusable = false}, SHIFT(1824),
  [4108] = {.count = 1, .reusable = true}, SHIFT(1825),
  [4110] = {.count = 1, .reusable = false}, SHIFT(1825),
  [4112] = {.count = 1, .reusable = true}, REDUCE(sym_structured_binding_declaration, 5),
  [4114] = {.count = 1, .reusable = false}, REDUCE(sym_structured_binding_declaration, 5),
  [4116] = {.count = 1, .reusable = true}, REDUCE(aux_sym_parameter_list_repeat1, 2),
  [4118] = {.count = 1, .reusable = true}, REDUCE(sym_parameter_list, 4, .dynamic_precedence = 1),
  [4120] = {.count = 1, .reusable = false}, REDUCE(sym_parameter_list, 4, .dynamic_precedence = 1),
  [4122] = {.count = 2, .reusable = true}, REDUCE(aux_sym_parameter_list_repeat1, 2), SHIFT_REPEAT(706),
  [4125] = {.count = 1, .reusable = true}, SHIFT(1826),
  [4127] = {.count = 1, .reusable = false}, SHIFT(1826),
  [4129] = {.count = 1, .reusable = true}, SHIFT(1827),
  [4131] = {.count = 1, .reusable = true}, SHIFT(1828),
  [4133] = {.count = 1, .reusable = true}, SHIFT(1829),
  [4135] = {.count = 1, .reusable = false}, SHIFT(1832),
  [4137] = {.count = 1, .reusable = false}, SHIFT(1831),
  [4139] = {.count = 1, .reusable = false}, SHIFT(1830),
  [4141] = {.count = 1, .reusable = true}, SHIFT(1833),
  [4143] = {.count = 1, .reusable = false}, REDUCE(sym_parenthesized_expression, 3),
  [4145] = {.count = 1, .reusable = true}, SHIFT(1834),
  [4147] = {.count = 1, .reusable = false}, SHIFT(1834),
  [4149] = {.count = 2, .reusable = false}, REDUCE(aux_sym_sized_type_specifier_repeat1, 2), SHIFT_REPEAT(1271),
  [4152] = {.count = 1, .reusable = true}, SHIFT(1837),
  [4154] = {.count = 1, .reusable = true}, SHIFT(1839),
  [4156] = {.count = 1, .reusable = true}, SHIFT(1841),
  [4158] = {.count = 1, .reusable = true}, SHIFT(1840),
  [4160] = {.count = 1, .reusable = false}, SHIFT(1841),
  [4162] = {.count = 1, .reusable = true}, SHIFT(1842),
  [4164] = {.count = 1, .reusable = true}, SHIFT(1843),
  [4166] = {.count = 1, .reusable = false}, SHIFT(1843),
  [4168] = {.count = 1, .reusable = true}, REDUCE(sym_lambda_capture_specifier, 3),
  [4170] = {.count = 1, .reusable = false}, REDUCE(sym_lambda_capture_specifier, 3),
  [4172] = {.count = 1, .reusable = true}, SHIFT(1844),
  [4174] = {.count = 1, .reusable = false}, SHIFT(1844),
  [4176] = {.count = 1, .reusable = true}, SHIFT(1845),
  [4178] = {.count = 1, .reusable = false}, SHIFT(1845),
  [4180] = {.count = 1, .reusable = true}, SHIFT(1846),
  [4182] = {.count = 1, .reusable = false}, SHIFT(1846),
  [4184] = {.count = 1, .reusable = true}, SHIFT(1847),
  [4186] = {.count = 1, .reusable = false}, SHIFT(1847),
  [4188] = {.count = 1, .reusable = true}, SHIFT(1848),
  [4190] = {.count = 1, .reusable = false}, SHIFT(1848),
  [4192] = {.count = 1, .reusable = true}, SHIFT(1849),
  [4194] = {.count = 1, .reusable = false}, SHIFT(1849),
  [4196] = {.count = 1, .reusable = true}, SHIFT(1850),
  [4198] = {.count = 1, .reusable = false}, SHIFT(1850),
  [4200] = {.count = 1, .reusable = true}, SHIFT(1851),
  [4202] = {.count = 1, .reusable = false}, SHIFT(1851),
  [4204] = {.count = 1, .reusable = true}, SHIFT(1852),
  [4206] = {.count = 1, .reusable = false}, SHIFT(1852),
  [4208] = {.count = 1, .reusable = true}, SHIFT(1853),
  [4210] = {.count = 1, .reusable = false}, SHIFT(1853),
  [4212] = {.count = 1, .reusable = true}, SHIFT(1854),
  [4214] = {.count = 1, .reusable = false}, SHIFT(1854),
  [4216] = {.count = 1, .reusable = true}, SHIFT(1855),
  [4218] = {.count = 1, .reusable = true}, SHIFT(1857),
  [4220] = {.count = 1, .reusable = true}, SHIFT(1858),
  [4222] = {.count = 1, .reusable = true}, SHIFT(1860),
  [4224] = {.count = 1, .reusable = true}, SHIFT(1861),
  [4226] = {.count = 1, .reusable = true}, SHIFT(1863),
  [4228] = {.count = 1, .reusable = true}, SHIFT(1865),
  [4230] = {.count = 1, .reusable = true}, REDUCE(aux_sym_concatenated_string_repeat1, 2),
  [4232] = {.count = 1, .reusable = false}, REDUCE(aux_sym_concatenated_string_repeat1, 2),
  [4234] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenated_string_repeat1, 2), SHIFT_REPEAT(1309),
  [4237] = {.count = 1, .reusable = true}, SHIFT(1866),
  [4239] = {.count = 2, .reusable = false}, REDUCE(sym_scoped_identifier, 3, .alias_sequence_id = 17), REDUCE(sym_scoped_type_identifier, 3, .alias_sequence_id = 18),
  [4242] = {.count = 1, .reusable = true}, SHIFT(1869),
  [4244] = {.count = 1, .reusable = false}, SHIFT(1869),
  [4246] = {.count = 1, .reusable = true}, REDUCE(sym_new_expression, 3, .alias_sequence_id = 4),
  [4248] = {.count = 1, .reusable = false}, REDUCE(sym_new_expression, 3, .alias_sequence_id = 4),
  [4250] = {.count = 1, .reusable = true}, REDUCE(sym_new_expression, 3),
  [4252] = {.count = 1, .reusable = false}, REDUCE(sym_new_expression, 3),
  [4254] = {.count = 1, .reusable = false}, REDUCE(sym_destructor_name, 2),
  [4256] = {.count = 1, .reusable = true}, SHIFT(1875),
  [4258] = {.count = 1, .reusable = true}, REDUCE(sym_delete_expression, 3),
  [4260] = {.count = 1, .reusable = false}, REDUCE(sym_delete_expression, 3),
  [4262] = {.count = 1, .reusable = true}, SHIFT(1876),
  [4264] = {.count = 1, .reusable = false}, SHIFT(1876),
  [4266] = {.count = 1, .reusable = true}, REDUCE(sym_array_declarator, 5),
  [4268] = {.count = 2, .reusable = false}, REDUCE(aux_sym__declaration_specifiers_repeat1, 2), SHIFT_REPEAT(784),
  [4271] = {.count = 2, .reusable = false}, REDUCE(aux_sym__declaration_specifiers_repeat1, 2), SHIFT_REPEAT(785),
  [4274] = {.count = 1, .reusable = true}, REDUCE(sym_math_expression, 3),
  [4276] = {.count = 1, .reusable = false}, REDUCE(sym_math_expression, 3),
  [4278] = {.count = 1, .reusable = true}, SHIFT(1877),
  [4280] = {.count = 1, .reusable = true}, REDUCE(sym_assignment_expression, 3),
  [4282] = {.count = 1, .reusable = true}, SHIFT(1878),
  [4284] = {.count = 1, .reusable = true}, REDUCE(sym_bitwise_expression, 3),
  [4286] = {.count = 1, .reusable = false}, REDUCE(sym_bitwise_expression, 3),
  [4288] = {.count = 1, .reusable = true}, REDUCE(sym_logical_expression, 3),
  [4290] = {.count = 1, .reusable = false}, REDUCE(sym_logical_expression, 3),
  [4292] = {.count = 1, .reusable = true}, REDUCE(sym_equality_expression, 3),
  [4294] = {.count = 1, .reusable = false}, REDUCE(sym_equality_expression, 3),
  [4296] = {.count = 1, .reusable = true}, REDUCE(sym_relational_expression, 3),
  [4298] = {.count = 1, .reusable = false}, REDUCE(sym_relational_expression, 3),
  [4300] = {.count = 1, .reusable = true}, REDUCE(sym_shift_expression, 3),
  [4302] = {.count = 1, .reusable = false}, REDUCE(sym_shift_expression, 3),
  [4304] = {.count = 1, .reusable = true}, REDUCE(sym_field_expression, 3, .alias_sequence_id = 33),
  [4306] = {.count = 1, .reusable = false}, REDUCE(sym_field_expression, 3, .alias_sequence_id = 33),
  [4308] = {.count = 2, .reusable = false}, REDUCE(sym_field_expression, 3, .alias_sequence_id = 33), SHIFT(810),
  [4311] = {.count = 1, .reusable = true}, REDUCE(sym_field_expression, 3),
  [4313] = {.count = 1, .reusable = false}, REDUCE(sym_field_expression, 3),
  [4315] = {.count = 1, .reusable = true}, SHIFT(810),
  [4317] = {.count = 2, .reusable = false}, REDUCE(sym_scoped_identifier, 3), REDUCE(sym_scoped_type_identifier, 3, .alias_sequence_id = 20),
  [4320] = {.count = 1, .reusable = true}, SHIFT(1880),
  [4322] = {.count = 1, .reusable = true}, SHIFT(1881),
  [4324] = {.count = 1, .reusable = true}, SHIFT(1882),
  [4326] = {.count = 1, .reusable = true}, REDUCE(sym_lambda_expression, 3),
  [4328] = {.count = 1, .reusable = false}, REDUCE(sym_lambda_expression, 3),
  [4330] = {.count = 1, .reusable = false}, SHIFT(1889),
  [4332] = {.count = 1, .reusable = false}, SHIFT(1888),
  [4334] = {.count = 1, .reusable = false}, SHIFT(1883),
  [4336] = {.count = 1, .reusable = false}, SHIFT(1884),
  [4338] = {.count = 1, .reusable = false}, SHIFT(1885),
  [4340] = {.count = 1, .reusable = false}, SHIFT(1886),
  [4342] = {.count = 1, .reusable = false}, SHIFT(1887),
  [4344] = {.count = 1, .reusable = true}, SHIFT(1890),
  [4346] = {.count = 1, .reusable = true}, SHIFT(1891),
  [4348] = {.count = 1, .reusable = true}, SHIFT(1893),
  [4350] = {.count = 1, .reusable = true}, SHIFT(1895),
  [4352] = {.count = 1, .reusable = true}, SHIFT(1896),
  [4354] = {.count = 1, .reusable = true}, SHIFT(1899),
  [4356] = {.count = 1, .reusable = true}, SHIFT(1905),
  [4358] = {.count = 1, .reusable = true}, SHIFT(1907),
  [4360] = {.count = 1, .reusable = false}, REDUCE(sym_abstract_pointer_declarator, 1),
  [4362] = {.count = 1, .reusable = false}, REDUCE(sym_abstract_reference_declarator, 1),
  [4364] = {.count = 1, .reusable = true}, REDUCE(sym_trailing_return_type, 3),
  [4366] = {.count = 1, .reusable = false}, REDUCE(sym_trailing_return_type, 3),
  [4368] = {.count = 1, .reusable = false}, REDUCE(sym_abstract_function_declarator, 1),
  [4370] = {.count = 1, .reusable = true}, SHIFT(1914),
  [4372] = {.count = 2, .reusable = false}, REDUCE(aux_sym_sized_type_specifier_repeat1, 2), SHIFT_REPEAT(1385),
  [4375] = {.count = 1, .reusable = false}, SHIFT(1915),
  [4377] = {.count = 1, .reusable = false}, SHIFT(1916),
  [4379] = {.count = 1, .reusable = false}, SHIFT(1917),
  [4381] = {.count = 1, .reusable = true}, SHIFT(1918),
  [4383] = {.count = 1, .reusable = true}, SHIFT(1919),
  [4385] = {.count = 1, .reusable = false}, SHIFT(1920),
  [4387] = {.count = 1, .reusable = true}, REDUCE(sym_preproc_if_in_compound_statement, 3, .alias_sequence_id = 7),
  [4389] = {.count = 1, .reusable = false}, REDUCE(sym_preproc_if_in_compound_statement, 3, .alias_sequence_id = 7),
  [4391] = {.count = 1, .reusable = true}, SHIFT(1921),
  [4393] = {.count = 1, .reusable = true}, SHIFT(1922),
  [4395] = {.count = 1, .reusable = true}, SHIFT(1947),
  [4397] = {.count = 1, .reusable = false}, SHIFT(1923),
  [4399] = {.count = 1, .reusable = false}, SHIFT(1924),
  [4401] = {.count = 1, .reusable = false}, SHIFT(1925),
  [4403] = {.count = 1, .reusable = false}, REDUCE(sym_preproc_else_in_compound_statement, 1, .alias_sequence_id = 8),
  [4405] = {.count = 1, .reusable = false}, SHIFT(1926),
  [4407] = {.count = 1, .reusable = false}, SHIFT(1927),
  [4409] = {.count = 1, .reusable = false}, SHIFT(1928),
  [4411] = {.count = 1, .reusable = true}, SHIFT(1929),
  [4413] = {.count = 1, .reusable = false}, SHIFT(1930),
  [4415] = {.count = 1, .reusable = true}, SHIFT(1931),
  [4417] = {.count = 1, .reusable = false}, SHIFT(1932),
  [4419] = {.count = 1, .reusable = false}, SHIFT(1933),
  [4421] = {.count = 1, .reusable = false}, SHIFT(1934),
  [4423] = {.count = 1, .reusable = false}, SHIFT(1935),
  [4425] = {.count = 1, .reusable = false}, SHIFT(1936),
  [4427] = {.count = 1, .reusable = false}, SHIFT(1937),
  [4429] = {.count = 1, .reusable = false}, SHIFT(1938),
  [4431] = {.count = 1, .reusable = false}, SHIFT(1939),
  [4433] = {.count = 1, .reusable = false}, SHIFT(1940),
  [4435] = {.count = 1, .reusable = false}, SHIFT(1941),
  [4437] = {.count = 1, .reusable = false}, SHIFT(1942),
  [4439] = {.count = 1, .reusable = false}, SHIFT(1947),
  [4441] = {.count = 1, .reusable = false}, SHIFT(1943),
  [4443] = {.count = 1, .reusable = false}, SHIFT(1950),
  [4445] = {.count = 1, .reusable = false}, SHIFT(1951),
  [4447] = {.count = 1, .reusable = false}, SHIFT(1952),
  [4449] = {.count = 1, .reusable = false}, SHIFT(1953),
  [4451] = {.count = 1, .reusable = true}, SHIFT(1955),
  [4453] = {.count = 1, .reusable = true}, SHIFT(1957),
  [4455] = {.count = 1, .reusable = true}, SHIFT(1958),
  [4457] = {.count = 1, .reusable = true}, SHIFT(1959),
  [4459] = {.count = 1, .reusable = true}, SHIFT(1960),
  [4461] = {.count = 1, .reusable = false}, SHIFT(1960),
  [4463] = {.count = 1, .reusable = true}, SHIFT(1961),
  [4465] = {.count = 1, .reusable = true}, SHIFT(1962),
  [4467] = {.count = 1, .reusable = true}, SHIFT(1964),
  [4469] = {.count = 1, .reusable = true}, SHIFT(1966),
  [4471] = {.count = 1, .reusable = true}, SHIFT(1965),
  [4473] = {.count = 1, .reusable = false}, SHIFT(1966),
  [4475] = {.count = 1, .reusable = true}, SHIFT(1968),
  [4477] = {.count = 1, .reusable = true}, SHIFT(1969),
  [4479] = {.count = 1, .reusable = true}, SHIFT(1970),
  [4481] = {.count = 1, .reusable = false}, SHIFT(1971),
  [4483] = {.count = 1, .reusable = true}, SHIFT(1972),
  [4485] = {.count = 1, .reusable = true}, SHIFT(1973),
  [4487] = {.count = 1, .reusable = true}, SHIFT(1974),
  [4489] = {.count = 1, .reusable = true}, SHIFT(1975),
  [4491] = {.count = 1, .reusable = true}, SHIFT(1979),
  [4493] = {.count = 1, .reusable = false}, SHIFT(1980),
  [4495] = {.count = 1, .reusable = true}, REDUCE(sym_preproc_ifdef_in_compound_statement, 3, .alias_sequence_id = 9),
  [4497] = {.count = 1, .reusable = false}, REDUCE(sym_preproc_ifdef_in_compound_statement, 3, .alias_sequence_id = 9),
  [4499] = {.count = 1, .reusable = true}, SHIFT(1984),
  [4501] = {.count = 1, .reusable = true}, SHIFT(1985),
  [4503] = {.count = 1, .reusable = false}, SHIFT(1986),
  [4505] = {.count = 1, .reusable = true}, REDUCE(sym_preproc_ifdef_in_compound_statement, 3, .alias_sequence_id = 10),
  [4507] = {.count = 1, .reusable = false}, REDUCE(sym_preproc_ifdef_in_compound_statement, 3, .alias_sequence_id = 10),
  [4509] = {.count = 1, .reusable = true}, SHIFT(1989),
  [4511] = {.count = 1, .reusable = true}, SHIFT(1990),
  [4513] = {.count = 1, .reusable = false}, SHIFT(1991),
  [4515] = {.count = 1, .reusable = true}, SHIFT(1994),
  [4517] = {.count = 1, .reusable = true}, SHIFT(1995),
  [4519] = {.count = 1, .reusable = true}, SHIFT(1999),
  [4521] = {.count = 1, .reusable = true}, SHIFT(1998),
  [4523] = {.count = 1, .reusable = false}, SHIFT(1999),
  [4525] = {.count = 1, .reusable = true}, SHIFT(2000),
  [4527] = {.count = 1, .reusable = false}, SHIFT(2001),
  [4529] = {.count = 1, .reusable = true}, SHIFT(2003),
  [4531] = {.count = 1, .reusable = true}, SHIFT(2002),
  [4533] = {.count = 1, .reusable = false}, SHIFT(2003),
  [4535] = {.count = 1, .reusable = true}, SHIFT(2004),
  [4537] = {.count = 1, .reusable = false}, SHIFT(2005),
  [4539] = {.count = 1, .reusable = false}, SHIFT(2006),
  [4541] = {.count = 1, .reusable = true}, SHIFT(2007),
  [4543] = {.count = 1, .reusable = true}, SHIFT(2006),
  [4545] = {.count = 1, .reusable = false}, SHIFT(2008),
  [4547] = {.count = 1, .reusable = true}, SHIFT(2009),
  [4549] = {.count = 1, .reusable = true}, SHIFT(2010),
  [4551] = {.count = 1, .reusable = false}, SHIFT(2011),
  [4553] = {.count = 1, .reusable = false}, SHIFT(2012),
  [4555] = {.count = 1, .reusable = true}, SHIFT(2013),
  [4557] = {.count = 1, .reusable = false}, SHIFT(2014),
  [4559] = {.count = 1, .reusable = true}, SHIFT(2014),
  [4561] = {.count = 1, .reusable = false}, SHIFT(2015),
  [4563] = {.count = 1, .reusable = false}, SHIFT(2016),
  [4565] = {.count = 1, .reusable = true}, SHIFT(2017),
  [4567] = {.count = 1, .reusable = false}, SHIFT(2017),
  [4569] = {.count = 1, .reusable = true}, SHIFT(2018),
  [4571] = {.count = 1, .reusable = true}, SHIFT(2019),
  [4573] = {.count = 1, .reusable = true}, SHIFT(2021),
  [4575] = {.count = 1, .reusable = true}, SHIFT(2023),
  [4577] = {.count = 1, .reusable = true}, SHIFT(2022),
  [4579] = {.count = 1, .reusable = false}, SHIFT(2023),
  [4581] = {.count = 1, .reusable = true}, SHIFT(2024),
  [4583] = {.count = 1, .reusable = true}, SHIFT(2025),
  [4585] = {.count = 1, .reusable = false}, SHIFT(2025),
  [4587] = {.count = 1, .reusable = true}, SHIFT(2026),
  [4589] = {.count = 1, .reusable = false}, SHIFT(2026),
  [4591] = {.count = 1, .reusable = true}, SHIFT(2028),
  [4593] = {.count = 1, .reusable = false}, SHIFT(2028),
  [4595] = {.count = 1, .reusable = true}, SHIFT(2029),
  [4597] = {.count = 1, .reusable = false}, SHIFT(2029),
  [4599] = {.count = 1, .reusable = true}, SHIFT(2030),
  [4601] = {.count = 1, .reusable = false}, SHIFT(2030),
  [4603] = {.count = 1, .reusable = true}, SHIFT(2031),
  [4605] = {.count = 1, .reusable = false}, SHIFT(2031),
  [4607] = {.count = 1, .reusable = true}, SHIFT(2032),
  [4609] = {.count = 1, .reusable = false}, SHIFT(2032),
  [4611] = {.count = 1, .reusable = true}, SHIFT(2033),
  [4613] = {.count = 1, .reusable = false}, SHIFT(2033),
  [4615] = {.count = 1, .reusable = true}, SHIFT(2034),
  [4617] = {.count = 1, .reusable = false}, SHIFT(2034),
  [4619] = {.count = 1, .reusable = true}, SHIFT(2035),
  [4621] = {.count = 1, .reusable = false}, SHIFT(2035),
  [4623] = {.count = 1, .reusable = true}, SHIFT(2036),
  [4625] = {.count = 1, .reusable = false}, SHIFT(2036),
  [4627] = {.count = 1, .reusable = true}, SHIFT(2037),
  [4629] = {.count = 1, .reusable = false}, SHIFT(2037),
  [4631] = {.count = 1, .reusable = true}, SHIFT(2038),
  [4633] = {.count = 1, .reusable = false}, SHIFT(2040),
  [4635] = {.count = 1, .reusable = true}, REDUCE(sym_case_statement, 3),
  [4637] = {.count = 1, .reusable = false}, REDUCE(sym_case_statement, 3),
  [4639] = {.count = 1, .reusable = true}, SHIFT(2041),
  [4641] = {.count = 1, .reusable = true}, SHIFT(2042),
  [4643] = {.count = 1, .reusable = true}, SHIFT(2043),
  [4645] = {.count = 1, .reusable = true}, SHIFT(2044),
  [4647] = {.count = 1, .reusable = false}, SHIFT(2044),
  [4649] = {.count = 1, .reusable = true}, SHIFT(2045),
  [4651] = {.count = 1, .reusable = true}, SHIFT(2046),
  [4653] = {.count = 1, .reusable = false}, SHIFT(2046),
  [4655] = {.count = 1, .reusable = true}, SHIFT(2047),
  [4657] = {.count = 1, .reusable = false}, SHIFT(2048),
  [4659] = {.count = 1, .reusable = false}, SHIFT(2049),
  [4661] = {.count = 1, .reusable = true}, SHIFT(2052),
  [4663] = {.count = 1, .reusable = false}, SHIFT(2052),
  [4665] = {.count = 1, .reusable = true}, SHIFT(2053),
  [4667] = {.count = 1, .reusable = true}, SHIFT(2055),
  [4669] = {.count = 1, .reusable = true}, SHIFT(2054),
  [4671] = {.count = 1, .reusable = false}, SHIFT(2055),
  [4673] = {.count = 1, .reusable = true}, SHIFT(2057),
  [4675] = {.count = 1, .reusable = true}, SHIFT(2058),
  [4677] = {.count = 1, .reusable = true}, SHIFT(2060),
  [4679] = {.count = 1, .reusable = true}, SHIFT(2062),
  [4681] = {.count = 1, .reusable = true}, SHIFT(2061),
  [4683] = {.count = 1, .reusable = false}, SHIFT(2062),
  [4685] = {.count = 1, .reusable = true}, SHIFT(2063),
  [4687] = {.count = 1, .reusable = false}, SHIFT(2064),
  [4689] = {.count = 1, .reusable = true}, SHIFT(2064),
  [4691] = {.count = 1, .reusable = true}, SHIFT(2065),
  [4693] = {.count = 1, .reusable = true}, SHIFT(2068),
  [4695] = {.count = 1, .reusable = true}, SHIFT(2069),
  [4697] = {.count = 1, .reusable = true}, REDUCE(sym_return_statement, 3),
  [4699] = {.count = 1, .reusable = false}, REDUCE(sym_return_statement, 3),
  [4701] = {.count = 1, .reusable = true}, REDUCE(sym_goto_statement, 3, .alias_sequence_id = 34),
  [4703] = {.count = 1, .reusable = false}, REDUCE(sym_goto_statement, 3, .alias_sequence_id = 34),
  [4705] = {.count = 1, .reusable = true}, SHIFT(2070),
  [4707] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenated_string_repeat1, 2), SHIFT_REPEAT(1506),
  [4710] = {.count = 1, .reusable = true}, REDUCE(sym_labeled_statement, 3, .alias_sequence_id = 35),
  [4712] = {.count = 1, .reusable = false}, REDUCE(sym_labeled_statement, 3, .alias_sequence_id = 35),
  [4714] = {.count = 1, .reusable = true}, SHIFT(2071),
  [4716] = {.count = 1, .reusable = true}, SHIFT(2072),
  [4718] = {.count = 1, .reusable = false}, SHIFT(2072),
  [4720] = {.count = 1, .reusable = true}, SHIFT(2073),
  [4722] = {.count = 1, .reusable = true}, SHIFT(2074),
  [4724] = {.count = 1, .reusable = false}, SHIFT(2074),
  [4726] = {.count = 1, .reusable = true}, SHIFT(2076),
  [4728] = {.count = 1, .reusable = true}, SHIFT(2077),
  [4730] = {.count = 1, .reusable = false}, SHIFT(2077),
  [4732] = {.count = 1, .reusable = true}, SHIFT(2079),
  [4734] = {.count = 1, .reusable = true}, REDUCE(sym_comma_expression, 3),
  [4736] = {.count = 1, .reusable = true}, SHIFT(2080),
  [4738] = {.count = 1, .reusable = true}, REDUCE(sym_scoped_field_identifier, 3, .alias_sequence_id = 36),
  [4740] = {.count = 1, .reusable = true}, REDUCE(sym_scoped_field_identifier, 3, .alias_sequence_id = 17),
  [4742] = {.count = 1, .reusable = true}, REDUCE(aux_sym_field_initializer_list_repeat1, 2),
  [4744] = {.count = 2, .reusable = true}, REDUCE(aux_sym_field_initializer_list_repeat1, 2), SHIFT_REPEAT(918),
  [4747] = {.count = 1, .reusable = true}, REDUCE(sym_scoped_field_identifier, 3, .alias_sequence_id = 33),
  [4749] = {.count = 1, .reusable = true}, REDUCE(sym_scoped_field_identifier, 3),
  [4751] = {.count = 1, .reusable = true}, REDUCE(aux_sym_preproc_params_repeat1, 2),
  [4753] = {.count = 1, .reusable = false}, REDUCE(sym_preproc_params, 4),
  [4755] = {.count = 2, .reusable = true}, REDUCE(aux_sym_preproc_params_repeat1, 2), SHIFT_REPEAT(924),
  [4758] = {.count = 2, .reusable = false}, REDUCE(aux_sym_sized_type_specifier_repeat1, 2), SHIFT_REPEAT(1550),
  [4761] = {.count = 1, .reusable = true}, SHIFT(2085),
  [4763] = {.count = 1, .reusable = true}, SHIFT(2086),
  [4765] = {.count = 1, .reusable = true}, SHIFT(2087),
  [4767] = {.count = 1, .reusable = true}, SHIFT(2088),
  [4769] = {.count = 1, .reusable = true}, SHIFT(2089),
  [4771] = {.count = 1, .reusable = false}, SHIFT(2090),
  [4773] = {.count = 1, .reusable = false}, SHIFT(2091),
  [4775] = {.count = 1, .reusable = false}, SHIFT(2092),
  [4777] = {.count = 1, .reusable = true}, SHIFT(2093),
  [4779] = {.count = 1, .reusable = false}, SHIFT(2093),
  [4781] = {.count = 1, .reusable = true}, SHIFT(2095),
  [4783] = {.count = 1, .reusable = false}, SHIFT(2095),
  [4785] = {.count = 1, .reusable = true}, SHIFT(2097),
  [4787] = {.count = 1, .reusable = false}, SHIFT(2097),
  [4789] = {.count = 1, .reusable = true}, SHIFT(2099),
  [4791] = {.count = 1, .reusable = true}, SHIFT(2100),
  [4793] = {.count = 1, .reusable = true}, SHIFT(2102),
  [4795] = {.count = 1, .reusable = true}, SHIFT(2103),
  [4797] = {.count = 1, .reusable = true}, SHIFT(2105),
  [4799] = {.count = 1, .reusable = true}, SHIFT(2106),
  [4801] = {.count = 1, .reusable = true}, SHIFT(2107),
  [4803] = {.count = 1, .reusable = true}, SHIFT(2108),
  [4805] = {.count = 1, .reusable = false}, SHIFT(2108),
  [4807] = {.count = 1, .reusable = true}, SHIFT(2110),
  [4809] = {.count = 1, .reusable = true}, SHIFT(2111),
  [4811] = {.count = 1, .reusable = false}, SHIFT(2111),
  [4813] = {.count = 1, .reusable = true}, SHIFT(2113),
  [4815] = {.count = 1, .reusable = true}, SHIFT(2114),
  [4817] = {.count = 1, .reusable = true}, REDUCE(sym_preproc_elif, 4, .alias_sequence_id = 22),
  [4819] = {.count = 1, .reusable = true}, SHIFT(2116),
  [4821] = {.count = 1, .reusable = true}, SHIFT(2117),
  [4823] = {.count = 1, .reusable = true}, SHIFT(2118),
  [4825] = {.count = 1, .reusable = true}, SHIFT(2119),
  [4827] = {.count = 1, .reusable = true}, SHIFT(2120),
  [4829] = {.count = 1, .reusable = true}, REDUCE(sym_array_type_declarator, 4),
  [4831] = {.count = 1, .reusable = true}, SHIFT(2121),
  [4833] = {.count = 2, .reusable = false}, REDUCE(aux_sym_sized_type_specifier_repeat1, 2), SHIFT_REPEAT(1627),
  [4836] = {.count = 1, .reusable = true}, REDUCE(sym_enumerator_list, 5),
  [4838] = {.count = 1, .reusable = false}, REDUCE(sym_enumerator_list, 5),
  [4840] = {.count = 1, .reusable = true}, REDUCE(sym_preproc_else_in_field_declaration_list, 2, .alias_sequence_id = 8),
  [4842] = {.count = 1, .reusable = true}, REDUCE(sym_preproc_elif_in_field_declaration_list, 2, .alias_sequence_id = 22),
  [4844] = {.count = 1, .reusable = true}, REDUCE(sym_preproc_if_in_field_declaration_list, 4, .alias_sequence_id = 37),
  [4846] = {.count = 1, .reusable = false}, REDUCE(sym_preproc_if_in_field_declaration_list, 4, .alias_sequence_id = 37),
  [4848] = {.count = 1, .reusable = true}, REDUCE(sym_preproc_if_in_field_declaration_list, 4, .alias_sequence_id = 38),
  [4850] = {.count = 1, .reusable = false}, REDUCE(sym_preproc_if_in_field_declaration_list, 4, .alias_sequence_id = 38),
  [4852] = {.count = 1, .reusable = true}, REDUCE(sym_preproc_if_in_field_declaration_list, 4, .alias_sequence_id = 23),
  [4854] = {.count = 1, .reusable = false}, REDUCE(sym_preproc_if_in_field_declaration_list, 4, .alias_sequence_id = 23),
  [4856] = {.count = 1, .reusable = true}, SHIFT(2130),
  [4858] = {.count = 1, .reusable = true}, SHIFT(2131),
  [4860] = {.count = 1, .reusable = true}, REDUCE(sym_preproc_ifdef_in_field_declaration_list, 4, .alias_sequence_id = 39),
  [4862] = {.count = 1, .reusable = false}, REDUCE(sym_preproc_ifdef_in_field_declaration_list, 4, .alias_sequence_id = 39),
  [4864] = {.count = 1, .reusable = true}, REDUCE(sym_preproc_ifdef_in_field_declaration_list, 4, .alias_sequence_id = 40),
  [4866] = {.count = 1, .reusable = false}, REDUCE(sym_preproc_ifdef_in_field_declaration_list, 4, .alias_sequence_id = 40),
  [4868] = {.count = 1, .reusable = true}, REDUCE(sym_preproc_ifdef_in_field_declaration_list, 4, .alias_sequence_id = 24),
  [4870] = {.count = 1, .reusable = false}, REDUCE(sym_preproc_ifdef_in_field_declaration_list, 4, .alias_sequence_id = 24),
  [4872] = {.count = 1, .reusable = true}, SHIFT(2132),
  [4874] = {.count = 1, .reusable = true}, SHIFT(2133),
  [4876] = {.count = 1, .reusable = true}, REDUCE(sym_preproc_ifdef_in_field_declaration_list, 4, .alias_sequence_id = 41),
  [4878] = {.count = 1, .reusable = false}, REDUCE(sym_preproc_ifdef_in_field_declaration_list, 4, .alias_sequence_id = 41),
  [4880] = {.count = 1, .reusable = true}, REDUCE(sym_preproc_ifdef_in_field_declaration_list, 4, .alias_sequence_id = 42),
  [4882] = {.count = 1, .reusable = false}, REDUCE(sym_preproc_ifdef_in_field_declaration_list, 4, .alias_sequence_id = 42),
  [4884] = {.count = 1, .reusable = true}, REDUCE(sym_preproc_ifdef_in_field_declaration_list, 4, .alias_sequence_id = 25),
  [4886] = {.count = 1, .reusable = false}, REDUCE(sym_preproc_ifdef_in_field_declaration_list, 4, .alias_sequence_id = 25),
  [4888] = {.count = 1, .reusable = true}, SHIFT(2134),
  [4890] = {.count = 1, .reusable = true}, SHIFT(2135),
  [4892] = {.count = 1, .reusable = true}, SHIFT(2136),
  [4894] = {.count = 1, .reusable = true}, SHIFT(2137),
  [4896] = {.count = 1, .reusable = true}, SHIFT(2138),
  [4898] = {.count = 1, .reusable = true}, SHIFT(2139),
  [4900] = {.count = 1, .reusable = true}, REDUCE(sym__field_declarator, 3),
  [4902] = {.count = 1, .reusable = true}, SHIFT(2140),
  [4904] = {.count = 1, .reusable = true}, REDUCE(sym_field_declaration, 4),
  [4906] = {.count = 1, .reusable = false}, REDUCE(sym_field_declaration, 4),
  [4908] = {.count = 2, .reusable = true}, REDUCE(sym_scoped_field_identifier, 3, .alias_sequence_id = 36), REDUCE(sym_scoped_type_identifier, 3, .alias_sequence_id = 18),
  [4911] = {.count = 1, .reusable = true}, SHIFT(2141),
  [4913] = {.count = 1, .reusable = true}, SHIFT(2142),
  [4915] = {.count = 1, .reusable = true}, REDUCE(aux_sym_field_declaration_repeat1, 2),
  [4917] = {.count = 1, .reusable = true}, REDUCE(sym_array_field_declarator, 3),
  [4919] = {.count = 1, .reusable = true}, SHIFT(2145),
  [4921] = {.count = 1, .reusable = true}, SHIFT(2144),
  [4923] = {.count = 1, .reusable = false}, SHIFT(2145),
  [4925] = {.count = 1, .reusable = true}, SHIFT(2146),
  [4927] = {.count = 1, .reusable = false}, SHIFT(2149),
  [4929] = {.count = 1, .reusable = false}, SHIFT(2148),
  [4931] = {.count = 1, .reusable = false}, SHIFT(2147),
  [4933] = {.count = 1, .reusable = true}, REDUCE(sym_function_field_declarator, 3),
  [4935] = {.count = 1, .reusable = true}, SHIFT(2150),
  [4937] = {.count = 1, .reusable = true}, SHIFT(2151),
  [4939] = {.count = 1, .reusable = false}, SHIFT(2151),
  [4941] = {.count = 2, .reusable = true}, REDUCE(aux_sym_field_declaration_repeat1, 2), SHIFT_REPEAT(1069),
  [4944] = {.count = 2, .reusable = true}, REDUCE(sym_scoped_field_identifier, 3, .alias_sequence_id = 33), REDUCE(sym_scoped_type_identifier, 3, .alias_sequence_id = 20),
  [4947] = {.count = 1, .reusable = true}, SHIFT(2152),
  [4949] = {.count = 1, .reusable = true}, SHIFT(2154),
  [4951] = {.count = 1, .reusable = false}, SHIFT(2155),
  [4953] = {.count = 1, .reusable = true}, SHIFT(2155),
  [4955] = {.count = 1, .reusable = false}, SHIFT(2158),
  [4957] = {.count = 2, .reusable = true}, REDUCE(aux_sym_function_declarator_repeat1, 2), SHIFT_REPEAT(1079),
  [4960] = {.count = 2, .reusable = true}, REDUCE(aux_sym_function_declarator_repeat1, 2), SHIFT_REPEAT(1680),
  [4963] = {.count = 1, .reusable = true}, REDUCE(aux_sym_base_class_clause_repeat1, 3),
  [4965] = {.count = 1, .reusable = true}, SHIFT(2159),
  [4967] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenated_string_repeat1, 2), SHIFT_REPEAT(1686),
  [4970] = {.count = 1, .reusable = true}, SHIFT(2160),
  [4972] = {.count = 1, .reusable = true}, SHIFT(2161),
  [4974] = {.count = 1, .reusable = false}, SHIFT(2161),
  [4976] = {.count = 1, .reusable = true}, SHIFT(2162),
  [4978] = {.count = 1, .reusable = true}, REDUCE(sym__abstract_declarator, 3),
  [4980] = {.count = 1, .reusable = false}, REDUCE(sym__abstract_declarator, 3),
  [4982] = {.count = 1, .reusable = true}, SHIFT(2163),
  [4984] = {.count = 1, .reusable = false}, SHIFT(2164),
  [4986] = {.count = 1, .reusable = true}, SHIFT(2165),
  [4988] = {.count = 1, .reusable = true}, REDUCE(sym_abstract_array_declarator, 3),
  [4990] = {.count = 1, .reusable = false}, REDUCE(sym_abstract_array_declarator, 3),
  [4992] = {.count = 1, .reusable = true}, SHIFT(2166),
  [4994] = {.count = 1, .reusable = true}, SHIFT(2167),
  [4996] = {.count = 1, .reusable = false}, SHIFT(2167),
  [4998] = {.count = 1, .reusable = true}, REDUCE(sym_abstract_function_declarator, 3),
  [5000] = {.count = 1, .reusable = false}, REDUCE(sym_abstract_function_declarator, 3),
  [5002] = {.count = 1, .reusable = true}, REDUCE(aux_sym_abstract_function_declarator_repeat1, 2),
  [5004] = {.count = 2, .reusable = false}, REDUCE(aux_sym_abstract_function_declarator_repeat1, 2), SHIFT_REPEAT(376),
  [5007] = {.count = 2, .reusable = true}, REDUCE(aux_sym_abstract_function_declarator_repeat1, 2), SHIFT_REPEAT(376),
  [5010] = {.count = 2, .reusable = true}, REDUCE(aux_sym_abstract_function_declarator_repeat1, 2), SHIFT_REPEAT(1716),
  [5013] = {.count = 1, .reusable = true}, REDUCE(sym_optional_type_parameter_declaration, 4, .alias_sequence_id = 4),
  [5015] = {.count = 1, .reusable = false}, SHIFT(2170),
  [5017] = {.count = 1, .reusable = true}, SHIFT(2171),
  [5019] = {.count = 1, .reusable = true}, SHIFT(2173),
  [5021] = {.count = 1, .reusable = true}, SHIFT(2174),
  [5023] = {.count = 1, .reusable = true}, SHIFT(2178),
  [5025] = {.count = 1, .reusable = true}, SHIFT(2177),
  [5027] = {.count = 1, .reusable = false}, SHIFT(2178),
  [5029] = {.count = 1, .reusable = true}, SHIFT(2179),
  [5031] = {.count = 1, .reusable = false}, SHIFT(2180),
  [5033] = {.count = 1, .reusable = true}, SHIFT(2182),
  [5035] = {.count = 1, .reusable = true}, SHIFT(2181),
  [5037] = {.count = 1, .reusable = false}, SHIFT(2182),
  [5039] = {.count = 1, .reusable = false}, SHIFT(2183),
  [5041] = {.count = 1, .reusable = false}, SHIFT(2184),
  [5043] = {.count = 1, .reusable = true}, SHIFT(2185),
  [5045] = {.count = 1, .reusable = true}, SHIFT(2184),
  [5047] = {.count = 1, .reusable = false}, SHIFT(2186),
  [5049] = {.count = 1, .reusable = true}, SHIFT(2187),
  [5051] = {.count = 1, .reusable = true}, SHIFT(2188),
  [5053] = {.count = 1, .reusable = false}, SHIFT(2189),
  [5055] = {.count = 1, .reusable = false}, SHIFT(2190),
  [5057] = {.count = 1, .reusable = true}, SHIFT(2191),
  [5059] = {.count = 1, .reusable = false}, SHIFT(2192),
  [5061] = {.count = 1, .reusable = true}, SHIFT(2192),
  [5063] = {.count = 1, .reusable = false}, SHIFT(2193),
  [5065] = {.count = 1, .reusable = false}, SHIFT(2194),
  [5067] = {.count = 1, .reusable = false}, SHIFT(2197),
  [5069] = {.count = 1, .reusable = false}, SHIFT(2196),
  [5071] = {.count = 1, .reusable = false}, SHIFT(2195),
  [5073] = {.count = 1, .reusable = true}, SHIFT(2198),
  [5075] = {.count = 2, .reusable = false}, REDUCE(aux_sym_sized_type_specifier_repeat1, 2), SHIFT_REPEAT(1744),
  [5078] = {.count = 1, .reusable = true}, SHIFT(2203),
  [5080] = {.count = 1, .reusable = false}, SHIFT(2204),
  [5082] = {.count = 1, .reusable = true}, SHIFT(2205),
  [5084] = {.count = 1, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2),
  [5086] = {.count = 1, .reusable = true}, REDUCE(sym_argument_list, 4, .dynamic_precedence = 1),
  [5088] = {.count = 1, .reusable = false}, REDUCE(sym_argument_list, 4, .dynamic_precedence = 1),
  [5090] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(1172),
  [5093] = {.count = 1, .reusable = true}, REDUCE(sym_subscript_designator, 3),
  [5095] = {.count = 1, .reusable = true}, SHIFT(2206),
  [5097] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenated_string_repeat1, 2), SHIFT_REPEAT(1760),
  [5100] = {.count = 1, .reusable = true}, SHIFT(2207),
  [5102] = {.count = 1, .reusable = true}, SHIFT(2208),
  [5104] = {.count = 1, .reusable = false}, SHIFT(2208),
  [5106] = {.count = 1, .reusable = true}, REDUCE(sym_initializer_list, 4),
  [5108] = {.count = 1, .reusable = false}, REDUCE(sym_initializer_list, 4),
  [5110] = {.count = 2, .reusable = true}, REDUCE(aux_sym_initializer_list_repeat1, 2), SHIFT(897),
  [5113] = {.count = 1, .reusable = true}, REDUCE(aux_sym_initializer_list_repeat1, 2),
  [5115] = {.count = 1, .reusable = true}, SHIFT(2209),
  [5117] = {.count = 1, .reusable = true}, SHIFT(2210),
  [5119] = {.count = 2, .reusable = true}, REDUCE(aux_sym_initializer_list_repeat1, 2), SHIFT_REPEAT(2211),
  [5122] = {.count = 1, .reusable = true}, SHIFT(2212),
  [5124] = {.count = 1, .reusable = true}, REDUCE(sym_initializer_pair, 3),
  [5126] = {.count = 2, .reusable = false}, REDUCE(aux_sym_sized_type_specifier_repeat1, 2), SHIFT_REPEAT(1791),
  [5129] = {.count = 1, .reusable = true}, SHIFT(2217),
  [5131] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenated_string_repeat1, 2), SHIFT_REPEAT(1794),
  [5134] = {.count = 1, .reusable = true}, SHIFT(2218),
  [5136] = {.count = 1, .reusable = true}, SHIFT(2219),
  [5138] = {.count = 1, .reusable = false}, SHIFT(2219),
  [5140] = {.count = 1, .reusable = true}, SHIFT(2220),
  [5142] = {.count = 1, .reusable = true}, SHIFT(2221),
  [5144] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenated_string_repeat1, 2), SHIFT_REPEAT(1811),
  [5147] = {.count = 1, .reusable = true}, SHIFT(2222),
  [5149] = {.count = 1, .reusable = true}, SHIFT(2223),
  [5151] = {.count = 1, .reusable = false}, SHIFT(2223),
  [5153] = {.count = 1, .reusable = true}, SHIFT(2224),
  [5155] = {.count = 1, .reusable = false}, SHIFT(2227),
  [5157] = {.count = 1, .reusable = false}, SHIFT(2226),
  [5159] = {.count = 1, .reusable = false}, SHIFT(2225),
  [5161] = {.count = 1, .reusable = true}, SHIFT(2228),
  [5163] = {.count = 1, .reusable = true}, SHIFT(2229),
  [5165] = {.count = 1, .reusable = false}, SHIFT(2230),
  [5167] = {.count = 1, .reusable = true}, SHIFT(2230),
  [5169] = {.count = 1, .reusable = false}, SHIFT(2232),
  [5171] = {.count = 2, .reusable = true}, REDUCE(aux_sym_abstract_function_declarator_repeat1, 2), SHIFT_REPEAT(1833),
  [5174] = {.count = 1, .reusable = true}, REDUCE(sym_cast_expression, 4),
  [5176] = {.count = 1, .reusable = false}, REDUCE(sym_cast_expression, 4),
  [5178] = {.count = 1, .reusable = true}, REDUCE(sym_compound_literal_expression, 4),
  [5180] = {.count = 1, .reusable = false}, REDUCE(sym_compound_literal_expression, 4),
  [5182] = {.count = 1, .reusable = true}, SHIFT(2233),
  [5184] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenated_string_repeat1, 2), SHIFT_REPEAT(1839),
  [5187] = {.count = 1, .reusable = true}, SHIFT(2234),
  [5189] = {.count = 1, .reusable = true}, SHIFT(2235),
  [5191] = {.count = 1, .reusable = false}, SHIFT(2235),
  [5193] = {.count = 1, .reusable = true}, REDUCE(aux_sym_for_statement_repeat1, 2),
  [5195] = {.count = 1, .reusable = true}, SHIFT(2236),
  [5197] = {.count = 1, .reusable = true}, REDUCE(sym_lambda_capture_specifier, 4),
  [5199] = {.count = 1, .reusable = false}, REDUCE(sym_lambda_capture_specifier, 4),
  [5201] = {.count = 2, .reusable = true}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(1279),
  [5204] = {.count = 1, .reusable = true}, SHIFT(2237),
  [5206] = {.count = 1, .reusable = true}, SHIFT(2238),
  [5208] = {.count = 1, .reusable = false}, SHIFT(349),
  [5210] = {.count = 1, .reusable = true}, REDUCE(sym_sizeof_expression, 4),
  [5212] = {.count = 1, .reusable = false}, REDUCE(sym_sizeof_expression, 4),
  [5214] = {.count = 1, .reusable = false}, SHIFT(355),
  [5216] = {.count = 1, .reusable = true}, SHIFT(2239),
  [5218] = {.count = 1, .reusable = true}, SHIFT(2240),
  [5220] = {.count = 1, .reusable = true}, REDUCE(sym_new_expression, 4, .alias_sequence_id = 4),
  [5222] = {.count = 1, .reusable = false}, REDUCE(sym_new_expression, 4, .alias_sequence_id = 4),
  [5224] = {.count = 1, .reusable = true}, REDUCE(sym_new_expression, 4, .alias_sequence_id = 20),
  [5226] = {.count = 1, .reusable = false}, REDUCE(sym_new_expression, 4, .alias_sequence_id = 20),
  [5228] = {.count = 1, .reusable = true}, REDUCE(sym_new_expression, 4),
  [5230] = {.count = 1, .reusable = false}, REDUCE(sym_new_expression, 4),
  [5232] = {.count = 1, .reusable = true}, SHIFT(2243),
  [5234] = {.count = 1, .reusable = false}, SHIFT(2243),
  [5236] = {.count = 1, .reusable = true}, REDUCE(sym_delete_expression, 4),
  [5238] = {.count = 1, .reusable = false}, REDUCE(sym_delete_expression, 4),
  [5240] = {.count = 1, .reusable = true}, REDUCE(sym_subscript_expression, 4),
  [5242] = {.count = 1, .reusable = false}, REDUCE(sym_subscript_expression, 4),
  [5244] = {.count = 1, .reusable = true}, SHIFT(2244),
  [5246] = {.count = 1, .reusable = false}, SHIFT(2244),
  [5248] = {.count = 1, .reusable = true}, SHIFT(2245),
  [5250] = {.count = 1, .reusable = false}, SHIFT(2248),
  [5252] = {.count = 1, .reusable = false}, SHIFT(2247),
  [5254] = {.count = 1, .reusable = false}, SHIFT(2246),
  [5256] = {.count = 1, .reusable = true}, SHIFT(2249),
  [5258] = {.count = 1, .reusable = true}, SHIFT(2250),
  [5260] = {.count = 1, .reusable = true}, SHIFT(2254),
  [5262] = {.count = 1, .reusable = false}, SHIFT(2255),
  [5264] = {.count = 1, .reusable = true}, SHIFT(2255),
  [5266] = {.count = 1, .reusable = false}, SHIFT(2257),
  [5268] = {.count = 2, .reusable = true}, REDUCE(aux_sym_abstract_function_declarator_repeat1, 2), SHIFT_REPEAT(1890),
  [5271] = {.count = 1, .reusable = true}, SHIFT(2258),
  [5273] = {.count = 1, .reusable = true}, SHIFT(2259),
  [5275] = {.count = 1, .reusable = true}, SHIFT(2260),
  [5277] = {.count = 1, .reusable = true}, SHIFT(2261),
  [5279] = {.count = 1, .reusable = true}, SHIFT(2263),
  [5281] = {.count = 1, .reusable = true}, SHIFT(2266),
  [5283] = {.count = 1, .reusable = false}, REDUCE(sym_abstract_pointer_declarator, 2),
  [5285] = {.count = 1, .reusable = false}, REDUCE(sym_abstract_reference_declarator, 2),
  [5287] = {.count = 1, .reusable = true}, SHIFT(2270),
  [5289] = {.count = 1, .reusable = true}, SHIFT(2271),
  [5291] = {.count = 1, .reusable = true}, SHIFT(2272),
  [5293] = {.count = 1, .reusable = false}, SHIFT(2273),
  [5295] = {.count = 1, .reusable = false}, SHIFT(2274),
  [5297] = {.count = 1, .reusable = false}, SHIFT(2276),
  [5299] = {.count = 1, .reusable = false}, SHIFT(2280),
  [5301] = {.count = 1, .reusable = false}, SHIFT(2284),
  [5303] = {.count = 1, .reusable = true}, SHIFT(2288),
  [5305] = {.count = 1, .reusable = true}, SHIFT(2289),
  [5307] = {.count = 1, .reusable = false}, SHIFT(2290),
  [5309] = {.count = 1, .reusable = true}, SHIFT(2291),
  [5311] = {.count = 1, .reusable = true}, SHIFT(2292),
  [5313] = {.count = 1, .reusable = false}, SHIFT(2293),
  [5315] = {.count = 1, .reusable = false}, SHIFT(2294),
  [5317] = {.count = 1, .reusable = false}, SHIFT(2295),
  [5319] = {.count = 1, .reusable = true}, SHIFT(2297),
  [5321] = {.count = 1, .reusable = true}, SHIFT(2299),
  [5323] = {.count = 1, .reusable = true}, SHIFT(2300),
  [5325] = {.count = 1, .reusable = true}, SHIFT(2301),
  [5327] = {.count = 1, .reusable = true}, SHIFT(2302),
  [5329] = {.count = 1, .reusable = false}, SHIFT(2302),
  [5331] = {.count = 1, .reusable = true}, SHIFT(2303),
  [5333] = {.count = 1, .reusable = true}, SHIFT(2304),
  [5335] = {.count = 1, .reusable = true}, SHIFT(2306),
  [5337] = {.count = 1, .reusable = true}, SHIFT(2308),
  [5339] = {.count = 1, .reusable = true}, SHIFT(2307),
  [5341] = {.count = 1, .reusable = false}, SHIFT(2308),
  [5343] = {.count = 1, .reusable = true}, SHIFT(2310),
  [5345] = {.count = 1, .reusable = true}, SHIFT(2311),
  [5347] = {.count = 1, .reusable = true}, SHIFT(2312),
  [5349] = {.count = 1, .reusable = false}, SHIFT(2313),
  [5351] = {.count = 1, .reusable = true}, SHIFT(2314),
  [5353] = {.count = 1, .reusable = true}, SHIFT(2315),
  [5355] = {.count = 1, .reusable = true}, SHIFT(2319),
  [5357] = {.count = 1, .reusable = false}, REDUCE(sym_preproc_else_in_compound_statement, 2, .alias_sequence_id = 8),
  [5359] = {.count = 1, .reusable = false}, REDUCE(sym_preproc_elif_in_compound_statement, 2, .alias_sequence_id = 22),
  [5361] = {.count = 1, .reusable = false}, SHIFT(2324),
  [5363] = {.count = 1, .reusable = false}, SHIFT(2326),
  [5365] = {.count = 1, .reusable = true}, SHIFT(2327),
  [5367] = {.count = 1, .reusable = true}, SHIFT(2328),
  [5369] = {.count = 1, .reusable = false}, SHIFT(2328),
  [5371] = {.count = 1, .reusable = true}, SHIFT(2329),
  [5373] = {.count = 1, .reusable = true}, SHIFT(2330),
  [5375] = {.count = 1, .reusable = false}, SHIFT(2330),
  [5377] = {.count = 1, .reusable = true}, SHIFT(2331),
  [5379] = {.count = 1, .reusable = false}, SHIFT(2332),
  [5381] = {.count = 1, .reusable = true}, SHIFT(2335),
  [5383] = {.count = 1, .reusable = false}, SHIFT(2335),
  [5385] = {.count = 1, .reusable = true}, SHIFT(2336),
  [5387] = {.count = 1, .reusable = true}, SHIFT(2338),
  [5389] = {.count = 1, .reusable = true}, SHIFT(2337),
  [5391] = {.count = 1, .reusable = false}, SHIFT(2338),
  [5393] = {.count = 1, .reusable = true}, SHIFT(2340),
  [5395] = {.count = 1, .reusable = true}, SHIFT(2341),
  [5397] = {.count = 1, .reusable = false}, SHIFT(2342),
  [5399] = {.count = 1, .reusable = true}, REDUCE(sym_preproc_if_in_compound_statement, 4, .alias_sequence_id = 37),
  [5401] = {.count = 1, .reusable = false}, REDUCE(sym_preproc_if_in_compound_statement, 4, .alias_sequence_id = 37),
  [5403] = {.count = 1, .reusable = true}, REDUCE(sym_preproc_if_in_compound_statement, 4, .alias_sequence_id = 38),
  [5405] = {.count = 1, .reusable = false}, REDUCE(sym_preproc_if_in_compound_statement, 4, .alias_sequence_id = 38),
  [5407] = {.count = 1, .reusable = true}, SHIFT(2344),
  [5409] = {.count = 1, .reusable = true}, SHIFT(2346),
  [5411] = {.count = 1, .reusable = true}, SHIFT(2348),
  [5413] = {.count = 1, .reusable = true}, REDUCE(sym_preproc_if_in_compound_statement, 4, .alias_sequence_id = 23),
  [5415] = {.count = 1, .reusable = false}, REDUCE(sym_preproc_if_in_compound_statement, 4, .alias_sequence_id = 23),
  [5417] = {.count = 1, .reusable = true}, SHIFT(2350),
  [5419] = {.count = 1, .reusable = true}, SHIFT(2351),
  [5421] = {.count = 2, .reusable = true}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(1419),
  [5424] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(1390),
  [5427] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(1391),
  [5430] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(1392),
  [5433] = {.count = 1, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2),
  [5435] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(1394),
  [5438] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(1395),
  [5441] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(1398),
  [5444] = {.count = 2, .reusable = true}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(1399),
  [5447] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(1400),
  [5450] = {.count = 2, .reusable = true}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(1401),
  [5453] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(1402),
  [5456] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(1403),
  [5459] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(1404),
  [5462] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(1405),
  [5465] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(1406),
  [5468] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(1407),
  [5471] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(1408),
  [5474] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(1409),
  [5477] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(1410),
  [5480] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(1411),
  [5483] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(1412),
  [5486] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(1419),
  [5489] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(1413),
  [5492] = {.count = 1, .reusable = true}, REDUCE(sym_preproc_ifdef_in_compound_statement, 4, .alias_sequence_id = 39),
  [5494] = {.count = 1, .reusable = false}, REDUCE(sym_preproc_ifdef_in_compound_statement, 4, .alias_sequence_id = 39),
  [5496] = {.count = 1, .reusable = true}, REDUCE(sym_preproc_ifdef_in_compound_statement, 4, .alias_sequence_id = 40),
  [5498] = {.count = 1, .reusable = false}, REDUCE(sym_preproc_ifdef_in_compound_statement, 4, .alias_sequence_id = 40),
  [5500] = {.count = 1, .reusable = true}, REDUCE(sym_preproc_ifdef_in_compound_statement, 4, .alias_sequence_id = 24),
  [5502] = {.count = 1, .reusable = false}, REDUCE(sym_preproc_ifdef_in_compound_statement, 4, .alias_sequence_id = 24),
  [5504] = {.count = 1, .reusable = true}, SHIFT(2352),
  [5506] = {.count = 1, .reusable = true}, SHIFT(2353),
  [5508] = {.count = 1, .reusable = true}, REDUCE(sym_preproc_ifdef_in_compound_statement, 4, .alias_sequence_id = 41),
  [5510] = {.count = 1, .reusable = false}, REDUCE(sym_preproc_ifdef_in_compound_statement, 4, .alias_sequence_id = 41),
  [5512] = {.count = 1, .reusable = true}, REDUCE(sym_preproc_ifdef_in_compound_statement, 4, .alias_sequence_id = 42),
  [5514] = {.count = 1, .reusable = false}, REDUCE(sym_preproc_ifdef_in_compound_statement, 4, .alias_sequence_id = 42),
  [5516] = {.count = 1, .reusable = true}, REDUCE(sym_preproc_ifdef_in_compound_statement, 4, .alias_sequence_id = 25),
  [5518] = {.count = 1, .reusable = false}, REDUCE(sym_preproc_ifdef_in_compound_statement, 4, .alias_sequence_id = 25),
  [5520] = {.count = 1, .reusable = true}, SHIFT(2354),
  [5522] = {.count = 1, .reusable = true}, SHIFT(2355),
  [5524] = {.count = 1, .reusable = true}, SHIFT(2356),
  [5526] = {.count = 1, .reusable = true}, SHIFT(2357),
  [5528] = {.count = 1, .reusable = true}, SHIFT(2359),
  [5530] = {.count = 1, .reusable = true}, SHIFT(2361),
  [5532] = {.count = 1, .reusable = true}, SHIFT(2360),
  [5534] = {.count = 1, .reusable = false}, SHIFT(2361),
  [5536] = {.count = 1, .reusable = true}, SHIFT(2362),
  [5538] = {.count = 1, .reusable = true}, SHIFT(2378),
  [5540] = {.count = 1, .reusable = true}, SHIFT(2363),
  [5542] = {.count = 1, .reusable = true}, SHIFT(2364),
  [5544] = {.count = 1, .reusable = false}, SHIFT(2365),
  [5546] = {.count = 1, .reusable = false}, SHIFT(2366),
  [5548] = {.count = 1, .reusable = false}, SHIFT(2367),
  [5550] = {.count = 1, .reusable = false}, SHIFT(2368),
  [5552] = {.count = 1, .reusable = false}, SHIFT(2369),
  [5554] = {.count = 1, .reusable = false}, SHIFT(2370),
  [5556] = {.count = 1, .reusable = false}, SHIFT(2371),
  [5558] = {.count = 1, .reusable = false}, SHIFT(2372),
  [5560] = {.count = 1, .reusable = false}, SHIFT(2373),
  [5562] = {.count = 1, .reusable = false}, SHIFT(2374),
  [5564] = {.count = 1, .reusable = false}, SHIFT(2375),
  [5566] = {.count = 1, .reusable = false}, SHIFT(2378),
  [5568] = {.count = 1, .reusable = false}, SHIFT(2376),
  [5570] = {.count = 1, .reusable = true}, SHIFT(2380),
  [5572] = {.count = 1, .reusable = false}, SHIFT(2380),
  [5574] = {.count = 1, .reusable = true}, SHIFT(2381),
  [5576] = {.count = 1, .reusable = false}, SHIFT(2381),
  [5578] = {.count = 1, .reusable = true}, SHIFT(2382),
  [5580] = {.count = 1, .reusable = false}, SHIFT(2382),
  [5582] = {.count = 1, .reusable = true}, SHIFT(2383),
  [5584] = {.count = 1, .reusable = false}, SHIFT(2383),
  [5586] = {.count = 1, .reusable = true}, SHIFT(2384),
  [5588] = {.count = 1, .reusable = false}, SHIFT(2384),
  [5590] = {.count = 1, .reusable = true}, SHIFT(2385),
  [5592] = {.count = 1, .reusable = false}, SHIFT(2385),
  [5594] = {.count = 1, .reusable = true}, SHIFT(2386),
  [5596] = {.count = 1, .reusable = false}, SHIFT(2386),
  [5598] = {.count = 1, .reusable = true}, SHIFT(2387),
  [5600] = {.count = 1, .reusable = false}, SHIFT(2387),
  [5602] = {.count = 1, .reusable = true}, SHIFT(2388),
  [5604] = {.count = 1, .reusable = false}, SHIFT(2388),
  [5606] = {.count = 1, .reusable = true}, SHIFT(2389),
  [5608] = {.count = 1, .reusable = false}, SHIFT(2389),
  [5610] = {.count = 1, .reusable = true}, SHIFT(2390),
  [5612] = {.count = 1, .reusable = false}, SHIFT(2390),
  [5614] = {.count = 1, .reusable = true}, SHIFT(2391),
  [5616] = {.count = 1, .reusable = true}, SHIFT(2393),
  [5618] = {.count = 1, .reusable = false}, SHIFT(2393),
  [5620] = {.count = 1, .reusable = true}, SHIFT(2394),
  [5622] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenated_string_repeat1, 2), SHIFT_REPEAT(2021),
  [5625] = {.count = 1, .reusable = true}, SHIFT(2395),
  [5627] = {.count = 1, .reusable = true}, SHIFT(2396),
  [5629] = {.count = 1, .reusable = false}, SHIFT(2396),
  [5631] = {.count = 1, .reusable = true}, REDUCE(sym_case_statement, 4),
  [5633] = {.count = 1, .reusable = false}, REDUCE(sym_case_statement, 4),
  [5635] = {.count = 1, .reusable = true}, SHIFT(2397),
  [5637] = {.count = 1, .reusable = false}, SHIFT(2398),
  [5639] = {.count = 1, .reusable = false}, SHIFT(2399),
  [5641] = {.count = 1, .reusable = true}, SHIFT(2401),
  [5643] = {.count = 1, .reusable = true}, SHIFT(2402),
  [5645] = {.count = 1, .reusable = false}, SHIFT(2402),
  [5647] = {.count = 1, .reusable = true}, SHIFT(2403),
  [5649] = {.count = 1, .reusable = false}, SHIFT(2405),
  [5651] = {.count = 1, .reusable = true}, SHIFT(2407),
  [5653] = {.count = 1, .reusable = true}, SHIFT(2409),
  [5655] = {.count = 1, .reusable = true}, SHIFT(2410),
  [5657] = {.count = 1, .reusable = true}, SHIFT(2412),
  [5659] = {.count = 1, .reusable = true}, SHIFT(2411),
  [5661] = {.count = 1, .reusable = false}, SHIFT(2412),
  [5663] = {.count = 1, .reusable = true}, SHIFT(2413),
  [5665] = {.count = 1, .reusable = true}, SHIFT(2414),
  [5667] = {.count = 1, .reusable = true}, SHIFT(2415),
  [5669] = {.count = 1, .reusable = false}, SHIFT(2415),
  [5671] = {.count = 1, .reusable = true}, SHIFT(2417),
  [5673] = {.count = 1, .reusable = true}, SHIFT(2416),
  [5675] = {.count = 1, .reusable = false}, SHIFT(2417),
  [5677] = {.count = 1, .reusable = true}, SHIFT(2418),
  [5679] = {.count = 1, .reusable = true}, SHIFT(2419),
  [5681] = {.count = 1, .reusable = true}, SHIFT(2420),
  [5683] = {.count = 1, .reusable = true}, SHIFT(2421),
  [5685] = {.count = 1, .reusable = true}, REDUCE(sym_for_range_declaration, 2),
  [5687] = {.count = 1, .reusable = true}, SHIFT(2424),
  [5689] = {.count = 1, .reusable = false}, SHIFT(2424),
  [5691] = {.count = 1, .reusable = true}, SHIFT(2425),
  [5693] = {.count = 1, .reusable = false}, SHIFT(2425),
  [5695] = {.count = 1, .reusable = false}, SHIFT(390),
  [5697] = {.count = 1, .reusable = false}, SHIFT(402),
  [5699] = {.count = 1, .reusable = true}, SHIFT(2426),
  [5701] = {.count = 1, .reusable = false}, SHIFT(2426),
  [5703] = {.count = 1, .reusable = true}, SHIFT(2427),
  [5705] = {.count = 1, .reusable = true}, SHIFT(2428),
  [5707] = {.count = 1, .reusable = true}, SHIFT(2429),
  [5709] = {.count = 1, .reusable = false}, SHIFT(2429),
  [5711] = {.count = 1, .reusable = true}, SHIFT(2431),
  [5713] = {.count = 1, .reusable = true}, SHIFT(2432),
  [5715] = {.count = 1, .reusable = true}, SHIFT(2433),
  [5717] = {.count = 1, .reusable = true}, SHIFT(2434),
  [5719] = {.count = 1, .reusable = true}, SHIFT(2435),
  [5721] = {.count = 1, .reusable = true}, SHIFT(2436),
  [5723] = {.count = 1, .reusable = true}, SHIFT(2437),
  [5725] = {.count = 1, .reusable = true}, SHIFT(2438),
  [5727] = {.count = 1, .reusable = true}, SHIFT(2439),
  [5729] = {.count = 1, .reusable = true}, REDUCE(sym_array_type_declarator, 5),
  [5731] = {.count = 1, .reusable = true}, REDUCE(sym_preproc_elif_in_field_declaration_list, 3, .alias_sequence_id = 43),
  [5733] = {.count = 1, .reusable = true}, REDUCE(sym_preproc_elif_in_field_declaration_list, 3, .alias_sequence_id = 44),
  [5735] = {.count = 1, .reusable = true}, REDUCE(sym_preproc_elif_in_field_declaration_list, 3, .alias_sequence_id = 22),
  [5737] = {.count = 1, .reusable = true}, REDUCE(sym_preproc_if_in_field_declaration_list, 5, .alias_sequence_id = 45),
  [5739] = {.count = 1, .reusable = false}, REDUCE(sym_preproc_if_in_field_declaration_list, 5, .alias_sequence_id = 45),
  [5741] = {.count = 1, .reusable = true}, REDUCE(sym_preproc_if_in_field_declaration_list, 5, .alias_sequence_id = 46),
  [5743] = {.count = 1, .reusable = false}, REDUCE(sym_preproc_if_in_field_declaration_list, 5, .alias_sequence_id = 46),
  [5745] = {.count = 1, .reusable = true}, REDUCE(sym_preproc_ifdef_in_field_declaration_list, 5, .alias_sequence_id = 47),
  [5747] = {.count = 1, .reusable = false}, REDUCE(sym_preproc_ifdef_in_field_declaration_list, 5, .alias_sequence_id = 47),
  [5749] = {.count = 1, .reusable = true}, REDUCE(sym_preproc_ifdef_in_field_declaration_list, 5, .alias_sequence_id = 48),
  [5751] = {.count = 1, .reusable = false}, REDUCE(sym_preproc_ifdef_in_field_declaration_list, 5, .alias_sequence_id = 48),
  [5753] = {.count = 1, .reusable = true}, REDUCE(sym_preproc_ifdef_in_field_declaration_list, 5, .alias_sequence_id = 49),
  [5755] = {.count = 1, .reusable = false}, REDUCE(sym_preproc_ifdef_in_field_declaration_list, 5, .alias_sequence_id = 49),
  [5757] = {.count = 1, .reusable = true}, REDUCE(sym_preproc_ifdef_in_field_declaration_list, 5, .alias_sequence_id = 50),
  [5759] = {.count = 1, .reusable = false}, REDUCE(sym_preproc_ifdef_in_field_declaration_list, 5, .alias_sequence_id = 50),
  [5761] = {.count = 1, .reusable = true}, SHIFT(2443),
  [5763] = {.count = 1, .reusable = true}, SHIFT(2444),
  [5765] = {.count = 1, .reusable = true}, REDUCE(sym_array_field_declarator, 4),
  [5767] = {.count = 1, .reusable = true}, SHIFT(2445),
  [5769] = {.count = 1, .reusable = true}, REDUCE(sym_field_declaration, 5),
  [5771] = {.count = 1, .reusable = false}, REDUCE(sym_field_declaration, 5),
  [5773] = {.count = 1, .reusable = true}, SHIFT(2446),
  [5775] = {.count = 1, .reusable = false}, SHIFT(2447),
  [5777] = {.count = 1, .reusable = true}, SHIFT(2447),
  [5779] = {.count = 1, .reusable = false}, SHIFT(2450),
  [5781] = {.count = 2, .reusable = true}, REDUCE(aux_sym_function_declarator_repeat1, 2), SHIFT_REPEAT(1670),
  [5784] = {.count = 2, .reusable = true}, REDUCE(aux_sym_function_declarator_repeat1, 2), SHIFT_REPEAT(2150),
  [5787] = {.count = 1, .reusable = true}, SHIFT(2451),
  [5789] = {.count = 1, .reusable = true}, SHIFT(2452),
  [5791] = {.count = 2, .reusable = false}, REDUCE(aux_sym_sized_type_specifier_repeat1, 2), SHIFT_REPEAT(2158),
  [5794] = {.count = 1, .reusable = false}, SHIFT(575),
  [5796] = {.count = 1, .reusable = false}, SHIFT(576),
  [5798] = {.count = 1, .reusable = true}, SHIFT(2457),
  [5800] = {.count = 1, .reusable = false}, SHIFT(2457),
  [5802] = {.count = 1, .reusable = true}, SHIFT(2458),
  [5804] = {.count = 1, .reusable = false}, SHIFT(2458),
  [5806] = {.count = 2, .reusable = true}, REDUCE(aux_sym_abstract_function_declarator_repeat1, 2), SHIFT_REPEAT(2165),
  [5809] = {.count = 1, .reusable = true}, REDUCE(sym_abstract_array_declarator, 4),
  [5811] = {.count = 1, .reusable = false}, REDUCE(sym_abstract_array_declarator, 4),
  [5813] = {.count = 1, .reusable = true}, SHIFT(2460),
  [5815] = {.count = 1, .reusable = true}, REDUCE(sym_abstract_function_declarator, 4),
  [5817] = {.count = 1, .reusable = false}, REDUCE(sym_abstract_function_declarator, 4),
  [5819] = {.count = 2, .reusable = false}, REDUCE(aux_sym_sized_type_specifier_repeat1, 2), SHIFT_REPEAT(2170),
  [5822] = {.count = 1, .reusable = true}, SHIFT(2461),
  [5824] = {.count = 1, .reusable = true}, SHIFT(2462),
  [5826] = {.count = 1, .reusable = true}, SHIFT(2463),
  [5828] = {.count = 1, .reusable = true}, SHIFT(2464),
  [5830] = {.count = 1, .reusable = true}, SHIFT(2466),
  [5832] = {.count = 1, .reusable = true}, SHIFT(2468),
  [5834] = {.count = 1, .reusable = true}, SHIFT(2467),
  [5836] = {.count = 1, .reusable = false}, SHIFT(2468),
  [5838] = {.count = 1, .reusable = true}, SHIFT(2469),
  [5840] = {.count = 1, .reusable = true}, SHIFT(2470),
  [5842] = {.count = 1, .reusable = false}, SHIFT(2470),
  [5844] = {.count = 1, .reusable = true}, SHIFT(2471),
  [5846] = {.count = 1, .reusable = false}, SHIFT(2471),
  [5848] = {.count = 1, .reusable = true}, SHIFT(2472),
  [5850] = {.count = 1, .reusable = false}, SHIFT(2472),
  [5852] = {.count = 1, .reusable = true}, SHIFT(2473),
  [5854] = {.count = 1, .reusable = false}, SHIFT(2473),
  [5856] = {.count = 1, .reusable = true}, SHIFT(2474),
  [5858] = {.count = 1, .reusable = false}, SHIFT(2474),
  [5860] = {.count = 1, .reusable = true}, SHIFT(2475),
  [5862] = {.count = 1, .reusable = false}, SHIFT(2475),
  [5864] = {.count = 1, .reusable = true}, SHIFT(2476),
  [5866] = {.count = 1, .reusable = false}, SHIFT(2476),
  [5868] = {.count = 1, .reusable = true}, SHIFT(2477),
  [5870] = {.count = 1, .reusable = false}, SHIFT(2477),
  [5872] = {.count = 1, .reusable = true}, SHIFT(2478),
  [5874] = {.count = 1, .reusable = false}, SHIFT(2478),
  [5876] = {.count = 1, .reusable = true}, SHIFT(2479),
  [5878] = {.count = 1, .reusable = false}, SHIFT(2479),
  [5880] = {.count = 1, .reusable = true}, SHIFT(2480),
  [5882] = {.count = 1, .reusable = false}, SHIFT(2480),
  [5884] = {.count = 1, .reusable = true}, SHIFT(2481),
  [5886] = {.count = 1, .reusable = false}, SHIFT(2482),
  [5888] = {.count = 1, .reusable = true}, SHIFT(2482),
  [5890] = {.count = 1, .reusable = false}, SHIFT(2485),
  [5892] = {.count = 2, .reusable = true}, REDUCE(aux_sym_function_declarator_repeat1, 2), SHIFT_REPEAT(1737),
  [5895] = {.count = 2, .reusable = true}, REDUCE(aux_sym_function_declarator_repeat1, 2), SHIFT_REPEAT(2198),
  [5898] = {.count = 2, .reusable = true}, REDUCE(aux_sym_abstract_function_declarator_repeat1, 2), SHIFT_REPEAT(2205),
  [5901] = {.count = 1, .reusable = false}, SHIFT(659),
  [5903] = {.count = 1, .reusable = false}, SHIFT(661),
  [5905] = {.count = 1, .reusable = true}, SHIFT(2488),
  [5907] = {.count = 1, .reusable = false}, SHIFT(2488),
  [5909] = {.count = 1, .reusable = true}, SHIFT(2489),
  [5911] = {.count = 1, .reusable = false}, SHIFT(2489),
  [5913] = {.count = 1, .reusable = true}, REDUCE(sym_initializer_list, 5),
  [5915] = {.count = 1, .reusable = false}, REDUCE(sym_initializer_list, 5),
  [5917] = {.count = 1, .reusable = true}, SHIFT(2491),
  [5919] = {.count = 1, .reusable = false}, SHIFT(682),
  [5921] = {.count = 1, .reusable = false}, SHIFT(683),
  [5923] = {.count = 1, .reusable = true}, SHIFT(2492),
  [5925] = {.count = 1, .reusable = false}, SHIFT(2492),
  [5927] = {.count = 1, .reusable = true}, SHIFT(2493),
  [5929] = {.count = 1, .reusable = false}, SHIFT(2493),
  [5931] = {.count = 1, .reusable = false}, SHIFT(692),
  [5933] = {.count = 1, .reusable = false}, SHIFT(693),
  [5935] = {.count = 1, .reusable = true}, SHIFT(2494),
  [5937] = {.count = 1, .reusable = false}, SHIFT(2494),
  [5939] = {.count = 1, .reusable = true}, SHIFT(2495),
  [5941] = {.count = 1, .reusable = false}, SHIFT(2495),
  [5943] = {.count = 1, .reusable = true}, SHIFT(2496),
  [5945] = {.count = 1, .reusable = false}, SHIFT(2497),
  [5947] = {.count = 1, .reusable = true}, SHIFT(2497),
  [5949] = {.count = 1, .reusable = false}, SHIFT(2500),
  [5951] = {.count = 2, .reusable = true}, REDUCE(aux_sym_function_declarator_repeat1, 2), SHIFT_REPEAT(1827),
  [5954] = {.count = 2, .reusable = true}, REDUCE(aux_sym_function_declarator_repeat1, 2), SHIFT_REPEAT(2228),
  [5957] = {.count = 2, .reusable = false}, REDUCE(aux_sym_sized_type_specifier_repeat1, 2), SHIFT_REPEAT(2232),
  [5960] = {.count = 1, .reusable = false}, SHIFT(729),
  [5962] = {.count = 1, .reusable = false}, SHIFT(733),
  [5964] = {.count = 1, .reusable = true}, SHIFT(2501),
  [5966] = {.count = 1, .reusable = false}, SHIFT(2501),
  [5968] = {.count = 1, .reusable = true}, SHIFT(2502),
  [5970] = {.count = 1, .reusable = false}, SHIFT(2502),
  [5972] = {.count = 1, .reusable = true}, SHIFT(2503),
  [5974] = {.count = 1, .reusable = true}, REDUCE(sym_new_declarator, 3),
  [5976] = {.count = 1, .reusable = true}, REDUCE(sym_new_expression, 5, .alias_sequence_id = 20),
  [5978] = {.count = 1, .reusable = false}, REDUCE(sym_new_expression, 5, .alias_sequence_id = 20),
  [5980] = {.count = 1, .reusable = true}, REDUCE(sym_new_expression, 5),
  [5982] = {.count = 1, .reusable = false}, REDUCE(sym_new_expression, 5),
  [5984] = {.count = 1, .reusable = true}, REDUCE(sym_delete_expression, 5),
  [5986] = {.count = 1, .reusable = false}, REDUCE(sym_delete_expression, 5),
  [5988] = {.count = 1, .reusable = true}, REDUCE(sym_conditional_expression, 5),
  [5990] = {.count = 1, .reusable = false}, SHIFT(2505),
  [5992] = {.count = 2, .reusable = true}, REDUCE(aux_sym_abstract_function_declarator_repeat1, 2), SHIFT_REPEAT(2249),
  [5995] = {.count = 2, .reusable = false}, REDUCE(aux_sym_sized_type_specifier_repeat1, 2), SHIFT_REPEAT(2257),
  [5998] = {.count = 1, .reusable = true}, SHIFT(2508),
  [6000] = {.count = 1, .reusable = true}, SHIFT(2509),
  [6002] = {.count = 1, .reusable = true}, SHIFT(2510),
  [6004] = {.count = 2, .reusable = true}, REDUCE(aux_sym_abstract_function_declarator_repeat1, 2), SHIFT_REPEAT(2270),
  [6007] = {.count = 1, .reusable = false}, SHIFT(2511),
  [6009] = {.count = 1, .reusable = false}, SHIFT(2512),
  [6011] = {.count = 1, .reusable = false}, SHIFT(2513),
  [6013] = {.count = 1, .reusable = true}, SHIFT(2514),
  [6015] = {.count = 1, .reusable = true}, SHIFT(2515),
  [6017] = {.count = 1, .reusable = false}, SHIFT(2516),
  [6019] = {.count = 1, .reusable = true}, SHIFT(2519),
  [6021] = {.count = 1, .reusable = true}, SHIFT(2520),
  [6023] = {.count = 1, .reusable = false}, SHIFT(2521),
  [6025] = {.count = 1, .reusable = true}, SHIFT(2524),
  [6027] = {.count = 1, .reusable = true}, SHIFT(2525),
  [6029] = {.count = 1, .reusable = false}, SHIFT(2526),
  [6031] = {.count = 1, .reusable = false}, SHIFT(2529),
  [6033] = {.count = 1, .reusable = false}, SHIFT(2530),
  [6035] = {.count = 1, .reusable = false}, SHIFT(2532),
  [6037] = {.count = 1, .reusable = false}, SHIFT(2536),
  [6039] = {.count = 1, .reusable = false}, SHIFT(2540),
  [6041] = {.count = 1, .reusable = false}, SHIFT(2544),
  [6043] = {.count = 1, .reusable = false}, SHIFT(2546),
  [6045] = {.count = 1, .reusable = true}, SHIFT(2547),
  [6047] = {.count = 1, .reusable = true}, SHIFT(2548),
  [6049] = {.count = 1, .reusable = false}, SHIFT(2548),
  [6051] = {.count = 1, .reusable = true}, SHIFT(2549),
  [6053] = {.count = 1, .reusable = true}, SHIFT(2550),
  [6055] = {.count = 1, .reusable = false}, SHIFT(2550),
  [6057] = {.count = 1, .reusable = true}, SHIFT(2551),
  [6059] = {.count = 1, .reusable = false}, SHIFT(2552),
  [6061] = {.count = 1, .reusable = true}, SHIFT(2555),
  [6063] = {.count = 1, .reusable = false}, SHIFT(2555),
  [6065] = {.count = 1, .reusable = true}, SHIFT(2556),
  [6067] = {.count = 1, .reusable = true}, SHIFT(2558),
  [6069] = {.count = 1, .reusable = true}, SHIFT(2557),
  [6071] = {.count = 1, .reusable = false}, SHIFT(2558),
  [6073] = {.count = 1, .reusable = true}, SHIFT(2560),
  [6075] = {.count = 1, .reusable = true}, SHIFT(2561),
  [6077] = {.count = 1, .reusable = false}, SHIFT(2562),
  [6079] = {.count = 1, .reusable = true}, SHIFT(2564),
  [6081] = {.count = 1, .reusable = true}, SHIFT(2566),
  [6083] = {.count = 1, .reusable = true}, SHIFT(2568),
  [6085] = {.count = 2, .reusable = true}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(1947),
  [6088] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(1923),
  [6091] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(1924),
  [6094] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(1925),
  [6097] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(1926),
  [6100] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(1927),
  [6103] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(1928),
  [6106] = {.count = 2, .reusable = true}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(1929),
  [6109] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(1930),
  [6112] = {.count = 2, .reusable = true}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(1931),
  [6115] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(1932),
  [6118] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(1933),
  [6121] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(1934),
  [6124] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(1935),
  [6127] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(1936),
  [6130] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(1937),
  [6133] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(1938),
  [6136] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(1939),
  [6139] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(1940),
  [6142] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(1941),
  [6145] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(1942),
  [6148] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(1947),
  [6151] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(1943),
  [6154] = {.count = 1, .reusable = true}, REDUCE(sym_preproc_elif_in_compound_statement, 3, .alias_sequence_id = 43),
  [6156] = {.count = 1, .reusable = true}, REDUCE(sym_preproc_elif_in_compound_statement, 3, .alias_sequence_id = 44),
  [6158] = {.count = 1, .reusable = false}, REDUCE(sym_preproc_elif_in_compound_statement, 3, .alias_sequence_id = 22),
  [6160] = {.count = 1, .reusable = true}, SHIFT(2572),
  [6162] = {.count = 1, .reusable = true}, SHIFT(2573),
  [6164] = {.count = 1, .reusable = true}, SHIFT(2575),
  [6166] = {.count = 1, .reusable = true}, SHIFT(2576),
  [6168] = {.count = 1, .reusable = false}, SHIFT(2576),
  [6170] = {.count = 1, .reusable = true}, SHIFT(2577),
  [6172] = {.count = 1, .reusable = true}, SHIFT(2579),
  [6174] = {.count = 1, .reusable = true}, SHIFT(2580),
  [6176] = {.count = 1, .reusable = true}, SHIFT(2582),
  [6178] = {.count = 1, .reusable = true}, SHIFT(2581),
  [6180] = {.count = 1, .reusable = false}, SHIFT(2582),
  [6182] = {.count = 1, .reusable = true}, SHIFT(2583),
  [6184] = {.count = 1, .reusable = true}, SHIFT(2584),
  [6186] = {.count = 1, .reusable = true}, SHIFT(2585),
  [6188] = {.count = 1, .reusable = true}, SHIFT(2586),
  [6190] = {.count = 1, .reusable = false}, SHIFT(2586),
  [6192] = {.count = 1, .reusable = true}, SHIFT(2588),
  [6194] = {.count = 1, .reusable = true}, SHIFT(2589),
  [6196] = {.count = 1, .reusable = false}, SHIFT(2589),
  [6198] = {.count = 1, .reusable = true}, SHIFT(2591),
  [6200] = {.count = 1, .reusable = true}, REDUCE(sym_preproc_if_in_compound_statement, 5, .alias_sequence_id = 45),
  [6202] = {.count = 1, .reusable = false}, REDUCE(sym_preproc_if_in_compound_statement, 5, .alias_sequence_id = 45),
  [6204] = {.count = 1, .reusable = true}, REDUCE(sym_preproc_if_in_compound_statement, 5, .alias_sequence_id = 46),
  [6206] = {.count = 1, .reusable = false}, REDUCE(sym_preproc_if_in_compound_statement, 5, .alias_sequence_id = 46),
  [6208] = {.count = 1, .reusable = true}, REDUCE(sym_preproc_ifdef_in_compound_statement, 5, .alias_sequence_id = 47),
  [6210] = {.count = 1, .reusable = false}, REDUCE(sym_preproc_ifdef_in_compound_statement, 5, .alias_sequence_id = 47),
  [6212] = {.count = 1, .reusable = true}, REDUCE(sym_preproc_ifdef_in_compound_statement, 5, .alias_sequence_id = 48),
  [6214] = {.count = 1, .reusable = false}, REDUCE(sym_preproc_ifdef_in_compound_statement, 5, .alias_sequence_id = 48),
  [6216] = {.count = 1, .reusable = true}, REDUCE(sym_preproc_ifdef_in_compound_statement, 5, .alias_sequence_id = 49),
  [6218] = {.count = 1, .reusable = false}, REDUCE(sym_preproc_ifdef_in_compound_statement, 5, .alias_sequence_id = 49),
  [6220] = {.count = 1, .reusable = true}, REDUCE(sym_preproc_ifdef_in_compound_statement, 5, .alias_sequence_id = 50),
  [6222] = {.count = 1, .reusable = false}, REDUCE(sym_preproc_ifdef_in_compound_statement, 5, .alias_sequence_id = 50),
  [6224] = {.count = 1, .reusable = true}, SHIFT(2592),
  [6226] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenated_string_repeat1, 2), SHIFT_REPEAT(2359),
  [6229] = {.count = 1, .reusable = true}, SHIFT(2593),
  [6231] = {.count = 1, .reusable = true}, SHIFT(2594),
  [6233] = {.count = 1, .reusable = false}, SHIFT(2594),
  [6235] = {.count = 1, .reusable = true}, SHIFT(2595),
  [6237] = {.count = 1, .reusable = true}, SHIFT(2597),
  [6239] = {.count = 1, .reusable = true}, SHIFT(2598),
  [6241] = {.count = 1, .reusable = true}, SHIFT(2599),
  [6243] = {.count = 1, .reusable = true}, SHIFT(2600),
  [6245] = {.count = 1, .reusable = false}, SHIFT(2600),
  [6247] = {.count = 1, .reusable = true}, SHIFT(2601),
  [6249] = {.count = 1, .reusable = true}, SHIFT(2602),
  [6251] = {.count = 1, .reusable = true}, SHIFT(2604),
  [6253] = {.count = 1, .reusable = true}, SHIFT(2606),
  [6255] = {.count = 1, .reusable = true}, SHIFT(2605),
  [6257] = {.count = 1, .reusable = false}, SHIFT(2606),
  [6259] = {.count = 1, .reusable = true}, SHIFT(2608),
  [6261] = {.count = 1, .reusable = true}, SHIFT(2609),
  [6263] = {.count = 1, .reusable = true}, SHIFT(2610),
  [6265] = {.count = 1, .reusable = false}, SHIFT(2611),
  [6267] = {.count = 1, .reusable = true}, REDUCE(sym_if_statement, 5),
  [6269] = {.count = 1, .reusable = false}, REDUCE(sym_if_statement, 5),
  [6271] = {.count = 1, .reusable = false}, SHIFT(2612),
  [6273] = {.count = 1, .reusable = true}, SHIFT(2613),
  [6275] = {.count = 1, .reusable = true}, SHIFT(2614),
  [6277] = {.count = 1, .reusable = true}, REDUCE(sym_switch_statement, 5),
  [6279] = {.count = 1, .reusable = false}, REDUCE(sym_switch_statement, 5),
  [6281] = {.count = 1, .reusable = false}, SHIFT(846),
  [6283] = {.count = 1, .reusable = false}, SHIFT(847),
  [6285] = {.count = 1, .reusable = true}, SHIFT(2616),
  [6287] = {.count = 1, .reusable = false}, SHIFT(2616),
  [6289] = {.count = 1, .reusable = true}, SHIFT(2617),
  [6291] = {.count = 1, .reusable = false}, SHIFT(2617),
  [6293] = {.count = 1, .reusable = true}, REDUCE(sym_while_statement, 5),
  [6295] = {.count = 1, .reusable = false}, REDUCE(sym_while_statement, 5),
  [6297] = {.count = 1, .reusable = false}, SHIFT(2618),
  [6299] = {.count = 1, .reusable = false}, SHIFT(2619),
  [6301] = {.count = 1, .reusable = false}, SHIFT(2620),
  [6303] = {.count = 1, .reusable = false}, SHIFT(2621),
  [6305] = {.count = 1, .reusable = false}, SHIFT(2622),
  [6307] = {.count = 1, .reusable = false}, SHIFT(2623),
  [6309] = {.count = 1, .reusable = false}, SHIFT(2624),
  [6311] = {.count = 1, .reusable = true}, SHIFT(2626),
  [6313] = {.count = 1, .reusable = false}, SHIFT(2629),
  [6315] = {.count = 1, .reusable = true}, SHIFT(2630),
  [6317] = {.count = 1, .reusable = true}, SHIFT(2633),
  [6319] = {.count = 1, .reusable = false}, SHIFT(2633),
  [6321] = {.count = 1, .reusable = true}, SHIFT(2635),
  [6323] = {.count = 1, .reusable = true}, SHIFT(2634),
  [6325] = {.count = 1, .reusable = false}, SHIFT(2635),
  [6327] = {.count = 1, .reusable = true}, SHIFT(2636),
  [6329] = {.count = 1, .reusable = true}, SHIFT(2637),
  [6331] = {.count = 1, .reusable = false}, SHIFT(2637),
  [6333] = {.count = 1, .reusable = true}, SHIFT(2638),
  [6335] = {.count = 1, .reusable = false}, SHIFT(2638),
  [6337] = {.count = 1, .reusable = true}, SHIFT(2639),
  [6339] = {.count = 1, .reusable = true}, SHIFT(2641),
  [6341] = {.count = 1, .reusable = true}, SHIFT(2642),
  [6343] = {.count = 1, .reusable = true}, SHIFT(2644),
  [6345] = {.count = 1, .reusable = false}, SHIFT(2644),
  [6347] = {.count = 1, .reusable = true}, SHIFT(2645),
  [6349] = {.count = 1, .reusable = true}, SHIFT(2646),
  [6351] = {.count = 1, .reusable = true}, SHIFT(2647),
  [6353] = {.count = 1, .reusable = true}, SHIFT(2648),
  [6355] = {.count = 1, .reusable = true}, SHIFT(2649),
  [6357] = {.count = 1, .reusable = true}, REDUCE(sym_preproc_elif_in_field_declaration_list, 4, .alias_sequence_id = 51),
  [6359] = {.count = 1, .reusable = true}, REDUCE(sym_preproc_elif_in_field_declaration_list, 4, .alias_sequence_id = 52),
  [6361] = {.count = 1, .reusable = false}, SHIFT(2655),
  [6363] = {.count = 1, .reusable = false}, SHIFT(2654),
  [6365] = {.count = 1, .reusable = false}, SHIFT(2650),
  [6367] = {.count = 1, .reusable = false}, SHIFT(2651),
  [6369] = {.count = 1, .reusable = false}, SHIFT(2652),
  [6371] = {.count = 1, .reusable = false}, SHIFT(2653),
  [6373] = {.count = 1, .reusable = true}, SHIFT(2656),
  [6375] = {.count = 1, .reusable = true}, REDUCE(sym_array_field_declarator, 5),
  [6377] = {.count = 2, .reusable = false}, REDUCE(aux_sym_sized_type_specifier_repeat1, 2), SHIFT_REPEAT(2450),
  [6380] = {.count = 1, .reusable = true}, REDUCE(sym_field_declaration, 6),
  [6382] = {.count = 1, .reusable = false}, REDUCE(sym_field_declaration, 6),
  [6384] = {.count = 1, .reusable = true}, SHIFT(2662),
  [6386] = {.count = 1, .reusable = true}, REDUCE(sym_abstract_array_declarator, 5),
  [6388] = {.count = 1, .reusable = false}, REDUCE(sym_abstract_array_declarator, 5),
  [6390] = {.count = 1, .reusable = true}, SHIFT(2663),
  [6392] = {.count = 1, .reusable = true}, SHIFT(2664),
  [6394] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenated_string_repeat1, 2), SHIFT_REPEAT(2466),
  [6397] = {.count = 1, .reusable = true}, SHIFT(2665),
  [6399] = {.count = 1, .reusable = true}, SHIFT(2666),
  [6401] = {.count = 1, .reusable = false}, SHIFT(2666),
  [6403] = {.count = 1, .reusable = true}, SHIFT(2667),
  [6405] = {.count = 2, .reusable = false}, REDUCE(aux_sym_sized_type_specifier_repeat1, 2), SHIFT_REPEAT(2485),
  [6408] = {.count = 2, .reusable = true}, REDUCE(aux_sym_abstract_function_declarator_repeat1, 2), SHIFT_REPEAT(2491),
  [6411] = {.count = 2, .reusable = false}, REDUCE(aux_sym_sized_type_specifier_repeat1, 2), SHIFT_REPEAT(2500),
  [6414] = {.count = 1, .reusable = true}, REDUCE(sym_new_declarator, 4),
  [6416] = {.count = 2, .reusable = false}, REDUCE(aux_sym_sized_type_specifier_repeat1, 2), SHIFT_REPEAT(2505),
  [6419] = {.count = 1, .reusable = true}, SHIFT(2676),
  [6421] = {.count = 1, .reusable = true}, SHIFT(2677),
  [6423] = {.count = 1, .reusable = true}, SHIFT(2678),
  [6425] = {.count = 1, .reusable = true}, SHIFT(2679),
  [6427] = {.count = 1, .reusable = true}, SHIFT(2680),
  [6429] = {.count = 1, .reusable = true}, SHIFT(2681),
  [6431] = {.count = 1, .reusable = true}, SHIFT(2682),
  [6433] = {.count = 1, .reusable = true}, SHIFT(2683),
  [6435] = {.count = 1, .reusable = true}, SHIFT(2684),
  [6437] = {.count = 1, .reusable = false}, SHIFT(2685),
  [6439] = {.count = 1, .reusable = false}, SHIFT(2686),
  [6441] = {.count = 1, .reusable = false}, SHIFT(2687),
  [6443] = {.count = 1, .reusable = true}, SHIFT(2688),
  [6445] = {.count = 1, .reusable = true}, SHIFT(2689),
  [6447] = {.count = 1, .reusable = false}, SHIFT(2690),
  [6449] = {.count = 1, .reusable = true}, SHIFT(2693),
  [6451] = {.count = 1, .reusable = true}, SHIFT(2694),
  [6453] = {.count = 1, .reusable = false}, SHIFT(2695),
  [6455] = {.count = 1, .reusable = true}, SHIFT(2698),
  [6457] = {.count = 1, .reusable = true}, SHIFT(2699),
  [6459] = {.count = 1, .reusable = false}, SHIFT(2700),
  [6461] = {.count = 1, .reusable = true}, SHIFT(2703),
  [6463] = {.count = 1, .reusable = true}, SHIFT(2704),
  [6465] = {.count = 1, .reusable = true}, SHIFT(2706),
  [6467] = {.count = 1, .reusable = true}, SHIFT(2707),
  [6469] = {.count = 1, .reusable = false}, SHIFT(2707),
  [6471] = {.count = 1, .reusable = true}, SHIFT(2708),
  [6473] = {.count = 1, .reusable = true}, SHIFT(2710),
  [6475] = {.count = 1, .reusable = true}, SHIFT(2711),
  [6477] = {.count = 1, .reusable = true}, SHIFT(2713),
  [6479] = {.count = 1, .reusable = true}, SHIFT(2712),
  [6481] = {.count = 1, .reusable = false}, SHIFT(2713),
  [6483] = {.count = 1, .reusable = true}, SHIFT(2714),
  [6485] = {.count = 1, .reusable = true}, SHIFT(2715),
  [6487] = {.count = 1, .reusable = true}, SHIFT(2716),
  [6489] = {.count = 1, .reusable = true}, SHIFT(2717),
  [6491] = {.count = 1, .reusable = false}, SHIFT(2717),
  [6493] = {.count = 1, .reusable = true}, SHIFT(2719),
  [6495] = {.count = 1, .reusable = true}, SHIFT(2720),
  [6497] = {.count = 1, .reusable = false}, SHIFT(2720),
  [6499] = {.count = 1, .reusable = true}, SHIFT(2722),
  [6501] = {.count = 1, .reusable = true}, REDUCE(sym_preproc_elif_in_compound_statement, 4, .alias_sequence_id = 51),
  [6503] = {.count = 1, .reusable = true}, REDUCE(sym_preproc_elif_in_compound_statement, 4, .alias_sequence_id = 52),
  [6505] = {.count = 1, .reusable = true}, SHIFT(2723),
  [6507] = {.count = 1, .reusable = true}, SHIFT(2739),
  [6509] = {.count = 1, .reusable = true}, SHIFT(2724),
  [6511] = {.count = 1, .reusable = true}, SHIFT(2725),
  [6513] = {.count = 1, .reusable = false}, SHIFT(2726),
  [6515] = {.count = 1, .reusable = false}, SHIFT(2727),
  [6517] = {.count = 1, .reusable = false}, SHIFT(2728),
  [6519] = {.count = 1, .reusable = false}, SHIFT(2729),
  [6521] = {.count = 1, .reusable = false}, SHIFT(2730),
  [6523] = {.count = 1, .reusable = false}, SHIFT(2731),
  [6525] = {.count = 1, .reusable = false}, SHIFT(2732),
  [6527] = {.count = 1, .reusable = false}, SHIFT(2733),
  [6529] = {.count = 1, .reusable = false}, SHIFT(2734),
  [6531] = {.count = 1, .reusable = false}, SHIFT(2735),
  [6533] = {.count = 1, .reusable = false}, SHIFT(2736),
  [6535] = {.count = 1, .reusable = false}, SHIFT(2739),
  [6537] = {.count = 1, .reusable = false}, SHIFT(2737),
  [6539] = {.count = 1, .reusable = true}, SHIFT(2741),
  [6541] = {.count = 1, .reusable = true}, SHIFT(2744),
  [6543] = {.count = 1, .reusable = false}, SHIFT(2744),
  [6545] = {.count = 1, .reusable = true}, SHIFT(2746),
  [6547] = {.count = 1, .reusable = true}, SHIFT(2745),
  [6549] = {.count = 1, .reusable = false}, SHIFT(2746),
  [6551] = {.count = 1, .reusable = true}, SHIFT(2747),
  [6553] = {.count = 1, .reusable = true}, SHIFT(2748),
  [6555] = {.count = 1, .reusable = false}, SHIFT(2748),
  [6557] = {.count = 1, .reusable = true}, SHIFT(2749),
  [6559] = {.count = 1, .reusable = false}, SHIFT(2749),
  [6561] = {.count = 1, .reusable = true}, SHIFT(2750),
  [6563] = {.count = 1, .reusable = true}, SHIFT(2751),
  [6565] = {.count = 1, .reusable = false}, SHIFT(1435),
  [6567] = {.count = 1, .reusable = false}, SHIFT(1436),
  [6569] = {.count = 1, .reusable = true}, SHIFT(2752),
  [6571] = {.count = 1, .reusable = false}, SHIFT(2752),
  [6573] = {.count = 1, .reusable = true}, SHIFT(2753),
  [6575] = {.count = 1, .reusable = true}, SHIFT(2754),
  [6577] = {.count = 1, .reusable = false}, SHIFT(2754),
  [6579] = {.count = 1, .reusable = true}, SHIFT(2755),
  [6581] = {.count = 1, .reusable = true}, SHIFT(2756),
  [6583] = {.count = 1, .reusable = false}, SHIFT(2756),
  [6585] = {.count = 1, .reusable = true}, SHIFT(2757),
  [6587] = {.count = 1, .reusable = false}, SHIFT(2758),
  [6589] = {.count = 1, .reusable = false}, SHIFT(2759),
  [6591] = {.count = 1, .reusable = true}, SHIFT(2762),
  [6593] = {.count = 1, .reusable = false}, SHIFT(2762),
  [6595] = {.count = 1, .reusable = true}, SHIFT(2763),
  [6597] = {.count = 1, .reusable = true}, SHIFT(2765),
  [6599] = {.count = 1, .reusable = true}, SHIFT(2764),
  [6601] = {.count = 1, .reusable = false}, SHIFT(2765),
  [6603] = {.count = 1, .reusable = true}, SHIFT(2767),
  [6605] = {.count = 1, .reusable = true}, SHIFT(2768),
  [6607] = {.count = 1, .reusable = true}, SHIFT(2771),
  [6609] = {.count = 1, .reusable = false}, SHIFT(2771),
  [6611] = {.count = 1, .reusable = true}, REDUCE(sym_if_statement, 6),
  [6613] = {.count = 1, .reusable = false}, REDUCE(sym_if_statement, 6),
  [6615] = {.count = 1, .reusable = false}, SHIFT(2772),
  [6617] = {.count = 1, .reusable = true}, SHIFT(2773),
  [6619] = {.count = 1, .reusable = true}, SHIFT(2774),
  [6621] = {.count = 1, .reusable = true}, SHIFT(2775),
  [6623] = {.count = 1, .reusable = true}, SHIFT(2776),
  [6625] = {.count = 1, .reusable = false}, SHIFT(2776),
  [6627] = {.count = 1, .reusable = true}, SHIFT(2777),
  [6629] = {.count = 1, .reusable = true}, SHIFT(2778),
  [6631] = {.count = 1, .reusable = true}, SHIFT(2779),
  [6633] = {.count = 1, .reusable = false}, SHIFT(2780),
  [6635] = {.count = 1, .reusable = true}, SHIFT(2781),
  [6637] = {.count = 1, .reusable = true}, SHIFT(2783),
  [6639] = {.count = 1, .reusable = true}, SHIFT(2785),
  [6641] = {.count = 1, .reusable = true}, SHIFT(2786),
  [6643] = {.count = 1, .reusable = true}, SHIFT(2788),
  [6645] = {.count = 1, .reusable = true}, SHIFT(2790),
  [6647] = {.count = 1, .reusable = false}, SHIFT(2790),
  [6649] = {.count = 1, .reusable = true}, SHIFT(2791),
  [6651] = {.count = 1, .reusable = true}, SHIFT(2792),
  [6653] = {.count = 1, .reusable = true}, REDUCE(sym_do_statement, 6),
  [6655] = {.count = 1, .reusable = false}, REDUCE(sym_do_statement, 6),
  [6657] = {.count = 1, .reusable = true}, REDUCE(sym_for_statement, 6),
  [6659] = {.count = 1, .reusable = false}, REDUCE(sym_for_statement, 6),
  [6661] = {.count = 1, .reusable = true}, SHIFT(2793),
  [6663] = {.count = 1, .reusable = false}, SHIFT(2793),
  [6665] = {.count = 1, .reusable = true}, SHIFT(2795),
  [6667] = {.count = 1, .reusable = false}, SHIFT(2800),
  [6669] = {.count = 1, .reusable = false}, SHIFT(2799),
  [6671] = {.count = 1, .reusable = false}, SHIFT(2798),
  [6673] = {.count = 1, .reusable = true}, SHIFT(2801),
  [6675] = {.count = 1, .reusable = true}, SHIFT(2802),
  [6677] = {.count = 1, .reusable = false}, SHIFT(2802),
  [6679] = {.count = 1, .reusable = true}, SHIFT(2807),
  [6681] = {.count = 1, .reusable = false}, SHIFT(2808),
  [6683] = {.count = 1, .reusable = true}, SHIFT(2808),
  [6685] = {.count = 1, .reusable = false}, SHIFT(2811),
  [6687] = {.count = 2, .reusable = true}, REDUCE(aux_sym_function_declarator_repeat1, 2), SHIFT_REPEAT(2443),
  [6690] = {.count = 2, .reusable = true}, REDUCE(aux_sym_function_declarator_repeat1, 2), SHIFT_REPEAT(2656),
  [6693] = {.count = 1, .reusable = true}, SHIFT(2813),
  [6695] = {.count = 2, .reusable = true}, REDUCE(aux_sym_abstract_function_declarator_repeat1, 2), SHIFT_REPEAT(2662),
  [6698] = {.count = 1, .reusable = false}, SHIFT(1728),
  [6700] = {.count = 1, .reusable = false}, SHIFT(1729),
  [6702] = {.count = 1, .reusable = true}, SHIFT(2814),
  [6704] = {.count = 1, .reusable = false}, SHIFT(2814),
  [6706] = {.count = 1, .reusable = true}, SHIFT(2815),
  [6708] = {.count = 1, .reusable = false}, SHIFT(2815),
  [6710] = {.count = 1, .reusable = true}, SHIFT(2817),
  [6712] = {.count = 1, .reusable = true}, SHIFT(2819),
  [6714] = {.count = 1, .reusable = true}, SHIFT(2820),
  [6716] = {.count = 1, .reusable = true}, SHIFT(2821),
  [6718] = {.count = 1, .reusable = true}, SHIFT(2822),
  [6720] = {.count = 1, .reusable = true}, SHIFT(2823),
  [6722] = {.count = 1, .reusable = true}, SHIFT(2824),
  [6724] = {.count = 1, .reusable = true}, SHIFT(2825),
  [6726] = {.count = 1, .reusable = true}, SHIFT(2826),
  [6728] = {.count = 1, .reusable = true}, SHIFT(2827),
  [6730] = {.count = 1, .reusable = true}, SHIFT(2828),
  [6732] = {.count = 1, .reusable = true}, SHIFT(2844),
  [6734] = {.count = 1, .reusable = true}, SHIFT(2829),
  [6736] = {.count = 1, .reusable = true}, SHIFT(2830),
  [6738] = {.count = 1, .reusable = false}, SHIFT(2831),
  [6740] = {.count = 1, .reusable = false}, SHIFT(2832),
  [6742] = {.count = 1, .reusable = false}, SHIFT(2833),
  [6744] = {.count = 1, .reusable = false}, SHIFT(2834),
  [6746] = {.count = 1, .reusable = false}, SHIFT(2835),
  [6748] = {.count = 1, .reusable = false}, SHIFT(2836),
  [6750] = {.count = 1, .reusable = false}, SHIFT(2837),
  [6752] = {.count = 1, .reusable = false}, SHIFT(2838),
  [6754] = {.count = 1, .reusable = false}, SHIFT(2839),
  [6756] = {.count = 1, .reusable = false}, SHIFT(2840),
  [6758] = {.count = 1, .reusable = false}, SHIFT(2841),
  [6760] = {.count = 1, .reusable = false}, SHIFT(2844),
  [6762] = {.count = 1, .reusable = false}, SHIFT(2842),
  [6764] = {.count = 1, .reusable = true}, SHIFT(2846),
  [6766] = {.count = 1, .reusable = true}, SHIFT(2849),
  [6768] = {.count = 1, .reusable = false}, SHIFT(2849),
  [6770] = {.count = 1, .reusable = true}, SHIFT(2851),
  [6772] = {.count = 1, .reusable = true}, SHIFT(2850),
  [6774] = {.count = 1, .reusable = false}, SHIFT(2851),
  [6776] = {.count = 1, .reusable = true}, SHIFT(2852),
  [6778] = {.count = 1, .reusable = true}, SHIFT(2853),
  [6780] = {.count = 1, .reusable = false}, SHIFT(2853),
  [6782] = {.count = 1, .reusable = true}, SHIFT(2854),
  [6784] = {.count = 1, .reusable = false}, SHIFT(2854),
  [6786] = {.count = 1, .reusable = true}, SHIFT(2855),
  [6788] = {.count = 1, .reusable = true}, SHIFT(2856),
  [6790] = {.count = 1, .reusable = true}, SHIFT(2857),
  [6792] = {.count = 1, .reusable = true}, SHIFT(2859),
  [6794] = {.count = 1, .reusable = true}, SHIFT(2860),
  [6796] = {.count = 1, .reusable = true}, SHIFT(2861),
  [6798] = {.count = 1, .reusable = true}, SHIFT(2862),
  [6800] = {.count = 1, .reusable = false}, SHIFT(2862),
  [6802] = {.count = 1, .reusable = true}, SHIFT(2863),
  [6804] = {.count = 1, .reusable = true}, SHIFT(2864),
  [6806] = {.count = 1, .reusable = true}, SHIFT(2866),
  [6808] = {.count = 1, .reusable = true}, SHIFT(2868),
  [6810] = {.count = 1, .reusable = true}, SHIFT(2867),
  [6812] = {.count = 1, .reusable = false}, SHIFT(2868),
  [6814] = {.count = 1, .reusable = true}, SHIFT(2870),
  [6816] = {.count = 1, .reusable = true}, SHIFT(2871),
  [6818] = {.count = 1, .reusable = true}, SHIFT(2872),
  [6820] = {.count = 1, .reusable = false}, SHIFT(2873),
  [6822] = {.count = 1, .reusable = false}, SHIFT(2874),
  [6824] = {.count = 1, .reusable = true}, SHIFT(2875),
  [6826] = {.count = 1, .reusable = true}, SHIFT(2877),
  [6828] = {.count = 1, .reusable = true}, SHIFT(2879),
  [6830] = {.count = 1, .reusable = true}, SHIFT(2881),
  [6832] = {.count = 1, .reusable = false}, SHIFT(2881),
  [6834] = {.count = 1, .reusable = true}, SHIFT(2882),
  [6836] = {.count = 1, .reusable = true}, SHIFT(2883),
  [6838] = {.count = 1, .reusable = true}, SHIFT(2884),
  [6840] = {.count = 1, .reusable = true}, SHIFT(2885),
  [6842] = {.count = 1, .reusable = false}, SHIFT(2885),
  [6844] = {.count = 1, .reusable = true}, SHIFT(2886),
  [6846] = {.count = 1, .reusable = false}, SHIFT(2888),
  [6848] = {.count = 1, .reusable = true}, SHIFT(2890),
  [6850] = {.count = 1, .reusable = true}, SHIFT(2892),
  [6852] = {.count = 1, .reusable = true}, SHIFT(2893),
  [6854] = {.count = 1, .reusable = true}, SHIFT(2895),
  [6856] = {.count = 1, .reusable = true}, SHIFT(2894),
  [6858] = {.count = 1, .reusable = false}, SHIFT(2895),
  [6860] = {.count = 1, .reusable = true}, SHIFT(2896),
  [6862] = {.count = 1, .reusable = true}, SHIFT(2897),
  [6864] = {.count = 1, .reusable = true}, REDUCE(sym_if_statement, 7),
  [6866] = {.count = 1, .reusable = false}, REDUCE(sym_if_statement, 7),
  [6868] = {.count = 1, .reusable = true}, SHIFT(2899),
  [6870] = {.count = 1, .reusable = false}, SHIFT(2899),
  [6872] = {.count = 1, .reusable = true}, SHIFT(2900),
  [6874] = {.count = 1, .reusable = true}, SHIFT(2901),
  [6876] = {.count = 1, .reusable = false}, SHIFT(2901),
  [6878] = {.count = 1, .reusable = true}, SHIFT(2902),
  [6880] = {.count = 1, .reusable = false}, SHIFT(2903),
  [6882] = {.count = 1, .reusable = true}, SHIFT(2904),
  [6884] = {.count = 1, .reusable = false}, SHIFT(2904),
  [6886] = {.count = 1, .reusable = true}, SHIFT(2906),
  [6888] = {.count = 1, .reusable = true}, SHIFT(2905),
  [6890] = {.count = 1, .reusable = false}, SHIFT(2906),
  [6892] = {.count = 1, .reusable = true}, SHIFT(2909),
  [6894] = {.count = 1, .reusable = true}, SHIFT(2910),
  [6896] = {.count = 1, .reusable = true}, SHIFT(2912),
  [6898] = {.count = 1, .reusable = true}, SHIFT(2914),
  [6900] = {.count = 1, .reusable = false}, SHIFT(2914),
  [6902] = {.count = 1, .reusable = true}, REDUCE(sym_for_statement, 7),
  [6904] = {.count = 1, .reusable = false}, REDUCE(sym_for_statement, 7),
  [6906] = {.count = 2, .reusable = true}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(2641),
  [6909] = {.count = 1, .reusable = true}, SHIFT(2917),
  [6911] = {.count = 1, .reusable = true}, SHIFT(2918),
  [6913] = {.count = 1, .reusable = false}, SHIFT(2919),
  [6915] = {.count = 1, .reusable = true}, SHIFT(2919),
  [6917] = {.count = 1, .reusable = false}, SHIFT(2922),
  [6919] = {.count = 2, .reusable = true}, REDUCE(aux_sym_function_declarator_repeat1, 2), SHIFT_REPEAT(2645),
  [6922] = {.count = 2, .reusable = true}, REDUCE(aux_sym_function_declarator_repeat1, 2), SHIFT_REPEAT(2801),
  [6925] = {.count = 1, .reusable = true}, REDUCE(sym_for_range_loop, 7),
  [6927] = {.count = 1, .reusable = false}, REDUCE(sym_for_range_loop, 7),
  [6929] = {.count = 2, .reusable = false}, REDUCE(aux_sym_sized_type_specifier_repeat1, 2), SHIFT_REPEAT(2811),
  [6932] = {.count = 2, .reusable = true}, REDUCE(aux_sym_abstract_function_declarator_repeat1, 2), SHIFT_REPEAT(2813),
  [6935] = {.count = 2, .reusable = true}, REDUCE(aux_sym_abstract_function_declarator_repeat1, 2), SHIFT_REPEAT(2817),
  [6938] = {.count = 2, .reusable = true}, REDUCE(aux_sym_abstract_function_declarator_repeat1, 2), SHIFT_REPEAT(2819),
  [6941] = {.count = 1, .reusable = true}, SHIFT(2928),
  [6943] = {.count = 1, .reusable = true}, SHIFT(2930),
  [6945] = {.count = 1, .reusable = true}, SHIFT(2931),
  [6947] = {.count = 1, .reusable = true}, SHIFT(2932),
  [6949] = {.count = 1, .reusable = true}, SHIFT(2933),
  [6951] = {.count = 1, .reusable = false}, SHIFT(2933),
  [6953] = {.count = 1, .reusable = true}, SHIFT(2934),
  [6955] = {.count = 1, .reusable = true}, SHIFT(2935),
  [6957] = {.count = 1, .reusable = true}, SHIFT(2937),
  [6959] = {.count = 1, .reusable = true}, SHIFT(2939),
  [6961] = {.count = 1, .reusable = true}, SHIFT(2938),
  [6963] = {.count = 1, .reusable = false}, SHIFT(2939),
  [6965] = {.count = 1, .reusable = true}, SHIFT(2941),
  [6967] = {.count = 1, .reusable = true}, SHIFT(2942),
  [6969] = {.count = 1, .reusable = true}, SHIFT(2943),
  [6971] = {.count = 1, .reusable = false}, SHIFT(2944),
  [6973] = {.count = 1, .reusable = false}, SHIFT(2945),
  [6975] = {.count = 1, .reusable = true}, SHIFT(2946),
  [6977] = {.count = 1, .reusable = true}, SHIFT(2948),
  [6979] = {.count = 1, .reusable = true}, SHIFT(2950),
  [6981] = {.count = 1, .reusable = true}, SHIFT(2952),
  [6983] = {.count = 1, .reusable = false}, SHIFT(2952),
  [6985] = {.count = 1, .reusable = true}, SHIFT(2953),
  [6987] = {.count = 1, .reusable = true}, SHIFT(2954),
  [6989] = {.count = 1, .reusable = true}, SHIFT(2955),
  [6991] = {.count = 1, .reusable = true}, SHIFT(2956),
  [6993] = {.count = 1, .reusable = false}, SHIFT(2956),
  [6995] = {.count = 1, .reusable = true}, SHIFT(2957),
  [6997] = {.count = 1, .reusable = true}, SHIFT(2958),
  [6999] = {.count = 1, .reusable = false}, SHIFT(2958),
  [7001] = {.count = 1, .reusable = true}, SHIFT(2959),
  [7003] = {.count = 1, .reusable = false}, SHIFT(2960),
  [7005] = {.count = 1, .reusable = false}, SHIFT(2961),
  [7007] = {.count = 1, .reusable = true}, SHIFT(2964),
  [7009] = {.count = 1, .reusable = false}, SHIFT(2964),
  [7011] = {.count = 1, .reusable = true}, SHIFT(2965),
  [7013] = {.count = 1, .reusable = true}, SHIFT(2967),
  [7015] = {.count = 1, .reusable = true}, SHIFT(2966),
  [7017] = {.count = 1, .reusable = false}, SHIFT(2967),
  [7019] = {.count = 1, .reusable = true}, SHIFT(2969),
  [7021] = {.count = 1, .reusable = true}, SHIFT(2970),
  [7023] = {.count = 1, .reusable = false}, SHIFT(2973),
  [7025] = {.count = 1, .reusable = true}, SHIFT(2975),
  [7027] = {.count = 1, .reusable = true}, SHIFT(2977),
  [7029] = {.count = 1, .reusable = false}, SHIFT(2977),
  [7031] = {.count = 1, .reusable = true}, SHIFT(2980),
  [7033] = {.count = 1, .reusable = false}, SHIFT(2983),
  [7035] = {.count = 1, .reusable = true}, SHIFT(2984),
  [7037] = {.count = 1, .reusable = true}, SHIFT(2987),
  [7039] = {.count = 1, .reusable = false}, SHIFT(2987),
  [7041] = {.count = 1, .reusable = true}, SHIFT(2989),
  [7043] = {.count = 1, .reusable = true}, SHIFT(2988),
  [7045] = {.count = 1, .reusable = false}, SHIFT(2989),
  [7047] = {.count = 1, .reusable = true}, SHIFT(2990),
  [7049] = {.count = 1, .reusable = true}, SHIFT(2991),
  [7051] = {.count = 1, .reusable = false}, SHIFT(2991),
  [7053] = {.count = 1, .reusable = true}, SHIFT(2992),
  [7055] = {.count = 1, .reusable = false}, SHIFT(2992),
  [7057] = {.count = 1, .reusable = true}, REDUCE(sym_if_statement, 8),
  [7059] = {.count = 1, .reusable = false}, REDUCE(sym_if_statement, 8),
  [7061] = {.count = 1, .reusable = true}, SHIFT(2993),
  [7063] = {.count = 1, .reusable = true}, SHIFT(2994),
  [7065] = {.count = 1, .reusable = false}, SHIFT(2994),
  [7067] = {.count = 1, .reusable = true}, SHIFT(2995),
  [7069] = {.count = 1, .reusable = true}, SHIFT(2996),
  [7071] = {.count = 1, .reusable = true}, SHIFT(2998),
  [7073] = {.count = 1, .reusable = true}, SHIFT(2997),
  [7075] = {.count = 1, .reusable = false}, SHIFT(2998),
  [7077] = {.count = 1, .reusable = true}, SHIFT(2999),
  [7079] = {.count = 1, .reusable = true}, SHIFT(3000),
  [7081] = {.count = 1, .reusable = true}, SHIFT(3003),
  [7083] = {.count = 1, .reusable = true}, REDUCE(sym_for_statement, 8),
  [7085] = {.count = 1, .reusable = false}, REDUCE(sym_for_statement, 8),
  [7087] = {.count = 2, .reusable = false}, REDUCE(aux_sym_sized_type_specifier_repeat1, 2), SHIFT_REPEAT(2922),
  [7090] = {.count = 1, .reusable = true}, SHIFT(3010),
  [7092] = {.count = 1, .reusable = true}, SHIFT(3012),
  [7094] = {.count = 1, .reusable = true}, SHIFT(3013),
  [7096] = {.count = 1, .reusable = true}, SHIFT(3014),
  [7098] = {.count = 1, .reusable = false}, SHIFT(3014),
  [7100] = {.count = 1, .reusable = true}, SHIFT(3015),
  [7102] = {.count = 1, .reusable = true}, SHIFT(3016),
  [7104] = {.count = 1, .reusable = false}, SHIFT(3016),
  [7106] = {.count = 1, .reusable = true}, SHIFT(3017),
  [7108] = {.count = 1, .reusable = false}, SHIFT(3018),
  [7110] = {.count = 1, .reusable = false}, SHIFT(3019),
  [7112] = {.count = 1, .reusable = true}, SHIFT(3022),
  [7114] = {.count = 1, .reusable = false}, SHIFT(3022),
  [7116] = {.count = 1, .reusable = true}, SHIFT(3023),
  [7118] = {.count = 1, .reusable = true}, SHIFT(3025),
  [7120] = {.count = 1, .reusable = true}, SHIFT(3024),
  [7122] = {.count = 1, .reusable = false}, SHIFT(3025),
  [7124] = {.count = 1, .reusable = true}, SHIFT(3027),
  [7126] = {.count = 1, .reusable = true}, SHIFT(3028),
  [7128] = {.count = 1, .reusable = false}, SHIFT(3031),
  [7130] = {.count = 1, .reusable = true}, SHIFT(3033),
  [7132] = {.count = 1, .reusable = true}, SHIFT(3035),
  [7134] = {.count = 1, .reusable = false}, SHIFT(3035),
  [7136] = {.count = 1, .reusable = true}, SHIFT(3037),
  [7138] = {.count = 1, .reusable = true}, SHIFT(3038),
  [7140] = {.count = 1, .reusable = false}, SHIFT(3038),
  [7142] = {.count = 1, .reusable = true}, SHIFT(3039),
  [7144] = {.count = 1, .reusable = false}, SHIFT(3041),
  [7146] = {.count = 1, .reusable = true}, SHIFT(3043),
  [7148] = {.count = 1, .reusable = true}, SHIFT(3045),
  [7150] = {.count = 1, .reusable = true}, SHIFT(3046),
  [7152] = {.count = 1, .reusable = true}, SHIFT(3048),
  [7154] = {.count = 1, .reusable = true}, SHIFT(3047),
  [7156] = {.count = 1, .reusable = false}, SHIFT(3048),
  [7158] = {.count = 1, .reusable = true}, SHIFT(3049),
  [7160] = {.count = 1, .reusable = true}, SHIFT(3050),
  [7162] = {.count = 1, .reusable = true}, SHIFT(3053),
  [7164] = {.count = 1, .reusable = false}, SHIFT(3055),
  [7166] = {.count = 1, .reusable = true}, SHIFT(3057),
  [7168] = {.count = 1, .reusable = true}, SHIFT(3059),
  [7170] = {.count = 1, .reusable = true}, SHIFT(3060),
  [7172] = {.count = 1, .reusable = true}, SHIFT(3062),
  [7174] = {.count = 1, .reusable = true}, SHIFT(3064),
  [7176] = {.count = 1, .reusable = false}, SHIFT(3064),
  [7178] = {.count = 1, .reusable = true}, SHIFT(3065),
  [7180] = {.count = 1, .reusable = true}, SHIFT(3066),
  [7182] = {.count = 1, .reusable = true}, SHIFT(3068),
  [7184] = {.count = 1, .reusable = true}, SHIFT(3070),
  [7186] = {.count = 1, .reusable = true}, SHIFT(3069),
  [7188] = {.count = 1, .reusable = false}, SHIFT(3070),
  [7190] = {.count = 1, .reusable = true}, SHIFT(3071),
  [7192] = {.count = 1, .reusable = true}, SHIFT(3072),
  [7194] = {.count = 1, .reusable = false}, SHIFT(3072),
  [7196] = {.count = 1, .reusable = true}, SHIFT(3073),
  [7198] = {.count = 1, .reusable = false}, SHIFT(3073),
  [7200] = {.count = 1, .reusable = true}, SHIFT(3075),
  [7202] = {.count = 1, .reusable = true}, REDUCE(sym_for_statement, 9),
  [7204] = {.count = 1, .reusable = false}, REDUCE(sym_for_statement, 9),
  [7206] = {.count = 1, .reusable = true}, SHIFT(3077),
  [7208] = {.count = 2, .reusable = true}, REDUCE(aux_sym_abstract_function_declarator_repeat1, 2), SHIFT_REPEAT(3012),
  [7211] = {.count = 1, .reusable = true}, SHIFT(3079),
  [7213] = {.count = 1, .reusable = true}, SHIFT(3080),
  [7215] = {.count = 1, .reusable = false}, SHIFT(3080),
  [7217] = {.count = 1, .reusable = true}, SHIFT(3081),
  [7219] = {.count = 1, .reusable = false}, SHIFT(3083),
  [7221] = {.count = 1, .reusable = true}, SHIFT(3085),
  [7223] = {.count = 1, .reusable = true}, SHIFT(3087),
  [7225] = {.count = 1, .reusable = true}, SHIFT(3088),
  [7227] = {.count = 1, .reusable = true}, SHIFT(3090),
  [7229] = {.count = 1, .reusable = true}, SHIFT(3089),
  [7231] = {.count = 1, .reusable = false}, SHIFT(3090),
  [7233] = {.count = 1, .reusable = true}, SHIFT(3091),
  [7235] = {.count = 1, .reusable = true}, SHIFT(3092),
  [7237] = {.count = 1, .reusable = true}, SHIFT(3095),
  [7239] = {.count = 1, .reusable = true}, SHIFT(3098),
  [7241] = {.count = 1, .reusable = false}, SHIFT(3101),
  [7243] = {.count = 1, .reusable = true}, SHIFT(3102),
  [7245] = {.count = 1, .reusable = true}, SHIFT(3105),
  [7247] = {.count = 1, .reusable = false}, SHIFT(3105),
  [7249] = {.count = 1, .reusable = true}, SHIFT(3107),
  [7251] = {.count = 1, .reusable = true}, SHIFT(3106),
  [7253] = {.count = 1, .reusable = false}, SHIFT(3107),
  [7255] = {.count = 1, .reusable = true}, SHIFT(3108),
  [7257] = {.count = 1, .reusable = true}, SHIFT(3109),
  [7259] = {.count = 1, .reusable = false}, SHIFT(3109),
  [7261] = {.count = 1, .reusable = true}, SHIFT(3110),
  [7263] = {.count = 1, .reusable = false}, SHIFT(3110),
  [7265] = {.count = 1, .reusable = true}, SHIFT(3112),
  [7267] = {.count = 1, .reusable = false}, SHIFT(3114),
  [7269] = {.count = 1, .reusable = true}, SHIFT(3115),
  [7271] = {.count = 1, .reusable = true}, SHIFT(3117),
  [7273] = {.count = 1, .reusable = true}, SHIFT(3119),
  [7275] = {.count = 1, .reusable = false}, SHIFT(3119),
  [7277] = {.count = 1, .reusable = true}, SHIFT(3121),
  [7279] = {.count = 1, .reusable = true}, SHIFT(3123),
  [7281] = {.count = 1, .reusable = true}, SHIFT(3125),
  [7283] = {.count = 1, .reusable = false}, SHIFT(3125),
  [7285] = {.count = 1, .reusable = true}, SHIFT(3126),
  [7287] = {.count = 1, .reusable = true}, SHIFT(3127),
  [7289] = {.count = 2, .reusable = true}, REDUCE(aux_sym_abstract_function_declarator_repeat1, 2), SHIFT_REPEAT(3077),
  [7292] = {.count = 1, .reusable = true}, REDUCE(sym_for_statement, 10),
  [7294] = {.count = 1, .reusable = false}, REDUCE(sym_for_statement, 10),
  [7296] = {.count = 1, .reusable = true}, SHIFT(3130),
  [7298] = {.count = 1, .reusable = false}, SHIFT(3133),
  [7300] = {.count = 1, .reusable = true}, SHIFT(3134),
  [7302] = {.count = 1, .reusable = true}, SHIFT(3137),
  [7304] = {.count = 1, .reusable = false}, SHIFT(3137),
  [7306] = {.count = 1, .reusable = true}, SHIFT(3139),
  [7308] = {.count = 1, .reusable = true}, SHIFT(3138),
  [7310] = {.count = 1, .reusable = false}, SHIFT(3139),
  [7312] = {.count = 1, .reusable = true}, SHIFT(3140),
  [7314] = {.count = 1, .reusable = true}, SHIFT(3141),
  [7316] = {.count = 1, .reusable = false}, SHIFT(3141),
  [7318] = {.count = 1, .reusable = true}, SHIFT(3142),
  [7320] = {.count = 1, .reusable = false}, SHIFT(3142),
  [7322] = {.count = 1, .reusable = true}, SHIFT(3144),
  [7324] = {.count = 1, .reusable = false}, SHIFT(3145),
  [7326] = {.count = 1, .reusable = true}, SHIFT(3147),
  [7328] = {.count = 1, .reusable = true}, SHIFT(3149),
  [7330] = {.count = 1, .reusable = true}, SHIFT(3150),
  [7332] = {.count = 1, .reusable = true}, SHIFT(3152),
  [7334] = {.count = 1, .reusable = true}, SHIFT(3154),
  [7336] = {.count = 1, .reusable = false}, SHIFT(3154),
  [7338] = {.count = 1, .reusable = true}, SHIFT(3155),
  [7340] = {.count = 1, .reusable = true}, SHIFT(3156),
  [7342] = {.count = 1, .reusable = true}, SHIFT(3160),
  [7344] = {.count = 1, .reusable = true}, SHIFT(3162),
  [7346] = {.count = 1, .reusable = true}, SHIFT(3163),
  [7348] = {.count = 1, .reusable = true}, SHIFT(3165),
  [7350] = {.count = 1, .reusable = false}, SHIFT(3165),
  [7352] = {.count = 1, .reusable = false}, SHIFT(3166),
  [7354] = {.count = 1, .reusable = true}, SHIFT(3168),
  [7356] = {.count = 1, .reusable = true}, SHIFT(3170),
  [7358] = {.count = 1, .reusable = true}, SHIFT(3171),
  [7360] = {.count = 1, .reusable = true}, SHIFT(3173),
  [7362] = {.count = 1, .reusable = true}, SHIFT(3175),
  [7364] = {.count = 1, .reusable = false}, SHIFT(3175),
  [7366] = {.count = 1, .reusable = true}, SHIFT(3176),
  [7368] = {.count = 1, .reusable = true}, SHIFT(3177),
  [7370] = {.count = 1, .reusable = false}, SHIFT(3180),
  [7372] = {.count = 1, .reusable = true}, SHIFT(3181),
  [7374] = {.count = 1, .reusable = true}, SHIFT(3183),
  [7376] = {.count = 1, .reusable = true}, SHIFT(3185),
  [7378] = {.count = 1, .reusable = false}, SHIFT(3185),
  [7380] = {.count = 1, .reusable = true}, SHIFT(3188),
  [7382] = {.count = 1, .reusable = true}, SHIFT(3189),
  [7384] = {.count = 1, .reusable = false}, SHIFT(3192),
  [7386] = {.count = 1, .reusable = true}, SHIFT(3193),
  [7388] = {.count = 1, .reusable = true}, SHIFT(3195),
  [7390] = {.count = 1, .reusable = true}, SHIFT(3197),
  [7392] = {.count = 1, .reusable = false}, SHIFT(3197),
  [7394] = {.count = 1, .reusable = true}, SHIFT(3201),
  [7396] = {.count = 1, .reusable = true}, SHIFT(3204),
  [7398] = {.count = 1, .reusable = true}, SHIFT(3207),
  [7400] = {.count = 1, .reusable = true}, SHIFT(3210),
  [7402] = {.count = 1, .reusable = true}, SHIFT(3212),
};

void *tree_sitter_cpp_external_scanner_create();
void tree_sitter_cpp_external_scanner_destroy(void *);
bool tree_sitter_cpp_external_scanner_scan(void *, TSLexer *, const bool *);
unsigned tree_sitter_cpp_external_scanner_serialize(void *, char *);
void tree_sitter_cpp_external_scanner_deserialize(void *, const char *, unsigned);

#ifdef _WIN32
#define extern __declspec(dllexport)
#endif

extern const TSLanguage *tree_sitter_cpp() {
  static TSLanguage language = {
    .version = LANGUAGE_VERSION,
    .symbol_count = SYMBOL_COUNT,
    .alias_count = ALIAS_COUNT,
    .token_count = TOKEN_COUNT,
    .symbol_metadata = ts_symbol_metadata,
    .parse_table = (const unsigned short *)ts_parse_table,
    .parse_actions = ts_parse_actions,
    .lex_modes = ts_lex_modes,
    .symbol_names = ts_symbol_names,
    .alias_sequences = (const TSSymbol *)ts_alias_sequences,
    .max_alias_sequence_length = MAX_ALIAS_SEQUENCE_LENGTH,
    .lex_fn = ts_lex,
    .external_token_count = EXTERNAL_TOKEN_COUNT,
    .external_scanner = {
      (const bool *)ts_external_scanner_states,
      ts_external_scanner_symbol_map,
      tree_sitter_cpp_external_scanner_create,
      tree_sitter_cpp_external_scanner_destroy,
      tree_sitter_cpp_external_scanner_scan,
      tree_sitter_cpp_external_scanner_serialize,
      tree_sitter_cpp_external_scanner_deserialize,
    },
  };
  return &language;
}
