#include <tree_sitter/parser.h>

#if defined(__GNUC__) || defined(__clang__)
#pragma GCC diagnostic push
#pragma GCC diagnostic ignored "-Wmissing-field-initializers"
#endif

#define LANGUAGE_VERSION 8
#define STATE_COUNT 1962
#define SYMBOL_COUNT 198
#define ALIAS_COUNT 2
#define TOKEN_COUNT 93
#define EXTERNAL_TOKEN_COUNT 3
#define MAX_ALIAS_SEQUENCE_LENGTH 5

enum {
  sym__newline = 1,
  sym__indent = 2,
  sym__dedent = 3,
  anon_sym_import = 4,
  anon_sym_DOT = 5,
  anon_sym_from = 6,
  anon_sym_LPAREN = 7,
  anon_sym_RPAREN = 8,
  anon_sym_COMMA = 9,
  anon_sym_as = 10,
  anon_sym_STAR = 11,
  anon_sym_print = 12,
  anon_sym_GT_GT = 13,
  anon_sym_assert = 14,
  anon_sym_return = 15,
  anon_sym_del = 16,
  anon_sym_raise = 17,
  sym_pass_statement = 18,
  sym_break_statement = 19,
  sym_continue_statement = 20,
  anon_sym_if = 21,
  anon_sym_COLON = 22,
  anon_sym_elif = 23,
  anon_sym_else = 24,
  anon_sym_async = 25,
  anon_sym_for = 26,
  anon_sym_in = 27,
  anon_sym_while = 28,
  anon_sym_try = 29,
  anon_sym_except = 30,
  anon_sym_finally = 31,
  anon_sym_with = 32,
  anon_sym_def = 33,
  anon_sym_DASH_GT = 34,
  anon_sym_EQ = 35,
  anon_sym_global = 36,
  anon_sym_nonlocal = 37,
  anon_sym_exec = 38,
  anon_sym_class = 39,
  anon_sym_AT = 40,
  anon_sym_not = 41,
  anon_sym_and = 42,
  anon_sym_or = 43,
  anon_sym_PLUS = 44,
  anon_sym_DASH = 45,
  anon_sym_SLASH = 46,
  anon_sym_PERCENT = 47,
  anon_sym_SLASH_SLASH = 48,
  anon_sym_STAR_STAR = 49,
  anon_sym_PIPE = 50,
  anon_sym_AMP = 51,
  anon_sym_CARET = 52,
  anon_sym_LT_LT = 53,
  anon_sym_TILDE = 54,
  anon_sym_LT = 55,
  anon_sym_LT_EQ = 56,
  anon_sym_EQ_EQ = 57,
  anon_sym_BANG_EQ = 58,
  anon_sym_GT_EQ = 59,
  anon_sym_GT = 60,
  anon_sym_LT_GT = 61,
  anon_sym_is = 62,
  anon_sym_lambda = 63,
  anon_sym_PLUS_EQ = 64,
  anon_sym_DASH_EQ = 65,
  anon_sym_STAR_EQ = 66,
  anon_sym_SLASH_EQ = 67,
  anon_sym_AT_EQ = 68,
  anon_sym_SLASH_SLASH_EQ = 69,
  anon_sym_PERCENT_EQ = 70,
  anon_sym_STAR_STAR_EQ = 71,
  anon_sym_GT_GT_EQ = 72,
  anon_sym_LT_LT_EQ = 73,
  anon_sym_AMP_EQ = 74,
  anon_sym_CARET_EQ = 75,
  anon_sym_PIPE_EQ = 76,
  anon_sym_yield = 77,
  anon_sym_LBRACK = 78,
  anon_sym_RBRACK = 79,
  sym_ellipsis = 80,
  anon_sym_LBRACE = 81,
  anon_sym_RBRACE = 82,
  sym_string = 83,
  sym_integer = 84,
  sym_float = 85,
  sym_identifier = 86,
  sym_true = 87,
  sym_false = 88,
  sym_none = 89,
  anon_sym_await = 90,
  sym_comment = 91,
  sym__semicolon = 92,
  sym_module = 93,
  sym__statement = 94,
  sym__simple_statements = 95,
  sym_import_statement = 96,
  sym_import_prefix = 97,
  sym_relative_import = 98,
  sym_import_from_statement = 99,
  sym__import_list = 100,
  sym_aliased_import = 101,
  sym_wildcard_import = 102,
  sym_print_statement = 103,
  sym_chevron = 104,
  sym_assert_statement = 105,
  sym_expression_statement = 106,
  sym_return_statement = 107,
  sym_delete_statement = 108,
  sym_raise_statement = 109,
  sym_if_statement = 110,
  sym_elif_clause = 111,
  sym_else_clause = 112,
  sym_for_statement = 113,
  sym_while_statement = 114,
  sym_try_statement = 115,
  sym_except_clause = 116,
  sym_finally_clause = 117,
  sym_with_statement = 118,
  sym_with_item = 119,
  sym_function_definition = 120,
  sym_parameters = 121,
  sym_lambda_parameters = 122,
  sym__parameters = 123,
  sym_default_parameter = 124,
  sym_typed_default_parameter = 125,
  sym_list_splat = 126,
  sym_dictionary_splat = 127,
  sym_global_statement = 128,
  sym_nonlocal_statement = 129,
  sym_exec_statement = 130,
  sym_class_definition = 131,
  sym_argument_list = 132,
  sym_decorated_definition = 133,
  sym_decorator = 134,
  sym__suite = 135,
  sym_variables = 136,
  sym_expression_list = 137,
  sym_dotted_name = 138,
  sym__expression_within_for_in_clause = 139,
  sym__expression = 140,
  sym__primary_expression = 141,
  sym_not_operator = 142,
  sym_boolean_operator = 143,
  sym_binary_operator = 144,
  sym_unary_operator = 145,
  sym_comparison_operator = 146,
  sym_lambda = 147,
  sym_lambda_within_for_in_clause = 148,
  sym_assignment = 149,
  sym_augmented_assignment = 150,
  sym__right_hand_side = 151,
  sym_yield = 152,
  sym_attribute = 153,
  sym_subscript = 154,
  sym_slice = 155,
  sym_call = 156,
  sym_typed_parameter = 157,
  sym_type = 158,
  sym_keyword_argument = 159,
  sym_list = 160,
  sym__comprehension_body = 161,
  sym_list_comprehension = 162,
  sym_dictionary = 163,
  sym_dictionary_comprehension = 164,
  sym_pair = 165,
  sym_set = 166,
  sym_set_comprehension = 167,
  sym_parenthesized_expression = 168,
  sym_tuple = 169,
  sym_generator_expression = 170,
  sym_for_in_clause = 171,
  sym_if_clause = 172,
  sym_conditional_expression = 173,
  sym_concatenated_string = 174,
  sym_await = 175,
  aux_sym_module_repeat1 = 176,
  aux_sym__simple_statements_repeat1 = 177,
  aux_sym_import_prefix_repeat1 = 178,
  aux_sym__import_list_repeat1 = 179,
  aux_sym_print_statement_repeat1 = 180,
  aux_sym_if_statement_repeat1 = 181,
  aux_sym_try_statement_repeat1 = 182,
  aux_sym_with_statement_repeat1 = 183,
  aux_sym__parameters_repeat1 = 184,
  aux_sym_global_statement_repeat1 = 185,
  aux_sym_argument_list_repeat1 = 186,
  aux_sym_decorated_definition_repeat1 = 187,
  aux_sym_variables_repeat1 = 188,
  aux_sym_dotted_name_repeat1 = 189,
  aux_sym_comparison_operator_repeat1 = 190,
  aux_sym_subscript_repeat1 = 191,
  aux_sym_list_repeat1 = 192,
  aux_sym__comprehension_body_repeat1 = 193,
  aux_sym_dictionary_repeat1 = 194,
  aux_sym_tuple_repeat1 = 195,
  aux_sym_for_in_clause_repeat1 = 196,
  aux_sym_concatenated_string_repeat1 = 197,
  alias_sym_identifier = 198,
  alias_sym_lambda = 199,
};

static const char *ts_symbol_names[] = {
  [sym__newline] = "_newline",
  [sym__indent] = "_indent",
  [sym__dedent] = "_dedent",
  [ts_builtin_sym_end] = "END",
  [anon_sym_import] = "import",
  [anon_sym_DOT] = ".",
  [anon_sym_from] = "from",
  [anon_sym_LPAREN] = "(",
  [anon_sym_RPAREN] = ")",
  [anon_sym_COMMA] = ",",
  [anon_sym_as] = "as",
  [anon_sym_STAR] = "*",
  [anon_sym_print] = "print",
  [anon_sym_GT_GT] = ">>",
  [anon_sym_assert] = "assert",
  [anon_sym_return] = "return",
  [anon_sym_del] = "del",
  [anon_sym_raise] = "raise",
  [sym_pass_statement] = "pass_statement",
  [sym_break_statement] = "break_statement",
  [sym_continue_statement] = "continue_statement",
  [anon_sym_if] = "if",
  [anon_sym_COLON] = ":",
  [anon_sym_elif] = "elif",
  [anon_sym_else] = "else",
  [anon_sym_async] = "async",
  [anon_sym_for] = "for",
  [anon_sym_in] = "in",
  [anon_sym_while] = "while",
  [anon_sym_try] = "try",
  [anon_sym_except] = "except",
  [anon_sym_finally] = "finally",
  [anon_sym_with] = "with",
  [anon_sym_def] = "def",
  [anon_sym_DASH_GT] = "->",
  [anon_sym_EQ] = "=",
  [anon_sym_global] = "global",
  [anon_sym_nonlocal] = "nonlocal",
  [anon_sym_exec] = "exec",
  [anon_sym_class] = "class",
  [anon_sym_AT] = "@",
  [anon_sym_not] = "not",
  [anon_sym_and] = "and",
  [anon_sym_or] = "or",
  [anon_sym_PLUS] = "+",
  [anon_sym_DASH] = "-",
  [anon_sym_SLASH] = "/",
  [anon_sym_PERCENT] = "%",
  [anon_sym_SLASH_SLASH] = "//",
  [anon_sym_STAR_STAR] = "**",
  [anon_sym_PIPE] = "|",
  [anon_sym_AMP] = "&",
  [anon_sym_CARET] = "^",
  [anon_sym_LT_LT] = "<<",
  [anon_sym_TILDE] = "~",
  [anon_sym_LT] = "<",
  [anon_sym_LT_EQ] = "<=",
  [anon_sym_EQ_EQ] = "==",
  [anon_sym_BANG_EQ] = "!=",
  [anon_sym_GT_EQ] = ">=",
  [anon_sym_GT] = ">",
  [anon_sym_LT_GT] = "<>",
  [anon_sym_is] = "is",
  [anon_sym_lambda] = "lambda",
  [anon_sym_PLUS_EQ] = "+=",
  [anon_sym_DASH_EQ] = "-=",
  [anon_sym_STAR_EQ] = "*=",
  [anon_sym_SLASH_EQ] = "/=",
  [anon_sym_AT_EQ] = "@=",
  [anon_sym_SLASH_SLASH_EQ] = "//=",
  [anon_sym_PERCENT_EQ] = "%=",
  [anon_sym_STAR_STAR_EQ] = "**=",
  [anon_sym_GT_GT_EQ] = ">>=",
  [anon_sym_LT_LT_EQ] = "<<=",
  [anon_sym_AMP_EQ] = "&=",
  [anon_sym_CARET_EQ] = "^=",
  [anon_sym_PIPE_EQ] = "|=",
  [anon_sym_yield] = "yield",
  [anon_sym_LBRACK] = "[",
  [anon_sym_RBRACK] = "]",
  [sym_ellipsis] = "ellipsis",
  [anon_sym_LBRACE] = "{",
  [anon_sym_RBRACE] = "}",
  [sym_string] = "string",
  [sym_integer] = "integer",
  [sym_float] = "float",
  [sym_identifier] = "identifier",
  [sym_true] = "true",
  [sym_false] = "false",
  [sym_none] = "none",
  [anon_sym_await] = "await",
  [sym_comment] = "comment",
  [sym__semicolon] = "_semicolon",
  [sym_module] = "module",
  [sym__statement] = "_statement",
  [sym__simple_statements] = "_simple_statements",
  [sym_import_statement] = "import_statement",
  [sym_import_prefix] = "import_prefix",
  [sym_relative_import] = "relative_import",
  [sym_import_from_statement] = "import_from_statement",
  [sym__import_list] = "_import_list",
  [sym_aliased_import] = "aliased_import",
  [sym_wildcard_import] = "wildcard_import",
  [sym_print_statement] = "print_statement",
  [sym_chevron] = "chevron",
  [sym_assert_statement] = "assert_statement",
  [sym_expression_statement] = "expression_statement",
  [sym_return_statement] = "return_statement",
  [sym_delete_statement] = "delete_statement",
  [sym_raise_statement] = "raise_statement",
  [sym_if_statement] = "if_statement",
  [sym_elif_clause] = "elif_clause",
  [sym_else_clause] = "else_clause",
  [sym_for_statement] = "for_statement",
  [sym_while_statement] = "while_statement",
  [sym_try_statement] = "try_statement",
  [sym_except_clause] = "except_clause",
  [sym_finally_clause] = "finally_clause",
  [sym_with_statement] = "with_statement",
  [sym_with_item] = "with_item",
  [sym_function_definition] = "function_definition",
  [sym_parameters] = "parameters",
  [sym_lambda_parameters] = "lambda_parameters",
  [sym__parameters] = "_parameters",
  [sym_default_parameter] = "default_parameter",
  [sym_typed_default_parameter] = "typed_default_parameter",
  [sym_list_splat] = "list_splat",
  [sym_dictionary_splat] = "dictionary_splat",
  [sym_global_statement] = "global_statement",
  [sym_nonlocal_statement] = "nonlocal_statement",
  [sym_exec_statement] = "exec_statement",
  [sym_class_definition] = "class_definition",
  [sym_argument_list] = "argument_list",
  [sym_decorated_definition] = "decorated_definition",
  [sym_decorator] = "decorator",
  [sym__suite] = "_suite",
  [sym_variables] = "variables",
  [sym_expression_list] = "expression_list",
  [sym_dotted_name] = "dotted_name",
  [sym__expression_within_for_in_clause] = "_expression_within_for_in_clause",
  [sym__expression] = "_expression",
  [sym__primary_expression] = "_primary_expression",
  [sym_not_operator] = "not_operator",
  [sym_boolean_operator] = "boolean_operator",
  [sym_binary_operator] = "binary_operator",
  [sym_unary_operator] = "unary_operator",
  [sym_comparison_operator] = "comparison_operator",
  [sym_lambda] = "lambda",
  [sym_lambda_within_for_in_clause] = "lambda_within_for_in_clause",
  [sym_assignment] = "assignment",
  [sym_augmented_assignment] = "augmented_assignment",
  [sym__right_hand_side] = "_right_hand_side",
  [sym_yield] = "yield",
  [sym_attribute] = "attribute",
  [sym_subscript] = "subscript",
  [sym_slice] = "slice",
  [sym_call] = "call",
  [sym_typed_parameter] = "typed_parameter",
  [sym_type] = "type",
  [sym_keyword_argument] = "keyword_argument",
  [sym_list] = "list",
  [sym__comprehension_body] = "_comprehension_body",
  [sym_list_comprehension] = "list_comprehension",
  [sym_dictionary] = "dictionary",
  [sym_dictionary_comprehension] = "dictionary_comprehension",
  [sym_pair] = "pair",
  [sym_set] = "set",
  [sym_set_comprehension] = "set_comprehension",
  [sym_parenthesized_expression] = "parenthesized_expression",
  [sym_tuple] = "tuple",
  [sym_generator_expression] = "generator_expression",
  [sym_for_in_clause] = "for_in_clause",
  [sym_if_clause] = "if_clause",
  [sym_conditional_expression] = "conditional_expression",
  [sym_concatenated_string] = "concatenated_string",
  [sym_await] = "await",
  [aux_sym_module_repeat1] = "module_repeat1",
  [aux_sym__simple_statements_repeat1] = "_simple_statements_repeat1",
  [aux_sym_import_prefix_repeat1] = "import_prefix_repeat1",
  [aux_sym__import_list_repeat1] = "_import_list_repeat1",
  [aux_sym_print_statement_repeat1] = "print_statement_repeat1",
  [aux_sym_if_statement_repeat1] = "if_statement_repeat1",
  [aux_sym_try_statement_repeat1] = "try_statement_repeat1",
  [aux_sym_with_statement_repeat1] = "with_statement_repeat1",
  [aux_sym__parameters_repeat1] = "_parameters_repeat1",
  [aux_sym_global_statement_repeat1] = "global_statement_repeat1",
  [aux_sym_argument_list_repeat1] = "argument_list_repeat1",
  [aux_sym_decorated_definition_repeat1] = "decorated_definition_repeat1",
  [aux_sym_variables_repeat1] = "variables_repeat1",
  [aux_sym_dotted_name_repeat1] = "dotted_name_repeat1",
  [aux_sym_comparison_operator_repeat1] = "comparison_operator_repeat1",
  [aux_sym_subscript_repeat1] = "subscript_repeat1",
  [aux_sym_list_repeat1] = "list_repeat1",
  [aux_sym__comprehension_body_repeat1] = "_comprehension_body_repeat1",
  [aux_sym_dictionary_repeat1] = "dictionary_repeat1",
  [aux_sym_tuple_repeat1] = "tuple_repeat1",
  [aux_sym_for_in_clause_repeat1] = "for_in_clause_repeat1",
  [aux_sym_concatenated_string_repeat1] = "concatenated_string_repeat1",
  [alias_sym_identifier] = "identifier",
  [alias_sym_lambda] = "lambda",
};

static const TSSymbolMetadata ts_symbol_metadata[] = {
  [sym__newline] = {
    .visible = false,
    .named = true,
  },
  [sym__indent] = {
    .visible = false,
    .named = true,
  },
  [sym__dedent] = {
    .visible = false,
    .named = true,
  },
  [ts_builtin_sym_end] = {
    .visible = false,
    .named = true,
  },
  [anon_sym_import] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_from] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COMMA] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_as] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_print] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_assert] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_return] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_del] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_raise] = {
    .visible = true,
    .named = false,
  },
  [sym_pass_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_break_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_continue_statement] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_if] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_elif] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_else] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_async] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_for] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_in] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_while] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_try] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_except] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_finally] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_with] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_def] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_global] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_nonlocal] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_exec] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_class] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_not] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_and] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_or] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PERCENT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH_SLASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR_STAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_CARET] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_TILDE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_is] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_lambda] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH_SLASH_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PERCENT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR_STAR_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_LT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_CARET_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_yield] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACK] = {
    .visible = true,
    .named = false,
  },
  [sym_ellipsis] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_LBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACE] = {
    .visible = true,
    .named = false,
  },
  [sym_string] = {
    .visible = true,
    .named = true,
  },
  [sym_integer] = {
    .visible = true,
    .named = true,
  },
  [sym_float] = {
    .visible = true,
    .named = true,
  },
  [sym_identifier] = {
    .visible = true,
    .named = true,
  },
  [sym_true] = {
    .visible = true,
    .named = true,
  },
  [sym_false] = {
    .visible = true,
    .named = true,
  },
  [sym_none] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_await] = {
    .visible = true,
    .named = false,
  },
  [sym_comment] = {
    .visible = true,
    .named = true,
  },
  [sym__semicolon] = {
    .visible = false,
    .named = true,
  },
  [sym_module] = {
    .visible = true,
    .named = true,
  },
  [sym__statement] = {
    .visible = false,
    .named = true,
  },
  [sym__simple_statements] = {
    .visible = false,
    .named = true,
  },
  [sym_import_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_import_prefix] = {
    .visible = true,
    .named = true,
  },
  [sym_relative_import] = {
    .visible = true,
    .named = true,
  },
  [sym_import_from_statement] = {
    .visible = true,
    .named = true,
  },
  [sym__import_list] = {
    .visible = false,
    .named = true,
  },
  [sym_aliased_import] = {
    .visible = true,
    .named = true,
  },
  [sym_wildcard_import] = {
    .visible = true,
    .named = true,
  },
  [sym_print_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_chevron] = {
    .visible = true,
    .named = true,
  },
  [sym_assert_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_expression_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_return_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_delete_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_raise_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_if_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_elif_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_else_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_for_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_while_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_try_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_except_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_finally_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_with_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_with_item] = {
    .visible = true,
    .named = true,
  },
  [sym_function_definition] = {
    .visible = true,
    .named = true,
  },
  [sym_parameters] = {
    .visible = true,
    .named = true,
  },
  [sym_lambda_parameters] = {
    .visible = true,
    .named = true,
  },
  [sym__parameters] = {
    .visible = false,
    .named = true,
  },
  [sym_default_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym_typed_default_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym_list_splat] = {
    .visible = true,
    .named = true,
  },
  [sym_dictionary_splat] = {
    .visible = true,
    .named = true,
  },
  [sym_global_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_nonlocal_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_exec_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_class_definition] = {
    .visible = true,
    .named = true,
  },
  [sym_argument_list] = {
    .visible = true,
    .named = true,
  },
  [sym_decorated_definition] = {
    .visible = true,
    .named = true,
  },
  [sym_decorator] = {
    .visible = true,
    .named = true,
  },
  [sym__suite] = {
    .visible = false,
    .named = true,
  },
  [sym_variables] = {
    .visible = true,
    .named = true,
  },
  [sym_expression_list] = {
    .visible = true,
    .named = true,
  },
  [sym_dotted_name] = {
    .visible = true,
    .named = true,
  },
  [sym__expression_within_for_in_clause] = {
    .visible = false,
    .named = true,
  },
  [sym__expression] = {
    .visible = false,
    .named = true,
  },
  [sym__primary_expression] = {
    .visible = false,
    .named = true,
  },
  [sym_not_operator] = {
    .visible = true,
    .named = true,
  },
  [sym_boolean_operator] = {
    .visible = true,
    .named = true,
  },
  [sym_binary_operator] = {
    .visible = true,
    .named = true,
  },
  [sym_unary_operator] = {
    .visible = true,
    .named = true,
  },
  [sym_comparison_operator] = {
    .visible = true,
    .named = true,
  },
  [sym_lambda] = {
    .visible = true,
    .named = true,
  },
  [sym_lambda_within_for_in_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_assignment] = {
    .visible = true,
    .named = true,
  },
  [sym_augmented_assignment] = {
    .visible = true,
    .named = true,
  },
  [sym__right_hand_side] = {
    .visible = false,
    .named = true,
  },
  [sym_yield] = {
    .visible = true,
    .named = true,
  },
  [sym_attribute] = {
    .visible = true,
    .named = true,
  },
  [sym_subscript] = {
    .visible = true,
    .named = true,
  },
  [sym_slice] = {
    .visible = true,
    .named = true,
  },
  [sym_call] = {
    .visible = true,
    .named = true,
  },
  [sym_typed_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym_type] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_argument] = {
    .visible = true,
    .named = true,
  },
  [sym_list] = {
    .visible = true,
    .named = true,
  },
  [sym__comprehension_body] = {
    .visible = false,
    .named = true,
  },
  [sym_list_comprehension] = {
    .visible = true,
    .named = true,
  },
  [sym_dictionary] = {
    .visible = true,
    .named = true,
  },
  [sym_dictionary_comprehension] = {
    .visible = true,
    .named = true,
  },
  [sym_pair] = {
    .visible = true,
    .named = true,
  },
  [sym_set] = {
    .visible = true,
    .named = true,
  },
  [sym_set_comprehension] = {
    .visible = true,
    .named = true,
  },
  [sym_parenthesized_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_tuple] = {
    .visible = true,
    .named = true,
  },
  [sym_generator_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_for_in_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_if_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_conditional_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_concatenated_string] = {
    .visible = true,
    .named = true,
  },
  [sym_await] = {
    .visible = true,
    .named = true,
  },
  [aux_sym_module_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__simple_statements_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_import_prefix_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__import_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_print_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_if_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_try_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_with_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__parameters_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_global_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_argument_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_decorated_definition_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_variables_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_dotted_name_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_comparison_operator_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_subscript_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__comprehension_body_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_dictionary_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_tuple_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_for_in_clause_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_concatenated_string_repeat1] = {
    .visible = false,
    .named = false,
  },
  [alias_sym_identifier] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_lambda] = {
    .visible = true,
    .named = true,
  },
};

static TSSymbol ts_alias_sequences[4][MAX_ALIAS_SEQUENCE_LENGTH] = {
  [1] = {
    [0] = alias_sym_identifier,
  },
  [2] = {
    [1] = alias_sym_identifier,
  },
  [3] = {
    [0] = alias_sym_lambda,
  },
};

static bool ts_lex(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  switch (state) {
    case 0:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '\"')
        ADVANCE(4);
      if (lookahead == '#')
        ADVANCE(13);
      if (lookahead == '%')
        ADVANCE(14);
      if (lookahead == '&')
        ADVANCE(16);
      if (lookahead == '\'')
        ADVANCE(18);
      if (lookahead == '(')
        ADVANCE(26);
      if (lookahead == ')')
        ADVANCE(27);
      if (lookahead == '*')
        ADVANCE(28);
      if (lookahead == '+')
        ADVANCE(32);
      if (lookahead == ',')
        ADVANCE(34);
      if (lookahead == '-')
        ADVANCE(35);
      if (lookahead == '.')
        ADVANCE(38);
      if (lookahead == '/')
        ADVANCE(47);
      if (lookahead == '0')
        ADVANCE(51);
      if (lookahead == ':')
        ADVANCE(66);
      if (lookahead == ';')
        ADVANCE(67);
      if (lookahead == '<')
        ADVANCE(68);
      if (lookahead == '=')
        ADVANCE(73);
      if (lookahead == '>')
        ADVANCE(75);
      if (lookahead == '@')
        ADVANCE(79);
      if (lookahead == 'F')
        ADVANCE(81);
      if (lookahead == 'N')
        ADVANCE(87);
      if (lookahead == 'T')
        ADVANCE(91);
      if (lookahead == '[')
        ADVANCE(95);
      if (lookahead == '\\')
        SKIP(96);
      if (lookahead == ']')
        ADVANCE(98);
      if (lookahead == '^')
        ADVANCE(99);
      if (lookahead == '`')
        ADVANCE(101);
      if (lookahead == '{')
        ADVANCE(104);
      if (lookahead == '|')
        ADVANCE(105);
      if (lookahead == '}')
        ADVANCE(107);
      if (lookahead == '~')
        ADVANCE(108);
      if (lookahead == 'B' ||
          lookahead == 'b')
        ADVANCE(109);
      if (lookahead == 'E' ||
          lookahead == 'e')
        ADVANCE(110);
      if (lookahead == 'R' ||
          lookahead == 'r')
        ADVANCE(109);
      if (lookahead == 'U' ||
          lookahead == 'u')
        ADVANCE(109);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279)
        SKIP(0);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(65);
      if (('A' <= lookahead && lookahead <= 'z'))
        ADVANCE(86);
      END_STATE();
    case 1:
      ACCEPT_TOKEN(ts_builtin_sym_end);
      END_STATE();
    case 2:
      if (lookahead == '=')
        ADVANCE(3);
      END_STATE();
    case 3:
      ACCEPT_TOKEN(anon_sym_BANG_EQ);
      END_STATE();
    case 4:
      if (lookahead == '\"')
        ADVANCE(5);
      if (lookahead == '\\')
        ADVANCE(10);
      if (lookahead != 0 &&
          lookahead != '\n')
        ADVANCE(11);
      END_STATE();
    case 5:
      ACCEPT_TOKEN(sym_string);
      if (lookahead == '\"')
        ADVANCE(6);
      END_STATE();
    case 6:
      if (lookahead == '\"')
        ADVANCE(7);
      if (lookahead != 0)
        ADVANCE(6);
      END_STATE();
    case 7:
      if (lookahead == '\"')
        ADVANCE(8);
      if (lookahead != 0)
        ADVANCE(6);
      END_STATE();
    case 8:
      if (lookahead == '\"')
        ADVANCE(9);
      if (lookahead != 0)
        ADVANCE(6);
      END_STATE();
    case 9:
      ACCEPT_TOKEN(sym_string);
      END_STATE();
    case 10:
      if (lookahead == '\n')
        ADVANCE(11);
      if (lookahead == '\r')
        ADVANCE(12);
      if (lookahead != 0)
        ADVANCE(11);
      END_STATE();
    case 11:
      if (lookahead == '\"')
        ADVANCE(9);
      if (lookahead == '\\')
        ADVANCE(10);
      if (lookahead != 0 &&
          lookahead != '\n')
        ADVANCE(11);
      END_STATE();
    case 12:
      if (lookahead == '\n')
        ADVANCE(11);
      if (lookahead == '\"')
        ADVANCE(9);
      if (lookahead == '\\')
        ADVANCE(10);
      if (lookahead != 0)
        ADVANCE(11);
      END_STATE();
    case 13:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead != 0 &&
          lookahead != '\n')
        ADVANCE(13);
      END_STATE();
    case 14:
      ACCEPT_TOKEN(anon_sym_PERCENT);
      if (lookahead == '=')
        ADVANCE(15);
      END_STATE();
    case 15:
      ACCEPT_TOKEN(anon_sym_PERCENT_EQ);
      END_STATE();
    case 16:
      ACCEPT_TOKEN(anon_sym_AMP);
      if (lookahead == '=')
        ADVANCE(17);
      END_STATE();
    case 17:
      ACCEPT_TOKEN(anon_sym_AMP_EQ);
      END_STATE();
    case 18:
      if (lookahead == '\'')
        ADVANCE(19);
      if (lookahead == '\\')
        ADVANCE(23);
      if (lookahead != 0 &&
          lookahead != '\n')
        ADVANCE(24);
      END_STATE();
    case 19:
      ACCEPT_TOKEN(sym_string);
      if (lookahead == '\'')
        ADVANCE(20);
      END_STATE();
    case 20:
      if (lookahead == '\'')
        ADVANCE(21);
      if (lookahead != 0)
        ADVANCE(20);
      END_STATE();
    case 21:
      if (lookahead == '\'')
        ADVANCE(22);
      if (lookahead != 0)
        ADVANCE(20);
      END_STATE();
    case 22:
      if (lookahead == '\'')
        ADVANCE(9);
      if (lookahead != 0)
        ADVANCE(20);
      END_STATE();
    case 23:
      if (lookahead == '\n')
        ADVANCE(24);
      if (lookahead == '\r')
        ADVANCE(25);
      if (lookahead != 0)
        ADVANCE(24);
      END_STATE();
    case 24:
      if (lookahead == '\'')
        ADVANCE(9);
      if (lookahead == '\\')
        ADVANCE(23);
      if (lookahead != 0 &&
          lookahead != '\n')
        ADVANCE(24);
      END_STATE();
    case 25:
      if (lookahead == '\n')
        ADVANCE(24);
      if (lookahead == '\'')
        ADVANCE(9);
      if (lookahead == '\\')
        ADVANCE(23);
      if (lookahead != 0)
        ADVANCE(24);
      END_STATE();
    case 26:
      ACCEPT_TOKEN(anon_sym_LPAREN);
      END_STATE();
    case 27:
      ACCEPT_TOKEN(anon_sym_RPAREN);
      END_STATE();
    case 28:
      ACCEPT_TOKEN(anon_sym_STAR);
      if (lookahead == '*')
        ADVANCE(29);
      if (lookahead == '=')
        ADVANCE(31);
      END_STATE();
    case 29:
      ACCEPT_TOKEN(anon_sym_STAR_STAR);
      if (lookahead == '=')
        ADVANCE(30);
      END_STATE();
    case 30:
      ACCEPT_TOKEN(anon_sym_STAR_STAR_EQ);
      END_STATE();
    case 31:
      ACCEPT_TOKEN(anon_sym_STAR_EQ);
      END_STATE();
    case 32:
      ACCEPT_TOKEN(anon_sym_PLUS);
      if (lookahead == '=')
        ADVANCE(33);
      END_STATE();
    case 33:
      ACCEPT_TOKEN(anon_sym_PLUS_EQ);
      END_STATE();
    case 34:
      ACCEPT_TOKEN(anon_sym_COMMA);
      END_STATE();
    case 35:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '=')
        ADVANCE(36);
      if (lookahead == '>')
        ADVANCE(37);
      END_STATE();
    case 36:
      ACCEPT_TOKEN(anon_sym_DASH_EQ);
      END_STATE();
    case 37:
      ACCEPT_TOKEN(anon_sym_DASH_GT);
      END_STATE();
    case 38:
      ACCEPT_TOKEN(anon_sym_DOT);
      if (lookahead == '.')
        ADVANCE(39);
      if (lookahead == 'E' ||
          lookahead == 'e')
        ADVANCE(41);
      if (lookahead == 'J' ||
          lookahead == 'j')
        ADVANCE(43);
      if (lookahead == 'L' ||
          lookahead == 'l')
        ADVANCE(43);
      if (('0' <= lookahead && lookahead <= '9'))
        ADVANCE(45);
      END_STATE();
    case 39:
      if (lookahead == '.')
        ADVANCE(40);
      END_STATE();
    case 40:
      ACCEPT_TOKEN(sym_ellipsis);
      END_STATE();
    case 41:
      ACCEPT_TOKEN(sym_float);
      if (lookahead == '+' ||
          lookahead == '-')
        ADVANCE(42);
      if (lookahead == 'J' ||
          lookahead == 'j')
        ADVANCE(43);
      if (lookahead == 'L' ||
          lookahead == 'l')
        ADVANCE(43);
      if (('0' <= lookahead && lookahead <= '9'))
        ADVANCE(44);
      END_STATE();
    case 42:
      ACCEPT_TOKEN(sym_float);
      if (lookahead == 'J' ||
          lookahead == 'j')
        ADVANCE(43);
      if (lookahead == 'L' ||
          lookahead == 'l')
        ADVANCE(43);
      if (('0' <= lookahead && lookahead <= '9'))
        ADVANCE(44);
      END_STATE();
    case 43:
      ACCEPT_TOKEN(sym_float);
      END_STATE();
    case 44:
      ACCEPT_TOKEN(sym_float);
      if (lookahead == '_')
        ADVANCE(42);
      if (lookahead == 'J' ||
          lookahead == 'j')
        ADVANCE(43);
      if (lookahead == 'L' ||
          lookahead == 'l')
        ADVANCE(43);
      if (('0' <= lookahead && lookahead <= '9'))
        ADVANCE(44);
      END_STATE();
    case 45:
      ACCEPT_TOKEN(sym_float);
      if (lookahead == '_')
        ADVANCE(46);
      if (lookahead == 'E' ||
          lookahead == 'e')
        ADVANCE(41);
      if (lookahead == 'J' ||
          lookahead == 'j')
        ADVANCE(43);
      if (lookahead == 'L' ||
          lookahead == 'l')
        ADVANCE(43);
      if (('0' <= lookahead && lookahead <= '9'))
        ADVANCE(45);
      END_STATE();
    case 46:
      ACCEPT_TOKEN(sym_float);
      if (lookahead == 'E' ||
          lookahead == 'e')
        ADVANCE(41);
      if (lookahead == 'J' ||
          lookahead == 'j')
        ADVANCE(43);
      if (lookahead == 'L' ||
          lookahead == 'l')
        ADVANCE(43);
      if (('0' <= lookahead && lookahead <= '9'))
        ADVANCE(45);
      END_STATE();
    case 47:
      ACCEPT_TOKEN(anon_sym_SLASH);
      if (lookahead == '/')
        ADVANCE(48);
      if (lookahead == '=')
        ADVANCE(50);
      END_STATE();
    case 48:
      ACCEPT_TOKEN(anon_sym_SLASH_SLASH);
      if (lookahead == '=')
        ADVANCE(49);
      END_STATE();
    case 49:
      ACCEPT_TOKEN(anon_sym_SLASH_SLASH_EQ);
      END_STATE();
    case 50:
      ACCEPT_TOKEN(anon_sym_SLASH_EQ);
      END_STATE();
    case 51:
      ACCEPT_TOKEN(sym_integer);
      if (lookahead == '.')
        ADVANCE(46);
      if (lookahead == 'B')
        ADVANCE(52);
      if (lookahead == 'O')
        ADVANCE(56);
      if (lookahead == 'X')
        ADVANCE(59);
      if (lookahead == '_')
        ADVANCE(62);
      if (lookahead == 'b')
        ADVANCE(52);
      if (lookahead == 'o')
        ADVANCE(56);
      if (lookahead == 'x')
        ADVANCE(59);
      if (lookahead == 'E' ||
          lookahead == 'e')
        ADVANCE(63);
      if (lookahead == 'J' ||
          lookahead == 'j')
        ADVANCE(55);
      if (lookahead == 'L' ||
          lookahead == 'l')
        ADVANCE(55);
      if (('0' <= lookahead && lookahead <= '9'))
        ADVANCE(65);
      END_STATE();
    case 52:
      if (lookahead == '_')
        ADVANCE(53);
      if (lookahead == '0' ||
          lookahead == '1')
        ADVANCE(54);
      END_STATE();
    case 53:
      if (lookahead == '0' ||
          lookahead == '1')
        ADVANCE(54);
      END_STATE();
    case 54:
      ACCEPT_TOKEN(sym_integer);
      if (lookahead == '_')
        ADVANCE(53);
      if (lookahead == '0' ||
          lookahead == '1')
        ADVANCE(54);
      if (lookahead == 'L' ||
          lookahead == 'l')
        ADVANCE(55);
      END_STATE();
    case 55:
      ACCEPT_TOKEN(sym_integer);
      END_STATE();
    case 56:
      if (lookahead == '_')
        ADVANCE(57);
      if (('0' <= lookahead && lookahead <= '7'))
        ADVANCE(58);
      END_STATE();
    case 57:
      if (('0' <= lookahead && lookahead <= '7'))
        ADVANCE(58);
      END_STATE();
    case 58:
      ACCEPT_TOKEN(sym_integer);
      if (lookahead == '_')
        ADVANCE(57);
      if (lookahead == 'L' ||
          lookahead == 'l')
        ADVANCE(55);
      if (('0' <= lookahead && lookahead <= '7'))
        ADVANCE(58);
      END_STATE();
    case 59:
      if (lookahead == '_')
        ADVANCE(60);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f'))
        ADVANCE(61);
      END_STATE();
    case 60:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f'))
        ADVANCE(61);
      END_STATE();
    case 61:
      ACCEPT_TOKEN(sym_integer);
      if (lookahead == '_')
        ADVANCE(60);
      if (lookahead == 'L' ||
          lookahead == 'l')
        ADVANCE(55);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f'))
        ADVANCE(61);
      END_STATE();
    case 62:
      ACCEPT_TOKEN(sym_integer);
      if (lookahead == '.')
        ADVANCE(46);
      if (lookahead == 'E' ||
          lookahead == 'e')
        ADVANCE(63);
      if (lookahead == 'J' ||
          lookahead == 'j')
        ADVANCE(55);
      if (lookahead == 'L' ||
          lookahead == 'l')
        ADVANCE(55);
      if (('0' <= lookahead && lookahead <= '9'))
        ADVANCE(65);
      END_STATE();
    case 63:
      if (lookahead == '+' ||
          lookahead == '-')
        ADVANCE(64);
      if (('0' <= lookahead && lookahead <= '9'))
        ADVANCE(44);
      END_STATE();
    case 64:
      if (('0' <= lookahead && lookahead <= '9'))
        ADVANCE(44);
      END_STATE();
    case 65:
      ACCEPT_TOKEN(sym_integer);
      if (lookahead == '.')
        ADVANCE(46);
      if (lookahead == '_')
        ADVANCE(62);
      if (lookahead == 'E' ||
          lookahead == 'e')
        ADVANCE(63);
      if (lookahead == 'J' ||
          lookahead == 'j')
        ADVANCE(55);
      if (lookahead == 'L' ||
          lookahead == 'l')
        ADVANCE(55);
      if (('0' <= lookahead && lookahead <= '9'))
        ADVANCE(65);
      END_STATE();
    case 66:
      ACCEPT_TOKEN(anon_sym_COLON);
      END_STATE();
    case 67:
      ACCEPT_TOKEN(sym__semicolon);
      END_STATE();
    case 68:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '<')
        ADVANCE(69);
      if (lookahead == '=')
        ADVANCE(71);
      if (lookahead == '>')
        ADVANCE(72);
      END_STATE();
    case 69:
      ACCEPT_TOKEN(anon_sym_LT_LT);
      if (lookahead == '=')
        ADVANCE(70);
      END_STATE();
    case 70:
      ACCEPT_TOKEN(anon_sym_LT_LT_EQ);
      END_STATE();
    case 71:
      ACCEPT_TOKEN(anon_sym_LT_EQ);
      END_STATE();
    case 72:
      ACCEPT_TOKEN(anon_sym_LT_GT);
      END_STATE();
    case 73:
      ACCEPT_TOKEN(anon_sym_EQ);
      if (lookahead == '=')
        ADVANCE(74);
      END_STATE();
    case 74:
      ACCEPT_TOKEN(anon_sym_EQ_EQ);
      END_STATE();
    case 75:
      ACCEPT_TOKEN(anon_sym_GT);
      if (lookahead == '=')
        ADVANCE(76);
      if (lookahead == '>')
        ADVANCE(77);
      END_STATE();
    case 76:
      ACCEPT_TOKEN(anon_sym_GT_EQ);
      END_STATE();
    case 77:
      ACCEPT_TOKEN(anon_sym_GT_GT);
      if (lookahead == '=')
        ADVANCE(78);
      END_STATE();
    case 78:
      ACCEPT_TOKEN(anon_sym_GT_GT_EQ);
      END_STATE();
    case 79:
      ACCEPT_TOKEN(anon_sym_AT);
      if (lookahead == '=')
        ADVANCE(80);
      END_STATE();
    case 80:
      ACCEPT_TOKEN(anon_sym_AT_EQ);
      END_STATE();
    case 81:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'a')
        ADVANCE(82);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z'))
        ADVANCE(86);
      END_STATE();
    case 82:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'l')
        ADVANCE(83);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(86);
      END_STATE();
    case 83:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 's')
        ADVANCE(84);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(86);
      END_STATE();
    case 84:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'e')
        ADVANCE(85);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(86);
      END_STATE();
    case 85:
      ACCEPT_TOKEN(sym_false);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(86);
      END_STATE();
    case 86:
      ACCEPT_TOKEN(sym_identifier);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(86);
      END_STATE();
    case 87:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'o')
        ADVANCE(88);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(86);
      END_STATE();
    case 88:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'n')
        ADVANCE(89);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(86);
      END_STATE();
    case 89:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'e')
        ADVANCE(90);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(86);
      END_STATE();
    case 90:
      ACCEPT_TOKEN(sym_none);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(86);
      END_STATE();
    case 91:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'r')
        ADVANCE(92);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(86);
      END_STATE();
    case 92:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'u')
        ADVANCE(93);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(86);
      END_STATE();
    case 93:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'e')
        ADVANCE(94);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(86);
      END_STATE();
    case 94:
      ACCEPT_TOKEN(sym_true);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(86);
      END_STATE();
    case 95:
      ACCEPT_TOKEN(anon_sym_LBRACK);
      END_STATE();
    case 96:
      if (lookahead == '\n')
        SKIP(0);
      if (lookahead == '\r')
        SKIP(97);
      END_STATE();
    case 97:
      if (lookahead == '\n')
        SKIP(0);
      END_STATE();
    case 98:
      ACCEPT_TOKEN(anon_sym_RBRACK);
      END_STATE();
    case 99:
      ACCEPT_TOKEN(anon_sym_CARET);
      if (lookahead == '=')
        ADVANCE(100);
      END_STATE();
    case 100:
      ACCEPT_TOKEN(anon_sym_CARET_EQ);
      END_STATE();
    case 101:
      if (lookahead == '\\')
        ADVANCE(102);
      if (lookahead == '`')
        ADVANCE(9);
      if (lookahead != 0 &&
          lookahead != '\n')
        ADVANCE(101);
      END_STATE();
    case 102:
      if (lookahead == '\n')
        ADVANCE(101);
      if (lookahead == '\r')
        ADVANCE(103);
      if (lookahead != 0)
        ADVANCE(101);
      END_STATE();
    case 103:
      if (lookahead == '\n')
        ADVANCE(101);
      if (lookahead == '\\')
        ADVANCE(102);
      if (lookahead == '`')
        ADVANCE(9);
      if (lookahead != 0)
        ADVANCE(101);
      END_STATE();
    case 104:
      ACCEPT_TOKEN(anon_sym_LBRACE);
      END_STATE();
    case 105:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == '=')
        ADVANCE(106);
      END_STATE();
    case 106:
      ACCEPT_TOKEN(anon_sym_PIPE_EQ);
      END_STATE();
    case 107:
      ACCEPT_TOKEN(anon_sym_RBRACE);
      END_STATE();
    case 108:
      ACCEPT_TOKEN(anon_sym_TILDE);
      END_STATE();
    case 109:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\"')
        ADVANCE(4);
      if (lookahead == '\'')
        ADVANCE(18);
      if (lookahead == '`')
        ADVANCE(101);
      if (lookahead == 'B' ||
          lookahead == 'b')
        ADVANCE(109);
      if (lookahead == 'R' ||
          lookahead == 'r')
        ADVANCE(109);
      if (lookahead == 'U' ||
          lookahead == 'u')
        ADVANCE(109);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('_' <= lookahead && lookahead <= 'z'))
        ADVANCE(86);
      END_STATE();
    case 110:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '+' ||
          lookahead == '-')
        ADVANCE(64);
      if (('0' <= lookahead && lookahead <= '9'))
        ADVANCE(111);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(86);
      END_STATE();
    case 111:
      ACCEPT_TOKEN(sym_float);
      if (lookahead == '_')
        ADVANCE(112);
      if (lookahead == 'J' ||
          lookahead == 'j')
        ADVANCE(113);
      if (lookahead == 'L' ||
          lookahead == 'l')
        ADVANCE(113);
      if (('0' <= lookahead && lookahead <= '9'))
        ADVANCE(111);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(86);
      END_STATE();
    case 112:
      ACCEPT_TOKEN(sym_float);
      if (lookahead == 'J' ||
          lookahead == 'j')
        ADVANCE(113);
      if (lookahead == 'L' ||
          lookahead == 'l')
        ADVANCE(113);
      if (('0' <= lookahead && lookahead <= '9'))
        ADVANCE(111);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(86);
      END_STATE();
    case 113:
      ACCEPT_TOKEN(sym_float);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(86);
      END_STATE();
    case 114:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '\"')
        ADVANCE(4);
      if (lookahead == '#')
        ADVANCE(13);
      if (lookahead == '\'')
        ADVANCE(18);
      if (lookahead == '(')
        ADVANCE(26);
      if (lookahead == ')')
        ADVANCE(27);
      if (lookahead == '*')
        ADVANCE(115);
      if (lookahead == '+')
        ADVANCE(116);
      if (lookahead == ',')
        ADVANCE(34);
      if (lookahead == '-')
        ADVANCE(117);
      if (lookahead == '.')
        ADVANCE(118);
      if (lookahead == '0')
        ADVANCE(51);
      if (lookahead == ':')
        ADVANCE(66);
      if (lookahead == '@')
        ADVANCE(119);
      if (lookahead == 'F')
        ADVANCE(81);
      if (lookahead == 'N')
        ADVANCE(87);
      if (lookahead == 'T')
        ADVANCE(91);
      if (lookahead == '[')
        ADVANCE(95);
      if (lookahead == '\\')
        SKIP(120);
      if (lookahead == ']')
        ADVANCE(98);
      if (lookahead == '`')
        ADVANCE(101);
      if (lookahead == '{')
        ADVANCE(104);
      if (lookahead == '}')
        ADVANCE(107);
      if (lookahead == '~')
        ADVANCE(108);
      if (lookahead == 'B' ||
          lookahead == 'b')
        ADVANCE(109);
      if (lookahead == 'E' ||
          lookahead == 'e')
        ADVANCE(110);
      if (lookahead == 'R' ||
          lookahead == 'r')
        ADVANCE(109);
      if (lookahead == 'U' ||
          lookahead == 'u')
        ADVANCE(109);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279)
        SKIP(114);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(65);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('_' <= lookahead && lookahead <= 'z'))
        ADVANCE(86);
      END_STATE();
    case 115:
      ACCEPT_TOKEN(anon_sym_STAR);
      END_STATE();
    case 116:
      ACCEPT_TOKEN(anon_sym_PLUS);
      END_STATE();
    case 117:
      ACCEPT_TOKEN(anon_sym_DASH);
      END_STATE();
    case 118:
      ACCEPT_TOKEN(sym_float);
      if (lookahead == '.')
        ADVANCE(39);
      if (lookahead == 'E' ||
          lookahead == 'e')
        ADVANCE(41);
      if (lookahead == 'J' ||
          lookahead == 'j')
        ADVANCE(43);
      if (lookahead == 'L' ||
          lookahead == 'l')
        ADVANCE(43);
      if (('0' <= lookahead && lookahead <= '9'))
        ADVANCE(45);
      END_STATE();
    case 119:
      ACCEPT_TOKEN(anon_sym_AT);
      END_STATE();
    case 120:
      if (lookahead == '\n')
        SKIP(114);
      if (lookahead == '\r')
        SKIP(121);
      END_STATE();
    case 121:
      if (lookahead == '\n')
        SKIP(114);
      END_STATE();
    case 122:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '\"')
        ADVANCE(4);
      if (lookahead == '#')
        ADVANCE(13);
      if (lookahead == '%')
        ADVANCE(14);
      if (lookahead == '&')
        ADVANCE(16);
      if (lookahead == '\'')
        ADVANCE(18);
      if (lookahead == '(')
        ADVANCE(26);
      if (lookahead == '*')
        ADVANCE(28);
      if (lookahead == '+')
        ADVANCE(32);
      if (lookahead == ',')
        ADVANCE(34);
      if (lookahead == '-')
        ADVANCE(123);
      if (lookahead == '.')
        ADVANCE(124);
      if (lookahead == '/')
        ADVANCE(47);
      if (lookahead == ':')
        ADVANCE(66);
      if (lookahead == ';')
        ADVANCE(67);
      if (lookahead == '<')
        ADVANCE(68);
      if (lookahead == '=')
        ADVANCE(73);
      if (lookahead == '>')
        ADVANCE(75);
      if (lookahead == '@')
        ADVANCE(79);
      if (lookahead == '[')
        ADVANCE(95);
      if (lookahead == '\\')
        SKIP(125);
      if (lookahead == '^')
        ADVANCE(99);
      if (lookahead == '`')
        ADVANCE(101);
      if (lookahead == '|')
        ADVANCE(105);
      if (lookahead == 'B' ||
          lookahead == 'b')
        ADVANCE(109);
      if (lookahead == 'R' ||
          lookahead == 'r')
        ADVANCE(109);
      if (lookahead == 'U' ||
          lookahead == 'u')
        ADVANCE(109);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279)
        SKIP(122);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('_' <= lookahead && lookahead <= 'z'))
        ADVANCE(86);
      END_STATE();
    case 123:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '=')
        ADVANCE(36);
      END_STATE();
    case 124:
      ACCEPT_TOKEN(anon_sym_DOT);
      END_STATE();
    case 125:
      if (lookahead == '\n')
        SKIP(122);
      if (lookahead == '\r')
        SKIP(126);
      END_STATE();
    case 126:
      if (lookahead == '\n')
        SKIP(122);
      END_STATE();
    case 127:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '\"')
        ADVANCE(4);
      if (lookahead == '#')
        ADVANCE(13);
      if (lookahead == '%')
        ADVANCE(14);
      if (lookahead == '&')
        ADVANCE(16);
      if (lookahead == '\'')
        ADVANCE(18);
      if (lookahead == '(')
        ADVANCE(26);
      if (lookahead == '*')
        ADVANCE(28);
      if (lookahead == '+')
        ADVANCE(32);
      if (lookahead == ',')
        ADVANCE(34);
      if (lookahead == '-')
        ADVANCE(123);
      if (lookahead == '.')
        ADVANCE(38);
      if (lookahead == '/')
        ADVANCE(47);
      if (lookahead == '0')
        ADVANCE(51);
      if (lookahead == ':')
        ADVANCE(66);
      if (lookahead == ';')
        ADVANCE(67);
      if (lookahead == '<')
        ADVANCE(68);
      if (lookahead == '=')
        ADVANCE(73);
      if (lookahead == '>')
        ADVANCE(75);
      if (lookahead == '@')
        ADVANCE(79);
      if (lookahead == 'F')
        ADVANCE(81);
      if (lookahead == 'N')
        ADVANCE(87);
      if (lookahead == 'T')
        ADVANCE(91);
      if (lookahead == '[')
        ADVANCE(95);
      if (lookahead == '\\')
        SKIP(128);
      if (lookahead == '^')
        ADVANCE(99);
      if (lookahead == '`')
        ADVANCE(101);
      if (lookahead == '{')
        ADVANCE(104);
      if (lookahead == '|')
        ADVANCE(105);
      if (lookahead == '~')
        ADVANCE(108);
      if (lookahead == 'B' ||
          lookahead == 'b')
        ADVANCE(109);
      if (lookahead == 'E' ||
          lookahead == 'e')
        ADVANCE(110);
      if (lookahead == 'R' ||
          lookahead == 'r')
        ADVANCE(109);
      if (lookahead == 'U' ||
          lookahead == 'u')
        ADVANCE(109);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279)
        SKIP(127);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(65);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('_' <= lookahead && lookahead <= 'z'))
        ADVANCE(86);
      END_STATE();
    case 128:
      if (lookahead == '\n')
        SKIP(127);
      if (lookahead == '\r')
        SKIP(129);
      END_STATE();
    case 129:
      if (lookahead == '\n')
        SKIP(127);
      END_STATE();
    case 130:
      if (lookahead == '\"')
        ADVANCE(4);
      if (lookahead == '#')
        ADVANCE(13);
      if (lookahead == '\'')
        ADVANCE(18);
      if (lookahead == '(')
        ADVANCE(26);
      if (lookahead == '+')
        ADVANCE(116);
      if (lookahead == '-')
        ADVANCE(117);
      if (lookahead == '.')
        ADVANCE(118);
      if (lookahead == '0')
        ADVANCE(51);
      if (lookahead == ';')
        ADVANCE(67);
      if (lookahead == 'F')
        ADVANCE(81);
      if (lookahead == 'N')
        ADVANCE(87);
      if (lookahead == 'T')
        ADVANCE(91);
      if (lookahead == '[')
        ADVANCE(95);
      if (lookahead == '\\')
        SKIP(131);
      if (lookahead == '`')
        ADVANCE(101);
      if (lookahead == '{')
        ADVANCE(104);
      if (lookahead == '~')
        ADVANCE(108);
      if (lookahead == 'B' ||
          lookahead == 'b')
        ADVANCE(109);
      if (lookahead == 'E' ||
          lookahead == 'e')
        ADVANCE(110);
      if (lookahead == 'R' ||
          lookahead == 'r')
        ADVANCE(109);
      if (lookahead == 'U' ||
          lookahead == 'u')
        ADVANCE(109);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279)
        SKIP(130);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(65);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('_' <= lookahead && lookahead <= 'z'))
        ADVANCE(86);
      END_STATE();
    case 131:
      if (lookahead == '\n')
        SKIP(130);
      if (lookahead == '\r')
        SKIP(132);
      END_STATE();
    case 132:
      if (lookahead == '\n')
        SKIP(130);
      END_STATE();
    case 133:
      if (lookahead == '#')
        ADVANCE(13);
      if (lookahead == ';')
        ADVANCE(67);
      if (lookahead == '\\')
        SKIP(134);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279)
        SKIP(133);
      END_STATE();
    case 134:
      if (lookahead == '\n')
        SKIP(133);
      if (lookahead == '\r')
        SKIP(135);
      END_STATE();
    case 135:
      if (lookahead == '\n')
        SKIP(133);
      END_STATE();
    case 136:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(13);
      if (lookahead == '(')
        ADVANCE(26);
      if (lookahead == ')')
        ADVANCE(27);
      if (lookahead == '*')
        ADVANCE(115);
      if (lookahead == ',')
        ADVANCE(34);
      if (lookahead == '.')
        ADVANCE(124);
      if (lookahead == ':')
        ADVANCE(66);
      if (lookahead == '<')
        ADVANCE(137);
      if (lookahead == '=')
        ADVANCE(73);
      if (lookahead == '>')
        ADVANCE(138);
      if (lookahead == '\\')
        SKIP(139);
      if (lookahead == ']')
        ADVANCE(98);
      if (lookahead == '}')
        ADVANCE(107);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279)
        SKIP(136);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(86);
      END_STATE();
    case 137:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '=')
        ADVANCE(71);
      if (lookahead == '>')
        ADVANCE(72);
      END_STATE();
    case 138:
      ACCEPT_TOKEN(anon_sym_GT);
      if (lookahead == '=')
        ADVANCE(76);
      END_STATE();
    case 139:
      if (lookahead == '\n')
        SKIP(136);
      if (lookahead == '\r')
        SKIP(140);
      END_STATE();
    case 140:
      if (lookahead == '\n')
        SKIP(136);
      END_STATE();
    case 141:
      if (lookahead == '#')
        ADVANCE(13);
      if (lookahead == '%')
        ADVANCE(142);
      if (lookahead == '&')
        ADVANCE(143);
      if (lookahead == '*')
        ADVANCE(144);
      if (lookahead == '+')
        ADVANCE(146);
      if (lookahead == ',')
        ADVANCE(34);
      if (lookahead == '-')
        ADVANCE(147);
      if (lookahead == '/')
        ADVANCE(148);
      if (lookahead == ':')
        ADVANCE(66);
      if (lookahead == ';')
        ADVANCE(67);
      if (lookahead == '<')
        ADVANCE(150);
      if (lookahead == '=')
        ADVANCE(152);
      if (lookahead == '>')
        ADVANCE(153);
      if (lookahead == '@')
        ADVANCE(155);
      if (lookahead == '\\')
        SKIP(156);
      if (lookahead == '^')
        ADVANCE(158);
      if (lookahead == '|')
        ADVANCE(159);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279)
        SKIP(141);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(86);
      END_STATE();
    case 142:
      if (lookahead == '=')
        ADVANCE(15);
      END_STATE();
    case 143:
      if (lookahead == '=')
        ADVANCE(17);
      END_STATE();
    case 144:
      if (lookahead == '*')
        ADVANCE(145);
      if (lookahead == '=')
        ADVANCE(31);
      END_STATE();
    case 145:
      if (lookahead == '=')
        ADVANCE(30);
      END_STATE();
    case 146:
      if (lookahead == '=')
        ADVANCE(33);
      END_STATE();
    case 147:
      if (lookahead == '=')
        ADVANCE(36);
      END_STATE();
    case 148:
      if (lookahead == '/')
        ADVANCE(149);
      if (lookahead == '=')
        ADVANCE(50);
      END_STATE();
    case 149:
      if (lookahead == '=')
        ADVANCE(49);
      END_STATE();
    case 150:
      if (lookahead == '<')
        ADVANCE(151);
      END_STATE();
    case 151:
      if (lookahead == '=')
        ADVANCE(70);
      END_STATE();
    case 152:
      ACCEPT_TOKEN(anon_sym_EQ);
      END_STATE();
    case 153:
      if (lookahead == '>')
        ADVANCE(154);
      END_STATE();
    case 154:
      if (lookahead == '=')
        ADVANCE(78);
      END_STATE();
    case 155:
      if (lookahead == '=')
        ADVANCE(80);
      END_STATE();
    case 156:
      if (lookahead == '\n')
        SKIP(141);
      if (lookahead == '\r')
        SKIP(157);
      END_STATE();
    case 157:
      if (lookahead == '\n')
        SKIP(141);
      END_STATE();
    case 158:
      if (lookahead == '=')
        ADVANCE(100);
      END_STATE();
    case 159:
      if (lookahead == '=')
        ADVANCE(106);
      END_STATE();
    case 160:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(13);
      if (lookahead == '%')
        ADVANCE(14);
      if (lookahead == '&')
        ADVANCE(16);
      if (lookahead == '(')
        ADVANCE(26);
      if (lookahead == '*')
        ADVANCE(28);
      if (lookahead == '+')
        ADVANCE(32);
      if (lookahead == ',')
        ADVANCE(34);
      if (lookahead == '-')
        ADVANCE(123);
      if (lookahead == '.')
        ADVANCE(124);
      if (lookahead == '/')
        ADVANCE(47);
      if (lookahead == ':')
        ADVANCE(66);
      if (lookahead == ';')
        ADVANCE(67);
      if (lookahead == '<')
        ADVANCE(68);
      if (lookahead == '=')
        ADVANCE(73);
      if (lookahead == '>')
        ADVANCE(75);
      if (lookahead == '@')
        ADVANCE(79);
      if (lookahead == '[')
        ADVANCE(95);
      if (lookahead == '\\')
        SKIP(161);
      if (lookahead == '^')
        ADVANCE(99);
      if (lookahead == '|')
        ADVANCE(105);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279)
        SKIP(160);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(86);
      END_STATE();
    case 161:
      if (lookahead == '\n')
        SKIP(160);
      if (lookahead == '\r')
        SKIP(162);
      END_STATE();
    case 162:
      if (lookahead == '\n')
        SKIP(160);
      END_STATE();
    case 163:
      if (lookahead == '#')
        ADVANCE(13);
      if (lookahead == ',')
        ADVANCE(34);
      if (lookahead == '.')
        ADVANCE(124);
      if (lookahead == ';')
        ADVANCE(67);
      if (lookahead == '\\')
        SKIP(164);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279)
        SKIP(163);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(86);
      END_STATE();
    case 164:
      if (lookahead == '\n')
        SKIP(163);
      if (lookahead == '\r')
        SKIP(165);
      END_STATE();
    case 165:
      if (lookahead == '\n')
        SKIP(163);
      END_STATE();
    case 166:
      if (lookahead == '#')
        ADVANCE(13);
      if (lookahead == ',')
        ADVANCE(34);
      if (lookahead == ';')
        ADVANCE(67);
      if (lookahead == '\\')
        SKIP(167);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279)
        SKIP(166);
      END_STATE();
    case 167:
      if (lookahead == '\n')
        SKIP(166);
      if (lookahead == '\r')
        SKIP(168);
      END_STATE();
    case 168:
      if (lookahead == '\n')
        SKIP(166);
      END_STATE();
    case 169:
      if (lookahead == '#')
        ADVANCE(13);
      if (lookahead == ',')
        ADVANCE(34);
      if (lookahead == ';')
        ADVANCE(67);
      if (lookahead == '\\')
        SKIP(170);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279)
        SKIP(169);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(86);
      END_STATE();
    case 170:
      if (lookahead == '\n')
        SKIP(169);
      if (lookahead == '\r')
        SKIP(171);
      END_STATE();
    case 171:
      if (lookahead == '\n')
        SKIP(169);
      END_STATE();
    case 172:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '\"')
        ADVANCE(4);
      if (lookahead == '#')
        ADVANCE(13);
      if (lookahead == '%')
        ADVANCE(173);
      if (lookahead == '&')
        ADVANCE(174);
      if (lookahead == '\'')
        ADVANCE(18);
      if (lookahead == '(')
        ADVANCE(26);
      if (lookahead == ')')
        ADVANCE(27);
      if (lookahead == '*')
        ADVANCE(175);
      if (lookahead == '+')
        ADVANCE(116);
      if (lookahead == ',')
        ADVANCE(34);
      if (lookahead == '-')
        ADVANCE(117);
      if (lookahead == '.')
        ADVANCE(124);
      if (lookahead == '/')
        ADVANCE(177);
      if (lookahead == ':')
        ADVANCE(66);
      if (lookahead == '<')
        ADVANCE(179);
      if (lookahead == '=')
        ADVANCE(73);
      if (lookahead == '>')
        ADVANCE(181);
      if (lookahead == '@')
        ADVANCE(119);
      if (lookahead == '[')
        ADVANCE(95);
      if (lookahead == '\\')
        SKIP(183);
      if (lookahead == ']')
        ADVANCE(98);
      if (lookahead == '^')
        ADVANCE(185);
      if (lookahead == '`')
        ADVANCE(101);
      if (lookahead == '|')
        ADVANCE(186);
      if (lookahead == '}')
        ADVANCE(107);
      if (lookahead == 'B' ||
          lookahead == 'b')
        ADVANCE(109);
      if (lookahead == 'R' ||
          lookahead == 'r')
        ADVANCE(109);
      if (lookahead == 'U' ||
          lookahead == 'u')
        ADVANCE(109);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279)
        SKIP(172);
      if (('A' <= lookahead && lookahead <= 'z'))
        ADVANCE(86);
      END_STATE();
    case 173:
      ACCEPT_TOKEN(anon_sym_PERCENT);
      END_STATE();
    case 174:
      ACCEPT_TOKEN(anon_sym_AMP);
      END_STATE();
    case 175:
      ACCEPT_TOKEN(anon_sym_STAR);
      if (lookahead == '*')
        ADVANCE(176);
      END_STATE();
    case 176:
      ACCEPT_TOKEN(anon_sym_STAR_STAR);
      END_STATE();
    case 177:
      ACCEPT_TOKEN(anon_sym_SLASH);
      if (lookahead == '/')
        ADVANCE(178);
      END_STATE();
    case 178:
      ACCEPT_TOKEN(anon_sym_SLASH_SLASH);
      END_STATE();
    case 179:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '<')
        ADVANCE(180);
      if (lookahead == '=')
        ADVANCE(71);
      if (lookahead == '>')
        ADVANCE(72);
      END_STATE();
    case 180:
      ACCEPT_TOKEN(anon_sym_LT_LT);
      END_STATE();
    case 181:
      ACCEPT_TOKEN(anon_sym_GT);
      if (lookahead == '=')
        ADVANCE(76);
      if (lookahead == '>')
        ADVANCE(182);
      END_STATE();
    case 182:
      ACCEPT_TOKEN(anon_sym_GT_GT);
      END_STATE();
    case 183:
      if (lookahead == '\n')
        SKIP(172);
      if (lookahead == '\r')
        SKIP(184);
      END_STATE();
    case 184:
      if (lookahead == '\n')
        SKIP(172);
      END_STATE();
    case 185:
      ACCEPT_TOKEN(anon_sym_CARET);
      END_STATE();
    case 186:
      ACCEPT_TOKEN(anon_sym_PIPE);
      END_STATE();
    case 187:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(13);
      if (lookahead == '%')
        ADVANCE(173);
      if (lookahead == '&')
        ADVANCE(174);
      if (lookahead == '(')
        ADVANCE(26);
      if (lookahead == '*')
        ADVANCE(175);
      if (lookahead == '+')
        ADVANCE(116);
      if (lookahead == ',')
        ADVANCE(34);
      if (lookahead == '-')
        ADVANCE(117);
      if (lookahead == '.')
        ADVANCE(124);
      if (lookahead == '/')
        ADVANCE(177);
      if (lookahead == ';')
        ADVANCE(67);
      if (lookahead == '<')
        ADVANCE(179);
      if (lookahead == '=')
        ADVANCE(73);
      if (lookahead == '>')
        ADVANCE(181);
      if (lookahead == '@')
        ADVANCE(119);
      if (lookahead == '[')
        ADVANCE(95);
      if (lookahead == '\\')
        SKIP(188);
      if (lookahead == '^')
        ADVANCE(185);
      if (lookahead == '|')
        ADVANCE(186);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279)
        SKIP(187);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(86);
      END_STATE();
    case 188:
      if (lookahead == '\n')
        SKIP(187);
      if (lookahead == '\r')
        SKIP(189);
      END_STATE();
    case 189:
      if (lookahead == '\n')
        SKIP(187);
      END_STATE();
    case 190:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '\"')
        ADVANCE(4);
      if (lookahead == '#')
        ADVANCE(13);
      if (lookahead == '%')
        ADVANCE(173);
      if (lookahead == '&')
        ADVANCE(174);
      if (lookahead == '\'')
        ADVANCE(18);
      if (lookahead == '(')
        ADVANCE(26);
      if (lookahead == '*')
        ADVANCE(175);
      if (lookahead == '+')
        ADVANCE(116);
      if (lookahead == ',')
        ADVANCE(34);
      if (lookahead == '-')
        ADVANCE(117);
      if (lookahead == '.')
        ADVANCE(124);
      if (lookahead == '/')
        ADVANCE(177);
      if (lookahead == ';')
        ADVANCE(67);
      if (lookahead == '<')
        ADVANCE(179);
      if (lookahead == '=')
        ADVANCE(191);
      if (lookahead == '>')
        ADVANCE(181);
      if (lookahead == '@')
        ADVANCE(119);
      if (lookahead == '[')
        ADVANCE(95);
      if (lookahead == '\\')
        SKIP(192);
      if (lookahead == '^')
        ADVANCE(185);
      if (lookahead == '`')
        ADVANCE(101);
      if (lookahead == '|')
        ADVANCE(186);
      if (lookahead == 'B' ||
          lookahead == 'b')
        ADVANCE(109);
      if (lookahead == 'R' ||
          lookahead == 'r')
        ADVANCE(109);
      if (lookahead == 'U' ||
          lookahead == 'u')
        ADVANCE(109);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279)
        SKIP(190);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('_' <= lookahead && lookahead <= 'z'))
        ADVANCE(86);
      END_STATE();
    case 191:
      if (lookahead == '=')
        ADVANCE(74);
      END_STATE();
    case 192:
      if (lookahead == '\n')
        SKIP(190);
      if (lookahead == '\r')
        SKIP(193);
      END_STATE();
    case 193:
      if (lookahead == '\n')
        SKIP(190);
      END_STATE();
    case 194:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(13);
      if (lookahead == '%')
        ADVANCE(173);
      if (lookahead == '&')
        ADVANCE(174);
      if (lookahead == '(')
        ADVANCE(26);
      if (lookahead == '*')
        ADVANCE(175);
      if (lookahead == '+')
        ADVANCE(116);
      if (lookahead == ',')
        ADVANCE(34);
      if (lookahead == '-')
        ADVANCE(117);
      if (lookahead == '.')
        ADVANCE(124);
      if (lookahead == '/')
        ADVANCE(177);
      if (lookahead == ';')
        ADVANCE(67);
      if (lookahead == '<')
        ADVANCE(179);
      if (lookahead == '=')
        ADVANCE(191);
      if (lookahead == '>')
        ADVANCE(181);
      if (lookahead == '@')
        ADVANCE(119);
      if (lookahead == '[')
        ADVANCE(95);
      if (lookahead == '\\')
        SKIP(195);
      if (lookahead == '^')
        ADVANCE(185);
      if (lookahead == '|')
        ADVANCE(186);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279)
        SKIP(194);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(86);
      END_STATE();
    case 195:
      if (lookahead == '\n')
        SKIP(194);
      if (lookahead == '\r')
        SKIP(196);
      END_STATE();
    case 196:
      if (lookahead == '\n')
        SKIP(194);
      END_STATE();
    case 197:
      if (lookahead == '#')
        ADVANCE(13);
      if (lookahead == ';')
        ADVANCE(67);
      if (lookahead == '\\')
        SKIP(198);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279)
        SKIP(197);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(86);
      END_STATE();
    case 198:
      if (lookahead == '\n')
        SKIP(197);
      if (lookahead == '\r')
        SKIP(199);
      END_STATE();
    case 199:
      if (lookahead == '\n')
        SKIP(197);
      END_STATE();
    case 200:
      if (lookahead == '\"')
        ADVANCE(4);
      if (lookahead == '#')
        ADVANCE(13);
      if (lookahead == '\'')
        ADVANCE(18);
      if (lookahead == '(')
        ADVANCE(26);
      if (lookahead == '+')
        ADVANCE(116);
      if (lookahead == '-')
        ADVANCE(117);
      if (lookahead == '.')
        ADVANCE(118);
      if (lookahead == '0')
        ADVANCE(51);
      if (lookahead == 'F')
        ADVANCE(81);
      if (lookahead == 'N')
        ADVANCE(87);
      if (lookahead == 'T')
        ADVANCE(91);
      if (lookahead == '[')
        ADVANCE(95);
      if (lookahead == '\\')
        SKIP(201);
      if (lookahead == '`')
        ADVANCE(101);
      if (lookahead == '{')
        ADVANCE(104);
      if (lookahead == '~')
        ADVANCE(108);
      if (lookahead == 'B' ||
          lookahead == 'b')
        ADVANCE(109);
      if (lookahead == 'E' ||
          lookahead == 'e')
        ADVANCE(110);
      if (lookahead == 'R' ||
          lookahead == 'r')
        ADVANCE(109);
      if (lookahead == 'U' ||
          lookahead == 'u')
        ADVANCE(109);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279)
        SKIP(200);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(65);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('_' <= lookahead && lookahead <= 'z'))
        ADVANCE(86);
      END_STATE();
    case 201:
      if (lookahead == '\n')
        SKIP(200);
      if (lookahead == '\r')
        SKIP(202);
      END_STATE();
    case 202:
      if (lookahead == '\n')
        SKIP(200);
      END_STATE();
    case 203:
      if (lookahead == '#')
        ADVANCE(13);
      if (lookahead == '(')
        ADVANCE(26);
      if (lookahead == '.')
        ADVANCE(124);
      if (lookahead == '\\')
        SKIP(204);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279)
        SKIP(203);
      END_STATE();
    case 204:
      if (lookahead == '\n')
        SKIP(203);
      if (lookahead == '\r')
        SKIP(205);
      END_STATE();
    case 205:
      if (lookahead == '\n')
        SKIP(203);
      END_STATE();
    case 206:
      if (lookahead == '#')
        ADVANCE(13);
      if (lookahead == '(')
        ADVANCE(26);
      if (lookahead == '\\')
        SKIP(207);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279)
        SKIP(206);
      END_STATE();
    case 207:
      if (lookahead == '\n')
        SKIP(206);
      if (lookahead == '\r')
        SKIP(208);
      END_STATE();
    case 208:
      if (lookahead == '\n')
        SKIP(206);
      END_STATE();
    case 209:
      if (lookahead == '\"')
        ADVANCE(4);
      if (lookahead == '#')
        ADVANCE(13);
      if (lookahead == '%')
        ADVANCE(142);
      if (lookahead == '&')
        ADVANCE(143);
      if (lookahead == '\'')
        ADVANCE(18);
      if (lookahead == '(')
        ADVANCE(26);
      if (lookahead == '*')
        ADVANCE(144);
      if (lookahead == '+')
        ADVANCE(32);
      if (lookahead == '-')
        ADVANCE(123);
      if (lookahead == '.')
        ADVANCE(118);
      if (lookahead == '/')
        ADVANCE(148);
      if (lookahead == '0')
        ADVANCE(51);
      if (lookahead == ':')
        ADVANCE(66);
      if (lookahead == ';')
        ADVANCE(67);
      if (lookahead == '<')
        ADVANCE(150);
      if (lookahead == '=')
        ADVANCE(152);
      if (lookahead == '>')
        ADVANCE(153);
      if (lookahead == '@')
        ADVANCE(155);
      if (lookahead == 'F')
        ADVANCE(81);
      if (lookahead == 'N')
        ADVANCE(87);
      if (lookahead == 'T')
        ADVANCE(91);
      if (lookahead == '[')
        ADVANCE(95);
      if (lookahead == '\\')
        SKIP(210);
      if (lookahead == '^')
        ADVANCE(158);
      if (lookahead == '`')
        ADVANCE(101);
      if (lookahead == '{')
        ADVANCE(104);
      if (lookahead == '|')
        ADVANCE(159);
      if (lookahead == '~')
        ADVANCE(108);
      if (lookahead == 'B' ||
          lookahead == 'b')
        ADVANCE(109);
      if (lookahead == 'E' ||
          lookahead == 'e')
        ADVANCE(110);
      if (lookahead == 'R' ||
          lookahead == 'r')
        ADVANCE(109);
      if (lookahead == 'U' ||
          lookahead == 'u')
        ADVANCE(109);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279)
        SKIP(209);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(65);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('_' <= lookahead && lookahead <= 'z'))
        ADVANCE(86);
      END_STATE();
    case 210:
      if (lookahead == '\n')
        SKIP(209);
      if (lookahead == '\r')
        SKIP(211);
      END_STATE();
    case 211:
      if (lookahead == '\n')
        SKIP(209);
      END_STATE();
    case 212:
      if (lookahead == '#')
        ADVANCE(13);
      if (lookahead == '%')
        ADVANCE(142);
      if (lookahead == '&')
        ADVANCE(143);
      if (lookahead == '*')
        ADVANCE(144);
      if (lookahead == '+')
        ADVANCE(146);
      if (lookahead == ',')
        ADVANCE(34);
      if (lookahead == '-')
        ADVANCE(147);
      if (lookahead == '/')
        ADVANCE(148);
      if (lookahead == ':')
        ADVANCE(66);
      if (lookahead == ';')
        ADVANCE(67);
      if (lookahead == '<')
        ADVANCE(150);
      if (lookahead == '=')
        ADVANCE(152);
      if (lookahead == '>')
        ADVANCE(153);
      if (lookahead == '@')
        ADVANCE(155);
      if (lookahead == '\\')
        SKIP(213);
      if (lookahead == '^')
        ADVANCE(158);
      if (lookahead == '|')
        ADVANCE(159);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279)
        SKIP(212);
      END_STATE();
    case 213:
      if (lookahead == '\n')
        SKIP(212);
      if (lookahead == '\r')
        SKIP(214);
      END_STATE();
    case 214:
      if (lookahead == '\n')
        SKIP(212);
      END_STATE();
    case 215:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(13);
      if (lookahead == '%')
        ADVANCE(142);
      if (lookahead == '&')
        ADVANCE(143);
      if (lookahead == '*')
        ADVANCE(144);
      if (lookahead == '+')
        ADVANCE(146);
      if (lookahead == ',')
        ADVANCE(34);
      if (lookahead == '-')
        ADVANCE(147);
      if (lookahead == '/')
        ADVANCE(148);
      if (lookahead == ':')
        ADVANCE(66);
      if (lookahead == ';')
        ADVANCE(67);
      if (lookahead == '<')
        ADVANCE(216);
      if (lookahead == '=')
        ADVANCE(73);
      if (lookahead == '>')
        ADVANCE(217);
      if (lookahead == '@')
        ADVANCE(155);
      if (lookahead == '\\')
        SKIP(218);
      if (lookahead == '^')
        ADVANCE(158);
      if (lookahead == '|')
        ADVANCE(159);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279)
        SKIP(215);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(86);
      END_STATE();
    case 216:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '<')
        ADVANCE(151);
      if (lookahead == '=')
        ADVANCE(71);
      if (lookahead == '>')
        ADVANCE(72);
      END_STATE();
    case 217:
      ACCEPT_TOKEN(anon_sym_GT);
      if (lookahead == '=')
        ADVANCE(76);
      if (lookahead == '>')
        ADVANCE(154);
      END_STATE();
    case 218:
      if (lookahead == '\n')
        SKIP(215);
      if (lookahead == '\r')
        SKIP(219);
      END_STATE();
    case 219:
      if (lookahead == '\n')
        SKIP(215);
      END_STATE();
    case 220:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(13);
      if (lookahead == ',')
        ADVANCE(34);
      if (lookahead == ';')
        ADVANCE(67);
      if (lookahead == '<')
        ADVANCE(137);
      if (lookahead == '=')
        ADVANCE(191);
      if (lookahead == '>')
        ADVANCE(138);
      if (lookahead == '\\')
        SKIP(221);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279)
        SKIP(220);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(86);
      END_STATE();
    case 221:
      if (lookahead == '\n')
        SKIP(220);
      if (lookahead == '\r')
        SKIP(222);
      END_STATE();
    case 222:
      if (lookahead == '\n')
        SKIP(220);
      END_STATE();
    case 223:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '\"')
        ADVANCE(4);
      if (lookahead == '#')
        ADVANCE(13);
      if (lookahead == '%')
        ADVANCE(173);
      if (lookahead == '&')
        ADVANCE(174);
      if (lookahead == '\'')
        ADVANCE(18);
      if (lookahead == '(')
        ADVANCE(26);
      if (lookahead == '*')
        ADVANCE(175);
      if (lookahead == '+')
        ADVANCE(116);
      if (lookahead == '-')
        ADVANCE(117);
      if (lookahead == '.')
        ADVANCE(124);
      if (lookahead == '/')
        ADVANCE(177);
      if (lookahead == ';')
        ADVANCE(67);
      if (lookahead == '<')
        ADVANCE(179);
      if (lookahead == '=')
        ADVANCE(191);
      if (lookahead == '>')
        ADVANCE(181);
      if (lookahead == '@')
        ADVANCE(119);
      if (lookahead == '[')
        ADVANCE(95);
      if (lookahead == '\\')
        SKIP(224);
      if (lookahead == '^')
        ADVANCE(185);
      if (lookahead == '`')
        ADVANCE(101);
      if (lookahead == '|')
        ADVANCE(186);
      if (lookahead == 'B' ||
          lookahead == 'b')
        ADVANCE(109);
      if (lookahead == 'R' ||
          lookahead == 'r')
        ADVANCE(109);
      if (lookahead == 'U' ||
          lookahead == 'u')
        ADVANCE(109);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279)
        SKIP(223);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('_' <= lookahead && lookahead <= 'z'))
        ADVANCE(86);
      END_STATE();
    case 224:
      if (lookahead == '\n')
        SKIP(223);
      if (lookahead == '\r')
        SKIP(225);
      END_STATE();
    case 225:
      if (lookahead == '\n')
        SKIP(223);
      END_STATE();
    case 226:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(13);
      if (lookahead == '%')
        ADVANCE(173);
      if (lookahead == '&')
        ADVANCE(174);
      if (lookahead == '(')
        ADVANCE(26);
      if (lookahead == '*')
        ADVANCE(175);
      if (lookahead == '+')
        ADVANCE(116);
      if (lookahead == '-')
        ADVANCE(117);
      if (lookahead == '.')
        ADVANCE(124);
      if (lookahead == '/')
        ADVANCE(177);
      if (lookahead == ';')
        ADVANCE(67);
      if (lookahead == '<')
        ADVANCE(179);
      if (lookahead == '=')
        ADVANCE(191);
      if (lookahead == '>')
        ADVANCE(181);
      if (lookahead == '@')
        ADVANCE(119);
      if (lookahead == '[')
        ADVANCE(95);
      if (lookahead == '\\')
        SKIP(227);
      if (lookahead == '^')
        ADVANCE(185);
      if (lookahead == '|')
        ADVANCE(186);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279)
        SKIP(226);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(86);
      END_STATE();
    case 227:
      if (lookahead == '\n')
        SKIP(226);
      if (lookahead == '\r')
        SKIP(228);
      END_STATE();
    case 228:
      if (lookahead == '\n')
        SKIP(226);
      END_STATE();
    case 229:
      if (lookahead == '\"')
        ADVANCE(4);
      if (lookahead == '#')
        ADVANCE(13);
      if (lookahead == '\'')
        ADVANCE(18);
      if (lookahead == '(')
        ADVANCE(26);
      if (lookahead == '+')
        ADVANCE(116);
      if (lookahead == '-')
        ADVANCE(117);
      if (lookahead == '.')
        ADVANCE(118);
      if (lookahead == '0')
        ADVANCE(51);
      if (lookahead == '@')
        ADVANCE(119);
      if (lookahead == 'F')
        ADVANCE(81);
      if (lookahead == 'N')
        ADVANCE(87);
      if (lookahead == 'T')
        ADVANCE(91);
      if (lookahead == '[')
        ADVANCE(95);
      if (lookahead == '\\')
        SKIP(230);
      if (lookahead == '`')
        ADVANCE(101);
      if (lookahead == '{')
        ADVANCE(104);
      if (lookahead == '~')
        ADVANCE(108);
      if (lookahead == 'B' ||
          lookahead == 'b')
        ADVANCE(109);
      if (lookahead == 'E' ||
          lookahead == 'e')
        ADVANCE(110);
      if (lookahead == 'R' ||
          lookahead == 'r')
        ADVANCE(109);
      if (lookahead == 'U' ||
          lookahead == 'u')
        ADVANCE(109);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279)
        SKIP(229);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(65);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('_' <= lookahead && lookahead <= 'z'))
        ADVANCE(86);
      END_STATE();
    case 230:
      if (lookahead == '\n')
        SKIP(229);
      if (lookahead == '\r')
        SKIP(231);
      END_STATE();
    case 231:
      if (lookahead == '\n')
        SKIP(229);
      END_STATE();
    case 232:
      if (lookahead == '#')
        ADVANCE(13);
      if (lookahead == '-')
        ADVANCE(233);
      if (lookahead == ':')
        ADVANCE(66);
      if (lookahead == '\\')
        SKIP(234);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279)
        SKIP(232);
      END_STATE();
    case 233:
      if (lookahead == '>')
        ADVANCE(37);
      END_STATE();
    case 234:
      if (lookahead == '\n')
        SKIP(232);
      if (lookahead == '\r')
        SKIP(235);
      END_STATE();
    case 235:
      if (lookahead == '\n')
        SKIP(232);
      END_STATE();
    case 236:
      if (lookahead == '#')
        ADVANCE(13);
      if (lookahead == '\\')
        SKIP(237);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279)
        SKIP(236);
      END_STATE();
    case 237:
      if (lookahead == '\n')
        SKIP(236);
      if (lookahead == '\r')
        SKIP(238);
      END_STATE();
    case 238:
      if (lookahead == '\n')
        SKIP(236);
      END_STATE();
    case 239:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '\"')
        ADVANCE(4);
      if (lookahead == '#')
        ADVANCE(13);
      if (lookahead == '%')
        ADVANCE(173);
      if (lookahead == '&')
        ADVANCE(174);
      if (lookahead == '\'')
        ADVANCE(18);
      if (lookahead == '(')
        ADVANCE(26);
      if (lookahead == '*')
        ADVANCE(175);
      if (lookahead == '+')
        ADVANCE(116);
      if (lookahead == '-')
        ADVANCE(117);
      if (lookahead == '.')
        ADVANCE(124);
      if (lookahead == '/')
        ADVANCE(177);
      if (lookahead == ';')
        ADVANCE(67);
      if (lookahead == '<')
        ADVANCE(179);
      if (lookahead == '=')
        ADVANCE(73);
      if (lookahead == '>')
        ADVANCE(181);
      if (lookahead == '@')
        ADVANCE(119);
      if (lookahead == '[')
        ADVANCE(95);
      if (lookahead == '\\')
        SKIP(240);
      if (lookahead == '^')
        ADVANCE(185);
      if (lookahead == '`')
        ADVANCE(101);
      if (lookahead == '|')
        ADVANCE(186);
      if (lookahead == 'B' ||
          lookahead == 'b')
        ADVANCE(109);
      if (lookahead == 'R' ||
          lookahead == 'r')
        ADVANCE(109);
      if (lookahead == 'U' ||
          lookahead == 'u')
        ADVANCE(109);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279)
        SKIP(239);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('_' <= lookahead && lookahead <= 'z'))
        ADVANCE(86);
      END_STATE();
    case 240:
      if (lookahead == '\n')
        SKIP(239);
      if (lookahead == '\r')
        SKIP(241);
      END_STATE();
    case 241:
      if (lookahead == '\n')
        SKIP(239);
      END_STATE();
    case 242:
      if (lookahead == '#')
        ADVANCE(13);
      if (lookahead == ';')
        ADVANCE(67);
      if (lookahead == '=')
        ADVANCE(152);
      if (lookahead == '\\')
        SKIP(243);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279)
        SKIP(242);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(86);
      END_STATE();
    case 243:
      if (lookahead == '\n')
        SKIP(242);
      if (lookahead == '\r')
        SKIP(244);
      END_STATE();
    case 244:
      if (lookahead == '\n')
        SKIP(242);
      END_STATE();
    case 245:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(13);
      if (lookahead == '%')
        ADVANCE(173);
      if (lookahead == '&')
        ADVANCE(174);
      if (lookahead == '(')
        ADVANCE(26);
      if (lookahead == '*')
        ADVANCE(175);
      if (lookahead == '+')
        ADVANCE(116);
      if (lookahead == '-')
        ADVANCE(117);
      if (lookahead == '.')
        ADVANCE(124);
      if (lookahead == '/')
        ADVANCE(177);
      if (lookahead == ';')
        ADVANCE(67);
      if (lookahead == '<')
        ADVANCE(179);
      if (lookahead == '=')
        ADVANCE(73);
      if (lookahead == '>')
        ADVANCE(181);
      if (lookahead == '@')
        ADVANCE(119);
      if (lookahead == '[')
        ADVANCE(95);
      if (lookahead == '\\')
        SKIP(246);
      if (lookahead == '^')
        ADVANCE(185);
      if (lookahead == '|')
        ADVANCE(186);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279)
        SKIP(245);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(86);
      END_STATE();
    case 246:
      if (lookahead == '\n')
        SKIP(245);
      if (lookahead == '\r')
        SKIP(247);
      END_STATE();
    case 247:
      if (lookahead == '\n')
        SKIP(245);
      END_STATE();
    case 248:
      if (lookahead == '#')
        ADVANCE(13);
      if (lookahead == ';')
        ADVANCE(67);
      if (lookahead == '=')
        ADVANCE(152);
      if (lookahead == '\\')
        SKIP(249);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279)
        SKIP(248);
      END_STATE();
    case 249:
      if (lookahead == '\n')
        SKIP(248);
      if (lookahead == '\r')
        SKIP(250);
      END_STATE();
    case 250:
      if (lookahead == '\n')
        SKIP(248);
      END_STATE();
    case 251:
      if (lookahead == '#')
        ADVANCE(13);
      if (lookahead == '%')
        ADVANCE(142);
      if (lookahead == '&')
        ADVANCE(143);
      if (lookahead == '*')
        ADVANCE(144);
      if (lookahead == '+')
        ADVANCE(146);
      if (lookahead == '-')
        ADVANCE(147);
      if (lookahead == '/')
        ADVANCE(148);
      if (lookahead == ':')
        ADVANCE(66);
      if (lookahead == ';')
        ADVANCE(67);
      if (lookahead == '<')
        ADVANCE(150);
      if (lookahead == '=')
        ADVANCE(152);
      if (lookahead == '>')
        ADVANCE(153);
      if (lookahead == '@')
        ADVANCE(155);
      if (lookahead == '\\')
        SKIP(252);
      if (lookahead == '^')
        ADVANCE(158);
      if (lookahead == '|')
        ADVANCE(159);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279)
        SKIP(251);
      END_STATE();
    case 252:
      if (lookahead == '\n')
        SKIP(251);
      if (lookahead == '\r')
        SKIP(253);
      END_STATE();
    case 253:
      if (lookahead == '\n')
        SKIP(251);
      END_STATE();
    case 254:
      if (lookahead == '#')
        ADVANCE(13);
      if (lookahead == '(')
        ADVANCE(26);
      if (lookahead == ',')
        ADVANCE(34);
      if (lookahead == '.')
        ADVANCE(124);
      if (lookahead == ';')
        ADVANCE(67);
      if (lookahead == '\\')
        SKIP(255);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279)
        SKIP(254);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(86);
      END_STATE();
    case 255:
      if (lookahead == '\n')
        SKIP(254);
      if (lookahead == '\r')
        SKIP(256);
      END_STATE();
    case 256:
      if (lookahead == '\n')
        SKIP(254);
      END_STATE();
    case 257:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(13);
      if (lookahead == ';')
        ADVANCE(67);
      if (lookahead == '<')
        ADVANCE(137);
      if (lookahead == '=')
        ADVANCE(191);
      if (lookahead == '>')
        ADVANCE(138);
      if (lookahead == '\\')
        SKIP(258);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279)
        SKIP(257);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(86);
      END_STATE();
    case 258:
      if (lookahead == '\n')
        SKIP(257);
      if (lookahead == '\r')
        SKIP(259);
      END_STATE();
    case 259:
      if (lookahead == '\n')
        SKIP(257);
      END_STATE();
    case 260:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(13);
      if (lookahead == ';')
        ADVANCE(67);
      if (lookahead == '<')
        ADVANCE(137);
      if (lookahead == '=')
        ADVANCE(73);
      if (lookahead == '>')
        ADVANCE(138);
      if (lookahead == '\\')
        SKIP(261);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279)
        SKIP(260);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(86);
      END_STATE();
    case 261:
      if (lookahead == '\n')
        SKIP(260);
      if (lookahead == '\r')
        SKIP(262);
      END_STATE();
    case 262:
      if (lookahead == '\n')
        SKIP(260);
      END_STATE();
    default:
      return false;
  }
}

static bool ts_lex_keywords(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  switch (state) {
    case 0:
      if (lookahead == 'a')
        ADVANCE(1);
      if (lookahead == 'b')
        ADVANCE(16);
      if (lookahead == 'c')
        ADVANCE(21);
      if (lookahead == 'd')
        ADVANCE(33);
      if (lookahead == 'e')
        ADVANCE(37);
      if (lookahead == 'f')
        ADVANCE(50);
      if (lookahead == 'g')
        ADVANCE(62);
      if (lookahead == 'i')
        ADVANCE(68);
      if (lookahead == 'l')
        ADVANCE(77);
      if (lookahead == 'n')
        ADVANCE(83);
      if (lookahead == 'o')
        ADVANCE(92);
      if (lookahead == 'p')
        ADVANCE(94);
      if (lookahead == 'r')
        ADVANCE(102);
      if (lookahead == 't')
        ADVANCE(112);
      if (lookahead == 'w')
        ADVANCE(115);
      if (lookahead == 'y')
        ADVANCE(123);
      END_STATE();
    case 1:
      if (lookahead == 'n')
        ADVANCE(2);
      if (lookahead == 's')
        ADVANCE(4);
      if (lookahead == 'w')
        ADVANCE(12);
      END_STATE();
    case 2:
      if (lookahead == 'd')
        ADVANCE(3);
      END_STATE();
    case 3:
      ACCEPT_TOKEN(anon_sym_and);
      END_STATE();
    case 4:
      ACCEPT_TOKEN(anon_sym_as);
      if (lookahead == 's')
        ADVANCE(5);
      if (lookahead == 'y')
        ADVANCE(9);
      END_STATE();
    case 5:
      if (lookahead == 'e')
        ADVANCE(6);
      END_STATE();
    case 6:
      if (lookahead == 'r')
        ADVANCE(7);
      END_STATE();
    case 7:
      if (lookahead == 't')
        ADVANCE(8);
      END_STATE();
    case 8:
      ACCEPT_TOKEN(anon_sym_assert);
      END_STATE();
    case 9:
      if (lookahead == 'n')
        ADVANCE(10);
      END_STATE();
    case 10:
      if (lookahead == 'c')
        ADVANCE(11);
      END_STATE();
    case 11:
      ACCEPT_TOKEN(anon_sym_async);
      END_STATE();
    case 12:
      if (lookahead == 'a')
        ADVANCE(13);
      END_STATE();
    case 13:
      if (lookahead == 'i')
        ADVANCE(14);
      END_STATE();
    case 14:
      if (lookahead == 't')
        ADVANCE(15);
      END_STATE();
    case 15:
      ACCEPT_TOKEN(anon_sym_await);
      END_STATE();
    case 16:
      if (lookahead == 'r')
        ADVANCE(17);
      END_STATE();
    case 17:
      if (lookahead == 'e')
        ADVANCE(18);
      END_STATE();
    case 18:
      if (lookahead == 'a')
        ADVANCE(19);
      END_STATE();
    case 19:
      if (lookahead == 'k')
        ADVANCE(20);
      END_STATE();
    case 20:
      ACCEPT_TOKEN(sym_break_statement);
      END_STATE();
    case 21:
      if (lookahead == 'l')
        ADVANCE(22);
      if (lookahead == 'o')
        ADVANCE(26);
      END_STATE();
    case 22:
      if (lookahead == 'a')
        ADVANCE(23);
      END_STATE();
    case 23:
      if (lookahead == 's')
        ADVANCE(24);
      END_STATE();
    case 24:
      if (lookahead == 's')
        ADVANCE(25);
      END_STATE();
    case 25:
      ACCEPT_TOKEN(anon_sym_class);
      END_STATE();
    case 26:
      if (lookahead == 'n')
        ADVANCE(27);
      END_STATE();
    case 27:
      if (lookahead == 't')
        ADVANCE(28);
      END_STATE();
    case 28:
      if (lookahead == 'i')
        ADVANCE(29);
      END_STATE();
    case 29:
      if (lookahead == 'n')
        ADVANCE(30);
      END_STATE();
    case 30:
      if (lookahead == 'u')
        ADVANCE(31);
      END_STATE();
    case 31:
      if (lookahead == 'e')
        ADVANCE(32);
      END_STATE();
    case 32:
      ACCEPT_TOKEN(sym_continue_statement);
      END_STATE();
    case 33:
      if (lookahead == 'e')
        ADVANCE(34);
      END_STATE();
    case 34:
      if (lookahead == 'f')
        ADVANCE(35);
      if (lookahead == 'l')
        ADVANCE(36);
      END_STATE();
    case 35:
      ACCEPT_TOKEN(anon_sym_def);
      END_STATE();
    case 36:
      ACCEPT_TOKEN(anon_sym_del);
      END_STATE();
    case 37:
      if (lookahead == 'l')
        ADVANCE(38);
      if (lookahead == 'x')
        ADVANCE(43);
      END_STATE();
    case 38:
      if (lookahead == 'i')
        ADVANCE(39);
      if (lookahead == 's')
        ADVANCE(41);
      END_STATE();
    case 39:
      if (lookahead == 'f')
        ADVANCE(40);
      END_STATE();
    case 40:
      ACCEPT_TOKEN(anon_sym_elif);
      END_STATE();
    case 41:
      if (lookahead == 'e')
        ADVANCE(42);
      END_STATE();
    case 42:
      ACCEPT_TOKEN(anon_sym_else);
      END_STATE();
    case 43:
      if (lookahead == 'c')
        ADVANCE(44);
      if (lookahead == 'e')
        ADVANCE(48);
      END_STATE();
    case 44:
      if (lookahead == 'e')
        ADVANCE(45);
      END_STATE();
    case 45:
      if (lookahead == 'p')
        ADVANCE(46);
      END_STATE();
    case 46:
      if (lookahead == 't')
        ADVANCE(47);
      END_STATE();
    case 47:
      ACCEPT_TOKEN(anon_sym_except);
      END_STATE();
    case 48:
      if (lookahead == 'c')
        ADVANCE(49);
      END_STATE();
    case 49:
      ACCEPT_TOKEN(anon_sym_exec);
      END_STATE();
    case 50:
      if (lookahead == 'i')
        ADVANCE(51);
      if (lookahead == 'o')
        ADVANCE(57);
      if (lookahead == 'r')
        ADVANCE(59);
      END_STATE();
    case 51:
      if (lookahead == 'n')
        ADVANCE(52);
      END_STATE();
    case 52:
      if (lookahead == 'a')
        ADVANCE(53);
      END_STATE();
    case 53:
      if (lookahead == 'l')
        ADVANCE(54);
      END_STATE();
    case 54:
      if (lookahead == 'l')
        ADVANCE(55);
      END_STATE();
    case 55:
      if (lookahead == 'y')
        ADVANCE(56);
      END_STATE();
    case 56:
      ACCEPT_TOKEN(anon_sym_finally);
      END_STATE();
    case 57:
      if (lookahead == 'r')
        ADVANCE(58);
      END_STATE();
    case 58:
      ACCEPT_TOKEN(anon_sym_for);
      END_STATE();
    case 59:
      if (lookahead == 'o')
        ADVANCE(60);
      END_STATE();
    case 60:
      if (lookahead == 'm')
        ADVANCE(61);
      END_STATE();
    case 61:
      ACCEPT_TOKEN(anon_sym_from);
      END_STATE();
    case 62:
      if (lookahead == 'l')
        ADVANCE(63);
      END_STATE();
    case 63:
      if (lookahead == 'o')
        ADVANCE(64);
      END_STATE();
    case 64:
      if (lookahead == 'b')
        ADVANCE(65);
      END_STATE();
    case 65:
      if (lookahead == 'a')
        ADVANCE(66);
      END_STATE();
    case 66:
      if (lookahead == 'l')
        ADVANCE(67);
      END_STATE();
    case 67:
      ACCEPT_TOKEN(anon_sym_global);
      END_STATE();
    case 68:
      if (lookahead == 'f')
        ADVANCE(69);
      if (lookahead == 'm')
        ADVANCE(70);
      if (lookahead == 'n')
        ADVANCE(75);
      if (lookahead == 's')
        ADVANCE(76);
      END_STATE();
    case 69:
      ACCEPT_TOKEN(anon_sym_if);
      END_STATE();
    case 70:
      if (lookahead == 'p')
        ADVANCE(71);
      END_STATE();
    case 71:
      if (lookahead == 'o')
        ADVANCE(72);
      END_STATE();
    case 72:
      if (lookahead == 'r')
        ADVANCE(73);
      END_STATE();
    case 73:
      if (lookahead == 't')
        ADVANCE(74);
      END_STATE();
    case 74:
      ACCEPT_TOKEN(anon_sym_import);
      END_STATE();
    case 75:
      ACCEPT_TOKEN(anon_sym_in);
      END_STATE();
    case 76:
      ACCEPT_TOKEN(anon_sym_is);
      END_STATE();
    case 77:
      if (lookahead == 'a')
        ADVANCE(78);
      END_STATE();
    case 78:
      if (lookahead == 'm')
        ADVANCE(79);
      END_STATE();
    case 79:
      if (lookahead == 'b')
        ADVANCE(80);
      END_STATE();
    case 80:
      if (lookahead == 'd')
        ADVANCE(81);
      END_STATE();
    case 81:
      if (lookahead == 'a')
        ADVANCE(82);
      END_STATE();
    case 82:
      ACCEPT_TOKEN(anon_sym_lambda);
      END_STATE();
    case 83:
      if (lookahead == 'o')
        ADVANCE(84);
      END_STATE();
    case 84:
      if (lookahead == 'n')
        ADVANCE(85);
      if (lookahead == 't')
        ADVANCE(91);
      END_STATE();
    case 85:
      if (lookahead == 'l')
        ADVANCE(86);
      END_STATE();
    case 86:
      if (lookahead == 'o')
        ADVANCE(87);
      END_STATE();
    case 87:
      if (lookahead == 'c')
        ADVANCE(88);
      END_STATE();
    case 88:
      if (lookahead == 'a')
        ADVANCE(89);
      END_STATE();
    case 89:
      if (lookahead == 'l')
        ADVANCE(90);
      END_STATE();
    case 90:
      ACCEPT_TOKEN(anon_sym_nonlocal);
      END_STATE();
    case 91:
      ACCEPT_TOKEN(anon_sym_not);
      END_STATE();
    case 92:
      if (lookahead == 'r')
        ADVANCE(93);
      END_STATE();
    case 93:
      ACCEPT_TOKEN(anon_sym_or);
      END_STATE();
    case 94:
      if (lookahead == 'a')
        ADVANCE(95);
      if (lookahead == 'r')
        ADVANCE(98);
      END_STATE();
    case 95:
      if (lookahead == 's')
        ADVANCE(96);
      END_STATE();
    case 96:
      if (lookahead == 's')
        ADVANCE(97);
      END_STATE();
    case 97:
      ACCEPT_TOKEN(sym_pass_statement);
      END_STATE();
    case 98:
      if (lookahead == 'i')
        ADVANCE(99);
      END_STATE();
    case 99:
      if (lookahead == 'n')
        ADVANCE(100);
      END_STATE();
    case 100:
      if (lookahead == 't')
        ADVANCE(101);
      END_STATE();
    case 101:
      ACCEPT_TOKEN(anon_sym_print);
      END_STATE();
    case 102:
      if (lookahead == 'a')
        ADVANCE(103);
      if (lookahead == 'e')
        ADVANCE(107);
      END_STATE();
    case 103:
      if (lookahead == 'i')
        ADVANCE(104);
      END_STATE();
    case 104:
      if (lookahead == 's')
        ADVANCE(105);
      END_STATE();
    case 105:
      if (lookahead == 'e')
        ADVANCE(106);
      END_STATE();
    case 106:
      ACCEPT_TOKEN(anon_sym_raise);
      END_STATE();
    case 107:
      if (lookahead == 't')
        ADVANCE(108);
      END_STATE();
    case 108:
      if (lookahead == 'u')
        ADVANCE(109);
      END_STATE();
    case 109:
      if (lookahead == 'r')
        ADVANCE(110);
      END_STATE();
    case 110:
      if (lookahead == 'n')
        ADVANCE(111);
      END_STATE();
    case 111:
      ACCEPT_TOKEN(anon_sym_return);
      END_STATE();
    case 112:
      if (lookahead == 'r')
        ADVANCE(113);
      END_STATE();
    case 113:
      if (lookahead == 'y')
        ADVANCE(114);
      END_STATE();
    case 114:
      ACCEPT_TOKEN(anon_sym_try);
      END_STATE();
    case 115:
      if (lookahead == 'h')
        ADVANCE(116);
      if (lookahead == 'i')
        ADVANCE(120);
      END_STATE();
    case 116:
      if (lookahead == 'i')
        ADVANCE(117);
      END_STATE();
    case 117:
      if (lookahead == 'l')
        ADVANCE(118);
      END_STATE();
    case 118:
      if (lookahead == 'e')
        ADVANCE(119);
      END_STATE();
    case 119:
      ACCEPT_TOKEN(anon_sym_while);
      END_STATE();
    case 120:
      if (lookahead == 't')
        ADVANCE(121);
      END_STATE();
    case 121:
      if (lookahead == 'h')
        ADVANCE(122);
      END_STATE();
    case 122:
      ACCEPT_TOKEN(anon_sym_with);
      END_STATE();
    case 123:
      if (lookahead == 'i')
        ADVANCE(124);
      END_STATE();
    case 124:
      if (lookahead == 'e')
        ADVANCE(125);
      END_STATE();
    case 125:
      if (lookahead == 'l')
        ADVANCE(126);
      END_STATE();
    case 126:
      if (lookahead == 'd')
        ADVANCE(127);
      END_STATE();
    case 127:
      ACCEPT_TOKEN(anon_sym_yield);
      END_STATE();
    default:
      return false;
  }
}

static TSLexMode ts_lex_modes[STATE_COUNT] = {
  [0] = {.lex_state = 0, .external_lex_state = 1},
  [1] = {.lex_state = 114},
  [2] = {.lex_state = 122},
  [3] = {.lex_state = 122},
  [4] = {.lex_state = 114},
  [5] = {.lex_state = 127, .external_lex_state = 2},
  [6] = {.lex_state = 114},
  [7] = {.lex_state = 130, .external_lex_state = 2},
  [8] = {.lex_state = 114},
  [9] = {.lex_state = 130, .external_lex_state = 2},
  [10] = {.lex_state = 133, .external_lex_state = 2},
  [11] = {.lex_state = 114},
  [12] = {.lex_state = 122},
  [13] = {.lex_state = 114},
  [14] = {.lex_state = 114},
  [15] = {.lex_state = 0},
  [16] = {.lex_state = 114},
  [17] = {.lex_state = 122},
  [18] = {.lex_state = 122},
  [19] = {.lex_state = 122},
  [20] = {.lex_state = 122, .external_lex_state = 2},
  [21] = {.lex_state = 122},
  [22] = {.lex_state = 122},
  [23] = {.lex_state = 114},
  [24] = {.lex_state = 114},
  [25] = {.lex_state = 136},
  [26] = {.lex_state = 130, .external_lex_state = 2},
  [27] = {.lex_state = 114},
  [28] = {.lex_state = 114},
  [29] = {.lex_state = 122, .external_lex_state = 2},
  [30] = {.lex_state = 114},
  [31] = {.lex_state = 0},
  [32] = {.lex_state = 0},
  [33] = {.lex_state = 141, .external_lex_state = 2},
  [34] = {.lex_state = 160, .external_lex_state = 2},
  [35] = {.lex_state = 133, .external_lex_state = 2},
  [36] = {.lex_state = 114},
  [37] = {.lex_state = 122},
  [38] = {.lex_state = 163, .external_lex_state = 2},
  [39] = {.lex_state = 133, .external_lex_state = 2},
  [40] = {.lex_state = 166, .external_lex_state = 2},
  [41] = {.lex_state = 169, .external_lex_state = 2},
  [42] = {.lex_state = 122},
  [43] = {.lex_state = 122},
  [44] = {.lex_state = 122},
  [45] = {.lex_state = 122},
  [46] = {.lex_state = 114},
  [47] = {.lex_state = 160, .external_lex_state = 2},
  [48] = {.lex_state = 0},
  [49] = {.lex_state = 172},
  [50] = {.lex_state = 114},
  [51] = {.lex_state = 114},
  [52] = {.lex_state = 136},
  [53] = {.lex_state = 114},
  [54] = {.lex_state = 114},
  [55] = {.lex_state = 114},
  [56] = {.lex_state = 172},
  [57] = {.lex_state = 114},
  [58] = {.lex_state = 136},
  [59] = {.lex_state = 172},
  [60] = {.lex_state = 0},
  [61] = {.lex_state = 114},
  [62] = {.lex_state = 187, .external_lex_state = 2},
  [63] = {.lex_state = 114},
  [64] = {.lex_state = 114},
  [65] = {.lex_state = 114},
  [66] = {.lex_state = 136},
  [67] = {.lex_state = 114},
  [68] = {.lex_state = 114},
  [69] = {.lex_state = 190, .external_lex_state = 2},
  [70] = {.lex_state = 114},
  [71] = {.lex_state = 166, .external_lex_state = 2},
  [72] = {.lex_state = 169, .external_lex_state = 2},
  [73] = {.lex_state = 194, .external_lex_state = 2},
  [74] = {.lex_state = 169, .external_lex_state = 2},
  [75] = {.lex_state = 133, .external_lex_state = 2},
  [76] = {.lex_state = 169, .external_lex_state = 2},
  [77] = {.lex_state = 133, .external_lex_state = 2},
  [78] = {.lex_state = 114},
  [79] = {.lex_state = 114},
  [80] = {.lex_state = 114},
  [81] = {.lex_state = 136},
  [82] = {.lex_state = 190, .external_lex_state = 2},
  [83] = {.lex_state = 114},
  [84] = {.lex_state = 197, .external_lex_state = 2},
  [85] = {.lex_state = 169, .external_lex_state = 2},
  [86] = {.lex_state = 194, .external_lex_state = 2},
  [87] = {.lex_state = 114},
  [88] = {.lex_state = 200, .external_lex_state = 2},
  [89] = {.lex_state = 133, .external_lex_state = 2},
  [90] = {.lex_state = 114},
  [91] = {.lex_state = 114},
  [92] = {.lex_state = 136},
  [93] = {.lex_state = 172},
  [94] = {.lex_state = 114},
  [95] = {.lex_state = 122},
  [96] = {.lex_state = 172},
  [97] = {.lex_state = 114},
  [98] = {.lex_state = 114},
  [99] = {.lex_state = 122},
  [100] = {.lex_state = 114},
  [101] = {.lex_state = 172},
  [102] = {.lex_state = 122},
  [103] = {.lex_state = 172},
  [104] = {.lex_state = 122},
  [105] = {.lex_state = 200, .external_lex_state = 3},
  [106] = {.lex_state = 114},
  [107] = {.lex_state = 114},
  [108] = {.lex_state = 136},
  [109] = {.lex_state = 172},
  [110] = {.lex_state = 114},
  [111] = {.lex_state = 0},
  [112] = {.lex_state = 122},
  [113] = {.lex_state = 172},
  [114] = {.lex_state = 0},
  [115] = {.lex_state = 166, .external_lex_state = 2},
  [116] = {.lex_state = 166, .external_lex_state = 2},
  [117] = {.lex_state = 197, .external_lex_state = 2},
  [118] = {.lex_state = 0},
  [119] = {.lex_state = 203, .external_lex_state = 2},
  [120] = {.lex_state = 206, .external_lex_state = 2},
  [121] = {.lex_state = 160, .external_lex_state = 2},
  [122] = {.lex_state = 141, .external_lex_state = 2},
  [123] = {.lex_state = 160, .external_lex_state = 2},
  [124] = {.lex_state = 114},
  [125] = {.lex_state = 114},
  [126] = {.lex_state = 0},
  [127] = {.lex_state = 114},
  [128] = {.lex_state = 0},
  [129] = {.lex_state = 0},
  [130] = {.lex_state = 0},
  [131] = {.lex_state = 0},
  [132] = {.lex_state = 0},
  [133] = {.lex_state = 114},
  [134] = {.lex_state = 133, .external_lex_state = 2},
  [135] = {.lex_state = 0},
  [136] = {.lex_state = 114},
  [137] = {.lex_state = 114},
  [138] = {.lex_state = 114},
  [139] = {.lex_state = 136},
  [140] = {.lex_state = 160, .external_lex_state = 2},
  [141] = {.lex_state = 172},
  [142] = {.lex_state = 114},
  [143] = {.lex_state = 0},
  [144] = {.lex_state = 136},
  [145] = {.lex_state = 172},
  [146] = {.lex_state = 0},
  [147] = {.lex_state = 114},
  [148] = {.lex_state = 114},
  [149] = {.lex_state = 114},
  [150] = {.lex_state = 136},
  [151] = {.lex_state = 160, .external_lex_state = 2},
  [152] = {.lex_state = 172},
  [153] = {.lex_state = 114},
  [154] = {.lex_state = 0},
  [155] = {.lex_state = 0},
  [156] = {.lex_state = 136},
  [157] = {.lex_state = 172},
  [158] = {.lex_state = 136},
  [159] = {.lex_state = 122, .external_lex_state = 2},
  [160] = {.lex_state = 141, .external_lex_state = 2},
  [161] = {.lex_state = 114},
  [162] = {.lex_state = 114},
  [163] = {.lex_state = 114},
  [164] = {.lex_state = 209, .external_lex_state = 2},
  [165] = {.lex_state = 114},
  [166] = {.lex_state = 114},
  [167] = {.lex_state = 114},
  [168] = {.lex_state = 212, .external_lex_state = 2},
  [169] = {.lex_state = 122},
  [170] = {.lex_state = 114},
  [171] = {.lex_state = 114},
  [172] = {.lex_state = 114},
  [173] = {.lex_state = 114},
  [174] = {.lex_state = 122},
  [175] = {.lex_state = 114},
  [176] = {.lex_state = 114},
  [177] = {.lex_state = 114},
  [178] = {.lex_state = 114},
  [179] = {.lex_state = 114},
  [180] = {.lex_state = 114},
  [181] = {.lex_state = 114},
  [182] = {.lex_state = 160, .external_lex_state = 2},
  [183] = {.lex_state = 215, .external_lex_state = 2},
  [184] = {.lex_state = 114},
  [185] = {.lex_state = 122},
  [186] = {.lex_state = 114},
  [187] = {.lex_state = 122},
  [188] = {.lex_state = 122},
  [189] = {.lex_state = 163, .external_lex_state = 2},
  [190] = {.lex_state = 197, .external_lex_state = 2},
  [191] = {.lex_state = 166, .external_lex_state = 2},
  [192] = {.lex_state = 122},
  [193] = {.lex_state = 122},
  [194] = {.lex_state = 122},
  [195] = {.lex_state = 122},
  [196] = {.lex_state = 136},
  [197] = {.lex_state = 122},
  [198] = {.lex_state = 172},
  [199] = {.lex_state = 0},
  [200] = {.lex_state = 136},
  [201] = {.lex_state = 0},
  [202] = {.lex_state = 160, .external_lex_state = 2},
  [203] = {.lex_state = 136},
  [204] = {.lex_state = 172},
  [205] = {.lex_state = 114},
  [206] = {.lex_state = 0},
  [207] = {.lex_state = 114},
  [208] = {.lex_state = 114},
  [209] = {.lex_state = 114},
  [210] = {.lex_state = 136},
  [211] = {.lex_state = 172},
  [212] = {.lex_state = 114},
  [213] = {.lex_state = 0},
  [214] = {.lex_state = 136},
  [215] = {.lex_state = 172},
  [216] = {.lex_state = 0},
  [217] = {.lex_state = 172},
  [218] = {.lex_state = 0},
  [219] = {.lex_state = 136},
  [220] = {.lex_state = 0},
  [221] = {.lex_state = 172},
  [222] = {.lex_state = 0},
  [223] = {.lex_state = 0},
  [224] = {.lex_state = 136},
  [225] = {.lex_state = 136},
  [226] = {.lex_state = 172},
  [227] = {.lex_state = 136},
  [228] = {.lex_state = 160, .external_lex_state = 2},
  [229] = {.lex_state = 114},
  [230] = {.lex_state = 114},
  [231] = {.lex_state = 122},
  [232] = {.lex_state = 114},
  [233] = {.lex_state = 114},
  [234] = {.lex_state = 114},
  [235] = {.lex_state = 0},
  [236] = {.lex_state = 136},
  [237] = {.lex_state = 0},
  [238] = {.lex_state = 122},
  [239] = {.lex_state = 114},
  [240] = {.lex_state = 114},
  [241] = {.lex_state = 114},
  [242] = {.lex_state = 114},
  [243] = {.lex_state = 122},
  [244] = {.lex_state = 114},
  [245] = {.lex_state = 114},
  [246] = {.lex_state = 114},
  [247] = {.lex_state = 114},
  [248] = {.lex_state = 114},
  [249] = {.lex_state = 114},
  [250] = {.lex_state = 114},
  [251] = {.lex_state = 172},
  [252] = {.lex_state = 136},
  [253] = {.lex_state = 187, .external_lex_state = 2},
  [254] = {.lex_state = 0},
  [255] = {.lex_state = 136},
  [256] = {.lex_state = 0},
  [257] = {.lex_state = 169, .external_lex_state = 2},
  [258] = {.lex_state = 169, .external_lex_state = 2},
  [259] = {.lex_state = 187, .external_lex_state = 2},
  [260] = {.lex_state = 114},
  [261] = {.lex_state = 0},
  [262] = {.lex_state = 0},
  [263] = {.lex_state = 187, .external_lex_state = 2},
  [264] = {.lex_state = 0},
  [265] = {.lex_state = 136},
  [266] = {.lex_state = 0},
  [267] = {.lex_state = 187, .external_lex_state = 2},
  [268] = {.lex_state = 0},
  [269] = {.lex_state = 0},
  [270] = {.lex_state = 136},
  [271] = {.lex_state = 136},
  [272] = {.lex_state = 190, .external_lex_state = 2},
  [273] = {.lex_state = 130, .external_lex_state = 2},
  [274] = {.lex_state = 166, .external_lex_state = 2},
  [275] = {.lex_state = 114},
  [276] = {.lex_state = 114},
  [277] = {.lex_state = 114},
  [278] = {.lex_state = 122},
  [279] = {.lex_state = 114},
  [280] = {.lex_state = 114},
  [281] = {.lex_state = 114},
  [282] = {.lex_state = 114},
  [283] = {.lex_state = 122},
  [284] = {.lex_state = 114},
  [285] = {.lex_state = 114},
  [286] = {.lex_state = 114},
  [287] = {.lex_state = 114},
  [288] = {.lex_state = 114},
  [289] = {.lex_state = 114},
  [290] = {.lex_state = 114},
  [291] = {.lex_state = 187, .external_lex_state = 2},
  [292] = {.lex_state = 220, .external_lex_state = 2},
  [293] = {.lex_state = 114},
  [294] = {.lex_state = 166, .external_lex_state = 2},
  [295] = {.lex_state = 130, .external_lex_state = 2},
  [296] = {.lex_state = 166, .external_lex_state = 2},
  [297] = {.lex_state = 114},
  [298] = {.lex_state = 114},
  [299] = {.lex_state = 136},
  [300] = {.lex_state = 223, .external_lex_state = 2},
  [301] = {.lex_state = 114},
  [302] = {.lex_state = 197, .external_lex_state = 2},
  [303] = {.lex_state = 226, .external_lex_state = 2},
  [304] = {.lex_state = 169, .external_lex_state = 2},
  [305] = {.lex_state = 114},
  [306] = {.lex_state = 0},
  [307] = {.lex_state = 190, .external_lex_state = 2},
  [308] = {.lex_state = 114},
  [309] = {.lex_state = 130, .external_lex_state = 2},
  [310] = {.lex_state = 114},
  [311] = {.lex_state = 114},
  [312] = {.lex_state = 114},
  [313] = {.lex_state = 169, .external_lex_state = 2},
  [314] = {.lex_state = 114},
  [315] = {.lex_state = 114},
  [316] = {.lex_state = 114},
  [317] = {.lex_state = 122},
  [318] = {.lex_state = 114},
  [319] = {.lex_state = 114},
  [320] = {.lex_state = 114},
  [321] = {.lex_state = 114},
  [322] = {.lex_state = 114},
  [323] = {.lex_state = 114},
  [324] = {.lex_state = 220, .external_lex_state = 2},
  [325] = {.lex_state = 114},
  [326] = {.lex_state = 133, .external_lex_state = 2},
  [327] = {.lex_state = 200, .external_lex_state = 2},
  [328] = {.lex_state = 133, .external_lex_state = 2},
  [329] = {.lex_state = 122},
  [330] = {.lex_state = 114},
  [331] = {.lex_state = 0},
  [332] = {.lex_state = 172},
  [333] = {.lex_state = 114},
  [334] = {.lex_state = 200, .external_lex_state = 3},
  [335] = {.lex_state = 114},
  [336] = {.lex_state = 114},
  [337] = {.lex_state = 114},
  [338] = {.lex_state = 114},
  [339] = {.lex_state = 114},
  [340] = {.lex_state = 122},
  [341] = {.lex_state = 114},
  [342] = {.lex_state = 114},
  [343] = {.lex_state = 114},
  [344] = {.lex_state = 114},
  [345] = {.lex_state = 114},
  [346] = {.lex_state = 114},
  [347] = {.lex_state = 122},
  [348] = {.lex_state = 122},
  [349] = {.lex_state = 0},
  [350] = {.lex_state = 0},
  [351] = {.lex_state = 172},
  [352] = {.lex_state = 114},
  [353] = {.lex_state = 114},
  [354] = {.lex_state = 114},
  [355] = {.lex_state = 114},
  [356] = {.lex_state = 114},
  [357] = {.lex_state = 114},
  [358] = {.lex_state = 114},
  [359] = {.lex_state = 114},
  [360] = {.lex_state = 114},
  [361] = {.lex_state = 122},
  [362] = {.lex_state = 200, .external_lex_state = 3},
  [363] = {.lex_state = 229, .external_lex_state = 4},
  [364] = {.lex_state = 133, .external_lex_state = 2},
  [365] = {.lex_state = 122},
  [366] = {.lex_state = 122},
  [367] = {.lex_state = 114},
  [368] = {.lex_state = 0},
  [369] = {.lex_state = 172},
  [370] = {.lex_state = 114},
  [371] = {.lex_state = 200, .external_lex_state = 3},
  [372] = {.lex_state = 0},
  [373] = {.lex_state = 114},
  [374] = {.lex_state = 114},
  [375] = {.lex_state = 114},
  [376] = {.lex_state = 114},
  [377] = {.lex_state = 114},
  [378] = {.lex_state = 114},
  [379] = {.lex_state = 114},
  [380] = {.lex_state = 122},
  [381] = {.lex_state = 114},
  [382] = {.lex_state = 114},
  [383] = {.lex_state = 114},
  [384] = {.lex_state = 114},
  [385] = {.lex_state = 114},
  [386] = {.lex_state = 114},
  [387] = {.lex_state = 122},
  [388] = {.lex_state = 136},
  [389] = {.lex_state = 232},
  [390] = {.lex_state = 122},
  [391] = {.lex_state = 166, .external_lex_state = 2},
  [392] = {.lex_state = 166, .external_lex_state = 2},
  [393] = {.lex_state = 114},
  [394] = {.lex_state = 114},
  [395] = {.lex_state = 200, .external_lex_state = 3},
  [396] = {.lex_state = 0},
  [397] = {.lex_state = 203, .external_lex_state = 2},
  [398] = {.lex_state = 122},
  [399] = {.lex_state = 114},
  [400] = {.lex_state = 236, .external_lex_state = 2},
  [401] = {.lex_state = 136},
  [402] = {.lex_state = 0},
  [403] = {.lex_state = 114},
  [404] = {.lex_state = 114},
  [405] = {.lex_state = 114},
  [406] = {.lex_state = 136},
  [407] = {.lex_state = 172},
  [408] = {.lex_state = 114},
  [409] = {.lex_state = 122},
  [410] = {.lex_state = 172},
  [411] = {.lex_state = 136},
  [412] = {.lex_state = 114},
  [413] = {.lex_state = 114},
  [414] = {.lex_state = 0},
  [415] = {.lex_state = 141, .external_lex_state = 2},
  [416] = {.lex_state = 136},
  [417] = {.lex_state = 114},
  [418] = {.lex_state = 114},
  [419] = {.lex_state = 0},
  [420] = {.lex_state = 114},
  [421] = {.lex_state = 114},
  [422] = {.lex_state = 197, .external_lex_state = 2},
  [423] = {.lex_state = 160, .external_lex_state = 2},
  [424] = {.lex_state = 114},
  [425] = {.lex_state = 114},
  [426] = {.lex_state = 136},
  [427] = {.lex_state = 172},
  [428] = {.lex_state = 114},
  [429] = {.lex_state = 136},
  [430] = {.lex_state = 172},
  [431] = {.lex_state = 136},
  [432] = {.lex_state = 114},
  [433] = {.lex_state = 0},
  [434] = {.lex_state = 172},
  [435] = {.lex_state = 114},
  [436] = {.lex_state = 0},
  [437] = {.lex_state = 114},
  [438] = {.lex_state = 122},
  [439] = {.lex_state = 114},
  [440] = {.lex_state = 114},
  [441] = {.lex_state = 114},
  [442] = {.lex_state = 0},
  [443] = {.lex_state = 136},
  [444] = {.lex_state = 114},
  [445] = {.lex_state = 114},
  [446] = {.lex_state = 114},
  [447] = {.lex_state = 122},
  [448] = {.lex_state = 114},
  [449] = {.lex_state = 114},
  [450] = {.lex_state = 114},
  [451] = {.lex_state = 114},
  [452] = {.lex_state = 114},
  [453] = {.lex_state = 114},
  [454] = {.lex_state = 136},
  [455] = {.lex_state = 160, .external_lex_state = 2},
  [456] = {.lex_state = 114},
  [457] = {.lex_state = 114},
  [458] = {.lex_state = 114},
  [459] = {.lex_state = 136},
  [460] = {.lex_state = 172},
  [461] = {.lex_state = 114},
  [462] = {.lex_state = 136},
  [463] = {.lex_state = 172},
  [464] = {.lex_state = 136},
  [465] = {.lex_state = 114},
  [466] = {.lex_state = 0},
  [467] = {.lex_state = 172},
  [468] = {.lex_state = 114},
  [469] = {.lex_state = 160, .external_lex_state = 2},
  [470] = {.lex_state = 0},
  [471] = {.lex_state = 114},
  [472] = {.lex_state = 0},
  [473] = {.lex_state = 114},
  [474] = {.lex_state = 114},
  [475] = {.lex_state = 122},
  [476] = {.lex_state = 114},
  [477] = {.lex_state = 114},
  [478] = {.lex_state = 114},
  [479] = {.lex_state = 0},
  [480] = {.lex_state = 136},
  [481] = {.lex_state = 114},
  [482] = {.lex_state = 114},
  [483] = {.lex_state = 114},
  [484] = {.lex_state = 122},
  [485] = {.lex_state = 114},
  [486] = {.lex_state = 114},
  [487] = {.lex_state = 114},
  [488] = {.lex_state = 114},
  [489] = {.lex_state = 114},
  [490] = {.lex_state = 114},
  [491] = {.lex_state = 136},
  [492] = {.lex_state = 0},
  [493] = {.lex_state = 122, .external_lex_state = 2},
  [494] = {.lex_state = 114},
  [495] = {.lex_state = 114},
  [496] = {.lex_state = 136},
  [497] = {.lex_state = 239, .external_lex_state = 2},
  [498] = {.lex_state = 114},
  [499] = {.lex_state = 242, .external_lex_state = 2},
  [500] = {.lex_state = 245, .external_lex_state = 2},
  [501] = {.lex_state = 248, .external_lex_state = 2},
  [502] = {.lex_state = 251, .external_lex_state = 2},
  [503] = {.lex_state = 141, .external_lex_state = 2},
  [504] = {.lex_state = 133, .external_lex_state = 2},
  [505] = {.lex_state = 133, .external_lex_state = 2},
  [506] = {.lex_state = 141, .external_lex_state = 2},
  [507] = {.lex_state = 114},
  [508] = {.lex_state = 114},
  [509] = {.lex_state = 136},
  [510] = {.lex_state = 172},
  [511] = {.lex_state = 114},
  [512] = {.lex_state = 122},
  [513] = {.lex_state = 172},
  [514] = {.lex_state = 141, .external_lex_state = 2},
  [515] = {.lex_state = 141, .external_lex_state = 2},
  [516] = {.lex_state = 209, .external_lex_state = 2},
  [517] = {.lex_state = 212, .external_lex_state = 2},
  [518] = {.lex_state = 160, .external_lex_state = 2},
  [519] = {.lex_state = 160, .external_lex_state = 2},
  [520] = {.lex_state = 0},
  [521] = {.lex_state = 114},
  [522] = {.lex_state = 172},
  [523] = {.lex_state = 172},
  [524] = {.lex_state = 0},
  [525] = {.lex_state = 136},
  [526] = {.lex_state = 160, .external_lex_state = 2},
  [527] = {.lex_state = 160, .external_lex_state = 2},
  [528] = {.lex_state = 160, .external_lex_state = 2},
  [529] = {.lex_state = 114},
  [530] = {.lex_state = 160, .external_lex_state = 2},
  [531] = {.lex_state = 160, .external_lex_state = 2},
  [532] = {.lex_state = 160, .external_lex_state = 2},
  [533] = {.lex_state = 160, .external_lex_state = 2},
  [534] = {.lex_state = 160, .external_lex_state = 2},
  [535] = {.lex_state = 114},
  [536] = {.lex_state = 114},
  [537] = {.lex_state = 114},
  [538] = {.lex_state = 136},
  [539] = {.lex_state = 172},
  [540] = {.lex_state = 114},
  [541] = {.lex_state = 136},
  [542] = {.lex_state = 172},
  [543] = {.lex_state = 0},
  [544] = {.lex_state = 215, .external_lex_state = 2},
  [545] = {.lex_state = 254, .external_lex_state = 2},
  [546] = {.lex_state = 163, .external_lex_state = 2},
  [547] = {.lex_state = 166, .external_lex_state = 2},
  [548] = {.lex_state = 169, .external_lex_state = 2},
  [549] = {.lex_state = 197, .external_lex_state = 2},
  [550] = {.lex_state = 166, .external_lex_state = 2},
  [551] = {.lex_state = 166, .external_lex_state = 2},
  [552] = {.lex_state = 136},
  [553] = {.lex_state = 122},
  [554] = {.lex_state = 122},
  [555] = {.lex_state = 133, .external_lex_state = 2},
  [556] = {.lex_state = 133, .external_lex_state = 2},
  [557] = {.lex_state = 172},
  [558] = {.lex_state = 172},
  [559] = {.lex_state = 114},
  [560] = {.lex_state = 0},
  [561] = {.lex_state = 0},
  [562] = {.lex_state = 136},
  [563] = {.lex_state = 114},
  [564] = {.lex_state = 136},
  [565] = {.lex_state = 136},
  [566] = {.lex_state = 114},
  [567] = {.lex_state = 0},
  [568] = {.lex_state = 172},
  [569] = {.lex_state = 114},
  [570] = {.lex_state = 114},
  [571] = {.lex_state = 114},
  [572] = {.lex_state = 114},
  [573] = {.lex_state = 0},
  [574] = {.lex_state = 114},
  [575] = {.lex_state = 114},
  [576] = {.lex_state = 114},
  [577] = {.lex_state = 122},
  [578] = {.lex_state = 114},
  [579] = {.lex_state = 114},
  [580] = {.lex_state = 114},
  [581] = {.lex_state = 114},
  [582] = {.lex_state = 114},
  [583] = {.lex_state = 114},
  [584] = {.lex_state = 136},
  [585] = {.lex_state = 172},
  [586] = {.lex_state = 114},
  [587] = {.lex_state = 0},
  [588] = {.lex_state = 0},
  [589] = {.lex_state = 172},
  [590] = {.lex_state = 114},
  [591] = {.lex_state = 172},
  [592] = {.lex_state = 0},
  [593] = {.lex_state = 114},
  [594] = {.lex_state = 0},
  [595] = {.lex_state = 0},
  [596] = {.lex_state = 0},
  [597] = {.lex_state = 172},
  [598] = {.lex_state = 160, .external_lex_state = 2},
  [599] = {.lex_state = 136},
  [600] = {.lex_state = 0},
  [601] = {.lex_state = 122},
  [602] = {.lex_state = 114},
  [603] = {.lex_state = 122},
  [604] = {.lex_state = 136},
  [605] = {.lex_state = 136},
  [606] = {.lex_state = 160, .external_lex_state = 2},
  [607] = {.lex_state = 114},
  [608] = {.lex_state = 136},
  [609] = {.lex_state = 114},
  [610] = {.lex_state = 0},
  [611] = {.lex_state = 172},
  [612] = {.lex_state = 172},
  [613] = {.lex_state = 0},
  [614] = {.lex_state = 0},
  [615] = {.lex_state = 136},
  [616] = {.lex_state = 172},
  [617] = {.lex_state = 172},
  [618] = {.lex_state = 172},
  [619] = {.lex_state = 114},
  [620] = {.lex_state = 172},
  [621] = {.lex_state = 172},
  [622] = {.lex_state = 172},
  [623] = {.lex_state = 172},
  [624] = {.lex_state = 172},
  [625] = {.lex_state = 136},
  [626] = {.lex_state = 0},
  [627] = {.lex_state = 136},
  [628] = {.lex_state = 187, .external_lex_state = 2},
  [629] = {.lex_state = 187, .external_lex_state = 2},
  [630] = {.lex_state = 114},
  [631] = {.lex_state = 0},
  [632] = {.lex_state = 0},
  [633] = {.lex_state = 169, .external_lex_state = 2},
  [634] = {.lex_state = 114},
  [635] = {.lex_state = 187, .external_lex_state = 2},
  [636] = {.lex_state = 114},
  [637] = {.lex_state = 0},
  [638] = {.lex_state = 0},
  [639] = {.lex_state = 187, .external_lex_state = 2},
  [640] = {.lex_state = 114},
  [641] = {.lex_state = 187, .external_lex_state = 2},
  [642] = {.lex_state = 0},
  [643] = {.lex_state = 114},
  [644] = {.lex_state = 0},
  [645] = {.lex_state = 0},
  [646] = {.lex_state = 0},
  [647] = {.lex_state = 190, .external_lex_state = 2},
  [648] = {.lex_state = 169, .external_lex_state = 2},
  [649] = {.lex_state = 130, .external_lex_state = 2},
  [650] = {.lex_state = 166, .external_lex_state = 2},
  [651] = {.lex_state = 122},
  [652] = {.lex_state = 169, .external_lex_state = 2},
  [653] = {.lex_state = 187, .external_lex_state = 2},
  [654] = {.lex_state = 187, .external_lex_state = 2},
  [655] = {.lex_state = 0},
  [656] = {.lex_state = 0},
  [657] = {.lex_state = 136},
  [658] = {.lex_state = 194, .external_lex_state = 2},
  [659] = {.lex_state = 194, .external_lex_state = 2},
  [660] = {.lex_state = 194, .external_lex_state = 2},
  [661] = {.lex_state = 114},
  [662] = {.lex_state = 194, .external_lex_state = 2},
  [663] = {.lex_state = 187, .external_lex_state = 2},
  [664] = {.lex_state = 194, .external_lex_state = 2},
  [665] = {.lex_state = 194, .external_lex_state = 2},
  [666] = {.lex_state = 194, .external_lex_state = 2},
  [667] = {.lex_state = 136},
  [668] = {.lex_state = 0},
  [669] = {.lex_state = 220, .external_lex_state = 2},
  [670] = {.lex_state = 130, .external_lex_state = 2},
  [671] = {.lex_state = 197, .external_lex_state = 2},
  [672] = {.lex_state = 114},
  [673] = {.lex_state = 0},
  [674] = {.lex_state = 223, .external_lex_state = 2},
  [675] = {.lex_state = 114},
  [676] = {.lex_state = 114},
  [677] = {.lex_state = 114},
  [678] = {.lex_state = 114},
  [679] = {.lex_state = 114},
  [680] = {.lex_state = 114},
  [681] = {.lex_state = 122},
  [682] = {.lex_state = 114},
  [683] = {.lex_state = 114},
  [684] = {.lex_state = 114},
  [685] = {.lex_state = 114},
  [686] = {.lex_state = 114},
  [687] = {.lex_state = 114},
  [688] = {.lex_state = 257, .external_lex_state = 2},
  [689] = {.lex_state = 169, .external_lex_state = 2},
  [690] = {.lex_state = 114},
  [691] = {.lex_state = 190, .external_lex_state = 2},
  [692] = {.lex_state = 197, .external_lex_state = 2},
  [693] = {.lex_state = 169, .external_lex_state = 2},
  [694] = {.lex_state = 122},
  [695] = {.lex_state = 169, .external_lex_state = 2},
  [696] = {.lex_state = 130, .external_lex_state = 2},
  [697] = {.lex_state = 169, .external_lex_state = 2},
  [698] = {.lex_state = 194, .external_lex_state = 2},
  [699] = {.lex_state = 194, .external_lex_state = 2},
  [700] = {.lex_state = 194, .external_lex_state = 2},
  [701] = {.lex_state = 114},
  [702] = {.lex_state = 194, .external_lex_state = 2},
  [703] = {.lex_state = 194, .external_lex_state = 2},
  [704] = {.lex_state = 194, .external_lex_state = 2},
  [705] = {.lex_state = 194, .external_lex_state = 2},
  [706] = {.lex_state = 220, .external_lex_state = 2},
  [707] = {.lex_state = 114},
  [708] = {.lex_state = 114},
  [709] = {.lex_state = 122},
  [710] = {.lex_state = 114},
  [711] = {.lex_state = 172},
  [712] = {.lex_state = 122},
  [713] = {.lex_state = 229, .external_lex_state = 4},
  [714] = {.lex_state = 133, .external_lex_state = 2},
  [715] = {.lex_state = 114},
  [716] = {.lex_state = 122},
  [717] = {.lex_state = 172},
  [718] = {.lex_state = 172},
  [719] = {.lex_state = 172},
  [720] = {.lex_state = 114},
  [721] = {.lex_state = 172},
  [722] = {.lex_state = 172},
  [723] = {.lex_state = 172},
  [724] = {.lex_state = 172},
  [725] = {.lex_state = 122},
  [726] = {.lex_state = 114},
  [727] = {.lex_state = 200, .external_lex_state = 3},
  [728] = {.lex_state = 0},
  [729] = {.lex_state = 232},
  [730] = {.lex_state = 172},
  [731] = {.lex_state = 0},
  [732] = {.lex_state = 122},
  [733] = {.lex_state = 172},
  [734] = {.lex_state = 172},
  [735] = {.lex_state = 172},
  [736] = {.lex_state = 172},
  [737] = {.lex_state = 172},
  [738] = {.lex_state = 172},
  [739] = {.lex_state = 172},
  [740] = {.lex_state = 114},
  [741] = {.lex_state = 122},
  [742] = {.lex_state = 229, .external_lex_state = 4},
  [743] = {.lex_state = 133, .external_lex_state = 2},
  [744] = {.lex_state = 114},
  [745] = {.lex_state = 114},
  [746] = {.lex_state = 133, .external_lex_state = 2},
  [747] = {.lex_state = 114},
  [748] = {.lex_state = 122},
  [749] = {.lex_state = 114},
  [750] = {.lex_state = 114},
  [751] = {.lex_state = 0},
  [752] = {.lex_state = 114},
  [753] = {.lex_state = 122},
  [754] = {.lex_state = 122},
  [755] = {.lex_state = 229, .external_lex_state = 4},
  [756] = {.lex_state = 122},
  [757] = {.lex_state = 114},
  [758] = {.lex_state = 200, .external_lex_state = 2},
  [759] = {.lex_state = 133, .external_lex_state = 2},
  [760] = {.lex_state = 114},
  [761] = {.lex_state = 0},
  [762] = {.lex_state = 114},
  [763] = {.lex_state = 114},
  [764] = {.lex_state = 122},
  [765] = {.lex_state = 114},
  [766] = {.lex_state = 172},
  [767] = {.lex_state = 0},
  [768] = {.lex_state = 229, .external_lex_state = 4},
  [769] = {.lex_state = 114},
  [770] = {.lex_state = 0},
  [771] = {.lex_state = 122},
  [772] = {.lex_state = 122},
  [773] = {.lex_state = 122},
  [774] = {.lex_state = 172},
  [775] = {.lex_state = 172},
  [776] = {.lex_state = 172},
  [777] = {.lex_state = 114},
  [778] = {.lex_state = 172},
  [779] = {.lex_state = 172},
  [780] = {.lex_state = 172},
  [781] = {.lex_state = 172},
  [782] = {.lex_state = 122},
  [783] = {.lex_state = 232},
  [784] = {.lex_state = 114},
  [785] = {.lex_state = 0},
  [786] = {.lex_state = 0},
  [787] = {.lex_state = 0},
  [788] = {.lex_state = 0},
  [789] = {.lex_state = 0},
  [790] = {.lex_state = 200, .external_lex_state = 3},
  [791] = {.lex_state = 114},
  [792] = {.lex_state = 166, .external_lex_state = 2},
  [793] = {.lex_state = 166, .external_lex_state = 2},
  [794] = {.lex_state = 169, .external_lex_state = 2},
  [795] = {.lex_state = 136},
  [796] = {.lex_state = 114},
  [797] = {.lex_state = 200, .external_lex_state = 3},
  [798] = {.lex_state = 203, .external_lex_state = 2},
  [799] = {.lex_state = 136},
  [800] = {.lex_state = 122},
  [801] = {.lex_state = 122},
  [802] = {.lex_state = 122},
  [803] = {.lex_state = 114},
  [804] = {.lex_state = 0},
  [805] = {.lex_state = 172},
  [806] = {.lex_state = 114},
  [807] = {.lex_state = 114},
  [808] = {.lex_state = 114},
  [809] = {.lex_state = 114},
  [810] = {.lex_state = 114},
  [811] = {.lex_state = 114},
  [812] = {.lex_state = 122},
  [813] = {.lex_state = 114},
  [814] = {.lex_state = 114},
  [815] = {.lex_state = 114},
  [816] = {.lex_state = 114},
  [817] = {.lex_state = 114},
  [818] = {.lex_state = 114},
  [819] = {.lex_state = 122},
  [820] = {.lex_state = 0},
  [821] = {.lex_state = 0},
  [822] = {.lex_state = 0},
  [823] = {.lex_state = 0},
  [824] = {.lex_state = 114},
  [825] = {.lex_state = 114},
  [826] = {.lex_state = 136},
  [827] = {.lex_state = 172},
  [828] = {.lex_state = 114},
  [829] = {.lex_state = 122},
  [830] = {.lex_state = 172},
  [831] = {.lex_state = 0},
  [832] = {.lex_state = 122},
  [833] = {.lex_state = 136},
  [834] = {.lex_state = 0},
  [835] = {.lex_state = 114},
  [836] = {.lex_state = 114},
  [837] = {.lex_state = 136},
  [838] = {.lex_state = 172},
  [839] = {.lex_state = 114},
  [840] = {.lex_state = 122},
  [841] = {.lex_state = 172},
  [842] = {.lex_state = 0},
  [843] = {.lex_state = 122},
  [844] = {.lex_state = 136},
  [845] = {.lex_state = 141, .external_lex_state = 2},
  [846] = {.lex_state = 122},
  [847] = {.lex_state = 0},
  [848] = {.lex_state = 136},
  [849] = {.lex_state = 114},
  [850] = {.lex_state = 0},
  [851] = {.lex_state = 172},
  [852] = {.lex_state = 114},
  [853] = {.lex_state = 114},
  [854] = {.lex_state = 114},
  [855] = {.lex_state = 114},
  [856] = {.lex_state = 114},
  [857] = {.lex_state = 114},
  [858] = {.lex_state = 122},
  [859] = {.lex_state = 114},
  [860] = {.lex_state = 114},
  [861] = {.lex_state = 114},
  [862] = {.lex_state = 114},
  [863] = {.lex_state = 114},
  [864] = {.lex_state = 114},
  [865] = {.lex_state = 136},
  [866] = {.lex_state = 136},
  [867] = {.lex_state = 114},
  [868] = {.lex_state = 172},
  [869] = {.lex_state = 160, .external_lex_state = 2},
  [870] = {.lex_state = 0},
  [871] = {.lex_state = 136},
  [872] = {.lex_state = 114},
  [873] = {.lex_state = 0},
  [874] = {.lex_state = 122},
  [875] = {.lex_state = 114},
  [876] = {.lex_state = 122},
  [877] = {.lex_state = 136},
  [878] = {.lex_state = 160, .external_lex_state = 2},
  [879] = {.lex_state = 114},
  [880] = {.lex_state = 136},
  [881] = {.lex_state = 172},
  [882] = {.lex_state = 172},
  [883] = {.lex_state = 172},
  [884] = {.lex_state = 114},
  [885] = {.lex_state = 172},
  [886] = {.lex_state = 172},
  [887] = {.lex_state = 172},
  [888] = {.lex_state = 172},
  [889] = {.lex_state = 136},
  [890] = {.lex_state = 136},
  [891] = {.lex_state = 136},
  [892] = {.lex_state = 114},
  [893] = {.lex_state = 0},
  [894] = {.lex_state = 172},
  [895] = {.lex_state = 114},
  [896] = {.lex_state = 114},
  [897] = {.lex_state = 114},
  [898] = {.lex_state = 114},
  [899] = {.lex_state = 114},
  [900] = {.lex_state = 114},
  [901] = {.lex_state = 122},
  [902] = {.lex_state = 114},
  [903] = {.lex_state = 114},
  [904] = {.lex_state = 114},
  [905] = {.lex_state = 114},
  [906] = {.lex_state = 114},
  [907] = {.lex_state = 114},
  [908] = {.lex_state = 136},
  [909] = {.lex_state = 136},
  [910] = {.lex_state = 114},
  [911] = {.lex_state = 172},
  [912] = {.lex_state = 114},
  [913] = {.lex_state = 160, .external_lex_state = 2},
  [914] = {.lex_state = 136},
  [915] = {.lex_state = 114},
  [916] = {.lex_state = 0},
  [917] = {.lex_state = 114},
  [918] = {.lex_state = 160, .external_lex_state = 2},
  [919] = {.lex_state = 0},
  [920] = {.lex_state = 122},
  [921] = {.lex_state = 114},
  [922] = {.lex_state = 0},
  [923] = {.lex_state = 122},
  [924] = {.lex_state = 114},
  [925] = {.lex_state = 114},
  [926] = {.lex_state = 136},
  [927] = {.lex_state = 172},
  [928] = {.lex_state = 114},
  [929] = {.lex_state = 136},
  [930] = {.lex_state = 172},
  [931] = {.lex_state = 114},
  [932] = {.lex_state = 122},
  [933] = {.lex_state = 136},
  [934] = {.lex_state = 160, .external_lex_state = 2},
  [935] = {.lex_state = 114},
  [936] = {.lex_state = 136},
  [937] = {.lex_state = 172},
  [938] = {.lex_state = 172},
  [939] = {.lex_state = 172},
  [940] = {.lex_state = 114},
  [941] = {.lex_state = 172},
  [942] = {.lex_state = 172},
  [943] = {.lex_state = 172},
  [944] = {.lex_state = 172},
  [945] = {.lex_state = 136},
  [946] = {.lex_state = 160, .external_lex_state = 2},
  [947] = {.lex_state = 242, .external_lex_state = 2},
  [948] = {.lex_state = 114},
  [949] = {.lex_state = 0},
  [950] = {.lex_state = 239, .external_lex_state = 2},
  [951] = {.lex_state = 114},
  [952] = {.lex_state = 114},
  [953] = {.lex_state = 114},
  [954] = {.lex_state = 114},
  [955] = {.lex_state = 114},
  [956] = {.lex_state = 114},
  [957] = {.lex_state = 122},
  [958] = {.lex_state = 114},
  [959] = {.lex_state = 114},
  [960] = {.lex_state = 114},
  [961] = {.lex_state = 114},
  [962] = {.lex_state = 114},
  [963] = {.lex_state = 114},
  [964] = {.lex_state = 260, .external_lex_state = 2},
  [965] = {.lex_state = 114},
  [966] = {.lex_state = 209, .external_lex_state = 2},
  [967] = {.lex_state = 212, .external_lex_state = 2},
  [968] = {.lex_state = 122},
  [969] = {.lex_state = 114},
  [970] = {.lex_state = 0},
  [971] = {.lex_state = 172},
  [972] = {.lex_state = 114},
  [973] = {.lex_state = 114},
  [974] = {.lex_state = 114},
  [975] = {.lex_state = 114},
  [976] = {.lex_state = 114},
  [977] = {.lex_state = 114},
  [978] = {.lex_state = 114},
  [979] = {.lex_state = 122},
  [980] = {.lex_state = 114},
  [981] = {.lex_state = 114},
  [982] = {.lex_state = 114},
  [983] = {.lex_state = 114},
  [984] = {.lex_state = 114},
  [985] = {.lex_state = 114},
  [986] = {.lex_state = 122},
  [987] = {.lex_state = 114},
  [988] = {.lex_state = 160, .external_lex_state = 2},
  [989] = {.lex_state = 114},
  [990] = {.lex_state = 136},
  [991] = {.lex_state = 114},
  [992] = {.lex_state = 114},
  [993] = {.lex_state = 114},
  [994] = {.lex_state = 0},
  [995] = {.lex_state = 160, .external_lex_state = 2},
  [996] = {.lex_state = 114},
  [997] = {.lex_state = 136},
  [998] = {.lex_state = 136},
  [999] = {.lex_state = 114},
  [1000] = {.lex_state = 0},
  [1001] = {.lex_state = 172},
  [1002] = {.lex_state = 114},
  [1003] = {.lex_state = 114},
  [1004] = {.lex_state = 114},
  [1005] = {.lex_state = 114},
  [1006] = {.lex_state = 114},
  [1007] = {.lex_state = 160, .external_lex_state = 2},
  [1008] = {.lex_state = 0},
  [1009] = {.lex_state = 114},
  [1010] = {.lex_state = 114},
  [1011] = {.lex_state = 114},
  [1012] = {.lex_state = 122},
  [1013] = {.lex_state = 114},
  [1014] = {.lex_state = 114},
  [1015] = {.lex_state = 114},
  [1016] = {.lex_state = 114},
  [1017] = {.lex_state = 114},
  [1018] = {.lex_state = 114},
  [1019] = {.lex_state = 136},
  [1020] = {.lex_state = 122},
  [1021] = {.lex_state = 136},
  [1022] = {.lex_state = 0},
  [1023] = {.lex_state = 0},
  [1024] = {.lex_state = 136},
  [1025] = {.lex_state = 172},
  [1026] = {.lex_state = 172},
  [1027] = {.lex_state = 114},
  [1028] = {.lex_state = 136},
  [1029] = {.lex_state = 136},
  [1030] = {.lex_state = 114},
  [1031] = {.lex_state = 172},
  [1032] = {.lex_state = 136},
  [1033] = {.lex_state = 122},
  [1034] = {.lex_state = 136},
  [1035] = {.lex_state = 114},
  [1036] = {.lex_state = 0},
  [1037] = {.lex_state = 172},
  [1038] = {.lex_state = 172},
  [1039] = {.lex_state = 172},
  [1040] = {.lex_state = 114},
  [1041] = {.lex_state = 172},
  [1042] = {.lex_state = 172},
  [1043] = {.lex_state = 172},
  [1044] = {.lex_state = 172},
  [1045] = {.lex_state = 136},
  [1046] = {.lex_state = 172},
  [1047] = {.lex_state = 114},
  [1048] = {.lex_state = 172},
  [1049] = {.lex_state = 172},
  [1050] = {.lex_state = 114},
  [1051] = {.lex_state = 172},
  [1052] = {.lex_state = 114},
  [1053] = {.lex_state = 172},
  [1054] = {.lex_state = 172},
  [1055] = {.lex_state = 114},
  [1056] = {.lex_state = 122},
  [1057] = {.lex_state = 114},
  [1058] = {.lex_state = 114},
  [1059] = {.lex_state = 114},
  [1060] = {.lex_state = 136},
  [1061] = {.lex_state = 172},
  [1062] = {.lex_state = 114},
  [1063] = {.lex_state = 136},
  [1064] = {.lex_state = 172},
  [1065] = {.lex_state = 136},
  [1066] = {.lex_state = 160, .external_lex_state = 2},
  [1067] = {.lex_state = 114},
  [1068] = {.lex_state = 172},
  [1069] = {.lex_state = 114},
  [1070] = {.lex_state = 0},
  [1071] = {.lex_state = 172},
  [1072] = {.lex_state = 114},
  [1073] = {.lex_state = 172},
  [1074] = {.lex_state = 0},
  [1075] = {.lex_state = 187, .external_lex_state = 2},
  [1076] = {.lex_state = 187, .external_lex_state = 2},
  [1077] = {.lex_state = 114},
  [1078] = {.lex_state = 169, .external_lex_state = 2},
  [1079] = {.lex_state = 187, .external_lex_state = 2},
  [1080] = {.lex_state = 114},
  [1081] = {.lex_state = 187, .external_lex_state = 2},
  [1082] = {.lex_state = 187, .external_lex_state = 2},
  [1083] = {.lex_state = 114},
  [1084] = {.lex_state = 187, .external_lex_state = 2},
  [1085] = {.lex_state = 114},
  [1086] = {.lex_state = 187, .external_lex_state = 2},
  [1087] = {.lex_state = 187, .external_lex_state = 2},
  [1088] = {.lex_state = 114},
  [1089] = {.lex_state = 187, .external_lex_state = 2},
  [1090] = {.lex_state = 114},
  [1091] = {.lex_state = 0},
  [1092] = {.lex_state = 194, .external_lex_state = 2},
  [1093] = {.lex_state = 114},
  [1094] = {.lex_state = 187, .external_lex_state = 2},
  [1095] = {.lex_state = 0},
  [1096] = {.lex_state = 197, .external_lex_state = 2},
  [1097] = {.lex_state = 114},
  [1098] = {.lex_state = 223, .external_lex_state = 2},
  [1099] = {.lex_state = 122},
  [1100] = {.lex_state = 197, .external_lex_state = 2},
  [1101] = {.lex_state = 226, .external_lex_state = 2},
  [1102] = {.lex_state = 226, .external_lex_state = 2},
  [1103] = {.lex_state = 226, .external_lex_state = 2},
  [1104] = {.lex_state = 114},
  [1105] = {.lex_state = 226, .external_lex_state = 2},
  [1106] = {.lex_state = 226, .external_lex_state = 2},
  [1107] = {.lex_state = 226, .external_lex_state = 2},
  [1108] = {.lex_state = 226, .external_lex_state = 2},
  [1109] = {.lex_state = 257, .external_lex_state = 2},
  [1110] = {.lex_state = 169, .external_lex_state = 2},
  [1111] = {.lex_state = 114},
  [1112] = {.lex_state = 114},
  [1113] = {.lex_state = 194, .external_lex_state = 2},
  [1114] = {.lex_state = 122},
  [1115] = {.lex_state = 114},
  [1116] = {.lex_state = 114},
  [1117] = {.lex_state = 229, .external_lex_state = 4},
  [1118] = {.lex_state = 114},
  [1119] = {.lex_state = 200, .external_lex_state = 2},
  [1120] = {.lex_state = 133, .external_lex_state = 2},
  [1121] = {.lex_state = 114},
  [1122] = {.lex_state = 0},
  [1123] = {.lex_state = 114},
  [1124] = {.lex_state = 114},
  [1125] = {.lex_state = 172},
  [1126] = {.lex_state = 0},
  [1127] = {.lex_state = 114},
  [1128] = {.lex_state = 200, .external_lex_state = 3},
  [1129] = {.lex_state = 200, .external_lex_state = 3},
  [1130] = {.lex_state = 114},
  [1131] = {.lex_state = 200, .external_lex_state = 3},
  [1132] = {.lex_state = 114},
  [1133] = {.lex_state = 0},
  [1134] = {.lex_state = 114},
  [1135] = {.lex_state = 114},
  [1136] = {.lex_state = 229, .external_lex_state = 4},
  [1137] = {.lex_state = 114},
  [1138] = {.lex_state = 200, .external_lex_state = 2},
  [1139] = {.lex_state = 133, .external_lex_state = 2},
  [1140] = {.lex_state = 114},
  [1141] = {.lex_state = 229, .external_lex_state = 4},
  [1142] = {.lex_state = 200, .external_lex_state = 2},
  [1143] = {.lex_state = 133, .external_lex_state = 2},
  [1144] = {.lex_state = 122},
  [1145] = {.lex_state = 114},
  [1146] = {.lex_state = 114},
  [1147] = {.lex_state = 122},
  [1148] = {.lex_state = 122},
  [1149] = {.lex_state = 122},
  [1150] = {.lex_state = 200, .external_lex_state = 3},
  [1151] = {.lex_state = 0},
  [1152] = {.lex_state = 0},
  [1153] = {.lex_state = 0},
  [1154] = {.lex_state = 114},
  [1155] = {.lex_state = 229, .external_lex_state = 4},
  [1156] = {.lex_state = 122},
  [1157] = {.lex_state = 229, .external_lex_state = 4},
  [1158] = {.lex_state = 114},
  [1159] = {.lex_state = 200, .external_lex_state = 2},
  [1160] = {.lex_state = 200, .external_lex_state = 3},
  [1161] = {.lex_state = 122},
  [1162] = {.lex_state = 200, .external_lex_state = 3},
  [1163] = {.lex_state = 0},
  [1164] = {.lex_state = 114},
  [1165] = {.lex_state = 114},
  [1166] = {.lex_state = 114},
  [1167] = {.lex_state = 122},
  [1168] = {.lex_state = 114},
  [1169] = {.lex_state = 229, .external_lex_state = 4},
  [1170] = {.lex_state = 114},
  [1171] = {.lex_state = 172},
  [1172] = {.lex_state = 114},
  [1173] = {.lex_state = 114},
  [1174] = {.lex_state = 114},
  [1175] = {.lex_state = 136},
  [1176] = {.lex_state = 172},
  [1177] = {.lex_state = 114},
  [1178] = {.lex_state = 136},
  [1179] = {.lex_state = 172},
  [1180] = {.lex_state = 136},
  [1181] = {.lex_state = 114},
  [1182] = {.lex_state = 114},
  [1183] = {.lex_state = 0},
  [1184] = {.lex_state = 136},
  [1185] = {.lex_state = 114},
  [1186] = {.lex_state = 114},
  [1187] = {.lex_state = 0},
  [1188] = {.lex_state = 232},
  [1189] = {.lex_state = 114},
  [1190] = {.lex_state = 114},
  [1191] = {.lex_state = 122},
  [1192] = {.lex_state = 0},
  [1193] = {.lex_state = 166, .external_lex_state = 2},
  [1194] = {.lex_state = 114},
  [1195] = {.lex_state = 122},
  [1196] = {.lex_state = 114},
  [1197] = {.lex_state = 172},
  [1198] = {.lex_state = 122},
  [1199] = {.lex_state = 122},
  [1200] = {.lex_state = 172},
  [1201] = {.lex_state = 172},
  [1202] = {.lex_state = 172},
  [1203] = {.lex_state = 114},
  [1204] = {.lex_state = 172},
  [1205] = {.lex_state = 172},
  [1206] = {.lex_state = 172},
  [1207] = {.lex_state = 172},
  [1208] = {.lex_state = 122},
  [1209] = {.lex_state = 122},
  [1210] = {.lex_state = 114},
  [1211] = {.lex_state = 0},
  [1212] = {.lex_state = 172},
  [1213] = {.lex_state = 114},
  [1214] = {.lex_state = 114},
  [1215] = {.lex_state = 114},
  [1216] = {.lex_state = 114},
  [1217] = {.lex_state = 114},
  [1218] = {.lex_state = 114},
  [1219] = {.lex_state = 122},
  [1220] = {.lex_state = 114},
  [1221] = {.lex_state = 114},
  [1222] = {.lex_state = 114},
  [1223] = {.lex_state = 114},
  [1224] = {.lex_state = 114},
  [1225] = {.lex_state = 114},
  [1226] = {.lex_state = 122},
  [1227] = {.lex_state = 114},
  [1228] = {.lex_state = 136},
  [1229] = {.lex_state = 122},
  [1230] = {.lex_state = 114},
  [1231] = {.lex_state = 0},
  [1232] = {.lex_state = 172},
  [1233] = {.lex_state = 114},
  [1234] = {.lex_state = 114},
  [1235] = {.lex_state = 114},
  [1236] = {.lex_state = 114},
  [1237] = {.lex_state = 114},
  [1238] = {.lex_state = 114},
  [1239] = {.lex_state = 122},
  [1240] = {.lex_state = 114},
  [1241] = {.lex_state = 114},
  [1242] = {.lex_state = 114},
  [1243] = {.lex_state = 114},
  [1244] = {.lex_state = 114},
  [1245] = {.lex_state = 114},
  [1246] = {.lex_state = 122},
  [1247] = {.lex_state = 114},
  [1248] = {.lex_state = 136},
  [1249] = {.lex_state = 114},
  [1250] = {.lex_state = 172},
  [1251] = {.lex_state = 122},
  [1252] = {.lex_state = 136},
  [1253] = {.lex_state = 172},
  [1254] = {.lex_state = 172},
  [1255] = {.lex_state = 172},
  [1256] = {.lex_state = 114},
  [1257] = {.lex_state = 172},
  [1258] = {.lex_state = 172},
  [1259] = {.lex_state = 172},
  [1260] = {.lex_state = 172},
  [1261] = {.lex_state = 136},
  [1262] = {.lex_state = 136},
  [1263] = {.lex_state = 160, .external_lex_state = 2},
  [1264] = {.lex_state = 114},
  [1265] = {.lex_state = 114},
  [1266] = {.lex_state = 122},
  [1267] = {.lex_state = 114},
  [1268] = {.lex_state = 114},
  [1269] = {.lex_state = 114},
  [1270] = {.lex_state = 136},
  [1271] = {.lex_state = 172},
  [1272] = {.lex_state = 114},
  [1273] = {.lex_state = 136},
  [1274] = {.lex_state = 172},
  [1275] = {.lex_state = 136},
  [1276] = {.lex_state = 172},
  [1277] = {.lex_state = 136},
  [1278] = {.lex_state = 114},
  [1279] = {.lex_state = 172},
  [1280] = {.lex_state = 122},
  [1281] = {.lex_state = 136},
  [1282] = {.lex_state = 172},
  [1283] = {.lex_state = 172},
  [1284] = {.lex_state = 172},
  [1285] = {.lex_state = 114},
  [1286] = {.lex_state = 172},
  [1287] = {.lex_state = 172},
  [1288] = {.lex_state = 172},
  [1289] = {.lex_state = 172},
  [1290] = {.lex_state = 136},
  [1291] = {.lex_state = 136},
  [1292] = {.lex_state = 160, .external_lex_state = 2},
  [1293] = {.lex_state = 114},
  [1294] = {.lex_state = 114},
  [1295] = {.lex_state = 160, .external_lex_state = 2},
  [1296] = {.lex_state = 114},
  [1297] = {.lex_state = 114},
  [1298] = {.lex_state = 136},
  [1299] = {.lex_state = 114},
  [1300] = {.lex_state = 0},
  [1301] = {.lex_state = 172},
  [1302] = {.lex_state = 114},
  [1303] = {.lex_state = 114},
  [1304] = {.lex_state = 114},
  [1305] = {.lex_state = 114},
  [1306] = {.lex_state = 114},
  [1307] = {.lex_state = 114},
  [1308] = {.lex_state = 122},
  [1309] = {.lex_state = 114},
  [1310] = {.lex_state = 114},
  [1311] = {.lex_state = 114},
  [1312] = {.lex_state = 114},
  [1313] = {.lex_state = 114},
  [1314] = {.lex_state = 114},
  [1315] = {.lex_state = 136},
  [1316] = {.lex_state = 122},
  [1317] = {.lex_state = 114},
  [1318] = {.lex_state = 114},
  [1319] = {.lex_state = 114},
  [1320] = {.lex_state = 136},
  [1321] = {.lex_state = 172},
  [1322] = {.lex_state = 114},
  [1323] = {.lex_state = 136},
  [1324] = {.lex_state = 172},
  [1325] = {.lex_state = 136},
  [1326] = {.lex_state = 172},
  [1327] = {.lex_state = 242, .external_lex_state = 2},
  [1328] = {.lex_state = 114},
  [1329] = {.lex_state = 239, .external_lex_state = 2},
  [1330] = {.lex_state = 122},
  [1331] = {.lex_state = 242, .external_lex_state = 2},
  [1332] = {.lex_state = 245, .external_lex_state = 2},
  [1333] = {.lex_state = 245, .external_lex_state = 2},
  [1334] = {.lex_state = 245, .external_lex_state = 2},
  [1335] = {.lex_state = 114},
  [1336] = {.lex_state = 245, .external_lex_state = 2},
  [1337] = {.lex_state = 245, .external_lex_state = 2},
  [1338] = {.lex_state = 245, .external_lex_state = 2},
  [1339] = {.lex_state = 245, .external_lex_state = 2},
  [1340] = {.lex_state = 260, .external_lex_state = 2},
  [1341] = {.lex_state = 133, .external_lex_state = 2},
  [1342] = {.lex_state = 209, .external_lex_state = 2},
  [1343] = {.lex_state = 122},
  [1344] = {.lex_state = 114},
  [1345] = {.lex_state = 172},
  [1346] = {.lex_state = 122},
  [1347] = {.lex_state = 141, .external_lex_state = 2},
  [1348] = {.lex_state = 122},
  [1349] = {.lex_state = 172},
  [1350] = {.lex_state = 172},
  [1351] = {.lex_state = 172},
  [1352] = {.lex_state = 114},
  [1353] = {.lex_state = 172},
  [1354] = {.lex_state = 172},
  [1355] = {.lex_state = 172},
  [1356] = {.lex_state = 172},
  [1357] = {.lex_state = 122},
  [1358] = {.lex_state = 136},
  [1359] = {.lex_state = 136},
  [1360] = {.lex_state = 136},
  [1361] = {.lex_state = 160, .external_lex_state = 2},
  [1362] = {.lex_state = 0},
  [1363] = {.lex_state = 136},
  [1364] = {.lex_state = 114},
  [1365] = {.lex_state = 0},
  [1366] = {.lex_state = 136},
  [1367] = {.lex_state = 114},
  [1368] = {.lex_state = 136},
  [1369] = {.lex_state = 114},
  [1370] = {.lex_state = 172},
  [1371] = {.lex_state = 160, .external_lex_state = 2},
  [1372] = {.lex_state = 136},
  [1373] = {.lex_state = 0},
  [1374] = {.lex_state = 122},
  [1375] = {.lex_state = 136},
  [1376] = {.lex_state = 136},
  [1377] = {.lex_state = 114},
  [1378] = {.lex_state = 0},
  [1379] = {.lex_state = 172},
  [1380] = {.lex_state = 172},
  [1381] = {.lex_state = 172},
  [1382] = {.lex_state = 114},
  [1383] = {.lex_state = 172},
  [1384] = {.lex_state = 172},
  [1385] = {.lex_state = 172},
  [1386] = {.lex_state = 172},
  [1387] = {.lex_state = 136},
  [1388] = {.lex_state = 136},
  [1389] = {.lex_state = 133, .external_lex_state = 2},
  [1390] = {.lex_state = 136},
  [1391] = {.lex_state = 0},
  [1392] = {.lex_state = 122},
  [1393] = {.lex_state = 172},
  [1394] = {.lex_state = 136},
  [1395] = {.lex_state = 114},
  [1396] = {.lex_state = 114},
  [1397] = {.lex_state = 172},
  [1398] = {.lex_state = 172},
  [1399] = {.lex_state = 172},
  [1400] = {.lex_state = 172},
  [1401] = {.lex_state = 136},
  [1402] = {.lex_state = 114},
  [1403] = {.lex_state = 136},
  [1404] = {.lex_state = 136},
  [1405] = {.lex_state = 136},
  [1406] = {.lex_state = 136},
  [1407] = {.lex_state = 136},
  [1408] = {.lex_state = 114},
  [1409] = {.lex_state = 0},
  [1410] = {.lex_state = 172},
  [1411] = {.lex_state = 114},
  [1412] = {.lex_state = 114},
  [1413] = {.lex_state = 114},
  [1414] = {.lex_state = 114},
  [1415] = {.lex_state = 114},
  [1416] = {.lex_state = 114},
  [1417] = {.lex_state = 122},
  [1418] = {.lex_state = 114},
  [1419] = {.lex_state = 114},
  [1420] = {.lex_state = 114},
  [1421] = {.lex_state = 114},
  [1422] = {.lex_state = 114},
  [1423] = {.lex_state = 114},
  [1424] = {.lex_state = 136},
  [1425] = {.lex_state = 172},
  [1426] = {.lex_state = 114},
  [1427] = {.lex_state = 172},
  [1428] = {.lex_state = 114},
  [1429] = {.lex_state = 187, .external_lex_state = 2},
  [1430] = {.lex_state = 187, .external_lex_state = 2},
  [1431] = {.lex_state = 187, .external_lex_state = 2},
  [1432] = {.lex_state = 187, .external_lex_state = 2},
  [1433] = {.lex_state = 169, .external_lex_state = 2},
  [1434] = {.lex_state = 187, .external_lex_state = 2},
  [1435] = {.lex_state = 114},
  [1436] = {.lex_state = 187, .external_lex_state = 2},
  [1437] = {.lex_state = 114},
  [1438] = {.lex_state = 197, .external_lex_state = 2},
  [1439] = {.lex_state = 114},
  [1440] = {.lex_state = 226, .external_lex_state = 2},
  [1441] = {.lex_state = 169, .external_lex_state = 2},
  [1442] = {.lex_state = 122},
  [1443] = {.lex_state = 114},
  [1444] = {.lex_state = 114},
  [1445] = {.lex_state = 200, .external_lex_state = 2},
  [1446] = {.lex_state = 122},
  [1447] = {.lex_state = 200, .external_lex_state = 3},
  [1448] = {.lex_state = 114},
  [1449] = {.lex_state = 114},
  [1450] = {.lex_state = 200, .external_lex_state = 3},
  [1451] = {.lex_state = 114},
  [1452] = {.lex_state = 114},
  [1453] = {.lex_state = 0},
  [1454] = {.lex_state = 114},
  [1455] = {.lex_state = 122},
  [1456] = {.lex_state = 114},
  [1457] = {.lex_state = 0},
  [1458] = {.lex_state = 114},
  [1459] = {.lex_state = 114},
  [1460] = {.lex_state = 200, .external_lex_state = 2},
  [1461] = {.lex_state = 229, .external_lex_state = 4},
  [1462] = {.lex_state = 200, .external_lex_state = 2},
  [1463] = {.lex_state = 200, .external_lex_state = 3},
  [1464] = {.lex_state = 122},
  [1465] = {.lex_state = 0},
  [1466] = {.lex_state = 0},
  [1467] = {.lex_state = 114},
  [1468] = {.lex_state = 200, .external_lex_state = 3},
  [1469] = {.lex_state = 122},
  [1470] = {.lex_state = 200, .external_lex_state = 3},
  [1471] = {.lex_state = 0},
  [1472] = {.lex_state = 232},
  [1473] = {.lex_state = 200, .external_lex_state = 3},
  [1474] = {.lex_state = 0},
  [1475] = {.lex_state = 114},
  [1476] = {.lex_state = 114},
  [1477] = {.lex_state = 114},
  [1478] = {.lex_state = 200, .external_lex_state = 3},
  [1479] = {.lex_state = 114},
  [1480] = {.lex_state = 200, .external_lex_state = 3},
  [1481] = {.lex_state = 114},
  [1482] = {.lex_state = 114},
  [1483] = {.lex_state = 122},
  [1484] = {.lex_state = 136},
  [1485] = {.lex_state = 136},
  [1486] = {.lex_state = 114},
  [1487] = {.lex_state = 0},
  [1488] = {.lex_state = 172},
  [1489] = {.lex_state = 114},
  [1490] = {.lex_state = 114},
  [1491] = {.lex_state = 114},
  [1492] = {.lex_state = 114},
  [1493] = {.lex_state = 114},
  [1494] = {.lex_state = 114},
  [1495] = {.lex_state = 122},
  [1496] = {.lex_state = 114},
  [1497] = {.lex_state = 114},
  [1498] = {.lex_state = 114},
  [1499] = {.lex_state = 114},
  [1500] = {.lex_state = 114},
  [1501] = {.lex_state = 114},
  [1502] = {.lex_state = 136},
  [1503] = {.lex_state = 0},
  [1504] = {.lex_state = 0},
  [1505] = {.lex_state = 0},
  [1506] = {.lex_state = 0},
  [1507] = {.lex_state = 136},
  [1508] = {.lex_state = 136},
  [1509] = {.lex_state = 0},
  [1510] = {.lex_state = 114},
  [1511] = {.lex_state = 114},
  [1512] = {.lex_state = 136},
  [1513] = {.lex_state = 172},
  [1514] = {.lex_state = 114},
  [1515] = {.lex_state = 136},
  [1516] = {.lex_state = 172},
  [1517] = {.lex_state = 0},
  [1518] = {.lex_state = 136},
  [1519] = {.lex_state = 136},
  [1520] = {.lex_state = 136},
  [1521] = {.lex_state = 200, .external_lex_state = 3},
  [1522] = {.lex_state = 122},
  [1523] = {.lex_state = 114},
  [1524] = {.lex_state = 172},
  [1525] = {.lex_state = 122},
  [1526] = {.lex_state = 114},
  [1527] = {.lex_state = 172},
  [1528] = {.lex_state = 122},
  [1529] = {.lex_state = 122},
  [1530] = {.lex_state = 172},
  [1531] = {.lex_state = 172},
  [1532] = {.lex_state = 172},
  [1533] = {.lex_state = 114},
  [1534] = {.lex_state = 172},
  [1535] = {.lex_state = 172},
  [1536] = {.lex_state = 172},
  [1537] = {.lex_state = 172},
  [1538] = {.lex_state = 122},
  [1539] = {.lex_state = 122},
  [1540] = {.lex_state = 122},
  [1541] = {.lex_state = 114},
  [1542] = {.lex_state = 172},
  [1543] = {.lex_state = 122},
  [1544] = {.lex_state = 122},
  [1545] = {.lex_state = 172},
  [1546] = {.lex_state = 172},
  [1547] = {.lex_state = 172},
  [1548] = {.lex_state = 114},
  [1549] = {.lex_state = 172},
  [1550] = {.lex_state = 172},
  [1551] = {.lex_state = 172},
  [1552] = {.lex_state = 172},
  [1553] = {.lex_state = 122},
  [1554] = {.lex_state = 122},
  [1555] = {.lex_state = 136},
  [1556] = {.lex_state = 114},
  [1557] = {.lex_state = 172},
  [1558] = {.lex_state = 136},
  [1559] = {.lex_state = 114},
  [1560] = {.lex_state = 136},
  [1561] = {.lex_state = 136},
  [1562] = {.lex_state = 136},
  [1563] = {.lex_state = 136},
  [1564] = {.lex_state = 114},
  [1565] = {.lex_state = 0},
  [1566] = {.lex_state = 172},
  [1567] = {.lex_state = 114},
  [1568] = {.lex_state = 114},
  [1569] = {.lex_state = 114},
  [1570] = {.lex_state = 114},
  [1571] = {.lex_state = 114},
  [1572] = {.lex_state = 114},
  [1573] = {.lex_state = 122},
  [1574] = {.lex_state = 114},
  [1575] = {.lex_state = 114},
  [1576] = {.lex_state = 114},
  [1577] = {.lex_state = 114},
  [1578] = {.lex_state = 114},
  [1579] = {.lex_state = 114},
  [1580] = {.lex_state = 136},
  [1581] = {.lex_state = 136},
  [1582] = {.lex_state = 114},
  [1583] = {.lex_state = 172},
  [1584] = {.lex_state = 136},
  [1585] = {.lex_state = 136},
  [1586] = {.lex_state = 136},
  [1587] = {.lex_state = 114},
  [1588] = {.lex_state = 172},
  [1589] = {.lex_state = 122},
  [1590] = {.lex_state = 136},
  [1591] = {.lex_state = 172},
  [1592] = {.lex_state = 172},
  [1593] = {.lex_state = 172},
  [1594] = {.lex_state = 114},
  [1595] = {.lex_state = 172},
  [1596] = {.lex_state = 172},
  [1597] = {.lex_state = 172},
  [1598] = {.lex_state = 172},
  [1599] = {.lex_state = 136},
  [1600] = {.lex_state = 114},
  [1601] = {.lex_state = 136},
  [1602] = {.lex_state = 136},
  [1603] = {.lex_state = 136},
  [1604] = {.lex_state = 136},
  [1605] = {.lex_state = 114},
  [1606] = {.lex_state = 0},
  [1607] = {.lex_state = 172},
  [1608] = {.lex_state = 114},
  [1609] = {.lex_state = 114},
  [1610] = {.lex_state = 114},
  [1611] = {.lex_state = 114},
  [1612] = {.lex_state = 114},
  [1613] = {.lex_state = 114},
  [1614] = {.lex_state = 122},
  [1615] = {.lex_state = 114},
  [1616] = {.lex_state = 114},
  [1617] = {.lex_state = 114},
  [1618] = {.lex_state = 114},
  [1619] = {.lex_state = 114},
  [1620] = {.lex_state = 114},
  [1621] = {.lex_state = 136},
  [1622] = {.lex_state = 242, .external_lex_state = 2},
  [1623] = {.lex_state = 114},
  [1624] = {.lex_state = 245, .external_lex_state = 2},
  [1625] = {.lex_state = 122},
  [1626] = {.lex_state = 114},
  [1627] = {.lex_state = 172},
  [1628] = {.lex_state = 160, .external_lex_state = 2},
  [1629] = {.lex_state = 114},
  [1630] = {.lex_state = 136},
  [1631] = {.lex_state = 136},
  [1632] = {.lex_state = 114},
  [1633] = {.lex_state = 114},
  [1634] = {.lex_state = 160, .external_lex_state = 2},
  [1635] = {.lex_state = 114},
  [1636] = {.lex_state = 172},
  [1637] = {.lex_state = 136},
  [1638] = {.lex_state = 0},
  [1639] = {.lex_state = 136},
  [1640] = {.lex_state = 136},
  [1641] = {.lex_state = 0},
  [1642] = {.lex_state = 0},
  [1643] = {.lex_state = 136},
  [1644] = {.lex_state = 136},
  [1645] = {.lex_state = 114},
  [1646] = {.lex_state = 0},
  [1647] = {.lex_state = 114},
  [1648] = {.lex_state = 136},
  [1649] = {.lex_state = 136},
  [1650] = {.lex_state = 114},
  [1651] = {.lex_state = 172},
  [1652] = {.lex_state = 122},
  [1653] = {.lex_state = 136},
  [1654] = {.lex_state = 172},
  [1655] = {.lex_state = 172},
  [1656] = {.lex_state = 172},
  [1657] = {.lex_state = 114},
  [1658] = {.lex_state = 172},
  [1659] = {.lex_state = 172},
  [1660] = {.lex_state = 172},
  [1661] = {.lex_state = 172},
  [1662] = {.lex_state = 136},
  [1663] = {.lex_state = 172},
  [1664] = {.lex_state = 172},
  [1665] = {.lex_state = 187, .external_lex_state = 2},
  [1666] = {.lex_state = 187, .external_lex_state = 2},
  [1667] = {.lex_state = 197, .external_lex_state = 2},
  [1668] = {.lex_state = 114},
  [1669] = {.lex_state = 200, .external_lex_state = 3},
  [1670] = {.lex_state = 114},
  [1671] = {.lex_state = 114},
  [1672] = {.lex_state = 200, .external_lex_state = 3},
  [1673] = {.lex_state = 114},
  [1674] = {.lex_state = 114},
  [1675] = {.lex_state = 114},
  [1676] = {.lex_state = 229, .external_lex_state = 4},
  [1677] = {.lex_state = 229, .external_lex_state = 4},
  [1678] = {.lex_state = 133, .external_lex_state = 2},
  [1679] = {.lex_state = 229, .external_lex_state = 4},
  [1680] = {.lex_state = 114},
  [1681] = {.lex_state = 200, .external_lex_state = 3},
  [1682] = {.lex_state = 0},
  [1683] = {.lex_state = 232},
  [1684] = {.lex_state = 0},
  [1685] = {.lex_state = 229, .external_lex_state = 4},
  [1686] = {.lex_state = 133, .external_lex_state = 2},
  [1687] = {.lex_state = 229, .external_lex_state = 4},
  [1688] = {.lex_state = 114},
  [1689] = {.lex_state = 0},
  [1690] = {.lex_state = 229, .external_lex_state = 4},
  [1691] = {.lex_state = 229, .external_lex_state = 4},
  [1692] = {.lex_state = 229, .external_lex_state = 4},
  [1693] = {.lex_state = 229, .external_lex_state = 4},
  [1694] = {.lex_state = 200, .external_lex_state = 3},
  [1695] = {.lex_state = 114},
  [1696] = {.lex_state = 229, .external_lex_state = 4},
  [1697] = {.lex_state = 200, .external_lex_state = 3},
  [1698] = {.lex_state = 122},
  [1699] = {.lex_state = 114},
  [1700] = {.lex_state = 229, .external_lex_state = 4},
  [1701] = {.lex_state = 133, .external_lex_state = 2},
  [1702] = {.lex_state = 114},
  [1703] = {.lex_state = 136},
  [1704] = {.lex_state = 114},
  [1705] = {.lex_state = 172},
  [1706] = {.lex_state = 122},
  [1707] = {.lex_state = 136},
  [1708] = {.lex_state = 172},
  [1709] = {.lex_state = 172},
  [1710] = {.lex_state = 172},
  [1711] = {.lex_state = 114},
  [1712] = {.lex_state = 172},
  [1713] = {.lex_state = 172},
  [1714] = {.lex_state = 172},
  [1715] = {.lex_state = 172},
  [1716] = {.lex_state = 136},
  [1717] = {.lex_state = 114},
  [1718] = {.lex_state = 136},
  [1719] = {.lex_state = 136},
  [1720] = {.lex_state = 114},
  [1721] = {.lex_state = 0},
  [1722] = {.lex_state = 172},
  [1723] = {.lex_state = 114},
  [1724] = {.lex_state = 114},
  [1725] = {.lex_state = 114},
  [1726] = {.lex_state = 114},
  [1727] = {.lex_state = 114},
  [1728] = {.lex_state = 114},
  [1729] = {.lex_state = 122},
  [1730] = {.lex_state = 114},
  [1731] = {.lex_state = 114},
  [1732] = {.lex_state = 114},
  [1733] = {.lex_state = 114},
  [1734] = {.lex_state = 114},
  [1735] = {.lex_state = 114},
  [1736] = {.lex_state = 136},
  [1737] = {.lex_state = 114},
  [1738] = {.lex_state = 114},
  [1739] = {.lex_state = 122},
  [1740] = {.lex_state = 122},
  [1741] = {.lex_state = 114},
  [1742] = {.lex_state = 172},
  [1743] = {.lex_state = 122},
  [1744] = {.lex_state = 114},
  [1745] = {.lex_state = 172},
  [1746] = {.lex_state = 136},
  [1747] = {.lex_state = 136},
  [1748] = {.lex_state = 114},
  [1749] = {.lex_state = 0},
  [1750] = {.lex_state = 114},
  [1751] = {.lex_state = 136},
  [1752] = {.lex_state = 136},
  [1753] = {.lex_state = 114},
  [1754] = {.lex_state = 172},
  [1755] = {.lex_state = 122},
  [1756] = {.lex_state = 136},
  [1757] = {.lex_state = 172},
  [1758] = {.lex_state = 172},
  [1759] = {.lex_state = 172},
  [1760] = {.lex_state = 114},
  [1761] = {.lex_state = 172},
  [1762] = {.lex_state = 172},
  [1763] = {.lex_state = 172},
  [1764] = {.lex_state = 172},
  [1765] = {.lex_state = 136},
  [1766] = {.lex_state = 136},
  [1767] = {.lex_state = 136},
  [1768] = {.lex_state = 114},
  [1769] = {.lex_state = 172},
  [1770] = {.lex_state = 136},
  [1771] = {.lex_state = 114},
  [1772] = {.lex_state = 0},
  [1773] = {.lex_state = 114},
  [1774] = {.lex_state = 136},
  [1775] = {.lex_state = 136},
  [1776] = {.lex_state = 114},
  [1777] = {.lex_state = 172},
  [1778] = {.lex_state = 122},
  [1779] = {.lex_state = 136},
  [1780] = {.lex_state = 172},
  [1781] = {.lex_state = 172},
  [1782] = {.lex_state = 172},
  [1783] = {.lex_state = 114},
  [1784] = {.lex_state = 172},
  [1785] = {.lex_state = 172},
  [1786] = {.lex_state = 172},
  [1787] = {.lex_state = 172},
  [1788] = {.lex_state = 136},
  [1789] = {.lex_state = 242, .external_lex_state = 2},
  [1790] = {.lex_state = 122},
  [1791] = {.lex_state = 136},
  [1792] = {.lex_state = 136},
  [1793] = {.lex_state = 122},
  [1794] = {.lex_state = 114},
  [1795] = {.lex_state = 136},
  [1796] = {.lex_state = 136},
  [1797] = {.lex_state = 114},
  [1798] = {.lex_state = 136},
  [1799] = {.lex_state = 136},
  [1800] = {.lex_state = 136},
  [1801] = {.lex_state = 114},
  [1802] = {.lex_state = 172},
  [1803] = {.lex_state = 114},
  [1804] = {.lex_state = 114},
  [1805] = {.lex_state = 114},
  [1806] = {.lex_state = 229, .external_lex_state = 4},
  [1807] = {.lex_state = 229, .external_lex_state = 4},
  [1808] = {.lex_state = 229, .external_lex_state = 4},
  [1809] = {.lex_state = 200, .external_lex_state = 2},
  [1810] = {.lex_state = 133, .external_lex_state = 2},
  [1811] = {.lex_state = 114},
  [1812] = {.lex_state = 0},
  [1813] = {.lex_state = 229, .external_lex_state = 4},
  [1814] = {.lex_state = 229, .external_lex_state = 4},
  [1815] = {.lex_state = 0},
  [1816] = {.lex_state = 229, .external_lex_state = 4},
  [1817] = {.lex_state = 200, .external_lex_state = 3},
  [1818] = {.lex_state = 200, .external_lex_state = 3},
  [1819] = {.lex_state = 114},
  [1820] = {.lex_state = 200, .external_lex_state = 3},
  [1821] = {.lex_state = 229, .external_lex_state = 4},
  [1822] = {.lex_state = 229, .external_lex_state = 4},
  [1823] = {.lex_state = 229, .external_lex_state = 4},
  [1824] = {.lex_state = 200, .external_lex_state = 2},
  [1825] = {.lex_state = 133, .external_lex_state = 2},
  [1826] = {.lex_state = 229, .external_lex_state = 4},
  [1827] = {.lex_state = 200, .external_lex_state = 3},
  [1828] = {.lex_state = 122},
  [1829] = {.lex_state = 200, .external_lex_state = 3},
  [1830] = {.lex_state = 0},
  [1831] = {.lex_state = 229, .external_lex_state = 4},
  [1832] = {.lex_state = 229, .external_lex_state = 4},
  [1833] = {.lex_state = 229, .external_lex_state = 4},
  [1834] = {.lex_state = 229, .external_lex_state = 4},
  [1835] = {.lex_state = 229, .external_lex_state = 4},
  [1836] = {.lex_state = 229, .external_lex_state = 4},
  [1837] = {.lex_state = 0},
  [1838] = {.lex_state = 229, .external_lex_state = 4},
  [1839] = {.lex_state = 200, .external_lex_state = 3},
  [1840] = {.lex_state = 114},
  [1841] = {.lex_state = 229, .external_lex_state = 4},
  [1842] = {.lex_state = 114},
  [1843] = {.lex_state = 200, .external_lex_state = 2},
  [1844] = {.lex_state = 133, .external_lex_state = 2},
  [1845] = {.lex_state = 136},
  [1846] = {.lex_state = 114},
  [1847] = {.lex_state = 172},
  [1848] = {.lex_state = 136},
  [1849] = {.lex_state = 136},
  [1850] = {.lex_state = 114},
  [1851] = {.lex_state = 172},
  [1852] = {.lex_state = 122},
  [1853] = {.lex_state = 136},
  [1854] = {.lex_state = 172},
  [1855] = {.lex_state = 172},
  [1856] = {.lex_state = 172},
  [1857] = {.lex_state = 114},
  [1858] = {.lex_state = 172},
  [1859] = {.lex_state = 172},
  [1860] = {.lex_state = 172},
  [1861] = {.lex_state = 172},
  [1862] = {.lex_state = 136},
  [1863] = {.lex_state = 136},
  [1864] = {.lex_state = 122},
  [1865] = {.lex_state = 122},
  [1866] = {.lex_state = 114},
  [1867] = {.lex_state = 136},
  [1868] = {.lex_state = 114},
  [1869] = {.lex_state = 136},
  [1870] = {.lex_state = 136},
  [1871] = {.lex_state = 114},
  [1872] = {.lex_state = 172},
  [1873] = {.lex_state = 136},
  [1874] = {.lex_state = 114},
  [1875] = {.lex_state = 136},
  [1876] = {.lex_state = 114},
  [1877] = {.lex_state = 136},
  [1878] = {.lex_state = 136},
  [1879] = {.lex_state = 114},
  [1880] = {.lex_state = 172},
  [1881] = {.lex_state = 114},
  [1882] = {.lex_state = 136},
  [1883] = {.lex_state = 114},
  [1884] = {.lex_state = 136},
  [1885] = {.lex_state = 229, .external_lex_state = 4},
  [1886] = {.lex_state = 229, .external_lex_state = 4},
  [1887] = {.lex_state = 200, .external_lex_state = 2},
  [1888] = {.lex_state = 122},
  [1889] = {.lex_state = 200, .external_lex_state = 3},
  [1890] = {.lex_state = 229, .external_lex_state = 4},
  [1891] = {.lex_state = 229, .external_lex_state = 4},
  [1892] = {.lex_state = 200, .external_lex_state = 3},
  [1893] = {.lex_state = 229, .external_lex_state = 4},
  [1894] = {.lex_state = 229, .external_lex_state = 4},
  [1895] = {.lex_state = 0},
  [1896] = {.lex_state = 229, .external_lex_state = 4},
  [1897] = {.lex_state = 229, .external_lex_state = 4},
  [1898] = {.lex_state = 229, .external_lex_state = 4},
  [1899] = {.lex_state = 200, .external_lex_state = 2},
  [1900] = {.lex_state = 229, .external_lex_state = 4},
  [1901] = {.lex_state = 133, .external_lex_state = 2},
  [1902] = {.lex_state = 229, .external_lex_state = 4},
  [1903] = {.lex_state = 114},
  [1904] = {.lex_state = 200, .external_lex_state = 3},
  [1905] = {.lex_state = 229, .external_lex_state = 4},
  [1906] = {.lex_state = 200, .external_lex_state = 3},
  [1907] = {.lex_state = 229, .external_lex_state = 4},
  [1908] = {.lex_state = 229, .external_lex_state = 4},
  [1909] = {.lex_state = 200, .external_lex_state = 3},
  [1910] = {.lex_state = 114},
  [1911] = {.lex_state = 114},
  [1912] = {.lex_state = 114},
  [1913] = {.lex_state = 200, .external_lex_state = 2},
  [1914] = {.lex_state = 136},
  [1915] = {.lex_state = 136},
  [1916] = {.lex_state = 114},
  [1917] = {.lex_state = 172},
  [1918] = {.lex_state = 114},
  [1919] = {.lex_state = 114},
  [1920] = {.lex_state = 136},
  [1921] = {.lex_state = 114},
  [1922] = {.lex_state = 114},
  [1923] = {.lex_state = 136},
  [1924] = {.lex_state = 229, .external_lex_state = 4},
  [1925] = {.lex_state = 200, .external_lex_state = 3},
  [1926] = {.lex_state = 229, .external_lex_state = 4},
  [1927] = {.lex_state = 229, .external_lex_state = 4},
  [1928] = {.lex_state = 200, .external_lex_state = 3},
  [1929] = {.lex_state = 229, .external_lex_state = 4},
  [1930] = {.lex_state = 229, .external_lex_state = 4},
  [1931] = {.lex_state = 229, .external_lex_state = 4},
  [1932] = {.lex_state = 229, .external_lex_state = 4},
  [1933] = {.lex_state = 229, .external_lex_state = 4},
  [1934] = {.lex_state = 200, .external_lex_state = 2},
  [1935] = {.lex_state = 133, .external_lex_state = 2},
  [1936] = {.lex_state = 122},
  [1937] = {.lex_state = 229, .external_lex_state = 4},
  [1938] = {.lex_state = 229, .external_lex_state = 4},
  [1939] = {.lex_state = 133, .external_lex_state = 2},
  [1940] = {.lex_state = 229, .external_lex_state = 4},
  [1941] = {.lex_state = 229, .external_lex_state = 4},
  [1942] = {.lex_state = 114},
  [1943] = {.lex_state = 136},
  [1944] = {.lex_state = 229, .external_lex_state = 4},
  [1945] = {.lex_state = 229, .external_lex_state = 4},
  [1946] = {.lex_state = 229, .external_lex_state = 4},
  [1947] = {.lex_state = 229, .external_lex_state = 4},
  [1948] = {.lex_state = 229, .external_lex_state = 4},
  [1949] = {.lex_state = 200, .external_lex_state = 2},
  [1950] = {.lex_state = 200, .external_lex_state = 3},
  [1951] = {.lex_state = 229, .external_lex_state = 4},
  [1952] = {.lex_state = 229, .external_lex_state = 4},
  [1953] = {.lex_state = 229, .external_lex_state = 4},
  [1954] = {.lex_state = 200, .external_lex_state = 2},
  [1955] = {.lex_state = 133, .external_lex_state = 2},
  [1956] = {.lex_state = 229, .external_lex_state = 4},
  [1957] = {.lex_state = 229, .external_lex_state = 4},
  [1958] = {.lex_state = 229, .external_lex_state = 4},
  [1959] = {.lex_state = 229, .external_lex_state = 4},
  [1960] = {.lex_state = 200, .external_lex_state = 2},
  [1961] = {.lex_state = 229, .external_lex_state = 4},
};

enum {
  ts_external_token__newline,
  ts_external_token__indent,
  ts_external_token__dedent,
};

static TSSymbol ts_external_scanner_symbol_map[EXTERNAL_TOKEN_COUNT] = {
  [ts_external_token__newline] = sym__newline,
  [ts_external_token__indent] = sym__indent,
  [ts_external_token__dedent] = sym__dedent,
};

static bool ts_external_scanner_states[5][EXTERNAL_TOKEN_COUNT] = {
  [1] = {
    [ts_external_token__newline] = true,
    [ts_external_token__indent] = true,
    [ts_external_token__dedent] = true,
  },
  [2] = {
    [ts_external_token__newline] = true,
  },
  [3] = {
    [ts_external_token__indent] = true,
  },
  [4] = {
    [ts_external_token__dedent] = true,
  },
};

static uint16_t ts_parse_table[STATE_COUNT][SYMBOL_COUNT] = {
  [0] = {
    [sym__newline] = ACTIONS(1),
    [sym__indent] = ACTIONS(1),
    [sym__dedent] = ACTIONS(1),
    [ts_builtin_sym_end] = ACTIONS(1),
    [anon_sym_import] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(3),
    [anon_sym_from] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(1),
    [anon_sym_RPAREN] = ACTIONS(1),
    [anon_sym_COMMA] = ACTIONS(1),
    [anon_sym_as] = ACTIONS(3),
    [anon_sym_STAR] = ACTIONS(3),
    [anon_sym_print] = ACTIONS(3),
    [anon_sym_GT_GT] = ACTIONS(3),
    [anon_sym_assert] = ACTIONS(3),
    [anon_sym_return] = ACTIONS(3),
    [anon_sym_del] = ACTIONS(3),
    [anon_sym_raise] = ACTIONS(3),
    [sym_pass_statement] = ACTIONS(3),
    [sym_break_statement] = ACTIONS(3),
    [sym_continue_statement] = ACTIONS(3),
    [anon_sym_if] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1),
    [anon_sym_elif] = ACTIONS(3),
    [anon_sym_else] = ACTIONS(3),
    [anon_sym_async] = ACTIONS(3),
    [anon_sym_for] = ACTIONS(3),
    [anon_sym_in] = ACTIONS(3),
    [anon_sym_while] = ACTIONS(3),
    [anon_sym_try] = ACTIONS(3),
    [anon_sym_except] = ACTIONS(3),
    [anon_sym_finally] = ACTIONS(3),
    [anon_sym_with] = ACTIONS(3),
    [anon_sym_def] = ACTIONS(3),
    [anon_sym_DASH_GT] = ACTIONS(1),
    [anon_sym_EQ] = ACTIONS(3),
    [anon_sym_global] = ACTIONS(3),
    [anon_sym_nonlocal] = ACTIONS(3),
    [anon_sym_exec] = ACTIONS(3),
    [anon_sym_class] = ACTIONS(3),
    [anon_sym_AT] = ACTIONS(3),
    [anon_sym_not] = ACTIONS(3),
    [anon_sym_and] = ACTIONS(3),
    [anon_sym_or] = ACTIONS(3),
    [anon_sym_PLUS] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(3),
    [anon_sym_SLASH] = ACTIONS(3),
    [anon_sym_PERCENT] = ACTIONS(3),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_STAR_STAR] = ACTIONS(3),
    [anon_sym_PIPE] = ACTIONS(3),
    [anon_sym_AMP] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(3),
    [anon_sym_LT_LT] = ACTIONS(3),
    [anon_sym_TILDE] = ACTIONS(1),
    [anon_sym_LT] = ACTIONS(3),
    [anon_sym_LT_EQ] = ACTIONS(1),
    [anon_sym_EQ_EQ] = ACTIONS(1),
    [anon_sym_BANG_EQ] = ACTIONS(1),
    [anon_sym_GT_EQ] = ACTIONS(1),
    [anon_sym_GT] = ACTIONS(3),
    [anon_sym_LT_GT] = ACTIONS(1),
    [anon_sym_is] = ACTIONS(3),
    [anon_sym_lambda] = ACTIONS(3),
    [anon_sym_PLUS_EQ] = ACTIONS(1),
    [anon_sym_DASH_EQ] = ACTIONS(1),
    [anon_sym_STAR_EQ] = ACTIONS(1),
    [anon_sym_SLASH_EQ] = ACTIONS(1),
    [anon_sym_AT_EQ] = ACTIONS(1),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(1),
    [anon_sym_PERCENT_EQ] = ACTIONS(1),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1),
    [anon_sym_GT_GT_EQ] = ACTIONS(1),
    [anon_sym_LT_LT_EQ] = ACTIONS(1),
    [anon_sym_AMP_EQ] = ACTIONS(1),
    [anon_sym_CARET_EQ] = ACTIONS(1),
    [anon_sym_PIPE_EQ] = ACTIONS(1),
    [anon_sym_yield] = ACTIONS(3),
    [anon_sym_LBRACK] = ACTIONS(1),
    [anon_sym_RBRACK] = ACTIONS(1),
    [sym_ellipsis] = ACTIONS(1),
    [anon_sym_LBRACE] = ACTIONS(1),
    [anon_sym_RBRACE] = ACTIONS(1),
    [sym_string] = ACTIONS(1),
    [sym_integer] = ACTIONS(3),
    [sym_float] = ACTIONS(3),
    [sym_identifier] = ACTIONS(3),
    [sym_true] = ACTIONS(3),
    [sym_false] = ACTIONS(3),
    [sym_none] = ACTIONS(3),
    [anon_sym_await] = ACTIONS(3),
    [sym_comment] = ACTIONS(5),
    [sym__semicolon] = ACTIONS(1),
  },
  [1] = {
    [sym_module] = STATE(31),
    [sym__statement] = STATE(36),
    [sym__simple_statements] = STATE(36),
    [sym_import_statement] = STATE(10),
    [sym_import_from_statement] = STATE(10),
    [sym_print_statement] = STATE(10),
    [sym_assert_statement] = STATE(10),
    [sym_expression_statement] = STATE(10),
    [sym_return_statement] = STATE(10),
    [sym_delete_statement] = STATE(10),
    [sym_raise_statement] = STATE(10),
    [sym_if_statement] = STATE(36),
    [sym_for_statement] = STATE(36),
    [sym_while_statement] = STATE(36),
    [sym_try_statement] = STATE(36),
    [sym_with_statement] = STATE(36),
    [sym_function_definition] = STATE(36),
    [sym_global_statement] = STATE(10),
    [sym_nonlocal_statement] = STATE(10),
    [sym_exec_statement] = STATE(10),
    [sym_class_definition] = STATE(36),
    [sym_decorated_definition] = STATE(36),
    [sym_decorator] = STATE(37),
    [sym_expression_list] = STATE(32),
    [sym__expression] = STATE(33),
    [sym__primary_expression] = STATE(34),
    [sym_not_operator] = STATE(33),
    [sym_boolean_operator] = STATE(33),
    [sym_binary_operator] = STATE(34),
    [sym_unary_operator] = STATE(34),
    [sym_comparison_operator] = STATE(33),
    [sym_lambda] = STATE(33),
    [sym_assignment] = STATE(35),
    [sym_augmented_assignment] = STATE(35),
    [sym_yield] = STATE(35),
    [sym_attribute] = STATE(34),
    [sym_subscript] = STATE(34),
    [sym_call] = STATE(34),
    [sym_list] = STATE(34),
    [sym_list_comprehension] = STATE(34),
    [sym_dictionary] = STATE(34),
    [sym_dictionary_comprehension] = STATE(34),
    [sym_set] = STATE(34),
    [sym_set_comprehension] = STATE(34),
    [sym_parenthesized_expression] = STATE(34),
    [sym_tuple] = STATE(34),
    [sym_generator_expression] = STATE(34),
    [sym_conditional_expression] = STATE(33),
    [sym_concatenated_string] = STATE(34),
    [sym_await] = STATE(33),
    [aux_sym_module_repeat1] = STATE(36),
    [aux_sym_decorated_definition_repeat1] = STATE(37),
    [ts_builtin_sym_end] = ACTIONS(8),
    [anon_sym_import] = ACTIONS(10),
    [anon_sym_from] = ACTIONS(12),
    [anon_sym_LPAREN] = ACTIONS(14),
    [anon_sym_print] = ACTIONS(16),
    [anon_sym_assert] = ACTIONS(18),
    [anon_sym_return] = ACTIONS(20),
    [anon_sym_del] = ACTIONS(22),
    [anon_sym_raise] = ACTIONS(24),
    [sym_pass_statement] = ACTIONS(26),
    [sym_break_statement] = ACTIONS(26),
    [sym_continue_statement] = ACTIONS(26),
    [anon_sym_if] = ACTIONS(28),
    [anon_sym_async] = ACTIONS(30),
    [anon_sym_for] = ACTIONS(32),
    [anon_sym_while] = ACTIONS(34),
    [anon_sym_try] = ACTIONS(36),
    [anon_sym_with] = ACTIONS(38),
    [anon_sym_def] = ACTIONS(40),
    [anon_sym_global] = ACTIONS(42),
    [anon_sym_nonlocal] = ACTIONS(44),
    [anon_sym_exec] = ACTIONS(46),
    [anon_sym_class] = ACTIONS(48),
    [anon_sym_AT] = ACTIONS(50),
    [anon_sym_not] = ACTIONS(52),
    [anon_sym_PLUS] = ACTIONS(54),
    [anon_sym_DASH] = ACTIONS(54),
    [anon_sym_TILDE] = ACTIONS(54),
    [anon_sym_lambda] = ACTIONS(56),
    [anon_sym_yield] = ACTIONS(58),
    [anon_sym_LBRACK] = ACTIONS(60),
    [sym_ellipsis] = ACTIONS(62),
    [anon_sym_LBRACE] = ACTIONS(64),
    [sym_string] = ACTIONS(66),
    [sym_integer] = ACTIONS(68),
    [sym_float] = ACTIONS(68),
    [sym_identifier] = ACTIONS(68),
    [sym_true] = ACTIONS(68),
    [sym_false] = ACTIONS(68),
    [sym_none] = ACTIONS(68),
    [anon_sym_await] = ACTIONS(70),
    [sym_comment] = ACTIONS(72),
  },
  [2] = {
    [sym__import_list] = STATE(39),
    [sym_aliased_import] = STATE(40),
    [sym_dotted_name] = STATE(41),
    [sym_identifier] = ACTIONS(74),
    [sym_comment] = ACTIONS(72),
  },
  [3] = {
    [sym_import_prefix] = STATE(43),
    [sym_relative_import] = STATE(44),
    [sym_dotted_name] = STATE(44),
    [aux_sym_import_prefix_repeat1] = STATE(45),
    [anon_sym_DOT] = ACTIONS(76),
    [sym_identifier] = ACTIONS(78),
    [sym_comment] = ACTIONS(72),
  },
  [4] = {
    [sym__expression] = STATE(58),
    [sym__primary_expression] = STATE(59),
    [sym_not_operator] = STATE(58),
    [sym_boolean_operator] = STATE(58),
    [sym_binary_operator] = STATE(59),
    [sym_unary_operator] = STATE(59),
    [sym_comparison_operator] = STATE(58),
    [sym_lambda] = STATE(58),
    [sym_yield] = STATE(60),
    [sym_attribute] = STATE(59),
    [sym_subscript] = STATE(59),
    [sym_call] = STATE(59),
    [sym_list] = STATE(59),
    [sym_list_comprehension] = STATE(59),
    [sym_dictionary] = STATE(59),
    [sym_dictionary_comprehension] = STATE(59),
    [sym_set] = STATE(59),
    [sym_set_comprehension] = STATE(59),
    [sym_parenthesized_expression] = STATE(59),
    [sym_tuple] = STATE(59),
    [sym_generator_expression] = STATE(59),
    [sym_conditional_expression] = STATE(58),
    [sym_concatenated_string] = STATE(59),
    [sym_await] = STATE(58),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_RPAREN] = ACTIONS(82),
    [anon_sym_COMMA] = ACTIONS(84),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_not] = ACTIONS(88),
    [anon_sym_PLUS] = ACTIONS(90),
    [anon_sym_DASH] = ACTIONS(90),
    [anon_sym_TILDE] = ACTIONS(90),
    [anon_sym_lambda] = ACTIONS(92),
    [anon_sym_yield] = ACTIONS(94),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(98),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(102),
    [sym_integer] = ACTIONS(104),
    [sym_float] = ACTIONS(104),
    [sym_identifier] = ACTIONS(104),
    [sym_true] = ACTIONS(104),
    [sym_false] = ACTIONS(104),
    [sym_none] = ACTIONS(104),
    [anon_sym_await] = ACTIONS(106),
    [sym_comment] = ACTIONS(72),
  },
  [5] = {
    [sym_chevron] = STATE(71),
    [sym__expression] = STATE(72),
    [sym__primary_expression] = STATE(73),
    [sym_not_operator] = STATE(72),
    [sym_boolean_operator] = STATE(72),
    [sym_binary_operator] = STATE(73),
    [sym_unary_operator] = STATE(73),
    [sym_comparison_operator] = STATE(72),
    [sym_lambda] = STATE(72),
    [sym_attribute] = STATE(73),
    [sym_subscript] = STATE(73),
    [sym_call] = STATE(73),
    [sym_list] = STATE(73),
    [sym_list_comprehension] = STATE(73),
    [sym_dictionary] = STATE(73),
    [sym_dictionary_comprehension] = STATE(73),
    [sym_set] = STATE(73),
    [sym_set_comprehension] = STATE(73),
    [sym_parenthesized_expression] = STATE(73),
    [sym_tuple] = STATE(73),
    [sym_generator_expression] = STATE(73),
    [sym_conditional_expression] = STATE(72),
    [sym_concatenated_string] = STATE(73),
    [sym_await] = STATE(72),
    [sym__newline] = ACTIONS(108),
    [anon_sym_DOT] = ACTIONS(110),
    [anon_sym_LPAREN] = ACTIONS(108),
    [anon_sym_COMMA] = ACTIONS(108),
    [anon_sym_STAR] = ACTIONS(110),
    [anon_sym_print] = ACTIONS(112),
    [anon_sym_GT_GT] = ACTIONS(114),
    [anon_sym_if] = ACTIONS(110),
    [anon_sym_COLON] = ACTIONS(108),
    [anon_sym_in] = ACTIONS(110),
    [anon_sym_EQ] = ACTIONS(110),
    [anon_sym_exec] = ACTIONS(112),
    [anon_sym_AT] = ACTIONS(110),
    [anon_sym_not] = ACTIONS(110),
    [anon_sym_and] = ACTIONS(110),
    [anon_sym_or] = ACTIONS(110),
    [anon_sym_PLUS] = ACTIONS(110),
    [anon_sym_DASH] = ACTIONS(110),
    [anon_sym_SLASH] = ACTIONS(110),
    [anon_sym_PERCENT] = ACTIONS(110),
    [anon_sym_SLASH_SLASH] = ACTIONS(110),
    [anon_sym_STAR_STAR] = ACTIONS(110),
    [anon_sym_PIPE] = ACTIONS(110),
    [anon_sym_AMP] = ACTIONS(110),
    [anon_sym_CARET] = ACTIONS(110),
    [anon_sym_LT_LT] = ACTIONS(110),
    [anon_sym_TILDE] = ACTIONS(116),
    [anon_sym_LT] = ACTIONS(110),
    [anon_sym_LT_EQ] = ACTIONS(108),
    [anon_sym_EQ_EQ] = ACTIONS(108),
    [anon_sym_BANG_EQ] = ACTIONS(108),
    [anon_sym_GT_EQ] = ACTIONS(108),
    [anon_sym_GT] = ACTIONS(110),
    [anon_sym_LT_GT] = ACTIONS(108),
    [anon_sym_is] = ACTIONS(110),
    [anon_sym_lambda] = ACTIONS(118),
    [anon_sym_PLUS_EQ] = ACTIONS(108),
    [anon_sym_DASH_EQ] = ACTIONS(108),
    [anon_sym_STAR_EQ] = ACTIONS(108),
    [anon_sym_SLASH_EQ] = ACTIONS(108),
    [anon_sym_AT_EQ] = ACTIONS(108),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(108),
    [anon_sym_PERCENT_EQ] = ACTIONS(108),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(108),
    [anon_sym_GT_GT_EQ] = ACTIONS(108),
    [anon_sym_LT_LT_EQ] = ACTIONS(108),
    [anon_sym_AMP_EQ] = ACTIONS(108),
    [anon_sym_CARET_EQ] = ACTIONS(108),
    [anon_sym_PIPE_EQ] = ACTIONS(108),
    [anon_sym_LBRACK] = ACTIONS(108),
    [sym_ellipsis] = ACTIONS(120),
    [anon_sym_LBRACE] = ACTIONS(122),
    [sym_string] = ACTIONS(124),
    [sym_integer] = ACTIONS(126),
    [sym_float] = ACTIONS(126),
    [sym_identifier] = ACTIONS(126),
    [sym_true] = ACTIONS(126),
    [sym_false] = ACTIONS(126),
    [sym_none] = ACTIONS(126),
    [anon_sym_await] = ACTIONS(128),
    [sym_comment] = ACTIONS(72),
    [sym__semicolon] = ACTIONS(108),
  },
  [6] = {
    [sym__expression] = STATE(74),
    [sym__primary_expression] = STATE(73),
    [sym_not_operator] = STATE(74),
    [sym_boolean_operator] = STATE(74),
    [sym_binary_operator] = STATE(73),
    [sym_unary_operator] = STATE(73),
    [sym_comparison_operator] = STATE(74),
    [sym_lambda] = STATE(74),
    [sym_attribute] = STATE(73),
    [sym_subscript] = STATE(73),
    [sym_call] = STATE(73),
    [sym_list] = STATE(73),
    [sym_list_comprehension] = STATE(73),
    [sym_dictionary] = STATE(73),
    [sym_dictionary_comprehension] = STATE(73),
    [sym_set] = STATE(73),
    [sym_set_comprehension] = STATE(73),
    [sym_parenthesized_expression] = STATE(73),
    [sym_tuple] = STATE(73),
    [sym_generator_expression] = STATE(73),
    [sym_conditional_expression] = STATE(74),
    [sym_concatenated_string] = STATE(73),
    [sym_await] = STATE(74),
    [anon_sym_LPAREN] = ACTIONS(130),
    [anon_sym_print] = ACTIONS(112),
    [anon_sym_exec] = ACTIONS(112),
    [anon_sym_not] = ACTIONS(132),
    [anon_sym_PLUS] = ACTIONS(116),
    [anon_sym_DASH] = ACTIONS(116),
    [anon_sym_TILDE] = ACTIONS(116),
    [anon_sym_lambda] = ACTIONS(118),
    [anon_sym_LBRACK] = ACTIONS(134),
    [sym_ellipsis] = ACTIONS(120),
    [anon_sym_LBRACE] = ACTIONS(122),
    [sym_string] = ACTIONS(124),
    [sym_integer] = ACTIONS(126),
    [sym_float] = ACTIONS(126),
    [sym_identifier] = ACTIONS(126),
    [sym_true] = ACTIONS(126),
    [sym_false] = ACTIONS(126),
    [sym_none] = ACTIONS(126),
    [anon_sym_await] = ACTIONS(128),
    [sym_comment] = ACTIONS(72),
  },
  [7] = {
    [sym_expression_list] = STATE(75),
    [sym__expression] = STATE(76),
    [sym__primary_expression] = STATE(73),
    [sym_not_operator] = STATE(76),
    [sym_boolean_operator] = STATE(76),
    [sym_binary_operator] = STATE(73),
    [sym_unary_operator] = STATE(73),
    [sym_comparison_operator] = STATE(76),
    [sym_lambda] = STATE(76),
    [sym_attribute] = STATE(73),
    [sym_subscript] = STATE(73),
    [sym_call] = STATE(73),
    [sym_list] = STATE(73),
    [sym_list_comprehension] = STATE(73),
    [sym_dictionary] = STATE(73),
    [sym_dictionary_comprehension] = STATE(73),
    [sym_set] = STATE(73),
    [sym_set_comprehension] = STATE(73),
    [sym_parenthesized_expression] = STATE(73),
    [sym_tuple] = STATE(73),
    [sym_generator_expression] = STATE(73),
    [sym_conditional_expression] = STATE(76),
    [sym_concatenated_string] = STATE(73),
    [sym_await] = STATE(76),
    [sym__newline] = ACTIONS(136),
    [anon_sym_LPAREN] = ACTIONS(130),
    [anon_sym_print] = ACTIONS(112),
    [anon_sym_exec] = ACTIONS(112),
    [anon_sym_not] = ACTIONS(132),
    [anon_sym_PLUS] = ACTIONS(116),
    [anon_sym_DASH] = ACTIONS(116),
    [anon_sym_TILDE] = ACTIONS(116),
    [anon_sym_lambda] = ACTIONS(118),
    [anon_sym_LBRACK] = ACTIONS(134),
    [sym_ellipsis] = ACTIONS(120),
    [anon_sym_LBRACE] = ACTIONS(122),
    [sym_string] = ACTIONS(124),
    [sym_integer] = ACTIONS(126),
    [sym_float] = ACTIONS(126),
    [sym_identifier] = ACTIONS(126),
    [sym_true] = ACTIONS(126),
    [sym_false] = ACTIONS(126),
    [sym_none] = ACTIONS(126),
    [anon_sym_await] = ACTIONS(128),
    [sym_comment] = ACTIONS(72),
    [sym__semicolon] = ACTIONS(136),
  },
  [8] = {
    [sym_expression_list] = STATE(77),
    [sym__expression] = STATE(76),
    [sym__primary_expression] = STATE(73),
    [sym_not_operator] = STATE(76),
    [sym_boolean_operator] = STATE(76),
    [sym_binary_operator] = STATE(73),
    [sym_unary_operator] = STATE(73),
    [sym_comparison_operator] = STATE(76),
    [sym_lambda] = STATE(76),
    [sym_attribute] = STATE(73),
    [sym_subscript] = STATE(73),
    [sym_call] = STATE(73),
    [sym_list] = STATE(73),
    [sym_list_comprehension] = STATE(73),
    [sym_dictionary] = STATE(73),
    [sym_dictionary_comprehension] = STATE(73),
    [sym_set] = STATE(73),
    [sym_set_comprehension] = STATE(73),
    [sym_parenthesized_expression] = STATE(73),
    [sym_tuple] = STATE(73),
    [sym_generator_expression] = STATE(73),
    [sym_conditional_expression] = STATE(76),
    [sym_concatenated_string] = STATE(73),
    [sym_await] = STATE(76),
    [anon_sym_LPAREN] = ACTIONS(130),
    [anon_sym_print] = ACTIONS(112),
    [anon_sym_exec] = ACTIONS(112),
    [anon_sym_not] = ACTIONS(132),
    [anon_sym_PLUS] = ACTIONS(116),
    [anon_sym_DASH] = ACTIONS(116),
    [anon_sym_TILDE] = ACTIONS(116),
    [anon_sym_lambda] = ACTIONS(118),
    [anon_sym_LBRACK] = ACTIONS(134),
    [sym_ellipsis] = ACTIONS(120),
    [anon_sym_LBRACE] = ACTIONS(122),
    [sym_string] = ACTIONS(124),
    [sym_integer] = ACTIONS(126),
    [sym_float] = ACTIONS(126),
    [sym_identifier] = ACTIONS(126),
    [sym_true] = ACTIONS(126),
    [sym_false] = ACTIONS(126),
    [sym_none] = ACTIONS(126),
    [anon_sym_await] = ACTIONS(128),
    [sym_comment] = ACTIONS(72),
  },
  [9] = {
    [sym_expression_list] = STATE(84),
    [sym__expression] = STATE(85),
    [sym__primary_expression] = STATE(86),
    [sym_not_operator] = STATE(85),
    [sym_boolean_operator] = STATE(85),
    [sym_binary_operator] = STATE(86),
    [sym_unary_operator] = STATE(86),
    [sym_comparison_operator] = STATE(85),
    [sym_lambda] = STATE(85),
    [sym_attribute] = STATE(86),
    [sym_subscript] = STATE(86),
    [sym_call] = STATE(86),
    [sym_list] = STATE(86),
    [sym_list_comprehension] = STATE(86),
    [sym_dictionary] = STATE(86),
    [sym_dictionary_comprehension] = STATE(86),
    [sym_set] = STATE(86),
    [sym_set_comprehension] = STATE(86),
    [sym_parenthesized_expression] = STATE(86),
    [sym_tuple] = STATE(86),
    [sym_generator_expression] = STATE(86),
    [sym_conditional_expression] = STATE(85),
    [sym_concatenated_string] = STATE(86),
    [sym_await] = STATE(85),
    [sym__newline] = ACTIONS(138),
    [anon_sym_from] = ACTIONS(140),
    [anon_sym_LPAREN] = ACTIONS(130),
    [anon_sym_print] = ACTIONS(112),
    [anon_sym_exec] = ACTIONS(112),
    [anon_sym_not] = ACTIONS(142),
    [anon_sym_PLUS] = ACTIONS(144),
    [anon_sym_DASH] = ACTIONS(144),
    [anon_sym_TILDE] = ACTIONS(144),
    [anon_sym_lambda] = ACTIONS(146),
    [anon_sym_LBRACK] = ACTIONS(134),
    [sym_ellipsis] = ACTIONS(148),
    [anon_sym_LBRACE] = ACTIONS(122),
    [sym_string] = ACTIONS(150),
    [sym_integer] = ACTIONS(152),
    [sym_float] = ACTIONS(152),
    [sym_identifier] = ACTIONS(152),
    [sym_true] = ACTIONS(152),
    [sym_false] = ACTIONS(152),
    [sym_none] = ACTIONS(152),
    [anon_sym_await] = ACTIONS(154),
    [sym_comment] = ACTIONS(72),
    [sym__semicolon] = ACTIONS(138),
  },
  [10] = {
    [aux_sym__simple_statements_repeat1] = STATE(89),
    [sym__newline] = ACTIONS(156),
    [sym_comment] = ACTIONS(72),
    [sym__semicolon] = ACTIONS(158),
  },
  [11] = {
    [sym__expression] = STATE(95),
    [sym__primary_expression] = STATE(96),
    [sym_not_operator] = STATE(95),
    [sym_boolean_operator] = STATE(95),
    [sym_binary_operator] = STATE(96),
    [sym_unary_operator] = STATE(96),
    [sym_comparison_operator] = STATE(95),
    [sym_lambda] = STATE(95),
    [sym_attribute] = STATE(96),
    [sym_subscript] = STATE(96),
    [sym_call] = STATE(96),
    [sym_list] = STATE(96),
    [sym_list_comprehension] = STATE(96),
    [sym_dictionary] = STATE(96),
    [sym_dictionary_comprehension] = STATE(96),
    [sym_set] = STATE(96),
    [sym_set_comprehension] = STATE(96),
    [sym_parenthesized_expression] = STATE(96),
    [sym_tuple] = STATE(96),
    [sym_generator_expression] = STATE(96),
    [sym_conditional_expression] = STATE(95),
    [sym_concatenated_string] = STATE(96),
    [sym_await] = STATE(95),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_not] = ACTIONS(160),
    [anon_sym_PLUS] = ACTIONS(162),
    [anon_sym_DASH] = ACTIONS(162),
    [anon_sym_TILDE] = ACTIONS(162),
    [anon_sym_lambda] = ACTIONS(164),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(166),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(168),
    [sym_integer] = ACTIONS(170),
    [sym_float] = ACTIONS(170),
    [sym_identifier] = ACTIONS(170),
    [sym_true] = ACTIONS(170),
    [sym_false] = ACTIONS(170),
    [sym_none] = ACTIONS(170),
    [anon_sym_await] = ACTIONS(172),
    [sym_comment] = ACTIONS(72),
  },
  [12] = {
    [anon_sym_for] = ACTIONS(174),
    [anon_sym_with] = ACTIONS(176),
    [anon_sym_def] = ACTIONS(178),
    [sym_comment] = ACTIONS(72),
  },
  [13] = {
    [sym_variables] = STATE(102),
    [sym__primary_expression] = STATE(103),
    [sym_binary_operator] = STATE(103),
    [sym_unary_operator] = STATE(103),
    [sym_attribute] = STATE(103),
    [sym_subscript] = STATE(103),
    [sym_call] = STATE(103),
    [sym_list] = STATE(103),
    [sym_list_comprehension] = STATE(103),
    [sym_dictionary] = STATE(103),
    [sym_dictionary_comprehension] = STATE(103),
    [sym_set] = STATE(103),
    [sym_set_comprehension] = STATE(103),
    [sym_parenthesized_expression] = STATE(103),
    [sym_tuple] = STATE(103),
    [sym_generator_expression] = STATE(103),
    [sym_concatenated_string] = STATE(103),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_PLUS] = ACTIONS(180),
    [anon_sym_DASH] = ACTIONS(180),
    [anon_sym_TILDE] = ACTIONS(180),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(182),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(184),
    [sym_integer] = ACTIONS(186),
    [sym_float] = ACTIONS(186),
    [sym_identifier] = ACTIONS(186),
    [sym_true] = ACTIONS(186),
    [sym_false] = ACTIONS(186),
    [sym_none] = ACTIONS(186),
    [sym_comment] = ACTIONS(72),
  },
  [14] = {
    [sym__expression] = STATE(104),
    [sym__primary_expression] = STATE(96),
    [sym_not_operator] = STATE(104),
    [sym_boolean_operator] = STATE(104),
    [sym_binary_operator] = STATE(96),
    [sym_unary_operator] = STATE(96),
    [sym_comparison_operator] = STATE(104),
    [sym_lambda] = STATE(104),
    [sym_attribute] = STATE(96),
    [sym_subscript] = STATE(96),
    [sym_call] = STATE(96),
    [sym_list] = STATE(96),
    [sym_list_comprehension] = STATE(96),
    [sym_dictionary] = STATE(96),
    [sym_dictionary_comprehension] = STATE(96),
    [sym_set] = STATE(96),
    [sym_set_comprehension] = STATE(96),
    [sym_parenthesized_expression] = STATE(96),
    [sym_tuple] = STATE(96),
    [sym_generator_expression] = STATE(96),
    [sym_conditional_expression] = STATE(104),
    [sym_concatenated_string] = STATE(96),
    [sym_await] = STATE(104),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_not] = ACTIONS(160),
    [anon_sym_PLUS] = ACTIONS(162),
    [anon_sym_DASH] = ACTIONS(162),
    [anon_sym_TILDE] = ACTIONS(162),
    [anon_sym_lambda] = ACTIONS(164),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(166),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(168),
    [sym_integer] = ACTIONS(170),
    [sym_float] = ACTIONS(170),
    [sym_identifier] = ACTIONS(170),
    [sym_true] = ACTIONS(170),
    [sym_false] = ACTIONS(170),
    [sym_none] = ACTIONS(170),
    [anon_sym_await] = ACTIONS(172),
    [sym_comment] = ACTIONS(72),
  },
  [15] = {
    [anon_sym_COLON] = ACTIONS(188),
    [sym_comment] = ACTIONS(72),
  },
  [16] = {
    [sym_with_item] = STATE(111),
    [sym__expression] = STATE(112),
    [sym__primary_expression] = STATE(113),
    [sym_not_operator] = STATE(112),
    [sym_boolean_operator] = STATE(112),
    [sym_binary_operator] = STATE(113),
    [sym_unary_operator] = STATE(113),
    [sym_comparison_operator] = STATE(112),
    [sym_lambda] = STATE(112),
    [sym_attribute] = STATE(113),
    [sym_subscript] = STATE(113),
    [sym_call] = STATE(113),
    [sym_list] = STATE(113),
    [sym_list_comprehension] = STATE(113),
    [sym_dictionary] = STATE(113),
    [sym_dictionary_comprehension] = STATE(113),
    [sym_set] = STATE(113),
    [sym_set_comprehension] = STATE(113),
    [sym_parenthesized_expression] = STATE(113),
    [sym_tuple] = STATE(113),
    [sym_generator_expression] = STATE(113),
    [sym_conditional_expression] = STATE(112),
    [sym_concatenated_string] = STATE(113),
    [sym_await] = STATE(112),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_not] = ACTIONS(190),
    [anon_sym_PLUS] = ACTIONS(192),
    [anon_sym_DASH] = ACTIONS(192),
    [anon_sym_TILDE] = ACTIONS(192),
    [anon_sym_lambda] = ACTIONS(194),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(196),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(198),
    [sym_integer] = ACTIONS(200),
    [sym_float] = ACTIONS(200),
    [sym_identifier] = ACTIONS(200),
    [sym_true] = ACTIONS(200),
    [sym_false] = ACTIONS(200),
    [sym_none] = ACTIONS(200),
    [anon_sym_await] = ACTIONS(202),
    [sym_comment] = ACTIONS(72),
  },
  [17] = {
    [sym_identifier] = ACTIONS(204),
    [sym_comment] = ACTIONS(72),
  },
  [18] = {
    [sym_identifier] = ACTIONS(206),
    [sym_comment] = ACTIONS(72),
  },
  [19] = {
    [sym_identifier] = ACTIONS(208),
    [sym_comment] = ACTIONS(72),
  },
  [20] = {
    [sym__newline] = ACTIONS(108),
    [anon_sym_DOT] = ACTIONS(108),
    [anon_sym_LPAREN] = ACTIONS(108),
    [anon_sym_COMMA] = ACTIONS(108),
    [anon_sym_STAR] = ACTIONS(110),
    [anon_sym_GT_GT] = ACTIONS(110),
    [anon_sym_if] = ACTIONS(108),
    [anon_sym_COLON] = ACTIONS(108),
    [anon_sym_in] = ACTIONS(108),
    [anon_sym_EQ] = ACTIONS(110),
    [anon_sym_AT] = ACTIONS(110),
    [anon_sym_not] = ACTIONS(108),
    [anon_sym_and] = ACTIONS(108),
    [anon_sym_or] = ACTIONS(108),
    [anon_sym_PLUS] = ACTIONS(110),
    [anon_sym_DASH] = ACTIONS(110),
    [anon_sym_SLASH] = ACTIONS(110),
    [anon_sym_PERCENT] = ACTIONS(110),
    [anon_sym_SLASH_SLASH] = ACTIONS(110),
    [anon_sym_STAR_STAR] = ACTIONS(110),
    [anon_sym_PIPE] = ACTIONS(110),
    [anon_sym_AMP] = ACTIONS(110),
    [anon_sym_CARET] = ACTIONS(110),
    [anon_sym_LT_LT] = ACTIONS(110),
    [anon_sym_LT] = ACTIONS(110),
    [anon_sym_LT_EQ] = ACTIONS(108),
    [anon_sym_EQ_EQ] = ACTIONS(108),
    [anon_sym_BANG_EQ] = ACTIONS(108),
    [anon_sym_GT_EQ] = ACTIONS(108),
    [anon_sym_GT] = ACTIONS(110),
    [anon_sym_LT_GT] = ACTIONS(108),
    [anon_sym_is] = ACTIONS(108),
    [anon_sym_PLUS_EQ] = ACTIONS(108),
    [anon_sym_DASH_EQ] = ACTIONS(108),
    [anon_sym_STAR_EQ] = ACTIONS(108),
    [anon_sym_SLASH_EQ] = ACTIONS(108),
    [anon_sym_AT_EQ] = ACTIONS(108),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(108),
    [anon_sym_PERCENT_EQ] = ACTIONS(108),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(108),
    [anon_sym_GT_GT_EQ] = ACTIONS(108),
    [anon_sym_LT_LT_EQ] = ACTIONS(108),
    [anon_sym_AMP_EQ] = ACTIONS(108),
    [anon_sym_CARET_EQ] = ACTIONS(108),
    [anon_sym_PIPE_EQ] = ACTIONS(108),
    [anon_sym_LBRACK] = ACTIONS(108),
    [sym_string] = ACTIONS(210),
    [sym_comment] = ACTIONS(72),
    [sym__semicolon] = ACTIONS(108),
  },
  [21] = {
    [sym_identifier] = ACTIONS(212),
    [sym_comment] = ACTIONS(72),
  },
  [22] = {
    [sym_dotted_name] = STATE(120),
    [sym_identifier] = ACTIONS(214),
    [sym_comment] = ACTIONS(72),
  },
  [23] = {
    [sym__expression] = STATE(122),
    [sym__primary_expression] = STATE(34),
    [sym_not_operator] = STATE(122),
    [sym_boolean_operator] = STATE(122),
    [sym_binary_operator] = STATE(34),
    [sym_unary_operator] = STATE(34),
    [sym_comparison_operator] = STATE(122),
    [sym_lambda] = STATE(122),
    [sym_attribute] = STATE(34),
    [sym_subscript] = STATE(34),
    [sym_call] = STATE(34),
    [sym_list] = STATE(34),
    [sym_list_comprehension] = STATE(34),
    [sym_dictionary] = STATE(34),
    [sym_dictionary_comprehension] = STATE(34),
    [sym_set] = STATE(34),
    [sym_set_comprehension] = STATE(34),
    [sym_parenthesized_expression] = STATE(34),
    [sym_tuple] = STATE(34),
    [sym_generator_expression] = STATE(34),
    [sym_conditional_expression] = STATE(122),
    [sym_concatenated_string] = STATE(34),
    [sym_await] = STATE(122),
    [anon_sym_LPAREN] = ACTIONS(14),
    [anon_sym_print] = ACTIONS(216),
    [anon_sym_exec] = ACTIONS(216),
    [anon_sym_not] = ACTIONS(52),
    [anon_sym_PLUS] = ACTIONS(54),
    [anon_sym_DASH] = ACTIONS(54),
    [anon_sym_TILDE] = ACTIONS(54),
    [anon_sym_lambda] = ACTIONS(56),
    [anon_sym_LBRACK] = ACTIONS(60),
    [sym_ellipsis] = ACTIONS(62),
    [anon_sym_LBRACE] = ACTIONS(64),
    [sym_string] = ACTIONS(66),
    [sym_integer] = ACTIONS(68),
    [sym_float] = ACTIONS(68),
    [sym_identifier] = ACTIONS(68),
    [sym_true] = ACTIONS(68),
    [sym_false] = ACTIONS(68),
    [sym_none] = ACTIONS(68),
    [anon_sym_await] = ACTIONS(70),
    [sym_comment] = ACTIONS(72),
  },
  [24] = {
    [sym__primary_expression] = STATE(123),
    [sym_binary_operator] = STATE(123),
    [sym_unary_operator] = STATE(123),
    [sym_attribute] = STATE(123),
    [sym_subscript] = STATE(123),
    [sym_call] = STATE(123),
    [sym_list] = STATE(123),
    [sym_list_comprehension] = STATE(123),
    [sym_dictionary] = STATE(123),
    [sym_dictionary_comprehension] = STATE(123),
    [sym_set] = STATE(123),
    [sym_set_comprehension] = STATE(123),
    [sym_parenthesized_expression] = STATE(123),
    [sym_tuple] = STATE(123),
    [sym_generator_expression] = STATE(123),
    [sym_concatenated_string] = STATE(123),
    [anon_sym_LPAREN] = ACTIONS(14),
    [anon_sym_print] = ACTIONS(216),
    [anon_sym_exec] = ACTIONS(216),
    [anon_sym_PLUS] = ACTIONS(54),
    [anon_sym_DASH] = ACTIONS(54),
    [anon_sym_TILDE] = ACTIONS(54),
    [anon_sym_LBRACK] = ACTIONS(60),
    [sym_ellipsis] = ACTIONS(218),
    [anon_sym_LBRACE] = ACTIONS(64),
    [sym_string] = ACTIONS(66),
    [sym_integer] = ACTIONS(220),
    [sym_float] = ACTIONS(220),
    [sym_identifier] = ACTIONS(220),
    [sym_true] = ACTIONS(220),
    [sym_false] = ACTIONS(220),
    [sym_none] = ACTIONS(220),
    [sym_comment] = ACTIONS(72),
  },
  [25] = {
    [sym_lambda_parameters] = STATE(129),
    [sym__parameters] = STATE(130),
    [sym_default_parameter] = STATE(131),
    [sym_typed_default_parameter] = STATE(131),
    [sym_list_splat] = STATE(132),
    [sym_dictionary_splat] = STATE(132),
    [sym_typed_parameter] = STATE(131),
    [sym_tuple] = STATE(131),
    [anon_sym_LPAREN] = ACTIONS(222),
    [anon_sym_STAR] = ACTIONS(224),
    [anon_sym_print] = ACTIONS(226),
    [anon_sym_COLON] = ACTIONS(228),
    [anon_sym_exec] = ACTIONS(226),
    [sym_identifier] = ACTIONS(230),
    [sym_comment] = ACTIONS(72),
  },
  [26] = {
    [sym_expression_list] = STATE(134),
    [sym__expression] = STATE(76),
    [sym__primary_expression] = STATE(73),
    [sym_not_operator] = STATE(76),
    [sym_boolean_operator] = STATE(76),
    [sym_binary_operator] = STATE(73),
    [sym_unary_operator] = STATE(73),
    [sym_comparison_operator] = STATE(76),
    [sym_lambda] = STATE(76),
    [sym_attribute] = STATE(73),
    [sym_subscript] = STATE(73),
    [sym_call] = STATE(73),
    [sym_list] = STATE(73),
    [sym_list_comprehension] = STATE(73),
    [sym_dictionary] = STATE(73),
    [sym_dictionary_comprehension] = STATE(73),
    [sym_set] = STATE(73),
    [sym_set_comprehension] = STATE(73),
    [sym_parenthesized_expression] = STATE(73),
    [sym_tuple] = STATE(73),
    [sym_generator_expression] = STATE(73),
    [sym_conditional_expression] = STATE(76),
    [sym_concatenated_string] = STATE(73),
    [sym_await] = STATE(76),
    [sym__newline] = ACTIONS(232),
    [anon_sym_from] = ACTIONS(234),
    [anon_sym_LPAREN] = ACTIONS(130),
    [anon_sym_print] = ACTIONS(112),
    [anon_sym_exec] = ACTIONS(112),
    [anon_sym_not] = ACTIONS(132),
    [anon_sym_PLUS] = ACTIONS(116),
    [anon_sym_DASH] = ACTIONS(116),
    [anon_sym_TILDE] = ACTIONS(116),
    [anon_sym_lambda] = ACTIONS(118),
    [anon_sym_LBRACK] = ACTIONS(134),
    [sym_ellipsis] = ACTIONS(120),
    [anon_sym_LBRACE] = ACTIONS(122),
    [sym_string] = ACTIONS(124),
    [sym_integer] = ACTIONS(126),
    [sym_float] = ACTIONS(126),
    [sym_identifier] = ACTIONS(126),
    [sym_true] = ACTIONS(126),
    [sym_false] = ACTIONS(126),
    [sym_none] = ACTIONS(126),
    [anon_sym_await] = ACTIONS(128),
    [sym_comment] = ACTIONS(72),
    [sym__semicolon] = ACTIONS(232),
  },
  [27] = {
    [sym_list_splat] = STATE(143),
    [sym__expression] = STATE(144),
    [sym__primary_expression] = STATE(145),
    [sym_not_operator] = STATE(144),
    [sym_boolean_operator] = STATE(144),
    [sym_binary_operator] = STATE(145),
    [sym_unary_operator] = STATE(145),
    [sym_comparison_operator] = STATE(144),
    [sym_lambda] = STATE(144),
    [sym_attribute] = STATE(145),
    [sym_subscript] = STATE(145),
    [sym_call] = STATE(145),
    [sym_list] = STATE(145),
    [sym_list_comprehension] = STATE(145),
    [sym_dictionary] = STATE(145),
    [sym_dictionary_comprehension] = STATE(145),
    [sym_set] = STATE(145),
    [sym_set_comprehension] = STATE(145),
    [sym_parenthesized_expression] = STATE(145),
    [sym_tuple] = STATE(145),
    [sym_generator_expression] = STATE(145),
    [sym_conditional_expression] = STATE(144),
    [sym_concatenated_string] = STATE(145),
    [sym_await] = STATE(144),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_COMMA] = ACTIONS(236),
    [anon_sym_STAR] = ACTIONS(238),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_not] = ACTIONS(240),
    [anon_sym_PLUS] = ACTIONS(242),
    [anon_sym_DASH] = ACTIONS(242),
    [anon_sym_TILDE] = ACTIONS(242),
    [anon_sym_lambda] = ACTIONS(244),
    [anon_sym_LBRACK] = ACTIONS(96),
    [anon_sym_RBRACK] = ACTIONS(246),
    [sym_ellipsis] = ACTIONS(248),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(250),
    [sym_integer] = ACTIONS(252),
    [sym_float] = ACTIONS(252),
    [sym_identifier] = ACTIONS(252),
    [sym_true] = ACTIONS(252),
    [sym_false] = ACTIONS(252),
    [sym_none] = ACTIONS(252),
    [anon_sym_await] = ACTIONS(254),
    [sym_comment] = ACTIONS(72),
  },
  [28] = {
    [sym_list_splat] = STATE(154),
    [sym_dictionary_splat] = STATE(155),
    [sym__expression] = STATE(156),
    [sym__primary_expression] = STATE(157),
    [sym_not_operator] = STATE(156),
    [sym_boolean_operator] = STATE(156),
    [sym_binary_operator] = STATE(157),
    [sym_unary_operator] = STATE(157),
    [sym_comparison_operator] = STATE(156),
    [sym_lambda] = STATE(156),
    [sym_attribute] = STATE(157),
    [sym_subscript] = STATE(157),
    [sym_call] = STATE(157),
    [sym_list] = STATE(157),
    [sym_list_comprehension] = STATE(157),
    [sym_dictionary] = STATE(157),
    [sym_dictionary_comprehension] = STATE(157),
    [sym_pair] = STATE(158),
    [sym_set] = STATE(157),
    [sym_set_comprehension] = STATE(157),
    [sym_parenthesized_expression] = STATE(157),
    [sym_tuple] = STATE(157),
    [sym_generator_expression] = STATE(157),
    [sym_conditional_expression] = STATE(156),
    [sym_concatenated_string] = STATE(157),
    [sym_await] = STATE(156),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_COMMA] = ACTIONS(256),
    [anon_sym_STAR] = ACTIONS(258),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_not] = ACTIONS(260),
    [anon_sym_PLUS] = ACTIONS(262),
    [anon_sym_DASH] = ACTIONS(262),
    [anon_sym_TILDE] = ACTIONS(262),
    [anon_sym_lambda] = ACTIONS(264),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(266),
    [anon_sym_LBRACE] = ACTIONS(100),
    [anon_sym_RBRACE] = ACTIONS(268),
    [sym_string] = ACTIONS(270),
    [sym_integer] = ACTIONS(272),
    [sym_float] = ACTIONS(272),
    [sym_identifier] = ACTIONS(272),
    [sym_true] = ACTIONS(272),
    [sym_false] = ACTIONS(272),
    [sym_none] = ACTIONS(272),
    [anon_sym_await] = ACTIONS(274),
    [sym_comment] = ACTIONS(72),
  },
  [29] = {
    [aux_sym_concatenated_string_repeat1] = STATE(159),
    [sym__newline] = ACTIONS(276),
    [anon_sym_DOT] = ACTIONS(276),
    [anon_sym_LPAREN] = ACTIONS(276),
    [anon_sym_COMMA] = ACTIONS(276),
    [anon_sym_STAR] = ACTIONS(278),
    [anon_sym_GT_GT] = ACTIONS(278),
    [anon_sym_if] = ACTIONS(276),
    [anon_sym_COLON] = ACTIONS(276),
    [anon_sym_in] = ACTIONS(276),
    [anon_sym_EQ] = ACTIONS(278),
    [anon_sym_AT] = ACTIONS(278),
    [anon_sym_not] = ACTIONS(276),
    [anon_sym_and] = ACTIONS(276),
    [anon_sym_or] = ACTIONS(276),
    [anon_sym_PLUS] = ACTIONS(278),
    [anon_sym_DASH] = ACTIONS(278),
    [anon_sym_SLASH] = ACTIONS(278),
    [anon_sym_PERCENT] = ACTIONS(278),
    [anon_sym_SLASH_SLASH] = ACTIONS(278),
    [anon_sym_STAR_STAR] = ACTIONS(278),
    [anon_sym_PIPE] = ACTIONS(278),
    [anon_sym_AMP] = ACTIONS(278),
    [anon_sym_CARET] = ACTIONS(278),
    [anon_sym_LT_LT] = ACTIONS(278),
    [anon_sym_LT] = ACTIONS(278),
    [anon_sym_LT_EQ] = ACTIONS(276),
    [anon_sym_EQ_EQ] = ACTIONS(276),
    [anon_sym_BANG_EQ] = ACTIONS(276),
    [anon_sym_GT_EQ] = ACTIONS(276),
    [anon_sym_GT] = ACTIONS(278),
    [anon_sym_LT_GT] = ACTIONS(276),
    [anon_sym_is] = ACTIONS(276),
    [anon_sym_PLUS_EQ] = ACTIONS(276),
    [anon_sym_DASH_EQ] = ACTIONS(276),
    [anon_sym_STAR_EQ] = ACTIONS(276),
    [anon_sym_SLASH_EQ] = ACTIONS(276),
    [anon_sym_AT_EQ] = ACTIONS(276),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(276),
    [anon_sym_PERCENT_EQ] = ACTIONS(276),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(276),
    [anon_sym_GT_GT_EQ] = ACTIONS(276),
    [anon_sym_LT_LT_EQ] = ACTIONS(276),
    [anon_sym_AMP_EQ] = ACTIONS(276),
    [anon_sym_CARET_EQ] = ACTIONS(276),
    [anon_sym_PIPE_EQ] = ACTIONS(276),
    [anon_sym_LBRACK] = ACTIONS(276),
    [sym_string] = ACTIONS(280),
    [sym_comment] = ACTIONS(72),
    [sym__semicolon] = ACTIONS(276),
  },
  [30] = {
    [sym__expression] = STATE(160),
    [sym__primary_expression] = STATE(34),
    [sym_not_operator] = STATE(160),
    [sym_boolean_operator] = STATE(160),
    [sym_binary_operator] = STATE(34),
    [sym_unary_operator] = STATE(34),
    [sym_comparison_operator] = STATE(160),
    [sym_lambda] = STATE(160),
    [sym_attribute] = STATE(34),
    [sym_subscript] = STATE(34),
    [sym_call] = STATE(34),
    [sym_list] = STATE(34),
    [sym_list_comprehension] = STATE(34),
    [sym_dictionary] = STATE(34),
    [sym_dictionary_comprehension] = STATE(34),
    [sym_set] = STATE(34),
    [sym_set_comprehension] = STATE(34),
    [sym_parenthesized_expression] = STATE(34),
    [sym_tuple] = STATE(34),
    [sym_generator_expression] = STATE(34),
    [sym_conditional_expression] = STATE(160),
    [sym_concatenated_string] = STATE(34),
    [sym_await] = STATE(160),
    [anon_sym_LPAREN] = ACTIONS(14),
    [anon_sym_print] = ACTIONS(216),
    [anon_sym_exec] = ACTIONS(216),
    [anon_sym_not] = ACTIONS(52),
    [anon_sym_PLUS] = ACTIONS(54),
    [anon_sym_DASH] = ACTIONS(54),
    [anon_sym_TILDE] = ACTIONS(54),
    [anon_sym_lambda] = ACTIONS(56),
    [anon_sym_LBRACK] = ACTIONS(60),
    [sym_ellipsis] = ACTIONS(62),
    [anon_sym_LBRACE] = ACTIONS(64),
    [sym_string] = ACTIONS(66),
    [sym_integer] = ACTIONS(68),
    [sym_float] = ACTIONS(68),
    [sym_identifier] = ACTIONS(68),
    [sym_true] = ACTIONS(68),
    [sym_false] = ACTIONS(68),
    [sym_none] = ACTIONS(68),
    [anon_sym_await] = ACTIONS(70),
    [sym_comment] = ACTIONS(72),
  },
  [31] = {
    [ts_builtin_sym_end] = ACTIONS(282),
    [sym_comment] = ACTIONS(72),
  },
  [32] = {
    [anon_sym_COLON] = ACTIONS(284),
    [anon_sym_EQ] = ACTIONS(286),
    [anon_sym_PLUS_EQ] = ACTIONS(288),
    [anon_sym_DASH_EQ] = ACTIONS(288),
    [anon_sym_STAR_EQ] = ACTIONS(288),
    [anon_sym_SLASH_EQ] = ACTIONS(288),
    [anon_sym_AT_EQ] = ACTIONS(288),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(288),
    [anon_sym_PERCENT_EQ] = ACTIONS(288),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(288),
    [anon_sym_GT_GT_EQ] = ACTIONS(288),
    [anon_sym_LT_LT_EQ] = ACTIONS(288),
    [anon_sym_AMP_EQ] = ACTIONS(288),
    [anon_sym_CARET_EQ] = ACTIONS(288),
    [anon_sym_PIPE_EQ] = ACTIONS(288),
    [sym_comment] = ACTIONS(72),
  },
  [33] = {
    [aux_sym_print_statement_repeat1] = STATE(168),
    [sym__newline] = ACTIONS(290),
    [anon_sym_COMMA] = ACTIONS(292),
    [anon_sym_if] = ACTIONS(294),
    [anon_sym_COLON] = ACTIONS(296),
    [anon_sym_EQ] = ACTIONS(296),
    [anon_sym_and] = ACTIONS(298),
    [anon_sym_or] = ACTIONS(300),
    [anon_sym_PLUS_EQ] = ACTIONS(296),
    [anon_sym_DASH_EQ] = ACTIONS(296),
    [anon_sym_STAR_EQ] = ACTIONS(296),
    [anon_sym_SLASH_EQ] = ACTIONS(296),
    [anon_sym_AT_EQ] = ACTIONS(296),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(296),
    [anon_sym_PERCENT_EQ] = ACTIONS(296),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(296),
    [anon_sym_GT_GT_EQ] = ACTIONS(296),
    [anon_sym_LT_LT_EQ] = ACTIONS(296),
    [anon_sym_AMP_EQ] = ACTIONS(296),
    [anon_sym_CARET_EQ] = ACTIONS(296),
    [anon_sym_PIPE_EQ] = ACTIONS(296),
    [sym_comment] = ACTIONS(72),
    [sym__semicolon] = ACTIONS(290),
  },
  [34] = {
    [sym_argument_list] = STATE(182),
    [sym_generator_expression] = STATE(182),
    [aux_sym_comparison_operator_repeat1] = STATE(183),
    [sym__newline] = ACTIONS(302),
    [anon_sym_DOT] = ACTIONS(304),
    [anon_sym_LPAREN] = ACTIONS(306),
    [anon_sym_COMMA] = ACTIONS(302),
    [anon_sym_STAR] = ACTIONS(308),
    [anon_sym_GT_GT] = ACTIONS(310),
    [anon_sym_if] = ACTIONS(302),
    [anon_sym_COLON] = ACTIONS(302),
    [anon_sym_in] = ACTIONS(312),
    [anon_sym_EQ] = ACTIONS(314),
    [anon_sym_AT] = ACTIONS(308),
    [anon_sym_not] = ACTIONS(316),
    [anon_sym_and] = ACTIONS(302),
    [anon_sym_or] = ACTIONS(302),
    [anon_sym_PLUS] = ACTIONS(318),
    [anon_sym_DASH] = ACTIONS(318),
    [anon_sym_SLASH] = ACTIONS(308),
    [anon_sym_PERCENT] = ACTIONS(308),
    [anon_sym_SLASH_SLASH] = ACTIONS(308),
    [anon_sym_STAR_STAR] = ACTIONS(320),
    [anon_sym_PIPE] = ACTIONS(322),
    [anon_sym_AMP] = ACTIONS(324),
    [anon_sym_CARET] = ACTIONS(326),
    [anon_sym_LT_LT] = ACTIONS(310),
    [anon_sym_LT] = ACTIONS(328),
    [anon_sym_LT_EQ] = ACTIONS(312),
    [anon_sym_EQ_EQ] = ACTIONS(312),
    [anon_sym_BANG_EQ] = ACTIONS(312),
    [anon_sym_GT_EQ] = ACTIONS(312),
    [anon_sym_GT] = ACTIONS(328),
    [anon_sym_LT_GT] = ACTIONS(312),
    [anon_sym_is] = ACTIONS(330),
    [anon_sym_PLUS_EQ] = ACTIONS(302),
    [anon_sym_DASH_EQ] = ACTIONS(302),
    [anon_sym_STAR_EQ] = ACTIONS(302),
    [anon_sym_SLASH_EQ] = ACTIONS(302),
    [anon_sym_AT_EQ] = ACTIONS(302),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(302),
    [anon_sym_PERCENT_EQ] = ACTIONS(302),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(302),
    [anon_sym_GT_GT_EQ] = ACTIONS(302),
    [anon_sym_LT_LT_EQ] = ACTIONS(302),
    [anon_sym_AMP_EQ] = ACTIONS(302),
    [anon_sym_CARET_EQ] = ACTIONS(302),
    [anon_sym_PIPE_EQ] = ACTIONS(302),
    [anon_sym_LBRACK] = ACTIONS(332),
    [sym_comment] = ACTIONS(72),
    [sym__semicolon] = ACTIONS(302),
  },
  [35] = {
    [sym__newline] = ACTIONS(290),
    [sym_comment] = ACTIONS(72),
    [sym__semicolon] = ACTIONS(290),
  },
  [36] = {
    [sym__statement] = STATE(184),
    [sym__simple_statements] = STATE(184),
    [sym_import_statement] = STATE(10),
    [sym_import_from_statement] = STATE(10),
    [sym_print_statement] = STATE(10),
    [sym_assert_statement] = STATE(10),
    [sym_expression_statement] = STATE(10),
    [sym_return_statement] = STATE(10),
    [sym_delete_statement] = STATE(10),
    [sym_raise_statement] = STATE(10),
    [sym_if_statement] = STATE(184),
    [sym_for_statement] = STATE(184),
    [sym_while_statement] = STATE(184),
    [sym_try_statement] = STATE(184),
    [sym_with_statement] = STATE(184),
    [sym_function_definition] = STATE(184),
    [sym_global_statement] = STATE(10),
    [sym_nonlocal_statement] = STATE(10),
    [sym_exec_statement] = STATE(10),
    [sym_class_definition] = STATE(184),
    [sym_decorated_definition] = STATE(184),
    [sym_decorator] = STATE(37),
    [sym_expression_list] = STATE(32),
    [sym__expression] = STATE(33),
    [sym__primary_expression] = STATE(34),
    [sym_not_operator] = STATE(33),
    [sym_boolean_operator] = STATE(33),
    [sym_binary_operator] = STATE(34),
    [sym_unary_operator] = STATE(34),
    [sym_comparison_operator] = STATE(33),
    [sym_lambda] = STATE(33),
    [sym_assignment] = STATE(35),
    [sym_augmented_assignment] = STATE(35),
    [sym_yield] = STATE(35),
    [sym_attribute] = STATE(34),
    [sym_subscript] = STATE(34),
    [sym_call] = STATE(34),
    [sym_list] = STATE(34),
    [sym_list_comprehension] = STATE(34),
    [sym_dictionary] = STATE(34),
    [sym_dictionary_comprehension] = STATE(34),
    [sym_set] = STATE(34),
    [sym_set_comprehension] = STATE(34),
    [sym_parenthesized_expression] = STATE(34),
    [sym_tuple] = STATE(34),
    [sym_generator_expression] = STATE(34),
    [sym_conditional_expression] = STATE(33),
    [sym_concatenated_string] = STATE(34),
    [sym_await] = STATE(33),
    [aux_sym_module_repeat1] = STATE(184),
    [aux_sym_decorated_definition_repeat1] = STATE(37),
    [ts_builtin_sym_end] = ACTIONS(334),
    [anon_sym_import] = ACTIONS(10),
    [anon_sym_from] = ACTIONS(12),
    [anon_sym_LPAREN] = ACTIONS(14),
    [anon_sym_print] = ACTIONS(16),
    [anon_sym_assert] = ACTIONS(18),
    [anon_sym_return] = ACTIONS(20),
    [anon_sym_del] = ACTIONS(22),
    [anon_sym_raise] = ACTIONS(24),
    [sym_pass_statement] = ACTIONS(26),
    [sym_break_statement] = ACTIONS(26),
    [sym_continue_statement] = ACTIONS(26),
    [anon_sym_if] = ACTIONS(28),
    [anon_sym_async] = ACTIONS(30),
    [anon_sym_for] = ACTIONS(32),
    [anon_sym_while] = ACTIONS(34),
    [anon_sym_try] = ACTIONS(36),
    [anon_sym_with] = ACTIONS(38),
    [anon_sym_def] = ACTIONS(40),
    [anon_sym_global] = ACTIONS(42),
    [anon_sym_nonlocal] = ACTIONS(44),
    [anon_sym_exec] = ACTIONS(46),
    [anon_sym_class] = ACTIONS(48),
    [anon_sym_AT] = ACTIONS(50),
    [anon_sym_not] = ACTIONS(52),
    [anon_sym_PLUS] = ACTIONS(54),
    [anon_sym_DASH] = ACTIONS(54),
    [anon_sym_TILDE] = ACTIONS(54),
    [anon_sym_lambda] = ACTIONS(56),
    [anon_sym_yield] = ACTIONS(58),
    [anon_sym_LBRACK] = ACTIONS(60),
    [sym_ellipsis] = ACTIONS(62),
    [anon_sym_LBRACE] = ACTIONS(64),
    [sym_string] = ACTIONS(66),
    [sym_integer] = ACTIONS(68),
    [sym_float] = ACTIONS(68),
    [sym_identifier] = ACTIONS(68),
    [sym_true] = ACTIONS(68),
    [sym_false] = ACTIONS(68),
    [sym_none] = ACTIONS(68),
    [anon_sym_await] = ACTIONS(70),
    [sym_comment] = ACTIONS(72),
  },
  [37] = {
    [sym_function_definition] = STATE(186),
    [sym_class_definition] = STATE(186),
    [sym_decorator] = STATE(187),
    [aux_sym_decorated_definition_repeat1] = STATE(187),
    [anon_sym_async] = ACTIONS(336),
    [anon_sym_def] = ACTIONS(338),
    [anon_sym_class] = ACTIONS(340),
    [anon_sym_AT] = ACTIONS(50),
    [sym_comment] = ACTIONS(72),
  },
  [38] = {
    [aux_sym_dotted_name_repeat1] = STATE(189),
    [sym__newline] = ACTIONS(342),
    [anon_sym_DOT] = ACTIONS(344),
    [anon_sym_COMMA] = ACTIONS(342),
    [anon_sym_as] = ACTIONS(342),
    [sym_comment] = ACTIONS(72),
    [sym__semicolon] = ACTIONS(342),
  },
  [39] = {
    [sym__newline] = ACTIONS(346),
    [sym_comment] = ACTIONS(72),
    [sym__semicolon] = ACTIONS(346),
  },
  [40] = {
    [aux_sym__import_list_repeat1] = STATE(191),
    [sym__newline] = ACTIONS(348),
    [anon_sym_COMMA] = ACTIONS(350),
    [sym_comment] = ACTIONS(72),
    [sym__semicolon] = ACTIONS(348),
  },
  [41] = {
    [aux_sym__import_list_repeat1] = STATE(191),
    [sym__newline] = ACTIONS(348),
    [anon_sym_COMMA] = ACTIONS(350),
    [anon_sym_as] = ACTIONS(352),
    [sym_comment] = ACTIONS(72),
    [sym__semicolon] = ACTIONS(348),
  },
  [42] = {
    [aux_sym_dotted_name_repeat1] = STATE(194),
    [anon_sym_import] = ACTIONS(342),
    [anon_sym_DOT] = ACTIONS(354),
    [sym_comment] = ACTIONS(72),
  },
  [43] = {
    [sym_dotted_name] = STATE(195),
    [anon_sym_import] = ACTIONS(356),
    [sym_identifier] = ACTIONS(358),
    [sym_comment] = ACTIONS(72),
  },
  [44] = {
    [anon_sym_import] = ACTIONS(360),
    [sym_comment] = ACTIONS(72),
  },
  [45] = {
    [aux_sym_import_prefix_repeat1] = STATE(197),
    [anon_sym_import] = ACTIONS(362),
    [anon_sym_DOT] = ACTIONS(364),
    [sym_identifier] = ACTIONS(362),
    [sym_comment] = ACTIONS(72),
  },
  [46] = {
    [sym__expression] = STATE(200),
    [sym__primary_expression] = STATE(59),
    [sym_not_operator] = STATE(200),
    [sym_boolean_operator] = STATE(200),
    [sym_binary_operator] = STATE(59),
    [sym_unary_operator] = STATE(59),
    [sym_comparison_operator] = STATE(200),
    [sym_lambda] = STATE(200),
    [sym_yield] = STATE(201),
    [sym_attribute] = STATE(59),
    [sym_subscript] = STATE(59),
    [sym_call] = STATE(59),
    [sym_list] = STATE(59),
    [sym_list_comprehension] = STATE(59),
    [sym_dictionary] = STATE(59),
    [sym_dictionary_comprehension] = STATE(59),
    [sym_set] = STATE(59),
    [sym_set_comprehension] = STATE(59),
    [sym_parenthesized_expression] = STATE(59),
    [sym_tuple] = STATE(59),
    [sym_generator_expression] = STATE(59),
    [sym_conditional_expression] = STATE(200),
    [sym_concatenated_string] = STATE(59),
    [sym_await] = STATE(200),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_RPAREN] = ACTIONS(366),
    [anon_sym_COMMA] = ACTIONS(368),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_not] = ACTIONS(88),
    [anon_sym_PLUS] = ACTIONS(90),
    [anon_sym_DASH] = ACTIONS(90),
    [anon_sym_TILDE] = ACTIONS(90),
    [anon_sym_lambda] = ACTIONS(92),
    [anon_sym_yield] = ACTIONS(94),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(98),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(102),
    [sym_integer] = ACTIONS(104),
    [sym_float] = ACTIONS(104),
    [sym_identifier] = ACTIONS(104),
    [sym_true] = ACTIONS(104),
    [sym_false] = ACTIONS(104),
    [sym_none] = ACTIONS(104),
    [anon_sym_await] = ACTIONS(106),
    [sym_comment] = ACTIONS(72),
  },
  [47] = {
    [sym__newline] = ACTIONS(370),
    [anon_sym_DOT] = ACTIONS(370),
    [anon_sym_LPAREN] = ACTIONS(370),
    [anon_sym_COMMA] = ACTIONS(370),
    [anon_sym_STAR] = ACTIONS(372),
    [anon_sym_GT_GT] = ACTIONS(372),
    [anon_sym_if] = ACTIONS(370),
    [anon_sym_COLON] = ACTIONS(370),
    [anon_sym_in] = ACTIONS(370),
    [anon_sym_EQ] = ACTIONS(372),
    [anon_sym_AT] = ACTIONS(372),
    [anon_sym_not] = ACTIONS(370),
    [anon_sym_and] = ACTIONS(370),
    [anon_sym_or] = ACTIONS(370),
    [anon_sym_PLUS] = ACTIONS(372),
    [anon_sym_DASH] = ACTIONS(372),
    [anon_sym_SLASH] = ACTIONS(372),
    [anon_sym_PERCENT] = ACTIONS(372),
    [anon_sym_SLASH_SLASH] = ACTIONS(372),
    [anon_sym_STAR_STAR] = ACTIONS(372),
    [anon_sym_PIPE] = ACTIONS(372),
    [anon_sym_AMP] = ACTIONS(372),
    [anon_sym_CARET] = ACTIONS(372),
    [anon_sym_LT_LT] = ACTIONS(372),
    [anon_sym_LT] = ACTIONS(372),
    [anon_sym_LT_EQ] = ACTIONS(370),
    [anon_sym_EQ_EQ] = ACTIONS(370),
    [anon_sym_BANG_EQ] = ACTIONS(370),
    [anon_sym_GT_EQ] = ACTIONS(370),
    [anon_sym_GT] = ACTIONS(372),
    [anon_sym_LT_GT] = ACTIONS(370),
    [anon_sym_is] = ACTIONS(370),
    [anon_sym_PLUS_EQ] = ACTIONS(370),
    [anon_sym_DASH_EQ] = ACTIONS(370),
    [anon_sym_STAR_EQ] = ACTIONS(370),
    [anon_sym_SLASH_EQ] = ACTIONS(370),
    [anon_sym_AT_EQ] = ACTIONS(370),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(370),
    [anon_sym_PERCENT_EQ] = ACTIONS(370),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(370),
    [anon_sym_GT_GT_EQ] = ACTIONS(370),
    [anon_sym_LT_LT_EQ] = ACTIONS(370),
    [anon_sym_AMP_EQ] = ACTIONS(370),
    [anon_sym_CARET_EQ] = ACTIONS(370),
    [anon_sym_PIPE_EQ] = ACTIONS(370),
    [anon_sym_LBRACK] = ACTIONS(370),
    [sym_comment] = ACTIONS(72),
    [sym__semicolon] = ACTIONS(370),
  },
  [48] = {
    [anon_sym_RPAREN] = ACTIONS(374),
    [sym_comment] = ACTIONS(72),
  },
  [49] = {
    [anon_sym_DOT] = ACTIONS(108),
    [anon_sym_LPAREN] = ACTIONS(108),
    [anon_sym_RPAREN] = ACTIONS(108),
    [anon_sym_COMMA] = ACTIONS(108),
    [anon_sym_as] = ACTIONS(110),
    [anon_sym_STAR] = ACTIONS(110),
    [anon_sym_GT_GT] = ACTIONS(108),
    [anon_sym_if] = ACTIONS(108),
    [anon_sym_COLON] = ACTIONS(108),
    [anon_sym_else] = ACTIONS(108),
    [anon_sym_async] = ACTIONS(108),
    [anon_sym_for] = ACTIONS(108),
    [anon_sym_in] = ACTIONS(108),
    [anon_sym_EQ] = ACTIONS(110),
    [anon_sym_AT] = ACTIONS(108),
    [anon_sym_not] = ACTIONS(108),
    [anon_sym_and] = ACTIONS(108),
    [anon_sym_or] = ACTIONS(108),
    [anon_sym_PLUS] = ACTIONS(108),
    [anon_sym_DASH] = ACTIONS(108),
    [anon_sym_SLASH] = ACTIONS(110),
    [anon_sym_PERCENT] = ACTIONS(108),
    [anon_sym_SLASH_SLASH] = ACTIONS(108),
    [anon_sym_STAR_STAR] = ACTIONS(108),
    [anon_sym_PIPE] = ACTIONS(108),
    [anon_sym_AMP] = ACTIONS(108),
    [anon_sym_CARET] = ACTIONS(108),
    [anon_sym_LT_LT] = ACTIONS(108),
    [anon_sym_LT] = ACTIONS(110),
    [anon_sym_LT_EQ] = ACTIONS(108),
    [anon_sym_EQ_EQ] = ACTIONS(108),
    [anon_sym_BANG_EQ] = ACTIONS(108),
    [anon_sym_GT_EQ] = ACTIONS(108),
    [anon_sym_GT] = ACTIONS(110),
    [anon_sym_LT_GT] = ACTIONS(108),
    [anon_sym_is] = ACTIONS(108),
    [anon_sym_LBRACK] = ACTIONS(108),
    [anon_sym_RBRACK] = ACTIONS(108),
    [anon_sym_RBRACE] = ACTIONS(108),
    [sym_comment] = ACTIONS(72),
  },
  [50] = {
    [sym__expression] = STATE(203),
    [sym__primary_expression] = STATE(59),
    [sym_not_operator] = STATE(203),
    [sym_boolean_operator] = STATE(203),
    [sym_binary_operator] = STATE(59),
    [sym_unary_operator] = STATE(59),
    [sym_comparison_operator] = STATE(203),
    [sym_lambda] = STATE(203),
    [sym_attribute] = STATE(59),
    [sym_subscript] = STATE(59),
    [sym_call] = STATE(59),
    [sym_list] = STATE(59),
    [sym_list_comprehension] = STATE(59),
    [sym_dictionary] = STATE(59),
    [sym_dictionary_comprehension] = STATE(59),
    [sym_set] = STATE(59),
    [sym_set_comprehension] = STATE(59),
    [sym_parenthesized_expression] = STATE(59),
    [sym_tuple] = STATE(59),
    [sym_generator_expression] = STATE(59),
    [sym_conditional_expression] = STATE(203),
    [sym_concatenated_string] = STATE(59),
    [sym_await] = STATE(203),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_not] = ACTIONS(88),
    [anon_sym_PLUS] = ACTIONS(90),
    [anon_sym_DASH] = ACTIONS(90),
    [anon_sym_TILDE] = ACTIONS(90),
    [anon_sym_lambda] = ACTIONS(92),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(98),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(102),
    [sym_integer] = ACTIONS(104),
    [sym_float] = ACTIONS(104),
    [sym_identifier] = ACTIONS(104),
    [sym_true] = ACTIONS(104),
    [sym_false] = ACTIONS(104),
    [sym_none] = ACTIONS(104),
    [anon_sym_await] = ACTIONS(106),
    [sym_comment] = ACTIONS(72),
  },
  [51] = {
    [sym__primary_expression] = STATE(204),
    [sym_binary_operator] = STATE(204),
    [sym_unary_operator] = STATE(204),
    [sym_attribute] = STATE(204),
    [sym_subscript] = STATE(204),
    [sym_call] = STATE(204),
    [sym_list] = STATE(204),
    [sym_list_comprehension] = STATE(204),
    [sym_dictionary] = STATE(204),
    [sym_dictionary_comprehension] = STATE(204),
    [sym_set] = STATE(204),
    [sym_set_comprehension] = STATE(204),
    [sym_parenthesized_expression] = STATE(204),
    [sym_tuple] = STATE(204),
    [sym_generator_expression] = STATE(204),
    [sym_concatenated_string] = STATE(204),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_PLUS] = ACTIONS(90),
    [anon_sym_DASH] = ACTIONS(90),
    [anon_sym_TILDE] = ACTIONS(90),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(376),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(102),
    [sym_integer] = ACTIONS(378),
    [sym_float] = ACTIONS(378),
    [sym_identifier] = ACTIONS(378),
    [sym_true] = ACTIONS(378),
    [sym_false] = ACTIONS(378),
    [sym_none] = ACTIONS(378),
    [sym_comment] = ACTIONS(72),
  },
  [52] = {
    [sym_lambda_parameters] = STATE(206),
    [sym__parameters] = STATE(130),
    [sym_default_parameter] = STATE(131),
    [sym_typed_default_parameter] = STATE(131),
    [sym_list_splat] = STATE(132),
    [sym_dictionary_splat] = STATE(132),
    [sym_typed_parameter] = STATE(131),
    [sym_tuple] = STATE(131),
    [anon_sym_LPAREN] = ACTIONS(222),
    [anon_sym_STAR] = ACTIONS(224),
    [anon_sym_print] = ACTIONS(226),
    [anon_sym_COLON] = ACTIONS(380),
    [anon_sym_exec] = ACTIONS(226),
    [sym_identifier] = ACTIONS(230),
    [sym_comment] = ACTIONS(72),
  },
  [53] = {
    [sym_expression_list] = STATE(213),
    [sym__expression] = STATE(214),
    [sym__primary_expression] = STATE(215),
    [sym_not_operator] = STATE(214),
    [sym_boolean_operator] = STATE(214),
    [sym_binary_operator] = STATE(215),
    [sym_unary_operator] = STATE(215),
    [sym_comparison_operator] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym_attribute] = STATE(215),
    [sym_subscript] = STATE(215),
    [sym_call] = STATE(215),
    [sym_list] = STATE(215),
    [sym_list_comprehension] = STATE(215),
    [sym_dictionary] = STATE(215),
    [sym_dictionary_comprehension] = STATE(215),
    [sym_set] = STATE(215),
    [sym_set_comprehension] = STATE(215),
    [sym_parenthesized_expression] = STATE(215),
    [sym_tuple] = STATE(215),
    [sym_generator_expression] = STATE(215),
    [sym_conditional_expression] = STATE(214),
    [sym_concatenated_string] = STATE(215),
    [sym_await] = STATE(214),
    [anon_sym_from] = ACTIONS(382),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_RPAREN] = ACTIONS(232),
    [anon_sym_COMMA] = ACTIONS(232),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_not] = ACTIONS(384),
    [anon_sym_PLUS] = ACTIONS(386),
    [anon_sym_DASH] = ACTIONS(386),
    [anon_sym_TILDE] = ACTIONS(386),
    [anon_sym_lambda] = ACTIONS(388),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(390),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(392),
    [sym_integer] = ACTIONS(394),
    [sym_float] = ACTIONS(394),
    [sym_identifier] = ACTIONS(394),
    [sym_true] = ACTIONS(394),
    [sym_false] = ACTIONS(394),
    [sym_none] = ACTIONS(394),
    [anon_sym_await] = ACTIONS(396),
    [sym_comment] = ACTIONS(72),
  },
  [54] = {
    [sym_list_splat] = STATE(218),
    [sym__expression] = STATE(219),
    [sym__primary_expression] = STATE(145),
    [sym_not_operator] = STATE(219),
    [sym_boolean_operator] = STATE(219),
    [sym_binary_operator] = STATE(145),
    [sym_unary_operator] = STATE(145),
    [sym_comparison_operator] = STATE(219),
    [sym_lambda] = STATE(219),
    [sym_attribute] = STATE(145),
    [sym_subscript] = STATE(145),
    [sym_call] = STATE(145),
    [sym_list] = STATE(145),
    [sym_list_comprehension] = STATE(145),
    [sym_dictionary] = STATE(145),
    [sym_dictionary_comprehension] = STATE(145),
    [sym_set] = STATE(145),
    [sym_set_comprehension] = STATE(145),
    [sym_parenthesized_expression] = STATE(145),
    [sym_tuple] = STATE(145),
    [sym_generator_expression] = STATE(145),
    [sym_conditional_expression] = STATE(219),
    [sym_concatenated_string] = STATE(145),
    [sym_await] = STATE(219),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_COMMA] = ACTIONS(398),
    [anon_sym_STAR] = ACTIONS(238),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_not] = ACTIONS(240),
    [anon_sym_PLUS] = ACTIONS(242),
    [anon_sym_DASH] = ACTIONS(242),
    [anon_sym_TILDE] = ACTIONS(242),
    [anon_sym_lambda] = ACTIONS(244),
    [anon_sym_LBRACK] = ACTIONS(96),
    [anon_sym_RBRACK] = ACTIONS(400),
    [sym_ellipsis] = ACTIONS(248),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(250),
    [sym_integer] = ACTIONS(252),
    [sym_float] = ACTIONS(252),
    [sym_identifier] = ACTIONS(252),
    [sym_true] = ACTIONS(252),
    [sym_false] = ACTIONS(252),
    [sym_none] = ACTIONS(252),
    [anon_sym_await] = ACTIONS(254),
    [sym_comment] = ACTIONS(72),
  },
  [55] = {
    [sym_list_splat] = STATE(222),
    [sym_dictionary_splat] = STATE(223),
    [sym__expression] = STATE(224),
    [sym__primary_expression] = STATE(157),
    [sym_not_operator] = STATE(224),
    [sym_boolean_operator] = STATE(224),
    [sym_binary_operator] = STATE(157),
    [sym_unary_operator] = STATE(157),
    [sym_comparison_operator] = STATE(224),
    [sym_lambda] = STATE(224),
    [sym_attribute] = STATE(157),
    [sym_subscript] = STATE(157),
    [sym_call] = STATE(157),
    [sym_list] = STATE(157),
    [sym_list_comprehension] = STATE(157),
    [sym_dictionary] = STATE(157),
    [sym_dictionary_comprehension] = STATE(157),
    [sym_pair] = STATE(225),
    [sym_set] = STATE(157),
    [sym_set_comprehension] = STATE(157),
    [sym_parenthesized_expression] = STATE(157),
    [sym_tuple] = STATE(157),
    [sym_generator_expression] = STATE(157),
    [sym_conditional_expression] = STATE(224),
    [sym_concatenated_string] = STATE(157),
    [sym_await] = STATE(224),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_COMMA] = ACTIONS(402),
    [anon_sym_STAR] = ACTIONS(258),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_not] = ACTIONS(260),
    [anon_sym_PLUS] = ACTIONS(262),
    [anon_sym_DASH] = ACTIONS(262),
    [anon_sym_TILDE] = ACTIONS(262),
    [anon_sym_lambda] = ACTIONS(264),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(266),
    [anon_sym_LBRACE] = ACTIONS(100),
    [anon_sym_RBRACE] = ACTIONS(404),
    [sym_string] = ACTIONS(270),
    [sym_integer] = ACTIONS(272),
    [sym_float] = ACTIONS(272),
    [sym_identifier] = ACTIONS(272),
    [sym_true] = ACTIONS(272),
    [sym_false] = ACTIONS(272),
    [sym_none] = ACTIONS(272),
    [anon_sym_await] = ACTIONS(274),
    [sym_comment] = ACTIONS(72),
  },
  [56] = {
    [aux_sym_concatenated_string_repeat1] = STATE(226),
    [anon_sym_DOT] = ACTIONS(276),
    [anon_sym_LPAREN] = ACTIONS(276),
    [anon_sym_RPAREN] = ACTIONS(276),
    [anon_sym_COMMA] = ACTIONS(276),
    [anon_sym_STAR] = ACTIONS(278),
    [anon_sym_GT_GT] = ACTIONS(276),
    [anon_sym_if] = ACTIONS(276),
    [anon_sym_async] = ACTIONS(276),
    [anon_sym_for] = ACTIONS(276),
    [anon_sym_in] = ACTIONS(276),
    [anon_sym_AT] = ACTIONS(276),
    [anon_sym_not] = ACTIONS(276),
    [anon_sym_and] = ACTIONS(276),
    [anon_sym_or] = ACTIONS(276),
    [anon_sym_PLUS] = ACTIONS(276),
    [anon_sym_DASH] = ACTIONS(276),
    [anon_sym_SLASH] = ACTIONS(278),
    [anon_sym_PERCENT] = ACTIONS(276),
    [anon_sym_SLASH_SLASH] = ACTIONS(276),
    [anon_sym_STAR_STAR] = ACTIONS(276),
    [anon_sym_PIPE] = ACTIONS(276),
    [anon_sym_AMP] = ACTIONS(276),
    [anon_sym_CARET] = ACTIONS(276),
    [anon_sym_LT_LT] = ACTIONS(276),
    [anon_sym_LT] = ACTIONS(278),
    [anon_sym_LT_EQ] = ACTIONS(276),
    [anon_sym_EQ_EQ] = ACTIONS(276),
    [anon_sym_BANG_EQ] = ACTIONS(276),
    [anon_sym_GT_EQ] = ACTIONS(276),
    [anon_sym_GT] = ACTIONS(278),
    [anon_sym_LT_GT] = ACTIONS(276),
    [anon_sym_is] = ACTIONS(276),
    [anon_sym_LBRACK] = ACTIONS(276),
    [sym_string] = ACTIONS(406),
    [sym_comment] = ACTIONS(72),
  },
  [57] = {
    [sym__expression] = STATE(227),
    [sym__primary_expression] = STATE(59),
    [sym_not_operator] = STATE(227),
    [sym_boolean_operator] = STATE(227),
    [sym_binary_operator] = STATE(59),
    [sym_unary_operator] = STATE(59),
    [sym_comparison_operator] = STATE(227),
    [sym_lambda] = STATE(227),
    [sym_attribute] = STATE(59),
    [sym_subscript] = STATE(59),
    [sym_call] = STATE(59),
    [sym_list] = STATE(59),
    [sym_list_comprehension] = STATE(59),
    [sym_dictionary] = STATE(59),
    [sym_dictionary_comprehension] = STATE(59),
    [sym_set] = STATE(59),
    [sym_set_comprehension] = STATE(59),
    [sym_parenthesized_expression] = STATE(59),
    [sym_tuple] = STATE(59),
    [sym_generator_expression] = STATE(59),
    [sym_conditional_expression] = STATE(227),
    [sym_concatenated_string] = STATE(59),
    [sym_await] = STATE(227),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_not] = ACTIONS(88),
    [anon_sym_PLUS] = ACTIONS(90),
    [anon_sym_DASH] = ACTIONS(90),
    [anon_sym_TILDE] = ACTIONS(90),
    [anon_sym_lambda] = ACTIONS(92),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(98),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(102),
    [sym_integer] = ACTIONS(104),
    [sym_float] = ACTIONS(104),
    [sym_identifier] = ACTIONS(104),
    [sym_true] = ACTIONS(104),
    [sym_false] = ACTIONS(104),
    [sym_none] = ACTIONS(104),
    [anon_sym_await] = ACTIONS(106),
    [sym_comment] = ACTIONS(72),
  },
  [58] = {
    [sym__comprehension_body] = STATE(235),
    [sym_for_in_clause] = STATE(236),
    [aux_sym_tuple_repeat1] = STATE(237),
    [anon_sym_RPAREN] = ACTIONS(408),
    [anon_sym_COMMA] = ACTIONS(410),
    [anon_sym_if] = ACTIONS(412),
    [anon_sym_async] = ACTIONS(414),
    [anon_sym_for] = ACTIONS(416),
    [anon_sym_and] = ACTIONS(418),
    [anon_sym_or] = ACTIONS(420),
    [sym_comment] = ACTIONS(72),
  },
  [59] = {
    [sym_argument_list] = STATE(251),
    [sym_generator_expression] = STATE(251),
    [aux_sym_comparison_operator_repeat1] = STATE(252),
    [anon_sym_DOT] = ACTIONS(422),
    [anon_sym_LPAREN] = ACTIONS(424),
    [anon_sym_RPAREN] = ACTIONS(302),
    [anon_sym_COMMA] = ACTIONS(302),
    [anon_sym_STAR] = ACTIONS(426),
    [anon_sym_GT_GT] = ACTIONS(428),
    [anon_sym_if] = ACTIONS(302),
    [anon_sym_async] = ACTIONS(302),
    [anon_sym_for] = ACTIONS(302),
    [anon_sym_in] = ACTIONS(430),
    [anon_sym_AT] = ACTIONS(432),
    [anon_sym_not] = ACTIONS(434),
    [anon_sym_and] = ACTIONS(302),
    [anon_sym_or] = ACTIONS(302),
    [anon_sym_PLUS] = ACTIONS(436),
    [anon_sym_DASH] = ACTIONS(436),
    [anon_sym_SLASH] = ACTIONS(426),
    [anon_sym_PERCENT] = ACTIONS(432),
    [anon_sym_SLASH_SLASH] = ACTIONS(432),
    [anon_sym_STAR_STAR] = ACTIONS(438),
    [anon_sym_PIPE] = ACTIONS(440),
    [anon_sym_AMP] = ACTIONS(442),
    [anon_sym_CARET] = ACTIONS(444),
    [anon_sym_LT_LT] = ACTIONS(428),
    [anon_sym_LT] = ACTIONS(446),
    [anon_sym_LT_EQ] = ACTIONS(430),
    [anon_sym_EQ_EQ] = ACTIONS(430),
    [anon_sym_BANG_EQ] = ACTIONS(430),
    [anon_sym_GT_EQ] = ACTIONS(430),
    [anon_sym_GT] = ACTIONS(446),
    [anon_sym_LT_GT] = ACTIONS(430),
    [anon_sym_is] = ACTIONS(448),
    [anon_sym_LBRACK] = ACTIONS(450),
    [sym_comment] = ACTIONS(72),
  },
  [60] = {
    [aux_sym_tuple_repeat1] = STATE(237),
    [anon_sym_RPAREN] = ACTIONS(408),
    [anon_sym_COMMA] = ACTIONS(410),
    [sym_comment] = ACTIONS(72),
  },
  [61] = {
    [sym__expression] = STATE(255),
    [sym__primary_expression] = STATE(59),
    [sym_not_operator] = STATE(255),
    [sym_boolean_operator] = STATE(255),
    [sym_binary_operator] = STATE(59),
    [sym_unary_operator] = STATE(59),
    [sym_comparison_operator] = STATE(255),
    [sym_lambda] = STATE(255),
    [sym_yield] = STATE(256),
    [sym_attribute] = STATE(59),
    [sym_subscript] = STATE(59),
    [sym_call] = STATE(59),
    [sym_list] = STATE(59),
    [sym_list_comprehension] = STATE(59),
    [sym_dictionary] = STATE(59),
    [sym_dictionary_comprehension] = STATE(59),
    [sym_set] = STATE(59),
    [sym_set_comprehension] = STATE(59),
    [sym_parenthesized_expression] = STATE(59),
    [sym_tuple] = STATE(59),
    [sym_generator_expression] = STATE(59),
    [sym_conditional_expression] = STATE(255),
    [sym_concatenated_string] = STATE(59),
    [sym_await] = STATE(255),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_RPAREN] = ACTIONS(452),
    [anon_sym_COMMA] = ACTIONS(454),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_not] = ACTIONS(88),
    [anon_sym_PLUS] = ACTIONS(90),
    [anon_sym_DASH] = ACTIONS(90),
    [anon_sym_TILDE] = ACTIONS(90),
    [anon_sym_lambda] = ACTIONS(92),
    [anon_sym_yield] = ACTIONS(94),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(98),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(102),
    [sym_integer] = ACTIONS(104),
    [sym_float] = ACTIONS(104),
    [sym_identifier] = ACTIONS(104),
    [sym_true] = ACTIONS(104),
    [sym_false] = ACTIONS(104),
    [sym_none] = ACTIONS(104),
    [anon_sym_await] = ACTIONS(106),
    [sym_comment] = ACTIONS(72),
  },
  [62] = {
    [sym__newline] = ACTIONS(108),
    [anon_sym_DOT] = ACTIONS(108),
    [anon_sym_from] = ACTIONS(108),
    [anon_sym_LPAREN] = ACTIONS(108),
    [anon_sym_COMMA] = ACTIONS(108),
    [anon_sym_STAR] = ACTIONS(110),
    [anon_sym_GT_GT] = ACTIONS(108),
    [anon_sym_if] = ACTIONS(108),
    [anon_sym_in] = ACTIONS(108),
    [anon_sym_EQ] = ACTIONS(110),
    [anon_sym_AT] = ACTIONS(108),
    [anon_sym_not] = ACTIONS(108),
    [anon_sym_and] = ACTIONS(108),
    [anon_sym_or] = ACTIONS(108),
    [anon_sym_PLUS] = ACTIONS(108),
    [anon_sym_DASH] = ACTIONS(108),
    [anon_sym_SLASH] = ACTIONS(110),
    [anon_sym_PERCENT] = ACTIONS(108),
    [anon_sym_SLASH_SLASH] = ACTIONS(108),
    [anon_sym_STAR_STAR] = ACTIONS(108),
    [anon_sym_PIPE] = ACTIONS(108),
    [anon_sym_AMP] = ACTIONS(108),
    [anon_sym_CARET] = ACTIONS(108),
    [anon_sym_LT_LT] = ACTIONS(108),
    [anon_sym_LT] = ACTIONS(110),
    [anon_sym_LT_EQ] = ACTIONS(108),
    [anon_sym_EQ_EQ] = ACTIONS(108),
    [anon_sym_BANG_EQ] = ACTIONS(108),
    [anon_sym_GT_EQ] = ACTIONS(108),
    [anon_sym_GT] = ACTIONS(110),
    [anon_sym_LT_GT] = ACTIONS(108),
    [anon_sym_is] = ACTIONS(108),
    [anon_sym_LBRACK] = ACTIONS(108),
    [sym_comment] = ACTIONS(72),
    [sym__semicolon] = ACTIONS(108),
  },
  [63] = {
    [sym__expression] = STATE(257),
    [sym__primary_expression] = STATE(73),
    [sym_not_operator] = STATE(257),
    [sym_boolean_operator] = STATE(257),
    [sym_binary_operator] = STATE(73),
    [sym_unary_operator] = STATE(73),
    [sym_comparison_operator] = STATE(257),
    [sym_lambda] = STATE(257),
    [sym_attribute] = STATE(73),
    [sym_subscript] = STATE(73),
    [sym_call] = STATE(73),
    [sym_list] = STATE(73),
    [sym_list_comprehension] = STATE(73),
    [sym_dictionary] = STATE(73),
    [sym_dictionary_comprehension] = STATE(73),
    [sym_set] = STATE(73),
    [sym_set_comprehension] = STATE(73),
    [sym_parenthesized_expression] = STATE(73),
    [sym_tuple] = STATE(73),
    [sym_generator_expression] = STATE(73),
    [sym_conditional_expression] = STATE(257),
    [sym_concatenated_string] = STATE(73),
    [sym_await] = STATE(257),
    [anon_sym_LPAREN] = ACTIONS(130),
    [anon_sym_print] = ACTIONS(112),
    [anon_sym_exec] = ACTIONS(112),
    [anon_sym_not] = ACTIONS(132),
    [anon_sym_PLUS] = ACTIONS(116),
    [anon_sym_DASH] = ACTIONS(116),
    [anon_sym_TILDE] = ACTIONS(116),
    [anon_sym_lambda] = ACTIONS(118),
    [anon_sym_LBRACK] = ACTIONS(134),
    [sym_ellipsis] = ACTIONS(120),
    [anon_sym_LBRACE] = ACTIONS(122),
    [sym_string] = ACTIONS(124),
    [sym_integer] = ACTIONS(126),
    [sym_float] = ACTIONS(126),
    [sym_identifier] = ACTIONS(126),
    [sym_true] = ACTIONS(126),
    [sym_false] = ACTIONS(126),
    [sym_none] = ACTIONS(126),
    [anon_sym_await] = ACTIONS(128),
    [sym_comment] = ACTIONS(72),
  },
  [64] = {
    [sym__expression] = STATE(258),
    [sym__primary_expression] = STATE(73),
    [sym_not_operator] = STATE(258),
    [sym_boolean_operator] = STATE(258),
    [sym_binary_operator] = STATE(73),
    [sym_unary_operator] = STATE(73),
    [sym_comparison_operator] = STATE(258),
    [sym_lambda] = STATE(258),
    [sym_attribute] = STATE(73),
    [sym_subscript] = STATE(73),
    [sym_call] = STATE(73),
    [sym_list] = STATE(73),
    [sym_list_comprehension] = STATE(73),
    [sym_dictionary] = STATE(73),
    [sym_dictionary_comprehension] = STATE(73),
    [sym_set] = STATE(73),
    [sym_set_comprehension] = STATE(73),
    [sym_parenthesized_expression] = STATE(73),
    [sym_tuple] = STATE(73),
    [sym_generator_expression] = STATE(73),
    [sym_conditional_expression] = STATE(258),
    [sym_concatenated_string] = STATE(73),
    [sym_await] = STATE(258),
    [anon_sym_LPAREN] = ACTIONS(130),
    [anon_sym_print] = ACTIONS(112),
    [anon_sym_exec] = ACTIONS(112),
    [anon_sym_not] = ACTIONS(132),
    [anon_sym_PLUS] = ACTIONS(116),
    [anon_sym_DASH] = ACTIONS(116),
    [anon_sym_TILDE] = ACTIONS(116),
    [anon_sym_lambda] = ACTIONS(118),
    [anon_sym_LBRACK] = ACTIONS(134),
    [sym_ellipsis] = ACTIONS(120),
    [anon_sym_LBRACE] = ACTIONS(122),
    [sym_string] = ACTIONS(124),
    [sym_integer] = ACTIONS(126),
    [sym_float] = ACTIONS(126),
    [sym_identifier] = ACTIONS(126),
    [sym_true] = ACTIONS(126),
    [sym_false] = ACTIONS(126),
    [sym_none] = ACTIONS(126),
    [anon_sym_await] = ACTIONS(128),
    [sym_comment] = ACTIONS(72),
  },
  [65] = {
    [sym__primary_expression] = STATE(259),
    [sym_binary_operator] = STATE(259),
    [sym_unary_operator] = STATE(259),
    [sym_attribute] = STATE(259),
    [sym_subscript] = STATE(259),
    [sym_call] = STATE(259),
    [sym_list] = STATE(259),
    [sym_list_comprehension] = STATE(259),
    [sym_dictionary] = STATE(259),
    [sym_dictionary_comprehension] = STATE(259),
    [sym_set] = STATE(259),
    [sym_set_comprehension] = STATE(259),
    [sym_parenthesized_expression] = STATE(259),
    [sym_tuple] = STATE(259),
    [sym_generator_expression] = STATE(259),
    [sym_concatenated_string] = STATE(259),
    [anon_sym_LPAREN] = ACTIONS(130),
    [anon_sym_print] = ACTIONS(112),
    [anon_sym_exec] = ACTIONS(112),
    [anon_sym_PLUS] = ACTIONS(116),
    [anon_sym_DASH] = ACTIONS(116),
    [anon_sym_TILDE] = ACTIONS(116),
    [anon_sym_LBRACK] = ACTIONS(134),
    [sym_ellipsis] = ACTIONS(456),
    [anon_sym_LBRACE] = ACTIONS(122),
    [sym_string] = ACTIONS(124),
    [sym_integer] = ACTIONS(458),
    [sym_float] = ACTIONS(458),
    [sym_identifier] = ACTIONS(458),
    [sym_true] = ACTIONS(458),
    [sym_false] = ACTIONS(458),
    [sym_none] = ACTIONS(458),
    [sym_comment] = ACTIONS(72),
  },
  [66] = {
    [sym_lambda_parameters] = STATE(261),
    [sym__parameters] = STATE(130),
    [sym_default_parameter] = STATE(131),
    [sym_typed_default_parameter] = STATE(131),
    [sym_list_splat] = STATE(132),
    [sym_dictionary_splat] = STATE(132),
    [sym_typed_parameter] = STATE(131),
    [sym_tuple] = STATE(131),
    [anon_sym_LPAREN] = ACTIONS(222),
    [anon_sym_STAR] = ACTIONS(224),
    [anon_sym_print] = ACTIONS(226),
    [anon_sym_COLON] = ACTIONS(460),
    [anon_sym_exec] = ACTIONS(226),
    [sym_identifier] = ACTIONS(230),
    [sym_comment] = ACTIONS(72),
  },
  [67] = {
    [sym_list_splat] = STATE(264),
    [sym__expression] = STATE(265),
    [sym__primary_expression] = STATE(145),
    [sym_not_operator] = STATE(265),
    [sym_boolean_operator] = STATE(265),
    [sym_binary_operator] = STATE(145),
    [sym_unary_operator] = STATE(145),
    [sym_comparison_operator] = STATE(265),
    [sym_lambda] = STATE(265),
    [sym_attribute] = STATE(145),
    [sym_subscript] = STATE(145),
    [sym_call] = STATE(145),
    [sym_list] = STATE(145),
    [sym_list_comprehension] = STATE(145),
    [sym_dictionary] = STATE(145),
    [sym_dictionary_comprehension] = STATE(145),
    [sym_set] = STATE(145),
    [sym_set_comprehension] = STATE(145),
    [sym_parenthesized_expression] = STATE(145),
    [sym_tuple] = STATE(145),
    [sym_generator_expression] = STATE(145),
    [sym_conditional_expression] = STATE(265),
    [sym_concatenated_string] = STATE(145),
    [sym_await] = STATE(265),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_COMMA] = ACTIONS(462),
    [anon_sym_STAR] = ACTIONS(238),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_not] = ACTIONS(240),
    [anon_sym_PLUS] = ACTIONS(242),
    [anon_sym_DASH] = ACTIONS(242),
    [anon_sym_TILDE] = ACTIONS(242),
    [anon_sym_lambda] = ACTIONS(244),
    [anon_sym_LBRACK] = ACTIONS(96),
    [anon_sym_RBRACK] = ACTIONS(464),
    [sym_ellipsis] = ACTIONS(248),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(250),
    [sym_integer] = ACTIONS(252),
    [sym_float] = ACTIONS(252),
    [sym_identifier] = ACTIONS(252),
    [sym_true] = ACTIONS(252),
    [sym_false] = ACTIONS(252),
    [sym_none] = ACTIONS(252),
    [anon_sym_await] = ACTIONS(254),
    [sym_comment] = ACTIONS(72),
  },
  [68] = {
    [sym_list_splat] = STATE(268),
    [sym_dictionary_splat] = STATE(269),
    [sym__expression] = STATE(270),
    [sym__primary_expression] = STATE(157),
    [sym_not_operator] = STATE(270),
    [sym_boolean_operator] = STATE(270),
    [sym_binary_operator] = STATE(157),
    [sym_unary_operator] = STATE(157),
    [sym_comparison_operator] = STATE(270),
    [sym_lambda] = STATE(270),
    [sym_attribute] = STATE(157),
    [sym_subscript] = STATE(157),
    [sym_call] = STATE(157),
    [sym_list] = STATE(157),
    [sym_list_comprehension] = STATE(157),
    [sym_dictionary] = STATE(157),
    [sym_dictionary_comprehension] = STATE(157),
    [sym_pair] = STATE(271),
    [sym_set] = STATE(157),
    [sym_set_comprehension] = STATE(157),
    [sym_parenthesized_expression] = STATE(157),
    [sym_tuple] = STATE(157),
    [sym_generator_expression] = STATE(157),
    [sym_conditional_expression] = STATE(270),
    [sym_concatenated_string] = STATE(157),
    [sym_await] = STATE(270),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_COMMA] = ACTIONS(466),
    [anon_sym_STAR] = ACTIONS(258),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_not] = ACTIONS(260),
    [anon_sym_PLUS] = ACTIONS(262),
    [anon_sym_DASH] = ACTIONS(262),
    [anon_sym_TILDE] = ACTIONS(262),
    [anon_sym_lambda] = ACTIONS(264),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(266),
    [anon_sym_LBRACE] = ACTIONS(100),
    [anon_sym_RBRACE] = ACTIONS(468),
    [sym_string] = ACTIONS(270),
    [sym_integer] = ACTIONS(272),
    [sym_float] = ACTIONS(272),
    [sym_identifier] = ACTIONS(272),
    [sym_true] = ACTIONS(272),
    [sym_false] = ACTIONS(272),
    [sym_none] = ACTIONS(272),
    [anon_sym_await] = ACTIONS(274),
    [sym_comment] = ACTIONS(72),
  },
  [69] = {
    [aux_sym_concatenated_string_repeat1] = STATE(272),
    [sym__newline] = ACTIONS(276),
    [anon_sym_DOT] = ACTIONS(276),
    [anon_sym_LPAREN] = ACTIONS(276),
    [anon_sym_COMMA] = ACTIONS(276),
    [anon_sym_STAR] = ACTIONS(278),
    [anon_sym_GT_GT] = ACTIONS(276),
    [anon_sym_if] = ACTIONS(276),
    [anon_sym_in] = ACTIONS(276),
    [anon_sym_AT] = ACTIONS(276),
    [anon_sym_not] = ACTIONS(276),
    [anon_sym_and] = ACTIONS(276),
    [anon_sym_or] = ACTIONS(276),
    [anon_sym_PLUS] = ACTIONS(276),
    [anon_sym_DASH] = ACTIONS(276),
    [anon_sym_SLASH] = ACTIONS(278),
    [anon_sym_PERCENT] = ACTIONS(276),
    [anon_sym_SLASH_SLASH] = ACTIONS(276),
    [anon_sym_STAR_STAR] = ACTIONS(276),
    [anon_sym_PIPE] = ACTIONS(276),
    [anon_sym_AMP] = ACTIONS(276),
    [anon_sym_CARET] = ACTIONS(276),
    [anon_sym_LT_LT] = ACTIONS(276),
    [anon_sym_LT] = ACTIONS(278),
    [anon_sym_LT_EQ] = ACTIONS(276),
    [anon_sym_EQ_EQ] = ACTIONS(276),
    [anon_sym_BANG_EQ] = ACTIONS(276),
    [anon_sym_GT_EQ] = ACTIONS(276),
    [anon_sym_GT] = ACTIONS(278),
    [anon_sym_LT_GT] = ACTIONS(276),
    [anon_sym_is] = ACTIONS(276),
    [anon_sym_LBRACK] = ACTIONS(276),
    [sym_string] = ACTIONS(470),
    [sym_comment] = ACTIONS(72),
    [sym__semicolon] = ACTIONS(276),
  },
  [70] = {
    [sym__expression] = STATE(160),
    [sym__primary_expression] = STATE(73),
    [sym_not_operator] = STATE(160),
    [sym_boolean_operator] = STATE(160),
    [sym_binary_operator] = STATE(73),
    [sym_unary_operator] = STATE(73),
    [sym_comparison_operator] = STATE(160),
    [sym_lambda] = STATE(160),
    [sym_attribute] = STATE(73),
    [sym_subscript] = STATE(73),
    [sym_call] = STATE(73),
    [sym_list] = STATE(73),
    [sym_list_comprehension] = STATE(73),
    [sym_dictionary] = STATE(73),
    [sym_dictionary_comprehension] = STATE(73),
    [sym_set] = STATE(73),
    [sym_set_comprehension] = STATE(73),
    [sym_parenthesized_expression] = STATE(73),
    [sym_tuple] = STATE(73),
    [sym_generator_expression] = STATE(73),
    [sym_conditional_expression] = STATE(160),
    [sym_concatenated_string] = STATE(73),
    [sym_await] = STATE(160),
    [anon_sym_LPAREN] = ACTIONS(130),
    [anon_sym_print] = ACTIONS(112),
    [anon_sym_exec] = ACTIONS(112),
    [anon_sym_not] = ACTIONS(132),
    [anon_sym_PLUS] = ACTIONS(116),
    [anon_sym_DASH] = ACTIONS(116),
    [anon_sym_TILDE] = ACTIONS(116),
    [anon_sym_lambda] = ACTIONS(118),
    [anon_sym_LBRACK] = ACTIONS(134),
    [sym_ellipsis] = ACTIONS(120),
    [anon_sym_LBRACE] = ACTIONS(122),
    [sym_string] = ACTIONS(124),
    [sym_integer] = ACTIONS(126),
    [sym_float] = ACTIONS(126),
    [sym_identifier] = ACTIONS(126),
    [sym_true] = ACTIONS(126),
    [sym_false] = ACTIONS(126),
    [sym_none] = ACTIONS(126),
    [anon_sym_await] = ACTIONS(128),
    [sym_comment] = ACTIONS(72),
  },
  [71] = {
    [aux_sym_print_statement_repeat1] = STATE(274),
    [sym__newline] = ACTIONS(472),
    [anon_sym_COMMA] = ACTIONS(474),
    [sym_comment] = ACTIONS(72),
    [sym__semicolon] = ACTIONS(472),
  },
  [72] = {
    [aux_sym_print_statement_repeat1] = STATE(274),
    [sym__newline] = ACTIONS(472),
    [anon_sym_COMMA] = ACTIONS(474),
    [anon_sym_if] = ACTIONS(476),
    [anon_sym_and] = ACTIONS(478),
    [anon_sym_or] = ACTIONS(480),
    [sym_comment] = ACTIONS(72),
    [sym__semicolon] = ACTIONS(472),
  },
  [73] = {
    [sym_argument_list] = STATE(291),
    [sym_generator_expression] = STATE(291),
    [aux_sym_comparison_operator_repeat1] = STATE(292),
    [sym__newline] = ACTIONS(302),
    [anon_sym_DOT] = ACTIONS(482),
    [anon_sym_LPAREN] = ACTIONS(484),
    [anon_sym_COMMA] = ACTIONS(302),
    [anon_sym_STAR] = ACTIONS(486),
    [anon_sym_GT_GT] = ACTIONS(488),
    [anon_sym_if] = ACTIONS(302),
    [anon_sym_in] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(492),
    [anon_sym_not] = ACTIONS(494),
    [anon_sym_and] = ACTIONS(302),
    [anon_sym_or] = ACTIONS(302),
    [anon_sym_PLUS] = ACTIONS(496),
    [anon_sym_DASH] = ACTIONS(496),
    [anon_sym_SLASH] = ACTIONS(486),
    [anon_sym_PERCENT] = ACTIONS(492),
    [anon_sym_SLASH_SLASH] = ACTIONS(492),
    [anon_sym_STAR_STAR] = ACTIONS(498),
    [anon_sym_PIPE] = ACTIONS(500),
    [anon_sym_AMP] = ACTIONS(502),
    [anon_sym_CARET] = ACTIONS(504),
    [anon_sym_LT_LT] = ACTIONS(488),
    [anon_sym_LT] = ACTIONS(506),
    [anon_sym_LT_EQ] = ACTIONS(490),
    [anon_sym_EQ_EQ] = ACTIONS(490),
    [anon_sym_BANG_EQ] = ACTIONS(490),
    [anon_sym_GT_EQ] = ACTIONS(490),
    [anon_sym_GT] = ACTIONS(506),
    [anon_sym_LT_GT] = ACTIONS(490),
    [anon_sym_is] = ACTIONS(508),
    [anon_sym_LBRACK] = ACTIONS(510),
    [sym_comment] = ACTIONS(72),
    [sym__semicolon] = ACTIONS(302),
  },
  [74] = {
    [aux_sym_print_statement_repeat1] = STATE(294),
    [sym__newline] = ACTIONS(512),
    [anon_sym_COMMA] = ACTIONS(514),
    [anon_sym_if] = ACTIONS(476),
    [anon_sym_and] = ACTIONS(478),
    [anon_sym_or] = ACTIONS(480),
    [sym_comment] = ACTIONS(72),
    [sym__semicolon] = ACTIONS(512),
  },
  [75] = {
    [sym__newline] = ACTIONS(516),
    [sym_comment] = ACTIONS(72),
    [sym__semicolon] = ACTIONS(516),
  },
  [76] = {
    [aux_sym_print_statement_repeat1] = STATE(296),
    [sym__newline] = ACTIONS(296),
    [anon_sym_COMMA] = ACTIONS(518),
    [anon_sym_if] = ACTIONS(476),
    [anon_sym_and] = ACTIONS(478),
    [anon_sym_or] = ACTIONS(480),
    [sym_comment] = ACTIONS(72),
    [sym__semicolon] = ACTIONS(296),
  },
  [77] = {
    [sym__newline] = ACTIONS(520),
    [sym_comment] = ACTIONS(72),
    [sym__semicolon] = ACTIONS(520),
  },
  [78] = {
    [sym__expression] = STATE(302),
    [sym__primary_expression] = STATE(303),
    [sym_not_operator] = STATE(302),
    [sym_boolean_operator] = STATE(302),
    [sym_binary_operator] = STATE(303),
    [sym_unary_operator] = STATE(303),
    [sym_comparison_operator] = STATE(302),
    [sym_lambda] = STATE(302),
    [sym_attribute] = STATE(303),
    [sym_subscript] = STATE(303),
    [sym_call] = STATE(303),
    [sym_list] = STATE(303),
    [sym_list_comprehension] = STATE(303),
    [sym_dictionary] = STATE(303),
    [sym_dictionary_comprehension] = STATE(303),
    [sym_set] = STATE(303),
    [sym_set_comprehension] = STATE(303),
    [sym_parenthesized_expression] = STATE(303),
    [sym_tuple] = STATE(303),
    [sym_generator_expression] = STATE(303),
    [sym_conditional_expression] = STATE(302),
    [sym_concatenated_string] = STATE(303),
    [sym_await] = STATE(302),
    [anon_sym_LPAREN] = ACTIONS(130),
    [anon_sym_print] = ACTIONS(112),
    [anon_sym_exec] = ACTIONS(112),
    [anon_sym_not] = ACTIONS(522),
    [anon_sym_PLUS] = ACTIONS(524),
    [anon_sym_DASH] = ACTIONS(524),
    [anon_sym_TILDE] = ACTIONS(524),
    [anon_sym_lambda] = ACTIONS(526),
    [anon_sym_LBRACK] = ACTIONS(134),
    [sym_ellipsis] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(122),
    [sym_string] = ACTIONS(530),
    [sym_integer] = ACTIONS(532),
    [sym_float] = ACTIONS(532),
    [sym_identifier] = ACTIONS(532),
    [sym_true] = ACTIONS(532),
    [sym_false] = ACTIONS(532),
    [sym_none] = ACTIONS(532),
    [anon_sym_await] = ACTIONS(534),
    [sym_comment] = ACTIONS(72),
  },
  [79] = {
    [sym__expression] = STATE(304),
    [sym__primary_expression] = STATE(86),
    [sym_not_operator] = STATE(304),
    [sym_boolean_operator] = STATE(304),
    [sym_binary_operator] = STATE(86),
    [sym_unary_operator] = STATE(86),
    [sym_comparison_operator] = STATE(304),
    [sym_lambda] = STATE(304),
    [sym_attribute] = STATE(86),
    [sym_subscript] = STATE(86),
    [sym_call] = STATE(86),
    [sym_list] = STATE(86),
    [sym_list_comprehension] = STATE(86),
    [sym_dictionary] = STATE(86),
    [sym_dictionary_comprehension] = STATE(86),
    [sym_set] = STATE(86),
    [sym_set_comprehension] = STATE(86),
    [sym_parenthesized_expression] = STATE(86),
    [sym_tuple] = STATE(86),
    [sym_generator_expression] = STATE(86),
    [sym_conditional_expression] = STATE(304),
    [sym_concatenated_string] = STATE(86),
    [sym_await] = STATE(304),
    [anon_sym_LPAREN] = ACTIONS(130),
    [anon_sym_print] = ACTIONS(112),
    [anon_sym_exec] = ACTIONS(112),
    [anon_sym_not] = ACTIONS(142),
    [anon_sym_PLUS] = ACTIONS(144),
    [anon_sym_DASH] = ACTIONS(144),
    [anon_sym_TILDE] = ACTIONS(144),
    [anon_sym_lambda] = ACTIONS(146),
    [anon_sym_LBRACK] = ACTIONS(134),
    [sym_ellipsis] = ACTIONS(148),
    [anon_sym_LBRACE] = ACTIONS(122),
    [sym_string] = ACTIONS(150),
    [sym_integer] = ACTIONS(152),
    [sym_float] = ACTIONS(152),
    [sym_identifier] = ACTIONS(152),
    [sym_true] = ACTIONS(152),
    [sym_false] = ACTIONS(152),
    [sym_none] = ACTIONS(152),
    [anon_sym_await] = ACTIONS(154),
    [sym_comment] = ACTIONS(72),
  },
  [80] = {
    [sym__primary_expression] = STATE(259),
    [sym_binary_operator] = STATE(259),
    [sym_unary_operator] = STATE(259),
    [sym_attribute] = STATE(259),
    [sym_subscript] = STATE(259),
    [sym_call] = STATE(259),
    [sym_list] = STATE(259),
    [sym_list_comprehension] = STATE(259),
    [sym_dictionary] = STATE(259),
    [sym_dictionary_comprehension] = STATE(259),
    [sym_set] = STATE(259),
    [sym_set_comprehension] = STATE(259),
    [sym_parenthesized_expression] = STATE(259),
    [sym_tuple] = STATE(259),
    [sym_generator_expression] = STATE(259),
    [sym_concatenated_string] = STATE(259),
    [anon_sym_LPAREN] = ACTIONS(130),
    [anon_sym_print] = ACTIONS(112),
    [anon_sym_exec] = ACTIONS(112),
    [anon_sym_PLUS] = ACTIONS(144),
    [anon_sym_DASH] = ACTIONS(144),
    [anon_sym_TILDE] = ACTIONS(144),
    [anon_sym_LBRACK] = ACTIONS(134),
    [sym_ellipsis] = ACTIONS(456),
    [anon_sym_LBRACE] = ACTIONS(122),
    [sym_string] = ACTIONS(150),
    [sym_integer] = ACTIONS(458),
    [sym_float] = ACTIONS(458),
    [sym_identifier] = ACTIONS(458),
    [sym_true] = ACTIONS(458),
    [sym_false] = ACTIONS(458),
    [sym_none] = ACTIONS(458),
    [sym_comment] = ACTIONS(72),
  },
  [81] = {
    [sym_lambda_parameters] = STATE(306),
    [sym__parameters] = STATE(130),
    [sym_default_parameter] = STATE(131),
    [sym_typed_default_parameter] = STATE(131),
    [sym_list_splat] = STATE(132),
    [sym_dictionary_splat] = STATE(132),
    [sym_typed_parameter] = STATE(131),
    [sym_tuple] = STATE(131),
    [anon_sym_LPAREN] = ACTIONS(222),
    [anon_sym_STAR] = ACTIONS(224),
    [anon_sym_print] = ACTIONS(226),
    [anon_sym_COLON] = ACTIONS(536),
    [anon_sym_exec] = ACTIONS(226),
    [sym_identifier] = ACTIONS(230),
    [sym_comment] = ACTIONS(72),
  },
  [82] = {
    [aux_sym_concatenated_string_repeat1] = STATE(307),
    [sym__newline] = ACTIONS(276),
    [anon_sym_DOT] = ACTIONS(276),
    [anon_sym_from] = ACTIONS(276),
    [anon_sym_LPAREN] = ACTIONS(276),
    [anon_sym_COMMA] = ACTIONS(276),
    [anon_sym_STAR] = ACTIONS(278),
    [anon_sym_GT_GT] = ACTIONS(276),
    [anon_sym_if] = ACTIONS(276),
    [anon_sym_in] = ACTIONS(276),
    [anon_sym_AT] = ACTIONS(276),
    [anon_sym_not] = ACTIONS(276),
    [anon_sym_and] = ACTIONS(276),
    [anon_sym_or] = ACTIONS(276),
    [anon_sym_PLUS] = ACTIONS(276),
    [anon_sym_DASH] = ACTIONS(276),
    [anon_sym_SLASH] = ACTIONS(278),
    [anon_sym_PERCENT] = ACTIONS(276),
    [anon_sym_SLASH_SLASH] = ACTIONS(276),
    [anon_sym_STAR_STAR] = ACTIONS(276),
    [anon_sym_PIPE] = ACTIONS(276),
    [anon_sym_AMP] = ACTIONS(276),
    [anon_sym_CARET] = ACTIONS(276),
    [anon_sym_LT_LT] = ACTIONS(276),
    [anon_sym_LT] = ACTIONS(278),
    [anon_sym_LT_EQ] = ACTIONS(276),
    [anon_sym_EQ_EQ] = ACTIONS(276),
    [anon_sym_BANG_EQ] = ACTIONS(276),
    [anon_sym_GT_EQ] = ACTIONS(276),
    [anon_sym_GT] = ACTIONS(278),
    [anon_sym_LT_GT] = ACTIONS(276),
    [anon_sym_is] = ACTIONS(276),
    [anon_sym_LBRACK] = ACTIONS(276),
    [sym_string] = ACTIONS(538),
    [sym_comment] = ACTIONS(72),
    [sym__semicolon] = ACTIONS(276),
  },
  [83] = {
    [sym__expression] = STATE(160),
    [sym__primary_expression] = STATE(86),
    [sym_not_operator] = STATE(160),
    [sym_boolean_operator] = STATE(160),
    [sym_binary_operator] = STATE(86),
    [sym_unary_operator] = STATE(86),
    [sym_comparison_operator] = STATE(160),
    [sym_lambda] = STATE(160),
    [sym_attribute] = STATE(86),
    [sym_subscript] = STATE(86),
    [sym_call] = STATE(86),
    [sym_list] = STATE(86),
    [sym_list_comprehension] = STATE(86),
    [sym_dictionary] = STATE(86),
    [sym_dictionary_comprehension] = STATE(86),
    [sym_set] = STATE(86),
    [sym_set_comprehension] = STATE(86),
    [sym_parenthesized_expression] = STATE(86),
    [sym_tuple] = STATE(86),
    [sym_generator_expression] = STATE(86),
    [sym_conditional_expression] = STATE(160),
    [sym_concatenated_string] = STATE(86),
    [sym_await] = STATE(160),
    [anon_sym_LPAREN] = ACTIONS(130),
    [anon_sym_print] = ACTIONS(112),
    [anon_sym_exec] = ACTIONS(112),
    [anon_sym_not] = ACTIONS(142),
    [anon_sym_PLUS] = ACTIONS(144),
    [anon_sym_DASH] = ACTIONS(144),
    [anon_sym_TILDE] = ACTIONS(144),
    [anon_sym_lambda] = ACTIONS(146),
    [anon_sym_LBRACK] = ACTIONS(134),
    [sym_ellipsis] = ACTIONS(148),
    [anon_sym_LBRACE] = ACTIONS(122),
    [sym_string] = ACTIONS(150),
    [sym_integer] = ACTIONS(152),
    [sym_float] = ACTIONS(152),
    [sym_identifier] = ACTIONS(152),
    [sym_true] = ACTIONS(152),
    [sym_false] = ACTIONS(152),
    [sym_none] = ACTIONS(152),
    [anon_sym_await] = ACTIONS(154),
    [sym_comment] = ACTIONS(72),
  },
  [84] = {
    [sym__newline] = ACTIONS(540),
    [anon_sym_from] = ACTIONS(542),
    [sym_comment] = ACTIONS(72),
    [sym__semicolon] = ACTIONS(540),
  },
  [85] = {
    [aux_sym_print_statement_repeat1] = STATE(313),
    [sym__newline] = ACTIONS(296),
    [anon_sym_from] = ACTIONS(296),
    [anon_sym_COMMA] = ACTIONS(544),
    [anon_sym_if] = ACTIONS(546),
    [anon_sym_and] = ACTIONS(548),
    [anon_sym_or] = ACTIONS(550),
    [sym_comment] = ACTIONS(72),
    [sym__semicolon] = ACTIONS(296),
  },
  [86] = {
    [sym_argument_list] = STATE(291),
    [sym_generator_expression] = STATE(291),
    [aux_sym_comparison_operator_repeat1] = STATE(324),
    [sym__newline] = ACTIONS(302),
    [anon_sym_DOT] = ACTIONS(482),
    [anon_sym_from] = ACTIONS(302),
    [anon_sym_LPAREN] = ACTIONS(484),
    [anon_sym_COMMA] = ACTIONS(302),
    [anon_sym_STAR] = ACTIONS(552),
    [anon_sym_GT_GT] = ACTIONS(554),
    [anon_sym_if] = ACTIONS(302),
    [anon_sym_in] = ACTIONS(556),
    [anon_sym_AT] = ACTIONS(558),
    [anon_sym_not] = ACTIONS(560),
    [anon_sym_and] = ACTIONS(302),
    [anon_sym_or] = ACTIONS(302),
    [anon_sym_PLUS] = ACTIONS(562),
    [anon_sym_DASH] = ACTIONS(562),
    [anon_sym_SLASH] = ACTIONS(552),
    [anon_sym_PERCENT] = ACTIONS(558),
    [anon_sym_SLASH_SLASH] = ACTIONS(558),
    [anon_sym_STAR_STAR] = ACTIONS(564),
    [anon_sym_PIPE] = ACTIONS(566),
    [anon_sym_AMP] = ACTIONS(568),
    [anon_sym_CARET] = ACTIONS(570),
    [anon_sym_LT_LT] = ACTIONS(554),
    [anon_sym_LT] = ACTIONS(572),
    [anon_sym_LT_EQ] = ACTIONS(556),
    [anon_sym_EQ_EQ] = ACTIONS(556),
    [anon_sym_BANG_EQ] = ACTIONS(556),
    [anon_sym_GT_EQ] = ACTIONS(556),
    [anon_sym_GT] = ACTIONS(572),
    [anon_sym_LT_GT] = ACTIONS(556),
    [anon_sym_is] = ACTIONS(574),
    [anon_sym_LBRACK] = ACTIONS(510),
    [sym_comment] = ACTIONS(72),
    [sym__semicolon] = ACTIONS(302),
  },
  [87] = {
    [ts_builtin_sym_end] = ACTIONS(576),
    [anon_sym_import] = ACTIONS(578),
    [anon_sym_from] = ACTIONS(578),
    [anon_sym_LPAREN] = ACTIONS(576),
    [anon_sym_print] = ACTIONS(578),
    [anon_sym_assert] = ACTIONS(578),
    [anon_sym_return] = ACTIONS(578),
    [anon_sym_del] = ACTIONS(578),
    [anon_sym_raise] = ACTIONS(578),
    [sym_pass_statement] = ACTIONS(578),
    [sym_break_statement] = ACTIONS(578),
    [sym_continue_statement] = ACTIONS(578),
    [anon_sym_if] = ACTIONS(578),
    [anon_sym_async] = ACTIONS(578),
    [anon_sym_for] = ACTIONS(578),
    [anon_sym_while] = ACTIONS(578),
    [anon_sym_try] = ACTIONS(578),
    [anon_sym_with] = ACTIONS(578),
    [anon_sym_def] = ACTIONS(578),
    [anon_sym_global] = ACTIONS(578),
    [anon_sym_nonlocal] = ACTIONS(578),
    [anon_sym_exec] = ACTIONS(578),
    [anon_sym_class] = ACTIONS(578),
    [anon_sym_AT] = ACTIONS(576),
    [anon_sym_not] = ACTIONS(578),
    [anon_sym_PLUS] = ACTIONS(576),
    [anon_sym_DASH] = ACTIONS(576),
    [anon_sym_TILDE] = ACTIONS(576),
    [anon_sym_lambda] = ACTIONS(578),
    [anon_sym_yield] = ACTIONS(578),
    [anon_sym_LBRACK] = ACTIONS(576),
    [sym_ellipsis] = ACTIONS(576),
    [anon_sym_LBRACE] = ACTIONS(576),
    [sym_string] = ACTIONS(576),
    [sym_integer] = ACTIONS(578),
    [sym_float] = ACTIONS(578),
    [sym_identifier] = ACTIONS(578),
    [sym_true] = ACTIONS(578),
    [sym_false] = ACTIONS(578),
    [sym_none] = ACTIONS(578),
    [anon_sym_await] = ACTIONS(578),
    [sym_comment] = ACTIONS(72),
  },
  [88] = {
    [sym_import_statement] = STATE(326),
    [sym_import_from_statement] = STATE(326),
    [sym_print_statement] = STATE(326),
    [sym_assert_statement] = STATE(326),
    [sym_expression_statement] = STATE(326),
    [sym_return_statement] = STATE(326),
    [sym_delete_statement] = STATE(326),
    [sym_raise_statement] = STATE(326),
    [sym_global_statement] = STATE(326),
    [sym_nonlocal_statement] = STATE(326),
    [sym_exec_statement] = STATE(326),
    [sym_expression_list] = STATE(32),
    [sym__expression] = STATE(33),
    [sym__primary_expression] = STATE(34),
    [sym_not_operator] = STATE(33),
    [sym_boolean_operator] = STATE(33),
    [sym_binary_operator] = STATE(34),
    [sym_unary_operator] = STATE(34),
    [sym_comparison_operator] = STATE(33),
    [sym_lambda] = STATE(33),
    [sym_assignment] = STATE(35),
    [sym_augmented_assignment] = STATE(35),
    [sym_yield] = STATE(35),
    [sym_attribute] = STATE(34),
    [sym_subscript] = STATE(34),
    [sym_call] = STATE(34),
    [sym_list] = STATE(34),
    [sym_list_comprehension] = STATE(34),
    [sym_dictionary] = STATE(34),
    [sym_dictionary_comprehension] = STATE(34),
    [sym_set] = STATE(34),
    [sym_set_comprehension] = STATE(34),
    [sym_parenthesized_expression] = STATE(34),
    [sym_tuple] = STATE(34),
    [sym_generator_expression] = STATE(34),
    [sym_conditional_expression] = STATE(33),
    [sym_concatenated_string] = STATE(34),
    [sym_await] = STATE(33),
    [sym__newline] = ACTIONS(580),
    [anon_sym_import] = ACTIONS(10),
    [anon_sym_from] = ACTIONS(12),
    [anon_sym_LPAREN] = ACTIONS(14),
    [anon_sym_print] = ACTIONS(16),
    [anon_sym_assert] = ACTIONS(18),
    [anon_sym_return] = ACTIONS(20),
    [anon_sym_del] = ACTIONS(22),
    [anon_sym_raise] = ACTIONS(24),
    [sym_pass_statement] = ACTIONS(582),
    [sym_break_statement] = ACTIONS(582),
    [sym_continue_statement] = ACTIONS(582),
    [anon_sym_global] = ACTIONS(42),
    [anon_sym_nonlocal] = ACTIONS(44),
    [anon_sym_exec] = ACTIONS(46),
    [anon_sym_not] = ACTIONS(52),
    [anon_sym_PLUS] = ACTIONS(54),
    [anon_sym_DASH] = ACTIONS(54),
    [anon_sym_TILDE] = ACTIONS(54),
    [anon_sym_lambda] = ACTIONS(56),
    [anon_sym_yield] = ACTIONS(58),
    [anon_sym_LBRACK] = ACTIONS(60),
    [sym_ellipsis] = ACTIONS(62),
    [anon_sym_LBRACE] = ACTIONS(64),
    [sym_string] = ACTIONS(66),
    [sym_integer] = ACTIONS(68),
    [sym_float] = ACTIONS(68),
    [sym_identifier] = ACTIONS(68),
    [sym_true] = ACTIONS(68),
    [sym_false] = ACTIONS(68),
    [sym_none] = ACTIONS(68),
    [anon_sym_await] = ACTIONS(70),
    [sym_comment] = ACTIONS(72),
  },
  [89] = {
    [aux_sym__simple_statements_repeat1] = STATE(328),
    [sym__newline] = ACTIONS(580),
    [sym_comment] = ACTIONS(72),
    [sym__semicolon] = ACTIONS(584),
  },
  [90] = {
    [sym__expression] = STATE(329),
    [sym__primary_expression] = STATE(96),
    [sym_not_operator] = STATE(329),
    [sym_boolean_operator] = STATE(329),
    [sym_binary_operator] = STATE(96),
    [sym_unary_operator] = STATE(96),
    [sym_comparison_operator] = STATE(329),
    [sym_lambda] = STATE(329),
    [sym_attribute] = STATE(96),
    [sym_subscript] = STATE(96),
    [sym_call] = STATE(96),
    [sym_list] = STATE(96),
    [sym_list_comprehension] = STATE(96),
    [sym_dictionary] = STATE(96),
    [sym_dictionary_comprehension] = STATE(96),
    [sym_set] = STATE(96),
    [sym_set_comprehension] = STATE(96),
    [sym_parenthesized_expression] = STATE(96),
    [sym_tuple] = STATE(96),
    [sym_generator_expression] = STATE(96),
    [sym_conditional_expression] = STATE(329),
    [sym_concatenated_string] = STATE(96),
    [sym_await] = STATE(329),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_not] = ACTIONS(160),
    [anon_sym_PLUS] = ACTIONS(162),
    [anon_sym_DASH] = ACTIONS(162),
    [anon_sym_TILDE] = ACTIONS(162),
    [anon_sym_lambda] = ACTIONS(164),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(166),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(168),
    [sym_integer] = ACTIONS(170),
    [sym_float] = ACTIONS(170),
    [sym_identifier] = ACTIONS(170),
    [sym_true] = ACTIONS(170),
    [sym_false] = ACTIONS(170),
    [sym_none] = ACTIONS(170),
    [anon_sym_await] = ACTIONS(172),
    [sym_comment] = ACTIONS(72),
  },
  [91] = {
    [sym__primary_expression] = STATE(204),
    [sym_binary_operator] = STATE(204),
    [sym_unary_operator] = STATE(204),
    [sym_attribute] = STATE(204),
    [sym_subscript] = STATE(204),
    [sym_call] = STATE(204),
    [sym_list] = STATE(204),
    [sym_list_comprehension] = STATE(204),
    [sym_dictionary] = STATE(204),
    [sym_dictionary_comprehension] = STATE(204),
    [sym_set] = STATE(204),
    [sym_set_comprehension] = STATE(204),
    [sym_parenthesized_expression] = STATE(204),
    [sym_tuple] = STATE(204),
    [sym_generator_expression] = STATE(204),
    [sym_concatenated_string] = STATE(204),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_PLUS] = ACTIONS(162),
    [anon_sym_DASH] = ACTIONS(162),
    [anon_sym_TILDE] = ACTIONS(162),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(376),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(168),
    [sym_integer] = ACTIONS(378),
    [sym_float] = ACTIONS(378),
    [sym_identifier] = ACTIONS(378),
    [sym_true] = ACTIONS(378),
    [sym_false] = ACTIONS(378),
    [sym_none] = ACTIONS(378),
    [sym_comment] = ACTIONS(72),
  },
  [92] = {
    [sym_lambda_parameters] = STATE(331),
    [sym__parameters] = STATE(130),
    [sym_default_parameter] = STATE(131),
    [sym_typed_default_parameter] = STATE(131),
    [sym_list_splat] = STATE(132),
    [sym_dictionary_splat] = STATE(132),
    [sym_typed_parameter] = STATE(131),
    [sym_tuple] = STATE(131),
    [anon_sym_LPAREN] = ACTIONS(222),
    [anon_sym_STAR] = ACTIONS(224),
    [anon_sym_print] = ACTIONS(226),
    [anon_sym_COLON] = ACTIONS(586),
    [anon_sym_exec] = ACTIONS(226),
    [sym_identifier] = ACTIONS(230),
    [sym_comment] = ACTIONS(72),
  },
  [93] = {
    [aux_sym_concatenated_string_repeat1] = STATE(332),
    [anon_sym_DOT] = ACTIONS(276),
    [anon_sym_LPAREN] = ACTIONS(276),
    [anon_sym_STAR] = ACTIONS(278),
    [anon_sym_GT_GT] = ACTIONS(276),
    [anon_sym_if] = ACTIONS(276),
    [anon_sym_COLON] = ACTIONS(276),
    [anon_sym_in] = ACTIONS(276),
    [anon_sym_AT] = ACTIONS(276),
    [anon_sym_not] = ACTIONS(276),
    [anon_sym_and] = ACTIONS(276),
    [anon_sym_or] = ACTIONS(276),
    [anon_sym_PLUS] = ACTIONS(276),
    [anon_sym_DASH] = ACTIONS(276),
    [anon_sym_SLASH] = ACTIONS(278),
    [anon_sym_PERCENT] = ACTIONS(276),
    [anon_sym_SLASH_SLASH] = ACTIONS(276),
    [anon_sym_STAR_STAR] = ACTIONS(276),
    [anon_sym_PIPE] = ACTIONS(276),
    [anon_sym_AMP] = ACTIONS(276),
    [anon_sym_CARET] = ACTIONS(276),
    [anon_sym_LT_LT] = ACTIONS(276),
    [anon_sym_LT] = ACTIONS(278),
    [anon_sym_LT_EQ] = ACTIONS(276),
    [anon_sym_EQ_EQ] = ACTIONS(276),
    [anon_sym_BANG_EQ] = ACTIONS(276),
    [anon_sym_GT_EQ] = ACTIONS(276),
    [anon_sym_GT] = ACTIONS(278),
    [anon_sym_LT_GT] = ACTIONS(276),
    [anon_sym_is] = ACTIONS(276),
    [anon_sym_LBRACK] = ACTIONS(276),
    [sym_string] = ACTIONS(588),
    [sym_comment] = ACTIONS(72),
  },
  [94] = {
    [sym__expression] = STATE(227),
    [sym__primary_expression] = STATE(96),
    [sym_not_operator] = STATE(227),
    [sym_boolean_operator] = STATE(227),
    [sym_binary_operator] = STATE(96),
    [sym_unary_operator] = STATE(96),
    [sym_comparison_operator] = STATE(227),
    [sym_lambda] = STATE(227),
    [sym_attribute] = STATE(96),
    [sym_subscript] = STATE(96),
    [sym_call] = STATE(96),
    [sym_list] = STATE(96),
    [sym_list_comprehension] = STATE(96),
    [sym_dictionary] = STATE(96),
    [sym_dictionary_comprehension] = STATE(96),
    [sym_set] = STATE(96),
    [sym_set_comprehension] = STATE(96),
    [sym_parenthesized_expression] = STATE(96),
    [sym_tuple] = STATE(96),
    [sym_generator_expression] = STATE(96),
    [sym_conditional_expression] = STATE(227),
    [sym_concatenated_string] = STATE(96),
    [sym_await] = STATE(227),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_not] = ACTIONS(160),
    [anon_sym_PLUS] = ACTIONS(162),
    [anon_sym_DASH] = ACTIONS(162),
    [anon_sym_TILDE] = ACTIONS(162),
    [anon_sym_lambda] = ACTIONS(164),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(166),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(168),
    [sym_integer] = ACTIONS(170),
    [sym_float] = ACTIONS(170),
    [sym_identifier] = ACTIONS(170),
    [sym_true] = ACTIONS(170),
    [sym_false] = ACTIONS(170),
    [sym_none] = ACTIONS(170),
    [anon_sym_await] = ACTIONS(172),
    [sym_comment] = ACTIONS(72),
  },
  [95] = {
    [anon_sym_if] = ACTIONS(590),
    [anon_sym_COLON] = ACTIONS(592),
    [anon_sym_and] = ACTIONS(594),
    [anon_sym_or] = ACTIONS(596),
    [sym_comment] = ACTIONS(72),
  },
  [96] = {
    [sym_argument_list] = STATE(251),
    [sym_generator_expression] = STATE(251),
    [aux_sym_comparison_operator_repeat1] = STATE(347),
    [anon_sym_DOT] = ACTIONS(422),
    [anon_sym_LPAREN] = ACTIONS(424),
    [anon_sym_STAR] = ACTIONS(598),
    [anon_sym_GT_GT] = ACTIONS(600),
    [anon_sym_if] = ACTIONS(302),
    [anon_sym_COLON] = ACTIONS(302),
    [anon_sym_in] = ACTIONS(602),
    [anon_sym_AT] = ACTIONS(604),
    [anon_sym_not] = ACTIONS(606),
    [anon_sym_and] = ACTIONS(302),
    [anon_sym_or] = ACTIONS(302),
    [anon_sym_PLUS] = ACTIONS(608),
    [anon_sym_DASH] = ACTIONS(608),
    [anon_sym_SLASH] = ACTIONS(598),
    [anon_sym_PERCENT] = ACTIONS(604),
    [anon_sym_SLASH_SLASH] = ACTIONS(604),
    [anon_sym_STAR_STAR] = ACTIONS(610),
    [anon_sym_PIPE] = ACTIONS(612),
    [anon_sym_AMP] = ACTIONS(614),
    [anon_sym_CARET] = ACTIONS(616),
    [anon_sym_LT_LT] = ACTIONS(600),
    [anon_sym_LT] = ACTIONS(618),
    [anon_sym_LT_EQ] = ACTIONS(602),
    [anon_sym_EQ_EQ] = ACTIONS(602),
    [anon_sym_BANG_EQ] = ACTIONS(602),
    [anon_sym_GT_EQ] = ACTIONS(602),
    [anon_sym_GT] = ACTIONS(618),
    [anon_sym_LT_GT] = ACTIONS(602),
    [anon_sym_is] = ACTIONS(620),
    [anon_sym_LBRACK] = ACTIONS(450),
    [sym_comment] = ACTIONS(72),
  },
  [97] = {
    [sym_variables] = STATE(348),
    [sym__primary_expression] = STATE(103),
    [sym_binary_operator] = STATE(103),
    [sym_unary_operator] = STATE(103),
    [sym_attribute] = STATE(103),
    [sym_subscript] = STATE(103),
    [sym_call] = STATE(103),
    [sym_list] = STATE(103),
    [sym_list_comprehension] = STATE(103),
    [sym_dictionary] = STATE(103),
    [sym_dictionary_comprehension] = STATE(103),
    [sym_set] = STATE(103),
    [sym_set_comprehension] = STATE(103),
    [sym_parenthesized_expression] = STATE(103),
    [sym_tuple] = STATE(103),
    [sym_generator_expression] = STATE(103),
    [sym_concatenated_string] = STATE(103),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_PLUS] = ACTIONS(180),
    [anon_sym_DASH] = ACTIONS(180),
    [anon_sym_TILDE] = ACTIONS(180),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(182),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(184),
    [sym_integer] = ACTIONS(186),
    [sym_float] = ACTIONS(186),
    [sym_identifier] = ACTIONS(186),
    [sym_true] = ACTIONS(186),
    [sym_false] = ACTIONS(186),
    [sym_none] = ACTIONS(186),
    [sym_comment] = ACTIONS(72),
  },
  [98] = {
    [sym_with_item] = STATE(349),
    [sym__expression] = STATE(112),
    [sym__primary_expression] = STATE(113),
    [sym_not_operator] = STATE(112),
    [sym_boolean_operator] = STATE(112),
    [sym_binary_operator] = STATE(113),
    [sym_unary_operator] = STATE(113),
    [sym_comparison_operator] = STATE(112),
    [sym_lambda] = STATE(112),
    [sym_attribute] = STATE(113),
    [sym_subscript] = STATE(113),
    [sym_call] = STATE(113),
    [sym_list] = STATE(113),
    [sym_list_comprehension] = STATE(113),
    [sym_dictionary] = STATE(113),
    [sym_dictionary_comprehension] = STATE(113),
    [sym_set] = STATE(113),
    [sym_set_comprehension] = STATE(113),
    [sym_parenthesized_expression] = STATE(113),
    [sym_tuple] = STATE(113),
    [sym_generator_expression] = STATE(113),
    [sym_conditional_expression] = STATE(112),
    [sym_concatenated_string] = STATE(113),
    [sym_await] = STATE(112),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_not] = ACTIONS(190),
    [anon_sym_PLUS] = ACTIONS(192),
    [anon_sym_DASH] = ACTIONS(192),
    [anon_sym_TILDE] = ACTIONS(192),
    [anon_sym_lambda] = ACTIONS(194),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(196),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(198),
    [sym_integer] = ACTIONS(200),
    [sym_float] = ACTIONS(200),
    [sym_identifier] = ACTIONS(200),
    [sym_true] = ACTIONS(200),
    [sym_false] = ACTIONS(200),
    [sym_none] = ACTIONS(200),
    [anon_sym_await] = ACTIONS(202),
    [sym_comment] = ACTIONS(72),
  },
  [99] = {
    [sym_identifier] = ACTIONS(622),
    [sym_comment] = ACTIONS(72),
  },
  [100] = {
    [sym__primary_expression] = STATE(204),
    [sym_binary_operator] = STATE(204),
    [sym_unary_operator] = STATE(204),
    [sym_attribute] = STATE(204),
    [sym_subscript] = STATE(204),
    [sym_call] = STATE(204),
    [sym_list] = STATE(204),
    [sym_list_comprehension] = STATE(204),
    [sym_dictionary] = STATE(204),
    [sym_dictionary_comprehension] = STATE(204),
    [sym_set] = STATE(204),
    [sym_set_comprehension] = STATE(204),
    [sym_parenthesized_expression] = STATE(204),
    [sym_tuple] = STATE(204),
    [sym_generator_expression] = STATE(204),
    [sym_concatenated_string] = STATE(204),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_PLUS] = ACTIONS(180),
    [anon_sym_DASH] = ACTIONS(180),
    [anon_sym_TILDE] = ACTIONS(180),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(376),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(184),
    [sym_integer] = ACTIONS(378),
    [sym_float] = ACTIONS(378),
    [sym_identifier] = ACTIONS(378),
    [sym_true] = ACTIONS(378),
    [sym_false] = ACTIONS(378),
    [sym_none] = ACTIONS(378),
    [sym_comment] = ACTIONS(72),
  },
  [101] = {
    [aux_sym_concatenated_string_repeat1] = STATE(351),
    [anon_sym_DOT] = ACTIONS(276),
    [anon_sym_LPAREN] = ACTIONS(276),
    [anon_sym_COMMA] = ACTIONS(276),
    [anon_sym_STAR] = ACTIONS(278),
    [anon_sym_GT_GT] = ACTIONS(276),
    [anon_sym_in] = ACTIONS(276),
    [anon_sym_AT] = ACTIONS(276),
    [anon_sym_PLUS] = ACTIONS(276),
    [anon_sym_DASH] = ACTIONS(276),
    [anon_sym_SLASH] = ACTIONS(278),
    [anon_sym_PERCENT] = ACTIONS(276),
    [anon_sym_SLASH_SLASH] = ACTIONS(276),
    [anon_sym_STAR_STAR] = ACTIONS(276),
    [anon_sym_PIPE] = ACTIONS(276),
    [anon_sym_AMP] = ACTIONS(276),
    [anon_sym_CARET] = ACTIONS(276),
    [anon_sym_LT_LT] = ACTIONS(276),
    [anon_sym_LBRACK] = ACTIONS(276),
    [sym_string] = ACTIONS(624),
    [sym_comment] = ACTIONS(72),
  },
  [102] = {
    [anon_sym_in] = ACTIONS(626),
    [sym_comment] = ACTIONS(72),
  },
  [103] = {
    [sym_argument_list] = STATE(251),
    [sym_generator_expression] = STATE(251),
    [aux_sym_variables_repeat1] = STATE(361),
    [anon_sym_DOT] = ACTIONS(422),
    [anon_sym_LPAREN] = ACTIONS(424),
    [anon_sym_COMMA] = ACTIONS(628),
    [anon_sym_STAR] = ACTIONS(630),
    [anon_sym_GT_GT] = ACTIONS(632),
    [anon_sym_in] = ACTIONS(634),
    [anon_sym_AT] = ACTIONS(636),
    [anon_sym_PLUS] = ACTIONS(638),
    [anon_sym_DASH] = ACTIONS(638),
    [anon_sym_SLASH] = ACTIONS(630),
    [anon_sym_PERCENT] = ACTIONS(636),
    [anon_sym_SLASH_SLASH] = ACTIONS(636),
    [anon_sym_STAR_STAR] = ACTIONS(640),
    [anon_sym_PIPE] = ACTIONS(642),
    [anon_sym_AMP] = ACTIONS(644),
    [anon_sym_CARET] = ACTIONS(646),
    [anon_sym_LT_LT] = ACTIONS(632),
    [anon_sym_LBRACK] = ACTIONS(450),
    [sym_comment] = ACTIONS(72),
  },
  [104] = {
    [anon_sym_if] = ACTIONS(590),
    [anon_sym_COLON] = ACTIONS(648),
    [anon_sym_and] = ACTIONS(594),
    [anon_sym_or] = ACTIONS(596),
    [sym_comment] = ACTIONS(72),
  },
  [105] = {
    [sym__simple_statements] = STATE(365),
    [sym_import_statement] = STATE(364),
    [sym_import_from_statement] = STATE(364),
    [sym_print_statement] = STATE(364),
    [sym_assert_statement] = STATE(364),
    [sym_expression_statement] = STATE(364),
    [sym_return_statement] = STATE(364),
    [sym_delete_statement] = STATE(364),
    [sym_raise_statement] = STATE(364),
    [sym_global_statement] = STATE(364),
    [sym_nonlocal_statement] = STATE(364),
    [sym_exec_statement] = STATE(364),
    [sym__suite] = STATE(365),
    [sym_expression_list] = STATE(32),
    [sym__expression] = STATE(33),
    [sym__primary_expression] = STATE(34),
    [sym_not_operator] = STATE(33),
    [sym_boolean_operator] = STATE(33),
    [sym_binary_operator] = STATE(34),
    [sym_unary_operator] = STATE(34),
    [sym_comparison_operator] = STATE(33),
    [sym_lambda] = STATE(33),
    [sym_assignment] = STATE(35),
    [sym_augmented_assignment] = STATE(35),
    [sym_yield] = STATE(35),
    [sym_attribute] = STATE(34),
    [sym_subscript] = STATE(34),
    [sym_call] = STATE(34),
    [sym_list] = STATE(34),
    [sym_list_comprehension] = STATE(34),
    [sym_dictionary] = STATE(34),
    [sym_dictionary_comprehension] = STATE(34),
    [sym_set] = STATE(34),
    [sym_set_comprehension] = STATE(34),
    [sym_parenthesized_expression] = STATE(34),
    [sym_tuple] = STATE(34),
    [sym_generator_expression] = STATE(34),
    [sym_conditional_expression] = STATE(33),
    [sym_concatenated_string] = STATE(34),
    [sym_await] = STATE(33),
    [sym__indent] = ACTIONS(650),
    [anon_sym_import] = ACTIONS(10),
    [anon_sym_from] = ACTIONS(12),
    [anon_sym_LPAREN] = ACTIONS(14),
    [anon_sym_print] = ACTIONS(16),
    [anon_sym_assert] = ACTIONS(18),
    [anon_sym_return] = ACTIONS(20),
    [anon_sym_del] = ACTIONS(22),
    [anon_sym_raise] = ACTIONS(24),
    [sym_pass_statement] = ACTIONS(652),
    [sym_break_statement] = ACTIONS(652),
    [sym_continue_statement] = ACTIONS(652),
    [anon_sym_global] = ACTIONS(42),
    [anon_sym_nonlocal] = ACTIONS(44),
    [anon_sym_exec] = ACTIONS(46),
    [anon_sym_not] = ACTIONS(52),
    [anon_sym_PLUS] = ACTIONS(54),
    [anon_sym_DASH] = ACTIONS(54),
    [anon_sym_TILDE] = ACTIONS(54),
    [anon_sym_lambda] = ACTIONS(56),
    [anon_sym_yield] = ACTIONS(58),
    [anon_sym_LBRACK] = ACTIONS(60),
    [sym_ellipsis] = ACTIONS(62),
    [anon_sym_LBRACE] = ACTIONS(64),
    [sym_string] = ACTIONS(66),
    [sym_integer] = ACTIONS(68),
    [sym_float] = ACTIONS(68),
    [sym_identifier] = ACTIONS(68),
    [sym_true] = ACTIONS(68),
    [sym_false] = ACTIONS(68),
    [sym_none] = ACTIONS(68),
    [anon_sym_await] = ACTIONS(70),
    [sym_comment] = ACTIONS(72),
  },
  [106] = {
    [sym__expression] = STATE(366),
    [sym__primary_expression] = STATE(113),
    [sym_not_operator] = STATE(366),
    [sym_boolean_operator] = STATE(366),
    [sym_binary_operator] = STATE(113),
    [sym_unary_operator] = STATE(113),
    [sym_comparison_operator] = STATE(366),
    [sym_lambda] = STATE(366),
    [sym_attribute] = STATE(113),
    [sym_subscript] = STATE(113),
    [sym_call] = STATE(113),
    [sym_list] = STATE(113),
    [sym_list_comprehension] = STATE(113),
    [sym_dictionary] = STATE(113),
    [sym_dictionary_comprehension] = STATE(113),
    [sym_set] = STATE(113),
    [sym_set_comprehension] = STATE(113),
    [sym_parenthesized_expression] = STATE(113),
    [sym_tuple] = STATE(113),
    [sym_generator_expression] = STATE(113),
    [sym_conditional_expression] = STATE(366),
    [sym_concatenated_string] = STATE(113),
    [sym_await] = STATE(366),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_not] = ACTIONS(190),
    [anon_sym_PLUS] = ACTIONS(192),
    [anon_sym_DASH] = ACTIONS(192),
    [anon_sym_TILDE] = ACTIONS(192),
    [anon_sym_lambda] = ACTIONS(194),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(196),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(198),
    [sym_integer] = ACTIONS(200),
    [sym_float] = ACTIONS(200),
    [sym_identifier] = ACTIONS(200),
    [sym_true] = ACTIONS(200),
    [sym_false] = ACTIONS(200),
    [sym_none] = ACTIONS(200),
    [anon_sym_await] = ACTIONS(202),
    [sym_comment] = ACTIONS(72),
  },
  [107] = {
    [sym__primary_expression] = STATE(204),
    [sym_binary_operator] = STATE(204),
    [sym_unary_operator] = STATE(204),
    [sym_attribute] = STATE(204),
    [sym_subscript] = STATE(204),
    [sym_call] = STATE(204),
    [sym_list] = STATE(204),
    [sym_list_comprehension] = STATE(204),
    [sym_dictionary] = STATE(204),
    [sym_dictionary_comprehension] = STATE(204),
    [sym_set] = STATE(204),
    [sym_set_comprehension] = STATE(204),
    [sym_parenthesized_expression] = STATE(204),
    [sym_tuple] = STATE(204),
    [sym_generator_expression] = STATE(204),
    [sym_concatenated_string] = STATE(204),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_PLUS] = ACTIONS(192),
    [anon_sym_DASH] = ACTIONS(192),
    [anon_sym_TILDE] = ACTIONS(192),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(376),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(198),
    [sym_integer] = ACTIONS(378),
    [sym_float] = ACTIONS(378),
    [sym_identifier] = ACTIONS(378),
    [sym_true] = ACTIONS(378),
    [sym_false] = ACTIONS(378),
    [sym_none] = ACTIONS(378),
    [sym_comment] = ACTIONS(72),
  },
  [108] = {
    [sym_lambda_parameters] = STATE(368),
    [sym__parameters] = STATE(130),
    [sym_default_parameter] = STATE(131),
    [sym_typed_default_parameter] = STATE(131),
    [sym_list_splat] = STATE(132),
    [sym_dictionary_splat] = STATE(132),
    [sym_typed_parameter] = STATE(131),
    [sym_tuple] = STATE(131),
    [anon_sym_LPAREN] = ACTIONS(222),
    [anon_sym_STAR] = ACTIONS(224),
    [anon_sym_print] = ACTIONS(226),
    [anon_sym_COLON] = ACTIONS(654),
    [anon_sym_exec] = ACTIONS(226),
    [sym_identifier] = ACTIONS(230),
    [sym_comment] = ACTIONS(72),
  },
  [109] = {
    [aux_sym_concatenated_string_repeat1] = STATE(369),
    [anon_sym_DOT] = ACTIONS(276),
    [anon_sym_LPAREN] = ACTIONS(276),
    [anon_sym_COMMA] = ACTIONS(276),
    [anon_sym_as] = ACTIONS(276),
    [anon_sym_STAR] = ACTIONS(278),
    [anon_sym_GT_GT] = ACTIONS(276),
    [anon_sym_if] = ACTIONS(276),
    [anon_sym_COLON] = ACTIONS(276),
    [anon_sym_in] = ACTIONS(276),
    [anon_sym_AT] = ACTIONS(276),
    [anon_sym_not] = ACTIONS(276),
    [anon_sym_and] = ACTIONS(276),
    [anon_sym_or] = ACTIONS(276),
    [anon_sym_PLUS] = ACTIONS(276),
    [anon_sym_DASH] = ACTIONS(276),
    [anon_sym_SLASH] = ACTIONS(278),
    [anon_sym_PERCENT] = ACTIONS(276),
    [anon_sym_SLASH_SLASH] = ACTIONS(276),
    [anon_sym_STAR_STAR] = ACTIONS(276),
    [anon_sym_PIPE] = ACTIONS(276),
    [anon_sym_AMP] = ACTIONS(276),
    [anon_sym_CARET] = ACTIONS(276),
    [anon_sym_LT_LT] = ACTIONS(276),
    [anon_sym_LT] = ACTIONS(278),
    [anon_sym_LT_EQ] = ACTIONS(276),
    [anon_sym_EQ_EQ] = ACTIONS(276),
    [anon_sym_BANG_EQ] = ACTIONS(276),
    [anon_sym_GT_EQ] = ACTIONS(276),
    [anon_sym_GT] = ACTIONS(278),
    [anon_sym_LT_GT] = ACTIONS(276),
    [anon_sym_is] = ACTIONS(276),
    [anon_sym_LBRACK] = ACTIONS(276),
    [sym_string] = ACTIONS(656),
    [sym_comment] = ACTIONS(72),
  },
  [110] = {
    [sym__expression] = STATE(227),
    [sym__primary_expression] = STATE(113),
    [sym_not_operator] = STATE(227),
    [sym_boolean_operator] = STATE(227),
    [sym_binary_operator] = STATE(113),
    [sym_unary_operator] = STATE(113),
    [sym_comparison_operator] = STATE(227),
    [sym_lambda] = STATE(227),
    [sym_attribute] = STATE(113),
    [sym_subscript] = STATE(113),
    [sym_call] = STATE(113),
    [sym_list] = STATE(113),
    [sym_list_comprehension] = STATE(113),
    [sym_dictionary] = STATE(113),
    [sym_dictionary_comprehension] = STATE(113),
    [sym_set] = STATE(113),
    [sym_set_comprehension] = STATE(113),
    [sym_parenthesized_expression] = STATE(113),
    [sym_tuple] = STATE(113),
    [sym_generator_expression] = STATE(113),
    [sym_conditional_expression] = STATE(227),
    [sym_concatenated_string] = STATE(113),
    [sym_await] = STATE(227),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_not] = ACTIONS(190),
    [anon_sym_PLUS] = ACTIONS(192),
    [anon_sym_DASH] = ACTIONS(192),
    [anon_sym_TILDE] = ACTIONS(192),
    [anon_sym_lambda] = ACTIONS(194),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(196),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(198),
    [sym_integer] = ACTIONS(200),
    [sym_float] = ACTIONS(200),
    [sym_identifier] = ACTIONS(200),
    [sym_true] = ACTIONS(200),
    [sym_false] = ACTIONS(200),
    [sym_none] = ACTIONS(200),
    [anon_sym_await] = ACTIONS(202),
    [sym_comment] = ACTIONS(72),
  },
  [111] = {
    [aux_sym_with_statement_repeat1] = STATE(372),
    [anon_sym_COMMA] = ACTIONS(658),
    [anon_sym_COLON] = ACTIONS(660),
    [sym_comment] = ACTIONS(72),
  },
  [112] = {
    [anon_sym_COMMA] = ACTIONS(662),
    [anon_sym_as] = ACTIONS(664),
    [anon_sym_if] = ACTIONS(666),
    [anon_sym_COLON] = ACTIONS(662),
    [anon_sym_and] = ACTIONS(668),
    [anon_sym_or] = ACTIONS(670),
    [sym_comment] = ACTIONS(72),
  },
  [113] = {
    [sym_argument_list] = STATE(251),
    [sym_generator_expression] = STATE(251),
    [aux_sym_comparison_operator_repeat1] = STATE(387),
    [anon_sym_DOT] = ACTIONS(422),
    [anon_sym_LPAREN] = ACTIONS(424),
    [anon_sym_COMMA] = ACTIONS(302),
    [anon_sym_as] = ACTIONS(302),
    [anon_sym_STAR] = ACTIONS(672),
    [anon_sym_GT_GT] = ACTIONS(674),
    [anon_sym_if] = ACTIONS(302),
    [anon_sym_COLON] = ACTIONS(302),
    [anon_sym_in] = ACTIONS(676),
    [anon_sym_AT] = ACTIONS(678),
    [anon_sym_not] = ACTIONS(680),
    [anon_sym_and] = ACTIONS(302),
    [anon_sym_or] = ACTIONS(302),
    [anon_sym_PLUS] = ACTIONS(682),
    [anon_sym_DASH] = ACTIONS(682),
    [anon_sym_SLASH] = ACTIONS(672),
    [anon_sym_PERCENT] = ACTIONS(678),
    [anon_sym_SLASH_SLASH] = ACTIONS(678),
    [anon_sym_STAR_STAR] = ACTIONS(684),
    [anon_sym_PIPE] = ACTIONS(686),
    [anon_sym_AMP] = ACTIONS(688),
    [anon_sym_CARET] = ACTIONS(690),
    [anon_sym_LT_LT] = ACTIONS(674),
    [anon_sym_LT] = ACTIONS(692),
    [anon_sym_LT_EQ] = ACTIONS(676),
    [anon_sym_EQ_EQ] = ACTIONS(676),
    [anon_sym_BANG_EQ] = ACTIONS(676),
    [anon_sym_GT_EQ] = ACTIONS(676),
    [anon_sym_GT] = ACTIONS(692),
    [anon_sym_LT_GT] = ACTIONS(676),
    [anon_sym_is] = ACTIONS(694),
    [anon_sym_LBRACK] = ACTIONS(450),
    [sym_comment] = ACTIONS(72),
  },
  [114] = {
    [sym_parameters] = STATE(389),
    [anon_sym_LPAREN] = ACTIONS(696),
    [sym_comment] = ACTIONS(72),
  },
  [115] = {
    [aux_sym_global_statement_repeat1] = STATE(391),
    [sym__newline] = ACTIONS(698),
    [anon_sym_COMMA] = ACTIONS(700),
    [sym_comment] = ACTIONS(72),
    [sym__semicolon] = ACTIONS(698),
  },
  [116] = {
    [aux_sym_global_statement_repeat1] = STATE(392),
    [sym__newline] = ACTIONS(702),
    [anon_sym_COMMA] = ACTIONS(700),
    [sym_comment] = ACTIONS(72),
    [sym__semicolon] = ACTIONS(702),
  },
  [117] = {
    [sym__newline] = ACTIONS(704),
    [anon_sym_in] = ACTIONS(706),
    [sym_comment] = ACTIONS(72),
    [sym__semicolon] = ACTIONS(704),
  },
  [118] = {
    [sym_argument_list] = STATE(396),
    [anon_sym_LPAREN] = ACTIONS(708),
    [anon_sym_COLON] = ACTIONS(710),
    [sym_comment] = ACTIONS(72),
  },
  [119] = {
    [aux_sym_dotted_name_repeat1] = STATE(397),
    [sym__newline] = ACTIONS(342),
    [anon_sym_DOT] = ACTIONS(344),
    [anon_sym_LPAREN] = ACTIONS(342),
    [sym_comment] = ACTIONS(72),
  },
  [120] = {
    [sym_argument_list] = STATE(400),
    [sym__newline] = ACTIONS(712),
    [anon_sym_LPAREN] = ACTIONS(714),
    [sym_comment] = ACTIONS(72),
  },
  [121] = {
    [sym__newline] = ACTIONS(108),
    [anon_sym_DOT] = ACTIONS(108),
    [anon_sym_LPAREN] = ACTIONS(108),
    [anon_sym_COMMA] = ACTIONS(108),
    [anon_sym_STAR] = ACTIONS(110),
    [anon_sym_GT_GT] = ACTIONS(110),
    [anon_sym_if] = ACTIONS(108),
    [anon_sym_COLON] = ACTIONS(108),
    [anon_sym_in] = ACTIONS(108),
    [anon_sym_EQ] = ACTIONS(110),
    [anon_sym_AT] = ACTIONS(110),
    [anon_sym_not] = ACTIONS(108),
    [anon_sym_and] = ACTIONS(108),
    [anon_sym_or] = ACTIONS(108),
    [anon_sym_PLUS] = ACTIONS(110),
    [anon_sym_DASH] = ACTIONS(110),
    [anon_sym_SLASH] = ACTIONS(110),
    [anon_sym_PERCENT] = ACTIONS(110),
    [anon_sym_SLASH_SLASH] = ACTIONS(110),
    [anon_sym_STAR_STAR] = ACTIONS(110),
    [anon_sym_PIPE] = ACTIONS(110),
    [anon_sym_AMP] = ACTIONS(110),
    [anon_sym_CARET] = ACTIONS(110),
    [anon_sym_LT_LT] = ACTIONS(110),
    [anon_sym_LT] = ACTIONS(110),
    [anon_sym_LT_EQ] = ACTIONS(108),
    [anon_sym_EQ_EQ] = ACTIONS(108),
    [anon_sym_BANG_EQ] = ACTIONS(108),
    [anon_sym_GT_EQ] = ACTIONS(108),
    [anon_sym_GT] = ACTIONS(110),
    [anon_sym_LT_GT] = ACTIONS(108),
    [anon_sym_is] = ACTIONS(108),
    [anon_sym_PLUS_EQ] = ACTIONS(108),
    [anon_sym_DASH_EQ] = ACTIONS(108),
    [anon_sym_STAR_EQ] = ACTIONS(108),
    [anon_sym_SLASH_EQ] = ACTIONS(108),
    [anon_sym_AT_EQ] = ACTIONS(108),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(108),
    [anon_sym_PERCENT_EQ] = ACTIONS(108),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(108),
    [anon_sym_GT_GT_EQ] = ACTIONS(108),
    [anon_sym_LT_LT_EQ] = ACTIONS(108),
    [anon_sym_AMP_EQ] = ACTIONS(108),
    [anon_sym_CARET_EQ] = ACTIONS(108),
    [anon_sym_PIPE_EQ] = ACTIONS(108),
    [anon_sym_LBRACK] = ACTIONS(108),
    [sym_comment] = ACTIONS(72),
    [sym__semicolon] = ACTIONS(108),
  },
  [122] = {
    [sym__newline] = ACTIONS(716),
    [anon_sym_COMMA] = ACTIONS(716),
    [anon_sym_if] = ACTIONS(716),
    [anon_sym_COLON] = ACTIONS(716),
    [anon_sym_EQ] = ACTIONS(716),
    [anon_sym_and] = ACTIONS(298),
    [anon_sym_or] = ACTIONS(300),
    [anon_sym_PLUS_EQ] = ACTIONS(716),
    [anon_sym_DASH_EQ] = ACTIONS(716),
    [anon_sym_STAR_EQ] = ACTIONS(716),
    [anon_sym_SLASH_EQ] = ACTIONS(716),
    [anon_sym_AT_EQ] = ACTIONS(716),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(716),
    [anon_sym_PERCENT_EQ] = ACTIONS(716),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(716),
    [anon_sym_GT_GT_EQ] = ACTIONS(716),
    [anon_sym_LT_LT_EQ] = ACTIONS(716),
    [anon_sym_AMP_EQ] = ACTIONS(716),
    [anon_sym_CARET_EQ] = ACTIONS(716),
    [anon_sym_PIPE_EQ] = ACTIONS(716),
    [sym_comment] = ACTIONS(72),
    [sym__semicolon] = ACTIONS(716),
  },
  [123] = {
    [sym_argument_list] = STATE(182),
    [sym_generator_expression] = STATE(182),
    [sym__newline] = ACTIONS(718),
    [anon_sym_DOT] = ACTIONS(718),
    [anon_sym_LPAREN] = ACTIONS(306),
    [anon_sym_COMMA] = ACTIONS(718),
    [anon_sym_STAR] = ACTIONS(720),
    [anon_sym_GT_GT] = ACTIONS(720),
    [anon_sym_if] = ACTIONS(718),
    [anon_sym_COLON] = ACTIONS(718),
    [anon_sym_in] = ACTIONS(718),
    [anon_sym_EQ] = ACTIONS(720),
    [anon_sym_AT] = ACTIONS(720),
    [anon_sym_not] = ACTIONS(718),
    [anon_sym_and] = ACTIONS(718),
    [anon_sym_or] = ACTIONS(718),
    [anon_sym_PLUS] = ACTIONS(720),
    [anon_sym_DASH] = ACTIONS(720),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_PERCENT] = ACTIONS(720),
    [anon_sym_SLASH_SLASH] = ACTIONS(720),
    [anon_sym_STAR_STAR] = ACTIONS(720),
    [anon_sym_PIPE] = ACTIONS(720),
    [anon_sym_AMP] = ACTIONS(720),
    [anon_sym_CARET] = ACTIONS(720),
    [anon_sym_LT_LT] = ACTIONS(720),
    [anon_sym_LT] = ACTIONS(720),
    [anon_sym_LT_EQ] = ACTIONS(718),
    [anon_sym_EQ_EQ] = ACTIONS(718),
    [anon_sym_BANG_EQ] = ACTIONS(718),
    [anon_sym_GT_EQ] = ACTIONS(718),
    [anon_sym_GT] = ACTIONS(720),
    [anon_sym_LT_GT] = ACTIONS(718),
    [anon_sym_is] = ACTIONS(718),
    [anon_sym_PLUS_EQ] = ACTIONS(718),
    [anon_sym_DASH_EQ] = ACTIONS(718),
    [anon_sym_STAR_EQ] = ACTIONS(718),
    [anon_sym_SLASH_EQ] = ACTIONS(718),
    [anon_sym_AT_EQ] = ACTIONS(718),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(718),
    [anon_sym_PERCENT_EQ] = ACTIONS(718),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(718),
    [anon_sym_GT_GT_EQ] = ACTIONS(718),
    [anon_sym_LT_LT_EQ] = ACTIONS(718),
    [anon_sym_AMP_EQ] = ACTIONS(718),
    [anon_sym_CARET_EQ] = ACTIONS(718),
    [anon_sym_PIPE_EQ] = ACTIONS(718),
    [anon_sym_LBRACK] = ACTIONS(718),
    [sym_comment] = ACTIONS(72),
    [sym__semicolon] = ACTIONS(718),
  },
  [124] = {
    [sym__expression] = STATE(401),
    [sym__primary_expression] = STATE(215),
    [sym_not_operator] = STATE(401),
    [sym_boolean_operator] = STATE(401),
    [sym_binary_operator] = STATE(215),
    [sym_unary_operator] = STATE(215),
    [sym_comparison_operator] = STATE(401),
    [sym_lambda] = STATE(401),
    [sym_yield] = STATE(402),
    [sym_attribute] = STATE(215),
    [sym_subscript] = STATE(215),
    [sym_call] = STATE(215),
    [sym_list] = STATE(215),
    [sym_list_comprehension] = STATE(215),
    [sym_dictionary] = STATE(215),
    [sym_dictionary_comprehension] = STATE(215),
    [sym_set] = STATE(215),
    [sym_set_comprehension] = STATE(215),
    [sym_parenthesized_expression] = STATE(215),
    [sym_tuple] = STATE(215),
    [sym_generator_expression] = STATE(215),
    [sym_conditional_expression] = STATE(401),
    [sym_concatenated_string] = STATE(215),
    [sym_await] = STATE(401),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_RPAREN] = ACTIONS(366),
    [anon_sym_COMMA] = ACTIONS(368),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_not] = ACTIONS(384),
    [anon_sym_PLUS] = ACTIONS(386),
    [anon_sym_DASH] = ACTIONS(386),
    [anon_sym_TILDE] = ACTIONS(386),
    [anon_sym_lambda] = ACTIONS(388),
    [anon_sym_yield] = ACTIONS(94),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(390),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(392),
    [sym_integer] = ACTIONS(394),
    [sym_float] = ACTIONS(394),
    [sym_identifier] = ACTIONS(394),
    [sym_true] = ACTIONS(394),
    [sym_false] = ACTIONS(394),
    [sym_none] = ACTIONS(394),
    [anon_sym_await] = ACTIONS(396),
    [sym_comment] = ACTIONS(72),
  },
  [125] = {
    [sym__expression] = STATE(409),
    [sym__primary_expression] = STATE(410),
    [sym_not_operator] = STATE(409),
    [sym_boolean_operator] = STATE(409),
    [sym_binary_operator] = STATE(410),
    [sym_unary_operator] = STATE(410),
    [sym_comparison_operator] = STATE(409),
    [sym_lambda] = STATE(409),
    [sym_attribute] = STATE(410),
    [sym_subscript] = STATE(410),
    [sym_call] = STATE(410),
    [sym_list] = STATE(410),
    [sym_list_comprehension] = STATE(410),
    [sym_dictionary] = STATE(410),
    [sym_dictionary_comprehension] = STATE(410),
    [sym_set] = STATE(410),
    [sym_set_comprehension] = STATE(410),
    [sym_parenthesized_expression] = STATE(410),
    [sym_tuple] = STATE(410),
    [sym_generator_expression] = STATE(410),
    [sym_conditional_expression] = STATE(409),
    [sym_concatenated_string] = STATE(410),
    [sym_await] = STATE(409),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_COMMA] = ACTIONS(722),
    [anon_sym_STAR] = ACTIONS(724),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_COLON] = ACTIONS(722),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_not] = ACTIONS(726),
    [anon_sym_PLUS] = ACTIONS(728),
    [anon_sym_DASH] = ACTIONS(728),
    [anon_sym_TILDE] = ACTIONS(728),
    [anon_sym_lambda] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(732),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(734),
    [sym_integer] = ACTIONS(736),
    [sym_float] = ACTIONS(736),
    [sym_identifier] = ACTIONS(736),
    [sym_true] = ACTIONS(736),
    [sym_false] = ACTIONS(736),
    [sym_none] = ACTIONS(736),
    [anon_sym_await] = ACTIONS(738),
    [sym_comment] = ACTIONS(72),
  },
  [126] = {
    [aux_sym__parameters_repeat1] = STATE(414),
    [anon_sym_COMMA] = ACTIONS(740),
    [anon_sym_COLON] = ACTIONS(742),
    [anon_sym_EQ] = ACTIONS(744),
    [sym_comment] = ACTIONS(72),
  },
  [127] = {
    [sym__expression] = STATE(415),
    [sym__primary_expression] = STATE(34),
    [sym_not_operator] = STATE(415),
    [sym_boolean_operator] = STATE(415),
    [sym_binary_operator] = STATE(34),
    [sym_unary_operator] = STATE(34),
    [sym_comparison_operator] = STATE(415),
    [sym_lambda] = STATE(415),
    [sym_attribute] = STATE(34),
    [sym_subscript] = STATE(34),
    [sym_call] = STATE(34),
    [sym_list] = STATE(34),
    [sym_list_comprehension] = STATE(34),
    [sym_dictionary] = STATE(34),
    [sym_dictionary_comprehension] = STATE(34),
    [sym_set] = STATE(34),
    [sym_set_comprehension] = STATE(34),
    [sym_parenthesized_expression] = STATE(34),
    [sym_tuple] = STATE(34),
    [sym_generator_expression] = STATE(34),
    [sym_conditional_expression] = STATE(415),
    [sym_concatenated_string] = STATE(34),
    [sym_await] = STATE(415),
    [anon_sym_LPAREN] = ACTIONS(14),
    [anon_sym_print] = ACTIONS(216),
    [anon_sym_exec] = ACTIONS(216),
    [anon_sym_not] = ACTIONS(52),
    [anon_sym_PLUS] = ACTIONS(54),
    [anon_sym_DASH] = ACTIONS(54),
    [anon_sym_TILDE] = ACTIONS(54),
    [anon_sym_lambda] = ACTIONS(56),
    [anon_sym_LBRACK] = ACTIONS(60),
    [sym_ellipsis] = ACTIONS(62),
    [anon_sym_LBRACE] = ACTIONS(64),
    [sym_string] = ACTIONS(66),
    [sym_integer] = ACTIONS(68),
    [sym_float] = ACTIONS(68),
    [sym_identifier] = ACTIONS(68),
    [sym_true] = ACTIONS(68),
    [sym_false] = ACTIONS(68),
    [sym_none] = ACTIONS(68),
    [anon_sym_await] = ACTIONS(70),
    [sym_comment] = ACTIONS(72),
  },
  [128] = {
    [aux_sym__parameters_repeat1] = STATE(419),
    [anon_sym_COMMA] = ACTIONS(746),
    [anon_sym_COLON] = ACTIONS(748),
    [anon_sym_EQ] = ACTIONS(750),
    [sym_comment] = ACTIONS(72),
  },
  [129] = {
    [anon_sym_COLON] = ACTIONS(752),
    [sym_comment] = ACTIONS(72),
  },
  [130] = {
    [anon_sym_COLON] = ACTIONS(754),
    [sym_comment] = ACTIONS(72),
  },
  [131] = {
    [aux_sym__parameters_repeat1] = STATE(419),
    [anon_sym_COMMA] = ACTIONS(746),
    [anon_sym_COLON] = ACTIONS(748),
    [sym_comment] = ACTIONS(72),
  },
  [132] = {
    [aux_sym__parameters_repeat1] = STATE(419),
    [anon_sym_COMMA] = ACTIONS(746),
    [anon_sym_COLON] = ACTIONS(748),
    [sym_comment] = ACTIONS(72),
  },
  [133] = {
    [sym__expression] = STATE(422),
    [sym__primary_expression] = STATE(303),
    [sym_not_operator] = STATE(422),
    [sym_boolean_operator] = STATE(422),
    [sym_binary_operator] = STATE(303),
    [sym_unary_operator] = STATE(303),
    [sym_comparison_operator] = STATE(422),
    [sym_lambda] = STATE(422),
    [sym_attribute] = STATE(303),
    [sym_subscript] = STATE(303),
    [sym_call] = STATE(303),
    [sym_list] = STATE(303),
    [sym_list_comprehension] = STATE(303),
    [sym_dictionary] = STATE(303),
    [sym_dictionary_comprehension] = STATE(303),
    [sym_set] = STATE(303),
    [sym_set_comprehension] = STATE(303),
    [sym_parenthesized_expression] = STATE(303),
    [sym_tuple] = STATE(303),
    [sym_generator_expression] = STATE(303),
    [sym_conditional_expression] = STATE(422),
    [sym_concatenated_string] = STATE(303),
    [sym_await] = STATE(422),
    [anon_sym_LPAREN] = ACTIONS(130),
    [anon_sym_print] = ACTIONS(112),
    [anon_sym_exec] = ACTIONS(112),
    [anon_sym_not] = ACTIONS(522),
    [anon_sym_PLUS] = ACTIONS(524),
    [anon_sym_DASH] = ACTIONS(524),
    [anon_sym_TILDE] = ACTIONS(524),
    [anon_sym_lambda] = ACTIONS(526),
    [anon_sym_LBRACK] = ACTIONS(134),
    [sym_ellipsis] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(122),
    [sym_string] = ACTIONS(530),
    [sym_integer] = ACTIONS(532),
    [sym_float] = ACTIONS(532),
    [sym_identifier] = ACTIONS(532),
    [sym_true] = ACTIONS(532),
    [sym_false] = ACTIONS(532),
    [sym_none] = ACTIONS(532),
    [anon_sym_await] = ACTIONS(534),
    [sym_comment] = ACTIONS(72),
  },
  [134] = {
    [sym__newline] = ACTIONS(756),
    [sym_comment] = ACTIONS(72),
    [sym__semicolon] = ACTIONS(756),
  },
  [135] = {
    [anon_sym_RBRACK] = ACTIONS(758),
    [sym_comment] = ACTIONS(72),
  },
  [136] = {
    [sym__expression] = STATE(429),
    [sym__primary_expression] = STATE(430),
    [sym_not_operator] = STATE(429),
    [sym_boolean_operator] = STATE(429),
    [sym_binary_operator] = STATE(430),
    [sym_unary_operator] = STATE(430),
    [sym_comparison_operator] = STATE(429),
    [sym_lambda] = STATE(429),
    [sym_attribute] = STATE(430),
    [sym_subscript] = STATE(430),
    [sym_call] = STATE(430),
    [sym_list] = STATE(430),
    [sym_list_comprehension] = STATE(430),
    [sym_dictionary] = STATE(430),
    [sym_dictionary_comprehension] = STATE(430),
    [sym_set] = STATE(430),
    [sym_set_comprehension] = STATE(430),
    [sym_parenthesized_expression] = STATE(430),
    [sym_tuple] = STATE(430),
    [sym_generator_expression] = STATE(430),
    [sym_conditional_expression] = STATE(429),
    [sym_concatenated_string] = STATE(430),
    [sym_await] = STATE(429),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_COMMA] = ACTIONS(722),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_not] = ACTIONS(760),
    [anon_sym_PLUS] = ACTIONS(762),
    [anon_sym_DASH] = ACTIONS(762),
    [anon_sym_TILDE] = ACTIONS(762),
    [anon_sym_lambda] = ACTIONS(764),
    [anon_sym_LBRACK] = ACTIONS(96),
    [anon_sym_RBRACK] = ACTIONS(722),
    [sym_ellipsis] = ACTIONS(766),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(768),
    [sym_integer] = ACTIONS(770),
    [sym_float] = ACTIONS(770),
    [sym_identifier] = ACTIONS(770),
    [sym_true] = ACTIONS(770),
    [sym_false] = ACTIONS(770),
    [sym_none] = ACTIONS(770),
    [anon_sym_await] = ACTIONS(772),
    [sym_comment] = ACTIONS(72),
  },
  [137] = {
    [sym__expression] = STATE(431),
    [sym__primary_expression] = STATE(145),
    [sym_not_operator] = STATE(431),
    [sym_boolean_operator] = STATE(431),
    [sym_binary_operator] = STATE(145),
    [sym_unary_operator] = STATE(145),
    [sym_comparison_operator] = STATE(431),
    [sym_lambda] = STATE(431),
    [sym_attribute] = STATE(145),
    [sym_subscript] = STATE(145),
    [sym_call] = STATE(145),
    [sym_list] = STATE(145),
    [sym_list_comprehension] = STATE(145),
    [sym_dictionary] = STATE(145),
    [sym_dictionary_comprehension] = STATE(145),
    [sym_set] = STATE(145),
    [sym_set_comprehension] = STATE(145),
    [sym_parenthesized_expression] = STATE(145),
    [sym_tuple] = STATE(145),
    [sym_generator_expression] = STATE(145),
    [sym_conditional_expression] = STATE(431),
    [sym_concatenated_string] = STATE(145),
    [sym_await] = STATE(431),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_not] = ACTIONS(240),
    [anon_sym_PLUS] = ACTIONS(242),
    [anon_sym_DASH] = ACTIONS(242),
    [anon_sym_TILDE] = ACTIONS(242),
    [anon_sym_lambda] = ACTIONS(244),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(248),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(250),
    [sym_integer] = ACTIONS(252),
    [sym_float] = ACTIONS(252),
    [sym_identifier] = ACTIONS(252),
    [sym_true] = ACTIONS(252),
    [sym_false] = ACTIONS(252),
    [sym_none] = ACTIONS(252),
    [anon_sym_await] = ACTIONS(254),
    [sym_comment] = ACTIONS(72),
  },
  [138] = {
    [sym__primary_expression] = STATE(204),
    [sym_binary_operator] = STATE(204),
    [sym_unary_operator] = STATE(204),
    [sym_attribute] = STATE(204),
    [sym_subscript] = STATE(204),
    [sym_call] = STATE(204),
    [sym_list] = STATE(204),
    [sym_list_comprehension] = STATE(204),
    [sym_dictionary] = STATE(204),
    [sym_dictionary_comprehension] = STATE(204),
    [sym_set] = STATE(204),
    [sym_set_comprehension] = STATE(204),
    [sym_parenthesized_expression] = STATE(204),
    [sym_tuple] = STATE(204),
    [sym_generator_expression] = STATE(204),
    [sym_concatenated_string] = STATE(204),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_PLUS] = ACTIONS(242),
    [anon_sym_DASH] = ACTIONS(242),
    [anon_sym_TILDE] = ACTIONS(242),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(376),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(250),
    [sym_integer] = ACTIONS(378),
    [sym_float] = ACTIONS(378),
    [sym_identifier] = ACTIONS(378),
    [sym_true] = ACTIONS(378),
    [sym_false] = ACTIONS(378),
    [sym_none] = ACTIONS(378),
    [sym_comment] = ACTIONS(72),
  },
  [139] = {
    [sym_lambda_parameters] = STATE(433),
    [sym__parameters] = STATE(130),
    [sym_default_parameter] = STATE(131),
    [sym_typed_default_parameter] = STATE(131),
    [sym_list_splat] = STATE(132),
    [sym_dictionary_splat] = STATE(132),
    [sym_typed_parameter] = STATE(131),
    [sym_tuple] = STATE(131),
    [anon_sym_LPAREN] = ACTIONS(222),
    [anon_sym_STAR] = ACTIONS(224),
    [anon_sym_print] = ACTIONS(226),
    [anon_sym_COLON] = ACTIONS(774),
    [anon_sym_exec] = ACTIONS(226),
    [sym_identifier] = ACTIONS(230),
    [sym_comment] = ACTIONS(72),
  },
  [140] = {
    [sym__newline] = ACTIONS(776),
    [anon_sym_DOT] = ACTIONS(776),
    [anon_sym_LPAREN] = ACTIONS(776),
    [anon_sym_COMMA] = ACTIONS(776),
    [anon_sym_STAR] = ACTIONS(778),
    [anon_sym_GT_GT] = ACTIONS(778),
    [anon_sym_if] = ACTIONS(776),
    [anon_sym_COLON] = ACTIONS(776),
    [anon_sym_in] = ACTIONS(776),
    [anon_sym_EQ] = ACTIONS(778),
    [anon_sym_AT] = ACTIONS(778),
    [anon_sym_not] = ACTIONS(776),
    [anon_sym_and] = ACTIONS(776),
    [anon_sym_or] = ACTIONS(776),
    [anon_sym_PLUS] = ACTIONS(778),
    [anon_sym_DASH] = ACTIONS(778),
    [anon_sym_SLASH] = ACTIONS(778),
    [anon_sym_PERCENT] = ACTIONS(778),
    [anon_sym_SLASH_SLASH] = ACTIONS(778),
    [anon_sym_STAR_STAR] = ACTIONS(778),
    [anon_sym_PIPE] = ACTIONS(778),
    [anon_sym_AMP] = ACTIONS(778),
    [anon_sym_CARET] = ACTIONS(778),
    [anon_sym_LT_LT] = ACTIONS(778),
    [anon_sym_LT] = ACTIONS(778),
    [anon_sym_LT_EQ] = ACTIONS(776),
    [anon_sym_EQ_EQ] = ACTIONS(776),
    [anon_sym_BANG_EQ] = ACTIONS(776),
    [anon_sym_GT_EQ] = ACTIONS(776),
    [anon_sym_GT] = ACTIONS(778),
    [anon_sym_LT_GT] = ACTIONS(776),
    [anon_sym_is] = ACTIONS(776),
    [anon_sym_PLUS_EQ] = ACTIONS(776),
    [anon_sym_DASH_EQ] = ACTIONS(776),
    [anon_sym_STAR_EQ] = ACTIONS(776),
    [anon_sym_SLASH_EQ] = ACTIONS(776),
    [anon_sym_AT_EQ] = ACTIONS(776),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(776),
    [anon_sym_PERCENT_EQ] = ACTIONS(776),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(776),
    [anon_sym_GT_GT_EQ] = ACTIONS(776),
    [anon_sym_LT_LT_EQ] = ACTIONS(776),
    [anon_sym_AMP_EQ] = ACTIONS(776),
    [anon_sym_CARET_EQ] = ACTIONS(776),
    [anon_sym_PIPE_EQ] = ACTIONS(776),
    [anon_sym_LBRACK] = ACTIONS(776),
    [sym_comment] = ACTIONS(72),
    [sym__semicolon] = ACTIONS(776),
  },
  [141] = {
    [aux_sym_concatenated_string_repeat1] = STATE(434),
    [anon_sym_DOT] = ACTIONS(276),
    [anon_sym_LPAREN] = ACTIONS(276),
    [anon_sym_COMMA] = ACTIONS(276),
    [anon_sym_STAR] = ACTIONS(278),
    [anon_sym_GT_GT] = ACTIONS(276),
    [anon_sym_if] = ACTIONS(276),
    [anon_sym_async] = ACTIONS(276),
    [anon_sym_for] = ACTIONS(276),
    [anon_sym_in] = ACTIONS(276),
    [anon_sym_AT] = ACTIONS(276),
    [anon_sym_not] = ACTIONS(276),
    [anon_sym_and] = ACTIONS(276),
    [anon_sym_or] = ACTIONS(276),
    [anon_sym_PLUS] = ACTIONS(276),
    [anon_sym_DASH] = ACTIONS(276),
    [anon_sym_SLASH] = ACTIONS(278),
    [anon_sym_PERCENT] = ACTIONS(276),
    [anon_sym_SLASH_SLASH] = ACTIONS(276),
    [anon_sym_STAR_STAR] = ACTIONS(276),
    [anon_sym_PIPE] = ACTIONS(276),
    [anon_sym_AMP] = ACTIONS(276),
    [anon_sym_CARET] = ACTIONS(276),
    [anon_sym_LT_LT] = ACTIONS(276),
    [anon_sym_LT] = ACTIONS(278),
    [anon_sym_LT_EQ] = ACTIONS(276),
    [anon_sym_EQ_EQ] = ACTIONS(276),
    [anon_sym_BANG_EQ] = ACTIONS(276),
    [anon_sym_GT_EQ] = ACTIONS(276),
    [anon_sym_GT] = ACTIONS(278),
    [anon_sym_LT_GT] = ACTIONS(276),
    [anon_sym_is] = ACTIONS(276),
    [anon_sym_LBRACK] = ACTIONS(276),
    [anon_sym_RBRACK] = ACTIONS(276),
    [sym_string] = ACTIONS(780),
    [sym_comment] = ACTIONS(72),
  },
  [142] = {
    [sym__expression] = STATE(227),
    [sym__primary_expression] = STATE(145),
    [sym_not_operator] = STATE(227),
    [sym_boolean_operator] = STATE(227),
    [sym_binary_operator] = STATE(145),
    [sym_unary_operator] = STATE(145),
    [sym_comparison_operator] = STATE(227),
    [sym_lambda] = STATE(227),
    [sym_attribute] = STATE(145),
    [sym_subscript] = STATE(145),
    [sym_call] = STATE(145),
    [sym_list] = STATE(145),
    [sym_list_comprehension] = STATE(145),
    [sym_dictionary] = STATE(145),
    [sym_dictionary_comprehension] = STATE(145),
    [sym_set] = STATE(145),
    [sym_set_comprehension] = STATE(145),
    [sym_parenthesized_expression] = STATE(145),
    [sym_tuple] = STATE(145),
    [sym_generator_expression] = STATE(145),
    [sym_conditional_expression] = STATE(227),
    [sym_concatenated_string] = STATE(145),
    [sym_await] = STATE(227),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_not] = ACTIONS(240),
    [anon_sym_PLUS] = ACTIONS(242),
    [anon_sym_DASH] = ACTIONS(242),
    [anon_sym_TILDE] = ACTIONS(242),
    [anon_sym_lambda] = ACTIONS(244),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(248),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(250),
    [sym_integer] = ACTIONS(252),
    [sym_float] = ACTIONS(252),
    [sym_identifier] = ACTIONS(252),
    [sym_true] = ACTIONS(252),
    [sym_false] = ACTIONS(252),
    [sym_none] = ACTIONS(252),
    [anon_sym_await] = ACTIONS(254),
    [sym_comment] = ACTIONS(72),
  },
  [143] = {
    [aux_sym_list_repeat1] = STATE(436),
    [anon_sym_COMMA] = ACTIONS(782),
    [anon_sym_RBRACK] = ACTIONS(758),
    [sym_comment] = ACTIONS(72),
  },
  [144] = {
    [sym__comprehension_body] = STATE(442),
    [sym_for_in_clause] = STATE(443),
    [aux_sym_list_repeat1] = STATE(436),
    [anon_sym_COMMA] = ACTIONS(782),
    [anon_sym_if] = ACTIONS(784),
    [anon_sym_async] = ACTIONS(786),
    [anon_sym_for] = ACTIONS(788),
    [anon_sym_and] = ACTIONS(790),
    [anon_sym_or] = ACTIONS(792),
    [anon_sym_RBRACK] = ACTIONS(758),
    [sym_comment] = ACTIONS(72),
  },
  [145] = {
    [sym_argument_list] = STATE(251),
    [sym_generator_expression] = STATE(251),
    [aux_sym_comparison_operator_repeat1] = STATE(454),
    [anon_sym_DOT] = ACTIONS(422),
    [anon_sym_LPAREN] = ACTIONS(424),
    [anon_sym_COMMA] = ACTIONS(302),
    [anon_sym_STAR] = ACTIONS(794),
    [anon_sym_GT_GT] = ACTIONS(796),
    [anon_sym_if] = ACTIONS(302),
    [anon_sym_async] = ACTIONS(302),
    [anon_sym_for] = ACTIONS(302),
    [anon_sym_in] = ACTIONS(798),
    [anon_sym_AT] = ACTIONS(800),
    [anon_sym_not] = ACTIONS(802),
    [anon_sym_and] = ACTIONS(302),
    [anon_sym_or] = ACTIONS(302),
    [anon_sym_PLUS] = ACTIONS(804),
    [anon_sym_DASH] = ACTIONS(804),
    [anon_sym_SLASH] = ACTIONS(794),
    [anon_sym_PERCENT] = ACTIONS(800),
    [anon_sym_SLASH_SLASH] = ACTIONS(800),
    [anon_sym_STAR_STAR] = ACTIONS(806),
    [anon_sym_PIPE] = ACTIONS(808),
    [anon_sym_AMP] = ACTIONS(810),
    [anon_sym_CARET] = ACTIONS(812),
    [anon_sym_LT_LT] = ACTIONS(796),
    [anon_sym_LT] = ACTIONS(814),
    [anon_sym_LT_EQ] = ACTIONS(798),
    [anon_sym_EQ_EQ] = ACTIONS(798),
    [anon_sym_BANG_EQ] = ACTIONS(798),
    [anon_sym_GT_EQ] = ACTIONS(798),
    [anon_sym_GT] = ACTIONS(814),
    [anon_sym_LT_GT] = ACTIONS(798),
    [anon_sym_is] = ACTIONS(816),
    [anon_sym_LBRACK] = ACTIONS(450),
    [anon_sym_RBRACK] = ACTIONS(302),
    [sym_comment] = ACTIONS(72),
  },
  [146] = {
    [anon_sym_RBRACE] = ACTIONS(818),
    [sym_comment] = ACTIONS(72),
  },
  [147] = {
    [sym__expression] = STATE(462),
    [sym__primary_expression] = STATE(463),
    [sym_not_operator] = STATE(462),
    [sym_boolean_operator] = STATE(462),
    [sym_binary_operator] = STATE(463),
    [sym_unary_operator] = STATE(463),
    [sym_comparison_operator] = STATE(462),
    [sym_lambda] = STATE(462),
    [sym_attribute] = STATE(463),
    [sym_subscript] = STATE(463),
    [sym_call] = STATE(463),
    [sym_list] = STATE(463),
    [sym_list_comprehension] = STATE(463),
    [sym_dictionary] = STATE(463),
    [sym_dictionary_comprehension] = STATE(463),
    [sym_set] = STATE(463),
    [sym_set_comprehension] = STATE(463),
    [sym_parenthesized_expression] = STATE(463),
    [sym_tuple] = STATE(463),
    [sym_generator_expression] = STATE(463),
    [sym_conditional_expression] = STATE(462),
    [sym_concatenated_string] = STATE(463),
    [sym_await] = STATE(462),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_COMMA] = ACTIONS(722),
    [anon_sym_STAR] = ACTIONS(820),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_not] = ACTIONS(822),
    [anon_sym_PLUS] = ACTIONS(824),
    [anon_sym_DASH] = ACTIONS(824),
    [anon_sym_TILDE] = ACTIONS(824),
    [anon_sym_lambda] = ACTIONS(826),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(828),
    [anon_sym_LBRACE] = ACTIONS(100),
    [anon_sym_RBRACE] = ACTIONS(722),
    [sym_string] = ACTIONS(830),
    [sym_integer] = ACTIONS(832),
    [sym_float] = ACTIONS(832),
    [sym_identifier] = ACTIONS(832),
    [sym_true] = ACTIONS(832),
    [sym_false] = ACTIONS(832),
    [sym_none] = ACTIONS(832),
    [anon_sym_await] = ACTIONS(834),
    [sym_comment] = ACTIONS(72),
  },
  [148] = {
    [sym__expression] = STATE(464),
    [sym__primary_expression] = STATE(157),
    [sym_not_operator] = STATE(464),
    [sym_boolean_operator] = STATE(464),
    [sym_binary_operator] = STATE(157),
    [sym_unary_operator] = STATE(157),
    [sym_comparison_operator] = STATE(464),
    [sym_lambda] = STATE(464),
    [sym_attribute] = STATE(157),
    [sym_subscript] = STATE(157),
    [sym_call] = STATE(157),
    [sym_list] = STATE(157),
    [sym_list_comprehension] = STATE(157),
    [sym_dictionary] = STATE(157),
    [sym_dictionary_comprehension] = STATE(157),
    [sym_set] = STATE(157),
    [sym_set_comprehension] = STATE(157),
    [sym_parenthesized_expression] = STATE(157),
    [sym_tuple] = STATE(157),
    [sym_generator_expression] = STATE(157),
    [sym_conditional_expression] = STATE(464),
    [sym_concatenated_string] = STATE(157),
    [sym_await] = STATE(464),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_not] = ACTIONS(260),
    [anon_sym_PLUS] = ACTIONS(262),
    [anon_sym_DASH] = ACTIONS(262),
    [anon_sym_TILDE] = ACTIONS(262),
    [anon_sym_lambda] = ACTIONS(264),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(266),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(270),
    [sym_integer] = ACTIONS(272),
    [sym_float] = ACTIONS(272),
    [sym_identifier] = ACTIONS(272),
    [sym_true] = ACTIONS(272),
    [sym_false] = ACTIONS(272),
    [sym_none] = ACTIONS(272),
    [anon_sym_await] = ACTIONS(274),
    [sym_comment] = ACTIONS(72),
  },
  [149] = {
    [sym__primary_expression] = STATE(204),
    [sym_binary_operator] = STATE(204),
    [sym_unary_operator] = STATE(204),
    [sym_attribute] = STATE(204),
    [sym_subscript] = STATE(204),
    [sym_call] = STATE(204),
    [sym_list] = STATE(204),
    [sym_list_comprehension] = STATE(204),
    [sym_dictionary] = STATE(204),
    [sym_dictionary_comprehension] = STATE(204),
    [sym_set] = STATE(204),
    [sym_set_comprehension] = STATE(204),
    [sym_parenthesized_expression] = STATE(204),
    [sym_tuple] = STATE(204),
    [sym_generator_expression] = STATE(204),
    [sym_concatenated_string] = STATE(204),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_PLUS] = ACTIONS(262),
    [anon_sym_DASH] = ACTIONS(262),
    [anon_sym_TILDE] = ACTIONS(262),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(376),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(270),
    [sym_integer] = ACTIONS(378),
    [sym_float] = ACTIONS(378),
    [sym_identifier] = ACTIONS(378),
    [sym_true] = ACTIONS(378),
    [sym_false] = ACTIONS(378),
    [sym_none] = ACTIONS(378),
    [sym_comment] = ACTIONS(72),
  },
  [150] = {
    [sym_lambda_parameters] = STATE(466),
    [sym__parameters] = STATE(130),
    [sym_default_parameter] = STATE(131),
    [sym_typed_default_parameter] = STATE(131),
    [sym_list_splat] = STATE(132),
    [sym_dictionary_splat] = STATE(132),
    [sym_typed_parameter] = STATE(131),
    [sym_tuple] = STATE(131),
    [anon_sym_LPAREN] = ACTIONS(222),
    [anon_sym_STAR] = ACTIONS(224),
    [anon_sym_print] = ACTIONS(226),
    [anon_sym_COLON] = ACTIONS(836),
    [anon_sym_exec] = ACTIONS(226),
    [sym_identifier] = ACTIONS(230),
    [sym_comment] = ACTIONS(72),
  },
  [151] = {
    [sym__newline] = ACTIONS(838),
    [anon_sym_DOT] = ACTIONS(838),
    [anon_sym_LPAREN] = ACTIONS(838),
    [anon_sym_COMMA] = ACTIONS(838),
    [anon_sym_STAR] = ACTIONS(840),
    [anon_sym_GT_GT] = ACTIONS(840),
    [anon_sym_if] = ACTIONS(838),
    [anon_sym_COLON] = ACTIONS(838),
    [anon_sym_in] = ACTIONS(838),
    [anon_sym_EQ] = ACTIONS(840),
    [anon_sym_AT] = ACTIONS(840),
    [anon_sym_not] = ACTIONS(838),
    [anon_sym_and] = ACTIONS(838),
    [anon_sym_or] = ACTIONS(838),
    [anon_sym_PLUS] = ACTIONS(840),
    [anon_sym_DASH] = ACTIONS(840),
    [anon_sym_SLASH] = ACTIONS(840),
    [anon_sym_PERCENT] = ACTIONS(840),
    [anon_sym_SLASH_SLASH] = ACTIONS(840),
    [anon_sym_STAR_STAR] = ACTIONS(840),
    [anon_sym_PIPE] = ACTIONS(840),
    [anon_sym_AMP] = ACTIONS(840),
    [anon_sym_CARET] = ACTIONS(840),
    [anon_sym_LT_LT] = ACTIONS(840),
    [anon_sym_LT] = ACTIONS(840),
    [anon_sym_LT_EQ] = ACTIONS(838),
    [anon_sym_EQ_EQ] = ACTIONS(838),
    [anon_sym_BANG_EQ] = ACTIONS(838),
    [anon_sym_GT_EQ] = ACTIONS(838),
    [anon_sym_GT] = ACTIONS(840),
    [anon_sym_LT_GT] = ACTIONS(838),
    [anon_sym_is] = ACTIONS(838),
    [anon_sym_PLUS_EQ] = ACTIONS(838),
    [anon_sym_DASH_EQ] = ACTIONS(838),
    [anon_sym_STAR_EQ] = ACTIONS(838),
    [anon_sym_SLASH_EQ] = ACTIONS(838),
    [anon_sym_AT_EQ] = ACTIONS(838),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(838),
    [anon_sym_PERCENT_EQ] = ACTIONS(838),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(838),
    [anon_sym_GT_GT_EQ] = ACTIONS(838),
    [anon_sym_LT_LT_EQ] = ACTIONS(838),
    [anon_sym_AMP_EQ] = ACTIONS(838),
    [anon_sym_CARET_EQ] = ACTIONS(838),
    [anon_sym_PIPE_EQ] = ACTIONS(838),
    [anon_sym_LBRACK] = ACTIONS(838),
    [sym_comment] = ACTIONS(72),
    [sym__semicolon] = ACTIONS(838),
  },
  [152] = {
    [aux_sym_concatenated_string_repeat1] = STATE(467),
    [anon_sym_DOT] = ACTIONS(276),
    [anon_sym_LPAREN] = ACTIONS(276),
    [anon_sym_COMMA] = ACTIONS(276),
    [anon_sym_STAR] = ACTIONS(278),
    [anon_sym_GT_GT] = ACTIONS(276),
    [anon_sym_if] = ACTIONS(276),
    [anon_sym_COLON] = ACTIONS(276),
    [anon_sym_async] = ACTIONS(276),
    [anon_sym_for] = ACTIONS(276),
    [anon_sym_in] = ACTIONS(276),
    [anon_sym_AT] = ACTIONS(276),
    [anon_sym_not] = ACTIONS(276),
    [anon_sym_and] = ACTIONS(276),
    [anon_sym_or] = ACTIONS(276),
    [anon_sym_PLUS] = ACTIONS(276),
    [anon_sym_DASH] = ACTIONS(276),
    [anon_sym_SLASH] = ACTIONS(278),
    [anon_sym_PERCENT] = ACTIONS(276),
    [anon_sym_SLASH_SLASH] = ACTIONS(276),
    [anon_sym_STAR_STAR] = ACTIONS(276),
    [anon_sym_PIPE] = ACTIONS(276),
    [anon_sym_AMP] = ACTIONS(276),
    [anon_sym_CARET] = ACTIONS(276),
    [anon_sym_LT_LT] = ACTIONS(276),
    [anon_sym_LT] = ACTIONS(278),
    [anon_sym_LT_EQ] = ACTIONS(276),
    [anon_sym_EQ_EQ] = ACTIONS(276),
    [anon_sym_BANG_EQ] = ACTIONS(276),
    [anon_sym_GT_EQ] = ACTIONS(276),
    [anon_sym_GT] = ACTIONS(278),
    [anon_sym_LT_GT] = ACTIONS(276),
    [anon_sym_is] = ACTIONS(276),
    [anon_sym_LBRACK] = ACTIONS(276),
    [anon_sym_RBRACE] = ACTIONS(276),
    [sym_string] = ACTIONS(842),
    [sym_comment] = ACTIONS(72),
  },
  [153] = {
    [sym__expression] = STATE(227),
    [sym__primary_expression] = STATE(157),
    [sym_not_operator] = STATE(227),
    [sym_boolean_operator] = STATE(227),
    [sym_binary_operator] = STATE(157),
    [sym_unary_operator] = STATE(157),
    [sym_comparison_operator] = STATE(227),
    [sym_lambda] = STATE(227),
    [sym_attribute] = STATE(157),
    [sym_subscript] = STATE(157),
    [sym_call] = STATE(157),
    [sym_list] = STATE(157),
    [sym_list_comprehension] = STATE(157),
    [sym_dictionary] = STATE(157),
    [sym_dictionary_comprehension] = STATE(157),
    [sym_set] = STATE(157),
    [sym_set_comprehension] = STATE(157),
    [sym_parenthesized_expression] = STATE(157),
    [sym_tuple] = STATE(157),
    [sym_generator_expression] = STATE(157),
    [sym_conditional_expression] = STATE(227),
    [sym_concatenated_string] = STATE(157),
    [sym_await] = STATE(227),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_not] = ACTIONS(260),
    [anon_sym_PLUS] = ACTIONS(262),
    [anon_sym_DASH] = ACTIONS(262),
    [anon_sym_TILDE] = ACTIONS(262),
    [anon_sym_lambda] = ACTIONS(264),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(266),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(270),
    [sym_integer] = ACTIONS(272),
    [sym_float] = ACTIONS(272),
    [sym_identifier] = ACTIONS(272),
    [sym_true] = ACTIONS(272),
    [sym_false] = ACTIONS(272),
    [sym_none] = ACTIONS(272),
    [anon_sym_await] = ACTIONS(274),
    [sym_comment] = ACTIONS(72),
  },
  [154] = {
    [aux_sym_list_repeat1] = STATE(470),
    [anon_sym_COMMA] = ACTIONS(844),
    [anon_sym_RBRACE] = ACTIONS(846),
    [sym_comment] = ACTIONS(72),
  },
  [155] = {
    [aux_sym_dictionary_repeat1] = STATE(472),
    [anon_sym_COMMA] = ACTIONS(848),
    [anon_sym_RBRACE] = ACTIONS(818),
    [sym_comment] = ACTIONS(72),
  },
  [156] = {
    [sym__comprehension_body] = STATE(479),
    [sym_for_in_clause] = STATE(480),
    [aux_sym_list_repeat1] = STATE(470),
    [anon_sym_COMMA] = ACTIONS(844),
    [anon_sym_if] = ACTIONS(850),
    [anon_sym_COLON] = ACTIONS(852),
    [anon_sym_async] = ACTIONS(854),
    [anon_sym_for] = ACTIONS(856),
    [anon_sym_and] = ACTIONS(858),
    [anon_sym_or] = ACTIONS(860),
    [anon_sym_RBRACE] = ACTIONS(846),
    [sym_comment] = ACTIONS(72),
  },
  [157] = {
    [sym_argument_list] = STATE(251),
    [sym_generator_expression] = STATE(251),
    [aux_sym_comparison_operator_repeat1] = STATE(491),
    [anon_sym_DOT] = ACTIONS(422),
    [anon_sym_LPAREN] = ACTIONS(424),
    [anon_sym_COMMA] = ACTIONS(302),
    [anon_sym_STAR] = ACTIONS(862),
    [anon_sym_GT_GT] = ACTIONS(864),
    [anon_sym_if] = ACTIONS(302),
    [anon_sym_COLON] = ACTIONS(302),
    [anon_sym_async] = ACTIONS(302),
    [anon_sym_for] = ACTIONS(302),
    [anon_sym_in] = ACTIONS(866),
    [anon_sym_AT] = ACTIONS(868),
    [anon_sym_not] = ACTIONS(870),
    [anon_sym_and] = ACTIONS(302),
    [anon_sym_or] = ACTIONS(302),
    [anon_sym_PLUS] = ACTIONS(872),
    [anon_sym_DASH] = ACTIONS(872),
    [anon_sym_SLASH] = ACTIONS(862),
    [anon_sym_PERCENT] = ACTIONS(868),
    [anon_sym_SLASH_SLASH] = ACTIONS(868),
    [anon_sym_STAR_STAR] = ACTIONS(874),
    [anon_sym_PIPE] = ACTIONS(876),
    [anon_sym_AMP] = ACTIONS(878),
    [anon_sym_CARET] = ACTIONS(880),
    [anon_sym_LT_LT] = ACTIONS(864),
    [anon_sym_LT] = ACTIONS(882),
    [anon_sym_LT_EQ] = ACTIONS(866),
    [anon_sym_EQ_EQ] = ACTIONS(866),
    [anon_sym_BANG_EQ] = ACTIONS(866),
    [anon_sym_GT_EQ] = ACTIONS(866),
    [anon_sym_GT] = ACTIONS(882),
    [anon_sym_LT_GT] = ACTIONS(866),
    [anon_sym_is] = ACTIONS(884),
    [anon_sym_LBRACK] = ACTIONS(450),
    [anon_sym_RBRACE] = ACTIONS(302),
    [sym_comment] = ACTIONS(72),
  },
  [158] = {
    [sym__comprehension_body] = STATE(492),
    [sym_for_in_clause] = STATE(480),
    [aux_sym_dictionary_repeat1] = STATE(472),
    [anon_sym_COMMA] = ACTIONS(848),
    [anon_sym_async] = ACTIONS(854),
    [anon_sym_for] = ACTIONS(856),
    [anon_sym_RBRACE] = ACTIONS(818),
    [sym_comment] = ACTIONS(72),
  },
  [159] = {
    [aux_sym_concatenated_string_repeat1] = STATE(493),
    [sym__newline] = ACTIONS(886),
    [anon_sym_DOT] = ACTIONS(886),
    [anon_sym_LPAREN] = ACTIONS(886),
    [anon_sym_COMMA] = ACTIONS(886),
    [anon_sym_STAR] = ACTIONS(888),
    [anon_sym_GT_GT] = ACTIONS(888),
    [anon_sym_if] = ACTIONS(886),
    [anon_sym_COLON] = ACTIONS(886),
    [anon_sym_in] = ACTIONS(886),
    [anon_sym_EQ] = ACTIONS(888),
    [anon_sym_AT] = ACTIONS(888),
    [anon_sym_not] = ACTIONS(886),
    [anon_sym_and] = ACTIONS(886),
    [anon_sym_or] = ACTIONS(886),
    [anon_sym_PLUS] = ACTIONS(888),
    [anon_sym_DASH] = ACTIONS(888),
    [anon_sym_SLASH] = ACTIONS(888),
    [anon_sym_PERCENT] = ACTIONS(888),
    [anon_sym_SLASH_SLASH] = ACTIONS(888),
    [anon_sym_STAR_STAR] = ACTIONS(888),
    [anon_sym_PIPE] = ACTIONS(888),
    [anon_sym_AMP] = ACTIONS(888),
    [anon_sym_CARET] = ACTIONS(888),
    [anon_sym_LT_LT] = ACTIONS(888),
    [anon_sym_LT] = ACTIONS(888),
    [anon_sym_LT_EQ] = ACTIONS(886),
    [anon_sym_EQ_EQ] = ACTIONS(886),
    [anon_sym_BANG_EQ] = ACTIONS(886),
    [anon_sym_GT_EQ] = ACTIONS(886),
    [anon_sym_GT] = ACTIONS(888),
    [anon_sym_LT_GT] = ACTIONS(886),
    [anon_sym_is] = ACTIONS(886),
    [anon_sym_PLUS_EQ] = ACTIONS(886),
    [anon_sym_DASH_EQ] = ACTIONS(886),
    [anon_sym_STAR_EQ] = ACTIONS(886),
    [anon_sym_SLASH_EQ] = ACTIONS(886),
    [anon_sym_AT_EQ] = ACTIONS(886),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(886),
    [anon_sym_PERCENT_EQ] = ACTIONS(886),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(886),
    [anon_sym_GT_GT_EQ] = ACTIONS(886),
    [anon_sym_LT_LT_EQ] = ACTIONS(886),
    [anon_sym_AMP_EQ] = ACTIONS(886),
    [anon_sym_CARET_EQ] = ACTIONS(886),
    [anon_sym_PIPE_EQ] = ACTIONS(886),
    [anon_sym_LBRACK] = ACTIONS(886),
    [sym_string] = ACTIONS(890),
    [sym_comment] = ACTIONS(72),
    [sym__semicolon] = ACTIONS(886),
  },
  [160] = {
    [sym__newline] = ACTIONS(892),
    [anon_sym_from] = ACTIONS(892),
    [anon_sym_COMMA] = ACTIONS(892),
    [anon_sym_if] = ACTIONS(892),
    [anon_sym_COLON] = ACTIONS(892),
    [anon_sym_EQ] = ACTIONS(892),
    [anon_sym_and] = ACTIONS(892),
    [anon_sym_or] = ACTIONS(892),
    [anon_sym_PLUS_EQ] = ACTIONS(892),
    [anon_sym_DASH_EQ] = ACTIONS(892),
    [anon_sym_STAR_EQ] = ACTIONS(892),
    [anon_sym_SLASH_EQ] = ACTIONS(892),
    [anon_sym_AT_EQ] = ACTIONS(892),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(892),
    [anon_sym_PERCENT_EQ] = ACTIONS(892),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(892),
    [anon_sym_GT_GT_EQ] = ACTIONS(892),
    [anon_sym_LT_LT_EQ] = ACTIONS(892),
    [anon_sym_AMP_EQ] = ACTIONS(892),
    [anon_sym_CARET_EQ] = ACTIONS(892),
    [anon_sym_PIPE_EQ] = ACTIONS(892),
    [sym_comment] = ACTIONS(72),
    [sym__semicolon] = ACTIONS(892),
  },
  [161] = {
    [sym__expression] = STATE(499),
    [sym__primary_expression] = STATE(500),
    [sym_not_operator] = STATE(499),
    [sym_boolean_operator] = STATE(499),
    [sym_binary_operator] = STATE(500),
    [sym_unary_operator] = STATE(500),
    [sym_comparison_operator] = STATE(499),
    [sym_lambda] = STATE(499),
    [sym_attribute] = STATE(500),
    [sym_subscript] = STATE(500),
    [sym_call] = STATE(500),
    [sym_type] = STATE(501),
    [sym_list] = STATE(500),
    [sym_list_comprehension] = STATE(500),
    [sym_dictionary] = STATE(500),
    [sym_dictionary_comprehension] = STATE(500),
    [sym_set] = STATE(500),
    [sym_set_comprehension] = STATE(500),
    [sym_parenthesized_expression] = STATE(500),
    [sym_tuple] = STATE(500),
    [sym_generator_expression] = STATE(500),
    [sym_conditional_expression] = STATE(499),
    [sym_concatenated_string] = STATE(500),
    [sym_await] = STATE(499),
    [anon_sym_LPAREN] = ACTIONS(130),
    [anon_sym_print] = ACTIONS(112),
    [anon_sym_exec] = ACTIONS(112),
    [anon_sym_not] = ACTIONS(894),
    [anon_sym_PLUS] = ACTIONS(896),
    [anon_sym_DASH] = ACTIONS(896),
    [anon_sym_TILDE] = ACTIONS(896),
    [anon_sym_lambda] = ACTIONS(898),
    [anon_sym_LBRACK] = ACTIONS(134),
    [sym_ellipsis] = ACTIONS(900),
    [anon_sym_LBRACE] = ACTIONS(122),
    [sym_string] = ACTIONS(902),
    [sym_integer] = ACTIONS(904),
    [sym_float] = ACTIONS(904),
    [sym_identifier] = ACTIONS(904),
    [sym_true] = ACTIONS(904),
    [sym_false] = ACTIONS(904),
    [sym_none] = ACTIONS(904),
    [anon_sym_await] = ACTIONS(906),
    [sym_comment] = ACTIONS(72),
  },
  [162] = {
    [sym_expression_list] = STATE(502),
    [sym__expression] = STATE(503),
    [sym__primary_expression] = STATE(34),
    [sym_not_operator] = STATE(503),
    [sym_boolean_operator] = STATE(503),
    [sym_binary_operator] = STATE(34),
    [sym_unary_operator] = STATE(34),
    [sym_comparison_operator] = STATE(503),
    [sym_lambda] = STATE(503),
    [sym_assignment] = STATE(504),
    [sym_augmented_assignment] = STATE(504),
    [sym__right_hand_side] = STATE(504),
    [sym_yield] = STATE(504),
    [sym_attribute] = STATE(34),
    [sym_subscript] = STATE(34),
    [sym_call] = STATE(34),
    [sym_list] = STATE(34),
    [sym_list_comprehension] = STATE(34),
    [sym_dictionary] = STATE(34),
    [sym_dictionary_comprehension] = STATE(34),
    [sym_set] = STATE(34),
    [sym_set_comprehension] = STATE(34),
    [sym_parenthesized_expression] = STATE(34),
    [sym_tuple] = STATE(34),
    [sym_generator_expression] = STATE(34),
    [sym_conditional_expression] = STATE(503),
    [sym_concatenated_string] = STATE(34),
    [sym_await] = STATE(503),
    [anon_sym_LPAREN] = ACTIONS(14),
    [anon_sym_print] = ACTIONS(216),
    [anon_sym_exec] = ACTIONS(216),
    [anon_sym_not] = ACTIONS(52),
    [anon_sym_PLUS] = ACTIONS(54),
    [anon_sym_DASH] = ACTIONS(54),
    [anon_sym_TILDE] = ACTIONS(54),
    [anon_sym_lambda] = ACTIONS(56),
    [anon_sym_yield] = ACTIONS(58),
    [anon_sym_LBRACK] = ACTIONS(60),
    [sym_ellipsis] = ACTIONS(62),
    [anon_sym_LBRACE] = ACTIONS(64),
    [sym_string] = ACTIONS(66),
    [sym_integer] = ACTIONS(68),
    [sym_float] = ACTIONS(68),
    [sym_identifier] = ACTIONS(68),
    [sym_true] = ACTIONS(68),
    [sym_false] = ACTIONS(68),
    [sym_none] = ACTIONS(68),
    [anon_sym_await] = ACTIONS(70),
    [sym_comment] = ACTIONS(72),
  },
  [163] = {
    [sym_expression_list] = STATE(502),
    [sym__expression] = STATE(503),
    [sym__primary_expression] = STATE(34),
    [sym_not_operator] = STATE(503),
    [sym_boolean_operator] = STATE(503),
    [sym_binary_operator] = STATE(34),
    [sym_unary_operator] = STATE(34),
    [sym_comparison_operator] = STATE(503),
    [sym_lambda] = STATE(503),
    [sym_assignment] = STATE(505),
    [sym_augmented_assignment] = STATE(505),
    [sym__right_hand_side] = STATE(505),
    [sym_yield] = STATE(505),
    [sym_attribute] = STATE(34),
    [sym_subscript] = STATE(34),
    [sym_call] = STATE(34),
    [sym_list] = STATE(34),
    [sym_list_comprehension] = STATE(34),
    [sym_dictionary] = STATE(34),
    [sym_dictionary_comprehension] = STATE(34),
    [sym_set] = STATE(34),
    [sym_set_comprehension] = STATE(34),
    [sym_parenthesized_expression] = STATE(34),
    [sym_tuple] = STATE(34),
    [sym_generator_expression] = STATE(34),
    [sym_conditional_expression] = STATE(503),
    [sym_concatenated_string] = STATE(34),
    [sym_await] = STATE(503),
    [anon_sym_LPAREN] = ACTIONS(14),
    [anon_sym_print] = ACTIONS(216),
    [anon_sym_exec] = ACTIONS(216),
    [anon_sym_not] = ACTIONS(52),
    [anon_sym_PLUS] = ACTIONS(54),
    [anon_sym_DASH] = ACTIONS(54),
    [anon_sym_TILDE] = ACTIONS(54),
    [anon_sym_lambda] = ACTIONS(56),
    [anon_sym_yield] = ACTIONS(58),
    [anon_sym_LBRACK] = ACTIONS(60),
    [sym_ellipsis] = ACTIONS(62),
    [anon_sym_LBRACE] = ACTIONS(64),
    [sym_string] = ACTIONS(66),
    [sym_integer] = ACTIONS(68),
    [sym_float] = ACTIONS(68),
    [sym_identifier] = ACTIONS(68),
    [sym_true] = ACTIONS(68),
    [sym_false] = ACTIONS(68),
    [sym_none] = ACTIONS(68),
    [anon_sym_await] = ACTIONS(70),
    [sym_comment] = ACTIONS(72),
  },
  [164] = {
    [sym__expression] = STATE(506),
    [sym__primary_expression] = STATE(34),
    [sym_not_operator] = STATE(506),
    [sym_boolean_operator] = STATE(506),
    [sym_binary_operator] = STATE(34),
    [sym_unary_operator] = STATE(34),
    [sym_comparison_operator] = STATE(506),
    [sym_lambda] = STATE(506),
    [sym_attribute] = STATE(34),
    [sym_subscript] = STATE(34),
    [sym_call] = STATE(34),
    [sym_list] = STATE(34),
    [sym_list_comprehension] = STATE(34),
    [sym_dictionary] = STATE(34),
    [sym_dictionary_comprehension] = STATE(34),
    [sym_set] = STATE(34),
    [sym_set_comprehension] = STATE(34),
    [sym_parenthesized_expression] = STATE(34),
    [sym_tuple] = STATE(34),
    [sym_generator_expression] = STATE(34),
    [sym_conditional_expression] = STATE(506),
    [sym_concatenated_string] = STATE(34),
    [sym_await] = STATE(506),
    [sym__newline] = ACTIONS(908),
    [anon_sym_LPAREN] = ACTIONS(14),
    [anon_sym_print] = ACTIONS(216),
    [anon_sym_COLON] = ACTIONS(910),
    [anon_sym_EQ] = ACTIONS(910),
    [anon_sym_exec] = ACTIONS(216),
    [anon_sym_not] = ACTIONS(52),
    [anon_sym_PLUS] = ACTIONS(912),
    [anon_sym_DASH] = ACTIONS(912),
    [anon_sym_TILDE] = ACTIONS(54),
    [anon_sym_lambda] = ACTIONS(56),
    [anon_sym_PLUS_EQ] = ACTIONS(910),
    [anon_sym_DASH_EQ] = ACTIONS(910),
    [anon_sym_STAR_EQ] = ACTIONS(910),
    [anon_sym_SLASH_EQ] = ACTIONS(910),
    [anon_sym_AT_EQ] = ACTIONS(910),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(910),
    [anon_sym_PERCENT_EQ] = ACTIONS(910),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(910),
    [anon_sym_GT_GT_EQ] = ACTIONS(910),
    [anon_sym_LT_LT_EQ] = ACTIONS(910),
    [anon_sym_AMP_EQ] = ACTIONS(910),
    [anon_sym_CARET_EQ] = ACTIONS(910),
    [anon_sym_PIPE_EQ] = ACTIONS(910),
    [anon_sym_LBRACK] = ACTIONS(60),
    [sym_ellipsis] = ACTIONS(62),
    [anon_sym_LBRACE] = ACTIONS(64),
    [sym_string] = ACTIONS(66),
    [sym_integer] = ACTIONS(68),
    [sym_float] = ACTIONS(68),
    [sym_identifier] = ACTIONS(68),
    [sym_true] = ACTIONS(68),
    [sym_false] = ACTIONS(68),
    [sym_none] = ACTIONS(68),
    [anon_sym_await] = ACTIONS(70),
    [sym_comment] = ACTIONS(72),
    [sym__semicolon] = ACTIONS(908),
  },
  [165] = {
    [sym__expression] = STATE(512),
    [sym__primary_expression] = STATE(513),
    [sym_not_operator] = STATE(512),
    [sym_boolean_operator] = STATE(512),
    [sym_binary_operator] = STATE(513),
    [sym_unary_operator] = STATE(513),
    [sym_comparison_operator] = STATE(512),
    [sym_lambda] = STATE(512),
    [sym_attribute] = STATE(513),
    [sym_subscript] = STATE(513),
    [sym_call] = STATE(513),
    [sym_list] = STATE(513),
    [sym_list_comprehension] = STATE(513),
    [sym_dictionary] = STATE(513),
    [sym_dictionary_comprehension] = STATE(513),
    [sym_set] = STATE(513),
    [sym_set_comprehension] = STATE(513),
    [sym_parenthesized_expression] = STATE(513),
    [sym_tuple] = STATE(513),
    [sym_generator_expression] = STATE(513),
    [sym_conditional_expression] = STATE(512),
    [sym_concatenated_string] = STATE(513),
    [sym_await] = STATE(512),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_not] = ACTIONS(914),
    [anon_sym_PLUS] = ACTIONS(916),
    [anon_sym_DASH] = ACTIONS(916),
    [anon_sym_TILDE] = ACTIONS(916),
    [anon_sym_lambda] = ACTIONS(918),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(920),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(922),
    [sym_integer] = ACTIONS(924),
    [sym_float] = ACTIONS(924),
    [sym_identifier] = ACTIONS(924),
    [sym_true] = ACTIONS(924),
    [sym_false] = ACTIONS(924),
    [sym_none] = ACTIONS(924),
    [anon_sym_await] = ACTIONS(926),
    [sym_comment] = ACTIONS(72),
  },
  [166] = {
    [sym__expression] = STATE(514),
    [sym__primary_expression] = STATE(34),
    [sym_not_operator] = STATE(514),
    [sym_boolean_operator] = STATE(514),
    [sym_binary_operator] = STATE(34),
    [sym_unary_operator] = STATE(34),
    [sym_comparison_operator] = STATE(514),
    [sym_lambda] = STATE(514),
    [sym_attribute] = STATE(34),
    [sym_subscript] = STATE(34),
    [sym_call] = STATE(34),
    [sym_list] = STATE(34),
    [sym_list_comprehension] = STATE(34),
    [sym_dictionary] = STATE(34),
    [sym_dictionary_comprehension] = STATE(34),
    [sym_set] = STATE(34),
    [sym_set_comprehension] = STATE(34),
    [sym_parenthesized_expression] = STATE(34),
    [sym_tuple] = STATE(34),
    [sym_generator_expression] = STATE(34),
    [sym_conditional_expression] = STATE(514),
    [sym_concatenated_string] = STATE(34),
    [sym_await] = STATE(514),
    [anon_sym_LPAREN] = ACTIONS(14),
    [anon_sym_print] = ACTIONS(216),
    [anon_sym_exec] = ACTIONS(216),
    [anon_sym_not] = ACTIONS(52),
    [anon_sym_PLUS] = ACTIONS(54),
    [anon_sym_DASH] = ACTIONS(54),
    [anon_sym_TILDE] = ACTIONS(54),
    [anon_sym_lambda] = ACTIONS(56),
    [anon_sym_LBRACK] = ACTIONS(60),
    [sym_ellipsis] = ACTIONS(62),
    [anon_sym_LBRACE] = ACTIONS(64),
    [sym_string] = ACTIONS(66),
    [sym_integer] = ACTIONS(68),
    [sym_float] = ACTIONS(68),
    [sym_identifier] = ACTIONS(68),
    [sym_true] = ACTIONS(68),
    [sym_false] = ACTIONS(68),
    [sym_none] = ACTIONS(68),
    [anon_sym_await] = ACTIONS(70),
    [sym_comment] = ACTIONS(72),
  },
  [167] = {
    [sym__expression] = STATE(515),
    [sym__primary_expression] = STATE(34),
    [sym_not_operator] = STATE(515),
    [sym_boolean_operator] = STATE(515),
    [sym_binary_operator] = STATE(34),
    [sym_unary_operator] = STATE(34),
    [sym_comparison_operator] = STATE(515),
    [sym_lambda] = STATE(515),
    [sym_attribute] = STATE(34),
    [sym_subscript] = STATE(34),
    [sym_call] = STATE(34),
    [sym_list] = STATE(34),
    [sym_list_comprehension] = STATE(34),
    [sym_dictionary] = STATE(34),
    [sym_dictionary_comprehension] = STATE(34),
    [sym_set] = STATE(34),
    [sym_set_comprehension] = STATE(34),
    [sym_parenthesized_expression] = STATE(34),
    [sym_tuple] = STATE(34),
    [sym_generator_expression] = STATE(34),
    [sym_conditional_expression] = STATE(515),
    [sym_concatenated_string] = STATE(34),
    [sym_await] = STATE(515),
    [anon_sym_LPAREN] = ACTIONS(14),
    [anon_sym_print] = ACTIONS(216),
    [anon_sym_exec] = ACTIONS(216),
    [anon_sym_not] = ACTIONS(52),
    [anon_sym_PLUS] = ACTIONS(54),
    [anon_sym_DASH] = ACTIONS(54),
    [anon_sym_TILDE] = ACTIONS(54),
    [anon_sym_lambda] = ACTIONS(56),
    [anon_sym_LBRACK] = ACTIONS(60),
    [sym_ellipsis] = ACTIONS(62),
    [anon_sym_LBRACE] = ACTIONS(64),
    [sym_string] = ACTIONS(66),
    [sym_integer] = ACTIONS(68),
    [sym_float] = ACTIONS(68),
    [sym_identifier] = ACTIONS(68),
    [sym_true] = ACTIONS(68),
    [sym_false] = ACTIONS(68),
    [sym_none] = ACTIONS(68),
    [anon_sym_await] = ACTIONS(70),
    [sym_comment] = ACTIONS(72),
  },
  [168] = {
    [aux_sym_print_statement_repeat1] = STATE(517),
    [sym__newline] = ACTIONS(908),
    [anon_sym_COMMA] = ACTIONS(928),
    [anon_sym_COLON] = ACTIONS(910),
    [anon_sym_EQ] = ACTIONS(910),
    [anon_sym_PLUS_EQ] = ACTIONS(910),
    [anon_sym_DASH_EQ] = ACTIONS(910),
    [anon_sym_STAR_EQ] = ACTIONS(910),
    [anon_sym_SLASH_EQ] = ACTIONS(910),
    [anon_sym_AT_EQ] = ACTIONS(910),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(910),
    [anon_sym_PERCENT_EQ] = ACTIONS(910),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(910),
    [anon_sym_GT_GT_EQ] = ACTIONS(910),
    [anon_sym_LT_LT_EQ] = ACTIONS(910),
    [anon_sym_AMP_EQ] = ACTIONS(910),
    [anon_sym_CARET_EQ] = ACTIONS(910),
    [anon_sym_PIPE_EQ] = ACTIONS(910),
    [sym_comment] = ACTIONS(72),
    [sym__semicolon] = ACTIONS(908),
  },
  [169] = {
    [sym_identifier] = ACTIONS(930),
    [sym_comment] = ACTIONS(72),
  },
  [170] = {
    [sym_list_splat] = STATE(524),
    [sym_dictionary_splat] = STATE(524),
    [sym__expression] = STATE(525),
    [sym__primary_expression] = STATE(59),
    [sym_not_operator] = STATE(525),
    [sym_boolean_operator] = STATE(525),
    [sym_binary_operator] = STATE(59),
    [sym_unary_operator] = STATE(59),
    [sym_comparison_operator] = STATE(525),
    [sym_lambda] = STATE(525),
    [sym_attribute] = STATE(59),
    [sym_subscript] = STATE(59),
    [sym_call] = STATE(59),
    [sym_keyword_argument] = STATE(524),
    [sym_list] = STATE(59),
    [sym_list_comprehension] = STATE(59),
    [sym_dictionary] = STATE(59),
    [sym_dictionary_comprehension] = STATE(59),
    [sym_set] = STATE(59),
    [sym_set_comprehension] = STATE(59),
    [sym_parenthesized_expression] = STATE(59),
    [sym_tuple] = STATE(59),
    [sym_generator_expression] = STATE(59),
    [sym_conditional_expression] = STATE(525),
    [sym_concatenated_string] = STATE(59),
    [sym_await] = STATE(525),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_RPAREN] = ACTIONS(932),
    [anon_sym_COMMA] = ACTIONS(934),
    [anon_sym_STAR] = ACTIONS(936),
    [anon_sym_print] = ACTIONS(938),
    [anon_sym_exec] = ACTIONS(938),
    [anon_sym_not] = ACTIONS(88),
    [anon_sym_PLUS] = ACTIONS(90),
    [anon_sym_DASH] = ACTIONS(90),
    [anon_sym_TILDE] = ACTIONS(90),
    [anon_sym_lambda] = ACTIONS(92),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(98),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(102),
    [sym_integer] = ACTIONS(104),
    [sym_float] = ACTIONS(104),
    [sym_identifier] = ACTIONS(940),
    [sym_true] = ACTIONS(104),
    [sym_false] = ACTIONS(104),
    [sym_none] = ACTIONS(104),
    [anon_sym_await] = ACTIONS(106),
    [sym_comment] = ACTIONS(72),
  },
  [171] = {
    [sym__primary_expression] = STATE(526),
    [sym_binary_operator] = STATE(526),
    [sym_unary_operator] = STATE(526),
    [sym_attribute] = STATE(526),
    [sym_subscript] = STATE(526),
    [sym_call] = STATE(526),
    [sym_list] = STATE(526),
    [sym_list_comprehension] = STATE(526),
    [sym_dictionary] = STATE(526),
    [sym_dictionary_comprehension] = STATE(526),
    [sym_set] = STATE(526),
    [sym_set_comprehension] = STATE(526),
    [sym_parenthesized_expression] = STATE(526),
    [sym_tuple] = STATE(526),
    [sym_generator_expression] = STATE(526),
    [sym_concatenated_string] = STATE(526),
    [anon_sym_LPAREN] = ACTIONS(14),
    [anon_sym_print] = ACTIONS(216),
    [anon_sym_exec] = ACTIONS(216),
    [anon_sym_PLUS] = ACTIONS(54),
    [anon_sym_DASH] = ACTIONS(54),
    [anon_sym_TILDE] = ACTIONS(54),
    [anon_sym_LBRACK] = ACTIONS(60),
    [sym_ellipsis] = ACTIONS(942),
    [anon_sym_LBRACE] = ACTIONS(64),
    [sym_string] = ACTIONS(66),
    [sym_integer] = ACTIONS(944),
    [sym_float] = ACTIONS(944),
    [sym_identifier] = ACTIONS(944),
    [sym_true] = ACTIONS(944),
    [sym_false] = ACTIONS(944),
    [sym_none] = ACTIONS(944),
    [sym_comment] = ACTIONS(72),
  },
  [172] = {
    [sym__primary_expression] = STATE(527),
    [sym_binary_operator] = STATE(527),
    [sym_unary_operator] = STATE(527),
    [sym_attribute] = STATE(527),
    [sym_subscript] = STATE(527),
    [sym_call] = STATE(527),
    [sym_list] = STATE(527),
    [sym_list_comprehension] = STATE(527),
    [sym_dictionary] = STATE(527),
    [sym_dictionary_comprehension] = STATE(527),
    [sym_set] = STATE(527),
    [sym_set_comprehension] = STATE(527),
    [sym_parenthesized_expression] = STATE(527),
    [sym_tuple] = STATE(527),
    [sym_generator_expression] = STATE(527),
    [sym_concatenated_string] = STATE(527),
    [anon_sym_LPAREN] = ACTIONS(14),
    [anon_sym_print] = ACTIONS(216),
    [anon_sym_exec] = ACTIONS(216),
    [anon_sym_PLUS] = ACTIONS(54),
    [anon_sym_DASH] = ACTIONS(54),
    [anon_sym_TILDE] = ACTIONS(54),
    [anon_sym_LBRACK] = ACTIONS(60),
    [sym_ellipsis] = ACTIONS(946),
    [anon_sym_LBRACE] = ACTIONS(64),
    [sym_string] = ACTIONS(66),
    [sym_integer] = ACTIONS(948),
    [sym_float] = ACTIONS(948),
    [sym_identifier] = ACTIONS(948),
    [sym_true] = ACTIONS(948),
    [sym_false] = ACTIONS(948),
    [sym_none] = ACTIONS(948),
    [sym_comment] = ACTIONS(72),
  },
  [173] = {
    [sym__primary_expression] = STATE(528),
    [sym_binary_operator] = STATE(528),
    [sym_unary_operator] = STATE(528),
    [sym_attribute] = STATE(528),
    [sym_subscript] = STATE(528),
    [sym_call] = STATE(528),
    [sym_list] = STATE(528),
    [sym_list_comprehension] = STATE(528),
    [sym_dictionary] = STATE(528),
    [sym_dictionary_comprehension] = STATE(528),
    [sym_set] = STATE(528),
    [sym_set_comprehension] = STATE(528),
    [sym_parenthesized_expression] = STATE(528),
    [sym_tuple] = STATE(528),
    [sym_generator_expression] = STATE(528),
    [sym_concatenated_string] = STATE(528),
    [anon_sym_LPAREN] = ACTIONS(14),
    [anon_sym_print] = ACTIONS(216),
    [anon_sym_exec] = ACTIONS(216),
    [anon_sym_PLUS] = ACTIONS(54),
    [anon_sym_DASH] = ACTIONS(54),
    [anon_sym_TILDE] = ACTIONS(54),
    [anon_sym_LBRACK] = ACTIONS(60),
    [sym_ellipsis] = ACTIONS(950),
    [anon_sym_LBRACE] = ACTIONS(64),
    [sym_string] = ACTIONS(66),
    [sym_integer] = ACTIONS(952),
    [sym_float] = ACTIONS(952),
    [sym_identifier] = ACTIONS(952),
    [sym_true] = ACTIONS(952),
    [sym_false] = ACTIONS(952),
    [sym_none] = ACTIONS(952),
    [sym_comment] = ACTIONS(72),
  },
  [174] = {
    [anon_sym_in] = ACTIONS(954),
    [sym_comment] = ACTIONS(72),
  },
  [175] = {
    [sym__primary_expression] = STATE(530),
    [sym_binary_operator] = STATE(530),
    [sym_unary_operator] = STATE(530),
    [sym_attribute] = STATE(530),
    [sym_subscript] = STATE(530),
    [sym_call] = STATE(530),
    [sym_list] = STATE(530),
    [sym_list_comprehension] = STATE(530),
    [sym_dictionary] = STATE(530),
    [sym_dictionary_comprehension] = STATE(530),
    [sym_set] = STATE(530),
    [sym_set_comprehension] = STATE(530),
    [sym_parenthesized_expression] = STATE(530),
    [sym_tuple] = STATE(530),
    [sym_generator_expression] = STATE(530),
    [sym_concatenated_string] = STATE(530),
    [anon_sym_LPAREN] = ACTIONS(14),
    [anon_sym_print] = ACTIONS(216),
    [anon_sym_exec] = ACTIONS(216),
    [anon_sym_PLUS] = ACTIONS(54),
    [anon_sym_DASH] = ACTIONS(54),
    [anon_sym_TILDE] = ACTIONS(54),
    [anon_sym_LBRACK] = ACTIONS(60),
    [sym_ellipsis] = ACTIONS(956),
    [anon_sym_LBRACE] = ACTIONS(64),
    [sym_string] = ACTIONS(66),
    [sym_integer] = ACTIONS(958),
    [sym_float] = ACTIONS(958),
    [sym_identifier] = ACTIONS(958),
    [sym_true] = ACTIONS(958),
    [sym_false] = ACTIONS(958),
    [sym_none] = ACTIONS(958),
    [sym_comment] = ACTIONS(72),
  },
  [176] = {
    [sym__primary_expression] = STATE(531),
    [sym_binary_operator] = STATE(531),
    [sym_unary_operator] = STATE(531),
    [sym_attribute] = STATE(531),
    [sym_subscript] = STATE(531),
    [sym_call] = STATE(531),
    [sym_list] = STATE(531),
    [sym_list_comprehension] = STATE(531),
    [sym_dictionary] = STATE(531),
    [sym_dictionary_comprehension] = STATE(531),
    [sym_set] = STATE(531),
    [sym_set_comprehension] = STATE(531),
    [sym_parenthesized_expression] = STATE(531),
    [sym_tuple] = STATE(531),
    [sym_generator_expression] = STATE(531),
    [sym_concatenated_string] = STATE(531),
    [anon_sym_LPAREN] = ACTIONS(14),
    [anon_sym_print] = ACTIONS(216),
    [anon_sym_exec] = ACTIONS(216),
    [anon_sym_PLUS] = ACTIONS(54),
    [anon_sym_DASH] = ACTIONS(54),
    [anon_sym_TILDE] = ACTIONS(54),
    [anon_sym_LBRACK] = ACTIONS(60),
    [sym_ellipsis] = ACTIONS(960),
    [anon_sym_LBRACE] = ACTIONS(64),
    [sym_string] = ACTIONS(66),
    [sym_integer] = ACTIONS(962),
    [sym_float] = ACTIONS(962),
    [sym_identifier] = ACTIONS(962),
    [sym_true] = ACTIONS(962),
    [sym_false] = ACTIONS(962),
    [sym_none] = ACTIONS(962),
    [sym_comment] = ACTIONS(72),
  },
  [177] = {
    [sym__primary_expression] = STATE(532),
    [sym_binary_operator] = STATE(532),
    [sym_unary_operator] = STATE(532),
    [sym_attribute] = STATE(532),
    [sym_subscript] = STATE(532),
    [sym_call] = STATE(532),
    [sym_list] = STATE(532),
    [sym_list_comprehension] = STATE(532),
    [sym_dictionary] = STATE(532),
    [sym_dictionary_comprehension] = STATE(532),
    [sym_set] = STATE(532),
    [sym_set_comprehension] = STATE(532),
    [sym_parenthesized_expression] = STATE(532),
    [sym_tuple] = STATE(532),
    [sym_generator_expression] = STATE(532),
    [sym_concatenated_string] = STATE(532),
    [anon_sym_LPAREN] = ACTIONS(14),
    [anon_sym_print] = ACTIONS(216),
    [anon_sym_exec] = ACTIONS(216),
    [anon_sym_PLUS] = ACTIONS(54),
    [anon_sym_DASH] = ACTIONS(54),
    [anon_sym_TILDE] = ACTIONS(54),
    [anon_sym_LBRACK] = ACTIONS(60),
    [sym_ellipsis] = ACTIONS(964),
    [anon_sym_LBRACE] = ACTIONS(64),
    [sym_string] = ACTIONS(66),
    [sym_integer] = ACTIONS(966),
    [sym_float] = ACTIONS(966),
    [sym_identifier] = ACTIONS(966),
    [sym_true] = ACTIONS(966),
    [sym_false] = ACTIONS(966),
    [sym_none] = ACTIONS(966),
    [sym_comment] = ACTIONS(72),
  },
  [178] = {
    [sym__primary_expression] = STATE(533),
    [sym_binary_operator] = STATE(533),
    [sym_unary_operator] = STATE(533),
    [sym_attribute] = STATE(533),
    [sym_subscript] = STATE(533),
    [sym_call] = STATE(533),
    [sym_list] = STATE(533),
    [sym_list_comprehension] = STATE(533),
    [sym_dictionary] = STATE(533),
    [sym_dictionary_comprehension] = STATE(533),
    [sym_set] = STATE(533),
    [sym_set_comprehension] = STATE(533),
    [sym_parenthesized_expression] = STATE(533),
    [sym_tuple] = STATE(533),
    [sym_generator_expression] = STATE(533),
    [sym_concatenated_string] = STATE(533),
    [anon_sym_LPAREN] = ACTIONS(14),
    [anon_sym_print] = ACTIONS(216),
    [anon_sym_exec] = ACTIONS(216),
    [anon_sym_PLUS] = ACTIONS(54),
    [anon_sym_DASH] = ACTIONS(54),
    [anon_sym_TILDE] = ACTIONS(54),
    [anon_sym_LBRACK] = ACTIONS(60),
    [sym_ellipsis] = ACTIONS(968),
    [anon_sym_LBRACE] = ACTIONS(64),
    [sym_string] = ACTIONS(66),
    [sym_integer] = ACTIONS(970),
    [sym_float] = ACTIONS(970),
    [sym_identifier] = ACTIONS(970),
    [sym_true] = ACTIONS(970),
    [sym_false] = ACTIONS(970),
    [sym_none] = ACTIONS(970),
    [sym_comment] = ACTIONS(72),
  },
  [179] = {
    [sym__primary_expression] = STATE(534),
    [sym_binary_operator] = STATE(534),
    [sym_unary_operator] = STATE(534),
    [sym_attribute] = STATE(534),
    [sym_subscript] = STATE(534),
    [sym_call] = STATE(534),
    [sym_list] = STATE(534),
    [sym_list_comprehension] = STATE(534),
    [sym_dictionary] = STATE(534),
    [sym_dictionary_comprehension] = STATE(534),
    [sym_set] = STATE(534),
    [sym_set_comprehension] = STATE(534),
    [sym_parenthesized_expression] = STATE(534),
    [sym_tuple] = STATE(534),
    [sym_generator_expression] = STATE(534),
    [sym_concatenated_string] = STATE(534),
    [anon_sym_LPAREN] = ACTIONS(14),
    [anon_sym_print] = ACTIONS(216),
    [anon_sym_exec] = ACTIONS(216),
    [anon_sym_PLUS] = ACTIONS(54),
    [anon_sym_DASH] = ACTIONS(54),
    [anon_sym_TILDE] = ACTIONS(54),
    [anon_sym_LBRACK] = ACTIONS(60),
    [sym_ellipsis] = ACTIONS(972),
    [anon_sym_LBRACE] = ACTIONS(64),
    [sym_string] = ACTIONS(66),
    [sym_integer] = ACTIONS(974),
    [sym_float] = ACTIONS(974),
    [sym_identifier] = ACTIONS(974),
    [sym_true] = ACTIONS(974),
    [sym_false] = ACTIONS(974),
    [sym_none] = ACTIONS(974),
    [sym_comment] = ACTIONS(72),
  },
  [180] = {
    [sym__primary_expression] = STATE(528),
    [sym_binary_operator] = STATE(528),
    [sym_unary_operator] = STATE(528),
    [sym_attribute] = STATE(528),
    [sym_subscript] = STATE(528),
    [sym_call] = STATE(528),
    [sym_list] = STATE(528),
    [sym_list_comprehension] = STATE(528),
    [sym_dictionary] = STATE(528),
    [sym_dictionary_comprehension] = STATE(528),
    [sym_set] = STATE(528),
    [sym_set_comprehension] = STATE(528),
    [sym_parenthesized_expression] = STATE(528),
    [sym_tuple] = STATE(528),
    [sym_generator_expression] = STATE(528),
    [sym_concatenated_string] = STATE(528),
    [anon_sym_LPAREN] = ACTIONS(14),
    [anon_sym_print] = ACTIONS(216),
    [anon_sym_exec] = ACTIONS(216),
    [anon_sym_not] = ACTIONS(976),
    [anon_sym_PLUS] = ACTIONS(54),
    [anon_sym_DASH] = ACTIONS(54),
    [anon_sym_TILDE] = ACTIONS(54),
    [anon_sym_LBRACK] = ACTIONS(60),
    [sym_ellipsis] = ACTIONS(950),
    [anon_sym_LBRACE] = ACTIONS(64),
    [sym_string] = ACTIONS(66),
    [sym_integer] = ACTIONS(952),
    [sym_float] = ACTIONS(952),
    [sym_identifier] = ACTIONS(952),
    [sym_true] = ACTIONS(952),
    [sym_false] = ACTIONS(952),
    [sym_none] = ACTIONS(952),
    [sym_comment] = ACTIONS(72),
  },
  [181] = {
    [sym__expression] = STATE(541),
    [sym__primary_expression] = STATE(542),
    [sym_not_operator] = STATE(541),
    [sym_boolean_operator] = STATE(541),
    [sym_binary_operator] = STATE(542),
    [sym_unary_operator] = STATE(542),
    [sym_comparison_operator] = STATE(541),
    [sym_lambda] = STATE(541),
    [sym_attribute] = STATE(542),
    [sym_subscript] = STATE(542),
    [sym_slice] = STATE(543),
    [sym_call] = STATE(542),
    [sym_list] = STATE(542),
    [sym_list_comprehension] = STATE(542),
    [sym_dictionary] = STATE(542),
    [sym_dictionary_comprehension] = STATE(542),
    [sym_set] = STATE(542),
    [sym_set_comprehension] = STATE(542),
    [sym_parenthesized_expression] = STATE(542),
    [sym_tuple] = STATE(542),
    [sym_generator_expression] = STATE(542),
    [sym_conditional_expression] = STATE(541),
    [sym_concatenated_string] = STATE(542),
    [sym_await] = STATE(541),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_COLON] = ACTIONS(978),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_not] = ACTIONS(980),
    [anon_sym_PLUS] = ACTIONS(982),
    [anon_sym_DASH] = ACTIONS(982),
    [anon_sym_TILDE] = ACTIONS(982),
    [anon_sym_lambda] = ACTIONS(984),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(986),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(988),
    [sym_integer] = ACTIONS(990),
    [sym_float] = ACTIONS(990),
    [sym_identifier] = ACTIONS(990),
    [sym_true] = ACTIONS(990),
    [sym_false] = ACTIONS(990),
    [sym_none] = ACTIONS(990),
    [anon_sym_await] = ACTIONS(992),
    [sym_comment] = ACTIONS(72),
  },
  [182] = {
    [sym__newline] = ACTIONS(994),
    [anon_sym_DOT] = ACTIONS(994),
    [anon_sym_LPAREN] = ACTIONS(994),
    [anon_sym_COMMA] = ACTIONS(994),
    [anon_sym_STAR] = ACTIONS(996),
    [anon_sym_GT_GT] = ACTIONS(996),
    [anon_sym_if] = ACTIONS(994),
    [anon_sym_COLON] = ACTIONS(994),
    [anon_sym_in] = ACTIONS(994),
    [anon_sym_EQ] = ACTIONS(996),
    [anon_sym_AT] = ACTIONS(996),
    [anon_sym_not] = ACTIONS(994),
    [anon_sym_and] = ACTIONS(994),
    [anon_sym_or] = ACTIONS(994),
    [anon_sym_PLUS] = ACTIONS(996),
    [anon_sym_DASH] = ACTIONS(996),
    [anon_sym_SLASH] = ACTIONS(996),
    [anon_sym_PERCENT] = ACTIONS(996),
    [anon_sym_SLASH_SLASH] = ACTIONS(996),
    [anon_sym_STAR_STAR] = ACTIONS(996),
    [anon_sym_PIPE] = ACTIONS(996),
    [anon_sym_AMP] = ACTIONS(996),
    [anon_sym_CARET] = ACTIONS(996),
    [anon_sym_LT_LT] = ACTIONS(996),
    [anon_sym_LT] = ACTIONS(996),
    [anon_sym_LT_EQ] = ACTIONS(994),
    [anon_sym_EQ_EQ] = ACTIONS(994),
    [anon_sym_BANG_EQ] = ACTIONS(994),
    [anon_sym_GT_EQ] = ACTIONS(994),
    [anon_sym_GT] = ACTIONS(996),
    [anon_sym_LT_GT] = ACTIONS(994),
    [anon_sym_is] = ACTIONS(994),
    [anon_sym_PLUS_EQ] = ACTIONS(994),
    [anon_sym_DASH_EQ] = ACTIONS(994),
    [anon_sym_STAR_EQ] = ACTIONS(994),
    [anon_sym_SLASH_EQ] = ACTIONS(994),
    [anon_sym_AT_EQ] = ACTIONS(994),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(994),
    [anon_sym_PERCENT_EQ] = ACTIONS(994),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(994),
    [anon_sym_GT_GT_EQ] = ACTIONS(994),
    [anon_sym_LT_LT_EQ] = ACTIONS(994),
    [anon_sym_AMP_EQ] = ACTIONS(994),
    [anon_sym_CARET_EQ] = ACTIONS(994),
    [anon_sym_PIPE_EQ] = ACTIONS(994),
    [anon_sym_LBRACK] = ACTIONS(994),
    [sym_comment] = ACTIONS(72),
    [sym__semicolon] = ACTIONS(994),
  },
  [183] = {
    [aux_sym_comparison_operator_repeat1] = STATE(544),
    [sym__newline] = ACTIONS(998),
    [anon_sym_COMMA] = ACTIONS(998),
    [anon_sym_if] = ACTIONS(998),
    [anon_sym_COLON] = ACTIONS(998),
    [anon_sym_in] = ACTIONS(312),
    [anon_sym_EQ] = ACTIONS(1000),
    [anon_sym_not] = ACTIONS(316),
    [anon_sym_and] = ACTIONS(998),
    [anon_sym_or] = ACTIONS(998),
    [anon_sym_LT] = ACTIONS(328),
    [anon_sym_LT_EQ] = ACTIONS(312),
    [anon_sym_EQ_EQ] = ACTIONS(312),
    [anon_sym_BANG_EQ] = ACTIONS(312),
    [anon_sym_GT_EQ] = ACTIONS(312),
    [anon_sym_GT] = ACTIONS(328),
    [anon_sym_LT_GT] = ACTIONS(312),
    [anon_sym_is] = ACTIONS(330),
    [anon_sym_PLUS_EQ] = ACTIONS(998),
    [anon_sym_DASH_EQ] = ACTIONS(998),
    [anon_sym_STAR_EQ] = ACTIONS(998),
    [anon_sym_SLASH_EQ] = ACTIONS(998),
    [anon_sym_AT_EQ] = ACTIONS(998),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(998),
    [anon_sym_PERCENT_EQ] = ACTIONS(998),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(998),
    [anon_sym_GT_GT_EQ] = ACTIONS(998),
    [anon_sym_LT_LT_EQ] = ACTIONS(998),
    [anon_sym_AMP_EQ] = ACTIONS(998),
    [anon_sym_CARET_EQ] = ACTIONS(998),
    [anon_sym_PIPE_EQ] = ACTIONS(998),
    [sym_comment] = ACTIONS(72),
    [sym__semicolon] = ACTIONS(998),
  },
  [184] = {
    [sym__statement] = STATE(184),
    [sym__simple_statements] = STATE(184),
    [sym_import_statement] = STATE(10),
    [sym_import_from_statement] = STATE(10),
    [sym_print_statement] = STATE(10),
    [sym_assert_statement] = STATE(10),
    [sym_expression_statement] = STATE(10),
    [sym_return_statement] = STATE(10),
    [sym_delete_statement] = STATE(10),
    [sym_raise_statement] = STATE(10),
    [sym_if_statement] = STATE(184),
    [sym_for_statement] = STATE(184),
    [sym_while_statement] = STATE(184),
    [sym_try_statement] = STATE(184),
    [sym_with_statement] = STATE(184),
    [sym_function_definition] = STATE(184),
    [sym_global_statement] = STATE(10),
    [sym_nonlocal_statement] = STATE(10),
    [sym_exec_statement] = STATE(10),
    [sym_class_definition] = STATE(184),
    [sym_decorated_definition] = STATE(184),
    [sym_decorator] = STATE(37),
    [sym_expression_list] = STATE(32),
    [sym__expression] = STATE(33),
    [sym__primary_expression] = STATE(34),
    [sym_not_operator] = STATE(33),
    [sym_boolean_operator] = STATE(33),
    [sym_binary_operator] = STATE(34),
    [sym_unary_operator] = STATE(34),
    [sym_comparison_operator] = STATE(33),
    [sym_lambda] = STATE(33),
    [sym_assignment] = STATE(35),
    [sym_augmented_assignment] = STATE(35),
    [sym_yield] = STATE(35),
    [sym_attribute] = STATE(34),
    [sym_subscript] = STATE(34),
    [sym_call] = STATE(34),
    [sym_list] = STATE(34),
    [sym_list_comprehension] = STATE(34),
    [sym_dictionary] = STATE(34),
    [sym_dictionary_comprehension] = STATE(34),
    [sym_set] = STATE(34),
    [sym_set_comprehension] = STATE(34),
    [sym_parenthesized_expression] = STATE(34),
    [sym_tuple] = STATE(34),
    [sym_generator_expression] = STATE(34),
    [sym_conditional_expression] = STATE(33),
    [sym_concatenated_string] = STATE(34),
    [sym_await] = STATE(33),
    [aux_sym_module_repeat1] = STATE(184),
    [aux_sym_decorated_definition_repeat1] = STATE(37),
    [ts_builtin_sym_end] = ACTIONS(1002),
    [anon_sym_import] = ACTIONS(1004),
    [anon_sym_from] = ACTIONS(1007),
    [anon_sym_LPAREN] = ACTIONS(1010),
    [anon_sym_print] = ACTIONS(1013),
    [anon_sym_assert] = ACTIONS(1016),
    [anon_sym_return] = ACTIONS(1019),
    [anon_sym_del] = ACTIONS(1022),
    [anon_sym_raise] = ACTIONS(1025),
    [sym_pass_statement] = ACTIONS(1028),
    [sym_break_statement] = ACTIONS(1028),
    [sym_continue_statement] = ACTIONS(1028),
    [anon_sym_if] = ACTIONS(1031),
    [anon_sym_async] = ACTIONS(1034),
    [anon_sym_for] = ACTIONS(1037),
    [anon_sym_while] = ACTIONS(1040),
    [anon_sym_try] = ACTIONS(1043),
    [anon_sym_with] = ACTIONS(1046),
    [anon_sym_def] = ACTIONS(1049),
    [anon_sym_global] = ACTIONS(1052),
    [anon_sym_nonlocal] = ACTIONS(1055),
    [anon_sym_exec] = ACTIONS(1058),
    [anon_sym_class] = ACTIONS(1061),
    [anon_sym_AT] = ACTIONS(1064),
    [anon_sym_not] = ACTIONS(1067),
    [anon_sym_PLUS] = ACTIONS(1070),
    [anon_sym_DASH] = ACTIONS(1070),
    [anon_sym_TILDE] = ACTIONS(1070),
    [anon_sym_lambda] = ACTIONS(1073),
    [anon_sym_yield] = ACTIONS(1076),
    [anon_sym_LBRACK] = ACTIONS(1079),
    [sym_ellipsis] = ACTIONS(1082),
    [anon_sym_LBRACE] = ACTIONS(1085),
    [sym_string] = ACTIONS(1088),
    [sym_integer] = ACTIONS(1091),
    [sym_float] = ACTIONS(1091),
    [sym_identifier] = ACTIONS(1091),
    [sym_true] = ACTIONS(1091),
    [sym_false] = ACTIONS(1091),
    [sym_none] = ACTIONS(1091),
    [anon_sym_await] = ACTIONS(1094),
    [sym_comment] = ACTIONS(72),
  },
  [185] = {
    [anon_sym_def] = ACTIONS(178),
    [sym_comment] = ACTIONS(72),
  },
  [186] = {
    [ts_builtin_sym_end] = ACTIONS(1097),
    [anon_sym_import] = ACTIONS(1099),
    [anon_sym_from] = ACTIONS(1099),
    [anon_sym_LPAREN] = ACTIONS(1097),
    [anon_sym_print] = ACTIONS(1099),
    [anon_sym_assert] = ACTIONS(1099),
    [anon_sym_return] = ACTIONS(1099),
    [anon_sym_del] = ACTIONS(1099),
    [anon_sym_raise] = ACTIONS(1099),
    [sym_pass_statement] = ACTIONS(1099),
    [sym_break_statement] = ACTIONS(1099),
    [sym_continue_statement] = ACTIONS(1099),
    [anon_sym_if] = ACTIONS(1099),
    [anon_sym_async] = ACTIONS(1099),
    [anon_sym_for] = ACTIONS(1099),
    [anon_sym_while] = ACTIONS(1099),
    [anon_sym_try] = ACTIONS(1099),
    [anon_sym_with] = ACTIONS(1099),
    [anon_sym_def] = ACTIONS(1099),
    [anon_sym_global] = ACTIONS(1099),
    [anon_sym_nonlocal] = ACTIONS(1099),
    [anon_sym_exec] = ACTIONS(1099),
    [anon_sym_class] = ACTIONS(1099),
    [anon_sym_AT] = ACTIONS(1097),
    [anon_sym_not] = ACTIONS(1099),
    [anon_sym_PLUS] = ACTIONS(1097),
    [anon_sym_DASH] = ACTIONS(1097),
    [anon_sym_TILDE] = ACTIONS(1097),
    [anon_sym_lambda] = ACTIONS(1099),
    [anon_sym_yield] = ACTIONS(1099),
    [anon_sym_LBRACK] = ACTIONS(1097),
    [sym_ellipsis] = ACTIONS(1097),
    [anon_sym_LBRACE] = ACTIONS(1097),
    [sym_string] = ACTIONS(1097),
    [sym_integer] = ACTIONS(1099),
    [sym_float] = ACTIONS(1099),
    [sym_identifier] = ACTIONS(1099),
    [sym_true] = ACTIONS(1099),
    [sym_false] = ACTIONS(1099),
    [sym_none] = ACTIONS(1099),
    [anon_sym_await] = ACTIONS(1099),
    [sym_comment] = ACTIONS(72),
  },
  [187] = {
    [sym_decorator] = STATE(187),
    [aux_sym_decorated_definition_repeat1] = STATE(187),
    [anon_sym_async] = ACTIONS(1101),
    [anon_sym_def] = ACTIONS(1101),
    [anon_sym_class] = ACTIONS(1101),
    [anon_sym_AT] = ACTIONS(1103),
    [sym_comment] = ACTIONS(72),
  },
  [188] = {
    [sym_identifier] = ACTIONS(1106),
    [sym_comment] = ACTIONS(72),
  },
  [189] = {
    [aux_sym_dotted_name_repeat1] = STATE(546),
    [sym__newline] = ACTIONS(1108),
    [anon_sym_DOT] = ACTIONS(344),
    [anon_sym_COMMA] = ACTIONS(1108),
    [anon_sym_as] = ACTIONS(1108),
    [sym_comment] = ACTIONS(72),
    [sym__semicolon] = ACTIONS(1108),
  },
  [190] = {
    [sym_aliased_import] = STATE(547),
    [sym_dotted_name] = STATE(548),
    [sym__newline] = ACTIONS(1110),
    [sym_identifier] = ACTIONS(74),
    [sym_comment] = ACTIONS(72),
    [sym__semicolon] = ACTIONS(1110),
  },
  [191] = {
    [aux_sym__import_list_repeat1] = STATE(550),
    [sym__newline] = ACTIONS(1110),
    [anon_sym_COMMA] = ACTIONS(1112),
    [sym_comment] = ACTIONS(72),
    [sym__semicolon] = ACTIONS(1110),
  },
  [192] = {
    [sym_identifier] = ACTIONS(1114),
    [sym_comment] = ACTIONS(72),
  },
  [193] = {
    [sym_identifier] = ACTIONS(1116),
    [sym_comment] = ACTIONS(72),
  },
  [194] = {
    [aux_sym_dotted_name_repeat1] = STATE(553),
    [anon_sym_import] = ACTIONS(1108),
    [anon_sym_DOT] = ACTIONS(354),
    [sym_comment] = ACTIONS(72),
  },
  [195] = {
    [anon_sym_import] = ACTIONS(1118),
    [sym_comment] = ACTIONS(72),
  },
  [196] = {
    [sym__import_list] = STATE(556),
    [sym_aliased_import] = STATE(40),
    [sym_wildcard_import] = STATE(556),
    [sym_dotted_name] = STATE(41),
    [anon_sym_LPAREN] = ACTIONS(1120),
    [anon_sym_STAR] = ACTIONS(1122),
    [sym_identifier] = ACTIONS(74),
    [sym_comment] = ACTIONS(72),
  },
  [197] = {
    [aux_sym_import_prefix_repeat1] = STATE(197),
    [anon_sym_import] = ACTIONS(1124),
    [anon_sym_DOT] = ACTIONS(1126),
    [sym_identifier] = ACTIONS(1124),
    [sym_comment] = ACTIONS(72),
  },
  [198] = {
    [anon_sym_DOT] = ACTIONS(370),
    [anon_sym_LPAREN] = ACTIONS(370),
    [anon_sym_RPAREN] = ACTIONS(370),
    [anon_sym_COMMA] = ACTIONS(370),
    [anon_sym_as] = ACTIONS(372),
    [anon_sym_STAR] = ACTIONS(372),
    [anon_sym_GT_GT] = ACTIONS(370),
    [anon_sym_if] = ACTIONS(370),
    [anon_sym_COLON] = ACTIONS(370),
    [anon_sym_else] = ACTIONS(370),
    [anon_sym_async] = ACTIONS(370),
    [anon_sym_for] = ACTIONS(370),
    [anon_sym_in] = ACTIONS(370),
    [anon_sym_EQ] = ACTIONS(372),
    [anon_sym_AT] = ACTIONS(370),
    [anon_sym_not] = ACTIONS(370),
    [anon_sym_and] = ACTIONS(370),
    [anon_sym_or] = ACTIONS(370),
    [anon_sym_PLUS] = ACTIONS(370),
    [anon_sym_DASH] = ACTIONS(370),
    [anon_sym_SLASH] = ACTIONS(372),
    [anon_sym_PERCENT] = ACTIONS(370),
    [anon_sym_SLASH_SLASH] = ACTIONS(370),
    [anon_sym_STAR_STAR] = ACTIONS(370),
    [anon_sym_PIPE] = ACTIONS(370),
    [anon_sym_AMP] = ACTIONS(370),
    [anon_sym_CARET] = ACTIONS(370),
    [anon_sym_LT_LT] = ACTIONS(370),
    [anon_sym_LT] = ACTIONS(372),
    [anon_sym_LT_EQ] = ACTIONS(370),
    [anon_sym_EQ_EQ] = ACTIONS(370),
    [anon_sym_BANG_EQ] = ACTIONS(370),
    [anon_sym_GT_EQ] = ACTIONS(370),
    [anon_sym_GT] = ACTIONS(372),
    [anon_sym_LT_GT] = ACTIONS(370),
    [anon_sym_is] = ACTIONS(370),
    [anon_sym_LBRACK] = ACTIONS(370),
    [anon_sym_RBRACK] = ACTIONS(370),
    [anon_sym_RBRACE] = ACTIONS(370),
    [sym_comment] = ACTIONS(72),
  },
  [199] = {
    [anon_sym_RPAREN] = ACTIONS(1129),
    [sym_comment] = ACTIONS(72),
  },
  [200] = {
    [sym__comprehension_body] = STATE(560),
    [sym_for_in_clause] = STATE(236),
    [aux_sym_tuple_repeat1] = STATE(561),
    [anon_sym_RPAREN] = ACTIONS(1131),
    [anon_sym_COMMA] = ACTIONS(1133),
    [anon_sym_if] = ACTIONS(412),
    [anon_sym_async] = ACTIONS(414),
    [anon_sym_for] = ACTIONS(416),
    [anon_sym_and] = ACTIONS(418),
    [anon_sym_or] = ACTIONS(420),
    [sym_comment] = ACTIONS(72),
  },
  [201] = {
    [aux_sym_tuple_repeat1] = STATE(561),
    [anon_sym_RPAREN] = ACTIONS(1131),
    [anon_sym_COMMA] = ACTIONS(1133),
    [sym_comment] = ACTIONS(72),
  },
  [202] = {
    [sym__newline] = ACTIONS(1135),
    [anon_sym_DOT] = ACTIONS(1135),
    [anon_sym_LPAREN] = ACTIONS(1135),
    [anon_sym_COMMA] = ACTIONS(1135),
    [anon_sym_STAR] = ACTIONS(1137),
    [anon_sym_GT_GT] = ACTIONS(1137),
    [anon_sym_if] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(1135),
    [anon_sym_in] = ACTIONS(1135),
    [anon_sym_EQ] = ACTIONS(1137),
    [anon_sym_AT] = ACTIONS(1137),
    [anon_sym_not] = ACTIONS(1135),
    [anon_sym_and] = ACTIONS(1135),
    [anon_sym_or] = ACTIONS(1135),
    [anon_sym_PLUS] = ACTIONS(1137),
    [anon_sym_DASH] = ACTIONS(1137),
    [anon_sym_SLASH] = ACTIONS(1137),
    [anon_sym_PERCENT] = ACTIONS(1137),
    [anon_sym_SLASH_SLASH] = ACTIONS(1137),
    [anon_sym_STAR_STAR] = ACTIONS(1137),
    [anon_sym_PIPE] = ACTIONS(1137),
    [anon_sym_AMP] = ACTIONS(1137),
    [anon_sym_CARET] = ACTIONS(1137),
    [anon_sym_LT_LT] = ACTIONS(1137),
    [anon_sym_LT] = ACTIONS(1137),
    [anon_sym_LT_EQ] = ACTIONS(1135),
    [anon_sym_EQ_EQ] = ACTIONS(1135),
    [anon_sym_BANG_EQ] = ACTIONS(1135),
    [anon_sym_GT_EQ] = ACTIONS(1135),
    [anon_sym_GT] = ACTIONS(1137),
    [anon_sym_LT_GT] = ACTIONS(1135),
    [anon_sym_is] = ACTIONS(1135),
    [anon_sym_PLUS_EQ] = ACTIONS(1135),
    [anon_sym_DASH_EQ] = ACTIONS(1135),
    [anon_sym_STAR_EQ] = ACTIONS(1135),
    [anon_sym_SLASH_EQ] = ACTIONS(1135),
    [anon_sym_AT_EQ] = ACTIONS(1135),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(1135),
    [anon_sym_PERCENT_EQ] = ACTIONS(1135),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1135),
    [anon_sym_GT_GT_EQ] = ACTIONS(1135),
    [anon_sym_LT_LT_EQ] = ACTIONS(1135),
    [anon_sym_AMP_EQ] = ACTIONS(1135),
    [anon_sym_CARET_EQ] = ACTIONS(1135),
    [anon_sym_PIPE_EQ] = ACTIONS(1135),
    [anon_sym_LBRACK] = ACTIONS(1135),
    [sym_comment] = ACTIONS(72),
    [sym__semicolon] = ACTIONS(1135),
  },
  [203] = {
    [anon_sym_RPAREN] = ACTIONS(716),
    [anon_sym_COMMA] = ACTIONS(716),
    [anon_sym_if] = ACTIONS(716),
    [anon_sym_async] = ACTIONS(716),
    [anon_sym_for] = ACTIONS(716),
    [anon_sym_and] = ACTIONS(418),
    [anon_sym_or] = ACTIONS(420),
    [sym_comment] = ACTIONS(72),
  },
  [204] = {
    [sym_argument_list] = STATE(251),
    [sym_generator_expression] = STATE(251),
    [anon_sym_DOT] = ACTIONS(718),
    [anon_sym_LPAREN] = ACTIONS(424),
    [anon_sym_RPAREN] = ACTIONS(718),
    [anon_sym_COMMA] = ACTIONS(718),
    [anon_sym_as] = ACTIONS(720),
    [anon_sym_STAR] = ACTIONS(720),
    [anon_sym_GT_GT] = ACTIONS(718),
    [anon_sym_if] = ACTIONS(718),
    [anon_sym_COLON] = ACTIONS(718),
    [anon_sym_else] = ACTIONS(718),
    [anon_sym_async] = ACTIONS(718),
    [anon_sym_for] = ACTIONS(718),
    [anon_sym_in] = ACTIONS(718),
    [anon_sym_EQ] = ACTIONS(720),
    [anon_sym_AT] = ACTIONS(718),
    [anon_sym_not] = ACTIONS(718),
    [anon_sym_and] = ACTIONS(718),
    [anon_sym_or] = ACTIONS(718),
    [anon_sym_PLUS] = ACTIONS(718),
    [anon_sym_DASH] = ACTIONS(718),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_PERCENT] = ACTIONS(718),
    [anon_sym_SLASH_SLASH] = ACTIONS(718),
    [anon_sym_STAR_STAR] = ACTIONS(718),
    [anon_sym_PIPE] = ACTIONS(718),
    [anon_sym_AMP] = ACTIONS(718),
    [anon_sym_CARET] = ACTIONS(718),
    [anon_sym_LT_LT] = ACTIONS(718),
    [anon_sym_LT] = ACTIONS(720),
    [anon_sym_LT_EQ] = ACTIONS(718),
    [anon_sym_EQ_EQ] = ACTIONS(718),
    [anon_sym_BANG_EQ] = ACTIONS(718),
    [anon_sym_GT_EQ] = ACTIONS(718),
    [anon_sym_GT] = ACTIONS(720),
    [anon_sym_LT_GT] = ACTIONS(718),
    [anon_sym_is] = ACTIONS(718),
    [anon_sym_LBRACK] = ACTIONS(718),
    [anon_sym_RBRACK] = ACTIONS(718),
    [anon_sym_RBRACE] = ACTIONS(718),
    [sym_comment] = ACTIONS(72),
  },
  [205] = {
    [sym__expression] = STATE(562),
    [sym__primary_expression] = STATE(59),
    [sym_not_operator] = STATE(562),
    [sym_boolean_operator] = STATE(562),
    [sym_binary_operator] = STATE(59),
    [sym_unary_operator] = STATE(59),
    [sym_comparison_operator] = STATE(562),
    [sym_lambda] = STATE(562),
    [sym_attribute] = STATE(59),
    [sym_subscript] = STATE(59),
    [sym_call] = STATE(59),
    [sym_list] = STATE(59),
    [sym_list_comprehension] = STATE(59),
    [sym_dictionary] = STATE(59),
    [sym_dictionary_comprehension] = STATE(59),
    [sym_set] = STATE(59),
    [sym_set_comprehension] = STATE(59),
    [sym_parenthesized_expression] = STATE(59),
    [sym_tuple] = STATE(59),
    [sym_generator_expression] = STATE(59),
    [sym_conditional_expression] = STATE(562),
    [sym_concatenated_string] = STATE(59),
    [sym_await] = STATE(562),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_not] = ACTIONS(88),
    [anon_sym_PLUS] = ACTIONS(90),
    [anon_sym_DASH] = ACTIONS(90),
    [anon_sym_TILDE] = ACTIONS(90),
    [anon_sym_lambda] = ACTIONS(92),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(98),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(102),
    [sym_integer] = ACTIONS(104),
    [sym_float] = ACTIONS(104),
    [sym_identifier] = ACTIONS(104),
    [sym_true] = ACTIONS(104),
    [sym_false] = ACTIONS(104),
    [sym_none] = ACTIONS(104),
    [anon_sym_await] = ACTIONS(106),
    [sym_comment] = ACTIONS(72),
  },
  [206] = {
    [anon_sym_COLON] = ACTIONS(1139),
    [sym_comment] = ACTIONS(72),
  },
  [207] = {
    [sym__expression] = STATE(564),
    [sym__primary_expression] = STATE(215),
    [sym_not_operator] = STATE(564),
    [sym_boolean_operator] = STATE(564),
    [sym_binary_operator] = STATE(215),
    [sym_unary_operator] = STATE(215),
    [sym_comparison_operator] = STATE(564),
    [sym_lambda] = STATE(564),
    [sym_attribute] = STATE(215),
    [sym_subscript] = STATE(215),
    [sym_call] = STATE(215),
    [sym_list] = STATE(215),
    [sym_list_comprehension] = STATE(215),
    [sym_dictionary] = STATE(215),
    [sym_dictionary_comprehension] = STATE(215),
    [sym_set] = STATE(215),
    [sym_set_comprehension] = STATE(215),
    [sym_parenthesized_expression] = STATE(215),
    [sym_tuple] = STATE(215),
    [sym_generator_expression] = STATE(215),
    [sym_conditional_expression] = STATE(564),
    [sym_concatenated_string] = STATE(215),
    [sym_await] = STATE(564),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_not] = ACTIONS(384),
    [anon_sym_PLUS] = ACTIONS(386),
    [anon_sym_DASH] = ACTIONS(386),
    [anon_sym_TILDE] = ACTIONS(386),
    [anon_sym_lambda] = ACTIONS(388),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(390),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(392),
    [sym_integer] = ACTIONS(394),
    [sym_float] = ACTIONS(394),
    [sym_identifier] = ACTIONS(394),
    [sym_true] = ACTIONS(394),
    [sym_false] = ACTIONS(394),
    [sym_none] = ACTIONS(394),
    [anon_sym_await] = ACTIONS(396),
    [sym_comment] = ACTIONS(72),
  },
  [208] = {
    [sym__expression] = STATE(565),
    [sym__primary_expression] = STATE(215),
    [sym_not_operator] = STATE(565),
    [sym_boolean_operator] = STATE(565),
    [sym_binary_operator] = STATE(215),
    [sym_unary_operator] = STATE(215),
    [sym_comparison_operator] = STATE(565),
    [sym_lambda] = STATE(565),
    [sym_attribute] = STATE(215),
    [sym_subscript] = STATE(215),
    [sym_call] = STATE(215),
    [sym_list] = STATE(215),
    [sym_list_comprehension] = STATE(215),
    [sym_dictionary] = STATE(215),
    [sym_dictionary_comprehension] = STATE(215),
    [sym_set] = STATE(215),
    [sym_set_comprehension] = STATE(215),
    [sym_parenthesized_expression] = STATE(215),
    [sym_tuple] = STATE(215),
    [sym_generator_expression] = STATE(215),
    [sym_conditional_expression] = STATE(565),
    [sym_concatenated_string] = STATE(215),
    [sym_await] = STATE(565),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_not] = ACTIONS(384),
    [anon_sym_PLUS] = ACTIONS(386),
    [anon_sym_DASH] = ACTIONS(386),
    [anon_sym_TILDE] = ACTIONS(386),
    [anon_sym_lambda] = ACTIONS(388),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(390),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(392),
    [sym_integer] = ACTIONS(394),
    [sym_float] = ACTIONS(394),
    [sym_identifier] = ACTIONS(394),
    [sym_true] = ACTIONS(394),
    [sym_false] = ACTIONS(394),
    [sym_none] = ACTIONS(394),
    [anon_sym_await] = ACTIONS(396),
    [sym_comment] = ACTIONS(72),
  },
  [209] = {
    [sym__primary_expression] = STATE(204),
    [sym_binary_operator] = STATE(204),
    [sym_unary_operator] = STATE(204),
    [sym_attribute] = STATE(204),
    [sym_subscript] = STATE(204),
    [sym_call] = STATE(204),
    [sym_list] = STATE(204),
    [sym_list_comprehension] = STATE(204),
    [sym_dictionary] = STATE(204),
    [sym_dictionary_comprehension] = STATE(204),
    [sym_set] = STATE(204),
    [sym_set_comprehension] = STATE(204),
    [sym_parenthesized_expression] = STATE(204),
    [sym_tuple] = STATE(204),
    [sym_generator_expression] = STATE(204),
    [sym_concatenated_string] = STATE(204),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_PLUS] = ACTIONS(386),
    [anon_sym_DASH] = ACTIONS(386),
    [anon_sym_TILDE] = ACTIONS(386),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(376),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(392),
    [sym_integer] = ACTIONS(378),
    [sym_float] = ACTIONS(378),
    [sym_identifier] = ACTIONS(378),
    [sym_true] = ACTIONS(378),
    [sym_false] = ACTIONS(378),
    [sym_none] = ACTIONS(378),
    [sym_comment] = ACTIONS(72),
  },
  [210] = {
    [sym_lambda_parameters] = STATE(567),
    [sym__parameters] = STATE(130),
    [sym_default_parameter] = STATE(131),
    [sym_typed_default_parameter] = STATE(131),
    [sym_list_splat] = STATE(132),
    [sym_dictionary_splat] = STATE(132),
    [sym_typed_parameter] = STATE(131),
    [sym_tuple] = STATE(131),
    [anon_sym_LPAREN] = ACTIONS(222),
    [anon_sym_STAR] = ACTIONS(224),
    [anon_sym_print] = ACTIONS(226),
    [anon_sym_COLON] = ACTIONS(1141),
    [anon_sym_exec] = ACTIONS(226),
    [sym_identifier] = ACTIONS(230),
    [sym_comment] = ACTIONS(72),
  },
  [211] = {
    [aux_sym_concatenated_string_repeat1] = STATE(568),
    [anon_sym_DOT] = ACTIONS(276),
    [anon_sym_LPAREN] = ACTIONS(276),
    [anon_sym_RPAREN] = ACTIONS(276),
    [anon_sym_COMMA] = ACTIONS(276),
    [anon_sym_STAR] = ACTIONS(278),
    [anon_sym_GT_GT] = ACTIONS(276),
    [anon_sym_if] = ACTIONS(276),
    [anon_sym_in] = ACTIONS(276),
    [anon_sym_AT] = ACTIONS(276),
    [anon_sym_not] = ACTIONS(276),
    [anon_sym_and] = ACTIONS(276),
    [anon_sym_or] = ACTIONS(276),
    [anon_sym_PLUS] = ACTIONS(276),
    [anon_sym_DASH] = ACTIONS(276),
    [anon_sym_SLASH] = ACTIONS(278),
    [anon_sym_PERCENT] = ACTIONS(276),
    [anon_sym_SLASH_SLASH] = ACTIONS(276),
    [anon_sym_STAR_STAR] = ACTIONS(276),
    [anon_sym_PIPE] = ACTIONS(276),
    [anon_sym_AMP] = ACTIONS(276),
    [anon_sym_CARET] = ACTIONS(276),
    [anon_sym_LT_LT] = ACTIONS(276),
    [anon_sym_LT] = ACTIONS(278),
    [anon_sym_LT_EQ] = ACTIONS(276),
    [anon_sym_EQ_EQ] = ACTIONS(276),
    [anon_sym_BANG_EQ] = ACTIONS(276),
    [anon_sym_GT_EQ] = ACTIONS(276),
    [anon_sym_GT] = ACTIONS(278),
    [anon_sym_LT_GT] = ACTIONS(276),
    [anon_sym_is] = ACTIONS(276),
    [anon_sym_LBRACK] = ACTIONS(276),
    [sym_string] = ACTIONS(1143),
    [sym_comment] = ACTIONS(72),
  },
  [212] = {
    [sym__expression] = STATE(227),
    [sym__primary_expression] = STATE(215),
    [sym_not_operator] = STATE(227),
    [sym_boolean_operator] = STATE(227),
    [sym_binary_operator] = STATE(215),
    [sym_unary_operator] = STATE(215),
    [sym_comparison_operator] = STATE(227),
    [sym_lambda] = STATE(227),
    [sym_attribute] = STATE(215),
    [sym_subscript] = STATE(215),
    [sym_call] = STATE(215),
    [sym_list] = STATE(215),
    [sym_list_comprehension] = STATE(215),
    [sym_dictionary] = STATE(215),
    [sym_dictionary_comprehension] = STATE(215),
    [sym_set] = STATE(215),
    [sym_set_comprehension] = STATE(215),
    [sym_parenthesized_expression] = STATE(215),
    [sym_tuple] = STATE(215),
    [sym_generator_expression] = STATE(215),
    [sym_conditional_expression] = STATE(227),
    [sym_concatenated_string] = STATE(215),
    [sym_await] = STATE(227),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_not] = ACTIONS(384),
    [anon_sym_PLUS] = ACTIONS(386),
    [anon_sym_DASH] = ACTIONS(386),
    [anon_sym_TILDE] = ACTIONS(386),
    [anon_sym_lambda] = ACTIONS(388),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(390),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(392),
    [sym_integer] = ACTIONS(394),
    [sym_float] = ACTIONS(394),
    [sym_identifier] = ACTIONS(394),
    [sym_true] = ACTIONS(394),
    [sym_false] = ACTIONS(394),
    [sym_none] = ACTIONS(394),
    [anon_sym_await] = ACTIONS(396),
    [sym_comment] = ACTIONS(72),
  },
  [213] = {
    [anon_sym_RPAREN] = ACTIONS(756),
    [anon_sym_COMMA] = ACTIONS(756),
    [sym_comment] = ACTIONS(72),
  },
  [214] = {
    [aux_sym_print_statement_repeat1] = STATE(573),
    [anon_sym_RPAREN] = ACTIONS(296),
    [anon_sym_COMMA] = ACTIONS(1145),
    [anon_sym_if] = ACTIONS(1147),
    [anon_sym_and] = ACTIONS(1149),
    [anon_sym_or] = ACTIONS(1151),
    [sym_comment] = ACTIONS(72),
  },
  [215] = {
    [sym_argument_list] = STATE(251),
    [sym_generator_expression] = STATE(251),
    [aux_sym_comparison_operator_repeat1] = STATE(584),
    [anon_sym_DOT] = ACTIONS(422),
    [anon_sym_LPAREN] = ACTIONS(424),
    [anon_sym_RPAREN] = ACTIONS(302),
    [anon_sym_COMMA] = ACTIONS(302),
    [anon_sym_STAR] = ACTIONS(1153),
    [anon_sym_GT_GT] = ACTIONS(1155),
    [anon_sym_if] = ACTIONS(302),
    [anon_sym_in] = ACTIONS(1157),
    [anon_sym_AT] = ACTIONS(1159),
    [anon_sym_not] = ACTIONS(1161),
    [anon_sym_and] = ACTIONS(302),
    [anon_sym_or] = ACTIONS(302),
    [anon_sym_PLUS] = ACTIONS(1163),
    [anon_sym_DASH] = ACTIONS(1163),
    [anon_sym_SLASH] = ACTIONS(1153),
    [anon_sym_PERCENT] = ACTIONS(1159),
    [anon_sym_SLASH_SLASH] = ACTIONS(1159),
    [anon_sym_STAR_STAR] = ACTIONS(1165),
    [anon_sym_PIPE] = ACTIONS(1167),
    [anon_sym_AMP] = ACTIONS(1169),
    [anon_sym_CARET] = ACTIONS(1171),
    [anon_sym_LT_LT] = ACTIONS(1155),
    [anon_sym_LT] = ACTIONS(1173),
    [anon_sym_LT_EQ] = ACTIONS(1157),
    [anon_sym_EQ_EQ] = ACTIONS(1157),
    [anon_sym_BANG_EQ] = ACTIONS(1157),
    [anon_sym_GT_EQ] = ACTIONS(1157),
    [anon_sym_GT] = ACTIONS(1173),
    [anon_sym_LT_GT] = ACTIONS(1157),
    [anon_sym_is] = ACTIONS(1175),
    [anon_sym_LBRACK] = ACTIONS(450),
    [sym_comment] = ACTIONS(72),
  },
  [216] = {
    [anon_sym_RBRACK] = ACTIONS(1177),
    [sym_comment] = ACTIONS(72),
  },
  [217] = {
    [anon_sym_DOT] = ACTIONS(776),
    [anon_sym_LPAREN] = ACTIONS(776),
    [anon_sym_RPAREN] = ACTIONS(776),
    [anon_sym_COMMA] = ACTIONS(776),
    [anon_sym_as] = ACTIONS(778),
    [anon_sym_STAR] = ACTIONS(778),
    [anon_sym_GT_GT] = ACTIONS(776),
    [anon_sym_if] = ACTIONS(776),
    [anon_sym_COLON] = ACTIONS(776),
    [anon_sym_else] = ACTIONS(776),
    [anon_sym_async] = ACTIONS(776),
    [anon_sym_for] = ACTIONS(776),
    [anon_sym_in] = ACTIONS(776),
    [anon_sym_EQ] = ACTIONS(778),
    [anon_sym_AT] = ACTIONS(776),
    [anon_sym_not] = ACTIONS(776),
    [anon_sym_and] = ACTIONS(776),
    [anon_sym_or] = ACTIONS(776),
    [anon_sym_PLUS] = ACTIONS(776),
    [anon_sym_DASH] = ACTIONS(776),
    [anon_sym_SLASH] = ACTIONS(778),
    [anon_sym_PERCENT] = ACTIONS(776),
    [anon_sym_SLASH_SLASH] = ACTIONS(776),
    [anon_sym_STAR_STAR] = ACTIONS(776),
    [anon_sym_PIPE] = ACTIONS(776),
    [anon_sym_AMP] = ACTIONS(776),
    [anon_sym_CARET] = ACTIONS(776),
    [anon_sym_LT_LT] = ACTIONS(776),
    [anon_sym_LT] = ACTIONS(778),
    [anon_sym_LT_EQ] = ACTIONS(776),
    [anon_sym_EQ_EQ] = ACTIONS(776),
    [anon_sym_BANG_EQ] = ACTIONS(776),
    [anon_sym_GT_EQ] = ACTIONS(776),
    [anon_sym_GT] = ACTIONS(778),
    [anon_sym_LT_GT] = ACTIONS(776),
    [anon_sym_is] = ACTIONS(776),
    [anon_sym_LBRACK] = ACTIONS(776),
    [anon_sym_RBRACK] = ACTIONS(776),
    [anon_sym_RBRACE] = ACTIONS(776),
    [sym_comment] = ACTIONS(72),
  },
  [218] = {
    [aux_sym_list_repeat1] = STATE(587),
    [anon_sym_COMMA] = ACTIONS(1179),
    [anon_sym_RBRACK] = ACTIONS(1177),
    [sym_comment] = ACTIONS(72),
  },
  [219] = {
    [sym__comprehension_body] = STATE(588),
    [sym_for_in_clause] = STATE(443),
    [aux_sym_list_repeat1] = STATE(587),
    [anon_sym_COMMA] = ACTIONS(1179),
    [anon_sym_if] = ACTIONS(784),
    [anon_sym_async] = ACTIONS(786),
    [anon_sym_for] = ACTIONS(788),
    [anon_sym_and] = ACTIONS(790),
    [anon_sym_or] = ACTIONS(792),
    [anon_sym_RBRACK] = ACTIONS(1177),
    [sym_comment] = ACTIONS(72),
  },
  [220] = {
    [anon_sym_RBRACE] = ACTIONS(1181),
    [sym_comment] = ACTIONS(72),
  },
  [221] = {
    [anon_sym_DOT] = ACTIONS(838),
    [anon_sym_LPAREN] = ACTIONS(838),
    [anon_sym_RPAREN] = ACTIONS(838),
    [anon_sym_COMMA] = ACTIONS(838),
    [anon_sym_as] = ACTIONS(840),
    [anon_sym_STAR] = ACTIONS(840),
    [anon_sym_GT_GT] = ACTIONS(838),
    [anon_sym_if] = ACTIONS(838),
    [anon_sym_COLON] = ACTIONS(838),
    [anon_sym_else] = ACTIONS(838),
    [anon_sym_async] = ACTIONS(838),
    [anon_sym_for] = ACTIONS(838),
    [anon_sym_in] = ACTIONS(838),
    [anon_sym_EQ] = ACTIONS(840),
    [anon_sym_AT] = ACTIONS(838),
    [anon_sym_not] = ACTIONS(838),
    [anon_sym_and] = ACTIONS(838),
    [anon_sym_or] = ACTIONS(838),
    [anon_sym_PLUS] = ACTIONS(838),
    [anon_sym_DASH] = ACTIONS(838),
    [anon_sym_SLASH] = ACTIONS(840),
    [anon_sym_PERCENT] = ACTIONS(838),
    [anon_sym_SLASH_SLASH] = ACTIONS(838),
    [anon_sym_STAR_STAR] = ACTIONS(838),
    [anon_sym_PIPE] = ACTIONS(838),
    [anon_sym_AMP] = ACTIONS(838),
    [anon_sym_CARET] = ACTIONS(838),
    [anon_sym_LT_LT] = ACTIONS(838),
    [anon_sym_LT] = ACTIONS(840),
    [anon_sym_LT_EQ] = ACTIONS(838),
    [anon_sym_EQ_EQ] = ACTIONS(838),
    [anon_sym_BANG_EQ] = ACTIONS(838),
    [anon_sym_GT_EQ] = ACTIONS(838),
    [anon_sym_GT] = ACTIONS(840),
    [anon_sym_LT_GT] = ACTIONS(838),
    [anon_sym_is] = ACTIONS(838),
    [anon_sym_LBRACK] = ACTIONS(838),
    [anon_sym_RBRACK] = ACTIONS(838),
    [anon_sym_RBRACE] = ACTIONS(838),
    [sym_comment] = ACTIONS(72),
  },
  [222] = {
    [aux_sym_list_repeat1] = STATE(592),
    [anon_sym_COMMA] = ACTIONS(1183),
    [anon_sym_RBRACE] = ACTIONS(1185),
    [sym_comment] = ACTIONS(72),
  },
  [223] = {
    [aux_sym_dictionary_repeat1] = STATE(594),
    [anon_sym_COMMA] = ACTIONS(1187),
    [anon_sym_RBRACE] = ACTIONS(1181),
    [sym_comment] = ACTIONS(72),
  },
  [224] = {
    [sym__comprehension_body] = STATE(595),
    [sym_for_in_clause] = STATE(480),
    [aux_sym_list_repeat1] = STATE(592),
    [anon_sym_COMMA] = ACTIONS(1183),
    [anon_sym_if] = ACTIONS(850),
    [anon_sym_COLON] = ACTIONS(852),
    [anon_sym_async] = ACTIONS(854),
    [anon_sym_for] = ACTIONS(856),
    [anon_sym_and] = ACTIONS(858),
    [anon_sym_or] = ACTIONS(860),
    [anon_sym_RBRACE] = ACTIONS(1185),
    [sym_comment] = ACTIONS(72),
  },
  [225] = {
    [sym__comprehension_body] = STATE(596),
    [sym_for_in_clause] = STATE(480),
    [aux_sym_dictionary_repeat1] = STATE(594),
    [anon_sym_COMMA] = ACTIONS(1187),
    [anon_sym_async] = ACTIONS(854),
    [anon_sym_for] = ACTIONS(856),
    [anon_sym_RBRACE] = ACTIONS(1181),
    [sym_comment] = ACTIONS(72),
  },
  [226] = {
    [aux_sym_concatenated_string_repeat1] = STATE(597),
    [anon_sym_DOT] = ACTIONS(886),
    [anon_sym_LPAREN] = ACTIONS(886),
    [anon_sym_RPAREN] = ACTIONS(886),
    [anon_sym_COMMA] = ACTIONS(886),
    [anon_sym_STAR] = ACTIONS(888),
    [anon_sym_GT_GT] = ACTIONS(886),
    [anon_sym_if] = ACTIONS(886),
    [anon_sym_async] = ACTIONS(886),
    [anon_sym_for] = ACTIONS(886),
    [anon_sym_in] = ACTIONS(886),
    [anon_sym_AT] = ACTIONS(886),
    [anon_sym_not] = ACTIONS(886),
    [anon_sym_and] = ACTIONS(886),
    [anon_sym_or] = ACTIONS(886),
    [anon_sym_PLUS] = ACTIONS(886),
    [anon_sym_DASH] = ACTIONS(886),
    [anon_sym_SLASH] = ACTIONS(888),
    [anon_sym_PERCENT] = ACTIONS(886),
    [anon_sym_SLASH_SLASH] = ACTIONS(886),
    [anon_sym_STAR_STAR] = ACTIONS(886),
    [anon_sym_PIPE] = ACTIONS(886),
    [anon_sym_AMP] = ACTIONS(886),
    [anon_sym_CARET] = ACTIONS(886),
    [anon_sym_LT_LT] = ACTIONS(886),
    [anon_sym_LT] = ACTIONS(888),
    [anon_sym_LT_EQ] = ACTIONS(886),
    [anon_sym_EQ_EQ] = ACTIONS(886),
    [anon_sym_BANG_EQ] = ACTIONS(886),
    [anon_sym_GT_EQ] = ACTIONS(886),
    [anon_sym_GT] = ACTIONS(888),
    [anon_sym_LT_GT] = ACTIONS(886),
    [anon_sym_is] = ACTIONS(886),
    [anon_sym_LBRACK] = ACTIONS(886),
    [sym_string] = ACTIONS(1189),
    [sym_comment] = ACTIONS(72),
  },
  [227] = {
    [anon_sym_RPAREN] = ACTIONS(892),
    [anon_sym_COMMA] = ACTIONS(892),
    [anon_sym_as] = ACTIONS(1191),
    [anon_sym_if] = ACTIONS(892),
    [anon_sym_COLON] = ACTIONS(892),
    [anon_sym_else] = ACTIONS(892),
    [anon_sym_async] = ACTIONS(892),
    [anon_sym_for] = ACTIONS(892),
    [anon_sym_EQ] = ACTIONS(892),
    [anon_sym_and] = ACTIONS(892),
    [anon_sym_or] = ACTIONS(892),
    [anon_sym_RBRACK] = ACTIONS(892),
    [anon_sym_RBRACE] = ACTIONS(892),
    [sym_comment] = ACTIONS(72),
  },
  [228] = {
    [sym__newline] = ACTIONS(1193),
    [anon_sym_DOT] = ACTIONS(1193),
    [anon_sym_LPAREN] = ACTIONS(1193),
    [anon_sym_COMMA] = ACTIONS(1193),
    [anon_sym_STAR] = ACTIONS(1195),
    [anon_sym_GT_GT] = ACTIONS(1195),
    [anon_sym_if] = ACTIONS(1193),
    [anon_sym_COLON] = ACTIONS(1193),
    [anon_sym_in] = ACTIONS(1193),
    [anon_sym_EQ] = ACTIONS(1195),
    [anon_sym_AT] = ACTIONS(1195),
    [anon_sym_not] = ACTIONS(1193),
    [anon_sym_and] = ACTIONS(1193),
    [anon_sym_or] = ACTIONS(1193),
    [anon_sym_PLUS] = ACTIONS(1195),
    [anon_sym_DASH] = ACTIONS(1195),
    [anon_sym_SLASH] = ACTIONS(1195),
    [anon_sym_PERCENT] = ACTIONS(1195),
    [anon_sym_SLASH_SLASH] = ACTIONS(1195),
    [anon_sym_STAR_STAR] = ACTIONS(1195),
    [anon_sym_PIPE] = ACTIONS(1195),
    [anon_sym_AMP] = ACTIONS(1195),
    [anon_sym_CARET] = ACTIONS(1195),
    [anon_sym_LT_LT] = ACTIONS(1195),
    [anon_sym_LT] = ACTIONS(1195),
    [anon_sym_LT_EQ] = ACTIONS(1193),
    [anon_sym_EQ_EQ] = ACTIONS(1193),
    [anon_sym_BANG_EQ] = ACTIONS(1193),
    [anon_sym_GT_EQ] = ACTIONS(1193),
    [anon_sym_GT] = ACTIONS(1195),
    [anon_sym_LT_GT] = ACTIONS(1193),
    [anon_sym_is] = ACTIONS(1193),
    [anon_sym_PLUS_EQ] = ACTIONS(1193),
    [anon_sym_DASH_EQ] = ACTIONS(1193),
    [anon_sym_STAR_EQ] = ACTIONS(1193),
    [anon_sym_SLASH_EQ] = ACTIONS(1193),
    [anon_sym_AT_EQ] = ACTIONS(1193),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(1193),
    [anon_sym_PERCENT_EQ] = ACTIONS(1193),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1193),
    [anon_sym_GT_GT_EQ] = ACTIONS(1193),
    [anon_sym_LT_LT_EQ] = ACTIONS(1193),
    [anon_sym_AMP_EQ] = ACTIONS(1193),
    [anon_sym_CARET_EQ] = ACTIONS(1193),
    [anon_sym_PIPE_EQ] = ACTIONS(1193),
    [anon_sym_LBRACK] = ACTIONS(1193),
    [sym_comment] = ACTIONS(72),
    [sym__semicolon] = ACTIONS(1193),
  },
  [229] = {
    [sym__expression] = STATE(599),
    [sym__primary_expression] = STATE(215),
    [sym_not_operator] = STATE(599),
    [sym_boolean_operator] = STATE(599),
    [sym_binary_operator] = STATE(215),
    [sym_unary_operator] = STATE(215),
    [sym_comparison_operator] = STATE(599),
    [sym_lambda] = STATE(599),
    [sym_yield] = STATE(600),
    [sym_attribute] = STATE(215),
    [sym_subscript] = STATE(215),
    [sym_call] = STATE(215),
    [sym_list] = STATE(215),
    [sym_list_comprehension] = STATE(215),
    [sym_dictionary] = STATE(215),
    [sym_dictionary_comprehension] = STATE(215),
    [sym_set] = STATE(215),
    [sym_set_comprehension] = STATE(215),
    [sym_parenthesized_expression] = STATE(215),
    [sym_tuple] = STATE(215),
    [sym_generator_expression] = STATE(215),
    [sym_conditional_expression] = STATE(599),
    [sym_concatenated_string] = STATE(215),
    [sym_await] = STATE(599),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_RPAREN] = ACTIONS(1197),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_not] = ACTIONS(384),
    [anon_sym_PLUS] = ACTIONS(386),
    [anon_sym_DASH] = ACTIONS(386),
    [anon_sym_TILDE] = ACTIONS(386),
    [anon_sym_lambda] = ACTIONS(388),
    [anon_sym_yield] = ACTIONS(94),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(390),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(392),
    [sym_integer] = ACTIONS(394),
    [sym_float] = ACTIONS(394),
    [sym_identifier] = ACTIONS(394),
    [sym_true] = ACTIONS(394),
    [sym_false] = ACTIONS(394),
    [sym_none] = ACTIONS(394),
    [anon_sym_await] = ACTIONS(396),
    [sym_comment] = ACTIONS(72),
  },
  [230] = {
    [sym__expression] = STATE(601),
    [sym__primary_expression] = STATE(513),
    [sym_not_operator] = STATE(601),
    [sym_boolean_operator] = STATE(601),
    [sym_binary_operator] = STATE(513),
    [sym_unary_operator] = STATE(513),
    [sym_comparison_operator] = STATE(601),
    [sym_lambda] = STATE(601),
    [sym_attribute] = STATE(513),
    [sym_subscript] = STATE(513),
    [sym_call] = STATE(513),
    [sym_list] = STATE(513),
    [sym_list_comprehension] = STATE(513),
    [sym_dictionary] = STATE(513),
    [sym_dictionary_comprehension] = STATE(513),
    [sym_set] = STATE(513),
    [sym_set_comprehension] = STATE(513),
    [sym_parenthesized_expression] = STATE(513),
    [sym_tuple] = STATE(513),
    [sym_generator_expression] = STATE(513),
    [sym_conditional_expression] = STATE(601),
    [sym_concatenated_string] = STATE(513),
    [sym_await] = STATE(601),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_not] = ACTIONS(914),
    [anon_sym_PLUS] = ACTIONS(916),
    [anon_sym_DASH] = ACTIONS(916),
    [anon_sym_TILDE] = ACTIONS(916),
    [anon_sym_lambda] = ACTIONS(918),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(920),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(922),
    [sym_integer] = ACTIONS(924),
    [sym_float] = ACTIONS(924),
    [sym_identifier] = ACTIONS(924),
    [sym_true] = ACTIONS(924),
    [sym_false] = ACTIONS(924),
    [sym_none] = ACTIONS(924),
    [anon_sym_await] = ACTIONS(926),
    [sym_comment] = ACTIONS(72),
  },
  [231] = {
    [anon_sym_for] = ACTIONS(1199),
    [sym_comment] = ACTIONS(72),
  },
  [232] = {
    [sym_variables] = STATE(603),
    [sym__primary_expression] = STATE(103),
    [sym_binary_operator] = STATE(103),
    [sym_unary_operator] = STATE(103),
    [sym_attribute] = STATE(103),
    [sym_subscript] = STATE(103),
    [sym_call] = STATE(103),
    [sym_list] = STATE(103),
    [sym_list_comprehension] = STATE(103),
    [sym_dictionary] = STATE(103),
    [sym_dictionary_comprehension] = STATE(103),
    [sym_set] = STATE(103),
    [sym_set_comprehension] = STATE(103),
    [sym_parenthesized_expression] = STATE(103),
    [sym_tuple] = STATE(103),
    [sym_generator_expression] = STATE(103),
    [sym_concatenated_string] = STATE(103),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_PLUS] = ACTIONS(180),
    [anon_sym_DASH] = ACTIONS(180),
    [anon_sym_TILDE] = ACTIONS(180),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(182),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(184),
    [sym_integer] = ACTIONS(186),
    [sym_float] = ACTIONS(186),
    [sym_identifier] = ACTIONS(186),
    [sym_true] = ACTIONS(186),
    [sym_false] = ACTIONS(186),
    [sym_none] = ACTIONS(186),
    [sym_comment] = ACTIONS(72),
  },
  [233] = {
    [sym__expression] = STATE(604),
    [sym__primary_expression] = STATE(59),
    [sym_not_operator] = STATE(604),
    [sym_boolean_operator] = STATE(604),
    [sym_binary_operator] = STATE(59),
    [sym_unary_operator] = STATE(59),
    [sym_comparison_operator] = STATE(604),
    [sym_lambda] = STATE(604),
    [sym_attribute] = STATE(59),
    [sym_subscript] = STATE(59),
    [sym_call] = STATE(59),
    [sym_list] = STATE(59),
    [sym_list_comprehension] = STATE(59),
    [sym_dictionary] = STATE(59),
    [sym_dictionary_comprehension] = STATE(59),
    [sym_set] = STATE(59),
    [sym_set_comprehension] = STATE(59),
    [sym_parenthesized_expression] = STATE(59),
    [sym_tuple] = STATE(59),
    [sym_generator_expression] = STATE(59),
    [sym_conditional_expression] = STATE(604),
    [sym_concatenated_string] = STATE(59),
    [sym_await] = STATE(604),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_not] = ACTIONS(88),
    [anon_sym_PLUS] = ACTIONS(90),
    [anon_sym_DASH] = ACTIONS(90),
    [anon_sym_TILDE] = ACTIONS(90),
    [anon_sym_lambda] = ACTIONS(92),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(98),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(102),
    [sym_integer] = ACTIONS(104),
    [sym_float] = ACTIONS(104),
    [sym_identifier] = ACTIONS(104),
    [sym_true] = ACTIONS(104),
    [sym_false] = ACTIONS(104),
    [sym_none] = ACTIONS(104),
    [anon_sym_await] = ACTIONS(106),
    [sym_comment] = ACTIONS(72),
  },
  [234] = {
    [sym__expression] = STATE(605),
    [sym__primary_expression] = STATE(59),
    [sym_not_operator] = STATE(605),
    [sym_boolean_operator] = STATE(605),
    [sym_binary_operator] = STATE(59),
    [sym_unary_operator] = STATE(59),
    [sym_comparison_operator] = STATE(605),
    [sym_lambda] = STATE(605),
    [sym_attribute] = STATE(59),
    [sym_subscript] = STATE(59),
    [sym_call] = STATE(59),
    [sym_list] = STATE(59),
    [sym_list_comprehension] = STATE(59),
    [sym_dictionary] = STATE(59),
    [sym_dictionary_comprehension] = STATE(59),
    [sym_set] = STATE(59),
    [sym_set_comprehension] = STATE(59),
    [sym_parenthesized_expression] = STATE(59),
    [sym_tuple] = STATE(59),
    [sym_generator_expression] = STATE(59),
    [sym_conditional_expression] = STATE(605),
    [sym_concatenated_string] = STATE(59),
    [sym_await] = STATE(605),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_not] = ACTIONS(88),
    [anon_sym_PLUS] = ACTIONS(90),
    [anon_sym_DASH] = ACTIONS(90),
    [anon_sym_TILDE] = ACTIONS(90),
    [anon_sym_lambda] = ACTIONS(92),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(98),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(102),
    [sym_integer] = ACTIONS(104),
    [sym_float] = ACTIONS(104),
    [sym_identifier] = ACTIONS(104),
    [sym_true] = ACTIONS(104),
    [sym_false] = ACTIONS(104),
    [sym_none] = ACTIONS(104),
    [anon_sym_await] = ACTIONS(106),
    [sym_comment] = ACTIONS(72),
  },
  [235] = {
    [anon_sym_RPAREN] = ACTIONS(1201),
    [sym_comment] = ACTIONS(72),
  },
  [236] = {
    [sym_for_in_clause] = STATE(608),
    [sym_if_clause] = STATE(608),
    [aux_sym__comprehension_body_repeat1] = STATE(608),
    [anon_sym_RPAREN] = ACTIONS(1203),
    [anon_sym_if] = ACTIONS(1205),
    [anon_sym_async] = ACTIONS(414),
    [anon_sym_for] = ACTIONS(416),
    [sym_comment] = ACTIONS(72),
  },
  [237] = {
    [aux_sym_tuple_repeat1] = STATE(610),
    [anon_sym_RPAREN] = ACTIONS(1197),
    [anon_sym_COMMA] = ACTIONS(1207),
    [sym_comment] = ACTIONS(72),
  },
  [238] = {
    [sym_identifier] = ACTIONS(1209),
    [sym_comment] = ACTIONS(72),
  },
  [239] = {
    [sym_list_splat] = STATE(614),
    [sym_dictionary_splat] = STATE(614),
    [sym__expression] = STATE(615),
    [sym__primary_expression] = STATE(59),
    [sym_not_operator] = STATE(615),
    [sym_boolean_operator] = STATE(615),
    [sym_binary_operator] = STATE(59),
    [sym_unary_operator] = STATE(59),
    [sym_comparison_operator] = STATE(615),
    [sym_lambda] = STATE(615),
    [sym_attribute] = STATE(59),
    [sym_subscript] = STATE(59),
    [sym_call] = STATE(59),
    [sym_keyword_argument] = STATE(614),
    [sym_list] = STATE(59),
    [sym_list_comprehension] = STATE(59),
    [sym_dictionary] = STATE(59),
    [sym_dictionary_comprehension] = STATE(59),
    [sym_set] = STATE(59),
    [sym_set_comprehension] = STATE(59),
    [sym_parenthesized_expression] = STATE(59),
    [sym_tuple] = STATE(59),
    [sym_generator_expression] = STATE(59),
    [sym_conditional_expression] = STATE(615),
    [sym_concatenated_string] = STATE(59),
    [sym_await] = STATE(615),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_RPAREN] = ACTIONS(1211),
    [anon_sym_COMMA] = ACTIONS(1213),
    [anon_sym_STAR] = ACTIONS(936),
    [anon_sym_print] = ACTIONS(938),
    [anon_sym_exec] = ACTIONS(938),
    [anon_sym_not] = ACTIONS(88),
    [anon_sym_PLUS] = ACTIONS(90),
    [anon_sym_DASH] = ACTIONS(90),
    [anon_sym_TILDE] = ACTIONS(90),
    [anon_sym_lambda] = ACTIONS(92),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(98),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(102),
    [sym_integer] = ACTIONS(104),
    [sym_float] = ACTIONS(104),
    [sym_identifier] = ACTIONS(940),
    [sym_true] = ACTIONS(104),
    [sym_false] = ACTIONS(104),
    [sym_none] = ACTIONS(104),
    [anon_sym_await] = ACTIONS(106),
    [sym_comment] = ACTIONS(72),
  },
  [240] = {
    [sym__primary_expression] = STATE(616),
    [sym_binary_operator] = STATE(616),
    [sym_unary_operator] = STATE(616),
    [sym_attribute] = STATE(616),
    [sym_subscript] = STATE(616),
    [sym_call] = STATE(616),
    [sym_list] = STATE(616),
    [sym_list_comprehension] = STATE(616),
    [sym_dictionary] = STATE(616),
    [sym_dictionary_comprehension] = STATE(616),
    [sym_set] = STATE(616),
    [sym_set_comprehension] = STATE(616),
    [sym_parenthesized_expression] = STATE(616),
    [sym_tuple] = STATE(616),
    [sym_generator_expression] = STATE(616),
    [sym_concatenated_string] = STATE(616),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_PLUS] = ACTIONS(90),
    [anon_sym_DASH] = ACTIONS(90),
    [anon_sym_TILDE] = ACTIONS(90),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(1215),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(102),
    [sym_integer] = ACTIONS(1217),
    [sym_float] = ACTIONS(1217),
    [sym_identifier] = ACTIONS(1217),
    [sym_true] = ACTIONS(1217),
    [sym_false] = ACTIONS(1217),
    [sym_none] = ACTIONS(1217),
    [sym_comment] = ACTIONS(72),
  },
  [241] = {
    [sym__primary_expression] = STATE(617),
    [sym_binary_operator] = STATE(617),
    [sym_unary_operator] = STATE(617),
    [sym_attribute] = STATE(617),
    [sym_subscript] = STATE(617),
    [sym_call] = STATE(617),
    [sym_list] = STATE(617),
    [sym_list_comprehension] = STATE(617),
    [sym_dictionary] = STATE(617),
    [sym_dictionary_comprehension] = STATE(617),
    [sym_set] = STATE(617),
    [sym_set_comprehension] = STATE(617),
    [sym_parenthesized_expression] = STATE(617),
    [sym_tuple] = STATE(617),
    [sym_generator_expression] = STATE(617),
    [sym_concatenated_string] = STATE(617),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_PLUS] = ACTIONS(90),
    [anon_sym_DASH] = ACTIONS(90),
    [anon_sym_TILDE] = ACTIONS(90),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(1219),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(102),
    [sym_integer] = ACTIONS(1221),
    [sym_float] = ACTIONS(1221),
    [sym_identifier] = ACTIONS(1221),
    [sym_true] = ACTIONS(1221),
    [sym_false] = ACTIONS(1221),
    [sym_none] = ACTIONS(1221),
    [sym_comment] = ACTIONS(72),
  },
  [242] = {
    [sym__primary_expression] = STATE(618),
    [sym_binary_operator] = STATE(618),
    [sym_unary_operator] = STATE(618),
    [sym_attribute] = STATE(618),
    [sym_subscript] = STATE(618),
    [sym_call] = STATE(618),
    [sym_list] = STATE(618),
    [sym_list_comprehension] = STATE(618),
    [sym_dictionary] = STATE(618),
    [sym_dictionary_comprehension] = STATE(618),
    [sym_set] = STATE(618),
    [sym_set_comprehension] = STATE(618),
    [sym_parenthesized_expression] = STATE(618),
    [sym_tuple] = STATE(618),
    [sym_generator_expression] = STATE(618),
    [sym_concatenated_string] = STATE(618),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_PLUS] = ACTIONS(90),
    [anon_sym_DASH] = ACTIONS(90),
    [anon_sym_TILDE] = ACTIONS(90),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(1223),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(102),
    [sym_integer] = ACTIONS(1225),
    [sym_float] = ACTIONS(1225),
    [sym_identifier] = ACTIONS(1225),
    [sym_true] = ACTIONS(1225),
    [sym_false] = ACTIONS(1225),
    [sym_none] = ACTIONS(1225),
    [sym_comment] = ACTIONS(72),
  },
  [243] = {
    [anon_sym_in] = ACTIONS(1227),
    [sym_comment] = ACTIONS(72),
  },
  [244] = {
    [sym__primary_expression] = STATE(620),
    [sym_binary_operator] = STATE(620),
    [sym_unary_operator] = STATE(620),
    [sym_attribute] = STATE(620),
    [sym_subscript] = STATE(620),
    [sym_call] = STATE(620),
    [sym_list] = STATE(620),
    [sym_list_comprehension] = STATE(620),
    [sym_dictionary] = STATE(620),
    [sym_dictionary_comprehension] = STATE(620),
    [sym_set] = STATE(620),
    [sym_set_comprehension] = STATE(620),
    [sym_parenthesized_expression] = STATE(620),
    [sym_tuple] = STATE(620),
    [sym_generator_expression] = STATE(620),
    [sym_concatenated_string] = STATE(620),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_PLUS] = ACTIONS(90),
    [anon_sym_DASH] = ACTIONS(90),
    [anon_sym_TILDE] = ACTIONS(90),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(1229),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(102),
    [sym_integer] = ACTIONS(1231),
    [sym_float] = ACTIONS(1231),
    [sym_identifier] = ACTIONS(1231),
    [sym_true] = ACTIONS(1231),
    [sym_false] = ACTIONS(1231),
    [sym_none] = ACTIONS(1231),
    [sym_comment] = ACTIONS(72),
  },
  [245] = {
    [sym__primary_expression] = STATE(621),
    [sym_binary_operator] = STATE(621),
    [sym_unary_operator] = STATE(621),
    [sym_attribute] = STATE(621),
    [sym_subscript] = STATE(621),
    [sym_call] = STATE(621),
    [sym_list] = STATE(621),
    [sym_list_comprehension] = STATE(621),
    [sym_dictionary] = STATE(621),
    [sym_dictionary_comprehension] = STATE(621),
    [sym_set] = STATE(621),
    [sym_set_comprehension] = STATE(621),
    [sym_parenthesized_expression] = STATE(621),
    [sym_tuple] = STATE(621),
    [sym_generator_expression] = STATE(621),
    [sym_concatenated_string] = STATE(621),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_PLUS] = ACTIONS(90),
    [anon_sym_DASH] = ACTIONS(90),
    [anon_sym_TILDE] = ACTIONS(90),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(1233),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(102),
    [sym_integer] = ACTIONS(1235),
    [sym_float] = ACTIONS(1235),
    [sym_identifier] = ACTIONS(1235),
    [sym_true] = ACTIONS(1235),
    [sym_false] = ACTIONS(1235),
    [sym_none] = ACTIONS(1235),
    [sym_comment] = ACTIONS(72),
  },
  [246] = {
    [sym__primary_expression] = STATE(622),
    [sym_binary_operator] = STATE(622),
    [sym_unary_operator] = STATE(622),
    [sym_attribute] = STATE(622),
    [sym_subscript] = STATE(622),
    [sym_call] = STATE(622),
    [sym_list] = STATE(622),
    [sym_list_comprehension] = STATE(622),
    [sym_dictionary] = STATE(622),
    [sym_dictionary_comprehension] = STATE(622),
    [sym_set] = STATE(622),
    [sym_set_comprehension] = STATE(622),
    [sym_parenthesized_expression] = STATE(622),
    [sym_tuple] = STATE(622),
    [sym_generator_expression] = STATE(622),
    [sym_concatenated_string] = STATE(622),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_PLUS] = ACTIONS(90),
    [anon_sym_DASH] = ACTIONS(90),
    [anon_sym_TILDE] = ACTIONS(90),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(1237),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(102),
    [sym_integer] = ACTIONS(1239),
    [sym_float] = ACTIONS(1239),
    [sym_identifier] = ACTIONS(1239),
    [sym_true] = ACTIONS(1239),
    [sym_false] = ACTIONS(1239),
    [sym_none] = ACTIONS(1239),
    [sym_comment] = ACTIONS(72),
  },
  [247] = {
    [sym__primary_expression] = STATE(623),
    [sym_binary_operator] = STATE(623),
    [sym_unary_operator] = STATE(623),
    [sym_attribute] = STATE(623),
    [sym_subscript] = STATE(623),
    [sym_call] = STATE(623),
    [sym_list] = STATE(623),
    [sym_list_comprehension] = STATE(623),
    [sym_dictionary] = STATE(623),
    [sym_dictionary_comprehension] = STATE(623),
    [sym_set] = STATE(623),
    [sym_set_comprehension] = STATE(623),
    [sym_parenthesized_expression] = STATE(623),
    [sym_tuple] = STATE(623),
    [sym_generator_expression] = STATE(623),
    [sym_concatenated_string] = STATE(623),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_PLUS] = ACTIONS(90),
    [anon_sym_DASH] = ACTIONS(90),
    [anon_sym_TILDE] = ACTIONS(90),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(1241),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(102),
    [sym_integer] = ACTIONS(1243),
    [sym_float] = ACTIONS(1243),
    [sym_identifier] = ACTIONS(1243),
    [sym_true] = ACTIONS(1243),
    [sym_false] = ACTIONS(1243),
    [sym_none] = ACTIONS(1243),
    [sym_comment] = ACTIONS(72),
  },
  [248] = {
    [sym__primary_expression] = STATE(624),
    [sym_binary_operator] = STATE(624),
    [sym_unary_operator] = STATE(624),
    [sym_attribute] = STATE(624),
    [sym_subscript] = STATE(624),
    [sym_call] = STATE(624),
    [sym_list] = STATE(624),
    [sym_list_comprehension] = STATE(624),
    [sym_dictionary] = STATE(624),
    [sym_dictionary_comprehension] = STATE(624),
    [sym_set] = STATE(624),
    [sym_set_comprehension] = STATE(624),
    [sym_parenthesized_expression] = STATE(624),
    [sym_tuple] = STATE(624),
    [sym_generator_expression] = STATE(624),
    [sym_concatenated_string] = STATE(624),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_PLUS] = ACTIONS(90),
    [anon_sym_DASH] = ACTIONS(90),
    [anon_sym_TILDE] = ACTIONS(90),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(1245),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(102),
    [sym_integer] = ACTIONS(1247),
    [sym_float] = ACTIONS(1247),
    [sym_identifier] = ACTIONS(1247),
    [sym_true] = ACTIONS(1247),
    [sym_false] = ACTIONS(1247),
    [sym_none] = ACTIONS(1247),
    [sym_comment] = ACTIONS(72),
  },
  [249] = {
    [sym__primary_expression] = STATE(618),
    [sym_binary_operator] = STATE(618),
    [sym_unary_operator] = STATE(618),
    [sym_attribute] = STATE(618),
    [sym_subscript] = STATE(618),
    [sym_call] = STATE(618),
    [sym_list] = STATE(618),
    [sym_list_comprehension] = STATE(618),
    [sym_dictionary] = STATE(618),
    [sym_dictionary_comprehension] = STATE(618),
    [sym_set] = STATE(618),
    [sym_set_comprehension] = STATE(618),
    [sym_parenthesized_expression] = STATE(618),
    [sym_tuple] = STATE(618),
    [sym_generator_expression] = STATE(618),
    [sym_concatenated_string] = STATE(618),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_not] = ACTIONS(1249),
    [anon_sym_PLUS] = ACTIONS(90),
    [anon_sym_DASH] = ACTIONS(90),
    [anon_sym_TILDE] = ACTIONS(90),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(1223),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(102),
    [sym_integer] = ACTIONS(1225),
    [sym_float] = ACTIONS(1225),
    [sym_identifier] = ACTIONS(1225),
    [sym_true] = ACTIONS(1225),
    [sym_false] = ACTIONS(1225),
    [sym_none] = ACTIONS(1225),
    [sym_comment] = ACTIONS(72),
  },
  [250] = {
    [sym__expression] = STATE(625),
    [sym__primary_expression] = STATE(542),
    [sym_not_operator] = STATE(625),
    [sym_boolean_operator] = STATE(625),
    [sym_binary_operator] = STATE(542),
    [sym_unary_operator] = STATE(542),
    [sym_comparison_operator] = STATE(625),
    [sym_lambda] = STATE(625),
    [sym_attribute] = STATE(542),
    [sym_subscript] = STATE(542),
    [sym_slice] = STATE(626),
    [sym_call] = STATE(542),
    [sym_list] = STATE(542),
    [sym_list_comprehension] = STATE(542),
    [sym_dictionary] = STATE(542),
    [sym_dictionary_comprehension] = STATE(542),
    [sym_set] = STATE(542),
    [sym_set_comprehension] = STATE(542),
    [sym_parenthesized_expression] = STATE(542),
    [sym_tuple] = STATE(542),
    [sym_generator_expression] = STATE(542),
    [sym_conditional_expression] = STATE(625),
    [sym_concatenated_string] = STATE(542),
    [sym_await] = STATE(625),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_COLON] = ACTIONS(978),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_not] = ACTIONS(980),
    [anon_sym_PLUS] = ACTIONS(982),
    [anon_sym_DASH] = ACTIONS(982),
    [anon_sym_TILDE] = ACTIONS(982),
    [anon_sym_lambda] = ACTIONS(984),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(986),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(988),
    [sym_integer] = ACTIONS(990),
    [sym_float] = ACTIONS(990),
    [sym_identifier] = ACTIONS(990),
    [sym_true] = ACTIONS(990),
    [sym_false] = ACTIONS(990),
    [sym_none] = ACTIONS(990),
    [anon_sym_await] = ACTIONS(992),
    [sym_comment] = ACTIONS(72),
  },
  [251] = {
    [anon_sym_DOT] = ACTIONS(994),
    [anon_sym_LPAREN] = ACTIONS(994),
    [anon_sym_RPAREN] = ACTIONS(994),
    [anon_sym_COMMA] = ACTIONS(994),
    [anon_sym_as] = ACTIONS(996),
    [anon_sym_STAR] = ACTIONS(996),
    [anon_sym_GT_GT] = ACTIONS(994),
    [anon_sym_if] = ACTIONS(994),
    [anon_sym_COLON] = ACTIONS(994),
    [anon_sym_else] = ACTIONS(994),
    [anon_sym_async] = ACTIONS(994),
    [anon_sym_for] = ACTIONS(994),
    [anon_sym_in] = ACTIONS(994),
    [anon_sym_EQ] = ACTIONS(996),
    [anon_sym_AT] = ACTIONS(994),
    [anon_sym_not] = ACTIONS(994),
    [anon_sym_and] = ACTIONS(994),
    [anon_sym_or] = ACTIONS(994),
    [anon_sym_PLUS] = ACTIONS(994),
    [anon_sym_DASH] = ACTIONS(994),
    [anon_sym_SLASH] = ACTIONS(996),
    [anon_sym_PERCENT] = ACTIONS(994),
    [anon_sym_SLASH_SLASH] = ACTIONS(994),
    [anon_sym_STAR_STAR] = ACTIONS(994),
    [anon_sym_PIPE] = ACTIONS(994),
    [anon_sym_AMP] = ACTIONS(994),
    [anon_sym_CARET] = ACTIONS(994),
    [anon_sym_LT_LT] = ACTIONS(994),
    [anon_sym_LT] = ACTIONS(996),
    [anon_sym_LT_EQ] = ACTIONS(994),
    [anon_sym_EQ_EQ] = ACTIONS(994),
    [anon_sym_BANG_EQ] = ACTIONS(994),
    [anon_sym_GT_EQ] = ACTIONS(994),
    [anon_sym_GT] = ACTIONS(996),
    [anon_sym_LT_GT] = ACTIONS(994),
    [anon_sym_is] = ACTIONS(994),
    [anon_sym_LBRACK] = ACTIONS(994),
    [anon_sym_RBRACK] = ACTIONS(994),
    [anon_sym_RBRACE] = ACTIONS(994),
    [sym_comment] = ACTIONS(72),
  },
  [252] = {
    [aux_sym_comparison_operator_repeat1] = STATE(627),
    [anon_sym_RPAREN] = ACTIONS(998),
    [anon_sym_COMMA] = ACTIONS(998),
    [anon_sym_if] = ACTIONS(998),
    [anon_sym_async] = ACTIONS(998),
    [anon_sym_for] = ACTIONS(998),
    [anon_sym_in] = ACTIONS(430),
    [anon_sym_not] = ACTIONS(434),
    [anon_sym_and] = ACTIONS(998),
    [anon_sym_or] = ACTIONS(998),
    [anon_sym_LT] = ACTIONS(446),
    [anon_sym_LT_EQ] = ACTIONS(430),
    [anon_sym_EQ_EQ] = ACTIONS(430),
    [anon_sym_BANG_EQ] = ACTIONS(430),
    [anon_sym_GT_EQ] = ACTIONS(430),
    [anon_sym_GT] = ACTIONS(446),
    [anon_sym_LT_GT] = ACTIONS(430),
    [anon_sym_is] = ACTIONS(448),
    [sym_comment] = ACTIONS(72),
  },
  [253] = {
    [sym__newline] = ACTIONS(370),
    [anon_sym_DOT] = ACTIONS(370),
    [anon_sym_from] = ACTIONS(370),
    [anon_sym_LPAREN] = ACTIONS(370),
    [anon_sym_COMMA] = ACTIONS(370),
    [anon_sym_STAR] = ACTIONS(372),
    [anon_sym_GT_GT] = ACTIONS(370),
    [anon_sym_if] = ACTIONS(370),
    [anon_sym_in] = ACTIONS(370),
    [anon_sym_EQ] = ACTIONS(372),
    [anon_sym_AT] = ACTIONS(370),
    [anon_sym_not] = ACTIONS(370),
    [anon_sym_and] = ACTIONS(370),
    [anon_sym_or] = ACTIONS(370),
    [anon_sym_PLUS] = ACTIONS(370),
    [anon_sym_DASH] = ACTIONS(370),
    [anon_sym_SLASH] = ACTIONS(372),
    [anon_sym_PERCENT] = ACTIONS(370),
    [anon_sym_SLASH_SLASH] = ACTIONS(370),
    [anon_sym_STAR_STAR] = ACTIONS(370),
    [anon_sym_PIPE] = ACTIONS(370),
    [anon_sym_AMP] = ACTIONS(370),
    [anon_sym_CARET] = ACTIONS(370),
    [anon_sym_LT_LT] = ACTIONS(370),
    [anon_sym_LT] = ACTIONS(372),
    [anon_sym_LT_EQ] = ACTIONS(370),
    [anon_sym_EQ_EQ] = ACTIONS(370),
    [anon_sym_BANG_EQ] = ACTIONS(370),
    [anon_sym_GT_EQ] = ACTIONS(370),
    [anon_sym_GT] = ACTIONS(372),
    [anon_sym_LT_GT] = ACTIONS(370),
    [anon_sym_is] = ACTIONS(370),
    [anon_sym_LBRACK] = ACTIONS(370),
    [sym_comment] = ACTIONS(72),
    [sym__semicolon] = ACTIONS(370),
  },
  [254] = {
    [anon_sym_RPAREN] = ACTIONS(1251),
    [sym_comment] = ACTIONS(72),
  },
  [255] = {
    [sym__comprehension_body] = STATE(631),
    [sym_for_in_clause] = STATE(236),
    [aux_sym_tuple_repeat1] = STATE(632),
    [anon_sym_RPAREN] = ACTIONS(1253),
    [anon_sym_COMMA] = ACTIONS(1255),
    [anon_sym_if] = ACTIONS(412),
    [anon_sym_async] = ACTIONS(414),
    [anon_sym_for] = ACTIONS(416),
    [anon_sym_and] = ACTIONS(418),
    [anon_sym_or] = ACTIONS(420),
    [sym_comment] = ACTIONS(72),
  },
  [256] = {
    [aux_sym_tuple_repeat1] = STATE(632),
    [anon_sym_RPAREN] = ACTIONS(1253),
    [anon_sym_COMMA] = ACTIONS(1255),
    [sym_comment] = ACTIONS(72),
  },
  [257] = {
    [sym__newline] = ACTIONS(1257),
    [anon_sym_COMMA] = ACTIONS(1257),
    [anon_sym_if] = ACTIONS(476),
    [anon_sym_and] = ACTIONS(478),
    [anon_sym_or] = ACTIONS(480),
    [sym_comment] = ACTIONS(72),
    [sym__semicolon] = ACTIONS(1257),
  },
  [258] = {
    [sym__newline] = ACTIONS(716),
    [anon_sym_COMMA] = ACTIONS(716),
    [anon_sym_if] = ACTIONS(716),
    [anon_sym_and] = ACTIONS(478),
    [anon_sym_or] = ACTIONS(480),
    [sym_comment] = ACTIONS(72),
    [sym__semicolon] = ACTIONS(716),
  },
  [259] = {
    [sym_argument_list] = STATE(291),
    [sym_generator_expression] = STATE(291),
    [sym__newline] = ACTIONS(718),
    [anon_sym_DOT] = ACTIONS(718),
    [anon_sym_from] = ACTIONS(718),
    [anon_sym_LPAREN] = ACTIONS(484),
    [anon_sym_COMMA] = ACTIONS(718),
    [anon_sym_STAR] = ACTIONS(720),
    [anon_sym_GT_GT] = ACTIONS(718),
    [anon_sym_if] = ACTIONS(718),
    [anon_sym_in] = ACTIONS(718),
    [anon_sym_EQ] = ACTIONS(720),
    [anon_sym_AT] = ACTIONS(718),
    [anon_sym_not] = ACTIONS(718),
    [anon_sym_and] = ACTIONS(718),
    [anon_sym_or] = ACTIONS(718),
    [anon_sym_PLUS] = ACTIONS(718),
    [anon_sym_DASH] = ACTIONS(718),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_PERCENT] = ACTIONS(718),
    [anon_sym_SLASH_SLASH] = ACTIONS(718),
    [anon_sym_STAR_STAR] = ACTIONS(718),
    [anon_sym_PIPE] = ACTIONS(718),
    [anon_sym_AMP] = ACTIONS(718),
    [anon_sym_CARET] = ACTIONS(718),
    [anon_sym_LT_LT] = ACTIONS(718),
    [anon_sym_LT] = ACTIONS(720),
    [anon_sym_LT_EQ] = ACTIONS(718),
    [anon_sym_EQ_EQ] = ACTIONS(718),
    [anon_sym_BANG_EQ] = ACTIONS(718),
    [anon_sym_GT_EQ] = ACTIONS(718),
    [anon_sym_GT] = ACTIONS(720),
    [anon_sym_LT_GT] = ACTIONS(718),
    [anon_sym_is] = ACTIONS(718),
    [anon_sym_LBRACK] = ACTIONS(718),
    [sym_comment] = ACTIONS(72),
    [sym__semicolon] = ACTIONS(718),
  },
  [260] = {
    [sym__expression] = STATE(633),
    [sym__primary_expression] = STATE(73),
    [sym_not_operator] = STATE(633),
    [sym_boolean_operator] = STATE(633),
    [sym_binary_operator] = STATE(73),
    [sym_unary_operator] = STATE(73),
    [sym_comparison_operator] = STATE(633),
    [sym_lambda] = STATE(633),
    [sym_attribute] = STATE(73),
    [sym_subscript] = STATE(73),
    [sym_call] = STATE(73),
    [sym_list] = STATE(73),
    [sym_list_comprehension] = STATE(73),
    [sym_dictionary] = STATE(73),
    [sym_dictionary_comprehension] = STATE(73),
    [sym_set] = STATE(73),
    [sym_set_comprehension] = STATE(73),
    [sym_parenthesized_expression] = STATE(73),
    [sym_tuple] = STATE(73),
    [sym_generator_expression] = STATE(73),
    [sym_conditional_expression] = STATE(633),
    [sym_concatenated_string] = STATE(73),
    [sym_await] = STATE(633),
    [anon_sym_LPAREN] = ACTIONS(130),
    [anon_sym_print] = ACTIONS(112),
    [anon_sym_exec] = ACTIONS(112),
    [anon_sym_not] = ACTIONS(132),
    [anon_sym_PLUS] = ACTIONS(116),
    [anon_sym_DASH] = ACTIONS(116),
    [anon_sym_TILDE] = ACTIONS(116),
    [anon_sym_lambda] = ACTIONS(118),
    [anon_sym_LBRACK] = ACTIONS(134),
    [sym_ellipsis] = ACTIONS(120),
    [anon_sym_LBRACE] = ACTIONS(122),
    [sym_string] = ACTIONS(124),
    [sym_integer] = ACTIONS(126),
    [sym_float] = ACTIONS(126),
    [sym_identifier] = ACTIONS(126),
    [sym_true] = ACTIONS(126),
    [sym_false] = ACTIONS(126),
    [sym_none] = ACTIONS(126),
    [anon_sym_await] = ACTIONS(128),
    [sym_comment] = ACTIONS(72),
  },
  [261] = {
    [anon_sym_COLON] = ACTIONS(1259),
    [sym_comment] = ACTIONS(72),
  },
  [262] = {
    [anon_sym_RBRACK] = ACTIONS(1261),
    [sym_comment] = ACTIONS(72),
  },
  [263] = {
    [sym__newline] = ACTIONS(776),
    [anon_sym_DOT] = ACTIONS(776),
    [anon_sym_from] = ACTIONS(776),
    [anon_sym_LPAREN] = ACTIONS(776),
    [anon_sym_COMMA] = ACTIONS(776),
    [anon_sym_STAR] = ACTIONS(778),
    [anon_sym_GT_GT] = ACTIONS(776),
    [anon_sym_if] = ACTIONS(776),
    [anon_sym_in] = ACTIONS(776),
    [anon_sym_EQ] = ACTIONS(778),
    [anon_sym_AT] = ACTIONS(776),
    [anon_sym_not] = ACTIONS(776),
    [anon_sym_and] = ACTIONS(776),
    [anon_sym_or] = ACTIONS(776),
    [anon_sym_PLUS] = ACTIONS(776),
    [anon_sym_DASH] = ACTIONS(776),
    [anon_sym_SLASH] = ACTIONS(778),
    [anon_sym_PERCENT] = ACTIONS(776),
    [anon_sym_SLASH_SLASH] = ACTIONS(776),
    [anon_sym_STAR_STAR] = ACTIONS(776),
    [anon_sym_PIPE] = ACTIONS(776),
    [anon_sym_AMP] = ACTIONS(776),
    [anon_sym_CARET] = ACTIONS(776),
    [anon_sym_LT_LT] = ACTIONS(776),
    [anon_sym_LT] = ACTIONS(778),
    [anon_sym_LT_EQ] = ACTIONS(776),
    [anon_sym_EQ_EQ] = ACTIONS(776),
    [anon_sym_BANG_EQ] = ACTIONS(776),
    [anon_sym_GT_EQ] = ACTIONS(776),
    [anon_sym_GT] = ACTIONS(778),
    [anon_sym_LT_GT] = ACTIONS(776),
    [anon_sym_is] = ACTIONS(776),
    [anon_sym_LBRACK] = ACTIONS(776),
    [sym_comment] = ACTIONS(72),
    [sym__semicolon] = ACTIONS(776),
  },
  [264] = {
    [aux_sym_list_repeat1] = STATE(637),
    [anon_sym_COMMA] = ACTIONS(1263),
    [anon_sym_RBRACK] = ACTIONS(1261),
    [sym_comment] = ACTIONS(72),
  },
  [265] = {
    [sym__comprehension_body] = STATE(638),
    [sym_for_in_clause] = STATE(443),
    [aux_sym_list_repeat1] = STATE(637),
    [anon_sym_COMMA] = ACTIONS(1263),
    [anon_sym_if] = ACTIONS(784),
    [anon_sym_async] = ACTIONS(786),
    [anon_sym_for] = ACTIONS(788),
    [anon_sym_and] = ACTIONS(790),
    [anon_sym_or] = ACTIONS(792),
    [anon_sym_RBRACK] = ACTIONS(1261),
    [sym_comment] = ACTIONS(72),
  },
  [266] = {
    [anon_sym_RBRACE] = ACTIONS(1265),
    [sym_comment] = ACTIONS(72),
  },
  [267] = {
    [sym__newline] = ACTIONS(838),
    [anon_sym_DOT] = ACTIONS(838),
    [anon_sym_from] = ACTIONS(838),
    [anon_sym_LPAREN] = ACTIONS(838),
    [anon_sym_COMMA] = ACTIONS(838),
    [anon_sym_STAR] = ACTIONS(840),
    [anon_sym_GT_GT] = ACTIONS(838),
    [anon_sym_if] = ACTIONS(838),
    [anon_sym_in] = ACTIONS(838),
    [anon_sym_EQ] = ACTIONS(840),
    [anon_sym_AT] = ACTIONS(838),
    [anon_sym_not] = ACTIONS(838),
    [anon_sym_and] = ACTIONS(838),
    [anon_sym_or] = ACTIONS(838),
    [anon_sym_PLUS] = ACTIONS(838),
    [anon_sym_DASH] = ACTIONS(838),
    [anon_sym_SLASH] = ACTIONS(840),
    [anon_sym_PERCENT] = ACTIONS(838),
    [anon_sym_SLASH_SLASH] = ACTIONS(838),
    [anon_sym_STAR_STAR] = ACTIONS(838),
    [anon_sym_PIPE] = ACTIONS(838),
    [anon_sym_AMP] = ACTIONS(838),
    [anon_sym_CARET] = ACTIONS(838),
    [anon_sym_LT_LT] = ACTIONS(838),
    [anon_sym_LT] = ACTIONS(840),
    [anon_sym_LT_EQ] = ACTIONS(838),
    [anon_sym_EQ_EQ] = ACTIONS(838),
    [anon_sym_BANG_EQ] = ACTIONS(838),
    [anon_sym_GT_EQ] = ACTIONS(838),
    [anon_sym_GT] = ACTIONS(840),
    [anon_sym_LT_GT] = ACTIONS(838),
    [anon_sym_is] = ACTIONS(838),
    [anon_sym_LBRACK] = ACTIONS(838),
    [sym_comment] = ACTIONS(72),
    [sym__semicolon] = ACTIONS(838),
  },
  [268] = {
    [aux_sym_list_repeat1] = STATE(642),
    [anon_sym_COMMA] = ACTIONS(1267),
    [anon_sym_RBRACE] = ACTIONS(1269),
    [sym_comment] = ACTIONS(72),
  },
  [269] = {
    [aux_sym_dictionary_repeat1] = STATE(644),
    [anon_sym_COMMA] = ACTIONS(1271),
    [anon_sym_RBRACE] = ACTIONS(1265),
    [sym_comment] = ACTIONS(72),
  },
  [270] = {
    [sym__comprehension_body] = STATE(645),
    [sym_for_in_clause] = STATE(480),
    [aux_sym_list_repeat1] = STATE(642),
    [anon_sym_COMMA] = ACTIONS(1267),
    [anon_sym_if] = ACTIONS(850),
    [anon_sym_COLON] = ACTIONS(852),
    [anon_sym_async] = ACTIONS(854),
    [anon_sym_for] = ACTIONS(856),
    [anon_sym_and] = ACTIONS(858),
    [anon_sym_or] = ACTIONS(860),
    [anon_sym_RBRACE] = ACTIONS(1269),
    [sym_comment] = ACTIONS(72),
  },
  [271] = {
    [sym__comprehension_body] = STATE(646),
    [sym_for_in_clause] = STATE(480),
    [aux_sym_dictionary_repeat1] = STATE(644),
    [anon_sym_COMMA] = ACTIONS(1271),
    [anon_sym_async] = ACTIONS(854),
    [anon_sym_for] = ACTIONS(856),
    [anon_sym_RBRACE] = ACTIONS(1265),
    [sym_comment] = ACTIONS(72),
  },
  [272] = {
    [aux_sym_concatenated_string_repeat1] = STATE(647),
    [sym__newline] = ACTIONS(886),
    [anon_sym_DOT] = ACTIONS(886),
    [anon_sym_LPAREN] = ACTIONS(886),
    [anon_sym_COMMA] = ACTIONS(886),
    [anon_sym_STAR] = ACTIONS(888),
    [anon_sym_GT_GT] = ACTIONS(886),
    [anon_sym_if] = ACTIONS(886),
    [anon_sym_in] = ACTIONS(886),
    [anon_sym_AT] = ACTIONS(886),
    [anon_sym_not] = ACTIONS(886),
    [anon_sym_and] = ACTIONS(886),
    [anon_sym_or] = ACTIONS(886),
    [anon_sym_PLUS] = ACTIONS(886),
    [anon_sym_DASH] = ACTIONS(886),
    [anon_sym_SLASH] = ACTIONS(888),
    [anon_sym_PERCENT] = ACTIONS(886),
    [anon_sym_SLASH_SLASH] = ACTIONS(886),
    [anon_sym_STAR_STAR] = ACTIONS(886),
    [anon_sym_PIPE] = ACTIONS(886),
    [anon_sym_AMP] = ACTIONS(886),
    [anon_sym_CARET] = ACTIONS(886),
    [anon_sym_LT_LT] = ACTIONS(886),
    [anon_sym_LT] = ACTIONS(888),
    [anon_sym_LT_EQ] = ACTIONS(886),
    [anon_sym_EQ_EQ] = ACTIONS(886),
    [anon_sym_BANG_EQ] = ACTIONS(886),
    [anon_sym_GT_EQ] = ACTIONS(886),
    [anon_sym_GT] = ACTIONS(888),
    [anon_sym_LT_GT] = ACTIONS(886),
    [anon_sym_is] = ACTIONS(886),
    [anon_sym_LBRACK] = ACTIONS(886),
    [sym_string] = ACTIONS(1273),
    [sym_comment] = ACTIONS(72),
    [sym__semicolon] = ACTIONS(886),
  },
  [273] = {
    [sym__expression] = STATE(648),
    [sym__primary_expression] = STATE(73),
    [sym_not_operator] = STATE(648),
    [sym_boolean_operator] = STATE(648),
    [sym_binary_operator] = STATE(73),
    [sym_unary_operator] = STATE(73),
    [sym_comparison_operator] = STATE(648),
    [sym_lambda] = STATE(648),
    [sym_attribute] = STATE(73),
    [sym_subscript] = STATE(73),
    [sym_call] = STATE(73),
    [sym_list] = STATE(73),
    [sym_list_comprehension] = STATE(73),
    [sym_dictionary] = STATE(73),
    [sym_dictionary_comprehension] = STATE(73),
    [sym_set] = STATE(73),
    [sym_set_comprehension] = STATE(73),
    [sym_parenthesized_expression] = STATE(73),
    [sym_tuple] = STATE(73),
    [sym_generator_expression] = STATE(73),
    [sym_conditional_expression] = STATE(648),
    [sym_concatenated_string] = STATE(73),
    [sym_await] = STATE(648),
    [sym__newline] = ACTIONS(1275),
    [anon_sym_LPAREN] = ACTIONS(130),
    [anon_sym_print] = ACTIONS(112),
    [anon_sym_exec] = ACTIONS(112),
    [anon_sym_not] = ACTIONS(132),
    [anon_sym_PLUS] = ACTIONS(116),
    [anon_sym_DASH] = ACTIONS(116),
    [anon_sym_TILDE] = ACTIONS(116),
    [anon_sym_lambda] = ACTIONS(118),
    [anon_sym_LBRACK] = ACTIONS(134),
    [sym_ellipsis] = ACTIONS(120),
    [anon_sym_LBRACE] = ACTIONS(122),
    [sym_string] = ACTIONS(124),
    [sym_integer] = ACTIONS(126),
    [sym_float] = ACTIONS(126),
    [sym_identifier] = ACTIONS(126),
    [sym_true] = ACTIONS(126),
    [sym_false] = ACTIONS(126),
    [sym_none] = ACTIONS(126),
    [anon_sym_await] = ACTIONS(128),
    [sym_comment] = ACTIONS(72),
    [sym__semicolon] = ACTIONS(1275),
  },
  [274] = {
    [aux_sym_print_statement_repeat1] = STATE(650),
    [sym__newline] = ACTIONS(1275),
    [anon_sym_COMMA] = ACTIONS(1277),
    [sym_comment] = ACTIONS(72),
    [sym__semicolon] = ACTIONS(1275),
  },
  [275] = {
    [sym__expression] = STATE(651),
    [sym__primary_expression] = STATE(513),
    [sym_not_operator] = STATE(651),
    [sym_boolean_operator] = STATE(651),
    [sym_binary_operator] = STATE(513),
    [sym_unary_operator] = STATE(513),
    [sym_comparison_operator] = STATE(651),
    [sym_lambda] = STATE(651),
    [sym_attribute] = STATE(513),
    [sym_subscript] = STATE(513),
    [sym_call] = STATE(513),
    [sym_list] = STATE(513),
    [sym_list_comprehension] = STATE(513),
    [sym_dictionary] = STATE(513),
    [sym_dictionary_comprehension] = STATE(513),
    [sym_set] = STATE(513),
    [sym_set_comprehension] = STATE(513),
    [sym_parenthesized_expression] = STATE(513),
    [sym_tuple] = STATE(513),
    [sym_generator_expression] = STATE(513),
    [sym_conditional_expression] = STATE(651),
    [sym_concatenated_string] = STATE(513),
    [sym_await] = STATE(651),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_not] = ACTIONS(914),
    [anon_sym_PLUS] = ACTIONS(916),
    [anon_sym_DASH] = ACTIONS(916),
    [anon_sym_TILDE] = ACTIONS(916),
    [anon_sym_lambda] = ACTIONS(918),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(920),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(922),
    [sym_integer] = ACTIONS(924),
    [sym_float] = ACTIONS(924),
    [sym_identifier] = ACTIONS(924),
    [sym_true] = ACTIONS(924),
    [sym_false] = ACTIONS(924),
    [sym_none] = ACTIONS(924),
    [anon_sym_await] = ACTIONS(926),
    [sym_comment] = ACTIONS(72),
  },
  [276] = {
    [sym__expression] = STATE(514),
    [sym__primary_expression] = STATE(73),
    [sym_not_operator] = STATE(514),
    [sym_boolean_operator] = STATE(514),
    [sym_binary_operator] = STATE(73),
    [sym_unary_operator] = STATE(73),
    [sym_comparison_operator] = STATE(514),
    [sym_lambda] = STATE(514),
    [sym_attribute] = STATE(73),
    [sym_subscript] = STATE(73),
    [sym_call] = STATE(73),
    [sym_list] = STATE(73),
    [sym_list_comprehension] = STATE(73),
    [sym_dictionary] = STATE(73),
    [sym_dictionary_comprehension] = STATE(73),
    [sym_set] = STATE(73),
    [sym_set_comprehension] = STATE(73),
    [sym_parenthesized_expression] = STATE(73),
    [sym_tuple] = STATE(73),
    [sym_generator_expression] = STATE(73),
    [sym_conditional_expression] = STATE(514),
    [sym_concatenated_string] = STATE(73),
    [sym_await] = STATE(514),
    [anon_sym_LPAREN] = ACTIONS(130),
    [anon_sym_print] = ACTIONS(112),
    [anon_sym_exec] = ACTIONS(112),
    [anon_sym_not] = ACTIONS(132),
    [anon_sym_PLUS] = ACTIONS(116),
    [anon_sym_DASH] = ACTIONS(116),
    [anon_sym_TILDE] = ACTIONS(116),
    [anon_sym_lambda] = ACTIONS(118),
    [anon_sym_LBRACK] = ACTIONS(134),
    [sym_ellipsis] = ACTIONS(120),
    [anon_sym_LBRACE] = ACTIONS(122),
    [sym_string] = ACTIONS(124),
    [sym_integer] = ACTIONS(126),
    [sym_float] = ACTIONS(126),
    [sym_identifier] = ACTIONS(126),
    [sym_true] = ACTIONS(126),
    [sym_false] = ACTIONS(126),
    [sym_none] = ACTIONS(126),
    [anon_sym_await] = ACTIONS(128),
    [sym_comment] = ACTIONS(72),
  },
  [277] = {
    [sym__expression] = STATE(652),
    [sym__primary_expression] = STATE(73),
    [sym_not_operator] = STATE(652),
    [sym_boolean_operator] = STATE(652),
    [sym_binary_operator] = STATE(73),
    [sym_unary_operator] = STATE(73),
    [sym_comparison_operator] = STATE(652),
    [sym_lambda] = STATE(652),
    [sym_attribute] = STATE(73),
    [sym_subscript] = STATE(73),
    [sym_call] = STATE(73),
    [sym_list] = STATE(73),
    [sym_list_comprehension] = STATE(73),
    [sym_dictionary] = STATE(73),
    [sym_dictionary_comprehension] = STATE(73),
    [sym_set] = STATE(73),
    [sym_set_comprehension] = STATE(73),
    [sym_parenthesized_expression] = STATE(73),
    [sym_tuple] = STATE(73),
    [sym_generator_expression] = STATE(73),
    [sym_conditional_expression] = STATE(652),
    [sym_concatenated_string] = STATE(73),
    [sym_await] = STATE(652),
    [anon_sym_LPAREN] = ACTIONS(130),
    [anon_sym_print] = ACTIONS(112),
    [anon_sym_exec] = ACTIONS(112),
    [anon_sym_not] = ACTIONS(132),
    [anon_sym_PLUS] = ACTIONS(116),
    [anon_sym_DASH] = ACTIONS(116),
    [anon_sym_TILDE] = ACTIONS(116),
    [anon_sym_lambda] = ACTIONS(118),
    [anon_sym_LBRACK] = ACTIONS(134),
    [sym_ellipsis] = ACTIONS(120),
    [anon_sym_LBRACE] = ACTIONS(122),
    [sym_string] = ACTIONS(124),
    [sym_integer] = ACTIONS(126),
    [sym_float] = ACTIONS(126),
    [sym_identifier] = ACTIONS(126),
    [sym_true] = ACTIONS(126),
    [sym_false] = ACTIONS(126),
    [sym_none] = ACTIONS(126),
    [anon_sym_await] = ACTIONS(128),
    [sym_comment] = ACTIONS(72),
  },
  [278] = {
    [sym_identifier] = ACTIONS(1279),
    [sym_comment] = ACTIONS(72),
  },
  [279] = {
    [sym_list_splat] = STATE(656),
    [sym_dictionary_splat] = STATE(656),
    [sym__expression] = STATE(657),
    [sym__primary_expression] = STATE(59),
    [sym_not_operator] = STATE(657),
    [sym_boolean_operator] = STATE(657),
    [sym_binary_operator] = STATE(59),
    [sym_unary_operator] = STATE(59),
    [sym_comparison_operator] = STATE(657),
    [sym_lambda] = STATE(657),
    [sym_attribute] = STATE(59),
    [sym_subscript] = STATE(59),
    [sym_call] = STATE(59),
    [sym_keyword_argument] = STATE(656),
    [sym_list] = STATE(59),
    [sym_list_comprehension] = STATE(59),
    [sym_dictionary] = STATE(59),
    [sym_dictionary_comprehension] = STATE(59),
    [sym_set] = STATE(59),
    [sym_set_comprehension] = STATE(59),
    [sym_parenthesized_expression] = STATE(59),
    [sym_tuple] = STATE(59),
    [sym_generator_expression] = STATE(59),
    [sym_conditional_expression] = STATE(657),
    [sym_concatenated_string] = STATE(59),
    [sym_await] = STATE(657),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_RPAREN] = ACTIONS(1281),
    [anon_sym_COMMA] = ACTIONS(1283),
    [anon_sym_STAR] = ACTIONS(936),
    [anon_sym_print] = ACTIONS(938),
    [anon_sym_exec] = ACTIONS(938),
    [anon_sym_not] = ACTIONS(88),
    [anon_sym_PLUS] = ACTIONS(90),
    [anon_sym_DASH] = ACTIONS(90),
    [anon_sym_TILDE] = ACTIONS(90),
    [anon_sym_lambda] = ACTIONS(92),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(98),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(102),
    [sym_integer] = ACTIONS(104),
    [sym_float] = ACTIONS(104),
    [sym_identifier] = ACTIONS(940),
    [sym_true] = ACTIONS(104),
    [sym_false] = ACTIONS(104),
    [sym_none] = ACTIONS(104),
    [anon_sym_await] = ACTIONS(106),
    [sym_comment] = ACTIONS(72),
  },
  [280] = {
    [sym__primary_expression] = STATE(658),
    [sym_binary_operator] = STATE(658),
    [sym_unary_operator] = STATE(658),
    [sym_attribute] = STATE(658),
    [sym_subscript] = STATE(658),
    [sym_call] = STATE(658),
    [sym_list] = STATE(658),
    [sym_list_comprehension] = STATE(658),
    [sym_dictionary] = STATE(658),
    [sym_dictionary_comprehension] = STATE(658),
    [sym_set] = STATE(658),
    [sym_set_comprehension] = STATE(658),
    [sym_parenthesized_expression] = STATE(658),
    [sym_tuple] = STATE(658),
    [sym_generator_expression] = STATE(658),
    [sym_concatenated_string] = STATE(658),
    [anon_sym_LPAREN] = ACTIONS(130),
    [anon_sym_print] = ACTIONS(112),
    [anon_sym_exec] = ACTIONS(112),
    [anon_sym_PLUS] = ACTIONS(116),
    [anon_sym_DASH] = ACTIONS(116),
    [anon_sym_TILDE] = ACTIONS(116),
    [anon_sym_LBRACK] = ACTIONS(134),
    [sym_ellipsis] = ACTIONS(1285),
    [anon_sym_LBRACE] = ACTIONS(122),
    [sym_string] = ACTIONS(124),
    [sym_integer] = ACTIONS(1287),
    [sym_float] = ACTIONS(1287),
    [sym_identifier] = ACTIONS(1287),
    [sym_true] = ACTIONS(1287),
    [sym_false] = ACTIONS(1287),
    [sym_none] = ACTIONS(1287),
    [sym_comment] = ACTIONS(72),
  },
  [281] = {
    [sym__primary_expression] = STATE(659),
    [sym_binary_operator] = STATE(659),
    [sym_unary_operator] = STATE(659),
    [sym_attribute] = STATE(659),
    [sym_subscript] = STATE(659),
    [sym_call] = STATE(659),
    [sym_list] = STATE(659),
    [sym_list_comprehension] = STATE(659),
    [sym_dictionary] = STATE(659),
    [sym_dictionary_comprehension] = STATE(659),
    [sym_set] = STATE(659),
    [sym_set_comprehension] = STATE(659),
    [sym_parenthesized_expression] = STATE(659),
    [sym_tuple] = STATE(659),
    [sym_generator_expression] = STATE(659),
    [sym_concatenated_string] = STATE(659),
    [anon_sym_LPAREN] = ACTIONS(130),
    [anon_sym_print] = ACTIONS(112),
    [anon_sym_exec] = ACTIONS(112),
    [anon_sym_PLUS] = ACTIONS(116),
    [anon_sym_DASH] = ACTIONS(116),
    [anon_sym_TILDE] = ACTIONS(116),
    [anon_sym_LBRACK] = ACTIONS(134),
    [sym_ellipsis] = ACTIONS(1289),
    [anon_sym_LBRACE] = ACTIONS(122),
    [sym_string] = ACTIONS(124),
    [sym_integer] = ACTIONS(1291),
    [sym_float] = ACTIONS(1291),
    [sym_identifier] = ACTIONS(1291),
    [sym_true] = ACTIONS(1291),
    [sym_false] = ACTIONS(1291),
    [sym_none] = ACTIONS(1291),
    [sym_comment] = ACTIONS(72),
  },
  [282] = {
    [sym__primary_expression] = STATE(660),
    [sym_binary_operator] = STATE(660),
    [sym_unary_operator] = STATE(660),
    [sym_attribute] = STATE(660),
    [sym_subscript] = STATE(660),
    [sym_call] = STATE(660),
    [sym_list] = STATE(660),
    [sym_list_comprehension] = STATE(660),
    [sym_dictionary] = STATE(660),
    [sym_dictionary_comprehension] = STATE(660),
    [sym_set] = STATE(660),
    [sym_set_comprehension] = STATE(660),
    [sym_parenthesized_expression] = STATE(660),
    [sym_tuple] = STATE(660),
    [sym_generator_expression] = STATE(660),
    [sym_concatenated_string] = STATE(660),
    [anon_sym_LPAREN] = ACTIONS(130),
    [anon_sym_print] = ACTIONS(112),
    [anon_sym_exec] = ACTIONS(112),
    [anon_sym_PLUS] = ACTIONS(116),
    [anon_sym_DASH] = ACTIONS(116),
    [anon_sym_TILDE] = ACTIONS(116),
    [anon_sym_LBRACK] = ACTIONS(134),
    [sym_ellipsis] = ACTIONS(1293),
    [anon_sym_LBRACE] = ACTIONS(122),
    [sym_string] = ACTIONS(124),
    [sym_integer] = ACTIONS(1295),
    [sym_float] = ACTIONS(1295),
    [sym_identifier] = ACTIONS(1295),
    [sym_true] = ACTIONS(1295),
    [sym_false] = ACTIONS(1295),
    [sym_none] = ACTIONS(1295),
    [sym_comment] = ACTIONS(72),
  },
  [283] = {
    [anon_sym_in] = ACTIONS(1297),
    [sym_comment] = ACTIONS(72),
  },
  [284] = {
    [sym__primary_expression] = STATE(662),
    [sym_binary_operator] = STATE(662),
    [sym_unary_operator] = STATE(662),
    [sym_attribute] = STATE(662),
    [sym_subscript] = STATE(662),
    [sym_call] = STATE(662),
    [sym_list] = STATE(662),
    [sym_list_comprehension] = STATE(662),
    [sym_dictionary] = STATE(662),
    [sym_dictionary_comprehension] = STATE(662),
    [sym_set] = STATE(662),
    [sym_set_comprehension] = STATE(662),
    [sym_parenthesized_expression] = STATE(662),
    [sym_tuple] = STATE(662),
    [sym_generator_expression] = STATE(662),
    [sym_concatenated_string] = STATE(662),
    [anon_sym_LPAREN] = ACTIONS(130),
    [anon_sym_print] = ACTIONS(112),
    [anon_sym_exec] = ACTIONS(112),
    [anon_sym_PLUS] = ACTIONS(116),
    [anon_sym_DASH] = ACTIONS(116),
    [anon_sym_TILDE] = ACTIONS(116),
    [anon_sym_LBRACK] = ACTIONS(134),
    [sym_ellipsis] = ACTIONS(1299),
    [anon_sym_LBRACE] = ACTIONS(122),
    [sym_string] = ACTIONS(124),
    [sym_integer] = ACTIONS(1301),
    [sym_float] = ACTIONS(1301),
    [sym_identifier] = ACTIONS(1301),
    [sym_true] = ACTIONS(1301),
    [sym_false] = ACTIONS(1301),
    [sym_none] = ACTIONS(1301),
    [sym_comment] = ACTIONS(72),
  },
  [285] = {
    [sym__primary_expression] = STATE(663),
    [sym_binary_operator] = STATE(663),
    [sym_unary_operator] = STATE(663),
    [sym_attribute] = STATE(663),
    [sym_subscript] = STATE(663),
    [sym_call] = STATE(663),
    [sym_list] = STATE(663),
    [sym_list_comprehension] = STATE(663),
    [sym_dictionary] = STATE(663),
    [sym_dictionary_comprehension] = STATE(663),
    [sym_set] = STATE(663),
    [sym_set_comprehension] = STATE(663),
    [sym_parenthesized_expression] = STATE(663),
    [sym_tuple] = STATE(663),
    [sym_generator_expression] = STATE(663),
    [sym_concatenated_string] = STATE(663),
    [anon_sym_LPAREN] = ACTIONS(130),
    [anon_sym_print] = ACTIONS(112),
    [anon_sym_exec] = ACTIONS(112),
    [anon_sym_PLUS] = ACTIONS(116),
    [anon_sym_DASH] = ACTIONS(116),
    [anon_sym_TILDE] = ACTIONS(116),
    [anon_sym_LBRACK] = ACTIONS(134),
    [sym_ellipsis] = ACTIONS(1303),
    [anon_sym_LBRACE] = ACTIONS(122),
    [sym_string] = ACTIONS(124),
    [sym_integer] = ACTIONS(1305),
    [sym_float] = ACTIONS(1305),
    [sym_identifier] = ACTIONS(1305),
    [sym_true] = ACTIONS(1305),
    [sym_false] = ACTIONS(1305),
    [sym_none] = ACTIONS(1305),
    [sym_comment] = ACTIONS(72),
  },
  [286] = {
    [sym__primary_expression] = STATE(664),
    [sym_binary_operator] = STATE(664),
    [sym_unary_operator] = STATE(664),
    [sym_attribute] = STATE(664),
    [sym_subscript] = STATE(664),
    [sym_call] = STATE(664),
    [sym_list] = STATE(664),
    [sym_list_comprehension] = STATE(664),
    [sym_dictionary] = STATE(664),
    [sym_dictionary_comprehension] = STATE(664),
    [sym_set] = STATE(664),
    [sym_set_comprehension] = STATE(664),
    [sym_parenthesized_expression] = STATE(664),
    [sym_tuple] = STATE(664),
    [sym_generator_expression] = STATE(664),
    [sym_concatenated_string] = STATE(664),
    [anon_sym_LPAREN] = ACTIONS(130),
    [anon_sym_print] = ACTIONS(112),
    [anon_sym_exec] = ACTIONS(112),
    [anon_sym_PLUS] = ACTIONS(116),
    [anon_sym_DASH] = ACTIONS(116),
    [anon_sym_TILDE] = ACTIONS(116),
    [anon_sym_LBRACK] = ACTIONS(134),
    [sym_ellipsis] = ACTIONS(1307),
    [anon_sym_LBRACE] = ACTIONS(122),
    [sym_string] = ACTIONS(124),
    [sym_integer] = ACTIONS(1309),
    [sym_float] = ACTIONS(1309),
    [sym_identifier] = ACTIONS(1309),
    [sym_true] = ACTIONS(1309),
    [sym_false] = ACTIONS(1309),
    [sym_none] = ACTIONS(1309),
    [sym_comment] = ACTIONS(72),
  },
  [287] = {
    [sym__primary_expression] = STATE(665),
    [sym_binary_operator] = STATE(665),
    [sym_unary_operator] = STATE(665),
    [sym_attribute] = STATE(665),
    [sym_subscript] = STATE(665),
    [sym_call] = STATE(665),
    [sym_list] = STATE(665),
    [sym_list_comprehension] = STATE(665),
    [sym_dictionary] = STATE(665),
    [sym_dictionary_comprehension] = STATE(665),
    [sym_set] = STATE(665),
    [sym_set_comprehension] = STATE(665),
    [sym_parenthesized_expression] = STATE(665),
    [sym_tuple] = STATE(665),
    [sym_generator_expression] = STATE(665),
    [sym_concatenated_string] = STATE(665),
    [anon_sym_LPAREN] = ACTIONS(130),
    [anon_sym_print] = ACTIONS(112),
    [anon_sym_exec] = ACTIONS(112),
    [anon_sym_PLUS] = ACTIONS(116),
    [anon_sym_DASH] = ACTIONS(116),
    [anon_sym_TILDE] = ACTIONS(116),
    [anon_sym_LBRACK] = ACTIONS(134),
    [sym_ellipsis] = ACTIONS(1311),
    [anon_sym_LBRACE] = ACTIONS(122),
    [sym_string] = ACTIONS(124),
    [sym_integer] = ACTIONS(1313),
    [sym_float] = ACTIONS(1313),
    [sym_identifier] = ACTIONS(1313),
    [sym_true] = ACTIONS(1313),
    [sym_false] = ACTIONS(1313),
    [sym_none] = ACTIONS(1313),
    [sym_comment] = ACTIONS(72),
  },
  [288] = {
    [sym__primary_expression] = STATE(666),
    [sym_binary_operator] = STATE(666),
    [sym_unary_operator] = STATE(666),
    [sym_attribute] = STATE(666),
    [sym_subscript] = STATE(666),
    [sym_call] = STATE(666),
    [sym_list] = STATE(666),
    [sym_list_comprehension] = STATE(666),
    [sym_dictionary] = STATE(666),
    [sym_dictionary_comprehension] = STATE(666),
    [sym_set] = STATE(666),
    [sym_set_comprehension] = STATE(666),
    [sym_parenthesized_expression] = STATE(666),
    [sym_tuple] = STATE(666),
    [sym_generator_expression] = STATE(666),
    [sym_concatenated_string] = STATE(666),
    [anon_sym_LPAREN] = ACTIONS(130),
    [anon_sym_print] = ACTIONS(112),
    [anon_sym_exec] = ACTIONS(112),
    [anon_sym_PLUS] = ACTIONS(116),
    [anon_sym_DASH] = ACTIONS(116),
    [anon_sym_TILDE] = ACTIONS(116),
    [anon_sym_LBRACK] = ACTIONS(134),
    [sym_ellipsis] = ACTIONS(1315),
    [anon_sym_LBRACE] = ACTIONS(122),
    [sym_string] = ACTIONS(124),
    [sym_integer] = ACTIONS(1317),
    [sym_float] = ACTIONS(1317),
    [sym_identifier] = ACTIONS(1317),
    [sym_true] = ACTIONS(1317),
    [sym_false] = ACTIONS(1317),
    [sym_none] = ACTIONS(1317),
    [sym_comment] = ACTIONS(72),
  },
  [289] = {
    [sym__primary_expression] = STATE(660),
    [sym_binary_operator] = STATE(660),
    [sym_unary_operator] = STATE(660),
    [sym_attribute] = STATE(660),
    [sym_subscript] = STATE(660),
    [sym_call] = STATE(660),
    [sym_list] = STATE(660),
    [sym_list_comprehension] = STATE(660),
    [sym_dictionary] = STATE(660),
    [sym_dictionary_comprehension] = STATE(660),
    [sym_set] = STATE(660),
    [sym_set_comprehension] = STATE(660),
    [sym_parenthesized_expression] = STATE(660),
    [sym_tuple] = STATE(660),
    [sym_generator_expression] = STATE(660),
    [sym_concatenated_string] = STATE(660),
    [anon_sym_LPAREN] = ACTIONS(130),
    [anon_sym_print] = ACTIONS(112),
    [anon_sym_exec] = ACTIONS(112),
    [anon_sym_not] = ACTIONS(1319),
    [anon_sym_PLUS] = ACTIONS(116),
    [anon_sym_DASH] = ACTIONS(116),
    [anon_sym_TILDE] = ACTIONS(116),
    [anon_sym_LBRACK] = ACTIONS(134),
    [sym_ellipsis] = ACTIONS(1293),
    [anon_sym_LBRACE] = ACTIONS(122),
    [sym_string] = ACTIONS(124),
    [sym_integer] = ACTIONS(1295),
    [sym_float] = ACTIONS(1295),
    [sym_identifier] = ACTIONS(1295),
    [sym_true] = ACTIONS(1295),
    [sym_false] = ACTIONS(1295),
    [sym_none] = ACTIONS(1295),
    [sym_comment] = ACTIONS(72),
  },
  [290] = {
    [sym__expression] = STATE(667),
    [sym__primary_expression] = STATE(542),
    [sym_not_operator] = STATE(667),
    [sym_boolean_operator] = STATE(667),
    [sym_binary_operator] = STATE(542),
    [sym_unary_operator] = STATE(542),
    [sym_comparison_operator] = STATE(667),
    [sym_lambda] = STATE(667),
    [sym_attribute] = STATE(542),
    [sym_subscript] = STATE(542),
    [sym_slice] = STATE(668),
    [sym_call] = STATE(542),
    [sym_list] = STATE(542),
    [sym_list_comprehension] = STATE(542),
    [sym_dictionary] = STATE(542),
    [sym_dictionary_comprehension] = STATE(542),
    [sym_set] = STATE(542),
    [sym_set_comprehension] = STATE(542),
    [sym_parenthesized_expression] = STATE(542),
    [sym_tuple] = STATE(542),
    [sym_generator_expression] = STATE(542),
    [sym_conditional_expression] = STATE(667),
    [sym_concatenated_string] = STATE(542),
    [sym_await] = STATE(667),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_COLON] = ACTIONS(978),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_not] = ACTIONS(980),
    [anon_sym_PLUS] = ACTIONS(982),
    [anon_sym_DASH] = ACTIONS(982),
    [anon_sym_TILDE] = ACTIONS(982),
    [anon_sym_lambda] = ACTIONS(984),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(986),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(988),
    [sym_integer] = ACTIONS(990),
    [sym_float] = ACTIONS(990),
    [sym_identifier] = ACTIONS(990),
    [sym_true] = ACTIONS(990),
    [sym_false] = ACTIONS(990),
    [sym_none] = ACTIONS(990),
    [anon_sym_await] = ACTIONS(992),
    [sym_comment] = ACTIONS(72),
  },
  [291] = {
    [sym__newline] = ACTIONS(994),
    [anon_sym_DOT] = ACTIONS(994),
    [anon_sym_from] = ACTIONS(994),
    [anon_sym_LPAREN] = ACTIONS(994),
    [anon_sym_COMMA] = ACTIONS(994),
    [anon_sym_STAR] = ACTIONS(996),
    [anon_sym_GT_GT] = ACTIONS(994),
    [anon_sym_if] = ACTIONS(994),
    [anon_sym_in] = ACTIONS(994),
    [anon_sym_EQ] = ACTIONS(996),
    [anon_sym_AT] = ACTIONS(994),
    [anon_sym_not] = ACTIONS(994),
    [anon_sym_and] = ACTIONS(994),
    [anon_sym_or] = ACTIONS(994),
    [anon_sym_PLUS] = ACTIONS(994),
    [anon_sym_DASH] = ACTIONS(994),
    [anon_sym_SLASH] = ACTIONS(996),
    [anon_sym_PERCENT] = ACTIONS(994),
    [anon_sym_SLASH_SLASH] = ACTIONS(994),
    [anon_sym_STAR_STAR] = ACTIONS(994),
    [anon_sym_PIPE] = ACTIONS(994),
    [anon_sym_AMP] = ACTIONS(994),
    [anon_sym_CARET] = ACTIONS(994),
    [anon_sym_LT_LT] = ACTIONS(994),
    [anon_sym_LT] = ACTIONS(996),
    [anon_sym_LT_EQ] = ACTIONS(994),
    [anon_sym_EQ_EQ] = ACTIONS(994),
    [anon_sym_BANG_EQ] = ACTIONS(994),
    [anon_sym_GT_EQ] = ACTIONS(994),
    [anon_sym_GT] = ACTIONS(996),
    [anon_sym_LT_GT] = ACTIONS(994),
    [anon_sym_is] = ACTIONS(994),
    [anon_sym_LBRACK] = ACTIONS(994),
    [sym_comment] = ACTIONS(72),
    [sym__semicolon] = ACTIONS(994),
  },
  [292] = {
    [aux_sym_comparison_operator_repeat1] = STATE(669),
    [sym__newline] = ACTIONS(998),
    [anon_sym_COMMA] = ACTIONS(998),
    [anon_sym_if] = ACTIONS(998),
    [anon_sym_in] = ACTIONS(490),
    [anon_sym_not] = ACTIONS(494),
    [anon_sym_and] = ACTIONS(998),
    [anon_sym_or] = ACTIONS(998),
    [anon_sym_LT] = ACTIONS(506),
    [anon_sym_LT_EQ] = ACTIONS(490),
    [anon_sym_EQ_EQ] = ACTIONS(490),
    [anon_sym_BANG_EQ] = ACTIONS(490),
    [anon_sym_GT_EQ] = ACTIONS(490),
    [anon_sym_GT] = ACTIONS(506),
    [anon_sym_LT_GT] = ACTIONS(490),
    [anon_sym_is] = ACTIONS(508),
    [sym_comment] = ACTIONS(72),
    [sym__semicolon] = ACTIONS(998),
  },
  [293] = {
    [sym__expression] = STATE(648),
    [sym__primary_expression] = STATE(73),
    [sym_not_operator] = STATE(648),
    [sym_boolean_operator] = STATE(648),
    [sym_binary_operator] = STATE(73),
    [sym_unary_operator] = STATE(73),
    [sym_comparison_operator] = STATE(648),
    [sym_lambda] = STATE(648),
    [sym_attribute] = STATE(73),
    [sym_subscript] = STATE(73),
    [sym_call] = STATE(73),
    [sym_list] = STATE(73),
    [sym_list_comprehension] = STATE(73),
    [sym_dictionary] = STATE(73),
    [sym_dictionary_comprehension] = STATE(73),
    [sym_set] = STATE(73),
    [sym_set_comprehension] = STATE(73),
    [sym_parenthesized_expression] = STATE(73),
    [sym_tuple] = STATE(73),
    [sym_generator_expression] = STATE(73),
    [sym_conditional_expression] = STATE(648),
    [sym_concatenated_string] = STATE(73),
    [sym_await] = STATE(648),
    [anon_sym_LPAREN] = ACTIONS(130),
    [anon_sym_print] = ACTIONS(112),
    [anon_sym_exec] = ACTIONS(112),
    [anon_sym_not] = ACTIONS(132),
    [anon_sym_PLUS] = ACTIONS(116),
    [anon_sym_DASH] = ACTIONS(116),
    [anon_sym_TILDE] = ACTIONS(116),
    [anon_sym_lambda] = ACTIONS(118),
    [anon_sym_LBRACK] = ACTIONS(134),
    [sym_ellipsis] = ACTIONS(120),
    [anon_sym_LBRACE] = ACTIONS(122),
    [sym_string] = ACTIONS(124),
    [sym_integer] = ACTIONS(126),
    [sym_float] = ACTIONS(126),
    [sym_identifier] = ACTIONS(126),
    [sym_true] = ACTIONS(126),
    [sym_false] = ACTIONS(126),
    [sym_none] = ACTIONS(126),
    [anon_sym_await] = ACTIONS(128),
    [sym_comment] = ACTIONS(72),
  },
  [294] = {
    [aux_sym_print_statement_repeat1] = STATE(650),
    [sym__newline] = ACTIONS(1321),
    [anon_sym_COMMA] = ACTIONS(514),
    [sym_comment] = ACTIONS(72),
    [sym__semicolon] = ACTIONS(1321),
  },
  [295] = {
    [sym__expression] = STATE(648),
    [sym__primary_expression] = STATE(73),
    [sym_not_operator] = STATE(648),
    [sym_boolean_operator] = STATE(648),
    [sym_binary_operator] = STATE(73),
    [sym_unary_operator] = STATE(73),
    [sym_comparison_operator] = STATE(648),
    [sym_lambda] = STATE(648),
    [sym_attribute] = STATE(73),
    [sym_subscript] = STATE(73),
    [sym_call] = STATE(73),
    [sym_list] = STATE(73),
    [sym_list_comprehension] = STATE(73),
    [sym_dictionary] = STATE(73),
    [sym_dictionary_comprehension] = STATE(73),
    [sym_set] = STATE(73),
    [sym_set_comprehension] = STATE(73),
    [sym_parenthesized_expression] = STATE(73),
    [sym_tuple] = STATE(73),
    [sym_generator_expression] = STATE(73),
    [sym_conditional_expression] = STATE(648),
    [sym_concatenated_string] = STATE(73),
    [sym_await] = STATE(648),
    [sym__newline] = ACTIONS(910),
    [anon_sym_LPAREN] = ACTIONS(130),
    [anon_sym_print] = ACTIONS(112),
    [anon_sym_exec] = ACTIONS(112),
    [anon_sym_not] = ACTIONS(132),
    [anon_sym_PLUS] = ACTIONS(116),
    [anon_sym_DASH] = ACTIONS(116),
    [anon_sym_TILDE] = ACTIONS(116),
    [anon_sym_lambda] = ACTIONS(118),
    [anon_sym_LBRACK] = ACTIONS(134),
    [sym_ellipsis] = ACTIONS(120),
    [anon_sym_LBRACE] = ACTIONS(122),
    [sym_string] = ACTIONS(124),
    [sym_integer] = ACTIONS(126),
    [sym_float] = ACTIONS(126),
    [sym_identifier] = ACTIONS(126),
    [sym_true] = ACTIONS(126),
    [sym_false] = ACTIONS(126),
    [sym_none] = ACTIONS(126),
    [anon_sym_await] = ACTIONS(128),
    [sym_comment] = ACTIONS(72),
    [sym__semicolon] = ACTIONS(910),
  },
  [296] = {
    [aux_sym_print_statement_repeat1] = STATE(650),
    [sym__newline] = ACTIONS(910),
    [anon_sym_COMMA] = ACTIONS(1323),
    [sym_comment] = ACTIONS(72),
    [sym__semicolon] = ACTIONS(910),
  },
  [297] = {
    [sym__expression] = STATE(671),
    [sym__primary_expression] = STATE(303),
    [sym_not_operator] = STATE(671),
    [sym_boolean_operator] = STATE(671),
    [sym_binary_operator] = STATE(303),
    [sym_unary_operator] = STATE(303),
    [sym_comparison_operator] = STATE(671),
    [sym_lambda] = STATE(671),
    [sym_attribute] = STATE(303),
    [sym_subscript] = STATE(303),
    [sym_call] = STATE(303),
    [sym_list] = STATE(303),
    [sym_list_comprehension] = STATE(303),
    [sym_dictionary] = STATE(303),
    [sym_dictionary_comprehension] = STATE(303),
    [sym_set] = STATE(303),
    [sym_set_comprehension] = STATE(303),
    [sym_parenthesized_expression] = STATE(303),
    [sym_tuple] = STATE(303),
    [sym_generator_expression] = STATE(303),
    [sym_conditional_expression] = STATE(671),
    [sym_concatenated_string] = STATE(303),
    [sym_await] = STATE(671),
    [anon_sym_LPAREN] = ACTIONS(130),
    [anon_sym_print] = ACTIONS(112),
    [anon_sym_exec] = ACTIONS(112),
    [anon_sym_not] = ACTIONS(522),
    [anon_sym_PLUS] = ACTIONS(524),
    [anon_sym_DASH] = ACTIONS(524),
    [anon_sym_TILDE] = ACTIONS(524),
    [anon_sym_lambda] = ACTIONS(526),
    [anon_sym_LBRACK] = ACTIONS(134),
    [sym_ellipsis] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(122),
    [sym_string] = ACTIONS(530),
    [sym_integer] = ACTIONS(532),
    [sym_float] = ACTIONS(532),
    [sym_identifier] = ACTIONS(532),
    [sym_true] = ACTIONS(532),
    [sym_false] = ACTIONS(532),
    [sym_none] = ACTIONS(532),
    [anon_sym_await] = ACTIONS(534),
    [sym_comment] = ACTIONS(72),
  },
  [298] = {
    [sym__primary_expression] = STATE(259),
    [sym_binary_operator] = STATE(259),
    [sym_unary_operator] = STATE(259),
    [sym_attribute] = STATE(259),
    [sym_subscript] = STATE(259),
    [sym_call] = STATE(259),
    [sym_list] = STATE(259),
    [sym_list_comprehension] = STATE(259),
    [sym_dictionary] = STATE(259),
    [sym_dictionary_comprehension] = STATE(259),
    [sym_set] = STATE(259),
    [sym_set_comprehension] = STATE(259),
    [sym_parenthesized_expression] = STATE(259),
    [sym_tuple] = STATE(259),
    [sym_generator_expression] = STATE(259),
    [sym_concatenated_string] = STATE(259),
    [anon_sym_LPAREN] = ACTIONS(130),
    [anon_sym_print] = ACTIONS(112),
    [anon_sym_exec] = ACTIONS(112),
    [anon_sym_PLUS] = ACTIONS(524),
    [anon_sym_DASH] = ACTIONS(524),
    [anon_sym_TILDE] = ACTIONS(524),
    [anon_sym_LBRACK] = ACTIONS(134),
    [sym_ellipsis] = ACTIONS(456),
    [anon_sym_LBRACE] = ACTIONS(122),
    [sym_string] = ACTIONS(530),
    [sym_integer] = ACTIONS(458),
    [sym_float] = ACTIONS(458),
    [sym_identifier] = ACTIONS(458),
    [sym_true] = ACTIONS(458),
    [sym_false] = ACTIONS(458),
    [sym_none] = ACTIONS(458),
    [sym_comment] = ACTIONS(72),
  },
  [299] = {
    [sym_lambda_parameters] = STATE(673),
    [sym__parameters] = STATE(130),
    [sym_default_parameter] = STATE(131),
    [sym_typed_default_parameter] = STATE(131),
    [sym_list_splat] = STATE(132),
    [sym_dictionary_splat] = STATE(132),
    [sym_typed_parameter] = STATE(131),
    [sym_tuple] = STATE(131),
    [anon_sym_LPAREN] = ACTIONS(222),
    [anon_sym_STAR] = ACTIONS(224),
    [anon_sym_print] = ACTIONS(226),
    [anon_sym_COLON] = ACTIONS(1325),
    [anon_sym_exec] = ACTIONS(226),
    [sym_identifier] = ACTIONS(230),
    [sym_comment] = ACTIONS(72),
  },
  [300] = {
    [aux_sym_concatenated_string_repeat1] = STATE(674),
    [sym__newline] = ACTIONS(276),
    [anon_sym_DOT] = ACTIONS(276),
    [anon_sym_LPAREN] = ACTIONS(276),
    [anon_sym_STAR] = ACTIONS(278),
    [anon_sym_GT_GT] = ACTIONS(276),
    [anon_sym_if] = ACTIONS(276),
    [anon_sym_in] = ACTIONS(276),
    [anon_sym_AT] = ACTIONS(276),
    [anon_sym_not] = ACTIONS(276),
    [anon_sym_and] = ACTIONS(276),
    [anon_sym_or] = ACTIONS(276),
    [anon_sym_PLUS] = ACTIONS(276),
    [anon_sym_DASH] = ACTIONS(276),
    [anon_sym_SLASH] = ACTIONS(278),
    [anon_sym_PERCENT] = ACTIONS(276),
    [anon_sym_SLASH_SLASH] = ACTIONS(276),
    [anon_sym_STAR_STAR] = ACTIONS(276),
    [anon_sym_PIPE] = ACTIONS(276),
    [anon_sym_AMP] = ACTIONS(276),
    [anon_sym_CARET] = ACTIONS(276),
    [anon_sym_LT_LT] = ACTIONS(276),
    [anon_sym_LT] = ACTIONS(278),
    [anon_sym_LT_EQ] = ACTIONS(276),
    [anon_sym_EQ_EQ] = ACTIONS(276),
    [anon_sym_BANG_EQ] = ACTIONS(276),
    [anon_sym_GT_EQ] = ACTIONS(276),
    [anon_sym_GT] = ACTIONS(278),
    [anon_sym_LT_GT] = ACTIONS(276),
    [anon_sym_is] = ACTIONS(276),
    [anon_sym_LBRACK] = ACTIONS(276),
    [sym_string] = ACTIONS(1327),
    [sym_comment] = ACTIONS(72),
    [sym__semicolon] = ACTIONS(276),
  },
  [301] = {
    [sym__expression] = STATE(160),
    [sym__primary_expression] = STATE(303),
    [sym_not_operator] = STATE(160),
    [sym_boolean_operator] = STATE(160),
    [sym_binary_operator] = STATE(303),
    [sym_unary_operator] = STATE(303),
    [sym_comparison_operator] = STATE(160),
    [sym_lambda] = STATE(160),
    [sym_attribute] = STATE(303),
    [sym_subscript] = STATE(303),
    [sym_call] = STATE(303),
    [sym_list] = STATE(303),
    [sym_list_comprehension] = STATE(303),
    [sym_dictionary] = STATE(303),
    [sym_dictionary_comprehension] = STATE(303),
    [sym_set] = STATE(303),
    [sym_set_comprehension] = STATE(303),
    [sym_parenthesized_expression] = STATE(303),
    [sym_tuple] = STATE(303),
    [sym_generator_expression] = STATE(303),
    [sym_conditional_expression] = STATE(160),
    [sym_concatenated_string] = STATE(303),
    [sym_await] = STATE(160),
    [anon_sym_LPAREN] = ACTIONS(130),
    [anon_sym_print] = ACTIONS(112),
    [anon_sym_exec] = ACTIONS(112),
    [anon_sym_not] = ACTIONS(522),
    [anon_sym_PLUS] = ACTIONS(524),
    [anon_sym_DASH] = ACTIONS(524),
    [anon_sym_TILDE] = ACTIONS(524),
    [anon_sym_lambda] = ACTIONS(526),
    [anon_sym_LBRACK] = ACTIONS(134),
    [sym_ellipsis] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(122),
    [sym_string] = ACTIONS(530),
    [sym_integer] = ACTIONS(532),
    [sym_float] = ACTIONS(532),
    [sym_identifier] = ACTIONS(532),
    [sym_true] = ACTIONS(532),
    [sym_false] = ACTIONS(532),
    [sym_none] = ACTIONS(532),
    [anon_sym_await] = ACTIONS(534),
    [sym_comment] = ACTIONS(72),
  },
  [302] = {
    [sym__newline] = ACTIONS(1329),
    [anon_sym_if] = ACTIONS(1331),
    [anon_sym_and] = ACTIONS(1333),
    [anon_sym_or] = ACTIONS(1335),
    [sym_comment] = ACTIONS(72),
    [sym__semicolon] = ACTIONS(1329),
  },
  [303] = {
    [sym_argument_list] = STATE(291),
    [sym_generator_expression] = STATE(291),
    [aux_sym_comparison_operator_repeat1] = STATE(688),
    [sym__newline] = ACTIONS(302),
    [anon_sym_DOT] = ACTIONS(482),
    [anon_sym_LPAREN] = ACTIONS(484),
    [anon_sym_STAR] = ACTIONS(1337),
    [anon_sym_GT_GT] = ACTIONS(1339),
    [anon_sym_if] = ACTIONS(302),
    [anon_sym_in] = ACTIONS(1341),
    [anon_sym_AT] = ACTIONS(1343),
    [anon_sym_not] = ACTIONS(1345),
    [anon_sym_and] = ACTIONS(302),
    [anon_sym_or] = ACTIONS(302),
    [anon_sym_PLUS] = ACTIONS(1347),
    [anon_sym_DASH] = ACTIONS(1347),
    [anon_sym_SLASH] = ACTIONS(1337),
    [anon_sym_PERCENT] = ACTIONS(1343),
    [anon_sym_SLASH_SLASH] = ACTIONS(1343),
    [anon_sym_STAR_STAR] = ACTIONS(1349),
    [anon_sym_PIPE] = ACTIONS(1351),
    [anon_sym_AMP] = ACTIONS(1353),
    [anon_sym_CARET] = ACTIONS(1355),
    [anon_sym_LT_LT] = ACTIONS(1339),
    [anon_sym_LT] = ACTIONS(1357),
    [anon_sym_LT_EQ] = ACTIONS(1341),
    [anon_sym_EQ_EQ] = ACTIONS(1341),
    [anon_sym_BANG_EQ] = ACTIONS(1341),
    [anon_sym_GT_EQ] = ACTIONS(1341),
    [anon_sym_GT] = ACTIONS(1357),
    [anon_sym_LT_GT] = ACTIONS(1341),
    [anon_sym_is] = ACTIONS(1359),
    [anon_sym_LBRACK] = ACTIONS(510),
    [sym_comment] = ACTIONS(72),
    [sym__semicolon] = ACTIONS(302),
  },
  [304] = {
    [sym__newline] = ACTIONS(716),
    [anon_sym_from] = ACTIONS(716),
    [anon_sym_COMMA] = ACTIONS(716),
    [anon_sym_if] = ACTIONS(716),
    [anon_sym_and] = ACTIONS(548),
    [anon_sym_or] = ACTIONS(550),
    [sym_comment] = ACTIONS(72),
    [sym__semicolon] = ACTIONS(716),
  },
  [305] = {
    [sym__expression] = STATE(689),
    [sym__primary_expression] = STATE(86),
    [sym_not_operator] = STATE(689),
    [sym_boolean_operator] = STATE(689),
    [sym_binary_operator] = STATE(86),
    [sym_unary_operator] = STATE(86),
    [sym_comparison_operator] = STATE(689),
    [sym_lambda] = STATE(689),
    [sym_attribute] = STATE(86),
    [sym_subscript] = STATE(86),
    [sym_call] = STATE(86),
    [sym_list] = STATE(86),
    [sym_list_comprehension] = STATE(86),
    [sym_dictionary] = STATE(86),
    [sym_dictionary_comprehension] = STATE(86),
    [sym_set] = STATE(86),
    [sym_set_comprehension] = STATE(86),
    [sym_parenthesized_expression] = STATE(86),
    [sym_tuple] = STATE(86),
    [sym_generator_expression] = STATE(86),
    [sym_conditional_expression] = STATE(689),
    [sym_concatenated_string] = STATE(86),
    [sym_await] = STATE(689),
    [anon_sym_LPAREN] = ACTIONS(130),
    [anon_sym_print] = ACTIONS(112),
    [anon_sym_exec] = ACTIONS(112),
    [anon_sym_not] = ACTIONS(142),
    [anon_sym_PLUS] = ACTIONS(144),
    [anon_sym_DASH] = ACTIONS(144),
    [anon_sym_TILDE] = ACTIONS(144),
    [anon_sym_lambda] = ACTIONS(146),
    [anon_sym_LBRACK] = ACTIONS(134),
    [sym_ellipsis] = ACTIONS(148),
    [anon_sym_LBRACE] = ACTIONS(122),
    [sym_string] = ACTIONS(150),
    [sym_integer] = ACTIONS(152),
    [sym_float] = ACTIONS(152),
    [sym_identifier] = ACTIONS(152),
    [sym_true] = ACTIONS(152),
    [sym_false] = ACTIONS(152),
    [sym_none] = ACTIONS(152),
    [anon_sym_await] = ACTIONS(154),
    [sym_comment] = ACTIONS(72),
  },
  [306] = {
    [anon_sym_COLON] = ACTIONS(1361),
    [sym_comment] = ACTIONS(72),
  },
  [307] = {
    [aux_sym_concatenated_string_repeat1] = STATE(691),
    [sym__newline] = ACTIONS(886),
    [anon_sym_DOT] = ACTIONS(886),
    [anon_sym_from] = ACTIONS(886),
    [anon_sym_LPAREN] = ACTIONS(886),
    [anon_sym_COMMA] = ACTIONS(886),
    [anon_sym_STAR] = ACTIONS(888),
    [anon_sym_GT_GT] = ACTIONS(886),
    [anon_sym_if] = ACTIONS(886),
    [anon_sym_in] = ACTIONS(886),
    [anon_sym_AT] = ACTIONS(886),
    [anon_sym_not] = ACTIONS(886),
    [anon_sym_and] = ACTIONS(886),
    [anon_sym_or] = ACTIONS(886),
    [anon_sym_PLUS] = ACTIONS(886),
    [anon_sym_DASH] = ACTIONS(886),
    [anon_sym_SLASH] = ACTIONS(888),
    [anon_sym_PERCENT] = ACTIONS(886),
    [anon_sym_SLASH_SLASH] = ACTIONS(886),
    [anon_sym_STAR_STAR] = ACTIONS(886),
    [anon_sym_PIPE] = ACTIONS(886),
    [anon_sym_AMP] = ACTIONS(886),
    [anon_sym_CARET] = ACTIONS(886),
    [anon_sym_LT_LT] = ACTIONS(886),
    [anon_sym_LT] = ACTIONS(888),
    [anon_sym_LT_EQ] = ACTIONS(886),
    [anon_sym_EQ_EQ] = ACTIONS(886),
    [anon_sym_BANG_EQ] = ACTIONS(886),
    [anon_sym_GT_EQ] = ACTIONS(886),
    [anon_sym_GT] = ACTIONS(888),
    [anon_sym_LT_GT] = ACTIONS(886),
    [anon_sym_is] = ACTIONS(886),
    [anon_sym_LBRACK] = ACTIONS(886),
    [sym_string] = ACTIONS(1363),
    [sym_comment] = ACTIONS(72),
    [sym__semicolon] = ACTIONS(886),
  },
  [308] = {
    [sym__expression] = STATE(692),
    [sym__primary_expression] = STATE(303),
    [sym_not_operator] = STATE(692),
    [sym_boolean_operator] = STATE(692),
    [sym_binary_operator] = STATE(303),
    [sym_unary_operator] = STATE(303),
    [sym_comparison_operator] = STATE(692),
    [sym_lambda] = STATE(692),
    [sym_attribute] = STATE(303),
    [sym_subscript] = STATE(303),
    [sym_call] = STATE(303),
    [sym_list] = STATE(303),
    [sym_list_comprehension] = STATE(303),
    [sym_dictionary] = STATE(303),
    [sym_dictionary_comprehension] = STATE(303),
    [sym_set] = STATE(303),
    [sym_set_comprehension] = STATE(303),
    [sym_parenthesized_expression] = STATE(303),
    [sym_tuple] = STATE(303),
    [sym_generator_expression] = STATE(303),
    [sym_conditional_expression] = STATE(692),
    [sym_concatenated_string] = STATE(303),
    [sym_await] = STATE(692),
    [anon_sym_LPAREN] = ACTIONS(130),
    [anon_sym_print] = ACTIONS(112),
    [anon_sym_exec] = ACTIONS(112),
    [anon_sym_not] = ACTIONS(522),
    [anon_sym_PLUS] = ACTIONS(524),
    [anon_sym_DASH] = ACTIONS(524),
    [anon_sym_TILDE] = ACTIONS(524),
    [anon_sym_lambda] = ACTIONS(526),
    [anon_sym_LBRACK] = ACTIONS(134),
    [sym_ellipsis] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(122),
    [sym_string] = ACTIONS(530),
    [sym_integer] = ACTIONS(532),
    [sym_float] = ACTIONS(532),
    [sym_identifier] = ACTIONS(532),
    [sym_true] = ACTIONS(532),
    [sym_false] = ACTIONS(532),
    [sym_none] = ACTIONS(532),
    [anon_sym_await] = ACTIONS(534),
    [sym_comment] = ACTIONS(72),
  },
  [309] = {
    [sym__expression] = STATE(693),
    [sym__primary_expression] = STATE(86),
    [sym_not_operator] = STATE(693),
    [sym_boolean_operator] = STATE(693),
    [sym_binary_operator] = STATE(86),
    [sym_unary_operator] = STATE(86),
    [sym_comparison_operator] = STATE(693),
    [sym_lambda] = STATE(693),
    [sym_attribute] = STATE(86),
    [sym_subscript] = STATE(86),
    [sym_call] = STATE(86),
    [sym_list] = STATE(86),
    [sym_list_comprehension] = STATE(86),
    [sym_dictionary] = STATE(86),
    [sym_dictionary_comprehension] = STATE(86),
    [sym_set] = STATE(86),
    [sym_set_comprehension] = STATE(86),
    [sym_parenthesized_expression] = STATE(86),
    [sym_tuple] = STATE(86),
    [sym_generator_expression] = STATE(86),
    [sym_conditional_expression] = STATE(693),
    [sym_concatenated_string] = STATE(86),
    [sym_await] = STATE(693),
    [sym__newline] = ACTIONS(910),
    [anon_sym_from] = ACTIONS(1365),
    [anon_sym_LPAREN] = ACTIONS(130),
    [anon_sym_print] = ACTIONS(112),
    [anon_sym_exec] = ACTIONS(112),
    [anon_sym_not] = ACTIONS(142),
    [anon_sym_PLUS] = ACTIONS(144),
    [anon_sym_DASH] = ACTIONS(144),
    [anon_sym_TILDE] = ACTIONS(144),
    [anon_sym_lambda] = ACTIONS(146),
    [anon_sym_LBRACK] = ACTIONS(134),
    [sym_ellipsis] = ACTIONS(148),
    [anon_sym_LBRACE] = ACTIONS(122),
    [sym_string] = ACTIONS(150),
    [sym_integer] = ACTIONS(152),
    [sym_float] = ACTIONS(152),
    [sym_identifier] = ACTIONS(152),
    [sym_true] = ACTIONS(152),
    [sym_false] = ACTIONS(152),
    [sym_none] = ACTIONS(152),
    [anon_sym_await] = ACTIONS(154),
    [sym_comment] = ACTIONS(72),
    [sym__semicolon] = ACTIONS(910),
  },
  [310] = {
    [sym__expression] = STATE(694),
    [sym__primary_expression] = STATE(513),
    [sym_not_operator] = STATE(694),
    [sym_boolean_operator] = STATE(694),
    [sym_binary_operator] = STATE(513),
    [sym_unary_operator] = STATE(513),
    [sym_comparison_operator] = STATE(694),
    [sym_lambda] = STATE(694),
    [sym_attribute] = STATE(513),
    [sym_subscript] = STATE(513),
    [sym_call] = STATE(513),
    [sym_list] = STATE(513),
    [sym_list_comprehension] = STATE(513),
    [sym_dictionary] = STATE(513),
    [sym_dictionary_comprehension] = STATE(513),
    [sym_set] = STATE(513),
    [sym_set_comprehension] = STATE(513),
    [sym_parenthesized_expression] = STATE(513),
    [sym_tuple] = STATE(513),
    [sym_generator_expression] = STATE(513),
    [sym_conditional_expression] = STATE(694),
    [sym_concatenated_string] = STATE(513),
    [sym_await] = STATE(694),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_not] = ACTIONS(914),
    [anon_sym_PLUS] = ACTIONS(916),
    [anon_sym_DASH] = ACTIONS(916),
    [anon_sym_TILDE] = ACTIONS(916),
    [anon_sym_lambda] = ACTIONS(918),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(920),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(922),
    [sym_integer] = ACTIONS(924),
    [sym_float] = ACTIONS(924),
    [sym_identifier] = ACTIONS(924),
    [sym_true] = ACTIONS(924),
    [sym_false] = ACTIONS(924),
    [sym_none] = ACTIONS(924),
    [anon_sym_await] = ACTIONS(926),
    [sym_comment] = ACTIONS(72),
  },
  [311] = {
    [sym__expression] = STATE(514),
    [sym__primary_expression] = STATE(86),
    [sym_not_operator] = STATE(514),
    [sym_boolean_operator] = STATE(514),
    [sym_binary_operator] = STATE(86),
    [sym_unary_operator] = STATE(86),
    [sym_comparison_operator] = STATE(514),
    [sym_lambda] = STATE(514),
    [sym_attribute] = STATE(86),
    [sym_subscript] = STATE(86),
    [sym_call] = STATE(86),
    [sym_list] = STATE(86),
    [sym_list_comprehension] = STATE(86),
    [sym_dictionary] = STATE(86),
    [sym_dictionary_comprehension] = STATE(86),
    [sym_set] = STATE(86),
    [sym_set_comprehension] = STATE(86),
    [sym_parenthesized_expression] = STATE(86),
    [sym_tuple] = STATE(86),
    [sym_generator_expression] = STATE(86),
    [sym_conditional_expression] = STATE(514),
    [sym_concatenated_string] = STATE(86),
    [sym_await] = STATE(514),
    [anon_sym_LPAREN] = ACTIONS(130),
    [anon_sym_print] = ACTIONS(112),
    [anon_sym_exec] = ACTIONS(112),
    [anon_sym_not] = ACTIONS(142),
    [anon_sym_PLUS] = ACTIONS(144),
    [anon_sym_DASH] = ACTIONS(144),
    [anon_sym_TILDE] = ACTIONS(144),
    [anon_sym_lambda] = ACTIONS(146),
    [anon_sym_LBRACK] = ACTIONS(134),
    [sym_ellipsis] = ACTIONS(148),
    [anon_sym_LBRACE] = ACTIONS(122),
    [sym_string] = ACTIONS(150),
    [sym_integer] = ACTIONS(152),
    [sym_float] = ACTIONS(152),
    [sym_identifier] = ACTIONS(152),
    [sym_true] = ACTIONS(152),
    [sym_false] = ACTIONS(152),
    [sym_none] = ACTIONS(152),
    [anon_sym_await] = ACTIONS(154),
    [sym_comment] = ACTIONS(72),
  },
  [312] = {
    [sym__expression] = STATE(695),
    [sym__primary_expression] = STATE(86),
    [sym_not_operator] = STATE(695),
    [sym_boolean_operator] = STATE(695),
    [sym_binary_operator] = STATE(86),
    [sym_unary_operator] = STATE(86),
    [sym_comparison_operator] = STATE(695),
    [sym_lambda] = STATE(695),
    [sym_attribute] = STATE(86),
    [sym_subscript] = STATE(86),
    [sym_call] = STATE(86),
    [sym_list] = STATE(86),
    [sym_list_comprehension] = STATE(86),
    [sym_dictionary] = STATE(86),
    [sym_dictionary_comprehension] = STATE(86),
    [sym_set] = STATE(86),
    [sym_set_comprehension] = STATE(86),
    [sym_parenthesized_expression] = STATE(86),
    [sym_tuple] = STATE(86),
    [sym_generator_expression] = STATE(86),
    [sym_conditional_expression] = STATE(695),
    [sym_concatenated_string] = STATE(86),
    [sym_await] = STATE(695),
    [anon_sym_LPAREN] = ACTIONS(130),
    [anon_sym_print] = ACTIONS(112),
    [anon_sym_exec] = ACTIONS(112),
    [anon_sym_not] = ACTIONS(142),
    [anon_sym_PLUS] = ACTIONS(144),
    [anon_sym_DASH] = ACTIONS(144),
    [anon_sym_TILDE] = ACTIONS(144),
    [anon_sym_lambda] = ACTIONS(146),
    [anon_sym_LBRACK] = ACTIONS(134),
    [sym_ellipsis] = ACTIONS(148),
    [anon_sym_LBRACE] = ACTIONS(122),
    [sym_string] = ACTIONS(150),
    [sym_integer] = ACTIONS(152),
    [sym_float] = ACTIONS(152),
    [sym_identifier] = ACTIONS(152),
    [sym_true] = ACTIONS(152),
    [sym_false] = ACTIONS(152),
    [sym_none] = ACTIONS(152),
    [anon_sym_await] = ACTIONS(154),
    [sym_comment] = ACTIONS(72),
  },
  [313] = {
    [aux_sym_print_statement_repeat1] = STATE(697),
    [sym__newline] = ACTIONS(910),
    [anon_sym_from] = ACTIONS(910),
    [anon_sym_COMMA] = ACTIONS(1367),
    [sym_comment] = ACTIONS(72),
    [sym__semicolon] = ACTIONS(910),
  },
  [314] = {
    [sym__primary_expression] = STATE(698),
    [sym_binary_operator] = STATE(698),
    [sym_unary_operator] = STATE(698),
    [sym_attribute] = STATE(698),
    [sym_subscript] = STATE(698),
    [sym_call] = STATE(698),
    [sym_list] = STATE(698),
    [sym_list_comprehension] = STATE(698),
    [sym_dictionary] = STATE(698),
    [sym_dictionary_comprehension] = STATE(698),
    [sym_set] = STATE(698),
    [sym_set_comprehension] = STATE(698),
    [sym_parenthesized_expression] = STATE(698),
    [sym_tuple] = STATE(698),
    [sym_generator_expression] = STATE(698),
    [sym_concatenated_string] = STATE(698),
    [anon_sym_LPAREN] = ACTIONS(130),
    [anon_sym_print] = ACTIONS(112),
    [anon_sym_exec] = ACTIONS(112),
    [anon_sym_PLUS] = ACTIONS(144),
    [anon_sym_DASH] = ACTIONS(144),
    [anon_sym_TILDE] = ACTIONS(144),
    [anon_sym_LBRACK] = ACTIONS(134),
    [sym_ellipsis] = ACTIONS(1369),
    [anon_sym_LBRACE] = ACTIONS(122),
    [sym_string] = ACTIONS(150),
    [sym_integer] = ACTIONS(1371),
    [sym_float] = ACTIONS(1371),
    [sym_identifier] = ACTIONS(1371),
    [sym_true] = ACTIONS(1371),
    [sym_false] = ACTIONS(1371),
    [sym_none] = ACTIONS(1371),
    [sym_comment] = ACTIONS(72),
  },
  [315] = {
    [sym__primary_expression] = STATE(699),
    [sym_binary_operator] = STATE(699),
    [sym_unary_operator] = STATE(699),
    [sym_attribute] = STATE(699),
    [sym_subscript] = STATE(699),
    [sym_call] = STATE(699),
    [sym_list] = STATE(699),
    [sym_list_comprehension] = STATE(699),
    [sym_dictionary] = STATE(699),
    [sym_dictionary_comprehension] = STATE(699),
    [sym_set] = STATE(699),
    [sym_set_comprehension] = STATE(699),
    [sym_parenthesized_expression] = STATE(699),
    [sym_tuple] = STATE(699),
    [sym_generator_expression] = STATE(699),
    [sym_concatenated_string] = STATE(699),
    [anon_sym_LPAREN] = ACTIONS(130),
    [anon_sym_print] = ACTIONS(112),
    [anon_sym_exec] = ACTIONS(112),
    [anon_sym_PLUS] = ACTIONS(144),
    [anon_sym_DASH] = ACTIONS(144),
    [anon_sym_TILDE] = ACTIONS(144),
    [anon_sym_LBRACK] = ACTIONS(134),
    [sym_ellipsis] = ACTIONS(1373),
    [anon_sym_LBRACE] = ACTIONS(122),
    [sym_string] = ACTIONS(150),
    [sym_integer] = ACTIONS(1375),
    [sym_float] = ACTIONS(1375),
    [sym_identifier] = ACTIONS(1375),
    [sym_true] = ACTIONS(1375),
    [sym_false] = ACTIONS(1375),
    [sym_none] = ACTIONS(1375),
    [sym_comment] = ACTIONS(72),
  },
  [316] = {
    [sym__primary_expression] = STATE(700),
    [sym_binary_operator] = STATE(700),
    [sym_unary_operator] = STATE(700),
    [sym_attribute] = STATE(700),
    [sym_subscript] = STATE(700),
    [sym_call] = STATE(700),
    [sym_list] = STATE(700),
    [sym_list_comprehension] = STATE(700),
    [sym_dictionary] = STATE(700),
    [sym_dictionary_comprehension] = STATE(700),
    [sym_set] = STATE(700),
    [sym_set_comprehension] = STATE(700),
    [sym_parenthesized_expression] = STATE(700),
    [sym_tuple] = STATE(700),
    [sym_generator_expression] = STATE(700),
    [sym_concatenated_string] = STATE(700),
    [anon_sym_LPAREN] = ACTIONS(130),
    [anon_sym_print] = ACTIONS(112),
    [anon_sym_exec] = ACTIONS(112),
    [anon_sym_PLUS] = ACTIONS(144),
    [anon_sym_DASH] = ACTIONS(144),
    [anon_sym_TILDE] = ACTIONS(144),
    [anon_sym_LBRACK] = ACTIONS(134),
    [sym_ellipsis] = ACTIONS(1377),
    [anon_sym_LBRACE] = ACTIONS(122),
    [sym_string] = ACTIONS(150),
    [sym_integer] = ACTIONS(1379),
    [sym_float] = ACTIONS(1379),
    [sym_identifier] = ACTIONS(1379),
    [sym_true] = ACTIONS(1379),
    [sym_false] = ACTIONS(1379),
    [sym_none] = ACTIONS(1379),
    [sym_comment] = ACTIONS(72),
  },
  [317] = {
    [anon_sym_in] = ACTIONS(1381),
    [sym_comment] = ACTIONS(72),
  },
  [318] = {
    [sym__primary_expression] = STATE(702),
    [sym_binary_operator] = STATE(702),
    [sym_unary_operator] = STATE(702),
    [sym_attribute] = STATE(702),
    [sym_subscript] = STATE(702),
    [sym_call] = STATE(702),
    [sym_list] = STATE(702),
    [sym_list_comprehension] = STATE(702),
    [sym_dictionary] = STATE(702),
    [sym_dictionary_comprehension] = STATE(702),
    [sym_set] = STATE(702),
    [sym_set_comprehension] = STATE(702),
    [sym_parenthesized_expression] = STATE(702),
    [sym_tuple] = STATE(702),
    [sym_generator_expression] = STATE(702),
    [sym_concatenated_string] = STATE(702),
    [anon_sym_LPAREN] = ACTIONS(130),
    [anon_sym_print] = ACTIONS(112),
    [anon_sym_exec] = ACTIONS(112),
    [anon_sym_PLUS] = ACTIONS(144),
    [anon_sym_DASH] = ACTIONS(144),
    [anon_sym_TILDE] = ACTIONS(144),
    [anon_sym_LBRACK] = ACTIONS(134),
    [sym_ellipsis] = ACTIONS(1383),
    [anon_sym_LBRACE] = ACTIONS(122),
    [sym_string] = ACTIONS(150),
    [sym_integer] = ACTIONS(1385),
    [sym_float] = ACTIONS(1385),
    [sym_identifier] = ACTIONS(1385),
    [sym_true] = ACTIONS(1385),
    [sym_false] = ACTIONS(1385),
    [sym_none] = ACTIONS(1385),
    [sym_comment] = ACTIONS(72),
  },
  [319] = {
    [sym__primary_expression] = STATE(663),
    [sym_binary_operator] = STATE(663),
    [sym_unary_operator] = STATE(663),
    [sym_attribute] = STATE(663),
    [sym_subscript] = STATE(663),
    [sym_call] = STATE(663),
    [sym_list] = STATE(663),
    [sym_list_comprehension] = STATE(663),
    [sym_dictionary] = STATE(663),
    [sym_dictionary_comprehension] = STATE(663),
    [sym_set] = STATE(663),
    [sym_set_comprehension] = STATE(663),
    [sym_parenthesized_expression] = STATE(663),
    [sym_tuple] = STATE(663),
    [sym_generator_expression] = STATE(663),
    [sym_concatenated_string] = STATE(663),
    [anon_sym_LPAREN] = ACTIONS(130),
    [anon_sym_print] = ACTIONS(112),
    [anon_sym_exec] = ACTIONS(112),
    [anon_sym_PLUS] = ACTIONS(144),
    [anon_sym_DASH] = ACTIONS(144),
    [anon_sym_TILDE] = ACTIONS(144),
    [anon_sym_LBRACK] = ACTIONS(134),
    [sym_ellipsis] = ACTIONS(1303),
    [anon_sym_LBRACE] = ACTIONS(122),
    [sym_string] = ACTIONS(150),
    [sym_integer] = ACTIONS(1305),
    [sym_float] = ACTIONS(1305),
    [sym_identifier] = ACTIONS(1305),
    [sym_true] = ACTIONS(1305),
    [sym_false] = ACTIONS(1305),
    [sym_none] = ACTIONS(1305),
    [sym_comment] = ACTIONS(72),
  },
  [320] = {
    [sym__primary_expression] = STATE(703),
    [sym_binary_operator] = STATE(703),
    [sym_unary_operator] = STATE(703),
    [sym_attribute] = STATE(703),
    [sym_subscript] = STATE(703),
    [sym_call] = STATE(703),
    [sym_list] = STATE(703),
    [sym_list_comprehension] = STATE(703),
    [sym_dictionary] = STATE(703),
    [sym_dictionary_comprehension] = STATE(703),
    [sym_set] = STATE(703),
    [sym_set_comprehension] = STATE(703),
    [sym_parenthesized_expression] = STATE(703),
    [sym_tuple] = STATE(703),
    [sym_generator_expression] = STATE(703),
    [sym_concatenated_string] = STATE(703),
    [anon_sym_LPAREN] = ACTIONS(130),
    [anon_sym_print] = ACTIONS(112),
    [anon_sym_exec] = ACTIONS(112),
    [anon_sym_PLUS] = ACTIONS(144),
    [anon_sym_DASH] = ACTIONS(144),
    [anon_sym_TILDE] = ACTIONS(144),
    [anon_sym_LBRACK] = ACTIONS(134),
    [sym_ellipsis] = ACTIONS(1387),
    [anon_sym_LBRACE] = ACTIONS(122),
    [sym_string] = ACTIONS(150),
    [sym_integer] = ACTIONS(1389),
    [sym_float] = ACTIONS(1389),
    [sym_identifier] = ACTIONS(1389),
    [sym_true] = ACTIONS(1389),
    [sym_false] = ACTIONS(1389),
    [sym_none] = ACTIONS(1389),
    [sym_comment] = ACTIONS(72),
  },
  [321] = {
    [sym__primary_expression] = STATE(704),
    [sym_binary_operator] = STATE(704),
    [sym_unary_operator] = STATE(704),
    [sym_attribute] = STATE(704),
    [sym_subscript] = STATE(704),
    [sym_call] = STATE(704),
    [sym_list] = STATE(704),
    [sym_list_comprehension] = STATE(704),
    [sym_dictionary] = STATE(704),
    [sym_dictionary_comprehension] = STATE(704),
    [sym_set] = STATE(704),
    [sym_set_comprehension] = STATE(704),
    [sym_parenthesized_expression] = STATE(704),
    [sym_tuple] = STATE(704),
    [sym_generator_expression] = STATE(704),
    [sym_concatenated_string] = STATE(704),
    [anon_sym_LPAREN] = ACTIONS(130),
    [anon_sym_print] = ACTIONS(112),
    [anon_sym_exec] = ACTIONS(112),
    [anon_sym_PLUS] = ACTIONS(144),
    [anon_sym_DASH] = ACTIONS(144),
    [anon_sym_TILDE] = ACTIONS(144),
    [anon_sym_LBRACK] = ACTIONS(134),
    [sym_ellipsis] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(122),
    [sym_string] = ACTIONS(150),
    [sym_integer] = ACTIONS(1393),
    [sym_float] = ACTIONS(1393),
    [sym_identifier] = ACTIONS(1393),
    [sym_true] = ACTIONS(1393),
    [sym_false] = ACTIONS(1393),
    [sym_none] = ACTIONS(1393),
    [sym_comment] = ACTIONS(72),
  },
  [322] = {
    [sym__primary_expression] = STATE(705),
    [sym_binary_operator] = STATE(705),
    [sym_unary_operator] = STATE(705),
    [sym_attribute] = STATE(705),
    [sym_subscript] = STATE(705),
    [sym_call] = STATE(705),
    [sym_list] = STATE(705),
    [sym_list_comprehension] = STATE(705),
    [sym_dictionary] = STATE(705),
    [sym_dictionary_comprehension] = STATE(705),
    [sym_set] = STATE(705),
    [sym_set_comprehension] = STATE(705),
    [sym_parenthesized_expression] = STATE(705),
    [sym_tuple] = STATE(705),
    [sym_generator_expression] = STATE(705),
    [sym_concatenated_string] = STATE(705),
    [anon_sym_LPAREN] = ACTIONS(130),
    [anon_sym_print] = ACTIONS(112),
    [anon_sym_exec] = ACTIONS(112),
    [anon_sym_PLUS] = ACTIONS(144),
    [anon_sym_DASH] = ACTIONS(144),
    [anon_sym_TILDE] = ACTIONS(144),
    [anon_sym_LBRACK] = ACTIONS(134),
    [sym_ellipsis] = ACTIONS(1395),
    [anon_sym_LBRACE] = ACTIONS(122),
    [sym_string] = ACTIONS(150),
    [sym_integer] = ACTIONS(1397),
    [sym_float] = ACTIONS(1397),
    [sym_identifier] = ACTIONS(1397),
    [sym_true] = ACTIONS(1397),
    [sym_false] = ACTIONS(1397),
    [sym_none] = ACTIONS(1397),
    [sym_comment] = ACTIONS(72),
  },
  [323] = {
    [sym__primary_expression] = STATE(700),
    [sym_binary_operator] = STATE(700),
    [sym_unary_operator] = STATE(700),
    [sym_attribute] = STATE(700),
    [sym_subscript] = STATE(700),
    [sym_call] = STATE(700),
    [sym_list] = STATE(700),
    [sym_list_comprehension] = STATE(700),
    [sym_dictionary] = STATE(700),
    [sym_dictionary_comprehension] = STATE(700),
    [sym_set] = STATE(700),
    [sym_set_comprehension] = STATE(700),
    [sym_parenthesized_expression] = STATE(700),
    [sym_tuple] = STATE(700),
    [sym_generator_expression] = STATE(700),
    [sym_concatenated_string] = STATE(700),
    [anon_sym_LPAREN] = ACTIONS(130),
    [anon_sym_print] = ACTIONS(112),
    [anon_sym_exec] = ACTIONS(112),
    [anon_sym_not] = ACTIONS(1399),
    [anon_sym_PLUS] = ACTIONS(144),
    [anon_sym_DASH] = ACTIONS(144),
    [anon_sym_TILDE] = ACTIONS(144),
    [anon_sym_LBRACK] = ACTIONS(134),
    [sym_ellipsis] = ACTIONS(1377),
    [anon_sym_LBRACE] = ACTIONS(122),
    [sym_string] = ACTIONS(150),
    [sym_integer] = ACTIONS(1379),
    [sym_float] = ACTIONS(1379),
    [sym_identifier] = ACTIONS(1379),
    [sym_true] = ACTIONS(1379),
    [sym_false] = ACTIONS(1379),
    [sym_none] = ACTIONS(1379),
    [sym_comment] = ACTIONS(72),
  },
  [324] = {
    [aux_sym_comparison_operator_repeat1] = STATE(706),
    [sym__newline] = ACTIONS(998),
    [anon_sym_from] = ACTIONS(998),
    [anon_sym_COMMA] = ACTIONS(998),
    [anon_sym_if] = ACTIONS(998),
    [anon_sym_in] = ACTIONS(556),
    [anon_sym_not] = ACTIONS(560),
    [anon_sym_and] = ACTIONS(998),
    [anon_sym_or] = ACTIONS(998),
    [anon_sym_LT] = ACTIONS(572),
    [anon_sym_LT_EQ] = ACTIONS(556),
    [anon_sym_EQ_EQ] = ACTIONS(556),
    [anon_sym_BANG_EQ] = ACTIONS(556),
    [anon_sym_GT_EQ] = ACTIONS(556),
    [anon_sym_GT] = ACTIONS(572),
    [anon_sym_LT_GT] = ACTIONS(556),
    [anon_sym_is] = ACTIONS(574),
    [sym_comment] = ACTIONS(72),
    [sym__semicolon] = ACTIONS(998),
  },
  [325] = {
    [ts_builtin_sym_end] = ACTIONS(1401),
    [anon_sym_import] = ACTIONS(1403),
    [anon_sym_from] = ACTIONS(1403),
    [anon_sym_LPAREN] = ACTIONS(1401),
    [anon_sym_print] = ACTIONS(1403),
    [anon_sym_assert] = ACTIONS(1403),
    [anon_sym_return] = ACTIONS(1403),
    [anon_sym_del] = ACTIONS(1403),
    [anon_sym_raise] = ACTIONS(1403),
    [sym_pass_statement] = ACTIONS(1403),
    [sym_break_statement] = ACTIONS(1403),
    [sym_continue_statement] = ACTIONS(1403),
    [anon_sym_if] = ACTIONS(1403),
    [anon_sym_async] = ACTIONS(1403),
    [anon_sym_for] = ACTIONS(1403),
    [anon_sym_while] = ACTIONS(1403),
    [anon_sym_try] = ACTIONS(1403),
    [anon_sym_with] = ACTIONS(1403),
    [anon_sym_def] = ACTIONS(1403),
    [anon_sym_global] = ACTIONS(1403),
    [anon_sym_nonlocal] = ACTIONS(1403),
    [anon_sym_exec] = ACTIONS(1403),
    [anon_sym_class] = ACTIONS(1403),
    [anon_sym_AT] = ACTIONS(1401),
    [anon_sym_not] = ACTIONS(1403),
    [anon_sym_PLUS] = ACTIONS(1401),
    [anon_sym_DASH] = ACTIONS(1401),
    [anon_sym_TILDE] = ACTIONS(1401),
    [anon_sym_lambda] = ACTIONS(1403),
    [anon_sym_yield] = ACTIONS(1403),
    [anon_sym_LBRACK] = ACTIONS(1401),
    [sym_ellipsis] = ACTIONS(1401),
    [anon_sym_LBRACE] = ACTIONS(1401),
    [sym_string] = ACTIONS(1401),
    [sym_integer] = ACTIONS(1403),
    [sym_float] = ACTIONS(1403),
    [sym_identifier] = ACTIONS(1403),
    [sym_true] = ACTIONS(1403),
    [sym_false] = ACTIONS(1403),
    [sym_none] = ACTIONS(1403),
    [anon_sym_await] = ACTIONS(1403),
    [sym_comment] = ACTIONS(72),
  },
  [326] = {
    [sym__newline] = ACTIONS(1405),
    [sym_comment] = ACTIONS(72),
    [sym__semicolon] = ACTIONS(1405),
  },
  [327] = {
    [sym_import_statement] = STATE(326),
    [sym_import_from_statement] = STATE(326),
    [sym_print_statement] = STATE(326),
    [sym_assert_statement] = STATE(326),
    [sym_expression_statement] = STATE(326),
    [sym_return_statement] = STATE(326),
    [sym_delete_statement] = STATE(326),
    [sym_raise_statement] = STATE(326),
    [sym_global_statement] = STATE(326),
    [sym_nonlocal_statement] = STATE(326),
    [sym_exec_statement] = STATE(326),
    [sym_expression_list] = STATE(32),
    [sym__expression] = STATE(33),
    [sym__primary_expression] = STATE(34),
    [sym_not_operator] = STATE(33),
    [sym_boolean_operator] = STATE(33),
    [sym_binary_operator] = STATE(34),
    [sym_unary_operator] = STATE(34),
    [sym_comparison_operator] = STATE(33),
    [sym_lambda] = STATE(33),
    [sym_assignment] = STATE(35),
    [sym_augmented_assignment] = STATE(35),
    [sym_yield] = STATE(35),
    [sym_attribute] = STATE(34),
    [sym_subscript] = STATE(34),
    [sym_call] = STATE(34),
    [sym_list] = STATE(34),
    [sym_list_comprehension] = STATE(34),
    [sym_dictionary] = STATE(34),
    [sym_dictionary_comprehension] = STATE(34),
    [sym_set] = STATE(34),
    [sym_set_comprehension] = STATE(34),
    [sym_parenthesized_expression] = STATE(34),
    [sym_tuple] = STATE(34),
    [sym_generator_expression] = STATE(34),
    [sym_conditional_expression] = STATE(33),
    [sym_concatenated_string] = STATE(34),
    [sym_await] = STATE(33),
    [sym__newline] = ACTIONS(1407),
    [anon_sym_import] = ACTIONS(10),
    [anon_sym_from] = ACTIONS(12),
    [anon_sym_LPAREN] = ACTIONS(14),
    [anon_sym_print] = ACTIONS(16),
    [anon_sym_assert] = ACTIONS(18),
    [anon_sym_return] = ACTIONS(20),
    [anon_sym_del] = ACTIONS(22),
    [anon_sym_raise] = ACTIONS(24),
    [sym_pass_statement] = ACTIONS(582),
    [sym_break_statement] = ACTIONS(582),
    [sym_continue_statement] = ACTIONS(582),
    [anon_sym_global] = ACTIONS(42),
    [anon_sym_nonlocal] = ACTIONS(44),
    [anon_sym_exec] = ACTIONS(46),
    [anon_sym_not] = ACTIONS(52),
    [anon_sym_PLUS] = ACTIONS(54),
    [anon_sym_DASH] = ACTIONS(54),
    [anon_sym_TILDE] = ACTIONS(54),
    [anon_sym_lambda] = ACTIONS(56),
    [anon_sym_yield] = ACTIONS(58),
    [anon_sym_LBRACK] = ACTIONS(60),
    [sym_ellipsis] = ACTIONS(62),
    [anon_sym_LBRACE] = ACTIONS(64),
    [sym_string] = ACTIONS(66),
    [sym_integer] = ACTIONS(68),
    [sym_float] = ACTIONS(68),
    [sym_identifier] = ACTIONS(68),
    [sym_true] = ACTIONS(68),
    [sym_false] = ACTIONS(68),
    [sym_none] = ACTIONS(68),
    [anon_sym_await] = ACTIONS(70),
    [sym_comment] = ACTIONS(72),
  },
  [328] = {
    [aux_sym__simple_statements_repeat1] = STATE(328),
    [sym__newline] = ACTIONS(1405),
    [sym_comment] = ACTIONS(72),
    [sym__semicolon] = ACTIONS(1409),
  },
  [329] = {
    [anon_sym_if] = ACTIONS(716),
    [anon_sym_COLON] = ACTIONS(716),
    [anon_sym_and] = ACTIONS(594),
    [anon_sym_or] = ACTIONS(596),
    [sym_comment] = ACTIONS(72),
  },
  [330] = {
    [sym__expression] = STATE(709),
    [sym__primary_expression] = STATE(96),
    [sym_not_operator] = STATE(709),
    [sym_boolean_operator] = STATE(709),
    [sym_binary_operator] = STATE(96),
    [sym_unary_operator] = STATE(96),
    [sym_comparison_operator] = STATE(709),
    [sym_lambda] = STATE(709),
    [sym_attribute] = STATE(96),
    [sym_subscript] = STATE(96),
    [sym_call] = STATE(96),
    [sym_list] = STATE(96),
    [sym_list_comprehension] = STATE(96),
    [sym_dictionary] = STATE(96),
    [sym_dictionary_comprehension] = STATE(96),
    [sym_set] = STATE(96),
    [sym_set_comprehension] = STATE(96),
    [sym_parenthesized_expression] = STATE(96),
    [sym_tuple] = STATE(96),
    [sym_generator_expression] = STATE(96),
    [sym_conditional_expression] = STATE(709),
    [sym_concatenated_string] = STATE(96),
    [sym_await] = STATE(709),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_not] = ACTIONS(160),
    [anon_sym_PLUS] = ACTIONS(162),
    [anon_sym_DASH] = ACTIONS(162),
    [anon_sym_TILDE] = ACTIONS(162),
    [anon_sym_lambda] = ACTIONS(164),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(166),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(168),
    [sym_integer] = ACTIONS(170),
    [sym_float] = ACTIONS(170),
    [sym_identifier] = ACTIONS(170),
    [sym_true] = ACTIONS(170),
    [sym_false] = ACTIONS(170),
    [sym_none] = ACTIONS(170),
    [anon_sym_await] = ACTIONS(172),
    [sym_comment] = ACTIONS(72),
  },
  [331] = {
    [anon_sym_COLON] = ACTIONS(1412),
    [sym_comment] = ACTIONS(72),
  },
  [332] = {
    [aux_sym_concatenated_string_repeat1] = STATE(711),
    [anon_sym_DOT] = ACTIONS(886),
    [anon_sym_LPAREN] = ACTIONS(886),
    [anon_sym_STAR] = ACTIONS(888),
    [anon_sym_GT_GT] = ACTIONS(886),
    [anon_sym_if] = ACTIONS(886),
    [anon_sym_COLON] = ACTIONS(886),
    [anon_sym_in] = ACTIONS(886),
    [anon_sym_AT] = ACTIONS(886),
    [anon_sym_not] = ACTIONS(886),
    [anon_sym_and] = ACTIONS(886),
    [anon_sym_or] = ACTIONS(886),
    [anon_sym_PLUS] = ACTIONS(886),
    [anon_sym_DASH] = ACTIONS(886),
    [anon_sym_SLASH] = ACTIONS(888),
    [anon_sym_PERCENT] = ACTIONS(886),
    [anon_sym_SLASH_SLASH] = ACTIONS(886),
    [anon_sym_STAR_STAR] = ACTIONS(886),
    [anon_sym_PIPE] = ACTIONS(886),
    [anon_sym_AMP] = ACTIONS(886),
    [anon_sym_CARET] = ACTIONS(886),
    [anon_sym_LT_LT] = ACTIONS(886),
    [anon_sym_LT] = ACTIONS(888),
    [anon_sym_LT_EQ] = ACTIONS(886),
    [anon_sym_EQ_EQ] = ACTIONS(886),
    [anon_sym_BANG_EQ] = ACTIONS(886),
    [anon_sym_GT_EQ] = ACTIONS(886),
    [anon_sym_GT] = ACTIONS(888),
    [anon_sym_LT_GT] = ACTIONS(886),
    [anon_sym_is] = ACTIONS(886),
    [anon_sym_LBRACK] = ACTIONS(886),
    [sym_string] = ACTIONS(1414),
    [sym_comment] = ACTIONS(72),
  },
  [333] = {
    [sym__expression] = STATE(712),
    [sym__primary_expression] = STATE(513),
    [sym_not_operator] = STATE(712),
    [sym_boolean_operator] = STATE(712),
    [sym_binary_operator] = STATE(513),
    [sym_unary_operator] = STATE(513),
    [sym_comparison_operator] = STATE(712),
    [sym_lambda] = STATE(712),
    [sym_attribute] = STATE(513),
    [sym_subscript] = STATE(513),
    [sym_call] = STATE(513),
    [sym_list] = STATE(513),
    [sym_list_comprehension] = STATE(513),
    [sym_dictionary] = STATE(513),
    [sym_dictionary_comprehension] = STATE(513),
    [sym_set] = STATE(513),
    [sym_set_comprehension] = STATE(513),
    [sym_parenthesized_expression] = STATE(513),
    [sym_tuple] = STATE(513),
    [sym_generator_expression] = STATE(513),
    [sym_conditional_expression] = STATE(712),
    [sym_concatenated_string] = STATE(513),
    [sym_await] = STATE(712),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_not] = ACTIONS(914),
    [anon_sym_PLUS] = ACTIONS(916),
    [anon_sym_DASH] = ACTIONS(916),
    [anon_sym_TILDE] = ACTIONS(916),
    [anon_sym_lambda] = ACTIONS(918),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(920),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(922),
    [sym_integer] = ACTIONS(924),
    [sym_float] = ACTIONS(924),
    [sym_identifier] = ACTIONS(924),
    [sym_true] = ACTIONS(924),
    [sym_false] = ACTIONS(924),
    [sym_none] = ACTIONS(924),
    [anon_sym_await] = ACTIONS(926),
    [sym_comment] = ACTIONS(72),
  },
  [334] = {
    [sym__simple_statements] = STATE(715),
    [sym_import_statement] = STATE(714),
    [sym_import_from_statement] = STATE(714),
    [sym_print_statement] = STATE(714),
    [sym_assert_statement] = STATE(714),
    [sym_expression_statement] = STATE(714),
    [sym_return_statement] = STATE(714),
    [sym_delete_statement] = STATE(714),
    [sym_raise_statement] = STATE(714),
    [sym_global_statement] = STATE(714),
    [sym_nonlocal_statement] = STATE(714),
    [sym_exec_statement] = STATE(714),
    [sym__suite] = STATE(715),
    [sym_expression_list] = STATE(32),
    [sym__expression] = STATE(33),
    [sym__primary_expression] = STATE(34),
    [sym_not_operator] = STATE(33),
    [sym_boolean_operator] = STATE(33),
    [sym_binary_operator] = STATE(34),
    [sym_unary_operator] = STATE(34),
    [sym_comparison_operator] = STATE(33),
    [sym_lambda] = STATE(33),
    [sym_assignment] = STATE(35),
    [sym_augmented_assignment] = STATE(35),
    [sym_yield] = STATE(35),
    [sym_attribute] = STATE(34),
    [sym_subscript] = STATE(34),
    [sym_call] = STATE(34),
    [sym_list] = STATE(34),
    [sym_list_comprehension] = STATE(34),
    [sym_dictionary] = STATE(34),
    [sym_dictionary_comprehension] = STATE(34),
    [sym_set] = STATE(34),
    [sym_set_comprehension] = STATE(34),
    [sym_parenthesized_expression] = STATE(34),
    [sym_tuple] = STATE(34),
    [sym_generator_expression] = STATE(34),
    [sym_conditional_expression] = STATE(33),
    [sym_concatenated_string] = STATE(34),
    [sym_await] = STATE(33),
    [sym__indent] = ACTIONS(1416),
    [anon_sym_import] = ACTIONS(10),
    [anon_sym_from] = ACTIONS(12),
    [anon_sym_LPAREN] = ACTIONS(14),
    [anon_sym_print] = ACTIONS(16),
    [anon_sym_assert] = ACTIONS(18),
    [anon_sym_return] = ACTIONS(20),
    [anon_sym_del] = ACTIONS(22),
    [anon_sym_raise] = ACTIONS(24),
    [sym_pass_statement] = ACTIONS(1418),
    [sym_break_statement] = ACTIONS(1418),
    [sym_continue_statement] = ACTIONS(1418),
    [anon_sym_global] = ACTIONS(42),
    [anon_sym_nonlocal] = ACTIONS(44),
    [anon_sym_exec] = ACTIONS(46),
    [anon_sym_not] = ACTIONS(52),
    [anon_sym_PLUS] = ACTIONS(54),
    [anon_sym_DASH] = ACTIONS(54),
    [anon_sym_TILDE] = ACTIONS(54),
    [anon_sym_lambda] = ACTIONS(56),
    [anon_sym_yield] = ACTIONS(58),
    [anon_sym_LBRACK] = ACTIONS(60),
    [sym_ellipsis] = ACTIONS(62),
    [anon_sym_LBRACE] = ACTIONS(64),
    [sym_string] = ACTIONS(66),
    [sym_integer] = ACTIONS(68),
    [sym_float] = ACTIONS(68),
    [sym_identifier] = ACTIONS(68),
    [sym_true] = ACTIONS(68),
    [sym_false] = ACTIONS(68),
    [sym_none] = ACTIONS(68),
    [anon_sym_await] = ACTIONS(70),
    [sym_comment] = ACTIONS(72),
  },
  [335] = {
    [sym__expression] = STATE(604),
    [sym__primary_expression] = STATE(96),
    [sym_not_operator] = STATE(604),
    [sym_boolean_operator] = STATE(604),
    [sym_binary_operator] = STATE(96),
    [sym_unary_operator] = STATE(96),
    [sym_comparison_operator] = STATE(604),
    [sym_lambda] = STATE(604),
    [sym_attribute] = STATE(96),
    [sym_subscript] = STATE(96),
    [sym_call] = STATE(96),
    [sym_list] = STATE(96),
    [sym_list_comprehension] = STATE(96),
    [sym_dictionary] = STATE(96),
    [sym_dictionary_comprehension] = STATE(96),
    [sym_set] = STATE(96),
    [sym_set_comprehension] = STATE(96),
    [sym_parenthesized_expression] = STATE(96),
    [sym_tuple] = STATE(96),
    [sym_generator_expression] = STATE(96),
    [sym_conditional_expression] = STATE(604),
    [sym_concatenated_string] = STATE(96),
    [sym_await] = STATE(604),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_not] = ACTIONS(160),
    [anon_sym_PLUS] = ACTIONS(162),
    [anon_sym_DASH] = ACTIONS(162),
    [anon_sym_TILDE] = ACTIONS(162),
    [anon_sym_lambda] = ACTIONS(164),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(166),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(168),
    [sym_integer] = ACTIONS(170),
    [sym_float] = ACTIONS(170),
    [sym_identifier] = ACTIONS(170),
    [sym_true] = ACTIONS(170),
    [sym_false] = ACTIONS(170),
    [sym_none] = ACTIONS(170),
    [anon_sym_await] = ACTIONS(172),
    [sym_comment] = ACTIONS(72),
  },
  [336] = {
    [sym__expression] = STATE(716),
    [sym__primary_expression] = STATE(96),
    [sym_not_operator] = STATE(716),
    [sym_boolean_operator] = STATE(716),
    [sym_binary_operator] = STATE(96),
    [sym_unary_operator] = STATE(96),
    [sym_comparison_operator] = STATE(716),
    [sym_lambda] = STATE(716),
    [sym_attribute] = STATE(96),
    [sym_subscript] = STATE(96),
    [sym_call] = STATE(96),
    [sym_list] = STATE(96),
    [sym_list_comprehension] = STATE(96),
    [sym_dictionary] = STATE(96),
    [sym_dictionary_comprehension] = STATE(96),
    [sym_set] = STATE(96),
    [sym_set_comprehension] = STATE(96),
    [sym_parenthesized_expression] = STATE(96),
    [sym_tuple] = STATE(96),
    [sym_generator_expression] = STATE(96),
    [sym_conditional_expression] = STATE(716),
    [sym_concatenated_string] = STATE(96),
    [sym_await] = STATE(716),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_not] = ACTIONS(160),
    [anon_sym_PLUS] = ACTIONS(162),
    [anon_sym_DASH] = ACTIONS(162),
    [anon_sym_TILDE] = ACTIONS(162),
    [anon_sym_lambda] = ACTIONS(164),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(166),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(168),
    [sym_integer] = ACTIONS(170),
    [sym_float] = ACTIONS(170),
    [sym_identifier] = ACTIONS(170),
    [sym_true] = ACTIONS(170),
    [sym_false] = ACTIONS(170),
    [sym_none] = ACTIONS(170),
    [anon_sym_await] = ACTIONS(172),
    [sym_comment] = ACTIONS(72),
  },
  [337] = {
    [sym__primary_expression] = STATE(717),
    [sym_binary_operator] = STATE(717),
    [sym_unary_operator] = STATE(717),
    [sym_attribute] = STATE(717),
    [sym_subscript] = STATE(717),
    [sym_call] = STATE(717),
    [sym_list] = STATE(717),
    [sym_list_comprehension] = STATE(717),
    [sym_dictionary] = STATE(717),
    [sym_dictionary_comprehension] = STATE(717),
    [sym_set] = STATE(717),
    [sym_set_comprehension] = STATE(717),
    [sym_parenthesized_expression] = STATE(717),
    [sym_tuple] = STATE(717),
    [sym_generator_expression] = STATE(717),
    [sym_concatenated_string] = STATE(717),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_PLUS] = ACTIONS(162),
    [anon_sym_DASH] = ACTIONS(162),
    [anon_sym_TILDE] = ACTIONS(162),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(1420),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(168),
    [sym_integer] = ACTIONS(1422),
    [sym_float] = ACTIONS(1422),
    [sym_identifier] = ACTIONS(1422),
    [sym_true] = ACTIONS(1422),
    [sym_false] = ACTIONS(1422),
    [sym_none] = ACTIONS(1422),
    [sym_comment] = ACTIONS(72),
  },
  [338] = {
    [sym__primary_expression] = STATE(718),
    [sym_binary_operator] = STATE(718),
    [sym_unary_operator] = STATE(718),
    [sym_attribute] = STATE(718),
    [sym_subscript] = STATE(718),
    [sym_call] = STATE(718),
    [sym_list] = STATE(718),
    [sym_list_comprehension] = STATE(718),
    [sym_dictionary] = STATE(718),
    [sym_dictionary_comprehension] = STATE(718),
    [sym_set] = STATE(718),
    [sym_set_comprehension] = STATE(718),
    [sym_parenthesized_expression] = STATE(718),
    [sym_tuple] = STATE(718),
    [sym_generator_expression] = STATE(718),
    [sym_concatenated_string] = STATE(718),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_PLUS] = ACTIONS(162),
    [anon_sym_DASH] = ACTIONS(162),
    [anon_sym_TILDE] = ACTIONS(162),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(1424),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(168),
    [sym_integer] = ACTIONS(1426),
    [sym_float] = ACTIONS(1426),
    [sym_identifier] = ACTIONS(1426),
    [sym_true] = ACTIONS(1426),
    [sym_false] = ACTIONS(1426),
    [sym_none] = ACTIONS(1426),
    [sym_comment] = ACTIONS(72),
  },
  [339] = {
    [sym__primary_expression] = STATE(719),
    [sym_binary_operator] = STATE(719),
    [sym_unary_operator] = STATE(719),
    [sym_attribute] = STATE(719),
    [sym_subscript] = STATE(719),
    [sym_call] = STATE(719),
    [sym_list] = STATE(719),
    [sym_list_comprehension] = STATE(719),
    [sym_dictionary] = STATE(719),
    [sym_dictionary_comprehension] = STATE(719),
    [sym_set] = STATE(719),
    [sym_set_comprehension] = STATE(719),
    [sym_parenthesized_expression] = STATE(719),
    [sym_tuple] = STATE(719),
    [sym_generator_expression] = STATE(719),
    [sym_concatenated_string] = STATE(719),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_PLUS] = ACTIONS(162),
    [anon_sym_DASH] = ACTIONS(162),
    [anon_sym_TILDE] = ACTIONS(162),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(1428),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(168),
    [sym_integer] = ACTIONS(1430),
    [sym_float] = ACTIONS(1430),
    [sym_identifier] = ACTIONS(1430),
    [sym_true] = ACTIONS(1430),
    [sym_false] = ACTIONS(1430),
    [sym_none] = ACTIONS(1430),
    [sym_comment] = ACTIONS(72),
  },
  [340] = {
    [anon_sym_in] = ACTIONS(1432),
    [sym_comment] = ACTIONS(72),
  },
  [341] = {
    [sym__primary_expression] = STATE(721),
    [sym_binary_operator] = STATE(721),
    [sym_unary_operator] = STATE(721),
    [sym_attribute] = STATE(721),
    [sym_subscript] = STATE(721),
    [sym_call] = STATE(721),
    [sym_list] = STATE(721),
    [sym_list_comprehension] = STATE(721),
    [sym_dictionary] = STATE(721),
    [sym_dictionary_comprehension] = STATE(721),
    [sym_set] = STATE(721),
    [sym_set_comprehension] = STATE(721),
    [sym_parenthesized_expression] = STATE(721),
    [sym_tuple] = STATE(721),
    [sym_generator_expression] = STATE(721),
    [sym_concatenated_string] = STATE(721),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_PLUS] = ACTIONS(162),
    [anon_sym_DASH] = ACTIONS(162),
    [anon_sym_TILDE] = ACTIONS(162),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(1434),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(168),
    [sym_integer] = ACTIONS(1436),
    [sym_float] = ACTIONS(1436),
    [sym_identifier] = ACTIONS(1436),
    [sym_true] = ACTIONS(1436),
    [sym_false] = ACTIONS(1436),
    [sym_none] = ACTIONS(1436),
    [sym_comment] = ACTIONS(72),
  },
  [342] = {
    [sym__primary_expression] = STATE(621),
    [sym_binary_operator] = STATE(621),
    [sym_unary_operator] = STATE(621),
    [sym_attribute] = STATE(621),
    [sym_subscript] = STATE(621),
    [sym_call] = STATE(621),
    [sym_list] = STATE(621),
    [sym_list_comprehension] = STATE(621),
    [sym_dictionary] = STATE(621),
    [sym_dictionary_comprehension] = STATE(621),
    [sym_set] = STATE(621),
    [sym_set_comprehension] = STATE(621),
    [sym_parenthesized_expression] = STATE(621),
    [sym_tuple] = STATE(621),
    [sym_generator_expression] = STATE(621),
    [sym_concatenated_string] = STATE(621),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_PLUS] = ACTIONS(162),
    [anon_sym_DASH] = ACTIONS(162),
    [anon_sym_TILDE] = ACTIONS(162),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(1233),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(168),
    [sym_integer] = ACTIONS(1235),
    [sym_float] = ACTIONS(1235),
    [sym_identifier] = ACTIONS(1235),
    [sym_true] = ACTIONS(1235),
    [sym_false] = ACTIONS(1235),
    [sym_none] = ACTIONS(1235),
    [sym_comment] = ACTIONS(72),
  },
  [343] = {
    [sym__primary_expression] = STATE(722),
    [sym_binary_operator] = STATE(722),
    [sym_unary_operator] = STATE(722),
    [sym_attribute] = STATE(722),
    [sym_subscript] = STATE(722),
    [sym_call] = STATE(722),
    [sym_list] = STATE(722),
    [sym_list_comprehension] = STATE(722),
    [sym_dictionary] = STATE(722),
    [sym_dictionary_comprehension] = STATE(722),
    [sym_set] = STATE(722),
    [sym_set_comprehension] = STATE(722),
    [sym_parenthesized_expression] = STATE(722),
    [sym_tuple] = STATE(722),
    [sym_generator_expression] = STATE(722),
    [sym_concatenated_string] = STATE(722),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_PLUS] = ACTIONS(162),
    [anon_sym_DASH] = ACTIONS(162),
    [anon_sym_TILDE] = ACTIONS(162),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(1438),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(168),
    [sym_integer] = ACTIONS(1440),
    [sym_float] = ACTIONS(1440),
    [sym_identifier] = ACTIONS(1440),
    [sym_true] = ACTIONS(1440),
    [sym_false] = ACTIONS(1440),
    [sym_none] = ACTIONS(1440),
    [sym_comment] = ACTIONS(72),
  },
  [344] = {
    [sym__primary_expression] = STATE(723),
    [sym_binary_operator] = STATE(723),
    [sym_unary_operator] = STATE(723),
    [sym_attribute] = STATE(723),
    [sym_subscript] = STATE(723),
    [sym_call] = STATE(723),
    [sym_list] = STATE(723),
    [sym_list_comprehension] = STATE(723),
    [sym_dictionary] = STATE(723),
    [sym_dictionary_comprehension] = STATE(723),
    [sym_set] = STATE(723),
    [sym_set_comprehension] = STATE(723),
    [sym_parenthesized_expression] = STATE(723),
    [sym_tuple] = STATE(723),
    [sym_generator_expression] = STATE(723),
    [sym_concatenated_string] = STATE(723),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_PLUS] = ACTIONS(162),
    [anon_sym_DASH] = ACTIONS(162),
    [anon_sym_TILDE] = ACTIONS(162),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(1442),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(168),
    [sym_integer] = ACTIONS(1444),
    [sym_float] = ACTIONS(1444),
    [sym_identifier] = ACTIONS(1444),
    [sym_true] = ACTIONS(1444),
    [sym_false] = ACTIONS(1444),
    [sym_none] = ACTIONS(1444),
    [sym_comment] = ACTIONS(72),
  },
  [345] = {
    [sym__primary_expression] = STATE(724),
    [sym_binary_operator] = STATE(724),
    [sym_unary_operator] = STATE(724),
    [sym_attribute] = STATE(724),
    [sym_subscript] = STATE(724),
    [sym_call] = STATE(724),
    [sym_list] = STATE(724),
    [sym_list_comprehension] = STATE(724),
    [sym_dictionary] = STATE(724),
    [sym_dictionary_comprehension] = STATE(724),
    [sym_set] = STATE(724),
    [sym_set_comprehension] = STATE(724),
    [sym_parenthesized_expression] = STATE(724),
    [sym_tuple] = STATE(724),
    [sym_generator_expression] = STATE(724),
    [sym_concatenated_string] = STATE(724),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_PLUS] = ACTIONS(162),
    [anon_sym_DASH] = ACTIONS(162),
    [anon_sym_TILDE] = ACTIONS(162),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(1446),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(168),
    [sym_integer] = ACTIONS(1448),
    [sym_float] = ACTIONS(1448),
    [sym_identifier] = ACTIONS(1448),
    [sym_true] = ACTIONS(1448),
    [sym_false] = ACTIONS(1448),
    [sym_none] = ACTIONS(1448),
    [sym_comment] = ACTIONS(72),
  },
  [346] = {
    [sym__primary_expression] = STATE(719),
    [sym_binary_operator] = STATE(719),
    [sym_unary_operator] = STATE(719),
    [sym_attribute] = STATE(719),
    [sym_subscript] = STATE(719),
    [sym_call] = STATE(719),
    [sym_list] = STATE(719),
    [sym_list_comprehension] = STATE(719),
    [sym_dictionary] = STATE(719),
    [sym_dictionary_comprehension] = STATE(719),
    [sym_set] = STATE(719),
    [sym_set_comprehension] = STATE(719),
    [sym_parenthesized_expression] = STATE(719),
    [sym_tuple] = STATE(719),
    [sym_generator_expression] = STATE(719),
    [sym_concatenated_string] = STATE(719),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_not] = ACTIONS(1450),
    [anon_sym_PLUS] = ACTIONS(162),
    [anon_sym_DASH] = ACTIONS(162),
    [anon_sym_TILDE] = ACTIONS(162),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(1428),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(168),
    [sym_integer] = ACTIONS(1430),
    [sym_float] = ACTIONS(1430),
    [sym_identifier] = ACTIONS(1430),
    [sym_true] = ACTIONS(1430),
    [sym_false] = ACTIONS(1430),
    [sym_none] = ACTIONS(1430),
    [sym_comment] = ACTIONS(72),
  },
  [347] = {
    [aux_sym_comparison_operator_repeat1] = STATE(725),
    [anon_sym_if] = ACTIONS(998),
    [anon_sym_COLON] = ACTIONS(998),
    [anon_sym_in] = ACTIONS(602),
    [anon_sym_not] = ACTIONS(606),
    [anon_sym_and] = ACTIONS(998),
    [anon_sym_or] = ACTIONS(998),
    [anon_sym_LT] = ACTIONS(618),
    [anon_sym_LT_EQ] = ACTIONS(602),
    [anon_sym_EQ_EQ] = ACTIONS(602),
    [anon_sym_BANG_EQ] = ACTIONS(602),
    [anon_sym_GT_EQ] = ACTIONS(602),
    [anon_sym_GT] = ACTIONS(618),
    [anon_sym_LT_GT] = ACTIONS(602),
    [anon_sym_is] = ACTIONS(620),
    [sym_comment] = ACTIONS(72),
  },
  [348] = {
    [anon_sym_in] = ACTIONS(1452),
    [sym_comment] = ACTIONS(72),
  },
  [349] = {
    [aux_sym_with_statement_repeat1] = STATE(728),
    [anon_sym_COMMA] = ACTIONS(658),
    [anon_sym_COLON] = ACTIONS(1454),
    [sym_comment] = ACTIONS(72),
  },
  [350] = {
    [sym_parameters] = STATE(729),
    [anon_sym_LPAREN] = ACTIONS(696),
    [sym_comment] = ACTIONS(72),
  },
  [351] = {
    [aux_sym_concatenated_string_repeat1] = STATE(730),
    [anon_sym_DOT] = ACTIONS(886),
    [anon_sym_LPAREN] = ACTIONS(886),
    [anon_sym_COMMA] = ACTIONS(886),
    [anon_sym_STAR] = ACTIONS(888),
    [anon_sym_GT_GT] = ACTIONS(886),
    [anon_sym_in] = ACTIONS(886),
    [anon_sym_AT] = ACTIONS(886),
    [anon_sym_PLUS] = ACTIONS(886),
    [anon_sym_DASH] = ACTIONS(886),
    [anon_sym_SLASH] = ACTIONS(888),
    [anon_sym_PERCENT] = ACTIONS(886),
    [anon_sym_SLASH_SLASH] = ACTIONS(886),
    [anon_sym_STAR_STAR] = ACTIONS(886),
    [anon_sym_PIPE] = ACTIONS(886),
    [anon_sym_AMP] = ACTIONS(886),
    [anon_sym_CARET] = ACTIONS(886),
    [anon_sym_LT_LT] = ACTIONS(886),
    [anon_sym_LBRACK] = ACTIONS(886),
    [sym_string] = ACTIONS(1456),
    [sym_comment] = ACTIONS(72),
  },
  [352] = {
    [sym_expression_list] = STATE(731),
    [sym__expression] = STATE(732),
    [sym__primary_expression] = STATE(410),
    [sym_not_operator] = STATE(732),
    [sym_boolean_operator] = STATE(732),
    [sym_binary_operator] = STATE(410),
    [sym_unary_operator] = STATE(410),
    [sym_comparison_operator] = STATE(732),
    [sym_lambda] = STATE(732),
    [sym_attribute] = STATE(410),
    [sym_subscript] = STATE(410),
    [sym_call] = STATE(410),
    [sym_list] = STATE(410),
    [sym_list_comprehension] = STATE(410),
    [sym_dictionary] = STATE(410),
    [sym_dictionary_comprehension] = STATE(410),
    [sym_set] = STATE(410),
    [sym_set_comprehension] = STATE(410),
    [sym_parenthesized_expression] = STATE(410),
    [sym_tuple] = STATE(410),
    [sym_generator_expression] = STATE(410),
    [sym_conditional_expression] = STATE(732),
    [sym_concatenated_string] = STATE(410),
    [sym_await] = STATE(732),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_not] = ACTIONS(726),
    [anon_sym_PLUS] = ACTIONS(728),
    [anon_sym_DASH] = ACTIONS(728),
    [anon_sym_TILDE] = ACTIONS(728),
    [anon_sym_lambda] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(732),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(734),
    [sym_integer] = ACTIONS(736),
    [sym_float] = ACTIONS(736),
    [sym_identifier] = ACTIONS(736),
    [sym_true] = ACTIONS(736),
    [sym_false] = ACTIONS(736),
    [sym_none] = ACTIONS(736),
    [anon_sym_await] = ACTIONS(738),
    [sym_comment] = ACTIONS(72),
  },
  [353] = {
    [sym__primary_expression] = STATE(733),
    [sym_binary_operator] = STATE(733),
    [sym_unary_operator] = STATE(733),
    [sym_attribute] = STATE(733),
    [sym_subscript] = STATE(733),
    [sym_call] = STATE(733),
    [sym_list] = STATE(733),
    [sym_list_comprehension] = STATE(733),
    [sym_dictionary] = STATE(733),
    [sym_dictionary_comprehension] = STATE(733),
    [sym_set] = STATE(733),
    [sym_set_comprehension] = STATE(733),
    [sym_parenthesized_expression] = STATE(733),
    [sym_tuple] = STATE(733),
    [sym_generator_expression] = STATE(733),
    [sym_concatenated_string] = STATE(733),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_in] = ACTIONS(1458),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_PLUS] = ACTIONS(180),
    [anon_sym_DASH] = ACTIONS(180),
    [anon_sym_TILDE] = ACTIONS(180),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(1460),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(184),
    [sym_integer] = ACTIONS(1462),
    [sym_float] = ACTIONS(1462),
    [sym_identifier] = ACTIONS(1462),
    [sym_true] = ACTIONS(1462),
    [sym_false] = ACTIONS(1462),
    [sym_none] = ACTIONS(1462),
    [sym_comment] = ACTIONS(72),
  },
  [354] = {
    [sym__primary_expression] = STATE(734),
    [sym_binary_operator] = STATE(734),
    [sym_unary_operator] = STATE(734),
    [sym_attribute] = STATE(734),
    [sym_subscript] = STATE(734),
    [sym_call] = STATE(734),
    [sym_list] = STATE(734),
    [sym_list_comprehension] = STATE(734),
    [sym_dictionary] = STATE(734),
    [sym_dictionary_comprehension] = STATE(734),
    [sym_set] = STATE(734),
    [sym_set_comprehension] = STATE(734),
    [sym_parenthesized_expression] = STATE(734),
    [sym_tuple] = STATE(734),
    [sym_generator_expression] = STATE(734),
    [sym_concatenated_string] = STATE(734),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_PLUS] = ACTIONS(180),
    [anon_sym_DASH] = ACTIONS(180),
    [anon_sym_TILDE] = ACTIONS(180),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(1464),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(184),
    [sym_integer] = ACTIONS(1466),
    [sym_float] = ACTIONS(1466),
    [sym_identifier] = ACTIONS(1466),
    [sym_true] = ACTIONS(1466),
    [sym_false] = ACTIONS(1466),
    [sym_none] = ACTIONS(1466),
    [sym_comment] = ACTIONS(72),
  },
  [355] = {
    [sym__primary_expression] = STATE(735),
    [sym_binary_operator] = STATE(735),
    [sym_unary_operator] = STATE(735),
    [sym_attribute] = STATE(735),
    [sym_subscript] = STATE(735),
    [sym_call] = STATE(735),
    [sym_list] = STATE(735),
    [sym_list_comprehension] = STATE(735),
    [sym_dictionary] = STATE(735),
    [sym_dictionary_comprehension] = STATE(735),
    [sym_set] = STATE(735),
    [sym_set_comprehension] = STATE(735),
    [sym_parenthesized_expression] = STATE(735),
    [sym_tuple] = STATE(735),
    [sym_generator_expression] = STATE(735),
    [sym_concatenated_string] = STATE(735),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_PLUS] = ACTIONS(180),
    [anon_sym_DASH] = ACTIONS(180),
    [anon_sym_TILDE] = ACTIONS(180),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(1468),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(184),
    [sym_integer] = ACTIONS(1470),
    [sym_float] = ACTIONS(1470),
    [sym_identifier] = ACTIONS(1470),
    [sym_true] = ACTIONS(1470),
    [sym_false] = ACTIONS(1470),
    [sym_none] = ACTIONS(1470),
    [sym_comment] = ACTIONS(72),
  },
  [356] = {
    [sym__primary_expression] = STATE(736),
    [sym_binary_operator] = STATE(736),
    [sym_unary_operator] = STATE(736),
    [sym_attribute] = STATE(736),
    [sym_subscript] = STATE(736),
    [sym_call] = STATE(736),
    [sym_list] = STATE(736),
    [sym_list_comprehension] = STATE(736),
    [sym_dictionary] = STATE(736),
    [sym_dictionary_comprehension] = STATE(736),
    [sym_set] = STATE(736),
    [sym_set_comprehension] = STATE(736),
    [sym_parenthesized_expression] = STATE(736),
    [sym_tuple] = STATE(736),
    [sym_generator_expression] = STATE(736),
    [sym_concatenated_string] = STATE(736),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_PLUS] = ACTIONS(180),
    [anon_sym_DASH] = ACTIONS(180),
    [anon_sym_TILDE] = ACTIONS(180),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(1472),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(184),
    [sym_integer] = ACTIONS(1474),
    [sym_float] = ACTIONS(1474),
    [sym_identifier] = ACTIONS(1474),
    [sym_true] = ACTIONS(1474),
    [sym_false] = ACTIONS(1474),
    [sym_none] = ACTIONS(1474),
    [sym_comment] = ACTIONS(72),
  },
  [357] = {
    [sym__primary_expression] = STATE(621),
    [sym_binary_operator] = STATE(621),
    [sym_unary_operator] = STATE(621),
    [sym_attribute] = STATE(621),
    [sym_subscript] = STATE(621),
    [sym_call] = STATE(621),
    [sym_list] = STATE(621),
    [sym_list_comprehension] = STATE(621),
    [sym_dictionary] = STATE(621),
    [sym_dictionary_comprehension] = STATE(621),
    [sym_set] = STATE(621),
    [sym_set_comprehension] = STATE(621),
    [sym_parenthesized_expression] = STATE(621),
    [sym_tuple] = STATE(621),
    [sym_generator_expression] = STATE(621),
    [sym_concatenated_string] = STATE(621),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_PLUS] = ACTIONS(180),
    [anon_sym_DASH] = ACTIONS(180),
    [anon_sym_TILDE] = ACTIONS(180),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(1233),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(184),
    [sym_integer] = ACTIONS(1235),
    [sym_float] = ACTIONS(1235),
    [sym_identifier] = ACTIONS(1235),
    [sym_true] = ACTIONS(1235),
    [sym_false] = ACTIONS(1235),
    [sym_none] = ACTIONS(1235),
    [sym_comment] = ACTIONS(72),
  },
  [358] = {
    [sym__primary_expression] = STATE(737),
    [sym_binary_operator] = STATE(737),
    [sym_unary_operator] = STATE(737),
    [sym_attribute] = STATE(737),
    [sym_subscript] = STATE(737),
    [sym_call] = STATE(737),
    [sym_list] = STATE(737),
    [sym_list_comprehension] = STATE(737),
    [sym_dictionary] = STATE(737),
    [sym_dictionary_comprehension] = STATE(737),
    [sym_set] = STATE(737),
    [sym_set_comprehension] = STATE(737),
    [sym_parenthesized_expression] = STATE(737),
    [sym_tuple] = STATE(737),
    [sym_generator_expression] = STATE(737),
    [sym_concatenated_string] = STATE(737),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_PLUS] = ACTIONS(180),
    [anon_sym_DASH] = ACTIONS(180),
    [anon_sym_TILDE] = ACTIONS(180),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(1476),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(184),
    [sym_integer] = ACTIONS(1478),
    [sym_float] = ACTIONS(1478),
    [sym_identifier] = ACTIONS(1478),
    [sym_true] = ACTIONS(1478),
    [sym_false] = ACTIONS(1478),
    [sym_none] = ACTIONS(1478),
    [sym_comment] = ACTIONS(72),
  },
  [359] = {
    [sym__primary_expression] = STATE(738),
    [sym_binary_operator] = STATE(738),
    [sym_unary_operator] = STATE(738),
    [sym_attribute] = STATE(738),
    [sym_subscript] = STATE(738),
    [sym_call] = STATE(738),
    [sym_list] = STATE(738),
    [sym_list_comprehension] = STATE(738),
    [sym_dictionary] = STATE(738),
    [sym_dictionary_comprehension] = STATE(738),
    [sym_set] = STATE(738),
    [sym_set_comprehension] = STATE(738),
    [sym_parenthesized_expression] = STATE(738),
    [sym_tuple] = STATE(738),
    [sym_generator_expression] = STATE(738),
    [sym_concatenated_string] = STATE(738),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_PLUS] = ACTIONS(180),
    [anon_sym_DASH] = ACTIONS(180),
    [anon_sym_TILDE] = ACTIONS(180),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(1480),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(184),
    [sym_integer] = ACTIONS(1482),
    [sym_float] = ACTIONS(1482),
    [sym_identifier] = ACTIONS(1482),
    [sym_true] = ACTIONS(1482),
    [sym_false] = ACTIONS(1482),
    [sym_none] = ACTIONS(1482),
    [sym_comment] = ACTIONS(72),
  },
  [360] = {
    [sym__primary_expression] = STATE(739),
    [sym_binary_operator] = STATE(739),
    [sym_unary_operator] = STATE(739),
    [sym_attribute] = STATE(739),
    [sym_subscript] = STATE(739),
    [sym_call] = STATE(739),
    [sym_list] = STATE(739),
    [sym_list_comprehension] = STATE(739),
    [sym_dictionary] = STATE(739),
    [sym_dictionary_comprehension] = STATE(739),
    [sym_set] = STATE(739),
    [sym_set_comprehension] = STATE(739),
    [sym_parenthesized_expression] = STATE(739),
    [sym_tuple] = STATE(739),
    [sym_generator_expression] = STATE(739),
    [sym_concatenated_string] = STATE(739),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_PLUS] = ACTIONS(180),
    [anon_sym_DASH] = ACTIONS(180),
    [anon_sym_TILDE] = ACTIONS(180),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(1484),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(184),
    [sym_integer] = ACTIONS(1486),
    [sym_float] = ACTIONS(1486),
    [sym_identifier] = ACTIONS(1486),
    [sym_true] = ACTIONS(1486),
    [sym_false] = ACTIONS(1486),
    [sym_none] = ACTIONS(1486),
    [sym_comment] = ACTIONS(72),
  },
  [361] = {
    [aux_sym_variables_repeat1] = STATE(741),
    [anon_sym_COMMA] = ACTIONS(1488),
    [anon_sym_in] = ACTIONS(1490),
    [sym_comment] = ACTIONS(72),
  },
  [362] = {
    [sym__simple_statements] = STATE(744),
    [sym_import_statement] = STATE(743),
    [sym_import_from_statement] = STATE(743),
    [sym_print_statement] = STATE(743),
    [sym_assert_statement] = STATE(743),
    [sym_expression_statement] = STATE(743),
    [sym_return_statement] = STATE(743),
    [sym_delete_statement] = STATE(743),
    [sym_raise_statement] = STATE(743),
    [sym_global_statement] = STATE(743),
    [sym_nonlocal_statement] = STATE(743),
    [sym_exec_statement] = STATE(743),
    [sym__suite] = STATE(744),
    [sym_expression_list] = STATE(32),
    [sym__expression] = STATE(33),
    [sym__primary_expression] = STATE(34),
    [sym_not_operator] = STATE(33),
    [sym_boolean_operator] = STATE(33),
    [sym_binary_operator] = STATE(34),
    [sym_unary_operator] = STATE(34),
    [sym_comparison_operator] = STATE(33),
    [sym_lambda] = STATE(33),
    [sym_assignment] = STATE(35),
    [sym_augmented_assignment] = STATE(35),
    [sym_yield] = STATE(35),
    [sym_attribute] = STATE(34),
    [sym_subscript] = STATE(34),
    [sym_call] = STATE(34),
    [sym_list] = STATE(34),
    [sym_list_comprehension] = STATE(34),
    [sym_dictionary] = STATE(34),
    [sym_dictionary_comprehension] = STATE(34),
    [sym_set] = STATE(34),
    [sym_set_comprehension] = STATE(34),
    [sym_parenthesized_expression] = STATE(34),
    [sym_tuple] = STATE(34),
    [sym_generator_expression] = STATE(34),
    [sym_conditional_expression] = STATE(33),
    [sym_concatenated_string] = STATE(34),
    [sym_await] = STATE(33),
    [sym__indent] = ACTIONS(1492),
    [anon_sym_import] = ACTIONS(10),
    [anon_sym_from] = ACTIONS(12),
    [anon_sym_LPAREN] = ACTIONS(14),
    [anon_sym_print] = ACTIONS(16),
    [anon_sym_assert] = ACTIONS(18),
    [anon_sym_return] = ACTIONS(20),
    [anon_sym_del] = ACTIONS(22),
    [anon_sym_raise] = ACTIONS(24),
    [sym_pass_statement] = ACTIONS(1494),
    [sym_break_statement] = ACTIONS(1494),
    [sym_continue_statement] = ACTIONS(1494),
    [anon_sym_global] = ACTIONS(42),
    [anon_sym_nonlocal] = ACTIONS(44),
    [anon_sym_exec] = ACTIONS(46),
    [anon_sym_not] = ACTIONS(52),
    [anon_sym_PLUS] = ACTIONS(54),
    [anon_sym_DASH] = ACTIONS(54),
    [anon_sym_TILDE] = ACTIONS(54),
    [anon_sym_lambda] = ACTIONS(56),
    [anon_sym_yield] = ACTIONS(58),
    [anon_sym_LBRACK] = ACTIONS(60),
    [sym_ellipsis] = ACTIONS(62),
    [anon_sym_LBRACE] = ACTIONS(64),
    [sym_string] = ACTIONS(66),
    [sym_integer] = ACTIONS(68),
    [sym_float] = ACTIONS(68),
    [sym_identifier] = ACTIONS(68),
    [sym_true] = ACTIONS(68),
    [sym_false] = ACTIONS(68),
    [sym_none] = ACTIONS(68),
    [anon_sym_await] = ACTIONS(70),
    [sym_comment] = ACTIONS(72),
  },
  [363] = {
    [sym__statement] = STATE(755),
    [sym__simple_statements] = STATE(755),
    [sym_import_statement] = STATE(746),
    [sym_import_from_statement] = STATE(746),
    [sym_print_statement] = STATE(746),
    [sym_assert_statement] = STATE(746),
    [sym_expression_statement] = STATE(746),
    [sym_return_statement] = STATE(746),
    [sym_delete_statement] = STATE(746),
    [sym_raise_statement] = STATE(746),
    [sym_if_statement] = STATE(755),
    [sym_for_statement] = STATE(755),
    [sym_while_statement] = STATE(755),
    [sym_try_statement] = STATE(755),
    [sym_with_statement] = STATE(755),
    [sym_function_definition] = STATE(755),
    [sym_global_statement] = STATE(746),
    [sym_nonlocal_statement] = STATE(746),
    [sym_exec_statement] = STATE(746),
    [sym_class_definition] = STATE(755),
    [sym_decorated_definition] = STATE(755),
    [sym_decorator] = STATE(756),
    [sym_expression_list] = STATE(32),
    [sym__expression] = STATE(33),
    [sym__primary_expression] = STATE(34),
    [sym_not_operator] = STATE(33),
    [sym_boolean_operator] = STATE(33),
    [sym_binary_operator] = STATE(34),
    [sym_unary_operator] = STATE(34),
    [sym_comparison_operator] = STATE(33),
    [sym_lambda] = STATE(33),
    [sym_assignment] = STATE(35),
    [sym_augmented_assignment] = STATE(35),
    [sym_yield] = STATE(35),
    [sym_attribute] = STATE(34),
    [sym_subscript] = STATE(34),
    [sym_call] = STATE(34),
    [sym_list] = STATE(34),
    [sym_list_comprehension] = STATE(34),
    [sym_dictionary] = STATE(34),
    [sym_dictionary_comprehension] = STATE(34),
    [sym_set] = STATE(34),
    [sym_set_comprehension] = STATE(34),
    [sym_parenthesized_expression] = STATE(34),
    [sym_tuple] = STATE(34),
    [sym_generator_expression] = STATE(34),
    [sym_conditional_expression] = STATE(33),
    [sym_concatenated_string] = STATE(34),
    [sym_await] = STATE(33),
    [aux_sym_module_repeat1] = STATE(755),
    [aux_sym_decorated_definition_repeat1] = STATE(756),
    [sym__dedent] = ACTIONS(1496),
    [anon_sym_import] = ACTIONS(10),
    [anon_sym_from] = ACTIONS(12),
    [anon_sym_LPAREN] = ACTIONS(14),
    [anon_sym_print] = ACTIONS(16),
    [anon_sym_assert] = ACTIONS(18),
    [anon_sym_return] = ACTIONS(20),
    [anon_sym_del] = ACTIONS(22),
    [anon_sym_raise] = ACTIONS(24),
    [sym_pass_statement] = ACTIONS(1498),
    [sym_break_statement] = ACTIONS(1498),
    [sym_continue_statement] = ACTIONS(1498),
    [anon_sym_if] = ACTIONS(1500),
    [anon_sym_async] = ACTIONS(1502),
    [anon_sym_for] = ACTIONS(1504),
    [anon_sym_while] = ACTIONS(1506),
    [anon_sym_try] = ACTIONS(1508),
    [anon_sym_with] = ACTIONS(1510),
    [anon_sym_def] = ACTIONS(1512),
    [anon_sym_global] = ACTIONS(42),
    [anon_sym_nonlocal] = ACTIONS(44),
    [anon_sym_exec] = ACTIONS(46),
    [anon_sym_class] = ACTIONS(1514),
    [anon_sym_AT] = ACTIONS(50),
    [anon_sym_not] = ACTIONS(52),
    [anon_sym_PLUS] = ACTIONS(54),
    [anon_sym_DASH] = ACTIONS(54),
    [anon_sym_TILDE] = ACTIONS(54),
    [anon_sym_lambda] = ACTIONS(56),
    [anon_sym_yield] = ACTIONS(58),
    [anon_sym_LBRACK] = ACTIONS(60),
    [sym_ellipsis] = ACTIONS(62),
    [anon_sym_LBRACE] = ACTIONS(64),
    [sym_string] = ACTIONS(66),
    [sym_integer] = ACTIONS(68),
    [sym_float] = ACTIONS(68),
    [sym_identifier] = ACTIONS(68),
    [sym_true] = ACTIONS(68),
    [sym_false] = ACTIONS(68),
    [sym_none] = ACTIONS(68),
    [anon_sym_await] = ACTIONS(70),
    [sym_comment] = ACTIONS(72),
  },
  [364] = {
    [aux_sym__simple_statements_repeat1] = STATE(759),
    [sym__newline] = ACTIONS(1516),
    [sym_comment] = ACTIONS(72),
    [sym__semicolon] = ACTIONS(1518),
  },
  [365] = {
    [sym_except_clause] = STATE(763),
    [sym_finally_clause] = STATE(762),
    [aux_sym_try_statement_repeat1] = STATE(763),
    [anon_sym_except] = ACTIONS(1520),
    [anon_sym_finally] = ACTIONS(1522),
    [sym_comment] = ACTIONS(72),
  },
  [366] = {
    [anon_sym_COMMA] = ACTIONS(716),
    [anon_sym_as] = ACTIONS(716),
    [anon_sym_if] = ACTIONS(716),
    [anon_sym_COLON] = ACTIONS(716),
    [anon_sym_and] = ACTIONS(668),
    [anon_sym_or] = ACTIONS(670),
    [sym_comment] = ACTIONS(72),
  },
  [367] = {
    [sym__expression] = STATE(764),
    [sym__primary_expression] = STATE(113),
    [sym_not_operator] = STATE(764),
    [sym_boolean_operator] = STATE(764),
    [sym_binary_operator] = STATE(113),
    [sym_unary_operator] = STATE(113),
    [sym_comparison_operator] = STATE(764),
    [sym_lambda] = STATE(764),
    [sym_attribute] = STATE(113),
    [sym_subscript] = STATE(113),
    [sym_call] = STATE(113),
    [sym_list] = STATE(113),
    [sym_list_comprehension] = STATE(113),
    [sym_dictionary] = STATE(113),
    [sym_dictionary_comprehension] = STATE(113),
    [sym_set] = STATE(113),
    [sym_set_comprehension] = STATE(113),
    [sym_parenthesized_expression] = STATE(113),
    [sym_tuple] = STATE(113),
    [sym_generator_expression] = STATE(113),
    [sym_conditional_expression] = STATE(764),
    [sym_concatenated_string] = STATE(113),
    [sym_await] = STATE(764),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_not] = ACTIONS(190),
    [anon_sym_PLUS] = ACTIONS(192),
    [anon_sym_DASH] = ACTIONS(192),
    [anon_sym_TILDE] = ACTIONS(192),
    [anon_sym_lambda] = ACTIONS(194),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(196),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(198),
    [sym_integer] = ACTIONS(200),
    [sym_float] = ACTIONS(200),
    [sym_identifier] = ACTIONS(200),
    [sym_true] = ACTIONS(200),
    [sym_false] = ACTIONS(200),
    [sym_none] = ACTIONS(200),
    [anon_sym_await] = ACTIONS(202),
    [sym_comment] = ACTIONS(72),
  },
  [368] = {
    [anon_sym_COLON] = ACTIONS(1524),
    [sym_comment] = ACTIONS(72),
  },
  [369] = {
    [aux_sym_concatenated_string_repeat1] = STATE(766),
    [anon_sym_DOT] = ACTIONS(886),
    [anon_sym_LPAREN] = ACTIONS(886),
    [anon_sym_COMMA] = ACTIONS(886),
    [anon_sym_as] = ACTIONS(886),
    [anon_sym_STAR] = ACTIONS(888),
    [anon_sym_GT_GT] = ACTIONS(886),
    [anon_sym_if] = ACTIONS(886),
    [anon_sym_COLON] = ACTIONS(886),
    [anon_sym_in] = ACTIONS(886),
    [anon_sym_AT] = ACTIONS(886),
    [anon_sym_not] = ACTIONS(886),
    [anon_sym_and] = ACTIONS(886),
    [anon_sym_or] = ACTIONS(886),
    [anon_sym_PLUS] = ACTIONS(886),
    [anon_sym_DASH] = ACTIONS(886),
    [anon_sym_SLASH] = ACTIONS(888),
    [anon_sym_PERCENT] = ACTIONS(886),
    [anon_sym_SLASH_SLASH] = ACTIONS(886),
    [anon_sym_STAR_STAR] = ACTIONS(886),
    [anon_sym_PIPE] = ACTIONS(886),
    [anon_sym_AMP] = ACTIONS(886),
    [anon_sym_CARET] = ACTIONS(886),
    [anon_sym_LT_LT] = ACTIONS(886),
    [anon_sym_LT] = ACTIONS(888),
    [anon_sym_LT_EQ] = ACTIONS(886),
    [anon_sym_EQ_EQ] = ACTIONS(886),
    [anon_sym_BANG_EQ] = ACTIONS(886),
    [anon_sym_GT_EQ] = ACTIONS(886),
    [anon_sym_GT] = ACTIONS(888),
    [anon_sym_LT_GT] = ACTIONS(886),
    [anon_sym_is] = ACTIONS(886),
    [anon_sym_LBRACK] = ACTIONS(886),
    [sym_string] = ACTIONS(1526),
    [sym_comment] = ACTIONS(72),
  },
  [370] = {
    [sym_with_item] = STATE(767),
    [sym__expression] = STATE(112),
    [sym__primary_expression] = STATE(113),
    [sym_not_operator] = STATE(112),
    [sym_boolean_operator] = STATE(112),
    [sym_binary_operator] = STATE(113),
    [sym_unary_operator] = STATE(113),
    [sym_comparison_operator] = STATE(112),
    [sym_lambda] = STATE(112),
    [sym_attribute] = STATE(113),
    [sym_subscript] = STATE(113),
    [sym_call] = STATE(113),
    [sym_list] = STATE(113),
    [sym_list_comprehension] = STATE(113),
    [sym_dictionary] = STATE(113),
    [sym_dictionary_comprehension] = STATE(113),
    [sym_set] = STATE(113),
    [sym_set_comprehension] = STATE(113),
    [sym_parenthesized_expression] = STATE(113),
    [sym_tuple] = STATE(113),
    [sym_generator_expression] = STATE(113),
    [sym_conditional_expression] = STATE(112),
    [sym_concatenated_string] = STATE(113),
    [sym_await] = STATE(112),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_not] = ACTIONS(190),
    [anon_sym_PLUS] = ACTIONS(192),
    [anon_sym_DASH] = ACTIONS(192),
    [anon_sym_TILDE] = ACTIONS(192),
    [anon_sym_lambda] = ACTIONS(194),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(196),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(198),
    [sym_integer] = ACTIONS(200),
    [sym_float] = ACTIONS(200),
    [sym_identifier] = ACTIONS(200),
    [sym_true] = ACTIONS(200),
    [sym_false] = ACTIONS(200),
    [sym_none] = ACTIONS(200),
    [anon_sym_await] = ACTIONS(202),
    [sym_comment] = ACTIONS(72),
  },
  [371] = {
    [sym__simple_statements] = STATE(769),
    [sym_import_statement] = STATE(10),
    [sym_import_from_statement] = STATE(10),
    [sym_print_statement] = STATE(10),
    [sym_assert_statement] = STATE(10),
    [sym_expression_statement] = STATE(10),
    [sym_return_statement] = STATE(10),
    [sym_delete_statement] = STATE(10),
    [sym_raise_statement] = STATE(10),
    [sym_global_statement] = STATE(10),
    [sym_nonlocal_statement] = STATE(10),
    [sym_exec_statement] = STATE(10),
    [sym__suite] = STATE(769),
    [sym_expression_list] = STATE(32),
    [sym__expression] = STATE(33),
    [sym__primary_expression] = STATE(34),
    [sym_not_operator] = STATE(33),
    [sym_boolean_operator] = STATE(33),
    [sym_binary_operator] = STATE(34),
    [sym_unary_operator] = STATE(34),
    [sym_comparison_operator] = STATE(33),
    [sym_lambda] = STATE(33),
    [sym_assignment] = STATE(35),
    [sym_augmented_assignment] = STATE(35),
    [sym_yield] = STATE(35),
    [sym_attribute] = STATE(34),
    [sym_subscript] = STATE(34),
    [sym_call] = STATE(34),
    [sym_list] = STATE(34),
    [sym_list_comprehension] = STATE(34),
    [sym_dictionary] = STATE(34),
    [sym_dictionary_comprehension] = STATE(34),
    [sym_set] = STATE(34),
    [sym_set_comprehension] = STATE(34),
    [sym_parenthesized_expression] = STATE(34),
    [sym_tuple] = STATE(34),
    [sym_generator_expression] = STATE(34),
    [sym_conditional_expression] = STATE(33),
    [sym_concatenated_string] = STATE(34),
    [sym_await] = STATE(33),
    [sym__indent] = ACTIONS(1528),
    [anon_sym_import] = ACTIONS(10),
    [anon_sym_from] = ACTIONS(12),
    [anon_sym_LPAREN] = ACTIONS(14),
    [anon_sym_print] = ACTIONS(16),
    [anon_sym_assert] = ACTIONS(18),
    [anon_sym_return] = ACTIONS(20),
    [anon_sym_del] = ACTIONS(22),
    [anon_sym_raise] = ACTIONS(24),
    [sym_pass_statement] = ACTIONS(26),
    [sym_break_statement] = ACTIONS(26),
    [sym_continue_statement] = ACTIONS(26),
    [anon_sym_global] = ACTIONS(42),
    [anon_sym_nonlocal] = ACTIONS(44),
    [anon_sym_exec] = ACTIONS(46),
    [anon_sym_not] = ACTIONS(52),
    [anon_sym_PLUS] = ACTIONS(54),
    [anon_sym_DASH] = ACTIONS(54),
    [anon_sym_TILDE] = ACTIONS(54),
    [anon_sym_lambda] = ACTIONS(56),
    [anon_sym_yield] = ACTIONS(58),
    [anon_sym_LBRACK] = ACTIONS(60),
    [sym_ellipsis] = ACTIONS(62),
    [anon_sym_LBRACE] = ACTIONS(64),
    [sym_string] = ACTIONS(66),
    [sym_integer] = ACTIONS(68),
    [sym_float] = ACTIONS(68),
    [sym_identifier] = ACTIONS(68),
    [sym_true] = ACTIONS(68),
    [sym_false] = ACTIONS(68),
    [sym_none] = ACTIONS(68),
    [anon_sym_await] = ACTIONS(70),
    [sym_comment] = ACTIONS(72),
  },
  [372] = {
    [aux_sym_with_statement_repeat1] = STATE(770),
    [anon_sym_COMMA] = ACTIONS(658),
    [anon_sym_COLON] = ACTIONS(1454),
    [sym_comment] = ACTIONS(72),
  },
  [373] = {
    [sym__expression] = STATE(771),
    [sym__primary_expression] = STATE(410),
    [sym_not_operator] = STATE(771),
    [sym_boolean_operator] = STATE(771),
    [sym_binary_operator] = STATE(410),
    [sym_unary_operator] = STATE(410),
    [sym_comparison_operator] = STATE(771),
    [sym_lambda] = STATE(771),
    [sym_attribute] = STATE(410),
    [sym_subscript] = STATE(410),
    [sym_call] = STATE(410),
    [sym_list] = STATE(410),
    [sym_list_comprehension] = STATE(410),
    [sym_dictionary] = STATE(410),
    [sym_dictionary_comprehension] = STATE(410),
    [sym_set] = STATE(410),
    [sym_set_comprehension] = STATE(410),
    [sym_parenthesized_expression] = STATE(410),
    [sym_tuple] = STATE(410),
    [sym_generator_expression] = STATE(410),
    [sym_conditional_expression] = STATE(771),
    [sym_concatenated_string] = STATE(410),
    [sym_await] = STATE(771),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_not] = ACTIONS(726),
    [anon_sym_PLUS] = ACTIONS(728),
    [anon_sym_DASH] = ACTIONS(728),
    [anon_sym_TILDE] = ACTIONS(728),
    [anon_sym_lambda] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(732),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(734),
    [sym_integer] = ACTIONS(736),
    [sym_float] = ACTIONS(736),
    [sym_identifier] = ACTIONS(736),
    [sym_true] = ACTIONS(736),
    [sym_false] = ACTIONS(736),
    [sym_none] = ACTIONS(736),
    [anon_sym_await] = ACTIONS(738),
    [sym_comment] = ACTIONS(72),
  },
  [374] = {
    [sym__expression] = STATE(772),
    [sym__primary_expression] = STATE(513),
    [sym_not_operator] = STATE(772),
    [sym_boolean_operator] = STATE(772),
    [sym_binary_operator] = STATE(513),
    [sym_unary_operator] = STATE(513),
    [sym_comparison_operator] = STATE(772),
    [sym_lambda] = STATE(772),
    [sym_attribute] = STATE(513),
    [sym_subscript] = STATE(513),
    [sym_call] = STATE(513),
    [sym_list] = STATE(513),
    [sym_list_comprehension] = STATE(513),
    [sym_dictionary] = STATE(513),
    [sym_dictionary_comprehension] = STATE(513),
    [sym_set] = STATE(513),
    [sym_set_comprehension] = STATE(513),
    [sym_parenthesized_expression] = STATE(513),
    [sym_tuple] = STATE(513),
    [sym_generator_expression] = STATE(513),
    [sym_conditional_expression] = STATE(772),
    [sym_concatenated_string] = STATE(513),
    [sym_await] = STATE(772),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_not] = ACTIONS(914),
    [anon_sym_PLUS] = ACTIONS(916),
    [anon_sym_DASH] = ACTIONS(916),
    [anon_sym_TILDE] = ACTIONS(916),
    [anon_sym_lambda] = ACTIONS(918),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(920),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(922),
    [sym_integer] = ACTIONS(924),
    [sym_float] = ACTIONS(924),
    [sym_identifier] = ACTIONS(924),
    [sym_true] = ACTIONS(924),
    [sym_false] = ACTIONS(924),
    [sym_none] = ACTIONS(924),
    [anon_sym_await] = ACTIONS(926),
    [sym_comment] = ACTIONS(72),
  },
  [375] = {
    [sym__expression] = STATE(604),
    [sym__primary_expression] = STATE(113),
    [sym_not_operator] = STATE(604),
    [sym_boolean_operator] = STATE(604),
    [sym_binary_operator] = STATE(113),
    [sym_unary_operator] = STATE(113),
    [sym_comparison_operator] = STATE(604),
    [sym_lambda] = STATE(604),
    [sym_attribute] = STATE(113),
    [sym_subscript] = STATE(113),
    [sym_call] = STATE(113),
    [sym_list] = STATE(113),
    [sym_list_comprehension] = STATE(113),
    [sym_dictionary] = STATE(113),
    [sym_dictionary_comprehension] = STATE(113),
    [sym_set] = STATE(113),
    [sym_set_comprehension] = STATE(113),
    [sym_parenthesized_expression] = STATE(113),
    [sym_tuple] = STATE(113),
    [sym_generator_expression] = STATE(113),
    [sym_conditional_expression] = STATE(604),
    [sym_concatenated_string] = STATE(113),
    [sym_await] = STATE(604),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_not] = ACTIONS(190),
    [anon_sym_PLUS] = ACTIONS(192),
    [anon_sym_DASH] = ACTIONS(192),
    [anon_sym_TILDE] = ACTIONS(192),
    [anon_sym_lambda] = ACTIONS(194),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(196),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(198),
    [sym_integer] = ACTIONS(200),
    [sym_float] = ACTIONS(200),
    [sym_identifier] = ACTIONS(200),
    [sym_true] = ACTIONS(200),
    [sym_false] = ACTIONS(200),
    [sym_none] = ACTIONS(200),
    [anon_sym_await] = ACTIONS(202),
    [sym_comment] = ACTIONS(72),
  },
  [376] = {
    [sym__expression] = STATE(773),
    [sym__primary_expression] = STATE(113),
    [sym_not_operator] = STATE(773),
    [sym_boolean_operator] = STATE(773),
    [sym_binary_operator] = STATE(113),
    [sym_unary_operator] = STATE(113),
    [sym_comparison_operator] = STATE(773),
    [sym_lambda] = STATE(773),
    [sym_attribute] = STATE(113),
    [sym_subscript] = STATE(113),
    [sym_call] = STATE(113),
    [sym_list] = STATE(113),
    [sym_list_comprehension] = STATE(113),
    [sym_dictionary] = STATE(113),
    [sym_dictionary_comprehension] = STATE(113),
    [sym_set] = STATE(113),
    [sym_set_comprehension] = STATE(113),
    [sym_parenthesized_expression] = STATE(113),
    [sym_tuple] = STATE(113),
    [sym_generator_expression] = STATE(113),
    [sym_conditional_expression] = STATE(773),
    [sym_concatenated_string] = STATE(113),
    [sym_await] = STATE(773),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_not] = ACTIONS(190),
    [anon_sym_PLUS] = ACTIONS(192),
    [anon_sym_DASH] = ACTIONS(192),
    [anon_sym_TILDE] = ACTIONS(192),
    [anon_sym_lambda] = ACTIONS(194),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(196),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(198),
    [sym_integer] = ACTIONS(200),
    [sym_float] = ACTIONS(200),
    [sym_identifier] = ACTIONS(200),
    [sym_true] = ACTIONS(200),
    [sym_false] = ACTIONS(200),
    [sym_none] = ACTIONS(200),
    [anon_sym_await] = ACTIONS(202),
    [sym_comment] = ACTIONS(72),
  },
  [377] = {
    [sym__primary_expression] = STATE(774),
    [sym_binary_operator] = STATE(774),
    [sym_unary_operator] = STATE(774),
    [sym_attribute] = STATE(774),
    [sym_subscript] = STATE(774),
    [sym_call] = STATE(774),
    [sym_list] = STATE(774),
    [sym_list_comprehension] = STATE(774),
    [sym_dictionary] = STATE(774),
    [sym_dictionary_comprehension] = STATE(774),
    [sym_set] = STATE(774),
    [sym_set_comprehension] = STATE(774),
    [sym_parenthesized_expression] = STATE(774),
    [sym_tuple] = STATE(774),
    [sym_generator_expression] = STATE(774),
    [sym_concatenated_string] = STATE(774),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_PLUS] = ACTIONS(192),
    [anon_sym_DASH] = ACTIONS(192),
    [anon_sym_TILDE] = ACTIONS(192),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(1530),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(198),
    [sym_integer] = ACTIONS(1532),
    [sym_float] = ACTIONS(1532),
    [sym_identifier] = ACTIONS(1532),
    [sym_true] = ACTIONS(1532),
    [sym_false] = ACTIONS(1532),
    [sym_none] = ACTIONS(1532),
    [sym_comment] = ACTIONS(72),
  },
  [378] = {
    [sym__primary_expression] = STATE(775),
    [sym_binary_operator] = STATE(775),
    [sym_unary_operator] = STATE(775),
    [sym_attribute] = STATE(775),
    [sym_subscript] = STATE(775),
    [sym_call] = STATE(775),
    [sym_list] = STATE(775),
    [sym_list_comprehension] = STATE(775),
    [sym_dictionary] = STATE(775),
    [sym_dictionary_comprehension] = STATE(775),
    [sym_set] = STATE(775),
    [sym_set_comprehension] = STATE(775),
    [sym_parenthesized_expression] = STATE(775),
    [sym_tuple] = STATE(775),
    [sym_generator_expression] = STATE(775),
    [sym_concatenated_string] = STATE(775),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_PLUS] = ACTIONS(192),
    [anon_sym_DASH] = ACTIONS(192),
    [anon_sym_TILDE] = ACTIONS(192),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(1534),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(198),
    [sym_integer] = ACTIONS(1536),
    [sym_float] = ACTIONS(1536),
    [sym_identifier] = ACTIONS(1536),
    [sym_true] = ACTIONS(1536),
    [sym_false] = ACTIONS(1536),
    [sym_none] = ACTIONS(1536),
    [sym_comment] = ACTIONS(72),
  },
  [379] = {
    [sym__primary_expression] = STATE(776),
    [sym_binary_operator] = STATE(776),
    [sym_unary_operator] = STATE(776),
    [sym_attribute] = STATE(776),
    [sym_subscript] = STATE(776),
    [sym_call] = STATE(776),
    [sym_list] = STATE(776),
    [sym_list_comprehension] = STATE(776),
    [sym_dictionary] = STATE(776),
    [sym_dictionary_comprehension] = STATE(776),
    [sym_set] = STATE(776),
    [sym_set_comprehension] = STATE(776),
    [sym_parenthesized_expression] = STATE(776),
    [sym_tuple] = STATE(776),
    [sym_generator_expression] = STATE(776),
    [sym_concatenated_string] = STATE(776),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_PLUS] = ACTIONS(192),
    [anon_sym_DASH] = ACTIONS(192),
    [anon_sym_TILDE] = ACTIONS(192),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(1538),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(198),
    [sym_integer] = ACTIONS(1540),
    [sym_float] = ACTIONS(1540),
    [sym_identifier] = ACTIONS(1540),
    [sym_true] = ACTIONS(1540),
    [sym_false] = ACTIONS(1540),
    [sym_none] = ACTIONS(1540),
    [sym_comment] = ACTIONS(72),
  },
  [380] = {
    [anon_sym_in] = ACTIONS(1542),
    [sym_comment] = ACTIONS(72),
  },
  [381] = {
    [sym__primary_expression] = STATE(778),
    [sym_binary_operator] = STATE(778),
    [sym_unary_operator] = STATE(778),
    [sym_attribute] = STATE(778),
    [sym_subscript] = STATE(778),
    [sym_call] = STATE(778),
    [sym_list] = STATE(778),
    [sym_list_comprehension] = STATE(778),
    [sym_dictionary] = STATE(778),
    [sym_dictionary_comprehension] = STATE(778),
    [sym_set] = STATE(778),
    [sym_set_comprehension] = STATE(778),
    [sym_parenthesized_expression] = STATE(778),
    [sym_tuple] = STATE(778),
    [sym_generator_expression] = STATE(778),
    [sym_concatenated_string] = STATE(778),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_PLUS] = ACTIONS(192),
    [anon_sym_DASH] = ACTIONS(192),
    [anon_sym_TILDE] = ACTIONS(192),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(1544),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(198),
    [sym_integer] = ACTIONS(1546),
    [sym_float] = ACTIONS(1546),
    [sym_identifier] = ACTIONS(1546),
    [sym_true] = ACTIONS(1546),
    [sym_false] = ACTIONS(1546),
    [sym_none] = ACTIONS(1546),
    [sym_comment] = ACTIONS(72),
  },
  [382] = {
    [sym__primary_expression] = STATE(621),
    [sym_binary_operator] = STATE(621),
    [sym_unary_operator] = STATE(621),
    [sym_attribute] = STATE(621),
    [sym_subscript] = STATE(621),
    [sym_call] = STATE(621),
    [sym_list] = STATE(621),
    [sym_list_comprehension] = STATE(621),
    [sym_dictionary] = STATE(621),
    [sym_dictionary_comprehension] = STATE(621),
    [sym_set] = STATE(621),
    [sym_set_comprehension] = STATE(621),
    [sym_parenthesized_expression] = STATE(621),
    [sym_tuple] = STATE(621),
    [sym_generator_expression] = STATE(621),
    [sym_concatenated_string] = STATE(621),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_PLUS] = ACTIONS(192),
    [anon_sym_DASH] = ACTIONS(192),
    [anon_sym_TILDE] = ACTIONS(192),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(1233),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(198),
    [sym_integer] = ACTIONS(1235),
    [sym_float] = ACTIONS(1235),
    [sym_identifier] = ACTIONS(1235),
    [sym_true] = ACTIONS(1235),
    [sym_false] = ACTIONS(1235),
    [sym_none] = ACTIONS(1235),
    [sym_comment] = ACTIONS(72),
  },
  [383] = {
    [sym__primary_expression] = STATE(779),
    [sym_binary_operator] = STATE(779),
    [sym_unary_operator] = STATE(779),
    [sym_attribute] = STATE(779),
    [sym_subscript] = STATE(779),
    [sym_call] = STATE(779),
    [sym_list] = STATE(779),
    [sym_list_comprehension] = STATE(779),
    [sym_dictionary] = STATE(779),
    [sym_dictionary_comprehension] = STATE(779),
    [sym_set] = STATE(779),
    [sym_set_comprehension] = STATE(779),
    [sym_parenthesized_expression] = STATE(779),
    [sym_tuple] = STATE(779),
    [sym_generator_expression] = STATE(779),
    [sym_concatenated_string] = STATE(779),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_PLUS] = ACTIONS(192),
    [anon_sym_DASH] = ACTIONS(192),
    [anon_sym_TILDE] = ACTIONS(192),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(1548),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(198),
    [sym_integer] = ACTIONS(1550),
    [sym_float] = ACTIONS(1550),
    [sym_identifier] = ACTIONS(1550),
    [sym_true] = ACTIONS(1550),
    [sym_false] = ACTIONS(1550),
    [sym_none] = ACTIONS(1550),
    [sym_comment] = ACTIONS(72),
  },
  [384] = {
    [sym__primary_expression] = STATE(780),
    [sym_binary_operator] = STATE(780),
    [sym_unary_operator] = STATE(780),
    [sym_attribute] = STATE(780),
    [sym_subscript] = STATE(780),
    [sym_call] = STATE(780),
    [sym_list] = STATE(780),
    [sym_list_comprehension] = STATE(780),
    [sym_dictionary] = STATE(780),
    [sym_dictionary_comprehension] = STATE(780),
    [sym_set] = STATE(780),
    [sym_set_comprehension] = STATE(780),
    [sym_parenthesized_expression] = STATE(780),
    [sym_tuple] = STATE(780),
    [sym_generator_expression] = STATE(780),
    [sym_concatenated_string] = STATE(780),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_PLUS] = ACTIONS(192),
    [anon_sym_DASH] = ACTIONS(192),
    [anon_sym_TILDE] = ACTIONS(192),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(1552),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(198),
    [sym_integer] = ACTIONS(1554),
    [sym_float] = ACTIONS(1554),
    [sym_identifier] = ACTIONS(1554),
    [sym_true] = ACTIONS(1554),
    [sym_false] = ACTIONS(1554),
    [sym_none] = ACTIONS(1554),
    [sym_comment] = ACTIONS(72),
  },
  [385] = {
    [sym__primary_expression] = STATE(781),
    [sym_binary_operator] = STATE(781),
    [sym_unary_operator] = STATE(781),
    [sym_attribute] = STATE(781),
    [sym_subscript] = STATE(781),
    [sym_call] = STATE(781),
    [sym_list] = STATE(781),
    [sym_list_comprehension] = STATE(781),
    [sym_dictionary] = STATE(781),
    [sym_dictionary_comprehension] = STATE(781),
    [sym_set] = STATE(781),
    [sym_set_comprehension] = STATE(781),
    [sym_parenthesized_expression] = STATE(781),
    [sym_tuple] = STATE(781),
    [sym_generator_expression] = STATE(781),
    [sym_concatenated_string] = STATE(781),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_PLUS] = ACTIONS(192),
    [anon_sym_DASH] = ACTIONS(192),
    [anon_sym_TILDE] = ACTIONS(192),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(1556),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(198),
    [sym_integer] = ACTIONS(1558),
    [sym_float] = ACTIONS(1558),
    [sym_identifier] = ACTIONS(1558),
    [sym_true] = ACTIONS(1558),
    [sym_false] = ACTIONS(1558),
    [sym_none] = ACTIONS(1558),
    [sym_comment] = ACTIONS(72),
  },
  [386] = {
    [sym__primary_expression] = STATE(776),
    [sym_binary_operator] = STATE(776),
    [sym_unary_operator] = STATE(776),
    [sym_attribute] = STATE(776),
    [sym_subscript] = STATE(776),
    [sym_call] = STATE(776),
    [sym_list] = STATE(776),
    [sym_list_comprehension] = STATE(776),
    [sym_dictionary] = STATE(776),
    [sym_dictionary_comprehension] = STATE(776),
    [sym_set] = STATE(776),
    [sym_set_comprehension] = STATE(776),
    [sym_parenthesized_expression] = STATE(776),
    [sym_tuple] = STATE(776),
    [sym_generator_expression] = STATE(776),
    [sym_concatenated_string] = STATE(776),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_not] = ACTIONS(1560),
    [anon_sym_PLUS] = ACTIONS(192),
    [anon_sym_DASH] = ACTIONS(192),
    [anon_sym_TILDE] = ACTIONS(192),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(1538),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(198),
    [sym_integer] = ACTIONS(1540),
    [sym_float] = ACTIONS(1540),
    [sym_identifier] = ACTIONS(1540),
    [sym_true] = ACTIONS(1540),
    [sym_false] = ACTIONS(1540),
    [sym_none] = ACTIONS(1540),
    [sym_comment] = ACTIONS(72),
  },
  [387] = {
    [aux_sym_comparison_operator_repeat1] = STATE(782),
    [anon_sym_COMMA] = ACTIONS(998),
    [anon_sym_as] = ACTIONS(998),
    [anon_sym_if] = ACTIONS(998),
    [anon_sym_COLON] = ACTIONS(998),
    [anon_sym_in] = ACTIONS(676),
    [anon_sym_not] = ACTIONS(680),
    [anon_sym_and] = ACTIONS(998),
    [anon_sym_or] = ACTIONS(998),
    [anon_sym_LT] = ACTIONS(692),
    [anon_sym_LT_EQ] = ACTIONS(676),
    [anon_sym_EQ_EQ] = ACTIONS(676),
    [anon_sym_BANG_EQ] = ACTIONS(676),
    [anon_sym_GT_EQ] = ACTIONS(676),
    [anon_sym_GT] = ACTIONS(692),
    [anon_sym_LT_GT] = ACTIONS(676),
    [anon_sym_is] = ACTIONS(694),
    [sym_comment] = ACTIONS(72),
  },
  [388] = {
    [sym__parameters] = STATE(787),
    [sym_default_parameter] = STATE(788),
    [sym_typed_default_parameter] = STATE(788),
    [sym_list_splat] = STATE(789),
    [sym_dictionary_splat] = STATE(789),
    [sym_typed_parameter] = STATE(788),
    [sym_tuple] = STATE(788),
    [anon_sym_LPAREN] = ACTIONS(222),
    [anon_sym_RPAREN] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1564),
    [anon_sym_print] = ACTIONS(1566),
    [anon_sym_exec] = ACTIONS(1566),
    [sym_identifier] = ACTIONS(1568),
    [sym_comment] = ACTIONS(72),
  },
  [389] = {
    [anon_sym_COLON] = ACTIONS(1570),
    [anon_sym_DASH_GT] = ACTIONS(1572),
    [sym_comment] = ACTIONS(72),
  },
  [390] = {
    [sym_identifier] = ACTIONS(1574),
    [sym_comment] = ACTIONS(72),
  },
  [391] = {
    [aux_sym_global_statement_repeat1] = STATE(793),
    [sym__newline] = ACTIONS(1576),
    [anon_sym_COMMA] = ACTIONS(700),
    [sym_comment] = ACTIONS(72),
    [sym__semicolon] = ACTIONS(1576),
  },
  [392] = {
    [aux_sym_global_statement_repeat1] = STATE(793),
    [sym__newline] = ACTIONS(1578),
    [anon_sym_COMMA] = ACTIONS(700),
    [sym_comment] = ACTIONS(72),
    [sym__semicolon] = ACTIONS(1578),
  },
  [393] = {
    [sym__expression] = STATE(794),
    [sym__primary_expression] = STATE(73),
    [sym_not_operator] = STATE(794),
    [sym_boolean_operator] = STATE(794),
    [sym_binary_operator] = STATE(73),
    [sym_unary_operator] = STATE(73),
    [sym_comparison_operator] = STATE(794),
    [sym_lambda] = STATE(794),
    [sym_attribute] = STATE(73),
    [sym_subscript] = STATE(73),
    [sym_call] = STATE(73),
    [sym_list] = STATE(73),
    [sym_list_comprehension] = STATE(73),
    [sym_dictionary] = STATE(73),
    [sym_dictionary_comprehension] = STATE(73),
    [sym_set] = STATE(73),
    [sym_set_comprehension] = STATE(73),
    [sym_parenthesized_expression] = STATE(73),
    [sym_tuple] = STATE(73),
    [sym_generator_expression] = STATE(73),
    [sym_conditional_expression] = STATE(794),
    [sym_concatenated_string] = STATE(73),
    [sym_await] = STATE(794),
    [anon_sym_LPAREN] = ACTIONS(130),
    [anon_sym_print] = ACTIONS(112),
    [anon_sym_exec] = ACTIONS(112),
    [anon_sym_not] = ACTIONS(132),
    [anon_sym_PLUS] = ACTIONS(116),
    [anon_sym_DASH] = ACTIONS(116),
    [anon_sym_TILDE] = ACTIONS(116),
    [anon_sym_lambda] = ACTIONS(118),
    [anon_sym_LBRACK] = ACTIONS(134),
    [sym_ellipsis] = ACTIONS(120),
    [anon_sym_LBRACE] = ACTIONS(122),
    [sym_string] = ACTIONS(124),
    [sym_integer] = ACTIONS(126),
    [sym_float] = ACTIONS(126),
    [sym_identifier] = ACTIONS(126),
    [sym_true] = ACTIONS(126),
    [sym_false] = ACTIONS(126),
    [sym_none] = ACTIONS(126),
    [anon_sym_await] = ACTIONS(128),
    [sym_comment] = ACTIONS(72),
  },
  [394] = {
    [sym_list_splat] = STATE(614),
    [sym_dictionary_splat] = STATE(614),
    [sym__expression] = STATE(795),
    [sym__primary_expression] = STATE(215),
    [sym_not_operator] = STATE(795),
    [sym_boolean_operator] = STATE(795),
    [sym_binary_operator] = STATE(215),
    [sym_unary_operator] = STATE(215),
    [sym_comparison_operator] = STATE(795),
    [sym_lambda] = STATE(795),
    [sym_attribute] = STATE(215),
    [sym_subscript] = STATE(215),
    [sym_call] = STATE(215),
    [sym_keyword_argument] = STATE(614),
    [sym_list] = STATE(215),
    [sym_list_comprehension] = STATE(215),
    [sym_dictionary] = STATE(215),
    [sym_dictionary_comprehension] = STATE(215),
    [sym_set] = STATE(215),
    [sym_set_comprehension] = STATE(215),
    [sym_parenthesized_expression] = STATE(215),
    [sym_tuple] = STATE(215),
    [sym_generator_expression] = STATE(215),
    [sym_conditional_expression] = STATE(795),
    [sym_concatenated_string] = STATE(215),
    [sym_await] = STATE(795),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_RPAREN] = ACTIONS(1211),
    [anon_sym_COMMA] = ACTIONS(1213),
    [anon_sym_STAR] = ACTIONS(936),
    [anon_sym_print] = ACTIONS(938),
    [anon_sym_exec] = ACTIONS(938),
    [anon_sym_not] = ACTIONS(384),
    [anon_sym_PLUS] = ACTIONS(386),
    [anon_sym_DASH] = ACTIONS(386),
    [anon_sym_TILDE] = ACTIONS(386),
    [anon_sym_lambda] = ACTIONS(388),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(390),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(392),
    [sym_integer] = ACTIONS(394),
    [sym_float] = ACTIONS(394),
    [sym_identifier] = ACTIONS(940),
    [sym_true] = ACTIONS(394),
    [sym_false] = ACTIONS(394),
    [sym_none] = ACTIONS(394),
    [anon_sym_await] = ACTIONS(396),
    [sym_comment] = ACTIONS(72),
  },
  [395] = {
    [sym__simple_statements] = STATE(796),
    [sym_import_statement] = STATE(10),
    [sym_import_from_statement] = STATE(10),
    [sym_print_statement] = STATE(10),
    [sym_assert_statement] = STATE(10),
    [sym_expression_statement] = STATE(10),
    [sym_return_statement] = STATE(10),
    [sym_delete_statement] = STATE(10),
    [sym_raise_statement] = STATE(10),
    [sym_global_statement] = STATE(10),
    [sym_nonlocal_statement] = STATE(10),
    [sym_exec_statement] = STATE(10),
    [sym__suite] = STATE(796),
    [sym_expression_list] = STATE(32),
    [sym__expression] = STATE(33),
    [sym__primary_expression] = STATE(34),
    [sym_not_operator] = STATE(33),
    [sym_boolean_operator] = STATE(33),
    [sym_binary_operator] = STATE(34),
    [sym_unary_operator] = STATE(34),
    [sym_comparison_operator] = STATE(33),
    [sym_lambda] = STATE(33),
    [sym_assignment] = STATE(35),
    [sym_augmented_assignment] = STATE(35),
    [sym_yield] = STATE(35),
    [sym_attribute] = STATE(34),
    [sym_subscript] = STATE(34),
    [sym_call] = STATE(34),
    [sym_list] = STATE(34),
    [sym_list_comprehension] = STATE(34),
    [sym_dictionary] = STATE(34),
    [sym_dictionary_comprehension] = STATE(34),
    [sym_set] = STATE(34),
    [sym_set_comprehension] = STATE(34),
    [sym_parenthesized_expression] = STATE(34),
    [sym_tuple] = STATE(34),
    [sym_generator_expression] = STATE(34),
    [sym_conditional_expression] = STATE(33),
    [sym_concatenated_string] = STATE(34),
    [sym_await] = STATE(33),
    [sym__indent] = ACTIONS(1528),
    [anon_sym_import] = ACTIONS(10),
    [anon_sym_from] = ACTIONS(12),
    [anon_sym_LPAREN] = ACTIONS(14),
    [anon_sym_print] = ACTIONS(16),
    [anon_sym_assert] = ACTIONS(18),
    [anon_sym_return] = ACTIONS(20),
    [anon_sym_del] = ACTIONS(22),
    [anon_sym_raise] = ACTIONS(24),
    [sym_pass_statement] = ACTIONS(26),
    [sym_break_statement] = ACTIONS(26),
    [sym_continue_statement] = ACTIONS(26),
    [anon_sym_global] = ACTIONS(42),
    [anon_sym_nonlocal] = ACTIONS(44),
    [anon_sym_exec] = ACTIONS(46),
    [anon_sym_not] = ACTIONS(52),
    [anon_sym_PLUS] = ACTIONS(54),
    [anon_sym_DASH] = ACTIONS(54),
    [anon_sym_TILDE] = ACTIONS(54),
    [anon_sym_lambda] = ACTIONS(56),
    [anon_sym_yield] = ACTIONS(58),
    [anon_sym_LBRACK] = ACTIONS(60),
    [sym_ellipsis] = ACTIONS(62),
    [anon_sym_LBRACE] = ACTIONS(64),
    [sym_string] = ACTIONS(66),
    [sym_integer] = ACTIONS(68),
    [sym_float] = ACTIONS(68),
    [sym_identifier] = ACTIONS(68),
    [sym_true] = ACTIONS(68),
    [sym_false] = ACTIONS(68),
    [sym_none] = ACTIONS(68),
    [anon_sym_await] = ACTIONS(70),
    [sym_comment] = ACTIONS(72),
  },
  [396] = {
    [anon_sym_COLON] = ACTIONS(1580),
    [sym_comment] = ACTIONS(72),
  },
  [397] = {
    [aux_sym_dotted_name_repeat1] = STATE(798),
    [sym__newline] = ACTIONS(1108),
    [anon_sym_DOT] = ACTIONS(344),
    [anon_sym_LPAREN] = ACTIONS(1108),
    [sym_comment] = ACTIONS(72),
  },
  [398] = {
    [anon_sym_async] = ACTIONS(1582),
    [anon_sym_def] = ACTIONS(1582),
    [anon_sym_class] = ACTIONS(1582),
    [anon_sym_AT] = ACTIONS(1582),
    [sym_comment] = ACTIONS(72),
  },
  [399] = {
    [sym_list_splat] = STATE(524),
    [sym_dictionary_splat] = STATE(524),
    [sym__expression] = STATE(799),
    [sym__primary_expression] = STATE(215),
    [sym_not_operator] = STATE(799),
    [sym_boolean_operator] = STATE(799),
    [sym_binary_operator] = STATE(215),
    [sym_unary_operator] = STATE(215),
    [sym_comparison_operator] = STATE(799),
    [sym_lambda] = STATE(799),
    [sym_attribute] = STATE(215),
    [sym_subscript] = STATE(215),
    [sym_call] = STATE(215),
    [sym_keyword_argument] = STATE(524),
    [sym_list] = STATE(215),
    [sym_list_comprehension] = STATE(215),
    [sym_dictionary] = STATE(215),
    [sym_dictionary_comprehension] = STATE(215),
    [sym_set] = STATE(215),
    [sym_set_comprehension] = STATE(215),
    [sym_parenthesized_expression] = STATE(215),
    [sym_tuple] = STATE(215),
    [sym_generator_expression] = STATE(215),
    [sym_conditional_expression] = STATE(799),
    [sym_concatenated_string] = STATE(215),
    [sym_await] = STATE(799),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_RPAREN] = ACTIONS(932),
    [anon_sym_COMMA] = ACTIONS(934),
    [anon_sym_STAR] = ACTIONS(936),
    [anon_sym_print] = ACTIONS(938),
    [anon_sym_exec] = ACTIONS(938),
    [anon_sym_not] = ACTIONS(384),
    [anon_sym_PLUS] = ACTIONS(386),
    [anon_sym_DASH] = ACTIONS(386),
    [anon_sym_TILDE] = ACTIONS(386),
    [anon_sym_lambda] = ACTIONS(388),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(390),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(392),
    [sym_integer] = ACTIONS(394),
    [sym_float] = ACTIONS(394),
    [sym_identifier] = ACTIONS(940),
    [sym_true] = ACTIONS(394),
    [sym_false] = ACTIONS(394),
    [sym_none] = ACTIONS(394),
    [anon_sym_await] = ACTIONS(396),
    [sym_comment] = ACTIONS(72),
  },
  [400] = {
    [sym__newline] = ACTIONS(1584),
    [sym_comment] = ACTIONS(72),
  },
  [401] = {
    [aux_sym_tuple_repeat1] = STATE(561),
    [anon_sym_RPAREN] = ACTIONS(1129),
    [anon_sym_COMMA] = ACTIONS(1133),
    [anon_sym_if] = ACTIONS(1147),
    [anon_sym_and] = ACTIONS(1149),
    [anon_sym_or] = ACTIONS(1151),
    [sym_comment] = ACTIONS(72),
  },
  [402] = {
    [aux_sym_tuple_repeat1] = STATE(561),
    [anon_sym_RPAREN] = ACTIONS(1129),
    [anon_sym_COMMA] = ACTIONS(1133),
    [sym_comment] = ACTIONS(72),
  },
  [403] = {
    [sym__expression] = STATE(801),
    [sym__primary_expression] = STATE(410),
    [sym_not_operator] = STATE(801),
    [sym_boolean_operator] = STATE(801),
    [sym_binary_operator] = STATE(410),
    [sym_unary_operator] = STATE(410),
    [sym_comparison_operator] = STATE(801),
    [sym_lambda] = STATE(801),
    [sym_attribute] = STATE(410),
    [sym_subscript] = STATE(410),
    [sym_call] = STATE(410),
    [sym_list] = STATE(410),
    [sym_list_comprehension] = STATE(410),
    [sym_dictionary] = STATE(410),
    [sym_dictionary_comprehension] = STATE(410),
    [sym_set] = STATE(410),
    [sym_set_comprehension] = STATE(410),
    [sym_parenthesized_expression] = STATE(410),
    [sym_tuple] = STATE(410),
    [sym_generator_expression] = STATE(410),
    [sym_conditional_expression] = STATE(801),
    [sym_concatenated_string] = STATE(410),
    [sym_await] = STATE(801),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_not] = ACTIONS(726),
    [anon_sym_PLUS] = ACTIONS(728),
    [anon_sym_DASH] = ACTIONS(728),
    [anon_sym_TILDE] = ACTIONS(728),
    [anon_sym_lambda] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(732),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(734),
    [sym_integer] = ACTIONS(736),
    [sym_float] = ACTIONS(736),
    [sym_identifier] = ACTIONS(736),
    [sym_true] = ACTIONS(736),
    [sym_false] = ACTIONS(736),
    [sym_none] = ACTIONS(736),
    [anon_sym_await] = ACTIONS(738),
    [sym_comment] = ACTIONS(72),
  },
  [404] = {
    [sym__expression] = STATE(802),
    [sym__primary_expression] = STATE(410),
    [sym_not_operator] = STATE(802),
    [sym_boolean_operator] = STATE(802),
    [sym_binary_operator] = STATE(410),
    [sym_unary_operator] = STATE(410),
    [sym_comparison_operator] = STATE(802),
    [sym_lambda] = STATE(802),
    [sym_attribute] = STATE(410),
    [sym_subscript] = STATE(410),
    [sym_call] = STATE(410),
    [sym_list] = STATE(410),
    [sym_list_comprehension] = STATE(410),
    [sym_dictionary] = STATE(410),
    [sym_dictionary_comprehension] = STATE(410),
    [sym_set] = STATE(410),
    [sym_set_comprehension] = STATE(410),
    [sym_parenthesized_expression] = STATE(410),
    [sym_tuple] = STATE(410),
    [sym_generator_expression] = STATE(410),
    [sym_conditional_expression] = STATE(802),
    [sym_concatenated_string] = STATE(410),
    [sym_await] = STATE(802),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_not] = ACTIONS(726),
    [anon_sym_PLUS] = ACTIONS(728),
    [anon_sym_DASH] = ACTIONS(728),
    [anon_sym_TILDE] = ACTIONS(728),
    [anon_sym_lambda] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(732),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(734),
    [sym_integer] = ACTIONS(736),
    [sym_float] = ACTIONS(736),
    [sym_identifier] = ACTIONS(736),
    [sym_true] = ACTIONS(736),
    [sym_false] = ACTIONS(736),
    [sym_none] = ACTIONS(736),
    [anon_sym_await] = ACTIONS(738),
    [sym_comment] = ACTIONS(72),
  },
  [405] = {
    [sym__primary_expression] = STATE(204),
    [sym_binary_operator] = STATE(204),
    [sym_unary_operator] = STATE(204),
    [sym_attribute] = STATE(204),
    [sym_subscript] = STATE(204),
    [sym_call] = STATE(204),
    [sym_list] = STATE(204),
    [sym_list_comprehension] = STATE(204),
    [sym_dictionary] = STATE(204),
    [sym_dictionary_comprehension] = STATE(204),
    [sym_set] = STATE(204),
    [sym_set_comprehension] = STATE(204),
    [sym_parenthesized_expression] = STATE(204),
    [sym_tuple] = STATE(204),
    [sym_generator_expression] = STATE(204),
    [sym_concatenated_string] = STATE(204),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_PLUS] = ACTIONS(728),
    [anon_sym_DASH] = ACTIONS(728),
    [anon_sym_TILDE] = ACTIONS(728),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(376),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(734),
    [sym_integer] = ACTIONS(378),
    [sym_float] = ACTIONS(378),
    [sym_identifier] = ACTIONS(378),
    [sym_true] = ACTIONS(378),
    [sym_false] = ACTIONS(378),
    [sym_none] = ACTIONS(378),
    [sym_comment] = ACTIONS(72),
  },
  [406] = {
    [sym_lambda_parameters] = STATE(804),
    [sym__parameters] = STATE(130),
    [sym_default_parameter] = STATE(131),
    [sym_typed_default_parameter] = STATE(131),
    [sym_list_splat] = STATE(132),
    [sym_dictionary_splat] = STATE(132),
    [sym_typed_parameter] = STATE(131),
    [sym_tuple] = STATE(131),
    [anon_sym_LPAREN] = ACTIONS(222),
    [anon_sym_STAR] = ACTIONS(224),
    [anon_sym_print] = ACTIONS(226),
    [anon_sym_COLON] = ACTIONS(1586),
    [anon_sym_exec] = ACTIONS(226),
    [sym_identifier] = ACTIONS(230),
    [sym_comment] = ACTIONS(72),
  },
  [407] = {
    [aux_sym_concatenated_string_repeat1] = STATE(805),
    [anon_sym_DOT] = ACTIONS(276),
    [anon_sym_LPAREN] = ACTIONS(276),
    [anon_sym_COMMA] = ACTIONS(276),
    [anon_sym_STAR] = ACTIONS(278),
    [anon_sym_GT_GT] = ACTIONS(276),
    [anon_sym_if] = ACTIONS(276),
    [anon_sym_COLON] = ACTIONS(276),
    [anon_sym_in] = ACTIONS(276),
    [anon_sym_AT] = ACTIONS(276),
    [anon_sym_not] = ACTIONS(276),
    [anon_sym_and] = ACTIONS(276),
    [anon_sym_or] = ACTIONS(276),
    [anon_sym_PLUS] = ACTIONS(276),
    [anon_sym_DASH] = ACTIONS(276),
    [anon_sym_SLASH] = ACTIONS(278),
    [anon_sym_PERCENT] = ACTIONS(276),
    [anon_sym_SLASH_SLASH] = ACTIONS(276),
    [anon_sym_STAR_STAR] = ACTIONS(276),
    [anon_sym_PIPE] = ACTIONS(276),
    [anon_sym_AMP] = ACTIONS(276),
    [anon_sym_CARET] = ACTIONS(276),
    [anon_sym_LT_LT] = ACTIONS(276),
    [anon_sym_LT] = ACTIONS(278),
    [anon_sym_LT_EQ] = ACTIONS(276),
    [anon_sym_EQ_EQ] = ACTIONS(276),
    [anon_sym_BANG_EQ] = ACTIONS(276),
    [anon_sym_GT_EQ] = ACTIONS(276),
    [anon_sym_GT] = ACTIONS(278),
    [anon_sym_LT_GT] = ACTIONS(276),
    [anon_sym_is] = ACTIONS(276),
    [anon_sym_LBRACK] = ACTIONS(276),
    [sym_string] = ACTIONS(1588),
    [sym_comment] = ACTIONS(72),
  },
  [408] = {
    [sym__expression] = STATE(227),
    [sym__primary_expression] = STATE(410),
    [sym_not_operator] = STATE(227),
    [sym_boolean_operator] = STATE(227),
    [sym_binary_operator] = STATE(410),
    [sym_unary_operator] = STATE(410),
    [sym_comparison_operator] = STATE(227),
    [sym_lambda] = STATE(227),
    [sym_attribute] = STATE(410),
    [sym_subscript] = STATE(410),
    [sym_call] = STATE(410),
    [sym_list] = STATE(410),
    [sym_list_comprehension] = STATE(410),
    [sym_dictionary] = STATE(410),
    [sym_dictionary_comprehension] = STATE(410),
    [sym_set] = STATE(410),
    [sym_set_comprehension] = STATE(410),
    [sym_parenthesized_expression] = STATE(410),
    [sym_tuple] = STATE(410),
    [sym_generator_expression] = STATE(410),
    [sym_conditional_expression] = STATE(227),
    [sym_concatenated_string] = STATE(410),
    [sym_await] = STATE(227),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_not] = ACTIONS(726),
    [anon_sym_PLUS] = ACTIONS(728),
    [anon_sym_DASH] = ACTIONS(728),
    [anon_sym_TILDE] = ACTIONS(728),
    [anon_sym_lambda] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(732),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(734),
    [sym_integer] = ACTIONS(736),
    [sym_float] = ACTIONS(736),
    [sym_identifier] = ACTIONS(736),
    [sym_true] = ACTIONS(736),
    [sym_false] = ACTIONS(736),
    [sym_none] = ACTIONS(736),
    [anon_sym_await] = ACTIONS(738),
    [sym_comment] = ACTIONS(72),
  },
  [409] = {
    [anon_sym_COMMA] = ACTIONS(1590),
    [anon_sym_if] = ACTIONS(1592),
    [anon_sym_COLON] = ACTIONS(1590),
    [anon_sym_and] = ACTIONS(1594),
    [anon_sym_or] = ACTIONS(1596),
    [sym_comment] = ACTIONS(72),
  },
  [410] = {
    [sym_argument_list] = STATE(251),
    [sym_generator_expression] = STATE(251),
    [aux_sym_comparison_operator_repeat1] = STATE(819),
    [anon_sym_DOT] = ACTIONS(422),
    [anon_sym_LPAREN] = ACTIONS(424),
    [anon_sym_COMMA] = ACTIONS(302),
    [anon_sym_STAR] = ACTIONS(1598),
    [anon_sym_GT_GT] = ACTIONS(1600),
    [anon_sym_if] = ACTIONS(302),
    [anon_sym_COLON] = ACTIONS(302),
    [anon_sym_in] = ACTIONS(1602),
    [anon_sym_AT] = ACTIONS(1604),
    [anon_sym_not] = ACTIONS(1606),
    [anon_sym_and] = ACTIONS(302),
    [anon_sym_or] = ACTIONS(302),
    [anon_sym_PLUS] = ACTIONS(1608),
    [anon_sym_DASH] = ACTIONS(1608),
    [anon_sym_SLASH] = ACTIONS(1598),
    [anon_sym_PERCENT] = ACTIONS(1604),
    [anon_sym_SLASH_SLASH] = ACTIONS(1604),
    [anon_sym_STAR_STAR] = ACTIONS(1610),
    [anon_sym_PIPE] = ACTIONS(1612),
    [anon_sym_AMP] = ACTIONS(1614),
    [anon_sym_CARET] = ACTIONS(1616),
    [anon_sym_LT_LT] = ACTIONS(1600),
    [anon_sym_LT] = ACTIONS(1618),
    [anon_sym_LT_EQ] = ACTIONS(1602),
    [anon_sym_EQ_EQ] = ACTIONS(1602),
    [anon_sym_BANG_EQ] = ACTIONS(1602),
    [anon_sym_GT_EQ] = ACTIONS(1602),
    [anon_sym_GT] = ACTIONS(1618),
    [anon_sym_LT_GT] = ACTIONS(1602),
    [anon_sym_is] = ACTIONS(1620),
    [anon_sym_LBRACK] = ACTIONS(450),
    [sym_comment] = ACTIONS(72),
  },
  [411] = {
    [sym_default_parameter] = STATE(822),
    [sym_typed_default_parameter] = STATE(822),
    [sym_list_splat] = STATE(823),
    [sym_dictionary_splat] = STATE(823),
    [sym_typed_parameter] = STATE(822),
    [sym_tuple] = STATE(822),
    [anon_sym_LPAREN] = ACTIONS(222),
    [anon_sym_STAR] = ACTIONS(224),
    [anon_sym_print] = ACTIONS(1622),
    [anon_sym_COLON] = ACTIONS(1624),
    [anon_sym_exec] = ACTIONS(1622),
    [sym_identifier] = ACTIONS(1626),
    [sym_comment] = ACTIONS(72),
  },
  [412] = {
    [sym__expression] = STATE(829),
    [sym__primary_expression] = STATE(830),
    [sym_not_operator] = STATE(829),
    [sym_boolean_operator] = STATE(829),
    [sym_binary_operator] = STATE(830),
    [sym_unary_operator] = STATE(830),
    [sym_comparison_operator] = STATE(829),
    [sym_lambda] = STATE(829),
    [sym_attribute] = STATE(830),
    [sym_subscript] = STATE(830),
    [sym_call] = STATE(830),
    [sym_type] = STATE(831),
    [sym_list] = STATE(830),
    [sym_list_comprehension] = STATE(830),
    [sym_dictionary] = STATE(830),
    [sym_dictionary_comprehension] = STATE(830),
    [sym_set] = STATE(830),
    [sym_set_comprehension] = STATE(830),
    [sym_parenthesized_expression] = STATE(830),
    [sym_tuple] = STATE(830),
    [sym_generator_expression] = STATE(830),
    [sym_conditional_expression] = STATE(829),
    [sym_concatenated_string] = STATE(830),
    [sym_await] = STATE(829),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_not] = ACTIONS(1628),
    [anon_sym_PLUS] = ACTIONS(1630),
    [anon_sym_DASH] = ACTIONS(1630),
    [anon_sym_TILDE] = ACTIONS(1630),
    [anon_sym_lambda] = ACTIONS(1632),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(1634),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(1636),
    [sym_integer] = ACTIONS(1638),
    [sym_float] = ACTIONS(1638),
    [sym_identifier] = ACTIONS(1638),
    [sym_true] = ACTIONS(1638),
    [sym_false] = ACTIONS(1638),
    [sym_none] = ACTIONS(1638),
    [anon_sym_await] = ACTIONS(1640),
    [sym_comment] = ACTIONS(72),
  },
  [413] = {
    [sym__expression] = STATE(832),
    [sym__primary_expression] = STATE(410),
    [sym_not_operator] = STATE(832),
    [sym_boolean_operator] = STATE(832),
    [sym_binary_operator] = STATE(410),
    [sym_unary_operator] = STATE(410),
    [sym_comparison_operator] = STATE(832),
    [sym_lambda] = STATE(832),
    [sym_attribute] = STATE(410),
    [sym_subscript] = STATE(410),
    [sym_call] = STATE(410),
    [sym_list] = STATE(410),
    [sym_list_comprehension] = STATE(410),
    [sym_dictionary] = STATE(410),
    [sym_dictionary_comprehension] = STATE(410),
    [sym_set] = STATE(410),
    [sym_set_comprehension] = STATE(410),
    [sym_parenthesized_expression] = STATE(410),
    [sym_tuple] = STATE(410),
    [sym_generator_expression] = STATE(410),
    [sym_conditional_expression] = STATE(832),
    [sym_concatenated_string] = STATE(410),
    [sym_await] = STATE(832),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_not] = ACTIONS(726),
    [anon_sym_PLUS] = ACTIONS(728),
    [anon_sym_DASH] = ACTIONS(728),
    [anon_sym_TILDE] = ACTIONS(728),
    [anon_sym_lambda] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(732),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(734),
    [sym_integer] = ACTIONS(736),
    [sym_float] = ACTIONS(736),
    [sym_identifier] = ACTIONS(736),
    [sym_true] = ACTIONS(736),
    [sym_false] = ACTIONS(736),
    [sym_none] = ACTIONS(736),
    [anon_sym_await] = ACTIONS(738),
    [sym_comment] = ACTIONS(72),
  },
  [414] = {
    [aux_sym__parameters_repeat1] = STATE(834),
    [anon_sym_COMMA] = ACTIONS(1642),
    [anon_sym_COLON] = ACTIONS(1624),
    [sym_comment] = ACTIONS(72),
  },
  [415] = {
    [sym__newline] = ACTIONS(1644),
    [anon_sym_COMMA] = ACTIONS(1644),
    [anon_sym_if] = ACTIONS(294),
    [anon_sym_COLON] = ACTIONS(1644),
    [anon_sym_EQ] = ACTIONS(1644),
    [anon_sym_and] = ACTIONS(298),
    [anon_sym_or] = ACTIONS(300),
    [anon_sym_PLUS_EQ] = ACTIONS(1644),
    [anon_sym_DASH_EQ] = ACTIONS(1644),
    [anon_sym_STAR_EQ] = ACTIONS(1644),
    [anon_sym_SLASH_EQ] = ACTIONS(1644),
    [anon_sym_AT_EQ] = ACTIONS(1644),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(1644),
    [anon_sym_PERCENT_EQ] = ACTIONS(1644),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1644),
    [anon_sym_GT_GT_EQ] = ACTIONS(1644),
    [anon_sym_LT_LT_EQ] = ACTIONS(1644),
    [anon_sym_AMP_EQ] = ACTIONS(1644),
    [anon_sym_CARET_EQ] = ACTIONS(1644),
    [anon_sym_PIPE_EQ] = ACTIONS(1644),
    [sym_comment] = ACTIONS(72),
    [sym__semicolon] = ACTIONS(1644),
  },
  [416] = {
    [sym_default_parameter] = STATE(822),
    [sym_typed_default_parameter] = STATE(822),
    [sym_list_splat] = STATE(823),
    [sym_dictionary_splat] = STATE(823),
    [sym_typed_parameter] = STATE(822),
    [sym_tuple] = STATE(822),
    [anon_sym_LPAREN] = ACTIONS(222),
    [anon_sym_STAR] = ACTIONS(224),
    [anon_sym_print] = ACTIONS(1622),
    [anon_sym_COLON] = ACTIONS(1646),
    [anon_sym_exec] = ACTIONS(1622),
    [sym_identifier] = ACTIONS(1626),
    [sym_comment] = ACTIONS(72),
  },
  [417] = {
    [sym__expression] = STATE(840),
    [sym__primary_expression] = STATE(841),
    [sym_not_operator] = STATE(840),
    [sym_boolean_operator] = STATE(840),
    [sym_binary_operator] = STATE(841),
    [sym_unary_operator] = STATE(841),
    [sym_comparison_operator] = STATE(840),
    [sym_lambda] = STATE(840),
    [sym_attribute] = STATE(841),
    [sym_subscript] = STATE(841),
    [sym_call] = STATE(841),
    [sym_type] = STATE(842),
    [sym_list] = STATE(841),
    [sym_list_comprehension] = STATE(841),
    [sym_dictionary] = STATE(841),
    [sym_dictionary_comprehension] = STATE(841),
    [sym_set] = STATE(841),
    [sym_set_comprehension] = STATE(841),
    [sym_parenthesized_expression] = STATE(841),
    [sym_tuple] = STATE(841),
    [sym_generator_expression] = STATE(841),
    [sym_conditional_expression] = STATE(840),
    [sym_concatenated_string] = STATE(841),
    [sym_await] = STATE(840),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_not] = ACTIONS(1648),
    [anon_sym_PLUS] = ACTIONS(1650),
    [anon_sym_DASH] = ACTIONS(1650),
    [anon_sym_TILDE] = ACTIONS(1650),
    [anon_sym_lambda] = ACTIONS(1652),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(1654),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(1656),
    [sym_integer] = ACTIONS(1658),
    [sym_float] = ACTIONS(1658),
    [sym_identifier] = ACTIONS(1658),
    [sym_true] = ACTIONS(1658),
    [sym_false] = ACTIONS(1658),
    [sym_none] = ACTIONS(1658),
    [anon_sym_await] = ACTIONS(1660),
    [sym_comment] = ACTIONS(72),
  },
  [418] = {
    [sym__expression] = STATE(843),
    [sym__primary_expression] = STATE(410),
    [sym_not_operator] = STATE(843),
    [sym_boolean_operator] = STATE(843),
    [sym_binary_operator] = STATE(410),
    [sym_unary_operator] = STATE(410),
    [sym_comparison_operator] = STATE(843),
    [sym_lambda] = STATE(843),
    [sym_attribute] = STATE(410),
    [sym_subscript] = STATE(410),
    [sym_call] = STATE(410),
    [sym_list] = STATE(410),
    [sym_list_comprehension] = STATE(410),
    [sym_dictionary] = STATE(410),
    [sym_dictionary_comprehension] = STATE(410),
    [sym_set] = STATE(410),
    [sym_set_comprehension] = STATE(410),
    [sym_parenthesized_expression] = STATE(410),
    [sym_tuple] = STATE(410),
    [sym_generator_expression] = STATE(410),
    [sym_conditional_expression] = STATE(843),
    [sym_concatenated_string] = STATE(410),
    [sym_await] = STATE(843),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_not] = ACTIONS(726),
    [anon_sym_PLUS] = ACTIONS(728),
    [anon_sym_DASH] = ACTIONS(728),
    [anon_sym_TILDE] = ACTIONS(728),
    [anon_sym_lambda] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(732),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(734),
    [sym_integer] = ACTIONS(736),
    [sym_float] = ACTIONS(736),
    [sym_identifier] = ACTIONS(736),
    [sym_true] = ACTIONS(736),
    [sym_false] = ACTIONS(736),
    [sym_none] = ACTIONS(736),
    [anon_sym_await] = ACTIONS(738),
    [sym_comment] = ACTIONS(72),
  },
  [419] = {
    [aux_sym__parameters_repeat1] = STATE(834),
    [anon_sym_COMMA] = ACTIONS(1662),
    [anon_sym_COLON] = ACTIONS(1646),
    [sym_comment] = ACTIONS(72),
  },
  [420] = {
    [sym__expression] = STATE(845),
    [sym__primary_expression] = STATE(34),
    [sym_not_operator] = STATE(845),
    [sym_boolean_operator] = STATE(845),
    [sym_binary_operator] = STATE(34),
    [sym_unary_operator] = STATE(34),
    [sym_comparison_operator] = STATE(845),
    [sym_lambda] = STATE(845),
    [sym_attribute] = STATE(34),
    [sym_subscript] = STATE(34),
    [sym_call] = STATE(34),
    [sym_list] = STATE(34),
    [sym_list_comprehension] = STATE(34),
    [sym_dictionary] = STATE(34),
    [sym_dictionary_comprehension] = STATE(34),
    [sym_set] = STATE(34),
    [sym_set_comprehension] = STATE(34),
    [sym_parenthesized_expression] = STATE(34),
    [sym_tuple] = STATE(34),
    [sym_generator_expression] = STATE(34),
    [sym_conditional_expression] = STATE(845),
    [sym_concatenated_string] = STATE(34),
    [sym_await] = STATE(845),
    [anon_sym_LPAREN] = ACTIONS(14),
    [anon_sym_print] = ACTIONS(216),
    [anon_sym_exec] = ACTIONS(216),
    [anon_sym_not] = ACTIONS(52),
    [anon_sym_PLUS] = ACTIONS(54),
    [anon_sym_DASH] = ACTIONS(54),
    [anon_sym_TILDE] = ACTIONS(54),
    [anon_sym_lambda] = ACTIONS(56),
    [anon_sym_LBRACK] = ACTIONS(60),
    [sym_ellipsis] = ACTIONS(62),
    [anon_sym_LBRACE] = ACTIONS(64),
    [sym_string] = ACTIONS(66),
    [sym_integer] = ACTIONS(68),
    [sym_float] = ACTIONS(68),
    [sym_identifier] = ACTIONS(68),
    [sym_true] = ACTIONS(68),
    [sym_false] = ACTIONS(68),
    [sym_none] = ACTIONS(68),
    [anon_sym_await] = ACTIONS(70),
    [sym_comment] = ACTIONS(72),
  },
  [421] = {
    [sym__expression] = STATE(846),
    [sym__primary_expression] = STATE(410),
    [sym_not_operator] = STATE(846),
    [sym_boolean_operator] = STATE(846),
    [sym_binary_operator] = STATE(410),
    [sym_unary_operator] = STATE(410),
    [sym_comparison_operator] = STATE(846),
    [sym_lambda] = STATE(846),
    [sym_attribute] = STATE(410),
    [sym_subscript] = STATE(410),
    [sym_call] = STATE(410),
    [sym_type] = STATE(847),
    [sym_list] = STATE(410),
    [sym_list_comprehension] = STATE(410),
    [sym_dictionary] = STATE(410),
    [sym_dictionary_comprehension] = STATE(410),
    [sym_set] = STATE(410),
    [sym_set_comprehension] = STATE(410),
    [sym_parenthesized_expression] = STATE(410),
    [sym_tuple] = STATE(410),
    [sym_generator_expression] = STATE(410),
    [sym_conditional_expression] = STATE(846),
    [sym_concatenated_string] = STATE(410),
    [sym_await] = STATE(846),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_not] = ACTIONS(726),
    [anon_sym_PLUS] = ACTIONS(728),
    [anon_sym_DASH] = ACTIONS(728),
    [anon_sym_TILDE] = ACTIONS(728),
    [anon_sym_lambda] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(732),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(734),
    [sym_integer] = ACTIONS(736),
    [sym_float] = ACTIONS(736),
    [sym_identifier] = ACTIONS(736),
    [sym_true] = ACTIONS(736),
    [sym_false] = ACTIONS(736),
    [sym_none] = ACTIONS(736),
    [anon_sym_await] = ACTIONS(738),
    [sym_comment] = ACTIONS(72),
  },
  [422] = {
    [sym__newline] = ACTIONS(1664),
    [anon_sym_if] = ACTIONS(1331),
    [anon_sym_and] = ACTIONS(1333),
    [anon_sym_or] = ACTIONS(1335),
    [sym_comment] = ACTIONS(72),
    [sym__semicolon] = ACTIONS(1664),
  },
  [423] = {
    [sym__newline] = ACTIONS(1666),
    [anon_sym_DOT] = ACTIONS(1666),
    [anon_sym_LPAREN] = ACTIONS(1666),
    [anon_sym_COMMA] = ACTIONS(1666),
    [anon_sym_STAR] = ACTIONS(1668),
    [anon_sym_GT_GT] = ACTIONS(1668),
    [anon_sym_if] = ACTIONS(1666),
    [anon_sym_COLON] = ACTIONS(1666),
    [anon_sym_in] = ACTIONS(1666),
    [anon_sym_EQ] = ACTIONS(1668),
    [anon_sym_AT] = ACTIONS(1668),
    [anon_sym_not] = ACTIONS(1666),
    [anon_sym_and] = ACTIONS(1666),
    [anon_sym_or] = ACTIONS(1666),
    [anon_sym_PLUS] = ACTIONS(1668),
    [anon_sym_DASH] = ACTIONS(1668),
    [anon_sym_SLASH] = ACTIONS(1668),
    [anon_sym_PERCENT] = ACTIONS(1668),
    [anon_sym_SLASH_SLASH] = ACTIONS(1668),
    [anon_sym_STAR_STAR] = ACTIONS(1668),
    [anon_sym_PIPE] = ACTIONS(1668),
    [anon_sym_AMP] = ACTIONS(1668),
    [anon_sym_CARET] = ACTIONS(1668),
    [anon_sym_LT_LT] = ACTIONS(1668),
    [anon_sym_LT] = ACTIONS(1668),
    [anon_sym_LT_EQ] = ACTIONS(1666),
    [anon_sym_EQ_EQ] = ACTIONS(1666),
    [anon_sym_BANG_EQ] = ACTIONS(1666),
    [anon_sym_GT_EQ] = ACTIONS(1666),
    [anon_sym_GT] = ACTIONS(1668),
    [anon_sym_LT_GT] = ACTIONS(1666),
    [anon_sym_is] = ACTIONS(1666),
    [anon_sym_PLUS_EQ] = ACTIONS(1666),
    [anon_sym_DASH_EQ] = ACTIONS(1666),
    [anon_sym_STAR_EQ] = ACTIONS(1666),
    [anon_sym_SLASH_EQ] = ACTIONS(1666),
    [anon_sym_AT_EQ] = ACTIONS(1666),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(1666),
    [anon_sym_PERCENT_EQ] = ACTIONS(1666),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1666),
    [anon_sym_GT_GT_EQ] = ACTIONS(1666),
    [anon_sym_LT_LT_EQ] = ACTIONS(1666),
    [anon_sym_AMP_EQ] = ACTIONS(1666),
    [anon_sym_CARET_EQ] = ACTIONS(1666),
    [anon_sym_PIPE_EQ] = ACTIONS(1666),
    [anon_sym_LBRACK] = ACTIONS(1666),
    [sym_comment] = ACTIONS(72),
    [sym__semicolon] = ACTIONS(1666),
  },
  [424] = {
    [sym__expression] = STATE(848),
    [sym__primary_expression] = STATE(430),
    [sym_not_operator] = STATE(848),
    [sym_boolean_operator] = STATE(848),
    [sym_binary_operator] = STATE(430),
    [sym_unary_operator] = STATE(430),
    [sym_comparison_operator] = STATE(848),
    [sym_lambda] = STATE(848),
    [sym_attribute] = STATE(430),
    [sym_subscript] = STATE(430),
    [sym_call] = STATE(430),
    [sym_list] = STATE(430),
    [sym_list_comprehension] = STATE(430),
    [sym_dictionary] = STATE(430),
    [sym_dictionary_comprehension] = STATE(430),
    [sym_set] = STATE(430),
    [sym_set_comprehension] = STATE(430),
    [sym_parenthesized_expression] = STATE(430),
    [sym_tuple] = STATE(430),
    [sym_generator_expression] = STATE(430),
    [sym_conditional_expression] = STATE(848),
    [sym_concatenated_string] = STATE(430),
    [sym_await] = STATE(848),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_not] = ACTIONS(760),
    [anon_sym_PLUS] = ACTIONS(762),
    [anon_sym_DASH] = ACTIONS(762),
    [anon_sym_TILDE] = ACTIONS(762),
    [anon_sym_lambda] = ACTIONS(764),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(766),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(768),
    [sym_integer] = ACTIONS(770),
    [sym_float] = ACTIONS(770),
    [sym_identifier] = ACTIONS(770),
    [sym_true] = ACTIONS(770),
    [sym_false] = ACTIONS(770),
    [sym_none] = ACTIONS(770),
    [anon_sym_await] = ACTIONS(772),
    [sym_comment] = ACTIONS(72),
  },
  [425] = {
    [sym__primary_expression] = STATE(204),
    [sym_binary_operator] = STATE(204),
    [sym_unary_operator] = STATE(204),
    [sym_attribute] = STATE(204),
    [sym_subscript] = STATE(204),
    [sym_call] = STATE(204),
    [sym_list] = STATE(204),
    [sym_list_comprehension] = STATE(204),
    [sym_dictionary] = STATE(204),
    [sym_dictionary_comprehension] = STATE(204),
    [sym_set] = STATE(204),
    [sym_set_comprehension] = STATE(204),
    [sym_parenthesized_expression] = STATE(204),
    [sym_tuple] = STATE(204),
    [sym_generator_expression] = STATE(204),
    [sym_concatenated_string] = STATE(204),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_PLUS] = ACTIONS(762),
    [anon_sym_DASH] = ACTIONS(762),
    [anon_sym_TILDE] = ACTIONS(762),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(376),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(768),
    [sym_integer] = ACTIONS(378),
    [sym_float] = ACTIONS(378),
    [sym_identifier] = ACTIONS(378),
    [sym_true] = ACTIONS(378),
    [sym_false] = ACTIONS(378),
    [sym_none] = ACTIONS(378),
    [sym_comment] = ACTIONS(72),
  },
  [426] = {
    [sym_lambda_parameters] = STATE(850),
    [sym__parameters] = STATE(130),
    [sym_default_parameter] = STATE(131),
    [sym_typed_default_parameter] = STATE(131),
    [sym_list_splat] = STATE(132),
    [sym_dictionary_splat] = STATE(132),
    [sym_typed_parameter] = STATE(131),
    [sym_tuple] = STATE(131),
    [anon_sym_LPAREN] = ACTIONS(222),
    [anon_sym_STAR] = ACTIONS(224),
    [anon_sym_print] = ACTIONS(226),
    [anon_sym_COLON] = ACTIONS(1670),
    [anon_sym_exec] = ACTIONS(226),
    [sym_identifier] = ACTIONS(230),
    [sym_comment] = ACTIONS(72),
  },
  [427] = {
    [aux_sym_concatenated_string_repeat1] = STATE(851),
    [anon_sym_DOT] = ACTIONS(276),
    [anon_sym_LPAREN] = ACTIONS(276),
    [anon_sym_COMMA] = ACTIONS(276),
    [anon_sym_STAR] = ACTIONS(278),
    [anon_sym_GT_GT] = ACTIONS(276),
    [anon_sym_if] = ACTIONS(276),
    [anon_sym_in] = ACTIONS(276),
    [anon_sym_AT] = ACTIONS(276),
    [anon_sym_not] = ACTIONS(276),
    [anon_sym_and] = ACTIONS(276),
    [anon_sym_or] = ACTIONS(276),
    [anon_sym_PLUS] = ACTIONS(276),
    [anon_sym_DASH] = ACTIONS(276),
    [anon_sym_SLASH] = ACTIONS(278),
    [anon_sym_PERCENT] = ACTIONS(276),
    [anon_sym_SLASH_SLASH] = ACTIONS(276),
    [anon_sym_STAR_STAR] = ACTIONS(276),
    [anon_sym_PIPE] = ACTIONS(276),
    [anon_sym_AMP] = ACTIONS(276),
    [anon_sym_CARET] = ACTIONS(276),
    [anon_sym_LT_LT] = ACTIONS(276),
    [anon_sym_LT] = ACTIONS(278),
    [anon_sym_LT_EQ] = ACTIONS(276),
    [anon_sym_EQ_EQ] = ACTIONS(276),
    [anon_sym_BANG_EQ] = ACTIONS(276),
    [anon_sym_GT_EQ] = ACTIONS(276),
    [anon_sym_GT] = ACTIONS(278),
    [anon_sym_LT_GT] = ACTIONS(276),
    [anon_sym_is] = ACTIONS(276),
    [anon_sym_LBRACK] = ACTIONS(276),
    [anon_sym_RBRACK] = ACTIONS(276),
    [sym_string] = ACTIONS(1672),
    [sym_comment] = ACTIONS(72),
  },
  [428] = {
    [sym__expression] = STATE(227),
    [sym__primary_expression] = STATE(430),
    [sym_not_operator] = STATE(227),
    [sym_boolean_operator] = STATE(227),
    [sym_binary_operator] = STATE(430),
    [sym_unary_operator] = STATE(430),
    [sym_comparison_operator] = STATE(227),
    [sym_lambda] = STATE(227),
    [sym_attribute] = STATE(430),
    [sym_subscript] = STATE(430),
    [sym_call] = STATE(430),
    [sym_list] = STATE(430),
    [sym_list_comprehension] = STATE(430),
    [sym_dictionary] = STATE(430),
    [sym_dictionary_comprehension] = STATE(430),
    [sym_set] = STATE(430),
    [sym_set_comprehension] = STATE(430),
    [sym_parenthesized_expression] = STATE(430),
    [sym_tuple] = STATE(430),
    [sym_generator_expression] = STATE(430),
    [sym_conditional_expression] = STATE(227),
    [sym_concatenated_string] = STATE(430),
    [sym_await] = STATE(227),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_not] = ACTIONS(760),
    [anon_sym_PLUS] = ACTIONS(762),
    [anon_sym_DASH] = ACTIONS(762),
    [anon_sym_TILDE] = ACTIONS(762),
    [anon_sym_lambda] = ACTIONS(764),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(766),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(768),
    [sym_integer] = ACTIONS(770),
    [sym_float] = ACTIONS(770),
    [sym_identifier] = ACTIONS(770),
    [sym_true] = ACTIONS(770),
    [sym_false] = ACTIONS(770),
    [sym_none] = ACTIONS(770),
    [anon_sym_await] = ACTIONS(772),
    [sym_comment] = ACTIONS(72),
  },
  [429] = {
    [anon_sym_COMMA] = ACTIONS(1590),
    [anon_sym_if] = ACTIONS(1674),
    [anon_sym_and] = ACTIONS(1676),
    [anon_sym_or] = ACTIONS(1678),
    [anon_sym_RBRACK] = ACTIONS(1590),
    [sym_comment] = ACTIONS(72),
  },
  [430] = {
    [sym_argument_list] = STATE(251),
    [sym_generator_expression] = STATE(251),
    [aux_sym_comparison_operator_repeat1] = STATE(865),
    [anon_sym_DOT] = ACTIONS(422),
    [anon_sym_LPAREN] = ACTIONS(424),
    [anon_sym_COMMA] = ACTIONS(302),
    [anon_sym_STAR] = ACTIONS(1680),
    [anon_sym_GT_GT] = ACTIONS(1682),
    [anon_sym_if] = ACTIONS(302),
    [anon_sym_in] = ACTIONS(1684),
    [anon_sym_AT] = ACTIONS(1686),
    [anon_sym_not] = ACTIONS(1688),
    [anon_sym_and] = ACTIONS(302),
    [anon_sym_or] = ACTIONS(302),
    [anon_sym_PLUS] = ACTIONS(1690),
    [anon_sym_DASH] = ACTIONS(1690),
    [anon_sym_SLASH] = ACTIONS(1680),
    [anon_sym_PERCENT] = ACTIONS(1686),
    [anon_sym_SLASH_SLASH] = ACTIONS(1686),
    [anon_sym_STAR_STAR] = ACTIONS(1692),
    [anon_sym_PIPE] = ACTIONS(1694),
    [anon_sym_AMP] = ACTIONS(1696),
    [anon_sym_CARET] = ACTIONS(1698),
    [anon_sym_LT_LT] = ACTIONS(1682),
    [anon_sym_LT] = ACTIONS(1700),
    [anon_sym_LT_EQ] = ACTIONS(1684),
    [anon_sym_EQ_EQ] = ACTIONS(1684),
    [anon_sym_BANG_EQ] = ACTIONS(1684),
    [anon_sym_GT_EQ] = ACTIONS(1684),
    [anon_sym_GT] = ACTIONS(1700),
    [anon_sym_LT_GT] = ACTIONS(1684),
    [anon_sym_is] = ACTIONS(1702),
    [anon_sym_LBRACK] = ACTIONS(450),
    [anon_sym_RBRACK] = ACTIONS(302),
    [sym_comment] = ACTIONS(72),
  },
  [431] = {
    [anon_sym_COMMA] = ACTIONS(716),
    [anon_sym_if] = ACTIONS(716),
    [anon_sym_async] = ACTIONS(716),
    [anon_sym_for] = ACTIONS(716),
    [anon_sym_and] = ACTIONS(790),
    [anon_sym_or] = ACTIONS(792),
    [anon_sym_RBRACK] = ACTIONS(716),
    [sym_comment] = ACTIONS(72),
  },
  [432] = {
    [sym__expression] = STATE(866),
    [sym__primary_expression] = STATE(145),
    [sym_not_operator] = STATE(866),
    [sym_boolean_operator] = STATE(866),
    [sym_binary_operator] = STATE(145),
    [sym_unary_operator] = STATE(145),
    [sym_comparison_operator] = STATE(866),
    [sym_lambda] = STATE(866),
    [sym_attribute] = STATE(145),
    [sym_subscript] = STATE(145),
    [sym_call] = STATE(145),
    [sym_list] = STATE(145),
    [sym_list_comprehension] = STATE(145),
    [sym_dictionary] = STATE(145),
    [sym_dictionary_comprehension] = STATE(145),
    [sym_set] = STATE(145),
    [sym_set_comprehension] = STATE(145),
    [sym_parenthesized_expression] = STATE(145),
    [sym_tuple] = STATE(145),
    [sym_generator_expression] = STATE(145),
    [sym_conditional_expression] = STATE(866),
    [sym_concatenated_string] = STATE(145),
    [sym_await] = STATE(866),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_not] = ACTIONS(240),
    [anon_sym_PLUS] = ACTIONS(242),
    [anon_sym_DASH] = ACTIONS(242),
    [anon_sym_TILDE] = ACTIONS(242),
    [anon_sym_lambda] = ACTIONS(244),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(248),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(250),
    [sym_integer] = ACTIONS(252),
    [sym_float] = ACTIONS(252),
    [sym_identifier] = ACTIONS(252),
    [sym_true] = ACTIONS(252),
    [sym_false] = ACTIONS(252),
    [sym_none] = ACTIONS(252),
    [anon_sym_await] = ACTIONS(254),
    [sym_comment] = ACTIONS(72),
  },
  [433] = {
    [anon_sym_COLON] = ACTIONS(1704),
    [sym_comment] = ACTIONS(72),
  },
  [434] = {
    [aux_sym_concatenated_string_repeat1] = STATE(868),
    [anon_sym_DOT] = ACTIONS(886),
    [anon_sym_LPAREN] = ACTIONS(886),
    [anon_sym_COMMA] = ACTIONS(886),
    [anon_sym_STAR] = ACTIONS(888),
    [anon_sym_GT_GT] = ACTIONS(886),
    [anon_sym_if] = ACTIONS(886),
    [anon_sym_async] = ACTIONS(886),
    [anon_sym_for] = ACTIONS(886),
    [anon_sym_in] = ACTIONS(886),
    [anon_sym_AT] = ACTIONS(886),
    [anon_sym_not] = ACTIONS(886),
    [anon_sym_and] = ACTIONS(886),
    [anon_sym_or] = ACTIONS(886),
    [anon_sym_PLUS] = ACTIONS(886),
    [anon_sym_DASH] = ACTIONS(886),
    [anon_sym_SLASH] = ACTIONS(888),
    [anon_sym_PERCENT] = ACTIONS(886),
    [anon_sym_SLASH_SLASH] = ACTIONS(886),
    [anon_sym_STAR_STAR] = ACTIONS(886),
    [anon_sym_PIPE] = ACTIONS(886),
    [anon_sym_AMP] = ACTIONS(886),
    [anon_sym_CARET] = ACTIONS(886),
    [anon_sym_LT_LT] = ACTIONS(886),
    [anon_sym_LT] = ACTIONS(888),
    [anon_sym_LT_EQ] = ACTIONS(886),
    [anon_sym_EQ_EQ] = ACTIONS(886),
    [anon_sym_BANG_EQ] = ACTIONS(886),
    [anon_sym_GT_EQ] = ACTIONS(886),
    [anon_sym_GT] = ACTIONS(888),
    [anon_sym_LT_GT] = ACTIONS(886),
    [anon_sym_is] = ACTIONS(886),
    [anon_sym_LBRACK] = ACTIONS(886),
    [anon_sym_RBRACK] = ACTIONS(886),
    [sym_string] = ACTIONS(1706),
    [sym_comment] = ACTIONS(72),
  },
  [435] = {
    [sym_list_splat] = STATE(870),
    [sym__expression] = STATE(871),
    [sym__primary_expression] = STATE(430),
    [sym_not_operator] = STATE(871),
    [sym_boolean_operator] = STATE(871),
    [sym_binary_operator] = STATE(430),
    [sym_unary_operator] = STATE(430),
    [sym_comparison_operator] = STATE(871),
    [sym_lambda] = STATE(871),
    [sym_attribute] = STATE(430),
    [sym_subscript] = STATE(430),
    [sym_call] = STATE(430),
    [sym_list] = STATE(430),
    [sym_list_comprehension] = STATE(430),
    [sym_dictionary] = STATE(430),
    [sym_dictionary_comprehension] = STATE(430),
    [sym_set] = STATE(430),
    [sym_set_comprehension] = STATE(430),
    [sym_parenthesized_expression] = STATE(430),
    [sym_tuple] = STATE(430),
    [sym_generator_expression] = STATE(430),
    [sym_conditional_expression] = STATE(871),
    [sym_concatenated_string] = STATE(430),
    [sym_await] = STATE(871),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_STAR] = ACTIONS(238),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_not] = ACTIONS(760),
    [anon_sym_PLUS] = ACTIONS(762),
    [anon_sym_DASH] = ACTIONS(762),
    [anon_sym_TILDE] = ACTIONS(762),
    [anon_sym_lambda] = ACTIONS(764),
    [anon_sym_LBRACK] = ACTIONS(96),
    [anon_sym_RBRACK] = ACTIONS(1708),
    [sym_ellipsis] = ACTIONS(766),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(768),
    [sym_integer] = ACTIONS(770),
    [sym_float] = ACTIONS(770),
    [sym_identifier] = ACTIONS(770),
    [sym_true] = ACTIONS(770),
    [sym_false] = ACTIONS(770),
    [sym_none] = ACTIONS(770),
    [anon_sym_await] = ACTIONS(772),
    [sym_comment] = ACTIONS(72),
  },
  [436] = {
    [aux_sym_list_repeat1] = STATE(873),
    [anon_sym_COMMA] = ACTIONS(1710),
    [anon_sym_RBRACK] = ACTIONS(1708),
    [sym_comment] = ACTIONS(72),
  },
  [437] = {
    [sym__expression] = STATE(874),
    [sym__primary_expression] = STATE(513),
    [sym_not_operator] = STATE(874),
    [sym_boolean_operator] = STATE(874),
    [sym_binary_operator] = STATE(513),
    [sym_unary_operator] = STATE(513),
    [sym_comparison_operator] = STATE(874),
    [sym_lambda] = STATE(874),
    [sym_attribute] = STATE(513),
    [sym_subscript] = STATE(513),
    [sym_call] = STATE(513),
    [sym_list] = STATE(513),
    [sym_list_comprehension] = STATE(513),
    [sym_dictionary] = STATE(513),
    [sym_dictionary_comprehension] = STATE(513),
    [sym_set] = STATE(513),
    [sym_set_comprehension] = STATE(513),
    [sym_parenthesized_expression] = STATE(513),
    [sym_tuple] = STATE(513),
    [sym_generator_expression] = STATE(513),
    [sym_conditional_expression] = STATE(874),
    [sym_concatenated_string] = STATE(513),
    [sym_await] = STATE(874),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_not] = ACTIONS(914),
    [anon_sym_PLUS] = ACTIONS(916),
    [anon_sym_DASH] = ACTIONS(916),
    [anon_sym_TILDE] = ACTIONS(916),
    [anon_sym_lambda] = ACTIONS(918),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(920),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(922),
    [sym_integer] = ACTIONS(924),
    [sym_float] = ACTIONS(924),
    [sym_identifier] = ACTIONS(924),
    [sym_true] = ACTIONS(924),
    [sym_false] = ACTIONS(924),
    [sym_none] = ACTIONS(924),
    [anon_sym_await] = ACTIONS(926),
    [sym_comment] = ACTIONS(72),
  },
  [438] = {
    [anon_sym_for] = ACTIONS(1712),
    [sym_comment] = ACTIONS(72),
  },
  [439] = {
    [sym_variables] = STATE(876),
    [sym__primary_expression] = STATE(103),
    [sym_binary_operator] = STATE(103),
    [sym_unary_operator] = STATE(103),
    [sym_attribute] = STATE(103),
    [sym_subscript] = STATE(103),
    [sym_call] = STATE(103),
    [sym_list] = STATE(103),
    [sym_list_comprehension] = STATE(103),
    [sym_dictionary] = STATE(103),
    [sym_dictionary_comprehension] = STATE(103),
    [sym_set] = STATE(103),
    [sym_set_comprehension] = STATE(103),
    [sym_parenthesized_expression] = STATE(103),
    [sym_tuple] = STATE(103),
    [sym_generator_expression] = STATE(103),
    [sym_concatenated_string] = STATE(103),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_PLUS] = ACTIONS(180),
    [anon_sym_DASH] = ACTIONS(180),
    [anon_sym_TILDE] = ACTIONS(180),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(182),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(184),
    [sym_integer] = ACTIONS(186),
    [sym_float] = ACTIONS(186),
    [sym_identifier] = ACTIONS(186),
    [sym_true] = ACTIONS(186),
    [sym_false] = ACTIONS(186),
    [sym_none] = ACTIONS(186),
    [sym_comment] = ACTIONS(72),
  },
  [440] = {
    [sym__expression] = STATE(604),
    [sym__primary_expression] = STATE(145),
    [sym_not_operator] = STATE(604),
    [sym_boolean_operator] = STATE(604),
    [sym_binary_operator] = STATE(145),
    [sym_unary_operator] = STATE(145),
    [sym_comparison_operator] = STATE(604),
    [sym_lambda] = STATE(604),
    [sym_attribute] = STATE(145),
    [sym_subscript] = STATE(145),
    [sym_call] = STATE(145),
    [sym_list] = STATE(145),
    [sym_list_comprehension] = STATE(145),
    [sym_dictionary] = STATE(145),
    [sym_dictionary_comprehension] = STATE(145),
    [sym_set] = STATE(145),
    [sym_set_comprehension] = STATE(145),
    [sym_parenthesized_expression] = STATE(145),
    [sym_tuple] = STATE(145),
    [sym_generator_expression] = STATE(145),
    [sym_conditional_expression] = STATE(604),
    [sym_concatenated_string] = STATE(145),
    [sym_await] = STATE(604),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_not] = ACTIONS(240),
    [anon_sym_PLUS] = ACTIONS(242),
    [anon_sym_DASH] = ACTIONS(242),
    [anon_sym_TILDE] = ACTIONS(242),
    [anon_sym_lambda] = ACTIONS(244),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(248),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(250),
    [sym_integer] = ACTIONS(252),
    [sym_float] = ACTIONS(252),
    [sym_identifier] = ACTIONS(252),
    [sym_true] = ACTIONS(252),
    [sym_false] = ACTIONS(252),
    [sym_none] = ACTIONS(252),
    [anon_sym_await] = ACTIONS(254),
    [sym_comment] = ACTIONS(72),
  },
  [441] = {
    [sym__expression] = STATE(877),
    [sym__primary_expression] = STATE(145),
    [sym_not_operator] = STATE(877),
    [sym_boolean_operator] = STATE(877),
    [sym_binary_operator] = STATE(145),
    [sym_unary_operator] = STATE(145),
    [sym_comparison_operator] = STATE(877),
    [sym_lambda] = STATE(877),
    [sym_attribute] = STATE(145),
    [sym_subscript] = STATE(145),
    [sym_call] = STATE(145),
    [sym_list] = STATE(145),
    [sym_list_comprehension] = STATE(145),
    [sym_dictionary] = STATE(145),
    [sym_dictionary_comprehension] = STATE(145),
    [sym_set] = STATE(145),
    [sym_set_comprehension] = STATE(145),
    [sym_parenthesized_expression] = STATE(145),
    [sym_tuple] = STATE(145),
    [sym_generator_expression] = STATE(145),
    [sym_conditional_expression] = STATE(877),
    [sym_concatenated_string] = STATE(145),
    [sym_await] = STATE(877),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_not] = ACTIONS(240),
    [anon_sym_PLUS] = ACTIONS(242),
    [anon_sym_DASH] = ACTIONS(242),
    [anon_sym_TILDE] = ACTIONS(242),
    [anon_sym_lambda] = ACTIONS(244),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(248),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(250),
    [sym_integer] = ACTIONS(252),
    [sym_float] = ACTIONS(252),
    [sym_identifier] = ACTIONS(252),
    [sym_true] = ACTIONS(252),
    [sym_false] = ACTIONS(252),
    [sym_none] = ACTIONS(252),
    [anon_sym_await] = ACTIONS(254),
    [sym_comment] = ACTIONS(72),
  },
  [442] = {
    [anon_sym_RBRACK] = ACTIONS(1714),
    [sym_comment] = ACTIONS(72),
  },
  [443] = {
    [sym_for_in_clause] = STATE(880),
    [sym_if_clause] = STATE(880),
    [aux_sym__comprehension_body_repeat1] = STATE(880),
    [anon_sym_if] = ACTIONS(1716),
    [anon_sym_async] = ACTIONS(786),
    [anon_sym_for] = ACTIONS(788),
    [anon_sym_RBRACK] = ACTIONS(1203),
    [sym_comment] = ACTIONS(72),
  },
  [444] = {
    [sym__primary_expression] = STATE(881),
    [sym_binary_operator] = STATE(881),
    [sym_unary_operator] = STATE(881),
    [sym_attribute] = STATE(881),
    [sym_subscript] = STATE(881),
    [sym_call] = STATE(881),
    [sym_list] = STATE(881),
    [sym_list_comprehension] = STATE(881),
    [sym_dictionary] = STATE(881),
    [sym_dictionary_comprehension] = STATE(881),
    [sym_set] = STATE(881),
    [sym_set_comprehension] = STATE(881),
    [sym_parenthesized_expression] = STATE(881),
    [sym_tuple] = STATE(881),
    [sym_generator_expression] = STATE(881),
    [sym_concatenated_string] = STATE(881),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_PLUS] = ACTIONS(242),
    [anon_sym_DASH] = ACTIONS(242),
    [anon_sym_TILDE] = ACTIONS(242),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(1718),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(250),
    [sym_integer] = ACTIONS(1720),
    [sym_float] = ACTIONS(1720),
    [sym_identifier] = ACTIONS(1720),
    [sym_true] = ACTIONS(1720),
    [sym_false] = ACTIONS(1720),
    [sym_none] = ACTIONS(1720),
    [sym_comment] = ACTIONS(72),
  },
  [445] = {
    [sym__primary_expression] = STATE(882),
    [sym_binary_operator] = STATE(882),
    [sym_unary_operator] = STATE(882),
    [sym_attribute] = STATE(882),
    [sym_subscript] = STATE(882),
    [sym_call] = STATE(882),
    [sym_list] = STATE(882),
    [sym_list_comprehension] = STATE(882),
    [sym_dictionary] = STATE(882),
    [sym_dictionary_comprehension] = STATE(882),
    [sym_set] = STATE(882),
    [sym_set_comprehension] = STATE(882),
    [sym_parenthesized_expression] = STATE(882),
    [sym_tuple] = STATE(882),
    [sym_generator_expression] = STATE(882),
    [sym_concatenated_string] = STATE(882),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_PLUS] = ACTIONS(242),
    [anon_sym_DASH] = ACTIONS(242),
    [anon_sym_TILDE] = ACTIONS(242),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(1722),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(250),
    [sym_integer] = ACTIONS(1724),
    [sym_float] = ACTIONS(1724),
    [sym_identifier] = ACTIONS(1724),
    [sym_true] = ACTIONS(1724),
    [sym_false] = ACTIONS(1724),
    [sym_none] = ACTIONS(1724),
    [sym_comment] = ACTIONS(72),
  },
  [446] = {
    [sym__primary_expression] = STATE(883),
    [sym_binary_operator] = STATE(883),
    [sym_unary_operator] = STATE(883),
    [sym_attribute] = STATE(883),
    [sym_subscript] = STATE(883),
    [sym_call] = STATE(883),
    [sym_list] = STATE(883),
    [sym_list_comprehension] = STATE(883),
    [sym_dictionary] = STATE(883),
    [sym_dictionary_comprehension] = STATE(883),
    [sym_set] = STATE(883),
    [sym_set_comprehension] = STATE(883),
    [sym_parenthesized_expression] = STATE(883),
    [sym_tuple] = STATE(883),
    [sym_generator_expression] = STATE(883),
    [sym_concatenated_string] = STATE(883),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_PLUS] = ACTIONS(242),
    [anon_sym_DASH] = ACTIONS(242),
    [anon_sym_TILDE] = ACTIONS(242),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(1726),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(250),
    [sym_integer] = ACTIONS(1728),
    [sym_float] = ACTIONS(1728),
    [sym_identifier] = ACTIONS(1728),
    [sym_true] = ACTIONS(1728),
    [sym_false] = ACTIONS(1728),
    [sym_none] = ACTIONS(1728),
    [sym_comment] = ACTIONS(72),
  },
  [447] = {
    [anon_sym_in] = ACTIONS(1730),
    [sym_comment] = ACTIONS(72),
  },
  [448] = {
    [sym__primary_expression] = STATE(885),
    [sym_binary_operator] = STATE(885),
    [sym_unary_operator] = STATE(885),
    [sym_attribute] = STATE(885),
    [sym_subscript] = STATE(885),
    [sym_call] = STATE(885),
    [sym_list] = STATE(885),
    [sym_list_comprehension] = STATE(885),
    [sym_dictionary] = STATE(885),
    [sym_dictionary_comprehension] = STATE(885),
    [sym_set] = STATE(885),
    [sym_set_comprehension] = STATE(885),
    [sym_parenthesized_expression] = STATE(885),
    [sym_tuple] = STATE(885),
    [sym_generator_expression] = STATE(885),
    [sym_concatenated_string] = STATE(885),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_PLUS] = ACTIONS(242),
    [anon_sym_DASH] = ACTIONS(242),
    [anon_sym_TILDE] = ACTIONS(242),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(1732),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(250),
    [sym_integer] = ACTIONS(1734),
    [sym_float] = ACTIONS(1734),
    [sym_identifier] = ACTIONS(1734),
    [sym_true] = ACTIONS(1734),
    [sym_false] = ACTIONS(1734),
    [sym_none] = ACTIONS(1734),
    [sym_comment] = ACTIONS(72),
  },
  [449] = {
    [sym__primary_expression] = STATE(621),
    [sym_binary_operator] = STATE(621),
    [sym_unary_operator] = STATE(621),
    [sym_attribute] = STATE(621),
    [sym_subscript] = STATE(621),
    [sym_call] = STATE(621),
    [sym_list] = STATE(621),
    [sym_list_comprehension] = STATE(621),
    [sym_dictionary] = STATE(621),
    [sym_dictionary_comprehension] = STATE(621),
    [sym_set] = STATE(621),
    [sym_set_comprehension] = STATE(621),
    [sym_parenthesized_expression] = STATE(621),
    [sym_tuple] = STATE(621),
    [sym_generator_expression] = STATE(621),
    [sym_concatenated_string] = STATE(621),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_PLUS] = ACTIONS(242),
    [anon_sym_DASH] = ACTIONS(242),
    [anon_sym_TILDE] = ACTIONS(242),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(1233),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(250),
    [sym_integer] = ACTIONS(1235),
    [sym_float] = ACTIONS(1235),
    [sym_identifier] = ACTIONS(1235),
    [sym_true] = ACTIONS(1235),
    [sym_false] = ACTIONS(1235),
    [sym_none] = ACTIONS(1235),
    [sym_comment] = ACTIONS(72),
  },
  [450] = {
    [sym__primary_expression] = STATE(886),
    [sym_binary_operator] = STATE(886),
    [sym_unary_operator] = STATE(886),
    [sym_attribute] = STATE(886),
    [sym_subscript] = STATE(886),
    [sym_call] = STATE(886),
    [sym_list] = STATE(886),
    [sym_list_comprehension] = STATE(886),
    [sym_dictionary] = STATE(886),
    [sym_dictionary_comprehension] = STATE(886),
    [sym_set] = STATE(886),
    [sym_set_comprehension] = STATE(886),
    [sym_parenthesized_expression] = STATE(886),
    [sym_tuple] = STATE(886),
    [sym_generator_expression] = STATE(886),
    [sym_concatenated_string] = STATE(886),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_PLUS] = ACTIONS(242),
    [anon_sym_DASH] = ACTIONS(242),
    [anon_sym_TILDE] = ACTIONS(242),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(1736),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(250),
    [sym_integer] = ACTIONS(1738),
    [sym_float] = ACTIONS(1738),
    [sym_identifier] = ACTIONS(1738),
    [sym_true] = ACTIONS(1738),
    [sym_false] = ACTIONS(1738),
    [sym_none] = ACTIONS(1738),
    [sym_comment] = ACTIONS(72),
  },
  [451] = {
    [sym__primary_expression] = STATE(887),
    [sym_binary_operator] = STATE(887),
    [sym_unary_operator] = STATE(887),
    [sym_attribute] = STATE(887),
    [sym_subscript] = STATE(887),
    [sym_call] = STATE(887),
    [sym_list] = STATE(887),
    [sym_list_comprehension] = STATE(887),
    [sym_dictionary] = STATE(887),
    [sym_dictionary_comprehension] = STATE(887),
    [sym_set] = STATE(887),
    [sym_set_comprehension] = STATE(887),
    [sym_parenthesized_expression] = STATE(887),
    [sym_tuple] = STATE(887),
    [sym_generator_expression] = STATE(887),
    [sym_concatenated_string] = STATE(887),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_PLUS] = ACTIONS(242),
    [anon_sym_DASH] = ACTIONS(242),
    [anon_sym_TILDE] = ACTIONS(242),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(1740),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(250),
    [sym_integer] = ACTIONS(1742),
    [sym_float] = ACTIONS(1742),
    [sym_identifier] = ACTIONS(1742),
    [sym_true] = ACTIONS(1742),
    [sym_false] = ACTIONS(1742),
    [sym_none] = ACTIONS(1742),
    [sym_comment] = ACTIONS(72),
  },
  [452] = {
    [sym__primary_expression] = STATE(888),
    [sym_binary_operator] = STATE(888),
    [sym_unary_operator] = STATE(888),
    [sym_attribute] = STATE(888),
    [sym_subscript] = STATE(888),
    [sym_call] = STATE(888),
    [sym_list] = STATE(888),
    [sym_list_comprehension] = STATE(888),
    [sym_dictionary] = STATE(888),
    [sym_dictionary_comprehension] = STATE(888),
    [sym_set] = STATE(888),
    [sym_set_comprehension] = STATE(888),
    [sym_parenthesized_expression] = STATE(888),
    [sym_tuple] = STATE(888),
    [sym_generator_expression] = STATE(888),
    [sym_concatenated_string] = STATE(888),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_PLUS] = ACTIONS(242),
    [anon_sym_DASH] = ACTIONS(242),
    [anon_sym_TILDE] = ACTIONS(242),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(1744),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(250),
    [sym_integer] = ACTIONS(1746),
    [sym_float] = ACTIONS(1746),
    [sym_identifier] = ACTIONS(1746),
    [sym_true] = ACTIONS(1746),
    [sym_false] = ACTIONS(1746),
    [sym_none] = ACTIONS(1746),
    [sym_comment] = ACTIONS(72),
  },
  [453] = {
    [sym__primary_expression] = STATE(883),
    [sym_binary_operator] = STATE(883),
    [sym_unary_operator] = STATE(883),
    [sym_attribute] = STATE(883),
    [sym_subscript] = STATE(883),
    [sym_call] = STATE(883),
    [sym_list] = STATE(883),
    [sym_list_comprehension] = STATE(883),
    [sym_dictionary] = STATE(883),
    [sym_dictionary_comprehension] = STATE(883),
    [sym_set] = STATE(883),
    [sym_set_comprehension] = STATE(883),
    [sym_parenthesized_expression] = STATE(883),
    [sym_tuple] = STATE(883),
    [sym_generator_expression] = STATE(883),
    [sym_concatenated_string] = STATE(883),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_not] = ACTIONS(1748),
    [anon_sym_PLUS] = ACTIONS(242),
    [anon_sym_DASH] = ACTIONS(242),
    [anon_sym_TILDE] = ACTIONS(242),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(1726),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(250),
    [sym_integer] = ACTIONS(1728),
    [sym_float] = ACTIONS(1728),
    [sym_identifier] = ACTIONS(1728),
    [sym_true] = ACTIONS(1728),
    [sym_false] = ACTIONS(1728),
    [sym_none] = ACTIONS(1728),
    [sym_comment] = ACTIONS(72),
  },
  [454] = {
    [aux_sym_comparison_operator_repeat1] = STATE(889),
    [anon_sym_COMMA] = ACTIONS(998),
    [anon_sym_if] = ACTIONS(998),
    [anon_sym_async] = ACTIONS(998),
    [anon_sym_for] = ACTIONS(998),
    [anon_sym_in] = ACTIONS(798),
    [anon_sym_not] = ACTIONS(802),
    [anon_sym_and] = ACTIONS(998),
    [anon_sym_or] = ACTIONS(998),
    [anon_sym_LT] = ACTIONS(814),
    [anon_sym_LT_EQ] = ACTIONS(798),
    [anon_sym_EQ_EQ] = ACTIONS(798),
    [anon_sym_BANG_EQ] = ACTIONS(798),
    [anon_sym_GT_EQ] = ACTIONS(798),
    [anon_sym_GT] = ACTIONS(814),
    [anon_sym_LT_GT] = ACTIONS(798),
    [anon_sym_is] = ACTIONS(816),
    [anon_sym_RBRACK] = ACTIONS(998),
    [sym_comment] = ACTIONS(72),
  },
  [455] = {
    [sym__newline] = ACTIONS(1750),
    [anon_sym_DOT] = ACTIONS(1750),
    [anon_sym_LPAREN] = ACTIONS(1750),
    [anon_sym_COMMA] = ACTIONS(1750),
    [anon_sym_STAR] = ACTIONS(1752),
    [anon_sym_GT_GT] = ACTIONS(1752),
    [anon_sym_if] = ACTIONS(1750),
    [anon_sym_COLON] = ACTIONS(1750),
    [anon_sym_in] = ACTIONS(1750),
    [anon_sym_EQ] = ACTIONS(1752),
    [anon_sym_AT] = ACTIONS(1752),
    [anon_sym_not] = ACTIONS(1750),
    [anon_sym_and] = ACTIONS(1750),
    [anon_sym_or] = ACTIONS(1750),
    [anon_sym_PLUS] = ACTIONS(1752),
    [anon_sym_DASH] = ACTIONS(1752),
    [anon_sym_SLASH] = ACTIONS(1752),
    [anon_sym_PERCENT] = ACTIONS(1752),
    [anon_sym_SLASH_SLASH] = ACTIONS(1752),
    [anon_sym_STAR_STAR] = ACTIONS(1752),
    [anon_sym_PIPE] = ACTIONS(1752),
    [anon_sym_AMP] = ACTIONS(1752),
    [anon_sym_CARET] = ACTIONS(1752),
    [anon_sym_LT_LT] = ACTIONS(1752),
    [anon_sym_LT] = ACTIONS(1752),
    [anon_sym_LT_EQ] = ACTIONS(1750),
    [anon_sym_EQ_EQ] = ACTIONS(1750),
    [anon_sym_BANG_EQ] = ACTIONS(1750),
    [anon_sym_GT_EQ] = ACTIONS(1750),
    [anon_sym_GT] = ACTIONS(1752),
    [anon_sym_LT_GT] = ACTIONS(1750),
    [anon_sym_is] = ACTIONS(1750),
    [anon_sym_PLUS_EQ] = ACTIONS(1750),
    [anon_sym_DASH_EQ] = ACTIONS(1750),
    [anon_sym_STAR_EQ] = ACTIONS(1750),
    [anon_sym_SLASH_EQ] = ACTIONS(1750),
    [anon_sym_AT_EQ] = ACTIONS(1750),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(1750),
    [anon_sym_PERCENT_EQ] = ACTIONS(1750),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1750),
    [anon_sym_GT_GT_EQ] = ACTIONS(1750),
    [anon_sym_LT_LT_EQ] = ACTIONS(1750),
    [anon_sym_AMP_EQ] = ACTIONS(1750),
    [anon_sym_CARET_EQ] = ACTIONS(1750),
    [anon_sym_PIPE_EQ] = ACTIONS(1750),
    [anon_sym_LBRACK] = ACTIONS(1750),
    [sym_comment] = ACTIONS(72),
    [sym__semicolon] = ACTIONS(1750),
  },
  [456] = {
    [sym__expression] = STATE(890),
    [sym__primary_expression] = STATE(463),
    [sym_not_operator] = STATE(890),
    [sym_boolean_operator] = STATE(890),
    [sym_binary_operator] = STATE(463),
    [sym_unary_operator] = STATE(463),
    [sym_comparison_operator] = STATE(890),
    [sym_lambda] = STATE(890),
    [sym_attribute] = STATE(463),
    [sym_subscript] = STATE(463),
    [sym_call] = STATE(463),
    [sym_list] = STATE(463),
    [sym_list_comprehension] = STATE(463),
    [sym_dictionary] = STATE(463),
    [sym_dictionary_comprehension] = STATE(463),
    [sym_set] = STATE(463),
    [sym_set_comprehension] = STATE(463),
    [sym_parenthesized_expression] = STATE(463),
    [sym_tuple] = STATE(463),
    [sym_generator_expression] = STATE(463),
    [sym_conditional_expression] = STATE(890),
    [sym_concatenated_string] = STATE(463),
    [sym_await] = STATE(890),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_not] = ACTIONS(822),
    [anon_sym_PLUS] = ACTIONS(824),
    [anon_sym_DASH] = ACTIONS(824),
    [anon_sym_TILDE] = ACTIONS(824),
    [anon_sym_lambda] = ACTIONS(826),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(828),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(830),
    [sym_integer] = ACTIONS(832),
    [sym_float] = ACTIONS(832),
    [sym_identifier] = ACTIONS(832),
    [sym_true] = ACTIONS(832),
    [sym_false] = ACTIONS(832),
    [sym_none] = ACTIONS(832),
    [anon_sym_await] = ACTIONS(834),
    [sym_comment] = ACTIONS(72),
  },
  [457] = {
    [sym__expression] = STATE(891),
    [sym__primary_expression] = STATE(463),
    [sym_not_operator] = STATE(891),
    [sym_boolean_operator] = STATE(891),
    [sym_binary_operator] = STATE(463),
    [sym_unary_operator] = STATE(463),
    [sym_comparison_operator] = STATE(891),
    [sym_lambda] = STATE(891),
    [sym_attribute] = STATE(463),
    [sym_subscript] = STATE(463),
    [sym_call] = STATE(463),
    [sym_list] = STATE(463),
    [sym_list_comprehension] = STATE(463),
    [sym_dictionary] = STATE(463),
    [sym_dictionary_comprehension] = STATE(463),
    [sym_set] = STATE(463),
    [sym_set_comprehension] = STATE(463),
    [sym_parenthesized_expression] = STATE(463),
    [sym_tuple] = STATE(463),
    [sym_generator_expression] = STATE(463),
    [sym_conditional_expression] = STATE(891),
    [sym_concatenated_string] = STATE(463),
    [sym_await] = STATE(891),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_not] = ACTIONS(822),
    [anon_sym_PLUS] = ACTIONS(824),
    [anon_sym_DASH] = ACTIONS(824),
    [anon_sym_TILDE] = ACTIONS(824),
    [anon_sym_lambda] = ACTIONS(826),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(828),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(830),
    [sym_integer] = ACTIONS(832),
    [sym_float] = ACTIONS(832),
    [sym_identifier] = ACTIONS(832),
    [sym_true] = ACTIONS(832),
    [sym_false] = ACTIONS(832),
    [sym_none] = ACTIONS(832),
    [anon_sym_await] = ACTIONS(834),
    [sym_comment] = ACTIONS(72),
  },
  [458] = {
    [sym__primary_expression] = STATE(204),
    [sym_binary_operator] = STATE(204),
    [sym_unary_operator] = STATE(204),
    [sym_attribute] = STATE(204),
    [sym_subscript] = STATE(204),
    [sym_call] = STATE(204),
    [sym_list] = STATE(204),
    [sym_list_comprehension] = STATE(204),
    [sym_dictionary] = STATE(204),
    [sym_dictionary_comprehension] = STATE(204),
    [sym_set] = STATE(204),
    [sym_set_comprehension] = STATE(204),
    [sym_parenthesized_expression] = STATE(204),
    [sym_tuple] = STATE(204),
    [sym_generator_expression] = STATE(204),
    [sym_concatenated_string] = STATE(204),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_PLUS] = ACTIONS(824),
    [anon_sym_DASH] = ACTIONS(824),
    [anon_sym_TILDE] = ACTIONS(824),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(376),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(830),
    [sym_integer] = ACTIONS(378),
    [sym_float] = ACTIONS(378),
    [sym_identifier] = ACTIONS(378),
    [sym_true] = ACTIONS(378),
    [sym_false] = ACTIONS(378),
    [sym_none] = ACTIONS(378),
    [sym_comment] = ACTIONS(72),
  },
  [459] = {
    [sym_lambda_parameters] = STATE(893),
    [sym__parameters] = STATE(130),
    [sym_default_parameter] = STATE(131),
    [sym_typed_default_parameter] = STATE(131),
    [sym_list_splat] = STATE(132),
    [sym_dictionary_splat] = STATE(132),
    [sym_typed_parameter] = STATE(131),
    [sym_tuple] = STATE(131),
    [anon_sym_LPAREN] = ACTIONS(222),
    [anon_sym_STAR] = ACTIONS(224),
    [anon_sym_print] = ACTIONS(226),
    [anon_sym_COLON] = ACTIONS(1754),
    [anon_sym_exec] = ACTIONS(226),
    [sym_identifier] = ACTIONS(230),
    [sym_comment] = ACTIONS(72),
  },
  [460] = {
    [aux_sym_concatenated_string_repeat1] = STATE(894),
    [anon_sym_DOT] = ACTIONS(276),
    [anon_sym_LPAREN] = ACTIONS(276),
    [anon_sym_COMMA] = ACTIONS(276),
    [anon_sym_STAR] = ACTIONS(278),
    [anon_sym_GT_GT] = ACTIONS(276),
    [anon_sym_if] = ACTIONS(276),
    [anon_sym_in] = ACTIONS(276),
    [anon_sym_AT] = ACTIONS(276),
    [anon_sym_not] = ACTIONS(276),
    [anon_sym_and] = ACTIONS(276),
    [anon_sym_or] = ACTIONS(276),
    [anon_sym_PLUS] = ACTIONS(276),
    [anon_sym_DASH] = ACTIONS(276),
    [anon_sym_SLASH] = ACTIONS(278),
    [anon_sym_PERCENT] = ACTIONS(276),
    [anon_sym_SLASH_SLASH] = ACTIONS(276),
    [anon_sym_STAR_STAR] = ACTIONS(276),
    [anon_sym_PIPE] = ACTIONS(276),
    [anon_sym_AMP] = ACTIONS(276),
    [anon_sym_CARET] = ACTIONS(276),
    [anon_sym_LT_LT] = ACTIONS(276),
    [anon_sym_LT] = ACTIONS(278),
    [anon_sym_LT_EQ] = ACTIONS(276),
    [anon_sym_EQ_EQ] = ACTIONS(276),
    [anon_sym_BANG_EQ] = ACTIONS(276),
    [anon_sym_GT_EQ] = ACTIONS(276),
    [anon_sym_GT] = ACTIONS(278),
    [anon_sym_LT_GT] = ACTIONS(276),
    [anon_sym_is] = ACTIONS(276),
    [anon_sym_LBRACK] = ACTIONS(276),
    [anon_sym_RBRACE] = ACTIONS(276),
    [sym_string] = ACTIONS(1756),
    [sym_comment] = ACTIONS(72),
  },
  [461] = {
    [sym__expression] = STATE(227),
    [sym__primary_expression] = STATE(463),
    [sym_not_operator] = STATE(227),
    [sym_boolean_operator] = STATE(227),
    [sym_binary_operator] = STATE(463),
    [sym_unary_operator] = STATE(463),
    [sym_comparison_operator] = STATE(227),
    [sym_lambda] = STATE(227),
    [sym_attribute] = STATE(463),
    [sym_subscript] = STATE(463),
    [sym_call] = STATE(463),
    [sym_list] = STATE(463),
    [sym_list_comprehension] = STATE(463),
    [sym_dictionary] = STATE(463),
    [sym_dictionary_comprehension] = STATE(463),
    [sym_set] = STATE(463),
    [sym_set_comprehension] = STATE(463),
    [sym_parenthesized_expression] = STATE(463),
    [sym_tuple] = STATE(463),
    [sym_generator_expression] = STATE(463),
    [sym_conditional_expression] = STATE(227),
    [sym_concatenated_string] = STATE(463),
    [sym_await] = STATE(227),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_not] = ACTIONS(822),
    [anon_sym_PLUS] = ACTIONS(824),
    [anon_sym_DASH] = ACTIONS(824),
    [anon_sym_TILDE] = ACTIONS(824),
    [anon_sym_lambda] = ACTIONS(826),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(828),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(830),
    [sym_integer] = ACTIONS(832),
    [sym_float] = ACTIONS(832),
    [sym_identifier] = ACTIONS(832),
    [sym_true] = ACTIONS(832),
    [sym_false] = ACTIONS(832),
    [sym_none] = ACTIONS(832),
    [anon_sym_await] = ACTIONS(834),
    [sym_comment] = ACTIONS(72),
  },
  [462] = {
    [anon_sym_COMMA] = ACTIONS(1590),
    [anon_sym_if] = ACTIONS(1758),
    [anon_sym_and] = ACTIONS(1760),
    [anon_sym_or] = ACTIONS(1762),
    [anon_sym_RBRACE] = ACTIONS(1590),
    [sym_comment] = ACTIONS(72),
  },
  [463] = {
    [sym_argument_list] = STATE(251),
    [sym_generator_expression] = STATE(251),
    [aux_sym_comparison_operator_repeat1] = STATE(908),
    [anon_sym_DOT] = ACTIONS(422),
    [anon_sym_LPAREN] = ACTIONS(424),
    [anon_sym_COMMA] = ACTIONS(302),
    [anon_sym_STAR] = ACTIONS(1764),
    [anon_sym_GT_GT] = ACTIONS(1766),
    [anon_sym_if] = ACTIONS(302),
    [anon_sym_in] = ACTIONS(1768),
    [anon_sym_AT] = ACTIONS(1770),
    [anon_sym_not] = ACTIONS(1772),
    [anon_sym_and] = ACTIONS(302),
    [anon_sym_or] = ACTIONS(302),
    [anon_sym_PLUS] = ACTIONS(1774),
    [anon_sym_DASH] = ACTIONS(1774),
    [anon_sym_SLASH] = ACTIONS(1764),
    [anon_sym_PERCENT] = ACTIONS(1770),
    [anon_sym_SLASH_SLASH] = ACTIONS(1770),
    [anon_sym_STAR_STAR] = ACTIONS(1776),
    [anon_sym_PIPE] = ACTIONS(1778),
    [anon_sym_AMP] = ACTIONS(1780),
    [anon_sym_CARET] = ACTIONS(1782),
    [anon_sym_LT_LT] = ACTIONS(1766),
    [anon_sym_LT] = ACTIONS(1784),
    [anon_sym_LT_EQ] = ACTIONS(1768),
    [anon_sym_EQ_EQ] = ACTIONS(1768),
    [anon_sym_BANG_EQ] = ACTIONS(1768),
    [anon_sym_GT_EQ] = ACTIONS(1768),
    [anon_sym_GT] = ACTIONS(1784),
    [anon_sym_LT_GT] = ACTIONS(1768),
    [anon_sym_is] = ACTIONS(1786),
    [anon_sym_LBRACK] = ACTIONS(450),
    [anon_sym_RBRACE] = ACTIONS(302),
    [sym_comment] = ACTIONS(72),
  },
  [464] = {
    [anon_sym_COMMA] = ACTIONS(716),
    [anon_sym_if] = ACTIONS(716),
    [anon_sym_COLON] = ACTIONS(716),
    [anon_sym_async] = ACTIONS(716),
    [anon_sym_for] = ACTIONS(716),
    [anon_sym_and] = ACTIONS(858),
    [anon_sym_or] = ACTIONS(860),
    [anon_sym_RBRACE] = ACTIONS(716),
    [sym_comment] = ACTIONS(72),
  },
  [465] = {
    [sym__expression] = STATE(909),
    [sym__primary_expression] = STATE(157),
    [sym_not_operator] = STATE(909),
    [sym_boolean_operator] = STATE(909),
    [sym_binary_operator] = STATE(157),
    [sym_unary_operator] = STATE(157),
    [sym_comparison_operator] = STATE(909),
    [sym_lambda] = STATE(909),
    [sym_attribute] = STATE(157),
    [sym_subscript] = STATE(157),
    [sym_call] = STATE(157),
    [sym_list] = STATE(157),
    [sym_list_comprehension] = STATE(157),
    [sym_dictionary] = STATE(157),
    [sym_dictionary_comprehension] = STATE(157),
    [sym_set] = STATE(157),
    [sym_set_comprehension] = STATE(157),
    [sym_parenthesized_expression] = STATE(157),
    [sym_tuple] = STATE(157),
    [sym_generator_expression] = STATE(157),
    [sym_conditional_expression] = STATE(909),
    [sym_concatenated_string] = STATE(157),
    [sym_await] = STATE(909),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_not] = ACTIONS(260),
    [anon_sym_PLUS] = ACTIONS(262),
    [anon_sym_DASH] = ACTIONS(262),
    [anon_sym_TILDE] = ACTIONS(262),
    [anon_sym_lambda] = ACTIONS(264),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(266),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(270),
    [sym_integer] = ACTIONS(272),
    [sym_float] = ACTIONS(272),
    [sym_identifier] = ACTIONS(272),
    [sym_true] = ACTIONS(272),
    [sym_false] = ACTIONS(272),
    [sym_none] = ACTIONS(272),
    [anon_sym_await] = ACTIONS(274),
    [sym_comment] = ACTIONS(72),
  },
  [466] = {
    [anon_sym_COLON] = ACTIONS(1788),
    [sym_comment] = ACTIONS(72),
  },
  [467] = {
    [aux_sym_concatenated_string_repeat1] = STATE(911),
    [anon_sym_DOT] = ACTIONS(886),
    [anon_sym_LPAREN] = ACTIONS(886),
    [anon_sym_COMMA] = ACTIONS(886),
    [anon_sym_STAR] = ACTIONS(888),
    [anon_sym_GT_GT] = ACTIONS(886),
    [anon_sym_if] = ACTIONS(886),
    [anon_sym_COLON] = ACTIONS(886),
    [anon_sym_async] = ACTIONS(886),
    [anon_sym_for] = ACTIONS(886),
    [anon_sym_in] = ACTIONS(886),
    [anon_sym_AT] = ACTIONS(886),
    [anon_sym_not] = ACTIONS(886),
    [anon_sym_and] = ACTIONS(886),
    [anon_sym_or] = ACTIONS(886),
    [anon_sym_PLUS] = ACTIONS(886),
    [anon_sym_DASH] = ACTIONS(886),
    [anon_sym_SLASH] = ACTIONS(888),
    [anon_sym_PERCENT] = ACTIONS(886),
    [anon_sym_SLASH_SLASH] = ACTIONS(886),
    [anon_sym_STAR_STAR] = ACTIONS(886),
    [anon_sym_PIPE] = ACTIONS(886),
    [anon_sym_AMP] = ACTIONS(886),
    [anon_sym_CARET] = ACTIONS(886),
    [anon_sym_LT_LT] = ACTIONS(886),
    [anon_sym_LT] = ACTIONS(888),
    [anon_sym_LT_EQ] = ACTIONS(886),
    [anon_sym_EQ_EQ] = ACTIONS(886),
    [anon_sym_BANG_EQ] = ACTIONS(886),
    [anon_sym_GT_EQ] = ACTIONS(886),
    [anon_sym_GT] = ACTIONS(888),
    [anon_sym_LT_GT] = ACTIONS(886),
    [anon_sym_is] = ACTIONS(886),
    [anon_sym_LBRACK] = ACTIONS(886),
    [anon_sym_RBRACE] = ACTIONS(886),
    [sym_string] = ACTIONS(1790),
    [sym_comment] = ACTIONS(72),
  },
  [468] = {
    [sym_list_splat] = STATE(870),
    [sym__expression] = STATE(914),
    [sym__primary_expression] = STATE(463),
    [sym_not_operator] = STATE(914),
    [sym_boolean_operator] = STATE(914),
    [sym_binary_operator] = STATE(463),
    [sym_unary_operator] = STATE(463),
    [sym_comparison_operator] = STATE(914),
    [sym_lambda] = STATE(914),
    [sym_attribute] = STATE(463),
    [sym_subscript] = STATE(463),
    [sym_call] = STATE(463),
    [sym_list] = STATE(463),
    [sym_list_comprehension] = STATE(463),
    [sym_dictionary] = STATE(463),
    [sym_dictionary_comprehension] = STATE(463),
    [sym_set] = STATE(463),
    [sym_set_comprehension] = STATE(463),
    [sym_parenthesized_expression] = STATE(463),
    [sym_tuple] = STATE(463),
    [sym_generator_expression] = STATE(463),
    [sym_conditional_expression] = STATE(914),
    [sym_concatenated_string] = STATE(463),
    [sym_await] = STATE(914),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_STAR] = ACTIONS(1792),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_not] = ACTIONS(822),
    [anon_sym_PLUS] = ACTIONS(824),
    [anon_sym_DASH] = ACTIONS(824),
    [anon_sym_TILDE] = ACTIONS(824),
    [anon_sym_lambda] = ACTIONS(826),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(828),
    [anon_sym_LBRACE] = ACTIONS(100),
    [anon_sym_RBRACE] = ACTIONS(1794),
    [sym_string] = ACTIONS(830),
    [sym_integer] = ACTIONS(832),
    [sym_float] = ACTIONS(832),
    [sym_identifier] = ACTIONS(832),
    [sym_true] = ACTIONS(832),
    [sym_false] = ACTIONS(832),
    [sym_none] = ACTIONS(832),
    [anon_sym_await] = ACTIONS(834),
    [sym_comment] = ACTIONS(72),
  },
  [469] = {
    [sym__newline] = ACTIONS(1796),
    [anon_sym_DOT] = ACTIONS(1796),
    [anon_sym_LPAREN] = ACTIONS(1796),
    [anon_sym_COMMA] = ACTIONS(1796),
    [anon_sym_STAR] = ACTIONS(1798),
    [anon_sym_GT_GT] = ACTIONS(1798),
    [anon_sym_if] = ACTIONS(1796),
    [anon_sym_COLON] = ACTIONS(1796),
    [anon_sym_in] = ACTIONS(1796),
    [anon_sym_EQ] = ACTIONS(1798),
    [anon_sym_AT] = ACTIONS(1798),
    [anon_sym_not] = ACTIONS(1796),
    [anon_sym_and] = ACTIONS(1796),
    [anon_sym_or] = ACTIONS(1796),
    [anon_sym_PLUS] = ACTIONS(1798),
    [anon_sym_DASH] = ACTIONS(1798),
    [anon_sym_SLASH] = ACTIONS(1798),
    [anon_sym_PERCENT] = ACTIONS(1798),
    [anon_sym_SLASH_SLASH] = ACTIONS(1798),
    [anon_sym_STAR_STAR] = ACTIONS(1798),
    [anon_sym_PIPE] = ACTIONS(1798),
    [anon_sym_AMP] = ACTIONS(1798),
    [anon_sym_CARET] = ACTIONS(1798),
    [anon_sym_LT_LT] = ACTIONS(1798),
    [anon_sym_LT] = ACTIONS(1798),
    [anon_sym_LT_EQ] = ACTIONS(1796),
    [anon_sym_EQ_EQ] = ACTIONS(1796),
    [anon_sym_BANG_EQ] = ACTIONS(1796),
    [anon_sym_GT_EQ] = ACTIONS(1796),
    [anon_sym_GT] = ACTIONS(1798),
    [anon_sym_LT_GT] = ACTIONS(1796),
    [anon_sym_is] = ACTIONS(1796),
    [anon_sym_PLUS_EQ] = ACTIONS(1796),
    [anon_sym_DASH_EQ] = ACTIONS(1796),
    [anon_sym_STAR_EQ] = ACTIONS(1796),
    [anon_sym_SLASH_EQ] = ACTIONS(1796),
    [anon_sym_AT_EQ] = ACTIONS(1796),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(1796),
    [anon_sym_PERCENT_EQ] = ACTIONS(1796),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1796),
    [anon_sym_GT_GT_EQ] = ACTIONS(1796),
    [anon_sym_LT_LT_EQ] = ACTIONS(1796),
    [anon_sym_AMP_EQ] = ACTIONS(1796),
    [anon_sym_CARET_EQ] = ACTIONS(1796),
    [anon_sym_PIPE_EQ] = ACTIONS(1796),
    [anon_sym_LBRACK] = ACTIONS(1796),
    [sym_comment] = ACTIONS(72),
    [sym__semicolon] = ACTIONS(1796),
  },
  [470] = {
    [aux_sym_list_repeat1] = STATE(916),
    [anon_sym_COMMA] = ACTIONS(1800),
    [anon_sym_RBRACE] = ACTIONS(1794),
    [sym_comment] = ACTIONS(72),
  },
  [471] = {
    [sym_dictionary_splat] = STATE(919),
    [sym__expression] = STATE(920),
    [sym__primary_expression] = STATE(96),
    [sym_not_operator] = STATE(920),
    [sym_boolean_operator] = STATE(920),
    [sym_binary_operator] = STATE(96),
    [sym_unary_operator] = STATE(96),
    [sym_comparison_operator] = STATE(920),
    [sym_lambda] = STATE(920),
    [sym_attribute] = STATE(96),
    [sym_subscript] = STATE(96),
    [sym_call] = STATE(96),
    [sym_list] = STATE(96),
    [sym_list_comprehension] = STATE(96),
    [sym_dictionary] = STATE(96),
    [sym_dictionary_comprehension] = STATE(96),
    [sym_pair] = STATE(919),
    [sym_set] = STATE(96),
    [sym_set_comprehension] = STATE(96),
    [sym_parenthesized_expression] = STATE(96),
    [sym_tuple] = STATE(96),
    [sym_generator_expression] = STATE(96),
    [sym_conditional_expression] = STATE(920),
    [sym_concatenated_string] = STATE(96),
    [sym_await] = STATE(920),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_STAR] = ACTIONS(1802),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_not] = ACTIONS(160),
    [anon_sym_PLUS] = ACTIONS(162),
    [anon_sym_DASH] = ACTIONS(162),
    [anon_sym_TILDE] = ACTIONS(162),
    [anon_sym_lambda] = ACTIONS(164),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(166),
    [anon_sym_LBRACE] = ACTIONS(100),
    [anon_sym_RBRACE] = ACTIONS(1804),
    [sym_string] = ACTIONS(168),
    [sym_integer] = ACTIONS(170),
    [sym_float] = ACTIONS(170),
    [sym_identifier] = ACTIONS(170),
    [sym_true] = ACTIONS(170),
    [sym_false] = ACTIONS(170),
    [sym_none] = ACTIONS(170),
    [anon_sym_await] = ACTIONS(172),
    [sym_comment] = ACTIONS(72),
  },
  [472] = {
    [aux_sym_dictionary_repeat1] = STATE(922),
    [anon_sym_COMMA] = ACTIONS(1806),
    [anon_sym_RBRACE] = ACTIONS(1804),
    [sym_comment] = ACTIONS(72),
  },
  [473] = {
    [sym__expression] = STATE(923),
    [sym__primary_expression] = STATE(513),
    [sym_not_operator] = STATE(923),
    [sym_boolean_operator] = STATE(923),
    [sym_binary_operator] = STATE(513),
    [sym_unary_operator] = STATE(513),
    [sym_comparison_operator] = STATE(923),
    [sym_lambda] = STATE(923),
    [sym_attribute] = STATE(513),
    [sym_subscript] = STATE(513),
    [sym_call] = STATE(513),
    [sym_list] = STATE(513),
    [sym_list_comprehension] = STATE(513),
    [sym_dictionary] = STATE(513),
    [sym_dictionary_comprehension] = STATE(513),
    [sym_set] = STATE(513),
    [sym_set_comprehension] = STATE(513),
    [sym_parenthesized_expression] = STATE(513),
    [sym_tuple] = STATE(513),
    [sym_generator_expression] = STATE(513),
    [sym_conditional_expression] = STATE(923),
    [sym_concatenated_string] = STATE(513),
    [sym_await] = STATE(923),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_not] = ACTIONS(914),
    [anon_sym_PLUS] = ACTIONS(916),
    [anon_sym_DASH] = ACTIONS(916),
    [anon_sym_TILDE] = ACTIONS(916),
    [anon_sym_lambda] = ACTIONS(918),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(920),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(922),
    [sym_integer] = ACTIONS(924),
    [sym_float] = ACTIONS(924),
    [sym_identifier] = ACTIONS(924),
    [sym_true] = ACTIONS(924),
    [sym_false] = ACTIONS(924),
    [sym_none] = ACTIONS(924),
    [anon_sym_await] = ACTIONS(926),
    [sym_comment] = ACTIONS(72),
  },
  [474] = {
    [sym__expression] = STATE(929),
    [sym__primary_expression] = STATE(930),
    [sym_not_operator] = STATE(929),
    [sym_boolean_operator] = STATE(929),
    [sym_binary_operator] = STATE(930),
    [sym_unary_operator] = STATE(930),
    [sym_comparison_operator] = STATE(929),
    [sym_lambda] = STATE(929),
    [sym_attribute] = STATE(930),
    [sym_subscript] = STATE(930),
    [sym_call] = STATE(930),
    [sym_list] = STATE(930),
    [sym_list_comprehension] = STATE(930),
    [sym_dictionary] = STATE(930),
    [sym_dictionary_comprehension] = STATE(930),
    [sym_set] = STATE(930),
    [sym_set_comprehension] = STATE(930),
    [sym_parenthesized_expression] = STATE(930),
    [sym_tuple] = STATE(930),
    [sym_generator_expression] = STATE(930),
    [sym_conditional_expression] = STATE(929),
    [sym_concatenated_string] = STATE(930),
    [sym_await] = STATE(929),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_not] = ACTIONS(1808),
    [anon_sym_PLUS] = ACTIONS(1810),
    [anon_sym_DASH] = ACTIONS(1810),
    [anon_sym_TILDE] = ACTIONS(1810),
    [anon_sym_lambda] = ACTIONS(1812),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(1814),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(1816),
    [sym_integer] = ACTIONS(1818),
    [sym_float] = ACTIONS(1818),
    [sym_identifier] = ACTIONS(1818),
    [sym_true] = ACTIONS(1818),
    [sym_false] = ACTIONS(1818),
    [sym_none] = ACTIONS(1818),
    [anon_sym_await] = ACTIONS(1820),
    [sym_comment] = ACTIONS(72),
  },
  [475] = {
    [anon_sym_for] = ACTIONS(1822),
    [sym_comment] = ACTIONS(72),
  },
  [476] = {
    [sym_variables] = STATE(932),
    [sym__primary_expression] = STATE(103),
    [sym_binary_operator] = STATE(103),
    [sym_unary_operator] = STATE(103),
    [sym_attribute] = STATE(103),
    [sym_subscript] = STATE(103),
    [sym_call] = STATE(103),
    [sym_list] = STATE(103),
    [sym_list_comprehension] = STATE(103),
    [sym_dictionary] = STATE(103),
    [sym_dictionary_comprehension] = STATE(103),
    [sym_set] = STATE(103),
    [sym_set_comprehension] = STATE(103),
    [sym_parenthesized_expression] = STATE(103),
    [sym_tuple] = STATE(103),
    [sym_generator_expression] = STATE(103),
    [sym_concatenated_string] = STATE(103),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_PLUS] = ACTIONS(180),
    [anon_sym_DASH] = ACTIONS(180),
    [anon_sym_TILDE] = ACTIONS(180),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(182),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(184),
    [sym_integer] = ACTIONS(186),
    [sym_float] = ACTIONS(186),
    [sym_identifier] = ACTIONS(186),
    [sym_true] = ACTIONS(186),
    [sym_false] = ACTIONS(186),
    [sym_none] = ACTIONS(186),
    [sym_comment] = ACTIONS(72),
  },
  [477] = {
    [sym__expression] = STATE(604),
    [sym__primary_expression] = STATE(157),
    [sym_not_operator] = STATE(604),
    [sym_boolean_operator] = STATE(604),
    [sym_binary_operator] = STATE(157),
    [sym_unary_operator] = STATE(157),
    [sym_comparison_operator] = STATE(604),
    [sym_lambda] = STATE(604),
    [sym_attribute] = STATE(157),
    [sym_subscript] = STATE(157),
    [sym_call] = STATE(157),
    [sym_list] = STATE(157),
    [sym_list_comprehension] = STATE(157),
    [sym_dictionary] = STATE(157),
    [sym_dictionary_comprehension] = STATE(157),
    [sym_set] = STATE(157),
    [sym_set_comprehension] = STATE(157),
    [sym_parenthesized_expression] = STATE(157),
    [sym_tuple] = STATE(157),
    [sym_generator_expression] = STATE(157),
    [sym_conditional_expression] = STATE(604),
    [sym_concatenated_string] = STATE(157),
    [sym_await] = STATE(604),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_not] = ACTIONS(260),
    [anon_sym_PLUS] = ACTIONS(262),
    [anon_sym_DASH] = ACTIONS(262),
    [anon_sym_TILDE] = ACTIONS(262),
    [anon_sym_lambda] = ACTIONS(264),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(266),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(270),
    [sym_integer] = ACTIONS(272),
    [sym_float] = ACTIONS(272),
    [sym_identifier] = ACTIONS(272),
    [sym_true] = ACTIONS(272),
    [sym_false] = ACTIONS(272),
    [sym_none] = ACTIONS(272),
    [anon_sym_await] = ACTIONS(274),
    [sym_comment] = ACTIONS(72),
  },
  [478] = {
    [sym__expression] = STATE(933),
    [sym__primary_expression] = STATE(157),
    [sym_not_operator] = STATE(933),
    [sym_boolean_operator] = STATE(933),
    [sym_binary_operator] = STATE(157),
    [sym_unary_operator] = STATE(157),
    [sym_comparison_operator] = STATE(933),
    [sym_lambda] = STATE(933),
    [sym_attribute] = STATE(157),
    [sym_subscript] = STATE(157),
    [sym_call] = STATE(157),
    [sym_list] = STATE(157),
    [sym_list_comprehension] = STATE(157),
    [sym_dictionary] = STATE(157),
    [sym_dictionary_comprehension] = STATE(157),
    [sym_set] = STATE(157),
    [sym_set_comprehension] = STATE(157),
    [sym_parenthesized_expression] = STATE(157),
    [sym_tuple] = STATE(157),
    [sym_generator_expression] = STATE(157),
    [sym_conditional_expression] = STATE(933),
    [sym_concatenated_string] = STATE(157),
    [sym_await] = STATE(933),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_not] = ACTIONS(260),
    [anon_sym_PLUS] = ACTIONS(262),
    [anon_sym_DASH] = ACTIONS(262),
    [anon_sym_TILDE] = ACTIONS(262),
    [anon_sym_lambda] = ACTIONS(264),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(266),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(270),
    [sym_integer] = ACTIONS(272),
    [sym_float] = ACTIONS(272),
    [sym_identifier] = ACTIONS(272),
    [sym_true] = ACTIONS(272),
    [sym_false] = ACTIONS(272),
    [sym_none] = ACTIONS(272),
    [anon_sym_await] = ACTIONS(274),
    [sym_comment] = ACTIONS(72),
  },
  [479] = {
    [anon_sym_RBRACE] = ACTIONS(1824),
    [sym_comment] = ACTIONS(72),
  },
  [480] = {
    [sym_for_in_clause] = STATE(936),
    [sym_if_clause] = STATE(936),
    [aux_sym__comprehension_body_repeat1] = STATE(936),
    [anon_sym_if] = ACTIONS(1826),
    [anon_sym_async] = ACTIONS(854),
    [anon_sym_for] = ACTIONS(856),
    [anon_sym_RBRACE] = ACTIONS(1203),
    [sym_comment] = ACTIONS(72),
  },
  [481] = {
    [sym__primary_expression] = STATE(937),
    [sym_binary_operator] = STATE(937),
    [sym_unary_operator] = STATE(937),
    [sym_attribute] = STATE(937),
    [sym_subscript] = STATE(937),
    [sym_call] = STATE(937),
    [sym_list] = STATE(937),
    [sym_list_comprehension] = STATE(937),
    [sym_dictionary] = STATE(937),
    [sym_dictionary_comprehension] = STATE(937),
    [sym_set] = STATE(937),
    [sym_set_comprehension] = STATE(937),
    [sym_parenthesized_expression] = STATE(937),
    [sym_tuple] = STATE(937),
    [sym_generator_expression] = STATE(937),
    [sym_concatenated_string] = STATE(937),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_PLUS] = ACTIONS(262),
    [anon_sym_DASH] = ACTIONS(262),
    [anon_sym_TILDE] = ACTIONS(262),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(1828),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(270),
    [sym_integer] = ACTIONS(1830),
    [sym_float] = ACTIONS(1830),
    [sym_identifier] = ACTIONS(1830),
    [sym_true] = ACTIONS(1830),
    [sym_false] = ACTIONS(1830),
    [sym_none] = ACTIONS(1830),
    [sym_comment] = ACTIONS(72),
  },
  [482] = {
    [sym__primary_expression] = STATE(938),
    [sym_binary_operator] = STATE(938),
    [sym_unary_operator] = STATE(938),
    [sym_attribute] = STATE(938),
    [sym_subscript] = STATE(938),
    [sym_call] = STATE(938),
    [sym_list] = STATE(938),
    [sym_list_comprehension] = STATE(938),
    [sym_dictionary] = STATE(938),
    [sym_dictionary_comprehension] = STATE(938),
    [sym_set] = STATE(938),
    [sym_set_comprehension] = STATE(938),
    [sym_parenthesized_expression] = STATE(938),
    [sym_tuple] = STATE(938),
    [sym_generator_expression] = STATE(938),
    [sym_concatenated_string] = STATE(938),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_PLUS] = ACTIONS(262),
    [anon_sym_DASH] = ACTIONS(262),
    [anon_sym_TILDE] = ACTIONS(262),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(1832),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(270),
    [sym_integer] = ACTIONS(1834),
    [sym_float] = ACTIONS(1834),
    [sym_identifier] = ACTIONS(1834),
    [sym_true] = ACTIONS(1834),
    [sym_false] = ACTIONS(1834),
    [sym_none] = ACTIONS(1834),
    [sym_comment] = ACTIONS(72),
  },
  [483] = {
    [sym__primary_expression] = STATE(939),
    [sym_binary_operator] = STATE(939),
    [sym_unary_operator] = STATE(939),
    [sym_attribute] = STATE(939),
    [sym_subscript] = STATE(939),
    [sym_call] = STATE(939),
    [sym_list] = STATE(939),
    [sym_list_comprehension] = STATE(939),
    [sym_dictionary] = STATE(939),
    [sym_dictionary_comprehension] = STATE(939),
    [sym_set] = STATE(939),
    [sym_set_comprehension] = STATE(939),
    [sym_parenthesized_expression] = STATE(939),
    [sym_tuple] = STATE(939),
    [sym_generator_expression] = STATE(939),
    [sym_concatenated_string] = STATE(939),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_PLUS] = ACTIONS(262),
    [anon_sym_DASH] = ACTIONS(262),
    [anon_sym_TILDE] = ACTIONS(262),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(1836),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(270),
    [sym_integer] = ACTIONS(1838),
    [sym_float] = ACTIONS(1838),
    [sym_identifier] = ACTIONS(1838),
    [sym_true] = ACTIONS(1838),
    [sym_false] = ACTIONS(1838),
    [sym_none] = ACTIONS(1838),
    [sym_comment] = ACTIONS(72),
  },
  [484] = {
    [anon_sym_in] = ACTIONS(1840),
    [sym_comment] = ACTIONS(72),
  },
  [485] = {
    [sym__primary_expression] = STATE(941),
    [sym_binary_operator] = STATE(941),
    [sym_unary_operator] = STATE(941),
    [sym_attribute] = STATE(941),
    [sym_subscript] = STATE(941),
    [sym_call] = STATE(941),
    [sym_list] = STATE(941),
    [sym_list_comprehension] = STATE(941),
    [sym_dictionary] = STATE(941),
    [sym_dictionary_comprehension] = STATE(941),
    [sym_set] = STATE(941),
    [sym_set_comprehension] = STATE(941),
    [sym_parenthesized_expression] = STATE(941),
    [sym_tuple] = STATE(941),
    [sym_generator_expression] = STATE(941),
    [sym_concatenated_string] = STATE(941),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_PLUS] = ACTIONS(262),
    [anon_sym_DASH] = ACTIONS(262),
    [anon_sym_TILDE] = ACTIONS(262),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(1842),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(270),
    [sym_integer] = ACTIONS(1844),
    [sym_float] = ACTIONS(1844),
    [sym_identifier] = ACTIONS(1844),
    [sym_true] = ACTIONS(1844),
    [sym_false] = ACTIONS(1844),
    [sym_none] = ACTIONS(1844),
    [sym_comment] = ACTIONS(72),
  },
  [486] = {
    [sym__primary_expression] = STATE(621),
    [sym_binary_operator] = STATE(621),
    [sym_unary_operator] = STATE(621),
    [sym_attribute] = STATE(621),
    [sym_subscript] = STATE(621),
    [sym_call] = STATE(621),
    [sym_list] = STATE(621),
    [sym_list_comprehension] = STATE(621),
    [sym_dictionary] = STATE(621),
    [sym_dictionary_comprehension] = STATE(621),
    [sym_set] = STATE(621),
    [sym_set_comprehension] = STATE(621),
    [sym_parenthesized_expression] = STATE(621),
    [sym_tuple] = STATE(621),
    [sym_generator_expression] = STATE(621),
    [sym_concatenated_string] = STATE(621),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_PLUS] = ACTIONS(262),
    [anon_sym_DASH] = ACTIONS(262),
    [anon_sym_TILDE] = ACTIONS(262),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(1233),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(270),
    [sym_integer] = ACTIONS(1235),
    [sym_float] = ACTIONS(1235),
    [sym_identifier] = ACTIONS(1235),
    [sym_true] = ACTIONS(1235),
    [sym_false] = ACTIONS(1235),
    [sym_none] = ACTIONS(1235),
    [sym_comment] = ACTIONS(72),
  },
  [487] = {
    [sym__primary_expression] = STATE(942),
    [sym_binary_operator] = STATE(942),
    [sym_unary_operator] = STATE(942),
    [sym_attribute] = STATE(942),
    [sym_subscript] = STATE(942),
    [sym_call] = STATE(942),
    [sym_list] = STATE(942),
    [sym_list_comprehension] = STATE(942),
    [sym_dictionary] = STATE(942),
    [sym_dictionary_comprehension] = STATE(942),
    [sym_set] = STATE(942),
    [sym_set_comprehension] = STATE(942),
    [sym_parenthesized_expression] = STATE(942),
    [sym_tuple] = STATE(942),
    [sym_generator_expression] = STATE(942),
    [sym_concatenated_string] = STATE(942),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_PLUS] = ACTIONS(262),
    [anon_sym_DASH] = ACTIONS(262),
    [anon_sym_TILDE] = ACTIONS(262),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(1846),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(270),
    [sym_integer] = ACTIONS(1848),
    [sym_float] = ACTIONS(1848),
    [sym_identifier] = ACTIONS(1848),
    [sym_true] = ACTIONS(1848),
    [sym_false] = ACTIONS(1848),
    [sym_none] = ACTIONS(1848),
    [sym_comment] = ACTIONS(72),
  },
  [488] = {
    [sym__primary_expression] = STATE(943),
    [sym_binary_operator] = STATE(943),
    [sym_unary_operator] = STATE(943),
    [sym_attribute] = STATE(943),
    [sym_subscript] = STATE(943),
    [sym_call] = STATE(943),
    [sym_list] = STATE(943),
    [sym_list_comprehension] = STATE(943),
    [sym_dictionary] = STATE(943),
    [sym_dictionary_comprehension] = STATE(943),
    [sym_set] = STATE(943),
    [sym_set_comprehension] = STATE(943),
    [sym_parenthesized_expression] = STATE(943),
    [sym_tuple] = STATE(943),
    [sym_generator_expression] = STATE(943),
    [sym_concatenated_string] = STATE(943),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_PLUS] = ACTIONS(262),
    [anon_sym_DASH] = ACTIONS(262),
    [anon_sym_TILDE] = ACTIONS(262),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(1850),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(270),
    [sym_integer] = ACTIONS(1852),
    [sym_float] = ACTIONS(1852),
    [sym_identifier] = ACTIONS(1852),
    [sym_true] = ACTIONS(1852),
    [sym_false] = ACTIONS(1852),
    [sym_none] = ACTIONS(1852),
    [sym_comment] = ACTIONS(72),
  },
  [489] = {
    [sym__primary_expression] = STATE(944),
    [sym_binary_operator] = STATE(944),
    [sym_unary_operator] = STATE(944),
    [sym_attribute] = STATE(944),
    [sym_subscript] = STATE(944),
    [sym_call] = STATE(944),
    [sym_list] = STATE(944),
    [sym_list_comprehension] = STATE(944),
    [sym_dictionary] = STATE(944),
    [sym_dictionary_comprehension] = STATE(944),
    [sym_set] = STATE(944),
    [sym_set_comprehension] = STATE(944),
    [sym_parenthesized_expression] = STATE(944),
    [sym_tuple] = STATE(944),
    [sym_generator_expression] = STATE(944),
    [sym_concatenated_string] = STATE(944),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_PLUS] = ACTIONS(262),
    [anon_sym_DASH] = ACTIONS(262),
    [anon_sym_TILDE] = ACTIONS(262),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(270),
    [sym_integer] = ACTIONS(1856),
    [sym_float] = ACTIONS(1856),
    [sym_identifier] = ACTIONS(1856),
    [sym_true] = ACTIONS(1856),
    [sym_false] = ACTIONS(1856),
    [sym_none] = ACTIONS(1856),
    [sym_comment] = ACTIONS(72),
  },
  [490] = {
    [sym__primary_expression] = STATE(939),
    [sym_binary_operator] = STATE(939),
    [sym_unary_operator] = STATE(939),
    [sym_attribute] = STATE(939),
    [sym_subscript] = STATE(939),
    [sym_call] = STATE(939),
    [sym_list] = STATE(939),
    [sym_list_comprehension] = STATE(939),
    [sym_dictionary] = STATE(939),
    [sym_dictionary_comprehension] = STATE(939),
    [sym_set] = STATE(939),
    [sym_set_comprehension] = STATE(939),
    [sym_parenthesized_expression] = STATE(939),
    [sym_tuple] = STATE(939),
    [sym_generator_expression] = STATE(939),
    [sym_concatenated_string] = STATE(939),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_not] = ACTIONS(1858),
    [anon_sym_PLUS] = ACTIONS(262),
    [anon_sym_DASH] = ACTIONS(262),
    [anon_sym_TILDE] = ACTIONS(262),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(1836),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(270),
    [sym_integer] = ACTIONS(1838),
    [sym_float] = ACTIONS(1838),
    [sym_identifier] = ACTIONS(1838),
    [sym_true] = ACTIONS(1838),
    [sym_false] = ACTIONS(1838),
    [sym_none] = ACTIONS(1838),
    [sym_comment] = ACTIONS(72),
  },
  [491] = {
    [aux_sym_comparison_operator_repeat1] = STATE(945),
    [anon_sym_COMMA] = ACTIONS(998),
    [anon_sym_if] = ACTIONS(998),
    [anon_sym_COLON] = ACTIONS(998),
    [anon_sym_async] = ACTIONS(998),
    [anon_sym_for] = ACTIONS(998),
    [anon_sym_in] = ACTIONS(866),
    [anon_sym_not] = ACTIONS(870),
    [anon_sym_and] = ACTIONS(998),
    [anon_sym_or] = ACTIONS(998),
    [anon_sym_LT] = ACTIONS(882),
    [anon_sym_LT_EQ] = ACTIONS(866),
    [anon_sym_EQ_EQ] = ACTIONS(866),
    [anon_sym_BANG_EQ] = ACTIONS(866),
    [anon_sym_GT_EQ] = ACTIONS(866),
    [anon_sym_GT] = ACTIONS(882),
    [anon_sym_LT_GT] = ACTIONS(866),
    [anon_sym_is] = ACTIONS(884),
    [anon_sym_RBRACE] = ACTIONS(998),
    [sym_comment] = ACTIONS(72),
  },
  [492] = {
    [anon_sym_RBRACE] = ACTIONS(1860),
    [sym_comment] = ACTIONS(72),
  },
  [493] = {
    [aux_sym_concatenated_string_repeat1] = STATE(493),
    [sym__newline] = ACTIONS(1862),
    [anon_sym_DOT] = ACTIONS(1862),
    [anon_sym_LPAREN] = ACTIONS(1862),
    [anon_sym_COMMA] = ACTIONS(1862),
    [anon_sym_STAR] = ACTIONS(1864),
    [anon_sym_GT_GT] = ACTIONS(1864),
    [anon_sym_if] = ACTIONS(1862),
    [anon_sym_COLON] = ACTIONS(1862),
    [anon_sym_in] = ACTIONS(1862),
    [anon_sym_EQ] = ACTIONS(1864),
    [anon_sym_AT] = ACTIONS(1864),
    [anon_sym_not] = ACTIONS(1862),
    [anon_sym_and] = ACTIONS(1862),
    [anon_sym_or] = ACTIONS(1862),
    [anon_sym_PLUS] = ACTIONS(1864),
    [anon_sym_DASH] = ACTIONS(1864),
    [anon_sym_SLASH] = ACTIONS(1864),
    [anon_sym_PERCENT] = ACTIONS(1864),
    [anon_sym_SLASH_SLASH] = ACTIONS(1864),
    [anon_sym_STAR_STAR] = ACTIONS(1864),
    [anon_sym_PIPE] = ACTIONS(1864),
    [anon_sym_AMP] = ACTIONS(1864),
    [anon_sym_CARET] = ACTIONS(1864),
    [anon_sym_LT_LT] = ACTIONS(1864),
    [anon_sym_LT] = ACTIONS(1864),
    [anon_sym_LT_EQ] = ACTIONS(1862),
    [anon_sym_EQ_EQ] = ACTIONS(1862),
    [anon_sym_BANG_EQ] = ACTIONS(1862),
    [anon_sym_GT_EQ] = ACTIONS(1862),
    [anon_sym_GT] = ACTIONS(1864),
    [anon_sym_LT_GT] = ACTIONS(1862),
    [anon_sym_is] = ACTIONS(1862),
    [anon_sym_PLUS_EQ] = ACTIONS(1862),
    [anon_sym_DASH_EQ] = ACTIONS(1862),
    [anon_sym_STAR_EQ] = ACTIONS(1862),
    [anon_sym_SLASH_EQ] = ACTIONS(1862),
    [anon_sym_AT_EQ] = ACTIONS(1862),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(1862),
    [anon_sym_PERCENT_EQ] = ACTIONS(1862),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1862),
    [anon_sym_GT_GT_EQ] = ACTIONS(1862),
    [anon_sym_LT_LT_EQ] = ACTIONS(1862),
    [anon_sym_AMP_EQ] = ACTIONS(1862),
    [anon_sym_CARET_EQ] = ACTIONS(1862),
    [anon_sym_PIPE_EQ] = ACTIONS(1862),
    [anon_sym_LBRACK] = ACTIONS(1862),
    [sym_string] = ACTIONS(1866),
    [sym_comment] = ACTIONS(72),
    [sym__semicolon] = ACTIONS(1862),
  },
  [494] = {
    [sym__expression] = STATE(947),
    [sym__primary_expression] = STATE(500),
    [sym_not_operator] = STATE(947),
    [sym_boolean_operator] = STATE(947),
    [sym_binary_operator] = STATE(500),
    [sym_unary_operator] = STATE(500),
    [sym_comparison_operator] = STATE(947),
    [sym_lambda] = STATE(947),
    [sym_attribute] = STATE(500),
    [sym_subscript] = STATE(500),
    [sym_call] = STATE(500),
    [sym_list] = STATE(500),
    [sym_list_comprehension] = STATE(500),
    [sym_dictionary] = STATE(500),
    [sym_dictionary_comprehension] = STATE(500),
    [sym_set] = STATE(500),
    [sym_set_comprehension] = STATE(500),
    [sym_parenthesized_expression] = STATE(500),
    [sym_tuple] = STATE(500),
    [sym_generator_expression] = STATE(500),
    [sym_conditional_expression] = STATE(947),
    [sym_concatenated_string] = STATE(500),
    [sym_await] = STATE(947),
    [anon_sym_LPAREN] = ACTIONS(130),
    [anon_sym_print] = ACTIONS(112),
    [anon_sym_exec] = ACTIONS(112),
    [anon_sym_not] = ACTIONS(894),
    [anon_sym_PLUS] = ACTIONS(896),
    [anon_sym_DASH] = ACTIONS(896),
    [anon_sym_TILDE] = ACTIONS(896),
    [anon_sym_lambda] = ACTIONS(898),
    [anon_sym_LBRACK] = ACTIONS(134),
    [sym_ellipsis] = ACTIONS(900),
    [anon_sym_LBRACE] = ACTIONS(122),
    [sym_string] = ACTIONS(902),
    [sym_integer] = ACTIONS(904),
    [sym_float] = ACTIONS(904),
    [sym_identifier] = ACTIONS(904),
    [sym_true] = ACTIONS(904),
    [sym_false] = ACTIONS(904),
    [sym_none] = ACTIONS(904),
    [anon_sym_await] = ACTIONS(906),
    [sym_comment] = ACTIONS(72),
  },
  [495] = {
    [sym__primary_expression] = STATE(259),
    [sym_binary_operator] = STATE(259),
    [sym_unary_operator] = STATE(259),
    [sym_attribute] = STATE(259),
    [sym_subscript] = STATE(259),
    [sym_call] = STATE(259),
    [sym_list] = STATE(259),
    [sym_list_comprehension] = STATE(259),
    [sym_dictionary] = STATE(259),
    [sym_dictionary_comprehension] = STATE(259),
    [sym_set] = STATE(259),
    [sym_set_comprehension] = STATE(259),
    [sym_parenthesized_expression] = STATE(259),
    [sym_tuple] = STATE(259),
    [sym_generator_expression] = STATE(259),
    [sym_concatenated_string] = STATE(259),
    [anon_sym_LPAREN] = ACTIONS(130),
    [anon_sym_print] = ACTIONS(112),
    [anon_sym_exec] = ACTIONS(112),
    [anon_sym_PLUS] = ACTIONS(896),
    [anon_sym_DASH] = ACTIONS(896),
    [anon_sym_TILDE] = ACTIONS(896),
    [anon_sym_LBRACK] = ACTIONS(134),
    [sym_ellipsis] = ACTIONS(456),
    [anon_sym_LBRACE] = ACTIONS(122),
    [sym_string] = ACTIONS(902),
    [sym_integer] = ACTIONS(458),
    [sym_float] = ACTIONS(458),
    [sym_identifier] = ACTIONS(458),
    [sym_true] = ACTIONS(458),
    [sym_false] = ACTIONS(458),
    [sym_none] = ACTIONS(458),
    [sym_comment] = ACTIONS(72),
  },
  [496] = {
    [sym_lambda_parameters] = STATE(949),
    [sym__parameters] = STATE(130),
    [sym_default_parameter] = STATE(131),
    [sym_typed_default_parameter] = STATE(131),
    [sym_list_splat] = STATE(132),
    [sym_dictionary_splat] = STATE(132),
    [sym_typed_parameter] = STATE(131),
    [sym_tuple] = STATE(131),
    [anon_sym_LPAREN] = ACTIONS(222),
    [anon_sym_STAR] = ACTIONS(224),
    [anon_sym_print] = ACTIONS(226),
    [anon_sym_COLON] = ACTIONS(1869),
    [anon_sym_exec] = ACTIONS(226),
    [sym_identifier] = ACTIONS(230),
    [sym_comment] = ACTIONS(72),
  },
  [497] = {
    [aux_sym_concatenated_string_repeat1] = STATE(950),
    [sym__newline] = ACTIONS(276),
    [anon_sym_DOT] = ACTIONS(276),
    [anon_sym_LPAREN] = ACTIONS(276),
    [anon_sym_STAR] = ACTIONS(278),
    [anon_sym_GT_GT] = ACTIONS(276),
    [anon_sym_if] = ACTIONS(276),
    [anon_sym_in] = ACTIONS(276),
    [anon_sym_EQ] = ACTIONS(278),
    [anon_sym_AT] = ACTIONS(276),
    [anon_sym_not] = ACTIONS(276),
    [anon_sym_and] = ACTIONS(276),
    [anon_sym_or] = ACTIONS(276),
    [anon_sym_PLUS] = ACTIONS(276),
    [anon_sym_DASH] = ACTIONS(276),
    [anon_sym_SLASH] = ACTIONS(278),
    [anon_sym_PERCENT] = ACTIONS(276),
    [anon_sym_SLASH_SLASH] = ACTIONS(276),
    [anon_sym_STAR_STAR] = ACTIONS(276),
    [anon_sym_PIPE] = ACTIONS(276),
    [anon_sym_AMP] = ACTIONS(276),
    [anon_sym_CARET] = ACTIONS(276),
    [anon_sym_LT_LT] = ACTIONS(276),
    [anon_sym_LT] = ACTIONS(278),
    [anon_sym_LT_EQ] = ACTIONS(276),
    [anon_sym_EQ_EQ] = ACTIONS(276),
    [anon_sym_BANG_EQ] = ACTIONS(276),
    [anon_sym_GT_EQ] = ACTIONS(276),
    [anon_sym_GT] = ACTIONS(278),
    [anon_sym_LT_GT] = ACTIONS(276),
    [anon_sym_is] = ACTIONS(276),
    [anon_sym_LBRACK] = ACTIONS(276),
    [sym_string] = ACTIONS(1871),
    [sym_comment] = ACTIONS(72),
    [sym__semicolon] = ACTIONS(276),
  },
  [498] = {
    [sym__expression] = STATE(160),
    [sym__primary_expression] = STATE(500),
    [sym_not_operator] = STATE(160),
    [sym_boolean_operator] = STATE(160),
    [sym_binary_operator] = STATE(500),
    [sym_unary_operator] = STATE(500),
    [sym_comparison_operator] = STATE(160),
    [sym_lambda] = STATE(160),
    [sym_attribute] = STATE(500),
    [sym_subscript] = STATE(500),
    [sym_call] = STATE(500),
    [sym_list] = STATE(500),
    [sym_list_comprehension] = STATE(500),
    [sym_dictionary] = STATE(500),
    [sym_dictionary_comprehension] = STATE(500),
    [sym_set] = STATE(500),
    [sym_set_comprehension] = STATE(500),
    [sym_parenthesized_expression] = STATE(500),
    [sym_tuple] = STATE(500),
    [sym_generator_expression] = STATE(500),
    [sym_conditional_expression] = STATE(160),
    [sym_concatenated_string] = STATE(500),
    [sym_await] = STATE(160),
    [anon_sym_LPAREN] = ACTIONS(130),
    [anon_sym_print] = ACTIONS(112),
    [anon_sym_exec] = ACTIONS(112),
    [anon_sym_not] = ACTIONS(894),
    [anon_sym_PLUS] = ACTIONS(896),
    [anon_sym_DASH] = ACTIONS(896),
    [anon_sym_TILDE] = ACTIONS(896),
    [anon_sym_lambda] = ACTIONS(898),
    [anon_sym_LBRACK] = ACTIONS(134),
    [sym_ellipsis] = ACTIONS(900),
    [anon_sym_LBRACE] = ACTIONS(122),
    [sym_string] = ACTIONS(902),
    [sym_integer] = ACTIONS(904),
    [sym_float] = ACTIONS(904),
    [sym_identifier] = ACTIONS(904),
    [sym_true] = ACTIONS(904),
    [sym_false] = ACTIONS(904),
    [sym_none] = ACTIONS(904),
    [anon_sym_await] = ACTIONS(906),
    [sym_comment] = ACTIONS(72),
  },
  [499] = {
    [sym__newline] = ACTIONS(1873),
    [anon_sym_if] = ACTIONS(1875),
    [anon_sym_EQ] = ACTIONS(1873),
    [anon_sym_and] = ACTIONS(1877),
    [anon_sym_or] = ACTIONS(1879),
    [sym_comment] = ACTIONS(72),
    [sym__semicolon] = ACTIONS(1873),
  },
  [500] = {
    [sym_argument_list] = STATE(291),
    [sym_generator_expression] = STATE(291),
    [aux_sym_comparison_operator_repeat1] = STATE(964),
    [sym__newline] = ACTIONS(302),
    [anon_sym_DOT] = ACTIONS(482),
    [anon_sym_LPAREN] = ACTIONS(484),
    [anon_sym_STAR] = ACTIONS(1881),
    [anon_sym_GT_GT] = ACTIONS(1883),
    [anon_sym_if] = ACTIONS(302),
    [anon_sym_in] = ACTIONS(1885),
    [anon_sym_EQ] = ACTIONS(314),
    [anon_sym_AT] = ACTIONS(1887),
    [anon_sym_not] = ACTIONS(1889),
    [anon_sym_and] = ACTIONS(302),
    [anon_sym_or] = ACTIONS(302),
    [anon_sym_PLUS] = ACTIONS(1891),
    [anon_sym_DASH] = ACTIONS(1891),
    [anon_sym_SLASH] = ACTIONS(1881),
    [anon_sym_PERCENT] = ACTIONS(1887),
    [anon_sym_SLASH_SLASH] = ACTIONS(1887),
    [anon_sym_STAR_STAR] = ACTIONS(1893),
    [anon_sym_PIPE] = ACTIONS(1895),
    [anon_sym_AMP] = ACTIONS(1897),
    [anon_sym_CARET] = ACTIONS(1899),
    [anon_sym_LT_LT] = ACTIONS(1883),
    [anon_sym_LT] = ACTIONS(1901),
    [anon_sym_LT_EQ] = ACTIONS(1885),
    [anon_sym_EQ_EQ] = ACTIONS(1885),
    [anon_sym_BANG_EQ] = ACTIONS(1885),
    [anon_sym_GT_EQ] = ACTIONS(1885),
    [anon_sym_GT] = ACTIONS(1901),
    [anon_sym_LT_GT] = ACTIONS(1885),
    [anon_sym_is] = ACTIONS(1903),
    [anon_sym_LBRACK] = ACTIONS(510),
    [sym_comment] = ACTIONS(72),
    [sym__semicolon] = ACTIONS(302),
  },
  [501] = {
    [sym__newline] = ACTIONS(1905),
    [anon_sym_EQ] = ACTIONS(1907),
    [sym_comment] = ACTIONS(72),
    [sym__semicolon] = ACTIONS(1905),
  },
  [502] = {
    [sym__newline] = ACTIONS(1909),
    [anon_sym_COLON] = ACTIONS(284),
    [anon_sym_EQ] = ACTIONS(286),
    [anon_sym_PLUS_EQ] = ACTIONS(288),
    [anon_sym_DASH_EQ] = ACTIONS(288),
    [anon_sym_STAR_EQ] = ACTIONS(288),
    [anon_sym_SLASH_EQ] = ACTIONS(288),
    [anon_sym_AT_EQ] = ACTIONS(288),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(288),
    [anon_sym_PERCENT_EQ] = ACTIONS(288),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(288),
    [anon_sym_GT_GT_EQ] = ACTIONS(288),
    [anon_sym_LT_LT_EQ] = ACTIONS(288),
    [anon_sym_AMP_EQ] = ACTIONS(288),
    [anon_sym_CARET_EQ] = ACTIONS(288),
    [anon_sym_PIPE_EQ] = ACTIONS(288),
    [sym_comment] = ACTIONS(72),
    [sym__semicolon] = ACTIONS(1909),
  },
  [503] = {
    [aux_sym_print_statement_repeat1] = STATE(967),
    [sym__newline] = ACTIONS(296),
    [anon_sym_COMMA] = ACTIONS(1911),
    [anon_sym_if] = ACTIONS(294),
    [anon_sym_COLON] = ACTIONS(296),
    [anon_sym_EQ] = ACTIONS(296),
    [anon_sym_and] = ACTIONS(298),
    [anon_sym_or] = ACTIONS(300),
    [anon_sym_PLUS_EQ] = ACTIONS(296),
    [anon_sym_DASH_EQ] = ACTIONS(296),
    [anon_sym_STAR_EQ] = ACTIONS(296),
    [anon_sym_SLASH_EQ] = ACTIONS(296),
    [anon_sym_AT_EQ] = ACTIONS(296),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(296),
    [anon_sym_PERCENT_EQ] = ACTIONS(296),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(296),
    [anon_sym_GT_GT_EQ] = ACTIONS(296),
    [anon_sym_LT_LT_EQ] = ACTIONS(296),
    [anon_sym_AMP_EQ] = ACTIONS(296),
    [anon_sym_CARET_EQ] = ACTIONS(296),
    [anon_sym_PIPE_EQ] = ACTIONS(296),
    [sym_comment] = ACTIONS(72),
    [sym__semicolon] = ACTIONS(296),
  },
  [504] = {
    [sym__newline] = ACTIONS(1905),
    [sym_comment] = ACTIONS(72),
    [sym__semicolon] = ACTIONS(1905),
  },
  [505] = {
    [sym__newline] = ACTIONS(1913),
    [sym_comment] = ACTIONS(72),
    [sym__semicolon] = ACTIONS(1913),
  },
  [506] = {
    [sym__newline] = ACTIONS(1915),
    [anon_sym_COMMA] = ACTIONS(1915),
    [anon_sym_if] = ACTIONS(294),
    [anon_sym_COLON] = ACTIONS(1915),
    [anon_sym_EQ] = ACTIONS(1915),
    [anon_sym_and] = ACTIONS(298),
    [anon_sym_or] = ACTIONS(300),
    [anon_sym_PLUS_EQ] = ACTIONS(1915),
    [anon_sym_DASH_EQ] = ACTIONS(1915),
    [anon_sym_STAR_EQ] = ACTIONS(1915),
    [anon_sym_SLASH_EQ] = ACTIONS(1915),
    [anon_sym_AT_EQ] = ACTIONS(1915),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(1915),
    [anon_sym_PERCENT_EQ] = ACTIONS(1915),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1915),
    [anon_sym_GT_GT_EQ] = ACTIONS(1915),
    [anon_sym_LT_LT_EQ] = ACTIONS(1915),
    [anon_sym_AMP_EQ] = ACTIONS(1915),
    [anon_sym_CARET_EQ] = ACTIONS(1915),
    [anon_sym_PIPE_EQ] = ACTIONS(1915),
    [sym_comment] = ACTIONS(72),
    [sym__semicolon] = ACTIONS(1915),
  },
  [507] = {
    [sym__expression] = STATE(968),
    [sym__primary_expression] = STATE(513),
    [sym_not_operator] = STATE(968),
    [sym_boolean_operator] = STATE(968),
    [sym_binary_operator] = STATE(513),
    [sym_unary_operator] = STATE(513),
    [sym_comparison_operator] = STATE(968),
    [sym_lambda] = STATE(968),
    [sym_attribute] = STATE(513),
    [sym_subscript] = STATE(513),
    [sym_call] = STATE(513),
    [sym_list] = STATE(513),
    [sym_list_comprehension] = STATE(513),
    [sym_dictionary] = STATE(513),
    [sym_dictionary_comprehension] = STATE(513),
    [sym_set] = STATE(513),
    [sym_set_comprehension] = STATE(513),
    [sym_parenthesized_expression] = STATE(513),
    [sym_tuple] = STATE(513),
    [sym_generator_expression] = STATE(513),
    [sym_conditional_expression] = STATE(968),
    [sym_concatenated_string] = STATE(513),
    [sym_await] = STATE(968),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_not] = ACTIONS(914),
    [anon_sym_PLUS] = ACTIONS(916),
    [anon_sym_DASH] = ACTIONS(916),
    [anon_sym_TILDE] = ACTIONS(916),
    [anon_sym_lambda] = ACTIONS(918),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(920),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(922),
    [sym_integer] = ACTIONS(924),
    [sym_float] = ACTIONS(924),
    [sym_identifier] = ACTIONS(924),
    [sym_true] = ACTIONS(924),
    [sym_false] = ACTIONS(924),
    [sym_none] = ACTIONS(924),
    [anon_sym_await] = ACTIONS(926),
    [sym_comment] = ACTIONS(72),
  },
  [508] = {
    [sym__primary_expression] = STATE(204),
    [sym_binary_operator] = STATE(204),
    [sym_unary_operator] = STATE(204),
    [sym_attribute] = STATE(204),
    [sym_subscript] = STATE(204),
    [sym_call] = STATE(204),
    [sym_list] = STATE(204),
    [sym_list_comprehension] = STATE(204),
    [sym_dictionary] = STATE(204),
    [sym_dictionary_comprehension] = STATE(204),
    [sym_set] = STATE(204),
    [sym_set_comprehension] = STATE(204),
    [sym_parenthesized_expression] = STATE(204),
    [sym_tuple] = STATE(204),
    [sym_generator_expression] = STATE(204),
    [sym_concatenated_string] = STATE(204),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_PLUS] = ACTIONS(916),
    [anon_sym_DASH] = ACTIONS(916),
    [anon_sym_TILDE] = ACTIONS(916),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(376),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(922),
    [sym_integer] = ACTIONS(378),
    [sym_float] = ACTIONS(378),
    [sym_identifier] = ACTIONS(378),
    [sym_true] = ACTIONS(378),
    [sym_false] = ACTIONS(378),
    [sym_none] = ACTIONS(378),
    [sym_comment] = ACTIONS(72),
  },
  [509] = {
    [sym_lambda_parameters] = STATE(970),
    [sym__parameters] = STATE(130),
    [sym_default_parameter] = STATE(131),
    [sym_typed_default_parameter] = STATE(131),
    [sym_list_splat] = STATE(132),
    [sym_dictionary_splat] = STATE(132),
    [sym_typed_parameter] = STATE(131),
    [sym_tuple] = STATE(131),
    [anon_sym_LPAREN] = ACTIONS(222),
    [anon_sym_STAR] = ACTIONS(224),
    [anon_sym_print] = ACTIONS(226),
    [anon_sym_COLON] = ACTIONS(1917),
    [anon_sym_exec] = ACTIONS(226),
    [sym_identifier] = ACTIONS(230),
    [sym_comment] = ACTIONS(72),
  },
  [510] = {
    [aux_sym_concatenated_string_repeat1] = STATE(971),
    [anon_sym_DOT] = ACTIONS(276),
    [anon_sym_LPAREN] = ACTIONS(276),
    [anon_sym_STAR] = ACTIONS(278),
    [anon_sym_GT_GT] = ACTIONS(276),
    [anon_sym_if] = ACTIONS(276),
    [anon_sym_else] = ACTIONS(276),
    [anon_sym_in] = ACTIONS(276),
    [anon_sym_AT] = ACTIONS(276),
    [anon_sym_not] = ACTIONS(276),
    [anon_sym_and] = ACTIONS(276),
    [anon_sym_or] = ACTIONS(276),
    [anon_sym_PLUS] = ACTIONS(276),
    [anon_sym_DASH] = ACTIONS(276),
    [anon_sym_SLASH] = ACTIONS(278),
    [anon_sym_PERCENT] = ACTIONS(276),
    [anon_sym_SLASH_SLASH] = ACTIONS(276),
    [anon_sym_STAR_STAR] = ACTIONS(276),
    [anon_sym_PIPE] = ACTIONS(276),
    [anon_sym_AMP] = ACTIONS(276),
    [anon_sym_CARET] = ACTIONS(276),
    [anon_sym_LT_LT] = ACTIONS(276),
    [anon_sym_LT] = ACTIONS(278),
    [anon_sym_LT_EQ] = ACTIONS(276),
    [anon_sym_EQ_EQ] = ACTIONS(276),
    [anon_sym_BANG_EQ] = ACTIONS(276),
    [anon_sym_GT_EQ] = ACTIONS(276),
    [anon_sym_GT] = ACTIONS(278),
    [anon_sym_LT_GT] = ACTIONS(276),
    [anon_sym_is] = ACTIONS(276),
    [anon_sym_LBRACK] = ACTIONS(276),
    [sym_string] = ACTIONS(1919),
    [sym_comment] = ACTIONS(72),
  },
  [511] = {
    [sym__expression] = STATE(227),
    [sym__primary_expression] = STATE(513),
    [sym_not_operator] = STATE(227),
    [sym_boolean_operator] = STATE(227),
    [sym_binary_operator] = STATE(513),
    [sym_unary_operator] = STATE(513),
    [sym_comparison_operator] = STATE(227),
    [sym_lambda] = STATE(227),
    [sym_attribute] = STATE(513),
    [sym_subscript] = STATE(513),
    [sym_call] = STATE(513),
    [sym_list] = STATE(513),
    [sym_list_comprehension] = STATE(513),
    [sym_dictionary] = STATE(513),
    [sym_dictionary_comprehension] = STATE(513),
    [sym_set] = STATE(513),
    [sym_set_comprehension] = STATE(513),
    [sym_parenthesized_expression] = STATE(513),
    [sym_tuple] = STATE(513),
    [sym_generator_expression] = STATE(513),
    [sym_conditional_expression] = STATE(227),
    [sym_concatenated_string] = STATE(513),
    [sym_await] = STATE(227),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_not] = ACTIONS(914),
    [anon_sym_PLUS] = ACTIONS(916),
    [anon_sym_DASH] = ACTIONS(916),
    [anon_sym_TILDE] = ACTIONS(916),
    [anon_sym_lambda] = ACTIONS(918),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(920),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(922),
    [sym_integer] = ACTIONS(924),
    [sym_float] = ACTIONS(924),
    [sym_identifier] = ACTIONS(924),
    [sym_true] = ACTIONS(924),
    [sym_false] = ACTIONS(924),
    [sym_none] = ACTIONS(924),
    [anon_sym_await] = ACTIONS(926),
    [sym_comment] = ACTIONS(72),
  },
  [512] = {
    [anon_sym_if] = ACTIONS(1921),
    [anon_sym_else] = ACTIONS(1923),
    [anon_sym_and] = ACTIONS(1925),
    [anon_sym_or] = ACTIONS(1927),
    [sym_comment] = ACTIONS(72),
  },
  [513] = {
    [sym_argument_list] = STATE(251),
    [sym_generator_expression] = STATE(251),
    [aux_sym_comparison_operator_repeat1] = STATE(986),
    [anon_sym_DOT] = ACTIONS(422),
    [anon_sym_LPAREN] = ACTIONS(424),
    [anon_sym_STAR] = ACTIONS(1929),
    [anon_sym_GT_GT] = ACTIONS(1931),
    [anon_sym_if] = ACTIONS(302),
    [anon_sym_else] = ACTIONS(302),
    [anon_sym_in] = ACTIONS(1933),
    [anon_sym_AT] = ACTIONS(1935),
    [anon_sym_not] = ACTIONS(1937),
    [anon_sym_and] = ACTIONS(302),
    [anon_sym_or] = ACTIONS(302),
    [anon_sym_PLUS] = ACTIONS(1939),
    [anon_sym_DASH] = ACTIONS(1939),
    [anon_sym_SLASH] = ACTIONS(1929),
    [anon_sym_PERCENT] = ACTIONS(1935),
    [anon_sym_SLASH_SLASH] = ACTIONS(1935),
    [anon_sym_STAR_STAR] = ACTIONS(1941),
    [anon_sym_PIPE] = ACTIONS(1943),
    [anon_sym_AMP] = ACTIONS(1945),
    [anon_sym_CARET] = ACTIONS(1947),
    [anon_sym_LT_LT] = ACTIONS(1931),
    [anon_sym_LT] = ACTIONS(1949),
    [anon_sym_LT_EQ] = ACTIONS(1933),
    [anon_sym_EQ_EQ] = ACTIONS(1933),
    [anon_sym_BANG_EQ] = ACTIONS(1933),
    [anon_sym_GT_EQ] = ACTIONS(1933),
    [anon_sym_GT] = ACTIONS(1949),
    [anon_sym_LT_GT] = ACTIONS(1933),
    [anon_sym_is] = ACTIONS(1951),
    [anon_sym_LBRACK] = ACTIONS(450),
    [sym_comment] = ACTIONS(72),
  },
  [514] = {
    [sym__newline] = ACTIONS(1953),
    [anon_sym_from] = ACTIONS(1953),
    [anon_sym_COMMA] = ACTIONS(1953),
    [anon_sym_if] = ACTIONS(1953),
    [anon_sym_COLON] = ACTIONS(1953),
    [anon_sym_EQ] = ACTIONS(1953),
    [anon_sym_and] = ACTIONS(1953),
    [anon_sym_or] = ACTIONS(1953),
    [anon_sym_PLUS_EQ] = ACTIONS(1953),
    [anon_sym_DASH_EQ] = ACTIONS(1953),
    [anon_sym_STAR_EQ] = ACTIONS(1953),
    [anon_sym_SLASH_EQ] = ACTIONS(1953),
    [anon_sym_AT_EQ] = ACTIONS(1953),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(1953),
    [anon_sym_PERCENT_EQ] = ACTIONS(1953),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1953),
    [anon_sym_GT_GT_EQ] = ACTIONS(1953),
    [anon_sym_LT_LT_EQ] = ACTIONS(1953),
    [anon_sym_AMP_EQ] = ACTIONS(1953),
    [anon_sym_CARET_EQ] = ACTIONS(1953),
    [anon_sym_PIPE_EQ] = ACTIONS(1953),
    [sym_comment] = ACTIONS(72),
    [sym__semicolon] = ACTIONS(1953),
  },
  [515] = {
    [sym__newline] = ACTIONS(1953),
    [anon_sym_COMMA] = ACTIONS(1953),
    [anon_sym_if] = ACTIONS(1953),
    [anon_sym_COLON] = ACTIONS(1953),
    [anon_sym_EQ] = ACTIONS(1953),
    [anon_sym_and] = ACTIONS(298),
    [anon_sym_or] = ACTIONS(1953),
    [anon_sym_PLUS_EQ] = ACTIONS(1953),
    [anon_sym_DASH_EQ] = ACTIONS(1953),
    [anon_sym_STAR_EQ] = ACTIONS(1953),
    [anon_sym_SLASH_EQ] = ACTIONS(1953),
    [anon_sym_AT_EQ] = ACTIONS(1953),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(1953),
    [anon_sym_PERCENT_EQ] = ACTIONS(1953),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1953),
    [anon_sym_GT_GT_EQ] = ACTIONS(1953),
    [anon_sym_LT_LT_EQ] = ACTIONS(1953),
    [anon_sym_AMP_EQ] = ACTIONS(1953),
    [anon_sym_CARET_EQ] = ACTIONS(1953),
    [anon_sym_PIPE_EQ] = ACTIONS(1953),
    [sym_comment] = ACTIONS(72),
    [sym__semicolon] = ACTIONS(1953),
  },
  [516] = {
    [sym__expression] = STATE(506),
    [sym__primary_expression] = STATE(34),
    [sym_not_operator] = STATE(506),
    [sym_boolean_operator] = STATE(506),
    [sym_binary_operator] = STATE(34),
    [sym_unary_operator] = STATE(34),
    [sym_comparison_operator] = STATE(506),
    [sym_lambda] = STATE(506),
    [sym_attribute] = STATE(34),
    [sym_subscript] = STATE(34),
    [sym_call] = STATE(34),
    [sym_list] = STATE(34),
    [sym_list_comprehension] = STATE(34),
    [sym_dictionary] = STATE(34),
    [sym_dictionary_comprehension] = STATE(34),
    [sym_set] = STATE(34),
    [sym_set_comprehension] = STATE(34),
    [sym_parenthesized_expression] = STATE(34),
    [sym_tuple] = STATE(34),
    [sym_generator_expression] = STATE(34),
    [sym_conditional_expression] = STATE(506),
    [sym_concatenated_string] = STATE(34),
    [sym_await] = STATE(506),
    [sym__newline] = ACTIONS(1955),
    [anon_sym_LPAREN] = ACTIONS(14),
    [anon_sym_print] = ACTIONS(216),
    [anon_sym_COLON] = ACTIONS(1957),
    [anon_sym_EQ] = ACTIONS(1957),
    [anon_sym_exec] = ACTIONS(216),
    [anon_sym_not] = ACTIONS(52),
    [anon_sym_PLUS] = ACTIONS(912),
    [anon_sym_DASH] = ACTIONS(912),
    [anon_sym_TILDE] = ACTIONS(54),
    [anon_sym_lambda] = ACTIONS(56),
    [anon_sym_PLUS_EQ] = ACTIONS(1957),
    [anon_sym_DASH_EQ] = ACTIONS(1957),
    [anon_sym_STAR_EQ] = ACTIONS(1957),
    [anon_sym_SLASH_EQ] = ACTIONS(1957),
    [anon_sym_AT_EQ] = ACTIONS(1957),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(1957),
    [anon_sym_PERCENT_EQ] = ACTIONS(1957),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1957),
    [anon_sym_GT_GT_EQ] = ACTIONS(1957),
    [anon_sym_LT_LT_EQ] = ACTIONS(1957),
    [anon_sym_AMP_EQ] = ACTIONS(1957),
    [anon_sym_CARET_EQ] = ACTIONS(1957),
    [anon_sym_PIPE_EQ] = ACTIONS(1957),
    [anon_sym_LBRACK] = ACTIONS(60),
    [sym_ellipsis] = ACTIONS(62),
    [anon_sym_LBRACE] = ACTIONS(64),
    [sym_string] = ACTIONS(66),
    [sym_integer] = ACTIONS(68),
    [sym_float] = ACTIONS(68),
    [sym_identifier] = ACTIONS(68),
    [sym_true] = ACTIONS(68),
    [sym_false] = ACTIONS(68),
    [sym_none] = ACTIONS(68),
    [anon_sym_await] = ACTIONS(70),
    [sym_comment] = ACTIONS(72),
    [sym__semicolon] = ACTIONS(1955),
  },
  [517] = {
    [aux_sym_print_statement_repeat1] = STATE(517),
    [sym__newline] = ACTIONS(1915),
    [anon_sym_COMMA] = ACTIONS(1959),
    [anon_sym_COLON] = ACTIONS(1915),
    [anon_sym_EQ] = ACTIONS(1915),
    [anon_sym_PLUS_EQ] = ACTIONS(1915),
    [anon_sym_DASH_EQ] = ACTIONS(1915),
    [anon_sym_STAR_EQ] = ACTIONS(1915),
    [anon_sym_SLASH_EQ] = ACTIONS(1915),
    [anon_sym_AT_EQ] = ACTIONS(1915),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(1915),
    [anon_sym_PERCENT_EQ] = ACTIONS(1915),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1915),
    [anon_sym_GT_GT_EQ] = ACTIONS(1915),
    [anon_sym_LT_LT_EQ] = ACTIONS(1915),
    [anon_sym_AMP_EQ] = ACTIONS(1915),
    [anon_sym_CARET_EQ] = ACTIONS(1915),
    [anon_sym_PIPE_EQ] = ACTIONS(1915),
    [sym_comment] = ACTIONS(72),
    [sym__semicolon] = ACTIONS(1915),
  },
  [518] = {
    [sym__newline] = ACTIONS(1962),
    [anon_sym_DOT] = ACTIONS(1962),
    [anon_sym_LPAREN] = ACTIONS(1962),
    [anon_sym_COMMA] = ACTIONS(1962),
    [anon_sym_STAR] = ACTIONS(1964),
    [anon_sym_GT_GT] = ACTIONS(1964),
    [anon_sym_if] = ACTIONS(1962),
    [anon_sym_COLON] = ACTIONS(1962),
    [anon_sym_in] = ACTIONS(1962),
    [anon_sym_EQ] = ACTIONS(1964),
    [anon_sym_AT] = ACTIONS(1964),
    [anon_sym_not] = ACTIONS(1962),
    [anon_sym_and] = ACTIONS(1962),
    [anon_sym_or] = ACTIONS(1962),
    [anon_sym_PLUS] = ACTIONS(1964),
    [anon_sym_DASH] = ACTIONS(1964),
    [anon_sym_SLASH] = ACTIONS(1964),
    [anon_sym_PERCENT] = ACTIONS(1964),
    [anon_sym_SLASH_SLASH] = ACTIONS(1964),
    [anon_sym_STAR_STAR] = ACTIONS(1964),
    [anon_sym_PIPE] = ACTIONS(1964),
    [anon_sym_AMP] = ACTIONS(1964),
    [anon_sym_CARET] = ACTIONS(1964),
    [anon_sym_LT_LT] = ACTIONS(1964),
    [anon_sym_LT] = ACTIONS(1964),
    [anon_sym_LT_EQ] = ACTIONS(1962),
    [anon_sym_EQ_EQ] = ACTIONS(1962),
    [anon_sym_BANG_EQ] = ACTIONS(1962),
    [anon_sym_GT_EQ] = ACTIONS(1962),
    [anon_sym_GT] = ACTIONS(1964),
    [anon_sym_LT_GT] = ACTIONS(1962),
    [anon_sym_is] = ACTIONS(1962),
    [anon_sym_PLUS_EQ] = ACTIONS(1962),
    [anon_sym_DASH_EQ] = ACTIONS(1962),
    [anon_sym_STAR_EQ] = ACTIONS(1962),
    [anon_sym_SLASH_EQ] = ACTIONS(1962),
    [anon_sym_AT_EQ] = ACTIONS(1962),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(1962),
    [anon_sym_PERCENT_EQ] = ACTIONS(1962),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1962),
    [anon_sym_GT_GT_EQ] = ACTIONS(1962),
    [anon_sym_LT_LT_EQ] = ACTIONS(1962),
    [anon_sym_AMP_EQ] = ACTIONS(1962),
    [anon_sym_CARET_EQ] = ACTIONS(1962),
    [anon_sym_PIPE_EQ] = ACTIONS(1962),
    [anon_sym_LBRACK] = ACTIONS(1962),
    [sym_comment] = ACTIONS(72),
    [sym__semicolon] = ACTIONS(1962),
  },
  [519] = {
    [sym__newline] = ACTIONS(1966),
    [anon_sym_DOT] = ACTIONS(1966),
    [anon_sym_LPAREN] = ACTIONS(1966),
    [anon_sym_COMMA] = ACTIONS(1966),
    [anon_sym_STAR] = ACTIONS(1968),
    [anon_sym_GT_GT] = ACTIONS(1968),
    [anon_sym_if] = ACTIONS(1966),
    [anon_sym_COLON] = ACTIONS(1966),
    [anon_sym_in] = ACTIONS(1966),
    [anon_sym_EQ] = ACTIONS(1968),
    [anon_sym_AT] = ACTIONS(1968),
    [anon_sym_not] = ACTIONS(1966),
    [anon_sym_and] = ACTIONS(1966),
    [anon_sym_or] = ACTIONS(1966),
    [anon_sym_PLUS] = ACTIONS(1968),
    [anon_sym_DASH] = ACTIONS(1968),
    [anon_sym_SLASH] = ACTIONS(1968),
    [anon_sym_PERCENT] = ACTIONS(1968),
    [anon_sym_SLASH_SLASH] = ACTIONS(1968),
    [anon_sym_STAR_STAR] = ACTIONS(1968),
    [anon_sym_PIPE] = ACTIONS(1968),
    [anon_sym_AMP] = ACTIONS(1968),
    [anon_sym_CARET] = ACTIONS(1968),
    [anon_sym_LT_LT] = ACTIONS(1968),
    [anon_sym_LT] = ACTIONS(1968),
    [anon_sym_LT_EQ] = ACTIONS(1966),
    [anon_sym_EQ_EQ] = ACTIONS(1966),
    [anon_sym_BANG_EQ] = ACTIONS(1966),
    [anon_sym_GT_EQ] = ACTIONS(1966),
    [anon_sym_GT] = ACTIONS(1968),
    [anon_sym_LT_GT] = ACTIONS(1966),
    [anon_sym_is] = ACTIONS(1966),
    [anon_sym_PLUS_EQ] = ACTIONS(1966),
    [anon_sym_DASH_EQ] = ACTIONS(1966),
    [anon_sym_STAR_EQ] = ACTIONS(1966),
    [anon_sym_SLASH_EQ] = ACTIONS(1966),
    [anon_sym_AT_EQ] = ACTIONS(1966),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(1966),
    [anon_sym_PERCENT_EQ] = ACTIONS(1966),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1966),
    [anon_sym_GT_GT_EQ] = ACTIONS(1966),
    [anon_sym_LT_LT_EQ] = ACTIONS(1966),
    [anon_sym_AMP_EQ] = ACTIONS(1966),
    [anon_sym_CARET_EQ] = ACTIONS(1966),
    [anon_sym_PIPE_EQ] = ACTIONS(1966),
    [anon_sym_LBRACK] = ACTIONS(1966),
    [sym_comment] = ACTIONS(72),
    [sym__semicolon] = ACTIONS(1966),
  },
  [520] = {
    [anon_sym_RPAREN] = ACTIONS(1970),
    [sym_comment] = ACTIONS(72),
  },
  [521] = {
    [sym__expression] = STATE(990),
    [sym__primary_expression] = STATE(215),
    [sym_not_operator] = STATE(990),
    [sym_boolean_operator] = STATE(990),
    [sym_binary_operator] = STATE(215),
    [sym_unary_operator] = STATE(215),
    [sym_comparison_operator] = STATE(990),
    [sym_lambda] = STATE(990),
    [sym_attribute] = STATE(215),
    [sym_subscript] = STATE(215),
    [sym_call] = STATE(215),
    [sym_list] = STATE(215),
    [sym_list_comprehension] = STATE(215),
    [sym_dictionary] = STATE(215),
    [sym_dictionary_comprehension] = STATE(215),
    [sym_set] = STATE(215),
    [sym_set_comprehension] = STATE(215),
    [sym_parenthesized_expression] = STATE(215),
    [sym_tuple] = STATE(215),
    [sym_generator_expression] = STATE(215),
    [sym_conditional_expression] = STATE(990),
    [sym_concatenated_string] = STATE(215),
    [sym_await] = STATE(990),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_RPAREN] = ACTIONS(722),
    [anon_sym_COMMA] = ACTIONS(722),
    [anon_sym_STAR] = ACTIONS(1972),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_not] = ACTIONS(384),
    [anon_sym_PLUS] = ACTIONS(386),
    [anon_sym_DASH] = ACTIONS(386),
    [anon_sym_TILDE] = ACTIONS(386),
    [anon_sym_lambda] = ACTIONS(388),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(390),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(392),
    [sym_integer] = ACTIONS(394),
    [sym_float] = ACTIONS(394),
    [sym_identifier] = ACTIONS(394),
    [sym_true] = ACTIONS(394),
    [sym_false] = ACTIONS(394),
    [sym_none] = ACTIONS(394),
    [anon_sym_await] = ACTIONS(396),
    [sym_comment] = ACTIONS(72),
  },
  [522] = {
    [anon_sym_DOT] = ACTIONS(108),
    [anon_sym_LPAREN] = ACTIONS(108),
    [anon_sym_RPAREN] = ACTIONS(108),
    [anon_sym_COMMA] = ACTIONS(108),
    [anon_sym_STAR] = ACTIONS(110),
    [anon_sym_GT_GT] = ACTIONS(108),
    [anon_sym_if] = ACTIONS(108),
    [anon_sym_async] = ACTIONS(108),
    [anon_sym_for] = ACTIONS(108),
    [anon_sym_in] = ACTIONS(108),
    [anon_sym_EQ] = ACTIONS(1974),
    [anon_sym_AT] = ACTIONS(108),
    [anon_sym_not] = ACTIONS(108),
    [anon_sym_and] = ACTIONS(108),
    [anon_sym_or] = ACTIONS(108),
    [anon_sym_PLUS] = ACTIONS(108),
    [anon_sym_DASH] = ACTIONS(108),
    [anon_sym_SLASH] = ACTIONS(110),
    [anon_sym_PERCENT] = ACTIONS(108),
    [anon_sym_SLASH_SLASH] = ACTIONS(108),
    [anon_sym_STAR_STAR] = ACTIONS(108),
    [anon_sym_PIPE] = ACTIONS(108),
    [anon_sym_AMP] = ACTIONS(108),
    [anon_sym_CARET] = ACTIONS(108),
    [anon_sym_LT_LT] = ACTIONS(108),
    [anon_sym_LT] = ACTIONS(110),
    [anon_sym_LT_EQ] = ACTIONS(108),
    [anon_sym_EQ_EQ] = ACTIONS(108),
    [anon_sym_BANG_EQ] = ACTIONS(108),
    [anon_sym_GT_EQ] = ACTIONS(108),
    [anon_sym_GT] = ACTIONS(110),
    [anon_sym_LT_GT] = ACTIONS(108),
    [anon_sym_is] = ACTIONS(108),
    [anon_sym_LBRACK] = ACTIONS(108),
    [sym_comment] = ACTIONS(72),
  },
  [523] = {
    [anon_sym_DOT] = ACTIONS(276),
    [anon_sym_LPAREN] = ACTIONS(276),
    [anon_sym_RPAREN] = ACTIONS(276),
    [anon_sym_COMMA] = ACTIONS(276),
    [anon_sym_STAR] = ACTIONS(278),
    [anon_sym_GT_GT] = ACTIONS(276),
    [anon_sym_if] = ACTIONS(276),
    [anon_sym_async] = ACTIONS(276),
    [anon_sym_for] = ACTIONS(276),
    [anon_sym_in] = ACTIONS(276),
    [anon_sym_EQ] = ACTIONS(1976),
    [anon_sym_AT] = ACTIONS(276),
    [anon_sym_not] = ACTIONS(276),
    [anon_sym_and] = ACTIONS(276),
    [anon_sym_or] = ACTIONS(276),
    [anon_sym_PLUS] = ACTIONS(276),
    [anon_sym_DASH] = ACTIONS(276),
    [anon_sym_SLASH] = ACTIONS(278),
    [anon_sym_PERCENT] = ACTIONS(276),
    [anon_sym_SLASH_SLASH] = ACTIONS(276),
    [anon_sym_STAR_STAR] = ACTIONS(276),
    [anon_sym_PIPE] = ACTIONS(276),
    [anon_sym_AMP] = ACTIONS(276),
    [anon_sym_CARET] = ACTIONS(276),
    [anon_sym_LT_LT] = ACTIONS(276),
    [anon_sym_LT] = ACTIONS(278),
    [anon_sym_LT_EQ] = ACTIONS(276),
    [anon_sym_EQ_EQ] = ACTIONS(276),
    [anon_sym_BANG_EQ] = ACTIONS(276),
    [anon_sym_GT_EQ] = ACTIONS(276),
    [anon_sym_GT] = ACTIONS(278),
    [anon_sym_LT_GT] = ACTIONS(276),
    [anon_sym_is] = ACTIONS(276),
    [anon_sym_LBRACK] = ACTIONS(276),
    [sym_comment] = ACTIONS(72),
  },
  [524] = {
    [aux_sym_argument_list_repeat1] = STATE(994),
    [anon_sym_RPAREN] = ACTIONS(1970),
    [anon_sym_COMMA] = ACTIONS(1978),
    [sym_comment] = ACTIONS(72),
  },
  [525] = {
    [sym__comprehension_body] = STATE(235),
    [sym_for_in_clause] = STATE(236),
    [aux_sym_argument_list_repeat1] = STATE(994),
    [anon_sym_RPAREN] = ACTIONS(1970),
    [anon_sym_COMMA] = ACTIONS(1978),
    [anon_sym_if] = ACTIONS(412),
    [anon_sym_async] = ACTIONS(414),
    [anon_sym_for] = ACTIONS(416),
    [anon_sym_and] = ACTIONS(418),
    [anon_sym_or] = ACTIONS(420),
    [sym_comment] = ACTIONS(72),
  },
  [526] = {
    [sym_argument_list] = STATE(182),
    [sym_generator_expression] = STATE(182),
    [sym__newline] = ACTIONS(1980),
    [anon_sym_DOT] = ACTIONS(1980),
    [anon_sym_LPAREN] = ACTIONS(306),
    [anon_sym_COMMA] = ACTIONS(1980),
    [anon_sym_STAR] = ACTIONS(1982),
    [anon_sym_GT_GT] = ACTIONS(1982),
    [anon_sym_if] = ACTIONS(1980),
    [anon_sym_COLON] = ACTIONS(1980),
    [anon_sym_in] = ACTIONS(1980),
    [anon_sym_EQ] = ACTIONS(1982),
    [anon_sym_AT] = ACTIONS(1982),
    [anon_sym_not] = ACTIONS(1980),
    [anon_sym_and] = ACTIONS(1980),
    [anon_sym_or] = ACTIONS(1980),
    [anon_sym_PLUS] = ACTIONS(1982),
    [anon_sym_DASH] = ACTIONS(1982),
    [anon_sym_SLASH] = ACTIONS(1982),
    [anon_sym_PERCENT] = ACTIONS(1982),
    [anon_sym_SLASH_SLASH] = ACTIONS(1982),
    [anon_sym_STAR_STAR] = ACTIONS(320),
    [anon_sym_PIPE] = ACTIONS(1982),
    [anon_sym_AMP] = ACTIONS(1982),
    [anon_sym_CARET] = ACTIONS(1982),
    [anon_sym_LT_LT] = ACTIONS(1982),
    [anon_sym_LT] = ACTIONS(1982),
    [anon_sym_LT_EQ] = ACTIONS(1980),
    [anon_sym_EQ_EQ] = ACTIONS(1980),
    [anon_sym_BANG_EQ] = ACTIONS(1980),
    [anon_sym_GT_EQ] = ACTIONS(1980),
    [anon_sym_GT] = ACTIONS(1982),
    [anon_sym_LT_GT] = ACTIONS(1980),
    [anon_sym_is] = ACTIONS(1980),
    [anon_sym_PLUS_EQ] = ACTIONS(1980),
    [anon_sym_DASH_EQ] = ACTIONS(1980),
    [anon_sym_STAR_EQ] = ACTIONS(1980),
    [anon_sym_SLASH_EQ] = ACTIONS(1980),
    [anon_sym_AT_EQ] = ACTIONS(1980),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(1980),
    [anon_sym_PERCENT_EQ] = ACTIONS(1980),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1980),
    [anon_sym_GT_GT_EQ] = ACTIONS(1980),
    [anon_sym_LT_LT_EQ] = ACTIONS(1980),
    [anon_sym_AMP_EQ] = ACTIONS(1980),
    [anon_sym_CARET_EQ] = ACTIONS(1980),
    [anon_sym_PIPE_EQ] = ACTIONS(1980),
    [anon_sym_LBRACK] = ACTIONS(1980),
    [sym_comment] = ACTIONS(72),
    [sym__semicolon] = ACTIONS(1980),
  },
  [527] = {
    [sym_argument_list] = STATE(182),
    [sym_generator_expression] = STATE(182),
    [sym__newline] = ACTIONS(1980),
    [anon_sym_DOT] = ACTIONS(1980),
    [anon_sym_LPAREN] = ACTIONS(306),
    [anon_sym_COMMA] = ACTIONS(1980),
    [anon_sym_STAR] = ACTIONS(308),
    [anon_sym_GT_GT] = ACTIONS(1982),
    [anon_sym_if] = ACTIONS(1980),
    [anon_sym_COLON] = ACTIONS(1980),
    [anon_sym_in] = ACTIONS(1980),
    [anon_sym_EQ] = ACTIONS(1982),
    [anon_sym_AT] = ACTIONS(308),
    [anon_sym_not] = ACTIONS(1980),
    [anon_sym_and] = ACTIONS(1980),
    [anon_sym_or] = ACTIONS(1980),
    [anon_sym_PLUS] = ACTIONS(318),
    [anon_sym_DASH] = ACTIONS(318),
    [anon_sym_SLASH] = ACTIONS(308),
    [anon_sym_PERCENT] = ACTIONS(308),
    [anon_sym_SLASH_SLASH] = ACTIONS(308),
    [anon_sym_STAR_STAR] = ACTIONS(320),
    [anon_sym_PIPE] = ACTIONS(1982),
    [anon_sym_AMP] = ACTIONS(1982),
    [anon_sym_CARET] = ACTIONS(1982),
    [anon_sym_LT_LT] = ACTIONS(1982),
    [anon_sym_LT] = ACTIONS(1982),
    [anon_sym_LT_EQ] = ACTIONS(1980),
    [anon_sym_EQ_EQ] = ACTIONS(1980),
    [anon_sym_BANG_EQ] = ACTIONS(1980),
    [anon_sym_GT_EQ] = ACTIONS(1980),
    [anon_sym_GT] = ACTIONS(1982),
    [anon_sym_LT_GT] = ACTIONS(1980),
    [anon_sym_is] = ACTIONS(1980),
    [anon_sym_PLUS_EQ] = ACTIONS(1980),
    [anon_sym_DASH_EQ] = ACTIONS(1980),
    [anon_sym_STAR_EQ] = ACTIONS(1980),
    [anon_sym_SLASH_EQ] = ACTIONS(1980),
    [anon_sym_AT_EQ] = ACTIONS(1980),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(1980),
    [anon_sym_PERCENT_EQ] = ACTIONS(1980),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1980),
    [anon_sym_GT_GT_EQ] = ACTIONS(1980),
    [anon_sym_LT_LT_EQ] = ACTIONS(1980),
    [anon_sym_AMP_EQ] = ACTIONS(1980),
    [anon_sym_CARET_EQ] = ACTIONS(1980),
    [anon_sym_PIPE_EQ] = ACTIONS(1980),
    [anon_sym_LBRACK] = ACTIONS(1980),
    [sym_comment] = ACTIONS(72),
    [sym__semicolon] = ACTIONS(1980),
  },
  [528] = {
    [sym_argument_list] = STATE(182),
    [sym_generator_expression] = STATE(182),
    [sym__newline] = ACTIONS(1984),
    [anon_sym_DOT] = ACTIONS(304),
    [anon_sym_LPAREN] = ACTIONS(306),
    [anon_sym_COMMA] = ACTIONS(1984),
    [anon_sym_STAR] = ACTIONS(308),
    [anon_sym_GT_GT] = ACTIONS(310),
    [anon_sym_if] = ACTIONS(1984),
    [anon_sym_COLON] = ACTIONS(1984),
    [anon_sym_in] = ACTIONS(1984),
    [anon_sym_EQ] = ACTIONS(1986),
    [anon_sym_AT] = ACTIONS(308),
    [anon_sym_not] = ACTIONS(1984),
    [anon_sym_and] = ACTIONS(1984),
    [anon_sym_or] = ACTIONS(1984),
    [anon_sym_PLUS] = ACTIONS(318),
    [anon_sym_DASH] = ACTIONS(318),
    [anon_sym_SLASH] = ACTIONS(308),
    [anon_sym_PERCENT] = ACTIONS(308),
    [anon_sym_SLASH_SLASH] = ACTIONS(308),
    [anon_sym_STAR_STAR] = ACTIONS(320),
    [anon_sym_PIPE] = ACTIONS(322),
    [anon_sym_AMP] = ACTIONS(324),
    [anon_sym_CARET] = ACTIONS(326),
    [anon_sym_LT_LT] = ACTIONS(310),
    [anon_sym_LT] = ACTIONS(1986),
    [anon_sym_LT_EQ] = ACTIONS(1984),
    [anon_sym_EQ_EQ] = ACTIONS(1984),
    [anon_sym_BANG_EQ] = ACTIONS(1984),
    [anon_sym_GT_EQ] = ACTIONS(1984),
    [anon_sym_GT] = ACTIONS(1986),
    [anon_sym_LT_GT] = ACTIONS(1984),
    [anon_sym_is] = ACTIONS(1984),
    [anon_sym_PLUS_EQ] = ACTIONS(1984),
    [anon_sym_DASH_EQ] = ACTIONS(1984),
    [anon_sym_STAR_EQ] = ACTIONS(1984),
    [anon_sym_SLASH_EQ] = ACTIONS(1984),
    [anon_sym_AT_EQ] = ACTIONS(1984),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(1984),
    [anon_sym_PERCENT_EQ] = ACTIONS(1984),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1984),
    [anon_sym_GT_GT_EQ] = ACTIONS(1984),
    [anon_sym_LT_LT_EQ] = ACTIONS(1984),
    [anon_sym_AMP_EQ] = ACTIONS(1984),
    [anon_sym_CARET_EQ] = ACTIONS(1984),
    [anon_sym_PIPE_EQ] = ACTIONS(1984),
    [anon_sym_LBRACK] = ACTIONS(332),
    [sym_comment] = ACTIONS(72),
    [sym__semicolon] = ACTIONS(1984),
  },
  [529] = {
    [sym__primary_expression] = STATE(995),
    [sym_binary_operator] = STATE(995),
    [sym_unary_operator] = STATE(995),
    [sym_attribute] = STATE(995),
    [sym_subscript] = STATE(995),
    [sym_call] = STATE(995),
    [sym_list] = STATE(995),
    [sym_list_comprehension] = STATE(995),
    [sym_dictionary] = STATE(995),
    [sym_dictionary_comprehension] = STATE(995),
    [sym_set] = STATE(995),
    [sym_set_comprehension] = STATE(995),
    [sym_parenthesized_expression] = STATE(995),
    [sym_tuple] = STATE(995),
    [sym_generator_expression] = STATE(995),
    [sym_concatenated_string] = STATE(995),
    [anon_sym_LPAREN] = ACTIONS(14),
    [anon_sym_print] = ACTIONS(216),
    [anon_sym_exec] = ACTIONS(216),
    [anon_sym_PLUS] = ACTIONS(54),
    [anon_sym_DASH] = ACTIONS(54),
    [anon_sym_TILDE] = ACTIONS(54),
    [anon_sym_LBRACK] = ACTIONS(60),
    [sym_ellipsis] = ACTIONS(1988),
    [anon_sym_LBRACE] = ACTIONS(64),
    [sym_string] = ACTIONS(66),
    [sym_integer] = ACTIONS(1990),
    [sym_float] = ACTIONS(1990),
    [sym_identifier] = ACTIONS(1990),
    [sym_true] = ACTIONS(1990),
    [sym_false] = ACTIONS(1990),
    [sym_none] = ACTIONS(1990),
    [sym_comment] = ACTIONS(72),
  },
  [530] = {
    [sym_argument_list] = STATE(182),
    [sym_generator_expression] = STATE(182),
    [sym__newline] = ACTIONS(1980),
    [anon_sym_DOT] = ACTIONS(1980),
    [anon_sym_LPAREN] = ACTIONS(306),
    [anon_sym_COMMA] = ACTIONS(1980),
    [anon_sym_STAR] = ACTIONS(308),
    [anon_sym_GT_GT] = ACTIONS(1982),
    [anon_sym_if] = ACTIONS(1980),
    [anon_sym_COLON] = ACTIONS(1980),
    [anon_sym_in] = ACTIONS(1980),
    [anon_sym_EQ] = ACTIONS(1982),
    [anon_sym_AT] = ACTIONS(308),
    [anon_sym_not] = ACTIONS(1980),
    [anon_sym_and] = ACTIONS(1980),
    [anon_sym_or] = ACTIONS(1980),
    [anon_sym_PLUS] = ACTIONS(1982),
    [anon_sym_DASH] = ACTIONS(1982),
    [anon_sym_SLASH] = ACTIONS(308),
    [anon_sym_PERCENT] = ACTIONS(308),
    [anon_sym_SLASH_SLASH] = ACTIONS(308),
    [anon_sym_STAR_STAR] = ACTIONS(320),
    [anon_sym_PIPE] = ACTIONS(1982),
    [anon_sym_AMP] = ACTIONS(1982),
    [anon_sym_CARET] = ACTIONS(1982),
    [anon_sym_LT_LT] = ACTIONS(1982),
    [anon_sym_LT] = ACTIONS(1982),
    [anon_sym_LT_EQ] = ACTIONS(1980),
    [anon_sym_EQ_EQ] = ACTIONS(1980),
    [anon_sym_BANG_EQ] = ACTIONS(1980),
    [anon_sym_GT_EQ] = ACTIONS(1980),
    [anon_sym_GT] = ACTIONS(1982),
    [anon_sym_LT_GT] = ACTIONS(1980),
    [anon_sym_is] = ACTIONS(1980),
    [anon_sym_PLUS_EQ] = ACTIONS(1980),
    [anon_sym_DASH_EQ] = ACTIONS(1980),
    [anon_sym_STAR_EQ] = ACTIONS(1980),
    [anon_sym_SLASH_EQ] = ACTIONS(1980),
    [anon_sym_AT_EQ] = ACTIONS(1980),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(1980),
    [anon_sym_PERCENT_EQ] = ACTIONS(1980),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1980),
    [anon_sym_GT_GT_EQ] = ACTIONS(1980),
    [anon_sym_LT_LT_EQ] = ACTIONS(1980),
    [anon_sym_AMP_EQ] = ACTIONS(1980),
    [anon_sym_CARET_EQ] = ACTIONS(1980),
    [anon_sym_PIPE_EQ] = ACTIONS(1980),
    [anon_sym_LBRACK] = ACTIONS(1980),
    [sym_comment] = ACTIONS(72),
    [sym__semicolon] = ACTIONS(1980),
  },
  [531] = {
    [sym_argument_list] = STATE(182),
    [sym_generator_expression] = STATE(182),
    [sym__newline] = ACTIONS(1980),
    [anon_sym_DOT] = ACTIONS(1980),
    [anon_sym_LPAREN] = ACTIONS(306),
    [anon_sym_COMMA] = ACTIONS(1980),
    [anon_sym_STAR] = ACTIONS(1982),
    [anon_sym_GT_GT] = ACTIONS(1982),
    [anon_sym_if] = ACTIONS(1980),
    [anon_sym_COLON] = ACTIONS(1980),
    [anon_sym_in] = ACTIONS(1980),
    [anon_sym_EQ] = ACTIONS(1982),
    [anon_sym_AT] = ACTIONS(1982),
    [anon_sym_not] = ACTIONS(1980),
    [anon_sym_and] = ACTIONS(1980),
    [anon_sym_or] = ACTIONS(1980),
    [anon_sym_PLUS] = ACTIONS(1982),
    [anon_sym_DASH] = ACTIONS(1982),
    [anon_sym_SLASH] = ACTIONS(1982),
    [anon_sym_PERCENT] = ACTIONS(1982),
    [anon_sym_SLASH_SLASH] = ACTIONS(1982),
    [anon_sym_STAR_STAR] = ACTIONS(1982),
    [anon_sym_PIPE] = ACTIONS(1982),
    [anon_sym_AMP] = ACTIONS(1982),
    [anon_sym_CARET] = ACTIONS(1982),
    [anon_sym_LT_LT] = ACTIONS(1982),
    [anon_sym_LT] = ACTIONS(1982),
    [anon_sym_LT_EQ] = ACTIONS(1980),
    [anon_sym_EQ_EQ] = ACTIONS(1980),
    [anon_sym_BANG_EQ] = ACTIONS(1980),
    [anon_sym_GT_EQ] = ACTIONS(1980),
    [anon_sym_GT] = ACTIONS(1982),
    [anon_sym_LT_GT] = ACTIONS(1980),
    [anon_sym_is] = ACTIONS(1980),
    [anon_sym_PLUS_EQ] = ACTIONS(1980),
    [anon_sym_DASH_EQ] = ACTIONS(1980),
    [anon_sym_STAR_EQ] = ACTIONS(1980),
    [anon_sym_SLASH_EQ] = ACTIONS(1980),
    [anon_sym_AT_EQ] = ACTIONS(1980),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(1980),
    [anon_sym_PERCENT_EQ] = ACTIONS(1980),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1980),
    [anon_sym_GT_GT_EQ] = ACTIONS(1980),
    [anon_sym_LT_LT_EQ] = ACTIONS(1980),
    [anon_sym_AMP_EQ] = ACTIONS(1980),
    [anon_sym_CARET_EQ] = ACTIONS(1980),
    [anon_sym_PIPE_EQ] = ACTIONS(1980),
    [anon_sym_LBRACK] = ACTIONS(1980),
    [sym_comment] = ACTIONS(72),
    [sym__semicolon] = ACTIONS(1980),
  },
  [532] = {
    [sym_argument_list] = STATE(182),
    [sym_generator_expression] = STATE(182),
    [sym__newline] = ACTIONS(1980),
    [anon_sym_DOT] = ACTIONS(1980),
    [anon_sym_LPAREN] = ACTIONS(306),
    [anon_sym_COMMA] = ACTIONS(1980),
    [anon_sym_STAR] = ACTIONS(308),
    [anon_sym_GT_GT] = ACTIONS(310),
    [anon_sym_if] = ACTIONS(1980),
    [anon_sym_COLON] = ACTIONS(1980),
    [anon_sym_in] = ACTIONS(1980),
    [anon_sym_EQ] = ACTIONS(1982),
    [anon_sym_AT] = ACTIONS(308),
    [anon_sym_not] = ACTIONS(1980),
    [anon_sym_and] = ACTIONS(1980),
    [anon_sym_or] = ACTIONS(1980),
    [anon_sym_PLUS] = ACTIONS(318),
    [anon_sym_DASH] = ACTIONS(318),
    [anon_sym_SLASH] = ACTIONS(308),
    [anon_sym_PERCENT] = ACTIONS(308),
    [anon_sym_SLASH_SLASH] = ACTIONS(308),
    [anon_sym_STAR_STAR] = ACTIONS(320),
    [anon_sym_PIPE] = ACTIONS(1982),
    [anon_sym_AMP] = ACTIONS(324),
    [anon_sym_CARET] = ACTIONS(326),
    [anon_sym_LT_LT] = ACTIONS(310),
    [anon_sym_LT] = ACTIONS(1982),
    [anon_sym_LT_EQ] = ACTIONS(1980),
    [anon_sym_EQ_EQ] = ACTIONS(1980),
    [anon_sym_BANG_EQ] = ACTIONS(1980),
    [anon_sym_GT_EQ] = ACTIONS(1980),
    [anon_sym_GT] = ACTIONS(1982),
    [anon_sym_LT_GT] = ACTIONS(1980),
    [anon_sym_is] = ACTIONS(1980),
    [anon_sym_PLUS_EQ] = ACTIONS(1980),
    [anon_sym_DASH_EQ] = ACTIONS(1980),
    [anon_sym_STAR_EQ] = ACTIONS(1980),
    [anon_sym_SLASH_EQ] = ACTIONS(1980),
    [anon_sym_AT_EQ] = ACTIONS(1980),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(1980),
    [anon_sym_PERCENT_EQ] = ACTIONS(1980),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1980),
    [anon_sym_GT_GT_EQ] = ACTIONS(1980),
    [anon_sym_LT_LT_EQ] = ACTIONS(1980),
    [anon_sym_AMP_EQ] = ACTIONS(1980),
    [anon_sym_CARET_EQ] = ACTIONS(1980),
    [anon_sym_PIPE_EQ] = ACTIONS(1980),
    [anon_sym_LBRACK] = ACTIONS(1980),
    [sym_comment] = ACTIONS(72),
    [sym__semicolon] = ACTIONS(1980),
  },
  [533] = {
    [sym_argument_list] = STATE(182),
    [sym_generator_expression] = STATE(182),
    [sym__newline] = ACTIONS(1980),
    [anon_sym_DOT] = ACTIONS(1980),
    [anon_sym_LPAREN] = ACTIONS(306),
    [anon_sym_COMMA] = ACTIONS(1980),
    [anon_sym_STAR] = ACTIONS(308),
    [anon_sym_GT_GT] = ACTIONS(310),
    [anon_sym_if] = ACTIONS(1980),
    [anon_sym_COLON] = ACTIONS(1980),
    [anon_sym_in] = ACTIONS(1980),
    [anon_sym_EQ] = ACTIONS(1982),
    [anon_sym_AT] = ACTIONS(308),
    [anon_sym_not] = ACTIONS(1980),
    [anon_sym_and] = ACTIONS(1980),
    [anon_sym_or] = ACTIONS(1980),
    [anon_sym_PLUS] = ACTIONS(318),
    [anon_sym_DASH] = ACTIONS(318),
    [anon_sym_SLASH] = ACTIONS(308),
    [anon_sym_PERCENT] = ACTIONS(308),
    [anon_sym_SLASH_SLASH] = ACTIONS(308),
    [anon_sym_STAR_STAR] = ACTIONS(320),
    [anon_sym_PIPE] = ACTIONS(1982),
    [anon_sym_AMP] = ACTIONS(1982),
    [anon_sym_CARET] = ACTIONS(326),
    [anon_sym_LT_LT] = ACTIONS(310),
    [anon_sym_LT] = ACTIONS(1982),
    [anon_sym_LT_EQ] = ACTIONS(1980),
    [anon_sym_EQ_EQ] = ACTIONS(1980),
    [anon_sym_BANG_EQ] = ACTIONS(1980),
    [anon_sym_GT_EQ] = ACTIONS(1980),
    [anon_sym_GT] = ACTIONS(1982),
    [anon_sym_LT_GT] = ACTIONS(1980),
    [anon_sym_is] = ACTIONS(1980),
    [anon_sym_PLUS_EQ] = ACTIONS(1980),
    [anon_sym_DASH_EQ] = ACTIONS(1980),
    [anon_sym_STAR_EQ] = ACTIONS(1980),
    [anon_sym_SLASH_EQ] = ACTIONS(1980),
    [anon_sym_AT_EQ] = ACTIONS(1980),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(1980),
    [anon_sym_PERCENT_EQ] = ACTIONS(1980),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1980),
    [anon_sym_GT_GT_EQ] = ACTIONS(1980),
    [anon_sym_LT_LT_EQ] = ACTIONS(1980),
    [anon_sym_AMP_EQ] = ACTIONS(1980),
    [anon_sym_CARET_EQ] = ACTIONS(1980),
    [anon_sym_PIPE_EQ] = ACTIONS(1980),
    [anon_sym_LBRACK] = ACTIONS(1980),
    [sym_comment] = ACTIONS(72),
    [sym__semicolon] = ACTIONS(1980),
  },
  [534] = {
    [sym_argument_list] = STATE(182),
    [sym_generator_expression] = STATE(182),
    [sym__newline] = ACTIONS(1980),
    [anon_sym_DOT] = ACTIONS(1980),
    [anon_sym_LPAREN] = ACTIONS(306),
    [anon_sym_COMMA] = ACTIONS(1980),
    [anon_sym_STAR] = ACTIONS(308),
    [anon_sym_GT_GT] = ACTIONS(310),
    [anon_sym_if] = ACTIONS(1980),
    [anon_sym_COLON] = ACTIONS(1980),
    [anon_sym_in] = ACTIONS(1980),
    [anon_sym_EQ] = ACTIONS(1982),
    [anon_sym_AT] = ACTIONS(308),
    [anon_sym_not] = ACTIONS(1980),
    [anon_sym_and] = ACTIONS(1980),
    [anon_sym_or] = ACTIONS(1980),
    [anon_sym_PLUS] = ACTIONS(318),
    [anon_sym_DASH] = ACTIONS(318),
    [anon_sym_SLASH] = ACTIONS(308),
    [anon_sym_PERCENT] = ACTIONS(308),
    [anon_sym_SLASH_SLASH] = ACTIONS(308),
    [anon_sym_STAR_STAR] = ACTIONS(320),
    [anon_sym_PIPE] = ACTIONS(1982),
    [anon_sym_AMP] = ACTIONS(1982),
    [anon_sym_CARET] = ACTIONS(1982),
    [anon_sym_LT_LT] = ACTIONS(310),
    [anon_sym_LT] = ACTIONS(1982),
    [anon_sym_LT_EQ] = ACTIONS(1980),
    [anon_sym_EQ_EQ] = ACTIONS(1980),
    [anon_sym_BANG_EQ] = ACTIONS(1980),
    [anon_sym_GT_EQ] = ACTIONS(1980),
    [anon_sym_GT] = ACTIONS(1982),
    [anon_sym_LT_GT] = ACTIONS(1980),
    [anon_sym_is] = ACTIONS(1980),
    [anon_sym_PLUS_EQ] = ACTIONS(1980),
    [anon_sym_DASH_EQ] = ACTIONS(1980),
    [anon_sym_STAR_EQ] = ACTIONS(1980),
    [anon_sym_SLASH_EQ] = ACTIONS(1980),
    [anon_sym_AT_EQ] = ACTIONS(1980),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(1980),
    [anon_sym_PERCENT_EQ] = ACTIONS(1980),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1980),
    [anon_sym_GT_GT_EQ] = ACTIONS(1980),
    [anon_sym_LT_LT_EQ] = ACTIONS(1980),
    [anon_sym_AMP_EQ] = ACTIONS(1980),
    [anon_sym_CARET_EQ] = ACTIONS(1980),
    [anon_sym_PIPE_EQ] = ACTIONS(1980),
    [anon_sym_LBRACK] = ACTIONS(1980),
    [sym_comment] = ACTIONS(72),
    [sym__semicolon] = ACTIONS(1980),
  },
  [535] = {
    [sym__expression] = STATE(997),
    [sym__primary_expression] = STATE(542),
    [sym_not_operator] = STATE(997),
    [sym_boolean_operator] = STATE(997),
    [sym_binary_operator] = STATE(542),
    [sym_unary_operator] = STATE(542),
    [sym_comparison_operator] = STATE(997),
    [sym_lambda] = STATE(997),
    [sym_attribute] = STATE(542),
    [sym_subscript] = STATE(542),
    [sym_call] = STATE(542),
    [sym_list] = STATE(542),
    [sym_list_comprehension] = STATE(542),
    [sym_dictionary] = STATE(542),
    [sym_dictionary_comprehension] = STATE(542),
    [sym_set] = STATE(542),
    [sym_set_comprehension] = STATE(542),
    [sym_parenthesized_expression] = STATE(542),
    [sym_tuple] = STATE(542),
    [sym_generator_expression] = STATE(542),
    [sym_conditional_expression] = STATE(997),
    [sym_concatenated_string] = STATE(542),
    [sym_await] = STATE(997),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_COMMA] = ACTIONS(1992),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_COLON] = ACTIONS(1994),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_not] = ACTIONS(980),
    [anon_sym_PLUS] = ACTIONS(982),
    [anon_sym_DASH] = ACTIONS(982),
    [anon_sym_TILDE] = ACTIONS(982),
    [anon_sym_lambda] = ACTIONS(984),
    [anon_sym_LBRACK] = ACTIONS(96),
    [anon_sym_RBRACK] = ACTIONS(1992),
    [sym_ellipsis] = ACTIONS(986),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(988),
    [sym_integer] = ACTIONS(990),
    [sym_float] = ACTIONS(990),
    [sym_identifier] = ACTIONS(990),
    [sym_true] = ACTIONS(990),
    [sym_false] = ACTIONS(990),
    [sym_none] = ACTIONS(990),
    [anon_sym_await] = ACTIONS(992),
    [sym_comment] = ACTIONS(72),
  },
  [536] = {
    [sym__expression] = STATE(998),
    [sym__primary_expression] = STATE(542),
    [sym_not_operator] = STATE(998),
    [sym_boolean_operator] = STATE(998),
    [sym_binary_operator] = STATE(542),
    [sym_unary_operator] = STATE(542),
    [sym_comparison_operator] = STATE(998),
    [sym_lambda] = STATE(998),
    [sym_attribute] = STATE(542),
    [sym_subscript] = STATE(542),
    [sym_call] = STATE(542),
    [sym_list] = STATE(542),
    [sym_list_comprehension] = STATE(542),
    [sym_dictionary] = STATE(542),
    [sym_dictionary_comprehension] = STATE(542),
    [sym_set] = STATE(542),
    [sym_set_comprehension] = STATE(542),
    [sym_parenthesized_expression] = STATE(542),
    [sym_tuple] = STATE(542),
    [sym_generator_expression] = STATE(542),
    [sym_conditional_expression] = STATE(998),
    [sym_concatenated_string] = STATE(542),
    [sym_await] = STATE(998),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_not] = ACTIONS(980),
    [anon_sym_PLUS] = ACTIONS(982),
    [anon_sym_DASH] = ACTIONS(982),
    [anon_sym_TILDE] = ACTIONS(982),
    [anon_sym_lambda] = ACTIONS(984),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(986),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(988),
    [sym_integer] = ACTIONS(990),
    [sym_float] = ACTIONS(990),
    [sym_identifier] = ACTIONS(990),
    [sym_true] = ACTIONS(990),
    [sym_false] = ACTIONS(990),
    [sym_none] = ACTIONS(990),
    [anon_sym_await] = ACTIONS(992),
    [sym_comment] = ACTIONS(72),
  },
  [537] = {
    [sym__primary_expression] = STATE(204),
    [sym_binary_operator] = STATE(204),
    [sym_unary_operator] = STATE(204),
    [sym_attribute] = STATE(204),
    [sym_subscript] = STATE(204),
    [sym_call] = STATE(204),
    [sym_list] = STATE(204),
    [sym_list_comprehension] = STATE(204),
    [sym_dictionary] = STATE(204),
    [sym_dictionary_comprehension] = STATE(204),
    [sym_set] = STATE(204),
    [sym_set_comprehension] = STATE(204),
    [sym_parenthesized_expression] = STATE(204),
    [sym_tuple] = STATE(204),
    [sym_generator_expression] = STATE(204),
    [sym_concatenated_string] = STATE(204),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_PLUS] = ACTIONS(982),
    [anon_sym_DASH] = ACTIONS(982),
    [anon_sym_TILDE] = ACTIONS(982),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(376),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(988),
    [sym_integer] = ACTIONS(378),
    [sym_float] = ACTIONS(378),
    [sym_identifier] = ACTIONS(378),
    [sym_true] = ACTIONS(378),
    [sym_false] = ACTIONS(378),
    [sym_none] = ACTIONS(378),
    [sym_comment] = ACTIONS(72),
  },
  [538] = {
    [sym_lambda_parameters] = STATE(1000),
    [sym__parameters] = STATE(130),
    [sym_default_parameter] = STATE(131),
    [sym_typed_default_parameter] = STATE(131),
    [sym_list_splat] = STATE(132),
    [sym_dictionary_splat] = STATE(132),
    [sym_typed_parameter] = STATE(131),
    [sym_tuple] = STATE(131),
    [anon_sym_LPAREN] = ACTIONS(222),
    [anon_sym_STAR] = ACTIONS(224),
    [anon_sym_print] = ACTIONS(226),
    [anon_sym_COLON] = ACTIONS(1996),
    [anon_sym_exec] = ACTIONS(226),
    [sym_identifier] = ACTIONS(230),
    [sym_comment] = ACTIONS(72),
  },
  [539] = {
    [aux_sym_concatenated_string_repeat1] = STATE(1001),
    [anon_sym_DOT] = ACTIONS(276),
    [anon_sym_LPAREN] = ACTIONS(276),
    [anon_sym_COMMA] = ACTIONS(276),
    [anon_sym_STAR] = ACTIONS(278),
    [anon_sym_GT_GT] = ACTIONS(276),
    [anon_sym_if] = ACTIONS(276),
    [anon_sym_COLON] = ACTIONS(276),
    [anon_sym_in] = ACTIONS(276),
    [anon_sym_AT] = ACTIONS(276),
    [anon_sym_not] = ACTIONS(276),
    [anon_sym_and] = ACTIONS(276),
    [anon_sym_or] = ACTIONS(276),
    [anon_sym_PLUS] = ACTIONS(276),
    [anon_sym_DASH] = ACTIONS(276),
    [anon_sym_SLASH] = ACTIONS(278),
    [anon_sym_PERCENT] = ACTIONS(276),
    [anon_sym_SLASH_SLASH] = ACTIONS(276),
    [anon_sym_STAR_STAR] = ACTIONS(276),
    [anon_sym_PIPE] = ACTIONS(276),
    [anon_sym_AMP] = ACTIONS(276),
    [anon_sym_CARET] = ACTIONS(276),
    [anon_sym_LT_LT] = ACTIONS(276),
    [anon_sym_LT] = ACTIONS(278),
    [anon_sym_LT_EQ] = ACTIONS(276),
    [anon_sym_EQ_EQ] = ACTIONS(276),
    [anon_sym_BANG_EQ] = ACTIONS(276),
    [anon_sym_GT_EQ] = ACTIONS(276),
    [anon_sym_GT] = ACTIONS(278),
    [anon_sym_LT_GT] = ACTIONS(276),
    [anon_sym_is] = ACTIONS(276),
    [anon_sym_LBRACK] = ACTIONS(276),
    [anon_sym_RBRACK] = ACTIONS(276),
    [sym_string] = ACTIONS(1998),
    [sym_comment] = ACTIONS(72),
  },
  [540] = {
    [sym__expression] = STATE(227),
    [sym__primary_expression] = STATE(542),
    [sym_not_operator] = STATE(227),
    [sym_boolean_operator] = STATE(227),
    [sym_binary_operator] = STATE(542),
    [sym_unary_operator] = STATE(542),
    [sym_comparison_operator] = STATE(227),
    [sym_lambda] = STATE(227),
    [sym_attribute] = STATE(542),
    [sym_subscript] = STATE(542),
    [sym_call] = STATE(542),
    [sym_list] = STATE(542),
    [sym_list_comprehension] = STATE(542),
    [sym_dictionary] = STATE(542),
    [sym_dictionary_comprehension] = STATE(542),
    [sym_set] = STATE(542),
    [sym_set_comprehension] = STATE(542),
    [sym_parenthesized_expression] = STATE(542),
    [sym_tuple] = STATE(542),
    [sym_generator_expression] = STATE(542),
    [sym_conditional_expression] = STATE(227),
    [sym_concatenated_string] = STATE(542),
    [sym_await] = STATE(227),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_not] = ACTIONS(980),
    [anon_sym_PLUS] = ACTIONS(982),
    [anon_sym_DASH] = ACTIONS(982),
    [anon_sym_TILDE] = ACTIONS(982),
    [anon_sym_lambda] = ACTIONS(984),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(986),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(988),
    [sym_integer] = ACTIONS(990),
    [sym_float] = ACTIONS(990),
    [sym_identifier] = ACTIONS(990),
    [sym_true] = ACTIONS(990),
    [sym_false] = ACTIONS(990),
    [sym_none] = ACTIONS(990),
    [anon_sym_await] = ACTIONS(992),
    [sym_comment] = ACTIONS(72),
  },
  [541] = {
    [aux_sym_subscript_repeat1] = STATE(1008),
    [anon_sym_COMMA] = ACTIONS(2000),
    [anon_sym_if] = ACTIONS(2002),
    [anon_sym_COLON] = ACTIONS(2004),
    [anon_sym_and] = ACTIONS(2006),
    [anon_sym_or] = ACTIONS(2008),
    [anon_sym_RBRACK] = ACTIONS(2010),
    [sym_comment] = ACTIONS(72),
  },
  [542] = {
    [sym_argument_list] = STATE(251),
    [sym_generator_expression] = STATE(251),
    [aux_sym_comparison_operator_repeat1] = STATE(1019),
    [anon_sym_DOT] = ACTIONS(422),
    [anon_sym_LPAREN] = ACTIONS(424),
    [anon_sym_COMMA] = ACTIONS(302),
    [anon_sym_STAR] = ACTIONS(2012),
    [anon_sym_GT_GT] = ACTIONS(2014),
    [anon_sym_if] = ACTIONS(302),
    [anon_sym_COLON] = ACTIONS(302),
    [anon_sym_in] = ACTIONS(2016),
    [anon_sym_AT] = ACTIONS(2018),
    [anon_sym_not] = ACTIONS(2020),
    [anon_sym_and] = ACTIONS(302),
    [anon_sym_or] = ACTIONS(302),
    [anon_sym_PLUS] = ACTIONS(2022),
    [anon_sym_DASH] = ACTIONS(2022),
    [anon_sym_SLASH] = ACTIONS(2012),
    [anon_sym_PERCENT] = ACTIONS(2018),
    [anon_sym_SLASH_SLASH] = ACTIONS(2018),
    [anon_sym_STAR_STAR] = ACTIONS(2024),
    [anon_sym_PIPE] = ACTIONS(2026),
    [anon_sym_AMP] = ACTIONS(2028),
    [anon_sym_CARET] = ACTIONS(2030),
    [anon_sym_LT_LT] = ACTIONS(2014),
    [anon_sym_LT] = ACTIONS(2032),
    [anon_sym_LT_EQ] = ACTIONS(2016),
    [anon_sym_EQ_EQ] = ACTIONS(2016),
    [anon_sym_BANG_EQ] = ACTIONS(2016),
    [anon_sym_GT_EQ] = ACTIONS(2016),
    [anon_sym_GT] = ACTIONS(2032),
    [anon_sym_LT_GT] = ACTIONS(2016),
    [anon_sym_is] = ACTIONS(2034),
    [anon_sym_LBRACK] = ACTIONS(450),
    [anon_sym_RBRACK] = ACTIONS(302),
    [sym_comment] = ACTIONS(72),
  },
  [543] = {
    [aux_sym_subscript_repeat1] = STATE(1008),
    [anon_sym_COMMA] = ACTIONS(2000),
    [anon_sym_RBRACK] = ACTIONS(2010),
    [sym_comment] = ACTIONS(72),
  },
  [544] = {
    [aux_sym_comparison_operator_repeat1] = STATE(544),
    [sym__newline] = ACTIONS(1984),
    [anon_sym_COMMA] = ACTIONS(1984),
    [anon_sym_if] = ACTIONS(1984),
    [anon_sym_COLON] = ACTIONS(1984),
    [anon_sym_in] = ACTIONS(2036),
    [anon_sym_EQ] = ACTIONS(1986),
    [anon_sym_not] = ACTIONS(2039),
    [anon_sym_and] = ACTIONS(1984),
    [anon_sym_or] = ACTIONS(1984),
    [anon_sym_LT] = ACTIONS(2042),
    [anon_sym_LT_EQ] = ACTIONS(2036),
    [anon_sym_EQ_EQ] = ACTIONS(2036),
    [anon_sym_BANG_EQ] = ACTIONS(2036),
    [anon_sym_GT_EQ] = ACTIONS(2036),
    [anon_sym_GT] = ACTIONS(2042),
    [anon_sym_LT_GT] = ACTIONS(2036),
    [anon_sym_is] = ACTIONS(2045),
    [anon_sym_PLUS_EQ] = ACTIONS(1984),
    [anon_sym_DASH_EQ] = ACTIONS(1984),
    [anon_sym_STAR_EQ] = ACTIONS(1984),
    [anon_sym_SLASH_EQ] = ACTIONS(1984),
    [anon_sym_AT_EQ] = ACTIONS(1984),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(1984),
    [anon_sym_PERCENT_EQ] = ACTIONS(1984),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1984),
    [anon_sym_GT_GT_EQ] = ACTIONS(1984),
    [anon_sym_LT_LT_EQ] = ACTIONS(1984),
    [anon_sym_AMP_EQ] = ACTIONS(1984),
    [anon_sym_CARET_EQ] = ACTIONS(1984),
    [anon_sym_PIPE_EQ] = ACTIONS(1984),
    [sym_comment] = ACTIONS(72),
    [sym__semicolon] = ACTIONS(1984),
  },
  [545] = {
    [sym__newline] = ACTIONS(2048),
    [anon_sym_DOT] = ACTIONS(2048),
    [anon_sym_LPAREN] = ACTIONS(2048),
    [anon_sym_COMMA] = ACTIONS(2048),
    [anon_sym_as] = ACTIONS(2048),
    [sym_comment] = ACTIONS(72),
    [sym__semicolon] = ACTIONS(2048),
  },
  [546] = {
    [aux_sym_dotted_name_repeat1] = STATE(546),
    [sym__newline] = ACTIONS(2048),
    [anon_sym_DOT] = ACTIONS(2050),
    [anon_sym_COMMA] = ACTIONS(2048),
    [anon_sym_as] = ACTIONS(2048),
    [sym_comment] = ACTIONS(72),
    [sym__semicolon] = ACTIONS(2048),
  },
  [547] = {
    [sym__newline] = ACTIONS(2053),
    [anon_sym_COMMA] = ACTIONS(2053),
    [sym_comment] = ACTIONS(72),
    [sym__semicolon] = ACTIONS(2053),
  },
  [548] = {
    [sym__newline] = ACTIONS(2053),
    [anon_sym_COMMA] = ACTIONS(2053),
    [anon_sym_as] = ACTIONS(352),
    [sym_comment] = ACTIONS(72),
    [sym__semicolon] = ACTIONS(2053),
  },
  [549] = {
    [sym_aliased_import] = STATE(547),
    [sym_dotted_name] = STATE(548),
    [sym__newline] = ACTIONS(2055),
    [sym_identifier] = ACTIONS(74),
    [sym_comment] = ACTIONS(72),
    [sym__semicolon] = ACTIONS(2055),
  },
  [550] = {
    [aux_sym__import_list_repeat1] = STATE(550),
    [sym__newline] = ACTIONS(2053),
    [anon_sym_COMMA] = ACTIONS(2057),
    [sym_comment] = ACTIONS(72),
    [sym__semicolon] = ACTIONS(2053),
  },
  [551] = {
    [sym__newline] = ACTIONS(2060),
    [anon_sym_COMMA] = ACTIONS(2060),
    [sym_comment] = ACTIONS(72),
    [sym__semicolon] = ACTIONS(2060),
  },
  [552] = {
    [anon_sym_import] = ACTIONS(2048),
    [anon_sym_DOT] = ACTIONS(2048),
    [anon_sym_RPAREN] = ACTIONS(2048),
    [anon_sym_COMMA] = ACTIONS(2048),
    [anon_sym_as] = ACTIONS(2048),
    [sym_comment] = ACTIONS(72),
  },
  [553] = {
    [aux_sym_dotted_name_repeat1] = STATE(553),
    [anon_sym_import] = ACTIONS(2048),
    [anon_sym_DOT] = ACTIONS(2062),
    [sym_comment] = ACTIONS(72),
  },
  [554] = {
    [sym__import_list] = STATE(1022),
    [sym_aliased_import] = STATE(1023),
    [sym_dotted_name] = STATE(1024),
    [sym_identifier] = ACTIONS(2065),
    [sym_comment] = ACTIONS(72),
  },
  [555] = {
    [sym__newline] = ACTIONS(2067),
    [sym_comment] = ACTIONS(72),
    [sym__semicolon] = ACTIONS(2067),
  },
  [556] = {
    [sym__newline] = ACTIONS(2069),
    [sym_comment] = ACTIONS(72),
    [sym__semicolon] = ACTIONS(2069),
  },
  [557] = {
    [anon_sym_DOT] = ACTIONS(1135),
    [anon_sym_LPAREN] = ACTIONS(1135),
    [anon_sym_RPAREN] = ACTIONS(1135),
    [anon_sym_COMMA] = ACTIONS(1135),
    [anon_sym_as] = ACTIONS(1137),
    [anon_sym_STAR] = ACTIONS(1137),
    [anon_sym_GT_GT] = ACTIONS(1135),
    [anon_sym_if] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(1135),
    [anon_sym_else] = ACTIONS(1135),
    [anon_sym_async] = ACTIONS(1135),
    [anon_sym_for] = ACTIONS(1135),
    [anon_sym_in] = ACTIONS(1135),
    [anon_sym_EQ] = ACTIONS(1137),
    [anon_sym_AT] = ACTIONS(1135),
    [anon_sym_not] = ACTIONS(1135),
    [anon_sym_and] = ACTIONS(1135),
    [anon_sym_or] = ACTIONS(1135),
    [anon_sym_PLUS] = ACTIONS(1135),
    [anon_sym_DASH] = ACTIONS(1135),
    [anon_sym_SLASH] = ACTIONS(1137),
    [anon_sym_PERCENT] = ACTIONS(1135),
    [anon_sym_SLASH_SLASH] = ACTIONS(1135),
    [anon_sym_STAR_STAR] = ACTIONS(1135),
    [anon_sym_PIPE] = ACTIONS(1135),
    [anon_sym_AMP] = ACTIONS(1135),
    [anon_sym_CARET] = ACTIONS(1135),
    [anon_sym_LT_LT] = ACTIONS(1135),
    [anon_sym_LT] = ACTIONS(1137),
    [anon_sym_LT_EQ] = ACTIONS(1135),
    [anon_sym_EQ_EQ] = ACTIONS(1135),
    [anon_sym_BANG_EQ] = ACTIONS(1135),
    [anon_sym_GT_EQ] = ACTIONS(1135),
    [anon_sym_GT] = ACTIONS(1137),
    [anon_sym_LT_GT] = ACTIONS(1135),
    [anon_sym_is] = ACTIONS(1135),
    [anon_sym_LBRACK] = ACTIONS(1135),
    [anon_sym_RBRACK] = ACTIONS(1135),
    [anon_sym_RBRACE] = ACTIONS(1135),
    [sym_comment] = ACTIONS(72),
  },
  [558] = {
    [anon_sym_DOT] = ACTIONS(1193),
    [anon_sym_LPAREN] = ACTIONS(1193),
    [anon_sym_RPAREN] = ACTIONS(1193),
    [anon_sym_COMMA] = ACTIONS(1193),
    [anon_sym_as] = ACTIONS(1195),
    [anon_sym_STAR] = ACTIONS(1195),
    [anon_sym_GT_GT] = ACTIONS(1193),
    [anon_sym_if] = ACTIONS(1193),
    [anon_sym_COLON] = ACTIONS(1193),
    [anon_sym_else] = ACTIONS(1193),
    [anon_sym_async] = ACTIONS(1193),
    [anon_sym_for] = ACTIONS(1193),
    [anon_sym_in] = ACTIONS(1193),
    [anon_sym_EQ] = ACTIONS(1195),
    [anon_sym_AT] = ACTIONS(1193),
    [anon_sym_not] = ACTIONS(1193),
    [anon_sym_and] = ACTIONS(1193),
    [anon_sym_or] = ACTIONS(1193),
    [anon_sym_PLUS] = ACTIONS(1193),
    [anon_sym_DASH] = ACTIONS(1193),
    [anon_sym_SLASH] = ACTIONS(1195),
    [anon_sym_PERCENT] = ACTIONS(1193),
    [anon_sym_SLASH_SLASH] = ACTIONS(1193),
    [anon_sym_STAR_STAR] = ACTIONS(1193),
    [anon_sym_PIPE] = ACTIONS(1193),
    [anon_sym_AMP] = ACTIONS(1193),
    [anon_sym_CARET] = ACTIONS(1193),
    [anon_sym_LT_LT] = ACTIONS(1193),
    [anon_sym_LT] = ACTIONS(1195),
    [anon_sym_LT_EQ] = ACTIONS(1193),
    [anon_sym_EQ_EQ] = ACTIONS(1193),
    [anon_sym_BANG_EQ] = ACTIONS(1193),
    [anon_sym_GT_EQ] = ACTIONS(1193),
    [anon_sym_GT] = ACTIONS(1195),
    [anon_sym_LT_GT] = ACTIONS(1193),
    [anon_sym_is] = ACTIONS(1193),
    [anon_sym_LBRACK] = ACTIONS(1193),
    [anon_sym_RBRACK] = ACTIONS(1193),
    [anon_sym_RBRACE] = ACTIONS(1193),
    [sym_comment] = ACTIONS(72),
  },
  [559] = {
    [sym__expression] = STATE(599),
    [sym__primary_expression] = STATE(215),
    [sym_not_operator] = STATE(599),
    [sym_boolean_operator] = STATE(599),
    [sym_binary_operator] = STATE(215),
    [sym_unary_operator] = STATE(215),
    [sym_comparison_operator] = STATE(599),
    [sym_lambda] = STATE(599),
    [sym_yield] = STATE(600),
    [sym_attribute] = STATE(215),
    [sym_subscript] = STATE(215),
    [sym_call] = STATE(215),
    [sym_list] = STATE(215),
    [sym_list_comprehension] = STATE(215),
    [sym_dictionary] = STATE(215),
    [sym_dictionary_comprehension] = STATE(215),
    [sym_set] = STATE(215),
    [sym_set_comprehension] = STATE(215),
    [sym_parenthesized_expression] = STATE(215),
    [sym_tuple] = STATE(215),
    [sym_generator_expression] = STATE(215),
    [sym_conditional_expression] = STATE(599),
    [sym_concatenated_string] = STATE(215),
    [sym_await] = STATE(599),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_RPAREN] = ACTIONS(2071),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_not] = ACTIONS(384),
    [anon_sym_PLUS] = ACTIONS(386),
    [anon_sym_DASH] = ACTIONS(386),
    [anon_sym_TILDE] = ACTIONS(386),
    [anon_sym_lambda] = ACTIONS(388),
    [anon_sym_yield] = ACTIONS(94),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(390),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(392),
    [sym_integer] = ACTIONS(394),
    [sym_float] = ACTIONS(394),
    [sym_identifier] = ACTIONS(394),
    [sym_true] = ACTIONS(394),
    [sym_false] = ACTIONS(394),
    [sym_none] = ACTIONS(394),
    [anon_sym_await] = ACTIONS(396),
    [sym_comment] = ACTIONS(72),
  },
  [560] = {
    [anon_sym_RPAREN] = ACTIONS(2073),
    [sym_comment] = ACTIONS(72),
  },
  [561] = {
    [aux_sym_tuple_repeat1] = STATE(610),
    [anon_sym_RPAREN] = ACTIONS(2071),
    [anon_sym_COMMA] = ACTIONS(2075),
    [sym_comment] = ACTIONS(72),
  },
  [562] = {
    [anon_sym_RPAREN] = ACTIONS(1644),
    [anon_sym_COMMA] = ACTIONS(1644),
    [anon_sym_if] = ACTIONS(412),
    [anon_sym_async] = ACTIONS(1644),
    [anon_sym_for] = ACTIONS(1644),
    [anon_sym_and] = ACTIONS(418),
    [anon_sym_or] = ACTIONS(420),
    [sym_comment] = ACTIONS(72),
  },
  [563] = {
    [sym__expression] = STATE(1028),
    [sym__primary_expression] = STATE(59),
    [sym_not_operator] = STATE(1028),
    [sym_boolean_operator] = STATE(1028),
    [sym_binary_operator] = STATE(59),
    [sym_unary_operator] = STATE(59),
    [sym_comparison_operator] = STATE(1028),
    [sym_lambda] = STATE(1028),
    [sym_attribute] = STATE(59),
    [sym_subscript] = STATE(59),
    [sym_call] = STATE(59),
    [sym_list] = STATE(59),
    [sym_list_comprehension] = STATE(59),
    [sym_dictionary] = STATE(59),
    [sym_dictionary_comprehension] = STATE(59),
    [sym_set] = STATE(59),
    [sym_set_comprehension] = STATE(59),
    [sym_parenthesized_expression] = STATE(59),
    [sym_tuple] = STATE(59),
    [sym_generator_expression] = STATE(59),
    [sym_conditional_expression] = STATE(1028),
    [sym_concatenated_string] = STATE(59),
    [sym_await] = STATE(1028),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_not] = ACTIONS(88),
    [anon_sym_PLUS] = ACTIONS(90),
    [anon_sym_DASH] = ACTIONS(90),
    [anon_sym_TILDE] = ACTIONS(90),
    [anon_sym_lambda] = ACTIONS(92),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(98),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(102),
    [sym_integer] = ACTIONS(104),
    [sym_float] = ACTIONS(104),
    [sym_identifier] = ACTIONS(104),
    [sym_true] = ACTIONS(104),
    [sym_false] = ACTIONS(104),
    [sym_none] = ACTIONS(104),
    [anon_sym_await] = ACTIONS(106),
    [sym_comment] = ACTIONS(72),
  },
  [564] = {
    [anon_sym_RPAREN] = ACTIONS(1664),
    [anon_sym_COMMA] = ACTIONS(1664),
    [anon_sym_if] = ACTIONS(1147),
    [anon_sym_and] = ACTIONS(1149),
    [anon_sym_or] = ACTIONS(1151),
    [sym_comment] = ACTIONS(72),
  },
  [565] = {
    [anon_sym_RPAREN] = ACTIONS(716),
    [anon_sym_COMMA] = ACTIONS(716),
    [anon_sym_if] = ACTIONS(716),
    [anon_sym_and] = ACTIONS(1149),
    [anon_sym_or] = ACTIONS(1151),
    [sym_comment] = ACTIONS(72),
  },
  [566] = {
    [sym__expression] = STATE(1029),
    [sym__primary_expression] = STATE(215),
    [sym_not_operator] = STATE(1029),
    [sym_boolean_operator] = STATE(1029),
    [sym_binary_operator] = STATE(215),
    [sym_unary_operator] = STATE(215),
    [sym_comparison_operator] = STATE(1029),
    [sym_lambda] = STATE(1029),
    [sym_attribute] = STATE(215),
    [sym_subscript] = STATE(215),
    [sym_call] = STATE(215),
    [sym_list] = STATE(215),
    [sym_list_comprehension] = STATE(215),
    [sym_dictionary] = STATE(215),
    [sym_dictionary_comprehension] = STATE(215),
    [sym_set] = STATE(215),
    [sym_set_comprehension] = STATE(215),
    [sym_parenthesized_expression] = STATE(215),
    [sym_tuple] = STATE(215),
    [sym_generator_expression] = STATE(215),
    [sym_conditional_expression] = STATE(1029),
    [sym_concatenated_string] = STATE(215),
    [sym_await] = STATE(1029),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_not] = ACTIONS(384),
    [anon_sym_PLUS] = ACTIONS(386),
    [anon_sym_DASH] = ACTIONS(386),
    [anon_sym_TILDE] = ACTIONS(386),
    [anon_sym_lambda] = ACTIONS(388),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(390),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(392),
    [sym_integer] = ACTIONS(394),
    [sym_float] = ACTIONS(394),
    [sym_identifier] = ACTIONS(394),
    [sym_true] = ACTIONS(394),
    [sym_false] = ACTIONS(394),
    [sym_none] = ACTIONS(394),
    [anon_sym_await] = ACTIONS(396),
    [sym_comment] = ACTIONS(72),
  },
  [567] = {
    [anon_sym_COLON] = ACTIONS(2077),
    [sym_comment] = ACTIONS(72),
  },
  [568] = {
    [aux_sym_concatenated_string_repeat1] = STATE(1031),
    [anon_sym_DOT] = ACTIONS(886),
    [anon_sym_LPAREN] = ACTIONS(886),
    [anon_sym_RPAREN] = ACTIONS(886),
    [anon_sym_COMMA] = ACTIONS(886),
    [anon_sym_STAR] = ACTIONS(888),
    [anon_sym_GT_GT] = ACTIONS(886),
    [anon_sym_if] = ACTIONS(886),
    [anon_sym_in] = ACTIONS(886),
    [anon_sym_AT] = ACTIONS(886),
    [anon_sym_not] = ACTIONS(886),
    [anon_sym_and] = ACTIONS(886),
    [anon_sym_or] = ACTIONS(886),
    [anon_sym_PLUS] = ACTIONS(886),
    [anon_sym_DASH] = ACTIONS(886),
    [anon_sym_SLASH] = ACTIONS(888),
    [anon_sym_PERCENT] = ACTIONS(886),
    [anon_sym_SLASH_SLASH] = ACTIONS(886),
    [anon_sym_STAR_STAR] = ACTIONS(886),
    [anon_sym_PIPE] = ACTIONS(886),
    [anon_sym_AMP] = ACTIONS(886),
    [anon_sym_CARET] = ACTIONS(886),
    [anon_sym_LT_LT] = ACTIONS(886),
    [anon_sym_LT] = ACTIONS(888),
    [anon_sym_LT_EQ] = ACTIONS(886),
    [anon_sym_EQ_EQ] = ACTIONS(886),
    [anon_sym_BANG_EQ] = ACTIONS(886),
    [anon_sym_GT_EQ] = ACTIONS(886),
    [anon_sym_GT] = ACTIONS(888),
    [anon_sym_LT_GT] = ACTIONS(886),
    [anon_sym_is] = ACTIONS(886),
    [anon_sym_LBRACK] = ACTIONS(886),
    [sym_string] = ACTIONS(2079),
    [sym_comment] = ACTIONS(72),
  },
  [569] = {
    [sym__expression] = STATE(1032),
    [sym__primary_expression] = STATE(215),
    [sym_not_operator] = STATE(1032),
    [sym_boolean_operator] = STATE(1032),
    [sym_binary_operator] = STATE(215),
    [sym_unary_operator] = STATE(215),
    [sym_comparison_operator] = STATE(1032),
    [sym_lambda] = STATE(1032),
    [sym_attribute] = STATE(215),
    [sym_subscript] = STATE(215),
    [sym_call] = STATE(215),
    [sym_list] = STATE(215),
    [sym_list_comprehension] = STATE(215),
    [sym_dictionary] = STATE(215),
    [sym_dictionary_comprehension] = STATE(215),
    [sym_set] = STATE(215),
    [sym_set_comprehension] = STATE(215),
    [sym_parenthesized_expression] = STATE(215),
    [sym_tuple] = STATE(215),
    [sym_generator_expression] = STATE(215),
    [sym_conditional_expression] = STATE(1032),
    [sym_concatenated_string] = STATE(215),
    [sym_await] = STATE(1032),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_RPAREN] = ACTIONS(910),
    [anon_sym_COMMA] = ACTIONS(910),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_not] = ACTIONS(384),
    [anon_sym_PLUS] = ACTIONS(386),
    [anon_sym_DASH] = ACTIONS(386),
    [anon_sym_TILDE] = ACTIONS(386),
    [anon_sym_lambda] = ACTIONS(388),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(390),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(392),
    [sym_integer] = ACTIONS(394),
    [sym_float] = ACTIONS(394),
    [sym_identifier] = ACTIONS(394),
    [sym_true] = ACTIONS(394),
    [sym_false] = ACTIONS(394),
    [sym_none] = ACTIONS(394),
    [anon_sym_await] = ACTIONS(396),
    [sym_comment] = ACTIONS(72),
  },
  [570] = {
    [sym__expression] = STATE(1033),
    [sym__primary_expression] = STATE(513),
    [sym_not_operator] = STATE(1033),
    [sym_boolean_operator] = STATE(1033),
    [sym_binary_operator] = STATE(513),
    [sym_unary_operator] = STATE(513),
    [sym_comparison_operator] = STATE(1033),
    [sym_lambda] = STATE(1033),
    [sym_attribute] = STATE(513),
    [sym_subscript] = STATE(513),
    [sym_call] = STATE(513),
    [sym_list] = STATE(513),
    [sym_list_comprehension] = STATE(513),
    [sym_dictionary] = STATE(513),
    [sym_dictionary_comprehension] = STATE(513),
    [sym_set] = STATE(513),
    [sym_set_comprehension] = STATE(513),
    [sym_parenthesized_expression] = STATE(513),
    [sym_tuple] = STATE(513),
    [sym_generator_expression] = STATE(513),
    [sym_conditional_expression] = STATE(1033),
    [sym_concatenated_string] = STATE(513),
    [sym_await] = STATE(1033),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_not] = ACTIONS(914),
    [anon_sym_PLUS] = ACTIONS(916),
    [anon_sym_DASH] = ACTIONS(916),
    [anon_sym_TILDE] = ACTIONS(916),
    [anon_sym_lambda] = ACTIONS(918),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(920),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(922),
    [sym_integer] = ACTIONS(924),
    [sym_float] = ACTIONS(924),
    [sym_identifier] = ACTIONS(924),
    [sym_true] = ACTIONS(924),
    [sym_false] = ACTIONS(924),
    [sym_none] = ACTIONS(924),
    [anon_sym_await] = ACTIONS(926),
    [sym_comment] = ACTIONS(72),
  },
  [571] = {
    [sym__expression] = STATE(604),
    [sym__primary_expression] = STATE(215),
    [sym_not_operator] = STATE(604),
    [sym_boolean_operator] = STATE(604),
    [sym_binary_operator] = STATE(215),
    [sym_unary_operator] = STATE(215),
    [sym_comparison_operator] = STATE(604),
    [sym_lambda] = STATE(604),
    [sym_attribute] = STATE(215),
    [sym_subscript] = STATE(215),
    [sym_call] = STATE(215),
    [sym_list] = STATE(215),
    [sym_list_comprehension] = STATE(215),
    [sym_dictionary] = STATE(215),
    [sym_dictionary_comprehension] = STATE(215),
    [sym_set] = STATE(215),
    [sym_set_comprehension] = STATE(215),
    [sym_parenthesized_expression] = STATE(215),
    [sym_tuple] = STATE(215),
    [sym_generator_expression] = STATE(215),
    [sym_conditional_expression] = STATE(604),
    [sym_concatenated_string] = STATE(215),
    [sym_await] = STATE(604),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_not] = ACTIONS(384),
    [anon_sym_PLUS] = ACTIONS(386),
    [anon_sym_DASH] = ACTIONS(386),
    [anon_sym_TILDE] = ACTIONS(386),
    [anon_sym_lambda] = ACTIONS(388),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(390),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(392),
    [sym_integer] = ACTIONS(394),
    [sym_float] = ACTIONS(394),
    [sym_identifier] = ACTIONS(394),
    [sym_true] = ACTIONS(394),
    [sym_false] = ACTIONS(394),
    [sym_none] = ACTIONS(394),
    [anon_sym_await] = ACTIONS(396),
    [sym_comment] = ACTIONS(72),
  },
  [572] = {
    [sym__expression] = STATE(1034),
    [sym__primary_expression] = STATE(215),
    [sym_not_operator] = STATE(1034),
    [sym_boolean_operator] = STATE(1034),
    [sym_binary_operator] = STATE(215),
    [sym_unary_operator] = STATE(215),
    [sym_comparison_operator] = STATE(1034),
    [sym_lambda] = STATE(1034),
    [sym_attribute] = STATE(215),
    [sym_subscript] = STATE(215),
    [sym_call] = STATE(215),
    [sym_list] = STATE(215),
    [sym_list_comprehension] = STATE(215),
    [sym_dictionary] = STATE(215),
    [sym_dictionary_comprehension] = STATE(215),
    [sym_set] = STATE(215),
    [sym_set_comprehension] = STATE(215),
    [sym_parenthesized_expression] = STATE(215),
    [sym_tuple] = STATE(215),
    [sym_generator_expression] = STATE(215),
    [sym_conditional_expression] = STATE(1034),
    [sym_concatenated_string] = STATE(215),
    [sym_await] = STATE(1034),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_not] = ACTIONS(384),
    [anon_sym_PLUS] = ACTIONS(386),
    [anon_sym_DASH] = ACTIONS(386),
    [anon_sym_TILDE] = ACTIONS(386),
    [anon_sym_lambda] = ACTIONS(388),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(390),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(392),
    [sym_integer] = ACTIONS(394),
    [sym_float] = ACTIONS(394),
    [sym_identifier] = ACTIONS(394),
    [sym_true] = ACTIONS(394),
    [sym_false] = ACTIONS(394),
    [sym_none] = ACTIONS(394),
    [anon_sym_await] = ACTIONS(396),
    [sym_comment] = ACTIONS(72),
  },
  [573] = {
    [aux_sym_print_statement_repeat1] = STATE(1036),
    [anon_sym_RPAREN] = ACTIONS(910),
    [anon_sym_COMMA] = ACTIONS(2081),
    [sym_comment] = ACTIONS(72),
  },
  [574] = {
    [sym__primary_expression] = STATE(1037),
    [sym_binary_operator] = STATE(1037),
    [sym_unary_operator] = STATE(1037),
    [sym_attribute] = STATE(1037),
    [sym_subscript] = STATE(1037),
    [sym_call] = STATE(1037),
    [sym_list] = STATE(1037),
    [sym_list_comprehension] = STATE(1037),
    [sym_dictionary] = STATE(1037),
    [sym_dictionary_comprehension] = STATE(1037),
    [sym_set] = STATE(1037),
    [sym_set_comprehension] = STATE(1037),
    [sym_parenthesized_expression] = STATE(1037),
    [sym_tuple] = STATE(1037),
    [sym_generator_expression] = STATE(1037),
    [sym_concatenated_string] = STATE(1037),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_PLUS] = ACTIONS(386),
    [anon_sym_DASH] = ACTIONS(386),
    [anon_sym_TILDE] = ACTIONS(386),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(2083),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(392),
    [sym_integer] = ACTIONS(2085),
    [sym_float] = ACTIONS(2085),
    [sym_identifier] = ACTIONS(2085),
    [sym_true] = ACTIONS(2085),
    [sym_false] = ACTIONS(2085),
    [sym_none] = ACTIONS(2085),
    [sym_comment] = ACTIONS(72),
  },
  [575] = {
    [sym__primary_expression] = STATE(1038),
    [sym_binary_operator] = STATE(1038),
    [sym_unary_operator] = STATE(1038),
    [sym_attribute] = STATE(1038),
    [sym_subscript] = STATE(1038),
    [sym_call] = STATE(1038),
    [sym_list] = STATE(1038),
    [sym_list_comprehension] = STATE(1038),
    [sym_dictionary] = STATE(1038),
    [sym_dictionary_comprehension] = STATE(1038),
    [sym_set] = STATE(1038),
    [sym_set_comprehension] = STATE(1038),
    [sym_parenthesized_expression] = STATE(1038),
    [sym_tuple] = STATE(1038),
    [sym_generator_expression] = STATE(1038),
    [sym_concatenated_string] = STATE(1038),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_PLUS] = ACTIONS(386),
    [anon_sym_DASH] = ACTIONS(386),
    [anon_sym_TILDE] = ACTIONS(386),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(2087),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(392),
    [sym_integer] = ACTIONS(2089),
    [sym_float] = ACTIONS(2089),
    [sym_identifier] = ACTIONS(2089),
    [sym_true] = ACTIONS(2089),
    [sym_false] = ACTIONS(2089),
    [sym_none] = ACTIONS(2089),
    [sym_comment] = ACTIONS(72),
  },
  [576] = {
    [sym__primary_expression] = STATE(1039),
    [sym_binary_operator] = STATE(1039),
    [sym_unary_operator] = STATE(1039),
    [sym_attribute] = STATE(1039),
    [sym_subscript] = STATE(1039),
    [sym_call] = STATE(1039),
    [sym_list] = STATE(1039),
    [sym_list_comprehension] = STATE(1039),
    [sym_dictionary] = STATE(1039),
    [sym_dictionary_comprehension] = STATE(1039),
    [sym_set] = STATE(1039),
    [sym_set_comprehension] = STATE(1039),
    [sym_parenthesized_expression] = STATE(1039),
    [sym_tuple] = STATE(1039),
    [sym_generator_expression] = STATE(1039),
    [sym_concatenated_string] = STATE(1039),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_PLUS] = ACTIONS(386),
    [anon_sym_DASH] = ACTIONS(386),
    [anon_sym_TILDE] = ACTIONS(386),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(2091),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(392),
    [sym_integer] = ACTIONS(2093),
    [sym_float] = ACTIONS(2093),
    [sym_identifier] = ACTIONS(2093),
    [sym_true] = ACTIONS(2093),
    [sym_false] = ACTIONS(2093),
    [sym_none] = ACTIONS(2093),
    [sym_comment] = ACTIONS(72),
  },
  [577] = {
    [anon_sym_in] = ACTIONS(2095),
    [sym_comment] = ACTIONS(72),
  },
  [578] = {
    [sym__primary_expression] = STATE(1041),
    [sym_binary_operator] = STATE(1041),
    [sym_unary_operator] = STATE(1041),
    [sym_attribute] = STATE(1041),
    [sym_subscript] = STATE(1041),
    [sym_call] = STATE(1041),
    [sym_list] = STATE(1041),
    [sym_list_comprehension] = STATE(1041),
    [sym_dictionary] = STATE(1041),
    [sym_dictionary_comprehension] = STATE(1041),
    [sym_set] = STATE(1041),
    [sym_set_comprehension] = STATE(1041),
    [sym_parenthesized_expression] = STATE(1041),
    [sym_tuple] = STATE(1041),
    [sym_generator_expression] = STATE(1041),
    [sym_concatenated_string] = STATE(1041),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_PLUS] = ACTIONS(386),
    [anon_sym_DASH] = ACTIONS(386),
    [anon_sym_TILDE] = ACTIONS(386),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(2097),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(392),
    [sym_integer] = ACTIONS(2099),
    [sym_float] = ACTIONS(2099),
    [sym_identifier] = ACTIONS(2099),
    [sym_true] = ACTIONS(2099),
    [sym_false] = ACTIONS(2099),
    [sym_none] = ACTIONS(2099),
    [sym_comment] = ACTIONS(72),
  },
  [579] = {
    [sym__primary_expression] = STATE(621),
    [sym_binary_operator] = STATE(621),
    [sym_unary_operator] = STATE(621),
    [sym_attribute] = STATE(621),
    [sym_subscript] = STATE(621),
    [sym_call] = STATE(621),
    [sym_list] = STATE(621),
    [sym_list_comprehension] = STATE(621),
    [sym_dictionary] = STATE(621),
    [sym_dictionary_comprehension] = STATE(621),
    [sym_set] = STATE(621),
    [sym_set_comprehension] = STATE(621),
    [sym_parenthesized_expression] = STATE(621),
    [sym_tuple] = STATE(621),
    [sym_generator_expression] = STATE(621),
    [sym_concatenated_string] = STATE(621),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_PLUS] = ACTIONS(386),
    [anon_sym_DASH] = ACTIONS(386),
    [anon_sym_TILDE] = ACTIONS(386),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(1233),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(392),
    [sym_integer] = ACTIONS(1235),
    [sym_float] = ACTIONS(1235),
    [sym_identifier] = ACTIONS(1235),
    [sym_true] = ACTIONS(1235),
    [sym_false] = ACTIONS(1235),
    [sym_none] = ACTIONS(1235),
    [sym_comment] = ACTIONS(72),
  },
  [580] = {
    [sym__primary_expression] = STATE(1042),
    [sym_binary_operator] = STATE(1042),
    [sym_unary_operator] = STATE(1042),
    [sym_attribute] = STATE(1042),
    [sym_subscript] = STATE(1042),
    [sym_call] = STATE(1042),
    [sym_list] = STATE(1042),
    [sym_list_comprehension] = STATE(1042),
    [sym_dictionary] = STATE(1042),
    [sym_dictionary_comprehension] = STATE(1042),
    [sym_set] = STATE(1042),
    [sym_set_comprehension] = STATE(1042),
    [sym_parenthesized_expression] = STATE(1042),
    [sym_tuple] = STATE(1042),
    [sym_generator_expression] = STATE(1042),
    [sym_concatenated_string] = STATE(1042),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_PLUS] = ACTIONS(386),
    [anon_sym_DASH] = ACTIONS(386),
    [anon_sym_TILDE] = ACTIONS(386),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(2101),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(392),
    [sym_integer] = ACTIONS(2103),
    [sym_float] = ACTIONS(2103),
    [sym_identifier] = ACTIONS(2103),
    [sym_true] = ACTIONS(2103),
    [sym_false] = ACTIONS(2103),
    [sym_none] = ACTIONS(2103),
    [sym_comment] = ACTIONS(72),
  },
  [581] = {
    [sym__primary_expression] = STATE(1043),
    [sym_binary_operator] = STATE(1043),
    [sym_unary_operator] = STATE(1043),
    [sym_attribute] = STATE(1043),
    [sym_subscript] = STATE(1043),
    [sym_call] = STATE(1043),
    [sym_list] = STATE(1043),
    [sym_list_comprehension] = STATE(1043),
    [sym_dictionary] = STATE(1043),
    [sym_dictionary_comprehension] = STATE(1043),
    [sym_set] = STATE(1043),
    [sym_set_comprehension] = STATE(1043),
    [sym_parenthesized_expression] = STATE(1043),
    [sym_tuple] = STATE(1043),
    [sym_generator_expression] = STATE(1043),
    [sym_concatenated_string] = STATE(1043),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_PLUS] = ACTIONS(386),
    [anon_sym_DASH] = ACTIONS(386),
    [anon_sym_TILDE] = ACTIONS(386),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(2105),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(392),
    [sym_integer] = ACTIONS(2107),
    [sym_float] = ACTIONS(2107),
    [sym_identifier] = ACTIONS(2107),
    [sym_true] = ACTIONS(2107),
    [sym_false] = ACTIONS(2107),
    [sym_none] = ACTIONS(2107),
    [sym_comment] = ACTIONS(72),
  },
  [582] = {
    [sym__primary_expression] = STATE(1044),
    [sym_binary_operator] = STATE(1044),
    [sym_unary_operator] = STATE(1044),
    [sym_attribute] = STATE(1044),
    [sym_subscript] = STATE(1044),
    [sym_call] = STATE(1044),
    [sym_list] = STATE(1044),
    [sym_list_comprehension] = STATE(1044),
    [sym_dictionary] = STATE(1044),
    [sym_dictionary_comprehension] = STATE(1044),
    [sym_set] = STATE(1044),
    [sym_set_comprehension] = STATE(1044),
    [sym_parenthesized_expression] = STATE(1044),
    [sym_tuple] = STATE(1044),
    [sym_generator_expression] = STATE(1044),
    [sym_concatenated_string] = STATE(1044),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_PLUS] = ACTIONS(386),
    [anon_sym_DASH] = ACTIONS(386),
    [anon_sym_TILDE] = ACTIONS(386),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(2109),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(392),
    [sym_integer] = ACTIONS(2111),
    [sym_float] = ACTIONS(2111),
    [sym_identifier] = ACTIONS(2111),
    [sym_true] = ACTIONS(2111),
    [sym_false] = ACTIONS(2111),
    [sym_none] = ACTIONS(2111),
    [sym_comment] = ACTIONS(72),
  },
  [583] = {
    [sym__primary_expression] = STATE(1039),
    [sym_binary_operator] = STATE(1039),
    [sym_unary_operator] = STATE(1039),
    [sym_attribute] = STATE(1039),
    [sym_subscript] = STATE(1039),
    [sym_call] = STATE(1039),
    [sym_list] = STATE(1039),
    [sym_list_comprehension] = STATE(1039),
    [sym_dictionary] = STATE(1039),
    [sym_dictionary_comprehension] = STATE(1039),
    [sym_set] = STATE(1039),
    [sym_set_comprehension] = STATE(1039),
    [sym_parenthesized_expression] = STATE(1039),
    [sym_tuple] = STATE(1039),
    [sym_generator_expression] = STATE(1039),
    [sym_concatenated_string] = STATE(1039),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_not] = ACTIONS(2113),
    [anon_sym_PLUS] = ACTIONS(386),
    [anon_sym_DASH] = ACTIONS(386),
    [anon_sym_TILDE] = ACTIONS(386),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(2091),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(392),
    [sym_integer] = ACTIONS(2093),
    [sym_float] = ACTIONS(2093),
    [sym_identifier] = ACTIONS(2093),
    [sym_true] = ACTIONS(2093),
    [sym_false] = ACTIONS(2093),
    [sym_none] = ACTIONS(2093),
    [sym_comment] = ACTIONS(72),
  },
  [584] = {
    [aux_sym_comparison_operator_repeat1] = STATE(1045),
    [anon_sym_RPAREN] = ACTIONS(998),
    [anon_sym_COMMA] = ACTIONS(998),
    [anon_sym_if] = ACTIONS(998),
    [anon_sym_in] = ACTIONS(1157),
    [anon_sym_not] = ACTIONS(1161),
    [anon_sym_and] = ACTIONS(998),
    [anon_sym_or] = ACTIONS(998),
    [anon_sym_LT] = ACTIONS(1173),
    [anon_sym_LT_EQ] = ACTIONS(1157),
    [anon_sym_EQ_EQ] = ACTIONS(1157),
    [anon_sym_BANG_EQ] = ACTIONS(1157),
    [anon_sym_GT_EQ] = ACTIONS(1157),
    [anon_sym_GT] = ACTIONS(1173),
    [anon_sym_LT_GT] = ACTIONS(1157),
    [anon_sym_is] = ACTIONS(1175),
    [sym_comment] = ACTIONS(72),
  },
  [585] = {
    [anon_sym_DOT] = ACTIONS(1666),
    [anon_sym_LPAREN] = ACTIONS(1666),
    [anon_sym_RPAREN] = ACTIONS(1666),
    [anon_sym_COMMA] = ACTIONS(1666),
    [anon_sym_as] = ACTIONS(1668),
    [anon_sym_STAR] = ACTIONS(1668),
    [anon_sym_GT_GT] = ACTIONS(1666),
    [anon_sym_if] = ACTIONS(1666),
    [anon_sym_COLON] = ACTIONS(1666),
    [anon_sym_else] = ACTIONS(1666),
    [anon_sym_async] = ACTIONS(1666),
    [anon_sym_for] = ACTIONS(1666),
    [anon_sym_in] = ACTIONS(1666),
    [anon_sym_EQ] = ACTIONS(1668),
    [anon_sym_AT] = ACTIONS(1666),
    [anon_sym_not] = ACTIONS(1666),
    [anon_sym_and] = ACTIONS(1666),
    [anon_sym_or] = ACTIONS(1666),
    [anon_sym_PLUS] = ACTIONS(1666),
    [anon_sym_DASH] = ACTIONS(1666),
    [anon_sym_SLASH] = ACTIONS(1668),
    [anon_sym_PERCENT] = ACTIONS(1666),
    [anon_sym_SLASH_SLASH] = ACTIONS(1666),
    [anon_sym_STAR_STAR] = ACTIONS(1666),
    [anon_sym_PIPE] = ACTIONS(1666),
    [anon_sym_AMP] = ACTIONS(1666),
    [anon_sym_CARET] = ACTIONS(1666),
    [anon_sym_LT_LT] = ACTIONS(1666),
    [anon_sym_LT] = ACTIONS(1668),
    [anon_sym_LT_EQ] = ACTIONS(1666),
    [anon_sym_EQ_EQ] = ACTIONS(1666),
    [anon_sym_BANG_EQ] = ACTIONS(1666),
    [anon_sym_GT_EQ] = ACTIONS(1666),
    [anon_sym_GT] = ACTIONS(1668),
    [anon_sym_LT_GT] = ACTIONS(1666),
    [anon_sym_is] = ACTIONS(1666),
    [anon_sym_LBRACK] = ACTIONS(1666),
    [anon_sym_RBRACK] = ACTIONS(1666),
    [anon_sym_RBRACE] = ACTIONS(1666),
    [sym_comment] = ACTIONS(72),
  },
  [586] = {
    [sym_list_splat] = STATE(870),
    [sym__expression] = STATE(871),
    [sym__primary_expression] = STATE(430),
    [sym_not_operator] = STATE(871),
    [sym_boolean_operator] = STATE(871),
    [sym_binary_operator] = STATE(430),
    [sym_unary_operator] = STATE(430),
    [sym_comparison_operator] = STATE(871),
    [sym_lambda] = STATE(871),
    [sym_attribute] = STATE(430),
    [sym_subscript] = STATE(430),
    [sym_call] = STATE(430),
    [sym_list] = STATE(430),
    [sym_list_comprehension] = STATE(430),
    [sym_dictionary] = STATE(430),
    [sym_dictionary_comprehension] = STATE(430),
    [sym_set] = STATE(430),
    [sym_set_comprehension] = STATE(430),
    [sym_parenthesized_expression] = STATE(430),
    [sym_tuple] = STATE(430),
    [sym_generator_expression] = STATE(430),
    [sym_conditional_expression] = STATE(871),
    [sym_concatenated_string] = STATE(430),
    [sym_await] = STATE(871),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_STAR] = ACTIONS(238),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_not] = ACTIONS(760),
    [anon_sym_PLUS] = ACTIONS(762),
    [anon_sym_DASH] = ACTIONS(762),
    [anon_sym_TILDE] = ACTIONS(762),
    [anon_sym_lambda] = ACTIONS(764),
    [anon_sym_LBRACK] = ACTIONS(96),
    [anon_sym_RBRACK] = ACTIONS(2115),
    [sym_ellipsis] = ACTIONS(766),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(768),
    [sym_integer] = ACTIONS(770),
    [sym_float] = ACTIONS(770),
    [sym_identifier] = ACTIONS(770),
    [sym_true] = ACTIONS(770),
    [sym_false] = ACTIONS(770),
    [sym_none] = ACTIONS(770),
    [anon_sym_await] = ACTIONS(772),
    [sym_comment] = ACTIONS(72),
  },
  [587] = {
    [aux_sym_list_repeat1] = STATE(873),
    [anon_sym_COMMA] = ACTIONS(2117),
    [anon_sym_RBRACK] = ACTIONS(2115),
    [sym_comment] = ACTIONS(72),
  },
  [588] = {
    [anon_sym_RBRACK] = ACTIONS(2119),
    [sym_comment] = ACTIONS(72),
  },
  [589] = {
    [anon_sym_DOT] = ACTIONS(1750),
    [anon_sym_LPAREN] = ACTIONS(1750),
    [anon_sym_RPAREN] = ACTIONS(1750),
    [anon_sym_COMMA] = ACTIONS(1750),
    [anon_sym_as] = ACTIONS(1752),
    [anon_sym_STAR] = ACTIONS(1752),
    [anon_sym_GT_GT] = ACTIONS(1750),
    [anon_sym_if] = ACTIONS(1750),
    [anon_sym_COLON] = ACTIONS(1750),
    [anon_sym_else] = ACTIONS(1750),
    [anon_sym_async] = ACTIONS(1750),
    [anon_sym_for] = ACTIONS(1750),
    [anon_sym_in] = ACTIONS(1750),
    [anon_sym_EQ] = ACTIONS(1752),
    [anon_sym_AT] = ACTIONS(1750),
    [anon_sym_not] = ACTIONS(1750),
    [anon_sym_and] = ACTIONS(1750),
    [anon_sym_or] = ACTIONS(1750),
    [anon_sym_PLUS] = ACTIONS(1750),
    [anon_sym_DASH] = ACTIONS(1750),
    [anon_sym_SLASH] = ACTIONS(1752),
    [anon_sym_PERCENT] = ACTIONS(1750),
    [anon_sym_SLASH_SLASH] = ACTIONS(1750),
    [anon_sym_STAR_STAR] = ACTIONS(1750),
    [anon_sym_PIPE] = ACTIONS(1750),
    [anon_sym_AMP] = ACTIONS(1750),
    [anon_sym_CARET] = ACTIONS(1750),
    [anon_sym_LT_LT] = ACTIONS(1750),
    [anon_sym_LT] = ACTIONS(1752),
    [anon_sym_LT_EQ] = ACTIONS(1750),
    [anon_sym_EQ_EQ] = ACTIONS(1750),
    [anon_sym_BANG_EQ] = ACTIONS(1750),
    [anon_sym_GT_EQ] = ACTIONS(1750),
    [anon_sym_GT] = ACTIONS(1752),
    [anon_sym_LT_GT] = ACTIONS(1750),
    [anon_sym_is] = ACTIONS(1750),
    [anon_sym_LBRACK] = ACTIONS(1750),
    [anon_sym_RBRACK] = ACTIONS(1750),
    [anon_sym_RBRACE] = ACTIONS(1750),
    [sym_comment] = ACTIONS(72),
  },
  [590] = {
    [sym_list_splat] = STATE(870),
    [sym__expression] = STATE(914),
    [sym__primary_expression] = STATE(463),
    [sym_not_operator] = STATE(914),
    [sym_boolean_operator] = STATE(914),
    [sym_binary_operator] = STATE(463),
    [sym_unary_operator] = STATE(463),
    [sym_comparison_operator] = STATE(914),
    [sym_lambda] = STATE(914),
    [sym_attribute] = STATE(463),
    [sym_subscript] = STATE(463),
    [sym_call] = STATE(463),
    [sym_list] = STATE(463),
    [sym_list_comprehension] = STATE(463),
    [sym_dictionary] = STATE(463),
    [sym_dictionary_comprehension] = STATE(463),
    [sym_set] = STATE(463),
    [sym_set_comprehension] = STATE(463),
    [sym_parenthesized_expression] = STATE(463),
    [sym_tuple] = STATE(463),
    [sym_generator_expression] = STATE(463),
    [sym_conditional_expression] = STATE(914),
    [sym_concatenated_string] = STATE(463),
    [sym_await] = STATE(914),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_STAR] = ACTIONS(1792),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_not] = ACTIONS(822),
    [anon_sym_PLUS] = ACTIONS(824),
    [anon_sym_DASH] = ACTIONS(824),
    [anon_sym_TILDE] = ACTIONS(824),
    [anon_sym_lambda] = ACTIONS(826),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(828),
    [anon_sym_LBRACE] = ACTIONS(100),
    [anon_sym_RBRACE] = ACTIONS(2121),
    [sym_string] = ACTIONS(830),
    [sym_integer] = ACTIONS(832),
    [sym_float] = ACTIONS(832),
    [sym_identifier] = ACTIONS(832),
    [sym_true] = ACTIONS(832),
    [sym_false] = ACTIONS(832),
    [sym_none] = ACTIONS(832),
    [anon_sym_await] = ACTIONS(834),
    [sym_comment] = ACTIONS(72),
  },
  [591] = {
    [anon_sym_DOT] = ACTIONS(1796),
    [anon_sym_LPAREN] = ACTIONS(1796),
    [anon_sym_RPAREN] = ACTIONS(1796),
    [anon_sym_COMMA] = ACTIONS(1796),
    [anon_sym_as] = ACTIONS(1798),
    [anon_sym_STAR] = ACTIONS(1798),
    [anon_sym_GT_GT] = ACTIONS(1796),
    [anon_sym_if] = ACTIONS(1796),
    [anon_sym_COLON] = ACTIONS(1796),
    [anon_sym_else] = ACTIONS(1796),
    [anon_sym_async] = ACTIONS(1796),
    [anon_sym_for] = ACTIONS(1796),
    [anon_sym_in] = ACTIONS(1796),
    [anon_sym_EQ] = ACTIONS(1798),
    [anon_sym_AT] = ACTIONS(1796),
    [anon_sym_not] = ACTIONS(1796),
    [anon_sym_and] = ACTIONS(1796),
    [anon_sym_or] = ACTIONS(1796),
    [anon_sym_PLUS] = ACTIONS(1796),
    [anon_sym_DASH] = ACTIONS(1796),
    [anon_sym_SLASH] = ACTIONS(1798),
    [anon_sym_PERCENT] = ACTIONS(1796),
    [anon_sym_SLASH_SLASH] = ACTIONS(1796),
    [anon_sym_STAR_STAR] = ACTIONS(1796),
    [anon_sym_PIPE] = ACTIONS(1796),
    [anon_sym_AMP] = ACTIONS(1796),
    [anon_sym_CARET] = ACTIONS(1796),
    [anon_sym_LT_LT] = ACTIONS(1796),
    [anon_sym_LT] = ACTIONS(1798),
    [anon_sym_LT_EQ] = ACTIONS(1796),
    [anon_sym_EQ_EQ] = ACTIONS(1796),
    [anon_sym_BANG_EQ] = ACTIONS(1796),
    [anon_sym_GT_EQ] = ACTIONS(1796),
    [anon_sym_GT] = ACTIONS(1798),
    [anon_sym_LT_GT] = ACTIONS(1796),
    [anon_sym_is] = ACTIONS(1796),
    [anon_sym_LBRACK] = ACTIONS(1796),
    [anon_sym_RBRACK] = ACTIONS(1796),
    [anon_sym_RBRACE] = ACTIONS(1796),
    [sym_comment] = ACTIONS(72),
  },
  [592] = {
    [aux_sym_list_repeat1] = STATE(916),
    [anon_sym_COMMA] = ACTIONS(2123),
    [anon_sym_RBRACE] = ACTIONS(2121),
    [sym_comment] = ACTIONS(72),
  },
  [593] = {
    [sym_dictionary_splat] = STATE(919),
    [sym__expression] = STATE(920),
    [sym__primary_expression] = STATE(96),
    [sym_not_operator] = STATE(920),
    [sym_boolean_operator] = STATE(920),
    [sym_binary_operator] = STATE(96),
    [sym_unary_operator] = STATE(96),
    [sym_comparison_operator] = STATE(920),
    [sym_lambda] = STATE(920),
    [sym_attribute] = STATE(96),
    [sym_subscript] = STATE(96),
    [sym_call] = STATE(96),
    [sym_list] = STATE(96),
    [sym_list_comprehension] = STATE(96),
    [sym_dictionary] = STATE(96),
    [sym_dictionary_comprehension] = STATE(96),
    [sym_pair] = STATE(919),
    [sym_set] = STATE(96),
    [sym_set_comprehension] = STATE(96),
    [sym_parenthesized_expression] = STATE(96),
    [sym_tuple] = STATE(96),
    [sym_generator_expression] = STATE(96),
    [sym_conditional_expression] = STATE(920),
    [sym_concatenated_string] = STATE(96),
    [sym_await] = STATE(920),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_STAR] = ACTIONS(1802),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_not] = ACTIONS(160),
    [anon_sym_PLUS] = ACTIONS(162),
    [anon_sym_DASH] = ACTIONS(162),
    [anon_sym_TILDE] = ACTIONS(162),
    [anon_sym_lambda] = ACTIONS(164),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(166),
    [anon_sym_LBRACE] = ACTIONS(100),
    [anon_sym_RBRACE] = ACTIONS(2125),
    [sym_string] = ACTIONS(168),
    [sym_integer] = ACTIONS(170),
    [sym_float] = ACTIONS(170),
    [sym_identifier] = ACTIONS(170),
    [sym_true] = ACTIONS(170),
    [sym_false] = ACTIONS(170),
    [sym_none] = ACTIONS(170),
    [anon_sym_await] = ACTIONS(172),
    [sym_comment] = ACTIONS(72),
  },
  [594] = {
    [aux_sym_dictionary_repeat1] = STATE(922),
    [anon_sym_COMMA] = ACTIONS(2127),
    [anon_sym_RBRACE] = ACTIONS(2125),
    [sym_comment] = ACTIONS(72),
  },
  [595] = {
    [anon_sym_RBRACE] = ACTIONS(2129),
    [sym_comment] = ACTIONS(72),
  },
  [596] = {
    [anon_sym_RBRACE] = ACTIONS(2131),
    [sym_comment] = ACTIONS(72),
  },
  [597] = {
    [aux_sym_concatenated_string_repeat1] = STATE(597),
    [anon_sym_DOT] = ACTIONS(1862),
    [anon_sym_LPAREN] = ACTIONS(1862),
    [anon_sym_RPAREN] = ACTIONS(1862),
    [anon_sym_COMMA] = ACTIONS(1862),
    [anon_sym_STAR] = ACTIONS(1864),
    [anon_sym_GT_GT] = ACTIONS(1862),
    [anon_sym_if] = ACTIONS(1862),
    [anon_sym_async] = ACTIONS(1862),
    [anon_sym_for] = ACTIONS(1862),
    [anon_sym_in] = ACTIONS(1862),
    [anon_sym_AT] = ACTIONS(1862),
    [anon_sym_not] = ACTIONS(1862),
    [anon_sym_and] = ACTIONS(1862),
    [anon_sym_or] = ACTIONS(1862),
    [anon_sym_PLUS] = ACTIONS(1862),
    [anon_sym_DASH] = ACTIONS(1862),
    [anon_sym_SLASH] = ACTIONS(1864),
    [anon_sym_PERCENT] = ACTIONS(1862),
    [anon_sym_SLASH_SLASH] = ACTIONS(1862),
    [anon_sym_STAR_STAR] = ACTIONS(1862),
    [anon_sym_PIPE] = ACTIONS(1862),
    [anon_sym_AMP] = ACTIONS(1862),
    [anon_sym_CARET] = ACTIONS(1862),
    [anon_sym_LT_LT] = ACTIONS(1862),
    [anon_sym_LT] = ACTIONS(1864),
    [anon_sym_LT_EQ] = ACTIONS(1862),
    [anon_sym_EQ_EQ] = ACTIONS(1862),
    [anon_sym_BANG_EQ] = ACTIONS(1862),
    [anon_sym_GT_EQ] = ACTIONS(1862),
    [anon_sym_GT] = ACTIONS(1864),
    [anon_sym_LT_GT] = ACTIONS(1862),
    [anon_sym_is] = ACTIONS(1862),
    [anon_sym_LBRACK] = ACTIONS(1862),
    [sym_string] = ACTIONS(2133),
    [sym_comment] = ACTIONS(72),
  },
  [598] = {
    [sym__newline] = ACTIONS(2136),
    [anon_sym_DOT] = ACTIONS(2136),
    [anon_sym_LPAREN] = ACTIONS(2136),
    [anon_sym_COMMA] = ACTIONS(2136),
    [anon_sym_STAR] = ACTIONS(2138),
    [anon_sym_GT_GT] = ACTIONS(2138),
    [anon_sym_if] = ACTIONS(2136),
    [anon_sym_COLON] = ACTIONS(2136),
    [anon_sym_in] = ACTIONS(2136),
    [anon_sym_EQ] = ACTIONS(2138),
    [anon_sym_AT] = ACTIONS(2138),
    [anon_sym_not] = ACTIONS(2136),
    [anon_sym_and] = ACTIONS(2136),
    [anon_sym_or] = ACTIONS(2136),
    [anon_sym_PLUS] = ACTIONS(2138),
    [anon_sym_DASH] = ACTIONS(2138),
    [anon_sym_SLASH] = ACTIONS(2138),
    [anon_sym_PERCENT] = ACTIONS(2138),
    [anon_sym_SLASH_SLASH] = ACTIONS(2138),
    [anon_sym_STAR_STAR] = ACTIONS(2138),
    [anon_sym_PIPE] = ACTIONS(2138),
    [anon_sym_AMP] = ACTIONS(2138),
    [anon_sym_CARET] = ACTIONS(2138),
    [anon_sym_LT_LT] = ACTIONS(2138),
    [anon_sym_LT] = ACTIONS(2138),
    [anon_sym_LT_EQ] = ACTIONS(2136),
    [anon_sym_EQ_EQ] = ACTIONS(2136),
    [anon_sym_BANG_EQ] = ACTIONS(2136),
    [anon_sym_GT_EQ] = ACTIONS(2136),
    [anon_sym_GT] = ACTIONS(2138),
    [anon_sym_LT_GT] = ACTIONS(2136),
    [anon_sym_is] = ACTIONS(2136),
    [anon_sym_PLUS_EQ] = ACTIONS(2136),
    [anon_sym_DASH_EQ] = ACTIONS(2136),
    [anon_sym_STAR_EQ] = ACTIONS(2136),
    [anon_sym_SLASH_EQ] = ACTIONS(2136),
    [anon_sym_AT_EQ] = ACTIONS(2136),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(2136),
    [anon_sym_PERCENT_EQ] = ACTIONS(2136),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2136),
    [anon_sym_GT_GT_EQ] = ACTIONS(2136),
    [anon_sym_LT_LT_EQ] = ACTIONS(2136),
    [anon_sym_AMP_EQ] = ACTIONS(2136),
    [anon_sym_CARET_EQ] = ACTIONS(2136),
    [anon_sym_PIPE_EQ] = ACTIONS(2136),
    [anon_sym_LBRACK] = ACTIONS(2136),
    [sym_comment] = ACTIONS(72),
    [sym__semicolon] = ACTIONS(2136),
  },
  [599] = {
    [anon_sym_RPAREN] = ACTIONS(2140),
    [anon_sym_COMMA] = ACTIONS(2140),
    [anon_sym_if] = ACTIONS(1147),
    [anon_sym_and] = ACTIONS(1149),
    [anon_sym_or] = ACTIONS(1151),
    [sym_comment] = ACTIONS(72),
  },
  [600] = {
    [anon_sym_RPAREN] = ACTIONS(2140),
    [anon_sym_COMMA] = ACTIONS(2140),
    [sym_comment] = ACTIONS(72),
  },
  [601] = {
    [anon_sym_if] = ACTIONS(1921),
    [anon_sym_else] = ACTIONS(2142),
    [anon_sym_and] = ACTIONS(1925),
    [anon_sym_or] = ACTIONS(1927),
    [sym_comment] = ACTIONS(72),
  },
  [602] = {
    [sym_variables] = STATE(1056),
    [sym__primary_expression] = STATE(103),
    [sym_binary_operator] = STATE(103),
    [sym_unary_operator] = STATE(103),
    [sym_attribute] = STATE(103),
    [sym_subscript] = STATE(103),
    [sym_call] = STATE(103),
    [sym_list] = STATE(103),
    [sym_list_comprehension] = STATE(103),
    [sym_dictionary] = STATE(103),
    [sym_dictionary_comprehension] = STATE(103),
    [sym_set] = STATE(103),
    [sym_set_comprehension] = STATE(103),
    [sym_parenthesized_expression] = STATE(103),
    [sym_tuple] = STATE(103),
    [sym_generator_expression] = STATE(103),
    [sym_concatenated_string] = STATE(103),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_PLUS] = ACTIONS(180),
    [anon_sym_DASH] = ACTIONS(180),
    [anon_sym_TILDE] = ACTIONS(180),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(182),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(184),
    [sym_integer] = ACTIONS(186),
    [sym_float] = ACTIONS(186),
    [sym_identifier] = ACTIONS(186),
    [sym_true] = ACTIONS(186),
    [sym_false] = ACTIONS(186),
    [sym_none] = ACTIONS(186),
    [sym_comment] = ACTIONS(72),
  },
  [603] = {
    [anon_sym_in] = ACTIONS(2144),
    [sym_comment] = ACTIONS(72),
  },
  [604] = {
    [anon_sym_RPAREN] = ACTIONS(1953),
    [anon_sym_COMMA] = ACTIONS(1953),
    [anon_sym_as] = ACTIONS(2146),
    [anon_sym_if] = ACTIONS(1953),
    [anon_sym_COLON] = ACTIONS(1953),
    [anon_sym_else] = ACTIONS(1953),
    [anon_sym_async] = ACTIONS(1953),
    [anon_sym_for] = ACTIONS(1953),
    [anon_sym_EQ] = ACTIONS(1953),
    [anon_sym_and] = ACTIONS(1953),
    [anon_sym_or] = ACTIONS(1953),
    [anon_sym_RBRACK] = ACTIONS(1953),
    [anon_sym_RBRACE] = ACTIONS(1953),
    [sym_comment] = ACTIONS(72),
  },
  [605] = {
    [anon_sym_RPAREN] = ACTIONS(1953),
    [anon_sym_COMMA] = ACTIONS(1953),
    [anon_sym_if] = ACTIONS(1953),
    [anon_sym_async] = ACTIONS(1953),
    [anon_sym_for] = ACTIONS(1953),
    [anon_sym_and] = ACTIONS(418),
    [anon_sym_or] = ACTIONS(1953),
    [sym_comment] = ACTIONS(72),
  },
  [606] = {
    [sym__newline] = ACTIONS(2148),
    [anon_sym_DOT] = ACTIONS(2148),
    [anon_sym_LPAREN] = ACTIONS(2148),
    [anon_sym_COMMA] = ACTIONS(2148),
    [anon_sym_STAR] = ACTIONS(2150),
    [anon_sym_GT_GT] = ACTIONS(2150),
    [anon_sym_if] = ACTIONS(2148),
    [anon_sym_COLON] = ACTIONS(2148),
    [anon_sym_in] = ACTIONS(2148),
    [anon_sym_EQ] = ACTIONS(2150),
    [anon_sym_AT] = ACTIONS(2150),
    [anon_sym_not] = ACTIONS(2148),
    [anon_sym_and] = ACTIONS(2148),
    [anon_sym_or] = ACTIONS(2148),
    [anon_sym_PLUS] = ACTIONS(2150),
    [anon_sym_DASH] = ACTIONS(2150),
    [anon_sym_SLASH] = ACTIONS(2150),
    [anon_sym_PERCENT] = ACTIONS(2150),
    [anon_sym_SLASH_SLASH] = ACTIONS(2150),
    [anon_sym_STAR_STAR] = ACTIONS(2150),
    [anon_sym_PIPE] = ACTIONS(2150),
    [anon_sym_AMP] = ACTIONS(2150),
    [anon_sym_CARET] = ACTIONS(2150),
    [anon_sym_LT_LT] = ACTIONS(2150),
    [anon_sym_LT] = ACTIONS(2150),
    [anon_sym_LT_EQ] = ACTIONS(2148),
    [anon_sym_EQ_EQ] = ACTIONS(2148),
    [anon_sym_BANG_EQ] = ACTIONS(2148),
    [anon_sym_GT_EQ] = ACTIONS(2148),
    [anon_sym_GT] = ACTIONS(2150),
    [anon_sym_LT_GT] = ACTIONS(2148),
    [anon_sym_is] = ACTIONS(2148),
    [anon_sym_PLUS_EQ] = ACTIONS(2148),
    [anon_sym_DASH_EQ] = ACTIONS(2148),
    [anon_sym_STAR_EQ] = ACTIONS(2148),
    [anon_sym_SLASH_EQ] = ACTIONS(2148),
    [anon_sym_AT_EQ] = ACTIONS(2148),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(2148),
    [anon_sym_PERCENT_EQ] = ACTIONS(2148),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2148),
    [anon_sym_GT_GT_EQ] = ACTIONS(2148),
    [anon_sym_LT_LT_EQ] = ACTIONS(2148),
    [anon_sym_AMP_EQ] = ACTIONS(2148),
    [anon_sym_CARET_EQ] = ACTIONS(2148),
    [anon_sym_PIPE_EQ] = ACTIONS(2148),
    [anon_sym_LBRACK] = ACTIONS(2148),
    [sym_comment] = ACTIONS(72),
    [sym__semicolon] = ACTIONS(2148),
  },
  [607] = {
    [sym__expression] = STATE(1063),
    [sym__primary_expression] = STATE(1064),
    [sym_not_operator] = STATE(1063),
    [sym_boolean_operator] = STATE(1063),
    [sym_binary_operator] = STATE(1064),
    [sym_unary_operator] = STATE(1064),
    [sym_comparison_operator] = STATE(1063),
    [sym_lambda] = STATE(1063),
    [sym_attribute] = STATE(1064),
    [sym_subscript] = STATE(1064),
    [sym_call] = STATE(1064),
    [sym_list] = STATE(1064),
    [sym_list_comprehension] = STATE(1064),
    [sym_dictionary] = STATE(1064),
    [sym_dictionary_comprehension] = STATE(1064),
    [sym_set] = STATE(1064),
    [sym_set_comprehension] = STATE(1064),
    [sym_parenthesized_expression] = STATE(1064),
    [sym_tuple] = STATE(1064),
    [sym_generator_expression] = STATE(1064),
    [sym_conditional_expression] = STATE(1063),
    [sym_concatenated_string] = STATE(1064),
    [sym_await] = STATE(1063),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_not] = ACTIONS(2152),
    [anon_sym_PLUS] = ACTIONS(2154),
    [anon_sym_DASH] = ACTIONS(2154),
    [anon_sym_TILDE] = ACTIONS(2154),
    [anon_sym_lambda] = ACTIONS(2156),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(2158),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(2160),
    [sym_integer] = ACTIONS(2162),
    [sym_float] = ACTIONS(2162),
    [sym_identifier] = ACTIONS(2162),
    [sym_true] = ACTIONS(2162),
    [sym_false] = ACTIONS(2162),
    [sym_none] = ACTIONS(2162),
    [anon_sym_await] = ACTIONS(2164),
    [sym_comment] = ACTIONS(72),
  },
  [608] = {
    [sym_for_in_clause] = STATE(1065),
    [sym_if_clause] = STATE(1065),
    [aux_sym__comprehension_body_repeat1] = STATE(1065),
    [anon_sym_RPAREN] = ACTIONS(2166),
    [anon_sym_if] = ACTIONS(1205),
    [anon_sym_async] = ACTIONS(414),
    [anon_sym_for] = ACTIONS(416),
    [sym_comment] = ACTIONS(72),
  },
  [609] = {
    [sym__expression] = STATE(599),
    [sym__primary_expression] = STATE(215),
    [sym_not_operator] = STATE(599),
    [sym_boolean_operator] = STATE(599),
    [sym_binary_operator] = STATE(215),
    [sym_unary_operator] = STATE(215),
    [sym_comparison_operator] = STATE(599),
    [sym_lambda] = STATE(599),
    [sym_yield] = STATE(600),
    [sym_attribute] = STATE(215),
    [sym_subscript] = STATE(215),
    [sym_call] = STATE(215),
    [sym_list] = STATE(215),
    [sym_list_comprehension] = STATE(215),
    [sym_dictionary] = STATE(215),
    [sym_dictionary_comprehension] = STATE(215),
    [sym_set] = STATE(215),
    [sym_set_comprehension] = STATE(215),
    [sym_parenthesized_expression] = STATE(215),
    [sym_tuple] = STATE(215),
    [sym_generator_expression] = STATE(215),
    [sym_conditional_expression] = STATE(599),
    [sym_concatenated_string] = STATE(215),
    [sym_await] = STATE(599),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_RPAREN] = ACTIONS(2168),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_not] = ACTIONS(384),
    [anon_sym_PLUS] = ACTIONS(386),
    [anon_sym_DASH] = ACTIONS(386),
    [anon_sym_TILDE] = ACTIONS(386),
    [anon_sym_lambda] = ACTIONS(388),
    [anon_sym_yield] = ACTIONS(94),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(390),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(392),
    [sym_integer] = ACTIONS(394),
    [sym_float] = ACTIONS(394),
    [sym_identifier] = ACTIONS(394),
    [sym_true] = ACTIONS(394),
    [sym_false] = ACTIONS(394),
    [sym_none] = ACTIONS(394),
    [anon_sym_await] = ACTIONS(396),
    [sym_comment] = ACTIONS(72),
  },
  [610] = {
    [aux_sym_tuple_repeat1] = STATE(610),
    [anon_sym_RPAREN] = ACTIONS(2140),
    [anon_sym_COMMA] = ACTIONS(2170),
    [sym_comment] = ACTIONS(72),
  },
  [611] = {
    [anon_sym_DOT] = ACTIONS(1962),
    [anon_sym_LPAREN] = ACTIONS(1962),
    [anon_sym_RPAREN] = ACTIONS(1962),
    [anon_sym_COMMA] = ACTIONS(1962),
    [anon_sym_as] = ACTIONS(1964),
    [anon_sym_STAR] = ACTIONS(1964),
    [anon_sym_GT_GT] = ACTIONS(1962),
    [anon_sym_if] = ACTIONS(1962),
    [anon_sym_COLON] = ACTIONS(1962),
    [anon_sym_else] = ACTIONS(1962),
    [anon_sym_async] = ACTIONS(1962),
    [anon_sym_for] = ACTIONS(1962),
    [anon_sym_in] = ACTIONS(1962),
    [anon_sym_EQ] = ACTIONS(1964),
    [anon_sym_AT] = ACTIONS(1962),
    [anon_sym_not] = ACTIONS(1962),
    [anon_sym_and] = ACTIONS(1962),
    [anon_sym_or] = ACTIONS(1962),
    [anon_sym_PLUS] = ACTIONS(1962),
    [anon_sym_DASH] = ACTIONS(1962),
    [anon_sym_SLASH] = ACTIONS(1964),
    [anon_sym_PERCENT] = ACTIONS(1962),
    [anon_sym_SLASH_SLASH] = ACTIONS(1962),
    [anon_sym_STAR_STAR] = ACTIONS(1962),
    [anon_sym_PIPE] = ACTIONS(1962),
    [anon_sym_AMP] = ACTIONS(1962),
    [anon_sym_CARET] = ACTIONS(1962),
    [anon_sym_LT_LT] = ACTIONS(1962),
    [anon_sym_LT] = ACTIONS(1964),
    [anon_sym_LT_EQ] = ACTIONS(1962),
    [anon_sym_EQ_EQ] = ACTIONS(1962),
    [anon_sym_BANG_EQ] = ACTIONS(1962),
    [anon_sym_GT_EQ] = ACTIONS(1962),
    [anon_sym_GT] = ACTIONS(1964),
    [anon_sym_LT_GT] = ACTIONS(1962),
    [anon_sym_is] = ACTIONS(1962),
    [anon_sym_LBRACK] = ACTIONS(1962),
    [anon_sym_RBRACK] = ACTIONS(1962),
    [anon_sym_RBRACE] = ACTIONS(1962),
    [sym_comment] = ACTIONS(72),
  },
  [612] = {
    [anon_sym_DOT] = ACTIONS(1966),
    [anon_sym_LPAREN] = ACTIONS(1966),
    [anon_sym_RPAREN] = ACTIONS(1966),
    [anon_sym_COMMA] = ACTIONS(1966),
    [anon_sym_as] = ACTIONS(1968),
    [anon_sym_STAR] = ACTIONS(1968),
    [anon_sym_GT_GT] = ACTIONS(1966),
    [anon_sym_if] = ACTIONS(1966),
    [anon_sym_COLON] = ACTIONS(1966),
    [anon_sym_else] = ACTIONS(1966),
    [anon_sym_async] = ACTIONS(1966),
    [anon_sym_for] = ACTIONS(1966),
    [anon_sym_in] = ACTIONS(1966),
    [anon_sym_EQ] = ACTIONS(1968),
    [anon_sym_AT] = ACTIONS(1966),
    [anon_sym_not] = ACTIONS(1966),
    [anon_sym_and] = ACTIONS(1966),
    [anon_sym_or] = ACTIONS(1966),
    [anon_sym_PLUS] = ACTIONS(1966),
    [anon_sym_DASH] = ACTIONS(1966),
    [anon_sym_SLASH] = ACTIONS(1968),
    [anon_sym_PERCENT] = ACTIONS(1966),
    [anon_sym_SLASH_SLASH] = ACTIONS(1966),
    [anon_sym_STAR_STAR] = ACTIONS(1966),
    [anon_sym_PIPE] = ACTIONS(1966),
    [anon_sym_AMP] = ACTIONS(1966),
    [anon_sym_CARET] = ACTIONS(1966),
    [anon_sym_LT_LT] = ACTIONS(1966),
    [anon_sym_LT] = ACTIONS(1968),
    [anon_sym_LT_EQ] = ACTIONS(1966),
    [anon_sym_EQ_EQ] = ACTIONS(1966),
    [anon_sym_BANG_EQ] = ACTIONS(1966),
    [anon_sym_GT_EQ] = ACTIONS(1966),
    [anon_sym_GT] = ACTIONS(1968),
    [anon_sym_LT_GT] = ACTIONS(1966),
    [anon_sym_is] = ACTIONS(1966),
    [anon_sym_LBRACK] = ACTIONS(1966),
    [anon_sym_RBRACK] = ACTIONS(1966),
    [anon_sym_RBRACE] = ACTIONS(1966),
    [sym_comment] = ACTIONS(72),
  },
  [613] = {
    [anon_sym_RPAREN] = ACTIONS(2173),
    [sym_comment] = ACTIONS(72),
  },
  [614] = {
    [aux_sym_argument_list_repeat1] = STATE(1070),
    [anon_sym_RPAREN] = ACTIONS(2173),
    [anon_sym_COMMA] = ACTIONS(2175),
    [sym_comment] = ACTIONS(72),
  },
  [615] = {
    [sym__comprehension_body] = STATE(560),
    [sym_for_in_clause] = STATE(236),
    [aux_sym_argument_list_repeat1] = STATE(1070),
    [anon_sym_RPAREN] = ACTIONS(2173),
    [anon_sym_COMMA] = ACTIONS(2175),
    [anon_sym_if] = ACTIONS(412),
    [anon_sym_async] = ACTIONS(414),
    [anon_sym_for] = ACTIONS(416),
    [anon_sym_and] = ACTIONS(418),
    [anon_sym_or] = ACTIONS(420),
    [sym_comment] = ACTIONS(72),
  },
  [616] = {
    [sym_argument_list] = STATE(251),
    [sym_generator_expression] = STATE(251),
    [anon_sym_DOT] = ACTIONS(1980),
    [anon_sym_LPAREN] = ACTIONS(424),
    [anon_sym_RPAREN] = ACTIONS(1980),
    [anon_sym_COMMA] = ACTIONS(1980),
    [anon_sym_STAR] = ACTIONS(1982),
    [anon_sym_GT_GT] = ACTIONS(1980),
    [anon_sym_if] = ACTIONS(1980),
    [anon_sym_async] = ACTIONS(1980),
    [anon_sym_for] = ACTIONS(1980),
    [anon_sym_in] = ACTIONS(1980),
    [anon_sym_AT] = ACTIONS(1980),
    [anon_sym_not] = ACTIONS(1980),
    [anon_sym_and] = ACTIONS(1980),
    [anon_sym_or] = ACTIONS(1980),
    [anon_sym_PLUS] = ACTIONS(1980),
    [anon_sym_DASH] = ACTIONS(1980),
    [anon_sym_SLASH] = ACTIONS(1982),
    [anon_sym_PERCENT] = ACTIONS(1980),
    [anon_sym_SLASH_SLASH] = ACTIONS(1980),
    [anon_sym_STAR_STAR] = ACTIONS(438),
    [anon_sym_PIPE] = ACTIONS(1980),
    [anon_sym_AMP] = ACTIONS(1980),
    [anon_sym_CARET] = ACTIONS(1980),
    [anon_sym_LT_LT] = ACTIONS(1980),
    [anon_sym_LT] = ACTIONS(1982),
    [anon_sym_LT_EQ] = ACTIONS(1980),
    [anon_sym_EQ_EQ] = ACTIONS(1980),
    [anon_sym_BANG_EQ] = ACTIONS(1980),
    [anon_sym_GT_EQ] = ACTIONS(1980),
    [anon_sym_GT] = ACTIONS(1982),
    [anon_sym_LT_GT] = ACTIONS(1980),
    [anon_sym_is] = ACTIONS(1980),
    [anon_sym_LBRACK] = ACTIONS(1980),
    [sym_comment] = ACTIONS(72),
  },
  [617] = {
    [sym_argument_list] = STATE(251),
    [sym_generator_expression] = STATE(251),
    [anon_sym_DOT] = ACTIONS(1980),
    [anon_sym_LPAREN] = ACTIONS(424),
    [anon_sym_RPAREN] = ACTIONS(1980),
    [anon_sym_COMMA] = ACTIONS(1980),
    [anon_sym_STAR] = ACTIONS(426),
    [anon_sym_GT_GT] = ACTIONS(1980),
    [anon_sym_if] = ACTIONS(1980),
    [anon_sym_async] = ACTIONS(1980),
    [anon_sym_for] = ACTIONS(1980),
    [anon_sym_in] = ACTIONS(1980),
    [anon_sym_AT] = ACTIONS(432),
    [anon_sym_not] = ACTIONS(1980),
    [anon_sym_and] = ACTIONS(1980),
    [anon_sym_or] = ACTIONS(1980),
    [anon_sym_PLUS] = ACTIONS(436),
    [anon_sym_DASH] = ACTIONS(436),
    [anon_sym_SLASH] = ACTIONS(426),
    [anon_sym_PERCENT] = ACTIONS(432),
    [anon_sym_SLASH_SLASH] = ACTIONS(432),
    [anon_sym_STAR_STAR] = ACTIONS(438),
    [anon_sym_PIPE] = ACTIONS(1980),
    [anon_sym_AMP] = ACTIONS(1980),
    [anon_sym_CARET] = ACTIONS(1980),
    [anon_sym_LT_LT] = ACTIONS(1980),
    [anon_sym_LT] = ACTIONS(1982),
    [anon_sym_LT_EQ] = ACTIONS(1980),
    [anon_sym_EQ_EQ] = ACTIONS(1980),
    [anon_sym_BANG_EQ] = ACTIONS(1980),
    [anon_sym_GT_EQ] = ACTIONS(1980),
    [anon_sym_GT] = ACTIONS(1982),
    [anon_sym_LT_GT] = ACTIONS(1980),
    [anon_sym_is] = ACTIONS(1980),
    [anon_sym_LBRACK] = ACTIONS(1980),
    [sym_comment] = ACTIONS(72),
  },
  [618] = {
    [sym_argument_list] = STATE(251),
    [sym_generator_expression] = STATE(251),
    [anon_sym_DOT] = ACTIONS(422),
    [anon_sym_LPAREN] = ACTIONS(424),
    [anon_sym_RPAREN] = ACTIONS(1984),
    [anon_sym_COMMA] = ACTIONS(1984),
    [anon_sym_STAR] = ACTIONS(426),
    [anon_sym_GT_GT] = ACTIONS(428),
    [anon_sym_if] = ACTIONS(1984),
    [anon_sym_async] = ACTIONS(1984),
    [anon_sym_for] = ACTIONS(1984),
    [anon_sym_in] = ACTIONS(1984),
    [anon_sym_AT] = ACTIONS(432),
    [anon_sym_not] = ACTIONS(1984),
    [anon_sym_and] = ACTIONS(1984),
    [anon_sym_or] = ACTIONS(1984),
    [anon_sym_PLUS] = ACTIONS(436),
    [anon_sym_DASH] = ACTIONS(436),
    [anon_sym_SLASH] = ACTIONS(426),
    [anon_sym_PERCENT] = ACTIONS(432),
    [anon_sym_SLASH_SLASH] = ACTIONS(432),
    [anon_sym_STAR_STAR] = ACTIONS(438),
    [anon_sym_PIPE] = ACTIONS(440),
    [anon_sym_AMP] = ACTIONS(442),
    [anon_sym_CARET] = ACTIONS(444),
    [anon_sym_LT_LT] = ACTIONS(428),
    [anon_sym_LT] = ACTIONS(1986),
    [anon_sym_LT_EQ] = ACTIONS(1984),
    [anon_sym_EQ_EQ] = ACTIONS(1984),
    [anon_sym_BANG_EQ] = ACTIONS(1984),
    [anon_sym_GT_EQ] = ACTIONS(1984),
    [anon_sym_GT] = ACTIONS(1986),
    [anon_sym_LT_GT] = ACTIONS(1984),
    [anon_sym_is] = ACTIONS(1984),
    [anon_sym_LBRACK] = ACTIONS(450),
    [sym_comment] = ACTIONS(72),
  },
  [619] = {
    [sym__primary_expression] = STATE(1071),
    [sym_binary_operator] = STATE(1071),
    [sym_unary_operator] = STATE(1071),
    [sym_attribute] = STATE(1071),
    [sym_subscript] = STATE(1071),
    [sym_call] = STATE(1071),
    [sym_list] = STATE(1071),
    [sym_list_comprehension] = STATE(1071),
    [sym_dictionary] = STATE(1071),
    [sym_dictionary_comprehension] = STATE(1071),
    [sym_set] = STATE(1071),
    [sym_set_comprehension] = STATE(1071),
    [sym_parenthesized_expression] = STATE(1071),
    [sym_tuple] = STATE(1071),
    [sym_generator_expression] = STATE(1071),
    [sym_concatenated_string] = STATE(1071),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_PLUS] = ACTIONS(90),
    [anon_sym_DASH] = ACTIONS(90),
    [anon_sym_TILDE] = ACTIONS(90),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(2177),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(102),
    [sym_integer] = ACTIONS(2179),
    [sym_float] = ACTIONS(2179),
    [sym_identifier] = ACTIONS(2179),
    [sym_true] = ACTIONS(2179),
    [sym_false] = ACTIONS(2179),
    [sym_none] = ACTIONS(2179),
    [sym_comment] = ACTIONS(72),
  },
  [620] = {
    [sym_argument_list] = STATE(251),
    [sym_generator_expression] = STATE(251),
    [anon_sym_DOT] = ACTIONS(1980),
    [anon_sym_LPAREN] = ACTIONS(424),
    [anon_sym_RPAREN] = ACTIONS(1980),
    [anon_sym_COMMA] = ACTIONS(1980),
    [anon_sym_STAR] = ACTIONS(426),
    [anon_sym_GT_GT] = ACTIONS(1980),
    [anon_sym_if] = ACTIONS(1980),
    [anon_sym_async] = ACTIONS(1980),
    [anon_sym_for] = ACTIONS(1980),
    [anon_sym_in] = ACTIONS(1980),
    [anon_sym_AT] = ACTIONS(432),
    [anon_sym_not] = ACTIONS(1980),
    [anon_sym_and] = ACTIONS(1980),
    [anon_sym_or] = ACTIONS(1980),
    [anon_sym_PLUS] = ACTIONS(1980),
    [anon_sym_DASH] = ACTIONS(1980),
    [anon_sym_SLASH] = ACTIONS(426),
    [anon_sym_PERCENT] = ACTIONS(432),
    [anon_sym_SLASH_SLASH] = ACTIONS(432),
    [anon_sym_STAR_STAR] = ACTIONS(438),
    [anon_sym_PIPE] = ACTIONS(1980),
    [anon_sym_AMP] = ACTIONS(1980),
    [anon_sym_CARET] = ACTIONS(1980),
    [anon_sym_LT_LT] = ACTIONS(1980),
    [anon_sym_LT] = ACTIONS(1982),
    [anon_sym_LT_EQ] = ACTIONS(1980),
    [anon_sym_EQ_EQ] = ACTIONS(1980),
    [anon_sym_BANG_EQ] = ACTIONS(1980),
    [anon_sym_GT_EQ] = ACTIONS(1980),
    [anon_sym_GT] = ACTIONS(1982),
    [anon_sym_LT_GT] = ACTIONS(1980),
    [anon_sym_is] = ACTIONS(1980),
    [anon_sym_LBRACK] = ACTIONS(1980),
    [sym_comment] = ACTIONS(72),
  },
  [621] = {
    [sym_argument_list] = STATE(251),
    [sym_generator_expression] = STATE(251),
    [anon_sym_DOT] = ACTIONS(1980),
    [anon_sym_LPAREN] = ACTIONS(424),
    [anon_sym_RPAREN] = ACTIONS(1980),
    [anon_sym_COMMA] = ACTIONS(1980),
    [anon_sym_as] = ACTIONS(1982),
    [anon_sym_STAR] = ACTIONS(1982),
    [anon_sym_GT_GT] = ACTIONS(1980),
    [anon_sym_if] = ACTIONS(1980),
    [anon_sym_COLON] = ACTIONS(1980),
    [anon_sym_else] = ACTIONS(1980),
    [anon_sym_async] = ACTIONS(1980),
    [anon_sym_for] = ACTIONS(1980),
    [anon_sym_in] = ACTIONS(1980),
    [anon_sym_EQ] = ACTIONS(1982),
    [anon_sym_AT] = ACTIONS(1980),
    [anon_sym_not] = ACTIONS(1980),
    [anon_sym_and] = ACTIONS(1980),
    [anon_sym_or] = ACTIONS(1980),
    [anon_sym_PLUS] = ACTIONS(1980),
    [anon_sym_DASH] = ACTIONS(1980),
    [anon_sym_SLASH] = ACTIONS(1982),
    [anon_sym_PERCENT] = ACTIONS(1980),
    [anon_sym_SLASH_SLASH] = ACTIONS(1980),
    [anon_sym_STAR_STAR] = ACTIONS(1980),
    [anon_sym_PIPE] = ACTIONS(1980),
    [anon_sym_AMP] = ACTIONS(1980),
    [anon_sym_CARET] = ACTIONS(1980),
    [anon_sym_LT_LT] = ACTIONS(1980),
    [anon_sym_LT] = ACTIONS(1982),
    [anon_sym_LT_EQ] = ACTIONS(1980),
    [anon_sym_EQ_EQ] = ACTIONS(1980),
    [anon_sym_BANG_EQ] = ACTIONS(1980),
    [anon_sym_GT_EQ] = ACTIONS(1980),
    [anon_sym_GT] = ACTIONS(1982),
    [anon_sym_LT_GT] = ACTIONS(1980),
    [anon_sym_is] = ACTIONS(1980),
    [anon_sym_LBRACK] = ACTIONS(1980),
    [anon_sym_RBRACK] = ACTIONS(1980),
    [anon_sym_RBRACE] = ACTIONS(1980),
    [sym_comment] = ACTIONS(72),
  },
  [622] = {
    [sym_argument_list] = STATE(251),
    [sym_generator_expression] = STATE(251),
    [anon_sym_DOT] = ACTIONS(1980),
    [anon_sym_LPAREN] = ACTIONS(424),
    [anon_sym_RPAREN] = ACTIONS(1980),
    [anon_sym_COMMA] = ACTIONS(1980),
    [anon_sym_STAR] = ACTIONS(426),
    [anon_sym_GT_GT] = ACTIONS(428),
    [anon_sym_if] = ACTIONS(1980),
    [anon_sym_async] = ACTIONS(1980),
    [anon_sym_for] = ACTIONS(1980),
    [anon_sym_in] = ACTIONS(1980),
    [anon_sym_AT] = ACTIONS(432),
    [anon_sym_not] = ACTIONS(1980),
    [anon_sym_and] = ACTIONS(1980),
    [anon_sym_or] = ACTIONS(1980),
    [anon_sym_PLUS] = ACTIONS(436),
    [anon_sym_DASH] = ACTIONS(436),
    [anon_sym_SLASH] = ACTIONS(426),
    [anon_sym_PERCENT] = ACTIONS(432),
    [anon_sym_SLASH_SLASH] = ACTIONS(432),
    [anon_sym_STAR_STAR] = ACTIONS(438),
    [anon_sym_PIPE] = ACTIONS(1980),
    [anon_sym_AMP] = ACTIONS(442),
    [anon_sym_CARET] = ACTIONS(444),
    [anon_sym_LT_LT] = ACTIONS(428),
    [anon_sym_LT] = ACTIONS(1982),
    [anon_sym_LT_EQ] = ACTIONS(1980),
    [anon_sym_EQ_EQ] = ACTIONS(1980),
    [anon_sym_BANG_EQ] = ACTIONS(1980),
    [anon_sym_GT_EQ] = ACTIONS(1980),
    [anon_sym_GT] = ACTIONS(1982),
    [anon_sym_LT_GT] = ACTIONS(1980),
    [anon_sym_is] = ACTIONS(1980),
    [anon_sym_LBRACK] = ACTIONS(1980),
    [sym_comment] = ACTIONS(72),
  },
  [623] = {
    [sym_argument_list] = STATE(251),
    [sym_generator_expression] = STATE(251),
    [anon_sym_DOT] = ACTIONS(1980),
    [anon_sym_LPAREN] = ACTIONS(424),
    [anon_sym_RPAREN] = ACTIONS(1980),
    [anon_sym_COMMA] = ACTIONS(1980),
    [anon_sym_STAR] = ACTIONS(426),
    [anon_sym_GT_GT] = ACTIONS(428),
    [anon_sym_if] = ACTIONS(1980),
    [anon_sym_async] = ACTIONS(1980),
    [anon_sym_for] = ACTIONS(1980),
    [anon_sym_in] = ACTIONS(1980),
    [anon_sym_AT] = ACTIONS(432),
    [anon_sym_not] = ACTIONS(1980),
    [anon_sym_and] = ACTIONS(1980),
    [anon_sym_or] = ACTIONS(1980),
    [anon_sym_PLUS] = ACTIONS(436),
    [anon_sym_DASH] = ACTIONS(436),
    [anon_sym_SLASH] = ACTIONS(426),
    [anon_sym_PERCENT] = ACTIONS(432),
    [anon_sym_SLASH_SLASH] = ACTIONS(432),
    [anon_sym_STAR_STAR] = ACTIONS(438),
    [anon_sym_PIPE] = ACTIONS(1980),
    [anon_sym_AMP] = ACTIONS(1980),
    [anon_sym_CARET] = ACTIONS(444),
    [anon_sym_LT_LT] = ACTIONS(428),
    [anon_sym_LT] = ACTIONS(1982),
    [anon_sym_LT_EQ] = ACTIONS(1980),
    [anon_sym_EQ_EQ] = ACTIONS(1980),
    [anon_sym_BANG_EQ] = ACTIONS(1980),
    [anon_sym_GT_EQ] = ACTIONS(1980),
    [anon_sym_GT] = ACTIONS(1982),
    [anon_sym_LT_GT] = ACTIONS(1980),
    [anon_sym_is] = ACTIONS(1980),
    [anon_sym_LBRACK] = ACTIONS(1980),
    [sym_comment] = ACTIONS(72),
  },
  [624] = {
    [sym_argument_list] = STATE(251),
    [sym_generator_expression] = STATE(251),
    [anon_sym_DOT] = ACTIONS(1980),
    [anon_sym_LPAREN] = ACTIONS(424),
    [anon_sym_RPAREN] = ACTIONS(1980),
    [anon_sym_COMMA] = ACTIONS(1980),
    [anon_sym_STAR] = ACTIONS(426),
    [anon_sym_GT_GT] = ACTIONS(428),
    [anon_sym_if] = ACTIONS(1980),
    [anon_sym_async] = ACTIONS(1980),
    [anon_sym_for] = ACTIONS(1980),
    [anon_sym_in] = ACTIONS(1980),
    [anon_sym_AT] = ACTIONS(432),
    [anon_sym_not] = ACTIONS(1980),
    [anon_sym_and] = ACTIONS(1980),
    [anon_sym_or] = ACTIONS(1980),
    [anon_sym_PLUS] = ACTIONS(436),
    [anon_sym_DASH] = ACTIONS(436),
    [anon_sym_SLASH] = ACTIONS(426),
    [anon_sym_PERCENT] = ACTIONS(432),
    [anon_sym_SLASH_SLASH] = ACTIONS(432),
    [anon_sym_STAR_STAR] = ACTIONS(438),
    [anon_sym_PIPE] = ACTIONS(1980),
    [anon_sym_AMP] = ACTIONS(1980),
    [anon_sym_CARET] = ACTIONS(1980),
    [anon_sym_LT_LT] = ACTIONS(428),
    [anon_sym_LT] = ACTIONS(1982),
    [anon_sym_LT_EQ] = ACTIONS(1980),
    [anon_sym_EQ_EQ] = ACTIONS(1980),
    [anon_sym_BANG_EQ] = ACTIONS(1980),
    [anon_sym_GT_EQ] = ACTIONS(1980),
    [anon_sym_GT] = ACTIONS(1982),
    [anon_sym_LT_GT] = ACTIONS(1980),
    [anon_sym_is] = ACTIONS(1980),
    [anon_sym_LBRACK] = ACTIONS(1980),
    [sym_comment] = ACTIONS(72),
  },
  [625] = {
    [aux_sym_subscript_repeat1] = STATE(1074),
    [anon_sym_COMMA] = ACTIONS(2181),
    [anon_sym_if] = ACTIONS(2002),
    [anon_sym_COLON] = ACTIONS(2004),
    [anon_sym_and] = ACTIONS(2006),
    [anon_sym_or] = ACTIONS(2008),
    [anon_sym_RBRACK] = ACTIONS(2183),
    [sym_comment] = ACTIONS(72),
  },
  [626] = {
    [aux_sym_subscript_repeat1] = STATE(1074),
    [anon_sym_COMMA] = ACTIONS(2181),
    [anon_sym_RBRACK] = ACTIONS(2183),
    [sym_comment] = ACTIONS(72),
  },
  [627] = {
    [aux_sym_comparison_operator_repeat1] = STATE(627),
    [anon_sym_RPAREN] = ACTIONS(1984),
    [anon_sym_COMMA] = ACTIONS(1984),
    [anon_sym_if] = ACTIONS(1984),
    [anon_sym_async] = ACTIONS(1984),
    [anon_sym_for] = ACTIONS(1984),
    [anon_sym_in] = ACTIONS(2185),
    [anon_sym_not] = ACTIONS(2188),
    [anon_sym_and] = ACTIONS(1984),
    [anon_sym_or] = ACTIONS(1984),
    [anon_sym_LT] = ACTIONS(2191),
    [anon_sym_LT_EQ] = ACTIONS(2185),
    [anon_sym_EQ_EQ] = ACTIONS(2185),
    [anon_sym_BANG_EQ] = ACTIONS(2185),
    [anon_sym_GT_EQ] = ACTIONS(2185),
    [anon_sym_GT] = ACTIONS(2191),
    [anon_sym_LT_GT] = ACTIONS(2185),
    [anon_sym_is] = ACTIONS(2194),
    [sym_comment] = ACTIONS(72),
  },
  [628] = {
    [sym__newline] = ACTIONS(1135),
    [anon_sym_DOT] = ACTIONS(1135),
    [anon_sym_from] = ACTIONS(1135),
    [anon_sym_LPAREN] = ACTIONS(1135),
    [anon_sym_COMMA] = ACTIONS(1135),
    [anon_sym_STAR] = ACTIONS(1137),
    [anon_sym_GT_GT] = ACTIONS(1135),
    [anon_sym_if] = ACTIONS(1135),
    [anon_sym_in] = ACTIONS(1135),
    [anon_sym_EQ] = ACTIONS(1137),
    [anon_sym_AT] = ACTIONS(1135),
    [anon_sym_not] = ACTIONS(1135),
    [anon_sym_and] = ACTIONS(1135),
    [anon_sym_or] = ACTIONS(1135),
    [anon_sym_PLUS] = ACTIONS(1135),
    [anon_sym_DASH] = ACTIONS(1135),
    [anon_sym_SLASH] = ACTIONS(1137),
    [anon_sym_PERCENT] = ACTIONS(1135),
    [anon_sym_SLASH_SLASH] = ACTIONS(1135),
    [anon_sym_STAR_STAR] = ACTIONS(1135),
    [anon_sym_PIPE] = ACTIONS(1135),
    [anon_sym_AMP] = ACTIONS(1135),
    [anon_sym_CARET] = ACTIONS(1135),
    [anon_sym_LT_LT] = ACTIONS(1135),
    [anon_sym_LT] = ACTIONS(1137),
    [anon_sym_LT_EQ] = ACTIONS(1135),
    [anon_sym_EQ_EQ] = ACTIONS(1135),
    [anon_sym_BANG_EQ] = ACTIONS(1135),
    [anon_sym_GT_EQ] = ACTIONS(1135),
    [anon_sym_GT] = ACTIONS(1137),
    [anon_sym_LT_GT] = ACTIONS(1135),
    [anon_sym_is] = ACTIONS(1135),
    [anon_sym_LBRACK] = ACTIONS(1135),
    [sym_comment] = ACTIONS(72),
    [sym__semicolon] = ACTIONS(1135),
  },
  [629] = {
    [sym__newline] = ACTIONS(1193),
    [anon_sym_DOT] = ACTIONS(1193),
    [anon_sym_from] = ACTIONS(1193),
    [anon_sym_LPAREN] = ACTIONS(1193),
    [anon_sym_COMMA] = ACTIONS(1193),
    [anon_sym_STAR] = ACTIONS(1195),
    [anon_sym_GT_GT] = ACTIONS(1193),
    [anon_sym_if] = ACTIONS(1193),
    [anon_sym_in] = ACTIONS(1193),
    [anon_sym_EQ] = ACTIONS(1195),
    [anon_sym_AT] = ACTIONS(1193),
    [anon_sym_not] = ACTIONS(1193),
    [anon_sym_and] = ACTIONS(1193),
    [anon_sym_or] = ACTIONS(1193),
    [anon_sym_PLUS] = ACTIONS(1193),
    [anon_sym_DASH] = ACTIONS(1193),
    [anon_sym_SLASH] = ACTIONS(1195),
    [anon_sym_PERCENT] = ACTIONS(1193),
    [anon_sym_SLASH_SLASH] = ACTIONS(1193),
    [anon_sym_STAR_STAR] = ACTIONS(1193),
    [anon_sym_PIPE] = ACTIONS(1193),
    [anon_sym_AMP] = ACTIONS(1193),
    [anon_sym_CARET] = ACTIONS(1193),
    [anon_sym_LT_LT] = ACTIONS(1193),
    [anon_sym_LT] = ACTIONS(1195),
    [anon_sym_LT_EQ] = ACTIONS(1193),
    [anon_sym_EQ_EQ] = ACTIONS(1193),
    [anon_sym_BANG_EQ] = ACTIONS(1193),
    [anon_sym_GT_EQ] = ACTIONS(1193),
    [anon_sym_GT] = ACTIONS(1195),
    [anon_sym_LT_GT] = ACTIONS(1193),
    [anon_sym_is] = ACTIONS(1193),
    [anon_sym_LBRACK] = ACTIONS(1193),
    [sym_comment] = ACTIONS(72),
    [sym__semicolon] = ACTIONS(1193),
  },
  [630] = {
    [sym__expression] = STATE(599),
    [sym__primary_expression] = STATE(215),
    [sym_not_operator] = STATE(599),
    [sym_boolean_operator] = STATE(599),
    [sym_binary_operator] = STATE(215),
    [sym_unary_operator] = STATE(215),
    [sym_comparison_operator] = STATE(599),
    [sym_lambda] = STATE(599),
    [sym_yield] = STATE(600),
    [sym_attribute] = STATE(215),
    [sym_subscript] = STATE(215),
    [sym_call] = STATE(215),
    [sym_list] = STATE(215),
    [sym_list_comprehension] = STATE(215),
    [sym_dictionary] = STATE(215),
    [sym_dictionary_comprehension] = STATE(215),
    [sym_set] = STATE(215),
    [sym_set_comprehension] = STATE(215),
    [sym_parenthesized_expression] = STATE(215),
    [sym_tuple] = STATE(215),
    [sym_generator_expression] = STATE(215),
    [sym_conditional_expression] = STATE(599),
    [sym_concatenated_string] = STATE(215),
    [sym_await] = STATE(599),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_RPAREN] = ACTIONS(2197),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_not] = ACTIONS(384),
    [anon_sym_PLUS] = ACTIONS(386),
    [anon_sym_DASH] = ACTIONS(386),
    [anon_sym_TILDE] = ACTIONS(386),
    [anon_sym_lambda] = ACTIONS(388),
    [anon_sym_yield] = ACTIONS(94),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(390),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(392),
    [sym_integer] = ACTIONS(394),
    [sym_float] = ACTIONS(394),
    [sym_identifier] = ACTIONS(394),
    [sym_true] = ACTIONS(394),
    [sym_false] = ACTIONS(394),
    [sym_none] = ACTIONS(394),
    [anon_sym_await] = ACTIONS(396),
    [sym_comment] = ACTIONS(72),
  },
  [631] = {
    [anon_sym_RPAREN] = ACTIONS(2199),
    [sym_comment] = ACTIONS(72),
  },
  [632] = {
    [aux_sym_tuple_repeat1] = STATE(610),
    [anon_sym_RPAREN] = ACTIONS(2197),
    [anon_sym_COMMA] = ACTIONS(2201),
    [sym_comment] = ACTIONS(72),
  },
  [633] = {
    [sym__newline] = ACTIONS(1644),
    [anon_sym_COMMA] = ACTIONS(1644),
    [anon_sym_if] = ACTIONS(476),
    [anon_sym_and] = ACTIONS(478),
    [anon_sym_or] = ACTIONS(480),
    [sym_comment] = ACTIONS(72),
    [sym__semicolon] = ACTIONS(1644),
  },
  [634] = {
    [sym__expression] = STATE(1078),
    [sym__primary_expression] = STATE(73),
    [sym_not_operator] = STATE(1078),
    [sym_boolean_operator] = STATE(1078),
    [sym_binary_operator] = STATE(73),
    [sym_unary_operator] = STATE(73),
    [sym_comparison_operator] = STATE(1078),
    [sym_lambda] = STATE(1078),
    [sym_attribute] = STATE(73),
    [sym_subscript] = STATE(73),
    [sym_call] = STATE(73),
    [sym_list] = STATE(73),
    [sym_list_comprehension] = STATE(73),
    [sym_dictionary] = STATE(73),
    [sym_dictionary_comprehension] = STATE(73),
    [sym_set] = STATE(73),
    [sym_set_comprehension] = STATE(73),
    [sym_parenthesized_expression] = STATE(73),
    [sym_tuple] = STATE(73),
    [sym_generator_expression] = STATE(73),
    [sym_conditional_expression] = STATE(1078),
    [sym_concatenated_string] = STATE(73),
    [sym_await] = STATE(1078),
    [anon_sym_LPAREN] = ACTIONS(130),
    [anon_sym_print] = ACTIONS(112),
    [anon_sym_exec] = ACTIONS(112),
    [anon_sym_not] = ACTIONS(132),
    [anon_sym_PLUS] = ACTIONS(116),
    [anon_sym_DASH] = ACTIONS(116),
    [anon_sym_TILDE] = ACTIONS(116),
    [anon_sym_lambda] = ACTIONS(118),
    [anon_sym_LBRACK] = ACTIONS(134),
    [sym_ellipsis] = ACTIONS(120),
    [anon_sym_LBRACE] = ACTIONS(122),
    [sym_string] = ACTIONS(124),
    [sym_integer] = ACTIONS(126),
    [sym_float] = ACTIONS(126),
    [sym_identifier] = ACTIONS(126),
    [sym_true] = ACTIONS(126),
    [sym_false] = ACTIONS(126),
    [sym_none] = ACTIONS(126),
    [anon_sym_await] = ACTIONS(128),
    [sym_comment] = ACTIONS(72),
  },
  [635] = {
    [sym__newline] = ACTIONS(1666),
    [anon_sym_DOT] = ACTIONS(1666),
    [anon_sym_from] = ACTIONS(1666),
    [anon_sym_LPAREN] = ACTIONS(1666),
    [anon_sym_COMMA] = ACTIONS(1666),
    [anon_sym_STAR] = ACTIONS(1668),
    [anon_sym_GT_GT] = ACTIONS(1666),
    [anon_sym_if] = ACTIONS(1666),
    [anon_sym_in] = ACTIONS(1666),
    [anon_sym_EQ] = ACTIONS(1668),
    [anon_sym_AT] = ACTIONS(1666),
    [anon_sym_not] = ACTIONS(1666),
    [anon_sym_and] = ACTIONS(1666),
    [anon_sym_or] = ACTIONS(1666),
    [anon_sym_PLUS] = ACTIONS(1666),
    [anon_sym_DASH] = ACTIONS(1666),
    [anon_sym_SLASH] = ACTIONS(1668),
    [anon_sym_PERCENT] = ACTIONS(1666),
    [anon_sym_SLASH_SLASH] = ACTIONS(1666),
    [anon_sym_STAR_STAR] = ACTIONS(1666),
    [anon_sym_PIPE] = ACTIONS(1666),
    [anon_sym_AMP] = ACTIONS(1666),
    [anon_sym_CARET] = ACTIONS(1666),
    [anon_sym_LT_LT] = ACTIONS(1666),
    [anon_sym_LT] = ACTIONS(1668),
    [anon_sym_LT_EQ] = ACTIONS(1666),
    [anon_sym_EQ_EQ] = ACTIONS(1666),
    [anon_sym_BANG_EQ] = ACTIONS(1666),
    [anon_sym_GT_EQ] = ACTIONS(1666),
    [anon_sym_GT] = ACTIONS(1668),
    [anon_sym_LT_GT] = ACTIONS(1666),
    [anon_sym_is] = ACTIONS(1666),
    [anon_sym_LBRACK] = ACTIONS(1666),
    [sym_comment] = ACTIONS(72),
    [sym__semicolon] = ACTIONS(1666),
  },
  [636] = {
    [sym_list_splat] = STATE(870),
    [sym__expression] = STATE(871),
    [sym__primary_expression] = STATE(430),
    [sym_not_operator] = STATE(871),
    [sym_boolean_operator] = STATE(871),
    [sym_binary_operator] = STATE(430),
    [sym_unary_operator] = STATE(430),
    [sym_comparison_operator] = STATE(871),
    [sym_lambda] = STATE(871),
    [sym_attribute] = STATE(430),
    [sym_subscript] = STATE(430),
    [sym_call] = STATE(430),
    [sym_list] = STATE(430),
    [sym_list_comprehension] = STATE(430),
    [sym_dictionary] = STATE(430),
    [sym_dictionary_comprehension] = STATE(430),
    [sym_set] = STATE(430),
    [sym_set_comprehension] = STATE(430),
    [sym_parenthesized_expression] = STATE(430),
    [sym_tuple] = STATE(430),
    [sym_generator_expression] = STATE(430),
    [sym_conditional_expression] = STATE(871),
    [sym_concatenated_string] = STATE(430),
    [sym_await] = STATE(871),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_STAR] = ACTIONS(238),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_not] = ACTIONS(760),
    [anon_sym_PLUS] = ACTIONS(762),
    [anon_sym_DASH] = ACTIONS(762),
    [anon_sym_TILDE] = ACTIONS(762),
    [anon_sym_lambda] = ACTIONS(764),
    [anon_sym_LBRACK] = ACTIONS(96),
    [anon_sym_RBRACK] = ACTIONS(2203),
    [sym_ellipsis] = ACTIONS(766),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(768),
    [sym_integer] = ACTIONS(770),
    [sym_float] = ACTIONS(770),
    [sym_identifier] = ACTIONS(770),
    [sym_true] = ACTIONS(770),
    [sym_false] = ACTIONS(770),
    [sym_none] = ACTIONS(770),
    [anon_sym_await] = ACTIONS(772),
    [sym_comment] = ACTIONS(72),
  },
  [637] = {
    [aux_sym_list_repeat1] = STATE(873),
    [anon_sym_COMMA] = ACTIONS(2205),
    [anon_sym_RBRACK] = ACTIONS(2203),
    [sym_comment] = ACTIONS(72),
  },
  [638] = {
    [anon_sym_RBRACK] = ACTIONS(2207),
    [sym_comment] = ACTIONS(72),
  },
  [639] = {
    [sym__newline] = ACTIONS(1750),
    [anon_sym_DOT] = ACTIONS(1750),
    [anon_sym_from] = ACTIONS(1750),
    [anon_sym_LPAREN] = ACTIONS(1750),
    [anon_sym_COMMA] = ACTIONS(1750),
    [anon_sym_STAR] = ACTIONS(1752),
    [anon_sym_GT_GT] = ACTIONS(1750),
    [anon_sym_if] = ACTIONS(1750),
    [anon_sym_in] = ACTIONS(1750),
    [anon_sym_EQ] = ACTIONS(1752),
    [anon_sym_AT] = ACTIONS(1750),
    [anon_sym_not] = ACTIONS(1750),
    [anon_sym_and] = ACTIONS(1750),
    [anon_sym_or] = ACTIONS(1750),
    [anon_sym_PLUS] = ACTIONS(1750),
    [anon_sym_DASH] = ACTIONS(1750),
    [anon_sym_SLASH] = ACTIONS(1752),
    [anon_sym_PERCENT] = ACTIONS(1750),
    [anon_sym_SLASH_SLASH] = ACTIONS(1750),
    [anon_sym_STAR_STAR] = ACTIONS(1750),
    [anon_sym_PIPE] = ACTIONS(1750),
    [anon_sym_AMP] = ACTIONS(1750),
    [anon_sym_CARET] = ACTIONS(1750),
    [anon_sym_LT_LT] = ACTIONS(1750),
    [anon_sym_LT] = ACTIONS(1752),
    [anon_sym_LT_EQ] = ACTIONS(1750),
    [anon_sym_EQ_EQ] = ACTIONS(1750),
    [anon_sym_BANG_EQ] = ACTIONS(1750),
    [anon_sym_GT_EQ] = ACTIONS(1750),
    [anon_sym_GT] = ACTIONS(1752),
    [anon_sym_LT_GT] = ACTIONS(1750),
    [anon_sym_is] = ACTIONS(1750),
    [anon_sym_LBRACK] = ACTIONS(1750),
    [sym_comment] = ACTIONS(72),
    [sym__semicolon] = ACTIONS(1750),
  },
  [640] = {
    [sym_list_splat] = STATE(870),
    [sym__expression] = STATE(914),
    [sym__primary_expression] = STATE(463),
    [sym_not_operator] = STATE(914),
    [sym_boolean_operator] = STATE(914),
    [sym_binary_operator] = STATE(463),
    [sym_unary_operator] = STATE(463),
    [sym_comparison_operator] = STATE(914),
    [sym_lambda] = STATE(914),
    [sym_attribute] = STATE(463),
    [sym_subscript] = STATE(463),
    [sym_call] = STATE(463),
    [sym_list] = STATE(463),
    [sym_list_comprehension] = STATE(463),
    [sym_dictionary] = STATE(463),
    [sym_dictionary_comprehension] = STATE(463),
    [sym_set] = STATE(463),
    [sym_set_comprehension] = STATE(463),
    [sym_parenthesized_expression] = STATE(463),
    [sym_tuple] = STATE(463),
    [sym_generator_expression] = STATE(463),
    [sym_conditional_expression] = STATE(914),
    [sym_concatenated_string] = STATE(463),
    [sym_await] = STATE(914),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_STAR] = ACTIONS(1792),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_not] = ACTIONS(822),
    [anon_sym_PLUS] = ACTIONS(824),
    [anon_sym_DASH] = ACTIONS(824),
    [anon_sym_TILDE] = ACTIONS(824),
    [anon_sym_lambda] = ACTIONS(826),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(828),
    [anon_sym_LBRACE] = ACTIONS(100),
    [anon_sym_RBRACE] = ACTIONS(2209),
    [sym_string] = ACTIONS(830),
    [sym_integer] = ACTIONS(832),
    [sym_float] = ACTIONS(832),
    [sym_identifier] = ACTIONS(832),
    [sym_true] = ACTIONS(832),
    [sym_false] = ACTIONS(832),
    [sym_none] = ACTIONS(832),
    [anon_sym_await] = ACTIONS(834),
    [sym_comment] = ACTIONS(72),
  },
  [641] = {
    [sym__newline] = ACTIONS(1796),
    [anon_sym_DOT] = ACTIONS(1796),
    [anon_sym_from] = ACTIONS(1796),
    [anon_sym_LPAREN] = ACTIONS(1796),
    [anon_sym_COMMA] = ACTIONS(1796),
    [anon_sym_STAR] = ACTIONS(1798),
    [anon_sym_GT_GT] = ACTIONS(1796),
    [anon_sym_if] = ACTIONS(1796),
    [anon_sym_in] = ACTIONS(1796),
    [anon_sym_EQ] = ACTIONS(1798),
    [anon_sym_AT] = ACTIONS(1796),
    [anon_sym_not] = ACTIONS(1796),
    [anon_sym_and] = ACTIONS(1796),
    [anon_sym_or] = ACTIONS(1796),
    [anon_sym_PLUS] = ACTIONS(1796),
    [anon_sym_DASH] = ACTIONS(1796),
    [anon_sym_SLASH] = ACTIONS(1798),
    [anon_sym_PERCENT] = ACTIONS(1796),
    [anon_sym_SLASH_SLASH] = ACTIONS(1796),
    [anon_sym_STAR_STAR] = ACTIONS(1796),
    [anon_sym_PIPE] = ACTIONS(1796),
    [anon_sym_AMP] = ACTIONS(1796),
    [anon_sym_CARET] = ACTIONS(1796),
    [anon_sym_LT_LT] = ACTIONS(1796),
    [anon_sym_LT] = ACTIONS(1798),
    [anon_sym_LT_EQ] = ACTIONS(1796),
    [anon_sym_EQ_EQ] = ACTIONS(1796),
    [anon_sym_BANG_EQ] = ACTIONS(1796),
    [anon_sym_GT_EQ] = ACTIONS(1796),
    [anon_sym_GT] = ACTIONS(1798),
    [anon_sym_LT_GT] = ACTIONS(1796),
    [anon_sym_is] = ACTIONS(1796),
    [anon_sym_LBRACK] = ACTIONS(1796),
    [sym_comment] = ACTIONS(72),
    [sym__semicolon] = ACTIONS(1796),
  },
  [642] = {
    [aux_sym_list_repeat1] = STATE(916),
    [anon_sym_COMMA] = ACTIONS(2211),
    [anon_sym_RBRACE] = ACTIONS(2209),
    [sym_comment] = ACTIONS(72),
  },
  [643] = {
    [sym_dictionary_splat] = STATE(919),
    [sym__expression] = STATE(920),
    [sym__primary_expression] = STATE(96),
    [sym_not_operator] = STATE(920),
    [sym_boolean_operator] = STATE(920),
    [sym_binary_operator] = STATE(96),
    [sym_unary_operator] = STATE(96),
    [sym_comparison_operator] = STATE(920),
    [sym_lambda] = STATE(920),
    [sym_attribute] = STATE(96),
    [sym_subscript] = STATE(96),
    [sym_call] = STATE(96),
    [sym_list] = STATE(96),
    [sym_list_comprehension] = STATE(96),
    [sym_dictionary] = STATE(96),
    [sym_dictionary_comprehension] = STATE(96),
    [sym_pair] = STATE(919),
    [sym_set] = STATE(96),
    [sym_set_comprehension] = STATE(96),
    [sym_parenthesized_expression] = STATE(96),
    [sym_tuple] = STATE(96),
    [sym_generator_expression] = STATE(96),
    [sym_conditional_expression] = STATE(920),
    [sym_concatenated_string] = STATE(96),
    [sym_await] = STATE(920),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_STAR] = ACTIONS(1802),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_not] = ACTIONS(160),
    [anon_sym_PLUS] = ACTIONS(162),
    [anon_sym_DASH] = ACTIONS(162),
    [anon_sym_TILDE] = ACTIONS(162),
    [anon_sym_lambda] = ACTIONS(164),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(166),
    [anon_sym_LBRACE] = ACTIONS(100),
    [anon_sym_RBRACE] = ACTIONS(2213),
    [sym_string] = ACTIONS(168),
    [sym_integer] = ACTIONS(170),
    [sym_float] = ACTIONS(170),
    [sym_identifier] = ACTIONS(170),
    [sym_true] = ACTIONS(170),
    [sym_false] = ACTIONS(170),
    [sym_none] = ACTIONS(170),
    [anon_sym_await] = ACTIONS(172),
    [sym_comment] = ACTIONS(72),
  },
  [644] = {
    [aux_sym_dictionary_repeat1] = STATE(922),
    [anon_sym_COMMA] = ACTIONS(2215),
    [anon_sym_RBRACE] = ACTIONS(2213),
    [sym_comment] = ACTIONS(72),
  },
  [645] = {
    [anon_sym_RBRACE] = ACTIONS(2217),
    [sym_comment] = ACTIONS(72),
  },
  [646] = {
    [anon_sym_RBRACE] = ACTIONS(2219),
    [sym_comment] = ACTIONS(72),
  },
  [647] = {
    [aux_sym_concatenated_string_repeat1] = STATE(647),
    [sym__newline] = ACTIONS(1862),
    [anon_sym_DOT] = ACTIONS(1862),
    [anon_sym_LPAREN] = ACTIONS(1862),
    [anon_sym_COMMA] = ACTIONS(1862),
    [anon_sym_STAR] = ACTIONS(1864),
    [anon_sym_GT_GT] = ACTIONS(1862),
    [anon_sym_if] = ACTIONS(1862),
    [anon_sym_in] = ACTIONS(1862),
    [anon_sym_AT] = ACTIONS(1862),
    [anon_sym_not] = ACTIONS(1862),
    [anon_sym_and] = ACTIONS(1862),
    [anon_sym_or] = ACTIONS(1862),
    [anon_sym_PLUS] = ACTIONS(1862),
    [anon_sym_DASH] = ACTIONS(1862),
    [anon_sym_SLASH] = ACTIONS(1864),
    [anon_sym_PERCENT] = ACTIONS(1862),
    [anon_sym_SLASH_SLASH] = ACTIONS(1862),
    [anon_sym_STAR_STAR] = ACTIONS(1862),
    [anon_sym_PIPE] = ACTIONS(1862),
    [anon_sym_AMP] = ACTIONS(1862),
    [anon_sym_CARET] = ACTIONS(1862),
    [anon_sym_LT_LT] = ACTIONS(1862),
    [anon_sym_LT] = ACTIONS(1864),
    [anon_sym_LT_EQ] = ACTIONS(1862),
    [anon_sym_EQ_EQ] = ACTIONS(1862),
    [anon_sym_BANG_EQ] = ACTIONS(1862),
    [anon_sym_GT_EQ] = ACTIONS(1862),
    [anon_sym_GT] = ACTIONS(1864),
    [anon_sym_LT_GT] = ACTIONS(1862),
    [anon_sym_is] = ACTIONS(1862),
    [anon_sym_LBRACK] = ACTIONS(1862),
    [sym_string] = ACTIONS(2221),
    [sym_comment] = ACTIONS(72),
    [sym__semicolon] = ACTIONS(1862),
  },
  [648] = {
    [sym__newline] = ACTIONS(1915),
    [anon_sym_COMMA] = ACTIONS(1915),
    [anon_sym_if] = ACTIONS(476),
    [anon_sym_and] = ACTIONS(478),
    [anon_sym_or] = ACTIONS(480),
    [sym_comment] = ACTIONS(72),
    [sym__semicolon] = ACTIONS(1915),
  },
  [649] = {
    [sym__expression] = STATE(648),
    [sym__primary_expression] = STATE(73),
    [sym_not_operator] = STATE(648),
    [sym_boolean_operator] = STATE(648),
    [sym_binary_operator] = STATE(73),
    [sym_unary_operator] = STATE(73),
    [sym_comparison_operator] = STATE(648),
    [sym_lambda] = STATE(648),
    [sym_attribute] = STATE(73),
    [sym_subscript] = STATE(73),
    [sym_call] = STATE(73),
    [sym_list] = STATE(73),
    [sym_list_comprehension] = STATE(73),
    [sym_dictionary] = STATE(73),
    [sym_dictionary_comprehension] = STATE(73),
    [sym_set] = STATE(73),
    [sym_set_comprehension] = STATE(73),
    [sym_parenthesized_expression] = STATE(73),
    [sym_tuple] = STATE(73),
    [sym_generator_expression] = STATE(73),
    [sym_conditional_expression] = STATE(648),
    [sym_concatenated_string] = STATE(73),
    [sym_await] = STATE(648),
    [sym__newline] = ACTIONS(2224),
    [anon_sym_LPAREN] = ACTIONS(130),
    [anon_sym_print] = ACTIONS(112),
    [anon_sym_exec] = ACTIONS(112),
    [anon_sym_not] = ACTIONS(132),
    [anon_sym_PLUS] = ACTIONS(116),
    [anon_sym_DASH] = ACTIONS(116),
    [anon_sym_TILDE] = ACTIONS(116),
    [anon_sym_lambda] = ACTIONS(118),
    [anon_sym_LBRACK] = ACTIONS(134),
    [sym_ellipsis] = ACTIONS(120),
    [anon_sym_LBRACE] = ACTIONS(122),
    [sym_string] = ACTIONS(124),
    [sym_integer] = ACTIONS(126),
    [sym_float] = ACTIONS(126),
    [sym_identifier] = ACTIONS(126),
    [sym_true] = ACTIONS(126),
    [sym_false] = ACTIONS(126),
    [sym_none] = ACTIONS(126),
    [anon_sym_await] = ACTIONS(128),
    [sym_comment] = ACTIONS(72),
    [sym__semicolon] = ACTIONS(2224),
  },
  [650] = {
    [aux_sym_print_statement_repeat1] = STATE(650),
    [sym__newline] = ACTIONS(1915),
    [anon_sym_COMMA] = ACTIONS(2226),
    [sym_comment] = ACTIONS(72),
    [sym__semicolon] = ACTIONS(1915),
  },
  [651] = {
    [anon_sym_if] = ACTIONS(1921),
    [anon_sym_else] = ACTIONS(2229),
    [anon_sym_and] = ACTIONS(1925),
    [anon_sym_or] = ACTIONS(1927),
    [sym_comment] = ACTIONS(72),
  },
  [652] = {
    [sym__newline] = ACTIONS(1953),
    [anon_sym_COMMA] = ACTIONS(1953),
    [anon_sym_if] = ACTIONS(1953),
    [anon_sym_and] = ACTIONS(478),
    [anon_sym_or] = ACTIONS(1953),
    [sym_comment] = ACTIONS(72),
    [sym__semicolon] = ACTIONS(1953),
  },
  [653] = {
    [sym__newline] = ACTIONS(1962),
    [anon_sym_DOT] = ACTIONS(1962),
    [anon_sym_from] = ACTIONS(1962),
    [anon_sym_LPAREN] = ACTIONS(1962),
    [anon_sym_COMMA] = ACTIONS(1962),
    [anon_sym_STAR] = ACTIONS(1964),
    [anon_sym_GT_GT] = ACTIONS(1962),
    [anon_sym_if] = ACTIONS(1962),
    [anon_sym_in] = ACTIONS(1962),
    [anon_sym_EQ] = ACTIONS(1964),
    [anon_sym_AT] = ACTIONS(1962),
    [anon_sym_not] = ACTIONS(1962),
    [anon_sym_and] = ACTIONS(1962),
    [anon_sym_or] = ACTIONS(1962),
    [anon_sym_PLUS] = ACTIONS(1962),
    [anon_sym_DASH] = ACTIONS(1962),
    [anon_sym_SLASH] = ACTIONS(1964),
    [anon_sym_PERCENT] = ACTIONS(1962),
    [anon_sym_SLASH_SLASH] = ACTIONS(1962),
    [anon_sym_STAR_STAR] = ACTIONS(1962),
    [anon_sym_PIPE] = ACTIONS(1962),
    [anon_sym_AMP] = ACTIONS(1962),
    [anon_sym_CARET] = ACTIONS(1962),
    [anon_sym_LT_LT] = ACTIONS(1962),
    [anon_sym_LT] = ACTIONS(1964),
    [anon_sym_LT_EQ] = ACTIONS(1962),
    [anon_sym_EQ_EQ] = ACTIONS(1962),
    [anon_sym_BANG_EQ] = ACTIONS(1962),
    [anon_sym_GT_EQ] = ACTIONS(1962),
    [anon_sym_GT] = ACTIONS(1964),
    [anon_sym_LT_GT] = ACTIONS(1962),
    [anon_sym_is] = ACTIONS(1962),
    [anon_sym_LBRACK] = ACTIONS(1962),
    [sym_comment] = ACTIONS(72),
    [sym__semicolon] = ACTIONS(1962),
  },
  [654] = {
    [sym__newline] = ACTIONS(1966),
    [anon_sym_DOT] = ACTIONS(1966),
    [anon_sym_from] = ACTIONS(1966),
    [anon_sym_LPAREN] = ACTIONS(1966),
    [anon_sym_COMMA] = ACTIONS(1966),
    [anon_sym_STAR] = ACTIONS(1968),
    [anon_sym_GT_GT] = ACTIONS(1966),
    [anon_sym_if] = ACTIONS(1966),
    [anon_sym_in] = ACTIONS(1966),
    [anon_sym_EQ] = ACTIONS(1968),
    [anon_sym_AT] = ACTIONS(1966),
    [anon_sym_not] = ACTIONS(1966),
    [anon_sym_and] = ACTIONS(1966),
    [anon_sym_or] = ACTIONS(1966),
    [anon_sym_PLUS] = ACTIONS(1966),
    [anon_sym_DASH] = ACTIONS(1966),
    [anon_sym_SLASH] = ACTIONS(1968),
    [anon_sym_PERCENT] = ACTIONS(1966),
    [anon_sym_SLASH_SLASH] = ACTIONS(1966),
    [anon_sym_STAR_STAR] = ACTIONS(1966),
    [anon_sym_PIPE] = ACTIONS(1966),
    [anon_sym_AMP] = ACTIONS(1966),
    [anon_sym_CARET] = ACTIONS(1966),
    [anon_sym_LT_LT] = ACTIONS(1966),
    [anon_sym_LT] = ACTIONS(1968),
    [anon_sym_LT_EQ] = ACTIONS(1966),
    [anon_sym_EQ_EQ] = ACTIONS(1966),
    [anon_sym_BANG_EQ] = ACTIONS(1966),
    [anon_sym_GT_EQ] = ACTIONS(1966),
    [anon_sym_GT] = ACTIONS(1968),
    [anon_sym_LT_GT] = ACTIONS(1966),
    [anon_sym_is] = ACTIONS(1966),
    [anon_sym_LBRACK] = ACTIONS(1966),
    [sym_comment] = ACTIONS(72),
    [sym__semicolon] = ACTIONS(1966),
  },
  [655] = {
    [anon_sym_RPAREN] = ACTIONS(2231),
    [sym_comment] = ACTIONS(72),
  },
  [656] = {
    [aux_sym_argument_list_repeat1] = STATE(1091),
    [anon_sym_RPAREN] = ACTIONS(2231),
    [anon_sym_COMMA] = ACTIONS(2233),
    [sym_comment] = ACTIONS(72),
  },
  [657] = {
    [sym__comprehension_body] = STATE(631),
    [sym_for_in_clause] = STATE(236),
    [aux_sym_argument_list_repeat1] = STATE(1091),
    [anon_sym_RPAREN] = ACTIONS(2231),
    [anon_sym_COMMA] = ACTIONS(2233),
    [anon_sym_if] = ACTIONS(412),
    [anon_sym_async] = ACTIONS(414),
    [anon_sym_for] = ACTIONS(416),
    [anon_sym_and] = ACTIONS(418),
    [anon_sym_or] = ACTIONS(420),
    [sym_comment] = ACTIONS(72),
  },
  [658] = {
    [sym_argument_list] = STATE(291),
    [sym_generator_expression] = STATE(291),
    [sym__newline] = ACTIONS(1980),
    [anon_sym_DOT] = ACTIONS(1980),
    [anon_sym_LPAREN] = ACTIONS(484),
    [anon_sym_COMMA] = ACTIONS(1980),
    [anon_sym_STAR] = ACTIONS(1982),
    [anon_sym_GT_GT] = ACTIONS(1980),
    [anon_sym_if] = ACTIONS(1980),
    [anon_sym_in] = ACTIONS(1980),
    [anon_sym_AT] = ACTIONS(1980),
    [anon_sym_not] = ACTIONS(1980),
    [anon_sym_and] = ACTIONS(1980),
    [anon_sym_or] = ACTIONS(1980),
    [anon_sym_PLUS] = ACTIONS(1980),
    [anon_sym_DASH] = ACTIONS(1980),
    [anon_sym_SLASH] = ACTIONS(1982),
    [anon_sym_PERCENT] = ACTIONS(1980),
    [anon_sym_SLASH_SLASH] = ACTIONS(1980),
    [anon_sym_STAR_STAR] = ACTIONS(498),
    [anon_sym_PIPE] = ACTIONS(1980),
    [anon_sym_AMP] = ACTIONS(1980),
    [anon_sym_CARET] = ACTIONS(1980),
    [anon_sym_LT_LT] = ACTIONS(1980),
    [anon_sym_LT] = ACTIONS(1982),
    [anon_sym_LT_EQ] = ACTIONS(1980),
    [anon_sym_EQ_EQ] = ACTIONS(1980),
    [anon_sym_BANG_EQ] = ACTIONS(1980),
    [anon_sym_GT_EQ] = ACTIONS(1980),
    [anon_sym_GT] = ACTIONS(1982),
    [anon_sym_LT_GT] = ACTIONS(1980),
    [anon_sym_is] = ACTIONS(1980),
    [anon_sym_LBRACK] = ACTIONS(1980),
    [sym_comment] = ACTIONS(72),
    [sym__semicolon] = ACTIONS(1980),
  },
  [659] = {
    [sym_argument_list] = STATE(291),
    [sym_generator_expression] = STATE(291),
    [sym__newline] = ACTIONS(1980),
    [anon_sym_DOT] = ACTIONS(1980),
    [anon_sym_LPAREN] = ACTIONS(484),
    [anon_sym_COMMA] = ACTIONS(1980),
    [anon_sym_STAR] = ACTIONS(486),
    [anon_sym_GT_GT] = ACTIONS(1980),
    [anon_sym_if] = ACTIONS(1980),
    [anon_sym_in] = ACTIONS(1980),
    [anon_sym_AT] = ACTIONS(492),
    [anon_sym_not] = ACTIONS(1980),
    [anon_sym_and] = ACTIONS(1980),
    [anon_sym_or] = ACTIONS(1980),
    [anon_sym_PLUS] = ACTIONS(496),
    [anon_sym_DASH] = ACTIONS(496),
    [anon_sym_SLASH] = ACTIONS(486),
    [anon_sym_PERCENT] = ACTIONS(492),
    [anon_sym_SLASH_SLASH] = ACTIONS(492),
    [anon_sym_STAR_STAR] = ACTIONS(498),
    [anon_sym_PIPE] = ACTIONS(1980),
    [anon_sym_AMP] = ACTIONS(1980),
    [anon_sym_CARET] = ACTIONS(1980),
    [anon_sym_LT_LT] = ACTIONS(1980),
    [anon_sym_LT] = ACTIONS(1982),
    [anon_sym_LT_EQ] = ACTIONS(1980),
    [anon_sym_EQ_EQ] = ACTIONS(1980),
    [anon_sym_BANG_EQ] = ACTIONS(1980),
    [anon_sym_GT_EQ] = ACTIONS(1980),
    [anon_sym_GT] = ACTIONS(1982),
    [anon_sym_LT_GT] = ACTIONS(1980),
    [anon_sym_is] = ACTIONS(1980),
    [anon_sym_LBRACK] = ACTIONS(1980),
    [sym_comment] = ACTIONS(72),
    [sym__semicolon] = ACTIONS(1980),
  },
  [660] = {
    [sym_argument_list] = STATE(291),
    [sym_generator_expression] = STATE(291),
    [sym__newline] = ACTIONS(1984),
    [anon_sym_DOT] = ACTIONS(482),
    [anon_sym_LPAREN] = ACTIONS(484),
    [anon_sym_COMMA] = ACTIONS(1984),
    [anon_sym_STAR] = ACTIONS(486),
    [anon_sym_GT_GT] = ACTIONS(488),
    [anon_sym_if] = ACTIONS(1984),
    [anon_sym_in] = ACTIONS(1984),
    [anon_sym_AT] = ACTIONS(492),
    [anon_sym_not] = ACTIONS(1984),
    [anon_sym_and] = ACTIONS(1984),
    [anon_sym_or] = ACTIONS(1984),
    [anon_sym_PLUS] = ACTIONS(496),
    [anon_sym_DASH] = ACTIONS(496),
    [anon_sym_SLASH] = ACTIONS(486),
    [anon_sym_PERCENT] = ACTIONS(492),
    [anon_sym_SLASH_SLASH] = ACTIONS(492),
    [anon_sym_STAR_STAR] = ACTIONS(498),
    [anon_sym_PIPE] = ACTIONS(500),
    [anon_sym_AMP] = ACTIONS(502),
    [anon_sym_CARET] = ACTIONS(504),
    [anon_sym_LT_LT] = ACTIONS(488),
    [anon_sym_LT] = ACTIONS(1986),
    [anon_sym_LT_EQ] = ACTIONS(1984),
    [anon_sym_EQ_EQ] = ACTIONS(1984),
    [anon_sym_BANG_EQ] = ACTIONS(1984),
    [anon_sym_GT_EQ] = ACTIONS(1984),
    [anon_sym_GT] = ACTIONS(1986),
    [anon_sym_LT_GT] = ACTIONS(1984),
    [anon_sym_is] = ACTIONS(1984),
    [anon_sym_LBRACK] = ACTIONS(510),
    [sym_comment] = ACTIONS(72),
    [sym__semicolon] = ACTIONS(1984),
  },
  [661] = {
    [sym__primary_expression] = STATE(1092),
    [sym_binary_operator] = STATE(1092),
    [sym_unary_operator] = STATE(1092),
    [sym_attribute] = STATE(1092),
    [sym_subscript] = STATE(1092),
    [sym_call] = STATE(1092),
    [sym_list] = STATE(1092),
    [sym_list_comprehension] = STATE(1092),
    [sym_dictionary] = STATE(1092),
    [sym_dictionary_comprehension] = STATE(1092),
    [sym_set] = STATE(1092),
    [sym_set_comprehension] = STATE(1092),
    [sym_parenthesized_expression] = STATE(1092),
    [sym_tuple] = STATE(1092),
    [sym_generator_expression] = STATE(1092),
    [sym_concatenated_string] = STATE(1092),
    [anon_sym_LPAREN] = ACTIONS(130),
    [anon_sym_print] = ACTIONS(112),
    [anon_sym_exec] = ACTIONS(112),
    [anon_sym_PLUS] = ACTIONS(116),
    [anon_sym_DASH] = ACTIONS(116),
    [anon_sym_TILDE] = ACTIONS(116),
    [anon_sym_LBRACK] = ACTIONS(134),
    [sym_ellipsis] = ACTIONS(2235),
    [anon_sym_LBRACE] = ACTIONS(122),
    [sym_string] = ACTIONS(124),
    [sym_integer] = ACTIONS(2237),
    [sym_float] = ACTIONS(2237),
    [sym_identifier] = ACTIONS(2237),
    [sym_true] = ACTIONS(2237),
    [sym_false] = ACTIONS(2237),
    [sym_none] = ACTIONS(2237),
    [sym_comment] = ACTIONS(72),
  },
  [662] = {
    [sym_argument_list] = STATE(291),
    [sym_generator_expression] = STATE(291),
    [sym__newline] = ACTIONS(1980),
    [anon_sym_DOT] = ACTIONS(1980),
    [anon_sym_LPAREN] = ACTIONS(484),
    [anon_sym_COMMA] = ACTIONS(1980),
    [anon_sym_STAR] = ACTIONS(486),
    [anon_sym_GT_GT] = ACTIONS(1980),
    [anon_sym_if] = ACTIONS(1980),
    [anon_sym_in] = ACTIONS(1980),
    [anon_sym_AT] = ACTIONS(492),
    [anon_sym_not] = ACTIONS(1980),
    [anon_sym_and] = ACTIONS(1980),
    [anon_sym_or] = ACTIONS(1980),
    [anon_sym_PLUS] = ACTIONS(1980),
    [anon_sym_DASH] = ACTIONS(1980),
    [anon_sym_SLASH] = ACTIONS(486),
    [anon_sym_PERCENT] = ACTIONS(492),
    [anon_sym_SLASH_SLASH] = ACTIONS(492),
    [anon_sym_STAR_STAR] = ACTIONS(498),
    [anon_sym_PIPE] = ACTIONS(1980),
    [anon_sym_AMP] = ACTIONS(1980),
    [anon_sym_CARET] = ACTIONS(1980),
    [anon_sym_LT_LT] = ACTIONS(1980),
    [anon_sym_LT] = ACTIONS(1982),
    [anon_sym_LT_EQ] = ACTIONS(1980),
    [anon_sym_EQ_EQ] = ACTIONS(1980),
    [anon_sym_BANG_EQ] = ACTIONS(1980),
    [anon_sym_GT_EQ] = ACTIONS(1980),
    [anon_sym_GT] = ACTIONS(1982),
    [anon_sym_LT_GT] = ACTIONS(1980),
    [anon_sym_is] = ACTIONS(1980),
    [anon_sym_LBRACK] = ACTIONS(1980),
    [sym_comment] = ACTIONS(72),
    [sym__semicolon] = ACTIONS(1980),
  },
  [663] = {
    [sym_argument_list] = STATE(291),
    [sym_generator_expression] = STATE(291),
    [sym__newline] = ACTIONS(1980),
    [anon_sym_DOT] = ACTIONS(1980),
    [anon_sym_from] = ACTIONS(1980),
    [anon_sym_LPAREN] = ACTIONS(484),
    [anon_sym_COMMA] = ACTIONS(1980),
    [anon_sym_STAR] = ACTIONS(1982),
    [anon_sym_GT_GT] = ACTIONS(1980),
    [anon_sym_if] = ACTIONS(1980),
    [anon_sym_in] = ACTIONS(1980),
    [anon_sym_EQ] = ACTIONS(1982),
    [anon_sym_AT] = ACTIONS(1980),
    [anon_sym_not] = ACTIONS(1980),
    [anon_sym_and] = ACTIONS(1980),
    [anon_sym_or] = ACTIONS(1980),
    [anon_sym_PLUS] = ACTIONS(1980),
    [anon_sym_DASH] = ACTIONS(1980),
    [anon_sym_SLASH] = ACTIONS(1982),
    [anon_sym_PERCENT] = ACTIONS(1980),
    [anon_sym_SLASH_SLASH] = ACTIONS(1980),
    [anon_sym_STAR_STAR] = ACTIONS(1980),
    [anon_sym_PIPE] = ACTIONS(1980),
    [anon_sym_AMP] = ACTIONS(1980),
    [anon_sym_CARET] = ACTIONS(1980),
    [anon_sym_LT_LT] = ACTIONS(1980),
    [anon_sym_LT] = ACTIONS(1982),
    [anon_sym_LT_EQ] = ACTIONS(1980),
    [anon_sym_EQ_EQ] = ACTIONS(1980),
    [anon_sym_BANG_EQ] = ACTIONS(1980),
    [anon_sym_GT_EQ] = ACTIONS(1980),
    [anon_sym_GT] = ACTIONS(1982),
    [anon_sym_LT_GT] = ACTIONS(1980),
    [anon_sym_is] = ACTIONS(1980),
    [anon_sym_LBRACK] = ACTIONS(1980),
    [sym_comment] = ACTIONS(72),
    [sym__semicolon] = ACTIONS(1980),
  },
  [664] = {
    [sym_argument_list] = STATE(291),
    [sym_generator_expression] = STATE(291),
    [sym__newline] = ACTIONS(1980),
    [anon_sym_DOT] = ACTIONS(1980),
    [anon_sym_LPAREN] = ACTIONS(484),
    [anon_sym_COMMA] = ACTIONS(1980),
    [anon_sym_STAR] = ACTIONS(486),
    [anon_sym_GT_GT] = ACTIONS(488),
    [anon_sym_if] = ACTIONS(1980),
    [anon_sym_in] = ACTIONS(1980),
    [anon_sym_AT] = ACTIONS(492),
    [anon_sym_not] = ACTIONS(1980),
    [anon_sym_and] = ACTIONS(1980),
    [anon_sym_or] = ACTIONS(1980),
    [anon_sym_PLUS] = ACTIONS(496),
    [anon_sym_DASH] = ACTIONS(496),
    [anon_sym_SLASH] = ACTIONS(486),
    [anon_sym_PERCENT] = ACTIONS(492),
    [anon_sym_SLASH_SLASH] = ACTIONS(492),
    [anon_sym_STAR_STAR] = ACTIONS(498),
    [anon_sym_PIPE] = ACTIONS(1980),
    [anon_sym_AMP] = ACTIONS(502),
    [anon_sym_CARET] = ACTIONS(504),
    [anon_sym_LT_LT] = ACTIONS(488),
    [anon_sym_LT] = ACTIONS(1982),
    [anon_sym_LT_EQ] = ACTIONS(1980),
    [anon_sym_EQ_EQ] = ACTIONS(1980),
    [anon_sym_BANG_EQ] = ACTIONS(1980),
    [anon_sym_GT_EQ] = ACTIONS(1980),
    [anon_sym_GT] = ACTIONS(1982),
    [anon_sym_LT_GT] = ACTIONS(1980),
    [anon_sym_is] = ACTIONS(1980),
    [anon_sym_LBRACK] = ACTIONS(1980),
    [sym_comment] = ACTIONS(72),
    [sym__semicolon] = ACTIONS(1980),
  },
  [665] = {
    [sym_argument_list] = STATE(291),
    [sym_generator_expression] = STATE(291),
    [sym__newline] = ACTIONS(1980),
    [anon_sym_DOT] = ACTIONS(1980),
    [anon_sym_LPAREN] = ACTIONS(484),
    [anon_sym_COMMA] = ACTIONS(1980),
    [anon_sym_STAR] = ACTIONS(486),
    [anon_sym_GT_GT] = ACTIONS(488),
    [anon_sym_if] = ACTIONS(1980),
    [anon_sym_in] = ACTIONS(1980),
    [anon_sym_AT] = ACTIONS(492),
    [anon_sym_not] = ACTIONS(1980),
    [anon_sym_and] = ACTIONS(1980),
    [anon_sym_or] = ACTIONS(1980),
    [anon_sym_PLUS] = ACTIONS(496),
    [anon_sym_DASH] = ACTIONS(496),
    [anon_sym_SLASH] = ACTIONS(486),
    [anon_sym_PERCENT] = ACTIONS(492),
    [anon_sym_SLASH_SLASH] = ACTIONS(492),
    [anon_sym_STAR_STAR] = ACTIONS(498),
    [anon_sym_PIPE] = ACTIONS(1980),
    [anon_sym_AMP] = ACTIONS(1980),
    [anon_sym_CARET] = ACTIONS(504),
    [anon_sym_LT_LT] = ACTIONS(488),
    [anon_sym_LT] = ACTIONS(1982),
    [anon_sym_LT_EQ] = ACTIONS(1980),
    [anon_sym_EQ_EQ] = ACTIONS(1980),
    [anon_sym_BANG_EQ] = ACTIONS(1980),
    [anon_sym_GT_EQ] = ACTIONS(1980),
    [anon_sym_GT] = ACTIONS(1982),
    [anon_sym_LT_GT] = ACTIONS(1980),
    [anon_sym_is] = ACTIONS(1980),
    [anon_sym_LBRACK] = ACTIONS(1980),
    [sym_comment] = ACTIONS(72),
    [sym__semicolon] = ACTIONS(1980),
  },
  [666] = {
    [sym_argument_list] = STATE(291),
    [sym_generator_expression] = STATE(291),
    [sym__newline] = ACTIONS(1980),
    [anon_sym_DOT] = ACTIONS(1980),
    [anon_sym_LPAREN] = ACTIONS(484),
    [anon_sym_COMMA] = ACTIONS(1980),
    [anon_sym_STAR] = ACTIONS(486),
    [anon_sym_GT_GT] = ACTIONS(488),
    [anon_sym_if] = ACTIONS(1980),
    [anon_sym_in] = ACTIONS(1980),
    [anon_sym_AT] = ACTIONS(492),
    [anon_sym_not] = ACTIONS(1980),
    [anon_sym_and] = ACTIONS(1980),
    [anon_sym_or] = ACTIONS(1980),
    [anon_sym_PLUS] = ACTIONS(496),
    [anon_sym_DASH] = ACTIONS(496),
    [anon_sym_SLASH] = ACTIONS(486),
    [anon_sym_PERCENT] = ACTIONS(492),
    [anon_sym_SLASH_SLASH] = ACTIONS(492),
    [anon_sym_STAR_STAR] = ACTIONS(498),
    [anon_sym_PIPE] = ACTIONS(1980),
    [anon_sym_AMP] = ACTIONS(1980),
    [anon_sym_CARET] = ACTIONS(1980),
    [anon_sym_LT_LT] = ACTIONS(488),
    [anon_sym_LT] = ACTIONS(1982),
    [anon_sym_LT_EQ] = ACTIONS(1980),
    [anon_sym_EQ_EQ] = ACTIONS(1980),
    [anon_sym_BANG_EQ] = ACTIONS(1980),
    [anon_sym_GT_EQ] = ACTIONS(1980),
    [anon_sym_GT] = ACTIONS(1982),
    [anon_sym_LT_GT] = ACTIONS(1980),
    [anon_sym_is] = ACTIONS(1980),
    [anon_sym_LBRACK] = ACTIONS(1980),
    [sym_comment] = ACTIONS(72),
    [sym__semicolon] = ACTIONS(1980),
  },
  [667] = {
    [aux_sym_subscript_repeat1] = STATE(1095),
    [anon_sym_COMMA] = ACTIONS(2239),
    [anon_sym_if] = ACTIONS(2002),
    [anon_sym_COLON] = ACTIONS(2004),
    [anon_sym_and] = ACTIONS(2006),
    [anon_sym_or] = ACTIONS(2008),
    [anon_sym_RBRACK] = ACTIONS(2241),
    [sym_comment] = ACTIONS(72),
  },
  [668] = {
    [aux_sym_subscript_repeat1] = STATE(1095),
    [anon_sym_COMMA] = ACTIONS(2239),
    [anon_sym_RBRACK] = ACTIONS(2241),
    [sym_comment] = ACTIONS(72),
  },
  [669] = {
    [aux_sym_comparison_operator_repeat1] = STATE(669),
    [sym__newline] = ACTIONS(1984),
    [anon_sym_COMMA] = ACTIONS(1984),
    [anon_sym_if] = ACTIONS(1984),
    [anon_sym_in] = ACTIONS(2243),
    [anon_sym_not] = ACTIONS(2246),
    [anon_sym_and] = ACTIONS(1984),
    [anon_sym_or] = ACTIONS(1984),
    [anon_sym_LT] = ACTIONS(2249),
    [anon_sym_LT_EQ] = ACTIONS(2243),
    [anon_sym_EQ_EQ] = ACTIONS(2243),
    [anon_sym_BANG_EQ] = ACTIONS(2243),
    [anon_sym_GT_EQ] = ACTIONS(2243),
    [anon_sym_GT] = ACTIONS(2249),
    [anon_sym_LT_GT] = ACTIONS(2243),
    [anon_sym_is] = ACTIONS(2252),
    [sym_comment] = ACTIONS(72),
    [sym__semicolon] = ACTIONS(1984),
  },
  [670] = {
    [sym__expression] = STATE(648),
    [sym__primary_expression] = STATE(73),
    [sym_not_operator] = STATE(648),
    [sym_boolean_operator] = STATE(648),
    [sym_binary_operator] = STATE(73),
    [sym_unary_operator] = STATE(73),
    [sym_comparison_operator] = STATE(648),
    [sym_lambda] = STATE(648),
    [sym_attribute] = STATE(73),
    [sym_subscript] = STATE(73),
    [sym_call] = STATE(73),
    [sym_list] = STATE(73),
    [sym_list_comprehension] = STATE(73),
    [sym_dictionary] = STATE(73),
    [sym_dictionary_comprehension] = STATE(73),
    [sym_set] = STATE(73),
    [sym_set_comprehension] = STATE(73),
    [sym_parenthesized_expression] = STATE(73),
    [sym_tuple] = STATE(73),
    [sym_generator_expression] = STATE(73),
    [sym_conditional_expression] = STATE(648),
    [sym_concatenated_string] = STATE(73),
    [sym_await] = STATE(648),
    [sym__newline] = ACTIONS(1957),
    [anon_sym_LPAREN] = ACTIONS(130),
    [anon_sym_print] = ACTIONS(112),
    [anon_sym_exec] = ACTIONS(112),
    [anon_sym_not] = ACTIONS(132),
    [anon_sym_PLUS] = ACTIONS(116),
    [anon_sym_DASH] = ACTIONS(116),
    [anon_sym_TILDE] = ACTIONS(116),
    [anon_sym_lambda] = ACTIONS(118),
    [anon_sym_LBRACK] = ACTIONS(134),
    [sym_ellipsis] = ACTIONS(120),
    [anon_sym_LBRACE] = ACTIONS(122),
    [sym_string] = ACTIONS(124),
    [sym_integer] = ACTIONS(126),
    [sym_float] = ACTIONS(126),
    [sym_identifier] = ACTIONS(126),
    [sym_true] = ACTIONS(126),
    [sym_false] = ACTIONS(126),
    [sym_none] = ACTIONS(126),
    [anon_sym_await] = ACTIONS(128),
    [sym_comment] = ACTIONS(72),
    [sym__semicolon] = ACTIONS(1957),
  },
  [671] = {
    [sym__newline] = ACTIONS(716),
    [anon_sym_if] = ACTIONS(716),
    [anon_sym_and] = ACTIONS(1333),
    [anon_sym_or] = ACTIONS(1335),
    [sym_comment] = ACTIONS(72),
    [sym__semicolon] = ACTIONS(716),
  },
  [672] = {
    [sym__expression] = STATE(1096),
    [sym__primary_expression] = STATE(303),
    [sym_not_operator] = STATE(1096),
    [sym_boolean_operator] = STATE(1096),
    [sym_binary_operator] = STATE(303),
    [sym_unary_operator] = STATE(303),
    [sym_comparison_operator] = STATE(1096),
    [sym_lambda] = STATE(1096),
    [sym_attribute] = STATE(303),
    [sym_subscript] = STATE(303),
    [sym_call] = STATE(303),
    [sym_list] = STATE(303),
    [sym_list_comprehension] = STATE(303),
    [sym_dictionary] = STATE(303),
    [sym_dictionary_comprehension] = STATE(303),
    [sym_set] = STATE(303),
    [sym_set_comprehension] = STATE(303),
    [sym_parenthesized_expression] = STATE(303),
    [sym_tuple] = STATE(303),
    [sym_generator_expression] = STATE(303),
    [sym_conditional_expression] = STATE(1096),
    [sym_concatenated_string] = STATE(303),
    [sym_await] = STATE(1096),
    [anon_sym_LPAREN] = ACTIONS(130),
    [anon_sym_print] = ACTIONS(112),
    [anon_sym_exec] = ACTIONS(112),
    [anon_sym_not] = ACTIONS(522),
    [anon_sym_PLUS] = ACTIONS(524),
    [anon_sym_DASH] = ACTIONS(524),
    [anon_sym_TILDE] = ACTIONS(524),
    [anon_sym_lambda] = ACTIONS(526),
    [anon_sym_LBRACK] = ACTIONS(134),
    [sym_ellipsis] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(122),
    [sym_string] = ACTIONS(530),
    [sym_integer] = ACTIONS(532),
    [sym_float] = ACTIONS(532),
    [sym_identifier] = ACTIONS(532),
    [sym_true] = ACTIONS(532),
    [sym_false] = ACTIONS(532),
    [sym_none] = ACTIONS(532),
    [anon_sym_await] = ACTIONS(534),
    [sym_comment] = ACTIONS(72),
  },
  [673] = {
    [anon_sym_COLON] = ACTIONS(2255),
    [sym_comment] = ACTIONS(72),
  },
  [674] = {
    [aux_sym_concatenated_string_repeat1] = STATE(1098),
    [sym__newline] = ACTIONS(886),
    [anon_sym_DOT] = ACTIONS(886),
    [anon_sym_LPAREN] = ACTIONS(886),
    [anon_sym_STAR] = ACTIONS(888),
    [anon_sym_GT_GT] = ACTIONS(886),
    [anon_sym_if] = ACTIONS(886),
    [anon_sym_in] = ACTIONS(886),
    [anon_sym_AT] = ACTIONS(886),
    [anon_sym_not] = ACTIONS(886),
    [anon_sym_and] = ACTIONS(886),
    [anon_sym_or] = ACTIONS(886),
    [anon_sym_PLUS] = ACTIONS(886),
    [anon_sym_DASH] = ACTIONS(886),
    [anon_sym_SLASH] = ACTIONS(888),
    [anon_sym_PERCENT] = ACTIONS(886),
    [anon_sym_SLASH_SLASH] = ACTIONS(886),
    [anon_sym_STAR_STAR] = ACTIONS(886),
    [anon_sym_PIPE] = ACTIONS(886),
    [anon_sym_AMP] = ACTIONS(886),
    [anon_sym_CARET] = ACTIONS(886),
    [anon_sym_LT_LT] = ACTIONS(886),
    [anon_sym_LT] = ACTIONS(888),
    [anon_sym_LT_EQ] = ACTIONS(886),
    [anon_sym_EQ_EQ] = ACTIONS(886),
    [anon_sym_BANG_EQ] = ACTIONS(886),
    [anon_sym_GT_EQ] = ACTIONS(886),
    [anon_sym_GT] = ACTIONS(888),
    [anon_sym_LT_GT] = ACTIONS(886),
    [anon_sym_is] = ACTIONS(886),
    [anon_sym_LBRACK] = ACTIONS(886),
    [sym_string] = ACTIONS(2257),
    [sym_comment] = ACTIONS(72),
    [sym__semicolon] = ACTIONS(886),
  },
  [675] = {
    [sym__expression] = STATE(1099),
    [sym__primary_expression] = STATE(513),
    [sym_not_operator] = STATE(1099),
    [sym_boolean_operator] = STATE(1099),
    [sym_binary_operator] = STATE(513),
    [sym_unary_operator] = STATE(513),
    [sym_comparison_operator] = STATE(1099),
    [sym_lambda] = STATE(1099),
    [sym_attribute] = STATE(513),
    [sym_subscript] = STATE(513),
    [sym_call] = STATE(513),
    [sym_list] = STATE(513),
    [sym_list_comprehension] = STATE(513),
    [sym_dictionary] = STATE(513),
    [sym_dictionary_comprehension] = STATE(513),
    [sym_set] = STATE(513),
    [sym_set_comprehension] = STATE(513),
    [sym_parenthesized_expression] = STATE(513),
    [sym_tuple] = STATE(513),
    [sym_generator_expression] = STATE(513),
    [sym_conditional_expression] = STATE(1099),
    [sym_concatenated_string] = STATE(513),
    [sym_await] = STATE(1099),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_not] = ACTIONS(914),
    [anon_sym_PLUS] = ACTIONS(916),
    [anon_sym_DASH] = ACTIONS(916),
    [anon_sym_TILDE] = ACTIONS(916),
    [anon_sym_lambda] = ACTIONS(918),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(920),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(922),
    [sym_integer] = ACTIONS(924),
    [sym_float] = ACTIONS(924),
    [sym_identifier] = ACTIONS(924),
    [sym_true] = ACTIONS(924),
    [sym_false] = ACTIONS(924),
    [sym_none] = ACTIONS(924),
    [anon_sym_await] = ACTIONS(926),
    [sym_comment] = ACTIONS(72),
  },
  [676] = {
    [sym__expression] = STATE(514),
    [sym__primary_expression] = STATE(303),
    [sym_not_operator] = STATE(514),
    [sym_boolean_operator] = STATE(514),
    [sym_binary_operator] = STATE(303),
    [sym_unary_operator] = STATE(303),
    [sym_comparison_operator] = STATE(514),
    [sym_lambda] = STATE(514),
    [sym_attribute] = STATE(303),
    [sym_subscript] = STATE(303),
    [sym_call] = STATE(303),
    [sym_list] = STATE(303),
    [sym_list_comprehension] = STATE(303),
    [sym_dictionary] = STATE(303),
    [sym_dictionary_comprehension] = STATE(303),
    [sym_set] = STATE(303),
    [sym_set_comprehension] = STATE(303),
    [sym_parenthesized_expression] = STATE(303),
    [sym_tuple] = STATE(303),
    [sym_generator_expression] = STATE(303),
    [sym_conditional_expression] = STATE(514),
    [sym_concatenated_string] = STATE(303),
    [sym_await] = STATE(514),
    [anon_sym_LPAREN] = ACTIONS(130),
    [anon_sym_print] = ACTIONS(112),
    [anon_sym_exec] = ACTIONS(112),
    [anon_sym_not] = ACTIONS(522),
    [anon_sym_PLUS] = ACTIONS(524),
    [anon_sym_DASH] = ACTIONS(524),
    [anon_sym_TILDE] = ACTIONS(524),
    [anon_sym_lambda] = ACTIONS(526),
    [anon_sym_LBRACK] = ACTIONS(134),
    [sym_ellipsis] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(122),
    [sym_string] = ACTIONS(530),
    [sym_integer] = ACTIONS(532),
    [sym_float] = ACTIONS(532),
    [sym_identifier] = ACTIONS(532),
    [sym_true] = ACTIONS(532),
    [sym_false] = ACTIONS(532),
    [sym_none] = ACTIONS(532),
    [anon_sym_await] = ACTIONS(534),
    [sym_comment] = ACTIONS(72),
  },
  [677] = {
    [sym__expression] = STATE(1100),
    [sym__primary_expression] = STATE(303),
    [sym_not_operator] = STATE(1100),
    [sym_boolean_operator] = STATE(1100),
    [sym_binary_operator] = STATE(303),
    [sym_unary_operator] = STATE(303),
    [sym_comparison_operator] = STATE(1100),
    [sym_lambda] = STATE(1100),
    [sym_attribute] = STATE(303),
    [sym_subscript] = STATE(303),
    [sym_call] = STATE(303),
    [sym_list] = STATE(303),
    [sym_list_comprehension] = STATE(303),
    [sym_dictionary] = STATE(303),
    [sym_dictionary_comprehension] = STATE(303),
    [sym_set] = STATE(303),
    [sym_set_comprehension] = STATE(303),
    [sym_parenthesized_expression] = STATE(303),
    [sym_tuple] = STATE(303),
    [sym_generator_expression] = STATE(303),
    [sym_conditional_expression] = STATE(1100),
    [sym_concatenated_string] = STATE(303),
    [sym_await] = STATE(1100),
    [anon_sym_LPAREN] = ACTIONS(130),
    [anon_sym_print] = ACTIONS(112),
    [anon_sym_exec] = ACTIONS(112),
    [anon_sym_not] = ACTIONS(522),
    [anon_sym_PLUS] = ACTIONS(524),
    [anon_sym_DASH] = ACTIONS(524),
    [anon_sym_TILDE] = ACTIONS(524),
    [anon_sym_lambda] = ACTIONS(526),
    [anon_sym_LBRACK] = ACTIONS(134),
    [sym_ellipsis] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(122),
    [sym_string] = ACTIONS(530),
    [sym_integer] = ACTIONS(532),
    [sym_float] = ACTIONS(532),
    [sym_identifier] = ACTIONS(532),
    [sym_true] = ACTIONS(532),
    [sym_false] = ACTIONS(532),
    [sym_none] = ACTIONS(532),
    [anon_sym_await] = ACTIONS(534),
    [sym_comment] = ACTIONS(72),
  },
  [678] = {
    [sym__primary_expression] = STATE(1101),
    [sym_binary_operator] = STATE(1101),
    [sym_unary_operator] = STATE(1101),
    [sym_attribute] = STATE(1101),
    [sym_subscript] = STATE(1101),
    [sym_call] = STATE(1101),
    [sym_list] = STATE(1101),
    [sym_list_comprehension] = STATE(1101),
    [sym_dictionary] = STATE(1101),
    [sym_dictionary_comprehension] = STATE(1101),
    [sym_set] = STATE(1101),
    [sym_set_comprehension] = STATE(1101),
    [sym_parenthesized_expression] = STATE(1101),
    [sym_tuple] = STATE(1101),
    [sym_generator_expression] = STATE(1101),
    [sym_concatenated_string] = STATE(1101),
    [anon_sym_LPAREN] = ACTIONS(130),
    [anon_sym_print] = ACTIONS(112),
    [anon_sym_exec] = ACTIONS(112),
    [anon_sym_PLUS] = ACTIONS(524),
    [anon_sym_DASH] = ACTIONS(524),
    [anon_sym_TILDE] = ACTIONS(524),
    [anon_sym_LBRACK] = ACTIONS(134),
    [sym_ellipsis] = ACTIONS(2259),
    [anon_sym_LBRACE] = ACTIONS(122),
    [sym_string] = ACTIONS(530),
    [sym_integer] = ACTIONS(2261),
    [sym_float] = ACTIONS(2261),
    [sym_identifier] = ACTIONS(2261),
    [sym_true] = ACTIONS(2261),
    [sym_false] = ACTIONS(2261),
    [sym_none] = ACTIONS(2261),
    [sym_comment] = ACTIONS(72),
  },
  [679] = {
    [sym__primary_expression] = STATE(1102),
    [sym_binary_operator] = STATE(1102),
    [sym_unary_operator] = STATE(1102),
    [sym_attribute] = STATE(1102),
    [sym_subscript] = STATE(1102),
    [sym_call] = STATE(1102),
    [sym_list] = STATE(1102),
    [sym_list_comprehension] = STATE(1102),
    [sym_dictionary] = STATE(1102),
    [sym_dictionary_comprehension] = STATE(1102),
    [sym_set] = STATE(1102),
    [sym_set_comprehension] = STATE(1102),
    [sym_parenthesized_expression] = STATE(1102),
    [sym_tuple] = STATE(1102),
    [sym_generator_expression] = STATE(1102),
    [sym_concatenated_string] = STATE(1102),
    [anon_sym_LPAREN] = ACTIONS(130),
    [anon_sym_print] = ACTIONS(112),
    [anon_sym_exec] = ACTIONS(112),
    [anon_sym_PLUS] = ACTIONS(524),
    [anon_sym_DASH] = ACTIONS(524),
    [anon_sym_TILDE] = ACTIONS(524),
    [anon_sym_LBRACK] = ACTIONS(134),
    [sym_ellipsis] = ACTIONS(2263),
    [anon_sym_LBRACE] = ACTIONS(122),
    [sym_string] = ACTIONS(530),
    [sym_integer] = ACTIONS(2265),
    [sym_float] = ACTIONS(2265),
    [sym_identifier] = ACTIONS(2265),
    [sym_true] = ACTIONS(2265),
    [sym_false] = ACTIONS(2265),
    [sym_none] = ACTIONS(2265),
    [sym_comment] = ACTIONS(72),
  },
  [680] = {
    [sym__primary_expression] = STATE(1103),
    [sym_binary_operator] = STATE(1103),
    [sym_unary_operator] = STATE(1103),
    [sym_attribute] = STATE(1103),
    [sym_subscript] = STATE(1103),
    [sym_call] = STATE(1103),
    [sym_list] = STATE(1103),
    [sym_list_comprehension] = STATE(1103),
    [sym_dictionary] = STATE(1103),
    [sym_dictionary_comprehension] = STATE(1103),
    [sym_set] = STATE(1103),
    [sym_set_comprehension] = STATE(1103),
    [sym_parenthesized_expression] = STATE(1103),
    [sym_tuple] = STATE(1103),
    [sym_generator_expression] = STATE(1103),
    [sym_concatenated_string] = STATE(1103),
    [anon_sym_LPAREN] = ACTIONS(130),
    [anon_sym_print] = ACTIONS(112),
    [anon_sym_exec] = ACTIONS(112),
    [anon_sym_PLUS] = ACTIONS(524),
    [anon_sym_DASH] = ACTIONS(524),
    [anon_sym_TILDE] = ACTIONS(524),
    [anon_sym_LBRACK] = ACTIONS(134),
    [sym_ellipsis] = ACTIONS(2267),
    [anon_sym_LBRACE] = ACTIONS(122),
    [sym_string] = ACTIONS(530),
    [sym_integer] = ACTIONS(2269),
    [sym_float] = ACTIONS(2269),
    [sym_identifier] = ACTIONS(2269),
    [sym_true] = ACTIONS(2269),
    [sym_false] = ACTIONS(2269),
    [sym_none] = ACTIONS(2269),
    [sym_comment] = ACTIONS(72),
  },
  [681] = {
    [anon_sym_in] = ACTIONS(2271),
    [sym_comment] = ACTIONS(72),
  },
  [682] = {
    [sym__primary_expression] = STATE(1105),
    [sym_binary_operator] = STATE(1105),
    [sym_unary_operator] = STATE(1105),
    [sym_attribute] = STATE(1105),
    [sym_subscript] = STATE(1105),
    [sym_call] = STATE(1105),
    [sym_list] = STATE(1105),
    [sym_list_comprehension] = STATE(1105),
    [sym_dictionary] = STATE(1105),
    [sym_dictionary_comprehension] = STATE(1105),
    [sym_set] = STATE(1105),
    [sym_set_comprehension] = STATE(1105),
    [sym_parenthesized_expression] = STATE(1105),
    [sym_tuple] = STATE(1105),
    [sym_generator_expression] = STATE(1105),
    [sym_concatenated_string] = STATE(1105),
    [anon_sym_LPAREN] = ACTIONS(130),
    [anon_sym_print] = ACTIONS(112),
    [anon_sym_exec] = ACTIONS(112),
    [anon_sym_PLUS] = ACTIONS(524),
    [anon_sym_DASH] = ACTIONS(524),
    [anon_sym_TILDE] = ACTIONS(524),
    [anon_sym_LBRACK] = ACTIONS(134),
    [sym_ellipsis] = ACTIONS(2273),
    [anon_sym_LBRACE] = ACTIONS(122),
    [sym_string] = ACTIONS(530),
    [sym_integer] = ACTIONS(2275),
    [sym_float] = ACTIONS(2275),
    [sym_identifier] = ACTIONS(2275),
    [sym_true] = ACTIONS(2275),
    [sym_false] = ACTIONS(2275),
    [sym_none] = ACTIONS(2275),
    [sym_comment] = ACTIONS(72),
  },
  [683] = {
    [sym__primary_expression] = STATE(663),
    [sym_binary_operator] = STATE(663),
    [sym_unary_operator] = STATE(663),
    [sym_attribute] = STATE(663),
    [sym_subscript] = STATE(663),
    [sym_call] = STATE(663),
    [sym_list] = STATE(663),
    [sym_list_comprehension] = STATE(663),
    [sym_dictionary] = STATE(663),
    [sym_dictionary_comprehension] = STATE(663),
    [sym_set] = STATE(663),
    [sym_set_comprehension] = STATE(663),
    [sym_parenthesized_expression] = STATE(663),
    [sym_tuple] = STATE(663),
    [sym_generator_expression] = STATE(663),
    [sym_concatenated_string] = STATE(663),
    [anon_sym_LPAREN] = ACTIONS(130),
    [anon_sym_print] = ACTIONS(112),
    [anon_sym_exec] = ACTIONS(112),
    [anon_sym_PLUS] = ACTIONS(524),
    [anon_sym_DASH] = ACTIONS(524),
    [anon_sym_TILDE] = ACTIONS(524),
    [anon_sym_LBRACK] = ACTIONS(134),
    [sym_ellipsis] = ACTIONS(1303),
    [anon_sym_LBRACE] = ACTIONS(122),
    [sym_string] = ACTIONS(530),
    [sym_integer] = ACTIONS(1305),
    [sym_float] = ACTIONS(1305),
    [sym_identifier] = ACTIONS(1305),
    [sym_true] = ACTIONS(1305),
    [sym_false] = ACTIONS(1305),
    [sym_none] = ACTIONS(1305),
    [sym_comment] = ACTIONS(72),
  },
  [684] = {
    [sym__primary_expression] = STATE(1106),
    [sym_binary_operator] = STATE(1106),
    [sym_unary_operator] = STATE(1106),
    [sym_attribute] = STATE(1106),
    [sym_subscript] = STATE(1106),
    [sym_call] = STATE(1106),
    [sym_list] = STATE(1106),
    [sym_list_comprehension] = STATE(1106),
    [sym_dictionary] = STATE(1106),
    [sym_dictionary_comprehension] = STATE(1106),
    [sym_set] = STATE(1106),
    [sym_set_comprehension] = STATE(1106),
    [sym_parenthesized_expression] = STATE(1106),
    [sym_tuple] = STATE(1106),
    [sym_generator_expression] = STATE(1106),
    [sym_concatenated_string] = STATE(1106),
    [anon_sym_LPAREN] = ACTIONS(130),
    [anon_sym_print] = ACTIONS(112),
    [anon_sym_exec] = ACTIONS(112),
    [anon_sym_PLUS] = ACTIONS(524),
    [anon_sym_DASH] = ACTIONS(524),
    [anon_sym_TILDE] = ACTIONS(524),
    [anon_sym_LBRACK] = ACTIONS(134),
    [sym_ellipsis] = ACTIONS(2277),
    [anon_sym_LBRACE] = ACTIONS(122),
    [sym_string] = ACTIONS(530),
    [sym_integer] = ACTIONS(2279),
    [sym_float] = ACTIONS(2279),
    [sym_identifier] = ACTIONS(2279),
    [sym_true] = ACTIONS(2279),
    [sym_false] = ACTIONS(2279),
    [sym_none] = ACTIONS(2279),
    [sym_comment] = ACTIONS(72),
  },
  [685] = {
    [sym__primary_expression] = STATE(1107),
    [sym_binary_operator] = STATE(1107),
    [sym_unary_operator] = STATE(1107),
    [sym_attribute] = STATE(1107),
    [sym_subscript] = STATE(1107),
    [sym_call] = STATE(1107),
    [sym_list] = STATE(1107),
    [sym_list_comprehension] = STATE(1107),
    [sym_dictionary] = STATE(1107),
    [sym_dictionary_comprehension] = STATE(1107),
    [sym_set] = STATE(1107),
    [sym_set_comprehension] = STATE(1107),
    [sym_parenthesized_expression] = STATE(1107),
    [sym_tuple] = STATE(1107),
    [sym_generator_expression] = STATE(1107),
    [sym_concatenated_string] = STATE(1107),
    [anon_sym_LPAREN] = ACTIONS(130),
    [anon_sym_print] = ACTIONS(112),
    [anon_sym_exec] = ACTIONS(112),
    [anon_sym_PLUS] = ACTIONS(524),
    [anon_sym_DASH] = ACTIONS(524),
    [anon_sym_TILDE] = ACTIONS(524),
    [anon_sym_LBRACK] = ACTIONS(134),
    [sym_ellipsis] = ACTIONS(2281),
    [anon_sym_LBRACE] = ACTIONS(122),
    [sym_string] = ACTIONS(530),
    [sym_integer] = ACTIONS(2283),
    [sym_float] = ACTIONS(2283),
    [sym_identifier] = ACTIONS(2283),
    [sym_true] = ACTIONS(2283),
    [sym_false] = ACTIONS(2283),
    [sym_none] = ACTIONS(2283),
    [sym_comment] = ACTIONS(72),
  },
  [686] = {
    [sym__primary_expression] = STATE(1108),
    [sym_binary_operator] = STATE(1108),
    [sym_unary_operator] = STATE(1108),
    [sym_attribute] = STATE(1108),
    [sym_subscript] = STATE(1108),
    [sym_call] = STATE(1108),
    [sym_list] = STATE(1108),
    [sym_list_comprehension] = STATE(1108),
    [sym_dictionary] = STATE(1108),
    [sym_dictionary_comprehension] = STATE(1108),
    [sym_set] = STATE(1108),
    [sym_set_comprehension] = STATE(1108),
    [sym_parenthesized_expression] = STATE(1108),
    [sym_tuple] = STATE(1108),
    [sym_generator_expression] = STATE(1108),
    [sym_concatenated_string] = STATE(1108),
    [anon_sym_LPAREN] = ACTIONS(130),
    [anon_sym_print] = ACTIONS(112),
    [anon_sym_exec] = ACTIONS(112),
    [anon_sym_PLUS] = ACTIONS(524),
    [anon_sym_DASH] = ACTIONS(524),
    [anon_sym_TILDE] = ACTIONS(524),
    [anon_sym_LBRACK] = ACTIONS(134),
    [sym_ellipsis] = ACTIONS(2285),
    [anon_sym_LBRACE] = ACTIONS(122),
    [sym_string] = ACTIONS(530),
    [sym_integer] = ACTIONS(2287),
    [sym_float] = ACTIONS(2287),
    [sym_identifier] = ACTIONS(2287),
    [sym_true] = ACTIONS(2287),
    [sym_false] = ACTIONS(2287),
    [sym_none] = ACTIONS(2287),
    [sym_comment] = ACTIONS(72),
  },
  [687] = {
    [sym__primary_expression] = STATE(1103),
    [sym_binary_operator] = STATE(1103),
    [sym_unary_operator] = STATE(1103),
    [sym_attribute] = STATE(1103),
    [sym_subscript] = STATE(1103),
    [sym_call] = STATE(1103),
    [sym_list] = STATE(1103),
    [sym_list_comprehension] = STATE(1103),
    [sym_dictionary] = STATE(1103),
    [sym_dictionary_comprehension] = STATE(1103),
    [sym_set] = STATE(1103),
    [sym_set_comprehension] = STATE(1103),
    [sym_parenthesized_expression] = STATE(1103),
    [sym_tuple] = STATE(1103),
    [sym_generator_expression] = STATE(1103),
    [sym_concatenated_string] = STATE(1103),
    [anon_sym_LPAREN] = ACTIONS(130),
    [anon_sym_print] = ACTIONS(112),
    [anon_sym_exec] = ACTIONS(112),
    [anon_sym_not] = ACTIONS(2289),
    [anon_sym_PLUS] = ACTIONS(524),
    [anon_sym_DASH] = ACTIONS(524),
    [anon_sym_TILDE] = ACTIONS(524),
    [anon_sym_LBRACK] = ACTIONS(134),
    [sym_ellipsis] = ACTIONS(2267),
    [anon_sym_LBRACE] = ACTIONS(122),
    [sym_string] = ACTIONS(530),
    [sym_integer] = ACTIONS(2269),
    [sym_float] = ACTIONS(2269),
    [sym_identifier] = ACTIONS(2269),
    [sym_true] = ACTIONS(2269),
    [sym_false] = ACTIONS(2269),
    [sym_none] = ACTIONS(2269),
    [sym_comment] = ACTIONS(72),
  },
  [688] = {
    [aux_sym_comparison_operator_repeat1] = STATE(1109),
    [sym__newline] = ACTIONS(998),
    [anon_sym_if] = ACTIONS(998),
    [anon_sym_in] = ACTIONS(1341),
    [anon_sym_not] = ACTIONS(1345),
    [anon_sym_and] = ACTIONS(998),
    [anon_sym_or] = ACTIONS(998),
    [anon_sym_LT] = ACTIONS(1357),
    [anon_sym_LT_EQ] = ACTIONS(1341),
    [anon_sym_EQ_EQ] = ACTIONS(1341),
    [anon_sym_BANG_EQ] = ACTIONS(1341),
    [anon_sym_GT_EQ] = ACTIONS(1341),
    [anon_sym_GT] = ACTIONS(1357),
    [anon_sym_LT_GT] = ACTIONS(1341),
    [anon_sym_is] = ACTIONS(1359),
    [sym_comment] = ACTIONS(72),
    [sym__semicolon] = ACTIONS(998),
  },
  [689] = {
    [sym__newline] = ACTIONS(1644),
    [anon_sym_from] = ACTIONS(1644),
    [anon_sym_COMMA] = ACTIONS(1644),
    [anon_sym_if] = ACTIONS(546),
    [anon_sym_and] = ACTIONS(548),
    [anon_sym_or] = ACTIONS(550),
    [sym_comment] = ACTIONS(72),
    [sym__semicolon] = ACTIONS(1644),
  },
  [690] = {
    [sym__expression] = STATE(1110),
    [sym__primary_expression] = STATE(86),
    [sym_not_operator] = STATE(1110),
    [sym_boolean_operator] = STATE(1110),
    [sym_binary_operator] = STATE(86),
    [sym_unary_operator] = STATE(86),
    [sym_comparison_operator] = STATE(1110),
    [sym_lambda] = STATE(1110),
    [sym_attribute] = STATE(86),
    [sym_subscript] = STATE(86),
    [sym_call] = STATE(86),
    [sym_list] = STATE(86),
    [sym_list_comprehension] = STATE(86),
    [sym_dictionary] = STATE(86),
    [sym_dictionary_comprehension] = STATE(86),
    [sym_set] = STATE(86),
    [sym_set_comprehension] = STATE(86),
    [sym_parenthesized_expression] = STATE(86),
    [sym_tuple] = STATE(86),
    [sym_generator_expression] = STATE(86),
    [sym_conditional_expression] = STATE(1110),
    [sym_concatenated_string] = STATE(86),
    [sym_await] = STATE(1110),
    [anon_sym_LPAREN] = ACTIONS(130),
    [anon_sym_print] = ACTIONS(112),
    [anon_sym_exec] = ACTIONS(112),
    [anon_sym_not] = ACTIONS(142),
    [anon_sym_PLUS] = ACTIONS(144),
    [anon_sym_DASH] = ACTIONS(144),
    [anon_sym_TILDE] = ACTIONS(144),
    [anon_sym_lambda] = ACTIONS(146),
    [anon_sym_LBRACK] = ACTIONS(134),
    [sym_ellipsis] = ACTIONS(148),
    [anon_sym_LBRACE] = ACTIONS(122),
    [sym_string] = ACTIONS(150),
    [sym_integer] = ACTIONS(152),
    [sym_float] = ACTIONS(152),
    [sym_identifier] = ACTIONS(152),
    [sym_true] = ACTIONS(152),
    [sym_false] = ACTIONS(152),
    [sym_none] = ACTIONS(152),
    [anon_sym_await] = ACTIONS(154),
    [sym_comment] = ACTIONS(72),
  },
  [691] = {
    [aux_sym_concatenated_string_repeat1] = STATE(691),
    [sym__newline] = ACTIONS(1862),
    [anon_sym_DOT] = ACTIONS(1862),
    [anon_sym_from] = ACTIONS(1862),
    [anon_sym_LPAREN] = ACTIONS(1862),
    [anon_sym_COMMA] = ACTIONS(1862),
    [anon_sym_STAR] = ACTIONS(1864),
    [anon_sym_GT_GT] = ACTIONS(1862),
    [anon_sym_if] = ACTIONS(1862),
    [anon_sym_in] = ACTIONS(1862),
    [anon_sym_AT] = ACTIONS(1862),
    [anon_sym_not] = ACTIONS(1862),
    [anon_sym_and] = ACTIONS(1862),
    [anon_sym_or] = ACTIONS(1862),
    [anon_sym_PLUS] = ACTIONS(1862),
    [anon_sym_DASH] = ACTIONS(1862),
    [anon_sym_SLASH] = ACTIONS(1864),
    [anon_sym_PERCENT] = ACTIONS(1862),
    [anon_sym_SLASH_SLASH] = ACTIONS(1862),
    [anon_sym_STAR_STAR] = ACTIONS(1862),
    [anon_sym_PIPE] = ACTIONS(1862),
    [anon_sym_AMP] = ACTIONS(1862),
    [anon_sym_CARET] = ACTIONS(1862),
    [anon_sym_LT_LT] = ACTIONS(1862),
    [anon_sym_LT] = ACTIONS(1864),
    [anon_sym_LT_EQ] = ACTIONS(1862),
    [anon_sym_EQ_EQ] = ACTIONS(1862),
    [anon_sym_BANG_EQ] = ACTIONS(1862),
    [anon_sym_GT_EQ] = ACTIONS(1862),
    [anon_sym_GT] = ACTIONS(1864),
    [anon_sym_LT_GT] = ACTIONS(1862),
    [anon_sym_is] = ACTIONS(1862),
    [anon_sym_LBRACK] = ACTIONS(1862),
    [sym_string] = ACTIONS(2291),
    [sym_comment] = ACTIONS(72),
    [sym__semicolon] = ACTIONS(1862),
  },
  [692] = {
    [sym__newline] = ACTIONS(2294),
    [anon_sym_if] = ACTIONS(1331),
    [anon_sym_and] = ACTIONS(1333),
    [anon_sym_or] = ACTIONS(1335),
    [sym_comment] = ACTIONS(72),
    [sym__semicolon] = ACTIONS(2294),
  },
  [693] = {
    [sym__newline] = ACTIONS(1915),
    [anon_sym_from] = ACTIONS(1915),
    [anon_sym_COMMA] = ACTIONS(1915),
    [anon_sym_if] = ACTIONS(546),
    [anon_sym_and] = ACTIONS(548),
    [anon_sym_or] = ACTIONS(550),
    [sym_comment] = ACTIONS(72),
    [sym__semicolon] = ACTIONS(1915),
  },
  [694] = {
    [anon_sym_if] = ACTIONS(1921),
    [anon_sym_else] = ACTIONS(2296),
    [anon_sym_and] = ACTIONS(1925),
    [anon_sym_or] = ACTIONS(1927),
    [sym_comment] = ACTIONS(72),
  },
  [695] = {
    [sym__newline] = ACTIONS(1953),
    [anon_sym_from] = ACTIONS(1953),
    [anon_sym_COMMA] = ACTIONS(1953),
    [anon_sym_if] = ACTIONS(1953),
    [anon_sym_and] = ACTIONS(548),
    [anon_sym_or] = ACTIONS(1953),
    [sym_comment] = ACTIONS(72),
    [sym__semicolon] = ACTIONS(1953),
  },
  [696] = {
    [sym__expression] = STATE(693),
    [sym__primary_expression] = STATE(86),
    [sym_not_operator] = STATE(693),
    [sym_boolean_operator] = STATE(693),
    [sym_binary_operator] = STATE(86),
    [sym_unary_operator] = STATE(86),
    [sym_comparison_operator] = STATE(693),
    [sym_lambda] = STATE(693),
    [sym_attribute] = STATE(86),
    [sym_subscript] = STATE(86),
    [sym_call] = STATE(86),
    [sym_list] = STATE(86),
    [sym_list_comprehension] = STATE(86),
    [sym_dictionary] = STATE(86),
    [sym_dictionary_comprehension] = STATE(86),
    [sym_set] = STATE(86),
    [sym_set_comprehension] = STATE(86),
    [sym_parenthesized_expression] = STATE(86),
    [sym_tuple] = STATE(86),
    [sym_generator_expression] = STATE(86),
    [sym_conditional_expression] = STATE(693),
    [sym_concatenated_string] = STATE(86),
    [sym_await] = STATE(693),
    [sym__newline] = ACTIONS(1957),
    [anon_sym_from] = ACTIONS(2298),
    [anon_sym_LPAREN] = ACTIONS(130),
    [anon_sym_print] = ACTIONS(112),
    [anon_sym_exec] = ACTIONS(112),
    [anon_sym_not] = ACTIONS(142),
    [anon_sym_PLUS] = ACTIONS(144),
    [anon_sym_DASH] = ACTIONS(144),
    [anon_sym_TILDE] = ACTIONS(144),
    [anon_sym_lambda] = ACTIONS(146),
    [anon_sym_LBRACK] = ACTIONS(134),
    [sym_ellipsis] = ACTIONS(148),
    [anon_sym_LBRACE] = ACTIONS(122),
    [sym_string] = ACTIONS(150),
    [sym_integer] = ACTIONS(152),
    [sym_float] = ACTIONS(152),
    [sym_identifier] = ACTIONS(152),
    [sym_true] = ACTIONS(152),
    [sym_false] = ACTIONS(152),
    [sym_none] = ACTIONS(152),
    [anon_sym_await] = ACTIONS(154),
    [sym_comment] = ACTIONS(72),
    [sym__semicolon] = ACTIONS(1957),
  },
  [697] = {
    [aux_sym_print_statement_repeat1] = STATE(697),
    [sym__newline] = ACTIONS(1915),
    [anon_sym_from] = ACTIONS(1915),
    [anon_sym_COMMA] = ACTIONS(2300),
    [sym_comment] = ACTIONS(72),
    [sym__semicolon] = ACTIONS(1915),
  },
  [698] = {
    [sym_argument_list] = STATE(291),
    [sym_generator_expression] = STATE(291),
    [sym__newline] = ACTIONS(1980),
    [anon_sym_DOT] = ACTIONS(1980),
    [anon_sym_from] = ACTIONS(1980),
    [anon_sym_LPAREN] = ACTIONS(484),
    [anon_sym_COMMA] = ACTIONS(1980),
    [anon_sym_STAR] = ACTIONS(1982),
    [anon_sym_GT_GT] = ACTIONS(1980),
    [anon_sym_if] = ACTIONS(1980),
    [anon_sym_in] = ACTIONS(1980),
    [anon_sym_AT] = ACTIONS(1980),
    [anon_sym_not] = ACTIONS(1980),
    [anon_sym_and] = ACTIONS(1980),
    [anon_sym_or] = ACTIONS(1980),
    [anon_sym_PLUS] = ACTIONS(1980),
    [anon_sym_DASH] = ACTIONS(1980),
    [anon_sym_SLASH] = ACTIONS(1982),
    [anon_sym_PERCENT] = ACTIONS(1980),
    [anon_sym_SLASH_SLASH] = ACTIONS(1980),
    [anon_sym_STAR_STAR] = ACTIONS(564),
    [anon_sym_PIPE] = ACTIONS(1980),
    [anon_sym_AMP] = ACTIONS(1980),
    [anon_sym_CARET] = ACTIONS(1980),
    [anon_sym_LT_LT] = ACTIONS(1980),
    [anon_sym_LT] = ACTIONS(1982),
    [anon_sym_LT_EQ] = ACTIONS(1980),
    [anon_sym_EQ_EQ] = ACTIONS(1980),
    [anon_sym_BANG_EQ] = ACTIONS(1980),
    [anon_sym_GT_EQ] = ACTIONS(1980),
    [anon_sym_GT] = ACTIONS(1982),
    [anon_sym_LT_GT] = ACTIONS(1980),
    [anon_sym_is] = ACTIONS(1980),
    [anon_sym_LBRACK] = ACTIONS(1980),
    [sym_comment] = ACTIONS(72),
    [sym__semicolon] = ACTIONS(1980),
  },
  [699] = {
    [sym_argument_list] = STATE(291),
    [sym_generator_expression] = STATE(291),
    [sym__newline] = ACTIONS(1980),
    [anon_sym_DOT] = ACTIONS(1980),
    [anon_sym_from] = ACTIONS(1980),
    [anon_sym_LPAREN] = ACTIONS(484),
    [anon_sym_COMMA] = ACTIONS(1980),
    [anon_sym_STAR] = ACTIONS(552),
    [anon_sym_GT_GT] = ACTIONS(1980),
    [anon_sym_if] = ACTIONS(1980),
    [anon_sym_in] = ACTIONS(1980),
    [anon_sym_AT] = ACTIONS(558),
    [anon_sym_not] = ACTIONS(1980),
    [anon_sym_and] = ACTIONS(1980),
    [anon_sym_or] = ACTIONS(1980),
    [anon_sym_PLUS] = ACTIONS(562),
    [anon_sym_DASH] = ACTIONS(562),
    [anon_sym_SLASH] = ACTIONS(552),
    [anon_sym_PERCENT] = ACTIONS(558),
    [anon_sym_SLASH_SLASH] = ACTIONS(558),
    [anon_sym_STAR_STAR] = ACTIONS(564),
    [anon_sym_PIPE] = ACTIONS(1980),
    [anon_sym_AMP] = ACTIONS(1980),
    [anon_sym_CARET] = ACTIONS(1980),
    [anon_sym_LT_LT] = ACTIONS(1980),
    [anon_sym_LT] = ACTIONS(1982),
    [anon_sym_LT_EQ] = ACTIONS(1980),
    [anon_sym_EQ_EQ] = ACTIONS(1980),
    [anon_sym_BANG_EQ] = ACTIONS(1980),
    [anon_sym_GT_EQ] = ACTIONS(1980),
    [anon_sym_GT] = ACTIONS(1982),
    [anon_sym_LT_GT] = ACTIONS(1980),
    [anon_sym_is] = ACTIONS(1980),
    [anon_sym_LBRACK] = ACTIONS(1980),
    [sym_comment] = ACTIONS(72),
    [sym__semicolon] = ACTIONS(1980),
  },
  [700] = {
    [sym_argument_list] = STATE(291),
    [sym_generator_expression] = STATE(291),
    [sym__newline] = ACTIONS(1984),
    [anon_sym_DOT] = ACTIONS(482),
    [anon_sym_from] = ACTIONS(1984),
    [anon_sym_LPAREN] = ACTIONS(484),
    [anon_sym_COMMA] = ACTIONS(1984),
    [anon_sym_STAR] = ACTIONS(552),
    [anon_sym_GT_GT] = ACTIONS(554),
    [anon_sym_if] = ACTIONS(1984),
    [anon_sym_in] = ACTIONS(1984),
    [anon_sym_AT] = ACTIONS(558),
    [anon_sym_not] = ACTIONS(1984),
    [anon_sym_and] = ACTIONS(1984),
    [anon_sym_or] = ACTIONS(1984),
    [anon_sym_PLUS] = ACTIONS(562),
    [anon_sym_DASH] = ACTIONS(562),
    [anon_sym_SLASH] = ACTIONS(552),
    [anon_sym_PERCENT] = ACTIONS(558),
    [anon_sym_SLASH_SLASH] = ACTIONS(558),
    [anon_sym_STAR_STAR] = ACTIONS(564),
    [anon_sym_PIPE] = ACTIONS(566),
    [anon_sym_AMP] = ACTIONS(568),
    [anon_sym_CARET] = ACTIONS(570),
    [anon_sym_LT_LT] = ACTIONS(554),
    [anon_sym_LT] = ACTIONS(1986),
    [anon_sym_LT_EQ] = ACTIONS(1984),
    [anon_sym_EQ_EQ] = ACTIONS(1984),
    [anon_sym_BANG_EQ] = ACTIONS(1984),
    [anon_sym_GT_EQ] = ACTIONS(1984),
    [anon_sym_GT] = ACTIONS(1986),
    [anon_sym_LT_GT] = ACTIONS(1984),
    [anon_sym_is] = ACTIONS(1984),
    [anon_sym_LBRACK] = ACTIONS(510),
    [sym_comment] = ACTIONS(72),
    [sym__semicolon] = ACTIONS(1984),
  },
  [701] = {
    [sym__primary_expression] = STATE(1113),
    [sym_binary_operator] = STATE(1113),
    [sym_unary_operator] = STATE(1113),
    [sym_attribute] = STATE(1113),
    [sym_subscript] = STATE(1113),
    [sym_call] = STATE(1113),
    [sym_list] = STATE(1113),
    [sym_list_comprehension] = STATE(1113),
    [sym_dictionary] = STATE(1113),
    [sym_dictionary_comprehension] = STATE(1113),
    [sym_set] = STATE(1113),
    [sym_set_comprehension] = STATE(1113),
    [sym_parenthesized_expression] = STATE(1113),
    [sym_tuple] = STATE(1113),
    [sym_generator_expression] = STATE(1113),
    [sym_concatenated_string] = STATE(1113),
    [anon_sym_LPAREN] = ACTIONS(130),
    [anon_sym_print] = ACTIONS(112),
    [anon_sym_exec] = ACTIONS(112),
    [anon_sym_PLUS] = ACTIONS(144),
    [anon_sym_DASH] = ACTIONS(144),
    [anon_sym_TILDE] = ACTIONS(144),
    [anon_sym_LBRACK] = ACTIONS(134),
    [sym_ellipsis] = ACTIONS(2303),
    [anon_sym_LBRACE] = ACTIONS(122),
    [sym_string] = ACTIONS(150),
    [sym_integer] = ACTIONS(2305),
    [sym_float] = ACTIONS(2305),
    [sym_identifier] = ACTIONS(2305),
    [sym_true] = ACTIONS(2305),
    [sym_false] = ACTIONS(2305),
    [sym_none] = ACTIONS(2305),
    [sym_comment] = ACTIONS(72),
  },
  [702] = {
    [sym_argument_list] = STATE(291),
    [sym_generator_expression] = STATE(291),
    [sym__newline] = ACTIONS(1980),
    [anon_sym_DOT] = ACTIONS(1980),
    [anon_sym_from] = ACTIONS(1980),
    [anon_sym_LPAREN] = ACTIONS(484),
    [anon_sym_COMMA] = ACTIONS(1980),
    [anon_sym_STAR] = ACTIONS(552),
    [anon_sym_GT_GT] = ACTIONS(1980),
    [anon_sym_if] = ACTIONS(1980),
    [anon_sym_in] = ACTIONS(1980),
    [anon_sym_AT] = ACTIONS(558),
    [anon_sym_not] = ACTIONS(1980),
    [anon_sym_and] = ACTIONS(1980),
    [anon_sym_or] = ACTIONS(1980),
    [anon_sym_PLUS] = ACTIONS(1980),
    [anon_sym_DASH] = ACTIONS(1980),
    [anon_sym_SLASH] = ACTIONS(552),
    [anon_sym_PERCENT] = ACTIONS(558),
    [anon_sym_SLASH_SLASH] = ACTIONS(558),
    [anon_sym_STAR_STAR] = ACTIONS(564),
    [anon_sym_PIPE] = ACTIONS(1980),
    [anon_sym_AMP] = ACTIONS(1980),
    [anon_sym_CARET] = ACTIONS(1980),
    [anon_sym_LT_LT] = ACTIONS(1980),
    [anon_sym_LT] = ACTIONS(1982),
    [anon_sym_LT_EQ] = ACTIONS(1980),
    [anon_sym_EQ_EQ] = ACTIONS(1980),
    [anon_sym_BANG_EQ] = ACTIONS(1980),
    [anon_sym_GT_EQ] = ACTIONS(1980),
    [anon_sym_GT] = ACTIONS(1982),
    [anon_sym_LT_GT] = ACTIONS(1980),
    [anon_sym_is] = ACTIONS(1980),
    [anon_sym_LBRACK] = ACTIONS(1980),
    [sym_comment] = ACTIONS(72),
    [sym__semicolon] = ACTIONS(1980),
  },
  [703] = {
    [sym_argument_list] = STATE(291),
    [sym_generator_expression] = STATE(291),
    [sym__newline] = ACTIONS(1980),
    [anon_sym_DOT] = ACTIONS(1980),
    [anon_sym_from] = ACTIONS(1980),
    [anon_sym_LPAREN] = ACTIONS(484),
    [anon_sym_COMMA] = ACTIONS(1980),
    [anon_sym_STAR] = ACTIONS(552),
    [anon_sym_GT_GT] = ACTIONS(554),
    [anon_sym_if] = ACTIONS(1980),
    [anon_sym_in] = ACTIONS(1980),
    [anon_sym_AT] = ACTIONS(558),
    [anon_sym_not] = ACTIONS(1980),
    [anon_sym_and] = ACTIONS(1980),
    [anon_sym_or] = ACTIONS(1980),
    [anon_sym_PLUS] = ACTIONS(562),
    [anon_sym_DASH] = ACTIONS(562),
    [anon_sym_SLASH] = ACTIONS(552),
    [anon_sym_PERCENT] = ACTIONS(558),
    [anon_sym_SLASH_SLASH] = ACTIONS(558),
    [anon_sym_STAR_STAR] = ACTIONS(564),
    [anon_sym_PIPE] = ACTIONS(1980),
    [anon_sym_AMP] = ACTIONS(568),
    [anon_sym_CARET] = ACTIONS(570),
    [anon_sym_LT_LT] = ACTIONS(554),
    [anon_sym_LT] = ACTIONS(1982),
    [anon_sym_LT_EQ] = ACTIONS(1980),
    [anon_sym_EQ_EQ] = ACTIONS(1980),
    [anon_sym_BANG_EQ] = ACTIONS(1980),
    [anon_sym_GT_EQ] = ACTIONS(1980),
    [anon_sym_GT] = ACTIONS(1982),
    [anon_sym_LT_GT] = ACTIONS(1980),
    [anon_sym_is] = ACTIONS(1980),
    [anon_sym_LBRACK] = ACTIONS(1980),
    [sym_comment] = ACTIONS(72),
    [sym__semicolon] = ACTIONS(1980),
  },
  [704] = {
    [sym_argument_list] = STATE(291),
    [sym_generator_expression] = STATE(291),
    [sym__newline] = ACTIONS(1980),
    [anon_sym_DOT] = ACTIONS(1980),
    [anon_sym_from] = ACTIONS(1980),
    [anon_sym_LPAREN] = ACTIONS(484),
    [anon_sym_COMMA] = ACTIONS(1980),
    [anon_sym_STAR] = ACTIONS(552),
    [anon_sym_GT_GT] = ACTIONS(554),
    [anon_sym_if] = ACTIONS(1980),
    [anon_sym_in] = ACTIONS(1980),
    [anon_sym_AT] = ACTIONS(558),
    [anon_sym_not] = ACTIONS(1980),
    [anon_sym_and] = ACTIONS(1980),
    [anon_sym_or] = ACTIONS(1980),
    [anon_sym_PLUS] = ACTIONS(562),
    [anon_sym_DASH] = ACTIONS(562),
    [anon_sym_SLASH] = ACTIONS(552),
    [anon_sym_PERCENT] = ACTIONS(558),
    [anon_sym_SLASH_SLASH] = ACTIONS(558),
    [anon_sym_STAR_STAR] = ACTIONS(564),
    [anon_sym_PIPE] = ACTIONS(1980),
    [anon_sym_AMP] = ACTIONS(1980),
    [anon_sym_CARET] = ACTIONS(570),
    [anon_sym_LT_LT] = ACTIONS(554),
    [anon_sym_LT] = ACTIONS(1982),
    [anon_sym_LT_EQ] = ACTIONS(1980),
    [anon_sym_EQ_EQ] = ACTIONS(1980),
    [anon_sym_BANG_EQ] = ACTIONS(1980),
    [anon_sym_GT_EQ] = ACTIONS(1980),
    [anon_sym_GT] = ACTIONS(1982),
    [anon_sym_LT_GT] = ACTIONS(1980),
    [anon_sym_is] = ACTIONS(1980),
    [anon_sym_LBRACK] = ACTIONS(1980),
    [sym_comment] = ACTIONS(72),
    [sym__semicolon] = ACTIONS(1980),
  },
  [705] = {
    [sym_argument_list] = STATE(291),
    [sym_generator_expression] = STATE(291),
    [sym__newline] = ACTIONS(1980),
    [anon_sym_DOT] = ACTIONS(1980),
    [anon_sym_from] = ACTIONS(1980),
    [anon_sym_LPAREN] = ACTIONS(484),
    [anon_sym_COMMA] = ACTIONS(1980),
    [anon_sym_STAR] = ACTIONS(552),
    [anon_sym_GT_GT] = ACTIONS(554),
    [anon_sym_if] = ACTIONS(1980),
    [anon_sym_in] = ACTIONS(1980),
    [anon_sym_AT] = ACTIONS(558),
    [anon_sym_not] = ACTIONS(1980),
    [anon_sym_and] = ACTIONS(1980),
    [anon_sym_or] = ACTIONS(1980),
    [anon_sym_PLUS] = ACTIONS(562),
    [anon_sym_DASH] = ACTIONS(562),
    [anon_sym_SLASH] = ACTIONS(552),
    [anon_sym_PERCENT] = ACTIONS(558),
    [anon_sym_SLASH_SLASH] = ACTIONS(558),
    [anon_sym_STAR_STAR] = ACTIONS(564),
    [anon_sym_PIPE] = ACTIONS(1980),
    [anon_sym_AMP] = ACTIONS(1980),
    [anon_sym_CARET] = ACTIONS(1980),
    [anon_sym_LT_LT] = ACTIONS(554),
    [anon_sym_LT] = ACTIONS(1982),
    [anon_sym_LT_EQ] = ACTIONS(1980),
    [anon_sym_EQ_EQ] = ACTIONS(1980),
    [anon_sym_BANG_EQ] = ACTIONS(1980),
    [anon_sym_GT_EQ] = ACTIONS(1980),
    [anon_sym_GT] = ACTIONS(1982),
    [anon_sym_LT_GT] = ACTIONS(1980),
    [anon_sym_is] = ACTIONS(1980),
    [anon_sym_LBRACK] = ACTIONS(1980),
    [sym_comment] = ACTIONS(72),
    [sym__semicolon] = ACTIONS(1980),
  },
  [706] = {
    [aux_sym_comparison_operator_repeat1] = STATE(706),
    [sym__newline] = ACTIONS(1984),
    [anon_sym_from] = ACTIONS(1984),
    [anon_sym_COMMA] = ACTIONS(1984),
    [anon_sym_if] = ACTIONS(1984),
    [anon_sym_in] = ACTIONS(2307),
    [anon_sym_not] = ACTIONS(2310),
    [anon_sym_and] = ACTIONS(1984),
    [anon_sym_or] = ACTIONS(1984),
    [anon_sym_LT] = ACTIONS(2313),
    [anon_sym_LT_EQ] = ACTIONS(2307),
    [anon_sym_EQ_EQ] = ACTIONS(2307),
    [anon_sym_BANG_EQ] = ACTIONS(2307),
    [anon_sym_GT_EQ] = ACTIONS(2307),
    [anon_sym_GT] = ACTIONS(2313),
    [anon_sym_LT_GT] = ACTIONS(2307),
    [anon_sym_is] = ACTIONS(2316),
    [sym_comment] = ACTIONS(72),
    [sym__semicolon] = ACTIONS(1984),
  },
  [707] = {
    [ts_builtin_sym_end] = ACTIONS(2319),
    [anon_sym_import] = ACTIONS(2321),
    [anon_sym_from] = ACTIONS(2321),
    [anon_sym_LPAREN] = ACTIONS(2319),
    [anon_sym_print] = ACTIONS(2321),
    [anon_sym_assert] = ACTIONS(2321),
    [anon_sym_return] = ACTIONS(2321),
    [anon_sym_del] = ACTIONS(2321),
    [anon_sym_raise] = ACTIONS(2321),
    [sym_pass_statement] = ACTIONS(2321),
    [sym_break_statement] = ACTIONS(2321),
    [sym_continue_statement] = ACTIONS(2321),
    [anon_sym_if] = ACTIONS(2321),
    [anon_sym_async] = ACTIONS(2321),
    [anon_sym_for] = ACTIONS(2321),
    [anon_sym_while] = ACTIONS(2321),
    [anon_sym_try] = ACTIONS(2321),
    [anon_sym_with] = ACTIONS(2321),
    [anon_sym_def] = ACTIONS(2321),
    [anon_sym_global] = ACTIONS(2321),
    [anon_sym_nonlocal] = ACTIONS(2321),
    [anon_sym_exec] = ACTIONS(2321),
    [anon_sym_class] = ACTIONS(2321),
    [anon_sym_AT] = ACTIONS(2319),
    [anon_sym_not] = ACTIONS(2321),
    [anon_sym_PLUS] = ACTIONS(2319),
    [anon_sym_DASH] = ACTIONS(2319),
    [anon_sym_TILDE] = ACTIONS(2319),
    [anon_sym_lambda] = ACTIONS(2321),
    [anon_sym_yield] = ACTIONS(2321),
    [anon_sym_LBRACK] = ACTIONS(2319),
    [sym_ellipsis] = ACTIONS(2319),
    [anon_sym_LBRACE] = ACTIONS(2319),
    [sym_string] = ACTIONS(2319),
    [sym_integer] = ACTIONS(2321),
    [sym_float] = ACTIONS(2321),
    [sym_identifier] = ACTIONS(2321),
    [sym_true] = ACTIONS(2321),
    [sym_false] = ACTIONS(2321),
    [sym_none] = ACTIONS(2321),
    [anon_sym_await] = ACTIONS(2321),
    [sym_comment] = ACTIONS(72),
  },
  [708] = {
    [sym_import_statement] = STATE(326),
    [sym_import_from_statement] = STATE(326),
    [sym_print_statement] = STATE(326),
    [sym_assert_statement] = STATE(326),
    [sym_expression_statement] = STATE(326),
    [sym_return_statement] = STATE(326),
    [sym_delete_statement] = STATE(326),
    [sym_raise_statement] = STATE(326),
    [sym_global_statement] = STATE(326),
    [sym_nonlocal_statement] = STATE(326),
    [sym_exec_statement] = STATE(326),
    [sym_expression_list] = STATE(32),
    [sym__expression] = STATE(33),
    [sym__primary_expression] = STATE(34),
    [sym_not_operator] = STATE(33),
    [sym_boolean_operator] = STATE(33),
    [sym_binary_operator] = STATE(34),
    [sym_unary_operator] = STATE(34),
    [sym_comparison_operator] = STATE(33),
    [sym_lambda] = STATE(33),
    [sym_assignment] = STATE(35),
    [sym_augmented_assignment] = STATE(35),
    [sym_yield] = STATE(35),
    [sym_attribute] = STATE(34),
    [sym_subscript] = STATE(34),
    [sym_call] = STATE(34),
    [sym_list] = STATE(34),
    [sym_list_comprehension] = STATE(34),
    [sym_dictionary] = STATE(34),
    [sym_dictionary_comprehension] = STATE(34),
    [sym_set] = STATE(34),
    [sym_set_comprehension] = STATE(34),
    [sym_parenthesized_expression] = STATE(34),
    [sym_tuple] = STATE(34),
    [sym_generator_expression] = STATE(34),
    [sym_conditional_expression] = STATE(33),
    [sym_concatenated_string] = STATE(34),
    [sym_await] = STATE(33),
    [anon_sym_import] = ACTIONS(10),
    [anon_sym_from] = ACTIONS(12),
    [anon_sym_LPAREN] = ACTIONS(14),
    [anon_sym_print] = ACTIONS(16),
    [anon_sym_assert] = ACTIONS(18),
    [anon_sym_return] = ACTIONS(20),
    [anon_sym_del] = ACTIONS(22),
    [anon_sym_raise] = ACTIONS(24),
    [sym_pass_statement] = ACTIONS(582),
    [sym_break_statement] = ACTIONS(582),
    [sym_continue_statement] = ACTIONS(582),
    [anon_sym_global] = ACTIONS(42),
    [anon_sym_nonlocal] = ACTIONS(44),
    [anon_sym_exec] = ACTIONS(46),
    [anon_sym_not] = ACTIONS(52),
    [anon_sym_PLUS] = ACTIONS(54),
    [anon_sym_DASH] = ACTIONS(54),
    [anon_sym_TILDE] = ACTIONS(54),
    [anon_sym_lambda] = ACTIONS(56),
    [anon_sym_yield] = ACTIONS(58),
    [anon_sym_LBRACK] = ACTIONS(60),
    [sym_ellipsis] = ACTIONS(62),
    [anon_sym_LBRACE] = ACTIONS(64),
    [sym_string] = ACTIONS(66),
    [sym_integer] = ACTIONS(68),
    [sym_float] = ACTIONS(68),
    [sym_identifier] = ACTIONS(68),
    [sym_true] = ACTIONS(68),
    [sym_false] = ACTIONS(68),
    [sym_none] = ACTIONS(68),
    [anon_sym_await] = ACTIONS(70),
    [sym_comment] = ACTIONS(72),
  },
  [709] = {
    [anon_sym_if] = ACTIONS(590),
    [anon_sym_COLON] = ACTIONS(1644),
    [anon_sym_and] = ACTIONS(594),
    [anon_sym_or] = ACTIONS(596),
    [sym_comment] = ACTIONS(72),
  },
  [710] = {
    [sym__expression] = STATE(1114),
    [sym__primary_expression] = STATE(96),
    [sym_not_operator] = STATE(1114),
    [sym_boolean_operator] = STATE(1114),
    [sym_binary_operator] = STATE(96),
    [sym_unary_operator] = STATE(96),
    [sym_comparison_operator] = STATE(1114),
    [sym_lambda] = STATE(1114),
    [sym_attribute] = STATE(96),
    [sym_subscript] = STATE(96),
    [sym_call] = STATE(96),
    [sym_list] = STATE(96),
    [sym_list_comprehension] = STATE(96),
    [sym_dictionary] = STATE(96),
    [sym_dictionary_comprehension] = STATE(96),
    [sym_set] = STATE(96),
    [sym_set_comprehension] = STATE(96),
    [sym_parenthesized_expression] = STATE(96),
    [sym_tuple] = STATE(96),
    [sym_generator_expression] = STATE(96),
    [sym_conditional_expression] = STATE(1114),
    [sym_concatenated_string] = STATE(96),
    [sym_await] = STATE(1114),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_not] = ACTIONS(160),
    [anon_sym_PLUS] = ACTIONS(162),
    [anon_sym_DASH] = ACTIONS(162),
    [anon_sym_TILDE] = ACTIONS(162),
    [anon_sym_lambda] = ACTIONS(164),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(166),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(168),
    [sym_integer] = ACTIONS(170),
    [sym_float] = ACTIONS(170),
    [sym_identifier] = ACTIONS(170),
    [sym_true] = ACTIONS(170),
    [sym_false] = ACTIONS(170),
    [sym_none] = ACTIONS(170),
    [anon_sym_await] = ACTIONS(172),
    [sym_comment] = ACTIONS(72),
  },
  [711] = {
    [aux_sym_concatenated_string_repeat1] = STATE(711),
    [anon_sym_DOT] = ACTIONS(1862),
    [anon_sym_LPAREN] = ACTIONS(1862),
    [anon_sym_STAR] = ACTIONS(1864),
    [anon_sym_GT_GT] = ACTIONS(1862),
    [anon_sym_if] = ACTIONS(1862),
    [anon_sym_COLON] = ACTIONS(1862),
    [anon_sym_in] = ACTIONS(1862),
    [anon_sym_AT] = ACTIONS(1862),
    [anon_sym_not] = ACTIONS(1862),
    [anon_sym_and] = ACTIONS(1862),
    [anon_sym_or] = ACTIONS(1862),
    [anon_sym_PLUS] = ACTIONS(1862),
    [anon_sym_DASH] = ACTIONS(1862),
    [anon_sym_SLASH] = ACTIONS(1864),
    [anon_sym_PERCENT] = ACTIONS(1862),
    [anon_sym_SLASH_SLASH] = ACTIONS(1862),
    [anon_sym_STAR_STAR] = ACTIONS(1862),
    [anon_sym_PIPE] = ACTIONS(1862),
    [anon_sym_AMP] = ACTIONS(1862),
    [anon_sym_CARET] = ACTIONS(1862),
    [anon_sym_LT_LT] = ACTIONS(1862),
    [anon_sym_LT] = ACTIONS(1864),
    [anon_sym_LT_EQ] = ACTIONS(1862),
    [anon_sym_EQ_EQ] = ACTIONS(1862),
    [anon_sym_BANG_EQ] = ACTIONS(1862),
    [anon_sym_GT_EQ] = ACTIONS(1862),
    [anon_sym_GT] = ACTIONS(1864),
    [anon_sym_LT_GT] = ACTIONS(1862),
    [anon_sym_is] = ACTIONS(1862),
    [anon_sym_LBRACK] = ACTIONS(1862),
    [sym_string] = ACTIONS(2323),
    [sym_comment] = ACTIONS(72),
  },
  [712] = {
    [anon_sym_if] = ACTIONS(1921),
    [anon_sym_else] = ACTIONS(2326),
    [anon_sym_and] = ACTIONS(1925),
    [anon_sym_or] = ACTIONS(1927),
    [sym_comment] = ACTIONS(72),
  },
  [713] = {
    [sym__statement] = STATE(1117),
    [sym__simple_statements] = STATE(1117),
    [sym_import_statement] = STATE(746),
    [sym_import_from_statement] = STATE(746),
    [sym_print_statement] = STATE(746),
    [sym_assert_statement] = STATE(746),
    [sym_expression_statement] = STATE(746),
    [sym_return_statement] = STATE(746),
    [sym_delete_statement] = STATE(746),
    [sym_raise_statement] = STATE(746),
    [sym_if_statement] = STATE(1117),
    [sym_for_statement] = STATE(1117),
    [sym_while_statement] = STATE(1117),
    [sym_try_statement] = STATE(1117),
    [sym_with_statement] = STATE(1117),
    [sym_function_definition] = STATE(1117),
    [sym_global_statement] = STATE(746),
    [sym_nonlocal_statement] = STATE(746),
    [sym_exec_statement] = STATE(746),
    [sym_class_definition] = STATE(1117),
    [sym_decorated_definition] = STATE(1117),
    [sym_decorator] = STATE(756),
    [sym_expression_list] = STATE(32),
    [sym__expression] = STATE(33),
    [sym__primary_expression] = STATE(34),
    [sym_not_operator] = STATE(33),
    [sym_boolean_operator] = STATE(33),
    [sym_binary_operator] = STATE(34),
    [sym_unary_operator] = STATE(34),
    [sym_comparison_operator] = STATE(33),
    [sym_lambda] = STATE(33),
    [sym_assignment] = STATE(35),
    [sym_augmented_assignment] = STATE(35),
    [sym_yield] = STATE(35),
    [sym_attribute] = STATE(34),
    [sym_subscript] = STATE(34),
    [sym_call] = STATE(34),
    [sym_list] = STATE(34),
    [sym_list_comprehension] = STATE(34),
    [sym_dictionary] = STATE(34),
    [sym_dictionary_comprehension] = STATE(34),
    [sym_set] = STATE(34),
    [sym_set_comprehension] = STATE(34),
    [sym_parenthesized_expression] = STATE(34),
    [sym_tuple] = STATE(34),
    [sym_generator_expression] = STATE(34),
    [sym_conditional_expression] = STATE(33),
    [sym_concatenated_string] = STATE(34),
    [sym_await] = STATE(33),
    [aux_sym_module_repeat1] = STATE(1117),
    [aux_sym_decorated_definition_repeat1] = STATE(756),
    [sym__dedent] = ACTIONS(2328),
    [anon_sym_import] = ACTIONS(10),
    [anon_sym_from] = ACTIONS(12),
    [anon_sym_LPAREN] = ACTIONS(14),
    [anon_sym_print] = ACTIONS(16),
    [anon_sym_assert] = ACTIONS(18),
    [anon_sym_return] = ACTIONS(20),
    [anon_sym_del] = ACTIONS(22),
    [anon_sym_raise] = ACTIONS(24),
    [sym_pass_statement] = ACTIONS(1498),
    [sym_break_statement] = ACTIONS(1498),
    [sym_continue_statement] = ACTIONS(1498),
    [anon_sym_if] = ACTIONS(1500),
    [anon_sym_async] = ACTIONS(1502),
    [anon_sym_for] = ACTIONS(1504),
    [anon_sym_while] = ACTIONS(1506),
    [anon_sym_try] = ACTIONS(1508),
    [anon_sym_with] = ACTIONS(1510),
    [anon_sym_def] = ACTIONS(1512),
    [anon_sym_global] = ACTIONS(42),
    [anon_sym_nonlocal] = ACTIONS(44),
    [anon_sym_exec] = ACTIONS(46),
    [anon_sym_class] = ACTIONS(1514),
    [anon_sym_AT] = ACTIONS(50),
    [anon_sym_not] = ACTIONS(52),
    [anon_sym_PLUS] = ACTIONS(54),
    [anon_sym_DASH] = ACTIONS(54),
    [anon_sym_TILDE] = ACTIONS(54),
    [anon_sym_lambda] = ACTIONS(56),
    [anon_sym_yield] = ACTIONS(58),
    [anon_sym_LBRACK] = ACTIONS(60),
    [sym_ellipsis] = ACTIONS(62),
    [anon_sym_LBRACE] = ACTIONS(64),
    [sym_string] = ACTIONS(66),
    [sym_integer] = ACTIONS(68),
    [sym_float] = ACTIONS(68),
    [sym_identifier] = ACTIONS(68),
    [sym_true] = ACTIONS(68),
    [sym_false] = ACTIONS(68),
    [sym_none] = ACTIONS(68),
    [anon_sym_await] = ACTIONS(70),
    [sym_comment] = ACTIONS(72),
  },
  [714] = {
    [aux_sym__simple_statements_repeat1] = STATE(1120),
    [sym__newline] = ACTIONS(2330),
    [sym_comment] = ACTIONS(72),
    [sym__semicolon] = ACTIONS(2332),
  },
  [715] = {
    [sym_elif_clause] = STATE(1124),
    [sym_else_clause] = STATE(1123),
    [aux_sym_if_statement_repeat1] = STATE(1124),
    [ts_builtin_sym_end] = ACTIONS(2334),
    [anon_sym_import] = ACTIONS(2336),
    [anon_sym_from] = ACTIONS(2336),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [anon_sym_print] = ACTIONS(2336),
    [anon_sym_assert] = ACTIONS(2336),
    [anon_sym_return] = ACTIONS(2336),
    [anon_sym_del] = ACTIONS(2336),
    [anon_sym_raise] = ACTIONS(2336),
    [sym_pass_statement] = ACTIONS(2336),
    [sym_break_statement] = ACTIONS(2336),
    [sym_continue_statement] = ACTIONS(2336),
    [anon_sym_if] = ACTIONS(2336),
    [anon_sym_elif] = ACTIONS(2338),
    [anon_sym_else] = ACTIONS(2340),
    [anon_sym_async] = ACTIONS(2336),
    [anon_sym_for] = ACTIONS(2336),
    [anon_sym_while] = ACTIONS(2336),
    [anon_sym_try] = ACTIONS(2336),
    [anon_sym_with] = ACTIONS(2336),
    [anon_sym_def] = ACTIONS(2336),
    [anon_sym_global] = ACTIONS(2336),
    [anon_sym_nonlocal] = ACTIONS(2336),
    [anon_sym_exec] = ACTIONS(2336),
    [anon_sym_class] = ACTIONS(2336),
    [anon_sym_AT] = ACTIONS(2334),
    [anon_sym_not] = ACTIONS(2336),
    [anon_sym_PLUS] = ACTIONS(2334),
    [anon_sym_DASH] = ACTIONS(2334),
    [anon_sym_TILDE] = ACTIONS(2334),
    [anon_sym_lambda] = ACTIONS(2336),
    [anon_sym_yield] = ACTIONS(2336),
    [anon_sym_LBRACK] = ACTIONS(2334),
    [sym_ellipsis] = ACTIONS(2334),
    [anon_sym_LBRACE] = ACTIONS(2334),
    [sym_string] = ACTIONS(2334),
    [sym_integer] = ACTIONS(2336),
    [sym_float] = ACTIONS(2336),
    [sym_identifier] = ACTIONS(2336),
    [sym_true] = ACTIONS(2336),
    [sym_false] = ACTIONS(2336),
    [sym_none] = ACTIONS(2336),
    [anon_sym_await] = ACTIONS(2336),
    [sym_comment] = ACTIONS(72),
  },
  [716] = {
    [anon_sym_if] = ACTIONS(1953),
    [anon_sym_COLON] = ACTIONS(1953),
    [anon_sym_and] = ACTIONS(594),
    [anon_sym_or] = ACTIONS(1953),
    [sym_comment] = ACTIONS(72),
  },
  [717] = {
    [sym_argument_list] = STATE(251),
    [sym_generator_expression] = STATE(251),
    [anon_sym_DOT] = ACTIONS(1980),
    [anon_sym_LPAREN] = ACTIONS(424),
    [anon_sym_STAR] = ACTIONS(1982),
    [anon_sym_GT_GT] = ACTIONS(1980),
    [anon_sym_if] = ACTIONS(1980),
    [anon_sym_COLON] = ACTIONS(1980),
    [anon_sym_in] = ACTIONS(1980),
    [anon_sym_AT] = ACTIONS(1980),
    [anon_sym_not] = ACTIONS(1980),
    [anon_sym_and] = ACTIONS(1980),
    [anon_sym_or] = ACTIONS(1980),
    [anon_sym_PLUS] = ACTIONS(1980),
    [anon_sym_DASH] = ACTIONS(1980),
    [anon_sym_SLASH] = ACTIONS(1982),
    [anon_sym_PERCENT] = ACTIONS(1980),
    [anon_sym_SLASH_SLASH] = ACTIONS(1980),
    [anon_sym_STAR_STAR] = ACTIONS(610),
    [anon_sym_PIPE] = ACTIONS(1980),
    [anon_sym_AMP] = ACTIONS(1980),
    [anon_sym_CARET] = ACTIONS(1980),
    [anon_sym_LT_LT] = ACTIONS(1980),
    [anon_sym_LT] = ACTIONS(1982),
    [anon_sym_LT_EQ] = ACTIONS(1980),
    [anon_sym_EQ_EQ] = ACTIONS(1980),
    [anon_sym_BANG_EQ] = ACTIONS(1980),
    [anon_sym_GT_EQ] = ACTIONS(1980),
    [anon_sym_GT] = ACTIONS(1982),
    [anon_sym_LT_GT] = ACTIONS(1980),
    [anon_sym_is] = ACTIONS(1980),
    [anon_sym_LBRACK] = ACTIONS(1980),
    [sym_comment] = ACTIONS(72),
  },
  [718] = {
    [sym_argument_list] = STATE(251),
    [sym_generator_expression] = STATE(251),
    [anon_sym_DOT] = ACTIONS(1980),
    [anon_sym_LPAREN] = ACTIONS(424),
    [anon_sym_STAR] = ACTIONS(598),
    [anon_sym_GT_GT] = ACTIONS(1980),
    [anon_sym_if] = ACTIONS(1980),
    [anon_sym_COLON] = ACTIONS(1980),
    [anon_sym_in] = ACTIONS(1980),
    [anon_sym_AT] = ACTIONS(604),
    [anon_sym_not] = ACTIONS(1980),
    [anon_sym_and] = ACTIONS(1980),
    [anon_sym_or] = ACTIONS(1980),
    [anon_sym_PLUS] = ACTIONS(608),
    [anon_sym_DASH] = ACTIONS(608),
    [anon_sym_SLASH] = ACTIONS(598),
    [anon_sym_PERCENT] = ACTIONS(604),
    [anon_sym_SLASH_SLASH] = ACTIONS(604),
    [anon_sym_STAR_STAR] = ACTIONS(610),
    [anon_sym_PIPE] = ACTIONS(1980),
    [anon_sym_AMP] = ACTIONS(1980),
    [anon_sym_CARET] = ACTIONS(1980),
    [anon_sym_LT_LT] = ACTIONS(1980),
    [anon_sym_LT] = ACTIONS(1982),
    [anon_sym_LT_EQ] = ACTIONS(1980),
    [anon_sym_EQ_EQ] = ACTIONS(1980),
    [anon_sym_BANG_EQ] = ACTIONS(1980),
    [anon_sym_GT_EQ] = ACTIONS(1980),
    [anon_sym_GT] = ACTIONS(1982),
    [anon_sym_LT_GT] = ACTIONS(1980),
    [anon_sym_is] = ACTIONS(1980),
    [anon_sym_LBRACK] = ACTIONS(1980),
    [sym_comment] = ACTIONS(72),
  },
  [719] = {
    [sym_argument_list] = STATE(251),
    [sym_generator_expression] = STATE(251),
    [anon_sym_DOT] = ACTIONS(422),
    [anon_sym_LPAREN] = ACTIONS(424),
    [anon_sym_STAR] = ACTIONS(598),
    [anon_sym_GT_GT] = ACTIONS(600),
    [anon_sym_if] = ACTIONS(1984),
    [anon_sym_COLON] = ACTIONS(1984),
    [anon_sym_in] = ACTIONS(1984),
    [anon_sym_AT] = ACTIONS(604),
    [anon_sym_not] = ACTIONS(1984),
    [anon_sym_and] = ACTIONS(1984),
    [anon_sym_or] = ACTIONS(1984),
    [anon_sym_PLUS] = ACTIONS(608),
    [anon_sym_DASH] = ACTIONS(608),
    [anon_sym_SLASH] = ACTIONS(598),
    [anon_sym_PERCENT] = ACTIONS(604),
    [anon_sym_SLASH_SLASH] = ACTIONS(604),
    [anon_sym_STAR_STAR] = ACTIONS(610),
    [anon_sym_PIPE] = ACTIONS(612),
    [anon_sym_AMP] = ACTIONS(614),
    [anon_sym_CARET] = ACTIONS(616),
    [anon_sym_LT_LT] = ACTIONS(600),
    [anon_sym_LT] = ACTIONS(1986),
    [anon_sym_LT_EQ] = ACTIONS(1984),
    [anon_sym_EQ_EQ] = ACTIONS(1984),
    [anon_sym_BANG_EQ] = ACTIONS(1984),
    [anon_sym_GT_EQ] = ACTIONS(1984),
    [anon_sym_GT] = ACTIONS(1986),
    [anon_sym_LT_GT] = ACTIONS(1984),
    [anon_sym_is] = ACTIONS(1984),
    [anon_sym_LBRACK] = ACTIONS(450),
    [sym_comment] = ACTIONS(72),
  },
  [720] = {
    [sym__primary_expression] = STATE(1125),
    [sym_binary_operator] = STATE(1125),
    [sym_unary_operator] = STATE(1125),
    [sym_attribute] = STATE(1125),
    [sym_subscript] = STATE(1125),
    [sym_call] = STATE(1125),
    [sym_list] = STATE(1125),
    [sym_list_comprehension] = STATE(1125),
    [sym_dictionary] = STATE(1125),
    [sym_dictionary_comprehension] = STATE(1125),
    [sym_set] = STATE(1125),
    [sym_set_comprehension] = STATE(1125),
    [sym_parenthesized_expression] = STATE(1125),
    [sym_tuple] = STATE(1125),
    [sym_generator_expression] = STATE(1125),
    [sym_concatenated_string] = STATE(1125),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_PLUS] = ACTIONS(162),
    [anon_sym_DASH] = ACTIONS(162),
    [anon_sym_TILDE] = ACTIONS(162),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(2342),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(168),
    [sym_integer] = ACTIONS(2344),
    [sym_float] = ACTIONS(2344),
    [sym_identifier] = ACTIONS(2344),
    [sym_true] = ACTIONS(2344),
    [sym_false] = ACTIONS(2344),
    [sym_none] = ACTIONS(2344),
    [sym_comment] = ACTIONS(72),
  },
  [721] = {
    [sym_argument_list] = STATE(251),
    [sym_generator_expression] = STATE(251),
    [anon_sym_DOT] = ACTIONS(1980),
    [anon_sym_LPAREN] = ACTIONS(424),
    [anon_sym_STAR] = ACTIONS(598),
    [anon_sym_GT_GT] = ACTIONS(1980),
    [anon_sym_if] = ACTIONS(1980),
    [anon_sym_COLON] = ACTIONS(1980),
    [anon_sym_in] = ACTIONS(1980),
    [anon_sym_AT] = ACTIONS(604),
    [anon_sym_not] = ACTIONS(1980),
    [anon_sym_and] = ACTIONS(1980),
    [anon_sym_or] = ACTIONS(1980),
    [anon_sym_PLUS] = ACTIONS(1980),
    [anon_sym_DASH] = ACTIONS(1980),
    [anon_sym_SLASH] = ACTIONS(598),
    [anon_sym_PERCENT] = ACTIONS(604),
    [anon_sym_SLASH_SLASH] = ACTIONS(604),
    [anon_sym_STAR_STAR] = ACTIONS(610),
    [anon_sym_PIPE] = ACTIONS(1980),
    [anon_sym_AMP] = ACTIONS(1980),
    [anon_sym_CARET] = ACTIONS(1980),
    [anon_sym_LT_LT] = ACTIONS(1980),
    [anon_sym_LT] = ACTIONS(1982),
    [anon_sym_LT_EQ] = ACTIONS(1980),
    [anon_sym_EQ_EQ] = ACTIONS(1980),
    [anon_sym_BANG_EQ] = ACTIONS(1980),
    [anon_sym_GT_EQ] = ACTIONS(1980),
    [anon_sym_GT] = ACTIONS(1982),
    [anon_sym_LT_GT] = ACTIONS(1980),
    [anon_sym_is] = ACTIONS(1980),
    [anon_sym_LBRACK] = ACTIONS(1980),
    [sym_comment] = ACTIONS(72),
  },
  [722] = {
    [sym_argument_list] = STATE(251),
    [sym_generator_expression] = STATE(251),
    [anon_sym_DOT] = ACTIONS(1980),
    [anon_sym_LPAREN] = ACTIONS(424),
    [anon_sym_STAR] = ACTIONS(598),
    [anon_sym_GT_GT] = ACTIONS(600),
    [anon_sym_if] = ACTIONS(1980),
    [anon_sym_COLON] = ACTIONS(1980),
    [anon_sym_in] = ACTIONS(1980),
    [anon_sym_AT] = ACTIONS(604),
    [anon_sym_not] = ACTIONS(1980),
    [anon_sym_and] = ACTIONS(1980),
    [anon_sym_or] = ACTIONS(1980),
    [anon_sym_PLUS] = ACTIONS(608),
    [anon_sym_DASH] = ACTIONS(608),
    [anon_sym_SLASH] = ACTIONS(598),
    [anon_sym_PERCENT] = ACTIONS(604),
    [anon_sym_SLASH_SLASH] = ACTIONS(604),
    [anon_sym_STAR_STAR] = ACTIONS(610),
    [anon_sym_PIPE] = ACTIONS(1980),
    [anon_sym_AMP] = ACTIONS(614),
    [anon_sym_CARET] = ACTIONS(616),
    [anon_sym_LT_LT] = ACTIONS(600),
    [anon_sym_LT] = ACTIONS(1982),
    [anon_sym_LT_EQ] = ACTIONS(1980),
    [anon_sym_EQ_EQ] = ACTIONS(1980),
    [anon_sym_BANG_EQ] = ACTIONS(1980),
    [anon_sym_GT_EQ] = ACTIONS(1980),
    [anon_sym_GT] = ACTIONS(1982),
    [anon_sym_LT_GT] = ACTIONS(1980),
    [anon_sym_is] = ACTIONS(1980),
    [anon_sym_LBRACK] = ACTIONS(1980),
    [sym_comment] = ACTIONS(72),
  },
  [723] = {
    [sym_argument_list] = STATE(251),
    [sym_generator_expression] = STATE(251),
    [anon_sym_DOT] = ACTIONS(1980),
    [anon_sym_LPAREN] = ACTIONS(424),
    [anon_sym_STAR] = ACTIONS(598),
    [anon_sym_GT_GT] = ACTIONS(600),
    [anon_sym_if] = ACTIONS(1980),
    [anon_sym_COLON] = ACTIONS(1980),
    [anon_sym_in] = ACTIONS(1980),
    [anon_sym_AT] = ACTIONS(604),
    [anon_sym_not] = ACTIONS(1980),
    [anon_sym_and] = ACTIONS(1980),
    [anon_sym_or] = ACTIONS(1980),
    [anon_sym_PLUS] = ACTIONS(608),
    [anon_sym_DASH] = ACTIONS(608),
    [anon_sym_SLASH] = ACTIONS(598),
    [anon_sym_PERCENT] = ACTIONS(604),
    [anon_sym_SLASH_SLASH] = ACTIONS(604),
    [anon_sym_STAR_STAR] = ACTIONS(610),
    [anon_sym_PIPE] = ACTIONS(1980),
    [anon_sym_AMP] = ACTIONS(1980),
    [anon_sym_CARET] = ACTIONS(616),
    [anon_sym_LT_LT] = ACTIONS(600),
    [anon_sym_LT] = ACTIONS(1982),
    [anon_sym_LT_EQ] = ACTIONS(1980),
    [anon_sym_EQ_EQ] = ACTIONS(1980),
    [anon_sym_BANG_EQ] = ACTIONS(1980),
    [anon_sym_GT_EQ] = ACTIONS(1980),
    [anon_sym_GT] = ACTIONS(1982),
    [anon_sym_LT_GT] = ACTIONS(1980),
    [anon_sym_is] = ACTIONS(1980),
    [anon_sym_LBRACK] = ACTIONS(1980),
    [sym_comment] = ACTIONS(72),
  },
  [724] = {
    [sym_argument_list] = STATE(251),
    [sym_generator_expression] = STATE(251),
    [anon_sym_DOT] = ACTIONS(1980),
    [anon_sym_LPAREN] = ACTIONS(424),
    [anon_sym_STAR] = ACTIONS(598),
    [anon_sym_GT_GT] = ACTIONS(600),
    [anon_sym_if] = ACTIONS(1980),
    [anon_sym_COLON] = ACTIONS(1980),
    [anon_sym_in] = ACTIONS(1980),
    [anon_sym_AT] = ACTIONS(604),
    [anon_sym_not] = ACTIONS(1980),
    [anon_sym_and] = ACTIONS(1980),
    [anon_sym_or] = ACTIONS(1980),
    [anon_sym_PLUS] = ACTIONS(608),
    [anon_sym_DASH] = ACTIONS(608),
    [anon_sym_SLASH] = ACTIONS(598),
    [anon_sym_PERCENT] = ACTIONS(604),
    [anon_sym_SLASH_SLASH] = ACTIONS(604),
    [anon_sym_STAR_STAR] = ACTIONS(610),
    [anon_sym_PIPE] = ACTIONS(1980),
    [anon_sym_AMP] = ACTIONS(1980),
    [anon_sym_CARET] = ACTIONS(1980),
    [anon_sym_LT_LT] = ACTIONS(600),
    [anon_sym_LT] = ACTIONS(1982),
    [anon_sym_LT_EQ] = ACTIONS(1980),
    [anon_sym_EQ_EQ] = ACTIONS(1980),
    [anon_sym_BANG_EQ] = ACTIONS(1980),
    [anon_sym_GT_EQ] = ACTIONS(1980),
    [anon_sym_GT] = ACTIONS(1982),
    [anon_sym_LT_GT] = ACTIONS(1980),
    [anon_sym_is] = ACTIONS(1980),
    [anon_sym_LBRACK] = ACTIONS(1980),
    [sym_comment] = ACTIONS(72),
  },
  [725] = {
    [aux_sym_comparison_operator_repeat1] = STATE(725),
    [anon_sym_if] = ACTIONS(1984),
    [anon_sym_COLON] = ACTIONS(1984),
    [anon_sym_in] = ACTIONS(2346),
    [anon_sym_not] = ACTIONS(2349),
    [anon_sym_and] = ACTIONS(1984),
    [anon_sym_or] = ACTIONS(1984),
    [anon_sym_LT] = ACTIONS(2352),
    [anon_sym_LT_EQ] = ACTIONS(2346),
    [anon_sym_EQ_EQ] = ACTIONS(2346),
    [anon_sym_BANG_EQ] = ACTIONS(2346),
    [anon_sym_GT_EQ] = ACTIONS(2346),
    [anon_sym_GT] = ACTIONS(2352),
    [anon_sym_LT_GT] = ACTIONS(2346),
    [anon_sym_is] = ACTIONS(2355),
    [sym_comment] = ACTIONS(72),
  },
  [726] = {
    [sym_expression_list] = STATE(1126),
    [sym__expression] = STATE(732),
    [sym__primary_expression] = STATE(410),
    [sym_not_operator] = STATE(732),
    [sym_boolean_operator] = STATE(732),
    [sym_binary_operator] = STATE(410),
    [sym_unary_operator] = STATE(410),
    [sym_comparison_operator] = STATE(732),
    [sym_lambda] = STATE(732),
    [sym_attribute] = STATE(410),
    [sym_subscript] = STATE(410),
    [sym_call] = STATE(410),
    [sym_list] = STATE(410),
    [sym_list_comprehension] = STATE(410),
    [sym_dictionary] = STATE(410),
    [sym_dictionary_comprehension] = STATE(410),
    [sym_set] = STATE(410),
    [sym_set_comprehension] = STATE(410),
    [sym_parenthesized_expression] = STATE(410),
    [sym_tuple] = STATE(410),
    [sym_generator_expression] = STATE(410),
    [sym_conditional_expression] = STATE(732),
    [sym_concatenated_string] = STATE(410),
    [sym_await] = STATE(732),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_not] = ACTIONS(726),
    [anon_sym_PLUS] = ACTIONS(728),
    [anon_sym_DASH] = ACTIONS(728),
    [anon_sym_TILDE] = ACTIONS(728),
    [anon_sym_lambda] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(732),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(734),
    [sym_integer] = ACTIONS(736),
    [sym_float] = ACTIONS(736),
    [sym_identifier] = ACTIONS(736),
    [sym_true] = ACTIONS(736),
    [sym_false] = ACTIONS(736),
    [sym_none] = ACTIONS(736),
    [anon_sym_await] = ACTIONS(738),
    [sym_comment] = ACTIONS(72),
  },
  [727] = {
    [sym__simple_statements] = STATE(1127),
    [sym_import_statement] = STATE(10),
    [sym_import_from_statement] = STATE(10),
    [sym_print_statement] = STATE(10),
    [sym_assert_statement] = STATE(10),
    [sym_expression_statement] = STATE(10),
    [sym_return_statement] = STATE(10),
    [sym_delete_statement] = STATE(10),
    [sym_raise_statement] = STATE(10),
    [sym_global_statement] = STATE(10),
    [sym_nonlocal_statement] = STATE(10),
    [sym_exec_statement] = STATE(10),
    [sym__suite] = STATE(1127),
    [sym_expression_list] = STATE(32),
    [sym__expression] = STATE(33),
    [sym__primary_expression] = STATE(34),
    [sym_not_operator] = STATE(33),
    [sym_boolean_operator] = STATE(33),
    [sym_binary_operator] = STATE(34),
    [sym_unary_operator] = STATE(34),
    [sym_comparison_operator] = STATE(33),
    [sym_lambda] = STATE(33),
    [sym_assignment] = STATE(35),
    [sym_augmented_assignment] = STATE(35),
    [sym_yield] = STATE(35),
    [sym_attribute] = STATE(34),
    [sym_subscript] = STATE(34),
    [sym_call] = STATE(34),
    [sym_list] = STATE(34),
    [sym_list_comprehension] = STATE(34),
    [sym_dictionary] = STATE(34),
    [sym_dictionary_comprehension] = STATE(34),
    [sym_set] = STATE(34),
    [sym_set_comprehension] = STATE(34),
    [sym_parenthesized_expression] = STATE(34),
    [sym_tuple] = STATE(34),
    [sym_generator_expression] = STATE(34),
    [sym_conditional_expression] = STATE(33),
    [sym_concatenated_string] = STATE(34),
    [sym_await] = STATE(33),
    [sym__indent] = ACTIONS(1528),
    [anon_sym_import] = ACTIONS(10),
    [anon_sym_from] = ACTIONS(12),
    [anon_sym_LPAREN] = ACTIONS(14),
    [anon_sym_print] = ACTIONS(16),
    [anon_sym_assert] = ACTIONS(18),
    [anon_sym_return] = ACTIONS(20),
    [anon_sym_del] = ACTIONS(22),
    [anon_sym_raise] = ACTIONS(24),
    [sym_pass_statement] = ACTIONS(26),
    [sym_break_statement] = ACTIONS(26),
    [sym_continue_statement] = ACTIONS(26),
    [anon_sym_global] = ACTIONS(42),
    [anon_sym_nonlocal] = ACTIONS(44),
    [anon_sym_exec] = ACTIONS(46),
    [anon_sym_not] = ACTIONS(52),
    [anon_sym_PLUS] = ACTIONS(54),
    [anon_sym_DASH] = ACTIONS(54),
    [anon_sym_TILDE] = ACTIONS(54),
    [anon_sym_lambda] = ACTIONS(56),
    [anon_sym_yield] = ACTIONS(58),
    [anon_sym_LBRACK] = ACTIONS(60),
    [sym_ellipsis] = ACTIONS(62),
    [anon_sym_LBRACE] = ACTIONS(64),
    [sym_string] = ACTIONS(66),
    [sym_integer] = ACTIONS(68),
    [sym_float] = ACTIONS(68),
    [sym_identifier] = ACTIONS(68),
    [sym_true] = ACTIONS(68),
    [sym_false] = ACTIONS(68),
    [sym_none] = ACTIONS(68),
    [anon_sym_await] = ACTIONS(70),
    [sym_comment] = ACTIONS(72),
  },
  [728] = {
    [aux_sym_with_statement_repeat1] = STATE(770),
    [anon_sym_COMMA] = ACTIONS(658),
    [anon_sym_COLON] = ACTIONS(2358),
    [sym_comment] = ACTIONS(72),
  },
  [729] = {
    [anon_sym_COLON] = ACTIONS(2360),
    [anon_sym_DASH_GT] = ACTIONS(2362),
    [sym_comment] = ACTIONS(72),
  },
  [730] = {
    [aux_sym_concatenated_string_repeat1] = STATE(730),
    [anon_sym_DOT] = ACTIONS(1862),
    [anon_sym_LPAREN] = ACTIONS(1862),
    [anon_sym_COMMA] = ACTIONS(1862),
    [anon_sym_STAR] = ACTIONS(1864),
    [anon_sym_GT_GT] = ACTIONS(1862),
    [anon_sym_in] = ACTIONS(1862),
    [anon_sym_AT] = ACTIONS(1862),
    [anon_sym_PLUS] = ACTIONS(1862),
    [anon_sym_DASH] = ACTIONS(1862),
    [anon_sym_SLASH] = ACTIONS(1864),
    [anon_sym_PERCENT] = ACTIONS(1862),
    [anon_sym_SLASH_SLASH] = ACTIONS(1862),
    [anon_sym_STAR_STAR] = ACTIONS(1862),
    [anon_sym_PIPE] = ACTIONS(1862),
    [anon_sym_AMP] = ACTIONS(1862),
    [anon_sym_CARET] = ACTIONS(1862),
    [anon_sym_LT_LT] = ACTIONS(1862),
    [anon_sym_LBRACK] = ACTIONS(1862),
    [sym_string] = ACTIONS(2364),
    [sym_comment] = ACTIONS(72),
  },
  [731] = {
    [anon_sym_COLON] = ACTIONS(2367),
    [sym_comment] = ACTIONS(72),
  },
  [732] = {
    [aux_sym_print_statement_repeat1] = STATE(1133),
    [anon_sym_COMMA] = ACTIONS(2369),
    [anon_sym_if] = ACTIONS(1592),
    [anon_sym_COLON] = ACTIONS(296),
    [anon_sym_and] = ACTIONS(1594),
    [anon_sym_or] = ACTIONS(1596),
    [sym_comment] = ACTIONS(72),
  },
  [733] = {
    [sym_argument_list] = STATE(251),
    [sym_generator_expression] = STATE(251),
    [anon_sym_DOT] = ACTIONS(422),
    [anon_sym_LPAREN] = ACTIONS(424),
    [anon_sym_COMMA] = ACTIONS(2371),
    [anon_sym_STAR] = ACTIONS(630),
    [anon_sym_GT_GT] = ACTIONS(632),
    [anon_sym_in] = ACTIONS(2371),
    [anon_sym_AT] = ACTIONS(636),
    [anon_sym_PLUS] = ACTIONS(638),
    [anon_sym_DASH] = ACTIONS(638),
    [anon_sym_SLASH] = ACTIONS(630),
    [anon_sym_PERCENT] = ACTIONS(636),
    [anon_sym_SLASH_SLASH] = ACTIONS(636),
    [anon_sym_STAR_STAR] = ACTIONS(640),
    [anon_sym_PIPE] = ACTIONS(642),
    [anon_sym_AMP] = ACTIONS(644),
    [anon_sym_CARET] = ACTIONS(646),
    [anon_sym_LT_LT] = ACTIONS(632),
    [anon_sym_LBRACK] = ACTIONS(450),
    [sym_comment] = ACTIONS(72),
  },
  [734] = {
    [sym_argument_list] = STATE(251),
    [sym_generator_expression] = STATE(251),
    [anon_sym_DOT] = ACTIONS(1980),
    [anon_sym_LPAREN] = ACTIONS(424),
    [anon_sym_COMMA] = ACTIONS(1980),
    [anon_sym_STAR] = ACTIONS(1982),
    [anon_sym_GT_GT] = ACTIONS(1980),
    [anon_sym_in] = ACTIONS(1980),
    [anon_sym_AT] = ACTIONS(1980),
    [anon_sym_PLUS] = ACTIONS(1980),
    [anon_sym_DASH] = ACTIONS(1980),
    [anon_sym_SLASH] = ACTIONS(1982),
    [anon_sym_PERCENT] = ACTIONS(1980),
    [anon_sym_SLASH_SLASH] = ACTIONS(1980),
    [anon_sym_STAR_STAR] = ACTIONS(640),
    [anon_sym_PIPE] = ACTIONS(1980),
    [anon_sym_AMP] = ACTIONS(1980),
    [anon_sym_CARET] = ACTIONS(1980),
    [anon_sym_LT_LT] = ACTIONS(1980),
    [anon_sym_LBRACK] = ACTIONS(1980),
    [sym_comment] = ACTIONS(72),
  },
  [735] = {
    [sym_argument_list] = STATE(251),
    [sym_generator_expression] = STATE(251),
    [anon_sym_DOT] = ACTIONS(1980),
    [anon_sym_LPAREN] = ACTIONS(424),
    [anon_sym_COMMA] = ACTIONS(1980),
    [anon_sym_STAR] = ACTIONS(630),
    [anon_sym_GT_GT] = ACTIONS(1980),
    [anon_sym_in] = ACTIONS(1980),
    [anon_sym_AT] = ACTIONS(636),
    [anon_sym_PLUS] = ACTIONS(638),
    [anon_sym_DASH] = ACTIONS(638),
    [anon_sym_SLASH] = ACTIONS(630),
    [anon_sym_PERCENT] = ACTIONS(636),
    [anon_sym_SLASH_SLASH] = ACTIONS(636),
    [anon_sym_STAR_STAR] = ACTIONS(640),
    [anon_sym_PIPE] = ACTIONS(1980),
    [anon_sym_AMP] = ACTIONS(1980),
    [anon_sym_CARET] = ACTIONS(1980),
    [anon_sym_LT_LT] = ACTIONS(1980),
    [anon_sym_LBRACK] = ACTIONS(1980),
    [sym_comment] = ACTIONS(72),
  },
  [736] = {
    [sym_argument_list] = STATE(251),
    [sym_generator_expression] = STATE(251),
    [anon_sym_DOT] = ACTIONS(1980),
    [anon_sym_LPAREN] = ACTIONS(424),
    [anon_sym_COMMA] = ACTIONS(1980),
    [anon_sym_STAR] = ACTIONS(630),
    [anon_sym_GT_GT] = ACTIONS(1980),
    [anon_sym_in] = ACTIONS(1980),
    [anon_sym_AT] = ACTIONS(636),
    [anon_sym_PLUS] = ACTIONS(1980),
    [anon_sym_DASH] = ACTIONS(1980),
    [anon_sym_SLASH] = ACTIONS(630),
    [anon_sym_PERCENT] = ACTIONS(636),
    [anon_sym_SLASH_SLASH] = ACTIONS(636),
    [anon_sym_STAR_STAR] = ACTIONS(640),
    [anon_sym_PIPE] = ACTIONS(1980),
    [anon_sym_AMP] = ACTIONS(1980),
    [anon_sym_CARET] = ACTIONS(1980),
    [anon_sym_LT_LT] = ACTIONS(1980),
    [anon_sym_LBRACK] = ACTIONS(1980),
    [sym_comment] = ACTIONS(72),
  },
  [737] = {
    [sym_argument_list] = STATE(251),
    [sym_generator_expression] = STATE(251),
    [anon_sym_DOT] = ACTIONS(1980),
    [anon_sym_LPAREN] = ACTIONS(424),
    [anon_sym_COMMA] = ACTIONS(1980),
    [anon_sym_STAR] = ACTIONS(630),
    [anon_sym_GT_GT] = ACTIONS(632),
    [anon_sym_in] = ACTIONS(1980),
    [anon_sym_AT] = ACTIONS(636),
    [anon_sym_PLUS] = ACTIONS(638),
    [anon_sym_DASH] = ACTIONS(638),
    [anon_sym_SLASH] = ACTIONS(630),
    [anon_sym_PERCENT] = ACTIONS(636),
    [anon_sym_SLASH_SLASH] = ACTIONS(636),
    [anon_sym_STAR_STAR] = ACTIONS(640),
    [anon_sym_PIPE] = ACTIONS(1980),
    [anon_sym_AMP] = ACTIONS(644),
    [anon_sym_CARET] = ACTIONS(646),
    [anon_sym_LT_LT] = ACTIONS(632),
    [anon_sym_LBRACK] = ACTIONS(1980),
    [sym_comment] = ACTIONS(72),
  },
  [738] = {
    [sym_argument_list] = STATE(251),
    [sym_generator_expression] = STATE(251),
    [anon_sym_DOT] = ACTIONS(1980),
    [anon_sym_LPAREN] = ACTIONS(424),
    [anon_sym_COMMA] = ACTIONS(1980),
    [anon_sym_STAR] = ACTIONS(630),
    [anon_sym_GT_GT] = ACTIONS(632),
    [anon_sym_in] = ACTIONS(1980),
    [anon_sym_AT] = ACTIONS(636),
    [anon_sym_PLUS] = ACTIONS(638),
    [anon_sym_DASH] = ACTIONS(638),
    [anon_sym_SLASH] = ACTIONS(630),
    [anon_sym_PERCENT] = ACTIONS(636),
    [anon_sym_SLASH_SLASH] = ACTIONS(636),
    [anon_sym_STAR_STAR] = ACTIONS(640),
    [anon_sym_PIPE] = ACTIONS(1980),
    [anon_sym_AMP] = ACTIONS(1980),
    [anon_sym_CARET] = ACTIONS(646),
    [anon_sym_LT_LT] = ACTIONS(632),
    [anon_sym_LBRACK] = ACTIONS(1980),
    [sym_comment] = ACTIONS(72),
  },
  [739] = {
    [sym_argument_list] = STATE(251),
    [sym_generator_expression] = STATE(251),
    [anon_sym_DOT] = ACTIONS(1980),
    [anon_sym_LPAREN] = ACTIONS(424),
    [anon_sym_COMMA] = ACTIONS(1980),
    [anon_sym_STAR] = ACTIONS(630),
    [anon_sym_GT_GT] = ACTIONS(632),
    [anon_sym_in] = ACTIONS(1980),
    [anon_sym_AT] = ACTIONS(636),
    [anon_sym_PLUS] = ACTIONS(638),
    [anon_sym_DASH] = ACTIONS(638),
    [anon_sym_SLASH] = ACTIONS(630),
    [anon_sym_PERCENT] = ACTIONS(636),
    [anon_sym_SLASH_SLASH] = ACTIONS(636),
    [anon_sym_STAR_STAR] = ACTIONS(640),
    [anon_sym_PIPE] = ACTIONS(1980),
    [anon_sym_AMP] = ACTIONS(1980),
    [anon_sym_CARET] = ACTIONS(1980),
    [anon_sym_LT_LT] = ACTIONS(632),
    [anon_sym_LBRACK] = ACTIONS(1980),
    [sym_comment] = ACTIONS(72),
  },
  [740] = {
    [sym__primary_expression] = STATE(733),
    [sym_binary_operator] = STATE(733),
    [sym_unary_operator] = STATE(733),
    [sym_attribute] = STATE(733),
    [sym_subscript] = STATE(733),
    [sym_call] = STATE(733),
    [sym_list] = STATE(733),
    [sym_list_comprehension] = STATE(733),
    [sym_dictionary] = STATE(733),
    [sym_dictionary_comprehension] = STATE(733),
    [sym_set] = STATE(733),
    [sym_set_comprehension] = STATE(733),
    [sym_parenthesized_expression] = STATE(733),
    [sym_tuple] = STATE(733),
    [sym_generator_expression] = STATE(733),
    [sym_concatenated_string] = STATE(733),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_in] = ACTIONS(2373),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_PLUS] = ACTIONS(180),
    [anon_sym_DASH] = ACTIONS(180),
    [anon_sym_TILDE] = ACTIONS(180),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(1460),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(184),
    [sym_integer] = ACTIONS(1462),
    [sym_float] = ACTIONS(1462),
    [sym_identifier] = ACTIONS(1462),
    [sym_true] = ACTIONS(1462),
    [sym_false] = ACTIONS(1462),
    [sym_none] = ACTIONS(1462),
    [sym_comment] = ACTIONS(72),
  },
  [741] = {
    [aux_sym_variables_repeat1] = STATE(741),
    [anon_sym_COMMA] = ACTIONS(2375),
    [anon_sym_in] = ACTIONS(2371),
    [sym_comment] = ACTIONS(72),
  },
  [742] = {
    [sym__statement] = STATE(1136),
    [sym__simple_statements] = STATE(1136),
    [sym_import_statement] = STATE(746),
    [sym_import_from_statement] = STATE(746),
    [sym_print_statement] = STATE(746),
    [sym_assert_statement] = STATE(746),
    [sym_expression_statement] = STATE(746),
    [sym_return_statement] = STATE(746),
    [sym_delete_statement] = STATE(746),
    [sym_raise_statement] = STATE(746),
    [sym_if_statement] = STATE(1136),
    [sym_for_statement] = STATE(1136),
    [sym_while_statement] = STATE(1136),
    [sym_try_statement] = STATE(1136),
    [sym_with_statement] = STATE(1136),
    [sym_function_definition] = STATE(1136),
    [sym_global_statement] = STATE(746),
    [sym_nonlocal_statement] = STATE(746),
    [sym_exec_statement] = STATE(746),
    [sym_class_definition] = STATE(1136),
    [sym_decorated_definition] = STATE(1136),
    [sym_decorator] = STATE(756),
    [sym_expression_list] = STATE(32),
    [sym__expression] = STATE(33),
    [sym__primary_expression] = STATE(34),
    [sym_not_operator] = STATE(33),
    [sym_boolean_operator] = STATE(33),
    [sym_binary_operator] = STATE(34),
    [sym_unary_operator] = STATE(34),
    [sym_comparison_operator] = STATE(33),
    [sym_lambda] = STATE(33),
    [sym_assignment] = STATE(35),
    [sym_augmented_assignment] = STATE(35),
    [sym_yield] = STATE(35),
    [sym_attribute] = STATE(34),
    [sym_subscript] = STATE(34),
    [sym_call] = STATE(34),
    [sym_list] = STATE(34),
    [sym_list_comprehension] = STATE(34),
    [sym_dictionary] = STATE(34),
    [sym_dictionary_comprehension] = STATE(34),
    [sym_set] = STATE(34),
    [sym_set_comprehension] = STATE(34),
    [sym_parenthesized_expression] = STATE(34),
    [sym_tuple] = STATE(34),
    [sym_generator_expression] = STATE(34),
    [sym_conditional_expression] = STATE(33),
    [sym_concatenated_string] = STATE(34),
    [sym_await] = STATE(33),
    [aux_sym_module_repeat1] = STATE(1136),
    [aux_sym_decorated_definition_repeat1] = STATE(756),
    [sym__dedent] = ACTIONS(2378),
    [anon_sym_import] = ACTIONS(10),
    [anon_sym_from] = ACTIONS(12),
    [anon_sym_LPAREN] = ACTIONS(14),
    [anon_sym_print] = ACTIONS(16),
    [anon_sym_assert] = ACTIONS(18),
    [anon_sym_return] = ACTIONS(20),
    [anon_sym_del] = ACTIONS(22),
    [anon_sym_raise] = ACTIONS(24),
    [sym_pass_statement] = ACTIONS(1498),
    [sym_break_statement] = ACTIONS(1498),
    [sym_continue_statement] = ACTIONS(1498),
    [anon_sym_if] = ACTIONS(1500),
    [anon_sym_async] = ACTIONS(1502),
    [anon_sym_for] = ACTIONS(1504),
    [anon_sym_while] = ACTIONS(1506),
    [anon_sym_try] = ACTIONS(1508),
    [anon_sym_with] = ACTIONS(1510),
    [anon_sym_def] = ACTIONS(1512),
    [anon_sym_global] = ACTIONS(42),
    [anon_sym_nonlocal] = ACTIONS(44),
    [anon_sym_exec] = ACTIONS(46),
    [anon_sym_class] = ACTIONS(1514),
    [anon_sym_AT] = ACTIONS(50),
    [anon_sym_not] = ACTIONS(52),
    [anon_sym_PLUS] = ACTIONS(54),
    [anon_sym_DASH] = ACTIONS(54),
    [anon_sym_TILDE] = ACTIONS(54),
    [anon_sym_lambda] = ACTIONS(56),
    [anon_sym_yield] = ACTIONS(58),
    [anon_sym_LBRACK] = ACTIONS(60),
    [sym_ellipsis] = ACTIONS(62),
    [anon_sym_LBRACE] = ACTIONS(64),
    [sym_string] = ACTIONS(66),
    [sym_integer] = ACTIONS(68),
    [sym_float] = ACTIONS(68),
    [sym_identifier] = ACTIONS(68),
    [sym_true] = ACTIONS(68),
    [sym_false] = ACTIONS(68),
    [sym_none] = ACTIONS(68),
    [anon_sym_await] = ACTIONS(70),
    [sym_comment] = ACTIONS(72),
  },
  [743] = {
    [aux_sym__simple_statements_repeat1] = STATE(1139),
    [sym__newline] = ACTIONS(2380),
    [sym_comment] = ACTIONS(72),
    [sym__semicolon] = ACTIONS(2382),
  },
  [744] = {
    [sym_else_clause] = STATE(1140),
    [ts_builtin_sym_end] = ACTIONS(2384),
    [anon_sym_import] = ACTIONS(2386),
    [anon_sym_from] = ACTIONS(2386),
    [anon_sym_LPAREN] = ACTIONS(2384),
    [anon_sym_print] = ACTIONS(2386),
    [anon_sym_assert] = ACTIONS(2386),
    [anon_sym_return] = ACTIONS(2386),
    [anon_sym_del] = ACTIONS(2386),
    [anon_sym_raise] = ACTIONS(2386),
    [sym_pass_statement] = ACTIONS(2386),
    [sym_break_statement] = ACTIONS(2386),
    [sym_continue_statement] = ACTIONS(2386),
    [anon_sym_if] = ACTIONS(2386),
    [anon_sym_else] = ACTIONS(2340),
    [anon_sym_async] = ACTIONS(2386),
    [anon_sym_for] = ACTIONS(2386),
    [anon_sym_while] = ACTIONS(2386),
    [anon_sym_try] = ACTIONS(2386),
    [anon_sym_with] = ACTIONS(2386),
    [anon_sym_def] = ACTIONS(2386),
    [anon_sym_global] = ACTIONS(2386),
    [anon_sym_nonlocal] = ACTIONS(2386),
    [anon_sym_exec] = ACTIONS(2386),
    [anon_sym_class] = ACTIONS(2386),
    [anon_sym_AT] = ACTIONS(2384),
    [anon_sym_not] = ACTIONS(2386),
    [anon_sym_PLUS] = ACTIONS(2384),
    [anon_sym_DASH] = ACTIONS(2384),
    [anon_sym_TILDE] = ACTIONS(2384),
    [anon_sym_lambda] = ACTIONS(2386),
    [anon_sym_yield] = ACTIONS(2386),
    [anon_sym_LBRACK] = ACTIONS(2384),
    [sym_ellipsis] = ACTIONS(2384),
    [anon_sym_LBRACE] = ACTIONS(2384),
    [sym_string] = ACTIONS(2384),
    [sym_integer] = ACTIONS(2386),
    [sym_float] = ACTIONS(2386),
    [sym_identifier] = ACTIONS(2386),
    [sym_true] = ACTIONS(2386),
    [sym_false] = ACTIONS(2386),
    [sym_none] = ACTIONS(2386),
    [anon_sym_await] = ACTIONS(2386),
    [sym_comment] = ACTIONS(72),
  },
  [745] = {
    [ts_builtin_sym_end] = ACTIONS(2388),
    [anon_sym_import] = ACTIONS(2390),
    [anon_sym_from] = ACTIONS(2390),
    [anon_sym_LPAREN] = ACTIONS(2388),
    [anon_sym_print] = ACTIONS(2390),
    [anon_sym_assert] = ACTIONS(2390),
    [anon_sym_return] = ACTIONS(2390),
    [anon_sym_del] = ACTIONS(2390),
    [anon_sym_raise] = ACTIONS(2390),
    [sym_pass_statement] = ACTIONS(2390),
    [sym_break_statement] = ACTIONS(2390),
    [sym_continue_statement] = ACTIONS(2390),
    [anon_sym_if] = ACTIONS(2390),
    [anon_sym_else] = ACTIONS(2390),
    [anon_sym_async] = ACTIONS(2390),
    [anon_sym_for] = ACTIONS(2390),
    [anon_sym_while] = ACTIONS(2390),
    [anon_sym_try] = ACTIONS(2390),
    [anon_sym_except] = ACTIONS(2390),
    [anon_sym_finally] = ACTIONS(2390),
    [anon_sym_with] = ACTIONS(2390),
    [anon_sym_def] = ACTIONS(2390),
    [anon_sym_global] = ACTIONS(2390),
    [anon_sym_nonlocal] = ACTIONS(2390),
    [anon_sym_exec] = ACTIONS(2390),
    [anon_sym_class] = ACTIONS(2390),
    [anon_sym_AT] = ACTIONS(2388),
    [anon_sym_not] = ACTIONS(2390),
    [anon_sym_PLUS] = ACTIONS(2388),
    [anon_sym_DASH] = ACTIONS(2388),
    [anon_sym_TILDE] = ACTIONS(2388),
    [anon_sym_lambda] = ACTIONS(2390),
    [anon_sym_yield] = ACTIONS(2390),
    [anon_sym_LBRACK] = ACTIONS(2388),
    [sym_ellipsis] = ACTIONS(2388),
    [anon_sym_LBRACE] = ACTIONS(2388),
    [sym_string] = ACTIONS(2388),
    [sym_integer] = ACTIONS(2390),
    [sym_float] = ACTIONS(2390),
    [sym_identifier] = ACTIONS(2390),
    [sym_true] = ACTIONS(2390),
    [sym_false] = ACTIONS(2390),
    [sym_none] = ACTIONS(2390),
    [anon_sym_await] = ACTIONS(2390),
    [sym_comment] = ACTIONS(72),
  },
  [746] = {
    [aux_sym__simple_statements_repeat1] = STATE(1143),
    [sym__newline] = ACTIONS(2392),
    [sym_comment] = ACTIONS(72),
    [sym__semicolon] = ACTIONS(2394),
  },
  [747] = {
    [sym__expression] = STATE(1144),
    [sym__primary_expression] = STATE(96),
    [sym_not_operator] = STATE(1144),
    [sym_boolean_operator] = STATE(1144),
    [sym_binary_operator] = STATE(96),
    [sym_unary_operator] = STATE(96),
    [sym_comparison_operator] = STATE(1144),
    [sym_lambda] = STATE(1144),
    [sym_attribute] = STATE(96),
    [sym_subscript] = STATE(96),
    [sym_call] = STATE(96),
    [sym_list] = STATE(96),
    [sym_list_comprehension] = STATE(96),
    [sym_dictionary] = STATE(96),
    [sym_dictionary_comprehension] = STATE(96),
    [sym_set] = STATE(96),
    [sym_set_comprehension] = STATE(96),
    [sym_parenthesized_expression] = STATE(96),
    [sym_tuple] = STATE(96),
    [sym_generator_expression] = STATE(96),
    [sym_conditional_expression] = STATE(1144),
    [sym_concatenated_string] = STATE(96),
    [sym_await] = STATE(1144),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_not] = ACTIONS(160),
    [anon_sym_PLUS] = ACTIONS(162),
    [anon_sym_DASH] = ACTIONS(162),
    [anon_sym_TILDE] = ACTIONS(162),
    [anon_sym_lambda] = ACTIONS(164),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(166),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(168),
    [sym_integer] = ACTIONS(170),
    [sym_float] = ACTIONS(170),
    [sym_identifier] = ACTIONS(170),
    [sym_true] = ACTIONS(170),
    [sym_false] = ACTIONS(170),
    [sym_none] = ACTIONS(170),
    [anon_sym_await] = ACTIONS(172),
    [sym_comment] = ACTIONS(72),
  },
  [748] = {
    [anon_sym_for] = ACTIONS(2396),
    [anon_sym_with] = ACTIONS(2398),
    [anon_sym_def] = ACTIONS(2400),
    [sym_comment] = ACTIONS(72),
  },
  [749] = {
    [sym_variables] = STATE(1148),
    [sym__primary_expression] = STATE(103),
    [sym_binary_operator] = STATE(103),
    [sym_unary_operator] = STATE(103),
    [sym_attribute] = STATE(103),
    [sym_subscript] = STATE(103),
    [sym_call] = STATE(103),
    [sym_list] = STATE(103),
    [sym_list_comprehension] = STATE(103),
    [sym_dictionary] = STATE(103),
    [sym_dictionary_comprehension] = STATE(103),
    [sym_set] = STATE(103),
    [sym_set_comprehension] = STATE(103),
    [sym_parenthesized_expression] = STATE(103),
    [sym_tuple] = STATE(103),
    [sym_generator_expression] = STATE(103),
    [sym_concatenated_string] = STATE(103),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_PLUS] = ACTIONS(180),
    [anon_sym_DASH] = ACTIONS(180),
    [anon_sym_TILDE] = ACTIONS(180),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(182),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(184),
    [sym_integer] = ACTIONS(186),
    [sym_float] = ACTIONS(186),
    [sym_identifier] = ACTIONS(186),
    [sym_true] = ACTIONS(186),
    [sym_false] = ACTIONS(186),
    [sym_none] = ACTIONS(186),
    [sym_comment] = ACTIONS(72),
  },
  [750] = {
    [sym__expression] = STATE(1149),
    [sym__primary_expression] = STATE(96),
    [sym_not_operator] = STATE(1149),
    [sym_boolean_operator] = STATE(1149),
    [sym_binary_operator] = STATE(96),
    [sym_unary_operator] = STATE(96),
    [sym_comparison_operator] = STATE(1149),
    [sym_lambda] = STATE(1149),
    [sym_attribute] = STATE(96),
    [sym_subscript] = STATE(96),
    [sym_call] = STATE(96),
    [sym_list] = STATE(96),
    [sym_list_comprehension] = STATE(96),
    [sym_dictionary] = STATE(96),
    [sym_dictionary_comprehension] = STATE(96),
    [sym_set] = STATE(96),
    [sym_set_comprehension] = STATE(96),
    [sym_parenthesized_expression] = STATE(96),
    [sym_tuple] = STATE(96),
    [sym_generator_expression] = STATE(96),
    [sym_conditional_expression] = STATE(1149),
    [sym_concatenated_string] = STATE(96),
    [sym_await] = STATE(1149),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_not] = ACTIONS(160),
    [anon_sym_PLUS] = ACTIONS(162),
    [anon_sym_DASH] = ACTIONS(162),
    [anon_sym_TILDE] = ACTIONS(162),
    [anon_sym_lambda] = ACTIONS(164),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(166),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(168),
    [sym_integer] = ACTIONS(170),
    [sym_float] = ACTIONS(170),
    [sym_identifier] = ACTIONS(170),
    [sym_true] = ACTIONS(170),
    [sym_false] = ACTIONS(170),
    [sym_none] = ACTIONS(170),
    [anon_sym_await] = ACTIONS(172),
    [sym_comment] = ACTIONS(72),
  },
  [751] = {
    [anon_sym_COLON] = ACTIONS(2402),
    [sym_comment] = ACTIONS(72),
  },
  [752] = {
    [sym_with_item] = STATE(1151),
    [sym__expression] = STATE(112),
    [sym__primary_expression] = STATE(113),
    [sym_not_operator] = STATE(112),
    [sym_boolean_operator] = STATE(112),
    [sym_binary_operator] = STATE(113),
    [sym_unary_operator] = STATE(113),
    [sym_comparison_operator] = STATE(112),
    [sym_lambda] = STATE(112),
    [sym_attribute] = STATE(113),
    [sym_subscript] = STATE(113),
    [sym_call] = STATE(113),
    [sym_list] = STATE(113),
    [sym_list_comprehension] = STATE(113),
    [sym_dictionary] = STATE(113),
    [sym_dictionary_comprehension] = STATE(113),
    [sym_set] = STATE(113),
    [sym_set_comprehension] = STATE(113),
    [sym_parenthesized_expression] = STATE(113),
    [sym_tuple] = STATE(113),
    [sym_generator_expression] = STATE(113),
    [sym_conditional_expression] = STATE(112),
    [sym_concatenated_string] = STATE(113),
    [sym_await] = STATE(112),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_not] = ACTIONS(190),
    [anon_sym_PLUS] = ACTIONS(192),
    [anon_sym_DASH] = ACTIONS(192),
    [anon_sym_TILDE] = ACTIONS(192),
    [anon_sym_lambda] = ACTIONS(194),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(196),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(198),
    [sym_integer] = ACTIONS(200),
    [sym_float] = ACTIONS(200),
    [sym_identifier] = ACTIONS(200),
    [sym_true] = ACTIONS(200),
    [sym_false] = ACTIONS(200),
    [sym_none] = ACTIONS(200),
    [anon_sym_await] = ACTIONS(202),
    [sym_comment] = ACTIONS(72),
  },
  [753] = {
    [sym_identifier] = ACTIONS(2404),
    [sym_comment] = ACTIONS(72),
  },
  [754] = {
    [sym_identifier] = ACTIONS(2406),
    [sym_comment] = ACTIONS(72),
  },
  [755] = {
    [sym__statement] = STATE(1155),
    [sym__simple_statements] = STATE(1155),
    [sym_import_statement] = STATE(746),
    [sym_import_from_statement] = STATE(746),
    [sym_print_statement] = STATE(746),
    [sym_assert_statement] = STATE(746),
    [sym_expression_statement] = STATE(746),
    [sym_return_statement] = STATE(746),
    [sym_delete_statement] = STATE(746),
    [sym_raise_statement] = STATE(746),
    [sym_if_statement] = STATE(1155),
    [sym_for_statement] = STATE(1155),
    [sym_while_statement] = STATE(1155),
    [sym_try_statement] = STATE(1155),
    [sym_with_statement] = STATE(1155),
    [sym_function_definition] = STATE(1155),
    [sym_global_statement] = STATE(746),
    [sym_nonlocal_statement] = STATE(746),
    [sym_exec_statement] = STATE(746),
    [sym_class_definition] = STATE(1155),
    [sym_decorated_definition] = STATE(1155),
    [sym_decorator] = STATE(756),
    [sym_expression_list] = STATE(32),
    [sym__expression] = STATE(33),
    [sym__primary_expression] = STATE(34),
    [sym_not_operator] = STATE(33),
    [sym_boolean_operator] = STATE(33),
    [sym_binary_operator] = STATE(34),
    [sym_unary_operator] = STATE(34),
    [sym_comparison_operator] = STATE(33),
    [sym_lambda] = STATE(33),
    [sym_assignment] = STATE(35),
    [sym_augmented_assignment] = STATE(35),
    [sym_yield] = STATE(35),
    [sym_attribute] = STATE(34),
    [sym_subscript] = STATE(34),
    [sym_call] = STATE(34),
    [sym_list] = STATE(34),
    [sym_list_comprehension] = STATE(34),
    [sym_dictionary] = STATE(34),
    [sym_dictionary_comprehension] = STATE(34),
    [sym_set] = STATE(34),
    [sym_set_comprehension] = STATE(34),
    [sym_parenthesized_expression] = STATE(34),
    [sym_tuple] = STATE(34),
    [sym_generator_expression] = STATE(34),
    [sym_conditional_expression] = STATE(33),
    [sym_concatenated_string] = STATE(34),
    [sym_await] = STATE(33),
    [aux_sym_module_repeat1] = STATE(1155),
    [aux_sym_decorated_definition_repeat1] = STATE(756),
    [sym__dedent] = ACTIONS(2408),
    [anon_sym_import] = ACTIONS(10),
    [anon_sym_from] = ACTIONS(12),
    [anon_sym_LPAREN] = ACTIONS(14),
    [anon_sym_print] = ACTIONS(16),
    [anon_sym_assert] = ACTIONS(18),
    [anon_sym_return] = ACTIONS(20),
    [anon_sym_del] = ACTIONS(22),
    [anon_sym_raise] = ACTIONS(24),
    [sym_pass_statement] = ACTIONS(1498),
    [sym_break_statement] = ACTIONS(1498),
    [sym_continue_statement] = ACTIONS(1498),
    [anon_sym_if] = ACTIONS(1500),
    [anon_sym_async] = ACTIONS(1502),
    [anon_sym_for] = ACTIONS(1504),
    [anon_sym_while] = ACTIONS(1506),
    [anon_sym_try] = ACTIONS(1508),
    [anon_sym_with] = ACTIONS(1510),
    [anon_sym_def] = ACTIONS(1512),
    [anon_sym_global] = ACTIONS(42),
    [anon_sym_nonlocal] = ACTIONS(44),
    [anon_sym_exec] = ACTIONS(46),
    [anon_sym_class] = ACTIONS(1514),
    [anon_sym_AT] = ACTIONS(50),
    [anon_sym_not] = ACTIONS(52),
    [anon_sym_PLUS] = ACTIONS(54),
    [anon_sym_DASH] = ACTIONS(54),
    [anon_sym_TILDE] = ACTIONS(54),
    [anon_sym_lambda] = ACTIONS(56),
    [anon_sym_yield] = ACTIONS(58),
    [anon_sym_LBRACK] = ACTIONS(60),
    [sym_ellipsis] = ACTIONS(62),
    [anon_sym_LBRACE] = ACTIONS(64),
    [sym_string] = ACTIONS(66),
    [sym_integer] = ACTIONS(68),
    [sym_float] = ACTIONS(68),
    [sym_identifier] = ACTIONS(68),
    [sym_true] = ACTIONS(68),
    [sym_false] = ACTIONS(68),
    [sym_none] = ACTIONS(68),
    [anon_sym_await] = ACTIONS(70),
    [sym_comment] = ACTIONS(72),
  },
  [756] = {
    [sym_function_definition] = STATE(1157),
    [sym_class_definition] = STATE(1157),
    [sym_decorator] = STATE(187),
    [aux_sym_decorated_definition_repeat1] = STATE(187),
    [anon_sym_async] = ACTIONS(2410),
    [anon_sym_def] = ACTIONS(2412),
    [anon_sym_class] = ACTIONS(2414),
    [anon_sym_AT] = ACTIONS(50),
    [sym_comment] = ACTIONS(72),
  },
  [757] = {
    [ts_builtin_sym_end] = ACTIONS(576),
    [anon_sym_import] = ACTIONS(578),
    [anon_sym_from] = ACTIONS(578),
    [anon_sym_LPAREN] = ACTIONS(576),
    [anon_sym_print] = ACTIONS(578),
    [anon_sym_assert] = ACTIONS(578),
    [anon_sym_return] = ACTIONS(578),
    [anon_sym_del] = ACTIONS(578),
    [anon_sym_raise] = ACTIONS(578),
    [sym_pass_statement] = ACTIONS(578),
    [sym_break_statement] = ACTIONS(578),
    [sym_continue_statement] = ACTIONS(578),
    [anon_sym_if] = ACTIONS(578),
    [anon_sym_else] = ACTIONS(578),
    [anon_sym_async] = ACTIONS(578),
    [anon_sym_for] = ACTIONS(578),
    [anon_sym_while] = ACTIONS(578),
    [anon_sym_try] = ACTIONS(578),
    [anon_sym_except] = ACTIONS(578),
    [anon_sym_finally] = ACTIONS(578),
    [anon_sym_with] = ACTIONS(578),
    [anon_sym_def] = ACTIONS(578),
    [anon_sym_global] = ACTIONS(578),
    [anon_sym_nonlocal] = ACTIONS(578),
    [anon_sym_exec] = ACTIONS(578),
    [anon_sym_class] = ACTIONS(578),
    [anon_sym_AT] = ACTIONS(576),
    [anon_sym_not] = ACTIONS(578),
    [anon_sym_PLUS] = ACTIONS(576),
    [anon_sym_DASH] = ACTIONS(576),
    [anon_sym_TILDE] = ACTIONS(576),
    [anon_sym_lambda] = ACTIONS(578),
    [anon_sym_yield] = ACTIONS(578),
    [anon_sym_LBRACK] = ACTIONS(576),
    [sym_ellipsis] = ACTIONS(576),
    [anon_sym_LBRACE] = ACTIONS(576),
    [sym_string] = ACTIONS(576),
    [sym_integer] = ACTIONS(578),
    [sym_float] = ACTIONS(578),
    [sym_identifier] = ACTIONS(578),
    [sym_true] = ACTIONS(578),
    [sym_false] = ACTIONS(578),
    [sym_none] = ACTIONS(578),
    [anon_sym_await] = ACTIONS(578),
    [sym_comment] = ACTIONS(72),
  },
  [758] = {
    [sym_import_statement] = STATE(326),
    [sym_import_from_statement] = STATE(326),
    [sym_print_statement] = STATE(326),
    [sym_assert_statement] = STATE(326),
    [sym_expression_statement] = STATE(326),
    [sym_return_statement] = STATE(326),
    [sym_delete_statement] = STATE(326),
    [sym_raise_statement] = STATE(326),
    [sym_global_statement] = STATE(326),
    [sym_nonlocal_statement] = STATE(326),
    [sym_exec_statement] = STATE(326),
    [sym_expression_list] = STATE(32),
    [sym__expression] = STATE(33),
    [sym__primary_expression] = STATE(34),
    [sym_not_operator] = STATE(33),
    [sym_boolean_operator] = STATE(33),
    [sym_binary_operator] = STATE(34),
    [sym_unary_operator] = STATE(34),
    [sym_comparison_operator] = STATE(33),
    [sym_lambda] = STATE(33),
    [sym_assignment] = STATE(35),
    [sym_augmented_assignment] = STATE(35),
    [sym_yield] = STATE(35),
    [sym_attribute] = STATE(34),
    [sym_subscript] = STATE(34),
    [sym_call] = STATE(34),
    [sym_list] = STATE(34),
    [sym_list_comprehension] = STATE(34),
    [sym_dictionary] = STATE(34),
    [sym_dictionary_comprehension] = STATE(34),
    [sym_set] = STATE(34),
    [sym_set_comprehension] = STATE(34),
    [sym_parenthesized_expression] = STATE(34),
    [sym_tuple] = STATE(34),
    [sym_generator_expression] = STATE(34),
    [sym_conditional_expression] = STATE(33),
    [sym_concatenated_string] = STATE(34),
    [sym_await] = STATE(33),
    [sym__newline] = ACTIONS(2416),
    [anon_sym_import] = ACTIONS(10),
    [anon_sym_from] = ACTIONS(12),
    [anon_sym_LPAREN] = ACTIONS(14),
    [anon_sym_print] = ACTIONS(16),
    [anon_sym_assert] = ACTIONS(18),
    [anon_sym_return] = ACTIONS(20),
    [anon_sym_del] = ACTIONS(22),
    [anon_sym_raise] = ACTIONS(24),
    [sym_pass_statement] = ACTIONS(582),
    [sym_break_statement] = ACTIONS(582),
    [sym_continue_statement] = ACTIONS(582),
    [anon_sym_global] = ACTIONS(42),
    [anon_sym_nonlocal] = ACTIONS(44),
    [anon_sym_exec] = ACTIONS(46),
    [anon_sym_not] = ACTIONS(52),
    [anon_sym_PLUS] = ACTIONS(54),
    [anon_sym_DASH] = ACTIONS(54),
    [anon_sym_TILDE] = ACTIONS(54),
    [anon_sym_lambda] = ACTIONS(56),
    [anon_sym_yield] = ACTIONS(58),
    [anon_sym_LBRACK] = ACTIONS(60),
    [sym_ellipsis] = ACTIONS(62),
    [anon_sym_LBRACE] = ACTIONS(64),
    [sym_string] = ACTIONS(66),
    [sym_integer] = ACTIONS(68),
    [sym_float] = ACTIONS(68),
    [sym_identifier] = ACTIONS(68),
    [sym_true] = ACTIONS(68),
    [sym_false] = ACTIONS(68),
    [sym_none] = ACTIONS(68),
    [anon_sym_await] = ACTIONS(70),
    [sym_comment] = ACTIONS(72),
  },
  [759] = {
    [aux_sym__simple_statements_repeat1] = STATE(328),
    [sym__newline] = ACTIONS(2416),
    [sym_comment] = ACTIONS(72),
    [sym__semicolon] = ACTIONS(2418),
  },
  [760] = {
    [sym__expression] = STATE(1161),
    [sym__primary_expression] = STATE(113),
    [sym_not_operator] = STATE(1161),
    [sym_boolean_operator] = STATE(1161),
    [sym_binary_operator] = STATE(113),
    [sym_unary_operator] = STATE(113),
    [sym_comparison_operator] = STATE(1161),
    [sym_lambda] = STATE(1161),
    [sym_attribute] = STATE(113),
    [sym_subscript] = STATE(113),
    [sym_call] = STATE(113),
    [sym_list] = STATE(113),
    [sym_list_comprehension] = STATE(113),
    [sym_dictionary] = STATE(113),
    [sym_dictionary_comprehension] = STATE(113),
    [sym_set] = STATE(113),
    [sym_set_comprehension] = STATE(113),
    [sym_parenthesized_expression] = STATE(113),
    [sym_tuple] = STATE(113),
    [sym_generator_expression] = STATE(113),
    [sym_conditional_expression] = STATE(1161),
    [sym_concatenated_string] = STATE(113),
    [sym_await] = STATE(1161),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_COLON] = ACTIONS(2420),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_not] = ACTIONS(190),
    [anon_sym_PLUS] = ACTIONS(192),
    [anon_sym_DASH] = ACTIONS(192),
    [anon_sym_TILDE] = ACTIONS(192),
    [anon_sym_lambda] = ACTIONS(194),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(196),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(198),
    [sym_integer] = ACTIONS(200),
    [sym_float] = ACTIONS(200),
    [sym_identifier] = ACTIONS(200),
    [sym_true] = ACTIONS(200),
    [sym_false] = ACTIONS(200),
    [sym_none] = ACTIONS(200),
    [anon_sym_await] = ACTIONS(202),
    [sym_comment] = ACTIONS(72),
  },
  [761] = {
    [anon_sym_COLON] = ACTIONS(2422),
    [sym_comment] = ACTIONS(72),
  },
  [762] = {
    [ts_builtin_sym_end] = ACTIONS(2424),
    [anon_sym_import] = ACTIONS(2426),
    [anon_sym_from] = ACTIONS(2426),
    [anon_sym_LPAREN] = ACTIONS(2424),
    [anon_sym_print] = ACTIONS(2426),
    [anon_sym_assert] = ACTIONS(2426),
    [anon_sym_return] = ACTIONS(2426),
    [anon_sym_del] = ACTIONS(2426),
    [anon_sym_raise] = ACTIONS(2426),
    [sym_pass_statement] = ACTIONS(2426),
    [sym_break_statement] = ACTIONS(2426),
    [sym_continue_statement] = ACTIONS(2426),
    [anon_sym_if] = ACTIONS(2426),
    [anon_sym_async] = ACTIONS(2426),
    [anon_sym_for] = ACTIONS(2426),
    [anon_sym_while] = ACTIONS(2426),
    [anon_sym_try] = ACTIONS(2426),
    [anon_sym_with] = ACTIONS(2426),
    [anon_sym_def] = ACTIONS(2426),
    [anon_sym_global] = ACTIONS(2426),
    [anon_sym_nonlocal] = ACTIONS(2426),
    [anon_sym_exec] = ACTIONS(2426),
    [anon_sym_class] = ACTIONS(2426),
    [anon_sym_AT] = ACTIONS(2424),
    [anon_sym_not] = ACTIONS(2426),
    [anon_sym_PLUS] = ACTIONS(2424),
    [anon_sym_DASH] = ACTIONS(2424),
    [anon_sym_TILDE] = ACTIONS(2424),
    [anon_sym_lambda] = ACTIONS(2426),
    [anon_sym_yield] = ACTIONS(2426),
    [anon_sym_LBRACK] = ACTIONS(2424),
    [sym_ellipsis] = ACTIONS(2424),
    [anon_sym_LBRACE] = ACTIONS(2424),
    [sym_string] = ACTIONS(2424),
    [sym_integer] = ACTIONS(2426),
    [sym_float] = ACTIONS(2426),
    [sym_identifier] = ACTIONS(2426),
    [sym_true] = ACTIONS(2426),
    [sym_false] = ACTIONS(2426),
    [sym_none] = ACTIONS(2426),
    [anon_sym_await] = ACTIONS(2426),
    [sym_comment] = ACTIONS(72),
  },
  [763] = {
    [sym_else_clause] = STATE(1164),
    [sym_except_clause] = STATE(1166),
    [sym_finally_clause] = STATE(1165),
    [aux_sym_try_statement_repeat1] = STATE(1166),
    [ts_builtin_sym_end] = ACTIONS(2424),
    [anon_sym_import] = ACTIONS(2426),
    [anon_sym_from] = ACTIONS(2426),
    [anon_sym_LPAREN] = ACTIONS(2424),
    [anon_sym_print] = ACTIONS(2426),
    [anon_sym_assert] = ACTIONS(2426),
    [anon_sym_return] = ACTIONS(2426),
    [anon_sym_del] = ACTIONS(2426),
    [anon_sym_raise] = ACTIONS(2426),
    [sym_pass_statement] = ACTIONS(2426),
    [sym_break_statement] = ACTIONS(2426),
    [sym_continue_statement] = ACTIONS(2426),
    [anon_sym_if] = ACTIONS(2426),
    [anon_sym_else] = ACTIONS(2428),
    [anon_sym_async] = ACTIONS(2426),
    [anon_sym_for] = ACTIONS(2426),
    [anon_sym_while] = ACTIONS(2426),
    [anon_sym_try] = ACTIONS(2426),
    [anon_sym_except] = ACTIONS(2430),
    [anon_sym_finally] = ACTIONS(2432),
    [anon_sym_with] = ACTIONS(2426),
    [anon_sym_def] = ACTIONS(2426),
    [anon_sym_global] = ACTIONS(2426),
    [anon_sym_nonlocal] = ACTIONS(2426),
    [anon_sym_exec] = ACTIONS(2426),
    [anon_sym_class] = ACTIONS(2426),
    [anon_sym_AT] = ACTIONS(2424),
    [anon_sym_not] = ACTIONS(2426),
    [anon_sym_PLUS] = ACTIONS(2424),
    [anon_sym_DASH] = ACTIONS(2424),
    [anon_sym_TILDE] = ACTIONS(2424),
    [anon_sym_lambda] = ACTIONS(2426),
    [anon_sym_yield] = ACTIONS(2426),
    [anon_sym_LBRACK] = ACTIONS(2424),
    [sym_ellipsis] = ACTIONS(2424),
    [anon_sym_LBRACE] = ACTIONS(2424),
    [sym_string] = ACTIONS(2424),
    [sym_integer] = ACTIONS(2426),
    [sym_float] = ACTIONS(2426),
    [sym_identifier] = ACTIONS(2426),
    [sym_true] = ACTIONS(2426),
    [sym_false] = ACTIONS(2426),
    [sym_none] = ACTIONS(2426),
    [anon_sym_await] = ACTIONS(2426),
    [sym_comment] = ACTIONS(72),
  },
  [764] = {
    [anon_sym_COMMA] = ACTIONS(1644),
    [anon_sym_as] = ACTIONS(1644),
    [anon_sym_if] = ACTIONS(666),
    [anon_sym_COLON] = ACTIONS(1644),
    [anon_sym_and] = ACTIONS(668),
    [anon_sym_or] = ACTIONS(670),
    [sym_comment] = ACTIONS(72),
  },
  [765] = {
    [sym__expression] = STATE(1167),
    [sym__primary_expression] = STATE(113),
    [sym_not_operator] = STATE(1167),
    [sym_boolean_operator] = STATE(1167),
    [sym_binary_operator] = STATE(113),
    [sym_unary_operator] = STATE(113),
    [sym_comparison_operator] = STATE(1167),
    [sym_lambda] = STATE(1167),
    [sym_attribute] = STATE(113),
    [sym_subscript] = STATE(113),
    [sym_call] = STATE(113),
    [sym_list] = STATE(113),
    [sym_list_comprehension] = STATE(113),
    [sym_dictionary] = STATE(113),
    [sym_dictionary_comprehension] = STATE(113),
    [sym_set] = STATE(113),
    [sym_set_comprehension] = STATE(113),
    [sym_parenthesized_expression] = STATE(113),
    [sym_tuple] = STATE(113),
    [sym_generator_expression] = STATE(113),
    [sym_conditional_expression] = STATE(1167),
    [sym_concatenated_string] = STATE(113),
    [sym_await] = STATE(1167),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_not] = ACTIONS(190),
    [anon_sym_PLUS] = ACTIONS(192),
    [anon_sym_DASH] = ACTIONS(192),
    [anon_sym_TILDE] = ACTIONS(192),
    [anon_sym_lambda] = ACTIONS(194),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(196),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(198),
    [sym_integer] = ACTIONS(200),
    [sym_float] = ACTIONS(200),
    [sym_identifier] = ACTIONS(200),
    [sym_true] = ACTIONS(200),
    [sym_false] = ACTIONS(200),
    [sym_none] = ACTIONS(200),
    [anon_sym_await] = ACTIONS(202),
    [sym_comment] = ACTIONS(72),
  },
  [766] = {
    [aux_sym_concatenated_string_repeat1] = STATE(766),
    [anon_sym_DOT] = ACTIONS(1862),
    [anon_sym_LPAREN] = ACTIONS(1862),
    [anon_sym_COMMA] = ACTIONS(1862),
    [anon_sym_as] = ACTIONS(1862),
    [anon_sym_STAR] = ACTIONS(1864),
    [anon_sym_GT_GT] = ACTIONS(1862),
    [anon_sym_if] = ACTIONS(1862),
    [anon_sym_COLON] = ACTIONS(1862),
    [anon_sym_in] = ACTIONS(1862),
    [anon_sym_AT] = ACTIONS(1862),
    [anon_sym_not] = ACTIONS(1862),
    [anon_sym_and] = ACTIONS(1862),
    [anon_sym_or] = ACTIONS(1862),
    [anon_sym_PLUS] = ACTIONS(1862),
    [anon_sym_DASH] = ACTIONS(1862),
    [anon_sym_SLASH] = ACTIONS(1864),
    [anon_sym_PERCENT] = ACTIONS(1862),
    [anon_sym_SLASH_SLASH] = ACTIONS(1862),
    [anon_sym_STAR_STAR] = ACTIONS(1862),
    [anon_sym_PIPE] = ACTIONS(1862),
    [anon_sym_AMP] = ACTIONS(1862),
    [anon_sym_CARET] = ACTIONS(1862),
    [anon_sym_LT_LT] = ACTIONS(1862),
    [anon_sym_LT] = ACTIONS(1864),
    [anon_sym_LT_EQ] = ACTIONS(1862),
    [anon_sym_EQ_EQ] = ACTIONS(1862),
    [anon_sym_BANG_EQ] = ACTIONS(1862),
    [anon_sym_GT_EQ] = ACTIONS(1862),
    [anon_sym_GT] = ACTIONS(1864),
    [anon_sym_LT_GT] = ACTIONS(1862),
    [anon_sym_is] = ACTIONS(1862),
    [anon_sym_LBRACK] = ACTIONS(1862),
    [sym_string] = ACTIONS(2434),
    [sym_comment] = ACTIONS(72),
  },
  [767] = {
    [anon_sym_COMMA] = ACTIONS(2437),
    [anon_sym_COLON] = ACTIONS(2437),
    [sym_comment] = ACTIONS(72),
  },
  [768] = {
    [sym__statement] = STATE(1169),
    [sym__simple_statements] = STATE(1169),
    [sym_import_statement] = STATE(746),
    [sym_import_from_statement] = STATE(746),
    [sym_print_statement] = STATE(746),
    [sym_assert_statement] = STATE(746),
    [sym_expression_statement] = STATE(746),
    [sym_return_statement] = STATE(746),
    [sym_delete_statement] = STATE(746),
    [sym_raise_statement] = STATE(746),
    [sym_if_statement] = STATE(1169),
    [sym_for_statement] = STATE(1169),
    [sym_while_statement] = STATE(1169),
    [sym_try_statement] = STATE(1169),
    [sym_with_statement] = STATE(1169),
    [sym_function_definition] = STATE(1169),
    [sym_global_statement] = STATE(746),
    [sym_nonlocal_statement] = STATE(746),
    [sym_exec_statement] = STATE(746),
    [sym_class_definition] = STATE(1169),
    [sym_decorated_definition] = STATE(1169),
    [sym_decorator] = STATE(756),
    [sym_expression_list] = STATE(32),
    [sym__expression] = STATE(33),
    [sym__primary_expression] = STATE(34),
    [sym_not_operator] = STATE(33),
    [sym_boolean_operator] = STATE(33),
    [sym_binary_operator] = STATE(34),
    [sym_unary_operator] = STATE(34),
    [sym_comparison_operator] = STATE(33),
    [sym_lambda] = STATE(33),
    [sym_assignment] = STATE(35),
    [sym_augmented_assignment] = STATE(35),
    [sym_yield] = STATE(35),
    [sym_attribute] = STATE(34),
    [sym_subscript] = STATE(34),
    [sym_call] = STATE(34),
    [sym_list] = STATE(34),
    [sym_list_comprehension] = STATE(34),
    [sym_dictionary] = STATE(34),
    [sym_dictionary_comprehension] = STATE(34),
    [sym_set] = STATE(34),
    [sym_set_comprehension] = STATE(34),
    [sym_parenthesized_expression] = STATE(34),
    [sym_tuple] = STATE(34),
    [sym_generator_expression] = STATE(34),
    [sym_conditional_expression] = STATE(33),
    [sym_concatenated_string] = STATE(34),
    [sym_await] = STATE(33),
    [aux_sym_module_repeat1] = STATE(1169),
    [aux_sym_decorated_definition_repeat1] = STATE(756),
    [sym__dedent] = ACTIONS(2439),
    [anon_sym_import] = ACTIONS(10),
    [anon_sym_from] = ACTIONS(12),
    [anon_sym_LPAREN] = ACTIONS(14),
    [anon_sym_print] = ACTIONS(16),
    [anon_sym_assert] = ACTIONS(18),
    [anon_sym_return] = ACTIONS(20),
    [anon_sym_del] = ACTIONS(22),
    [anon_sym_raise] = ACTIONS(24),
    [sym_pass_statement] = ACTIONS(1498),
    [sym_break_statement] = ACTIONS(1498),
    [sym_continue_statement] = ACTIONS(1498),
    [anon_sym_if] = ACTIONS(1500),
    [anon_sym_async] = ACTIONS(1502),
    [anon_sym_for] = ACTIONS(1504),
    [anon_sym_while] = ACTIONS(1506),
    [anon_sym_try] = ACTIONS(1508),
    [anon_sym_with] = ACTIONS(1510),
    [anon_sym_def] = ACTIONS(1512),
    [anon_sym_global] = ACTIONS(42),
    [anon_sym_nonlocal] = ACTIONS(44),
    [anon_sym_exec] = ACTIONS(46),
    [anon_sym_class] = ACTIONS(1514),
    [anon_sym_AT] = ACTIONS(50),
    [anon_sym_not] = ACTIONS(52),
    [anon_sym_PLUS] = ACTIONS(54),
    [anon_sym_DASH] = ACTIONS(54),
    [anon_sym_TILDE] = ACTIONS(54),
    [anon_sym_lambda] = ACTIONS(56),
    [anon_sym_yield] = ACTIONS(58),
    [anon_sym_LBRACK] = ACTIONS(60),
    [sym_ellipsis] = ACTIONS(62),
    [anon_sym_LBRACE] = ACTIONS(64),
    [sym_string] = ACTIONS(66),
    [sym_integer] = ACTIONS(68),
    [sym_float] = ACTIONS(68),
    [sym_identifier] = ACTIONS(68),
    [sym_true] = ACTIONS(68),
    [sym_false] = ACTIONS(68),
    [sym_none] = ACTIONS(68),
    [anon_sym_await] = ACTIONS(70),
    [sym_comment] = ACTIONS(72),
  },
  [769] = {
    [ts_builtin_sym_end] = ACTIONS(2441),
    [anon_sym_import] = ACTIONS(2443),
    [anon_sym_from] = ACTIONS(2443),
    [anon_sym_LPAREN] = ACTIONS(2441),
    [anon_sym_print] = ACTIONS(2443),
    [anon_sym_assert] = ACTIONS(2443),
    [anon_sym_return] = ACTIONS(2443),
    [anon_sym_del] = ACTIONS(2443),
    [anon_sym_raise] = ACTIONS(2443),
    [sym_pass_statement] = ACTIONS(2443),
    [sym_break_statement] = ACTIONS(2443),
    [sym_continue_statement] = ACTIONS(2443),
    [anon_sym_if] = ACTIONS(2443),
    [anon_sym_async] = ACTIONS(2443),
    [anon_sym_for] = ACTIONS(2443),
    [anon_sym_while] = ACTIONS(2443),
    [anon_sym_try] = ACTIONS(2443),
    [anon_sym_with] = ACTIONS(2443),
    [anon_sym_def] = ACTIONS(2443),
    [anon_sym_global] = ACTIONS(2443),
    [anon_sym_nonlocal] = ACTIONS(2443),
    [anon_sym_exec] = ACTIONS(2443),
    [anon_sym_class] = ACTIONS(2443),
    [anon_sym_AT] = ACTIONS(2441),
    [anon_sym_not] = ACTIONS(2443),
    [anon_sym_PLUS] = ACTIONS(2441),
    [anon_sym_DASH] = ACTIONS(2441),
    [anon_sym_TILDE] = ACTIONS(2441),
    [anon_sym_lambda] = ACTIONS(2443),
    [anon_sym_yield] = ACTIONS(2443),
    [anon_sym_LBRACK] = ACTIONS(2441),
    [sym_ellipsis] = ACTIONS(2441),
    [anon_sym_LBRACE] = ACTIONS(2441),
    [sym_string] = ACTIONS(2441),
    [sym_integer] = ACTIONS(2443),
    [sym_float] = ACTIONS(2443),
    [sym_identifier] = ACTIONS(2443),
    [sym_true] = ACTIONS(2443),
    [sym_false] = ACTIONS(2443),
    [sym_none] = ACTIONS(2443),
    [anon_sym_await] = ACTIONS(2443),
    [sym_comment] = ACTIONS(72),
  },
  [770] = {
    [aux_sym_with_statement_repeat1] = STATE(770),
    [anon_sym_COMMA] = ACTIONS(2445),
    [anon_sym_COLON] = ACTIONS(2437),
    [sym_comment] = ACTIONS(72),
  },
  [771] = {
    [anon_sym_COMMA] = ACTIONS(2448),
    [anon_sym_if] = ACTIONS(1592),
    [anon_sym_COLON] = ACTIONS(2448),
    [anon_sym_and] = ACTIONS(1594),
    [anon_sym_or] = ACTIONS(1596),
    [sym_comment] = ACTIONS(72),
  },
  [772] = {
    [anon_sym_if] = ACTIONS(1921),
    [anon_sym_else] = ACTIONS(2450),
    [anon_sym_and] = ACTIONS(1925),
    [anon_sym_or] = ACTIONS(1927),
    [sym_comment] = ACTIONS(72),
  },
  [773] = {
    [anon_sym_COMMA] = ACTIONS(1953),
    [anon_sym_as] = ACTIONS(1953),
    [anon_sym_if] = ACTIONS(1953),
    [anon_sym_COLON] = ACTIONS(1953),
    [anon_sym_and] = ACTIONS(668),
    [anon_sym_or] = ACTIONS(1953),
    [sym_comment] = ACTIONS(72),
  },
  [774] = {
    [sym_argument_list] = STATE(251),
    [sym_generator_expression] = STATE(251),
    [anon_sym_DOT] = ACTIONS(1980),
    [anon_sym_LPAREN] = ACTIONS(424),
    [anon_sym_COMMA] = ACTIONS(1980),
    [anon_sym_as] = ACTIONS(1980),
    [anon_sym_STAR] = ACTIONS(1982),
    [anon_sym_GT_GT] = ACTIONS(1980),
    [anon_sym_if] = ACTIONS(1980),
    [anon_sym_COLON] = ACTIONS(1980),
    [anon_sym_in] = ACTIONS(1980),
    [anon_sym_AT] = ACTIONS(1980),
    [anon_sym_not] = ACTIONS(1980),
    [anon_sym_and] = ACTIONS(1980),
    [anon_sym_or] = ACTIONS(1980),
    [anon_sym_PLUS] = ACTIONS(1980),
    [anon_sym_DASH] = ACTIONS(1980),
    [anon_sym_SLASH] = ACTIONS(1982),
    [anon_sym_PERCENT] = ACTIONS(1980),
    [anon_sym_SLASH_SLASH] = ACTIONS(1980),
    [anon_sym_STAR_STAR] = ACTIONS(684),
    [anon_sym_PIPE] = ACTIONS(1980),
    [anon_sym_AMP] = ACTIONS(1980),
    [anon_sym_CARET] = ACTIONS(1980),
    [anon_sym_LT_LT] = ACTIONS(1980),
    [anon_sym_LT] = ACTIONS(1982),
    [anon_sym_LT_EQ] = ACTIONS(1980),
    [anon_sym_EQ_EQ] = ACTIONS(1980),
    [anon_sym_BANG_EQ] = ACTIONS(1980),
    [anon_sym_GT_EQ] = ACTIONS(1980),
    [anon_sym_GT] = ACTIONS(1982),
    [anon_sym_LT_GT] = ACTIONS(1980),
    [anon_sym_is] = ACTIONS(1980),
    [anon_sym_LBRACK] = ACTIONS(1980),
    [sym_comment] = ACTIONS(72),
  },
  [775] = {
    [sym_argument_list] = STATE(251),
    [sym_generator_expression] = STATE(251),
    [anon_sym_DOT] = ACTIONS(1980),
    [anon_sym_LPAREN] = ACTIONS(424),
    [anon_sym_COMMA] = ACTIONS(1980),
    [anon_sym_as] = ACTIONS(1980),
    [anon_sym_STAR] = ACTIONS(672),
    [anon_sym_GT_GT] = ACTIONS(1980),
    [anon_sym_if] = ACTIONS(1980),
    [anon_sym_COLON] = ACTIONS(1980),
    [anon_sym_in] = ACTIONS(1980),
    [anon_sym_AT] = ACTIONS(678),
    [anon_sym_not] = ACTIONS(1980),
    [anon_sym_and] = ACTIONS(1980),
    [anon_sym_or] = ACTIONS(1980),
    [anon_sym_PLUS] = ACTIONS(682),
    [anon_sym_DASH] = ACTIONS(682),
    [anon_sym_SLASH] = ACTIONS(672),
    [anon_sym_PERCENT] = ACTIONS(678),
    [anon_sym_SLASH_SLASH] = ACTIONS(678),
    [anon_sym_STAR_STAR] = ACTIONS(684),
    [anon_sym_PIPE] = ACTIONS(1980),
    [anon_sym_AMP] = ACTIONS(1980),
    [anon_sym_CARET] = ACTIONS(1980),
    [anon_sym_LT_LT] = ACTIONS(1980),
    [anon_sym_LT] = ACTIONS(1982),
    [anon_sym_LT_EQ] = ACTIONS(1980),
    [anon_sym_EQ_EQ] = ACTIONS(1980),
    [anon_sym_BANG_EQ] = ACTIONS(1980),
    [anon_sym_GT_EQ] = ACTIONS(1980),
    [anon_sym_GT] = ACTIONS(1982),
    [anon_sym_LT_GT] = ACTIONS(1980),
    [anon_sym_is] = ACTIONS(1980),
    [anon_sym_LBRACK] = ACTIONS(1980),
    [sym_comment] = ACTIONS(72),
  },
  [776] = {
    [sym_argument_list] = STATE(251),
    [sym_generator_expression] = STATE(251),
    [anon_sym_DOT] = ACTIONS(422),
    [anon_sym_LPAREN] = ACTIONS(424),
    [anon_sym_COMMA] = ACTIONS(1984),
    [anon_sym_as] = ACTIONS(1984),
    [anon_sym_STAR] = ACTIONS(672),
    [anon_sym_GT_GT] = ACTIONS(674),
    [anon_sym_if] = ACTIONS(1984),
    [anon_sym_COLON] = ACTIONS(1984),
    [anon_sym_in] = ACTIONS(1984),
    [anon_sym_AT] = ACTIONS(678),
    [anon_sym_not] = ACTIONS(1984),
    [anon_sym_and] = ACTIONS(1984),
    [anon_sym_or] = ACTIONS(1984),
    [anon_sym_PLUS] = ACTIONS(682),
    [anon_sym_DASH] = ACTIONS(682),
    [anon_sym_SLASH] = ACTIONS(672),
    [anon_sym_PERCENT] = ACTIONS(678),
    [anon_sym_SLASH_SLASH] = ACTIONS(678),
    [anon_sym_STAR_STAR] = ACTIONS(684),
    [anon_sym_PIPE] = ACTIONS(686),
    [anon_sym_AMP] = ACTIONS(688),
    [anon_sym_CARET] = ACTIONS(690),
    [anon_sym_LT_LT] = ACTIONS(674),
    [anon_sym_LT] = ACTIONS(1986),
    [anon_sym_LT_EQ] = ACTIONS(1984),
    [anon_sym_EQ_EQ] = ACTIONS(1984),
    [anon_sym_BANG_EQ] = ACTIONS(1984),
    [anon_sym_GT_EQ] = ACTIONS(1984),
    [anon_sym_GT] = ACTIONS(1986),
    [anon_sym_LT_GT] = ACTIONS(1984),
    [anon_sym_is] = ACTIONS(1984),
    [anon_sym_LBRACK] = ACTIONS(450),
    [sym_comment] = ACTIONS(72),
  },
  [777] = {
    [sym__primary_expression] = STATE(1171),
    [sym_binary_operator] = STATE(1171),
    [sym_unary_operator] = STATE(1171),
    [sym_attribute] = STATE(1171),
    [sym_subscript] = STATE(1171),
    [sym_call] = STATE(1171),
    [sym_list] = STATE(1171),
    [sym_list_comprehension] = STATE(1171),
    [sym_dictionary] = STATE(1171),
    [sym_dictionary_comprehension] = STATE(1171),
    [sym_set] = STATE(1171),
    [sym_set_comprehension] = STATE(1171),
    [sym_parenthesized_expression] = STATE(1171),
    [sym_tuple] = STATE(1171),
    [sym_generator_expression] = STATE(1171),
    [sym_concatenated_string] = STATE(1171),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_PLUS] = ACTIONS(192),
    [anon_sym_DASH] = ACTIONS(192),
    [anon_sym_TILDE] = ACTIONS(192),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(2452),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(198),
    [sym_integer] = ACTIONS(2454),
    [sym_float] = ACTIONS(2454),
    [sym_identifier] = ACTIONS(2454),
    [sym_true] = ACTIONS(2454),
    [sym_false] = ACTIONS(2454),
    [sym_none] = ACTIONS(2454),
    [sym_comment] = ACTIONS(72),
  },
  [778] = {
    [sym_argument_list] = STATE(251),
    [sym_generator_expression] = STATE(251),
    [anon_sym_DOT] = ACTIONS(1980),
    [anon_sym_LPAREN] = ACTIONS(424),
    [anon_sym_COMMA] = ACTIONS(1980),
    [anon_sym_as] = ACTIONS(1980),
    [anon_sym_STAR] = ACTIONS(672),
    [anon_sym_GT_GT] = ACTIONS(1980),
    [anon_sym_if] = ACTIONS(1980),
    [anon_sym_COLON] = ACTIONS(1980),
    [anon_sym_in] = ACTIONS(1980),
    [anon_sym_AT] = ACTIONS(678),
    [anon_sym_not] = ACTIONS(1980),
    [anon_sym_and] = ACTIONS(1980),
    [anon_sym_or] = ACTIONS(1980),
    [anon_sym_PLUS] = ACTIONS(1980),
    [anon_sym_DASH] = ACTIONS(1980),
    [anon_sym_SLASH] = ACTIONS(672),
    [anon_sym_PERCENT] = ACTIONS(678),
    [anon_sym_SLASH_SLASH] = ACTIONS(678),
    [anon_sym_STAR_STAR] = ACTIONS(684),
    [anon_sym_PIPE] = ACTIONS(1980),
    [anon_sym_AMP] = ACTIONS(1980),
    [anon_sym_CARET] = ACTIONS(1980),
    [anon_sym_LT_LT] = ACTIONS(1980),
    [anon_sym_LT] = ACTIONS(1982),
    [anon_sym_LT_EQ] = ACTIONS(1980),
    [anon_sym_EQ_EQ] = ACTIONS(1980),
    [anon_sym_BANG_EQ] = ACTIONS(1980),
    [anon_sym_GT_EQ] = ACTIONS(1980),
    [anon_sym_GT] = ACTIONS(1982),
    [anon_sym_LT_GT] = ACTIONS(1980),
    [anon_sym_is] = ACTIONS(1980),
    [anon_sym_LBRACK] = ACTIONS(1980),
    [sym_comment] = ACTIONS(72),
  },
  [779] = {
    [sym_argument_list] = STATE(251),
    [sym_generator_expression] = STATE(251),
    [anon_sym_DOT] = ACTIONS(1980),
    [anon_sym_LPAREN] = ACTIONS(424),
    [anon_sym_COMMA] = ACTIONS(1980),
    [anon_sym_as] = ACTIONS(1980),
    [anon_sym_STAR] = ACTIONS(672),
    [anon_sym_GT_GT] = ACTIONS(674),
    [anon_sym_if] = ACTIONS(1980),
    [anon_sym_COLON] = ACTIONS(1980),
    [anon_sym_in] = ACTIONS(1980),
    [anon_sym_AT] = ACTIONS(678),
    [anon_sym_not] = ACTIONS(1980),
    [anon_sym_and] = ACTIONS(1980),
    [anon_sym_or] = ACTIONS(1980),
    [anon_sym_PLUS] = ACTIONS(682),
    [anon_sym_DASH] = ACTIONS(682),
    [anon_sym_SLASH] = ACTIONS(672),
    [anon_sym_PERCENT] = ACTIONS(678),
    [anon_sym_SLASH_SLASH] = ACTIONS(678),
    [anon_sym_STAR_STAR] = ACTIONS(684),
    [anon_sym_PIPE] = ACTIONS(1980),
    [anon_sym_AMP] = ACTIONS(688),
    [anon_sym_CARET] = ACTIONS(690),
    [anon_sym_LT_LT] = ACTIONS(674),
    [anon_sym_LT] = ACTIONS(1982),
    [anon_sym_LT_EQ] = ACTIONS(1980),
    [anon_sym_EQ_EQ] = ACTIONS(1980),
    [anon_sym_BANG_EQ] = ACTIONS(1980),
    [anon_sym_GT_EQ] = ACTIONS(1980),
    [anon_sym_GT] = ACTIONS(1982),
    [anon_sym_LT_GT] = ACTIONS(1980),
    [anon_sym_is] = ACTIONS(1980),
    [anon_sym_LBRACK] = ACTIONS(1980),
    [sym_comment] = ACTIONS(72),
  },
  [780] = {
    [sym_argument_list] = STATE(251),
    [sym_generator_expression] = STATE(251),
    [anon_sym_DOT] = ACTIONS(1980),
    [anon_sym_LPAREN] = ACTIONS(424),
    [anon_sym_COMMA] = ACTIONS(1980),
    [anon_sym_as] = ACTIONS(1980),
    [anon_sym_STAR] = ACTIONS(672),
    [anon_sym_GT_GT] = ACTIONS(674),
    [anon_sym_if] = ACTIONS(1980),
    [anon_sym_COLON] = ACTIONS(1980),
    [anon_sym_in] = ACTIONS(1980),
    [anon_sym_AT] = ACTIONS(678),
    [anon_sym_not] = ACTIONS(1980),
    [anon_sym_and] = ACTIONS(1980),
    [anon_sym_or] = ACTIONS(1980),
    [anon_sym_PLUS] = ACTIONS(682),
    [anon_sym_DASH] = ACTIONS(682),
    [anon_sym_SLASH] = ACTIONS(672),
    [anon_sym_PERCENT] = ACTIONS(678),
    [anon_sym_SLASH_SLASH] = ACTIONS(678),
    [anon_sym_STAR_STAR] = ACTIONS(684),
    [anon_sym_PIPE] = ACTIONS(1980),
    [anon_sym_AMP] = ACTIONS(1980),
    [anon_sym_CARET] = ACTIONS(690),
    [anon_sym_LT_LT] = ACTIONS(674),
    [anon_sym_LT] = ACTIONS(1982),
    [anon_sym_LT_EQ] = ACTIONS(1980),
    [anon_sym_EQ_EQ] = ACTIONS(1980),
    [anon_sym_BANG_EQ] = ACTIONS(1980),
    [anon_sym_GT_EQ] = ACTIONS(1980),
    [anon_sym_GT] = ACTIONS(1982),
    [anon_sym_LT_GT] = ACTIONS(1980),
    [anon_sym_is] = ACTIONS(1980),
    [anon_sym_LBRACK] = ACTIONS(1980),
    [sym_comment] = ACTIONS(72),
  },
  [781] = {
    [sym_argument_list] = STATE(251),
    [sym_generator_expression] = STATE(251),
    [anon_sym_DOT] = ACTIONS(1980),
    [anon_sym_LPAREN] = ACTIONS(424),
    [anon_sym_COMMA] = ACTIONS(1980),
    [anon_sym_as] = ACTIONS(1980),
    [anon_sym_STAR] = ACTIONS(672),
    [anon_sym_GT_GT] = ACTIONS(674),
    [anon_sym_if] = ACTIONS(1980),
    [anon_sym_COLON] = ACTIONS(1980),
    [anon_sym_in] = ACTIONS(1980),
    [anon_sym_AT] = ACTIONS(678),
    [anon_sym_not] = ACTIONS(1980),
    [anon_sym_and] = ACTIONS(1980),
    [anon_sym_or] = ACTIONS(1980),
    [anon_sym_PLUS] = ACTIONS(682),
    [anon_sym_DASH] = ACTIONS(682),
    [anon_sym_SLASH] = ACTIONS(672),
    [anon_sym_PERCENT] = ACTIONS(678),
    [anon_sym_SLASH_SLASH] = ACTIONS(678),
    [anon_sym_STAR_STAR] = ACTIONS(684),
    [anon_sym_PIPE] = ACTIONS(1980),
    [anon_sym_AMP] = ACTIONS(1980),
    [anon_sym_CARET] = ACTIONS(1980),
    [anon_sym_LT_LT] = ACTIONS(674),
    [anon_sym_LT] = ACTIONS(1982),
    [anon_sym_LT_EQ] = ACTIONS(1980),
    [anon_sym_EQ_EQ] = ACTIONS(1980),
    [anon_sym_BANG_EQ] = ACTIONS(1980),
    [anon_sym_GT_EQ] = ACTIONS(1980),
    [anon_sym_GT] = ACTIONS(1982),
    [anon_sym_LT_GT] = ACTIONS(1980),
    [anon_sym_is] = ACTIONS(1980),
    [anon_sym_LBRACK] = ACTIONS(1980),
    [sym_comment] = ACTIONS(72),
  },
  [782] = {
    [aux_sym_comparison_operator_repeat1] = STATE(782),
    [anon_sym_COMMA] = ACTIONS(1984),
    [anon_sym_as] = ACTIONS(1984),
    [anon_sym_if] = ACTIONS(1984),
    [anon_sym_COLON] = ACTIONS(1984),
    [anon_sym_in] = ACTIONS(2456),
    [anon_sym_not] = ACTIONS(2459),
    [anon_sym_and] = ACTIONS(1984),
    [anon_sym_or] = ACTIONS(1984),
    [anon_sym_LT] = ACTIONS(2462),
    [anon_sym_LT_EQ] = ACTIONS(2456),
    [anon_sym_EQ_EQ] = ACTIONS(2456),
    [anon_sym_BANG_EQ] = ACTIONS(2456),
    [anon_sym_GT_EQ] = ACTIONS(2456),
    [anon_sym_GT] = ACTIONS(2462),
    [anon_sym_LT_GT] = ACTIONS(2456),
    [anon_sym_is] = ACTIONS(2465),
    [sym_comment] = ACTIONS(72),
  },
  [783] = {
    [anon_sym_COLON] = ACTIONS(2468),
    [anon_sym_DASH_GT] = ACTIONS(2468),
    [sym_comment] = ACTIONS(72),
  },
  [784] = {
    [sym__expression] = STATE(1178),
    [sym__primary_expression] = STATE(1179),
    [sym_not_operator] = STATE(1178),
    [sym_boolean_operator] = STATE(1178),
    [sym_binary_operator] = STATE(1179),
    [sym_unary_operator] = STATE(1179),
    [sym_comparison_operator] = STATE(1178),
    [sym_lambda] = STATE(1178),
    [sym_attribute] = STATE(1179),
    [sym_subscript] = STATE(1179),
    [sym_call] = STATE(1179),
    [sym_list] = STATE(1179),
    [sym_list_comprehension] = STATE(1179),
    [sym_dictionary] = STATE(1179),
    [sym_dictionary_comprehension] = STATE(1179),
    [sym_set] = STATE(1179),
    [sym_set_comprehension] = STATE(1179),
    [sym_parenthesized_expression] = STATE(1179),
    [sym_tuple] = STATE(1179),
    [sym_generator_expression] = STATE(1179),
    [sym_conditional_expression] = STATE(1178),
    [sym_concatenated_string] = STATE(1179),
    [sym_await] = STATE(1178),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_RPAREN] = ACTIONS(722),
    [anon_sym_COMMA] = ACTIONS(722),
    [anon_sym_STAR] = ACTIONS(2470),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_COLON] = ACTIONS(722),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_not] = ACTIONS(2472),
    [anon_sym_PLUS] = ACTIONS(2474),
    [anon_sym_DASH] = ACTIONS(2474),
    [anon_sym_TILDE] = ACTIONS(2474),
    [anon_sym_lambda] = ACTIONS(2476),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(2478),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(2480),
    [sym_integer] = ACTIONS(2482),
    [sym_float] = ACTIONS(2482),
    [sym_identifier] = ACTIONS(2482),
    [sym_true] = ACTIONS(2482),
    [sym_false] = ACTIONS(2482),
    [sym_none] = ACTIONS(2482),
    [anon_sym_await] = ACTIONS(2484),
    [sym_comment] = ACTIONS(72),
  },
  [785] = {
    [aux_sym__parameters_repeat1] = STATE(1183),
    [anon_sym_RPAREN] = ACTIONS(742),
    [anon_sym_COMMA] = ACTIONS(2486),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_EQ] = ACTIONS(2490),
    [sym_comment] = ACTIONS(72),
  },
  [786] = {
    [aux_sym__parameters_repeat1] = STATE(1187),
    [anon_sym_RPAREN] = ACTIONS(748),
    [anon_sym_COMMA] = ACTIONS(2492),
    [anon_sym_COLON] = ACTIONS(2494),
    [anon_sym_EQ] = ACTIONS(2496),
    [sym_comment] = ACTIONS(72),
  },
  [787] = {
    [anon_sym_RPAREN] = ACTIONS(2498),
    [sym_comment] = ACTIONS(72),
  },
  [788] = {
    [aux_sym__parameters_repeat1] = STATE(1187),
    [anon_sym_RPAREN] = ACTIONS(748),
    [anon_sym_COMMA] = ACTIONS(2492),
    [sym_comment] = ACTIONS(72),
  },
  [789] = {
    [aux_sym__parameters_repeat1] = STATE(1187),
    [anon_sym_RPAREN] = ACTIONS(748),
    [anon_sym_COMMA] = ACTIONS(2492),
    [anon_sym_COLON] = ACTIONS(2500),
    [sym_comment] = ACTIONS(72),
  },
  [790] = {
    [sym__simple_statements] = STATE(1190),
    [sym_import_statement] = STATE(10),
    [sym_import_from_statement] = STATE(10),
    [sym_print_statement] = STATE(10),
    [sym_assert_statement] = STATE(10),
    [sym_expression_statement] = STATE(10),
    [sym_return_statement] = STATE(10),
    [sym_delete_statement] = STATE(10),
    [sym_raise_statement] = STATE(10),
    [sym_global_statement] = STATE(10),
    [sym_nonlocal_statement] = STATE(10),
    [sym_exec_statement] = STATE(10),
    [sym__suite] = STATE(1190),
    [sym_expression_list] = STATE(32),
    [sym__expression] = STATE(33),
    [sym__primary_expression] = STATE(34),
    [sym_not_operator] = STATE(33),
    [sym_boolean_operator] = STATE(33),
    [sym_binary_operator] = STATE(34),
    [sym_unary_operator] = STATE(34),
    [sym_comparison_operator] = STATE(33),
    [sym_lambda] = STATE(33),
    [sym_assignment] = STATE(35),
    [sym_augmented_assignment] = STATE(35),
    [sym_yield] = STATE(35),
    [sym_attribute] = STATE(34),
    [sym_subscript] = STATE(34),
    [sym_call] = STATE(34),
    [sym_list] = STATE(34),
    [sym_list_comprehension] = STATE(34),
    [sym_dictionary] = STATE(34),
    [sym_dictionary_comprehension] = STATE(34),
    [sym_set] = STATE(34),
    [sym_set_comprehension] = STATE(34),
    [sym_parenthesized_expression] = STATE(34),
    [sym_tuple] = STATE(34),
    [sym_generator_expression] = STATE(34),
    [sym_conditional_expression] = STATE(33),
    [sym_concatenated_string] = STATE(34),
    [sym_await] = STATE(33),
    [sym__indent] = ACTIONS(1528),
    [anon_sym_import] = ACTIONS(10),
    [anon_sym_from] = ACTIONS(12),
    [anon_sym_LPAREN] = ACTIONS(14),
    [anon_sym_print] = ACTIONS(16),
    [anon_sym_assert] = ACTIONS(18),
    [anon_sym_return] = ACTIONS(20),
    [anon_sym_del] = ACTIONS(22),
    [anon_sym_raise] = ACTIONS(24),
    [sym_pass_statement] = ACTIONS(26),
    [sym_break_statement] = ACTIONS(26),
    [sym_continue_statement] = ACTIONS(26),
    [anon_sym_global] = ACTIONS(42),
    [anon_sym_nonlocal] = ACTIONS(44),
    [anon_sym_exec] = ACTIONS(46),
    [anon_sym_not] = ACTIONS(52),
    [anon_sym_PLUS] = ACTIONS(54),
    [anon_sym_DASH] = ACTIONS(54),
    [anon_sym_TILDE] = ACTIONS(54),
    [anon_sym_lambda] = ACTIONS(56),
    [anon_sym_yield] = ACTIONS(58),
    [anon_sym_LBRACK] = ACTIONS(60),
    [sym_ellipsis] = ACTIONS(62),
    [anon_sym_LBRACE] = ACTIONS(64),
    [sym_string] = ACTIONS(66),
    [sym_integer] = ACTIONS(68),
    [sym_float] = ACTIONS(68),
    [sym_identifier] = ACTIONS(68),
    [sym_true] = ACTIONS(68),
    [sym_false] = ACTIONS(68),
    [sym_none] = ACTIONS(68),
    [anon_sym_await] = ACTIONS(70),
    [sym_comment] = ACTIONS(72),
  },
  [791] = {
    [sym__expression] = STATE(1191),
    [sym__primary_expression] = STATE(96),
    [sym_not_operator] = STATE(1191),
    [sym_boolean_operator] = STATE(1191),
    [sym_binary_operator] = STATE(96),
    [sym_unary_operator] = STATE(96),
    [sym_comparison_operator] = STATE(1191),
    [sym_lambda] = STATE(1191),
    [sym_attribute] = STATE(96),
    [sym_subscript] = STATE(96),
    [sym_call] = STATE(96),
    [sym_type] = STATE(1192),
    [sym_list] = STATE(96),
    [sym_list_comprehension] = STATE(96),
    [sym_dictionary] = STATE(96),
    [sym_dictionary_comprehension] = STATE(96),
    [sym_set] = STATE(96),
    [sym_set_comprehension] = STATE(96),
    [sym_parenthesized_expression] = STATE(96),
    [sym_tuple] = STATE(96),
    [sym_generator_expression] = STATE(96),
    [sym_conditional_expression] = STATE(1191),
    [sym_concatenated_string] = STATE(96),
    [sym_await] = STATE(1191),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_not] = ACTIONS(160),
    [anon_sym_PLUS] = ACTIONS(162),
    [anon_sym_DASH] = ACTIONS(162),
    [anon_sym_TILDE] = ACTIONS(162),
    [anon_sym_lambda] = ACTIONS(164),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(166),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(168),
    [sym_integer] = ACTIONS(170),
    [sym_float] = ACTIONS(170),
    [sym_identifier] = ACTIONS(170),
    [sym_true] = ACTIONS(170),
    [sym_false] = ACTIONS(170),
    [sym_none] = ACTIONS(170),
    [anon_sym_await] = ACTIONS(172),
    [sym_comment] = ACTIONS(72),
  },
  [792] = {
    [sym__newline] = ACTIONS(2502),
    [anon_sym_COMMA] = ACTIONS(2502),
    [sym_comment] = ACTIONS(72),
    [sym__semicolon] = ACTIONS(2502),
  },
  [793] = {
    [aux_sym_global_statement_repeat1] = STATE(793),
    [sym__newline] = ACTIONS(2502),
    [anon_sym_COMMA] = ACTIONS(2504),
    [sym_comment] = ACTIONS(72),
    [sym__semicolon] = ACTIONS(2502),
  },
  [794] = {
    [aux_sym_print_statement_repeat1] = STATE(1193),
    [sym__newline] = ACTIONS(2507),
    [anon_sym_COMMA] = ACTIONS(514),
    [anon_sym_if] = ACTIONS(476),
    [anon_sym_and] = ACTIONS(478),
    [anon_sym_or] = ACTIONS(480),
    [sym_comment] = ACTIONS(72),
    [sym__semicolon] = ACTIONS(2507),
  },
  [795] = {
    [aux_sym_argument_list_repeat1] = STATE(1070),
    [anon_sym_RPAREN] = ACTIONS(2173),
    [anon_sym_COMMA] = ACTIONS(2175),
    [anon_sym_if] = ACTIONS(1147),
    [anon_sym_and] = ACTIONS(1149),
    [anon_sym_or] = ACTIONS(1151),
    [sym_comment] = ACTIONS(72),
  },
  [796] = {
    [ts_builtin_sym_end] = ACTIONS(2509),
    [anon_sym_import] = ACTIONS(2511),
    [anon_sym_from] = ACTIONS(2511),
    [anon_sym_LPAREN] = ACTIONS(2509),
    [anon_sym_print] = ACTIONS(2511),
    [anon_sym_assert] = ACTIONS(2511),
    [anon_sym_return] = ACTIONS(2511),
    [anon_sym_del] = ACTIONS(2511),
    [anon_sym_raise] = ACTIONS(2511),
    [sym_pass_statement] = ACTIONS(2511),
    [sym_break_statement] = ACTIONS(2511),
    [sym_continue_statement] = ACTIONS(2511),
    [anon_sym_if] = ACTIONS(2511),
    [anon_sym_async] = ACTIONS(2511),
    [anon_sym_for] = ACTIONS(2511),
    [anon_sym_while] = ACTIONS(2511),
    [anon_sym_try] = ACTIONS(2511),
    [anon_sym_with] = ACTIONS(2511),
    [anon_sym_def] = ACTIONS(2511),
    [anon_sym_global] = ACTIONS(2511),
    [anon_sym_nonlocal] = ACTIONS(2511),
    [anon_sym_exec] = ACTIONS(2511),
    [anon_sym_class] = ACTIONS(2511),
    [anon_sym_AT] = ACTIONS(2509),
    [anon_sym_not] = ACTIONS(2511),
    [anon_sym_PLUS] = ACTIONS(2509),
    [anon_sym_DASH] = ACTIONS(2509),
    [anon_sym_TILDE] = ACTIONS(2509),
    [anon_sym_lambda] = ACTIONS(2511),
    [anon_sym_yield] = ACTIONS(2511),
    [anon_sym_LBRACK] = ACTIONS(2509),
    [sym_ellipsis] = ACTIONS(2509),
    [anon_sym_LBRACE] = ACTIONS(2509),
    [sym_string] = ACTIONS(2509),
    [sym_integer] = ACTIONS(2511),
    [sym_float] = ACTIONS(2511),
    [sym_identifier] = ACTIONS(2511),
    [sym_true] = ACTIONS(2511),
    [sym_false] = ACTIONS(2511),
    [sym_none] = ACTIONS(2511),
    [anon_sym_await] = ACTIONS(2511),
    [sym_comment] = ACTIONS(72),
  },
  [797] = {
    [sym__simple_statements] = STATE(1194),
    [sym_import_statement] = STATE(10),
    [sym_import_from_statement] = STATE(10),
    [sym_print_statement] = STATE(10),
    [sym_assert_statement] = STATE(10),
    [sym_expression_statement] = STATE(10),
    [sym_return_statement] = STATE(10),
    [sym_delete_statement] = STATE(10),
    [sym_raise_statement] = STATE(10),
    [sym_global_statement] = STATE(10),
    [sym_nonlocal_statement] = STATE(10),
    [sym_exec_statement] = STATE(10),
    [sym__suite] = STATE(1194),
    [sym_expression_list] = STATE(32),
    [sym__expression] = STATE(33),
    [sym__primary_expression] = STATE(34),
    [sym_not_operator] = STATE(33),
    [sym_boolean_operator] = STATE(33),
    [sym_binary_operator] = STATE(34),
    [sym_unary_operator] = STATE(34),
    [sym_comparison_operator] = STATE(33),
    [sym_lambda] = STATE(33),
    [sym_assignment] = STATE(35),
    [sym_augmented_assignment] = STATE(35),
    [sym_yield] = STATE(35),
    [sym_attribute] = STATE(34),
    [sym_subscript] = STATE(34),
    [sym_call] = STATE(34),
    [sym_list] = STATE(34),
    [sym_list_comprehension] = STATE(34),
    [sym_dictionary] = STATE(34),
    [sym_dictionary_comprehension] = STATE(34),
    [sym_set] = STATE(34),
    [sym_set_comprehension] = STATE(34),
    [sym_parenthesized_expression] = STATE(34),
    [sym_tuple] = STATE(34),
    [sym_generator_expression] = STATE(34),
    [sym_conditional_expression] = STATE(33),
    [sym_concatenated_string] = STATE(34),
    [sym_await] = STATE(33),
    [sym__indent] = ACTIONS(1528),
    [anon_sym_import] = ACTIONS(10),
    [anon_sym_from] = ACTIONS(12),
    [anon_sym_LPAREN] = ACTIONS(14),
    [anon_sym_print] = ACTIONS(16),
    [anon_sym_assert] = ACTIONS(18),
    [anon_sym_return] = ACTIONS(20),
    [anon_sym_del] = ACTIONS(22),
    [anon_sym_raise] = ACTIONS(24),
    [sym_pass_statement] = ACTIONS(26),
    [sym_break_statement] = ACTIONS(26),
    [sym_continue_statement] = ACTIONS(26),
    [anon_sym_global] = ACTIONS(42),
    [anon_sym_nonlocal] = ACTIONS(44),
    [anon_sym_exec] = ACTIONS(46),
    [anon_sym_not] = ACTIONS(52),
    [anon_sym_PLUS] = ACTIONS(54),
    [anon_sym_DASH] = ACTIONS(54),
    [anon_sym_TILDE] = ACTIONS(54),
    [anon_sym_lambda] = ACTIONS(56),
    [anon_sym_yield] = ACTIONS(58),
    [anon_sym_LBRACK] = ACTIONS(60),
    [sym_ellipsis] = ACTIONS(62),
    [anon_sym_LBRACE] = ACTIONS(64),
    [sym_string] = ACTIONS(66),
    [sym_integer] = ACTIONS(68),
    [sym_float] = ACTIONS(68),
    [sym_identifier] = ACTIONS(68),
    [sym_true] = ACTIONS(68),
    [sym_false] = ACTIONS(68),
    [sym_none] = ACTIONS(68),
    [anon_sym_await] = ACTIONS(70),
    [sym_comment] = ACTIONS(72),
  },
  [798] = {
    [aux_sym_dotted_name_repeat1] = STATE(798),
    [sym__newline] = ACTIONS(2048),
    [anon_sym_DOT] = ACTIONS(2050),
    [anon_sym_LPAREN] = ACTIONS(2048),
    [sym_comment] = ACTIONS(72),
  },
  [799] = {
    [aux_sym_argument_list_repeat1] = STATE(994),
    [anon_sym_RPAREN] = ACTIONS(1970),
    [anon_sym_COMMA] = ACTIONS(1978),
    [anon_sym_if] = ACTIONS(1147),
    [anon_sym_and] = ACTIONS(1149),
    [anon_sym_or] = ACTIONS(1151),
    [sym_comment] = ACTIONS(72),
  },
  [800] = {
    [anon_sym_async] = ACTIONS(2513),
    [anon_sym_def] = ACTIONS(2513),
    [anon_sym_class] = ACTIONS(2513),
    [anon_sym_AT] = ACTIONS(2513),
    [sym_comment] = ACTIONS(72),
  },
  [801] = {
    [anon_sym_COMMA] = ACTIONS(2515),
    [anon_sym_if] = ACTIONS(1592),
    [anon_sym_COLON] = ACTIONS(2515),
    [anon_sym_and] = ACTIONS(1594),
    [anon_sym_or] = ACTIONS(1596),
    [sym_comment] = ACTIONS(72),
  },
  [802] = {
    [anon_sym_COMMA] = ACTIONS(716),
    [anon_sym_if] = ACTIONS(716),
    [anon_sym_COLON] = ACTIONS(716),
    [anon_sym_and] = ACTIONS(1594),
    [anon_sym_or] = ACTIONS(1596),
    [sym_comment] = ACTIONS(72),
  },
  [803] = {
    [sym__expression] = STATE(1195),
    [sym__primary_expression] = STATE(410),
    [sym_not_operator] = STATE(1195),
    [sym_boolean_operator] = STATE(1195),
    [sym_binary_operator] = STATE(410),
    [sym_unary_operator] = STATE(410),
    [sym_comparison_operator] = STATE(1195),
    [sym_lambda] = STATE(1195),
    [sym_attribute] = STATE(410),
    [sym_subscript] = STATE(410),
    [sym_call] = STATE(410),
    [sym_list] = STATE(410),
    [sym_list_comprehension] = STATE(410),
    [sym_dictionary] = STATE(410),
    [sym_dictionary_comprehension] = STATE(410),
    [sym_set] = STATE(410),
    [sym_set_comprehension] = STATE(410),
    [sym_parenthesized_expression] = STATE(410),
    [sym_tuple] = STATE(410),
    [sym_generator_expression] = STATE(410),
    [sym_conditional_expression] = STATE(1195),
    [sym_concatenated_string] = STATE(410),
    [sym_await] = STATE(1195),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_not] = ACTIONS(726),
    [anon_sym_PLUS] = ACTIONS(728),
    [anon_sym_DASH] = ACTIONS(728),
    [anon_sym_TILDE] = ACTIONS(728),
    [anon_sym_lambda] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(732),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(734),
    [sym_integer] = ACTIONS(736),
    [sym_float] = ACTIONS(736),
    [sym_identifier] = ACTIONS(736),
    [sym_true] = ACTIONS(736),
    [sym_false] = ACTIONS(736),
    [sym_none] = ACTIONS(736),
    [anon_sym_await] = ACTIONS(738),
    [sym_comment] = ACTIONS(72),
  },
  [804] = {
    [anon_sym_COLON] = ACTIONS(2517),
    [sym_comment] = ACTIONS(72),
  },
  [805] = {
    [aux_sym_concatenated_string_repeat1] = STATE(1197),
    [anon_sym_DOT] = ACTIONS(886),
    [anon_sym_LPAREN] = ACTIONS(886),
    [anon_sym_COMMA] = ACTIONS(886),
    [anon_sym_STAR] = ACTIONS(888),
    [anon_sym_GT_GT] = ACTIONS(886),
    [anon_sym_if] = ACTIONS(886),
    [anon_sym_COLON] = ACTIONS(886),
    [anon_sym_in] = ACTIONS(886),
    [anon_sym_AT] = ACTIONS(886),
    [anon_sym_not] = ACTIONS(886),
    [anon_sym_and] = ACTIONS(886),
    [anon_sym_or] = ACTIONS(886),
    [anon_sym_PLUS] = ACTIONS(886),
    [anon_sym_DASH] = ACTIONS(886),
    [anon_sym_SLASH] = ACTIONS(888),
    [anon_sym_PERCENT] = ACTIONS(886),
    [anon_sym_SLASH_SLASH] = ACTIONS(886),
    [anon_sym_STAR_STAR] = ACTIONS(886),
    [anon_sym_PIPE] = ACTIONS(886),
    [anon_sym_AMP] = ACTIONS(886),
    [anon_sym_CARET] = ACTIONS(886),
    [anon_sym_LT_LT] = ACTIONS(886),
    [anon_sym_LT] = ACTIONS(888),
    [anon_sym_LT_EQ] = ACTIONS(886),
    [anon_sym_EQ_EQ] = ACTIONS(886),
    [anon_sym_BANG_EQ] = ACTIONS(886),
    [anon_sym_GT_EQ] = ACTIONS(886),
    [anon_sym_GT] = ACTIONS(888),
    [anon_sym_LT_GT] = ACTIONS(886),
    [anon_sym_is] = ACTIONS(886),
    [anon_sym_LBRACK] = ACTIONS(886),
    [sym_string] = ACTIONS(2519),
    [sym_comment] = ACTIONS(72),
  },
  [806] = {
    [sym__expression] = STATE(1198),
    [sym__primary_expression] = STATE(513),
    [sym_not_operator] = STATE(1198),
    [sym_boolean_operator] = STATE(1198),
    [sym_binary_operator] = STATE(513),
    [sym_unary_operator] = STATE(513),
    [sym_comparison_operator] = STATE(1198),
    [sym_lambda] = STATE(1198),
    [sym_attribute] = STATE(513),
    [sym_subscript] = STATE(513),
    [sym_call] = STATE(513),
    [sym_list] = STATE(513),
    [sym_list_comprehension] = STATE(513),
    [sym_dictionary] = STATE(513),
    [sym_dictionary_comprehension] = STATE(513),
    [sym_set] = STATE(513),
    [sym_set_comprehension] = STATE(513),
    [sym_parenthesized_expression] = STATE(513),
    [sym_tuple] = STATE(513),
    [sym_generator_expression] = STATE(513),
    [sym_conditional_expression] = STATE(1198),
    [sym_concatenated_string] = STATE(513),
    [sym_await] = STATE(1198),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_not] = ACTIONS(914),
    [anon_sym_PLUS] = ACTIONS(916),
    [anon_sym_DASH] = ACTIONS(916),
    [anon_sym_TILDE] = ACTIONS(916),
    [anon_sym_lambda] = ACTIONS(918),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(920),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(922),
    [sym_integer] = ACTIONS(924),
    [sym_float] = ACTIONS(924),
    [sym_identifier] = ACTIONS(924),
    [sym_true] = ACTIONS(924),
    [sym_false] = ACTIONS(924),
    [sym_none] = ACTIONS(924),
    [anon_sym_await] = ACTIONS(926),
    [sym_comment] = ACTIONS(72),
  },
  [807] = {
    [sym__expression] = STATE(604),
    [sym__primary_expression] = STATE(410),
    [sym_not_operator] = STATE(604),
    [sym_boolean_operator] = STATE(604),
    [sym_binary_operator] = STATE(410),
    [sym_unary_operator] = STATE(410),
    [sym_comparison_operator] = STATE(604),
    [sym_lambda] = STATE(604),
    [sym_attribute] = STATE(410),
    [sym_subscript] = STATE(410),
    [sym_call] = STATE(410),
    [sym_list] = STATE(410),
    [sym_list_comprehension] = STATE(410),
    [sym_dictionary] = STATE(410),
    [sym_dictionary_comprehension] = STATE(410),
    [sym_set] = STATE(410),
    [sym_set_comprehension] = STATE(410),
    [sym_parenthesized_expression] = STATE(410),
    [sym_tuple] = STATE(410),
    [sym_generator_expression] = STATE(410),
    [sym_conditional_expression] = STATE(604),
    [sym_concatenated_string] = STATE(410),
    [sym_await] = STATE(604),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_not] = ACTIONS(726),
    [anon_sym_PLUS] = ACTIONS(728),
    [anon_sym_DASH] = ACTIONS(728),
    [anon_sym_TILDE] = ACTIONS(728),
    [anon_sym_lambda] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(732),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(734),
    [sym_integer] = ACTIONS(736),
    [sym_float] = ACTIONS(736),
    [sym_identifier] = ACTIONS(736),
    [sym_true] = ACTIONS(736),
    [sym_false] = ACTIONS(736),
    [sym_none] = ACTIONS(736),
    [anon_sym_await] = ACTIONS(738),
    [sym_comment] = ACTIONS(72),
  },
  [808] = {
    [sym__expression] = STATE(1199),
    [sym__primary_expression] = STATE(410),
    [sym_not_operator] = STATE(1199),
    [sym_boolean_operator] = STATE(1199),
    [sym_binary_operator] = STATE(410),
    [sym_unary_operator] = STATE(410),
    [sym_comparison_operator] = STATE(1199),
    [sym_lambda] = STATE(1199),
    [sym_attribute] = STATE(410),
    [sym_subscript] = STATE(410),
    [sym_call] = STATE(410),
    [sym_list] = STATE(410),
    [sym_list_comprehension] = STATE(410),
    [sym_dictionary] = STATE(410),
    [sym_dictionary_comprehension] = STATE(410),
    [sym_set] = STATE(410),
    [sym_set_comprehension] = STATE(410),
    [sym_parenthesized_expression] = STATE(410),
    [sym_tuple] = STATE(410),
    [sym_generator_expression] = STATE(410),
    [sym_conditional_expression] = STATE(1199),
    [sym_concatenated_string] = STATE(410),
    [sym_await] = STATE(1199),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_not] = ACTIONS(726),
    [anon_sym_PLUS] = ACTIONS(728),
    [anon_sym_DASH] = ACTIONS(728),
    [anon_sym_TILDE] = ACTIONS(728),
    [anon_sym_lambda] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(732),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(734),
    [sym_integer] = ACTIONS(736),
    [sym_float] = ACTIONS(736),
    [sym_identifier] = ACTIONS(736),
    [sym_true] = ACTIONS(736),
    [sym_false] = ACTIONS(736),
    [sym_none] = ACTIONS(736),
    [anon_sym_await] = ACTIONS(738),
    [sym_comment] = ACTIONS(72),
  },
  [809] = {
    [sym__primary_expression] = STATE(1200),
    [sym_binary_operator] = STATE(1200),
    [sym_unary_operator] = STATE(1200),
    [sym_attribute] = STATE(1200),
    [sym_subscript] = STATE(1200),
    [sym_call] = STATE(1200),
    [sym_list] = STATE(1200),
    [sym_list_comprehension] = STATE(1200),
    [sym_dictionary] = STATE(1200),
    [sym_dictionary_comprehension] = STATE(1200),
    [sym_set] = STATE(1200),
    [sym_set_comprehension] = STATE(1200),
    [sym_parenthesized_expression] = STATE(1200),
    [sym_tuple] = STATE(1200),
    [sym_generator_expression] = STATE(1200),
    [sym_concatenated_string] = STATE(1200),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_PLUS] = ACTIONS(728),
    [anon_sym_DASH] = ACTIONS(728),
    [anon_sym_TILDE] = ACTIONS(728),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(2521),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(734),
    [sym_integer] = ACTIONS(2523),
    [sym_float] = ACTIONS(2523),
    [sym_identifier] = ACTIONS(2523),
    [sym_true] = ACTIONS(2523),
    [sym_false] = ACTIONS(2523),
    [sym_none] = ACTIONS(2523),
    [sym_comment] = ACTIONS(72),
  },
  [810] = {
    [sym__primary_expression] = STATE(1201),
    [sym_binary_operator] = STATE(1201),
    [sym_unary_operator] = STATE(1201),
    [sym_attribute] = STATE(1201),
    [sym_subscript] = STATE(1201),
    [sym_call] = STATE(1201),
    [sym_list] = STATE(1201),
    [sym_list_comprehension] = STATE(1201),
    [sym_dictionary] = STATE(1201),
    [sym_dictionary_comprehension] = STATE(1201),
    [sym_set] = STATE(1201),
    [sym_set_comprehension] = STATE(1201),
    [sym_parenthesized_expression] = STATE(1201),
    [sym_tuple] = STATE(1201),
    [sym_generator_expression] = STATE(1201),
    [sym_concatenated_string] = STATE(1201),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_PLUS] = ACTIONS(728),
    [anon_sym_DASH] = ACTIONS(728),
    [anon_sym_TILDE] = ACTIONS(728),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(2525),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(734),
    [sym_integer] = ACTIONS(2527),
    [sym_float] = ACTIONS(2527),
    [sym_identifier] = ACTIONS(2527),
    [sym_true] = ACTIONS(2527),
    [sym_false] = ACTIONS(2527),
    [sym_none] = ACTIONS(2527),
    [sym_comment] = ACTIONS(72),
  },
  [811] = {
    [sym__primary_expression] = STATE(1202),
    [sym_binary_operator] = STATE(1202),
    [sym_unary_operator] = STATE(1202),
    [sym_attribute] = STATE(1202),
    [sym_subscript] = STATE(1202),
    [sym_call] = STATE(1202),
    [sym_list] = STATE(1202),
    [sym_list_comprehension] = STATE(1202),
    [sym_dictionary] = STATE(1202),
    [sym_dictionary_comprehension] = STATE(1202),
    [sym_set] = STATE(1202),
    [sym_set_comprehension] = STATE(1202),
    [sym_parenthesized_expression] = STATE(1202),
    [sym_tuple] = STATE(1202),
    [sym_generator_expression] = STATE(1202),
    [sym_concatenated_string] = STATE(1202),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_PLUS] = ACTIONS(728),
    [anon_sym_DASH] = ACTIONS(728),
    [anon_sym_TILDE] = ACTIONS(728),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(2529),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(734),
    [sym_integer] = ACTIONS(2531),
    [sym_float] = ACTIONS(2531),
    [sym_identifier] = ACTIONS(2531),
    [sym_true] = ACTIONS(2531),
    [sym_false] = ACTIONS(2531),
    [sym_none] = ACTIONS(2531),
    [sym_comment] = ACTIONS(72),
  },
  [812] = {
    [anon_sym_in] = ACTIONS(2533),
    [sym_comment] = ACTIONS(72),
  },
  [813] = {
    [sym__primary_expression] = STATE(1204),
    [sym_binary_operator] = STATE(1204),
    [sym_unary_operator] = STATE(1204),
    [sym_attribute] = STATE(1204),
    [sym_subscript] = STATE(1204),
    [sym_call] = STATE(1204),
    [sym_list] = STATE(1204),
    [sym_list_comprehension] = STATE(1204),
    [sym_dictionary] = STATE(1204),
    [sym_dictionary_comprehension] = STATE(1204),
    [sym_set] = STATE(1204),
    [sym_set_comprehension] = STATE(1204),
    [sym_parenthesized_expression] = STATE(1204),
    [sym_tuple] = STATE(1204),
    [sym_generator_expression] = STATE(1204),
    [sym_concatenated_string] = STATE(1204),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_PLUS] = ACTIONS(728),
    [anon_sym_DASH] = ACTIONS(728),
    [anon_sym_TILDE] = ACTIONS(728),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(2535),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(734),
    [sym_integer] = ACTIONS(2537),
    [sym_float] = ACTIONS(2537),
    [sym_identifier] = ACTIONS(2537),
    [sym_true] = ACTIONS(2537),
    [sym_false] = ACTIONS(2537),
    [sym_none] = ACTIONS(2537),
    [sym_comment] = ACTIONS(72),
  },
  [814] = {
    [sym__primary_expression] = STATE(621),
    [sym_binary_operator] = STATE(621),
    [sym_unary_operator] = STATE(621),
    [sym_attribute] = STATE(621),
    [sym_subscript] = STATE(621),
    [sym_call] = STATE(621),
    [sym_list] = STATE(621),
    [sym_list_comprehension] = STATE(621),
    [sym_dictionary] = STATE(621),
    [sym_dictionary_comprehension] = STATE(621),
    [sym_set] = STATE(621),
    [sym_set_comprehension] = STATE(621),
    [sym_parenthesized_expression] = STATE(621),
    [sym_tuple] = STATE(621),
    [sym_generator_expression] = STATE(621),
    [sym_concatenated_string] = STATE(621),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_PLUS] = ACTIONS(728),
    [anon_sym_DASH] = ACTIONS(728),
    [anon_sym_TILDE] = ACTIONS(728),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(1233),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(734),
    [sym_integer] = ACTIONS(1235),
    [sym_float] = ACTIONS(1235),
    [sym_identifier] = ACTIONS(1235),
    [sym_true] = ACTIONS(1235),
    [sym_false] = ACTIONS(1235),
    [sym_none] = ACTIONS(1235),
    [sym_comment] = ACTIONS(72),
  },
  [815] = {
    [sym__primary_expression] = STATE(1205),
    [sym_binary_operator] = STATE(1205),
    [sym_unary_operator] = STATE(1205),
    [sym_attribute] = STATE(1205),
    [sym_subscript] = STATE(1205),
    [sym_call] = STATE(1205),
    [sym_list] = STATE(1205),
    [sym_list_comprehension] = STATE(1205),
    [sym_dictionary] = STATE(1205),
    [sym_dictionary_comprehension] = STATE(1205),
    [sym_set] = STATE(1205),
    [sym_set_comprehension] = STATE(1205),
    [sym_parenthesized_expression] = STATE(1205),
    [sym_tuple] = STATE(1205),
    [sym_generator_expression] = STATE(1205),
    [sym_concatenated_string] = STATE(1205),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_PLUS] = ACTIONS(728),
    [anon_sym_DASH] = ACTIONS(728),
    [anon_sym_TILDE] = ACTIONS(728),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(2539),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(734),
    [sym_integer] = ACTIONS(2541),
    [sym_float] = ACTIONS(2541),
    [sym_identifier] = ACTIONS(2541),
    [sym_true] = ACTIONS(2541),
    [sym_false] = ACTIONS(2541),
    [sym_none] = ACTIONS(2541),
    [sym_comment] = ACTIONS(72),
  },
  [816] = {
    [sym__primary_expression] = STATE(1206),
    [sym_binary_operator] = STATE(1206),
    [sym_unary_operator] = STATE(1206),
    [sym_attribute] = STATE(1206),
    [sym_subscript] = STATE(1206),
    [sym_call] = STATE(1206),
    [sym_list] = STATE(1206),
    [sym_list_comprehension] = STATE(1206),
    [sym_dictionary] = STATE(1206),
    [sym_dictionary_comprehension] = STATE(1206),
    [sym_set] = STATE(1206),
    [sym_set_comprehension] = STATE(1206),
    [sym_parenthesized_expression] = STATE(1206),
    [sym_tuple] = STATE(1206),
    [sym_generator_expression] = STATE(1206),
    [sym_concatenated_string] = STATE(1206),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_PLUS] = ACTIONS(728),
    [anon_sym_DASH] = ACTIONS(728),
    [anon_sym_TILDE] = ACTIONS(728),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(2543),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(734),
    [sym_integer] = ACTIONS(2545),
    [sym_float] = ACTIONS(2545),
    [sym_identifier] = ACTIONS(2545),
    [sym_true] = ACTIONS(2545),
    [sym_false] = ACTIONS(2545),
    [sym_none] = ACTIONS(2545),
    [sym_comment] = ACTIONS(72),
  },
  [817] = {
    [sym__primary_expression] = STATE(1207),
    [sym_binary_operator] = STATE(1207),
    [sym_unary_operator] = STATE(1207),
    [sym_attribute] = STATE(1207),
    [sym_subscript] = STATE(1207),
    [sym_call] = STATE(1207),
    [sym_list] = STATE(1207),
    [sym_list_comprehension] = STATE(1207),
    [sym_dictionary] = STATE(1207),
    [sym_dictionary_comprehension] = STATE(1207),
    [sym_set] = STATE(1207),
    [sym_set_comprehension] = STATE(1207),
    [sym_parenthesized_expression] = STATE(1207),
    [sym_tuple] = STATE(1207),
    [sym_generator_expression] = STATE(1207),
    [sym_concatenated_string] = STATE(1207),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_PLUS] = ACTIONS(728),
    [anon_sym_DASH] = ACTIONS(728),
    [anon_sym_TILDE] = ACTIONS(728),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(2547),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(734),
    [sym_integer] = ACTIONS(2549),
    [sym_float] = ACTIONS(2549),
    [sym_identifier] = ACTIONS(2549),
    [sym_true] = ACTIONS(2549),
    [sym_false] = ACTIONS(2549),
    [sym_none] = ACTIONS(2549),
    [sym_comment] = ACTIONS(72),
  },
  [818] = {
    [sym__primary_expression] = STATE(1202),
    [sym_binary_operator] = STATE(1202),
    [sym_unary_operator] = STATE(1202),
    [sym_attribute] = STATE(1202),
    [sym_subscript] = STATE(1202),
    [sym_call] = STATE(1202),
    [sym_list] = STATE(1202),
    [sym_list_comprehension] = STATE(1202),
    [sym_dictionary] = STATE(1202),
    [sym_dictionary_comprehension] = STATE(1202),
    [sym_set] = STATE(1202),
    [sym_set_comprehension] = STATE(1202),
    [sym_parenthesized_expression] = STATE(1202),
    [sym_tuple] = STATE(1202),
    [sym_generator_expression] = STATE(1202),
    [sym_concatenated_string] = STATE(1202),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_not] = ACTIONS(2551),
    [anon_sym_PLUS] = ACTIONS(728),
    [anon_sym_DASH] = ACTIONS(728),
    [anon_sym_TILDE] = ACTIONS(728),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(2529),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(734),
    [sym_integer] = ACTIONS(2531),
    [sym_float] = ACTIONS(2531),
    [sym_identifier] = ACTIONS(2531),
    [sym_true] = ACTIONS(2531),
    [sym_false] = ACTIONS(2531),
    [sym_none] = ACTIONS(2531),
    [sym_comment] = ACTIONS(72),
  },
  [819] = {
    [aux_sym_comparison_operator_repeat1] = STATE(1208),
    [anon_sym_COMMA] = ACTIONS(998),
    [anon_sym_if] = ACTIONS(998),
    [anon_sym_COLON] = ACTIONS(998),
    [anon_sym_in] = ACTIONS(1602),
    [anon_sym_not] = ACTIONS(1606),
    [anon_sym_and] = ACTIONS(998),
    [anon_sym_or] = ACTIONS(998),
    [anon_sym_LT] = ACTIONS(1618),
    [anon_sym_LT_EQ] = ACTIONS(1602),
    [anon_sym_EQ_EQ] = ACTIONS(1602),
    [anon_sym_BANG_EQ] = ACTIONS(1602),
    [anon_sym_GT_EQ] = ACTIONS(1602),
    [anon_sym_GT] = ACTIONS(1618),
    [anon_sym_LT_GT] = ACTIONS(1602),
    [anon_sym_is] = ACTIONS(1620),
    [sym_comment] = ACTIONS(72),
  },
  [820] = {
    [anon_sym_COMMA] = ACTIONS(2553),
    [anon_sym_COLON] = ACTIONS(2553),
    [anon_sym_EQ] = ACTIONS(744),
    [sym_comment] = ACTIONS(72),
  },
  [821] = {
    [anon_sym_COMMA] = ACTIONS(2555),
    [anon_sym_COLON] = ACTIONS(2555),
    [anon_sym_EQ] = ACTIONS(750),
    [sym_comment] = ACTIONS(72),
  },
  [822] = {
    [anon_sym_RPAREN] = ACTIONS(2555),
    [anon_sym_COMMA] = ACTIONS(2555),
    [anon_sym_COLON] = ACTIONS(2555),
    [sym_comment] = ACTIONS(72),
  },
  [823] = {
    [anon_sym_COMMA] = ACTIONS(2555),
    [anon_sym_COLON] = ACTIONS(2555),
    [sym_comment] = ACTIONS(72),
  },
  [824] = {
    [sym__expression] = STATE(1209),
    [sym__primary_expression] = STATE(830),
    [sym_not_operator] = STATE(1209),
    [sym_boolean_operator] = STATE(1209),
    [sym_binary_operator] = STATE(830),
    [sym_unary_operator] = STATE(830),
    [sym_comparison_operator] = STATE(1209),
    [sym_lambda] = STATE(1209),
    [sym_attribute] = STATE(830),
    [sym_subscript] = STATE(830),
    [sym_call] = STATE(830),
    [sym_list] = STATE(830),
    [sym_list_comprehension] = STATE(830),
    [sym_dictionary] = STATE(830),
    [sym_dictionary_comprehension] = STATE(830),
    [sym_set] = STATE(830),
    [sym_set_comprehension] = STATE(830),
    [sym_parenthesized_expression] = STATE(830),
    [sym_tuple] = STATE(830),
    [sym_generator_expression] = STATE(830),
    [sym_conditional_expression] = STATE(1209),
    [sym_concatenated_string] = STATE(830),
    [sym_await] = STATE(1209),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_not] = ACTIONS(1628),
    [anon_sym_PLUS] = ACTIONS(1630),
    [anon_sym_DASH] = ACTIONS(1630),
    [anon_sym_TILDE] = ACTIONS(1630),
    [anon_sym_lambda] = ACTIONS(1632),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(1634),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(1636),
    [sym_integer] = ACTIONS(1638),
    [sym_float] = ACTIONS(1638),
    [sym_identifier] = ACTIONS(1638),
    [sym_true] = ACTIONS(1638),
    [sym_false] = ACTIONS(1638),
    [sym_none] = ACTIONS(1638),
    [anon_sym_await] = ACTIONS(1640),
    [sym_comment] = ACTIONS(72),
  },
  [825] = {
    [sym__primary_expression] = STATE(204),
    [sym_binary_operator] = STATE(204),
    [sym_unary_operator] = STATE(204),
    [sym_attribute] = STATE(204),
    [sym_subscript] = STATE(204),
    [sym_call] = STATE(204),
    [sym_list] = STATE(204),
    [sym_list_comprehension] = STATE(204),
    [sym_dictionary] = STATE(204),
    [sym_dictionary_comprehension] = STATE(204),
    [sym_set] = STATE(204),
    [sym_set_comprehension] = STATE(204),
    [sym_parenthesized_expression] = STATE(204),
    [sym_tuple] = STATE(204),
    [sym_generator_expression] = STATE(204),
    [sym_concatenated_string] = STATE(204),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_PLUS] = ACTIONS(1630),
    [anon_sym_DASH] = ACTIONS(1630),
    [anon_sym_TILDE] = ACTIONS(1630),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(376),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(1636),
    [sym_integer] = ACTIONS(378),
    [sym_float] = ACTIONS(378),
    [sym_identifier] = ACTIONS(378),
    [sym_true] = ACTIONS(378),
    [sym_false] = ACTIONS(378),
    [sym_none] = ACTIONS(378),
    [sym_comment] = ACTIONS(72),
  },
  [826] = {
    [sym_lambda_parameters] = STATE(1211),
    [sym__parameters] = STATE(130),
    [sym_default_parameter] = STATE(131),
    [sym_typed_default_parameter] = STATE(131),
    [sym_list_splat] = STATE(132),
    [sym_dictionary_splat] = STATE(132),
    [sym_typed_parameter] = STATE(131),
    [sym_tuple] = STATE(131),
    [anon_sym_LPAREN] = ACTIONS(222),
    [anon_sym_STAR] = ACTIONS(224),
    [anon_sym_print] = ACTIONS(226),
    [anon_sym_COLON] = ACTIONS(2557),
    [anon_sym_exec] = ACTIONS(226),
    [sym_identifier] = ACTIONS(230),
    [sym_comment] = ACTIONS(72),
  },
  [827] = {
    [aux_sym_concatenated_string_repeat1] = STATE(1212),
    [anon_sym_DOT] = ACTIONS(276),
    [anon_sym_LPAREN] = ACTIONS(276),
    [anon_sym_STAR] = ACTIONS(278),
    [anon_sym_GT_GT] = ACTIONS(276),
    [anon_sym_if] = ACTIONS(276),
    [anon_sym_in] = ACTIONS(276),
    [anon_sym_EQ] = ACTIONS(278),
    [anon_sym_AT] = ACTIONS(276),
    [anon_sym_not] = ACTIONS(276),
    [anon_sym_and] = ACTIONS(276),
    [anon_sym_or] = ACTIONS(276),
    [anon_sym_PLUS] = ACTIONS(276),
    [anon_sym_DASH] = ACTIONS(276),
    [anon_sym_SLASH] = ACTIONS(278),
    [anon_sym_PERCENT] = ACTIONS(276),
    [anon_sym_SLASH_SLASH] = ACTIONS(276),
    [anon_sym_STAR_STAR] = ACTIONS(276),
    [anon_sym_PIPE] = ACTIONS(276),
    [anon_sym_AMP] = ACTIONS(276),
    [anon_sym_CARET] = ACTIONS(276),
    [anon_sym_LT_LT] = ACTIONS(276),
    [anon_sym_LT] = ACTIONS(278),
    [anon_sym_LT_EQ] = ACTIONS(276),
    [anon_sym_EQ_EQ] = ACTIONS(276),
    [anon_sym_BANG_EQ] = ACTIONS(276),
    [anon_sym_GT_EQ] = ACTIONS(276),
    [anon_sym_GT] = ACTIONS(278),
    [anon_sym_LT_GT] = ACTIONS(276),
    [anon_sym_is] = ACTIONS(276),
    [anon_sym_LBRACK] = ACTIONS(276),
    [sym_string] = ACTIONS(2559),
    [sym_comment] = ACTIONS(72),
  },
  [828] = {
    [sym__expression] = STATE(227),
    [sym__primary_expression] = STATE(830),
    [sym_not_operator] = STATE(227),
    [sym_boolean_operator] = STATE(227),
    [sym_binary_operator] = STATE(830),
    [sym_unary_operator] = STATE(830),
    [sym_comparison_operator] = STATE(227),
    [sym_lambda] = STATE(227),
    [sym_attribute] = STATE(830),
    [sym_subscript] = STATE(830),
    [sym_call] = STATE(830),
    [sym_list] = STATE(830),
    [sym_list_comprehension] = STATE(830),
    [sym_dictionary] = STATE(830),
    [sym_dictionary_comprehension] = STATE(830),
    [sym_set] = STATE(830),
    [sym_set_comprehension] = STATE(830),
    [sym_parenthesized_expression] = STATE(830),
    [sym_tuple] = STATE(830),
    [sym_generator_expression] = STATE(830),
    [sym_conditional_expression] = STATE(227),
    [sym_concatenated_string] = STATE(830),
    [sym_await] = STATE(227),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_not] = ACTIONS(1628),
    [anon_sym_PLUS] = ACTIONS(1630),
    [anon_sym_DASH] = ACTIONS(1630),
    [anon_sym_TILDE] = ACTIONS(1630),
    [anon_sym_lambda] = ACTIONS(1632),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(1634),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(1636),
    [sym_integer] = ACTIONS(1638),
    [sym_float] = ACTIONS(1638),
    [sym_identifier] = ACTIONS(1638),
    [sym_true] = ACTIONS(1638),
    [sym_false] = ACTIONS(1638),
    [sym_none] = ACTIONS(1638),
    [anon_sym_await] = ACTIONS(1640),
    [sym_comment] = ACTIONS(72),
  },
  [829] = {
    [anon_sym_if] = ACTIONS(2561),
    [anon_sym_EQ] = ACTIONS(1873),
    [anon_sym_and] = ACTIONS(2563),
    [anon_sym_or] = ACTIONS(2565),
    [sym_comment] = ACTIONS(72),
  },
  [830] = {
    [sym_argument_list] = STATE(251),
    [sym_generator_expression] = STATE(251),
    [aux_sym_comparison_operator_repeat1] = STATE(1226),
    [anon_sym_DOT] = ACTIONS(422),
    [anon_sym_LPAREN] = ACTIONS(424),
    [anon_sym_STAR] = ACTIONS(2567),
    [anon_sym_GT_GT] = ACTIONS(2569),
    [anon_sym_if] = ACTIONS(302),
    [anon_sym_in] = ACTIONS(2571),
    [anon_sym_EQ] = ACTIONS(314),
    [anon_sym_AT] = ACTIONS(2573),
    [anon_sym_not] = ACTIONS(2575),
    [anon_sym_and] = ACTIONS(302),
    [anon_sym_or] = ACTIONS(302),
    [anon_sym_PLUS] = ACTIONS(2577),
    [anon_sym_DASH] = ACTIONS(2577),
    [anon_sym_SLASH] = ACTIONS(2567),
    [anon_sym_PERCENT] = ACTIONS(2573),
    [anon_sym_SLASH_SLASH] = ACTIONS(2573),
    [anon_sym_STAR_STAR] = ACTIONS(2579),
    [anon_sym_PIPE] = ACTIONS(2581),
    [anon_sym_AMP] = ACTIONS(2583),
    [anon_sym_CARET] = ACTIONS(2585),
    [anon_sym_LT_LT] = ACTIONS(2569),
    [anon_sym_LT] = ACTIONS(2587),
    [anon_sym_LT_EQ] = ACTIONS(2571),
    [anon_sym_EQ_EQ] = ACTIONS(2571),
    [anon_sym_BANG_EQ] = ACTIONS(2571),
    [anon_sym_GT_EQ] = ACTIONS(2571),
    [anon_sym_GT] = ACTIONS(2587),
    [anon_sym_LT_GT] = ACTIONS(2571),
    [anon_sym_is] = ACTIONS(2589),
    [anon_sym_LBRACK] = ACTIONS(450),
    [sym_comment] = ACTIONS(72),
  },
  [831] = {
    [anon_sym_EQ] = ACTIONS(2591),
    [sym_comment] = ACTIONS(72),
  },
  [832] = {
    [anon_sym_COMMA] = ACTIONS(2593),
    [anon_sym_if] = ACTIONS(1592),
    [anon_sym_COLON] = ACTIONS(2593),
    [anon_sym_and] = ACTIONS(1594),
    [anon_sym_or] = ACTIONS(1596),
    [sym_comment] = ACTIONS(72),
  },
  [833] = {
    [sym_default_parameter] = STATE(822),
    [sym_typed_default_parameter] = STATE(822),
    [sym_list_splat] = STATE(823),
    [sym_dictionary_splat] = STATE(823),
    [sym_typed_parameter] = STATE(822),
    [sym_tuple] = STATE(822),
    [anon_sym_LPAREN] = ACTIONS(222),
    [anon_sym_STAR] = ACTIONS(224),
    [anon_sym_print] = ACTIONS(1622),
    [anon_sym_COLON] = ACTIONS(2595),
    [anon_sym_exec] = ACTIONS(1622),
    [sym_identifier] = ACTIONS(1626),
    [sym_comment] = ACTIONS(72),
  },
  [834] = {
    [aux_sym__parameters_repeat1] = STATE(834),
    [anon_sym_COMMA] = ACTIONS(2597),
    [anon_sym_COLON] = ACTIONS(2555),
    [sym_comment] = ACTIONS(72),
  },
  [835] = {
    [sym__expression] = STATE(1229),
    [sym__primary_expression] = STATE(841),
    [sym_not_operator] = STATE(1229),
    [sym_boolean_operator] = STATE(1229),
    [sym_binary_operator] = STATE(841),
    [sym_unary_operator] = STATE(841),
    [sym_comparison_operator] = STATE(1229),
    [sym_lambda] = STATE(1229),
    [sym_attribute] = STATE(841),
    [sym_subscript] = STATE(841),
    [sym_call] = STATE(841),
    [sym_list] = STATE(841),
    [sym_list_comprehension] = STATE(841),
    [sym_dictionary] = STATE(841),
    [sym_dictionary_comprehension] = STATE(841),
    [sym_set] = STATE(841),
    [sym_set_comprehension] = STATE(841),
    [sym_parenthesized_expression] = STATE(841),
    [sym_tuple] = STATE(841),
    [sym_generator_expression] = STATE(841),
    [sym_conditional_expression] = STATE(1229),
    [sym_concatenated_string] = STATE(841),
    [sym_await] = STATE(1229),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_not] = ACTIONS(1648),
    [anon_sym_PLUS] = ACTIONS(1650),
    [anon_sym_DASH] = ACTIONS(1650),
    [anon_sym_TILDE] = ACTIONS(1650),
    [anon_sym_lambda] = ACTIONS(1652),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(1654),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(1656),
    [sym_integer] = ACTIONS(1658),
    [sym_float] = ACTIONS(1658),
    [sym_identifier] = ACTIONS(1658),
    [sym_true] = ACTIONS(1658),
    [sym_false] = ACTIONS(1658),
    [sym_none] = ACTIONS(1658),
    [anon_sym_await] = ACTIONS(1660),
    [sym_comment] = ACTIONS(72),
  },
  [836] = {
    [sym__primary_expression] = STATE(204),
    [sym_binary_operator] = STATE(204),
    [sym_unary_operator] = STATE(204),
    [sym_attribute] = STATE(204),
    [sym_subscript] = STATE(204),
    [sym_call] = STATE(204),
    [sym_list] = STATE(204),
    [sym_list_comprehension] = STATE(204),
    [sym_dictionary] = STATE(204),
    [sym_dictionary_comprehension] = STATE(204),
    [sym_set] = STATE(204),
    [sym_set_comprehension] = STATE(204),
    [sym_parenthesized_expression] = STATE(204),
    [sym_tuple] = STATE(204),
    [sym_generator_expression] = STATE(204),
    [sym_concatenated_string] = STATE(204),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_PLUS] = ACTIONS(1650),
    [anon_sym_DASH] = ACTIONS(1650),
    [anon_sym_TILDE] = ACTIONS(1650),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(376),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(1656),
    [sym_integer] = ACTIONS(378),
    [sym_float] = ACTIONS(378),
    [sym_identifier] = ACTIONS(378),
    [sym_true] = ACTIONS(378),
    [sym_false] = ACTIONS(378),
    [sym_none] = ACTIONS(378),
    [sym_comment] = ACTIONS(72),
  },
  [837] = {
    [sym_lambda_parameters] = STATE(1231),
    [sym__parameters] = STATE(130),
    [sym_default_parameter] = STATE(131),
    [sym_typed_default_parameter] = STATE(131),
    [sym_list_splat] = STATE(132),
    [sym_dictionary_splat] = STATE(132),
    [sym_typed_parameter] = STATE(131),
    [sym_tuple] = STATE(131),
    [anon_sym_LPAREN] = ACTIONS(222),
    [anon_sym_STAR] = ACTIONS(224),
    [anon_sym_print] = ACTIONS(226),
    [anon_sym_COLON] = ACTIONS(2600),
    [anon_sym_exec] = ACTIONS(226),
    [sym_identifier] = ACTIONS(230),
    [sym_comment] = ACTIONS(72),
  },
  [838] = {
    [aux_sym_concatenated_string_repeat1] = STATE(1232),
    [anon_sym_DOT] = ACTIONS(276),
    [anon_sym_LPAREN] = ACTIONS(276),
    [anon_sym_COMMA] = ACTIONS(276),
    [anon_sym_STAR] = ACTIONS(278),
    [anon_sym_GT_GT] = ACTIONS(276),
    [anon_sym_if] = ACTIONS(276),
    [anon_sym_COLON] = ACTIONS(276),
    [anon_sym_in] = ACTIONS(276),
    [anon_sym_EQ] = ACTIONS(278),
    [anon_sym_AT] = ACTIONS(276),
    [anon_sym_not] = ACTIONS(276),
    [anon_sym_and] = ACTIONS(276),
    [anon_sym_or] = ACTIONS(276),
    [anon_sym_PLUS] = ACTIONS(276),
    [anon_sym_DASH] = ACTIONS(276),
    [anon_sym_SLASH] = ACTIONS(278),
    [anon_sym_PERCENT] = ACTIONS(276),
    [anon_sym_SLASH_SLASH] = ACTIONS(276),
    [anon_sym_STAR_STAR] = ACTIONS(276),
    [anon_sym_PIPE] = ACTIONS(276),
    [anon_sym_AMP] = ACTIONS(276),
    [anon_sym_CARET] = ACTIONS(276),
    [anon_sym_LT_LT] = ACTIONS(276),
    [anon_sym_LT] = ACTIONS(278),
    [anon_sym_LT_EQ] = ACTIONS(276),
    [anon_sym_EQ_EQ] = ACTIONS(276),
    [anon_sym_BANG_EQ] = ACTIONS(276),
    [anon_sym_GT_EQ] = ACTIONS(276),
    [anon_sym_GT] = ACTIONS(278),
    [anon_sym_LT_GT] = ACTIONS(276),
    [anon_sym_is] = ACTIONS(276),
    [anon_sym_LBRACK] = ACTIONS(276),
    [sym_string] = ACTIONS(2602),
    [sym_comment] = ACTIONS(72),
  },
  [839] = {
    [sym__expression] = STATE(227),
    [sym__primary_expression] = STATE(841),
    [sym_not_operator] = STATE(227),
    [sym_boolean_operator] = STATE(227),
    [sym_binary_operator] = STATE(841),
    [sym_unary_operator] = STATE(841),
    [sym_comparison_operator] = STATE(227),
    [sym_lambda] = STATE(227),
    [sym_attribute] = STATE(841),
    [sym_subscript] = STATE(841),
    [sym_call] = STATE(841),
    [sym_list] = STATE(841),
    [sym_list_comprehension] = STATE(841),
    [sym_dictionary] = STATE(841),
    [sym_dictionary_comprehension] = STATE(841),
    [sym_set] = STATE(841),
    [sym_set_comprehension] = STATE(841),
    [sym_parenthesized_expression] = STATE(841),
    [sym_tuple] = STATE(841),
    [sym_generator_expression] = STATE(841),
    [sym_conditional_expression] = STATE(227),
    [sym_concatenated_string] = STATE(841),
    [sym_await] = STATE(227),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_not] = ACTIONS(1648),
    [anon_sym_PLUS] = ACTIONS(1650),
    [anon_sym_DASH] = ACTIONS(1650),
    [anon_sym_TILDE] = ACTIONS(1650),
    [anon_sym_lambda] = ACTIONS(1652),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(1654),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(1656),
    [sym_integer] = ACTIONS(1658),
    [sym_float] = ACTIONS(1658),
    [sym_identifier] = ACTIONS(1658),
    [sym_true] = ACTIONS(1658),
    [sym_false] = ACTIONS(1658),
    [sym_none] = ACTIONS(1658),
    [anon_sym_await] = ACTIONS(1660),
    [sym_comment] = ACTIONS(72),
  },
  [840] = {
    [anon_sym_COMMA] = ACTIONS(1873),
    [anon_sym_if] = ACTIONS(2604),
    [anon_sym_COLON] = ACTIONS(1873),
    [anon_sym_EQ] = ACTIONS(1873),
    [anon_sym_and] = ACTIONS(2606),
    [anon_sym_or] = ACTIONS(2608),
    [sym_comment] = ACTIONS(72),
  },
  [841] = {
    [sym_argument_list] = STATE(251),
    [sym_generator_expression] = STATE(251),
    [aux_sym_comparison_operator_repeat1] = STATE(1246),
    [anon_sym_DOT] = ACTIONS(422),
    [anon_sym_LPAREN] = ACTIONS(424),
    [anon_sym_COMMA] = ACTIONS(302),
    [anon_sym_STAR] = ACTIONS(2610),
    [anon_sym_GT_GT] = ACTIONS(2612),
    [anon_sym_if] = ACTIONS(302),
    [anon_sym_COLON] = ACTIONS(302),
    [anon_sym_in] = ACTIONS(2614),
    [anon_sym_EQ] = ACTIONS(314),
    [anon_sym_AT] = ACTIONS(2616),
    [anon_sym_not] = ACTIONS(2618),
    [anon_sym_and] = ACTIONS(302),
    [anon_sym_or] = ACTIONS(302),
    [anon_sym_PLUS] = ACTIONS(2620),
    [anon_sym_DASH] = ACTIONS(2620),
    [anon_sym_SLASH] = ACTIONS(2610),
    [anon_sym_PERCENT] = ACTIONS(2616),
    [anon_sym_SLASH_SLASH] = ACTIONS(2616),
    [anon_sym_STAR_STAR] = ACTIONS(2622),
    [anon_sym_PIPE] = ACTIONS(2624),
    [anon_sym_AMP] = ACTIONS(2626),
    [anon_sym_CARET] = ACTIONS(2628),
    [anon_sym_LT_LT] = ACTIONS(2612),
    [anon_sym_LT] = ACTIONS(2630),
    [anon_sym_LT_EQ] = ACTIONS(2614),
    [anon_sym_EQ_EQ] = ACTIONS(2614),
    [anon_sym_BANG_EQ] = ACTIONS(2614),
    [anon_sym_GT_EQ] = ACTIONS(2614),
    [anon_sym_GT] = ACTIONS(2630),
    [anon_sym_LT_GT] = ACTIONS(2614),
    [anon_sym_is] = ACTIONS(2632),
    [anon_sym_LBRACK] = ACTIONS(450),
    [sym_comment] = ACTIONS(72),
  },
  [842] = {
    [anon_sym_COMMA] = ACTIONS(2634),
    [anon_sym_COLON] = ACTIONS(2634),
    [anon_sym_EQ] = ACTIONS(2636),
    [sym_comment] = ACTIONS(72),
  },
  [843] = {
    [anon_sym_COMMA] = ACTIONS(2638),
    [anon_sym_if] = ACTIONS(1592),
    [anon_sym_COLON] = ACTIONS(2638),
    [anon_sym_and] = ACTIONS(1594),
    [anon_sym_or] = ACTIONS(1596),
    [sym_comment] = ACTIONS(72),
  },
  [844] = {
    [sym_default_parameter] = STATE(822),
    [sym_typed_default_parameter] = STATE(822),
    [sym_list_splat] = STATE(823),
    [sym_dictionary_splat] = STATE(823),
    [sym_typed_parameter] = STATE(822),
    [sym_tuple] = STATE(822),
    [anon_sym_LPAREN] = ACTIONS(222),
    [anon_sym_STAR] = ACTIONS(224),
    [anon_sym_print] = ACTIONS(1622),
    [anon_sym_COLON] = ACTIONS(2640),
    [anon_sym_exec] = ACTIONS(1622),
    [sym_identifier] = ACTIONS(1626),
    [sym_comment] = ACTIONS(72),
  },
  [845] = {
    [sym__newline] = ACTIONS(2642),
    [anon_sym_COMMA] = ACTIONS(2642),
    [anon_sym_if] = ACTIONS(294),
    [anon_sym_COLON] = ACTIONS(2642),
    [anon_sym_EQ] = ACTIONS(2642),
    [anon_sym_and] = ACTIONS(298),
    [anon_sym_or] = ACTIONS(300),
    [anon_sym_PLUS_EQ] = ACTIONS(2642),
    [anon_sym_DASH_EQ] = ACTIONS(2642),
    [anon_sym_STAR_EQ] = ACTIONS(2642),
    [anon_sym_SLASH_EQ] = ACTIONS(2642),
    [anon_sym_AT_EQ] = ACTIONS(2642),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(2642),
    [anon_sym_PERCENT_EQ] = ACTIONS(2642),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2642),
    [anon_sym_GT_GT_EQ] = ACTIONS(2642),
    [anon_sym_LT_LT_EQ] = ACTIONS(2642),
    [anon_sym_AMP_EQ] = ACTIONS(2642),
    [anon_sym_CARET_EQ] = ACTIONS(2642),
    [anon_sym_PIPE_EQ] = ACTIONS(2642),
    [sym_comment] = ACTIONS(72),
    [sym__semicolon] = ACTIONS(2642),
  },
  [846] = {
    [anon_sym_COMMA] = ACTIONS(1873),
    [anon_sym_if] = ACTIONS(1592),
    [anon_sym_COLON] = ACTIONS(1873),
    [anon_sym_and] = ACTIONS(1594),
    [anon_sym_or] = ACTIONS(1596),
    [sym_comment] = ACTIONS(72),
  },
  [847] = {
    [anon_sym_RPAREN] = ACTIONS(2634),
    [anon_sym_COMMA] = ACTIONS(2634),
    [anon_sym_COLON] = ACTIONS(2634),
    [sym_comment] = ACTIONS(72),
  },
  [848] = {
    [anon_sym_COMMA] = ACTIONS(716),
    [anon_sym_if] = ACTIONS(716),
    [anon_sym_and] = ACTIONS(1676),
    [anon_sym_or] = ACTIONS(1678),
    [anon_sym_RBRACK] = ACTIONS(716),
    [sym_comment] = ACTIONS(72),
  },
  [849] = {
    [sym__expression] = STATE(1248),
    [sym__primary_expression] = STATE(430),
    [sym_not_operator] = STATE(1248),
    [sym_boolean_operator] = STATE(1248),
    [sym_binary_operator] = STATE(430),
    [sym_unary_operator] = STATE(430),
    [sym_comparison_operator] = STATE(1248),
    [sym_lambda] = STATE(1248),
    [sym_attribute] = STATE(430),
    [sym_subscript] = STATE(430),
    [sym_call] = STATE(430),
    [sym_list] = STATE(430),
    [sym_list_comprehension] = STATE(430),
    [sym_dictionary] = STATE(430),
    [sym_dictionary_comprehension] = STATE(430),
    [sym_set] = STATE(430),
    [sym_set_comprehension] = STATE(430),
    [sym_parenthesized_expression] = STATE(430),
    [sym_tuple] = STATE(430),
    [sym_generator_expression] = STATE(430),
    [sym_conditional_expression] = STATE(1248),
    [sym_concatenated_string] = STATE(430),
    [sym_await] = STATE(1248),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_not] = ACTIONS(760),
    [anon_sym_PLUS] = ACTIONS(762),
    [anon_sym_DASH] = ACTIONS(762),
    [anon_sym_TILDE] = ACTIONS(762),
    [anon_sym_lambda] = ACTIONS(764),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(766),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(768),
    [sym_integer] = ACTIONS(770),
    [sym_float] = ACTIONS(770),
    [sym_identifier] = ACTIONS(770),
    [sym_true] = ACTIONS(770),
    [sym_false] = ACTIONS(770),
    [sym_none] = ACTIONS(770),
    [anon_sym_await] = ACTIONS(772),
    [sym_comment] = ACTIONS(72),
  },
  [850] = {
    [anon_sym_COLON] = ACTIONS(2644),
    [sym_comment] = ACTIONS(72),
  },
  [851] = {
    [aux_sym_concatenated_string_repeat1] = STATE(1250),
    [anon_sym_DOT] = ACTIONS(886),
    [anon_sym_LPAREN] = ACTIONS(886),
    [anon_sym_COMMA] = ACTIONS(886),
    [anon_sym_STAR] = ACTIONS(888),
    [anon_sym_GT_GT] = ACTIONS(886),
    [anon_sym_if] = ACTIONS(886),
    [anon_sym_in] = ACTIONS(886),
    [anon_sym_AT] = ACTIONS(886),
    [anon_sym_not] = ACTIONS(886),
    [anon_sym_and] = ACTIONS(886),
    [anon_sym_or] = ACTIONS(886),
    [anon_sym_PLUS] = ACTIONS(886),
    [anon_sym_DASH] = ACTIONS(886),
    [anon_sym_SLASH] = ACTIONS(888),
    [anon_sym_PERCENT] = ACTIONS(886),
    [anon_sym_SLASH_SLASH] = ACTIONS(886),
    [anon_sym_STAR_STAR] = ACTIONS(886),
    [anon_sym_PIPE] = ACTIONS(886),
    [anon_sym_AMP] = ACTIONS(886),
    [anon_sym_CARET] = ACTIONS(886),
    [anon_sym_LT_LT] = ACTIONS(886),
    [anon_sym_LT] = ACTIONS(888),
    [anon_sym_LT_EQ] = ACTIONS(886),
    [anon_sym_EQ_EQ] = ACTIONS(886),
    [anon_sym_BANG_EQ] = ACTIONS(886),
    [anon_sym_GT_EQ] = ACTIONS(886),
    [anon_sym_GT] = ACTIONS(888),
    [anon_sym_LT_GT] = ACTIONS(886),
    [anon_sym_is] = ACTIONS(886),
    [anon_sym_LBRACK] = ACTIONS(886),
    [anon_sym_RBRACK] = ACTIONS(886),
    [sym_string] = ACTIONS(2646),
    [sym_comment] = ACTIONS(72),
  },
  [852] = {
    [sym__expression] = STATE(1251),
    [sym__primary_expression] = STATE(513),
    [sym_not_operator] = STATE(1251),
    [sym_boolean_operator] = STATE(1251),
    [sym_binary_operator] = STATE(513),
    [sym_unary_operator] = STATE(513),
    [sym_comparison_operator] = STATE(1251),
    [sym_lambda] = STATE(1251),
    [sym_attribute] = STATE(513),
    [sym_subscript] = STATE(513),
    [sym_call] = STATE(513),
    [sym_list] = STATE(513),
    [sym_list_comprehension] = STATE(513),
    [sym_dictionary] = STATE(513),
    [sym_dictionary_comprehension] = STATE(513),
    [sym_set] = STATE(513),
    [sym_set_comprehension] = STATE(513),
    [sym_parenthesized_expression] = STATE(513),
    [sym_tuple] = STATE(513),
    [sym_generator_expression] = STATE(513),
    [sym_conditional_expression] = STATE(1251),
    [sym_concatenated_string] = STATE(513),
    [sym_await] = STATE(1251),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_not] = ACTIONS(914),
    [anon_sym_PLUS] = ACTIONS(916),
    [anon_sym_DASH] = ACTIONS(916),
    [anon_sym_TILDE] = ACTIONS(916),
    [anon_sym_lambda] = ACTIONS(918),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(920),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(922),
    [sym_integer] = ACTIONS(924),
    [sym_float] = ACTIONS(924),
    [sym_identifier] = ACTIONS(924),
    [sym_true] = ACTIONS(924),
    [sym_false] = ACTIONS(924),
    [sym_none] = ACTIONS(924),
    [anon_sym_await] = ACTIONS(926),
    [sym_comment] = ACTIONS(72),
  },
  [853] = {
    [sym__expression] = STATE(604),
    [sym__primary_expression] = STATE(430),
    [sym_not_operator] = STATE(604),
    [sym_boolean_operator] = STATE(604),
    [sym_binary_operator] = STATE(430),
    [sym_unary_operator] = STATE(430),
    [sym_comparison_operator] = STATE(604),
    [sym_lambda] = STATE(604),
    [sym_attribute] = STATE(430),
    [sym_subscript] = STATE(430),
    [sym_call] = STATE(430),
    [sym_list] = STATE(430),
    [sym_list_comprehension] = STATE(430),
    [sym_dictionary] = STATE(430),
    [sym_dictionary_comprehension] = STATE(430),
    [sym_set] = STATE(430),
    [sym_set_comprehension] = STATE(430),
    [sym_parenthesized_expression] = STATE(430),
    [sym_tuple] = STATE(430),
    [sym_generator_expression] = STATE(430),
    [sym_conditional_expression] = STATE(604),
    [sym_concatenated_string] = STATE(430),
    [sym_await] = STATE(604),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_not] = ACTIONS(760),
    [anon_sym_PLUS] = ACTIONS(762),
    [anon_sym_DASH] = ACTIONS(762),
    [anon_sym_TILDE] = ACTIONS(762),
    [anon_sym_lambda] = ACTIONS(764),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(766),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(768),
    [sym_integer] = ACTIONS(770),
    [sym_float] = ACTIONS(770),
    [sym_identifier] = ACTIONS(770),
    [sym_true] = ACTIONS(770),
    [sym_false] = ACTIONS(770),
    [sym_none] = ACTIONS(770),
    [anon_sym_await] = ACTIONS(772),
    [sym_comment] = ACTIONS(72),
  },
  [854] = {
    [sym__expression] = STATE(1252),
    [sym__primary_expression] = STATE(430),
    [sym_not_operator] = STATE(1252),
    [sym_boolean_operator] = STATE(1252),
    [sym_binary_operator] = STATE(430),
    [sym_unary_operator] = STATE(430),
    [sym_comparison_operator] = STATE(1252),
    [sym_lambda] = STATE(1252),
    [sym_attribute] = STATE(430),
    [sym_subscript] = STATE(430),
    [sym_call] = STATE(430),
    [sym_list] = STATE(430),
    [sym_list_comprehension] = STATE(430),
    [sym_dictionary] = STATE(430),
    [sym_dictionary_comprehension] = STATE(430),
    [sym_set] = STATE(430),
    [sym_set_comprehension] = STATE(430),
    [sym_parenthesized_expression] = STATE(430),
    [sym_tuple] = STATE(430),
    [sym_generator_expression] = STATE(430),
    [sym_conditional_expression] = STATE(1252),
    [sym_concatenated_string] = STATE(430),
    [sym_await] = STATE(1252),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_not] = ACTIONS(760),
    [anon_sym_PLUS] = ACTIONS(762),
    [anon_sym_DASH] = ACTIONS(762),
    [anon_sym_TILDE] = ACTIONS(762),
    [anon_sym_lambda] = ACTIONS(764),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(766),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(768),
    [sym_integer] = ACTIONS(770),
    [sym_float] = ACTIONS(770),
    [sym_identifier] = ACTIONS(770),
    [sym_true] = ACTIONS(770),
    [sym_false] = ACTIONS(770),
    [sym_none] = ACTIONS(770),
    [anon_sym_await] = ACTIONS(772),
    [sym_comment] = ACTIONS(72),
  },
  [855] = {
    [sym__primary_expression] = STATE(1253),
    [sym_binary_operator] = STATE(1253),
    [sym_unary_operator] = STATE(1253),
    [sym_attribute] = STATE(1253),
    [sym_subscript] = STATE(1253),
    [sym_call] = STATE(1253),
    [sym_list] = STATE(1253),
    [sym_list_comprehension] = STATE(1253),
    [sym_dictionary] = STATE(1253),
    [sym_dictionary_comprehension] = STATE(1253),
    [sym_set] = STATE(1253),
    [sym_set_comprehension] = STATE(1253),
    [sym_parenthesized_expression] = STATE(1253),
    [sym_tuple] = STATE(1253),
    [sym_generator_expression] = STATE(1253),
    [sym_concatenated_string] = STATE(1253),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_PLUS] = ACTIONS(762),
    [anon_sym_DASH] = ACTIONS(762),
    [anon_sym_TILDE] = ACTIONS(762),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(2648),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(768),
    [sym_integer] = ACTIONS(2650),
    [sym_float] = ACTIONS(2650),
    [sym_identifier] = ACTIONS(2650),
    [sym_true] = ACTIONS(2650),
    [sym_false] = ACTIONS(2650),
    [sym_none] = ACTIONS(2650),
    [sym_comment] = ACTIONS(72),
  },
  [856] = {
    [sym__primary_expression] = STATE(1254),
    [sym_binary_operator] = STATE(1254),
    [sym_unary_operator] = STATE(1254),
    [sym_attribute] = STATE(1254),
    [sym_subscript] = STATE(1254),
    [sym_call] = STATE(1254),
    [sym_list] = STATE(1254),
    [sym_list_comprehension] = STATE(1254),
    [sym_dictionary] = STATE(1254),
    [sym_dictionary_comprehension] = STATE(1254),
    [sym_set] = STATE(1254),
    [sym_set_comprehension] = STATE(1254),
    [sym_parenthesized_expression] = STATE(1254),
    [sym_tuple] = STATE(1254),
    [sym_generator_expression] = STATE(1254),
    [sym_concatenated_string] = STATE(1254),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_PLUS] = ACTIONS(762),
    [anon_sym_DASH] = ACTIONS(762),
    [anon_sym_TILDE] = ACTIONS(762),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(2652),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(768),
    [sym_integer] = ACTIONS(2654),
    [sym_float] = ACTIONS(2654),
    [sym_identifier] = ACTIONS(2654),
    [sym_true] = ACTIONS(2654),
    [sym_false] = ACTIONS(2654),
    [sym_none] = ACTIONS(2654),
    [sym_comment] = ACTIONS(72),
  },
  [857] = {
    [sym__primary_expression] = STATE(1255),
    [sym_binary_operator] = STATE(1255),
    [sym_unary_operator] = STATE(1255),
    [sym_attribute] = STATE(1255),
    [sym_subscript] = STATE(1255),
    [sym_call] = STATE(1255),
    [sym_list] = STATE(1255),
    [sym_list_comprehension] = STATE(1255),
    [sym_dictionary] = STATE(1255),
    [sym_dictionary_comprehension] = STATE(1255),
    [sym_set] = STATE(1255),
    [sym_set_comprehension] = STATE(1255),
    [sym_parenthesized_expression] = STATE(1255),
    [sym_tuple] = STATE(1255),
    [sym_generator_expression] = STATE(1255),
    [sym_concatenated_string] = STATE(1255),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_PLUS] = ACTIONS(762),
    [anon_sym_DASH] = ACTIONS(762),
    [anon_sym_TILDE] = ACTIONS(762),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(2656),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(768),
    [sym_integer] = ACTIONS(2658),
    [sym_float] = ACTIONS(2658),
    [sym_identifier] = ACTIONS(2658),
    [sym_true] = ACTIONS(2658),
    [sym_false] = ACTIONS(2658),
    [sym_none] = ACTIONS(2658),
    [sym_comment] = ACTIONS(72),
  },
  [858] = {
    [anon_sym_in] = ACTIONS(2660),
    [sym_comment] = ACTIONS(72),
  },
  [859] = {
    [sym__primary_expression] = STATE(1257),
    [sym_binary_operator] = STATE(1257),
    [sym_unary_operator] = STATE(1257),
    [sym_attribute] = STATE(1257),
    [sym_subscript] = STATE(1257),
    [sym_call] = STATE(1257),
    [sym_list] = STATE(1257),
    [sym_list_comprehension] = STATE(1257),
    [sym_dictionary] = STATE(1257),
    [sym_dictionary_comprehension] = STATE(1257),
    [sym_set] = STATE(1257),
    [sym_set_comprehension] = STATE(1257),
    [sym_parenthesized_expression] = STATE(1257),
    [sym_tuple] = STATE(1257),
    [sym_generator_expression] = STATE(1257),
    [sym_concatenated_string] = STATE(1257),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_PLUS] = ACTIONS(762),
    [anon_sym_DASH] = ACTIONS(762),
    [anon_sym_TILDE] = ACTIONS(762),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(2662),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(768),
    [sym_integer] = ACTIONS(2664),
    [sym_float] = ACTIONS(2664),
    [sym_identifier] = ACTIONS(2664),
    [sym_true] = ACTIONS(2664),
    [sym_false] = ACTIONS(2664),
    [sym_none] = ACTIONS(2664),
    [sym_comment] = ACTIONS(72),
  },
  [860] = {
    [sym__primary_expression] = STATE(621),
    [sym_binary_operator] = STATE(621),
    [sym_unary_operator] = STATE(621),
    [sym_attribute] = STATE(621),
    [sym_subscript] = STATE(621),
    [sym_call] = STATE(621),
    [sym_list] = STATE(621),
    [sym_list_comprehension] = STATE(621),
    [sym_dictionary] = STATE(621),
    [sym_dictionary_comprehension] = STATE(621),
    [sym_set] = STATE(621),
    [sym_set_comprehension] = STATE(621),
    [sym_parenthesized_expression] = STATE(621),
    [sym_tuple] = STATE(621),
    [sym_generator_expression] = STATE(621),
    [sym_concatenated_string] = STATE(621),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_PLUS] = ACTIONS(762),
    [anon_sym_DASH] = ACTIONS(762),
    [anon_sym_TILDE] = ACTIONS(762),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(1233),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(768),
    [sym_integer] = ACTIONS(1235),
    [sym_float] = ACTIONS(1235),
    [sym_identifier] = ACTIONS(1235),
    [sym_true] = ACTIONS(1235),
    [sym_false] = ACTIONS(1235),
    [sym_none] = ACTIONS(1235),
    [sym_comment] = ACTIONS(72),
  },
  [861] = {
    [sym__primary_expression] = STATE(1258),
    [sym_binary_operator] = STATE(1258),
    [sym_unary_operator] = STATE(1258),
    [sym_attribute] = STATE(1258),
    [sym_subscript] = STATE(1258),
    [sym_call] = STATE(1258),
    [sym_list] = STATE(1258),
    [sym_list_comprehension] = STATE(1258),
    [sym_dictionary] = STATE(1258),
    [sym_dictionary_comprehension] = STATE(1258),
    [sym_set] = STATE(1258),
    [sym_set_comprehension] = STATE(1258),
    [sym_parenthesized_expression] = STATE(1258),
    [sym_tuple] = STATE(1258),
    [sym_generator_expression] = STATE(1258),
    [sym_concatenated_string] = STATE(1258),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_PLUS] = ACTIONS(762),
    [anon_sym_DASH] = ACTIONS(762),
    [anon_sym_TILDE] = ACTIONS(762),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(2666),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(768),
    [sym_integer] = ACTIONS(2668),
    [sym_float] = ACTIONS(2668),
    [sym_identifier] = ACTIONS(2668),
    [sym_true] = ACTIONS(2668),
    [sym_false] = ACTIONS(2668),
    [sym_none] = ACTIONS(2668),
    [sym_comment] = ACTIONS(72),
  },
  [862] = {
    [sym__primary_expression] = STATE(1259),
    [sym_binary_operator] = STATE(1259),
    [sym_unary_operator] = STATE(1259),
    [sym_attribute] = STATE(1259),
    [sym_subscript] = STATE(1259),
    [sym_call] = STATE(1259),
    [sym_list] = STATE(1259),
    [sym_list_comprehension] = STATE(1259),
    [sym_dictionary] = STATE(1259),
    [sym_dictionary_comprehension] = STATE(1259),
    [sym_set] = STATE(1259),
    [sym_set_comprehension] = STATE(1259),
    [sym_parenthesized_expression] = STATE(1259),
    [sym_tuple] = STATE(1259),
    [sym_generator_expression] = STATE(1259),
    [sym_concatenated_string] = STATE(1259),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_PLUS] = ACTIONS(762),
    [anon_sym_DASH] = ACTIONS(762),
    [anon_sym_TILDE] = ACTIONS(762),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(2670),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(768),
    [sym_integer] = ACTIONS(2672),
    [sym_float] = ACTIONS(2672),
    [sym_identifier] = ACTIONS(2672),
    [sym_true] = ACTIONS(2672),
    [sym_false] = ACTIONS(2672),
    [sym_none] = ACTIONS(2672),
    [sym_comment] = ACTIONS(72),
  },
  [863] = {
    [sym__primary_expression] = STATE(1260),
    [sym_binary_operator] = STATE(1260),
    [sym_unary_operator] = STATE(1260),
    [sym_attribute] = STATE(1260),
    [sym_subscript] = STATE(1260),
    [sym_call] = STATE(1260),
    [sym_list] = STATE(1260),
    [sym_list_comprehension] = STATE(1260),
    [sym_dictionary] = STATE(1260),
    [sym_dictionary_comprehension] = STATE(1260),
    [sym_set] = STATE(1260),
    [sym_set_comprehension] = STATE(1260),
    [sym_parenthesized_expression] = STATE(1260),
    [sym_tuple] = STATE(1260),
    [sym_generator_expression] = STATE(1260),
    [sym_concatenated_string] = STATE(1260),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_PLUS] = ACTIONS(762),
    [anon_sym_DASH] = ACTIONS(762),
    [anon_sym_TILDE] = ACTIONS(762),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(2674),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(768),
    [sym_integer] = ACTIONS(2676),
    [sym_float] = ACTIONS(2676),
    [sym_identifier] = ACTIONS(2676),
    [sym_true] = ACTIONS(2676),
    [sym_false] = ACTIONS(2676),
    [sym_none] = ACTIONS(2676),
    [sym_comment] = ACTIONS(72),
  },
  [864] = {
    [sym__primary_expression] = STATE(1255),
    [sym_binary_operator] = STATE(1255),
    [sym_unary_operator] = STATE(1255),
    [sym_attribute] = STATE(1255),
    [sym_subscript] = STATE(1255),
    [sym_call] = STATE(1255),
    [sym_list] = STATE(1255),
    [sym_list_comprehension] = STATE(1255),
    [sym_dictionary] = STATE(1255),
    [sym_dictionary_comprehension] = STATE(1255),
    [sym_set] = STATE(1255),
    [sym_set_comprehension] = STATE(1255),
    [sym_parenthesized_expression] = STATE(1255),
    [sym_tuple] = STATE(1255),
    [sym_generator_expression] = STATE(1255),
    [sym_concatenated_string] = STATE(1255),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_not] = ACTIONS(2678),
    [anon_sym_PLUS] = ACTIONS(762),
    [anon_sym_DASH] = ACTIONS(762),
    [anon_sym_TILDE] = ACTIONS(762),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(2656),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(768),
    [sym_integer] = ACTIONS(2658),
    [sym_float] = ACTIONS(2658),
    [sym_identifier] = ACTIONS(2658),
    [sym_true] = ACTIONS(2658),
    [sym_false] = ACTIONS(2658),
    [sym_none] = ACTIONS(2658),
    [sym_comment] = ACTIONS(72),
  },
  [865] = {
    [aux_sym_comparison_operator_repeat1] = STATE(1261),
    [anon_sym_COMMA] = ACTIONS(998),
    [anon_sym_if] = ACTIONS(998),
    [anon_sym_in] = ACTIONS(1684),
    [anon_sym_not] = ACTIONS(1688),
    [anon_sym_and] = ACTIONS(998),
    [anon_sym_or] = ACTIONS(998),
    [anon_sym_LT] = ACTIONS(1700),
    [anon_sym_LT_EQ] = ACTIONS(1684),
    [anon_sym_EQ_EQ] = ACTIONS(1684),
    [anon_sym_BANG_EQ] = ACTIONS(1684),
    [anon_sym_GT_EQ] = ACTIONS(1684),
    [anon_sym_GT] = ACTIONS(1700),
    [anon_sym_LT_GT] = ACTIONS(1684),
    [anon_sym_is] = ACTIONS(1702),
    [anon_sym_RBRACK] = ACTIONS(998),
    [sym_comment] = ACTIONS(72),
  },
  [866] = {
    [anon_sym_COMMA] = ACTIONS(1644),
    [anon_sym_if] = ACTIONS(784),
    [anon_sym_async] = ACTIONS(1644),
    [anon_sym_for] = ACTIONS(1644),
    [anon_sym_and] = ACTIONS(790),
    [anon_sym_or] = ACTIONS(792),
    [anon_sym_RBRACK] = ACTIONS(1644),
    [sym_comment] = ACTIONS(72),
  },
  [867] = {
    [sym__expression] = STATE(1262),
    [sym__primary_expression] = STATE(145),
    [sym_not_operator] = STATE(1262),
    [sym_boolean_operator] = STATE(1262),
    [sym_binary_operator] = STATE(145),
    [sym_unary_operator] = STATE(145),
    [sym_comparison_operator] = STATE(1262),
    [sym_lambda] = STATE(1262),
    [sym_attribute] = STATE(145),
    [sym_subscript] = STATE(145),
    [sym_call] = STATE(145),
    [sym_list] = STATE(145),
    [sym_list_comprehension] = STATE(145),
    [sym_dictionary] = STATE(145),
    [sym_dictionary_comprehension] = STATE(145),
    [sym_set] = STATE(145),
    [sym_set_comprehension] = STATE(145),
    [sym_parenthesized_expression] = STATE(145),
    [sym_tuple] = STATE(145),
    [sym_generator_expression] = STATE(145),
    [sym_conditional_expression] = STATE(1262),
    [sym_concatenated_string] = STATE(145),
    [sym_await] = STATE(1262),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_not] = ACTIONS(240),
    [anon_sym_PLUS] = ACTIONS(242),
    [anon_sym_DASH] = ACTIONS(242),
    [anon_sym_TILDE] = ACTIONS(242),
    [anon_sym_lambda] = ACTIONS(244),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(248),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(250),
    [sym_integer] = ACTIONS(252),
    [sym_float] = ACTIONS(252),
    [sym_identifier] = ACTIONS(252),
    [sym_true] = ACTIONS(252),
    [sym_false] = ACTIONS(252),
    [sym_none] = ACTIONS(252),
    [anon_sym_await] = ACTIONS(254),
    [sym_comment] = ACTIONS(72),
  },
  [868] = {
    [aux_sym_concatenated_string_repeat1] = STATE(868),
    [anon_sym_DOT] = ACTIONS(1862),
    [anon_sym_LPAREN] = ACTIONS(1862),
    [anon_sym_COMMA] = ACTIONS(1862),
    [anon_sym_STAR] = ACTIONS(1864),
    [anon_sym_GT_GT] = ACTIONS(1862),
    [anon_sym_if] = ACTIONS(1862),
    [anon_sym_async] = ACTIONS(1862),
    [anon_sym_for] = ACTIONS(1862),
    [anon_sym_in] = ACTIONS(1862),
    [anon_sym_AT] = ACTIONS(1862),
    [anon_sym_not] = ACTIONS(1862),
    [anon_sym_and] = ACTIONS(1862),
    [anon_sym_or] = ACTIONS(1862),
    [anon_sym_PLUS] = ACTIONS(1862),
    [anon_sym_DASH] = ACTIONS(1862),
    [anon_sym_SLASH] = ACTIONS(1864),
    [anon_sym_PERCENT] = ACTIONS(1862),
    [anon_sym_SLASH_SLASH] = ACTIONS(1862),
    [anon_sym_STAR_STAR] = ACTIONS(1862),
    [anon_sym_PIPE] = ACTIONS(1862),
    [anon_sym_AMP] = ACTIONS(1862),
    [anon_sym_CARET] = ACTIONS(1862),
    [anon_sym_LT_LT] = ACTIONS(1862),
    [anon_sym_LT] = ACTIONS(1864),
    [anon_sym_LT_EQ] = ACTIONS(1862),
    [anon_sym_EQ_EQ] = ACTIONS(1862),
    [anon_sym_BANG_EQ] = ACTIONS(1862),
    [anon_sym_GT_EQ] = ACTIONS(1862),
    [anon_sym_GT] = ACTIONS(1864),
    [anon_sym_LT_GT] = ACTIONS(1862),
    [anon_sym_is] = ACTIONS(1862),
    [anon_sym_LBRACK] = ACTIONS(1862),
    [anon_sym_RBRACK] = ACTIONS(1862),
    [sym_string] = ACTIONS(2680),
    [sym_comment] = ACTIONS(72),
  },
  [869] = {
    [sym__newline] = ACTIONS(2683),
    [anon_sym_DOT] = ACTIONS(2683),
    [anon_sym_LPAREN] = ACTIONS(2683),
    [anon_sym_COMMA] = ACTIONS(2683),
    [anon_sym_STAR] = ACTIONS(2685),
    [anon_sym_GT_GT] = ACTIONS(2685),
    [anon_sym_if] = ACTIONS(2683),
    [anon_sym_COLON] = ACTIONS(2683),
    [anon_sym_in] = ACTIONS(2683),
    [anon_sym_EQ] = ACTIONS(2685),
    [anon_sym_AT] = ACTIONS(2685),
    [anon_sym_not] = ACTIONS(2683),
    [anon_sym_and] = ACTIONS(2683),
    [anon_sym_or] = ACTIONS(2683),
    [anon_sym_PLUS] = ACTIONS(2685),
    [anon_sym_DASH] = ACTIONS(2685),
    [anon_sym_SLASH] = ACTIONS(2685),
    [anon_sym_PERCENT] = ACTIONS(2685),
    [anon_sym_SLASH_SLASH] = ACTIONS(2685),
    [anon_sym_STAR_STAR] = ACTIONS(2685),
    [anon_sym_PIPE] = ACTIONS(2685),
    [anon_sym_AMP] = ACTIONS(2685),
    [anon_sym_CARET] = ACTIONS(2685),
    [anon_sym_LT_LT] = ACTIONS(2685),
    [anon_sym_LT] = ACTIONS(2685),
    [anon_sym_LT_EQ] = ACTIONS(2683),
    [anon_sym_EQ_EQ] = ACTIONS(2683),
    [anon_sym_BANG_EQ] = ACTIONS(2683),
    [anon_sym_GT_EQ] = ACTIONS(2683),
    [anon_sym_GT] = ACTIONS(2685),
    [anon_sym_LT_GT] = ACTIONS(2683),
    [anon_sym_is] = ACTIONS(2683),
    [anon_sym_PLUS_EQ] = ACTIONS(2683),
    [anon_sym_DASH_EQ] = ACTIONS(2683),
    [anon_sym_STAR_EQ] = ACTIONS(2683),
    [anon_sym_SLASH_EQ] = ACTIONS(2683),
    [anon_sym_AT_EQ] = ACTIONS(2683),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(2683),
    [anon_sym_PERCENT_EQ] = ACTIONS(2683),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2683),
    [anon_sym_GT_GT_EQ] = ACTIONS(2683),
    [anon_sym_LT_LT_EQ] = ACTIONS(2683),
    [anon_sym_AMP_EQ] = ACTIONS(2683),
    [anon_sym_CARET_EQ] = ACTIONS(2683),
    [anon_sym_PIPE_EQ] = ACTIONS(2683),
    [anon_sym_LBRACK] = ACTIONS(2683),
    [sym_comment] = ACTIONS(72),
    [sym__semicolon] = ACTIONS(2683),
  },
  [870] = {
    [anon_sym_COMMA] = ACTIONS(2687),
    [anon_sym_RBRACK] = ACTIONS(2687),
    [anon_sym_RBRACE] = ACTIONS(2687),
    [sym_comment] = ACTIONS(72),
  },
  [871] = {
    [anon_sym_COMMA] = ACTIONS(2687),
    [anon_sym_if] = ACTIONS(1674),
    [anon_sym_and] = ACTIONS(1676),
    [anon_sym_or] = ACTIONS(1678),
    [anon_sym_RBRACK] = ACTIONS(2687),
    [sym_comment] = ACTIONS(72),
  },
  [872] = {
    [sym_list_splat] = STATE(870),
    [sym__expression] = STATE(871),
    [sym__primary_expression] = STATE(430),
    [sym_not_operator] = STATE(871),
    [sym_boolean_operator] = STATE(871),
    [sym_binary_operator] = STATE(430),
    [sym_unary_operator] = STATE(430),
    [sym_comparison_operator] = STATE(871),
    [sym_lambda] = STATE(871),
    [sym_attribute] = STATE(430),
    [sym_subscript] = STATE(430),
    [sym_call] = STATE(430),
    [sym_list] = STATE(430),
    [sym_list_comprehension] = STATE(430),
    [sym_dictionary] = STATE(430),
    [sym_dictionary_comprehension] = STATE(430),
    [sym_set] = STATE(430),
    [sym_set_comprehension] = STATE(430),
    [sym_parenthesized_expression] = STATE(430),
    [sym_tuple] = STATE(430),
    [sym_generator_expression] = STATE(430),
    [sym_conditional_expression] = STATE(871),
    [sym_concatenated_string] = STATE(430),
    [sym_await] = STATE(871),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_STAR] = ACTIONS(238),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_not] = ACTIONS(760),
    [anon_sym_PLUS] = ACTIONS(762),
    [anon_sym_DASH] = ACTIONS(762),
    [anon_sym_TILDE] = ACTIONS(762),
    [anon_sym_lambda] = ACTIONS(764),
    [anon_sym_LBRACK] = ACTIONS(96),
    [anon_sym_RBRACK] = ACTIONS(2689),
    [sym_ellipsis] = ACTIONS(766),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(768),
    [sym_integer] = ACTIONS(770),
    [sym_float] = ACTIONS(770),
    [sym_identifier] = ACTIONS(770),
    [sym_true] = ACTIONS(770),
    [sym_false] = ACTIONS(770),
    [sym_none] = ACTIONS(770),
    [anon_sym_await] = ACTIONS(772),
    [sym_comment] = ACTIONS(72),
  },
  [873] = {
    [aux_sym_list_repeat1] = STATE(873),
    [anon_sym_COMMA] = ACTIONS(2691),
    [anon_sym_RBRACK] = ACTIONS(2687),
    [sym_comment] = ACTIONS(72),
  },
  [874] = {
    [anon_sym_if] = ACTIONS(1921),
    [anon_sym_else] = ACTIONS(2694),
    [anon_sym_and] = ACTIONS(1925),
    [anon_sym_or] = ACTIONS(1927),
    [sym_comment] = ACTIONS(72),
  },
  [875] = {
    [sym_variables] = STATE(1266),
    [sym__primary_expression] = STATE(103),
    [sym_binary_operator] = STATE(103),
    [sym_unary_operator] = STATE(103),
    [sym_attribute] = STATE(103),
    [sym_subscript] = STATE(103),
    [sym_call] = STATE(103),
    [sym_list] = STATE(103),
    [sym_list_comprehension] = STATE(103),
    [sym_dictionary] = STATE(103),
    [sym_dictionary_comprehension] = STATE(103),
    [sym_set] = STATE(103),
    [sym_set_comprehension] = STATE(103),
    [sym_parenthesized_expression] = STATE(103),
    [sym_tuple] = STATE(103),
    [sym_generator_expression] = STATE(103),
    [sym_concatenated_string] = STATE(103),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_PLUS] = ACTIONS(180),
    [anon_sym_DASH] = ACTIONS(180),
    [anon_sym_TILDE] = ACTIONS(180),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(182),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(184),
    [sym_integer] = ACTIONS(186),
    [sym_float] = ACTIONS(186),
    [sym_identifier] = ACTIONS(186),
    [sym_true] = ACTIONS(186),
    [sym_false] = ACTIONS(186),
    [sym_none] = ACTIONS(186),
    [sym_comment] = ACTIONS(72),
  },
  [876] = {
    [anon_sym_in] = ACTIONS(2696),
    [sym_comment] = ACTIONS(72),
  },
  [877] = {
    [anon_sym_COMMA] = ACTIONS(1953),
    [anon_sym_if] = ACTIONS(1953),
    [anon_sym_async] = ACTIONS(1953),
    [anon_sym_for] = ACTIONS(1953),
    [anon_sym_and] = ACTIONS(790),
    [anon_sym_or] = ACTIONS(1953),
    [anon_sym_RBRACK] = ACTIONS(1953),
    [sym_comment] = ACTIONS(72),
  },
  [878] = {
    [sym__newline] = ACTIONS(2698),
    [anon_sym_DOT] = ACTIONS(2698),
    [anon_sym_LPAREN] = ACTIONS(2698),
    [anon_sym_COMMA] = ACTIONS(2698),
    [anon_sym_STAR] = ACTIONS(2700),
    [anon_sym_GT_GT] = ACTIONS(2700),
    [anon_sym_if] = ACTIONS(2698),
    [anon_sym_COLON] = ACTIONS(2698),
    [anon_sym_in] = ACTIONS(2698),
    [anon_sym_EQ] = ACTIONS(2700),
    [anon_sym_AT] = ACTIONS(2700),
    [anon_sym_not] = ACTIONS(2698),
    [anon_sym_and] = ACTIONS(2698),
    [anon_sym_or] = ACTIONS(2698),
    [anon_sym_PLUS] = ACTIONS(2700),
    [anon_sym_DASH] = ACTIONS(2700),
    [anon_sym_SLASH] = ACTIONS(2700),
    [anon_sym_PERCENT] = ACTIONS(2700),
    [anon_sym_SLASH_SLASH] = ACTIONS(2700),
    [anon_sym_STAR_STAR] = ACTIONS(2700),
    [anon_sym_PIPE] = ACTIONS(2700),
    [anon_sym_AMP] = ACTIONS(2700),
    [anon_sym_CARET] = ACTIONS(2700),
    [anon_sym_LT_LT] = ACTIONS(2700),
    [anon_sym_LT] = ACTIONS(2700),
    [anon_sym_LT_EQ] = ACTIONS(2698),
    [anon_sym_EQ_EQ] = ACTIONS(2698),
    [anon_sym_BANG_EQ] = ACTIONS(2698),
    [anon_sym_GT_EQ] = ACTIONS(2698),
    [anon_sym_GT] = ACTIONS(2700),
    [anon_sym_LT_GT] = ACTIONS(2698),
    [anon_sym_is] = ACTIONS(2698),
    [anon_sym_PLUS_EQ] = ACTIONS(2698),
    [anon_sym_DASH_EQ] = ACTIONS(2698),
    [anon_sym_STAR_EQ] = ACTIONS(2698),
    [anon_sym_SLASH_EQ] = ACTIONS(2698),
    [anon_sym_AT_EQ] = ACTIONS(2698),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(2698),
    [anon_sym_PERCENT_EQ] = ACTIONS(2698),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2698),
    [anon_sym_GT_GT_EQ] = ACTIONS(2698),
    [anon_sym_LT_LT_EQ] = ACTIONS(2698),
    [anon_sym_AMP_EQ] = ACTIONS(2698),
    [anon_sym_CARET_EQ] = ACTIONS(2698),
    [anon_sym_PIPE_EQ] = ACTIONS(2698),
    [anon_sym_LBRACK] = ACTIONS(2698),
    [sym_comment] = ACTIONS(72),
    [sym__semicolon] = ACTIONS(2698),
  },
  [879] = {
    [sym__expression] = STATE(1273),
    [sym__primary_expression] = STATE(1274),
    [sym_not_operator] = STATE(1273),
    [sym_boolean_operator] = STATE(1273),
    [sym_binary_operator] = STATE(1274),
    [sym_unary_operator] = STATE(1274),
    [sym_comparison_operator] = STATE(1273),
    [sym_lambda] = STATE(1273),
    [sym_attribute] = STATE(1274),
    [sym_subscript] = STATE(1274),
    [sym_call] = STATE(1274),
    [sym_list] = STATE(1274),
    [sym_list_comprehension] = STATE(1274),
    [sym_dictionary] = STATE(1274),
    [sym_dictionary_comprehension] = STATE(1274),
    [sym_set] = STATE(1274),
    [sym_set_comprehension] = STATE(1274),
    [sym_parenthesized_expression] = STATE(1274),
    [sym_tuple] = STATE(1274),
    [sym_generator_expression] = STATE(1274),
    [sym_conditional_expression] = STATE(1273),
    [sym_concatenated_string] = STATE(1274),
    [sym_await] = STATE(1273),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_not] = ACTIONS(2702),
    [anon_sym_PLUS] = ACTIONS(2704),
    [anon_sym_DASH] = ACTIONS(2704),
    [anon_sym_TILDE] = ACTIONS(2704),
    [anon_sym_lambda] = ACTIONS(2706),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(2708),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(2710),
    [sym_integer] = ACTIONS(2712),
    [sym_float] = ACTIONS(2712),
    [sym_identifier] = ACTIONS(2712),
    [sym_true] = ACTIONS(2712),
    [sym_false] = ACTIONS(2712),
    [sym_none] = ACTIONS(2712),
    [anon_sym_await] = ACTIONS(2714),
    [sym_comment] = ACTIONS(72),
  },
  [880] = {
    [sym_for_in_clause] = STATE(1275),
    [sym_if_clause] = STATE(1275),
    [aux_sym__comprehension_body_repeat1] = STATE(1275),
    [anon_sym_if] = ACTIONS(1716),
    [anon_sym_async] = ACTIONS(786),
    [anon_sym_for] = ACTIONS(788),
    [anon_sym_RBRACK] = ACTIONS(2166),
    [sym_comment] = ACTIONS(72),
  },
  [881] = {
    [sym_argument_list] = STATE(251),
    [sym_generator_expression] = STATE(251),
    [anon_sym_DOT] = ACTIONS(1980),
    [anon_sym_LPAREN] = ACTIONS(424),
    [anon_sym_COMMA] = ACTIONS(1980),
    [anon_sym_STAR] = ACTIONS(1982),
    [anon_sym_GT_GT] = ACTIONS(1980),
    [anon_sym_if] = ACTIONS(1980),
    [anon_sym_async] = ACTIONS(1980),
    [anon_sym_for] = ACTIONS(1980),
    [anon_sym_in] = ACTIONS(1980),
    [anon_sym_AT] = ACTIONS(1980),
    [anon_sym_not] = ACTIONS(1980),
    [anon_sym_and] = ACTIONS(1980),
    [anon_sym_or] = ACTIONS(1980),
    [anon_sym_PLUS] = ACTIONS(1980),
    [anon_sym_DASH] = ACTIONS(1980),
    [anon_sym_SLASH] = ACTIONS(1982),
    [anon_sym_PERCENT] = ACTIONS(1980),
    [anon_sym_SLASH_SLASH] = ACTIONS(1980),
    [anon_sym_STAR_STAR] = ACTIONS(806),
    [anon_sym_PIPE] = ACTIONS(1980),
    [anon_sym_AMP] = ACTIONS(1980),
    [anon_sym_CARET] = ACTIONS(1980),
    [anon_sym_LT_LT] = ACTIONS(1980),
    [anon_sym_LT] = ACTIONS(1982),
    [anon_sym_LT_EQ] = ACTIONS(1980),
    [anon_sym_EQ_EQ] = ACTIONS(1980),
    [anon_sym_BANG_EQ] = ACTIONS(1980),
    [anon_sym_GT_EQ] = ACTIONS(1980),
    [anon_sym_GT] = ACTIONS(1982),
    [anon_sym_LT_GT] = ACTIONS(1980),
    [anon_sym_is] = ACTIONS(1980),
    [anon_sym_LBRACK] = ACTIONS(1980),
    [anon_sym_RBRACK] = ACTIONS(1980),
    [sym_comment] = ACTIONS(72),
  },
  [882] = {
    [sym_argument_list] = STATE(251),
    [sym_generator_expression] = STATE(251),
    [anon_sym_DOT] = ACTIONS(1980),
    [anon_sym_LPAREN] = ACTIONS(424),
    [anon_sym_COMMA] = ACTIONS(1980),
    [anon_sym_STAR] = ACTIONS(794),
    [anon_sym_GT_GT] = ACTIONS(1980),
    [anon_sym_if] = ACTIONS(1980),
    [anon_sym_async] = ACTIONS(1980),
    [anon_sym_for] = ACTIONS(1980),
    [anon_sym_in] = ACTIONS(1980),
    [anon_sym_AT] = ACTIONS(800),
    [anon_sym_not] = ACTIONS(1980),
    [anon_sym_and] = ACTIONS(1980),
    [anon_sym_or] = ACTIONS(1980),
    [anon_sym_PLUS] = ACTIONS(804),
    [anon_sym_DASH] = ACTIONS(804),
    [anon_sym_SLASH] = ACTIONS(794),
    [anon_sym_PERCENT] = ACTIONS(800),
    [anon_sym_SLASH_SLASH] = ACTIONS(800),
    [anon_sym_STAR_STAR] = ACTIONS(806),
    [anon_sym_PIPE] = ACTIONS(1980),
    [anon_sym_AMP] = ACTIONS(1980),
    [anon_sym_CARET] = ACTIONS(1980),
    [anon_sym_LT_LT] = ACTIONS(1980),
    [anon_sym_LT] = ACTIONS(1982),
    [anon_sym_LT_EQ] = ACTIONS(1980),
    [anon_sym_EQ_EQ] = ACTIONS(1980),
    [anon_sym_BANG_EQ] = ACTIONS(1980),
    [anon_sym_GT_EQ] = ACTIONS(1980),
    [anon_sym_GT] = ACTIONS(1982),
    [anon_sym_LT_GT] = ACTIONS(1980),
    [anon_sym_is] = ACTIONS(1980),
    [anon_sym_LBRACK] = ACTIONS(1980),
    [anon_sym_RBRACK] = ACTIONS(1980),
    [sym_comment] = ACTIONS(72),
  },
  [883] = {
    [sym_argument_list] = STATE(251),
    [sym_generator_expression] = STATE(251),
    [anon_sym_DOT] = ACTIONS(422),
    [anon_sym_LPAREN] = ACTIONS(424),
    [anon_sym_COMMA] = ACTIONS(1984),
    [anon_sym_STAR] = ACTIONS(794),
    [anon_sym_GT_GT] = ACTIONS(796),
    [anon_sym_if] = ACTIONS(1984),
    [anon_sym_async] = ACTIONS(1984),
    [anon_sym_for] = ACTIONS(1984),
    [anon_sym_in] = ACTIONS(1984),
    [anon_sym_AT] = ACTIONS(800),
    [anon_sym_not] = ACTIONS(1984),
    [anon_sym_and] = ACTIONS(1984),
    [anon_sym_or] = ACTIONS(1984),
    [anon_sym_PLUS] = ACTIONS(804),
    [anon_sym_DASH] = ACTIONS(804),
    [anon_sym_SLASH] = ACTIONS(794),
    [anon_sym_PERCENT] = ACTIONS(800),
    [anon_sym_SLASH_SLASH] = ACTIONS(800),
    [anon_sym_STAR_STAR] = ACTIONS(806),
    [anon_sym_PIPE] = ACTIONS(808),
    [anon_sym_AMP] = ACTIONS(810),
    [anon_sym_CARET] = ACTIONS(812),
    [anon_sym_LT_LT] = ACTIONS(796),
    [anon_sym_LT] = ACTIONS(1986),
    [anon_sym_LT_EQ] = ACTIONS(1984),
    [anon_sym_EQ_EQ] = ACTIONS(1984),
    [anon_sym_BANG_EQ] = ACTIONS(1984),
    [anon_sym_GT_EQ] = ACTIONS(1984),
    [anon_sym_GT] = ACTIONS(1986),
    [anon_sym_LT_GT] = ACTIONS(1984),
    [anon_sym_is] = ACTIONS(1984),
    [anon_sym_LBRACK] = ACTIONS(450),
    [anon_sym_RBRACK] = ACTIONS(1984),
    [sym_comment] = ACTIONS(72),
  },
  [884] = {
    [sym__primary_expression] = STATE(1276),
    [sym_binary_operator] = STATE(1276),
    [sym_unary_operator] = STATE(1276),
    [sym_attribute] = STATE(1276),
    [sym_subscript] = STATE(1276),
    [sym_call] = STATE(1276),
    [sym_list] = STATE(1276),
    [sym_list_comprehension] = STATE(1276),
    [sym_dictionary] = STATE(1276),
    [sym_dictionary_comprehension] = STATE(1276),
    [sym_set] = STATE(1276),
    [sym_set_comprehension] = STATE(1276),
    [sym_parenthesized_expression] = STATE(1276),
    [sym_tuple] = STATE(1276),
    [sym_generator_expression] = STATE(1276),
    [sym_concatenated_string] = STATE(1276),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_PLUS] = ACTIONS(242),
    [anon_sym_DASH] = ACTIONS(242),
    [anon_sym_TILDE] = ACTIONS(242),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(2716),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(250),
    [sym_integer] = ACTIONS(2718),
    [sym_float] = ACTIONS(2718),
    [sym_identifier] = ACTIONS(2718),
    [sym_true] = ACTIONS(2718),
    [sym_false] = ACTIONS(2718),
    [sym_none] = ACTIONS(2718),
    [sym_comment] = ACTIONS(72),
  },
  [885] = {
    [sym_argument_list] = STATE(251),
    [sym_generator_expression] = STATE(251),
    [anon_sym_DOT] = ACTIONS(1980),
    [anon_sym_LPAREN] = ACTIONS(424),
    [anon_sym_COMMA] = ACTIONS(1980),
    [anon_sym_STAR] = ACTIONS(794),
    [anon_sym_GT_GT] = ACTIONS(1980),
    [anon_sym_if] = ACTIONS(1980),
    [anon_sym_async] = ACTIONS(1980),
    [anon_sym_for] = ACTIONS(1980),
    [anon_sym_in] = ACTIONS(1980),
    [anon_sym_AT] = ACTIONS(800),
    [anon_sym_not] = ACTIONS(1980),
    [anon_sym_and] = ACTIONS(1980),
    [anon_sym_or] = ACTIONS(1980),
    [anon_sym_PLUS] = ACTIONS(1980),
    [anon_sym_DASH] = ACTIONS(1980),
    [anon_sym_SLASH] = ACTIONS(794),
    [anon_sym_PERCENT] = ACTIONS(800),
    [anon_sym_SLASH_SLASH] = ACTIONS(800),
    [anon_sym_STAR_STAR] = ACTIONS(806),
    [anon_sym_PIPE] = ACTIONS(1980),
    [anon_sym_AMP] = ACTIONS(1980),
    [anon_sym_CARET] = ACTIONS(1980),
    [anon_sym_LT_LT] = ACTIONS(1980),
    [anon_sym_LT] = ACTIONS(1982),
    [anon_sym_LT_EQ] = ACTIONS(1980),
    [anon_sym_EQ_EQ] = ACTIONS(1980),
    [anon_sym_BANG_EQ] = ACTIONS(1980),
    [anon_sym_GT_EQ] = ACTIONS(1980),
    [anon_sym_GT] = ACTIONS(1982),
    [anon_sym_LT_GT] = ACTIONS(1980),
    [anon_sym_is] = ACTIONS(1980),
    [anon_sym_LBRACK] = ACTIONS(1980),
    [anon_sym_RBRACK] = ACTIONS(1980),
    [sym_comment] = ACTIONS(72),
  },
  [886] = {
    [sym_argument_list] = STATE(251),
    [sym_generator_expression] = STATE(251),
    [anon_sym_DOT] = ACTIONS(1980),
    [anon_sym_LPAREN] = ACTIONS(424),
    [anon_sym_COMMA] = ACTIONS(1980),
    [anon_sym_STAR] = ACTIONS(794),
    [anon_sym_GT_GT] = ACTIONS(796),
    [anon_sym_if] = ACTIONS(1980),
    [anon_sym_async] = ACTIONS(1980),
    [anon_sym_for] = ACTIONS(1980),
    [anon_sym_in] = ACTIONS(1980),
    [anon_sym_AT] = ACTIONS(800),
    [anon_sym_not] = ACTIONS(1980),
    [anon_sym_and] = ACTIONS(1980),
    [anon_sym_or] = ACTIONS(1980),
    [anon_sym_PLUS] = ACTIONS(804),
    [anon_sym_DASH] = ACTIONS(804),
    [anon_sym_SLASH] = ACTIONS(794),
    [anon_sym_PERCENT] = ACTIONS(800),
    [anon_sym_SLASH_SLASH] = ACTIONS(800),
    [anon_sym_STAR_STAR] = ACTIONS(806),
    [anon_sym_PIPE] = ACTIONS(1980),
    [anon_sym_AMP] = ACTIONS(810),
    [anon_sym_CARET] = ACTIONS(812),
    [anon_sym_LT_LT] = ACTIONS(796),
    [anon_sym_LT] = ACTIONS(1982),
    [anon_sym_LT_EQ] = ACTIONS(1980),
    [anon_sym_EQ_EQ] = ACTIONS(1980),
    [anon_sym_BANG_EQ] = ACTIONS(1980),
    [anon_sym_GT_EQ] = ACTIONS(1980),
    [anon_sym_GT] = ACTIONS(1982),
    [anon_sym_LT_GT] = ACTIONS(1980),
    [anon_sym_is] = ACTIONS(1980),
    [anon_sym_LBRACK] = ACTIONS(1980),
    [anon_sym_RBRACK] = ACTIONS(1980),
    [sym_comment] = ACTIONS(72),
  },
  [887] = {
    [sym_argument_list] = STATE(251),
    [sym_generator_expression] = STATE(251),
    [anon_sym_DOT] = ACTIONS(1980),
    [anon_sym_LPAREN] = ACTIONS(424),
    [anon_sym_COMMA] = ACTIONS(1980),
    [anon_sym_STAR] = ACTIONS(794),
    [anon_sym_GT_GT] = ACTIONS(796),
    [anon_sym_if] = ACTIONS(1980),
    [anon_sym_async] = ACTIONS(1980),
    [anon_sym_for] = ACTIONS(1980),
    [anon_sym_in] = ACTIONS(1980),
    [anon_sym_AT] = ACTIONS(800),
    [anon_sym_not] = ACTIONS(1980),
    [anon_sym_and] = ACTIONS(1980),
    [anon_sym_or] = ACTIONS(1980),
    [anon_sym_PLUS] = ACTIONS(804),
    [anon_sym_DASH] = ACTIONS(804),
    [anon_sym_SLASH] = ACTIONS(794),
    [anon_sym_PERCENT] = ACTIONS(800),
    [anon_sym_SLASH_SLASH] = ACTIONS(800),
    [anon_sym_STAR_STAR] = ACTIONS(806),
    [anon_sym_PIPE] = ACTIONS(1980),
    [anon_sym_AMP] = ACTIONS(1980),
    [anon_sym_CARET] = ACTIONS(812),
    [anon_sym_LT_LT] = ACTIONS(796),
    [anon_sym_LT] = ACTIONS(1982),
    [anon_sym_LT_EQ] = ACTIONS(1980),
    [anon_sym_EQ_EQ] = ACTIONS(1980),
    [anon_sym_BANG_EQ] = ACTIONS(1980),
    [anon_sym_GT_EQ] = ACTIONS(1980),
    [anon_sym_GT] = ACTIONS(1982),
    [anon_sym_LT_GT] = ACTIONS(1980),
    [anon_sym_is] = ACTIONS(1980),
    [anon_sym_LBRACK] = ACTIONS(1980),
    [anon_sym_RBRACK] = ACTIONS(1980),
    [sym_comment] = ACTIONS(72),
  },
  [888] = {
    [sym_argument_list] = STATE(251),
    [sym_generator_expression] = STATE(251),
    [anon_sym_DOT] = ACTIONS(1980),
    [anon_sym_LPAREN] = ACTIONS(424),
    [anon_sym_COMMA] = ACTIONS(1980),
    [anon_sym_STAR] = ACTIONS(794),
    [anon_sym_GT_GT] = ACTIONS(796),
    [anon_sym_if] = ACTIONS(1980),
    [anon_sym_async] = ACTIONS(1980),
    [anon_sym_for] = ACTIONS(1980),
    [anon_sym_in] = ACTIONS(1980),
    [anon_sym_AT] = ACTIONS(800),
    [anon_sym_not] = ACTIONS(1980),
    [anon_sym_and] = ACTIONS(1980),
    [anon_sym_or] = ACTIONS(1980),
    [anon_sym_PLUS] = ACTIONS(804),
    [anon_sym_DASH] = ACTIONS(804),
    [anon_sym_SLASH] = ACTIONS(794),
    [anon_sym_PERCENT] = ACTIONS(800),
    [anon_sym_SLASH_SLASH] = ACTIONS(800),
    [anon_sym_STAR_STAR] = ACTIONS(806),
    [anon_sym_PIPE] = ACTIONS(1980),
    [anon_sym_AMP] = ACTIONS(1980),
    [anon_sym_CARET] = ACTIONS(1980),
    [anon_sym_LT_LT] = ACTIONS(796),
    [anon_sym_LT] = ACTIONS(1982),
    [anon_sym_LT_EQ] = ACTIONS(1980),
    [anon_sym_EQ_EQ] = ACTIONS(1980),
    [anon_sym_BANG_EQ] = ACTIONS(1980),
    [anon_sym_GT_EQ] = ACTIONS(1980),
    [anon_sym_GT] = ACTIONS(1982),
    [anon_sym_LT_GT] = ACTIONS(1980),
    [anon_sym_is] = ACTIONS(1980),
    [anon_sym_LBRACK] = ACTIONS(1980),
    [anon_sym_RBRACK] = ACTIONS(1980),
    [sym_comment] = ACTIONS(72),
  },
  [889] = {
    [aux_sym_comparison_operator_repeat1] = STATE(889),
    [anon_sym_COMMA] = ACTIONS(1984),
    [anon_sym_if] = ACTIONS(1984),
    [anon_sym_async] = ACTIONS(1984),
    [anon_sym_for] = ACTIONS(1984),
    [anon_sym_in] = ACTIONS(2720),
    [anon_sym_not] = ACTIONS(2723),
    [anon_sym_and] = ACTIONS(1984),
    [anon_sym_or] = ACTIONS(1984),
    [anon_sym_LT] = ACTIONS(2726),
    [anon_sym_LT_EQ] = ACTIONS(2720),
    [anon_sym_EQ_EQ] = ACTIONS(2720),
    [anon_sym_BANG_EQ] = ACTIONS(2720),
    [anon_sym_GT_EQ] = ACTIONS(2720),
    [anon_sym_GT] = ACTIONS(2726),
    [anon_sym_LT_GT] = ACTIONS(2720),
    [anon_sym_is] = ACTIONS(2729),
    [anon_sym_RBRACK] = ACTIONS(1984),
    [sym_comment] = ACTIONS(72),
  },
  [890] = {
    [anon_sym_COMMA] = ACTIONS(2515),
    [anon_sym_if] = ACTIONS(1758),
    [anon_sym_and] = ACTIONS(1760),
    [anon_sym_or] = ACTIONS(1762),
    [anon_sym_RBRACE] = ACTIONS(2515),
    [sym_comment] = ACTIONS(72),
  },
  [891] = {
    [anon_sym_COMMA] = ACTIONS(716),
    [anon_sym_if] = ACTIONS(716),
    [anon_sym_and] = ACTIONS(1760),
    [anon_sym_or] = ACTIONS(1762),
    [anon_sym_RBRACE] = ACTIONS(716),
    [sym_comment] = ACTIONS(72),
  },
  [892] = {
    [sym__expression] = STATE(1277),
    [sym__primary_expression] = STATE(463),
    [sym_not_operator] = STATE(1277),
    [sym_boolean_operator] = STATE(1277),
    [sym_binary_operator] = STATE(463),
    [sym_unary_operator] = STATE(463),
    [sym_comparison_operator] = STATE(1277),
    [sym_lambda] = STATE(1277),
    [sym_attribute] = STATE(463),
    [sym_subscript] = STATE(463),
    [sym_call] = STATE(463),
    [sym_list] = STATE(463),
    [sym_list_comprehension] = STATE(463),
    [sym_dictionary] = STATE(463),
    [sym_dictionary_comprehension] = STATE(463),
    [sym_set] = STATE(463),
    [sym_set_comprehension] = STATE(463),
    [sym_parenthesized_expression] = STATE(463),
    [sym_tuple] = STATE(463),
    [sym_generator_expression] = STATE(463),
    [sym_conditional_expression] = STATE(1277),
    [sym_concatenated_string] = STATE(463),
    [sym_await] = STATE(1277),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_not] = ACTIONS(822),
    [anon_sym_PLUS] = ACTIONS(824),
    [anon_sym_DASH] = ACTIONS(824),
    [anon_sym_TILDE] = ACTIONS(824),
    [anon_sym_lambda] = ACTIONS(826),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(828),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(830),
    [sym_integer] = ACTIONS(832),
    [sym_float] = ACTIONS(832),
    [sym_identifier] = ACTIONS(832),
    [sym_true] = ACTIONS(832),
    [sym_false] = ACTIONS(832),
    [sym_none] = ACTIONS(832),
    [anon_sym_await] = ACTIONS(834),
    [sym_comment] = ACTIONS(72),
  },
  [893] = {
    [anon_sym_COLON] = ACTIONS(2732),
    [sym_comment] = ACTIONS(72),
  },
  [894] = {
    [aux_sym_concatenated_string_repeat1] = STATE(1279),
    [anon_sym_DOT] = ACTIONS(886),
    [anon_sym_LPAREN] = ACTIONS(886),
    [anon_sym_COMMA] = ACTIONS(886),
    [anon_sym_STAR] = ACTIONS(888),
    [anon_sym_GT_GT] = ACTIONS(886),
    [anon_sym_if] = ACTIONS(886),
    [anon_sym_in] = ACTIONS(886),
    [anon_sym_AT] = ACTIONS(886),
    [anon_sym_not] = ACTIONS(886),
    [anon_sym_and] = ACTIONS(886),
    [anon_sym_or] = ACTIONS(886),
    [anon_sym_PLUS] = ACTIONS(886),
    [anon_sym_DASH] = ACTIONS(886),
    [anon_sym_SLASH] = ACTIONS(888),
    [anon_sym_PERCENT] = ACTIONS(886),
    [anon_sym_SLASH_SLASH] = ACTIONS(886),
    [anon_sym_STAR_STAR] = ACTIONS(886),
    [anon_sym_PIPE] = ACTIONS(886),
    [anon_sym_AMP] = ACTIONS(886),
    [anon_sym_CARET] = ACTIONS(886),
    [anon_sym_LT_LT] = ACTIONS(886),
    [anon_sym_LT] = ACTIONS(888),
    [anon_sym_LT_EQ] = ACTIONS(886),
    [anon_sym_EQ_EQ] = ACTIONS(886),
    [anon_sym_BANG_EQ] = ACTIONS(886),
    [anon_sym_GT_EQ] = ACTIONS(886),
    [anon_sym_GT] = ACTIONS(888),
    [anon_sym_LT_GT] = ACTIONS(886),
    [anon_sym_is] = ACTIONS(886),
    [anon_sym_LBRACK] = ACTIONS(886),
    [anon_sym_RBRACE] = ACTIONS(886),
    [sym_string] = ACTIONS(2734),
    [sym_comment] = ACTIONS(72),
  },
  [895] = {
    [sym__expression] = STATE(1280),
    [sym__primary_expression] = STATE(513),
    [sym_not_operator] = STATE(1280),
    [sym_boolean_operator] = STATE(1280),
    [sym_binary_operator] = STATE(513),
    [sym_unary_operator] = STATE(513),
    [sym_comparison_operator] = STATE(1280),
    [sym_lambda] = STATE(1280),
    [sym_attribute] = STATE(513),
    [sym_subscript] = STATE(513),
    [sym_call] = STATE(513),
    [sym_list] = STATE(513),
    [sym_list_comprehension] = STATE(513),
    [sym_dictionary] = STATE(513),
    [sym_dictionary_comprehension] = STATE(513),
    [sym_set] = STATE(513),
    [sym_set_comprehension] = STATE(513),
    [sym_parenthesized_expression] = STATE(513),
    [sym_tuple] = STATE(513),
    [sym_generator_expression] = STATE(513),
    [sym_conditional_expression] = STATE(1280),
    [sym_concatenated_string] = STATE(513),
    [sym_await] = STATE(1280),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_not] = ACTIONS(914),
    [anon_sym_PLUS] = ACTIONS(916),
    [anon_sym_DASH] = ACTIONS(916),
    [anon_sym_TILDE] = ACTIONS(916),
    [anon_sym_lambda] = ACTIONS(918),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(920),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(922),
    [sym_integer] = ACTIONS(924),
    [sym_float] = ACTIONS(924),
    [sym_identifier] = ACTIONS(924),
    [sym_true] = ACTIONS(924),
    [sym_false] = ACTIONS(924),
    [sym_none] = ACTIONS(924),
    [anon_sym_await] = ACTIONS(926),
    [sym_comment] = ACTIONS(72),
  },
  [896] = {
    [sym__expression] = STATE(604),
    [sym__primary_expression] = STATE(463),
    [sym_not_operator] = STATE(604),
    [sym_boolean_operator] = STATE(604),
    [sym_binary_operator] = STATE(463),
    [sym_unary_operator] = STATE(463),
    [sym_comparison_operator] = STATE(604),
    [sym_lambda] = STATE(604),
    [sym_attribute] = STATE(463),
    [sym_subscript] = STATE(463),
    [sym_call] = STATE(463),
    [sym_list] = STATE(463),
    [sym_list_comprehension] = STATE(463),
    [sym_dictionary] = STATE(463),
    [sym_dictionary_comprehension] = STATE(463),
    [sym_set] = STATE(463),
    [sym_set_comprehension] = STATE(463),
    [sym_parenthesized_expression] = STATE(463),
    [sym_tuple] = STATE(463),
    [sym_generator_expression] = STATE(463),
    [sym_conditional_expression] = STATE(604),
    [sym_concatenated_string] = STATE(463),
    [sym_await] = STATE(604),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_not] = ACTIONS(822),
    [anon_sym_PLUS] = ACTIONS(824),
    [anon_sym_DASH] = ACTIONS(824),
    [anon_sym_TILDE] = ACTIONS(824),
    [anon_sym_lambda] = ACTIONS(826),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(828),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(830),
    [sym_integer] = ACTIONS(832),
    [sym_float] = ACTIONS(832),
    [sym_identifier] = ACTIONS(832),
    [sym_true] = ACTIONS(832),
    [sym_false] = ACTIONS(832),
    [sym_none] = ACTIONS(832),
    [anon_sym_await] = ACTIONS(834),
    [sym_comment] = ACTIONS(72),
  },
  [897] = {
    [sym__expression] = STATE(1281),
    [sym__primary_expression] = STATE(463),
    [sym_not_operator] = STATE(1281),
    [sym_boolean_operator] = STATE(1281),
    [sym_binary_operator] = STATE(463),
    [sym_unary_operator] = STATE(463),
    [sym_comparison_operator] = STATE(1281),
    [sym_lambda] = STATE(1281),
    [sym_attribute] = STATE(463),
    [sym_subscript] = STATE(463),
    [sym_call] = STATE(463),
    [sym_list] = STATE(463),
    [sym_list_comprehension] = STATE(463),
    [sym_dictionary] = STATE(463),
    [sym_dictionary_comprehension] = STATE(463),
    [sym_set] = STATE(463),
    [sym_set_comprehension] = STATE(463),
    [sym_parenthesized_expression] = STATE(463),
    [sym_tuple] = STATE(463),
    [sym_generator_expression] = STATE(463),
    [sym_conditional_expression] = STATE(1281),
    [sym_concatenated_string] = STATE(463),
    [sym_await] = STATE(1281),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_not] = ACTIONS(822),
    [anon_sym_PLUS] = ACTIONS(824),
    [anon_sym_DASH] = ACTIONS(824),
    [anon_sym_TILDE] = ACTIONS(824),
    [anon_sym_lambda] = ACTIONS(826),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(828),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(830),
    [sym_integer] = ACTIONS(832),
    [sym_float] = ACTIONS(832),
    [sym_identifier] = ACTIONS(832),
    [sym_true] = ACTIONS(832),
    [sym_false] = ACTIONS(832),
    [sym_none] = ACTIONS(832),
    [anon_sym_await] = ACTIONS(834),
    [sym_comment] = ACTIONS(72),
  },
  [898] = {
    [sym__primary_expression] = STATE(1282),
    [sym_binary_operator] = STATE(1282),
    [sym_unary_operator] = STATE(1282),
    [sym_attribute] = STATE(1282),
    [sym_subscript] = STATE(1282),
    [sym_call] = STATE(1282),
    [sym_list] = STATE(1282),
    [sym_list_comprehension] = STATE(1282),
    [sym_dictionary] = STATE(1282),
    [sym_dictionary_comprehension] = STATE(1282),
    [sym_set] = STATE(1282),
    [sym_set_comprehension] = STATE(1282),
    [sym_parenthesized_expression] = STATE(1282),
    [sym_tuple] = STATE(1282),
    [sym_generator_expression] = STATE(1282),
    [sym_concatenated_string] = STATE(1282),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_PLUS] = ACTIONS(824),
    [anon_sym_DASH] = ACTIONS(824),
    [anon_sym_TILDE] = ACTIONS(824),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(2736),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(830),
    [sym_integer] = ACTIONS(2738),
    [sym_float] = ACTIONS(2738),
    [sym_identifier] = ACTIONS(2738),
    [sym_true] = ACTIONS(2738),
    [sym_false] = ACTIONS(2738),
    [sym_none] = ACTIONS(2738),
    [sym_comment] = ACTIONS(72),
  },
  [899] = {
    [sym__primary_expression] = STATE(1283),
    [sym_binary_operator] = STATE(1283),
    [sym_unary_operator] = STATE(1283),
    [sym_attribute] = STATE(1283),
    [sym_subscript] = STATE(1283),
    [sym_call] = STATE(1283),
    [sym_list] = STATE(1283),
    [sym_list_comprehension] = STATE(1283),
    [sym_dictionary] = STATE(1283),
    [sym_dictionary_comprehension] = STATE(1283),
    [sym_set] = STATE(1283),
    [sym_set_comprehension] = STATE(1283),
    [sym_parenthesized_expression] = STATE(1283),
    [sym_tuple] = STATE(1283),
    [sym_generator_expression] = STATE(1283),
    [sym_concatenated_string] = STATE(1283),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_PLUS] = ACTIONS(824),
    [anon_sym_DASH] = ACTIONS(824),
    [anon_sym_TILDE] = ACTIONS(824),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(2740),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(830),
    [sym_integer] = ACTIONS(2742),
    [sym_float] = ACTIONS(2742),
    [sym_identifier] = ACTIONS(2742),
    [sym_true] = ACTIONS(2742),
    [sym_false] = ACTIONS(2742),
    [sym_none] = ACTIONS(2742),
    [sym_comment] = ACTIONS(72),
  },
  [900] = {
    [sym__primary_expression] = STATE(1284),
    [sym_binary_operator] = STATE(1284),
    [sym_unary_operator] = STATE(1284),
    [sym_attribute] = STATE(1284),
    [sym_subscript] = STATE(1284),
    [sym_call] = STATE(1284),
    [sym_list] = STATE(1284),
    [sym_list_comprehension] = STATE(1284),
    [sym_dictionary] = STATE(1284),
    [sym_dictionary_comprehension] = STATE(1284),
    [sym_set] = STATE(1284),
    [sym_set_comprehension] = STATE(1284),
    [sym_parenthesized_expression] = STATE(1284),
    [sym_tuple] = STATE(1284),
    [sym_generator_expression] = STATE(1284),
    [sym_concatenated_string] = STATE(1284),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_PLUS] = ACTIONS(824),
    [anon_sym_DASH] = ACTIONS(824),
    [anon_sym_TILDE] = ACTIONS(824),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(2744),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(830),
    [sym_integer] = ACTIONS(2746),
    [sym_float] = ACTIONS(2746),
    [sym_identifier] = ACTIONS(2746),
    [sym_true] = ACTIONS(2746),
    [sym_false] = ACTIONS(2746),
    [sym_none] = ACTIONS(2746),
    [sym_comment] = ACTIONS(72),
  },
  [901] = {
    [anon_sym_in] = ACTIONS(2748),
    [sym_comment] = ACTIONS(72),
  },
  [902] = {
    [sym__primary_expression] = STATE(1286),
    [sym_binary_operator] = STATE(1286),
    [sym_unary_operator] = STATE(1286),
    [sym_attribute] = STATE(1286),
    [sym_subscript] = STATE(1286),
    [sym_call] = STATE(1286),
    [sym_list] = STATE(1286),
    [sym_list_comprehension] = STATE(1286),
    [sym_dictionary] = STATE(1286),
    [sym_dictionary_comprehension] = STATE(1286),
    [sym_set] = STATE(1286),
    [sym_set_comprehension] = STATE(1286),
    [sym_parenthesized_expression] = STATE(1286),
    [sym_tuple] = STATE(1286),
    [sym_generator_expression] = STATE(1286),
    [sym_concatenated_string] = STATE(1286),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_PLUS] = ACTIONS(824),
    [anon_sym_DASH] = ACTIONS(824),
    [anon_sym_TILDE] = ACTIONS(824),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(2750),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(830),
    [sym_integer] = ACTIONS(2752),
    [sym_float] = ACTIONS(2752),
    [sym_identifier] = ACTIONS(2752),
    [sym_true] = ACTIONS(2752),
    [sym_false] = ACTIONS(2752),
    [sym_none] = ACTIONS(2752),
    [sym_comment] = ACTIONS(72),
  },
  [903] = {
    [sym__primary_expression] = STATE(621),
    [sym_binary_operator] = STATE(621),
    [sym_unary_operator] = STATE(621),
    [sym_attribute] = STATE(621),
    [sym_subscript] = STATE(621),
    [sym_call] = STATE(621),
    [sym_list] = STATE(621),
    [sym_list_comprehension] = STATE(621),
    [sym_dictionary] = STATE(621),
    [sym_dictionary_comprehension] = STATE(621),
    [sym_set] = STATE(621),
    [sym_set_comprehension] = STATE(621),
    [sym_parenthesized_expression] = STATE(621),
    [sym_tuple] = STATE(621),
    [sym_generator_expression] = STATE(621),
    [sym_concatenated_string] = STATE(621),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_PLUS] = ACTIONS(824),
    [anon_sym_DASH] = ACTIONS(824),
    [anon_sym_TILDE] = ACTIONS(824),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(1233),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(830),
    [sym_integer] = ACTIONS(1235),
    [sym_float] = ACTIONS(1235),
    [sym_identifier] = ACTIONS(1235),
    [sym_true] = ACTIONS(1235),
    [sym_false] = ACTIONS(1235),
    [sym_none] = ACTIONS(1235),
    [sym_comment] = ACTIONS(72),
  },
  [904] = {
    [sym__primary_expression] = STATE(1287),
    [sym_binary_operator] = STATE(1287),
    [sym_unary_operator] = STATE(1287),
    [sym_attribute] = STATE(1287),
    [sym_subscript] = STATE(1287),
    [sym_call] = STATE(1287),
    [sym_list] = STATE(1287),
    [sym_list_comprehension] = STATE(1287),
    [sym_dictionary] = STATE(1287),
    [sym_dictionary_comprehension] = STATE(1287),
    [sym_set] = STATE(1287),
    [sym_set_comprehension] = STATE(1287),
    [sym_parenthesized_expression] = STATE(1287),
    [sym_tuple] = STATE(1287),
    [sym_generator_expression] = STATE(1287),
    [sym_concatenated_string] = STATE(1287),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_PLUS] = ACTIONS(824),
    [anon_sym_DASH] = ACTIONS(824),
    [anon_sym_TILDE] = ACTIONS(824),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(2754),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(830),
    [sym_integer] = ACTIONS(2756),
    [sym_float] = ACTIONS(2756),
    [sym_identifier] = ACTIONS(2756),
    [sym_true] = ACTIONS(2756),
    [sym_false] = ACTIONS(2756),
    [sym_none] = ACTIONS(2756),
    [sym_comment] = ACTIONS(72),
  },
  [905] = {
    [sym__primary_expression] = STATE(1288),
    [sym_binary_operator] = STATE(1288),
    [sym_unary_operator] = STATE(1288),
    [sym_attribute] = STATE(1288),
    [sym_subscript] = STATE(1288),
    [sym_call] = STATE(1288),
    [sym_list] = STATE(1288),
    [sym_list_comprehension] = STATE(1288),
    [sym_dictionary] = STATE(1288),
    [sym_dictionary_comprehension] = STATE(1288),
    [sym_set] = STATE(1288),
    [sym_set_comprehension] = STATE(1288),
    [sym_parenthesized_expression] = STATE(1288),
    [sym_tuple] = STATE(1288),
    [sym_generator_expression] = STATE(1288),
    [sym_concatenated_string] = STATE(1288),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_PLUS] = ACTIONS(824),
    [anon_sym_DASH] = ACTIONS(824),
    [anon_sym_TILDE] = ACTIONS(824),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(2758),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(830),
    [sym_integer] = ACTIONS(2760),
    [sym_float] = ACTIONS(2760),
    [sym_identifier] = ACTIONS(2760),
    [sym_true] = ACTIONS(2760),
    [sym_false] = ACTIONS(2760),
    [sym_none] = ACTIONS(2760),
    [sym_comment] = ACTIONS(72),
  },
  [906] = {
    [sym__primary_expression] = STATE(1289),
    [sym_binary_operator] = STATE(1289),
    [sym_unary_operator] = STATE(1289),
    [sym_attribute] = STATE(1289),
    [sym_subscript] = STATE(1289),
    [sym_call] = STATE(1289),
    [sym_list] = STATE(1289),
    [sym_list_comprehension] = STATE(1289),
    [sym_dictionary] = STATE(1289),
    [sym_dictionary_comprehension] = STATE(1289),
    [sym_set] = STATE(1289),
    [sym_set_comprehension] = STATE(1289),
    [sym_parenthesized_expression] = STATE(1289),
    [sym_tuple] = STATE(1289),
    [sym_generator_expression] = STATE(1289),
    [sym_concatenated_string] = STATE(1289),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_PLUS] = ACTIONS(824),
    [anon_sym_DASH] = ACTIONS(824),
    [anon_sym_TILDE] = ACTIONS(824),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(2762),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(830),
    [sym_integer] = ACTIONS(2764),
    [sym_float] = ACTIONS(2764),
    [sym_identifier] = ACTIONS(2764),
    [sym_true] = ACTIONS(2764),
    [sym_false] = ACTIONS(2764),
    [sym_none] = ACTIONS(2764),
    [sym_comment] = ACTIONS(72),
  },
  [907] = {
    [sym__primary_expression] = STATE(1284),
    [sym_binary_operator] = STATE(1284),
    [sym_unary_operator] = STATE(1284),
    [sym_attribute] = STATE(1284),
    [sym_subscript] = STATE(1284),
    [sym_call] = STATE(1284),
    [sym_list] = STATE(1284),
    [sym_list_comprehension] = STATE(1284),
    [sym_dictionary] = STATE(1284),
    [sym_dictionary_comprehension] = STATE(1284),
    [sym_set] = STATE(1284),
    [sym_set_comprehension] = STATE(1284),
    [sym_parenthesized_expression] = STATE(1284),
    [sym_tuple] = STATE(1284),
    [sym_generator_expression] = STATE(1284),
    [sym_concatenated_string] = STATE(1284),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_not] = ACTIONS(2766),
    [anon_sym_PLUS] = ACTIONS(824),
    [anon_sym_DASH] = ACTIONS(824),
    [anon_sym_TILDE] = ACTIONS(824),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(2744),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(830),
    [sym_integer] = ACTIONS(2746),
    [sym_float] = ACTIONS(2746),
    [sym_identifier] = ACTIONS(2746),
    [sym_true] = ACTIONS(2746),
    [sym_false] = ACTIONS(2746),
    [sym_none] = ACTIONS(2746),
    [sym_comment] = ACTIONS(72),
  },
  [908] = {
    [aux_sym_comparison_operator_repeat1] = STATE(1290),
    [anon_sym_COMMA] = ACTIONS(998),
    [anon_sym_if] = ACTIONS(998),
    [anon_sym_in] = ACTIONS(1768),
    [anon_sym_not] = ACTIONS(1772),
    [anon_sym_and] = ACTIONS(998),
    [anon_sym_or] = ACTIONS(998),
    [anon_sym_LT] = ACTIONS(1784),
    [anon_sym_LT_EQ] = ACTIONS(1768),
    [anon_sym_EQ_EQ] = ACTIONS(1768),
    [anon_sym_BANG_EQ] = ACTIONS(1768),
    [anon_sym_GT_EQ] = ACTIONS(1768),
    [anon_sym_GT] = ACTIONS(1784),
    [anon_sym_LT_GT] = ACTIONS(1768),
    [anon_sym_is] = ACTIONS(1786),
    [anon_sym_RBRACE] = ACTIONS(998),
    [sym_comment] = ACTIONS(72),
  },
  [909] = {
    [anon_sym_COMMA] = ACTIONS(1644),
    [anon_sym_if] = ACTIONS(850),
    [anon_sym_COLON] = ACTIONS(1644),
    [anon_sym_async] = ACTIONS(1644),
    [anon_sym_for] = ACTIONS(1644),
    [anon_sym_and] = ACTIONS(858),
    [anon_sym_or] = ACTIONS(860),
    [anon_sym_RBRACE] = ACTIONS(1644),
    [sym_comment] = ACTIONS(72),
  },
  [910] = {
    [sym__expression] = STATE(1291),
    [sym__primary_expression] = STATE(157),
    [sym_not_operator] = STATE(1291),
    [sym_boolean_operator] = STATE(1291),
    [sym_binary_operator] = STATE(157),
    [sym_unary_operator] = STATE(157),
    [sym_comparison_operator] = STATE(1291),
    [sym_lambda] = STATE(1291),
    [sym_attribute] = STATE(157),
    [sym_subscript] = STATE(157),
    [sym_call] = STATE(157),
    [sym_list] = STATE(157),
    [sym_list_comprehension] = STATE(157),
    [sym_dictionary] = STATE(157),
    [sym_dictionary_comprehension] = STATE(157),
    [sym_set] = STATE(157),
    [sym_set_comprehension] = STATE(157),
    [sym_parenthesized_expression] = STATE(157),
    [sym_tuple] = STATE(157),
    [sym_generator_expression] = STATE(157),
    [sym_conditional_expression] = STATE(1291),
    [sym_concatenated_string] = STATE(157),
    [sym_await] = STATE(1291),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_not] = ACTIONS(260),
    [anon_sym_PLUS] = ACTIONS(262),
    [anon_sym_DASH] = ACTIONS(262),
    [anon_sym_TILDE] = ACTIONS(262),
    [anon_sym_lambda] = ACTIONS(264),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(266),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(270),
    [sym_integer] = ACTIONS(272),
    [sym_float] = ACTIONS(272),
    [sym_identifier] = ACTIONS(272),
    [sym_true] = ACTIONS(272),
    [sym_false] = ACTIONS(272),
    [sym_none] = ACTIONS(272),
    [anon_sym_await] = ACTIONS(274),
    [sym_comment] = ACTIONS(72),
  },
  [911] = {
    [aux_sym_concatenated_string_repeat1] = STATE(911),
    [anon_sym_DOT] = ACTIONS(1862),
    [anon_sym_LPAREN] = ACTIONS(1862),
    [anon_sym_COMMA] = ACTIONS(1862),
    [anon_sym_STAR] = ACTIONS(1864),
    [anon_sym_GT_GT] = ACTIONS(1862),
    [anon_sym_if] = ACTIONS(1862),
    [anon_sym_COLON] = ACTIONS(1862),
    [anon_sym_async] = ACTIONS(1862),
    [anon_sym_for] = ACTIONS(1862),
    [anon_sym_in] = ACTIONS(1862),
    [anon_sym_AT] = ACTIONS(1862),
    [anon_sym_not] = ACTIONS(1862),
    [anon_sym_and] = ACTIONS(1862),
    [anon_sym_or] = ACTIONS(1862),
    [anon_sym_PLUS] = ACTIONS(1862),
    [anon_sym_DASH] = ACTIONS(1862),
    [anon_sym_SLASH] = ACTIONS(1864),
    [anon_sym_PERCENT] = ACTIONS(1862),
    [anon_sym_SLASH_SLASH] = ACTIONS(1862),
    [anon_sym_STAR_STAR] = ACTIONS(1862),
    [anon_sym_PIPE] = ACTIONS(1862),
    [anon_sym_AMP] = ACTIONS(1862),
    [anon_sym_CARET] = ACTIONS(1862),
    [anon_sym_LT_LT] = ACTIONS(1862),
    [anon_sym_LT] = ACTIONS(1864),
    [anon_sym_LT_EQ] = ACTIONS(1862),
    [anon_sym_EQ_EQ] = ACTIONS(1862),
    [anon_sym_BANG_EQ] = ACTIONS(1862),
    [anon_sym_GT_EQ] = ACTIONS(1862),
    [anon_sym_GT] = ACTIONS(1864),
    [anon_sym_LT_GT] = ACTIONS(1862),
    [anon_sym_is] = ACTIONS(1862),
    [anon_sym_LBRACK] = ACTIONS(1862),
    [anon_sym_RBRACE] = ACTIONS(1862),
    [sym_string] = ACTIONS(2768),
    [sym_comment] = ACTIONS(72),
  },
  [912] = {
    [sym__expression] = STATE(462),
    [sym__primary_expression] = STATE(463),
    [sym_not_operator] = STATE(462),
    [sym_boolean_operator] = STATE(462),
    [sym_binary_operator] = STATE(463),
    [sym_unary_operator] = STATE(463),
    [sym_comparison_operator] = STATE(462),
    [sym_lambda] = STATE(462),
    [sym_attribute] = STATE(463),
    [sym_subscript] = STATE(463),
    [sym_call] = STATE(463),
    [sym_list] = STATE(463),
    [sym_list_comprehension] = STATE(463),
    [sym_dictionary] = STATE(463),
    [sym_dictionary_comprehension] = STATE(463),
    [sym_set] = STATE(463),
    [sym_set_comprehension] = STATE(463),
    [sym_parenthesized_expression] = STATE(463),
    [sym_tuple] = STATE(463),
    [sym_generator_expression] = STATE(463),
    [sym_conditional_expression] = STATE(462),
    [sym_concatenated_string] = STATE(463),
    [sym_await] = STATE(462),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_COMMA] = ACTIONS(722),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_not] = ACTIONS(822),
    [anon_sym_PLUS] = ACTIONS(824),
    [anon_sym_DASH] = ACTIONS(824),
    [anon_sym_TILDE] = ACTIONS(824),
    [anon_sym_lambda] = ACTIONS(826),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(828),
    [anon_sym_LBRACE] = ACTIONS(100),
    [anon_sym_RBRACE] = ACTIONS(722),
    [sym_string] = ACTIONS(830),
    [sym_integer] = ACTIONS(832),
    [sym_float] = ACTIONS(832),
    [sym_identifier] = ACTIONS(832),
    [sym_true] = ACTIONS(832),
    [sym_false] = ACTIONS(832),
    [sym_none] = ACTIONS(832),
    [anon_sym_await] = ACTIONS(834),
    [sym_comment] = ACTIONS(72),
  },
  [913] = {
    [sym__newline] = ACTIONS(2771),
    [anon_sym_DOT] = ACTIONS(2771),
    [anon_sym_LPAREN] = ACTIONS(2771),
    [anon_sym_COMMA] = ACTIONS(2771),
    [anon_sym_STAR] = ACTIONS(2773),
    [anon_sym_GT_GT] = ACTIONS(2773),
    [anon_sym_if] = ACTIONS(2771),
    [anon_sym_COLON] = ACTIONS(2771),
    [anon_sym_in] = ACTIONS(2771),
    [anon_sym_EQ] = ACTIONS(2773),
    [anon_sym_AT] = ACTIONS(2773),
    [anon_sym_not] = ACTIONS(2771),
    [anon_sym_and] = ACTIONS(2771),
    [anon_sym_or] = ACTIONS(2771),
    [anon_sym_PLUS] = ACTIONS(2773),
    [anon_sym_DASH] = ACTIONS(2773),
    [anon_sym_SLASH] = ACTIONS(2773),
    [anon_sym_PERCENT] = ACTIONS(2773),
    [anon_sym_SLASH_SLASH] = ACTIONS(2773),
    [anon_sym_STAR_STAR] = ACTIONS(2773),
    [anon_sym_PIPE] = ACTIONS(2773),
    [anon_sym_AMP] = ACTIONS(2773),
    [anon_sym_CARET] = ACTIONS(2773),
    [anon_sym_LT_LT] = ACTIONS(2773),
    [anon_sym_LT] = ACTIONS(2773),
    [anon_sym_LT_EQ] = ACTIONS(2771),
    [anon_sym_EQ_EQ] = ACTIONS(2771),
    [anon_sym_BANG_EQ] = ACTIONS(2771),
    [anon_sym_GT_EQ] = ACTIONS(2771),
    [anon_sym_GT] = ACTIONS(2773),
    [anon_sym_LT_GT] = ACTIONS(2771),
    [anon_sym_is] = ACTIONS(2771),
    [anon_sym_PLUS_EQ] = ACTIONS(2771),
    [anon_sym_DASH_EQ] = ACTIONS(2771),
    [anon_sym_STAR_EQ] = ACTIONS(2771),
    [anon_sym_SLASH_EQ] = ACTIONS(2771),
    [anon_sym_AT_EQ] = ACTIONS(2771),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(2771),
    [anon_sym_PERCENT_EQ] = ACTIONS(2771),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2771),
    [anon_sym_GT_GT_EQ] = ACTIONS(2771),
    [anon_sym_LT_LT_EQ] = ACTIONS(2771),
    [anon_sym_AMP_EQ] = ACTIONS(2771),
    [anon_sym_CARET_EQ] = ACTIONS(2771),
    [anon_sym_PIPE_EQ] = ACTIONS(2771),
    [anon_sym_LBRACK] = ACTIONS(2771),
    [sym_comment] = ACTIONS(72),
    [sym__semicolon] = ACTIONS(2771),
  },
  [914] = {
    [anon_sym_COMMA] = ACTIONS(2687),
    [anon_sym_if] = ACTIONS(1758),
    [anon_sym_and] = ACTIONS(1760),
    [anon_sym_or] = ACTIONS(1762),
    [anon_sym_RBRACE] = ACTIONS(2687),
    [sym_comment] = ACTIONS(72),
  },
  [915] = {
    [sym_list_splat] = STATE(870),
    [sym__expression] = STATE(914),
    [sym__primary_expression] = STATE(463),
    [sym_not_operator] = STATE(914),
    [sym_boolean_operator] = STATE(914),
    [sym_binary_operator] = STATE(463),
    [sym_unary_operator] = STATE(463),
    [sym_comparison_operator] = STATE(914),
    [sym_lambda] = STATE(914),
    [sym_attribute] = STATE(463),
    [sym_subscript] = STATE(463),
    [sym_call] = STATE(463),
    [sym_list] = STATE(463),
    [sym_list_comprehension] = STATE(463),
    [sym_dictionary] = STATE(463),
    [sym_dictionary_comprehension] = STATE(463),
    [sym_set] = STATE(463),
    [sym_set_comprehension] = STATE(463),
    [sym_parenthesized_expression] = STATE(463),
    [sym_tuple] = STATE(463),
    [sym_generator_expression] = STATE(463),
    [sym_conditional_expression] = STATE(914),
    [sym_concatenated_string] = STATE(463),
    [sym_await] = STATE(914),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_STAR] = ACTIONS(1792),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_not] = ACTIONS(822),
    [anon_sym_PLUS] = ACTIONS(824),
    [anon_sym_DASH] = ACTIONS(824),
    [anon_sym_TILDE] = ACTIONS(824),
    [anon_sym_lambda] = ACTIONS(826),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(828),
    [anon_sym_LBRACE] = ACTIONS(100),
    [anon_sym_RBRACE] = ACTIONS(2775),
    [sym_string] = ACTIONS(830),
    [sym_integer] = ACTIONS(832),
    [sym_float] = ACTIONS(832),
    [sym_identifier] = ACTIONS(832),
    [sym_true] = ACTIONS(832),
    [sym_false] = ACTIONS(832),
    [sym_none] = ACTIONS(832),
    [anon_sym_await] = ACTIONS(834),
    [sym_comment] = ACTIONS(72),
  },
  [916] = {
    [aux_sym_list_repeat1] = STATE(916),
    [anon_sym_COMMA] = ACTIONS(2777),
    [anon_sym_RBRACE] = ACTIONS(2687),
    [sym_comment] = ACTIONS(72),
  },
  [917] = {
    [anon_sym_STAR] = ACTIONS(820),
    [sym_comment] = ACTIONS(72),
  },
  [918] = {
    [sym__newline] = ACTIONS(2780),
    [anon_sym_DOT] = ACTIONS(2780),
    [anon_sym_LPAREN] = ACTIONS(2780),
    [anon_sym_COMMA] = ACTIONS(2780),
    [anon_sym_STAR] = ACTIONS(2782),
    [anon_sym_GT_GT] = ACTIONS(2782),
    [anon_sym_if] = ACTIONS(2780),
    [anon_sym_COLON] = ACTIONS(2780),
    [anon_sym_in] = ACTIONS(2780),
    [anon_sym_EQ] = ACTIONS(2782),
    [anon_sym_AT] = ACTIONS(2782),
    [anon_sym_not] = ACTIONS(2780),
    [anon_sym_and] = ACTIONS(2780),
    [anon_sym_or] = ACTIONS(2780),
    [anon_sym_PLUS] = ACTIONS(2782),
    [anon_sym_DASH] = ACTIONS(2782),
    [anon_sym_SLASH] = ACTIONS(2782),
    [anon_sym_PERCENT] = ACTIONS(2782),
    [anon_sym_SLASH_SLASH] = ACTIONS(2782),
    [anon_sym_STAR_STAR] = ACTIONS(2782),
    [anon_sym_PIPE] = ACTIONS(2782),
    [anon_sym_AMP] = ACTIONS(2782),
    [anon_sym_CARET] = ACTIONS(2782),
    [anon_sym_LT_LT] = ACTIONS(2782),
    [anon_sym_LT] = ACTIONS(2782),
    [anon_sym_LT_EQ] = ACTIONS(2780),
    [anon_sym_EQ_EQ] = ACTIONS(2780),
    [anon_sym_BANG_EQ] = ACTIONS(2780),
    [anon_sym_GT_EQ] = ACTIONS(2780),
    [anon_sym_GT] = ACTIONS(2782),
    [anon_sym_LT_GT] = ACTIONS(2780),
    [anon_sym_is] = ACTIONS(2780),
    [anon_sym_PLUS_EQ] = ACTIONS(2780),
    [anon_sym_DASH_EQ] = ACTIONS(2780),
    [anon_sym_STAR_EQ] = ACTIONS(2780),
    [anon_sym_SLASH_EQ] = ACTIONS(2780),
    [anon_sym_AT_EQ] = ACTIONS(2780),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(2780),
    [anon_sym_PERCENT_EQ] = ACTIONS(2780),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2780),
    [anon_sym_GT_GT_EQ] = ACTIONS(2780),
    [anon_sym_LT_LT_EQ] = ACTIONS(2780),
    [anon_sym_AMP_EQ] = ACTIONS(2780),
    [anon_sym_CARET_EQ] = ACTIONS(2780),
    [anon_sym_PIPE_EQ] = ACTIONS(2780),
    [anon_sym_LBRACK] = ACTIONS(2780),
    [sym_comment] = ACTIONS(72),
    [sym__semicolon] = ACTIONS(2780),
  },
  [919] = {
    [anon_sym_COMMA] = ACTIONS(2784),
    [anon_sym_RBRACE] = ACTIONS(2784),
    [sym_comment] = ACTIONS(72),
  },
  [920] = {
    [anon_sym_if] = ACTIONS(590),
    [anon_sym_COLON] = ACTIONS(2786),
    [anon_sym_and] = ACTIONS(594),
    [anon_sym_or] = ACTIONS(596),
    [sym_comment] = ACTIONS(72),
  },
  [921] = {
    [sym_dictionary_splat] = STATE(919),
    [sym__expression] = STATE(920),
    [sym__primary_expression] = STATE(96),
    [sym_not_operator] = STATE(920),
    [sym_boolean_operator] = STATE(920),
    [sym_binary_operator] = STATE(96),
    [sym_unary_operator] = STATE(96),
    [sym_comparison_operator] = STATE(920),
    [sym_lambda] = STATE(920),
    [sym_attribute] = STATE(96),
    [sym_subscript] = STATE(96),
    [sym_call] = STATE(96),
    [sym_list] = STATE(96),
    [sym_list_comprehension] = STATE(96),
    [sym_dictionary] = STATE(96),
    [sym_dictionary_comprehension] = STATE(96),
    [sym_pair] = STATE(919),
    [sym_set] = STATE(96),
    [sym_set_comprehension] = STATE(96),
    [sym_parenthesized_expression] = STATE(96),
    [sym_tuple] = STATE(96),
    [sym_generator_expression] = STATE(96),
    [sym_conditional_expression] = STATE(920),
    [sym_concatenated_string] = STATE(96),
    [sym_await] = STATE(920),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_STAR] = ACTIONS(1802),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_not] = ACTIONS(160),
    [anon_sym_PLUS] = ACTIONS(162),
    [anon_sym_DASH] = ACTIONS(162),
    [anon_sym_TILDE] = ACTIONS(162),
    [anon_sym_lambda] = ACTIONS(164),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(166),
    [anon_sym_LBRACE] = ACTIONS(100),
    [anon_sym_RBRACE] = ACTIONS(2788),
    [sym_string] = ACTIONS(168),
    [sym_integer] = ACTIONS(170),
    [sym_float] = ACTIONS(170),
    [sym_identifier] = ACTIONS(170),
    [sym_true] = ACTIONS(170),
    [sym_false] = ACTIONS(170),
    [sym_none] = ACTIONS(170),
    [anon_sym_await] = ACTIONS(172),
    [sym_comment] = ACTIONS(72),
  },
  [922] = {
    [aux_sym_dictionary_repeat1] = STATE(922),
    [anon_sym_COMMA] = ACTIONS(2790),
    [anon_sym_RBRACE] = ACTIONS(2784),
    [sym_comment] = ACTIONS(72),
  },
  [923] = {
    [anon_sym_if] = ACTIONS(1921),
    [anon_sym_else] = ACTIONS(2793),
    [anon_sym_and] = ACTIONS(1925),
    [anon_sym_or] = ACTIONS(1927),
    [sym_comment] = ACTIONS(72),
  },
  [924] = {
    [sym__expression] = STATE(1298),
    [sym__primary_expression] = STATE(930),
    [sym_not_operator] = STATE(1298),
    [sym_boolean_operator] = STATE(1298),
    [sym_binary_operator] = STATE(930),
    [sym_unary_operator] = STATE(930),
    [sym_comparison_operator] = STATE(1298),
    [sym_lambda] = STATE(1298),
    [sym_attribute] = STATE(930),
    [sym_subscript] = STATE(930),
    [sym_call] = STATE(930),
    [sym_list] = STATE(930),
    [sym_list_comprehension] = STATE(930),
    [sym_dictionary] = STATE(930),
    [sym_dictionary_comprehension] = STATE(930),
    [sym_set] = STATE(930),
    [sym_set_comprehension] = STATE(930),
    [sym_parenthesized_expression] = STATE(930),
    [sym_tuple] = STATE(930),
    [sym_generator_expression] = STATE(930),
    [sym_conditional_expression] = STATE(1298),
    [sym_concatenated_string] = STATE(930),
    [sym_await] = STATE(1298),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_not] = ACTIONS(1808),
    [anon_sym_PLUS] = ACTIONS(1810),
    [anon_sym_DASH] = ACTIONS(1810),
    [anon_sym_TILDE] = ACTIONS(1810),
    [anon_sym_lambda] = ACTIONS(1812),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(1814),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(1816),
    [sym_integer] = ACTIONS(1818),
    [sym_float] = ACTIONS(1818),
    [sym_identifier] = ACTIONS(1818),
    [sym_true] = ACTIONS(1818),
    [sym_false] = ACTIONS(1818),
    [sym_none] = ACTIONS(1818),
    [anon_sym_await] = ACTIONS(1820),
    [sym_comment] = ACTIONS(72),
  },
  [925] = {
    [sym__primary_expression] = STATE(204),
    [sym_binary_operator] = STATE(204),
    [sym_unary_operator] = STATE(204),
    [sym_attribute] = STATE(204),
    [sym_subscript] = STATE(204),
    [sym_call] = STATE(204),
    [sym_list] = STATE(204),
    [sym_list_comprehension] = STATE(204),
    [sym_dictionary] = STATE(204),
    [sym_dictionary_comprehension] = STATE(204),
    [sym_set] = STATE(204),
    [sym_set_comprehension] = STATE(204),
    [sym_parenthesized_expression] = STATE(204),
    [sym_tuple] = STATE(204),
    [sym_generator_expression] = STATE(204),
    [sym_concatenated_string] = STATE(204),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_PLUS] = ACTIONS(1810),
    [anon_sym_DASH] = ACTIONS(1810),
    [anon_sym_TILDE] = ACTIONS(1810),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(376),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(1816),
    [sym_integer] = ACTIONS(378),
    [sym_float] = ACTIONS(378),
    [sym_identifier] = ACTIONS(378),
    [sym_true] = ACTIONS(378),
    [sym_false] = ACTIONS(378),
    [sym_none] = ACTIONS(378),
    [sym_comment] = ACTIONS(72),
  },
  [926] = {
    [sym_lambda_parameters] = STATE(1300),
    [sym__parameters] = STATE(130),
    [sym_default_parameter] = STATE(131),
    [sym_typed_default_parameter] = STATE(131),
    [sym_list_splat] = STATE(132),
    [sym_dictionary_splat] = STATE(132),
    [sym_typed_parameter] = STATE(131),
    [sym_tuple] = STATE(131),
    [anon_sym_LPAREN] = ACTIONS(222),
    [anon_sym_STAR] = ACTIONS(224),
    [anon_sym_print] = ACTIONS(226),
    [anon_sym_COLON] = ACTIONS(2795),
    [anon_sym_exec] = ACTIONS(226),
    [sym_identifier] = ACTIONS(230),
    [sym_comment] = ACTIONS(72),
  },
  [927] = {
    [aux_sym_concatenated_string_repeat1] = STATE(1301),
    [anon_sym_DOT] = ACTIONS(276),
    [anon_sym_LPAREN] = ACTIONS(276),
    [anon_sym_COMMA] = ACTIONS(276),
    [anon_sym_STAR] = ACTIONS(278),
    [anon_sym_GT_GT] = ACTIONS(276),
    [anon_sym_if] = ACTIONS(276),
    [anon_sym_async] = ACTIONS(276),
    [anon_sym_for] = ACTIONS(276),
    [anon_sym_in] = ACTIONS(276),
    [anon_sym_AT] = ACTIONS(276),
    [anon_sym_not] = ACTIONS(276),
    [anon_sym_and] = ACTIONS(276),
    [anon_sym_or] = ACTIONS(276),
    [anon_sym_PLUS] = ACTIONS(276),
    [anon_sym_DASH] = ACTIONS(276),
    [anon_sym_SLASH] = ACTIONS(278),
    [anon_sym_PERCENT] = ACTIONS(276),
    [anon_sym_SLASH_SLASH] = ACTIONS(276),
    [anon_sym_STAR_STAR] = ACTIONS(276),
    [anon_sym_PIPE] = ACTIONS(276),
    [anon_sym_AMP] = ACTIONS(276),
    [anon_sym_CARET] = ACTIONS(276),
    [anon_sym_LT_LT] = ACTIONS(276),
    [anon_sym_LT] = ACTIONS(278),
    [anon_sym_LT_EQ] = ACTIONS(276),
    [anon_sym_EQ_EQ] = ACTIONS(276),
    [anon_sym_BANG_EQ] = ACTIONS(276),
    [anon_sym_GT_EQ] = ACTIONS(276),
    [anon_sym_GT] = ACTIONS(278),
    [anon_sym_LT_GT] = ACTIONS(276),
    [anon_sym_is] = ACTIONS(276),
    [anon_sym_LBRACK] = ACTIONS(276),
    [anon_sym_RBRACE] = ACTIONS(276),
    [sym_string] = ACTIONS(2797),
    [sym_comment] = ACTIONS(72),
  },
  [928] = {
    [sym__expression] = STATE(227),
    [sym__primary_expression] = STATE(930),
    [sym_not_operator] = STATE(227),
    [sym_boolean_operator] = STATE(227),
    [sym_binary_operator] = STATE(930),
    [sym_unary_operator] = STATE(930),
    [sym_comparison_operator] = STATE(227),
    [sym_lambda] = STATE(227),
    [sym_attribute] = STATE(930),
    [sym_subscript] = STATE(930),
    [sym_call] = STATE(930),
    [sym_list] = STATE(930),
    [sym_list_comprehension] = STATE(930),
    [sym_dictionary] = STATE(930),
    [sym_dictionary_comprehension] = STATE(930),
    [sym_set] = STATE(930),
    [sym_set_comprehension] = STATE(930),
    [sym_parenthesized_expression] = STATE(930),
    [sym_tuple] = STATE(930),
    [sym_generator_expression] = STATE(930),
    [sym_conditional_expression] = STATE(227),
    [sym_concatenated_string] = STATE(930),
    [sym_await] = STATE(227),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_not] = ACTIONS(1808),
    [anon_sym_PLUS] = ACTIONS(1810),
    [anon_sym_DASH] = ACTIONS(1810),
    [anon_sym_TILDE] = ACTIONS(1810),
    [anon_sym_lambda] = ACTIONS(1812),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(1814),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(1816),
    [sym_integer] = ACTIONS(1818),
    [sym_float] = ACTIONS(1818),
    [sym_identifier] = ACTIONS(1818),
    [sym_true] = ACTIONS(1818),
    [sym_false] = ACTIONS(1818),
    [sym_none] = ACTIONS(1818),
    [anon_sym_await] = ACTIONS(1820),
    [sym_comment] = ACTIONS(72),
  },
  [929] = {
    [anon_sym_COMMA] = ACTIONS(2799),
    [anon_sym_if] = ACTIONS(2801),
    [anon_sym_async] = ACTIONS(2799),
    [anon_sym_for] = ACTIONS(2799),
    [anon_sym_and] = ACTIONS(2803),
    [anon_sym_or] = ACTIONS(2805),
    [anon_sym_RBRACE] = ACTIONS(2799),
    [sym_comment] = ACTIONS(72),
  },
  [930] = {
    [sym_argument_list] = STATE(251),
    [sym_generator_expression] = STATE(251),
    [aux_sym_comparison_operator_repeat1] = STATE(1315),
    [anon_sym_DOT] = ACTIONS(422),
    [anon_sym_LPAREN] = ACTIONS(424),
    [anon_sym_COMMA] = ACTIONS(302),
    [anon_sym_STAR] = ACTIONS(2807),
    [anon_sym_GT_GT] = ACTIONS(2809),
    [anon_sym_if] = ACTIONS(302),
    [anon_sym_async] = ACTIONS(302),
    [anon_sym_for] = ACTIONS(302),
    [anon_sym_in] = ACTIONS(2811),
    [anon_sym_AT] = ACTIONS(2813),
    [anon_sym_not] = ACTIONS(2815),
    [anon_sym_and] = ACTIONS(302),
    [anon_sym_or] = ACTIONS(302),
    [anon_sym_PLUS] = ACTIONS(2817),
    [anon_sym_DASH] = ACTIONS(2817),
    [anon_sym_SLASH] = ACTIONS(2807),
    [anon_sym_PERCENT] = ACTIONS(2813),
    [anon_sym_SLASH_SLASH] = ACTIONS(2813),
    [anon_sym_STAR_STAR] = ACTIONS(2819),
    [anon_sym_PIPE] = ACTIONS(2821),
    [anon_sym_AMP] = ACTIONS(2823),
    [anon_sym_CARET] = ACTIONS(2825),
    [anon_sym_LT_LT] = ACTIONS(2809),
    [anon_sym_LT] = ACTIONS(2827),
    [anon_sym_LT_EQ] = ACTIONS(2811),
    [anon_sym_EQ_EQ] = ACTIONS(2811),
    [anon_sym_BANG_EQ] = ACTIONS(2811),
    [anon_sym_GT_EQ] = ACTIONS(2811),
    [anon_sym_GT] = ACTIONS(2827),
    [anon_sym_LT_GT] = ACTIONS(2811),
    [anon_sym_is] = ACTIONS(2829),
    [anon_sym_LBRACK] = ACTIONS(450),
    [anon_sym_RBRACE] = ACTIONS(302),
    [sym_comment] = ACTIONS(72),
  },
  [931] = {
    [sym_variables] = STATE(1316),
    [sym__primary_expression] = STATE(103),
    [sym_binary_operator] = STATE(103),
    [sym_unary_operator] = STATE(103),
    [sym_attribute] = STATE(103),
    [sym_subscript] = STATE(103),
    [sym_call] = STATE(103),
    [sym_list] = STATE(103),
    [sym_list_comprehension] = STATE(103),
    [sym_dictionary] = STATE(103),
    [sym_dictionary_comprehension] = STATE(103),
    [sym_set] = STATE(103),
    [sym_set_comprehension] = STATE(103),
    [sym_parenthesized_expression] = STATE(103),
    [sym_tuple] = STATE(103),
    [sym_generator_expression] = STATE(103),
    [sym_concatenated_string] = STATE(103),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_PLUS] = ACTIONS(180),
    [anon_sym_DASH] = ACTIONS(180),
    [anon_sym_TILDE] = ACTIONS(180),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(182),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(184),
    [sym_integer] = ACTIONS(186),
    [sym_float] = ACTIONS(186),
    [sym_identifier] = ACTIONS(186),
    [sym_true] = ACTIONS(186),
    [sym_false] = ACTIONS(186),
    [sym_none] = ACTIONS(186),
    [sym_comment] = ACTIONS(72),
  },
  [932] = {
    [anon_sym_in] = ACTIONS(2831),
    [sym_comment] = ACTIONS(72),
  },
  [933] = {
    [anon_sym_COMMA] = ACTIONS(1953),
    [anon_sym_if] = ACTIONS(1953),
    [anon_sym_COLON] = ACTIONS(1953),
    [anon_sym_async] = ACTIONS(1953),
    [anon_sym_for] = ACTIONS(1953),
    [anon_sym_and] = ACTIONS(858),
    [anon_sym_or] = ACTIONS(1953),
    [anon_sym_RBRACE] = ACTIONS(1953),
    [sym_comment] = ACTIONS(72),
  },
  [934] = {
    [sym__newline] = ACTIONS(2833),
    [anon_sym_DOT] = ACTIONS(2833),
    [anon_sym_LPAREN] = ACTIONS(2833),
    [anon_sym_COMMA] = ACTIONS(2833),
    [anon_sym_STAR] = ACTIONS(2835),
    [anon_sym_GT_GT] = ACTIONS(2835),
    [anon_sym_if] = ACTIONS(2833),
    [anon_sym_COLON] = ACTIONS(2833),
    [anon_sym_in] = ACTIONS(2833),
    [anon_sym_EQ] = ACTIONS(2835),
    [anon_sym_AT] = ACTIONS(2835),
    [anon_sym_not] = ACTIONS(2833),
    [anon_sym_and] = ACTIONS(2833),
    [anon_sym_or] = ACTIONS(2833),
    [anon_sym_PLUS] = ACTIONS(2835),
    [anon_sym_DASH] = ACTIONS(2835),
    [anon_sym_SLASH] = ACTIONS(2835),
    [anon_sym_PERCENT] = ACTIONS(2835),
    [anon_sym_SLASH_SLASH] = ACTIONS(2835),
    [anon_sym_STAR_STAR] = ACTIONS(2835),
    [anon_sym_PIPE] = ACTIONS(2835),
    [anon_sym_AMP] = ACTIONS(2835),
    [anon_sym_CARET] = ACTIONS(2835),
    [anon_sym_LT_LT] = ACTIONS(2835),
    [anon_sym_LT] = ACTIONS(2835),
    [anon_sym_LT_EQ] = ACTIONS(2833),
    [anon_sym_EQ_EQ] = ACTIONS(2833),
    [anon_sym_BANG_EQ] = ACTIONS(2833),
    [anon_sym_GT_EQ] = ACTIONS(2833),
    [anon_sym_GT] = ACTIONS(2835),
    [anon_sym_LT_GT] = ACTIONS(2833),
    [anon_sym_is] = ACTIONS(2833),
    [anon_sym_PLUS_EQ] = ACTIONS(2833),
    [anon_sym_DASH_EQ] = ACTIONS(2833),
    [anon_sym_STAR_EQ] = ACTIONS(2833),
    [anon_sym_SLASH_EQ] = ACTIONS(2833),
    [anon_sym_AT_EQ] = ACTIONS(2833),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(2833),
    [anon_sym_PERCENT_EQ] = ACTIONS(2833),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2833),
    [anon_sym_GT_GT_EQ] = ACTIONS(2833),
    [anon_sym_LT_LT_EQ] = ACTIONS(2833),
    [anon_sym_AMP_EQ] = ACTIONS(2833),
    [anon_sym_CARET_EQ] = ACTIONS(2833),
    [anon_sym_PIPE_EQ] = ACTIONS(2833),
    [anon_sym_LBRACK] = ACTIONS(2833),
    [sym_comment] = ACTIONS(72),
    [sym__semicolon] = ACTIONS(2833),
  },
  [935] = {
    [sym__expression] = STATE(1323),
    [sym__primary_expression] = STATE(1324),
    [sym_not_operator] = STATE(1323),
    [sym_boolean_operator] = STATE(1323),
    [sym_binary_operator] = STATE(1324),
    [sym_unary_operator] = STATE(1324),
    [sym_comparison_operator] = STATE(1323),
    [sym_lambda] = STATE(1323),
    [sym_attribute] = STATE(1324),
    [sym_subscript] = STATE(1324),
    [sym_call] = STATE(1324),
    [sym_list] = STATE(1324),
    [sym_list_comprehension] = STATE(1324),
    [sym_dictionary] = STATE(1324),
    [sym_dictionary_comprehension] = STATE(1324),
    [sym_set] = STATE(1324),
    [sym_set_comprehension] = STATE(1324),
    [sym_parenthesized_expression] = STATE(1324),
    [sym_tuple] = STATE(1324),
    [sym_generator_expression] = STATE(1324),
    [sym_conditional_expression] = STATE(1323),
    [sym_concatenated_string] = STATE(1324),
    [sym_await] = STATE(1323),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_not] = ACTIONS(2837),
    [anon_sym_PLUS] = ACTIONS(2839),
    [anon_sym_DASH] = ACTIONS(2839),
    [anon_sym_TILDE] = ACTIONS(2839),
    [anon_sym_lambda] = ACTIONS(2841),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(2843),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(2845),
    [sym_integer] = ACTIONS(2847),
    [sym_float] = ACTIONS(2847),
    [sym_identifier] = ACTIONS(2847),
    [sym_true] = ACTIONS(2847),
    [sym_false] = ACTIONS(2847),
    [sym_none] = ACTIONS(2847),
    [anon_sym_await] = ACTIONS(2849),
    [sym_comment] = ACTIONS(72),
  },
  [936] = {
    [sym_for_in_clause] = STATE(1325),
    [sym_if_clause] = STATE(1325),
    [aux_sym__comprehension_body_repeat1] = STATE(1325),
    [anon_sym_if] = ACTIONS(1826),
    [anon_sym_async] = ACTIONS(854),
    [anon_sym_for] = ACTIONS(856),
    [anon_sym_RBRACE] = ACTIONS(2166),
    [sym_comment] = ACTIONS(72),
  },
  [937] = {
    [sym_argument_list] = STATE(251),
    [sym_generator_expression] = STATE(251),
    [anon_sym_DOT] = ACTIONS(1980),
    [anon_sym_LPAREN] = ACTIONS(424),
    [anon_sym_COMMA] = ACTIONS(1980),
    [anon_sym_STAR] = ACTIONS(1982),
    [anon_sym_GT_GT] = ACTIONS(1980),
    [anon_sym_if] = ACTIONS(1980),
    [anon_sym_COLON] = ACTIONS(1980),
    [anon_sym_async] = ACTIONS(1980),
    [anon_sym_for] = ACTIONS(1980),
    [anon_sym_in] = ACTIONS(1980),
    [anon_sym_AT] = ACTIONS(1980),
    [anon_sym_not] = ACTIONS(1980),
    [anon_sym_and] = ACTIONS(1980),
    [anon_sym_or] = ACTIONS(1980),
    [anon_sym_PLUS] = ACTIONS(1980),
    [anon_sym_DASH] = ACTIONS(1980),
    [anon_sym_SLASH] = ACTIONS(1982),
    [anon_sym_PERCENT] = ACTIONS(1980),
    [anon_sym_SLASH_SLASH] = ACTIONS(1980),
    [anon_sym_STAR_STAR] = ACTIONS(874),
    [anon_sym_PIPE] = ACTIONS(1980),
    [anon_sym_AMP] = ACTIONS(1980),
    [anon_sym_CARET] = ACTIONS(1980),
    [anon_sym_LT_LT] = ACTIONS(1980),
    [anon_sym_LT] = ACTIONS(1982),
    [anon_sym_LT_EQ] = ACTIONS(1980),
    [anon_sym_EQ_EQ] = ACTIONS(1980),
    [anon_sym_BANG_EQ] = ACTIONS(1980),
    [anon_sym_GT_EQ] = ACTIONS(1980),
    [anon_sym_GT] = ACTIONS(1982),
    [anon_sym_LT_GT] = ACTIONS(1980),
    [anon_sym_is] = ACTIONS(1980),
    [anon_sym_LBRACK] = ACTIONS(1980),
    [anon_sym_RBRACE] = ACTIONS(1980),
    [sym_comment] = ACTIONS(72),
  },
  [938] = {
    [sym_argument_list] = STATE(251),
    [sym_generator_expression] = STATE(251),
    [anon_sym_DOT] = ACTIONS(1980),
    [anon_sym_LPAREN] = ACTIONS(424),
    [anon_sym_COMMA] = ACTIONS(1980),
    [anon_sym_STAR] = ACTIONS(862),
    [anon_sym_GT_GT] = ACTIONS(1980),
    [anon_sym_if] = ACTIONS(1980),
    [anon_sym_COLON] = ACTIONS(1980),
    [anon_sym_async] = ACTIONS(1980),
    [anon_sym_for] = ACTIONS(1980),
    [anon_sym_in] = ACTIONS(1980),
    [anon_sym_AT] = ACTIONS(868),
    [anon_sym_not] = ACTIONS(1980),
    [anon_sym_and] = ACTIONS(1980),
    [anon_sym_or] = ACTIONS(1980),
    [anon_sym_PLUS] = ACTIONS(872),
    [anon_sym_DASH] = ACTIONS(872),
    [anon_sym_SLASH] = ACTIONS(862),
    [anon_sym_PERCENT] = ACTIONS(868),
    [anon_sym_SLASH_SLASH] = ACTIONS(868),
    [anon_sym_STAR_STAR] = ACTIONS(874),
    [anon_sym_PIPE] = ACTIONS(1980),
    [anon_sym_AMP] = ACTIONS(1980),
    [anon_sym_CARET] = ACTIONS(1980),
    [anon_sym_LT_LT] = ACTIONS(1980),
    [anon_sym_LT] = ACTIONS(1982),
    [anon_sym_LT_EQ] = ACTIONS(1980),
    [anon_sym_EQ_EQ] = ACTIONS(1980),
    [anon_sym_BANG_EQ] = ACTIONS(1980),
    [anon_sym_GT_EQ] = ACTIONS(1980),
    [anon_sym_GT] = ACTIONS(1982),
    [anon_sym_LT_GT] = ACTIONS(1980),
    [anon_sym_is] = ACTIONS(1980),
    [anon_sym_LBRACK] = ACTIONS(1980),
    [anon_sym_RBRACE] = ACTIONS(1980),
    [sym_comment] = ACTIONS(72),
  },
  [939] = {
    [sym_argument_list] = STATE(251),
    [sym_generator_expression] = STATE(251),
    [anon_sym_DOT] = ACTIONS(422),
    [anon_sym_LPAREN] = ACTIONS(424),
    [anon_sym_COMMA] = ACTIONS(1984),
    [anon_sym_STAR] = ACTIONS(862),
    [anon_sym_GT_GT] = ACTIONS(864),
    [anon_sym_if] = ACTIONS(1984),
    [anon_sym_COLON] = ACTIONS(1984),
    [anon_sym_async] = ACTIONS(1984),
    [anon_sym_for] = ACTIONS(1984),
    [anon_sym_in] = ACTIONS(1984),
    [anon_sym_AT] = ACTIONS(868),
    [anon_sym_not] = ACTIONS(1984),
    [anon_sym_and] = ACTIONS(1984),
    [anon_sym_or] = ACTIONS(1984),
    [anon_sym_PLUS] = ACTIONS(872),
    [anon_sym_DASH] = ACTIONS(872),
    [anon_sym_SLASH] = ACTIONS(862),
    [anon_sym_PERCENT] = ACTIONS(868),
    [anon_sym_SLASH_SLASH] = ACTIONS(868),
    [anon_sym_STAR_STAR] = ACTIONS(874),
    [anon_sym_PIPE] = ACTIONS(876),
    [anon_sym_AMP] = ACTIONS(878),
    [anon_sym_CARET] = ACTIONS(880),
    [anon_sym_LT_LT] = ACTIONS(864),
    [anon_sym_LT] = ACTIONS(1986),
    [anon_sym_LT_EQ] = ACTIONS(1984),
    [anon_sym_EQ_EQ] = ACTIONS(1984),
    [anon_sym_BANG_EQ] = ACTIONS(1984),
    [anon_sym_GT_EQ] = ACTIONS(1984),
    [anon_sym_GT] = ACTIONS(1986),
    [anon_sym_LT_GT] = ACTIONS(1984),
    [anon_sym_is] = ACTIONS(1984),
    [anon_sym_LBRACK] = ACTIONS(450),
    [anon_sym_RBRACE] = ACTIONS(1984),
    [sym_comment] = ACTIONS(72),
  },
  [940] = {
    [sym__primary_expression] = STATE(1326),
    [sym_binary_operator] = STATE(1326),
    [sym_unary_operator] = STATE(1326),
    [sym_attribute] = STATE(1326),
    [sym_subscript] = STATE(1326),
    [sym_call] = STATE(1326),
    [sym_list] = STATE(1326),
    [sym_list_comprehension] = STATE(1326),
    [sym_dictionary] = STATE(1326),
    [sym_dictionary_comprehension] = STATE(1326),
    [sym_set] = STATE(1326),
    [sym_set_comprehension] = STATE(1326),
    [sym_parenthesized_expression] = STATE(1326),
    [sym_tuple] = STATE(1326),
    [sym_generator_expression] = STATE(1326),
    [sym_concatenated_string] = STATE(1326),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_PLUS] = ACTIONS(262),
    [anon_sym_DASH] = ACTIONS(262),
    [anon_sym_TILDE] = ACTIONS(262),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(2851),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(270),
    [sym_integer] = ACTIONS(2853),
    [sym_float] = ACTIONS(2853),
    [sym_identifier] = ACTIONS(2853),
    [sym_true] = ACTIONS(2853),
    [sym_false] = ACTIONS(2853),
    [sym_none] = ACTIONS(2853),
    [sym_comment] = ACTIONS(72),
  },
  [941] = {
    [sym_argument_list] = STATE(251),
    [sym_generator_expression] = STATE(251),
    [anon_sym_DOT] = ACTIONS(1980),
    [anon_sym_LPAREN] = ACTIONS(424),
    [anon_sym_COMMA] = ACTIONS(1980),
    [anon_sym_STAR] = ACTIONS(862),
    [anon_sym_GT_GT] = ACTIONS(1980),
    [anon_sym_if] = ACTIONS(1980),
    [anon_sym_COLON] = ACTIONS(1980),
    [anon_sym_async] = ACTIONS(1980),
    [anon_sym_for] = ACTIONS(1980),
    [anon_sym_in] = ACTIONS(1980),
    [anon_sym_AT] = ACTIONS(868),
    [anon_sym_not] = ACTIONS(1980),
    [anon_sym_and] = ACTIONS(1980),
    [anon_sym_or] = ACTIONS(1980),
    [anon_sym_PLUS] = ACTIONS(1980),
    [anon_sym_DASH] = ACTIONS(1980),
    [anon_sym_SLASH] = ACTIONS(862),
    [anon_sym_PERCENT] = ACTIONS(868),
    [anon_sym_SLASH_SLASH] = ACTIONS(868),
    [anon_sym_STAR_STAR] = ACTIONS(874),
    [anon_sym_PIPE] = ACTIONS(1980),
    [anon_sym_AMP] = ACTIONS(1980),
    [anon_sym_CARET] = ACTIONS(1980),
    [anon_sym_LT_LT] = ACTIONS(1980),
    [anon_sym_LT] = ACTIONS(1982),
    [anon_sym_LT_EQ] = ACTIONS(1980),
    [anon_sym_EQ_EQ] = ACTIONS(1980),
    [anon_sym_BANG_EQ] = ACTIONS(1980),
    [anon_sym_GT_EQ] = ACTIONS(1980),
    [anon_sym_GT] = ACTIONS(1982),
    [anon_sym_LT_GT] = ACTIONS(1980),
    [anon_sym_is] = ACTIONS(1980),
    [anon_sym_LBRACK] = ACTIONS(1980),
    [anon_sym_RBRACE] = ACTIONS(1980),
    [sym_comment] = ACTIONS(72),
  },
  [942] = {
    [sym_argument_list] = STATE(251),
    [sym_generator_expression] = STATE(251),
    [anon_sym_DOT] = ACTIONS(1980),
    [anon_sym_LPAREN] = ACTIONS(424),
    [anon_sym_COMMA] = ACTIONS(1980),
    [anon_sym_STAR] = ACTIONS(862),
    [anon_sym_GT_GT] = ACTIONS(864),
    [anon_sym_if] = ACTIONS(1980),
    [anon_sym_COLON] = ACTIONS(1980),
    [anon_sym_async] = ACTIONS(1980),
    [anon_sym_for] = ACTIONS(1980),
    [anon_sym_in] = ACTIONS(1980),
    [anon_sym_AT] = ACTIONS(868),
    [anon_sym_not] = ACTIONS(1980),
    [anon_sym_and] = ACTIONS(1980),
    [anon_sym_or] = ACTIONS(1980),
    [anon_sym_PLUS] = ACTIONS(872),
    [anon_sym_DASH] = ACTIONS(872),
    [anon_sym_SLASH] = ACTIONS(862),
    [anon_sym_PERCENT] = ACTIONS(868),
    [anon_sym_SLASH_SLASH] = ACTIONS(868),
    [anon_sym_STAR_STAR] = ACTIONS(874),
    [anon_sym_PIPE] = ACTIONS(1980),
    [anon_sym_AMP] = ACTIONS(878),
    [anon_sym_CARET] = ACTIONS(880),
    [anon_sym_LT_LT] = ACTIONS(864),
    [anon_sym_LT] = ACTIONS(1982),
    [anon_sym_LT_EQ] = ACTIONS(1980),
    [anon_sym_EQ_EQ] = ACTIONS(1980),
    [anon_sym_BANG_EQ] = ACTIONS(1980),
    [anon_sym_GT_EQ] = ACTIONS(1980),
    [anon_sym_GT] = ACTIONS(1982),
    [anon_sym_LT_GT] = ACTIONS(1980),
    [anon_sym_is] = ACTIONS(1980),
    [anon_sym_LBRACK] = ACTIONS(1980),
    [anon_sym_RBRACE] = ACTIONS(1980),
    [sym_comment] = ACTIONS(72),
  },
  [943] = {
    [sym_argument_list] = STATE(251),
    [sym_generator_expression] = STATE(251),
    [anon_sym_DOT] = ACTIONS(1980),
    [anon_sym_LPAREN] = ACTIONS(424),
    [anon_sym_COMMA] = ACTIONS(1980),
    [anon_sym_STAR] = ACTIONS(862),
    [anon_sym_GT_GT] = ACTIONS(864),
    [anon_sym_if] = ACTIONS(1980),
    [anon_sym_COLON] = ACTIONS(1980),
    [anon_sym_async] = ACTIONS(1980),
    [anon_sym_for] = ACTIONS(1980),
    [anon_sym_in] = ACTIONS(1980),
    [anon_sym_AT] = ACTIONS(868),
    [anon_sym_not] = ACTIONS(1980),
    [anon_sym_and] = ACTIONS(1980),
    [anon_sym_or] = ACTIONS(1980),
    [anon_sym_PLUS] = ACTIONS(872),
    [anon_sym_DASH] = ACTIONS(872),
    [anon_sym_SLASH] = ACTIONS(862),
    [anon_sym_PERCENT] = ACTIONS(868),
    [anon_sym_SLASH_SLASH] = ACTIONS(868),
    [anon_sym_STAR_STAR] = ACTIONS(874),
    [anon_sym_PIPE] = ACTIONS(1980),
    [anon_sym_AMP] = ACTIONS(1980),
    [anon_sym_CARET] = ACTIONS(880),
    [anon_sym_LT_LT] = ACTIONS(864),
    [anon_sym_LT] = ACTIONS(1982),
    [anon_sym_LT_EQ] = ACTIONS(1980),
    [anon_sym_EQ_EQ] = ACTIONS(1980),
    [anon_sym_BANG_EQ] = ACTIONS(1980),
    [anon_sym_GT_EQ] = ACTIONS(1980),
    [anon_sym_GT] = ACTIONS(1982),
    [anon_sym_LT_GT] = ACTIONS(1980),
    [anon_sym_is] = ACTIONS(1980),
    [anon_sym_LBRACK] = ACTIONS(1980),
    [anon_sym_RBRACE] = ACTIONS(1980),
    [sym_comment] = ACTIONS(72),
  },
  [944] = {
    [sym_argument_list] = STATE(251),
    [sym_generator_expression] = STATE(251),
    [anon_sym_DOT] = ACTIONS(1980),
    [anon_sym_LPAREN] = ACTIONS(424),
    [anon_sym_COMMA] = ACTIONS(1980),
    [anon_sym_STAR] = ACTIONS(862),
    [anon_sym_GT_GT] = ACTIONS(864),
    [anon_sym_if] = ACTIONS(1980),
    [anon_sym_COLON] = ACTIONS(1980),
    [anon_sym_async] = ACTIONS(1980),
    [anon_sym_for] = ACTIONS(1980),
    [anon_sym_in] = ACTIONS(1980),
    [anon_sym_AT] = ACTIONS(868),
    [anon_sym_not] = ACTIONS(1980),
    [anon_sym_and] = ACTIONS(1980),
    [anon_sym_or] = ACTIONS(1980),
    [anon_sym_PLUS] = ACTIONS(872),
    [anon_sym_DASH] = ACTIONS(872),
    [anon_sym_SLASH] = ACTIONS(862),
    [anon_sym_PERCENT] = ACTIONS(868),
    [anon_sym_SLASH_SLASH] = ACTIONS(868),
    [anon_sym_STAR_STAR] = ACTIONS(874),
    [anon_sym_PIPE] = ACTIONS(1980),
    [anon_sym_AMP] = ACTIONS(1980),
    [anon_sym_CARET] = ACTIONS(1980),
    [anon_sym_LT_LT] = ACTIONS(864),
    [anon_sym_LT] = ACTIONS(1982),
    [anon_sym_LT_EQ] = ACTIONS(1980),
    [anon_sym_EQ_EQ] = ACTIONS(1980),
    [anon_sym_BANG_EQ] = ACTIONS(1980),
    [anon_sym_GT_EQ] = ACTIONS(1980),
    [anon_sym_GT] = ACTIONS(1982),
    [anon_sym_LT_GT] = ACTIONS(1980),
    [anon_sym_is] = ACTIONS(1980),
    [anon_sym_LBRACK] = ACTIONS(1980),
    [anon_sym_RBRACE] = ACTIONS(1980),
    [sym_comment] = ACTIONS(72),
  },
  [945] = {
    [aux_sym_comparison_operator_repeat1] = STATE(945),
    [anon_sym_COMMA] = ACTIONS(1984),
    [anon_sym_if] = ACTIONS(1984),
    [anon_sym_COLON] = ACTIONS(1984),
    [anon_sym_async] = ACTIONS(1984),
    [anon_sym_for] = ACTIONS(1984),
    [anon_sym_in] = ACTIONS(2855),
    [anon_sym_not] = ACTIONS(2858),
    [anon_sym_and] = ACTIONS(1984),
    [anon_sym_or] = ACTIONS(1984),
    [anon_sym_LT] = ACTIONS(2861),
    [anon_sym_LT_EQ] = ACTIONS(2855),
    [anon_sym_EQ_EQ] = ACTIONS(2855),
    [anon_sym_BANG_EQ] = ACTIONS(2855),
    [anon_sym_GT_EQ] = ACTIONS(2855),
    [anon_sym_GT] = ACTIONS(2861),
    [anon_sym_LT_GT] = ACTIONS(2855),
    [anon_sym_is] = ACTIONS(2864),
    [anon_sym_RBRACE] = ACTIONS(1984),
    [sym_comment] = ACTIONS(72),
  },
  [946] = {
    [sym__newline] = ACTIONS(2867),
    [anon_sym_DOT] = ACTIONS(2867),
    [anon_sym_LPAREN] = ACTIONS(2867),
    [anon_sym_COMMA] = ACTIONS(2867),
    [anon_sym_STAR] = ACTIONS(2869),
    [anon_sym_GT_GT] = ACTIONS(2869),
    [anon_sym_if] = ACTIONS(2867),
    [anon_sym_COLON] = ACTIONS(2867),
    [anon_sym_in] = ACTIONS(2867),
    [anon_sym_EQ] = ACTIONS(2869),
    [anon_sym_AT] = ACTIONS(2869),
    [anon_sym_not] = ACTIONS(2867),
    [anon_sym_and] = ACTIONS(2867),
    [anon_sym_or] = ACTIONS(2867),
    [anon_sym_PLUS] = ACTIONS(2869),
    [anon_sym_DASH] = ACTIONS(2869),
    [anon_sym_SLASH] = ACTIONS(2869),
    [anon_sym_PERCENT] = ACTIONS(2869),
    [anon_sym_SLASH_SLASH] = ACTIONS(2869),
    [anon_sym_STAR_STAR] = ACTIONS(2869),
    [anon_sym_PIPE] = ACTIONS(2869),
    [anon_sym_AMP] = ACTIONS(2869),
    [anon_sym_CARET] = ACTIONS(2869),
    [anon_sym_LT_LT] = ACTIONS(2869),
    [anon_sym_LT] = ACTIONS(2869),
    [anon_sym_LT_EQ] = ACTIONS(2867),
    [anon_sym_EQ_EQ] = ACTIONS(2867),
    [anon_sym_BANG_EQ] = ACTIONS(2867),
    [anon_sym_GT_EQ] = ACTIONS(2867),
    [anon_sym_GT] = ACTIONS(2869),
    [anon_sym_LT_GT] = ACTIONS(2867),
    [anon_sym_is] = ACTIONS(2867),
    [anon_sym_PLUS_EQ] = ACTIONS(2867),
    [anon_sym_DASH_EQ] = ACTIONS(2867),
    [anon_sym_STAR_EQ] = ACTIONS(2867),
    [anon_sym_SLASH_EQ] = ACTIONS(2867),
    [anon_sym_AT_EQ] = ACTIONS(2867),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(2867),
    [anon_sym_PERCENT_EQ] = ACTIONS(2867),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2867),
    [anon_sym_GT_GT_EQ] = ACTIONS(2867),
    [anon_sym_LT_LT_EQ] = ACTIONS(2867),
    [anon_sym_AMP_EQ] = ACTIONS(2867),
    [anon_sym_CARET_EQ] = ACTIONS(2867),
    [anon_sym_PIPE_EQ] = ACTIONS(2867),
    [anon_sym_LBRACK] = ACTIONS(2867),
    [sym_comment] = ACTIONS(72),
    [sym__semicolon] = ACTIONS(2867),
  },
  [947] = {
    [sym__newline] = ACTIONS(716),
    [anon_sym_if] = ACTIONS(716),
    [anon_sym_EQ] = ACTIONS(716),
    [anon_sym_and] = ACTIONS(1877),
    [anon_sym_or] = ACTIONS(1879),
    [sym_comment] = ACTIONS(72),
    [sym__semicolon] = ACTIONS(716),
  },
  [948] = {
    [sym__expression] = STATE(1327),
    [sym__primary_expression] = STATE(500),
    [sym_not_operator] = STATE(1327),
    [sym_boolean_operator] = STATE(1327),
    [sym_binary_operator] = STATE(500),
    [sym_unary_operator] = STATE(500),
    [sym_comparison_operator] = STATE(1327),
    [sym_lambda] = STATE(1327),
    [sym_attribute] = STATE(500),
    [sym_subscript] = STATE(500),
    [sym_call] = STATE(500),
    [sym_list] = STATE(500),
    [sym_list_comprehension] = STATE(500),
    [sym_dictionary] = STATE(500),
    [sym_dictionary_comprehension] = STATE(500),
    [sym_set] = STATE(500),
    [sym_set_comprehension] = STATE(500),
    [sym_parenthesized_expression] = STATE(500),
    [sym_tuple] = STATE(500),
    [sym_generator_expression] = STATE(500),
    [sym_conditional_expression] = STATE(1327),
    [sym_concatenated_string] = STATE(500),
    [sym_await] = STATE(1327),
    [anon_sym_LPAREN] = ACTIONS(130),
    [anon_sym_print] = ACTIONS(112),
    [anon_sym_exec] = ACTIONS(112),
    [anon_sym_not] = ACTIONS(894),
    [anon_sym_PLUS] = ACTIONS(896),
    [anon_sym_DASH] = ACTIONS(896),
    [anon_sym_TILDE] = ACTIONS(896),
    [anon_sym_lambda] = ACTIONS(898),
    [anon_sym_LBRACK] = ACTIONS(134),
    [sym_ellipsis] = ACTIONS(900),
    [anon_sym_LBRACE] = ACTIONS(122),
    [sym_string] = ACTIONS(902),
    [sym_integer] = ACTIONS(904),
    [sym_float] = ACTIONS(904),
    [sym_identifier] = ACTIONS(904),
    [sym_true] = ACTIONS(904),
    [sym_false] = ACTIONS(904),
    [sym_none] = ACTIONS(904),
    [anon_sym_await] = ACTIONS(906),
    [sym_comment] = ACTIONS(72),
  },
  [949] = {
    [anon_sym_COLON] = ACTIONS(2871),
    [sym_comment] = ACTIONS(72),
  },
  [950] = {
    [aux_sym_concatenated_string_repeat1] = STATE(1329),
    [sym__newline] = ACTIONS(886),
    [anon_sym_DOT] = ACTIONS(886),
    [anon_sym_LPAREN] = ACTIONS(886),
    [anon_sym_STAR] = ACTIONS(888),
    [anon_sym_GT_GT] = ACTIONS(886),
    [anon_sym_if] = ACTIONS(886),
    [anon_sym_in] = ACTIONS(886),
    [anon_sym_EQ] = ACTIONS(888),
    [anon_sym_AT] = ACTIONS(886),
    [anon_sym_not] = ACTIONS(886),
    [anon_sym_and] = ACTIONS(886),
    [anon_sym_or] = ACTIONS(886),
    [anon_sym_PLUS] = ACTIONS(886),
    [anon_sym_DASH] = ACTIONS(886),
    [anon_sym_SLASH] = ACTIONS(888),
    [anon_sym_PERCENT] = ACTIONS(886),
    [anon_sym_SLASH_SLASH] = ACTIONS(886),
    [anon_sym_STAR_STAR] = ACTIONS(886),
    [anon_sym_PIPE] = ACTIONS(886),
    [anon_sym_AMP] = ACTIONS(886),
    [anon_sym_CARET] = ACTIONS(886),
    [anon_sym_LT_LT] = ACTIONS(886),
    [anon_sym_LT] = ACTIONS(888),
    [anon_sym_LT_EQ] = ACTIONS(886),
    [anon_sym_EQ_EQ] = ACTIONS(886),
    [anon_sym_BANG_EQ] = ACTIONS(886),
    [anon_sym_GT_EQ] = ACTIONS(886),
    [anon_sym_GT] = ACTIONS(888),
    [anon_sym_LT_GT] = ACTIONS(886),
    [anon_sym_is] = ACTIONS(886),
    [anon_sym_LBRACK] = ACTIONS(886),
    [sym_string] = ACTIONS(2873),
    [sym_comment] = ACTIONS(72),
    [sym__semicolon] = ACTIONS(886),
  },
  [951] = {
    [sym__expression] = STATE(1330),
    [sym__primary_expression] = STATE(513),
    [sym_not_operator] = STATE(1330),
    [sym_boolean_operator] = STATE(1330),
    [sym_binary_operator] = STATE(513),
    [sym_unary_operator] = STATE(513),
    [sym_comparison_operator] = STATE(1330),
    [sym_lambda] = STATE(1330),
    [sym_attribute] = STATE(513),
    [sym_subscript] = STATE(513),
    [sym_call] = STATE(513),
    [sym_list] = STATE(513),
    [sym_list_comprehension] = STATE(513),
    [sym_dictionary] = STATE(513),
    [sym_dictionary_comprehension] = STATE(513),
    [sym_set] = STATE(513),
    [sym_set_comprehension] = STATE(513),
    [sym_parenthesized_expression] = STATE(513),
    [sym_tuple] = STATE(513),
    [sym_generator_expression] = STATE(513),
    [sym_conditional_expression] = STATE(1330),
    [sym_concatenated_string] = STATE(513),
    [sym_await] = STATE(1330),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_not] = ACTIONS(914),
    [anon_sym_PLUS] = ACTIONS(916),
    [anon_sym_DASH] = ACTIONS(916),
    [anon_sym_TILDE] = ACTIONS(916),
    [anon_sym_lambda] = ACTIONS(918),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(920),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(922),
    [sym_integer] = ACTIONS(924),
    [sym_float] = ACTIONS(924),
    [sym_identifier] = ACTIONS(924),
    [sym_true] = ACTIONS(924),
    [sym_false] = ACTIONS(924),
    [sym_none] = ACTIONS(924),
    [anon_sym_await] = ACTIONS(926),
    [sym_comment] = ACTIONS(72),
  },
  [952] = {
    [sym__expression] = STATE(514),
    [sym__primary_expression] = STATE(500),
    [sym_not_operator] = STATE(514),
    [sym_boolean_operator] = STATE(514),
    [sym_binary_operator] = STATE(500),
    [sym_unary_operator] = STATE(500),
    [sym_comparison_operator] = STATE(514),
    [sym_lambda] = STATE(514),
    [sym_attribute] = STATE(500),
    [sym_subscript] = STATE(500),
    [sym_call] = STATE(500),
    [sym_list] = STATE(500),
    [sym_list_comprehension] = STATE(500),
    [sym_dictionary] = STATE(500),
    [sym_dictionary_comprehension] = STATE(500),
    [sym_set] = STATE(500),
    [sym_set_comprehension] = STATE(500),
    [sym_parenthesized_expression] = STATE(500),
    [sym_tuple] = STATE(500),
    [sym_generator_expression] = STATE(500),
    [sym_conditional_expression] = STATE(514),
    [sym_concatenated_string] = STATE(500),
    [sym_await] = STATE(514),
    [anon_sym_LPAREN] = ACTIONS(130),
    [anon_sym_print] = ACTIONS(112),
    [anon_sym_exec] = ACTIONS(112),
    [anon_sym_not] = ACTIONS(894),
    [anon_sym_PLUS] = ACTIONS(896),
    [anon_sym_DASH] = ACTIONS(896),
    [anon_sym_TILDE] = ACTIONS(896),
    [anon_sym_lambda] = ACTIONS(898),
    [anon_sym_LBRACK] = ACTIONS(134),
    [sym_ellipsis] = ACTIONS(900),
    [anon_sym_LBRACE] = ACTIONS(122),
    [sym_string] = ACTIONS(902),
    [sym_integer] = ACTIONS(904),
    [sym_float] = ACTIONS(904),
    [sym_identifier] = ACTIONS(904),
    [sym_true] = ACTIONS(904),
    [sym_false] = ACTIONS(904),
    [sym_none] = ACTIONS(904),
    [anon_sym_await] = ACTIONS(906),
    [sym_comment] = ACTIONS(72),
  },
  [953] = {
    [sym__expression] = STATE(1331),
    [sym__primary_expression] = STATE(500),
    [sym_not_operator] = STATE(1331),
    [sym_boolean_operator] = STATE(1331),
    [sym_binary_operator] = STATE(500),
    [sym_unary_operator] = STATE(500),
    [sym_comparison_operator] = STATE(1331),
    [sym_lambda] = STATE(1331),
    [sym_attribute] = STATE(500),
    [sym_subscript] = STATE(500),
    [sym_call] = STATE(500),
    [sym_list] = STATE(500),
    [sym_list_comprehension] = STATE(500),
    [sym_dictionary] = STATE(500),
    [sym_dictionary_comprehension] = STATE(500),
    [sym_set] = STATE(500),
    [sym_set_comprehension] = STATE(500),
    [sym_parenthesized_expression] = STATE(500),
    [sym_tuple] = STATE(500),
    [sym_generator_expression] = STATE(500),
    [sym_conditional_expression] = STATE(1331),
    [sym_concatenated_string] = STATE(500),
    [sym_await] = STATE(1331),
    [anon_sym_LPAREN] = ACTIONS(130),
    [anon_sym_print] = ACTIONS(112),
    [anon_sym_exec] = ACTIONS(112),
    [anon_sym_not] = ACTIONS(894),
    [anon_sym_PLUS] = ACTIONS(896),
    [anon_sym_DASH] = ACTIONS(896),
    [anon_sym_TILDE] = ACTIONS(896),
    [anon_sym_lambda] = ACTIONS(898),
    [anon_sym_LBRACK] = ACTIONS(134),
    [sym_ellipsis] = ACTIONS(900),
    [anon_sym_LBRACE] = ACTIONS(122),
    [sym_string] = ACTIONS(902),
    [sym_integer] = ACTIONS(904),
    [sym_float] = ACTIONS(904),
    [sym_identifier] = ACTIONS(904),
    [sym_true] = ACTIONS(904),
    [sym_false] = ACTIONS(904),
    [sym_none] = ACTIONS(904),
    [anon_sym_await] = ACTIONS(906),
    [sym_comment] = ACTIONS(72),
  },
  [954] = {
    [sym__primary_expression] = STATE(1332),
    [sym_binary_operator] = STATE(1332),
    [sym_unary_operator] = STATE(1332),
    [sym_attribute] = STATE(1332),
    [sym_subscript] = STATE(1332),
    [sym_call] = STATE(1332),
    [sym_list] = STATE(1332),
    [sym_list_comprehension] = STATE(1332),
    [sym_dictionary] = STATE(1332),
    [sym_dictionary_comprehension] = STATE(1332),
    [sym_set] = STATE(1332),
    [sym_set_comprehension] = STATE(1332),
    [sym_parenthesized_expression] = STATE(1332),
    [sym_tuple] = STATE(1332),
    [sym_generator_expression] = STATE(1332),
    [sym_concatenated_string] = STATE(1332),
    [anon_sym_LPAREN] = ACTIONS(130),
    [anon_sym_print] = ACTIONS(112),
    [anon_sym_exec] = ACTIONS(112),
    [anon_sym_PLUS] = ACTIONS(896),
    [anon_sym_DASH] = ACTIONS(896),
    [anon_sym_TILDE] = ACTIONS(896),
    [anon_sym_LBRACK] = ACTIONS(134),
    [sym_ellipsis] = ACTIONS(2875),
    [anon_sym_LBRACE] = ACTIONS(122),
    [sym_string] = ACTIONS(902),
    [sym_integer] = ACTIONS(2877),
    [sym_float] = ACTIONS(2877),
    [sym_identifier] = ACTIONS(2877),
    [sym_true] = ACTIONS(2877),
    [sym_false] = ACTIONS(2877),
    [sym_none] = ACTIONS(2877),
    [sym_comment] = ACTIONS(72),
  },
  [955] = {
    [sym__primary_expression] = STATE(1333),
    [sym_binary_operator] = STATE(1333),
    [sym_unary_operator] = STATE(1333),
    [sym_attribute] = STATE(1333),
    [sym_subscript] = STATE(1333),
    [sym_call] = STATE(1333),
    [sym_list] = STATE(1333),
    [sym_list_comprehension] = STATE(1333),
    [sym_dictionary] = STATE(1333),
    [sym_dictionary_comprehension] = STATE(1333),
    [sym_set] = STATE(1333),
    [sym_set_comprehension] = STATE(1333),
    [sym_parenthesized_expression] = STATE(1333),
    [sym_tuple] = STATE(1333),
    [sym_generator_expression] = STATE(1333),
    [sym_concatenated_string] = STATE(1333),
    [anon_sym_LPAREN] = ACTIONS(130),
    [anon_sym_print] = ACTIONS(112),
    [anon_sym_exec] = ACTIONS(112),
    [anon_sym_PLUS] = ACTIONS(896),
    [anon_sym_DASH] = ACTIONS(896),
    [anon_sym_TILDE] = ACTIONS(896),
    [anon_sym_LBRACK] = ACTIONS(134),
    [sym_ellipsis] = ACTIONS(2879),
    [anon_sym_LBRACE] = ACTIONS(122),
    [sym_string] = ACTIONS(902),
    [sym_integer] = ACTIONS(2881),
    [sym_float] = ACTIONS(2881),
    [sym_identifier] = ACTIONS(2881),
    [sym_true] = ACTIONS(2881),
    [sym_false] = ACTIONS(2881),
    [sym_none] = ACTIONS(2881),
    [sym_comment] = ACTIONS(72),
  },
  [956] = {
    [sym__primary_expression] = STATE(1334),
    [sym_binary_operator] = STATE(1334),
    [sym_unary_operator] = STATE(1334),
    [sym_attribute] = STATE(1334),
    [sym_subscript] = STATE(1334),
    [sym_call] = STATE(1334),
    [sym_list] = STATE(1334),
    [sym_list_comprehension] = STATE(1334),
    [sym_dictionary] = STATE(1334),
    [sym_dictionary_comprehension] = STATE(1334),
    [sym_set] = STATE(1334),
    [sym_set_comprehension] = STATE(1334),
    [sym_parenthesized_expression] = STATE(1334),
    [sym_tuple] = STATE(1334),
    [sym_generator_expression] = STATE(1334),
    [sym_concatenated_string] = STATE(1334),
    [anon_sym_LPAREN] = ACTIONS(130),
    [anon_sym_print] = ACTIONS(112),
    [anon_sym_exec] = ACTIONS(112),
    [anon_sym_PLUS] = ACTIONS(896),
    [anon_sym_DASH] = ACTIONS(896),
    [anon_sym_TILDE] = ACTIONS(896),
    [anon_sym_LBRACK] = ACTIONS(134),
    [sym_ellipsis] = ACTIONS(2883),
    [anon_sym_LBRACE] = ACTIONS(122),
    [sym_string] = ACTIONS(902),
    [sym_integer] = ACTIONS(2885),
    [sym_float] = ACTIONS(2885),
    [sym_identifier] = ACTIONS(2885),
    [sym_true] = ACTIONS(2885),
    [sym_false] = ACTIONS(2885),
    [sym_none] = ACTIONS(2885),
    [sym_comment] = ACTIONS(72),
  },
  [957] = {
    [anon_sym_in] = ACTIONS(2887),
    [sym_comment] = ACTIONS(72),
  },
  [958] = {
    [sym__primary_expression] = STATE(1336),
    [sym_binary_operator] = STATE(1336),
    [sym_unary_operator] = STATE(1336),
    [sym_attribute] = STATE(1336),
    [sym_subscript] = STATE(1336),
    [sym_call] = STATE(1336),
    [sym_list] = STATE(1336),
    [sym_list_comprehension] = STATE(1336),
    [sym_dictionary] = STATE(1336),
    [sym_dictionary_comprehension] = STATE(1336),
    [sym_set] = STATE(1336),
    [sym_set_comprehension] = STATE(1336),
    [sym_parenthesized_expression] = STATE(1336),
    [sym_tuple] = STATE(1336),
    [sym_generator_expression] = STATE(1336),
    [sym_concatenated_string] = STATE(1336),
    [anon_sym_LPAREN] = ACTIONS(130),
    [anon_sym_print] = ACTIONS(112),
    [anon_sym_exec] = ACTIONS(112),
    [anon_sym_PLUS] = ACTIONS(896),
    [anon_sym_DASH] = ACTIONS(896),
    [anon_sym_TILDE] = ACTIONS(896),
    [anon_sym_LBRACK] = ACTIONS(134),
    [sym_ellipsis] = ACTIONS(2889),
    [anon_sym_LBRACE] = ACTIONS(122),
    [sym_string] = ACTIONS(902),
    [sym_integer] = ACTIONS(2891),
    [sym_float] = ACTIONS(2891),
    [sym_identifier] = ACTIONS(2891),
    [sym_true] = ACTIONS(2891),
    [sym_false] = ACTIONS(2891),
    [sym_none] = ACTIONS(2891),
    [sym_comment] = ACTIONS(72),
  },
  [959] = {
    [sym__primary_expression] = STATE(663),
    [sym_binary_operator] = STATE(663),
    [sym_unary_operator] = STATE(663),
    [sym_attribute] = STATE(663),
    [sym_subscript] = STATE(663),
    [sym_call] = STATE(663),
    [sym_list] = STATE(663),
    [sym_list_comprehension] = STATE(663),
    [sym_dictionary] = STATE(663),
    [sym_dictionary_comprehension] = STATE(663),
    [sym_set] = STATE(663),
    [sym_set_comprehension] = STATE(663),
    [sym_parenthesized_expression] = STATE(663),
    [sym_tuple] = STATE(663),
    [sym_generator_expression] = STATE(663),
    [sym_concatenated_string] = STATE(663),
    [anon_sym_LPAREN] = ACTIONS(130),
    [anon_sym_print] = ACTIONS(112),
    [anon_sym_exec] = ACTIONS(112),
    [anon_sym_PLUS] = ACTIONS(896),
    [anon_sym_DASH] = ACTIONS(896),
    [anon_sym_TILDE] = ACTIONS(896),
    [anon_sym_LBRACK] = ACTIONS(134),
    [sym_ellipsis] = ACTIONS(1303),
    [anon_sym_LBRACE] = ACTIONS(122),
    [sym_string] = ACTIONS(902),
    [sym_integer] = ACTIONS(1305),
    [sym_float] = ACTIONS(1305),
    [sym_identifier] = ACTIONS(1305),
    [sym_true] = ACTIONS(1305),
    [sym_false] = ACTIONS(1305),
    [sym_none] = ACTIONS(1305),
    [sym_comment] = ACTIONS(72),
  },
  [960] = {
    [sym__primary_expression] = STATE(1337),
    [sym_binary_operator] = STATE(1337),
    [sym_unary_operator] = STATE(1337),
    [sym_attribute] = STATE(1337),
    [sym_subscript] = STATE(1337),
    [sym_call] = STATE(1337),
    [sym_list] = STATE(1337),
    [sym_list_comprehension] = STATE(1337),
    [sym_dictionary] = STATE(1337),
    [sym_dictionary_comprehension] = STATE(1337),
    [sym_set] = STATE(1337),
    [sym_set_comprehension] = STATE(1337),
    [sym_parenthesized_expression] = STATE(1337),
    [sym_tuple] = STATE(1337),
    [sym_generator_expression] = STATE(1337),
    [sym_concatenated_string] = STATE(1337),
    [anon_sym_LPAREN] = ACTIONS(130),
    [anon_sym_print] = ACTIONS(112),
    [anon_sym_exec] = ACTIONS(112),
    [anon_sym_PLUS] = ACTIONS(896),
    [anon_sym_DASH] = ACTIONS(896),
    [anon_sym_TILDE] = ACTIONS(896),
    [anon_sym_LBRACK] = ACTIONS(134),
    [sym_ellipsis] = ACTIONS(2893),
    [anon_sym_LBRACE] = ACTIONS(122),
    [sym_string] = ACTIONS(902),
    [sym_integer] = ACTIONS(2895),
    [sym_float] = ACTIONS(2895),
    [sym_identifier] = ACTIONS(2895),
    [sym_true] = ACTIONS(2895),
    [sym_false] = ACTIONS(2895),
    [sym_none] = ACTIONS(2895),
    [sym_comment] = ACTIONS(72),
  },
  [961] = {
    [sym__primary_expression] = STATE(1338),
    [sym_binary_operator] = STATE(1338),
    [sym_unary_operator] = STATE(1338),
    [sym_attribute] = STATE(1338),
    [sym_subscript] = STATE(1338),
    [sym_call] = STATE(1338),
    [sym_list] = STATE(1338),
    [sym_list_comprehension] = STATE(1338),
    [sym_dictionary] = STATE(1338),
    [sym_dictionary_comprehension] = STATE(1338),
    [sym_set] = STATE(1338),
    [sym_set_comprehension] = STATE(1338),
    [sym_parenthesized_expression] = STATE(1338),
    [sym_tuple] = STATE(1338),
    [sym_generator_expression] = STATE(1338),
    [sym_concatenated_string] = STATE(1338),
    [anon_sym_LPAREN] = ACTIONS(130),
    [anon_sym_print] = ACTIONS(112),
    [anon_sym_exec] = ACTIONS(112),
    [anon_sym_PLUS] = ACTIONS(896),
    [anon_sym_DASH] = ACTIONS(896),
    [anon_sym_TILDE] = ACTIONS(896),
    [anon_sym_LBRACK] = ACTIONS(134),
    [sym_ellipsis] = ACTIONS(2897),
    [anon_sym_LBRACE] = ACTIONS(122),
    [sym_string] = ACTIONS(902),
    [sym_integer] = ACTIONS(2899),
    [sym_float] = ACTIONS(2899),
    [sym_identifier] = ACTIONS(2899),
    [sym_true] = ACTIONS(2899),
    [sym_false] = ACTIONS(2899),
    [sym_none] = ACTIONS(2899),
    [sym_comment] = ACTIONS(72),
  },
  [962] = {
    [sym__primary_expression] = STATE(1339),
    [sym_binary_operator] = STATE(1339),
    [sym_unary_operator] = STATE(1339),
    [sym_attribute] = STATE(1339),
    [sym_subscript] = STATE(1339),
    [sym_call] = STATE(1339),
    [sym_list] = STATE(1339),
    [sym_list_comprehension] = STATE(1339),
    [sym_dictionary] = STATE(1339),
    [sym_dictionary_comprehension] = STATE(1339),
    [sym_set] = STATE(1339),
    [sym_set_comprehension] = STATE(1339),
    [sym_parenthesized_expression] = STATE(1339),
    [sym_tuple] = STATE(1339),
    [sym_generator_expression] = STATE(1339),
    [sym_concatenated_string] = STATE(1339),
    [anon_sym_LPAREN] = ACTIONS(130),
    [anon_sym_print] = ACTIONS(112),
    [anon_sym_exec] = ACTIONS(112),
    [anon_sym_PLUS] = ACTIONS(896),
    [anon_sym_DASH] = ACTIONS(896),
    [anon_sym_TILDE] = ACTIONS(896),
    [anon_sym_LBRACK] = ACTIONS(134),
    [sym_ellipsis] = ACTIONS(2901),
    [anon_sym_LBRACE] = ACTIONS(122),
    [sym_string] = ACTIONS(902),
    [sym_integer] = ACTIONS(2903),
    [sym_float] = ACTIONS(2903),
    [sym_identifier] = ACTIONS(2903),
    [sym_true] = ACTIONS(2903),
    [sym_false] = ACTIONS(2903),
    [sym_none] = ACTIONS(2903),
    [sym_comment] = ACTIONS(72),
  },
  [963] = {
    [sym__primary_expression] = STATE(1334),
    [sym_binary_operator] = STATE(1334),
    [sym_unary_operator] = STATE(1334),
    [sym_attribute] = STATE(1334),
    [sym_subscript] = STATE(1334),
    [sym_call] = STATE(1334),
    [sym_list] = STATE(1334),
    [sym_list_comprehension] = STATE(1334),
    [sym_dictionary] = STATE(1334),
    [sym_dictionary_comprehension] = STATE(1334),
    [sym_set] = STATE(1334),
    [sym_set_comprehension] = STATE(1334),
    [sym_parenthesized_expression] = STATE(1334),
    [sym_tuple] = STATE(1334),
    [sym_generator_expression] = STATE(1334),
    [sym_concatenated_string] = STATE(1334),
    [anon_sym_LPAREN] = ACTIONS(130),
    [anon_sym_print] = ACTIONS(112),
    [anon_sym_exec] = ACTIONS(112),
    [anon_sym_not] = ACTIONS(2905),
    [anon_sym_PLUS] = ACTIONS(896),
    [anon_sym_DASH] = ACTIONS(896),
    [anon_sym_TILDE] = ACTIONS(896),
    [anon_sym_LBRACK] = ACTIONS(134),
    [sym_ellipsis] = ACTIONS(2883),
    [anon_sym_LBRACE] = ACTIONS(122),
    [sym_string] = ACTIONS(902),
    [sym_integer] = ACTIONS(2885),
    [sym_float] = ACTIONS(2885),
    [sym_identifier] = ACTIONS(2885),
    [sym_true] = ACTIONS(2885),
    [sym_false] = ACTIONS(2885),
    [sym_none] = ACTIONS(2885),
    [sym_comment] = ACTIONS(72),
  },
  [964] = {
    [aux_sym_comparison_operator_repeat1] = STATE(1340),
    [sym__newline] = ACTIONS(998),
    [anon_sym_if] = ACTIONS(998),
    [anon_sym_in] = ACTIONS(1885),
    [anon_sym_EQ] = ACTIONS(1000),
    [anon_sym_not] = ACTIONS(1889),
    [anon_sym_and] = ACTIONS(998),
    [anon_sym_or] = ACTIONS(998),
    [anon_sym_LT] = ACTIONS(1901),
    [anon_sym_LT_EQ] = ACTIONS(1885),
    [anon_sym_EQ_EQ] = ACTIONS(1885),
    [anon_sym_BANG_EQ] = ACTIONS(1885),
    [anon_sym_GT_EQ] = ACTIONS(1885),
    [anon_sym_GT] = ACTIONS(1901),
    [anon_sym_LT_GT] = ACTIONS(1885),
    [anon_sym_is] = ACTIONS(1903),
    [sym_comment] = ACTIONS(72),
    [sym__semicolon] = ACTIONS(998),
  },
  [965] = {
    [sym_expression_list] = STATE(502),
    [sym__expression] = STATE(503),
    [sym__primary_expression] = STATE(34),
    [sym_not_operator] = STATE(503),
    [sym_boolean_operator] = STATE(503),
    [sym_binary_operator] = STATE(34),
    [sym_unary_operator] = STATE(34),
    [sym_comparison_operator] = STATE(503),
    [sym_lambda] = STATE(503),
    [sym_assignment] = STATE(1341),
    [sym_augmented_assignment] = STATE(1341),
    [sym__right_hand_side] = STATE(1341),
    [sym_yield] = STATE(1341),
    [sym_attribute] = STATE(34),
    [sym_subscript] = STATE(34),
    [sym_call] = STATE(34),
    [sym_list] = STATE(34),
    [sym_list_comprehension] = STATE(34),
    [sym_dictionary] = STATE(34),
    [sym_dictionary_comprehension] = STATE(34),
    [sym_set] = STATE(34),
    [sym_set_comprehension] = STATE(34),
    [sym_parenthesized_expression] = STATE(34),
    [sym_tuple] = STATE(34),
    [sym_generator_expression] = STATE(34),
    [sym_conditional_expression] = STATE(503),
    [sym_concatenated_string] = STATE(34),
    [sym_await] = STATE(503),
    [anon_sym_LPAREN] = ACTIONS(14),
    [anon_sym_print] = ACTIONS(216),
    [anon_sym_exec] = ACTIONS(216),
    [anon_sym_not] = ACTIONS(52),
    [anon_sym_PLUS] = ACTIONS(54),
    [anon_sym_DASH] = ACTIONS(54),
    [anon_sym_TILDE] = ACTIONS(54),
    [anon_sym_lambda] = ACTIONS(56),
    [anon_sym_yield] = ACTIONS(58),
    [anon_sym_LBRACK] = ACTIONS(60),
    [sym_ellipsis] = ACTIONS(62),
    [anon_sym_LBRACE] = ACTIONS(64),
    [sym_string] = ACTIONS(66),
    [sym_integer] = ACTIONS(68),
    [sym_float] = ACTIONS(68),
    [sym_identifier] = ACTIONS(68),
    [sym_true] = ACTIONS(68),
    [sym_false] = ACTIONS(68),
    [sym_none] = ACTIONS(68),
    [anon_sym_await] = ACTIONS(70),
    [sym_comment] = ACTIONS(72),
  },
  [966] = {
    [sym__expression] = STATE(506),
    [sym__primary_expression] = STATE(34),
    [sym_not_operator] = STATE(506),
    [sym_boolean_operator] = STATE(506),
    [sym_binary_operator] = STATE(34),
    [sym_unary_operator] = STATE(34),
    [sym_comparison_operator] = STATE(506),
    [sym_lambda] = STATE(506),
    [sym_attribute] = STATE(34),
    [sym_subscript] = STATE(34),
    [sym_call] = STATE(34),
    [sym_list] = STATE(34),
    [sym_list_comprehension] = STATE(34),
    [sym_dictionary] = STATE(34),
    [sym_dictionary_comprehension] = STATE(34),
    [sym_set] = STATE(34),
    [sym_set_comprehension] = STATE(34),
    [sym_parenthesized_expression] = STATE(34),
    [sym_tuple] = STATE(34),
    [sym_generator_expression] = STATE(34),
    [sym_conditional_expression] = STATE(506),
    [sym_concatenated_string] = STATE(34),
    [sym_await] = STATE(506),
    [sym__newline] = ACTIONS(910),
    [anon_sym_LPAREN] = ACTIONS(14),
    [anon_sym_print] = ACTIONS(216),
    [anon_sym_COLON] = ACTIONS(910),
    [anon_sym_EQ] = ACTIONS(910),
    [anon_sym_exec] = ACTIONS(216),
    [anon_sym_not] = ACTIONS(52),
    [anon_sym_PLUS] = ACTIONS(912),
    [anon_sym_DASH] = ACTIONS(912),
    [anon_sym_TILDE] = ACTIONS(54),
    [anon_sym_lambda] = ACTIONS(56),
    [anon_sym_PLUS_EQ] = ACTIONS(910),
    [anon_sym_DASH_EQ] = ACTIONS(910),
    [anon_sym_STAR_EQ] = ACTIONS(910),
    [anon_sym_SLASH_EQ] = ACTIONS(910),
    [anon_sym_AT_EQ] = ACTIONS(910),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(910),
    [anon_sym_PERCENT_EQ] = ACTIONS(910),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(910),
    [anon_sym_GT_GT_EQ] = ACTIONS(910),
    [anon_sym_LT_LT_EQ] = ACTIONS(910),
    [anon_sym_AMP_EQ] = ACTIONS(910),
    [anon_sym_CARET_EQ] = ACTIONS(910),
    [anon_sym_PIPE_EQ] = ACTIONS(910),
    [anon_sym_LBRACK] = ACTIONS(60),
    [sym_ellipsis] = ACTIONS(62),
    [anon_sym_LBRACE] = ACTIONS(64),
    [sym_string] = ACTIONS(66),
    [sym_integer] = ACTIONS(68),
    [sym_float] = ACTIONS(68),
    [sym_identifier] = ACTIONS(68),
    [sym_true] = ACTIONS(68),
    [sym_false] = ACTIONS(68),
    [sym_none] = ACTIONS(68),
    [anon_sym_await] = ACTIONS(70),
    [sym_comment] = ACTIONS(72),
    [sym__semicolon] = ACTIONS(910),
  },
  [967] = {
    [aux_sym_print_statement_repeat1] = STATE(517),
    [sym__newline] = ACTIONS(910),
    [anon_sym_COMMA] = ACTIONS(2907),
    [anon_sym_COLON] = ACTIONS(910),
    [anon_sym_EQ] = ACTIONS(910),
    [anon_sym_PLUS_EQ] = ACTIONS(910),
    [anon_sym_DASH_EQ] = ACTIONS(910),
    [anon_sym_STAR_EQ] = ACTIONS(910),
    [anon_sym_SLASH_EQ] = ACTIONS(910),
    [anon_sym_AT_EQ] = ACTIONS(910),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(910),
    [anon_sym_PERCENT_EQ] = ACTIONS(910),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(910),
    [anon_sym_GT_GT_EQ] = ACTIONS(910),
    [anon_sym_LT_LT_EQ] = ACTIONS(910),
    [anon_sym_AMP_EQ] = ACTIONS(910),
    [anon_sym_CARET_EQ] = ACTIONS(910),
    [anon_sym_PIPE_EQ] = ACTIONS(910),
    [sym_comment] = ACTIONS(72),
    [sym__semicolon] = ACTIONS(910),
  },
  [968] = {
    [anon_sym_if] = ACTIONS(716),
    [anon_sym_else] = ACTIONS(716),
    [anon_sym_and] = ACTIONS(1925),
    [anon_sym_or] = ACTIONS(1927),
    [sym_comment] = ACTIONS(72),
  },
  [969] = {
    [sym__expression] = STATE(1343),
    [sym__primary_expression] = STATE(513),
    [sym_not_operator] = STATE(1343),
    [sym_boolean_operator] = STATE(1343),
    [sym_binary_operator] = STATE(513),
    [sym_unary_operator] = STATE(513),
    [sym_comparison_operator] = STATE(1343),
    [sym_lambda] = STATE(1343),
    [sym_attribute] = STATE(513),
    [sym_subscript] = STATE(513),
    [sym_call] = STATE(513),
    [sym_list] = STATE(513),
    [sym_list_comprehension] = STATE(513),
    [sym_dictionary] = STATE(513),
    [sym_dictionary_comprehension] = STATE(513),
    [sym_set] = STATE(513),
    [sym_set_comprehension] = STATE(513),
    [sym_parenthesized_expression] = STATE(513),
    [sym_tuple] = STATE(513),
    [sym_generator_expression] = STATE(513),
    [sym_conditional_expression] = STATE(1343),
    [sym_concatenated_string] = STATE(513),
    [sym_await] = STATE(1343),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_not] = ACTIONS(914),
    [anon_sym_PLUS] = ACTIONS(916),
    [anon_sym_DASH] = ACTIONS(916),
    [anon_sym_TILDE] = ACTIONS(916),
    [anon_sym_lambda] = ACTIONS(918),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(920),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(922),
    [sym_integer] = ACTIONS(924),
    [sym_float] = ACTIONS(924),
    [sym_identifier] = ACTIONS(924),
    [sym_true] = ACTIONS(924),
    [sym_false] = ACTIONS(924),
    [sym_none] = ACTIONS(924),
    [anon_sym_await] = ACTIONS(926),
    [sym_comment] = ACTIONS(72),
  },
  [970] = {
    [anon_sym_COLON] = ACTIONS(2909),
    [sym_comment] = ACTIONS(72),
  },
  [971] = {
    [aux_sym_concatenated_string_repeat1] = STATE(1345),
    [anon_sym_DOT] = ACTIONS(886),
    [anon_sym_LPAREN] = ACTIONS(886),
    [anon_sym_STAR] = ACTIONS(888),
    [anon_sym_GT_GT] = ACTIONS(886),
    [anon_sym_if] = ACTIONS(886),
    [anon_sym_else] = ACTIONS(886),
    [anon_sym_in] = ACTIONS(886),
    [anon_sym_AT] = ACTIONS(886),
    [anon_sym_not] = ACTIONS(886),
    [anon_sym_and] = ACTIONS(886),
    [anon_sym_or] = ACTIONS(886),
    [anon_sym_PLUS] = ACTIONS(886),
    [anon_sym_DASH] = ACTIONS(886),
    [anon_sym_SLASH] = ACTIONS(888),
    [anon_sym_PERCENT] = ACTIONS(886),
    [anon_sym_SLASH_SLASH] = ACTIONS(886),
    [anon_sym_STAR_STAR] = ACTIONS(886),
    [anon_sym_PIPE] = ACTIONS(886),
    [anon_sym_AMP] = ACTIONS(886),
    [anon_sym_CARET] = ACTIONS(886),
    [anon_sym_LT_LT] = ACTIONS(886),
    [anon_sym_LT] = ACTIONS(888),
    [anon_sym_LT_EQ] = ACTIONS(886),
    [anon_sym_EQ_EQ] = ACTIONS(886),
    [anon_sym_BANG_EQ] = ACTIONS(886),
    [anon_sym_GT_EQ] = ACTIONS(886),
    [anon_sym_GT] = ACTIONS(888),
    [anon_sym_LT_GT] = ACTIONS(886),
    [anon_sym_is] = ACTIONS(886),
    [anon_sym_LBRACK] = ACTIONS(886),
    [sym_string] = ACTIONS(2911),
    [sym_comment] = ACTIONS(72),
  },
  [972] = {
    [sym__expression] = STATE(1346),
    [sym__primary_expression] = STATE(513),
    [sym_not_operator] = STATE(1346),
    [sym_boolean_operator] = STATE(1346),
    [sym_binary_operator] = STATE(513),
    [sym_unary_operator] = STATE(513),
    [sym_comparison_operator] = STATE(1346),
    [sym_lambda] = STATE(1346),
    [sym_attribute] = STATE(513),
    [sym_subscript] = STATE(513),
    [sym_call] = STATE(513),
    [sym_list] = STATE(513),
    [sym_list_comprehension] = STATE(513),
    [sym_dictionary] = STATE(513),
    [sym_dictionary_comprehension] = STATE(513),
    [sym_set] = STATE(513),
    [sym_set_comprehension] = STATE(513),
    [sym_parenthesized_expression] = STATE(513),
    [sym_tuple] = STATE(513),
    [sym_generator_expression] = STATE(513),
    [sym_conditional_expression] = STATE(1346),
    [sym_concatenated_string] = STATE(513),
    [sym_await] = STATE(1346),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_not] = ACTIONS(914),
    [anon_sym_PLUS] = ACTIONS(916),
    [anon_sym_DASH] = ACTIONS(916),
    [anon_sym_TILDE] = ACTIONS(916),
    [anon_sym_lambda] = ACTIONS(918),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(920),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(922),
    [sym_integer] = ACTIONS(924),
    [sym_float] = ACTIONS(924),
    [sym_identifier] = ACTIONS(924),
    [sym_true] = ACTIONS(924),
    [sym_false] = ACTIONS(924),
    [sym_none] = ACTIONS(924),
    [anon_sym_await] = ACTIONS(926),
    [sym_comment] = ACTIONS(72),
  },
  [973] = {
    [sym__expression] = STATE(1347),
    [sym__primary_expression] = STATE(34),
    [sym_not_operator] = STATE(1347),
    [sym_boolean_operator] = STATE(1347),
    [sym_binary_operator] = STATE(34),
    [sym_unary_operator] = STATE(34),
    [sym_comparison_operator] = STATE(1347),
    [sym_lambda] = STATE(1347),
    [sym_attribute] = STATE(34),
    [sym_subscript] = STATE(34),
    [sym_call] = STATE(34),
    [sym_list] = STATE(34),
    [sym_list_comprehension] = STATE(34),
    [sym_dictionary] = STATE(34),
    [sym_dictionary_comprehension] = STATE(34),
    [sym_set] = STATE(34),
    [sym_set_comprehension] = STATE(34),
    [sym_parenthesized_expression] = STATE(34),
    [sym_tuple] = STATE(34),
    [sym_generator_expression] = STATE(34),
    [sym_conditional_expression] = STATE(1347),
    [sym_concatenated_string] = STATE(34),
    [sym_await] = STATE(1347),
    [anon_sym_LPAREN] = ACTIONS(14),
    [anon_sym_print] = ACTIONS(216),
    [anon_sym_exec] = ACTIONS(216),
    [anon_sym_not] = ACTIONS(52),
    [anon_sym_PLUS] = ACTIONS(54),
    [anon_sym_DASH] = ACTIONS(54),
    [anon_sym_TILDE] = ACTIONS(54),
    [anon_sym_lambda] = ACTIONS(56),
    [anon_sym_LBRACK] = ACTIONS(60),
    [sym_ellipsis] = ACTIONS(62),
    [anon_sym_LBRACE] = ACTIONS(64),
    [sym_string] = ACTIONS(66),
    [sym_integer] = ACTIONS(68),
    [sym_float] = ACTIONS(68),
    [sym_identifier] = ACTIONS(68),
    [sym_true] = ACTIONS(68),
    [sym_false] = ACTIONS(68),
    [sym_none] = ACTIONS(68),
    [anon_sym_await] = ACTIONS(70),
    [sym_comment] = ACTIONS(72),
  },
  [974] = {
    [sym__expression] = STATE(604),
    [sym__primary_expression] = STATE(513),
    [sym_not_operator] = STATE(604),
    [sym_boolean_operator] = STATE(604),
    [sym_binary_operator] = STATE(513),
    [sym_unary_operator] = STATE(513),
    [sym_comparison_operator] = STATE(604),
    [sym_lambda] = STATE(604),
    [sym_attribute] = STATE(513),
    [sym_subscript] = STATE(513),
    [sym_call] = STATE(513),
    [sym_list] = STATE(513),
    [sym_list_comprehension] = STATE(513),
    [sym_dictionary] = STATE(513),
    [sym_dictionary_comprehension] = STATE(513),
    [sym_set] = STATE(513),
    [sym_set_comprehension] = STATE(513),
    [sym_parenthesized_expression] = STATE(513),
    [sym_tuple] = STATE(513),
    [sym_generator_expression] = STATE(513),
    [sym_conditional_expression] = STATE(604),
    [sym_concatenated_string] = STATE(513),
    [sym_await] = STATE(604),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_not] = ACTIONS(914),
    [anon_sym_PLUS] = ACTIONS(916),
    [anon_sym_DASH] = ACTIONS(916),
    [anon_sym_TILDE] = ACTIONS(916),
    [anon_sym_lambda] = ACTIONS(918),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(920),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(922),
    [sym_integer] = ACTIONS(924),
    [sym_float] = ACTIONS(924),
    [sym_identifier] = ACTIONS(924),
    [sym_true] = ACTIONS(924),
    [sym_false] = ACTIONS(924),
    [sym_none] = ACTIONS(924),
    [anon_sym_await] = ACTIONS(926),
    [sym_comment] = ACTIONS(72),
  },
  [975] = {
    [sym__expression] = STATE(1348),
    [sym__primary_expression] = STATE(513),
    [sym_not_operator] = STATE(1348),
    [sym_boolean_operator] = STATE(1348),
    [sym_binary_operator] = STATE(513),
    [sym_unary_operator] = STATE(513),
    [sym_comparison_operator] = STATE(1348),
    [sym_lambda] = STATE(1348),
    [sym_attribute] = STATE(513),
    [sym_subscript] = STATE(513),
    [sym_call] = STATE(513),
    [sym_list] = STATE(513),
    [sym_list_comprehension] = STATE(513),
    [sym_dictionary] = STATE(513),
    [sym_dictionary_comprehension] = STATE(513),
    [sym_set] = STATE(513),
    [sym_set_comprehension] = STATE(513),
    [sym_parenthesized_expression] = STATE(513),
    [sym_tuple] = STATE(513),
    [sym_generator_expression] = STATE(513),
    [sym_conditional_expression] = STATE(1348),
    [sym_concatenated_string] = STATE(513),
    [sym_await] = STATE(1348),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_not] = ACTIONS(914),
    [anon_sym_PLUS] = ACTIONS(916),
    [anon_sym_DASH] = ACTIONS(916),
    [anon_sym_TILDE] = ACTIONS(916),
    [anon_sym_lambda] = ACTIONS(918),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(920),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(922),
    [sym_integer] = ACTIONS(924),
    [sym_float] = ACTIONS(924),
    [sym_identifier] = ACTIONS(924),
    [sym_true] = ACTIONS(924),
    [sym_false] = ACTIONS(924),
    [sym_none] = ACTIONS(924),
    [anon_sym_await] = ACTIONS(926),
    [sym_comment] = ACTIONS(72),
  },
  [976] = {
    [sym__primary_expression] = STATE(1349),
    [sym_binary_operator] = STATE(1349),
    [sym_unary_operator] = STATE(1349),
    [sym_attribute] = STATE(1349),
    [sym_subscript] = STATE(1349),
    [sym_call] = STATE(1349),
    [sym_list] = STATE(1349),
    [sym_list_comprehension] = STATE(1349),
    [sym_dictionary] = STATE(1349),
    [sym_dictionary_comprehension] = STATE(1349),
    [sym_set] = STATE(1349),
    [sym_set_comprehension] = STATE(1349),
    [sym_parenthesized_expression] = STATE(1349),
    [sym_tuple] = STATE(1349),
    [sym_generator_expression] = STATE(1349),
    [sym_concatenated_string] = STATE(1349),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_PLUS] = ACTIONS(916),
    [anon_sym_DASH] = ACTIONS(916),
    [anon_sym_TILDE] = ACTIONS(916),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(2913),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(922),
    [sym_integer] = ACTIONS(2915),
    [sym_float] = ACTIONS(2915),
    [sym_identifier] = ACTIONS(2915),
    [sym_true] = ACTIONS(2915),
    [sym_false] = ACTIONS(2915),
    [sym_none] = ACTIONS(2915),
    [sym_comment] = ACTIONS(72),
  },
  [977] = {
    [sym__primary_expression] = STATE(1350),
    [sym_binary_operator] = STATE(1350),
    [sym_unary_operator] = STATE(1350),
    [sym_attribute] = STATE(1350),
    [sym_subscript] = STATE(1350),
    [sym_call] = STATE(1350),
    [sym_list] = STATE(1350),
    [sym_list_comprehension] = STATE(1350),
    [sym_dictionary] = STATE(1350),
    [sym_dictionary_comprehension] = STATE(1350),
    [sym_set] = STATE(1350),
    [sym_set_comprehension] = STATE(1350),
    [sym_parenthesized_expression] = STATE(1350),
    [sym_tuple] = STATE(1350),
    [sym_generator_expression] = STATE(1350),
    [sym_concatenated_string] = STATE(1350),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_PLUS] = ACTIONS(916),
    [anon_sym_DASH] = ACTIONS(916),
    [anon_sym_TILDE] = ACTIONS(916),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(2917),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(922),
    [sym_integer] = ACTIONS(2919),
    [sym_float] = ACTIONS(2919),
    [sym_identifier] = ACTIONS(2919),
    [sym_true] = ACTIONS(2919),
    [sym_false] = ACTIONS(2919),
    [sym_none] = ACTIONS(2919),
    [sym_comment] = ACTIONS(72),
  },
  [978] = {
    [sym__primary_expression] = STATE(1351),
    [sym_binary_operator] = STATE(1351),
    [sym_unary_operator] = STATE(1351),
    [sym_attribute] = STATE(1351),
    [sym_subscript] = STATE(1351),
    [sym_call] = STATE(1351),
    [sym_list] = STATE(1351),
    [sym_list_comprehension] = STATE(1351),
    [sym_dictionary] = STATE(1351),
    [sym_dictionary_comprehension] = STATE(1351),
    [sym_set] = STATE(1351),
    [sym_set_comprehension] = STATE(1351),
    [sym_parenthesized_expression] = STATE(1351),
    [sym_tuple] = STATE(1351),
    [sym_generator_expression] = STATE(1351),
    [sym_concatenated_string] = STATE(1351),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_PLUS] = ACTIONS(916),
    [anon_sym_DASH] = ACTIONS(916),
    [anon_sym_TILDE] = ACTIONS(916),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(2921),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(922),
    [sym_integer] = ACTIONS(2923),
    [sym_float] = ACTIONS(2923),
    [sym_identifier] = ACTIONS(2923),
    [sym_true] = ACTIONS(2923),
    [sym_false] = ACTIONS(2923),
    [sym_none] = ACTIONS(2923),
    [sym_comment] = ACTIONS(72),
  },
  [979] = {
    [anon_sym_in] = ACTIONS(2925),
    [sym_comment] = ACTIONS(72),
  },
  [980] = {
    [sym__primary_expression] = STATE(1353),
    [sym_binary_operator] = STATE(1353),
    [sym_unary_operator] = STATE(1353),
    [sym_attribute] = STATE(1353),
    [sym_subscript] = STATE(1353),
    [sym_call] = STATE(1353),
    [sym_list] = STATE(1353),
    [sym_list_comprehension] = STATE(1353),
    [sym_dictionary] = STATE(1353),
    [sym_dictionary_comprehension] = STATE(1353),
    [sym_set] = STATE(1353),
    [sym_set_comprehension] = STATE(1353),
    [sym_parenthesized_expression] = STATE(1353),
    [sym_tuple] = STATE(1353),
    [sym_generator_expression] = STATE(1353),
    [sym_concatenated_string] = STATE(1353),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_PLUS] = ACTIONS(916),
    [anon_sym_DASH] = ACTIONS(916),
    [anon_sym_TILDE] = ACTIONS(916),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(2927),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(922),
    [sym_integer] = ACTIONS(2929),
    [sym_float] = ACTIONS(2929),
    [sym_identifier] = ACTIONS(2929),
    [sym_true] = ACTIONS(2929),
    [sym_false] = ACTIONS(2929),
    [sym_none] = ACTIONS(2929),
    [sym_comment] = ACTIONS(72),
  },
  [981] = {
    [sym__primary_expression] = STATE(621),
    [sym_binary_operator] = STATE(621),
    [sym_unary_operator] = STATE(621),
    [sym_attribute] = STATE(621),
    [sym_subscript] = STATE(621),
    [sym_call] = STATE(621),
    [sym_list] = STATE(621),
    [sym_list_comprehension] = STATE(621),
    [sym_dictionary] = STATE(621),
    [sym_dictionary_comprehension] = STATE(621),
    [sym_set] = STATE(621),
    [sym_set_comprehension] = STATE(621),
    [sym_parenthesized_expression] = STATE(621),
    [sym_tuple] = STATE(621),
    [sym_generator_expression] = STATE(621),
    [sym_concatenated_string] = STATE(621),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_PLUS] = ACTIONS(916),
    [anon_sym_DASH] = ACTIONS(916),
    [anon_sym_TILDE] = ACTIONS(916),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(1233),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(922),
    [sym_integer] = ACTIONS(1235),
    [sym_float] = ACTIONS(1235),
    [sym_identifier] = ACTIONS(1235),
    [sym_true] = ACTIONS(1235),
    [sym_false] = ACTIONS(1235),
    [sym_none] = ACTIONS(1235),
    [sym_comment] = ACTIONS(72),
  },
  [982] = {
    [sym__primary_expression] = STATE(1354),
    [sym_binary_operator] = STATE(1354),
    [sym_unary_operator] = STATE(1354),
    [sym_attribute] = STATE(1354),
    [sym_subscript] = STATE(1354),
    [sym_call] = STATE(1354),
    [sym_list] = STATE(1354),
    [sym_list_comprehension] = STATE(1354),
    [sym_dictionary] = STATE(1354),
    [sym_dictionary_comprehension] = STATE(1354),
    [sym_set] = STATE(1354),
    [sym_set_comprehension] = STATE(1354),
    [sym_parenthesized_expression] = STATE(1354),
    [sym_tuple] = STATE(1354),
    [sym_generator_expression] = STATE(1354),
    [sym_concatenated_string] = STATE(1354),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_PLUS] = ACTIONS(916),
    [anon_sym_DASH] = ACTIONS(916),
    [anon_sym_TILDE] = ACTIONS(916),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(2931),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(922),
    [sym_integer] = ACTIONS(2933),
    [sym_float] = ACTIONS(2933),
    [sym_identifier] = ACTIONS(2933),
    [sym_true] = ACTIONS(2933),
    [sym_false] = ACTIONS(2933),
    [sym_none] = ACTIONS(2933),
    [sym_comment] = ACTIONS(72),
  },
  [983] = {
    [sym__primary_expression] = STATE(1355),
    [sym_binary_operator] = STATE(1355),
    [sym_unary_operator] = STATE(1355),
    [sym_attribute] = STATE(1355),
    [sym_subscript] = STATE(1355),
    [sym_call] = STATE(1355),
    [sym_list] = STATE(1355),
    [sym_list_comprehension] = STATE(1355),
    [sym_dictionary] = STATE(1355),
    [sym_dictionary_comprehension] = STATE(1355),
    [sym_set] = STATE(1355),
    [sym_set_comprehension] = STATE(1355),
    [sym_parenthesized_expression] = STATE(1355),
    [sym_tuple] = STATE(1355),
    [sym_generator_expression] = STATE(1355),
    [sym_concatenated_string] = STATE(1355),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_PLUS] = ACTIONS(916),
    [anon_sym_DASH] = ACTIONS(916),
    [anon_sym_TILDE] = ACTIONS(916),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(2935),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(922),
    [sym_integer] = ACTIONS(2937),
    [sym_float] = ACTIONS(2937),
    [sym_identifier] = ACTIONS(2937),
    [sym_true] = ACTIONS(2937),
    [sym_false] = ACTIONS(2937),
    [sym_none] = ACTIONS(2937),
    [sym_comment] = ACTIONS(72),
  },
  [984] = {
    [sym__primary_expression] = STATE(1356),
    [sym_binary_operator] = STATE(1356),
    [sym_unary_operator] = STATE(1356),
    [sym_attribute] = STATE(1356),
    [sym_subscript] = STATE(1356),
    [sym_call] = STATE(1356),
    [sym_list] = STATE(1356),
    [sym_list_comprehension] = STATE(1356),
    [sym_dictionary] = STATE(1356),
    [sym_dictionary_comprehension] = STATE(1356),
    [sym_set] = STATE(1356),
    [sym_set_comprehension] = STATE(1356),
    [sym_parenthesized_expression] = STATE(1356),
    [sym_tuple] = STATE(1356),
    [sym_generator_expression] = STATE(1356),
    [sym_concatenated_string] = STATE(1356),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_PLUS] = ACTIONS(916),
    [anon_sym_DASH] = ACTIONS(916),
    [anon_sym_TILDE] = ACTIONS(916),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(2939),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(922),
    [sym_integer] = ACTIONS(2941),
    [sym_float] = ACTIONS(2941),
    [sym_identifier] = ACTIONS(2941),
    [sym_true] = ACTIONS(2941),
    [sym_false] = ACTIONS(2941),
    [sym_none] = ACTIONS(2941),
    [sym_comment] = ACTIONS(72),
  },
  [985] = {
    [sym__primary_expression] = STATE(1351),
    [sym_binary_operator] = STATE(1351),
    [sym_unary_operator] = STATE(1351),
    [sym_attribute] = STATE(1351),
    [sym_subscript] = STATE(1351),
    [sym_call] = STATE(1351),
    [sym_list] = STATE(1351),
    [sym_list_comprehension] = STATE(1351),
    [sym_dictionary] = STATE(1351),
    [sym_dictionary_comprehension] = STATE(1351),
    [sym_set] = STATE(1351),
    [sym_set_comprehension] = STATE(1351),
    [sym_parenthesized_expression] = STATE(1351),
    [sym_tuple] = STATE(1351),
    [sym_generator_expression] = STATE(1351),
    [sym_concatenated_string] = STATE(1351),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_not] = ACTIONS(2943),
    [anon_sym_PLUS] = ACTIONS(916),
    [anon_sym_DASH] = ACTIONS(916),
    [anon_sym_TILDE] = ACTIONS(916),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(2921),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(922),
    [sym_integer] = ACTIONS(2923),
    [sym_float] = ACTIONS(2923),
    [sym_identifier] = ACTIONS(2923),
    [sym_true] = ACTIONS(2923),
    [sym_false] = ACTIONS(2923),
    [sym_none] = ACTIONS(2923),
    [sym_comment] = ACTIONS(72),
  },
  [986] = {
    [aux_sym_comparison_operator_repeat1] = STATE(1357),
    [anon_sym_if] = ACTIONS(998),
    [anon_sym_else] = ACTIONS(998),
    [anon_sym_in] = ACTIONS(1933),
    [anon_sym_not] = ACTIONS(1937),
    [anon_sym_and] = ACTIONS(998),
    [anon_sym_or] = ACTIONS(998),
    [anon_sym_LT] = ACTIONS(1949),
    [anon_sym_LT_EQ] = ACTIONS(1933),
    [anon_sym_EQ_EQ] = ACTIONS(1933),
    [anon_sym_BANG_EQ] = ACTIONS(1933),
    [anon_sym_GT_EQ] = ACTIONS(1933),
    [anon_sym_GT] = ACTIONS(1949),
    [anon_sym_LT_GT] = ACTIONS(1933),
    [anon_sym_is] = ACTIONS(1951),
    [sym_comment] = ACTIONS(72),
  },
  [987] = {
    [sym__expression] = STATE(506),
    [sym__primary_expression] = STATE(34),
    [sym_not_operator] = STATE(506),
    [sym_boolean_operator] = STATE(506),
    [sym_binary_operator] = STATE(34),
    [sym_unary_operator] = STATE(34),
    [sym_comparison_operator] = STATE(506),
    [sym_lambda] = STATE(506),
    [sym_attribute] = STATE(34),
    [sym_subscript] = STATE(34),
    [sym_call] = STATE(34),
    [sym_list] = STATE(34),
    [sym_list_comprehension] = STATE(34),
    [sym_dictionary] = STATE(34),
    [sym_dictionary_comprehension] = STATE(34),
    [sym_set] = STATE(34),
    [sym_set_comprehension] = STATE(34),
    [sym_parenthesized_expression] = STATE(34),
    [sym_tuple] = STATE(34),
    [sym_generator_expression] = STATE(34),
    [sym_conditional_expression] = STATE(506),
    [sym_concatenated_string] = STATE(34),
    [sym_await] = STATE(506),
    [anon_sym_LPAREN] = ACTIONS(14),
    [anon_sym_print] = ACTIONS(216),
    [anon_sym_exec] = ACTIONS(216),
    [anon_sym_not] = ACTIONS(52),
    [anon_sym_PLUS] = ACTIONS(54),
    [anon_sym_DASH] = ACTIONS(54),
    [anon_sym_TILDE] = ACTIONS(54),
    [anon_sym_lambda] = ACTIONS(56),
    [anon_sym_LBRACK] = ACTIONS(60),
    [sym_ellipsis] = ACTIONS(62),
    [anon_sym_LBRACE] = ACTIONS(64),
    [sym_string] = ACTIONS(66),
    [sym_integer] = ACTIONS(68),
    [sym_float] = ACTIONS(68),
    [sym_identifier] = ACTIONS(68),
    [sym_true] = ACTIONS(68),
    [sym_false] = ACTIONS(68),
    [sym_none] = ACTIONS(68),
    [anon_sym_await] = ACTIONS(70),
    [sym_comment] = ACTIONS(72),
  },
  [988] = {
    [sym__newline] = ACTIONS(2945),
    [anon_sym_DOT] = ACTIONS(2945),
    [anon_sym_LPAREN] = ACTIONS(2945),
    [anon_sym_COMMA] = ACTIONS(2945),
    [anon_sym_STAR] = ACTIONS(2947),
    [anon_sym_GT_GT] = ACTIONS(2947),
    [anon_sym_if] = ACTIONS(2945),
    [anon_sym_COLON] = ACTIONS(2945),
    [anon_sym_in] = ACTIONS(2945),
    [anon_sym_EQ] = ACTIONS(2947),
    [anon_sym_AT] = ACTIONS(2947),
    [anon_sym_not] = ACTIONS(2945),
    [anon_sym_and] = ACTIONS(2945),
    [anon_sym_or] = ACTIONS(2945),
    [anon_sym_PLUS] = ACTIONS(2947),
    [anon_sym_DASH] = ACTIONS(2947),
    [anon_sym_SLASH] = ACTIONS(2947),
    [anon_sym_PERCENT] = ACTIONS(2947),
    [anon_sym_SLASH_SLASH] = ACTIONS(2947),
    [anon_sym_STAR_STAR] = ACTIONS(2947),
    [anon_sym_PIPE] = ACTIONS(2947),
    [anon_sym_AMP] = ACTIONS(2947),
    [anon_sym_CARET] = ACTIONS(2947),
    [anon_sym_LT_LT] = ACTIONS(2947),
    [anon_sym_LT] = ACTIONS(2947),
    [anon_sym_LT_EQ] = ACTIONS(2945),
    [anon_sym_EQ_EQ] = ACTIONS(2945),
    [anon_sym_BANG_EQ] = ACTIONS(2945),
    [anon_sym_GT_EQ] = ACTIONS(2945),
    [anon_sym_GT] = ACTIONS(2947),
    [anon_sym_LT_GT] = ACTIONS(2945),
    [anon_sym_is] = ACTIONS(2945),
    [anon_sym_PLUS_EQ] = ACTIONS(2945),
    [anon_sym_DASH_EQ] = ACTIONS(2945),
    [anon_sym_STAR_EQ] = ACTIONS(2945),
    [anon_sym_SLASH_EQ] = ACTIONS(2945),
    [anon_sym_AT_EQ] = ACTIONS(2945),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(2945),
    [anon_sym_PERCENT_EQ] = ACTIONS(2945),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2945),
    [anon_sym_GT_GT_EQ] = ACTIONS(2945),
    [anon_sym_LT_LT_EQ] = ACTIONS(2945),
    [anon_sym_AMP_EQ] = ACTIONS(2945),
    [anon_sym_CARET_EQ] = ACTIONS(2945),
    [anon_sym_PIPE_EQ] = ACTIONS(2945),
    [anon_sym_LBRACK] = ACTIONS(2945),
    [sym_comment] = ACTIONS(72),
    [sym__semicolon] = ACTIONS(2945),
  },
  [989] = {
    [sym__expression] = STATE(1358),
    [sym__primary_expression] = STATE(215),
    [sym_not_operator] = STATE(1358),
    [sym_boolean_operator] = STATE(1358),
    [sym_binary_operator] = STATE(215),
    [sym_unary_operator] = STATE(215),
    [sym_comparison_operator] = STATE(1358),
    [sym_lambda] = STATE(1358),
    [sym_attribute] = STATE(215),
    [sym_subscript] = STATE(215),
    [sym_call] = STATE(215),
    [sym_list] = STATE(215),
    [sym_list_comprehension] = STATE(215),
    [sym_dictionary] = STATE(215),
    [sym_dictionary_comprehension] = STATE(215),
    [sym_set] = STATE(215),
    [sym_set_comprehension] = STATE(215),
    [sym_parenthesized_expression] = STATE(215),
    [sym_tuple] = STATE(215),
    [sym_generator_expression] = STATE(215),
    [sym_conditional_expression] = STATE(1358),
    [sym_concatenated_string] = STATE(215),
    [sym_await] = STATE(1358),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_not] = ACTIONS(384),
    [anon_sym_PLUS] = ACTIONS(386),
    [anon_sym_DASH] = ACTIONS(386),
    [anon_sym_TILDE] = ACTIONS(386),
    [anon_sym_lambda] = ACTIONS(388),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(390),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(392),
    [sym_integer] = ACTIONS(394),
    [sym_float] = ACTIONS(394),
    [sym_identifier] = ACTIONS(394),
    [sym_true] = ACTIONS(394),
    [sym_false] = ACTIONS(394),
    [sym_none] = ACTIONS(394),
    [anon_sym_await] = ACTIONS(396),
    [sym_comment] = ACTIONS(72),
  },
  [990] = {
    [anon_sym_RPAREN] = ACTIONS(1590),
    [anon_sym_COMMA] = ACTIONS(1590),
    [anon_sym_if] = ACTIONS(1147),
    [anon_sym_and] = ACTIONS(1149),
    [anon_sym_or] = ACTIONS(1151),
    [sym_comment] = ACTIONS(72),
  },
  [991] = {
    [sym__expression] = STATE(1359),
    [sym__primary_expression] = STATE(215),
    [sym_not_operator] = STATE(1359),
    [sym_boolean_operator] = STATE(1359),
    [sym_binary_operator] = STATE(215),
    [sym_unary_operator] = STATE(215),
    [sym_comparison_operator] = STATE(1359),
    [sym_lambda] = STATE(1359),
    [sym_attribute] = STATE(215),
    [sym_subscript] = STATE(215),
    [sym_call] = STATE(215),
    [sym_list] = STATE(215),
    [sym_list_comprehension] = STATE(215),
    [sym_dictionary] = STATE(215),
    [sym_dictionary_comprehension] = STATE(215),
    [sym_set] = STATE(215),
    [sym_set_comprehension] = STATE(215),
    [sym_parenthesized_expression] = STATE(215),
    [sym_tuple] = STATE(215),
    [sym_generator_expression] = STATE(215),
    [sym_conditional_expression] = STATE(1359),
    [sym_concatenated_string] = STATE(215),
    [sym_await] = STATE(1359),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_not] = ACTIONS(384),
    [anon_sym_PLUS] = ACTIONS(386),
    [anon_sym_DASH] = ACTIONS(386),
    [anon_sym_TILDE] = ACTIONS(386),
    [anon_sym_lambda] = ACTIONS(388),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(390),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(392),
    [sym_integer] = ACTIONS(394),
    [sym_float] = ACTIONS(394),
    [sym_identifier] = ACTIONS(394),
    [sym_true] = ACTIONS(394),
    [sym_false] = ACTIONS(394),
    [sym_none] = ACTIONS(394),
    [anon_sym_await] = ACTIONS(396),
    [sym_comment] = ACTIONS(72),
  },
  [992] = {
    [sym__expression] = STATE(1360),
    [sym__primary_expression] = STATE(215),
    [sym_not_operator] = STATE(1360),
    [sym_boolean_operator] = STATE(1360),
    [sym_binary_operator] = STATE(215),
    [sym_unary_operator] = STATE(215),
    [sym_comparison_operator] = STATE(1360),
    [sym_lambda] = STATE(1360),
    [sym_attribute] = STATE(215),
    [sym_subscript] = STATE(215),
    [sym_call] = STATE(215),
    [sym_list] = STATE(215),
    [sym_list_comprehension] = STATE(215),
    [sym_dictionary] = STATE(215),
    [sym_dictionary_comprehension] = STATE(215),
    [sym_set] = STATE(215),
    [sym_set_comprehension] = STATE(215),
    [sym_parenthesized_expression] = STATE(215),
    [sym_tuple] = STATE(215),
    [sym_generator_expression] = STATE(215),
    [sym_conditional_expression] = STATE(1360),
    [sym_concatenated_string] = STATE(215),
    [sym_await] = STATE(1360),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_not] = ACTIONS(384),
    [anon_sym_PLUS] = ACTIONS(386),
    [anon_sym_DASH] = ACTIONS(386),
    [anon_sym_TILDE] = ACTIONS(386),
    [anon_sym_lambda] = ACTIONS(388),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(390),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(392),
    [sym_integer] = ACTIONS(394),
    [sym_float] = ACTIONS(394),
    [sym_identifier] = ACTIONS(394),
    [sym_true] = ACTIONS(394),
    [sym_false] = ACTIONS(394),
    [sym_none] = ACTIONS(394),
    [anon_sym_await] = ACTIONS(396),
    [sym_comment] = ACTIONS(72),
  },
  [993] = {
    [sym_list_splat] = STATE(1362),
    [sym_dictionary_splat] = STATE(1362),
    [sym__expression] = STATE(1363),
    [sym__primary_expression] = STATE(215),
    [sym_not_operator] = STATE(1363),
    [sym_boolean_operator] = STATE(1363),
    [sym_binary_operator] = STATE(215),
    [sym_unary_operator] = STATE(215),
    [sym_comparison_operator] = STATE(1363),
    [sym_lambda] = STATE(1363),
    [sym_attribute] = STATE(215),
    [sym_subscript] = STATE(215),
    [sym_call] = STATE(215),
    [sym_keyword_argument] = STATE(1362),
    [sym_list] = STATE(215),
    [sym_list_comprehension] = STATE(215),
    [sym_dictionary] = STATE(215),
    [sym_dictionary_comprehension] = STATE(215),
    [sym_set] = STATE(215),
    [sym_set_comprehension] = STATE(215),
    [sym_parenthesized_expression] = STATE(215),
    [sym_tuple] = STATE(215),
    [sym_generator_expression] = STATE(215),
    [sym_conditional_expression] = STATE(1363),
    [sym_concatenated_string] = STATE(215),
    [sym_await] = STATE(1363),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_RPAREN] = ACTIONS(2949),
    [anon_sym_STAR] = ACTIONS(936),
    [anon_sym_print] = ACTIONS(938),
    [anon_sym_exec] = ACTIONS(938),
    [anon_sym_not] = ACTIONS(384),
    [anon_sym_PLUS] = ACTIONS(386),
    [anon_sym_DASH] = ACTIONS(386),
    [anon_sym_TILDE] = ACTIONS(386),
    [anon_sym_lambda] = ACTIONS(388),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(390),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(392),
    [sym_integer] = ACTIONS(394),
    [sym_float] = ACTIONS(394),
    [sym_identifier] = ACTIONS(940),
    [sym_true] = ACTIONS(394),
    [sym_false] = ACTIONS(394),
    [sym_none] = ACTIONS(394),
    [anon_sym_await] = ACTIONS(396),
    [sym_comment] = ACTIONS(72),
  },
  [994] = {
    [aux_sym_argument_list_repeat1] = STATE(1365),
    [anon_sym_RPAREN] = ACTIONS(2949),
    [anon_sym_COMMA] = ACTIONS(2951),
    [sym_comment] = ACTIONS(72),
  },
  [995] = {
    [sym_argument_list] = STATE(182),
    [sym_generator_expression] = STATE(182),
    [sym__newline] = ACTIONS(2953),
    [anon_sym_DOT] = ACTIONS(304),
    [anon_sym_LPAREN] = ACTIONS(306),
    [anon_sym_COMMA] = ACTIONS(2953),
    [anon_sym_STAR] = ACTIONS(308),
    [anon_sym_GT_GT] = ACTIONS(310),
    [anon_sym_if] = ACTIONS(2953),
    [anon_sym_COLON] = ACTIONS(2953),
    [anon_sym_in] = ACTIONS(2953),
    [anon_sym_EQ] = ACTIONS(2955),
    [anon_sym_AT] = ACTIONS(308),
    [anon_sym_not] = ACTIONS(2953),
    [anon_sym_and] = ACTIONS(2953),
    [anon_sym_or] = ACTIONS(2953),
    [anon_sym_PLUS] = ACTIONS(318),
    [anon_sym_DASH] = ACTIONS(318),
    [anon_sym_SLASH] = ACTIONS(308),
    [anon_sym_PERCENT] = ACTIONS(308),
    [anon_sym_SLASH_SLASH] = ACTIONS(308),
    [anon_sym_STAR_STAR] = ACTIONS(320),
    [anon_sym_PIPE] = ACTIONS(322),
    [anon_sym_AMP] = ACTIONS(324),
    [anon_sym_CARET] = ACTIONS(326),
    [anon_sym_LT_LT] = ACTIONS(310),
    [anon_sym_LT] = ACTIONS(2955),
    [anon_sym_LT_EQ] = ACTIONS(2953),
    [anon_sym_EQ_EQ] = ACTIONS(2953),
    [anon_sym_BANG_EQ] = ACTIONS(2953),
    [anon_sym_GT_EQ] = ACTIONS(2953),
    [anon_sym_GT] = ACTIONS(2955),
    [anon_sym_LT_GT] = ACTIONS(2953),
    [anon_sym_is] = ACTIONS(2953),
    [anon_sym_PLUS_EQ] = ACTIONS(2953),
    [anon_sym_DASH_EQ] = ACTIONS(2953),
    [anon_sym_STAR_EQ] = ACTIONS(2953),
    [anon_sym_SLASH_EQ] = ACTIONS(2953),
    [anon_sym_AT_EQ] = ACTIONS(2953),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(2953),
    [anon_sym_PERCENT_EQ] = ACTIONS(2953),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2953),
    [anon_sym_GT_GT_EQ] = ACTIONS(2953),
    [anon_sym_LT_LT_EQ] = ACTIONS(2953),
    [anon_sym_AMP_EQ] = ACTIONS(2953),
    [anon_sym_CARET_EQ] = ACTIONS(2953),
    [anon_sym_PIPE_EQ] = ACTIONS(2953),
    [anon_sym_LBRACK] = ACTIONS(332),
    [sym_comment] = ACTIONS(72),
    [sym__semicolon] = ACTIONS(2953),
  },
  [996] = {
    [sym__expression] = STATE(1366),
    [sym__primary_expression] = STATE(430),
    [sym_not_operator] = STATE(1366),
    [sym_boolean_operator] = STATE(1366),
    [sym_binary_operator] = STATE(430),
    [sym_unary_operator] = STATE(430),
    [sym_comparison_operator] = STATE(1366),
    [sym_lambda] = STATE(1366),
    [sym_attribute] = STATE(430),
    [sym_subscript] = STATE(430),
    [sym_call] = STATE(430),
    [sym_list] = STATE(430),
    [sym_list_comprehension] = STATE(430),
    [sym_dictionary] = STATE(430),
    [sym_dictionary_comprehension] = STATE(430),
    [sym_set] = STATE(430),
    [sym_set_comprehension] = STATE(430),
    [sym_parenthesized_expression] = STATE(430),
    [sym_tuple] = STATE(430),
    [sym_generator_expression] = STATE(430),
    [sym_conditional_expression] = STATE(1366),
    [sym_concatenated_string] = STATE(430),
    [sym_await] = STATE(1366),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_COMMA] = ACTIONS(2957),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_not] = ACTIONS(760),
    [anon_sym_PLUS] = ACTIONS(762),
    [anon_sym_DASH] = ACTIONS(762),
    [anon_sym_TILDE] = ACTIONS(762),
    [anon_sym_lambda] = ACTIONS(764),
    [anon_sym_LBRACK] = ACTIONS(96),
    [anon_sym_RBRACK] = ACTIONS(2957),
    [sym_ellipsis] = ACTIONS(766),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(768),
    [sym_integer] = ACTIONS(770),
    [sym_float] = ACTIONS(770),
    [sym_identifier] = ACTIONS(770),
    [sym_true] = ACTIONS(770),
    [sym_false] = ACTIONS(770),
    [sym_none] = ACTIONS(770),
    [anon_sym_await] = ACTIONS(772),
    [sym_comment] = ACTIONS(72),
  },
  [997] = {
    [anon_sym_COMMA] = ACTIONS(2957),
    [anon_sym_if] = ACTIONS(2002),
    [anon_sym_COLON] = ACTIONS(2959),
    [anon_sym_and] = ACTIONS(2006),
    [anon_sym_or] = ACTIONS(2008),
    [anon_sym_RBRACK] = ACTIONS(2957),
    [sym_comment] = ACTIONS(72),
  },
  [998] = {
    [anon_sym_COMMA] = ACTIONS(716),
    [anon_sym_if] = ACTIONS(716),
    [anon_sym_COLON] = ACTIONS(716),
    [anon_sym_and] = ACTIONS(2006),
    [anon_sym_or] = ACTIONS(2008),
    [anon_sym_RBRACK] = ACTIONS(716),
    [sym_comment] = ACTIONS(72),
  },
  [999] = {
    [sym__expression] = STATE(1368),
    [sym__primary_expression] = STATE(542),
    [sym_not_operator] = STATE(1368),
    [sym_boolean_operator] = STATE(1368),
    [sym_binary_operator] = STATE(542),
    [sym_unary_operator] = STATE(542),
    [sym_comparison_operator] = STATE(1368),
    [sym_lambda] = STATE(1368),
    [sym_attribute] = STATE(542),
    [sym_subscript] = STATE(542),
    [sym_call] = STATE(542),
    [sym_list] = STATE(542),
    [sym_list_comprehension] = STATE(542),
    [sym_dictionary] = STATE(542),
    [sym_dictionary_comprehension] = STATE(542),
    [sym_set] = STATE(542),
    [sym_set_comprehension] = STATE(542),
    [sym_parenthesized_expression] = STATE(542),
    [sym_tuple] = STATE(542),
    [sym_generator_expression] = STATE(542),
    [sym_conditional_expression] = STATE(1368),
    [sym_concatenated_string] = STATE(542),
    [sym_await] = STATE(1368),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_not] = ACTIONS(980),
    [anon_sym_PLUS] = ACTIONS(982),
    [anon_sym_DASH] = ACTIONS(982),
    [anon_sym_TILDE] = ACTIONS(982),
    [anon_sym_lambda] = ACTIONS(984),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(986),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(988),
    [sym_integer] = ACTIONS(990),
    [sym_float] = ACTIONS(990),
    [sym_identifier] = ACTIONS(990),
    [sym_true] = ACTIONS(990),
    [sym_false] = ACTIONS(990),
    [sym_none] = ACTIONS(990),
    [anon_sym_await] = ACTIONS(992),
    [sym_comment] = ACTIONS(72),
  },
  [1000] = {
    [anon_sym_COLON] = ACTIONS(2961),
    [sym_comment] = ACTIONS(72),
  },
  [1001] = {
    [aux_sym_concatenated_string_repeat1] = STATE(1370),
    [anon_sym_DOT] = ACTIONS(886),
    [anon_sym_LPAREN] = ACTIONS(886),
    [anon_sym_COMMA] = ACTIONS(886),
    [anon_sym_STAR] = ACTIONS(888),
    [anon_sym_GT_GT] = ACTIONS(886),
    [anon_sym_if] = ACTIONS(886),
    [anon_sym_COLON] = ACTIONS(886),
    [anon_sym_in] = ACTIONS(886),
    [anon_sym_AT] = ACTIONS(886),
    [anon_sym_not] = ACTIONS(886),
    [anon_sym_and] = ACTIONS(886),
    [anon_sym_or] = ACTIONS(886),
    [anon_sym_PLUS] = ACTIONS(886),
    [anon_sym_DASH] = ACTIONS(886),
    [anon_sym_SLASH] = ACTIONS(888),
    [anon_sym_PERCENT] = ACTIONS(886),
    [anon_sym_SLASH_SLASH] = ACTIONS(886),
    [anon_sym_STAR_STAR] = ACTIONS(886),
    [anon_sym_PIPE] = ACTIONS(886),
    [anon_sym_AMP] = ACTIONS(886),
    [anon_sym_CARET] = ACTIONS(886),
    [anon_sym_LT_LT] = ACTIONS(886),
    [anon_sym_LT] = ACTIONS(888),
    [anon_sym_LT_EQ] = ACTIONS(886),
    [anon_sym_EQ_EQ] = ACTIONS(886),
    [anon_sym_BANG_EQ] = ACTIONS(886),
    [anon_sym_GT_EQ] = ACTIONS(886),
    [anon_sym_GT] = ACTIONS(888),
    [anon_sym_LT_GT] = ACTIONS(886),
    [anon_sym_is] = ACTIONS(886),
    [anon_sym_LBRACK] = ACTIONS(886),
    [anon_sym_RBRACK] = ACTIONS(886),
    [sym_string] = ACTIONS(2963),
    [sym_comment] = ACTIONS(72),
  },
  [1002] = {
    [sym__expression] = STATE(1372),
    [sym__primary_expression] = STATE(542),
    [sym_not_operator] = STATE(1372),
    [sym_boolean_operator] = STATE(1372),
    [sym_binary_operator] = STATE(542),
    [sym_unary_operator] = STATE(542),
    [sym_comparison_operator] = STATE(1372),
    [sym_lambda] = STATE(1372),
    [sym_attribute] = STATE(542),
    [sym_subscript] = STATE(542),
    [sym_slice] = STATE(1373),
    [sym_call] = STATE(542),
    [sym_list] = STATE(542),
    [sym_list_comprehension] = STATE(542),
    [sym_dictionary] = STATE(542),
    [sym_dictionary_comprehension] = STATE(542),
    [sym_set] = STATE(542),
    [sym_set_comprehension] = STATE(542),
    [sym_parenthesized_expression] = STATE(542),
    [sym_tuple] = STATE(542),
    [sym_generator_expression] = STATE(542),
    [sym_conditional_expression] = STATE(1372),
    [sym_concatenated_string] = STATE(542),
    [sym_await] = STATE(1372),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_COLON] = ACTIONS(978),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_not] = ACTIONS(980),
    [anon_sym_PLUS] = ACTIONS(982),
    [anon_sym_DASH] = ACTIONS(982),
    [anon_sym_TILDE] = ACTIONS(982),
    [anon_sym_lambda] = ACTIONS(984),
    [anon_sym_LBRACK] = ACTIONS(96),
    [anon_sym_RBRACK] = ACTIONS(2965),
    [sym_ellipsis] = ACTIONS(986),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(988),
    [sym_integer] = ACTIONS(990),
    [sym_float] = ACTIONS(990),
    [sym_identifier] = ACTIONS(990),
    [sym_true] = ACTIONS(990),
    [sym_false] = ACTIONS(990),
    [sym_none] = ACTIONS(990),
    [anon_sym_await] = ACTIONS(992),
    [sym_comment] = ACTIONS(72),
  },
  [1003] = {
    [sym__expression] = STATE(1374),
    [sym__primary_expression] = STATE(513),
    [sym_not_operator] = STATE(1374),
    [sym_boolean_operator] = STATE(1374),
    [sym_binary_operator] = STATE(513),
    [sym_unary_operator] = STATE(513),
    [sym_comparison_operator] = STATE(1374),
    [sym_lambda] = STATE(1374),
    [sym_attribute] = STATE(513),
    [sym_subscript] = STATE(513),
    [sym_call] = STATE(513),
    [sym_list] = STATE(513),
    [sym_list_comprehension] = STATE(513),
    [sym_dictionary] = STATE(513),
    [sym_dictionary_comprehension] = STATE(513),
    [sym_set] = STATE(513),
    [sym_set_comprehension] = STATE(513),
    [sym_parenthesized_expression] = STATE(513),
    [sym_tuple] = STATE(513),
    [sym_generator_expression] = STATE(513),
    [sym_conditional_expression] = STATE(1374),
    [sym_concatenated_string] = STATE(513),
    [sym_await] = STATE(1374),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_not] = ACTIONS(914),
    [anon_sym_PLUS] = ACTIONS(916),
    [anon_sym_DASH] = ACTIONS(916),
    [anon_sym_TILDE] = ACTIONS(916),
    [anon_sym_lambda] = ACTIONS(918),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(920),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(922),
    [sym_integer] = ACTIONS(924),
    [sym_float] = ACTIONS(924),
    [sym_identifier] = ACTIONS(924),
    [sym_true] = ACTIONS(924),
    [sym_false] = ACTIONS(924),
    [sym_none] = ACTIONS(924),
    [anon_sym_await] = ACTIONS(926),
    [sym_comment] = ACTIONS(72),
  },
  [1004] = {
    [sym__expression] = STATE(1375),
    [sym__primary_expression] = STATE(542),
    [sym_not_operator] = STATE(1375),
    [sym_boolean_operator] = STATE(1375),
    [sym_binary_operator] = STATE(542),
    [sym_unary_operator] = STATE(542),
    [sym_comparison_operator] = STATE(1375),
    [sym_lambda] = STATE(1375),
    [sym_attribute] = STATE(542),
    [sym_subscript] = STATE(542),
    [sym_call] = STATE(542),
    [sym_list] = STATE(542),
    [sym_list_comprehension] = STATE(542),
    [sym_dictionary] = STATE(542),
    [sym_dictionary_comprehension] = STATE(542),
    [sym_set] = STATE(542),
    [sym_set_comprehension] = STATE(542),
    [sym_parenthesized_expression] = STATE(542),
    [sym_tuple] = STATE(542),
    [sym_generator_expression] = STATE(542),
    [sym_conditional_expression] = STATE(1375),
    [sym_concatenated_string] = STATE(542),
    [sym_await] = STATE(1375),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_COMMA] = ACTIONS(2957),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_COLON] = ACTIONS(2959),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_not] = ACTIONS(980),
    [anon_sym_PLUS] = ACTIONS(982),
    [anon_sym_DASH] = ACTIONS(982),
    [anon_sym_TILDE] = ACTIONS(982),
    [anon_sym_lambda] = ACTIONS(984),
    [anon_sym_LBRACK] = ACTIONS(96),
    [anon_sym_RBRACK] = ACTIONS(2957),
    [sym_ellipsis] = ACTIONS(986),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(988),
    [sym_integer] = ACTIONS(990),
    [sym_float] = ACTIONS(990),
    [sym_identifier] = ACTIONS(990),
    [sym_true] = ACTIONS(990),
    [sym_false] = ACTIONS(990),
    [sym_none] = ACTIONS(990),
    [anon_sym_await] = ACTIONS(992),
    [sym_comment] = ACTIONS(72),
  },
  [1005] = {
    [sym__expression] = STATE(604),
    [sym__primary_expression] = STATE(542),
    [sym_not_operator] = STATE(604),
    [sym_boolean_operator] = STATE(604),
    [sym_binary_operator] = STATE(542),
    [sym_unary_operator] = STATE(542),
    [sym_comparison_operator] = STATE(604),
    [sym_lambda] = STATE(604),
    [sym_attribute] = STATE(542),
    [sym_subscript] = STATE(542),
    [sym_call] = STATE(542),
    [sym_list] = STATE(542),
    [sym_list_comprehension] = STATE(542),
    [sym_dictionary] = STATE(542),
    [sym_dictionary_comprehension] = STATE(542),
    [sym_set] = STATE(542),
    [sym_set_comprehension] = STATE(542),
    [sym_parenthesized_expression] = STATE(542),
    [sym_tuple] = STATE(542),
    [sym_generator_expression] = STATE(542),
    [sym_conditional_expression] = STATE(604),
    [sym_concatenated_string] = STATE(542),
    [sym_await] = STATE(604),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_not] = ACTIONS(980),
    [anon_sym_PLUS] = ACTIONS(982),
    [anon_sym_DASH] = ACTIONS(982),
    [anon_sym_TILDE] = ACTIONS(982),
    [anon_sym_lambda] = ACTIONS(984),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(986),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(988),
    [sym_integer] = ACTIONS(990),
    [sym_float] = ACTIONS(990),
    [sym_identifier] = ACTIONS(990),
    [sym_true] = ACTIONS(990),
    [sym_false] = ACTIONS(990),
    [sym_none] = ACTIONS(990),
    [anon_sym_await] = ACTIONS(992),
    [sym_comment] = ACTIONS(72),
  },
  [1006] = {
    [sym__expression] = STATE(1376),
    [sym__primary_expression] = STATE(542),
    [sym_not_operator] = STATE(1376),
    [sym_boolean_operator] = STATE(1376),
    [sym_binary_operator] = STATE(542),
    [sym_unary_operator] = STATE(542),
    [sym_comparison_operator] = STATE(1376),
    [sym_lambda] = STATE(1376),
    [sym_attribute] = STATE(542),
    [sym_subscript] = STATE(542),
    [sym_call] = STATE(542),
    [sym_list] = STATE(542),
    [sym_list_comprehension] = STATE(542),
    [sym_dictionary] = STATE(542),
    [sym_dictionary_comprehension] = STATE(542),
    [sym_set] = STATE(542),
    [sym_set_comprehension] = STATE(542),
    [sym_parenthesized_expression] = STATE(542),
    [sym_tuple] = STATE(542),
    [sym_generator_expression] = STATE(542),
    [sym_conditional_expression] = STATE(1376),
    [sym_concatenated_string] = STATE(542),
    [sym_await] = STATE(1376),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_not] = ACTIONS(980),
    [anon_sym_PLUS] = ACTIONS(982),
    [anon_sym_DASH] = ACTIONS(982),
    [anon_sym_TILDE] = ACTIONS(982),
    [anon_sym_lambda] = ACTIONS(984),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(986),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(988),
    [sym_integer] = ACTIONS(990),
    [sym_float] = ACTIONS(990),
    [sym_identifier] = ACTIONS(990),
    [sym_true] = ACTIONS(990),
    [sym_false] = ACTIONS(990),
    [sym_none] = ACTIONS(990),
    [anon_sym_await] = ACTIONS(992),
    [sym_comment] = ACTIONS(72),
  },
  [1007] = {
    [sym__newline] = ACTIONS(2967),
    [anon_sym_DOT] = ACTIONS(2967),
    [anon_sym_LPAREN] = ACTIONS(2967),
    [anon_sym_COMMA] = ACTIONS(2967),
    [anon_sym_STAR] = ACTIONS(2969),
    [anon_sym_GT_GT] = ACTIONS(2969),
    [anon_sym_if] = ACTIONS(2967),
    [anon_sym_COLON] = ACTIONS(2967),
    [anon_sym_in] = ACTIONS(2967),
    [anon_sym_EQ] = ACTIONS(2969),
    [anon_sym_AT] = ACTIONS(2969),
    [anon_sym_not] = ACTIONS(2967),
    [anon_sym_and] = ACTIONS(2967),
    [anon_sym_or] = ACTIONS(2967),
    [anon_sym_PLUS] = ACTIONS(2969),
    [anon_sym_DASH] = ACTIONS(2969),
    [anon_sym_SLASH] = ACTIONS(2969),
    [anon_sym_PERCENT] = ACTIONS(2969),
    [anon_sym_SLASH_SLASH] = ACTIONS(2969),
    [anon_sym_STAR_STAR] = ACTIONS(2969),
    [anon_sym_PIPE] = ACTIONS(2969),
    [anon_sym_AMP] = ACTIONS(2969),
    [anon_sym_CARET] = ACTIONS(2969),
    [anon_sym_LT_LT] = ACTIONS(2969),
    [anon_sym_LT] = ACTIONS(2969),
    [anon_sym_LT_EQ] = ACTIONS(2967),
    [anon_sym_EQ_EQ] = ACTIONS(2967),
    [anon_sym_BANG_EQ] = ACTIONS(2967),
    [anon_sym_GT_EQ] = ACTIONS(2967),
    [anon_sym_GT] = ACTIONS(2969),
    [anon_sym_LT_GT] = ACTIONS(2967),
    [anon_sym_is] = ACTIONS(2967),
    [anon_sym_PLUS_EQ] = ACTIONS(2967),
    [anon_sym_DASH_EQ] = ACTIONS(2967),
    [anon_sym_STAR_EQ] = ACTIONS(2967),
    [anon_sym_SLASH_EQ] = ACTIONS(2967),
    [anon_sym_AT_EQ] = ACTIONS(2967),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(2967),
    [anon_sym_PERCENT_EQ] = ACTIONS(2967),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2967),
    [anon_sym_GT_GT_EQ] = ACTIONS(2967),
    [anon_sym_LT_LT_EQ] = ACTIONS(2967),
    [anon_sym_AMP_EQ] = ACTIONS(2967),
    [anon_sym_CARET_EQ] = ACTIONS(2967),
    [anon_sym_PIPE_EQ] = ACTIONS(2967),
    [anon_sym_LBRACK] = ACTIONS(2967),
    [sym_comment] = ACTIONS(72),
    [sym__semicolon] = ACTIONS(2967),
  },
  [1008] = {
    [aux_sym_subscript_repeat1] = STATE(1378),
    [anon_sym_COMMA] = ACTIONS(2971),
    [anon_sym_RBRACK] = ACTIONS(2965),
    [sym_comment] = ACTIONS(72),
  },
  [1009] = {
    [sym__primary_expression] = STATE(1379),
    [sym_binary_operator] = STATE(1379),
    [sym_unary_operator] = STATE(1379),
    [sym_attribute] = STATE(1379),
    [sym_subscript] = STATE(1379),
    [sym_call] = STATE(1379),
    [sym_list] = STATE(1379),
    [sym_list_comprehension] = STATE(1379),
    [sym_dictionary] = STATE(1379),
    [sym_dictionary_comprehension] = STATE(1379),
    [sym_set] = STATE(1379),
    [sym_set_comprehension] = STATE(1379),
    [sym_parenthesized_expression] = STATE(1379),
    [sym_tuple] = STATE(1379),
    [sym_generator_expression] = STATE(1379),
    [sym_concatenated_string] = STATE(1379),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_PLUS] = ACTIONS(982),
    [anon_sym_DASH] = ACTIONS(982),
    [anon_sym_TILDE] = ACTIONS(982),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(2973),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(988),
    [sym_integer] = ACTIONS(2975),
    [sym_float] = ACTIONS(2975),
    [sym_identifier] = ACTIONS(2975),
    [sym_true] = ACTIONS(2975),
    [sym_false] = ACTIONS(2975),
    [sym_none] = ACTIONS(2975),
    [sym_comment] = ACTIONS(72),
  },
  [1010] = {
    [sym__primary_expression] = STATE(1380),
    [sym_binary_operator] = STATE(1380),
    [sym_unary_operator] = STATE(1380),
    [sym_attribute] = STATE(1380),
    [sym_subscript] = STATE(1380),
    [sym_call] = STATE(1380),
    [sym_list] = STATE(1380),
    [sym_list_comprehension] = STATE(1380),
    [sym_dictionary] = STATE(1380),
    [sym_dictionary_comprehension] = STATE(1380),
    [sym_set] = STATE(1380),
    [sym_set_comprehension] = STATE(1380),
    [sym_parenthesized_expression] = STATE(1380),
    [sym_tuple] = STATE(1380),
    [sym_generator_expression] = STATE(1380),
    [sym_concatenated_string] = STATE(1380),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_PLUS] = ACTIONS(982),
    [anon_sym_DASH] = ACTIONS(982),
    [anon_sym_TILDE] = ACTIONS(982),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(2977),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(988),
    [sym_integer] = ACTIONS(2979),
    [sym_float] = ACTIONS(2979),
    [sym_identifier] = ACTIONS(2979),
    [sym_true] = ACTIONS(2979),
    [sym_false] = ACTIONS(2979),
    [sym_none] = ACTIONS(2979),
    [sym_comment] = ACTIONS(72),
  },
  [1011] = {
    [sym__primary_expression] = STATE(1381),
    [sym_binary_operator] = STATE(1381),
    [sym_unary_operator] = STATE(1381),
    [sym_attribute] = STATE(1381),
    [sym_subscript] = STATE(1381),
    [sym_call] = STATE(1381),
    [sym_list] = STATE(1381),
    [sym_list_comprehension] = STATE(1381),
    [sym_dictionary] = STATE(1381),
    [sym_dictionary_comprehension] = STATE(1381),
    [sym_set] = STATE(1381),
    [sym_set_comprehension] = STATE(1381),
    [sym_parenthesized_expression] = STATE(1381),
    [sym_tuple] = STATE(1381),
    [sym_generator_expression] = STATE(1381),
    [sym_concatenated_string] = STATE(1381),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_PLUS] = ACTIONS(982),
    [anon_sym_DASH] = ACTIONS(982),
    [anon_sym_TILDE] = ACTIONS(982),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(2981),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(988),
    [sym_integer] = ACTIONS(2983),
    [sym_float] = ACTIONS(2983),
    [sym_identifier] = ACTIONS(2983),
    [sym_true] = ACTIONS(2983),
    [sym_false] = ACTIONS(2983),
    [sym_none] = ACTIONS(2983),
    [sym_comment] = ACTIONS(72),
  },
  [1012] = {
    [anon_sym_in] = ACTIONS(2985),
    [sym_comment] = ACTIONS(72),
  },
  [1013] = {
    [sym__primary_expression] = STATE(1383),
    [sym_binary_operator] = STATE(1383),
    [sym_unary_operator] = STATE(1383),
    [sym_attribute] = STATE(1383),
    [sym_subscript] = STATE(1383),
    [sym_call] = STATE(1383),
    [sym_list] = STATE(1383),
    [sym_list_comprehension] = STATE(1383),
    [sym_dictionary] = STATE(1383),
    [sym_dictionary_comprehension] = STATE(1383),
    [sym_set] = STATE(1383),
    [sym_set_comprehension] = STATE(1383),
    [sym_parenthesized_expression] = STATE(1383),
    [sym_tuple] = STATE(1383),
    [sym_generator_expression] = STATE(1383),
    [sym_concatenated_string] = STATE(1383),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_PLUS] = ACTIONS(982),
    [anon_sym_DASH] = ACTIONS(982),
    [anon_sym_TILDE] = ACTIONS(982),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(2987),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(988),
    [sym_integer] = ACTIONS(2989),
    [sym_float] = ACTIONS(2989),
    [sym_identifier] = ACTIONS(2989),
    [sym_true] = ACTIONS(2989),
    [sym_false] = ACTIONS(2989),
    [sym_none] = ACTIONS(2989),
    [sym_comment] = ACTIONS(72),
  },
  [1014] = {
    [sym__primary_expression] = STATE(621),
    [sym_binary_operator] = STATE(621),
    [sym_unary_operator] = STATE(621),
    [sym_attribute] = STATE(621),
    [sym_subscript] = STATE(621),
    [sym_call] = STATE(621),
    [sym_list] = STATE(621),
    [sym_list_comprehension] = STATE(621),
    [sym_dictionary] = STATE(621),
    [sym_dictionary_comprehension] = STATE(621),
    [sym_set] = STATE(621),
    [sym_set_comprehension] = STATE(621),
    [sym_parenthesized_expression] = STATE(621),
    [sym_tuple] = STATE(621),
    [sym_generator_expression] = STATE(621),
    [sym_concatenated_string] = STATE(621),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_PLUS] = ACTIONS(982),
    [anon_sym_DASH] = ACTIONS(982),
    [anon_sym_TILDE] = ACTIONS(982),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(1233),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(988),
    [sym_integer] = ACTIONS(1235),
    [sym_float] = ACTIONS(1235),
    [sym_identifier] = ACTIONS(1235),
    [sym_true] = ACTIONS(1235),
    [sym_false] = ACTIONS(1235),
    [sym_none] = ACTIONS(1235),
    [sym_comment] = ACTIONS(72),
  },
  [1015] = {
    [sym__primary_expression] = STATE(1384),
    [sym_binary_operator] = STATE(1384),
    [sym_unary_operator] = STATE(1384),
    [sym_attribute] = STATE(1384),
    [sym_subscript] = STATE(1384),
    [sym_call] = STATE(1384),
    [sym_list] = STATE(1384),
    [sym_list_comprehension] = STATE(1384),
    [sym_dictionary] = STATE(1384),
    [sym_dictionary_comprehension] = STATE(1384),
    [sym_set] = STATE(1384),
    [sym_set_comprehension] = STATE(1384),
    [sym_parenthesized_expression] = STATE(1384),
    [sym_tuple] = STATE(1384),
    [sym_generator_expression] = STATE(1384),
    [sym_concatenated_string] = STATE(1384),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_PLUS] = ACTIONS(982),
    [anon_sym_DASH] = ACTIONS(982),
    [anon_sym_TILDE] = ACTIONS(982),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(2991),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(988),
    [sym_integer] = ACTIONS(2993),
    [sym_float] = ACTIONS(2993),
    [sym_identifier] = ACTIONS(2993),
    [sym_true] = ACTIONS(2993),
    [sym_false] = ACTIONS(2993),
    [sym_none] = ACTIONS(2993),
    [sym_comment] = ACTIONS(72),
  },
  [1016] = {
    [sym__primary_expression] = STATE(1385),
    [sym_binary_operator] = STATE(1385),
    [sym_unary_operator] = STATE(1385),
    [sym_attribute] = STATE(1385),
    [sym_subscript] = STATE(1385),
    [sym_call] = STATE(1385),
    [sym_list] = STATE(1385),
    [sym_list_comprehension] = STATE(1385),
    [sym_dictionary] = STATE(1385),
    [sym_dictionary_comprehension] = STATE(1385),
    [sym_set] = STATE(1385),
    [sym_set_comprehension] = STATE(1385),
    [sym_parenthesized_expression] = STATE(1385),
    [sym_tuple] = STATE(1385),
    [sym_generator_expression] = STATE(1385),
    [sym_concatenated_string] = STATE(1385),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_PLUS] = ACTIONS(982),
    [anon_sym_DASH] = ACTIONS(982),
    [anon_sym_TILDE] = ACTIONS(982),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(2995),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(988),
    [sym_integer] = ACTIONS(2997),
    [sym_float] = ACTIONS(2997),
    [sym_identifier] = ACTIONS(2997),
    [sym_true] = ACTIONS(2997),
    [sym_false] = ACTIONS(2997),
    [sym_none] = ACTIONS(2997),
    [sym_comment] = ACTIONS(72),
  },
  [1017] = {
    [sym__primary_expression] = STATE(1386),
    [sym_binary_operator] = STATE(1386),
    [sym_unary_operator] = STATE(1386),
    [sym_attribute] = STATE(1386),
    [sym_subscript] = STATE(1386),
    [sym_call] = STATE(1386),
    [sym_list] = STATE(1386),
    [sym_list_comprehension] = STATE(1386),
    [sym_dictionary] = STATE(1386),
    [sym_dictionary_comprehension] = STATE(1386),
    [sym_set] = STATE(1386),
    [sym_set_comprehension] = STATE(1386),
    [sym_parenthesized_expression] = STATE(1386),
    [sym_tuple] = STATE(1386),
    [sym_generator_expression] = STATE(1386),
    [sym_concatenated_string] = STATE(1386),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_PLUS] = ACTIONS(982),
    [anon_sym_DASH] = ACTIONS(982),
    [anon_sym_TILDE] = ACTIONS(982),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(2999),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(988),
    [sym_integer] = ACTIONS(3001),
    [sym_float] = ACTIONS(3001),
    [sym_identifier] = ACTIONS(3001),
    [sym_true] = ACTIONS(3001),
    [sym_false] = ACTIONS(3001),
    [sym_none] = ACTIONS(3001),
    [sym_comment] = ACTIONS(72),
  },
  [1018] = {
    [sym__primary_expression] = STATE(1381),
    [sym_binary_operator] = STATE(1381),
    [sym_unary_operator] = STATE(1381),
    [sym_attribute] = STATE(1381),
    [sym_subscript] = STATE(1381),
    [sym_call] = STATE(1381),
    [sym_list] = STATE(1381),
    [sym_list_comprehension] = STATE(1381),
    [sym_dictionary] = STATE(1381),
    [sym_dictionary_comprehension] = STATE(1381),
    [sym_set] = STATE(1381),
    [sym_set_comprehension] = STATE(1381),
    [sym_parenthesized_expression] = STATE(1381),
    [sym_tuple] = STATE(1381),
    [sym_generator_expression] = STATE(1381),
    [sym_concatenated_string] = STATE(1381),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_not] = ACTIONS(3003),
    [anon_sym_PLUS] = ACTIONS(982),
    [anon_sym_DASH] = ACTIONS(982),
    [anon_sym_TILDE] = ACTIONS(982),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(2981),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(988),
    [sym_integer] = ACTIONS(2983),
    [sym_float] = ACTIONS(2983),
    [sym_identifier] = ACTIONS(2983),
    [sym_true] = ACTIONS(2983),
    [sym_false] = ACTIONS(2983),
    [sym_none] = ACTIONS(2983),
    [sym_comment] = ACTIONS(72),
  },
  [1019] = {
    [aux_sym_comparison_operator_repeat1] = STATE(1387),
    [anon_sym_COMMA] = ACTIONS(998),
    [anon_sym_if] = ACTIONS(998),
    [anon_sym_COLON] = ACTIONS(998),
    [anon_sym_in] = ACTIONS(2016),
    [anon_sym_not] = ACTIONS(2020),
    [anon_sym_and] = ACTIONS(998),
    [anon_sym_or] = ACTIONS(998),
    [anon_sym_LT] = ACTIONS(2032),
    [anon_sym_LT_EQ] = ACTIONS(2016),
    [anon_sym_EQ_EQ] = ACTIONS(2016),
    [anon_sym_BANG_EQ] = ACTIONS(2016),
    [anon_sym_GT_EQ] = ACTIONS(2016),
    [anon_sym_GT] = ACTIONS(2032),
    [anon_sym_LT_GT] = ACTIONS(2016),
    [anon_sym_is] = ACTIONS(2034),
    [anon_sym_RBRACK] = ACTIONS(998),
    [sym_comment] = ACTIONS(72),
  },
  [1020] = {
    [sym_aliased_import] = STATE(547),
    [sym_dotted_name] = STATE(548),
    [sym_identifier] = ACTIONS(74),
    [sym_comment] = ACTIONS(72),
  },
  [1021] = {
    [aux_sym_dotted_name_repeat1] = STATE(1388),
    [anon_sym_DOT] = ACTIONS(354),
    [anon_sym_RPAREN] = ACTIONS(342),
    [anon_sym_COMMA] = ACTIONS(342),
    [anon_sym_as] = ACTIONS(342),
    [sym_comment] = ACTIONS(72),
  },
  [1022] = {
    [anon_sym_RPAREN] = ACTIONS(3005),
    [sym_comment] = ACTIONS(72),
  },
  [1023] = {
    [aux_sym__import_list_repeat1] = STATE(1391),
    [anon_sym_RPAREN] = ACTIONS(348),
    [anon_sym_COMMA] = ACTIONS(3007),
    [sym_comment] = ACTIONS(72),
  },
  [1024] = {
    [aux_sym__import_list_repeat1] = STATE(1391),
    [anon_sym_RPAREN] = ACTIONS(348),
    [anon_sym_COMMA] = ACTIONS(3007),
    [anon_sym_as] = ACTIONS(3009),
    [sym_comment] = ACTIONS(72),
  },
  [1025] = {
    [anon_sym_DOT] = ACTIONS(2136),
    [anon_sym_LPAREN] = ACTIONS(2136),
    [anon_sym_RPAREN] = ACTIONS(2136),
    [anon_sym_COMMA] = ACTIONS(2136),
    [anon_sym_as] = ACTIONS(2138),
    [anon_sym_STAR] = ACTIONS(2138),
    [anon_sym_GT_GT] = ACTIONS(2136),
    [anon_sym_if] = ACTIONS(2136),
    [anon_sym_COLON] = ACTIONS(2136),
    [anon_sym_else] = ACTIONS(2136),
    [anon_sym_async] = ACTIONS(2136),
    [anon_sym_for] = ACTIONS(2136),
    [anon_sym_in] = ACTIONS(2136),
    [anon_sym_EQ] = ACTIONS(2138),
    [anon_sym_AT] = ACTIONS(2136),
    [anon_sym_not] = ACTIONS(2136),
    [anon_sym_and] = ACTIONS(2136),
    [anon_sym_or] = ACTIONS(2136),
    [anon_sym_PLUS] = ACTIONS(2136),
    [anon_sym_DASH] = ACTIONS(2136),
    [anon_sym_SLASH] = ACTIONS(2138),
    [anon_sym_PERCENT] = ACTIONS(2136),
    [anon_sym_SLASH_SLASH] = ACTIONS(2136),
    [anon_sym_STAR_STAR] = ACTIONS(2136),
    [anon_sym_PIPE] = ACTIONS(2136),
    [anon_sym_AMP] = ACTIONS(2136),
    [anon_sym_CARET] = ACTIONS(2136),
    [anon_sym_LT_LT] = ACTIONS(2136),
    [anon_sym_LT] = ACTIONS(2138),
    [anon_sym_LT_EQ] = ACTIONS(2136),
    [anon_sym_EQ_EQ] = ACTIONS(2136),
    [anon_sym_BANG_EQ] = ACTIONS(2136),
    [anon_sym_GT_EQ] = ACTIONS(2136),
    [anon_sym_GT] = ACTIONS(2138),
    [anon_sym_LT_GT] = ACTIONS(2136),
    [anon_sym_is] = ACTIONS(2136),
    [anon_sym_LBRACK] = ACTIONS(2136),
    [anon_sym_RBRACK] = ACTIONS(2136),
    [anon_sym_RBRACE] = ACTIONS(2136),
    [sym_comment] = ACTIONS(72),
  },
  [1026] = {
    [anon_sym_DOT] = ACTIONS(2148),
    [anon_sym_LPAREN] = ACTIONS(2148),
    [anon_sym_RPAREN] = ACTIONS(2148),
    [anon_sym_COMMA] = ACTIONS(2148),
    [anon_sym_as] = ACTIONS(2150),
    [anon_sym_STAR] = ACTIONS(2150),
    [anon_sym_GT_GT] = ACTIONS(2148),
    [anon_sym_if] = ACTIONS(2148),
    [anon_sym_COLON] = ACTIONS(2148),
    [anon_sym_else] = ACTIONS(2148),
    [anon_sym_async] = ACTIONS(2148),
    [anon_sym_for] = ACTIONS(2148),
    [anon_sym_in] = ACTIONS(2148),
    [anon_sym_EQ] = ACTIONS(2150),
    [anon_sym_AT] = ACTIONS(2148),
    [anon_sym_not] = ACTIONS(2148),
    [anon_sym_and] = ACTIONS(2148),
    [anon_sym_or] = ACTIONS(2148),
    [anon_sym_PLUS] = ACTIONS(2148),
    [anon_sym_DASH] = ACTIONS(2148),
    [anon_sym_SLASH] = ACTIONS(2150),
    [anon_sym_PERCENT] = ACTIONS(2148),
    [anon_sym_SLASH_SLASH] = ACTIONS(2148),
    [anon_sym_STAR_STAR] = ACTIONS(2148),
    [anon_sym_PIPE] = ACTIONS(2148),
    [anon_sym_AMP] = ACTIONS(2148),
    [anon_sym_CARET] = ACTIONS(2148),
    [anon_sym_LT_LT] = ACTIONS(2148),
    [anon_sym_LT] = ACTIONS(2150),
    [anon_sym_LT_EQ] = ACTIONS(2148),
    [anon_sym_EQ_EQ] = ACTIONS(2148),
    [anon_sym_BANG_EQ] = ACTIONS(2148),
    [anon_sym_GT_EQ] = ACTIONS(2148),
    [anon_sym_GT] = ACTIONS(2150),
    [anon_sym_LT_GT] = ACTIONS(2148),
    [anon_sym_is] = ACTIONS(2148),
    [anon_sym_LBRACK] = ACTIONS(2148),
    [anon_sym_RBRACK] = ACTIONS(2148),
    [anon_sym_RBRACE] = ACTIONS(2148),
    [sym_comment] = ACTIONS(72),
  },
  [1027] = {
    [sym__expression] = STATE(599),
    [sym__primary_expression] = STATE(215),
    [sym_not_operator] = STATE(599),
    [sym_boolean_operator] = STATE(599),
    [sym_binary_operator] = STATE(215),
    [sym_unary_operator] = STATE(215),
    [sym_comparison_operator] = STATE(599),
    [sym_lambda] = STATE(599),
    [sym_yield] = STATE(600),
    [sym_attribute] = STATE(215),
    [sym_subscript] = STATE(215),
    [sym_call] = STATE(215),
    [sym_list] = STATE(215),
    [sym_list_comprehension] = STATE(215),
    [sym_dictionary] = STATE(215),
    [sym_dictionary_comprehension] = STATE(215),
    [sym_set] = STATE(215),
    [sym_set_comprehension] = STATE(215),
    [sym_parenthesized_expression] = STATE(215),
    [sym_tuple] = STATE(215),
    [sym_generator_expression] = STATE(215),
    [sym_conditional_expression] = STATE(599),
    [sym_concatenated_string] = STATE(215),
    [sym_await] = STATE(599),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_RPAREN] = ACTIONS(3011),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_not] = ACTIONS(384),
    [anon_sym_PLUS] = ACTIONS(386),
    [anon_sym_DASH] = ACTIONS(386),
    [anon_sym_TILDE] = ACTIONS(386),
    [anon_sym_lambda] = ACTIONS(388),
    [anon_sym_yield] = ACTIONS(94),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(390),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(392),
    [sym_integer] = ACTIONS(394),
    [sym_float] = ACTIONS(394),
    [sym_identifier] = ACTIONS(394),
    [sym_true] = ACTIONS(394),
    [sym_false] = ACTIONS(394),
    [sym_none] = ACTIONS(394),
    [anon_sym_await] = ACTIONS(396),
    [sym_comment] = ACTIONS(72),
  },
  [1028] = {
    [anon_sym_RPAREN] = ACTIONS(2642),
    [anon_sym_COMMA] = ACTIONS(2642),
    [anon_sym_if] = ACTIONS(412),
    [anon_sym_async] = ACTIONS(2642),
    [anon_sym_for] = ACTIONS(2642),
    [anon_sym_and] = ACTIONS(418),
    [anon_sym_or] = ACTIONS(420),
    [sym_comment] = ACTIONS(72),
  },
  [1029] = {
    [anon_sym_RPAREN] = ACTIONS(1644),
    [anon_sym_COMMA] = ACTIONS(1644),
    [anon_sym_if] = ACTIONS(1147),
    [anon_sym_and] = ACTIONS(1149),
    [anon_sym_or] = ACTIONS(1151),
    [sym_comment] = ACTIONS(72),
  },
  [1030] = {
    [sym__expression] = STATE(1394),
    [sym__primary_expression] = STATE(215),
    [sym_not_operator] = STATE(1394),
    [sym_boolean_operator] = STATE(1394),
    [sym_binary_operator] = STATE(215),
    [sym_unary_operator] = STATE(215),
    [sym_comparison_operator] = STATE(1394),
    [sym_lambda] = STATE(1394),
    [sym_attribute] = STATE(215),
    [sym_subscript] = STATE(215),
    [sym_call] = STATE(215),
    [sym_list] = STATE(215),
    [sym_list_comprehension] = STATE(215),
    [sym_dictionary] = STATE(215),
    [sym_dictionary_comprehension] = STATE(215),
    [sym_set] = STATE(215),
    [sym_set_comprehension] = STATE(215),
    [sym_parenthesized_expression] = STATE(215),
    [sym_tuple] = STATE(215),
    [sym_generator_expression] = STATE(215),
    [sym_conditional_expression] = STATE(1394),
    [sym_concatenated_string] = STATE(215),
    [sym_await] = STATE(1394),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_not] = ACTIONS(384),
    [anon_sym_PLUS] = ACTIONS(386),
    [anon_sym_DASH] = ACTIONS(386),
    [anon_sym_TILDE] = ACTIONS(386),
    [anon_sym_lambda] = ACTIONS(388),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(390),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(392),
    [sym_integer] = ACTIONS(394),
    [sym_float] = ACTIONS(394),
    [sym_identifier] = ACTIONS(394),
    [sym_true] = ACTIONS(394),
    [sym_false] = ACTIONS(394),
    [sym_none] = ACTIONS(394),
    [anon_sym_await] = ACTIONS(396),
    [sym_comment] = ACTIONS(72),
  },
  [1031] = {
    [aux_sym_concatenated_string_repeat1] = STATE(1031),
    [anon_sym_DOT] = ACTIONS(1862),
    [anon_sym_LPAREN] = ACTIONS(1862),
    [anon_sym_RPAREN] = ACTIONS(1862),
    [anon_sym_COMMA] = ACTIONS(1862),
    [anon_sym_STAR] = ACTIONS(1864),
    [anon_sym_GT_GT] = ACTIONS(1862),
    [anon_sym_if] = ACTIONS(1862),
    [anon_sym_in] = ACTIONS(1862),
    [anon_sym_AT] = ACTIONS(1862),
    [anon_sym_not] = ACTIONS(1862),
    [anon_sym_and] = ACTIONS(1862),
    [anon_sym_or] = ACTIONS(1862),
    [anon_sym_PLUS] = ACTIONS(1862),
    [anon_sym_DASH] = ACTIONS(1862),
    [anon_sym_SLASH] = ACTIONS(1864),
    [anon_sym_PERCENT] = ACTIONS(1862),
    [anon_sym_SLASH_SLASH] = ACTIONS(1862),
    [anon_sym_STAR_STAR] = ACTIONS(1862),
    [anon_sym_PIPE] = ACTIONS(1862),
    [anon_sym_AMP] = ACTIONS(1862),
    [anon_sym_CARET] = ACTIONS(1862),
    [anon_sym_LT_LT] = ACTIONS(1862),
    [anon_sym_LT] = ACTIONS(1864),
    [anon_sym_LT_EQ] = ACTIONS(1862),
    [anon_sym_EQ_EQ] = ACTIONS(1862),
    [anon_sym_BANG_EQ] = ACTIONS(1862),
    [anon_sym_GT_EQ] = ACTIONS(1862),
    [anon_sym_GT] = ACTIONS(1864),
    [anon_sym_LT_GT] = ACTIONS(1862),
    [anon_sym_is] = ACTIONS(1862),
    [anon_sym_LBRACK] = ACTIONS(1862),
    [sym_string] = ACTIONS(3013),
    [sym_comment] = ACTIONS(72),
  },
  [1032] = {
    [anon_sym_RPAREN] = ACTIONS(1915),
    [anon_sym_COMMA] = ACTIONS(1915),
    [anon_sym_if] = ACTIONS(1147),
    [anon_sym_and] = ACTIONS(1149),
    [anon_sym_or] = ACTIONS(1151),
    [sym_comment] = ACTIONS(72),
  },
  [1033] = {
    [anon_sym_if] = ACTIONS(1921),
    [anon_sym_else] = ACTIONS(3016),
    [anon_sym_and] = ACTIONS(1925),
    [anon_sym_or] = ACTIONS(1927),
    [sym_comment] = ACTIONS(72),
  },
  [1034] = {
    [anon_sym_RPAREN] = ACTIONS(1953),
    [anon_sym_COMMA] = ACTIONS(1953),
    [anon_sym_if] = ACTIONS(1953),
    [anon_sym_and] = ACTIONS(1149),
    [anon_sym_or] = ACTIONS(1953),
    [sym_comment] = ACTIONS(72),
  },
  [1035] = {
    [sym__expression] = STATE(1032),
    [sym__primary_expression] = STATE(215),
    [sym_not_operator] = STATE(1032),
    [sym_boolean_operator] = STATE(1032),
    [sym_binary_operator] = STATE(215),
    [sym_unary_operator] = STATE(215),
    [sym_comparison_operator] = STATE(1032),
    [sym_lambda] = STATE(1032),
    [sym_attribute] = STATE(215),
    [sym_subscript] = STATE(215),
    [sym_call] = STATE(215),
    [sym_list] = STATE(215),
    [sym_list_comprehension] = STATE(215),
    [sym_dictionary] = STATE(215),
    [sym_dictionary_comprehension] = STATE(215),
    [sym_set] = STATE(215),
    [sym_set_comprehension] = STATE(215),
    [sym_parenthesized_expression] = STATE(215),
    [sym_tuple] = STATE(215),
    [sym_generator_expression] = STATE(215),
    [sym_conditional_expression] = STATE(1032),
    [sym_concatenated_string] = STATE(215),
    [sym_await] = STATE(1032),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_RPAREN] = ACTIONS(1957),
    [anon_sym_COMMA] = ACTIONS(1957),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_not] = ACTIONS(384),
    [anon_sym_PLUS] = ACTIONS(386),
    [anon_sym_DASH] = ACTIONS(386),
    [anon_sym_TILDE] = ACTIONS(386),
    [anon_sym_lambda] = ACTIONS(388),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(390),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(392),
    [sym_integer] = ACTIONS(394),
    [sym_float] = ACTIONS(394),
    [sym_identifier] = ACTIONS(394),
    [sym_true] = ACTIONS(394),
    [sym_false] = ACTIONS(394),
    [sym_none] = ACTIONS(394),
    [anon_sym_await] = ACTIONS(396),
    [sym_comment] = ACTIONS(72),
  },
  [1036] = {
    [aux_sym_print_statement_repeat1] = STATE(1036),
    [anon_sym_RPAREN] = ACTIONS(1915),
    [anon_sym_COMMA] = ACTIONS(3018),
    [sym_comment] = ACTIONS(72),
  },
  [1037] = {
    [sym_argument_list] = STATE(251),
    [sym_generator_expression] = STATE(251),
    [anon_sym_DOT] = ACTIONS(1980),
    [anon_sym_LPAREN] = ACTIONS(424),
    [anon_sym_RPAREN] = ACTIONS(1980),
    [anon_sym_COMMA] = ACTIONS(1980),
    [anon_sym_STAR] = ACTIONS(1982),
    [anon_sym_GT_GT] = ACTIONS(1980),
    [anon_sym_if] = ACTIONS(1980),
    [anon_sym_in] = ACTIONS(1980),
    [anon_sym_AT] = ACTIONS(1980),
    [anon_sym_not] = ACTIONS(1980),
    [anon_sym_and] = ACTIONS(1980),
    [anon_sym_or] = ACTIONS(1980),
    [anon_sym_PLUS] = ACTIONS(1980),
    [anon_sym_DASH] = ACTIONS(1980),
    [anon_sym_SLASH] = ACTIONS(1982),
    [anon_sym_PERCENT] = ACTIONS(1980),
    [anon_sym_SLASH_SLASH] = ACTIONS(1980),
    [anon_sym_STAR_STAR] = ACTIONS(1165),
    [anon_sym_PIPE] = ACTIONS(1980),
    [anon_sym_AMP] = ACTIONS(1980),
    [anon_sym_CARET] = ACTIONS(1980),
    [anon_sym_LT_LT] = ACTIONS(1980),
    [anon_sym_LT] = ACTIONS(1982),
    [anon_sym_LT_EQ] = ACTIONS(1980),
    [anon_sym_EQ_EQ] = ACTIONS(1980),
    [anon_sym_BANG_EQ] = ACTIONS(1980),
    [anon_sym_GT_EQ] = ACTIONS(1980),
    [anon_sym_GT] = ACTIONS(1982),
    [anon_sym_LT_GT] = ACTIONS(1980),
    [anon_sym_is] = ACTIONS(1980),
    [anon_sym_LBRACK] = ACTIONS(1980),
    [sym_comment] = ACTIONS(72),
  },
  [1038] = {
    [sym_argument_list] = STATE(251),
    [sym_generator_expression] = STATE(251),
    [anon_sym_DOT] = ACTIONS(1980),
    [anon_sym_LPAREN] = ACTIONS(424),
    [anon_sym_RPAREN] = ACTIONS(1980),
    [anon_sym_COMMA] = ACTIONS(1980),
    [anon_sym_STAR] = ACTIONS(1153),
    [anon_sym_GT_GT] = ACTIONS(1980),
    [anon_sym_if] = ACTIONS(1980),
    [anon_sym_in] = ACTIONS(1980),
    [anon_sym_AT] = ACTIONS(1159),
    [anon_sym_not] = ACTIONS(1980),
    [anon_sym_and] = ACTIONS(1980),
    [anon_sym_or] = ACTIONS(1980),
    [anon_sym_PLUS] = ACTIONS(1163),
    [anon_sym_DASH] = ACTIONS(1163),
    [anon_sym_SLASH] = ACTIONS(1153),
    [anon_sym_PERCENT] = ACTIONS(1159),
    [anon_sym_SLASH_SLASH] = ACTIONS(1159),
    [anon_sym_STAR_STAR] = ACTIONS(1165),
    [anon_sym_PIPE] = ACTIONS(1980),
    [anon_sym_AMP] = ACTIONS(1980),
    [anon_sym_CARET] = ACTIONS(1980),
    [anon_sym_LT_LT] = ACTIONS(1980),
    [anon_sym_LT] = ACTIONS(1982),
    [anon_sym_LT_EQ] = ACTIONS(1980),
    [anon_sym_EQ_EQ] = ACTIONS(1980),
    [anon_sym_BANG_EQ] = ACTIONS(1980),
    [anon_sym_GT_EQ] = ACTIONS(1980),
    [anon_sym_GT] = ACTIONS(1982),
    [anon_sym_LT_GT] = ACTIONS(1980),
    [anon_sym_is] = ACTIONS(1980),
    [anon_sym_LBRACK] = ACTIONS(1980),
    [sym_comment] = ACTIONS(72),
  },
  [1039] = {
    [sym_argument_list] = STATE(251),
    [sym_generator_expression] = STATE(251),
    [anon_sym_DOT] = ACTIONS(422),
    [anon_sym_LPAREN] = ACTIONS(424),
    [anon_sym_RPAREN] = ACTIONS(1984),
    [anon_sym_COMMA] = ACTIONS(1984),
    [anon_sym_STAR] = ACTIONS(1153),
    [anon_sym_GT_GT] = ACTIONS(1155),
    [anon_sym_if] = ACTIONS(1984),
    [anon_sym_in] = ACTIONS(1984),
    [anon_sym_AT] = ACTIONS(1159),
    [anon_sym_not] = ACTIONS(1984),
    [anon_sym_and] = ACTIONS(1984),
    [anon_sym_or] = ACTIONS(1984),
    [anon_sym_PLUS] = ACTIONS(1163),
    [anon_sym_DASH] = ACTIONS(1163),
    [anon_sym_SLASH] = ACTIONS(1153),
    [anon_sym_PERCENT] = ACTIONS(1159),
    [anon_sym_SLASH_SLASH] = ACTIONS(1159),
    [anon_sym_STAR_STAR] = ACTIONS(1165),
    [anon_sym_PIPE] = ACTIONS(1167),
    [anon_sym_AMP] = ACTIONS(1169),
    [anon_sym_CARET] = ACTIONS(1171),
    [anon_sym_LT_LT] = ACTIONS(1155),
    [anon_sym_LT] = ACTIONS(1986),
    [anon_sym_LT_EQ] = ACTIONS(1984),
    [anon_sym_EQ_EQ] = ACTIONS(1984),
    [anon_sym_BANG_EQ] = ACTIONS(1984),
    [anon_sym_GT_EQ] = ACTIONS(1984),
    [anon_sym_GT] = ACTIONS(1986),
    [anon_sym_LT_GT] = ACTIONS(1984),
    [anon_sym_is] = ACTIONS(1984),
    [anon_sym_LBRACK] = ACTIONS(450),
    [sym_comment] = ACTIONS(72),
  },
  [1040] = {
    [sym__primary_expression] = STATE(1397),
    [sym_binary_operator] = STATE(1397),
    [sym_unary_operator] = STATE(1397),
    [sym_attribute] = STATE(1397),
    [sym_subscript] = STATE(1397),
    [sym_call] = STATE(1397),
    [sym_list] = STATE(1397),
    [sym_list_comprehension] = STATE(1397),
    [sym_dictionary] = STATE(1397),
    [sym_dictionary_comprehension] = STATE(1397),
    [sym_set] = STATE(1397),
    [sym_set_comprehension] = STATE(1397),
    [sym_parenthesized_expression] = STATE(1397),
    [sym_tuple] = STATE(1397),
    [sym_generator_expression] = STATE(1397),
    [sym_concatenated_string] = STATE(1397),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_PLUS] = ACTIONS(386),
    [anon_sym_DASH] = ACTIONS(386),
    [anon_sym_TILDE] = ACTIONS(386),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(3021),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(392),
    [sym_integer] = ACTIONS(3023),
    [sym_float] = ACTIONS(3023),
    [sym_identifier] = ACTIONS(3023),
    [sym_true] = ACTIONS(3023),
    [sym_false] = ACTIONS(3023),
    [sym_none] = ACTIONS(3023),
    [sym_comment] = ACTIONS(72),
  },
  [1041] = {
    [sym_argument_list] = STATE(251),
    [sym_generator_expression] = STATE(251),
    [anon_sym_DOT] = ACTIONS(1980),
    [anon_sym_LPAREN] = ACTIONS(424),
    [anon_sym_RPAREN] = ACTIONS(1980),
    [anon_sym_COMMA] = ACTIONS(1980),
    [anon_sym_STAR] = ACTIONS(1153),
    [anon_sym_GT_GT] = ACTIONS(1980),
    [anon_sym_if] = ACTIONS(1980),
    [anon_sym_in] = ACTIONS(1980),
    [anon_sym_AT] = ACTIONS(1159),
    [anon_sym_not] = ACTIONS(1980),
    [anon_sym_and] = ACTIONS(1980),
    [anon_sym_or] = ACTIONS(1980),
    [anon_sym_PLUS] = ACTIONS(1980),
    [anon_sym_DASH] = ACTIONS(1980),
    [anon_sym_SLASH] = ACTIONS(1153),
    [anon_sym_PERCENT] = ACTIONS(1159),
    [anon_sym_SLASH_SLASH] = ACTIONS(1159),
    [anon_sym_STAR_STAR] = ACTIONS(1165),
    [anon_sym_PIPE] = ACTIONS(1980),
    [anon_sym_AMP] = ACTIONS(1980),
    [anon_sym_CARET] = ACTIONS(1980),
    [anon_sym_LT_LT] = ACTIONS(1980),
    [anon_sym_LT] = ACTIONS(1982),
    [anon_sym_LT_EQ] = ACTIONS(1980),
    [anon_sym_EQ_EQ] = ACTIONS(1980),
    [anon_sym_BANG_EQ] = ACTIONS(1980),
    [anon_sym_GT_EQ] = ACTIONS(1980),
    [anon_sym_GT] = ACTIONS(1982),
    [anon_sym_LT_GT] = ACTIONS(1980),
    [anon_sym_is] = ACTIONS(1980),
    [anon_sym_LBRACK] = ACTIONS(1980),
    [sym_comment] = ACTIONS(72),
  },
  [1042] = {
    [sym_argument_list] = STATE(251),
    [sym_generator_expression] = STATE(251),
    [anon_sym_DOT] = ACTIONS(1980),
    [anon_sym_LPAREN] = ACTIONS(424),
    [anon_sym_RPAREN] = ACTIONS(1980),
    [anon_sym_COMMA] = ACTIONS(1980),
    [anon_sym_STAR] = ACTIONS(1153),
    [anon_sym_GT_GT] = ACTIONS(1155),
    [anon_sym_if] = ACTIONS(1980),
    [anon_sym_in] = ACTIONS(1980),
    [anon_sym_AT] = ACTIONS(1159),
    [anon_sym_not] = ACTIONS(1980),
    [anon_sym_and] = ACTIONS(1980),
    [anon_sym_or] = ACTIONS(1980),
    [anon_sym_PLUS] = ACTIONS(1163),
    [anon_sym_DASH] = ACTIONS(1163),
    [anon_sym_SLASH] = ACTIONS(1153),
    [anon_sym_PERCENT] = ACTIONS(1159),
    [anon_sym_SLASH_SLASH] = ACTIONS(1159),
    [anon_sym_STAR_STAR] = ACTIONS(1165),
    [anon_sym_PIPE] = ACTIONS(1980),
    [anon_sym_AMP] = ACTIONS(1169),
    [anon_sym_CARET] = ACTIONS(1171),
    [anon_sym_LT_LT] = ACTIONS(1155),
    [anon_sym_LT] = ACTIONS(1982),
    [anon_sym_LT_EQ] = ACTIONS(1980),
    [anon_sym_EQ_EQ] = ACTIONS(1980),
    [anon_sym_BANG_EQ] = ACTIONS(1980),
    [anon_sym_GT_EQ] = ACTIONS(1980),
    [anon_sym_GT] = ACTIONS(1982),
    [anon_sym_LT_GT] = ACTIONS(1980),
    [anon_sym_is] = ACTIONS(1980),
    [anon_sym_LBRACK] = ACTIONS(1980),
    [sym_comment] = ACTIONS(72),
  },
  [1043] = {
    [sym_argument_list] = STATE(251),
    [sym_generator_expression] = STATE(251),
    [anon_sym_DOT] = ACTIONS(1980),
    [anon_sym_LPAREN] = ACTIONS(424),
    [anon_sym_RPAREN] = ACTIONS(1980),
    [anon_sym_COMMA] = ACTIONS(1980),
    [anon_sym_STAR] = ACTIONS(1153),
    [anon_sym_GT_GT] = ACTIONS(1155),
    [anon_sym_if] = ACTIONS(1980),
    [anon_sym_in] = ACTIONS(1980),
    [anon_sym_AT] = ACTIONS(1159),
    [anon_sym_not] = ACTIONS(1980),
    [anon_sym_and] = ACTIONS(1980),
    [anon_sym_or] = ACTIONS(1980),
    [anon_sym_PLUS] = ACTIONS(1163),
    [anon_sym_DASH] = ACTIONS(1163),
    [anon_sym_SLASH] = ACTIONS(1153),
    [anon_sym_PERCENT] = ACTIONS(1159),
    [anon_sym_SLASH_SLASH] = ACTIONS(1159),
    [anon_sym_STAR_STAR] = ACTIONS(1165),
    [anon_sym_PIPE] = ACTIONS(1980),
    [anon_sym_AMP] = ACTIONS(1980),
    [anon_sym_CARET] = ACTIONS(1171),
    [anon_sym_LT_LT] = ACTIONS(1155),
    [anon_sym_LT] = ACTIONS(1982),
    [anon_sym_LT_EQ] = ACTIONS(1980),
    [anon_sym_EQ_EQ] = ACTIONS(1980),
    [anon_sym_BANG_EQ] = ACTIONS(1980),
    [anon_sym_GT_EQ] = ACTIONS(1980),
    [anon_sym_GT] = ACTIONS(1982),
    [anon_sym_LT_GT] = ACTIONS(1980),
    [anon_sym_is] = ACTIONS(1980),
    [anon_sym_LBRACK] = ACTIONS(1980),
    [sym_comment] = ACTIONS(72),
  },
  [1044] = {
    [sym_argument_list] = STATE(251),
    [sym_generator_expression] = STATE(251),
    [anon_sym_DOT] = ACTIONS(1980),
    [anon_sym_LPAREN] = ACTIONS(424),
    [anon_sym_RPAREN] = ACTIONS(1980),
    [anon_sym_COMMA] = ACTIONS(1980),
    [anon_sym_STAR] = ACTIONS(1153),
    [anon_sym_GT_GT] = ACTIONS(1155),
    [anon_sym_if] = ACTIONS(1980),
    [anon_sym_in] = ACTIONS(1980),
    [anon_sym_AT] = ACTIONS(1159),
    [anon_sym_not] = ACTIONS(1980),
    [anon_sym_and] = ACTIONS(1980),
    [anon_sym_or] = ACTIONS(1980),
    [anon_sym_PLUS] = ACTIONS(1163),
    [anon_sym_DASH] = ACTIONS(1163),
    [anon_sym_SLASH] = ACTIONS(1153),
    [anon_sym_PERCENT] = ACTIONS(1159),
    [anon_sym_SLASH_SLASH] = ACTIONS(1159),
    [anon_sym_STAR_STAR] = ACTIONS(1165),
    [anon_sym_PIPE] = ACTIONS(1980),
    [anon_sym_AMP] = ACTIONS(1980),
    [anon_sym_CARET] = ACTIONS(1980),
    [anon_sym_LT_LT] = ACTIONS(1155),
    [anon_sym_LT] = ACTIONS(1982),
    [anon_sym_LT_EQ] = ACTIONS(1980),
    [anon_sym_EQ_EQ] = ACTIONS(1980),
    [anon_sym_BANG_EQ] = ACTIONS(1980),
    [anon_sym_GT_EQ] = ACTIONS(1980),
    [anon_sym_GT] = ACTIONS(1982),
    [anon_sym_LT_GT] = ACTIONS(1980),
    [anon_sym_is] = ACTIONS(1980),
    [anon_sym_LBRACK] = ACTIONS(1980),
    [sym_comment] = ACTIONS(72),
  },
  [1045] = {
    [aux_sym_comparison_operator_repeat1] = STATE(1045),
    [anon_sym_RPAREN] = ACTIONS(1984),
    [anon_sym_COMMA] = ACTIONS(1984),
    [anon_sym_if] = ACTIONS(1984),
    [anon_sym_in] = ACTIONS(3025),
    [anon_sym_not] = ACTIONS(3028),
    [anon_sym_and] = ACTIONS(1984),
    [anon_sym_or] = ACTIONS(1984),
    [anon_sym_LT] = ACTIONS(3031),
    [anon_sym_LT_EQ] = ACTIONS(3025),
    [anon_sym_EQ_EQ] = ACTIONS(3025),
    [anon_sym_BANG_EQ] = ACTIONS(3025),
    [anon_sym_GT_EQ] = ACTIONS(3025),
    [anon_sym_GT] = ACTIONS(3031),
    [anon_sym_LT_GT] = ACTIONS(3025),
    [anon_sym_is] = ACTIONS(3034),
    [sym_comment] = ACTIONS(72),
  },
  [1046] = {
    [anon_sym_DOT] = ACTIONS(2683),
    [anon_sym_LPAREN] = ACTIONS(2683),
    [anon_sym_RPAREN] = ACTIONS(2683),
    [anon_sym_COMMA] = ACTIONS(2683),
    [anon_sym_as] = ACTIONS(2685),
    [anon_sym_STAR] = ACTIONS(2685),
    [anon_sym_GT_GT] = ACTIONS(2683),
    [anon_sym_if] = ACTIONS(2683),
    [anon_sym_COLON] = ACTIONS(2683),
    [anon_sym_else] = ACTIONS(2683),
    [anon_sym_async] = ACTIONS(2683),
    [anon_sym_for] = ACTIONS(2683),
    [anon_sym_in] = ACTIONS(2683),
    [anon_sym_EQ] = ACTIONS(2685),
    [anon_sym_AT] = ACTIONS(2683),
    [anon_sym_not] = ACTIONS(2683),
    [anon_sym_and] = ACTIONS(2683),
    [anon_sym_or] = ACTIONS(2683),
    [anon_sym_PLUS] = ACTIONS(2683),
    [anon_sym_DASH] = ACTIONS(2683),
    [anon_sym_SLASH] = ACTIONS(2685),
    [anon_sym_PERCENT] = ACTIONS(2683),
    [anon_sym_SLASH_SLASH] = ACTIONS(2683),
    [anon_sym_STAR_STAR] = ACTIONS(2683),
    [anon_sym_PIPE] = ACTIONS(2683),
    [anon_sym_AMP] = ACTIONS(2683),
    [anon_sym_CARET] = ACTIONS(2683),
    [anon_sym_LT_LT] = ACTIONS(2683),
    [anon_sym_LT] = ACTIONS(2685),
    [anon_sym_LT_EQ] = ACTIONS(2683),
    [anon_sym_EQ_EQ] = ACTIONS(2683),
    [anon_sym_BANG_EQ] = ACTIONS(2683),
    [anon_sym_GT_EQ] = ACTIONS(2683),
    [anon_sym_GT] = ACTIONS(2685),
    [anon_sym_LT_GT] = ACTIONS(2683),
    [anon_sym_is] = ACTIONS(2683),
    [anon_sym_LBRACK] = ACTIONS(2683),
    [anon_sym_RBRACK] = ACTIONS(2683),
    [anon_sym_RBRACE] = ACTIONS(2683),
    [sym_comment] = ACTIONS(72),
  },
  [1047] = {
    [sym_list_splat] = STATE(870),
    [sym__expression] = STATE(871),
    [sym__primary_expression] = STATE(430),
    [sym_not_operator] = STATE(871),
    [sym_boolean_operator] = STATE(871),
    [sym_binary_operator] = STATE(430),
    [sym_unary_operator] = STATE(430),
    [sym_comparison_operator] = STATE(871),
    [sym_lambda] = STATE(871),
    [sym_attribute] = STATE(430),
    [sym_subscript] = STATE(430),
    [sym_call] = STATE(430),
    [sym_list] = STATE(430),
    [sym_list_comprehension] = STATE(430),
    [sym_dictionary] = STATE(430),
    [sym_dictionary_comprehension] = STATE(430),
    [sym_set] = STATE(430),
    [sym_set_comprehension] = STATE(430),
    [sym_parenthesized_expression] = STATE(430),
    [sym_tuple] = STATE(430),
    [sym_generator_expression] = STATE(430),
    [sym_conditional_expression] = STATE(871),
    [sym_concatenated_string] = STATE(430),
    [sym_await] = STATE(871),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_STAR] = ACTIONS(238),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_not] = ACTIONS(760),
    [anon_sym_PLUS] = ACTIONS(762),
    [anon_sym_DASH] = ACTIONS(762),
    [anon_sym_TILDE] = ACTIONS(762),
    [anon_sym_lambda] = ACTIONS(764),
    [anon_sym_LBRACK] = ACTIONS(96),
    [anon_sym_RBRACK] = ACTIONS(3037),
    [sym_ellipsis] = ACTIONS(766),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(768),
    [sym_integer] = ACTIONS(770),
    [sym_float] = ACTIONS(770),
    [sym_identifier] = ACTIONS(770),
    [sym_true] = ACTIONS(770),
    [sym_false] = ACTIONS(770),
    [sym_none] = ACTIONS(770),
    [anon_sym_await] = ACTIONS(772),
    [sym_comment] = ACTIONS(72),
  },
  [1048] = {
    [anon_sym_DOT] = ACTIONS(2698),
    [anon_sym_LPAREN] = ACTIONS(2698),
    [anon_sym_RPAREN] = ACTIONS(2698),
    [anon_sym_COMMA] = ACTIONS(2698),
    [anon_sym_as] = ACTIONS(2700),
    [anon_sym_STAR] = ACTIONS(2700),
    [anon_sym_GT_GT] = ACTIONS(2698),
    [anon_sym_if] = ACTIONS(2698),
    [anon_sym_COLON] = ACTIONS(2698),
    [anon_sym_else] = ACTIONS(2698),
    [anon_sym_async] = ACTIONS(2698),
    [anon_sym_for] = ACTIONS(2698),
    [anon_sym_in] = ACTIONS(2698),
    [anon_sym_EQ] = ACTIONS(2700),
    [anon_sym_AT] = ACTIONS(2698),
    [anon_sym_not] = ACTIONS(2698),
    [anon_sym_and] = ACTIONS(2698),
    [anon_sym_or] = ACTIONS(2698),
    [anon_sym_PLUS] = ACTIONS(2698),
    [anon_sym_DASH] = ACTIONS(2698),
    [anon_sym_SLASH] = ACTIONS(2700),
    [anon_sym_PERCENT] = ACTIONS(2698),
    [anon_sym_SLASH_SLASH] = ACTIONS(2698),
    [anon_sym_STAR_STAR] = ACTIONS(2698),
    [anon_sym_PIPE] = ACTIONS(2698),
    [anon_sym_AMP] = ACTIONS(2698),
    [anon_sym_CARET] = ACTIONS(2698),
    [anon_sym_LT_LT] = ACTIONS(2698),
    [anon_sym_LT] = ACTIONS(2700),
    [anon_sym_LT_EQ] = ACTIONS(2698),
    [anon_sym_EQ_EQ] = ACTIONS(2698),
    [anon_sym_BANG_EQ] = ACTIONS(2698),
    [anon_sym_GT_EQ] = ACTIONS(2698),
    [anon_sym_GT] = ACTIONS(2700),
    [anon_sym_LT_GT] = ACTIONS(2698),
    [anon_sym_is] = ACTIONS(2698),
    [anon_sym_LBRACK] = ACTIONS(2698),
    [anon_sym_RBRACK] = ACTIONS(2698),
    [anon_sym_RBRACE] = ACTIONS(2698),
    [sym_comment] = ACTIONS(72),
  },
  [1049] = {
    [anon_sym_DOT] = ACTIONS(2771),
    [anon_sym_LPAREN] = ACTIONS(2771),
    [anon_sym_RPAREN] = ACTIONS(2771),
    [anon_sym_COMMA] = ACTIONS(2771),
    [anon_sym_as] = ACTIONS(2773),
    [anon_sym_STAR] = ACTIONS(2773),
    [anon_sym_GT_GT] = ACTIONS(2771),
    [anon_sym_if] = ACTIONS(2771),
    [anon_sym_COLON] = ACTIONS(2771),
    [anon_sym_else] = ACTIONS(2771),
    [anon_sym_async] = ACTIONS(2771),
    [anon_sym_for] = ACTIONS(2771),
    [anon_sym_in] = ACTIONS(2771),
    [anon_sym_EQ] = ACTIONS(2773),
    [anon_sym_AT] = ACTIONS(2771),
    [anon_sym_not] = ACTIONS(2771),
    [anon_sym_and] = ACTIONS(2771),
    [anon_sym_or] = ACTIONS(2771),
    [anon_sym_PLUS] = ACTIONS(2771),
    [anon_sym_DASH] = ACTIONS(2771),
    [anon_sym_SLASH] = ACTIONS(2773),
    [anon_sym_PERCENT] = ACTIONS(2771),
    [anon_sym_SLASH_SLASH] = ACTIONS(2771),
    [anon_sym_STAR_STAR] = ACTIONS(2771),
    [anon_sym_PIPE] = ACTIONS(2771),
    [anon_sym_AMP] = ACTIONS(2771),
    [anon_sym_CARET] = ACTIONS(2771),
    [anon_sym_LT_LT] = ACTIONS(2771),
    [anon_sym_LT] = ACTIONS(2773),
    [anon_sym_LT_EQ] = ACTIONS(2771),
    [anon_sym_EQ_EQ] = ACTIONS(2771),
    [anon_sym_BANG_EQ] = ACTIONS(2771),
    [anon_sym_GT_EQ] = ACTIONS(2771),
    [anon_sym_GT] = ACTIONS(2773),
    [anon_sym_LT_GT] = ACTIONS(2771),
    [anon_sym_is] = ACTIONS(2771),
    [anon_sym_LBRACK] = ACTIONS(2771),
    [anon_sym_RBRACK] = ACTIONS(2771),
    [anon_sym_RBRACE] = ACTIONS(2771),
    [sym_comment] = ACTIONS(72),
  },
  [1050] = {
    [sym_list_splat] = STATE(870),
    [sym__expression] = STATE(914),
    [sym__primary_expression] = STATE(463),
    [sym_not_operator] = STATE(914),
    [sym_boolean_operator] = STATE(914),
    [sym_binary_operator] = STATE(463),
    [sym_unary_operator] = STATE(463),
    [sym_comparison_operator] = STATE(914),
    [sym_lambda] = STATE(914),
    [sym_attribute] = STATE(463),
    [sym_subscript] = STATE(463),
    [sym_call] = STATE(463),
    [sym_list] = STATE(463),
    [sym_list_comprehension] = STATE(463),
    [sym_dictionary] = STATE(463),
    [sym_dictionary_comprehension] = STATE(463),
    [sym_set] = STATE(463),
    [sym_set_comprehension] = STATE(463),
    [sym_parenthesized_expression] = STATE(463),
    [sym_tuple] = STATE(463),
    [sym_generator_expression] = STATE(463),
    [sym_conditional_expression] = STATE(914),
    [sym_concatenated_string] = STATE(463),
    [sym_await] = STATE(914),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_STAR] = ACTIONS(1792),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_not] = ACTIONS(822),
    [anon_sym_PLUS] = ACTIONS(824),
    [anon_sym_DASH] = ACTIONS(824),
    [anon_sym_TILDE] = ACTIONS(824),
    [anon_sym_lambda] = ACTIONS(826),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(828),
    [anon_sym_LBRACE] = ACTIONS(100),
    [anon_sym_RBRACE] = ACTIONS(3039),
    [sym_string] = ACTIONS(830),
    [sym_integer] = ACTIONS(832),
    [sym_float] = ACTIONS(832),
    [sym_identifier] = ACTIONS(832),
    [sym_true] = ACTIONS(832),
    [sym_false] = ACTIONS(832),
    [sym_none] = ACTIONS(832),
    [anon_sym_await] = ACTIONS(834),
    [sym_comment] = ACTIONS(72),
  },
  [1051] = {
    [anon_sym_DOT] = ACTIONS(2780),
    [anon_sym_LPAREN] = ACTIONS(2780),
    [anon_sym_RPAREN] = ACTIONS(2780),
    [anon_sym_COMMA] = ACTIONS(2780),
    [anon_sym_as] = ACTIONS(2782),
    [anon_sym_STAR] = ACTIONS(2782),
    [anon_sym_GT_GT] = ACTIONS(2780),
    [anon_sym_if] = ACTIONS(2780),
    [anon_sym_COLON] = ACTIONS(2780),
    [anon_sym_else] = ACTIONS(2780),
    [anon_sym_async] = ACTIONS(2780),
    [anon_sym_for] = ACTIONS(2780),
    [anon_sym_in] = ACTIONS(2780),
    [anon_sym_EQ] = ACTIONS(2782),
    [anon_sym_AT] = ACTIONS(2780),
    [anon_sym_not] = ACTIONS(2780),
    [anon_sym_and] = ACTIONS(2780),
    [anon_sym_or] = ACTIONS(2780),
    [anon_sym_PLUS] = ACTIONS(2780),
    [anon_sym_DASH] = ACTIONS(2780),
    [anon_sym_SLASH] = ACTIONS(2782),
    [anon_sym_PERCENT] = ACTIONS(2780),
    [anon_sym_SLASH_SLASH] = ACTIONS(2780),
    [anon_sym_STAR_STAR] = ACTIONS(2780),
    [anon_sym_PIPE] = ACTIONS(2780),
    [anon_sym_AMP] = ACTIONS(2780),
    [anon_sym_CARET] = ACTIONS(2780),
    [anon_sym_LT_LT] = ACTIONS(2780),
    [anon_sym_LT] = ACTIONS(2782),
    [anon_sym_LT_EQ] = ACTIONS(2780),
    [anon_sym_EQ_EQ] = ACTIONS(2780),
    [anon_sym_BANG_EQ] = ACTIONS(2780),
    [anon_sym_GT_EQ] = ACTIONS(2780),
    [anon_sym_GT] = ACTIONS(2782),
    [anon_sym_LT_GT] = ACTIONS(2780),
    [anon_sym_is] = ACTIONS(2780),
    [anon_sym_LBRACK] = ACTIONS(2780),
    [anon_sym_RBRACK] = ACTIONS(2780),
    [anon_sym_RBRACE] = ACTIONS(2780),
    [sym_comment] = ACTIONS(72),
  },
  [1052] = {
    [sym_dictionary_splat] = STATE(919),
    [sym__expression] = STATE(920),
    [sym__primary_expression] = STATE(96),
    [sym_not_operator] = STATE(920),
    [sym_boolean_operator] = STATE(920),
    [sym_binary_operator] = STATE(96),
    [sym_unary_operator] = STATE(96),
    [sym_comparison_operator] = STATE(920),
    [sym_lambda] = STATE(920),
    [sym_attribute] = STATE(96),
    [sym_subscript] = STATE(96),
    [sym_call] = STATE(96),
    [sym_list] = STATE(96),
    [sym_list_comprehension] = STATE(96),
    [sym_dictionary] = STATE(96),
    [sym_dictionary_comprehension] = STATE(96),
    [sym_pair] = STATE(919),
    [sym_set] = STATE(96),
    [sym_set_comprehension] = STATE(96),
    [sym_parenthesized_expression] = STATE(96),
    [sym_tuple] = STATE(96),
    [sym_generator_expression] = STATE(96),
    [sym_conditional_expression] = STATE(920),
    [sym_concatenated_string] = STATE(96),
    [sym_await] = STATE(920),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_STAR] = ACTIONS(1802),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_not] = ACTIONS(160),
    [anon_sym_PLUS] = ACTIONS(162),
    [anon_sym_DASH] = ACTIONS(162),
    [anon_sym_TILDE] = ACTIONS(162),
    [anon_sym_lambda] = ACTIONS(164),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(166),
    [anon_sym_LBRACE] = ACTIONS(100),
    [anon_sym_RBRACE] = ACTIONS(3041),
    [sym_string] = ACTIONS(168),
    [sym_integer] = ACTIONS(170),
    [sym_float] = ACTIONS(170),
    [sym_identifier] = ACTIONS(170),
    [sym_true] = ACTIONS(170),
    [sym_false] = ACTIONS(170),
    [sym_none] = ACTIONS(170),
    [anon_sym_await] = ACTIONS(172),
    [sym_comment] = ACTIONS(72),
  },
  [1053] = {
    [anon_sym_DOT] = ACTIONS(2833),
    [anon_sym_LPAREN] = ACTIONS(2833),
    [anon_sym_RPAREN] = ACTIONS(2833),
    [anon_sym_COMMA] = ACTIONS(2833),
    [anon_sym_as] = ACTIONS(2835),
    [anon_sym_STAR] = ACTIONS(2835),
    [anon_sym_GT_GT] = ACTIONS(2833),
    [anon_sym_if] = ACTIONS(2833),
    [anon_sym_COLON] = ACTIONS(2833),
    [anon_sym_else] = ACTIONS(2833),
    [anon_sym_async] = ACTIONS(2833),
    [anon_sym_for] = ACTIONS(2833),
    [anon_sym_in] = ACTIONS(2833),
    [anon_sym_EQ] = ACTIONS(2835),
    [anon_sym_AT] = ACTIONS(2833),
    [anon_sym_not] = ACTIONS(2833),
    [anon_sym_and] = ACTIONS(2833),
    [anon_sym_or] = ACTIONS(2833),
    [anon_sym_PLUS] = ACTIONS(2833),
    [anon_sym_DASH] = ACTIONS(2833),
    [anon_sym_SLASH] = ACTIONS(2835),
    [anon_sym_PERCENT] = ACTIONS(2833),
    [anon_sym_SLASH_SLASH] = ACTIONS(2833),
    [anon_sym_STAR_STAR] = ACTIONS(2833),
    [anon_sym_PIPE] = ACTIONS(2833),
    [anon_sym_AMP] = ACTIONS(2833),
    [anon_sym_CARET] = ACTIONS(2833),
    [anon_sym_LT_LT] = ACTIONS(2833),
    [anon_sym_LT] = ACTIONS(2835),
    [anon_sym_LT_EQ] = ACTIONS(2833),
    [anon_sym_EQ_EQ] = ACTIONS(2833),
    [anon_sym_BANG_EQ] = ACTIONS(2833),
    [anon_sym_GT_EQ] = ACTIONS(2833),
    [anon_sym_GT] = ACTIONS(2835),
    [anon_sym_LT_GT] = ACTIONS(2833),
    [anon_sym_is] = ACTIONS(2833),
    [anon_sym_LBRACK] = ACTIONS(2833),
    [anon_sym_RBRACK] = ACTIONS(2833),
    [anon_sym_RBRACE] = ACTIONS(2833),
    [sym_comment] = ACTIONS(72),
  },
  [1054] = {
    [anon_sym_DOT] = ACTIONS(2867),
    [anon_sym_LPAREN] = ACTIONS(2867),
    [anon_sym_RPAREN] = ACTIONS(2867),
    [anon_sym_COMMA] = ACTIONS(2867),
    [anon_sym_as] = ACTIONS(2869),
    [anon_sym_STAR] = ACTIONS(2869),
    [anon_sym_GT_GT] = ACTIONS(2867),
    [anon_sym_if] = ACTIONS(2867),
    [anon_sym_COLON] = ACTIONS(2867),
    [anon_sym_else] = ACTIONS(2867),
    [anon_sym_async] = ACTIONS(2867),
    [anon_sym_for] = ACTIONS(2867),
    [anon_sym_in] = ACTIONS(2867),
    [anon_sym_EQ] = ACTIONS(2869),
    [anon_sym_AT] = ACTIONS(2867),
    [anon_sym_not] = ACTIONS(2867),
    [anon_sym_and] = ACTIONS(2867),
    [anon_sym_or] = ACTIONS(2867),
    [anon_sym_PLUS] = ACTIONS(2867),
    [anon_sym_DASH] = ACTIONS(2867),
    [anon_sym_SLASH] = ACTIONS(2869),
    [anon_sym_PERCENT] = ACTIONS(2867),
    [anon_sym_SLASH_SLASH] = ACTIONS(2867),
    [anon_sym_STAR_STAR] = ACTIONS(2867),
    [anon_sym_PIPE] = ACTIONS(2867),
    [anon_sym_AMP] = ACTIONS(2867),
    [anon_sym_CARET] = ACTIONS(2867),
    [anon_sym_LT_LT] = ACTIONS(2867),
    [anon_sym_LT] = ACTIONS(2869),
    [anon_sym_LT_EQ] = ACTIONS(2867),
    [anon_sym_EQ_EQ] = ACTIONS(2867),
    [anon_sym_BANG_EQ] = ACTIONS(2867),
    [anon_sym_GT_EQ] = ACTIONS(2867),
    [anon_sym_GT] = ACTIONS(2869),
    [anon_sym_LT_GT] = ACTIONS(2867),
    [anon_sym_is] = ACTIONS(2867),
    [anon_sym_LBRACK] = ACTIONS(2867),
    [anon_sym_RBRACK] = ACTIONS(2867),
    [anon_sym_RBRACE] = ACTIONS(2867),
    [sym_comment] = ACTIONS(72),
  },
  [1055] = {
    [sym__expression] = STATE(1401),
    [sym__primary_expression] = STATE(59),
    [sym_not_operator] = STATE(1401),
    [sym_boolean_operator] = STATE(1401),
    [sym_binary_operator] = STATE(59),
    [sym_unary_operator] = STATE(59),
    [sym_comparison_operator] = STATE(1401),
    [sym_lambda] = STATE(1401),
    [sym_attribute] = STATE(59),
    [sym_subscript] = STATE(59),
    [sym_call] = STATE(59),
    [sym_list] = STATE(59),
    [sym_list_comprehension] = STATE(59),
    [sym_dictionary] = STATE(59),
    [sym_dictionary_comprehension] = STATE(59),
    [sym_set] = STATE(59),
    [sym_set_comprehension] = STATE(59),
    [sym_parenthesized_expression] = STATE(59),
    [sym_tuple] = STATE(59),
    [sym_generator_expression] = STATE(59),
    [sym_conditional_expression] = STATE(1401),
    [sym_concatenated_string] = STATE(59),
    [sym_await] = STATE(1401),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_not] = ACTIONS(88),
    [anon_sym_PLUS] = ACTIONS(90),
    [anon_sym_DASH] = ACTIONS(90),
    [anon_sym_TILDE] = ACTIONS(90),
    [anon_sym_lambda] = ACTIONS(92),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(98),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(102),
    [sym_integer] = ACTIONS(104),
    [sym_float] = ACTIONS(104),
    [sym_identifier] = ACTIONS(104),
    [sym_true] = ACTIONS(104),
    [sym_false] = ACTIONS(104),
    [sym_none] = ACTIONS(104),
    [anon_sym_await] = ACTIONS(106),
    [sym_comment] = ACTIONS(72),
  },
  [1056] = {
    [anon_sym_in] = ACTIONS(3043),
    [sym_comment] = ACTIONS(72),
  },
  [1057] = {
    [sym__expression_within_for_in_clause] = STATE(1404),
    [sym__expression] = STATE(1405),
    [sym__primary_expression] = STATE(59),
    [sym_not_operator] = STATE(1405),
    [sym_boolean_operator] = STATE(1405),
    [sym_binary_operator] = STATE(59),
    [sym_unary_operator] = STATE(59),
    [sym_comparison_operator] = STATE(1405),
    [sym_lambda] = STATE(1405),
    [sym_lambda_within_for_in_clause] = STATE(1406),
    [sym_attribute] = STATE(59),
    [sym_subscript] = STATE(59),
    [sym_call] = STATE(59),
    [sym_list] = STATE(59),
    [sym_list_comprehension] = STATE(59),
    [sym_dictionary] = STATE(59),
    [sym_dictionary_comprehension] = STATE(59),
    [sym_set] = STATE(59),
    [sym_set_comprehension] = STATE(59),
    [sym_parenthesized_expression] = STATE(59),
    [sym_tuple] = STATE(59),
    [sym_generator_expression] = STATE(59),
    [sym_conditional_expression] = STATE(1405),
    [sym_concatenated_string] = STATE(59),
    [sym_await] = STATE(1405),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_not] = ACTIONS(88),
    [anon_sym_PLUS] = ACTIONS(90),
    [anon_sym_DASH] = ACTIONS(90),
    [anon_sym_TILDE] = ACTIONS(90),
    [anon_sym_lambda] = ACTIONS(3045),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(98),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(102),
    [sym_integer] = ACTIONS(104),
    [sym_float] = ACTIONS(104),
    [sym_identifier] = ACTIONS(104),
    [sym_true] = ACTIONS(104),
    [sym_false] = ACTIONS(104),
    [sym_none] = ACTIONS(104),
    [anon_sym_await] = ACTIONS(106),
    [sym_comment] = ACTIONS(72),
  },
  [1058] = {
    [sym__expression] = STATE(1407),
    [sym__primary_expression] = STATE(1064),
    [sym_not_operator] = STATE(1407),
    [sym_boolean_operator] = STATE(1407),
    [sym_binary_operator] = STATE(1064),
    [sym_unary_operator] = STATE(1064),
    [sym_comparison_operator] = STATE(1407),
    [sym_lambda] = STATE(1407),
    [sym_attribute] = STATE(1064),
    [sym_subscript] = STATE(1064),
    [sym_call] = STATE(1064),
    [sym_list] = STATE(1064),
    [sym_list_comprehension] = STATE(1064),
    [sym_dictionary] = STATE(1064),
    [sym_dictionary_comprehension] = STATE(1064),
    [sym_set] = STATE(1064),
    [sym_set_comprehension] = STATE(1064),
    [sym_parenthesized_expression] = STATE(1064),
    [sym_tuple] = STATE(1064),
    [sym_generator_expression] = STATE(1064),
    [sym_conditional_expression] = STATE(1407),
    [sym_concatenated_string] = STATE(1064),
    [sym_await] = STATE(1407),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_not] = ACTIONS(2152),
    [anon_sym_PLUS] = ACTIONS(2154),
    [anon_sym_DASH] = ACTIONS(2154),
    [anon_sym_TILDE] = ACTIONS(2154),
    [anon_sym_lambda] = ACTIONS(2156),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(2158),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(2160),
    [sym_integer] = ACTIONS(2162),
    [sym_float] = ACTIONS(2162),
    [sym_identifier] = ACTIONS(2162),
    [sym_true] = ACTIONS(2162),
    [sym_false] = ACTIONS(2162),
    [sym_none] = ACTIONS(2162),
    [anon_sym_await] = ACTIONS(2164),
    [sym_comment] = ACTIONS(72),
  },
  [1059] = {
    [sym__primary_expression] = STATE(204),
    [sym_binary_operator] = STATE(204),
    [sym_unary_operator] = STATE(204),
    [sym_attribute] = STATE(204),
    [sym_subscript] = STATE(204),
    [sym_call] = STATE(204),
    [sym_list] = STATE(204),
    [sym_list_comprehension] = STATE(204),
    [sym_dictionary] = STATE(204),
    [sym_dictionary_comprehension] = STATE(204),
    [sym_set] = STATE(204),
    [sym_set_comprehension] = STATE(204),
    [sym_parenthesized_expression] = STATE(204),
    [sym_tuple] = STATE(204),
    [sym_generator_expression] = STATE(204),
    [sym_concatenated_string] = STATE(204),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_PLUS] = ACTIONS(2154),
    [anon_sym_DASH] = ACTIONS(2154),
    [anon_sym_TILDE] = ACTIONS(2154),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(376),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(2160),
    [sym_integer] = ACTIONS(378),
    [sym_float] = ACTIONS(378),
    [sym_identifier] = ACTIONS(378),
    [sym_true] = ACTIONS(378),
    [sym_false] = ACTIONS(378),
    [sym_none] = ACTIONS(378),
    [sym_comment] = ACTIONS(72),
  },
  [1060] = {
    [sym_lambda_parameters] = STATE(1409),
    [sym__parameters] = STATE(130),
    [sym_default_parameter] = STATE(131),
    [sym_typed_default_parameter] = STATE(131),
    [sym_list_splat] = STATE(132),
    [sym_dictionary_splat] = STATE(132),
    [sym_typed_parameter] = STATE(131),
    [sym_tuple] = STATE(131),
    [anon_sym_LPAREN] = ACTIONS(222),
    [anon_sym_STAR] = ACTIONS(224),
    [anon_sym_print] = ACTIONS(226),
    [anon_sym_COLON] = ACTIONS(3047),
    [anon_sym_exec] = ACTIONS(226),
    [sym_identifier] = ACTIONS(230),
    [sym_comment] = ACTIONS(72),
  },
  [1061] = {
    [aux_sym_concatenated_string_repeat1] = STATE(1410),
    [anon_sym_DOT] = ACTIONS(276),
    [anon_sym_LPAREN] = ACTIONS(276),
    [anon_sym_RPAREN] = ACTIONS(276),
    [anon_sym_STAR] = ACTIONS(278),
    [anon_sym_GT_GT] = ACTIONS(276),
    [anon_sym_if] = ACTIONS(276),
    [anon_sym_async] = ACTIONS(276),
    [anon_sym_for] = ACTIONS(276),
    [anon_sym_in] = ACTIONS(276),
    [anon_sym_AT] = ACTIONS(276),
    [anon_sym_not] = ACTIONS(276),
    [anon_sym_and] = ACTIONS(276),
    [anon_sym_or] = ACTIONS(276),
    [anon_sym_PLUS] = ACTIONS(276),
    [anon_sym_DASH] = ACTIONS(276),
    [anon_sym_SLASH] = ACTIONS(278),
    [anon_sym_PERCENT] = ACTIONS(276),
    [anon_sym_SLASH_SLASH] = ACTIONS(276),
    [anon_sym_STAR_STAR] = ACTIONS(276),
    [anon_sym_PIPE] = ACTIONS(276),
    [anon_sym_AMP] = ACTIONS(276),
    [anon_sym_CARET] = ACTIONS(276),
    [anon_sym_LT_LT] = ACTIONS(276),
    [anon_sym_LT] = ACTIONS(278),
    [anon_sym_LT_EQ] = ACTIONS(276),
    [anon_sym_EQ_EQ] = ACTIONS(276),
    [anon_sym_BANG_EQ] = ACTIONS(276),
    [anon_sym_GT_EQ] = ACTIONS(276),
    [anon_sym_GT] = ACTIONS(278),
    [anon_sym_LT_GT] = ACTIONS(276),
    [anon_sym_is] = ACTIONS(276),
    [anon_sym_LBRACK] = ACTIONS(276),
    [sym_string] = ACTIONS(3049),
    [sym_comment] = ACTIONS(72),
  },
  [1062] = {
    [sym__expression] = STATE(227),
    [sym__primary_expression] = STATE(1064),
    [sym_not_operator] = STATE(227),
    [sym_boolean_operator] = STATE(227),
    [sym_binary_operator] = STATE(1064),
    [sym_unary_operator] = STATE(1064),
    [sym_comparison_operator] = STATE(227),
    [sym_lambda] = STATE(227),
    [sym_attribute] = STATE(1064),
    [sym_subscript] = STATE(1064),
    [sym_call] = STATE(1064),
    [sym_list] = STATE(1064),
    [sym_list_comprehension] = STATE(1064),
    [sym_dictionary] = STATE(1064),
    [sym_dictionary_comprehension] = STATE(1064),
    [sym_set] = STATE(1064),
    [sym_set_comprehension] = STATE(1064),
    [sym_parenthesized_expression] = STATE(1064),
    [sym_tuple] = STATE(1064),
    [sym_generator_expression] = STATE(1064),
    [sym_conditional_expression] = STATE(227),
    [sym_concatenated_string] = STATE(1064),
    [sym_await] = STATE(227),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_not] = ACTIONS(2152),
    [anon_sym_PLUS] = ACTIONS(2154),
    [anon_sym_DASH] = ACTIONS(2154),
    [anon_sym_TILDE] = ACTIONS(2154),
    [anon_sym_lambda] = ACTIONS(2156),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(2158),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(2160),
    [sym_integer] = ACTIONS(2162),
    [sym_float] = ACTIONS(2162),
    [sym_identifier] = ACTIONS(2162),
    [sym_true] = ACTIONS(2162),
    [sym_false] = ACTIONS(2162),
    [sym_none] = ACTIONS(2162),
    [anon_sym_await] = ACTIONS(2164),
    [sym_comment] = ACTIONS(72),
  },
  [1063] = {
    [anon_sym_RPAREN] = ACTIONS(3051),
    [anon_sym_if] = ACTIONS(3051),
    [anon_sym_async] = ACTIONS(3051),
    [anon_sym_for] = ACTIONS(3051),
    [anon_sym_and] = ACTIONS(3053),
    [anon_sym_or] = ACTIONS(3055),
    [sym_comment] = ACTIONS(72),
  },
  [1064] = {
    [sym_argument_list] = STATE(251),
    [sym_generator_expression] = STATE(251),
    [aux_sym_comparison_operator_repeat1] = STATE(1424),
    [anon_sym_DOT] = ACTIONS(422),
    [anon_sym_LPAREN] = ACTIONS(424),
    [anon_sym_RPAREN] = ACTIONS(302),
    [anon_sym_STAR] = ACTIONS(3057),
    [anon_sym_GT_GT] = ACTIONS(3059),
    [anon_sym_if] = ACTIONS(302),
    [anon_sym_async] = ACTIONS(302),
    [anon_sym_for] = ACTIONS(302),
    [anon_sym_in] = ACTIONS(3061),
    [anon_sym_AT] = ACTIONS(3063),
    [anon_sym_not] = ACTIONS(3065),
    [anon_sym_and] = ACTIONS(302),
    [anon_sym_or] = ACTIONS(302),
    [anon_sym_PLUS] = ACTIONS(3067),
    [anon_sym_DASH] = ACTIONS(3067),
    [anon_sym_SLASH] = ACTIONS(3057),
    [anon_sym_PERCENT] = ACTIONS(3063),
    [anon_sym_SLASH_SLASH] = ACTIONS(3063),
    [anon_sym_STAR_STAR] = ACTIONS(3069),
    [anon_sym_PIPE] = ACTIONS(3071),
    [anon_sym_AMP] = ACTIONS(3073),
    [anon_sym_CARET] = ACTIONS(3075),
    [anon_sym_LT_LT] = ACTIONS(3059),
    [anon_sym_LT] = ACTIONS(3077),
    [anon_sym_LT_EQ] = ACTIONS(3061),
    [anon_sym_EQ_EQ] = ACTIONS(3061),
    [anon_sym_BANG_EQ] = ACTIONS(3061),
    [anon_sym_GT_EQ] = ACTIONS(3061),
    [anon_sym_GT] = ACTIONS(3077),
    [anon_sym_LT_GT] = ACTIONS(3061),
    [anon_sym_is] = ACTIONS(3079),
    [anon_sym_LBRACK] = ACTIONS(450),
    [sym_comment] = ACTIONS(72),
  },
  [1065] = {
    [sym_for_in_clause] = STATE(1065),
    [sym_if_clause] = STATE(1065),
    [aux_sym__comprehension_body_repeat1] = STATE(1065),
    [anon_sym_RPAREN] = ACTIONS(3081),
    [anon_sym_if] = ACTIONS(3083),
    [anon_sym_async] = ACTIONS(3086),
    [anon_sym_for] = ACTIONS(3089),
    [sym_comment] = ACTIONS(72),
  },
  [1066] = {
    [sym__newline] = ACTIONS(3092),
    [anon_sym_DOT] = ACTIONS(3092),
    [anon_sym_LPAREN] = ACTIONS(3092),
    [anon_sym_COMMA] = ACTIONS(3092),
    [anon_sym_STAR] = ACTIONS(3094),
    [anon_sym_GT_GT] = ACTIONS(3094),
    [anon_sym_if] = ACTIONS(3092),
    [anon_sym_COLON] = ACTIONS(3092),
    [anon_sym_in] = ACTIONS(3092),
    [anon_sym_EQ] = ACTIONS(3094),
    [anon_sym_AT] = ACTIONS(3094),
    [anon_sym_not] = ACTIONS(3092),
    [anon_sym_and] = ACTIONS(3092),
    [anon_sym_or] = ACTIONS(3092),
    [anon_sym_PLUS] = ACTIONS(3094),
    [anon_sym_DASH] = ACTIONS(3094),
    [anon_sym_SLASH] = ACTIONS(3094),
    [anon_sym_PERCENT] = ACTIONS(3094),
    [anon_sym_SLASH_SLASH] = ACTIONS(3094),
    [anon_sym_STAR_STAR] = ACTIONS(3094),
    [anon_sym_PIPE] = ACTIONS(3094),
    [anon_sym_AMP] = ACTIONS(3094),
    [anon_sym_CARET] = ACTIONS(3094),
    [anon_sym_LT_LT] = ACTIONS(3094),
    [anon_sym_LT] = ACTIONS(3094),
    [anon_sym_LT_EQ] = ACTIONS(3092),
    [anon_sym_EQ_EQ] = ACTIONS(3092),
    [anon_sym_BANG_EQ] = ACTIONS(3092),
    [anon_sym_GT_EQ] = ACTIONS(3092),
    [anon_sym_GT] = ACTIONS(3094),
    [anon_sym_LT_GT] = ACTIONS(3092),
    [anon_sym_is] = ACTIONS(3092),
    [anon_sym_PLUS_EQ] = ACTIONS(3092),
    [anon_sym_DASH_EQ] = ACTIONS(3092),
    [anon_sym_STAR_EQ] = ACTIONS(3092),
    [anon_sym_SLASH_EQ] = ACTIONS(3092),
    [anon_sym_AT_EQ] = ACTIONS(3092),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3092),
    [anon_sym_PERCENT_EQ] = ACTIONS(3092),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3092),
    [anon_sym_GT_GT_EQ] = ACTIONS(3092),
    [anon_sym_LT_LT_EQ] = ACTIONS(3092),
    [anon_sym_AMP_EQ] = ACTIONS(3092),
    [anon_sym_CARET_EQ] = ACTIONS(3092),
    [anon_sym_PIPE_EQ] = ACTIONS(3092),
    [anon_sym_LBRACK] = ACTIONS(3092),
    [sym_comment] = ACTIONS(72),
    [sym__semicolon] = ACTIONS(3092),
  },
  [1067] = {
    [sym__expression] = STATE(599),
    [sym__primary_expression] = STATE(215),
    [sym_not_operator] = STATE(599),
    [sym_boolean_operator] = STATE(599),
    [sym_binary_operator] = STATE(215),
    [sym_unary_operator] = STATE(215),
    [sym_comparison_operator] = STATE(599),
    [sym_lambda] = STATE(599),
    [sym_yield] = STATE(600),
    [sym_attribute] = STATE(215),
    [sym_subscript] = STATE(215),
    [sym_call] = STATE(215),
    [sym_list] = STATE(215),
    [sym_list_comprehension] = STATE(215),
    [sym_dictionary] = STATE(215),
    [sym_dictionary_comprehension] = STATE(215),
    [sym_set] = STATE(215),
    [sym_set_comprehension] = STATE(215),
    [sym_parenthesized_expression] = STATE(215),
    [sym_tuple] = STATE(215),
    [sym_generator_expression] = STATE(215),
    [sym_conditional_expression] = STATE(599),
    [sym_concatenated_string] = STATE(215),
    [sym_await] = STATE(599),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_not] = ACTIONS(384),
    [anon_sym_PLUS] = ACTIONS(386),
    [anon_sym_DASH] = ACTIONS(386),
    [anon_sym_TILDE] = ACTIONS(386),
    [anon_sym_lambda] = ACTIONS(388),
    [anon_sym_yield] = ACTIONS(94),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(390),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(392),
    [sym_integer] = ACTIONS(394),
    [sym_float] = ACTIONS(394),
    [sym_identifier] = ACTIONS(394),
    [sym_true] = ACTIONS(394),
    [sym_false] = ACTIONS(394),
    [sym_none] = ACTIONS(394),
    [anon_sym_await] = ACTIONS(396),
    [sym_comment] = ACTIONS(72),
  },
  [1068] = {
    [anon_sym_DOT] = ACTIONS(2945),
    [anon_sym_LPAREN] = ACTIONS(2945),
    [anon_sym_RPAREN] = ACTIONS(2945),
    [anon_sym_COMMA] = ACTIONS(2945),
    [anon_sym_as] = ACTIONS(2947),
    [anon_sym_STAR] = ACTIONS(2947),
    [anon_sym_GT_GT] = ACTIONS(2945),
    [anon_sym_if] = ACTIONS(2945),
    [anon_sym_COLON] = ACTIONS(2945),
    [anon_sym_else] = ACTIONS(2945),
    [anon_sym_async] = ACTIONS(2945),
    [anon_sym_for] = ACTIONS(2945),
    [anon_sym_in] = ACTIONS(2945),
    [anon_sym_EQ] = ACTIONS(2947),
    [anon_sym_AT] = ACTIONS(2945),
    [anon_sym_not] = ACTIONS(2945),
    [anon_sym_and] = ACTIONS(2945),
    [anon_sym_or] = ACTIONS(2945),
    [anon_sym_PLUS] = ACTIONS(2945),
    [anon_sym_DASH] = ACTIONS(2945),
    [anon_sym_SLASH] = ACTIONS(2947),
    [anon_sym_PERCENT] = ACTIONS(2945),
    [anon_sym_SLASH_SLASH] = ACTIONS(2945),
    [anon_sym_STAR_STAR] = ACTIONS(2945),
    [anon_sym_PIPE] = ACTIONS(2945),
    [anon_sym_AMP] = ACTIONS(2945),
    [anon_sym_CARET] = ACTIONS(2945),
    [anon_sym_LT_LT] = ACTIONS(2945),
    [anon_sym_LT] = ACTIONS(2947),
    [anon_sym_LT_EQ] = ACTIONS(2945),
    [anon_sym_EQ_EQ] = ACTIONS(2945),
    [anon_sym_BANG_EQ] = ACTIONS(2945),
    [anon_sym_GT_EQ] = ACTIONS(2945),
    [anon_sym_GT] = ACTIONS(2947),
    [anon_sym_LT_GT] = ACTIONS(2945),
    [anon_sym_is] = ACTIONS(2945),
    [anon_sym_LBRACK] = ACTIONS(2945),
    [anon_sym_RBRACK] = ACTIONS(2945),
    [anon_sym_RBRACE] = ACTIONS(2945),
    [sym_comment] = ACTIONS(72),
  },
  [1069] = {
    [sym_list_splat] = STATE(1362),
    [sym_dictionary_splat] = STATE(1362),
    [sym__expression] = STATE(1363),
    [sym__primary_expression] = STATE(215),
    [sym_not_operator] = STATE(1363),
    [sym_boolean_operator] = STATE(1363),
    [sym_binary_operator] = STATE(215),
    [sym_unary_operator] = STATE(215),
    [sym_comparison_operator] = STATE(1363),
    [sym_lambda] = STATE(1363),
    [sym_attribute] = STATE(215),
    [sym_subscript] = STATE(215),
    [sym_call] = STATE(215),
    [sym_keyword_argument] = STATE(1362),
    [sym_list] = STATE(215),
    [sym_list_comprehension] = STATE(215),
    [sym_dictionary] = STATE(215),
    [sym_dictionary_comprehension] = STATE(215),
    [sym_set] = STATE(215),
    [sym_set_comprehension] = STATE(215),
    [sym_parenthesized_expression] = STATE(215),
    [sym_tuple] = STATE(215),
    [sym_generator_expression] = STATE(215),
    [sym_conditional_expression] = STATE(1363),
    [sym_concatenated_string] = STATE(215),
    [sym_await] = STATE(1363),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_RPAREN] = ACTIONS(3096),
    [anon_sym_STAR] = ACTIONS(936),
    [anon_sym_print] = ACTIONS(938),
    [anon_sym_exec] = ACTIONS(938),
    [anon_sym_not] = ACTIONS(384),
    [anon_sym_PLUS] = ACTIONS(386),
    [anon_sym_DASH] = ACTIONS(386),
    [anon_sym_TILDE] = ACTIONS(386),
    [anon_sym_lambda] = ACTIONS(388),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(390),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(392),
    [sym_integer] = ACTIONS(394),
    [sym_float] = ACTIONS(394),
    [sym_identifier] = ACTIONS(940),
    [sym_true] = ACTIONS(394),
    [sym_false] = ACTIONS(394),
    [sym_none] = ACTIONS(394),
    [anon_sym_await] = ACTIONS(396),
    [sym_comment] = ACTIONS(72),
  },
  [1070] = {
    [aux_sym_argument_list_repeat1] = STATE(1365),
    [anon_sym_RPAREN] = ACTIONS(3096),
    [anon_sym_COMMA] = ACTIONS(3098),
    [sym_comment] = ACTIONS(72),
  },
  [1071] = {
    [sym_argument_list] = STATE(251),
    [sym_generator_expression] = STATE(251),
    [anon_sym_DOT] = ACTIONS(422),
    [anon_sym_LPAREN] = ACTIONS(424),
    [anon_sym_RPAREN] = ACTIONS(2953),
    [anon_sym_COMMA] = ACTIONS(2953),
    [anon_sym_STAR] = ACTIONS(426),
    [anon_sym_GT_GT] = ACTIONS(428),
    [anon_sym_if] = ACTIONS(2953),
    [anon_sym_async] = ACTIONS(2953),
    [anon_sym_for] = ACTIONS(2953),
    [anon_sym_in] = ACTIONS(2953),
    [anon_sym_AT] = ACTIONS(432),
    [anon_sym_not] = ACTIONS(2953),
    [anon_sym_and] = ACTIONS(2953),
    [anon_sym_or] = ACTIONS(2953),
    [anon_sym_PLUS] = ACTIONS(436),
    [anon_sym_DASH] = ACTIONS(436),
    [anon_sym_SLASH] = ACTIONS(426),
    [anon_sym_PERCENT] = ACTIONS(432),
    [anon_sym_SLASH_SLASH] = ACTIONS(432),
    [anon_sym_STAR_STAR] = ACTIONS(438),
    [anon_sym_PIPE] = ACTIONS(440),
    [anon_sym_AMP] = ACTIONS(442),
    [anon_sym_CARET] = ACTIONS(444),
    [anon_sym_LT_LT] = ACTIONS(428),
    [anon_sym_LT] = ACTIONS(2955),
    [anon_sym_LT_EQ] = ACTIONS(2953),
    [anon_sym_EQ_EQ] = ACTIONS(2953),
    [anon_sym_BANG_EQ] = ACTIONS(2953),
    [anon_sym_GT_EQ] = ACTIONS(2953),
    [anon_sym_GT] = ACTIONS(2955),
    [anon_sym_LT_GT] = ACTIONS(2953),
    [anon_sym_is] = ACTIONS(2953),
    [anon_sym_LBRACK] = ACTIONS(450),
    [sym_comment] = ACTIONS(72),
  },
  [1072] = {
    [sym__expression] = STATE(1372),
    [sym__primary_expression] = STATE(542),
    [sym_not_operator] = STATE(1372),
    [sym_boolean_operator] = STATE(1372),
    [sym_binary_operator] = STATE(542),
    [sym_unary_operator] = STATE(542),
    [sym_comparison_operator] = STATE(1372),
    [sym_lambda] = STATE(1372),
    [sym_attribute] = STATE(542),
    [sym_subscript] = STATE(542),
    [sym_slice] = STATE(1373),
    [sym_call] = STATE(542),
    [sym_list] = STATE(542),
    [sym_list_comprehension] = STATE(542),
    [sym_dictionary] = STATE(542),
    [sym_dictionary_comprehension] = STATE(542),
    [sym_set] = STATE(542),
    [sym_set_comprehension] = STATE(542),
    [sym_parenthesized_expression] = STATE(542),
    [sym_tuple] = STATE(542),
    [sym_generator_expression] = STATE(542),
    [sym_conditional_expression] = STATE(1372),
    [sym_concatenated_string] = STATE(542),
    [sym_await] = STATE(1372),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_COLON] = ACTIONS(978),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_not] = ACTIONS(980),
    [anon_sym_PLUS] = ACTIONS(982),
    [anon_sym_DASH] = ACTIONS(982),
    [anon_sym_TILDE] = ACTIONS(982),
    [anon_sym_lambda] = ACTIONS(984),
    [anon_sym_LBRACK] = ACTIONS(96),
    [anon_sym_RBRACK] = ACTIONS(3100),
    [sym_ellipsis] = ACTIONS(986),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(988),
    [sym_integer] = ACTIONS(990),
    [sym_float] = ACTIONS(990),
    [sym_identifier] = ACTIONS(990),
    [sym_true] = ACTIONS(990),
    [sym_false] = ACTIONS(990),
    [sym_none] = ACTIONS(990),
    [anon_sym_await] = ACTIONS(992),
    [sym_comment] = ACTIONS(72),
  },
  [1073] = {
    [anon_sym_DOT] = ACTIONS(2967),
    [anon_sym_LPAREN] = ACTIONS(2967),
    [anon_sym_RPAREN] = ACTIONS(2967),
    [anon_sym_COMMA] = ACTIONS(2967),
    [anon_sym_as] = ACTIONS(2969),
    [anon_sym_STAR] = ACTIONS(2969),
    [anon_sym_GT_GT] = ACTIONS(2967),
    [anon_sym_if] = ACTIONS(2967),
    [anon_sym_COLON] = ACTIONS(2967),
    [anon_sym_else] = ACTIONS(2967),
    [anon_sym_async] = ACTIONS(2967),
    [anon_sym_for] = ACTIONS(2967),
    [anon_sym_in] = ACTIONS(2967),
    [anon_sym_EQ] = ACTIONS(2969),
    [anon_sym_AT] = ACTIONS(2967),
    [anon_sym_not] = ACTIONS(2967),
    [anon_sym_and] = ACTIONS(2967),
    [anon_sym_or] = ACTIONS(2967),
    [anon_sym_PLUS] = ACTIONS(2967),
    [anon_sym_DASH] = ACTIONS(2967),
    [anon_sym_SLASH] = ACTIONS(2969),
    [anon_sym_PERCENT] = ACTIONS(2967),
    [anon_sym_SLASH_SLASH] = ACTIONS(2967),
    [anon_sym_STAR_STAR] = ACTIONS(2967),
    [anon_sym_PIPE] = ACTIONS(2967),
    [anon_sym_AMP] = ACTIONS(2967),
    [anon_sym_CARET] = ACTIONS(2967),
    [anon_sym_LT_LT] = ACTIONS(2967),
    [anon_sym_LT] = ACTIONS(2969),
    [anon_sym_LT_EQ] = ACTIONS(2967),
    [anon_sym_EQ_EQ] = ACTIONS(2967),
    [anon_sym_BANG_EQ] = ACTIONS(2967),
    [anon_sym_GT_EQ] = ACTIONS(2967),
    [anon_sym_GT] = ACTIONS(2969),
    [anon_sym_LT_GT] = ACTIONS(2967),
    [anon_sym_is] = ACTIONS(2967),
    [anon_sym_LBRACK] = ACTIONS(2967),
    [anon_sym_RBRACK] = ACTIONS(2967),
    [anon_sym_RBRACE] = ACTIONS(2967),
    [sym_comment] = ACTIONS(72),
  },
  [1074] = {
    [aux_sym_subscript_repeat1] = STATE(1378),
    [anon_sym_COMMA] = ACTIONS(3102),
    [anon_sym_RBRACK] = ACTIONS(3100),
    [sym_comment] = ACTIONS(72),
  },
  [1075] = {
    [sym__newline] = ACTIONS(2136),
    [anon_sym_DOT] = ACTIONS(2136),
    [anon_sym_from] = ACTIONS(2136),
    [anon_sym_LPAREN] = ACTIONS(2136),
    [anon_sym_COMMA] = ACTIONS(2136),
    [anon_sym_STAR] = ACTIONS(2138),
    [anon_sym_GT_GT] = ACTIONS(2136),
    [anon_sym_if] = ACTIONS(2136),
    [anon_sym_in] = ACTIONS(2136),
    [anon_sym_EQ] = ACTIONS(2138),
    [anon_sym_AT] = ACTIONS(2136),
    [anon_sym_not] = ACTIONS(2136),
    [anon_sym_and] = ACTIONS(2136),
    [anon_sym_or] = ACTIONS(2136),
    [anon_sym_PLUS] = ACTIONS(2136),
    [anon_sym_DASH] = ACTIONS(2136),
    [anon_sym_SLASH] = ACTIONS(2138),
    [anon_sym_PERCENT] = ACTIONS(2136),
    [anon_sym_SLASH_SLASH] = ACTIONS(2136),
    [anon_sym_STAR_STAR] = ACTIONS(2136),
    [anon_sym_PIPE] = ACTIONS(2136),
    [anon_sym_AMP] = ACTIONS(2136),
    [anon_sym_CARET] = ACTIONS(2136),
    [anon_sym_LT_LT] = ACTIONS(2136),
    [anon_sym_LT] = ACTIONS(2138),
    [anon_sym_LT_EQ] = ACTIONS(2136),
    [anon_sym_EQ_EQ] = ACTIONS(2136),
    [anon_sym_BANG_EQ] = ACTIONS(2136),
    [anon_sym_GT_EQ] = ACTIONS(2136),
    [anon_sym_GT] = ACTIONS(2138),
    [anon_sym_LT_GT] = ACTIONS(2136),
    [anon_sym_is] = ACTIONS(2136),
    [anon_sym_LBRACK] = ACTIONS(2136),
    [sym_comment] = ACTIONS(72),
    [sym__semicolon] = ACTIONS(2136),
  },
  [1076] = {
    [sym__newline] = ACTIONS(2148),
    [anon_sym_DOT] = ACTIONS(2148),
    [anon_sym_from] = ACTIONS(2148),
    [anon_sym_LPAREN] = ACTIONS(2148),
    [anon_sym_COMMA] = ACTIONS(2148),
    [anon_sym_STAR] = ACTIONS(2150),
    [anon_sym_GT_GT] = ACTIONS(2148),
    [anon_sym_if] = ACTIONS(2148),
    [anon_sym_in] = ACTIONS(2148),
    [anon_sym_EQ] = ACTIONS(2150),
    [anon_sym_AT] = ACTIONS(2148),
    [anon_sym_not] = ACTIONS(2148),
    [anon_sym_and] = ACTIONS(2148),
    [anon_sym_or] = ACTIONS(2148),
    [anon_sym_PLUS] = ACTIONS(2148),
    [anon_sym_DASH] = ACTIONS(2148),
    [anon_sym_SLASH] = ACTIONS(2150),
    [anon_sym_PERCENT] = ACTIONS(2148),
    [anon_sym_SLASH_SLASH] = ACTIONS(2148),
    [anon_sym_STAR_STAR] = ACTIONS(2148),
    [anon_sym_PIPE] = ACTIONS(2148),
    [anon_sym_AMP] = ACTIONS(2148),
    [anon_sym_CARET] = ACTIONS(2148),
    [anon_sym_LT_LT] = ACTIONS(2148),
    [anon_sym_LT] = ACTIONS(2150),
    [anon_sym_LT_EQ] = ACTIONS(2148),
    [anon_sym_EQ_EQ] = ACTIONS(2148),
    [anon_sym_BANG_EQ] = ACTIONS(2148),
    [anon_sym_GT_EQ] = ACTIONS(2148),
    [anon_sym_GT] = ACTIONS(2150),
    [anon_sym_LT_GT] = ACTIONS(2148),
    [anon_sym_is] = ACTIONS(2148),
    [anon_sym_LBRACK] = ACTIONS(2148),
    [sym_comment] = ACTIONS(72),
    [sym__semicolon] = ACTIONS(2148),
  },
  [1077] = {
    [sym__expression] = STATE(599),
    [sym__primary_expression] = STATE(215),
    [sym_not_operator] = STATE(599),
    [sym_boolean_operator] = STATE(599),
    [sym_binary_operator] = STATE(215),
    [sym_unary_operator] = STATE(215),
    [sym_comparison_operator] = STATE(599),
    [sym_lambda] = STATE(599),
    [sym_yield] = STATE(600),
    [sym_attribute] = STATE(215),
    [sym_subscript] = STATE(215),
    [sym_call] = STATE(215),
    [sym_list] = STATE(215),
    [sym_list_comprehension] = STATE(215),
    [sym_dictionary] = STATE(215),
    [sym_dictionary_comprehension] = STATE(215),
    [sym_set] = STATE(215),
    [sym_set_comprehension] = STATE(215),
    [sym_parenthesized_expression] = STATE(215),
    [sym_tuple] = STATE(215),
    [sym_generator_expression] = STATE(215),
    [sym_conditional_expression] = STATE(599),
    [sym_concatenated_string] = STATE(215),
    [sym_await] = STATE(599),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_RPAREN] = ACTIONS(3104),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_not] = ACTIONS(384),
    [anon_sym_PLUS] = ACTIONS(386),
    [anon_sym_DASH] = ACTIONS(386),
    [anon_sym_TILDE] = ACTIONS(386),
    [anon_sym_lambda] = ACTIONS(388),
    [anon_sym_yield] = ACTIONS(94),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(390),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(392),
    [sym_integer] = ACTIONS(394),
    [sym_float] = ACTIONS(394),
    [sym_identifier] = ACTIONS(394),
    [sym_true] = ACTIONS(394),
    [sym_false] = ACTIONS(394),
    [sym_none] = ACTIONS(394),
    [anon_sym_await] = ACTIONS(396),
    [sym_comment] = ACTIONS(72),
  },
  [1078] = {
    [sym__newline] = ACTIONS(2642),
    [anon_sym_COMMA] = ACTIONS(2642),
    [anon_sym_if] = ACTIONS(476),
    [anon_sym_and] = ACTIONS(478),
    [anon_sym_or] = ACTIONS(480),
    [sym_comment] = ACTIONS(72),
    [sym__semicolon] = ACTIONS(2642),
  },
  [1079] = {
    [sym__newline] = ACTIONS(2683),
    [anon_sym_DOT] = ACTIONS(2683),
    [anon_sym_from] = ACTIONS(2683),
    [anon_sym_LPAREN] = ACTIONS(2683),
    [anon_sym_COMMA] = ACTIONS(2683),
    [anon_sym_STAR] = ACTIONS(2685),
    [anon_sym_GT_GT] = ACTIONS(2683),
    [anon_sym_if] = ACTIONS(2683),
    [anon_sym_in] = ACTIONS(2683),
    [anon_sym_EQ] = ACTIONS(2685),
    [anon_sym_AT] = ACTIONS(2683),
    [anon_sym_not] = ACTIONS(2683),
    [anon_sym_and] = ACTIONS(2683),
    [anon_sym_or] = ACTIONS(2683),
    [anon_sym_PLUS] = ACTIONS(2683),
    [anon_sym_DASH] = ACTIONS(2683),
    [anon_sym_SLASH] = ACTIONS(2685),
    [anon_sym_PERCENT] = ACTIONS(2683),
    [anon_sym_SLASH_SLASH] = ACTIONS(2683),
    [anon_sym_STAR_STAR] = ACTIONS(2683),
    [anon_sym_PIPE] = ACTIONS(2683),
    [anon_sym_AMP] = ACTIONS(2683),
    [anon_sym_CARET] = ACTIONS(2683),
    [anon_sym_LT_LT] = ACTIONS(2683),
    [anon_sym_LT] = ACTIONS(2685),
    [anon_sym_LT_EQ] = ACTIONS(2683),
    [anon_sym_EQ_EQ] = ACTIONS(2683),
    [anon_sym_BANG_EQ] = ACTIONS(2683),
    [anon_sym_GT_EQ] = ACTIONS(2683),
    [anon_sym_GT] = ACTIONS(2685),
    [anon_sym_LT_GT] = ACTIONS(2683),
    [anon_sym_is] = ACTIONS(2683),
    [anon_sym_LBRACK] = ACTIONS(2683),
    [sym_comment] = ACTIONS(72),
    [sym__semicolon] = ACTIONS(2683),
  },
  [1080] = {
    [sym_list_splat] = STATE(870),
    [sym__expression] = STATE(871),
    [sym__primary_expression] = STATE(430),
    [sym_not_operator] = STATE(871),
    [sym_boolean_operator] = STATE(871),
    [sym_binary_operator] = STATE(430),
    [sym_unary_operator] = STATE(430),
    [sym_comparison_operator] = STATE(871),
    [sym_lambda] = STATE(871),
    [sym_attribute] = STATE(430),
    [sym_subscript] = STATE(430),
    [sym_call] = STATE(430),
    [sym_list] = STATE(430),
    [sym_list_comprehension] = STATE(430),
    [sym_dictionary] = STATE(430),
    [sym_dictionary_comprehension] = STATE(430),
    [sym_set] = STATE(430),
    [sym_set_comprehension] = STATE(430),
    [sym_parenthesized_expression] = STATE(430),
    [sym_tuple] = STATE(430),
    [sym_generator_expression] = STATE(430),
    [sym_conditional_expression] = STATE(871),
    [sym_concatenated_string] = STATE(430),
    [sym_await] = STATE(871),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_STAR] = ACTIONS(238),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_not] = ACTIONS(760),
    [anon_sym_PLUS] = ACTIONS(762),
    [anon_sym_DASH] = ACTIONS(762),
    [anon_sym_TILDE] = ACTIONS(762),
    [anon_sym_lambda] = ACTIONS(764),
    [anon_sym_LBRACK] = ACTIONS(96),
    [anon_sym_RBRACK] = ACTIONS(3106),
    [sym_ellipsis] = ACTIONS(766),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(768),
    [sym_integer] = ACTIONS(770),
    [sym_float] = ACTIONS(770),
    [sym_identifier] = ACTIONS(770),
    [sym_true] = ACTIONS(770),
    [sym_false] = ACTIONS(770),
    [sym_none] = ACTIONS(770),
    [anon_sym_await] = ACTIONS(772),
    [sym_comment] = ACTIONS(72),
  },
  [1081] = {
    [sym__newline] = ACTIONS(2698),
    [anon_sym_DOT] = ACTIONS(2698),
    [anon_sym_from] = ACTIONS(2698),
    [anon_sym_LPAREN] = ACTIONS(2698),
    [anon_sym_COMMA] = ACTIONS(2698),
    [anon_sym_STAR] = ACTIONS(2700),
    [anon_sym_GT_GT] = ACTIONS(2698),
    [anon_sym_if] = ACTIONS(2698),
    [anon_sym_in] = ACTIONS(2698),
    [anon_sym_EQ] = ACTIONS(2700),
    [anon_sym_AT] = ACTIONS(2698),
    [anon_sym_not] = ACTIONS(2698),
    [anon_sym_and] = ACTIONS(2698),
    [anon_sym_or] = ACTIONS(2698),
    [anon_sym_PLUS] = ACTIONS(2698),
    [anon_sym_DASH] = ACTIONS(2698),
    [anon_sym_SLASH] = ACTIONS(2700),
    [anon_sym_PERCENT] = ACTIONS(2698),
    [anon_sym_SLASH_SLASH] = ACTIONS(2698),
    [anon_sym_STAR_STAR] = ACTIONS(2698),
    [anon_sym_PIPE] = ACTIONS(2698),
    [anon_sym_AMP] = ACTIONS(2698),
    [anon_sym_CARET] = ACTIONS(2698),
    [anon_sym_LT_LT] = ACTIONS(2698),
    [anon_sym_LT] = ACTIONS(2700),
    [anon_sym_LT_EQ] = ACTIONS(2698),
    [anon_sym_EQ_EQ] = ACTIONS(2698),
    [anon_sym_BANG_EQ] = ACTIONS(2698),
    [anon_sym_GT_EQ] = ACTIONS(2698),
    [anon_sym_GT] = ACTIONS(2700),
    [anon_sym_LT_GT] = ACTIONS(2698),
    [anon_sym_is] = ACTIONS(2698),
    [anon_sym_LBRACK] = ACTIONS(2698),
    [sym_comment] = ACTIONS(72),
    [sym__semicolon] = ACTIONS(2698),
  },
  [1082] = {
    [sym__newline] = ACTIONS(2771),
    [anon_sym_DOT] = ACTIONS(2771),
    [anon_sym_from] = ACTIONS(2771),
    [anon_sym_LPAREN] = ACTIONS(2771),
    [anon_sym_COMMA] = ACTIONS(2771),
    [anon_sym_STAR] = ACTIONS(2773),
    [anon_sym_GT_GT] = ACTIONS(2771),
    [anon_sym_if] = ACTIONS(2771),
    [anon_sym_in] = ACTIONS(2771),
    [anon_sym_EQ] = ACTIONS(2773),
    [anon_sym_AT] = ACTIONS(2771),
    [anon_sym_not] = ACTIONS(2771),
    [anon_sym_and] = ACTIONS(2771),
    [anon_sym_or] = ACTIONS(2771),
    [anon_sym_PLUS] = ACTIONS(2771),
    [anon_sym_DASH] = ACTIONS(2771),
    [anon_sym_SLASH] = ACTIONS(2773),
    [anon_sym_PERCENT] = ACTIONS(2771),
    [anon_sym_SLASH_SLASH] = ACTIONS(2771),
    [anon_sym_STAR_STAR] = ACTIONS(2771),
    [anon_sym_PIPE] = ACTIONS(2771),
    [anon_sym_AMP] = ACTIONS(2771),
    [anon_sym_CARET] = ACTIONS(2771),
    [anon_sym_LT_LT] = ACTIONS(2771),
    [anon_sym_LT] = ACTIONS(2773),
    [anon_sym_LT_EQ] = ACTIONS(2771),
    [anon_sym_EQ_EQ] = ACTIONS(2771),
    [anon_sym_BANG_EQ] = ACTIONS(2771),
    [anon_sym_GT_EQ] = ACTIONS(2771),
    [anon_sym_GT] = ACTIONS(2773),
    [anon_sym_LT_GT] = ACTIONS(2771),
    [anon_sym_is] = ACTIONS(2771),
    [anon_sym_LBRACK] = ACTIONS(2771),
    [sym_comment] = ACTIONS(72),
    [sym__semicolon] = ACTIONS(2771),
  },
  [1083] = {
    [sym_list_splat] = STATE(870),
    [sym__expression] = STATE(914),
    [sym__primary_expression] = STATE(463),
    [sym_not_operator] = STATE(914),
    [sym_boolean_operator] = STATE(914),
    [sym_binary_operator] = STATE(463),
    [sym_unary_operator] = STATE(463),
    [sym_comparison_operator] = STATE(914),
    [sym_lambda] = STATE(914),
    [sym_attribute] = STATE(463),
    [sym_subscript] = STATE(463),
    [sym_call] = STATE(463),
    [sym_list] = STATE(463),
    [sym_list_comprehension] = STATE(463),
    [sym_dictionary] = STATE(463),
    [sym_dictionary_comprehension] = STATE(463),
    [sym_set] = STATE(463),
    [sym_set_comprehension] = STATE(463),
    [sym_parenthesized_expression] = STATE(463),
    [sym_tuple] = STATE(463),
    [sym_generator_expression] = STATE(463),
    [sym_conditional_expression] = STATE(914),
    [sym_concatenated_string] = STATE(463),
    [sym_await] = STATE(914),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_STAR] = ACTIONS(1792),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_not] = ACTIONS(822),
    [anon_sym_PLUS] = ACTIONS(824),
    [anon_sym_DASH] = ACTIONS(824),
    [anon_sym_TILDE] = ACTIONS(824),
    [anon_sym_lambda] = ACTIONS(826),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(828),
    [anon_sym_LBRACE] = ACTIONS(100),
    [anon_sym_RBRACE] = ACTIONS(3108),
    [sym_string] = ACTIONS(830),
    [sym_integer] = ACTIONS(832),
    [sym_float] = ACTIONS(832),
    [sym_identifier] = ACTIONS(832),
    [sym_true] = ACTIONS(832),
    [sym_false] = ACTIONS(832),
    [sym_none] = ACTIONS(832),
    [anon_sym_await] = ACTIONS(834),
    [sym_comment] = ACTIONS(72),
  },
  [1084] = {
    [sym__newline] = ACTIONS(2780),
    [anon_sym_DOT] = ACTIONS(2780),
    [anon_sym_from] = ACTIONS(2780),
    [anon_sym_LPAREN] = ACTIONS(2780),
    [anon_sym_COMMA] = ACTIONS(2780),
    [anon_sym_STAR] = ACTIONS(2782),
    [anon_sym_GT_GT] = ACTIONS(2780),
    [anon_sym_if] = ACTIONS(2780),
    [anon_sym_in] = ACTIONS(2780),
    [anon_sym_EQ] = ACTIONS(2782),
    [anon_sym_AT] = ACTIONS(2780),
    [anon_sym_not] = ACTIONS(2780),
    [anon_sym_and] = ACTIONS(2780),
    [anon_sym_or] = ACTIONS(2780),
    [anon_sym_PLUS] = ACTIONS(2780),
    [anon_sym_DASH] = ACTIONS(2780),
    [anon_sym_SLASH] = ACTIONS(2782),
    [anon_sym_PERCENT] = ACTIONS(2780),
    [anon_sym_SLASH_SLASH] = ACTIONS(2780),
    [anon_sym_STAR_STAR] = ACTIONS(2780),
    [anon_sym_PIPE] = ACTIONS(2780),
    [anon_sym_AMP] = ACTIONS(2780),
    [anon_sym_CARET] = ACTIONS(2780),
    [anon_sym_LT_LT] = ACTIONS(2780),
    [anon_sym_LT] = ACTIONS(2782),
    [anon_sym_LT_EQ] = ACTIONS(2780),
    [anon_sym_EQ_EQ] = ACTIONS(2780),
    [anon_sym_BANG_EQ] = ACTIONS(2780),
    [anon_sym_GT_EQ] = ACTIONS(2780),
    [anon_sym_GT] = ACTIONS(2782),
    [anon_sym_LT_GT] = ACTIONS(2780),
    [anon_sym_is] = ACTIONS(2780),
    [anon_sym_LBRACK] = ACTIONS(2780),
    [sym_comment] = ACTIONS(72),
    [sym__semicolon] = ACTIONS(2780),
  },
  [1085] = {
    [sym_dictionary_splat] = STATE(919),
    [sym__expression] = STATE(920),
    [sym__primary_expression] = STATE(96),
    [sym_not_operator] = STATE(920),
    [sym_boolean_operator] = STATE(920),
    [sym_binary_operator] = STATE(96),
    [sym_unary_operator] = STATE(96),
    [sym_comparison_operator] = STATE(920),
    [sym_lambda] = STATE(920),
    [sym_attribute] = STATE(96),
    [sym_subscript] = STATE(96),
    [sym_call] = STATE(96),
    [sym_list] = STATE(96),
    [sym_list_comprehension] = STATE(96),
    [sym_dictionary] = STATE(96),
    [sym_dictionary_comprehension] = STATE(96),
    [sym_pair] = STATE(919),
    [sym_set] = STATE(96),
    [sym_set_comprehension] = STATE(96),
    [sym_parenthesized_expression] = STATE(96),
    [sym_tuple] = STATE(96),
    [sym_generator_expression] = STATE(96),
    [sym_conditional_expression] = STATE(920),
    [sym_concatenated_string] = STATE(96),
    [sym_await] = STATE(920),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_STAR] = ACTIONS(1802),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_not] = ACTIONS(160),
    [anon_sym_PLUS] = ACTIONS(162),
    [anon_sym_DASH] = ACTIONS(162),
    [anon_sym_TILDE] = ACTIONS(162),
    [anon_sym_lambda] = ACTIONS(164),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(166),
    [anon_sym_LBRACE] = ACTIONS(100),
    [anon_sym_RBRACE] = ACTIONS(3110),
    [sym_string] = ACTIONS(168),
    [sym_integer] = ACTIONS(170),
    [sym_float] = ACTIONS(170),
    [sym_identifier] = ACTIONS(170),
    [sym_true] = ACTIONS(170),
    [sym_false] = ACTIONS(170),
    [sym_none] = ACTIONS(170),
    [anon_sym_await] = ACTIONS(172),
    [sym_comment] = ACTIONS(72),
  },
  [1086] = {
    [sym__newline] = ACTIONS(2833),
    [anon_sym_DOT] = ACTIONS(2833),
    [anon_sym_from] = ACTIONS(2833),
    [anon_sym_LPAREN] = ACTIONS(2833),
    [anon_sym_COMMA] = ACTIONS(2833),
    [anon_sym_STAR] = ACTIONS(2835),
    [anon_sym_GT_GT] = ACTIONS(2833),
    [anon_sym_if] = ACTIONS(2833),
    [anon_sym_in] = ACTIONS(2833),
    [anon_sym_EQ] = ACTIONS(2835),
    [anon_sym_AT] = ACTIONS(2833),
    [anon_sym_not] = ACTIONS(2833),
    [anon_sym_and] = ACTIONS(2833),
    [anon_sym_or] = ACTIONS(2833),
    [anon_sym_PLUS] = ACTIONS(2833),
    [anon_sym_DASH] = ACTIONS(2833),
    [anon_sym_SLASH] = ACTIONS(2835),
    [anon_sym_PERCENT] = ACTIONS(2833),
    [anon_sym_SLASH_SLASH] = ACTIONS(2833),
    [anon_sym_STAR_STAR] = ACTIONS(2833),
    [anon_sym_PIPE] = ACTIONS(2833),
    [anon_sym_AMP] = ACTIONS(2833),
    [anon_sym_CARET] = ACTIONS(2833),
    [anon_sym_LT_LT] = ACTIONS(2833),
    [anon_sym_LT] = ACTIONS(2835),
    [anon_sym_LT_EQ] = ACTIONS(2833),
    [anon_sym_EQ_EQ] = ACTIONS(2833),
    [anon_sym_BANG_EQ] = ACTIONS(2833),
    [anon_sym_GT_EQ] = ACTIONS(2833),
    [anon_sym_GT] = ACTIONS(2835),
    [anon_sym_LT_GT] = ACTIONS(2833),
    [anon_sym_is] = ACTIONS(2833),
    [anon_sym_LBRACK] = ACTIONS(2833),
    [sym_comment] = ACTIONS(72),
    [sym__semicolon] = ACTIONS(2833),
  },
  [1087] = {
    [sym__newline] = ACTIONS(2867),
    [anon_sym_DOT] = ACTIONS(2867),
    [anon_sym_from] = ACTIONS(2867),
    [anon_sym_LPAREN] = ACTIONS(2867),
    [anon_sym_COMMA] = ACTIONS(2867),
    [anon_sym_STAR] = ACTIONS(2869),
    [anon_sym_GT_GT] = ACTIONS(2867),
    [anon_sym_if] = ACTIONS(2867),
    [anon_sym_in] = ACTIONS(2867),
    [anon_sym_EQ] = ACTIONS(2869),
    [anon_sym_AT] = ACTIONS(2867),
    [anon_sym_not] = ACTIONS(2867),
    [anon_sym_and] = ACTIONS(2867),
    [anon_sym_or] = ACTIONS(2867),
    [anon_sym_PLUS] = ACTIONS(2867),
    [anon_sym_DASH] = ACTIONS(2867),
    [anon_sym_SLASH] = ACTIONS(2869),
    [anon_sym_PERCENT] = ACTIONS(2867),
    [anon_sym_SLASH_SLASH] = ACTIONS(2867),
    [anon_sym_STAR_STAR] = ACTIONS(2867),
    [anon_sym_PIPE] = ACTIONS(2867),
    [anon_sym_AMP] = ACTIONS(2867),
    [anon_sym_CARET] = ACTIONS(2867),
    [anon_sym_LT_LT] = ACTIONS(2867),
    [anon_sym_LT] = ACTIONS(2869),
    [anon_sym_LT_EQ] = ACTIONS(2867),
    [anon_sym_EQ_EQ] = ACTIONS(2867),
    [anon_sym_BANG_EQ] = ACTIONS(2867),
    [anon_sym_GT_EQ] = ACTIONS(2867),
    [anon_sym_GT] = ACTIONS(2869),
    [anon_sym_LT_GT] = ACTIONS(2867),
    [anon_sym_is] = ACTIONS(2867),
    [anon_sym_LBRACK] = ACTIONS(2867),
    [sym_comment] = ACTIONS(72),
    [sym__semicolon] = ACTIONS(2867),
  },
  [1088] = {
    [sym__expression] = STATE(1433),
    [sym__primary_expression] = STATE(73),
    [sym_not_operator] = STATE(1433),
    [sym_boolean_operator] = STATE(1433),
    [sym_binary_operator] = STATE(73),
    [sym_unary_operator] = STATE(73),
    [sym_comparison_operator] = STATE(1433),
    [sym_lambda] = STATE(1433),
    [sym_attribute] = STATE(73),
    [sym_subscript] = STATE(73),
    [sym_call] = STATE(73),
    [sym_list] = STATE(73),
    [sym_list_comprehension] = STATE(73),
    [sym_dictionary] = STATE(73),
    [sym_dictionary_comprehension] = STATE(73),
    [sym_set] = STATE(73),
    [sym_set_comprehension] = STATE(73),
    [sym_parenthesized_expression] = STATE(73),
    [sym_tuple] = STATE(73),
    [sym_generator_expression] = STATE(73),
    [sym_conditional_expression] = STATE(1433),
    [sym_concatenated_string] = STATE(73),
    [sym_await] = STATE(1433),
    [anon_sym_LPAREN] = ACTIONS(130),
    [anon_sym_print] = ACTIONS(112),
    [anon_sym_exec] = ACTIONS(112),
    [anon_sym_not] = ACTIONS(132),
    [anon_sym_PLUS] = ACTIONS(116),
    [anon_sym_DASH] = ACTIONS(116),
    [anon_sym_TILDE] = ACTIONS(116),
    [anon_sym_lambda] = ACTIONS(118),
    [anon_sym_LBRACK] = ACTIONS(134),
    [sym_ellipsis] = ACTIONS(120),
    [anon_sym_LBRACE] = ACTIONS(122),
    [sym_string] = ACTIONS(124),
    [sym_integer] = ACTIONS(126),
    [sym_float] = ACTIONS(126),
    [sym_identifier] = ACTIONS(126),
    [sym_true] = ACTIONS(126),
    [sym_false] = ACTIONS(126),
    [sym_none] = ACTIONS(126),
    [anon_sym_await] = ACTIONS(128),
    [sym_comment] = ACTIONS(72),
  },
  [1089] = {
    [sym__newline] = ACTIONS(2945),
    [anon_sym_DOT] = ACTIONS(2945),
    [anon_sym_from] = ACTIONS(2945),
    [anon_sym_LPAREN] = ACTIONS(2945),
    [anon_sym_COMMA] = ACTIONS(2945),
    [anon_sym_STAR] = ACTIONS(2947),
    [anon_sym_GT_GT] = ACTIONS(2945),
    [anon_sym_if] = ACTIONS(2945),
    [anon_sym_in] = ACTIONS(2945),
    [anon_sym_EQ] = ACTIONS(2947),
    [anon_sym_AT] = ACTIONS(2945),
    [anon_sym_not] = ACTIONS(2945),
    [anon_sym_and] = ACTIONS(2945),
    [anon_sym_or] = ACTIONS(2945),
    [anon_sym_PLUS] = ACTIONS(2945),
    [anon_sym_DASH] = ACTIONS(2945),
    [anon_sym_SLASH] = ACTIONS(2947),
    [anon_sym_PERCENT] = ACTIONS(2945),
    [anon_sym_SLASH_SLASH] = ACTIONS(2945),
    [anon_sym_STAR_STAR] = ACTIONS(2945),
    [anon_sym_PIPE] = ACTIONS(2945),
    [anon_sym_AMP] = ACTIONS(2945),
    [anon_sym_CARET] = ACTIONS(2945),
    [anon_sym_LT_LT] = ACTIONS(2945),
    [anon_sym_LT] = ACTIONS(2947),
    [anon_sym_LT_EQ] = ACTIONS(2945),
    [anon_sym_EQ_EQ] = ACTIONS(2945),
    [anon_sym_BANG_EQ] = ACTIONS(2945),
    [anon_sym_GT_EQ] = ACTIONS(2945),
    [anon_sym_GT] = ACTIONS(2947),
    [anon_sym_LT_GT] = ACTIONS(2945),
    [anon_sym_is] = ACTIONS(2945),
    [anon_sym_LBRACK] = ACTIONS(2945),
    [sym_comment] = ACTIONS(72),
    [sym__semicolon] = ACTIONS(2945),
  },
  [1090] = {
    [sym_list_splat] = STATE(1362),
    [sym_dictionary_splat] = STATE(1362),
    [sym__expression] = STATE(1363),
    [sym__primary_expression] = STATE(215),
    [sym_not_operator] = STATE(1363),
    [sym_boolean_operator] = STATE(1363),
    [sym_binary_operator] = STATE(215),
    [sym_unary_operator] = STATE(215),
    [sym_comparison_operator] = STATE(1363),
    [sym_lambda] = STATE(1363),
    [sym_attribute] = STATE(215),
    [sym_subscript] = STATE(215),
    [sym_call] = STATE(215),
    [sym_keyword_argument] = STATE(1362),
    [sym_list] = STATE(215),
    [sym_list_comprehension] = STATE(215),
    [sym_dictionary] = STATE(215),
    [sym_dictionary_comprehension] = STATE(215),
    [sym_set] = STATE(215),
    [sym_set_comprehension] = STATE(215),
    [sym_parenthesized_expression] = STATE(215),
    [sym_tuple] = STATE(215),
    [sym_generator_expression] = STATE(215),
    [sym_conditional_expression] = STATE(1363),
    [sym_concatenated_string] = STATE(215),
    [sym_await] = STATE(1363),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_RPAREN] = ACTIONS(3112),
    [anon_sym_STAR] = ACTIONS(936),
    [anon_sym_print] = ACTIONS(938),
    [anon_sym_exec] = ACTIONS(938),
    [anon_sym_not] = ACTIONS(384),
    [anon_sym_PLUS] = ACTIONS(386),
    [anon_sym_DASH] = ACTIONS(386),
    [anon_sym_TILDE] = ACTIONS(386),
    [anon_sym_lambda] = ACTIONS(388),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(390),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(392),
    [sym_integer] = ACTIONS(394),
    [sym_float] = ACTIONS(394),
    [sym_identifier] = ACTIONS(940),
    [sym_true] = ACTIONS(394),
    [sym_false] = ACTIONS(394),
    [sym_none] = ACTIONS(394),
    [anon_sym_await] = ACTIONS(396),
    [sym_comment] = ACTIONS(72),
  },
  [1091] = {
    [aux_sym_argument_list_repeat1] = STATE(1365),
    [anon_sym_RPAREN] = ACTIONS(3112),
    [anon_sym_COMMA] = ACTIONS(3114),
    [sym_comment] = ACTIONS(72),
  },
  [1092] = {
    [sym_argument_list] = STATE(291),
    [sym_generator_expression] = STATE(291),
    [sym__newline] = ACTIONS(2953),
    [anon_sym_DOT] = ACTIONS(482),
    [anon_sym_LPAREN] = ACTIONS(484),
    [anon_sym_COMMA] = ACTIONS(2953),
    [anon_sym_STAR] = ACTIONS(486),
    [anon_sym_GT_GT] = ACTIONS(488),
    [anon_sym_if] = ACTIONS(2953),
    [anon_sym_in] = ACTIONS(2953),
    [anon_sym_AT] = ACTIONS(492),
    [anon_sym_not] = ACTIONS(2953),
    [anon_sym_and] = ACTIONS(2953),
    [anon_sym_or] = ACTIONS(2953),
    [anon_sym_PLUS] = ACTIONS(496),
    [anon_sym_DASH] = ACTIONS(496),
    [anon_sym_SLASH] = ACTIONS(486),
    [anon_sym_PERCENT] = ACTIONS(492),
    [anon_sym_SLASH_SLASH] = ACTIONS(492),
    [anon_sym_STAR_STAR] = ACTIONS(498),
    [anon_sym_PIPE] = ACTIONS(500),
    [anon_sym_AMP] = ACTIONS(502),
    [anon_sym_CARET] = ACTIONS(504),
    [anon_sym_LT_LT] = ACTIONS(488),
    [anon_sym_LT] = ACTIONS(2955),
    [anon_sym_LT_EQ] = ACTIONS(2953),
    [anon_sym_EQ_EQ] = ACTIONS(2953),
    [anon_sym_BANG_EQ] = ACTIONS(2953),
    [anon_sym_GT_EQ] = ACTIONS(2953),
    [anon_sym_GT] = ACTIONS(2955),
    [anon_sym_LT_GT] = ACTIONS(2953),
    [anon_sym_is] = ACTIONS(2953),
    [anon_sym_LBRACK] = ACTIONS(510),
    [sym_comment] = ACTIONS(72),
    [sym__semicolon] = ACTIONS(2953),
  },
  [1093] = {
    [sym__expression] = STATE(1372),
    [sym__primary_expression] = STATE(542),
    [sym_not_operator] = STATE(1372),
    [sym_boolean_operator] = STATE(1372),
    [sym_binary_operator] = STATE(542),
    [sym_unary_operator] = STATE(542),
    [sym_comparison_operator] = STATE(1372),
    [sym_lambda] = STATE(1372),
    [sym_attribute] = STATE(542),
    [sym_subscript] = STATE(542),
    [sym_slice] = STATE(1373),
    [sym_call] = STATE(542),
    [sym_list] = STATE(542),
    [sym_list_comprehension] = STATE(542),
    [sym_dictionary] = STATE(542),
    [sym_dictionary_comprehension] = STATE(542),
    [sym_set] = STATE(542),
    [sym_set_comprehension] = STATE(542),
    [sym_parenthesized_expression] = STATE(542),
    [sym_tuple] = STATE(542),
    [sym_generator_expression] = STATE(542),
    [sym_conditional_expression] = STATE(1372),
    [sym_concatenated_string] = STATE(542),
    [sym_await] = STATE(1372),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_COLON] = ACTIONS(978),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_not] = ACTIONS(980),
    [anon_sym_PLUS] = ACTIONS(982),
    [anon_sym_DASH] = ACTIONS(982),
    [anon_sym_TILDE] = ACTIONS(982),
    [anon_sym_lambda] = ACTIONS(984),
    [anon_sym_LBRACK] = ACTIONS(96),
    [anon_sym_RBRACK] = ACTIONS(3116),
    [sym_ellipsis] = ACTIONS(986),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(988),
    [sym_integer] = ACTIONS(990),
    [sym_float] = ACTIONS(990),
    [sym_identifier] = ACTIONS(990),
    [sym_true] = ACTIONS(990),
    [sym_false] = ACTIONS(990),
    [sym_none] = ACTIONS(990),
    [anon_sym_await] = ACTIONS(992),
    [sym_comment] = ACTIONS(72),
  },
  [1094] = {
    [sym__newline] = ACTIONS(2967),
    [anon_sym_DOT] = ACTIONS(2967),
    [anon_sym_from] = ACTIONS(2967),
    [anon_sym_LPAREN] = ACTIONS(2967),
    [anon_sym_COMMA] = ACTIONS(2967),
    [anon_sym_STAR] = ACTIONS(2969),
    [anon_sym_GT_GT] = ACTIONS(2967),
    [anon_sym_if] = ACTIONS(2967),
    [anon_sym_in] = ACTIONS(2967),
    [anon_sym_EQ] = ACTIONS(2969),
    [anon_sym_AT] = ACTIONS(2967),
    [anon_sym_not] = ACTIONS(2967),
    [anon_sym_and] = ACTIONS(2967),
    [anon_sym_or] = ACTIONS(2967),
    [anon_sym_PLUS] = ACTIONS(2967),
    [anon_sym_DASH] = ACTIONS(2967),
    [anon_sym_SLASH] = ACTIONS(2969),
    [anon_sym_PERCENT] = ACTIONS(2967),
    [anon_sym_SLASH_SLASH] = ACTIONS(2967),
    [anon_sym_STAR_STAR] = ACTIONS(2967),
    [anon_sym_PIPE] = ACTIONS(2967),
    [anon_sym_AMP] = ACTIONS(2967),
    [anon_sym_CARET] = ACTIONS(2967),
    [anon_sym_LT_LT] = ACTIONS(2967),
    [anon_sym_LT] = ACTIONS(2969),
    [anon_sym_LT_EQ] = ACTIONS(2967),
    [anon_sym_EQ_EQ] = ACTIONS(2967),
    [anon_sym_BANG_EQ] = ACTIONS(2967),
    [anon_sym_GT_EQ] = ACTIONS(2967),
    [anon_sym_GT] = ACTIONS(2969),
    [anon_sym_LT_GT] = ACTIONS(2967),
    [anon_sym_is] = ACTIONS(2967),
    [anon_sym_LBRACK] = ACTIONS(2967),
    [sym_comment] = ACTIONS(72),
    [sym__semicolon] = ACTIONS(2967),
  },
  [1095] = {
    [aux_sym_subscript_repeat1] = STATE(1378),
    [anon_sym_COMMA] = ACTIONS(3118),
    [anon_sym_RBRACK] = ACTIONS(3116),
    [sym_comment] = ACTIONS(72),
  },
  [1096] = {
    [sym__newline] = ACTIONS(1644),
    [anon_sym_if] = ACTIONS(1331),
    [anon_sym_and] = ACTIONS(1333),
    [anon_sym_or] = ACTIONS(1335),
    [sym_comment] = ACTIONS(72),
    [sym__semicolon] = ACTIONS(1644),
  },
  [1097] = {
    [sym__expression] = STATE(1438),
    [sym__primary_expression] = STATE(303),
    [sym_not_operator] = STATE(1438),
    [sym_boolean_operator] = STATE(1438),
    [sym_binary_operator] = STATE(303),
    [sym_unary_operator] = STATE(303),
    [sym_comparison_operator] = STATE(1438),
    [sym_lambda] = STATE(1438),
    [sym_attribute] = STATE(303),
    [sym_subscript] = STATE(303),
    [sym_call] = STATE(303),
    [sym_list] = STATE(303),
    [sym_list_comprehension] = STATE(303),
    [sym_dictionary] = STATE(303),
    [sym_dictionary_comprehension] = STATE(303),
    [sym_set] = STATE(303),
    [sym_set_comprehension] = STATE(303),
    [sym_parenthesized_expression] = STATE(303),
    [sym_tuple] = STATE(303),
    [sym_generator_expression] = STATE(303),
    [sym_conditional_expression] = STATE(1438),
    [sym_concatenated_string] = STATE(303),
    [sym_await] = STATE(1438),
    [anon_sym_LPAREN] = ACTIONS(130),
    [anon_sym_print] = ACTIONS(112),
    [anon_sym_exec] = ACTIONS(112),
    [anon_sym_not] = ACTIONS(522),
    [anon_sym_PLUS] = ACTIONS(524),
    [anon_sym_DASH] = ACTIONS(524),
    [anon_sym_TILDE] = ACTIONS(524),
    [anon_sym_lambda] = ACTIONS(526),
    [anon_sym_LBRACK] = ACTIONS(134),
    [sym_ellipsis] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(122),
    [sym_string] = ACTIONS(530),
    [sym_integer] = ACTIONS(532),
    [sym_float] = ACTIONS(532),
    [sym_identifier] = ACTIONS(532),
    [sym_true] = ACTIONS(532),
    [sym_false] = ACTIONS(532),
    [sym_none] = ACTIONS(532),
    [anon_sym_await] = ACTIONS(534),
    [sym_comment] = ACTIONS(72),
  },
  [1098] = {
    [aux_sym_concatenated_string_repeat1] = STATE(1098),
    [sym__newline] = ACTIONS(1862),
    [anon_sym_DOT] = ACTIONS(1862),
    [anon_sym_LPAREN] = ACTIONS(1862),
    [anon_sym_STAR] = ACTIONS(1864),
    [anon_sym_GT_GT] = ACTIONS(1862),
    [anon_sym_if] = ACTIONS(1862),
    [anon_sym_in] = ACTIONS(1862),
    [anon_sym_AT] = ACTIONS(1862),
    [anon_sym_not] = ACTIONS(1862),
    [anon_sym_and] = ACTIONS(1862),
    [anon_sym_or] = ACTIONS(1862),
    [anon_sym_PLUS] = ACTIONS(1862),
    [anon_sym_DASH] = ACTIONS(1862),
    [anon_sym_SLASH] = ACTIONS(1864),
    [anon_sym_PERCENT] = ACTIONS(1862),
    [anon_sym_SLASH_SLASH] = ACTIONS(1862),
    [anon_sym_STAR_STAR] = ACTIONS(1862),
    [anon_sym_PIPE] = ACTIONS(1862),
    [anon_sym_AMP] = ACTIONS(1862),
    [anon_sym_CARET] = ACTIONS(1862),
    [anon_sym_LT_LT] = ACTIONS(1862),
    [anon_sym_LT] = ACTIONS(1864),
    [anon_sym_LT_EQ] = ACTIONS(1862),
    [anon_sym_EQ_EQ] = ACTIONS(1862),
    [anon_sym_BANG_EQ] = ACTIONS(1862),
    [anon_sym_GT_EQ] = ACTIONS(1862),
    [anon_sym_GT] = ACTIONS(1864),
    [anon_sym_LT_GT] = ACTIONS(1862),
    [anon_sym_is] = ACTIONS(1862),
    [anon_sym_LBRACK] = ACTIONS(1862),
    [sym_string] = ACTIONS(3120),
    [sym_comment] = ACTIONS(72),
    [sym__semicolon] = ACTIONS(1862),
  },
  [1099] = {
    [anon_sym_if] = ACTIONS(1921),
    [anon_sym_else] = ACTIONS(3123),
    [anon_sym_and] = ACTIONS(1925),
    [anon_sym_or] = ACTIONS(1927),
    [sym_comment] = ACTIONS(72),
  },
  [1100] = {
    [sym__newline] = ACTIONS(1953),
    [anon_sym_if] = ACTIONS(1953),
    [anon_sym_and] = ACTIONS(1333),
    [anon_sym_or] = ACTIONS(1953),
    [sym_comment] = ACTIONS(72),
    [sym__semicolon] = ACTIONS(1953),
  },
  [1101] = {
    [sym_argument_list] = STATE(291),
    [sym_generator_expression] = STATE(291),
    [sym__newline] = ACTIONS(1980),
    [anon_sym_DOT] = ACTIONS(1980),
    [anon_sym_LPAREN] = ACTIONS(484),
    [anon_sym_STAR] = ACTIONS(1982),
    [anon_sym_GT_GT] = ACTIONS(1980),
    [anon_sym_if] = ACTIONS(1980),
    [anon_sym_in] = ACTIONS(1980),
    [anon_sym_AT] = ACTIONS(1980),
    [anon_sym_not] = ACTIONS(1980),
    [anon_sym_and] = ACTIONS(1980),
    [anon_sym_or] = ACTIONS(1980),
    [anon_sym_PLUS] = ACTIONS(1980),
    [anon_sym_DASH] = ACTIONS(1980),
    [anon_sym_SLASH] = ACTIONS(1982),
    [anon_sym_PERCENT] = ACTIONS(1980),
    [anon_sym_SLASH_SLASH] = ACTIONS(1980),
    [anon_sym_STAR_STAR] = ACTIONS(1349),
    [anon_sym_PIPE] = ACTIONS(1980),
    [anon_sym_AMP] = ACTIONS(1980),
    [anon_sym_CARET] = ACTIONS(1980),
    [anon_sym_LT_LT] = ACTIONS(1980),
    [anon_sym_LT] = ACTIONS(1982),
    [anon_sym_LT_EQ] = ACTIONS(1980),
    [anon_sym_EQ_EQ] = ACTIONS(1980),
    [anon_sym_BANG_EQ] = ACTIONS(1980),
    [anon_sym_GT_EQ] = ACTIONS(1980),
    [anon_sym_GT] = ACTIONS(1982),
    [anon_sym_LT_GT] = ACTIONS(1980),
    [anon_sym_is] = ACTIONS(1980),
    [anon_sym_LBRACK] = ACTIONS(1980),
    [sym_comment] = ACTIONS(72),
    [sym__semicolon] = ACTIONS(1980),
  },
  [1102] = {
    [sym_argument_list] = STATE(291),
    [sym_generator_expression] = STATE(291),
    [sym__newline] = ACTIONS(1980),
    [anon_sym_DOT] = ACTIONS(1980),
    [anon_sym_LPAREN] = ACTIONS(484),
    [anon_sym_STAR] = ACTIONS(1337),
    [anon_sym_GT_GT] = ACTIONS(1980),
    [anon_sym_if] = ACTIONS(1980),
    [anon_sym_in] = ACTIONS(1980),
    [anon_sym_AT] = ACTIONS(1343),
    [anon_sym_not] = ACTIONS(1980),
    [anon_sym_and] = ACTIONS(1980),
    [anon_sym_or] = ACTIONS(1980),
    [anon_sym_PLUS] = ACTIONS(1347),
    [anon_sym_DASH] = ACTIONS(1347),
    [anon_sym_SLASH] = ACTIONS(1337),
    [anon_sym_PERCENT] = ACTIONS(1343),
    [anon_sym_SLASH_SLASH] = ACTIONS(1343),
    [anon_sym_STAR_STAR] = ACTIONS(1349),
    [anon_sym_PIPE] = ACTIONS(1980),
    [anon_sym_AMP] = ACTIONS(1980),
    [anon_sym_CARET] = ACTIONS(1980),
    [anon_sym_LT_LT] = ACTIONS(1980),
    [anon_sym_LT] = ACTIONS(1982),
    [anon_sym_LT_EQ] = ACTIONS(1980),
    [anon_sym_EQ_EQ] = ACTIONS(1980),
    [anon_sym_BANG_EQ] = ACTIONS(1980),
    [anon_sym_GT_EQ] = ACTIONS(1980),
    [anon_sym_GT] = ACTIONS(1982),
    [anon_sym_LT_GT] = ACTIONS(1980),
    [anon_sym_is] = ACTIONS(1980),
    [anon_sym_LBRACK] = ACTIONS(1980),
    [sym_comment] = ACTIONS(72),
    [sym__semicolon] = ACTIONS(1980),
  },
  [1103] = {
    [sym_argument_list] = STATE(291),
    [sym_generator_expression] = STATE(291),
    [sym__newline] = ACTIONS(1984),
    [anon_sym_DOT] = ACTIONS(482),
    [anon_sym_LPAREN] = ACTIONS(484),
    [anon_sym_STAR] = ACTIONS(1337),
    [anon_sym_GT_GT] = ACTIONS(1339),
    [anon_sym_if] = ACTIONS(1984),
    [anon_sym_in] = ACTIONS(1984),
    [anon_sym_AT] = ACTIONS(1343),
    [anon_sym_not] = ACTIONS(1984),
    [anon_sym_and] = ACTIONS(1984),
    [anon_sym_or] = ACTIONS(1984),
    [anon_sym_PLUS] = ACTIONS(1347),
    [anon_sym_DASH] = ACTIONS(1347),
    [anon_sym_SLASH] = ACTIONS(1337),
    [anon_sym_PERCENT] = ACTIONS(1343),
    [anon_sym_SLASH_SLASH] = ACTIONS(1343),
    [anon_sym_STAR_STAR] = ACTIONS(1349),
    [anon_sym_PIPE] = ACTIONS(1351),
    [anon_sym_AMP] = ACTIONS(1353),
    [anon_sym_CARET] = ACTIONS(1355),
    [anon_sym_LT_LT] = ACTIONS(1339),
    [anon_sym_LT] = ACTIONS(1986),
    [anon_sym_LT_EQ] = ACTIONS(1984),
    [anon_sym_EQ_EQ] = ACTIONS(1984),
    [anon_sym_BANG_EQ] = ACTIONS(1984),
    [anon_sym_GT_EQ] = ACTIONS(1984),
    [anon_sym_GT] = ACTIONS(1986),
    [anon_sym_LT_GT] = ACTIONS(1984),
    [anon_sym_is] = ACTIONS(1984),
    [anon_sym_LBRACK] = ACTIONS(510),
    [sym_comment] = ACTIONS(72),
    [sym__semicolon] = ACTIONS(1984),
  },
  [1104] = {
    [sym__primary_expression] = STATE(1440),
    [sym_binary_operator] = STATE(1440),
    [sym_unary_operator] = STATE(1440),
    [sym_attribute] = STATE(1440),
    [sym_subscript] = STATE(1440),
    [sym_call] = STATE(1440),
    [sym_list] = STATE(1440),
    [sym_list_comprehension] = STATE(1440),
    [sym_dictionary] = STATE(1440),
    [sym_dictionary_comprehension] = STATE(1440),
    [sym_set] = STATE(1440),
    [sym_set_comprehension] = STATE(1440),
    [sym_parenthesized_expression] = STATE(1440),
    [sym_tuple] = STATE(1440),
    [sym_generator_expression] = STATE(1440),
    [sym_concatenated_string] = STATE(1440),
    [anon_sym_LPAREN] = ACTIONS(130),
    [anon_sym_print] = ACTIONS(112),
    [anon_sym_exec] = ACTIONS(112),
    [anon_sym_PLUS] = ACTIONS(524),
    [anon_sym_DASH] = ACTIONS(524),
    [anon_sym_TILDE] = ACTIONS(524),
    [anon_sym_LBRACK] = ACTIONS(134),
    [sym_ellipsis] = ACTIONS(3125),
    [anon_sym_LBRACE] = ACTIONS(122),
    [sym_string] = ACTIONS(530),
    [sym_integer] = ACTIONS(3127),
    [sym_float] = ACTIONS(3127),
    [sym_identifier] = ACTIONS(3127),
    [sym_true] = ACTIONS(3127),
    [sym_false] = ACTIONS(3127),
    [sym_none] = ACTIONS(3127),
    [sym_comment] = ACTIONS(72),
  },
  [1105] = {
    [sym_argument_list] = STATE(291),
    [sym_generator_expression] = STATE(291),
    [sym__newline] = ACTIONS(1980),
    [anon_sym_DOT] = ACTIONS(1980),
    [anon_sym_LPAREN] = ACTIONS(484),
    [anon_sym_STAR] = ACTIONS(1337),
    [anon_sym_GT_GT] = ACTIONS(1980),
    [anon_sym_if] = ACTIONS(1980),
    [anon_sym_in] = ACTIONS(1980),
    [anon_sym_AT] = ACTIONS(1343),
    [anon_sym_not] = ACTIONS(1980),
    [anon_sym_and] = ACTIONS(1980),
    [anon_sym_or] = ACTIONS(1980),
    [anon_sym_PLUS] = ACTIONS(1980),
    [anon_sym_DASH] = ACTIONS(1980),
    [anon_sym_SLASH] = ACTIONS(1337),
    [anon_sym_PERCENT] = ACTIONS(1343),
    [anon_sym_SLASH_SLASH] = ACTIONS(1343),
    [anon_sym_STAR_STAR] = ACTIONS(1349),
    [anon_sym_PIPE] = ACTIONS(1980),
    [anon_sym_AMP] = ACTIONS(1980),
    [anon_sym_CARET] = ACTIONS(1980),
    [anon_sym_LT_LT] = ACTIONS(1980),
    [anon_sym_LT] = ACTIONS(1982),
    [anon_sym_LT_EQ] = ACTIONS(1980),
    [anon_sym_EQ_EQ] = ACTIONS(1980),
    [anon_sym_BANG_EQ] = ACTIONS(1980),
    [anon_sym_GT_EQ] = ACTIONS(1980),
    [anon_sym_GT] = ACTIONS(1982),
    [anon_sym_LT_GT] = ACTIONS(1980),
    [anon_sym_is] = ACTIONS(1980),
    [anon_sym_LBRACK] = ACTIONS(1980),
    [sym_comment] = ACTIONS(72),
    [sym__semicolon] = ACTIONS(1980),
  },
  [1106] = {
    [sym_argument_list] = STATE(291),
    [sym_generator_expression] = STATE(291),
    [sym__newline] = ACTIONS(1980),
    [anon_sym_DOT] = ACTIONS(1980),
    [anon_sym_LPAREN] = ACTIONS(484),
    [anon_sym_STAR] = ACTIONS(1337),
    [anon_sym_GT_GT] = ACTIONS(1339),
    [anon_sym_if] = ACTIONS(1980),
    [anon_sym_in] = ACTIONS(1980),
    [anon_sym_AT] = ACTIONS(1343),
    [anon_sym_not] = ACTIONS(1980),
    [anon_sym_and] = ACTIONS(1980),
    [anon_sym_or] = ACTIONS(1980),
    [anon_sym_PLUS] = ACTIONS(1347),
    [anon_sym_DASH] = ACTIONS(1347),
    [anon_sym_SLASH] = ACTIONS(1337),
    [anon_sym_PERCENT] = ACTIONS(1343),
    [anon_sym_SLASH_SLASH] = ACTIONS(1343),
    [anon_sym_STAR_STAR] = ACTIONS(1349),
    [anon_sym_PIPE] = ACTIONS(1980),
    [anon_sym_AMP] = ACTIONS(1353),
    [anon_sym_CARET] = ACTIONS(1355),
    [anon_sym_LT_LT] = ACTIONS(1339),
    [anon_sym_LT] = ACTIONS(1982),
    [anon_sym_LT_EQ] = ACTIONS(1980),
    [anon_sym_EQ_EQ] = ACTIONS(1980),
    [anon_sym_BANG_EQ] = ACTIONS(1980),
    [anon_sym_GT_EQ] = ACTIONS(1980),
    [anon_sym_GT] = ACTIONS(1982),
    [anon_sym_LT_GT] = ACTIONS(1980),
    [anon_sym_is] = ACTIONS(1980),
    [anon_sym_LBRACK] = ACTIONS(1980),
    [sym_comment] = ACTIONS(72),
    [sym__semicolon] = ACTIONS(1980),
  },
  [1107] = {
    [sym_argument_list] = STATE(291),
    [sym_generator_expression] = STATE(291),
    [sym__newline] = ACTIONS(1980),
    [anon_sym_DOT] = ACTIONS(1980),
    [anon_sym_LPAREN] = ACTIONS(484),
    [anon_sym_STAR] = ACTIONS(1337),
    [anon_sym_GT_GT] = ACTIONS(1339),
    [anon_sym_if] = ACTIONS(1980),
    [anon_sym_in] = ACTIONS(1980),
    [anon_sym_AT] = ACTIONS(1343),
    [anon_sym_not] = ACTIONS(1980),
    [anon_sym_and] = ACTIONS(1980),
    [anon_sym_or] = ACTIONS(1980),
    [anon_sym_PLUS] = ACTIONS(1347),
    [anon_sym_DASH] = ACTIONS(1347),
    [anon_sym_SLASH] = ACTIONS(1337),
    [anon_sym_PERCENT] = ACTIONS(1343),
    [anon_sym_SLASH_SLASH] = ACTIONS(1343),
    [anon_sym_STAR_STAR] = ACTIONS(1349),
    [anon_sym_PIPE] = ACTIONS(1980),
    [anon_sym_AMP] = ACTIONS(1980),
    [anon_sym_CARET] = ACTIONS(1355),
    [anon_sym_LT_LT] = ACTIONS(1339),
    [anon_sym_LT] = ACTIONS(1982),
    [anon_sym_LT_EQ] = ACTIONS(1980),
    [anon_sym_EQ_EQ] = ACTIONS(1980),
    [anon_sym_BANG_EQ] = ACTIONS(1980),
    [anon_sym_GT_EQ] = ACTIONS(1980),
    [anon_sym_GT] = ACTIONS(1982),
    [anon_sym_LT_GT] = ACTIONS(1980),
    [anon_sym_is] = ACTIONS(1980),
    [anon_sym_LBRACK] = ACTIONS(1980),
    [sym_comment] = ACTIONS(72),
    [sym__semicolon] = ACTIONS(1980),
  },
  [1108] = {
    [sym_argument_list] = STATE(291),
    [sym_generator_expression] = STATE(291),
    [sym__newline] = ACTIONS(1980),
    [anon_sym_DOT] = ACTIONS(1980),
    [anon_sym_LPAREN] = ACTIONS(484),
    [anon_sym_STAR] = ACTIONS(1337),
    [anon_sym_GT_GT] = ACTIONS(1339),
    [anon_sym_if] = ACTIONS(1980),
    [anon_sym_in] = ACTIONS(1980),
    [anon_sym_AT] = ACTIONS(1343),
    [anon_sym_not] = ACTIONS(1980),
    [anon_sym_and] = ACTIONS(1980),
    [anon_sym_or] = ACTIONS(1980),
    [anon_sym_PLUS] = ACTIONS(1347),
    [anon_sym_DASH] = ACTIONS(1347),
    [anon_sym_SLASH] = ACTIONS(1337),
    [anon_sym_PERCENT] = ACTIONS(1343),
    [anon_sym_SLASH_SLASH] = ACTIONS(1343),
    [anon_sym_STAR_STAR] = ACTIONS(1349),
    [anon_sym_PIPE] = ACTIONS(1980),
    [anon_sym_AMP] = ACTIONS(1980),
    [anon_sym_CARET] = ACTIONS(1980),
    [anon_sym_LT_LT] = ACTIONS(1339),
    [anon_sym_LT] = ACTIONS(1982),
    [anon_sym_LT_EQ] = ACTIONS(1980),
    [anon_sym_EQ_EQ] = ACTIONS(1980),
    [anon_sym_BANG_EQ] = ACTIONS(1980),
    [anon_sym_GT_EQ] = ACTIONS(1980),
    [anon_sym_GT] = ACTIONS(1982),
    [anon_sym_LT_GT] = ACTIONS(1980),
    [anon_sym_is] = ACTIONS(1980),
    [anon_sym_LBRACK] = ACTIONS(1980),
    [sym_comment] = ACTIONS(72),
    [sym__semicolon] = ACTIONS(1980),
  },
  [1109] = {
    [aux_sym_comparison_operator_repeat1] = STATE(1109),
    [sym__newline] = ACTIONS(1984),
    [anon_sym_if] = ACTIONS(1984),
    [anon_sym_in] = ACTIONS(3129),
    [anon_sym_not] = ACTIONS(3132),
    [anon_sym_and] = ACTIONS(1984),
    [anon_sym_or] = ACTIONS(1984),
    [anon_sym_LT] = ACTIONS(3135),
    [anon_sym_LT_EQ] = ACTIONS(3129),
    [anon_sym_EQ_EQ] = ACTIONS(3129),
    [anon_sym_BANG_EQ] = ACTIONS(3129),
    [anon_sym_GT_EQ] = ACTIONS(3129),
    [anon_sym_GT] = ACTIONS(3135),
    [anon_sym_LT_GT] = ACTIONS(3129),
    [anon_sym_is] = ACTIONS(3138),
    [sym_comment] = ACTIONS(72),
    [sym__semicolon] = ACTIONS(1984),
  },
  [1110] = {
    [sym__newline] = ACTIONS(2642),
    [anon_sym_from] = ACTIONS(2642),
    [anon_sym_COMMA] = ACTIONS(2642),
    [anon_sym_if] = ACTIONS(546),
    [anon_sym_and] = ACTIONS(548),
    [anon_sym_or] = ACTIONS(550),
    [sym_comment] = ACTIONS(72),
    [sym__semicolon] = ACTIONS(2642),
  },
  [1111] = {
    [sym__expression] = STATE(1441),
    [sym__primary_expression] = STATE(86),
    [sym_not_operator] = STATE(1441),
    [sym_boolean_operator] = STATE(1441),
    [sym_binary_operator] = STATE(86),
    [sym_unary_operator] = STATE(86),
    [sym_comparison_operator] = STATE(1441),
    [sym_lambda] = STATE(1441),
    [sym_attribute] = STATE(86),
    [sym_subscript] = STATE(86),
    [sym_call] = STATE(86),
    [sym_list] = STATE(86),
    [sym_list_comprehension] = STATE(86),
    [sym_dictionary] = STATE(86),
    [sym_dictionary_comprehension] = STATE(86),
    [sym_set] = STATE(86),
    [sym_set_comprehension] = STATE(86),
    [sym_parenthesized_expression] = STATE(86),
    [sym_tuple] = STATE(86),
    [sym_generator_expression] = STATE(86),
    [sym_conditional_expression] = STATE(1441),
    [sym_concatenated_string] = STATE(86),
    [sym_await] = STATE(1441),
    [anon_sym_LPAREN] = ACTIONS(130),
    [anon_sym_print] = ACTIONS(112),
    [anon_sym_exec] = ACTIONS(112),
    [anon_sym_not] = ACTIONS(142),
    [anon_sym_PLUS] = ACTIONS(144),
    [anon_sym_DASH] = ACTIONS(144),
    [anon_sym_TILDE] = ACTIONS(144),
    [anon_sym_lambda] = ACTIONS(146),
    [anon_sym_LBRACK] = ACTIONS(134),
    [sym_ellipsis] = ACTIONS(148),
    [anon_sym_LBRACE] = ACTIONS(122),
    [sym_string] = ACTIONS(150),
    [sym_integer] = ACTIONS(152),
    [sym_float] = ACTIONS(152),
    [sym_identifier] = ACTIONS(152),
    [sym_true] = ACTIONS(152),
    [sym_false] = ACTIONS(152),
    [sym_none] = ACTIONS(152),
    [anon_sym_await] = ACTIONS(154),
    [sym_comment] = ACTIONS(72),
  },
  [1112] = {
    [sym__expression] = STATE(693),
    [sym__primary_expression] = STATE(86),
    [sym_not_operator] = STATE(693),
    [sym_boolean_operator] = STATE(693),
    [sym_binary_operator] = STATE(86),
    [sym_unary_operator] = STATE(86),
    [sym_comparison_operator] = STATE(693),
    [sym_lambda] = STATE(693),
    [sym_attribute] = STATE(86),
    [sym_subscript] = STATE(86),
    [sym_call] = STATE(86),
    [sym_list] = STATE(86),
    [sym_list_comprehension] = STATE(86),
    [sym_dictionary] = STATE(86),
    [sym_dictionary_comprehension] = STATE(86),
    [sym_set] = STATE(86),
    [sym_set_comprehension] = STATE(86),
    [sym_parenthesized_expression] = STATE(86),
    [sym_tuple] = STATE(86),
    [sym_generator_expression] = STATE(86),
    [sym_conditional_expression] = STATE(693),
    [sym_concatenated_string] = STATE(86),
    [sym_await] = STATE(693),
    [anon_sym_LPAREN] = ACTIONS(130),
    [anon_sym_print] = ACTIONS(112),
    [anon_sym_exec] = ACTIONS(112),
    [anon_sym_not] = ACTIONS(142),
    [anon_sym_PLUS] = ACTIONS(144),
    [anon_sym_DASH] = ACTIONS(144),
    [anon_sym_TILDE] = ACTIONS(144),
    [anon_sym_lambda] = ACTIONS(146),
    [anon_sym_LBRACK] = ACTIONS(134),
    [sym_ellipsis] = ACTIONS(148),
    [anon_sym_LBRACE] = ACTIONS(122),
    [sym_string] = ACTIONS(150),
    [sym_integer] = ACTIONS(152),
    [sym_float] = ACTIONS(152),
    [sym_identifier] = ACTIONS(152),
    [sym_true] = ACTIONS(152),
    [sym_false] = ACTIONS(152),
    [sym_none] = ACTIONS(152),
    [anon_sym_await] = ACTIONS(154),
    [sym_comment] = ACTIONS(72),
  },
  [1113] = {
    [sym_argument_list] = STATE(291),
    [sym_generator_expression] = STATE(291),
    [sym__newline] = ACTIONS(2953),
    [anon_sym_DOT] = ACTIONS(482),
    [anon_sym_from] = ACTIONS(2953),
    [anon_sym_LPAREN] = ACTIONS(484),
    [anon_sym_COMMA] = ACTIONS(2953),
    [anon_sym_STAR] = ACTIONS(552),
    [anon_sym_GT_GT] = ACTIONS(554),
    [anon_sym_if] = ACTIONS(2953),
    [anon_sym_in] = ACTIONS(2953),
    [anon_sym_AT] = ACTIONS(558),
    [anon_sym_not] = ACTIONS(2953),
    [anon_sym_and] = ACTIONS(2953),
    [anon_sym_or] = ACTIONS(2953),
    [anon_sym_PLUS] = ACTIONS(562),
    [anon_sym_DASH] = ACTIONS(562),
    [anon_sym_SLASH] = ACTIONS(552),
    [anon_sym_PERCENT] = ACTIONS(558),
    [anon_sym_SLASH_SLASH] = ACTIONS(558),
    [anon_sym_STAR_STAR] = ACTIONS(564),
    [anon_sym_PIPE] = ACTIONS(566),
    [anon_sym_AMP] = ACTIONS(568),
    [anon_sym_CARET] = ACTIONS(570),
    [anon_sym_LT_LT] = ACTIONS(554),
    [anon_sym_LT] = ACTIONS(2955),
    [anon_sym_LT_EQ] = ACTIONS(2953),
    [anon_sym_EQ_EQ] = ACTIONS(2953),
    [anon_sym_BANG_EQ] = ACTIONS(2953),
    [anon_sym_GT_EQ] = ACTIONS(2953),
    [anon_sym_GT] = ACTIONS(2955),
    [anon_sym_LT_GT] = ACTIONS(2953),
    [anon_sym_is] = ACTIONS(2953),
    [anon_sym_LBRACK] = ACTIONS(510),
    [sym_comment] = ACTIONS(72),
    [sym__semicolon] = ACTIONS(2953),
  },
  [1114] = {
    [anon_sym_if] = ACTIONS(590),
    [anon_sym_COLON] = ACTIONS(2642),
    [anon_sym_and] = ACTIONS(594),
    [anon_sym_or] = ACTIONS(596),
    [sym_comment] = ACTIONS(72),
  },
  [1115] = {
    [sym__expression] = STATE(1442),
    [sym__primary_expression] = STATE(96),
    [sym_not_operator] = STATE(1442),
    [sym_boolean_operator] = STATE(1442),
    [sym_binary_operator] = STATE(96),
    [sym_unary_operator] = STATE(96),
    [sym_comparison_operator] = STATE(1442),
    [sym_lambda] = STATE(1442),
    [sym_attribute] = STATE(96),
    [sym_subscript] = STATE(96),
    [sym_call] = STATE(96),
    [sym_list] = STATE(96),
    [sym_list_comprehension] = STATE(96),
    [sym_dictionary] = STATE(96),
    [sym_dictionary_comprehension] = STATE(96),
    [sym_set] = STATE(96),
    [sym_set_comprehension] = STATE(96),
    [sym_parenthesized_expression] = STATE(96),
    [sym_tuple] = STATE(96),
    [sym_generator_expression] = STATE(96),
    [sym_conditional_expression] = STATE(1442),
    [sym_concatenated_string] = STATE(96),
    [sym_await] = STATE(1442),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_not] = ACTIONS(160),
    [anon_sym_PLUS] = ACTIONS(162),
    [anon_sym_DASH] = ACTIONS(162),
    [anon_sym_TILDE] = ACTIONS(162),
    [anon_sym_lambda] = ACTIONS(164),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(166),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(168),
    [sym_integer] = ACTIONS(170),
    [sym_float] = ACTIONS(170),
    [sym_identifier] = ACTIONS(170),
    [sym_true] = ACTIONS(170),
    [sym_false] = ACTIONS(170),
    [sym_none] = ACTIONS(170),
    [anon_sym_await] = ACTIONS(172),
    [sym_comment] = ACTIONS(72),
  },
  [1116] = {
    [ts_builtin_sym_end] = ACTIONS(2388),
    [anon_sym_import] = ACTIONS(2390),
    [anon_sym_from] = ACTIONS(2390),
    [anon_sym_LPAREN] = ACTIONS(2388),
    [anon_sym_print] = ACTIONS(2390),
    [anon_sym_assert] = ACTIONS(2390),
    [anon_sym_return] = ACTIONS(2390),
    [anon_sym_del] = ACTIONS(2390),
    [anon_sym_raise] = ACTIONS(2390),
    [sym_pass_statement] = ACTIONS(2390),
    [sym_break_statement] = ACTIONS(2390),
    [sym_continue_statement] = ACTIONS(2390),
    [anon_sym_if] = ACTIONS(2390),
    [anon_sym_elif] = ACTIONS(2390),
    [anon_sym_else] = ACTIONS(2390),
    [anon_sym_async] = ACTIONS(2390),
    [anon_sym_for] = ACTIONS(2390),
    [anon_sym_while] = ACTIONS(2390),
    [anon_sym_try] = ACTIONS(2390),
    [anon_sym_with] = ACTIONS(2390),
    [anon_sym_def] = ACTIONS(2390),
    [anon_sym_global] = ACTIONS(2390),
    [anon_sym_nonlocal] = ACTIONS(2390),
    [anon_sym_exec] = ACTIONS(2390),
    [anon_sym_class] = ACTIONS(2390),
    [anon_sym_AT] = ACTIONS(2388),
    [anon_sym_not] = ACTIONS(2390),
    [anon_sym_PLUS] = ACTIONS(2388),
    [anon_sym_DASH] = ACTIONS(2388),
    [anon_sym_TILDE] = ACTIONS(2388),
    [anon_sym_lambda] = ACTIONS(2390),
    [anon_sym_yield] = ACTIONS(2390),
    [anon_sym_LBRACK] = ACTIONS(2388),
    [sym_ellipsis] = ACTIONS(2388),
    [anon_sym_LBRACE] = ACTIONS(2388),
    [sym_string] = ACTIONS(2388),
    [sym_integer] = ACTIONS(2390),
    [sym_float] = ACTIONS(2390),
    [sym_identifier] = ACTIONS(2390),
    [sym_true] = ACTIONS(2390),
    [sym_false] = ACTIONS(2390),
    [sym_none] = ACTIONS(2390),
    [anon_sym_await] = ACTIONS(2390),
    [sym_comment] = ACTIONS(72),
  },
  [1117] = {
    [sym__statement] = STATE(1155),
    [sym__simple_statements] = STATE(1155),
    [sym_import_statement] = STATE(746),
    [sym_import_from_statement] = STATE(746),
    [sym_print_statement] = STATE(746),
    [sym_assert_statement] = STATE(746),
    [sym_expression_statement] = STATE(746),
    [sym_return_statement] = STATE(746),
    [sym_delete_statement] = STATE(746),
    [sym_raise_statement] = STATE(746),
    [sym_if_statement] = STATE(1155),
    [sym_for_statement] = STATE(1155),
    [sym_while_statement] = STATE(1155),
    [sym_try_statement] = STATE(1155),
    [sym_with_statement] = STATE(1155),
    [sym_function_definition] = STATE(1155),
    [sym_global_statement] = STATE(746),
    [sym_nonlocal_statement] = STATE(746),
    [sym_exec_statement] = STATE(746),
    [sym_class_definition] = STATE(1155),
    [sym_decorated_definition] = STATE(1155),
    [sym_decorator] = STATE(756),
    [sym_expression_list] = STATE(32),
    [sym__expression] = STATE(33),
    [sym__primary_expression] = STATE(34),
    [sym_not_operator] = STATE(33),
    [sym_boolean_operator] = STATE(33),
    [sym_binary_operator] = STATE(34),
    [sym_unary_operator] = STATE(34),
    [sym_comparison_operator] = STATE(33),
    [sym_lambda] = STATE(33),
    [sym_assignment] = STATE(35),
    [sym_augmented_assignment] = STATE(35),
    [sym_yield] = STATE(35),
    [sym_attribute] = STATE(34),
    [sym_subscript] = STATE(34),
    [sym_call] = STATE(34),
    [sym_list] = STATE(34),
    [sym_list_comprehension] = STATE(34),
    [sym_dictionary] = STATE(34),
    [sym_dictionary_comprehension] = STATE(34),
    [sym_set] = STATE(34),
    [sym_set_comprehension] = STATE(34),
    [sym_parenthesized_expression] = STATE(34),
    [sym_tuple] = STATE(34),
    [sym_generator_expression] = STATE(34),
    [sym_conditional_expression] = STATE(33),
    [sym_concatenated_string] = STATE(34),
    [sym_await] = STATE(33),
    [aux_sym_module_repeat1] = STATE(1155),
    [aux_sym_decorated_definition_repeat1] = STATE(756),
    [sym__dedent] = ACTIONS(3141),
    [anon_sym_import] = ACTIONS(10),
    [anon_sym_from] = ACTIONS(12),
    [anon_sym_LPAREN] = ACTIONS(14),
    [anon_sym_print] = ACTIONS(16),
    [anon_sym_assert] = ACTIONS(18),
    [anon_sym_return] = ACTIONS(20),
    [anon_sym_del] = ACTIONS(22),
    [anon_sym_raise] = ACTIONS(24),
    [sym_pass_statement] = ACTIONS(1498),
    [sym_break_statement] = ACTIONS(1498),
    [sym_continue_statement] = ACTIONS(1498),
    [anon_sym_if] = ACTIONS(1500),
    [anon_sym_async] = ACTIONS(1502),
    [anon_sym_for] = ACTIONS(1504),
    [anon_sym_while] = ACTIONS(1506),
    [anon_sym_try] = ACTIONS(1508),
    [anon_sym_with] = ACTIONS(1510),
    [anon_sym_def] = ACTIONS(1512),
    [anon_sym_global] = ACTIONS(42),
    [anon_sym_nonlocal] = ACTIONS(44),
    [anon_sym_exec] = ACTIONS(46),
    [anon_sym_class] = ACTIONS(1514),
    [anon_sym_AT] = ACTIONS(50),
    [anon_sym_not] = ACTIONS(52),
    [anon_sym_PLUS] = ACTIONS(54),
    [anon_sym_DASH] = ACTIONS(54),
    [anon_sym_TILDE] = ACTIONS(54),
    [anon_sym_lambda] = ACTIONS(56),
    [anon_sym_yield] = ACTIONS(58),
    [anon_sym_LBRACK] = ACTIONS(60),
    [sym_ellipsis] = ACTIONS(62),
    [anon_sym_LBRACE] = ACTIONS(64),
    [sym_string] = ACTIONS(66),
    [sym_integer] = ACTIONS(68),
    [sym_float] = ACTIONS(68),
    [sym_identifier] = ACTIONS(68),
    [sym_true] = ACTIONS(68),
    [sym_false] = ACTIONS(68),
    [sym_none] = ACTIONS(68),
    [anon_sym_await] = ACTIONS(70),
    [sym_comment] = ACTIONS(72),
  },
  [1118] = {
    [ts_builtin_sym_end] = ACTIONS(576),
    [anon_sym_import] = ACTIONS(578),
    [anon_sym_from] = ACTIONS(578),
    [anon_sym_LPAREN] = ACTIONS(576),
    [anon_sym_print] = ACTIONS(578),
    [anon_sym_assert] = ACTIONS(578),
    [anon_sym_return] = ACTIONS(578),
    [anon_sym_del] = ACTIONS(578),
    [anon_sym_raise] = ACTIONS(578),
    [sym_pass_statement] = ACTIONS(578),
    [sym_break_statement] = ACTIONS(578),
    [sym_continue_statement] = ACTIONS(578),
    [anon_sym_if] = ACTIONS(578),
    [anon_sym_elif] = ACTIONS(578),
    [anon_sym_else] = ACTIONS(578),
    [anon_sym_async] = ACTIONS(578),
    [anon_sym_for] = ACTIONS(578),
    [anon_sym_while] = ACTIONS(578),
    [anon_sym_try] = ACTIONS(578),
    [anon_sym_with] = ACTIONS(578),
    [anon_sym_def] = ACTIONS(578),
    [anon_sym_global] = ACTIONS(578),
    [anon_sym_nonlocal] = ACTIONS(578),
    [anon_sym_exec] = ACTIONS(578),
    [anon_sym_class] = ACTIONS(578),
    [anon_sym_AT] = ACTIONS(576),
    [anon_sym_not] = ACTIONS(578),
    [anon_sym_PLUS] = ACTIONS(576),
    [anon_sym_DASH] = ACTIONS(576),
    [anon_sym_TILDE] = ACTIONS(576),
    [anon_sym_lambda] = ACTIONS(578),
    [anon_sym_yield] = ACTIONS(578),
    [anon_sym_LBRACK] = ACTIONS(576),
    [sym_ellipsis] = ACTIONS(576),
    [anon_sym_LBRACE] = ACTIONS(576),
    [sym_string] = ACTIONS(576),
    [sym_integer] = ACTIONS(578),
    [sym_float] = ACTIONS(578),
    [sym_identifier] = ACTIONS(578),
    [sym_true] = ACTIONS(578),
    [sym_false] = ACTIONS(578),
    [sym_none] = ACTIONS(578),
    [anon_sym_await] = ACTIONS(578),
    [sym_comment] = ACTIONS(72),
  },
  [1119] = {
    [sym_import_statement] = STATE(326),
    [sym_import_from_statement] = STATE(326),
    [sym_print_statement] = STATE(326),
    [sym_assert_statement] = STATE(326),
    [sym_expression_statement] = STATE(326),
    [sym_return_statement] = STATE(326),
    [sym_delete_statement] = STATE(326),
    [sym_raise_statement] = STATE(326),
    [sym_global_statement] = STATE(326),
    [sym_nonlocal_statement] = STATE(326),
    [sym_exec_statement] = STATE(326),
    [sym_expression_list] = STATE(32),
    [sym__expression] = STATE(33),
    [sym__primary_expression] = STATE(34),
    [sym_not_operator] = STATE(33),
    [sym_boolean_operator] = STATE(33),
    [sym_binary_operator] = STATE(34),
    [sym_unary_operator] = STATE(34),
    [sym_comparison_operator] = STATE(33),
    [sym_lambda] = STATE(33),
    [sym_assignment] = STATE(35),
    [sym_augmented_assignment] = STATE(35),
    [sym_yield] = STATE(35),
    [sym_attribute] = STATE(34),
    [sym_subscript] = STATE(34),
    [sym_call] = STATE(34),
    [sym_list] = STATE(34),
    [sym_list_comprehension] = STATE(34),
    [sym_dictionary] = STATE(34),
    [sym_dictionary_comprehension] = STATE(34),
    [sym_set] = STATE(34),
    [sym_set_comprehension] = STATE(34),
    [sym_parenthesized_expression] = STATE(34),
    [sym_tuple] = STATE(34),
    [sym_generator_expression] = STATE(34),
    [sym_conditional_expression] = STATE(33),
    [sym_concatenated_string] = STATE(34),
    [sym_await] = STATE(33),
    [sym__newline] = ACTIONS(3143),
    [anon_sym_import] = ACTIONS(10),
    [anon_sym_from] = ACTIONS(12),
    [anon_sym_LPAREN] = ACTIONS(14),
    [anon_sym_print] = ACTIONS(16),
    [anon_sym_assert] = ACTIONS(18),
    [anon_sym_return] = ACTIONS(20),
    [anon_sym_del] = ACTIONS(22),
    [anon_sym_raise] = ACTIONS(24),
    [sym_pass_statement] = ACTIONS(582),
    [sym_break_statement] = ACTIONS(582),
    [sym_continue_statement] = ACTIONS(582),
    [anon_sym_global] = ACTIONS(42),
    [anon_sym_nonlocal] = ACTIONS(44),
    [anon_sym_exec] = ACTIONS(46),
    [anon_sym_not] = ACTIONS(52),
    [anon_sym_PLUS] = ACTIONS(54),
    [anon_sym_DASH] = ACTIONS(54),
    [anon_sym_TILDE] = ACTIONS(54),
    [anon_sym_lambda] = ACTIONS(56),
    [anon_sym_yield] = ACTIONS(58),
    [anon_sym_LBRACK] = ACTIONS(60),
    [sym_ellipsis] = ACTIONS(62),
    [anon_sym_LBRACE] = ACTIONS(64),
    [sym_string] = ACTIONS(66),
    [sym_integer] = ACTIONS(68),
    [sym_float] = ACTIONS(68),
    [sym_identifier] = ACTIONS(68),
    [sym_true] = ACTIONS(68),
    [sym_false] = ACTIONS(68),
    [sym_none] = ACTIONS(68),
    [anon_sym_await] = ACTIONS(70),
    [sym_comment] = ACTIONS(72),
  },
  [1120] = {
    [aux_sym__simple_statements_repeat1] = STATE(328),
    [sym__newline] = ACTIONS(3143),
    [sym_comment] = ACTIONS(72),
    [sym__semicolon] = ACTIONS(3145),
  },
  [1121] = {
    [sym__expression] = STATE(1446),
    [sym__primary_expression] = STATE(96),
    [sym_not_operator] = STATE(1446),
    [sym_boolean_operator] = STATE(1446),
    [sym_binary_operator] = STATE(96),
    [sym_unary_operator] = STATE(96),
    [sym_comparison_operator] = STATE(1446),
    [sym_lambda] = STATE(1446),
    [sym_attribute] = STATE(96),
    [sym_subscript] = STATE(96),
    [sym_call] = STATE(96),
    [sym_list] = STATE(96),
    [sym_list_comprehension] = STATE(96),
    [sym_dictionary] = STATE(96),
    [sym_dictionary_comprehension] = STATE(96),
    [sym_set] = STATE(96),
    [sym_set_comprehension] = STATE(96),
    [sym_parenthesized_expression] = STATE(96),
    [sym_tuple] = STATE(96),
    [sym_generator_expression] = STATE(96),
    [sym_conditional_expression] = STATE(1446),
    [sym_concatenated_string] = STATE(96),
    [sym_await] = STATE(1446),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_not] = ACTIONS(160),
    [anon_sym_PLUS] = ACTIONS(162),
    [anon_sym_DASH] = ACTIONS(162),
    [anon_sym_TILDE] = ACTIONS(162),
    [anon_sym_lambda] = ACTIONS(164),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(166),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(168),
    [sym_integer] = ACTIONS(170),
    [sym_float] = ACTIONS(170),
    [sym_identifier] = ACTIONS(170),
    [sym_true] = ACTIONS(170),
    [sym_false] = ACTIONS(170),
    [sym_none] = ACTIONS(170),
    [anon_sym_await] = ACTIONS(172),
    [sym_comment] = ACTIONS(72),
  },
  [1122] = {
    [anon_sym_COLON] = ACTIONS(3147),
    [sym_comment] = ACTIONS(72),
  },
  [1123] = {
    [ts_builtin_sym_end] = ACTIONS(3149),
    [anon_sym_import] = ACTIONS(3151),
    [anon_sym_from] = ACTIONS(3151),
    [anon_sym_LPAREN] = ACTIONS(3149),
    [anon_sym_print] = ACTIONS(3151),
    [anon_sym_assert] = ACTIONS(3151),
    [anon_sym_return] = ACTIONS(3151),
    [anon_sym_del] = ACTIONS(3151),
    [anon_sym_raise] = ACTIONS(3151),
    [sym_pass_statement] = ACTIONS(3151),
    [sym_break_statement] = ACTIONS(3151),
    [sym_continue_statement] = ACTIONS(3151),
    [anon_sym_if] = ACTIONS(3151),
    [anon_sym_async] = ACTIONS(3151),
    [anon_sym_for] = ACTIONS(3151),
    [anon_sym_while] = ACTIONS(3151),
    [anon_sym_try] = ACTIONS(3151),
    [anon_sym_with] = ACTIONS(3151),
    [anon_sym_def] = ACTIONS(3151),
    [anon_sym_global] = ACTIONS(3151),
    [anon_sym_nonlocal] = ACTIONS(3151),
    [anon_sym_exec] = ACTIONS(3151),
    [anon_sym_class] = ACTIONS(3151),
    [anon_sym_AT] = ACTIONS(3149),
    [anon_sym_not] = ACTIONS(3151),
    [anon_sym_PLUS] = ACTIONS(3149),
    [anon_sym_DASH] = ACTIONS(3149),
    [anon_sym_TILDE] = ACTIONS(3149),
    [anon_sym_lambda] = ACTIONS(3151),
    [anon_sym_yield] = ACTIONS(3151),
    [anon_sym_LBRACK] = ACTIONS(3149),
    [sym_ellipsis] = ACTIONS(3149),
    [anon_sym_LBRACE] = ACTIONS(3149),
    [sym_string] = ACTIONS(3149),
    [sym_integer] = ACTIONS(3151),
    [sym_float] = ACTIONS(3151),
    [sym_identifier] = ACTIONS(3151),
    [sym_true] = ACTIONS(3151),
    [sym_false] = ACTIONS(3151),
    [sym_none] = ACTIONS(3151),
    [anon_sym_await] = ACTIONS(3151),
    [sym_comment] = ACTIONS(72),
  },
  [1124] = {
    [sym_elif_clause] = STATE(1449),
    [sym_else_clause] = STATE(1448),
    [aux_sym_if_statement_repeat1] = STATE(1449),
    [ts_builtin_sym_end] = ACTIONS(3149),
    [anon_sym_import] = ACTIONS(3151),
    [anon_sym_from] = ACTIONS(3151),
    [anon_sym_LPAREN] = ACTIONS(3149),
    [anon_sym_print] = ACTIONS(3151),
    [anon_sym_assert] = ACTIONS(3151),
    [anon_sym_return] = ACTIONS(3151),
    [anon_sym_del] = ACTIONS(3151),
    [anon_sym_raise] = ACTIONS(3151),
    [sym_pass_statement] = ACTIONS(3151),
    [sym_break_statement] = ACTIONS(3151),
    [sym_continue_statement] = ACTIONS(3151),
    [anon_sym_if] = ACTIONS(3151),
    [anon_sym_elif] = ACTIONS(2338),
    [anon_sym_else] = ACTIONS(2340),
    [anon_sym_async] = ACTIONS(3151),
    [anon_sym_for] = ACTIONS(3151),
    [anon_sym_while] = ACTIONS(3151),
    [anon_sym_try] = ACTIONS(3151),
    [anon_sym_with] = ACTIONS(3151),
    [anon_sym_def] = ACTIONS(3151),
    [anon_sym_global] = ACTIONS(3151),
    [anon_sym_nonlocal] = ACTIONS(3151),
    [anon_sym_exec] = ACTIONS(3151),
    [anon_sym_class] = ACTIONS(3151),
    [anon_sym_AT] = ACTIONS(3149),
    [anon_sym_not] = ACTIONS(3151),
    [anon_sym_PLUS] = ACTIONS(3149),
    [anon_sym_DASH] = ACTIONS(3149),
    [anon_sym_TILDE] = ACTIONS(3149),
    [anon_sym_lambda] = ACTIONS(3151),
    [anon_sym_yield] = ACTIONS(3151),
    [anon_sym_LBRACK] = ACTIONS(3149),
    [sym_ellipsis] = ACTIONS(3149),
    [anon_sym_LBRACE] = ACTIONS(3149),
    [sym_string] = ACTIONS(3149),
    [sym_integer] = ACTIONS(3151),
    [sym_float] = ACTIONS(3151),
    [sym_identifier] = ACTIONS(3151),
    [sym_true] = ACTIONS(3151),
    [sym_false] = ACTIONS(3151),
    [sym_none] = ACTIONS(3151),
    [anon_sym_await] = ACTIONS(3151),
    [sym_comment] = ACTIONS(72),
  },
  [1125] = {
    [sym_argument_list] = STATE(251),
    [sym_generator_expression] = STATE(251),
    [anon_sym_DOT] = ACTIONS(422),
    [anon_sym_LPAREN] = ACTIONS(424),
    [anon_sym_STAR] = ACTIONS(598),
    [anon_sym_GT_GT] = ACTIONS(600),
    [anon_sym_if] = ACTIONS(2953),
    [anon_sym_COLON] = ACTIONS(2953),
    [anon_sym_in] = ACTIONS(2953),
    [anon_sym_AT] = ACTIONS(604),
    [anon_sym_not] = ACTIONS(2953),
    [anon_sym_and] = ACTIONS(2953),
    [anon_sym_or] = ACTIONS(2953),
    [anon_sym_PLUS] = ACTIONS(608),
    [anon_sym_DASH] = ACTIONS(608),
    [anon_sym_SLASH] = ACTIONS(598),
    [anon_sym_PERCENT] = ACTIONS(604),
    [anon_sym_SLASH_SLASH] = ACTIONS(604),
    [anon_sym_STAR_STAR] = ACTIONS(610),
    [anon_sym_PIPE] = ACTIONS(612),
    [anon_sym_AMP] = ACTIONS(614),
    [anon_sym_CARET] = ACTIONS(616),
    [anon_sym_LT_LT] = ACTIONS(600),
    [anon_sym_LT] = ACTIONS(2955),
    [anon_sym_LT_EQ] = ACTIONS(2953),
    [anon_sym_EQ_EQ] = ACTIONS(2953),
    [anon_sym_BANG_EQ] = ACTIONS(2953),
    [anon_sym_GT_EQ] = ACTIONS(2953),
    [anon_sym_GT] = ACTIONS(2955),
    [anon_sym_LT_GT] = ACTIONS(2953),
    [anon_sym_is] = ACTIONS(2953),
    [anon_sym_LBRACK] = ACTIONS(450),
    [sym_comment] = ACTIONS(72),
  },
  [1126] = {
    [anon_sym_COLON] = ACTIONS(3153),
    [sym_comment] = ACTIONS(72),
  },
  [1127] = {
    [ts_builtin_sym_end] = ACTIONS(3155),
    [anon_sym_import] = ACTIONS(3157),
    [anon_sym_from] = ACTIONS(3157),
    [anon_sym_LPAREN] = ACTIONS(3155),
    [anon_sym_print] = ACTIONS(3157),
    [anon_sym_assert] = ACTIONS(3157),
    [anon_sym_return] = ACTIONS(3157),
    [anon_sym_del] = ACTIONS(3157),
    [anon_sym_raise] = ACTIONS(3157),
    [sym_pass_statement] = ACTIONS(3157),
    [sym_break_statement] = ACTIONS(3157),
    [sym_continue_statement] = ACTIONS(3157),
    [anon_sym_if] = ACTIONS(3157),
    [anon_sym_async] = ACTIONS(3157),
    [anon_sym_for] = ACTIONS(3157),
    [anon_sym_while] = ACTIONS(3157),
    [anon_sym_try] = ACTIONS(3157),
    [anon_sym_with] = ACTIONS(3157),
    [anon_sym_def] = ACTIONS(3157),
    [anon_sym_global] = ACTIONS(3157),
    [anon_sym_nonlocal] = ACTIONS(3157),
    [anon_sym_exec] = ACTIONS(3157),
    [anon_sym_class] = ACTIONS(3157),
    [anon_sym_AT] = ACTIONS(3155),
    [anon_sym_not] = ACTIONS(3157),
    [anon_sym_PLUS] = ACTIONS(3155),
    [anon_sym_DASH] = ACTIONS(3155),
    [anon_sym_TILDE] = ACTIONS(3155),
    [anon_sym_lambda] = ACTIONS(3157),
    [anon_sym_yield] = ACTIONS(3157),
    [anon_sym_LBRACK] = ACTIONS(3155),
    [sym_ellipsis] = ACTIONS(3155),
    [anon_sym_LBRACE] = ACTIONS(3155),
    [sym_string] = ACTIONS(3155),
    [sym_integer] = ACTIONS(3157),
    [sym_float] = ACTIONS(3157),
    [sym_identifier] = ACTIONS(3157),
    [sym_true] = ACTIONS(3157),
    [sym_false] = ACTIONS(3157),
    [sym_none] = ACTIONS(3157),
    [anon_sym_await] = ACTIONS(3157),
    [sym_comment] = ACTIONS(72),
  },
  [1128] = {
    [sym__simple_statements] = STATE(1451),
    [sym_import_statement] = STATE(10),
    [sym_import_from_statement] = STATE(10),
    [sym_print_statement] = STATE(10),
    [sym_assert_statement] = STATE(10),
    [sym_expression_statement] = STATE(10),
    [sym_return_statement] = STATE(10),
    [sym_delete_statement] = STATE(10),
    [sym_raise_statement] = STATE(10),
    [sym_global_statement] = STATE(10),
    [sym_nonlocal_statement] = STATE(10),
    [sym_exec_statement] = STATE(10),
    [sym__suite] = STATE(1451),
    [sym_expression_list] = STATE(32),
    [sym__expression] = STATE(33),
    [sym__primary_expression] = STATE(34),
    [sym_not_operator] = STATE(33),
    [sym_boolean_operator] = STATE(33),
    [sym_binary_operator] = STATE(34),
    [sym_unary_operator] = STATE(34),
    [sym_comparison_operator] = STATE(33),
    [sym_lambda] = STATE(33),
    [sym_assignment] = STATE(35),
    [sym_augmented_assignment] = STATE(35),
    [sym_yield] = STATE(35),
    [sym_attribute] = STATE(34),
    [sym_subscript] = STATE(34),
    [sym_call] = STATE(34),
    [sym_list] = STATE(34),
    [sym_list_comprehension] = STATE(34),
    [sym_dictionary] = STATE(34),
    [sym_dictionary_comprehension] = STATE(34),
    [sym_set] = STATE(34),
    [sym_set_comprehension] = STATE(34),
    [sym_parenthesized_expression] = STATE(34),
    [sym_tuple] = STATE(34),
    [sym_generator_expression] = STATE(34),
    [sym_conditional_expression] = STATE(33),
    [sym_concatenated_string] = STATE(34),
    [sym_await] = STATE(33),
    [sym__indent] = ACTIONS(1528),
    [anon_sym_import] = ACTIONS(10),
    [anon_sym_from] = ACTIONS(12),
    [anon_sym_LPAREN] = ACTIONS(14),
    [anon_sym_print] = ACTIONS(16),
    [anon_sym_assert] = ACTIONS(18),
    [anon_sym_return] = ACTIONS(20),
    [anon_sym_del] = ACTIONS(22),
    [anon_sym_raise] = ACTIONS(24),
    [sym_pass_statement] = ACTIONS(26),
    [sym_break_statement] = ACTIONS(26),
    [sym_continue_statement] = ACTIONS(26),
    [anon_sym_global] = ACTIONS(42),
    [anon_sym_nonlocal] = ACTIONS(44),
    [anon_sym_exec] = ACTIONS(46),
    [anon_sym_not] = ACTIONS(52),
    [anon_sym_PLUS] = ACTIONS(54),
    [anon_sym_DASH] = ACTIONS(54),
    [anon_sym_TILDE] = ACTIONS(54),
    [anon_sym_lambda] = ACTIONS(56),
    [anon_sym_yield] = ACTIONS(58),
    [anon_sym_LBRACK] = ACTIONS(60),
    [sym_ellipsis] = ACTIONS(62),
    [anon_sym_LBRACE] = ACTIONS(64),
    [sym_string] = ACTIONS(66),
    [sym_integer] = ACTIONS(68),
    [sym_float] = ACTIONS(68),
    [sym_identifier] = ACTIONS(68),
    [sym_true] = ACTIONS(68),
    [sym_false] = ACTIONS(68),
    [sym_none] = ACTIONS(68),
    [anon_sym_await] = ACTIONS(70),
    [sym_comment] = ACTIONS(72),
  },
  [1129] = {
    [sym__simple_statements] = STATE(1452),
    [sym_import_statement] = STATE(10),
    [sym_import_from_statement] = STATE(10),
    [sym_print_statement] = STATE(10),
    [sym_assert_statement] = STATE(10),
    [sym_expression_statement] = STATE(10),
    [sym_return_statement] = STATE(10),
    [sym_delete_statement] = STATE(10),
    [sym_raise_statement] = STATE(10),
    [sym_global_statement] = STATE(10),
    [sym_nonlocal_statement] = STATE(10),
    [sym_exec_statement] = STATE(10),
    [sym__suite] = STATE(1452),
    [sym_expression_list] = STATE(32),
    [sym__expression] = STATE(33),
    [sym__primary_expression] = STATE(34),
    [sym_not_operator] = STATE(33),
    [sym_boolean_operator] = STATE(33),
    [sym_binary_operator] = STATE(34),
    [sym_unary_operator] = STATE(34),
    [sym_comparison_operator] = STATE(33),
    [sym_lambda] = STATE(33),
    [sym_assignment] = STATE(35),
    [sym_augmented_assignment] = STATE(35),
    [sym_yield] = STATE(35),
    [sym_attribute] = STATE(34),
    [sym_subscript] = STATE(34),
    [sym_call] = STATE(34),
    [sym_list] = STATE(34),
    [sym_list_comprehension] = STATE(34),
    [sym_dictionary] = STATE(34),
    [sym_dictionary_comprehension] = STATE(34),
    [sym_set] = STATE(34),
    [sym_set_comprehension] = STATE(34),
    [sym_parenthesized_expression] = STATE(34),
    [sym_tuple] = STATE(34),
    [sym_generator_expression] = STATE(34),
    [sym_conditional_expression] = STATE(33),
    [sym_concatenated_string] = STATE(34),
    [sym_await] = STATE(33),
    [sym__indent] = ACTIONS(1528),
    [anon_sym_import] = ACTIONS(10),
    [anon_sym_from] = ACTIONS(12),
    [anon_sym_LPAREN] = ACTIONS(14),
    [anon_sym_print] = ACTIONS(16),
    [anon_sym_assert] = ACTIONS(18),
    [anon_sym_return] = ACTIONS(20),
    [anon_sym_del] = ACTIONS(22),
    [anon_sym_raise] = ACTIONS(24),
    [sym_pass_statement] = ACTIONS(26),
    [sym_break_statement] = ACTIONS(26),
    [sym_continue_statement] = ACTIONS(26),
    [anon_sym_global] = ACTIONS(42),
    [anon_sym_nonlocal] = ACTIONS(44),
    [anon_sym_exec] = ACTIONS(46),
    [anon_sym_not] = ACTIONS(52),
    [anon_sym_PLUS] = ACTIONS(54),
    [anon_sym_DASH] = ACTIONS(54),
    [anon_sym_TILDE] = ACTIONS(54),
    [anon_sym_lambda] = ACTIONS(56),
    [anon_sym_yield] = ACTIONS(58),
    [anon_sym_LBRACK] = ACTIONS(60),
    [sym_ellipsis] = ACTIONS(62),
    [anon_sym_LBRACE] = ACTIONS(64),
    [sym_string] = ACTIONS(66),
    [sym_integer] = ACTIONS(68),
    [sym_float] = ACTIONS(68),
    [sym_identifier] = ACTIONS(68),
    [sym_true] = ACTIONS(68),
    [sym_false] = ACTIONS(68),
    [sym_none] = ACTIONS(68),
    [anon_sym_await] = ACTIONS(70),
    [sym_comment] = ACTIONS(72),
  },
  [1130] = {
    [sym__expression] = STATE(1191),
    [sym__primary_expression] = STATE(96),
    [sym_not_operator] = STATE(1191),
    [sym_boolean_operator] = STATE(1191),
    [sym_binary_operator] = STATE(96),
    [sym_unary_operator] = STATE(96),
    [sym_comparison_operator] = STATE(1191),
    [sym_lambda] = STATE(1191),
    [sym_attribute] = STATE(96),
    [sym_subscript] = STATE(96),
    [sym_call] = STATE(96),
    [sym_type] = STATE(1453),
    [sym_list] = STATE(96),
    [sym_list_comprehension] = STATE(96),
    [sym_dictionary] = STATE(96),
    [sym_dictionary_comprehension] = STATE(96),
    [sym_set] = STATE(96),
    [sym_set_comprehension] = STATE(96),
    [sym_parenthesized_expression] = STATE(96),
    [sym_tuple] = STATE(96),
    [sym_generator_expression] = STATE(96),
    [sym_conditional_expression] = STATE(1191),
    [sym_concatenated_string] = STATE(96),
    [sym_await] = STATE(1191),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_not] = ACTIONS(160),
    [anon_sym_PLUS] = ACTIONS(162),
    [anon_sym_DASH] = ACTIONS(162),
    [anon_sym_TILDE] = ACTIONS(162),
    [anon_sym_lambda] = ACTIONS(164),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(166),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(168),
    [sym_integer] = ACTIONS(170),
    [sym_float] = ACTIONS(170),
    [sym_identifier] = ACTIONS(170),
    [sym_true] = ACTIONS(170),
    [sym_false] = ACTIONS(170),
    [sym_none] = ACTIONS(170),
    [anon_sym_await] = ACTIONS(172),
    [sym_comment] = ACTIONS(72),
  },
  [1131] = {
    [sym__simple_statements] = STATE(1454),
    [sym_import_statement] = STATE(743),
    [sym_import_from_statement] = STATE(743),
    [sym_print_statement] = STATE(743),
    [sym_assert_statement] = STATE(743),
    [sym_expression_statement] = STATE(743),
    [sym_return_statement] = STATE(743),
    [sym_delete_statement] = STATE(743),
    [sym_raise_statement] = STATE(743),
    [sym_global_statement] = STATE(743),
    [sym_nonlocal_statement] = STATE(743),
    [sym_exec_statement] = STATE(743),
    [sym__suite] = STATE(1454),
    [sym_expression_list] = STATE(32),
    [sym__expression] = STATE(33),
    [sym__primary_expression] = STATE(34),
    [sym_not_operator] = STATE(33),
    [sym_boolean_operator] = STATE(33),
    [sym_binary_operator] = STATE(34),
    [sym_unary_operator] = STATE(34),
    [sym_comparison_operator] = STATE(33),
    [sym_lambda] = STATE(33),
    [sym_assignment] = STATE(35),
    [sym_augmented_assignment] = STATE(35),
    [sym_yield] = STATE(35),
    [sym_attribute] = STATE(34),
    [sym_subscript] = STATE(34),
    [sym_call] = STATE(34),
    [sym_list] = STATE(34),
    [sym_list_comprehension] = STATE(34),
    [sym_dictionary] = STATE(34),
    [sym_dictionary_comprehension] = STATE(34),
    [sym_set] = STATE(34),
    [sym_set_comprehension] = STATE(34),
    [sym_parenthesized_expression] = STATE(34),
    [sym_tuple] = STATE(34),
    [sym_generator_expression] = STATE(34),
    [sym_conditional_expression] = STATE(33),
    [sym_concatenated_string] = STATE(34),
    [sym_await] = STATE(33),
    [sym__indent] = ACTIONS(1492),
    [anon_sym_import] = ACTIONS(10),
    [anon_sym_from] = ACTIONS(12),
    [anon_sym_LPAREN] = ACTIONS(14),
    [anon_sym_print] = ACTIONS(16),
    [anon_sym_assert] = ACTIONS(18),
    [anon_sym_return] = ACTIONS(20),
    [anon_sym_del] = ACTIONS(22),
    [anon_sym_raise] = ACTIONS(24),
    [sym_pass_statement] = ACTIONS(1494),
    [sym_break_statement] = ACTIONS(1494),
    [sym_continue_statement] = ACTIONS(1494),
    [anon_sym_global] = ACTIONS(42),
    [anon_sym_nonlocal] = ACTIONS(44),
    [anon_sym_exec] = ACTIONS(46),
    [anon_sym_not] = ACTIONS(52),
    [anon_sym_PLUS] = ACTIONS(54),
    [anon_sym_DASH] = ACTIONS(54),
    [anon_sym_TILDE] = ACTIONS(54),
    [anon_sym_lambda] = ACTIONS(56),
    [anon_sym_yield] = ACTIONS(58),
    [anon_sym_LBRACK] = ACTIONS(60),
    [sym_ellipsis] = ACTIONS(62),
    [anon_sym_LBRACE] = ACTIONS(64),
    [sym_string] = ACTIONS(66),
    [sym_integer] = ACTIONS(68),
    [sym_float] = ACTIONS(68),
    [sym_identifier] = ACTIONS(68),
    [sym_true] = ACTIONS(68),
    [sym_false] = ACTIONS(68),
    [sym_none] = ACTIONS(68),
    [anon_sym_await] = ACTIONS(70),
    [sym_comment] = ACTIONS(72),
  },
  [1132] = {
    [sym__expression] = STATE(1455),
    [sym__primary_expression] = STATE(410),
    [sym_not_operator] = STATE(1455),
    [sym_boolean_operator] = STATE(1455),
    [sym_binary_operator] = STATE(410),
    [sym_unary_operator] = STATE(410),
    [sym_comparison_operator] = STATE(1455),
    [sym_lambda] = STATE(1455),
    [sym_attribute] = STATE(410),
    [sym_subscript] = STATE(410),
    [sym_call] = STATE(410),
    [sym_list] = STATE(410),
    [sym_list_comprehension] = STATE(410),
    [sym_dictionary] = STATE(410),
    [sym_dictionary_comprehension] = STATE(410),
    [sym_set] = STATE(410),
    [sym_set_comprehension] = STATE(410),
    [sym_parenthesized_expression] = STATE(410),
    [sym_tuple] = STATE(410),
    [sym_generator_expression] = STATE(410),
    [sym_conditional_expression] = STATE(1455),
    [sym_concatenated_string] = STATE(410),
    [sym_await] = STATE(1455),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_COLON] = ACTIONS(910),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_not] = ACTIONS(726),
    [anon_sym_PLUS] = ACTIONS(728),
    [anon_sym_DASH] = ACTIONS(728),
    [anon_sym_TILDE] = ACTIONS(728),
    [anon_sym_lambda] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(732),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(734),
    [sym_integer] = ACTIONS(736),
    [sym_float] = ACTIONS(736),
    [sym_identifier] = ACTIONS(736),
    [sym_true] = ACTIONS(736),
    [sym_false] = ACTIONS(736),
    [sym_none] = ACTIONS(736),
    [anon_sym_await] = ACTIONS(738),
    [sym_comment] = ACTIONS(72),
  },
  [1133] = {
    [aux_sym_print_statement_repeat1] = STATE(1457),
    [anon_sym_COMMA] = ACTIONS(3159),
    [anon_sym_COLON] = ACTIONS(910),
    [sym_comment] = ACTIONS(72),
  },
  [1134] = {
    [sym__primary_expression] = STATE(733),
    [sym_binary_operator] = STATE(733),
    [sym_unary_operator] = STATE(733),
    [sym_attribute] = STATE(733),
    [sym_subscript] = STATE(733),
    [sym_call] = STATE(733),
    [sym_list] = STATE(733),
    [sym_list_comprehension] = STATE(733),
    [sym_dictionary] = STATE(733),
    [sym_dictionary_comprehension] = STATE(733),
    [sym_set] = STATE(733),
    [sym_set_comprehension] = STATE(733),
    [sym_parenthesized_expression] = STATE(733),
    [sym_tuple] = STATE(733),
    [sym_generator_expression] = STATE(733),
    [sym_concatenated_string] = STATE(733),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_PLUS] = ACTIONS(180),
    [anon_sym_DASH] = ACTIONS(180),
    [anon_sym_TILDE] = ACTIONS(180),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(1460),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(184),
    [sym_integer] = ACTIONS(1462),
    [sym_float] = ACTIONS(1462),
    [sym_identifier] = ACTIONS(1462),
    [sym_true] = ACTIONS(1462),
    [sym_false] = ACTIONS(1462),
    [sym_none] = ACTIONS(1462),
    [sym_comment] = ACTIONS(72),
  },
  [1135] = {
    [ts_builtin_sym_end] = ACTIONS(2388),
    [anon_sym_import] = ACTIONS(2390),
    [anon_sym_from] = ACTIONS(2390),
    [anon_sym_LPAREN] = ACTIONS(2388),
    [anon_sym_print] = ACTIONS(2390),
    [anon_sym_assert] = ACTIONS(2390),
    [anon_sym_return] = ACTIONS(2390),
    [anon_sym_del] = ACTIONS(2390),
    [anon_sym_raise] = ACTIONS(2390),
    [sym_pass_statement] = ACTIONS(2390),
    [sym_break_statement] = ACTIONS(2390),
    [sym_continue_statement] = ACTIONS(2390),
    [anon_sym_if] = ACTIONS(2390),
    [anon_sym_else] = ACTIONS(2390),
    [anon_sym_async] = ACTIONS(2390),
    [anon_sym_for] = ACTIONS(2390),
    [anon_sym_while] = ACTIONS(2390),
    [anon_sym_try] = ACTIONS(2390),
    [anon_sym_with] = ACTIONS(2390),
    [anon_sym_def] = ACTIONS(2390),
    [anon_sym_global] = ACTIONS(2390),
    [anon_sym_nonlocal] = ACTIONS(2390),
    [anon_sym_exec] = ACTIONS(2390),
    [anon_sym_class] = ACTIONS(2390),
    [anon_sym_AT] = ACTIONS(2388),
    [anon_sym_not] = ACTIONS(2390),
    [anon_sym_PLUS] = ACTIONS(2388),
    [anon_sym_DASH] = ACTIONS(2388),
    [anon_sym_TILDE] = ACTIONS(2388),
    [anon_sym_lambda] = ACTIONS(2390),
    [anon_sym_yield] = ACTIONS(2390),
    [anon_sym_LBRACK] = ACTIONS(2388),
    [sym_ellipsis] = ACTIONS(2388),
    [anon_sym_LBRACE] = ACTIONS(2388),
    [sym_string] = ACTIONS(2388),
    [sym_integer] = ACTIONS(2390),
    [sym_float] = ACTIONS(2390),
    [sym_identifier] = ACTIONS(2390),
    [sym_true] = ACTIONS(2390),
    [sym_false] = ACTIONS(2390),
    [sym_none] = ACTIONS(2390),
    [anon_sym_await] = ACTIONS(2390),
    [sym_comment] = ACTIONS(72),
  },
  [1136] = {
    [sym__statement] = STATE(1155),
    [sym__simple_statements] = STATE(1155),
    [sym_import_statement] = STATE(746),
    [sym_import_from_statement] = STATE(746),
    [sym_print_statement] = STATE(746),
    [sym_assert_statement] = STATE(746),
    [sym_expression_statement] = STATE(746),
    [sym_return_statement] = STATE(746),
    [sym_delete_statement] = STATE(746),
    [sym_raise_statement] = STATE(746),
    [sym_if_statement] = STATE(1155),
    [sym_for_statement] = STATE(1155),
    [sym_while_statement] = STATE(1155),
    [sym_try_statement] = STATE(1155),
    [sym_with_statement] = STATE(1155),
    [sym_function_definition] = STATE(1155),
    [sym_global_statement] = STATE(746),
    [sym_nonlocal_statement] = STATE(746),
    [sym_exec_statement] = STATE(746),
    [sym_class_definition] = STATE(1155),
    [sym_decorated_definition] = STATE(1155),
    [sym_decorator] = STATE(756),
    [sym_expression_list] = STATE(32),
    [sym__expression] = STATE(33),
    [sym__primary_expression] = STATE(34),
    [sym_not_operator] = STATE(33),
    [sym_boolean_operator] = STATE(33),
    [sym_binary_operator] = STATE(34),
    [sym_unary_operator] = STATE(34),
    [sym_comparison_operator] = STATE(33),
    [sym_lambda] = STATE(33),
    [sym_assignment] = STATE(35),
    [sym_augmented_assignment] = STATE(35),
    [sym_yield] = STATE(35),
    [sym_attribute] = STATE(34),
    [sym_subscript] = STATE(34),
    [sym_call] = STATE(34),
    [sym_list] = STATE(34),
    [sym_list_comprehension] = STATE(34),
    [sym_dictionary] = STATE(34),
    [sym_dictionary_comprehension] = STATE(34),
    [sym_set] = STATE(34),
    [sym_set_comprehension] = STATE(34),
    [sym_parenthesized_expression] = STATE(34),
    [sym_tuple] = STATE(34),
    [sym_generator_expression] = STATE(34),
    [sym_conditional_expression] = STATE(33),
    [sym_concatenated_string] = STATE(34),
    [sym_await] = STATE(33),
    [aux_sym_module_repeat1] = STATE(1155),
    [aux_sym_decorated_definition_repeat1] = STATE(756),
    [sym__dedent] = ACTIONS(3161),
    [anon_sym_import] = ACTIONS(10),
    [anon_sym_from] = ACTIONS(12),
    [anon_sym_LPAREN] = ACTIONS(14),
    [anon_sym_print] = ACTIONS(16),
    [anon_sym_assert] = ACTIONS(18),
    [anon_sym_return] = ACTIONS(20),
    [anon_sym_del] = ACTIONS(22),
    [anon_sym_raise] = ACTIONS(24),
    [sym_pass_statement] = ACTIONS(1498),
    [sym_break_statement] = ACTIONS(1498),
    [sym_continue_statement] = ACTIONS(1498),
    [anon_sym_if] = ACTIONS(1500),
    [anon_sym_async] = ACTIONS(1502),
    [anon_sym_for] = ACTIONS(1504),
    [anon_sym_while] = ACTIONS(1506),
    [anon_sym_try] = ACTIONS(1508),
    [anon_sym_with] = ACTIONS(1510),
    [anon_sym_def] = ACTIONS(1512),
    [anon_sym_global] = ACTIONS(42),
    [anon_sym_nonlocal] = ACTIONS(44),
    [anon_sym_exec] = ACTIONS(46),
    [anon_sym_class] = ACTIONS(1514),
    [anon_sym_AT] = ACTIONS(50),
    [anon_sym_not] = ACTIONS(52),
    [anon_sym_PLUS] = ACTIONS(54),
    [anon_sym_DASH] = ACTIONS(54),
    [anon_sym_TILDE] = ACTIONS(54),
    [anon_sym_lambda] = ACTIONS(56),
    [anon_sym_yield] = ACTIONS(58),
    [anon_sym_LBRACK] = ACTIONS(60),
    [sym_ellipsis] = ACTIONS(62),
    [anon_sym_LBRACE] = ACTIONS(64),
    [sym_string] = ACTIONS(66),
    [sym_integer] = ACTIONS(68),
    [sym_float] = ACTIONS(68),
    [sym_identifier] = ACTIONS(68),
    [sym_true] = ACTIONS(68),
    [sym_false] = ACTIONS(68),
    [sym_none] = ACTIONS(68),
    [anon_sym_await] = ACTIONS(70),
    [sym_comment] = ACTIONS(72),
  },
  [1137] = {
    [ts_builtin_sym_end] = ACTIONS(576),
    [anon_sym_import] = ACTIONS(578),
    [anon_sym_from] = ACTIONS(578),
    [anon_sym_LPAREN] = ACTIONS(576),
    [anon_sym_print] = ACTIONS(578),
    [anon_sym_assert] = ACTIONS(578),
    [anon_sym_return] = ACTIONS(578),
    [anon_sym_del] = ACTIONS(578),
    [anon_sym_raise] = ACTIONS(578),
    [sym_pass_statement] = ACTIONS(578),
    [sym_break_statement] = ACTIONS(578),
    [sym_continue_statement] = ACTIONS(578),
    [anon_sym_if] = ACTIONS(578),
    [anon_sym_else] = ACTIONS(578),
    [anon_sym_async] = ACTIONS(578),
    [anon_sym_for] = ACTIONS(578),
    [anon_sym_while] = ACTIONS(578),
    [anon_sym_try] = ACTIONS(578),
    [anon_sym_with] = ACTIONS(578),
    [anon_sym_def] = ACTIONS(578),
    [anon_sym_global] = ACTIONS(578),
    [anon_sym_nonlocal] = ACTIONS(578),
    [anon_sym_exec] = ACTIONS(578),
    [anon_sym_class] = ACTIONS(578),
    [anon_sym_AT] = ACTIONS(576),
    [anon_sym_not] = ACTIONS(578),
    [anon_sym_PLUS] = ACTIONS(576),
    [anon_sym_DASH] = ACTIONS(576),
    [anon_sym_TILDE] = ACTIONS(576),
    [anon_sym_lambda] = ACTIONS(578),
    [anon_sym_yield] = ACTIONS(578),
    [anon_sym_LBRACK] = ACTIONS(576),
    [sym_ellipsis] = ACTIONS(576),
    [anon_sym_LBRACE] = ACTIONS(576),
    [sym_string] = ACTIONS(576),
    [sym_integer] = ACTIONS(578),
    [sym_float] = ACTIONS(578),
    [sym_identifier] = ACTIONS(578),
    [sym_true] = ACTIONS(578),
    [sym_false] = ACTIONS(578),
    [sym_none] = ACTIONS(578),
    [anon_sym_await] = ACTIONS(578),
    [sym_comment] = ACTIONS(72),
  },
  [1138] = {
    [sym_import_statement] = STATE(326),
    [sym_import_from_statement] = STATE(326),
    [sym_print_statement] = STATE(326),
    [sym_assert_statement] = STATE(326),
    [sym_expression_statement] = STATE(326),
    [sym_return_statement] = STATE(326),
    [sym_delete_statement] = STATE(326),
    [sym_raise_statement] = STATE(326),
    [sym_global_statement] = STATE(326),
    [sym_nonlocal_statement] = STATE(326),
    [sym_exec_statement] = STATE(326),
    [sym_expression_list] = STATE(32),
    [sym__expression] = STATE(33),
    [sym__primary_expression] = STATE(34),
    [sym_not_operator] = STATE(33),
    [sym_boolean_operator] = STATE(33),
    [sym_binary_operator] = STATE(34),
    [sym_unary_operator] = STATE(34),
    [sym_comparison_operator] = STATE(33),
    [sym_lambda] = STATE(33),
    [sym_assignment] = STATE(35),
    [sym_augmented_assignment] = STATE(35),
    [sym_yield] = STATE(35),
    [sym_attribute] = STATE(34),
    [sym_subscript] = STATE(34),
    [sym_call] = STATE(34),
    [sym_list] = STATE(34),
    [sym_list_comprehension] = STATE(34),
    [sym_dictionary] = STATE(34),
    [sym_dictionary_comprehension] = STATE(34),
    [sym_set] = STATE(34),
    [sym_set_comprehension] = STATE(34),
    [sym_parenthesized_expression] = STATE(34),
    [sym_tuple] = STATE(34),
    [sym_generator_expression] = STATE(34),
    [sym_conditional_expression] = STATE(33),
    [sym_concatenated_string] = STATE(34),
    [sym_await] = STATE(33),
    [sym__newline] = ACTIONS(3163),
    [anon_sym_import] = ACTIONS(10),
    [anon_sym_from] = ACTIONS(12),
    [anon_sym_LPAREN] = ACTIONS(14),
    [anon_sym_print] = ACTIONS(16),
    [anon_sym_assert] = ACTIONS(18),
    [anon_sym_return] = ACTIONS(20),
    [anon_sym_del] = ACTIONS(22),
    [anon_sym_raise] = ACTIONS(24),
    [sym_pass_statement] = ACTIONS(582),
    [sym_break_statement] = ACTIONS(582),
    [sym_continue_statement] = ACTIONS(582),
    [anon_sym_global] = ACTIONS(42),
    [anon_sym_nonlocal] = ACTIONS(44),
    [anon_sym_exec] = ACTIONS(46),
    [anon_sym_not] = ACTIONS(52),
    [anon_sym_PLUS] = ACTIONS(54),
    [anon_sym_DASH] = ACTIONS(54),
    [anon_sym_TILDE] = ACTIONS(54),
    [anon_sym_lambda] = ACTIONS(56),
    [anon_sym_yield] = ACTIONS(58),
    [anon_sym_LBRACK] = ACTIONS(60),
    [sym_ellipsis] = ACTIONS(62),
    [anon_sym_LBRACE] = ACTIONS(64),
    [sym_string] = ACTIONS(66),
    [sym_integer] = ACTIONS(68),
    [sym_float] = ACTIONS(68),
    [sym_identifier] = ACTIONS(68),
    [sym_true] = ACTIONS(68),
    [sym_false] = ACTIONS(68),
    [sym_none] = ACTIONS(68),
    [anon_sym_await] = ACTIONS(70),
    [sym_comment] = ACTIONS(72),
  },
  [1139] = {
    [aux_sym__simple_statements_repeat1] = STATE(328),
    [sym__newline] = ACTIONS(3163),
    [sym_comment] = ACTIONS(72),
    [sym__semicolon] = ACTIONS(3165),
  },
  [1140] = {
    [ts_builtin_sym_end] = ACTIONS(3167),
    [anon_sym_import] = ACTIONS(3169),
    [anon_sym_from] = ACTIONS(3169),
    [anon_sym_LPAREN] = ACTIONS(3167),
    [anon_sym_print] = ACTIONS(3169),
    [anon_sym_assert] = ACTIONS(3169),
    [anon_sym_return] = ACTIONS(3169),
    [anon_sym_del] = ACTIONS(3169),
    [anon_sym_raise] = ACTIONS(3169),
    [sym_pass_statement] = ACTIONS(3169),
    [sym_break_statement] = ACTIONS(3169),
    [sym_continue_statement] = ACTIONS(3169),
    [anon_sym_if] = ACTIONS(3169),
    [anon_sym_async] = ACTIONS(3169),
    [anon_sym_for] = ACTIONS(3169),
    [anon_sym_while] = ACTIONS(3169),
    [anon_sym_try] = ACTIONS(3169),
    [anon_sym_with] = ACTIONS(3169),
    [anon_sym_def] = ACTIONS(3169),
    [anon_sym_global] = ACTIONS(3169),
    [anon_sym_nonlocal] = ACTIONS(3169),
    [anon_sym_exec] = ACTIONS(3169),
    [anon_sym_class] = ACTIONS(3169),
    [anon_sym_AT] = ACTIONS(3167),
    [anon_sym_not] = ACTIONS(3169),
    [anon_sym_PLUS] = ACTIONS(3167),
    [anon_sym_DASH] = ACTIONS(3167),
    [anon_sym_TILDE] = ACTIONS(3167),
    [anon_sym_lambda] = ACTIONS(3169),
    [anon_sym_yield] = ACTIONS(3169),
    [anon_sym_LBRACK] = ACTIONS(3167),
    [sym_ellipsis] = ACTIONS(3167),
    [anon_sym_LBRACE] = ACTIONS(3167),
    [sym_string] = ACTIONS(3167),
    [sym_integer] = ACTIONS(3169),
    [sym_float] = ACTIONS(3169),
    [sym_identifier] = ACTIONS(3169),
    [sym_true] = ACTIONS(3169),
    [sym_false] = ACTIONS(3169),
    [sym_none] = ACTIONS(3169),
    [anon_sym_await] = ACTIONS(3169),
    [sym_comment] = ACTIONS(72),
  },
  [1141] = {
    [sym__dedent] = ACTIONS(576),
    [anon_sym_import] = ACTIONS(578),
    [anon_sym_from] = ACTIONS(578),
    [anon_sym_LPAREN] = ACTIONS(576),
    [anon_sym_print] = ACTIONS(578),
    [anon_sym_assert] = ACTIONS(578),
    [anon_sym_return] = ACTIONS(578),
    [anon_sym_del] = ACTIONS(578),
    [anon_sym_raise] = ACTIONS(578),
    [sym_pass_statement] = ACTIONS(578),
    [sym_break_statement] = ACTIONS(578),
    [sym_continue_statement] = ACTIONS(578),
    [anon_sym_if] = ACTIONS(578),
    [anon_sym_async] = ACTIONS(578),
    [anon_sym_for] = ACTIONS(578),
    [anon_sym_while] = ACTIONS(578),
    [anon_sym_try] = ACTIONS(578),
    [anon_sym_with] = ACTIONS(578),
    [anon_sym_def] = ACTIONS(578),
    [anon_sym_global] = ACTIONS(578),
    [anon_sym_nonlocal] = ACTIONS(578),
    [anon_sym_exec] = ACTIONS(578),
    [anon_sym_class] = ACTIONS(578),
    [anon_sym_AT] = ACTIONS(576),
    [anon_sym_not] = ACTIONS(578),
    [anon_sym_PLUS] = ACTIONS(576),
    [anon_sym_DASH] = ACTIONS(576),
    [anon_sym_TILDE] = ACTIONS(576),
    [anon_sym_lambda] = ACTIONS(578),
    [anon_sym_yield] = ACTIONS(578),
    [anon_sym_LBRACK] = ACTIONS(576),
    [sym_ellipsis] = ACTIONS(576),
    [anon_sym_LBRACE] = ACTIONS(576),
    [sym_string] = ACTIONS(576),
    [sym_integer] = ACTIONS(578),
    [sym_float] = ACTIONS(578),
    [sym_identifier] = ACTIONS(578),
    [sym_true] = ACTIONS(578),
    [sym_false] = ACTIONS(578),
    [sym_none] = ACTIONS(578),
    [anon_sym_await] = ACTIONS(578),
    [sym_comment] = ACTIONS(72),
  },
  [1142] = {
    [sym_import_statement] = STATE(326),
    [sym_import_from_statement] = STATE(326),
    [sym_print_statement] = STATE(326),
    [sym_assert_statement] = STATE(326),
    [sym_expression_statement] = STATE(326),
    [sym_return_statement] = STATE(326),
    [sym_delete_statement] = STATE(326),
    [sym_raise_statement] = STATE(326),
    [sym_global_statement] = STATE(326),
    [sym_nonlocal_statement] = STATE(326),
    [sym_exec_statement] = STATE(326),
    [sym_expression_list] = STATE(32),
    [sym__expression] = STATE(33),
    [sym__primary_expression] = STATE(34),
    [sym_not_operator] = STATE(33),
    [sym_boolean_operator] = STATE(33),
    [sym_binary_operator] = STATE(34),
    [sym_unary_operator] = STATE(34),
    [sym_comparison_operator] = STATE(33),
    [sym_lambda] = STATE(33),
    [sym_assignment] = STATE(35),
    [sym_augmented_assignment] = STATE(35),
    [sym_yield] = STATE(35),
    [sym_attribute] = STATE(34),
    [sym_subscript] = STATE(34),
    [sym_call] = STATE(34),
    [sym_list] = STATE(34),
    [sym_list_comprehension] = STATE(34),
    [sym_dictionary] = STATE(34),
    [sym_dictionary_comprehension] = STATE(34),
    [sym_set] = STATE(34),
    [sym_set_comprehension] = STATE(34),
    [sym_parenthesized_expression] = STATE(34),
    [sym_tuple] = STATE(34),
    [sym_generator_expression] = STATE(34),
    [sym_conditional_expression] = STATE(33),
    [sym_concatenated_string] = STATE(34),
    [sym_await] = STATE(33),
    [sym__newline] = ACTIONS(3171),
    [anon_sym_import] = ACTIONS(10),
    [anon_sym_from] = ACTIONS(12),
    [anon_sym_LPAREN] = ACTIONS(14),
    [anon_sym_print] = ACTIONS(16),
    [anon_sym_assert] = ACTIONS(18),
    [anon_sym_return] = ACTIONS(20),
    [anon_sym_del] = ACTIONS(22),
    [anon_sym_raise] = ACTIONS(24),
    [sym_pass_statement] = ACTIONS(582),
    [sym_break_statement] = ACTIONS(582),
    [sym_continue_statement] = ACTIONS(582),
    [anon_sym_global] = ACTIONS(42),
    [anon_sym_nonlocal] = ACTIONS(44),
    [anon_sym_exec] = ACTIONS(46),
    [anon_sym_not] = ACTIONS(52),
    [anon_sym_PLUS] = ACTIONS(54),
    [anon_sym_DASH] = ACTIONS(54),
    [anon_sym_TILDE] = ACTIONS(54),
    [anon_sym_lambda] = ACTIONS(56),
    [anon_sym_yield] = ACTIONS(58),
    [anon_sym_LBRACK] = ACTIONS(60),
    [sym_ellipsis] = ACTIONS(62),
    [anon_sym_LBRACE] = ACTIONS(64),
    [sym_string] = ACTIONS(66),
    [sym_integer] = ACTIONS(68),
    [sym_float] = ACTIONS(68),
    [sym_identifier] = ACTIONS(68),
    [sym_true] = ACTIONS(68),
    [sym_false] = ACTIONS(68),
    [sym_none] = ACTIONS(68),
    [anon_sym_await] = ACTIONS(70),
    [sym_comment] = ACTIONS(72),
  },
  [1143] = {
    [aux_sym__simple_statements_repeat1] = STATE(328),
    [sym__newline] = ACTIONS(3171),
    [sym_comment] = ACTIONS(72),
    [sym__semicolon] = ACTIONS(3173),
  },
  [1144] = {
    [anon_sym_if] = ACTIONS(590),
    [anon_sym_COLON] = ACTIONS(3175),
    [anon_sym_and] = ACTIONS(594),
    [anon_sym_or] = ACTIONS(596),
    [sym_comment] = ACTIONS(72),
  },
  [1145] = {
    [sym_variables] = STATE(1464),
    [sym__primary_expression] = STATE(103),
    [sym_binary_operator] = STATE(103),
    [sym_unary_operator] = STATE(103),
    [sym_attribute] = STATE(103),
    [sym_subscript] = STATE(103),
    [sym_call] = STATE(103),
    [sym_list] = STATE(103),
    [sym_list_comprehension] = STATE(103),
    [sym_dictionary] = STATE(103),
    [sym_dictionary_comprehension] = STATE(103),
    [sym_set] = STATE(103),
    [sym_set_comprehension] = STATE(103),
    [sym_parenthesized_expression] = STATE(103),
    [sym_tuple] = STATE(103),
    [sym_generator_expression] = STATE(103),
    [sym_concatenated_string] = STATE(103),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_PLUS] = ACTIONS(180),
    [anon_sym_DASH] = ACTIONS(180),
    [anon_sym_TILDE] = ACTIONS(180),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(182),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(184),
    [sym_integer] = ACTIONS(186),
    [sym_float] = ACTIONS(186),
    [sym_identifier] = ACTIONS(186),
    [sym_true] = ACTIONS(186),
    [sym_false] = ACTIONS(186),
    [sym_none] = ACTIONS(186),
    [sym_comment] = ACTIONS(72),
  },
  [1146] = {
    [sym_with_item] = STATE(1465),
    [sym__expression] = STATE(112),
    [sym__primary_expression] = STATE(113),
    [sym_not_operator] = STATE(112),
    [sym_boolean_operator] = STATE(112),
    [sym_binary_operator] = STATE(113),
    [sym_unary_operator] = STATE(113),
    [sym_comparison_operator] = STATE(112),
    [sym_lambda] = STATE(112),
    [sym_attribute] = STATE(113),
    [sym_subscript] = STATE(113),
    [sym_call] = STATE(113),
    [sym_list] = STATE(113),
    [sym_list_comprehension] = STATE(113),
    [sym_dictionary] = STATE(113),
    [sym_dictionary_comprehension] = STATE(113),
    [sym_set] = STATE(113),
    [sym_set_comprehension] = STATE(113),
    [sym_parenthesized_expression] = STATE(113),
    [sym_tuple] = STATE(113),
    [sym_generator_expression] = STATE(113),
    [sym_conditional_expression] = STATE(112),
    [sym_concatenated_string] = STATE(113),
    [sym_await] = STATE(112),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_not] = ACTIONS(190),
    [anon_sym_PLUS] = ACTIONS(192),
    [anon_sym_DASH] = ACTIONS(192),
    [anon_sym_TILDE] = ACTIONS(192),
    [anon_sym_lambda] = ACTIONS(194),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(196),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(198),
    [sym_integer] = ACTIONS(200),
    [sym_float] = ACTIONS(200),
    [sym_identifier] = ACTIONS(200),
    [sym_true] = ACTIONS(200),
    [sym_false] = ACTIONS(200),
    [sym_none] = ACTIONS(200),
    [anon_sym_await] = ACTIONS(202),
    [sym_comment] = ACTIONS(72),
  },
  [1147] = {
    [sym_identifier] = ACTIONS(3177),
    [sym_comment] = ACTIONS(72),
  },
  [1148] = {
    [anon_sym_in] = ACTIONS(3179),
    [sym_comment] = ACTIONS(72),
  },
  [1149] = {
    [anon_sym_if] = ACTIONS(590),
    [anon_sym_COLON] = ACTIONS(3181),
    [anon_sym_and] = ACTIONS(594),
    [anon_sym_or] = ACTIONS(596),
    [sym_comment] = ACTIONS(72),
  },
  [1150] = {
    [sym__simple_statements] = STATE(1469),
    [sym_import_statement] = STATE(364),
    [sym_import_from_statement] = STATE(364),
    [sym_print_statement] = STATE(364),
    [sym_assert_statement] = STATE(364),
    [sym_expression_statement] = STATE(364),
    [sym_return_statement] = STATE(364),
    [sym_delete_statement] = STATE(364),
    [sym_raise_statement] = STATE(364),
    [sym_global_statement] = STATE(364),
    [sym_nonlocal_statement] = STATE(364),
    [sym_exec_statement] = STATE(364),
    [sym__suite] = STATE(1469),
    [sym_expression_list] = STATE(32),
    [sym__expression] = STATE(33),
    [sym__primary_expression] = STATE(34),
    [sym_not_operator] = STATE(33),
    [sym_boolean_operator] = STATE(33),
    [sym_binary_operator] = STATE(34),
    [sym_unary_operator] = STATE(34),
    [sym_comparison_operator] = STATE(33),
    [sym_lambda] = STATE(33),
    [sym_assignment] = STATE(35),
    [sym_augmented_assignment] = STATE(35),
    [sym_yield] = STATE(35),
    [sym_attribute] = STATE(34),
    [sym_subscript] = STATE(34),
    [sym_call] = STATE(34),
    [sym_list] = STATE(34),
    [sym_list_comprehension] = STATE(34),
    [sym_dictionary] = STATE(34),
    [sym_dictionary_comprehension] = STATE(34),
    [sym_set] = STATE(34),
    [sym_set_comprehension] = STATE(34),
    [sym_parenthesized_expression] = STATE(34),
    [sym_tuple] = STATE(34),
    [sym_generator_expression] = STATE(34),
    [sym_conditional_expression] = STATE(33),
    [sym_concatenated_string] = STATE(34),
    [sym_await] = STATE(33),
    [sym__indent] = ACTIONS(650),
    [anon_sym_import] = ACTIONS(10),
    [anon_sym_from] = ACTIONS(12),
    [anon_sym_LPAREN] = ACTIONS(14),
    [anon_sym_print] = ACTIONS(16),
    [anon_sym_assert] = ACTIONS(18),
    [anon_sym_return] = ACTIONS(20),
    [anon_sym_del] = ACTIONS(22),
    [anon_sym_raise] = ACTIONS(24),
    [sym_pass_statement] = ACTIONS(652),
    [sym_break_statement] = ACTIONS(652),
    [sym_continue_statement] = ACTIONS(652),
    [anon_sym_global] = ACTIONS(42),
    [anon_sym_nonlocal] = ACTIONS(44),
    [anon_sym_exec] = ACTIONS(46),
    [anon_sym_not] = ACTIONS(52),
    [anon_sym_PLUS] = ACTIONS(54),
    [anon_sym_DASH] = ACTIONS(54),
    [anon_sym_TILDE] = ACTIONS(54),
    [anon_sym_lambda] = ACTIONS(56),
    [anon_sym_yield] = ACTIONS(58),
    [anon_sym_LBRACK] = ACTIONS(60),
    [sym_ellipsis] = ACTIONS(62),
    [anon_sym_LBRACE] = ACTIONS(64),
    [sym_string] = ACTIONS(66),
    [sym_integer] = ACTIONS(68),
    [sym_float] = ACTIONS(68),
    [sym_identifier] = ACTIONS(68),
    [sym_true] = ACTIONS(68),
    [sym_false] = ACTIONS(68),
    [sym_none] = ACTIONS(68),
    [anon_sym_await] = ACTIONS(70),
    [sym_comment] = ACTIONS(72),
  },
  [1151] = {
    [aux_sym_with_statement_repeat1] = STATE(1471),
    [anon_sym_COMMA] = ACTIONS(658),
    [anon_sym_COLON] = ACTIONS(3183),
    [sym_comment] = ACTIONS(72),
  },
  [1152] = {
    [sym_parameters] = STATE(1472),
    [anon_sym_LPAREN] = ACTIONS(696),
    [sym_comment] = ACTIONS(72),
  },
  [1153] = {
    [sym_argument_list] = STATE(1474),
    [anon_sym_LPAREN] = ACTIONS(708),
    [anon_sym_COLON] = ACTIONS(3185),
    [sym_comment] = ACTIONS(72),
  },
  [1154] = {
    [ts_builtin_sym_end] = ACTIONS(3187),
    [anon_sym_import] = ACTIONS(3189),
    [anon_sym_from] = ACTIONS(3189),
    [anon_sym_LPAREN] = ACTIONS(3187),
    [anon_sym_print] = ACTIONS(3189),
    [anon_sym_assert] = ACTIONS(3189),
    [anon_sym_return] = ACTIONS(3189),
    [anon_sym_del] = ACTIONS(3189),
    [anon_sym_raise] = ACTIONS(3189),
    [sym_pass_statement] = ACTIONS(3189),
    [sym_break_statement] = ACTIONS(3189),
    [sym_continue_statement] = ACTIONS(3189),
    [anon_sym_if] = ACTIONS(3189),
    [anon_sym_else] = ACTIONS(3189),
    [anon_sym_async] = ACTIONS(3189),
    [anon_sym_for] = ACTIONS(3189),
    [anon_sym_while] = ACTIONS(3189),
    [anon_sym_try] = ACTIONS(3189),
    [anon_sym_except] = ACTIONS(3189),
    [anon_sym_finally] = ACTIONS(3189),
    [anon_sym_with] = ACTIONS(3189),
    [anon_sym_def] = ACTIONS(3189),
    [anon_sym_global] = ACTIONS(3189),
    [anon_sym_nonlocal] = ACTIONS(3189),
    [anon_sym_exec] = ACTIONS(3189),
    [anon_sym_class] = ACTIONS(3189),
    [anon_sym_AT] = ACTIONS(3187),
    [anon_sym_not] = ACTIONS(3189),
    [anon_sym_PLUS] = ACTIONS(3187),
    [anon_sym_DASH] = ACTIONS(3187),
    [anon_sym_TILDE] = ACTIONS(3187),
    [anon_sym_lambda] = ACTIONS(3189),
    [anon_sym_yield] = ACTIONS(3189),
    [anon_sym_LBRACK] = ACTIONS(3187),
    [sym_ellipsis] = ACTIONS(3187),
    [anon_sym_LBRACE] = ACTIONS(3187),
    [sym_string] = ACTIONS(3187),
    [sym_integer] = ACTIONS(3189),
    [sym_float] = ACTIONS(3189),
    [sym_identifier] = ACTIONS(3189),
    [sym_true] = ACTIONS(3189),
    [sym_false] = ACTIONS(3189),
    [sym_none] = ACTIONS(3189),
    [anon_sym_await] = ACTIONS(3189),
    [sym_comment] = ACTIONS(72),
  },
  [1155] = {
    [sym__statement] = STATE(1155),
    [sym__simple_statements] = STATE(1155),
    [sym_import_statement] = STATE(746),
    [sym_import_from_statement] = STATE(746),
    [sym_print_statement] = STATE(746),
    [sym_assert_statement] = STATE(746),
    [sym_expression_statement] = STATE(746),
    [sym_return_statement] = STATE(746),
    [sym_delete_statement] = STATE(746),
    [sym_raise_statement] = STATE(746),
    [sym_if_statement] = STATE(1155),
    [sym_for_statement] = STATE(1155),
    [sym_while_statement] = STATE(1155),
    [sym_try_statement] = STATE(1155),
    [sym_with_statement] = STATE(1155),
    [sym_function_definition] = STATE(1155),
    [sym_global_statement] = STATE(746),
    [sym_nonlocal_statement] = STATE(746),
    [sym_exec_statement] = STATE(746),
    [sym_class_definition] = STATE(1155),
    [sym_decorated_definition] = STATE(1155),
    [sym_decorator] = STATE(756),
    [sym_expression_list] = STATE(32),
    [sym__expression] = STATE(33),
    [sym__primary_expression] = STATE(34),
    [sym_not_operator] = STATE(33),
    [sym_boolean_operator] = STATE(33),
    [sym_binary_operator] = STATE(34),
    [sym_unary_operator] = STATE(34),
    [sym_comparison_operator] = STATE(33),
    [sym_lambda] = STATE(33),
    [sym_assignment] = STATE(35),
    [sym_augmented_assignment] = STATE(35),
    [sym_yield] = STATE(35),
    [sym_attribute] = STATE(34),
    [sym_subscript] = STATE(34),
    [sym_call] = STATE(34),
    [sym_list] = STATE(34),
    [sym_list_comprehension] = STATE(34),
    [sym_dictionary] = STATE(34),
    [sym_dictionary_comprehension] = STATE(34),
    [sym_set] = STATE(34),
    [sym_set_comprehension] = STATE(34),
    [sym_parenthesized_expression] = STATE(34),
    [sym_tuple] = STATE(34),
    [sym_generator_expression] = STATE(34),
    [sym_conditional_expression] = STATE(33),
    [sym_concatenated_string] = STATE(34),
    [sym_await] = STATE(33),
    [aux_sym_module_repeat1] = STATE(1155),
    [aux_sym_decorated_definition_repeat1] = STATE(756),
    [sym__dedent] = ACTIONS(1002),
    [anon_sym_import] = ACTIONS(1004),
    [anon_sym_from] = ACTIONS(1007),
    [anon_sym_LPAREN] = ACTIONS(1010),
    [anon_sym_print] = ACTIONS(1013),
    [anon_sym_assert] = ACTIONS(1016),
    [anon_sym_return] = ACTIONS(1019),
    [anon_sym_del] = ACTIONS(1022),
    [anon_sym_raise] = ACTIONS(1025),
    [sym_pass_statement] = ACTIONS(3191),
    [sym_break_statement] = ACTIONS(3191),
    [sym_continue_statement] = ACTIONS(3191),
    [anon_sym_if] = ACTIONS(3194),
    [anon_sym_async] = ACTIONS(3197),
    [anon_sym_for] = ACTIONS(3200),
    [anon_sym_while] = ACTIONS(3203),
    [anon_sym_try] = ACTIONS(3206),
    [anon_sym_with] = ACTIONS(3209),
    [anon_sym_def] = ACTIONS(3212),
    [anon_sym_global] = ACTIONS(1052),
    [anon_sym_nonlocal] = ACTIONS(1055),
    [anon_sym_exec] = ACTIONS(1058),
    [anon_sym_class] = ACTIONS(3215),
    [anon_sym_AT] = ACTIONS(1064),
    [anon_sym_not] = ACTIONS(1067),
    [anon_sym_PLUS] = ACTIONS(1070),
    [anon_sym_DASH] = ACTIONS(1070),
    [anon_sym_TILDE] = ACTIONS(1070),
    [anon_sym_lambda] = ACTIONS(1073),
    [anon_sym_yield] = ACTIONS(1076),
    [anon_sym_LBRACK] = ACTIONS(1079),
    [sym_ellipsis] = ACTIONS(1082),
    [anon_sym_LBRACE] = ACTIONS(1085),
    [sym_string] = ACTIONS(1088),
    [sym_integer] = ACTIONS(1091),
    [sym_float] = ACTIONS(1091),
    [sym_identifier] = ACTIONS(1091),
    [sym_true] = ACTIONS(1091),
    [sym_false] = ACTIONS(1091),
    [sym_none] = ACTIONS(1091),
    [anon_sym_await] = ACTIONS(1094),
    [sym_comment] = ACTIONS(72),
  },
  [1156] = {
    [anon_sym_def] = ACTIONS(2400),
    [sym_comment] = ACTIONS(72),
  },
  [1157] = {
    [sym__dedent] = ACTIONS(1097),
    [anon_sym_import] = ACTIONS(1099),
    [anon_sym_from] = ACTIONS(1099),
    [anon_sym_LPAREN] = ACTIONS(1097),
    [anon_sym_print] = ACTIONS(1099),
    [anon_sym_assert] = ACTIONS(1099),
    [anon_sym_return] = ACTIONS(1099),
    [anon_sym_del] = ACTIONS(1099),
    [anon_sym_raise] = ACTIONS(1099),
    [sym_pass_statement] = ACTIONS(1099),
    [sym_break_statement] = ACTIONS(1099),
    [sym_continue_statement] = ACTIONS(1099),
    [anon_sym_if] = ACTIONS(1099),
    [anon_sym_async] = ACTIONS(1099),
    [anon_sym_for] = ACTIONS(1099),
    [anon_sym_while] = ACTIONS(1099),
    [anon_sym_try] = ACTIONS(1099),
    [anon_sym_with] = ACTIONS(1099),
    [anon_sym_def] = ACTIONS(1099),
    [anon_sym_global] = ACTIONS(1099),
    [anon_sym_nonlocal] = ACTIONS(1099),
    [anon_sym_exec] = ACTIONS(1099),
    [anon_sym_class] = ACTIONS(1099),
    [anon_sym_AT] = ACTIONS(1097),
    [anon_sym_not] = ACTIONS(1099),
    [anon_sym_PLUS] = ACTIONS(1097),
    [anon_sym_DASH] = ACTIONS(1097),
    [anon_sym_TILDE] = ACTIONS(1097),
    [anon_sym_lambda] = ACTIONS(1099),
    [anon_sym_yield] = ACTIONS(1099),
    [anon_sym_LBRACK] = ACTIONS(1097),
    [sym_ellipsis] = ACTIONS(1097),
    [anon_sym_LBRACE] = ACTIONS(1097),
    [sym_string] = ACTIONS(1097),
    [sym_integer] = ACTIONS(1099),
    [sym_float] = ACTIONS(1099),
    [sym_identifier] = ACTIONS(1099),
    [sym_true] = ACTIONS(1099),
    [sym_false] = ACTIONS(1099),
    [sym_none] = ACTIONS(1099),
    [anon_sym_await] = ACTIONS(1099),
    [sym_comment] = ACTIONS(72),
  },
  [1158] = {
    [ts_builtin_sym_end] = ACTIONS(1401),
    [anon_sym_import] = ACTIONS(1403),
    [anon_sym_from] = ACTIONS(1403),
    [anon_sym_LPAREN] = ACTIONS(1401),
    [anon_sym_print] = ACTIONS(1403),
    [anon_sym_assert] = ACTIONS(1403),
    [anon_sym_return] = ACTIONS(1403),
    [anon_sym_del] = ACTIONS(1403),
    [anon_sym_raise] = ACTIONS(1403),
    [sym_pass_statement] = ACTIONS(1403),
    [sym_break_statement] = ACTIONS(1403),
    [sym_continue_statement] = ACTIONS(1403),
    [anon_sym_if] = ACTIONS(1403),
    [anon_sym_else] = ACTIONS(1403),
    [anon_sym_async] = ACTIONS(1403),
    [anon_sym_for] = ACTIONS(1403),
    [anon_sym_while] = ACTIONS(1403),
    [anon_sym_try] = ACTIONS(1403),
    [anon_sym_except] = ACTIONS(1403),
    [anon_sym_finally] = ACTIONS(1403),
    [anon_sym_with] = ACTIONS(1403),
    [anon_sym_def] = ACTIONS(1403),
    [anon_sym_global] = ACTIONS(1403),
    [anon_sym_nonlocal] = ACTIONS(1403),
    [anon_sym_exec] = ACTIONS(1403),
    [anon_sym_class] = ACTIONS(1403),
    [anon_sym_AT] = ACTIONS(1401),
    [anon_sym_not] = ACTIONS(1403),
    [anon_sym_PLUS] = ACTIONS(1401),
    [anon_sym_DASH] = ACTIONS(1401),
    [anon_sym_TILDE] = ACTIONS(1401),
    [anon_sym_lambda] = ACTIONS(1403),
    [anon_sym_yield] = ACTIONS(1403),
    [anon_sym_LBRACK] = ACTIONS(1401),
    [sym_ellipsis] = ACTIONS(1401),
    [anon_sym_LBRACE] = ACTIONS(1401),
    [sym_string] = ACTIONS(1401),
    [sym_integer] = ACTIONS(1403),
    [sym_float] = ACTIONS(1403),
    [sym_identifier] = ACTIONS(1403),
    [sym_true] = ACTIONS(1403),
    [sym_false] = ACTIONS(1403),
    [sym_none] = ACTIONS(1403),
    [anon_sym_await] = ACTIONS(1403),
    [sym_comment] = ACTIONS(72),
  },
  [1159] = {
    [sym_import_statement] = STATE(326),
    [sym_import_from_statement] = STATE(326),
    [sym_print_statement] = STATE(326),
    [sym_assert_statement] = STATE(326),
    [sym_expression_statement] = STATE(326),
    [sym_return_statement] = STATE(326),
    [sym_delete_statement] = STATE(326),
    [sym_raise_statement] = STATE(326),
    [sym_global_statement] = STATE(326),
    [sym_nonlocal_statement] = STATE(326),
    [sym_exec_statement] = STATE(326),
    [sym_expression_list] = STATE(32),
    [sym__expression] = STATE(33),
    [sym__primary_expression] = STATE(34),
    [sym_not_operator] = STATE(33),
    [sym_boolean_operator] = STATE(33),
    [sym_binary_operator] = STATE(34),
    [sym_unary_operator] = STATE(34),
    [sym_comparison_operator] = STATE(33),
    [sym_lambda] = STATE(33),
    [sym_assignment] = STATE(35),
    [sym_augmented_assignment] = STATE(35),
    [sym_yield] = STATE(35),
    [sym_attribute] = STATE(34),
    [sym_subscript] = STATE(34),
    [sym_call] = STATE(34),
    [sym_list] = STATE(34),
    [sym_list_comprehension] = STATE(34),
    [sym_dictionary] = STATE(34),
    [sym_dictionary_comprehension] = STATE(34),
    [sym_set] = STATE(34),
    [sym_set_comprehension] = STATE(34),
    [sym_parenthesized_expression] = STATE(34),
    [sym_tuple] = STATE(34),
    [sym_generator_expression] = STATE(34),
    [sym_conditional_expression] = STATE(33),
    [sym_concatenated_string] = STATE(34),
    [sym_await] = STATE(33),
    [sym__newline] = ACTIONS(3218),
    [anon_sym_import] = ACTIONS(10),
    [anon_sym_from] = ACTIONS(12),
    [anon_sym_LPAREN] = ACTIONS(14),
    [anon_sym_print] = ACTIONS(16),
    [anon_sym_assert] = ACTIONS(18),
    [anon_sym_return] = ACTIONS(20),
    [anon_sym_del] = ACTIONS(22),
    [anon_sym_raise] = ACTIONS(24),
    [sym_pass_statement] = ACTIONS(582),
    [sym_break_statement] = ACTIONS(582),
    [sym_continue_statement] = ACTIONS(582),
    [anon_sym_global] = ACTIONS(42),
    [anon_sym_nonlocal] = ACTIONS(44),
    [anon_sym_exec] = ACTIONS(46),
    [anon_sym_not] = ACTIONS(52),
    [anon_sym_PLUS] = ACTIONS(54),
    [anon_sym_DASH] = ACTIONS(54),
    [anon_sym_TILDE] = ACTIONS(54),
    [anon_sym_lambda] = ACTIONS(56),
    [anon_sym_yield] = ACTIONS(58),
    [anon_sym_LBRACK] = ACTIONS(60),
    [sym_ellipsis] = ACTIONS(62),
    [anon_sym_LBRACE] = ACTIONS(64),
    [sym_string] = ACTIONS(66),
    [sym_integer] = ACTIONS(68),
    [sym_float] = ACTIONS(68),
    [sym_identifier] = ACTIONS(68),
    [sym_true] = ACTIONS(68),
    [sym_false] = ACTIONS(68),
    [sym_none] = ACTIONS(68),
    [anon_sym_await] = ACTIONS(70),
    [sym_comment] = ACTIONS(72),
  },
  [1160] = {
    [sym__simple_statements] = STATE(1476),
    [sym_import_statement] = STATE(364),
    [sym_import_from_statement] = STATE(364),
    [sym_print_statement] = STATE(364),
    [sym_assert_statement] = STATE(364),
    [sym_expression_statement] = STATE(364),
    [sym_return_statement] = STATE(364),
    [sym_delete_statement] = STATE(364),
    [sym_raise_statement] = STATE(364),
    [sym_global_statement] = STATE(364),
    [sym_nonlocal_statement] = STATE(364),
    [sym_exec_statement] = STATE(364),
    [sym__suite] = STATE(1476),
    [sym_expression_list] = STATE(32),
    [sym__expression] = STATE(33),
    [sym__primary_expression] = STATE(34),
    [sym_not_operator] = STATE(33),
    [sym_boolean_operator] = STATE(33),
    [sym_binary_operator] = STATE(34),
    [sym_unary_operator] = STATE(34),
    [sym_comparison_operator] = STATE(33),
    [sym_lambda] = STATE(33),
    [sym_assignment] = STATE(35),
    [sym_augmented_assignment] = STATE(35),
    [sym_yield] = STATE(35),
    [sym_attribute] = STATE(34),
    [sym_subscript] = STATE(34),
    [sym_call] = STATE(34),
    [sym_list] = STATE(34),
    [sym_list_comprehension] = STATE(34),
    [sym_dictionary] = STATE(34),
    [sym_dictionary_comprehension] = STATE(34),
    [sym_set] = STATE(34),
    [sym_set_comprehension] = STATE(34),
    [sym_parenthesized_expression] = STATE(34),
    [sym_tuple] = STATE(34),
    [sym_generator_expression] = STATE(34),
    [sym_conditional_expression] = STATE(33),
    [sym_concatenated_string] = STATE(34),
    [sym_await] = STATE(33),
    [sym__indent] = ACTIONS(650),
    [anon_sym_import] = ACTIONS(10),
    [anon_sym_from] = ACTIONS(12),
    [anon_sym_LPAREN] = ACTIONS(14),
    [anon_sym_print] = ACTIONS(16),
    [anon_sym_assert] = ACTIONS(18),
    [anon_sym_return] = ACTIONS(20),
    [anon_sym_del] = ACTIONS(22),
    [anon_sym_raise] = ACTIONS(24),
    [sym_pass_statement] = ACTIONS(652),
    [sym_break_statement] = ACTIONS(652),
    [sym_continue_statement] = ACTIONS(652),
    [anon_sym_global] = ACTIONS(42),
    [anon_sym_nonlocal] = ACTIONS(44),
    [anon_sym_exec] = ACTIONS(46),
    [anon_sym_not] = ACTIONS(52),
    [anon_sym_PLUS] = ACTIONS(54),
    [anon_sym_DASH] = ACTIONS(54),
    [anon_sym_TILDE] = ACTIONS(54),
    [anon_sym_lambda] = ACTIONS(56),
    [anon_sym_yield] = ACTIONS(58),
    [anon_sym_LBRACK] = ACTIONS(60),
    [sym_ellipsis] = ACTIONS(62),
    [anon_sym_LBRACE] = ACTIONS(64),
    [sym_string] = ACTIONS(66),
    [sym_integer] = ACTIONS(68),
    [sym_float] = ACTIONS(68),
    [sym_identifier] = ACTIONS(68),
    [sym_true] = ACTIONS(68),
    [sym_false] = ACTIONS(68),
    [sym_none] = ACTIONS(68),
    [anon_sym_await] = ACTIONS(70),
    [sym_comment] = ACTIONS(72),
  },
  [1161] = {
    [anon_sym_COMMA] = ACTIONS(3220),
    [anon_sym_as] = ACTIONS(3220),
    [anon_sym_if] = ACTIONS(666),
    [anon_sym_COLON] = ACTIONS(3222),
    [anon_sym_and] = ACTIONS(668),
    [anon_sym_or] = ACTIONS(670),
    [sym_comment] = ACTIONS(72),
  },
  [1162] = {
    [sym__simple_statements] = STATE(1479),
    [sym_import_statement] = STATE(10),
    [sym_import_from_statement] = STATE(10),
    [sym_print_statement] = STATE(10),
    [sym_assert_statement] = STATE(10),
    [sym_expression_statement] = STATE(10),
    [sym_return_statement] = STATE(10),
    [sym_delete_statement] = STATE(10),
    [sym_raise_statement] = STATE(10),
    [sym_global_statement] = STATE(10),
    [sym_nonlocal_statement] = STATE(10),
    [sym_exec_statement] = STATE(10),
    [sym__suite] = STATE(1479),
    [sym_expression_list] = STATE(32),
    [sym__expression] = STATE(33),
    [sym__primary_expression] = STATE(34),
    [sym_not_operator] = STATE(33),
    [sym_boolean_operator] = STATE(33),
    [sym_binary_operator] = STATE(34),
    [sym_unary_operator] = STATE(34),
    [sym_comparison_operator] = STATE(33),
    [sym_lambda] = STATE(33),
    [sym_assignment] = STATE(35),
    [sym_augmented_assignment] = STATE(35),
    [sym_yield] = STATE(35),
    [sym_attribute] = STATE(34),
    [sym_subscript] = STATE(34),
    [sym_call] = STATE(34),
    [sym_list] = STATE(34),
    [sym_list_comprehension] = STATE(34),
    [sym_dictionary] = STATE(34),
    [sym_dictionary_comprehension] = STATE(34),
    [sym_set] = STATE(34),
    [sym_set_comprehension] = STATE(34),
    [sym_parenthesized_expression] = STATE(34),
    [sym_tuple] = STATE(34),
    [sym_generator_expression] = STATE(34),
    [sym_conditional_expression] = STATE(33),
    [sym_concatenated_string] = STATE(34),
    [sym_await] = STATE(33),
    [sym__indent] = ACTIONS(1528),
    [anon_sym_import] = ACTIONS(10),
    [anon_sym_from] = ACTIONS(12),
    [anon_sym_LPAREN] = ACTIONS(14),
    [anon_sym_print] = ACTIONS(16),
    [anon_sym_assert] = ACTIONS(18),
    [anon_sym_return] = ACTIONS(20),
    [anon_sym_del] = ACTIONS(22),
    [anon_sym_raise] = ACTIONS(24),
    [sym_pass_statement] = ACTIONS(26),
    [sym_break_statement] = ACTIONS(26),
    [sym_continue_statement] = ACTIONS(26),
    [anon_sym_global] = ACTIONS(42),
    [anon_sym_nonlocal] = ACTIONS(44),
    [anon_sym_exec] = ACTIONS(46),
    [anon_sym_not] = ACTIONS(52),
    [anon_sym_PLUS] = ACTIONS(54),
    [anon_sym_DASH] = ACTIONS(54),
    [anon_sym_TILDE] = ACTIONS(54),
    [anon_sym_lambda] = ACTIONS(56),
    [anon_sym_yield] = ACTIONS(58),
    [anon_sym_LBRACK] = ACTIONS(60),
    [sym_ellipsis] = ACTIONS(62),
    [anon_sym_LBRACE] = ACTIONS(64),
    [sym_string] = ACTIONS(66),
    [sym_integer] = ACTIONS(68),
    [sym_float] = ACTIONS(68),
    [sym_identifier] = ACTIONS(68),
    [sym_true] = ACTIONS(68),
    [sym_false] = ACTIONS(68),
    [sym_none] = ACTIONS(68),
    [anon_sym_await] = ACTIONS(70),
    [sym_comment] = ACTIONS(72),
  },
  [1163] = {
    [anon_sym_COLON] = ACTIONS(3224),
    [sym_comment] = ACTIONS(72),
  },
  [1164] = {
    [sym_finally_clause] = STATE(1481),
    [ts_builtin_sym_end] = ACTIONS(3226),
    [anon_sym_import] = ACTIONS(3228),
    [anon_sym_from] = ACTIONS(3228),
    [anon_sym_LPAREN] = ACTIONS(3226),
    [anon_sym_print] = ACTIONS(3228),
    [anon_sym_assert] = ACTIONS(3228),
    [anon_sym_return] = ACTIONS(3228),
    [anon_sym_del] = ACTIONS(3228),
    [anon_sym_raise] = ACTIONS(3228),
    [sym_pass_statement] = ACTIONS(3228),
    [sym_break_statement] = ACTIONS(3228),
    [sym_continue_statement] = ACTIONS(3228),
    [anon_sym_if] = ACTIONS(3228),
    [anon_sym_async] = ACTIONS(3228),
    [anon_sym_for] = ACTIONS(3228),
    [anon_sym_while] = ACTIONS(3228),
    [anon_sym_try] = ACTIONS(3228),
    [anon_sym_finally] = ACTIONS(2432),
    [anon_sym_with] = ACTIONS(3228),
    [anon_sym_def] = ACTIONS(3228),
    [anon_sym_global] = ACTIONS(3228),
    [anon_sym_nonlocal] = ACTIONS(3228),
    [anon_sym_exec] = ACTIONS(3228),
    [anon_sym_class] = ACTIONS(3228),
    [anon_sym_AT] = ACTIONS(3226),
    [anon_sym_not] = ACTIONS(3228),
    [anon_sym_PLUS] = ACTIONS(3226),
    [anon_sym_DASH] = ACTIONS(3226),
    [anon_sym_TILDE] = ACTIONS(3226),
    [anon_sym_lambda] = ACTIONS(3228),
    [anon_sym_yield] = ACTIONS(3228),
    [anon_sym_LBRACK] = ACTIONS(3226),
    [sym_ellipsis] = ACTIONS(3226),
    [anon_sym_LBRACE] = ACTIONS(3226),
    [sym_string] = ACTIONS(3226),
    [sym_integer] = ACTIONS(3228),
    [sym_float] = ACTIONS(3228),
    [sym_identifier] = ACTIONS(3228),
    [sym_true] = ACTIONS(3228),
    [sym_false] = ACTIONS(3228),
    [sym_none] = ACTIONS(3228),
    [anon_sym_await] = ACTIONS(3228),
    [sym_comment] = ACTIONS(72),
  },
  [1165] = {
    [ts_builtin_sym_end] = ACTIONS(3226),
    [anon_sym_import] = ACTIONS(3228),
    [anon_sym_from] = ACTIONS(3228),
    [anon_sym_LPAREN] = ACTIONS(3226),
    [anon_sym_print] = ACTIONS(3228),
    [anon_sym_assert] = ACTIONS(3228),
    [anon_sym_return] = ACTIONS(3228),
    [anon_sym_del] = ACTIONS(3228),
    [anon_sym_raise] = ACTIONS(3228),
    [sym_pass_statement] = ACTIONS(3228),
    [sym_break_statement] = ACTIONS(3228),
    [sym_continue_statement] = ACTIONS(3228),
    [anon_sym_if] = ACTIONS(3228),
    [anon_sym_async] = ACTIONS(3228),
    [anon_sym_for] = ACTIONS(3228),
    [anon_sym_while] = ACTIONS(3228),
    [anon_sym_try] = ACTIONS(3228),
    [anon_sym_with] = ACTIONS(3228),
    [anon_sym_def] = ACTIONS(3228),
    [anon_sym_global] = ACTIONS(3228),
    [anon_sym_nonlocal] = ACTIONS(3228),
    [anon_sym_exec] = ACTIONS(3228),
    [anon_sym_class] = ACTIONS(3228),
    [anon_sym_AT] = ACTIONS(3226),
    [anon_sym_not] = ACTIONS(3228),
    [anon_sym_PLUS] = ACTIONS(3226),
    [anon_sym_DASH] = ACTIONS(3226),
    [anon_sym_TILDE] = ACTIONS(3226),
    [anon_sym_lambda] = ACTIONS(3228),
    [anon_sym_yield] = ACTIONS(3228),
    [anon_sym_LBRACK] = ACTIONS(3226),
    [sym_ellipsis] = ACTIONS(3226),
    [anon_sym_LBRACE] = ACTIONS(3226),
    [sym_string] = ACTIONS(3226),
    [sym_integer] = ACTIONS(3228),
    [sym_float] = ACTIONS(3228),
    [sym_identifier] = ACTIONS(3228),
    [sym_true] = ACTIONS(3228),
    [sym_false] = ACTIONS(3228),
    [sym_none] = ACTIONS(3228),
    [anon_sym_await] = ACTIONS(3228),
    [sym_comment] = ACTIONS(72),
  },
  [1166] = {
    [sym_except_clause] = STATE(1166),
    [aux_sym_try_statement_repeat1] = STATE(1166),
    [ts_builtin_sym_end] = ACTIONS(3230),
    [anon_sym_import] = ACTIONS(3232),
    [anon_sym_from] = ACTIONS(3232),
    [anon_sym_LPAREN] = ACTIONS(3230),
    [anon_sym_print] = ACTIONS(3232),
    [anon_sym_assert] = ACTIONS(3232),
    [anon_sym_return] = ACTIONS(3232),
    [anon_sym_del] = ACTIONS(3232),
    [anon_sym_raise] = ACTIONS(3232),
    [sym_pass_statement] = ACTIONS(3232),
    [sym_break_statement] = ACTIONS(3232),
    [sym_continue_statement] = ACTIONS(3232),
    [anon_sym_if] = ACTIONS(3232),
    [anon_sym_else] = ACTIONS(3232),
    [anon_sym_async] = ACTIONS(3232),
    [anon_sym_for] = ACTIONS(3232),
    [anon_sym_while] = ACTIONS(3232),
    [anon_sym_try] = ACTIONS(3232),
    [anon_sym_except] = ACTIONS(3234),
    [anon_sym_finally] = ACTIONS(3232),
    [anon_sym_with] = ACTIONS(3232),
    [anon_sym_def] = ACTIONS(3232),
    [anon_sym_global] = ACTIONS(3232),
    [anon_sym_nonlocal] = ACTIONS(3232),
    [anon_sym_exec] = ACTIONS(3232),
    [anon_sym_class] = ACTIONS(3232),
    [anon_sym_AT] = ACTIONS(3230),
    [anon_sym_not] = ACTIONS(3232),
    [anon_sym_PLUS] = ACTIONS(3230),
    [anon_sym_DASH] = ACTIONS(3230),
    [anon_sym_TILDE] = ACTIONS(3230),
    [anon_sym_lambda] = ACTIONS(3232),
    [anon_sym_yield] = ACTIONS(3232),
    [anon_sym_LBRACK] = ACTIONS(3230),
    [sym_ellipsis] = ACTIONS(3230),
    [anon_sym_LBRACE] = ACTIONS(3230),
    [sym_string] = ACTIONS(3230),
    [sym_integer] = ACTIONS(3232),
    [sym_float] = ACTIONS(3232),
    [sym_identifier] = ACTIONS(3232),
    [sym_true] = ACTIONS(3232),
    [sym_false] = ACTIONS(3232),
    [sym_none] = ACTIONS(3232),
    [anon_sym_await] = ACTIONS(3232),
    [sym_comment] = ACTIONS(72),
  },
  [1167] = {
    [anon_sym_COMMA] = ACTIONS(2642),
    [anon_sym_as] = ACTIONS(2642),
    [anon_sym_if] = ACTIONS(666),
    [anon_sym_COLON] = ACTIONS(2642),
    [anon_sym_and] = ACTIONS(668),
    [anon_sym_or] = ACTIONS(670),
    [sym_comment] = ACTIONS(72),
  },
  [1168] = {
    [ts_builtin_sym_end] = ACTIONS(2388),
    [anon_sym_import] = ACTIONS(2390),
    [anon_sym_from] = ACTIONS(2390),
    [anon_sym_LPAREN] = ACTIONS(2388),
    [anon_sym_print] = ACTIONS(2390),
    [anon_sym_assert] = ACTIONS(2390),
    [anon_sym_return] = ACTIONS(2390),
    [anon_sym_del] = ACTIONS(2390),
    [anon_sym_raise] = ACTIONS(2390),
    [sym_pass_statement] = ACTIONS(2390),
    [sym_break_statement] = ACTIONS(2390),
    [sym_continue_statement] = ACTIONS(2390),
    [anon_sym_if] = ACTIONS(2390),
    [anon_sym_async] = ACTIONS(2390),
    [anon_sym_for] = ACTIONS(2390),
    [anon_sym_while] = ACTIONS(2390),
    [anon_sym_try] = ACTIONS(2390),
    [anon_sym_with] = ACTIONS(2390),
    [anon_sym_def] = ACTIONS(2390),
    [anon_sym_global] = ACTIONS(2390),
    [anon_sym_nonlocal] = ACTIONS(2390),
    [anon_sym_exec] = ACTIONS(2390),
    [anon_sym_class] = ACTIONS(2390),
    [anon_sym_AT] = ACTIONS(2388),
    [anon_sym_not] = ACTIONS(2390),
    [anon_sym_PLUS] = ACTIONS(2388),
    [anon_sym_DASH] = ACTIONS(2388),
    [anon_sym_TILDE] = ACTIONS(2388),
    [anon_sym_lambda] = ACTIONS(2390),
    [anon_sym_yield] = ACTIONS(2390),
    [anon_sym_LBRACK] = ACTIONS(2388),
    [sym_ellipsis] = ACTIONS(2388),
    [anon_sym_LBRACE] = ACTIONS(2388),
    [sym_string] = ACTIONS(2388),
    [sym_integer] = ACTIONS(2390),
    [sym_float] = ACTIONS(2390),
    [sym_identifier] = ACTIONS(2390),
    [sym_true] = ACTIONS(2390),
    [sym_false] = ACTIONS(2390),
    [sym_none] = ACTIONS(2390),
    [anon_sym_await] = ACTIONS(2390),
    [sym_comment] = ACTIONS(72),
  },
  [1169] = {
    [sym__statement] = STATE(1155),
    [sym__simple_statements] = STATE(1155),
    [sym_import_statement] = STATE(746),
    [sym_import_from_statement] = STATE(746),
    [sym_print_statement] = STATE(746),
    [sym_assert_statement] = STATE(746),
    [sym_expression_statement] = STATE(746),
    [sym_return_statement] = STATE(746),
    [sym_delete_statement] = STATE(746),
    [sym_raise_statement] = STATE(746),
    [sym_if_statement] = STATE(1155),
    [sym_for_statement] = STATE(1155),
    [sym_while_statement] = STATE(1155),
    [sym_try_statement] = STATE(1155),
    [sym_with_statement] = STATE(1155),
    [sym_function_definition] = STATE(1155),
    [sym_global_statement] = STATE(746),
    [sym_nonlocal_statement] = STATE(746),
    [sym_exec_statement] = STATE(746),
    [sym_class_definition] = STATE(1155),
    [sym_decorated_definition] = STATE(1155),
    [sym_decorator] = STATE(756),
    [sym_expression_list] = STATE(32),
    [sym__expression] = STATE(33),
    [sym__primary_expression] = STATE(34),
    [sym_not_operator] = STATE(33),
    [sym_boolean_operator] = STATE(33),
    [sym_binary_operator] = STATE(34),
    [sym_unary_operator] = STATE(34),
    [sym_comparison_operator] = STATE(33),
    [sym_lambda] = STATE(33),
    [sym_assignment] = STATE(35),
    [sym_augmented_assignment] = STATE(35),
    [sym_yield] = STATE(35),
    [sym_attribute] = STATE(34),
    [sym_subscript] = STATE(34),
    [sym_call] = STATE(34),
    [sym_list] = STATE(34),
    [sym_list_comprehension] = STATE(34),
    [sym_dictionary] = STATE(34),
    [sym_dictionary_comprehension] = STATE(34),
    [sym_set] = STATE(34),
    [sym_set_comprehension] = STATE(34),
    [sym_parenthesized_expression] = STATE(34),
    [sym_tuple] = STATE(34),
    [sym_generator_expression] = STATE(34),
    [sym_conditional_expression] = STATE(33),
    [sym_concatenated_string] = STATE(34),
    [sym_await] = STATE(33),
    [aux_sym_module_repeat1] = STATE(1155),
    [aux_sym_decorated_definition_repeat1] = STATE(756),
    [sym__dedent] = ACTIONS(3237),
    [anon_sym_import] = ACTIONS(10),
    [anon_sym_from] = ACTIONS(12),
    [anon_sym_LPAREN] = ACTIONS(14),
    [anon_sym_print] = ACTIONS(16),
    [anon_sym_assert] = ACTIONS(18),
    [anon_sym_return] = ACTIONS(20),
    [anon_sym_del] = ACTIONS(22),
    [anon_sym_raise] = ACTIONS(24),
    [sym_pass_statement] = ACTIONS(1498),
    [sym_break_statement] = ACTIONS(1498),
    [sym_continue_statement] = ACTIONS(1498),
    [anon_sym_if] = ACTIONS(1500),
    [anon_sym_async] = ACTIONS(1502),
    [anon_sym_for] = ACTIONS(1504),
    [anon_sym_while] = ACTIONS(1506),
    [anon_sym_try] = ACTIONS(1508),
    [anon_sym_with] = ACTIONS(1510),
    [anon_sym_def] = ACTIONS(1512),
    [anon_sym_global] = ACTIONS(42),
    [anon_sym_nonlocal] = ACTIONS(44),
    [anon_sym_exec] = ACTIONS(46),
    [anon_sym_class] = ACTIONS(1514),
    [anon_sym_AT] = ACTIONS(50),
    [anon_sym_not] = ACTIONS(52),
    [anon_sym_PLUS] = ACTIONS(54),
    [anon_sym_DASH] = ACTIONS(54),
    [anon_sym_TILDE] = ACTIONS(54),
    [anon_sym_lambda] = ACTIONS(56),
    [anon_sym_yield] = ACTIONS(58),
    [anon_sym_LBRACK] = ACTIONS(60),
    [sym_ellipsis] = ACTIONS(62),
    [anon_sym_LBRACE] = ACTIONS(64),
    [sym_string] = ACTIONS(66),
    [sym_integer] = ACTIONS(68),
    [sym_float] = ACTIONS(68),
    [sym_identifier] = ACTIONS(68),
    [sym_true] = ACTIONS(68),
    [sym_false] = ACTIONS(68),
    [sym_none] = ACTIONS(68),
    [anon_sym_await] = ACTIONS(70),
    [sym_comment] = ACTIONS(72),
  },
  [1170] = {
    [sym__expression] = STATE(1483),
    [sym__primary_expression] = STATE(113),
    [sym_not_operator] = STATE(1483),
    [sym_boolean_operator] = STATE(1483),
    [sym_binary_operator] = STATE(113),
    [sym_unary_operator] = STATE(113),
    [sym_comparison_operator] = STATE(1483),
    [sym_lambda] = STATE(1483),
    [sym_attribute] = STATE(113),
    [sym_subscript] = STATE(113),
    [sym_call] = STATE(113),
    [sym_list] = STATE(113),
    [sym_list_comprehension] = STATE(113),
    [sym_dictionary] = STATE(113),
    [sym_dictionary_comprehension] = STATE(113),
    [sym_set] = STATE(113),
    [sym_set_comprehension] = STATE(113),
    [sym_parenthesized_expression] = STATE(113),
    [sym_tuple] = STATE(113),
    [sym_generator_expression] = STATE(113),
    [sym_conditional_expression] = STATE(1483),
    [sym_concatenated_string] = STATE(113),
    [sym_await] = STATE(1483),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_not] = ACTIONS(190),
    [anon_sym_PLUS] = ACTIONS(192),
    [anon_sym_DASH] = ACTIONS(192),
    [anon_sym_TILDE] = ACTIONS(192),
    [anon_sym_lambda] = ACTIONS(194),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(196),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(198),
    [sym_integer] = ACTIONS(200),
    [sym_float] = ACTIONS(200),
    [sym_identifier] = ACTIONS(200),
    [sym_true] = ACTIONS(200),
    [sym_false] = ACTIONS(200),
    [sym_none] = ACTIONS(200),
    [anon_sym_await] = ACTIONS(202),
    [sym_comment] = ACTIONS(72),
  },
  [1171] = {
    [sym_argument_list] = STATE(251),
    [sym_generator_expression] = STATE(251),
    [anon_sym_DOT] = ACTIONS(422),
    [anon_sym_LPAREN] = ACTIONS(424),
    [anon_sym_COMMA] = ACTIONS(2953),
    [anon_sym_as] = ACTIONS(2953),
    [anon_sym_STAR] = ACTIONS(672),
    [anon_sym_GT_GT] = ACTIONS(674),
    [anon_sym_if] = ACTIONS(2953),
    [anon_sym_COLON] = ACTIONS(2953),
    [anon_sym_in] = ACTIONS(2953),
    [anon_sym_AT] = ACTIONS(678),
    [anon_sym_not] = ACTIONS(2953),
    [anon_sym_and] = ACTIONS(2953),
    [anon_sym_or] = ACTIONS(2953),
    [anon_sym_PLUS] = ACTIONS(682),
    [anon_sym_DASH] = ACTIONS(682),
    [anon_sym_SLASH] = ACTIONS(672),
    [anon_sym_PERCENT] = ACTIONS(678),
    [anon_sym_SLASH_SLASH] = ACTIONS(678),
    [anon_sym_STAR_STAR] = ACTIONS(684),
    [anon_sym_PIPE] = ACTIONS(686),
    [anon_sym_AMP] = ACTIONS(688),
    [anon_sym_CARET] = ACTIONS(690),
    [anon_sym_LT_LT] = ACTIONS(674),
    [anon_sym_LT] = ACTIONS(2955),
    [anon_sym_LT_EQ] = ACTIONS(2953),
    [anon_sym_EQ_EQ] = ACTIONS(2953),
    [anon_sym_BANG_EQ] = ACTIONS(2953),
    [anon_sym_GT_EQ] = ACTIONS(2953),
    [anon_sym_GT] = ACTIONS(2955),
    [anon_sym_LT_GT] = ACTIONS(2953),
    [anon_sym_is] = ACTIONS(2953),
    [anon_sym_LBRACK] = ACTIONS(450),
    [sym_comment] = ACTIONS(72),
  },
  [1172] = {
    [sym__expression] = STATE(1484),
    [sym__primary_expression] = STATE(1179),
    [sym_not_operator] = STATE(1484),
    [sym_boolean_operator] = STATE(1484),
    [sym_binary_operator] = STATE(1179),
    [sym_unary_operator] = STATE(1179),
    [sym_comparison_operator] = STATE(1484),
    [sym_lambda] = STATE(1484),
    [sym_attribute] = STATE(1179),
    [sym_subscript] = STATE(1179),
    [sym_call] = STATE(1179),
    [sym_list] = STATE(1179),
    [sym_list_comprehension] = STATE(1179),
    [sym_dictionary] = STATE(1179),
    [sym_dictionary_comprehension] = STATE(1179),
    [sym_set] = STATE(1179),
    [sym_set_comprehension] = STATE(1179),
    [sym_parenthesized_expression] = STATE(1179),
    [sym_tuple] = STATE(1179),
    [sym_generator_expression] = STATE(1179),
    [sym_conditional_expression] = STATE(1484),
    [sym_concatenated_string] = STATE(1179),
    [sym_await] = STATE(1484),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_not] = ACTIONS(2472),
    [anon_sym_PLUS] = ACTIONS(2474),
    [anon_sym_DASH] = ACTIONS(2474),
    [anon_sym_TILDE] = ACTIONS(2474),
    [anon_sym_lambda] = ACTIONS(2476),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(2478),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(2480),
    [sym_integer] = ACTIONS(2482),
    [sym_float] = ACTIONS(2482),
    [sym_identifier] = ACTIONS(2482),
    [sym_true] = ACTIONS(2482),
    [sym_false] = ACTIONS(2482),
    [sym_none] = ACTIONS(2482),
    [anon_sym_await] = ACTIONS(2484),
    [sym_comment] = ACTIONS(72),
  },
  [1173] = {
    [sym__expression] = STATE(1485),
    [sym__primary_expression] = STATE(1179),
    [sym_not_operator] = STATE(1485),
    [sym_boolean_operator] = STATE(1485),
    [sym_binary_operator] = STATE(1179),
    [sym_unary_operator] = STATE(1179),
    [sym_comparison_operator] = STATE(1485),
    [sym_lambda] = STATE(1485),
    [sym_attribute] = STATE(1179),
    [sym_subscript] = STATE(1179),
    [sym_call] = STATE(1179),
    [sym_list] = STATE(1179),
    [sym_list_comprehension] = STATE(1179),
    [sym_dictionary] = STATE(1179),
    [sym_dictionary_comprehension] = STATE(1179),
    [sym_set] = STATE(1179),
    [sym_set_comprehension] = STATE(1179),
    [sym_parenthesized_expression] = STATE(1179),
    [sym_tuple] = STATE(1179),
    [sym_generator_expression] = STATE(1179),
    [sym_conditional_expression] = STATE(1485),
    [sym_concatenated_string] = STATE(1179),
    [sym_await] = STATE(1485),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_not] = ACTIONS(2472),
    [anon_sym_PLUS] = ACTIONS(2474),
    [anon_sym_DASH] = ACTIONS(2474),
    [anon_sym_TILDE] = ACTIONS(2474),
    [anon_sym_lambda] = ACTIONS(2476),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(2478),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(2480),
    [sym_integer] = ACTIONS(2482),
    [sym_float] = ACTIONS(2482),
    [sym_identifier] = ACTIONS(2482),
    [sym_true] = ACTIONS(2482),
    [sym_false] = ACTIONS(2482),
    [sym_none] = ACTIONS(2482),
    [anon_sym_await] = ACTIONS(2484),
    [sym_comment] = ACTIONS(72),
  },
  [1174] = {
    [sym__primary_expression] = STATE(204),
    [sym_binary_operator] = STATE(204),
    [sym_unary_operator] = STATE(204),
    [sym_attribute] = STATE(204),
    [sym_subscript] = STATE(204),
    [sym_call] = STATE(204),
    [sym_list] = STATE(204),
    [sym_list_comprehension] = STATE(204),
    [sym_dictionary] = STATE(204),
    [sym_dictionary_comprehension] = STATE(204),
    [sym_set] = STATE(204),
    [sym_set_comprehension] = STATE(204),
    [sym_parenthesized_expression] = STATE(204),
    [sym_tuple] = STATE(204),
    [sym_generator_expression] = STATE(204),
    [sym_concatenated_string] = STATE(204),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_PLUS] = ACTIONS(2474),
    [anon_sym_DASH] = ACTIONS(2474),
    [anon_sym_TILDE] = ACTIONS(2474),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(376),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(2480),
    [sym_integer] = ACTIONS(378),
    [sym_float] = ACTIONS(378),
    [sym_identifier] = ACTIONS(378),
    [sym_true] = ACTIONS(378),
    [sym_false] = ACTIONS(378),
    [sym_none] = ACTIONS(378),
    [sym_comment] = ACTIONS(72),
  },
  [1175] = {
    [sym_lambda_parameters] = STATE(1487),
    [sym__parameters] = STATE(130),
    [sym_default_parameter] = STATE(131),
    [sym_typed_default_parameter] = STATE(131),
    [sym_list_splat] = STATE(132),
    [sym_dictionary_splat] = STATE(132),
    [sym_typed_parameter] = STATE(131),
    [sym_tuple] = STATE(131),
    [anon_sym_LPAREN] = ACTIONS(222),
    [anon_sym_STAR] = ACTIONS(224),
    [anon_sym_print] = ACTIONS(226),
    [anon_sym_COLON] = ACTIONS(3239),
    [anon_sym_exec] = ACTIONS(226),
    [sym_identifier] = ACTIONS(230),
    [sym_comment] = ACTIONS(72),
  },
  [1176] = {
    [aux_sym_concatenated_string_repeat1] = STATE(1488),
    [anon_sym_DOT] = ACTIONS(276),
    [anon_sym_LPAREN] = ACTIONS(276),
    [anon_sym_RPAREN] = ACTIONS(276),
    [anon_sym_COMMA] = ACTIONS(276),
    [anon_sym_STAR] = ACTIONS(278),
    [anon_sym_GT_GT] = ACTIONS(276),
    [anon_sym_if] = ACTIONS(276),
    [anon_sym_COLON] = ACTIONS(276),
    [anon_sym_in] = ACTIONS(276),
    [anon_sym_AT] = ACTIONS(276),
    [anon_sym_not] = ACTIONS(276),
    [anon_sym_and] = ACTIONS(276),
    [anon_sym_or] = ACTIONS(276),
    [anon_sym_PLUS] = ACTIONS(276),
    [anon_sym_DASH] = ACTIONS(276),
    [anon_sym_SLASH] = ACTIONS(278),
    [anon_sym_PERCENT] = ACTIONS(276),
    [anon_sym_SLASH_SLASH] = ACTIONS(276),
    [anon_sym_STAR_STAR] = ACTIONS(276),
    [anon_sym_PIPE] = ACTIONS(276),
    [anon_sym_AMP] = ACTIONS(276),
    [anon_sym_CARET] = ACTIONS(276),
    [anon_sym_LT_LT] = ACTIONS(276),
    [anon_sym_LT] = ACTIONS(278),
    [anon_sym_LT_EQ] = ACTIONS(276),
    [anon_sym_EQ_EQ] = ACTIONS(276),
    [anon_sym_BANG_EQ] = ACTIONS(276),
    [anon_sym_GT_EQ] = ACTIONS(276),
    [anon_sym_GT] = ACTIONS(278),
    [anon_sym_LT_GT] = ACTIONS(276),
    [anon_sym_is] = ACTIONS(276),
    [anon_sym_LBRACK] = ACTIONS(276),
    [sym_string] = ACTIONS(3241),
    [sym_comment] = ACTIONS(72),
  },
  [1177] = {
    [sym__expression] = STATE(227),
    [sym__primary_expression] = STATE(1179),
    [sym_not_operator] = STATE(227),
    [sym_boolean_operator] = STATE(227),
    [sym_binary_operator] = STATE(1179),
    [sym_unary_operator] = STATE(1179),
    [sym_comparison_operator] = STATE(227),
    [sym_lambda] = STATE(227),
    [sym_attribute] = STATE(1179),
    [sym_subscript] = STATE(1179),
    [sym_call] = STATE(1179),
    [sym_list] = STATE(1179),
    [sym_list_comprehension] = STATE(1179),
    [sym_dictionary] = STATE(1179),
    [sym_dictionary_comprehension] = STATE(1179),
    [sym_set] = STATE(1179),
    [sym_set_comprehension] = STATE(1179),
    [sym_parenthesized_expression] = STATE(1179),
    [sym_tuple] = STATE(1179),
    [sym_generator_expression] = STATE(1179),
    [sym_conditional_expression] = STATE(227),
    [sym_concatenated_string] = STATE(1179),
    [sym_await] = STATE(227),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_not] = ACTIONS(2472),
    [anon_sym_PLUS] = ACTIONS(2474),
    [anon_sym_DASH] = ACTIONS(2474),
    [anon_sym_TILDE] = ACTIONS(2474),
    [anon_sym_lambda] = ACTIONS(2476),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(2478),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(2480),
    [sym_integer] = ACTIONS(2482),
    [sym_float] = ACTIONS(2482),
    [sym_identifier] = ACTIONS(2482),
    [sym_true] = ACTIONS(2482),
    [sym_false] = ACTIONS(2482),
    [sym_none] = ACTIONS(2482),
    [anon_sym_await] = ACTIONS(2484),
    [sym_comment] = ACTIONS(72),
  },
  [1178] = {
    [anon_sym_RPAREN] = ACTIONS(1590),
    [anon_sym_COMMA] = ACTIONS(1590),
    [anon_sym_if] = ACTIONS(3243),
    [anon_sym_COLON] = ACTIONS(1590),
    [anon_sym_and] = ACTIONS(3245),
    [anon_sym_or] = ACTIONS(3247),
    [sym_comment] = ACTIONS(72),
  },
  [1179] = {
    [sym_argument_list] = STATE(251),
    [sym_generator_expression] = STATE(251),
    [aux_sym_comparison_operator_repeat1] = STATE(1502),
    [anon_sym_DOT] = ACTIONS(422),
    [anon_sym_LPAREN] = ACTIONS(424),
    [anon_sym_RPAREN] = ACTIONS(302),
    [anon_sym_COMMA] = ACTIONS(302),
    [anon_sym_STAR] = ACTIONS(3249),
    [anon_sym_GT_GT] = ACTIONS(3251),
    [anon_sym_if] = ACTIONS(302),
    [anon_sym_COLON] = ACTIONS(302),
    [anon_sym_in] = ACTIONS(3253),
    [anon_sym_AT] = ACTIONS(3255),
    [anon_sym_not] = ACTIONS(3257),
    [anon_sym_and] = ACTIONS(302),
    [anon_sym_or] = ACTIONS(302),
    [anon_sym_PLUS] = ACTIONS(3259),
    [anon_sym_DASH] = ACTIONS(3259),
    [anon_sym_SLASH] = ACTIONS(3249),
    [anon_sym_PERCENT] = ACTIONS(3255),
    [anon_sym_SLASH_SLASH] = ACTIONS(3255),
    [anon_sym_STAR_STAR] = ACTIONS(3261),
    [anon_sym_PIPE] = ACTIONS(3263),
    [anon_sym_AMP] = ACTIONS(3265),
    [anon_sym_CARET] = ACTIONS(3267),
    [anon_sym_LT_LT] = ACTIONS(3251),
    [anon_sym_LT] = ACTIONS(3269),
    [anon_sym_LT_EQ] = ACTIONS(3253),
    [anon_sym_EQ_EQ] = ACTIONS(3253),
    [anon_sym_BANG_EQ] = ACTIONS(3253),
    [anon_sym_GT_EQ] = ACTIONS(3253),
    [anon_sym_GT] = ACTIONS(3269),
    [anon_sym_LT_GT] = ACTIONS(3253),
    [anon_sym_is] = ACTIONS(3271),
    [anon_sym_LBRACK] = ACTIONS(450),
    [sym_comment] = ACTIONS(72),
  },
  [1180] = {
    [sym_default_parameter] = STATE(822),
    [sym_typed_default_parameter] = STATE(822),
    [sym_list_splat] = STATE(1505),
    [sym_dictionary_splat] = STATE(1505),
    [sym_typed_parameter] = STATE(822),
    [sym_tuple] = STATE(822),
    [anon_sym_LPAREN] = ACTIONS(222),
    [anon_sym_RPAREN] = ACTIONS(1624),
    [anon_sym_STAR] = ACTIONS(1564),
    [anon_sym_print] = ACTIONS(3273),
    [anon_sym_exec] = ACTIONS(3273),
    [sym_identifier] = ACTIONS(3275),
    [sym_comment] = ACTIONS(72),
  },
  [1181] = {
    [sym__expression] = STATE(829),
    [sym__primary_expression] = STATE(830),
    [sym_not_operator] = STATE(829),
    [sym_boolean_operator] = STATE(829),
    [sym_binary_operator] = STATE(830),
    [sym_unary_operator] = STATE(830),
    [sym_comparison_operator] = STATE(829),
    [sym_lambda] = STATE(829),
    [sym_attribute] = STATE(830),
    [sym_subscript] = STATE(830),
    [sym_call] = STATE(830),
    [sym_type] = STATE(1506),
    [sym_list] = STATE(830),
    [sym_list_comprehension] = STATE(830),
    [sym_dictionary] = STATE(830),
    [sym_dictionary_comprehension] = STATE(830),
    [sym_set] = STATE(830),
    [sym_set_comprehension] = STATE(830),
    [sym_parenthesized_expression] = STATE(830),
    [sym_tuple] = STATE(830),
    [sym_generator_expression] = STATE(830),
    [sym_conditional_expression] = STATE(829),
    [sym_concatenated_string] = STATE(830),
    [sym_await] = STATE(829),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_not] = ACTIONS(1628),
    [anon_sym_PLUS] = ACTIONS(1630),
    [anon_sym_DASH] = ACTIONS(1630),
    [anon_sym_TILDE] = ACTIONS(1630),
    [anon_sym_lambda] = ACTIONS(1632),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(1634),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(1636),
    [sym_integer] = ACTIONS(1638),
    [sym_float] = ACTIONS(1638),
    [sym_identifier] = ACTIONS(1638),
    [sym_true] = ACTIONS(1638),
    [sym_false] = ACTIONS(1638),
    [sym_none] = ACTIONS(1638),
    [anon_sym_await] = ACTIONS(1640),
    [sym_comment] = ACTIONS(72),
  },
  [1182] = {
    [sym__expression] = STATE(1507),
    [sym__primary_expression] = STATE(215),
    [sym_not_operator] = STATE(1507),
    [sym_boolean_operator] = STATE(1507),
    [sym_binary_operator] = STATE(215),
    [sym_unary_operator] = STATE(215),
    [sym_comparison_operator] = STATE(1507),
    [sym_lambda] = STATE(1507),
    [sym_attribute] = STATE(215),
    [sym_subscript] = STATE(215),
    [sym_call] = STATE(215),
    [sym_list] = STATE(215),
    [sym_list_comprehension] = STATE(215),
    [sym_dictionary] = STATE(215),
    [sym_dictionary_comprehension] = STATE(215),
    [sym_set] = STATE(215),
    [sym_set_comprehension] = STATE(215),
    [sym_parenthesized_expression] = STATE(215),
    [sym_tuple] = STATE(215),
    [sym_generator_expression] = STATE(215),
    [sym_conditional_expression] = STATE(1507),
    [sym_concatenated_string] = STATE(215),
    [sym_await] = STATE(1507),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_not] = ACTIONS(384),
    [anon_sym_PLUS] = ACTIONS(386),
    [anon_sym_DASH] = ACTIONS(386),
    [anon_sym_TILDE] = ACTIONS(386),
    [anon_sym_lambda] = ACTIONS(388),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(390),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(392),
    [sym_integer] = ACTIONS(394),
    [sym_float] = ACTIONS(394),
    [sym_identifier] = ACTIONS(394),
    [sym_true] = ACTIONS(394),
    [sym_false] = ACTIONS(394),
    [sym_none] = ACTIONS(394),
    [anon_sym_await] = ACTIONS(396),
    [sym_comment] = ACTIONS(72),
  },
  [1183] = {
    [aux_sym__parameters_repeat1] = STATE(1509),
    [anon_sym_RPAREN] = ACTIONS(1624),
    [anon_sym_COMMA] = ACTIONS(3277),
    [sym_comment] = ACTIONS(72),
  },
  [1184] = {
    [sym_default_parameter] = STATE(822),
    [sym_typed_default_parameter] = STATE(822),
    [sym_list_splat] = STATE(1505),
    [sym_dictionary_splat] = STATE(1505),
    [sym_typed_parameter] = STATE(822),
    [sym_tuple] = STATE(822),
    [anon_sym_LPAREN] = ACTIONS(222),
    [anon_sym_RPAREN] = ACTIONS(1646),
    [anon_sym_STAR] = ACTIONS(1564),
    [anon_sym_print] = ACTIONS(3273),
    [anon_sym_exec] = ACTIONS(3273),
    [sym_identifier] = ACTIONS(3275),
    [sym_comment] = ACTIONS(72),
  },
  [1185] = {
    [sym__expression] = STATE(1515),
    [sym__primary_expression] = STATE(1516),
    [sym_not_operator] = STATE(1515),
    [sym_boolean_operator] = STATE(1515),
    [sym_binary_operator] = STATE(1516),
    [sym_unary_operator] = STATE(1516),
    [sym_comparison_operator] = STATE(1515),
    [sym_lambda] = STATE(1515),
    [sym_attribute] = STATE(1516),
    [sym_subscript] = STATE(1516),
    [sym_call] = STATE(1516),
    [sym_type] = STATE(1517),
    [sym_list] = STATE(1516),
    [sym_list_comprehension] = STATE(1516),
    [sym_dictionary] = STATE(1516),
    [sym_dictionary_comprehension] = STATE(1516),
    [sym_set] = STATE(1516),
    [sym_set_comprehension] = STATE(1516),
    [sym_parenthesized_expression] = STATE(1516),
    [sym_tuple] = STATE(1516),
    [sym_generator_expression] = STATE(1516),
    [sym_conditional_expression] = STATE(1515),
    [sym_concatenated_string] = STATE(1516),
    [sym_await] = STATE(1515),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_not] = ACTIONS(3279),
    [anon_sym_PLUS] = ACTIONS(3281),
    [anon_sym_DASH] = ACTIONS(3281),
    [anon_sym_TILDE] = ACTIONS(3281),
    [anon_sym_lambda] = ACTIONS(3283),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(3285),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(3287),
    [sym_integer] = ACTIONS(3289),
    [sym_float] = ACTIONS(3289),
    [sym_identifier] = ACTIONS(3289),
    [sym_true] = ACTIONS(3289),
    [sym_false] = ACTIONS(3289),
    [sym_none] = ACTIONS(3289),
    [anon_sym_await] = ACTIONS(3291),
    [sym_comment] = ACTIONS(72),
  },
  [1186] = {
    [sym__expression] = STATE(1518),
    [sym__primary_expression] = STATE(215),
    [sym_not_operator] = STATE(1518),
    [sym_boolean_operator] = STATE(1518),
    [sym_binary_operator] = STATE(215),
    [sym_unary_operator] = STATE(215),
    [sym_comparison_operator] = STATE(1518),
    [sym_lambda] = STATE(1518),
    [sym_attribute] = STATE(215),
    [sym_subscript] = STATE(215),
    [sym_call] = STATE(215),
    [sym_list] = STATE(215),
    [sym_list_comprehension] = STATE(215),
    [sym_dictionary] = STATE(215),
    [sym_dictionary_comprehension] = STATE(215),
    [sym_set] = STATE(215),
    [sym_set_comprehension] = STATE(215),
    [sym_parenthesized_expression] = STATE(215),
    [sym_tuple] = STATE(215),
    [sym_generator_expression] = STATE(215),
    [sym_conditional_expression] = STATE(1518),
    [sym_concatenated_string] = STATE(215),
    [sym_await] = STATE(1518),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_not] = ACTIONS(384),
    [anon_sym_PLUS] = ACTIONS(386),
    [anon_sym_DASH] = ACTIONS(386),
    [anon_sym_TILDE] = ACTIONS(386),
    [anon_sym_lambda] = ACTIONS(388),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(390),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(392),
    [sym_integer] = ACTIONS(394),
    [sym_float] = ACTIONS(394),
    [sym_identifier] = ACTIONS(394),
    [sym_true] = ACTIONS(394),
    [sym_false] = ACTIONS(394),
    [sym_none] = ACTIONS(394),
    [anon_sym_await] = ACTIONS(396),
    [sym_comment] = ACTIONS(72),
  },
  [1187] = {
    [aux_sym__parameters_repeat1] = STATE(1509),
    [anon_sym_RPAREN] = ACTIONS(1646),
    [anon_sym_COMMA] = ACTIONS(3293),
    [sym_comment] = ACTIONS(72),
  },
  [1188] = {
    [anon_sym_COLON] = ACTIONS(3295),
    [anon_sym_DASH_GT] = ACTIONS(3295),
    [sym_comment] = ACTIONS(72),
  },
  [1189] = {
    [sym__expression] = STATE(1520),
    [sym__primary_expression] = STATE(215),
    [sym_not_operator] = STATE(1520),
    [sym_boolean_operator] = STATE(1520),
    [sym_binary_operator] = STATE(215),
    [sym_unary_operator] = STATE(215),
    [sym_comparison_operator] = STATE(1520),
    [sym_lambda] = STATE(1520),
    [sym_attribute] = STATE(215),
    [sym_subscript] = STATE(215),
    [sym_call] = STATE(215),
    [sym_type] = STATE(847),
    [sym_list] = STATE(215),
    [sym_list_comprehension] = STATE(215),
    [sym_dictionary] = STATE(215),
    [sym_dictionary_comprehension] = STATE(215),
    [sym_set] = STATE(215),
    [sym_set_comprehension] = STATE(215),
    [sym_parenthesized_expression] = STATE(215),
    [sym_tuple] = STATE(215),
    [sym_generator_expression] = STATE(215),
    [sym_conditional_expression] = STATE(1520),
    [sym_concatenated_string] = STATE(215),
    [sym_await] = STATE(1520),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_not] = ACTIONS(384),
    [anon_sym_PLUS] = ACTIONS(386),
    [anon_sym_DASH] = ACTIONS(386),
    [anon_sym_TILDE] = ACTIONS(386),
    [anon_sym_lambda] = ACTIONS(388),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(390),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(392),
    [sym_integer] = ACTIONS(394),
    [sym_float] = ACTIONS(394),
    [sym_identifier] = ACTIONS(394),
    [sym_true] = ACTIONS(394),
    [sym_false] = ACTIONS(394),
    [sym_none] = ACTIONS(394),
    [anon_sym_await] = ACTIONS(396),
    [sym_comment] = ACTIONS(72),
  },
  [1190] = {
    [ts_builtin_sym_end] = ACTIONS(3297),
    [anon_sym_import] = ACTIONS(3299),
    [anon_sym_from] = ACTIONS(3299),
    [anon_sym_LPAREN] = ACTIONS(3297),
    [anon_sym_print] = ACTIONS(3299),
    [anon_sym_assert] = ACTIONS(3299),
    [anon_sym_return] = ACTIONS(3299),
    [anon_sym_del] = ACTIONS(3299),
    [anon_sym_raise] = ACTIONS(3299),
    [sym_pass_statement] = ACTIONS(3299),
    [sym_break_statement] = ACTIONS(3299),
    [sym_continue_statement] = ACTIONS(3299),
    [anon_sym_if] = ACTIONS(3299),
    [anon_sym_async] = ACTIONS(3299),
    [anon_sym_for] = ACTIONS(3299),
    [anon_sym_while] = ACTIONS(3299),
    [anon_sym_try] = ACTIONS(3299),
    [anon_sym_with] = ACTIONS(3299),
    [anon_sym_def] = ACTIONS(3299),
    [anon_sym_global] = ACTIONS(3299),
    [anon_sym_nonlocal] = ACTIONS(3299),
    [anon_sym_exec] = ACTIONS(3299),
    [anon_sym_class] = ACTIONS(3299),
    [anon_sym_AT] = ACTIONS(3297),
    [anon_sym_not] = ACTIONS(3299),
    [anon_sym_PLUS] = ACTIONS(3297),
    [anon_sym_DASH] = ACTIONS(3297),
    [anon_sym_TILDE] = ACTIONS(3297),
    [anon_sym_lambda] = ACTIONS(3299),
    [anon_sym_yield] = ACTIONS(3299),
    [anon_sym_LBRACK] = ACTIONS(3297),
    [sym_ellipsis] = ACTIONS(3297),
    [anon_sym_LBRACE] = ACTIONS(3297),
    [sym_string] = ACTIONS(3297),
    [sym_integer] = ACTIONS(3299),
    [sym_float] = ACTIONS(3299),
    [sym_identifier] = ACTIONS(3299),
    [sym_true] = ACTIONS(3299),
    [sym_false] = ACTIONS(3299),
    [sym_none] = ACTIONS(3299),
    [anon_sym_await] = ACTIONS(3299),
    [sym_comment] = ACTIONS(72),
  },
  [1191] = {
    [anon_sym_if] = ACTIONS(590),
    [anon_sym_COLON] = ACTIONS(1873),
    [anon_sym_and] = ACTIONS(594),
    [anon_sym_or] = ACTIONS(596),
    [sym_comment] = ACTIONS(72),
  },
  [1192] = {
    [anon_sym_COLON] = ACTIONS(3301),
    [sym_comment] = ACTIONS(72),
  },
  [1193] = {
    [aux_sym_print_statement_repeat1] = STATE(650),
    [sym__newline] = ACTIONS(3303),
    [anon_sym_COMMA] = ACTIONS(514),
    [sym_comment] = ACTIONS(72),
    [sym__semicolon] = ACTIONS(3303),
  },
  [1194] = {
    [ts_builtin_sym_end] = ACTIONS(3305),
    [anon_sym_import] = ACTIONS(3307),
    [anon_sym_from] = ACTIONS(3307),
    [anon_sym_LPAREN] = ACTIONS(3305),
    [anon_sym_print] = ACTIONS(3307),
    [anon_sym_assert] = ACTIONS(3307),
    [anon_sym_return] = ACTIONS(3307),
    [anon_sym_del] = ACTIONS(3307),
    [anon_sym_raise] = ACTIONS(3307),
    [sym_pass_statement] = ACTIONS(3307),
    [sym_break_statement] = ACTIONS(3307),
    [sym_continue_statement] = ACTIONS(3307),
    [anon_sym_if] = ACTIONS(3307),
    [anon_sym_async] = ACTIONS(3307),
    [anon_sym_for] = ACTIONS(3307),
    [anon_sym_while] = ACTIONS(3307),
    [anon_sym_try] = ACTIONS(3307),
    [anon_sym_with] = ACTIONS(3307),
    [anon_sym_def] = ACTIONS(3307),
    [anon_sym_global] = ACTIONS(3307),
    [anon_sym_nonlocal] = ACTIONS(3307),
    [anon_sym_exec] = ACTIONS(3307),
    [anon_sym_class] = ACTIONS(3307),
    [anon_sym_AT] = ACTIONS(3305),
    [anon_sym_not] = ACTIONS(3307),
    [anon_sym_PLUS] = ACTIONS(3305),
    [anon_sym_DASH] = ACTIONS(3305),
    [anon_sym_TILDE] = ACTIONS(3305),
    [anon_sym_lambda] = ACTIONS(3307),
    [anon_sym_yield] = ACTIONS(3307),
    [anon_sym_LBRACK] = ACTIONS(3305),
    [sym_ellipsis] = ACTIONS(3305),
    [anon_sym_LBRACE] = ACTIONS(3305),
    [sym_string] = ACTIONS(3305),
    [sym_integer] = ACTIONS(3307),
    [sym_float] = ACTIONS(3307),
    [sym_identifier] = ACTIONS(3307),
    [sym_true] = ACTIONS(3307),
    [sym_false] = ACTIONS(3307),
    [sym_none] = ACTIONS(3307),
    [anon_sym_await] = ACTIONS(3307),
    [sym_comment] = ACTIONS(72),
  },
  [1195] = {
    [anon_sym_COMMA] = ACTIONS(1644),
    [anon_sym_if] = ACTIONS(1592),
    [anon_sym_COLON] = ACTIONS(1644),
    [anon_sym_and] = ACTIONS(1594),
    [anon_sym_or] = ACTIONS(1596),
    [sym_comment] = ACTIONS(72),
  },
  [1196] = {
    [sym__expression] = STATE(1522),
    [sym__primary_expression] = STATE(410),
    [sym_not_operator] = STATE(1522),
    [sym_boolean_operator] = STATE(1522),
    [sym_binary_operator] = STATE(410),
    [sym_unary_operator] = STATE(410),
    [sym_comparison_operator] = STATE(1522),
    [sym_lambda] = STATE(1522),
    [sym_attribute] = STATE(410),
    [sym_subscript] = STATE(410),
    [sym_call] = STATE(410),
    [sym_list] = STATE(410),
    [sym_list_comprehension] = STATE(410),
    [sym_dictionary] = STATE(410),
    [sym_dictionary_comprehension] = STATE(410),
    [sym_set] = STATE(410),
    [sym_set_comprehension] = STATE(410),
    [sym_parenthesized_expression] = STATE(410),
    [sym_tuple] = STATE(410),
    [sym_generator_expression] = STATE(410),
    [sym_conditional_expression] = STATE(1522),
    [sym_concatenated_string] = STATE(410),
    [sym_await] = STATE(1522),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_not] = ACTIONS(726),
    [anon_sym_PLUS] = ACTIONS(728),
    [anon_sym_DASH] = ACTIONS(728),
    [anon_sym_TILDE] = ACTIONS(728),
    [anon_sym_lambda] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(732),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(734),
    [sym_integer] = ACTIONS(736),
    [sym_float] = ACTIONS(736),
    [sym_identifier] = ACTIONS(736),
    [sym_true] = ACTIONS(736),
    [sym_false] = ACTIONS(736),
    [sym_none] = ACTIONS(736),
    [anon_sym_await] = ACTIONS(738),
    [sym_comment] = ACTIONS(72),
  },
  [1197] = {
    [aux_sym_concatenated_string_repeat1] = STATE(1197),
    [anon_sym_DOT] = ACTIONS(1862),
    [anon_sym_LPAREN] = ACTIONS(1862),
    [anon_sym_COMMA] = ACTIONS(1862),
    [anon_sym_STAR] = ACTIONS(1864),
    [anon_sym_GT_GT] = ACTIONS(1862),
    [anon_sym_if] = ACTIONS(1862),
    [anon_sym_COLON] = ACTIONS(1862),
    [anon_sym_in] = ACTIONS(1862),
    [anon_sym_AT] = ACTIONS(1862),
    [anon_sym_not] = ACTIONS(1862),
    [anon_sym_and] = ACTIONS(1862),
    [anon_sym_or] = ACTIONS(1862),
    [anon_sym_PLUS] = ACTIONS(1862),
    [anon_sym_DASH] = ACTIONS(1862),
    [anon_sym_SLASH] = ACTIONS(1864),
    [anon_sym_PERCENT] = ACTIONS(1862),
    [anon_sym_SLASH_SLASH] = ACTIONS(1862),
    [anon_sym_STAR_STAR] = ACTIONS(1862),
    [anon_sym_PIPE] = ACTIONS(1862),
    [anon_sym_AMP] = ACTIONS(1862),
    [anon_sym_CARET] = ACTIONS(1862),
    [anon_sym_LT_LT] = ACTIONS(1862),
    [anon_sym_LT] = ACTIONS(1864),
    [anon_sym_LT_EQ] = ACTIONS(1862),
    [anon_sym_EQ_EQ] = ACTIONS(1862),
    [anon_sym_BANG_EQ] = ACTIONS(1862),
    [anon_sym_GT_EQ] = ACTIONS(1862),
    [anon_sym_GT] = ACTIONS(1864),
    [anon_sym_LT_GT] = ACTIONS(1862),
    [anon_sym_is] = ACTIONS(1862),
    [anon_sym_LBRACK] = ACTIONS(1862),
    [sym_string] = ACTIONS(3309),
    [sym_comment] = ACTIONS(72),
  },
  [1198] = {
    [anon_sym_if] = ACTIONS(1921),
    [anon_sym_else] = ACTIONS(3312),
    [anon_sym_and] = ACTIONS(1925),
    [anon_sym_or] = ACTIONS(1927),
    [sym_comment] = ACTIONS(72),
  },
  [1199] = {
    [anon_sym_COMMA] = ACTIONS(1953),
    [anon_sym_if] = ACTIONS(1953),
    [anon_sym_COLON] = ACTIONS(1953),
    [anon_sym_and] = ACTIONS(1594),
    [anon_sym_or] = ACTIONS(1953),
    [sym_comment] = ACTIONS(72),
  },
  [1200] = {
    [sym_argument_list] = STATE(251),
    [sym_generator_expression] = STATE(251),
    [anon_sym_DOT] = ACTIONS(1980),
    [anon_sym_LPAREN] = ACTIONS(424),
    [anon_sym_COMMA] = ACTIONS(1980),
    [anon_sym_STAR] = ACTIONS(1982),
    [anon_sym_GT_GT] = ACTIONS(1980),
    [anon_sym_if] = ACTIONS(1980),
    [anon_sym_COLON] = ACTIONS(1980),
    [anon_sym_in] = ACTIONS(1980),
    [anon_sym_AT] = ACTIONS(1980),
    [anon_sym_not] = ACTIONS(1980),
    [anon_sym_and] = ACTIONS(1980),
    [anon_sym_or] = ACTIONS(1980),
    [anon_sym_PLUS] = ACTIONS(1980),
    [anon_sym_DASH] = ACTIONS(1980),
    [anon_sym_SLASH] = ACTIONS(1982),
    [anon_sym_PERCENT] = ACTIONS(1980),
    [anon_sym_SLASH_SLASH] = ACTIONS(1980),
    [anon_sym_STAR_STAR] = ACTIONS(1610),
    [anon_sym_PIPE] = ACTIONS(1980),
    [anon_sym_AMP] = ACTIONS(1980),
    [anon_sym_CARET] = ACTIONS(1980),
    [anon_sym_LT_LT] = ACTIONS(1980),
    [anon_sym_LT] = ACTIONS(1982),
    [anon_sym_LT_EQ] = ACTIONS(1980),
    [anon_sym_EQ_EQ] = ACTIONS(1980),
    [anon_sym_BANG_EQ] = ACTIONS(1980),
    [anon_sym_GT_EQ] = ACTIONS(1980),
    [anon_sym_GT] = ACTIONS(1982),
    [anon_sym_LT_GT] = ACTIONS(1980),
    [anon_sym_is] = ACTIONS(1980),
    [anon_sym_LBRACK] = ACTIONS(1980),
    [sym_comment] = ACTIONS(72),
  },
  [1201] = {
    [sym_argument_list] = STATE(251),
    [sym_generator_expression] = STATE(251),
    [anon_sym_DOT] = ACTIONS(1980),
    [anon_sym_LPAREN] = ACTIONS(424),
    [anon_sym_COMMA] = ACTIONS(1980),
    [anon_sym_STAR] = ACTIONS(1598),
    [anon_sym_GT_GT] = ACTIONS(1980),
    [anon_sym_if] = ACTIONS(1980),
    [anon_sym_COLON] = ACTIONS(1980),
    [anon_sym_in] = ACTIONS(1980),
    [anon_sym_AT] = ACTIONS(1604),
    [anon_sym_not] = ACTIONS(1980),
    [anon_sym_and] = ACTIONS(1980),
    [anon_sym_or] = ACTIONS(1980),
    [anon_sym_PLUS] = ACTIONS(1608),
    [anon_sym_DASH] = ACTIONS(1608),
    [anon_sym_SLASH] = ACTIONS(1598),
    [anon_sym_PERCENT] = ACTIONS(1604),
    [anon_sym_SLASH_SLASH] = ACTIONS(1604),
    [anon_sym_STAR_STAR] = ACTIONS(1610),
    [anon_sym_PIPE] = ACTIONS(1980),
    [anon_sym_AMP] = ACTIONS(1980),
    [anon_sym_CARET] = ACTIONS(1980),
    [anon_sym_LT_LT] = ACTIONS(1980),
    [anon_sym_LT] = ACTIONS(1982),
    [anon_sym_LT_EQ] = ACTIONS(1980),
    [anon_sym_EQ_EQ] = ACTIONS(1980),
    [anon_sym_BANG_EQ] = ACTIONS(1980),
    [anon_sym_GT_EQ] = ACTIONS(1980),
    [anon_sym_GT] = ACTIONS(1982),
    [anon_sym_LT_GT] = ACTIONS(1980),
    [anon_sym_is] = ACTIONS(1980),
    [anon_sym_LBRACK] = ACTIONS(1980),
    [sym_comment] = ACTIONS(72),
  },
  [1202] = {
    [sym_argument_list] = STATE(251),
    [sym_generator_expression] = STATE(251),
    [anon_sym_DOT] = ACTIONS(422),
    [anon_sym_LPAREN] = ACTIONS(424),
    [anon_sym_COMMA] = ACTIONS(1984),
    [anon_sym_STAR] = ACTIONS(1598),
    [anon_sym_GT_GT] = ACTIONS(1600),
    [anon_sym_if] = ACTIONS(1984),
    [anon_sym_COLON] = ACTIONS(1984),
    [anon_sym_in] = ACTIONS(1984),
    [anon_sym_AT] = ACTIONS(1604),
    [anon_sym_not] = ACTIONS(1984),
    [anon_sym_and] = ACTIONS(1984),
    [anon_sym_or] = ACTIONS(1984),
    [anon_sym_PLUS] = ACTIONS(1608),
    [anon_sym_DASH] = ACTIONS(1608),
    [anon_sym_SLASH] = ACTIONS(1598),
    [anon_sym_PERCENT] = ACTIONS(1604),
    [anon_sym_SLASH_SLASH] = ACTIONS(1604),
    [anon_sym_STAR_STAR] = ACTIONS(1610),
    [anon_sym_PIPE] = ACTIONS(1612),
    [anon_sym_AMP] = ACTIONS(1614),
    [anon_sym_CARET] = ACTIONS(1616),
    [anon_sym_LT_LT] = ACTIONS(1600),
    [anon_sym_LT] = ACTIONS(1986),
    [anon_sym_LT_EQ] = ACTIONS(1984),
    [anon_sym_EQ_EQ] = ACTIONS(1984),
    [anon_sym_BANG_EQ] = ACTIONS(1984),
    [anon_sym_GT_EQ] = ACTIONS(1984),
    [anon_sym_GT] = ACTIONS(1986),
    [anon_sym_LT_GT] = ACTIONS(1984),
    [anon_sym_is] = ACTIONS(1984),
    [anon_sym_LBRACK] = ACTIONS(450),
    [sym_comment] = ACTIONS(72),
  },
  [1203] = {
    [sym__primary_expression] = STATE(1524),
    [sym_binary_operator] = STATE(1524),
    [sym_unary_operator] = STATE(1524),
    [sym_attribute] = STATE(1524),
    [sym_subscript] = STATE(1524),
    [sym_call] = STATE(1524),
    [sym_list] = STATE(1524),
    [sym_list_comprehension] = STATE(1524),
    [sym_dictionary] = STATE(1524),
    [sym_dictionary_comprehension] = STATE(1524),
    [sym_set] = STATE(1524),
    [sym_set_comprehension] = STATE(1524),
    [sym_parenthesized_expression] = STATE(1524),
    [sym_tuple] = STATE(1524),
    [sym_generator_expression] = STATE(1524),
    [sym_concatenated_string] = STATE(1524),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_PLUS] = ACTIONS(728),
    [anon_sym_DASH] = ACTIONS(728),
    [anon_sym_TILDE] = ACTIONS(728),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(3314),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(734),
    [sym_integer] = ACTIONS(3316),
    [sym_float] = ACTIONS(3316),
    [sym_identifier] = ACTIONS(3316),
    [sym_true] = ACTIONS(3316),
    [sym_false] = ACTIONS(3316),
    [sym_none] = ACTIONS(3316),
    [sym_comment] = ACTIONS(72),
  },
  [1204] = {
    [sym_argument_list] = STATE(251),
    [sym_generator_expression] = STATE(251),
    [anon_sym_DOT] = ACTIONS(1980),
    [anon_sym_LPAREN] = ACTIONS(424),
    [anon_sym_COMMA] = ACTIONS(1980),
    [anon_sym_STAR] = ACTIONS(1598),
    [anon_sym_GT_GT] = ACTIONS(1980),
    [anon_sym_if] = ACTIONS(1980),
    [anon_sym_COLON] = ACTIONS(1980),
    [anon_sym_in] = ACTIONS(1980),
    [anon_sym_AT] = ACTIONS(1604),
    [anon_sym_not] = ACTIONS(1980),
    [anon_sym_and] = ACTIONS(1980),
    [anon_sym_or] = ACTIONS(1980),
    [anon_sym_PLUS] = ACTIONS(1980),
    [anon_sym_DASH] = ACTIONS(1980),
    [anon_sym_SLASH] = ACTIONS(1598),
    [anon_sym_PERCENT] = ACTIONS(1604),
    [anon_sym_SLASH_SLASH] = ACTIONS(1604),
    [anon_sym_STAR_STAR] = ACTIONS(1610),
    [anon_sym_PIPE] = ACTIONS(1980),
    [anon_sym_AMP] = ACTIONS(1980),
    [anon_sym_CARET] = ACTIONS(1980),
    [anon_sym_LT_LT] = ACTIONS(1980),
    [anon_sym_LT] = ACTIONS(1982),
    [anon_sym_LT_EQ] = ACTIONS(1980),
    [anon_sym_EQ_EQ] = ACTIONS(1980),
    [anon_sym_BANG_EQ] = ACTIONS(1980),
    [anon_sym_GT_EQ] = ACTIONS(1980),
    [anon_sym_GT] = ACTIONS(1982),
    [anon_sym_LT_GT] = ACTIONS(1980),
    [anon_sym_is] = ACTIONS(1980),
    [anon_sym_LBRACK] = ACTIONS(1980),
    [sym_comment] = ACTIONS(72),
  },
  [1205] = {
    [sym_argument_list] = STATE(251),
    [sym_generator_expression] = STATE(251),
    [anon_sym_DOT] = ACTIONS(1980),
    [anon_sym_LPAREN] = ACTIONS(424),
    [anon_sym_COMMA] = ACTIONS(1980),
    [anon_sym_STAR] = ACTIONS(1598),
    [anon_sym_GT_GT] = ACTIONS(1600),
    [anon_sym_if] = ACTIONS(1980),
    [anon_sym_COLON] = ACTIONS(1980),
    [anon_sym_in] = ACTIONS(1980),
    [anon_sym_AT] = ACTIONS(1604),
    [anon_sym_not] = ACTIONS(1980),
    [anon_sym_and] = ACTIONS(1980),
    [anon_sym_or] = ACTIONS(1980),
    [anon_sym_PLUS] = ACTIONS(1608),
    [anon_sym_DASH] = ACTIONS(1608),
    [anon_sym_SLASH] = ACTIONS(1598),
    [anon_sym_PERCENT] = ACTIONS(1604),
    [anon_sym_SLASH_SLASH] = ACTIONS(1604),
    [anon_sym_STAR_STAR] = ACTIONS(1610),
    [anon_sym_PIPE] = ACTIONS(1980),
    [anon_sym_AMP] = ACTIONS(1614),
    [anon_sym_CARET] = ACTIONS(1616),
    [anon_sym_LT_LT] = ACTIONS(1600),
    [anon_sym_LT] = ACTIONS(1982),
    [anon_sym_LT_EQ] = ACTIONS(1980),
    [anon_sym_EQ_EQ] = ACTIONS(1980),
    [anon_sym_BANG_EQ] = ACTIONS(1980),
    [anon_sym_GT_EQ] = ACTIONS(1980),
    [anon_sym_GT] = ACTIONS(1982),
    [anon_sym_LT_GT] = ACTIONS(1980),
    [anon_sym_is] = ACTIONS(1980),
    [anon_sym_LBRACK] = ACTIONS(1980),
    [sym_comment] = ACTIONS(72),
  },
  [1206] = {
    [sym_argument_list] = STATE(251),
    [sym_generator_expression] = STATE(251),
    [anon_sym_DOT] = ACTIONS(1980),
    [anon_sym_LPAREN] = ACTIONS(424),
    [anon_sym_COMMA] = ACTIONS(1980),
    [anon_sym_STAR] = ACTIONS(1598),
    [anon_sym_GT_GT] = ACTIONS(1600),
    [anon_sym_if] = ACTIONS(1980),
    [anon_sym_COLON] = ACTIONS(1980),
    [anon_sym_in] = ACTIONS(1980),
    [anon_sym_AT] = ACTIONS(1604),
    [anon_sym_not] = ACTIONS(1980),
    [anon_sym_and] = ACTIONS(1980),
    [anon_sym_or] = ACTIONS(1980),
    [anon_sym_PLUS] = ACTIONS(1608),
    [anon_sym_DASH] = ACTIONS(1608),
    [anon_sym_SLASH] = ACTIONS(1598),
    [anon_sym_PERCENT] = ACTIONS(1604),
    [anon_sym_SLASH_SLASH] = ACTIONS(1604),
    [anon_sym_STAR_STAR] = ACTIONS(1610),
    [anon_sym_PIPE] = ACTIONS(1980),
    [anon_sym_AMP] = ACTIONS(1980),
    [anon_sym_CARET] = ACTIONS(1616),
    [anon_sym_LT_LT] = ACTIONS(1600),
    [anon_sym_LT] = ACTIONS(1982),
    [anon_sym_LT_EQ] = ACTIONS(1980),
    [anon_sym_EQ_EQ] = ACTIONS(1980),
    [anon_sym_BANG_EQ] = ACTIONS(1980),
    [anon_sym_GT_EQ] = ACTIONS(1980),
    [anon_sym_GT] = ACTIONS(1982),
    [anon_sym_LT_GT] = ACTIONS(1980),
    [anon_sym_is] = ACTIONS(1980),
    [anon_sym_LBRACK] = ACTIONS(1980),
    [sym_comment] = ACTIONS(72),
  },
  [1207] = {
    [sym_argument_list] = STATE(251),
    [sym_generator_expression] = STATE(251),
    [anon_sym_DOT] = ACTIONS(1980),
    [anon_sym_LPAREN] = ACTIONS(424),
    [anon_sym_COMMA] = ACTIONS(1980),
    [anon_sym_STAR] = ACTIONS(1598),
    [anon_sym_GT_GT] = ACTIONS(1600),
    [anon_sym_if] = ACTIONS(1980),
    [anon_sym_COLON] = ACTIONS(1980),
    [anon_sym_in] = ACTIONS(1980),
    [anon_sym_AT] = ACTIONS(1604),
    [anon_sym_not] = ACTIONS(1980),
    [anon_sym_and] = ACTIONS(1980),
    [anon_sym_or] = ACTIONS(1980),
    [anon_sym_PLUS] = ACTIONS(1608),
    [anon_sym_DASH] = ACTIONS(1608),
    [anon_sym_SLASH] = ACTIONS(1598),
    [anon_sym_PERCENT] = ACTIONS(1604),
    [anon_sym_SLASH_SLASH] = ACTIONS(1604),
    [anon_sym_STAR_STAR] = ACTIONS(1610),
    [anon_sym_PIPE] = ACTIONS(1980),
    [anon_sym_AMP] = ACTIONS(1980),
    [anon_sym_CARET] = ACTIONS(1980),
    [anon_sym_LT_LT] = ACTIONS(1600),
    [anon_sym_LT] = ACTIONS(1982),
    [anon_sym_LT_EQ] = ACTIONS(1980),
    [anon_sym_EQ_EQ] = ACTIONS(1980),
    [anon_sym_BANG_EQ] = ACTIONS(1980),
    [anon_sym_GT_EQ] = ACTIONS(1980),
    [anon_sym_GT] = ACTIONS(1982),
    [anon_sym_LT_GT] = ACTIONS(1980),
    [anon_sym_is] = ACTIONS(1980),
    [anon_sym_LBRACK] = ACTIONS(1980),
    [sym_comment] = ACTIONS(72),
  },
  [1208] = {
    [aux_sym_comparison_operator_repeat1] = STATE(1208),
    [anon_sym_COMMA] = ACTIONS(1984),
    [anon_sym_if] = ACTIONS(1984),
    [anon_sym_COLON] = ACTIONS(1984),
    [anon_sym_in] = ACTIONS(3318),
    [anon_sym_not] = ACTIONS(3321),
    [anon_sym_and] = ACTIONS(1984),
    [anon_sym_or] = ACTIONS(1984),
    [anon_sym_LT] = ACTIONS(3324),
    [anon_sym_LT_EQ] = ACTIONS(3318),
    [anon_sym_EQ_EQ] = ACTIONS(3318),
    [anon_sym_BANG_EQ] = ACTIONS(3318),
    [anon_sym_GT_EQ] = ACTIONS(3318),
    [anon_sym_GT] = ACTIONS(3324),
    [anon_sym_LT_GT] = ACTIONS(3318),
    [anon_sym_is] = ACTIONS(3327),
    [sym_comment] = ACTIONS(72),
  },
  [1209] = {
    [anon_sym_if] = ACTIONS(716),
    [anon_sym_EQ] = ACTIONS(716),
    [anon_sym_and] = ACTIONS(2563),
    [anon_sym_or] = ACTIONS(2565),
    [sym_comment] = ACTIONS(72),
  },
  [1210] = {
    [sym__expression] = STATE(1525),
    [sym__primary_expression] = STATE(830),
    [sym_not_operator] = STATE(1525),
    [sym_boolean_operator] = STATE(1525),
    [sym_binary_operator] = STATE(830),
    [sym_unary_operator] = STATE(830),
    [sym_comparison_operator] = STATE(1525),
    [sym_lambda] = STATE(1525),
    [sym_attribute] = STATE(830),
    [sym_subscript] = STATE(830),
    [sym_call] = STATE(830),
    [sym_list] = STATE(830),
    [sym_list_comprehension] = STATE(830),
    [sym_dictionary] = STATE(830),
    [sym_dictionary_comprehension] = STATE(830),
    [sym_set] = STATE(830),
    [sym_set_comprehension] = STATE(830),
    [sym_parenthesized_expression] = STATE(830),
    [sym_tuple] = STATE(830),
    [sym_generator_expression] = STATE(830),
    [sym_conditional_expression] = STATE(1525),
    [sym_concatenated_string] = STATE(830),
    [sym_await] = STATE(1525),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_not] = ACTIONS(1628),
    [anon_sym_PLUS] = ACTIONS(1630),
    [anon_sym_DASH] = ACTIONS(1630),
    [anon_sym_TILDE] = ACTIONS(1630),
    [anon_sym_lambda] = ACTIONS(1632),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(1634),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(1636),
    [sym_integer] = ACTIONS(1638),
    [sym_float] = ACTIONS(1638),
    [sym_identifier] = ACTIONS(1638),
    [sym_true] = ACTIONS(1638),
    [sym_false] = ACTIONS(1638),
    [sym_none] = ACTIONS(1638),
    [anon_sym_await] = ACTIONS(1640),
    [sym_comment] = ACTIONS(72),
  },
  [1211] = {
    [anon_sym_COLON] = ACTIONS(3330),
    [sym_comment] = ACTIONS(72),
  },
  [1212] = {
    [aux_sym_concatenated_string_repeat1] = STATE(1527),
    [anon_sym_DOT] = ACTIONS(886),
    [anon_sym_LPAREN] = ACTIONS(886),
    [anon_sym_STAR] = ACTIONS(888),
    [anon_sym_GT_GT] = ACTIONS(886),
    [anon_sym_if] = ACTIONS(886),
    [anon_sym_in] = ACTIONS(886),
    [anon_sym_EQ] = ACTIONS(888),
    [anon_sym_AT] = ACTIONS(886),
    [anon_sym_not] = ACTIONS(886),
    [anon_sym_and] = ACTIONS(886),
    [anon_sym_or] = ACTIONS(886),
    [anon_sym_PLUS] = ACTIONS(886),
    [anon_sym_DASH] = ACTIONS(886),
    [anon_sym_SLASH] = ACTIONS(888),
    [anon_sym_PERCENT] = ACTIONS(886),
    [anon_sym_SLASH_SLASH] = ACTIONS(886),
    [anon_sym_STAR_STAR] = ACTIONS(886),
    [anon_sym_PIPE] = ACTIONS(886),
    [anon_sym_AMP] = ACTIONS(886),
    [anon_sym_CARET] = ACTIONS(886),
    [anon_sym_LT_LT] = ACTIONS(886),
    [anon_sym_LT] = ACTIONS(888),
    [anon_sym_LT_EQ] = ACTIONS(886),
    [anon_sym_EQ_EQ] = ACTIONS(886),
    [anon_sym_BANG_EQ] = ACTIONS(886),
    [anon_sym_GT_EQ] = ACTIONS(886),
    [anon_sym_GT] = ACTIONS(888),
    [anon_sym_LT_GT] = ACTIONS(886),
    [anon_sym_is] = ACTIONS(886),
    [anon_sym_LBRACK] = ACTIONS(886),
    [sym_string] = ACTIONS(3332),
    [sym_comment] = ACTIONS(72),
  },
  [1213] = {
    [sym__expression] = STATE(1528),
    [sym__primary_expression] = STATE(513),
    [sym_not_operator] = STATE(1528),
    [sym_boolean_operator] = STATE(1528),
    [sym_binary_operator] = STATE(513),
    [sym_unary_operator] = STATE(513),
    [sym_comparison_operator] = STATE(1528),
    [sym_lambda] = STATE(1528),
    [sym_attribute] = STATE(513),
    [sym_subscript] = STATE(513),
    [sym_call] = STATE(513),
    [sym_list] = STATE(513),
    [sym_list_comprehension] = STATE(513),
    [sym_dictionary] = STATE(513),
    [sym_dictionary_comprehension] = STATE(513),
    [sym_set] = STATE(513),
    [sym_set_comprehension] = STATE(513),
    [sym_parenthesized_expression] = STATE(513),
    [sym_tuple] = STATE(513),
    [sym_generator_expression] = STATE(513),
    [sym_conditional_expression] = STATE(1528),
    [sym_concatenated_string] = STATE(513),
    [sym_await] = STATE(1528),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_not] = ACTIONS(914),
    [anon_sym_PLUS] = ACTIONS(916),
    [anon_sym_DASH] = ACTIONS(916),
    [anon_sym_TILDE] = ACTIONS(916),
    [anon_sym_lambda] = ACTIONS(918),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(920),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(922),
    [sym_integer] = ACTIONS(924),
    [sym_float] = ACTIONS(924),
    [sym_identifier] = ACTIONS(924),
    [sym_true] = ACTIONS(924),
    [sym_false] = ACTIONS(924),
    [sym_none] = ACTIONS(924),
    [anon_sym_await] = ACTIONS(926),
    [sym_comment] = ACTIONS(72),
  },
  [1214] = {
    [sym__expression] = STATE(604),
    [sym__primary_expression] = STATE(830),
    [sym_not_operator] = STATE(604),
    [sym_boolean_operator] = STATE(604),
    [sym_binary_operator] = STATE(830),
    [sym_unary_operator] = STATE(830),
    [sym_comparison_operator] = STATE(604),
    [sym_lambda] = STATE(604),
    [sym_attribute] = STATE(830),
    [sym_subscript] = STATE(830),
    [sym_call] = STATE(830),
    [sym_list] = STATE(830),
    [sym_list_comprehension] = STATE(830),
    [sym_dictionary] = STATE(830),
    [sym_dictionary_comprehension] = STATE(830),
    [sym_set] = STATE(830),
    [sym_set_comprehension] = STATE(830),
    [sym_parenthesized_expression] = STATE(830),
    [sym_tuple] = STATE(830),
    [sym_generator_expression] = STATE(830),
    [sym_conditional_expression] = STATE(604),
    [sym_concatenated_string] = STATE(830),
    [sym_await] = STATE(604),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_not] = ACTIONS(1628),
    [anon_sym_PLUS] = ACTIONS(1630),
    [anon_sym_DASH] = ACTIONS(1630),
    [anon_sym_TILDE] = ACTIONS(1630),
    [anon_sym_lambda] = ACTIONS(1632),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(1634),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(1636),
    [sym_integer] = ACTIONS(1638),
    [sym_float] = ACTIONS(1638),
    [sym_identifier] = ACTIONS(1638),
    [sym_true] = ACTIONS(1638),
    [sym_false] = ACTIONS(1638),
    [sym_none] = ACTIONS(1638),
    [anon_sym_await] = ACTIONS(1640),
    [sym_comment] = ACTIONS(72),
  },
  [1215] = {
    [sym__expression] = STATE(1529),
    [sym__primary_expression] = STATE(830),
    [sym_not_operator] = STATE(1529),
    [sym_boolean_operator] = STATE(1529),
    [sym_binary_operator] = STATE(830),
    [sym_unary_operator] = STATE(830),
    [sym_comparison_operator] = STATE(1529),
    [sym_lambda] = STATE(1529),
    [sym_attribute] = STATE(830),
    [sym_subscript] = STATE(830),
    [sym_call] = STATE(830),
    [sym_list] = STATE(830),
    [sym_list_comprehension] = STATE(830),
    [sym_dictionary] = STATE(830),
    [sym_dictionary_comprehension] = STATE(830),
    [sym_set] = STATE(830),
    [sym_set_comprehension] = STATE(830),
    [sym_parenthesized_expression] = STATE(830),
    [sym_tuple] = STATE(830),
    [sym_generator_expression] = STATE(830),
    [sym_conditional_expression] = STATE(1529),
    [sym_concatenated_string] = STATE(830),
    [sym_await] = STATE(1529),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_not] = ACTIONS(1628),
    [anon_sym_PLUS] = ACTIONS(1630),
    [anon_sym_DASH] = ACTIONS(1630),
    [anon_sym_TILDE] = ACTIONS(1630),
    [anon_sym_lambda] = ACTIONS(1632),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(1634),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(1636),
    [sym_integer] = ACTIONS(1638),
    [sym_float] = ACTIONS(1638),
    [sym_identifier] = ACTIONS(1638),
    [sym_true] = ACTIONS(1638),
    [sym_false] = ACTIONS(1638),
    [sym_none] = ACTIONS(1638),
    [anon_sym_await] = ACTIONS(1640),
    [sym_comment] = ACTIONS(72),
  },
  [1216] = {
    [sym__primary_expression] = STATE(1530),
    [sym_binary_operator] = STATE(1530),
    [sym_unary_operator] = STATE(1530),
    [sym_attribute] = STATE(1530),
    [sym_subscript] = STATE(1530),
    [sym_call] = STATE(1530),
    [sym_list] = STATE(1530),
    [sym_list_comprehension] = STATE(1530),
    [sym_dictionary] = STATE(1530),
    [sym_dictionary_comprehension] = STATE(1530),
    [sym_set] = STATE(1530),
    [sym_set_comprehension] = STATE(1530),
    [sym_parenthesized_expression] = STATE(1530),
    [sym_tuple] = STATE(1530),
    [sym_generator_expression] = STATE(1530),
    [sym_concatenated_string] = STATE(1530),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_PLUS] = ACTIONS(1630),
    [anon_sym_DASH] = ACTIONS(1630),
    [anon_sym_TILDE] = ACTIONS(1630),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(3334),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(1636),
    [sym_integer] = ACTIONS(3336),
    [sym_float] = ACTIONS(3336),
    [sym_identifier] = ACTIONS(3336),
    [sym_true] = ACTIONS(3336),
    [sym_false] = ACTIONS(3336),
    [sym_none] = ACTIONS(3336),
    [sym_comment] = ACTIONS(72),
  },
  [1217] = {
    [sym__primary_expression] = STATE(1531),
    [sym_binary_operator] = STATE(1531),
    [sym_unary_operator] = STATE(1531),
    [sym_attribute] = STATE(1531),
    [sym_subscript] = STATE(1531),
    [sym_call] = STATE(1531),
    [sym_list] = STATE(1531),
    [sym_list_comprehension] = STATE(1531),
    [sym_dictionary] = STATE(1531),
    [sym_dictionary_comprehension] = STATE(1531),
    [sym_set] = STATE(1531),
    [sym_set_comprehension] = STATE(1531),
    [sym_parenthesized_expression] = STATE(1531),
    [sym_tuple] = STATE(1531),
    [sym_generator_expression] = STATE(1531),
    [sym_concatenated_string] = STATE(1531),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_PLUS] = ACTIONS(1630),
    [anon_sym_DASH] = ACTIONS(1630),
    [anon_sym_TILDE] = ACTIONS(1630),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(3338),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(1636),
    [sym_integer] = ACTIONS(3340),
    [sym_float] = ACTIONS(3340),
    [sym_identifier] = ACTIONS(3340),
    [sym_true] = ACTIONS(3340),
    [sym_false] = ACTIONS(3340),
    [sym_none] = ACTIONS(3340),
    [sym_comment] = ACTIONS(72),
  },
  [1218] = {
    [sym__primary_expression] = STATE(1532),
    [sym_binary_operator] = STATE(1532),
    [sym_unary_operator] = STATE(1532),
    [sym_attribute] = STATE(1532),
    [sym_subscript] = STATE(1532),
    [sym_call] = STATE(1532),
    [sym_list] = STATE(1532),
    [sym_list_comprehension] = STATE(1532),
    [sym_dictionary] = STATE(1532),
    [sym_dictionary_comprehension] = STATE(1532),
    [sym_set] = STATE(1532),
    [sym_set_comprehension] = STATE(1532),
    [sym_parenthesized_expression] = STATE(1532),
    [sym_tuple] = STATE(1532),
    [sym_generator_expression] = STATE(1532),
    [sym_concatenated_string] = STATE(1532),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_PLUS] = ACTIONS(1630),
    [anon_sym_DASH] = ACTIONS(1630),
    [anon_sym_TILDE] = ACTIONS(1630),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(3342),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(1636),
    [sym_integer] = ACTIONS(3344),
    [sym_float] = ACTIONS(3344),
    [sym_identifier] = ACTIONS(3344),
    [sym_true] = ACTIONS(3344),
    [sym_false] = ACTIONS(3344),
    [sym_none] = ACTIONS(3344),
    [sym_comment] = ACTIONS(72),
  },
  [1219] = {
    [anon_sym_in] = ACTIONS(3346),
    [sym_comment] = ACTIONS(72),
  },
  [1220] = {
    [sym__primary_expression] = STATE(1534),
    [sym_binary_operator] = STATE(1534),
    [sym_unary_operator] = STATE(1534),
    [sym_attribute] = STATE(1534),
    [sym_subscript] = STATE(1534),
    [sym_call] = STATE(1534),
    [sym_list] = STATE(1534),
    [sym_list_comprehension] = STATE(1534),
    [sym_dictionary] = STATE(1534),
    [sym_dictionary_comprehension] = STATE(1534),
    [sym_set] = STATE(1534),
    [sym_set_comprehension] = STATE(1534),
    [sym_parenthesized_expression] = STATE(1534),
    [sym_tuple] = STATE(1534),
    [sym_generator_expression] = STATE(1534),
    [sym_concatenated_string] = STATE(1534),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_PLUS] = ACTIONS(1630),
    [anon_sym_DASH] = ACTIONS(1630),
    [anon_sym_TILDE] = ACTIONS(1630),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(3348),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(1636),
    [sym_integer] = ACTIONS(3350),
    [sym_float] = ACTIONS(3350),
    [sym_identifier] = ACTIONS(3350),
    [sym_true] = ACTIONS(3350),
    [sym_false] = ACTIONS(3350),
    [sym_none] = ACTIONS(3350),
    [sym_comment] = ACTIONS(72),
  },
  [1221] = {
    [sym__primary_expression] = STATE(621),
    [sym_binary_operator] = STATE(621),
    [sym_unary_operator] = STATE(621),
    [sym_attribute] = STATE(621),
    [sym_subscript] = STATE(621),
    [sym_call] = STATE(621),
    [sym_list] = STATE(621),
    [sym_list_comprehension] = STATE(621),
    [sym_dictionary] = STATE(621),
    [sym_dictionary_comprehension] = STATE(621),
    [sym_set] = STATE(621),
    [sym_set_comprehension] = STATE(621),
    [sym_parenthesized_expression] = STATE(621),
    [sym_tuple] = STATE(621),
    [sym_generator_expression] = STATE(621),
    [sym_concatenated_string] = STATE(621),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_PLUS] = ACTIONS(1630),
    [anon_sym_DASH] = ACTIONS(1630),
    [anon_sym_TILDE] = ACTIONS(1630),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(1233),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(1636),
    [sym_integer] = ACTIONS(1235),
    [sym_float] = ACTIONS(1235),
    [sym_identifier] = ACTIONS(1235),
    [sym_true] = ACTIONS(1235),
    [sym_false] = ACTIONS(1235),
    [sym_none] = ACTIONS(1235),
    [sym_comment] = ACTIONS(72),
  },
  [1222] = {
    [sym__primary_expression] = STATE(1535),
    [sym_binary_operator] = STATE(1535),
    [sym_unary_operator] = STATE(1535),
    [sym_attribute] = STATE(1535),
    [sym_subscript] = STATE(1535),
    [sym_call] = STATE(1535),
    [sym_list] = STATE(1535),
    [sym_list_comprehension] = STATE(1535),
    [sym_dictionary] = STATE(1535),
    [sym_dictionary_comprehension] = STATE(1535),
    [sym_set] = STATE(1535),
    [sym_set_comprehension] = STATE(1535),
    [sym_parenthesized_expression] = STATE(1535),
    [sym_tuple] = STATE(1535),
    [sym_generator_expression] = STATE(1535),
    [sym_concatenated_string] = STATE(1535),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_PLUS] = ACTIONS(1630),
    [anon_sym_DASH] = ACTIONS(1630),
    [anon_sym_TILDE] = ACTIONS(1630),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(3352),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(1636),
    [sym_integer] = ACTIONS(3354),
    [sym_float] = ACTIONS(3354),
    [sym_identifier] = ACTIONS(3354),
    [sym_true] = ACTIONS(3354),
    [sym_false] = ACTIONS(3354),
    [sym_none] = ACTIONS(3354),
    [sym_comment] = ACTIONS(72),
  },
  [1223] = {
    [sym__primary_expression] = STATE(1536),
    [sym_binary_operator] = STATE(1536),
    [sym_unary_operator] = STATE(1536),
    [sym_attribute] = STATE(1536),
    [sym_subscript] = STATE(1536),
    [sym_call] = STATE(1536),
    [sym_list] = STATE(1536),
    [sym_list_comprehension] = STATE(1536),
    [sym_dictionary] = STATE(1536),
    [sym_dictionary_comprehension] = STATE(1536),
    [sym_set] = STATE(1536),
    [sym_set_comprehension] = STATE(1536),
    [sym_parenthesized_expression] = STATE(1536),
    [sym_tuple] = STATE(1536),
    [sym_generator_expression] = STATE(1536),
    [sym_concatenated_string] = STATE(1536),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_PLUS] = ACTIONS(1630),
    [anon_sym_DASH] = ACTIONS(1630),
    [anon_sym_TILDE] = ACTIONS(1630),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(3356),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(1636),
    [sym_integer] = ACTIONS(3358),
    [sym_float] = ACTIONS(3358),
    [sym_identifier] = ACTIONS(3358),
    [sym_true] = ACTIONS(3358),
    [sym_false] = ACTIONS(3358),
    [sym_none] = ACTIONS(3358),
    [sym_comment] = ACTIONS(72),
  },
  [1224] = {
    [sym__primary_expression] = STATE(1537),
    [sym_binary_operator] = STATE(1537),
    [sym_unary_operator] = STATE(1537),
    [sym_attribute] = STATE(1537),
    [sym_subscript] = STATE(1537),
    [sym_call] = STATE(1537),
    [sym_list] = STATE(1537),
    [sym_list_comprehension] = STATE(1537),
    [sym_dictionary] = STATE(1537),
    [sym_dictionary_comprehension] = STATE(1537),
    [sym_set] = STATE(1537),
    [sym_set_comprehension] = STATE(1537),
    [sym_parenthesized_expression] = STATE(1537),
    [sym_tuple] = STATE(1537),
    [sym_generator_expression] = STATE(1537),
    [sym_concatenated_string] = STATE(1537),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_PLUS] = ACTIONS(1630),
    [anon_sym_DASH] = ACTIONS(1630),
    [anon_sym_TILDE] = ACTIONS(1630),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(3360),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(1636),
    [sym_integer] = ACTIONS(3362),
    [sym_float] = ACTIONS(3362),
    [sym_identifier] = ACTIONS(3362),
    [sym_true] = ACTIONS(3362),
    [sym_false] = ACTIONS(3362),
    [sym_none] = ACTIONS(3362),
    [sym_comment] = ACTIONS(72),
  },
  [1225] = {
    [sym__primary_expression] = STATE(1532),
    [sym_binary_operator] = STATE(1532),
    [sym_unary_operator] = STATE(1532),
    [sym_attribute] = STATE(1532),
    [sym_subscript] = STATE(1532),
    [sym_call] = STATE(1532),
    [sym_list] = STATE(1532),
    [sym_list_comprehension] = STATE(1532),
    [sym_dictionary] = STATE(1532),
    [sym_dictionary_comprehension] = STATE(1532),
    [sym_set] = STATE(1532),
    [sym_set_comprehension] = STATE(1532),
    [sym_parenthesized_expression] = STATE(1532),
    [sym_tuple] = STATE(1532),
    [sym_generator_expression] = STATE(1532),
    [sym_concatenated_string] = STATE(1532),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_not] = ACTIONS(3364),
    [anon_sym_PLUS] = ACTIONS(1630),
    [anon_sym_DASH] = ACTIONS(1630),
    [anon_sym_TILDE] = ACTIONS(1630),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(3342),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(1636),
    [sym_integer] = ACTIONS(3344),
    [sym_float] = ACTIONS(3344),
    [sym_identifier] = ACTIONS(3344),
    [sym_true] = ACTIONS(3344),
    [sym_false] = ACTIONS(3344),
    [sym_none] = ACTIONS(3344),
    [sym_comment] = ACTIONS(72),
  },
  [1226] = {
    [aux_sym_comparison_operator_repeat1] = STATE(1538),
    [anon_sym_if] = ACTIONS(998),
    [anon_sym_in] = ACTIONS(2571),
    [anon_sym_EQ] = ACTIONS(1000),
    [anon_sym_not] = ACTIONS(2575),
    [anon_sym_and] = ACTIONS(998),
    [anon_sym_or] = ACTIONS(998),
    [anon_sym_LT] = ACTIONS(2587),
    [anon_sym_LT_EQ] = ACTIONS(2571),
    [anon_sym_EQ_EQ] = ACTIONS(2571),
    [anon_sym_BANG_EQ] = ACTIONS(2571),
    [anon_sym_GT_EQ] = ACTIONS(2571),
    [anon_sym_GT] = ACTIONS(2587),
    [anon_sym_LT_GT] = ACTIONS(2571),
    [anon_sym_is] = ACTIONS(2589),
    [sym_comment] = ACTIONS(72),
  },
  [1227] = {
    [sym__expression] = STATE(1539),
    [sym__primary_expression] = STATE(410),
    [sym_not_operator] = STATE(1539),
    [sym_boolean_operator] = STATE(1539),
    [sym_binary_operator] = STATE(410),
    [sym_unary_operator] = STATE(410),
    [sym_comparison_operator] = STATE(1539),
    [sym_lambda] = STATE(1539),
    [sym_attribute] = STATE(410),
    [sym_subscript] = STATE(410),
    [sym_call] = STATE(410),
    [sym_list] = STATE(410),
    [sym_list_comprehension] = STATE(410),
    [sym_dictionary] = STATE(410),
    [sym_dictionary_comprehension] = STATE(410),
    [sym_set] = STATE(410),
    [sym_set_comprehension] = STATE(410),
    [sym_parenthesized_expression] = STATE(410),
    [sym_tuple] = STATE(410),
    [sym_generator_expression] = STATE(410),
    [sym_conditional_expression] = STATE(1539),
    [sym_concatenated_string] = STATE(410),
    [sym_await] = STATE(1539),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_not] = ACTIONS(726),
    [anon_sym_PLUS] = ACTIONS(728),
    [anon_sym_DASH] = ACTIONS(728),
    [anon_sym_TILDE] = ACTIONS(728),
    [anon_sym_lambda] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(732),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(734),
    [sym_integer] = ACTIONS(736),
    [sym_float] = ACTIONS(736),
    [sym_identifier] = ACTIONS(736),
    [sym_true] = ACTIONS(736),
    [sym_false] = ACTIONS(736),
    [sym_none] = ACTIONS(736),
    [anon_sym_await] = ACTIONS(738),
    [sym_comment] = ACTIONS(72),
  },
  [1228] = {
    [sym_default_parameter] = STATE(822),
    [sym_typed_default_parameter] = STATE(822),
    [sym_list_splat] = STATE(823),
    [sym_dictionary_splat] = STATE(823),
    [sym_typed_parameter] = STATE(822),
    [sym_tuple] = STATE(822),
    [anon_sym_LPAREN] = ACTIONS(222),
    [anon_sym_STAR] = ACTIONS(224),
    [anon_sym_print] = ACTIONS(1622),
    [anon_sym_exec] = ACTIONS(1622),
    [sym_identifier] = ACTIONS(1626),
    [sym_comment] = ACTIONS(72),
  },
  [1229] = {
    [anon_sym_COMMA] = ACTIONS(716),
    [anon_sym_if] = ACTIONS(716),
    [anon_sym_COLON] = ACTIONS(716),
    [anon_sym_EQ] = ACTIONS(716),
    [anon_sym_and] = ACTIONS(2606),
    [anon_sym_or] = ACTIONS(2608),
    [sym_comment] = ACTIONS(72),
  },
  [1230] = {
    [sym__expression] = STATE(1540),
    [sym__primary_expression] = STATE(841),
    [sym_not_operator] = STATE(1540),
    [sym_boolean_operator] = STATE(1540),
    [sym_binary_operator] = STATE(841),
    [sym_unary_operator] = STATE(841),
    [sym_comparison_operator] = STATE(1540),
    [sym_lambda] = STATE(1540),
    [sym_attribute] = STATE(841),
    [sym_subscript] = STATE(841),
    [sym_call] = STATE(841),
    [sym_list] = STATE(841),
    [sym_list_comprehension] = STATE(841),
    [sym_dictionary] = STATE(841),
    [sym_dictionary_comprehension] = STATE(841),
    [sym_set] = STATE(841),
    [sym_set_comprehension] = STATE(841),
    [sym_parenthesized_expression] = STATE(841),
    [sym_tuple] = STATE(841),
    [sym_generator_expression] = STATE(841),
    [sym_conditional_expression] = STATE(1540),
    [sym_concatenated_string] = STATE(841),
    [sym_await] = STATE(1540),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_not] = ACTIONS(1648),
    [anon_sym_PLUS] = ACTIONS(1650),
    [anon_sym_DASH] = ACTIONS(1650),
    [anon_sym_TILDE] = ACTIONS(1650),
    [anon_sym_lambda] = ACTIONS(1652),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(1654),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(1656),
    [sym_integer] = ACTIONS(1658),
    [sym_float] = ACTIONS(1658),
    [sym_identifier] = ACTIONS(1658),
    [sym_true] = ACTIONS(1658),
    [sym_false] = ACTIONS(1658),
    [sym_none] = ACTIONS(1658),
    [anon_sym_await] = ACTIONS(1660),
    [sym_comment] = ACTIONS(72),
  },
  [1231] = {
    [anon_sym_COLON] = ACTIONS(3366),
    [sym_comment] = ACTIONS(72),
  },
  [1232] = {
    [aux_sym_concatenated_string_repeat1] = STATE(1542),
    [anon_sym_DOT] = ACTIONS(886),
    [anon_sym_LPAREN] = ACTIONS(886),
    [anon_sym_COMMA] = ACTIONS(886),
    [anon_sym_STAR] = ACTIONS(888),
    [anon_sym_GT_GT] = ACTIONS(886),
    [anon_sym_if] = ACTIONS(886),
    [anon_sym_COLON] = ACTIONS(886),
    [anon_sym_in] = ACTIONS(886),
    [anon_sym_EQ] = ACTIONS(888),
    [anon_sym_AT] = ACTIONS(886),
    [anon_sym_not] = ACTIONS(886),
    [anon_sym_and] = ACTIONS(886),
    [anon_sym_or] = ACTIONS(886),
    [anon_sym_PLUS] = ACTIONS(886),
    [anon_sym_DASH] = ACTIONS(886),
    [anon_sym_SLASH] = ACTIONS(888),
    [anon_sym_PERCENT] = ACTIONS(886),
    [anon_sym_SLASH_SLASH] = ACTIONS(886),
    [anon_sym_STAR_STAR] = ACTIONS(886),
    [anon_sym_PIPE] = ACTIONS(886),
    [anon_sym_AMP] = ACTIONS(886),
    [anon_sym_CARET] = ACTIONS(886),
    [anon_sym_LT_LT] = ACTIONS(886),
    [anon_sym_LT] = ACTIONS(888),
    [anon_sym_LT_EQ] = ACTIONS(886),
    [anon_sym_EQ_EQ] = ACTIONS(886),
    [anon_sym_BANG_EQ] = ACTIONS(886),
    [anon_sym_GT_EQ] = ACTIONS(886),
    [anon_sym_GT] = ACTIONS(888),
    [anon_sym_LT_GT] = ACTIONS(886),
    [anon_sym_is] = ACTIONS(886),
    [anon_sym_LBRACK] = ACTIONS(886),
    [sym_string] = ACTIONS(3368),
    [sym_comment] = ACTIONS(72),
  },
  [1233] = {
    [sym__expression] = STATE(1543),
    [sym__primary_expression] = STATE(513),
    [sym_not_operator] = STATE(1543),
    [sym_boolean_operator] = STATE(1543),
    [sym_binary_operator] = STATE(513),
    [sym_unary_operator] = STATE(513),
    [sym_comparison_operator] = STATE(1543),
    [sym_lambda] = STATE(1543),
    [sym_attribute] = STATE(513),
    [sym_subscript] = STATE(513),
    [sym_call] = STATE(513),
    [sym_list] = STATE(513),
    [sym_list_comprehension] = STATE(513),
    [sym_dictionary] = STATE(513),
    [sym_dictionary_comprehension] = STATE(513),
    [sym_set] = STATE(513),
    [sym_set_comprehension] = STATE(513),
    [sym_parenthesized_expression] = STATE(513),
    [sym_tuple] = STATE(513),
    [sym_generator_expression] = STATE(513),
    [sym_conditional_expression] = STATE(1543),
    [sym_concatenated_string] = STATE(513),
    [sym_await] = STATE(1543),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_not] = ACTIONS(914),
    [anon_sym_PLUS] = ACTIONS(916),
    [anon_sym_DASH] = ACTIONS(916),
    [anon_sym_TILDE] = ACTIONS(916),
    [anon_sym_lambda] = ACTIONS(918),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(920),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(922),
    [sym_integer] = ACTIONS(924),
    [sym_float] = ACTIONS(924),
    [sym_identifier] = ACTIONS(924),
    [sym_true] = ACTIONS(924),
    [sym_false] = ACTIONS(924),
    [sym_none] = ACTIONS(924),
    [anon_sym_await] = ACTIONS(926),
    [sym_comment] = ACTIONS(72),
  },
  [1234] = {
    [sym__expression] = STATE(604),
    [sym__primary_expression] = STATE(841),
    [sym_not_operator] = STATE(604),
    [sym_boolean_operator] = STATE(604),
    [sym_binary_operator] = STATE(841),
    [sym_unary_operator] = STATE(841),
    [sym_comparison_operator] = STATE(604),
    [sym_lambda] = STATE(604),
    [sym_attribute] = STATE(841),
    [sym_subscript] = STATE(841),
    [sym_call] = STATE(841),
    [sym_list] = STATE(841),
    [sym_list_comprehension] = STATE(841),
    [sym_dictionary] = STATE(841),
    [sym_dictionary_comprehension] = STATE(841),
    [sym_set] = STATE(841),
    [sym_set_comprehension] = STATE(841),
    [sym_parenthesized_expression] = STATE(841),
    [sym_tuple] = STATE(841),
    [sym_generator_expression] = STATE(841),
    [sym_conditional_expression] = STATE(604),
    [sym_concatenated_string] = STATE(841),
    [sym_await] = STATE(604),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_not] = ACTIONS(1648),
    [anon_sym_PLUS] = ACTIONS(1650),
    [anon_sym_DASH] = ACTIONS(1650),
    [anon_sym_TILDE] = ACTIONS(1650),
    [anon_sym_lambda] = ACTIONS(1652),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(1654),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(1656),
    [sym_integer] = ACTIONS(1658),
    [sym_float] = ACTIONS(1658),
    [sym_identifier] = ACTIONS(1658),
    [sym_true] = ACTIONS(1658),
    [sym_false] = ACTIONS(1658),
    [sym_none] = ACTIONS(1658),
    [anon_sym_await] = ACTIONS(1660),
    [sym_comment] = ACTIONS(72),
  },
  [1235] = {
    [sym__expression] = STATE(1544),
    [sym__primary_expression] = STATE(841),
    [sym_not_operator] = STATE(1544),
    [sym_boolean_operator] = STATE(1544),
    [sym_binary_operator] = STATE(841),
    [sym_unary_operator] = STATE(841),
    [sym_comparison_operator] = STATE(1544),
    [sym_lambda] = STATE(1544),
    [sym_attribute] = STATE(841),
    [sym_subscript] = STATE(841),
    [sym_call] = STATE(841),
    [sym_list] = STATE(841),
    [sym_list_comprehension] = STATE(841),
    [sym_dictionary] = STATE(841),
    [sym_dictionary_comprehension] = STATE(841),
    [sym_set] = STATE(841),
    [sym_set_comprehension] = STATE(841),
    [sym_parenthesized_expression] = STATE(841),
    [sym_tuple] = STATE(841),
    [sym_generator_expression] = STATE(841),
    [sym_conditional_expression] = STATE(1544),
    [sym_concatenated_string] = STATE(841),
    [sym_await] = STATE(1544),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_not] = ACTIONS(1648),
    [anon_sym_PLUS] = ACTIONS(1650),
    [anon_sym_DASH] = ACTIONS(1650),
    [anon_sym_TILDE] = ACTIONS(1650),
    [anon_sym_lambda] = ACTIONS(1652),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(1654),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(1656),
    [sym_integer] = ACTIONS(1658),
    [sym_float] = ACTIONS(1658),
    [sym_identifier] = ACTIONS(1658),
    [sym_true] = ACTIONS(1658),
    [sym_false] = ACTIONS(1658),
    [sym_none] = ACTIONS(1658),
    [anon_sym_await] = ACTIONS(1660),
    [sym_comment] = ACTIONS(72),
  },
  [1236] = {
    [sym__primary_expression] = STATE(1545),
    [sym_binary_operator] = STATE(1545),
    [sym_unary_operator] = STATE(1545),
    [sym_attribute] = STATE(1545),
    [sym_subscript] = STATE(1545),
    [sym_call] = STATE(1545),
    [sym_list] = STATE(1545),
    [sym_list_comprehension] = STATE(1545),
    [sym_dictionary] = STATE(1545),
    [sym_dictionary_comprehension] = STATE(1545),
    [sym_set] = STATE(1545),
    [sym_set_comprehension] = STATE(1545),
    [sym_parenthesized_expression] = STATE(1545),
    [sym_tuple] = STATE(1545),
    [sym_generator_expression] = STATE(1545),
    [sym_concatenated_string] = STATE(1545),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_PLUS] = ACTIONS(1650),
    [anon_sym_DASH] = ACTIONS(1650),
    [anon_sym_TILDE] = ACTIONS(1650),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(3370),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(1656),
    [sym_integer] = ACTIONS(3372),
    [sym_float] = ACTIONS(3372),
    [sym_identifier] = ACTIONS(3372),
    [sym_true] = ACTIONS(3372),
    [sym_false] = ACTIONS(3372),
    [sym_none] = ACTIONS(3372),
    [sym_comment] = ACTIONS(72),
  },
  [1237] = {
    [sym__primary_expression] = STATE(1546),
    [sym_binary_operator] = STATE(1546),
    [sym_unary_operator] = STATE(1546),
    [sym_attribute] = STATE(1546),
    [sym_subscript] = STATE(1546),
    [sym_call] = STATE(1546),
    [sym_list] = STATE(1546),
    [sym_list_comprehension] = STATE(1546),
    [sym_dictionary] = STATE(1546),
    [sym_dictionary_comprehension] = STATE(1546),
    [sym_set] = STATE(1546),
    [sym_set_comprehension] = STATE(1546),
    [sym_parenthesized_expression] = STATE(1546),
    [sym_tuple] = STATE(1546),
    [sym_generator_expression] = STATE(1546),
    [sym_concatenated_string] = STATE(1546),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_PLUS] = ACTIONS(1650),
    [anon_sym_DASH] = ACTIONS(1650),
    [anon_sym_TILDE] = ACTIONS(1650),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(3374),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(1656),
    [sym_integer] = ACTIONS(3376),
    [sym_float] = ACTIONS(3376),
    [sym_identifier] = ACTIONS(3376),
    [sym_true] = ACTIONS(3376),
    [sym_false] = ACTIONS(3376),
    [sym_none] = ACTIONS(3376),
    [sym_comment] = ACTIONS(72),
  },
  [1238] = {
    [sym__primary_expression] = STATE(1547),
    [sym_binary_operator] = STATE(1547),
    [sym_unary_operator] = STATE(1547),
    [sym_attribute] = STATE(1547),
    [sym_subscript] = STATE(1547),
    [sym_call] = STATE(1547),
    [sym_list] = STATE(1547),
    [sym_list_comprehension] = STATE(1547),
    [sym_dictionary] = STATE(1547),
    [sym_dictionary_comprehension] = STATE(1547),
    [sym_set] = STATE(1547),
    [sym_set_comprehension] = STATE(1547),
    [sym_parenthesized_expression] = STATE(1547),
    [sym_tuple] = STATE(1547),
    [sym_generator_expression] = STATE(1547),
    [sym_concatenated_string] = STATE(1547),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_PLUS] = ACTIONS(1650),
    [anon_sym_DASH] = ACTIONS(1650),
    [anon_sym_TILDE] = ACTIONS(1650),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(3378),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(1656),
    [sym_integer] = ACTIONS(3380),
    [sym_float] = ACTIONS(3380),
    [sym_identifier] = ACTIONS(3380),
    [sym_true] = ACTIONS(3380),
    [sym_false] = ACTIONS(3380),
    [sym_none] = ACTIONS(3380),
    [sym_comment] = ACTIONS(72),
  },
  [1239] = {
    [anon_sym_in] = ACTIONS(3382),
    [sym_comment] = ACTIONS(72),
  },
  [1240] = {
    [sym__primary_expression] = STATE(1549),
    [sym_binary_operator] = STATE(1549),
    [sym_unary_operator] = STATE(1549),
    [sym_attribute] = STATE(1549),
    [sym_subscript] = STATE(1549),
    [sym_call] = STATE(1549),
    [sym_list] = STATE(1549),
    [sym_list_comprehension] = STATE(1549),
    [sym_dictionary] = STATE(1549),
    [sym_dictionary_comprehension] = STATE(1549),
    [sym_set] = STATE(1549),
    [sym_set_comprehension] = STATE(1549),
    [sym_parenthesized_expression] = STATE(1549),
    [sym_tuple] = STATE(1549),
    [sym_generator_expression] = STATE(1549),
    [sym_concatenated_string] = STATE(1549),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_PLUS] = ACTIONS(1650),
    [anon_sym_DASH] = ACTIONS(1650),
    [anon_sym_TILDE] = ACTIONS(1650),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(3384),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(1656),
    [sym_integer] = ACTIONS(3386),
    [sym_float] = ACTIONS(3386),
    [sym_identifier] = ACTIONS(3386),
    [sym_true] = ACTIONS(3386),
    [sym_false] = ACTIONS(3386),
    [sym_none] = ACTIONS(3386),
    [sym_comment] = ACTIONS(72),
  },
  [1241] = {
    [sym__primary_expression] = STATE(621),
    [sym_binary_operator] = STATE(621),
    [sym_unary_operator] = STATE(621),
    [sym_attribute] = STATE(621),
    [sym_subscript] = STATE(621),
    [sym_call] = STATE(621),
    [sym_list] = STATE(621),
    [sym_list_comprehension] = STATE(621),
    [sym_dictionary] = STATE(621),
    [sym_dictionary_comprehension] = STATE(621),
    [sym_set] = STATE(621),
    [sym_set_comprehension] = STATE(621),
    [sym_parenthesized_expression] = STATE(621),
    [sym_tuple] = STATE(621),
    [sym_generator_expression] = STATE(621),
    [sym_concatenated_string] = STATE(621),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_PLUS] = ACTIONS(1650),
    [anon_sym_DASH] = ACTIONS(1650),
    [anon_sym_TILDE] = ACTIONS(1650),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(1233),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(1656),
    [sym_integer] = ACTIONS(1235),
    [sym_float] = ACTIONS(1235),
    [sym_identifier] = ACTIONS(1235),
    [sym_true] = ACTIONS(1235),
    [sym_false] = ACTIONS(1235),
    [sym_none] = ACTIONS(1235),
    [sym_comment] = ACTIONS(72),
  },
  [1242] = {
    [sym__primary_expression] = STATE(1550),
    [sym_binary_operator] = STATE(1550),
    [sym_unary_operator] = STATE(1550),
    [sym_attribute] = STATE(1550),
    [sym_subscript] = STATE(1550),
    [sym_call] = STATE(1550),
    [sym_list] = STATE(1550),
    [sym_list_comprehension] = STATE(1550),
    [sym_dictionary] = STATE(1550),
    [sym_dictionary_comprehension] = STATE(1550),
    [sym_set] = STATE(1550),
    [sym_set_comprehension] = STATE(1550),
    [sym_parenthesized_expression] = STATE(1550),
    [sym_tuple] = STATE(1550),
    [sym_generator_expression] = STATE(1550),
    [sym_concatenated_string] = STATE(1550),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_PLUS] = ACTIONS(1650),
    [anon_sym_DASH] = ACTIONS(1650),
    [anon_sym_TILDE] = ACTIONS(1650),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(3388),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(1656),
    [sym_integer] = ACTIONS(3390),
    [sym_float] = ACTIONS(3390),
    [sym_identifier] = ACTIONS(3390),
    [sym_true] = ACTIONS(3390),
    [sym_false] = ACTIONS(3390),
    [sym_none] = ACTIONS(3390),
    [sym_comment] = ACTIONS(72),
  },
  [1243] = {
    [sym__primary_expression] = STATE(1551),
    [sym_binary_operator] = STATE(1551),
    [sym_unary_operator] = STATE(1551),
    [sym_attribute] = STATE(1551),
    [sym_subscript] = STATE(1551),
    [sym_call] = STATE(1551),
    [sym_list] = STATE(1551),
    [sym_list_comprehension] = STATE(1551),
    [sym_dictionary] = STATE(1551),
    [sym_dictionary_comprehension] = STATE(1551),
    [sym_set] = STATE(1551),
    [sym_set_comprehension] = STATE(1551),
    [sym_parenthesized_expression] = STATE(1551),
    [sym_tuple] = STATE(1551),
    [sym_generator_expression] = STATE(1551),
    [sym_concatenated_string] = STATE(1551),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_PLUS] = ACTIONS(1650),
    [anon_sym_DASH] = ACTIONS(1650),
    [anon_sym_TILDE] = ACTIONS(1650),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(3392),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(1656),
    [sym_integer] = ACTIONS(3394),
    [sym_float] = ACTIONS(3394),
    [sym_identifier] = ACTIONS(3394),
    [sym_true] = ACTIONS(3394),
    [sym_false] = ACTIONS(3394),
    [sym_none] = ACTIONS(3394),
    [sym_comment] = ACTIONS(72),
  },
  [1244] = {
    [sym__primary_expression] = STATE(1552),
    [sym_binary_operator] = STATE(1552),
    [sym_unary_operator] = STATE(1552),
    [sym_attribute] = STATE(1552),
    [sym_subscript] = STATE(1552),
    [sym_call] = STATE(1552),
    [sym_list] = STATE(1552),
    [sym_list_comprehension] = STATE(1552),
    [sym_dictionary] = STATE(1552),
    [sym_dictionary_comprehension] = STATE(1552),
    [sym_set] = STATE(1552),
    [sym_set_comprehension] = STATE(1552),
    [sym_parenthesized_expression] = STATE(1552),
    [sym_tuple] = STATE(1552),
    [sym_generator_expression] = STATE(1552),
    [sym_concatenated_string] = STATE(1552),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_PLUS] = ACTIONS(1650),
    [anon_sym_DASH] = ACTIONS(1650),
    [anon_sym_TILDE] = ACTIONS(1650),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(3396),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(1656),
    [sym_integer] = ACTIONS(3398),
    [sym_float] = ACTIONS(3398),
    [sym_identifier] = ACTIONS(3398),
    [sym_true] = ACTIONS(3398),
    [sym_false] = ACTIONS(3398),
    [sym_none] = ACTIONS(3398),
    [sym_comment] = ACTIONS(72),
  },
  [1245] = {
    [sym__primary_expression] = STATE(1547),
    [sym_binary_operator] = STATE(1547),
    [sym_unary_operator] = STATE(1547),
    [sym_attribute] = STATE(1547),
    [sym_subscript] = STATE(1547),
    [sym_call] = STATE(1547),
    [sym_list] = STATE(1547),
    [sym_list_comprehension] = STATE(1547),
    [sym_dictionary] = STATE(1547),
    [sym_dictionary_comprehension] = STATE(1547),
    [sym_set] = STATE(1547),
    [sym_set_comprehension] = STATE(1547),
    [sym_parenthesized_expression] = STATE(1547),
    [sym_tuple] = STATE(1547),
    [sym_generator_expression] = STATE(1547),
    [sym_concatenated_string] = STATE(1547),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_not] = ACTIONS(3400),
    [anon_sym_PLUS] = ACTIONS(1650),
    [anon_sym_DASH] = ACTIONS(1650),
    [anon_sym_TILDE] = ACTIONS(1650),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(3378),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(1656),
    [sym_integer] = ACTIONS(3380),
    [sym_float] = ACTIONS(3380),
    [sym_identifier] = ACTIONS(3380),
    [sym_true] = ACTIONS(3380),
    [sym_false] = ACTIONS(3380),
    [sym_none] = ACTIONS(3380),
    [sym_comment] = ACTIONS(72),
  },
  [1246] = {
    [aux_sym_comparison_operator_repeat1] = STATE(1553),
    [anon_sym_COMMA] = ACTIONS(998),
    [anon_sym_if] = ACTIONS(998),
    [anon_sym_COLON] = ACTIONS(998),
    [anon_sym_in] = ACTIONS(2614),
    [anon_sym_EQ] = ACTIONS(1000),
    [anon_sym_not] = ACTIONS(2618),
    [anon_sym_and] = ACTIONS(998),
    [anon_sym_or] = ACTIONS(998),
    [anon_sym_LT] = ACTIONS(2630),
    [anon_sym_LT_EQ] = ACTIONS(2614),
    [anon_sym_EQ_EQ] = ACTIONS(2614),
    [anon_sym_BANG_EQ] = ACTIONS(2614),
    [anon_sym_GT_EQ] = ACTIONS(2614),
    [anon_sym_GT] = ACTIONS(2630),
    [anon_sym_LT_GT] = ACTIONS(2614),
    [anon_sym_is] = ACTIONS(2632),
    [sym_comment] = ACTIONS(72),
  },
  [1247] = {
    [sym__expression] = STATE(1554),
    [sym__primary_expression] = STATE(410),
    [sym_not_operator] = STATE(1554),
    [sym_boolean_operator] = STATE(1554),
    [sym_binary_operator] = STATE(410),
    [sym_unary_operator] = STATE(410),
    [sym_comparison_operator] = STATE(1554),
    [sym_lambda] = STATE(1554),
    [sym_attribute] = STATE(410),
    [sym_subscript] = STATE(410),
    [sym_call] = STATE(410),
    [sym_list] = STATE(410),
    [sym_list_comprehension] = STATE(410),
    [sym_dictionary] = STATE(410),
    [sym_dictionary_comprehension] = STATE(410),
    [sym_set] = STATE(410),
    [sym_set_comprehension] = STATE(410),
    [sym_parenthesized_expression] = STATE(410),
    [sym_tuple] = STATE(410),
    [sym_generator_expression] = STATE(410),
    [sym_conditional_expression] = STATE(1554),
    [sym_concatenated_string] = STATE(410),
    [sym_await] = STATE(1554),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_not] = ACTIONS(726),
    [anon_sym_PLUS] = ACTIONS(728),
    [anon_sym_DASH] = ACTIONS(728),
    [anon_sym_TILDE] = ACTIONS(728),
    [anon_sym_lambda] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(732),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(734),
    [sym_integer] = ACTIONS(736),
    [sym_float] = ACTIONS(736),
    [sym_identifier] = ACTIONS(736),
    [sym_true] = ACTIONS(736),
    [sym_false] = ACTIONS(736),
    [sym_none] = ACTIONS(736),
    [anon_sym_await] = ACTIONS(738),
    [sym_comment] = ACTIONS(72),
  },
  [1248] = {
    [anon_sym_COMMA] = ACTIONS(1644),
    [anon_sym_if] = ACTIONS(1674),
    [anon_sym_and] = ACTIONS(1676),
    [anon_sym_or] = ACTIONS(1678),
    [anon_sym_RBRACK] = ACTIONS(1644),
    [sym_comment] = ACTIONS(72),
  },
  [1249] = {
    [sym__expression] = STATE(1555),
    [sym__primary_expression] = STATE(430),
    [sym_not_operator] = STATE(1555),
    [sym_boolean_operator] = STATE(1555),
    [sym_binary_operator] = STATE(430),
    [sym_unary_operator] = STATE(430),
    [sym_comparison_operator] = STATE(1555),
    [sym_lambda] = STATE(1555),
    [sym_attribute] = STATE(430),
    [sym_subscript] = STATE(430),
    [sym_call] = STATE(430),
    [sym_list] = STATE(430),
    [sym_list_comprehension] = STATE(430),
    [sym_dictionary] = STATE(430),
    [sym_dictionary_comprehension] = STATE(430),
    [sym_set] = STATE(430),
    [sym_set_comprehension] = STATE(430),
    [sym_parenthesized_expression] = STATE(430),
    [sym_tuple] = STATE(430),
    [sym_generator_expression] = STATE(430),
    [sym_conditional_expression] = STATE(1555),
    [sym_concatenated_string] = STATE(430),
    [sym_await] = STATE(1555),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_not] = ACTIONS(760),
    [anon_sym_PLUS] = ACTIONS(762),
    [anon_sym_DASH] = ACTIONS(762),
    [anon_sym_TILDE] = ACTIONS(762),
    [anon_sym_lambda] = ACTIONS(764),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(766),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(768),
    [sym_integer] = ACTIONS(770),
    [sym_float] = ACTIONS(770),
    [sym_identifier] = ACTIONS(770),
    [sym_true] = ACTIONS(770),
    [sym_false] = ACTIONS(770),
    [sym_none] = ACTIONS(770),
    [anon_sym_await] = ACTIONS(772),
    [sym_comment] = ACTIONS(72),
  },
  [1250] = {
    [aux_sym_concatenated_string_repeat1] = STATE(1250),
    [anon_sym_DOT] = ACTIONS(1862),
    [anon_sym_LPAREN] = ACTIONS(1862),
    [anon_sym_COMMA] = ACTIONS(1862),
    [anon_sym_STAR] = ACTIONS(1864),
    [anon_sym_GT_GT] = ACTIONS(1862),
    [anon_sym_if] = ACTIONS(1862),
    [anon_sym_in] = ACTIONS(1862),
    [anon_sym_AT] = ACTIONS(1862),
    [anon_sym_not] = ACTIONS(1862),
    [anon_sym_and] = ACTIONS(1862),
    [anon_sym_or] = ACTIONS(1862),
    [anon_sym_PLUS] = ACTIONS(1862),
    [anon_sym_DASH] = ACTIONS(1862),
    [anon_sym_SLASH] = ACTIONS(1864),
    [anon_sym_PERCENT] = ACTIONS(1862),
    [anon_sym_SLASH_SLASH] = ACTIONS(1862),
    [anon_sym_STAR_STAR] = ACTIONS(1862),
    [anon_sym_PIPE] = ACTIONS(1862),
    [anon_sym_AMP] = ACTIONS(1862),
    [anon_sym_CARET] = ACTIONS(1862),
    [anon_sym_LT_LT] = ACTIONS(1862),
    [anon_sym_LT] = ACTIONS(1864),
    [anon_sym_LT_EQ] = ACTIONS(1862),
    [anon_sym_EQ_EQ] = ACTIONS(1862),
    [anon_sym_BANG_EQ] = ACTIONS(1862),
    [anon_sym_GT_EQ] = ACTIONS(1862),
    [anon_sym_GT] = ACTIONS(1864),
    [anon_sym_LT_GT] = ACTIONS(1862),
    [anon_sym_is] = ACTIONS(1862),
    [anon_sym_LBRACK] = ACTIONS(1862),
    [anon_sym_RBRACK] = ACTIONS(1862),
    [sym_string] = ACTIONS(3402),
    [sym_comment] = ACTIONS(72),
  },
  [1251] = {
    [anon_sym_if] = ACTIONS(1921),
    [anon_sym_else] = ACTIONS(3405),
    [anon_sym_and] = ACTIONS(1925),
    [anon_sym_or] = ACTIONS(1927),
    [sym_comment] = ACTIONS(72),
  },
  [1252] = {
    [anon_sym_COMMA] = ACTIONS(1953),
    [anon_sym_if] = ACTIONS(1953),
    [anon_sym_and] = ACTIONS(1676),
    [anon_sym_or] = ACTIONS(1953),
    [anon_sym_RBRACK] = ACTIONS(1953),
    [sym_comment] = ACTIONS(72),
  },
  [1253] = {
    [sym_argument_list] = STATE(251),
    [sym_generator_expression] = STATE(251),
    [anon_sym_DOT] = ACTIONS(1980),
    [anon_sym_LPAREN] = ACTIONS(424),
    [anon_sym_COMMA] = ACTIONS(1980),
    [anon_sym_STAR] = ACTIONS(1982),
    [anon_sym_GT_GT] = ACTIONS(1980),
    [anon_sym_if] = ACTIONS(1980),
    [anon_sym_in] = ACTIONS(1980),
    [anon_sym_AT] = ACTIONS(1980),
    [anon_sym_not] = ACTIONS(1980),
    [anon_sym_and] = ACTIONS(1980),
    [anon_sym_or] = ACTIONS(1980),
    [anon_sym_PLUS] = ACTIONS(1980),
    [anon_sym_DASH] = ACTIONS(1980),
    [anon_sym_SLASH] = ACTIONS(1982),
    [anon_sym_PERCENT] = ACTIONS(1980),
    [anon_sym_SLASH_SLASH] = ACTIONS(1980),
    [anon_sym_STAR_STAR] = ACTIONS(1692),
    [anon_sym_PIPE] = ACTIONS(1980),
    [anon_sym_AMP] = ACTIONS(1980),
    [anon_sym_CARET] = ACTIONS(1980),
    [anon_sym_LT_LT] = ACTIONS(1980),
    [anon_sym_LT] = ACTIONS(1982),
    [anon_sym_LT_EQ] = ACTIONS(1980),
    [anon_sym_EQ_EQ] = ACTIONS(1980),
    [anon_sym_BANG_EQ] = ACTIONS(1980),
    [anon_sym_GT_EQ] = ACTIONS(1980),
    [anon_sym_GT] = ACTIONS(1982),
    [anon_sym_LT_GT] = ACTIONS(1980),
    [anon_sym_is] = ACTIONS(1980),
    [anon_sym_LBRACK] = ACTIONS(1980),
    [anon_sym_RBRACK] = ACTIONS(1980),
    [sym_comment] = ACTIONS(72),
  },
  [1254] = {
    [sym_argument_list] = STATE(251),
    [sym_generator_expression] = STATE(251),
    [anon_sym_DOT] = ACTIONS(1980),
    [anon_sym_LPAREN] = ACTIONS(424),
    [anon_sym_COMMA] = ACTIONS(1980),
    [anon_sym_STAR] = ACTIONS(1680),
    [anon_sym_GT_GT] = ACTIONS(1980),
    [anon_sym_if] = ACTIONS(1980),
    [anon_sym_in] = ACTIONS(1980),
    [anon_sym_AT] = ACTIONS(1686),
    [anon_sym_not] = ACTIONS(1980),
    [anon_sym_and] = ACTIONS(1980),
    [anon_sym_or] = ACTIONS(1980),
    [anon_sym_PLUS] = ACTIONS(1690),
    [anon_sym_DASH] = ACTIONS(1690),
    [anon_sym_SLASH] = ACTIONS(1680),
    [anon_sym_PERCENT] = ACTIONS(1686),
    [anon_sym_SLASH_SLASH] = ACTIONS(1686),
    [anon_sym_STAR_STAR] = ACTIONS(1692),
    [anon_sym_PIPE] = ACTIONS(1980),
    [anon_sym_AMP] = ACTIONS(1980),
    [anon_sym_CARET] = ACTIONS(1980),
    [anon_sym_LT_LT] = ACTIONS(1980),
    [anon_sym_LT] = ACTIONS(1982),
    [anon_sym_LT_EQ] = ACTIONS(1980),
    [anon_sym_EQ_EQ] = ACTIONS(1980),
    [anon_sym_BANG_EQ] = ACTIONS(1980),
    [anon_sym_GT_EQ] = ACTIONS(1980),
    [anon_sym_GT] = ACTIONS(1982),
    [anon_sym_LT_GT] = ACTIONS(1980),
    [anon_sym_is] = ACTIONS(1980),
    [anon_sym_LBRACK] = ACTIONS(1980),
    [anon_sym_RBRACK] = ACTIONS(1980),
    [sym_comment] = ACTIONS(72),
  },
  [1255] = {
    [sym_argument_list] = STATE(251),
    [sym_generator_expression] = STATE(251),
    [anon_sym_DOT] = ACTIONS(422),
    [anon_sym_LPAREN] = ACTIONS(424),
    [anon_sym_COMMA] = ACTIONS(1984),
    [anon_sym_STAR] = ACTIONS(1680),
    [anon_sym_GT_GT] = ACTIONS(1682),
    [anon_sym_if] = ACTIONS(1984),
    [anon_sym_in] = ACTIONS(1984),
    [anon_sym_AT] = ACTIONS(1686),
    [anon_sym_not] = ACTIONS(1984),
    [anon_sym_and] = ACTIONS(1984),
    [anon_sym_or] = ACTIONS(1984),
    [anon_sym_PLUS] = ACTIONS(1690),
    [anon_sym_DASH] = ACTIONS(1690),
    [anon_sym_SLASH] = ACTIONS(1680),
    [anon_sym_PERCENT] = ACTIONS(1686),
    [anon_sym_SLASH_SLASH] = ACTIONS(1686),
    [anon_sym_STAR_STAR] = ACTIONS(1692),
    [anon_sym_PIPE] = ACTIONS(1694),
    [anon_sym_AMP] = ACTIONS(1696),
    [anon_sym_CARET] = ACTIONS(1698),
    [anon_sym_LT_LT] = ACTIONS(1682),
    [anon_sym_LT] = ACTIONS(1986),
    [anon_sym_LT_EQ] = ACTIONS(1984),
    [anon_sym_EQ_EQ] = ACTIONS(1984),
    [anon_sym_BANG_EQ] = ACTIONS(1984),
    [anon_sym_GT_EQ] = ACTIONS(1984),
    [anon_sym_GT] = ACTIONS(1986),
    [anon_sym_LT_GT] = ACTIONS(1984),
    [anon_sym_is] = ACTIONS(1984),
    [anon_sym_LBRACK] = ACTIONS(450),
    [anon_sym_RBRACK] = ACTIONS(1984),
    [sym_comment] = ACTIONS(72),
  },
  [1256] = {
    [sym__primary_expression] = STATE(1557),
    [sym_binary_operator] = STATE(1557),
    [sym_unary_operator] = STATE(1557),
    [sym_attribute] = STATE(1557),
    [sym_subscript] = STATE(1557),
    [sym_call] = STATE(1557),
    [sym_list] = STATE(1557),
    [sym_list_comprehension] = STATE(1557),
    [sym_dictionary] = STATE(1557),
    [sym_dictionary_comprehension] = STATE(1557),
    [sym_set] = STATE(1557),
    [sym_set_comprehension] = STATE(1557),
    [sym_parenthesized_expression] = STATE(1557),
    [sym_tuple] = STATE(1557),
    [sym_generator_expression] = STATE(1557),
    [sym_concatenated_string] = STATE(1557),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_PLUS] = ACTIONS(762),
    [anon_sym_DASH] = ACTIONS(762),
    [anon_sym_TILDE] = ACTIONS(762),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(3407),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(768),
    [sym_integer] = ACTIONS(3409),
    [sym_float] = ACTIONS(3409),
    [sym_identifier] = ACTIONS(3409),
    [sym_true] = ACTIONS(3409),
    [sym_false] = ACTIONS(3409),
    [sym_none] = ACTIONS(3409),
    [sym_comment] = ACTIONS(72),
  },
  [1257] = {
    [sym_argument_list] = STATE(251),
    [sym_generator_expression] = STATE(251),
    [anon_sym_DOT] = ACTIONS(1980),
    [anon_sym_LPAREN] = ACTIONS(424),
    [anon_sym_COMMA] = ACTIONS(1980),
    [anon_sym_STAR] = ACTIONS(1680),
    [anon_sym_GT_GT] = ACTIONS(1980),
    [anon_sym_if] = ACTIONS(1980),
    [anon_sym_in] = ACTIONS(1980),
    [anon_sym_AT] = ACTIONS(1686),
    [anon_sym_not] = ACTIONS(1980),
    [anon_sym_and] = ACTIONS(1980),
    [anon_sym_or] = ACTIONS(1980),
    [anon_sym_PLUS] = ACTIONS(1980),
    [anon_sym_DASH] = ACTIONS(1980),
    [anon_sym_SLASH] = ACTIONS(1680),
    [anon_sym_PERCENT] = ACTIONS(1686),
    [anon_sym_SLASH_SLASH] = ACTIONS(1686),
    [anon_sym_STAR_STAR] = ACTIONS(1692),
    [anon_sym_PIPE] = ACTIONS(1980),
    [anon_sym_AMP] = ACTIONS(1980),
    [anon_sym_CARET] = ACTIONS(1980),
    [anon_sym_LT_LT] = ACTIONS(1980),
    [anon_sym_LT] = ACTIONS(1982),
    [anon_sym_LT_EQ] = ACTIONS(1980),
    [anon_sym_EQ_EQ] = ACTIONS(1980),
    [anon_sym_BANG_EQ] = ACTIONS(1980),
    [anon_sym_GT_EQ] = ACTIONS(1980),
    [anon_sym_GT] = ACTIONS(1982),
    [anon_sym_LT_GT] = ACTIONS(1980),
    [anon_sym_is] = ACTIONS(1980),
    [anon_sym_LBRACK] = ACTIONS(1980),
    [anon_sym_RBRACK] = ACTIONS(1980),
    [sym_comment] = ACTIONS(72),
  },
  [1258] = {
    [sym_argument_list] = STATE(251),
    [sym_generator_expression] = STATE(251),
    [anon_sym_DOT] = ACTIONS(1980),
    [anon_sym_LPAREN] = ACTIONS(424),
    [anon_sym_COMMA] = ACTIONS(1980),
    [anon_sym_STAR] = ACTIONS(1680),
    [anon_sym_GT_GT] = ACTIONS(1682),
    [anon_sym_if] = ACTIONS(1980),
    [anon_sym_in] = ACTIONS(1980),
    [anon_sym_AT] = ACTIONS(1686),
    [anon_sym_not] = ACTIONS(1980),
    [anon_sym_and] = ACTIONS(1980),
    [anon_sym_or] = ACTIONS(1980),
    [anon_sym_PLUS] = ACTIONS(1690),
    [anon_sym_DASH] = ACTIONS(1690),
    [anon_sym_SLASH] = ACTIONS(1680),
    [anon_sym_PERCENT] = ACTIONS(1686),
    [anon_sym_SLASH_SLASH] = ACTIONS(1686),
    [anon_sym_STAR_STAR] = ACTIONS(1692),
    [anon_sym_PIPE] = ACTIONS(1980),
    [anon_sym_AMP] = ACTIONS(1696),
    [anon_sym_CARET] = ACTIONS(1698),
    [anon_sym_LT_LT] = ACTIONS(1682),
    [anon_sym_LT] = ACTIONS(1982),
    [anon_sym_LT_EQ] = ACTIONS(1980),
    [anon_sym_EQ_EQ] = ACTIONS(1980),
    [anon_sym_BANG_EQ] = ACTIONS(1980),
    [anon_sym_GT_EQ] = ACTIONS(1980),
    [anon_sym_GT] = ACTIONS(1982),
    [anon_sym_LT_GT] = ACTIONS(1980),
    [anon_sym_is] = ACTIONS(1980),
    [anon_sym_LBRACK] = ACTIONS(1980),
    [anon_sym_RBRACK] = ACTIONS(1980),
    [sym_comment] = ACTIONS(72),
  },
  [1259] = {
    [sym_argument_list] = STATE(251),
    [sym_generator_expression] = STATE(251),
    [anon_sym_DOT] = ACTIONS(1980),
    [anon_sym_LPAREN] = ACTIONS(424),
    [anon_sym_COMMA] = ACTIONS(1980),
    [anon_sym_STAR] = ACTIONS(1680),
    [anon_sym_GT_GT] = ACTIONS(1682),
    [anon_sym_if] = ACTIONS(1980),
    [anon_sym_in] = ACTIONS(1980),
    [anon_sym_AT] = ACTIONS(1686),
    [anon_sym_not] = ACTIONS(1980),
    [anon_sym_and] = ACTIONS(1980),
    [anon_sym_or] = ACTIONS(1980),
    [anon_sym_PLUS] = ACTIONS(1690),
    [anon_sym_DASH] = ACTIONS(1690),
    [anon_sym_SLASH] = ACTIONS(1680),
    [anon_sym_PERCENT] = ACTIONS(1686),
    [anon_sym_SLASH_SLASH] = ACTIONS(1686),
    [anon_sym_STAR_STAR] = ACTIONS(1692),
    [anon_sym_PIPE] = ACTIONS(1980),
    [anon_sym_AMP] = ACTIONS(1980),
    [anon_sym_CARET] = ACTIONS(1698),
    [anon_sym_LT_LT] = ACTIONS(1682),
    [anon_sym_LT] = ACTIONS(1982),
    [anon_sym_LT_EQ] = ACTIONS(1980),
    [anon_sym_EQ_EQ] = ACTIONS(1980),
    [anon_sym_BANG_EQ] = ACTIONS(1980),
    [anon_sym_GT_EQ] = ACTIONS(1980),
    [anon_sym_GT] = ACTIONS(1982),
    [anon_sym_LT_GT] = ACTIONS(1980),
    [anon_sym_is] = ACTIONS(1980),
    [anon_sym_LBRACK] = ACTIONS(1980),
    [anon_sym_RBRACK] = ACTIONS(1980),
    [sym_comment] = ACTIONS(72),
  },
  [1260] = {
    [sym_argument_list] = STATE(251),
    [sym_generator_expression] = STATE(251),
    [anon_sym_DOT] = ACTIONS(1980),
    [anon_sym_LPAREN] = ACTIONS(424),
    [anon_sym_COMMA] = ACTIONS(1980),
    [anon_sym_STAR] = ACTIONS(1680),
    [anon_sym_GT_GT] = ACTIONS(1682),
    [anon_sym_if] = ACTIONS(1980),
    [anon_sym_in] = ACTIONS(1980),
    [anon_sym_AT] = ACTIONS(1686),
    [anon_sym_not] = ACTIONS(1980),
    [anon_sym_and] = ACTIONS(1980),
    [anon_sym_or] = ACTIONS(1980),
    [anon_sym_PLUS] = ACTIONS(1690),
    [anon_sym_DASH] = ACTIONS(1690),
    [anon_sym_SLASH] = ACTIONS(1680),
    [anon_sym_PERCENT] = ACTIONS(1686),
    [anon_sym_SLASH_SLASH] = ACTIONS(1686),
    [anon_sym_STAR_STAR] = ACTIONS(1692),
    [anon_sym_PIPE] = ACTIONS(1980),
    [anon_sym_AMP] = ACTIONS(1980),
    [anon_sym_CARET] = ACTIONS(1980),
    [anon_sym_LT_LT] = ACTIONS(1682),
    [anon_sym_LT] = ACTIONS(1982),
    [anon_sym_LT_EQ] = ACTIONS(1980),
    [anon_sym_EQ_EQ] = ACTIONS(1980),
    [anon_sym_BANG_EQ] = ACTIONS(1980),
    [anon_sym_GT_EQ] = ACTIONS(1980),
    [anon_sym_GT] = ACTIONS(1982),
    [anon_sym_LT_GT] = ACTIONS(1980),
    [anon_sym_is] = ACTIONS(1980),
    [anon_sym_LBRACK] = ACTIONS(1980),
    [anon_sym_RBRACK] = ACTIONS(1980),
    [sym_comment] = ACTIONS(72),
  },
  [1261] = {
    [aux_sym_comparison_operator_repeat1] = STATE(1261),
    [anon_sym_COMMA] = ACTIONS(1984),
    [anon_sym_if] = ACTIONS(1984),
    [anon_sym_in] = ACTIONS(3411),
    [anon_sym_not] = ACTIONS(3414),
    [anon_sym_and] = ACTIONS(1984),
    [anon_sym_or] = ACTIONS(1984),
    [anon_sym_LT] = ACTIONS(3417),
    [anon_sym_LT_EQ] = ACTIONS(3411),
    [anon_sym_EQ_EQ] = ACTIONS(3411),
    [anon_sym_BANG_EQ] = ACTIONS(3411),
    [anon_sym_GT_EQ] = ACTIONS(3411),
    [anon_sym_GT] = ACTIONS(3417),
    [anon_sym_LT_GT] = ACTIONS(3411),
    [anon_sym_is] = ACTIONS(3420),
    [anon_sym_RBRACK] = ACTIONS(1984),
    [sym_comment] = ACTIONS(72),
  },
  [1262] = {
    [anon_sym_COMMA] = ACTIONS(2642),
    [anon_sym_if] = ACTIONS(784),
    [anon_sym_async] = ACTIONS(2642),
    [anon_sym_for] = ACTIONS(2642),
    [anon_sym_and] = ACTIONS(790),
    [anon_sym_or] = ACTIONS(792),
    [anon_sym_RBRACK] = ACTIONS(2642),
    [sym_comment] = ACTIONS(72),
  },
  [1263] = {
    [sym__newline] = ACTIONS(3423),
    [anon_sym_DOT] = ACTIONS(3423),
    [anon_sym_LPAREN] = ACTIONS(3423),
    [anon_sym_COMMA] = ACTIONS(3423),
    [anon_sym_STAR] = ACTIONS(3425),
    [anon_sym_GT_GT] = ACTIONS(3425),
    [anon_sym_if] = ACTIONS(3423),
    [anon_sym_COLON] = ACTIONS(3423),
    [anon_sym_in] = ACTIONS(3423),
    [anon_sym_EQ] = ACTIONS(3425),
    [anon_sym_AT] = ACTIONS(3425),
    [anon_sym_not] = ACTIONS(3423),
    [anon_sym_and] = ACTIONS(3423),
    [anon_sym_or] = ACTIONS(3423),
    [anon_sym_PLUS] = ACTIONS(3425),
    [anon_sym_DASH] = ACTIONS(3425),
    [anon_sym_SLASH] = ACTIONS(3425),
    [anon_sym_PERCENT] = ACTIONS(3425),
    [anon_sym_SLASH_SLASH] = ACTIONS(3425),
    [anon_sym_STAR_STAR] = ACTIONS(3425),
    [anon_sym_PIPE] = ACTIONS(3425),
    [anon_sym_AMP] = ACTIONS(3425),
    [anon_sym_CARET] = ACTIONS(3425),
    [anon_sym_LT_LT] = ACTIONS(3425),
    [anon_sym_LT] = ACTIONS(3425),
    [anon_sym_LT_EQ] = ACTIONS(3423),
    [anon_sym_EQ_EQ] = ACTIONS(3423),
    [anon_sym_BANG_EQ] = ACTIONS(3423),
    [anon_sym_GT_EQ] = ACTIONS(3423),
    [anon_sym_GT] = ACTIONS(3425),
    [anon_sym_LT_GT] = ACTIONS(3423),
    [anon_sym_is] = ACTIONS(3423),
    [anon_sym_PLUS_EQ] = ACTIONS(3423),
    [anon_sym_DASH_EQ] = ACTIONS(3423),
    [anon_sym_STAR_EQ] = ACTIONS(3423),
    [anon_sym_SLASH_EQ] = ACTIONS(3423),
    [anon_sym_AT_EQ] = ACTIONS(3423),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3423),
    [anon_sym_PERCENT_EQ] = ACTIONS(3423),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3423),
    [anon_sym_GT_GT_EQ] = ACTIONS(3423),
    [anon_sym_LT_LT_EQ] = ACTIONS(3423),
    [anon_sym_AMP_EQ] = ACTIONS(3423),
    [anon_sym_CARET_EQ] = ACTIONS(3423),
    [anon_sym_PIPE_EQ] = ACTIONS(3423),
    [anon_sym_LBRACK] = ACTIONS(3423),
    [sym_comment] = ACTIONS(72),
    [sym__semicolon] = ACTIONS(3423),
  },
  [1264] = {
    [sym_list_splat] = STATE(870),
    [sym__expression] = STATE(871),
    [sym__primary_expression] = STATE(430),
    [sym_not_operator] = STATE(871),
    [sym_boolean_operator] = STATE(871),
    [sym_binary_operator] = STATE(430),
    [sym_unary_operator] = STATE(430),
    [sym_comparison_operator] = STATE(871),
    [sym_lambda] = STATE(871),
    [sym_attribute] = STATE(430),
    [sym_subscript] = STATE(430),
    [sym_call] = STATE(430),
    [sym_list] = STATE(430),
    [sym_list_comprehension] = STATE(430),
    [sym_dictionary] = STATE(430),
    [sym_dictionary_comprehension] = STATE(430),
    [sym_set] = STATE(430),
    [sym_set_comprehension] = STATE(430),
    [sym_parenthesized_expression] = STATE(430),
    [sym_tuple] = STATE(430),
    [sym_generator_expression] = STATE(430),
    [sym_conditional_expression] = STATE(871),
    [sym_concatenated_string] = STATE(430),
    [sym_await] = STATE(871),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_STAR] = ACTIONS(238),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_not] = ACTIONS(760),
    [anon_sym_PLUS] = ACTIONS(762),
    [anon_sym_DASH] = ACTIONS(762),
    [anon_sym_TILDE] = ACTIONS(762),
    [anon_sym_lambda] = ACTIONS(764),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(766),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(768),
    [sym_integer] = ACTIONS(770),
    [sym_float] = ACTIONS(770),
    [sym_identifier] = ACTIONS(770),
    [sym_true] = ACTIONS(770),
    [sym_false] = ACTIONS(770),
    [sym_none] = ACTIONS(770),
    [anon_sym_await] = ACTIONS(772),
    [sym_comment] = ACTIONS(72),
  },
  [1265] = {
    [sym__expression] = STATE(1558),
    [sym__primary_expression] = STATE(145),
    [sym_not_operator] = STATE(1558),
    [sym_boolean_operator] = STATE(1558),
    [sym_binary_operator] = STATE(145),
    [sym_unary_operator] = STATE(145),
    [sym_comparison_operator] = STATE(1558),
    [sym_lambda] = STATE(1558),
    [sym_attribute] = STATE(145),
    [sym_subscript] = STATE(145),
    [sym_call] = STATE(145),
    [sym_list] = STATE(145),
    [sym_list_comprehension] = STATE(145),
    [sym_dictionary] = STATE(145),
    [sym_dictionary_comprehension] = STATE(145),
    [sym_set] = STATE(145),
    [sym_set_comprehension] = STATE(145),
    [sym_parenthesized_expression] = STATE(145),
    [sym_tuple] = STATE(145),
    [sym_generator_expression] = STATE(145),
    [sym_conditional_expression] = STATE(1558),
    [sym_concatenated_string] = STATE(145),
    [sym_await] = STATE(1558),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_not] = ACTIONS(240),
    [anon_sym_PLUS] = ACTIONS(242),
    [anon_sym_DASH] = ACTIONS(242),
    [anon_sym_TILDE] = ACTIONS(242),
    [anon_sym_lambda] = ACTIONS(244),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(248),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(250),
    [sym_integer] = ACTIONS(252),
    [sym_float] = ACTIONS(252),
    [sym_identifier] = ACTIONS(252),
    [sym_true] = ACTIONS(252),
    [sym_false] = ACTIONS(252),
    [sym_none] = ACTIONS(252),
    [anon_sym_await] = ACTIONS(254),
    [sym_comment] = ACTIONS(72),
  },
  [1266] = {
    [anon_sym_in] = ACTIONS(3427),
    [sym_comment] = ACTIONS(72),
  },
  [1267] = {
    [sym__expression_within_for_in_clause] = STATE(1561),
    [sym__expression] = STATE(1562),
    [sym__primary_expression] = STATE(145),
    [sym_not_operator] = STATE(1562),
    [sym_boolean_operator] = STATE(1562),
    [sym_binary_operator] = STATE(145),
    [sym_unary_operator] = STATE(145),
    [sym_comparison_operator] = STATE(1562),
    [sym_lambda] = STATE(1562),
    [sym_lambda_within_for_in_clause] = STATE(1406),
    [sym_attribute] = STATE(145),
    [sym_subscript] = STATE(145),
    [sym_call] = STATE(145),
    [sym_list] = STATE(145),
    [sym_list_comprehension] = STATE(145),
    [sym_dictionary] = STATE(145),
    [sym_dictionary_comprehension] = STATE(145),
    [sym_set] = STATE(145),
    [sym_set_comprehension] = STATE(145),
    [sym_parenthesized_expression] = STATE(145),
    [sym_tuple] = STATE(145),
    [sym_generator_expression] = STATE(145),
    [sym_conditional_expression] = STATE(1562),
    [sym_concatenated_string] = STATE(145),
    [sym_await] = STATE(1562),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_not] = ACTIONS(240),
    [anon_sym_PLUS] = ACTIONS(242),
    [anon_sym_DASH] = ACTIONS(242),
    [anon_sym_TILDE] = ACTIONS(242),
    [anon_sym_lambda] = ACTIONS(3429),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(248),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(250),
    [sym_integer] = ACTIONS(252),
    [sym_float] = ACTIONS(252),
    [sym_identifier] = ACTIONS(252),
    [sym_true] = ACTIONS(252),
    [sym_false] = ACTIONS(252),
    [sym_none] = ACTIONS(252),
    [anon_sym_await] = ACTIONS(254),
    [sym_comment] = ACTIONS(72),
  },
  [1268] = {
    [sym__expression] = STATE(1563),
    [sym__primary_expression] = STATE(1274),
    [sym_not_operator] = STATE(1563),
    [sym_boolean_operator] = STATE(1563),
    [sym_binary_operator] = STATE(1274),
    [sym_unary_operator] = STATE(1274),
    [sym_comparison_operator] = STATE(1563),
    [sym_lambda] = STATE(1563),
    [sym_attribute] = STATE(1274),
    [sym_subscript] = STATE(1274),
    [sym_call] = STATE(1274),
    [sym_list] = STATE(1274),
    [sym_list_comprehension] = STATE(1274),
    [sym_dictionary] = STATE(1274),
    [sym_dictionary_comprehension] = STATE(1274),
    [sym_set] = STATE(1274),
    [sym_set_comprehension] = STATE(1274),
    [sym_parenthesized_expression] = STATE(1274),
    [sym_tuple] = STATE(1274),
    [sym_generator_expression] = STATE(1274),
    [sym_conditional_expression] = STATE(1563),
    [sym_concatenated_string] = STATE(1274),
    [sym_await] = STATE(1563),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_not] = ACTIONS(2702),
    [anon_sym_PLUS] = ACTIONS(2704),
    [anon_sym_DASH] = ACTIONS(2704),
    [anon_sym_TILDE] = ACTIONS(2704),
    [anon_sym_lambda] = ACTIONS(2706),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(2708),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(2710),
    [sym_integer] = ACTIONS(2712),
    [sym_float] = ACTIONS(2712),
    [sym_identifier] = ACTIONS(2712),
    [sym_true] = ACTIONS(2712),
    [sym_false] = ACTIONS(2712),
    [sym_none] = ACTIONS(2712),
    [anon_sym_await] = ACTIONS(2714),
    [sym_comment] = ACTIONS(72),
  },
  [1269] = {
    [sym__primary_expression] = STATE(204),
    [sym_binary_operator] = STATE(204),
    [sym_unary_operator] = STATE(204),
    [sym_attribute] = STATE(204),
    [sym_subscript] = STATE(204),
    [sym_call] = STATE(204),
    [sym_list] = STATE(204),
    [sym_list_comprehension] = STATE(204),
    [sym_dictionary] = STATE(204),
    [sym_dictionary_comprehension] = STATE(204),
    [sym_set] = STATE(204),
    [sym_set_comprehension] = STATE(204),
    [sym_parenthesized_expression] = STATE(204),
    [sym_tuple] = STATE(204),
    [sym_generator_expression] = STATE(204),
    [sym_concatenated_string] = STATE(204),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_PLUS] = ACTIONS(2704),
    [anon_sym_DASH] = ACTIONS(2704),
    [anon_sym_TILDE] = ACTIONS(2704),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(376),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(2710),
    [sym_integer] = ACTIONS(378),
    [sym_float] = ACTIONS(378),
    [sym_identifier] = ACTIONS(378),
    [sym_true] = ACTIONS(378),
    [sym_false] = ACTIONS(378),
    [sym_none] = ACTIONS(378),
    [sym_comment] = ACTIONS(72),
  },
  [1270] = {
    [sym_lambda_parameters] = STATE(1565),
    [sym__parameters] = STATE(130),
    [sym_default_parameter] = STATE(131),
    [sym_typed_default_parameter] = STATE(131),
    [sym_list_splat] = STATE(132),
    [sym_dictionary_splat] = STATE(132),
    [sym_typed_parameter] = STATE(131),
    [sym_tuple] = STATE(131),
    [anon_sym_LPAREN] = ACTIONS(222),
    [anon_sym_STAR] = ACTIONS(224),
    [anon_sym_print] = ACTIONS(226),
    [anon_sym_COLON] = ACTIONS(3431),
    [anon_sym_exec] = ACTIONS(226),
    [sym_identifier] = ACTIONS(230),
    [sym_comment] = ACTIONS(72),
  },
  [1271] = {
    [aux_sym_concatenated_string_repeat1] = STATE(1566),
    [anon_sym_DOT] = ACTIONS(276),
    [anon_sym_LPAREN] = ACTIONS(276),
    [anon_sym_STAR] = ACTIONS(278),
    [anon_sym_GT_GT] = ACTIONS(276),
    [anon_sym_if] = ACTIONS(276),
    [anon_sym_async] = ACTIONS(276),
    [anon_sym_for] = ACTIONS(276),
    [anon_sym_in] = ACTIONS(276),
    [anon_sym_AT] = ACTIONS(276),
    [anon_sym_not] = ACTIONS(276),
    [anon_sym_and] = ACTIONS(276),
    [anon_sym_or] = ACTIONS(276),
    [anon_sym_PLUS] = ACTIONS(276),
    [anon_sym_DASH] = ACTIONS(276),
    [anon_sym_SLASH] = ACTIONS(278),
    [anon_sym_PERCENT] = ACTIONS(276),
    [anon_sym_SLASH_SLASH] = ACTIONS(276),
    [anon_sym_STAR_STAR] = ACTIONS(276),
    [anon_sym_PIPE] = ACTIONS(276),
    [anon_sym_AMP] = ACTIONS(276),
    [anon_sym_CARET] = ACTIONS(276),
    [anon_sym_LT_LT] = ACTIONS(276),
    [anon_sym_LT] = ACTIONS(278),
    [anon_sym_LT_EQ] = ACTIONS(276),
    [anon_sym_EQ_EQ] = ACTIONS(276),
    [anon_sym_BANG_EQ] = ACTIONS(276),
    [anon_sym_GT_EQ] = ACTIONS(276),
    [anon_sym_GT] = ACTIONS(278),
    [anon_sym_LT_GT] = ACTIONS(276),
    [anon_sym_is] = ACTIONS(276),
    [anon_sym_LBRACK] = ACTIONS(276),
    [anon_sym_RBRACK] = ACTIONS(276),
    [sym_string] = ACTIONS(3433),
    [sym_comment] = ACTIONS(72),
  },
  [1272] = {
    [sym__expression] = STATE(227),
    [sym__primary_expression] = STATE(1274),
    [sym_not_operator] = STATE(227),
    [sym_boolean_operator] = STATE(227),
    [sym_binary_operator] = STATE(1274),
    [sym_unary_operator] = STATE(1274),
    [sym_comparison_operator] = STATE(227),
    [sym_lambda] = STATE(227),
    [sym_attribute] = STATE(1274),
    [sym_subscript] = STATE(1274),
    [sym_call] = STATE(1274),
    [sym_list] = STATE(1274),
    [sym_list_comprehension] = STATE(1274),
    [sym_dictionary] = STATE(1274),
    [sym_dictionary_comprehension] = STATE(1274),
    [sym_set] = STATE(1274),
    [sym_set_comprehension] = STATE(1274),
    [sym_parenthesized_expression] = STATE(1274),
    [sym_tuple] = STATE(1274),
    [sym_generator_expression] = STATE(1274),
    [sym_conditional_expression] = STATE(227),
    [sym_concatenated_string] = STATE(1274),
    [sym_await] = STATE(227),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_not] = ACTIONS(2702),
    [anon_sym_PLUS] = ACTIONS(2704),
    [anon_sym_DASH] = ACTIONS(2704),
    [anon_sym_TILDE] = ACTIONS(2704),
    [anon_sym_lambda] = ACTIONS(2706),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(2708),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(2710),
    [sym_integer] = ACTIONS(2712),
    [sym_float] = ACTIONS(2712),
    [sym_identifier] = ACTIONS(2712),
    [sym_true] = ACTIONS(2712),
    [sym_false] = ACTIONS(2712),
    [sym_none] = ACTIONS(2712),
    [anon_sym_await] = ACTIONS(2714),
    [sym_comment] = ACTIONS(72),
  },
  [1273] = {
    [anon_sym_if] = ACTIONS(3051),
    [anon_sym_async] = ACTIONS(3051),
    [anon_sym_for] = ACTIONS(3051),
    [anon_sym_and] = ACTIONS(3435),
    [anon_sym_or] = ACTIONS(3437),
    [anon_sym_RBRACK] = ACTIONS(3051),
    [sym_comment] = ACTIONS(72),
  },
  [1274] = {
    [sym_argument_list] = STATE(251),
    [sym_generator_expression] = STATE(251),
    [aux_sym_comparison_operator_repeat1] = STATE(1580),
    [anon_sym_DOT] = ACTIONS(422),
    [anon_sym_LPAREN] = ACTIONS(424),
    [anon_sym_STAR] = ACTIONS(3439),
    [anon_sym_GT_GT] = ACTIONS(3441),
    [anon_sym_if] = ACTIONS(302),
    [anon_sym_async] = ACTIONS(302),
    [anon_sym_for] = ACTIONS(302),
    [anon_sym_in] = ACTIONS(3443),
    [anon_sym_AT] = ACTIONS(3445),
    [anon_sym_not] = ACTIONS(3447),
    [anon_sym_and] = ACTIONS(302),
    [anon_sym_or] = ACTIONS(302),
    [anon_sym_PLUS] = ACTIONS(3449),
    [anon_sym_DASH] = ACTIONS(3449),
    [anon_sym_SLASH] = ACTIONS(3439),
    [anon_sym_PERCENT] = ACTIONS(3445),
    [anon_sym_SLASH_SLASH] = ACTIONS(3445),
    [anon_sym_STAR_STAR] = ACTIONS(3451),
    [anon_sym_PIPE] = ACTIONS(3453),
    [anon_sym_AMP] = ACTIONS(3455),
    [anon_sym_CARET] = ACTIONS(3457),
    [anon_sym_LT_LT] = ACTIONS(3441),
    [anon_sym_LT] = ACTIONS(3459),
    [anon_sym_LT_EQ] = ACTIONS(3443),
    [anon_sym_EQ_EQ] = ACTIONS(3443),
    [anon_sym_BANG_EQ] = ACTIONS(3443),
    [anon_sym_GT_EQ] = ACTIONS(3443),
    [anon_sym_GT] = ACTIONS(3459),
    [anon_sym_LT_GT] = ACTIONS(3443),
    [anon_sym_is] = ACTIONS(3461),
    [anon_sym_LBRACK] = ACTIONS(450),
    [anon_sym_RBRACK] = ACTIONS(302),
    [sym_comment] = ACTIONS(72),
  },
  [1275] = {
    [sym_for_in_clause] = STATE(1275),
    [sym_if_clause] = STATE(1275),
    [aux_sym__comprehension_body_repeat1] = STATE(1275),
    [anon_sym_if] = ACTIONS(3463),
    [anon_sym_async] = ACTIONS(3466),
    [anon_sym_for] = ACTIONS(3469),
    [anon_sym_RBRACK] = ACTIONS(3081),
    [sym_comment] = ACTIONS(72),
  },
  [1276] = {
    [sym_argument_list] = STATE(251),
    [sym_generator_expression] = STATE(251),
    [anon_sym_DOT] = ACTIONS(422),
    [anon_sym_LPAREN] = ACTIONS(424),
    [anon_sym_COMMA] = ACTIONS(2953),
    [anon_sym_STAR] = ACTIONS(794),
    [anon_sym_GT_GT] = ACTIONS(796),
    [anon_sym_if] = ACTIONS(2953),
    [anon_sym_async] = ACTIONS(2953),
    [anon_sym_for] = ACTIONS(2953),
    [anon_sym_in] = ACTIONS(2953),
    [anon_sym_AT] = ACTIONS(800),
    [anon_sym_not] = ACTIONS(2953),
    [anon_sym_and] = ACTIONS(2953),
    [anon_sym_or] = ACTIONS(2953),
    [anon_sym_PLUS] = ACTIONS(804),
    [anon_sym_DASH] = ACTIONS(804),
    [anon_sym_SLASH] = ACTIONS(794),
    [anon_sym_PERCENT] = ACTIONS(800),
    [anon_sym_SLASH_SLASH] = ACTIONS(800),
    [anon_sym_STAR_STAR] = ACTIONS(806),
    [anon_sym_PIPE] = ACTIONS(808),
    [anon_sym_AMP] = ACTIONS(810),
    [anon_sym_CARET] = ACTIONS(812),
    [anon_sym_LT_LT] = ACTIONS(796),
    [anon_sym_LT] = ACTIONS(2955),
    [anon_sym_LT_EQ] = ACTIONS(2953),
    [anon_sym_EQ_EQ] = ACTIONS(2953),
    [anon_sym_BANG_EQ] = ACTIONS(2953),
    [anon_sym_GT_EQ] = ACTIONS(2953),
    [anon_sym_GT] = ACTIONS(2955),
    [anon_sym_LT_GT] = ACTIONS(2953),
    [anon_sym_is] = ACTIONS(2953),
    [anon_sym_LBRACK] = ACTIONS(450),
    [anon_sym_RBRACK] = ACTIONS(2953),
    [sym_comment] = ACTIONS(72),
  },
  [1277] = {
    [anon_sym_COMMA] = ACTIONS(1644),
    [anon_sym_if] = ACTIONS(1758),
    [anon_sym_and] = ACTIONS(1760),
    [anon_sym_or] = ACTIONS(1762),
    [anon_sym_RBRACE] = ACTIONS(1644),
    [sym_comment] = ACTIONS(72),
  },
  [1278] = {
    [sym__expression] = STATE(1581),
    [sym__primary_expression] = STATE(463),
    [sym_not_operator] = STATE(1581),
    [sym_boolean_operator] = STATE(1581),
    [sym_binary_operator] = STATE(463),
    [sym_unary_operator] = STATE(463),
    [sym_comparison_operator] = STATE(1581),
    [sym_lambda] = STATE(1581),
    [sym_attribute] = STATE(463),
    [sym_subscript] = STATE(463),
    [sym_call] = STATE(463),
    [sym_list] = STATE(463),
    [sym_list_comprehension] = STATE(463),
    [sym_dictionary] = STATE(463),
    [sym_dictionary_comprehension] = STATE(463),
    [sym_set] = STATE(463),
    [sym_set_comprehension] = STATE(463),
    [sym_parenthesized_expression] = STATE(463),
    [sym_tuple] = STATE(463),
    [sym_generator_expression] = STATE(463),
    [sym_conditional_expression] = STATE(1581),
    [sym_concatenated_string] = STATE(463),
    [sym_await] = STATE(1581),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_not] = ACTIONS(822),
    [anon_sym_PLUS] = ACTIONS(824),
    [anon_sym_DASH] = ACTIONS(824),
    [anon_sym_TILDE] = ACTIONS(824),
    [anon_sym_lambda] = ACTIONS(826),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(828),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(830),
    [sym_integer] = ACTIONS(832),
    [sym_float] = ACTIONS(832),
    [sym_identifier] = ACTIONS(832),
    [sym_true] = ACTIONS(832),
    [sym_false] = ACTIONS(832),
    [sym_none] = ACTIONS(832),
    [anon_sym_await] = ACTIONS(834),
    [sym_comment] = ACTIONS(72),
  },
  [1279] = {
    [aux_sym_concatenated_string_repeat1] = STATE(1279),
    [anon_sym_DOT] = ACTIONS(1862),
    [anon_sym_LPAREN] = ACTIONS(1862),
    [anon_sym_COMMA] = ACTIONS(1862),
    [anon_sym_STAR] = ACTIONS(1864),
    [anon_sym_GT_GT] = ACTIONS(1862),
    [anon_sym_if] = ACTIONS(1862),
    [anon_sym_in] = ACTIONS(1862),
    [anon_sym_AT] = ACTIONS(1862),
    [anon_sym_not] = ACTIONS(1862),
    [anon_sym_and] = ACTIONS(1862),
    [anon_sym_or] = ACTIONS(1862),
    [anon_sym_PLUS] = ACTIONS(1862),
    [anon_sym_DASH] = ACTIONS(1862),
    [anon_sym_SLASH] = ACTIONS(1864),
    [anon_sym_PERCENT] = ACTIONS(1862),
    [anon_sym_SLASH_SLASH] = ACTIONS(1862),
    [anon_sym_STAR_STAR] = ACTIONS(1862),
    [anon_sym_PIPE] = ACTIONS(1862),
    [anon_sym_AMP] = ACTIONS(1862),
    [anon_sym_CARET] = ACTIONS(1862),
    [anon_sym_LT_LT] = ACTIONS(1862),
    [anon_sym_LT] = ACTIONS(1864),
    [anon_sym_LT_EQ] = ACTIONS(1862),
    [anon_sym_EQ_EQ] = ACTIONS(1862),
    [anon_sym_BANG_EQ] = ACTIONS(1862),
    [anon_sym_GT_EQ] = ACTIONS(1862),
    [anon_sym_GT] = ACTIONS(1864),
    [anon_sym_LT_GT] = ACTIONS(1862),
    [anon_sym_is] = ACTIONS(1862),
    [anon_sym_LBRACK] = ACTIONS(1862),
    [anon_sym_RBRACE] = ACTIONS(1862),
    [sym_string] = ACTIONS(3472),
    [sym_comment] = ACTIONS(72),
  },
  [1280] = {
    [anon_sym_if] = ACTIONS(1921),
    [anon_sym_else] = ACTIONS(3475),
    [anon_sym_and] = ACTIONS(1925),
    [anon_sym_or] = ACTIONS(1927),
    [sym_comment] = ACTIONS(72),
  },
  [1281] = {
    [anon_sym_COMMA] = ACTIONS(1953),
    [anon_sym_if] = ACTIONS(1953),
    [anon_sym_and] = ACTIONS(1760),
    [anon_sym_or] = ACTIONS(1953),
    [anon_sym_RBRACE] = ACTIONS(1953),
    [sym_comment] = ACTIONS(72),
  },
  [1282] = {
    [sym_argument_list] = STATE(251),
    [sym_generator_expression] = STATE(251),
    [anon_sym_DOT] = ACTIONS(1980),
    [anon_sym_LPAREN] = ACTIONS(424),
    [anon_sym_COMMA] = ACTIONS(1980),
    [anon_sym_STAR] = ACTIONS(1982),
    [anon_sym_GT_GT] = ACTIONS(1980),
    [anon_sym_if] = ACTIONS(1980),
    [anon_sym_in] = ACTIONS(1980),
    [anon_sym_AT] = ACTIONS(1980),
    [anon_sym_not] = ACTIONS(1980),
    [anon_sym_and] = ACTIONS(1980),
    [anon_sym_or] = ACTIONS(1980),
    [anon_sym_PLUS] = ACTIONS(1980),
    [anon_sym_DASH] = ACTIONS(1980),
    [anon_sym_SLASH] = ACTIONS(1982),
    [anon_sym_PERCENT] = ACTIONS(1980),
    [anon_sym_SLASH_SLASH] = ACTIONS(1980),
    [anon_sym_STAR_STAR] = ACTIONS(1776),
    [anon_sym_PIPE] = ACTIONS(1980),
    [anon_sym_AMP] = ACTIONS(1980),
    [anon_sym_CARET] = ACTIONS(1980),
    [anon_sym_LT_LT] = ACTIONS(1980),
    [anon_sym_LT] = ACTIONS(1982),
    [anon_sym_LT_EQ] = ACTIONS(1980),
    [anon_sym_EQ_EQ] = ACTIONS(1980),
    [anon_sym_BANG_EQ] = ACTIONS(1980),
    [anon_sym_GT_EQ] = ACTIONS(1980),
    [anon_sym_GT] = ACTIONS(1982),
    [anon_sym_LT_GT] = ACTIONS(1980),
    [anon_sym_is] = ACTIONS(1980),
    [anon_sym_LBRACK] = ACTIONS(1980),
    [anon_sym_RBRACE] = ACTIONS(1980),
    [sym_comment] = ACTIONS(72),
  },
  [1283] = {
    [sym_argument_list] = STATE(251),
    [sym_generator_expression] = STATE(251),
    [anon_sym_DOT] = ACTIONS(1980),
    [anon_sym_LPAREN] = ACTIONS(424),
    [anon_sym_COMMA] = ACTIONS(1980),
    [anon_sym_STAR] = ACTIONS(1764),
    [anon_sym_GT_GT] = ACTIONS(1980),
    [anon_sym_if] = ACTIONS(1980),
    [anon_sym_in] = ACTIONS(1980),
    [anon_sym_AT] = ACTIONS(1770),
    [anon_sym_not] = ACTIONS(1980),
    [anon_sym_and] = ACTIONS(1980),
    [anon_sym_or] = ACTIONS(1980),
    [anon_sym_PLUS] = ACTIONS(1774),
    [anon_sym_DASH] = ACTIONS(1774),
    [anon_sym_SLASH] = ACTIONS(1764),
    [anon_sym_PERCENT] = ACTIONS(1770),
    [anon_sym_SLASH_SLASH] = ACTIONS(1770),
    [anon_sym_STAR_STAR] = ACTIONS(1776),
    [anon_sym_PIPE] = ACTIONS(1980),
    [anon_sym_AMP] = ACTIONS(1980),
    [anon_sym_CARET] = ACTIONS(1980),
    [anon_sym_LT_LT] = ACTIONS(1980),
    [anon_sym_LT] = ACTIONS(1982),
    [anon_sym_LT_EQ] = ACTIONS(1980),
    [anon_sym_EQ_EQ] = ACTIONS(1980),
    [anon_sym_BANG_EQ] = ACTIONS(1980),
    [anon_sym_GT_EQ] = ACTIONS(1980),
    [anon_sym_GT] = ACTIONS(1982),
    [anon_sym_LT_GT] = ACTIONS(1980),
    [anon_sym_is] = ACTIONS(1980),
    [anon_sym_LBRACK] = ACTIONS(1980),
    [anon_sym_RBRACE] = ACTIONS(1980),
    [sym_comment] = ACTIONS(72),
  },
  [1284] = {
    [sym_argument_list] = STATE(251),
    [sym_generator_expression] = STATE(251),
    [anon_sym_DOT] = ACTIONS(422),
    [anon_sym_LPAREN] = ACTIONS(424),
    [anon_sym_COMMA] = ACTIONS(1984),
    [anon_sym_STAR] = ACTIONS(1764),
    [anon_sym_GT_GT] = ACTIONS(1766),
    [anon_sym_if] = ACTIONS(1984),
    [anon_sym_in] = ACTIONS(1984),
    [anon_sym_AT] = ACTIONS(1770),
    [anon_sym_not] = ACTIONS(1984),
    [anon_sym_and] = ACTIONS(1984),
    [anon_sym_or] = ACTIONS(1984),
    [anon_sym_PLUS] = ACTIONS(1774),
    [anon_sym_DASH] = ACTIONS(1774),
    [anon_sym_SLASH] = ACTIONS(1764),
    [anon_sym_PERCENT] = ACTIONS(1770),
    [anon_sym_SLASH_SLASH] = ACTIONS(1770),
    [anon_sym_STAR_STAR] = ACTIONS(1776),
    [anon_sym_PIPE] = ACTIONS(1778),
    [anon_sym_AMP] = ACTIONS(1780),
    [anon_sym_CARET] = ACTIONS(1782),
    [anon_sym_LT_LT] = ACTIONS(1766),
    [anon_sym_LT] = ACTIONS(1986),
    [anon_sym_LT_EQ] = ACTIONS(1984),
    [anon_sym_EQ_EQ] = ACTIONS(1984),
    [anon_sym_BANG_EQ] = ACTIONS(1984),
    [anon_sym_GT_EQ] = ACTIONS(1984),
    [anon_sym_GT] = ACTIONS(1986),
    [anon_sym_LT_GT] = ACTIONS(1984),
    [anon_sym_is] = ACTIONS(1984),
    [anon_sym_LBRACK] = ACTIONS(450),
    [anon_sym_RBRACE] = ACTIONS(1984),
    [sym_comment] = ACTIONS(72),
  },
  [1285] = {
    [sym__primary_expression] = STATE(1583),
    [sym_binary_operator] = STATE(1583),
    [sym_unary_operator] = STATE(1583),
    [sym_attribute] = STATE(1583),
    [sym_subscript] = STATE(1583),
    [sym_call] = STATE(1583),
    [sym_list] = STATE(1583),
    [sym_list_comprehension] = STATE(1583),
    [sym_dictionary] = STATE(1583),
    [sym_dictionary_comprehension] = STATE(1583),
    [sym_set] = STATE(1583),
    [sym_set_comprehension] = STATE(1583),
    [sym_parenthesized_expression] = STATE(1583),
    [sym_tuple] = STATE(1583),
    [sym_generator_expression] = STATE(1583),
    [sym_concatenated_string] = STATE(1583),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_PLUS] = ACTIONS(824),
    [anon_sym_DASH] = ACTIONS(824),
    [anon_sym_TILDE] = ACTIONS(824),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(3477),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(830),
    [sym_integer] = ACTIONS(3479),
    [sym_float] = ACTIONS(3479),
    [sym_identifier] = ACTIONS(3479),
    [sym_true] = ACTIONS(3479),
    [sym_false] = ACTIONS(3479),
    [sym_none] = ACTIONS(3479),
    [sym_comment] = ACTIONS(72),
  },
  [1286] = {
    [sym_argument_list] = STATE(251),
    [sym_generator_expression] = STATE(251),
    [anon_sym_DOT] = ACTIONS(1980),
    [anon_sym_LPAREN] = ACTIONS(424),
    [anon_sym_COMMA] = ACTIONS(1980),
    [anon_sym_STAR] = ACTIONS(1764),
    [anon_sym_GT_GT] = ACTIONS(1980),
    [anon_sym_if] = ACTIONS(1980),
    [anon_sym_in] = ACTIONS(1980),
    [anon_sym_AT] = ACTIONS(1770),
    [anon_sym_not] = ACTIONS(1980),
    [anon_sym_and] = ACTIONS(1980),
    [anon_sym_or] = ACTIONS(1980),
    [anon_sym_PLUS] = ACTIONS(1980),
    [anon_sym_DASH] = ACTIONS(1980),
    [anon_sym_SLASH] = ACTIONS(1764),
    [anon_sym_PERCENT] = ACTIONS(1770),
    [anon_sym_SLASH_SLASH] = ACTIONS(1770),
    [anon_sym_STAR_STAR] = ACTIONS(1776),
    [anon_sym_PIPE] = ACTIONS(1980),
    [anon_sym_AMP] = ACTIONS(1980),
    [anon_sym_CARET] = ACTIONS(1980),
    [anon_sym_LT_LT] = ACTIONS(1980),
    [anon_sym_LT] = ACTIONS(1982),
    [anon_sym_LT_EQ] = ACTIONS(1980),
    [anon_sym_EQ_EQ] = ACTIONS(1980),
    [anon_sym_BANG_EQ] = ACTIONS(1980),
    [anon_sym_GT_EQ] = ACTIONS(1980),
    [anon_sym_GT] = ACTIONS(1982),
    [anon_sym_LT_GT] = ACTIONS(1980),
    [anon_sym_is] = ACTIONS(1980),
    [anon_sym_LBRACK] = ACTIONS(1980),
    [anon_sym_RBRACE] = ACTIONS(1980),
    [sym_comment] = ACTIONS(72),
  },
  [1287] = {
    [sym_argument_list] = STATE(251),
    [sym_generator_expression] = STATE(251),
    [anon_sym_DOT] = ACTIONS(1980),
    [anon_sym_LPAREN] = ACTIONS(424),
    [anon_sym_COMMA] = ACTIONS(1980),
    [anon_sym_STAR] = ACTIONS(1764),
    [anon_sym_GT_GT] = ACTIONS(1766),
    [anon_sym_if] = ACTIONS(1980),
    [anon_sym_in] = ACTIONS(1980),
    [anon_sym_AT] = ACTIONS(1770),
    [anon_sym_not] = ACTIONS(1980),
    [anon_sym_and] = ACTIONS(1980),
    [anon_sym_or] = ACTIONS(1980),
    [anon_sym_PLUS] = ACTIONS(1774),
    [anon_sym_DASH] = ACTIONS(1774),
    [anon_sym_SLASH] = ACTIONS(1764),
    [anon_sym_PERCENT] = ACTIONS(1770),
    [anon_sym_SLASH_SLASH] = ACTIONS(1770),
    [anon_sym_STAR_STAR] = ACTIONS(1776),
    [anon_sym_PIPE] = ACTIONS(1980),
    [anon_sym_AMP] = ACTIONS(1780),
    [anon_sym_CARET] = ACTIONS(1782),
    [anon_sym_LT_LT] = ACTIONS(1766),
    [anon_sym_LT] = ACTIONS(1982),
    [anon_sym_LT_EQ] = ACTIONS(1980),
    [anon_sym_EQ_EQ] = ACTIONS(1980),
    [anon_sym_BANG_EQ] = ACTIONS(1980),
    [anon_sym_GT_EQ] = ACTIONS(1980),
    [anon_sym_GT] = ACTIONS(1982),
    [anon_sym_LT_GT] = ACTIONS(1980),
    [anon_sym_is] = ACTIONS(1980),
    [anon_sym_LBRACK] = ACTIONS(1980),
    [anon_sym_RBRACE] = ACTIONS(1980),
    [sym_comment] = ACTIONS(72),
  },
  [1288] = {
    [sym_argument_list] = STATE(251),
    [sym_generator_expression] = STATE(251),
    [anon_sym_DOT] = ACTIONS(1980),
    [anon_sym_LPAREN] = ACTIONS(424),
    [anon_sym_COMMA] = ACTIONS(1980),
    [anon_sym_STAR] = ACTIONS(1764),
    [anon_sym_GT_GT] = ACTIONS(1766),
    [anon_sym_if] = ACTIONS(1980),
    [anon_sym_in] = ACTIONS(1980),
    [anon_sym_AT] = ACTIONS(1770),
    [anon_sym_not] = ACTIONS(1980),
    [anon_sym_and] = ACTIONS(1980),
    [anon_sym_or] = ACTIONS(1980),
    [anon_sym_PLUS] = ACTIONS(1774),
    [anon_sym_DASH] = ACTIONS(1774),
    [anon_sym_SLASH] = ACTIONS(1764),
    [anon_sym_PERCENT] = ACTIONS(1770),
    [anon_sym_SLASH_SLASH] = ACTIONS(1770),
    [anon_sym_STAR_STAR] = ACTIONS(1776),
    [anon_sym_PIPE] = ACTIONS(1980),
    [anon_sym_AMP] = ACTIONS(1980),
    [anon_sym_CARET] = ACTIONS(1782),
    [anon_sym_LT_LT] = ACTIONS(1766),
    [anon_sym_LT] = ACTIONS(1982),
    [anon_sym_LT_EQ] = ACTIONS(1980),
    [anon_sym_EQ_EQ] = ACTIONS(1980),
    [anon_sym_BANG_EQ] = ACTIONS(1980),
    [anon_sym_GT_EQ] = ACTIONS(1980),
    [anon_sym_GT] = ACTIONS(1982),
    [anon_sym_LT_GT] = ACTIONS(1980),
    [anon_sym_is] = ACTIONS(1980),
    [anon_sym_LBRACK] = ACTIONS(1980),
    [anon_sym_RBRACE] = ACTIONS(1980),
    [sym_comment] = ACTIONS(72),
  },
  [1289] = {
    [sym_argument_list] = STATE(251),
    [sym_generator_expression] = STATE(251),
    [anon_sym_DOT] = ACTIONS(1980),
    [anon_sym_LPAREN] = ACTIONS(424),
    [anon_sym_COMMA] = ACTIONS(1980),
    [anon_sym_STAR] = ACTIONS(1764),
    [anon_sym_GT_GT] = ACTIONS(1766),
    [anon_sym_if] = ACTIONS(1980),
    [anon_sym_in] = ACTIONS(1980),
    [anon_sym_AT] = ACTIONS(1770),
    [anon_sym_not] = ACTIONS(1980),
    [anon_sym_and] = ACTIONS(1980),
    [anon_sym_or] = ACTIONS(1980),
    [anon_sym_PLUS] = ACTIONS(1774),
    [anon_sym_DASH] = ACTIONS(1774),
    [anon_sym_SLASH] = ACTIONS(1764),
    [anon_sym_PERCENT] = ACTIONS(1770),
    [anon_sym_SLASH_SLASH] = ACTIONS(1770),
    [anon_sym_STAR_STAR] = ACTIONS(1776),
    [anon_sym_PIPE] = ACTIONS(1980),
    [anon_sym_AMP] = ACTIONS(1980),
    [anon_sym_CARET] = ACTIONS(1980),
    [anon_sym_LT_LT] = ACTIONS(1766),
    [anon_sym_LT] = ACTIONS(1982),
    [anon_sym_LT_EQ] = ACTIONS(1980),
    [anon_sym_EQ_EQ] = ACTIONS(1980),
    [anon_sym_BANG_EQ] = ACTIONS(1980),
    [anon_sym_GT_EQ] = ACTIONS(1980),
    [anon_sym_GT] = ACTIONS(1982),
    [anon_sym_LT_GT] = ACTIONS(1980),
    [anon_sym_is] = ACTIONS(1980),
    [anon_sym_LBRACK] = ACTIONS(1980),
    [anon_sym_RBRACE] = ACTIONS(1980),
    [sym_comment] = ACTIONS(72),
  },
  [1290] = {
    [aux_sym_comparison_operator_repeat1] = STATE(1290),
    [anon_sym_COMMA] = ACTIONS(1984),
    [anon_sym_if] = ACTIONS(1984),
    [anon_sym_in] = ACTIONS(3481),
    [anon_sym_not] = ACTIONS(3484),
    [anon_sym_and] = ACTIONS(1984),
    [anon_sym_or] = ACTIONS(1984),
    [anon_sym_LT] = ACTIONS(3487),
    [anon_sym_LT_EQ] = ACTIONS(3481),
    [anon_sym_EQ_EQ] = ACTIONS(3481),
    [anon_sym_BANG_EQ] = ACTIONS(3481),
    [anon_sym_GT_EQ] = ACTIONS(3481),
    [anon_sym_GT] = ACTIONS(3487),
    [anon_sym_LT_GT] = ACTIONS(3481),
    [anon_sym_is] = ACTIONS(3490),
    [anon_sym_RBRACE] = ACTIONS(1984),
    [sym_comment] = ACTIONS(72),
  },
  [1291] = {
    [anon_sym_COMMA] = ACTIONS(2642),
    [anon_sym_if] = ACTIONS(850),
    [anon_sym_COLON] = ACTIONS(2642),
    [anon_sym_async] = ACTIONS(2642),
    [anon_sym_for] = ACTIONS(2642),
    [anon_sym_and] = ACTIONS(858),
    [anon_sym_or] = ACTIONS(860),
    [anon_sym_RBRACE] = ACTIONS(2642),
    [sym_comment] = ACTIONS(72),
  },
  [1292] = {
    [sym__newline] = ACTIONS(3493),
    [anon_sym_DOT] = ACTIONS(3493),
    [anon_sym_LPAREN] = ACTIONS(3493),
    [anon_sym_COMMA] = ACTIONS(3493),
    [anon_sym_STAR] = ACTIONS(3495),
    [anon_sym_GT_GT] = ACTIONS(3495),
    [anon_sym_if] = ACTIONS(3493),
    [anon_sym_COLON] = ACTIONS(3493),
    [anon_sym_in] = ACTIONS(3493),
    [anon_sym_EQ] = ACTIONS(3495),
    [anon_sym_AT] = ACTIONS(3495),
    [anon_sym_not] = ACTIONS(3493),
    [anon_sym_and] = ACTIONS(3493),
    [anon_sym_or] = ACTIONS(3493),
    [anon_sym_PLUS] = ACTIONS(3495),
    [anon_sym_DASH] = ACTIONS(3495),
    [anon_sym_SLASH] = ACTIONS(3495),
    [anon_sym_PERCENT] = ACTIONS(3495),
    [anon_sym_SLASH_SLASH] = ACTIONS(3495),
    [anon_sym_STAR_STAR] = ACTIONS(3495),
    [anon_sym_PIPE] = ACTIONS(3495),
    [anon_sym_AMP] = ACTIONS(3495),
    [anon_sym_CARET] = ACTIONS(3495),
    [anon_sym_LT_LT] = ACTIONS(3495),
    [anon_sym_LT] = ACTIONS(3495),
    [anon_sym_LT_EQ] = ACTIONS(3493),
    [anon_sym_EQ_EQ] = ACTIONS(3493),
    [anon_sym_BANG_EQ] = ACTIONS(3493),
    [anon_sym_GT_EQ] = ACTIONS(3493),
    [anon_sym_GT] = ACTIONS(3495),
    [anon_sym_LT_GT] = ACTIONS(3493),
    [anon_sym_is] = ACTIONS(3493),
    [anon_sym_PLUS_EQ] = ACTIONS(3493),
    [anon_sym_DASH_EQ] = ACTIONS(3493),
    [anon_sym_STAR_EQ] = ACTIONS(3493),
    [anon_sym_SLASH_EQ] = ACTIONS(3493),
    [anon_sym_AT_EQ] = ACTIONS(3493),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3493),
    [anon_sym_PERCENT_EQ] = ACTIONS(3493),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3493),
    [anon_sym_GT_GT_EQ] = ACTIONS(3493),
    [anon_sym_LT_LT_EQ] = ACTIONS(3493),
    [anon_sym_AMP_EQ] = ACTIONS(3493),
    [anon_sym_CARET_EQ] = ACTIONS(3493),
    [anon_sym_PIPE_EQ] = ACTIONS(3493),
    [anon_sym_LBRACK] = ACTIONS(3493),
    [sym_comment] = ACTIONS(72),
    [sym__semicolon] = ACTIONS(3493),
  },
  [1293] = {
    [sym_list_splat] = STATE(870),
    [sym__expression] = STATE(914),
    [sym__primary_expression] = STATE(463),
    [sym_not_operator] = STATE(914),
    [sym_boolean_operator] = STATE(914),
    [sym_binary_operator] = STATE(463),
    [sym_unary_operator] = STATE(463),
    [sym_comparison_operator] = STATE(914),
    [sym_lambda] = STATE(914),
    [sym_attribute] = STATE(463),
    [sym_subscript] = STATE(463),
    [sym_call] = STATE(463),
    [sym_list] = STATE(463),
    [sym_list_comprehension] = STATE(463),
    [sym_dictionary] = STATE(463),
    [sym_dictionary_comprehension] = STATE(463),
    [sym_set] = STATE(463),
    [sym_set_comprehension] = STATE(463),
    [sym_parenthesized_expression] = STATE(463),
    [sym_tuple] = STATE(463),
    [sym_generator_expression] = STATE(463),
    [sym_conditional_expression] = STATE(914),
    [sym_concatenated_string] = STATE(463),
    [sym_await] = STATE(914),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_STAR] = ACTIONS(1792),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_not] = ACTIONS(822),
    [anon_sym_PLUS] = ACTIONS(824),
    [anon_sym_DASH] = ACTIONS(824),
    [anon_sym_TILDE] = ACTIONS(824),
    [anon_sym_lambda] = ACTIONS(826),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(828),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(830),
    [sym_integer] = ACTIONS(832),
    [sym_float] = ACTIONS(832),
    [sym_identifier] = ACTIONS(832),
    [sym_true] = ACTIONS(832),
    [sym_false] = ACTIONS(832),
    [sym_none] = ACTIONS(832),
    [anon_sym_await] = ACTIONS(834),
    [sym_comment] = ACTIONS(72),
  },
  [1294] = {
    [sym__expression] = STATE(1584),
    [sym__primary_expression] = STATE(463),
    [sym_not_operator] = STATE(1584),
    [sym_boolean_operator] = STATE(1584),
    [sym_binary_operator] = STATE(463),
    [sym_unary_operator] = STATE(463),
    [sym_comparison_operator] = STATE(1584),
    [sym_lambda] = STATE(1584),
    [sym_attribute] = STATE(463),
    [sym_subscript] = STATE(463),
    [sym_call] = STATE(463),
    [sym_list] = STATE(463),
    [sym_list_comprehension] = STATE(463),
    [sym_dictionary] = STATE(463),
    [sym_dictionary_comprehension] = STATE(463),
    [sym_set] = STATE(463),
    [sym_set_comprehension] = STATE(463),
    [sym_parenthesized_expression] = STATE(463),
    [sym_tuple] = STATE(463),
    [sym_generator_expression] = STATE(463),
    [sym_conditional_expression] = STATE(1584),
    [sym_concatenated_string] = STATE(463),
    [sym_await] = STATE(1584),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_not] = ACTIONS(822),
    [anon_sym_PLUS] = ACTIONS(824),
    [anon_sym_DASH] = ACTIONS(824),
    [anon_sym_TILDE] = ACTIONS(824),
    [anon_sym_lambda] = ACTIONS(826),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(828),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(830),
    [sym_integer] = ACTIONS(832),
    [sym_float] = ACTIONS(832),
    [sym_identifier] = ACTIONS(832),
    [sym_true] = ACTIONS(832),
    [sym_false] = ACTIONS(832),
    [sym_none] = ACTIONS(832),
    [anon_sym_await] = ACTIONS(834),
    [sym_comment] = ACTIONS(72),
  },
  [1295] = {
    [sym__newline] = ACTIONS(3497),
    [anon_sym_DOT] = ACTIONS(3497),
    [anon_sym_LPAREN] = ACTIONS(3497),
    [anon_sym_COMMA] = ACTIONS(3497),
    [anon_sym_STAR] = ACTIONS(3499),
    [anon_sym_GT_GT] = ACTIONS(3499),
    [anon_sym_if] = ACTIONS(3497),
    [anon_sym_COLON] = ACTIONS(3497),
    [anon_sym_in] = ACTIONS(3497),
    [anon_sym_EQ] = ACTIONS(3499),
    [anon_sym_AT] = ACTIONS(3499),
    [anon_sym_not] = ACTIONS(3497),
    [anon_sym_and] = ACTIONS(3497),
    [anon_sym_or] = ACTIONS(3497),
    [anon_sym_PLUS] = ACTIONS(3499),
    [anon_sym_DASH] = ACTIONS(3499),
    [anon_sym_SLASH] = ACTIONS(3499),
    [anon_sym_PERCENT] = ACTIONS(3499),
    [anon_sym_SLASH_SLASH] = ACTIONS(3499),
    [anon_sym_STAR_STAR] = ACTIONS(3499),
    [anon_sym_PIPE] = ACTIONS(3499),
    [anon_sym_AMP] = ACTIONS(3499),
    [anon_sym_CARET] = ACTIONS(3499),
    [anon_sym_LT_LT] = ACTIONS(3499),
    [anon_sym_LT] = ACTIONS(3499),
    [anon_sym_LT_EQ] = ACTIONS(3497),
    [anon_sym_EQ_EQ] = ACTIONS(3497),
    [anon_sym_BANG_EQ] = ACTIONS(3497),
    [anon_sym_GT_EQ] = ACTIONS(3497),
    [anon_sym_GT] = ACTIONS(3499),
    [anon_sym_LT_GT] = ACTIONS(3497),
    [anon_sym_is] = ACTIONS(3497),
    [anon_sym_PLUS_EQ] = ACTIONS(3497),
    [anon_sym_DASH_EQ] = ACTIONS(3497),
    [anon_sym_STAR_EQ] = ACTIONS(3497),
    [anon_sym_SLASH_EQ] = ACTIONS(3497),
    [anon_sym_AT_EQ] = ACTIONS(3497),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3497),
    [anon_sym_PERCENT_EQ] = ACTIONS(3497),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3497),
    [anon_sym_GT_GT_EQ] = ACTIONS(3497),
    [anon_sym_LT_LT_EQ] = ACTIONS(3497),
    [anon_sym_AMP_EQ] = ACTIONS(3497),
    [anon_sym_CARET_EQ] = ACTIONS(3497),
    [anon_sym_PIPE_EQ] = ACTIONS(3497),
    [anon_sym_LBRACK] = ACTIONS(3497),
    [sym_comment] = ACTIONS(72),
    [sym__semicolon] = ACTIONS(3497),
  },
  [1296] = {
    [sym_dictionary_splat] = STATE(919),
    [sym__expression] = STATE(920),
    [sym__primary_expression] = STATE(96),
    [sym_not_operator] = STATE(920),
    [sym_boolean_operator] = STATE(920),
    [sym_binary_operator] = STATE(96),
    [sym_unary_operator] = STATE(96),
    [sym_comparison_operator] = STATE(920),
    [sym_lambda] = STATE(920),
    [sym_attribute] = STATE(96),
    [sym_subscript] = STATE(96),
    [sym_call] = STATE(96),
    [sym_list] = STATE(96),
    [sym_list_comprehension] = STATE(96),
    [sym_dictionary] = STATE(96),
    [sym_dictionary_comprehension] = STATE(96),
    [sym_pair] = STATE(919),
    [sym_set] = STATE(96),
    [sym_set_comprehension] = STATE(96),
    [sym_parenthesized_expression] = STATE(96),
    [sym_tuple] = STATE(96),
    [sym_generator_expression] = STATE(96),
    [sym_conditional_expression] = STATE(920),
    [sym_concatenated_string] = STATE(96),
    [sym_await] = STATE(920),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_STAR] = ACTIONS(1802),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_not] = ACTIONS(160),
    [anon_sym_PLUS] = ACTIONS(162),
    [anon_sym_DASH] = ACTIONS(162),
    [anon_sym_TILDE] = ACTIONS(162),
    [anon_sym_lambda] = ACTIONS(164),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(166),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(168),
    [sym_integer] = ACTIONS(170),
    [sym_float] = ACTIONS(170),
    [sym_identifier] = ACTIONS(170),
    [sym_true] = ACTIONS(170),
    [sym_false] = ACTIONS(170),
    [sym_none] = ACTIONS(170),
    [anon_sym_await] = ACTIONS(172),
    [sym_comment] = ACTIONS(72),
  },
  [1297] = {
    [sym__expression] = STATE(1585),
    [sym__primary_expression] = STATE(157),
    [sym_not_operator] = STATE(1585),
    [sym_boolean_operator] = STATE(1585),
    [sym_binary_operator] = STATE(157),
    [sym_unary_operator] = STATE(157),
    [sym_comparison_operator] = STATE(1585),
    [sym_lambda] = STATE(1585),
    [sym_attribute] = STATE(157),
    [sym_subscript] = STATE(157),
    [sym_call] = STATE(157),
    [sym_list] = STATE(157),
    [sym_list_comprehension] = STATE(157),
    [sym_dictionary] = STATE(157),
    [sym_dictionary_comprehension] = STATE(157),
    [sym_set] = STATE(157),
    [sym_set_comprehension] = STATE(157),
    [sym_parenthesized_expression] = STATE(157),
    [sym_tuple] = STATE(157),
    [sym_generator_expression] = STATE(157),
    [sym_conditional_expression] = STATE(1585),
    [sym_concatenated_string] = STATE(157),
    [sym_await] = STATE(1585),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_not] = ACTIONS(260),
    [anon_sym_PLUS] = ACTIONS(262),
    [anon_sym_DASH] = ACTIONS(262),
    [anon_sym_TILDE] = ACTIONS(262),
    [anon_sym_lambda] = ACTIONS(264),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(266),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(270),
    [sym_integer] = ACTIONS(272),
    [sym_float] = ACTIONS(272),
    [sym_identifier] = ACTIONS(272),
    [sym_true] = ACTIONS(272),
    [sym_false] = ACTIONS(272),
    [sym_none] = ACTIONS(272),
    [anon_sym_await] = ACTIONS(274),
    [sym_comment] = ACTIONS(72),
  },
  [1298] = {
    [anon_sym_COMMA] = ACTIONS(716),
    [anon_sym_if] = ACTIONS(716),
    [anon_sym_async] = ACTIONS(716),
    [anon_sym_for] = ACTIONS(716),
    [anon_sym_and] = ACTIONS(2803),
    [anon_sym_or] = ACTIONS(2805),
    [anon_sym_RBRACE] = ACTIONS(716),
    [sym_comment] = ACTIONS(72),
  },
  [1299] = {
    [sym__expression] = STATE(1586),
    [sym__primary_expression] = STATE(930),
    [sym_not_operator] = STATE(1586),
    [sym_boolean_operator] = STATE(1586),
    [sym_binary_operator] = STATE(930),
    [sym_unary_operator] = STATE(930),
    [sym_comparison_operator] = STATE(1586),
    [sym_lambda] = STATE(1586),
    [sym_attribute] = STATE(930),
    [sym_subscript] = STATE(930),
    [sym_call] = STATE(930),
    [sym_list] = STATE(930),
    [sym_list_comprehension] = STATE(930),
    [sym_dictionary] = STATE(930),
    [sym_dictionary_comprehension] = STATE(930),
    [sym_set] = STATE(930),
    [sym_set_comprehension] = STATE(930),
    [sym_parenthesized_expression] = STATE(930),
    [sym_tuple] = STATE(930),
    [sym_generator_expression] = STATE(930),
    [sym_conditional_expression] = STATE(1586),
    [sym_concatenated_string] = STATE(930),
    [sym_await] = STATE(1586),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_not] = ACTIONS(1808),
    [anon_sym_PLUS] = ACTIONS(1810),
    [anon_sym_DASH] = ACTIONS(1810),
    [anon_sym_TILDE] = ACTIONS(1810),
    [anon_sym_lambda] = ACTIONS(1812),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(1814),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(1816),
    [sym_integer] = ACTIONS(1818),
    [sym_float] = ACTIONS(1818),
    [sym_identifier] = ACTIONS(1818),
    [sym_true] = ACTIONS(1818),
    [sym_false] = ACTIONS(1818),
    [sym_none] = ACTIONS(1818),
    [anon_sym_await] = ACTIONS(1820),
    [sym_comment] = ACTIONS(72),
  },
  [1300] = {
    [anon_sym_COLON] = ACTIONS(3501),
    [sym_comment] = ACTIONS(72),
  },
  [1301] = {
    [aux_sym_concatenated_string_repeat1] = STATE(1588),
    [anon_sym_DOT] = ACTIONS(886),
    [anon_sym_LPAREN] = ACTIONS(886),
    [anon_sym_COMMA] = ACTIONS(886),
    [anon_sym_STAR] = ACTIONS(888),
    [anon_sym_GT_GT] = ACTIONS(886),
    [anon_sym_if] = ACTIONS(886),
    [anon_sym_async] = ACTIONS(886),
    [anon_sym_for] = ACTIONS(886),
    [anon_sym_in] = ACTIONS(886),
    [anon_sym_AT] = ACTIONS(886),
    [anon_sym_not] = ACTIONS(886),
    [anon_sym_and] = ACTIONS(886),
    [anon_sym_or] = ACTIONS(886),
    [anon_sym_PLUS] = ACTIONS(886),
    [anon_sym_DASH] = ACTIONS(886),
    [anon_sym_SLASH] = ACTIONS(888),
    [anon_sym_PERCENT] = ACTIONS(886),
    [anon_sym_SLASH_SLASH] = ACTIONS(886),
    [anon_sym_STAR_STAR] = ACTIONS(886),
    [anon_sym_PIPE] = ACTIONS(886),
    [anon_sym_AMP] = ACTIONS(886),
    [anon_sym_CARET] = ACTIONS(886),
    [anon_sym_LT_LT] = ACTIONS(886),
    [anon_sym_LT] = ACTIONS(888),
    [anon_sym_LT_EQ] = ACTIONS(886),
    [anon_sym_EQ_EQ] = ACTIONS(886),
    [anon_sym_BANG_EQ] = ACTIONS(886),
    [anon_sym_GT_EQ] = ACTIONS(886),
    [anon_sym_GT] = ACTIONS(888),
    [anon_sym_LT_GT] = ACTIONS(886),
    [anon_sym_is] = ACTIONS(886),
    [anon_sym_LBRACK] = ACTIONS(886),
    [anon_sym_RBRACE] = ACTIONS(886),
    [sym_string] = ACTIONS(3503),
    [sym_comment] = ACTIONS(72),
  },
  [1302] = {
    [sym__expression] = STATE(1589),
    [sym__primary_expression] = STATE(513),
    [sym_not_operator] = STATE(1589),
    [sym_boolean_operator] = STATE(1589),
    [sym_binary_operator] = STATE(513),
    [sym_unary_operator] = STATE(513),
    [sym_comparison_operator] = STATE(1589),
    [sym_lambda] = STATE(1589),
    [sym_attribute] = STATE(513),
    [sym_subscript] = STATE(513),
    [sym_call] = STATE(513),
    [sym_list] = STATE(513),
    [sym_list_comprehension] = STATE(513),
    [sym_dictionary] = STATE(513),
    [sym_dictionary_comprehension] = STATE(513),
    [sym_set] = STATE(513),
    [sym_set_comprehension] = STATE(513),
    [sym_parenthesized_expression] = STATE(513),
    [sym_tuple] = STATE(513),
    [sym_generator_expression] = STATE(513),
    [sym_conditional_expression] = STATE(1589),
    [sym_concatenated_string] = STATE(513),
    [sym_await] = STATE(1589),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_not] = ACTIONS(914),
    [anon_sym_PLUS] = ACTIONS(916),
    [anon_sym_DASH] = ACTIONS(916),
    [anon_sym_TILDE] = ACTIONS(916),
    [anon_sym_lambda] = ACTIONS(918),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(920),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(922),
    [sym_integer] = ACTIONS(924),
    [sym_float] = ACTIONS(924),
    [sym_identifier] = ACTIONS(924),
    [sym_true] = ACTIONS(924),
    [sym_false] = ACTIONS(924),
    [sym_none] = ACTIONS(924),
    [anon_sym_await] = ACTIONS(926),
    [sym_comment] = ACTIONS(72),
  },
  [1303] = {
    [sym__expression] = STATE(604),
    [sym__primary_expression] = STATE(930),
    [sym_not_operator] = STATE(604),
    [sym_boolean_operator] = STATE(604),
    [sym_binary_operator] = STATE(930),
    [sym_unary_operator] = STATE(930),
    [sym_comparison_operator] = STATE(604),
    [sym_lambda] = STATE(604),
    [sym_attribute] = STATE(930),
    [sym_subscript] = STATE(930),
    [sym_call] = STATE(930),
    [sym_list] = STATE(930),
    [sym_list_comprehension] = STATE(930),
    [sym_dictionary] = STATE(930),
    [sym_dictionary_comprehension] = STATE(930),
    [sym_set] = STATE(930),
    [sym_set_comprehension] = STATE(930),
    [sym_parenthesized_expression] = STATE(930),
    [sym_tuple] = STATE(930),
    [sym_generator_expression] = STATE(930),
    [sym_conditional_expression] = STATE(604),
    [sym_concatenated_string] = STATE(930),
    [sym_await] = STATE(604),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_not] = ACTIONS(1808),
    [anon_sym_PLUS] = ACTIONS(1810),
    [anon_sym_DASH] = ACTIONS(1810),
    [anon_sym_TILDE] = ACTIONS(1810),
    [anon_sym_lambda] = ACTIONS(1812),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(1814),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(1816),
    [sym_integer] = ACTIONS(1818),
    [sym_float] = ACTIONS(1818),
    [sym_identifier] = ACTIONS(1818),
    [sym_true] = ACTIONS(1818),
    [sym_false] = ACTIONS(1818),
    [sym_none] = ACTIONS(1818),
    [anon_sym_await] = ACTIONS(1820),
    [sym_comment] = ACTIONS(72),
  },
  [1304] = {
    [sym__expression] = STATE(1590),
    [sym__primary_expression] = STATE(930),
    [sym_not_operator] = STATE(1590),
    [sym_boolean_operator] = STATE(1590),
    [sym_binary_operator] = STATE(930),
    [sym_unary_operator] = STATE(930),
    [sym_comparison_operator] = STATE(1590),
    [sym_lambda] = STATE(1590),
    [sym_attribute] = STATE(930),
    [sym_subscript] = STATE(930),
    [sym_call] = STATE(930),
    [sym_list] = STATE(930),
    [sym_list_comprehension] = STATE(930),
    [sym_dictionary] = STATE(930),
    [sym_dictionary_comprehension] = STATE(930),
    [sym_set] = STATE(930),
    [sym_set_comprehension] = STATE(930),
    [sym_parenthesized_expression] = STATE(930),
    [sym_tuple] = STATE(930),
    [sym_generator_expression] = STATE(930),
    [sym_conditional_expression] = STATE(1590),
    [sym_concatenated_string] = STATE(930),
    [sym_await] = STATE(1590),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_not] = ACTIONS(1808),
    [anon_sym_PLUS] = ACTIONS(1810),
    [anon_sym_DASH] = ACTIONS(1810),
    [anon_sym_TILDE] = ACTIONS(1810),
    [anon_sym_lambda] = ACTIONS(1812),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(1814),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(1816),
    [sym_integer] = ACTIONS(1818),
    [sym_float] = ACTIONS(1818),
    [sym_identifier] = ACTIONS(1818),
    [sym_true] = ACTIONS(1818),
    [sym_false] = ACTIONS(1818),
    [sym_none] = ACTIONS(1818),
    [anon_sym_await] = ACTIONS(1820),
    [sym_comment] = ACTIONS(72),
  },
  [1305] = {
    [sym__primary_expression] = STATE(1591),
    [sym_binary_operator] = STATE(1591),
    [sym_unary_operator] = STATE(1591),
    [sym_attribute] = STATE(1591),
    [sym_subscript] = STATE(1591),
    [sym_call] = STATE(1591),
    [sym_list] = STATE(1591),
    [sym_list_comprehension] = STATE(1591),
    [sym_dictionary] = STATE(1591),
    [sym_dictionary_comprehension] = STATE(1591),
    [sym_set] = STATE(1591),
    [sym_set_comprehension] = STATE(1591),
    [sym_parenthesized_expression] = STATE(1591),
    [sym_tuple] = STATE(1591),
    [sym_generator_expression] = STATE(1591),
    [sym_concatenated_string] = STATE(1591),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_PLUS] = ACTIONS(1810),
    [anon_sym_DASH] = ACTIONS(1810),
    [anon_sym_TILDE] = ACTIONS(1810),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(3505),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(1816),
    [sym_integer] = ACTIONS(3507),
    [sym_float] = ACTIONS(3507),
    [sym_identifier] = ACTIONS(3507),
    [sym_true] = ACTIONS(3507),
    [sym_false] = ACTIONS(3507),
    [sym_none] = ACTIONS(3507),
    [sym_comment] = ACTIONS(72),
  },
  [1306] = {
    [sym__primary_expression] = STATE(1592),
    [sym_binary_operator] = STATE(1592),
    [sym_unary_operator] = STATE(1592),
    [sym_attribute] = STATE(1592),
    [sym_subscript] = STATE(1592),
    [sym_call] = STATE(1592),
    [sym_list] = STATE(1592),
    [sym_list_comprehension] = STATE(1592),
    [sym_dictionary] = STATE(1592),
    [sym_dictionary_comprehension] = STATE(1592),
    [sym_set] = STATE(1592),
    [sym_set_comprehension] = STATE(1592),
    [sym_parenthesized_expression] = STATE(1592),
    [sym_tuple] = STATE(1592),
    [sym_generator_expression] = STATE(1592),
    [sym_concatenated_string] = STATE(1592),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_PLUS] = ACTIONS(1810),
    [anon_sym_DASH] = ACTIONS(1810),
    [anon_sym_TILDE] = ACTIONS(1810),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(3509),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(1816),
    [sym_integer] = ACTIONS(3511),
    [sym_float] = ACTIONS(3511),
    [sym_identifier] = ACTIONS(3511),
    [sym_true] = ACTIONS(3511),
    [sym_false] = ACTIONS(3511),
    [sym_none] = ACTIONS(3511),
    [sym_comment] = ACTIONS(72),
  },
  [1307] = {
    [sym__primary_expression] = STATE(1593),
    [sym_binary_operator] = STATE(1593),
    [sym_unary_operator] = STATE(1593),
    [sym_attribute] = STATE(1593),
    [sym_subscript] = STATE(1593),
    [sym_call] = STATE(1593),
    [sym_list] = STATE(1593),
    [sym_list_comprehension] = STATE(1593),
    [sym_dictionary] = STATE(1593),
    [sym_dictionary_comprehension] = STATE(1593),
    [sym_set] = STATE(1593),
    [sym_set_comprehension] = STATE(1593),
    [sym_parenthesized_expression] = STATE(1593),
    [sym_tuple] = STATE(1593),
    [sym_generator_expression] = STATE(1593),
    [sym_concatenated_string] = STATE(1593),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_PLUS] = ACTIONS(1810),
    [anon_sym_DASH] = ACTIONS(1810),
    [anon_sym_TILDE] = ACTIONS(1810),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(3513),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(1816),
    [sym_integer] = ACTIONS(3515),
    [sym_float] = ACTIONS(3515),
    [sym_identifier] = ACTIONS(3515),
    [sym_true] = ACTIONS(3515),
    [sym_false] = ACTIONS(3515),
    [sym_none] = ACTIONS(3515),
    [sym_comment] = ACTIONS(72),
  },
  [1308] = {
    [anon_sym_in] = ACTIONS(3517),
    [sym_comment] = ACTIONS(72),
  },
  [1309] = {
    [sym__primary_expression] = STATE(1595),
    [sym_binary_operator] = STATE(1595),
    [sym_unary_operator] = STATE(1595),
    [sym_attribute] = STATE(1595),
    [sym_subscript] = STATE(1595),
    [sym_call] = STATE(1595),
    [sym_list] = STATE(1595),
    [sym_list_comprehension] = STATE(1595),
    [sym_dictionary] = STATE(1595),
    [sym_dictionary_comprehension] = STATE(1595),
    [sym_set] = STATE(1595),
    [sym_set_comprehension] = STATE(1595),
    [sym_parenthesized_expression] = STATE(1595),
    [sym_tuple] = STATE(1595),
    [sym_generator_expression] = STATE(1595),
    [sym_concatenated_string] = STATE(1595),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_PLUS] = ACTIONS(1810),
    [anon_sym_DASH] = ACTIONS(1810),
    [anon_sym_TILDE] = ACTIONS(1810),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(3519),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(1816),
    [sym_integer] = ACTIONS(3521),
    [sym_float] = ACTIONS(3521),
    [sym_identifier] = ACTIONS(3521),
    [sym_true] = ACTIONS(3521),
    [sym_false] = ACTIONS(3521),
    [sym_none] = ACTIONS(3521),
    [sym_comment] = ACTIONS(72),
  },
  [1310] = {
    [sym__primary_expression] = STATE(621),
    [sym_binary_operator] = STATE(621),
    [sym_unary_operator] = STATE(621),
    [sym_attribute] = STATE(621),
    [sym_subscript] = STATE(621),
    [sym_call] = STATE(621),
    [sym_list] = STATE(621),
    [sym_list_comprehension] = STATE(621),
    [sym_dictionary] = STATE(621),
    [sym_dictionary_comprehension] = STATE(621),
    [sym_set] = STATE(621),
    [sym_set_comprehension] = STATE(621),
    [sym_parenthesized_expression] = STATE(621),
    [sym_tuple] = STATE(621),
    [sym_generator_expression] = STATE(621),
    [sym_concatenated_string] = STATE(621),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_PLUS] = ACTIONS(1810),
    [anon_sym_DASH] = ACTIONS(1810),
    [anon_sym_TILDE] = ACTIONS(1810),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(1233),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(1816),
    [sym_integer] = ACTIONS(1235),
    [sym_float] = ACTIONS(1235),
    [sym_identifier] = ACTIONS(1235),
    [sym_true] = ACTIONS(1235),
    [sym_false] = ACTIONS(1235),
    [sym_none] = ACTIONS(1235),
    [sym_comment] = ACTIONS(72),
  },
  [1311] = {
    [sym__primary_expression] = STATE(1596),
    [sym_binary_operator] = STATE(1596),
    [sym_unary_operator] = STATE(1596),
    [sym_attribute] = STATE(1596),
    [sym_subscript] = STATE(1596),
    [sym_call] = STATE(1596),
    [sym_list] = STATE(1596),
    [sym_list_comprehension] = STATE(1596),
    [sym_dictionary] = STATE(1596),
    [sym_dictionary_comprehension] = STATE(1596),
    [sym_set] = STATE(1596),
    [sym_set_comprehension] = STATE(1596),
    [sym_parenthesized_expression] = STATE(1596),
    [sym_tuple] = STATE(1596),
    [sym_generator_expression] = STATE(1596),
    [sym_concatenated_string] = STATE(1596),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_PLUS] = ACTIONS(1810),
    [anon_sym_DASH] = ACTIONS(1810),
    [anon_sym_TILDE] = ACTIONS(1810),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(3523),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(1816),
    [sym_integer] = ACTIONS(3525),
    [sym_float] = ACTIONS(3525),
    [sym_identifier] = ACTIONS(3525),
    [sym_true] = ACTIONS(3525),
    [sym_false] = ACTIONS(3525),
    [sym_none] = ACTIONS(3525),
    [sym_comment] = ACTIONS(72),
  },
  [1312] = {
    [sym__primary_expression] = STATE(1597),
    [sym_binary_operator] = STATE(1597),
    [sym_unary_operator] = STATE(1597),
    [sym_attribute] = STATE(1597),
    [sym_subscript] = STATE(1597),
    [sym_call] = STATE(1597),
    [sym_list] = STATE(1597),
    [sym_list_comprehension] = STATE(1597),
    [sym_dictionary] = STATE(1597),
    [sym_dictionary_comprehension] = STATE(1597),
    [sym_set] = STATE(1597),
    [sym_set_comprehension] = STATE(1597),
    [sym_parenthesized_expression] = STATE(1597),
    [sym_tuple] = STATE(1597),
    [sym_generator_expression] = STATE(1597),
    [sym_concatenated_string] = STATE(1597),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_PLUS] = ACTIONS(1810),
    [anon_sym_DASH] = ACTIONS(1810),
    [anon_sym_TILDE] = ACTIONS(1810),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(3527),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(1816),
    [sym_integer] = ACTIONS(3529),
    [sym_float] = ACTIONS(3529),
    [sym_identifier] = ACTIONS(3529),
    [sym_true] = ACTIONS(3529),
    [sym_false] = ACTIONS(3529),
    [sym_none] = ACTIONS(3529),
    [sym_comment] = ACTIONS(72),
  },
  [1313] = {
    [sym__primary_expression] = STATE(1598),
    [sym_binary_operator] = STATE(1598),
    [sym_unary_operator] = STATE(1598),
    [sym_attribute] = STATE(1598),
    [sym_subscript] = STATE(1598),
    [sym_call] = STATE(1598),
    [sym_list] = STATE(1598),
    [sym_list_comprehension] = STATE(1598),
    [sym_dictionary] = STATE(1598),
    [sym_dictionary_comprehension] = STATE(1598),
    [sym_set] = STATE(1598),
    [sym_set_comprehension] = STATE(1598),
    [sym_parenthesized_expression] = STATE(1598),
    [sym_tuple] = STATE(1598),
    [sym_generator_expression] = STATE(1598),
    [sym_concatenated_string] = STATE(1598),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_PLUS] = ACTIONS(1810),
    [anon_sym_DASH] = ACTIONS(1810),
    [anon_sym_TILDE] = ACTIONS(1810),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(3531),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(1816),
    [sym_integer] = ACTIONS(3533),
    [sym_float] = ACTIONS(3533),
    [sym_identifier] = ACTIONS(3533),
    [sym_true] = ACTIONS(3533),
    [sym_false] = ACTIONS(3533),
    [sym_none] = ACTIONS(3533),
    [sym_comment] = ACTIONS(72),
  },
  [1314] = {
    [sym__primary_expression] = STATE(1593),
    [sym_binary_operator] = STATE(1593),
    [sym_unary_operator] = STATE(1593),
    [sym_attribute] = STATE(1593),
    [sym_subscript] = STATE(1593),
    [sym_call] = STATE(1593),
    [sym_list] = STATE(1593),
    [sym_list_comprehension] = STATE(1593),
    [sym_dictionary] = STATE(1593),
    [sym_dictionary_comprehension] = STATE(1593),
    [sym_set] = STATE(1593),
    [sym_set_comprehension] = STATE(1593),
    [sym_parenthesized_expression] = STATE(1593),
    [sym_tuple] = STATE(1593),
    [sym_generator_expression] = STATE(1593),
    [sym_concatenated_string] = STATE(1593),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_not] = ACTIONS(3535),
    [anon_sym_PLUS] = ACTIONS(1810),
    [anon_sym_DASH] = ACTIONS(1810),
    [anon_sym_TILDE] = ACTIONS(1810),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(3513),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(1816),
    [sym_integer] = ACTIONS(3515),
    [sym_float] = ACTIONS(3515),
    [sym_identifier] = ACTIONS(3515),
    [sym_true] = ACTIONS(3515),
    [sym_false] = ACTIONS(3515),
    [sym_none] = ACTIONS(3515),
    [sym_comment] = ACTIONS(72),
  },
  [1315] = {
    [aux_sym_comparison_operator_repeat1] = STATE(1599),
    [anon_sym_COMMA] = ACTIONS(998),
    [anon_sym_if] = ACTIONS(998),
    [anon_sym_async] = ACTIONS(998),
    [anon_sym_for] = ACTIONS(998),
    [anon_sym_in] = ACTIONS(2811),
    [anon_sym_not] = ACTIONS(2815),
    [anon_sym_and] = ACTIONS(998),
    [anon_sym_or] = ACTIONS(998),
    [anon_sym_LT] = ACTIONS(2827),
    [anon_sym_LT_EQ] = ACTIONS(2811),
    [anon_sym_EQ_EQ] = ACTIONS(2811),
    [anon_sym_BANG_EQ] = ACTIONS(2811),
    [anon_sym_GT_EQ] = ACTIONS(2811),
    [anon_sym_GT] = ACTIONS(2827),
    [anon_sym_LT_GT] = ACTIONS(2811),
    [anon_sym_is] = ACTIONS(2829),
    [anon_sym_RBRACE] = ACTIONS(998),
    [sym_comment] = ACTIONS(72),
  },
  [1316] = {
    [anon_sym_in] = ACTIONS(3537),
    [sym_comment] = ACTIONS(72),
  },
  [1317] = {
    [sym__expression_within_for_in_clause] = STATE(1602),
    [sym__expression] = STATE(1603),
    [sym__primary_expression] = STATE(930),
    [sym_not_operator] = STATE(1603),
    [sym_boolean_operator] = STATE(1603),
    [sym_binary_operator] = STATE(930),
    [sym_unary_operator] = STATE(930),
    [sym_comparison_operator] = STATE(1603),
    [sym_lambda] = STATE(1603),
    [sym_lambda_within_for_in_clause] = STATE(1406),
    [sym_attribute] = STATE(930),
    [sym_subscript] = STATE(930),
    [sym_call] = STATE(930),
    [sym_list] = STATE(930),
    [sym_list_comprehension] = STATE(930),
    [sym_dictionary] = STATE(930),
    [sym_dictionary_comprehension] = STATE(930),
    [sym_set] = STATE(930),
    [sym_set_comprehension] = STATE(930),
    [sym_parenthesized_expression] = STATE(930),
    [sym_tuple] = STATE(930),
    [sym_generator_expression] = STATE(930),
    [sym_conditional_expression] = STATE(1603),
    [sym_concatenated_string] = STATE(930),
    [sym_await] = STATE(1603),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_not] = ACTIONS(1808),
    [anon_sym_PLUS] = ACTIONS(1810),
    [anon_sym_DASH] = ACTIONS(1810),
    [anon_sym_TILDE] = ACTIONS(1810),
    [anon_sym_lambda] = ACTIONS(3539),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(1814),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(1816),
    [sym_integer] = ACTIONS(1818),
    [sym_float] = ACTIONS(1818),
    [sym_identifier] = ACTIONS(1818),
    [sym_true] = ACTIONS(1818),
    [sym_false] = ACTIONS(1818),
    [sym_none] = ACTIONS(1818),
    [anon_sym_await] = ACTIONS(1820),
    [sym_comment] = ACTIONS(72),
  },
  [1318] = {
    [sym__expression] = STATE(1604),
    [sym__primary_expression] = STATE(1324),
    [sym_not_operator] = STATE(1604),
    [sym_boolean_operator] = STATE(1604),
    [sym_binary_operator] = STATE(1324),
    [sym_unary_operator] = STATE(1324),
    [sym_comparison_operator] = STATE(1604),
    [sym_lambda] = STATE(1604),
    [sym_attribute] = STATE(1324),
    [sym_subscript] = STATE(1324),
    [sym_call] = STATE(1324),
    [sym_list] = STATE(1324),
    [sym_list_comprehension] = STATE(1324),
    [sym_dictionary] = STATE(1324),
    [sym_dictionary_comprehension] = STATE(1324),
    [sym_set] = STATE(1324),
    [sym_set_comprehension] = STATE(1324),
    [sym_parenthesized_expression] = STATE(1324),
    [sym_tuple] = STATE(1324),
    [sym_generator_expression] = STATE(1324),
    [sym_conditional_expression] = STATE(1604),
    [sym_concatenated_string] = STATE(1324),
    [sym_await] = STATE(1604),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_not] = ACTIONS(2837),
    [anon_sym_PLUS] = ACTIONS(2839),
    [anon_sym_DASH] = ACTIONS(2839),
    [anon_sym_TILDE] = ACTIONS(2839),
    [anon_sym_lambda] = ACTIONS(2841),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(2843),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(2845),
    [sym_integer] = ACTIONS(2847),
    [sym_float] = ACTIONS(2847),
    [sym_identifier] = ACTIONS(2847),
    [sym_true] = ACTIONS(2847),
    [sym_false] = ACTIONS(2847),
    [sym_none] = ACTIONS(2847),
    [anon_sym_await] = ACTIONS(2849),
    [sym_comment] = ACTIONS(72),
  },
  [1319] = {
    [sym__primary_expression] = STATE(204),
    [sym_binary_operator] = STATE(204),
    [sym_unary_operator] = STATE(204),
    [sym_attribute] = STATE(204),
    [sym_subscript] = STATE(204),
    [sym_call] = STATE(204),
    [sym_list] = STATE(204),
    [sym_list_comprehension] = STATE(204),
    [sym_dictionary] = STATE(204),
    [sym_dictionary_comprehension] = STATE(204),
    [sym_set] = STATE(204),
    [sym_set_comprehension] = STATE(204),
    [sym_parenthesized_expression] = STATE(204),
    [sym_tuple] = STATE(204),
    [sym_generator_expression] = STATE(204),
    [sym_concatenated_string] = STATE(204),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_PLUS] = ACTIONS(2839),
    [anon_sym_DASH] = ACTIONS(2839),
    [anon_sym_TILDE] = ACTIONS(2839),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(376),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(2845),
    [sym_integer] = ACTIONS(378),
    [sym_float] = ACTIONS(378),
    [sym_identifier] = ACTIONS(378),
    [sym_true] = ACTIONS(378),
    [sym_false] = ACTIONS(378),
    [sym_none] = ACTIONS(378),
    [sym_comment] = ACTIONS(72),
  },
  [1320] = {
    [sym_lambda_parameters] = STATE(1606),
    [sym__parameters] = STATE(130),
    [sym_default_parameter] = STATE(131),
    [sym_typed_default_parameter] = STATE(131),
    [sym_list_splat] = STATE(132),
    [sym_dictionary_splat] = STATE(132),
    [sym_typed_parameter] = STATE(131),
    [sym_tuple] = STATE(131),
    [anon_sym_LPAREN] = ACTIONS(222),
    [anon_sym_STAR] = ACTIONS(224),
    [anon_sym_print] = ACTIONS(226),
    [anon_sym_COLON] = ACTIONS(3541),
    [anon_sym_exec] = ACTIONS(226),
    [sym_identifier] = ACTIONS(230),
    [sym_comment] = ACTIONS(72),
  },
  [1321] = {
    [aux_sym_concatenated_string_repeat1] = STATE(1607),
    [anon_sym_DOT] = ACTIONS(276),
    [anon_sym_LPAREN] = ACTIONS(276),
    [anon_sym_STAR] = ACTIONS(278),
    [anon_sym_GT_GT] = ACTIONS(276),
    [anon_sym_if] = ACTIONS(276),
    [anon_sym_async] = ACTIONS(276),
    [anon_sym_for] = ACTIONS(276),
    [anon_sym_in] = ACTIONS(276),
    [anon_sym_AT] = ACTIONS(276),
    [anon_sym_not] = ACTIONS(276),
    [anon_sym_and] = ACTIONS(276),
    [anon_sym_or] = ACTIONS(276),
    [anon_sym_PLUS] = ACTIONS(276),
    [anon_sym_DASH] = ACTIONS(276),
    [anon_sym_SLASH] = ACTIONS(278),
    [anon_sym_PERCENT] = ACTIONS(276),
    [anon_sym_SLASH_SLASH] = ACTIONS(276),
    [anon_sym_STAR_STAR] = ACTIONS(276),
    [anon_sym_PIPE] = ACTIONS(276),
    [anon_sym_AMP] = ACTIONS(276),
    [anon_sym_CARET] = ACTIONS(276),
    [anon_sym_LT_LT] = ACTIONS(276),
    [anon_sym_LT] = ACTIONS(278),
    [anon_sym_LT_EQ] = ACTIONS(276),
    [anon_sym_EQ_EQ] = ACTIONS(276),
    [anon_sym_BANG_EQ] = ACTIONS(276),
    [anon_sym_GT_EQ] = ACTIONS(276),
    [anon_sym_GT] = ACTIONS(278),
    [anon_sym_LT_GT] = ACTIONS(276),
    [anon_sym_is] = ACTIONS(276),
    [anon_sym_LBRACK] = ACTIONS(276),
    [anon_sym_RBRACE] = ACTIONS(276),
    [sym_string] = ACTIONS(3543),
    [sym_comment] = ACTIONS(72),
  },
  [1322] = {
    [sym__expression] = STATE(227),
    [sym__primary_expression] = STATE(1324),
    [sym_not_operator] = STATE(227),
    [sym_boolean_operator] = STATE(227),
    [sym_binary_operator] = STATE(1324),
    [sym_unary_operator] = STATE(1324),
    [sym_comparison_operator] = STATE(227),
    [sym_lambda] = STATE(227),
    [sym_attribute] = STATE(1324),
    [sym_subscript] = STATE(1324),
    [sym_call] = STATE(1324),
    [sym_list] = STATE(1324),
    [sym_list_comprehension] = STATE(1324),
    [sym_dictionary] = STATE(1324),
    [sym_dictionary_comprehension] = STATE(1324),
    [sym_set] = STATE(1324),
    [sym_set_comprehension] = STATE(1324),
    [sym_parenthesized_expression] = STATE(1324),
    [sym_tuple] = STATE(1324),
    [sym_generator_expression] = STATE(1324),
    [sym_conditional_expression] = STATE(227),
    [sym_concatenated_string] = STATE(1324),
    [sym_await] = STATE(227),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_not] = ACTIONS(2837),
    [anon_sym_PLUS] = ACTIONS(2839),
    [anon_sym_DASH] = ACTIONS(2839),
    [anon_sym_TILDE] = ACTIONS(2839),
    [anon_sym_lambda] = ACTIONS(2841),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(2843),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(2845),
    [sym_integer] = ACTIONS(2847),
    [sym_float] = ACTIONS(2847),
    [sym_identifier] = ACTIONS(2847),
    [sym_true] = ACTIONS(2847),
    [sym_false] = ACTIONS(2847),
    [sym_none] = ACTIONS(2847),
    [anon_sym_await] = ACTIONS(2849),
    [sym_comment] = ACTIONS(72),
  },
  [1323] = {
    [anon_sym_if] = ACTIONS(3051),
    [anon_sym_async] = ACTIONS(3051),
    [anon_sym_for] = ACTIONS(3051),
    [anon_sym_and] = ACTIONS(3545),
    [anon_sym_or] = ACTIONS(3547),
    [anon_sym_RBRACE] = ACTIONS(3051),
    [sym_comment] = ACTIONS(72),
  },
  [1324] = {
    [sym_argument_list] = STATE(251),
    [sym_generator_expression] = STATE(251),
    [aux_sym_comparison_operator_repeat1] = STATE(1621),
    [anon_sym_DOT] = ACTIONS(422),
    [anon_sym_LPAREN] = ACTIONS(424),
    [anon_sym_STAR] = ACTIONS(3549),
    [anon_sym_GT_GT] = ACTIONS(3551),
    [anon_sym_if] = ACTIONS(302),
    [anon_sym_async] = ACTIONS(302),
    [anon_sym_for] = ACTIONS(302),
    [anon_sym_in] = ACTIONS(3553),
    [anon_sym_AT] = ACTIONS(3555),
    [anon_sym_not] = ACTIONS(3557),
    [anon_sym_and] = ACTIONS(302),
    [anon_sym_or] = ACTIONS(302),
    [anon_sym_PLUS] = ACTIONS(3559),
    [anon_sym_DASH] = ACTIONS(3559),
    [anon_sym_SLASH] = ACTIONS(3549),
    [anon_sym_PERCENT] = ACTIONS(3555),
    [anon_sym_SLASH_SLASH] = ACTIONS(3555),
    [anon_sym_STAR_STAR] = ACTIONS(3561),
    [anon_sym_PIPE] = ACTIONS(3563),
    [anon_sym_AMP] = ACTIONS(3565),
    [anon_sym_CARET] = ACTIONS(3567),
    [anon_sym_LT_LT] = ACTIONS(3551),
    [anon_sym_LT] = ACTIONS(3569),
    [anon_sym_LT_EQ] = ACTIONS(3553),
    [anon_sym_EQ_EQ] = ACTIONS(3553),
    [anon_sym_BANG_EQ] = ACTIONS(3553),
    [anon_sym_GT_EQ] = ACTIONS(3553),
    [anon_sym_GT] = ACTIONS(3569),
    [anon_sym_LT_GT] = ACTIONS(3553),
    [anon_sym_is] = ACTIONS(3571),
    [anon_sym_LBRACK] = ACTIONS(450),
    [anon_sym_RBRACE] = ACTIONS(302),
    [sym_comment] = ACTIONS(72),
  },
  [1325] = {
    [sym_for_in_clause] = STATE(1325),
    [sym_if_clause] = STATE(1325),
    [aux_sym__comprehension_body_repeat1] = STATE(1325),
    [anon_sym_if] = ACTIONS(3573),
    [anon_sym_async] = ACTIONS(3576),
    [anon_sym_for] = ACTIONS(3579),
    [anon_sym_RBRACE] = ACTIONS(3081),
    [sym_comment] = ACTIONS(72),
  },
  [1326] = {
    [sym_argument_list] = STATE(251),
    [sym_generator_expression] = STATE(251),
    [anon_sym_DOT] = ACTIONS(422),
    [anon_sym_LPAREN] = ACTIONS(424),
    [anon_sym_COMMA] = ACTIONS(2953),
    [anon_sym_STAR] = ACTIONS(862),
    [anon_sym_GT_GT] = ACTIONS(864),
    [anon_sym_if] = ACTIONS(2953),
    [anon_sym_COLON] = ACTIONS(2953),
    [anon_sym_async] = ACTIONS(2953),
    [anon_sym_for] = ACTIONS(2953),
    [anon_sym_in] = ACTIONS(2953),
    [anon_sym_AT] = ACTIONS(868),
    [anon_sym_not] = ACTIONS(2953),
    [anon_sym_and] = ACTIONS(2953),
    [anon_sym_or] = ACTIONS(2953),
    [anon_sym_PLUS] = ACTIONS(872),
    [anon_sym_DASH] = ACTIONS(872),
    [anon_sym_SLASH] = ACTIONS(862),
    [anon_sym_PERCENT] = ACTIONS(868),
    [anon_sym_SLASH_SLASH] = ACTIONS(868),
    [anon_sym_STAR_STAR] = ACTIONS(874),
    [anon_sym_PIPE] = ACTIONS(876),
    [anon_sym_AMP] = ACTIONS(878),
    [anon_sym_CARET] = ACTIONS(880),
    [anon_sym_LT_LT] = ACTIONS(864),
    [anon_sym_LT] = ACTIONS(2955),
    [anon_sym_LT_EQ] = ACTIONS(2953),
    [anon_sym_EQ_EQ] = ACTIONS(2953),
    [anon_sym_BANG_EQ] = ACTIONS(2953),
    [anon_sym_GT_EQ] = ACTIONS(2953),
    [anon_sym_GT] = ACTIONS(2955),
    [anon_sym_LT_GT] = ACTIONS(2953),
    [anon_sym_is] = ACTIONS(2953),
    [anon_sym_LBRACK] = ACTIONS(450),
    [anon_sym_RBRACE] = ACTIONS(2953),
    [sym_comment] = ACTIONS(72),
  },
  [1327] = {
    [sym__newline] = ACTIONS(1644),
    [anon_sym_if] = ACTIONS(1875),
    [anon_sym_EQ] = ACTIONS(1644),
    [anon_sym_and] = ACTIONS(1877),
    [anon_sym_or] = ACTIONS(1879),
    [sym_comment] = ACTIONS(72),
    [sym__semicolon] = ACTIONS(1644),
  },
  [1328] = {
    [sym__expression] = STATE(1622),
    [sym__primary_expression] = STATE(500),
    [sym_not_operator] = STATE(1622),
    [sym_boolean_operator] = STATE(1622),
    [sym_binary_operator] = STATE(500),
    [sym_unary_operator] = STATE(500),
    [sym_comparison_operator] = STATE(1622),
    [sym_lambda] = STATE(1622),
    [sym_attribute] = STATE(500),
    [sym_subscript] = STATE(500),
    [sym_call] = STATE(500),
    [sym_list] = STATE(500),
    [sym_list_comprehension] = STATE(500),
    [sym_dictionary] = STATE(500),
    [sym_dictionary_comprehension] = STATE(500),
    [sym_set] = STATE(500),
    [sym_set_comprehension] = STATE(500),
    [sym_parenthesized_expression] = STATE(500),
    [sym_tuple] = STATE(500),
    [sym_generator_expression] = STATE(500),
    [sym_conditional_expression] = STATE(1622),
    [sym_concatenated_string] = STATE(500),
    [sym_await] = STATE(1622),
    [anon_sym_LPAREN] = ACTIONS(130),
    [anon_sym_print] = ACTIONS(112),
    [anon_sym_exec] = ACTIONS(112),
    [anon_sym_not] = ACTIONS(894),
    [anon_sym_PLUS] = ACTIONS(896),
    [anon_sym_DASH] = ACTIONS(896),
    [anon_sym_TILDE] = ACTIONS(896),
    [anon_sym_lambda] = ACTIONS(898),
    [anon_sym_LBRACK] = ACTIONS(134),
    [sym_ellipsis] = ACTIONS(900),
    [anon_sym_LBRACE] = ACTIONS(122),
    [sym_string] = ACTIONS(902),
    [sym_integer] = ACTIONS(904),
    [sym_float] = ACTIONS(904),
    [sym_identifier] = ACTIONS(904),
    [sym_true] = ACTIONS(904),
    [sym_false] = ACTIONS(904),
    [sym_none] = ACTIONS(904),
    [anon_sym_await] = ACTIONS(906),
    [sym_comment] = ACTIONS(72),
  },
  [1329] = {
    [aux_sym_concatenated_string_repeat1] = STATE(1329),
    [sym__newline] = ACTIONS(1862),
    [anon_sym_DOT] = ACTIONS(1862),
    [anon_sym_LPAREN] = ACTIONS(1862),
    [anon_sym_STAR] = ACTIONS(1864),
    [anon_sym_GT_GT] = ACTIONS(1862),
    [anon_sym_if] = ACTIONS(1862),
    [anon_sym_in] = ACTIONS(1862),
    [anon_sym_EQ] = ACTIONS(1864),
    [anon_sym_AT] = ACTIONS(1862),
    [anon_sym_not] = ACTIONS(1862),
    [anon_sym_and] = ACTIONS(1862),
    [anon_sym_or] = ACTIONS(1862),
    [anon_sym_PLUS] = ACTIONS(1862),
    [anon_sym_DASH] = ACTIONS(1862),
    [anon_sym_SLASH] = ACTIONS(1864),
    [anon_sym_PERCENT] = ACTIONS(1862),
    [anon_sym_SLASH_SLASH] = ACTIONS(1862),
    [anon_sym_STAR_STAR] = ACTIONS(1862),
    [anon_sym_PIPE] = ACTIONS(1862),
    [anon_sym_AMP] = ACTIONS(1862),
    [anon_sym_CARET] = ACTIONS(1862),
    [anon_sym_LT_LT] = ACTIONS(1862),
    [anon_sym_LT] = ACTIONS(1864),
    [anon_sym_LT_EQ] = ACTIONS(1862),
    [anon_sym_EQ_EQ] = ACTIONS(1862),
    [anon_sym_BANG_EQ] = ACTIONS(1862),
    [anon_sym_GT_EQ] = ACTIONS(1862),
    [anon_sym_GT] = ACTIONS(1864),
    [anon_sym_LT_GT] = ACTIONS(1862),
    [anon_sym_is] = ACTIONS(1862),
    [anon_sym_LBRACK] = ACTIONS(1862),
    [sym_string] = ACTIONS(3582),
    [sym_comment] = ACTIONS(72),
    [sym__semicolon] = ACTIONS(1862),
  },
  [1330] = {
    [anon_sym_if] = ACTIONS(1921),
    [anon_sym_else] = ACTIONS(3585),
    [anon_sym_and] = ACTIONS(1925),
    [anon_sym_or] = ACTIONS(1927),
    [sym_comment] = ACTIONS(72),
  },
  [1331] = {
    [sym__newline] = ACTIONS(1953),
    [anon_sym_if] = ACTIONS(1953),
    [anon_sym_EQ] = ACTIONS(1953),
    [anon_sym_and] = ACTIONS(1877),
    [anon_sym_or] = ACTIONS(1953),
    [sym_comment] = ACTIONS(72),
    [sym__semicolon] = ACTIONS(1953),
  },
  [1332] = {
    [sym_argument_list] = STATE(291),
    [sym_generator_expression] = STATE(291),
    [sym__newline] = ACTIONS(1980),
    [anon_sym_DOT] = ACTIONS(1980),
    [anon_sym_LPAREN] = ACTIONS(484),
    [anon_sym_STAR] = ACTIONS(1982),
    [anon_sym_GT_GT] = ACTIONS(1980),
    [anon_sym_if] = ACTIONS(1980),
    [anon_sym_in] = ACTIONS(1980),
    [anon_sym_EQ] = ACTIONS(1982),
    [anon_sym_AT] = ACTIONS(1980),
    [anon_sym_not] = ACTIONS(1980),
    [anon_sym_and] = ACTIONS(1980),
    [anon_sym_or] = ACTIONS(1980),
    [anon_sym_PLUS] = ACTIONS(1980),
    [anon_sym_DASH] = ACTIONS(1980),
    [anon_sym_SLASH] = ACTIONS(1982),
    [anon_sym_PERCENT] = ACTIONS(1980),
    [anon_sym_SLASH_SLASH] = ACTIONS(1980),
    [anon_sym_STAR_STAR] = ACTIONS(1893),
    [anon_sym_PIPE] = ACTIONS(1980),
    [anon_sym_AMP] = ACTIONS(1980),
    [anon_sym_CARET] = ACTIONS(1980),
    [anon_sym_LT_LT] = ACTIONS(1980),
    [anon_sym_LT] = ACTIONS(1982),
    [anon_sym_LT_EQ] = ACTIONS(1980),
    [anon_sym_EQ_EQ] = ACTIONS(1980),
    [anon_sym_BANG_EQ] = ACTIONS(1980),
    [anon_sym_GT_EQ] = ACTIONS(1980),
    [anon_sym_GT] = ACTIONS(1982),
    [anon_sym_LT_GT] = ACTIONS(1980),
    [anon_sym_is] = ACTIONS(1980),
    [anon_sym_LBRACK] = ACTIONS(1980),
    [sym_comment] = ACTIONS(72),
    [sym__semicolon] = ACTIONS(1980),
  },
  [1333] = {
    [sym_argument_list] = STATE(291),
    [sym_generator_expression] = STATE(291),
    [sym__newline] = ACTIONS(1980),
    [anon_sym_DOT] = ACTIONS(1980),
    [anon_sym_LPAREN] = ACTIONS(484),
    [anon_sym_STAR] = ACTIONS(1881),
    [anon_sym_GT_GT] = ACTIONS(1980),
    [anon_sym_if] = ACTIONS(1980),
    [anon_sym_in] = ACTIONS(1980),
    [anon_sym_EQ] = ACTIONS(1982),
    [anon_sym_AT] = ACTIONS(1887),
    [anon_sym_not] = ACTIONS(1980),
    [anon_sym_and] = ACTIONS(1980),
    [anon_sym_or] = ACTIONS(1980),
    [anon_sym_PLUS] = ACTIONS(1891),
    [anon_sym_DASH] = ACTIONS(1891),
    [anon_sym_SLASH] = ACTIONS(1881),
    [anon_sym_PERCENT] = ACTIONS(1887),
    [anon_sym_SLASH_SLASH] = ACTIONS(1887),
    [anon_sym_STAR_STAR] = ACTIONS(1893),
    [anon_sym_PIPE] = ACTIONS(1980),
    [anon_sym_AMP] = ACTIONS(1980),
    [anon_sym_CARET] = ACTIONS(1980),
    [anon_sym_LT_LT] = ACTIONS(1980),
    [anon_sym_LT] = ACTIONS(1982),
    [anon_sym_LT_EQ] = ACTIONS(1980),
    [anon_sym_EQ_EQ] = ACTIONS(1980),
    [anon_sym_BANG_EQ] = ACTIONS(1980),
    [anon_sym_GT_EQ] = ACTIONS(1980),
    [anon_sym_GT] = ACTIONS(1982),
    [anon_sym_LT_GT] = ACTIONS(1980),
    [anon_sym_is] = ACTIONS(1980),
    [anon_sym_LBRACK] = ACTIONS(1980),
    [sym_comment] = ACTIONS(72),
    [sym__semicolon] = ACTIONS(1980),
  },
  [1334] = {
    [sym_argument_list] = STATE(291),
    [sym_generator_expression] = STATE(291),
    [sym__newline] = ACTIONS(1984),
    [anon_sym_DOT] = ACTIONS(482),
    [anon_sym_LPAREN] = ACTIONS(484),
    [anon_sym_STAR] = ACTIONS(1881),
    [anon_sym_GT_GT] = ACTIONS(1883),
    [anon_sym_if] = ACTIONS(1984),
    [anon_sym_in] = ACTIONS(1984),
    [anon_sym_EQ] = ACTIONS(1986),
    [anon_sym_AT] = ACTIONS(1887),
    [anon_sym_not] = ACTIONS(1984),
    [anon_sym_and] = ACTIONS(1984),
    [anon_sym_or] = ACTIONS(1984),
    [anon_sym_PLUS] = ACTIONS(1891),
    [anon_sym_DASH] = ACTIONS(1891),
    [anon_sym_SLASH] = ACTIONS(1881),
    [anon_sym_PERCENT] = ACTIONS(1887),
    [anon_sym_SLASH_SLASH] = ACTIONS(1887),
    [anon_sym_STAR_STAR] = ACTIONS(1893),
    [anon_sym_PIPE] = ACTIONS(1895),
    [anon_sym_AMP] = ACTIONS(1897),
    [anon_sym_CARET] = ACTIONS(1899),
    [anon_sym_LT_LT] = ACTIONS(1883),
    [anon_sym_LT] = ACTIONS(1986),
    [anon_sym_LT_EQ] = ACTIONS(1984),
    [anon_sym_EQ_EQ] = ACTIONS(1984),
    [anon_sym_BANG_EQ] = ACTIONS(1984),
    [anon_sym_GT_EQ] = ACTIONS(1984),
    [anon_sym_GT] = ACTIONS(1986),
    [anon_sym_LT_GT] = ACTIONS(1984),
    [anon_sym_is] = ACTIONS(1984),
    [anon_sym_LBRACK] = ACTIONS(510),
    [sym_comment] = ACTIONS(72),
    [sym__semicolon] = ACTIONS(1984),
  },
  [1335] = {
    [sym__primary_expression] = STATE(1624),
    [sym_binary_operator] = STATE(1624),
    [sym_unary_operator] = STATE(1624),
    [sym_attribute] = STATE(1624),
    [sym_subscript] = STATE(1624),
    [sym_call] = STATE(1624),
    [sym_list] = STATE(1624),
    [sym_list_comprehension] = STATE(1624),
    [sym_dictionary] = STATE(1624),
    [sym_dictionary_comprehension] = STATE(1624),
    [sym_set] = STATE(1624),
    [sym_set_comprehension] = STATE(1624),
    [sym_parenthesized_expression] = STATE(1624),
    [sym_tuple] = STATE(1624),
    [sym_generator_expression] = STATE(1624),
    [sym_concatenated_string] = STATE(1624),
    [anon_sym_LPAREN] = ACTIONS(130),
    [anon_sym_print] = ACTIONS(112),
    [anon_sym_exec] = ACTIONS(112),
    [anon_sym_PLUS] = ACTIONS(896),
    [anon_sym_DASH] = ACTIONS(896),
    [anon_sym_TILDE] = ACTIONS(896),
    [anon_sym_LBRACK] = ACTIONS(134),
    [sym_ellipsis] = ACTIONS(3587),
    [anon_sym_LBRACE] = ACTIONS(122),
    [sym_string] = ACTIONS(902),
    [sym_integer] = ACTIONS(3589),
    [sym_float] = ACTIONS(3589),
    [sym_identifier] = ACTIONS(3589),
    [sym_true] = ACTIONS(3589),
    [sym_false] = ACTIONS(3589),
    [sym_none] = ACTIONS(3589),
    [sym_comment] = ACTIONS(72),
  },
  [1336] = {
    [sym_argument_list] = STATE(291),
    [sym_generator_expression] = STATE(291),
    [sym__newline] = ACTIONS(1980),
    [anon_sym_DOT] = ACTIONS(1980),
    [anon_sym_LPAREN] = ACTIONS(484),
    [anon_sym_STAR] = ACTIONS(1881),
    [anon_sym_GT_GT] = ACTIONS(1980),
    [anon_sym_if] = ACTIONS(1980),
    [anon_sym_in] = ACTIONS(1980),
    [anon_sym_EQ] = ACTIONS(1982),
    [anon_sym_AT] = ACTIONS(1887),
    [anon_sym_not] = ACTIONS(1980),
    [anon_sym_and] = ACTIONS(1980),
    [anon_sym_or] = ACTIONS(1980),
    [anon_sym_PLUS] = ACTIONS(1980),
    [anon_sym_DASH] = ACTIONS(1980),
    [anon_sym_SLASH] = ACTIONS(1881),
    [anon_sym_PERCENT] = ACTIONS(1887),
    [anon_sym_SLASH_SLASH] = ACTIONS(1887),
    [anon_sym_STAR_STAR] = ACTIONS(1893),
    [anon_sym_PIPE] = ACTIONS(1980),
    [anon_sym_AMP] = ACTIONS(1980),
    [anon_sym_CARET] = ACTIONS(1980),
    [anon_sym_LT_LT] = ACTIONS(1980),
    [anon_sym_LT] = ACTIONS(1982),
    [anon_sym_LT_EQ] = ACTIONS(1980),
    [anon_sym_EQ_EQ] = ACTIONS(1980),
    [anon_sym_BANG_EQ] = ACTIONS(1980),
    [anon_sym_GT_EQ] = ACTIONS(1980),
    [anon_sym_GT] = ACTIONS(1982),
    [anon_sym_LT_GT] = ACTIONS(1980),
    [anon_sym_is] = ACTIONS(1980),
    [anon_sym_LBRACK] = ACTIONS(1980),
    [sym_comment] = ACTIONS(72),
    [sym__semicolon] = ACTIONS(1980),
  },
  [1337] = {
    [sym_argument_list] = STATE(291),
    [sym_generator_expression] = STATE(291),
    [sym__newline] = ACTIONS(1980),
    [anon_sym_DOT] = ACTIONS(1980),
    [anon_sym_LPAREN] = ACTIONS(484),
    [anon_sym_STAR] = ACTIONS(1881),
    [anon_sym_GT_GT] = ACTIONS(1883),
    [anon_sym_if] = ACTIONS(1980),
    [anon_sym_in] = ACTIONS(1980),
    [anon_sym_EQ] = ACTIONS(1982),
    [anon_sym_AT] = ACTIONS(1887),
    [anon_sym_not] = ACTIONS(1980),
    [anon_sym_and] = ACTIONS(1980),
    [anon_sym_or] = ACTIONS(1980),
    [anon_sym_PLUS] = ACTIONS(1891),
    [anon_sym_DASH] = ACTIONS(1891),
    [anon_sym_SLASH] = ACTIONS(1881),
    [anon_sym_PERCENT] = ACTIONS(1887),
    [anon_sym_SLASH_SLASH] = ACTIONS(1887),
    [anon_sym_STAR_STAR] = ACTIONS(1893),
    [anon_sym_PIPE] = ACTIONS(1980),
    [anon_sym_AMP] = ACTIONS(1897),
    [anon_sym_CARET] = ACTIONS(1899),
    [anon_sym_LT_LT] = ACTIONS(1883),
    [anon_sym_LT] = ACTIONS(1982),
    [anon_sym_LT_EQ] = ACTIONS(1980),
    [anon_sym_EQ_EQ] = ACTIONS(1980),
    [anon_sym_BANG_EQ] = ACTIONS(1980),
    [anon_sym_GT_EQ] = ACTIONS(1980),
    [anon_sym_GT] = ACTIONS(1982),
    [anon_sym_LT_GT] = ACTIONS(1980),
    [anon_sym_is] = ACTIONS(1980),
    [anon_sym_LBRACK] = ACTIONS(1980),
    [sym_comment] = ACTIONS(72),
    [sym__semicolon] = ACTIONS(1980),
  },
  [1338] = {
    [sym_argument_list] = STATE(291),
    [sym_generator_expression] = STATE(291),
    [sym__newline] = ACTIONS(1980),
    [anon_sym_DOT] = ACTIONS(1980),
    [anon_sym_LPAREN] = ACTIONS(484),
    [anon_sym_STAR] = ACTIONS(1881),
    [anon_sym_GT_GT] = ACTIONS(1883),
    [anon_sym_if] = ACTIONS(1980),
    [anon_sym_in] = ACTIONS(1980),
    [anon_sym_EQ] = ACTIONS(1982),
    [anon_sym_AT] = ACTIONS(1887),
    [anon_sym_not] = ACTIONS(1980),
    [anon_sym_and] = ACTIONS(1980),
    [anon_sym_or] = ACTIONS(1980),
    [anon_sym_PLUS] = ACTIONS(1891),
    [anon_sym_DASH] = ACTIONS(1891),
    [anon_sym_SLASH] = ACTIONS(1881),
    [anon_sym_PERCENT] = ACTIONS(1887),
    [anon_sym_SLASH_SLASH] = ACTIONS(1887),
    [anon_sym_STAR_STAR] = ACTIONS(1893),
    [anon_sym_PIPE] = ACTIONS(1980),
    [anon_sym_AMP] = ACTIONS(1980),
    [anon_sym_CARET] = ACTIONS(1899),
    [anon_sym_LT_LT] = ACTIONS(1883),
    [anon_sym_LT] = ACTIONS(1982),
    [anon_sym_LT_EQ] = ACTIONS(1980),
    [anon_sym_EQ_EQ] = ACTIONS(1980),
    [anon_sym_BANG_EQ] = ACTIONS(1980),
    [anon_sym_GT_EQ] = ACTIONS(1980),
    [anon_sym_GT] = ACTIONS(1982),
    [anon_sym_LT_GT] = ACTIONS(1980),
    [anon_sym_is] = ACTIONS(1980),
    [anon_sym_LBRACK] = ACTIONS(1980),
    [sym_comment] = ACTIONS(72),
    [sym__semicolon] = ACTIONS(1980),
  },
  [1339] = {
    [sym_argument_list] = STATE(291),
    [sym_generator_expression] = STATE(291),
    [sym__newline] = ACTIONS(1980),
    [anon_sym_DOT] = ACTIONS(1980),
    [anon_sym_LPAREN] = ACTIONS(484),
    [anon_sym_STAR] = ACTIONS(1881),
    [anon_sym_GT_GT] = ACTIONS(1883),
    [anon_sym_if] = ACTIONS(1980),
    [anon_sym_in] = ACTIONS(1980),
    [anon_sym_EQ] = ACTIONS(1982),
    [anon_sym_AT] = ACTIONS(1887),
    [anon_sym_not] = ACTIONS(1980),
    [anon_sym_and] = ACTIONS(1980),
    [anon_sym_or] = ACTIONS(1980),
    [anon_sym_PLUS] = ACTIONS(1891),
    [anon_sym_DASH] = ACTIONS(1891),
    [anon_sym_SLASH] = ACTIONS(1881),
    [anon_sym_PERCENT] = ACTIONS(1887),
    [anon_sym_SLASH_SLASH] = ACTIONS(1887),
    [anon_sym_STAR_STAR] = ACTIONS(1893),
    [anon_sym_PIPE] = ACTIONS(1980),
    [anon_sym_AMP] = ACTIONS(1980),
    [anon_sym_CARET] = ACTIONS(1980),
    [anon_sym_LT_LT] = ACTIONS(1883),
    [anon_sym_LT] = ACTIONS(1982),
    [anon_sym_LT_EQ] = ACTIONS(1980),
    [anon_sym_EQ_EQ] = ACTIONS(1980),
    [anon_sym_BANG_EQ] = ACTIONS(1980),
    [anon_sym_GT_EQ] = ACTIONS(1980),
    [anon_sym_GT] = ACTIONS(1982),
    [anon_sym_LT_GT] = ACTIONS(1980),
    [anon_sym_is] = ACTIONS(1980),
    [anon_sym_LBRACK] = ACTIONS(1980),
    [sym_comment] = ACTIONS(72),
    [sym__semicolon] = ACTIONS(1980),
  },
  [1340] = {
    [aux_sym_comparison_operator_repeat1] = STATE(1340),
    [sym__newline] = ACTIONS(1984),
    [anon_sym_if] = ACTIONS(1984),
    [anon_sym_in] = ACTIONS(3591),
    [anon_sym_EQ] = ACTIONS(1986),
    [anon_sym_not] = ACTIONS(3594),
    [anon_sym_and] = ACTIONS(1984),
    [anon_sym_or] = ACTIONS(1984),
    [anon_sym_LT] = ACTIONS(3597),
    [anon_sym_LT_EQ] = ACTIONS(3591),
    [anon_sym_EQ_EQ] = ACTIONS(3591),
    [anon_sym_BANG_EQ] = ACTIONS(3591),
    [anon_sym_GT_EQ] = ACTIONS(3591),
    [anon_sym_GT] = ACTIONS(3597),
    [anon_sym_LT_GT] = ACTIONS(3591),
    [anon_sym_is] = ACTIONS(3600),
    [sym_comment] = ACTIONS(72),
    [sym__semicolon] = ACTIONS(1984),
  },
  [1341] = {
    [sym__newline] = ACTIONS(3603),
    [sym_comment] = ACTIONS(72),
    [sym__semicolon] = ACTIONS(3603),
  },
  [1342] = {
    [sym__expression] = STATE(506),
    [sym__primary_expression] = STATE(34),
    [sym_not_operator] = STATE(506),
    [sym_boolean_operator] = STATE(506),
    [sym_binary_operator] = STATE(34),
    [sym_unary_operator] = STATE(34),
    [sym_comparison_operator] = STATE(506),
    [sym_lambda] = STATE(506),
    [sym_attribute] = STATE(34),
    [sym_subscript] = STATE(34),
    [sym_call] = STATE(34),
    [sym_list] = STATE(34),
    [sym_list_comprehension] = STATE(34),
    [sym_dictionary] = STATE(34),
    [sym_dictionary_comprehension] = STATE(34),
    [sym_set] = STATE(34),
    [sym_set_comprehension] = STATE(34),
    [sym_parenthesized_expression] = STATE(34),
    [sym_tuple] = STATE(34),
    [sym_generator_expression] = STATE(34),
    [sym_conditional_expression] = STATE(506),
    [sym_concatenated_string] = STATE(34),
    [sym_await] = STATE(506),
    [sym__newline] = ACTIONS(1957),
    [anon_sym_LPAREN] = ACTIONS(14),
    [anon_sym_print] = ACTIONS(216),
    [anon_sym_COLON] = ACTIONS(1957),
    [anon_sym_EQ] = ACTIONS(1957),
    [anon_sym_exec] = ACTIONS(216),
    [anon_sym_not] = ACTIONS(52),
    [anon_sym_PLUS] = ACTIONS(912),
    [anon_sym_DASH] = ACTIONS(912),
    [anon_sym_TILDE] = ACTIONS(54),
    [anon_sym_lambda] = ACTIONS(56),
    [anon_sym_PLUS_EQ] = ACTIONS(1957),
    [anon_sym_DASH_EQ] = ACTIONS(1957),
    [anon_sym_STAR_EQ] = ACTIONS(1957),
    [anon_sym_SLASH_EQ] = ACTIONS(1957),
    [anon_sym_AT_EQ] = ACTIONS(1957),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(1957),
    [anon_sym_PERCENT_EQ] = ACTIONS(1957),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1957),
    [anon_sym_GT_GT_EQ] = ACTIONS(1957),
    [anon_sym_LT_LT_EQ] = ACTIONS(1957),
    [anon_sym_AMP_EQ] = ACTIONS(1957),
    [anon_sym_CARET_EQ] = ACTIONS(1957),
    [anon_sym_PIPE_EQ] = ACTIONS(1957),
    [anon_sym_LBRACK] = ACTIONS(60),
    [sym_ellipsis] = ACTIONS(62),
    [anon_sym_LBRACE] = ACTIONS(64),
    [sym_string] = ACTIONS(66),
    [sym_integer] = ACTIONS(68),
    [sym_float] = ACTIONS(68),
    [sym_identifier] = ACTIONS(68),
    [sym_true] = ACTIONS(68),
    [sym_false] = ACTIONS(68),
    [sym_none] = ACTIONS(68),
    [anon_sym_await] = ACTIONS(70),
    [sym_comment] = ACTIONS(72),
    [sym__semicolon] = ACTIONS(1957),
  },
  [1343] = {
    [anon_sym_if] = ACTIONS(1921),
    [anon_sym_else] = ACTIONS(1644),
    [anon_sym_and] = ACTIONS(1925),
    [anon_sym_or] = ACTIONS(1927),
    [sym_comment] = ACTIONS(72),
  },
  [1344] = {
    [sym__expression] = STATE(1625),
    [sym__primary_expression] = STATE(513),
    [sym_not_operator] = STATE(1625),
    [sym_boolean_operator] = STATE(1625),
    [sym_binary_operator] = STATE(513),
    [sym_unary_operator] = STATE(513),
    [sym_comparison_operator] = STATE(1625),
    [sym_lambda] = STATE(1625),
    [sym_attribute] = STATE(513),
    [sym_subscript] = STATE(513),
    [sym_call] = STATE(513),
    [sym_list] = STATE(513),
    [sym_list_comprehension] = STATE(513),
    [sym_dictionary] = STATE(513),
    [sym_dictionary_comprehension] = STATE(513),
    [sym_set] = STATE(513),
    [sym_set_comprehension] = STATE(513),
    [sym_parenthesized_expression] = STATE(513),
    [sym_tuple] = STATE(513),
    [sym_generator_expression] = STATE(513),
    [sym_conditional_expression] = STATE(1625),
    [sym_concatenated_string] = STATE(513),
    [sym_await] = STATE(1625),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_not] = ACTIONS(914),
    [anon_sym_PLUS] = ACTIONS(916),
    [anon_sym_DASH] = ACTIONS(916),
    [anon_sym_TILDE] = ACTIONS(916),
    [anon_sym_lambda] = ACTIONS(918),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(920),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(922),
    [sym_integer] = ACTIONS(924),
    [sym_float] = ACTIONS(924),
    [sym_identifier] = ACTIONS(924),
    [sym_true] = ACTIONS(924),
    [sym_false] = ACTIONS(924),
    [sym_none] = ACTIONS(924),
    [anon_sym_await] = ACTIONS(926),
    [sym_comment] = ACTIONS(72),
  },
  [1345] = {
    [aux_sym_concatenated_string_repeat1] = STATE(1345),
    [anon_sym_DOT] = ACTIONS(1862),
    [anon_sym_LPAREN] = ACTIONS(1862),
    [anon_sym_STAR] = ACTIONS(1864),
    [anon_sym_GT_GT] = ACTIONS(1862),
    [anon_sym_if] = ACTIONS(1862),
    [anon_sym_else] = ACTIONS(1862),
    [anon_sym_in] = ACTIONS(1862),
    [anon_sym_AT] = ACTIONS(1862),
    [anon_sym_not] = ACTIONS(1862),
    [anon_sym_and] = ACTIONS(1862),
    [anon_sym_or] = ACTIONS(1862),
    [anon_sym_PLUS] = ACTIONS(1862),
    [anon_sym_DASH] = ACTIONS(1862),
    [anon_sym_SLASH] = ACTIONS(1864),
    [anon_sym_PERCENT] = ACTIONS(1862),
    [anon_sym_SLASH_SLASH] = ACTIONS(1862),
    [anon_sym_STAR_STAR] = ACTIONS(1862),
    [anon_sym_PIPE] = ACTIONS(1862),
    [anon_sym_AMP] = ACTIONS(1862),
    [anon_sym_CARET] = ACTIONS(1862),
    [anon_sym_LT_LT] = ACTIONS(1862),
    [anon_sym_LT] = ACTIONS(1864),
    [anon_sym_LT_EQ] = ACTIONS(1862),
    [anon_sym_EQ_EQ] = ACTIONS(1862),
    [anon_sym_BANG_EQ] = ACTIONS(1862),
    [anon_sym_GT_EQ] = ACTIONS(1862),
    [anon_sym_GT] = ACTIONS(1864),
    [anon_sym_LT_GT] = ACTIONS(1862),
    [anon_sym_is] = ACTIONS(1862),
    [anon_sym_LBRACK] = ACTIONS(1862),
    [sym_string] = ACTIONS(3605),
    [sym_comment] = ACTIONS(72),
  },
  [1346] = {
    [anon_sym_if] = ACTIONS(1921),
    [anon_sym_else] = ACTIONS(3608),
    [anon_sym_and] = ACTIONS(1925),
    [anon_sym_or] = ACTIONS(1927),
    [sym_comment] = ACTIONS(72),
  },
  [1347] = {
    [sym__newline] = ACTIONS(3610),
    [anon_sym_COMMA] = ACTIONS(3610),
    [anon_sym_if] = ACTIONS(294),
    [anon_sym_COLON] = ACTIONS(3610),
    [anon_sym_EQ] = ACTIONS(3610),
    [anon_sym_and] = ACTIONS(298),
    [anon_sym_or] = ACTIONS(300),
    [anon_sym_PLUS_EQ] = ACTIONS(3610),
    [anon_sym_DASH_EQ] = ACTIONS(3610),
    [anon_sym_STAR_EQ] = ACTIONS(3610),
    [anon_sym_SLASH_EQ] = ACTIONS(3610),
    [anon_sym_AT_EQ] = ACTIONS(3610),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3610),
    [anon_sym_PERCENT_EQ] = ACTIONS(3610),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3610),
    [anon_sym_GT_GT_EQ] = ACTIONS(3610),
    [anon_sym_LT_LT_EQ] = ACTIONS(3610),
    [anon_sym_AMP_EQ] = ACTIONS(3610),
    [anon_sym_CARET_EQ] = ACTIONS(3610),
    [anon_sym_PIPE_EQ] = ACTIONS(3610),
    [sym_comment] = ACTIONS(72),
    [sym__semicolon] = ACTIONS(3610),
  },
  [1348] = {
    [anon_sym_if] = ACTIONS(1953),
    [anon_sym_else] = ACTIONS(1953),
    [anon_sym_and] = ACTIONS(1925),
    [anon_sym_or] = ACTIONS(1953),
    [sym_comment] = ACTIONS(72),
  },
  [1349] = {
    [sym_argument_list] = STATE(251),
    [sym_generator_expression] = STATE(251),
    [anon_sym_DOT] = ACTIONS(1980),
    [anon_sym_LPAREN] = ACTIONS(424),
    [anon_sym_STAR] = ACTIONS(1982),
    [anon_sym_GT_GT] = ACTIONS(1980),
    [anon_sym_if] = ACTIONS(1980),
    [anon_sym_else] = ACTIONS(1980),
    [anon_sym_in] = ACTIONS(1980),
    [anon_sym_AT] = ACTIONS(1980),
    [anon_sym_not] = ACTIONS(1980),
    [anon_sym_and] = ACTIONS(1980),
    [anon_sym_or] = ACTIONS(1980),
    [anon_sym_PLUS] = ACTIONS(1980),
    [anon_sym_DASH] = ACTIONS(1980),
    [anon_sym_SLASH] = ACTIONS(1982),
    [anon_sym_PERCENT] = ACTIONS(1980),
    [anon_sym_SLASH_SLASH] = ACTIONS(1980),
    [anon_sym_STAR_STAR] = ACTIONS(1941),
    [anon_sym_PIPE] = ACTIONS(1980),
    [anon_sym_AMP] = ACTIONS(1980),
    [anon_sym_CARET] = ACTIONS(1980),
    [anon_sym_LT_LT] = ACTIONS(1980),
    [anon_sym_LT] = ACTIONS(1982),
    [anon_sym_LT_EQ] = ACTIONS(1980),
    [anon_sym_EQ_EQ] = ACTIONS(1980),
    [anon_sym_BANG_EQ] = ACTIONS(1980),
    [anon_sym_GT_EQ] = ACTIONS(1980),
    [anon_sym_GT] = ACTIONS(1982),
    [anon_sym_LT_GT] = ACTIONS(1980),
    [anon_sym_is] = ACTIONS(1980),
    [anon_sym_LBRACK] = ACTIONS(1980),
    [sym_comment] = ACTIONS(72),
  },
  [1350] = {
    [sym_argument_list] = STATE(251),
    [sym_generator_expression] = STATE(251),
    [anon_sym_DOT] = ACTIONS(1980),
    [anon_sym_LPAREN] = ACTIONS(424),
    [anon_sym_STAR] = ACTIONS(1929),
    [anon_sym_GT_GT] = ACTIONS(1980),
    [anon_sym_if] = ACTIONS(1980),
    [anon_sym_else] = ACTIONS(1980),
    [anon_sym_in] = ACTIONS(1980),
    [anon_sym_AT] = ACTIONS(1935),
    [anon_sym_not] = ACTIONS(1980),
    [anon_sym_and] = ACTIONS(1980),
    [anon_sym_or] = ACTIONS(1980),
    [anon_sym_PLUS] = ACTIONS(1939),
    [anon_sym_DASH] = ACTIONS(1939),
    [anon_sym_SLASH] = ACTIONS(1929),
    [anon_sym_PERCENT] = ACTIONS(1935),
    [anon_sym_SLASH_SLASH] = ACTIONS(1935),
    [anon_sym_STAR_STAR] = ACTIONS(1941),
    [anon_sym_PIPE] = ACTIONS(1980),
    [anon_sym_AMP] = ACTIONS(1980),
    [anon_sym_CARET] = ACTIONS(1980),
    [anon_sym_LT_LT] = ACTIONS(1980),
    [anon_sym_LT] = ACTIONS(1982),
    [anon_sym_LT_EQ] = ACTIONS(1980),
    [anon_sym_EQ_EQ] = ACTIONS(1980),
    [anon_sym_BANG_EQ] = ACTIONS(1980),
    [anon_sym_GT_EQ] = ACTIONS(1980),
    [anon_sym_GT] = ACTIONS(1982),
    [anon_sym_LT_GT] = ACTIONS(1980),
    [anon_sym_is] = ACTIONS(1980),
    [anon_sym_LBRACK] = ACTIONS(1980),
    [sym_comment] = ACTIONS(72),
  },
  [1351] = {
    [sym_argument_list] = STATE(251),
    [sym_generator_expression] = STATE(251),
    [anon_sym_DOT] = ACTIONS(422),
    [anon_sym_LPAREN] = ACTIONS(424),
    [anon_sym_STAR] = ACTIONS(1929),
    [anon_sym_GT_GT] = ACTIONS(1931),
    [anon_sym_if] = ACTIONS(1984),
    [anon_sym_else] = ACTIONS(1984),
    [anon_sym_in] = ACTIONS(1984),
    [anon_sym_AT] = ACTIONS(1935),
    [anon_sym_not] = ACTIONS(1984),
    [anon_sym_and] = ACTIONS(1984),
    [anon_sym_or] = ACTIONS(1984),
    [anon_sym_PLUS] = ACTIONS(1939),
    [anon_sym_DASH] = ACTIONS(1939),
    [anon_sym_SLASH] = ACTIONS(1929),
    [anon_sym_PERCENT] = ACTIONS(1935),
    [anon_sym_SLASH_SLASH] = ACTIONS(1935),
    [anon_sym_STAR_STAR] = ACTIONS(1941),
    [anon_sym_PIPE] = ACTIONS(1943),
    [anon_sym_AMP] = ACTIONS(1945),
    [anon_sym_CARET] = ACTIONS(1947),
    [anon_sym_LT_LT] = ACTIONS(1931),
    [anon_sym_LT] = ACTIONS(1986),
    [anon_sym_LT_EQ] = ACTIONS(1984),
    [anon_sym_EQ_EQ] = ACTIONS(1984),
    [anon_sym_BANG_EQ] = ACTIONS(1984),
    [anon_sym_GT_EQ] = ACTIONS(1984),
    [anon_sym_GT] = ACTIONS(1986),
    [anon_sym_LT_GT] = ACTIONS(1984),
    [anon_sym_is] = ACTIONS(1984),
    [anon_sym_LBRACK] = ACTIONS(450),
    [sym_comment] = ACTIONS(72),
  },
  [1352] = {
    [sym__primary_expression] = STATE(1627),
    [sym_binary_operator] = STATE(1627),
    [sym_unary_operator] = STATE(1627),
    [sym_attribute] = STATE(1627),
    [sym_subscript] = STATE(1627),
    [sym_call] = STATE(1627),
    [sym_list] = STATE(1627),
    [sym_list_comprehension] = STATE(1627),
    [sym_dictionary] = STATE(1627),
    [sym_dictionary_comprehension] = STATE(1627),
    [sym_set] = STATE(1627),
    [sym_set_comprehension] = STATE(1627),
    [sym_parenthesized_expression] = STATE(1627),
    [sym_tuple] = STATE(1627),
    [sym_generator_expression] = STATE(1627),
    [sym_concatenated_string] = STATE(1627),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_PLUS] = ACTIONS(916),
    [anon_sym_DASH] = ACTIONS(916),
    [anon_sym_TILDE] = ACTIONS(916),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(3612),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(922),
    [sym_integer] = ACTIONS(3614),
    [sym_float] = ACTIONS(3614),
    [sym_identifier] = ACTIONS(3614),
    [sym_true] = ACTIONS(3614),
    [sym_false] = ACTIONS(3614),
    [sym_none] = ACTIONS(3614),
    [sym_comment] = ACTIONS(72),
  },
  [1353] = {
    [sym_argument_list] = STATE(251),
    [sym_generator_expression] = STATE(251),
    [anon_sym_DOT] = ACTIONS(1980),
    [anon_sym_LPAREN] = ACTIONS(424),
    [anon_sym_STAR] = ACTIONS(1929),
    [anon_sym_GT_GT] = ACTIONS(1980),
    [anon_sym_if] = ACTIONS(1980),
    [anon_sym_else] = ACTIONS(1980),
    [anon_sym_in] = ACTIONS(1980),
    [anon_sym_AT] = ACTIONS(1935),
    [anon_sym_not] = ACTIONS(1980),
    [anon_sym_and] = ACTIONS(1980),
    [anon_sym_or] = ACTIONS(1980),
    [anon_sym_PLUS] = ACTIONS(1980),
    [anon_sym_DASH] = ACTIONS(1980),
    [anon_sym_SLASH] = ACTIONS(1929),
    [anon_sym_PERCENT] = ACTIONS(1935),
    [anon_sym_SLASH_SLASH] = ACTIONS(1935),
    [anon_sym_STAR_STAR] = ACTIONS(1941),
    [anon_sym_PIPE] = ACTIONS(1980),
    [anon_sym_AMP] = ACTIONS(1980),
    [anon_sym_CARET] = ACTIONS(1980),
    [anon_sym_LT_LT] = ACTIONS(1980),
    [anon_sym_LT] = ACTIONS(1982),
    [anon_sym_LT_EQ] = ACTIONS(1980),
    [anon_sym_EQ_EQ] = ACTIONS(1980),
    [anon_sym_BANG_EQ] = ACTIONS(1980),
    [anon_sym_GT_EQ] = ACTIONS(1980),
    [anon_sym_GT] = ACTIONS(1982),
    [anon_sym_LT_GT] = ACTIONS(1980),
    [anon_sym_is] = ACTIONS(1980),
    [anon_sym_LBRACK] = ACTIONS(1980),
    [sym_comment] = ACTIONS(72),
  },
  [1354] = {
    [sym_argument_list] = STATE(251),
    [sym_generator_expression] = STATE(251),
    [anon_sym_DOT] = ACTIONS(1980),
    [anon_sym_LPAREN] = ACTIONS(424),
    [anon_sym_STAR] = ACTIONS(1929),
    [anon_sym_GT_GT] = ACTIONS(1931),
    [anon_sym_if] = ACTIONS(1980),
    [anon_sym_else] = ACTIONS(1980),
    [anon_sym_in] = ACTIONS(1980),
    [anon_sym_AT] = ACTIONS(1935),
    [anon_sym_not] = ACTIONS(1980),
    [anon_sym_and] = ACTIONS(1980),
    [anon_sym_or] = ACTIONS(1980),
    [anon_sym_PLUS] = ACTIONS(1939),
    [anon_sym_DASH] = ACTIONS(1939),
    [anon_sym_SLASH] = ACTIONS(1929),
    [anon_sym_PERCENT] = ACTIONS(1935),
    [anon_sym_SLASH_SLASH] = ACTIONS(1935),
    [anon_sym_STAR_STAR] = ACTIONS(1941),
    [anon_sym_PIPE] = ACTIONS(1980),
    [anon_sym_AMP] = ACTIONS(1945),
    [anon_sym_CARET] = ACTIONS(1947),
    [anon_sym_LT_LT] = ACTIONS(1931),
    [anon_sym_LT] = ACTIONS(1982),
    [anon_sym_LT_EQ] = ACTIONS(1980),
    [anon_sym_EQ_EQ] = ACTIONS(1980),
    [anon_sym_BANG_EQ] = ACTIONS(1980),
    [anon_sym_GT_EQ] = ACTIONS(1980),
    [anon_sym_GT] = ACTIONS(1982),
    [anon_sym_LT_GT] = ACTIONS(1980),
    [anon_sym_is] = ACTIONS(1980),
    [anon_sym_LBRACK] = ACTIONS(1980),
    [sym_comment] = ACTIONS(72),
  },
  [1355] = {
    [sym_argument_list] = STATE(251),
    [sym_generator_expression] = STATE(251),
    [anon_sym_DOT] = ACTIONS(1980),
    [anon_sym_LPAREN] = ACTIONS(424),
    [anon_sym_STAR] = ACTIONS(1929),
    [anon_sym_GT_GT] = ACTIONS(1931),
    [anon_sym_if] = ACTIONS(1980),
    [anon_sym_else] = ACTIONS(1980),
    [anon_sym_in] = ACTIONS(1980),
    [anon_sym_AT] = ACTIONS(1935),
    [anon_sym_not] = ACTIONS(1980),
    [anon_sym_and] = ACTIONS(1980),
    [anon_sym_or] = ACTIONS(1980),
    [anon_sym_PLUS] = ACTIONS(1939),
    [anon_sym_DASH] = ACTIONS(1939),
    [anon_sym_SLASH] = ACTIONS(1929),
    [anon_sym_PERCENT] = ACTIONS(1935),
    [anon_sym_SLASH_SLASH] = ACTIONS(1935),
    [anon_sym_STAR_STAR] = ACTIONS(1941),
    [anon_sym_PIPE] = ACTIONS(1980),
    [anon_sym_AMP] = ACTIONS(1980),
    [anon_sym_CARET] = ACTIONS(1947),
    [anon_sym_LT_LT] = ACTIONS(1931),
    [anon_sym_LT] = ACTIONS(1982),
    [anon_sym_LT_EQ] = ACTIONS(1980),
    [anon_sym_EQ_EQ] = ACTIONS(1980),
    [anon_sym_BANG_EQ] = ACTIONS(1980),
    [anon_sym_GT_EQ] = ACTIONS(1980),
    [anon_sym_GT] = ACTIONS(1982),
    [anon_sym_LT_GT] = ACTIONS(1980),
    [anon_sym_is] = ACTIONS(1980),
    [anon_sym_LBRACK] = ACTIONS(1980),
    [sym_comment] = ACTIONS(72),
  },
  [1356] = {
    [sym_argument_list] = STATE(251),
    [sym_generator_expression] = STATE(251),
    [anon_sym_DOT] = ACTIONS(1980),
    [anon_sym_LPAREN] = ACTIONS(424),
    [anon_sym_STAR] = ACTIONS(1929),
    [anon_sym_GT_GT] = ACTIONS(1931),
    [anon_sym_if] = ACTIONS(1980),
    [anon_sym_else] = ACTIONS(1980),
    [anon_sym_in] = ACTIONS(1980),
    [anon_sym_AT] = ACTIONS(1935),
    [anon_sym_not] = ACTIONS(1980),
    [anon_sym_and] = ACTIONS(1980),
    [anon_sym_or] = ACTIONS(1980),
    [anon_sym_PLUS] = ACTIONS(1939),
    [anon_sym_DASH] = ACTIONS(1939),
    [anon_sym_SLASH] = ACTIONS(1929),
    [anon_sym_PERCENT] = ACTIONS(1935),
    [anon_sym_SLASH_SLASH] = ACTIONS(1935),
    [anon_sym_STAR_STAR] = ACTIONS(1941),
    [anon_sym_PIPE] = ACTIONS(1980),
    [anon_sym_AMP] = ACTIONS(1980),
    [anon_sym_CARET] = ACTIONS(1980),
    [anon_sym_LT_LT] = ACTIONS(1931),
    [anon_sym_LT] = ACTIONS(1982),
    [anon_sym_LT_EQ] = ACTIONS(1980),
    [anon_sym_EQ_EQ] = ACTIONS(1980),
    [anon_sym_BANG_EQ] = ACTIONS(1980),
    [anon_sym_GT_EQ] = ACTIONS(1980),
    [anon_sym_GT] = ACTIONS(1982),
    [anon_sym_LT_GT] = ACTIONS(1980),
    [anon_sym_is] = ACTIONS(1980),
    [anon_sym_LBRACK] = ACTIONS(1980),
    [sym_comment] = ACTIONS(72),
  },
  [1357] = {
    [aux_sym_comparison_operator_repeat1] = STATE(1357),
    [anon_sym_if] = ACTIONS(1984),
    [anon_sym_else] = ACTIONS(1984),
    [anon_sym_in] = ACTIONS(3616),
    [anon_sym_not] = ACTIONS(3619),
    [anon_sym_and] = ACTIONS(1984),
    [anon_sym_or] = ACTIONS(1984),
    [anon_sym_LT] = ACTIONS(3622),
    [anon_sym_LT_EQ] = ACTIONS(3616),
    [anon_sym_EQ_EQ] = ACTIONS(3616),
    [anon_sym_BANG_EQ] = ACTIONS(3616),
    [anon_sym_GT_EQ] = ACTIONS(3616),
    [anon_sym_GT] = ACTIONS(3622),
    [anon_sym_LT_GT] = ACTIONS(3616),
    [anon_sym_is] = ACTIONS(3625),
    [sym_comment] = ACTIONS(72),
  },
  [1358] = {
    [anon_sym_RPAREN] = ACTIONS(2515),
    [anon_sym_COMMA] = ACTIONS(2515),
    [anon_sym_if] = ACTIONS(1147),
    [anon_sym_and] = ACTIONS(1149),
    [anon_sym_or] = ACTIONS(1151),
    [sym_comment] = ACTIONS(72),
  },
  [1359] = {
    [anon_sym_RPAREN] = ACTIONS(3628),
    [anon_sym_COMMA] = ACTIONS(3628),
    [anon_sym_if] = ACTIONS(1147),
    [anon_sym_and] = ACTIONS(1149),
    [anon_sym_or] = ACTIONS(1151),
    [sym_comment] = ACTIONS(72),
  },
  [1360] = {
    [anon_sym_RPAREN] = ACTIONS(3630),
    [anon_sym_COMMA] = ACTIONS(3630),
    [anon_sym_if] = ACTIONS(1147),
    [anon_sym_and] = ACTIONS(1149),
    [anon_sym_or] = ACTIONS(1151),
    [sym_comment] = ACTIONS(72),
  },
  [1361] = {
    [sym__newline] = ACTIONS(3632),
    [anon_sym_DOT] = ACTIONS(3632),
    [anon_sym_LPAREN] = ACTIONS(3632),
    [anon_sym_COMMA] = ACTIONS(3632),
    [anon_sym_STAR] = ACTIONS(3634),
    [anon_sym_GT_GT] = ACTIONS(3634),
    [anon_sym_if] = ACTIONS(3632),
    [anon_sym_COLON] = ACTIONS(3632),
    [anon_sym_in] = ACTIONS(3632),
    [anon_sym_EQ] = ACTIONS(3634),
    [anon_sym_AT] = ACTIONS(3634),
    [anon_sym_not] = ACTIONS(3632),
    [anon_sym_and] = ACTIONS(3632),
    [anon_sym_or] = ACTIONS(3632),
    [anon_sym_PLUS] = ACTIONS(3634),
    [anon_sym_DASH] = ACTIONS(3634),
    [anon_sym_SLASH] = ACTIONS(3634),
    [anon_sym_PERCENT] = ACTIONS(3634),
    [anon_sym_SLASH_SLASH] = ACTIONS(3634),
    [anon_sym_STAR_STAR] = ACTIONS(3634),
    [anon_sym_PIPE] = ACTIONS(3634),
    [anon_sym_AMP] = ACTIONS(3634),
    [anon_sym_CARET] = ACTIONS(3634),
    [anon_sym_LT_LT] = ACTIONS(3634),
    [anon_sym_LT] = ACTIONS(3634),
    [anon_sym_LT_EQ] = ACTIONS(3632),
    [anon_sym_EQ_EQ] = ACTIONS(3632),
    [anon_sym_BANG_EQ] = ACTIONS(3632),
    [anon_sym_GT_EQ] = ACTIONS(3632),
    [anon_sym_GT] = ACTIONS(3634),
    [anon_sym_LT_GT] = ACTIONS(3632),
    [anon_sym_is] = ACTIONS(3632),
    [anon_sym_PLUS_EQ] = ACTIONS(3632),
    [anon_sym_DASH_EQ] = ACTIONS(3632),
    [anon_sym_STAR_EQ] = ACTIONS(3632),
    [anon_sym_SLASH_EQ] = ACTIONS(3632),
    [anon_sym_AT_EQ] = ACTIONS(3632),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3632),
    [anon_sym_PERCENT_EQ] = ACTIONS(3632),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3632),
    [anon_sym_GT_GT_EQ] = ACTIONS(3632),
    [anon_sym_LT_LT_EQ] = ACTIONS(3632),
    [anon_sym_AMP_EQ] = ACTIONS(3632),
    [anon_sym_CARET_EQ] = ACTIONS(3632),
    [anon_sym_PIPE_EQ] = ACTIONS(3632),
    [anon_sym_LBRACK] = ACTIONS(3632),
    [sym_comment] = ACTIONS(72),
    [sym__semicolon] = ACTIONS(3632),
  },
  [1362] = {
    [anon_sym_RPAREN] = ACTIONS(3636),
    [anon_sym_COMMA] = ACTIONS(3636),
    [sym_comment] = ACTIONS(72),
  },
  [1363] = {
    [anon_sym_RPAREN] = ACTIONS(3636),
    [anon_sym_COMMA] = ACTIONS(3636),
    [anon_sym_if] = ACTIONS(1147),
    [anon_sym_and] = ACTIONS(1149),
    [anon_sym_or] = ACTIONS(1151),
    [sym_comment] = ACTIONS(72),
  },
  [1364] = {
    [sym_list_splat] = STATE(1362),
    [sym_dictionary_splat] = STATE(1362),
    [sym__expression] = STATE(1363),
    [sym__primary_expression] = STATE(215),
    [sym_not_operator] = STATE(1363),
    [sym_boolean_operator] = STATE(1363),
    [sym_binary_operator] = STATE(215),
    [sym_unary_operator] = STATE(215),
    [sym_comparison_operator] = STATE(1363),
    [sym_lambda] = STATE(1363),
    [sym_attribute] = STATE(215),
    [sym_subscript] = STATE(215),
    [sym_call] = STATE(215),
    [sym_keyword_argument] = STATE(1362),
    [sym_list] = STATE(215),
    [sym_list_comprehension] = STATE(215),
    [sym_dictionary] = STATE(215),
    [sym_dictionary_comprehension] = STATE(215),
    [sym_set] = STATE(215),
    [sym_set_comprehension] = STATE(215),
    [sym_parenthesized_expression] = STATE(215),
    [sym_tuple] = STATE(215),
    [sym_generator_expression] = STATE(215),
    [sym_conditional_expression] = STATE(1363),
    [sym_concatenated_string] = STATE(215),
    [sym_await] = STATE(1363),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_RPAREN] = ACTIONS(3638),
    [anon_sym_STAR] = ACTIONS(936),
    [anon_sym_print] = ACTIONS(938),
    [anon_sym_exec] = ACTIONS(938),
    [anon_sym_not] = ACTIONS(384),
    [anon_sym_PLUS] = ACTIONS(386),
    [anon_sym_DASH] = ACTIONS(386),
    [anon_sym_TILDE] = ACTIONS(386),
    [anon_sym_lambda] = ACTIONS(388),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(390),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(392),
    [sym_integer] = ACTIONS(394),
    [sym_float] = ACTIONS(394),
    [sym_identifier] = ACTIONS(940),
    [sym_true] = ACTIONS(394),
    [sym_false] = ACTIONS(394),
    [sym_none] = ACTIONS(394),
    [anon_sym_await] = ACTIONS(396),
    [sym_comment] = ACTIONS(72),
  },
  [1365] = {
    [aux_sym_argument_list_repeat1] = STATE(1365),
    [anon_sym_RPAREN] = ACTIONS(3636),
    [anon_sym_COMMA] = ACTIONS(3640),
    [sym_comment] = ACTIONS(72),
  },
  [1366] = {
    [anon_sym_COMMA] = ACTIONS(3643),
    [anon_sym_if] = ACTIONS(1674),
    [anon_sym_and] = ACTIONS(1676),
    [anon_sym_or] = ACTIONS(1678),
    [anon_sym_RBRACK] = ACTIONS(3643),
    [sym_comment] = ACTIONS(72),
  },
  [1367] = {
    [sym__expression] = STATE(1630),
    [sym__primary_expression] = STATE(430),
    [sym_not_operator] = STATE(1630),
    [sym_boolean_operator] = STATE(1630),
    [sym_binary_operator] = STATE(430),
    [sym_unary_operator] = STATE(430),
    [sym_comparison_operator] = STATE(1630),
    [sym_lambda] = STATE(1630),
    [sym_attribute] = STATE(430),
    [sym_subscript] = STATE(430),
    [sym_call] = STATE(430),
    [sym_list] = STATE(430),
    [sym_list_comprehension] = STATE(430),
    [sym_dictionary] = STATE(430),
    [sym_dictionary_comprehension] = STATE(430),
    [sym_set] = STATE(430),
    [sym_set_comprehension] = STATE(430),
    [sym_parenthesized_expression] = STATE(430),
    [sym_tuple] = STATE(430),
    [sym_generator_expression] = STATE(430),
    [sym_conditional_expression] = STATE(1630),
    [sym_concatenated_string] = STATE(430),
    [sym_await] = STATE(1630),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_COMMA] = ACTIONS(3643),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_not] = ACTIONS(760),
    [anon_sym_PLUS] = ACTIONS(762),
    [anon_sym_DASH] = ACTIONS(762),
    [anon_sym_TILDE] = ACTIONS(762),
    [anon_sym_lambda] = ACTIONS(764),
    [anon_sym_LBRACK] = ACTIONS(96),
    [anon_sym_RBRACK] = ACTIONS(3643),
    [sym_ellipsis] = ACTIONS(766),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(768),
    [sym_integer] = ACTIONS(770),
    [sym_float] = ACTIONS(770),
    [sym_identifier] = ACTIONS(770),
    [sym_true] = ACTIONS(770),
    [sym_false] = ACTIONS(770),
    [sym_none] = ACTIONS(770),
    [anon_sym_await] = ACTIONS(772),
    [sym_comment] = ACTIONS(72),
  },
  [1368] = {
    [anon_sym_COMMA] = ACTIONS(1644),
    [anon_sym_if] = ACTIONS(2002),
    [anon_sym_COLON] = ACTIONS(1644),
    [anon_sym_and] = ACTIONS(2006),
    [anon_sym_or] = ACTIONS(2008),
    [anon_sym_RBRACK] = ACTIONS(1644),
    [sym_comment] = ACTIONS(72),
  },
  [1369] = {
    [sym__expression] = STATE(1631),
    [sym__primary_expression] = STATE(542),
    [sym_not_operator] = STATE(1631),
    [sym_boolean_operator] = STATE(1631),
    [sym_binary_operator] = STATE(542),
    [sym_unary_operator] = STATE(542),
    [sym_comparison_operator] = STATE(1631),
    [sym_lambda] = STATE(1631),
    [sym_attribute] = STATE(542),
    [sym_subscript] = STATE(542),
    [sym_call] = STATE(542),
    [sym_list] = STATE(542),
    [sym_list_comprehension] = STATE(542),
    [sym_dictionary] = STATE(542),
    [sym_dictionary_comprehension] = STATE(542),
    [sym_set] = STATE(542),
    [sym_set_comprehension] = STATE(542),
    [sym_parenthesized_expression] = STATE(542),
    [sym_tuple] = STATE(542),
    [sym_generator_expression] = STATE(542),
    [sym_conditional_expression] = STATE(1631),
    [sym_concatenated_string] = STATE(542),
    [sym_await] = STATE(1631),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_not] = ACTIONS(980),
    [anon_sym_PLUS] = ACTIONS(982),
    [anon_sym_DASH] = ACTIONS(982),
    [anon_sym_TILDE] = ACTIONS(982),
    [anon_sym_lambda] = ACTIONS(984),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(986),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(988),
    [sym_integer] = ACTIONS(990),
    [sym_float] = ACTIONS(990),
    [sym_identifier] = ACTIONS(990),
    [sym_true] = ACTIONS(990),
    [sym_false] = ACTIONS(990),
    [sym_none] = ACTIONS(990),
    [anon_sym_await] = ACTIONS(992),
    [sym_comment] = ACTIONS(72),
  },
  [1370] = {
    [aux_sym_concatenated_string_repeat1] = STATE(1370),
    [anon_sym_DOT] = ACTIONS(1862),
    [anon_sym_LPAREN] = ACTIONS(1862),
    [anon_sym_COMMA] = ACTIONS(1862),
    [anon_sym_STAR] = ACTIONS(1864),
    [anon_sym_GT_GT] = ACTIONS(1862),
    [anon_sym_if] = ACTIONS(1862),
    [anon_sym_COLON] = ACTIONS(1862),
    [anon_sym_in] = ACTIONS(1862),
    [anon_sym_AT] = ACTIONS(1862),
    [anon_sym_not] = ACTIONS(1862),
    [anon_sym_and] = ACTIONS(1862),
    [anon_sym_or] = ACTIONS(1862),
    [anon_sym_PLUS] = ACTIONS(1862),
    [anon_sym_DASH] = ACTIONS(1862),
    [anon_sym_SLASH] = ACTIONS(1864),
    [anon_sym_PERCENT] = ACTIONS(1862),
    [anon_sym_SLASH_SLASH] = ACTIONS(1862),
    [anon_sym_STAR_STAR] = ACTIONS(1862),
    [anon_sym_PIPE] = ACTIONS(1862),
    [anon_sym_AMP] = ACTIONS(1862),
    [anon_sym_CARET] = ACTIONS(1862),
    [anon_sym_LT_LT] = ACTIONS(1862),
    [anon_sym_LT] = ACTIONS(1864),
    [anon_sym_LT_EQ] = ACTIONS(1862),
    [anon_sym_EQ_EQ] = ACTIONS(1862),
    [anon_sym_BANG_EQ] = ACTIONS(1862),
    [anon_sym_GT_EQ] = ACTIONS(1862),
    [anon_sym_GT] = ACTIONS(1864),
    [anon_sym_LT_GT] = ACTIONS(1862),
    [anon_sym_is] = ACTIONS(1862),
    [anon_sym_LBRACK] = ACTIONS(1862),
    [anon_sym_RBRACK] = ACTIONS(1862),
    [sym_string] = ACTIONS(3645),
    [sym_comment] = ACTIONS(72),
  },
  [1371] = {
    [sym__newline] = ACTIONS(3648),
    [anon_sym_DOT] = ACTIONS(3648),
    [anon_sym_LPAREN] = ACTIONS(3648),
    [anon_sym_COMMA] = ACTIONS(3648),
    [anon_sym_STAR] = ACTIONS(3650),
    [anon_sym_GT_GT] = ACTIONS(3650),
    [anon_sym_if] = ACTIONS(3648),
    [anon_sym_COLON] = ACTIONS(3648),
    [anon_sym_in] = ACTIONS(3648),
    [anon_sym_EQ] = ACTIONS(3650),
    [anon_sym_AT] = ACTIONS(3650),
    [anon_sym_not] = ACTIONS(3648),
    [anon_sym_and] = ACTIONS(3648),
    [anon_sym_or] = ACTIONS(3648),
    [anon_sym_PLUS] = ACTIONS(3650),
    [anon_sym_DASH] = ACTIONS(3650),
    [anon_sym_SLASH] = ACTIONS(3650),
    [anon_sym_PERCENT] = ACTIONS(3650),
    [anon_sym_SLASH_SLASH] = ACTIONS(3650),
    [anon_sym_STAR_STAR] = ACTIONS(3650),
    [anon_sym_PIPE] = ACTIONS(3650),
    [anon_sym_AMP] = ACTIONS(3650),
    [anon_sym_CARET] = ACTIONS(3650),
    [anon_sym_LT_LT] = ACTIONS(3650),
    [anon_sym_LT] = ACTIONS(3650),
    [anon_sym_LT_EQ] = ACTIONS(3648),
    [anon_sym_EQ_EQ] = ACTIONS(3648),
    [anon_sym_BANG_EQ] = ACTIONS(3648),
    [anon_sym_GT_EQ] = ACTIONS(3648),
    [anon_sym_GT] = ACTIONS(3650),
    [anon_sym_LT_GT] = ACTIONS(3648),
    [anon_sym_is] = ACTIONS(3648),
    [anon_sym_PLUS_EQ] = ACTIONS(3648),
    [anon_sym_DASH_EQ] = ACTIONS(3648),
    [anon_sym_STAR_EQ] = ACTIONS(3648),
    [anon_sym_SLASH_EQ] = ACTIONS(3648),
    [anon_sym_AT_EQ] = ACTIONS(3648),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3648),
    [anon_sym_PERCENT_EQ] = ACTIONS(3648),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3648),
    [anon_sym_GT_GT_EQ] = ACTIONS(3648),
    [anon_sym_LT_LT_EQ] = ACTIONS(3648),
    [anon_sym_AMP_EQ] = ACTIONS(3648),
    [anon_sym_CARET_EQ] = ACTIONS(3648),
    [anon_sym_PIPE_EQ] = ACTIONS(3648),
    [anon_sym_LBRACK] = ACTIONS(3648),
    [sym_comment] = ACTIONS(72),
    [sym__semicolon] = ACTIONS(3648),
  },
  [1372] = {
    [anon_sym_COMMA] = ACTIONS(3652),
    [anon_sym_if] = ACTIONS(2002),
    [anon_sym_COLON] = ACTIONS(2004),
    [anon_sym_and] = ACTIONS(2006),
    [anon_sym_or] = ACTIONS(2008),
    [anon_sym_RBRACK] = ACTIONS(3652),
    [sym_comment] = ACTIONS(72),
  },
  [1373] = {
    [anon_sym_COMMA] = ACTIONS(3652),
    [anon_sym_RBRACK] = ACTIONS(3652),
    [sym_comment] = ACTIONS(72),
  },
  [1374] = {
    [anon_sym_if] = ACTIONS(1921),
    [anon_sym_else] = ACTIONS(3654),
    [anon_sym_and] = ACTIONS(1925),
    [anon_sym_or] = ACTIONS(1927),
    [sym_comment] = ACTIONS(72),
  },
  [1375] = {
    [anon_sym_COMMA] = ACTIONS(3643),
    [anon_sym_if] = ACTIONS(2002),
    [anon_sym_COLON] = ACTIONS(3656),
    [anon_sym_and] = ACTIONS(2006),
    [anon_sym_or] = ACTIONS(2008),
    [anon_sym_RBRACK] = ACTIONS(3643),
    [sym_comment] = ACTIONS(72),
  },
  [1376] = {
    [anon_sym_COMMA] = ACTIONS(1953),
    [anon_sym_if] = ACTIONS(1953),
    [anon_sym_COLON] = ACTIONS(1953),
    [anon_sym_and] = ACTIONS(2006),
    [anon_sym_or] = ACTIONS(1953),
    [anon_sym_RBRACK] = ACTIONS(1953),
    [sym_comment] = ACTIONS(72),
  },
  [1377] = {
    [sym__expression] = STATE(1372),
    [sym__primary_expression] = STATE(542),
    [sym_not_operator] = STATE(1372),
    [sym_boolean_operator] = STATE(1372),
    [sym_binary_operator] = STATE(542),
    [sym_unary_operator] = STATE(542),
    [sym_comparison_operator] = STATE(1372),
    [sym_lambda] = STATE(1372),
    [sym_attribute] = STATE(542),
    [sym_subscript] = STATE(542),
    [sym_slice] = STATE(1373),
    [sym_call] = STATE(542),
    [sym_list] = STATE(542),
    [sym_list_comprehension] = STATE(542),
    [sym_dictionary] = STATE(542),
    [sym_dictionary_comprehension] = STATE(542),
    [sym_set] = STATE(542),
    [sym_set_comprehension] = STATE(542),
    [sym_parenthesized_expression] = STATE(542),
    [sym_tuple] = STATE(542),
    [sym_generator_expression] = STATE(542),
    [sym_conditional_expression] = STATE(1372),
    [sym_concatenated_string] = STATE(542),
    [sym_await] = STATE(1372),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_COLON] = ACTIONS(978),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_not] = ACTIONS(980),
    [anon_sym_PLUS] = ACTIONS(982),
    [anon_sym_DASH] = ACTIONS(982),
    [anon_sym_TILDE] = ACTIONS(982),
    [anon_sym_lambda] = ACTIONS(984),
    [anon_sym_LBRACK] = ACTIONS(96),
    [anon_sym_RBRACK] = ACTIONS(3658),
    [sym_ellipsis] = ACTIONS(986),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(988),
    [sym_integer] = ACTIONS(990),
    [sym_float] = ACTIONS(990),
    [sym_identifier] = ACTIONS(990),
    [sym_true] = ACTIONS(990),
    [sym_false] = ACTIONS(990),
    [sym_none] = ACTIONS(990),
    [anon_sym_await] = ACTIONS(992),
    [sym_comment] = ACTIONS(72),
  },
  [1378] = {
    [aux_sym_subscript_repeat1] = STATE(1378),
    [anon_sym_COMMA] = ACTIONS(3660),
    [anon_sym_RBRACK] = ACTIONS(3652),
    [sym_comment] = ACTIONS(72),
  },
  [1379] = {
    [sym_argument_list] = STATE(251),
    [sym_generator_expression] = STATE(251),
    [anon_sym_DOT] = ACTIONS(1980),
    [anon_sym_LPAREN] = ACTIONS(424),
    [anon_sym_COMMA] = ACTIONS(1980),
    [anon_sym_STAR] = ACTIONS(1982),
    [anon_sym_GT_GT] = ACTIONS(1980),
    [anon_sym_if] = ACTIONS(1980),
    [anon_sym_COLON] = ACTIONS(1980),
    [anon_sym_in] = ACTIONS(1980),
    [anon_sym_AT] = ACTIONS(1980),
    [anon_sym_not] = ACTIONS(1980),
    [anon_sym_and] = ACTIONS(1980),
    [anon_sym_or] = ACTIONS(1980),
    [anon_sym_PLUS] = ACTIONS(1980),
    [anon_sym_DASH] = ACTIONS(1980),
    [anon_sym_SLASH] = ACTIONS(1982),
    [anon_sym_PERCENT] = ACTIONS(1980),
    [anon_sym_SLASH_SLASH] = ACTIONS(1980),
    [anon_sym_STAR_STAR] = ACTIONS(2024),
    [anon_sym_PIPE] = ACTIONS(1980),
    [anon_sym_AMP] = ACTIONS(1980),
    [anon_sym_CARET] = ACTIONS(1980),
    [anon_sym_LT_LT] = ACTIONS(1980),
    [anon_sym_LT] = ACTIONS(1982),
    [anon_sym_LT_EQ] = ACTIONS(1980),
    [anon_sym_EQ_EQ] = ACTIONS(1980),
    [anon_sym_BANG_EQ] = ACTIONS(1980),
    [anon_sym_GT_EQ] = ACTIONS(1980),
    [anon_sym_GT] = ACTIONS(1982),
    [anon_sym_LT_GT] = ACTIONS(1980),
    [anon_sym_is] = ACTIONS(1980),
    [anon_sym_LBRACK] = ACTIONS(1980),
    [anon_sym_RBRACK] = ACTIONS(1980),
    [sym_comment] = ACTIONS(72),
  },
  [1380] = {
    [sym_argument_list] = STATE(251),
    [sym_generator_expression] = STATE(251),
    [anon_sym_DOT] = ACTIONS(1980),
    [anon_sym_LPAREN] = ACTIONS(424),
    [anon_sym_COMMA] = ACTIONS(1980),
    [anon_sym_STAR] = ACTIONS(2012),
    [anon_sym_GT_GT] = ACTIONS(1980),
    [anon_sym_if] = ACTIONS(1980),
    [anon_sym_COLON] = ACTIONS(1980),
    [anon_sym_in] = ACTIONS(1980),
    [anon_sym_AT] = ACTIONS(2018),
    [anon_sym_not] = ACTIONS(1980),
    [anon_sym_and] = ACTIONS(1980),
    [anon_sym_or] = ACTIONS(1980),
    [anon_sym_PLUS] = ACTIONS(2022),
    [anon_sym_DASH] = ACTIONS(2022),
    [anon_sym_SLASH] = ACTIONS(2012),
    [anon_sym_PERCENT] = ACTIONS(2018),
    [anon_sym_SLASH_SLASH] = ACTIONS(2018),
    [anon_sym_STAR_STAR] = ACTIONS(2024),
    [anon_sym_PIPE] = ACTIONS(1980),
    [anon_sym_AMP] = ACTIONS(1980),
    [anon_sym_CARET] = ACTIONS(1980),
    [anon_sym_LT_LT] = ACTIONS(1980),
    [anon_sym_LT] = ACTIONS(1982),
    [anon_sym_LT_EQ] = ACTIONS(1980),
    [anon_sym_EQ_EQ] = ACTIONS(1980),
    [anon_sym_BANG_EQ] = ACTIONS(1980),
    [anon_sym_GT_EQ] = ACTIONS(1980),
    [anon_sym_GT] = ACTIONS(1982),
    [anon_sym_LT_GT] = ACTIONS(1980),
    [anon_sym_is] = ACTIONS(1980),
    [anon_sym_LBRACK] = ACTIONS(1980),
    [anon_sym_RBRACK] = ACTIONS(1980),
    [sym_comment] = ACTIONS(72),
  },
  [1381] = {
    [sym_argument_list] = STATE(251),
    [sym_generator_expression] = STATE(251),
    [anon_sym_DOT] = ACTIONS(422),
    [anon_sym_LPAREN] = ACTIONS(424),
    [anon_sym_COMMA] = ACTIONS(1984),
    [anon_sym_STAR] = ACTIONS(2012),
    [anon_sym_GT_GT] = ACTIONS(2014),
    [anon_sym_if] = ACTIONS(1984),
    [anon_sym_COLON] = ACTIONS(1984),
    [anon_sym_in] = ACTIONS(1984),
    [anon_sym_AT] = ACTIONS(2018),
    [anon_sym_not] = ACTIONS(1984),
    [anon_sym_and] = ACTIONS(1984),
    [anon_sym_or] = ACTIONS(1984),
    [anon_sym_PLUS] = ACTIONS(2022),
    [anon_sym_DASH] = ACTIONS(2022),
    [anon_sym_SLASH] = ACTIONS(2012),
    [anon_sym_PERCENT] = ACTIONS(2018),
    [anon_sym_SLASH_SLASH] = ACTIONS(2018),
    [anon_sym_STAR_STAR] = ACTIONS(2024),
    [anon_sym_PIPE] = ACTIONS(2026),
    [anon_sym_AMP] = ACTIONS(2028),
    [anon_sym_CARET] = ACTIONS(2030),
    [anon_sym_LT_LT] = ACTIONS(2014),
    [anon_sym_LT] = ACTIONS(1986),
    [anon_sym_LT_EQ] = ACTIONS(1984),
    [anon_sym_EQ_EQ] = ACTIONS(1984),
    [anon_sym_BANG_EQ] = ACTIONS(1984),
    [anon_sym_GT_EQ] = ACTIONS(1984),
    [anon_sym_GT] = ACTIONS(1986),
    [anon_sym_LT_GT] = ACTIONS(1984),
    [anon_sym_is] = ACTIONS(1984),
    [anon_sym_LBRACK] = ACTIONS(450),
    [anon_sym_RBRACK] = ACTIONS(1984),
    [sym_comment] = ACTIONS(72),
  },
  [1382] = {
    [sym__primary_expression] = STATE(1636),
    [sym_binary_operator] = STATE(1636),
    [sym_unary_operator] = STATE(1636),
    [sym_attribute] = STATE(1636),
    [sym_subscript] = STATE(1636),
    [sym_call] = STATE(1636),
    [sym_list] = STATE(1636),
    [sym_list_comprehension] = STATE(1636),
    [sym_dictionary] = STATE(1636),
    [sym_dictionary_comprehension] = STATE(1636),
    [sym_set] = STATE(1636),
    [sym_set_comprehension] = STATE(1636),
    [sym_parenthesized_expression] = STATE(1636),
    [sym_tuple] = STATE(1636),
    [sym_generator_expression] = STATE(1636),
    [sym_concatenated_string] = STATE(1636),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_PLUS] = ACTIONS(982),
    [anon_sym_DASH] = ACTIONS(982),
    [anon_sym_TILDE] = ACTIONS(982),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(3663),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(988),
    [sym_integer] = ACTIONS(3665),
    [sym_float] = ACTIONS(3665),
    [sym_identifier] = ACTIONS(3665),
    [sym_true] = ACTIONS(3665),
    [sym_false] = ACTIONS(3665),
    [sym_none] = ACTIONS(3665),
    [sym_comment] = ACTIONS(72),
  },
  [1383] = {
    [sym_argument_list] = STATE(251),
    [sym_generator_expression] = STATE(251),
    [anon_sym_DOT] = ACTIONS(1980),
    [anon_sym_LPAREN] = ACTIONS(424),
    [anon_sym_COMMA] = ACTIONS(1980),
    [anon_sym_STAR] = ACTIONS(2012),
    [anon_sym_GT_GT] = ACTIONS(1980),
    [anon_sym_if] = ACTIONS(1980),
    [anon_sym_COLON] = ACTIONS(1980),
    [anon_sym_in] = ACTIONS(1980),
    [anon_sym_AT] = ACTIONS(2018),
    [anon_sym_not] = ACTIONS(1980),
    [anon_sym_and] = ACTIONS(1980),
    [anon_sym_or] = ACTIONS(1980),
    [anon_sym_PLUS] = ACTIONS(1980),
    [anon_sym_DASH] = ACTIONS(1980),
    [anon_sym_SLASH] = ACTIONS(2012),
    [anon_sym_PERCENT] = ACTIONS(2018),
    [anon_sym_SLASH_SLASH] = ACTIONS(2018),
    [anon_sym_STAR_STAR] = ACTIONS(2024),
    [anon_sym_PIPE] = ACTIONS(1980),
    [anon_sym_AMP] = ACTIONS(1980),
    [anon_sym_CARET] = ACTIONS(1980),
    [anon_sym_LT_LT] = ACTIONS(1980),
    [anon_sym_LT] = ACTIONS(1982),
    [anon_sym_LT_EQ] = ACTIONS(1980),
    [anon_sym_EQ_EQ] = ACTIONS(1980),
    [anon_sym_BANG_EQ] = ACTIONS(1980),
    [anon_sym_GT_EQ] = ACTIONS(1980),
    [anon_sym_GT] = ACTIONS(1982),
    [anon_sym_LT_GT] = ACTIONS(1980),
    [anon_sym_is] = ACTIONS(1980),
    [anon_sym_LBRACK] = ACTIONS(1980),
    [anon_sym_RBRACK] = ACTIONS(1980),
    [sym_comment] = ACTIONS(72),
  },
  [1384] = {
    [sym_argument_list] = STATE(251),
    [sym_generator_expression] = STATE(251),
    [anon_sym_DOT] = ACTIONS(1980),
    [anon_sym_LPAREN] = ACTIONS(424),
    [anon_sym_COMMA] = ACTIONS(1980),
    [anon_sym_STAR] = ACTIONS(2012),
    [anon_sym_GT_GT] = ACTIONS(2014),
    [anon_sym_if] = ACTIONS(1980),
    [anon_sym_COLON] = ACTIONS(1980),
    [anon_sym_in] = ACTIONS(1980),
    [anon_sym_AT] = ACTIONS(2018),
    [anon_sym_not] = ACTIONS(1980),
    [anon_sym_and] = ACTIONS(1980),
    [anon_sym_or] = ACTIONS(1980),
    [anon_sym_PLUS] = ACTIONS(2022),
    [anon_sym_DASH] = ACTIONS(2022),
    [anon_sym_SLASH] = ACTIONS(2012),
    [anon_sym_PERCENT] = ACTIONS(2018),
    [anon_sym_SLASH_SLASH] = ACTIONS(2018),
    [anon_sym_STAR_STAR] = ACTIONS(2024),
    [anon_sym_PIPE] = ACTIONS(1980),
    [anon_sym_AMP] = ACTIONS(2028),
    [anon_sym_CARET] = ACTIONS(2030),
    [anon_sym_LT_LT] = ACTIONS(2014),
    [anon_sym_LT] = ACTIONS(1982),
    [anon_sym_LT_EQ] = ACTIONS(1980),
    [anon_sym_EQ_EQ] = ACTIONS(1980),
    [anon_sym_BANG_EQ] = ACTIONS(1980),
    [anon_sym_GT_EQ] = ACTIONS(1980),
    [anon_sym_GT] = ACTIONS(1982),
    [anon_sym_LT_GT] = ACTIONS(1980),
    [anon_sym_is] = ACTIONS(1980),
    [anon_sym_LBRACK] = ACTIONS(1980),
    [anon_sym_RBRACK] = ACTIONS(1980),
    [sym_comment] = ACTIONS(72),
  },
  [1385] = {
    [sym_argument_list] = STATE(251),
    [sym_generator_expression] = STATE(251),
    [anon_sym_DOT] = ACTIONS(1980),
    [anon_sym_LPAREN] = ACTIONS(424),
    [anon_sym_COMMA] = ACTIONS(1980),
    [anon_sym_STAR] = ACTIONS(2012),
    [anon_sym_GT_GT] = ACTIONS(2014),
    [anon_sym_if] = ACTIONS(1980),
    [anon_sym_COLON] = ACTIONS(1980),
    [anon_sym_in] = ACTIONS(1980),
    [anon_sym_AT] = ACTIONS(2018),
    [anon_sym_not] = ACTIONS(1980),
    [anon_sym_and] = ACTIONS(1980),
    [anon_sym_or] = ACTIONS(1980),
    [anon_sym_PLUS] = ACTIONS(2022),
    [anon_sym_DASH] = ACTIONS(2022),
    [anon_sym_SLASH] = ACTIONS(2012),
    [anon_sym_PERCENT] = ACTIONS(2018),
    [anon_sym_SLASH_SLASH] = ACTIONS(2018),
    [anon_sym_STAR_STAR] = ACTIONS(2024),
    [anon_sym_PIPE] = ACTIONS(1980),
    [anon_sym_AMP] = ACTIONS(1980),
    [anon_sym_CARET] = ACTIONS(2030),
    [anon_sym_LT_LT] = ACTIONS(2014),
    [anon_sym_LT] = ACTIONS(1982),
    [anon_sym_LT_EQ] = ACTIONS(1980),
    [anon_sym_EQ_EQ] = ACTIONS(1980),
    [anon_sym_BANG_EQ] = ACTIONS(1980),
    [anon_sym_GT_EQ] = ACTIONS(1980),
    [anon_sym_GT] = ACTIONS(1982),
    [anon_sym_LT_GT] = ACTIONS(1980),
    [anon_sym_is] = ACTIONS(1980),
    [anon_sym_LBRACK] = ACTIONS(1980),
    [anon_sym_RBRACK] = ACTIONS(1980),
    [sym_comment] = ACTIONS(72),
  },
  [1386] = {
    [sym_argument_list] = STATE(251),
    [sym_generator_expression] = STATE(251),
    [anon_sym_DOT] = ACTIONS(1980),
    [anon_sym_LPAREN] = ACTIONS(424),
    [anon_sym_COMMA] = ACTIONS(1980),
    [anon_sym_STAR] = ACTIONS(2012),
    [anon_sym_GT_GT] = ACTIONS(2014),
    [anon_sym_if] = ACTIONS(1980),
    [anon_sym_COLON] = ACTIONS(1980),
    [anon_sym_in] = ACTIONS(1980),
    [anon_sym_AT] = ACTIONS(2018),
    [anon_sym_not] = ACTIONS(1980),
    [anon_sym_and] = ACTIONS(1980),
    [anon_sym_or] = ACTIONS(1980),
    [anon_sym_PLUS] = ACTIONS(2022),
    [anon_sym_DASH] = ACTIONS(2022),
    [anon_sym_SLASH] = ACTIONS(2012),
    [anon_sym_PERCENT] = ACTIONS(2018),
    [anon_sym_SLASH_SLASH] = ACTIONS(2018),
    [anon_sym_STAR_STAR] = ACTIONS(2024),
    [anon_sym_PIPE] = ACTIONS(1980),
    [anon_sym_AMP] = ACTIONS(1980),
    [anon_sym_CARET] = ACTIONS(1980),
    [anon_sym_LT_LT] = ACTIONS(2014),
    [anon_sym_LT] = ACTIONS(1982),
    [anon_sym_LT_EQ] = ACTIONS(1980),
    [anon_sym_EQ_EQ] = ACTIONS(1980),
    [anon_sym_BANG_EQ] = ACTIONS(1980),
    [anon_sym_GT_EQ] = ACTIONS(1980),
    [anon_sym_GT] = ACTIONS(1982),
    [anon_sym_LT_GT] = ACTIONS(1980),
    [anon_sym_is] = ACTIONS(1980),
    [anon_sym_LBRACK] = ACTIONS(1980),
    [anon_sym_RBRACK] = ACTIONS(1980),
    [sym_comment] = ACTIONS(72),
  },
  [1387] = {
    [aux_sym_comparison_operator_repeat1] = STATE(1387),
    [anon_sym_COMMA] = ACTIONS(1984),
    [anon_sym_if] = ACTIONS(1984),
    [anon_sym_COLON] = ACTIONS(1984),
    [anon_sym_in] = ACTIONS(3667),
    [anon_sym_not] = ACTIONS(3670),
    [anon_sym_and] = ACTIONS(1984),
    [anon_sym_or] = ACTIONS(1984),
    [anon_sym_LT] = ACTIONS(3673),
    [anon_sym_LT_EQ] = ACTIONS(3667),
    [anon_sym_EQ_EQ] = ACTIONS(3667),
    [anon_sym_BANG_EQ] = ACTIONS(3667),
    [anon_sym_GT_EQ] = ACTIONS(3667),
    [anon_sym_GT] = ACTIONS(3673),
    [anon_sym_LT_GT] = ACTIONS(3667),
    [anon_sym_is] = ACTIONS(3676),
    [anon_sym_RBRACK] = ACTIONS(1984),
    [sym_comment] = ACTIONS(72),
  },
  [1388] = {
    [aux_sym_dotted_name_repeat1] = STATE(1637),
    [anon_sym_DOT] = ACTIONS(354),
    [anon_sym_RPAREN] = ACTIONS(1108),
    [anon_sym_COMMA] = ACTIONS(1108),
    [anon_sym_as] = ACTIONS(1108),
    [sym_comment] = ACTIONS(72),
  },
  [1389] = {
    [sym__newline] = ACTIONS(3679),
    [sym_comment] = ACTIONS(72),
    [sym__semicolon] = ACTIONS(3679),
  },
  [1390] = {
    [sym_aliased_import] = STATE(1638),
    [sym_dotted_name] = STATE(1639),
    [anon_sym_RPAREN] = ACTIONS(1110),
    [sym_identifier] = ACTIONS(2065),
    [sym_comment] = ACTIONS(72),
  },
  [1391] = {
    [aux_sym__import_list_repeat1] = STATE(1641),
    [anon_sym_RPAREN] = ACTIONS(1110),
    [anon_sym_COMMA] = ACTIONS(3681),
    [sym_comment] = ACTIONS(72),
  },
  [1392] = {
    [sym_identifier] = ACTIONS(3683),
    [sym_comment] = ACTIONS(72),
  },
  [1393] = {
    [anon_sym_DOT] = ACTIONS(3092),
    [anon_sym_LPAREN] = ACTIONS(3092),
    [anon_sym_RPAREN] = ACTIONS(3092),
    [anon_sym_COMMA] = ACTIONS(3092),
    [anon_sym_as] = ACTIONS(3094),
    [anon_sym_STAR] = ACTIONS(3094),
    [anon_sym_GT_GT] = ACTIONS(3092),
    [anon_sym_if] = ACTIONS(3092),
    [anon_sym_COLON] = ACTIONS(3092),
    [anon_sym_else] = ACTIONS(3092),
    [anon_sym_async] = ACTIONS(3092),
    [anon_sym_for] = ACTIONS(3092),
    [anon_sym_in] = ACTIONS(3092),
    [anon_sym_EQ] = ACTIONS(3094),
    [anon_sym_AT] = ACTIONS(3092),
    [anon_sym_not] = ACTIONS(3092),
    [anon_sym_and] = ACTIONS(3092),
    [anon_sym_or] = ACTIONS(3092),
    [anon_sym_PLUS] = ACTIONS(3092),
    [anon_sym_DASH] = ACTIONS(3092),
    [anon_sym_SLASH] = ACTIONS(3094),
    [anon_sym_PERCENT] = ACTIONS(3092),
    [anon_sym_SLASH_SLASH] = ACTIONS(3092),
    [anon_sym_STAR_STAR] = ACTIONS(3092),
    [anon_sym_PIPE] = ACTIONS(3092),
    [anon_sym_AMP] = ACTIONS(3092),
    [anon_sym_CARET] = ACTIONS(3092),
    [anon_sym_LT_LT] = ACTIONS(3092),
    [anon_sym_LT] = ACTIONS(3094),
    [anon_sym_LT_EQ] = ACTIONS(3092),
    [anon_sym_EQ_EQ] = ACTIONS(3092),
    [anon_sym_BANG_EQ] = ACTIONS(3092),
    [anon_sym_GT_EQ] = ACTIONS(3092),
    [anon_sym_GT] = ACTIONS(3094),
    [anon_sym_LT_GT] = ACTIONS(3092),
    [anon_sym_is] = ACTIONS(3092),
    [anon_sym_LBRACK] = ACTIONS(3092),
    [anon_sym_RBRACK] = ACTIONS(3092),
    [anon_sym_RBRACE] = ACTIONS(3092),
    [sym_comment] = ACTIONS(72),
  },
  [1394] = {
    [anon_sym_RPAREN] = ACTIONS(2642),
    [anon_sym_COMMA] = ACTIONS(2642),
    [anon_sym_if] = ACTIONS(1147),
    [anon_sym_and] = ACTIONS(1149),
    [anon_sym_or] = ACTIONS(1151),
    [sym_comment] = ACTIONS(72),
  },
  [1395] = {
    [sym__expression] = STATE(1643),
    [sym__primary_expression] = STATE(215),
    [sym_not_operator] = STATE(1643),
    [sym_boolean_operator] = STATE(1643),
    [sym_binary_operator] = STATE(215),
    [sym_unary_operator] = STATE(215),
    [sym_comparison_operator] = STATE(1643),
    [sym_lambda] = STATE(1643),
    [sym_attribute] = STATE(215),
    [sym_subscript] = STATE(215),
    [sym_call] = STATE(215),
    [sym_list] = STATE(215),
    [sym_list_comprehension] = STATE(215),
    [sym_dictionary] = STATE(215),
    [sym_dictionary_comprehension] = STATE(215),
    [sym_set] = STATE(215),
    [sym_set_comprehension] = STATE(215),
    [sym_parenthesized_expression] = STATE(215),
    [sym_tuple] = STATE(215),
    [sym_generator_expression] = STATE(215),
    [sym_conditional_expression] = STATE(1643),
    [sym_concatenated_string] = STATE(215),
    [sym_await] = STATE(1643),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_not] = ACTIONS(384),
    [anon_sym_PLUS] = ACTIONS(386),
    [anon_sym_DASH] = ACTIONS(386),
    [anon_sym_TILDE] = ACTIONS(386),
    [anon_sym_lambda] = ACTIONS(388),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(390),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(392),
    [sym_integer] = ACTIONS(394),
    [sym_float] = ACTIONS(394),
    [sym_identifier] = ACTIONS(394),
    [sym_true] = ACTIONS(394),
    [sym_false] = ACTIONS(394),
    [sym_none] = ACTIONS(394),
    [anon_sym_await] = ACTIONS(396),
    [sym_comment] = ACTIONS(72),
  },
  [1396] = {
    [sym__expression] = STATE(1032),
    [sym__primary_expression] = STATE(215),
    [sym_not_operator] = STATE(1032),
    [sym_boolean_operator] = STATE(1032),
    [sym_binary_operator] = STATE(215),
    [sym_unary_operator] = STATE(215),
    [sym_comparison_operator] = STATE(1032),
    [sym_lambda] = STATE(1032),
    [sym_attribute] = STATE(215),
    [sym_subscript] = STATE(215),
    [sym_call] = STATE(215),
    [sym_list] = STATE(215),
    [sym_list_comprehension] = STATE(215),
    [sym_dictionary] = STATE(215),
    [sym_dictionary_comprehension] = STATE(215),
    [sym_set] = STATE(215),
    [sym_set_comprehension] = STATE(215),
    [sym_parenthesized_expression] = STATE(215),
    [sym_tuple] = STATE(215),
    [sym_generator_expression] = STATE(215),
    [sym_conditional_expression] = STATE(1032),
    [sym_concatenated_string] = STATE(215),
    [sym_await] = STATE(1032),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_not] = ACTIONS(384),
    [anon_sym_PLUS] = ACTIONS(386),
    [anon_sym_DASH] = ACTIONS(386),
    [anon_sym_TILDE] = ACTIONS(386),
    [anon_sym_lambda] = ACTIONS(388),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(390),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(392),
    [sym_integer] = ACTIONS(394),
    [sym_float] = ACTIONS(394),
    [sym_identifier] = ACTIONS(394),
    [sym_true] = ACTIONS(394),
    [sym_false] = ACTIONS(394),
    [sym_none] = ACTIONS(394),
    [anon_sym_await] = ACTIONS(396),
    [sym_comment] = ACTIONS(72),
  },
  [1397] = {
    [sym_argument_list] = STATE(251),
    [sym_generator_expression] = STATE(251),
    [anon_sym_DOT] = ACTIONS(422),
    [anon_sym_LPAREN] = ACTIONS(424),
    [anon_sym_RPAREN] = ACTIONS(2953),
    [anon_sym_COMMA] = ACTIONS(2953),
    [anon_sym_STAR] = ACTIONS(1153),
    [anon_sym_GT_GT] = ACTIONS(1155),
    [anon_sym_if] = ACTIONS(2953),
    [anon_sym_in] = ACTIONS(2953),
    [anon_sym_AT] = ACTIONS(1159),
    [anon_sym_not] = ACTIONS(2953),
    [anon_sym_and] = ACTIONS(2953),
    [anon_sym_or] = ACTIONS(2953),
    [anon_sym_PLUS] = ACTIONS(1163),
    [anon_sym_DASH] = ACTIONS(1163),
    [anon_sym_SLASH] = ACTIONS(1153),
    [anon_sym_PERCENT] = ACTIONS(1159),
    [anon_sym_SLASH_SLASH] = ACTIONS(1159),
    [anon_sym_STAR_STAR] = ACTIONS(1165),
    [anon_sym_PIPE] = ACTIONS(1167),
    [anon_sym_AMP] = ACTIONS(1169),
    [anon_sym_CARET] = ACTIONS(1171),
    [anon_sym_LT_LT] = ACTIONS(1155),
    [anon_sym_LT] = ACTIONS(2955),
    [anon_sym_LT_EQ] = ACTIONS(2953),
    [anon_sym_EQ_EQ] = ACTIONS(2953),
    [anon_sym_BANG_EQ] = ACTIONS(2953),
    [anon_sym_GT_EQ] = ACTIONS(2953),
    [anon_sym_GT] = ACTIONS(2955),
    [anon_sym_LT_GT] = ACTIONS(2953),
    [anon_sym_is] = ACTIONS(2953),
    [anon_sym_LBRACK] = ACTIONS(450),
    [sym_comment] = ACTIONS(72),
  },
  [1398] = {
    [anon_sym_DOT] = ACTIONS(3423),
    [anon_sym_LPAREN] = ACTIONS(3423),
    [anon_sym_RPAREN] = ACTIONS(3423),
    [anon_sym_COMMA] = ACTIONS(3423),
    [anon_sym_as] = ACTIONS(3425),
    [anon_sym_STAR] = ACTIONS(3425),
    [anon_sym_GT_GT] = ACTIONS(3423),
    [anon_sym_if] = ACTIONS(3423),
    [anon_sym_COLON] = ACTIONS(3423),
    [anon_sym_else] = ACTIONS(3423),
    [anon_sym_async] = ACTIONS(3423),
    [anon_sym_for] = ACTIONS(3423),
    [anon_sym_in] = ACTIONS(3423),
    [anon_sym_EQ] = ACTIONS(3425),
    [anon_sym_AT] = ACTIONS(3423),
    [anon_sym_not] = ACTIONS(3423),
    [anon_sym_and] = ACTIONS(3423),
    [anon_sym_or] = ACTIONS(3423),
    [anon_sym_PLUS] = ACTIONS(3423),
    [anon_sym_DASH] = ACTIONS(3423),
    [anon_sym_SLASH] = ACTIONS(3425),
    [anon_sym_PERCENT] = ACTIONS(3423),
    [anon_sym_SLASH_SLASH] = ACTIONS(3423),
    [anon_sym_STAR_STAR] = ACTIONS(3423),
    [anon_sym_PIPE] = ACTIONS(3423),
    [anon_sym_AMP] = ACTIONS(3423),
    [anon_sym_CARET] = ACTIONS(3423),
    [anon_sym_LT_LT] = ACTIONS(3423),
    [anon_sym_LT] = ACTIONS(3425),
    [anon_sym_LT_EQ] = ACTIONS(3423),
    [anon_sym_EQ_EQ] = ACTIONS(3423),
    [anon_sym_BANG_EQ] = ACTIONS(3423),
    [anon_sym_GT_EQ] = ACTIONS(3423),
    [anon_sym_GT] = ACTIONS(3425),
    [anon_sym_LT_GT] = ACTIONS(3423),
    [anon_sym_is] = ACTIONS(3423),
    [anon_sym_LBRACK] = ACTIONS(3423),
    [anon_sym_RBRACK] = ACTIONS(3423),
    [anon_sym_RBRACE] = ACTIONS(3423),
    [sym_comment] = ACTIONS(72),
  },
  [1399] = {
    [anon_sym_DOT] = ACTIONS(3493),
    [anon_sym_LPAREN] = ACTIONS(3493),
    [anon_sym_RPAREN] = ACTIONS(3493),
    [anon_sym_COMMA] = ACTIONS(3493),
    [anon_sym_as] = ACTIONS(3495),
    [anon_sym_STAR] = ACTIONS(3495),
    [anon_sym_GT_GT] = ACTIONS(3493),
    [anon_sym_if] = ACTIONS(3493),
    [anon_sym_COLON] = ACTIONS(3493),
    [anon_sym_else] = ACTIONS(3493),
    [anon_sym_async] = ACTIONS(3493),
    [anon_sym_for] = ACTIONS(3493),
    [anon_sym_in] = ACTIONS(3493),
    [anon_sym_EQ] = ACTIONS(3495),
    [anon_sym_AT] = ACTIONS(3493),
    [anon_sym_not] = ACTIONS(3493),
    [anon_sym_and] = ACTIONS(3493),
    [anon_sym_or] = ACTIONS(3493),
    [anon_sym_PLUS] = ACTIONS(3493),
    [anon_sym_DASH] = ACTIONS(3493),
    [anon_sym_SLASH] = ACTIONS(3495),
    [anon_sym_PERCENT] = ACTIONS(3493),
    [anon_sym_SLASH_SLASH] = ACTIONS(3493),
    [anon_sym_STAR_STAR] = ACTIONS(3493),
    [anon_sym_PIPE] = ACTIONS(3493),
    [anon_sym_AMP] = ACTIONS(3493),
    [anon_sym_CARET] = ACTIONS(3493),
    [anon_sym_LT_LT] = ACTIONS(3493),
    [anon_sym_LT] = ACTIONS(3495),
    [anon_sym_LT_EQ] = ACTIONS(3493),
    [anon_sym_EQ_EQ] = ACTIONS(3493),
    [anon_sym_BANG_EQ] = ACTIONS(3493),
    [anon_sym_GT_EQ] = ACTIONS(3493),
    [anon_sym_GT] = ACTIONS(3495),
    [anon_sym_LT_GT] = ACTIONS(3493),
    [anon_sym_is] = ACTIONS(3493),
    [anon_sym_LBRACK] = ACTIONS(3493),
    [anon_sym_RBRACK] = ACTIONS(3493),
    [anon_sym_RBRACE] = ACTIONS(3493),
    [sym_comment] = ACTIONS(72),
  },
  [1400] = {
    [anon_sym_DOT] = ACTIONS(3497),
    [anon_sym_LPAREN] = ACTIONS(3497),
    [anon_sym_RPAREN] = ACTIONS(3497),
    [anon_sym_COMMA] = ACTIONS(3497),
    [anon_sym_as] = ACTIONS(3499),
    [anon_sym_STAR] = ACTIONS(3499),
    [anon_sym_GT_GT] = ACTIONS(3497),
    [anon_sym_if] = ACTIONS(3497),
    [anon_sym_COLON] = ACTIONS(3497),
    [anon_sym_else] = ACTIONS(3497),
    [anon_sym_async] = ACTIONS(3497),
    [anon_sym_for] = ACTIONS(3497),
    [anon_sym_in] = ACTIONS(3497),
    [anon_sym_EQ] = ACTIONS(3499),
    [anon_sym_AT] = ACTIONS(3497),
    [anon_sym_not] = ACTIONS(3497),
    [anon_sym_and] = ACTIONS(3497),
    [anon_sym_or] = ACTIONS(3497),
    [anon_sym_PLUS] = ACTIONS(3497),
    [anon_sym_DASH] = ACTIONS(3497),
    [anon_sym_SLASH] = ACTIONS(3499),
    [anon_sym_PERCENT] = ACTIONS(3497),
    [anon_sym_SLASH_SLASH] = ACTIONS(3497),
    [anon_sym_STAR_STAR] = ACTIONS(3497),
    [anon_sym_PIPE] = ACTIONS(3497),
    [anon_sym_AMP] = ACTIONS(3497),
    [anon_sym_CARET] = ACTIONS(3497),
    [anon_sym_LT_LT] = ACTIONS(3497),
    [anon_sym_LT] = ACTIONS(3499),
    [anon_sym_LT_EQ] = ACTIONS(3497),
    [anon_sym_EQ_EQ] = ACTIONS(3497),
    [anon_sym_BANG_EQ] = ACTIONS(3497),
    [anon_sym_GT_EQ] = ACTIONS(3497),
    [anon_sym_GT] = ACTIONS(3499),
    [anon_sym_LT_GT] = ACTIONS(3497),
    [anon_sym_is] = ACTIONS(3497),
    [anon_sym_LBRACK] = ACTIONS(3497),
    [anon_sym_RBRACK] = ACTIONS(3497),
    [anon_sym_RBRACE] = ACTIONS(3497),
    [sym_comment] = ACTIONS(72),
  },
  [1401] = {
    [anon_sym_RPAREN] = ACTIONS(3610),
    [anon_sym_COMMA] = ACTIONS(3610),
    [anon_sym_if] = ACTIONS(412),
    [anon_sym_async] = ACTIONS(3610),
    [anon_sym_for] = ACTIONS(3610),
    [anon_sym_and] = ACTIONS(418),
    [anon_sym_or] = ACTIONS(420),
    [sym_comment] = ACTIONS(72),
  },
  [1402] = {
    [sym__expression_within_for_in_clause] = STATE(1644),
    [sym__expression] = STATE(1405),
    [sym__primary_expression] = STATE(59),
    [sym_not_operator] = STATE(1405),
    [sym_boolean_operator] = STATE(1405),
    [sym_binary_operator] = STATE(59),
    [sym_unary_operator] = STATE(59),
    [sym_comparison_operator] = STATE(1405),
    [sym_lambda] = STATE(1405),
    [sym_lambda_within_for_in_clause] = STATE(1406),
    [sym_attribute] = STATE(59),
    [sym_subscript] = STATE(59),
    [sym_call] = STATE(59),
    [sym_list] = STATE(59),
    [sym_list_comprehension] = STATE(59),
    [sym_dictionary] = STATE(59),
    [sym_dictionary_comprehension] = STATE(59),
    [sym_set] = STATE(59),
    [sym_set_comprehension] = STATE(59),
    [sym_parenthesized_expression] = STATE(59),
    [sym_tuple] = STATE(59),
    [sym_generator_expression] = STATE(59),
    [sym_conditional_expression] = STATE(1405),
    [sym_concatenated_string] = STATE(59),
    [sym_await] = STATE(1405),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_not] = ACTIONS(88),
    [anon_sym_PLUS] = ACTIONS(90),
    [anon_sym_DASH] = ACTIONS(90),
    [anon_sym_TILDE] = ACTIONS(90),
    [anon_sym_lambda] = ACTIONS(3045),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(98),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(102),
    [sym_integer] = ACTIONS(104),
    [sym_float] = ACTIONS(104),
    [sym_identifier] = ACTIONS(104),
    [sym_true] = ACTIONS(104),
    [sym_false] = ACTIONS(104),
    [sym_none] = ACTIONS(104),
    [anon_sym_await] = ACTIONS(106),
    [sym_comment] = ACTIONS(72),
  },
  [1403] = {
    [sym_lambda_parameters] = STATE(1646),
    [sym__parameters] = STATE(130),
    [sym_default_parameter] = STATE(131),
    [sym_typed_default_parameter] = STATE(131),
    [sym_list_splat] = STATE(132),
    [sym_dictionary_splat] = STATE(132),
    [sym_typed_parameter] = STATE(131),
    [sym_tuple] = STATE(131),
    [anon_sym_LPAREN] = ACTIONS(222),
    [anon_sym_STAR] = ACTIONS(224),
    [anon_sym_print] = ACTIONS(226),
    [anon_sym_COLON] = ACTIONS(3685),
    [anon_sym_exec] = ACTIONS(226),
    [sym_identifier] = ACTIONS(230),
    [sym_comment] = ACTIONS(72),
  },
  [1404] = {
    [aux_sym_for_in_clause_repeat1] = STATE(1648),
    [anon_sym_RPAREN] = ACTIONS(3687),
    [anon_sym_COMMA] = ACTIONS(3689),
    [anon_sym_if] = ACTIONS(3687),
    [anon_sym_async] = ACTIONS(3687),
    [anon_sym_for] = ACTIONS(3687),
    [sym_comment] = ACTIONS(72),
  },
  [1405] = {
    [anon_sym_RPAREN] = ACTIONS(3691),
    [anon_sym_COMMA] = ACTIONS(3691),
    [anon_sym_if] = ACTIONS(3691),
    [anon_sym_async] = ACTIONS(3691),
    [anon_sym_for] = ACTIONS(3691),
    [anon_sym_and] = ACTIONS(418),
    [anon_sym_or] = ACTIONS(420),
    [sym_comment] = ACTIONS(72),
  },
  [1406] = {
    [anon_sym_RPAREN] = ACTIONS(3693),
    [anon_sym_COMMA] = ACTIONS(3693),
    [anon_sym_if] = ACTIONS(3693),
    [anon_sym_async] = ACTIONS(3693),
    [anon_sym_for] = ACTIONS(3693),
    [anon_sym_RBRACK] = ACTIONS(3693),
    [anon_sym_RBRACE] = ACTIONS(3693),
    [sym_comment] = ACTIONS(72),
  },
  [1407] = {
    [anon_sym_RPAREN] = ACTIONS(716),
    [anon_sym_if] = ACTIONS(716),
    [anon_sym_async] = ACTIONS(716),
    [anon_sym_for] = ACTIONS(716),
    [anon_sym_and] = ACTIONS(3053),
    [anon_sym_or] = ACTIONS(3055),
    [sym_comment] = ACTIONS(72),
  },
  [1408] = {
    [sym__expression] = STATE(1649),
    [sym__primary_expression] = STATE(1064),
    [sym_not_operator] = STATE(1649),
    [sym_boolean_operator] = STATE(1649),
    [sym_binary_operator] = STATE(1064),
    [sym_unary_operator] = STATE(1064),
    [sym_comparison_operator] = STATE(1649),
    [sym_lambda] = STATE(1649),
    [sym_attribute] = STATE(1064),
    [sym_subscript] = STATE(1064),
    [sym_call] = STATE(1064),
    [sym_list] = STATE(1064),
    [sym_list_comprehension] = STATE(1064),
    [sym_dictionary] = STATE(1064),
    [sym_dictionary_comprehension] = STATE(1064),
    [sym_set] = STATE(1064),
    [sym_set_comprehension] = STATE(1064),
    [sym_parenthesized_expression] = STATE(1064),
    [sym_tuple] = STATE(1064),
    [sym_generator_expression] = STATE(1064),
    [sym_conditional_expression] = STATE(1649),
    [sym_concatenated_string] = STATE(1064),
    [sym_await] = STATE(1649),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_not] = ACTIONS(2152),
    [anon_sym_PLUS] = ACTIONS(2154),
    [anon_sym_DASH] = ACTIONS(2154),
    [anon_sym_TILDE] = ACTIONS(2154),
    [anon_sym_lambda] = ACTIONS(2156),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(2158),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(2160),
    [sym_integer] = ACTIONS(2162),
    [sym_float] = ACTIONS(2162),
    [sym_identifier] = ACTIONS(2162),
    [sym_true] = ACTIONS(2162),
    [sym_false] = ACTIONS(2162),
    [sym_none] = ACTIONS(2162),
    [anon_sym_await] = ACTIONS(2164),
    [sym_comment] = ACTIONS(72),
  },
  [1409] = {
    [anon_sym_COLON] = ACTIONS(3695),
    [sym_comment] = ACTIONS(72),
  },
  [1410] = {
    [aux_sym_concatenated_string_repeat1] = STATE(1651),
    [anon_sym_DOT] = ACTIONS(886),
    [anon_sym_LPAREN] = ACTIONS(886),
    [anon_sym_RPAREN] = ACTIONS(886),
    [anon_sym_STAR] = ACTIONS(888),
    [anon_sym_GT_GT] = ACTIONS(886),
    [anon_sym_if] = ACTIONS(886),
    [anon_sym_async] = ACTIONS(886),
    [anon_sym_for] = ACTIONS(886),
    [anon_sym_in] = ACTIONS(886),
    [anon_sym_AT] = ACTIONS(886),
    [anon_sym_not] = ACTIONS(886),
    [anon_sym_and] = ACTIONS(886),
    [anon_sym_or] = ACTIONS(886),
    [anon_sym_PLUS] = ACTIONS(886),
    [anon_sym_DASH] = ACTIONS(886),
    [anon_sym_SLASH] = ACTIONS(888),
    [anon_sym_PERCENT] = ACTIONS(886),
    [anon_sym_SLASH_SLASH] = ACTIONS(886),
    [anon_sym_STAR_STAR] = ACTIONS(886),
    [anon_sym_PIPE] = ACTIONS(886),
    [anon_sym_AMP] = ACTIONS(886),
    [anon_sym_CARET] = ACTIONS(886),
    [anon_sym_LT_LT] = ACTIONS(886),
    [anon_sym_LT] = ACTIONS(888),
    [anon_sym_LT_EQ] = ACTIONS(886),
    [anon_sym_EQ_EQ] = ACTIONS(886),
    [anon_sym_BANG_EQ] = ACTIONS(886),
    [anon_sym_GT_EQ] = ACTIONS(886),
    [anon_sym_GT] = ACTIONS(888),
    [anon_sym_LT_GT] = ACTIONS(886),
    [anon_sym_is] = ACTIONS(886),
    [anon_sym_LBRACK] = ACTIONS(886),
    [sym_string] = ACTIONS(3697),
    [sym_comment] = ACTIONS(72),
  },
  [1411] = {
    [sym__expression] = STATE(1652),
    [sym__primary_expression] = STATE(513),
    [sym_not_operator] = STATE(1652),
    [sym_boolean_operator] = STATE(1652),
    [sym_binary_operator] = STATE(513),
    [sym_unary_operator] = STATE(513),
    [sym_comparison_operator] = STATE(1652),
    [sym_lambda] = STATE(1652),
    [sym_attribute] = STATE(513),
    [sym_subscript] = STATE(513),
    [sym_call] = STATE(513),
    [sym_list] = STATE(513),
    [sym_list_comprehension] = STATE(513),
    [sym_dictionary] = STATE(513),
    [sym_dictionary_comprehension] = STATE(513),
    [sym_set] = STATE(513),
    [sym_set_comprehension] = STATE(513),
    [sym_parenthesized_expression] = STATE(513),
    [sym_tuple] = STATE(513),
    [sym_generator_expression] = STATE(513),
    [sym_conditional_expression] = STATE(1652),
    [sym_concatenated_string] = STATE(513),
    [sym_await] = STATE(1652),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_not] = ACTIONS(914),
    [anon_sym_PLUS] = ACTIONS(916),
    [anon_sym_DASH] = ACTIONS(916),
    [anon_sym_TILDE] = ACTIONS(916),
    [anon_sym_lambda] = ACTIONS(918),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(920),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(922),
    [sym_integer] = ACTIONS(924),
    [sym_float] = ACTIONS(924),
    [sym_identifier] = ACTIONS(924),
    [sym_true] = ACTIONS(924),
    [sym_false] = ACTIONS(924),
    [sym_none] = ACTIONS(924),
    [anon_sym_await] = ACTIONS(926),
    [sym_comment] = ACTIONS(72),
  },
  [1412] = {
    [sym__expression] = STATE(604),
    [sym__primary_expression] = STATE(1064),
    [sym_not_operator] = STATE(604),
    [sym_boolean_operator] = STATE(604),
    [sym_binary_operator] = STATE(1064),
    [sym_unary_operator] = STATE(1064),
    [sym_comparison_operator] = STATE(604),
    [sym_lambda] = STATE(604),
    [sym_attribute] = STATE(1064),
    [sym_subscript] = STATE(1064),
    [sym_call] = STATE(1064),
    [sym_list] = STATE(1064),
    [sym_list_comprehension] = STATE(1064),
    [sym_dictionary] = STATE(1064),
    [sym_dictionary_comprehension] = STATE(1064),
    [sym_set] = STATE(1064),
    [sym_set_comprehension] = STATE(1064),
    [sym_parenthesized_expression] = STATE(1064),
    [sym_tuple] = STATE(1064),
    [sym_generator_expression] = STATE(1064),
    [sym_conditional_expression] = STATE(604),
    [sym_concatenated_string] = STATE(1064),
    [sym_await] = STATE(604),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_not] = ACTIONS(2152),
    [anon_sym_PLUS] = ACTIONS(2154),
    [anon_sym_DASH] = ACTIONS(2154),
    [anon_sym_TILDE] = ACTIONS(2154),
    [anon_sym_lambda] = ACTIONS(2156),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(2158),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(2160),
    [sym_integer] = ACTIONS(2162),
    [sym_float] = ACTIONS(2162),
    [sym_identifier] = ACTIONS(2162),
    [sym_true] = ACTIONS(2162),
    [sym_false] = ACTIONS(2162),
    [sym_none] = ACTIONS(2162),
    [anon_sym_await] = ACTIONS(2164),
    [sym_comment] = ACTIONS(72),
  },
  [1413] = {
    [sym__expression] = STATE(1653),
    [sym__primary_expression] = STATE(1064),
    [sym_not_operator] = STATE(1653),
    [sym_boolean_operator] = STATE(1653),
    [sym_binary_operator] = STATE(1064),
    [sym_unary_operator] = STATE(1064),
    [sym_comparison_operator] = STATE(1653),
    [sym_lambda] = STATE(1653),
    [sym_attribute] = STATE(1064),
    [sym_subscript] = STATE(1064),
    [sym_call] = STATE(1064),
    [sym_list] = STATE(1064),
    [sym_list_comprehension] = STATE(1064),
    [sym_dictionary] = STATE(1064),
    [sym_dictionary_comprehension] = STATE(1064),
    [sym_set] = STATE(1064),
    [sym_set_comprehension] = STATE(1064),
    [sym_parenthesized_expression] = STATE(1064),
    [sym_tuple] = STATE(1064),
    [sym_generator_expression] = STATE(1064),
    [sym_conditional_expression] = STATE(1653),
    [sym_concatenated_string] = STATE(1064),
    [sym_await] = STATE(1653),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_not] = ACTIONS(2152),
    [anon_sym_PLUS] = ACTIONS(2154),
    [anon_sym_DASH] = ACTIONS(2154),
    [anon_sym_TILDE] = ACTIONS(2154),
    [anon_sym_lambda] = ACTIONS(2156),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(2158),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(2160),
    [sym_integer] = ACTIONS(2162),
    [sym_float] = ACTIONS(2162),
    [sym_identifier] = ACTIONS(2162),
    [sym_true] = ACTIONS(2162),
    [sym_false] = ACTIONS(2162),
    [sym_none] = ACTIONS(2162),
    [anon_sym_await] = ACTIONS(2164),
    [sym_comment] = ACTIONS(72),
  },
  [1414] = {
    [sym__primary_expression] = STATE(1654),
    [sym_binary_operator] = STATE(1654),
    [sym_unary_operator] = STATE(1654),
    [sym_attribute] = STATE(1654),
    [sym_subscript] = STATE(1654),
    [sym_call] = STATE(1654),
    [sym_list] = STATE(1654),
    [sym_list_comprehension] = STATE(1654),
    [sym_dictionary] = STATE(1654),
    [sym_dictionary_comprehension] = STATE(1654),
    [sym_set] = STATE(1654),
    [sym_set_comprehension] = STATE(1654),
    [sym_parenthesized_expression] = STATE(1654),
    [sym_tuple] = STATE(1654),
    [sym_generator_expression] = STATE(1654),
    [sym_concatenated_string] = STATE(1654),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_PLUS] = ACTIONS(2154),
    [anon_sym_DASH] = ACTIONS(2154),
    [anon_sym_TILDE] = ACTIONS(2154),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(3699),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(2160),
    [sym_integer] = ACTIONS(3701),
    [sym_float] = ACTIONS(3701),
    [sym_identifier] = ACTIONS(3701),
    [sym_true] = ACTIONS(3701),
    [sym_false] = ACTIONS(3701),
    [sym_none] = ACTIONS(3701),
    [sym_comment] = ACTIONS(72),
  },
  [1415] = {
    [sym__primary_expression] = STATE(1655),
    [sym_binary_operator] = STATE(1655),
    [sym_unary_operator] = STATE(1655),
    [sym_attribute] = STATE(1655),
    [sym_subscript] = STATE(1655),
    [sym_call] = STATE(1655),
    [sym_list] = STATE(1655),
    [sym_list_comprehension] = STATE(1655),
    [sym_dictionary] = STATE(1655),
    [sym_dictionary_comprehension] = STATE(1655),
    [sym_set] = STATE(1655),
    [sym_set_comprehension] = STATE(1655),
    [sym_parenthesized_expression] = STATE(1655),
    [sym_tuple] = STATE(1655),
    [sym_generator_expression] = STATE(1655),
    [sym_concatenated_string] = STATE(1655),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_PLUS] = ACTIONS(2154),
    [anon_sym_DASH] = ACTIONS(2154),
    [anon_sym_TILDE] = ACTIONS(2154),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(3703),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(2160),
    [sym_integer] = ACTIONS(3705),
    [sym_float] = ACTIONS(3705),
    [sym_identifier] = ACTIONS(3705),
    [sym_true] = ACTIONS(3705),
    [sym_false] = ACTIONS(3705),
    [sym_none] = ACTIONS(3705),
    [sym_comment] = ACTIONS(72),
  },
  [1416] = {
    [sym__primary_expression] = STATE(1656),
    [sym_binary_operator] = STATE(1656),
    [sym_unary_operator] = STATE(1656),
    [sym_attribute] = STATE(1656),
    [sym_subscript] = STATE(1656),
    [sym_call] = STATE(1656),
    [sym_list] = STATE(1656),
    [sym_list_comprehension] = STATE(1656),
    [sym_dictionary] = STATE(1656),
    [sym_dictionary_comprehension] = STATE(1656),
    [sym_set] = STATE(1656),
    [sym_set_comprehension] = STATE(1656),
    [sym_parenthesized_expression] = STATE(1656),
    [sym_tuple] = STATE(1656),
    [sym_generator_expression] = STATE(1656),
    [sym_concatenated_string] = STATE(1656),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_PLUS] = ACTIONS(2154),
    [anon_sym_DASH] = ACTIONS(2154),
    [anon_sym_TILDE] = ACTIONS(2154),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(3707),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(2160),
    [sym_integer] = ACTIONS(3709),
    [sym_float] = ACTIONS(3709),
    [sym_identifier] = ACTIONS(3709),
    [sym_true] = ACTIONS(3709),
    [sym_false] = ACTIONS(3709),
    [sym_none] = ACTIONS(3709),
    [sym_comment] = ACTIONS(72),
  },
  [1417] = {
    [anon_sym_in] = ACTIONS(3711),
    [sym_comment] = ACTIONS(72),
  },
  [1418] = {
    [sym__primary_expression] = STATE(1658),
    [sym_binary_operator] = STATE(1658),
    [sym_unary_operator] = STATE(1658),
    [sym_attribute] = STATE(1658),
    [sym_subscript] = STATE(1658),
    [sym_call] = STATE(1658),
    [sym_list] = STATE(1658),
    [sym_list_comprehension] = STATE(1658),
    [sym_dictionary] = STATE(1658),
    [sym_dictionary_comprehension] = STATE(1658),
    [sym_set] = STATE(1658),
    [sym_set_comprehension] = STATE(1658),
    [sym_parenthesized_expression] = STATE(1658),
    [sym_tuple] = STATE(1658),
    [sym_generator_expression] = STATE(1658),
    [sym_concatenated_string] = STATE(1658),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_PLUS] = ACTIONS(2154),
    [anon_sym_DASH] = ACTIONS(2154),
    [anon_sym_TILDE] = ACTIONS(2154),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(3713),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(2160),
    [sym_integer] = ACTIONS(3715),
    [sym_float] = ACTIONS(3715),
    [sym_identifier] = ACTIONS(3715),
    [sym_true] = ACTIONS(3715),
    [sym_false] = ACTIONS(3715),
    [sym_none] = ACTIONS(3715),
    [sym_comment] = ACTIONS(72),
  },
  [1419] = {
    [sym__primary_expression] = STATE(621),
    [sym_binary_operator] = STATE(621),
    [sym_unary_operator] = STATE(621),
    [sym_attribute] = STATE(621),
    [sym_subscript] = STATE(621),
    [sym_call] = STATE(621),
    [sym_list] = STATE(621),
    [sym_list_comprehension] = STATE(621),
    [sym_dictionary] = STATE(621),
    [sym_dictionary_comprehension] = STATE(621),
    [sym_set] = STATE(621),
    [sym_set_comprehension] = STATE(621),
    [sym_parenthesized_expression] = STATE(621),
    [sym_tuple] = STATE(621),
    [sym_generator_expression] = STATE(621),
    [sym_concatenated_string] = STATE(621),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_PLUS] = ACTIONS(2154),
    [anon_sym_DASH] = ACTIONS(2154),
    [anon_sym_TILDE] = ACTIONS(2154),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(1233),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(2160),
    [sym_integer] = ACTIONS(1235),
    [sym_float] = ACTIONS(1235),
    [sym_identifier] = ACTIONS(1235),
    [sym_true] = ACTIONS(1235),
    [sym_false] = ACTIONS(1235),
    [sym_none] = ACTIONS(1235),
    [sym_comment] = ACTIONS(72),
  },
  [1420] = {
    [sym__primary_expression] = STATE(1659),
    [sym_binary_operator] = STATE(1659),
    [sym_unary_operator] = STATE(1659),
    [sym_attribute] = STATE(1659),
    [sym_subscript] = STATE(1659),
    [sym_call] = STATE(1659),
    [sym_list] = STATE(1659),
    [sym_list_comprehension] = STATE(1659),
    [sym_dictionary] = STATE(1659),
    [sym_dictionary_comprehension] = STATE(1659),
    [sym_set] = STATE(1659),
    [sym_set_comprehension] = STATE(1659),
    [sym_parenthesized_expression] = STATE(1659),
    [sym_tuple] = STATE(1659),
    [sym_generator_expression] = STATE(1659),
    [sym_concatenated_string] = STATE(1659),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_PLUS] = ACTIONS(2154),
    [anon_sym_DASH] = ACTIONS(2154),
    [anon_sym_TILDE] = ACTIONS(2154),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(3717),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(2160),
    [sym_integer] = ACTIONS(3719),
    [sym_float] = ACTIONS(3719),
    [sym_identifier] = ACTIONS(3719),
    [sym_true] = ACTIONS(3719),
    [sym_false] = ACTIONS(3719),
    [sym_none] = ACTIONS(3719),
    [sym_comment] = ACTIONS(72),
  },
  [1421] = {
    [sym__primary_expression] = STATE(1660),
    [sym_binary_operator] = STATE(1660),
    [sym_unary_operator] = STATE(1660),
    [sym_attribute] = STATE(1660),
    [sym_subscript] = STATE(1660),
    [sym_call] = STATE(1660),
    [sym_list] = STATE(1660),
    [sym_list_comprehension] = STATE(1660),
    [sym_dictionary] = STATE(1660),
    [sym_dictionary_comprehension] = STATE(1660),
    [sym_set] = STATE(1660),
    [sym_set_comprehension] = STATE(1660),
    [sym_parenthesized_expression] = STATE(1660),
    [sym_tuple] = STATE(1660),
    [sym_generator_expression] = STATE(1660),
    [sym_concatenated_string] = STATE(1660),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_PLUS] = ACTIONS(2154),
    [anon_sym_DASH] = ACTIONS(2154),
    [anon_sym_TILDE] = ACTIONS(2154),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(3721),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(2160),
    [sym_integer] = ACTIONS(3723),
    [sym_float] = ACTIONS(3723),
    [sym_identifier] = ACTIONS(3723),
    [sym_true] = ACTIONS(3723),
    [sym_false] = ACTIONS(3723),
    [sym_none] = ACTIONS(3723),
    [sym_comment] = ACTIONS(72),
  },
  [1422] = {
    [sym__primary_expression] = STATE(1661),
    [sym_binary_operator] = STATE(1661),
    [sym_unary_operator] = STATE(1661),
    [sym_attribute] = STATE(1661),
    [sym_subscript] = STATE(1661),
    [sym_call] = STATE(1661),
    [sym_list] = STATE(1661),
    [sym_list_comprehension] = STATE(1661),
    [sym_dictionary] = STATE(1661),
    [sym_dictionary_comprehension] = STATE(1661),
    [sym_set] = STATE(1661),
    [sym_set_comprehension] = STATE(1661),
    [sym_parenthesized_expression] = STATE(1661),
    [sym_tuple] = STATE(1661),
    [sym_generator_expression] = STATE(1661),
    [sym_concatenated_string] = STATE(1661),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_PLUS] = ACTIONS(2154),
    [anon_sym_DASH] = ACTIONS(2154),
    [anon_sym_TILDE] = ACTIONS(2154),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(3725),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(2160),
    [sym_integer] = ACTIONS(3727),
    [sym_float] = ACTIONS(3727),
    [sym_identifier] = ACTIONS(3727),
    [sym_true] = ACTIONS(3727),
    [sym_false] = ACTIONS(3727),
    [sym_none] = ACTIONS(3727),
    [sym_comment] = ACTIONS(72),
  },
  [1423] = {
    [sym__primary_expression] = STATE(1656),
    [sym_binary_operator] = STATE(1656),
    [sym_unary_operator] = STATE(1656),
    [sym_attribute] = STATE(1656),
    [sym_subscript] = STATE(1656),
    [sym_call] = STATE(1656),
    [sym_list] = STATE(1656),
    [sym_list_comprehension] = STATE(1656),
    [sym_dictionary] = STATE(1656),
    [sym_dictionary_comprehension] = STATE(1656),
    [sym_set] = STATE(1656),
    [sym_set_comprehension] = STATE(1656),
    [sym_parenthesized_expression] = STATE(1656),
    [sym_tuple] = STATE(1656),
    [sym_generator_expression] = STATE(1656),
    [sym_concatenated_string] = STATE(1656),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_not] = ACTIONS(3729),
    [anon_sym_PLUS] = ACTIONS(2154),
    [anon_sym_DASH] = ACTIONS(2154),
    [anon_sym_TILDE] = ACTIONS(2154),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(3707),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(2160),
    [sym_integer] = ACTIONS(3709),
    [sym_float] = ACTIONS(3709),
    [sym_identifier] = ACTIONS(3709),
    [sym_true] = ACTIONS(3709),
    [sym_false] = ACTIONS(3709),
    [sym_none] = ACTIONS(3709),
    [sym_comment] = ACTIONS(72),
  },
  [1424] = {
    [aux_sym_comparison_operator_repeat1] = STATE(1662),
    [anon_sym_RPAREN] = ACTIONS(998),
    [anon_sym_if] = ACTIONS(998),
    [anon_sym_async] = ACTIONS(998),
    [anon_sym_for] = ACTIONS(998),
    [anon_sym_in] = ACTIONS(3061),
    [anon_sym_not] = ACTIONS(3065),
    [anon_sym_and] = ACTIONS(998),
    [anon_sym_or] = ACTIONS(998),
    [anon_sym_LT] = ACTIONS(3077),
    [anon_sym_LT_EQ] = ACTIONS(3061),
    [anon_sym_EQ_EQ] = ACTIONS(3061),
    [anon_sym_BANG_EQ] = ACTIONS(3061),
    [anon_sym_GT_EQ] = ACTIONS(3061),
    [anon_sym_GT] = ACTIONS(3077),
    [anon_sym_LT_GT] = ACTIONS(3061),
    [anon_sym_is] = ACTIONS(3079),
    [sym_comment] = ACTIONS(72),
  },
  [1425] = {
    [anon_sym_DOT] = ACTIONS(3632),
    [anon_sym_LPAREN] = ACTIONS(3632),
    [anon_sym_RPAREN] = ACTIONS(3632),
    [anon_sym_COMMA] = ACTIONS(3632),
    [anon_sym_as] = ACTIONS(3634),
    [anon_sym_STAR] = ACTIONS(3634),
    [anon_sym_GT_GT] = ACTIONS(3632),
    [anon_sym_if] = ACTIONS(3632),
    [anon_sym_COLON] = ACTIONS(3632),
    [anon_sym_else] = ACTIONS(3632),
    [anon_sym_async] = ACTIONS(3632),
    [anon_sym_for] = ACTIONS(3632),
    [anon_sym_in] = ACTIONS(3632),
    [anon_sym_EQ] = ACTIONS(3634),
    [anon_sym_AT] = ACTIONS(3632),
    [anon_sym_not] = ACTIONS(3632),
    [anon_sym_and] = ACTIONS(3632),
    [anon_sym_or] = ACTIONS(3632),
    [anon_sym_PLUS] = ACTIONS(3632),
    [anon_sym_DASH] = ACTIONS(3632),
    [anon_sym_SLASH] = ACTIONS(3634),
    [anon_sym_PERCENT] = ACTIONS(3632),
    [anon_sym_SLASH_SLASH] = ACTIONS(3632),
    [anon_sym_STAR_STAR] = ACTIONS(3632),
    [anon_sym_PIPE] = ACTIONS(3632),
    [anon_sym_AMP] = ACTIONS(3632),
    [anon_sym_CARET] = ACTIONS(3632),
    [anon_sym_LT_LT] = ACTIONS(3632),
    [anon_sym_LT] = ACTIONS(3634),
    [anon_sym_LT_EQ] = ACTIONS(3632),
    [anon_sym_EQ_EQ] = ACTIONS(3632),
    [anon_sym_BANG_EQ] = ACTIONS(3632),
    [anon_sym_GT_EQ] = ACTIONS(3632),
    [anon_sym_GT] = ACTIONS(3634),
    [anon_sym_LT_GT] = ACTIONS(3632),
    [anon_sym_is] = ACTIONS(3632),
    [anon_sym_LBRACK] = ACTIONS(3632),
    [anon_sym_RBRACK] = ACTIONS(3632),
    [anon_sym_RBRACE] = ACTIONS(3632),
    [sym_comment] = ACTIONS(72),
  },
  [1426] = {
    [sym_list_splat] = STATE(1362),
    [sym_dictionary_splat] = STATE(1362),
    [sym__expression] = STATE(1363),
    [sym__primary_expression] = STATE(215),
    [sym_not_operator] = STATE(1363),
    [sym_boolean_operator] = STATE(1363),
    [sym_binary_operator] = STATE(215),
    [sym_unary_operator] = STATE(215),
    [sym_comparison_operator] = STATE(1363),
    [sym_lambda] = STATE(1363),
    [sym_attribute] = STATE(215),
    [sym_subscript] = STATE(215),
    [sym_call] = STATE(215),
    [sym_keyword_argument] = STATE(1362),
    [sym_list] = STATE(215),
    [sym_list_comprehension] = STATE(215),
    [sym_dictionary] = STATE(215),
    [sym_dictionary_comprehension] = STATE(215),
    [sym_set] = STATE(215),
    [sym_set_comprehension] = STATE(215),
    [sym_parenthesized_expression] = STATE(215),
    [sym_tuple] = STATE(215),
    [sym_generator_expression] = STATE(215),
    [sym_conditional_expression] = STATE(1363),
    [sym_concatenated_string] = STATE(215),
    [sym_await] = STATE(1363),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_RPAREN] = ACTIONS(3731),
    [anon_sym_STAR] = ACTIONS(936),
    [anon_sym_print] = ACTIONS(938),
    [anon_sym_exec] = ACTIONS(938),
    [anon_sym_not] = ACTIONS(384),
    [anon_sym_PLUS] = ACTIONS(386),
    [anon_sym_DASH] = ACTIONS(386),
    [anon_sym_TILDE] = ACTIONS(386),
    [anon_sym_lambda] = ACTIONS(388),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(390),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(392),
    [sym_integer] = ACTIONS(394),
    [sym_float] = ACTIONS(394),
    [sym_identifier] = ACTIONS(940),
    [sym_true] = ACTIONS(394),
    [sym_false] = ACTIONS(394),
    [sym_none] = ACTIONS(394),
    [anon_sym_await] = ACTIONS(396),
    [sym_comment] = ACTIONS(72),
  },
  [1427] = {
    [anon_sym_DOT] = ACTIONS(3648),
    [anon_sym_LPAREN] = ACTIONS(3648),
    [anon_sym_RPAREN] = ACTIONS(3648),
    [anon_sym_COMMA] = ACTIONS(3648),
    [anon_sym_as] = ACTIONS(3650),
    [anon_sym_STAR] = ACTIONS(3650),
    [anon_sym_GT_GT] = ACTIONS(3648),
    [anon_sym_if] = ACTIONS(3648),
    [anon_sym_COLON] = ACTIONS(3648),
    [anon_sym_else] = ACTIONS(3648),
    [anon_sym_async] = ACTIONS(3648),
    [anon_sym_for] = ACTIONS(3648),
    [anon_sym_in] = ACTIONS(3648),
    [anon_sym_EQ] = ACTIONS(3650),
    [anon_sym_AT] = ACTIONS(3648),
    [anon_sym_not] = ACTIONS(3648),
    [anon_sym_and] = ACTIONS(3648),
    [anon_sym_or] = ACTIONS(3648),
    [anon_sym_PLUS] = ACTIONS(3648),
    [anon_sym_DASH] = ACTIONS(3648),
    [anon_sym_SLASH] = ACTIONS(3650),
    [anon_sym_PERCENT] = ACTIONS(3648),
    [anon_sym_SLASH_SLASH] = ACTIONS(3648),
    [anon_sym_STAR_STAR] = ACTIONS(3648),
    [anon_sym_PIPE] = ACTIONS(3648),
    [anon_sym_AMP] = ACTIONS(3648),
    [anon_sym_CARET] = ACTIONS(3648),
    [anon_sym_LT_LT] = ACTIONS(3648),
    [anon_sym_LT] = ACTIONS(3650),
    [anon_sym_LT_EQ] = ACTIONS(3648),
    [anon_sym_EQ_EQ] = ACTIONS(3648),
    [anon_sym_BANG_EQ] = ACTIONS(3648),
    [anon_sym_GT_EQ] = ACTIONS(3648),
    [anon_sym_GT] = ACTIONS(3650),
    [anon_sym_LT_GT] = ACTIONS(3648),
    [anon_sym_is] = ACTIONS(3648),
    [anon_sym_LBRACK] = ACTIONS(3648),
    [anon_sym_RBRACK] = ACTIONS(3648),
    [anon_sym_RBRACE] = ACTIONS(3648),
    [sym_comment] = ACTIONS(72),
  },
  [1428] = {
    [sym__expression] = STATE(1372),
    [sym__primary_expression] = STATE(542),
    [sym_not_operator] = STATE(1372),
    [sym_boolean_operator] = STATE(1372),
    [sym_binary_operator] = STATE(542),
    [sym_unary_operator] = STATE(542),
    [sym_comparison_operator] = STATE(1372),
    [sym_lambda] = STATE(1372),
    [sym_attribute] = STATE(542),
    [sym_subscript] = STATE(542),
    [sym_slice] = STATE(1373),
    [sym_call] = STATE(542),
    [sym_list] = STATE(542),
    [sym_list_comprehension] = STATE(542),
    [sym_dictionary] = STATE(542),
    [sym_dictionary_comprehension] = STATE(542),
    [sym_set] = STATE(542),
    [sym_set_comprehension] = STATE(542),
    [sym_parenthesized_expression] = STATE(542),
    [sym_tuple] = STATE(542),
    [sym_generator_expression] = STATE(542),
    [sym_conditional_expression] = STATE(1372),
    [sym_concatenated_string] = STATE(542),
    [sym_await] = STATE(1372),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_COLON] = ACTIONS(978),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_not] = ACTIONS(980),
    [anon_sym_PLUS] = ACTIONS(982),
    [anon_sym_DASH] = ACTIONS(982),
    [anon_sym_TILDE] = ACTIONS(982),
    [anon_sym_lambda] = ACTIONS(984),
    [anon_sym_LBRACK] = ACTIONS(96),
    [anon_sym_RBRACK] = ACTIONS(3733),
    [sym_ellipsis] = ACTIONS(986),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(988),
    [sym_integer] = ACTIONS(990),
    [sym_float] = ACTIONS(990),
    [sym_identifier] = ACTIONS(990),
    [sym_true] = ACTIONS(990),
    [sym_false] = ACTIONS(990),
    [sym_none] = ACTIONS(990),
    [anon_sym_await] = ACTIONS(992),
    [sym_comment] = ACTIONS(72),
  },
  [1429] = {
    [sym__newline] = ACTIONS(3092),
    [anon_sym_DOT] = ACTIONS(3092),
    [anon_sym_from] = ACTIONS(3092),
    [anon_sym_LPAREN] = ACTIONS(3092),
    [anon_sym_COMMA] = ACTIONS(3092),
    [anon_sym_STAR] = ACTIONS(3094),
    [anon_sym_GT_GT] = ACTIONS(3092),
    [anon_sym_if] = ACTIONS(3092),
    [anon_sym_in] = ACTIONS(3092),
    [anon_sym_EQ] = ACTIONS(3094),
    [anon_sym_AT] = ACTIONS(3092),
    [anon_sym_not] = ACTIONS(3092),
    [anon_sym_and] = ACTIONS(3092),
    [anon_sym_or] = ACTIONS(3092),
    [anon_sym_PLUS] = ACTIONS(3092),
    [anon_sym_DASH] = ACTIONS(3092),
    [anon_sym_SLASH] = ACTIONS(3094),
    [anon_sym_PERCENT] = ACTIONS(3092),
    [anon_sym_SLASH_SLASH] = ACTIONS(3092),
    [anon_sym_STAR_STAR] = ACTIONS(3092),
    [anon_sym_PIPE] = ACTIONS(3092),
    [anon_sym_AMP] = ACTIONS(3092),
    [anon_sym_CARET] = ACTIONS(3092),
    [anon_sym_LT_LT] = ACTIONS(3092),
    [anon_sym_LT] = ACTIONS(3094),
    [anon_sym_LT_EQ] = ACTIONS(3092),
    [anon_sym_EQ_EQ] = ACTIONS(3092),
    [anon_sym_BANG_EQ] = ACTIONS(3092),
    [anon_sym_GT_EQ] = ACTIONS(3092),
    [anon_sym_GT] = ACTIONS(3094),
    [anon_sym_LT_GT] = ACTIONS(3092),
    [anon_sym_is] = ACTIONS(3092),
    [anon_sym_LBRACK] = ACTIONS(3092),
    [sym_comment] = ACTIONS(72),
    [sym__semicolon] = ACTIONS(3092),
  },
  [1430] = {
    [sym__newline] = ACTIONS(3423),
    [anon_sym_DOT] = ACTIONS(3423),
    [anon_sym_from] = ACTIONS(3423),
    [anon_sym_LPAREN] = ACTIONS(3423),
    [anon_sym_COMMA] = ACTIONS(3423),
    [anon_sym_STAR] = ACTIONS(3425),
    [anon_sym_GT_GT] = ACTIONS(3423),
    [anon_sym_if] = ACTIONS(3423),
    [anon_sym_in] = ACTIONS(3423),
    [anon_sym_EQ] = ACTIONS(3425),
    [anon_sym_AT] = ACTIONS(3423),
    [anon_sym_not] = ACTIONS(3423),
    [anon_sym_and] = ACTIONS(3423),
    [anon_sym_or] = ACTIONS(3423),
    [anon_sym_PLUS] = ACTIONS(3423),
    [anon_sym_DASH] = ACTIONS(3423),
    [anon_sym_SLASH] = ACTIONS(3425),
    [anon_sym_PERCENT] = ACTIONS(3423),
    [anon_sym_SLASH_SLASH] = ACTIONS(3423),
    [anon_sym_STAR_STAR] = ACTIONS(3423),
    [anon_sym_PIPE] = ACTIONS(3423),
    [anon_sym_AMP] = ACTIONS(3423),
    [anon_sym_CARET] = ACTIONS(3423),
    [anon_sym_LT_LT] = ACTIONS(3423),
    [anon_sym_LT] = ACTIONS(3425),
    [anon_sym_LT_EQ] = ACTIONS(3423),
    [anon_sym_EQ_EQ] = ACTIONS(3423),
    [anon_sym_BANG_EQ] = ACTIONS(3423),
    [anon_sym_GT_EQ] = ACTIONS(3423),
    [anon_sym_GT] = ACTIONS(3425),
    [anon_sym_LT_GT] = ACTIONS(3423),
    [anon_sym_is] = ACTIONS(3423),
    [anon_sym_LBRACK] = ACTIONS(3423),
    [sym_comment] = ACTIONS(72),
    [sym__semicolon] = ACTIONS(3423),
  },
  [1431] = {
    [sym__newline] = ACTIONS(3493),
    [anon_sym_DOT] = ACTIONS(3493),
    [anon_sym_from] = ACTIONS(3493),
    [anon_sym_LPAREN] = ACTIONS(3493),
    [anon_sym_COMMA] = ACTIONS(3493),
    [anon_sym_STAR] = ACTIONS(3495),
    [anon_sym_GT_GT] = ACTIONS(3493),
    [anon_sym_if] = ACTIONS(3493),
    [anon_sym_in] = ACTIONS(3493),
    [anon_sym_EQ] = ACTIONS(3495),
    [anon_sym_AT] = ACTIONS(3493),
    [anon_sym_not] = ACTIONS(3493),
    [anon_sym_and] = ACTIONS(3493),
    [anon_sym_or] = ACTIONS(3493),
    [anon_sym_PLUS] = ACTIONS(3493),
    [anon_sym_DASH] = ACTIONS(3493),
    [anon_sym_SLASH] = ACTIONS(3495),
    [anon_sym_PERCENT] = ACTIONS(3493),
    [anon_sym_SLASH_SLASH] = ACTIONS(3493),
    [anon_sym_STAR_STAR] = ACTIONS(3493),
    [anon_sym_PIPE] = ACTIONS(3493),
    [anon_sym_AMP] = ACTIONS(3493),
    [anon_sym_CARET] = ACTIONS(3493),
    [anon_sym_LT_LT] = ACTIONS(3493),
    [anon_sym_LT] = ACTIONS(3495),
    [anon_sym_LT_EQ] = ACTIONS(3493),
    [anon_sym_EQ_EQ] = ACTIONS(3493),
    [anon_sym_BANG_EQ] = ACTIONS(3493),
    [anon_sym_GT_EQ] = ACTIONS(3493),
    [anon_sym_GT] = ACTIONS(3495),
    [anon_sym_LT_GT] = ACTIONS(3493),
    [anon_sym_is] = ACTIONS(3493),
    [anon_sym_LBRACK] = ACTIONS(3493),
    [sym_comment] = ACTIONS(72),
    [sym__semicolon] = ACTIONS(3493),
  },
  [1432] = {
    [sym__newline] = ACTIONS(3497),
    [anon_sym_DOT] = ACTIONS(3497),
    [anon_sym_from] = ACTIONS(3497),
    [anon_sym_LPAREN] = ACTIONS(3497),
    [anon_sym_COMMA] = ACTIONS(3497),
    [anon_sym_STAR] = ACTIONS(3499),
    [anon_sym_GT_GT] = ACTIONS(3497),
    [anon_sym_if] = ACTIONS(3497),
    [anon_sym_in] = ACTIONS(3497),
    [anon_sym_EQ] = ACTIONS(3499),
    [anon_sym_AT] = ACTIONS(3497),
    [anon_sym_not] = ACTIONS(3497),
    [anon_sym_and] = ACTIONS(3497),
    [anon_sym_or] = ACTIONS(3497),
    [anon_sym_PLUS] = ACTIONS(3497),
    [anon_sym_DASH] = ACTIONS(3497),
    [anon_sym_SLASH] = ACTIONS(3499),
    [anon_sym_PERCENT] = ACTIONS(3497),
    [anon_sym_SLASH_SLASH] = ACTIONS(3497),
    [anon_sym_STAR_STAR] = ACTIONS(3497),
    [anon_sym_PIPE] = ACTIONS(3497),
    [anon_sym_AMP] = ACTIONS(3497),
    [anon_sym_CARET] = ACTIONS(3497),
    [anon_sym_LT_LT] = ACTIONS(3497),
    [anon_sym_LT] = ACTIONS(3499),
    [anon_sym_LT_EQ] = ACTIONS(3497),
    [anon_sym_EQ_EQ] = ACTIONS(3497),
    [anon_sym_BANG_EQ] = ACTIONS(3497),
    [anon_sym_GT_EQ] = ACTIONS(3497),
    [anon_sym_GT] = ACTIONS(3499),
    [anon_sym_LT_GT] = ACTIONS(3497),
    [anon_sym_is] = ACTIONS(3497),
    [anon_sym_LBRACK] = ACTIONS(3497),
    [sym_comment] = ACTIONS(72),
    [sym__semicolon] = ACTIONS(3497),
  },
  [1433] = {
    [sym__newline] = ACTIONS(3610),
    [anon_sym_COMMA] = ACTIONS(3610),
    [anon_sym_if] = ACTIONS(476),
    [anon_sym_and] = ACTIONS(478),
    [anon_sym_or] = ACTIONS(480),
    [sym_comment] = ACTIONS(72),
    [sym__semicolon] = ACTIONS(3610),
  },
  [1434] = {
    [sym__newline] = ACTIONS(3632),
    [anon_sym_DOT] = ACTIONS(3632),
    [anon_sym_from] = ACTIONS(3632),
    [anon_sym_LPAREN] = ACTIONS(3632),
    [anon_sym_COMMA] = ACTIONS(3632),
    [anon_sym_STAR] = ACTIONS(3634),
    [anon_sym_GT_GT] = ACTIONS(3632),
    [anon_sym_if] = ACTIONS(3632),
    [anon_sym_in] = ACTIONS(3632),
    [anon_sym_EQ] = ACTIONS(3634),
    [anon_sym_AT] = ACTIONS(3632),
    [anon_sym_not] = ACTIONS(3632),
    [anon_sym_and] = ACTIONS(3632),
    [anon_sym_or] = ACTIONS(3632),
    [anon_sym_PLUS] = ACTIONS(3632),
    [anon_sym_DASH] = ACTIONS(3632),
    [anon_sym_SLASH] = ACTIONS(3634),
    [anon_sym_PERCENT] = ACTIONS(3632),
    [anon_sym_SLASH_SLASH] = ACTIONS(3632),
    [anon_sym_STAR_STAR] = ACTIONS(3632),
    [anon_sym_PIPE] = ACTIONS(3632),
    [anon_sym_AMP] = ACTIONS(3632),
    [anon_sym_CARET] = ACTIONS(3632),
    [anon_sym_LT_LT] = ACTIONS(3632),
    [anon_sym_LT] = ACTIONS(3634),
    [anon_sym_LT_EQ] = ACTIONS(3632),
    [anon_sym_EQ_EQ] = ACTIONS(3632),
    [anon_sym_BANG_EQ] = ACTIONS(3632),
    [anon_sym_GT_EQ] = ACTIONS(3632),
    [anon_sym_GT] = ACTIONS(3634),
    [anon_sym_LT_GT] = ACTIONS(3632),
    [anon_sym_is] = ACTIONS(3632),
    [anon_sym_LBRACK] = ACTIONS(3632),
    [sym_comment] = ACTIONS(72),
    [sym__semicolon] = ACTIONS(3632),
  },
  [1435] = {
    [sym_list_splat] = STATE(1362),
    [sym_dictionary_splat] = STATE(1362),
    [sym__expression] = STATE(1363),
    [sym__primary_expression] = STATE(215),
    [sym_not_operator] = STATE(1363),
    [sym_boolean_operator] = STATE(1363),
    [sym_binary_operator] = STATE(215),
    [sym_unary_operator] = STATE(215),
    [sym_comparison_operator] = STATE(1363),
    [sym_lambda] = STATE(1363),
    [sym_attribute] = STATE(215),
    [sym_subscript] = STATE(215),
    [sym_call] = STATE(215),
    [sym_keyword_argument] = STATE(1362),
    [sym_list] = STATE(215),
    [sym_list_comprehension] = STATE(215),
    [sym_dictionary] = STATE(215),
    [sym_dictionary_comprehension] = STATE(215),
    [sym_set] = STATE(215),
    [sym_set_comprehension] = STATE(215),
    [sym_parenthesized_expression] = STATE(215),
    [sym_tuple] = STATE(215),
    [sym_generator_expression] = STATE(215),
    [sym_conditional_expression] = STATE(1363),
    [sym_concatenated_string] = STATE(215),
    [sym_await] = STATE(1363),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_RPAREN] = ACTIONS(3735),
    [anon_sym_STAR] = ACTIONS(936),
    [anon_sym_print] = ACTIONS(938),
    [anon_sym_exec] = ACTIONS(938),
    [anon_sym_not] = ACTIONS(384),
    [anon_sym_PLUS] = ACTIONS(386),
    [anon_sym_DASH] = ACTIONS(386),
    [anon_sym_TILDE] = ACTIONS(386),
    [anon_sym_lambda] = ACTIONS(388),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(390),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(392),
    [sym_integer] = ACTIONS(394),
    [sym_float] = ACTIONS(394),
    [sym_identifier] = ACTIONS(940),
    [sym_true] = ACTIONS(394),
    [sym_false] = ACTIONS(394),
    [sym_none] = ACTIONS(394),
    [anon_sym_await] = ACTIONS(396),
    [sym_comment] = ACTIONS(72),
  },
  [1436] = {
    [sym__newline] = ACTIONS(3648),
    [anon_sym_DOT] = ACTIONS(3648),
    [anon_sym_from] = ACTIONS(3648),
    [anon_sym_LPAREN] = ACTIONS(3648),
    [anon_sym_COMMA] = ACTIONS(3648),
    [anon_sym_STAR] = ACTIONS(3650),
    [anon_sym_GT_GT] = ACTIONS(3648),
    [anon_sym_if] = ACTIONS(3648),
    [anon_sym_in] = ACTIONS(3648),
    [anon_sym_EQ] = ACTIONS(3650),
    [anon_sym_AT] = ACTIONS(3648),
    [anon_sym_not] = ACTIONS(3648),
    [anon_sym_and] = ACTIONS(3648),
    [anon_sym_or] = ACTIONS(3648),
    [anon_sym_PLUS] = ACTIONS(3648),
    [anon_sym_DASH] = ACTIONS(3648),
    [anon_sym_SLASH] = ACTIONS(3650),
    [anon_sym_PERCENT] = ACTIONS(3648),
    [anon_sym_SLASH_SLASH] = ACTIONS(3648),
    [anon_sym_STAR_STAR] = ACTIONS(3648),
    [anon_sym_PIPE] = ACTIONS(3648),
    [anon_sym_AMP] = ACTIONS(3648),
    [anon_sym_CARET] = ACTIONS(3648),
    [anon_sym_LT_LT] = ACTIONS(3648),
    [anon_sym_LT] = ACTIONS(3650),
    [anon_sym_LT_EQ] = ACTIONS(3648),
    [anon_sym_EQ_EQ] = ACTIONS(3648),
    [anon_sym_BANG_EQ] = ACTIONS(3648),
    [anon_sym_GT_EQ] = ACTIONS(3648),
    [anon_sym_GT] = ACTIONS(3650),
    [anon_sym_LT_GT] = ACTIONS(3648),
    [anon_sym_is] = ACTIONS(3648),
    [anon_sym_LBRACK] = ACTIONS(3648),
    [sym_comment] = ACTIONS(72),
    [sym__semicolon] = ACTIONS(3648),
  },
  [1437] = {
    [sym__expression] = STATE(1372),
    [sym__primary_expression] = STATE(542),
    [sym_not_operator] = STATE(1372),
    [sym_boolean_operator] = STATE(1372),
    [sym_binary_operator] = STATE(542),
    [sym_unary_operator] = STATE(542),
    [sym_comparison_operator] = STATE(1372),
    [sym_lambda] = STATE(1372),
    [sym_attribute] = STATE(542),
    [sym_subscript] = STATE(542),
    [sym_slice] = STATE(1373),
    [sym_call] = STATE(542),
    [sym_list] = STATE(542),
    [sym_list_comprehension] = STATE(542),
    [sym_dictionary] = STATE(542),
    [sym_dictionary_comprehension] = STATE(542),
    [sym_set] = STATE(542),
    [sym_set_comprehension] = STATE(542),
    [sym_parenthesized_expression] = STATE(542),
    [sym_tuple] = STATE(542),
    [sym_generator_expression] = STATE(542),
    [sym_conditional_expression] = STATE(1372),
    [sym_concatenated_string] = STATE(542),
    [sym_await] = STATE(1372),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_COLON] = ACTIONS(978),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_not] = ACTIONS(980),
    [anon_sym_PLUS] = ACTIONS(982),
    [anon_sym_DASH] = ACTIONS(982),
    [anon_sym_TILDE] = ACTIONS(982),
    [anon_sym_lambda] = ACTIONS(984),
    [anon_sym_LBRACK] = ACTIONS(96),
    [anon_sym_RBRACK] = ACTIONS(3737),
    [sym_ellipsis] = ACTIONS(986),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(988),
    [sym_integer] = ACTIONS(990),
    [sym_float] = ACTIONS(990),
    [sym_identifier] = ACTIONS(990),
    [sym_true] = ACTIONS(990),
    [sym_false] = ACTIONS(990),
    [sym_none] = ACTIONS(990),
    [anon_sym_await] = ACTIONS(992),
    [sym_comment] = ACTIONS(72),
  },
  [1438] = {
    [sym__newline] = ACTIONS(2642),
    [anon_sym_if] = ACTIONS(1331),
    [anon_sym_and] = ACTIONS(1333),
    [anon_sym_or] = ACTIONS(1335),
    [sym_comment] = ACTIONS(72),
    [sym__semicolon] = ACTIONS(2642),
  },
  [1439] = {
    [sym__expression] = STATE(1667),
    [sym__primary_expression] = STATE(303),
    [sym_not_operator] = STATE(1667),
    [sym_boolean_operator] = STATE(1667),
    [sym_binary_operator] = STATE(303),
    [sym_unary_operator] = STATE(303),
    [sym_comparison_operator] = STATE(1667),
    [sym_lambda] = STATE(1667),
    [sym_attribute] = STATE(303),
    [sym_subscript] = STATE(303),
    [sym_call] = STATE(303),
    [sym_list] = STATE(303),
    [sym_list_comprehension] = STATE(303),
    [sym_dictionary] = STATE(303),
    [sym_dictionary_comprehension] = STATE(303),
    [sym_set] = STATE(303),
    [sym_set_comprehension] = STATE(303),
    [sym_parenthesized_expression] = STATE(303),
    [sym_tuple] = STATE(303),
    [sym_generator_expression] = STATE(303),
    [sym_conditional_expression] = STATE(1667),
    [sym_concatenated_string] = STATE(303),
    [sym_await] = STATE(1667),
    [anon_sym_LPAREN] = ACTIONS(130),
    [anon_sym_print] = ACTIONS(112),
    [anon_sym_exec] = ACTIONS(112),
    [anon_sym_not] = ACTIONS(522),
    [anon_sym_PLUS] = ACTIONS(524),
    [anon_sym_DASH] = ACTIONS(524),
    [anon_sym_TILDE] = ACTIONS(524),
    [anon_sym_lambda] = ACTIONS(526),
    [anon_sym_LBRACK] = ACTIONS(134),
    [sym_ellipsis] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(122),
    [sym_string] = ACTIONS(530),
    [sym_integer] = ACTIONS(532),
    [sym_float] = ACTIONS(532),
    [sym_identifier] = ACTIONS(532),
    [sym_true] = ACTIONS(532),
    [sym_false] = ACTIONS(532),
    [sym_none] = ACTIONS(532),
    [anon_sym_await] = ACTIONS(534),
    [sym_comment] = ACTIONS(72),
  },
  [1440] = {
    [sym_argument_list] = STATE(291),
    [sym_generator_expression] = STATE(291),
    [sym__newline] = ACTIONS(2953),
    [anon_sym_DOT] = ACTIONS(482),
    [anon_sym_LPAREN] = ACTIONS(484),
    [anon_sym_STAR] = ACTIONS(1337),
    [anon_sym_GT_GT] = ACTIONS(1339),
    [anon_sym_if] = ACTIONS(2953),
    [anon_sym_in] = ACTIONS(2953),
    [anon_sym_AT] = ACTIONS(1343),
    [anon_sym_not] = ACTIONS(2953),
    [anon_sym_and] = ACTIONS(2953),
    [anon_sym_or] = ACTIONS(2953),
    [anon_sym_PLUS] = ACTIONS(1347),
    [anon_sym_DASH] = ACTIONS(1347),
    [anon_sym_SLASH] = ACTIONS(1337),
    [anon_sym_PERCENT] = ACTIONS(1343),
    [anon_sym_SLASH_SLASH] = ACTIONS(1343),
    [anon_sym_STAR_STAR] = ACTIONS(1349),
    [anon_sym_PIPE] = ACTIONS(1351),
    [anon_sym_AMP] = ACTIONS(1353),
    [anon_sym_CARET] = ACTIONS(1355),
    [anon_sym_LT_LT] = ACTIONS(1339),
    [anon_sym_LT] = ACTIONS(2955),
    [anon_sym_LT_EQ] = ACTIONS(2953),
    [anon_sym_EQ_EQ] = ACTIONS(2953),
    [anon_sym_BANG_EQ] = ACTIONS(2953),
    [anon_sym_GT_EQ] = ACTIONS(2953),
    [anon_sym_GT] = ACTIONS(2955),
    [anon_sym_LT_GT] = ACTIONS(2953),
    [anon_sym_is] = ACTIONS(2953),
    [anon_sym_LBRACK] = ACTIONS(510),
    [sym_comment] = ACTIONS(72),
    [sym__semicolon] = ACTIONS(2953),
  },
  [1441] = {
    [sym__newline] = ACTIONS(3610),
    [anon_sym_from] = ACTIONS(3610),
    [anon_sym_COMMA] = ACTIONS(3610),
    [anon_sym_if] = ACTIONS(546),
    [anon_sym_and] = ACTIONS(548),
    [anon_sym_or] = ACTIONS(550),
    [sym_comment] = ACTIONS(72),
    [sym__semicolon] = ACTIONS(3610),
  },
  [1442] = {
    [anon_sym_if] = ACTIONS(590),
    [anon_sym_COLON] = ACTIONS(3610),
    [anon_sym_and] = ACTIONS(594),
    [anon_sym_or] = ACTIONS(596),
    [sym_comment] = ACTIONS(72),
  },
  [1443] = {
    [ts_builtin_sym_end] = ACTIONS(3187),
    [anon_sym_import] = ACTIONS(3189),
    [anon_sym_from] = ACTIONS(3189),
    [anon_sym_LPAREN] = ACTIONS(3187),
    [anon_sym_print] = ACTIONS(3189),
    [anon_sym_assert] = ACTIONS(3189),
    [anon_sym_return] = ACTIONS(3189),
    [anon_sym_del] = ACTIONS(3189),
    [anon_sym_raise] = ACTIONS(3189),
    [sym_pass_statement] = ACTIONS(3189),
    [sym_break_statement] = ACTIONS(3189),
    [sym_continue_statement] = ACTIONS(3189),
    [anon_sym_if] = ACTIONS(3189),
    [anon_sym_elif] = ACTIONS(3189),
    [anon_sym_else] = ACTIONS(3189),
    [anon_sym_async] = ACTIONS(3189),
    [anon_sym_for] = ACTIONS(3189),
    [anon_sym_while] = ACTIONS(3189),
    [anon_sym_try] = ACTIONS(3189),
    [anon_sym_with] = ACTIONS(3189),
    [anon_sym_def] = ACTIONS(3189),
    [anon_sym_global] = ACTIONS(3189),
    [anon_sym_nonlocal] = ACTIONS(3189),
    [anon_sym_exec] = ACTIONS(3189),
    [anon_sym_class] = ACTIONS(3189),
    [anon_sym_AT] = ACTIONS(3187),
    [anon_sym_not] = ACTIONS(3189),
    [anon_sym_PLUS] = ACTIONS(3187),
    [anon_sym_DASH] = ACTIONS(3187),
    [anon_sym_TILDE] = ACTIONS(3187),
    [anon_sym_lambda] = ACTIONS(3189),
    [anon_sym_yield] = ACTIONS(3189),
    [anon_sym_LBRACK] = ACTIONS(3187),
    [sym_ellipsis] = ACTIONS(3187),
    [anon_sym_LBRACE] = ACTIONS(3187),
    [sym_string] = ACTIONS(3187),
    [sym_integer] = ACTIONS(3189),
    [sym_float] = ACTIONS(3189),
    [sym_identifier] = ACTIONS(3189),
    [sym_true] = ACTIONS(3189),
    [sym_false] = ACTIONS(3189),
    [sym_none] = ACTIONS(3189),
    [anon_sym_await] = ACTIONS(3189),
    [sym_comment] = ACTIONS(72),
  },
  [1444] = {
    [ts_builtin_sym_end] = ACTIONS(1401),
    [anon_sym_import] = ACTIONS(1403),
    [anon_sym_from] = ACTIONS(1403),
    [anon_sym_LPAREN] = ACTIONS(1401),
    [anon_sym_print] = ACTIONS(1403),
    [anon_sym_assert] = ACTIONS(1403),
    [anon_sym_return] = ACTIONS(1403),
    [anon_sym_del] = ACTIONS(1403),
    [anon_sym_raise] = ACTIONS(1403),
    [sym_pass_statement] = ACTIONS(1403),
    [sym_break_statement] = ACTIONS(1403),
    [sym_continue_statement] = ACTIONS(1403),
    [anon_sym_if] = ACTIONS(1403),
    [anon_sym_elif] = ACTIONS(1403),
    [anon_sym_else] = ACTIONS(1403),
    [anon_sym_async] = ACTIONS(1403),
    [anon_sym_for] = ACTIONS(1403),
    [anon_sym_while] = ACTIONS(1403),
    [anon_sym_try] = ACTIONS(1403),
    [anon_sym_with] = ACTIONS(1403),
    [anon_sym_def] = ACTIONS(1403),
    [anon_sym_global] = ACTIONS(1403),
    [anon_sym_nonlocal] = ACTIONS(1403),
    [anon_sym_exec] = ACTIONS(1403),
    [anon_sym_class] = ACTIONS(1403),
    [anon_sym_AT] = ACTIONS(1401),
    [anon_sym_not] = ACTIONS(1403),
    [anon_sym_PLUS] = ACTIONS(1401),
    [anon_sym_DASH] = ACTIONS(1401),
    [anon_sym_TILDE] = ACTIONS(1401),
    [anon_sym_lambda] = ACTIONS(1403),
    [anon_sym_yield] = ACTIONS(1403),
    [anon_sym_LBRACK] = ACTIONS(1401),
    [sym_ellipsis] = ACTIONS(1401),
    [anon_sym_LBRACE] = ACTIONS(1401),
    [sym_string] = ACTIONS(1401),
    [sym_integer] = ACTIONS(1403),
    [sym_float] = ACTIONS(1403),
    [sym_identifier] = ACTIONS(1403),
    [sym_true] = ACTIONS(1403),
    [sym_false] = ACTIONS(1403),
    [sym_none] = ACTIONS(1403),
    [anon_sym_await] = ACTIONS(1403),
    [sym_comment] = ACTIONS(72),
  },
  [1445] = {
    [sym_import_statement] = STATE(326),
    [sym_import_from_statement] = STATE(326),
    [sym_print_statement] = STATE(326),
    [sym_assert_statement] = STATE(326),
    [sym_expression_statement] = STATE(326),
    [sym_return_statement] = STATE(326),
    [sym_delete_statement] = STATE(326),
    [sym_raise_statement] = STATE(326),
    [sym_global_statement] = STATE(326),
    [sym_nonlocal_statement] = STATE(326),
    [sym_exec_statement] = STATE(326),
    [sym_expression_list] = STATE(32),
    [sym__expression] = STATE(33),
    [sym__primary_expression] = STATE(34),
    [sym_not_operator] = STATE(33),
    [sym_boolean_operator] = STATE(33),
    [sym_binary_operator] = STATE(34),
    [sym_unary_operator] = STATE(34),
    [sym_comparison_operator] = STATE(33),
    [sym_lambda] = STATE(33),
    [sym_assignment] = STATE(35),
    [sym_augmented_assignment] = STATE(35),
    [sym_yield] = STATE(35),
    [sym_attribute] = STATE(34),
    [sym_subscript] = STATE(34),
    [sym_call] = STATE(34),
    [sym_list] = STATE(34),
    [sym_list_comprehension] = STATE(34),
    [sym_dictionary] = STATE(34),
    [sym_dictionary_comprehension] = STATE(34),
    [sym_set] = STATE(34),
    [sym_set_comprehension] = STATE(34),
    [sym_parenthesized_expression] = STATE(34),
    [sym_tuple] = STATE(34),
    [sym_generator_expression] = STATE(34),
    [sym_conditional_expression] = STATE(33),
    [sym_concatenated_string] = STATE(34),
    [sym_await] = STATE(33),
    [sym__newline] = ACTIONS(3739),
    [anon_sym_import] = ACTIONS(10),
    [anon_sym_from] = ACTIONS(12),
    [anon_sym_LPAREN] = ACTIONS(14),
    [anon_sym_print] = ACTIONS(16),
    [anon_sym_assert] = ACTIONS(18),
    [anon_sym_return] = ACTIONS(20),
    [anon_sym_del] = ACTIONS(22),
    [anon_sym_raise] = ACTIONS(24),
    [sym_pass_statement] = ACTIONS(582),
    [sym_break_statement] = ACTIONS(582),
    [sym_continue_statement] = ACTIONS(582),
    [anon_sym_global] = ACTIONS(42),
    [anon_sym_nonlocal] = ACTIONS(44),
    [anon_sym_exec] = ACTIONS(46),
    [anon_sym_not] = ACTIONS(52),
    [anon_sym_PLUS] = ACTIONS(54),
    [anon_sym_DASH] = ACTIONS(54),
    [anon_sym_TILDE] = ACTIONS(54),
    [anon_sym_lambda] = ACTIONS(56),
    [anon_sym_yield] = ACTIONS(58),
    [anon_sym_LBRACK] = ACTIONS(60),
    [sym_ellipsis] = ACTIONS(62),
    [anon_sym_LBRACE] = ACTIONS(64),
    [sym_string] = ACTIONS(66),
    [sym_integer] = ACTIONS(68),
    [sym_float] = ACTIONS(68),
    [sym_identifier] = ACTIONS(68),
    [sym_true] = ACTIONS(68),
    [sym_false] = ACTIONS(68),
    [sym_none] = ACTIONS(68),
    [anon_sym_await] = ACTIONS(70),
    [sym_comment] = ACTIONS(72),
  },
  [1446] = {
    [anon_sym_if] = ACTIONS(590),
    [anon_sym_COLON] = ACTIONS(3741),
    [anon_sym_and] = ACTIONS(594),
    [anon_sym_or] = ACTIONS(596),
    [sym_comment] = ACTIONS(72),
  },
  [1447] = {
    [sym__simple_statements] = STATE(1670),
    [sym_import_statement] = STATE(10),
    [sym_import_from_statement] = STATE(10),
    [sym_print_statement] = STATE(10),
    [sym_assert_statement] = STATE(10),
    [sym_expression_statement] = STATE(10),
    [sym_return_statement] = STATE(10),
    [sym_delete_statement] = STATE(10),
    [sym_raise_statement] = STATE(10),
    [sym_global_statement] = STATE(10),
    [sym_nonlocal_statement] = STATE(10),
    [sym_exec_statement] = STATE(10),
    [sym__suite] = STATE(1670),
    [sym_expression_list] = STATE(32),
    [sym__expression] = STATE(33),
    [sym__primary_expression] = STATE(34),
    [sym_not_operator] = STATE(33),
    [sym_boolean_operator] = STATE(33),
    [sym_binary_operator] = STATE(34),
    [sym_unary_operator] = STATE(34),
    [sym_comparison_operator] = STATE(33),
    [sym_lambda] = STATE(33),
    [sym_assignment] = STATE(35),
    [sym_augmented_assignment] = STATE(35),
    [sym_yield] = STATE(35),
    [sym_attribute] = STATE(34),
    [sym_subscript] = STATE(34),
    [sym_call] = STATE(34),
    [sym_list] = STATE(34),
    [sym_list_comprehension] = STATE(34),
    [sym_dictionary] = STATE(34),
    [sym_dictionary_comprehension] = STATE(34),
    [sym_set] = STATE(34),
    [sym_set_comprehension] = STATE(34),
    [sym_parenthesized_expression] = STATE(34),
    [sym_tuple] = STATE(34),
    [sym_generator_expression] = STATE(34),
    [sym_conditional_expression] = STATE(33),
    [sym_concatenated_string] = STATE(34),
    [sym_await] = STATE(33),
    [sym__indent] = ACTIONS(1528),
    [anon_sym_import] = ACTIONS(10),
    [anon_sym_from] = ACTIONS(12),
    [anon_sym_LPAREN] = ACTIONS(14),
    [anon_sym_print] = ACTIONS(16),
    [anon_sym_assert] = ACTIONS(18),
    [anon_sym_return] = ACTIONS(20),
    [anon_sym_del] = ACTIONS(22),
    [anon_sym_raise] = ACTIONS(24),
    [sym_pass_statement] = ACTIONS(26),
    [sym_break_statement] = ACTIONS(26),
    [sym_continue_statement] = ACTIONS(26),
    [anon_sym_global] = ACTIONS(42),
    [anon_sym_nonlocal] = ACTIONS(44),
    [anon_sym_exec] = ACTIONS(46),
    [anon_sym_not] = ACTIONS(52),
    [anon_sym_PLUS] = ACTIONS(54),
    [anon_sym_DASH] = ACTIONS(54),
    [anon_sym_TILDE] = ACTIONS(54),
    [anon_sym_lambda] = ACTIONS(56),
    [anon_sym_yield] = ACTIONS(58),
    [anon_sym_LBRACK] = ACTIONS(60),
    [sym_ellipsis] = ACTIONS(62),
    [anon_sym_LBRACE] = ACTIONS(64),
    [sym_string] = ACTIONS(66),
    [sym_integer] = ACTIONS(68),
    [sym_float] = ACTIONS(68),
    [sym_identifier] = ACTIONS(68),
    [sym_true] = ACTIONS(68),
    [sym_false] = ACTIONS(68),
    [sym_none] = ACTIONS(68),
    [anon_sym_await] = ACTIONS(70),
    [sym_comment] = ACTIONS(72),
  },
  [1448] = {
    [ts_builtin_sym_end] = ACTIONS(3743),
    [anon_sym_import] = ACTIONS(3745),
    [anon_sym_from] = ACTIONS(3745),
    [anon_sym_LPAREN] = ACTIONS(3743),
    [anon_sym_print] = ACTIONS(3745),
    [anon_sym_assert] = ACTIONS(3745),
    [anon_sym_return] = ACTIONS(3745),
    [anon_sym_del] = ACTIONS(3745),
    [anon_sym_raise] = ACTIONS(3745),
    [sym_pass_statement] = ACTIONS(3745),
    [sym_break_statement] = ACTIONS(3745),
    [sym_continue_statement] = ACTIONS(3745),
    [anon_sym_if] = ACTIONS(3745),
    [anon_sym_async] = ACTIONS(3745),
    [anon_sym_for] = ACTIONS(3745),
    [anon_sym_while] = ACTIONS(3745),
    [anon_sym_try] = ACTIONS(3745),
    [anon_sym_with] = ACTIONS(3745),
    [anon_sym_def] = ACTIONS(3745),
    [anon_sym_global] = ACTIONS(3745),
    [anon_sym_nonlocal] = ACTIONS(3745),
    [anon_sym_exec] = ACTIONS(3745),
    [anon_sym_class] = ACTIONS(3745),
    [anon_sym_AT] = ACTIONS(3743),
    [anon_sym_not] = ACTIONS(3745),
    [anon_sym_PLUS] = ACTIONS(3743),
    [anon_sym_DASH] = ACTIONS(3743),
    [anon_sym_TILDE] = ACTIONS(3743),
    [anon_sym_lambda] = ACTIONS(3745),
    [anon_sym_yield] = ACTIONS(3745),
    [anon_sym_LBRACK] = ACTIONS(3743),
    [sym_ellipsis] = ACTIONS(3743),
    [anon_sym_LBRACE] = ACTIONS(3743),
    [sym_string] = ACTIONS(3743),
    [sym_integer] = ACTIONS(3745),
    [sym_float] = ACTIONS(3745),
    [sym_identifier] = ACTIONS(3745),
    [sym_true] = ACTIONS(3745),
    [sym_false] = ACTIONS(3745),
    [sym_none] = ACTIONS(3745),
    [anon_sym_await] = ACTIONS(3745),
    [sym_comment] = ACTIONS(72),
  },
  [1449] = {
    [sym_elif_clause] = STATE(1449),
    [aux_sym_if_statement_repeat1] = STATE(1449),
    [ts_builtin_sym_end] = ACTIONS(3747),
    [anon_sym_import] = ACTIONS(3749),
    [anon_sym_from] = ACTIONS(3749),
    [anon_sym_LPAREN] = ACTIONS(3747),
    [anon_sym_print] = ACTIONS(3749),
    [anon_sym_assert] = ACTIONS(3749),
    [anon_sym_return] = ACTIONS(3749),
    [anon_sym_del] = ACTIONS(3749),
    [anon_sym_raise] = ACTIONS(3749),
    [sym_pass_statement] = ACTIONS(3749),
    [sym_break_statement] = ACTIONS(3749),
    [sym_continue_statement] = ACTIONS(3749),
    [anon_sym_if] = ACTIONS(3749),
    [anon_sym_elif] = ACTIONS(3751),
    [anon_sym_else] = ACTIONS(3749),
    [anon_sym_async] = ACTIONS(3749),
    [anon_sym_for] = ACTIONS(3749),
    [anon_sym_while] = ACTIONS(3749),
    [anon_sym_try] = ACTIONS(3749),
    [anon_sym_with] = ACTIONS(3749),
    [anon_sym_def] = ACTIONS(3749),
    [anon_sym_global] = ACTIONS(3749),
    [anon_sym_nonlocal] = ACTIONS(3749),
    [anon_sym_exec] = ACTIONS(3749),
    [anon_sym_class] = ACTIONS(3749),
    [anon_sym_AT] = ACTIONS(3747),
    [anon_sym_not] = ACTIONS(3749),
    [anon_sym_PLUS] = ACTIONS(3747),
    [anon_sym_DASH] = ACTIONS(3747),
    [anon_sym_TILDE] = ACTIONS(3747),
    [anon_sym_lambda] = ACTIONS(3749),
    [anon_sym_yield] = ACTIONS(3749),
    [anon_sym_LBRACK] = ACTIONS(3747),
    [sym_ellipsis] = ACTIONS(3747),
    [anon_sym_LBRACE] = ACTIONS(3747),
    [sym_string] = ACTIONS(3747),
    [sym_integer] = ACTIONS(3749),
    [sym_float] = ACTIONS(3749),
    [sym_identifier] = ACTIONS(3749),
    [sym_true] = ACTIONS(3749),
    [sym_false] = ACTIONS(3749),
    [sym_none] = ACTIONS(3749),
    [anon_sym_await] = ACTIONS(3749),
    [sym_comment] = ACTIONS(72),
  },
  [1450] = {
    [sym__simple_statements] = STATE(1671),
    [sym_import_statement] = STATE(743),
    [sym_import_from_statement] = STATE(743),
    [sym_print_statement] = STATE(743),
    [sym_assert_statement] = STATE(743),
    [sym_expression_statement] = STATE(743),
    [sym_return_statement] = STATE(743),
    [sym_delete_statement] = STATE(743),
    [sym_raise_statement] = STATE(743),
    [sym_global_statement] = STATE(743),
    [sym_nonlocal_statement] = STATE(743),
    [sym_exec_statement] = STATE(743),
    [sym__suite] = STATE(1671),
    [sym_expression_list] = STATE(32),
    [sym__expression] = STATE(33),
    [sym__primary_expression] = STATE(34),
    [sym_not_operator] = STATE(33),
    [sym_boolean_operator] = STATE(33),
    [sym_binary_operator] = STATE(34),
    [sym_unary_operator] = STATE(34),
    [sym_comparison_operator] = STATE(33),
    [sym_lambda] = STATE(33),
    [sym_assignment] = STATE(35),
    [sym_augmented_assignment] = STATE(35),
    [sym_yield] = STATE(35),
    [sym_attribute] = STATE(34),
    [sym_subscript] = STATE(34),
    [sym_call] = STATE(34),
    [sym_list] = STATE(34),
    [sym_list_comprehension] = STATE(34),
    [sym_dictionary] = STATE(34),
    [sym_dictionary_comprehension] = STATE(34),
    [sym_set] = STATE(34),
    [sym_set_comprehension] = STATE(34),
    [sym_parenthesized_expression] = STATE(34),
    [sym_tuple] = STATE(34),
    [sym_generator_expression] = STATE(34),
    [sym_conditional_expression] = STATE(33),
    [sym_concatenated_string] = STATE(34),
    [sym_await] = STATE(33),
    [sym__indent] = ACTIONS(1492),
    [anon_sym_import] = ACTIONS(10),
    [anon_sym_from] = ACTIONS(12),
    [anon_sym_LPAREN] = ACTIONS(14),
    [anon_sym_print] = ACTIONS(16),
    [anon_sym_assert] = ACTIONS(18),
    [anon_sym_return] = ACTIONS(20),
    [anon_sym_del] = ACTIONS(22),
    [anon_sym_raise] = ACTIONS(24),
    [sym_pass_statement] = ACTIONS(1494),
    [sym_break_statement] = ACTIONS(1494),
    [sym_continue_statement] = ACTIONS(1494),
    [anon_sym_global] = ACTIONS(42),
    [anon_sym_nonlocal] = ACTIONS(44),
    [anon_sym_exec] = ACTIONS(46),
    [anon_sym_not] = ACTIONS(52),
    [anon_sym_PLUS] = ACTIONS(54),
    [anon_sym_DASH] = ACTIONS(54),
    [anon_sym_TILDE] = ACTIONS(54),
    [anon_sym_lambda] = ACTIONS(56),
    [anon_sym_yield] = ACTIONS(58),
    [anon_sym_LBRACK] = ACTIONS(60),
    [sym_ellipsis] = ACTIONS(62),
    [anon_sym_LBRACE] = ACTIONS(64),
    [sym_string] = ACTIONS(66),
    [sym_integer] = ACTIONS(68),
    [sym_float] = ACTIONS(68),
    [sym_identifier] = ACTIONS(68),
    [sym_true] = ACTIONS(68),
    [sym_false] = ACTIONS(68),
    [sym_none] = ACTIONS(68),
    [anon_sym_await] = ACTIONS(70),
    [sym_comment] = ACTIONS(72),
  },
  [1451] = {
    [ts_builtin_sym_end] = ACTIONS(3754),
    [anon_sym_import] = ACTIONS(3756),
    [anon_sym_from] = ACTIONS(3756),
    [anon_sym_LPAREN] = ACTIONS(3754),
    [anon_sym_print] = ACTIONS(3756),
    [anon_sym_assert] = ACTIONS(3756),
    [anon_sym_return] = ACTIONS(3756),
    [anon_sym_del] = ACTIONS(3756),
    [anon_sym_raise] = ACTIONS(3756),
    [sym_pass_statement] = ACTIONS(3756),
    [sym_break_statement] = ACTIONS(3756),
    [sym_continue_statement] = ACTIONS(3756),
    [anon_sym_if] = ACTIONS(3756),
    [anon_sym_async] = ACTIONS(3756),
    [anon_sym_for] = ACTIONS(3756),
    [anon_sym_while] = ACTIONS(3756),
    [anon_sym_try] = ACTIONS(3756),
    [anon_sym_with] = ACTIONS(3756),
    [anon_sym_def] = ACTIONS(3756),
    [anon_sym_global] = ACTIONS(3756),
    [anon_sym_nonlocal] = ACTIONS(3756),
    [anon_sym_exec] = ACTIONS(3756),
    [anon_sym_class] = ACTIONS(3756),
    [anon_sym_AT] = ACTIONS(3754),
    [anon_sym_not] = ACTIONS(3756),
    [anon_sym_PLUS] = ACTIONS(3754),
    [anon_sym_DASH] = ACTIONS(3754),
    [anon_sym_TILDE] = ACTIONS(3754),
    [anon_sym_lambda] = ACTIONS(3756),
    [anon_sym_yield] = ACTIONS(3756),
    [anon_sym_LBRACK] = ACTIONS(3754),
    [sym_ellipsis] = ACTIONS(3754),
    [anon_sym_LBRACE] = ACTIONS(3754),
    [sym_string] = ACTIONS(3754),
    [sym_integer] = ACTIONS(3756),
    [sym_float] = ACTIONS(3756),
    [sym_identifier] = ACTIONS(3756),
    [sym_true] = ACTIONS(3756),
    [sym_false] = ACTIONS(3756),
    [sym_none] = ACTIONS(3756),
    [anon_sym_await] = ACTIONS(3756),
    [sym_comment] = ACTIONS(72),
  },
  [1452] = {
    [ts_builtin_sym_end] = ACTIONS(3758),
    [anon_sym_import] = ACTIONS(3760),
    [anon_sym_from] = ACTIONS(3760),
    [anon_sym_LPAREN] = ACTIONS(3758),
    [anon_sym_print] = ACTIONS(3760),
    [anon_sym_assert] = ACTIONS(3760),
    [anon_sym_return] = ACTIONS(3760),
    [anon_sym_del] = ACTIONS(3760),
    [anon_sym_raise] = ACTIONS(3760),
    [sym_pass_statement] = ACTIONS(3760),
    [sym_break_statement] = ACTIONS(3760),
    [sym_continue_statement] = ACTIONS(3760),
    [anon_sym_if] = ACTIONS(3760),
    [anon_sym_async] = ACTIONS(3760),
    [anon_sym_for] = ACTIONS(3760),
    [anon_sym_while] = ACTIONS(3760),
    [anon_sym_try] = ACTIONS(3760),
    [anon_sym_with] = ACTIONS(3760),
    [anon_sym_def] = ACTIONS(3760),
    [anon_sym_global] = ACTIONS(3760),
    [anon_sym_nonlocal] = ACTIONS(3760),
    [anon_sym_exec] = ACTIONS(3760),
    [anon_sym_class] = ACTIONS(3760),
    [anon_sym_AT] = ACTIONS(3758),
    [anon_sym_not] = ACTIONS(3760),
    [anon_sym_PLUS] = ACTIONS(3758),
    [anon_sym_DASH] = ACTIONS(3758),
    [anon_sym_TILDE] = ACTIONS(3758),
    [anon_sym_lambda] = ACTIONS(3760),
    [anon_sym_yield] = ACTIONS(3760),
    [anon_sym_LBRACK] = ACTIONS(3758),
    [sym_ellipsis] = ACTIONS(3758),
    [anon_sym_LBRACE] = ACTIONS(3758),
    [sym_string] = ACTIONS(3758),
    [sym_integer] = ACTIONS(3760),
    [sym_float] = ACTIONS(3760),
    [sym_identifier] = ACTIONS(3760),
    [sym_true] = ACTIONS(3760),
    [sym_false] = ACTIONS(3760),
    [sym_none] = ACTIONS(3760),
    [anon_sym_await] = ACTIONS(3760),
    [sym_comment] = ACTIONS(72),
  },
  [1453] = {
    [anon_sym_COLON] = ACTIONS(3762),
    [sym_comment] = ACTIONS(72),
  },
  [1454] = {
    [sym_else_clause] = STATE(1673),
    [ts_builtin_sym_end] = ACTIONS(3764),
    [anon_sym_import] = ACTIONS(3766),
    [anon_sym_from] = ACTIONS(3766),
    [anon_sym_LPAREN] = ACTIONS(3764),
    [anon_sym_print] = ACTIONS(3766),
    [anon_sym_assert] = ACTIONS(3766),
    [anon_sym_return] = ACTIONS(3766),
    [anon_sym_del] = ACTIONS(3766),
    [anon_sym_raise] = ACTIONS(3766),
    [sym_pass_statement] = ACTIONS(3766),
    [sym_break_statement] = ACTIONS(3766),
    [sym_continue_statement] = ACTIONS(3766),
    [anon_sym_if] = ACTIONS(3766),
    [anon_sym_else] = ACTIONS(2340),
    [anon_sym_async] = ACTIONS(3766),
    [anon_sym_for] = ACTIONS(3766),
    [anon_sym_while] = ACTIONS(3766),
    [anon_sym_try] = ACTIONS(3766),
    [anon_sym_with] = ACTIONS(3766),
    [anon_sym_def] = ACTIONS(3766),
    [anon_sym_global] = ACTIONS(3766),
    [anon_sym_nonlocal] = ACTIONS(3766),
    [anon_sym_exec] = ACTIONS(3766),
    [anon_sym_class] = ACTIONS(3766),
    [anon_sym_AT] = ACTIONS(3764),
    [anon_sym_not] = ACTIONS(3766),
    [anon_sym_PLUS] = ACTIONS(3764),
    [anon_sym_DASH] = ACTIONS(3764),
    [anon_sym_TILDE] = ACTIONS(3764),
    [anon_sym_lambda] = ACTIONS(3766),
    [anon_sym_yield] = ACTIONS(3766),
    [anon_sym_LBRACK] = ACTIONS(3764),
    [sym_ellipsis] = ACTIONS(3764),
    [anon_sym_LBRACE] = ACTIONS(3764),
    [sym_string] = ACTIONS(3764),
    [sym_integer] = ACTIONS(3766),
    [sym_float] = ACTIONS(3766),
    [sym_identifier] = ACTIONS(3766),
    [sym_true] = ACTIONS(3766),
    [sym_false] = ACTIONS(3766),
    [sym_none] = ACTIONS(3766),
    [anon_sym_await] = ACTIONS(3766),
    [sym_comment] = ACTIONS(72),
  },
  [1455] = {
    [anon_sym_COMMA] = ACTIONS(1915),
    [anon_sym_if] = ACTIONS(1592),
    [anon_sym_COLON] = ACTIONS(1915),
    [anon_sym_and] = ACTIONS(1594),
    [anon_sym_or] = ACTIONS(1596),
    [sym_comment] = ACTIONS(72),
  },
  [1456] = {
    [sym__expression] = STATE(1455),
    [sym__primary_expression] = STATE(410),
    [sym_not_operator] = STATE(1455),
    [sym_boolean_operator] = STATE(1455),
    [sym_binary_operator] = STATE(410),
    [sym_unary_operator] = STATE(410),
    [sym_comparison_operator] = STATE(1455),
    [sym_lambda] = STATE(1455),
    [sym_attribute] = STATE(410),
    [sym_subscript] = STATE(410),
    [sym_call] = STATE(410),
    [sym_list] = STATE(410),
    [sym_list_comprehension] = STATE(410),
    [sym_dictionary] = STATE(410),
    [sym_dictionary_comprehension] = STATE(410),
    [sym_set] = STATE(410),
    [sym_set_comprehension] = STATE(410),
    [sym_parenthesized_expression] = STATE(410),
    [sym_tuple] = STATE(410),
    [sym_generator_expression] = STATE(410),
    [sym_conditional_expression] = STATE(1455),
    [sym_concatenated_string] = STATE(410),
    [sym_await] = STATE(1455),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_COLON] = ACTIONS(1957),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_not] = ACTIONS(726),
    [anon_sym_PLUS] = ACTIONS(728),
    [anon_sym_DASH] = ACTIONS(728),
    [anon_sym_TILDE] = ACTIONS(728),
    [anon_sym_lambda] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(732),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(734),
    [sym_integer] = ACTIONS(736),
    [sym_float] = ACTIONS(736),
    [sym_identifier] = ACTIONS(736),
    [sym_true] = ACTIONS(736),
    [sym_false] = ACTIONS(736),
    [sym_none] = ACTIONS(736),
    [anon_sym_await] = ACTIONS(738),
    [sym_comment] = ACTIONS(72),
  },
  [1457] = {
    [aux_sym_print_statement_repeat1] = STATE(1457),
    [anon_sym_COMMA] = ACTIONS(3768),
    [anon_sym_COLON] = ACTIONS(1915),
    [sym_comment] = ACTIONS(72),
  },
  [1458] = {
    [ts_builtin_sym_end] = ACTIONS(3187),
    [anon_sym_import] = ACTIONS(3189),
    [anon_sym_from] = ACTIONS(3189),
    [anon_sym_LPAREN] = ACTIONS(3187),
    [anon_sym_print] = ACTIONS(3189),
    [anon_sym_assert] = ACTIONS(3189),
    [anon_sym_return] = ACTIONS(3189),
    [anon_sym_del] = ACTIONS(3189),
    [anon_sym_raise] = ACTIONS(3189),
    [sym_pass_statement] = ACTIONS(3189),
    [sym_break_statement] = ACTIONS(3189),
    [sym_continue_statement] = ACTIONS(3189),
    [anon_sym_if] = ACTIONS(3189),
    [anon_sym_else] = ACTIONS(3189),
    [anon_sym_async] = ACTIONS(3189),
    [anon_sym_for] = ACTIONS(3189),
    [anon_sym_while] = ACTIONS(3189),
    [anon_sym_try] = ACTIONS(3189),
    [anon_sym_with] = ACTIONS(3189),
    [anon_sym_def] = ACTIONS(3189),
    [anon_sym_global] = ACTIONS(3189),
    [anon_sym_nonlocal] = ACTIONS(3189),
    [anon_sym_exec] = ACTIONS(3189),
    [anon_sym_class] = ACTIONS(3189),
    [anon_sym_AT] = ACTIONS(3187),
    [anon_sym_not] = ACTIONS(3189),
    [anon_sym_PLUS] = ACTIONS(3187),
    [anon_sym_DASH] = ACTIONS(3187),
    [anon_sym_TILDE] = ACTIONS(3187),
    [anon_sym_lambda] = ACTIONS(3189),
    [anon_sym_yield] = ACTIONS(3189),
    [anon_sym_LBRACK] = ACTIONS(3187),
    [sym_ellipsis] = ACTIONS(3187),
    [anon_sym_LBRACE] = ACTIONS(3187),
    [sym_string] = ACTIONS(3187),
    [sym_integer] = ACTIONS(3189),
    [sym_float] = ACTIONS(3189),
    [sym_identifier] = ACTIONS(3189),
    [sym_true] = ACTIONS(3189),
    [sym_false] = ACTIONS(3189),
    [sym_none] = ACTIONS(3189),
    [anon_sym_await] = ACTIONS(3189),
    [sym_comment] = ACTIONS(72),
  },
  [1459] = {
    [ts_builtin_sym_end] = ACTIONS(1401),
    [anon_sym_import] = ACTIONS(1403),
    [anon_sym_from] = ACTIONS(1403),
    [anon_sym_LPAREN] = ACTIONS(1401),
    [anon_sym_print] = ACTIONS(1403),
    [anon_sym_assert] = ACTIONS(1403),
    [anon_sym_return] = ACTIONS(1403),
    [anon_sym_del] = ACTIONS(1403),
    [anon_sym_raise] = ACTIONS(1403),
    [sym_pass_statement] = ACTIONS(1403),
    [sym_break_statement] = ACTIONS(1403),
    [sym_continue_statement] = ACTIONS(1403),
    [anon_sym_if] = ACTIONS(1403),
    [anon_sym_else] = ACTIONS(1403),
    [anon_sym_async] = ACTIONS(1403),
    [anon_sym_for] = ACTIONS(1403),
    [anon_sym_while] = ACTIONS(1403),
    [anon_sym_try] = ACTIONS(1403),
    [anon_sym_with] = ACTIONS(1403),
    [anon_sym_def] = ACTIONS(1403),
    [anon_sym_global] = ACTIONS(1403),
    [anon_sym_nonlocal] = ACTIONS(1403),
    [anon_sym_exec] = ACTIONS(1403),
    [anon_sym_class] = ACTIONS(1403),
    [anon_sym_AT] = ACTIONS(1401),
    [anon_sym_not] = ACTIONS(1403),
    [anon_sym_PLUS] = ACTIONS(1401),
    [anon_sym_DASH] = ACTIONS(1401),
    [anon_sym_TILDE] = ACTIONS(1401),
    [anon_sym_lambda] = ACTIONS(1403),
    [anon_sym_yield] = ACTIONS(1403),
    [anon_sym_LBRACK] = ACTIONS(1401),
    [sym_ellipsis] = ACTIONS(1401),
    [anon_sym_LBRACE] = ACTIONS(1401),
    [sym_string] = ACTIONS(1401),
    [sym_integer] = ACTIONS(1403),
    [sym_float] = ACTIONS(1403),
    [sym_identifier] = ACTIONS(1403),
    [sym_true] = ACTIONS(1403),
    [sym_false] = ACTIONS(1403),
    [sym_none] = ACTIONS(1403),
    [anon_sym_await] = ACTIONS(1403),
    [sym_comment] = ACTIONS(72),
  },
  [1460] = {
    [sym_import_statement] = STATE(326),
    [sym_import_from_statement] = STATE(326),
    [sym_print_statement] = STATE(326),
    [sym_assert_statement] = STATE(326),
    [sym_expression_statement] = STATE(326),
    [sym_return_statement] = STATE(326),
    [sym_delete_statement] = STATE(326),
    [sym_raise_statement] = STATE(326),
    [sym_global_statement] = STATE(326),
    [sym_nonlocal_statement] = STATE(326),
    [sym_exec_statement] = STATE(326),
    [sym_expression_list] = STATE(32),
    [sym__expression] = STATE(33),
    [sym__primary_expression] = STATE(34),
    [sym_not_operator] = STATE(33),
    [sym_boolean_operator] = STATE(33),
    [sym_binary_operator] = STATE(34),
    [sym_unary_operator] = STATE(34),
    [sym_comparison_operator] = STATE(33),
    [sym_lambda] = STATE(33),
    [sym_assignment] = STATE(35),
    [sym_augmented_assignment] = STATE(35),
    [sym_yield] = STATE(35),
    [sym_attribute] = STATE(34),
    [sym_subscript] = STATE(34),
    [sym_call] = STATE(34),
    [sym_list] = STATE(34),
    [sym_list_comprehension] = STATE(34),
    [sym_dictionary] = STATE(34),
    [sym_dictionary_comprehension] = STATE(34),
    [sym_set] = STATE(34),
    [sym_set_comprehension] = STATE(34),
    [sym_parenthesized_expression] = STATE(34),
    [sym_tuple] = STATE(34),
    [sym_generator_expression] = STATE(34),
    [sym_conditional_expression] = STATE(33),
    [sym_concatenated_string] = STATE(34),
    [sym_await] = STATE(33),
    [sym__newline] = ACTIONS(3771),
    [anon_sym_import] = ACTIONS(10),
    [anon_sym_from] = ACTIONS(12),
    [anon_sym_LPAREN] = ACTIONS(14),
    [anon_sym_print] = ACTIONS(16),
    [anon_sym_assert] = ACTIONS(18),
    [anon_sym_return] = ACTIONS(20),
    [anon_sym_del] = ACTIONS(22),
    [anon_sym_raise] = ACTIONS(24),
    [sym_pass_statement] = ACTIONS(582),
    [sym_break_statement] = ACTIONS(582),
    [sym_continue_statement] = ACTIONS(582),
    [anon_sym_global] = ACTIONS(42),
    [anon_sym_nonlocal] = ACTIONS(44),
    [anon_sym_exec] = ACTIONS(46),
    [anon_sym_not] = ACTIONS(52),
    [anon_sym_PLUS] = ACTIONS(54),
    [anon_sym_DASH] = ACTIONS(54),
    [anon_sym_TILDE] = ACTIONS(54),
    [anon_sym_lambda] = ACTIONS(56),
    [anon_sym_yield] = ACTIONS(58),
    [anon_sym_LBRACK] = ACTIONS(60),
    [sym_ellipsis] = ACTIONS(62),
    [anon_sym_LBRACE] = ACTIONS(64),
    [sym_string] = ACTIONS(66),
    [sym_integer] = ACTIONS(68),
    [sym_float] = ACTIONS(68),
    [sym_identifier] = ACTIONS(68),
    [sym_true] = ACTIONS(68),
    [sym_false] = ACTIONS(68),
    [sym_none] = ACTIONS(68),
    [anon_sym_await] = ACTIONS(70),
    [sym_comment] = ACTIONS(72),
  },
  [1461] = {
    [sym__dedent] = ACTIONS(1401),
    [anon_sym_import] = ACTIONS(1403),
    [anon_sym_from] = ACTIONS(1403),
    [anon_sym_LPAREN] = ACTIONS(1401),
    [anon_sym_print] = ACTIONS(1403),
    [anon_sym_assert] = ACTIONS(1403),
    [anon_sym_return] = ACTIONS(1403),
    [anon_sym_del] = ACTIONS(1403),
    [anon_sym_raise] = ACTIONS(1403),
    [sym_pass_statement] = ACTIONS(1403),
    [sym_break_statement] = ACTIONS(1403),
    [sym_continue_statement] = ACTIONS(1403),
    [anon_sym_if] = ACTIONS(1403),
    [anon_sym_async] = ACTIONS(1403),
    [anon_sym_for] = ACTIONS(1403),
    [anon_sym_while] = ACTIONS(1403),
    [anon_sym_try] = ACTIONS(1403),
    [anon_sym_with] = ACTIONS(1403),
    [anon_sym_def] = ACTIONS(1403),
    [anon_sym_global] = ACTIONS(1403),
    [anon_sym_nonlocal] = ACTIONS(1403),
    [anon_sym_exec] = ACTIONS(1403),
    [anon_sym_class] = ACTIONS(1403),
    [anon_sym_AT] = ACTIONS(1401),
    [anon_sym_not] = ACTIONS(1403),
    [anon_sym_PLUS] = ACTIONS(1401),
    [anon_sym_DASH] = ACTIONS(1401),
    [anon_sym_TILDE] = ACTIONS(1401),
    [anon_sym_lambda] = ACTIONS(1403),
    [anon_sym_yield] = ACTIONS(1403),
    [anon_sym_LBRACK] = ACTIONS(1401),
    [sym_ellipsis] = ACTIONS(1401),
    [anon_sym_LBRACE] = ACTIONS(1401),
    [sym_string] = ACTIONS(1401),
    [sym_integer] = ACTIONS(1403),
    [sym_float] = ACTIONS(1403),
    [sym_identifier] = ACTIONS(1403),
    [sym_true] = ACTIONS(1403),
    [sym_false] = ACTIONS(1403),
    [sym_none] = ACTIONS(1403),
    [anon_sym_await] = ACTIONS(1403),
    [sym_comment] = ACTIONS(72),
  },
  [1462] = {
    [sym_import_statement] = STATE(326),
    [sym_import_from_statement] = STATE(326),
    [sym_print_statement] = STATE(326),
    [sym_assert_statement] = STATE(326),
    [sym_expression_statement] = STATE(326),
    [sym_return_statement] = STATE(326),
    [sym_delete_statement] = STATE(326),
    [sym_raise_statement] = STATE(326),
    [sym_global_statement] = STATE(326),
    [sym_nonlocal_statement] = STATE(326),
    [sym_exec_statement] = STATE(326),
    [sym_expression_list] = STATE(32),
    [sym__expression] = STATE(33),
    [sym__primary_expression] = STATE(34),
    [sym_not_operator] = STATE(33),
    [sym_boolean_operator] = STATE(33),
    [sym_binary_operator] = STATE(34),
    [sym_unary_operator] = STATE(34),
    [sym_comparison_operator] = STATE(33),
    [sym_lambda] = STATE(33),
    [sym_assignment] = STATE(35),
    [sym_augmented_assignment] = STATE(35),
    [sym_yield] = STATE(35),
    [sym_attribute] = STATE(34),
    [sym_subscript] = STATE(34),
    [sym_call] = STATE(34),
    [sym_list] = STATE(34),
    [sym_list_comprehension] = STATE(34),
    [sym_dictionary] = STATE(34),
    [sym_dictionary_comprehension] = STATE(34),
    [sym_set] = STATE(34),
    [sym_set_comprehension] = STATE(34),
    [sym_parenthesized_expression] = STATE(34),
    [sym_tuple] = STATE(34),
    [sym_generator_expression] = STATE(34),
    [sym_conditional_expression] = STATE(33),
    [sym_concatenated_string] = STATE(34),
    [sym_await] = STATE(33),
    [sym__newline] = ACTIONS(3773),
    [anon_sym_import] = ACTIONS(10),
    [anon_sym_from] = ACTIONS(12),
    [anon_sym_LPAREN] = ACTIONS(14),
    [anon_sym_print] = ACTIONS(16),
    [anon_sym_assert] = ACTIONS(18),
    [anon_sym_return] = ACTIONS(20),
    [anon_sym_del] = ACTIONS(22),
    [anon_sym_raise] = ACTIONS(24),
    [sym_pass_statement] = ACTIONS(582),
    [sym_break_statement] = ACTIONS(582),
    [sym_continue_statement] = ACTIONS(582),
    [anon_sym_global] = ACTIONS(42),
    [anon_sym_nonlocal] = ACTIONS(44),
    [anon_sym_exec] = ACTIONS(46),
    [anon_sym_not] = ACTIONS(52),
    [anon_sym_PLUS] = ACTIONS(54),
    [anon_sym_DASH] = ACTIONS(54),
    [anon_sym_TILDE] = ACTIONS(54),
    [anon_sym_lambda] = ACTIONS(56),
    [anon_sym_yield] = ACTIONS(58),
    [anon_sym_LBRACK] = ACTIONS(60),
    [sym_ellipsis] = ACTIONS(62),
    [anon_sym_LBRACE] = ACTIONS(64),
    [sym_string] = ACTIONS(66),
    [sym_integer] = ACTIONS(68),
    [sym_float] = ACTIONS(68),
    [sym_identifier] = ACTIONS(68),
    [sym_true] = ACTIONS(68),
    [sym_false] = ACTIONS(68),
    [sym_none] = ACTIONS(68),
    [anon_sym_await] = ACTIONS(70),
    [sym_comment] = ACTIONS(72),
  },
  [1463] = {
    [sym__simple_statements] = STATE(1679),
    [sym_import_statement] = STATE(1678),
    [sym_import_from_statement] = STATE(1678),
    [sym_print_statement] = STATE(1678),
    [sym_assert_statement] = STATE(1678),
    [sym_expression_statement] = STATE(1678),
    [sym_return_statement] = STATE(1678),
    [sym_delete_statement] = STATE(1678),
    [sym_raise_statement] = STATE(1678),
    [sym_global_statement] = STATE(1678),
    [sym_nonlocal_statement] = STATE(1678),
    [sym_exec_statement] = STATE(1678),
    [sym__suite] = STATE(1679),
    [sym_expression_list] = STATE(32),
    [sym__expression] = STATE(33),
    [sym__primary_expression] = STATE(34),
    [sym_not_operator] = STATE(33),
    [sym_boolean_operator] = STATE(33),
    [sym_binary_operator] = STATE(34),
    [sym_unary_operator] = STATE(34),
    [sym_comparison_operator] = STATE(33),
    [sym_lambda] = STATE(33),
    [sym_assignment] = STATE(35),
    [sym_augmented_assignment] = STATE(35),
    [sym_yield] = STATE(35),
    [sym_attribute] = STATE(34),
    [sym_subscript] = STATE(34),
    [sym_call] = STATE(34),
    [sym_list] = STATE(34),
    [sym_list_comprehension] = STATE(34),
    [sym_dictionary] = STATE(34),
    [sym_dictionary_comprehension] = STATE(34),
    [sym_set] = STATE(34),
    [sym_set_comprehension] = STATE(34),
    [sym_parenthesized_expression] = STATE(34),
    [sym_tuple] = STATE(34),
    [sym_generator_expression] = STATE(34),
    [sym_conditional_expression] = STATE(33),
    [sym_concatenated_string] = STATE(34),
    [sym_await] = STATE(33),
    [sym__indent] = ACTIONS(3775),
    [anon_sym_import] = ACTIONS(10),
    [anon_sym_from] = ACTIONS(12),
    [anon_sym_LPAREN] = ACTIONS(14),
    [anon_sym_print] = ACTIONS(16),
    [anon_sym_assert] = ACTIONS(18),
    [anon_sym_return] = ACTIONS(20),
    [anon_sym_del] = ACTIONS(22),
    [anon_sym_raise] = ACTIONS(24),
    [sym_pass_statement] = ACTIONS(3777),
    [sym_break_statement] = ACTIONS(3777),
    [sym_continue_statement] = ACTIONS(3777),
    [anon_sym_global] = ACTIONS(42),
    [anon_sym_nonlocal] = ACTIONS(44),
    [anon_sym_exec] = ACTIONS(46),
    [anon_sym_not] = ACTIONS(52),
    [anon_sym_PLUS] = ACTIONS(54),
    [anon_sym_DASH] = ACTIONS(54),
    [anon_sym_TILDE] = ACTIONS(54),
    [anon_sym_lambda] = ACTIONS(56),
    [anon_sym_yield] = ACTIONS(58),
    [anon_sym_LBRACK] = ACTIONS(60),
    [sym_ellipsis] = ACTIONS(62),
    [anon_sym_LBRACE] = ACTIONS(64),
    [sym_string] = ACTIONS(66),
    [sym_integer] = ACTIONS(68),
    [sym_float] = ACTIONS(68),
    [sym_identifier] = ACTIONS(68),
    [sym_true] = ACTIONS(68),
    [sym_false] = ACTIONS(68),
    [sym_none] = ACTIONS(68),
    [anon_sym_await] = ACTIONS(70),
    [sym_comment] = ACTIONS(72),
  },
  [1464] = {
    [anon_sym_in] = ACTIONS(3779),
    [sym_comment] = ACTIONS(72),
  },
  [1465] = {
    [aux_sym_with_statement_repeat1] = STATE(1682),
    [anon_sym_COMMA] = ACTIONS(658),
    [anon_sym_COLON] = ACTIONS(3781),
    [sym_comment] = ACTIONS(72),
  },
  [1466] = {
    [sym_parameters] = STATE(1683),
    [anon_sym_LPAREN] = ACTIONS(696),
    [sym_comment] = ACTIONS(72),
  },
  [1467] = {
    [sym_expression_list] = STATE(1684),
    [sym__expression] = STATE(732),
    [sym__primary_expression] = STATE(410),
    [sym_not_operator] = STATE(732),
    [sym_boolean_operator] = STATE(732),
    [sym_binary_operator] = STATE(410),
    [sym_unary_operator] = STATE(410),
    [sym_comparison_operator] = STATE(732),
    [sym_lambda] = STATE(732),
    [sym_attribute] = STATE(410),
    [sym_subscript] = STATE(410),
    [sym_call] = STATE(410),
    [sym_list] = STATE(410),
    [sym_list_comprehension] = STATE(410),
    [sym_dictionary] = STATE(410),
    [sym_dictionary_comprehension] = STATE(410),
    [sym_set] = STATE(410),
    [sym_set_comprehension] = STATE(410),
    [sym_parenthesized_expression] = STATE(410),
    [sym_tuple] = STATE(410),
    [sym_generator_expression] = STATE(410),
    [sym_conditional_expression] = STATE(732),
    [sym_concatenated_string] = STATE(410),
    [sym_await] = STATE(732),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_not] = ACTIONS(726),
    [anon_sym_PLUS] = ACTIONS(728),
    [anon_sym_DASH] = ACTIONS(728),
    [anon_sym_TILDE] = ACTIONS(728),
    [anon_sym_lambda] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(732),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(734),
    [sym_integer] = ACTIONS(736),
    [sym_float] = ACTIONS(736),
    [sym_identifier] = ACTIONS(736),
    [sym_true] = ACTIONS(736),
    [sym_false] = ACTIONS(736),
    [sym_none] = ACTIONS(736),
    [anon_sym_await] = ACTIONS(738),
    [sym_comment] = ACTIONS(72),
  },
  [1468] = {
    [sym__simple_statements] = STATE(1687),
    [sym_import_statement] = STATE(1686),
    [sym_import_from_statement] = STATE(1686),
    [sym_print_statement] = STATE(1686),
    [sym_assert_statement] = STATE(1686),
    [sym_expression_statement] = STATE(1686),
    [sym_return_statement] = STATE(1686),
    [sym_delete_statement] = STATE(1686),
    [sym_raise_statement] = STATE(1686),
    [sym_global_statement] = STATE(1686),
    [sym_nonlocal_statement] = STATE(1686),
    [sym_exec_statement] = STATE(1686),
    [sym__suite] = STATE(1687),
    [sym_expression_list] = STATE(32),
    [sym__expression] = STATE(33),
    [sym__primary_expression] = STATE(34),
    [sym_not_operator] = STATE(33),
    [sym_boolean_operator] = STATE(33),
    [sym_binary_operator] = STATE(34),
    [sym_unary_operator] = STATE(34),
    [sym_comparison_operator] = STATE(33),
    [sym_lambda] = STATE(33),
    [sym_assignment] = STATE(35),
    [sym_augmented_assignment] = STATE(35),
    [sym_yield] = STATE(35),
    [sym_attribute] = STATE(34),
    [sym_subscript] = STATE(34),
    [sym_call] = STATE(34),
    [sym_list] = STATE(34),
    [sym_list_comprehension] = STATE(34),
    [sym_dictionary] = STATE(34),
    [sym_dictionary_comprehension] = STATE(34),
    [sym_set] = STATE(34),
    [sym_set_comprehension] = STATE(34),
    [sym_parenthesized_expression] = STATE(34),
    [sym_tuple] = STATE(34),
    [sym_generator_expression] = STATE(34),
    [sym_conditional_expression] = STATE(33),
    [sym_concatenated_string] = STATE(34),
    [sym_await] = STATE(33),
    [sym__indent] = ACTIONS(3783),
    [anon_sym_import] = ACTIONS(10),
    [anon_sym_from] = ACTIONS(12),
    [anon_sym_LPAREN] = ACTIONS(14),
    [anon_sym_print] = ACTIONS(16),
    [anon_sym_assert] = ACTIONS(18),
    [anon_sym_return] = ACTIONS(20),
    [anon_sym_del] = ACTIONS(22),
    [anon_sym_raise] = ACTIONS(24),
    [sym_pass_statement] = ACTIONS(3785),
    [sym_break_statement] = ACTIONS(3785),
    [sym_continue_statement] = ACTIONS(3785),
    [anon_sym_global] = ACTIONS(42),
    [anon_sym_nonlocal] = ACTIONS(44),
    [anon_sym_exec] = ACTIONS(46),
    [anon_sym_not] = ACTIONS(52),
    [anon_sym_PLUS] = ACTIONS(54),
    [anon_sym_DASH] = ACTIONS(54),
    [anon_sym_TILDE] = ACTIONS(54),
    [anon_sym_lambda] = ACTIONS(56),
    [anon_sym_yield] = ACTIONS(58),
    [anon_sym_LBRACK] = ACTIONS(60),
    [sym_ellipsis] = ACTIONS(62),
    [anon_sym_LBRACE] = ACTIONS(64),
    [sym_string] = ACTIONS(66),
    [sym_integer] = ACTIONS(68),
    [sym_float] = ACTIONS(68),
    [sym_identifier] = ACTIONS(68),
    [sym_true] = ACTIONS(68),
    [sym_false] = ACTIONS(68),
    [sym_none] = ACTIONS(68),
    [anon_sym_await] = ACTIONS(70),
    [sym_comment] = ACTIONS(72),
  },
  [1469] = {
    [sym_except_clause] = STATE(1691),
    [sym_finally_clause] = STATE(1690),
    [aux_sym_try_statement_repeat1] = STATE(1691),
    [anon_sym_except] = ACTIONS(3787),
    [anon_sym_finally] = ACTIONS(3789),
    [sym_comment] = ACTIONS(72),
  },
  [1470] = {
    [sym__simple_statements] = STATE(1693),
    [sym_import_statement] = STATE(746),
    [sym_import_from_statement] = STATE(746),
    [sym_print_statement] = STATE(746),
    [sym_assert_statement] = STATE(746),
    [sym_expression_statement] = STATE(746),
    [sym_return_statement] = STATE(746),
    [sym_delete_statement] = STATE(746),
    [sym_raise_statement] = STATE(746),
    [sym_global_statement] = STATE(746),
    [sym_nonlocal_statement] = STATE(746),
    [sym_exec_statement] = STATE(746),
    [sym__suite] = STATE(1693),
    [sym_expression_list] = STATE(32),
    [sym__expression] = STATE(33),
    [sym__primary_expression] = STATE(34),
    [sym_not_operator] = STATE(33),
    [sym_boolean_operator] = STATE(33),
    [sym_binary_operator] = STATE(34),
    [sym_unary_operator] = STATE(34),
    [sym_comparison_operator] = STATE(33),
    [sym_lambda] = STATE(33),
    [sym_assignment] = STATE(35),
    [sym_augmented_assignment] = STATE(35),
    [sym_yield] = STATE(35),
    [sym_attribute] = STATE(34),
    [sym_subscript] = STATE(34),
    [sym_call] = STATE(34),
    [sym_list] = STATE(34),
    [sym_list_comprehension] = STATE(34),
    [sym_dictionary] = STATE(34),
    [sym_dictionary_comprehension] = STATE(34),
    [sym_set] = STATE(34),
    [sym_set_comprehension] = STATE(34),
    [sym_parenthesized_expression] = STATE(34),
    [sym_tuple] = STATE(34),
    [sym_generator_expression] = STATE(34),
    [sym_conditional_expression] = STATE(33),
    [sym_concatenated_string] = STATE(34),
    [sym_await] = STATE(33),
    [sym__indent] = ACTIONS(3791),
    [anon_sym_import] = ACTIONS(10),
    [anon_sym_from] = ACTIONS(12),
    [anon_sym_LPAREN] = ACTIONS(14),
    [anon_sym_print] = ACTIONS(16),
    [anon_sym_assert] = ACTIONS(18),
    [anon_sym_return] = ACTIONS(20),
    [anon_sym_del] = ACTIONS(22),
    [anon_sym_raise] = ACTIONS(24),
    [sym_pass_statement] = ACTIONS(1498),
    [sym_break_statement] = ACTIONS(1498),
    [sym_continue_statement] = ACTIONS(1498),
    [anon_sym_global] = ACTIONS(42),
    [anon_sym_nonlocal] = ACTIONS(44),
    [anon_sym_exec] = ACTIONS(46),
    [anon_sym_not] = ACTIONS(52),
    [anon_sym_PLUS] = ACTIONS(54),
    [anon_sym_DASH] = ACTIONS(54),
    [anon_sym_TILDE] = ACTIONS(54),
    [anon_sym_lambda] = ACTIONS(56),
    [anon_sym_yield] = ACTIONS(58),
    [anon_sym_LBRACK] = ACTIONS(60),
    [sym_ellipsis] = ACTIONS(62),
    [anon_sym_LBRACE] = ACTIONS(64),
    [sym_string] = ACTIONS(66),
    [sym_integer] = ACTIONS(68),
    [sym_float] = ACTIONS(68),
    [sym_identifier] = ACTIONS(68),
    [sym_true] = ACTIONS(68),
    [sym_false] = ACTIONS(68),
    [sym_none] = ACTIONS(68),
    [anon_sym_await] = ACTIONS(70),
    [sym_comment] = ACTIONS(72),
  },
  [1471] = {
    [aux_sym_with_statement_repeat1] = STATE(770),
    [anon_sym_COMMA] = ACTIONS(658),
    [anon_sym_COLON] = ACTIONS(3781),
    [sym_comment] = ACTIONS(72),
  },
  [1472] = {
    [anon_sym_COLON] = ACTIONS(3793),
    [anon_sym_DASH_GT] = ACTIONS(3795),
    [sym_comment] = ACTIONS(72),
  },
  [1473] = {
    [sym__simple_statements] = STATE(1696),
    [sym_import_statement] = STATE(746),
    [sym_import_from_statement] = STATE(746),
    [sym_print_statement] = STATE(746),
    [sym_assert_statement] = STATE(746),
    [sym_expression_statement] = STATE(746),
    [sym_return_statement] = STATE(746),
    [sym_delete_statement] = STATE(746),
    [sym_raise_statement] = STATE(746),
    [sym_global_statement] = STATE(746),
    [sym_nonlocal_statement] = STATE(746),
    [sym_exec_statement] = STATE(746),
    [sym__suite] = STATE(1696),
    [sym_expression_list] = STATE(32),
    [sym__expression] = STATE(33),
    [sym__primary_expression] = STATE(34),
    [sym_not_operator] = STATE(33),
    [sym_boolean_operator] = STATE(33),
    [sym_binary_operator] = STATE(34),
    [sym_unary_operator] = STATE(34),
    [sym_comparison_operator] = STATE(33),
    [sym_lambda] = STATE(33),
    [sym_assignment] = STATE(35),
    [sym_augmented_assignment] = STATE(35),
    [sym_yield] = STATE(35),
    [sym_attribute] = STATE(34),
    [sym_subscript] = STATE(34),
    [sym_call] = STATE(34),
    [sym_list] = STATE(34),
    [sym_list_comprehension] = STATE(34),
    [sym_dictionary] = STATE(34),
    [sym_dictionary_comprehension] = STATE(34),
    [sym_set] = STATE(34),
    [sym_set_comprehension] = STATE(34),
    [sym_parenthesized_expression] = STATE(34),
    [sym_tuple] = STATE(34),
    [sym_generator_expression] = STATE(34),
    [sym_conditional_expression] = STATE(33),
    [sym_concatenated_string] = STATE(34),
    [sym_await] = STATE(33),
    [sym__indent] = ACTIONS(3791),
    [anon_sym_import] = ACTIONS(10),
    [anon_sym_from] = ACTIONS(12),
    [anon_sym_LPAREN] = ACTIONS(14),
    [anon_sym_print] = ACTIONS(16),
    [anon_sym_assert] = ACTIONS(18),
    [anon_sym_return] = ACTIONS(20),
    [anon_sym_del] = ACTIONS(22),
    [anon_sym_raise] = ACTIONS(24),
    [sym_pass_statement] = ACTIONS(1498),
    [sym_break_statement] = ACTIONS(1498),
    [sym_continue_statement] = ACTIONS(1498),
    [anon_sym_global] = ACTIONS(42),
    [anon_sym_nonlocal] = ACTIONS(44),
    [anon_sym_exec] = ACTIONS(46),
    [anon_sym_not] = ACTIONS(52),
    [anon_sym_PLUS] = ACTIONS(54),
    [anon_sym_DASH] = ACTIONS(54),
    [anon_sym_TILDE] = ACTIONS(54),
    [anon_sym_lambda] = ACTIONS(56),
    [anon_sym_yield] = ACTIONS(58),
    [anon_sym_LBRACK] = ACTIONS(60),
    [sym_ellipsis] = ACTIONS(62),
    [anon_sym_LBRACE] = ACTIONS(64),
    [sym_string] = ACTIONS(66),
    [sym_integer] = ACTIONS(68),
    [sym_float] = ACTIONS(68),
    [sym_identifier] = ACTIONS(68),
    [sym_true] = ACTIONS(68),
    [sym_false] = ACTIONS(68),
    [sym_none] = ACTIONS(68),
    [anon_sym_await] = ACTIONS(70),
    [sym_comment] = ACTIONS(72),
  },
  [1474] = {
    [anon_sym_COLON] = ACTIONS(3797),
    [sym_comment] = ACTIONS(72),
  },
  [1475] = {
    [ts_builtin_sym_end] = ACTIONS(2319),
    [anon_sym_import] = ACTIONS(2321),
    [anon_sym_from] = ACTIONS(2321),
    [anon_sym_LPAREN] = ACTIONS(2319),
    [anon_sym_print] = ACTIONS(2321),
    [anon_sym_assert] = ACTIONS(2321),
    [anon_sym_return] = ACTIONS(2321),
    [anon_sym_del] = ACTIONS(2321),
    [anon_sym_raise] = ACTIONS(2321),
    [sym_pass_statement] = ACTIONS(2321),
    [sym_break_statement] = ACTIONS(2321),
    [sym_continue_statement] = ACTIONS(2321),
    [anon_sym_if] = ACTIONS(2321),
    [anon_sym_else] = ACTIONS(2321),
    [anon_sym_async] = ACTIONS(2321),
    [anon_sym_for] = ACTIONS(2321),
    [anon_sym_while] = ACTIONS(2321),
    [anon_sym_try] = ACTIONS(2321),
    [anon_sym_except] = ACTIONS(2321),
    [anon_sym_finally] = ACTIONS(2321),
    [anon_sym_with] = ACTIONS(2321),
    [anon_sym_def] = ACTIONS(2321),
    [anon_sym_global] = ACTIONS(2321),
    [anon_sym_nonlocal] = ACTIONS(2321),
    [anon_sym_exec] = ACTIONS(2321),
    [anon_sym_class] = ACTIONS(2321),
    [anon_sym_AT] = ACTIONS(2319),
    [anon_sym_not] = ACTIONS(2321),
    [anon_sym_PLUS] = ACTIONS(2319),
    [anon_sym_DASH] = ACTIONS(2319),
    [anon_sym_TILDE] = ACTIONS(2319),
    [anon_sym_lambda] = ACTIONS(2321),
    [anon_sym_yield] = ACTIONS(2321),
    [anon_sym_LBRACK] = ACTIONS(2319),
    [sym_ellipsis] = ACTIONS(2319),
    [anon_sym_LBRACE] = ACTIONS(2319),
    [sym_string] = ACTIONS(2319),
    [sym_integer] = ACTIONS(2321),
    [sym_float] = ACTIONS(2321),
    [sym_identifier] = ACTIONS(2321),
    [sym_true] = ACTIONS(2321),
    [sym_false] = ACTIONS(2321),
    [sym_none] = ACTIONS(2321),
    [anon_sym_await] = ACTIONS(2321),
    [sym_comment] = ACTIONS(72),
  },
  [1476] = {
    [ts_builtin_sym_end] = ACTIONS(3799),
    [anon_sym_import] = ACTIONS(3801),
    [anon_sym_from] = ACTIONS(3801),
    [anon_sym_LPAREN] = ACTIONS(3799),
    [anon_sym_print] = ACTIONS(3801),
    [anon_sym_assert] = ACTIONS(3801),
    [anon_sym_return] = ACTIONS(3801),
    [anon_sym_del] = ACTIONS(3801),
    [anon_sym_raise] = ACTIONS(3801),
    [sym_pass_statement] = ACTIONS(3801),
    [sym_break_statement] = ACTIONS(3801),
    [sym_continue_statement] = ACTIONS(3801),
    [anon_sym_if] = ACTIONS(3801),
    [anon_sym_else] = ACTIONS(3801),
    [anon_sym_async] = ACTIONS(3801),
    [anon_sym_for] = ACTIONS(3801),
    [anon_sym_while] = ACTIONS(3801),
    [anon_sym_try] = ACTIONS(3801),
    [anon_sym_except] = ACTIONS(3801),
    [anon_sym_finally] = ACTIONS(3801),
    [anon_sym_with] = ACTIONS(3801),
    [anon_sym_def] = ACTIONS(3801),
    [anon_sym_global] = ACTIONS(3801),
    [anon_sym_nonlocal] = ACTIONS(3801),
    [anon_sym_exec] = ACTIONS(3801),
    [anon_sym_class] = ACTIONS(3801),
    [anon_sym_AT] = ACTIONS(3799),
    [anon_sym_not] = ACTIONS(3801),
    [anon_sym_PLUS] = ACTIONS(3799),
    [anon_sym_DASH] = ACTIONS(3799),
    [anon_sym_TILDE] = ACTIONS(3799),
    [anon_sym_lambda] = ACTIONS(3801),
    [anon_sym_yield] = ACTIONS(3801),
    [anon_sym_LBRACK] = ACTIONS(3799),
    [sym_ellipsis] = ACTIONS(3799),
    [anon_sym_LBRACE] = ACTIONS(3799),
    [sym_string] = ACTIONS(3799),
    [sym_integer] = ACTIONS(3801),
    [sym_float] = ACTIONS(3801),
    [sym_identifier] = ACTIONS(3801),
    [sym_true] = ACTIONS(3801),
    [sym_false] = ACTIONS(3801),
    [sym_none] = ACTIONS(3801),
    [anon_sym_await] = ACTIONS(3801),
    [sym_comment] = ACTIONS(72),
  },
  [1477] = {
    [sym__expression] = STATE(1698),
    [sym__primary_expression] = STATE(96),
    [sym_not_operator] = STATE(1698),
    [sym_boolean_operator] = STATE(1698),
    [sym_binary_operator] = STATE(96),
    [sym_unary_operator] = STATE(96),
    [sym_comparison_operator] = STATE(1698),
    [sym_lambda] = STATE(1698),
    [sym_attribute] = STATE(96),
    [sym_subscript] = STATE(96),
    [sym_call] = STATE(96),
    [sym_list] = STATE(96),
    [sym_list_comprehension] = STATE(96),
    [sym_dictionary] = STATE(96),
    [sym_dictionary_comprehension] = STATE(96),
    [sym_set] = STATE(96),
    [sym_set_comprehension] = STATE(96),
    [sym_parenthesized_expression] = STATE(96),
    [sym_tuple] = STATE(96),
    [sym_generator_expression] = STATE(96),
    [sym_conditional_expression] = STATE(1698),
    [sym_concatenated_string] = STATE(96),
    [sym_await] = STATE(1698),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_not] = ACTIONS(160),
    [anon_sym_PLUS] = ACTIONS(162),
    [anon_sym_DASH] = ACTIONS(162),
    [anon_sym_TILDE] = ACTIONS(162),
    [anon_sym_lambda] = ACTIONS(164),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(166),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(168),
    [sym_integer] = ACTIONS(170),
    [sym_float] = ACTIONS(170),
    [sym_identifier] = ACTIONS(170),
    [sym_true] = ACTIONS(170),
    [sym_false] = ACTIONS(170),
    [sym_none] = ACTIONS(170),
    [anon_sym_await] = ACTIONS(172),
    [sym_comment] = ACTIONS(72),
  },
  [1478] = {
    [sym__simple_statements] = STATE(1699),
    [sym_import_statement] = STATE(364),
    [sym_import_from_statement] = STATE(364),
    [sym_print_statement] = STATE(364),
    [sym_assert_statement] = STATE(364),
    [sym_expression_statement] = STATE(364),
    [sym_return_statement] = STATE(364),
    [sym_delete_statement] = STATE(364),
    [sym_raise_statement] = STATE(364),
    [sym_global_statement] = STATE(364),
    [sym_nonlocal_statement] = STATE(364),
    [sym_exec_statement] = STATE(364),
    [sym__suite] = STATE(1699),
    [sym_expression_list] = STATE(32),
    [sym__expression] = STATE(33),
    [sym__primary_expression] = STATE(34),
    [sym_not_operator] = STATE(33),
    [sym_boolean_operator] = STATE(33),
    [sym_binary_operator] = STATE(34),
    [sym_unary_operator] = STATE(34),
    [sym_comparison_operator] = STATE(33),
    [sym_lambda] = STATE(33),
    [sym_assignment] = STATE(35),
    [sym_augmented_assignment] = STATE(35),
    [sym_yield] = STATE(35),
    [sym_attribute] = STATE(34),
    [sym_subscript] = STATE(34),
    [sym_call] = STATE(34),
    [sym_list] = STATE(34),
    [sym_list_comprehension] = STATE(34),
    [sym_dictionary] = STATE(34),
    [sym_dictionary_comprehension] = STATE(34),
    [sym_set] = STATE(34),
    [sym_set_comprehension] = STATE(34),
    [sym_parenthesized_expression] = STATE(34),
    [sym_tuple] = STATE(34),
    [sym_generator_expression] = STATE(34),
    [sym_conditional_expression] = STATE(33),
    [sym_concatenated_string] = STATE(34),
    [sym_await] = STATE(33),
    [sym__indent] = ACTIONS(650),
    [anon_sym_import] = ACTIONS(10),
    [anon_sym_from] = ACTIONS(12),
    [anon_sym_LPAREN] = ACTIONS(14),
    [anon_sym_print] = ACTIONS(16),
    [anon_sym_assert] = ACTIONS(18),
    [anon_sym_return] = ACTIONS(20),
    [anon_sym_del] = ACTIONS(22),
    [anon_sym_raise] = ACTIONS(24),
    [sym_pass_statement] = ACTIONS(652),
    [sym_break_statement] = ACTIONS(652),
    [sym_continue_statement] = ACTIONS(652),
    [anon_sym_global] = ACTIONS(42),
    [anon_sym_nonlocal] = ACTIONS(44),
    [anon_sym_exec] = ACTIONS(46),
    [anon_sym_not] = ACTIONS(52),
    [anon_sym_PLUS] = ACTIONS(54),
    [anon_sym_DASH] = ACTIONS(54),
    [anon_sym_TILDE] = ACTIONS(54),
    [anon_sym_lambda] = ACTIONS(56),
    [anon_sym_yield] = ACTIONS(58),
    [anon_sym_LBRACK] = ACTIONS(60),
    [sym_ellipsis] = ACTIONS(62),
    [anon_sym_LBRACE] = ACTIONS(64),
    [sym_string] = ACTIONS(66),
    [sym_integer] = ACTIONS(68),
    [sym_float] = ACTIONS(68),
    [sym_identifier] = ACTIONS(68),
    [sym_true] = ACTIONS(68),
    [sym_false] = ACTIONS(68),
    [sym_none] = ACTIONS(68),
    [anon_sym_await] = ACTIONS(70),
    [sym_comment] = ACTIONS(72),
  },
  [1479] = {
    [ts_builtin_sym_end] = ACTIONS(3803),
    [anon_sym_import] = ACTIONS(3805),
    [anon_sym_from] = ACTIONS(3805),
    [anon_sym_LPAREN] = ACTIONS(3803),
    [anon_sym_print] = ACTIONS(3805),
    [anon_sym_assert] = ACTIONS(3805),
    [anon_sym_return] = ACTIONS(3805),
    [anon_sym_del] = ACTIONS(3805),
    [anon_sym_raise] = ACTIONS(3805),
    [sym_pass_statement] = ACTIONS(3805),
    [sym_break_statement] = ACTIONS(3805),
    [sym_continue_statement] = ACTIONS(3805),
    [anon_sym_if] = ACTIONS(3805),
    [anon_sym_async] = ACTIONS(3805),
    [anon_sym_for] = ACTIONS(3805),
    [anon_sym_while] = ACTIONS(3805),
    [anon_sym_try] = ACTIONS(3805),
    [anon_sym_with] = ACTIONS(3805),
    [anon_sym_def] = ACTIONS(3805),
    [anon_sym_global] = ACTIONS(3805),
    [anon_sym_nonlocal] = ACTIONS(3805),
    [anon_sym_exec] = ACTIONS(3805),
    [anon_sym_class] = ACTIONS(3805),
    [anon_sym_AT] = ACTIONS(3803),
    [anon_sym_not] = ACTIONS(3805),
    [anon_sym_PLUS] = ACTIONS(3803),
    [anon_sym_DASH] = ACTIONS(3803),
    [anon_sym_TILDE] = ACTIONS(3803),
    [anon_sym_lambda] = ACTIONS(3805),
    [anon_sym_yield] = ACTIONS(3805),
    [anon_sym_LBRACK] = ACTIONS(3803),
    [sym_ellipsis] = ACTIONS(3803),
    [anon_sym_LBRACE] = ACTIONS(3803),
    [sym_string] = ACTIONS(3803),
    [sym_integer] = ACTIONS(3805),
    [sym_float] = ACTIONS(3805),
    [sym_identifier] = ACTIONS(3805),
    [sym_true] = ACTIONS(3805),
    [sym_false] = ACTIONS(3805),
    [sym_none] = ACTIONS(3805),
    [anon_sym_await] = ACTIONS(3805),
    [sym_comment] = ACTIONS(72),
  },
  [1480] = {
    [sym__simple_statements] = STATE(1702),
    [sym_import_statement] = STATE(1701),
    [sym_import_from_statement] = STATE(1701),
    [sym_print_statement] = STATE(1701),
    [sym_assert_statement] = STATE(1701),
    [sym_expression_statement] = STATE(1701),
    [sym_return_statement] = STATE(1701),
    [sym_delete_statement] = STATE(1701),
    [sym_raise_statement] = STATE(1701),
    [sym_global_statement] = STATE(1701),
    [sym_nonlocal_statement] = STATE(1701),
    [sym_exec_statement] = STATE(1701),
    [sym__suite] = STATE(1702),
    [sym_expression_list] = STATE(32),
    [sym__expression] = STATE(33),
    [sym__primary_expression] = STATE(34),
    [sym_not_operator] = STATE(33),
    [sym_boolean_operator] = STATE(33),
    [sym_binary_operator] = STATE(34),
    [sym_unary_operator] = STATE(34),
    [sym_comparison_operator] = STATE(33),
    [sym_lambda] = STATE(33),
    [sym_assignment] = STATE(35),
    [sym_augmented_assignment] = STATE(35),
    [sym_yield] = STATE(35),
    [sym_attribute] = STATE(34),
    [sym_subscript] = STATE(34),
    [sym_call] = STATE(34),
    [sym_list] = STATE(34),
    [sym_list_comprehension] = STATE(34),
    [sym_dictionary] = STATE(34),
    [sym_dictionary_comprehension] = STATE(34),
    [sym_set] = STATE(34),
    [sym_set_comprehension] = STATE(34),
    [sym_parenthesized_expression] = STATE(34),
    [sym_tuple] = STATE(34),
    [sym_generator_expression] = STATE(34),
    [sym_conditional_expression] = STATE(33),
    [sym_concatenated_string] = STATE(34),
    [sym_await] = STATE(33),
    [sym__indent] = ACTIONS(3807),
    [anon_sym_import] = ACTIONS(10),
    [anon_sym_from] = ACTIONS(12),
    [anon_sym_LPAREN] = ACTIONS(14),
    [anon_sym_print] = ACTIONS(16),
    [anon_sym_assert] = ACTIONS(18),
    [anon_sym_return] = ACTIONS(20),
    [anon_sym_del] = ACTIONS(22),
    [anon_sym_raise] = ACTIONS(24),
    [sym_pass_statement] = ACTIONS(3809),
    [sym_break_statement] = ACTIONS(3809),
    [sym_continue_statement] = ACTIONS(3809),
    [anon_sym_global] = ACTIONS(42),
    [anon_sym_nonlocal] = ACTIONS(44),
    [anon_sym_exec] = ACTIONS(46),
    [anon_sym_not] = ACTIONS(52),
    [anon_sym_PLUS] = ACTIONS(54),
    [anon_sym_DASH] = ACTIONS(54),
    [anon_sym_TILDE] = ACTIONS(54),
    [anon_sym_lambda] = ACTIONS(56),
    [anon_sym_yield] = ACTIONS(58),
    [anon_sym_LBRACK] = ACTIONS(60),
    [sym_ellipsis] = ACTIONS(62),
    [anon_sym_LBRACE] = ACTIONS(64),
    [sym_string] = ACTIONS(66),
    [sym_integer] = ACTIONS(68),
    [sym_float] = ACTIONS(68),
    [sym_identifier] = ACTIONS(68),
    [sym_true] = ACTIONS(68),
    [sym_false] = ACTIONS(68),
    [sym_none] = ACTIONS(68),
    [anon_sym_await] = ACTIONS(70),
    [sym_comment] = ACTIONS(72),
  },
  [1481] = {
    [ts_builtin_sym_end] = ACTIONS(3811),
    [anon_sym_import] = ACTIONS(3813),
    [anon_sym_from] = ACTIONS(3813),
    [anon_sym_LPAREN] = ACTIONS(3811),
    [anon_sym_print] = ACTIONS(3813),
    [anon_sym_assert] = ACTIONS(3813),
    [anon_sym_return] = ACTIONS(3813),
    [anon_sym_del] = ACTIONS(3813),
    [anon_sym_raise] = ACTIONS(3813),
    [sym_pass_statement] = ACTIONS(3813),
    [sym_break_statement] = ACTIONS(3813),
    [sym_continue_statement] = ACTIONS(3813),
    [anon_sym_if] = ACTIONS(3813),
    [anon_sym_async] = ACTIONS(3813),
    [anon_sym_for] = ACTIONS(3813),
    [anon_sym_while] = ACTIONS(3813),
    [anon_sym_try] = ACTIONS(3813),
    [anon_sym_with] = ACTIONS(3813),
    [anon_sym_def] = ACTIONS(3813),
    [anon_sym_global] = ACTIONS(3813),
    [anon_sym_nonlocal] = ACTIONS(3813),
    [anon_sym_exec] = ACTIONS(3813),
    [anon_sym_class] = ACTIONS(3813),
    [anon_sym_AT] = ACTIONS(3811),
    [anon_sym_not] = ACTIONS(3813),
    [anon_sym_PLUS] = ACTIONS(3811),
    [anon_sym_DASH] = ACTIONS(3811),
    [anon_sym_TILDE] = ACTIONS(3811),
    [anon_sym_lambda] = ACTIONS(3813),
    [anon_sym_yield] = ACTIONS(3813),
    [anon_sym_LBRACK] = ACTIONS(3811),
    [sym_ellipsis] = ACTIONS(3811),
    [anon_sym_LBRACE] = ACTIONS(3811),
    [sym_string] = ACTIONS(3811),
    [sym_integer] = ACTIONS(3813),
    [sym_float] = ACTIONS(3813),
    [sym_identifier] = ACTIONS(3813),
    [sym_true] = ACTIONS(3813),
    [sym_false] = ACTIONS(3813),
    [sym_none] = ACTIONS(3813),
    [anon_sym_await] = ACTIONS(3813),
    [sym_comment] = ACTIONS(72),
  },
  [1482] = {
    [ts_builtin_sym_end] = ACTIONS(3187),
    [anon_sym_import] = ACTIONS(3189),
    [anon_sym_from] = ACTIONS(3189),
    [anon_sym_LPAREN] = ACTIONS(3187),
    [anon_sym_print] = ACTIONS(3189),
    [anon_sym_assert] = ACTIONS(3189),
    [anon_sym_return] = ACTIONS(3189),
    [anon_sym_del] = ACTIONS(3189),
    [anon_sym_raise] = ACTIONS(3189),
    [sym_pass_statement] = ACTIONS(3189),
    [sym_break_statement] = ACTIONS(3189),
    [sym_continue_statement] = ACTIONS(3189),
    [anon_sym_if] = ACTIONS(3189),
    [anon_sym_async] = ACTIONS(3189),
    [anon_sym_for] = ACTIONS(3189),
    [anon_sym_while] = ACTIONS(3189),
    [anon_sym_try] = ACTIONS(3189),
    [anon_sym_with] = ACTIONS(3189),
    [anon_sym_def] = ACTIONS(3189),
    [anon_sym_global] = ACTIONS(3189),
    [anon_sym_nonlocal] = ACTIONS(3189),
    [anon_sym_exec] = ACTIONS(3189),
    [anon_sym_class] = ACTIONS(3189),
    [anon_sym_AT] = ACTIONS(3187),
    [anon_sym_not] = ACTIONS(3189),
    [anon_sym_PLUS] = ACTIONS(3187),
    [anon_sym_DASH] = ACTIONS(3187),
    [anon_sym_TILDE] = ACTIONS(3187),
    [anon_sym_lambda] = ACTIONS(3189),
    [anon_sym_yield] = ACTIONS(3189),
    [anon_sym_LBRACK] = ACTIONS(3187),
    [sym_ellipsis] = ACTIONS(3187),
    [anon_sym_LBRACE] = ACTIONS(3187),
    [sym_string] = ACTIONS(3187),
    [sym_integer] = ACTIONS(3189),
    [sym_float] = ACTIONS(3189),
    [sym_identifier] = ACTIONS(3189),
    [sym_true] = ACTIONS(3189),
    [sym_false] = ACTIONS(3189),
    [sym_none] = ACTIONS(3189),
    [anon_sym_await] = ACTIONS(3189),
    [sym_comment] = ACTIONS(72),
  },
  [1483] = {
    [anon_sym_COMMA] = ACTIONS(3610),
    [anon_sym_as] = ACTIONS(3610),
    [anon_sym_if] = ACTIONS(666),
    [anon_sym_COLON] = ACTIONS(3610),
    [anon_sym_and] = ACTIONS(668),
    [anon_sym_or] = ACTIONS(670),
    [sym_comment] = ACTIONS(72),
  },
  [1484] = {
    [anon_sym_RPAREN] = ACTIONS(2515),
    [anon_sym_COMMA] = ACTIONS(2515),
    [anon_sym_if] = ACTIONS(3243),
    [anon_sym_COLON] = ACTIONS(2515),
    [anon_sym_and] = ACTIONS(3245),
    [anon_sym_or] = ACTIONS(3247),
    [sym_comment] = ACTIONS(72),
  },
  [1485] = {
    [anon_sym_RPAREN] = ACTIONS(716),
    [anon_sym_COMMA] = ACTIONS(716),
    [anon_sym_if] = ACTIONS(716),
    [anon_sym_COLON] = ACTIONS(716),
    [anon_sym_and] = ACTIONS(3245),
    [anon_sym_or] = ACTIONS(3247),
    [sym_comment] = ACTIONS(72),
  },
  [1486] = {
    [sym__expression] = STATE(1703),
    [sym__primary_expression] = STATE(1179),
    [sym_not_operator] = STATE(1703),
    [sym_boolean_operator] = STATE(1703),
    [sym_binary_operator] = STATE(1179),
    [sym_unary_operator] = STATE(1179),
    [sym_comparison_operator] = STATE(1703),
    [sym_lambda] = STATE(1703),
    [sym_attribute] = STATE(1179),
    [sym_subscript] = STATE(1179),
    [sym_call] = STATE(1179),
    [sym_list] = STATE(1179),
    [sym_list_comprehension] = STATE(1179),
    [sym_dictionary] = STATE(1179),
    [sym_dictionary_comprehension] = STATE(1179),
    [sym_set] = STATE(1179),
    [sym_set_comprehension] = STATE(1179),
    [sym_parenthesized_expression] = STATE(1179),
    [sym_tuple] = STATE(1179),
    [sym_generator_expression] = STATE(1179),
    [sym_conditional_expression] = STATE(1703),
    [sym_concatenated_string] = STATE(1179),
    [sym_await] = STATE(1703),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_not] = ACTIONS(2472),
    [anon_sym_PLUS] = ACTIONS(2474),
    [anon_sym_DASH] = ACTIONS(2474),
    [anon_sym_TILDE] = ACTIONS(2474),
    [anon_sym_lambda] = ACTIONS(2476),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(2478),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(2480),
    [sym_integer] = ACTIONS(2482),
    [sym_float] = ACTIONS(2482),
    [sym_identifier] = ACTIONS(2482),
    [sym_true] = ACTIONS(2482),
    [sym_false] = ACTIONS(2482),
    [sym_none] = ACTIONS(2482),
    [anon_sym_await] = ACTIONS(2484),
    [sym_comment] = ACTIONS(72),
  },
  [1487] = {
    [anon_sym_COLON] = ACTIONS(3815),
    [sym_comment] = ACTIONS(72),
  },
  [1488] = {
    [aux_sym_concatenated_string_repeat1] = STATE(1705),
    [anon_sym_DOT] = ACTIONS(886),
    [anon_sym_LPAREN] = ACTIONS(886),
    [anon_sym_RPAREN] = ACTIONS(886),
    [anon_sym_COMMA] = ACTIONS(886),
    [anon_sym_STAR] = ACTIONS(888),
    [anon_sym_GT_GT] = ACTIONS(886),
    [anon_sym_if] = ACTIONS(886),
    [anon_sym_COLON] = ACTIONS(886),
    [anon_sym_in] = ACTIONS(886),
    [anon_sym_AT] = ACTIONS(886),
    [anon_sym_not] = ACTIONS(886),
    [anon_sym_and] = ACTIONS(886),
    [anon_sym_or] = ACTIONS(886),
    [anon_sym_PLUS] = ACTIONS(886),
    [anon_sym_DASH] = ACTIONS(886),
    [anon_sym_SLASH] = ACTIONS(888),
    [anon_sym_PERCENT] = ACTIONS(886),
    [anon_sym_SLASH_SLASH] = ACTIONS(886),
    [anon_sym_STAR_STAR] = ACTIONS(886),
    [anon_sym_PIPE] = ACTIONS(886),
    [anon_sym_AMP] = ACTIONS(886),
    [anon_sym_CARET] = ACTIONS(886),
    [anon_sym_LT_LT] = ACTIONS(886),
    [anon_sym_LT] = ACTIONS(888),
    [anon_sym_LT_EQ] = ACTIONS(886),
    [anon_sym_EQ_EQ] = ACTIONS(886),
    [anon_sym_BANG_EQ] = ACTIONS(886),
    [anon_sym_GT_EQ] = ACTIONS(886),
    [anon_sym_GT] = ACTIONS(888),
    [anon_sym_LT_GT] = ACTIONS(886),
    [anon_sym_is] = ACTIONS(886),
    [anon_sym_LBRACK] = ACTIONS(886),
    [sym_string] = ACTIONS(3817),
    [sym_comment] = ACTIONS(72),
  },
  [1489] = {
    [sym__expression] = STATE(1706),
    [sym__primary_expression] = STATE(513),
    [sym_not_operator] = STATE(1706),
    [sym_boolean_operator] = STATE(1706),
    [sym_binary_operator] = STATE(513),
    [sym_unary_operator] = STATE(513),
    [sym_comparison_operator] = STATE(1706),
    [sym_lambda] = STATE(1706),
    [sym_attribute] = STATE(513),
    [sym_subscript] = STATE(513),
    [sym_call] = STATE(513),
    [sym_list] = STATE(513),
    [sym_list_comprehension] = STATE(513),
    [sym_dictionary] = STATE(513),
    [sym_dictionary_comprehension] = STATE(513),
    [sym_set] = STATE(513),
    [sym_set_comprehension] = STATE(513),
    [sym_parenthesized_expression] = STATE(513),
    [sym_tuple] = STATE(513),
    [sym_generator_expression] = STATE(513),
    [sym_conditional_expression] = STATE(1706),
    [sym_concatenated_string] = STATE(513),
    [sym_await] = STATE(1706),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_not] = ACTIONS(914),
    [anon_sym_PLUS] = ACTIONS(916),
    [anon_sym_DASH] = ACTIONS(916),
    [anon_sym_TILDE] = ACTIONS(916),
    [anon_sym_lambda] = ACTIONS(918),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(920),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(922),
    [sym_integer] = ACTIONS(924),
    [sym_float] = ACTIONS(924),
    [sym_identifier] = ACTIONS(924),
    [sym_true] = ACTIONS(924),
    [sym_false] = ACTIONS(924),
    [sym_none] = ACTIONS(924),
    [anon_sym_await] = ACTIONS(926),
    [sym_comment] = ACTIONS(72),
  },
  [1490] = {
    [sym__expression] = STATE(604),
    [sym__primary_expression] = STATE(1179),
    [sym_not_operator] = STATE(604),
    [sym_boolean_operator] = STATE(604),
    [sym_binary_operator] = STATE(1179),
    [sym_unary_operator] = STATE(1179),
    [sym_comparison_operator] = STATE(604),
    [sym_lambda] = STATE(604),
    [sym_attribute] = STATE(1179),
    [sym_subscript] = STATE(1179),
    [sym_call] = STATE(1179),
    [sym_list] = STATE(1179),
    [sym_list_comprehension] = STATE(1179),
    [sym_dictionary] = STATE(1179),
    [sym_dictionary_comprehension] = STATE(1179),
    [sym_set] = STATE(1179),
    [sym_set_comprehension] = STATE(1179),
    [sym_parenthesized_expression] = STATE(1179),
    [sym_tuple] = STATE(1179),
    [sym_generator_expression] = STATE(1179),
    [sym_conditional_expression] = STATE(604),
    [sym_concatenated_string] = STATE(1179),
    [sym_await] = STATE(604),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_not] = ACTIONS(2472),
    [anon_sym_PLUS] = ACTIONS(2474),
    [anon_sym_DASH] = ACTIONS(2474),
    [anon_sym_TILDE] = ACTIONS(2474),
    [anon_sym_lambda] = ACTIONS(2476),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(2478),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(2480),
    [sym_integer] = ACTIONS(2482),
    [sym_float] = ACTIONS(2482),
    [sym_identifier] = ACTIONS(2482),
    [sym_true] = ACTIONS(2482),
    [sym_false] = ACTIONS(2482),
    [sym_none] = ACTIONS(2482),
    [anon_sym_await] = ACTIONS(2484),
    [sym_comment] = ACTIONS(72),
  },
  [1491] = {
    [sym__expression] = STATE(1707),
    [sym__primary_expression] = STATE(1179),
    [sym_not_operator] = STATE(1707),
    [sym_boolean_operator] = STATE(1707),
    [sym_binary_operator] = STATE(1179),
    [sym_unary_operator] = STATE(1179),
    [sym_comparison_operator] = STATE(1707),
    [sym_lambda] = STATE(1707),
    [sym_attribute] = STATE(1179),
    [sym_subscript] = STATE(1179),
    [sym_call] = STATE(1179),
    [sym_list] = STATE(1179),
    [sym_list_comprehension] = STATE(1179),
    [sym_dictionary] = STATE(1179),
    [sym_dictionary_comprehension] = STATE(1179),
    [sym_set] = STATE(1179),
    [sym_set_comprehension] = STATE(1179),
    [sym_parenthesized_expression] = STATE(1179),
    [sym_tuple] = STATE(1179),
    [sym_generator_expression] = STATE(1179),
    [sym_conditional_expression] = STATE(1707),
    [sym_concatenated_string] = STATE(1179),
    [sym_await] = STATE(1707),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_not] = ACTIONS(2472),
    [anon_sym_PLUS] = ACTIONS(2474),
    [anon_sym_DASH] = ACTIONS(2474),
    [anon_sym_TILDE] = ACTIONS(2474),
    [anon_sym_lambda] = ACTIONS(2476),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(2478),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(2480),
    [sym_integer] = ACTIONS(2482),
    [sym_float] = ACTIONS(2482),
    [sym_identifier] = ACTIONS(2482),
    [sym_true] = ACTIONS(2482),
    [sym_false] = ACTIONS(2482),
    [sym_none] = ACTIONS(2482),
    [anon_sym_await] = ACTIONS(2484),
    [sym_comment] = ACTIONS(72),
  },
  [1492] = {
    [sym__primary_expression] = STATE(1708),
    [sym_binary_operator] = STATE(1708),
    [sym_unary_operator] = STATE(1708),
    [sym_attribute] = STATE(1708),
    [sym_subscript] = STATE(1708),
    [sym_call] = STATE(1708),
    [sym_list] = STATE(1708),
    [sym_list_comprehension] = STATE(1708),
    [sym_dictionary] = STATE(1708),
    [sym_dictionary_comprehension] = STATE(1708),
    [sym_set] = STATE(1708),
    [sym_set_comprehension] = STATE(1708),
    [sym_parenthesized_expression] = STATE(1708),
    [sym_tuple] = STATE(1708),
    [sym_generator_expression] = STATE(1708),
    [sym_concatenated_string] = STATE(1708),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_PLUS] = ACTIONS(2474),
    [anon_sym_DASH] = ACTIONS(2474),
    [anon_sym_TILDE] = ACTIONS(2474),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(3819),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(2480),
    [sym_integer] = ACTIONS(3821),
    [sym_float] = ACTIONS(3821),
    [sym_identifier] = ACTIONS(3821),
    [sym_true] = ACTIONS(3821),
    [sym_false] = ACTIONS(3821),
    [sym_none] = ACTIONS(3821),
    [sym_comment] = ACTIONS(72),
  },
  [1493] = {
    [sym__primary_expression] = STATE(1709),
    [sym_binary_operator] = STATE(1709),
    [sym_unary_operator] = STATE(1709),
    [sym_attribute] = STATE(1709),
    [sym_subscript] = STATE(1709),
    [sym_call] = STATE(1709),
    [sym_list] = STATE(1709),
    [sym_list_comprehension] = STATE(1709),
    [sym_dictionary] = STATE(1709),
    [sym_dictionary_comprehension] = STATE(1709),
    [sym_set] = STATE(1709),
    [sym_set_comprehension] = STATE(1709),
    [sym_parenthesized_expression] = STATE(1709),
    [sym_tuple] = STATE(1709),
    [sym_generator_expression] = STATE(1709),
    [sym_concatenated_string] = STATE(1709),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_PLUS] = ACTIONS(2474),
    [anon_sym_DASH] = ACTIONS(2474),
    [anon_sym_TILDE] = ACTIONS(2474),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(3823),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(2480),
    [sym_integer] = ACTIONS(3825),
    [sym_float] = ACTIONS(3825),
    [sym_identifier] = ACTIONS(3825),
    [sym_true] = ACTIONS(3825),
    [sym_false] = ACTIONS(3825),
    [sym_none] = ACTIONS(3825),
    [sym_comment] = ACTIONS(72),
  },
  [1494] = {
    [sym__primary_expression] = STATE(1710),
    [sym_binary_operator] = STATE(1710),
    [sym_unary_operator] = STATE(1710),
    [sym_attribute] = STATE(1710),
    [sym_subscript] = STATE(1710),
    [sym_call] = STATE(1710),
    [sym_list] = STATE(1710),
    [sym_list_comprehension] = STATE(1710),
    [sym_dictionary] = STATE(1710),
    [sym_dictionary_comprehension] = STATE(1710),
    [sym_set] = STATE(1710),
    [sym_set_comprehension] = STATE(1710),
    [sym_parenthesized_expression] = STATE(1710),
    [sym_tuple] = STATE(1710),
    [sym_generator_expression] = STATE(1710),
    [sym_concatenated_string] = STATE(1710),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_PLUS] = ACTIONS(2474),
    [anon_sym_DASH] = ACTIONS(2474),
    [anon_sym_TILDE] = ACTIONS(2474),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(3827),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(2480),
    [sym_integer] = ACTIONS(3829),
    [sym_float] = ACTIONS(3829),
    [sym_identifier] = ACTIONS(3829),
    [sym_true] = ACTIONS(3829),
    [sym_false] = ACTIONS(3829),
    [sym_none] = ACTIONS(3829),
    [sym_comment] = ACTIONS(72),
  },
  [1495] = {
    [anon_sym_in] = ACTIONS(3831),
    [sym_comment] = ACTIONS(72),
  },
  [1496] = {
    [sym__primary_expression] = STATE(1712),
    [sym_binary_operator] = STATE(1712),
    [sym_unary_operator] = STATE(1712),
    [sym_attribute] = STATE(1712),
    [sym_subscript] = STATE(1712),
    [sym_call] = STATE(1712),
    [sym_list] = STATE(1712),
    [sym_list_comprehension] = STATE(1712),
    [sym_dictionary] = STATE(1712),
    [sym_dictionary_comprehension] = STATE(1712),
    [sym_set] = STATE(1712),
    [sym_set_comprehension] = STATE(1712),
    [sym_parenthesized_expression] = STATE(1712),
    [sym_tuple] = STATE(1712),
    [sym_generator_expression] = STATE(1712),
    [sym_concatenated_string] = STATE(1712),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_PLUS] = ACTIONS(2474),
    [anon_sym_DASH] = ACTIONS(2474),
    [anon_sym_TILDE] = ACTIONS(2474),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(3833),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(2480),
    [sym_integer] = ACTIONS(3835),
    [sym_float] = ACTIONS(3835),
    [sym_identifier] = ACTIONS(3835),
    [sym_true] = ACTIONS(3835),
    [sym_false] = ACTIONS(3835),
    [sym_none] = ACTIONS(3835),
    [sym_comment] = ACTIONS(72),
  },
  [1497] = {
    [sym__primary_expression] = STATE(621),
    [sym_binary_operator] = STATE(621),
    [sym_unary_operator] = STATE(621),
    [sym_attribute] = STATE(621),
    [sym_subscript] = STATE(621),
    [sym_call] = STATE(621),
    [sym_list] = STATE(621),
    [sym_list_comprehension] = STATE(621),
    [sym_dictionary] = STATE(621),
    [sym_dictionary_comprehension] = STATE(621),
    [sym_set] = STATE(621),
    [sym_set_comprehension] = STATE(621),
    [sym_parenthesized_expression] = STATE(621),
    [sym_tuple] = STATE(621),
    [sym_generator_expression] = STATE(621),
    [sym_concatenated_string] = STATE(621),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_PLUS] = ACTIONS(2474),
    [anon_sym_DASH] = ACTIONS(2474),
    [anon_sym_TILDE] = ACTIONS(2474),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(1233),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(2480),
    [sym_integer] = ACTIONS(1235),
    [sym_float] = ACTIONS(1235),
    [sym_identifier] = ACTIONS(1235),
    [sym_true] = ACTIONS(1235),
    [sym_false] = ACTIONS(1235),
    [sym_none] = ACTIONS(1235),
    [sym_comment] = ACTIONS(72),
  },
  [1498] = {
    [sym__primary_expression] = STATE(1713),
    [sym_binary_operator] = STATE(1713),
    [sym_unary_operator] = STATE(1713),
    [sym_attribute] = STATE(1713),
    [sym_subscript] = STATE(1713),
    [sym_call] = STATE(1713),
    [sym_list] = STATE(1713),
    [sym_list_comprehension] = STATE(1713),
    [sym_dictionary] = STATE(1713),
    [sym_dictionary_comprehension] = STATE(1713),
    [sym_set] = STATE(1713),
    [sym_set_comprehension] = STATE(1713),
    [sym_parenthesized_expression] = STATE(1713),
    [sym_tuple] = STATE(1713),
    [sym_generator_expression] = STATE(1713),
    [sym_concatenated_string] = STATE(1713),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_PLUS] = ACTIONS(2474),
    [anon_sym_DASH] = ACTIONS(2474),
    [anon_sym_TILDE] = ACTIONS(2474),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(3837),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(2480),
    [sym_integer] = ACTIONS(3839),
    [sym_float] = ACTIONS(3839),
    [sym_identifier] = ACTIONS(3839),
    [sym_true] = ACTIONS(3839),
    [sym_false] = ACTIONS(3839),
    [sym_none] = ACTIONS(3839),
    [sym_comment] = ACTIONS(72),
  },
  [1499] = {
    [sym__primary_expression] = STATE(1714),
    [sym_binary_operator] = STATE(1714),
    [sym_unary_operator] = STATE(1714),
    [sym_attribute] = STATE(1714),
    [sym_subscript] = STATE(1714),
    [sym_call] = STATE(1714),
    [sym_list] = STATE(1714),
    [sym_list_comprehension] = STATE(1714),
    [sym_dictionary] = STATE(1714),
    [sym_dictionary_comprehension] = STATE(1714),
    [sym_set] = STATE(1714),
    [sym_set_comprehension] = STATE(1714),
    [sym_parenthesized_expression] = STATE(1714),
    [sym_tuple] = STATE(1714),
    [sym_generator_expression] = STATE(1714),
    [sym_concatenated_string] = STATE(1714),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_PLUS] = ACTIONS(2474),
    [anon_sym_DASH] = ACTIONS(2474),
    [anon_sym_TILDE] = ACTIONS(2474),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(3841),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(2480),
    [sym_integer] = ACTIONS(3843),
    [sym_float] = ACTIONS(3843),
    [sym_identifier] = ACTIONS(3843),
    [sym_true] = ACTIONS(3843),
    [sym_false] = ACTIONS(3843),
    [sym_none] = ACTIONS(3843),
    [sym_comment] = ACTIONS(72),
  },
  [1500] = {
    [sym__primary_expression] = STATE(1715),
    [sym_binary_operator] = STATE(1715),
    [sym_unary_operator] = STATE(1715),
    [sym_attribute] = STATE(1715),
    [sym_subscript] = STATE(1715),
    [sym_call] = STATE(1715),
    [sym_list] = STATE(1715),
    [sym_list_comprehension] = STATE(1715),
    [sym_dictionary] = STATE(1715),
    [sym_dictionary_comprehension] = STATE(1715),
    [sym_set] = STATE(1715),
    [sym_set_comprehension] = STATE(1715),
    [sym_parenthesized_expression] = STATE(1715),
    [sym_tuple] = STATE(1715),
    [sym_generator_expression] = STATE(1715),
    [sym_concatenated_string] = STATE(1715),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_PLUS] = ACTIONS(2474),
    [anon_sym_DASH] = ACTIONS(2474),
    [anon_sym_TILDE] = ACTIONS(2474),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(3845),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(2480),
    [sym_integer] = ACTIONS(3847),
    [sym_float] = ACTIONS(3847),
    [sym_identifier] = ACTIONS(3847),
    [sym_true] = ACTIONS(3847),
    [sym_false] = ACTIONS(3847),
    [sym_none] = ACTIONS(3847),
    [sym_comment] = ACTIONS(72),
  },
  [1501] = {
    [sym__primary_expression] = STATE(1710),
    [sym_binary_operator] = STATE(1710),
    [sym_unary_operator] = STATE(1710),
    [sym_attribute] = STATE(1710),
    [sym_subscript] = STATE(1710),
    [sym_call] = STATE(1710),
    [sym_list] = STATE(1710),
    [sym_list_comprehension] = STATE(1710),
    [sym_dictionary] = STATE(1710),
    [sym_dictionary_comprehension] = STATE(1710),
    [sym_set] = STATE(1710),
    [sym_set_comprehension] = STATE(1710),
    [sym_parenthesized_expression] = STATE(1710),
    [sym_tuple] = STATE(1710),
    [sym_generator_expression] = STATE(1710),
    [sym_concatenated_string] = STATE(1710),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_not] = ACTIONS(3849),
    [anon_sym_PLUS] = ACTIONS(2474),
    [anon_sym_DASH] = ACTIONS(2474),
    [anon_sym_TILDE] = ACTIONS(2474),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(3827),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(2480),
    [sym_integer] = ACTIONS(3829),
    [sym_float] = ACTIONS(3829),
    [sym_identifier] = ACTIONS(3829),
    [sym_true] = ACTIONS(3829),
    [sym_false] = ACTIONS(3829),
    [sym_none] = ACTIONS(3829),
    [sym_comment] = ACTIONS(72),
  },
  [1502] = {
    [aux_sym_comparison_operator_repeat1] = STATE(1716),
    [anon_sym_RPAREN] = ACTIONS(998),
    [anon_sym_COMMA] = ACTIONS(998),
    [anon_sym_if] = ACTIONS(998),
    [anon_sym_COLON] = ACTIONS(998),
    [anon_sym_in] = ACTIONS(3253),
    [anon_sym_not] = ACTIONS(3257),
    [anon_sym_and] = ACTIONS(998),
    [anon_sym_or] = ACTIONS(998),
    [anon_sym_LT] = ACTIONS(3269),
    [anon_sym_LT_EQ] = ACTIONS(3253),
    [anon_sym_EQ_EQ] = ACTIONS(3253),
    [anon_sym_BANG_EQ] = ACTIONS(3253),
    [anon_sym_GT_EQ] = ACTIONS(3253),
    [anon_sym_GT] = ACTIONS(3269),
    [anon_sym_LT_GT] = ACTIONS(3253),
    [anon_sym_is] = ACTIONS(3271),
    [sym_comment] = ACTIONS(72),
  },
  [1503] = {
    [anon_sym_RPAREN] = ACTIONS(2553),
    [anon_sym_COMMA] = ACTIONS(2553),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_EQ] = ACTIONS(2490),
    [sym_comment] = ACTIONS(72),
  },
  [1504] = {
    [anon_sym_RPAREN] = ACTIONS(2555),
    [anon_sym_COMMA] = ACTIONS(2555),
    [anon_sym_COLON] = ACTIONS(2494),
    [anon_sym_EQ] = ACTIONS(2496),
    [sym_comment] = ACTIONS(72),
  },
  [1505] = {
    [anon_sym_RPAREN] = ACTIONS(2555),
    [anon_sym_COMMA] = ACTIONS(2555),
    [anon_sym_COLON] = ACTIONS(2500),
    [sym_comment] = ACTIONS(72),
  },
  [1506] = {
    [anon_sym_EQ] = ACTIONS(3851),
    [sym_comment] = ACTIONS(72),
  },
  [1507] = {
    [anon_sym_RPAREN] = ACTIONS(2593),
    [anon_sym_COMMA] = ACTIONS(2593),
    [anon_sym_if] = ACTIONS(1147),
    [anon_sym_and] = ACTIONS(1149),
    [anon_sym_or] = ACTIONS(1151),
    [sym_comment] = ACTIONS(72),
  },
  [1508] = {
    [sym_default_parameter] = STATE(822),
    [sym_typed_default_parameter] = STATE(822),
    [sym_list_splat] = STATE(1505),
    [sym_dictionary_splat] = STATE(1505),
    [sym_typed_parameter] = STATE(822),
    [sym_tuple] = STATE(822),
    [anon_sym_LPAREN] = ACTIONS(222),
    [anon_sym_RPAREN] = ACTIONS(2595),
    [anon_sym_STAR] = ACTIONS(1564),
    [anon_sym_print] = ACTIONS(3273),
    [anon_sym_exec] = ACTIONS(3273),
    [sym_identifier] = ACTIONS(3275),
    [sym_comment] = ACTIONS(72),
  },
  [1509] = {
    [aux_sym__parameters_repeat1] = STATE(1509),
    [anon_sym_RPAREN] = ACTIONS(2555),
    [anon_sym_COMMA] = ACTIONS(3853),
    [sym_comment] = ACTIONS(72),
  },
  [1510] = {
    [sym__expression] = STATE(1719),
    [sym__primary_expression] = STATE(1516),
    [sym_not_operator] = STATE(1719),
    [sym_boolean_operator] = STATE(1719),
    [sym_binary_operator] = STATE(1516),
    [sym_unary_operator] = STATE(1516),
    [sym_comparison_operator] = STATE(1719),
    [sym_lambda] = STATE(1719),
    [sym_attribute] = STATE(1516),
    [sym_subscript] = STATE(1516),
    [sym_call] = STATE(1516),
    [sym_list] = STATE(1516),
    [sym_list_comprehension] = STATE(1516),
    [sym_dictionary] = STATE(1516),
    [sym_dictionary_comprehension] = STATE(1516),
    [sym_set] = STATE(1516),
    [sym_set_comprehension] = STATE(1516),
    [sym_parenthesized_expression] = STATE(1516),
    [sym_tuple] = STATE(1516),
    [sym_generator_expression] = STATE(1516),
    [sym_conditional_expression] = STATE(1719),
    [sym_concatenated_string] = STATE(1516),
    [sym_await] = STATE(1719),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_not] = ACTIONS(3279),
    [anon_sym_PLUS] = ACTIONS(3281),
    [anon_sym_DASH] = ACTIONS(3281),
    [anon_sym_TILDE] = ACTIONS(3281),
    [anon_sym_lambda] = ACTIONS(3283),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(3285),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(3287),
    [sym_integer] = ACTIONS(3289),
    [sym_float] = ACTIONS(3289),
    [sym_identifier] = ACTIONS(3289),
    [sym_true] = ACTIONS(3289),
    [sym_false] = ACTIONS(3289),
    [sym_none] = ACTIONS(3289),
    [anon_sym_await] = ACTIONS(3291),
    [sym_comment] = ACTIONS(72),
  },
  [1511] = {
    [sym__primary_expression] = STATE(204),
    [sym_binary_operator] = STATE(204),
    [sym_unary_operator] = STATE(204),
    [sym_attribute] = STATE(204),
    [sym_subscript] = STATE(204),
    [sym_call] = STATE(204),
    [sym_list] = STATE(204),
    [sym_list_comprehension] = STATE(204),
    [sym_dictionary] = STATE(204),
    [sym_dictionary_comprehension] = STATE(204),
    [sym_set] = STATE(204),
    [sym_set_comprehension] = STATE(204),
    [sym_parenthesized_expression] = STATE(204),
    [sym_tuple] = STATE(204),
    [sym_generator_expression] = STATE(204),
    [sym_concatenated_string] = STATE(204),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_PLUS] = ACTIONS(3281),
    [anon_sym_DASH] = ACTIONS(3281),
    [anon_sym_TILDE] = ACTIONS(3281),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(376),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(3287),
    [sym_integer] = ACTIONS(378),
    [sym_float] = ACTIONS(378),
    [sym_identifier] = ACTIONS(378),
    [sym_true] = ACTIONS(378),
    [sym_false] = ACTIONS(378),
    [sym_none] = ACTIONS(378),
    [sym_comment] = ACTIONS(72),
  },
  [1512] = {
    [sym_lambda_parameters] = STATE(1721),
    [sym__parameters] = STATE(130),
    [sym_default_parameter] = STATE(131),
    [sym_typed_default_parameter] = STATE(131),
    [sym_list_splat] = STATE(132),
    [sym_dictionary_splat] = STATE(132),
    [sym_typed_parameter] = STATE(131),
    [sym_tuple] = STATE(131),
    [anon_sym_LPAREN] = ACTIONS(222),
    [anon_sym_STAR] = ACTIONS(224),
    [anon_sym_print] = ACTIONS(226),
    [anon_sym_COLON] = ACTIONS(3856),
    [anon_sym_exec] = ACTIONS(226),
    [sym_identifier] = ACTIONS(230),
    [sym_comment] = ACTIONS(72),
  },
  [1513] = {
    [aux_sym_concatenated_string_repeat1] = STATE(1722),
    [anon_sym_DOT] = ACTIONS(276),
    [anon_sym_LPAREN] = ACTIONS(276),
    [anon_sym_RPAREN] = ACTIONS(276),
    [anon_sym_COMMA] = ACTIONS(276),
    [anon_sym_STAR] = ACTIONS(278),
    [anon_sym_GT_GT] = ACTIONS(276),
    [anon_sym_if] = ACTIONS(276),
    [anon_sym_in] = ACTIONS(276),
    [anon_sym_EQ] = ACTIONS(278),
    [anon_sym_AT] = ACTIONS(276),
    [anon_sym_not] = ACTIONS(276),
    [anon_sym_and] = ACTIONS(276),
    [anon_sym_or] = ACTIONS(276),
    [anon_sym_PLUS] = ACTIONS(276),
    [anon_sym_DASH] = ACTIONS(276),
    [anon_sym_SLASH] = ACTIONS(278),
    [anon_sym_PERCENT] = ACTIONS(276),
    [anon_sym_SLASH_SLASH] = ACTIONS(276),
    [anon_sym_STAR_STAR] = ACTIONS(276),
    [anon_sym_PIPE] = ACTIONS(276),
    [anon_sym_AMP] = ACTIONS(276),
    [anon_sym_CARET] = ACTIONS(276),
    [anon_sym_LT_LT] = ACTIONS(276),
    [anon_sym_LT] = ACTIONS(278),
    [anon_sym_LT_EQ] = ACTIONS(276),
    [anon_sym_EQ_EQ] = ACTIONS(276),
    [anon_sym_BANG_EQ] = ACTIONS(276),
    [anon_sym_GT_EQ] = ACTIONS(276),
    [anon_sym_GT] = ACTIONS(278),
    [anon_sym_LT_GT] = ACTIONS(276),
    [anon_sym_is] = ACTIONS(276),
    [anon_sym_LBRACK] = ACTIONS(276),
    [sym_string] = ACTIONS(3858),
    [sym_comment] = ACTIONS(72),
  },
  [1514] = {
    [sym__expression] = STATE(227),
    [sym__primary_expression] = STATE(1516),
    [sym_not_operator] = STATE(227),
    [sym_boolean_operator] = STATE(227),
    [sym_binary_operator] = STATE(1516),
    [sym_unary_operator] = STATE(1516),
    [sym_comparison_operator] = STATE(227),
    [sym_lambda] = STATE(227),
    [sym_attribute] = STATE(1516),
    [sym_subscript] = STATE(1516),
    [sym_call] = STATE(1516),
    [sym_list] = STATE(1516),
    [sym_list_comprehension] = STATE(1516),
    [sym_dictionary] = STATE(1516),
    [sym_dictionary_comprehension] = STATE(1516),
    [sym_set] = STATE(1516),
    [sym_set_comprehension] = STATE(1516),
    [sym_parenthesized_expression] = STATE(1516),
    [sym_tuple] = STATE(1516),
    [sym_generator_expression] = STATE(1516),
    [sym_conditional_expression] = STATE(227),
    [sym_concatenated_string] = STATE(1516),
    [sym_await] = STATE(227),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_not] = ACTIONS(3279),
    [anon_sym_PLUS] = ACTIONS(3281),
    [anon_sym_DASH] = ACTIONS(3281),
    [anon_sym_TILDE] = ACTIONS(3281),
    [anon_sym_lambda] = ACTIONS(3283),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(3285),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(3287),
    [sym_integer] = ACTIONS(3289),
    [sym_float] = ACTIONS(3289),
    [sym_identifier] = ACTIONS(3289),
    [sym_true] = ACTIONS(3289),
    [sym_false] = ACTIONS(3289),
    [sym_none] = ACTIONS(3289),
    [anon_sym_await] = ACTIONS(3291),
    [sym_comment] = ACTIONS(72),
  },
  [1515] = {
    [anon_sym_RPAREN] = ACTIONS(1873),
    [anon_sym_COMMA] = ACTIONS(1873),
    [anon_sym_if] = ACTIONS(3860),
    [anon_sym_EQ] = ACTIONS(1873),
    [anon_sym_and] = ACTIONS(3862),
    [anon_sym_or] = ACTIONS(3864),
    [sym_comment] = ACTIONS(72),
  },
  [1516] = {
    [sym_argument_list] = STATE(251),
    [sym_generator_expression] = STATE(251),
    [aux_sym_comparison_operator_repeat1] = STATE(1736),
    [anon_sym_DOT] = ACTIONS(422),
    [anon_sym_LPAREN] = ACTIONS(424),
    [anon_sym_RPAREN] = ACTIONS(302),
    [anon_sym_COMMA] = ACTIONS(302),
    [anon_sym_STAR] = ACTIONS(3866),
    [anon_sym_GT_GT] = ACTIONS(3868),
    [anon_sym_if] = ACTIONS(302),
    [anon_sym_in] = ACTIONS(3870),
    [anon_sym_EQ] = ACTIONS(314),
    [anon_sym_AT] = ACTIONS(3872),
    [anon_sym_not] = ACTIONS(3874),
    [anon_sym_and] = ACTIONS(302),
    [anon_sym_or] = ACTIONS(302),
    [anon_sym_PLUS] = ACTIONS(3876),
    [anon_sym_DASH] = ACTIONS(3876),
    [anon_sym_SLASH] = ACTIONS(3866),
    [anon_sym_PERCENT] = ACTIONS(3872),
    [anon_sym_SLASH_SLASH] = ACTIONS(3872),
    [anon_sym_STAR_STAR] = ACTIONS(3878),
    [anon_sym_PIPE] = ACTIONS(3880),
    [anon_sym_AMP] = ACTIONS(3882),
    [anon_sym_CARET] = ACTIONS(3884),
    [anon_sym_LT_LT] = ACTIONS(3868),
    [anon_sym_LT] = ACTIONS(3886),
    [anon_sym_LT_EQ] = ACTIONS(3870),
    [anon_sym_EQ_EQ] = ACTIONS(3870),
    [anon_sym_BANG_EQ] = ACTIONS(3870),
    [anon_sym_GT_EQ] = ACTIONS(3870),
    [anon_sym_GT] = ACTIONS(3886),
    [anon_sym_LT_GT] = ACTIONS(3870),
    [anon_sym_is] = ACTIONS(3888),
    [anon_sym_LBRACK] = ACTIONS(450),
    [sym_comment] = ACTIONS(72),
  },
  [1517] = {
    [anon_sym_RPAREN] = ACTIONS(2634),
    [anon_sym_COMMA] = ACTIONS(2634),
    [anon_sym_EQ] = ACTIONS(3890),
    [sym_comment] = ACTIONS(72),
  },
  [1518] = {
    [anon_sym_RPAREN] = ACTIONS(2638),
    [anon_sym_COMMA] = ACTIONS(2638),
    [anon_sym_if] = ACTIONS(1147),
    [anon_sym_and] = ACTIONS(1149),
    [anon_sym_or] = ACTIONS(1151),
    [sym_comment] = ACTIONS(72),
  },
  [1519] = {
    [sym_default_parameter] = STATE(822),
    [sym_typed_default_parameter] = STATE(822),
    [sym_list_splat] = STATE(1505),
    [sym_dictionary_splat] = STATE(1505),
    [sym_typed_parameter] = STATE(822),
    [sym_tuple] = STATE(822),
    [anon_sym_LPAREN] = ACTIONS(222),
    [anon_sym_RPAREN] = ACTIONS(2640),
    [anon_sym_STAR] = ACTIONS(1564),
    [anon_sym_print] = ACTIONS(3273),
    [anon_sym_exec] = ACTIONS(3273),
    [sym_identifier] = ACTIONS(3275),
    [sym_comment] = ACTIONS(72),
  },
  [1520] = {
    [anon_sym_RPAREN] = ACTIONS(1873),
    [anon_sym_COMMA] = ACTIONS(1873),
    [anon_sym_if] = ACTIONS(1147),
    [anon_sym_and] = ACTIONS(1149),
    [anon_sym_or] = ACTIONS(1151),
    [sym_comment] = ACTIONS(72),
  },
  [1521] = {
    [sym__simple_statements] = STATE(1738),
    [sym_import_statement] = STATE(10),
    [sym_import_from_statement] = STATE(10),
    [sym_print_statement] = STATE(10),
    [sym_assert_statement] = STATE(10),
    [sym_expression_statement] = STATE(10),
    [sym_return_statement] = STATE(10),
    [sym_delete_statement] = STATE(10),
    [sym_raise_statement] = STATE(10),
    [sym_global_statement] = STATE(10),
    [sym_nonlocal_statement] = STATE(10),
    [sym_exec_statement] = STATE(10),
    [sym__suite] = STATE(1738),
    [sym_expression_list] = STATE(32),
    [sym__expression] = STATE(33),
    [sym__primary_expression] = STATE(34),
    [sym_not_operator] = STATE(33),
    [sym_boolean_operator] = STATE(33),
    [sym_binary_operator] = STATE(34),
    [sym_unary_operator] = STATE(34),
    [sym_comparison_operator] = STATE(33),
    [sym_lambda] = STATE(33),
    [sym_assignment] = STATE(35),
    [sym_augmented_assignment] = STATE(35),
    [sym_yield] = STATE(35),
    [sym_attribute] = STATE(34),
    [sym_subscript] = STATE(34),
    [sym_call] = STATE(34),
    [sym_list] = STATE(34),
    [sym_list_comprehension] = STATE(34),
    [sym_dictionary] = STATE(34),
    [sym_dictionary_comprehension] = STATE(34),
    [sym_set] = STATE(34),
    [sym_set_comprehension] = STATE(34),
    [sym_parenthesized_expression] = STATE(34),
    [sym_tuple] = STATE(34),
    [sym_generator_expression] = STATE(34),
    [sym_conditional_expression] = STATE(33),
    [sym_concatenated_string] = STATE(34),
    [sym_await] = STATE(33),
    [sym__indent] = ACTIONS(1528),
    [anon_sym_import] = ACTIONS(10),
    [anon_sym_from] = ACTIONS(12),
    [anon_sym_LPAREN] = ACTIONS(14),
    [anon_sym_print] = ACTIONS(16),
    [anon_sym_assert] = ACTIONS(18),
    [anon_sym_return] = ACTIONS(20),
    [anon_sym_del] = ACTIONS(22),
    [anon_sym_raise] = ACTIONS(24),
    [sym_pass_statement] = ACTIONS(26),
    [sym_break_statement] = ACTIONS(26),
    [sym_continue_statement] = ACTIONS(26),
    [anon_sym_global] = ACTIONS(42),
    [anon_sym_nonlocal] = ACTIONS(44),
    [anon_sym_exec] = ACTIONS(46),
    [anon_sym_not] = ACTIONS(52),
    [anon_sym_PLUS] = ACTIONS(54),
    [anon_sym_DASH] = ACTIONS(54),
    [anon_sym_TILDE] = ACTIONS(54),
    [anon_sym_lambda] = ACTIONS(56),
    [anon_sym_yield] = ACTIONS(58),
    [anon_sym_LBRACK] = ACTIONS(60),
    [sym_ellipsis] = ACTIONS(62),
    [anon_sym_LBRACE] = ACTIONS(64),
    [sym_string] = ACTIONS(66),
    [sym_integer] = ACTIONS(68),
    [sym_float] = ACTIONS(68),
    [sym_identifier] = ACTIONS(68),
    [sym_true] = ACTIONS(68),
    [sym_false] = ACTIONS(68),
    [sym_none] = ACTIONS(68),
    [anon_sym_await] = ACTIONS(70),
    [sym_comment] = ACTIONS(72),
  },
  [1522] = {
    [anon_sym_COMMA] = ACTIONS(2642),
    [anon_sym_if] = ACTIONS(1592),
    [anon_sym_COLON] = ACTIONS(2642),
    [anon_sym_and] = ACTIONS(1594),
    [anon_sym_or] = ACTIONS(1596),
    [sym_comment] = ACTIONS(72),
  },
  [1523] = {
    [sym__expression] = STATE(1739),
    [sym__primary_expression] = STATE(410),
    [sym_not_operator] = STATE(1739),
    [sym_boolean_operator] = STATE(1739),
    [sym_binary_operator] = STATE(410),
    [sym_unary_operator] = STATE(410),
    [sym_comparison_operator] = STATE(1739),
    [sym_lambda] = STATE(1739),
    [sym_attribute] = STATE(410),
    [sym_subscript] = STATE(410),
    [sym_call] = STATE(410),
    [sym_list] = STATE(410),
    [sym_list_comprehension] = STATE(410),
    [sym_dictionary] = STATE(410),
    [sym_dictionary_comprehension] = STATE(410),
    [sym_set] = STATE(410),
    [sym_set_comprehension] = STATE(410),
    [sym_parenthesized_expression] = STATE(410),
    [sym_tuple] = STATE(410),
    [sym_generator_expression] = STATE(410),
    [sym_conditional_expression] = STATE(1739),
    [sym_concatenated_string] = STATE(410),
    [sym_await] = STATE(1739),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_not] = ACTIONS(726),
    [anon_sym_PLUS] = ACTIONS(728),
    [anon_sym_DASH] = ACTIONS(728),
    [anon_sym_TILDE] = ACTIONS(728),
    [anon_sym_lambda] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(732),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(734),
    [sym_integer] = ACTIONS(736),
    [sym_float] = ACTIONS(736),
    [sym_identifier] = ACTIONS(736),
    [sym_true] = ACTIONS(736),
    [sym_false] = ACTIONS(736),
    [sym_none] = ACTIONS(736),
    [anon_sym_await] = ACTIONS(738),
    [sym_comment] = ACTIONS(72),
  },
  [1524] = {
    [sym_argument_list] = STATE(251),
    [sym_generator_expression] = STATE(251),
    [anon_sym_DOT] = ACTIONS(422),
    [anon_sym_LPAREN] = ACTIONS(424),
    [anon_sym_COMMA] = ACTIONS(2953),
    [anon_sym_STAR] = ACTIONS(1598),
    [anon_sym_GT_GT] = ACTIONS(1600),
    [anon_sym_if] = ACTIONS(2953),
    [anon_sym_COLON] = ACTIONS(2953),
    [anon_sym_in] = ACTIONS(2953),
    [anon_sym_AT] = ACTIONS(1604),
    [anon_sym_not] = ACTIONS(2953),
    [anon_sym_and] = ACTIONS(2953),
    [anon_sym_or] = ACTIONS(2953),
    [anon_sym_PLUS] = ACTIONS(1608),
    [anon_sym_DASH] = ACTIONS(1608),
    [anon_sym_SLASH] = ACTIONS(1598),
    [anon_sym_PERCENT] = ACTIONS(1604),
    [anon_sym_SLASH_SLASH] = ACTIONS(1604),
    [anon_sym_STAR_STAR] = ACTIONS(1610),
    [anon_sym_PIPE] = ACTIONS(1612),
    [anon_sym_AMP] = ACTIONS(1614),
    [anon_sym_CARET] = ACTIONS(1616),
    [anon_sym_LT_LT] = ACTIONS(1600),
    [anon_sym_LT] = ACTIONS(2955),
    [anon_sym_LT_EQ] = ACTIONS(2953),
    [anon_sym_EQ_EQ] = ACTIONS(2953),
    [anon_sym_BANG_EQ] = ACTIONS(2953),
    [anon_sym_GT_EQ] = ACTIONS(2953),
    [anon_sym_GT] = ACTIONS(2955),
    [anon_sym_LT_GT] = ACTIONS(2953),
    [anon_sym_is] = ACTIONS(2953),
    [anon_sym_LBRACK] = ACTIONS(450),
    [sym_comment] = ACTIONS(72),
  },
  [1525] = {
    [anon_sym_if] = ACTIONS(2561),
    [anon_sym_EQ] = ACTIONS(1644),
    [anon_sym_and] = ACTIONS(2563),
    [anon_sym_or] = ACTIONS(2565),
    [sym_comment] = ACTIONS(72),
  },
  [1526] = {
    [sym__expression] = STATE(1740),
    [sym__primary_expression] = STATE(830),
    [sym_not_operator] = STATE(1740),
    [sym_boolean_operator] = STATE(1740),
    [sym_binary_operator] = STATE(830),
    [sym_unary_operator] = STATE(830),
    [sym_comparison_operator] = STATE(1740),
    [sym_lambda] = STATE(1740),
    [sym_attribute] = STATE(830),
    [sym_subscript] = STATE(830),
    [sym_call] = STATE(830),
    [sym_list] = STATE(830),
    [sym_list_comprehension] = STATE(830),
    [sym_dictionary] = STATE(830),
    [sym_dictionary_comprehension] = STATE(830),
    [sym_set] = STATE(830),
    [sym_set_comprehension] = STATE(830),
    [sym_parenthesized_expression] = STATE(830),
    [sym_tuple] = STATE(830),
    [sym_generator_expression] = STATE(830),
    [sym_conditional_expression] = STATE(1740),
    [sym_concatenated_string] = STATE(830),
    [sym_await] = STATE(1740),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_not] = ACTIONS(1628),
    [anon_sym_PLUS] = ACTIONS(1630),
    [anon_sym_DASH] = ACTIONS(1630),
    [anon_sym_TILDE] = ACTIONS(1630),
    [anon_sym_lambda] = ACTIONS(1632),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(1634),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(1636),
    [sym_integer] = ACTIONS(1638),
    [sym_float] = ACTIONS(1638),
    [sym_identifier] = ACTIONS(1638),
    [sym_true] = ACTIONS(1638),
    [sym_false] = ACTIONS(1638),
    [sym_none] = ACTIONS(1638),
    [anon_sym_await] = ACTIONS(1640),
    [sym_comment] = ACTIONS(72),
  },
  [1527] = {
    [aux_sym_concatenated_string_repeat1] = STATE(1527),
    [anon_sym_DOT] = ACTIONS(1862),
    [anon_sym_LPAREN] = ACTIONS(1862),
    [anon_sym_STAR] = ACTIONS(1864),
    [anon_sym_GT_GT] = ACTIONS(1862),
    [anon_sym_if] = ACTIONS(1862),
    [anon_sym_in] = ACTIONS(1862),
    [anon_sym_EQ] = ACTIONS(1864),
    [anon_sym_AT] = ACTIONS(1862),
    [anon_sym_not] = ACTIONS(1862),
    [anon_sym_and] = ACTIONS(1862),
    [anon_sym_or] = ACTIONS(1862),
    [anon_sym_PLUS] = ACTIONS(1862),
    [anon_sym_DASH] = ACTIONS(1862),
    [anon_sym_SLASH] = ACTIONS(1864),
    [anon_sym_PERCENT] = ACTIONS(1862),
    [anon_sym_SLASH_SLASH] = ACTIONS(1862),
    [anon_sym_STAR_STAR] = ACTIONS(1862),
    [anon_sym_PIPE] = ACTIONS(1862),
    [anon_sym_AMP] = ACTIONS(1862),
    [anon_sym_CARET] = ACTIONS(1862),
    [anon_sym_LT_LT] = ACTIONS(1862),
    [anon_sym_LT] = ACTIONS(1864),
    [anon_sym_LT_EQ] = ACTIONS(1862),
    [anon_sym_EQ_EQ] = ACTIONS(1862),
    [anon_sym_BANG_EQ] = ACTIONS(1862),
    [anon_sym_GT_EQ] = ACTIONS(1862),
    [anon_sym_GT] = ACTIONS(1864),
    [anon_sym_LT_GT] = ACTIONS(1862),
    [anon_sym_is] = ACTIONS(1862),
    [anon_sym_LBRACK] = ACTIONS(1862),
    [sym_string] = ACTIONS(3892),
    [sym_comment] = ACTIONS(72),
  },
  [1528] = {
    [anon_sym_if] = ACTIONS(1921),
    [anon_sym_else] = ACTIONS(3895),
    [anon_sym_and] = ACTIONS(1925),
    [anon_sym_or] = ACTIONS(1927),
    [sym_comment] = ACTIONS(72),
  },
  [1529] = {
    [anon_sym_if] = ACTIONS(1953),
    [anon_sym_EQ] = ACTIONS(1953),
    [anon_sym_and] = ACTIONS(2563),
    [anon_sym_or] = ACTIONS(1953),
    [sym_comment] = ACTIONS(72),
  },
  [1530] = {
    [sym_argument_list] = STATE(251),
    [sym_generator_expression] = STATE(251),
    [anon_sym_DOT] = ACTIONS(1980),
    [anon_sym_LPAREN] = ACTIONS(424),
    [anon_sym_STAR] = ACTIONS(1982),
    [anon_sym_GT_GT] = ACTIONS(1980),
    [anon_sym_if] = ACTIONS(1980),
    [anon_sym_in] = ACTIONS(1980),
    [anon_sym_EQ] = ACTIONS(1982),
    [anon_sym_AT] = ACTIONS(1980),
    [anon_sym_not] = ACTIONS(1980),
    [anon_sym_and] = ACTIONS(1980),
    [anon_sym_or] = ACTIONS(1980),
    [anon_sym_PLUS] = ACTIONS(1980),
    [anon_sym_DASH] = ACTIONS(1980),
    [anon_sym_SLASH] = ACTIONS(1982),
    [anon_sym_PERCENT] = ACTIONS(1980),
    [anon_sym_SLASH_SLASH] = ACTIONS(1980),
    [anon_sym_STAR_STAR] = ACTIONS(2579),
    [anon_sym_PIPE] = ACTIONS(1980),
    [anon_sym_AMP] = ACTIONS(1980),
    [anon_sym_CARET] = ACTIONS(1980),
    [anon_sym_LT_LT] = ACTIONS(1980),
    [anon_sym_LT] = ACTIONS(1982),
    [anon_sym_LT_EQ] = ACTIONS(1980),
    [anon_sym_EQ_EQ] = ACTIONS(1980),
    [anon_sym_BANG_EQ] = ACTIONS(1980),
    [anon_sym_GT_EQ] = ACTIONS(1980),
    [anon_sym_GT] = ACTIONS(1982),
    [anon_sym_LT_GT] = ACTIONS(1980),
    [anon_sym_is] = ACTIONS(1980),
    [anon_sym_LBRACK] = ACTIONS(1980),
    [sym_comment] = ACTIONS(72),
  },
  [1531] = {
    [sym_argument_list] = STATE(251),
    [sym_generator_expression] = STATE(251),
    [anon_sym_DOT] = ACTIONS(1980),
    [anon_sym_LPAREN] = ACTIONS(424),
    [anon_sym_STAR] = ACTIONS(2567),
    [anon_sym_GT_GT] = ACTIONS(1980),
    [anon_sym_if] = ACTIONS(1980),
    [anon_sym_in] = ACTIONS(1980),
    [anon_sym_EQ] = ACTIONS(1982),
    [anon_sym_AT] = ACTIONS(2573),
    [anon_sym_not] = ACTIONS(1980),
    [anon_sym_and] = ACTIONS(1980),
    [anon_sym_or] = ACTIONS(1980),
    [anon_sym_PLUS] = ACTIONS(2577),
    [anon_sym_DASH] = ACTIONS(2577),
    [anon_sym_SLASH] = ACTIONS(2567),
    [anon_sym_PERCENT] = ACTIONS(2573),
    [anon_sym_SLASH_SLASH] = ACTIONS(2573),
    [anon_sym_STAR_STAR] = ACTIONS(2579),
    [anon_sym_PIPE] = ACTIONS(1980),
    [anon_sym_AMP] = ACTIONS(1980),
    [anon_sym_CARET] = ACTIONS(1980),
    [anon_sym_LT_LT] = ACTIONS(1980),
    [anon_sym_LT] = ACTIONS(1982),
    [anon_sym_LT_EQ] = ACTIONS(1980),
    [anon_sym_EQ_EQ] = ACTIONS(1980),
    [anon_sym_BANG_EQ] = ACTIONS(1980),
    [anon_sym_GT_EQ] = ACTIONS(1980),
    [anon_sym_GT] = ACTIONS(1982),
    [anon_sym_LT_GT] = ACTIONS(1980),
    [anon_sym_is] = ACTIONS(1980),
    [anon_sym_LBRACK] = ACTIONS(1980),
    [sym_comment] = ACTIONS(72),
  },
  [1532] = {
    [sym_argument_list] = STATE(251),
    [sym_generator_expression] = STATE(251),
    [anon_sym_DOT] = ACTIONS(422),
    [anon_sym_LPAREN] = ACTIONS(424),
    [anon_sym_STAR] = ACTIONS(2567),
    [anon_sym_GT_GT] = ACTIONS(2569),
    [anon_sym_if] = ACTIONS(1984),
    [anon_sym_in] = ACTIONS(1984),
    [anon_sym_EQ] = ACTIONS(1986),
    [anon_sym_AT] = ACTIONS(2573),
    [anon_sym_not] = ACTIONS(1984),
    [anon_sym_and] = ACTIONS(1984),
    [anon_sym_or] = ACTIONS(1984),
    [anon_sym_PLUS] = ACTIONS(2577),
    [anon_sym_DASH] = ACTIONS(2577),
    [anon_sym_SLASH] = ACTIONS(2567),
    [anon_sym_PERCENT] = ACTIONS(2573),
    [anon_sym_SLASH_SLASH] = ACTIONS(2573),
    [anon_sym_STAR_STAR] = ACTIONS(2579),
    [anon_sym_PIPE] = ACTIONS(2581),
    [anon_sym_AMP] = ACTIONS(2583),
    [anon_sym_CARET] = ACTIONS(2585),
    [anon_sym_LT_LT] = ACTIONS(2569),
    [anon_sym_LT] = ACTIONS(1986),
    [anon_sym_LT_EQ] = ACTIONS(1984),
    [anon_sym_EQ_EQ] = ACTIONS(1984),
    [anon_sym_BANG_EQ] = ACTIONS(1984),
    [anon_sym_GT_EQ] = ACTIONS(1984),
    [anon_sym_GT] = ACTIONS(1986),
    [anon_sym_LT_GT] = ACTIONS(1984),
    [anon_sym_is] = ACTIONS(1984),
    [anon_sym_LBRACK] = ACTIONS(450),
    [sym_comment] = ACTIONS(72),
  },
  [1533] = {
    [sym__primary_expression] = STATE(1742),
    [sym_binary_operator] = STATE(1742),
    [sym_unary_operator] = STATE(1742),
    [sym_attribute] = STATE(1742),
    [sym_subscript] = STATE(1742),
    [sym_call] = STATE(1742),
    [sym_list] = STATE(1742),
    [sym_list_comprehension] = STATE(1742),
    [sym_dictionary] = STATE(1742),
    [sym_dictionary_comprehension] = STATE(1742),
    [sym_set] = STATE(1742),
    [sym_set_comprehension] = STATE(1742),
    [sym_parenthesized_expression] = STATE(1742),
    [sym_tuple] = STATE(1742),
    [sym_generator_expression] = STATE(1742),
    [sym_concatenated_string] = STATE(1742),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_PLUS] = ACTIONS(1630),
    [anon_sym_DASH] = ACTIONS(1630),
    [anon_sym_TILDE] = ACTIONS(1630),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(3897),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(1636),
    [sym_integer] = ACTIONS(3899),
    [sym_float] = ACTIONS(3899),
    [sym_identifier] = ACTIONS(3899),
    [sym_true] = ACTIONS(3899),
    [sym_false] = ACTIONS(3899),
    [sym_none] = ACTIONS(3899),
    [sym_comment] = ACTIONS(72),
  },
  [1534] = {
    [sym_argument_list] = STATE(251),
    [sym_generator_expression] = STATE(251),
    [anon_sym_DOT] = ACTIONS(1980),
    [anon_sym_LPAREN] = ACTIONS(424),
    [anon_sym_STAR] = ACTIONS(2567),
    [anon_sym_GT_GT] = ACTIONS(1980),
    [anon_sym_if] = ACTIONS(1980),
    [anon_sym_in] = ACTIONS(1980),
    [anon_sym_EQ] = ACTIONS(1982),
    [anon_sym_AT] = ACTIONS(2573),
    [anon_sym_not] = ACTIONS(1980),
    [anon_sym_and] = ACTIONS(1980),
    [anon_sym_or] = ACTIONS(1980),
    [anon_sym_PLUS] = ACTIONS(1980),
    [anon_sym_DASH] = ACTIONS(1980),
    [anon_sym_SLASH] = ACTIONS(2567),
    [anon_sym_PERCENT] = ACTIONS(2573),
    [anon_sym_SLASH_SLASH] = ACTIONS(2573),
    [anon_sym_STAR_STAR] = ACTIONS(2579),
    [anon_sym_PIPE] = ACTIONS(1980),
    [anon_sym_AMP] = ACTIONS(1980),
    [anon_sym_CARET] = ACTIONS(1980),
    [anon_sym_LT_LT] = ACTIONS(1980),
    [anon_sym_LT] = ACTIONS(1982),
    [anon_sym_LT_EQ] = ACTIONS(1980),
    [anon_sym_EQ_EQ] = ACTIONS(1980),
    [anon_sym_BANG_EQ] = ACTIONS(1980),
    [anon_sym_GT_EQ] = ACTIONS(1980),
    [anon_sym_GT] = ACTIONS(1982),
    [anon_sym_LT_GT] = ACTIONS(1980),
    [anon_sym_is] = ACTIONS(1980),
    [anon_sym_LBRACK] = ACTIONS(1980),
    [sym_comment] = ACTIONS(72),
  },
  [1535] = {
    [sym_argument_list] = STATE(251),
    [sym_generator_expression] = STATE(251),
    [anon_sym_DOT] = ACTIONS(1980),
    [anon_sym_LPAREN] = ACTIONS(424),
    [anon_sym_STAR] = ACTIONS(2567),
    [anon_sym_GT_GT] = ACTIONS(2569),
    [anon_sym_if] = ACTIONS(1980),
    [anon_sym_in] = ACTIONS(1980),
    [anon_sym_EQ] = ACTIONS(1982),
    [anon_sym_AT] = ACTIONS(2573),
    [anon_sym_not] = ACTIONS(1980),
    [anon_sym_and] = ACTIONS(1980),
    [anon_sym_or] = ACTIONS(1980),
    [anon_sym_PLUS] = ACTIONS(2577),
    [anon_sym_DASH] = ACTIONS(2577),
    [anon_sym_SLASH] = ACTIONS(2567),
    [anon_sym_PERCENT] = ACTIONS(2573),
    [anon_sym_SLASH_SLASH] = ACTIONS(2573),
    [anon_sym_STAR_STAR] = ACTIONS(2579),
    [anon_sym_PIPE] = ACTIONS(1980),
    [anon_sym_AMP] = ACTIONS(2583),
    [anon_sym_CARET] = ACTIONS(2585),
    [anon_sym_LT_LT] = ACTIONS(2569),
    [anon_sym_LT] = ACTIONS(1982),
    [anon_sym_LT_EQ] = ACTIONS(1980),
    [anon_sym_EQ_EQ] = ACTIONS(1980),
    [anon_sym_BANG_EQ] = ACTIONS(1980),
    [anon_sym_GT_EQ] = ACTIONS(1980),
    [anon_sym_GT] = ACTIONS(1982),
    [anon_sym_LT_GT] = ACTIONS(1980),
    [anon_sym_is] = ACTIONS(1980),
    [anon_sym_LBRACK] = ACTIONS(1980),
    [sym_comment] = ACTIONS(72),
  },
  [1536] = {
    [sym_argument_list] = STATE(251),
    [sym_generator_expression] = STATE(251),
    [anon_sym_DOT] = ACTIONS(1980),
    [anon_sym_LPAREN] = ACTIONS(424),
    [anon_sym_STAR] = ACTIONS(2567),
    [anon_sym_GT_GT] = ACTIONS(2569),
    [anon_sym_if] = ACTIONS(1980),
    [anon_sym_in] = ACTIONS(1980),
    [anon_sym_EQ] = ACTIONS(1982),
    [anon_sym_AT] = ACTIONS(2573),
    [anon_sym_not] = ACTIONS(1980),
    [anon_sym_and] = ACTIONS(1980),
    [anon_sym_or] = ACTIONS(1980),
    [anon_sym_PLUS] = ACTIONS(2577),
    [anon_sym_DASH] = ACTIONS(2577),
    [anon_sym_SLASH] = ACTIONS(2567),
    [anon_sym_PERCENT] = ACTIONS(2573),
    [anon_sym_SLASH_SLASH] = ACTIONS(2573),
    [anon_sym_STAR_STAR] = ACTIONS(2579),
    [anon_sym_PIPE] = ACTIONS(1980),
    [anon_sym_AMP] = ACTIONS(1980),
    [anon_sym_CARET] = ACTIONS(2585),
    [anon_sym_LT_LT] = ACTIONS(2569),
    [anon_sym_LT] = ACTIONS(1982),
    [anon_sym_LT_EQ] = ACTIONS(1980),
    [anon_sym_EQ_EQ] = ACTIONS(1980),
    [anon_sym_BANG_EQ] = ACTIONS(1980),
    [anon_sym_GT_EQ] = ACTIONS(1980),
    [anon_sym_GT] = ACTIONS(1982),
    [anon_sym_LT_GT] = ACTIONS(1980),
    [anon_sym_is] = ACTIONS(1980),
    [anon_sym_LBRACK] = ACTIONS(1980),
    [sym_comment] = ACTIONS(72),
  },
  [1537] = {
    [sym_argument_list] = STATE(251),
    [sym_generator_expression] = STATE(251),
    [anon_sym_DOT] = ACTIONS(1980),
    [anon_sym_LPAREN] = ACTIONS(424),
    [anon_sym_STAR] = ACTIONS(2567),
    [anon_sym_GT_GT] = ACTIONS(2569),
    [anon_sym_if] = ACTIONS(1980),
    [anon_sym_in] = ACTIONS(1980),
    [anon_sym_EQ] = ACTIONS(1982),
    [anon_sym_AT] = ACTIONS(2573),
    [anon_sym_not] = ACTIONS(1980),
    [anon_sym_and] = ACTIONS(1980),
    [anon_sym_or] = ACTIONS(1980),
    [anon_sym_PLUS] = ACTIONS(2577),
    [anon_sym_DASH] = ACTIONS(2577),
    [anon_sym_SLASH] = ACTIONS(2567),
    [anon_sym_PERCENT] = ACTIONS(2573),
    [anon_sym_SLASH_SLASH] = ACTIONS(2573),
    [anon_sym_STAR_STAR] = ACTIONS(2579),
    [anon_sym_PIPE] = ACTIONS(1980),
    [anon_sym_AMP] = ACTIONS(1980),
    [anon_sym_CARET] = ACTIONS(1980),
    [anon_sym_LT_LT] = ACTIONS(2569),
    [anon_sym_LT] = ACTIONS(1982),
    [anon_sym_LT_EQ] = ACTIONS(1980),
    [anon_sym_EQ_EQ] = ACTIONS(1980),
    [anon_sym_BANG_EQ] = ACTIONS(1980),
    [anon_sym_GT_EQ] = ACTIONS(1980),
    [anon_sym_GT] = ACTIONS(1982),
    [anon_sym_LT_GT] = ACTIONS(1980),
    [anon_sym_is] = ACTIONS(1980),
    [anon_sym_LBRACK] = ACTIONS(1980),
    [sym_comment] = ACTIONS(72),
  },
  [1538] = {
    [aux_sym_comparison_operator_repeat1] = STATE(1538),
    [anon_sym_if] = ACTIONS(1984),
    [anon_sym_in] = ACTIONS(3901),
    [anon_sym_EQ] = ACTIONS(1986),
    [anon_sym_not] = ACTIONS(3904),
    [anon_sym_and] = ACTIONS(1984),
    [anon_sym_or] = ACTIONS(1984),
    [anon_sym_LT] = ACTIONS(3907),
    [anon_sym_LT_EQ] = ACTIONS(3901),
    [anon_sym_EQ_EQ] = ACTIONS(3901),
    [anon_sym_BANG_EQ] = ACTIONS(3901),
    [anon_sym_GT_EQ] = ACTIONS(3901),
    [anon_sym_GT] = ACTIONS(3907),
    [anon_sym_LT_GT] = ACTIONS(3901),
    [anon_sym_is] = ACTIONS(3910),
    [sym_comment] = ACTIONS(72),
  },
  [1539] = {
    [anon_sym_COMMA] = ACTIONS(3913),
    [anon_sym_if] = ACTIONS(1592),
    [anon_sym_COLON] = ACTIONS(3913),
    [anon_sym_and] = ACTIONS(1594),
    [anon_sym_or] = ACTIONS(1596),
    [sym_comment] = ACTIONS(72),
  },
  [1540] = {
    [anon_sym_COMMA] = ACTIONS(1644),
    [anon_sym_if] = ACTIONS(2604),
    [anon_sym_COLON] = ACTIONS(1644),
    [anon_sym_EQ] = ACTIONS(1644),
    [anon_sym_and] = ACTIONS(2606),
    [anon_sym_or] = ACTIONS(2608),
    [sym_comment] = ACTIONS(72),
  },
  [1541] = {
    [sym__expression] = STATE(1743),
    [sym__primary_expression] = STATE(841),
    [sym_not_operator] = STATE(1743),
    [sym_boolean_operator] = STATE(1743),
    [sym_binary_operator] = STATE(841),
    [sym_unary_operator] = STATE(841),
    [sym_comparison_operator] = STATE(1743),
    [sym_lambda] = STATE(1743),
    [sym_attribute] = STATE(841),
    [sym_subscript] = STATE(841),
    [sym_call] = STATE(841),
    [sym_list] = STATE(841),
    [sym_list_comprehension] = STATE(841),
    [sym_dictionary] = STATE(841),
    [sym_dictionary_comprehension] = STATE(841),
    [sym_set] = STATE(841),
    [sym_set_comprehension] = STATE(841),
    [sym_parenthesized_expression] = STATE(841),
    [sym_tuple] = STATE(841),
    [sym_generator_expression] = STATE(841),
    [sym_conditional_expression] = STATE(1743),
    [sym_concatenated_string] = STATE(841),
    [sym_await] = STATE(1743),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_not] = ACTIONS(1648),
    [anon_sym_PLUS] = ACTIONS(1650),
    [anon_sym_DASH] = ACTIONS(1650),
    [anon_sym_TILDE] = ACTIONS(1650),
    [anon_sym_lambda] = ACTIONS(1652),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(1654),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(1656),
    [sym_integer] = ACTIONS(1658),
    [sym_float] = ACTIONS(1658),
    [sym_identifier] = ACTIONS(1658),
    [sym_true] = ACTIONS(1658),
    [sym_false] = ACTIONS(1658),
    [sym_none] = ACTIONS(1658),
    [anon_sym_await] = ACTIONS(1660),
    [sym_comment] = ACTIONS(72),
  },
  [1542] = {
    [aux_sym_concatenated_string_repeat1] = STATE(1542),
    [anon_sym_DOT] = ACTIONS(1862),
    [anon_sym_LPAREN] = ACTIONS(1862),
    [anon_sym_COMMA] = ACTIONS(1862),
    [anon_sym_STAR] = ACTIONS(1864),
    [anon_sym_GT_GT] = ACTIONS(1862),
    [anon_sym_if] = ACTIONS(1862),
    [anon_sym_COLON] = ACTIONS(1862),
    [anon_sym_in] = ACTIONS(1862),
    [anon_sym_EQ] = ACTIONS(1864),
    [anon_sym_AT] = ACTIONS(1862),
    [anon_sym_not] = ACTIONS(1862),
    [anon_sym_and] = ACTIONS(1862),
    [anon_sym_or] = ACTIONS(1862),
    [anon_sym_PLUS] = ACTIONS(1862),
    [anon_sym_DASH] = ACTIONS(1862),
    [anon_sym_SLASH] = ACTIONS(1864),
    [anon_sym_PERCENT] = ACTIONS(1862),
    [anon_sym_SLASH_SLASH] = ACTIONS(1862),
    [anon_sym_STAR_STAR] = ACTIONS(1862),
    [anon_sym_PIPE] = ACTIONS(1862),
    [anon_sym_AMP] = ACTIONS(1862),
    [anon_sym_CARET] = ACTIONS(1862),
    [anon_sym_LT_LT] = ACTIONS(1862),
    [anon_sym_LT] = ACTIONS(1864),
    [anon_sym_LT_EQ] = ACTIONS(1862),
    [anon_sym_EQ_EQ] = ACTIONS(1862),
    [anon_sym_BANG_EQ] = ACTIONS(1862),
    [anon_sym_GT_EQ] = ACTIONS(1862),
    [anon_sym_GT] = ACTIONS(1864),
    [anon_sym_LT_GT] = ACTIONS(1862),
    [anon_sym_is] = ACTIONS(1862),
    [anon_sym_LBRACK] = ACTIONS(1862),
    [sym_string] = ACTIONS(3915),
    [sym_comment] = ACTIONS(72),
  },
  [1543] = {
    [anon_sym_if] = ACTIONS(1921),
    [anon_sym_else] = ACTIONS(3918),
    [anon_sym_and] = ACTIONS(1925),
    [anon_sym_or] = ACTIONS(1927),
    [sym_comment] = ACTIONS(72),
  },
  [1544] = {
    [anon_sym_COMMA] = ACTIONS(1953),
    [anon_sym_if] = ACTIONS(1953),
    [anon_sym_COLON] = ACTIONS(1953),
    [anon_sym_EQ] = ACTIONS(1953),
    [anon_sym_and] = ACTIONS(2606),
    [anon_sym_or] = ACTIONS(1953),
    [sym_comment] = ACTIONS(72),
  },
  [1545] = {
    [sym_argument_list] = STATE(251),
    [sym_generator_expression] = STATE(251),
    [anon_sym_DOT] = ACTIONS(1980),
    [anon_sym_LPAREN] = ACTIONS(424),
    [anon_sym_COMMA] = ACTIONS(1980),
    [anon_sym_STAR] = ACTIONS(1982),
    [anon_sym_GT_GT] = ACTIONS(1980),
    [anon_sym_if] = ACTIONS(1980),
    [anon_sym_COLON] = ACTIONS(1980),
    [anon_sym_in] = ACTIONS(1980),
    [anon_sym_EQ] = ACTIONS(1982),
    [anon_sym_AT] = ACTIONS(1980),
    [anon_sym_not] = ACTIONS(1980),
    [anon_sym_and] = ACTIONS(1980),
    [anon_sym_or] = ACTIONS(1980),
    [anon_sym_PLUS] = ACTIONS(1980),
    [anon_sym_DASH] = ACTIONS(1980),
    [anon_sym_SLASH] = ACTIONS(1982),
    [anon_sym_PERCENT] = ACTIONS(1980),
    [anon_sym_SLASH_SLASH] = ACTIONS(1980),
    [anon_sym_STAR_STAR] = ACTIONS(2622),
    [anon_sym_PIPE] = ACTIONS(1980),
    [anon_sym_AMP] = ACTIONS(1980),
    [anon_sym_CARET] = ACTIONS(1980),
    [anon_sym_LT_LT] = ACTIONS(1980),
    [anon_sym_LT] = ACTIONS(1982),
    [anon_sym_LT_EQ] = ACTIONS(1980),
    [anon_sym_EQ_EQ] = ACTIONS(1980),
    [anon_sym_BANG_EQ] = ACTIONS(1980),
    [anon_sym_GT_EQ] = ACTIONS(1980),
    [anon_sym_GT] = ACTIONS(1982),
    [anon_sym_LT_GT] = ACTIONS(1980),
    [anon_sym_is] = ACTIONS(1980),
    [anon_sym_LBRACK] = ACTIONS(1980),
    [sym_comment] = ACTIONS(72),
  },
  [1546] = {
    [sym_argument_list] = STATE(251),
    [sym_generator_expression] = STATE(251),
    [anon_sym_DOT] = ACTIONS(1980),
    [anon_sym_LPAREN] = ACTIONS(424),
    [anon_sym_COMMA] = ACTIONS(1980),
    [anon_sym_STAR] = ACTIONS(2610),
    [anon_sym_GT_GT] = ACTIONS(1980),
    [anon_sym_if] = ACTIONS(1980),
    [anon_sym_COLON] = ACTIONS(1980),
    [anon_sym_in] = ACTIONS(1980),
    [anon_sym_EQ] = ACTIONS(1982),
    [anon_sym_AT] = ACTIONS(2616),
    [anon_sym_not] = ACTIONS(1980),
    [anon_sym_and] = ACTIONS(1980),
    [anon_sym_or] = ACTIONS(1980),
    [anon_sym_PLUS] = ACTIONS(2620),
    [anon_sym_DASH] = ACTIONS(2620),
    [anon_sym_SLASH] = ACTIONS(2610),
    [anon_sym_PERCENT] = ACTIONS(2616),
    [anon_sym_SLASH_SLASH] = ACTIONS(2616),
    [anon_sym_STAR_STAR] = ACTIONS(2622),
    [anon_sym_PIPE] = ACTIONS(1980),
    [anon_sym_AMP] = ACTIONS(1980),
    [anon_sym_CARET] = ACTIONS(1980),
    [anon_sym_LT_LT] = ACTIONS(1980),
    [anon_sym_LT] = ACTIONS(1982),
    [anon_sym_LT_EQ] = ACTIONS(1980),
    [anon_sym_EQ_EQ] = ACTIONS(1980),
    [anon_sym_BANG_EQ] = ACTIONS(1980),
    [anon_sym_GT_EQ] = ACTIONS(1980),
    [anon_sym_GT] = ACTIONS(1982),
    [anon_sym_LT_GT] = ACTIONS(1980),
    [anon_sym_is] = ACTIONS(1980),
    [anon_sym_LBRACK] = ACTIONS(1980),
    [sym_comment] = ACTIONS(72),
  },
  [1547] = {
    [sym_argument_list] = STATE(251),
    [sym_generator_expression] = STATE(251),
    [anon_sym_DOT] = ACTIONS(422),
    [anon_sym_LPAREN] = ACTIONS(424),
    [anon_sym_COMMA] = ACTIONS(1984),
    [anon_sym_STAR] = ACTIONS(2610),
    [anon_sym_GT_GT] = ACTIONS(2612),
    [anon_sym_if] = ACTIONS(1984),
    [anon_sym_COLON] = ACTIONS(1984),
    [anon_sym_in] = ACTIONS(1984),
    [anon_sym_EQ] = ACTIONS(1986),
    [anon_sym_AT] = ACTIONS(2616),
    [anon_sym_not] = ACTIONS(1984),
    [anon_sym_and] = ACTIONS(1984),
    [anon_sym_or] = ACTIONS(1984),
    [anon_sym_PLUS] = ACTIONS(2620),
    [anon_sym_DASH] = ACTIONS(2620),
    [anon_sym_SLASH] = ACTIONS(2610),
    [anon_sym_PERCENT] = ACTIONS(2616),
    [anon_sym_SLASH_SLASH] = ACTIONS(2616),
    [anon_sym_STAR_STAR] = ACTIONS(2622),
    [anon_sym_PIPE] = ACTIONS(2624),
    [anon_sym_AMP] = ACTIONS(2626),
    [anon_sym_CARET] = ACTIONS(2628),
    [anon_sym_LT_LT] = ACTIONS(2612),
    [anon_sym_LT] = ACTIONS(1986),
    [anon_sym_LT_EQ] = ACTIONS(1984),
    [anon_sym_EQ_EQ] = ACTIONS(1984),
    [anon_sym_BANG_EQ] = ACTIONS(1984),
    [anon_sym_GT_EQ] = ACTIONS(1984),
    [anon_sym_GT] = ACTIONS(1986),
    [anon_sym_LT_GT] = ACTIONS(1984),
    [anon_sym_is] = ACTIONS(1984),
    [anon_sym_LBRACK] = ACTIONS(450),
    [sym_comment] = ACTIONS(72),
  },
  [1548] = {
    [sym__primary_expression] = STATE(1745),
    [sym_binary_operator] = STATE(1745),
    [sym_unary_operator] = STATE(1745),
    [sym_attribute] = STATE(1745),
    [sym_subscript] = STATE(1745),
    [sym_call] = STATE(1745),
    [sym_list] = STATE(1745),
    [sym_list_comprehension] = STATE(1745),
    [sym_dictionary] = STATE(1745),
    [sym_dictionary_comprehension] = STATE(1745),
    [sym_set] = STATE(1745),
    [sym_set_comprehension] = STATE(1745),
    [sym_parenthesized_expression] = STATE(1745),
    [sym_tuple] = STATE(1745),
    [sym_generator_expression] = STATE(1745),
    [sym_concatenated_string] = STATE(1745),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_PLUS] = ACTIONS(1650),
    [anon_sym_DASH] = ACTIONS(1650),
    [anon_sym_TILDE] = ACTIONS(1650),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(3920),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(1656),
    [sym_integer] = ACTIONS(3922),
    [sym_float] = ACTIONS(3922),
    [sym_identifier] = ACTIONS(3922),
    [sym_true] = ACTIONS(3922),
    [sym_false] = ACTIONS(3922),
    [sym_none] = ACTIONS(3922),
    [sym_comment] = ACTIONS(72),
  },
  [1549] = {
    [sym_argument_list] = STATE(251),
    [sym_generator_expression] = STATE(251),
    [anon_sym_DOT] = ACTIONS(1980),
    [anon_sym_LPAREN] = ACTIONS(424),
    [anon_sym_COMMA] = ACTIONS(1980),
    [anon_sym_STAR] = ACTIONS(2610),
    [anon_sym_GT_GT] = ACTIONS(1980),
    [anon_sym_if] = ACTIONS(1980),
    [anon_sym_COLON] = ACTIONS(1980),
    [anon_sym_in] = ACTIONS(1980),
    [anon_sym_EQ] = ACTIONS(1982),
    [anon_sym_AT] = ACTIONS(2616),
    [anon_sym_not] = ACTIONS(1980),
    [anon_sym_and] = ACTIONS(1980),
    [anon_sym_or] = ACTIONS(1980),
    [anon_sym_PLUS] = ACTIONS(1980),
    [anon_sym_DASH] = ACTIONS(1980),
    [anon_sym_SLASH] = ACTIONS(2610),
    [anon_sym_PERCENT] = ACTIONS(2616),
    [anon_sym_SLASH_SLASH] = ACTIONS(2616),
    [anon_sym_STAR_STAR] = ACTIONS(2622),
    [anon_sym_PIPE] = ACTIONS(1980),
    [anon_sym_AMP] = ACTIONS(1980),
    [anon_sym_CARET] = ACTIONS(1980),
    [anon_sym_LT_LT] = ACTIONS(1980),
    [anon_sym_LT] = ACTIONS(1982),
    [anon_sym_LT_EQ] = ACTIONS(1980),
    [anon_sym_EQ_EQ] = ACTIONS(1980),
    [anon_sym_BANG_EQ] = ACTIONS(1980),
    [anon_sym_GT_EQ] = ACTIONS(1980),
    [anon_sym_GT] = ACTIONS(1982),
    [anon_sym_LT_GT] = ACTIONS(1980),
    [anon_sym_is] = ACTIONS(1980),
    [anon_sym_LBRACK] = ACTIONS(1980),
    [sym_comment] = ACTIONS(72),
  },
  [1550] = {
    [sym_argument_list] = STATE(251),
    [sym_generator_expression] = STATE(251),
    [anon_sym_DOT] = ACTIONS(1980),
    [anon_sym_LPAREN] = ACTIONS(424),
    [anon_sym_COMMA] = ACTIONS(1980),
    [anon_sym_STAR] = ACTIONS(2610),
    [anon_sym_GT_GT] = ACTIONS(2612),
    [anon_sym_if] = ACTIONS(1980),
    [anon_sym_COLON] = ACTIONS(1980),
    [anon_sym_in] = ACTIONS(1980),
    [anon_sym_EQ] = ACTIONS(1982),
    [anon_sym_AT] = ACTIONS(2616),
    [anon_sym_not] = ACTIONS(1980),
    [anon_sym_and] = ACTIONS(1980),
    [anon_sym_or] = ACTIONS(1980),
    [anon_sym_PLUS] = ACTIONS(2620),
    [anon_sym_DASH] = ACTIONS(2620),
    [anon_sym_SLASH] = ACTIONS(2610),
    [anon_sym_PERCENT] = ACTIONS(2616),
    [anon_sym_SLASH_SLASH] = ACTIONS(2616),
    [anon_sym_STAR_STAR] = ACTIONS(2622),
    [anon_sym_PIPE] = ACTIONS(1980),
    [anon_sym_AMP] = ACTIONS(2626),
    [anon_sym_CARET] = ACTIONS(2628),
    [anon_sym_LT_LT] = ACTIONS(2612),
    [anon_sym_LT] = ACTIONS(1982),
    [anon_sym_LT_EQ] = ACTIONS(1980),
    [anon_sym_EQ_EQ] = ACTIONS(1980),
    [anon_sym_BANG_EQ] = ACTIONS(1980),
    [anon_sym_GT_EQ] = ACTIONS(1980),
    [anon_sym_GT] = ACTIONS(1982),
    [anon_sym_LT_GT] = ACTIONS(1980),
    [anon_sym_is] = ACTIONS(1980),
    [anon_sym_LBRACK] = ACTIONS(1980),
    [sym_comment] = ACTIONS(72),
  },
  [1551] = {
    [sym_argument_list] = STATE(251),
    [sym_generator_expression] = STATE(251),
    [anon_sym_DOT] = ACTIONS(1980),
    [anon_sym_LPAREN] = ACTIONS(424),
    [anon_sym_COMMA] = ACTIONS(1980),
    [anon_sym_STAR] = ACTIONS(2610),
    [anon_sym_GT_GT] = ACTIONS(2612),
    [anon_sym_if] = ACTIONS(1980),
    [anon_sym_COLON] = ACTIONS(1980),
    [anon_sym_in] = ACTIONS(1980),
    [anon_sym_EQ] = ACTIONS(1982),
    [anon_sym_AT] = ACTIONS(2616),
    [anon_sym_not] = ACTIONS(1980),
    [anon_sym_and] = ACTIONS(1980),
    [anon_sym_or] = ACTIONS(1980),
    [anon_sym_PLUS] = ACTIONS(2620),
    [anon_sym_DASH] = ACTIONS(2620),
    [anon_sym_SLASH] = ACTIONS(2610),
    [anon_sym_PERCENT] = ACTIONS(2616),
    [anon_sym_SLASH_SLASH] = ACTIONS(2616),
    [anon_sym_STAR_STAR] = ACTIONS(2622),
    [anon_sym_PIPE] = ACTIONS(1980),
    [anon_sym_AMP] = ACTIONS(1980),
    [anon_sym_CARET] = ACTIONS(2628),
    [anon_sym_LT_LT] = ACTIONS(2612),
    [anon_sym_LT] = ACTIONS(1982),
    [anon_sym_LT_EQ] = ACTIONS(1980),
    [anon_sym_EQ_EQ] = ACTIONS(1980),
    [anon_sym_BANG_EQ] = ACTIONS(1980),
    [anon_sym_GT_EQ] = ACTIONS(1980),
    [anon_sym_GT] = ACTIONS(1982),
    [anon_sym_LT_GT] = ACTIONS(1980),
    [anon_sym_is] = ACTIONS(1980),
    [anon_sym_LBRACK] = ACTIONS(1980),
    [sym_comment] = ACTIONS(72),
  },
  [1552] = {
    [sym_argument_list] = STATE(251),
    [sym_generator_expression] = STATE(251),
    [anon_sym_DOT] = ACTIONS(1980),
    [anon_sym_LPAREN] = ACTIONS(424),
    [anon_sym_COMMA] = ACTIONS(1980),
    [anon_sym_STAR] = ACTIONS(2610),
    [anon_sym_GT_GT] = ACTIONS(2612),
    [anon_sym_if] = ACTIONS(1980),
    [anon_sym_COLON] = ACTIONS(1980),
    [anon_sym_in] = ACTIONS(1980),
    [anon_sym_EQ] = ACTIONS(1982),
    [anon_sym_AT] = ACTIONS(2616),
    [anon_sym_not] = ACTIONS(1980),
    [anon_sym_and] = ACTIONS(1980),
    [anon_sym_or] = ACTIONS(1980),
    [anon_sym_PLUS] = ACTIONS(2620),
    [anon_sym_DASH] = ACTIONS(2620),
    [anon_sym_SLASH] = ACTIONS(2610),
    [anon_sym_PERCENT] = ACTIONS(2616),
    [anon_sym_SLASH_SLASH] = ACTIONS(2616),
    [anon_sym_STAR_STAR] = ACTIONS(2622),
    [anon_sym_PIPE] = ACTIONS(1980),
    [anon_sym_AMP] = ACTIONS(1980),
    [anon_sym_CARET] = ACTIONS(1980),
    [anon_sym_LT_LT] = ACTIONS(2612),
    [anon_sym_LT] = ACTIONS(1982),
    [anon_sym_LT_EQ] = ACTIONS(1980),
    [anon_sym_EQ_EQ] = ACTIONS(1980),
    [anon_sym_BANG_EQ] = ACTIONS(1980),
    [anon_sym_GT_EQ] = ACTIONS(1980),
    [anon_sym_GT] = ACTIONS(1982),
    [anon_sym_LT_GT] = ACTIONS(1980),
    [anon_sym_is] = ACTIONS(1980),
    [anon_sym_LBRACK] = ACTIONS(1980),
    [sym_comment] = ACTIONS(72),
  },
  [1553] = {
    [aux_sym_comparison_operator_repeat1] = STATE(1553),
    [anon_sym_COMMA] = ACTIONS(1984),
    [anon_sym_if] = ACTIONS(1984),
    [anon_sym_COLON] = ACTIONS(1984),
    [anon_sym_in] = ACTIONS(3924),
    [anon_sym_EQ] = ACTIONS(1986),
    [anon_sym_not] = ACTIONS(3927),
    [anon_sym_and] = ACTIONS(1984),
    [anon_sym_or] = ACTIONS(1984),
    [anon_sym_LT] = ACTIONS(3930),
    [anon_sym_LT_EQ] = ACTIONS(3924),
    [anon_sym_EQ_EQ] = ACTIONS(3924),
    [anon_sym_BANG_EQ] = ACTIONS(3924),
    [anon_sym_GT_EQ] = ACTIONS(3924),
    [anon_sym_GT] = ACTIONS(3930),
    [anon_sym_LT_GT] = ACTIONS(3924),
    [anon_sym_is] = ACTIONS(3933),
    [sym_comment] = ACTIONS(72),
  },
  [1554] = {
    [anon_sym_COMMA] = ACTIONS(3936),
    [anon_sym_if] = ACTIONS(1592),
    [anon_sym_COLON] = ACTIONS(3936),
    [anon_sym_and] = ACTIONS(1594),
    [anon_sym_or] = ACTIONS(1596),
    [sym_comment] = ACTIONS(72),
  },
  [1555] = {
    [anon_sym_COMMA] = ACTIONS(2642),
    [anon_sym_if] = ACTIONS(1674),
    [anon_sym_and] = ACTIONS(1676),
    [anon_sym_or] = ACTIONS(1678),
    [anon_sym_RBRACK] = ACTIONS(2642),
    [sym_comment] = ACTIONS(72),
  },
  [1556] = {
    [sym__expression] = STATE(1746),
    [sym__primary_expression] = STATE(430),
    [sym_not_operator] = STATE(1746),
    [sym_boolean_operator] = STATE(1746),
    [sym_binary_operator] = STATE(430),
    [sym_unary_operator] = STATE(430),
    [sym_comparison_operator] = STATE(1746),
    [sym_lambda] = STATE(1746),
    [sym_attribute] = STATE(430),
    [sym_subscript] = STATE(430),
    [sym_call] = STATE(430),
    [sym_list] = STATE(430),
    [sym_list_comprehension] = STATE(430),
    [sym_dictionary] = STATE(430),
    [sym_dictionary_comprehension] = STATE(430),
    [sym_set] = STATE(430),
    [sym_set_comprehension] = STATE(430),
    [sym_parenthesized_expression] = STATE(430),
    [sym_tuple] = STATE(430),
    [sym_generator_expression] = STATE(430),
    [sym_conditional_expression] = STATE(1746),
    [sym_concatenated_string] = STATE(430),
    [sym_await] = STATE(1746),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_not] = ACTIONS(760),
    [anon_sym_PLUS] = ACTIONS(762),
    [anon_sym_DASH] = ACTIONS(762),
    [anon_sym_TILDE] = ACTIONS(762),
    [anon_sym_lambda] = ACTIONS(764),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(766),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(768),
    [sym_integer] = ACTIONS(770),
    [sym_float] = ACTIONS(770),
    [sym_identifier] = ACTIONS(770),
    [sym_true] = ACTIONS(770),
    [sym_false] = ACTIONS(770),
    [sym_none] = ACTIONS(770),
    [anon_sym_await] = ACTIONS(772),
    [sym_comment] = ACTIONS(72),
  },
  [1557] = {
    [sym_argument_list] = STATE(251),
    [sym_generator_expression] = STATE(251),
    [anon_sym_DOT] = ACTIONS(422),
    [anon_sym_LPAREN] = ACTIONS(424),
    [anon_sym_COMMA] = ACTIONS(2953),
    [anon_sym_STAR] = ACTIONS(1680),
    [anon_sym_GT_GT] = ACTIONS(1682),
    [anon_sym_if] = ACTIONS(2953),
    [anon_sym_in] = ACTIONS(2953),
    [anon_sym_AT] = ACTIONS(1686),
    [anon_sym_not] = ACTIONS(2953),
    [anon_sym_and] = ACTIONS(2953),
    [anon_sym_or] = ACTIONS(2953),
    [anon_sym_PLUS] = ACTIONS(1690),
    [anon_sym_DASH] = ACTIONS(1690),
    [anon_sym_SLASH] = ACTIONS(1680),
    [anon_sym_PERCENT] = ACTIONS(1686),
    [anon_sym_SLASH_SLASH] = ACTIONS(1686),
    [anon_sym_STAR_STAR] = ACTIONS(1692),
    [anon_sym_PIPE] = ACTIONS(1694),
    [anon_sym_AMP] = ACTIONS(1696),
    [anon_sym_CARET] = ACTIONS(1698),
    [anon_sym_LT_LT] = ACTIONS(1682),
    [anon_sym_LT] = ACTIONS(2955),
    [anon_sym_LT_EQ] = ACTIONS(2953),
    [anon_sym_EQ_EQ] = ACTIONS(2953),
    [anon_sym_BANG_EQ] = ACTIONS(2953),
    [anon_sym_GT_EQ] = ACTIONS(2953),
    [anon_sym_GT] = ACTIONS(2955),
    [anon_sym_LT_GT] = ACTIONS(2953),
    [anon_sym_is] = ACTIONS(2953),
    [anon_sym_LBRACK] = ACTIONS(450),
    [anon_sym_RBRACK] = ACTIONS(2953),
    [sym_comment] = ACTIONS(72),
  },
  [1558] = {
    [anon_sym_COMMA] = ACTIONS(3610),
    [anon_sym_if] = ACTIONS(784),
    [anon_sym_async] = ACTIONS(3610),
    [anon_sym_for] = ACTIONS(3610),
    [anon_sym_and] = ACTIONS(790),
    [anon_sym_or] = ACTIONS(792),
    [anon_sym_RBRACK] = ACTIONS(3610),
    [sym_comment] = ACTIONS(72),
  },
  [1559] = {
    [sym__expression_within_for_in_clause] = STATE(1747),
    [sym__expression] = STATE(1562),
    [sym__primary_expression] = STATE(145),
    [sym_not_operator] = STATE(1562),
    [sym_boolean_operator] = STATE(1562),
    [sym_binary_operator] = STATE(145),
    [sym_unary_operator] = STATE(145),
    [sym_comparison_operator] = STATE(1562),
    [sym_lambda] = STATE(1562),
    [sym_lambda_within_for_in_clause] = STATE(1406),
    [sym_attribute] = STATE(145),
    [sym_subscript] = STATE(145),
    [sym_call] = STATE(145),
    [sym_list] = STATE(145),
    [sym_list_comprehension] = STATE(145),
    [sym_dictionary] = STATE(145),
    [sym_dictionary_comprehension] = STATE(145),
    [sym_set] = STATE(145),
    [sym_set_comprehension] = STATE(145),
    [sym_parenthesized_expression] = STATE(145),
    [sym_tuple] = STATE(145),
    [sym_generator_expression] = STATE(145),
    [sym_conditional_expression] = STATE(1562),
    [sym_concatenated_string] = STATE(145),
    [sym_await] = STATE(1562),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_not] = ACTIONS(240),
    [anon_sym_PLUS] = ACTIONS(242),
    [anon_sym_DASH] = ACTIONS(242),
    [anon_sym_TILDE] = ACTIONS(242),
    [anon_sym_lambda] = ACTIONS(3429),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(248),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(250),
    [sym_integer] = ACTIONS(252),
    [sym_float] = ACTIONS(252),
    [sym_identifier] = ACTIONS(252),
    [sym_true] = ACTIONS(252),
    [sym_false] = ACTIONS(252),
    [sym_none] = ACTIONS(252),
    [anon_sym_await] = ACTIONS(254),
    [sym_comment] = ACTIONS(72),
  },
  [1560] = {
    [sym_lambda_parameters] = STATE(1749),
    [sym__parameters] = STATE(130),
    [sym_default_parameter] = STATE(131),
    [sym_typed_default_parameter] = STATE(131),
    [sym_list_splat] = STATE(132),
    [sym_dictionary_splat] = STATE(132),
    [sym_typed_parameter] = STATE(131),
    [sym_tuple] = STATE(131),
    [anon_sym_LPAREN] = ACTIONS(222),
    [anon_sym_STAR] = ACTIONS(224),
    [anon_sym_print] = ACTIONS(226),
    [anon_sym_COLON] = ACTIONS(3938),
    [anon_sym_exec] = ACTIONS(226),
    [sym_identifier] = ACTIONS(230),
    [sym_comment] = ACTIONS(72),
  },
  [1561] = {
    [aux_sym_for_in_clause_repeat1] = STATE(1751),
    [anon_sym_COMMA] = ACTIONS(3940),
    [anon_sym_if] = ACTIONS(3687),
    [anon_sym_async] = ACTIONS(3687),
    [anon_sym_for] = ACTIONS(3687),
    [anon_sym_RBRACK] = ACTIONS(3687),
    [sym_comment] = ACTIONS(72),
  },
  [1562] = {
    [anon_sym_COMMA] = ACTIONS(3691),
    [anon_sym_if] = ACTIONS(3691),
    [anon_sym_async] = ACTIONS(3691),
    [anon_sym_for] = ACTIONS(3691),
    [anon_sym_and] = ACTIONS(790),
    [anon_sym_or] = ACTIONS(792),
    [anon_sym_RBRACK] = ACTIONS(3691),
    [sym_comment] = ACTIONS(72),
  },
  [1563] = {
    [anon_sym_if] = ACTIONS(716),
    [anon_sym_async] = ACTIONS(716),
    [anon_sym_for] = ACTIONS(716),
    [anon_sym_and] = ACTIONS(3435),
    [anon_sym_or] = ACTIONS(3437),
    [anon_sym_RBRACK] = ACTIONS(716),
    [sym_comment] = ACTIONS(72),
  },
  [1564] = {
    [sym__expression] = STATE(1752),
    [sym__primary_expression] = STATE(1274),
    [sym_not_operator] = STATE(1752),
    [sym_boolean_operator] = STATE(1752),
    [sym_binary_operator] = STATE(1274),
    [sym_unary_operator] = STATE(1274),
    [sym_comparison_operator] = STATE(1752),
    [sym_lambda] = STATE(1752),
    [sym_attribute] = STATE(1274),
    [sym_subscript] = STATE(1274),
    [sym_call] = STATE(1274),
    [sym_list] = STATE(1274),
    [sym_list_comprehension] = STATE(1274),
    [sym_dictionary] = STATE(1274),
    [sym_dictionary_comprehension] = STATE(1274),
    [sym_set] = STATE(1274),
    [sym_set_comprehension] = STATE(1274),
    [sym_parenthesized_expression] = STATE(1274),
    [sym_tuple] = STATE(1274),
    [sym_generator_expression] = STATE(1274),
    [sym_conditional_expression] = STATE(1752),
    [sym_concatenated_string] = STATE(1274),
    [sym_await] = STATE(1752),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_not] = ACTIONS(2702),
    [anon_sym_PLUS] = ACTIONS(2704),
    [anon_sym_DASH] = ACTIONS(2704),
    [anon_sym_TILDE] = ACTIONS(2704),
    [anon_sym_lambda] = ACTIONS(2706),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(2708),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(2710),
    [sym_integer] = ACTIONS(2712),
    [sym_float] = ACTIONS(2712),
    [sym_identifier] = ACTIONS(2712),
    [sym_true] = ACTIONS(2712),
    [sym_false] = ACTIONS(2712),
    [sym_none] = ACTIONS(2712),
    [anon_sym_await] = ACTIONS(2714),
    [sym_comment] = ACTIONS(72),
  },
  [1565] = {
    [anon_sym_COLON] = ACTIONS(3942),
    [sym_comment] = ACTIONS(72),
  },
  [1566] = {
    [aux_sym_concatenated_string_repeat1] = STATE(1754),
    [anon_sym_DOT] = ACTIONS(886),
    [anon_sym_LPAREN] = ACTIONS(886),
    [anon_sym_STAR] = ACTIONS(888),
    [anon_sym_GT_GT] = ACTIONS(886),
    [anon_sym_if] = ACTIONS(886),
    [anon_sym_async] = ACTIONS(886),
    [anon_sym_for] = ACTIONS(886),
    [anon_sym_in] = ACTIONS(886),
    [anon_sym_AT] = ACTIONS(886),
    [anon_sym_not] = ACTIONS(886),
    [anon_sym_and] = ACTIONS(886),
    [anon_sym_or] = ACTIONS(886),
    [anon_sym_PLUS] = ACTIONS(886),
    [anon_sym_DASH] = ACTIONS(886),
    [anon_sym_SLASH] = ACTIONS(888),
    [anon_sym_PERCENT] = ACTIONS(886),
    [anon_sym_SLASH_SLASH] = ACTIONS(886),
    [anon_sym_STAR_STAR] = ACTIONS(886),
    [anon_sym_PIPE] = ACTIONS(886),
    [anon_sym_AMP] = ACTIONS(886),
    [anon_sym_CARET] = ACTIONS(886),
    [anon_sym_LT_LT] = ACTIONS(886),
    [anon_sym_LT] = ACTIONS(888),
    [anon_sym_LT_EQ] = ACTIONS(886),
    [anon_sym_EQ_EQ] = ACTIONS(886),
    [anon_sym_BANG_EQ] = ACTIONS(886),
    [anon_sym_GT_EQ] = ACTIONS(886),
    [anon_sym_GT] = ACTIONS(888),
    [anon_sym_LT_GT] = ACTIONS(886),
    [anon_sym_is] = ACTIONS(886),
    [anon_sym_LBRACK] = ACTIONS(886),
    [anon_sym_RBRACK] = ACTIONS(886),
    [sym_string] = ACTIONS(3944),
    [sym_comment] = ACTIONS(72),
  },
  [1567] = {
    [sym__expression] = STATE(1755),
    [sym__primary_expression] = STATE(513),
    [sym_not_operator] = STATE(1755),
    [sym_boolean_operator] = STATE(1755),
    [sym_binary_operator] = STATE(513),
    [sym_unary_operator] = STATE(513),
    [sym_comparison_operator] = STATE(1755),
    [sym_lambda] = STATE(1755),
    [sym_attribute] = STATE(513),
    [sym_subscript] = STATE(513),
    [sym_call] = STATE(513),
    [sym_list] = STATE(513),
    [sym_list_comprehension] = STATE(513),
    [sym_dictionary] = STATE(513),
    [sym_dictionary_comprehension] = STATE(513),
    [sym_set] = STATE(513),
    [sym_set_comprehension] = STATE(513),
    [sym_parenthesized_expression] = STATE(513),
    [sym_tuple] = STATE(513),
    [sym_generator_expression] = STATE(513),
    [sym_conditional_expression] = STATE(1755),
    [sym_concatenated_string] = STATE(513),
    [sym_await] = STATE(1755),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_not] = ACTIONS(914),
    [anon_sym_PLUS] = ACTIONS(916),
    [anon_sym_DASH] = ACTIONS(916),
    [anon_sym_TILDE] = ACTIONS(916),
    [anon_sym_lambda] = ACTIONS(918),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(920),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(922),
    [sym_integer] = ACTIONS(924),
    [sym_float] = ACTIONS(924),
    [sym_identifier] = ACTIONS(924),
    [sym_true] = ACTIONS(924),
    [sym_false] = ACTIONS(924),
    [sym_none] = ACTIONS(924),
    [anon_sym_await] = ACTIONS(926),
    [sym_comment] = ACTIONS(72),
  },
  [1568] = {
    [sym__expression] = STATE(604),
    [sym__primary_expression] = STATE(1274),
    [sym_not_operator] = STATE(604),
    [sym_boolean_operator] = STATE(604),
    [sym_binary_operator] = STATE(1274),
    [sym_unary_operator] = STATE(1274),
    [sym_comparison_operator] = STATE(604),
    [sym_lambda] = STATE(604),
    [sym_attribute] = STATE(1274),
    [sym_subscript] = STATE(1274),
    [sym_call] = STATE(1274),
    [sym_list] = STATE(1274),
    [sym_list_comprehension] = STATE(1274),
    [sym_dictionary] = STATE(1274),
    [sym_dictionary_comprehension] = STATE(1274),
    [sym_set] = STATE(1274),
    [sym_set_comprehension] = STATE(1274),
    [sym_parenthesized_expression] = STATE(1274),
    [sym_tuple] = STATE(1274),
    [sym_generator_expression] = STATE(1274),
    [sym_conditional_expression] = STATE(604),
    [sym_concatenated_string] = STATE(1274),
    [sym_await] = STATE(604),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_not] = ACTIONS(2702),
    [anon_sym_PLUS] = ACTIONS(2704),
    [anon_sym_DASH] = ACTIONS(2704),
    [anon_sym_TILDE] = ACTIONS(2704),
    [anon_sym_lambda] = ACTIONS(2706),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(2708),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(2710),
    [sym_integer] = ACTIONS(2712),
    [sym_float] = ACTIONS(2712),
    [sym_identifier] = ACTIONS(2712),
    [sym_true] = ACTIONS(2712),
    [sym_false] = ACTIONS(2712),
    [sym_none] = ACTIONS(2712),
    [anon_sym_await] = ACTIONS(2714),
    [sym_comment] = ACTIONS(72),
  },
  [1569] = {
    [sym__expression] = STATE(1756),
    [sym__primary_expression] = STATE(1274),
    [sym_not_operator] = STATE(1756),
    [sym_boolean_operator] = STATE(1756),
    [sym_binary_operator] = STATE(1274),
    [sym_unary_operator] = STATE(1274),
    [sym_comparison_operator] = STATE(1756),
    [sym_lambda] = STATE(1756),
    [sym_attribute] = STATE(1274),
    [sym_subscript] = STATE(1274),
    [sym_call] = STATE(1274),
    [sym_list] = STATE(1274),
    [sym_list_comprehension] = STATE(1274),
    [sym_dictionary] = STATE(1274),
    [sym_dictionary_comprehension] = STATE(1274),
    [sym_set] = STATE(1274),
    [sym_set_comprehension] = STATE(1274),
    [sym_parenthesized_expression] = STATE(1274),
    [sym_tuple] = STATE(1274),
    [sym_generator_expression] = STATE(1274),
    [sym_conditional_expression] = STATE(1756),
    [sym_concatenated_string] = STATE(1274),
    [sym_await] = STATE(1756),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_not] = ACTIONS(2702),
    [anon_sym_PLUS] = ACTIONS(2704),
    [anon_sym_DASH] = ACTIONS(2704),
    [anon_sym_TILDE] = ACTIONS(2704),
    [anon_sym_lambda] = ACTIONS(2706),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(2708),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(2710),
    [sym_integer] = ACTIONS(2712),
    [sym_float] = ACTIONS(2712),
    [sym_identifier] = ACTIONS(2712),
    [sym_true] = ACTIONS(2712),
    [sym_false] = ACTIONS(2712),
    [sym_none] = ACTIONS(2712),
    [anon_sym_await] = ACTIONS(2714),
    [sym_comment] = ACTIONS(72),
  },
  [1570] = {
    [sym__primary_expression] = STATE(1757),
    [sym_binary_operator] = STATE(1757),
    [sym_unary_operator] = STATE(1757),
    [sym_attribute] = STATE(1757),
    [sym_subscript] = STATE(1757),
    [sym_call] = STATE(1757),
    [sym_list] = STATE(1757),
    [sym_list_comprehension] = STATE(1757),
    [sym_dictionary] = STATE(1757),
    [sym_dictionary_comprehension] = STATE(1757),
    [sym_set] = STATE(1757),
    [sym_set_comprehension] = STATE(1757),
    [sym_parenthesized_expression] = STATE(1757),
    [sym_tuple] = STATE(1757),
    [sym_generator_expression] = STATE(1757),
    [sym_concatenated_string] = STATE(1757),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_PLUS] = ACTIONS(2704),
    [anon_sym_DASH] = ACTIONS(2704),
    [anon_sym_TILDE] = ACTIONS(2704),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(3946),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(2710),
    [sym_integer] = ACTIONS(3948),
    [sym_float] = ACTIONS(3948),
    [sym_identifier] = ACTIONS(3948),
    [sym_true] = ACTIONS(3948),
    [sym_false] = ACTIONS(3948),
    [sym_none] = ACTIONS(3948),
    [sym_comment] = ACTIONS(72),
  },
  [1571] = {
    [sym__primary_expression] = STATE(1758),
    [sym_binary_operator] = STATE(1758),
    [sym_unary_operator] = STATE(1758),
    [sym_attribute] = STATE(1758),
    [sym_subscript] = STATE(1758),
    [sym_call] = STATE(1758),
    [sym_list] = STATE(1758),
    [sym_list_comprehension] = STATE(1758),
    [sym_dictionary] = STATE(1758),
    [sym_dictionary_comprehension] = STATE(1758),
    [sym_set] = STATE(1758),
    [sym_set_comprehension] = STATE(1758),
    [sym_parenthesized_expression] = STATE(1758),
    [sym_tuple] = STATE(1758),
    [sym_generator_expression] = STATE(1758),
    [sym_concatenated_string] = STATE(1758),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_PLUS] = ACTIONS(2704),
    [anon_sym_DASH] = ACTIONS(2704),
    [anon_sym_TILDE] = ACTIONS(2704),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(3950),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(2710),
    [sym_integer] = ACTIONS(3952),
    [sym_float] = ACTIONS(3952),
    [sym_identifier] = ACTIONS(3952),
    [sym_true] = ACTIONS(3952),
    [sym_false] = ACTIONS(3952),
    [sym_none] = ACTIONS(3952),
    [sym_comment] = ACTIONS(72),
  },
  [1572] = {
    [sym__primary_expression] = STATE(1759),
    [sym_binary_operator] = STATE(1759),
    [sym_unary_operator] = STATE(1759),
    [sym_attribute] = STATE(1759),
    [sym_subscript] = STATE(1759),
    [sym_call] = STATE(1759),
    [sym_list] = STATE(1759),
    [sym_list_comprehension] = STATE(1759),
    [sym_dictionary] = STATE(1759),
    [sym_dictionary_comprehension] = STATE(1759),
    [sym_set] = STATE(1759),
    [sym_set_comprehension] = STATE(1759),
    [sym_parenthesized_expression] = STATE(1759),
    [sym_tuple] = STATE(1759),
    [sym_generator_expression] = STATE(1759),
    [sym_concatenated_string] = STATE(1759),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_PLUS] = ACTIONS(2704),
    [anon_sym_DASH] = ACTIONS(2704),
    [anon_sym_TILDE] = ACTIONS(2704),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(3954),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(2710),
    [sym_integer] = ACTIONS(3956),
    [sym_float] = ACTIONS(3956),
    [sym_identifier] = ACTIONS(3956),
    [sym_true] = ACTIONS(3956),
    [sym_false] = ACTIONS(3956),
    [sym_none] = ACTIONS(3956),
    [sym_comment] = ACTIONS(72),
  },
  [1573] = {
    [anon_sym_in] = ACTIONS(3958),
    [sym_comment] = ACTIONS(72),
  },
  [1574] = {
    [sym__primary_expression] = STATE(1761),
    [sym_binary_operator] = STATE(1761),
    [sym_unary_operator] = STATE(1761),
    [sym_attribute] = STATE(1761),
    [sym_subscript] = STATE(1761),
    [sym_call] = STATE(1761),
    [sym_list] = STATE(1761),
    [sym_list_comprehension] = STATE(1761),
    [sym_dictionary] = STATE(1761),
    [sym_dictionary_comprehension] = STATE(1761),
    [sym_set] = STATE(1761),
    [sym_set_comprehension] = STATE(1761),
    [sym_parenthesized_expression] = STATE(1761),
    [sym_tuple] = STATE(1761),
    [sym_generator_expression] = STATE(1761),
    [sym_concatenated_string] = STATE(1761),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_PLUS] = ACTIONS(2704),
    [anon_sym_DASH] = ACTIONS(2704),
    [anon_sym_TILDE] = ACTIONS(2704),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(3960),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(2710),
    [sym_integer] = ACTIONS(3962),
    [sym_float] = ACTIONS(3962),
    [sym_identifier] = ACTIONS(3962),
    [sym_true] = ACTIONS(3962),
    [sym_false] = ACTIONS(3962),
    [sym_none] = ACTIONS(3962),
    [sym_comment] = ACTIONS(72),
  },
  [1575] = {
    [sym__primary_expression] = STATE(621),
    [sym_binary_operator] = STATE(621),
    [sym_unary_operator] = STATE(621),
    [sym_attribute] = STATE(621),
    [sym_subscript] = STATE(621),
    [sym_call] = STATE(621),
    [sym_list] = STATE(621),
    [sym_list_comprehension] = STATE(621),
    [sym_dictionary] = STATE(621),
    [sym_dictionary_comprehension] = STATE(621),
    [sym_set] = STATE(621),
    [sym_set_comprehension] = STATE(621),
    [sym_parenthesized_expression] = STATE(621),
    [sym_tuple] = STATE(621),
    [sym_generator_expression] = STATE(621),
    [sym_concatenated_string] = STATE(621),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_PLUS] = ACTIONS(2704),
    [anon_sym_DASH] = ACTIONS(2704),
    [anon_sym_TILDE] = ACTIONS(2704),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(1233),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(2710),
    [sym_integer] = ACTIONS(1235),
    [sym_float] = ACTIONS(1235),
    [sym_identifier] = ACTIONS(1235),
    [sym_true] = ACTIONS(1235),
    [sym_false] = ACTIONS(1235),
    [sym_none] = ACTIONS(1235),
    [sym_comment] = ACTIONS(72),
  },
  [1576] = {
    [sym__primary_expression] = STATE(1762),
    [sym_binary_operator] = STATE(1762),
    [sym_unary_operator] = STATE(1762),
    [sym_attribute] = STATE(1762),
    [sym_subscript] = STATE(1762),
    [sym_call] = STATE(1762),
    [sym_list] = STATE(1762),
    [sym_list_comprehension] = STATE(1762),
    [sym_dictionary] = STATE(1762),
    [sym_dictionary_comprehension] = STATE(1762),
    [sym_set] = STATE(1762),
    [sym_set_comprehension] = STATE(1762),
    [sym_parenthesized_expression] = STATE(1762),
    [sym_tuple] = STATE(1762),
    [sym_generator_expression] = STATE(1762),
    [sym_concatenated_string] = STATE(1762),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_PLUS] = ACTIONS(2704),
    [anon_sym_DASH] = ACTIONS(2704),
    [anon_sym_TILDE] = ACTIONS(2704),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(3964),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(2710),
    [sym_integer] = ACTIONS(3966),
    [sym_float] = ACTIONS(3966),
    [sym_identifier] = ACTIONS(3966),
    [sym_true] = ACTIONS(3966),
    [sym_false] = ACTIONS(3966),
    [sym_none] = ACTIONS(3966),
    [sym_comment] = ACTIONS(72),
  },
  [1577] = {
    [sym__primary_expression] = STATE(1763),
    [sym_binary_operator] = STATE(1763),
    [sym_unary_operator] = STATE(1763),
    [sym_attribute] = STATE(1763),
    [sym_subscript] = STATE(1763),
    [sym_call] = STATE(1763),
    [sym_list] = STATE(1763),
    [sym_list_comprehension] = STATE(1763),
    [sym_dictionary] = STATE(1763),
    [sym_dictionary_comprehension] = STATE(1763),
    [sym_set] = STATE(1763),
    [sym_set_comprehension] = STATE(1763),
    [sym_parenthesized_expression] = STATE(1763),
    [sym_tuple] = STATE(1763),
    [sym_generator_expression] = STATE(1763),
    [sym_concatenated_string] = STATE(1763),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_PLUS] = ACTIONS(2704),
    [anon_sym_DASH] = ACTIONS(2704),
    [anon_sym_TILDE] = ACTIONS(2704),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(3968),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(2710),
    [sym_integer] = ACTIONS(3970),
    [sym_float] = ACTIONS(3970),
    [sym_identifier] = ACTIONS(3970),
    [sym_true] = ACTIONS(3970),
    [sym_false] = ACTIONS(3970),
    [sym_none] = ACTIONS(3970),
    [sym_comment] = ACTIONS(72),
  },
  [1578] = {
    [sym__primary_expression] = STATE(1764),
    [sym_binary_operator] = STATE(1764),
    [sym_unary_operator] = STATE(1764),
    [sym_attribute] = STATE(1764),
    [sym_subscript] = STATE(1764),
    [sym_call] = STATE(1764),
    [sym_list] = STATE(1764),
    [sym_list_comprehension] = STATE(1764),
    [sym_dictionary] = STATE(1764),
    [sym_dictionary_comprehension] = STATE(1764),
    [sym_set] = STATE(1764),
    [sym_set_comprehension] = STATE(1764),
    [sym_parenthesized_expression] = STATE(1764),
    [sym_tuple] = STATE(1764),
    [sym_generator_expression] = STATE(1764),
    [sym_concatenated_string] = STATE(1764),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_PLUS] = ACTIONS(2704),
    [anon_sym_DASH] = ACTIONS(2704),
    [anon_sym_TILDE] = ACTIONS(2704),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(3972),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(2710),
    [sym_integer] = ACTIONS(3974),
    [sym_float] = ACTIONS(3974),
    [sym_identifier] = ACTIONS(3974),
    [sym_true] = ACTIONS(3974),
    [sym_false] = ACTIONS(3974),
    [sym_none] = ACTIONS(3974),
    [sym_comment] = ACTIONS(72),
  },
  [1579] = {
    [sym__primary_expression] = STATE(1759),
    [sym_binary_operator] = STATE(1759),
    [sym_unary_operator] = STATE(1759),
    [sym_attribute] = STATE(1759),
    [sym_subscript] = STATE(1759),
    [sym_call] = STATE(1759),
    [sym_list] = STATE(1759),
    [sym_list_comprehension] = STATE(1759),
    [sym_dictionary] = STATE(1759),
    [sym_dictionary_comprehension] = STATE(1759),
    [sym_set] = STATE(1759),
    [sym_set_comprehension] = STATE(1759),
    [sym_parenthesized_expression] = STATE(1759),
    [sym_tuple] = STATE(1759),
    [sym_generator_expression] = STATE(1759),
    [sym_concatenated_string] = STATE(1759),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_not] = ACTIONS(3976),
    [anon_sym_PLUS] = ACTIONS(2704),
    [anon_sym_DASH] = ACTIONS(2704),
    [anon_sym_TILDE] = ACTIONS(2704),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(3954),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(2710),
    [sym_integer] = ACTIONS(3956),
    [sym_float] = ACTIONS(3956),
    [sym_identifier] = ACTIONS(3956),
    [sym_true] = ACTIONS(3956),
    [sym_false] = ACTIONS(3956),
    [sym_none] = ACTIONS(3956),
    [sym_comment] = ACTIONS(72),
  },
  [1580] = {
    [aux_sym_comparison_operator_repeat1] = STATE(1765),
    [anon_sym_if] = ACTIONS(998),
    [anon_sym_async] = ACTIONS(998),
    [anon_sym_for] = ACTIONS(998),
    [anon_sym_in] = ACTIONS(3443),
    [anon_sym_not] = ACTIONS(3447),
    [anon_sym_and] = ACTIONS(998),
    [anon_sym_or] = ACTIONS(998),
    [anon_sym_LT] = ACTIONS(3459),
    [anon_sym_LT_EQ] = ACTIONS(3443),
    [anon_sym_EQ_EQ] = ACTIONS(3443),
    [anon_sym_BANG_EQ] = ACTIONS(3443),
    [anon_sym_GT_EQ] = ACTIONS(3443),
    [anon_sym_GT] = ACTIONS(3459),
    [anon_sym_LT_GT] = ACTIONS(3443),
    [anon_sym_is] = ACTIONS(3461),
    [anon_sym_RBRACK] = ACTIONS(998),
    [sym_comment] = ACTIONS(72),
  },
  [1581] = {
    [anon_sym_COMMA] = ACTIONS(2642),
    [anon_sym_if] = ACTIONS(1758),
    [anon_sym_and] = ACTIONS(1760),
    [anon_sym_or] = ACTIONS(1762),
    [anon_sym_RBRACE] = ACTIONS(2642),
    [sym_comment] = ACTIONS(72),
  },
  [1582] = {
    [sym__expression] = STATE(1766),
    [sym__primary_expression] = STATE(463),
    [sym_not_operator] = STATE(1766),
    [sym_boolean_operator] = STATE(1766),
    [sym_binary_operator] = STATE(463),
    [sym_unary_operator] = STATE(463),
    [sym_comparison_operator] = STATE(1766),
    [sym_lambda] = STATE(1766),
    [sym_attribute] = STATE(463),
    [sym_subscript] = STATE(463),
    [sym_call] = STATE(463),
    [sym_list] = STATE(463),
    [sym_list_comprehension] = STATE(463),
    [sym_dictionary] = STATE(463),
    [sym_dictionary_comprehension] = STATE(463),
    [sym_set] = STATE(463),
    [sym_set_comprehension] = STATE(463),
    [sym_parenthesized_expression] = STATE(463),
    [sym_tuple] = STATE(463),
    [sym_generator_expression] = STATE(463),
    [sym_conditional_expression] = STATE(1766),
    [sym_concatenated_string] = STATE(463),
    [sym_await] = STATE(1766),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_not] = ACTIONS(822),
    [anon_sym_PLUS] = ACTIONS(824),
    [anon_sym_DASH] = ACTIONS(824),
    [anon_sym_TILDE] = ACTIONS(824),
    [anon_sym_lambda] = ACTIONS(826),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(828),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(830),
    [sym_integer] = ACTIONS(832),
    [sym_float] = ACTIONS(832),
    [sym_identifier] = ACTIONS(832),
    [sym_true] = ACTIONS(832),
    [sym_false] = ACTIONS(832),
    [sym_none] = ACTIONS(832),
    [anon_sym_await] = ACTIONS(834),
    [sym_comment] = ACTIONS(72),
  },
  [1583] = {
    [sym_argument_list] = STATE(251),
    [sym_generator_expression] = STATE(251),
    [anon_sym_DOT] = ACTIONS(422),
    [anon_sym_LPAREN] = ACTIONS(424),
    [anon_sym_COMMA] = ACTIONS(2953),
    [anon_sym_STAR] = ACTIONS(1764),
    [anon_sym_GT_GT] = ACTIONS(1766),
    [anon_sym_if] = ACTIONS(2953),
    [anon_sym_in] = ACTIONS(2953),
    [anon_sym_AT] = ACTIONS(1770),
    [anon_sym_not] = ACTIONS(2953),
    [anon_sym_and] = ACTIONS(2953),
    [anon_sym_or] = ACTIONS(2953),
    [anon_sym_PLUS] = ACTIONS(1774),
    [anon_sym_DASH] = ACTIONS(1774),
    [anon_sym_SLASH] = ACTIONS(1764),
    [anon_sym_PERCENT] = ACTIONS(1770),
    [anon_sym_SLASH_SLASH] = ACTIONS(1770),
    [anon_sym_STAR_STAR] = ACTIONS(1776),
    [anon_sym_PIPE] = ACTIONS(1778),
    [anon_sym_AMP] = ACTIONS(1780),
    [anon_sym_CARET] = ACTIONS(1782),
    [anon_sym_LT_LT] = ACTIONS(1766),
    [anon_sym_LT] = ACTIONS(2955),
    [anon_sym_LT_EQ] = ACTIONS(2953),
    [anon_sym_EQ_EQ] = ACTIONS(2953),
    [anon_sym_BANG_EQ] = ACTIONS(2953),
    [anon_sym_GT_EQ] = ACTIONS(2953),
    [anon_sym_GT] = ACTIONS(2955),
    [anon_sym_LT_GT] = ACTIONS(2953),
    [anon_sym_is] = ACTIONS(2953),
    [anon_sym_LBRACK] = ACTIONS(450),
    [anon_sym_RBRACE] = ACTIONS(2953),
    [sym_comment] = ACTIONS(72),
  },
  [1584] = {
    [anon_sym_COMMA] = ACTIONS(2799),
    [anon_sym_if] = ACTIONS(1758),
    [anon_sym_and] = ACTIONS(1760),
    [anon_sym_or] = ACTIONS(1762),
    [anon_sym_RBRACE] = ACTIONS(2799),
    [sym_comment] = ACTIONS(72),
  },
  [1585] = {
    [anon_sym_COMMA] = ACTIONS(3610),
    [anon_sym_if] = ACTIONS(850),
    [anon_sym_COLON] = ACTIONS(3610),
    [anon_sym_async] = ACTIONS(3610),
    [anon_sym_for] = ACTIONS(3610),
    [anon_sym_and] = ACTIONS(858),
    [anon_sym_or] = ACTIONS(860),
    [anon_sym_RBRACE] = ACTIONS(3610),
    [sym_comment] = ACTIONS(72),
  },
  [1586] = {
    [anon_sym_COMMA] = ACTIONS(1644),
    [anon_sym_if] = ACTIONS(2801),
    [anon_sym_async] = ACTIONS(1644),
    [anon_sym_for] = ACTIONS(1644),
    [anon_sym_and] = ACTIONS(2803),
    [anon_sym_or] = ACTIONS(2805),
    [anon_sym_RBRACE] = ACTIONS(1644),
    [sym_comment] = ACTIONS(72),
  },
  [1587] = {
    [sym__expression] = STATE(1767),
    [sym__primary_expression] = STATE(930),
    [sym_not_operator] = STATE(1767),
    [sym_boolean_operator] = STATE(1767),
    [sym_binary_operator] = STATE(930),
    [sym_unary_operator] = STATE(930),
    [sym_comparison_operator] = STATE(1767),
    [sym_lambda] = STATE(1767),
    [sym_attribute] = STATE(930),
    [sym_subscript] = STATE(930),
    [sym_call] = STATE(930),
    [sym_list] = STATE(930),
    [sym_list_comprehension] = STATE(930),
    [sym_dictionary] = STATE(930),
    [sym_dictionary_comprehension] = STATE(930),
    [sym_set] = STATE(930),
    [sym_set_comprehension] = STATE(930),
    [sym_parenthesized_expression] = STATE(930),
    [sym_tuple] = STATE(930),
    [sym_generator_expression] = STATE(930),
    [sym_conditional_expression] = STATE(1767),
    [sym_concatenated_string] = STATE(930),
    [sym_await] = STATE(1767),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_not] = ACTIONS(1808),
    [anon_sym_PLUS] = ACTIONS(1810),
    [anon_sym_DASH] = ACTIONS(1810),
    [anon_sym_TILDE] = ACTIONS(1810),
    [anon_sym_lambda] = ACTIONS(1812),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(1814),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(1816),
    [sym_integer] = ACTIONS(1818),
    [sym_float] = ACTIONS(1818),
    [sym_identifier] = ACTIONS(1818),
    [sym_true] = ACTIONS(1818),
    [sym_false] = ACTIONS(1818),
    [sym_none] = ACTIONS(1818),
    [anon_sym_await] = ACTIONS(1820),
    [sym_comment] = ACTIONS(72),
  },
  [1588] = {
    [aux_sym_concatenated_string_repeat1] = STATE(1588),
    [anon_sym_DOT] = ACTIONS(1862),
    [anon_sym_LPAREN] = ACTIONS(1862),
    [anon_sym_COMMA] = ACTIONS(1862),
    [anon_sym_STAR] = ACTIONS(1864),
    [anon_sym_GT_GT] = ACTIONS(1862),
    [anon_sym_if] = ACTIONS(1862),
    [anon_sym_async] = ACTIONS(1862),
    [anon_sym_for] = ACTIONS(1862),
    [anon_sym_in] = ACTIONS(1862),
    [anon_sym_AT] = ACTIONS(1862),
    [anon_sym_not] = ACTIONS(1862),
    [anon_sym_and] = ACTIONS(1862),
    [anon_sym_or] = ACTIONS(1862),
    [anon_sym_PLUS] = ACTIONS(1862),
    [anon_sym_DASH] = ACTIONS(1862),
    [anon_sym_SLASH] = ACTIONS(1864),
    [anon_sym_PERCENT] = ACTIONS(1862),
    [anon_sym_SLASH_SLASH] = ACTIONS(1862),
    [anon_sym_STAR_STAR] = ACTIONS(1862),
    [anon_sym_PIPE] = ACTIONS(1862),
    [anon_sym_AMP] = ACTIONS(1862),
    [anon_sym_CARET] = ACTIONS(1862),
    [anon_sym_LT_LT] = ACTIONS(1862),
    [anon_sym_LT] = ACTIONS(1864),
    [anon_sym_LT_EQ] = ACTIONS(1862),
    [anon_sym_EQ_EQ] = ACTIONS(1862),
    [anon_sym_BANG_EQ] = ACTIONS(1862),
    [anon_sym_GT_EQ] = ACTIONS(1862),
    [anon_sym_GT] = ACTIONS(1864),
    [anon_sym_LT_GT] = ACTIONS(1862),
    [anon_sym_is] = ACTIONS(1862),
    [anon_sym_LBRACK] = ACTIONS(1862),
    [anon_sym_RBRACE] = ACTIONS(1862),
    [sym_string] = ACTIONS(3978),
    [sym_comment] = ACTIONS(72),
  },
  [1589] = {
    [anon_sym_if] = ACTIONS(1921),
    [anon_sym_else] = ACTIONS(3981),
    [anon_sym_and] = ACTIONS(1925),
    [anon_sym_or] = ACTIONS(1927),
    [sym_comment] = ACTIONS(72),
  },
  [1590] = {
    [anon_sym_COMMA] = ACTIONS(1953),
    [anon_sym_if] = ACTIONS(1953),
    [anon_sym_async] = ACTIONS(1953),
    [anon_sym_for] = ACTIONS(1953),
    [anon_sym_and] = ACTIONS(2803),
    [anon_sym_or] = ACTIONS(1953),
    [anon_sym_RBRACE] = ACTIONS(1953),
    [sym_comment] = ACTIONS(72),
  },
  [1591] = {
    [sym_argument_list] = STATE(251),
    [sym_generator_expression] = STATE(251),
    [anon_sym_DOT] = ACTIONS(1980),
    [anon_sym_LPAREN] = ACTIONS(424),
    [anon_sym_COMMA] = ACTIONS(1980),
    [anon_sym_STAR] = ACTIONS(1982),
    [anon_sym_GT_GT] = ACTIONS(1980),
    [anon_sym_if] = ACTIONS(1980),
    [anon_sym_async] = ACTIONS(1980),
    [anon_sym_for] = ACTIONS(1980),
    [anon_sym_in] = ACTIONS(1980),
    [anon_sym_AT] = ACTIONS(1980),
    [anon_sym_not] = ACTIONS(1980),
    [anon_sym_and] = ACTIONS(1980),
    [anon_sym_or] = ACTIONS(1980),
    [anon_sym_PLUS] = ACTIONS(1980),
    [anon_sym_DASH] = ACTIONS(1980),
    [anon_sym_SLASH] = ACTIONS(1982),
    [anon_sym_PERCENT] = ACTIONS(1980),
    [anon_sym_SLASH_SLASH] = ACTIONS(1980),
    [anon_sym_STAR_STAR] = ACTIONS(2819),
    [anon_sym_PIPE] = ACTIONS(1980),
    [anon_sym_AMP] = ACTIONS(1980),
    [anon_sym_CARET] = ACTIONS(1980),
    [anon_sym_LT_LT] = ACTIONS(1980),
    [anon_sym_LT] = ACTIONS(1982),
    [anon_sym_LT_EQ] = ACTIONS(1980),
    [anon_sym_EQ_EQ] = ACTIONS(1980),
    [anon_sym_BANG_EQ] = ACTIONS(1980),
    [anon_sym_GT_EQ] = ACTIONS(1980),
    [anon_sym_GT] = ACTIONS(1982),
    [anon_sym_LT_GT] = ACTIONS(1980),
    [anon_sym_is] = ACTIONS(1980),
    [anon_sym_LBRACK] = ACTIONS(1980),
    [anon_sym_RBRACE] = ACTIONS(1980),
    [sym_comment] = ACTIONS(72),
  },
  [1592] = {
    [sym_argument_list] = STATE(251),
    [sym_generator_expression] = STATE(251),
    [anon_sym_DOT] = ACTIONS(1980),
    [anon_sym_LPAREN] = ACTIONS(424),
    [anon_sym_COMMA] = ACTIONS(1980),
    [anon_sym_STAR] = ACTIONS(2807),
    [anon_sym_GT_GT] = ACTIONS(1980),
    [anon_sym_if] = ACTIONS(1980),
    [anon_sym_async] = ACTIONS(1980),
    [anon_sym_for] = ACTIONS(1980),
    [anon_sym_in] = ACTIONS(1980),
    [anon_sym_AT] = ACTIONS(2813),
    [anon_sym_not] = ACTIONS(1980),
    [anon_sym_and] = ACTIONS(1980),
    [anon_sym_or] = ACTIONS(1980),
    [anon_sym_PLUS] = ACTIONS(2817),
    [anon_sym_DASH] = ACTIONS(2817),
    [anon_sym_SLASH] = ACTIONS(2807),
    [anon_sym_PERCENT] = ACTIONS(2813),
    [anon_sym_SLASH_SLASH] = ACTIONS(2813),
    [anon_sym_STAR_STAR] = ACTIONS(2819),
    [anon_sym_PIPE] = ACTIONS(1980),
    [anon_sym_AMP] = ACTIONS(1980),
    [anon_sym_CARET] = ACTIONS(1980),
    [anon_sym_LT_LT] = ACTIONS(1980),
    [anon_sym_LT] = ACTIONS(1982),
    [anon_sym_LT_EQ] = ACTIONS(1980),
    [anon_sym_EQ_EQ] = ACTIONS(1980),
    [anon_sym_BANG_EQ] = ACTIONS(1980),
    [anon_sym_GT_EQ] = ACTIONS(1980),
    [anon_sym_GT] = ACTIONS(1982),
    [anon_sym_LT_GT] = ACTIONS(1980),
    [anon_sym_is] = ACTIONS(1980),
    [anon_sym_LBRACK] = ACTIONS(1980),
    [anon_sym_RBRACE] = ACTIONS(1980),
    [sym_comment] = ACTIONS(72),
  },
  [1593] = {
    [sym_argument_list] = STATE(251),
    [sym_generator_expression] = STATE(251),
    [anon_sym_DOT] = ACTIONS(422),
    [anon_sym_LPAREN] = ACTIONS(424),
    [anon_sym_COMMA] = ACTIONS(1984),
    [anon_sym_STAR] = ACTIONS(2807),
    [anon_sym_GT_GT] = ACTIONS(2809),
    [anon_sym_if] = ACTIONS(1984),
    [anon_sym_async] = ACTIONS(1984),
    [anon_sym_for] = ACTIONS(1984),
    [anon_sym_in] = ACTIONS(1984),
    [anon_sym_AT] = ACTIONS(2813),
    [anon_sym_not] = ACTIONS(1984),
    [anon_sym_and] = ACTIONS(1984),
    [anon_sym_or] = ACTIONS(1984),
    [anon_sym_PLUS] = ACTIONS(2817),
    [anon_sym_DASH] = ACTIONS(2817),
    [anon_sym_SLASH] = ACTIONS(2807),
    [anon_sym_PERCENT] = ACTIONS(2813),
    [anon_sym_SLASH_SLASH] = ACTIONS(2813),
    [anon_sym_STAR_STAR] = ACTIONS(2819),
    [anon_sym_PIPE] = ACTIONS(2821),
    [anon_sym_AMP] = ACTIONS(2823),
    [anon_sym_CARET] = ACTIONS(2825),
    [anon_sym_LT_LT] = ACTIONS(2809),
    [anon_sym_LT] = ACTIONS(1986),
    [anon_sym_LT_EQ] = ACTIONS(1984),
    [anon_sym_EQ_EQ] = ACTIONS(1984),
    [anon_sym_BANG_EQ] = ACTIONS(1984),
    [anon_sym_GT_EQ] = ACTIONS(1984),
    [anon_sym_GT] = ACTIONS(1986),
    [anon_sym_LT_GT] = ACTIONS(1984),
    [anon_sym_is] = ACTIONS(1984),
    [anon_sym_LBRACK] = ACTIONS(450),
    [anon_sym_RBRACE] = ACTIONS(1984),
    [sym_comment] = ACTIONS(72),
  },
  [1594] = {
    [sym__primary_expression] = STATE(1769),
    [sym_binary_operator] = STATE(1769),
    [sym_unary_operator] = STATE(1769),
    [sym_attribute] = STATE(1769),
    [sym_subscript] = STATE(1769),
    [sym_call] = STATE(1769),
    [sym_list] = STATE(1769),
    [sym_list_comprehension] = STATE(1769),
    [sym_dictionary] = STATE(1769),
    [sym_dictionary_comprehension] = STATE(1769),
    [sym_set] = STATE(1769),
    [sym_set_comprehension] = STATE(1769),
    [sym_parenthesized_expression] = STATE(1769),
    [sym_tuple] = STATE(1769),
    [sym_generator_expression] = STATE(1769),
    [sym_concatenated_string] = STATE(1769),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_PLUS] = ACTIONS(1810),
    [anon_sym_DASH] = ACTIONS(1810),
    [anon_sym_TILDE] = ACTIONS(1810),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(3983),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(1816),
    [sym_integer] = ACTIONS(3985),
    [sym_float] = ACTIONS(3985),
    [sym_identifier] = ACTIONS(3985),
    [sym_true] = ACTIONS(3985),
    [sym_false] = ACTIONS(3985),
    [sym_none] = ACTIONS(3985),
    [sym_comment] = ACTIONS(72),
  },
  [1595] = {
    [sym_argument_list] = STATE(251),
    [sym_generator_expression] = STATE(251),
    [anon_sym_DOT] = ACTIONS(1980),
    [anon_sym_LPAREN] = ACTIONS(424),
    [anon_sym_COMMA] = ACTIONS(1980),
    [anon_sym_STAR] = ACTIONS(2807),
    [anon_sym_GT_GT] = ACTIONS(1980),
    [anon_sym_if] = ACTIONS(1980),
    [anon_sym_async] = ACTIONS(1980),
    [anon_sym_for] = ACTIONS(1980),
    [anon_sym_in] = ACTIONS(1980),
    [anon_sym_AT] = ACTIONS(2813),
    [anon_sym_not] = ACTIONS(1980),
    [anon_sym_and] = ACTIONS(1980),
    [anon_sym_or] = ACTIONS(1980),
    [anon_sym_PLUS] = ACTIONS(1980),
    [anon_sym_DASH] = ACTIONS(1980),
    [anon_sym_SLASH] = ACTIONS(2807),
    [anon_sym_PERCENT] = ACTIONS(2813),
    [anon_sym_SLASH_SLASH] = ACTIONS(2813),
    [anon_sym_STAR_STAR] = ACTIONS(2819),
    [anon_sym_PIPE] = ACTIONS(1980),
    [anon_sym_AMP] = ACTIONS(1980),
    [anon_sym_CARET] = ACTIONS(1980),
    [anon_sym_LT_LT] = ACTIONS(1980),
    [anon_sym_LT] = ACTIONS(1982),
    [anon_sym_LT_EQ] = ACTIONS(1980),
    [anon_sym_EQ_EQ] = ACTIONS(1980),
    [anon_sym_BANG_EQ] = ACTIONS(1980),
    [anon_sym_GT_EQ] = ACTIONS(1980),
    [anon_sym_GT] = ACTIONS(1982),
    [anon_sym_LT_GT] = ACTIONS(1980),
    [anon_sym_is] = ACTIONS(1980),
    [anon_sym_LBRACK] = ACTIONS(1980),
    [anon_sym_RBRACE] = ACTIONS(1980),
    [sym_comment] = ACTIONS(72),
  },
  [1596] = {
    [sym_argument_list] = STATE(251),
    [sym_generator_expression] = STATE(251),
    [anon_sym_DOT] = ACTIONS(1980),
    [anon_sym_LPAREN] = ACTIONS(424),
    [anon_sym_COMMA] = ACTIONS(1980),
    [anon_sym_STAR] = ACTIONS(2807),
    [anon_sym_GT_GT] = ACTIONS(2809),
    [anon_sym_if] = ACTIONS(1980),
    [anon_sym_async] = ACTIONS(1980),
    [anon_sym_for] = ACTIONS(1980),
    [anon_sym_in] = ACTIONS(1980),
    [anon_sym_AT] = ACTIONS(2813),
    [anon_sym_not] = ACTIONS(1980),
    [anon_sym_and] = ACTIONS(1980),
    [anon_sym_or] = ACTIONS(1980),
    [anon_sym_PLUS] = ACTIONS(2817),
    [anon_sym_DASH] = ACTIONS(2817),
    [anon_sym_SLASH] = ACTIONS(2807),
    [anon_sym_PERCENT] = ACTIONS(2813),
    [anon_sym_SLASH_SLASH] = ACTIONS(2813),
    [anon_sym_STAR_STAR] = ACTIONS(2819),
    [anon_sym_PIPE] = ACTIONS(1980),
    [anon_sym_AMP] = ACTIONS(2823),
    [anon_sym_CARET] = ACTIONS(2825),
    [anon_sym_LT_LT] = ACTIONS(2809),
    [anon_sym_LT] = ACTIONS(1982),
    [anon_sym_LT_EQ] = ACTIONS(1980),
    [anon_sym_EQ_EQ] = ACTIONS(1980),
    [anon_sym_BANG_EQ] = ACTIONS(1980),
    [anon_sym_GT_EQ] = ACTIONS(1980),
    [anon_sym_GT] = ACTIONS(1982),
    [anon_sym_LT_GT] = ACTIONS(1980),
    [anon_sym_is] = ACTIONS(1980),
    [anon_sym_LBRACK] = ACTIONS(1980),
    [anon_sym_RBRACE] = ACTIONS(1980),
    [sym_comment] = ACTIONS(72),
  },
  [1597] = {
    [sym_argument_list] = STATE(251),
    [sym_generator_expression] = STATE(251),
    [anon_sym_DOT] = ACTIONS(1980),
    [anon_sym_LPAREN] = ACTIONS(424),
    [anon_sym_COMMA] = ACTIONS(1980),
    [anon_sym_STAR] = ACTIONS(2807),
    [anon_sym_GT_GT] = ACTIONS(2809),
    [anon_sym_if] = ACTIONS(1980),
    [anon_sym_async] = ACTIONS(1980),
    [anon_sym_for] = ACTIONS(1980),
    [anon_sym_in] = ACTIONS(1980),
    [anon_sym_AT] = ACTIONS(2813),
    [anon_sym_not] = ACTIONS(1980),
    [anon_sym_and] = ACTIONS(1980),
    [anon_sym_or] = ACTIONS(1980),
    [anon_sym_PLUS] = ACTIONS(2817),
    [anon_sym_DASH] = ACTIONS(2817),
    [anon_sym_SLASH] = ACTIONS(2807),
    [anon_sym_PERCENT] = ACTIONS(2813),
    [anon_sym_SLASH_SLASH] = ACTIONS(2813),
    [anon_sym_STAR_STAR] = ACTIONS(2819),
    [anon_sym_PIPE] = ACTIONS(1980),
    [anon_sym_AMP] = ACTIONS(1980),
    [anon_sym_CARET] = ACTIONS(2825),
    [anon_sym_LT_LT] = ACTIONS(2809),
    [anon_sym_LT] = ACTIONS(1982),
    [anon_sym_LT_EQ] = ACTIONS(1980),
    [anon_sym_EQ_EQ] = ACTIONS(1980),
    [anon_sym_BANG_EQ] = ACTIONS(1980),
    [anon_sym_GT_EQ] = ACTIONS(1980),
    [anon_sym_GT] = ACTIONS(1982),
    [anon_sym_LT_GT] = ACTIONS(1980),
    [anon_sym_is] = ACTIONS(1980),
    [anon_sym_LBRACK] = ACTIONS(1980),
    [anon_sym_RBRACE] = ACTIONS(1980),
    [sym_comment] = ACTIONS(72),
  },
  [1598] = {
    [sym_argument_list] = STATE(251),
    [sym_generator_expression] = STATE(251),
    [anon_sym_DOT] = ACTIONS(1980),
    [anon_sym_LPAREN] = ACTIONS(424),
    [anon_sym_COMMA] = ACTIONS(1980),
    [anon_sym_STAR] = ACTIONS(2807),
    [anon_sym_GT_GT] = ACTIONS(2809),
    [anon_sym_if] = ACTIONS(1980),
    [anon_sym_async] = ACTIONS(1980),
    [anon_sym_for] = ACTIONS(1980),
    [anon_sym_in] = ACTIONS(1980),
    [anon_sym_AT] = ACTIONS(2813),
    [anon_sym_not] = ACTIONS(1980),
    [anon_sym_and] = ACTIONS(1980),
    [anon_sym_or] = ACTIONS(1980),
    [anon_sym_PLUS] = ACTIONS(2817),
    [anon_sym_DASH] = ACTIONS(2817),
    [anon_sym_SLASH] = ACTIONS(2807),
    [anon_sym_PERCENT] = ACTIONS(2813),
    [anon_sym_SLASH_SLASH] = ACTIONS(2813),
    [anon_sym_STAR_STAR] = ACTIONS(2819),
    [anon_sym_PIPE] = ACTIONS(1980),
    [anon_sym_AMP] = ACTIONS(1980),
    [anon_sym_CARET] = ACTIONS(1980),
    [anon_sym_LT_LT] = ACTIONS(2809),
    [anon_sym_LT] = ACTIONS(1982),
    [anon_sym_LT_EQ] = ACTIONS(1980),
    [anon_sym_EQ_EQ] = ACTIONS(1980),
    [anon_sym_BANG_EQ] = ACTIONS(1980),
    [anon_sym_GT_EQ] = ACTIONS(1980),
    [anon_sym_GT] = ACTIONS(1982),
    [anon_sym_LT_GT] = ACTIONS(1980),
    [anon_sym_is] = ACTIONS(1980),
    [anon_sym_LBRACK] = ACTIONS(1980),
    [anon_sym_RBRACE] = ACTIONS(1980),
    [sym_comment] = ACTIONS(72),
  },
  [1599] = {
    [aux_sym_comparison_operator_repeat1] = STATE(1599),
    [anon_sym_COMMA] = ACTIONS(1984),
    [anon_sym_if] = ACTIONS(1984),
    [anon_sym_async] = ACTIONS(1984),
    [anon_sym_for] = ACTIONS(1984),
    [anon_sym_in] = ACTIONS(3987),
    [anon_sym_not] = ACTIONS(3990),
    [anon_sym_and] = ACTIONS(1984),
    [anon_sym_or] = ACTIONS(1984),
    [anon_sym_LT] = ACTIONS(3993),
    [anon_sym_LT_EQ] = ACTIONS(3987),
    [anon_sym_EQ_EQ] = ACTIONS(3987),
    [anon_sym_BANG_EQ] = ACTIONS(3987),
    [anon_sym_GT_EQ] = ACTIONS(3987),
    [anon_sym_GT] = ACTIONS(3993),
    [anon_sym_LT_GT] = ACTIONS(3987),
    [anon_sym_is] = ACTIONS(3996),
    [anon_sym_RBRACE] = ACTIONS(1984),
    [sym_comment] = ACTIONS(72),
  },
  [1600] = {
    [sym__expression_within_for_in_clause] = STATE(1770),
    [sym__expression] = STATE(1603),
    [sym__primary_expression] = STATE(930),
    [sym_not_operator] = STATE(1603),
    [sym_boolean_operator] = STATE(1603),
    [sym_binary_operator] = STATE(930),
    [sym_unary_operator] = STATE(930),
    [sym_comparison_operator] = STATE(1603),
    [sym_lambda] = STATE(1603),
    [sym_lambda_within_for_in_clause] = STATE(1406),
    [sym_attribute] = STATE(930),
    [sym_subscript] = STATE(930),
    [sym_call] = STATE(930),
    [sym_list] = STATE(930),
    [sym_list_comprehension] = STATE(930),
    [sym_dictionary] = STATE(930),
    [sym_dictionary_comprehension] = STATE(930),
    [sym_set] = STATE(930),
    [sym_set_comprehension] = STATE(930),
    [sym_parenthesized_expression] = STATE(930),
    [sym_tuple] = STATE(930),
    [sym_generator_expression] = STATE(930),
    [sym_conditional_expression] = STATE(1603),
    [sym_concatenated_string] = STATE(930),
    [sym_await] = STATE(1603),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_not] = ACTIONS(1808),
    [anon_sym_PLUS] = ACTIONS(1810),
    [anon_sym_DASH] = ACTIONS(1810),
    [anon_sym_TILDE] = ACTIONS(1810),
    [anon_sym_lambda] = ACTIONS(3539),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(1814),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(1816),
    [sym_integer] = ACTIONS(1818),
    [sym_float] = ACTIONS(1818),
    [sym_identifier] = ACTIONS(1818),
    [sym_true] = ACTIONS(1818),
    [sym_false] = ACTIONS(1818),
    [sym_none] = ACTIONS(1818),
    [anon_sym_await] = ACTIONS(1820),
    [sym_comment] = ACTIONS(72),
  },
  [1601] = {
    [sym_lambda_parameters] = STATE(1772),
    [sym__parameters] = STATE(130),
    [sym_default_parameter] = STATE(131),
    [sym_typed_default_parameter] = STATE(131),
    [sym_list_splat] = STATE(132),
    [sym_dictionary_splat] = STATE(132),
    [sym_typed_parameter] = STATE(131),
    [sym_tuple] = STATE(131),
    [anon_sym_LPAREN] = ACTIONS(222),
    [anon_sym_STAR] = ACTIONS(224),
    [anon_sym_print] = ACTIONS(226),
    [anon_sym_COLON] = ACTIONS(3999),
    [anon_sym_exec] = ACTIONS(226),
    [sym_identifier] = ACTIONS(230),
    [sym_comment] = ACTIONS(72),
  },
  [1602] = {
    [aux_sym_for_in_clause_repeat1] = STATE(1774),
    [anon_sym_COMMA] = ACTIONS(4001),
    [anon_sym_if] = ACTIONS(3687),
    [anon_sym_async] = ACTIONS(3687),
    [anon_sym_for] = ACTIONS(3687),
    [anon_sym_RBRACE] = ACTIONS(3687),
    [sym_comment] = ACTIONS(72),
  },
  [1603] = {
    [anon_sym_COMMA] = ACTIONS(3691),
    [anon_sym_if] = ACTIONS(3691),
    [anon_sym_async] = ACTIONS(3691),
    [anon_sym_for] = ACTIONS(3691),
    [anon_sym_and] = ACTIONS(2803),
    [anon_sym_or] = ACTIONS(2805),
    [anon_sym_RBRACE] = ACTIONS(3691),
    [sym_comment] = ACTIONS(72),
  },
  [1604] = {
    [anon_sym_if] = ACTIONS(716),
    [anon_sym_async] = ACTIONS(716),
    [anon_sym_for] = ACTIONS(716),
    [anon_sym_and] = ACTIONS(3545),
    [anon_sym_or] = ACTIONS(3547),
    [anon_sym_RBRACE] = ACTIONS(716),
    [sym_comment] = ACTIONS(72),
  },
  [1605] = {
    [sym__expression] = STATE(1775),
    [sym__primary_expression] = STATE(1324),
    [sym_not_operator] = STATE(1775),
    [sym_boolean_operator] = STATE(1775),
    [sym_binary_operator] = STATE(1324),
    [sym_unary_operator] = STATE(1324),
    [sym_comparison_operator] = STATE(1775),
    [sym_lambda] = STATE(1775),
    [sym_attribute] = STATE(1324),
    [sym_subscript] = STATE(1324),
    [sym_call] = STATE(1324),
    [sym_list] = STATE(1324),
    [sym_list_comprehension] = STATE(1324),
    [sym_dictionary] = STATE(1324),
    [sym_dictionary_comprehension] = STATE(1324),
    [sym_set] = STATE(1324),
    [sym_set_comprehension] = STATE(1324),
    [sym_parenthesized_expression] = STATE(1324),
    [sym_tuple] = STATE(1324),
    [sym_generator_expression] = STATE(1324),
    [sym_conditional_expression] = STATE(1775),
    [sym_concatenated_string] = STATE(1324),
    [sym_await] = STATE(1775),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_not] = ACTIONS(2837),
    [anon_sym_PLUS] = ACTIONS(2839),
    [anon_sym_DASH] = ACTIONS(2839),
    [anon_sym_TILDE] = ACTIONS(2839),
    [anon_sym_lambda] = ACTIONS(2841),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(2843),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(2845),
    [sym_integer] = ACTIONS(2847),
    [sym_float] = ACTIONS(2847),
    [sym_identifier] = ACTIONS(2847),
    [sym_true] = ACTIONS(2847),
    [sym_false] = ACTIONS(2847),
    [sym_none] = ACTIONS(2847),
    [anon_sym_await] = ACTIONS(2849),
    [sym_comment] = ACTIONS(72),
  },
  [1606] = {
    [anon_sym_COLON] = ACTIONS(4003),
    [sym_comment] = ACTIONS(72),
  },
  [1607] = {
    [aux_sym_concatenated_string_repeat1] = STATE(1777),
    [anon_sym_DOT] = ACTIONS(886),
    [anon_sym_LPAREN] = ACTIONS(886),
    [anon_sym_STAR] = ACTIONS(888),
    [anon_sym_GT_GT] = ACTIONS(886),
    [anon_sym_if] = ACTIONS(886),
    [anon_sym_async] = ACTIONS(886),
    [anon_sym_for] = ACTIONS(886),
    [anon_sym_in] = ACTIONS(886),
    [anon_sym_AT] = ACTIONS(886),
    [anon_sym_not] = ACTIONS(886),
    [anon_sym_and] = ACTIONS(886),
    [anon_sym_or] = ACTIONS(886),
    [anon_sym_PLUS] = ACTIONS(886),
    [anon_sym_DASH] = ACTIONS(886),
    [anon_sym_SLASH] = ACTIONS(888),
    [anon_sym_PERCENT] = ACTIONS(886),
    [anon_sym_SLASH_SLASH] = ACTIONS(886),
    [anon_sym_STAR_STAR] = ACTIONS(886),
    [anon_sym_PIPE] = ACTIONS(886),
    [anon_sym_AMP] = ACTIONS(886),
    [anon_sym_CARET] = ACTIONS(886),
    [anon_sym_LT_LT] = ACTIONS(886),
    [anon_sym_LT] = ACTIONS(888),
    [anon_sym_LT_EQ] = ACTIONS(886),
    [anon_sym_EQ_EQ] = ACTIONS(886),
    [anon_sym_BANG_EQ] = ACTIONS(886),
    [anon_sym_GT_EQ] = ACTIONS(886),
    [anon_sym_GT] = ACTIONS(888),
    [anon_sym_LT_GT] = ACTIONS(886),
    [anon_sym_is] = ACTIONS(886),
    [anon_sym_LBRACK] = ACTIONS(886),
    [anon_sym_RBRACE] = ACTIONS(886),
    [sym_string] = ACTIONS(4005),
    [sym_comment] = ACTIONS(72),
  },
  [1608] = {
    [sym__expression] = STATE(1778),
    [sym__primary_expression] = STATE(513),
    [sym_not_operator] = STATE(1778),
    [sym_boolean_operator] = STATE(1778),
    [sym_binary_operator] = STATE(513),
    [sym_unary_operator] = STATE(513),
    [sym_comparison_operator] = STATE(1778),
    [sym_lambda] = STATE(1778),
    [sym_attribute] = STATE(513),
    [sym_subscript] = STATE(513),
    [sym_call] = STATE(513),
    [sym_list] = STATE(513),
    [sym_list_comprehension] = STATE(513),
    [sym_dictionary] = STATE(513),
    [sym_dictionary_comprehension] = STATE(513),
    [sym_set] = STATE(513),
    [sym_set_comprehension] = STATE(513),
    [sym_parenthesized_expression] = STATE(513),
    [sym_tuple] = STATE(513),
    [sym_generator_expression] = STATE(513),
    [sym_conditional_expression] = STATE(1778),
    [sym_concatenated_string] = STATE(513),
    [sym_await] = STATE(1778),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_not] = ACTIONS(914),
    [anon_sym_PLUS] = ACTIONS(916),
    [anon_sym_DASH] = ACTIONS(916),
    [anon_sym_TILDE] = ACTIONS(916),
    [anon_sym_lambda] = ACTIONS(918),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(920),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(922),
    [sym_integer] = ACTIONS(924),
    [sym_float] = ACTIONS(924),
    [sym_identifier] = ACTIONS(924),
    [sym_true] = ACTIONS(924),
    [sym_false] = ACTIONS(924),
    [sym_none] = ACTIONS(924),
    [anon_sym_await] = ACTIONS(926),
    [sym_comment] = ACTIONS(72),
  },
  [1609] = {
    [sym__expression] = STATE(604),
    [sym__primary_expression] = STATE(1324),
    [sym_not_operator] = STATE(604),
    [sym_boolean_operator] = STATE(604),
    [sym_binary_operator] = STATE(1324),
    [sym_unary_operator] = STATE(1324),
    [sym_comparison_operator] = STATE(604),
    [sym_lambda] = STATE(604),
    [sym_attribute] = STATE(1324),
    [sym_subscript] = STATE(1324),
    [sym_call] = STATE(1324),
    [sym_list] = STATE(1324),
    [sym_list_comprehension] = STATE(1324),
    [sym_dictionary] = STATE(1324),
    [sym_dictionary_comprehension] = STATE(1324),
    [sym_set] = STATE(1324),
    [sym_set_comprehension] = STATE(1324),
    [sym_parenthesized_expression] = STATE(1324),
    [sym_tuple] = STATE(1324),
    [sym_generator_expression] = STATE(1324),
    [sym_conditional_expression] = STATE(604),
    [sym_concatenated_string] = STATE(1324),
    [sym_await] = STATE(604),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_not] = ACTIONS(2837),
    [anon_sym_PLUS] = ACTIONS(2839),
    [anon_sym_DASH] = ACTIONS(2839),
    [anon_sym_TILDE] = ACTIONS(2839),
    [anon_sym_lambda] = ACTIONS(2841),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(2843),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(2845),
    [sym_integer] = ACTIONS(2847),
    [sym_float] = ACTIONS(2847),
    [sym_identifier] = ACTIONS(2847),
    [sym_true] = ACTIONS(2847),
    [sym_false] = ACTIONS(2847),
    [sym_none] = ACTIONS(2847),
    [anon_sym_await] = ACTIONS(2849),
    [sym_comment] = ACTIONS(72),
  },
  [1610] = {
    [sym__expression] = STATE(1779),
    [sym__primary_expression] = STATE(1324),
    [sym_not_operator] = STATE(1779),
    [sym_boolean_operator] = STATE(1779),
    [sym_binary_operator] = STATE(1324),
    [sym_unary_operator] = STATE(1324),
    [sym_comparison_operator] = STATE(1779),
    [sym_lambda] = STATE(1779),
    [sym_attribute] = STATE(1324),
    [sym_subscript] = STATE(1324),
    [sym_call] = STATE(1324),
    [sym_list] = STATE(1324),
    [sym_list_comprehension] = STATE(1324),
    [sym_dictionary] = STATE(1324),
    [sym_dictionary_comprehension] = STATE(1324),
    [sym_set] = STATE(1324),
    [sym_set_comprehension] = STATE(1324),
    [sym_parenthesized_expression] = STATE(1324),
    [sym_tuple] = STATE(1324),
    [sym_generator_expression] = STATE(1324),
    [sym_conditional_expression] = STATE(1779),
    [sym_concatenated_string] = STATE(1324),
    [sym_await] = STATE(1779),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_not] = ACTIONS(2837),
    [anon_sym_PLUS] = ACTIONS(2839),
    [anon_sym_DASH] = ACTIONS(2839),
    [anon_sym_TILDE] = ACTIONS(2839),
    [anon_sym_lambda] = ACTIONS(2841),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(2843),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(2845),
    [sym_integer] = ACTIONS(2847),
    [sym_float] = ACTIONS(2847),
    [sym_identifier] = ACTIONS(2847),
    [sym_true] = ACTIONS(2847),
    [sym_false] = ACTIONS(2847),
    [sym_none] = ACTIONS(2847),
    [anon_sym_await] = ACTIONS(2849),
    [sym_comment] = ACTIONS(72),
  },
  [1611] = {
    [sym__primary_expression] = STATE(1780),
    [sym_binary_operator] = STATE(1780),
    [sym_unary_operator] = STATE(1780),
    [sym_attribute] = STATE(1780),
    [sym_subscript] = STATE(1780),
    [sym_call] = STATE(1780),
    [sym_list] = STATE(1780),
    [sym_list_comprehension] = STATE(1780),
    [sym_dictionary] = STATE(1780),
    [sym_dictionary_comprehension] = STATE(1780),
    [sym_set] = STATE(1780),
    [sym_set_comprehension] = STATE(1780),
    [sym_parenthesized_expression] = STATE(1780),
    [sym_tuple] = STATE(1780),
    [sym_generator_expression] = STATE(1780),
    [sym_concatenated_string] = STATE(1780),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_PLUS] = ACTIONS(2839),
    [anon_sym_DASH] = ACTIONS(2839),
    [anon_sym_TILDE] = ACTIONS(2839),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(4007),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(2845),
    [sym_integer] = ACTIONS(4009),
    [sym_float] = ACTIONS(4009),
    [sym_identifier] = ACTIONS(4009),
    [sym_true] = ACTIONS(4009),
    [sym_false] = ACTIONS(4009),
    [sym_none] = ACTIONS(4009),
    [sym_comment] = ACTIONS(72),
  },
  [1612] = {
    [sym__primary_expression] = STATE(1781),
    [sym_binary_operator] = STATE(1781),
    [sym_unary_operator] = STATE(1781),
    [sym_attribute] = STATE(1781),
    [sym_subscript] = STATE(1781),
    [sym_call] = STATE(1781),
    [sym_list] = STATE(1781),
    [sym_list_comprehension] = STATE(1781),
    [sym_dictionary] = STATE(1781),
    [sym_dictionary_comprehension] = STATE(1781),
    [sym_set] = STATE(1781),
    [sym_set_comprehension] = STATE(1781),
    [sym_parenthesized_expression] = STATE(1781),
    [sym_tuple] = STATE(1781),
    [sym_generator_expression] = STATE(1781),
    [sym_concatenated_string] = STATE(1781),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_PLUS] = ACTIONS(2839),
    [anon_sym_DASH] = ACTIONS(2839),
    [anon_sym_TILDE] = ACTIONS(2839),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(4011),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(2845),
    [sym_integer] = ACTIONS(4013),
    [sym_float] = ACTIONS(4013),
    [sym_identifier] = ACTIONS(4013),
    [sym_true] = ACTIONS(4013),
    [sym_false] = ACTIONS(4013),
    [sym_none] = ACTIONS(4013),
    [sym_comment] = ACTIONS(72),
  },
  [1613] = {
    [sym__primary_expression] = STATE(1782),
    [sym_binary_operator] = STATE(1782),
    [sym_unary_operator] = STATE(1782),
    [sym_attribute] = STATE(1782),
    [sym_subscript] = STATE(1782),
    [sym_call] = STATE(1782),
    [sym_list] = STATE(1782),
    [sym_list_comprehension] = STATE(1782),
    [sym_dictionary] = STATE(1782),
    [sym_dictionary_comprehension] = STATE(1782),
    [sym_set] = STATE(1782),
    [sym_set_comprehension] = STATE(1782),
    [sym_parenthesized_expression] = STATE(1782),
    [sym_tuple] = STATE(1782),
    [sym_generator_expression] = STATE(1782),
    [sym_concatenated_string] = STATE(1782),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_PLUS] = ACTIONS(2839),
    [anon_sym_DASH] = ACTIONS(2839),
    [anon_sym_TILDE] = ACTIONS(2839),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(4015),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(2845),
    [sym_integer] = ACTIONS(4017),
    [sym_float] = ACTIONS(4017),
    [sym_identifier] = ACTIONS(4017),
    [sym_true] = ACTIONS(4017),
    [sym_false] = ACTIONS(4017),
    [sym_none] = ACTIONS(4017),
    [sym_comment] = ACTIONS(72),
  },
  [1614] = {
    [anon_sym_in] = ACTIONS(4019),
    [sym_comment] = ACTIONS(72),
  },
  [1615] = {
    [sym__primary_expression] = STATE(1784),
    [sym_binary_operator] = STATE(1784),
    [sym_unary_operator] = STATE(1784),
    [sym_attribute] = STATE(1784),
    [sym_subscript] = STATE(1784),
    [sym_call] = STATE(1784),
    [sym_list] = STATE(1784),
    [sym_list_comprehension] = STATE(1784),
    [sym_dictionary] = STATE(1784),
    [sym_dictionary_comprehension] = STATE(1784),
    [sym_set] = STATE(1784),
    [sym_set_comprehension] = STATE(1784),
    [sym_parenthesized_expression] = STATE(1784),
    [sym_tuple] = STATE(1784),
    [sym_generator_expression] = STATE(1784),
    [sym_concatenated_string] = STATE(1784),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_PLUS] = ACTIONS(2839),
    [anon_sym_DASH] = ACTIONS(2839),
    [anon_sym_TILDE] = ACTIONS(2839),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(4021),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(2845),
    [sym_integer] = ACTIONS(4023),
    [sym_float] = ACTIONS(4023),
    [sym_identifier] = ACTIONS(4023),
    [sym_true] = ACTIONS(4023),
    [sym_false] = ACTIONS(4023),
    [sym_none] = ACTIONS(4023),
    [sym_comment] = ACTIONS(72),
  },
  [1616] = {
    [sym__primary_expression] = STATE(621),
    [sym_binary_operator] = STATE(621),
    [sym_unary_operator] = STATE(621),
    [sym_attribute] = STATE(621),
    [sym_subscript] = STATE(621),
    [sym_call] = STATE(621),
    [sym_list] = STATE(621),
    [sym_list_comprehension] = STATE(621),
    [sym_dictionary] = STATE(621),
    [sym_dictionary_comprehension] = STATE(621),
    [sym_set] = STATE(621),
    [sym_set_comprehension] = STATE(621),
    [sym_parenthesized_expression] = STATE(621),
    [sym_tuple] = STATE(621),
    [sym_generator_expression] = STATE(621),
    [sym_concatenated_string] = STATE(621),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_PLUS] = ACTIONS(2839),
    [anon_sym_DASH] = ACTIONS(2839),
    [anon_sym_TILDE] = ACTIONS(2839),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(1233),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(2845),
    [sym_integer] = ACTIONS(1235),
    [sym_float] = ACTIONS(1235),
    [sym_identifier] = ACTIONS(1235),
    [sym_true] = ACTIONS(1235),
    [sym_false] = ACTIONS(1235),
    [sym_none] = ACTIONS(1235),
    [sym_comment] = ACTIONS(72),
  },
  [1617] = {
    [sym__primary_expression] = STATE(1785),
    [sym_binary_operator] = STATE(1785),
    [sym_unary_operator] = STATE(1785),
    [sym_attribute] = STATE(1785),
    [sym_subscript] = STATE(1785),
    [sym_call] = STATE(1785),
    [sym_list] = STATE(1785),
    [sym_list_comprehension] = STATE(1785),
    [sym_dictionary] = STATE(1785),
    [sym_dictionary_comprehension] = STATE(1785),
    [sym_set] = STATE(1785),
    [sym_set_comprehension] = STATE(1785),
    [sym_parenthesized_expression] = STATE(1785),
    [sym_tuple] = STATE(1785),
    [sym_generator_expression] = STATE(1785),
    [sym_concatenated_string] = STATE(1785),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_PLUS] = ACTIONS(2839),
    [anon_sym_DASH] = ACTIONS(2839),
    [anon_sym_TILDE] = ACTIONS(2839),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(4025),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(2845),
    [sym_integer] = ACTIONS(4027),
    [sym_float] = ACTIONS(4027),
    [sym_identifier] = ACTIONS(4027),
    [sym_true] = ACTIONS(4027),
    [sym_false] = ACTIONS(4027),
    [sym_none] = ACTIONS(4027),
    [sym_comment] = ACTIONS(72),
  },
  [1618] = {
    [sym__primary_expression] = STATE(1786),
    [sym_binary_operator] = STATE(1786),
    [sym_unary_operator] = STATE(1786),
    [sym_attribute] = STATE(1786),
    [sym_subscript] = STATE(1786),
    [sym_call] = STATE(1786),
    [sym_list] = STATE(1786),
    [sym_list_comprehension] = STATE(1786),
    [sym_dictionary] = STATE(1786),
    [sym_dictionary_comprehension] = STATE(1786),
    [sym_set] = STATE(1786),
    [sym_set_comprehension] = STATE(1786),
    [sym_parenthesized_expression] = STATE(1786),
    [sym_tuple] = STATE(1786),
    [sym_generator_expression] = STATE(1786),
    [sym_concatenated_string] = STATE(1786),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_PLUS] = ACTIONS(2839),
    [anon_sym_DASH] = ACTIONS(2839),
    [anon_sym_TILDE] = ACTIONS(2839),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(4029),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(2845),
    [sym_integer] = ACTIONS(4031),
    [sym_float] = ACTIONS(4031),
    [sym_identifier] = ACTIONS(4031),
    [sym_true] = ACTIONS(4031),
    [sym_false] = ACTIONS(4031),
    [sym_none] = ACTIONS(4031),
    [sym_comment] = ACTIONS(72),
  },
  [1619] = {
    [sym__primary_expression] = STATE(1787),
    [sym_binary_operator] = STATE(1787),
    [sym_unary_operator] = STATE(1787),
    [sym_attribute] = STATE(1787),
    [sym_subscript] = STATE(1787),
    [sym_call] = STATE(1787),
    [sym_list] = STATE(1787),
    [sym_list_comprehension] = STATE(1787),
    [sym_dictionary] = STATE(1787),
    [sym_dictionary_comprehension] = STATE(1787),
    [sym_set] = STATE(1787),
    [sym_set_comprehension] = STATE(1787),
    [sym_parenthesized_expression] = STATE(1787),
    [sym_tuple] = STATE(1787),
    [sym_generator_expression] = STATE(1787),
    [sym_concatenated_string] = STATE(1787),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_PLUS] = ACTIONS(2839),
    [anon_sym_DASH] = ACTIONS(2839),
    [anon_sym_TILDE] = ACTIONS(2839),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(4033),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(2845),
    [sym_integer] = ACTIONS(4035),
    [sym_float] = ACTIONS(4035),
    [sym_identifier] = ACTIONS(4035),
    [sym_true] = ACTIONS(4035),
    [sym_false] = ACTIONS(4035),
    [sym_none] = ACTIONS(4035),
    [sym_comment] = ACTIONS(72),
  },
  [1620] = {
    [sym__primary_expression] = STATE(1782),
    [sym_binary_operator] = STATE(1782),
    [sym_unary_operator] = STATE(1782),
    [sym_attribute] = STATE(1782),
    [sym_subscript] = STATE(1782),
    [sym_call] = STATE(1782),
    [sym_list] = STATE(1782),
    [sym_list_comprehension] = STATE(1782),
    [sym_dictionary] = STATE(1782),
    [sym_dictionary_comprehension] = STATE(1782),
    [sym_set] = STATE(1782),
    [sym_set_comprehension] = STATE(1782),
    [sym_parenthesized_expression] = STATE(1782),
    [sym_tuple] = STATE(1782),
    [sym_generator_expression] = STATE(1782),
    [sym_concatenated_string] = STATE(1782),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_not] = ACTIONS(4037),
    [anon_sym_PLUS] = ACTIONS(2839),
    [anon_sym_DASH] = ACTIONS(2839),
    [anon_sym_TILDE] = ACTIONS(2839),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(4015),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(2845),
    [sym_integer] = ACTIONS(4017),
    [sym_float] = ACTIONS(4017),
    [sym_identifier] = ACTIONS(4017),
    [sym_true] = ACTIONS(4017),
    [sym_false] = ACTIONS(4017),
    [sym_none] = ACTIONS(4017),
    [sym_comment] = ACTIONS(72),
  },
  [1621] = {
    [aux_sym_comparison_operator_repeat1] = STATE(1788),
    [anon_sym_if] = ACTIONS(998),
    [anon_sym_async] = ACTIONS(998),
    [anon_sym_for] = ACTIONS(998),
    [anon_sym_in] = ACTIONS(3553),
    [anon_sym_not] = ACTIONS(3557),
    [anon_sym_and] = ACTIONS(998),
    [anon_sym_or] = ACTIONS(998),
    [anon_sym_LT] = ACTIONS(3569),
    [anon_sym_LT_EQ] = ACTIONS(3553),
    [anon_sym_EQ_EQ] = ACTIONS(3553),
    [anon_sym_BANG_EQ] = ACTIONS(3553),
    [anon_sym_GT_EQ] = ACTIONS(3553),
    [anon_sym_GT] = ACTIONS(3569),
    [anon_sym_LT_GT] = ACTIONS(3553),
    [anon_sym_is] = ACTIONS(3571),
    [anon_sym_RBRACE] = ACTIONS(998),
    [sym_comment] = ACTIONS(72),
  },
  [1622] = {
    [sym__newline] = ACTIONS(2642),
    [anon_sym_if] = ACTIONS(1875),
    [anon_sym_EQ] = ACTIONS(2642),
    [anon_sym_and] = ACTIONS(1877),
    [anon_sym_or] = ACTIONS(1879),
    [sym_comment] = ACTIONS(72),
    [sym__semicolon] = ACTIONS(2642),
  },
  [1623] = {
    [sym__expression] = STATE(1789),
    [sym__primary_expression] = STATE(500),
    [sym_not_operator] = STATE(1789),
    [sym_boolean_operator] = STATE(1789),
    [sym_binary_operator] = STATE(500),
    [sym_unary_operator] = STATE(500),
    [sym_comparison_operator] = STATE(1789),
    [sym_lambda] = STATE(1789),
    [sym_attribute] = STATE(500),
    [sym_subscript] = STATE(500),
    [sym_call] = STATE(500),
    [sym_list] = STATE(500),
    [sym_list_comprehension] = STATE(500),
    [sym_dictionary] = STATE(500),
    [sym_dictionary_comprehension] = STATE(500),
    [sym_set] = STATE(500),
    [sym_set_comprehension] = STATE(500),
    [sym_parenthesized_expression] = STATE(500),
    [sym_tuple] = STATE(500),
    [sym_generator_expression] = STATE(500),
    [sym_conditional_expression] = STATE(1789),
    [sym_concatenated_string] = STATE(500),
    [sym_await] = STATE(1789),
    [anon_sym_LPAREN] = ACTIONS(130),
    [anon_sym_print] = ACTIONS(112),
    [anon_sym_exec] = ACTIONS(112),
    [anon_sym_not] = ACTIONS(894),
    [anon_sym_PLUS] = ACTIONS(896),
    [anon_sym_DASH] = ACTIONS(896),
    [anon_sym_TILDE] = ACTIONS(896),
    [anon_sym_lambda] = ACTIONS(898),
    [anon_sym_LBRACK] = ACTIONS(134),
    [sym_ellipsis] = ACTIONS(900),
    [anon_sym_LBRACE] = ACTIONS(122),
    [sym_string] = ACTIONS(902),
    [sym_integer] = ACTIONS(904),
    [sym_float] = ACTIONS(904),
    [sym_identifier] = ACTIONS(904),
    [sym_true] = ACTIONS(904),
    [sym_false] = ACTIONS(904),
    [sym_none] = ACTIONS(904),
    [anon_sym_await] = ACTIONS(906),
    [sym_comment] = ACTIONS(72),
  },
  [1624] = {
    [sym_argument_list] = STATE(291),
    [sym_generator_expression] = STATE(291),
    [sym__newline] = ACTIONS(2953),
    [anon_sym_DOT] = ACTIONS(482),
    [anon_sym_LPAREN] = ACTIONS(484),
    [anon_sym_STAR] = ACTIONS(1881),
    [anon_sym_GT_GT] = ACTIONS(1883),
    [anon_sym_if] = ACTIONS(2953),
    [anon_sym_in] = ACTIONS(2953),
    [anon_sym_EQ] = ACTIONS(2955),
    [anon_sym_AT] = ACTIONS(1887),
    [anon_sym_not] = ACTIONS(2953),
    [anon_sym_and] = ACTIONS(2953),
    [anon_sym_or] = ACTIONS(2953),
    [anon_sym_PLUS] = ACTIONS(1891),
    [anon_sym_DASH] = ACTIONS(1891),
    [anon_sym_SLASH] = ACTIONS(1881),
    [anon_sym_PERCENT] = ACTIONS(1887),
    [anon_sym_SLASH_SLASH] = ACTIONS(1887),
    [anon_sym_STAR_STAR] = ACTIONS(1893),
    [anon_sym_PIPE] = ACTIONS(1895),
    [anon_sym_AMP] = ACTIONS(1897),
    [anon_sym_CARET] = ACTIONS(1899),
    [anon_sym_LT_LT] = ACTIONS(1883),
    [anon_sym_LT] = ACTIONS(2955),
    [anon_sym_LT_EQ] = ACTIONS(2953),
    [anon_sym_EQ_EQ] = ACTIONS(2953),
    [anon_sym_BANG_EQ] = ACTIONS(2953),
    [anon_sym_GT_EQ] = ACTIONS(2953),
    [anon_sym_GT] = ACTIONS(2955),
    [anon_sym_LT_GT] = ACTIONS(2953),
    [anon_sym_is] = ACTIONS(2953),
    [anon_sym_LBRACK] = ACTIONS(510),
    [sym_comment] = ACTIONS(72),
    [sym__semicolon] = ACTIONS(2953),
  },
  [1625] = {
    [anon_sym_if] = ACTIONS(1921),
    [anon_sym_else] = ACTIONS(2642),
    [anon_sym_and] = ACTIONS(1925),
    [anon_sym_or] = ACTIONS(1927),
    [sym_comment] = ACTIONS(72),
  },
  [1626] = {
    [sym__expression] = STATE(1790),
    [sym__primary_expression] = STATE(513),
    [sym_not_operator] = STATE(1790),
    [sym_boolean_operator] = STATE(1790),
    [sym_binary_operator] = STATE(513),
    [sym_unary_operator] = STATE(513),
    [sym_comparison_operator] = STATE(1790),
    [sym_lambda] = STATE(1790),
    [sym_attribute] = STATE(513),
    [sym_subscript] = STATE(513),
    [sym_call] = STATE(513),
    [sym_list] = STATE(513),
    [sym_list_comprehension] = STATE(513),
    [sym_dictionary] = STATE(513),
    [sym_dictionary_comprehension] = STATE(513),
    [sym_set] = STATE(513),
    [sym_set_comprehension] = STATE(513),
    [sym_parenthesized_expression] = STATE(513),
    [sym_tuple] = STATE(513),
    [sym_generator_expression] = STATE(513),
    [sym_conditional_expression] = STATE(1790),
    [sym_concatenated_string] = STATE(513),
    [sym_await] = STATE(1790),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_not] = ACTIONS(914),
    [anon_sym_PLUS] = ACTIONS(916),
    [anon_sym_DASH] = ACTIONS(916),
    [anon_sym_TILDE] = ACTIONS(916),
    [anon_sym_lambda] = ACTIONS(918),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(920),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(922),
    [sym_integer] = ACTIONS(924),
    [sym_float] = ACTIONS(924),
    [sym_identifier] = ACTIONS(924),
    [sym_true] = ACTIONS(924),
    [sym_false] = ACTIONS(924),
    [sym_none] = ACTIONS(924),
    [anon_sym_await] = ACTIONS(926),
    [sym_comment] = ACTIONS(72),
  },
  [1627] = {
    [sym_argument_list] = STATE(251),
    [sym_generator_expression] = STATE(251),
    [anon_sym_DOT] = ACTIONS(422),
    [anon_sym_LPAREN] = ACTIONS(424),
    [anon_sym_STAR] = ACTIONS(1929),
    [anon_sym_GT_GT] = ACTIONS(1931),
    [anon_sym_if] = ACTIONS(2953),
    [anon_sym_else] = ACTIONS(2953),
    [anon_sym_in] = ACTIONS(2953),
    [anon_sym_AT] = ACTIONS(1935),
    [anon_sym_not] = ACTIONS(2953),
    [anon_sym_and] = ACTIONS(2953),
    [anon_sym_or] = ACTIONS(2953),
    [anon_sym_PLUS] = ACTIONS(1939),
    [anon_sym_DASH] = ACTIONS(1939),
    [anon_sym_SLASH] = ACTIONS(1929),
    [anon_sym_PERCENT] = ACTIONS(1935),
    [anon_sym_SLASH_SLASH] = ACTIONS(1935),
    [anon_sym_STAR_STAR] = ACTIONS(1941),
    [anon_sym_PIPE] = ACTIONS(1943),
    [anon_sym_AMP] = ACTIONS(1945),
    [anon_sym_CARET] = ACTIONS(1947),
    [anon_sym_LT_LT] = ACTIONS(1931),
    [anon_sym_LT] = ACTIONS(2955),
    [anon_sym_LT_EQ] = ACTIONS(2953),
    [anon_sym_EQ_EQ] = ACTIONS(2953),
    [anon_sym_BANG_EQ] = ACTIONS(2953),
    [anon_sym_GT_EQ] = ACTIONS(2953),
    [anon_sym_GT] = ACTIONS(2955),
    [anon_sym_LT_GT] = ACTIONS(2953),
    [anon_sym_is] = ACTIONS(2953),
    [anon_sym_LBRACK] = ACTIONS(450),
    [sym_comment] = ACTIONS(72),
  },
  [1628] = {
    [sym__newline] = ACTIONS(4039),
    [anon_sym_DOT] = ACTIONS(4039),
    [anon_sym_LPAREN] = ACTIONS(4039),
    [anon_sym_COMMA] = ACTIONS(4039),
    [anon_sym_STAR] = ACTIONS(4041),
    [anon_sym_GT_GT] = ACTIONS(4041),
    [anon_sym_if] = ACTIONS(4039),
    [anon_sym_COLON] = ACTIONS(4039),
    [anon_sym_in] = ACTIONS(4039),
    [anon_sym_EQ] = ACTIONS(4041),
    [anon_sym_AT] = ACTIONS(4041),
    [anon_sym_not] = ACTIONS(4039),
    [anon_sym_and] = ACTIONS(4039),
    [anon_sym_or] = ACTIONS(4039),
    [anon_sym_PLUS] = ACTIONS(4041),
    [anon_sym_DASH] = ACTIONS(4041),
    [anon_sym_SLASH] = ACTIONS(4041),
    [anon_sym_PERCENT] = ACTIONS(4041),
    [anon_sym_SLASH_SLASH] = ACTIONS(4041),
    [anon_sym_STAR_STAR] = ACTIONS(4041),
    [anon_sym_PIPE] = ACTIONS(4041),
    [anon_sym_AMP] = ACTIONS(4041),
    [anon_sym_CARET] = ACTIONS(4041),
    [anon_sym_LT_LT] = ACTIONS(4041),
    [anon_sym_LT] = ACTIONS(4041),
    [anon_sym_LT_EQ] = ACTIONS(4039),
    [anon_sym_EQ_EQ] = ACTIONS(4039),
    [anon_sym_BANG_EQ] = ACTIONS(4039),
    [anon_sym_GT_EQ] = ACTIONS(4039),
    [anon_sym_GT] = ACTIONS(4041),
    [anon_sym_LT_GT] = ACTIONS(4039),
    [anon_sym_is] = ACTIONS(4039),
    [anon_sym_PLUS_EQ] = ACTIONS(4039),
    [anon_sym_DASH_EQ] = ACTIONS(4039),
    [anon_sym_STAR_EQ] = ACTIONS(4039),
    [anon_sym_SLASH_EQ] = ACTIONS(4039),
    [anon_sym_AT_EQ] = ACTIONS(4039),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(4039),
    [anon_sym_PERCENT_EQ] = ACTIONS(4039),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4039),
    [anon_sym_GT_GT_EQ] = ACTIONS(4039),
    [anon_sym_LT_LT_EQ] = ACTIONS(4039),
    [anon_sym_AMP_EQ] = ACTIONS(4039),
    [anon_sym_CARET_EQ] = ACTIONS(4039),
    [anon_sym_PIPE_EQ] = ACTIONS(4039),
    [anon_sym_LBRACK] = ACTIONS(4039),
    [sym_comment] = ACTIONS(72),
    [sym__semicolon] = ACTIONS(4039),
  },
  [1629] = {
    [sym_list_splat] = STATE(1362),
    [sym_dictionary_splat] = STATE(1362),
    [sym__expression] = STATE(1363),
    [sym__primary_expression] = STATE(215),
    [sym_not_operator] = STATE(1363),
    [sym_boolean_operator] = STATE(1363),
    [sym_binary_operator] = STATE(215),
    [sym_unary_operator] = STATE(215),
    [sym_comparison_operator] = STATE(1363),
    [sym_lambda] = STATE(1363),
    [sym_attribute] = STATE(215),
    [sym_subscript] = STATE(215),
    [sym_call] = STATE(215),
    [sym_keyword_argument] = STATE(1362),
    [sym_list] = STATE(215),
    [sym_list_comprehension] = STATE(215),
    [sym_dictionary] = STATE(215),
    [sym_dictionary_comprehension] = STATE(215),
    [sym_set] = STATE(215),
    [sym_set_comprehension] = STATE(215),
    [sym_parenthesized_expression] = STATE(215),
    [sym_tuple] = STATE(215),
    [sym_generator_expression] = STATE(215),
    [sym_conditional_expression] = STATE(1363),
    [sym_concatenated_string] = STATE(215),
    [sym_await] = STATE(1363),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_STAR] = ACTIONS(936),
    [anon_sym_print] = ACTIONS(938),
    [anon_sym_exec] = ACTIONS(938),
    [anon_sym_not] = ACTIONS(384),
    [anon_sym_PLUS] = ACTIONS(386),
    [anon_sym_DASH] = ACTIONS(386),
    [anon_sym_TILDE] = ACTIONS(386),
    [anon_sym_lambda] = ACTIONS(388),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(390),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(392),
    [sym_integer] = ACTIONS(394),
    [sym_float] = ACTIONS(394),
    [sym_identifier] = ACTIONS(940),
    [sym_true] = ACTIONS(394),
    [sym_false] = ACTIONS(394),
    [sym_none] = ACTIONS(394),
    [anon_sym_await] = ACTIONS(396),
    [sym_comment] = ACTIONS(72),
  },
  [1630] = {
    [anon_sym_COMMA] = ACTIONS(4043),
    [anon_sym_if] = ACTIONS(1674),
    [anon_sym_and] = ACTIONS(1676),
    [anon_sym_or] = ACTIONS(1678),
    [anon_sym_RBRACK] = ACTIONS(4043),
    [sym_comment] = ACTIONS(72),
  },
  [1631] = {
    [anon_sym_COMMA] = ACTIONS(2642),
    [anon_sym_if] = ACTIONS(2002),
    [anon_sym_COLON] = ACTIONS(2642),
    [anon_sym_and] = ACTIONS(2006),
    [anon_sym_or] = ACTIONS(2008),
    [anon_sym_RBRACK] = ACTIONS(2642),
    [sym_comment] = ACTIONS(72),
  },
  [1632] = {
    [sym__expression] = STATE(1791),
    [sym__primary_expression] = STATE(542),
    [sym_not_operator] = STATE(1791),
    [sym_boolean_operator] = STATE(1791),
    [sym_binary_operator] = STATE(542),
    [sym_unary_operator] = STATE(542),
    [sym_comparison_operator] = STATE(1791),
    [sym_lambda] = STATE(1791),
    [sym_attribute] = STATE(542),
    [sym_subscript] = STATE(542),
    [sym_call] = STATE(542),
    [sym_list] = STATE(542),
    [sym_list_comprehension] = STATE(542),
    [sym_dictionary] = STATE(542),
    [sym_dictionary_comprehension] = STATE(542),
    [sym_set] = STATE(542),
    [sym_set_comprehension] = STATE(542),
    [sym_parenthesized_expression] = STATE(542),
    [sym_tuple] = STATE(542),
    [sym_generator_expression] = STATE(542),
    [sym_conditional_expression] = STATE(1791),
    [sym_concatenated_string] = STATE(542),
    [sym_await] = STATE(1791),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_not] = ACTIONS(980),
    [anon_sym_PLUS] = ACTIONS(982),
    [anon_sym_DASH] = ACTIONS(982),
    [anon_sym_TILDE] = ACTIONS(982),
    [anon_sym_lambda] = ACTIONS(984),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(986),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(988),
    [sym_integer] = ACTIONS(990),
    [sym_float] = ACTIONS(990),
    [sym_identifier] = ACTIONS(990),
    [sym_true] = ACTIONS(990),
    [sym_false] = ACTIONS(990),
    [sym_none] = ACTIONS(990),
    [anon_sym_await] = ACTIONS(992),
    [sym_comment] = ACTIONS(72),
  },
  [1633] = {
    [sym__expression] = STATE(1792),
    [sym__primary_expression] = STATE(430),
    [sym_not_operator] = STATE(1792),
    [sym_boolean_operator] = STATE(1792),
    [sym_binary_operator] = STATE(430),
    [sym_unary_operator] = STATE(430),
    [sym_comparison_operator] = STATE(1792),
    [sym_lambda] = STATE(1792),
    [sym_attribute] = STATE(430),
    [sym_subscript] = STATE(430),
    [sym_call] = STATE(430),
    [sym_list] = STATE(430),
    [sym_list_comprehension] = STATE(430),
    [sym_dictionary] = STATE(430),
    [sym_dictionary_comprehension] = STATE(430),
    [sym_set] = STATE(430),
    [sym_set_comprehension] = STATE(430),
    [sym_parenthesized_expression] = STATE(430),
    [sym_tuple] = STATE(430),
    [sym_generator_expression] = STATE(430),
    [sym_conditional_expression] = STATE(1792),
    [sym_concatenated_string] = STATE(430),
    [sym_await] = STATE(1792),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_COMMA] = ACTIONS(4043),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_not] = ACTIONS(760),
    [anon_sym_PLUS] = ACTIONS(762),
    [anon_sym_DASH] = ACTIONS(762),
    [anon_sym_TILDE] = ACTIONS(762),
    [anon_sym_lambda] = ACTIONS(764),
    [anon_sym_LBRACK] = ACTIONS(96),
    [anon_sym_RBRACK] = ACTIONS(4043),
    [sym_ellipsis] = ACTIONS(766),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(768),
    [sym_integer] = ACTIONS(770),
    [sym_float] = ACTIONS(770),
    [sym_identifier] = ACTIONS(770),
    [sym_true] = ACTIONS(770),
    [sym_false] = ACTIONS(770),
    [sym_none] = ACTIONS(770),
    [anon_sym_await] = ACTIONS(772),
    [sym_comment] = ACTIONS(72),
  },
  [1634] = {
    [sym__newline] = ACTIONS(4045),
    [anon_sym_DOT] = ACTIONS(4045),
    [anon_sym_LPAREN] = ACTIONS(4045),
    [anon_sym_COMMA] = ACTIONS(4045),
    [anon_sym_STAR] = ACTIONS(4047),
    [anon_sym_GT_GT] = ACTIONS(4047),
    [anon_sym_if] = ACTIONS(4045),
    [anon_sym_COLON] = ACTIONS(4045),
    [anon_sym_in] = ACTIONS(4045),
    [anon_sym_EQ] = ACTIONS(4047),
    [anon_sym_AT] = ACTIONS(4047),
    [anon_sym_not] = ACTIONS(4045),
    [anon_sym_and] = ACTIONS(4045),
    [anon_sym_or] = ACTIONS(4045),
    [anon_sym_PLUS] = ACTIONS(4047),
    [anon_sym_DASH] = ACTIONS(4047),
    [anon_sym_SLASH] = ACTIONS(4047),
    [anon_sym_PERCENT] = ACTIONS(4047),
    [anon_sym_SLASH_SLASH] = ACTIONS(4047),
    [anon_sym_STAR_STAR] = ACTIONS(4047),
    [anon_sym_PIPE] = ACTIONS(4047),
    [anon_sym_AMP] = ACTIONS(4047),
    [anon_sym_CARET] = ACTIONS(4047),
    [anon_sym_LT_LT] = ACTIONS(4047),
    [anon_sym_LT] = ACTIONS(4047),
    [anon_sym_LT_EQ] = ACTIONS(4045),
    [anon_sym_EQ_EQ] = ACTIONS(4045),
    [anon_sym_BANG_EQ] = ACTIONS(4045),
    [anon_sym_GT_EQ] = ACTIONS(4045),
    [anon_sym_GT] = ACTIONS(4047),
    [anon_sym_LT_GT] = ACTIONS(4045),
    [anon_sym_is] = ACTIONS(4045),
    [anon_sym_PLUS_EQ] = ACTIONS(4045),
    [anon_sym_DASH_EQ] = ACTIONS(4045),
    [anon_sym_STAR_EQ] = ACTIONS(4045),
    [anon_sym_SLASH_EQ] = ACTIONS(4045),
    [anon_sym_AT_EQ] = ACTIONS(4045),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(4045),
    [anon_sym_PERCENT_EQ] = ACTIONS(4045),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4045),
    [anon_sym_GT_GT_EQ] = ACTIONS(4045),
    [anon_sym_LT_LT_EQ] = ACTIONS(4045),
    [anon_sym_AMP_EQ] = ACTIONS(4045),
    [anon_sym_CARET_EQ] = ACTIONS(4045),
    [anon_sym_PIPE_EQ] = ACTIONS(4045),
    [anon_sym_LBRACK] = ACTIONS(4045),
    [sym_comment] = ACTIONS(72),
    [sym__semicolon] = ACTIONS(4045),
  },
  [1635] = {
    [sym__expression] = STATE(1372),
    [sym__primary_expression] = STATE(542),
    [sym_not_operator] = STATE(1372),
    [sym_boolean_operator] = STATE(1372),
    [sym_binary_operator] = STATE(542),
    [sym_unary_operator] = STATE(542),
    [sym_comparison_operator] = STATE(1372),
    [sym_lambda] = STATE(1372),
    [sym_attribute] = STATE(542),
    [sym_subscript] = STATE(542),
    [sym_slice] = STATE(1373),
    [sym_call] = STATE(542),
    [sym_list] = STATE(542),
    [sym_list_comprehension] = STATE(542),
    [sym_dictionary] = STATE(542),
    [sym_dictionary_comprehension] = STATE(542),
    [sym_set] = STATE(542),
    [sym_set_comprehension] = STATE(542),
    [sym_parenthesized_expression] = STATE(542),
    [sym_tuple] = STATE(542),
    [sym_generator_expression] = STATE(542),
    [sym_conditional_expression] = STATE(1372),
    [sym_concatenated_string] = STATE(542),
    [sym_await] = STATE(1372),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_COLON] = ACTIONS(978),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_not] = ACTIONS(980),
    [anon_sym_PLUS] = ACTIONS(982),
    [anon_sym_DASH] = ACTIONS(982),
    [anon_sym_TILDE] = ACTIONS(982),
    [anon_sym_lambda] = ACTIONS(984),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(986),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(988),
    [sym_integer] = ACTIONS(990),
    [sym_float] = ACTIONS(990),
    [sym_identifier] = ACTIONS(990),
    [sym_true] = ACTIONS(990),
    [sym_false] = ACTIONS(990),
    [sym_none] = ACTIONS(990),
    [anon_sym_await] = ACTIONS(992),
    [sym_comment] = ACTIONS(72),
  },
  [1636] = {
    [sym_argument_list] = STATE(251),
    [sym_generator_expression] = STATE(251),
    [anon_sym_DOT] = ACTIONS(422),
    [anon_sym_LPAREN] = ACTIONS(424),
    [anon_sym_COMMA] = ACTIONS(2953),
    [anon_sym_STAR] = ACTIONS(2012),
    [anon_sym_GT_GT] = ACTIONS(2014),
    [anon_sym_if] = ACTIONS(2953),
    [anon_sym_COLON] = ACTIONS(2953),
    [anon_sym_in] = ACTIONS(2953),
    [anon_sym_AT] = ACTIONS(2018),
    [anon_sym_not] = ACTIONS(2953),
    [anon_sym_and] = ACTIONS(2953),
    [anon_sym_or] = ACTIONS(2953),
    [anon_sym_PLUS] = ACTIONS(2022),
    [anon_sym_DASH] = ACTIONS(2022),
    [anon_sym_SLASH] = ACTIONS(2012),
    [anon_sym_PERCENT] = ACTIONS(2018),
    [anon_sym_SLASH_SLASH] = ACTIONS(2018),
    [anon_sym_STAR_STAR] = ACTIONS(2024),
    [anon_sym_PIPE] = ACTIONS(2026),
    [anon_sym_AMP] = ACTIONS(2028),
    [anon_sym_CARET] = ACTIONS(2030),
    [anon_sym_LT_LT] = ACTIONS(2014),
    [anon_sym_LT] = ACTIONS(2955),
    [anon_sym_LT_EQ] = ACTIONS(2953),
    [anon_sym_EQ_EQ] = ACTIONS(2953),
    [anon_sym_BANG_EQ] = ACTIONS(2953),
    [anon_sym_GT_EQ] = ACTIONS(2953),
    [anon_sym_GT] = ACTIONS(2955),
    [anon_sym_LT_GT] = ACTIONS(2953),
    [anon_sym_is] = ACTIONS(2953),
    [anon_sym_LBRACK] = ACTIONS(450),
    [anon_sym_RBRACK] = ACTIONS(2953),
    [sym_comment] = ACTIONS(72),
  },
  [1637] = {
    [aux_sym_dotted_name_repeat1] = STATE(1637),
    [anon_sym_DOT] = ACTIONS(2062),
    [anon_sym_RPAREN] = ACTIONS(2048),
    [anon_sym_COMMA] = ACTIONS(2048),
    [anon_sym_as] = ACTIONS(2048),
    [sym_comment] = ACTIONS(72),
  },
  [1638] = {
    [anon_sym_RPAREN] = ACTIONS(2053),
    [anon_sym_COMMA] = ACTIONS(2053),
    [sym_comment] = ACTIONS(72),
  },
  [1639] = {
    [anon_sym_RPAREN] = ACTIONS(2053),
    [anon_sym_COMMA] = ACTIONS(2053),
    [anon_sym_as] = ACTIONS(3009),
    [sym_comment] = ACTIONS(72),
  },
  [1640] = {
    [sym_aliased_import] = STATE(1638),
    [sym_dotted_name] = STATE(1639),
    [anon_sym_RPAREN] = ACTIONS(2055),
    [sym_identifier] = ACTIONS(2065),
    [sym_comment] = ACTIONS(72),
  },
  [1641] = {
    [aux_sym__import_list_repeat1] = STATE(1641),
    [anon_sym_RPAREN] = ACTIONS(2053),
    [anon_sym_COMMA] = ACTIONS(4049),
    [sym_comment] = ACTIONS(72),
  },
  [1642] = {
    [anon_sym_RPAREN] = ACTIONS(2060),
    [anon_sym_COMMA] = ACTIONS(2060),
    [sym_comment] = ACTIONS(72),
  },
  [1643] = {
    [anon_sym_RPAREN] = ACTIONS(3610),
    [anon_sym_COMMA] = ACTIONS(3610),
    [anon_sym_if] = ACTIONS(1147),
    [anon_sym_and] = ACTIONS(1149),
    [anon_sym_or] = ACTIONS(1151),
    [sym_comment] = ACTIONS(72),
  },
  [1644] = {
    [aux_sym_for_in_clause_repeat1] = STATE(1795),
    [anon_sym_RPAREN] = ACTIONS(4052),
    [anon_sym_COMMA] = ACTIONS(4054),
    [anon_sym_if] = ACTIONS(4052),
    [anon_sym_async] = ACTIONS(4052),
    [anon_sym_for] = ACTIONS(4052),
    [sym_comment] = ACTIONS(72),
  },
  [1645] = {
    [sym__expression_within_for_in_clause] = STATE(1796),
    [sym__expression] = STATE(1405),
    [sym__primary_expression] = STATE(59),
    [sym_not_operator] = STATE(1405),
    [sym_boolean_operator] = STATE(1405),
    [sym_binary_operator] = STATE(59),
    [sym_unary_operator] = STATE(59),
    [sym_comparison_operator] = STATE(1405),
    [sym_lambda] = STATE(1405),
    [sym_lambda_within_for_in_clause] = STATE(1406),
    [sym_attribute] = STATE(59),
    [sym_subscript] = STATE(59),
    [sym_call] = STATE(59),
    [sym_list] = STATE(59),
    [sym_list_comprehension] = STATE(59),
    [sym_dictionary] = STATE(59),
    [sym_dictionary_comprehension] = STATE(59),
    [sym_set] = STATE(59),
    [sym_set_comprehension] = STATE(59),
    [sym_parenthesized_expression] = STATE(59),
    [sym_tuple] = STATE(59),
    [sym_generator_expression] = STATE(59),
    [sym_conditional_expression] = STATE(1405),
    [sym_concatenated_string] = STATE(59),
    [sym_await] = STATE(1405),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_not] = ACTIONS(88),
    [anon_sym_PLUS] = ACTIONS(90),
    [anon_sym_DASH] = ACTIONS(90),
    [anon_sym_TILDE] = ACTIONS(90),
    [anon_sym_lambda] = ACTIONS(3045),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(98),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(102),
    [sym_integer] = ACTIONS(104),
    [sym_float] = ACTIONS(104),
    [sym_identifier] = ACTIONS(104),
    [sym_true] = ACTIONS(104),
    [sym_false] = ACTIONS(104),
    [sym_none] = ACTIONS(104),
    [anon_sym_await] = ACTIONS(106),
    [sym_comment] = ACTIONS(72),
  },
  [1646] = {
    [anon_sym_COLON] = ACTIONS(4056),
    [sym_comment] = ACTIONS(72),
  },
  [1647] = {
    [sym__expression_within_for_in_clause] = STATE(1798),
    [sym__expression] = STATE(1405),
    [sym__primary_expression] = STATE(59),
    [sym_not_operator] = STATE(1405),
    [sym_boolean_operator] = STATE(1405),
    [sym_binary_operator] = STATE(59),
    [sym_unary_operator] = STATE(59),
    [sym_comparison_operator] = STATE(1405),
    [sym_lambda] = STATE(1405),
    [sym_lambda_within_for_in_clause] = STATE(1406),
    [sym_attribute] = STATE(59),
    [sym_subscript] = STATE(59),
    [sym_call] = STATE(59),
    [sym_list] = STATE(59),
    [sym_list_comprehension] = STATE(59),
    [sym_dictionary] = STATE(59),
    [sym_dictionary_comprehension] = STATE(59),
    [sym_set] = STATE(59),
    [sym_set_comprehension] = STATE(59),
    [sym_parenthesized_expression] = STATE(59),
    [sym_tuple] = STATE(59),
    [sym_generator_expression] = STATE(59),
    [sym_conditional_expression] = STATE(1405),
    [sym_concatenated_string] = STATE(59),
    [sym_await] = STATE(1405),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_RPAREN] = ACTIONS(4052),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_if] = ACTIONS(4058),
    [anon_sym_async] = ACTIONS(4058),
    [anon_sym_for] = ACTIONS(4058),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_not] = ACTIONS(88),
    [anon_sym_PLUS] = ACTIONS(90),
    [anon_sym_DASH] = ACTIONS(90),
    [anon_sym_TILDE] = ACTIONS(90),
    [anon_sym_lambda] = ACTIONS(3045),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(98),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(102),
    [sym_integer] = ACTIONS(104),
    [sym_float] = ACTIONS(104),
    [sym_identifier] = ACTIONS(104),
    [sym_true] = ACTIONS(104),
    [sym_false] = ACTIONS(104),
    [sym_none] = ACTIONS(104),
    [anon_sym_await] = ACTIONS(106),
    [sym_comment] = ACTIONS(72),
  },
  [1648] = {
    [aux_sym_for_in_clause_repeat1] = STATE(1799),
    [anon_sym_RPAREN] = ACTIONS(4052),
    [anon_sym_COMMA] = ACTIONS(4054),
    [anon_sym_if] = ACTIONS(4052),
    [anon_sym_async] = ACTIONS(4052),
    [anon_sym_for] = ACTIONS(4052),
    [sym_comment] = ACTIONS(72),
  },
  [1649] = {
    [anon_sym_RPAREN] = ACTIONS(1644),
    [anon_sym_if] = ACTIONS(4060),
    [anon_sym_async] = ACTIONS(1644),
    [anon_sym_for] = ACTIONS(1644),
    [anon_sym_and] = ACTIONS(3053),
    [anon_sym_or] = ACTIONS(3055),
    [sym_comment] = ACTIONS(72),
  },
  [1650] = {
    [sym__expression] = STATE(1800),
    [sym__primary_expression] = STATE(1064),
    [sym_not_operator] = STATE(1800),
    [sym_boolean_operator] = STATE(1800),
    [sym_binary_operator] = STATE(1064),
    [sym_unary_operator] = STATE(1064),
    [sym_comparison_operator] = STATE(1800),
    [sym_lambda] = STATE(1800),
    [sym_attribute] = STATE(1064),
    [sym_subscript] = STATE(1064),
    [sym_call] = STATE(1064),
    [sym_list] = STATE(1064),
    [sym_list_comprehension] = STATE(1064),
    [sym_dictionary] = STATE(1064),
    [sym_dictionary_comprehension] = STATE(1064),
    [sym_set] = STATE(1064),
    [sym_set_comprehension] = STATE(1064),
    [sym_parenthesized_expression] = STATE(1064),
    [sym_tuple] = STATE(1064),
    [sym_generator_expression] = STATE(1064),
    [sym_conditional_expression] = STATE(1800),
    [sym_concatenated_string] = STATE(1064),
    [sym_await] = STATE(1800),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_not] = ACTIONS(2152),
    [anon_sym_PLUS] = ACTIONS(2154),
    [anon_sym_DASH] = ACTIONS(2154),
    [anon_sym_TILDE] = ACTIONS(2154),
    [anon_sym_lambda] = ACTIONS(2156),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(2158),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(2160),
    [sym_integer] = ACTIONS(2162),
    [sym_float] = ACTIONS(2162),
    [sym_identifier] = ACTIONS(2162),
    [sym_true] = ACTIONS(2162),
    [sym_false] = ACTIONS(2162),
    [sym_none] = ACTIONS(2162),
    [anon_sym_await] = ACTIONS(2164),
    [sym_comment] = ACTIONS(72),
  },
  [1651] = {
    [aux_sym_concatenated_string_repeat1] = STATE(1651),
    [anon_sym_DOT] = ACTIONS(1862),
    [anon_sym_LPAREN] = ACTIONS(1862),
    [anon_sym_RPAREN] = ACTIONS(1862),
    [anon_sym_STAR] = ACTIONS(1864),
    [anon_sym_GT_GT] = ACTIONS(1862),
    [anon_sym_if] = ACTIONS(1862),
    [anon_sym_async] = ACTIONS(1862),
    [anon_sym_for] = ACTIONS(1862),
    [anon_sym_in] = ACTIONS(1862),
    [anon_sym_AT] = ACTIONS(1862),
    [anon_sym_not] = ACTIONS(1862),
    [anon_sym_and] = ACTIONS(1862),
    [anon_sym_or] = ACTIONS(1862),
    [anon_sym_PLUS] = ACTIONS(1862),
    [anon_sym_DASH] = ACTIONS(1862),
    [anon_sym_SLASH] = ACTIONS(1864),
    [anon_sym_PERCENT] = ACTIONS(1862),
    [anon_sym_SLASH_SLASH] = ACTIONS(1862),
    [anon_sym_STAR_STAR] = ACTIONS(1862),
    [anon_sym_PIPE] = ACTIONS(1862),
    [anon_sym_AMP] = ACTIONS(1862),
    [anon_sym_CARET] = ACTIONS(1862),
    [anon_sym_LT_LT] = ACTIONS(1862),
    [anon_sym_LT] = ACTIONS(1864),
    [anon_sym_LT_EQ] = ACTIONS(1862),
    [anon_sym_EQ_EQ] = ACTIONS(1862),
    [anon_sym_BANG_EQ] = ACTIONS(1862),
    [anon_sym_GT_EQ] = ACTIONS(1862),
    [anon_sym_GT] = ACTIONS(1864),
    [anon_sym_LT_GT] = ACTIONS(1862),
    [anon_sym_is] = ACTIONS(1862),
    [anon_sym_LBRACK] = ACTIONS(1862),
    [sym_string] = ACTIONS(4062),
    [sym_comment] = ACTIONS(72),
  },
  [1652] = {
    [anon_sym_if] = ACTIONS(1921),
    [anon_sym_else] = ACTIONS(4065),
    [anon_sym_and] = ACTIONS(1925),
    [anon_sym_or] = ACTIONS(1927),
    [sym_comment] = ACTIONS(72),
  },
  [1653] = {
    [anon_sym_RPAREN] = ACTIONS(1953),
    [anon_sym_if] = ACTIONS(1953),
    [anon_sym_async] = ACTIONS(1953),
    [anon_sym_for] = ACTIONS(1953),
    [anon_sym_and] = ACTIONS(3053),
    [anon_sym_or] = ACTIONS(1953),
    [sym_comment] = ACTIONS(72),
  },
  [1654] = {
    [sym_argument_list] = STATE(251),
    [sym_generator_expression] = STATE(251),
    [anon_sym_DOT] = ACTIONS(1980),
    [anon_sym_LPAREN] = ACTIONS(424),
    [anon_sym_RPAREN] = ACTIONS(1980),
    [anon_sym_STAR] = ACTIONS(1982),
    [anon_sym_GT_GT] = ACTIONS(1980),
    [anon_sym_if] = ACTIONS(1980),
    [anon_sym_async] = ACTIONS(1980),
    [anon_sym_for] = ACTIONS(1980),
    [anon_sym_in] = ACTIONS(1980),
    [anon_sym_AT] = ACTIONS(1980),
    [anon_sym_not] = ACTIONS(1980),
    [anon_sym_and] = ACTIONS(1980),
    [anon_sym_or] = ACTIONS(1980),
    [anon_sym_PLUS] = ACTIONS(1980),
    [anon_sym_DASH] = ACTIONS(1980),
    [anon_sym_SLASH] = ACTIONS(1982),
    [anon_sym_PERCENT] = ACTIONS(1980),
    [anon_sym_SLASH_SLASH] = ACTIONS(1980),
    [anon_sym_STAR_STAR] = ACTIONS(3069),
    [anon_sym_PIPE] = ACTIONS(1980),
    [anon_sym_AMP] = ACTIONS(1980),
    [anon_sym_CARET] = ACTIONS(1980),
    [anon_sym_LT_LT] = ACTIONS(1980),
    [anon_sym_LT] = ACTIONS(1982),
    [anon_sym_LT_EQ] = ACTIONS(1980),
    [anon_sym_EQ_EQ] = ACTIONS(1980),
    [anon_sym_BANG_EQ] = ACTIONS(1980),
    [anon_sym_GT_EQ] = ACTIONS(1980),
    [anon_sym_GT] = ACTIONS(1982),
    [anon_sym_LT_GT] = ACTIONS(1980),
    [anon_sym_is] = ACTIONS(1980),
    [anon_sym_LBRACK] = ACTIONS(1980),
    [sym_comment] = ACTIONS(72),
  },
  [1655] = {
    [sym_argument_list] = STATE(251),
    [sym_generator_expression] = STATE(251),
    [anon_sym_DOT] = ACTIONS(1980),
    [anon_sym_LPAREN] = ACTIONS(424),
    [anon_sym_RPAREN] = ACTIONS(1980),
    [anon_sym_STAR] = ACTIONS(3057),
    [anon_sym_GT_GT] = ACTIONS(1980),
    [anon_sym_if] = ACTIONS(1980),
    [anon_sym_async] = ACTIONS(1980),
    [anon_sym_for] = ACTIONS(1980),
    [anon_sym_in] = ACTIONS(1980),
    [anon_sym_AT] = ACTIONS(3063),
    [anon_sym_not] = ACTIONS(1980),
    [anon_sym_and] = ACTIONS(1980),
    [anon_sym_or] = ACTIONS(1980),
    [anon_sym_PLUS] = ACTIONS(3067),
    [anon_sym_DASH] = ACTIONS(3067),
    [anon_sym_SLASH] = ACTIONS(3057),
    [anon_sym_PERCENT] = ACTIONS(3063),
    [anon_sym_SLASH_SLASH] = ACTIONS(3063),
    [anon_sym_STAR_STAR] = ACTIONS(3069),
    [anon_sym_PIPE] = ACTIONS(1980),
    [anon_sym_AMP] = ACTIONS(1980),
    [anon_sym_CARET] = ACTIONS(1980),
    [anon_sym_LT_LT] = ACTIONS(1980),
    [anon_sym_LT] = ACTIONS(1982),
    [anon_sym_LT_EQ] = ACTIONS(1980),
    [anon_sym_EQ_EQ] = ACTIONS(1980),
    [anon_sym_BANG_EQ] = ACTIONS(1980),
    [anon_sym_GT_EQ] = ACTIONS(1980),
    [anon_sym_GT] = ACTIONS(1982),
    [anon_sym_LT_GT] = ACTIONS(1980),
    [anon_sym_is] = ACTIONS(1980),
    [anon_sym_LBRACK] = ACTIONS(1980),
    [sym_comment] = ACTIONS(72),
  },
  [1656] = {
    [sym_argument_list] = STATE(251),
    [sym_generator_expression] = STATE(251),
    [anon_sym_DOT] = ACTIONS(422),
    [anon_sym_LPAREN] = ACTIONS(424),
    [anon_sym_RPAREN] = ACTIONS(1984),
    [anon_sym_STAR] = ACTIONS(3057),
    [anon_sym_GT_GT] = ACTIONS(3059),
    [anon_sym_if] = ACTIONS(1984),
    [anon_sym_async] = ACTIONS(1984),
    [anon_sym_for] = ACTIONS(1984),
    [anon_sym_in] = ACTIONS(1984),
    [anon_sym_AT] = ACTIONS(3063),
    [anon_sym_not] = ACTIONS(1984),
    [anon_sym_and] = ACTIONS(1984),
    [anon_sym_or] = ACTIONS(1984),
    [anon_sym_PLUS] = ACTIONS(3067),
    [anon_sym_DASH] = ACTIONS(3067),
    [anon_sym_SLASH] = ACTIONS(3057),
    [anon_sym_PERCENT] = ACTIONS(3063),
    [anon_sym_SLASH_SLASH] = ACTIONS(3063),
    [anon_sym_STAR_STAR] = ACTIONS(3069),
    [anon_sym_PIPE] = ACTIONS(3071),
    [anon_sym_AMP] = ACTIONS(3073),
    [anon_sym_CARET] = ACTIONS(3075),
    [anon_sym_LT_LT] = ACTIONS(3059),
    [anon_sym_LT] = ACTIONS(1986),
    [anon_sym_LT_EQ] = ACTIONS(1984),
    [anon_sym_EQ_EQ] = ACTIONS(1984),
    [anon_sym_BANG_EQ] = ACTIONS(1984),
    [anon_sym_GT_EQ] = ACTIONS(1984),
    [anon_sym_GT] = ACTIONS(1986),
    [anon_sym_LT_GT] = ACTIONS(1984),
    [anon_sym_is] = ACTIONS(1984),
    [anon_sym_LBRACK] = ACTIONS(450),
    [sym_comment] = ACTIONS(72),
  },
  [1657] = {
    [sym__primary_expression] = STATE(1802),
    [sym_binary_operator] = STATE(1802),
    [sym_unary_operator] = STATE(1802),
    [sym_attribute] = STATE(1802),
    [sym_subscript] = STATE(1802),
    [sym_call] = STATE(1802),
    [sym_list] = STATE(1802),
    [sym_list_comprehension] = STATE(1802),
    [sym_dictionary] = STATE(1802),
    [sym_dictionary_comprehension] = STATE(1802),
    [sym_set] = STATE(1802),
    [sym_set_comprehension] = STATE(1802),
    [sym_parenthesized_expression] = STATE(1802),
    [sym_tuple] = STATE(1802),
    [sym_generator_expression] = STATE(1802),
    [sym_concatenated_string] = STATE(1802),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_PLUS] = ACTIONS(2154),
    [anon_sym_DASH] = ACTIONS(2154),
    [anon_sym_TILDE] = ACTIONS(2154),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(4067),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(2160),
    [sym_integer] = ACTIONS(4069),
    [sym_float] = ACTIONS(4069),
    [sym_identifier] = ACTIONS(4069),
    [sym_true] = ACTIONS(4069),
    [sym_false] = ACTIONS(4069),
    [sym_none] = ACTIONS(4069),
    [sym_comment] = ACTIONS(72),
  },
  [1658] = {
    [sym_argument_list] = STATE(251),
    [sym_generator_expression] = STATE(251),
    [anon_sym_DOT] = ACTIONS(1980),
    [anon_sym_LPAREN] = ACTIONS(424),
    [anon_sym_RPAREN] = ACTIONS(1980),
    [anon_sym_STAR] = ACTIONS(3057),
    [anon_sym_GT_GT] = ACTIONS(1980),
    [anon_sym_if] = ACTIONS(1980),
    [anon_sym_async] = ACTIONS(1980),
    [anon_sym_for] = ACTIONS(1980),
    [anon_sym_in] = ACTIONS(1980),
    [anon_sym_AT] = ACTIONS(3063),
    [anon_sym_not] = ACTIONS(1980),
    [anon_sym_and] = ACTIONS(1980),
    [anon_sym_or] = ACTIONS(1980),
    [anon_sym_PLUS] = ACTIONS(1980),
    [anon_sym_DASH] = ACTIONS(1980),
    [anon_sym_SLASH] = ACTIONS(3057),
    [anon_sym_PERCENT] = ACTIONS(3063),
    [anon_sym_SLASH_SLASH] = ACTIONS(3063),
    [anon_sym_STAR_STAR] = ACTIONS(3069),
    [anon_sym_PIPE] = ACTIONS(1980),
    [anon_sym_AMP] = ACTIONS(1980),
    [anon_sym_CARET] = ACTIONS(1980),
    [anon_sym_LT_LT] = ACTIONS(1980),
    [anon_sym_LT] = ACTIONS(1982),
    [anon_sym_LT_EQ] = ACTIONS(1980),
    [anon_sym_EQ_EQ] = ACTIONS(1980),
    [anon_sym_BANG_EQ] = ACTIONS(1980),
    [anon_sym_GT_EQ] = ACTIONS(1980),
    [anon_sym_GT] = ACTIONS(1982),
    [anon_sym_LT_GT] = ACTIONS(1980),
    [anon_sym_is] = ACTIONS(1980),
    [anon_sym_LBRACK] = ACTIONS(1980),
    [sym_comment] = ACTIONS(72),
  },
  [1659] = {
    [sym_argument_list] = STATE(251),
    [sym_generator_expression] = STATE(251),
    [anon_sym_DOT] = ACTIONS(1980),
    [anon_sym_LPAREN] = ACTIONS(424),
    [anon_sym_RPAREN] = ACTIONS(1980),
    [anon_sym_STAR] = ACTIONS(3057),
    [anon_sym_GT_GT] = ACTIONS(3059),
    [anon_sym_if] = ACTIONS(1980),
    [anon_sym_async] = ACTIONS(1980),
    [anon_sym_for] = ACTIONS(1980),
    [anon_sym_in] = ACTIONS(1980),
    [anon_sym_AT] = ACTIONS(3063),
    [anon_sym_not] = ACTIONS(1980),
    [anon_sym_and] = ACTIONS(1980),
    [anon_sym_or] = ACTIONS(1980),
    [anon_sym_PLUS] = ACTIONS(3067),
    [anon_sym_DASH] = ACTIONS(3067),
    [anon_sym_SLASH] = ACTIONS(3057),
    [anon_sym_PERCENT] = ACTIONS(3063),
    [anon_sym_SLASH_SLASH] = ACTIONS(3063),
    [anon_sym_STAR_STAR] = ACTIONS(3069),
    [anon_sym_PIPE] = ACTIONS(1980),
    [anon_sym_AMP] = ACTIONS(3073),
    [anon_sym_CARET] = ACTIONS(3075),
    [anon_sym_LT_LT] = ACTIONS(3059),
    [anon_sym_LT] = ACTIONS(1982),
    [anon_sym_LT_EQ] = ACTIONS(1980),
    [anon_sym_EQ_EQ] = ACTIONS(1980),
    [anon_sym_BANG_EQ] = ACTIONS(1980),
    [anon_sym_GT_EQ] = ACTIONS(1980),
    [anon_sym_GT] = ACTIONS(1982),
    [anon_sym_LT_GT] = ACTIONS(1980),
    [anon_sym_is] = ACTIONS(1980),
    [anon_sym_LBRACK] = ACTIONS(1980),
    [sym_comment] = ACTIONS(72),
  },
  [1660] = {
    [sym_argument_list] = STATE(251),
    [sym_generator_expression] = STATE(251),
    [anon_sym_DOT] = ACTIONS(1980),
    [anon_sym_LPAREN] = ACTIONS(424),
    [anon_sym_RPAREN] = ACTIONS(1980),
    [anon_sym_STAR] = ACTIONS(3057),
    [anon_sym_GT_GT] = ACTIONS(3059),
    [anon_sym_if] = ACTIONS(1980),
    [anon_sym_async] = ACTIONS(1980),
    [anon_sym_for] = ACTIONS(1980),
    [anon_sym_in] = ACTIONS(1980),
    [anon_sym_AT] = ACTIONS(3063),
    [anon_sym_not] = ACTIONS(1980),
    [anon_sym_and] = ACTIONS(1980),
    [anon_sym_or] = ACTIONS(1980),
    [anon_sym_PLUS] = ACTIONS(3067),
    [anon_sym_DASH] = ACTIONS(3067),
    [anon_sym_SLASH] = ACTIONS(3057),
    [anon_sym_PERCENT] = ACTIONS(3063),
    [anon_sym_SLASH_SLASH] = ACTIONS(3063),
    [anon_sym_STAR_STAR] = ACTIONS(3069),
    [anon_sym_PIPE] = ACTIONS(1980),
    [anon_sym_AMP] = ACTIONS(1980),
    [anon_sym_CARET] = ACTIONS(3075),
    [anon_sym_LT_LT] = ACTIONS(3059),
    [anon_sym_LT] = ACTIONS(1982),
    [anon_sym_LT_EQ] = ACTIONS(1980),
    [anon_sym_EQ_EQ] = ACTIONS(1980),
    [anon_sym_BANG_EQ] = ACTIONS(1980),
    [anon_sym_GT_EQ] = ACTIONS(1980),
    [anon_sym_GT] = ACTIONS(1982),
    [anon_sym_LT_GT] = ACTIONS(1980),
    [anon_sym_is] = ACTIONS(1980),
    [anon_sym_LBRACK] = ACTIONS(1980),
    [sym_comment] = ACTIONS(72),
  },
  [1661] = {
    [sym_argument_list] = STATE(251),
    [sym_generator_expression] = STATE(251),
    [anon_sym_DOT] = ACTIONS(1980),
    [anon_sym_LPAREN] = ACTIONS(424),
    [anon_sym_RPAREN] = ACTIONS(1980),
    [anon_sym_STAR] = ACTIONS(3057),
    [anon_sym_GT_GT] = ACTIONS(3059),
    [anon_sym_if] = ACTIONS(1980),
    [anon_sym_async] = ACTIONS(1980),
    [anon_sym_for] = ACTIONS(1980),
    [anon_sym_in] = ACTIONS(1980),
    [anon_sym_AT] = ACTIONS(3063),
    [anon_sym_not] = ACTIONS(1980),
    [anon_sym_and] = ACTIONS(1980),
    [anon_sym_or] = ACTIONS(1980),
    [anon_sym_PLUS] = ACTIONS(3067),
    [anon_sym_DASH] = ACTIONS(3067),
    [anon_sym_SLASH] = ACTIONS(3057),
    [anon_sym_PERCENT] = ACTIONS(3063),
    [anon_sym_SLASH_SLASH] = ACTIONS(3063),
    [anon_sym_STAR_STAR] = ACTIONS(3069),
    [anon_sym_PIPE] = ACTIONS(1980),
    [anon_sym_AMP] = ACTIONS(1980),
    [anon_sym_CARET] = ACTIONS(1980),
    [anon_sym_LT_LT] = ACTIONS(3059),
    [anon_sym_LT] = ACTIONS(1982),
    [anon_sym_LT_EQ] = ACTIONS(1980),
    [anon_sym_EQ_EQ] = ACTIONS(1980),
    [anon_sym_BANG_EQ] = ACTIONS(1980),
    [anon_sym_GT_EQ] = ACTIONS(1980),
    [anon_sym_GT] = ACTIONS(1982),
    [anon_sym_LT_GT] = ACTIONS(1980),
    [anon_sym_is] = ACTIONS(1980),
    [anon_sym_LBRACK] = ACTIONS(1980),
    [sym_comment] = ACTIONS(72),
  },
  [1662] = {
    [aux_sym_comparison_operator_repeat1] = STATE(1662),
    [anon_sym_RPAREN] = ACTIONS(1984),
    [anon_sym_if] = ACTIONS(1984),
    [anon_sym_async] = ACTIONS(1984),
    [anon_sym_for] = ACTIONS(1984),
    [anon_sym_in] = ACTIONS(4071),
    [anon_sym_not] = ACTIONS(4074),
    [anon_sym_and] = ACTIONS(1984),
    [anon_sym_or] = ACTIONS(1984),
    [anon_sym_LT] = ACTIONS(4077),
    [anon_sym_LT_EQ] = ACTIONS(4071),
    [anon_sym_EQ_EQ] = ACTIONS(4071),
    [anon_sym_BANG_EQ] = ACTIONS(4071),
    [anon_sym_GT_EQ] = ACTIONS(4071),
    [anon_sym_GT] = ACTIONS(4077),
    [anon_sym_LT_GT] = ACTIONS(4071),
    [anon_sym_is] = ACTIONS(4080),
    [sym_comment] = ACTIONS(72),
  },
  [1663] = {
    [anon_sym_DOT] = ACTIONS(4039),
    [anon_sym_LPAREN] = ACTIONS(4039),
    [anon_sym_RPAREN] = ACTIONS(4039),
    [anon_sym_COMMA] = ACTIONS(4039),
    [anon_sym_as] = ACTIONS(4041),
    [anon_sym_STAR] = ACTIONS(4041),
    [anon_sym_GT_GT] = ACTIONS(4039),
    [anon_sym_if] = ACTIONS(4039),
    [anon_sym_COLON] = ACTIONS(4039),
    [anon_sym_else] = ACTIONS(4039),
    [anon_sym_async] = ACTIONS(4039),
    [anon_sym_for] = ACTIONS(4039),
    [anon_sym_in] = ACTIONS(4039),
    [anon_sym_EQ] = ACTIONS(4041),
    [anon_sym_AT] = ACTIONS(4039),
    [anon_sym_not] = ACTIONS(4039),
    [anon_sym_and] = ACTIONS(4039),
    [anon_sym_or] = ACTIONS(4039),
    [anon_sym_PLUS] = ACTIONS(4039),
    [anon_sym_DASH] = ACTIONS(4039),
    [anon_sym_SLASH] = ACTIONS(4041),
    [anon_sym_PERCENT] = ACTIONS(4039),
    [anon_sym_SLASH_SLASH] = ACTIONS(4039),
    [anon_sym_STAR_STAR] = ACTIONS(4039),
    [anon_sym_PIPE] = ACTIONS(4039),
    [anon_sym_AMP] = ACTIONS(4039),
    [anon_sym_CARET] = ACTIONS(4039),
    [anon_sym_LT_LT] = ACTIONS(4039),
    [anon_sym_LT] = ACTIONS(4041),
    [anon_sym_LT_EQ] = ACTIONS(4039),
    [anon_sym_EQ_EQ] = ACTIONS(4039),
    [anon_sym_BANG_EQ] = ACTIONS(4039),
    [anon_sym_GT_EQ] = ACTIONS(4039),
    [anon_sym_GT] = ACTIONS(4041),
    [anon_sym_LT_GT] = ACTIONS(4039),
    [anon_sym_is] = ACTIONS(4039),
    [anon_sym_LBRACK] = ACTIONS(4039),
    [anon_sym_RBRACK] = ACTIONS(4039),
    [anon_sym_RBRACE] = ACTIONS(4039),
    [sym_comment] = ACTIONS(72),
  },
  [1664] = {
    [anon_sym_DOT] = ACTIONS(4045),
    [anon_sym_LPAREN] = ACTIONS(4045),
    [anon_sym_RPAREN] = ACTIONS(4045),
    [anon_sym_COMMA] = ACTIONS(4045),
    [anon_sym_as] = ACTIONS(4047),
    [anon_sym_STAR] = ACTIONS(4047),
    [anon_sym_GT_GT] = ACTIONS(4045),
    [anon_sym_if] = ACTIONS(4045),
    [anon_sym_COLON] = ACTIONS(4045),
    [anon_sym_else] = ACTIONS(4045),
    [anon_sym_async] = ACTIONS(4045),
    [anon_sym_for] = ACTIONS(4045),
    [anon_sym_in] = ACTIONS(4045),
    [anon_sym_EQ] = ACTIONS(4047),
    [anon_sym_AT] = ACTIONS(4045),
    [anon_sym_not] = ACTIONS(4045),
    [anon_sym_and] = ACTIONS(4045),
    [anon_sym_or] = ACTIONS(4045),
    [anon_sym_PLUS] = ACTIONS(4045),
    [anon_sym_DASH] = ACTIONS(4045),
    [anon_sym_SLASH] = ACTIONS(4047),
    [anon_sym_PERCENT] = ACTIONS(4045),
    [anon_sym_SLASH_SLASH] = ACTIONS(4045),
    [anon_sym_STAR_STAR] = ACTIONS(4045),
    [anon_sym_PIPE] = ACTIONS(4045),
    [anon_sym_AMP] = ACTIONS(4045),
    [anon_sym_CARET] = ACTIONS(4045),
    [anon_sym_LT_LT] = ACTIONS(4045),
    [anon_sym_LT] = ACTIONS(4047),
    [anon_sym_LT_EQ] = ACTIONS(4045),
    [anon_sym_EQ_EQ] = ACTIONS(4045),
    [anon_sym_BANG_EQ] = ACTIONS(4045),
    [anon_sym_GT_EQ] = ACTIONS(4045),
    [anon_sym_GT] = ACTIONS(4047),
    [anon_sym_LT_GT] = ACTIONS(4045),
    [anon_sym_is] = ACTIONS(4045),
    [anon_sym_LBRACK] = ACTIONS(4045),
    [anon_sym_RBRACK] = ACTIONS(4045),
    [anon_sym_RBRACE] = ACTIONS(4045),
    [sym_comment] = ACTIONS(72),
  },
  [1665] = {
    [sym__newline] = ACTIONS(4039),
    [anon_sym_DOT] = ACTIONS(4039),
    [anon_sym_from] = ACTIONS(4039),
    [anon_sym_LPAREN] = ACTIONS(4039),
    [anon_sym_COMMA] = ACTIONS(4039),
    [anon_sym_STAR] = ACTIONS(4041),
    [anon_sym_GT_GT] = ACTIONS(4039),
    [anon_sym_if] = ACTIONS(4039),
    [anon_sym_in] = ACTIONS(4039),
    [anon_sym_EQ] = ACTIONS(4041),
    [anon_sym_AT] = ACTIONS(4039),
    [anon_sym_not] = ACTIONS(4039),
    [anon_sym_and] = ACTIONS(4039),
    [anon_sym_or] = ACTIONS(4039),
    [anon_sym_PLUS] = ACTIONS(4039),
    [anon_sym_DASH] = ACTIONS(4039),
    [anon_sym_SLASH] = ACTIONS(4041),
    [anon_sym_PERCENT] = ACTIONS(4039),
    [anon_sym_SLASH_SLASH] = ACTIONS(4039),
    [anon_sym_STAR_STAR] = ACTIONS(4039),
    [anon_sym_PIPE] = ACTIONS(4039),
    [anon_sym_AMP] = ACTIONS(4039),
    [anon_sym_CARET] = ACTIONS(4039),
    [anon_sym_LT_LT] = ACTIONS(4039),
    [anon_sym_LT] = ACTIONS(4041),
    [anon_sym_LT_EQ] = ACTIONS(4039),
    [anon_sym_EQ_EQ] = ACTIONS(4039),
    [anon_sym_BANG_EQ] = ACTIONS(4039),
    [anon_sym_GT_EQ] = ACTIONS(4039),
    [anon_sym_GT] = ACTIONS(4041),
    [anon_sym_LT_GT] = ACTIONS(4039),
    [anon_sym_is] = ACTIONS(4039),
    [anon_sym_LBRACK] = ACTIONS(4039),
    [sym_comment] = ACTIONS(72),
    [sym__semicolon] = ACTIONS(4039),
  },
  [1666] = {
    [sym__newline] = ACTIONS(4045),
    [anon_sym_DOT] = ACTIONS(4045),
    [anon_sym_from] = ACTIONS(4045),
    [anon_sym_LPAREN] = ACTIONS(4045),
    [anon_sym_COMMA] = ACTIONS(4045),
    [anon_sym_STAR] = ACTIONS(4047),
    [anon_sym_GT_GT] = ACTIONS(4045),
    [anon_sym_if] = ACTIONS(4045),
    [anon_sym_in] = ACTIONS(4045),
    [anon_sym_EQ] = ACTIONS(4047),
    [anon_sym_AT] = ACTIONS(4045),
    [anon_sym_not] = ACTIONS(4045),
    [anon_sym_and] = ACTIONS(4045),
    [anon_sym_or] = ACTIONS(4045),
    [anon_sym_PLUS] = ACTIONS(4045),
    [anon_sym_DASH] = ACTIONS(4045),
    [anon_sym_SLASH] = ACTIONS(4047),
    [anon_sym_PERCENT] = ACTIONS(4045),
    [anon_sym_SLASH_SLASH] = ACTIONS(4045),
    [anon_sym_STAR_STAR] = ACTIONS(4045),
    [anon_sym_PIPE] = ACTIONS(4045),
    [anon_sym_AMP] = ACTIONS(4045),
    [anon_sym_CARET] = ACTIONS(4045),
    [anon_sym_LT_LT] = ACTIONS(4045),
    [anon_sym_LT] = ACTIONS(4047),
    [anon_sym_LT_EQ] = ACTIONS(4045),
    [anon_sym_EQ_EQ] = ACTIONS(4045),
    [anon_sym_BANG_EQ] = ACTIONS(4045),
    [anon_sym_GT_EQ] = ACTIONS(4045),
    [anon_sym_GT] = ACTIONS(4047),
    [anon_sym_LT_GT] = ACTIONS(4045),
    [anon_sym_is] = ACTIONS(4045),
    [anon_sym_LBRACK] = ACTIONS(4045),
    [sym_comment] = ACTIONS(72),
    [sym__semicolon] = ACTIONS(4045),
  },
  [1667] = {
    [sym__newline] = ACTIONS(3610),
    [anon_sym_if] = ACTIONS(1331),
    [anon_sym_and] = ACTIONS(1333),
    [anon_sym_or] = ACTIONS(1335),
    [sym_comment] = ACTIONS(72),
    [sym__semicolon] = ACTIONS(3610),
  },
  [1668] = {
    [ts_builtin_sym_end] = ACTIONS(2319),
    [anon_sym_import] = ACTIONS(2321),
    [anon_sym_from] = ACTIONS(2321),
    [anon_sym_LPAREN] = ACTIONS(2319),
    [anon_sym_print] = ACTIONS(2321),
    [anon_sym_assert] = ACTIONS(2321),
    [anon_sym_return] = ACTIONS(2321),
    [anon_sym_del] = ACTIONS(2321),
    [anon_sym_raise] = ACTIONS(2321),
    [sym_pass_statement] = ACTIONS(2321),
    [sym_break_statement] = ACTIONS(2321),
    [sym_continue_statement] = ACTIONS(2321),
    [anon_sym_if] = ACTIONS(2321),
    [anon_sym_elif] = ACTIONS(2321),
    [anon_sym_else] = ACTIONS(2321),
    [anon_sym_async] = ACTIONS(2321),
    [anon_sym_for] = ACTIONS(2321),
    [anon_sym_while] = ACTIONS(2321),
    [anon_sym_try] = ACTIONS(2321),
    [anon_sym_with] = ACTIONS(2321),
    [anon_sym_def] = ACTIONS(2321),
    [anon_sym_global] = ACTIONS(2321),
    [anon_sym_nonlocal] = ACTIONS(2321),
    [anon_sym_exec] = ACTIONS(2321),
    [anon_sym_class] = ACTIONS(2321),
    [anon_sym_AT] = ACTIONS(2319),
    [anon_sym_not] = ACTIONS(2321),
    [anon_sym_PLUS] = ACTIONS(2319),
    [anon_sym_DASH] = ACTIONS(2319),
    [anon_sym_TILDE] = ACTIONS(2319),
    [anon_sym_lambda] = ACTIONS(2321),
    [anon_sym_yield] = ACTIONS(2321),
    [anon_sym_LBRACK] = ACTIONS(2319),
    [sym_ellipsis] = ACTIONS(2319),
    [anon_sym_LBRACE] = ACTIONS(2319),
    [sym_string] = ACTIONS(2319),
    [sym_integer] = ACTIONS(2321),
    [sym_float] = ACTIONS(2321),
    [sym_identifier] = ACTIONS(2321),
    [sym_true] = ACTIONS(2321),
    [sym_false] = ACTIONS(2321),
    [sym_none] = ACTIONS(2321),
    [anon_sym_await] = ACTIONS(2321),
    [sym_comment] = ACTIONS(72),
  },
  [1669] = {
    [sym__simple_statements] = STATE(1803),
    [sym_import_statement] = STATE(714),
    [sym_import_from_statement] = STATE(714),
    [sym_print_statement] = STATE(714),
    [sym_assert_statement] = STATE(714),
    [sym_expression_statement] = STATE(714),
    [sym_return_statement] = STATE(714),
    [sym_delete_statement] = STATE(714),
    [sym_raise_statement] = STATE(714),
    [sym_global_statement] = STATE(714),
    [sym_nonlocal_statement] = STATE(714),
    [sym_exec_statement] = STATE(714),
    [sym__suite] = STATE(1803),
    [sym_expression_list] = STATE(32),
    [sym__expression] = STATE(33),
    [sym__primary_expression] = STATE(34),
    [sym_not_operator] = STATE(33),
    [sym_boolean_operator] = STATE(33),
    [sym_binary_operator] = STATE(34),
    [sym_unary_operator] = STATE(34),
    [sym_comparison_operator] = STATE(33),
    [sym_lambda] = STATE(33),
    [sym_assignment] = STATE(35),
    [sym_augmented_assignment] = STATE(35),
    [sym_yield] = STATE(35),
    [sym_attribute] = STATE(34),
    [sym_subscript] = STATE(34),
    [sym_call] = STATE(34),
    [sym_list] = STATE(34),
    [sym_list_comprehension] = STATE(34),
    [sym_dictionary] = STATE(34),
    [sym_dictionary_comprehension] = STATE(34),
    [sym_set] = STATE(34),
    [sym_set_comprehension] = STATE(34),
    [sym_parenthesized_expression] = STATE(34),
    [sym_tuple] = STATE(34),
    [sym_generator_expression] = STATE(34),
    [sym_conditional_expression] = STATE(33),
    [sym_concatenated_string] = STATE(34),
    [sym_await] = STATE(33),
    [sym__indent] = ACTIONS(1416),
    [anon_sym_import] = ACTIONS(10),
    [anon_sym_from] = ACTIONS(12),
    [anon_sym_LPAREN] = ACTIONS(14),
    [anon_sym_print] = ACTIONS(16),
    [anon_sym_assert] = ACTIONS(18),
    [anon_sym_return] = ACTIONS(20),
    [anon_sym_del] = ACTIONS(22),
    [anon_sym_raise] = ACTIONS(24),
    [sym_pass_statement] = ACTIONS(1418),
    [sym_break_statement] = ACTIONS(1418),
    [sym_continue_statement] = ACTIONS(1418),
    [anon_sym_global] = ACTIONS(42),
    [anon_sym_nonlocal] = ACTIONS(44),
    [anon_sym_exec] = ACTIONS(46),
    [anon_sym_not] = ACTIONS(52),
    [anon_sym_PLUS] = ACTIONS(54),
    [anon_sym_DASH] = ACTIONS(54),
    [anon_sym_TILDE] = ACTIONS(54),
    [anon_sym_lambda] = ACTIONS(56),
    [anon_sym_yield] = ACTIONS(58),
    [anon_sym_LBRACK] = ACTIONS(60),
    [sym_ellipsis] = ACTIONS(62),
    [anon_sym_LBRACE] = ACTIONS(64),
    [sym_string] = ACTIONS(66),
    [sym_integer] = ACTIONS(68),
    [sym_float] = ACTIONS(68),
    [sym_identifier] = ACTIONS(68),
    [sym_true] = ACTIONS(68),
    [sym_false] = ACTIONS(68),
    [sym_none] = ACTIONS(68),
    [anon_sym_await] = ACTIONS(70),
    [sym_comment] = ACTIONS(72),
  },
  [1670] = {
    [ts_builtin_sym_end] = ACTIONS(4083),
    [anon_sym_import] = ACTIONS(4085),
    [anon_sym_from] = ACTIONS(4085),
    [anon_sym_LPAREN] = ACTIONS(4083),
    [anon_sym_print] = ACTIONS(4085),
    [anon_sym_assert] = ACTIONS(4085),
    [anon_sym_return] = ACTIONS(4085),
    [anon_sym_del] = ACTIONS(4085),
    [anon_sym_raise] = ACTIONS(4085),
    [sym_pass_statement] = ACTIONS(4085),
    [sym_break_statement] = ACTIONS(4085),
    [sym_continue_statement] = ACTIONS(4085),
    [anon_sym_if] = ACTIONS(4085),
    [anon_sym_async] = ACTIONS(4085),
    [anon_sym_for] = ACTIONS(4085),
    [anon_sym_while] = ACTIONS(4085),
    [anon_sym_try] = ACTIONS(4085),
    [anon_sym_with] = ACTIONS(4085),
    [anon_sym_def] = ACTIONS(4085),
    [anon_sym_global] = ACTIONS(4085),
    [anon_sym_nonlocal] = ACTIONS(4085),
    [anon_sym_exec] = ACTIONS(4085),
    [anon_sym_class] = ACTIONS(4085),
    [anon_sym_AT] = ACTIONS(4083),
    [anon_sym_not] = ACTIONS(4085),
    [anon_sym_PLUS] = ACTIONS(4083),
    [anon_sym_DASH] = ACTIONS(4083),
    [anon_sym_TILDE] = ACTIONS(4083),
    [anon_sym_lambda] = ACTIONS(4085),
    [anon_sym_yield] = ACTIONS(4085),
    [anon_sym_LBRACK] = ACTIONS(4083),
    [sym_ellipsis] = ACTIONS(4083),
    [anon_sym_LBRACE] = ACTIONS(4083),
    [sym_string] = ACTIONS(4083),
    [sym_integer] = ACTIONS(4085),
    [sym_float] = ACTIONS(4085),
    [sym_identifier] = ACTIONS(4085),
    [sym_true] = ACTIONS(4085),
    [sym_false] = ACTIONS(4085),
    [sym_none] = ACTIONS(4085),
    [anon_sym_await] = ACTIONS(4085),
    [sym_comment] = ACTIONS(72),
  },
  [1671] = {
    [sym_else_clause] = STATE(1804),
    [ts_builtin_sym_end] = ACTIONS(4087),
    [anon_sym_import] = ACTIONS(4089),
    [anon_sym_from] = ACTIONS(4089),
    [anon_sym_LPAREN] = ACTIONS(4087),
    [anon_sym_print] = ACTIONS(4089),
    [anon_sym_assert] = ACTIONS(4089),
    [anon_sym_return] = ACTIONS(4089),
    [anon_sym_del] = ACTIONS(4089),
    [anon_sym_raise] = ACTIONS(4089),
    [sym_pass_statement] = ACTIONS(4089),
    [sym_break_statement] = ACTIONS(4089),
    [sym_continue_statement] = ACTIONS(4089),
    [anon_sym_if] = ACTIONS(4089),
    [anon_sym_else] = ACTIONS(2340),
    [anon_sym_async] = ACTIONS(4089),
    [anon_sym_for] = ACTIONS(4089),
    [anon_sym_while] = ACTIONS(4089),
    [anon_sym_try] = ACTIONS(4089),
    [anon_sym_with] = ACTIONS(4089),
    [anon_sym_def] = ACTIONS(4089),
    [anon_sym_global] = ACTIONS(4089),
    [anon_sym_nonlocal] = ACTIONS(4089),
    [anon_sym_exec] = ACTIONS(4089),
    [anon_sym_class] = ACTIONS(4089),
    [anon_sym_AT] = ACTIONS(4087),
    [anon_sym_not] = ACTIONS(4089),
    [anon_sym_PLUS] = ACTIONS(4087),
    [anon_sym_DASH] = ACTIONS(4087),
    [anon_sym_TILDE] = ACTIONS(4087),
    [anon_sym_lambda] = ACTIONS(4089),
    [anon_sym_yield] = ACTIONS(4089),
    [anon_sym_LBRACK] = ACTIONS(4087),
    [sym_ellipsis] = ACTIONS(4087),
    [anon_sym_LBRACE] = ACTIONS(4087),
    [sym_string] = ACTIONS(4087),
    [sym_integer] = ACTIONS(4089),
    [sym_float] = ACTIONS(4089),
    [sym_identifier] = ACTIONS(4089),
    [sym_true] = ACTIONS(4089),
    [sym_false] = ACTIONS(4089),
    [sym_none] = ACTIONS(4089),
    [anon_sym_await] = ACTIONS(4089),
    [sym_comment] = ACTIONS(72),
  },
  [1672] = {
    [sym__simple_statements] = STATE(1805),
    [sym_import_statement] = STATE(10),
    [sym_import_from_statement] = STATE(10),
    [sym_print_statement] = STATE(10),
    [sym_assert_statement] = STATE(10),
    [sym_expression_statement] = STATE(10),
    [sym_return_statement] = STATE(10),
    [sym_delete_statement] = STATE(10),
    [sym_raise_statement] = STATE(10),
    [sym_global_statement] = STATE(10),
    [sym_nonlocal_statement] = STATE(10),
    [sym_exec_statement] = STATE(10),
    [sym__suite] = STATE(1805),
    [sym_expression_list] = STATE(32),
    [sym__expression] = STATE(33),
    [sym__primary_expression] = STATE(34),
    [sym_not_operator] = STATE(33),
    [sym_boolean_operator] = STATE(33),
    [sym_binary_operator] = STATE(34),
    [sym_unary_operator] = STATE(34),
    [sym_comparison_operator] = STATE(33),
    [sym_lambda] = STATE(33),
    [sym_assignment] = STATE(35),
    [sym_augmented_assignment] = STATE(35),
    [sym_yield] = STATE(35),
    [sym_attribute] = STATE(34),
    [sym_subscript] = STATE(34),
    [sym_call] = STATE(34),
    [sym_list] = STATE(34),
    [sym_list_comprehension] = STATE(34),
    [sym_dictionary] = STATE(34),
    [sym_dictionary_comprehension] = STATE(34),
    [sym_set] = STATE(34),
    [sym_set_comprehension] = STATE(34),
    [sym_parenthesized_expression] = STATE(34),
    [sym_tuple] = STATE(34),
    [sym_generator_expression] = STATE(34),
    [sym_conditional_expression] = STATE(33),
    [sym_concatenated_string] = STATE(34),
    [sym_await] = STATE(33),
    [sym__indent] = ACTIONS(1528),
    [anon_sym_import] = ACTIONS(10),
    [anon_sym_from] = ACTIONS(12),
    [anon_sym_LPAREN] = ACTIONS(14),
    [anon_sym_print] = ACTIONS(16),
    [anon_sym_assert] = ACTIONS(18),
    [anon_sym_return] = ACTIONS(20),
    [anon_sym_del] = ACTIONS(22),
    [anon_sym_raise] = ACTIONS(24),
    [sym_pass_statement] = ACTIONS(26),
    [sym_break_statement] = ACTIONS(26),
    [sym_continue_statement] = ACTIONS(26),
    [anon_sym_global] = ACTIONS(42),
    [anon_sym_nonlocal] = ACTIONS(44),
    [anon_sym_exec] = ACTIONS(46),
    [anon_sym_not] = ACTIONS(52),
    [anon_sym_PLUS] = ACTIONS(54),
    [anon_sym_DASH] = ACTIONS(54),
    [anon_sym_TILDE] = ACTIONS(54),
    [anon_sym_lambda] = ACTIONS(56),
    [anon_sym_yield] = ACTIONS(58),
    [anon_sym_LBRACK] = ACTIONS(60),
    [sym_ellipsis] = ACTIONS(62),
    [anon_sym_LBRACE] = ACTIONS(64),
    [sym_string] = ACTIONS(66),
    [sym_integer] = ACTIONS(68),
    [sym_float] = ACTIONS(68),
    [sym_identifier] = ACTIONS(68),
    [sym_true] = ACTIONS(68),
    [sym_false] = ACTIONS(68),
    [sym_none] = ACTIONS(68),
    [anon_sym_await] = ACTIONS(70),
    [sym_comment] = ACTIONS(72),
  },
  [1673] = {
    [ts_builtin_sym_end] = ACTIONS(4087),
    [anon_sym_import] = ACTIONS(4089),
    [anon_sym_from] = ACTIONS(4089),
    [anon_sym_LPAREN] = ACTIONS(4087),
    [anon_sym_print] = ACTIONS(4089),
    [anon_sym_assert] = ACTIONS(4089),
    [anon_sym_return] = ACTIONS(4089),
    [anon_sym_del] = ACTIONS(4089),
    [anon_sym_raise] = ACTIONS(4089),
    [sym_pass_statement] = ACTIONS(4089),
    [sym_break_statement] = ACTIONS(4089),
    [sym_continue_statement] = ACTIONS(4089),
    [anon_sym_if] = ACTIONS(4089),
    [anon_sym_async] = ACTIONS(4089),
    [anon_sym_for] = ACTIONS(4089),
    [anon_sym_while] = ACTIONS(4089),
    [anon_sym_try] = ACTIONS(4089),
    [anon_sym_with] = ACTIONS(4089),
    [anon_sym_def] = ACTIONS(4089),
    [anon_sym_global] = ACTIONS(4089),
    [anon_sym_nonlocal] = ACTIONS(4089),
    [anon_sym_exec] = ACTIONS(4089),
    [anon_sym_class] = ACTIONS(4089),
    [anon_sym_AT] = ACTIONS(4087),
    [anon_sym_not] = ACTIONS(4089),
    [anon_sym_PLUS] = ACTIONS(4087),
    [anon_sym_DASH] = ACTIONS(4087),
    [anon_sym_TILDE] = ACTIONS(4087),
    [anon_sym_lambda] = ACTIONS(4089),
    [anon_sym_yield] = ACTIONS(4089),
    [anon_sym_LBRACK] = ACTIONS(4087),
    [sym_ellipsis] = ACTIONS(4087),
    [anon_sym_LBRACE] = ACTIONS(4087),
    [sym_string] = ACTIONS(4087),
    [sym_integer] = ACTIONS(4089),
    [sym_float] = ACTIONS(4089),
    [sym_identifier] = ACTIONS(4089),
    [sym_true] = ACTIONS(4089),
    [sym_false] = ACTIONS(4089),
    [sym_none] = ACTIONS(4089),
    [anon_sym_await] = ACTIONS(4089),
    [sym_comment] = ACTIONS(72),
  },
  [1674] = {
    [sym__expression] = STATE(1455),
    [sym__primary_expression] = STATE(410),
    [sym_not_operator] = STATE(1455),
    [sym_boolean_operator] = STATE(1455),
    [sym_binary_operator] = STATE(410),
    [sym_unary_operator] = STATE(410),
    [sym_comparison_operator] = STATE(1455),
    [sym_lambda] = STATE(1455),
    [sym_attribute] = STATE(410),
    [sym_subscript] = STATE(410),
    [sym_call] = STATE(410),
    [sym_list] = STATE(410),
    [sym_list_comprehension] = STATE(410),
    [sym_dictionary] = STATE(410),
    [sym_dictionary_comprehension] = STATE(410),
    [sym_set] = STATE(410),
    [sym_set_comprehension] = STATE(410),
    [sym_parenthesized_expression] = STATE(410),
    [sym_tuple] = STATE(410),
    [sym_generator_expression] = STATE(410),
    [sym_conditional_expression] = STATE(1455),
    [sym_concatenated_string] = STATE(410),
    [sym_await] = STATE(1455),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_not] = ACTIONS(726),
    [anon_sym_PLUS] = ACTIONS(728),
    [anon_sym_DASH] = ACTIONS(728),
    [anon_sym_TILDE] = ACTIONS(728),
    [anon_sym_lambda] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(732),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(734),
    [sym_integer] = ACTIONS(736),
    [sym_float] = ACTIONS(736),
    [sym_identifier] = ACTIONS(736),
    [sym_true] = ACTIONS(736),
    [sym_false] = ACTIONS(736),
    [sym_none] = ACTIONS(736),
    [anon_sym_await] = ACTIONS(738),
    [sym_comment] = ACTIONS(72),
  },
  [1675] = {
    [ts_builtin_sym_end] = ACTIONS(2319),
    [anon_sym_import] = ACTIONS(2321),
    [anon_sym_from] = ACTIONS(2321),
    [anon_sym_LPAREN] = ACTIONS(2319),
    [anon_sym_print] = ACTIONS(2321),
    [anon_sym_assert] = ACTIONS(2321),
    [anon_sym_return] = ACTIONS(2321),
    [anon_sym_del] = ACTIONS(2321),
    [anon_sym_raise] = ACTIONS(2321),
    [sym_pass_statement] = ACTIONS(2321),
    [sym_break_statement] = ACTIONS(2321),
    [sym_continue_statement] = ACTIONS(2321),
    [anon_sym_if] = ACTIONS(2321),
    [anon_sym_else] = ACTIONS(2321),
    [anon_sym_async] = ACTIONS(2321),
    [anon_sym_for] = ACTIONS(2321),
    [anon_sym_while] = ACTIONS(2321),
    [anon_sym_try] = ACTIONS(2321),
    [anon_sym_with] = ACTIONS(2321),
    [anon_sym_def] = ACTIONS(2321),
    [anon_sym_global] = ACTIONS(2321),
    [anon_sym_nonlocal] = ACTIONS(2321),
    [anon_sym_exec] = ACTIONS(2321),
    [anon_sym_class] = ACTIONS(2321),
    [anon_sym_AT] = ACTIONS(2319),
    [anon_sym_not] = ACTIONS(2321),
    [anon_sym_PLUS] = ACTIONS(2319),
    [anon_sym_DASH] = ACTIONS(2319),
    [anon_sym_TILDE] = ACTIONS(2319),
    [anon_sym_lambda] = ACTIONS(2321),
    [anon_sym_yield] = ACTIONS(2321),
    [anon_sym_LBRACK] = ACTIONS(2319),
    [sym_ellipsis] = ACTIONS(2319),
    [anon_sym_LBRACE] = ACTIONS(2319),
    [sym_string] = ACTIONS(2319),
    [sym_integer] = ACTIONS(2321),
    [sym_float] = ACTIONS(2321),
    [sym_identifier] = ACTIONS(2321),
    [sym_true] = ACTIONS(2321),
    [sym_false] = ACTIONS(2321),
    [sym_none] = ACTIONS(2321),
    [anon_sym_await] = ACTIONS(2321),
    [sym_comment] = ACTIONS(72),
  },
  [1676] = {
    [sym__dedent] = ACTIONS(2319),
    [anon_sym_import] = ACTIONS(2321),
    [anon_sym_from] = ACTIONS(2321),
    [anon_sym_LPAREN] = ACTIONS(2319),
    [anon_sym_print] = ACTIONS(2321),
    [anon_sym_assert] = ACTIONS(2321),
    [anon_sym_return] = ACTIONS(2321),
    [anon_sym_del] = ACTIONS(2321),
    [anon_sym_raise] = ACTIONS(2321),
    [sym_pass_statement] = ACTIONS(2321),
    [sym_break_statement] = ACTIONS(2321),
    [sym_continue_statement] = ACTIONS(2321),
    [anon_sym_if] = ACTIONS(2321),
    [anon_sym_async] = ACTIONS(2321),
    [anon_sym_for] = ACTIONS(2321),
    [anon_sym_while] = ACTIONS(2321),
    [anon_sym_try] = ACTIONS(2321),
    [anon_sym_with] = ACTIONS(2321),
    [anon_sym_def] = ACTIONS(2321),
    [anon_sym_global] = ACTIONS(2321),
    [anon_sym_nonlocal] = ACTIONS(2321),
    [anon_sym_exec] = ACTIONS(2321),
    [anon_sym_class] = ACTIONS(2321),
    [anon_sym_AT] = ACTIONS(2319),
    [anon_sym_not] = ACTIONS(2321),
    [anon_sym_PLUS] = ACTIONS(2319),
    [anon_sym_DASH] = ACTIONS(2319),
    [anon_sym_TILDE] = ACTIONS(2319),
    [anon_sym_lambda] = ACTIONS(2321),
    [anon_sym_yield] = ACTIONS(2321),
    [anon_sym_LBRACK] = ACTIONS(2319),
    [sym_ellipsis] = ACTIONS(2319),
    [anon_sym_LBRACE] = ACTIONS(2319),
    [sym_string] = ACTIONS(2319),
    [sym_integer] = ACTIONS(2321),
    [sym_float] = ACTIONS(2321),
    [sym_identifier] = ACTIONS(2321),
    [sym_true] = ACTIONS(2321),
    [sym_false] = ACTIONS(2321),
    [sym_none] = ACTIONS(2321),
    [anon_sym_await] = ACTIONS(2321),
    [sym_comment] = ACTIONS(72),
  },
  [1677] = {
    [sym__statement] = STATE(1807),
    [sym__simple_statements] = STATE(1807),
    [sym_import_statement] = STATE(746),
    [sym_import_from_statement] = STATE(746),
    [sym_print_statement] = STATE(746),
    [sym_assert_statement] = STATE(746),
    [sym_expression_statement] = STATE(746),
    [sym_return_statement] = STATE(746),
    [sym_delete_statement] = STATE(746),
    [sym_raise_statement] = STATE(746),
    [sym_if_statement] = STATE(1807),
    [sym_for_statement] = STATE(1807),
    [sym_while_statement] = STATE(1807),
    [sym_try_statement] = STATE(1807),
    [sym_with_statement] = STATE(1807),
    [sym_function_definition] = STATE(1807),
    [sym_global_statement] = STATE(746),
    [sym_nonlocal_statement] = STATE(746),
    [sym_exec_statement] = STATE(746),
    [sym_class_definition] = STATE(1807),
    [sym_decorated_definition] = STATE(1807),
    [sym_decorator] = STATE(756),
    [sym_expression_list] = STATE(32),
    [sym__expression] = STATE(33),
    [sym__primary_expression] = STATE(34),
    [sym_not_operator] = STATE(33),
    [sym_boolean_operator] = STATE(33),
    [sym_binary_operator] = STATE(34),
    [sym_unary_operator] = STATE(34),
    [sym_comparison_operator] = STATE(33),
    [sym_lambda] = STATE(33),
    [sym_assignment] = STATE(35),
    [sym_augmented_assignment] = STATE(35),
    [sym_yield] = STATE(35),
    [sym_attribute] = STATE(34),
    [sym_subscript] = STATE(34),
    [sym_call] = STATE(34),
    [sym_list] = STATE(34),
    [sym_list_comprehension] = STATE(34),
    [sym_dictionary] = STATE(34),
    [sym_dictionary_comprehension] = STATE(34),
    [sym_set] = STATE(34),
    [sym_set_comprehension] = STATE(34),
    [sym_parenthesized_expression] = STATE(34),
    [sym_tuple] = STATE(34),
    [sym_generator_expression] = STATE(34),
    [sym_conditional_expression] = STATE(33),
    [sym_concatenated_string] = STATE(34),
    [sym_await] = STATE(33),
    [aux_sym_module_repeat1] = STATE(1807),
    [aux_sym_decorated_definition_repeat1] = STATE(756),
    [sym__dedent] = ACTIONS(4091),
    [anon_sym_import] = ACTIONS(10),
    [anon_sym_from] = ACTIONS(12),
    [anon_sym_LPAREN] = ACTIONS(14),
    [anon_sym_print] = ACTIONS(16),
    [anon_sym_assert] = ACTIONS(18),
    [anon_sym_return] = ACTIONS(20),
    [anon_sym_del] = ACTIONS(22),
    [anon_sym_raise] = ACTIONS(24),
    [sym_pass_statement] = ACTIONS(1498),
    [sym_break_statement] = ACTIONS(1498),
    [sym_continue_statement] = ACTIONS(1498),
    [anon_sym_if] = ACTIONS(1500),
    [anon_sym_async] = ACTIONS(1502),
    [anon_sym_for] = ACTIONS(1504),
    [anon_sym_while] = ACTIONS(1506),
    [anon_sym_try] = ACTIONS(1508),
    [anon_sym_with] = ACTIONS(1510),
    [anon_sym_def] = ACTIONS(1512),
    [anon_sym_global] = ACTIONS(42),
    [anon_sym_nonlocal] = ACTIONS(44),
    [anon_sym_exec] = ACTIONS(46),
    [anon_sym_class] = ACTIONS(1514),
    [anon_sym_AT] = ACTIONS(50),
    [anon_sym_not] = ACTIONS(52),
    [anon_sym_PLUS] = ACTIONS(54),
    [anon_sym_DASH] = ACTIONS(54),
    [anon_sym_TILDE] = ACTIONS(54),
    [anon_sym_lambda] = ACTIONS(56),
    [anon_sym_yield] = ACTIONS(58),
    [anon_sym_LBRACK] = ACTIONS(60),
    [sym_ellipsis] = ACTIONS(62),
    [anon_sym_LBRACE] = ACTIONS(64),
    [sym_string] = ACTIONS(66),
    [sym_integer] = ACTIONS(68),
    [sym_float] = ACTIONS(68),
    [sym_identifier] = ACTIONS(68),
    [sym_true] = ACTIONS(68),
    [sym_false] = ACTIONS(68),
    [sym_none] = ACTIONS(68),
    [anon_sym_await] = ACTIONS(70),
    [sym_comment] = ACTIONS(72),
  },
  [1678] = {
    [aux_sym__simple_statements_repeat1] = STATE(1810),
    [sym__newline] = ACTIONS(4093),
    [sym_comment] = ACTIONS(72),
    [sym__semicolon] = ACTIONS(4095),
  },
  [1679] = {
    [sym_elif_clause] = STATE(1814),
    [sym_else_clause] = STATE(1813),
    [aux_sym_if_statement_repeat1] = STATE(1814),
    [sym__dedent] = ACTIONS(2334),
    [anon_sym_import] = ACTIONS(2336),
    [anon_sym_from] = ACTIONS(2336),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [anon_sym_print] = ACTIONS(2336),
    [anon_sym_assert] = ACTIONS(2336),
    [anon_sym_return] = ACTIONS(2336),
    [anon_sym_del] = ACTIONS(2336),
    [anon_sym_raise] = ACTIONS(2336),
    [sym_pass_statement] = ACTIONS(2336),
    [sym_break_statement] = ACTIONS(2336),
    [sym_continue_statement] = ACTIONS(2336),
    [anon_sym_if] = ACTIONS(2336),
    [anon_sym_elif] = ACTIONS(4097),
    [anon_sym_else] = ACTIONS(4099),
    [anon_sym_async] = ACTIONS(2336),
    [anon_sym_for] = ACTIONS(2336),
    [anon_sym_while] = ACTIONS(2336),
    [anon_sym_try] = ACTIONS(2336),
    [anon_sym_with] = ACTIONS(2336),
    [anon_sym_def] = ACTIONS(2336),
    [anon_sym_global] = ACTIONS(2336),
    [anon_sym_nonlocal] = ACTIONS(2336),
    [anon_sym_exec] = ACTIONS(2336),
    [anon_sym_class] = ACTIONS(2336),
    [anon_sym_AT] = ACTIONS(2334),
    [anon_sym_not] = ACTIONS(2336),
    [anon_sym_PLUS] = ACTIONS(2334),
    [anon_sym_DASH] = ACTIONS(2334),
    [anon_sym_TILDE] = ACTIONS(2334),
    [anon_sym_lambda] = ACTIONS(2336),
    [anon_sym_yield] = ACTIONS(2336),
    [anon_sym_LBRACK] = ACTIONS(2334),
    [sym_ellipsis] = ACTIONS(2334),
    [anon_sym_LBRACE] = ACTIONS(2334),
    [sym_string] = ACTIONS(2334),
    [sym_integer] = ACTIONS(2336),
    [sym_float] = ACTIONS(2336),
    [sym_identifier] = ACTIONS(2336),
    [sym_true] = ACTIONS(2336),
    [sym_false] = ACTIONS(2336),
    [sym_none] = ACTIONS(2336),
    [anon_sym_await] = ACTIONS(2336),
    [sym_comment] = ACTIONS(72),
  },
  [1680] = {
    [sym_expression_list] = STATE(1815),
    [sym__expression] = STATE(732),
    [sym__primary_expression] = STATE(410),
    [sym_not_operator] = STATE(732),
    [sym_boolean_operator] = STATE(732),
    [sym_binary_operator] = STATE(410),
    [sym_unary_operator] = STATE(410),
    [sym_comparison_operator] = STATE(732),
    [sym_lambda] = STATE(732),
    [sym_attribute] = STATE(410),
    [sym_subscript] = STATE(410),
    [sym_call] = STATE(410),
    [sym_list] = STATE(410),
    [sym_list_comprehension] = STATE(410),
    [sym_dictionary] = STATE(410),
    [sym_dictionary_comprehension] = STATE(410),
    [sym_set] = STATE(410),
    [sym_set_comprehension] = STATE(410),
    [sym_parenthesized_expression] = STATE(410),
    [sym_tuple] = STATE(410),
    [sym_generator_expression] = STATE(410),
    [sym_conditional_expression] = STATE(732),
    [sym_concatenated_string] = STATE(410),
    [sym_await] = STATE(732),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_not] = ACTIONS(726),
    [anon_sym_PLUS] = ACTIONS(728),
    [anon_sym_DASH] = ACTIONS(728),
    [anon_sym_TILDE] = ACTIONS(728),
    [anon_sym_lambda] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(732),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(734),
    [sym_integer] = ACTIONS(736),
    [sym_float] = ACTIONS(736),
    [sym_identifier] = ACTIONS(736),
    [sym_true] = ACTIONS(736),
    [sym_false] = ACTIONS(736),
    [sym_none] = ACTIONS(736),
    [anon_sym_await] = ACTIONS(738),
    [sym_comment] = ACTIONS(72),
  },
  [1681] = {
    [sym__simple_statements] = STATE(1816),
    [sym_import_statement] = STATE(746),
    [sym_import_from_statement] = STATE(746),
    [sym_print_statement] = STATE(746),
    [sym_assert_statement] = STATE(746),
    [sym_expression_statement] = STATE(746),
    [sym_return_statement] = STATE(746),
    [sym_delete_statement] = STATE(746),
    [sym_raise_statement] = STATE(746),
    [sym_global_statement] = STATE(746),
    [sym_nonlocal_statement] = STATE(746),
    [sym_exec_statement] = STATE(746),
    [sym__suite] = STATE(1816),
    [sym_expression_list] = STATE(32),
    [sym__expression] = STATE(33),
    [sym__primary_expression] = STATE(34),
    [sym_not_operator] = STATE(33),
    [sym_boolean_operator] = STATE(33),
    [sym_binary_operator] = STATE(34),
    [sym_unary_operator] = STATE(34),
    [sym_comparison_operator] = STATE(33),
    [sym_lambda] = STATE(33),
    [sym_assignment] = STATE(35),
    [sym_augmented_assignment] = STATE(35),
    [sym_yield] = STATE(35),
    [sym_attribute] = STATE(34),
    [sym_subscript] = STATE(34),
    [sym_call] = STATE(34),
    [sym_list] = STATE(34),
    [sym_list_comprehension] = STATE(34),
    [sym_dictionary] = STATE(34),
    [sym_dictionary_comprehension] = STATE(34),
    [sym_set] = STATE(34),
    [sym_set_comprehension] = STATE(34),
    [sym_parenthesized_expression] = STATE(34),
    [sym_tuple] = STATE(34),
    [sym_generator_expression] = STATE(34),
    [sym_conditional_expression] = STATE(33),
    [sym_concatenated_string] = STATE(34),
    [sym_await] = STATE(33),
    [sym__indent] = ACTIONS(3791),
    [anon_sym_import] = ACTIONS(10),
    [anon_sym_from] = ACTIONS(12),
    [anon_sym_LPAREN] = ACTIONS(14),
    [anon_sym_print] = ACTIONS(16),
    [anon_sym_assert] = ACTIONS(18),
    [anon_sym_return] = ACTIONS(20),
    [anon_sym_del] = ACTIONS(22),
    [anon_sym_raise] = ACTIONS(24),
    [sym_pass_statement] = ACTIONS(1498),
    [sym_break_statement] = ACTIONS(1498),
    [sym_continue_statement] = ACTIONS(1498),
    [anon_sym_global] = ACTIONS(42),
    [anon_sym_nonlocal] = ACTIONS(44),
    [anon_sym_exec] = ACTIONS(46),
    [anon_sym_not] = ACTIONS(52),
    [anon_sym_PLUS] = ACTIONS(54),
    [anon_sym_DASH] = ACTIONS(54),
    [anon_sym_TILDE] = ACTIONS(54),
    [anon_sym_lambda] = ACTIONS(56),
    [anon_sym_yield] = ACTIONS(58),
    [anon_sym_LBRACK] = ACTIONS(60),
    [sym_ellipsis] = ACTIONS(62),
    [anon_sym_LBRACE] = ACTIONS(64),
    [sym_string] = ACTIONS(66),
    [sym_integer] = ACTIONS(68),
    [sym_float] = ACTIONS(68),
    [sym_identifier] = ACTIONS(68),
    [sym_true] = ACTIONS(68),
    [sym_false] = ACTIONS(68),
    [sym_none] = ACTIONS(68),
    [anon_sym_await] = ACTIONS(70),
    [sym_comment] = ACTIONS(72),
  },
  [1682] = {
    [aux_sym_with_statement_repeat1] = STATE(770),
    [anon_sym_COMMA] = ACTIONS(658),
    [anon_sym_COLON] = ACTIONS(4101),
    [sym_comment] = ACTIONS(72),
  },
  [1683] = {
    [anon_sym_COLON] = ACTIONS(4103),
    [anon_sym_DASH_GT] = ACTIONS(4105),
    [sym_comment] = ACTIONS(72),
  },
  [1684] = {
    [anon_sym_COLON] = ACTIONS(4107),
    [sym_comment] = ACTIONS(72),
  },
  [1685] = {
    [sym__statement] = STATE(1822),
    [sym__simple_statements] = STATE(1822),
    [sym_import_statement] = STATE(746),
    [sym_import_from_statement] = STATE(746),
    [sym_print_statement] = STATE(746),
    [sym_assert_statement] = STATE(746),
    [sym_expression_statement] = STATE(746),
    [sym_return_statement] = STATE(746),
    [sym_delete_statement] = STATE(746),
    [sym_raise_statement] = STATE(746),
    [sym_if_statement] = STATE(1822),
    [sym_for_statement] = STATE(1822),
    [sym_while_statement] = STATE(1822),
    [sym_try_statement] = STATE(1822),
    [sym_with_statement] = STATE(1822),
    [sym_function_definition] = STATE(1822),
    [sym_global_statement] = STATE(746),
    [sym_nonlocal_statement] = STATE(746),
    [sym_exec_statement] = STATE(746),
    [sym_class_definition] = STATE(1822),
    [sym_decorated_definition] = STATE(1822),
    [sym_decorator] = STATE(756),
    [sym_expression_list] = STATE(32),
    [sym__expression] = STATE(33),
    [sym__primary_expression] = STATE(34),
    [sym_not_operator] = STATE(33),
    [sym_boolean_operator] = STATE(33),
    [sym_binary_operator] = STATE(34),
    [sym_unary_operator] = STATE(34),
    [sym_comparison_operator] = STATE(33),
    [sym_lambda] = STATE(33),
    [sym_assignment] = STATE(35),
    [sym_augmented_assignment] = STATE(35),
    [sym_yield] = STATE(35),
    [sym_attribute] = STATE(34),
    [sym_subscript] = STATE(34),
    [sym_call] = STATE(34),
    [sym_list] = STATE(34),
    [sym_list_comprehension] = STATE(34),
    [sym_dictionary] = STATE(34),
    [sym_dictionary_comprehension] = STATE(34),
    [sym_set] = STATE(34),
    [sym_set_comprehension] = STATE(34),
    [sym_parenthesized_expression] = STATE(34),
    [sym_tuple] = STATE(34),
    [sym_generator_expression] = STATE(34),
    [sym_conditional_expression] = STATE(33),
    [sym_concatenated_string] = STATE(34),
    [sym_await] = STATE(33),
    [aux_sym_module_repeat1] = STATE(1822),
    [aux_sym_decorated_definition_repeat1] = STATE(756),
    [sym__dedent] = ACTIONS(4109),
    [anon_sym_import] = ACTIONS(10),
    [anon_sym_from] = ACTIONS(12),
    [anon_sym_LPAREN] = ACTIONS(14),
    [anon_sym_print] = ACTIONS(16),
    [anon_sym_assert] = ACTIONS(18),
    [anon_sym_return] = ACTIONS(20),
    [anon_sym_del] = ACTIONS(22),
    [anon_sym_raise] = ACTIONS(24),
    [sym_pass_statement] = ACTIONS(1498),
    [sym_break_statement] = ACTIONS(1498),
    [sym_continue_statement] = ACTIONS(1498),
    [anon_sym_if] = ACTIONS(1500),
    [anon_sym_async] = ACTIONS(1502),
    [anon_sym_for] = ACTIONS(1504),
    [anon_sym_while] = ACTIONS(1506),
    [anon_sym_try] = ACTIONS(1508),
    [anon_sym_with] = ACTIONS(1510),
    [anon_sym_def] = ACTIONS(1512),
    [anon_sym_global] = ACTIONS(42),
    [anon_sym_nonlocal] = ACTIONS(44),
    [anon_sym_exec] = ACTIONS(46),
    [anon_sym_class] = ACTIONS(1514),
    [anon_sym_AT] = ACTIONS(50),
    [anon_sym_not] = ACTIONS(52),
    [anon_sym_PLUS] = ACTIONS(54),
    [anon_sym_DASH] = ACTIONS(54),
    [anon_sym_TILDE] = ACTIONS(54),
    [anon_sym_lambda] = ACTIONS(56),
    [anon_sym_yield] = ACTIONS(58),
    [anon_sym_LBRACK] = ACTIONS(60),
    [sym_ellipsis] = ACTIONS(62),
    [anon_sym_LBRACE] = ACTIONS(64),
    [sym_string] = ACTIONS(66),
    [sym_integer] = ACTIONS(68),
    [sym_float] = ACTIONS(68),
    [sym_identifier] = ACTIONS(68),
    [sym_true] = ACTIONS(68),
    [sym_false] = ACTIONS(68),
    [sym_none] = ACTIONS(68),
    [anon_sym_await] = ACTIONS(70),
    [sym_comment] = ACTIONS(72),
  },
  [1686] = {
    [aux_sym__simple_statements_repeat1] = STATE(1825),
    [sym__newline] = ACTIONS(4111),
    [sym_comment] = ACTIONS(72),
    [sym__semicolon] = ACTIONS(4113),
  },
  [1687] = {
    [sym_else_clause] = STATE(1826),
    [sym__dedent] = ACTIONS(2384),
    [anon_sym_import] = ACTIONS(2386),
    [anon_sym_from] = ACTIONS(2386),
    [anon_sym_LPAREN] = ACTIONS(2384),
    [anon_sym_print] = ACTIONS(2386),
    [anon_sym_assert] = ACTIONS(2386),
    [anon_sym_return] = ACTIONS(2386),
    [anon_sym_del] = ACTIONS(2386),
    [anon_sym_raise] = ACTIONS(2386),
    [sym_pass_statement] = ACTIONS(2386),
    [sym_break_statement] = ACTIONS(2386),
    [sym_continue_statement] = ACTIONS(2386),
    [anon_sym_if] = ACTIONS(2386),
    [anon_sym_else] = ACTIONS(4099),
    [anon_sym_async] = ACTIONS(2386),
    [anon_sym_for] = ACTIONS(2386),
    [anon_sym_while] = ACTIONS(2386),
    [anon_sym_try] = ACTIONS(2386),
    [anon_sym_with] = ACTIONS(2386),
    [anon_sym_def] = ACTIONS(2386),
    [anon_sym_global] = ACTIONS(2386),
    [anon_sym_nonlocal] = ACTIONS(2386),
    [anon_sym_exec] = ACTIONS(2386),
    [anon_sym_class] = ACTIONS(2386),
    [anon_sym_AT] = ACTIONS(2384),
    [anon_sym_not] = ACTIONS(2386),
    [anon_sym_PLUS] = ACTIONS(2384),
    [anon_sym_DASH] = ACTIONS(2384),
    [anon_sym_TILDE] = ACTIONS(2384),
    [anon_sym_lambda] = ACTIONS(2386),
    [anon_sym_yield] = ACTIONS(2386),
    [anon_sym_LBRACK] = ACTIONS(2384),
    [sym_ellipsis] = ACTIONS(2384),
    [anon_sym_LBRACE] = ACTIONS(2384),
    [sym_string] = ACTIONS(2384),
    [sym_integer] = ACTIONS(2386),
    [sym_float] = ACTIONS(2386),
    [sym_identifier] = ACTIONS(2386),
    [sym_true] = ACTIONS(2386),
    [sym_false] = ACTIONS(2386),
    [sym_none] = ACTIONS(2386),
    [anon_sym_await] = ACTIONS(2386),
    [sym_comment] = ACTIONS(72),
  },
  [1688] = {
    [sym__expression] = STATE(1828),
    [sym__primary_expression] = STATE(113),
    [sym_not_operator] = STATE(1828),
    [sym_boolean_operator] = STATE(1828),
    [sym_binary_operator] = STATE(113),
    [sym_unary_operator] = STATE(113),
    [sym_comparison_operator] = STATE(1828),
    [sym_lambda] = STATE(1828),
    [sym_attribute] = STATE(113),
    [sym_subscript] = STATE(113),
    [sym_call] = STATE(113),
    [sym_list] = STATE(113),
    [sym_list_comprehension] = STATE(113),
    [sym_dictionary] = STATE(113),
    [sym_dictionary_comprehension] = STATE(113),
    [sym_set] = STATE(113),
    [sym_set_comprehension] = STATE(113),
    [sym_parenthesized_expression] = STATE(113),
    [sym_tuple] = STATE(113),
    [sym_generator_expression] = STATE(113),
    [sym_conditional_expression] = STATE(1828),
    [sym_concatenated_string] = STATE(113),
    [sym_await] = STATE(1828),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_COLON] = ACTIONS(4115),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_not] = ACTIONS(190),
    [anon_sym_PLUS] = ACTIONS(192),
    [anon_sym_DASH] = ACTIONS(192),
    [anon_sym_TILDE] = ACTIONS(192),
    [anon_sym_lambda] = ACTIONS(194),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(196),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(198),
    [sym_integer] = ACTIONS(200),
    [sym_float] = ACTIONS(200),
    [sym_identifier] = ACTIONS(200),
    [sym_true] = ACTIONS(200),
    [sym_false] = ACTIONS(200),
    [sym_none] = ACTIONS(200),
    [anon_sym_await] = ACTIONS(202),
    [sym_comment] = ACTIONS(72),
  },
  [1689] = {
    [anon_sym_COLON] = ACTIONS(4117),
    [sym_comment] = ACTIONS(72),
  },
  [1690] = {
    [sym__dedent] = ACTIONS(2424),
    [anon_sym_import] = ACTIONS(2426),
    [anon_sym_from] = ACTIONS(2426),
    [anon_sym_LPAREN] = ACTIONS(2424),
    [anon_sym_print] = ACTIONS(2426),
    [anon_sym_assert] = ACTIONS(2426),
    [anon_sym_return] = ACTIONS(2426),
    [anon_sym_del] = ACTIONS(2426),
    [anon_sym_raise] = ACTIONS(2426),
    [sym_pass_statement] = ACTIONS(2426),
    [sym_break_statement] = ACTIONS(2426),
    [sym_continue_statement] = ACTIONS(2426),
    [anon_sym_if] = ACTIONS(2426),
    [anon_sym_async] = ACTIONS(2426),
    [anon_sym_for] = ACTIONS(2426),
    [anon_sym_while] = ACTIONS(2426),
    [anon_sym_try] = ACTIONS(2426),
    [anon_sym_with] = ACTIONS(2426),
    [anon_sym_def] = ACTIONS(2426),
    [anon_sym_global] = ACTIONS(2426),
    [anon_sym_nonlocal] = ACTIONS(2426),
    [anon_sym_exec] = ACTIONS(2426),
    [anon_sym_class] = ACTIONS(2426),
    [anon_sym_AT] = ACTIONS(2424),
    [anon_sym_not] = ACTIONS(2426),
    [anon_sym_PLUS] = ACTIONS(2424),
    [anon_sym_DASH] = ACTIONS(2424),
    [anon_sym_TILDE] = ACTIONS(2424),
    [anon_sym_lambda] = ACTIONS(2426),
    [anon_sym_yield] = ACTIONS(2426),
    [anon_sym_LBRACK] = ACTIONS(2424),
    [sym_ellipsis] = ACTIONS(2424),
    [anon_sym_LBRACE] = ACTIONS(2424),
    [sym_string] = ACTIONS(2424),
    [sym_integer] = ACTIONS(2426),
    [sym_float] = ACTIONS(2426),
    [sym_identifier] = ACTIONS(2426),
    [sym_true] = ACTIONS(2426),
    [sym_false] = ACTIONS(2426),
    [sym_none] = ACTIONS(2426),
    [anon_sym_await] = ACTIONS(2426),
    [sym_comment] = ACTIONS(72),
  },
  [1691] = {
    [sym_else_clause] = STATE(1831),
    [sym_except_clause] = STATE(1833),
    [sym_finally_clause] = STATE(1832),
    [aux_sym_try_statement_repeat1] = STATE(1833),
    [sym__dedent] = ACTIONS(2424),
    [anon_sym_import] = ACTIONS(2426),
    [anon_sym_from] = ACTIONS(2426),
    [anon_sym_LPAREN] = ACTIONS(2424),
    [anon_sym_print] = ACTIONS(2426),
    [anon_sym_assert] = ACTIONS(2426),
    [anon_sym_return] = ACTIONS(2426),
    [anon_sym_del] = ACTIONS(2426),
    [anon_sym_raise] = ACTIONS(2426),
    [sym_pass_statement] = ACTIONS(2426),
    [sym_break_statement] = ACTIONS(2426),
    [sym_continue_statement] = ACTIONS(2426),
    [anon_sym_if] = ACTIONS(2426),
    [anon_sym_else] = ACTIONS(4119),
    [anon_sym_async] = ACTIONS(2426),
    [anon_sym_for] = ACTIONS(2426),
    [anon_sym_while] = ACTIONS(2426),
    [anon_sym_try] = ACTIONS(2426),
    [anon_sym_except] = ACTIONS(4121),
    [anon_sym_finally] = ACTIONS(4123),
    [anon_sym_with] = ACTIONS(2426),
    [anon_sym_def] = ACTIONS(2426),
    [anon_sym_global] = ACTIONS(2426),
    [anon_sym_nonlocal] = ACTIONS(2426),
    [anon_sym_exec] = ACTIONS(2426),
    [anon_sym_class] = ACTIONS(2426),
    [anon_sym_AT] = ACTIONS(2424),
    [anon_sym_not] = ACTIONS(2426),
    [anon_sym_PLUS] = ACTIONS(2424),
    [anon_sym_DASH] = ACTIONS(2424),
    [anon_sym_TILDE] = ACTIONS(2424),
    [anon_sym_lambda] = ACTIONS(2426),
    [anon_sym_yield] = ACTIONS(2426),
    [anon_sym_LBRACK] = ACTIONS(2424),
    [sym_ellipsis] = ACTIONS(2424),
    [anon_sym_LBRACE] = ACTIONS(2424),
    [sym_string] = ACTIONS(2424),
    [sym_integer] = ACTIONS(2426),
    [sym_float] = ACTIONS(2426),
    [sym_identifier] = ACTIONS(2426),
    [sym_true] = ACTIONS(2426),
    [sym_false] = ACTIONS(2426),
    [sym_none] = ACTIONS(2426),
    [anon_sym_await] = ACTIONS(2426),
    [sym_comment] = ACTIONS(72),
  },
  [1692] = {
    [sym__statement] = STATE(1835),
    [sym__simple_statements] = STATE(1835),
    [sym_import_statement] = STATE(746),
    [sym_import_from_statement] = STATE(746),
    [sym_print_statement] = STATE(746),
    [sym_assert_statement] = STATE(746),
    [sym_expression_statement] = STATE(746),
    [sym_return_statement] = STATE(746),
    [sym_delete_statement] = STATE(746),
    [sym_raise_statement] = STATE(746),
    [sym_if_statement] = STATE(1835),
    [sym_for_statement] = STATE(1835),
    [sym_while_statement] = STATE(1835),
    [sym_try_statement] = STATE(1835),
    [sym_with_statement] = STATE(1835),
    [sym_function_definition] = STATE(1835),
    [sym_global_statement] = STATE(746),
    [sym_nonlocal_statement] = STATE(746),
    [sym_exec_statement] = STATE(746),
    [sym_class_definition] = STATE(1835),
    [sym_decorated_definition] = STATE(1835),
    [sym_decorator] = STATE(756),
    [sym_expression_list] = STATE(32),
    [sym__expression] = STATE(33),
    [sym__primary_expression] = STATE(34),
    [sym_not_operator] = STATE(33),
    [sym_boolean_operator] = STATE(33),
    [sym_binary_operator] = STATE(34),
    [sym_unary_operator] = STATE(34),
    [sym_comparison_operator] = STATE(33),
    [sym_lambda] = STATE(33),
    [sym_assignment] = STATE(35),
    [sym_augmented_assignment] = STATE(35),
    [sym_yield] = STATE(35),
    [sym_attribute] = STATE(34),
    [sym_subscript] = STATE(34),
    [sym_call] = STATE(34),
    [sym_list] = STATE(34),
    [sym_list_comprehension] = STATE(34),
    [sym_dictionary] = STATE(34),
    [sym_dictionary_comprehension] = STATE(34),
    [sym_set] = STATE(34),
    [sym_set_comprehension] = STATE(34),
    [sym_parenthesized_expression] = STATE(34),
    [sym_tuple] = STATE(34),
    [sym_generator_expression] = STATE(34),
    [sym_conditional_expression] = STATE(33),
    [sym_concatenated_string] = STATE(34),
    [sym_await] = STATE(33),
    [aux_sym_module_repeat1] = STATE(1835),
    [aux_sym_decorated_definition_repeat1] = STATE(756),
    [sym__dedent] = ACTIONS(4125),
    [anon_sym_import] = ACTIONS(10),
    [anon_sym_from] = ACTIONS(12),
    [anon_sym_LPAREN] = ACTIONS(14),
    [anon_sym_print] = ACTIONS(16),
    [anon_sym_assert] = ACTIONS(18),
    [anon_sym_return] = ACTIONS(20),
    [anon_sym_del] = ACTIONS(22),
    [anon_sym_raise] = ACTIONS(24),
    [sym_pass_statement] = ACTIONS(1498),
    [sym_break_statement] = ACTIONS(1498),
    [sym_continue_statement] = ACTIONS(1498),
    [anon_sym_if] = ACTIONS(1500),
    [anon_sym_async] = ACTIONS(1502),
    [anon_sym_for] = ACTIONS(1504),
    [anon_sym_while] = ACTIONS(1506),
    [anon_sym_try] = ACTIONS(1508),
    [anon_sym_with] = ACTIONS(1510),
    [anon_sym_def] = ACTIONS(1512),
    [anon_sym_global] = ACTIONS(42),
    [anon_sym_nonlocal] = ACTIONS(44),
    [anon_sym_exec] = ACTIONS(46),
    [anon_sym_class] = ACTIONS(1514),
    [anon_sym_AT] = ACTIONS(50),
    [anon_sym_not] = ACTIONS(52),
    [anon_sym_PLUS] = ACTIONS(54),
    [anon_sym_DASH] = ACTIONS(54),
    [anon_sym_TILDE] = ACTIONS(54),
    [anon_sym_lambda] = ACTIONS(56),
    [anon_sym_yield] = ACTIONS(58),
    [anon_sym_LBRACK] = ACTIONS(60),
    [sym_ellipsis] = ACTIONS(62),
    [anon_sym_LBRACE] = ACTIONS(64),
    [sym_string] = ACTIONS(66),
    [sym_integer] = ACTIONS(68),
    [sym_float] = ACTIONS(68),
    [sym_identifier] = ACTIONS(68),
    [sym_true] = ACTIONS(68),
    [sym_false] = ACTIONS(68),
    [sym_none] = ACTIONS(68),
    [anon_sym_await] = ACTIONS(70),
    [sym_comment] = ACTIONS(72),
  },
  [1693] = {
    [sym__dedent] = ACTIONS(2441),
    [anon_sym_import] = ACTIONS(2443),
    [anon_sym_from] = ACTIONS(2443),
    [anon_sym_LPAREN] = ACTIONS(2441),
    [anon_sym_print] = ACTIONS(2443),
    [anon_sym_assert] = ACTIONS(2443),
    [anon_sym_return] = ACTIONS(2443),
    [anon_sym_del] = ACTIONS(2443),
    [anon_sym_raise] = ACTIONS(2443),
    [sym_pass_statement] = ACTIONS(2443),
    [sym_break_statement] = ACTIONS(2443),
    [sym_continue_statement] = ACTIONS(2443),
    [anon_sym_if] = ACTIONS(2443),
    [anon_sym_async] = ACTIONS(2443),
    [anon_sym_for] = ACTIONS(2443),
    [anon_sym_while] = ACTIONS(2443),
    [anon_sym_try] = ACTIONS(2443),
    [anon_sym_with] = ACTIONS(2443),
    [anon_sym_def] = ACTIONS(2443),
    [anon_sym_global] = ACTIONS(2443),
    [anon_sym_nonlocal] = ACTIONS(2443),
    [anon_sym_exec] = ACTIONS(2443),
    [anon_sym_class] = ACTIONS(2443),
    [anon_sym_AT] = ACTIONS(2441),
    [anon_sym_not] = ACTIONS(2443),
    [anon_sym_PLUS] = ACTIONS(2441),
    [anon_sym_DASH] = ACTIONS(2441),
    [anon_sym_TILDE] = ACTIONS(2441),
    [anon_sym_lambda] = ACTIONS(2443),
    [anon_sym_yield] = ACTIONS(2443),
    [anon_sym_LBRACK] = ACTIONS(2441),
    [sym_ellipsis] = ACTIONS(2441),
    [anon_sym_LBRACE] = ACTIONS(2441),
    [sym_string] = ACTIONS(2441),
    [sym_integer] = ACTIONS(2443),
    [sym_float] = ACTIONS(2443),
    [sym_identifier] = ACTIONS(2443),
    [sym_true] = ACTIONS(2443),
    [sym_false] = ACTIONS(2443),
    [sym_none] = ACTIONS(2443),
    [anon_sym_await] = ACTIONS(2443),
    [sym_comment] = ACTIONS(72),
  },
  [1694] = {
    [sym__simple_statements] = STATE(1836),
    [sym_import_statement] = STATE(746),
    [sym_import_from_statement] = STATE(746),
    [sym_print_statement] = STATE(746),
    [sym_assert_statement] = STATE(746),
    [sym_expression_statement] = STATE(746),
    [sym_return_statement] = STATE(746),
    [sym_delete_statement] = STATE(746),
    [sym_raise_statement] = STATE(746),
    [sym_global_statement] = STATE(746),
    [sym_nonlocal_statement] = STATE(746),
    [sym_exec_statement] = STATE(746),
    [sym__suite] = STATE(1836),
    [sym_expression_list] = STATE(32),
    [sym__expression] = STATE(33),
    [sym__primary_expression] = STATE(34),
    [sym_not_operator] = STATE(33),
    [sym_boolean_operator] = STATE(33),
    [sym_binary_operator] = STATE(34),
    [sym_unary_operator] = STATE(34),
    [sym_comparison_operator] = STATE(33),
    [sym_lambda] = STATE(33),
    [sym_assignment] = STATE(35),
    [sym_augmented_assignment] = STATE(35),
    [sym_yield] = STATE(35),
    [sym_attribute] = STATE(34),
    [sym_subscript] = STATE(34),
    [sym_call] = STATE(34),
    [sym_list] = STATE(34),
    [sym_list_comprehension] = STATE(34),
    [sym_dictionary] = STATE(34),
    [sym_dictionary_comprehension] = STATE(34),
    [sym_set] = STATE(34),
    [sym_set_comprehension] = STATE(34),
    [sym_parenthesized_expression] = STATE(34),
    [sym_tuple] = STATE(34),
    [sym_generator_expression] = STATE(34),
    [sym_conditional_expression] = STATE(33),
    [sym_concatenated_string] = STATE(34),
    [sym_await] = STATE(33),
    [sym__indent] = ACTIONS(3791),
    [anon_sym_import] = ACTIONS(10),
    [anon_sym_from] = ACTIONS(12),
    [anon_sym_LPAREN] = ACTIONS(14),
    [anon_sym_print] = ACTIONS(16),
    [anon_sym_assert] = ACTIONS(18),
    [anon_sym_return] = ACTIONS(20),
    [anon_sym_del] = ACTIONS(22),
    [anon_sym_raise] = ACTIONS(24),
    [sym_pass_statement] = ACTIONS(1498),
    [sym_break_statement] = ACTIONS(1498),
    [sym_continue_statement] = ACTIONS(1498),
    [anon_sym_global] = ACTIONS(42),
    [anon_sym_nonlocal] = ACTIONS(44),
    [anon_sym_exec] = ACTIONS(46),
    [anon_sym_not] = ACTIONS(52),
    [anon_sym_PLUS] = ACTIONS(54),
    [anon_sym_DASH] = ACTIONS(54),
    [anon_sym_TILDE] = ACTIONS(54),
    [anon_sym_lambda] = ACTIONS(56),
    [anon_sym_yield] = ACTIONS(58),
    [anon_sym_LBRACK] = ACTIONS(60),
    [sym_ellipsis] = ACTIONS(62),
    [anon_sym_LBRACE] = ACTIONS(64),
    [sym_string] = ACTIONS(66),
    [sym_integer] = ACTIONS(68),
    [sym_float] = ACTIONS(68),
    [sym_identifier] = ACTIONS(68),
    [sym_true] = ACTIONS(68),
    [sym_false] = ACTIONS(68),
    [sym_none] = ACTIONS(68),
    [anon_sym_await] = ACTIONS(70),
    [sym_comment] = ACTIONS(72),
  },
  [1695] = {
    [sym__expression] = STATE(1191),
    [sym__primary_expression] = STATE(96),
    [sym_not_operator] = STATE(1191),
    [sym_boolean_operator] = STATE(1191),
    [sym_binary_operator] = STATE(96),
    [sym_unary_operator] = STATE(96),
    [sym_comparison_operator] = STATE(1191),
    [sym_lambda] = STATE(1191),
    [sym_attribute] = STATE(96),
    [sym_subscript] = STATE(96),
    [sym_call] = STATE(96),
    [sym_type] = STATE(1837),
    [sym_list] = STATE(96),
    [sym_list_comprehension] = STATE(96),
    [sym_dictionary] = STATE(96),
    [sym_dictionary_comprehension] = STATE(96),
    [sym_set] = STATE(96),
    [sym_set_comprehension] = STATE(96),
    [sym_parenthesized_expression] = STATE(96),
    [sym_tuple] = STATE(96),
    [sym_generator_expression] = STATE(96),
    [sym_conditional_expression] = STATE(1191),
    [sym_concatenated_string] = STATE(96),
    [sym_await] = STATE(1191),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_not] = ACTIONS(160),
    [anon_sym_PLUS] = ACTIONS(162),
    [anon_sym_DASH] = ACTIONS(162),
    [anon_sym_TILDE] = ACTIONS(162),
    [anon_sym_lambda] = ACTIONS(164),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(166),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(168),
    [sym_integer] = ACTIONS(170),
    [sym_float] = ACTIONS(170),
    [sym_identifier] = ACTIONS(170),
    [sym_true] = ACTIONS(170),
    [sym_false] = ACTIONS(170),
    [sym_none] = ACTIONS(170),
    [anon_sym_await] = ACTIONS(172),
    [sym_comment] = ACTIONS(72),
  },
  [1696] = {
    [sym__dedent] = ACTIONS(2509),
    [anon_sym_import] = ACTIONS(2511),
    [anon_sym_from] = ACTIONS(2511),
    [anon_sym_LPAREN] = ACTIONS(2509),
    [anon_sym_print] = ACTIONS(2511),
    [anon_sym_assert] = ACTIONS(2511),
    [anon_sym_return] = ACTIONS(2511),
    [anon_sym_del] = ACTIONS(2511),
    [anon_sym_raise] = ACTIONS(2511),
    [sym_pass_statement] = ACTIONS(2511),
    [sym_break_statement] = ACTIONS(2511),
    [sym_continue_statement] = ACTIONS(2511),
    [anon_sym_if] = ACTIONS(2511),
    [anon_sym_async] = ACTIONS(2511),
    [anon_sym_for] = ACTIONS(2511),
    [anon_sym_while] = ACTIONS(2511),
    [anon_sym_try] = ACTIONS(2511),
    [anon_sym_with] = ACTIONS(2511),
    [anon_sym_def] = ACTIONS(2511),
    [anon_sym_global] = ACTIONS(2511),
    [anon_sym_nonlocal] = ACTIONS(2511),
    [anon_sym_exec] = ACTIONS(2511),
    [anon_sym_class] = ACTIONS(2511),
    [anon_sym_AT] = ACTIONS(2509),
    [anon_sym_not] = ACTIONS(2511),
    [anon_sym_PLUS] = ACTIONS(2509),
    [anon_sym_DASH] = ACTIONS(2509),
    [anon_sym_TILDE] = ACTIONS(2509),
    [anon_sym_lambda] = ACTIONS(2511),
    [anon_sym_yield] = ACTIONS(2511),
    [anon_sym_LBRACK] = ACTIONS(2509),
    [sym_ellipsis] = ACTIONS(2509),
    [anon_sym_LBRACE] = ACTIONS(2509),
    [sym_string] = ACTIONS(2509),
    [sym_integer] = ACTIONS(2511),
    [sym_float] = ACTIONS(2511),
    [sym_identifier] = ACTIONS(2511),
    [sym_true] = ACTIONS(2511),
    [sym_false] = ACTIONS(2511),
    [sym_none] = ACTIONS(2511),
    [anon_sym_await] = ACTIONS(2511),
    [sym_comment] = ACTIONS(72),
  },
  [1697] = {
    [sym__simple_statements] = STATE(1838),
    [sym_import_statement] = STATE(746),
    [sym_import_from_statement] = STATE(746),
    [sym_print_statement] = STATE(746),
    [sym_assert_statement] = STATE(746),
    [sym_expression_statement] = STATE(746),
    [sym_return_statement] = STATE(746),
    [sym_delete_statement] = STATE(746),
    [sym_raise_statement] = STATE(746),
    [sym_global_statement] = STATE(746),
    [sym_nonlocal_statement] = STATE(746),
    [sym_exec_statement] = STATE(746),
    [sym__suite] = STATE(1838),
    [sym_expression_list] = STATE(32),
    [sym__expression] = STATE(33),
    [sym__primary_expression] = STATE(34),
    [sym_not_operator] = STATE(33),
    [sym_boolean_operator] = STATE(33),
    [sym_binary_operator] = STATE(34),
    [sym_unary_operator] = STATE(34),
    [sym_comparison_operator] = STATE(33),
    [sym_lambda] = STATE(33),
    [sym_assignment] = STATE(35),
    [sym_augmented_assignment] = STATE(35),
    [sym_yield] = STATE(35),
    [sym_attribute] = STATE(34),
    [sym_subscript] = STATE(34),
    [sym_call] = STATE(34),
    [sym_list] = STATE(34),
    [sym_list_comprehension] = STATE(34),
    [sym_dictionary] = STATE(34),
    [sym_dictionary_comprehension] = STATE(34),
    [sym_set] = STATE(34),
    [sym_set_comprehension] = STATE(34),
    [sym_parenthesized_expression] = STATE(34),
    [sym_tuple] = STATE(34),
    [sym_generator_expression] = STATE(34),
    [sym_conditional_expression] = STATE(33),
    [sym_concatenated_string] = STATE(34),
    [sym_await] = STATE(33),
    [sym__indent] = ACTIONS(3791),
    [anon_sym_import] = ACTIONS(10),
    [anon_sym_from] = ACTIONS(12),
    [anon_sym_LPAREN] = ACTIONS(14),
    [anon_sym_print] = ACTIONS(16),
    [anon_sym_assert] = ACTIONS(18),
    [anon_sym_return] = ACTIONS(20),
    [anon_sym_del] = ACTIONS(22),
    [anon_sym_raise] = ACTIONS(24),
    [sym_pass_statement] = ACTIONS(1498),
    [sym_break_statement] = ACTIONS(1498),
    [sym_continue_statement] = ACTIONS(1498),
    [anon_sym_global] = ACTIONS(42),
    [anon_sym_nonlocal] = ACTIONS(44),
    [anon_sym_exec] = ACTIONS(46),
    [anon_sym_not] = ACTIONS(52),
    [anon_sym_PLUS] = ACTIONS(54),
    [anon_sym_DASH] = ACTIONS(54),
    [anon_sym_TILDE] = ACTIONS(54),
    [anon_sym_lambda] = ACTIONS(56),
    [anon_sym_yield] = ACTIONS(58),
    [anon_sym_LBRACK] = ACTIONS(60),
    [sym_ellipsis] = ACTIONS(62),
    [anon_sym_LBRACE] = ACTIONS(64),
    [sym_string] = ACTIONS(66),
    [sym_integer] = ACTIONS(68),
    [sym_float] = ACTIONS(68),
    [sym_identifier] = ACTIONS(68),
    [sym_true] = ACTIONS(68),
    [sym_false] = ACTIONS(68),
    [sym_none] = ACTIONS(68),
    [anon_sym_await] = ACTIONS(70),
    [sym_comment] = ACTIONS(72),
  },
  [1698] = {
    [anon_sym_if] = ACTIONS(590),
    [anon_sym_COLON] = ACTIONS(4127),
    [anon_sym_and] = ACTIONS(594),
    [anon_sym_or] = ACTIONS(596),
    [sym_comment] = ACTIONS(72),
  },
  [1699] = {
    [ts_builtin_sym_end] = ACTIONS(4129),
    [anon_sym_import] = ACTIONS(4131),
    [anon_sym_from] = ACTIONS(4131),
    [anon_sym_LPAREN] = ACTIONS(4129),
    [anon_sym_print] = ACTIONS(4131),
    [anon_sym_assert] = ACTIONS(4131),
    [anon_sym_return] = ACTIONS(4131),
    [anon_sym_del] = ACTIONS(4131),
    [anon_sym_raise] = ACTIONS(4131),
    [sym_pass_statement] = ACTIONS(4131),
    [sym_break_statement] = ACTIONS(4131),
    [sym_continue_statement] = ACTIONS(4131),
    [anon_sym_if] = ACTIONS(4131),
    [anon_sym_else] = ACTIONS(4131),
    [anon_sym_async] = ACTIONS(4131),
    [anon_sym_for] = ACTIONS(4131),
    [anon_sym_while] = ACTIONS(4131),
    [anon_sym_try] = ACTIONS(4131),
    [anon_sym_except] = ACTIONS(4131),
    [anon_sym_finally] = ACTIONS(4131),
    [anon_sym_with] = ACTIONS(4131),
    [anon_sym_def] = ACTIONS(4131),
    [anon_sym_global] = ACTIONS(4131),
    [anon_sym_nonlocal] = ACTIONS(4131),
    [anon_sym_exec] = ACTIONS(4131),
    [anon_sym_class] = ACTIONS(4131),
    [anon_sym_AT] = ACTIONS(4129),
    [anon_sym_not] = ACTIONS(4131),
    [anon_sym_PLUS] = ACTIONS(4129),
    [anon_sym_DASH] = ACTIONS(4129),
    [anon_sym_TILDE] = ACTIONS(4129),
    [anon_sym_lambda] = ACTIONS(4131),
    [anon_sym_yield] = ACTIONS(4131),
    [anon_sym_LBRACK] = ACTIONS(4129),
    [sym_ellipsis] = ACTIONS(4129),
    [anon_sym_LBRACE] = ACTIONS(4129),
    [sym_string] = ACTIONS(4129),
    [sym_integer] = ACTIONS(4131),
    [sym_float] = ACTIONS(4131),
    [sym_identifier] = ACTIONS(4131),
    [sym_true] = ACTIONS(4131),
    [sym_false] = ACTIONS(4131),
    [sym_none] = ACTIONS(4131),
    [anon_sym_await] = ACTIONS(4131),
    [sym_comment] = ACTIONS(72),
  },
  [1700] = {
    [sym__statement] = STATE(1841),
    [sym__simple_statements] = STATE(1841),
    [sym_import_statement] = STATE(746),
    [sym_import_from_statement] = STATE(746),
    [sym_print_statement] = STATE(746),
    [sym_assert_statement] = STATE(746),
    [sym_expression_statement] = STATE(746),
    [sym_return_statement] = STATE(746),
    [sym_delete_statement] = STATE(746),
    [sym_raise_statement] = STATE(746),
    [sym_if_statement] = STATE(1841),
    [sym_for_statement] = STATE(1841),
    [sym_while_statement] = STATE(1841),
    [sym_try_statement] = STATE(1841),
    [sym_with_statement] = STATE(1841),
    [sym_function_definition] = STATE(1841),
    [sym_global_statement] = STATE(746),
    [sym_nonlocal_statement] = STATE(746),
    [sym_exec_statement] = STATE(746),
    [sym_class_definition] = STATE(1841),
    [sym_decorated_definition] = STATE(1841),
    [sym_decorator] = STATE(756),
    [sym_expression_list] = STATE(32),
    [sym__expression] = STATE(33),
    [sym__primary_expression] = STATE(34),
    [sym_not_operator] = STATE(33),
    [sym_boolean_operator] = STATE(33),
    [sym_binary_operator] = STATE(34),
    [sym_unary_operator] = STATE(34),
    [sym_comparison_operator] = STATE(33),
    [sym_lambda] = STATE(33),
    [sym_assignment] = STATE(35),
    [sym_augmented_assignment] = STATE(35),
    [sym_yield] = STATE(35),
    [sym_attribute] = STATE(34),
    [sym_subscript] = STATE(34),
    [sym_call] = STATE(34),
    [sym_list] = STATE(34),
    [sym_list_comprehension] = STATE(34),
    [sym_dictionary] = STATE(34),
    [sym_dictionary_comprehension] = STATE(34),
    [sym_set] = STATE(34),
    [sym_set_comprehension] = STATE(34),
    [sym_parenthesized_expression] = STATE(34),
    [sym_tuple] = STATE(34),
    [sym_generator_expression] = STATE(34),
    [sym_conditional_expression] = STATE(33),
    [sym_concatenated_string] = STATE(34),
    [sym_await] = STATE(33),
    [aux_sym_module_repeat1] = STATE(1841),
    [aux_sym_decorated_definition_repeat1] = STATE(756),
    [sym__dedent] = ACTIONS(4133),
    [anon_sym_import] = ACTIONS(10),
    [anon_sym_from] = ACTIONS(12),
    [anon_sym_LPAREN] = ACTIONS(14),
    [anon_sym_print] = ACTIONS(16),
    [anon_sym_assert] = ACTIONS(18),
    [anon_sym_return] = ACTIONS(20),
    [anon_sym_del] = ACTIONS(22),
    [anon_sym_raise] = ACTIONS(24),
    [sym_pass_statement] = ACTIONS(1498),
    [sym_break_statement] = ACTIONS(1498),
    [sym_continue_statement] = ACTIONS(1498),
    [anon_sym_if] = ACTIONS(1500),
    [anon_sym_async] = ACTIONS(1502),
    [anon_sym_for] = ACTIONS(1504),
    [anon_sym_while] = ACTIONS(1506),
    [anon_sym_try] = ACTIONS(1508),
    [anon_sym_with] = ACTIONS(1510),
    [anon_sym_def] = ACTIONS(1512),
    [anon_sym_global] = ACTIONS(42),
    [anon_sym_nonlocal] = ACTIONS(44),
    [anon_sym_exec] = ACTIONS(46),
    [anon_sym_class] = ACTIONS(1514),
    [anon_sym_AT] = ACTIONS(50),
    [anon_sym_not] = ACTIONS(52),
    [anon_sym_PLUS] = ACTIONS(54),
    [anon_sym_DASH] = ACTIONS(54),
    [anon_sym_TILDE] = ACTIONS(54),
    [anon_sym_lambda] = ACTIONS(56),
    [anon_sym_yield] = ACTIONS(58),
    [anon_sym_LBRACK] = ACTIONS(60),
    [sym_ellipsis] = ACTIONS(62),
    [anon_sym_LBRACE] = ACTIONS(64),
    [sym_string] = ACTIONS(66),
    [sym_integer] = ACTIONS(68),
    [sym_float] = ACTIONS(68),
    [sym_identifier] = ACTIONS(68),
    [sym_true] = ACTIONS(68),
    [sym_false] = ACTIONS(68),
    [sym_none] = ACTIONS(68),
    [anon_sym_await] = ACTIONS(70),
    [sym_comment] = ACTIONS(72),
  },
  [1701] = {
    [aux_sym__simple_statements_repeat1] = STATE(1844),
    [sym__newline] = ACTIONS(4135),
    [sym_comment] = ACTIONS(72),
    [sym__semicolon] = ACTIONS(4137),
  },
  [1702] = {
    [ts_builtin_sym_end] = ACTIONS(4083),
    [anon_sym_import] = ACTIONS(4085),
    [anon_sym_from] = ACTIONS(4085),
    [anon_sym_LPAREN] = ACTIONS(4083),
    [anon_sym_print] = ACTIONS(4085),
    [anon_sym_assert] = ACTIONS(4085),
    [anon_sym_return] = ACTIONS(4085),
    [anon_sym_del] = ACTIONS(4085),
    [anon_sym_raise] = ACTIONS(4085),
    [sym_pass_statement] = ACTIONS(4085),
    [sym_break_statement] = ACTIONS(4085),
    [sym_continue_statement] = ACTIONS(4085),
    [anon_sym_if] = ACTIONS(4085),
    [anon_sym_async] = ACTIONS(4085),
    [anon_sym_for] = ACTIONS(4085),
    [anon_sym_while] = ACTIONS(4085),
    [anon_sym_try] = ACTIONS(4085),
    [anon_sym_finally] = ACTIONS(4085),
    [anon_sym_with] = ACTIONS(4085),
    [anon_sym_def] = ACTIONS(4085),
    [anon_sym_global] = ACTIONS(4085),
    [anon_sym_nonlocal] = ACTIONS(4085),
    [anon_sym_exec] = ACTIONS(4085),
    [anon_sym_class] = ACTIONS(4085),
    [anon_sym_AT] = ACTIONS(4083),
    [anon_sym_not] = ACTIONS(4085),
    [anon_sym_PLUS] = ACTIONS(4083),
    [anon_sym_DASH] = ACTIONS(4083),
    [anon_sym_TILDE] = ACTIONS(4083),
    [anon_sym_lambda] = ACTIONS(4085),
    [anon_sym_yield] = ACTIONS(4085),
    [anon_sym_LBRACK] = ACTIONS(4083),
    [sym_ellipsis] = ACTIONS(4083),
    [anon_sym_LBRACE] = ACTIONS(4083),
    [sym_string] = ACTIONS(4083),
    [sym_integer] = ACTIONS(4085),
    [sym_float] = ACTIONS(4085),
    [sym_identifier] = ACTIONS(4085),
    [sym_true] = ACTIONS(4085),
    [sym_false] = ACTIONS(4085),
    [sym_none] = ACTIONS(4085),
    [anon_sym_await] = ACTIONS(4085),
    [sym_comment] = ACTIONS(72),
  },
  [1703] = {
    [anon_sym_RPAREN] = ACTIONS(1644),
    [anon_sym_COMMA] = ACTIONS(1644),
    [anon_sym_if] = ACTIONS(3243),
    [anon_sym_COLON] = ACTIONS(1644),
    [anon_sym_and] = ACTIONS(3245),
    [anon_sym_or] = ACTIONS(3247),
    [sym_comment] = ACTIONS(72),
  },
  [1704] = {
    [sym__expression] = STATE(1845),
    [sym__primary_expression] = STATE(1179),
    [sym_not_operator] = STATE(1845),
    [sym_boolean_operator] = STATE(1845),
    [sym_binary_operator] = STATE(1179),
    [sym_unary_operator] = STATE(1179),
    [sym_comparison_operator] = STATE(1845),
    [sym_lambda] = STATE(1845),
    [sym_attribute] = STATE(1179),
    [sym_subscript] = STATE(1179),
    [sym_call] = STATE(1179),
    [sym_list] = STATE(1179),
    [sym_list_comprehension] = STATE(1179),
    [sym_dictionary] = STATE(1179),
    [sym_dictionary_comprehension] = STATE(1179),
    [sym_set] = STATE(1179),
    [sym_set_comprehension] = STATE(1179),
    [sym_parenthesized_expression] = STATE(1179),
    [sym_tuple] = STATE(1179),
    [sym_generator_expression] = STATE(1179),
    [sym_conditional_expression] = STATE(1845),
    [sym_concatenated_string] = STATE(1179),
    [sym_await] = STATE(1845),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_not] = ACTIONS(2472),
    [anon_sym_PLUS] = ACTIONS(2474),
    [anon_sym_DASH] = ACTIONS(2474),
    [anon_sym_TILDE] = ACTIONS(2474),
    [anon_sym_lambda] = ACTIONS(2476),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(2478),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(2480),
    [sym_integer] = ACTIONS(2482),
    [sym_float] = ACTIONS(2482),
    [sym_identifier] = ACTIONS(2482),
    [sym_true] = ACTIONS(2482),
    [sym_false] = ACTIONS(2482),
    [sym_none] = ACTIONS(2482),
    [anon_sym_await] = ACTIONS(2484),
    [sym_comment] = ACTIONS(72),
  },
  [1705] = {
    [aux_sym_concatenated_string_repeat1] = STATE(1705),
    [anon_sym_DOT] = ACTIONS(1862),
    [anon_sym_LPAREN] = ACTIONS(1862),
    [anon_sym_RPAREN] = ACTIONS(1862),
    [anon_sym_COMMA] = ACTIONS(1862),
    [anon_sym_STAR] = ACTIONS(1864),
    [anon_sym_GT_GT] = ACTIONS(1862),
    [anon_sym_if] = ACTIONS(1862),
    [anon_sym_COLON] = ACTIONS(1862),
    [anon_sym_in] = ACTIONS(1862),
    [anon_sym_AT] = ACTIONS(1862),
    [anon_sym_not] = ACTIONS(1862),
    [anon_sym_and] = ACTIONS(1862),
    [anon_sym_or] = ACTIONS(1862),
    [anon_sym_PLUS] = ACTIONS(1862),
    [anon_sym_DASH] = ACTIONS(1862),
    [anon_sym_SLASH] = ACTIONS(1864),
    [anon_sym_PERCENT] = ACTIONS(1862),
    [anon_sym_SLASH_SLASH] = ACTIONS(1862),
    [anon_sym_STAR_STAR] = ACTIONS(1862),
    [anon_sym_PIPE] = ACTIONS(1862),
    [anon_sym_AMP] = ACTIONS(1862),
    [anon_sym_CARET] = ACTIONS(1862),
    [anon_sym_LT_LT] = ACTIONS(1862),
    [anon_sym_LT] = ACTIONS(1864),
    [anon_sym_LT_EQ] = ACTIONS(1862),
    [anon_sym_EQ_EQ] = ACTIONS(1862),
    [anon_sym_BANG_EQ] = ACTIONS(1862),
    [anon_sym_GT_EQ] = ACTIONS(1862),
    [anon_sym_GT] = ACTIONS(1864),
    [anon_sym_LT_GT] = ACTIONS(1862),
    [anon_sym_is] = ACTIONS(1862),
    [anon_sym_LBRACK] = ACTIONS(1862),
    [sym_string] = ACTIONS(4139),
    [sym_comment] = ACTIONS(72),
  },
  [1706] = {
    [anon_sym_if] = ACTIONS(1921),
    [anon_sym_else] = ACTIONS(4142),
    [anon_sym_and] = ACTIONS(1925),
    [anon_sym_or] = ACTIONS(1927),
    [sym_comment] = ACTIONS(72),
  },
  [1707] = {
    [anon_sym_RPAREN] = ACTIONS(1953),
    [anon_sym_COMMA] = ACTIONS(1953),
    [anon_sym_if] = ACTIONS(1953),
    [anon_sym_COLON] = ACTIONS(1953),
    [anon_sym_and] = ACTIONS(3245),
    [anon_sym_or] = ACTIONS(1953),
    [sym_comment] = ACTIONS(72),
  },
  [1708] = {
    [sym_argument_list] = STATE(251),
    [sym_generator_expression] = STATE(251),
    [anon_sym_DOT] = ACTIONS(1980),
    [anon_sym_LPAREN] = ACTIONS(424),
    [anon_sym_RPAREN] = ACTIONS(1980),
    [anon_sym_COMMA] = ACTIONS(1980),
    [anon_sym_STAR] = ACTIONS(1982),
    [anon_sym_GT_GT] = ACTIONS(1980),
    [anon_sym_if] = ACTIONS(1980),
    [anon_sym_COLON] = ACTIONS(1980),
    [anon_sym_in] = ACTIONS(1980),
    [anon_sym_AT] = ACTIONS(1980),
    [anon_sym_not] = ACTIONS(1980),
    [anon_sym_and] = ACTIONS(1980),
    [anon_sym_or] = ACTIONS(1980),
    [anon_sym_PLUS] = ACTIONS(1980),
    [anon_sym_DASH] = ACTIONS(1980),
    [anon_sym_SLASH] = ACTIONS(1982),
    [anon_sym_PERCENT] = ACTIONS(1980),
    [anon_sym_SLASH_SLASH] = ACTIONS(1980),
    [anon_sym_STAR_STAR] = ACTIONS(3261),
    [anon_sym_PIPE] = ACTIONS(1980),
    [anon_sym_AMP] = ACTIONS(1980),
    [anon_sym_CARET] = ACTIONS(1980),
    [anon_sym_LT_LT] = ACTIONS(1980),
    [anon_sym_LT] = ACTIONS(1982),
    [anon_sym_LT_EQ] = ACTIONS(1980),
    [anon_sym_EQ_EQ] = ACTIONS(1980),
    [anon_sym_BANG_EQ] = ACTIONS(1980),
    [anon_sym_GT_EQ] = ACTIONS(1980),
    [anon_sym_GT] = ACTIONS(1982),
    [anon_sym_LT_GT] = ACTIONS(1980),
    [anon_sym_is] = ACTIONS(1980),
    [anon_sym_LBRACK] = ACTIONS(1980),
    [sym_comment] = ACTIONS(72),
  },
  [1709] = {
    [sym_argument_list] = STATE(251),
    [sym_generator_expression] = STATE(251),
    [anon_sym_DOT] = ACTIONS(1980),
    [anon_sym_LPAREN] = ACTIONS(424),
    [anon_sym_RPAREN] = ACTIONS(1980),
    [anon_sym_COMMA] = ACTIONS(1980),
    [anon_sym_STAR] = ACTIONS(3249),
    [anon_sym_GT_GT] = ACTIONS(1980),
    [anon_sym_if] = ACTIONS(1980),
    [anon_sym_COLON] = ACTIONS(1980),
    [anon_sym_in] = ACTIONS(1980),
    [anon_sym_AT] = ACTIONS(3255),
    [anon_sym_not] = ACTIONS(1980),
    [anon_sym_and] = ACTIONS(1980),
    [anon_sym_or] = ACTIONS(1980),
    [anon_sym_PLUS] = ACTIONS(3259),
    [anon_sym_DASH] = ACTIONS(3259),
    [anon_sym_SLASH] = ACTIONS(3249),
    [anon_sym_PERCENT] = ACTIONS(3255),
    [anon_sym_SLASH_SLASH] = ACTIONS(3255),
    [anon_sym_STAR_STAR] = ACTIONS(3261),
    [anon_sym_PIPE] = ACTIONS(1980),
    [anon_sym_AMP] = ACTIONS(1980),
    [anon_sym_CARET] = ACTIONS(1980),
    [anon_sym_LT_LT] = ACTIONS(1980),
    [anon_sym_LT] = ACTIONS(1982),
    [anon_sym_LT_EQ] = ACTIONS(1980),
    [anon_sym_EQ_EQ] = ACTIONS(1980),
    [anon_sym_BANG_EQ] = ACTIONS(1980),
    [anon_sym_GT_EQ] = ACTIONS(1980),
    [anon_sym_GT] = ACTIONS(1982),
    [anon_sym_LT_GT] = ACTIONS(1980),
    [anon_sym_is] = ACTIONS(1980),
    [anon_sym_LBRACK] = ACTIONS(1980),
    [sym_comment] = ACTIONS(72),
  },
  [1710] = {
    [sym_argument_list] = STATE(251),
    [sym_generator_expression] = STATE(251),
    [anon_sym_DOT] = ACTIONS(422),
    [anon_sym_LPAREN] = ACTIONS(424),
    [anon_sym_RPAREN] = ACTIONS(1984),
    [anon_sym_COMMA] = ACTIONS(1984),
    [anon_sym_STAR] = ACTIONS(3249),
    [anon_sym_GT_GT] = ACTIONS(3251),
    [anon_sym_if] = ACTIONS(1984),
    [anon_sym_COLON] = ACTIONS(1984),
    [anon_sym_in] = ACTIONS(1984),
    [anon_sym_AT] = ACTIONS(3255),
    [anon_sym_not] = ACTIONS(1984),
    [anon_sym_and] = ACTIONS(1984),
    [anon_sym_or] = ACTIONS(1984),
    [anon_sym_PLUS] = ACTIONS(3259),
    [anon_sym_DASH] = ACTIONS(3259),
    [anon_sym_SLASH] = ACTIONS(3249),
    [anon_sym_PERCENT] = ACTIONS(3255),
    [anon_sym_SLASH_SLASH] = ACTIONS(3255),
    [anon_sym_STAR_STAR] = ACTIONS(3261),
    [anon_sym_PIPE] = ACTIONS(3263),
    [anon_sym_AMP] = ACTIONS(3265),
    [anon_sym_CARET] = ACTIONS(3267),
    [anon_sym_LT_LT] = ACTIONS(3251),
    [anon_sym_LT] = ACTIONS(1986),
    [anon_sym_LT_EQ] = ACTIONS(1984),
    [anon_sym_EQ_EQ] = ACTIONS(1984),
    [anon_sym_BANG_EQ] = ACTIONS(1984),
    [anon_sym_GT_EQ] = ACTIONS(1984),
    [anon_sym_GT] = ACTIONS(1986),
    [anon_sym_LT_GT] = ACTIONS(1984),
    [anon_sym_is] = ACTIONS(1984),
    [anon_sym_LBRACK] = ACTIONS(450),
    [sym_comment] = ACTIONS(72),
  },
  [1711] = {
    [sym__primary_expression] = STATE(1847),
    [sym_binary_operator] = STATE(1847),
    [sym_unary_operator] = STATE(1847),
    [sym_attribute] = STATE(1847),
    [sym_subscript] = STATE(1847),
    [sym_call] = STATE(1847),
    [sym_list] = STATE(1847),
    [sym_list_comprehension] = STATE(1847),
    [sym_dictionary] = STATE(1847),
    [sym_dictionary_comprehension] = STATE(1847),
    [sym_set] = STATE(1847),
    [sym_set_comprehension] = STATE(1847),
    [sym_parenthesized_expression] = STATE(1847),
    [sym_tuple] = STATE(1847),
    [sym_generator_expression] = STATE(1847),
    [sym_concatenated_string] = STATE(1847),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_PLUS] = ACTIONS(2474),
    [anon_sym_DASH] = ACTIONS(2474),
    [anon_sym_TILDE] = ACTIONS(2474),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(4144),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(2480),
    [sym_integer] = ACTIONS(4146),
    [sym_float] = ACTIONS(4146),
    [sym_identifier] = ACTIONS(4146),
    [sym_true] = ACTIONS(4146),
    [sym_false] = ACTIONS(4146),
    [sym_none] = ACTIONS(4146),
    [sym_comment] = ACTIONS(72),
  },
  [1712] = {
    [sym_argument_list] = STATE(251),
    [sym_generator_expression] = STATE(251),
    [anon_sym_DOT] = ACTIONS(1980),
    [anon_sym_LPAREN] = ACTIONS(424),
    [anon_sym_RPAREN] = ACTIONS(1980),
    [anon_sym_COMMA] = ACTIONS(1980),
    [anon_sym_STAR] = ACTIONS(3249),
    [anon_sym_GT_GT] = ACTIONS(1980),
    [anon_sym_if] = ACTIONS(1980),
    [anon_sym_COLON] = ACTIONS(1980),
    [anon_sym_in] = ACTIONS(1980),
    [anon_sym_AT] = ACTIONS(3255),
    [anon_sym_not] = ACTIONS(1980),
    [anon_sym_and] = ACTIONS(1980),
    [anon_sym_or] = ACTIONS(1980),
    [anon_sym_PLUS] = ACTIONS(1980),
    [anon_sym_DASH] = ACTIONS(1980),
    [anon_sym_SLASH] = ACTIONS(3249),
    [anon_sym_PERCENT] = ACTIONS(3255),
    [anon_sym_SLASH_SLASH] = ACTIONS(3255),
    [anon_sym_STAR_STAR] = ACTIONS(3261),
    [anon_sym_PIPE] = ACTIONS(1980),
    [anon_sym_AMP] = ACTIONS(1980),
    [anon_sym_CARET] = ACTIONS(1980),
    [anon_sym_LT_LT] = ACTIONS(1980),
    [anon_sym_LT] = ACTIONS(1982),
    [anon_sym_LT_EQ] = ACTIONS(1980),
    [anon_sym_EQ_EQ] = ACTIONS(1980),
    [anon_sym_BANG_EQ] = ACTIONS(1980),
    [anon_sym_GT_EQ] = ACTIONS(1980),
    [anon_sym_GT] = ACTIONS(1982),
    [anon_sym_LT_GT] = ACTIONS(1980),
    [anon_sym_is] = ACTIONS(1980),
    [anon_sym_LBRACK] = ACTIONS(1980),
    [sym_comment] = ACTIONS(72),
  },
  [1713] = {
    [sym_argument_list] = STATE(251),
    [sym_generator_expression] = STATE(251),
    [anon_sym_DOT] = ACTIONS(1980),
    [anon_sym_LPAREN] = ACTIONS(424),
    [anon_sym_RPAREN] = ACTIONS(1980),
    [anon_sym_COMMA] = ACTIONS(1980),
    [anon_sym_STAR] = ACTIONS(3249),
    [anon_sym_GT_GT] = ACTIONS(3251),
    [anon_sym_if] = ACTIONS(1980),
    [anon_sym_COLON] = ACTIONS(1980),
    [anon_sym_in] = ACTIONS(1980),
    [anon_sym_AT] = ACTIONS(3255),
    [anon_sym_not] = ACTIONS(1980),
    [anon_sym_and] = ACTIONS(1980),
    [anon_sym_or] = ACTIONS(1980),
    [anon_sym_PLUS] = ACTIONS(3259),
    [anon_sym_DASH] = ACTIONS(3259),
    [anon_sym_SLASH] = ACTIONS(3249),
    [anon_sym_PERCENT] = ACTIONS(3255),
    [anon_sym_SLASH_SLASH] = ACTIONS(3255),
    [anon_sym_STAR_STAR] = ACTIONS(3261),
    [anon_sym_PIPE] = ACTIONS(1980),
    [anon_sym_AMP] = ACTIONS(3265),
    [anon_sym_CARET] = ACTIONS(3267),
    [anon_sym_LT_LT] = ACTIONS(3251),
    [anon_sym_LT] = ACTIONS(1982),
    [anon_sym_LT_EQ] = ACTIONS(1980),
    [anon_sym_EQ_EQ] = ACTIONS(1980),
    [anon_sym_BANG_EQ] = ACTIONS(1980),
    [anon_sym_GT_EQ] = ACTIONS(1980),
    [anon_sym_GT] = ACTIONS(1982),
    [anon_sym_LT_GT] = ACTIONS(1980),
    [anon_sym_is] = ACTIONS(1980),
    [anon_sym_LBRACK] = ACTIONS(1980),
    [sym_comment] = ACTIONS(72),
  },
  [1714] = {
    [sym_argument_list] = STATE(251),
    [sym_generator_expression] = STATE(251),
    [anon_sym_DOT] = ACTIONS(1980),
    [anon_sym_LPAREN] = ACTIONS(424),
    [anon_sym_RPAREN] = ACTIONS(1980),
    [anon_sym_COMMA] = ACTIONS(1980),
    [anon_sym_STAR] = ACTIONS(3249),
    [anon_sym_GT_GT] = ACTIONS(3251),
    [anon_sym_if] = ACTIONS(1980),
    [anon_sym_COLON] = ACTIONS(1980),
    [anon_sym_in] = ACTIONS(1980),
    [anon_sym_AT] = ACTIONS(3255),
    [anon_sym_not] = ACTIONS(1980),
    [anon_sym_and] = ACTIONS(1980),
    [anon_sym_or] = ACTIONS(1980),
    [anon_sym_PLUS] = ACTIONS(3259),
    [anon_sym_DASH] = ACTIONS(3259),
    [anon_sym_SLASH] = ACTIONS(3249),
    [anon_sym_PERCENT] = ACTIONS(3255),
    [anon_sym_SLASH_SLASH] = ACTIONS(3255),
    [anon_sym_STAR_STAR] = ACTIONS(3261),
    [anon_sym_PIPE] = ACTIONS(1980),
    [anon_sym_AMP] = ACTIONS(1980),
    [anon_sym_CARET] = ACTIONS(3267),
    [anon_sym_LT_LT] = ACTIONS(3251),
    [anon_sym_LT] = ACTIONS(1982),
    [anon_sym_LT_EQ] = ACTIONS(1980),
    [anon_sym_EQ_EQ] = ACTIONS(1980),
    [anon_sym_BANG_EQ] = ACTIONS(1980),
    [anon_sym_GT_EQ] = ACTIONS(1980),
    [anon_sym_GT] = ACTIONS(1982),
    [anon_sym_LT_GT] = ACTIONS(1980),
    [anon_sym_is] = ACTIONS(1980),
    [anon_sym_LBRACK] = ACTIONS(1980),
    [sym_comment] = ACTIONS(72),
  },
  [1715] = {
    [sym_argument_list] = STATE(251),
    [sym_generator_expression] = STATE(251),
    [anon_sym_DOT] = ACTIONS(1980),
    [anon_sym_LPAREN] = ACTIONS(424),
    [anon_sym_RPAREN] = ACTIONS(1980),
    [anon_sym_COMMA] = ACTIONS(1980),
    [anon_sym_STAR] = ACTIONS(3249),
    [anon_sym_GT_GT] = ACTIONS(3251),
    [anon_sym_if] = ACTIONS(1980),
    [anon_sym_COLON] = ACTIONS(1980),
    [anon_sym_in] = ACTIONS(1980),
    [anon_sym_AT] = ACTIONS(3255),
    [anon_sym_not] = ACTIONS(1980),
    [anon_sym_and] = ACTIONS(1980),
    [anon_sym_or] = ACTIONS(1980),
    [anon_sym_PLUS] = ACTIONS(3259),
    [anon_sym_DASH] = ACTIONS(3259),
    [anon_sym_SLASH] = ACTIONS(3249),
    [anon_sym_PERCENT] = ACTIONS(3255),
    [anon_sym_SLASH_SLASH] = ACTIONS(3255),
    [anon_sym_STAR_STAR] = ACTIONS(3261),
    [anon_sym_PIPE] = ACTIONS(1980),
    [anon_sym_AMP] = ACTIONS(1980),
    [anon_sym_CARET] = ACTIONS(1980),
    [anon_sym_LT_LT] = ACTIONS(3251),
    [anon_sym_LT] = ACTIONS(1982),
    [anon_sym_LT_EQ] = ACTIONS(1980),
    [anon_sym_EQ_EQ] = ACTIONS(1980),
    [anon_sym_BANG_EQ] = ACTIONS(1980),
    [anon_sym_GT_EQ] = ACTIONS(1980),
    [anon_sym_GT] = ACTIONS(1982),
    [anon_sym_LT_GT] = ACTIONS(1980),
    [anon_sym_is] = ACTIONS(1980),
    [anon_sym_LBRACK] = ACTIONS(1980),
    [sym_comment] = ACTIONS(72),
  },
  [1716] = {
    [aux_sym_comparison_operator_repeat1] = STATE(1716),
    [anon_sym_RPAREN] = ACTIONS(1984),
    [anon_sym_COMMA] = ACTIONS(1984),
    [anon_sym_if] = ACTIONS(1984),
    [anon_sym_COLON] = ACTIONS(1984),
    [anon_sym_in] = ACTIONS(4148),
    [anon_sym_not] = ACTIONS(4151),
    [anon_sym_and] = ACTIONS(1984),
    [anon_sym_or] = ACTIONS(1984),
    [anon_sym_LT] = ACTIONS(4154),
    [anon_sym_LT_EQ] = ACTIONS(4148),
    [anon_sym_EQ_EQ] = ACTIONS(4148),
    [anon_sym_BANG_EQ] = ACTIONS(4148),
    [anon_sym_GT_EQ] = ACTIONS(4148),
    [anon_sym_GT] = ACTIONS(4154),
    [anon_sym_LT_GT] = ACTIONS(4148),
    [anon_sym_is] = ACTIONS(4157),
    [sym_comment] = ACTIONS(72),
  },
  [1717] = {
    [sym__expression] = STATE(1848),
    [sym__primary_expression] = STATE(215),
    [sym_not_operator] = STATE(1848),
    [sym_boolean_operator] = STATE(1848),
    [sym_binary_operator] = STATE(215),
    [sym_unary_operator] = STATE(215),
    [sym_comparison_operator] = STATE(1848),
    [sym_lambda] = STATE(1848),
    [sym_attribute] = STATE(215),
    [sym_subscript] = STATE(215),
    [sym_call] = STATE(215),
    [sym_list] = STATE(215),
    [sym_list_comprehension] = STATE(215),
    [sym_dictionary] = STATE(215),
    [sym_dictionary_comprehension] = STATE(215),
    [sym_set] = STATE(215),
    [sym_set_comprehension] = STATE(215),
    [sym_parenthesized_expression] = STATE(215),
    [sym_tuple] = STATE(215),
    [sym_generator_expression] = STATE(215),
    [sym_conditional_expression] = STATE(1848),
    [sym_concatenated_string] = STATE(215),
    [sym_await] = STATE(1848),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_not] = ACTIONS(384),
    [anon_sym_PLUS] = ACTIONS(386),
    [anon_sym_DASH] = ACTIONS(386),
    [anon_sym_TILDE] = ACTIONS(386),
    [anon_sym_lambda] = ACTIONS(388),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(390),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(392),
    [sym_integer] = ACTIONS(394),
    [sym_float] = ACTIONS(394),
    [sym_identifier] = ACTIONS(394),
    [sym_true] = ACTIONS(394),
    [sym_false] = ACTIONS(394),
    [sym_none] = ACTIONS(394),
    [anon_sym_await] = ACTIONS(396),
    [sym_comment] = ACTIONS(72),
  },
  [1718] = {
    [sym_default_parameter] = STATE(822),
    [sym_typed_default_parameter] = STATE(822),
    [sym_list_splat] = STATE(1505),
    [sym_dictionary_splat] = STATE(1505),
    [sym_typed_parameter] = STATE(822),
    [sym_tuple] = STATE(822),
    [anon_sym_LPAREN] = ACTIONS(222),
    [anon_sym_STAR] = ACTIONS(1564),
    [anon_sym_print] = ACTIONS(3273),
    [anon_sym_exec] = ACTIONS(3273),
    [sym_identifier] = ACTIONS(3275),
    [sym_comment] = ACTIONS(72),
  },
  [1719] = {
    [anon_sym_RPAREN] = ACTIONS(716),
    [anon_sym_COMMA] = ACTIONS(716),
    [anon_sym_if] = ACTIONS(716),
    [anon_sym_EQ] = ACTIONS(716),
    [anon_sym_and] = ACTIONS(3862),
    [anon_sym_or] = ACTIONS(3864),
    [sym_comment] = ACTIONS(72),
  },
  [1720] = {
    [sym__expression] = STATE(1849),
    [sym__primary_expression] = STATE(1516),
    [sym_not_operator] = STATE(1849),
    [sym_boolean_operator] = STATE(1849),
    [sym_binary_operator] = STATE(1516),
    [sym_unary_operator] = STATE(1516),
    [sym_comparison_operator] = STATE(1849),
    [sym_lambda] = STATE(1849),
    [sym_attribute] = STATE(1516),
    [sym_subscript] = STATE(1516),
    [sym_call] = STATE(1516),
    [sym_list] = STATE(1516),
    [sym_list_comprehension] = STATE(1516),
    [sym_dictionary] = STATE(1516),
    [sym_dictionary_comprehension] = STATE(1516),
    [sym_set] = STATE(1516),
    [sym_set_comprehension] = STATE(1516),
    [sym_parenthesized_expression] = STATE(1516),
    [sym_tuple] = STATE(1516),
    [sym_generator_expression] = STATE(1516),
    [sym_conditional_expression] = STATE(1849),
    [sym_concatenated_string] = STATE(1516),
    [sym_await] = STATE(1849),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_not] = ACTIONS(3279),
    [anon_sym_PLUS] = ACTIONS(3281),
    [anon_sym_DASH] = ACTIONS(3281),
    [anon_sym_TILDE] = ACTIONS(3281),
    [anon_sym_lambda] = ACTIONS(3283),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(3285),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(3287),
    [sym_integer] = ACTIONS(3289),
    [sym_float] = ACTIONS(3289),
    [sym_identifier] = ACTIONS(3289),
    [sym_true] = ACTIONS(3289),
    [sym_false] = ACTIONS(3289),
    [sym_none] = ACTIONS(3289),
    [anon_sym_await] = ACTIONS(3291),
    [sym_comment] = ACTIONS(72),
  },
  [1721] = {
    [anon_sym_COLON] = ACTIONS(4160),
    [sym_comment] = ACTIONS(72),
  },
  [1722] = {
    [aux_sym_concatenated_string_repeat1] = STATE(1851),
    [anon_sym_DOT] = ACTIONS(886),
    [anon_sym_LPAREN] = ACTIONS(886),
    [anon_sym_RPAREN] = ACTIONS(886),
    [anon_sym_COMMA] = ACTIONS(886),
    [anon_sym_STAR] = ACTIONS(888),
    [anon_sym_GT_GT] = ACTIONS(886),
    [anon_sym_if] = ACTIONS(886),
    [anon_sym_in] = ACTIONS(886),
    [anon_sym_EQ] = ACTIONS(888),
    [anon_sym_AT] = ACTIONS(886),
    [anon_sym_not] = ACTIONS(886),
    [anon_sym_and] = ACTIONS(886),
    [anon_sym_or] = ACTIONS(886),
    [anon_sym_PLUS] = ACTIONS(886),
    [anon_sym_DASH] = ACTIONS(886),
    [anon_sym_SLASH] = ACTIONS(888),
    [anon_sym_PERCENT] = ACTIONS(886),
    [anon_sym_SLASH_SLASH] = ACTIONS(886),
    [anon_sym_STAR_STAR] = ACTIONS(886),
    [anon_sym_PIPE] = ACTIONS(886),
    [anon_sym_AMP] = ACTIONS(886),
    [anon_sym_CARET] = ACTIONS(886),
    [anon_sym_LT_LT] = ACTIONS(886),
    [anon_sym_LT] = ACTIONS(888),
    [anon_sym_LT_EQ] = ACTIONS(886),
    [anon_sym_EQ_EQ] = ACTIONS(886),
    [anon_sym_BANG_EQ] = ACTIONS(886),
    [anon_sym_GT_EQ] = ACTIONS(886),
    [anon_sym_GT] = ACTIONS(888),
    [anon_sym_LT_GT] = ACTIONS(886),
    [anon_sym_is] = ACTIONS(886),
    [anon_sym_LBRACK] = ACTIONS(886),
    [sym_string] = ACTIONS(4162),
    [sym_comment] = ACTIONS(72),
  },
  [1723] = {
    [sym__expression] = STATE(1852),
    [sym__primary_expression] = STATE(513),
    [sym_not_operator] = STATE(1852),
    [sym_boolean_operator] = STATE(1852),
    [sym_binary_operator] = STATE(513),
    [sym_unary_operator] = STATE(513),
    [sym_comparison_operator] = STATE(1852),
    [sym_lambda] = STATE(1852),
    [sym_attribute] = STATE(513),
    [sym_subscript] = STATE(513),
    [sym_call] = STATE(513),
    [sym_list] = STATE(513),
    [sym_list_comprehension] = STATE(513),
    [sym_dictionary] = STATE(513),
    [sym_dictionary_comprehension] = STATE(513),
    [sym_set] = STATE(513),
    [sym_set_comprehension] = STATE(513),
    [sym_parenthesized_expression] = STATE(513),
    [sym_tuple] = STATE(513),
    [sym_generator_expression] = STATE(513),
    [sym_conditional_expression] = STATE(1852),
    [sym_concatenated_string] = STATE(513),
    [sym_await] = STATE(1852),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_not] = ACTIONS(914),
    [anon_sym_PLUS] = ACTIONS(916),
    [anon_sym_DASH] = ACTIONS(916),
    [anon_sym_TILDE] = ACTIONS(916),
    [anon_sym_lambda] = ACTIONS(918),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(920),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(922),
    [sym_integer] = ACTIONS(924),
    [sym_float] = ACTIONS(924),
    [sym_identifier] = ACTIONS(924),
    [sym_true] = ACTIONS(924),
    [sym_false] = ACTIONS(924),
    [sym_none] = ACTIONS(924),
    [anon_sym_await] = ACTIONS(926),
    [sym_comment] = ACTIONS(72),
  },
  [1724] = {
    [sym__expression] = STATE(604),
    [sym__primary_expression] = STATE(1516),
    [sym_not_operator] = STATE(604),
    [sym_boolean_operator] = STATE(604),
    [sym_binary_operator] = STATE(1516),
    [sym_unary_operator] = STATE(1516),
    [sym_comparison_operator] = STATE(604),
    [sym_lambda] = STATE(604),
    [sym_attribute] = STATE(1516),
    [sym_subscript] = STATE(1516),
    [sym_call] = STATE(1516),
    [sym_list] = STATE(1516),
    [sym_list_comprehension] = STATE(1516),
    [sym_dictionary] = STATE(1516),
    [sym_dictionary_comprehension] = STATE(1516),
    [sym_set] = STATE(1516),
    [sym_set_comprehension] = STATE(1516),
    [sym_parenthesized_expression] = STATE(1516),
    [sym_tuple] = STATE(1516),
    [sym_generator_expression] = STATE(1516),
    [sym_conditional_expression] = STATE(604),
    [sym_concatenated_string] = STATE(1516),
    [sym_await] = STATE(604),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_not] = ACTIONS(3279),
    [anon_sym_PLUS] = ACTIONS(3281),
    [anon_sym_DASH] = ACTIONS(3281),
    [anon_sym_TILDE] = ACTIONS(3281),
    [anon_sym_lambda] = ACTIONS(3283),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(3285),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(3287),
    [sym_integer] = ACTIONS(3289),
    [sym_float] = ACTIONS(3289),
    [sym_identifier] = ACTIONS(3289),
    [sym_true] = ACTIONS(3289),
    [sym_false] = ACTIONS(3289),
    [sym_none] = ACTIONS(3289),
    [anon_sym_await] = ACTIONS(3291),
    [sym_comment] = ACTIONS(72),
  },
  [1725] = {
    [sym__expression] = STATE(1853),
    [sym__primary_expression] = STATE(1516),
    [sym_not_operator] = STATE(1853),
    [sym_boolean_operator] = STATE(1853),
    [sym_binary_operator] = STATE(1516),
    [sym_unary_operator] = STATE(1516),
    [sym_comparison_operator] = STATE(1853),
    [sym_lambda] = STATE(1853),
    [sym_attribute] = STATE(1516),
    [sym_subscript] = STATE(1516),
    [sym_call] = STATE(1516),
    [sym_list] = STATE(1516),
    [sym_list_comprehension] = STATE(1516),
    [sym_dictionary] = STATE(1516),
    [sym_dictionary_comprehension] = STATE(1516),
    [sym_set] = STATE(1516),
    [sym_set_comprehension] = STATE(1516),
    [sym_parenthesized_expression] = STATE(1516),
    [sym_tuple] = STATE(1516),
    [sym_generator_expression] = STATE(1516),
    [sym_conditional_expression] = STATE(1853),
    [sym_concatenated_string] = STATE(1516),
    [sym_await] = STATE(1853),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_not] = ACTIONS(3279),
    [anon_sym_PLUS] = ACTIONS(3281),
    [anon_sym_DASH] = ACTIONS(3281),
    [anon_sym_TILDE] = ACTIONS(3281),
    [anon_sym_lambda] = ACTIONS(3283),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(3285),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(3287),
    [sym_integer] = ACTIONS(3289),
    [sym_float] = ACTIONS(3289),
    [sym_identifier] = ACTIONS(3289),
    [sym_true] = ACTIONS(3289),
    [sym_false] = ACTIONS(3289),
    [sym_none] = ACTIONS(3289),
    [anon_sym_await] = ACTIONS(3291),
    [sym_comment] = ACTIONS(72),
  },
  [1726] = {
    [sym__primary_expression] = STATE(1854),
    [sym_binary_operator] = STATE(1854),
    [sym_unary_operator] = STATE(1854),
    [sym_attribute] = STATE(1854),
    [sym_subscript] = STATE(1854),
    [sym_call] = STATE(1854),
    [sym_list] = STATE(1854),
    [sym_list_comprehension] = STATE(1854),
    [sym_dictionary] = STATE(1854),
    [sym_dictionary_comprehension] = STATE(1854),
    [sym_set] = STATE(1854),
    [sym_set_comprehension] = STATE(1854),
    [sym_parenthesized_expression] = STATE(1854),
    [sym_tuple] = STATE(1854),
    [sym_generator_expression] = STATE(1854),
    [sym_concatenated_string] = STATE(1854),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_PLUS] = ACTIONS(3281),
    [anon_sym_DASH] = ACTIONS(3281),
    [anon_sym_TILDE] = ACTIONS(3281),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(4164),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(3287),
    [sym_integer] = ACTIONS(4166),
    [sym_float] = ACTIONS(4166),
    [sym_identifier] = ACTIONS(4166),
    [sym_true] = ACTIONS(4166),
    [sym_false] = ACTIONS(4166),
    [sym_none] = ACTIONS(4166),
    [sym_comment] = ACTIONS(72),
  },
  [1727] = {
    [sym__primary_expression] = STATE(1855),
    [sym_binary_operator] = STATE(1855),
    [sym_unary_operator] = STATE(1855),
    [sym_attribute] = STATE(1855),
    [sym_subscript] = STATE(1855),
    [sym_call] = STATE(1855),
    [sym_list] = STATE(1855),
    [sym_list_comprehension] = STATE(1855),
    [sym_dictionary] = STATE(1855),
    [sym_dictionary_comprehension] = STATE(1855),
    [sym_set] = STATE(1855),
    [sym_set_comprehension] = STATE(1855),
    [sym_parenthesized_expression] = STATE(1855),
    [sym_tuple] = STATE(1855),
    [sym_generator_expression] = STATE(1855),
    [sym_concatenated_string] = STATE(1855),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_PLUS] = ACTIONS(3281),
    [anon_sym_DASH] = ACTIONS(3281),
    [anon_sym_TILDE] = ACTIONS(3281),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(4168),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(3287),
    [sym_integer] = ACTIONS(4170),
    [sym_float] = ACTIONS(4170),
    [sym_identifier] = ACTIONS(4170),
    [sym_true] = ACTIONS(4170),
    [sym_false] = ACTIONS(4170),
    [sym_none] = ACTIONS(4170),
    [sym_comment] = ACTIONS(72),
  },
  [1728] = {
    [sym__primary_expression] = STATE(1856),
    [sym_binary_operator] = STATE(1856),
    [sym_unary_operator] = STATE(1856),
    [sym_attribute] = STATE(1856),
    [sym_subscript] = STATE(1856),
    [sym_call] = STATE(1856),
    [sym_list] = STATE(1856),
    [sym_list_comprehension] = STATE(1856),
    [sym_dictionary] = STATE(1856),
    [sym_dictionary_comprehension] = STATE(1856),
    [sym_set] = STATE(1856),
    [sym_set_comprehension] = STATE(1856),
    [sym_parenthesized_expression] = STATE(1856),
    [sym_tuple] = STATE(1856),
    [sym_generator_expression] = STATE(1856),
    [sym_concatenated_string] = STATE(1856),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_PLUS] = ACTIONS(3281),
    [anon_sym_DASH] = ACTIONS(3281),
    [anon_sym_TILDE] = ACTIONS(3281),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(4172),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(3287),
    [sym_integer] = ACTIONS(4174),
    [sym_float] = ACTIONS(4174),
    [sym_identifier] = ACTIONS(4174),
    [sym_true] = ACTIONS(4174),
    [sym_false] = ACTIONS(4174),
    [sym_none] = ACTIONS(4174),
    [sym_comment] = ACTIONS(72),
  },
  [1729] = {
    [anon_sym_in] = ACTIONS(4176),
    [sym_comment] = ACTIONS(72),
  },
  [1730] = {
    [sym__primary_expression] = STATE(1858),
    [sym_binary_operator] = STATE(1858),
    [sym_unary_operator] = STATE(1858),
    [sym_attribute] = STATE(1858),
    [sym_subscript] = STATE(1858),
    [sym_call] = STATE(1858),
    [sym_list] = STATE(1858),
    [sym_list_comprehension] = STATE(1858),
    [sym_dictionary] = STATE(1858),
    [sym_dictionary_comprehension] = STATE(1858),
    [sym_set] = STATE(1858),
    [sym_set_comprehension] = STATE(1858),
    [sym_parenthesized_expression] = STATE(1858),
    [sym_tuple] = STATE(1858),
    [sym_generator_expression] = STATE(1858),
    [sym_concatenated_string] = STATE(1858),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_PLUS] = ACTIONS(3281),
    [anon_sym_DASH] = ACTIONS(3281),
    [anon_sym_TILDE] = ACTIONS(3281),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(4178),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(3287),
    [sym_integer] = ACTIONS(4180),
    [sym_float] = ACTIONS(4180),
    [sym_identifier] = ACTIONS(4180),
    [sym_true] = ACTIONS(4180),
    [sym_false] = ACTIONS(4180),
    [sym_none] = ACTIONS(4180),
    [sym_comment] = ACTIONS(72),
  },
  [1731] = {
    [sym__primary_expression] = STATE(621),
    [sym_binary_operator] = STATE(621),
    [sym_unary_operator] = STATE(621),
    [sym_attribute] = STATE(621),
    [sym_subscript] = STATE(621),
    [sym_call] = STATE(621),
    [sym_list] = STATE(621),
    [sym_list_comprehension] = STATE(621),
    [sym_dictionary] = STATE(621),
    [sym_dictionary_comprehension] = STATE(621),
    [sym_set] = STATE(621),
    [sym_set_comprehension] = STATE(621),
    [sym_parenthesized_expression] = STATE(621),
    [sym_tuple] = STATE(621),
    [sym_generator_expression] = STATE(621),
    [sym_concatenated_string] = STATE(621),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_PLUS] = ACTIONS(3281),
    [anon_sym_DASH] = ACTIONS(3281),
    [anon_sym_TILDE] = ACTIONS(3281),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(1233),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(3287),
    [sym_integer] = ACTIONS(1235),
    [sym_float] = ACTIONS(1235),
    [sym_identifier] = ACTIONS(1235),
    [sym_true] = ACTIONS(1235),
    [sym_false] = ACTIONS(1235),
    [sym_none] = ACTIONS(1235),
    [sym_comment] = ACTIONS(72),
  },
  [1732] = {
    [sym__primary_expression] = STATE(1859),
    [sym_binary_operator] = STATE(1859),
    [sym_unary_operator] = STATE(1859),
    [sym_attribute] = STATE(1859),
    [sym_subscript] = STATE(1859),
    [sym_call] = STATE(1859),
    [sym_list] = STATE(1859),
    [sym_list_comprehension] = STATE(1859),
    [sym_dictionary] = STATE(1859),
    [sym_dictionary_comprehension] = STATE(1859),
    [sym_set] = STATE(1859),
    [sym_set_comprehension] = STATE(1859),
    [sym_parenthesized_expression] = STATE(1859),
    [sym_tuple] = STATE(1859),
    [sym_generator_expression] = STATE(1859),
    [sym_concatenated_string] = STATE(1859),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_PLUS] = ACTIONS(3281),
    [anon_sym_DASH] = ACTIONS(3281),
    [anon_sym_TILDE] = ACTIONS(3281),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(4182),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(3287),
    [sym_integer] = ACTIONS(4184),
    [sym_float] = ACTIONS(4184),
    [sym_identifier] = ACTIONS(4184),
    [sym_true] = ACTIONS(4184),
    [sym_false] = ACTIONS(4184),
    [sym_none] = ACTIONS(4184),
    [sym_comment] = ACTIONS(72),
  },
  [1733] = {
    [sym__primary_expression] = STATE(1860),
    [sym_binary_operator] = STATE(1860),
    [sym_unary_operator] = STATE(1860),
    [sym_attribute] = STATE(1860),
    [sym_subscript] = STATE(1860),
    [sym_call] = STATE(1860),
    [sym_list] = STATE(1860),
    [sym_list_comprehension] = STATE(1860),
    [sym_dictionary] = STATE(1860),
    [sym_dictionary_comprehension] = STATE(1860),
    [sym_set] = STATE(1860),
    [sym_set_comprehension] = STATE(1860),
    [sym_parenthesized_expression] = STATE(1860),
    [sym_tuple] = STATE(1860),
    [sym_generator_expression] = STATE(1860),
    [sym_concatenated_string] = STATE(1860),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_PLUS] = ACTIONS(3281),
    [anon_sym_DASH] = ACTIONS(3281),
    [anon_sym_TILDE] = ACTIONS(3281),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(4186),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(3287),
    [sym_integer] = ACTIONS(4188),
    [sym_float] = ACTIONS(4188),
    [sym_identifier] = ACTIONS(4188),
    [sym_true] = ACTIONS(4188),
    [sym_false] = ACTIONS(4188),
    [sym_none] = ACTIONS(4188),
    [sym_comment] = ACTIONS(72),
  },
  [1734] = {
    [sym__primary_expression] = STATE(1861),
    [sym_binary_operator] = STATE(1861),
    [sym_unary_operator] = STATE(1861),
    [sym_attribute] = STATE(1861),
    [sym_subscript] = STATE(1861),
    [sym_call] = STATE(1861),
    [sym_list] = STATE(1861),
    [sym_list_comprehension] = STATE(1861),
    [sym_dictionary] = STATE(1861),
    [sym_dictionary_comprehension] = STATE(1861),
    [sym_set] = STATE(1861),
    [sym_set_comprehension] = STATE(1861),
    [sym_parenthesized_expression] = STATE(1861),
    [sym_tuple] = STATE(1861),
    [sym_generator_expression] = STATE(1861),
    [sym_concatenated_string] = STATE(1861),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_PLUS] = ACTIONS(3281),
    [anon_sym_DASH] = ACTIONS(3281),
    [anon_sym_TILDE] = ACTIONS(3281),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(4190),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(3287),
    [sym_integer] = ACTIONS(4192),
    [sym_float] = ACTIONS(4192),
    [sym_identifier] = ACTIONS(4192),
    [sym_true] = ACTIONS(4192),
    [sym_false] = ACTIONS(4192),
    [sym_none] = ACTIONS(4192),
    [sym_comment] = ACTIONS(72),
  },
  [1735] = {
    [sym__primary_expression] = STATE(1856),
    [sym_binary_operator] = STATE(1856),
    [sym_unary_operator] = STATE(1856),
    [sym_attribute] = STATE(1856),
    [sym_subscript] = STATE(1856),
    [sym_call] = STATE(1856),
    [sym_list] = STATE(1856),
    [sym_list_comprehension] = STATE(1856),
    [sym_dictionary] = STATE(1856),
    [sym_dictionary_comprehension] = STATE(1856),
    [sym_set] = STATE(1856),
    [sym_set_comprehension] = STATE(1856),
    [sym_parenthesized_expression] = STATE(1856),
    [sym_tuple] = STATE(1856),
    [sym_generator_expression] = STATE(1856),
    [sym_concatenated_string] = STATE(1856),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_not] = ACTIONS(4194),
    [anon_sym_PLUS] = ACTIONS(3281),
    [anon_sym_DASH] = ACTIONS(3281),
    [anon_sym_TILDE] = ACTIONS(3281),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(4172),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(3287),
    [sym_integer] = ACTIONS(4174),
    [sym_float] = ACTIONS(4174),
    [sym_identifier] = ACTIONS(4174),
    [sym_true] = ACTIONS(4174),
    [sym_false] = ACTIONS(4174),
    [sym_none] = ACTIONS(4174),
    [sym_comment] = ACTIONS(72),
  },
  [1736] = {
    [aux_sym_comparison_operator_repeat1] = STATE(1862),
    [anon_sym_RPAREN] = ACTIONS(998),
    [anon_sym_COMMA] = ACTIONS(998),
    [anon_sym_if] = ACTIONS(998),
    [anon_sym_in] = ACTIONS(3870),
    [anon_sym_EQ] = ACTIONS(1000),
    [anon_sym_not] = ACTIONS(3874),
    [anon_sym_and] = ACTIONS(998),
    [anon_sym_or] = ACTIONS(998),
    [anon_sym_LT] = ACTIONS(3886),
    [anon_sym_LT_EQ] = ACTIONS(3870),
    [anon_sym_EQ_EQ] = ACTIONS(3870),
    [anon_sym_BANG_EQ] = ACTIONS(3870),
    [anon_sym_GT_EQ] = ACTIONS(3870),
    [anon_sym_GT] = ACTIONS(3886),
    [anon_sym_LT_GT] = ACTIONS(3870),
    [anon_sym_is] = ACTIONS(3888),
    [sym_comment] = ACTIONS(72),
  },
  [1737] = {
    [sym__expression] = STATE(1863),
    [sym__primary_expression] = STATE(215),
    [sym_not_operator] = STATE(1863),
    [sym_boolean_operator] = STATE(1863),
    [sym_binary_operator] = STATE(215),
    [sym_unary_operator] = STATE(215),
    [sym_comparison_operator] = STATE(1863),
    [sym_lambda] = STATE(1863),
    [sym_attribute] = STATE(215),
    [sym_subscript] = STATE(215),
    [sym_call] = STATE(215),
    [sym_list] = STATE(215),
    [sym_list_comprehension] = STATE(215),
    [sym_dictionary] = STATE(215),
    [sym_dictionary_comprehension] = STATE(215),
    [sym_set] = STATE(215),
    [sym_set_comprehension] = STATE(215),
    [sym_parenthesized_expression] = STATE(215),
    [sym_tuple] = STATE(215),
    [sym_generator_expression] = STATE(215),
    [sym_conditional_expression] = STATE(1863),
    [sym_concatenated_string] = STATE(215),
    [sym_await] = STATE(1863),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_not] = ACTIONS(384),
    [anon_sym_PLUS] = ACTIONS(386),
    [anon_sym_DASH] = ACTIONS(386),
    [anon_sym_TILDE] = ACTIONS(386),
    [anon_sym_lambda] = ACTIONS(388),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(390),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(392),
    [sym_integer] = ACTIONS(394),
    [sym_float] = ACTIONS(394),
    [sym_identifier] = ACTIONS(394),
    [sym_true] = ACTIONS(394),
    [sym_false] = ACTIONS(394),
    [sym_none] = ACTIONS(394),
    [anon_sym_await] = ACTIONS(396),
    [sym_comment] = ACTIONS(72),
  },
  [1738] = {
    [ts_builtin_sym_end] = ACTIONS(4196),
    [anon_sym_import] = ACTIONS(4198),
    [anon_sym_from] = ACTIONS(4198),
    [anon_sym_LPAREN] = ACTIONS(4196),
    [anon_sym_print] = ACTIONS(4198),
    [anon_sym_assert] = ACTIONS(4198),
    [anon_sym_return] = ACTIONS(4198),
    [anon_sym_del] = ACTIONS(4198),
    [anon_sym_raise] = ACTIONS(4198),
    [sym_pass_statement] = ACTIONS(4198),
    [sym_break_statement] = ACTIONS(4198),
    [sym_continue_statement] = ACTIONS(4198),
    [anon_sym_if] = ACTIONS(4198),
    [anon_sym_async] = ACTIONS(4198),
    [anon_sym_for] = ACTIONS(4198),
    [anon_sym_while] = ACTIONS(4198),
    [anon_sym_try] = ACTIONS(4198),
    [anon_sym_with] = ACTIONS(4198),
    [anon_sym_def] = ACTIONS(4198),
    [anon_sym_global] = ACTIONS(4198),
    [anon_sym_nonlocal] = ACTIONS(4198),
    [anon_sym_exec] = ACTIONS(4198),
    [anon_sym_class] = ACTIONS(4198),
    [anon_sym_AT] = ACTIONS(4196),
    [anon_sym_not] = ACTIONS(4198),
    [anon_sym_PLUS] = ACTIONS(4196),
    [anon_sym_DASH] = ACTIONS(4196),
    [anon_sym_TILDE] = ACTIONS(4196),
    [anon_sym_lambda] = ACTIONS(4198),
    [anon_sym_yield] = ACTIONS(4198),
    [anon_sym_LBRACK] = ACTIONS(4196),
    [sym_ellipsis] = ACTIONS(4196),
    [anon_sym_LBRACE] = ACTIONS(4196),
    [sym_string] = ACTIONS(4196),
    [sym_integer] = ACTIONS(4198),
    [sym_float] = ACTIONS(4198),
    [sym_identifier] = ACTIONS(4198),
    [sym_true] = ACTIONS(4198),
    [sym_false] = ACTIONS(4198),
    [sym_none] = ACTIONS(4198),
    [anon_sym_await] = ACTIONS(4198),
    [sym_comment] = ACTIONS(72),
  },
  [1739] = {
    [anon_sym_COMMA] = ACTIONS(3610),
    [anon_sym_if] = ACTIONS(1592),
    [anon_sym_COLON] = ACTIONS(3610),
    [anon_sym_and] = ACTIONS(1594),
    [anon_sym_or] = ACTIONS(1596),
    [sym_comment] = ACTIONS(72),
  },
  [1740] = {
    [anon_sym_if] = ACTIONS(2561),
    [anon_sym_EQ] = ACTIONS(2642),
    [anon_sym_and] = ACTIONS(2563),
    [anon_sym_or] = ACTIONS(2565),
    [sym_comment] = ACTIONS(72),
  },
  [1741] = {
    [sym__expression] = STATE(1864),
    [sym__primary_expression] = STATE(830),
    [sym_not_operator] = STATE(1864),
    [sym_boolean_operator] = STATE(1864),
    [sym_binary_operator] = STATE(830),
    [sym_unary_operator] = STATE(830),
    [sym_comparison_operator] = STATE(1864),
    [sym_lambda] = STATE(1864),
    [sym_attribute] = STATE(830),
    [sym_subscript] = STATE(830),
    [sym_call] = STATE(830),
    [sym_list] = STATE(830),
    [sym_list_comprehension] = STATE(830),
    [sym_dictionary] = STATE(830),
    [sym_dictionary_comprehension] = STATE(830),
    [sym_set] = STATE(830),
    [sym_set_comprehension] = STATE(830),
    [sym_parenthesized_expression] = STATE(830),
    [sym_tuple] = STATE(830),
    [sym_generator_expression] = STATE(830),
    [sym_conditional_expression] = STATE(1864),
    [sym_concatenated_string] = STATE(830),
    [sym_await] = STATE(1864),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_not] = ACTIONS(1628),
    [anon_sym_PLUS] = ACTIONS(1630),
    [anon_sym_DASH] = ACTIONS(1630),
    [anon_sym_TILDE] = ACTIONS(1630),
    [anon_sym_lambda] = ACTIONS(1632),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(1634),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(1636),
    [sym_integer] = ACTIONS(1638),
    [sym_float] = ACTIONS(1638),
    [sym_identifier] = ACTIONS(1638),
    [sym_true] = ACTIONS(1638),
    [sym_false] = ACTIONS(1638),
    [sym_none] = ACTIONS(1638),
    [anon_sym_await] = ACTIONS(1640),
    [sym_comment] = ACTIONS(72),
  },
  [1742] = {
    [sym_argument_list] = STATE(251),
    [sym_generator_expression] = STATE(251),
    [anon_sym_DOT] = ACTIONS(422),
    [anon_sym_LPAREN] = ACTIONS(424),
    [anon_sym_STAR] = ACTIONS(2567),
    [anon_sym_GT_GT] = ACTIONS(2569),
    [anon_sym_if] = ACTIONS(2953),
    [anon_sym_in] = ACTIONS(2953),
    [anon_sym_EQ] = ACTIONS(2955),
    [anon_sym_AT] = ACTIONS(2573),
    [anon_sym_not] = ACTIONS(2953),
    [anon_sym_and] = ACTIONS(2953),
    [anon_sym_or] = ACTIONS(2953),
    [anon_sym_PLUS] = ACTIONS(2577),
    [anon_sym_DASH] = ACTIONS(2577),
    [anon_sym_SLASH] = ACTIONS(2567),
    [anon_sym_PERCENT] = ACTIONS(2573),
    [anon_sym_SLASH_SLASH] = ACTIONS(2573),
    [anon_sym_STAR_STAR] = ACTIONS(2579),
    [anon_sym_PIPE] = ACTIONS(2581),
    [anon_sym_AMP] = ACTIONS(2583),
    [anon_sym_CARET] = ACTIONS(2585),
    [anon_sym_LT_LT] = ACTIONS(2569),
    [anon_sym_LT] = ACTIONS(2955),
    [anon_sym_LT_EQ] = ACTIONS(2953),
    [anon_sym_EQ_EQ] = ACTIONS(2953),
    [anon_sym_BANG_EQ] = ACTIONS(2953),
    [anon_sym_GT_EQ] = ACTIONS(2953),
    [anon_sym_GT] = ACTIONS(2955),
    [anon_sym_LT_GT] = ACTIONS(2953),
    [anon_sym_is] = ACTIONS(2953),
    [anon_sym_LBRACK] = ACTIONS(450),
    [sym_comment] = ACTIONS(72),
  },
  [1743] = {
    [anon_sym_COMMA] = ACTIONS(2642),
    [anon_sym_if] = ACTIONS(2604),
    [anon_sym_COLON] = ACTIONS(2642),
    [anon_sym_EQ] = ACTIONS(2642),
    [anon_sym_and] = ACTIONS(2606),
    [anon_sym_or] = ACTIONS(2608),
    [sym_comment] = ACTIONS(72),
  },
  [1744] = {
    [sym__expression] = STATE(1865),
    [sym__primary_expression] = STATE(841),
    [sym_not_operator] = STATE(1865),
    [sym_boolean_operator] = STATE(1865),
    [sym_binary_operator] = STATE(841),
    [sym_unary_operator] = STATE(841),
    [sym_comparison_operator] = STATE(1865),
    [sym_lambda] = STATE(1865),
    [sym_attribute] = STATE(841),
    [sym_subscript] = STATE(841),
    [sym_call] = STATE(841),
    [sym_list] = STATE(841),
    [sym_list_comprehension] = STATE(841),
    [sym_dictionary] = STATE(841),
    [sym_dictionary_comprehension] = STATE(841),
    [sym_set] = STATE(841),
    [sym_set_comprehension] = STATE(841),
    [sym_parenthesized_expression] = STATE(841),
    [sym_tuple] = STATE(841),
    [sym_generator_expression] = STATE(841),
    [sym_conditional_expression] = STATE(1865),
    [sym_concatenated_string] = STATE(841),
    [sym_await] = STATE(1865),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_not] = ACTIONS(1648),
    [anon_sym_PLUS] = ACTIONS(1650),
    [anon_sym_DASH] = ACTIONS(1650),
    [anon_sym_TILDE] = ACTIONS(1650),
    [anon_sym_lambda] = ACTIONS(1652),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(1654),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(1656),
    [sym_integer] = ACTIONS(1658),
    [sym_float] = ACTIONS(1658),
    [sym_identifier] = ACTIONS(1658),
    [sym_true] = ACTIONS(1658),
    [sym_false] = ACTIONS(1658),
    [sym_none] = ACTIONS(1658),
    [anon_sym_await] = ACTIONS(1660),
    [sym_comment] = ACTIONS(72),
  },
  [1745] = {
    [sym_argument_list] = STATE(251),
    [sym_generator_expression] = STATE(251),
    [anon_sym_DOT] = ACTIONS(422),
    [anon_sym_LPAREN] = ACTIONS(424),
    [anon_sym_COMMA] = ACTIONS(2953),
    [anon_sym_STAR] = ACTIONS(2610),
    [anon_sym_GT_GT] = ACTIONS(2612),
    [anon_sym_if] = ACTIONS(2953),
    [anon_sym_COLON] = ACTIONS(2953),
    [anon_sym_in] = ACTIONS(2953),
    [anon_sym_EQ] = ACTIONS(2955),
    [anon_sym_AT] = ACTIONS(2616),
    [anon_sym_not] = ACTIONS(2953),
    [anon_sym_and] = ACTIONS(2953),
    [anon_sym_or] = ACTIONS(2953),
    [anon_sym_PLUS] = ACTIONS(2620),
    [anon_sym_DASH] = ACTIONS(2620),
    [anon_sym_SLASH] = ACTIONS(2610),
    [anon_sym_PERCENT] = ACTIONS(2616),
    [anon_sym_SLASH_SLASH] = ACTIONS(2616),
    [anon_sym_STAR_STAR] = ACTIONS(2622),
    [anon_sym_PIPE] = ACTIONS(2624),
    [anon_sym_AMP] = ACTIONS(2626),
    [anon_sym_CARET] = ACTIONS(2628),
    [anon_sym_LT_LT] = ACTIONS(2612),
    [anon_sym_LT] = ACTIONS(2955),
    [anon_sym_LT_EQ] = ACTIONS(2953),
    [anon_sym_EQ_EQ] = ACTIONS(2953),
    [anon_sym_BANG_EQ] = ACTIONS(2953),
    [anon_sym_GT_EQ] = ACTIONS(2953),
    [anon_sym_GT] = ACTIONS(2955),
    [anon_sym_LT_GT] = ACTIONS(2953),
    [anon_sym_is] = ACTIONS(2953),
    [anon_sym_LBRACK] = ACTIONS(450),
    [sym_comment] = ACTIONS(72),
  },
  [1746] = {
    [anon_sym_COMMA] = ACTIONS(3610),
    [anon_sym_if] = ACTIONS(1674),
    [anon_sym_and] = ACTIONS(1676),
    [anon_sym_or] = ACTIONS(1678),
    [anon_sym_RBRACK] = ACTIONS(3610),
    [sym_comment] = ACTIONS(72),
  },
  [1747] = {
    [aux_sym_for_in_clause_repeat1] = STATE(1867),
    [anon_sym_COMMA] = ACTIONS(4200),
    [anon_sym_if] = ACTIONS(4052),
    [anon_sym_async] = ACTIONS(4052),
    [anon_sym_for] = ACTIONS(4052),
    [anon_sym_RBRACK] = ACTIONS(4052),
    [sym_comment] = ACTIONS(72),
  },
  [1748] = {
    [sym__expression_within_for_in_clause] = STATE(1796),
    [sym__expression] = STATE(1562),
    [sym__primary_expression] = STATE(145),
    [sym_not_operator] = STATE(1562),
    [sym_boolean_operator] = STATE(1562),
    [sym_binary_operator] = STATE(145),
    [sym_unary_operator] = STATE(145),
    [sym_comparison_operator] = STATE(1562),
    [sym_lambda] = STATE(1562),
    [sym_lambda_within_for_in_clause] = STATE(1406),
    [sym_attribute] = STATE(145),
    [sym_subscript] = STATE(145),
    [sym_call] = STATE(145),
    [sym_list] = STATE(145),
    [sym_list_comprehension] = STATE(145),
    [sym_dictionary] = STATE(145),
    [sym_dictionary_comprehension] = STATE(145),
    [sym_set] = STATE(145),
    [sym_set_comprehension] = STATE(145),
    [sym_parenthesized_expression] = STATE(145),
    [sym_tuple] = STATE(145),
    [sym_generator_expression] = STATE(145),
    [sym_conditional_expression] = STATE(1562),
    [sym_concatenated_string] = STATE(145),
    [sym_await] = STATE(1562),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_not] = ACTIONS(240),
    [anon_sym_PLUS] = ACTIONS(242),
    [anon_sym_DASH] = ACTIONS(242),
    [anon_sym_TILDE] = ACTIONS(242),
    [anon_sym_lambda] = ACTIONS(3429),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(248),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(250),
    [sym_integer] = ACTIONS(252),
    [sym_float] = ACTIONS(252),
    [sym_identifier] = ACTIONS(252),
    [sym_true] = ACTIONS(252),
    [sym_false] = ACTIONS(252),
    [sym_none] = ACTIONS(252),
    [anon_sym_await] = ACTIONS(254),
    [sym_comment] = ACTIONS(72),
  },
  [1749] = {
    [anon_sym_COLON] = ACTIONS(4202),
    [sym_comment] = ACTIONS(72),
  },
  [1750] = {
    [sym__expression_within_for_in_clause] = STATE(1798),
    [sym__expression] = STATE(1562),
    [sym__primary_expression] = STATE(145),
    [sym_not_operator] = STATE(1562),
    [sym_boolean_operator] = STATE(1562),
    [sym_binary_operator] = STATE(145),
    [sym_unary_operator] = STATE(145),
    [sym_comparison_operator] = STATE(1562),
    [sym_lambda] = STATE(1562),
    [sym_lambda_within_for_in_clause] = STATE(1406),
    [sym_attribute] = STATE(145),
    [sym_subscript] = STATE(145),
    [sym_call] = STATE(145),
    [sym_list] = STATE(145),
    [sym_list_comprehension] = STATE(145),
    [sym_dictionary] = STATE(145),
    [sym_dictionary_comprehension] = STATE(145),
    [sym_set] = STATE(145),
    [sym_set_comprehension] = STATE(145),
    [sym_parenthesized_expression] = STATE(145),
    [sym_tuple] = STATE(145),
    [sym_generator_expression] = STATE(145),
    [sym_conditional_expression] = STATE(1562),
    [sym_concatenated_string] = STATE(145),
    [sym_await] = STATE(1562),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_if] = ACTIONS(4058),
    [anon_sym_async] = ACTIONS(4058),
    [anon_sym_for] = ACTIONS(4058),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_not] = ACTIONS(240),
    [anon_sym_PLUS] = ACTIONS(242),
    [anon_sym_DASH] = ACTIONS(242),
    [anon_sym_TILDE] = ACTIONS(242),
    [anon_sym_lambda] = ACTIONS(3429),
    [anon_sym_LBRACK] = ACTIONS(96),
    [anon_sym_RBRACK] = ACTIONS(4052),
    [sym_ellipsis] = ACTIONS(248),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(250),
    [sym_integer] = ACTIONS(252),
    [sym_float] = ACTIONS(252),
    [sym_identifier] = ACTIONS(252),
    [sym_true] = ACTIONS(252),
    [sym_false] = ACTIONS(252),
    [sym_none] = ACTIONS(252),
    [anon_sym_await] = ACTIONS(254),
    [sym_comment] = ACTIONS(72),
  },
  [1751] = {
    [aux_sym_for_in_clause_repeat1] = STATE(1869),
    [anon_sym_COMMA] = ACTIONS(4200),
    [anon_sym_if] = ACTIONS(4052),
    [anon_sym_async] = ACTIONS(4052),
    [anon_sym_for] = ACTIONS(4052),
    [anon_sym_RBRACK] = ACTIONS(4052),
    [sym_comment] = ACTIONS(72),
  },
  [1752] = {
    [anon_sym_if] = ACTIONS(4204),
    [anon_sym_async] = ACTIONS(1644),
    [anon_sym_for] = ACTIONS(1644),
    [anon_sym_and] = ACTIONS(3435),
    [anon_sym_or] = ACTIONS(3437),
    [anon_sym_RBRACK] = ACTIONS(1644),
    [sym_comment] = ACTIONS(72),
  },
  [1753] = {
    [sym__expression] = STATE(1870),
    [sym__primary_expression] = STATE(1274),
    [sym_not_operator] = STATE(1870),
    [sym_boolean_operator] = STATE(1870),
    [sym_binary_operator] = STATE(1274),
    [sym_unary_operator] = STATE(1274),
    [sym_comparison_operator] = STATE(1870),
    [sym_lambda] = STATE(1870),
    [sym_attribute] = STATE(1274),
    [sym_subscript] = STATE(1274),
    [sym_call] = STATE(1274),
    [sym_list] = STATE(1274),
    [sym_list_comprehension] = STATE(1274),
    [sym_dictionary] = STATE(1274),
    [sym_dictionary_comprehension] = STATE(1274),
    [sym_set] = STATE(1274),
    [sym_set_comprehension] = STATE(1274),
    [sym_parenthesized_expression] = STATE(1274),
    [sym_tuple] = STATE(1274),
    [sym_generator_expression] = STATE(1274),
    [sym_conditional_expression] = STATE(1870),
    [sym_concatenated_string] = STATE(1274),
    [sym_await] = STATE(1870),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_not] = ACTIONS(2702),
    [anon_sym_PLUS] = ACTIONS(2704),
    [anon_sym_DASH] = ACTIONS(2704),
    [anon_sym_TILDE] = ACTIONS(2704),
    [anon_sym_lambda] = ACTIONS(2706),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(2708),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(2710),
    [sym_integer] = ACTIONS(2712),
    [sym_float] = ACTIONS(2712),
    [sym_identifier] = ACTIONS(2712),
    [sym_true] = ACTIONS(2712),
    [sym_false] = ACTIONS(2712),
    [sym_none] = ACTIONS(2712),
    [anon_sym_await] = ACTIONS(2714),
    [sym_comment] = ACTIONS(72),
  },
  [1754] = {
    [aux_sym_concatenated_string_repeat1] = STATE(1754),
    [anon_sym_DOT] = ACTIONS(1862),
    [anon_sym_LPAREN] = ACTIONS(1862),
    [anon_sym_STAR] = ACTIONS(1864),
    [anon_sym_GT_GT] = ACTIONS(1862),
    [anon_sym_if] = ACTIONS(1862),
    [anon_sym_async] = ACTIONS(1862),
    [anon_sym_for] = ACTIONS(1862),
    [anon_sym_in] = ACTIONS(1862),
    [anon_sym_AT] = ACTIONS(1862),
    [anon_sym_not] = ACTIONS(1862),
    [anon_sym_and] = ACTIONS(1862),
    [anon_sym_or] = ACTIONS(1862),
    [anon_sym_PLUS] = ACTIONS(1862),
    [anon_sym_DASH] = ACTIONS(1862),
    [anon_sym_SLASH] = ACTIONS(1864),
    [anon_sym_PERCENT] = ACTIONS(1862),
    [anon_sym_SLASH_SLASH] = ACTIONS(1862),
    [anon_sym_STAR_STAR] = ACTIONS(1862),
    [anon_sym_PIPE] = ACTIONS(1862),
    [anon_sym_AMP] = ACTIONS(1862),
    [anon_sym_CARET] = ACTIONS(1862),
    [anon_sym_LT_LT] = ACTIONS(1862),
    [anon_sym_LT] = ACTIONS(1864),
    [anon_sym_LT_EQ] = ACTIONS(1862),
    [anon_sym_EQ_EQ] = ACTIONS(1862),
    [anon_sym_BANG_EQ] = ACTIONS(1862),
    [anon_sym_GT_EQ] = ACTIONS(1862),
    [anon_sym_GT] = ACTIONS(1864),
    [anon_sym_LT_GT] = ACTIONS(1862),
    [anon_sym_is] = ACTIONS(1862),
    [anon_sym_LBRACK] = ACTIONS(1862),
    [anon_sym_RBRACK] = ACTIONS(1862),
    [sym_string] = ACTIONS(4206),
    [sym_comment] = ACTIONS(72),
  },
  [1755] = {
    [anon_sym_if] = ACTIONS(1921),
    [anon_sym_else] = ACTIONS(4209),
    [anon_sym_and] = ACTIONS(1925),
    [anon_sym_or] = ACTIONS(1927),
    [sym_comment] = ACTIONS(72),
  },
  [1756] = {
    [anon_sym_if] = ACTIONS(1953),
    [anon_sym_async] = ACTIONS(1953),
    [anon_sym_for] = ACTIONS(1953),
    [anon_sym_and] = ACTIONS(3435),
    [anon_sym_or] = ACTIONS(1953),
    [anon_sym_RBRACK] = ACTIONS(1953),
    [sym_comment] = ACTIONS(72),
  },
  [1757] = {
    [sym_argument_list] = STATE(251),
    [sym_generator_expression] = STATE(251),
    [anon_sym_DOT] = ACTIONS(1980),
    [anon_sym_LPAREN] = ACTIONS(424),
    [anon_sym_STAR] = ACTIONS(1982),
    [anon_sym_GT_GT] = ACTIONS(1980),
    [anon_sym_if] = ACTIONS(1980),
    [anon_sym_async] = ACTIONS(1980),
    [anon_sym_for] = ACTIONS(1980),
    [anon_sym_in] = ACTIONS(1980),
    [anon_sym_AT] = ACTIONS(1980),
    [anon_sym_not] = ACTIONS(1980),
    [anon_sym_and] = ACTIONS(1980),
    [anon_sym_or] = ACTIONS(1980),
    [anon_sym_PLUS] = ACTIONS(1980),
    [anon_sym_DASH] = ACTIONS(1980),
    [anon_sym_SLASH] = ACTIONS(1982),
    [anon_sym_PERCENT] = ACTIONS(1980),
    [anon_sym_SLASH_SLASH] = ACTIONS(1980),
    [anon_sym_STAR_STAR] = ACTIONS(3451),
    [anon_sym_PIPE] = ACTIONS(1980),
    [anon_sym_AMP] = ACTIONS(1980),
    [anon_sym_CARET] = ACTIONS(1980),
    [anon_sym_LT_LT] = ACTIONS(1980),
    [anon_sym_LT] = ACTIONS(1982),
    [anon_sym_LT_EQ] = ACTIONS(1980),
    [anon_sym_EQ_EQ] = ACTIONS(1980),
    [anon_sym_BANG_EQ] = ACTIONS(1980),
    [anon_sym_GT_EQ] = ACTIONS(1980),
    [anon_sym_GT] = ACTIONS(1982),
    [anon_sym_LT_GT] = ACTIONS(1980),
    [anon_sym_is] = ACTIONS(1980),
    [anon_sym_LBRACK] = ACTIONS(1980),
    [anon_sym_RBRACK] = ACTIONS(1980),
    [sym_comment] = ACTIONS(72),
  },
  [1758] = {
    [sym_argument_list] = STATE(251),
    [sym_generator_expression] = STATE(251),
    [anon_sym_DOT] = ACTIONS(1980),
    [anon_sym_LPAREN] = ACTIONS(424),
    [anon_sym_STAR] = ACTIONS(3439),
    [anon_sym_GT_GT] = ACTIONS(1980),
    [anon_sym_if] = ACTIONS(1980),
    [anon_sym_async] = ACTIONS(1980),
    [anon_sym_for] = ACTIONS(1980),
    [anon_sym_in] = ACTIONS(1980),
    [anon_sym_AT] = ACTIONS(3445),
    [anon_sym_not] = ACTIONS(1980),
    [anon_sym_and] = ACTIONS(1980),
    [anon_sym_or] = ACTIONS(1980),
    [anon_sym_PLUS] = ACTIONS(3449),
    [anon_sym_DASH] = ACTIONS(3449),
    [anon_sym_SLASH] = ACTIONS(3439),
    [anon_sym_PERCENT] = ACTIONS(3445),
    [anon_sym_SLASH_SLASH] = ACTIONS(3445),
    [anon_sym_STAR_STAR] = ACTIONS(3451),
    [anon_sym_PIPE] = ACTIONS(1980),
    [anon_sym_AMP] = ACTIONS(1980),
    [anon_sym_CARET] = ACTIONS(1980),
    [anon_sym_LT_LT] = ACTIONS(1980),
    [anon_sym_LT] = ACTIONS(1982),
    [anon_sym_LT_EQ] = ACTIONS(1980),
    [anon_sym_EQ_EQ] = ACTIONS(1980),
    [anon_sym_BANG_EQ] = ACTIONS(1980),
    [anon_sym_GT_EQ] = ACTIONS(1980),
    [anon_sym_GT] = ACTIONS(1982),
    [anon_sym_LT_GT] = ACTIONS(1980),
    [anon_sym_is] = ACTIONS(1980),
    [anon_sym_LBRACK] = ACTIONS(1980),
    [anon_sym_RBRACK] = ACTIONS(1980),
    [sym_comment] = ACTIONS(72),
  },
  [1759] = {
    [sym_argument_list] = STATE(251),
    [sym_generator_expression] = STATE(251),
    [anon_sym_DOT] = ACTIONS(422),
    [anon_sym_LPAREN] = ACTIONS(424),
    [anon_sym_STAR] = ACTIONS(3439),
    [anon_sym_GT_GT] = ACTIONS(3441),
    [anon_sym_if] = ACTIONS(1984),
    [anon_sym_async] = ACTIONS(1984),
    [anon_sym_for] = ACTIONS(1984),
    [anon_sym_in] = ACTIONS(1984),
    [anon_sym_AT] = ACTIONS(3445),
    [anon_sym_not] = ACTIONS(1984),
    [anon_sym_and] = ACTIONS(1984),
    [anon_sym_or] = ACTIONS(1984),
    [anon_sym_PLUS] = ACTIONS(3449),
    [anon_sym_DASH] = ACTIONS(3449),
    [anon_sym_SLASH] = ACTIONS(3439),
    [anon_sym_PERCENT] = ACTIONS(3445),
    [anon_sym_SLASH_SLASH] = ACTIONS(3445),
    [anon_sym_STAR_STAR] = ACTIONS(3451),
    [anon_sym_PIPE] = ACTIONS(3453),
    [anon_sym_AMP] = ACTIONS(3455),
    [anon_sym_CARET] = ACTIONS(3457),
    [anon_sym_LT_LT] = ACTIONS(3441),
    [anon_sym_LT] = ACTIONS(1986),
    [anon_sym_LT_EQ] = ACTIONS(1984),
    [anon_sym_EQ_EQ] = ACTIONS(1984),
    [anon_sym_BANG_EQ] = ACTIONS(1984),
    [anon_sym_GT_EQ] = ACTIONS(1984),
    [anon_sym_GT] = ACTIONS(1986),
    [anon_sym_LT_GT] = ACTIONS(1984),
    [anon_sym_is] = ACTIONS(1984),
    [anon_sym_LBRACK] = ACTIONS(450),
    [anon_sym_RBRACK] = ACTIONS(1984),
    [sym_comment] = ACTIONS(72),
  },
  [1760] = {
    [sym__primary_expression] = STATE(1872),
    [sym_binary_operator] = STATE(1872),
    [sym_unary_operator] = STATE(1872),
    [sym_attribute] = STATE(1872),
    [sym_subscript] = STATE(1872),
    [sym_call] = STATE(1872),
    [sym_list] = STATE(1872),
    [sym_list_comprehension] = STATE(1872),
    [sym_dictionary] = STATE(1872),
    [sym_dictionary_comprehension] = STATE(1872),
    [sym_set] = STATE(1872),
    [sym_set_comprehension] = STATE(1872),
    [sym_parenthesized_expression] = STATE(1872),
    [sym_tuple] = STATE(1872),
    [sym_generator_expression] = STATE(1872),
    [sym_concatenated_string] = STATE(1872),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_PLUS] = ACTIONS(2704),
    [anon_sym_DASH] = ACTIONS(2704),
    [anon_sym_TILDE] = ACTIONS(2704),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(4211),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(2710),
    [sym_integer] = ACTIONS(4213),
    [sym_float] = ACTIONS(4213),
    [sym_identifier] = ACTIONS(4213),
    [sym_true] = ACTIONS(4213),
    [sym_false] = ACTIONS(4213),
    [sym_none] = ACTIONS(4213),
    [sym_comment] = ACTIONS(72),
  },
  [1761] = {
    [sym_argument_list] = STATE(251),
    [sym_generator_expression] = STATE(251),
    [anon_sym_DOT] = ACTIONS(1980),
    [anon_sym_LPAREN] = ACTIONS(424),
    [anon_sym_STAR] = ACTIONS(3439),
    [anon_sym_GT_GT] = ACTIONS(1980),
    [anon_sym_if] = ACTIONS(1980),
    [anon_sym_async] = ACTIONS(1980),
    [anon_sym_for] = ACTIONS(1980),
    [anon_sym_in] = ACTIONS(1980),
    [anon_sym_AT] = ACTIONS(3445),
    [anon_sym_not] = ACTIONS(1980),
    [anon_sym_and] = ACTIONS(1980),
    [anon_sym_or] = ACTIONS(1980),
    [anon_sym_PLUS] = ACTIONS(1980),
    [anon_sym_DASH] = ACTIONS(1980),
    [anon_sym_SLASH] = ACTIONS(3439),
    [anon_sym_PERCENT] = ACTIONS(3445),
    [anon_sym_SLASH_SLASH] = ACTIONS(3445),
    [anon_sym_STAR_STAR] = ACTIONS(3451),
    [anon_sym_PIPE] = ACTIONS(1980),
    [anon_sym_AMP] = ACTIONS(1980),
    [anon_sym_CARET] = ACTIONS(1980),
    [anon_sym_LT_LT] = ACTIONS(1980),
    [anon_sym_LT] = ACTIONS(1982),
    [anon_sym_LT_EQ] = ACTIONS(1980),
    [anon_sym_EQ_EQ] = ACTIONS(1980),
    [anon_sym_BANG_EQ] = ACTIONS(1980),
    [anon_sym_GT_EQ] = ACTIONS(1980),
    [anon_sym_GT] = ACTIONS(1982),
    [anon_sym_LT_GT] = ACTIONS(1980),
    [anon_sym_is] = ACTIONS(1980),
    [anon_sym_LBRACK] = ACTIONS(1980),
    [anon_sym_RBRACK] = ACTIONS(1980),
    [sym_comment] = ACTIONS(72),
  },
  [1762] = {
    [sym_argument_list] = STATE(251),
    [sym_generator_expression] = STATE(251),
    [anon_sym_DOT] = ACTIONS(1980),
    [anon_sym_LPAREN] = ACTIONS(424),
    [anon_sym_STAR] = ACTIONS(3439),
    [anon_sym_GT_GT] = ACTIONS(3441),
    [anon_sym_if] = ACTIONS(1980),
    [anon_sym_async] = ACTIONS(1980),
    [anon_sym_for] = ACTIONS(1980),
    [anon_sym_in] = ACTIONS(1980),
    [anon_sym_AT] = ACTIONS(3445),
    [anon_sym_not] = ACTIONS(1980),
    [anon_sym_and] = ACTIONS(1980),
    [anon_sym_or] = ACTIONS(1980),
    [anon_sym_PLUS] = ACTIONS(3449),
    [anon_sym_DASH] = ACTIONS(3449),
    [anon_sym_SLASH] = ACTIONS(3439),
    [anon_sym_PERCENT] = ACTIONS(3445),
    [anon_sym_SLASH_SLASH] = ACTIONS(3445),
    [anon_sym_STAR_STAR] = ACTIONS(3451),
    [anon_sym_PIPE] = ACTIONS(1980),
    [anon_sym_AMP] = ACTIONS(3455),
    [anon_sym_CARET] = ACTIONS(3457),
    [anon_sym_LT_LT] = ACTIONS(3441),
    [anon_sym_LT] = ACTIONS(1982),
    [anon_sym_LT_EQ] = ACTIONS(1980),
    [anon_sym_EQ_EQ] = ACTIONS(1980),
    [anon_sym_BANG_EQ] = ACTIONS(1980),
    [anon_sym_GT_EQ] = ACTIONS(1980),
    [anon_sym_GT] = ACTIONS(1982),
    [anon_sym_LT_GT] = ACTIONS(1980),
    [anon_sym_is] = ACTIONS(1980),
    [anon_sym_LBRACK] = ACTIONS(1980),
    [anon_sym_RBRACK] = ACTIONS(1980),
    [sym_comment] = ACTIONS(72),
  },
  [1763] = {
    [sym_argument_list] = STATE(251),
    [sym_generator_expression] = STATE(251),
    [anon_sym_DOT] = ACTIONS(1980),
    [anon_sym_LPAREN] = ACTIONS(424),
    [anon_sym_STAR] = ACTIONS(3439),
    [anon_sym_GT_GT] = ACTIONS(3441),
    [anon_sym_if] = ACTIONS(1980),
    [anon_sym_async] = ACTIONS(1980),
    [anon_sym_for] = ACTIONS(1980),
    [anon_sym_in] = ACTIONS(1980),
    [anon_sym_AT] = ACTIONS(3445),
    [anon_sym_not] = ACTIONS(1980),
    [anon_sym_and] = ACTIONS(1980),
    [anon_sym_or] = ACTIONS(1980),
    [anon_sym_PLUS] = ACTIONS(3449),
    [anon_sym_DASH] = ACTIONS(3449),
    [anon_sym_SLASH] = ACTIONS(3439),
    [anon_sym_PERCENT] = ACTIONS(3445),
    [anon_sym_SLASH_SLASH] = ACTIONS(3445),
    [anon_sym_STAR_STAR] = ACTIONS(3451),
    [anon_sym_PIPE] = ACTIONS(1980),
    [anon_sym_AMP] = ACTIONS(1980),
    [anon_sym_CARET] = ACTIONS(3457),
    [anon_sym_LT_LT] = ACTIONS(3441),
    [anon_sym_LT] = ACTIONS(1982),
    [anon_sym_LT_EQ] = ACTIONS(1980),
    [anon_sym_EQ_EQ] = ACTIONS(1980),
    [anon_sym_BANG_EQ] = ACTIONS(1980),
    [anon_sym_GT_EQ] = ACTIONS(1980),
    [anon_sym_GT] = ACTIONS(1982),
    [anon_sym_LT_GT] = ACTIONS(1980),
    [anon_sym_is] = ACTIONS(1980),
    [anon_sym_LBRACK] = ACTIONS(1980),
    [anon_sym_RBRACK] = ACTIONS(1980),
    [sym_comment] = ACTIONS(72),
  },
  [1764] = {
    [sym_argument_list] = STATE(251),
    [sym_generator_expression] = STATE(251),
    [anon_sym_DOT] = ACTIONS(1980),
    [anon_sym_LPAREN] = ACTIONS(424),
    [anon_sym_STAR] = ACTIONS(3439),
    [anon_sym_GT_GT] = ACTIONS(3441),
    [anon_sym_if] = ACTIONS(1980),
    [anon_sym_async] = ACTIONS(1980),
    [anon_sym_for] = ACTIONS(1980),
    [anon_sym_in] = ACTIONS(1980),
    [anon_sym_AT] = ACTIONS(3445),
    [anon_sym_not] = ACTIONS(1980),
    [anon_sym_and] = ACTIONS(1980),
    [anon_sym_or] = ACTIONS(1980),
    [anon_sym_PLUS] = ACTIONS(3449),
    [anon_sym_DASH] = ACTIONS(3449),
    [anon_sym_SLASH] = ACTIONS(3439),
    [anon_sym_PERCENT] = ACTIONS(3445),
    [anon_sym_SLASH_SLASH] = ACTIONS(3445),
    [anon_sym_STAR_STAR] = ACTIONS(3451),
    [anon_sym_PIPE] = ACTIONS(1980),
    [anon_sym_AMP] = ACTIONS(1980),
    [anon_sym_CARET] = ACTIONS(1980),
    [anon_sym_LT_LT] = ACTIONS(3441),
    [anon_sym_LT] = ACTIONS(1982),
    [anon_sym_LT_EQ] = ACTIONS(1980),
    [anon_sym_EQ_EQ] = ACTIONS(1980),
    [anon_sym_BANG_EQ] = ACTIONS(1980),
    [anon_sym_GT_EQ] = ACTIONS(1980),
    [anon_sym_GT] = ACTIONS(1982),
    [anon_sym_LT_GT] = ACTIONS(1980),
    [anon_sym_is] = ACTIONS(1980),
    [anon_sym_LBRACK] = ACTIONS(1980),
    [anon_sym_RBRACK] = ACTIONS(1980),
    [sym_comment] = ACTIONS(72),
  },
  [1765] = {
    [aux_sym_comparison_operator_repeat1] = STATE(1765),
    [anon_sym_if] = ACTIONS(1984),
    [anon_sym_async] = ACTIONS(1984),
    [anon_sym_for] = ACTIONS(1984),
    [anon_sym_in] = ACTIONS(4215),
    [anon_sym_not] = ACTIONS(4218),
    [anon_sym_and] = ACTIONS(1984),
    [anon_sym_or] = ACTIONS(1984),
    [anon_sym_LT] = ACTIONS(4221),
    [anon_sym_LT_EQ] = ACTIONS(4215),
    [anon_sym_EQ_EQ] = ACTIONS(4215),
    [anon_sym_BANG_EQ] = ACTIONS(4215),
    [anon_sym_GT_EQ] = ACTIONS(4215),
    [anon_sym_GT] = ACTIONS(4221),
    [anon_sym_LT_GT] = ACTIONS(4215),
    [anon_sym_is] = ACTIONS(4224),
    [anon_sym_RBRACK] = ACTIONS(1984),
    [sym_comment] = ACTIONS(72),
  },
  [1766] = {
    [anon_sym_COMMA] = ACTIONS(3610),
    [anon_sym_if] = ACTIONS(1758),
    [anon_sym_and] = ACTIONS(1760),
    [anon_sym_or] = ACTIONS(1762),
    [anon_sym_RBRACE] = ACTIONS(3610),
    [sym_comment] = ACTIONS(72),
  },
  [1767] = {
    [anon_sym_COMMA] = ACTIONS(2642),
    [anon_sym_if] = ACTIONS(2801),
    [anon_sym_async] = ACTIONS(2642),
    [anon_sym_for] = ACTIONS(2642),
    [anon_sym_and] = ACTIONS(2803),
    [anon_sym_or] = ACTIONS(2805),
    [anon_sym_RBRACE] = ACTIONS(2642),
    [sym_comment] = ACTIONS(72),
  },
  [1768] = {
    [sym__expression] = STATE(1873),
    [sym__primary_expression] = STATE(930),
    [sym_not_operator] = STATE(1873),
    [sym_boolean_operator] = STATE(1873),
    [sym_binary_operator] = STATE(930),
    [sym_unary_operator] = STATE(930),
    [sym_comparison_operator] = STATE(1873),
    [sym_lambda] = STATE(1873),
    [sym_attribute] = STATE(930),
    [sym_subscript] = STATE(930),
    [sym_call] = STATE(930),
    [sym_list] = STATE(930),
    [sym_list_comprehension] = STATE(930),
    [sym_dictionary] = STATE(930),
    [sym_dictionary_comprehension] = STATE(930),
    [sym_set] = STATE(930),
    [sym_set_comprehension] = STATE(930),
    [sym_parenthesized_expression] = STATE(930),
    [sym_tuple] = STATE(930),
    [sym_generator_expression] = STATE(930),
    [sym_conditional_expression] = STATE(1873),
    [sym_concatenated_string] = STATE(930),
    [sym_await] = STATE(1873),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_not] = ACTIONS(1808),
    [anon_sym_PLUS] = ACTIONS(1810),
    [anon_sym_DASH] = ACTIONS(1810),
    [anon_sym_TILDE] = ACTIONS(1810),
    [anon_sym_lambda] = ACTIONS(1812),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(1814),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(1816),
    [sym_integer] = ACTIONS(1818),
    [sym_float] = ACTIONS(1818),
    [sym_identifier] = ACTIONS(1818),
    [sym_true] = ACTIONS(1818),
    [sym_false] = ACTIONS(1818),
    [sym_none] = ACTIONS(1818),
    [anon_sym_await] = ACTIONS(1820),
    [sym_comment] = ACTIONS(72),
  },
  [1769] = {
    [sym_argument_list] = STATE(251),
    [sym_generator_expression] = STATE(251),
    [anon_sym_DOT] = ACTIONS(422),
    [anon_sym_LPAREN] = ACTIONS(424),
    [anon_sym_COMMA] = ACTIONS(2953),
    [anon_sym_STAR] = ACTIONS(2807),
    [anon_sym_GT_GT] = ACTIONS(2809),
    [anon_sym_if] = ACTIONS(2953),
    [anon_sym_async] = ACTIONS(2953),
    [anon_sym_for] = ACTIONS(2953),
    [anon_sym_in] = ACTIONS(2953),
    [anon_sym_AT] = ACTIONS(2813),
    [anon_sym_not] = ACTIONS(2953),
    [anon_sym_and] = ACTIONS(2953),
    [anon_sym_or] = ACTIONS(2953),
    [anon_sym_PLUS] = ACTIONS(2817),
    [anon_sym_DASH] = ACTIONS(2817),
    [anon_sym_SLASH] = ACTIONS(2807),
    [anon_sym_PERCENT] = ACTIONS(2813),
    [anon_sym_SLASH_SLASH] = ACTIONS(2813),
    [anon_sym_STAR_STAR] = ACTIONS(2819),
    [anon_sym_PIPE] = ACTIONS(2821),
    [anon_sym_AMP] = ACTIONS(2823),
    [anon_sym_CARET] = ACTIONS(2825),
    [anon_sym_LT_LT] = ACTIONS(2809),
    [anon_sym_LT] = ACTIONS(2955),
    [anon_sym_LT_EQ] = ACTIONS(2953),
    [anon_sym_EQ_EQ] = ACTIONS(2953),
    [anon_sym_BANG_EQ] = ACTIONS(2953),
    [anon_sym_GT_EQ] = ACTIONS(2953),
    [anon_sym_GT] = ACTIONS(2955),
    [anon_sym_LT_GT] = ACTIONS(2953),
    [anon_sym_is] = ACTIONS(2953),
    [anon_sym_LBRACK] = ACTIONS(450),
    [anon_sym_RBRACE] = ACTIONS(2953),
    [sym_comment] = ACTIONS(72),
  },
  [1770] = {
    [aux_sym_for_in_clause_repeat1] = STATE(1875),
    [anon_sym_COMMA] = ACTIONS(4227),
    [anon_sym_if] = ACTIONS(4052),
    [anon_sym_async] = ACTIONS(4052),
    [anon_sym_for] = ACTIONS(4052),
    [anon_sym_RBRACE] = ACTIONS(4052),
    [sym_comment] = ACTIONS(72),
  },
  [1771] = {
    [sym__expression_within_for_in_clause] = STATE(1796),
    [sym__expression] = STATE(1603),
    [sym__primary_expression] = STATE(930),
    [sym_not_operator] = STATE(1603),
    [sym_boolean_operator] = STATE(1603),
    [sym_binary_operator] = STATE(930),
    [sym_unary_operator] = STATE(930),
    [sym_comparison_operator] = STATE(1603),
    [sym_lambda] = STATE(1603),
    [sym_lambda_within_for_in_clause] = STATE(1406),
    [sym_attribute] = STATE(930),
    [sym_subscript] = STATE(930),
    [sym_call] = STATE(930),
    [sym_list] = STATE(930),
    [sym_list_comprehension] = STATE(930),
    [sym_dictionary] = STATE(930),
    [sym_dictionary_comprehension] = STATE(930),
    [sym_set] = STATE(930),
    [sym_set_comprehension] = STATE(930),
    [sym_parenthesized_expression] = STATE(930),
    [sym_tuple] = STATE(930),
    [sym_generator_expression] = STATE(930),
    [sym_conditional_expression] = STATE(1603),
    [sym_concatenated_string] = STATE(930),
    [sym_await] = STATE(1603),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_not] = ACTIONS(1808),
    [anon_sym_PLUS] = ACTIONS(1810),
    [anon_sym_DASH] = ACTIONS(1810),
    [anon_sym_TILDE] = ACTIONS(1810),
    [anon_sym_lambda] = ACTIONS(3539),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(1814),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(1816),
    [sym_integer] = ACTIONS(1818),
    [sym_float] = ACTIONS(1818),
    [sym_identifier] = ACTIONS(1818),
    [sym_true] = ACTIONS(1818),
    [sym_false] = ACTIONS(1818),
    [sym_none] = ACTIONS(1818),
    [anon_sym_await] = ACTIONS(1820),
    [sym_comment] = ACTIONS(72),
  },
  [1772] = {
    [anon_sym_COLON] = ACTIONS(4229),
    [sym_comment] = ACTIONS(72),
  },
  [1773] = {
    [sym__expression_within_for_in_clause] = STATE(1798),
    [sym__expression] = STATE(1603),
    [sym__primary_expression] = STATE(930),
    [sym_not_operator] = STATE(1603),
    [sym_boolean_operator] = STATE(1603),
    [sym_binary_operator] = STATE(930),
    [sym_unary_operator] = STATE(930),
    [sym_comparison_operator] = STATE(1603),
    [sym_lambda] = STATE(1603),
    [sym_lambda_within_for_in_clause] = STATE(1406),
    [sym_attribute] = STATE(930),
    [sym_subscript] = STATE(930),
    [sym_call] = STATE(930),
    [sym_list] = STATE(930),
    [sym_list_comprehension] = STATE(930),
    [sym_dictionary] = STATE(930),
    [sym_dictionary_comprehension] = STATE(930),
    [sym_set] = STATE(930),
    [sym_set_comprehension] = STATE(930),
    [sym_parenthesized_expression] = STATE(930),
    [sym_tuple] = STATE(930),
    [sym_generator_expression] = STATE(930),
    [sym_conditional_expression] = STATE(1603),
    [sym_concatenated_string] = STATE(930),
    [sym_await] = STATE(1603),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_if] = ACTIONS(4058),
    [anon_sym_async] = ACTIONS(4058),
    [anon_sym_for] = ACTIONS(4058),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_not] = ACTIONS(1808),
    [anon_sym_PLUS] = ACTIONS(1810),
    [anon_sym_DASH] = ACTIONS(1810),
    [anon_sym_TILDE] = ACTIONS(1810),
    [anon_sym_lambda] = ACTIONS(3539),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(1814),
    [anon_sym_LBRACE] = ACTIONS(100),
    [anon_sym_RBRACE] = ACTIONS(4052),
    [sym_string] = ACTIONS(1816),
    [sym_integer] = ACTIONS(1818),
    [sym_float] = ACTIONS(1818),
    [sym_identifier] = ACTIONS(1818),
    [sym_true] = ACTIONS(1818),
    [sym_false] = ACTIONS(1818),
    [sym_none] = ACTIONS(1818),
    [anon_sym_await] = ACTIONS(1820),
    [sym_comment] = ACTIONS(72),
  },
  [1774] = {
    [aux_sym_for_in_clause_repeat1] = STATE(1877),
    [anon_sym_COMMA] = ACTIONS(4227),
    [anon_sym_if] = ACTIONS(4052),
    [anon_sym_async] = ACTIONS(4052),
    [anon_sym_for] = ACTIONS(4052),
    [anon_sym_RBRACE] = ACTIONS(4052),
    [sym_comment] = ACTIONS(72),
  },
  [1775] = {
    [anon_sym_if] = ACTIONS(4231),
    [anon_sym_async] = ACTIONS(1644),
    [anon_sym_for] = ACTIONS(1644),
    [anon_sym_and] = ACTIONS(3545),
    [anon_sym_or] = ACTIONS(3547),
    [anon_sym_RBRACE] = ACTIONS(1644),
    [sym_comment] = ACTIONS(72),
  },
  [1776] = {
    [sym__expression] = STATE(1878),
    [sym__primary_expression] = STATE(1324),
    [sym_not_operator] = STATE(1878),
    [sym_boolean_operator] = STATE(1878),
    [sym_binary_operator] = STATE(1324),
    [sym_unary_operator] = STATE(1324),
    [sym_comparison_operator] = STATE(1878),
    [sym_lambda] = STATE(1878),
    [sym_attribute] = STATE(1324),
    [sym_subscript] = STATE(1324),
    [sym_call] = STATE(1324),
    [sym_list] = STATE(1324),
    [sym_list_comprehension] = STATE(1324),
    [sym_dictionary] = STATE(1324),
    [sym_dictionary_comprehension] = STATE(1324),
    [sym_set] = STATE(1324),
    [sym_set_comprehension] = STATE(1324),
    [sym_parenthesized_expression] = STATE(1324),
    [sym_tuple] = STATE(1324),
    [sym_generator_expression] = STATE(1324),
    [sym_conditional_expression] = STATE(1878),
    [sym_concatenated_string] = STATE(1324),
    [sym_await] = STATE(1878),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_not] = ACTIONS(2837),
    [anon_sym_PLUS] = ACTIONS(2839),
    [anon_sym_DASH] = ACTIONS(2839),
    [anon_sym_TILDE] = ACTIONS(2839),
    [anon_sym_lambda] = ACTIONS(2841),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(2843),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(2845),
    [sym_integer] = ACTIONS(2847),
    [sym_float] = ACTIONS(2847),
    [sym_identifier] = ACTIONS(2847),
    [sym_true] = ACTIONS(2847),
    [sym_false] = ACTIONS(2847),
    [sym_none] = ACTIONS(2847),
    [anon_sym_await] = ACTIONS(2849),
    [sym_comment] = ACTIONS(72),
  },
  [1777] = {
    [aux_sym_concatenated_string_repeat1] = STATE(1777),
    [anon_sym_DOT] = ACTIONS(1862),
    [anon_sym_LPAREN] = ACTIONS(1862),
    [anon_sym_STAR] = ACTIONS(1864),
    [anon_sym_GT_GT] = ACTIONS(1862),
    [anon_sym_if] = ACTIONS(1862),
    [anon_sym_async] = ACTIONS(1862),
    [anon_sym_for] = ACTIONS(1862),
    [anon_sym_in] = ACTIONS(1862),
    [anon_sym_AT] = ACTIONS(1862),
    [anon_sym_not] = ACTIONS(1862),
    [anon_sym_and] = ACTIONS(1862),
    [anon_sym_or] = ACTIONS(1862),
    [anon_sym_PLUS] = ACTIONS(1862),
    [anon_sym_DASH] = ACTIONS(1862),
    [anon_sym_SLASH] = ACTIONS(1864),
    [anon_sym_PERCENT] = ACTIONS(1862),
    [anon_sym_SLASH_SLASH] = ACTIONS(1862),
    [anon_sym_STAR_STAR] = ACTIONS(1862),
    [anon_sym_PIPE] = ACTIONS(1862),
    [anon_sym_AMP] = ACTIONS(1862),
    [anon_sym_CARET] = ACTIONS(1862),
    [anon_sym_LT_LT] = ACTIONS(1862),
    [anon_sym_LT] = ACTIONS(1864),
    [anon_sym_LT_EQ] = ACTIONS(1862),
    [anon_sym_EQ_EQ] = ACTIONS(1862),
    [anon_sym_BANG_EQ] = ACTIONS(1862),
    [anon_sym_GT_EQ] = ACTIONS(1862),
    [anon_sym_GT] = ACTIONS(1864),
    [anon_sym_LT_GT] = ACTIONS(1862),
    [anon_sym_is] = ACTIONS(1862),
    [anon_sym_LBRACK] = ACTIONS(1862),
    [anon_sym_RBRACE] = ACTIONS(1862),
    [sym_string] = ACTIONS(4233),
    [sym_comment] = ACTIONS(72),
  },
  [1778] = {
    [anon_sym_if] = ACTIONS(1921),
    [anon_sym_else] = ACTIONS(4236),
    [anon_sym_and] = ACTIONS(1925),
    [anon_sym_or] = ACTIONS(1927),
    [sym_comment] = ACTIONS(72),
  },
  [1779] = {
    [anon_sym_if] = ACTIONS(1953),
    [anon_sym_async] = ACTIONS(1953),
    [anon_sym_for] = ACTIONS(1953),
    [anon_sym_and] = ACTIONS(3545),
    [anon_sym_or] = ACTIONS(1953),
    [anon_sym_RBRACE] = ACTIONS(1953),
    [sym_comment] = ACTIONS(72),
  },
  [1780] = {
    [sym_argument_list] = STATE(251),
    [sym_generator_expression] = STATE(251),
    [anon_sym_DOT] = ACTIONS(1980),
    [anon_sym_LPAREN] = ACTIONS(424),
    [anon_sym_STAR] = ACTIONS(1982),
    [anon_sym_GT_GT] = ACTIONS(1980),
    [anon_sym_if] = ACTIONS(1980),
    [anon_sym_async] = ACTIONS(1980),
    [anon_sym_for] = ACTIONS(1980),
    [anon_sym_in] = ACTIONS(1980),
    [anon_sym_AT] = ACTIONS(1980),
    [anon_sym_not] = ACTIONS(1980),
    [anon_sym_and] = ACTIONS(1980),
    [anon_sym_or] = ACTIONS(1980),
    [anon_sym_PLUS] = ACTIONS(1980),
    [anon_sym_DASH] = ACTIONS(1980),
    [anon_sym_SLASH] = ACTIONS(1982),
    [anon_sym_PERCENT] = ACTIONS(1980),
    [anon_sym_SLASH_SLASH] = ACTIONS(1980),
    [anon_sym_STAR_STAR] = ACTIONS(3561),
    [anon_sym_PIPE] = ACTIONS(1980),
    [anon_sym_AMP] = ACTIONS(1980),
    [anon_sym_CARET] = ACTIONS(1980),
    [anon_sym_LT_LT] = ACTIONS(1980),
    [anon_sym_LT] = ACTIONS(1982),
    [anon_sym_LT_EQ] = ACTIONS(1980),
    [anon_sym_EQ_EQ] = ACTIONS(1980),
    [anon_sym_BANG_EQ] = ACTIONS(1980),
    [anon_sym_GT_EQ] = ACTIONS(1980),
    [anon_sym_GT] = ACTIONS(1982),
    [anon_sym_LT_GT] = ACTIONS(1980),
    [anon_sym_is] = ACTIONS(1980),
    [anon_sym_LBRACK] = ACTIONS(1980),
    [anon_sym_RBRACE] = ACTIONS(1980),
    [sym_comment] = ACTIONS(72),
  },
  [1781] = {
    [sym_argument_list] = STATE(251),
    [sym_generator_expression] = STATE(251),
    [anon_sym_DOT] = ACTIONS(1980),
    [anon_sym_LPAREN] = ACTIONS(424),
    [anon_sym_STAR] = ACTIONS(3549),
    [anon_sym_GT_GT] = ACTIONS(1980),
    [anon_sym_if] = ACTIONS(1980),
    [anon_sym_async] = ACTIONS(1980),
    [anon_sym_for] = ACTIONS(1980),
    [anon_sym_in] = ACTIONS(1980),
    [anon_sym_AT] = ACTIONS(3555),
    [anon_sym_not] = ACTIONS(1980),
    [anon_sym_and] = ACTIONS(1980),
    [anon_sym_or] = ACTIONS(1980),
    [anon_sym_PLUS] = ACTIONS(3559),
    [anon_sym_DASH] = ACTIONS(3559),
    [anon_sym_SLASH] = ACTIONS(3549),
    [anon_sym_PERCENT] = ACTIONS(3555),
    [anon_sym_SLASH_SLASH] = ACTIONS(3555),
    [anon_sym_STAR_STAR] = ACTIONS(3561),
    [anon_sym_PIPE] = ACTIONS(1980),
    [anon_sym_AMP] = ACTIONS(1980),
    [anon_sym_CARET] = ACTIONS(1980),
    [anon_sym_LT_LT] = ACTIONS(1980),
    [anon_sym_LT] = ACTIONS(1982),
    [anon_sym_LT_EQ] = ACTIONS(1980),
    [anon_sym_EQ_EQ] = ACTIONS(1980),
    [anon_sym_BANG_EQ] = ACTIONS(1980),
    [anon_sym_GT_EQ] = ACTIONS(1980),
    [anon_sym_GT] = ACTIONS(1982),
    [anon_sym_LT_GT] = ACTIONS(1980),
    [anon_sym_is] = ACTIONS(1980),
    [anon_sym_LBRACK] = ACTIONS(1980),
    [anon_sym_RBRACE] = ACTIONS(1980),
    [sym_comment] = ACTIONS(72),
  },
  [1782] = {
    [sym_argument_list] = STATE(251),
    [sym_generator_expression] = STATE(251),
    [anon_sym_DOT] = ACTIONS(422),
    [anon_sym_LPAREN] = ACTIONS(424),
    [anon_sym_STAR] = ACTIONS(3549),
    [anon_sym_GT_GT] = ACTIONS(3551),
    [anon_sym_if] = ACTIONS(1984),
    [anon_sym_async] = ACTIONS(1984),
    [anon_sym_for] = ACTIONS(1984),
    [anon_sym_in] = ACTIONS(1984),
    [anon_sym_AT] = ACTIONS(3555),
    [anon_sym_not] = ACTIONS(1984),
    [anon_sym_and] = ACTIONS(1984),
    [anon_sym_or] = ACTIONS(1984),
    [anon_sym_PLUS] = ACTIONS(3559),
    [anon_sym_DASH] = ACTIONS(3559),
    [anon_sym_SLASH] = ACTIONS(3549),
    [anon_sym_PERCENT] = ACTIONS(3555),
    [anon_sym_SLASH_SLASH] = ACTIONS(3555),
    [anon_sym_STAR_STAR] = ACTIONS(3561),
    [anon_sym_PIPE] = ACTIONS(3563),
    [anon_sym_AMP] = ACTIONS(3565),
    [anon_sym_CARET] = ACTIONS(3567),
    [anon_sym_LT_LT] = ACTIONS(3551),
    [anon_sym_LT] = ACTIONS(1986),
    [anon_sym_LT_EQ] = ACTIONS(1984),
    [anon_sym_EQ_EQ] = ACTIONS(1984),
    [anon_sym_BANG_EQ] = ACTIONS(1984),
    [anon_sym_GT_EQ] = ACTIONS(1984),
    [anon_sym_GT] = ACTIONS(1986),
    [anon_sym_LT_GT] = ACTIONS(1984),
    [anon_sym_is] = ACTIONS(1984),
    [anon_sym_LBRACK] = ACTIONS(450),
    [anon_sym_RBRACE] = ACTIONS(1984),
    [sym_comment] = ACTIONS(72),
  },
  [1783] = {
    [sym__primary_expression] = STATE(1880),
    [sym_binary_operator] = STATE(1880),
    [sym_unary_operator] = STATE(1880),
    [sym_attribute] = STATE(1880),
    [sym_subscript] = STATE(1880),
    [sym_call] = STATE(1880),
    [sym_list] = STATE(1880),
    [sym_list_comprehension] = STATE(1880),
    [sym_dictionary] = STATE(1880),
    [sym_dictionary_comprehension] = STATE(1880),
    [sym_set] = STATE(1880),
    [sym_set_comprehension] = STATE(1880),
    [sym_parenthesized_expression] = STATE(1880),
    [sym_tuple] = STATE(1880),
    [sym_generator_expression] = STATE(1880),
    [sym_concatenated_string] = STATE(1880),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_PLUS] = ACTIONS(2839),
    [anon_sym_DASH] = ACTIONS(2839),
    [anon_sym_TILDE] = ACTIONS(2839),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(4238),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(2845),
    [sym_integer] = ACTIONS(4240),
    [sym_float] = ACTIONS(4240),
    [sym_identifier] = ACTIONS(4240),
    [sym_true] = ACTIONS(4240),
    [sym_false] = ACTIONS(4240),
    [sym_none] = ACTIONS(4240),
    [sym_comment] = ACTIONS(72),
  },
  [1784] = {
    [sym_argument_list] = STATE(251),
    [sym_generator_expression] = STATE(251),
    [anon_sym_DOT] = ACTIONS(1980),
    [anon_sym_LPAREN] = ACTIONS(424),
    [anon_sym_STAR] = ACTIONS(3549),
    [anon_sym_GT_GT] = ACTIONS(1980),
    [anon_sym_if] = ACTIONS(1980),
    [anon_sym_async] = ACTIONS(1980),
    [anon_sym_for] = ACTIONS(1980),
    [anon_sym_in] = ACTIONS(1980),
    [anon_sym_AT] = ACTIONS(3555),
    [anon_sym_not] = ACTIONS(1980),
    [anon_sym_and] = ACTIONS(1980),
    [anon_sym_or] = ACTIONS(1980),
    [anon_sym_PLUS] = ACTIONS(1980),
    [anon_sym_DASH] = ACTIONS(1980),
    [anon_sym_SLASH] = ACTIONS(3549),
    [anon_sym_PERCENT] = ACTIONS(3555),
    [anon_sym_SLASH_SLASH] = ACTIONS(3555),
    [anon_sym_STAR_STAR] = ACTIONS(3561),
    [anon_sym_PIPE] = ACTIONS(1980),
    [anon_sym_AMP] = ACTIONS(1980),
    [anon_sym_CARET] = ACTIONS(1980),
    [anon_sym_LT_LT] = ACTIONS(1980),
    [anon_sym_LT] = ACTIONS(1982),
    [anon_sym_LT_EQ] = ACTIONS(1980),
    [anon_sym_EQ_EQ] = ACTIONS(1980),
    [anon_sym_BANG_EQ] = ACTIONS(1980),
    [anon_sym_GT_EQ] = ACTIONS(1980),
    [anon_sym_GT] = ACTIONS(1982),
    [anon_sym_LT_GT] = ACTIONS(1980),
    [anon_sym_is] = ACTIONS(1980),
    [anon_sym_LBRACK] = ACTIONS(1980),
    [anon_sym_RBRACE] = ACTIONS(1980),
    [sym_comment] = ACTIONS(72),
  },
  [1785] = {
    [sym_argument_list] = STATE(251),
    [sym_generator_expression] = STATE(251),
    [anon_sym_DOT] = ACTIONS(1980),
    [anon_sym_LPAREN] = ACTIONS(424),
    [anon_sym_STAR] = ACTIONS(3549),
    [anon_sym_GT_GT] = ACTIONS(3551),
    [anon_sym_if] = ACTIONS(1980),
    [anon_sym_async] = ACTIONS(1980),
    [anon_sym_for] = ACTIONS(1980),
    [anon_sym_in] = ACTIONS(1980),
    [anon_sym_AT] = ACTIONS(3555),
    [anon_sym_not] = ACTIONS(1980),
    [anon_sym_and] = ACTIONS(1980),
    [anon_sym_or] = ACTIONS(1980),
    [anon_sym_PLUS] = ACTIONS(3559),
    [anon_sym_DASH] = ACTIONS(3559),
    [anon_sym_SLASH] = ACTIONS(3549),
    [anon_sym_PERCENT] = ACTIONS(3555),
    [anon_sym_SLASH_SLASH] = ACTIONS(3555),
    [anon_sym_STAR_STAR] = ACTIONS(3561),
    [anon_sym_PIPE] = ACTIONS(1980),
    [anon_sym_AMP] = ACTIONS(3565),
    [anon_sym_CARET] = ACTIONS(3567),
    [anon_sym_LT_LT] = ACTIONS(3551),
    [anon_sym_LT] = ACTIONS(1982),
    [anon_sym_LT_EQ] = ACTIONS(1980),
    [anon_sym_EQ_EQ] = ACTIONS(1980),
    [anon_sym_BANG_EQ] = ACTIONS(1980),
    [anon_sym_GT_EQ] = ACTIONS(1980),
    [anon_sym_GT] = ACTIONS(1982),
    [anon_sym_LT_GT] = ACTIONS(1980),
    [anon_sym_is] = ACTIONS(1980),
    [anon_sym_LBRACK] = ACTIONS(1980),
    [anon_sym_RBRACE] = ACTIONS(1980),
    [sym_comment] = ACTIONS(72),
  },
  [1786] = {
    [sym_argument_list] = STATE(251),
    [sym_generator_expression] = STATE(251),
    [anon_sym_DOT] = ACTIONS(1980),
    [anon_sym_LPAREN] = ACTIONS(424),
    [anon_sym_STAR] = ACTIONS(3549),
    [anon_sym_GT_GT] = ACTIONS(3551),
    [anon_sym_if] = ACTIONS(1980),
    [anon_sym_async] = ACTIONS(1980),
    [anon_sym_for] = ACTIONS(1980),
    [anon_sym_in] = ACTIONS(1980),
    [anon_sym_AT] = ACTIONS(3555),
    [anon_sym_not] = ACTIONS(1980),
    [anon_sym_and] = ACTIONS(1980),
    [anon_sym_or] = ACTIONS(1980),
    [anon_sym_PLUS] = ACTIONS(3559),
    [anon_sym_DASH] = ACTIONS(3559),
    [anon_sym_SLASH] = ACTIONS(3549),
    [anon_sym_PERCENT] = ACTIONS(3555),
    [anon_sym_SLASH_SLASH] = ACTIONS(3555),
    [anon_sym_STAR_STAR] = ACTIONS(3561),
    [anon_sym_PIPE] = ACTIONS(1980),
    [anon_sym_AMP] = ACTIONS(1980),
    [anon_sym_CARET] = ACTIONS(3567),
    [anon_sym_LT_LT] = ACTIONS(3551),
    [anon_sym_LT] = ACTIONS(1982),
    [anon_sym_LT_EQ] = ACTIONS(1980),
    [anon_sym_EQ_EQ] = ACTIONS(1980),
    [anon_sym_BANG_EQ] = ACTIONS(1980),
    [anon_sym_GT_EQ] = ACTIONS(1980),
    [anon_sym_GT] = ACTIONS(1982),
    [anon_sym_LT_GT] = ACTIONS(1980),
    [anon_sym_is] = ACTIONS(1980),
    [anon_sym_LBRACK] = ACTIONS(1980),
    [anon_sym_RBRACE] = ACTIONS(1980),
    [sym_comment] = ACTIONS(72),
  },
  [1787] = {
    [sym_argument_list] = STATE(251),
    [sym_generator_expression] = STATE(251),
    [anon_sym_DOT] = ACTIONS(1980),
    [anon_sym_LPAREN] = ACTIONS(424),
    [anon_sym_STAR] = ACTIONS(3549),
    [anon_sym_GT_GT] = ACTIONS(3551),
    [anon_sym_if] = ACTIONS(1980),
    [anon_sym_async] = ACTIONS(1980),
    [anon_sym_for] = ACTIONS(1980),
    [anon_sym_in] = ACTIONS(1980),
    [anon_sym_AT] = ACTIONS(3555),
    [anon_sym_not] = ACTIONS(1980),
    [anon_sym_and] = ACTIONS(1980),
    [anon_sym_or] = ACTIONS(1980),
    [anon_sym_PLUS] = ACTIONS(3559),
    [anon_sym_DASH] = ACTIONS(3559),
    [anon_sym_SLASH] = ACTIONS(3549),
    [anon_sym_PERCENT] = ACTIONS(3555),
    [anon_sym_SLASH_SLASH] = ACTIONS(3555),
    [anon_sym_STAR_STAR] = ACTIONS(3561),
    [anon_sym_PIPE] = ACTIONS(1980),
    [anon_sym_AMP] = ACTIONS(1980),
    [anon_sym_CARET] = ACTIONS(1980),
    [anon_sym_LT_LT] = ACTIONS(3551),
    [anon_sym_LT] = ACTIONS(1982),
    [anon_sym_LT_EQ] = ACTIONS(1980),
    [anon_sym_EQ_EQ] = ACTIONS(1980),
    [anon_sym_BANG_EQ] = ACTIONS(1980),
    [anon_sym_GT_EQ] = ACTIONS(1980),
    [anon_sym_GT] = ACTIONS(1982),
    [anon_sym_LT_GT] = ACTIONS(1980),
    [anon_sym_is] = ACTIONS(1980),
    [anon_sym_LBRACK] = ACTIONS(1980),
    [anon_sym_RBRACE] = ACTIONS(1980),
    [sym_comment] = ACTIONS(72),
  },
  [1788] = {
    [aux_sym_comparison_operator_repeat1] = STATE(1788),
    [anon_sym_if] = ACTIONS(1984),
    [anon_sym_async] = ACTIONS(1984),
    [anon_sym_for] = ACTIONS(1984),
    [anon_sym_in] = ACTIONS(4242),
    [anon_sym_not] = ACTIONS(4245),
    [anon_sym_and] = ACTIONS(1984),
    [anon_sym_or] = ACTIONS(1984),
    [anon_sym_LT] = ACTIONS(4248),
    [anon_sym_LT_EQ] = ACTIONS(4242),
    [anon_sym_EQ_EQ] = ACTIONS(4242),
    [anon_sym_BANG_EQ] = ACTIONS(4242),
    [anon_sym_GT_EQ] = ACTIONS(4242),
    [anon_sym_GT] = ACTIONS(4248),
    [anon_sym_LT_GT] = ACTIONS(4242),
    [anon_sym_is] = ACTIONS(4251),
    [anon_sym_RBRACE] = ACTIONS(1984),
    [sym_comment] = ACTIONS(72),
  },
  [1789] = {
    [sym__newline] = ACTIONS(3610),
    [anon_sym_if] = ACTIONS(1875),
    [anon_sym_EQ] = ACTIONS(3610),
    [anon_sym_and] = ACTIONS(1877),
    [anon_sym_or] = ACTIONS(1879),
    [sym_comment] = ACTIONS(72),
    [sym__semicolon] = ACTIONS(3610),
  },
  [1790] = {
    [anon_sym_if] = ACTIONS(1921),
    [anon_sym_else] = ACTIONS(3610),
    [anon_sym_and] = ACTIONS(1925),
    [anon_sym_or] = ACTIONS(1927),
    [sym_comment] = ACTIONS(72),
  },
  [1791] = {
    [anon_sym_COMMA] = ACTIONS(3610),
    [anon_sym_if] = ACTIONS(2002),
    [anon_sym_COLON] = ACTIONS(3610),
    [anon_sym_and] = ACTIONS(2006),
    [anon_sym_or] = ACTIONS(2008),
    [anon_sym_RBRACK] = ACTIONS(3610),
    [sym_comment] = ACTIONS(72),
  },
  [1792] = {
    [anon_sym_COMMA] = ACTIONS(4254),
    [anon_sym_if] = ACTIONS(1674),
    [anon_sym_and] = ACTIONS(1676),
    [anon_sym_or] = ACTIONS(1678),
    [anon_sym_RBRACK] = ACTIONS(4254),
    [sym_comment] = ACTIONS(72),
  },
  [1793] = {
    [sym_aliased_import] = STATE(1638),
    [sym_dotted_name] = STATE(1639),
    [sym_identifier] = ACTIONS(2065),
    [sym_comment] = ACTIONS(72),
  },
  [1794] = {
    [sym__expression_within_for_in_clause] = STATE(1798),
    [sym__expression] = STATE(1405),
    [sym__primary_expression] = STATE(59),
    [sym_not_operator] = STATE(1405),
    [sym_boolean_operator] = STATE(1405),
    [sym_binary_operator] = STATE(59),
    [sym_unary_operator] = STATE(59),
    [sym_comparison_operator] = STATE(1405),
    [sym_lambda] = STATE(1405),
    [sym_lambda_within_for_in_clause] = STATE(1406),
    [sym_attribute] = STATE(59),
    [sym_subscript] = STATE(59),
    [sym_call] = STATE(59),
    [sym_list] = STATE(59),
    [sym_list_comprehension] = STATE(59),
    [sym_dictionary] = STATE(59),
    [sym_dictionary_comprehension] = STATE(59),
    [sym_set] = STATE(59),
    [sym_set_comprehension] = STATE(59),
    [sym_parenthesized_expression] = STATE(59),
    [sym_tuple] = STATE(59),
    [sym_generator_expression] = STATE(59),
    [sym_conditional_expression] = STATE(1405),
    [sym_concatenated_string] = STATE(59),
    [sym_await] = STATE(1405),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_RPAREN] = ACTIONS(4256),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_if] = ACTIONS(4258),
    [anon_sym_async] = ACTIONS(4258),
    [anon_sym_for] = ACTIONS(4258),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_not] = ACTIONS(88),
    [anon_sym_PLUS] = ACTIONS(90),
    [anon_sym_DASH] = ACTIONS(90),
    [anon_sym_TILDE] = ACTIONS(90),
    [anon_sym_lambda] = ACTIONS(3045),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(98),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(102),
    [sym_integer] = ACTIONS(104),
    [sym_float] = ACTIONS(104),
    [sym_identifier] = ACTIONS(104),
    [sym_true] = ACTIONS(104),
    [sym_false] = ACTIONS(104),
    [sym_none] = ACTIONS(104),
    [anon_sym_await] = ACTIONS(106),
    [sym_comment] = ACTIONS(72),
  },
  [1795] = {
    [aux_sym_for_in_clause_repeat1] = STATE(1799),
    [anon_sym_RPAREN] = ACTIONS(4256),
    [anon_sym_COMMA] = ACTIONS(4260),
    [anon_sym_if] = ACTIONS(4256),
    [anon_sym_async] = ACTIONS(4256),
    [anon_sym_for] = ACTIONS(4256),
    [sym_comment] = ACTIONS(72),
  },
  [1796] = {
    [anon_sym_RPAREN] = ACTIONS(4262),
    [anon_sym_COMMA] = ACTIONS(4262),
    [anon_sym_if] = ACTIONS(4262),
    [anon_sym_async] = ACTIONS(4262),
    [anon_sym_for] = ACTIONS(4262),
    [anon_sym_RBRACK] = ACTIONS(4262),
    [anon_sym_RBRACE] = ACTIONS(4262),
    [sym_comment] = ACTIONS(72),
  },
  [1797] = {
    [sym__expression_within_for_in_clause] = STATE(1882),
    [sym__expression] = STATE(1405),
    [sym__primary_expression] = STATE(59),
    [sym_not_operator] = STATE(1405),
    [sym_boolean_operator] = STATE(1405),
    [sym_binary_operator] = STATE(59),
    [sym_unary_operator] = STATE(59),
    [sym_comparison_operator] = STATE(1405),
    [sym_lambda] = STATE(1405),
    [sym_lambda_within_for_in_clause] = STATE(1406),
    [sym_attribute] = STATE(59),
    [sym_subscript] = STATE(59),
    [sym_call] = STATE(59),
    [sym_list] = STATE(59),
    [sym_list_comprehension] = STATE(59),
    [sym_dictionary] = STATE(59),
    [sym_dictionary_comprehension] = STATE(59),
    [sym_set] = STATE(59),
    [sym_set_comprehension] = STATE(59),
    [sym_parenthesized_expression] = STATE(59),
    [sym_tuple] = STATE(59),
    [sym_generator_expression] = STATE(59),
    [sym_conditional_expression] = STATE(1405),
    [sym_concatenated_string] = STATE(59),
    [sym_await] = STATE(1405),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_not] = ACTIONS(88),
    [anon_sym_PLUS] = ACTIONS(90),
    [anon_sym_DASH] = ACTIONS(90),
    [anon_sym_TILDE] = ACTIONS(90),
    [anon_sym_lambda] = ACTIONS(3045),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(98),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(102),
    [sym_integer] = ACTIONS(104),
    [sym_float] = ACTIONS(104),
    [sym_identifier] = ACTIONS(104),
    [sym_true] = ACTIONS(104),
    [sym_false] = ACTIONS(104),
    [sym_none] = ACTIONS(104),
    [anon_sym_await] = ACTIONS(106),
    [sym_comment] = ACTIONS(72),
  },
  [1798] = {
    [anon_sym_RPAREN] = ACTIONS(4264),
    [anon_sym_COMMA] = ACTIONS(4264),
    [anon_sym_if] = ACTIONS(4264),
    [anon_sym_async] = ACTIONS(4264),
    [anon_sym_for] = ACTIONS(4264),
    [anon_sym_RBRACK] = ACTIONS(4264),
    [anon_sym_RBRACE] = ACTIONS(4264),
    [sym_comment] = ACTIONS(72),
  },
  [1799] = {
    [aux_sym_for_in_clause_repeat1] = STATE(1799),
    [anon_sym_RPAREN] = ACTIONS(4264),
    [anon_sym_COMMA] = ACTIONS(4266),
    [anon_sym_if] = ACTIONS(4264),
    [anon_sym_async] = ACTIONS(4264),
    [anon_sym_for] = ACTIONS(4264),
    [sym_comment] = ACTIONS(72),
  },
  [1800] = {
    [anon_sym_RPAREN] = ACTIONS(2642),
    [anon_sym_if] = ACTIONS(4060),
    [anon_sym_async] = ACTIONS(2642),
    [anon_sym_for] = ACTIONS(2642),
    [anon_sym_and] = ACTIONS(3053),
    [anon_sym_or] = ACTIONS(3055),
    [sym_comment] = ACTIONS(72),
  },
  [1801] = {
    [sym__expression] = STATE(1884),
    [sym__primary_expression] = STATE(1064),
    [sym_not_operator] = STATE(1884),
    [sym_boolean_operator] = STATE(1884),
    [sym_binary_operator] = STATE(1064),
    [sym_unary_operator] = STATE(1064),
    [sym_comparison_operator] = STATE(1884),
    [sym_lambda] = STATE(1884),
    [sym_attribute] = STATE(1064),
    [sym_subscript] = STATE(1064),
    [sym_call] = STATE(1064),
    [sym_list] = STATE(1064),
    [sym_list_comprehension] = STATE(1064),
    [sym_dictionary] = STATE(1064),
    [sym_dictionary_comprehension] = STATE(1064),
    [sym_set] = STATE(1064),
    [sym_set_comprehension] = STATE(1064),
    [sym_parenthesized_expression] = STATE(1064),
    [sym_tuple] = STATE(1064),
    [sym_generator_expression] = STATE(1064),
    [sym_conditional_expression] = STATE(1884),
    [sym_concatenated_string] = STATE(1064),
    [sym_await] = STATE(1884),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_not] = ACTIONS(2152),
    [anon_sym_PLUS] = ACTIONS(2154),
    [anon_sym_DASH] = ACTIONS(2154),
    [anon_sym_TILDE] = ACTIONS(2154),
    [anon_sym_lambda] = ACTIONS(2156),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(2158),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(2160),
    [sym_integer] = ACTIONS(2162),
    [sym_float] = ACTIONS(2162),
    [sym_identifier] = ACTIONS(2162),
    [sym_true] = ACTIONS(2162),
    [sym_false] = ACTIONS(2162),
    [sym_none] = ACTIONS(2162),
    [anon_sym_await] = ACTIONS(2164),
    [sym_comment] = ACTIONS(72),
  },
  [1802] = {
    [sym_argument_list] = STATE(251),
    [sym_generator_expression] = STATE(251),
    [anon_sym_DOT] = ACTIONS(422),
    [anon_sym_LPAREN] = ACTIONS(424),
    [anon_sym_RPAREN] = ACTIONS(2953),
    [anon_sym_STAR] = ACTIONS(3057),
    [anon_sym_GT_GT] = ACTIONS(3059),
    [anon_sym_if] = ACTIONS(2953),
    [anon_sym_async] = ACTIONS(2953),
    [anon_sym_for] = ACTIONS(2953),
    [anon_sym_in] = ACTIONS(2953),
    [anon_sym_AT] = ACTIONS(3063),
    [anon_sym_not] = ACTIONS(2953),
    [anon_sym_and] = ACTIONS(2953),
    [anon_sym_or] = ACTIONS(2953),
    [anon_sym_PLUS] = ACTIONS(3067),
    [anon_sym_DASH] = ACTIONS(3067),
    [anon_sym_SLASH] = ACTIONS(3057),
    [anon_sym_PERCENT] = ACTIONS(3063),
    [anon_sym_SLASH_SLASH] = ACTIONS(3063),
    [anon_sym_STAR_STAR] = ACTIONS(3069),
    [anon_sym_PIPE] = ACTIONS(3071),
    [anon_sym_AMP] = ACTIONS(3073),
    [anon_sym_CARET] = ACTIONS(3075),
    [anon_sym_LT_LT] = ACTIONS(3059),
    [anon_sym_LT] = ACTIONS(2955),
    [anon_sym_LT_EQ] = ACTIONS(2953),
    [anon_sym_EQ_EQ] = ACTIONS(2953),
    [anon_sym_BANG_EQ] = ACTIONS(2953),
    [anon_sym_GT_EQ] = ACTIONS(2953),
    [anon_sym_GT] = ACTIONS(2955),
    [anon_sym_LT_GT] = ACTIONS(2953),
    [anon_sym_is] = ACTIONS(2953),
    [anon_sym_LBRACK] = ACTIONS(450),
    [sym_comment] = ACTIONS(72),
  },
  [1803] = {
    [ts_builtin_sym_end] = ACTIONS(4269),
    [anon_sym_import] = ACTIONS(4271),
    [anon_sym_from] = ACTIONS(4271),
    [anon_sym_LPAREN] = ACTIONS(4269),
    [anon_sym_print] = ACTIONS(4271),
    [anon_sym_assert] = ACTIONS(4271),
    [anon_sym_return] = ACTIONS(4271),
    [anon_sym_del] = ACTIONS(4271),
    [anon_sym_raise] = ACTIONS(4271),
    [sym_pass_statement] = ACTIONS(4271),
    [sym_break_statement] = ACTIONS(4271),
    [sym_continue_statement] = ACTIONS(4271),
    [anon_sym_if] = ACTIONS(4271),
    [anon_sym_elif] = ACTIONS(4271),
    [anon_sym_else] = ACTIONS(4271),
    [anon_sym_async] = ACTIONS(4271),
    [anon_sym_for] = ACTIONS(4271),
    [anon_sym_while] = ACTIONS(4271),
    [anon_sym_try] = ACTIONS(4271),
    [anon_sym_with] = ACTIONS(4271),
    [anon_sym_def] = ACTIONS(4271),
    [anon_sym_global] = ACTIONS(4271),
    [anon_sym_nonlocal] = ACTIONS(4271),
    [anon_sym_exec] = ACTIONS(4271),
    [anon_sym_class] = ACTIONS(4271),
    [anon_sym_AT] = ACTIONS(4269),
    [anon_sym_not] = ACTIONS(4271),
    [anon_sym_PLUS] = ACTIONS(4269),
    [anon_sym_DASH] = ACTIONS(4269),
    [anon_sym_TILDE] = ACTIONS(4269),
    [anon_sym_lambda] = ACTIONS(4271),
    [anon_sym_yield] = ACTIONS(4271),
    [anon_sym_LBRACK] = ACTIONS(4269),
    [sym_ellipsis] = ACTIONS(4269),
    [anon_sym_LBRACE] = ACTIONS(4269),
    [sym_string] = ACTIONS(4269),
    [sym_integer] = ACTIONS(4271),
    [sym_float] = ACTIONS(4271),
    [sym_identifier] = ACTIONS(4271),
    [sym_true] = ACTIONS(4271),
    [sym_false] = ACTIONS(4271),
    [sym_none] = ACTIONS(4271),
    [anon_sym_await] = ACTIONS(4271),
    [sym_comment] = ACTIONS(72),
  },
  [1804] = {
    [ts_builtin_sym_end] = ACTIONS(4273),
    [anon_sym_import] = ACTIONS(4275),
    [anon_sym_from] = ACTIONS(4275),
    [anon_sym_LPAREN] = ACTIONS(4273),
    [anon_sym_print] = ACTIONS(4275),
    [anon_sym_assert] = ACTIONS(4275),
    [anon_sym_return] = ACTIONS(4275),
    [anon_sym_del] = ACTIONS(4275),
    [anon_sym_raise] = ACTIONS(4275),
    [sym_pass_statement] = ACTIONS(4275),
    [sym_break_statement] = ACTIONS(4275),
    [sym_continue_statement] = ACTIONS(4275),
    [anon_sym_if] = ACTIONS(4275),
    [anon_sym_async] = ACTIONS(4275),
    [anon_sym_for] = ACTIONS(4275),
    [anon_sym_while] = ACTIONS(4275),
    [anon_sym_try] = ACTIONS(4275),
    [anon_sym_with] = ACTIONS(4275),
    [anon_sym_def] = ACTIONS(4275),
    [anon_sym_global] = ACTIONS(4275),
    [anon_sym_nonlocal] = ACTIONS(4275),
    [anon_sym_exec] = ACTIONS(4275),
    [anon_sym_class] = ACTIONS(4275),
    [anon_sym_AT] = ACTIONS(4273),
    [anon_sym_not] = ACTIONS(4275),
    [anon_sym_PLUS] = ACTIONS(4273),
    [anon_sym_DASH] = ACTIONS(4273),
    [anon_sym_TILDE] = ACTIONS(4273),
    [anon_sym_lambda] = ACTIONS(4275),
    [anon_sym_yield] = ACTIONS(4275),
    [anon_sym_LBRACK] = ACTIONS(4273),
    [sym_ellipsis] = ACTIONS(4273),
    [anon_sym_LBRACE] = ACTIONS(4273),
    [sym_string] = ACTIONS(4273),
    [sym_integer] = ACTIONS(4275),
    [sym_float] = ACTIONS(4275),
    [sym_identifier] = ACTIONS(4275),
    [sym_true] = ACTIONS(4275),
    [sym_false] = ACTIONS(4275),
    [sym_none] = ACTIONS(4275),
    [anon_sym_await] = ACTIONS(4275),
    [sym_comment] = ACTIONS(72),
  },
  [1805] = {
    [ts_builtin_sym_end] = ACTIONS(4277),
    [anon_sym_import] = ACTIONS(4279),
    [anon_sym_from] = ACTIONS(4279),
    [anon_sym_LPAREN] = ACTIONS(4277),
    [anon_sym_print] = ACTIONS(4279),
    [anon_sym_assert] = ACTIONS(4279),
    [anon_sym_return] = ACTIONS(4279),
    [anon_sym_del] = ACTIONS(4279),
    [anon_sym_raise] = ACTIONS(4279),
    [sym_pass_statement] = ACTIONS(4279),
    [sym_break_statement] = ACTIONS(4279),
    [sym_continue_statement] = ACTIONS(4279),
    [anon_sym_if] = ACTIONS(4279),
    [anon_sym_async] = ACTIONS(4279),
    [anon_sym_for] = ACTIONS(4279),
    [anon_sym_while] = ACTIONS(4279),
    [anon_sym_try] = ACTIONS(4279),
    [anon_sym_with] = ACTIONS(4279),
    [anon_sym_def] = ACTIONS(4279),
    [anon_sym_global] = ACTIONS(4279),
    [anon_sym_nonlocal] = ACTIONS(4279),
    [anon_sym_exec] = ACTIONS(4279),
    [anon_sym_class] = ACTIONS(4279),
    [anon_sym_AT] = ACTIONS(4277),
    [anon_sym_not] = ACTIONS(4279),
    [anon_sym_PLUS] = ACTIONS(4277),
    [anon_sym_DASH] = ACTIONS(4277),
    [anon_sym_TILDE] = ACTIONS(4277),
    [anon_sym_lambda] = ACTIONS(4279),
    [anon_sym_yield] = ACTIONS(4279),
    [anon_sym_LBRACK] = ACTIONS(4277),
    [sym_ellipsis] = ACTIONS(4277),
    [anon_sym_LBRACE] = ACTIONS(4277),
    [sym_string] = ACTIONS(4277),
    [sym_integer] = ACTIONS(4279),
    [sym_float] = ACTIONS(4279),
    [sym_identifier] = ACTIONS(4279),
    [sym_true] = ACTIONS(4279),
    [sym_false] = ACTIONS(4279),
    [sym_none] = ACTIONS(4279),
    [anon_sym_await] = ACTIONS(4279),
    [sym_comment] = ACTIONS(72),
  },
  [1806] = {
    [sym__dedent] = ACTIONS(2388),
    [anon_sym_import] = ACTIONS(2390),
    [anon_sym_from] = ACTIONS(2390),
    [anon_sym_LPAREN] = ACTIONS(2388),
    [anon_sym_print] = ACTIONS(2390),
    [anon_sym_assert] = ACTIONS(2390),
    [anon_sym_return] = ACTIONS(2390),
    [anon_sym_del] = ACTIONS(2390),
    [anon_sym_raise] = ACTIONS(2390),
    [sym_pass_statement] = ACTIONS(2390),
    [sym_break_statement] = ACTIONS(2390),
    [sym_continue_statement] = ACTIONS(2390),
    [anon_sym_if] = ACTIONS(2390),
    [anon_sym_elif] = ACTIONS(2390),
    [anon_sym_else] = ACTIONS(2390),
    [anon_sym_async] = ACTIONS(2390),
    [anon_sym_for] = ACTIONS(2390),
    [anon_sym_while] = ACTIONS(2390),
    [anon_sym_try] = ACTIONS(2390),
    [anon_sym_with] = ACTIONS(2390),
    [anon_sym_def] = ACTIONS(2390),
    [anon_sym_global] = ACTIONS(2390),
    [anon_sym_nonlocal] = ACTIONS(2390),
    [anon_sym_exec] = ACTIONS(2390),
    [anon_sym_class] = ACTIONS(2390),
    [anon_sym_AT] = ACTIONS(2388),
    [anon_sym_not] = ACTIONS(2390),
    [anon_sym_PLUS] = ACTIONS(2388),
    [anon_sym_DASH] = ACTIONS(2388),
    [anon_sym_TILDE] = ACTIONS(2388),
    [anon_sym_lambda] = ACTIONS(2390),
    [anon_sym_yield] = ACTIONS(2390),
    [anon_sym_LBRACK] = ACTIONS(2388),
    [sym_ellipsis] = ACTIONS(2388),
    [anon_sym_LBRACE] = ACTIONS(2388),
    [sym_string] = ACTIONS(2388),
    [sym_integer] = ACTIONS(2390),
    [sym_float] = ACTIONS(2390),
    [sym_identifier] = ACTIONS(2390),
    [sym_true] = ACTIONS(2390),
    [sym_false] = ACTIONS(2390),
    [sym_none] = ACTIONS(2390),
    [anon_sym_await] = ACTIONS(2390),
    [sym_comment] = ACTIONS(72),
  },
  [1807] = {
    [sym__statement] = STATE(1155),
    [sym__simple_statements] = STATE(1155),
    [sym_import_statement] = STATE(746),
    [sym_import_from_statement] = STATE(746),
    [sym_print_statement] = STATE(746),
    [sym_assert_statement] = STATE(746),
    [sym_expression_statement] = STATE(746),
    [sym_return_statement] = STATE(746),
    [sym_delete_statement] = STATE(746),
    [sym_raise_statement] = STATE(746),
    [sym_if_statement] = STATE(1155),
    [sym_for_statement] = STATE(1155),
    [sym_while_statement] = STATE(1155),
    [sym_try_statement] = STATE(1155),
    [sym_with_statement] = STATE(1155),
    [sym_function_definition] = STATE(1155),
    [sym_global_statement] = STATE(746),
    [sym_nonlocal_statement] = STATE(746),
    [sym_exec_statement] = STATE(746),
    [sym_class_definition] = STATE(1155),
    [sym_decorated_definition] = STATE(1155),
    [sym_decorator] = STATE(756),
    [sym_expression_list] = STATE(32),
    [sym__expression] = STATE(33),
    [sym__primary_expression] = STATE(34),
    [sym_not_operator] = STATE(33),
    [sym_boolean_operator] = STATE(33),
    [sym_binary_operator] = STATE(34),
    [sym_unary_operator] = STATE(34),
    [sym_comparison_operator] = STATE(33),
    [sym_lambda] = STATE(33),
    [sym_assignment] = STATE(35),
    [sym_augmented_assignment] = STATE(35),
    [sym_yield] = STATE(35),
    [sym_attribute] = STATE(34),
    [sym_subscript] = STATE(34),
    [sym_call] = STATE(34),
    [sym_list] = STATE(34),
    [sym_list_comprehension] = STATE(34),
    [sym_dictionary] = STATE(34),
    [sym_dictionary_comprehension] = STATE(34),
    [sym_set] = STATE(34),
    [sym_set_comprehension] = STATE(34),
    [sym_parenthesized_expression] = STATE(34),
    [sym_tuple] = STATE(34),
    [sym_generator_expression] = STATE(34),
    [sym_conditional_expression] = STATE(33),
    [sym_concatenated_string] = STATE(34),
    [sym_await] = STATE(33),
    [aux_sym_module_repeat1] = STATE(1155),
    [aux_sym_decorated_definition_repeat1] = STATE(756),
    [sym__dedent] = ACTIONS(4281),
    [anon_sym_import] = ACTIONS(10),
    [anon_sym_from] = ACTIONS(12),
    [anon_sym_LPAREN] = ACTIONS(14),
    [anon_sym_print] = ACTIONS(16),
    [anon_sym_assert] = ACTIONS(18),
    [anon_sym_return] = ACTIONS(20),
    [anon_sym_del] = ACTIONS(22),
    [anon_sym_raise] = ACTIONS(24),
    [sym_pass_statement] = ACTIONS(1498),
    [sym_break_statement] = ACTIONS(1498),
    [sym_continue_statement] = ACTIONS(1498),
    [anon_sym_if] = ACTIONS(1500),
    [anon_sym_async] = ACTIONS(1502),
    [anon_sym_for] = ACTIONS(1504),
    [anon_sym_while] = ACTIONS(1506),
    [anon_sym_try] = ACTIONS(1508),
    [anon_sym_with] = ACTIONS(1510),
    [anon_sym_def] = ACTIONS(1512),
    [anon_sym_global] = ACTIONS(42),
    [anon_sym_nonlocal] = ACTIONS(44),
    [anon_sym_exec] = ACTIONS(46),
    [anon_sym_class] = ACTIONS(1514),
    [anon_sym_AT] = ACTIONS(50),
    [anon_sym_not] = ACTIONS(52),
    [anon_sym_PLUS] = ACTIONS(54),
    [anon_sym_DASH] = ACTIONS(54),
    [anon_sym_TILDE] = ACTIONS(54),
    [anon_sym_lambda] = ACTIONS(56),
    [anon_sym_yield] = ACTIONS(58),
    [anon_sym_LBRACK] = ACTIONS(60),
    [sym_ellipsis] = ACTIONS(62),
    [anon_sym_LBRACE] = ACTIONS(64),
    [sym_string] = ACTIONS(66),
    [sym_integer] = ACTIONS(68),
    [sym_float] = ACTIONS(68),
    [sym_identifier] = ACTIONS(68),
    [sym_true] = ACTIONS(68),
    [sym_false] = ACTIONS(68),
    [sym_none] = ACTIONS(68),
    [anon_sym_await] = ACTIONS(70),
    [sym_comment] = ACTIONS(72),
  },
  [1808] = {
    [sym__dedent] = ACTIONS(576),
    [anon_sym_import] = ACTIONS(578),
    [anon_sym_from] = ACTIONS(578),
    [anon_sym_LPAREN] = ACTIONS(576),
    [anon_sym_print] = ACTIONS(578),
    [anon_sym_assert] = ACTIONS(578),
    [anon_sym_return] = ACTIONS(578),
    [anon_sym_del] = ACTIONS(578),
    [anon_sym_raise] = ACTIONS(578),
    [sym_pass_statement] = ACTIONS(578),
    [sym_break_statement] = ACTIONS(578),
    [sym_continue_statement] = ACTIONS(578),
    [anon_sym_if] = ACTIONS(578),
    [anon_sym_elif] = ACTIONS(578),
    [anon_sym_else] = ACTIONS(578),
    [anon_sym_async] = ACTIONS(578),
    [anon_sym_for] = ACTIONS(578),
    [anon_sym_while] = ACTIONS(578),
    [anon_sym_try] = ACTIONS(578),
    [anon_sym_with] = ACTIONS(578),
    [anon_sym_def] = ACTIONS(578),
    [anon_sym_global] = ACTIONS(578),
    [anon_sym_nonlocal] = ACTIONS(578),
    [anon_sym_exec] = ACTIONS(578),
    [anon_sym_class] = ACTIONS(578),
    [anon_sym_AT] = ACTIONS(576),
    [anon_sym_not] = ACTIONS(578),
    [anon_sym_PLUS] = ACTIONS(576),
    [anon_sym_DASH] = ACTIONS(576),
    [anon_sym_TILDE] = ACTIONS(576),
    [anon_sym_lambda] = ACTIONS(578),
    [anon_sym_yield] = ACTIONS(578),
    [anon_sym_LBRACK] = ACTIONS(576),
    [sym_ellipsis] = ACTIONS(576),
    [anon_sym_LBRACE] = ACTIONS(576),
    [sym_string] = ACTIONS(576),
    [sym_integer] = ACTIONS(578),
    [sym_float] = ACTIONS(578),
    [sym_identifier] = ACTIONS(578),
    [sym_true] = ACTIONS(578),
    [sym_false] = ACTIONS(578),
    [sym_none] = ACTIONS(578),
    [anon_sym_await] = ACTIONS(578),
    [sym_comment] = ACTIONS(72),
  },
  [1809] = {
    [sym_import_statement] = STATE(326),
    [sym_import_from_statement] = STATE(326),
    [sym_print_statement] = STATE(326),
    [sym_assert_statement] = STATE(326),
    [sym_expression_statement] = STATE(326),
    [sym_return_statement] = STATE(326),
    [sym_delete_statement] = STATE(326),
    [sym_raise_statement] = STATE(326),
    [sym_global_statement] = STATE(326),
    [sym_nonlocal_statement] = STATE(326),
    [sym_exec_statement] = STATE(326),
    [sym_expression_list] = STATE(32),
    [sym__expression] = STATE(33),
    [sym__primary_expression] = STATE(34),
    [sym_not_operator] = STATE(33),
    [sym_boolean_operator] = STATE(33),
    [sym_binary_operator] = STATE(34),
    [sym_unary_operator] = STATE(34),
    [sym_comparison_operator] = STATE(33),
    [sym_lambda] = STATE(33),
    [sym_assignment] = STATE(35),
    [sym_augmented_assignment] = STATE(35),
    [sym_yield] = STATE(35),
    [sym_attribute] = STATE(34),
    [sym_subscript] = STATE(34),
    [sym_call] = STATE(34),
    [sym_list] = STATE(34),
    [sym_list_comprehension] = STATE(34),
    [sym_dictionary] = STATE(34),
    [sym_dictionary_comprehension] = STATE(34),
    [sym_set] = STATE(34),
    [sym_set_comprehension] = STATE(34),
    [sym_parenthesized_expression] = STATE(34),
    [sym_tuple] = STATE(34),
    [sym_generator_expression] = STATE(34),
    [sym_conditional_expression] = STATE(33),
    [sym_concatenated_string] = STATE(34),
    [sym_await] = STATE(33),
    [sym__newline] = ACTIONS(4283),
    [anon_sym_import] = ACTIONS(10),
    [anon_sym_from] = ACTIONS(12),
    [anon_sym_LPAREN] = ACTIONS(14),
    [anon_sym_print] = ACTIONS(16),
    [anon_sym_assert] = ACTIONS(18),
    [anon_sym_return] = ACTIONS(20),
    [anon_sym_del] = ACTIONS(22),
    [anon_sym_raise] = ACTIONS(24),
    [sym_pass_statement] = ACTIONS(582),
    [sym_break_statement] = ACTIONS(582),
    [sym_continue_statement] = ACTIONS(582),
    [anon_sym_global] = ACTIONS(42),
    [anon_sym_nonlocal] = ACTIONS(44),
    [anon_sym_exec] = ACTIONS(46),
    [anon_sym_not] = ACTIONS(52),
    [anon_sym_PLUS] = ACTIONS(54),
    [anon_sym_DASH] = ACTIONS(54),
    [anon_sym_TILDE] = ACTIONS(54),
    [anon_sym_lambda] = ACTIONS(56),
    [anon_sym_yield] = ACTIONS(58),
    [anon_sym_LBRACK] = ACTIONS(60),
    [sym_ellipsis] = ACTIONS(62),
    [anon_sym_LBRACE] = ACTIONS(64),
    [sym_string] = ACTIONS(66),
    [sym_integer] = ACTIONS(68),
    [sym_float] = ACTIONS(68),
    [sym_identifier] = ACTIONS(68),
    [sym_true] = ACTIONS(68),
    [sym_false] = ACTIONS(68),
    [sym_none] = ACTIONS(68),
    [anon_sym_await] = ACTIONS(70),
    [sym_comment] = ACTIONS(72),
  },
  [1810] = {
    [aux_sym__simple_statements_repeat1] = STATE(328),
    [sym__newline] = ACTIONS(4283),
    [sym_comment] = ACTIONS(72),
    [sym__semicolon] = ACTIONS(4285),
  },
  [1811] = {
    [sym__expression] = STATE(1888),
    [sym__primary_expression] = STATE(96),
    [sym_not_operator] = STATE(1888),
    [sym_boolean_operator] = STATE(1888),
    [sym_binary_operator] = STATE(96),
    [sym_unary_operator] = STATE(96),
    [sym_comparison_operator] = STATE(1888),
    [sym_lambda] = STATE(1888),
    [sym_attribute] = STATE(96),
    [sym_subscript] = STATE(96),
    [sym_call] = STATE(96),
    [sym_list] = STATE(96),
    [sym_list_comprehension] = STATE(96),
    [sym_dictionary] = STATE(96),
    [sym_dictionary_comprehension] = STATE(96),
    [sym_set] = STATE(96),
    [sym_set_comprehension] = STATE(96),
    [sym_parenthesized_expression] = STATE(96),
    [sym_tuple] = STATE(96),
    [sym_generator_expression] = STATE(96),
    [sym_conditional_expression] = STATE(1888),
    [sym_concatenated_string] = STATE(96),
    [sym_await] = STATE(1888),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_not] = ACTIONS(160),
    [anon_sym_PLUS] = ACTIONS(162),
    [anon_sym_DASH] = ACTIONS(162),
    [anon_sym_TILDE] = ACTIONS(162),
    [anon_sym_lambda] = ACTIONS(164),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(166),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(168),
    [sym_integer] = ACTIONS(170),
    [sym_float] = ACTIONS(170),
    [sym_identifier] = ACTIONS(170),
    [sym_true] = ACTIONS(170),
    [sym_false] = ACTIONS(170),
    [sym_none] = ACTIONS(170),
    [anon_sym_await] = ACTIONS(172),
    [sym_comment] = ACTIONS(72),
  },
  [1812] = {
    [anon_sym_COLON] = ACTIONS(4287),
    [sym_comment] = ACTIONS(72),
  },
  [1813] = {
    [sym__dedent] = ACTIONS(3149),
    [anon_sym_import] = ACTIONS(3151),
    [anon_sym_from] = ACTIONS(3151),
    [anon_sym_LPAREN] = ACTIONS(3149),
    [anon_sym_print] = ACTIONS(3151),
    [anon_sym_assert] = ACTIONS(3151),
    [anon_sym_return] = ACTIONS(3151),
    [anon_sym_del] = ACTIONS(3151),
    [anon_sym_raise] = ACTIONS(3151),
    [sym_pass_statement] = ACTIONS(3151),
    [sym_break_statement] = ACTIONS(3151),
    [sym_continue_statement] = ACTIONS(3151),
    [anon_sym_if] = ACTIONS(3151),
    [anon_sym_async] = ACTIONS(3151),
    [anon_sym_for] = ACTIONS(3151),
    [anon_sym_while] = ACTIONS(3151),
    [anon_sym_try] = ACTIONS(3151),
    [anon_sym_with] = ACTIONS(3151),
    [anon_sym_def] = ACTIONS(3151),
    [anon_sym_global] = ACTIONS(3151),
    [anon_sym_nonlocal] = ACTIONS(3151),
    [anon_sym_exec] = ACTIONS(3151),
    [anon_sym_class] = ACTIONS(3151),
    [anon_sym_AT] = ACTIONS(3149),
    [anon_sym_not] = ACTIONS(3151),
    [anon_sym_PLUS] = ACTIONS(3149),
    [anon_sym_DASH] = ACTIONS(3149),
    [anon_sym_TILDE] = ACTIONS(3149),
    [anon_sym_lambda] = ACTIONS(3151),
    [anon_sym_yield] = ACTIONS(3151),
    [anon_sym_LBRACK] = ACTIONS(3149),
    [sym_ellipsis] = ACTIONS(3149),
    [anon_sym_LBRACE] = ACTIONS(3149),
    [sym_string] = ACTIONS(3149),
    [sym_integer] = ACTIONS(3151),
    [sym_float] = ACTIONS(3151),
    [sym_identifier] = ACTIONS(3151),
    [sym_true] = ACTIONS(3151),
    [sym_false] = ACTIONS(3151),
    [sym_none] = ACTIONS(3151),
    [anon_sym_await] = ACTIONS(3151),
    [sym_comment] = ACTIONS(72),
  },
  [1814] = {
    [sym_elif_clause] = STATE(1891),
    [sym_else_clause] = STATE(1890),
    [aux_sym_if_statement_repeat1] = STATE(1891),
    [sym__dedent] = ACTIONS(3149),
    [anon_sym_import] = ACTIONS(3151),
    [anon_sym_from] = ACTIONS(3151),
    [anon_sym_LPAREN] = ACTIONS(3149),
    [anon_sym_print] = ACTIONS(3151),
    [anon_sym_assert] = ACTIONS(3151),
    [anon_sym_return] = ACTIONS(3151),
    [anon_sym_del] = ACTIONS(3151),
    [anon_sym_raise] = ACTIONS(3151),
    [sym_pass_statement] = ACTIONS(3151),
    [sym_break_statement] = ACTIONS(3151),
    [sym_continue_statement] = ACTIONS(3151),
    [anon_sym_if] = ACTIONS(3151),
    [anon_sym_elif] = ACTIONS(4097),
    [anon_sym_else] = ACTIONS(4099),
    [anon_sym_async] = ACTIONS(3151),
    [anon_sym_for] = ACTIONS(3151),
    [anon_sym_while] = ACTIONS(3151),
    [anon_sym_try] = ACTIONS(3151),
    [anon_sym_with] = ACTIONS(3151),
    [anon_sym_def] = ACTIONS(3151),
    [anon_sym_global] = ACTIONS(3151),
    [anon_sym_nonlocal] = ACTIONS(3151),
    [anon_sym_exec] = ACTIONS(3151),
    [anon_sym_class] = ACTIONS(3151),
    [anon_sym_AT] = ACTIONS(3149),
    [anon_sym_not] = ACTIONS(3151),
    [anon_sym_PLUS] = ACTIONS(3149),
    [anon_sym_DASH] = ACTIONS(3149),
    [anon_sym_TILDE] = ACTIONS(3149),
    [anon_sym_lambda] = ACTIONS(3151),
    [anon_sym_yield] = ACTIONS(3151),
    [anon_sym_LBRACK] = ACTIONS(3149),
    [sym_ellipsis] = ACTIONS(3149),
    [anon_sym_LBRACE] = ACTIONS(3149),
    [sym_string] = ACTIONS(3149),
    [sym_integer] = ACTIONS(3151),
    [sym_float] = ACTIONS(3151),
    [sym_identifier] = ACTIONS(3151),
    [sym_true] = ACTIONS(3151),
    [sym_false] = ACTIONS(3151),
    [sym_none] = ACTIONS(3151),
    [anon_sym_await] = ACTIONS(3151),
    [sym_comment] = ACTIONS(72),
  },
  [1815] = {
    [anon_sym_COLON] = ACTIONS(4289),
    [sym_comment] = ACTIONS(72),
  },
  [1816] = {
    [sym__dedent] = ACTIONS(3155),
    [anon_sym_import] = ACTIONS(3157),
    [anon_sym_from] = ACTIONS(3157),
    [anon_sym_LPAREN] = ACTIONS(3155),
    [anon_sym_print] = ACTIONS(3157),
    [anon_sym_assert] = ACTIONS(3157),
    [anon_sym_return] = ACTIONS(3157),
    [anon_sym_del] = ACTIONS(3157),
    [anon_sym_raise] = ACTIONS(3157),
    [sym_pass_statement] = ACTIONS(3157),
    [sym_break_statement] = ACTIONS(3157),
    [sym_continue_statement] = ACTIONS(3157),
    [anon_sym_if] = ACTIONS(3157),
    [anon_sym_async] = ACTIONS(3157),
    [anon_sym_for] = ACTIONS(3157),
    [anon_sym_while] = ACTIONS(3157),
    [anon_sym_try] = ACTIONS(3157),
    [anon_sym_with] = ACTIONS(3157),
    [anon_sym_def] = ACTIONS(3157),
    [anon_sym_global] = ACTIONS(3157),
    [anon_sym_nonlocal] = ACTIONS(3157),
    [anon_sym_exec] = ACTIONS(3157),
    [anon_sym_class] = ACTIONS(3157),
    [anon_sym_AT] = ACTIONS(3155),
    [anon_sym_not] = ACTIONS(3157),
    [anon_sym_PLUS] = ACTIONS(3155),
    [anon_sym_DASH] = ACTIONS(3155),
    [anon_sym_TILDE] = ACTIONS(3155),
    [anon_sym_lambda] = ACTIONS(3157),
    [anon_sym_yield] = ACTIONS(3157),
    [anon_sym_LBRACK] = ACTIONS(3155),
    [sym_ellipsis] = ACTIONS(3155),
    [anon_sym_LBRACE] = ACTIONS(3155),
    [sym_string] = ACTIONS(3155),
    [sym_integer] = ACTIONS(3157),
    [sym_float] = ACTIONS(3157),
    [sym_identifier] = ACTIONS(3157),
    [sym_true] = ACTIONS(3157),
    [sym_false] = ACTIONS(3157),
    [sym_none] = ACTIONS(3157),
    [anon_sym_await] = ACTIONS(3157),
    [sym_comment] = ACTIONS(72),
  },
  [1817] = {
    [sym__simple_statements] = STATE(1893),
    [sym_import_statement] = STATE(746),
    [sym_import_from_statement] = STATE(746),
    [sym_print_statement] = STATE(746),
    [sym_assert_statement] = STATE(746),
    [sym_expression_statement] = STATE(746),
    [sym_return_statement] = STATE(746),
    [sym_delete_statement] = STATE(746),
    [sym_raise_statement] = STATE(746),
    [sym_global_statement] = STATE(746),
    [sym_nonlocal_statement] = STATE(746),
    [sym_exec_statement] = STATE(746),
    [sym__suite] = STATE(1893),
    [sym_expression_list] = STATE(32),
    [sym__expression] = STATE(33),
    [sym__primary_expression] = STATE(34),
    [sym_not_operator] = STATE(33),
    [sym_boolean_operator] = STATE(33),
    [sym_binary_operator] = STATE(34),
    [sym_unary_operator] = STATE(34),
    [sym_comparison_operator] = STATE(33),
    [sym_lambda] = STATE(33),
    [sym_assignment] = STATE(35),
    [sym_augmented_assignment] = STATE(35),
    [sym_yield] = STATE(35),
    [sym_attribute] = STATE(34),
    [sym_subscript] = STATE(34),
    [sym_call] = STATE(34),
    [sym_list] = STATE(34),
    [sym_list_comprehension] = STATE(34),
    [sym_dictionary] = STATE(34),
    [sym_dictionary_comprehension] = STATE(34),
    [sym_set] = STATE(34),
    [sym_set_comprehension] = STATE(34),
    [sym_parenthesized_expression] = STATE(34),
    [sym_tuple] = STATE(34),
    [sym_generator_expression] = STATE(34),
    [sym_conditional_expression] = STATE(33),
    [sym_concatenated_string] = STATE(34),
    [sym_await] = STATE(33),
    [sym__indent] = ACTIONS(3791),
    [anon_sym_import] = ACTIONS(10),
    [anon_sym_from] = ACTIONS(12),
    [anon_sym_LPAREN] = ACTIONS(14),
    [anon_sym_print] = ACTIONS(16),
    [anon_sym_assert] = ACTIONS(18),
    [anon_sym_return] = ACTIONS(20),
    [anon_sym_del] = ACTIONS(22),
    [anon_sym_raise] = ACTIONS(24),
    [sym_pass_statement] = ACTIONS(1498),
    [sym_break_statement] = ACTIONS(1498),
    [sym_continue_statement] = ACTIONS(1498),
    [anon_sym_global] = ACTIONS(42),
    [anon_sym_nonlocal] = ACTIONS(44),
    [anon_sym_exec] = ACTIONS(46),
    [anon_sym_not] = ACTIONS(52),
    [anon_sym_PLUS] = ACTIONS(54),
    [anon_sym_DASH] = ACTIONS(54),
    [anon_sym_TILDE] = ACTIONS(54),
    [anon_sym_lambda] = ACTIONS(56),
    [anon_sym_yield] = ACTIONS(58),
    [anon_sym_LBRACK] = ACTIONS(60),
    [sym_ellipsis] = ACTIONS(62),
    [anon_sym_LBRACE] = ACTIONS(64),
    [sym_string] = ACTIONS(66),
    [sym_integer] = ACTIONS(68),
    [sym_float] = ACTIONS(68),
    [sym_identifier] = ACTIONS(68),
    [sym_true] = ACTIONS(68),
    [sym_false] = ACTIONS(68),
    [sym_none] = ACTIONS(68),
    [anon_sym_await] = ACTIONS(70),
    [sym_comment] = ACTIONS(72),
  },
  [1818] = {
    [sym__simple_statements] = STATE(1894),
    [sym_import_statement] = STATE(746),
    [sym_import_from_statement] = STATE(746),
    [sym_print_statement] = STATE(746),
    [sym_assert_statement] = STATE(746),
    [sym_expression_statement] = STATE(746),
    [sym_return_statement] = STATE(746),
    [sym_delete_statement] = STATE(746),
    [sym_raise_statement] = STATE(746),
    [sym_global_statement] = STATE(746),
    [sym_nonlocal_statement] = STATE(746),
    [sym_exec_statement] = STATE(746),
    [sym__suite] = STATE(1894),
    [sym_expression_list] = STATE(32),
    [sym__expression] = STATE(33),
    [sym__primary_expression] = STATE(34),
    [sym_not_operator] = STATE(33),
    [sym_boolean_operator] = STATE(33),
    [sym_binary_operator] = STATE(34),
    [sym_unary_operator] = STATE(34),
    [sym_comparison_operator] = STATE(33),
    [sym_lambda] = STATE(33),
    [sym_assignment] = STATE(35),
    [sym_augmented_assignment] = STATE(35),
    [sym_yield] = STATE(35),
    [sym_attribute] = STATE(34),
    [sym_subscript] = STATE(34),
    [sym_call] = STATE(34),
    [sym_list] = STATE(34),
    [sym_list_comprehension] = STATE(34),
    [sym_dictionary] = STATE(34),
    [sym_dictionary_comprehension] = STATE(34),
    [sym_set] = STATE(34),
    [sym_set_comprehension] = STATE(34),
    [sym_parenthesized_expression] = STATE(34),
    [sym_tuple] = STATE(34),
    [sym_generator_expression] = STATE(34),
    [sym_conditional_expression] = STATE(33),
    [sym_concatenated_string] = STATE(34),
    [sym_await] = STATE(33),
    [sym__indent] = ACTIONS(3791),
    [anon_sym_import] = ACTIONS(10),
    [anon_sym_from] = ACTIONS(12),
    [anon_sym_LPAREN] = ACTIONS(14),
    [anon_sym_print] = ACTIONS(16),
    [anon_sym_assert] = ACTIONS(18),
    [anon_sym_return] = ACTIONS(20),
    [anon_sym_del] = ACTIONS(22),
    [anon_sym_raise] = ACTIONS(24),
    [sym_pass_statement] = ACTIONS(1498),
    [sym_break_statement] = ACTIONS(1498),
    [sym_continue_statement] = ACTIONS(1498),
    [anon_sym_global] = ACTIONS(42),
    [anon_sym_nonlocal] = ACTIONS(44),
    [anon_sym_exec] = ACTIONS(46),
    [anon_sym_not] = ACTIONS(52),
    [anon_sym_PLUS] = ACTIONS(54),
    [anon_sym_DASH] = ACTIONS(54),
    [anon_sym_TILDE] = ACTIONS(54),
    [anon_sym_lambda] = ACTIONS(56),
    [anon_sym_yield] = ACTIONS(58),
    [anon_sym_LBRACK] = ACTIONS(60),
    [sym_ellipsis] = ACTIONS(62),
    [anon_sym_LBRACE] = ACTIONS(64),
    [sym_string] = ACTIONS(66),
    [sym_integer] = ACTIONS(68),
    [sym_float] = ACTIONS(68),
    [sym_identifier] = ACTIONS(68),
    [sym_true] = ACTIONS(68),
    [sym_false] = ACTIONS(68),
    [sym_none] = ACTIONS(68),
    [anon_sym_await] = ACTIONS(70),
    [sym_comment] = ACTIONS(72),
  },
  [1819] = {
    [sym__expression] = STATE(1191),
    [sym__primary_expression] = STATE(96),
    [sym_not_operator] = STATE(1191),
    [sym_boolean_operator] = STATE(1191),
    [sym_binary_operator] = STATE(96),
    [sym_unary_operator] = STATE(96),
    [sym_comparison_operator] = STATE(1191),
    [sym_lambda] = STATE(1191),
    [sym_attribute] = STATE(96),
    [sym_subscript] = STATE(96),
    [sym_call] = STATE(96),
    [sym_type] = STATE(1895),
    [sym_list] = STATE(96),
    [sym_list_comprehension] = STATE(96),
    [sym_dictionary] = STATE(96),
    [sym_dictionary_comprehension] = STATE(96),
    [sym_set] = STATE(96),
    [sym_set_comprehension] = STATE(96),
    [sym_parenthesized_expression] = STATE(96),
    [sym_tuple] = STATE(96),
    [sym_generator_expression] = STATE(96),
    [sym_conditional_expression] = STATE(1191),
    [sym_concatenated_string] = STATE(96),
    [sym_await] = STATE(1191),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_not] = ACTIONS(160),
    [anon_sym_PLUS] = ACTIONS(162),
    [anon_sym_DASH] = ACTIONS(162),
    [anon_sym_TILDE] = ACTIONS(162),
    [anon_sym_lambda] = ACTIONS(164),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(166),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(168),
    [sym_integer] = ACTIONS(170),
    [sym_float] = ACTIONS(170),
    [sym_identifier] = ACTIONS(170),
    [sym_true] = ACTIONS(170),
    [sym_false] = ACTIONS(170),
    [sym_none] = ACTIONS(170),
    [anon_sym_await] = ACTIONS(172),
    [sym_comment] = ACTIONS(72),
  },
  [1820] = {
    [sym__simple_statements] = STATE(1896),
    [sym_import_statement] = STATE(1686),
    [sym_import_from_statement] = STATE(1686),
    [sym_print_statement] = STATE(1686),
    [sym_assert_statement] = STATE(1686),
    [sym_expression_statement] = STATE(1686),
    [sym_return_statement] = STATE(1686),
    [sym_delete_statement] = STATE(1686),
    [sym_raise_statement] = STATE(1686),
    [sym_global_statement] = STATE(1686),
    [sym_nonlocal_statement] = STATE(1686),
    [sym_exec_statement] = STATE(1686),
    [sym__suite] = STATE(1896),
    [sym_expression_list] = STATE(32),
    [sym__expression] = STATE(33),
    [sym__primary_expression] = STATE(34),
    [sym_not_operator] = STATE(33),
    [sym_boolean_operator] = STATE(33),
    [sym_binary_operator] = STATE(34),
    [sym_unary_operator] = STATE(34),
    [sym_comparison_operator] = STATE(33),
    [sym_lambda] = STATE(33),
    [sym_assignment] = STATE(35),
    [sym_augmented_assignment] = STATE(35),
    [sym_yield] = STATE(35),
    [sym_attribute] = STATE(34),
    [sym_subscript] = STATE(34),
    [sym_call] = STATE(34),
    [sym_list] = STATE(34),
    [sym_list_comprehension] = STATE(34),
    [sym_dictionary] = STATE(34),
    [sym_dictionary_comprehension] = STATE(34),
    [sym_set] = STATE(34),
    [sym_set_comprehension] = STATE(34),
    [sym_parenthesized_expression] = STATE(34),
    [sym_tuple] = STATE(34),
    [sym_generator_expression] = STATE(34),
    [sym_conditional_expression] = STATE(33),
    [sym_concatenated_string] = STATE(34),
    [sym_await] = STATE(33),
    [sym__indent] = ACTIONS(3783),
    [anon_sym_import] = ACTIONS(10),
    [anon_sym_from] = ACTIONS(12),
    [anon_sym_LPAREN] = ACTIONS(14),
    [anon_sym_print] = ACTIONS(16),
    [anon_sym_assert] = ACTIONS(18),
    [anon_sym_return] = ACTIONS(20),
    [anon_sym_del] = ACTIONS(22),
    [anon_sym_raise] = ACTIONS(24),
    [sym_pass_statement] = ACTIONS(3785),
    [sym_break_statement] = ACTIONS(3785),
    [sym_continue_statement] = ACTIONS(3785),
    [anon_sym_global] = ACTIONS(42),
    [anon_sym_nonlocal] = ACTIONS(44),
    [anon_sym_exec] = ACTIONS(46),
    [anon_sym_not] = ACTIONS(52),
    [anon_sym_PLUS] = ACTIONS(54),
    [anon_sym_DASH] = ACTIONS(54),
    [anon_sym_TILDE] = ACTIONS(54),
    [anon_sym_lambda] = ACTIONS(56),
    [anon_sym_yield] = ACTIONS(58),
    [anon_sym_LBRACK] = ACTIONS(60),
    [sym_ellipsis] = ACTIONS(62),
    [anon_sym_LBRACE] = ACTIONS(64),
    [sym_string] = ACTIONS(66),
    [sym_integer] = ACTIONS(68),
    [sym_float] = ACTIONS(68),
    [sym_identifier] = ACTIONS(68),
    [sym_true] = ACTIONS(68),
    [sym_false] = ACTIONS(68),
    [sym_none] = ACTIONS(68),
    [anon_sym_await] = ACTIONS(70),
    [sym_comment] = ACTIONS(72),
  },
  [1821] = {
    [sym__dedent] = ACTIONS(2388),
    [anon_sym_import] = ACTIONS(2390),
    [anon_sym_from] = ACTIONS(2390),
    [anon_sym_LPAREN] = ACTIONS(2388),
    [anon_sym_print] = ACTIONS(2390),
    [anon_sym_assert] = ACTIONS(2390),
    [anon_sym_return] = ACTIONS(2390),
    [anon_sym_del] = ACTIONS(2390),
    [anon_sym_raise] = ACTIONS(2390),
    [sym_pass_statement] = ACTIONS(2390),
    [sym_break_statement] = ACTIONS(2390),
    [sym_continue_statement] = ACTIONS(2390),
    [anon_sym_if] = ACTIONS(2390),
    [anon_sym_else] = ACTIONS(2390),
    [anon_sym_async] = ACTIONS(2390),
    [anon_sym_for] = ACTIONS(2390),
    [anon_sym_while] = ACTIONS(2390),
    [anon_sym_try] = ACTIONS(2390),
    [anon_sym_with] = ACTIONS(2390),
    [anon_sym_def] = ACTIONS(2390),
    [anon_sym_global] = ACTIONS(2390),
    [anon_sym_nonlocal] = ACTIONS(2390),
    [anon_sym_exec] = ACTIONS(2390),
    [anon_sym_class] = ACTIONS(2390),
    [anon_sym_AT] = ACTIONS(2388),
    [anon_sym_not] = ACTIONS(2390),
    [anon_sym_PLUS] = ACTIONS(2388),
    [anon_sym_DASH] = ACTIONS(2388),
    [anon_sym_TILDE] = ACTIONS(2388),
    [anon_sym_lambda] = ACTIONS(2390),
    [anon_sym_yield] = ACTIONS(2390),
    [anon_sym_LBRACK] = ACTIONS(2388),
    [sym_ellipsis] = ACTIONS(2388),
    [anon_sym_LBRACE] = ACTIONS(2388),
    [sym_string] = ACTIONS(2388),
    [sym_integer] = ACTIONS(2390),
    [sym_float] = ACTIONS(2390),
    [sym_identifier] = ACTIONS(2390),
    [sym_true] = ACTIONS(2390),
    [sym_false] = ACTIONS(2390),
    [sym_none] = ACTIONS(2390),
    [anon_sym_await] = ACTIONS(2390),
    [sym_comment] = ACTIONS(72),
  },
  [1822] = {
    [sym__statement] = STATE(1155),
    [sym__simple_statements] = STATE(1155),
    [sym_import_statement] = STATE(746),
    [sym_import_from_statement] = STATE(746),
    [sym_print_statement] = STATE(746),
    [sym_assert_statement] = STATE(746),
    [sym_expression_statement] = STATE(746),
    [sym_return_statement] = STATE(746),
    [sym_delete_statement] = STATE(746),
    [sym_raise_statement] = STATE(746),
    [sym_if_statement] = STATE(1155),
    [sym_for_statement] = STATE(1155),
    [sym_while_statement] = STATE(1155),
    [sym_try_statement] = STATE(1155),
    [sym_with_statement] = STATE(1155),
    [sym_function_definition] = STATE(1155),
    [sym_global_statement] = STATE(746),
    [sym_nonlocal_statement] = STATE(746),
    [sym_exec_statement] = STATE(746),
    [sym_class_definition] = STATE(1155),
    [sym_decorated_definition] = STATE(1155),
    [sym_decorator] = STATE(756),
    [sym_expression_list] = STATE(32),
    [sym__expression] = STATE(33),
    [sym__primary_expression] = STATE(34),
    [sym_not_operator] = STATE(33),
    [sym_boolean_operator] = STATE(33),
    [sym_binary_operator] = STATE(34),
    [sym_unary_operator] = STATE(34),
    [sym_comparison_operator] = STATE(33),
    [sym_lambda] = STATE(33),
    [sym_assignment] = STATE(35),
    [sym_augmented_assignment] = STATE(35),
    [sym_yield] = STATE(35),
    [sym_attribute] = STATE(34),
    [sym_subscript] = STATE(34),
    [sym_call] = STATE(34),
    [sym_list] = STATE(34),
    [sym_list_comprehension] = STATE(34),
    [sym_dictionary] = STATE(34),
    [sym_dictionary_comprehension] = STATE(34),
    [sym_set] = STATE(34),
    [sym_set_comprehension] = STATE(34),
    [sym_parenthesized_expression] = STATE(34),
    [sym_tuple] = STATE(34),
    [sym_generator_expression] = STATE(34),
    [sym_conditional_expression] = STATE(33),
    [sym_concatenated_string] = STATE(34),
    [sym_await] = STATE(33),
    [aux_sym_module_repeat1] = STATE(1155),
    [aux_sym_decorated_definition_repeat1] = STATE(756),
    [sym__dedent] = ACTIONS(4291),
    [anon_sym_import] = ACTIONS(10),
    [anon_sym_from] = ACTIONS(12),
    [anon_sym_LPAREN] = ACTIONS(14),
    [anon_sym_print] = ACTIONS(16),
    [anon_sym_assert] = ACTIONS(18),
    [anon_sym_return] = ACTIONS(20),
    [anon_sym_del] = ACTIONS(22),
    [anon_sym_raise] = ACTIONS(24),
    [sym_pass_statement] = ACTIONS(1498),
    [sym_break_statement] = ACTIONS(1498),
    [sym_continue_statement] = ACTIONS(1498),
    [anon_sym_if] = ACTIONS(1500),
    [anon_sym_async] = ACTIONS(1502),
    [anon_sym_for] = ACTIONS(1504),
    [anon_sym_while] = ACTIONS(1506),
    [anon_sym_try] = ACTIONS(1508),
    [anon_sym_with] = ACTIONS(1510),
    [anon_sym_def] = ACTIONS(1512),
    [anon_sym_global] = ACTIONS(42),
    [anon_sym_nonlocal] = ACTIONS(44),
    [anon_sym_exec] = ACTIONS(46),
    [anon_sym_class] = ACTIONS(1514),
    [anon_sym_AT] = ACTIONS(50),
    [anon_sym_not] = ACTIONS(52),
    [anon_sym_PLUS] = ACTIONS(54),
    [anon_sym_DASH] = ACTIONS(54),
    [anon_sym_TILDE] = ACTIONS(54),
    [anon_sym_lambda] = ACTIONS(56),
    [anon_sym_yield] = ACTIONS(58),
    [anon_sym_LBRACK] = ACTIONS(60),
    [sym_ellipsis] = ACTIONS(62),
    [anon_sym_LBRACE] = ACTIONS(64),
    [sym_string] = ACTIONS(66),
    [sym_integer] = ACTIONS(68),
    [sym_float] = ACTIONS(68),
    [sym_identifier] = ACTIONS(68),
    [sym_true] = ACTIONS(68),
    [sym_false] = ACTIONS(68),
    [sym_none] = ACTIONS(68),
    [anon_sym_await] = ACTIONS(70),
    [sym_comment] = ACTIONS(72),
  },
  [1823] = {
    [sym__dedent] = ACTIONS(576),
    [anon_sym_import] = ACTIONS(578),
    [anon_sym_from] = ACTIONS(578),
    [anon_sym_LPAREN] = ACTIONS(576),
    [anon_sym_print] = ACTIONS(578),
    [anon_sym_assert] = ACTIONS(578),
    [anon_sym_return] = ACTIONS(578),
    [anon_sym_del] = ACTIONS(578),
    [anon_sym_raise] = ACTIONS(578),
    [sym_pass_statement] = ACTIONS(578),
    [sym_break_statement] = ACTIONS(578),
    [sym_continue_statement] = ACTIONS(578),
    [anon_sym_if] = ACTIONS(578),
    [anon_sym_else] = ACTIONS(578),
    [anon_sym_async] = ACTIONS(578),
    [anon_sym_for] = ACTIONS(578),
    [anon_sym_while] = ACTIONS(578),
    [anon_sym_try] = ACTIONS(578),
    [anon_sym_with] = ACTIONS(578),
    [anon_sym_def] = ACTIONS(578),
    [anon_sym_global] = ACTIONS(578),
    [anon_sym_nonlocal] = ACTIONS(578),
    [anon_sym_exec] = ACTIONS(578),
    [anon_sym_class] = ACTIONS(578),
    [anon_sym_AT] = ACTIONS(576),
    [anon_sym_not] = ACTIONS(578),
    [anon_sym_PLUS] = ACTIONS(576),
    [anon_sym_DASH] = ACTIONS(576),
    [anon_sym_TILDE] = ACTIONS(576),
    [anon_sym_lambda] = ACTIONS(578),
    [anon_sym_yield] = ACTIONS(578),
    [anon_sym_LBRACK] = ACTIONS(576),
    [sym_ellipsis] = ACTIONS(576),
    [anon_sym_LBRACE] = ACTIONS(576),
    [sym_string] = ACTIONS(576),
    [sym_integer] = ACTIONS(578),
    [sym_float] = ACTIONS(578),
    [sym_identifier] = ACTIONS(578),
    [sym_true] = ACTIONS(578),
    [sym_false] = ACTIONS(578),
    [sym_none] = ACTIONS(578),
    [anon_sym_await] = ACTIONS(578),
    [sym_comment] = ACTIONS(72),
  },
  [1824] = {
    [sym_import_statement] = STATE(326),
    [sym_import_from_statement] = STATE(326),
    [sym_print_statement] = STATE(326),
    [sym_assert_statement] = STATE(326),
    [sym_expression_statement] = STATE(326),
    [sym_return_statement] = STATE(326),
    [sym_delete_statement] = STATE(326),
    [sym_raise_statement] = STATE(326),
    [sym_global_statement] = STATE(326),
    [sym_nonlocal_statement] = STATE(326),
    [sym_exec_statement] = STATE(326),
    [sym_expression_list] = STATE(32),
    [sym__expression] = STATE(33),
    [sym__primary_expression] = STATE(34),
    [sym_not_operator] = STATE(33),
    [sym_boolean_operator] = STATE(33),
    [sym_binary_operator] = STATE(34),
    [sym_unary_operator] = STATE(34),
    [sym_comparison_operator] = STATE(33),
    [sym_lambda] = STATE(33),
    [sym_assignment] = STATE(35),
    [sym_augmented_assignment] = STATE(35),
    [sym_yield] = STATE(35),
    [sym_attribute] = STATE(34),
    [sym_subscript] = STATE(34),
    [sym_call] = STATE(34),
    [sym_list] = STATE(34),
    [sym_list_comprehension] = STATE(34),
    [sym_dictionary] = STATE(34),
    [sym_dictionary_comprehension] = STATE(34),
    [sym_set] = STATE(34),
    [sym_set_comprehension] = STATE(34),
    [sym_parenthesized_expression] = STATE(34),
    [sym_tuple] = STATE(34),
    [sym_generator_expression] = STATE(34),
    [sym_conditional_expression] = STATE(33),
    [sym_concatenated_string] = STATE(34),
    [sym_await] = STATE(33),
    [sym__newline] = ACTIONS(4293),
    [anon_sym_import] = ACTIONS(10),
    [anon_sym_from] = ACTIONS(12),
    [anon_sym_LPAREN] = ACTIONS(14),
    [anon_sym_print] = ACTIONS(16),
    [anon_sym_assert] = ACTIONS(18),
    [anon_sym_return] = ACTIONS(20),
    [anon_sym_del] = ACTIONS(22),
    [anon_sym_raise] = ACTIONS(24),
    [sym_pass_statement] = ACTIONS(582),
    [sym_break_statement] = ACTIONS(582),
    [sym_continue_statement] = ACTIONS(582),
    [anon_sym_global] = ACTIONS(42),
    [anon_sym_nonlocal] = ACTIONS(44),
    [anon_sym_exec] = ACTIONS(46),
    [anon_sym_not] = ACTIONS(52),
    [anon_sym_PLUS] = ACTIONS(54),
    [anon_sym_DASH] = ACTIONS(54),
    [anon_sym_TILDE] = ACTIONS(54),
    [anon_sym_lambda] = ACTIONS(56),
    [anon_sym_yield] = ACTIONS(58),
    [anon_sym_LBRACK] = ACTIONS(60),
    [sym_ellipsis] = ACTIONS(62),
    [anon_sym_LBRACE] = ACTIONS(64),
    [sym_string] = ACTIONS(66),
    [sym_integer] = ACTIONS(68),
    [sym_float] = ACTIONS(68),
    [sym_identifier] = ACTIONS(68),
    [sym_true] = ACTIONS(68),
    [sym_false] = ACTIONS(68),
    [sym_none] = ACTIONS(68),
    [anon_sym_await] = ACTIONS(70),
    [sym_comment] = ACTIONS(72),
  },
  [1825] = {
    [aux_sym__simple_statements_repeat1] = STATE(328),
    [sym__newline] = ACTIONS(4293),
    [sym_comment] = ACTIONS(72),
    [sym__semicolon] = ACTIONS(4295),
  },
  [1826] = {
    [sym__dedent] = ACTIONS(3167),
    [anon_sym_import] = ACTIONS(3169),
    [anon_sym_from] = ACTIONS(3169),
    [anon_sym_LPAREN] = ACTIONS(3167),
    [anon_sym_print] = ACTIONS(3169),
    [anon_sym_assert] = ACTIONS(3169),
    [anon_sym_return] = ACTIONS(3169),
    [anon_sym_del] = ACTIONS(3169),
    [anon_sym_raise] = ACTIONS(3169),
    [sym_pass_statement] = ACTIONS(3169),
    [sym_break_statement] = ACTIONS(3169),
    [sym_continue_statement] = ACTIONS(3169),
    [anon_sym_if] = ACTIONS(3169),
    [anon_sym_async] = ACTIONS(3169),
    [anon_sym_for] = ACTIONS(3169),
    [anon_sym_while] = ACTIONS(3169),
    [anon_sym_try] = ACTIONS(3169),
    [anon_sym_with] = ACTIONS(3169),
    [anon_sym_def] = ACTIONS(3169),
    [anon_sym_global] = ACTIONS(3169),
    [anon_sym_nonlocal] = ACTIONS(3169),
    [anon_sym_exec] = ACTIONS(3169),
    [anon_sym_class] = ACTIONS(3169),
    [anon_sym_AT] = ACTIONS(3167),
    [anon_sym_not] = ACTIONS(3169),
    [anon_sym_PLUS] = ACTIONS(3167),
    [anon_sym_DASH] = ACTIONS(3167),
    [anon_sym_TILDE] = ACTIONS(3167),
    [anon_sym_lambda] = ACTIONS(3169),
    [anon_sym_yield] = ACTIONS(3169),
    [anon_sym_LBRACK] = ACTIONS(3167),
    [sym_ellipsis] = ACTIONS(3167),
    [anon_sym_LBRACE] = ACTIONS(3167),
    [sym_string] = ACTIONS(3167),
    [sym_integer] = ACTIONS(3169),
    [sym_float] = ACTIONS(3169),
    [sym_identifier] = ACTIONS(3169),
    [sym_true] = ACTIONS(3169),
    [sym_false] = ACTIONS(3169),
    [sym_none] = ACTIONS(3169),
    [anon_sym_await] = ACTIONS(3169),
    [sym_comment] = ACTIONS(72),
  },
  [1827] = {
    [sym__simple_statements] = STATE(1902),
    [sym_import_statement] = STATE(1901),
    [sym_import_from_statement] = STATE(1901),
    [sym_print_statement] = STATE(1901),
    [sym_assert_statement] = STATE(1901),
    [sym_expression_statement] = STATE(1901),
    [sym_return_statement] = STATE(1901),
    [sym_delete_statement] = STATE(1901),
    [sym_raise_statement] = STATE(1901),
    [sym_global_statement] = STATE(1901),
    [sym_nonlocal_statement] = STATE(1901),
    [sym_exec_statement] = STATE(1901),
    [sym__suite] = STATE(1902),
    [sym_expression_list] = STATE(32),
    [sym__expression] = STATE(33),
    [sym__primary_expression] = STATE(34),
    [sym_not_operator] = STATE(33),
    [sym_boolean_operator] = STATE(33),
    [sym_binary_operator] = STATE(34),
    [sym_unary_operator] = STATE(34),
    [sym_comparison_operator] = STATE(33),
    [sym_lambda] = STATE(33),
    [sym_assignment] = STATE(35),
    [sym_augmented_assignment] = STATE(35),
    [sym_yield] = STATE(35),
    [sym_attribute] = STATE(34),
    [sym_subscript] = STATE(34),
    [sym_call] = STATE(34),
    [sym_list] = STATE(34),
    [sym_list_comprehension] = STATE(34),
    [sym_dictionary] = STATE(34),
    [sym_dictionary_comprehension] = STATE(34),
    [sym_set] = STATE(34),
    [sym_set_comprehension] = STATE(34),
    [sym_parenthesized_expression] = STATE(34),
    [sym_tuple] = STATE(34),
    [sym_generator_expression] = STATE(34),
    [sym_conditional_expression] = STATE(33),
    [sym_concatenated_string] = STATE(34),
    [sym_await] = STATE(33),
    [sym__indent] = ACTIONS(4297),
    [anon_sym_import] = ACTIONS(10),
    [anon_sym_from] = ACTIONS(12),
    [anon_sym_LPAREN] = ACTIONS(14),
    [anon_sym_print] = ACTIONS(16),
    [anon_sym_assert] = ACTIONS(18),
    [anon_sym_return] = ACTIONS(20),
    [anon_sym_del] = ACTIONS(22),
    [anon_sym_raise] = ACTIONS(24),
    [sym_pass_statement] = ACTIONS(4299),
    [sym_break_statement] = ACTIONS(4299),
    [sym_continue_statement] = ACTIONS(4299),
    [anon_sym_global] = ACTIONS(42),
    [anon_sym_nonlocal] = ACTIONS(44),
    [anon_sym_exec] = ACTIONS(46),
    [anon_sym_not] = ACTIONS(52),
    [anon_sym_PLUS] = ACTIONS(54),
    [anon_sym_DASH] = ACTIONS(54),
    [anon_sym_TILDE] = ACTIONS(54),
    [anon_sym_lambda] = ACTIONS(56),
    [anon_sym_yield] = ACTIONS(58),
    [anon_sym_LBRACK] = ACTIONS(60),
    [sym_ellipsis] = ACTIONS(62),
    [anon_sym_LBRACE] = ACTIONS(64),
    [sym_string] = ACTIONS(66),
    [sym_integer] = ACTIONS(68),
    [sym_float] = ACTIONS(68),
    [sym_identifier] = ACTIONS(68),
    [sym_true] = ACTIONS(68),
    [sym_false] = ACTIONS(68),
    [sym_none] = ACTIONS(68),
    [anon_sym_await] = ACTIONS(70),
    [sym_comment] = ACTIONS(72),
  },
  [1828] = {
    [anon_sym_COMMA] = ACTIONS(4301),
    [anon_sym_as] = ACTIONS(4301),
    [anon_sym_if] = ACTIONS(666),
    [anon_sym_COLON] = ACTIONS(4303),
    [anon_sym_and] = ACTIONS(668),
    [anon_sym_or] = ACTIONS(670),
    [sym_comment] = ACTIONS(72),
  },
  [1829] = {
    [sym__simple_statements] = STATE(1905),
    [sym_import_statement] = STATE(746),
    [sym_import_from_statement] = STATE(746),
    [sym_print_statement] = STATE(746),
    [sym_assert_statement] = STATE(746),
    [sym_expression_statement] = STATE(746),
    [sym_return_statement] = STATE(746),
    [sym_delete_statement] = STATE(746),
    [sym_raise_statement] = STATE(746),
    [sym_global_statement] = STATE(746),
    [sym_nonlocal_statement] = STATE(746),
    [sym_exec_statement] = STATE(746),
    [sym__suite] = STATE(1905),
    [sym_expression_list] = STATE(32),
    [sym__expression] = STATE(33),
    [sym__primary_expression] = STATE(34),
    [sym_not_operator] = STATE(33),
    [sym_boolean_operator] = STATE(33),
    [sym_binary_operator] = STATE(34),
    [sym_unary_operator] = STATE(34),
    [sym_comparison_operator] = STATE(33),
    [sym_lambda] = STATE(33),
    [sym_assignment] = STATE(35),
    [sym_augmented_assignment] = STATE(35),
    [sym_yield] = STATE(35),
    [sym_attribute] = STATE(34),
    [sym_subscript] = STATE(34),
    [sym_call] = STATE(34),
    [sym_list] = STATE(34),
    [sym_list_comprehension] = STATE(34),
    [sym_dictionary] = STATE(34),
    [sym_dictionary_comprehension] = STATE(34),
    [sym_set] = STATE(34),
    [sym_set_comprehension] = STATE(34),
    [sym_parenthesized_expression] = STATE(34),
    [sym_tuple] = STATE(34),
    [sym_generator_expression] = STATE(34),
    [sym_conditional_expression] = STATE(33),
    [sym_concatenated_string] = STATE(34),
    [sym_await] = STATE(33),
    [sym__indent] = ACTIONS(3791),
    [anon_sym_import] = ACTIONS(10),
    [anon_sym_from] = ACTIONS(12),
    [anon_sym_LPAREN] = ACTIONS(14),
    [anon_sym_print] = ACTIONS(16),
    [anon_sym_assert] = ACTIONS(18),
    [anon_sym_return] = ACTIONS(20),
    [anon_sym_del] = ACTIONS(22),
    [anon_sym_raise] = ACTIONS(24),
    [sym_pass_statement] = ACTIONS(1498),
    [sym_break_statement] = ACTIONS(1498),
    [sym_continue_statement] = ACTIONS(1498),
    [anon_sym_global] = ACTIONS(42),
    [anon_sym_nonlocal] = ACTIONS(44),
    [anon_sym_exec] = ACTIONS(46),
    [anon_sym_not] = ACTIONS(52),
    [anon_sym_PLUS] = ACTIONS(54),
    [anon_sym_DASH] = ACTIONS(54),
    [anon_sym_TILDE] = ACTIONS(54),
    [anon_sym_lambda] = ACTIONS(56),
    [anon_sym_yield] = ACTIONS(58),
    [anon_sym_LBRACK] = ACTIONS(60),
    [sym_ellipsis] = ACTIONS(62),
    [anon_sym_LBRACE] = ACTIONS(64),
    [sym_string] = ACTIONS(66),
    [sym_integer] = ACTIONS(68),
    [sym_float] = ACTIONS(68),
    [sym_identifier] = ACTIONS(68),
    [sym_true] = ACTIONS(68),
    [sym_false] = ACTIONS(68),
    [sym_none] = ACTIONS(68),
    [anon_sym_await] = ACTIONS(70),
    [sym_comment] = ACTIONS(72),
  },
  [1830] = {
    [anon_sym_COLON] = ACTIONS(4305),
    [sym_comment] = ACTIONS(72),
  },
  [1831] = {
    [sym_finally_clause] = STATE(1907),
    [sym__dedent] = ACTIONS(3226),
    [anon_sym_import] = ACTIONS(3228),
    [anon_sym_from] = ACTIONS(3228),
    [anon_sym_LPAREN] = ACTIONS(3226),
    [anon_sym_print] = ACTIONS(3228),
    [anon_sym_assert] = ACTIONS(3228),
    [anon_sym_return] = ACTIONS(3228),
    [anon_sym_del] = ACTIONS(3228),
    [anon_sym_raise] = ACTIONS(3228),
    [sym_pass_statement] = ACTIONS(3228),
    [sym_break_statement] = ACTIONS(3228),
    [sym_continue_statement] = ACTIONS(3228),
    [anon_sym_if] = ACTIONS(3228),
    [anon_sym_async] = ACTIONS(3228),
    [anon_sym_for] = ACTIONS(3228),
    [anon_sym_while] = ACTIONS(3228),
    [anon_sym_try] = ACTIONS(3228),
    [anon_sym_finally] = ACTIONS(4123),
    [anon_sym_with] = ACTIONS(3228),
    [anon_sym_def] = ACTIONS(3228),
    [anon_sym_global] = ACTIONS(3228),
    [anon_sym_nonlocal] = ACTIONS(3228),
    [anon_sym_exec] = ACTIONS(3228),
    [anon_sym_class] = ACTIONS(3228),
    [anon_sym_AT] = ACTIONS(3226),
    [anon_sym_not] = ACTIONS(3228),
    [anon_sym_PLUS] = ACTIONS(3226),
    [anon_sym_DASH] = ACTIONS(3226),
    [anon_sym_TILDE] = ACTIONS(3226),
    [anon_sym_lambda] = ACTIONS(3228),
    [anon_sym_yield] = ACTIONS(3228),
    [anon_sym_LBRACK] = ACTIONS(3226),
    [sym_ellipsis] = ACTIONS(3226),
    [anon_sym_LBRACE] = ACTIONS(3226),
    [sym_string] = ACTIONS(3226),
    [sym_integer] = ACTIONS(3228),
    [sym_float] = ACTIONS(3228),
    [sym_identifier] = ACTIONS(3228),
    [sym_true] = ACTIONS(3228),
    [sym_false] = ACTIONS(3228),
    [sym_none] = ACTIONS(3228),
    [anon_sym_await] = ACTIONS(3228),
    [sym_comment] = ACTIONS(72),
  },
  [1832] = {
    [sym__dedent] = ACTIONS(3226),
    [anon_sym_import] = ACTIONS(3228),
    [anon_sym_from] = ACTIONS(3228),
    [anon_sym_LPAREN] = ACTIONS(3226),
    [anon_sym_print] = ACTIONS(3228),
    [anon_sym_assert] = ACTIONS(3228),
    [anon_sym_return] = ACTIONS(3228),
    [anon_sym_del] = ACTIONS(3228),
    [anon_sym_raise] = ACTIONS(3228),
    [sym_pass_statement] = ACTIONS(3228),
    [sym_break_statement] = ACTIONS(3228),
    [sym_continue_statement] = ACTIONS(3228),
    [anon_sym_if] = ACTIONS(3228),
    [anon_sym_async] = ACTIONS(3228),
    [anon_sym_for] = ACTIONS(3228),
    [anon_sym_while] = ACTIONS(3228),
    [anon_sym_try] = ACTIONS(3228),
    [anon_sym_with] = ACTIONS(3228),
    [anon_sym_def] = ACTIONS(3228),
    [anon_sym_global] = ACTIONS(3228),
    [anon_sym_nonlocal] = ACTIONS(3228),
    [anon_sym_exec] = ACTIONS(3228),
    [anon_sym_class] = ACTIONS(3228),
    [anon_sym_AT] = ACTIONS(3226),
    [anon_sym_not] = ACTIONS(3228),
    [anon_sym_PLUS] = ACTIONS(3226),
    [anon_sym_DASH] = ACTIONS(3226),
    [anon_sym_TILDE] = ACTIONS(3226),
    [anon_sym_lambda] = ACTIONS(3228),
    [anon_sym_yield] = ACTIONS(3228),
    [anon_sym_LBRACK] = ACTIONS(3226),
    [sym_ellipsis] = ACTIONS(3226),
    [anon_sym_LBRACE] = ACTIONS(3226),
    [sym_string] = ACTIONS(3226),
    [sym_integer] = ACTIONS(3228),
    [sym_float] = ACTIONS(3228),
    [sym_identifier] = ACTIONS(3228),
    [sym_true] = ACTIONS(3228),
    [sym_false] = ACTIONS(3228),
    [sym_none] = ACTIONS(3228),
    [anon_sym_await] = ACTIONS(3228),
    [sym_comment] = ACTIONS(72),
  },
  [1833] = {
    [sym_except_clause] = STATE(1833),
    [aux_sym_try_statement_repeat1] = STATE(1833),
    [sym__dedent] = ACTIONS(3230),
    [anon_sym_import] = ACTIONS(3232),
    [anon_sym_from] = ACTIONS(3232),
    [anon_sym_LPAREN] = ACTIONS(3230),
    [anon_sym_print] = ACTIONS(3232),
    [anon_sym_assert] = ACTIONS(3232),
    [anon_sym_return] = ACTIONS(3232),
    [anon_sym_del] = ACTIONS(3232),
    [anon_sym_raise] = ACTIONS(3232),
    [sym_pass_statement] = ACTIONS(3232),
    [sym_break_statement] = ACTIONS(3232),
    [sym_continue_statement] = ACTIONS(3232),
    [anon_sym_if] = ACTIONS(3232),
    [anon_sym_else] = ACTIONS(3232),
    [anon_sym_async] = ACTIONS(3232),
    [anon_sym_for] = ACTIONS(3232),
    [anon_sym_while] = ACTIONS(3232),
    [anon_sym_try] = ACTIONS(3232),
    [anon_sym_except] = ACTIONS(4307),
    [anon_sym_finally] = ACTIONS(3232),
    [anon_sym_with] = ACTIONS(3232),
    [anon_sym_def] = ACTIONS(3232),
    [anon_sym_global] = ACTIONS(3232),
    [anon_sym_nonlocal] = ACTIONS(3232),
    [anon_sym_exec] = ACTIONS(3232),
    [anon_sym_class] = ACTIONS(3232),
    [anon_sym_AT] = ACTIONS(3230),
    [anon_sym_not] = ACTIONS(3232),
    [anon_sym_PLUS] = ACTIONS(3230),
    [anon_sym_DASH] = ACTIONS(3230),
    [anon_sym_TILDE] = ACTIONS(3230),
    [anon_sym_lambda] = ACTIONS(3232),
    [anon_sym_yield] = ACTIONS(3232),
    [anon_sym_LBRACK] = ACTIONS(3230),
    [sym_ellipsis] = ACTIONS(3230),
    [anon_sym_LBRACE] = ACTIONS(3230),
    [sym_string] = ACTIONS(3230),
    [sym_integer] = ACTIONS(3232),
    [sym_float] = ACTIONS(3232),
    [sym_identifier] = ACTIONS(3232),
    [sym_true] = ACTIONS(3232),
    [sym_false] = ACTIONS(3232),
    [sym_none] = ACTIONS(3232),
    [anon_sym_await] = ACTIONS(3232),
    [sym_comment] = ACTIONS(72),
  },
  [1834] = {
    [sym__dedent] = ACTIONS(2388),
    [anon_sym_import] = ACTIONS(2390),
    [anon_sym_from] = ACTIONS(2390),
    [anon_sym_LPAREN] = ACTIONS(2388),
    [anon_sym_print] = ACTIONS(2390),
    [anon_sym_assert] = ACTIONS(2390),
    [anon_sym_return] = ACTIONS(2390),
    [anon_sym_del] = ACTIONS(2390),
    [anon_sym_raise] = ACTIONS(2390),
    [sym_pass_statement] = ACTIONS(2390),
    [sym_break_statement] = ACTIONS(2390),
    [sym_continue_statement] = ACTIONS(2390),
    [anon_sym_if] = ACTIONS(2390),
    [anon_sym_async] = ACTIONS(2390),
    [anon_sym_for] = ACTIONS(2390),
    [anon_sym_while] = ACTIONS(2390),
    [anon_sym_try] = ACTIONS(2390),
    [anon_sym_with] = ACTIONS(2390),
    [anon_sym_def] = ACTIONS(2390),
    [anon_sym_global] = ACTIONS(2390),
    [anon_sym_nonlocal] = ACTIONS(2390),
    [anon_sym_exec] = ACTIONS(2390),
    [anon_sym_class] = ACTIONS(2390),
    [anon_sym_AT] = ACTIONS(2388),
    [anon_sym_not] = ACTIONS(2390),
    [anon_sym_PLUS] = ACTIONS(2388),
    [anon_sym_DASH] = ACTIONS(2388),
    [anon_sym_TILDE] = ACTIONS(2388),
    [anon_sym_lambda] = ACTIONS(2390),
    [anon_sym_yield] = ACTIONS(2390),
    [anon_sym_LBRACK] = ACTIONS(2388),
    [sym_ellipsis] = ACTIONS(2388),
    [anon_sym_LBRACE] = ACTIONS(2388),
    [sym_string] = ACTIONS(2388),
    [sym_integer] = ACTIONS(2390),
    [sym_float] = ACTIONS(2390),
    [sym_identifier] = ACTIONS(2390),
    [sym_true] = ACTIONS(2390),
    [sym_false] = ACTIONS(2390),
    [sym_none] = ACTIONS(2390),
    [anon_sym_await] = ACTIONS(2390),
    [sym_comment] = ACTIONS(72),
  },
  [1835] = {
    [sym__statement] = STATE(1155),
    [sym__simple_statements] = STATE(1155),
    [sym_import_statement] = STATE(746),
    [sym_import_from_statement] = STATE(746),
    [sym_print_statement] = STATE(746),
    [sym_assert_statement] = STATE(746),
    [sym_expression_statement] = STATE(746),
    [sym_return_statement] = STATE(746),
    [sym_delete_statement] = STATE(746),
    [sym_raise_statement] = STATE(746),
    [sym_if_statement] = STATE(1155),
    [sym_for_statement] = STATE(1155),
    [sym_while_statement] = STATE(1155),
    [sym_try_statement] = STATE(1155),
    [sym_with_statement] = STATE(1155),
    [sym_function_definition] = STATE(1155),
    [sym_global_statement] = STATE(746),
    [sym_nonlocal_statement] = STATE(746),
    [sym_exec_statement] = STATE(746),
    [sym_class_definition] = STATE(1155),
    [sym_decorated_definition] = STATE(1155),
    [sym_decorator] = STATE(756),
    [sym_expression_list] = STATE(32),
    [sym__expression] = STATE(33),
    [sym__primary_expression] = STATE(34),
    [sym_not_operator] = STATE(33),
    [sym_boolean_operator] = STATE(33),
    [sym_binary_operator] = STATE(34),
    [sym_unary_operator] = STATE(34),
    [sym_comparison_operator] = STATE(33),
    [sym_lambda] = STATE(33),
    [sym_assignment] = STATE(35),
    [sym_augmented_assignment] = STATE(35),
    [sym_yield] = STATE(35),
    [sym_attribute] = STATE(34),
    [sym_subscript] = STATE(34),
    [sym_call] = STATE(34),
    [sym_list] = STATE(34),
    [sym_list_comprehension] = STATE(34),
    [sym_dictionary] = STATE(34),
    [sym_dictionary_comprehension] = STATE(34),
    [sym_set] = STATE(34),
    [sym_set_comprehension] = STATE(34),
    [sym_parenthesized_expression] = STATE(34),
    [sym_tuple] = STATE(34),
    [sym_generator_expression] = STATE(34),
    [sym_conditional_expression] = STATE(33),
    [sym_concatenated_string] = STATE(34),
    [sym_await] = STATE(33),
    [aux_sym_module_repeat1] = STATE(1155),
    [aux_sym_decorated_definition_repeat1] = STATE(756),
    [sym__dedent] = ACTIONS(4310),
    [anon_sym_import] = ACTIONS(10),
    [anon_sym_from] = ACTIONS(12),
    [anon_sym_LPAREN] = ACTIONS(14),
    [anon_sym_print] = ACTIONS(16),
    [anon_sym_assert] = ACTIONS(18),
    [anon_sym_return] = ACTIONS(20),
    [anon_sym_del] = ACTIONS(22),
    [anon_sym_raise] = ACTIONS(24),
    [sym_pass_statement] = ACTIONS(1498),
    [sym_break_statement] = ACTIONS(1498),
    [sym_continue_statement] = ACTIONS(1498),
    [anon_sym_if] = ACTIONS(1500),
    [anon_sym_async] = ACTIONS(1502),
    [anon_sym_for] = ACTIONS(1504),
    [anon_sym_while] = ACTIONS(1506),
    [anon_sym_try] = ACTIONS(1508),
    [anon_sym_with] = ACTIONS(1510),
    [anon_sym_def] = ACTIONS(1512),
    [anon_sym_global] = ACTIONS(42),
    [anon_sym_nonlocal] = ACTIONS(44),
    [anon_sym_exec] = ACTIONS(46),
    [anon_sym_class] = ACTIONS(1514),
    [anon_sym_AT] = ACTIONS(50),
    [anon_sym_not] = ACTIONS(52),
    [anon_sym_PLUS] = ACTIONS(54),
    [anon_sym_DASH] = ACTIONS(54),
    [anon_sym_TILDE] = ACTIONS(54),
    [anon_sym_lambda] = ACTIONS(56),
    [anon_sym_yield] = ACTIONS(58),
    [anon_sym_LBRACK] = ACTIONS(60),
    [sym_ellipsis] = ACTIONS(62),
    [anon_sym_LBRACE] = ACTIONS(64),
    [sym_string] = ACTIONS(66),
    [sym_integer] = ACTIONS(68),
    [sym_float] = ACTIONS(68),
    [sym_identifier] = ACTIONS(68),
    [sym_true] = ACTIONS(68),
    [sym_false] = ACTIONS(68),
    [sym_none] = ACTIONS(68),
    [anon_sym_await] = ACTIONS(70),
    [sym_comment] = ACTIONS(72),
  },
  [1836] = {
    [sym__dedent] = ACTIONS(3297),
    [anon_sym_import] = ACTIONS(3299),
    [anon_sym_from] = ACTIONS(3299),
    [anon_sym_LPAREN] = ACTIONS(3297),
    [anon_sym_print] = ACTIONS(3299),
    [anon_sym_assert] = ACTIONS(3299),
    [anon_sym_return] = ACTIONS(3299),
    [anon_sym_del] = ACTIONS(3299),
    [anon_sym_raise] = ACTIONS(3299),
    [sym_pass_statement] = ACTIONS(3299),
    [sym_break_statement] = ACTIONS(3299),
    [sym_continue_statement] = ACTIONS(3299),
    [anon_sym_if] = ACTIONS(3299),
    [anon_sym_async] = ACTIONS(3299),
    [anon_sym_for] = ACTIONS(3299),
    [anon_sym_while] = ACTIONS(3299),
    [anon_sym_try] = ACTIONS(3299),
    [anon_sym_with] = ACTIONS(3299),
    [anon_sym_def] = ACTIONS(3299),
    [anon_sym_global] = ACTIONS(3299),
    [anon_sym_nonlocal] = ACTIONS(3299),
    [anon_sym_exec] = ACTIONS(3299),
    [anon_sym_class] = ACTIONS(3299),
    [anon_sym_AT] = ACTIONS(3297),
    [anon_sym_not] = ACTIONS(3299),
    [anon_sym_PLUS] = ACTIONS(3297),
    [anon_sym_DASH] = ACTIONS(3297),
    [anon_sym_TILDE] = ACTIONS(3297),
    [anon_sym_lambda] = ACTIONS(3299),
    [anon_sym_yield] = ACTIONS(3299),
    [anon_sym_LBRACK] = ACTIONS(3297),
    [sym_ellipsis] = ACTIONS(3297),
    [anon_sym_LBRACE] = ACTIONS(3297),
    [sym_string] = ACTIONS(3297),
    [sym_integer] = ACTIONS(3299),
    [sym_float] = ACTIONS(3299),
    [sym_identifier] = ACTIONS(3299),
    [sym_true] = ACTIONS(3299),
    [sym_false] = ACTIONS(3299),
    [sym_none] = ACTIONS(3299),
    [anon_sym_await] = ACTIONS(3299),
    [sym_comment] = ACTIONS(72),
  },
  [1837] = {
    [anon_sym_COLON] = ACTIONS(4312),
    [sym_comment] = ACTIONS(72),
  },
  [1838] = {
    [sym__dedent] = ACTIONS(3305),
    [anon_sym_import] = ACTIONS(3307),
    [anon_sym_from] = ACTIONS(3307),
    [anon_sym_LPAREN] = ACTIONS(3305),
    [anon_sym_print] = ACTIONS(3307),
    [anon_sym_assert] = ACTIONS(3307),
    [anon_sym_return] = ACTIONS(3307),
    [anon_sym_del] = ACTIONS(3307),
    [anon_sym_raise] = ACTIONS(3307),
    [sym_pass_statement] = ACTIONS(3307),
    [sym_break_statement] = ACTIONS(3307),
    [sym_continue_statement] = ACTIONS(3307),
    [anon_sym_if] = ACTIONS(3307),
    [anon_sym_async] = ACTIONS(3307),
    [anon_sym_for] = ACTIONS(3307),
    [anon_sym_while] = ACTIONS(3307),
    [anon_sym_try] = ACTIONS(3307),
    [anon_sym_with] = ACTIONS(3307),
    [anon_sym_def] = ACTIONS(3307),
    [anon_sym_global] = ACTIONS(3307),
    [anon_sym_nonlocal] = ACTIONS(3307),
    [anon_sym_exec] = ACTIONS(3307),
    [anon_sym_class] = ACTIONS(3307),
    [anon_sym_AT] = ACTIONS(3305),
    [anon_sym_not] = ACTIONS(3307),
    [anon_sym_PLUS] = ACTIONS(3305),
    [anon_sym_DASH] = ACTIONS(3305),
    [anon_sym_TILDE] = ACTIONS(3305),
    [anon_sym_lambda] = ACTIONS(3307),
    [anon_sym_yield] = ACTIONS(3307),
    [anon_sym_LBRACK] = ACTIONS(3305),
    [sym_ellipsis] = ACTIONS(3305),
    [anon_sym_LBRACE] = ACTIONS(3305),
    [sym_string] = ACTIONS(3305),
    [sym_integer] = ACTIONS(3307),
    [sym_float] = ACTIONS(3307),
    [sym_identifier] = ACTIONS(3307),
    [sym_true] = ACTIONS(3307),
    [sym_false] = ACTIONS(3307),
    [sym_none] = ACTIONS(3307),
    [anon_sym_await] = ACTIONS(3307),
    [sym_comment] = ACTIONS(72),
  },
  [1839] = {
    [sym__simple_statements] = STATE(1910),
    [sym_import_statement] = STATE(364),
    [sym_import_from_statement] = STATE(364),
    [sym_print_statement] = STATE(364),
    [sym_assert_statement] = STATE(364),
    [sym_expression_statement] = STATE(364),
    [sym_return_statement] = STATE(364),
    [sym_delete_statement] = STATE(364),
    [sym_raise_statement] = STATE(364),
    [sym_global_statement] = STATE(364),
    [sym_nonlocal_statement] = STATE(364),
    [sym_exec_statement] = STATE(364),
    [sym__suite] = STATE(1910),
    [sym_expression_list] = STATE(32),
    [sym__expression] = STATE(33),
    [sym__primary_expression] = STATE(34),
    [sym_not_operator] = STATE(33),
    [sym_boolean_operator] = STATE(33),
    [sym_binary_operator] = STATE(34),
    [sym_unary_operator] = STATE(34),
    [sym_comparison_operator] = STATE(33),
    [sym_lambda] = STATE(33),
    [sym_assignment] = STATE(35),
    [sym_augmented_assignment] = STATE(35),
    [sym_yield] = STATE(35),
    [sym_attribute] = STATE(34),
    [sym_subscript] = STATE(34),
    [sym_call] = STATE(34),
    [sym_list] = STATE(34),
    [sym_list_comprehension] = STATE(34),
    [sym_dictionary] = STATE(34),
    [sym_dictionary_comprehension] = STATE(34),
    [sym_set] = STATE(34),
    [sym_set_comprehension] = STATE(34),
    [sym_parenthesized_expression] = STATE(34),
    [sym_tuple] = STATE(34),
    [sym_generator_expression] = STATE(34),
    [sym_conditional_expression] = STATE(33),
    [sym_concatenated_string] = STATE(34),
    [sym_await] = STATE(33),
    [sym__indent] = ACTIONS(650),
    [anon_sym_import] = ACTIONS(10),
    [anon_sym_from] = ACTIONS(12),
    [anon_sym_LPAREN] = ACTIONS(14),
    [anon_sym_print] = ACTIONS(16),
    [anon_sym_assert] = ACTIONS(18),
    [anon_sym_return] = ACTIONS(20),
    [anon_sym_del] = ACTIONS(22),
    [anon_sym_raise] = ACTIONS(24),
    [sym_pass_statement] = ACTIONS(652),
    [sym_break_statement] = ACTIONS(652),
    [sym_continue_statement] = ACTIONS(652),
    [anon_sym_global] = ACTIONS(42),
    [anon_sym_nonlocal] = ACTIONS(44),
    [anon_sym_exec] = ACTIONS(46),
    [anon_sym_not] = ACTIONS(52),
    [anon_sym_PLUS] = ACTIONS(54),
    [anon_sym_DASH] = ACTIONS(54),
    [anon_sym_TILDE] = ACTIONS(54),
    [anon_sym_lambda] = ACTIONS(56),
    [anon_sym_yield] = ACTIONS(58),
    [anon_sym_LBRACK] = ACTIONS(60),
    [sym_ellipsis] = ACTIONS(62),
    [anon_sym_LBRACE] = ACTIONS(64),
    [sym_string] = ACTIONS(66),
    [sym_integer] = ACTIONS(68),
    [sym_float] = ACTIONS(68),
    [sym_identifier] = ACTIONS(68),
    [sym_true] = ACTIONS(68),
    [sym_false] = ACTIONS(68),
    [sym_none] = ACTIONS(68),
    [anon_sym_await] = ACTIONS(70),
    [sym_comment] = ACTIONS(72),
  },
  [1840] = {
    [ts_builtin_sym_end] = ACTIONS(2388),
    [anon_sym_import] = ACTIONS(2390),
    [anon_sym_from] = ACTIONS(2390),
    [anon_sym_LPAREN] = ACTIONS(2388),
    [anon_sym_print] = ACTIONS(2390),
    [anon_sym_assert] = ACTIONS(2390),
    [anon_sym_return] = ACTIONS(2390),
    [anon_sym_del] = ACTIONS(2390),
    [anon_sym_raise] = ACTIONS(2390),
    [sym_pass_statement] = ACTIONS(2390),
    [sym_break_statement] = ACTIONS(2390),
    [sym_continue_statement] = ACTIONS(2390),
    [anon_sym_if] = ACTIONS(2390),
    [anon_sym_async] = ACTIONS(2390),
    [anon_sym_for] = ACTIONS(2390),
    [anon_sym_while] = ACTIONS(2390),
    [anon_sym_try] = ACTIONS(2390),
    [anon_sym_finally] = ACTIONS(2390),
    [anon_sym_with] = ACTIONS(2390),
    [anon_sym_def] = ACTIONS(2390),
    [anon_sym_global] = ACTIONS(2390),
    [anon_sym_nonlocal] = ACTIONS(2390),
    [anon_sym_exec] = ACTIONS(2390),
    [anon_sym_class] = ACTIONS(2390),
    [anon_sym_AT] = ACTIONS(2388),
    [anon_sym_not] = ACTIONS(2390),
    [anon_sym_PLUS] = ACTIONS(2388),
    [anon_sym_DASH] = ACTIONS(2388),
    [anon_sym_TILDE] = ACTIONS(2388),
    [anon_sym_lambda] = ACTIONS(2390),
    [anon_sym_yield] = ACTIONS(2390),
    [anon_sym_LBRACK] = ACTIONS(2388),
    [sym_ellipsis] = ACTIONS(2388),
    [anon_sym_LBRACE] = ACTIONS(2388),
    [sym_string] = ACTIONS(2388),
    [sym_integer] = ACTIONS(2390),
    [sym_float] = ACTIONS(2390),
    [sym_identifier] = ACTIONS(2390),
    [sym_true] = ACTIONS(2390),
    [sym_false] = ACTIONS(2390),
    [sym_none] = ACTIONS(2390),
    [anon_sym_await] = ACTIONS(2390),
    [sym_comment] = ACTIONS(72),
  },
  [1841] = {
    [sym__statement] = STATE(1155),
    [sym__simple_statements] = STATE(1155),
    [sym_import_statement] = STATE(746),
    [sym_import_from_statement] = STATE(746),
    [sym_print_statement] = STATE(746),
    [sym_assert_statement] = STATE(746),
    [sym_expression_statement] = STATE(746),
    [sym_return_statement] = STATE(746),
    [sym_delete_statement] = STATE(746),
    [sym_raise_statement] = STATE(746),
    [sym_if_statement] = STATE(1155),
    [sym_for_statement] = STATE(1155),
    [sym_while_statement] = STATE(1155),
    [sym_try_statement] = STATE(1155),
    [sym_with_statement] = STATE(1155),
    [sym_function_definition] = STATE(1155),
    [sym_global_statement] = STATE(746),
    [sym_nonlocal_statement] = STATE(746),
    [sym_exec_statement] = STATE(746),
    [sym_class_definition] = STATE(1155),
    [sym_decorated_definition] = STATE(1155),
    [sym_decorator] = STATE(756),
    [sym_expression_list] = STATE(32),
    [sym__expression] = STATE(33),
    [sym__primary_expression] = STATE(34),
    [sym_not_operator] = STATE(33),
    [sym_boolean_operator] = STATE(33),
    [sym_binary_operator] = STATE(34),
    [sym_unary_operator] = STATE(34),
    [sym_comparison_operator] = STATE(33),
    [sym_lambda] = STATE(33),
    [sym_assignment] = STATE(35),
    [sym_augmented_assignment] = STATE(35),
    [sym_yield] = STATE(35),
    [sym_attribute] = STATE(34),
    [sym_subscript] = STATE(34),
    [sym_call] = STATE(34),
    [sym_list] = STATE(34),
    [sym_list_comprehension] = STATE(34),
    [sym_dictionary] = STATE(34),
    [sym_dictionary_comprehension] = STATE(34),
    [sym_set] = STATE(34),
    [sym_set_comprehension] = STATE(34),
    [sym_parenthesized_expression] = STATE(34),
    [sym_tuple] = STATE(34),
    [sym_generator_expression] = STATE(34),
    [sym_conditional_expression] = STATE(33),
    [sym_concatenated_string] = STATE(34),
    [sym_await] = STATE(33),
    [aux_sym_module_repeat1] = STATE(1155),
    [aux_sym_decorated_definition_repeat1] = STATE(756),
    [sym__dedent] = ACTIONS(4314),
    [anon_sym_import] = ACTIONS(10),
    [anon_sym_from] = ACTIONS(12),
    [anon_sym_LPAREN] = ACTIONS(14),
    [anon_sym_print] = ACTIONS(16),
    [anon_sym_assert] = ACTIONS(18),
    [anon_sym_return] = ACTIONS(20),
    [anon_sym_del] = ACTIONS(22),
    [anon_sym_raise] = ACTIONS(24),
    [sym_pass_statement] = ACTIONS(1498),
    [sym_break_statement] = ACTIONS(1498),
    [sym_continue_statement] = ACTIONS(1498),
    [anon_sym_if] = ACTIONS(1500),
    [anon_sym_async] = ACTIONS(1502),
    [anon_sym_for] = ACTIONS(1504),
    [anon_sym_while] = ACTIONS(1506),
    [anon_sym_try] = ACTIONS(1508),
    [anon_sym_with] = ACTIONS(1510),
    [anon_sym_def] = ACTIONS(1512),
    [anon_sym_global] = ACTIONS(42),
    [anon_sym_nonlocal] = ACTIONS(44),
    [anon_sym_exec] = ACTIONS(46),
    [anon_sym_class] = ACTIONS(1514),
    [anon_sym_AT] = ACTIONS(50),
    [anon_sym_not] = ACTIONS(52),
    [anon_sym_PLUS] = ACTIONS(54),
    [anon_sym_DASH] = ACTIONS(54),
    [anon_sym_TILDE] = ACTIONS(54),
    [anon_sym_lambda] = ACTIONS(56),
    [anon_sym_yield] = ACTIONS(58),
    [anon_sym_LBRACK] = ACTIONS(60),
    [sym_ellipsis] = ACTIONS(62),
    [anon_sym_LBRACE] = ACTIONS(64),
    [sym_string] = ACTIONS(66),
    [sym_integer] = ACTIONS(68),
    [sym_float] = ACTIONS(68),
    [sym_identifier] = ACTIONS(68),
    [sym_true] = ACTIONS(68),
    [sym_false] = ACTIONS(68),
    [sym_none] = ACTIONS(68),
    [anon_sym_await] = ACTIONS(70),
    [sym_comment] = ACTIONS(72),
  },
  [1842] = {
    [ts_builtin_sym_end] = ACTIONS(576),
    [anon_sym_import] = ACTIONS(578),
    [anon_sym_from] = ACTIONS(578),
    [anon_sym_LPAREN] = ACTIONS(576),
    [anon_sym_print] = ACTIONS(578),
    [anon_sym_assert] = ACTIONS(578),
    [anon_sym_return] = ACTIONS(578),
    [anon_sym_del] = ACTIONS(578),
    [anon_sym_raise] = ACTIONS(578),
    [sym_pass_statement] = ACTIONS(578),
    [sym_break_statement] = ACTIONS(578),
    [sym_continue_statement] = ACTIONS(578),
    [anon_sym_if] = ACTIONS(578),
    [anon_sym_async] = ACTIONS(578),
    [anon_sym_for] = ACTIONS(578),
    [anon_sym_while] = ACTIONS(578),
    [anon_sym_try] = ACTIONS(578),
    [anon_sym_finally] = ACTIONS(578),
    [anon_sym_with] = ACTIONS(578),
    [anon_sym_def] = ACTIONS(578),
    [anon_sym_global] = ACTIONS(578),
    [anon_sym_nonlocal] = ACTIONS(578),
    [anon_sym_exec] = ACTIONS(578),
    [anon_sym_class] = ACTIONS(578),
    [anon_sym_AT] = ACTIONS(576),
    [anon_sym_not] = ACTIONS(578),
    [anon_sym_PLUS] = ACTIONS(576),
    [anon_sym_DASH] = ACTIONS(576),
    [anon_sym_TILDE] = ACTIONS(576),
    [anon_sym_lambda] = ACTIONS(578),
    [anon_sym_yield] = ACTIONS(578),
    [anon_sym_LBRACK] = ACTIONS(576),
    [sym_ellipsis] = ACTIONS(576),
    [anon_sym_LBRACE] = ACTIONS(576),
    [sym_string] = ACTIONS(576),
    [sym_integer] = ACTIONS(578),
    [sym_float] = ACTIONS(578),
    [sym_identifier] = ACTIONS(578),
    [sym_true] = ACTIONS(578),
    [sym_false] = ACTIONS(578),
    [sym_none] = ACTIONS(578),
    [anon_sym_await] = ACTIONS(578),
    [sym_comment] = ACTIONS(72),
  },
  [1843] = {
    [sym_import_statement] = STATE(326),
    [sym_import_from_statement] = STATE(326),
    [sym_print_statement] = STATE(326),
    [sym_assert_statement] = STATE(326),
    [sym_expression_statement] = STATE(326),
    [sym_return_statement] = STATE(326),
    [sym_delete_statement] = STATE(326),
    [sym_raise_statement] = STATE(326),
    [sym_global_statement] = STATE(326),
    [sym_nonlocal_statement] = STATE(326),
    [sym_exec_statement] = STATE(326),
    [sym_expression_list] = STATE(32),
    [sym__expression] = STATE(33),
    [sym__primary_expression] = STATE(34),
    [sym_not_operator] = STATE(33),
    [sym_boolean_operator] = STATE(33),
    [sym_binary_operator] = STATE(34),
    [sym_unary_operator] = STATE(34),
    [sym_comparison_operator] = STATE(33),
    [sym_lambda] = STATE(33),
    [sym_assignment] = STATE(35),
    [sym_augmented_assignment] = STATE(35),
    [sym_yield] = STATE(35),
    [sym_attribute] = STATE(34),
    [sym_subscript] = STATE(34),
    [sym_call] = STATE(34),
    [sym_list] = STATE(34),
    [sym_list_comprehension] = STATE(34),
    [sym_dictionary] = STATE(34),
    [sym_dictionary_comprehension] = STATE(34),
    [sym_set] = STATE(34),
    [sym_set_comprehension] = STATE(34),
    [sym_parenthesized_expression] = STATE(34),
    [sym_tuple] = STATE(34),
    [sym_generator_expression] = STATE(34),
    [sym_conditional_expression] = STATE(33),
    [sym_concatenated_string] = STATE(34),
    [sym_await] = STATE(33),
    [sym__newline] = ACTIONS(4316),
    [anon_sym_import] = ACTIONS(10),
    [anon_sym_from] = ACTIONS(12),
    [anon_sym_LPAREN] = ACTIONS(14),
    [anon_sym_print] = ACTIONS(16),
    [anon_sym_assert] = ACTIONS(18),
    [anon_sym_return] = ACTIONS(20),
    [anon_sym_del] = ACTIONS(22),
    [anon_sym_raise] = ACTIONS(24),
    [sym_pass_statement] = ACTIONS(582),
    [sym_break_statement] = ACTIONS(582),
    [sym_continue_statement] = ACTIONS(582),
    [anon_sym_global] = ACTIONS(42),
    [anon_sym_nonlocal] = ACTIONS(44),
    [anon_sym_exec] = ACTIONS(46),
    [anon_sym_not] = ACTIONS(52),
    [anon_sym_PLUS] = ACTIONS(54),
    [anon_sym_DASH] = ACTIONS(54),
    [anon_sym_TILDE] = ACTIONS(54),
    [anon_sym_lambda] = ACTIONS(56),
    [anon_sym_yield] = ACTIONS(58),
    [anon_sym_LBRACK] = ACTIONS(60),
    [sym_ellipsis] = ACTIONS(62),
    [anon_sym_LBRACE] = ACTIONS(64),
    [sym_string] = ACTIONS(66),
    [sym_integer] = ACTIONS(68),
    [sym_float] = ACTIONS(68),
    [sym_identifier] = ACTIONS(68),
    [sym_true] = ACTIONS(68),
    [sym_false] = ACTIONS(68),
    [sym_none] = ACTIONS(68),
    [anon_sym_await] = ACTIONS(70),
    [sym_comment] = ACTIONS(72),
  },
  [1844] = {
    [aux_sym__simple_statements_repeat1] = STATE(328),
    [sym__newline] = ACTIONS(4316),
    [sym_comment] = ACTIONS(72),
    [sym__semicolon] = ACTIONS(4318),
  },
  [1845] = {
    [anon_sym_RPAREN] = ACTIONS(2642),
    [anon_sym_COMMA] = ACTIONS(2642),
    [anon_sym_if] = ACTIONS(3243),
    [anon_sym_COLON] = ACTIONS(2642),
    [anon_sym_and] = ACTIONS(3245),
    [anon_sym_or] = ACTIONS(3247),
    [sym_comment] = ACTIONS(72),
  },
  [1846] = {
    [sym__expression] = STATE(1914),
    [sym__primary_expression] = STATE(1179),
    [sym_not_operator] = STATE(1914),
    [sym_boolean_operator] = STATE(1914),
    [sym_binary_operator] = STATE(1179),
    [sym_unary_operator] = STATE(1179),
    [sym_comparison_operator] = STATE(1914),
    [sym_lambda] = STATE(1914),
    [sym_attribute] = STATE(1179),
    [sym_subscript] = STATE(1179),
    [sym_call] = STATE(1179),
    [sym_list] = STATE(1179),
    [sym_list_comprehension] = STATE(1179),
    [sym_dictionary] = STATE(1179),
    [sym_dictionary_comprehension] = STATE(1179),
    [sym_set] = STATE(1179),
    [sym_set_comprehension] = STATE(1179),
    [sym_parenthesized_expression] = STATE(1179),
    [sym_tuple] = STATE(1179),
    [sym_generator_expression] = STATE(1179),
    [sym_conditional_expression] = STATE(1914),
    [sym_concatenated_string] = STATE(1179),
    [sym_await] = STATE(1914),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_not] = ACTIONS(2472),
    [anon_sym_PLUS] = ACTIONS(2474),
    [anon_sym_DASH] = ACTIONS(2474),
    [anon_sym_TILDE] = ACTIONS(2474),
    [anon_sym_lambda] = ACTIONS(2476),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(2478),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(2480),
    [sym_integer] = ACTIONS(2482),
    [sym_float] = ACTIONS(2482),
    [sym_identifier] = ACTIONS(2482),
    [sym_true] = ACTIONS(2482),
    [sym_false] = ACTIONS(2482),
    [sym_none] = ACTIONS(2482),
    [anon_sym_await] = ACTIONS(2484),
    [sym_comment] = ACTIONS(72),
  },
  [1847] = {
    [sym_argument_list] = STATE(251),
    [sym_generator_expression] = STATE(251),
    [anon_sym_DOT] = ACTIONS(422),
    [anon_sym_LPAREN] = ACTIONS(424),
    [anon_sym_RPAREN] = ACTIONS(2953),
    [anon_sym_COMMA] = ACTIONS(2953),
    [anon_sym_STAR] = ACTIONS(3249),
    [anon_sym_GT_GT] = ACTIONS(3251),
    [anon_sym_if] = ACTIONS(2953),
    [anon_sym_COLON] = ACTIONS(2953),
    [anon_sym_in] = ACTIONS(2953),
    [anon_sym_AT] = ACTIONS(3255),
    [anon_sym_not] = ACTIONS(2953),
    [anon_sym_and] = ACTIONS(2953),
    [anon_sym_or] = ACTIONS(2953),
    [anon_sym_PLUS] = ACTIONS(3259),
    [anon_sym_DASH] = ACTIONS(3259),
    [anon_sym_SLASH] = ACTIONS(3249),
    [anon_sym_PERCENT] = ACTIONS(3255),
    [anon_sym_SLASH_SLASH] = ACTIONS(3255),
    [anon_sym_STAR_STAR] = ACTIONS(3261),
    [anon_sym_PIPE] = ACTIONS(3263),
    [anon_sym_AMP] = ACTIONS(3265),
    [anon_sym_CARET] = ACTIONS(3267),
    [anon_sym_LT_LT] = ACTIONS(3251),
    [anon_sym_LT] = ACTIONS(2955),
    [anon_sym_LT_EQ] = ACTIONS(2953),
    [anon_sym_EQ_EQ] = ACTIONS(2953),
    [anon_sym_BANG_EQ] = ACTIONS(2953),
    [anon_sym_GT_EQ] = ACTIONS(2953),
    [anon_sym_GT] = ACTIONS(2955),
    [anon_sym_LT_GT] = ACTIONS(2953),
    [anon_sym_is] = ACTIONS(2953),
    [anon_sym_LBRACK] = ACTIONS(450),
    [sym_comment] = ACTIONS(72),
  },
  [1848] = {
    [anon_sym_RPAREN] = ACTIONS(3913),
    [anon_sym_COMMA] = ACTIONS(3913),
    [anon_sym_if] = ACTIONS(1147),
    [anon_sym_and] = ACTIONS(1149),
    [anon_sym_or] = ACTIONS(1151),
    [sym_comment] = ACTIONS(72),
  },
  [1849] = {
    [anon_sym_RPAREN] = ACTIONS(1644),
    [anon_sym_COMMA] = ACTIONS(1644),
    [anon_sym_if] = ACTIONS(3860),
    [anon_sym_EQ] = ACTIONS(1644),
    [anon_sym_and] = ACTIONS(3862),
    [anon_sym_or] = ACTIONS(3864),
    [sym_comment] = ACTIONS(72),
  },
  [1850] = {
    [sym__expression] = STATE(1915),
    [sym__primary_expression] = STATE(1516),
    [sym_not_operator] = STATE(1915),
    [sym_boolean_operator] = STATE(1915),
    [sym_binary_operator] = STATE(1516),
    [sym_unary_operator] = STATE(1516),
    [sym_comparison_operator] = STATE(1915),
    [sym_lambda] = STATE(1915),
    [sym_attribute] = STATE(1516),
    [sym_subscript] = STATE(1516),
    [sym_call] = STATE(1516),
    [sym_list] = STATE(1516),
    [sym_list_comprehension] = STATE(1516),
    [sym_dictionary] = STATE(1516),
    [sym_dictionary_comprehension] = STATE(1516),
    [sym_set] = STATE(1516),
    [sym_set_comprehension] = STATE(1516),
    [sym_parenthesized_expression] = STATE(1516),
    [sym_tuple] = STATE(1516),
    [sym_generator_expression] = STATE(1516),
    [sym_conditional_expression] = STATE(1915),
    [sym_concatenated_string] = STATE(1516),
    [sym_await] = STATE(1915),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_not] = ACTIONS(3279),
    [anon_sym_PLUS] = ACTIONS(3281),
    [anon_sym_DASH] = ACTIONS(3281),
    [anon_sym_TILDE] = ACTIONS(3281),
    [anon_sym_lambda] = ACTIONS(3283),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(3285),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(3287),
    [sym_integer] = ACTIONS(3289),
    [sym_float] = ACTIONS(3289),
    [sym_identifier] = ACTIONS(3289),
    [sym_true] = ACTIONS(3289),
    [sym_false] = ACTIONS(3289),
    [sym_none] = ACTIONS(3289),
    [anon_sym_await] = ACTIONS(3291),
    [sym_comment] = ACTIONS(72),
  },
  [1851] = {
    [aux_sym_concatenated_string_repeat1] = STATE(1851),
    [anon_sym_DOT] = ACTIONS(1862),
    [anon_sym_LPAREN] = ACTIONS(1862),
    [anon_sym_RPAREN] = ACTIONS(1862),
    [anon_sym_COMMA] = ACTIONS(1862),
    [anon_sym_STAR] = ACTIONS(1864),
    [anon_sym_GT_GT] = ACTIONS(1862),
    [anon_sym_if] = ACTIONS(1862),
    [anon_sym_in] = ACTIONS(1862),
    [anon_sym_EQ] = ACTIONS(1864),
    [anon_sym_AT] = ACTIONS(1862),
    [anon_sym_not] = ACTIONS(1862),
    [anon_sym_and] = ACTIONS(1862),
    [anon_sym_or] = ACTIONS(1862),
    [anon_sym_PLUS] = ACTIONS(1862),
    [anon_sym_DASH] = ACTIONS(1862),
    [anon_sym_SLASH] = ACTIONS(1864),
    [anon_sym_PERCENT] = ACTIONS(1862),
    [anon_sym_SLASH_SLASH] = ACTIONS(1862),
    [anon_sym_STAR_STAR] = ACTIONS(1862),
    [anon_sym_PIPE] = ACTIONS(1862),
    [anon_sym_AMP] = ACTIONS(1862),
    [anon_sym_CARET] = ACTIONS(1862),
    [anon_sym_LT_LT] = ACTIONS(1862),
    [anon_sym_LT] = ACTIONS(1864),
    [anon_sym_LT_EQ] = ACTIONS(1862),
    [anon_sym_EQ_EQ] = ACTIONS(1862),
    [anon_sym_BANG_EQ] = ACTIONS(1862),
    [anon_sym_GT_EQ] = ACTIONS(1862),
    [anon_sym_GT] = ACTIONS(1864),
    [anon_sym_LT_GT] = ACTIONS(1862),
    [anon_sym_is] = ACTIONS(1862),
    [anon_sym_LBRACK] = ACTIONS(1862),
    [sym_string] = ACTIONS(4320),
    [sym_comment] = ACTIONS(72),
  },
  [1852] = {
    [anon_sym_if] = ACTIONS(1921),
    [anon_sym_else] = ACTIONS(4323),
    [anon_sym_and] = ACTIONS(1925),
    [anon_sym_or] = ACTIONS(1927),
    [sym_comment] = ACTIONS(72),
  },
  [1853] = {
    [anon_sym_RPAREN] = ACTIONS(1953),
    [anon_sym_COMMA] = ACTIONS(1953),
    [anon_sym_if] = ACTIONS(1953),
    [anon_sym_EQ] = ACTIONS(1953),
    [anon_sym_and] = ACTIONS(3862),
    [anon_sym_or] = ACTIONS(1953),
    [sym_comment] = ACTIONS(72),
  },
  [1854] = {
    [sym_argument_list] = STATE(251),
    [sym_generator_expression] = STATE(251),
    [anon_sym_DOT] = ACTIONS(1980),
    [anon_sym_LPAREN] = ACTIONS(424),
    [anon_sym_RPAREN] = ACTIONS(1980),
    [anon_sym_COMMA] = ACTIONS(1980),
    [anon_sym_STAR] = ACTIONS(1982),
    [anon_sym_GT_GT] = ACTIONS(1980),
    [anon_sym_if] = ACTIONS(1980),
    [anon_sym_in] = ACTIONS(1980),
    [anon_sym_EQ] = ACTIONS(1982),
    [anon_sym_AT] = ACTIONS(1980),
    [anon_sym_not] = ACTIONS(1980),
    [anon_sym_and] = ACTIONS(1980),
    [anon_sym_or] = ACTIONS(1980),
    [anon_sym_PLUS] = ACTIONS(1980),
    [anon_sym_DASH] = ACTIONS(1980),
    [anon_sym_SLASH] = ACTIONS(1982),
    [anon_sym_PERCENT] = ACTIONS(1980),
    [anon_sym_SLASH_SLASH] = ACTIONS(1980),
    [anon_sym_STAR_STAR] = ACTIONS(3878),
    [anon_sym_PIPE] = ACTIONS(1980),
    [anon_sym_AMP] = ACTIONS(1980),
    [anon_sym_CARET] = ACTIONS(1980),
    [anon_sym_LT_LT] = ACTIONS(1980),
    [anon_sym_LT] = ACTIONS(1982),
    [anon_sym_LT_EQ] = ACTIONS(1980),
    [anon_sym_EQ_EQ] = ACTIONS(1980),
    [anon_sym_BANG_EQ] = ACTIONS(1980),
    [anon_sym_GT_EQ] = ACTIONS(1980),
    [anon_sym_GT] = ACTIONS(1982),
    [anon_sym_LT_GT] = ACTIONS(1980),
    [anon_sym_is] = ACTIONS(1980),
    [anon_sym_LBRACK] = ACTIONS(1980),
    [sym_comment] = ACTIONS(72),
  },
  [1855] = {
    [sym_argument_list] = STATE(251),
    [sym_generator_expression] = STATE(251),
    [anon_sym_DOT] = ACTIONS(1980),
    [anon_sym_LPAREN] = ACTIONS(424),
    [anon_sym_RPAREN] = ACTIONS(1980),
    [anon_sym_COMMA] = ACTIONS(1980),
    [anon_sym_STAR] = ACTIONS(3866),
    [anon_sym_GT_GT] = ACTIONS(1980),
    [anon_sym_if] = ACTIONS(1980),
    [anon_sym_in] = ACTIONS(1980),
    [anon_sym_EQ] = ACTIONS(1982),
    [anon_sym_AT] = ACTIONS(3872),
    [anon_sym_not] = ACTIONS(1980),
    [anon_sym_and] = ACTIONS(1980),
    [anon_sym_or] = ACTIONS(1980),
    [anon_sym_PLUS] = ACTIONS(3876),
    [anon_sym_DASH] = ACTIONS(3876),
    [anon_sym_SLASH] = ACTIONS(3866),
    [anon_sym_PERCENT] = ACTIONS(3872),
    [anon_sym_SLASH_SLASH] = ACTIONS(3872),
    [anon_sym_STAR_STAR] = ACTIONS(3878),
    [anon_sym_PIPE] = ACTIONS(1980),
    [anon_sym_AMP] = ACTIONS(1980),
    [anon_sym_CARET] = ACTIONS(1980),
    [anon_sym_LT_LT] = ACTIONS(1980),
    [anon_sym_LT] = ACTIONS(1982),
    [anon_sym_LT_EQ] = ACTIONS(1980),
    [anon_sym_EQ_EQ] = ACTIONS(1980),
    [anon_sym_BANG_EQ] = ACTIONS(1980),
    [anon_sym_GT_EQ] = ACTIONS(1980),
    [anon_sym_GT] = ACTIONS(1982),
    [anon_sym_LT_GT] = ACTIONS(1980),
    [anon_sym_is] = ACTIONS(1980),
    [anon_sym_LBRACK] = ACTIONS(1980),
    [sym_comment] = ACTIONS(72),
  },
  [1856] = {
    [sym_argument_list] = STATE(251),
    [sym_generator_expression] = STATE(251),
    [anon_sym_DOT] = ACTIONS(422),
    [anon_sym_LPAREN] = ACTIONS(424),
    [anon_sym_RPAREN] = ACTIONS(1984),
    [anon_sym_COMMA] = ACTIONS(1984),
    [anon_sym_STAR] = ACTIONS(3866),
    [anon_sym_GT_GT] = ACTIONS(3868),
    [anon_sym_if] = ACTIONS(1984),
    [anon_sym_in] = ACTIONS(1984),
    [anon_sym_EQ] = ACTIONS(1986),
    [anon_sym_AT] = ACTIONS(3872),
    [anon_sym_not] = ACTIONS(1984),
    [anon_sym_and] = ACTIONS(1984),
    [anon_sym_or] = ACTIONS(1984),
    [anon_sym_PLUS] = ACTIONS(3876),
    [anon_sym_DASH] = ACTIONS(3876),
    [anon_sym_SLASH] = ACTIONS(3866),
    [anon_sym_PERCENT] = ACTIONS(3872),
    [anon_sym_SLASH_SLASH] = ACTIONS(3872),
    [anon_sym_STAR_STAR] = ACTIONS(3878),
    [anon_sym_PIPE] = ACTIONS(3880),
    [anon_sym_AMP] = ACTIONS(3882),
    [anon_sym_CARET] = ACTIONS(3884),
    [anon_sym_LT_LT] = ACTIONS(3868),
    [anon_sym_LT] = ACTIONS(1986),
    [anon_sym_LT_EQ] = ACTIONS(1984),
    [anon_sym_EQ_EQ] = ACTIONS(1984),
    [anon_sym_BANG_EQ] = ACTIONS(1984),
    [anon_sym_GT_EQ] = ACTIONS(1984),
    [anon_sym_GT] = ACTIONS(1986),
    [anon_sym_LT_GT] = ACTIONS(1984),
    [anon_sym_is] = ACTIONS(1984),
    [anon_sym_LBRACK] = ACTIONS(450),
    [sym_comment] = ACTIONS(72),
  },
  [1857] = {
    [sym__primary_expression] = STATE(1917),
    [sym_binary_operator] = STATE(1917),
    [sym_unary_operator] = STATE(1917),
    [sym_attribute] = STATE(1917),
    [sym_subscript] = STATE(1917),
    [sym_call] = STATE(1917),
    [sym_list] = STATE(1917),
    [sym_list_comprehension] = STATE(1917),
    [sym_dictionary] = STATE(1917),
    [sym_dictionary_comprehension] = STATE(1917),
    [sym_set] = STATE(1917),
    [sym_set_comprehension] = STATE(1917),
    [sym_parenthesized_expression] = STATE(1917),
    [sym_tuple] = STATE(1917),
    [sym_generator_expression] = STATE(1917),
    [sym_concatenated_string] = STATE(1917),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_PLUS] = ACTIONS(3281),
    [anon_sym_DASH] = ACTIONS(3281),
    [anon_sym_TILDE] = ACTIONS(3281),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(4325),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(3287),
    [sym_integer] = ACTIONS(4327),
    [sym_float] = ACTIONS(4327),
    [sym_identifier] = ACTIONS(4327),
    [sym_true] = ACTIONS(4327),
    [sym_false] = ACTIONS(4327),
    [sym_none] = ACTIONS(4327),
    [sym_comment] = ACTIONS(72),
  },
  [1858] = {
    [sym_argument_list] = STATE(251),
    [sym_generator_expression] = STATE(251),
    [anon_sym_DOT] = ACTIONS(1980),
    [anon_sym_LPAREN] = ACTIONS(424),
    [anon_sym_RPAREN] = ACTIONS(1980),
    [anon_sym_COMMA] = ACTIONS(1980),
    [anon_sym_STAR] = ACTIONS(3866),
    [anon_sym_GT_GT] = ACTIONS(1980),
    [anon_sym_if] = ACTIONS(1980),
    [anon_sym_in] = ACTIONS(1980),
    [anon_sym_EQ] = ACTIONS(1982),
    [anon_sym_AT] = ACTIONS(3872),
    [anon_sym_not] = ACTIONS(1980),
    [anon_sym_and] = ACTIONS(1980),
    [anon_sym_or] = ACTIONS(1980),
    [anon_sym_PLUS] = ACTIONS(1980),
    [anon_sym_DASH] = ACTIONS(1980),
    [anon_sym_SLASH] = ACTIONS(3866),
    [anon_sym_PERCENT] = ACTIONS(3872),
    [anon_sym_SLASH_SLASH] = ACTIONS(3872),
    [anon_sym_STAR_STAR] = ACTIONS(3878),
    [anon_sym_PIPE] = ACTIONS(1980),
    [anon_sym_AMP] = ACTIONS(1980),
    [anon_sym_CARET] = ACTIONS(1980),
    [anon_sym_LT_LT] = ACTIONS(1980),
    [anon_sym_LT] = ACTIONS(1982),
    [anon_sym_LT_EQ] = ACTIONS(1980),
    [anon_sym_EQ_EQ] = ACTIONS(1980),
    [anon_sym_BANG_EQ] = ACTIONS(1980),
    [anon_sym_GT_EQ] = ACTIONS(1980),
    [anon_sym_GT] = ACTIONS(1982),
    [anon_sym_LT_GT] = ACTIONS(1980),
    [anon_sym_is] = ACTIONS(1980),
    [anon_sym_LBRACK] = ACTIONS(1980),
    [sym_comment] = ACTIONS(72),
  },
  [1859] = {
    [sym_argument_list] = STATE(251),
    [sym_generator_expression] = STATE(251),
    [anon_sym_DOT] = ACTIONS(1980),
    [anon_sym_LPAREN] = ACTIONS(424),
    [anon_sym_RPAREN] = ACTIONS(1980),
    [anon_sym_COMMA] = ACTIONS(1980),
    [anon_sym_STAR] = ACTIONS(3866),
    [anon_sym_GT_GT] = ACTIONS(3868),
    [anon_sym_if] = ACTIONS(1980),
    [anon_sym_in] = ACTIONS(1980),
    [anon_sym_EQ] = ACTIONS(1982),
    [anon_sym_AT] = ACTIONS(3872),
    [anon_sym_not] = ACTIONS(1980),
    [anon_sym_and] = ACTIONS(1980),
    [anon_sym_or] = ACTIONS(1980),
    [anon_sym_PLUS] = ACTIONS(3876),
    [anon_sym_DASH] = ACTIONS(3876),
    [anon_sym_SLASH] = ACTIONS(3866),
    [anon_sym_PERCENT] = ACTIONS(3872),
    [anon_sym_SLASH_SLASH] = ACTIONS(3872),
    [anon_sym_STAR_STAR] = ACTIONS(3878),
    [anon_sym_PIPE] = ACTIONS(1980),
    [anon_sym_AMP] = ACTIONS(3882),
    [anon_sym_CARET] = ACTIONS(3884),
    [anon_sym_LT_LT] = ACTIONS(3868),
    [anon_sym_LT] = ACTIONS(1982),
    [anon_sym_LT_EQ] = ACTIONS(1980),
    [anon_sym_EQ_EQ] = ACTIONS(1980),
    [anon_sym_BANG_EQ] = ACTIONS(1980),
    [anon_sym_GT_EQ] = ACTIONS(1980),
    [anon_sym_GT] = ACTIONS(1982),
    [anon_sym_LT_GT] = ACTIONS(1980),
    [anon_sym_is] = ACTIONS(1980),
    [anon_sym_LBRACK] = ACTIONS(1980),
    [sym_comment] = ACTIONS(72),
  },
  [1860] = {
    [sym_argument_list] = STATE(251),
    [sym_generator_expression] = STATE(251),
    [anon_sym_DOT] = ACTIONS(1980),
    [anon_sym_LPAREN] = ACTIONS(424),
    [anon_sym_RPAREN] = ACTIONS(1980),
    [anon_sym_COMMA] = ACTIONS(1980),
    [anon_sym_STAR] = ACTIONS(3866),
    [anon_sym_GT_GT] = ACTIONS(3868),
    [anon_sym_if] = ACTIONS(1980),
    [anon_sym_in] = ACTIONS(1980),
    [anon_sym_EQ] = ACTIONS(1982),
    [anon_sym_AT] = ACTIONS(3872),
    [anon_sym_not] = ACTIONS(1980),
    [anon_sym_and] = ACTIONS(1980),
    [anon_sym_or] = ACTIONS(1980),
    [anon_sym_PLUS] = ACTIONS(3876),
    [anon_sym_DASH] = ACTIONS(3876),
    [anon_sym_SLASH] = ACTIONS(3866),
    [anon_sym_PERCENT] = ACTIONS(3872),
    [anon_sym_SLASH_SLASH] = ACTIONS(3872),
    [anon_sym_STAR_STAR] = ACTIONS(3878),
    [anon_sym_PIPE] = ACTIONS(1980),
    [anon_sym_AMP] = ACTIONS(1980),
    [anon_sym_CARET] = ACTIONS(3884),
    [anon_sym_LT_LT] = ACTIONS(3868),
    [anon_sym_LT] = ACTIONS(1982),
    [anon_sym_LT_EQ] = ACTIONS(1980),
    [anon_sym_EQ_EQ] = ACTIONS(1980),
    [anon_sym_BANG_EQ] = ACTIONS(1980),
    [anon_sym_GT_EQ] = ACTIONS(1980),
    [anon_sym_GT] = ACTIONS(1982),
    [anon_sym_LT_GT] = ACTIONS(1980),
    [anon_sym_is] = ACTIONS(1980),
    [anon_sym_LBRACK] = ACTIONS(1980),
    [sym_comment] = ACTIONS(72),
  },
  [1861] = {
    [sym_argument_list] = STATE(251),
    [sym_generator_expression] = STATE(251),
    [anon_sym_DOT] = ACTIONS(1980),
    [anon_sym_LPAREN] = ACTIONS(424),
    [anon_sym_RPAREN] = ACTIONS(1980),
    [anon_sym_COMMA] = ACTIONS(1980),
    [anon_sym_STAR] = ACTIONS(3866),
    [anon_sym_GT_GT] = ACTIONS(3868),
    [anon_sym_if] = ACTIONS(1980),
    [anon_sym_in] = ACTIONS(1980),
    [anon_sym_EQ] = ACTIONS(1982),
    [anon_sym_AT] = ACTIONS(3872),
    [anon_sym_not] = ACTIONS(1980),
    [anon_sym_and] = ACTIONS(1980),
    [anon_sym_or] = ACTIONS(1980),
    [anon_sym_PLUS] = ACTIONS(3876),
    [anon_sym_DASH] = ACTIONS(3876),
    [anon_sym_SLASH] = ACTIONS(3866),
    [anon_sym_PERCENT] = ACTIONS(3872),
    [anon_sym_SLASH_SLASH] = ACTIONS(3872),
    [anon_sym_STAR_STAR] = ACTIONS(3878),
    [anon_sym_PIPE] = ACTIONS(1980),
    [anon_sym_AMP] = ACTIONS(1980),
    [anon_sym_CARET] = ACTIONS(1980),
    [anon_sym_LT_LT] = ACTIONS(3868),
    [anon_sym_LT] = ACTIONS(1982),
    [anon_sym_LT_EQ] = ACTIONS(1980),
    [anon_sym_EQ_EQ] = ACTIONS(1980),
    [anon_sym_BANG_EQ] = ACTIONS(1980),
    [anon_sym_GT_EQ] = ACTIONS(1980),
    [anon_sym_GT] = ACTIONS(1982),
    [anon_sym_LT_GT] = ACTIONS(1980),
    [anon_sym_is] = ACTIONS(1980),
    [anon_sym_LBRACK] = ACTIONS(1980),
    [sym_comment] = ACTIONS(72),
  },
  [1862] = {
    [aux_sym_comparison_operator_repeat1] = STATE(1862),
    [anon_sym_RPAREN] = ACTIONS(1984),
    [anon_sym_COMMA] = ACTIONS(1984),
    [anon_sym_if] = ACTIONS(1984),
    [anon_sym_in] = ACTIONS(4329),
    [anon_sym_EQ] = ACTIONS(1986),
    [anon_sym_not] = ACTIONS(4332),
    [anon_sym_and] = ACTIONS(1984),
    [anon_sym_or] = ACTIONS(1984),
    [anon_sym_LT] = ACTIONS(4335),
    [anon_sym_LT_EQ] = ACTIONS(4329),
    [anon_sym_EQ_EQ] = ACTIONS(4329),
    [anon_sym_BANG_EQ] = ACTIONS(4329),
    [anon_sym_GT_EQ] = ACTIONS(4329),
    [anon_sym_GT] = ACTIONS(4335),
    [anon_sym_LT_GT] = ACTIONS(4329),
    [anon_sym_is] = ACTIONS(4338),
    [sym_comment] = ACTIONS(72),
  },
  [1863] = {
    [anon_sym_RPAREN] = ACTIONS(3936),
    [anon_sym_COMMA] = ACTIONS(3936),
    [anon_sym_if] = ACTIONS(1147),
    [anon_sym_and] = ACTIONS(1149),
    [anon_sym_or] = ACTIONS(1151),
    [sym_comment] = ACTIONS(72),
  },
  [1864] = {
    [anon_sym_if] = ACTIONS(2561),
    [anon_sym_EQ] = ACTIONS(3610),
    [anon_sym_and] = ACTIONS(2563),
    [anon_sym_or] = ACTIONS(2565),
    [sym_comment] = ACTIONS(72),
  },
  [1865] = {
    [anon_sym_COMMA] = ACTIONS(3610),
    [anon_sym_if] = ACTIONS(2604),
    [anon_sym_COLON] = ACTIONS(3610),
    [anon_sym_EQ] = ACTIONS(3610),
    [anon_sym_and] = ACTIONS(2606),
    [anon_sym_or] = ACTIONS(2608),
    [sym_comment] = ACTIONS(72),
  },
  [1866] = {
    [sym__expression_within_for_in_clause] = STATE(1798),
    [sym__expression] = STATE(1562),
    [sym__primary_expression] = STATE(145),
    [sym_not_operator] = STATE(1562),
    [sym_boolean_operator] = STATE(1562),
    [sym_binary_operator] = STATE(145),
    [sym_unary_operator] = STATE(145),
    [sym_comparison_operator] = STATE(1562),
    [sym_lambda] = STATE(1562),
    [sym_lambda_within_for_in_clause] = STATE(1406),
    [sym_attribute] = STATE(145),
    [sym_subscript] = STATE(145),
    [sym_call] = STATE(145),
    [sym_list] = STATE(145),
    [sym_list_comprehension] = STATE(145),
    [sym_dictionary] = STATE(145),
    [sym_dictionary_comprehension] = STATE(145),
    [sym_set] = STATE(145),
    [sym_set_comprehension] = STATE(145),
    [sym_parenthesized_expression] = STATE(145),
    [sym_tuple] = STATE(145),
    [sym_generator_expression] = STATE(145),
    [sym_conditional_expression] = STATE(1562),
    [sym_concatenated_string] = STATE(145),
    [sym_await] = STATE(1562),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_if] = ACTIONS(4258),
    [anon_sym_async] = ACTIONS(4258),
    [anon_sym_for] = ACTIONS(4258),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_not] = ACTIONS(240),
    [anon_sym_PLUS] = ACTIONS(242),
    [anon_sym_DASH] = ACTIONS(242),
    [anon_sym_TILDE] = ACTIONS(242),
    [anon_sym_lambda] = ACTIONS(3429),
    [anon_sym_LBRACK] = ACTIONS(96),
    [anon_sym_RBRACK] = ACTIONS(4256),
    [sym_ellipsis] = ACTIONS(248),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(250),
    [sym_integer] = ACTIONS(252),
    [sym_float] = ACTIONS(252),
    [sym_identifier] = ACTIONS(252),
    [sym_true] = ACTIONS(252),
    [sym_false] = ACTIONS(252),
    [sym_none] = ACTIONS(252),
    [anon_sym_await] = ACTIONS(254),
    [sym_comment] = ACTIONS(72),
  },
  [1867] = {
    [aux_sym_for_in_clause_repeat1] = STATE(1869),
    [anon_sym_COMMA] = ACTIONS(4341),
    [anon_sym_if] = ACTIONS(4256),
    [anon_sym_async] = ACTIONS(4256),
    [anon_sym_for] = ACTIONS(4256),
    [anon_sym_RBRACK] = ACTIONS(4256),
    [sym_comment] = ACTIONS(72),
  },
  [1868] = {
    [sym__expression_within_for_in_clause] = STATE(1882),
    [sym__expression] = STATE(1562),
    [sym__primary_expression] = STATE(145),
    [sym_not_operator] = STATE(1562),
    [sym_boolean_operator] = STATE(1562),
    [sym_binary_operator] = STATE(145),
    [sym_unary_operator] = STATE(145),
    [sym_comparison_operator] = STATE(1562),
    [sym_lambda] = STATE(1562),
    [sym_lambda_within_for_in_clause] = STATE(1406),
    [sym_attribute] = STATE(145),
    [sym_subscript] = STATE(145),
    [sym_call] = STATE(145),
    [sym_list] = STATE(145),
    [sym_list_comprehension] = STATE(145),
    [sym_dictionary] = STATE(145),
    [sym_dictionary_comprehension] = STATE(145),
    [sym_set] = STATE(145),
    [sym_set_comprehension] = STATE(145),
    [sym_parenthesized_expression] = STATE(145),
    [sym_tuple] = STATE(145),
    [sym_generator_expression] = STATE(145),
    [sym_conditional_expression] = STATE(1562),
    [sym_concatenated_string] = STATE(145),
    [sym_await] = STATE(1562),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_not] = ACTIONS(240),
    [anon_sym_PLUS] = ACTIONS(242),
    [anon_sym_DASH] = ACTIONS(242),
    [anon_sym_TILDE] = ACTIONS(242),
    [anon_sym_lambda] = ACTIONS(3429),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(248),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(250),
    [sym_integer] = ACTIONS(252),
    [sym_float] = ACTIONS(252),
    [sym_identifier] = ACTIONS(252),
    [sym_true] = ACTIONS(252),
    [sym_false] = ACTIONS(252),
    [sym_none] = ACTIONS(252),
    [anon_sym_await] = ACTIONS(254),
    [sym_comment] = ACTIONS(72),
  },
  [1869] = {
    [aux_sym_for_in_clause_repeat1] = STATE(1869),
    [anon_sym_COMMA] = ACTIONS(4343),
    [anon_sym_if] = ACTIONS(4264),
    [anon_sym_async] = ACTIONS(4264),
    [anon_sym_for] = ACTIONS(4264),
    [anon_sym_RBRACK] = ACTIONS(4264),
    [sym_comment] = ACTIONS(72),
  },
  [1870] = {
    [anon_sym_if] = ACTIONS(4204),
    [anon_sym_async] = ACTIONS(2642),
    [anon_sym_for] = ACTIONS(2642),
    [anon_sym_and] = ACTIONS(3435),
    [anon_sym_or] = ACTIONS(3437),
    [anon_sym_RBRACK] = ACTIONS(2642),
    [sym_comment] = ACTIONS(72),
  },
  [1871] = {
    [sym__expression] = STATE(1920),
    [sym__primary_expression] = STATE(1274),
    [sym_not_operator] = STATE(1920),
    [sym_boolean_operator] = STATE(1920),
    [sym_binary_operator] = STATE(1274),
    [sym_unary_operator] = STATE(1274),
    [sym_comparison_operator] = STATE(1920),
    [sym_lambda] = STATE(1920),
    [sym_attribute] = STATE(1274),
    [sym_subscript] = STATE(1274),
    [sym_call] = STATE(1274),
    [sym_list] = STATE(1274),
    [sym_list_comprehension] = STATE(1274),
    [sym_dictionary] = STATE(1274),
    [sym_dictionary_comprehension] = STATE(1274),
    [sym_set] = STATE(1274),
    [sym_set_comprehension] = STATE(1274),
    [sym_parenthesized_expression] = STATE(1274),
    [sym_tuple] = STATE(1274),
    [sym_generator_expression] = STATE(1274),
    [sym_conditional_expression] = STATE(1920),
    [sym_concatenated_string] = STATE(1274),
    [sym_await] = STATE(1920),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_not] = ACTIONS(2702),
    [anon_sym_PLUS] = ACTIONS(2704),
    [anon_sym_DASH] = ACTIONS(2704),
    [anon_sym_TILDE] = ACTIONS(2704),
    [anon_sym_lambda] = ACTIONS(2706),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(2708),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(2710),
    [sym_integer] = ACTIONS(2712),
    [sym_float] = ACTIONS(2712),
    [sym_identifier] = ACTIONS(2712),
    [sym_true] = ACTIONS(2712),
    [sym_false] = ACTIONS(2712),
    [sym_none] = ACTIONS(2712),
    [anon_sym_await] = ACTIONS(2714),
    [sym_comment] = ACTIONS(72),
  },
  [1872] = {
    [sym_argument_list] = STATE(251),
    [sym_generator_expression] = STATE(251),
    [anon_sym_DOT] = ACTIONS(422),
    [anon_sym_LPAREN] = ACTIONS(424),
    [anon_sym_STAR] = ACTIONS(3439),
    [anon_sym_GT_GT] = ACTIONS(3441),
    [anon_sym_if] = ACTIONS(2953),
    [anon_sym_async] = ACTIONS(2953),
    [anon_sym_for] = ACTIONS(2953),
    [anon_sym_in] = ACTIONS(2953),
    [anon_sym_AT] = ACTIONS(3445),
    [anon_sym_not] = ACTIONS(2953),
    [anon_sym_and] = ACTIONS(2953),
    [anon_sym_or] = ACTIONS(2953),
    [anon_sym_PLUS] = ACTIONS(3449),
    [anon_sym_DASH] = ACTIONS(3449),
    [anon_sym_SLASH] = ACTIONS(3439),
    [anon_sym_PERCENT] = ACTIONS(3445),
    [anon_sym_SLASH_SLASH] = ACTIONS(3445),
    [anon_sym_STAR_STAR] = ACTIONS(3451),
    [anon_sym_PIPE] = ACTIONS(3453),
    [anon_sym_AMP] = ACTIONS(3455),
    [anon_sym_CARET] = ACTIONS(3457),
    [anon_sym_LT_LT] = ACTIONS(3441),
    [anon_sym_LT] = ACTIONS(2955),
    [anon_sym_LT_EQ] = ACTIONS(2953),
    [anon_sym_EQ_EQ] = ACTIONS(2953),
    [anon_sym_BANG_EQ] = ACTIONS(2953),
    [anon_sym_GT_EQ] = ACTIONS(2953),
    [anon_sym_GT] = ACTIONS(2955),
    [anon_sym_LT_GT] = ACTIONS(2953),
    [anon_sym_is] = ACTIONS(2953),
    [anon_sym_LBRACK] = ACTIONS(450),
    [anon_sym_RBRACK] = ACTIONS(2953),
    [sym_comment] = ACTIONS(72),
  },
  [1873] = {
    [anon_sym_COMMA] = ACTIONS(3610),
    [anon_sym_if] = ACTIONS(2801),
    [anon_sym_async] = ACTIONS(3610),
    [anon_sym_for] = ACTIONS(3610),
    [anon_sym_and] = ACTIONS(2803),
    [anon_sym_or] = ACTIONS(2805),
    [anon_sym_RBRACE] = ACTIONS(3610),
    [sym_comment] = ACTIONS(72),
  },
  [1874] = {
    [sym__expression_within_for_in_clause] = STATE(1798),
    [sym__expression] = STATE(1603),
    [sym__primary_expression] = STATE(930),
    [sym_not_operator] = STATE(1603),
    [sym_boolean_operator] = STATE(1603),
    [sym_binary_operator] = STATE(930),
    [sym_unary_operator] = STATE(930),
    [sym_comparison_operator] = STATE(1603),
    [sym_lambda] = STATE(1603),
    [sym_lambda_within_for_in_clause] = STATE(1406),
    [sym_attribute] = STATE(930),
    [sym_subscript] = STATE(930),
    [sym_call] = STATE(930),
    [sym_list] = STATE(930),
    [sym_list_comprehension] = STATE(930),
    [sym_dictionary] = STATE(930),
    [sym_dictionary_comprehension] = STATE(930),
    [sym_set] = STATE(930),
    [sym_set_comprehension] = STATE(930),
    [sym_parenthesized_expression] = STATE(930),
    [sym_tuple] = STATE(930),
    [sym_generator_expression] = STATE(930),
    [sym_conditional_expression] = STATE(1603),
    [sym_concatenated_string] = STATE(930),
    [sym_await] = STATE(1603),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_if] = ACTIONS(4258),
    [anon_sym_async] = ACTIONS(4258),
    [anon_sym_for] = ACTIONS(4258),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_not] = ACTIONS(1808),
    [anon_sym_PLUS] = ACTIONS(1810),
    [anon_sym_DASH] = ACTIONS(1810),
    [anon_sym_TILDE] = ACTIONS(1810),
    [anon_sym_lambda] = ACTIONS(3539),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(1814),
    [anon_sym_LBRACE] = ACTIONS(100),
    [anon_sym_RBRACE] = ACTIONS(4256),
    [sym_string] = ACTIONS(1816),
    [sym_integer] = ACTIONS(1818),
    [sym_float] = ACTIONS(1818),
    [sym_identifier] = ACTIONS(1818),
    [sym_true] = ACTIONS(1818),
    [sym_false] = ACTIONS(1818),
    [sym_none] = ACTIONS(1818),
    [anon_sym_await] = ACTIONS(1820),
    [sym_comment] = ACTIONS(72),
  },
  [1875] = {
    [aux_sym_for_in_clause_repeat1] = STATE(1877),
    [anon_sym_COMMA] = ACTIONS(4346),
    [anon_sym_if] = ACTIONS(4256),
    [anon_sym_async] = ACTIONS(4256),
    [anon_sym_for] = ACTIONS(4256),
    [anon_sym_RBRACE] = ACTIONS(4256),
    [sym_comment] = ACTIONS(72),
  },
  [1876] = {
    [sym__expression_within_for_in_clause] = STATE(1882),
    [sym__expression] = STATE(1603),
    [sym__primary_expression] = STATE(930),
    [sym_not_operator] = STATE(1603),
    [sym_boolean_operator] = STATE(1603),
    [sym_binary_operator] = STATE(930),
    [sym_unary_operator] = STATE(930),
    [sym_comparison_operator] = STATE(1603),
    [sym_lambda] = STATE(1603),
    [sym_lambda_within_for_in_clause] = STATE(1406),
    [sym_attribute] = STATE(930),
    [sym_subscript] = STATE(930),
    [sym_call] = STATE(930),
    [sym_list] = STATE(930),
    [sym_list_comprehension] = STATE(930),
    [sym_dictionary] = STATE(930),
    [sym_dictionary_comprehension] = STATE(930),
    [sym_set] = STATE(930),
    [sym_set_comprehension] = STATE(930),
    [sym_parenthesized_expression] = STATE(930),
    [sym_tuple] = STATE(930),
    [sym_generator_expression] = STATE(930),
    [sym_conditional_expression] = STATE(1603),
    [sym_concatenated_string] = STATE(930),
    [sym_await] = STATE(1603),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_not] = ACTIONS(1808),
    [anon_sym_PLUS] = ACTIONS(1810),
    [anon_sym_DASH] = ACTIONS(1810),
    [anon_sym_TILDE] = ACTIONS(1810),
    [anon_sym_lambda] = ACTIONS(3539),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(1814),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(1816),
    [sym_integer] = ACTIONS(1818),
    [sym_float] = ACTIONS(1818),
    [sym_identifier] = ACTIONS(1818),
    [sym_true] = ACTIONS(1818),
    [sym_false] = ACTIONS(1818),
    [sym_none] = ACTIONS(1818),
    [anon_sym_await] = ACTIONS(1820),
    [sym_comment] = ACTIONS(72),
  },
  [1877] = {
    [aux_sym_for_in_clause_repeat1] = STATE(1877),
    [anon_sym_COMMA] = ACTIONS(4348),
    [anon_sym_if] = ACTIONS(4264),
    [anon_sym_async] = ACTIONS(4264),
    [anon_sym_for] = ACTIONS(4264),
    [anon_sym_RBRACE] = ACTIONS(4264),
    [sym_comment] = ACTIONS(72),
  },
  [1878] = {
    [anon_sym_if] = ACTIONS(4231),
    [anon_sym_async] = ACTIONS(2642),
    [anon_sym_for] = ACTIONS(2642),
    [anon_sym_and] = ACTIONS(3545),
    [anon_sym_or] = ACTIONS(3547),
    [anon_sym_RBRACE] = ACTIONS(2642),
    [sym_comment] = ACTIONS(72),
  },
  [1879] = {
    [sym__expression] = STATE(1923),
    [sym__primary_expression] = STATE(1324),
    [sym_not_operator] = STATE(1923),
    [sym_boolean_operator] = STATE(1923),
    [sym_binary_operator] = STATE(1324),
    [sym_unary_operator] = STATE(1324),
    [sym_comparison_operator] = STATE(1923),
    [sym_lambda] = STATE(1923),
    [sym_attribute] = STATE(1324),
    [sym_subscript] = STATE(1324),
    [sym_call] = STATE(1324),
    [sym_list] = STATE(1324),
    [sym_list_comprehension] = STATE(1324),
    [sym_dictionary] = STATE(1324),
    [sym_dictionary_comprehension] = STATE(1324),
    [sym_set] = STATE(1324),
    [sym_set_comprehension] = STATE(1324),
    [sym_parenthesized_expression] = STATE(1324),
    [sym_tuple] = STATE(1324),
    [sym_generator_expression] = STATE(1324),
    [sym_conditional_expression] = STATE(1923),
    [sym_concatenated_string] = STATE(1324),
    [sym_await] = STATE(1923),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_not] = ACTIONS(2837),
    [anon_sym_PLUS] = ACTIONS(2839),
    [anon_sym_DASH] = ACTIONS(2839),
    [anon_sym_TILDE] = ACTIONS(2839),
    [anon_sym_lambda] = ACTIONS(2841),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(2843),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(2845),
    [sym_integer] = ACTIONS(2847),
    [sym_float] = ACTIONS(2847),
    [sym_identifier] = ACTIONS(2847),
    [sym_true] = ACTIONS(2847),
    [sym_false] = ACTIONS(2847),
    [sym_none] = ACTIONS(2847),
    [anon_sym_await] = ACTIONS(2849),
    [sym_comment] = ACTIONS(72),
  },
  [1880] = {
    [sym_argument_list] = STATE(251),
    [sym_generator_expression] = STATE(251),
    [anon_sym_DOT] = ACTIONS(422),
    [anon_sym_LPAREN] = ACTIONS(424),
    [anon_sym_STAR] = ACTIONS(3549),
    [anon_sym_GT_GT] = ACTIONS(3551),
    [anon_sym_if] = ACTIONS(2953),
    [anon_sym_async] = ACTIONS(2953),
    [anon_sym_for] = ACTIONS(2953),
    [anon_sym_in] = ACTIONS(2953),
    [anon_sym_AT] = ACTIONS(3555),
    [anon_sym_not] = ACTIONS(2953),
    [anon_sym_and] = ACTIONS(2953),
    [anon_sym_or] = ACTIONS(2953),
    [anon_sym_PLUS] = ACTIONS(3559),
    [anon_sym_DASH] = ACTIONS(3559),
    [anon_sym_SLASH] = ACTIONS(3549),
    [anon_sym_PERCENT] = ACTIONS(3555),
    [anon_sym_SLASH_SLASH] = ACTIONS(3555),
    [anon_sym_STAR_STAR] = ACTIONS(3561),
    [anon_sym_PIPE] = ACTIONS(3563),
    [anon_sym_AMP] = ACTIONS(3565),
    [anon_sym_CARET] = ACTIONS(3567),
    [anon_sym_LT_LT] = ACTIONS(3551),
    [anon_sym_LT] = ACTIONS(2955),
    [anon_sym_LT_EQ] = ACTIONS(2953),
    [anon_sym_EQ_EQ] = ACTIONS(2953),
    [anon_sym_BANG_EQ] = ACTIONS(2953),
    [anon_sym_GT_EQ] = ACTIONS(2953),
    [anon_sym_GT] = ACTIONS(2955),
    [anon_sym_LT_GT] = ACTIONS(2953),
    [anon_sym_is] = ACTIONS(2953),
    [anon_sym_LBRACK] = ACTIONS(450),
    [anon_sym_RBRACE] = ACTIONS(2953),
    [sym_comment] = ACTIONS(72),
  },
  [1881] = {
    [sym__expression_within_for_in_clause] = STATE(1798),
    [sym__expression] = STATE(1405),
    [sym__primary_expression] = STATE(59),
    [sym_not_operator] = STATE(1405),
    [sym_boolean_operator] = STATE(1405),
    [sym_binary_operator] = STATE(59),
    [sym_unary_operator] = STATE(59),
    [sym_comparison_operator] = STATE(1405),
    [sym_lambda] = STATE(1405),
    [sym_lambda_within_for_in_clause] = STATE(1406),
    [sym_attribute] = STATE(59),
    [sym_subscript] = STATE(59),
    [sym_call] = STATE(59),
    [sym_list] = STATE(59),
    [sym_list_comprehension] = STATE(59),
    [sym_dictionary] = STATE(59),
    [sym_dictionary_comprehension] = STATE(59),
    [sym_set] = STATE(59),
    [sym_set_comprehension] = STATE(59),
    [sym_parenthesized_expression] = STATE(59),
    [sym_tuple] = STATE(59),
    [sym_generator_expression] = STATE(59),
    [sym_conditional_expression] = STATE(1405),
    [sym_concatenated_string] = STATE(59),
    [sym_await] = STATE(1405),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_RPAREN] = ACTIONS(4351),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_if] = ACTIONS(4353),
    [anon_sym_async] = ACTIONS(4353),
    [anon_sym_for] = ACTIONS(4353),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_not] = ACTIONS(88),
    [anon_sym_PLUS] = ACTIONS(90),
    [anon_sym_DASH] = ACTIONS(90),
    [anon_sym_TILDE] = ACTIONS(90),
    [anon_sym_lambda] = ACTIONS(3045),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(98),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(102),
    [sym_integer] = ACTIONS(104),
    [sym_float] = ACTIONS(104),
    [sym_identifier] = ACTIONS(104),
    [sym_true] = ACTIONS(104),
    [sym_false] = ACTIONS(104),
    [sym_none] = ACTIONS(104),
    [anon_sym_await] = ACTIONS(106),
    [sym_comment] = ACTIONS(72),
  },
  [1882] = {
    [anon_sym_RPAREN] = ACTIONS(4355),
    [anon_sym_COMMA] = ACTIONS(4355),
    [anon_sym_if] = ACTIONS(4355),
    [anon_sym_async] = ACTIONS(4355),
    [anon_sym_for] = ACTIONS(4355),
    [anon_sym_RBRACK] = ACTIONS(4355),
    [anon_sym_RBRACE] = ACTIONS(4355),
    [sym_comment] = ACTIONS(72),
  },
  [1883] = {
    [sym__expression_within_for_in_clause] = STATE(1798),
    [sym__expression] = STATE(1405),
    [sym__primary_expression] = STATE(59),
    [sym_not_operator] = STATE(1405),
    [sym_boolean_operator] = STATE(1405),
    [sym_binary_operator] = STATE(59),
    [sym_unary_operator] = STATE(59),
    [sym_comparison_operator] = STATE(1405),
    [sym_lambda] = STATE(1405),
    [sym_lambda_within_for_in_clause] = STATE(1406),
    [sym_attribute] = STATE(59),
    [sym_subscript] = STATE(59),
    [sym_call] = STATE(59),
    [sym_list] = STATE(59),
    [sym_list_comprehension] = STATE(59),
    [sym_dictionary] = STATE(59),
    [sym_dictionary_comprehension] = STATE(59),
    [sym_set] = STATE(59),
    [sym_set_comprehension] = STATE(59),
    [sym_parenthesized_expression] = STATE(59),
    [sym_tuple] = STATE(59),
    [sym_generator_expression] = STATE(59),
    [sym_conditional_expression] = STATE(1405),
    [sym_concatenated_string] = STATE(59),
    [sym_await] = STATE(1405),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_not] = ACTIONS(88),
    [anon_sym_PLUS] = ACTIONS(90),
    [anon_sym_DASH] = ACTIONS(90),
    [anon_sym_TILDE] = ACTIONS(90),
    [anon_sym_lambda] = ACTIONS(3045),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(98),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(102),
    [sym_integer] = ACTIONS(104),
    [sym_float] = ACTIONS(104),
    [sym_identifier] = ACTIONS(104),
    [sym_true] = ACTIONS(104),
    [sym_false] = ACTIONS(104),
    [sym_none] = ACTIONS(104),
    [anon_sym_await] = ACTIONS(106),
    [sym_comment] = ACTIONS(72),
  },
  [1884] = {
    [anon_sym_RPAREN] = ACTIONS(3610),
    [anon_sym_if] = ACTIONS(4060),
    [anon_sym_async] = ACTIONS(3610),
    [anon_sym_for] = ACTIONS(3610),
    [anon_sym_and] = ACTIONS(3053),
    [anon_sym_or] = ACTIONS(3055),
    [sym_comment] = ACTIONS(72),
  },
  [1885] = {
    [sym__dedent] = ACTIONS(3187),
    [anon_sym_import] = ACTIONS(3189),
    [anon_sym_from] = ACTIONS(3189),
    [anon_sym_LPAREN] = ACTIONS(3187),
    [anon_sym_print] = ACTIONS(3189),
    [anon_sym_assert] = ACTIONS(3189),
    [anon_sym_return] = ACTIONS(3189),
    [anon_sym_del] = ACTIONS(3189),
    [anon_sym_raise] = ACTIONS(3189),
    [sym_pass_statement] = ACTIONS(3189),
    [sym_break_statement] = ACTIONS(3189),
    [sym_continue_statement] = ACTIONS(3189),
    [anon_sym_if] = ACTIONS(3189),
    [anon_sym_elif] = ACTIONS(3189),
    [anon_sym_else] = ACTIONS(3189),
    [anon_sym_async] = ACTIONS(3189),
    [anon_sym_for] = ACTIONS(3189),
    [anon_sym_while] = ACTIONS(3189),
    [anon_sym_try] = ACTIONS(3189),
    [anon_sym_with] = ACTIONS(3189),
    [anon_sym_def] = ACTIONS(3189),
    [anon_sym_global] = ACTIONS(3189),
    [anon_sym_nonlocal] = ACTIONS(3189),
    [anon_sym_exec] = ACTIONS(3189),
    [anon_sym_class] = ACTIONS(3189),
    [anon_sym_AT] = ACTIONS(3187),
    [anon_sym_not] = ACTIONS(3189),
    [anon_sym_PLUS] = ACTIONS(3187),
    [anon_sym_DASH] = ACTIONS(3187),
    [anon_sym_TILDE] = ACTIONS(3187),
    [anon_sym_lambda] = ACTIONS(3189),
    [anon_sym_yield] = ACTIONS(3189),
    [anon_sym_LBRACK] = ACTIONS(3187),
    [sym_ellipsis] = ACTIONS(3187),
    [anon_sym_LBRACE] = ACTIONS(3187),
    [sym_string] = ACTIONS(3187),
    [sym_integer] = ACTIONS(3189),
    [sym_float] = ACTIONS(3189),
    [sym_identifier] = ACTIONS(3189),
    [sym_true] = ACTIONS(3189),
    [sym_false] = ACTIONS(3189),
    [sym_none] = ACTIONS(3189),
    [anon_sym_await] = ACTIONS(3189),
    [sym_comment] = ACTIONS(72),
  },
  [1886] = {
    [sym__dedent] = ACTIONS(1401),
    [anon_sym_import] = ACTIONS(1403),
    [anon_sym_from] = ACTIONS(1403),
    [anon_sym_LPAREN] = ACTIONS(1401),
    [anon_sym_print] = ACTIONS(1403),
    [anon_sym_assert] = ACTIONS(1403),
    [anon_sym_return] = ACTIONS(1403),
    [anon_sym_del] = ACTIONS(1403),
    [anon_sym_raise] = ACTIONS(1403),
    [sym_pass_statement] = ACTIONS(1403),
    [sym_break_statement] = ACTIONS(1403),
    [sym_continue_statement] = ACTIONS(1403),
    [anon_sym_if] = ACTIONS(1403),
    [anon_sym_elif] = ACTIONS(1403),
    [anon_sym_else] = ACTIONS(1403),
    [anon_sym_async] = ACTIONS(1403),
    [anon_sym_for] = ACTIONS(1403),
    [anon_sym_while] = ACTIONS(1403),
    [anon_sym_try] = ACTIONS(1403),
    [anon_sym_with] = ACTIONS(1403),
    [anon_sym_def] = ACTIONS(1403),
    [anon_sym_global] = ACTIONS(1403),
    [anon_sym_nonlocal] = ACTIONS(1403),
    [anon_sym_exec] = ACTIONS(1403),
    [anon_sym_class] = ACTIONS(1403),
    [anon_sym_AT] = ACTIONS(1401),
    [anon_sym_not] = ACTIONS(1403),
    [anon_sym_PLUS] = ACTIONS(1401),
    [anon_sym_DASH] = ACTIONS(1401),
    [anon_sym_TILDE] = ACTIONS(1401),
    [anon_sym_lambda] = ACTIONS(1403),
    [anon_sym_yield] = ACTIONS(1403),
    [anon_sym_LBRACK] = ACTIONS(1401),
    [sym_ellipsis] = ACTIONS(1401),
    [anon_sym_LBRACE] = ACTIONS(1401),
    [sym_string] = ACTIONS(1401),
    [sym_integer] = ACTIONS(1403),
    [sym_float] = ACTIONS(1403),
    [sym_identifier] = ACTIONS(1403),
    [sym_true] = ACTIONS(1403),
    [sym_false] = ACTIONS(1403),
    [sym_none] = ACTIONS(1403),
    [anon_sym_await] = ACTIONS(1403),
    [sym_comment] = ACTIONS(72),
  },
  [1887] = {
    [sym_import_statement] = STATE(326),
    [sym_import_from_statement] = STATE(326),
    [sym_print_statement] = STATE(326),
    [sym_assert_statement] = STATE(326),
    [sym_expression_statement] = STATE(326),
    [sym_return_statement] = STATE(326),
    [sym_delete_statement] = STATE(326),
    [sym_raise_statement] = STATE(326),
    [sym_global_statement] = STATE(326),
    [sym_nonlocal_statement] = STATE(326),
    [sym_exec_statement] = STATE(326),
    [sym_expression_list] = STATE(32),
    [sym__expression] = STATE(33),
    [sym__primary_expression] = STATE(34),
    [sym_not_operator] = STATE(33),
    [sym_boolean_operator] = STATE(33),
    [sym_binary_operator] = STATE(34),
    [sym_unary_operator] = STATE(34),
    [sym_comparison_operator] = STATE(33),
    [sym_lambda] = STATE(33),
    [sym_assignment] = STATE(35),
    [sym_augmented_assignment] = STATE(35),
    [sym_yield] = STATE(35),
    [sym_attribute] = STATE(34),
    [sym_subscript] = STATE(34),
    [sym_call] = STATE(34),
    [sym_list] = STATE(34),
    [sym_list_comprehension] = STATE(34),
    [sym_dictionary] = STATE(34),
    [sym_dictionary_comprehension] = STATE(34),
    [sym_set] = STATE(34),
    [sym_set_comprehension] = STATE(34),
    [sym_parenthesized_expression] = STATE(34),
    [sym_tuple] = STATE(34),
    [sym_generator_expression] = STATE(34),
    [sym_conditional_expression] = STATE(33),
    [sym_concatenated_string] = STATE(34),
    [sym_await] = STATE(33),
    [sym__newline] = ACTIONS(4357),
    [anon_sym_import] = ACTIONS(10),
    [anon_sym_from] = ACTIONS(12),
    [anon_sym_LPAREN] = ACTIONS(14),
    [anon_sym_print] = ACTIONS(16),
    [anon_sym_assert] = ACTIONS(18),
    [anon_sym_return] = ACTIONS(20),
    [anon_sym_del] = ACTIONS(22),
    [anon_sym_raise] = ACTIONS(24),
    [sym_pass_statement] = ACTIONS(582),
    [sym_break_statement] = ACTIONS(582),
    [sym_continue_statement] = ACTIONS(582),
    [anon_sym_global] = ACTIONS(42),
    [anon_sym_nonlocal] = ACTIONS(44),
    [anon_sym_exec] = ACTIONS(46),
    [anon_sym_not] = ACTIONS(52),
    [anon_sym_PLUS] = ACTIONS(54),
    [anon_sym_DASH] = ACTIONS(54),
    [anon_sym_TILDE] = ACTIONS(54),
    [anon_sym_lambda] = ACTIONS(56),
    [anon_sym_yield] = ACTIONS(58),
    [anon_sym_LBRACK] = ACTIONS(60),
    [sym_ellipsis] = ACTIONS(62),
    [anon_sym_LBRACE] = ACTIONS(64),
    [sym_string] = ACTIONS(66),
    [sym_integer] = ACTIONS(68),
    [sym_float] = ACTIONS(68),
    [sym_identifier] = ACTIONS(68),
    [sym_true] = ACTIONS(68),
    [sym_false] = ACTIONS(68),
    [sym_none] = ACTIONS(68),
    [anon_sym_await] = ACTIONS(70),
    [sym_comment] = ACTIONS(72),
  },
  [1888] = {
    [anon_sym_if] = ACTIONS(590),
    [anon_sym_COLON] = ACTIONS(4359),
    [anon_sym_and] = ACTIONS(594),
    [anon_sym_or] = ACTIONS(596),
    [sym_comment] = ACTIONS(72),
  },
  [1889] = {
    [sym__simple_statements] = STATE(1926),
    [sym_import_statement] = STATE(746),
    [sym_import_from_statement] = STATE(746),
    [sym_print_statement] = STATE(746),
    [sym_assert_statement] = STATE(746),
    [sym_expression_statement] = STATE(746),
    [sym_return_statement] = STATE(746),
    [sym_delete_statement] = STATE(746),
    [sym_raise_statement] = STATE(746),
    [sym_global_statement] = STATE(746),
    [sym_nonlocal_statement] = STATE(746),
    [sym_exec_statement] = STATE(746),
    [sym__suite] = STATE(1926),
    [sym_expression_list] = STATE(32),
    [sym__expression] = STATE(33),
    [sym__primary_expression] = STATE(34),
    [sym_not_operator] = STATE(33),
    [sym_boolean_operator] = STATE(33),
    [sym_binary_operator] = STATE(34),
    [sym_unary_operator] = STATE(34),
    [sym_comparison_operator] = STATE(33),
    [sym_lambda] = STATE(33),
    [sym_assignment] = STATE(35),
    [sym_augmented_assignment] = STATE(35),
    [sym_yield] = STATE(35),
    [sym_attribute] = STATE(34),
    [sym_subscript] = STATE(34),
    [sym_call] = STATE(34),
    [sym_list] = STATE(34),
    [sym_list_comprehension] = STATE(34),
    [sym_dictionary] = STATE(34),
    [sym_dictionary_comprehension] = STATE(34),
    [sym_set] = STATE(34),
    [sym_set_comprehension] = STATE(34),
    [sym_parenthesized_expression] = STATE(34),
    [sym_tuple] = STATE(34),
    [sym_generator_expression] = STATE(34),
    [sym_conditional_expression] = STATE(33),
    [sym_concatenated_string] = STATE(34),
    [sym_await] = STATE(33),
    [sym__indent] = ACTIONS(3791),
    [anon_sym_import] = ACTIONS(10),
    [anon_sym_from] = ACTIONS(12),
    [anon_sym_LPAREN] = ACTIONS(14),
    [anon_sym_print] = ACTIONS(16),
    [anon_sym_assert] = ACTIONS(18),
    [anon_sym_return] = ACTIONS(20),
    [anon_sym_del] = ACTIONS(22),
    [anon_sym_raise] = ACTIONS(24),
    [sym_pass_statement] = ACTIONS(1498),
    [sym_break_statement] = ACTIONS(1498),
    [sym_continue_statement] = ACTIONS(1498),
    [anon_sym_global] = ACTIONS(42),
    [anon_sym_nonlocal] = ACTIONS(44),
    [anon_sym_exec] = ACTIONS(46),
    [anon_sym_not] = ACTIONS(52),
    [anon_sym_PLUS] = ACTIONS(54),
    [anon_sym_DASH] = ACTIONS(54),
    [anon_sym_TILDE] = ACTIONS(54),
    [anon_sym_lambda] = ACTIONS(56),
    [anon_sym_yield] = ACTIONS(58),
    [anon_sym_LBRACK] = ACTIONS(60),
    [sym_ellipsis] = ACTIONS(62),
    [anon_sym_LBRACE] = ACTIONS(64),
    [sym_string] = ACTIONS(66),
    [sym_integer] = ACTIONS(68),
    [sym_float] = ACTIONS(68),
    [sym_identifier] = ACTIONS(68),
    [sym_true] = ACTIONS(68),
    [sym_false] = ACTIONS(68),
    [sym_none] = ACTIONS(68),
    [anon_sym_await] = ACTIONS(70),
    [sym_comment] = ACTIONS(72),
  },
  [1890] = {
    [sym__dedent] = ACTIONS(3743),
    [anon_sym_import] = ACTIONS(3745),
    [anon_sym_from] = ACTIONS(3745),
    [anon_sym_LPAREN] = ACTIONS(3743),
    [anon_sym_print] = ACTIONS(3745),
    [anon_sym_assert] = ACTIONS(3745),
    [anon_sym_return] = ACTIONS(3745),
    [anon_sym_del] = ACTIONS(3745),
    [anon_sym_raise] = ACTIONS(3745),
    [sym_pass_statement] = ACTIONS(3745),
    [sym_break_statement] = ACTIONS(3745),
    [sym_continue_statement] = ACTIONS(3745),
    [anon_sym_if] = ACTIONS(3745),
    [anon_sym_async] = ACTIONS(3745),
    [anon_sym_for] = ACTIONS(3745),
    [anon_sym_while] = ACTIONS(3745),
    [anon_sym_try] = ACTIONS(3745),
    [anon_sym_with] = ACTIONS(3745),
    [anon_sym_def] = ACTIONS(3745),
    [anon_sym_global] = ACTIONS(3745),
    [anon_sym_nonlocal] = ACTIONS(3745),
    [anon_sym_exec] = ACTIONS(3745),
    [anon_sym_class] = ACTIONS(3745),
    [anon_sym_AT] = ACTIONS(3743),
    [anon_sym_not] = ACTIONS(3745),
    [anon_sym_PLUS] = ACTIONS(3743),
    [anon_sym_DASH] = ACTIONS(3743),
    [anon_sym_TILDE] = ACTIONS(3743),
    [anon_sym_lambda] = ACTIONS(3745),
    [anon_sym_yield] = ACTIONS(3745),
    [anon_sym_LBRACK] = ACTIONS(3743),
    [sym_ellipsis] = ACTIONS(3743),
    [anon_sym_LBRACE] = ACTIONS(3743),
    [sym_string] = ACTIONS(3743),
    [sym_integer] = ACTIONS(3745),
    [sym_float] = ACTIONS(3745),
    [sym_identifier] = ACTIONS(3745),
    [sym_true] = ACTIONS(3745),
    [sym_false] = ACTIONS(3745),
    [sym_none] = ACTIONS(3745),
    [anon_sym_await] = ACTIONS(3745),
    [sym_comment] = ACTIONS(72),
  },
  [1891] = {
    [sym_elif_clause] = STATE(1891),
    [aux_sym_if_statement_repeat1] = STATE(1891),
    [sym__dedent] = ACTIONS(3747),
    [anon_sym_import] = ACTIONS(3749),
    [anon_sym_from] = ACTIONS(3749),
    [anon_sym_LPAREN] = ACTIONS(3747),
    [anon_sym_print] = ACTIONS(3749),
    [anon_sym_assert] = ACTIONS(3749),
    [anon_sym_return] = ACTIONS(3749),
    [anon_sym_del] = ACTIONS(3749),
    [anon_sym_raise] = ACTIONS(3749),
    [sym_pass_statement] = ACTIONS(3749),
    [sym_break_statement] = ACTIONS(3749),
    [sym_continue_statement] = ACTIONS(3749),
    [anon_sym_if] = ACTIONS(3749),
    [anon_sym_elif] = ACTIONS(4361),
    [anon_sym_else] = ACTIONS(3749),
    [anon_sym_async] = ACTIONS(3749),
    [anon_sym_for] = ACTIONS(3749),
    [anon_sym_while] = ACTIONS(3749),
    [anon_sym_try] = ACTIONS(3749),
    [anon_sym_with] = ACTIONS(3749),
    [anon_sym_def] = ACTIONS(3749),
    [anon_sym_global] = ACTIONS(3749),
    [anon_sym_nonlocal] = ACTIONS(3749),
    [anon_sym_exec] = ACTIONS(3749),
    [anon_sym_class] = ACTIONS(3749),
    [anon_sym_AT] = ACTIONS(3747),
    [anon_sym_not] = ACTIONS(3749),
    [anon_sym_PLUS] = ACTIONS(3747),
    [anon_sym_DASH] = ACTIONS(3747),
    [anon_sym_TILDE] = ACTIONS(3747),
    [anon_sym_lambda] = ACTIONS(3749),
    [anon_sym_yield] = ACTIONS(3749),
    [anon_sym_LBRACK] = ACTIONS(3747),
    [sym_ellipsis] = ACTIONS(3747),
    [anon_sym_LBRACE] = ACTIONS(3747),
    [sym_string] = ACTIONS(3747),
    [sym_integer] = ACTIONS(3749),
    [sym_float] = ACTIONS(3749),
    [sym_identifier] = ACTIONS(3749),
    [sym_true] = ACTIONS(3749),
    [sym_false] = ACTIONS(3749),
    [sym_none] = ACTIONS(3749),
    [anon_sym_await] = ACTIONS(3749),
    [sym_comment] = ACTIONS(72),
  },
  [1892] = {
    [sym__simple_statements] = STATE(1927),
    [sym_import_statement] = STATE(1686),
    [sym_import_from_statement] = STATE(1686),
    [sym_print_statement] = STATE(1686),
    [sym_assert_statement] = STATE(1686),
    [sym_expression_statement] = STATE(1686),
    [sym_return_statement] = STATE(1686),
    [sym_delete_statement] = STATE(1686),
    [sym_raise_statement] = STATE(1686),
    [sym_global_statement] = STATE(1686),
    [sym_nonlocal_statement] = STATE(1686),
    [sym_exec_statement] = STATE(1686),
    [sym__suite] = STATE(1927),
    [sym_expression_list] = STATE(32),
    [sym__expression] = STATE(33),
    [sym__primary_expression] = STATE(34),
    [sym_not_operator] = STATE(33),
    [sym_boolean_operator] = STATE(33),
    [sym_binary_operator] = STATE(34),
    [sym_unary_operator] = STATE(34),
    [sym_comparison_operator] = STATE(33),
    [sym_lambda] = STATE(33),
    [sym_assignment] = STATE(35),
    [sym_augmented_assignment] = STATE(35),
    [sym_yield] = STATE(35),
    [sym_attribute] = STATE(34),
    [sym_subscript] = STATE(34),
    [sym_call] = STATE(34),
    [sym_list] = STATE(34),
    [sym_list_comprehension] = STATE(34),
    [sym_dictionary] = STATE(34),
    [sym_dictionary_comprehension] = STATE(34),
    [sym_set] = STATE(34),
    [sym_set_comprehension] = STATE(34),
    [sym_parenthesized_expression] = STATE(34),
    [sym_tuple] = STATE(34),
    [sym_generator_expression] = STATE(34),
    [sym_conditional_expression] = STATE(33),
    [sym_concatenated_string] = STATE(34),
    [sym_await] = STATE(33),
    [sym__indent] = ACTIONS(3783),
    [anon_sym_import] = ACTIONS(10),
    [anon_sym_from] = ACTIONS(12),
    [anon_sym_LPAREN] = ACTIONS(14),
    [anon_sym_print] = ACTIONS(16),
    [anon_sym_assert] = ACTIONS(18),
    [anon_sym_return] = ACTIONS(20),
    [anon_sym_del] = ACTIONS(22),
    [anon_sym_raise] = ACTIONS(24),
    [sym_pass_statement] = ACTIONS(3785),
    [sym_break_statement] = ACTIONS(3785),
    [sym_continue_statement] = ACTIONS(3785),
    [anon_sym_global] = ACTIONS(42),
    [anon_sym_nonlocal] = ACTIONS(44),
    [anon_sym_exec] = ACTIONS(46),
    [anon_sym_not] = ACTIONS(52),
    [anon_sym_PLUS] = ACTIONS(54),
    [anon_sym_DASH] = ACTIONS(54),
    [anon_sym_TILDE] = ACTIONS(54),
    [anon_sym_lambda] = ACTIONS(56),
    [anon_sym_yield] = ACTIONS(58),
    [anon_sym_LBRACK] = ACTIONS(60),
    [sym_ellipsis] = ACTIONS(62),
    [anon_sym_LBRACE] = ACTIONS(64),
    [sym_string] = ACTIONS(66),
    [sym_integer] = ACTIONS(68),
    [sym_float] = ACTIONS(68),
    [sym_identifier] = ACTIONS(68),
    [sym_true] = ACTIONS(68),
    [sym_false] = ACTIONS(68),
    [sym_none] = ACTIONS(68),
    [anon_sym_await] = ACTIONS(70),
    [sym_comment] = ACTIONS(72),
  },
  [1893] = {
    [sym__dedent] = ACTIONS(3754),
    [anon_sym_import] = ACTIONS(3756),
    [anon_sym_from] = ACTIONS(3756),
    [anon_sym_LPAREN] = ACTIONS(3754),
    [anon_sym_print] = ACTIONS(3756),
    [anon_sym_assert] = ACTIONS(3756),
    [anon_sym_return] = ACTIONS(3756),
    [anon_sym_del] = ACTIONS(3756),
    [anon_sym_raise] = ACTIONS(3756),
    [sym_pass_statement] = ACTIONS(3756),
    [sym_break_statement] = ACTIONS(3756),
    [sym_continue_statement] = ACTIONS(3756),
    [anon_sym_if] = ACTIONS(3756),
    [anon_sym_async] = ACTIONS(3756),
    [anon_sym_for] = ACTIONS(3756),
    [anon_sym_while] = ACTIONS(3756),
    [anon_sym_try] = ACTIONS(3756),
    [anon_sym_with] = ACTIONS(3756),
    [anon_sym_def] = ACTIONS(3756),
    [anon_sym_global] = ACTIONS(3756),
    [anon_sym_nonlocal] = ACTIONS(3756),
    [anon_sym_exec] = ACTIONS(3756),
    [anon_sym_class] = ACTIONS(3756),
    [anon_sym_AT] = ACTIONS(3754),
    [anon_sym_not] = ACTIONS(3756),
    [anon_sym_PLUS] = ACTIONS(3754),
    [anon_sym_DASH] = ACTIONS(3754),
    [anon_sym_TILDE] = ACTIONS(3754),
    [anon_sym_lambda] = ACTIONS(3756),
    [anon_sym_yield] = ACTIONS(3756),
    [anon_sym_LBRACK] = ACTIONS(3754),
    [sym_ellipsis] = ACTIONS(3754),
    [anon_sym_LBRACE] = ACTIONS(3754),
    [sym_string] = ACTIONS(3754),
    [sym_integer] = ACTIONS(3756),
    [sym_float] = ACTIONS(3756),
    [sym_identifier] = ACTIONS(3756),
    [sym_true] = ACTIONS(3756),
    [sym_false] = ACTIONS(3756),
    [sym_none] = ACTIONS(3756),
    [anon_sym_await] = ACTIONS(3756),
    [sym_comment] = ACTIONS(72),
  },
  [1894] = {
    [sym__dedent] = ACTIONS(3758),
    [anon_sym_import] = ACTIONS(3760),
    [anon_sym_from] = ACTIONS(3760),
    [anon_sym_LPAREN] = ACTIONS(3758),
    [anon_sym_print] = ACTIONS(3760),
    [anon_sym_assert] = ACTIONS(3760),
    [anon_sym_return] = ACTIONS(3760),
    [anon_sym_del] = ACTIONS(3760),
    [anon_sym_raise] = ACTIONS(3760),
    [sym_pass_statement] = ACTIONS(3760),
    [sym_break_statement] = ACTIONS(3760),
    [sym_continue_statement] = ACTIONS(3760),
    [anon_sym_if] = ACTIONS(3760),
    [anon_sym_async] = ACTIONS(3760),
    [anon_sym_for] = ACTIONS(3760),
    [anon_sym_while] = ACTIONS(3760),
    [anon_sym_try] = ACTIONS(3760),
    [anon_sym_with] = ACTIONS(3760),
    [anon_sym_def] = ACTIONS(3760),
    [anon_sym_global] = ACTIONS(3760),
    [anon_sym_nonlocal] = ACTIONS(3760),
    [anon_sym_exec] = ACTIONS(3760),
    [anon_sym_class] = ACTIONS(3760),
    [anon_sym_AT] = ACTIONS(3758),
    [anon_sym_not] = ACTIONS(3760),
    [anon_sym_PLUS] = ACTIONS(3758),
    [anon_sym_DASH] = ACTIONS(3758),
    [anon_sym_TILDE] = ACTIONS(3758),
    [anon_sym_lambda] = ACTIONS(3760),
    [anon_sym_yield] = ACTIONS(3760),
    [anon_sym_LBRACK] = ACTIONS(3758),
    [sym_ellipsis] = ACTIONS(3758),
    [anon_sym_LBRACE] = ACTIONS(3758),
    [sym_string] = ACTIONS(3758),
    [sym_integer] = ACTIONS(3760),
    [sym_float] = ACTIONS(3760),
    [sym_identifier] = ACTIONS(3760),
    [sym_true] = ACTIONS(3760),
    [sym_false] = ACTIONS(3760),
    [sym_none] = ACTIONS(3760),
    [anon_sym_await] = ACTIONS(3760),
    [sym_comment] = ACTIONS(72),
  },
  [1895] = {
    [anon_sym_COLON] = ACTIONS(4364),
    [sym_comment] = ACTIONS(72),
  },
  [1896] = {
    [sym_else_clause] = STATE(1929),
    [sym__dedent] = ACTIONS(3764),
    [anon_sym_import] = ACTIONS(3766),
    [anon_sym_from] = ACTIONS(3766),
    [anon_sym_LPAREN] = ACTIONS(3764),
    [anon_sym_print] = ACTIONS(3766),
    [anon_sym_assert] = ACTIONS(3766),
    [anon_sym_return] = ACTIONS(3766),
    [anon_sym_del] = ACTIONS(3766),
    [anon_sym_raise] = ACTIONS(3766),
    [sym_pass_statement] = ACTIONS(3766),
    [sym_break_statement] = ACTIONS(3766),
    [sym_continue_statement] = ACTIONS(3766),
    [anon_sym_if] = ACTIONS(3766),
    [anon_sym_else] = ACTIONS(4099),
    [anon_sym_async] = ACTIONS(3766),
    [anon_sym_for] = ACTIONS(3766),
    [anon_sym_while] = ACTIONS(3766),
    [anon_sym_try] = ACTIONS(3766),
    [anon_sym_with] = ACTIONS(3766),
    [anon_sym_def] = ACTIONS(3766),
    [anon_sym_global] = ACTIONS(3766),
    [anon_sym_nonlocal] = ACTIONS(3766),
    [anon_sym_exec] = ACTIONS(3766),
    [anon_sym_class] = ACTIONS(3766),
    [anon_sym_AT] = ACTIONS(3764),
    [anon_sym_not] = ACTIONS(3766),
    [anon_sym_PLUS] = ACTIONS(3764),
    [anon_sym_DASH] = ACTIONS(3764),
    [anon_sym_TILDE] = ACTIONS(3764),
    [anon_sym_lambda] = ACTIONS(3766),
    [anon_sym_yield] = ACTIONS(3766),
    [anon_sym_LBRACK] = ACTIONS(3764),
    [sym_ellipsis] = ACTIONS(3764),
    [anon_sym_LBRACE] = ACTIONS(3764),
    [sym_string] = ACTIONS(3764),
    [sym_integer] = ACTIONS(3766),
    [sym_float] = ACTIONS(3766),
    [sym_identifier] = ACTIONS(3766),
    [sym_true] = ACTIONS(3766),
    [sym_false] = ACTIONS(3766),
    [sym_none] = ACTIONS(3766),
    [anon_sym_await] = ACTIONS(3766),
    [sym_comment] = ACTIONS(72),
  },
  [1897] = {
    [sym__dedent] = ACTIONS(3187),
    [anon_sym_import] = ACTIONS(3189),
    [anon_sym_from] = ACTIONS(3189),
    [anon_sym_LPAREN] = ACTIONS(3187),
    [anon_sym_print] = ACTIONS(3189),
    [anon_sym_assert] = ACTIONS(3189),
    [anon_sym_return] = ACTIONS(3189),
    [anon_sym_del] = ACTIONS(3189),
    [anon_sym_raise] = ACTIONS(3189),
    [sym_pass_statement] = ACTIONS(3189),
    [sym_break_statement] = ACTIONS(3189),
    [sym_continue_statement] = ACTIONS(3189),
    [anon_sym_if] = ACTIONS(3189),
    [anon_sym_else] = ACTIONS(3189),
    [anon_sym_async] = ACTIONS(3189),
    [anon_sym_for] = ACTIONS(3189),
    [anon_sym_while] = ACTIONS(3189),
    [anon_sym_try] = ACTIONS(3189),
    [anon_sym_with] = ACTIONS(3189),
    [anon_sym_def] = ACTIONS(3189),
    [anon_sym_global] = ACTIONS(3189),
    [anon_sym_nonlocal] = ACTIONS(3189),
    [anon_sym_exec] = ACTIONS(3189),
    [anon_sym_class] = ACTIONS(3189),
    [anon_sym_AT] = ACTIONS(3187),
    [anon_sym_not] = ACTIONS(3189),
    [anon_sym_PLUS] = ACTIONS(3187),
    [anon_sym_DASH] = ACTIONS(3187),
    [anon_sym_TILDE] = ACTIONS(3187),
    [anon_sym_lambda] = ACTIONS(3189),
    [anon_sym_yield] = ACTIONS(3189),
    [anon_sym_LBRACK] = ACTIONS(3187),
    [sym_ellipsis] = ACTIONS(3187),
    [anon_sym_LBRACE] = ACTIONS(3187),
    [sym_string] = ACTIONS(3187),
    [sym_integer] = ACTIONS(3189),
    [sym_float] = ACTIONS(3189),
    [sym_identifier] = ACTIONS(3189),
    [sym_true] = ACTIONS(3189),
    [sym_false] = ACTIONS(3189),
    [sym_none] = ACTIONS(3189),
    [anon_sym_await] = ACTIONS(3189),
    [sym_comment] = ACTIONS(72),
  },
  [1898] = {
    [sym__dedent] = ACTIONS(1401),
    [anon_sym_import] = ACTIONS(1403),
    [anon_sym_from] = ACTIONS(1403),
    [anon_sym_LPAREN] = ACTIONS(1401),
    [anon_sym_print] = ACTIONS(1403),
    [anon_sym_assert] = ACTIONS(1403),
    [anon_sym_return] = ACTIONS(1403),
    [anon_sym_del] = ACTIONS(1403),
    [anon_sym_raise] = ACTIONS(1403),
    [sym_pass_statement] = ACTIONS(1403),
    [sym_break_statement] = ACTIONS(1403),
    [sym_continue_statement] = ACTIONS(1403),
    [anon_sym_if] = ACTIONS(1403),
    [anon_sym_else] = ACTIONS(1403),
    [anon_sym_async] = ACTIONS(1403),
    [anon_sym_for] = ACTIONS(1403),
    [anon_sym_while] = ACTIONS(1403),
    [anon_sym_try] = ACTIONS(1403),
    [anon_sym_with] = ACTIONS(1403),
    [anon_sym_def] = ACTIONS(1403),
    [anon_sym_global] = ACTIONS(1403),
    [anon_sym_nonlocal] = ACTIONS(1403),
    [anon_sym_exec] = ACTIONS(1403),
    [anon_sym_class] = ACTIONS(1403),
    [anon_sym_AT] = ACTIONS(1401),
    [anon_sym_not] = ACTIONS(1403),
    [anon_sym_PLUS] = ACTIONS(1401),
    [anon_sym_DASH] = ACTIONS(1401),
    [anon_sym_TILDE] = ACTIONS(1401),
    [anon_sym_lambda] = ACTIONS(1403),
    [anon_sym_yield] = ACTIONS(1403),
    [anon_sym_LBRACK] = ACTIONS(1401),
    [sym_ellipsis] = ACTIONS(1401),
    [anon_sym_LBRACE] = ACTIONS(1401),
    [sym_string] = ACTIONS(1401),
    [sym_integer] = ACTIONS(1403),
    [sym_float] = ACTIONS(1403),
    [sym_identifier] = ACTIONS(1403),
    [sym_true] = ACTIONS(1403),
    [sym_false] = ACTIONS(1403),
    [sym_none] = ACTIONS(1403),
    [anon_sym_await] = ACTIONS(1403),
    [sym_comment] = ACTIONS(72),
  },
  [1899] = {
    [sym_import_statement] = STATE(326),
    [sym_import_from_statement] = STATE(326),
    [sym_print_statement] = STATE(326),
    [sym_assert_statement] = STATE(326),
    [sym_expression_statement] = STATE(326),
    [sym_return_statement] = STATE(326),
    [sym_delete_statement] = STATE(326),
    [sym_raise_statement] = STATE(326),
    [sym_global_statement] = STATE(326),
    [sym_nonlocal_statement] = STATE(326),
    [sym_exec_statement] = STATE(326),
    [sym_expression_list] = STATE(32),
    [sym__expression] = STATE(33),
    [sym__primary_expression] = STATE(34),
    [sym_not_operator] = STATE(33),
    [sym_boolean_operator] = STATE(33),
    [sym_binary_operator] = STATE(34),
    [sym_unary_operator] = STATE(34),
    [sym_comparison_operator] = STATE(33),
    [sym_lambda] = STATE(33),
    [sym_assignment] = STATE(35),
    [sym_augmented_assignment] = STATE(35),
    [sym_yield] = STATE(35),
    [sym_attribute] = STATE(34),
    [sym_subscript] = STATE(34),
    [sym_call] = STATE(34),
    [sym_list] = STATE(34),
    [sym_list_comprehension] = STATE(34),
    [sym_dictionary] = STATE(34),
    [sym_dictionary_comprehension] = STATE(34),
    [sym_set] = STATE(34),
    [sym_set_comprehension] = STATE(34),
    [sym_parenthesized_expression] = STATE(34),
    [sym_tuple] = STATE(34),
    [sym_generator_expression] = STATE(34),
    [sym_conditional_expression] = STATE(33),
    [sym_concatenated_string] = STATE(34),
    [sym_await] = STATE(33),
    [sym__newline] = ACTIONS(4366),
    [anon_sym_import] = ACTIONS(10),
    [anon_sym_from] = ACTIONS(12),
    [anon_sym_LPAREN] = ACTIONS(14),
    [anon_sym_print] = ACTIONS(16),
    [anon_sym_assert] = ACTIONS(18),
    [anon_sym_return] = ACTIONS(20),
    [anon_sym_del] = ACTIONS(22),
    [anon_sym_raise] = ACTIONS(24),
    [sym_pass_statement] = ACTIONS(582),
    [sym_break_statement] = ACTIONS(582),
    [sym_continue_statement] = ACTIONS(582),
    [anon_sym_global] = ACTIONS(42),
    [anon_sym_nonlocal] = ACTIONS(44),
    [anon_sym_exec] = ACTIONS(46),
    [anon_sym_not] = ACTIONS(52),
    [anon_sym_PLUS] = ACTIONS(54),
    [anon_sym_DASH] = ACTIONS(54),
    [anon_sym_TILDE] = ACTIONS(54),
    [anon_sym_lambda] = ACTIONS(56),
    [anon_sym_yield] = ACTIONS(58),
    [anon_sym_LBRACK] = ACTIONS(60),
    [sym_ellipsis] = ACTIONS(62),
    [anon_sym_LBRACE] = ACTIONS(64),
    [sym_string] = ACTIONS(66),
    [sym_integer] = ACTIONS(68),
    [sym_float] = ACTIONS(68),
    [sym_identifier] = ACTIONS(68),
    [sym_true] = ACTIONS(68),
    [sym_false] = ACTIONS(68),
    [sym_none] = ACTIONS(68),
    [anon_sym_await] = ACTIONS(70),
    [sym_comment] = ACTIONS(72),
  },
  [1900] = {
    [sym__statement] = STATE(1932),
    [sym__simple_statements] = STATE(1932),
    [sym_import_statement] = STATE(746),
    [sym_import_from_statement] = STATE(746),
    [sym_print_statement] = STATE(746),
    [sym_assert_statement] = STATE(746),
    [sym_expression_statement] = STATE(746),
    [sym_return_statement] = STATE(746),
    [sym_delete_statement] = STATE(746),
    [sym_raise_statement] = STATE(746),
    [sym_if_statement] = STATE(1932),
    [sym_for_statement] = STATE(1932),
    [sym_while_statement] = STATE(1932),
    [sym_try_statement] = STATE(1932),
    [sym_with_statement] = STATE(1932),
    [sym_function_definition] = STATE(1932),
    [sym_global_statement] = STATE(746),
    [sym_nonlocal_statement] = STATE(746),
    [sym_exec_statement] = STATE(746),
    [sym_class_definition] = STATE(1932),
    [sym_decorated_definition] = STATE(1932),
    [sym_decorator] = STATE(756),
    [sym_expression_list] = STATE(32),
    [sym__expression] = STATE(33),
    [sym__primary_expression] = STATE(34),
    [sym_not_operator] = STATE(33),
    [sym_boolean_operator] = STATE(33),
    [sym_binary_operator] = STATE(34),
    [sym_unary_operator] = STATE(34),
    [sym_comparison_operator] = STATE(33),
    [sym_lambda] = STATE(33),
    [sym_assignment] = STATE(35),
    [sym_augmented_assignment] = STATE(35),
    [sym_yield] = STATE(35),
    [sym_attribute] = STATE(34),
    [sym_subscript] = STATE(34),
    [sym_call] = STATE(34),
    [sym_list] = STATE(34),
    [sym_list_comprehension] = STATE(34),
    [sym_dictionary] = STATE(34),
    [sym_dictionary_comprehension] = STATE(34),
    [sym_set] = STATE(34),
    [sym_set_comprehension] = STATE(34),
    [sym_parenthesized_expression] = STATE(34),
    [sym_tuple] = STATE(34),
    [sym_generator_expression] = STATE(34),
    [sym_conditional_expression] = STATE(33),
    [sym_concatenated_string] = STATE(34),
    [sym_await] = STATE(33),
    [aux_sym_module_repeat1] = STATE(1932),
    [aux_sym_decorated_definition_repeat1] = STATE(756),
    [sym__dedent] = ACTIONS(4368),
    [anon_sym_import] = ACTIONS(10),
    [anon_sym_from] = ACTIONS(12),
    [anon_sym_LPAREN] = ACTIONS(14),
    [anon_sym_print] = ACTIONS(16),
    [anon_sym_assert] = ACTIONS(18),
    [anon_sym_return] = ACTIONS(20),
    [anon_sym_del] = ACTIONS(22),
    [anon_sym_raise] = ACTIONS(24),
    [sym_pass_statement] = ACTIONS(1498),
    [sym_break_statement] = ACTIONS(1498),
    [sym_continue_statement] = ACTIONS(1498),
    [anon_sym_if] = ACTIONS(1500),
    [anon_sym_async] = ACTIONS(1502),
    [anon_sym_for] = ACTIONS(1504),
    [anon_sym_while] = ACTIONS(1506),
    [anon_sym_try] = ACTIONS(1508),
    [anon_sym_with] = ACTIONS(1510),
    [anon_sym_def] = ACTIONS(1512),
    [anon_sym_global] = ACTIONS(42),
    [anon_sym_nonlocal] = ACTIONS(44),
    [anon_sym_exec] = ACTIONS(46),
    [anon_sym_class] = ACTIONS(1514),
    [anon_sym_AT] = ACTIONS(50),
    [anon_sym_not] = ACTIONS(52),
    [anon_sym_PLUS] = ACTIONS(54),
    [anon_sym_DASH] = ACTIONS(54),
    [anon_sym_TILDE] = ACTIONS(54),
    [anon_sym_lambda] = ACTIONS(56),
    [anon_sym_yield] = ACTIONS(58),
    [anon_sym_LBRACK] = ACTIONS(60),
    [sym_ellipsis] = ACTIONS(62),
    [anon_sym_LBRACE] = ACTIONS(64),
    [sym_string] = ACTIONS(66),
    [sym_integer] = ACTIONS(68),
    [sym_float] = ACTIONS(68),
    [sym_identifier] = ACTIONS(68),
    [sym_true] = ACTIONS(68),
    [sym_false] = ACTIONS(68),
    [sym_none] = ACTIONS(68),
    [anon_sym_await] = ACTIONS(70),
    [sym_comment] = ACTIONS(72),
  },
  [1901] = {
    [aux_sym__simple_statements_repeat1] = STATE(1935),
    [sym__newline] = ACTIONS(4370),
    [sym_comment] = ACTIONS(72),
    [sym__semicolon] = ACTIONS(4372),
  },
  [1902] = {
    [sym__dedent] = ACTIONS(3799),
    [anon_sym_import] = ACTIONS(3801),
    [anon_sym_from] = ACTIONS(3801),
    [anon_sym_LPAREN] = ACTIONS(3799),
    [anon_sym_print] = ACTIONS(3801),
    [anon_sym_assert] = ACTIONS(3801),
    [anon_sym_return] = ACTIONS(3801),
    [anon_sym_del] = ACTIONS(3801),
    [anon_sym_raise] = ACTIONS(3801),
    [sym_pass_statement] = ACTIONS(3801),
    [sym_break_statement] = ACTIONS(3801),
    [sym_continue_statement] = ACTIONS(3801),
    [anon_sym_if] = ACTIONS(3801),
    [anon_sym_else] = ACTIONS(3801),
    [anon_sym_async] = ACTIONS(3801),
    [anon_sym_for] = ACTIONS(3801),
    [anon_sym_while] = ACTIONS(3801),
    [anon_sym_try] = ACTIONS(3801),
    [anon_sym_except] = ACTIONS(3801),
    [anon_sym_finally] = ACTIONS(3801),
    [anon_sym_with] = ACTIONS(3801),
    [anon_sym_def] = ACTIONS(3801),
    [anon_sym_global] = ACTIONS(3801),
    [anon_sym_nonlocal] = ACTIONS(3801),
    [anon_sym_exec] = ACTIONS(3801),
    [anon_sym_class] = ACTIONS(3801),
    [anon_sym_AT] = ACTIONS(3799),
    [anon_sym_not] = ACTIONS(3801),
    [anon_sym_PLUS] = ACTIONS(3799),
    [anon_sym_DASH] = ACTIONS(3799),
    [anon_sym_TILDE] = ACTIONS(3799),
    [anon_sym_lambda] = ACTIONS(3801),
    [anon_sym_yield] = ACTIONS(3801),
    [anon_sym_LBRACK] = ACTIONS(3799),
    [sym_ellipsis] = ACTIONS(3799),
    [anon_sym_LBRACE] = ACTIONS(3799),
    [sym_string] = ACTIONS(3799),
    [sym_integer] = ACTIONS(3801),
    [sym_float] = ACTIONS(3801),
    [sym_identifier] = ACTIONS(3801),
    [sym_true] = ACTIONS(3801),
    [sym_false] = ACTIONS(3801),
    [sym_none] = ACTIONS(3801),
    [anon_sym_await] = ACTIONS(3801),
    [sym_comment] = ACTIONS(72),
  },
  [1903] = {
    [sym__expression] = STATE(1936),
    [sym__primary_expression] = STATE(96),
    [sym_not_operator] = STATE(1936),
    [sym_boolean_operator] = STATE(1936),
    [sym_binary_operator] = STATE(96),
    [sym_unary_operator] = STATE(96),
    [sym_comparison_operator] = STATE(1936),
    [sym_lambda] = STATE(1936),
    [sym_attribute] = STATE(96),
    [sym_subscript] = STATE(96),
    [sym_call] = STATE(96),
    [sym_list] = STATE(96),
    [sym_list_comprehension] = STATE(96),
    [sym_dictionary] = STATE(96),
    [sym_dictionary_comprehension] = STATE(96),
    [sym_set] = STATE(96),
    [sym_set_comprehension] = STATE(96),
    [sym_parenthesized_expression] = STATE(96),
    [sym_tuple] = STATE(96),
    [sym_generator_expression] = STATE(96),
    [sym_conditional_expression] = STATE(1936),
    [sym_concatenated_string] = STATE(96),
    [sym_await] = STATE(1936),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_not] = ACTIONS(160),
    [anon_sym_PLUS] = ACTIONS(162),
    [anon_sym_DASH] = ACTIONS(162),
    [anon_sym_TILDE] = ACTIONS(162),
    [anon_sym_lambda] = ACTIONS(164),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(166),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(168),
    [sym_integer] = ACTIONS(170),
    [sym_float] = ACTIONS(170),
    [sym_identifier] = ACTIONS(170),
    [sym_true] = ACTIONS(170),
    [sym_false] = ACTIONS(170),
    [sym_none] = ACTIONS(170),
    [anon_sym_await] = ACTIONS(172),
    [sym_comment] = ACTIONS(72),
  },
  [1904] = {
    [sym__simple_statements] = STATE(1937),
    [sym_import_statement] = STATE(1901),
    [sym_import_from_statement] = STATE(1901),
    [sym_print_statement] = STATE(1901),
    [sym_assert_statement] = STATE(1901),
    [sym_expression_statement] = STATE(1901),
    [sym_return_statement] = STATE(1901),
    [sym_delete_statement] = STATE(1901),
    [sym_raise_statement] = STATE(1901),
    [sym_global_statement] = STATE(1901),
    [sym_nonlocal_statement] = STATE(1901),
    [sym_exec_statement] = STATE(1901),
    [sym__suite] = STATE(1937),
    [sym_expression_list] = STATE(32),
    [sym__expression] = STATE(33),
    [sym__primary_expression] = STATE(34),
    [sym_not_operator] = STATE(33),
    [sym_boolean_operator] = STATE(33),
    [sym_binary_operator] = STATE(34),
    [sym_unary_operator] = STATE(34),
    [sym_comparison_operator] = STATE(33),
    [sym_lambda] = STATE(33),
    [sym_assignment] = STATE(35),
    [sym_augmented_assignment] = STATE(35),
    [sym_yield] = STATE(35),
    [sym_attribute] = STATE(34),
    [sym_subscript] = STATE(34),
    [sym_call] = STATE(34),
    [sym_list] = STATE(34),
    [sym_list_comprehension] = STATE(34),
    [sym_dictionary] = STATE(34),
    [sym_dictionary_comprehension] = STATE(34),
    [sym_set] = STATE(34),
    [sym_set_comprehension] = STATE(34),
    [sym_parenthesized_expression] = STATE(34),
    [sym_tuple] = STATE(34),
    [sym_generator_expression] = STATE(34),
    [sym_conditional_expression] = STATE(33),
    [sym_concatenated_string] = STATE(34),
    [sym_await] = STATE(33),
    [sym__indent] = ACTIONS(4297),
    [anon_sym_import] = ACTIONS(10),
    [anon_sym_from] = ACTIONS(12),
    [anon_sym_LPAREN] = ACTIONS(14),
    [anon_sym_print] = ACTIONS(16),
    [anon_sym_assert] = ACTIONS(18),
    [anon_sym_return] = ACTIONS(20),
    [anon_sym_del] = ACTIONS(22),
    [anon_sym_raise] = ACTIONS(24),
    [sym_pass_statement] = ACTIONS(4299),
    [sym_break_statement] = ACTIONS(4299),
    [sym_continue_statement] = ACTIONS(4299),
    [anon_sym_global] = ACTIONS(42),
    [anon_sym_nonlocal] = ACTIONS(44),
    [anon_sym_exec] = ACTIONS(46),
    [anon_sym_not] = ACTIONS(52),
    [anon_sym_PLUS] = ACTIONS(54),
    [anon_sym_DASH] = ACTIONS(54),
    [anon_sym_TILDE] = ACTIONS(54),
    [anon_sym_lambda] = ACTIONS(56),
    [anon_sym_yield] = ACTIONS(58),
    [anon_sym_LBRACK] = ACTIONS(60),
    [sym_ellipsis] = ACTIONS(62),
    [anon_sym_LBRACE] = ACTIONS(64),
    [sym_string] = ACTIONS(66),
    [sym_integer] = ACTIONS(68),
    [sym_float] = ACTIONS(68),
    [sym_identifier] = ACTIONS(68),
    [sym_true] = ACTIONS(68),
    [sym_false] = ACTIONS(68),
    [sym_none] = ACTIONS(68),
    [anon_sym_await] = ACTIONS(70),
    [sym_comment] = ACTIONS(72),
  },
  [1905] = {
    [sym__dedent] = ACTIONS(3803),
    [anon_sym_import] = ACTIONS(3805),
    [anon_sym_from] = ACTIONS(3805),
    [anon_sym_LPAREN] = ACTIONS(3803),
    [anon_sym_print] = ACTIONS(3805),
    [anon_sym_assert] = ACTIONS(3805),
    [anon_sym_return] = ACTIONS(3805),
    [anon_sym_del] = ACTIONS(3805),
    [anon_sym_raise] = ACTIONS(3805),
    [sym_pass_statement] = ACTIONS(3805),
    [sym_break_statement] = ACTIONS(3805),
    [sym_continue_statement] = ACTIONS(3805),
    [anon_sym_if] = ACTIONS(3805),
    [anon_sym_async] = ACTIONS(3805),
    [anon_sym_for] = ACTIONS(3805),
    [anon_sym_while] = ACTIONS(3805),
    [anon_sym_try] = ACTIONS(3805),
    [anon_sym_with] = ACTIONS(3805),
    [anon_sym_def] = ACTIONS(3805),
    [anon_sym_global] = ACTIONS(3805),
    [anon_sym_nonlocal] = ACTIONS(3805),
    [anon_sym_exec] = ACTIONS(3805),
    [anon_sym_class] = ACTIONS(3805),
    [anon_sym_AT] = ACTIONS(3803),
    [anon_sym_not] = ACTIONS(3805),
    [anon_sym_PLUS] = ACTIONS(3803),
    [anon_sym_DASH] = ACTIONS(3803),
    [anon_sym_TILDE] = ACTIONS(3803),
    [anon_sym_lambda] = ACTIONS(3805),
    [anon_sym_yield] = ACTIONS(3805),
    [anon_sym_LBRACK] = ACTIONS(3803),
    [sym_ellipsis] = ACTIONS(3803),
    [anon_sym_LBRACE] = ACTIONS(3803),
    [sym_string] = ACTIONS(3803),
    [sym_integer] = ACTIONS(3805),
    [sym_float] = ACTIONS(3805),
    [sym_identifier] = ACTIONS(3805),
    [sym_true] = ACTIONS(3805),
    [sym_false] = ACTIONS(3805),
    [sym_none] = ACTIONS(3805),
    [anon_sym_await] = ACTIONS(3805),
    [sym_comment] = ACTIONS(72),
  },
  [1906] = {
    [sym__simple_statements] = STATE(1940),
    [sym_import_statement] = STATE(1939),
    [sym_import_from_statement] = STATE(1939),
    [sym_print_statement] = STATE(1939),
    [sym_assert_statement] = STATE(1939),
    [sym_expression_statement] = STATE(1939),
    [sym_return_statement] = STATE(1939),
    [sym_delete_statement] = STATE(1939),
    [sym_raise_statement] = STATE(1939),
    [sym_global_statement] = STATE(1939),
    [sym_nonlocal_statement] = STATE(1939),
    [sym_exec_statement] = STATE(1939),
    [sym__suite] = STATE(1940),
    [sym_expression_list] = STATE(32),
    [sym__expression] = STATE(33),
    [sym__primary_expression] = STATE(34),
    [sym_not_operator] = STATE(33),
    [sym_boolean_operator] = STATE(33),
    [sym_binary_operator] = STATE(34),
    [sym_unary_operator] = STATE(34),
    [sym_comparison_operator] = STATE(33),
    [sym_lambda] = STATE(33),
    [sym_assignment] = STATE(35),
    [sym_augmented_assignment] = STATE(35),
    [sym_yield] = STATE(35),
    [sym_attribute] = STATE(34),
    [sym_subscript] = STATE(34),
    [sym_call] = STATE(34),
    [sym_list] = STATE(34),
    [sym_list_comprehension] = STATE(34),
    [sym_dictionary] = STATE(34),
    [sym_dictionary_comprehension] = STATE(34),
    [sym_set] = STATE(34),
    [sym_set_comprehension] = STATE(34),
    [sym_parenthesized_expression] = STATE(34),
    [sym_tuple] = STATE(34),
    [sym_generator_expression] = STATE(34),
    [sym_conditional_expression] = STATE(33),
    [sym_concatenated_string] = STATE(34),
    [sym_await] = STATE(33),
    [sym__indent] = ACTIONS(4374),
    [anon_sym_import] = ACTIONS(10),
    [anon_sym_from] = ACTIONS(12),
    [anon_sym_LPAREN] = ACTIONS(14),
    [anon_sym_print] = ACTIONS(16),
    [anon_sym_assert] = ACTIONS(18),
    [anon_sym_return] = ACTIONS(20),
    [anon_sym_del] = ACTIONS(22),
    [anon_sym_raise] = ACTIONS(24),
    [sym_pass_statement] = ACTIONS(4376),
    [sym_break_statement] = ACTIONS(4376),
    [sym_continue_statement] = ACTIONS(4376),
    [anon_sym_global] = ACTIONS(42),
    [anon_sym_nonlocal] = ACTIONS(44),
    [anon_sym_exec] = ACTIONS(46),
    [anon_sym_not] = ACTIONS(52),
    [anon_sym_PLUS] = ACTIONS(54),
    [anon_sym_DASH] = ACTIONS(54),
    [anon_sym_TILDE] = ACTIONS(54),
    [anon_sym_lambda] = ACTIONS(56),
    [anon_sym_yield] = ACTIONS(58),
    [anon_sym_LBRACK] = ACTIONS(60),
    [sym_ellipsis] = ACTIONS(62),
    [anon_sym_LBRACE] = ACTIONS(64),
    [sym_string] = ACTIONS(66),
    [sym_integer] = ACTIONS(68),
    [sym_float] = ACTIONS(68),
    [sym_identifier] = ACTIONS(68),
    [sym_true] = ACTIONS(68),
    [sym_false] = ACTIONS(68),
    [sym_none] = ACTIONS(68),
    [anon_sym_await] = ACTIONS(70),
    [sym_comment] = ACTIONS(72),
  },
  [1907] = {
    [sym__dedent] = ACTIONS(3811),
    [anon_sym_import] = ACTIONS(3813),
    [anon_sym_from] = ACTIONS(3813),
    [anon_sym_LPAREN] = ACTIONS(3811),
    [anon_sym_print] = ACTIONS(3813),
    [anon_sym_assert] = ACTIONS(3813),
    [anon_sym_return] = ACTIONS(3813),
    [anon_sym_del] = ACTIONS(3813),
    [anon_sym_raise] = ACTIONS(3813),
    [sym_pass_statement] = ACTIONS(3813),
    [sym_break_statement] = ACTIONS(3813),
    [sym_continue_statement] = ACTIONS(3813),
    [anon_sym_if] = ACTIONS(3813),
    [anon_sym_async] = ACTIONS(3813),
    [anon_sym_for] = ACTIONS(3813),
    [anon_sym_while] = ACTIONS(3813),
    [anon_sym_try] = ACTIONS(3813),
    [anon_sym_with] = ACTIONS(3813),
    [anon_sym_def] = ACTIONS(3813),
    [anon_sym_global] = ACTIONS(3813),
    [anon_sym_nonlocal] = ACTIONS(3813),
    [anon_sym_exec] = ACTIONS(3813),
    [anon_sym_class] = ACTIONS(3813),
    [anon_sym_AT] = ACTIONS(3811),
    [anon_sym_not] = ACTIONS(3813),
    [anon_sym_PLUS] = ACTIONS(3811),
    [anon_sym_DASH] = ACTIONS(3811),
    [anon_sym_TILDE] = ACTIONS(3811),
    [anon_sym_lambda] = ACTIONS(3813),
    [anon_sym_yield] = ACTIONS(3813),
    [anon_sym_LBRACK] = ACTIONS(3811),
    [sym_ellipsis] = ACTIONS(3811),
    [anon_sym_LBRACE] = ACTIONS(3811),
    [sym_string] = ACTIONS(3811),
    [sym_integer] = ACTIONS(3813),
    [sym_float] = ACTIONS(3813),
    [sym_identifier] = ACTIONS(3813),
    [sym_true] = ACTIONS(3813),
    [sym_false] = ACTIONS(3813),
    [sym_none] = ACTIONS(3813),
    [anon_sym_await] = ACTIONS(3813),
    [sym_comment] = ACTIONS(72),
  },
  [1908] = {
    [sym__dedent] = ACTIONS(3187),
    [anon_sym_import] = ACTIONS(3189),
    [anon_sym_from] = ACTIONS(3189),
    [anon_sym_LPAREN] = ACTIONS(3187),
    [anon_sym_print] = ACTIONS(3189),
    [anon_sym_assert] = ACTIONS(3189),
    [anon_sym_return] = ACTIONS(3189),
    [anon_sym_del] = ACTIONS(3189),
    [anon_sym_raise] = ACTIONS(3189),
    [sym_pass_statement] = ACTIONS(3189),
    [sym_break_statement] = ACTIONS(3189),
    [sym_continue_statement] = ACTIONS(3189),
    [anon_sym_if] = ACTIONS(3189),
    [anon_sym_async] = ACTIONS(3189),
    [anon_sym_for] = ACTIONS(3189),
    [anon_sym_while] = ACTIONS(3189),
    [anon_sym_try] = ACTIONS(3189),
    [anon_sym_with] = ACTIONS(3189),
    [anon_sym_def] = ACTIONS(3189),
    [anon_sym_global] = ACTIONS(3189),
    [anon_sym_nonlocal] = ACTIONS(3189),
    [anon_sym_exec] = ACTIONS(3189),
    [anon_sym_class] = ACTIONS(3189),
    [anon_sym_AT] = ACTIONS(3187),
    [anon_sym_not] = ACTIONS(3189),
    [anon_sym_PLUS] = ACTIONS(3187),
    [anon_sym_DASH] = ACTIONS(3187),
    [anon_sym_TILDE] = ACTIONS(3187),
    [anon_sym_lambda] = ACTIONS(3189),
    [anon_sym_yield] = ACTIONS(3189),
    [anon_sym_LBRACK] = ACTIONS(3187),
    [sym_ellipsis] = ACTIONS(3187),
    [anon_sym_LBRACE] = ACTIONS(3187),
    [sym_string] = ACTIONS(3187),
    [sym_integer] = ACTIONS(3189),
    [sym_float] = ACTIONS(3189),
    [sym_identifier] = ACTIONS(3189),
    [sym_true] = ACTIONS(3189),
    [sym_false] = ACTIONS(3189),
    [sym_none] = ACTIONS(3189),
    [anon_sym_await] = ACTIONS(3189),
    [sym_comment] = ACTIONS(72),
  },
  [1909] = {
    [sym__simple_statements] = STATE(1941),
    [sym_import_statement] = STATE(746),
    [sym_import_from_statement] = STATE(746),
    [sym_print_statement] = STATE(746),
    [sym_assert_statement] = STATE(746),
    [sym_expression_statement] = STATE(746),
    [sym_return_statement] = STATE(746),
    [sym_delete_statement] = STATE(746),
    [sym_raise_statement] = STATE(746),
    [sym_global_statement] = STATE(746),
    [sym_nonlocal_statement] = STATE(746),
    [sym_exec_statement] = STATE(746),
    [sym__suite] = STATE(1941),
    [sym_expression_list] = STATE(32),
    [sym__expression] = STATE(33),
    [sym__primary_expression] = STATE(34),
    [sym_not_operator] = STATE(33),
    [sym_boolean_operator] = STATE(33),
    [sym_binary_operator] = STATE(34),
    [sym_unary_operator] = STATE(34),
    [sym_comparison_operator] = STATE(33),
    [sym_lambda] = STATE(33),
    [sym_assignment] = STATE(35),
    [sym_augmented_assignment] = STATE(35),
    [sym_yield] = STATE(35),
    [sym_attribute] = STATE(34),
    [sym_subscript] = STATE(34),
    [sym_call] = STATE(34),
    [sym_list] = STATE(34),
    [sym_list_comprehension] = STATE(34),
    [sym_dictionary] = STATE(34),
    [sym_dictionary_comprehension] = STATE(34),
    [sym_set] = STATE(34),
    [sym_set_comprehension] = STATE(34),
    [sym_parenthesized_expression] = STATE(34),
    [sym_tuple] = STATE(34),
    [sym_generator_expression] = STATE(34),
    [sym_conditional_expression] = STATE(33),
    [sym_concatenated_string] = STATE(34),
    [sym_await] = STATE(33),
    [sym__indent] = ACTIONS(3791),
    [anon_sym_import] = ACTIONS(10),
    [anon_sym_from] = ACTIONS(12),
    [anon_sym_LPAREN] = ACTIONS(14),
    [anon_sym_print] = ACTIONS(16),
    [anon_sym_assert] = ACTIONS(18),
    [anon_sym_return] = ACTIONS(20),
    [anon_sym_del] = ACTIONS(22),
    [anon_sym_raise] = ACTIONS(24),
    [sym_pass_statement] = ACTIONS(1498),
    [sym_break_statement] = ACTIONS(1498),
    [sym_continue_statement] = ACTIONS(1498),
    [anon_sym_global] = ACTIONS(42),
    [anon_sym_nonlocal] = ACTIONS(44),
    [anon_sym_exec] = ACTIONS(46),
    [anon_sym_not] = ACTIONS(52),
    [anon_sym_PLUS] = ACTIONS(54),
    [anon_sym_DASH] = ACTIONS(54),
    [anon_sym_TILDE] = ACTIONS(54),
    [anon_sym_lambda] = ACTIONS(56),
    [anon_sym_yield] = ACTIONS(58),
    [anon_sym_LBRACK] = ACTIONS(60),
    [sym_ellipsis] = ACTIONS(62),
    [anon_sym_LBRACE] = ACTIONS(64),
    [sym_string] = ACTIONS(66),
    [sym_integer] = ACTIONS(68),
    [sym_float] = ACTIONS(68),
    [sym_identifier] = ACTIONS(68),
    [sym_true] = ACTIONS(68),
    [sym_false] = ACTIONS(68),
    [sym_none] = ACTIONS(68),
    [anon_sym_await] = ACTIONS(70),
    [sym_comment] = ACTIONS(72),
  },
  [1910] = {
    [ts_builtin_sym_end] = ACTIONS(4378),
    [anon_sym_import] = ACTIONS(4380),
    [anon_sym_from] = ACTIONS(4380),
    [anon_sym_LPAREN] = ACTIONS(4378),
    [anon_sym_print] = ACTIONS(4380),
    [anon_sym_assert] = ACTIONS(4380),
    [anon_sym_return] = ACTIONS(4380),
    [anon_sym_del] = ACTIONS(4380),
    [anon_sym_raise] = ACTIONS(4380),
    [sym_pass_statement] = ACTIONS(4380),
    [sym_break_statement] = ACTIONS(4380),
    [sym_continue_statement] = ACTIONS(4380),
    [anon_sym_if] = ACTIONS(4380),
    [anon_sym_else] = ACTIONS(4380),
    [anon_sym_async] = ACTIONS(4380),
    [anon_sym_for] = ACTIONS(4380),
    [anon_sym_while] = ACTIONS(4380),
    [anon_sym_try] = ACTIONS(4380),
    [anon_sym_except] = ACTIONS(4380),
    [anon_sym_finally] = ACTIONS(4380),
    [anon_sym_with] = ACTIONS(4380),
    [anon_sym_def] = ACTIONS(4380),
    [anon_sym_global] = ACTIONS(4380),
    [anon_sym_nonlocal] = ACTIONS(4380),
    [anon_sym_exec] = ACTIONS(4380),
    [anon_sym_class] = ACTIONS(4380),
    [anon_sym_AT] = ACTIONS(4378),
    [anon_sym_not] = ACTIONS(4380),
    [anon_sym_PLUS] = ACTIONS(4378),
    [anon_sym_DASH] = ACTIONS(4378),
    [anon_sym_TILDE] = ACTIONS(4378),
    [anon_sym_lambda] = ACTIONS(4380),
    [anon_sym_yield] = ACTIONS(4380),
    [anon_sym_LBRACK] = ACTIONS(4378),
    [sym_ellipsis] = ACTIONS(4378),
    [anon_sym_LBRACE] = ACTIONS(4378),
    [sym_string] = ACTIONS(4378),
    [sym_integer] = ACTIONS(4380),
    [sym_float] = ACTIONS(4380),
    [sym_identifier] = ACTIONS(4380),
    [sym_true] = ACTIONS(4380),
    [sym_false] = ACTIONS(4380),
    [sym_none] = ACTIONS(4380),
    [anon_sym_await] = ACTIONS(4380),
    [sym_comment] = ACTIONS(72),
  },
  [1911] = {
    [ts_builtin_sym_end] = ACTIONS(3187),
    [anon_sym_import] = ACTIONS(3189),
    [anon_sym_from] = ACTIONS(3189),
    [anon_sym_LPAREN] = ACTIONS(3187),
    [anon_sym_print] = ACTIONS(3189),
    [anon_sym_assert] = ACTIONS(3189),
    [anon_sym_return] = ACTIONS(3189),
    [anon_sym_del] = ACTIONS(3189),
    [anon_sym_raise] = ACTIONS(3189),
    [sym_pass_statement] = ACTIONS(3189),
    [sym_break_statement] = ACTIONS(3189),
    [sym_continue_statement] = ACTIONS(3189),
    [anon_sym_if] = ACTIONS(3189),
    [anon_sym_async] = ACTIONS(3189),
    [anon_sym_for] = ACTIONS(3189),
    [anon_sym_while] = ACTIONS(3189),
    [anon_sym_try] = ACTIONS(3189),
    [anon_sym_finally] = ACTIONS(3189),
    [anon_sym_with] = ACTIONS(3189),
    [anon_sym_def] = ACTIONS(3189),
    [anon_sym_global] = ACTIONS(3189),
    [anon_sym_nonlocal] = ACTIONS(3189),
    [anon_sym_exec] = ACTIONS(3189),
    [anon_sym_class] = ACTIONS(3189),
    [anon_sym_AT] = ACTIONS(3187),
    [anon_sym_not] = ACTIONS(3189),
    [anon_sym_PLUS] = ACTIONS(3187),
    [anon_sym_DASH] = ACTIONS(3187),
    [anon_sym_TILDE] = ACTIONS(3187),
    [anon_sym_lambda] = ACTIONS(3189),
    [anon_sym_yield] = ACTIONS(3189),
    [anon_sym_LBRACK] = ACTIONS(3187),
    [sym_ellipsis] = ACTIONS(3187),
    [anon_sym_LBRACE] = ACTIONS(3187),
    [sym_string] = ACTIONS(3187),
    [sym_integer] = ACTIONS(3189),
    [sym_float] = ACTIONS(3189),
    [sym_identifier] = ACTIONS(3189),
    [sym_true] = ACTIONS(3189),
    [sym_false] = ACTIONS(3189),
    [sym_none] = ACTIONS(3189),
    [anon_sym_await] = ACTIONS(3189),
    [sym_comment] = ACTIONS(72),
  },
  [1912] = {
    [ts_builtin_sym_end] = ACTIONS(1401),
    [anon_sym_import] = ACTIONS(1403),
    [anon_sym_from] = ACTIONS(1403),
    [anon_sym_LPAREN] = ACTIONS(1401),
    [anon_sym_print] = ACTIONS(1403),
    [anon_sym_assert] = ACTIONS(1403),
    [anon_sym_return] = ACTIONS(1403),
    [anon_sym_del] = ACTIONS(1403),
    [anon_sym_raise] = ACTIONS(1403),
    [sym_pass_statement] = ACTIONS(1403),
    [sym_break_statement] = ACTIONS(1403),
    [sym_continue_statement] = ACTIONS(1403),
    [anon_sym_if] = ACTIONS(1403),
    [anon_sym_async] = ACTIONS(1403),
    [anon_sym_for] = ACTIONS(1403),
    [anon_sym_while] = ACTIONS(1403),
    [anon_sym_try] = ACTIONS(1403),
    [anon_sym_finally] = ACTIONS(1403),
    [anon_sym_with] = ACTIONS(1403),
    [anon_sym_def] = ACTIONS(1403),
    [anon_sym_global] = ACTIONS(1403),
    [anon_sym_nonlocal] = ACTIONS(1403),
    [anon_sym_exec] = ACTIONS(1403),
    [anon_sym_class] = ACTIONS(1403),
    [anon_sym_AT] = ACTIONS(1401),
    [anon_sym_not] = ACTIONS(1403),
    [anon_sym_PLUS] = ACTIONS(1401),
    [anon_sym_DASH] = ACTIONS(1401),
    [anon_sym_TILDE] = ACTIONS(1401),
    [anon_sym_lambda] = ACTIONS(1403),
    [anon_sym_yield] = ACTIONS(1403),
    [anon_sym_LBRACK] = ACTIONS(1401),
    [sym_ellipsis] = ACTIONS(1401),
    [anon_sym_LBRACE] = ACTIONS(1401),
    [sym_string] = ACTIONS(1401),
    [sym_integer] = ACTIONS(1403),
    [sym_float] = ACTIONS(1403),
    [sym_identifier] = ACTIONS(1403),
    [sym_true] = ACTIONS(1403),
    [sym_false] = ACTIONS(1403),
    [sym_none] = ACTIONS(1403),
    [anon_sym_await] = ACTIONS(1403),
    [sym_comment] = ACTIONS(72),
  },
  [1913] = {
    [sym_import_statement] = STATE(326),
    [sym_import_from_statement] = STATE(326),
    [sym_print_statement] = STATE(326),
    [sym_assert_statement] = STATE(326),
    [sym_expression_statement] = STATE(326),
    [sym_return_statement] = STATE(326),
    [sym_delete_statement] = STATE(326),
    [sym_raise_statement] = STATE(326),
    [sym_global_statement] = STATE(326),
    [sym_nonlocal_statement] = STATE(326),
    [sym_exec_statement] = STATE(326),
    [sym_expression_list] = STATE(32),
    [sym__expression] = STATE(33),
    [sym__primary_expression] = STATE(34),
    [sym_not_operator] = STATE(33),
    [sym_boolean_operator] = STATE(33),
    [sym_binary_operator] = STATE(34),
    [sym_unary_operator] = STATE(34),
    [sym_comparison_operator] = STATE(33),
    [sym_lambda] = STATE(33),
    [sym_assignment] = STATE(35),
    [sym_augmented_assignment] = STATE(35),
    [sym_yield] = STATE(35),
    [sym_attribute] = STATE(34),
    [sym_subscript] = STATE(34),
    [sym_call] = STATE(34),
    [sym_list] = STATE(34),
    [sym_list_comprehension] = STATE(34),
    [sym_dictionary] = STATE(34),
    [sym_dictionary_comprehension] = STATE(34),
    [sym_set] = STATE(34),
    [sym_set_comprehension] = STATE(34),
    [sym_parenthesized_expression] = STATE(34),
    [sym_tuple] = STATE(34),
    [sym_generator_expression] = STATE(34),
    [sym_conditional_expression] = STATE(33),
    [sym_concatenated_string] = STATE(34),
    [sym_await] = STATE(33),
    [sym__newline] = ACTIONS(4382),
    [anon_sym_import] = ACTIONS(10),
    [anon_sym_from] = ACTIONS(12),
    [anon_sym_LPAREN] = ACTIONS(14),
    [anon_sym_print] = ACTIONS(16),
    [anon_sym_assert] = ACTIONS(18),
    [anon_sym_return] = ACTIONS(20),
    [anon_sym_del] = ACTIONS(22),
    [anon_sym_raise] = ACTIONS(24),
    [sym_pass_statement] = ACTIONS(582),
    [sym_break_statement] = ACTIONS(582),
    [sym_continue_statement] = ACTIONS(582),
    [anon_sym_global] = ACTIONS(42),
    [anon_sym_nonlocal] = ACTIONS(44),
    [anon_sym_exec] = ACTIONS(46),
    [anon_sym_not] = ACTIONS(52),
    [anon_sym_PLUS] = ACTIONS(54),
    [anon_sym_DASH] = ACTIONS(54),
    [anon_sym_TILDE] = ACTIONS(54),
    [anon_sym_lambda] = ACTIONS(56),
    [anon_sym_yield] = ACTIONS(58),
    [anon_sym_LBRACK] = ACTIONS(60),
    [sym_ellipsis] = ACTIONS(62),
    [anon_sym_LBRACE] = ACTIONS(64),
    [sym_string] = ACTIONS(66),
    [sym_integer] = ACTIONS(68),
    [sym_float] = ACTIONS(68),
    [sym_identifier] = ACTIONS(68),
    [sym_true] = ACTIONS(68),
    [sym_false] = ACTIONS(68),
    [sym_none] = ACTIONS(68),
    [anon_sym_await] = ACTIONS(70),
    [sym_comment] = ACTIONS(72),
  },
  [1914] = {
    [anon_sym_RPAREN] = ACTIONS(3610),
    [anon_sym_COMMA] = ACTIONS(3610),
    [anon_sym_if] = ACTIONS(3243),
    [anon_sym_COLON] = ACTIONS(3610),
    [anon_sym_and] = ACTIONS(3245),
    [anon_sym_or] = ACTIONS(3247),
    [sym_comment] = ACTIONS(72),
  },
  [1915] = {
    [anon_sym_RPAREN] = ACTIONS(2642),
    [anon_sym_COMMA] = ACTIONS(2642),
    [anon_sym_if] = ACTIONS(3860),
    [anon_sym_EQ] = ACTIONS(2642),
    [anon_sym_and] = ACTIONS(3862),
    [anon_sym_or] = ACTIONS(3864),
    [sym_comment] = ACTIONS(72),
  },
  [1916] = {
    [sym__expression] = STATE(1943),
    [sym__primary_expression] = STATE(1516),
    [sym_not_operator] = STATE(1943),
    [sym_boolean_operator] = STATE(1943),
    [sym_binary_operator] = STATE(1516),
    [sym_unary_operator] = STATE(1516),
    [sym_comparison_operator] = STATE(1943),
    [sym_lambda] = STATE(1943),
    [sym_attribute] = STATE(1516),
    [sym_subscript] = STATE(1516),
    [sym_call] = STATE(1516),
    [sym_list] = STATE(1516),
    [sym_list_comprehension] = STATE(1516),
    [sym_dictionary] = STATE(1516),
    [sym_dictionary_comprehension] = STATE(1516),
    [sym_set] = STATE(1516),
    [sym_set_comprehension] = STATE(1516),
    [sym_parenthesized_expression] = STATE(1516),
    [sym_tuple] = STATE(1516),
    [sym_generator_expression] = STATE(1516),
    [sym_conditional_expression] = STATE(1943),
    [sym_concatenated_string] = STATE(1516),
    [sym_await] = STATE(1943),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_not] = ACTIONS(3279),
    [anon_sym_PLUS] = ACTIONS(3281),
    [anon_sym_DASH] = ACTIONS(3281),
    [anon_sym_TILDE] = ACTIONS(3281),
    [anon_sym_lambda] = ACTIONS(3283),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(3285),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(3287),
    [sym_integer] = ACTIONS(3289),
    [sym_float] = ACTIONS(3289),
    [sym_identifier] = ACTIONS(3289),
    [sym_true] = ACTIONS(3289),
    [sym_false] = ACTIONS(3289),
    [sym_none] = ACTIONS(3289),
    [anon_sym_await] = ACTIONS(3291),
    [sym_comment] = ACTIONS(72),
  },
  [1917] = {
    [sym_argument_list] = STATE(251),
    [sym_generator_expression] = STATE(251),
    [anon_sym_DOT] = ACTIONS(422),
    [anon_sym_LPAREN] = ACTIONS(424),
    [anon_sym_RPAREN] = ACTIONS(2953),
    [anon_sym_COMMA] = ACTIONS(2953),
    [anon_sym_STAR] = ACTIONS(3866),
    [anon_sym_GT_GT] = ACTIONS(3868),
    [anon_sym_if] = ACTIONS(2953),
    [anon_sym_in] = ACTIONS(2953),
    [anon_sym_EQ] = ACTIONS(2955),
    [anon_sym_AT] = ACTIONS(3872),
    [anon_sym_not] = ACTIONS(2953),
    [anon_sym_and] = ACTIONS(2953),
    [anon_sym_or] = ACTIONS(2953),
    [anon_sym_PLUS] = ACTIONS(3876),
    [anon_sym_DASH] = ACTIONS(3876),
    [anon_sym_SLASH] = ACTIONS(3866),
    [anon_sym_PERCENT] = ACTIONS(3872),
    [anon_sym_SLASH_SLASH] = ACTIONS(3872),
    [anon_sym_STAR_STAR] = ACTIONS(3878),
    [anon_sym_PIPE] = ACTIONS(3880),
    [anon_sym_AMP] = ACTIONS(3882),
    [anon_sym_CARET] = ACTIONS(3884),
    [anon_sym_LT_LT] = ACTIONS(3868),
    [anon_sym_LT] = ACTIONS(2955),
    [anon_sym_LT_EQ] = ACTIONS(2953),
    [anon_sym_EQ_EQ] = ACTIONS(2953),
    [anon_sym_BANG_EQ] = ACTIONS(2953),
    [anon_sym_GT_EQ] = ACTIONS(2953),
    [anon_sym_GT] = ACTIONS(2955),
    [anon_sym_LT_GT] = ACTIONS(2953),
    [anon_sym_is] = ACTIONS(2953),
    [anon_sym_LBRACK] = ACTIONS(450),
    [sym_comment] = ACTIONS(72),
  },
  [1918] = {
    [sym__expression_within_for_in_clause] = STATE(1798),
    [sym__expression] = STATE(1562),
    [sym__primary_expression] = STATE(145),
    [sym_not_operator] = STATE(1562),
    [sym_boolean_operator] = STATE(1562),
    [sym_binary_operator] = STATE(145),
    [sym_unary_operator] = STATE(145),
    [sym_comparison_operator] = STATE(1562),
    [sym_lambda] = STATE(1562),
    [sym_lambda_within_for_in_clause] = STATE(1406),
    [sym_attribute] = STATE(145),
    [sym_subscript] = STATE(145),
    [sym_call] = STATE(145),
    [sym_list] = STATE(145),
    [sym_list_comprehension] = STATE(145),
    [sym_dictionary] = STATE(145),
    [sym_dictionary_comprehension] = STATE(145),
    [sym_set] = STATE(145),
    [sym_set_comprehension] = STATE(145),
    [sym_parenthesized_expression] = STATE(145),
    [sym_tuple] = STATE(145),
    [sym_generator_expression] = STATE(145),
    [sym_conditional_expression] = STATE(1562),
    [sym_concatenated_string] = STATE(145),
    [sym_await] = STATE(1562),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_if] = ACTIONS(4353),
    [anon_sym_async] = ACTIONS(4353),
    [anon_sym_for] = ACTIONS(4353),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_not] = ACTIONS(240),
    [anon_sym_PLUS] = ACTIONS(242),
    [anon_sym_DASH] = ACTIONS(242),
    [anon_sym_TILDE] = ACTIONS(242),
    [anon_sym_lambda] = ACTIONS(3429),
    [anon_sym_LBRACK] = ACTIONS(96),
    [anon_sym_RBRACK] = ACTIONS(4351),
    [sym_ellipsis] = ACTIONS(248),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(250),
    [sym_integer] = ACTIONS(252),
    [sym_float] = ACTIONS(252),
    [sym_identifier] = ACTIONS(252),
    [sym_true] = ACTIONS(252),
    [sym_false] = ACTIONS(252),
    [sym_none] = ACTIONS(252),
    [anon_sym_await] = ACTIONS(254),
    [sym_comment] = ACTIONS(72),
  },
  [1919] = {
    [sym__expression_within_for_in_clause] = STATE(1798),
    [sym__expression] = STATE(1562),
    [sym__primary_expression] = STATE(145),
    [sym_not_operator] = STATE(1562),
    [sym_boolean_operator] = STATE(1562),
    [sym_binary_operator] = STATE(145),
    [sym_unary_operator] = STATE(145),
    [sym_comparison_operator] = STATE(1562),
    [sym_lambda] = STATE(1562),
    [sym_lambda_within_for_in_clause] = STATE(1406),
    [sym_attribute] = STATE(145),
    [sym_subscript] = STATE(145),
    [sym_call] = STATE(145),
    [sym_list] = STATE(145),
    [sym_list_comprehension] = STATE(145),
    [sym_dictionary] = STATE(145),
    [sym_dictionary_comprehension] = STATE(145),
    [sym_set] = STATE(145),
    [sym_set_comprehension] = STATE(145),
    [sym_parenthesized_expression] = STATE(145),
    [sym_tuple] = STATE(145),
    [sym_generator_expression] = STATE(145),
    [sym_conditional_expression] = STATE(1562),
    [sym_concatenated_string] = STATE(145),
    [sym_await] = STATE(1562),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_not] = ACTIONS(240),
    [anon_sym_PLUS] = ACTIONS(242),
    [anon_sym_DASH] = ACTIONS(242),
    [anon_sym_TILDE] = ACTIONS(242),
    [anon_sym_lambda] = ACTIONS(3429),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(248),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(250),
    [sym_integer] = ACTIONS(252),
    [sym_float] = ACTIONS(252),
    [sym_identifier] = ACTIONS(252),
    [sym_true] = ACTIONS(252),
    [sym_false] = ACTIONS(252),
    [sym_none] = ACTIONS(252),
    [anon_sym_await] = ACTIONS(254),
    [sym_comment] = ACTIONS(72),
  },
  [1920] = {
    [anon_sym_if] = ACTIONS(4204),
    [anon_sym_async] = ACTIONS(3610),
    [anon_sym_for] = ACTIONS(3610),
    [anon_sym_and] = ACTIONS(3435),
    [anon_sym_or] = ACTIONS(3437),
    [anon_sym_RBRACK] = ACTIONS(3610),
    [sym_comment] = ACTIONS(72),
  },
  [1921] = {
    [sym__expression_within_for_in_clause] = STATE(1798),
    [sym__expression] = STATE(1603),
    [sym__primary_expression] = STATE(930),
    [sym_not_operator] = STATE(1603),
    [sym_boolean_operator] = STATE(1603),
    [sym_binary_operator] = STATE(930),
    [sym_unary_operator] = STATE(930),
    [sym_comparison_operator] = STATE(1603),
    [sym_lambda] = STATE(1603),
    [sym_lambda_within_for_in_clause] = STATE(1406),
    [sym_attribute] = STATE(930),
    [sym_subscript] = STATE(930),
    [sym_call] = STATE(930),
    [sym_list] = STATE(930),
    [sym_list_comprehension] = STATE(930),
    [sym_dictionary] = STATE(930),
    [sym_dictionary_comprehension] = STATE(930),
    [sym_set] = STATE(930),
    [sym_set_comprehension] = STATE(930),
    [sym_parenthesized_expression] = STATE(930),
    [sym_tuple] = STATE(930),
    [sym_generator_expression] = STATE(930),
    [sym_conditional_expression] = STATE(1603),
    [sym_concatenated_string] = STATE(930),
    [sym_await] = STATE(1603),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_if] = ACTIONS(4353),
    [anon_sym_async] = ACTIONS(4353),
    [anon_sym_for] = ACTIONS(4353),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_not] = ACTIONS(1808),
    [anon_sym_PLUS] = ACTIONS(1810),
    [anon_sym_DASH] = ACTIONS(1810),
    [anon_sym_TILDE] = ACTIONS(1810),
    [anon_sym_lambda] = ACTIONS(3539),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(1814),
    [anon_sym_LBRACE] = ACTIONS(100),
    [anon_sym_RBRACE] = ACTIONS(4351),
    [sym_string] = ACTIONS(1816),
    [sym_integer] = ACTIONS(1818),
    [sym_float] = ACTIONS(1818),
    [sym_identifier] = ACTIONS(1818),
    [sym_true] = ACTIONS(1818),
    [sym_false] = ACTIONS(1818),
    [sym_none] = ACTIONS(1818),
    [anon_sym_await] = ACTIONS(1820),
    [sym_comment] = ACTIONS(72),
  },
  [1922] = {
    [sym__expression_within_for_in_clause] = STATE(1798),
    [sym__expression] = STATE(1603),
    [sym__primary_expression] = STATE(930),
    [sym_not_operator] = STATE(1603),
    [sym_boolean_operator] = STATE(1603),
    [sym_binary_operator] = STATE(930),
    [sym_unary_operator] = STATE(930),
    [sym_comparison_operator] = STATE(1603),
    [sym_lambda] = STATE(1603),
    [sym_lambda_within_for_in_clause] = STATE(1406),
    [sym_attribute] = STATE(930),
    [sym_subscript] = STATE(930),
    [sym_call] = STATE(930),
    [sym_list] = STATE(930),
    [sym_list_comprehension] = STATE(930),
    [sym_dictionary] = STATE(930),
    [sym_dictionary_comprehension] = STATE(930),
    [sym_set] = STATE(930),
    [sym_set_comprehension] = STATE(930),
    [sym_parenthesized_expression] = STATE(930),
    [sym_tuple] = STATE(930),
    [sym_generator_expression] = STATE(930),
    [sym_conditional_expression] = STATE(1603),
    [sym_concatenated_string] = STATE(930),
    [sym_await] = STATE(1603),
    [anon_sym_LPAREN] = ACTIONS(80),
    [anon_sym_print] = ACTIONS(86),
    [anon_sym_exec] = ACTIONS(86),
    [anon_sym_not] = ACTIONS(1808),
    [anon_sym_PLUS] = ACTIONS(1810),
    [anon_sym_DASH] = ACTIONS(1810),
    [anon_sym_TILDE] = ACTIONS(1810),
    [anon_sym_lambda] = ACTIONS(3539),
    [anon_sym_LBRACK] = ACTIONS(96),
    [sym_ellipsis] = ACTIONS(1814),
    [anon_sym_LBRACE] = ACTIONS(100),
    [sym_string] = ACTIONS(1816),
    [sym_integer] = ACTIONS(1818),
    [sym_float] = ACTIONS(1818),
    [sym_identifier] = ACTIONS(1818),
    [sym_true] = ACTIONS(1818),
    [sym_false] = ACTIONS(1818),
    [sym_none] = ACTIONS(1818),
    [anon_sym_await] = ACTIONS(1820),
    [sym_comment] = ACTIONS(72),
  },
  [1923] = {
    [anon_sym_if] = ACTIONS(4231),
    [anon_sym_async] = ACTIONS(3610),
    [anon_sym_for] = ACTIONS(3610),
    [anon_sym_and] = ACTIONS(3545),
    [anon_sym_or] = ACTIONS(3547),
    [anon_sym_RBRACE] = ACTIONS(3610),
    [sym_comment] = ACTIONS(72),
  },
  [1924] = {
    [sym__dedent] = ACTIONS(2319),
    [anon_sym_import] = ACTIONS(2321),
    [anon_sym_from] = ACTIONS(2321),
    [anon_sym_LPAREN] = ACTIONS(2319),
    [anon_sym_print] = ACTIONS(2321),
    [anon_sym_assert] = ACTIONS(2321),
    [anon_sym_return] = ACTIONS(2321),
    [anon_sym_del] = ACTIONS(2321),
    [anon_sym_raise] = ACTIONS(2321),
    [sym_pass_statement] = ACTIONS(2321),
    [sym_break_statement] = ACTIONS(2321),
    [sym_continue_statement] = ACTIONS(2321),
    [anon_sym_if] = ACTIONS(2321),
    [anon_sym_elif] = ACTIONS(2321),
    [anon_sym_else] = ACTIONS(2321),
    [anon_sym_async] = ACTIONS(2321),
    [anon_sym_for] = ACTIONS(2321),
    [anon_sym_while] = ACTIONS(2321),
    [anon_sym_try] = ACTIONS(2321),
    [anon_sym_with] = ACTIONS(2321),
    [anon_sym_def] = ACTIONS(2321),
    [anon_sym_global] = ACTIONS(2321),
    [anon_sym_nonlocal] = ACTIONS(2321),
    [anon_sym_exec] = ACTIONS(2321),
    [anon_sym_class] = ACTIONS(2321),
    [anon_sym_AT] = ACTIONS(2319),
    [anon_sym_not] = ACTIONS(2321),
    [anon_sym_PLUS] = ACTIONS(2319),
    [anon_sym_DASH] = ACTIONS(2319),
    [anon_sym_TILDE] = ACTIONS(2319),
    [anon_sym_lambda] = ACTIONS(2321),
    [anon_sym_yield] = ACTIONS(2321),
    [anon_sym_LBRACK] = ACTIONS(2319),
    [sym_ellipsis] = ACTIONS(2319),
    [anon_sym_LBRACE] = ACTIONS(2319),
    [sym_string] = ACTIONS(2319),
    [sym_integer] = ACTIONS(2321),
    [sym_float] = ACTIONS(2321),
    [sym_identifier] = ACTIONS(2321),
    [sym_true] = ACTIONS(2321),
    [sym_false] = ACTIONS(2321),
    [sym_none] = ACTIONS(2321),
    [anon_sym_await] = ACTIONS(2321),
    [sym_comment] = ACTIONS(72),
  },
  [1925] = {
    [sym__simple_statements] = STATE(1944),
    [sym_import_statement] = STATE(1678),
    [sym_import_from_statement] = STATE(1678),
    [sym_print_statement] = STATE(1678),
    [sym_assert_statement] = STATE(1678),
    [sym_expression_statement] = STATE(1678),
    [sym_return_statement] = STATE(1678),
    [sym_delete_statement] = STATE(1678),
    [sym_raise_statement] = STATE(1678),
    [sym_global_statement] = STATE(1678),
    [sym_nonlocal_statement] = STATE(1678),
    [sym_exec_statement] = STATE(1678),
    [sym__suite] = STATE(1944),
    [sym_expression_list] = STATE(32),
    [sym__expression] = STATE(33),
    [sym__primary_expression] = STATE(34),
    [sym_not_operator] = STATE(33),
    [sym_boolean_operator] = STATE(33),
    [sym_binary_operator] = STATE(34),
    [sym_unary_operator] = STATE(34),
    [sym_comparison_operator] = STATE(33),
    [sym_lambda] = STATE(33),
    [sym_assignment] = STATE(35),
    [sym_augmented_assignment] = STATE(35),
    [sym_yield] = STATE(35),
    [sym_attribute] = STATE(34),
    [sym_subscript] = STATE(34),
    [sym_call] = STATE(34),
    [sym_list] = STATE(34),
    [sym_list_comprehension] = STATE(34),
    [sym_dictionary] = STATE(34),
    [sym_dictionary_comprehension] = STATE(34),
    [sym_set] = STATE(34),
    [sym_set_comprehension] = STATE(34),
    [sym_parenthesized_expression] = STATE(34),
    [sym_tuple] = STATE(34),
    [sym_generator_expression] = STATE(34),
    [sym_conditional_expression] = STATE(33),
    [sym_concatenated_string] = STATE(34),
    [sym_await] = STATE(33),
    [sym__indent] = ACTIONS(3775),
    [anon_sym_import] = ACTIONS(10),
    [anon_sym_from] = ACTIONS(12),
    [anon_sym_LPAREN] = ACTIONS(14),
    [anon_sym_print] = ACTIONS(16),
    [anon_sym_assert] = ACTIONS(18),
    [anon_sym_return] = ACTIONS(20),
    [anon_sym_del] = ACTIONS(22),
    [anon_sym_raise] = ACTIONS(24),
    [sym_pass_statement] = ACTIONS(3777),
    [sym_break_statement] = ACTIONS(3777),
    [sym_continue_statement] = ACTIONS(3777),
    [anon_sym_global] = ACTIONS(42),
    [anon_sym_nonlocal] = ACTIONS(44),
    [anon_sym_exec] = ACTIONS(46),
    [anon_sym_not] = ACTIONS(52),
    [anon_sym_PLUS] = ACTIONS(54),
    [anon_sym_DASH] = ACTIONS(54),
    [anon_sym_TILDE] = ACTIONS(54),
    [anon_sym_lambda] = ACTIONS(56),
    [anon_sym_yield] = ACTIONS(58),
    [anon_sym_LBRACK] = ACTIONS(60),
    [sym_ellipsis] = ACTIONS(62),
    [anon_sym_LBRACE] = ACTIONS(64),
    [sym_string] = ACTIONS(66),
    [sym_integer] = ACTIONS(68),
    [sym_float] = ACTIONS(68),
    [sym_identifier] = ACTIONS(68),
    [sym_true] = ACTIONS(68),
    [sym_false] = ACTIONS(68),
    [sym_none] = ACTIONS(68),
    [anon_sym_await] = ACTIONS(70),
    [sym_comment] = ACTIONS(72),
  },
  [1926] = {
    [sym__dedent] = ACTIONS(4083),
    [anon_sym_import] = ACTIONS(4085),
    [anon_sym_from] = ACTIONS(4085),
    [anon_sym_LPAREN] = ACTIONS(4083),
    [anon_sym_print] = ACTIONS(4085),
    [anon_sym_assert] = ACTIONS(4085),
    [anon_sym_return] = ACTIONS(4085),
    [anon_sym_del] = ACTIONS(4085),
    [anon_sym_raise] = ACTIONS(4085),
    [sym_pass_statement] = ACTIONS(4085),
    [sym_break_statement] = ACTIONS(4085),
    [sym_continue_statement] = ACTIONS(4085),
    [anon_sym_if] = ACTIONS(4085),
    [anon_sym_async] = ACTIONS(4085),
    [anon_sym_for] = ACTIONS(4085),
    [anon_sym_while] = ACTIONS(4085),
    [anon_sym_try] = ACTIONS(4085),
    [anon_sym_with] = ACTIONS(4085),
    [anon_sym_def] = ACTIONS(4085),
    [anon_sym_global] = ACTIONS(4085),
    [anon_sym_nonlocal] = ACTIONS(4085),
    [anon_sym_exec] = ACTIONS(4085),
    [anon_sym_class] = ACTIONS(4085),
    [anon_sym_AT] = ACTIONS(4083),
    [anon_sym_not] = ACTIONS(4085),
    [anon_sym_PLUS] = ACTIONS(4083),
    [anon_sym_DASH] = ACTIONS(4083),
    [anon_sym_TILDE] = ACTIONS(4083),
    [anon_sym_lambda] = ACTIONS(4085),
    [anon_sym_yield] = ACTIONS(4085),
    [anon_sym_LBRACK] = ACTIONS(4083),
    [sym_ellipsis] = ACTIONS(4083),
    [anon_sym_LBRACE] = ACTIONS(4083),
    [sym_string] = ACTIONS(4083),
    [sym_integer] = ACTIONS(4085),
    [sym_float] = ACTIONS(4085),
    [sym_identifier] = ACTIONS(4085),
    [sym_true] = ACTIONS(4085),
    [sym_false] = ACTIONS(4085),
    [sym_none] = ACTIONS(4085),
    [anon_sym_await] = ACTIONS(4085),
    [sym_comment] = ACTIONS(72),
  },
  [1927] = {
    [sym_else_clause] = STATE(1945),
    [sym__dedent] = ACTIONS(4087),
    [anon_sym_import] = ACTIONS(4089),
    [anon_sym_from] = ACTIONS(4089),
    [anon_sym_LPAREN] = ACTIONS(4087),
    [anon_sym_print] = ACTIONS(4089),
    [anon_sym_assert] = ACTIONS(4089),
    [anon_sym_return] = ACTIONS(4089),
    [anon_sym_del] = ACTIONS(4089),
    [anon_sym_raise] = ACTIONS(4089),
    [sym_pass_statement] = ACTIONS(4089),
    [sym_break_statement] = ACTIONS(4089),
    [sym_continue_statement] = ACTIONS(4089),
    [anon_sym_if] = ACTIONS(4089),
    [anon_sym_else] = ACTIONS(4099),
    [anon_sym_async] = ACTIONS(4089),
    [anon_sym_for] = ACTIONS(4089),
    [anon_sym_while] = ACTIONS(4089),
    [anon_sym_try] = ACTIONS(4089),
    [anon_sym_with] = ACTIONS(4089),
    [anon_sym_def] = ACTIONS(4089),
    [anon_sym_global] = ACTIONS(4089),
    [anon_sym_nonlocal] = ACTIONS(4089),
    [anon_sym_exec] = ACTIONS(4089),
    [anon_sym_class] = ACTIONS(4089),
    [anon_sym_AT] = ACTIONS(4087),
    [anon_sym_not] = ACTIONS(4089),
    [anon_sym_PLUS] = ACTIONS(4087),
    [anon_sym_DASH] = ACTIONS(4087),
    [anon_sym_TILDE] = ACTIONS(4087),
    [anon_sym_lambda] = ACTIONS(4089),
    [anon_sym_yield] = ACTIONS(4089),
    [anon_sym_LBRACK] = ACTIONS(4087),
    [sym_ellipsis] = ACTIONS(4087),
    [anon_sym_LBRACE] = ACTIONS(4087),
    [sym_string] = ACTIONS(4087),
    [sym_integer] = ACTIONS(4089),
    [sym_float] = ACTIONS(4089),
    [sym_identifier] = ACTIONS(4089),
    [sym_true] = ACTIONS(4089),
    [sym_false] = ACTIONS(4089),
    [sym_none] = ACTIONS(4089),
    [anon_sym_await] = ACTIONS(4089),
    [sym_comment] = ACTIONS(72),
  },
  [1928] = {
    [sym__simple_statements] = STATE(1946),
    [sym_import_statement] = STATE(746),
    [sym_import_from_statement] = STATE(746),
    [sym_print_statement] = STATE(746),
    [sym_assert_statement] = STATE(746),
    [sym_expression_statement] = STATE(746),
    [sym_return_statement] = STATE(746),
    [sym_delete_statement] = STATE(746),
    [sym_raise_statement] = STATE(746),
    [sym_global_statement] = STATE(746),
    [sym_nonlocal_statement] = STATE(746),
    [sym_exec_statement] = STATE(746),
    [sym__suite] = STATE(1946),
    [sym_expression_list] = STATE(32),
    [sym__expression] = STATE(33),
    [sym__primary_expression] = STATE(34),
    [sym_not_operator] = STATE(33),
    [sym_boolean_operator] = STATE(33),
    [sym_binary_operator] = STATE(34),
    [sym_unary_operator] = STATE(34),
    [sym_comparison_operator] = STATE(33),
    [sym_lambda] = STATE(33),
    [sym_assignment] = STATE(35),
    [sym_augmented_assignment] = STATE(35),
    [sym_yield] = STATE(35),
    [sym_attribute] = STATE(34),
    [sym_subscript] = STATE(34),
    [sym_call] = STATE(34),
    [sym_list] = STATE(34),
    [sym_list_comprehension] = STATE(34),
    [sym_dictionary] = STATE(34),
    [sym_dictionary_comprehension] = STATE(34),
    [sym_set] = STATE(34),
    [sym_set_comprehension] = STATE(34),
    [sym_parenthesized_expression] = STATE(34),
    [sym_tuple] = STATE(34),
    [sym_generator_expression] = STATE(34),
    [sym_conditional_expression] = STATE(33),
    [sym_concatenated_string] = STATE(34),
    [sym_await] = STATE(33),
    [sym__indent] = ACTIONS(3791),
    [anon_sym_import] = ACTIONS(10),
    [anon_sym_from] = ACTIONS(12),
    [anon_sym_LPAREN] = ACTIONS(14),
    [anon_sym_print] = ACTIONS(16),
    [anon_sym_assert] = ACTIONS(18),
    [anon_sym_return] = ACTIONS(20),
    [anon_sym_del] = ACTIONS(22),
    [anon_sym_raise] = ACTIONS(24),
    [sym_pass_statement] = ACTIONS(1498),
    [sym_break_statement] = ACTIONS(1498),
    [sym_continue_statement] = ACTIONS(1498),
    [anon_sym_global] = ACTIONS(42),
    [anon_sym_nonlocal] = ACTIONS(44),
    [anon_sym_exec] = ACTIONS(46),
    [anon_sym_not] = ACTIONS(52),
    [anon_sym_PLUS] = ACTIONS(54),
    [anon_sym_DASH] = ACTIONS(54),
    [anon_sym_TILDE] = ACTIONS(54),
    [anon_sym_lambda] = ACTIONS(56),
    [anon_sym_yield] = ACTIONS(58),
    [anon_sym_LBRACK] = ACTIONS(60),
    [sym_ellipsis] = ACTIONS(62),
    [anon_sym_LBRACE] = ACTIONS(64),
    [sym_string] = ACTIONS(66),
    [sym_integer] = ACTIONS(68),
    [sym_float] = ACTIONS(68),
    [sym_identifier] = ACTIONS(68),
    [sym_true] = ACTIONS(68),
    [sym_false] = ACTIONS(68),
    [sym_none] = ACTIONS(68),
    [anon_sym_await] = ACTIONS(70),
    [sym_comment] = ACTIONS(72),
  },
  [1929] = {
    [sym__dedent] = ACTIONS(4087),
    [anon_sym_import] = ACTIONS(4089),
    [anon_sym_from] = ACTIONS(4089),
    [anon_sym_LPAREN] = ACTIONS(4087),
    [anon_sym_print] = ACTIONS(4089),
    [anon_sym_assert] = ACTIONS(4089),
    [anon_sym_return] = ACTIONS(4089),
    [anon_sym_del] = ACTIONS(4089),
    [anon_sym_raise] = ACTIONS(4089),
    [sym_pass_statement] = ACTIONS(4089),
    [sym_break_statement] = ACTIONS(4089),
    [sym_continue_statement] = ACTIONS(4089),
    [anon_sym_if] = ACTIONS(4089),
    [anon_sym_async] = ACTIONS(4089),
    [anon_sym_for] = ACTIONS(4089),
    [anon_sym_while] = ACTIONS(4089),
    [anon_sym_try] = ACTIONS(4089),
    [anon_sym_with] = ACTIONS(4089),
    [anon_sym_def] = ACTIONS(4089),
    [anon_sym_global] = ACTIONS(4089),
    [anon_sym_nonlocal] = ACTIONS(4089),
    [anon_sym_exec] = ACTIONS(4089),
    [anon_sym_class] = ACTIONS(4089),
    [anon_sym_AT] = ACTIONS(4087),
    [anon_sym_not] = ACTIONS(4089),
    [anon_sym_PLUS] = ACTIONS(4087),
    [anon_sym_DASH] = ACTIONS(4087),
    [anon_sym_TILDE] = ACTIONS(4087),
    [anon_sym_lambda] = ACTIONS(4089),
    [anon_sym_yield] = ACTIONS(4089),
    [anon_sym_LBRACK] = ACTIONS(4087),
    [sym_ellipsis] = ACTIONS(4087),
    [anon_sym_LBRACE] = ACTIONS(4087),
    [sym_string] = ACTIONS(4087),
    [sym_integer] = ACTIONS(4089),
    [sym_float] = ACTIONS(4089),
    [sym_identifier] = ACTIONS(4089),
    [sym_true] = ACTIONS(4089),
    [sym_false] = ACTIONS(4089),
    [sym_none] = ACTIONS(4089),
    [anon_sym_await] = ACTIONS(4089),
    [sym_comment] = ACTIONS(72),
  },
  [1930] = {
    [sym__dedent] = ACTIONS(2319),
    [anon_sym_import] = ACTIONS(2321),
    [anon_sym_from] = ACTIONS(2321),
    [anon_sym_LPAREN] = ACTIONS(2319),
    [anon_sym_print] = ACTIONS(2321),
    [anon_sym_assert] = ACTIONS(2321),
    [anon_sym_return] = ACTIONS(2321),
    [anon_sym_del] = ACTIONS(2321),
    [anon_sym_raise] = ACTIONS(2321),
    [sym_pass_statement] = ACTIONS(2321),
    [sym_break_statement] = ACTIONS(2321),
    [sym_continue_statement] = ACTIONS(2321),
    [anon_sym_if] = ACTIONS(2321),
    [anon_sym_else] = ACTIONS(2321),
    [anon_sym_async] = ACTIONS(2321),
    [anon_sym_for] = ACTIONS(2321),
    [anon_sym_while] = ACTIONS(2321),
    [anon_sym_try] = ACTIONS(2321),
    [anon_sym_with] = ACTIONS(2321),
    [anon_sym_def] = ACTIONS(2321),
    [anon_sym_global] = ACTIONS(2321),
    [anon_sym_nonlocal] = ACTIONS(2321),
    [anon_sym_exec] = ACTIONS(2321),
    [anon_sym_class] = ACTIONS(2321),
    [anon_sym_AT] = ACTIONS(2319),
    [anon_sym_not] = ACTIONS(2321),
    [anon_sym_PLUS] = ACTIONS(2319),
    [anon_sym_DASH] = ACTIONS(2319),
    [anon_sym_TILDE] = ACTIONS(2319),
    [anon_sym_lambda] = ACTIONS(2321),
    [anon_sym_yield] = ACTIONS(2321),
    [anon_sym_LBRACK] = ACTIONS(2319),
    [sym_ellipsis] = ACTIONS(2319),
    [anon_sym_LBRACE] = ACTIONS(2319),
    [sym_string] = ACTIONS(2319),
    [sym_integer] = ACTIONS(2321),
    [sym_float] = ACTIONS(2321),
    [sym_identifier] = ACTIONS(2321),
    [sym_true] = ACTIONS(2321),
    [sym_false] = ACTIONS(2321),
    [sym_none] = ACTIONS(2321),
    [anon_sym_await] = ACTIONS(2321),
    [sym_comment] = ACTIONS(72),
  },
  [1931] = {
    [sym__dedent] = ACTIONS(2388),
    [anon_sym_import] = ACTIONS(2390),
    [anon_sym_from] = ACTIONS(2390),
    [anon_sym_LPAREN] = ACTIONS(2388),
    [anon_sym_print] = ACTIONS(2390),
    [anon_sym_assert] = ACTIONS(2390),
    [anon_sym_return] = ACTIONS(2390),
    [anon_sym_del] = ACTIONS(2390),
    [anon_sym_raise] = ACTIONS(2390),
    [sym_pass_statement] = ACTIONS(2390),
    [sym_break_statement] = ACTIONS(2390),
    [sym_continue_statement] = ACTIONS(2390),
    [anon_sym_if] = ACTIONS(2390),
    [anon_sym_else] = ACTIONS(2390),
    [anon_sym_async] = ACTIONS(2390),
    [anon_sym_for] = ACTIONS(2390),
    [anon_sym_while] = ACTIONS(2390),
    [anon_sym_try] = ACTIONS(2390),
    [anon_sym_except] = ACTIONS(2390),
    [anon_sym_finally] = ACTIONS(2390),
    [anon_sym_with] = ACTIONS(2390),
    [anon_sym_def] = ACTIONS(2390),
    [anon_sym_global] = ACTIONS(2390),
    [anon_sym_nonlocal] = ACTIONS(2390),
    [anon_sym_exec] = ACTIONS(2390),
    [anon_sym_class] = ACTIONS(2390),
    [anon_sym_AT] = ACTIONS(2388),
    [anon_sym_not] = ACTIONS(2390),
    [anon_sym_PLUS] = ACTIONS(2388),
    [anon_sym_DASH] = ACTIONS(2388),
    [anon_sym_TILDE] = ACTIONS(2388),
    [anon_sym_lambda] = ACTIONS(2390),
    [anon_sym_yield] = ACTIONS(2390),
    [anon_sym_LBRACK] = ACTIONS(2388),
    [sym_ellipsis] = ACTIONS(2388),
    [anon_sym_LBRACE] = ACTIONS(2388),
    [sym_string] = ACTIONS(2388),
    [sym_integer] = ACTIONS(2390),
    [sym_float] = ACTIONS(2390),
    [sym_identifier] = ACTIONS(2390),
    [sym_true] = ACTIONS(2390),
    [sym_false] = ACTIONS(2390),
    [sym_none] = ACTIONS(2390),
    [anon_sym_await] = ACTIONS(2390),
    [sym_comment] = ACTIONS(72),
  },
  [1932] = {
    [sym__statement] = STATE(1155),
    [sym__simple_statements] = STATE(1155),
    [sym_import_statement] = STATE(746),
    [sym_import_from_statement] = STATE(746),
    [sym_print_statement] = STATE(746),
    [sym_assert_statement] = STATE(746),
    [sym_expression_statement] = STATE(746),
    [sym_return_statement] = STATE(746),
    [sym_delete_statement] = STATE(746),
    [sym_raise_statement] = STATE(746),
    [sym_if_statement] = STATE(1155),
    [sym_for_statement] = STATE(1155),
    [sym_while_statement] = STATE(1155),
    [sym_try_statement] = STATE(1155),
    [sym_with_statement] = STATE(1155),
    [sym_function_definition] = STATE(1155),
    [sym_global_statement] = STATE(746),
    [sym_nonlocal_statement] = STATE(746),
    [sym_exec_statement] = STATE(746),
    [sym_class_definition] = STATE(1155),
    [sym_decorated_definition] = STATE(1155),
    [sym_decorator] = STATE(756),
    [sym_expression_list] = STATE(32),
    [sym__expression] = STATE(33),
    [sym__primary_expression] = STATE(34),
    [sym_not_operator] = STATE(33),
    [sym_boolean_operator] = STATE(33),
    [sym_binary_operator] = STATE(34),
    [sym_unary_operator] = STATE(34),
    [sym_comparison_operator] = STATE(33),
    [sym_lambda] = STATE(33),
    [sym_assignment] = STATE(35),
    [sym_augmented_assignment] = STATE(35),
    [sym_yield] = STATE(35),
    [sym_attribute] = STATE(34),
    [sym_subscript] = STATE(34),
    [sym_call] = STATE(34),
    [sym_list] = STATE(34),
    [sym_list_comprehension] = STATE(34),
    [sym_dictionary] = STATE(34),
    [sym_dictionary_comprehension] = STATE(34),
    [sym_set] = STATE(34),
    [sym_set_comprehension] = STATE(34),
    [sym_parenthesized_expression] = STATE(34),
    [sym_tuple] = STATE(34),
    [sym_generator_expression] = STATE(34),
    [sym_conditional_expression] = STATE(33),
    [sym_concatenated_string] = STATE(34),
    [sym_await] = STATE(33),
    [aux_sym_module_repeat1] = STATE(1155),
    [aux_sym_decorated_definition_repeat1] = STATE(756),
    [sym__dedent] = ACTIONS(4384),
    [anon_sym_import] = ACTIONS(10),
    [anon_sym_from] = ACTIONS(12),
    [anon_sym_LPAREN] = ACTIONS(14),
    [anon_sym_print] = ACTIONS(16),
    [anon_sym_assert] = ACTIONS(18),
    [anon_sym_return] = ACTIONS(20),
    [anon_sym_del] = ACTIONS(22),
    [anon_sym_raise] = ACTIONS(24),
    [sym_pass_statement] = ACTIONS(1498),
    [sym_break_statement] = ACTIONS(1498),
    [sym_continue_statement] = ACTIONS(1498),
    [anon_sym_if] = ACTIONS(1500),
    [anon_sym_async] = ACTIONS(1502),
    [anon_sym_for] = ACTIONS(1504),
    [anon_sym_while] = ACTIONS(1506),
    [anon_sym_try] = ACTIONS(1508),
    [anon_sym_with] = ACTIONS(1510),
    [anon_sym_def] = ACTIONS(1512),
    [anon_sym_global] = ACTIONS(42),
    [anon_sym_nonlocal] = ACTIONS(44),
    [anon_sym_exec] = ACTIONS(46),
    [anon_sym_class] = ACTIONS(1514),
    [anon_sym_AT] = ACTIONS(50),
    [anon_sym_not] = ACTIONS(52),
    [anon_sym_PLUS] = ACTIONS(54),
    [anon_sym_DASH] = ACTIONS(54),
    [anon_sym_TILDE] = ACTIONS(54),
    [anon_sym_lambda] = ACTIONS(56),
    [anon_sym_yield] = ACTIONS(58),
    [anon_sym_LBRACK] = ACTIONS(60),
    [sym_ellipsis] = ACTIONS(62),
    [anon_sym_LBRACE] = ACTIONS(64),
    [sym_string] = ACTIONS(66),
    [sym_integer] = ACTIONS(68),
    [sym_float] = ACTIONS(68),
    [sym_identifier] = ACTIONS(68),
    [sym_true] = ACTIONS(68),
    [sym_false] = ACTIONS(68),
    [sym_none] = ACTIONS(68),
    [anon_sym_await] = ACTIONS(70),
    [sym_comment] = ACTIONS(72),
  },
  [1933] = {
    [sym__dedent] = ACTIONS(576),
    [anon_sym_import] = ACTIONS(578),
    [anon_sym_from] = ACTIONS(578),
    [anon_sym_LPAREN] = ACTIONS(576),
    [anon_sym_print] = ACTIONS(578),
    [anon_sym_assert] = ACTIONS(578),
    [anon_sym_return] = ACTIONS(578),
    [anon_sym_del] = ACTIONS(578),
    [anon_sym_raise] = ACTIONS(578),
    [sym_pass_statement] = ACTIONS(578),
    [sym_break_statement] = ACTIONS(578),
    [sym_continue_statement] = ACTIONS(578),
    [anon_sym_if] = ACTIONS(578),
    [anon_sym_else] = ACTIONS(578),
    [anon_sym_async] = ACTIONS(578),
    [anon_sym_for] = ACTIONS(578),
    [anon_sym_while] = ACTIONS(578),
    [anon_sym_try] = ACTIONS(578),
    [anon_sym_except] = ACTIONS(578),
    [anon_sym_finally] = ACTIONS(578),
    [anon_sym_with] = ACTIONS(578),
    [anon_sym_def] = ACTIONS(578),
    [anon_sym_global] = ACTIONS(578),
    [anon_sym_nonlocal] = ACTIONS(578),
    [anon_sym_exec] = ACTIONS(578),
    [anon_sym_class] = ACTIONS(578),
    [anon_sym_AT] = ACTIONS(576),
    [anon_sym_not] = ACTIONS(578),
    [anon_sym_PLUS] = ACTIONS(576),
    [anon_sym_DASH] = ACTIONS(576),
    [anon_sym_TILDE] = ACTIONS(576),
    [anon_sym_lambda] = ACTIONS(578),
    [anon_sym_yield] = ACTIONS(578),
    [anon_sym_LBRACK] = ACTIONS(576),
    [sym_ellipsis] = ACTIONS(576),
    [anon_sym_LBRACE] = ACTIONS(576),
    [sym_string] = ACTIONS(576),
    [sym_integer] = ACTIONS(578),
    [sym_float] = ACTIONS(578),
    [sym_identifier] = ACTIONS(578),
    [sym_true] = ACTIONS(578),
    [sym_false] = ACTIONS(578),
    [sym_none] = ACTIONS(578),
    [anon_sym_await] = ACTIONS(578),
    [sym_comment] = ACTIONS(72),
  },
  [1934] = {
    [sym_import_statement] = STATE(326),
    [sym_import_from_statement] = STATE(326),
    [sym_print_statement] = STATE(326),
    [sym_assert_statement] = STATE(326),
    [sym_expression_statement] = STATE(326),
    [sym_return_statement] = STATE(326),
    [sym_delete_statement] = STATE(326),
    [sym_raise_statement] = STATE(326),
    [sym_global_statement] = STATE(326),
    [sym_nonlocal_statement] = STATE(326),
    [sym_exec_statement] = STATE(326),
    [sym_expression_list] = STATE(32),
    [sym__expression] = STATE(33),
    [sym__primary_expression] = STATE(34),
    [sym_not_operator] = STATE(33),
    [sym_boolean_operator] = STATE(33),
    [sym_binary_operator] = STATE(34),
    [sym_unary_operator] = STATE(34),
    [sym_comparison_operator] = STATE(33),
    [sym_lambda] = STATE(33),
    [sym_assignment] = STATE(35),
    [sym_augmented_assignment] = STATE(35),
    [sym_yield] = STATE(35),
    [sym_attribute] = STATE(34),
    [sym_subscript] = STATE(34),
    [sym_call] = STATE(34),
    [sym_list] = STATE(34),
    [sym_list_comprehension] = STATE(34),
    [sym_dictionary] = STATE(34),
    [sym_dictionary_comprehension] = STATE(34),
    [sym_set] = STATE(34),
    [sym_set_comprehension] = STATE(34),
    [sym_parenthesized_expression] = STATE(34),
    [sym_tuple] = STATE(34),
    [sym_generator_expression] = STATE(34),
    [sym_conditional_expression] = STATE(33),
    [sym_concatenated_string] = STATE(34),
    [sym_await] = STATE(33),
    [sym__newline] = ACTIONS(4386),
    [anon_sym_import] = ACTIONS(10),
    [anon_sym_from] = ACTIONS(12),
    [anon_sym_LPAREN] = ACTIONS(14),
    [anon_sym_print] = ACTIONS(16),
    [anon_sym_assert] = ACTIONS(18),
    [anon_sym_return] = ACTIONS(20),
    [anon_sym_del] = ACTIONS(22),
    [anon_sym_raise] = ACTIONS(24),
    [sym_pass_statement] = ACTIONS(582),
    [sym_break_statement] = ACTIONS(582),
    [sym_continue_statement] = ACTIONS(582),
    [anon_sym_global] = ACTIONS(42),
    [anon_sym_nonlocal] = ACTIONS(44),
    [anon_sym_exec] = ACTIONS(46),
    [anon_sym_not] = ACTIONS(52),
    [anon_sym_PLUS] = ACTIONS(54),
    [anon_sym_DASH] = ACTIONS(54),
    [anon_sym_TILDE] = ACTIONS(54),
    [anon_sym_lambda] = ACTIONS(56),
    [anon_sym_yield] = ACTIONS(58),
    [anon_sym_LBRACK] = ACTIONS(60),
    [sym_ellipsis] = ACTIONS(62),
    [anon_sym_LBRACE] = ACTIONS(64),
    [sym_string] = ACTIONS(66),
    [sym_integer] = ACTIONS(68),
    [sym_float] = ACTIONS(68),
    [sym_identifier] = ACTIONS(68),
    [sym_true] = ACTIONS(68),
    [sym_false] = ACTIONS(68),
    [sym_none] = ACTIONS(68),
    [anon_sym_await] = ACTIONS(70),
    [sym_comment] = ACTIONS(72),
  },
  [1935] = {
    [aux_sym__simple_statements_repeat1] = STATE(328),
    [sym__newline] = ACTIONS(4386),
    [sym_comment] = ACTIONS(72),
    [sym__semicolon] = ACTIONS(4388),
  },
  [1936] = {
    [anon_sym_if] = ACTIONS(590),
    [anon_sym_COLON] = ACTIONS(4390),
    [anon_sym_and] = ACTIONS(594),
    [anon_sym_or] = ACTIONS(596),
    [sym_comment] = ACTIONS(72),
  },
  [1937] = {
    [sym__dedent] = ACTIONS(4129),
    [anon_sym_import] = ACTIONS(4131),
    [anon_sym_from] = ACTIONS(4131),
    [anon_sym_LPAREN] = ACTIONS(4129),
    [anon_sym_print] = ACTIONS(4131),
    [anon_sym_assert] = ACTIONS(4131),
    [anon_sym_return] = ACTIONS(4131),
    [anon_sym_del] = ACTIONS(4131),
    [anon_sym_raise] = ACTIONS(4131),
    [sym_pass_statement] = ACTIONS(4131),
    [sym_break_statement] = ACTIONS(4131),
    [sym_continue_statement] = ACTIONS(4131),
    [anon_sym_if] = ACTIONS(4131),
    [anon_sym_else] = ACTIONS(4131),
    [anon_sym_async] = ACTIONS(4131),
    [anon_sym_for] = ACTIONS(4131),
    [anon_sym_while] = ACTIONS(4131),
    [anon_sym_try] = ACTIONS(4131),
    [anon_sym_except] = ACTIONS(4131),
    [anon_sym_finally] = ACTIONS(4131),
    [anon_sym_with] = ACTIONS(4131),
    [anon_sym_def] = ACTIONS(4131),
    [anon_sym_global] = ACTIONS(4131),
    [anon_sym_nonlocal] = ACTIONS(4131),
    [anon_sym_exec] = ACTIONS(4131),
    [anon_sym_class] = ACTIONS(4131),
    [anon_sym_AT] = ACTIONS(4129),
    [anon_sym_not] = ACTIONS(4131),
    [anon_sym_PLUS] = ACTIONS(4129),
    [anon_sym_DASH] = ACTIONS(4129),
    [anon_sym_TILDE] = ACTIONS(4129),
    [anon_sym_lambda] = ACTIONS(4131),
    [anon_sym_yield] = ACTIONS(4131),
    [anon_sym_LBRACK] = ACTIONS(4129),
    [sym_ellipsis] = ACTIONS(4129),
    [anon_sym_LBRACE] = ACTIONS(4129),
    [sym_string] = ACTIONS(4129),
    [sym_integer] = ACTIONS(4131),
    [sym_float] = ACTIONS(4131),
    [sym_identifier] = ACTIONS(4131),
    [sym_true] = ACTIONS(4131),
    [sym_false] = ACTIONS(4131),
    [sym_none] = ACTIONS(4131),
    [anon_sym_await] = ACTIONS(4131),
    [sym_comment] = ACTIONS(72),
  },
  [1938] = {
    [sym__statement] = STATE(1952),
    [sym__simple_statements] = STATE(1952),
    [sym_import_statement] = STATE(746),
    [sym_import_from_statement] = STATE(746),
    [sym_print_statement] = STATE(746),
    [sym_assert_statement] = STATE(746),
    [sym_expression_statement] = STATE(746),
    [sym_return_statement] = STATE(746),
    [sym_delete_statement] = STATE(746),
    [sym_raise_statement] = STATE(746),
    [sym_if_statement] = STATE(1952),
    [sym_for_statement] = STATE(1952),
    [sym_while_statement] = STATE(1952),
    [sym_try_statement] = STATE(1952),
    [sym_with_statement] = STATE(1952),
    [sym_function_definition] = STATE(1952),
    [sym_global_statement] = STATE(746),
    [sym_nonlocal_statement] = STATE(746),
    [sym_exec_statement] = STATE(746),
    [sym_class_definition] = STATE(1952),
    [sym_decorated_definition] = STATE(1952),
    [sym_decorator] = STATE(756),
    [sym_expression_list] = STATE(32),
    [sym__expression] = STATE(33),
    [sym__primary_expression] = STATE(34),
    [sym_not_operator] = STATE(33),
    [sym_boolean_operator] = STATE(33),
    [sym_binary_operator] = STATE(34),
    [sym_unary_operator] = STATE(34),
    [sym_comparison_operator] = STATE(33),
    [sym_lambda] = STATE(33),
    [sym_assignment] = STATE(35),
    [sym_augmented_assignment] = STATE(35),
    [sym_yield] = STATE(35),
    [sym_attribute] = STATE(34),
    [sym_subscript] = STATE(34),
    [sym_call] = STATE(34),
    [sym_list] = STATE(34),
    [sym_list_comprehension] = STATE(34),
    [sym_dictionary] = STATE(34),
    [sym_dictionary_comprehension] = STATE(34),
    [sym_set] = STATE(34),
    [sym_set_comprehension] = STATE(34),
    [sym_parenthesized_expression] = STATE(34),
    [sym_tuple] = STATE(34),
    [sym_generator_expression] = STATE(34),
    [sym_conditional_expression] = STATE(33),
    [sym_concatenated_string] = STATE(34),
    [sym_await] = STATE(33),
    [aux_sym_module_repeat1] = STATE(1952),
    [aux_sym_decorated_definition_repeat1] = STATE(756),
    [sym__dedent] = ACTIONS(4392),
    [anon_sym_import] = ACTIONS(10),
    [anon_sym_from] = ACTIONS(12),
    [anon_sym_LPAREN] = ACTIONS(14),
    [anon_sym_print] = ACTIONS(16),
    [anon_sym_assert] = ACTIONS(18),
    [anon_sym_return] = ACTIONS(20),
    [anon_sym_del] = ACTIONS(22),
    [anon_sym_raise] = ACTIONS(24),
    [sym_pass_statement] = ACTIONS(1498),
    [sym_break_statement] = ACTIONS(1498),
    [sym_continue_statement] = ACTIONS(1498),
    [anon_sym_if] = ACTIONS(1500),
    [anon_sym_async] = ACTIONS(1502),
    [anon_sym_for] = ACTIONS(1504),
    [anon_sym_while] = ACTIONS(1506),
    [anon_sym_try] = ACTIONS(1508),
    [anon_sym_with] = ACTIONS(1510),
    [anon_sym_def] = ACTIONS(1512),
    [anon_sym_global] = ACTIONS(42),
    [anon_sym_nonlocal] = ACTIONS(44),
    [anon_sym_exec] = ACTIONS(46),
    [anon_sym_class] = ACTIONS(1514),
    [anon_sym_AT] = ACTIONS(50),
    [anon_sym_not] = ACTIONS(52),
    [anon_sym_PLUS] = ACTIONS(54),
    [anon_sym_DASH] = ACTIONS(54),
    [anon_sym_TILDE] = ACTIONS(54),
    [anon_sym_lambda] = ACTIONS(56),
    [anon_sym_yield] = ACTIONS(58),
    [anon_sym_LBRACK] = ACTIONS(60),
    [sym_ellipsis] = ACTIONS(62),
    [anon_sym_LBRACE] = ACTIONS(64),
    [sym_string] = ACTIONS(66),
    [sym_integer] = ACTIONS(68),
    [sym_float] = ACTIONS(68),
    [sym_identifier] = ACTIONS(68),
    [sym_true] = ACTIONS(68),
    [sym_false] = ACTIONS(68),
    [sym_none] = ACTIONS(68),
    [anon_sym_await] = ACTIONS(70),
    [sym_comment] = ACTIONS(72),
  },
  [1939] = {
    [aux_sym__simple_statements_repeat1] = STATE(1955),
    [sym__newline] = ACTIONS(4394),
    [sym_comment] = ACTIONS(72),
    [sym__semicolon] = ACTIONS(4396),
  },
  [1940] = {
    [sym__dedent] = ACTIONS(4083),
    [anon_sym_import] = ACTIONS(4085),
    [anon_sym_from] = ACTIONS(4085),
    [anon_sym_LPAREN] = ACTIONS(4083),
    [anon_sym_print] = ACTIONS(4085),
    [anon_sym_assert] = ACTIONS(4085),
    [anon_sym_return] = ACTIONS(4085),
    [anon_sym_del] = ACTIONS(4085),
    [anon_sym_raise] = ACTIONS(4085),
    [sym_pass_statement] = ACTIONS(4085),
    [sym_break_statement] = ACTIONS(4085),
    [sym_continue_statement] = ACTIONS(4085),
    [anon_sym_if] = ACTIONS(4085),
    [anon_sym_async] = ACTIONS(4085),
    [anon_sym_for] = ACTIONS(4085),
    [anon_sym_while] = ACTIONS(4085),
    [anon_sym_try] = ACTIONS(4085),
    [anon_sym_finally] = ACTIONS(4085),
    [anon_sym_with] = ACTIONS(4085),
    [anon_sym_def] = ACTIONS(4085),
    [anon_sym_global] = ACTIONS(4085),
    [anon_sym_nonlocal] = ACTIONS(4085),
    [anon_sym_exec] = ACTIONS(4085),
    [anon_sym_class] = ACTIONS(4085),
    [anon_sym_AT] = ACTIONS(4083),
    [anon_sym_not] = ACTIONS(4085),
    [anon_sym_PLUS] = ACTIONS(4083),
    [anon_sym_DASH] = ACTIONS(4083),
    [anon_sym_TILDE] = ACTIONS(4083),
    [anon_sym_lambda] = ACTIONS(4085),
    [anon_sym_yield] = ACTIONS(4085),
    [anon_sym_LBRACK] = ACTIONS(4083),
    [sym_ellipsis] = ACTIONS(4083),
    [anon_sym_LBRACE] = ACTIONS(4083),
    [sym_string] = ACTIONS(4083),
    [sym_integer] = ACTIONS(4085),
    [sym_float] = ACTIONS(4085),
    [sym_identifier] = ACTIONS(4085),
    [sym_true] = ACTIONS(4085),
    [sym_false] = ACTIONS(4085),
    [sym_none] = ACTIONS(4085),
    [anon_sym_await] = ACTIONS(4085),
    [sym_comment] = ACTIONS(72),
  },
  [1941] = {
    [sym__dedent] = ACTIONS(4196),
    [anon_sym_import] = ACTIONS(4198),
    [anon_sym_from] = ACTIONS(4198),
    [anon_sym_LPAREN] = ACTIONS(4196),
    [anon_sym_print] = ACTIONS(4198),
    [anon_sym_assert] = ACTIONS(4198),
    [anon_sym_return] = ACTIONS(4198),
    [anon_sym_del] = ACTIONS(4198),
    [anon_sym_raise] = ACTIONS(4198),
    [sym_pass_statement] = ACTIONS(4198),
    [sym_break_statement] = ACTIONS(4198),
    [sym_continue_statement] = ACTIONS(4198),
    [anon_sym_if] = ACTIONS(4198),
    [anon_sym_async] = ACTIONS(4198),
    [anon_sym_for] = ACTIONS(4198),
    [anon_sym_while] = ACTIONS(4198),
    [anon_sym_try] = ACTIONS(4198),
    [anon_sym_with] = ACTIONS(4198),
    [anon_sym_def] = ACTIONS(4198),
    [anon_sym_global] = ACTIONS(4198),
    [anon_sym_nonlocal] = ACTIONS(4198),
    [anon_sym_exec] = ACTIONS(4198),
    [anon_sym_class] = ACTIONS(4198),
    [anon_sym_AT] = ACTIONS(4196),
    [anon_sym_not] = ACTIONS(4198),
    [anon_sym_PLUS] = ACTIONS(4196),
    [anon_sym_DASH] = ACTIONS(4196),
    [anon_sym_TILDE] = ACTIONS(4196),
    [anon_sym_lambda] = ACTIONS(4198),
    [anon_sym_yield] = ACTIONS(4198),
    [anon_sym_LBRACK] = ACTIONS(4196),
    [sym_ellipsis] = ACTIONS(4196),
    [anon_sym_LBRACE] = ACTIONS(4196),
    [sym_string] = ACTIONS(4196),
    [sym_integer] = ACTIONS(4198),
    [sym_float] = ACTIONS(4198),
    [sym_identifier] = ACTIONS(4198),
    [sym_true] = ACTIONS(4198),
    [sym_false] = ACTIONS(4198),
    [sym_none] = ACTIONS(4198),
    [anon_sym_await] = ACTIONS(4198),
    [sym_comment] = ACTIONS(72),
  },
  [1942] = {
    [ts_builtin_sym_end] = ACTIONS(2319),
    [anon_sym_import] = ACTIONS(2321),
    [anon_sym_from] = ACTIONS(2321),
    [anon_sym_LPAREN] = ACTIONS(2319),
    [anon_sym_print] = ACTIONS(2321),
    [anon_sym_assert] = ACTIONS(2321),
    [anon_sym_return] = ACTIONS(2321),
    [anon_sym_del] = ACTIONS(2321),
    [anon_sym_raise] = ACTIONS(2321),
    [sym_pass_statement] = ACTIONS(2321),
    [sym_break_statement] = ACTIONS(2321),
    [sym_continue_statement] = ACTIONS(2321),
    [anon_sym_if] = ACTIONS(2321),
    [anon_sym_async] = ACTIONS(2321),
    [anon_sym_for] = ACTIONS(2321),
    [anon_sym_while] = ACTIONS(2321),
    [anon_sym_try] = ACTIONS(2321),
    [anon_sym_finally] = ACTIONS(2321),
    [anon_sym_with] = ACTIONS(2321),
    [anon_sym_def] = ACTIONS(2321),
    [anon_sym_global] = ACTIONS(2321),
    [anon_sym_nonlocal] = ACTIONS(2321),
    [anon_sym_exec] = ACTIONS(2321),
    [anon_sym_class] = ACTIONS(2321),
    [anon_sym_AT] = ACTIONS(2319),
    [anon_sym_not] = ACTIONS(2321),
    [anon_sym_PLUS] = ACTIONS(2319),
    [anon_sym_DASH] = ACTIONS(2319),
    [anon_sym_TILDE] = ACTIONS(2319),
    [anon_sym_lambda] = ACTIONS(2321),
    [anon_sym_yield] = ACTIONS(2321),
    [anon_sym_LBRACK] = ACTIONS(2319),
    [sym_ellipsis] = ACTIONS(2319),
    [anon_sym_LBRACE] = ACTIONS(2319),
    [sym_string] = ACTIONS(2319),
    [sym_integer] = ACTIONS(2321),
    [sym_float] = ACTIONS(2321),
    [sym_identifier] = ACTIONS(2321),
    [sym_true] = ACTIONS(2321),
    [sym_false] = ACTIONS(2321),
    [sym_none] = ACTIONS(2321),
    [anon_sym_await] = ACTIONS(2321),
    [sym_comment] = ACTIONS(72),
  },
  [1943] = {
    [anon_sym_RPAREN] = ACTIONS(3610),
    [anon_sym_COMMA] = ACTIONS(3610),
    [anon_sym_if] = ACTIONS(3860),
    [anon_sym_EQ] = ACTIONS(3610),
    [anon_sym_and] = ACTIONS(3862),
    [anon_sym_or] = ACTIONS(3864),
    [sym_comment] = ACTIONS(72),
  },
  [1944] = {
    [sym__dedent] = ACTIONS(4269),
    [anon_sym_import] = ACTIONS(4271),
    [anon_sym_from] = ACTIONS(4271),
    [anon_sym_LPAREN] = ACTIONS(4269),
    [anon_sym_print] = ACTIONS(4271),
    [anon_sym_assert] = ACTIONS(4271),
    [anon_sym_return] = ACTIONS(4271),
    [anon_sym_del] = ACTIONS(4271),
    [anon_sym_raise] = ACTIONS(4271),
    [sym_pass_statement] = ACTIONS(4271),
    [sym_break_statement] = ACTIONS(4271),
    [sym_continue_statement] = ACTIONS(4271),
    [anon_sym_if] = ACTIONS(4271),
    [anon_sym_elif] = ACTIONS(4271),
    [anon_sym_else] = ACTIONS(4271),
    [anon_sym_async] = ACTIONS(4271),
    [anon_sym_for] = ACTIONS(4271),
    [anon_sym_while] = ACTIONS(4271),
    [anon_sym_try] = ACTIONS(4271),
    [anon_sym_with] = ACTIONS(4271),
    [anon_sym_def] = ACTIONS(4271),
    [anon_sym_global] = ACTIONS(4271),
    [anon_sym_nonlocal] = ACTIONS(4271),
    [anon_sym_exec] = ACTIONS(4271),
    [anon_sym_class] = ACTIONS(4271),
    [anon_sym_AT] = ACTIONS(4269),
    [anon_sym_not] = ACTIONS(4271),
    [anon_sym_PLUS] = ACTIONS(4269),
    [anon_sym_DASH] = ACTIONS(4269),
    [anon_sym_TILDE] = ACTIONS(4269),
    [anon_sym_lambda] = ACTIONS(4271),
    [anon_sym_yield] = ACTIONS(4271),
    [anon_sym_LBRACK] = ACTIONS(4269),
    [sym_ellipsis] = ACTIONS(4269),
    [anon_sym_LBRACE] = ACTIONS(4269),
    [sym_string] = ACTIONS(4269),
    [sym_integer] = ACTIONS(4271),
    [sym_float] = ACTIONS(4271),
    [sym_identifier] = ACTIONS(4271),
    [sym_true] = ACTIONS(4271),
    [sym_false] = ACTIONS(4271),
    [sym_none] = ACTIONS(4271),
    [anon_sym_await] = ACTIONS(4271),
    [sym_comment] = ACTIONS(72),
  },
  [1945] = {
    [sym__dedent] = ACTIONS(4273),
    [anon_sym_import] = ACTIONS(4275),
    [anon_sym_from] = ACTIONS(4275),
    [anon_sym_LPAREN] = ACTIONS(4273),
    [anon_sym_print] = ACTIONS(4275),
    [anon_sym_assert] = ACTIONS(4275),
    [anon_sym_return] = ACTIONS(4275),
    [anon_sym_del] = ACTIONS(4275),
    [anon_sym_raise] = ACTIONS(4275),
    [sym_pass_statement] = ACTIONS(4275),
    [sym_break_statement] = ACTIONS(4275),
    [sym_continue_statement] = ACTIONS(4275),
    [anon_sym_if] = ACTIONS(4275),
    [anon_sym_async] = ACTIONS(4275),
    [anon_sym_for] = ACTIONS(4275),
    [anon_sym_while] = ACTIONS(4275),
    [anon_sym_try] = ACTIONS(4275),
    [anon_sym_with] = ACTIONS(4275),
    [anon_sym_def] = ACTIONS(4275),
    [anon_sym_global] = ACTIONS(4275),
    [anon_sym_nonlocal] = ACTIONS(4275),
    [anon_sym_exec] = ACTIONS(4275),
    [anon_sym_class] = ACTIONS(4275),
    [anon_sym_AT] = ACTIONS(4273),
    [anon_sym_not] = ACTIONS(4275),
    [anon_sym_PLUS] = ACTIONS(4273),
    [anon_sym_DASH] = ACTIONS(4273),
    [anon_sym_TILDE] = ACTIONS(4273),
    [anon_sym_lambda] = ACTIONS(4275),
    [anon_sym_yield] = ACTIONS(4275),
    [anon_sym_LBRACK] = ACTIONS(4273),
    [sym_ellipsis] = ACTIONS(4273),
    [anon_sym_LBRACE] = ACTIONS(4273),
    [sym_string] = ACTIONS(4273),
    [sym_integer] = ACTIONS(4275),
    [sym_float] = ACTIONS(4275),
    [sym_identifier] = ACTIONS(4275),
    [sym_true] = ACTIONS(4275),
    [sym_false] = ACTIONS(4275),
    [sym_none] = ACTIONS(4275),
    [anon_sym_await] = ACTIONS(4275),
    [sym_comment] = ACTIONS(72),
  },
  [1946] = {
    [sym__dedent] = ACTIONS(4277),
    [anon_sym_import] = ACTIONS(4279),
    [anon_sym_from] = ACTIONS(4279),
    [anon_sym_LPAREN] = ACTIONS(4277),
    [anon_sym_print] = ACTIONS(4279),
    [anon_sym_assert] = ACTIONS(4279),
    [anon_sym_return] = ACTIONS(4279),
    [anon_sym_del] = ACTIONS(4279),
    [anon_sym_raise] = ACTIONS(4279),
    [sym_pass_statement] = ACTIONS(4279),
    [sym_break_statement] = ACTIONS(4279),
    [sym_continue_statement] = ACTIONS(4279),
    [anon_sym_if] = ACTIONS(4279),
    [anon_sym_async] = ACTIONS(4279),
    [anon_sym_for] = ACTIONS(4279),
    [anon_sym_while] = ACTIONS(4279),
    [anon_sym_try] = ACTIONS(4279),
    [anon_sym_with] = ACTIONS(4279),
    [anon_sym_def] = ACTIONS(4279),
    [anon_sym_global] = ACTIONS(4279),
    [anon_sym_nonlocal] = ACTIONS(4279),
    [anon_sym_exec] = ACTIONS(4279),
    [anon_sym_class] = ACTIONS(4279),
    [anon_sym_AT] = ACTIONS(4277),
    [anon_sym_not] = ACTIONS(4279),
    [anon_sym_PLUS] = ACTIONS(4277),
    [anon_sym_DASH] = ACTIONS(4277),
    [anon_sym_TILDE] = ACTIONS(4277),
    [anon_sym_lambda] = ACTIONS(4279),
    [anon_sym_yield] = ACTIONS(4279),
    [anon_sym_LBRACK] = ACTIONS(4277),
    [sym_ellipsis] = ACTIONS(4277),
    [anon_sym_LBRACE] = ACTIONS(4277),
    [sym_string] = ACTIONS(4277),
    [sym_integer] = ACTIONS(4279),
    [sym_float] = ACTIONS(4279),
    [sym_identifier] = ACTIONS(4279),
    [sym_true] = ACTIONS(4279),
    [sym_false] = ACTIONS(4279),
    [sym_none] = ACTIONS(4279),
    [anon_sym_await] = ACTIONS(4279),
    [sym_comment] = ACTIONS(72),
  },
  [1947] = {
    [sym__dedent] = ACTIONS(3187),
    [anon_sym_import] = ACTIONS(3189),
    [anon_sym_from] = ACTIONS(3189),
    [anon_sym_LPAREN] = ACTIONS(3187),
    [anon_sym_print] = ACTIONS(3189),
    [anon_sym_assert] = ACTIONS(3189),
    [anon_sym_return] = ACTIONS(3189),
    [anon_sym_del] = ACTIONS(3189),
    [anon_sym_raise] = ACTIONS(3189),
    [sym_pass_statement] = ACTIONS(3189),
    [sym_break_statement] = ACTIONS(3189),
    [sym_continue_statement] = ACTIONS(3189),
    [anon_sym_if] = ACTIONS(3189),
    [anon_sym_else] = ACTIONS(3189),
    [anon_sym_async] = ACTIONS(3189),
    [anon_sym_for] = ACTIONS(3189),
    [anon_sym_while] = ACTIONS(3189),
    [anon_sym_try] = ACTIONS(3189),
    [anon_sym_except] = ACTIONS(3189),
    [anon_sym_finally] = ACTIONS(3189),
    [anon_sym_with] = ACTIONS(3189),
    [anon_sym_def] = ACTIONS(3189),
    [anon_sym_global] = ACTIONS(3189),
    [anon_sym_nonlocal] = ACTIONS(3189),
    [anon_sym_exec] = ACTIONS(3189),
    [anon_sym_class] = ACTIONS(3189),
    [anon_sym_AT] = ACTIONS(3187),
    [anon_sym_not] = ACTIONS(3189),
    [anon_sym_PLUS] = ACTIONS(3187),
    [anon_sym_DASH] = ACTIONS(3187),
    [anon_sym_TILDE] = ACTIONS(3187),
    [anon_sym_lambda] = ACTIONS(3189),
    [anon_sym_yield] = ACTIONS(3189),
    [anon_sym_LBRACK] = ACTIONS(3187),
    [sym_ellipsis] = ACTIONS(3187),
    [anon_sym_LBRACE] = ACTIONS(3187),
    [sym_string] = ACTIONS(3187),
    [sym_integer] = ACTIONS(3189),
    [sym_float] = ACTIONS(3189),
    [sym_identifier] = ACTIONS(3189),
    [sym_true] = ACTIONS(3189),
    [sym_false] = ACTIONS(3189),
    [sym_none] = ACTIONS(3189),
    [anon_sym_await] = ACTIONS(3189),
    [sym_comment] = ACTIONS(72),
  },
  [1948] = {
    [sym__dedent] = ACTIONS(1401),
    [anon_sym_import] = ACTIONS(1403),
    [anon_sym_from] = ACTIONS(1403),
    [anon_sym_LPAREN] = ACTIONS(1401),
    [anon_sym_print] = ACTIONS(1403),
    [anon_sym_assert] = ACTIONS(1403),
    [anon_sym_return] = ACTIONS(1403),
    [anon_sym_del] = ACTIONS(1403),
    [anon_sym_raise] = ACTIONS(1403),
    [sym_pass_statement] = ACTIONS(1403),
    [sym_break_statement] = ACTIONS(1403),
    [sym_continue_statement] = ACTIONS(1403),
    [anon_sym_if] = ACTIONS(1403),
    [anon_sym_else] = ACTIONS(1403),
    [anon_sym_async] = ACTIONS(1403),
    [anon_sym_for] = ACTIONS(1403),
    [anon_sym_while] = ACTIONS(1403),
    [anon_sym_try] = ACTIONS(1403),
    [anon_sym_except] = ACTIONS(1403),
    [anon_sym_finally] = ACTIONS(1403),
    [anon_sym_with] = ACTIONS(1403),
    [anon_sym_def] = ACTIONS(1403),
    [anon_sym_global] = ACTIONS(1403),
    [anon_sym_nonlocal] = ACTIONS(1403),
    [anon_sym_exec] = ACTIONS(1403),
    [anon_sym_class] = ACTIONS(1403),
    [anon_sym_AT] = ACTIONS(1401),
    [anon_sym_not] = ACTIONS(1403),
    [anon_sym_PLUS] = ACTIONS(1401),
    [anon_sym_DASH] = ACTIONS(1401),
    [anon_sym_TILDE] = ACTIONS(1401),
    [anon_sym_lambda] = ACTIONS(1403),
    [anon_sym_yield] = ACTIONS(1403),
    [anon_sym_LBRACK] = ACTIONS(1401),
    [sym_ellipsis] = ACTIONS(1401),
    [anon_sym_LBRACE] = ACTIONS(1401),
    [sym_string] = ACTIONS(1401),
    [sym_integer] = ACTIONS(1403),
    [sym_float] = ACTIONS(1403),
    [sym_identifier] = ACTIONS(1403),
    [sym_true] = ACTIONS(1403),
    [sym_false] = ACTIONS(1403),
    [sym_none] = ACTIONS(1403),
    [anon_sym_await] = ACTIONS(1403),
    [sym_comment] = ACTIONS(72),
  },
  [1949] = {
    [sym_import_statement] = STATE(326),
    [sym_import_from_statement] = STATE(326),
    [sym_print_statement] = STATE(326),
    [sym_assert_statement] = STATE(326),
    [sym_expression_statement] = STATE(326),
    [sym_return_statement] = STATE(326),
    [sym_delete_statement] = STATE(326),
    [sym_raise_statement] = STATE(326),
    [sym_global_statement] = STATE(326),
    [sym_nonlocal_statement] = STATE(326),
    [sym_exec_statement] = STATE(326),
    [sym_expression_list] = STATE(32),
    [sym__expression] = STATE(33),
    [sym__primary_expression] = STATE(34),
    [sym_not_operator] = STATE(33),
    [sym_boolean_operator] = STATE(33),
    [sym_binary_operator] = STATE(34),
    [sym_unary_operator] = STATE(34),
    [sym_comparison_operator] = STATE(33),
    [sym_lambda] = STATE(33),
    [sym_assignment] = STATE(35),
    [sym_augmented_assignment] = STATE(35),
    [sym_yield] = STATE(35),
    [sym_attribute] = STATE(34),
    [sym_subscript] = STATE(34),
    [sym_call] = STATE(34),
    [sym_list] = STATE(34),
    [sym_list_comprehension] = STATE(34),
    [sym_dictionary] = STATE(34),
    [sym_dictionary_comprehension] = STATE(34),
    [sym_set] = STATE(34),
    [sym_set_comprehension] = STATE(34),
    [sym_parenthesized_expression] = STATE(34),
    [sym_tuple] = STATE(34),
    [sym_generator_expression] = STATE(34),
    [sym_conditional_expression] = STATE(33),
    [sym_concatenated_string] = STATE(34),
    [sym_await] = STATE(33),
    [sym__newline] = ACTIONS(4398),
    [anon_sym_import] = ACTIONS(10),
    [anon_sym_from] = ACTIONS(12),
    [anon_sym_LPAREN] = ACTIONS(14),
    [anon_sym_print] = ACTIONS(16),
    [anon_sym_assert] = ACTIONS(18),
    [anon_sym_return] = ACTIONS(20),
    [anon_sym_del] = ACTIONS(22),
    [anon_sym_raise] = ACTIONS(24),
    [sym_pass_statement] = ACTIONS(582),
    [sym_break_statement] = ACTIONS(582),
    [sym_continue_statement] = ACTIONS(582),
    [anon_sym_global] = ACTIONS(42),
    [anon_sym_nonlocal] = ACTIONS(44),
    [anon_sym_exec] = ACTIONS(46),
    [anon_sym_not] = ACTIONS(52),
    [anon_sym_PLUS] = ACTIONS(54),
    [anon_sym_DASH] = ACTIONS(54),
    [anon_sym_TILDE] = ACTIONS(54),
    [anon_sym_lambda] = ACTIONS(56),
    [anon_sym_yield] = ACTIONS(58),
    [anon_sym_LBRACK] = ACTIONS(60),
    [sym_ellipsis] = ACTIONS(62),
    [anon_sym_LBRACE] = ACTIONS(64),
    [sym_string] = ACTIONS(66),
    [sym_integer] = ACTIONS(68),
    [sym_float] = ACTIONS(68),
    [sym_identifier] = ACTIONS(68),
    [sym_true] = ACTIONS(68),
    [sym_false] = ACTIONS(68),
    [sym_none] = ACTIONS(68),
    [anon_sym_await] = ACTIONS(70),
    [sym_comment] = ACTIONS(72),
  },
  [1950] = {
    [sym__simple_statements] = STATE(1957),
    [sym_import_statement] = STATE(1901),
    [sym_import_from_statement] = STATE(1901),
    [sym_print_statement] = STATE(1901),
    [sym_assert_statement] = STATE(1901),
    [sym_expression_statement] = STATE(1901),
    [sym_return_statement] = STATE(1901),
    [sym_delete_statement] = STATE(1901),
    [sym_raise_statement] = STATE(1901),
    [sym_global_statement] = STATE(1901),
    [sym_nonlocal_statement] = STATE(1901),
    [sym_exec_statement] = STATE(1901),
    [sym__suite] = STATE(1957),
    [sym_expression_list] = STATE(32),
    [sym__expression] = STATE(33),
    [sym__primary_expression] = STATE(34),
    [sym_not_operator] = STATE(33),
    [sym_boolean_operator] = STATE(33),
    [sym_binary_operator] = STATE(34),
    [sym_unary_operator] = STATE(34),
    [sym_comparison_operator] = STATE(33),
    [sym_lambda] = STATE(33),
    [sym_assignment] = STATE(35),
    [sym_augmented_assignment] = STATE(35),
    [sym_yield] = STATE(35),
    [sym_attribute] = STATE(34),
    [sym_subscript] = STATE(34),
    [sym_call] = STATE(34),
    [sym_list] = STATE(34),
    [sym_list_comprehension] = STATE(34),
    [sym_dictionary] = STATE(34),
    [sym_dictionary_comprehension] = STATE(34),
    [sym_set] = STATE(34),
    [sym_set_comprehension] = STATE(34),
    [sym_parenthesized_expression] = STATE(34),
    [sym_tuple] = STATE(34),
    [sym_generator_expression] = STATE(34),
    [sym_conditional_expression] = STATE(33),
    [sym_concatenated_string] = STATE(34),
    [sym_await] = STATE(33),
    [sym__indent] = ACTIONS(4297),
    [anon_sym_import] = ACTIONS(10),
    [anon_sym_from] = ACTIONS(12),
    [anon_sym_LPAREN] = ACTIONS(14),
    [anon_sym_print] = ACTIONS(16),
    [anon_sym_assert] = ACTIONS(18),
    [anon_sym_return] = ACTIONS(20),
    [anon_sym_del] = ACTIONS(22),
    [anon_sym_raise] = ACTIONS(24),
    [sym_pass_statement] = ACTIONS(4299),
    [sym_break_statement] = ACTIONS(4299),
    [sym_continue_statement] = ACTIONS(4299),
    [anon_sym_global] = ACTIONS(42),
    [anon_sym_nonlocal] = ACTIONS(44),
    [anon_sym_exec] = ACTIONS(46),
    [anon_sym_not] = ACTIONS(52),
    [anon_sym_PLUS] = ACTIONS(54),
    [anon_sym_DASH] = ACTIONS(54),
    [anon_sym_TILDE] = ACTIONS(54),
    [anon_sym_lambda] = ACTIONS(56),
    [anon_sym_yield] = ACTIONS(58),
    [anon_sym_LBRACK] = ACTIONS(60),
    [sym_ellipsis] = ACTIONS(62),
    [anon_sym_LBRACE] = ACTIONS(64),
    [sym_string] = ACTIONS(66),
    [sym_integer] = ACTIONS(68),
    [sym_float] = ACTIONS(68),
    [sym_identifier] = ACTIONS(68),
    [sym_true] = ACTIONS(68),
    [sym_false] = ACTIONS(68),
    [sym_none] = ACTIONS(68),
    [anon_sym_await] = ACTIONS(70),
    [sym_comment] = ACTIONS(72),
  },
  [1951] = {
    [sym__dedent] = ACTIONS(2388),
    [anon_sym_import] = ACTIONS(2390),
    [anon_sym_from] = ACTIONS(2390),
    [anon_sym_LPAREN] = ACTIONS(2388),
    [anon_sym_print] = ACTIONS(2390),
    [anon_sym_assert] = ACTIONS(2390),
    [anon_sym_return] = ACTIONS(2390),
    [anon_sym_del] = ACTIONS(2390),
    [anon_sym_raise] = ACTIONS(2390),
    [sym_pass_statement] = ACTIONS(2390),
    [sym_break_statement] = ACTIONS(2390),
    [sym_continue_statement] = ACTIONS(2390),
    [anon_sym_if] = ACTIONS(2390),
    [anon_sym_async] = ACTIONS(2390),
    [anon_sym_for] = ACTIONS(2390),
    [anon_sym_while] = ACTIONS(2390),
    [anon_sym_try] = ACTIONS(2390),
    [anon_sym_finally] = ACTIONS(2390),
    [anon_sym_with] = ACTIONS(2390),
    [anon_sym_def] = ACTIONS(2390),
    [anon_sym_global] = ACTIONS(2390),
    [anon_sym_nonlocal] = ACTIONS(2390),
    [anon_sym_exec] = ACTIONS(2390),
    [anon_sym_class] = ACTIONS(2390),
    [anon_sym_AT] = ACTIONS(2388),
    [anon_sym_not] = ACTIONS(2390),
    [anon_sym_PLUS] = ACTIONS(2388),
    [anon_sym_DASH] = ACTIONS(2388),
    [anon_sym_TILDE] = ACTIONS(2388),
    [anon_sym_lambda] = ACTIONS(2390),
    [anon_sym_yield] = ACTIONS(2390),
    [anon_sym_LBRACK] = ACTIONS(2388),
    [sym_ellipsis] = ACTIONS(2388),
    [anon_sym_LBRACE] = ACTIONS(2388),
    [sym_string] = ACTIONS(2388),
    [sym_integer] = ACTIONS(2390),
    [sym_float] = ACTIONS(2390),
    [sym_identifier] = ACTIONS(2390),
    [sym_true] = ACTIONS(2390),
    [sym_false] = ACTIONS(2390),
    [sym_none] = ACTIONS(2390),
    [anon_sym_await] = ACTIONS(2390),
    [sym_comment] = ACTIONS(72),
  },
  [1952] = {
    [sym__statement] = STATE(1155),
    [sym__simple_statements] = STATE(1155),
    [sym_import_statement] = STATE(746),
    [sym_import_from_statement] = STATE(746),
    [sym_print_statement] = STATE(746),
    [sym_assert_statement] = STATE(746),
    [sym_expression_statement] = STATE(746),
    [sym_return_statement] = STATE(746),
    [sym_delete_statement] = STATE(746),
    [sym_raise_statement] = STATE(746),
    [sym_if_statement] = STATE(1155),
    [sym_for_statement] = STATE(1155),
    [sym_while_statement] = STATE(1155),
    [sym_try_statement] = STATE(1155),
    [sym_with_statement] = STATE(1155),
    [sym_function_definition] = STATE(1155),
    [sym_global_statement] = STATE(746),
    [sym_nonlocal_statement] = STATE(746),
    [sym_exec_statement] = STATE(746),
    [sym_class_definition] = STATE(1155),
    [sym_decorated_definition] = STATE(1155),
    [sym_decorator] = STATE(756),
    [sym_expression_list] = STATE(32),
    [sym__expression] = STATE(33),
    [sym__primary_expression] = STATE(34),
    [sym_not_operator] = STATE(33),
    [sym_boolean_operator] = STATE(33),
    [sym_binary_operator] = STATE(34),
    [sym_unary_operator] = STATE(34),
    [sym_comparison_operator] = STATE(33),
    [sym_lambda] = STATE(33),
    [sym_assignment] = STATE(35),
    [sym_augmented_assignment] = STATE(35),
    [sym_yield] = STATE(35),
    [sym_attribute] = STATE(34),
    [sym_subscript] = STATE(34),
    [sym_call] = STATE(34),
    [sym_list] = STATE(34),
    [sym_list_comprehension] = STATE(34),
    [sym_dictionary] = STATE(34),
    [sym_dictionary_comprehension] = STATE(34),
    [sym_set] = STATE(34),
    [sym_set_comprehension] = STATE(34),
    [sym_parenthesized_expression] = STATE(34),
    [sym_tuple] = STATE(34),
    [sym_generator_expression] = STATE(34),
    [sym_conditional_expression] = STATE(33),
    [sym_concatenated_string] = STATE(34),
    [sym_await] = STATE(33),
    [aux_sym_module_repeat1] = STATE(1155),
    [aux_sym_decorated_definition_repeat1] = STATE(756),
    [sym__dedent] = ACTIONS(4400),
    [anon_sym_import] = ACTIONS(10),
    [anon_sym_from] = ACTIONS(12),
    [anon_sym_LPAREN] = ACTIONS(14),
    [anon_sym_print] = ACTIONS(16),
    [anon_sym_assert] = ACTIONS(18),
    [anon_sym_return] = ACTIONS(20),
    [anon_sym_del] = ACTIONS(22),
    [anon_sym_raise] = ACTIONS(24),
    [sym_pass_statement] = ACTIONS(1498),
    [sym_break_statement] = ACTIONS(1498),
    [sym_continue_statement] = ACTIONS(1498),
    [anon_sym_if] = ACTIONS(1500),
    [anon_sym_async] = ACTIONS(1502),
    [anon_sym_for] = ACTIONS(1504),
    [anon_sym_while] = ACTIONS(1506),
    [anon_sym_try] = ACTIONS(1508),
    [anon_sym_with] = ACTIONS(1510),
    [anon_sym_def] = ACTIONS(1512),
    [anon_sym_global] = ACTIONS(42),
    [anon_sym_nonlocal] = ACTIONS(44),
    [anon_sym_exec] = ACTIONS(46),
    [anon_sym_class] = ACTIONS(1514),
    [anon_sym_AT] = ACTIONS(50),
    [anon_sym_not] = ACTIONS(52),
    [anon_sym_PLUS] = ACTIONS(54),
    [anon_sym_DASH] = ACTIONS(54),
    [anon_sym_TILDE] = ACTIONS(54),
    [anon_sym_lambda] = ACTIONS(56),
    [anon_sym_yield] = ACTIONS(58),
    [anon_sym_LBRACK] = ACTIONS(60),
    [sym_ellipsis] = ACTIONS(62),
    [anon_sym_LBRACE] = ACTIONS(64),
    [sym_string] = ACTIONS(66),
    [sym_integer] = ACTIONS(68),
    [sym_float] = ACTIONS(68),
    [sym_identifier] = ACTIONS(68),
    [sym_true] = ACTIONS(68),
    [sym_false] = ACTIONS(68),
    [sym_none] = ACTIONS(68),
    [anon_sym_await] = ACTIONS(70),
    [sym_comment] = ACTIONS(72),
  },
  [1953] = {
    [sym__dedent] = ACTIONS(576),
    [anon_sym_import] = ACTIONS(578),
    [anon_sym_from] = ACTIONS(578),
    [anon_sym_LPAREN] = ACTIONS(576),
    [anon_sym_print] = ACTIONS(578),
    [anon_sym_assert] = ACTIONS(578),
    [anon_sym_return] = ACTIONS(578),
    [anon_sym_del] = ACTIONS(578),
    [anon_sym_raise] = ACTIONS(578),
    [sym_pass_statement] = ACTIONS(578),
    [sym_break_statement] = ACTIONS(578),
    [sym_continue_statement] = ACTIONS(578),
    [anon_sym_if] = ACTIONS(578),
    [anon_sym_async] = ACTIONS(578),
    [anon_sym_for] = ACTIONS(578),
    [anon_sym_while] = ACTIONS(578),
    [anon_sym_try] = ACTIONS(578),
    [anon_sym_finally] = ACTIONS(578),
    [anon_sym_with] = ACTIONS(578),
    [anon_sym_def] = ACTIONS(578),
    [anon_sym_global] = ACTIONS(578),
    [anon_sym_nonlocal] = ACTIONS(578),
    [anon_sym_exec] = ACTIONS(578),
    [anon_sym_class] = ACTIONS(578),
    [anon_sym_AT] = ACTIONS(576),
    [anon_sym_not] = ACTIONS(578),
    [anon_sym_PLUS] = ACTIONS(576),
    [anon_sym_DASH] = ACTIONS(576),
    [anon_sym_TILDE] = ACTIONS(576),
    [anon_sym_lambda] = ACTIONS(578),
    [anon_sym_yield] = ACTIONS(578),
    [anon_sym_LBRACK] = ACTIONS(576),
    [sym_ellipsis] = ACTIONS(576),
    [anon_sym_LBRACE] = ACTIONS(576),
    [sym_string] = ACTIONS(576),
    [sym_integer] = ACTIONS(578),
    [sym_float] = ACTIONS(578),
    [sym_identifier] = ACTIONS(578),
    [sym_true] = ACTIONS(578),
    [sym_false] = ACTIONS(578),
    [sym_none] = ACTIONS(578),
    [anon_sym_await] = ACTIONS(578),
    [sym_comment] = ACTIONS(72),
  },
  [1954] = {
    [sym_import_statement] = STATE(326),
    [sym_import_from_statement] = STATE(326),
    [sym_print_statement] = STATE(326),
    [sym_assert_statement] = STATE(326),
    [sym_expression_statement] = STATE(326),
    [sym_return_statement] = STATE(326),
    [sym_delete_statement] = STATE(326),
    [sym_raise_statement] = STATE(326),
    [sym_global_statement] = STATE(326),
    [sym_nonlocal_statement] = STATE(326),
    [sym_exec_statement] = STATE(326),
    [sym_expression_list] = STATE(32),
    [sym__expression] = STATE(33),
    [sym__primary_expression] = STATE(34),
    [sym_not_operator] = STATE(33),
    [sym_boolean_operator] = STATE(33),
    [sym_binary_operator] = STATE(34),
    [sym_unary_operator] = STATE(34),
    [sym_comparison_operator] = STATE(33),
    [sym_lambda] = STATE(33),
    [sym_assignment] = STATE(35),
    [sym_augmented_assignment] = STATE(35),
    [sym_yield] = STATE(35),
    [sym_attribute] = STATE(34),
    [sym_subscript] = STATE(34),
    [sym_call] = STATE(34),
    [sym_list] = STATE(34),
    [sym_list_comprehension] = STATE(34),
    [sym_dictionary] = STATE(34),
    [sym_dictionary_comprehension] = STATE(34),
    [sym_set] = STATE(34),
    [sym_set_comprehension] = STATE(34),
    [sym_parenthesized_expression] = STATE(34),
    [sym_tuple] = STATE(34),
    [sym_generator_expression] = STATE(34),
    [sym_conditional_expression] = STATE(33),
    [sym_concatenated_string] = STATE(34),
    [sym_await] = STATE(33),
    [sym__newline] = ACTIONS(4402),
    [anon_sym_import] = ACTIONS(10),
    [anon_sym_from] = ACTIONS(12),
    [anon_sym_LPAREN] = ACTIONS(14),
    [anon_sym_print] = ACTIONS(16),
    [anon_sym_assert] = ACTIONS(18),
    [anon_sym_return] = ACTIONS(20),
    [anon_sym_del] = ACTIONS(22),
    [anon_sym_raise] = ACTIONS(24),
    [sym_pass_statement] = ACTIONS(582),
    [sym_break_statement] = ACTIONS(582),
    [sym_continue_statement] = ACTIONS(582),
    [anon_sym_global] = ACTIONS(42),
    [anon_sym_nonlocal] = ACTIONS(44),
    [anon_sym_exec] = ACTIONS(46),
    [anon_sym_not] = ACTIONS(52),
    [anon_sym_PLUS] = ACTIONS(54),
    [anon_sym_DASH] = ACTIONS(54),
    [anon_sym_TILDE] = ACTIONS(54),
    [anon_sym_lambda] = ACTIONS(56),
    [anon_sym_yield] = ACTIONS(58),
    [anon_sym_LBRACK] = ACTIONS(60),
    [sym_ellipsis] = ACTIONS(62),
    [anon_sym_LBRACE] = ACTIONS(64),
    [sym_string] = ACTIONS(66),
    [sym_integer] = ACTIONS(68),
    [sym_float] = ACTIONS(68),
    [sym_identifier] = ACTIONS(68),
    [sym_true] = ACTIONS(68),
    [sym_false] = ACTIONS(68),
    [sym_none] = ACTIONS(68),
    [anon_sym_await] = ACTIONS(70),
    [sym_comment] = ACTIONS(72),
  },
  [1955] = {
    [aux_sym__simple_statements_repeat1] = STATE(328),
    [sym__newline] = ACTIONS(4402),
    [sym_comment] = ACTIONS(72),
    [sym__semicolon] = ACTIONS(4404),
  },
  [1956] = {
    [sym__dedent] = ACTIONS(2319),
    [anon_sym_import] = ACTIONS(2321),
    [anon_sym_from] = ACTIONS(2321),
    [anon_sym_LPAREN] = ACTIONS(2319),
    [anon_sym_print] = ACTIONS(2321),
    [anon_sym_assert] = ACTIONS(2321),
    [anon_sym_return] = ACTIONS(2321),
    [anon_sym_del] = ACTIONS(2321),
    [anon_sym_raise] = ACTIONS(2321),
    [sym_pass_statement] = ACTIONS(2321),
    [sym_break_statement] = ACTIONS(2321),
    [sym_continue_statement] = ACTIONS(2321),
    [anon_sym_if] = ACTIONS(2321),
    [anon_sym_else] = ACTIONS(2321),
    [anon_sym_async] = ACTIONS(2321),
    [anon_sym_for] = ACTIONS(2321),
    [anon_sym_while] = ACTIONS(2321),
    [anon_sym_try] = ACTIONS(2321),
    [anon_sym_except] = ACTIONS(2321),
    [anon_sym_finally] = ACTIONS(2321),
    [anon_sym_with] = ACTIONS(2321),
    [anon_sym_def] = ACTIONS(2321),
    [anon_sym_global] = ACTIONS(2321),
    [anon_sym_nonlocal] = ACTIONS(2321),
    [anon_sym_exec] = ACTIONS(2321),
    [anon_sym_class] = ACTIONS(2321),
    [anon_sym_AT] = ACTIONS(2319),
    [anon_sym_not] = ACTIONS(2321),
    [anon_sym_PLUS] = ACTIONS(2319),
    [anon_sym_DASH] = ACTIONS(2319),
    [anon_sym_TILDE] = ACTIONS(2319),
    [anon_sym_lambda] = ACTIONS(2321),
    [anon_sym_yield] = ACTIONS(2321),
    [anon_sym_LBRACK] = ACTIONS(2319),
    [sym_ellipsis] = ACTIONS(2319),
    [anon_sym_LBRACE] = ACTIONS(2319),
    [sym_string] = ACTIONS(2319),
    [sym_integer] = ACTIONS(2321),
    [sym_float] = ACTIONS(2321),
    [sym_identifier] = ACTIONS(2321),
    [sym_true] = ACTIONS(2321),
    [sym_false] = ACTIONS(2321),
    [sym_none] = ACTIONS(2321),
    [anon_sym_await] = ACTIONS(2321),
    [sym_comment] = ACTIONS(72),
  },
  [1957] = {
    [sym__dedent] = ACTIONS(4378),
    [anon_sym_import] = ACTIONS(4380),
    [anon_sym_from] = ACTIONS(4380),
    [anon_sym_LPAREN] = ACTIONS(4378),
    [anon_sym_print] = ACTIONS(4380),
    [anon_sym_assert] = ACTIONS(4380),
    [anon_sym_return] = ACTIONS(4380),
    [anon_sym_del] = ACTIONS(4380),
    [anon_sym_raise] = ACTIONS(4380),
    [sym_pass_statement] = ACTIONS(4380),
    [sym_break_statement] = ACTIONS(4380),
    [sym_continue_statement] = ACTIONS(4380),
    [anon_sym_if] = ACTIONS(4380),
    [anon_sym_else] = ACTIONS(4380),
    [anon_sym_async] = ACTIONS(4380),
    [anon_sym_for] = ACTIONS(4380),
    [anon_sym_while] = ACTIONS(4380),
    [anon_sym_try] = ACTIONS(4380),
    [anon_sym_except] = ACTIONS(4380),
    [anon_sym_finally] = ACTIONS(4380),
    [anon_sym_with] = ACTIONS(4380),
    [anon_sym_def] = ACTIONS(4380),
    [anon_sym_global] = ACTIONS(4380),
    [anon_sym_nonlocal] = ACTIONS(4380),
    [anon_sym_exec] = ACTIONS(4380),
    [anon_sym_class] = ACTIONS(4380),
    [anon_sym_AT] = ACTIONS(4378),
    [anon_sym_not] = ACTIONS(4380),
    [anon_sym_PLUS] = ACTIONS(4378),
    [anon_sym_DASH] = ACTIONS(4378),
    [anon_sym_TILDE] = ACTIONS(4378),
    [anon_sym_lambda] = ACTIONS(4380),
    [anon_sym_yield] = ACTIONS(4380),
    [anon_sym_LBRACK] = ACTIONS(4378),
    [sym_ellipsis] = ACTIONS(4378),
    [anon_sym_LBRACE] = ACTIONS(4378),
    [sym_string] = ACTIONS(4378),
    [sym_integer] = ACTIONS(4380),
    [sym_float] = ACTIONS(4380),
    [sym_identifier] = ACTIONS(4380),
    [sym_true] = ACTIONS(4380),
    [sym_false] = ACTIONS(4380),
    [sym_none] = ACTIONS(4380),
    [anon_sym_await] = ACTIONS(4380),
    [sym_comment] = ACTIONS(72),
  },
  [1958] = {
    [sym__dedent] = ACTIONS(3187),
    [anon_sym_import] = ACTIONS(3189),
    [anon_sym_from] = ACTIONS(3189),
    [anon_sym_LPAREN] = ACTIONS(3187),
    [anon_sym_print] = ACTIONS(3189),
    [anon_sym_assert] = ACTIONS(3189),
    [anon_sym_return] = ACTIONS(3189),
    [anon_sym_del] = ACTIONS(3189),
    [anon_sym_raise] = ACTIONS(3189),
    [sym_pass_statement] = ACTIONS(3189),
    [sym_break_statement] = ACTIONS(3189),
    [sym_continue_statement] = ACTIONS(3189),
    [anon_sym_if] = ACTIONS(3189),
    [anon_sym_async] = ACTIONS(3189),
    [anon_sym_for] = ACTIONS(3189),
    [anon_sym_while] = ACTIONS(3189),
    [anon_sym_try] = ACTIONS(3189),
    [anon_sym_finally] = ACTIONS(3189),
    [anon_sym_with] = ACTIONS(3189),
    [anon_sym_def] = ACTIONS(3189),
    [anon_sym_global] = ACTIONS(3189),
    [anon_sym_nonlocal] = ACTIONS(3189),
    [anon_sym_exec] = ACTIONS(3189),
    [anon_sym_class] = ACTIONS(3189),
    [anon_sym_AT] = ACTIONS(3187),
    [anon_sym_not] = ACTIONS(3189),
    [anon_sym_PLUS] = ACTIONS(3187),
    [anon_sym_DASH] = ACTIONS(3187),
    [anon_sym_TILDE] = ACTIONS(3187),
    [anon_sym_lambda] = ACTIONS(3189),
    [anon_sym_yield] = ACTIONS(3189),
    [anon_sym_LBRACK] = ACTIONS(3187),
    [sym_ellipsis] = ACTIONS(3187),
    [anon_sym_LBRACE] = ACTIONS(3187),
    [sym_string] = ACTIONS(3187),
    [sym_integer] = ACTIONS(3189),
    [sym_float] = ACTIONS(3189),
    [sym_identifier] = ACTIONS(3189),
    [sym_true] = ACTIONS(3189),
    [sym_false] = ACTIONS(3189),
    [sym_none] = ACTIONS(3189),
    [anon_sym_await] = ACTIONS(3189),
    [sym_comment] = ACTIONS(72),
  },
  [1959] = {
    [sym__dedent] = ACTIONS(1401),
    [anon_sym_import] = ACTIONS(1403),
    [anon_sym_from] = ACTIONS(1403),
    [anon_sym_LPAREN] = ACTIONS(1401),
    [anon_sym_print] = ACTIONS(1403),
    [anon_sym_assert] = ACTIONS(1403),
    [anon_sym_return] = ACTIONS(1403),
    [anon_sym_del] = ACTIONS(1403),
    [anon_sym_raise] = ACTIONS(1403),
    [sym_pass_statement] = ACTIONS(1403),
    [sym_break_statement] = ACTIONS(1403),
    [sym_continue_statement] = ACTIONS(1403),
    [anon_sym_if] = ACTIONS(1403),
    [anon_sym_async] = ACTIONS(1403),
    [anon_sym_for] = ACTIONS(1403),
    [anon_sym_while] = ACTIONS(1403),
    [anon_sym_try] = ACTIONS(1403),
    [anon_sym_finally] = ACTIONS(1403),
    [anon_sym_with] = ACTIONS(1403),
    [anon_sym_def] = ACTIONS(1403),
    [anon_sym_global] = ACTIONS(1403),
    [anon_sym_nonlocal] = ACTIONS(1403),
    [anon_sym_exec] = ACTIONS(1403),
    [anon_sym_class] = ACTIONS(1403),
    [anon_sym_AT] = ACTIONS(1401),
    [anon_sym_not] = ACTIONS(1403),
    [anon_sym_PLUS] = ACTIONS(1401),
    [anon_sym_DASH] = ACTIONS(1401),
    [anon_sym_TILDE] = ACTIONS(1401),
    [anon_sym_lambda] = ACTIONS(1403),
    [anon_sym_yield] = ACTIONS(1403),
    [anon_sym_LBRACK] = ACTIONS(1401),
    [sym_ellipsis] = ACTIONS(1401),
    [anon_sym_LBRACE] = ACTIONS(1401),
    [sym_string] = ACTIONS(1401),
    [sym_integer] = ACTIONS(1403),
    [sym_float] = ACTIONS(1403),
    [sym_identifier] = ACTIONS(1403),
    [sym_true] = ACTIONS(1403),
    [sym_false] = ACTIONS(1403),
    [sym_none] = ACTIONS(1403),
    [anon_sym_await] = ACTIONS(1403),
    [sym_comment] = ACTIONS(72),
  },
  [1960] = {
    [sym_import_statement] = STATE(326),
    [sym_import_from_statement] = STATE(326),
    [sym_print_statement] = STATE(326),
    [sym_assert_statement] = STATE(326),
    [sym_expression_statement] = STATE(326),
    [sym_return_statement] = STATE(326),
    [sym_delete_statement] = STATE(326),
    [sym_raise_statement] = STATE(326),
    [sym_global_statement] = STATE(326),
    [sym_nonlocal_statement] = STATE(326),
    [sym_exec_statement] = STATE(326),
    [sym_expression_list] = STATE(32),
    [sym__expression] = STATE(33),
    [sym__primary_expression] = STATE(34),
    [sym_not_operator] = STATE(33),
    [sym_boolean_operator] = STATE(33),
    [sym_binary_operator] = STATE(34),
    [sym_unary_operator] = STATE(34),
    [sym_comparison_operator] = STATE(33),
    [sym_lambda] = STATE(33),
    [sym_assignment] = STATE(35),
    [sym_augmented_assignment] = STATE(35),
    [sym_yield] = STATE(35),
    [sym_attribute] = STATE(34),
    [sym_subscript] = STATE(34),
    [sym_call] = STATE(34),
    [sym_list] = STATE(34),
    [sym_list_comprehension] = STATE(34),
    [sym_dictionary] = STATE(34),
    [sym_dictionary_comprehension] = STATE(34),
    [sym_set] = STATE(34),
    [sym_set_comprehension] = STATE(34),
    [sym_parenthesized_expression] = STATE(34),
    [sym_tuple] = STATE(34),
    [sym_generator_expression] = STATE(34),
    [sym_conditional_expression] = STATE(33),
    [sym_concatenated_string] = STATE(34),
    [sym_await] = STATE(33),
    [sym__newline] = ACTIONS(4406),
    [anon_sym_import] = ACTIONS(10),
    [anon_sym_from] = ACTIONS(12),
    [anon_sym_LPAREN] = ACTIONS(14),
    [anon_sym_print] = ACTIONS(16),
    [anon_sym_assert] = ACTIONS(18),
    [anon_sym_return] = ACTIONS(20),
    [anon_sym_del] = ACTIONS(22),
    [anon_sym_raise] = ACTIONS(24),
    [sym_pass_statement] = ACTIONS(582),
    [sym_break_statement] = ACTIONS(582),
    [sym_continue_statement] = ACTIONS(582),
    [anon_sym_global] = ACTIONS(42),
    [anon_sym_nonlocal] = ACTIONS(44),
    [anon_sym_exec] = ACTIONS(46),
    [anon_sym_not] = ACTIONS(52),
    [anon_sym_PLUS] = ACTIONS(54),
    [anon_sym_DASH] = ACTIONS(54),
    [anon_sym_TILDE] = ACTIONS(54),
    [anon_sym_lambda] = ACTIONS(56),
    [anon_sym_yield] = ACTIONS(58),
    [anon_sym_LBRACK] = ACTIONS(60),
    [sym_ellipsis] = ACTIONS(62),
    [anon_sym_LBRACE] = ACTIONS(64),
    [sym_string] = ACTIONS(66),
    [sym_integer] = ACTIONS(68),
    [sym_float] = ACTIONS(68),
    [sym_identifier] = ACTIONS(68),
    [sym_true] = ACTIONS(68),
    [sym_false] = ACTIONS(68),
    [sym_none] = ACTIONS(68),
    [anon_sym_await] = ACTIONS(70),
    [sym_comment] = ACTIONS(72),
  },
  [1961] = {
    [sym__dedent] = ACTIONS(2319),
    [anon_sym_import] = ACTIONS(2321),
    [anon_sym_from] = ACTIONS(2321),
    [anon_sym_LPAREN] = ACTIONS(2319),
    [anon_sym_print] = ACTIONS(2321),
    [anon_sym_assert] = ACTIONS(2321),
    [anon_sym_return] = ACTIONS(2321),
    [anon_sym_del] = ACTIONS(2321),
    [anon_sym_raise] = ACTIONS(2321),
    [sym_pass_statement] = ACTIONS(2321),
    [sym_break_statement] = ACTIONS(2321),
    [sym_continue_statement] = ACTIONS(2321),
    [anon_sym_if] = ACTIONS(2321),
    [anon_sym_async] = ACTIONS(2321),
    [anon_sym_for] = ACTIONS(2321),
    [anon_sym_while] = ACTIONS(2321),
    [anon_sym_try] = ACTIONS(2321),
    [anon_sym_finally] = ACTIONS(2321),
    [anon_sym_with] = ACTIONS(2321),
    [anon_sym_def] = ACTIONS(2321),
    [anon_sym_global] = ACTIONS(2321),
    [anon_sym_nonlocal] = ACTIONS(2321),
    [anon_sym_exec] = ACTIONS(2321),
    [anon_sym_class] = ACTIONS(2321),
    [anon_sym_AT] = ACTIONS(2319),
    [anon_sym_not] = ACTIONS(2321),
    [anon_sym_PLUS] = ACTIONS(2319),
    [anon_sym_DASH] = ACTIONS(2319),
    [anon_sym_TILDE] = ACTIONS(2319),
    [anon_sym_lambda] = ACTIONS(2321),
    [anon_sym_yield] = ACTIONS(2321),
    [anon_sym_LBRACK] = ACTIONS(2319),
    [sym_ellipsis] = ACTIONS(2319),
    [anon_sym_LBRACE] = ACTIONS(2319),
    [sym_string] = ACTIONS(2319),
    [sym_integer] = ACTIONS(2321),
    [sym_float] = ACTIONS(2321),
    [sym_identifier] = ACTIONS(2321),
    [sym_true] = ACTIONS(2321),
    [sym_false] = ACTIONS(2321),
    [sym_none] = ACTIONS(2321),
    [anon_sym_await] = ACTIONS(2321),
    [sym_comment] = ACTIONS(72),
  },
};

static TSParseActionEntry ts_parse_actions[] = {
  [0] = {.count = 0, .reusable = false},
  [1] = {.count = 1, .reusable = true}, RECOVER(),
  [3] = {.count = 1, .reusable = false}, RECOVER(),
  [5] = {.count = 2, .reusable = true}, SHIFT_EXTRA(), RECOVER(),
  [8] = {.count = 1, .reusable = true}, REDUCE(sym_module, 0),
  [10] = {.count = 1, .reusable = false}, SHIFT(2),
  [12] = {.count = 1, .reusable = false}, SHIFT(3),
  [14] = {.count = 1, .reusable = true}, SHIFT(4),
  [16] = {.count = 1, .reusable = false}, SHIFT(5),
  [18] = {.count = 1, .reusable = false}, SHIFT(6),
  [20] = {.count = 1, .reusable = false}, SHIFT(7),
  [22] = {.count = 1, .reusable = false}, SHIFT(8),
  [24] = {.count = 1, .reusable = false}, SHIFT(9),
  [26] = {.count = 1, .reusable = false}, SHIFT(10),
  [28] = {.count = 1, .reusable = false}, SHIFT(11),
  [30] = {.count = 1, .reusable = false}, SHIFT(12),
  [32] = {.count = 1, .reusable = false}, SHIFT(13),
  [34] = {.count = 1, .reusable = false}, SHIFT(14),
  [36] = {.count = 1, .reusable = false}, SHIFT(15),
  [38] = {.count = 1, .reusable = false}, SHIFT(16),
  [40] = {.count = 1, .reusable = false}, SHIFT(17),
  [42] = {.count = 1, .reusable = false}, SHIFT(18),
  [44] = {.count = 1, .reusable = false}, SHIFT(19),
  [46] = {.count = 1, .reusable = false}, SHIFT(20),
  [48] = {.count = 1, .reusable = false}, SHIFT(21),
  [50] = {.count = 1, .reusable = true}, SHIFT(22),
  [52] = {.count = 1, .reusable = false}, SHIFT(23),
  [54] = {.count = 1, .reusable = true}, SHIFT(24),
  [56] = {.count = 1, .reusable = false}, SHIFT(25),
  [58] = {.count = 1, .reusable = false}, SHIFT(26),
  [60] = {.count = 1, .reusable = true}, SHIFT(27),
  [62] = {.count = 1, .reusable = true}, SHIFT(34),
  [64] = {.count = 1, .reusable = true}, SHIFT(28),
  [66] = {.count = 1, .reusable = true}, SHIFT(29),
  [68] = {.count = 1, .reusable = false}, SHIFT(34),
  [70] = {.count = 1, .reusable = false}, SHIFT(30),
  [72] = {.count = 1, .reusable = true}, SHIFT_EXTRA(),
  [74] = {.count = 1, .reusable = true}, SHIFT(38),
  [76] = {.count = 1, .reusable = true}, SHIFT(45),
  [78] = {.count = 1, .reusable = true}, SHIFT(42),
  [80] = {.count = 1, .reusable = true}, SHIFT(46),
  [82] = {.count = 1, .reusable = true}, SHIFT(47),
  [84] = {.count = 1, .reusable = true}, SHIFT(48),
  [86] = {.count = 1, .reusable = false}, SHIFT(49),
  [88] = {.count = 1, .reusable = false}, SHIFT(50),
  [90] = {.count = 1, .reusable = true}, SHIFT(51),
  [92] = {.count = 1, .reusable = false}, SHIFT(52),
  [94] = {.count = 1, .reusable = false}, SHIFT(53),
  [96] = {.count = 1, .reusable = true}, SHIFT(54),
  [98] = {.count = 1, .reusable = true}, SHIFT(59),
  [100] = {.count = 1, .reusable = true}, SHIFT(55),
  [102] = {.count = 1, .reusable = true}, SHIFT(56),
  [104] = {.count = 1, .reusable = false}, SHIFT(59),
  [106] = {.count = 1, .reusable = false}, SHIFT(57),
  [108] = {.count = 1, .reusable = true}, REDUCE(sym__primary_expression, 1, .alias_sequence_id = 1),
  [110] = {.count = 1, .reusable = false}, REDUCE(sym__primary_expression, 1, .alias_sequence_id = 1),
  [112] = {.count = 1, .reusable = false}, SHIFT(62),
  [114] = {.count = 1, .reusable = false}, SHIFT(63),
  [116] = {.count = 1, .reusable = true}, SHIFT(65),
  [118] = {.count = 1, .reusable = false}, SHIFT(66),
  [120] = {.count = 1, .reusable = true}, SHIFT(73),
  [122] = {.count = 1, .reusable = true}, SHIFT(68),
  [124] = {.count = 1, .reusable = true}, SHIFT(69),
  [126] = {.count = 1, .reusable = false}, SHIFT(73),
  [128] = {.count = 1, .reusable = false}, SHIFT(70),
  [130] = {.count = 1, .reusable = true}, SHIFT(61),
  [132] = {.count = 1, .reusable = false}, SHIFT(64),
  [134] = {.count = 1, .reusable = true}, SHIFT(67),
  [136] = {.count = 1, .reusable = true}, REDUCE(sym_return_statement, 1),
  [138] = {.count = 1, .reusable = true}, REDUCE(sym_raise_statement, 1),
  [140] = {.count = 1, .reusable = false}, SHIFT(78),
  [142] = {.count = 1, .reusable = false}, SHIFT(79),
  [144] = {.count = 1, .reusable = true}, SHIFT(80),
  [146] = {.count = 1, .reusable = false}, SHIFT(81),
  [148] = {.count = 1, .reusable = true}, SHIFT(86),
  [150] = {.count = 1, .reusable = true}, SHIFT(82),
  [152] = {.count = 1, .reusable = false}, SHIFT(86),
  [154] = {.count = 1, .reusable = false}, SHIFT(83),
  [156] = {.count = 1, .reusable = true}, SHIFT(87),
  [158] = {.count = 1, .reusable = true}, SHIFT(88),
  [160] = {.count = 1, .reusable = false}, SHIFT(90),
  [162] = {.count = 1, .reusable = true}, SHIFT(91),
  [164] = {.count = 1, .reusable = false}, SHIFT(92),
  [166] = {.count = 1, .reusable = true}, SHIFT(96),
  [168] = {.count = 1, .reusable = true}, SHIFT(93),
  [170] = {.count = 1, .reusable = false}, SHIFT(96),
  [172] = {.count = 1, .reusable = false}, SHIFT(94),
  [174] = {.count = 1, .reusable = true}, SHIFT(97),
  [176] = {.count = 1, .reusable = true}, SHIFT(98),
  [178] = {.count = 1, .reusable = true}, SHIFT(99),
  [180] = {.count = 1, .reusable = true}, SHIFT(100),
  [182] = {.count = 1, .reusable = true}, SHIFT(103),
  [184] = {.count = 1, .reusable = true}, SHIFT(101),
  [186] = {.count = 1, .reusable = false}, SHIFT(103),
  [188] = {.count = 1, .reusable = true}, SHIFT(105),
  [190] = {.count = 1, .reusable = false}, SHIFT(106),
  [192] = {.count = 1, .reusable = true}, SHIFT(107),
  [194] = {.count = 1, .reusable = false}, SHIFT(108),
  [196] = {.count = 1, .reusable = true}, SHIFT(113),
  [198] = {.count = 1, .reusable = true}, SHIFT(109),
  [200] = {.count = 1, .reusable = false}, SHIFT(113),
  [202] = {.count = 1, .reusable = false}, SHIFT(110),
  [204] = {.count = 1, .reusable = true}, SHIFT(114),
  [206] = {.count = 1, .reusable = true}, SHIFT(115),
  [208] = {.count = 1, .reusable = true}, SHIFT(116),
  [210] = {.count = 1, .reusable = true}, SHIFT(117),
  [212] = {.count = 1, .reusable = true}, SHIFT(118),
  [214] = {.count = 1, .reusable = true}, SHIFT(119),
  [216] = {.count = 1, .reusable = false}, SHIFT(121),
  [218] = {.count = 1, .reusable = true}, SHIFT(123),
  [220] = {.count = 1, .reusable = false}, SHIFT(123),
  [222] = {.count = 1, .reusable = true}, SHIFT(124),
  [224] = {.count = 1, .reusable = true}, SHIFT(125),
  [226] = {.count = 1, .reusable = false}, SHIFT(126),
  [228] = {.count = 1, .reusable = true}, SHIFT(127),
  [230] = {.count = 1, .reusable = false}, SHIFT(128),
  [232] = {.count = 1, .reusable = true}, REDUCE(sym_yield, 1),
  [234] = {.count = 1, .reusable = false}, SHIFT(133),
  [236] = {.count = 1, .reusable = true}, SHIFT(135),
  [238] = {.count = 1, .reusable = true}, SHIFT(136),
  [240] = {.count = 1, .reusable = false}, SHIFT(137),
  [242] = {.count = 1, .reusable = true}, SHIFT(138),
  [244] = {.count = 1, .reusable = false}, SHIFT(139),
  [246] = {.count = 1, .reusable = true}, SHIFT(140),
  [248] = {.count = 1, .reusable = true}, SHIFT(145),
  [250] = {.count = 1, .reusable = true}, SHIFT(141),
  [252] = {.count = 1, .reusable = false}, SHIFT(145),
  [254] = {.count = 1, .reusable = false}, SHIFT(142),
  [256] = {.count = 1, .reusable = true}, SHIFT(146),
  [258] = {.count = 1, .reusable = true}, SHIFT(147),
  [260] = {.count = 1, .reusable = false}, SHIFT(148),
  [262] = {.count = 1, .reusable = true}, SHIFT(149),
  [264] = {.count = 1, .reusable = false}, SHIFT(150),
  [266] = {.count = 1, .reusable = true}, SHIFT(157),
  [268] = {.count = 1, .reusable = true}, SHIFT(151),
  [270] = {.count = 1, .reusable = true}, SHIFT(152),
  [272] = {.count = 1, .reusable = false}, SHIFT(157),
  [274] = {.count = 1, .reusable = false}, SHIFT(153),
  [276] = {.count = 1, .reusable = true}, REDUCE(sym__primary_expression, 1),
  [278] = {.count = 1, .reusable = false}, REDUCE(sym__primary_expression, 1),
  [280] = {.count = 1, .reusable = true}, SHIFT(159),
  [282] = {.count = 1, .reusable = true}, ACCEPT_INPUT(),
  [284] = {.count = 1, .reusable = true}, SHIFT(161),
  [286] = {.count = 1, .reusable = true}, SHIFT(162),
  [288] = {.count = 1, .reusable = true}, SHIFT(163),
  [290] = {.count = 1, .reusable = true}, REDUCE(sym_expression_statement, 1),
  [292] = {.count = 1, .reusable = true}, SHIFT(164),
  [294] = {.count = 1, .reusable = true}, SHIFT(165),
  [296] = {.count = 1, .reusable = true}, REDUCE(sym_expression_list, 1),
  [298] = {.count = 1, .reusable = true}, SHIFT(166),
  [300] = {.count = 1, .reusable = true}, SHIFT(167),
  [302] = {.count = 1, .reusable = true}, REDUCE(sym__expression, 1),
  [304] = {.count = 1, .reusable = true}, SHIFT(169),
  [306] = {.count = 1, .reusable = true}, SHIFT(170),
  [308] = {.count = 1, .reusable = false}, SHIFT(171),
  [310] = {.count = 1, .reusable = false}, SHIFT(172),
  [312] = {.count = 1, .reusable = true}, SHIFT(173),
  [314] = {.count = 1, .reusable = false}, REDUCE(sym__expression, 1),
  [316] = {.count = 1, .reusable = true}, SHIFT(174),
  [318] = {.count = 1, .reusable = false}, SHIFT(175),
  [320] = {.count = 1, .reusable = false}, SHIFT(176),
  [322] = {.count = 1, .reusable = false}, SHIFT(177),
  [324] = {.count = 1, .reusable = false}, SHIFT(178),
  [326] = {.count = 1, .reusable = false}, SHIFT(179),
  [328] = {.count = 1, .reusable = false}, SHIFT(173),
  [330] = {.count = 1, .reusable = true}, SHIFT(180),
  [332] = {.count = 1, .reusable = true}, SHIFT(181),
  [334] = {.count = 1, .reusable = true}, REDUCE(sym_module, 1),
  [336] = {.count = 1, .reusable = true}, SHIFT(185),
  [338] = {.count = 1, .reusable = true}, SHIFT(17),
  [340] = {.count = 1, .reusable = true}, SHIFT(21),
  [342] = {.count = 1, .reusable = true}, REDUCE(sym_dotted_name, 1),
  [344] = {.count = 1, .reusable = true}, SHIFT(188),
  [346] = {.count = 1, .reusable = true}, REDUCE(sym_import_statement, 2),
  [348] = {.count = 1, .reusable = true}, REDUCE(sym__import_list, 1),
  [350] = {.count = 1, .reusable = true}, SHIFT(190),
  [352] = {.count = 1, .reusable = true}, SHIFT(192),
  [354] = {.count = 1, .reusable = true}, SHIFT(193),
  [356] = {.count = 1, .reusable = false}, REDUCE(sym_relative_import, 1),
  [358] = {.count = 1, .reusable = false}, SHIFT(42),
  [360] = {.count = 1, .reusable = true}, SHIFT(196),
  [362] = {.count = 1, .reusable = false}, REDUCE(sym_import_prefix, 1),
  [364] = {.count = 1, .reusable = true}, SHIFT(197),
  [366] = {.count = 1, .reusable = true}, SHIFT(198),
  [368] = {.count = 1, .reusable = true}, SHIFT(199),
  [370] = {.count = 1, .reusable = true}, REDUCE(sym_tuple, 2),
  [372] = {.count = 1, .reusable = false}, REDUCE(sym_tuple, 2),
  [374] = {.count = 1, .reusable = true}, SHIFT(202),
  [376] = {.count = 1, .reusable = true}, SHIFT(204),
  [378] = {.count = 1, .reusable = false}, SHIFT(204),
  [380] = {.count = 1, .reusable = true}, SHIFT(205),
  [382] = {.count = 1, .reusable = false}, SHIFT(207),
  [384] = {.count = 1, .reusable = false}, SHIFT(208),
  [386] = {.count = 1, .reusable = true}, SHIFT(209),
  [388] = {.count = 1, .reusable = false}, SHIFT(210),
  [390] = {.count = 1, .reusable = true}, SHIFT(215),
  [392] = {.count = 1, .reusable = true}, SHIFT(211),
  [394] = {.count = 1, .reusable = false}, SHIFT(215),
  [396] = {.count = 1, .reusable = false}, SHIFT(212),
  [398] = {.count = 1, .reusable = true}, SHIFT(216),
  [400] = {.count = 1, .reusable = true}, SHIFT(217),
  [402] = {.count = 1, .reusable = true}, SHIFT(220),
  [404] = {.count = 1, .reusable = true}, SHIFT(221),
  [406] = {.count = 1, .reusable = true}, SHIFT(226),
  [408] = {.count = 1, .reusable = true}, SHIFT(228),
  [410] = {.count = 1, .reusable = true}, SHIFT(229),
  [412] = {.count = 1, .reusable = true}, SHIFT(230),
  [414] = {.count = 1, .reusable = true}, SHIFT(231),
  [416] = {.count = 1, .reusable = true}, SHIFT(232),
  [418] = {.count = 1, .reusable = true}, SHIFT(233),
  [420] = {.count = 1, .reusable = true}, SHIFT(234),
  [422] = {.count = 1, .reusable = true}, SHIFT(238),
  [424] = {.count = 1, .reusable = true}, SHIFT(239),
  [426] = {.count = 1, .reusable = false}, SHIFT(240),
  [428] = {.count = 1, .reusable = true}, SHIFT(241),
  [430] = {.count = 1, .reusable = true}, SHIFT(242),
  [432] = {.count = 1, .reusable = true}, SHIFT(240),
  [434] = {.count = 1, .reusable = true}, SHIFT(243),
  [436] = {.count = 1, .reusable = true}, SHIFT(244),
  [438] = {.count = 1, .reusable = true}, SHIFT(245),
  [440] = {.count = 1, .reusable = true}, SHIFT(246),
  [442] = {.count = 1, .reusable = true}, SHIFT(247),
  [444] = {.count = 1, .reusable = true}, SHIFT(248),
  [446] = {.count = 1, .reusable = false}, SHIFT(242),
  [448] = {.count = 1, .reusable = true}, SHIFT(249),
  [450] = {.count = 1, .reusable = true}, SHIFT(250),
  [452] = {.count = 1, .reusable = true}, SHIFT(253),
  [454] = {.count = 1, .reusable = true}, SHIFT(254),
  [456] = {.count = 1, .reusable = true}, SHIFT(259),
  [458] = {.count = 1, .reusable = false}, SHIFT(259),
  [460] = {.count = 1, .reusable = true}, SHIFT(260),
  [462] = {.count = 1, .reusable = true}, SHIFT(262),
  [464] = {.count = 1, .reusable = true}, SHIFT(263),
  [466] = {.count = 1, .reusable = true}, SHIFT(266),
  [468] = {.count = 1, .reusable = true}, SHIFT(267),
  [470] = {.count = 1, .reusable = true}, SHIFT(272),
  [472] = {.count = 1, .reusable = true}, REDUCE(sym_print_statement, 2),
  [474] = {.count = 1, .reusable = true}, SHIFT(273),
  [476] = {.count = 1, .reusable = true}, SHIFT(275),
  [478] = {.count = 1, .reusable = true}, SHIFT(276),
  [480] = {.count = 1, .reusable = true}, SHIFT(277),
  [482] = {.count = 1, .reusable = true}, SHIFT(278),
  [484] = {.count = 1, .reusable = true}, SHIFT(279),
  [486] = {.count = 1, .reusable = false}, SHIFT(280),
  [488] = {.count = 1, .reusable = true}, SHIFT(281),
  [490] = {.count = 1, .reusable = true}, SHIFT(282),
  [492] = {.count = 1, .reusable = true}, SHIFT(280),
  [494] = {.count = 1, .reusable = true}, SHIFT(283),
  [496] = {.count = 1, .reusable = true}, SHIFT(284),
  [498] = {.count = 1, .reusable = true}, SHIFT(285),
  [500] = {.count = 1, .reusable = true}, SHIFT(286),
  [502] = {.count = 1, .reusable = true}, SHIFT(287),
  [504] = {.count = 1, .reusable = true}, SHIFT(288),
  [506] = {.count = 1, .reusable = false}, SHIFT(282),
  [508] = {.count = 1, .reusable = true}, SHIFT(289),
  [510] = {.count = 1, .reusable = true}, SHIFT(290),
  [512] = {.count = 1, .reusable = true}, REDUCE(sym_assert_statement, 2),
  [514] = {.count = 1, .reusable = true}, SHIFT(293),
  [516] = {.count = 1, .reusable = true}, REDUCE(sym_return_statement, 2),
  [518] = {.count = 1, .reusable = true}, SHIFT(295),
  [520] = {.count = 1, .reusable = true}, REDUCE(sym_delete_statement, 2),
  [522] = {.count = 1, .reusable = false}, SHIFT(297),
  [524] = {.count = 1, .reusable = true}, SHIFT(298),
  [526] = {.count = 1, .reusable = false}, SHIFT(299),
  [528] = {.count = 1, .reusable = true}, SHIFT(303),
  [530] = {.count = 1, .reusable = true}, SHIFT(300),
  [532] = {.count = 1, .reusable = false}, SHIFT(303),
  [534] = {.count = 1, .reusable = false}, SHIFT(301),
  [536] = {.count = 1, .reusable = true}, SHIFT(305),
  [538] = {.count = 1, .reusable = true}, SHIFT(307),
  [540] = {.count = 1, .reusable = true}, REDUCE(sym_raise_statement, 2),
  [542] = {.count = 1, .reusable = true}, SHIFT(308),
  [544] = {.count = 1, .reusable = true}, SHIFT(309),
  [546] = {.count = 1, .reusable = true}, SHIFT(310),
  [548] = {.count = 1, .reusable = true}, SHIFT(311),
  [550] = {.count = 1, .reusable = true}, SHIFT(312),
  [552] = {.count = 1, .reusable = false}, SHIFT(314),
  [554] = {.count = 1, .reusable = true}, SHIFT(315),
  [556] = {.count = 1, .reusable = true}, SHIFT(316),
  [558] = {.count = 1, .reusable = true}, SHIFT(314),
  [560] = {.count = 1, .reusable = true}, SHIFT(317),
  [562] = {.count = 1, .reusable = true}, SHIFT(318),
  [564] = {.count = 1, .reusable = true}, SHIFT(319),
  [566] = {.count = 1, .reusable = true}, SHIFT(320),
  [568] = {.count = 1, .reusable = true}, SHIFT(321),
  [570] = {.count = 1, .reusable = true}, SHIFT(322),
  [572] = {.count = 1, .reusable = false}, SHIFT(316),
  [574] = {.count = 1, .reusable = true}, SHIFT(323),
  [576] = {.count = 1, .reusable = true}, REDUCE(sym__simple_statements, 2),
  [578] = {.count = 1, .reusable = false}, REDUCE(sym__simple_statements, 2),
  [580] = {.count = 1, .reusable = true}, SHIFT(325),
  [582] = {.count = 1, .reusable = false}, SHIFT(326),
  [584] = {.count = 1, .reusable = true}, SHIFT(327),
  [586] = {.count = 1, .reusable = true}, SHIFT(330),
  [588] = {.count = 1, .reusable = true}, SHIFT(332),
  [590] = {.count = 1, .reusable = true}, SHIFT(333),
  [592] = {.count = 1, .reusable = true}, SHIFT(334),
  [594] = {.count = 1, .reusable = true}, SHIFT(335),
  [596] = {.count = 1, .reusable = true}, SHIFT(336),
  [598] = {.count = 1, .reusable = false}, SHIFT(337),
  [600] = {.count = 1, .reusable = true}, SHIFT(338),
  [602] = {.count = 1, .reusable = true}, SHIFT(339),
  [604] = {.count = 1, .reusable = true}, SHIFT(337),
  [606] = {.count = 1, .reusable = true}, SHIFT(340),
  [608] = {.count = 1, .reusable = true}, SHIFT(341),
  [610] = {.count = 1, .reusable = true}, SHIFT(342),
  [612] = {.count = 1, .reusable = true}, SHIFT(343),
  [614] = {.count = 1, .reusable = true}, SHIFT(344),
  [616] = {.count = 1, .reusable = true}, SHIFT(345),
  [618] = {.count = 1, .reusable = false}, SHIFT(339),
  [620] = {.count = 1, .reusable = true}, SHIFT(346),
  [622] = {.count = 1, .reusable = true}, SHIFT(350),
  [624] = {.count = 1, .reusable = true}, SHIFT(351),
  [626] = {.count = 1, .reusable = true}, SHIFT(352),
  [628] = {.count = 1, .reusable = true}, SHIFT(353),
  [630] = {.count = 1, .reusable = false}, SHIFT(354),
  [632] = {.count = 1, .reusable = true}, SHIFT(355),
  [634] = {.count = 1, .reusable = true}, REDUCE(sym_variables, 1),
  [636] = {.count = 1, .reusable = true}, SHIFT(354),
  [638] = {.count = 1, .reusable = true}, SHIFT(356),
  [640] = {.count = 1, .reusable = true}, SHIFT(357),
  [642] = {.count = 1, .reusable = true}, SHIFT(358),
  [644] = {.count = 1, .reusable = true}, SHIFT(359),
  [646] = {.count = 1, .reusable = true}, SHIFT(360),
  [648] = {.count = 1, .reusable = true}, SHIFT(362),
  [650] = {.count = 1, .reusable = true}, SHIFT(363),
  [652] = {.count = 1, .reusable = false}, SHIFT(364),
  [654] = {.count = 1, .reusable = true}, SHIFT(367),
  [656] = {.count = 1, .reusable = true}, SHIFT(369),
  [658] = {.count = 1, .reusable = true}, SHIFT(370),
  [660] = {.count = 1, .reusable = true}, SHIFT(371),
  [662] = {.count = 1, .reusable = true}, REDUCE(sym_with_item, 1),
  [664] = {.count = 1, .reusable = true}, SHIFT(373),
  [666] = {.count = 1, .reusable = true}, SHIFT(374),
  [668] = {.count = 1, .reusable = true}, SHIFT(375),
  [670] = {.count = 1, .reusable = true}, SHIFT(376),
  [672] = {.count = 1, .reusable = false}, SHIFT(377),
  [674] = {.count = 1, .reusable = true}, SHIFT(378),
  [676] = {.count = 1, .reusable = true}, SHIFT(379),
  [678] = {.count = 1, .reusable = true}, SHIFT(377),
  [680] = {.count = 1, .reusable = true}, SHIFT(380),
  [682] = {.count = 1, .reusable = true}, SHIFT(381),
  [684] = {.count = 1, .reusable = true}, SHIFT(382),
  [686] = {.count = 1, .reusable = true}, SHIFT(383),
  [688] = {.count = 1, .reusable = true}, SHIFT(384),
  [690] = {.count = 1, .reusable = true}, SHIFT(385),
  [692] = {.count = 1, .reusable = false}, SHIFT(379),
  [694] = {.count = 1, .reusable = true}, SHIFT(386),
  [696] = {.count = 1, .reusable = true}, SHIFT(388),
  [698] = {.count = 1, .reusable = true}, REDUCE(sym_global_statement, 2),
  [700] = {.count = 1, .reusable = true}, SHIFT(390),
  [702] = {.count = 1, .reusable = true}, REDUCE(sym_nonlocal_statement, 2),
  [704] = {.count = 1, .reusable = true}, REDUCE(sym_exec_statement, 2),
  [706] = {.count = 1, .reusable = true}, SHIFT(393),
  [708] = {.count = 1, .reusable = true}, SHIFT(394),
  [710] = {.count = 1, .reusable = true}, SHIFT(395),
  [712] = {.count = 1, .reusable = true}, SHIFT(398),
  [714] = {.count = 1, .reusable = true}, SHIFT(399),
  [716] = {.count = 1, .reusable = true}, REDUCE(sym_not_operator, 2),
  [718] = {.count = 1, .reusable = true}, REDUCE(sym_unary_operator, 2),
  [720] = {.count = 1, .reusable = false}, REDUCE(sym_unary_operator, 2),
  [722] = {.count = 1, .reusable = true}, REDUCE(sym_list_splat, 1),
  [724] = {.count = 1, .reusable = true}, SHIFT(403),
  [726] = {.count = 1, .reusable = false}, SHIFT(404),
  [728] = {.count = 1, .reusable = true}, SHIFT(405),
  [730] = {.count = 1, .reusable = false}, SHIFT(406),
  [732] = {.count = 1, .reusable = true}, SHIFT(410),
  [734] = {.count = 1, .reusable = true}, SHIFT(407),
  [736] = {.count = 1, .reusable = false}, SHIFT(410),
  [738] = {.count = 1, .reusable = false}, SHIFT(408),
  [740] = {.count = 1, .reusable = true}, SHIFT(411),
  [742] = {.count = 1, .reusable = true}, REDUCE(sym__parameters, 1, .alias_sequence_id = 1),
  [744] = {.count = 1, .reusable = true}, SHIFT(413),
  [746] = {.count = 1, .reusable = true}, SHIFT(416),
  [748] = {.count = 1, .reusable = true}, REDUCE(sym__parameters, 1),
  [750] = {.count = 1, .reusable = true}, SHIFT(418),
  [752] = {.count = 1, .reusable = true}, SHIFT(420),
  [754] = {.count = 1, .reusable = true}, REDUCE(sym_lambda_parameters, 1),
  [756] = {.count = 1, .reusable = true}, REDUCE(sym_yield, 2),
  [758] = {.count = 1, .reusable = true}, SHIFT(423),
  [760] = {.count = 1, .reusable = false}, SHIFT(424),
  [762] = {.count = 1, .reusable = true}, SHIFT(425),
  [764] = {.count = 1, .reusable = false}, SHIFT(426),
  [766] = {.count = 1, .reusable = true}, SHIFT(430),
  [768] = {.count = 1, .reusable = true}, SHIFT(427),
  [770] = {.count = 1, .reusable = false}, SHIFT(430),
  [772] = {.count = 1, .reusable = false}, SHIFT(428),
  [774] = {.count = 1, .reusable = true}, SHIFT(432),
  [776] = {.count = 1, .reusable = true}, REDUCE(sym_list, 2),
  [778] = {.count = 1, .reusable = false}, REDUCE(sym_list, 2),
  [780] = {.count = 1, .reusable = true}, SHIFT(434),
  [782] = {.count = 1, .reusable = true}, SHIFT(435),
  [784] = {.count = 1, .reusable = true}, SHIFT(437),
  [786] = {.count = 1, .reusable = true}, SHIFT(438),
  [788] = {.count = 1, .reusable = true}, SHIFT(439),
  [790] = {.count = 1, .reusable = true}, SHIFT(440),
  [792] = {.count = 1, .reusable = true}, SHIFT(441),
  [794] = {.count = 1, .reusable = false}, SHIFT(444),
  [796] = {.count = 1, .reusable = true}, SHIFT(445),
  [798] = {.count = 1, .reusable = true}, SHIFT(446),
  [800] = {.count = 1, .reusable = true}, SHIFT(444),
  [802] = {.count = 1, .reusable = true}, SHIFT(447),
  [804] = {.count = 1, .reusable = true}, SHIFT(448),
  [806] = {.count = 1, .reusable = true}, SHIFT(449),
  [808] = {.count = 1, .reusable = true}, SHIFT(450),
  [810] = {.count = 1, .reusable = true}, SHIFT(451),
  [812] = {.count = 1, .reusable = true}, SHIFT(452),
  [814] = {.count = 1, .reusable = false}, SHIFT(446),
  [816] = {.count = 1, .reusable = true}, SHIFT(453),
  [818] = {.count = 1, .reusable = true}, SHIFT(455),
  [820] = {.count = 1, .reusable = true}, SHIFT(456),
  [822] = {.count = 1, .reusable = false}, SHIFT(457),
  [824] = {.count = 1, .reusable = true}, SHIFT(458),
  [826] = {.count = 1, .reusable = false}, SHIFT(459),
  [828] = {.count = 1, .reusable = true}, SHIFT(463),
  [830] = {.count = 1, .reusable = true}, SHIFT(460),
  [832] = {.count = 1, .reusable = false}, SHIFT(463),
  [834] = {.count = 1, .reusable = false}, SHIFT(461),
  [836] = {.count = 1, .reusable = true}, SHIFT(465),
  [838] = {.count = 1, .reusable = true}, REDUCE(sym_dictionary, 2),
  [840] = {.count = 1, .reusable = false}, REDUCE(sym_dictionary, 2),
  [842] = {.count = 1, .reusable = true}, SHIFT(467),
  [844] = {.count = 1, .reusable = true}, SHIFT(468),
  [846] = {.count = 1, .reusable = true}, SHIFT(469),
  [848] = {.count = 1, .reusable = true}, SHIFT(471),
  [850] = {.count = 1, .reusable = true}, SHIFT(473),
  [852] = {.count = 1, .reusable = true}, SHIFT(474),
  [854] = {.count = 1, .reusable = true}, SHIFT(475),
  [856] = {.count = 1, .reusable = true}, SHIFT(476),
  [858] = {.count = 1, .reusable = true}, SHIFT(477),
  [860] = {.count = 1, .reusable = true}, SHIFT(478),
  [862] = {.count = 1, .reusable = false}, SHIFT(481),
  [864] = {.count = 1, .reusable = true}, SHIFT(482),
  [866] = {.count = 1, .reusable = true}, SHIFT(483),
  [868] = {.count = 1, .reusable = true}, SHIFT(481),
  [870] = {.count = 1, .reusable = true}, SHIFT(484),
  [872] = {.count = 1, .reusable = true}, SHIFT(485),
  [874] = {.count = 1, .reusable = true}, SHIFT(486),
  [876] = {.count = 1, .reusable = true}, SHIFT(487),
  [878] = {.count = 1, .reusable = true}, SHIFT(488),
  [880] = {.count = 1, .reusable = true}, SHIFT(489),
  [882] = {.count = 1, .reusable = false}, SHIFT(483),
  [884] = {.count = 1, .reusable = true}, SHIFT(490),
  [886] = {.count = 1, .reusable = true}, REDUCE(sym_concatenated_string, 2),
  [888] = {.count = 1, .reusable = false}, REDUCE(sym_concatenated_string, 2),
  [890] = {.count = 1, .reusable = true}, SHIFT(493),
  [892] = {.count = 1, .reusable = true}, REDUCE(sym_await, 2),
  [894] = {.count = 1, .reusable = false}, SHIFT(494),
  [896] = {.count = 1, .reusable = true}, SHIFT(495),
  [898] = {.count = 1, .reusable = false}, SHIFT(496),
  [900] = {.count = 1, .reusable = true}, SHIFT(500),
  [902] = {.count = 1, .reusable = true}, SHIFT(497),
  [904] = {.count = 1, .reusable = false}, SHIFT(500),
  [906] = {.count = 1, .reusable = false}, SHIFT(498),
  [908] = {.count = 1, .reusable = true}, REDUCE(sym_expression_statement, 2),
  [910] = {.count = 1, .reusable = true}, REDUCE(sym_expression_list, 2),
  [912] = {.count = 1, .reusable = false}, SHIFT(24),
  [914] = {.count = 1, .reusable = false}, SHIFT(507),
  [916] = {.count = 1, .reusable = true}, SHIFT(508),
  [918] = {.count = 1, .reusable = false}, SHIFT(509),
  [920] = {.count = 1, .reusable = true}, SHIFT(513),
  [922] = {.count = 1, .reusable = true}, SHIFT(510),
  [924] = {.count = 1, .reusable = false}, SHIFT(513),
  [926] = {.count = 1, .reusable = false}, SHIFT(511),
  [928] = {.count = 1, .reusable = true}, SHIFT(516),
  [930] = {.count = 1, .reusable = true}, SHIFT(518),
  [932] = {.count = 1, .reusable = true}, SHIFT(519),
  [934] = {.count = 1, .reusable = true}, SHIFT(520),
  [936] = {.count = 1, .reusable = true}, SHIFT(521),
  [938] = {.count = 1, .reusable = false}, SHIFT(522),
  [940] = {.count = 1, .reusable = false}, SHIFT(523),
  [942] = {.count = 1, .reusable = true}, SHIFT(526),
  [944] = {.count = 1, .reusable = false}, SHIFT(526),
  [946] = {.count = 1, .reusable = true}, SHIFT(527),
  [948] = {.count = 1, .reusable = false}, SHIFT(527),
  [950] = {.count = 1, .reusable = true}, SHIFT(528),
  [952] = {.count = 1, .reusable = false}, SHIFT(528),
  [954] = {.count = 1, .reusable = true}, SHIFT(529),
  [956] = {.count = 1, .reusable = true}, SHIFT(530),
  [958] = {.count = 1, .reusable = false}, SHIFT(530),
  [960] = {.count = 1, .reusable = true}, SHIFT(531),
  [962] = {.count = 1, .reusable = false}, SHIFT(531),
  [964] = {.count = 1, .reusable = true}, SHIFT(532),
  [966] = {.count = 1, .reusable = false}, SHIFT(532),
  [968] = {.count = 1, .reusable = true}, SHIFT(533),
  [970] = {.count = 1, .reusable = false}, SHIFT(533),
  [972] = {.count = 1, .reusable = true}, SHIFT(534),
  [974] = {.count = 1, .reusable = false}, SHIFT(534),
  [976] = {.count = 1, .reusable = false}, SHIFT(529),
  [978] = {.count = 1, .reusable = true}, SHIFT(535),
  [980] = {.count = 1, .reusable = false}, SHIFT(536),
  [982] = {.count = 1, .reusable = true}, SHIFT(537),
  [984] = {.count = 1, .reusable = false}, SHIFT(538),
  [986] = {.count = 1, .reusable = true}, SHIFT(542),
  [988] = {.count = 1, .reusable = true}, SHIFT(539),
  [990] = {.count = 1, .reusable = false}, SHIFT(542),
  [992] = {.count = 1, .reusable = false}, SHIFT(540),
  [994] = {.count = 1, .reusable = true}, REDUCE(sym_call, 2),
  [996] = {.count = 1, .reusable = false}, REDUCE(sym_call, 2),
  [998] = {.count = 1, .reusable = true}, REDUCE(sym_comparison_operator, 2),
  [1000] = {.count = 1, .reusable = false}, REDUCE(sym_comparison_operator, 2),
  [1002] = {.count = 1, .reusable = true}, REDUCE(aux_sym_module_repeat1, 2),
  [1004] = {.count = 2, .reusable = false}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(2),
  [1007] = {.count = 2, .reusable = false}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(3),
  [1010] = {.count = 2, .reusable = true}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(4),
  [1013] = {.count = 2, .reusable = false}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(5),
  [1016] = {.count = 2, .reusable = false}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(6),
  [1019] = {.count = 2, .reusable = false}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(7),
  [1022] = {.count = 2, .reusable = false}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(8),
  [1025] = {.count = 2, .reusable = false}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(9),
  [1028] = {.count = 2, .reusable = false}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(10),
  [1031] = {.count = 2, .reusable = false}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(11),
  [1034] = {.count = 2, .reusable = false}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(12),
  [1037] = {.count = 2, .reusable = false}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(13),
  [1040] = {.count = 2, .reusable = false}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(14),
  [1043] = {.count = 2, .reusable = false}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(15),
  [1046] = {.count = 2, .reusable = false}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(16),
  [1049] = {.count = 2, .reusable = false}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(17),
  [1052] = {.count = 2, .reusable = false}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(18),
  [1055] = {.count = 2, .reusable = false}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(19),
  [1058] = {.count = 2, .reusable = false}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(20),
  [1061] = {.count = 2, .reusable = false}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(21),
  [1064] = {.count = 2, .reusable = true}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(22),
  [1067] = {.count = 2, .reusable = false}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(23),
  [1070] = {.count = 2, .reusable = true}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(24),
  [1073] = {.count = 2, .reusable = false}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(25),
  [1076] = {.count = 2, .reusable = false}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(26),
  [1079] = {.count = 2, .reusable = true}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(27),
  [1082] = {.count = 2, .reusable = true}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(34),
  [1085] = {.count = 2, .reusable = true}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(28),
  [1088] = {.count = 2, .reusable = true}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(29),
  [1091] = {.count = 2, .reusable = false}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(34),
  [1094] = {.count = 2, .reusable = false}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(30),
  [1097] = {.count = 1, .reusable = true}, REDUCE(sym_decorated_definition, 2),
  [1099] = {.count = 1, .reusable = false}, REDUCE(sym_decorated_definition, 2),
  [1101] = {.count = 1, .reusable = true}, REDUCE(aux_sym_decorated_definition_repeat1, 2),
  [1103] = {.count = 2, .reusable = true}, REDUCE(aux_sym_decorated_definition_repeat1, 2), SHIFT_REPEAT(22),
  [1106] = {.count = 1, .reusable = true}, SHIFT(545),
  [1108] = {.count = 1, .reusable = true}, REDUCE(sym_dotted_name, 2),
  [1110] = {.count = 1, .reusable = true}, REDUCE(sym__import_list, 2),
  [1112] = {.count = 1, .reusable = true}, SHIFT(549),
  [1114] = {.count = 1, .reusable = true}, SHIFT(551),
  [1116] = {.count = 1, .reusable = true}, SHIFT(552),
  [1118] = {.count = 1, .reusable = true}, REDUCE(sym_relative_import, 2),
  [1120] = {.count = 1, .reusable = true}, SHIFT(554),
  [1122] = {.count = 1, .reusable = true}, SHIFT(555),
  [1124] = {.count = 1, .reusable = false}, REDUCE(aux_sym_import_prefix_repeat1, 2),
  [1126] = {.count = 2, .reusable = true}, REDUCE(aux_sym_import_prefix_repeat1, 2), SHIFT_REPEAT(197),
  [1129] = {.count = 1, .reusable = true}, SHIFT(557),
  [1131] = {.count = 1, .reusable = true}, SHIFT(558),
  [1133] = {.count = 1, .reusable = true}, SHIFT(559),
  [1135] = {.count = 1, .reusable = true}, REDUCE(sym_tuple, 3),
  [1137] = {.count = 1, .reusable = false}, REDUCE(sym_tuple, 3),
  [1139] = {.count = 1, .reusable = true}, SHIFT(563),
  [1141] = {.count = 1, .reusable = true}, SHIFT(566),
  [1143] = {.count = 1, .reusable = true}, SHIFT(568),
  [1145] = {.count = 1, .reusable = true}, SHIFT(569),
  [1147] = {.count = 1, .reusable = true}, SHIFT(570),
  [1149] = {.count = 1, .reusable = true}, SHIFT(571),
  [1151] = {.count = 1, .reusable = true}, SHIFT(572),
  [1153] = {.count = 1, .reusable = false}, SHIFT(574),
  [1155] = {.count = 1, .reusable = true}, SHIFT(575),
  [1157] = {.count = 1, .reusable = true}, SHIFT(576),
  [1159] = {.count = 1, .reusable = true}, SHIFT(574),
  [1161] = {.count = 1, .reusable = true}, SHIFT(577),
  [1163] = {.count = 1, .reusable = true}, SHIFT(578),
  [1165] = {.count = 1, .reusable = true}, SHIFT(579),
  [1167] = {.count = 1, .reusable = true}, SHIFT(580),
  [1169] = {.count = 1, .reusable = true}, SHIFT(581),
  [1171] = {.count = 1, .reusable = true}, SHIFT(582),
  [1173] = {.count = 1, .reusable = false}, SHIFT(576),
  [1175] = {.count = 1, .reusable = true}, SHIFT(583),
  [1177] = {.count = 1, .reusable = true}, SHIFT(585),
  [1179] = {.count = 1, .reusable = true}, SHIFT(586),
  [1181] = {.count = 1, .reusable = true}, SHIFT(589),
  [1183] = {.count = 1, .reusable = true}, SHIFT(590),
  [1185] = {.count = 1, .reusable = true}, SHIFT(591),
  [1187] = {.count = 1, .reusable = true}, SHIFT(593),
  [1189] = {.count = 1, .reusable = true}, SHIFT(597),
  [1191] = {.count = 1, .reusable = false}, REDUCE(sym_await, 2),
  [1193] = {.count = 1, .reusable = true}, REDUCE(sym_parenthesized_expression, 3),
  [1195] = {.count = 1, .reusable = false}, REDUCE(sym_parenthesized_expression, 3),
  [1197] = {.count = 1, .reusable = true}, SHIFT(598),
  [1199] = {.count = 1, .reusable = true}, SHIFT(602),
  [1201] = {.count = 1, .reusable = true}, SHIFT(606),
  [1203] = {.count = 1, .reusable = true}, REDUCE(sym__comprehension_body, 1),
  [1205] = {.count = 1, .reusable = true}, SHIFT(607),
  [1207] = {.count = 1, .reusable = true}, SHIFT(609),
  [1209] = {.count = 1, .reusable = true}, SHIFT(611),
  [1211] = {.count = 1, .reusable = true}, SHIFT(612),
  [1213] = {.count = 1, .reusable = true}, SHIFT(613),
  [1215] = {.count = 1, .reusable = true}, SHIFT(616),
  [1217] = {.count = 1, .reusable = false}, SHIFT(616),
  [1219] = {.count = 1, .reusable = true}, SHIFT(617),
  [1221] = {.count = 1, .reusable = false}, SHIFT(617),
  [1223] = {.count = 1, .reusable = true}, SHIFT(618),
  [1225] = {.count = 1, .reusable = false}, SHIFT(618),
  [1227] = {.count = 1, .reusable = true}, SHIFT(619),
  [1229] = {.count = 1, .reusable = true}, SHIFT(620),
  [1231] = {.count = 1, .reusable = false}, SHIFT(620),
  [1233] = {.count = 1, .reusable = true}, SHIFT(621),
  [1235] = {.count = 1, .reusable = false}, SHIFT(621),
  [1237] = {.count = 1, .reusable = true}, SHIFT(622),
  [1239] = {.count = 1, .reusable = false}, SHIFT(622),
  [1241] = {.count = 1, .reusable = true}, SHIFT(623),
  [1243] = {.count = 1, .reusable = false}, SHIFT(623),
  [1245] = {.count = 1, .reusable = true}, SHIFT(624),
  [1247] = {.count = 1, .reusable = false}, SHIFT(624),
  [1249] = {.count = 1, .reusable = false}, SHIFT(619),
  [1251] = {.count = 1, .reusable = true}, SHIFT(628),
  [1253] = {.count = 1, .reusable = true}, SHIFT(629),
  [1255] = {.count = 1, .reusable = true}, SHIFT(630),
  [1257] = {.count = 1, .reusable = true}, REDUCE(sym_chevron, 2),
  [1259] = {.count = 1, .reusable = true}, SHIFT(634),
  [1261] = {.count = 1, .reusable = true}, SHIFT(635),
  [1263] = {.count = 1, .reusable = true}, SHIFT(636),
  [1265] = {.count = 1, .reusable = true}, SHIFT(639),
  [1267] = {.count = 1, .reusable = true}, SHIFT(640),
  [1269] = {.count = 1, .reusable = true}, SHIFT(641),
  [1271] = {.count = 1, .reusable = true}, SHIFT(643),
  [1273] = {.count = 1, .reusable = true}, SHIFT(647),
  [1275] = {.count = 1, .reusable = true}, REDUCE(sym_print_statement, 3),
  [1277] = {.count = 1, .reusable = true}, SHIFT(649),
  [1279] = {.count = 1, .reusable = true}, SHIFT(653),
  [1281] = {.count = 1, .reusable = true}, SHIFT(654),
  [1283] = {.count = 1, .reusable = true}, SHIFT(655),
  [1285] = {.count = 1, .reusable = true}, SHIFT(658),
  [1287] = {.count = 1, .reusable = false}, SHIFT(658),
  [1289] = {.count = 1, .reusable = true}, SHIFT(659),
  [1291] = {.count = 1, .reusable = false}, SHIFT(659),
  [1293] = {.count = 1, .reusable = true}, SHIFT(660),
  [1295] = {.count = 1, .reusable = false}, SHIFT(660),
  [1297] = {.count = 1, .reusable = true}, SHIFT(661),
  [1299] = {.count = 1, .reusable = true}, SHIFT(662),
  [1301] = {.count = 1, .reusable = false}, SHIFT(662),
  [1303] = {.count = 1, .reusable = true}, SHIFT(663),
  [1305] = {.count = 1, .reusable = false}, SHIFT(663),
  [1307] = {.count = 1, .reusable = true}, SHIFT(664),
  [1309] = {.count = 1, .reusable = false}, SHIFT(664),
  [1311] = {.count = 1, .reusable = true}, SHIFT(665),
  [1313] = {.count = 1, .reusable = false}, SHIFT(665),
  [1315] = {.count = 1, .reusable = true}, SHIFT(666),
  [1317] = {.count = 1, .reusable = false}, SHIFT(666),
  [1319] = {.count = 1, .reusable = false}, SHIFT(661),
  [1321] = {.count = 1, .reusable = true}, REDUCE(sym_assert_statement, 3),
  [1323] = {.count = 1, .reusable = true}, SHIFT(670),
  [1325] = {.count = 1, .reusable = true}, SHIFT(672),
  [1327] = {.count = 1, .reusable = true}, SHIFT(674),
  [1329] = {.count = 1, .reusable = true}, REDUCE(sym_raise_statement, 3),
  [1331] = {.count = 1, .reusable = true}, SHIFT(675),
  [1333] = {.count = 1, .reusable = true}, SHIFT(676),
  [1335] = {.count = 1, .reusable = true}, SHIFT(677),
  [1337] = {.count = 1, .reusable = false}, SHIFT(678),
  [1339] = {.count = 1, .reusable = true}, SHIFT(679),
  [1341] = {.count = 1, .reusable = true}, SHIFT(680),
  [1343] = {.count = 1, .reusable = true}, SHIFT(678),
  [1345] = {.count = 1, .reusable = true}, SHIFT(681),
  [1347] = {.count = 1, .reusable = true}, SHIFT(682),
  [1349] = {.count = 1, .reusable = true}, SHIFT(683),
  [1351] = {.count = 1, .reusable = true}, SHIFT(684),
  [1353] = {.count = 1, .reusable = true}, SHIFT(685),
  [1355] = {.count = 1, .reusable = true}, SHIFT(686),
  [1357] = {.count = 1, .reusable = false}, SHIFT(680),
  [1359] = {.count = 1, .reusable = true}, SHIFT(687),
  [1361] = {.count = 1, .reusable = true}, SHIFT(690),
  [1363] = {.count = 1, .reusable = true}, SHIFT(691),
  [1365] = {.count = 1, .reusable = false}, REDUCE(sym_expression_list, 2),
  [1367] = {.count = 1, .reusable = true}, SHIFT(696),
  [1369] = {.count = 1, .reusable = true}, SHIFT(698),
  [1371] = {.count = 1, .reusable = false}, SHIFT(698),
  [1373] = {.count = 1, .reusable = true}, SHIFT(699),
  [1375] = {.count = 1, .reusable = false}, SHIFT(699),
  [1377] = {.count = 1, .reusable = true}, SHIFT(700),
  [1379] = {.count = 1, .reusable = false}, SHIFT(700),
  [1381] = {.count = 1, .reusable = true}, SHIFT(701),
  [1383] = {.count = 1, .reusable = true}, SHIFT(702),
  [1385] = {.count = 1, .reusable = false}, SHIFT(702),
  [1387] = {.count = 1, .reusable = true}, SHIFT(703),
  [1389] = {.count = 1, .reusable = false}, SHIFT(703),
  [1391] = {.count = 1, .reusable = true}, SHIFT(704),
  [1393] = {.count = 1, .reusable = false}, SHIFT(704),
  [1395] = {.count = 1, .reusable = true}, SHIFT(705),
  [1397] = {.count = 1, .reusable = false}, SHIFT(705),
  [1399] = {.count = 1, .reusable = false}, SHIFT(701),
  [1401] = {.count = 1, .reusable = true}, REDUCE(sym__simple_statements, 3),
  [1403] = {.count = 1, .reusable = false}, REDUCE(sym__simple_statements, 3),
  [1405] = {.count = 1, .reusable = true}, REDUCE(aux_sym__simple_statements_repeat1, 2),
  [1407] = {.count = 1, .reusable = true}, SHIFT(707),
  [1409] = {.count = 2, .reusable = true}, REDUCE(aux_sym__simple_statements_repeat1, 2), SHIFT_REPEAT(708),
  [1412] = {.count = 1, .reusable = true}, SHIFT(710),
  [1414] = {.count = 1, .reusable = true}, SHIFT(711),
  [1416] = {.count = 1, .reusable = true}, SHIFT(713),
  [1418] = {.count = 1, .reusable = false}, SHIFT(714),
  [1420] = {.count = 1, .reusable = true}, SHIFT(717),
  [1422] = {.count = 1, .reusable = false}, SHIFT(717),
  [1424] = {.count = 1, .reusable = true}, SHIFT(718),
  [1426] = {.count = 1, .reusable = false}, SHIFT(718),
  [1428] = {.count = 1, .reusable = true}, SHIFT(719),
  [1430] = {.count = 1, .reusable = false}, SHIFT(719),
  [1432] = {.count = 1, .reusable = true}, SHIFT(720),
  [1434] = {.count = 1, .reusable = true}, SHIFT(721),
  [1436] = {.count = 1, .reusable = false}, SHIFT(721),
  [1438] = {.count = 1, .reusable = true}, SHIFT(722),
  [1440] = {.count = 1, .reusable = false}, SHIFT(722),
  [1442] = {.count = 1, .reusable = true}, SHIFT(723),
  [1444] = {.count = 1, .reusable = false}, SHIFT(723),
  [1446] = {.count = 1, .reusable = true}, SHIFT(724),
  [1448] = {.count = 1, .reusable = false}, SHIFT(724),
  [1450] = {.count = 1, .reusable = false}, SHIFT(720),
  [1452] = {.count = 1, .reusable = true}, SHIFT(726),
  [1454] = {.count = 1, .reusable = true}, SHIFT(727),
  [1456] = {.count = 1, .reusable = true}, SHIFT(730),
  [1458] = {.count = 1, .reusable = false}, REDUCE(sym_variables, 2),
  [1460] = {.count = 1, .reusable = true}, SHIFT(733),
  [1462] = {.count = 1, .reusable = false}, SHIFT(733),
  [1464] = {.count = 1, .reusable = true}, SHIFT(734),
  [1466] = {.count = 1, .reusable = false}, SHIFT(734),
  [1468] = {.count = 1, .reusable = true}, SHIFT(735),
  [1470] = {.count = 1, .reusable = false}, SHIFT(735),
  [1472] = {.count = 1, .reusable = true}, SHIFT(736),
  [1474] = {.count = 1, .reusable = false}, SHIFT(736),
  [1476] = {.count = 1, .reusable = true}, SHIFT(737),
  [1478] = {.count = 1, .reusable = false}, SHIFT(737),
  [1480] = {.count = 1, .reusable = true}, SHIFT(738),
  [1482] = {.count = 1, .reusable = false}, SHIFT(738),
  [1484] = {.count = 1, .reusable = true}, SHIFT(739),
  [1486] = {.count = 1, .reusable = false}, SHIFT(739),
  [1488] = {.count = 1, .reusable = true}, SHIFT(740),
  [1490] = {.count = 1, .reusable = true}, REDUCE(sym_variables, 2),
  [1492] = {.count = 1, .reusable = true}, SHIFT(742),
  [1494] = {.count = 1, .reusable = false}, SHIFT(743),
  [1496] = {.count = 1, .reusable = true}, SHIFT(745),
  [1498] = {.count = 1, .reusable = false}, SHIFT(746),
  [1500] = {.count = 1, .reusable = false}, SHIFT(747),
  [1502] = {.count = 1, .reusable = false}, SHIFT(748),
  [1504] = {.count = 1, .reusable = false}, SHIFT(749),
  [1506] = {.count = 1, .reusable = false}, SHIFT(750),
  [1508] = {.count = 1, .reusable = false}, SHIFT(751),
  [1510] = {.count = 1, .reusable = false}, SHIFT(752),
  [1512] = {.count = 1, .reusable = false}, SHIFT(753),
  [1514] = {.count = 1, .reusable = false}, SHIFT(754),
  [1516] = {.count = 1, .reusable = true}, SHIFT(757),
  [1518] = {.count = 1, .reusable = true}, SHIFT(758),
  [1520] = {.count = 1, .reusable = true}, SHIFT(760),
  [1522] = {.count = 1, .reusable = true}, SHIFT(761),
  [1524] = {.count = 1, .reusable = true}, SHIFT(765),
  [1526] = {.count = 1, .reusable = true}, SHIFT(766),
  [1528] = {.count = 1, .reusable = true}, SHIFT(768),
  [1530] = {.count = 1, .reusable = true}, SHIFT(774),
  [1532] = {.count = 1, .reusable = false}, SHIFT(774),
  [1534] = {.count = 1, .reusable = true}, SHIFT(775),
  [1536] = {.count = 1, .reusable = false}, SHIFT(775),
  [1538] = {.count = 1, .reusable = true}, SHIFT(776),
  [1540] = {.count = 1, .reusable = false}, SHIFT(776),
  [1542] = {.count = 1, .reusable = true}, SHIFT(777),
  [1544] = {.count = 1, .reusable = true}, SHIFT(778),
  [1546] = {.count = 1, .reusable = false}, SHIFT(778),
  [1548] = {.count = 1, .reusable = true}, SHIFT(779),
  [1550] = {.count = 1, .reusable = false}, SHIFT(779),
  [1552] = {.count = 1, .reusable = true}, SHIFT(780),
  [1554] = {.count = 1, .reusable = false}, SHIFT(780),
  [1556] = {.count = 1, .reusable = true}, SHIFT(781),
  [1558] = {.count = 1, .reusable = false}, SHIFT(781),
  [1560] = {.count = 1, .reusable = false}, SHIFT(777),
  [1562] = {.count = 1, .reusable = true}, SHIFT(783),
  [1564] = {.count = 1, .reusable = true}, SHIFT(784),
  [1566] = {.count = 1, .reusable = false}, SHIFT(785),
  [1568] = {.count = 1, .reusable = false}, SHIFT(786),
  [1570] = {.count = 1, .reusable = true}, SHIFT(790),
  [1572] = {.count = 1, .reusable = true}, SHIFT(791),
  [1574] = {.count = 1, .reusable = true}, SHIFT(792),
  [1576] = {.count = 1, .reusable = true}, REDUCE(sym_global_statement, 3),
  [1578] = {.count = 1, .reusable = true}, REDUCE(sym_nonlocal_statement, 3),
  [1580] = {.count = 1, .reusable = true}, SHIFT(797),
  [1582] = {.count = 1, .reusable = true}, REDUCE(sym_decorator, 3),
  [1584] = {.count = 1, .reusable = true}, SHIFT(800),
  [1586] = {.count = 1, .reusable = true}, SHIFT(803),
  [1588] = {.count = 1, .reusable = true}, SHIFT(805),
  [1590] = {.count = 1, .reusable = true}, REDUCE(sym_list_splat, 2),
  [1592] = {.count = 1, .reusable = true}, SHIFT(806),
  [1594] = {.count = 1, .reusable = true}, SHIFT(807),
  [1596] = {.count = 1, .reusable = true}, SHIFT(808),
  [1598] = {.count = 1, .reusable = false}, SHIFT(809),
  [1600] = {.count = 1, .reusable = true}, SHIFT(810),
  [1602] = {.count = 1, .reusable = true}, SHIFT(811),
  [1604] = {.count = 1, .reusable = true}, SHIFT(809),
  [1606] = {.count = 1, .reusable = true}, SHIFT(812),
  [1608] = {.count = 1, .reusable = true}, SHIFT(813),
  [1610] = {.count = 1, .reusable = true}, SHIFT(814),
  [1612] = {.count = 1, .reusable = true}, SHIFT(815),
  [1614] = {.count = 1, .reusable = true}, SHIFT(816),
  [1616] = {.count = 1, .reusable = true}, SHIFT(817),
  [1618] = {.count = 1, .reusable = false}, SHIFT(811),
  [1620] = {.count = 1, .reusable = true}, SHIFT(818),
  [1622] = {.count = 1, .reusable = false}, SHIFT(820),
  [1624] = {.count = 1, .reusable = true}, REDUCE(sym__parameters, 2, .alias_sequence_id = 1),
  [1626] = {.count = 1, .reusable = false}, SHIFT(821),
  [1628] = {.count = 1, .reusable = false}, SHIFT(824),
  [1630] = {.count = 1, .reusable = true}, SHIFT(825),
  [1632] = {.count = 1, .reusable = false}, SHIFT(826),
  [1634] = {.count = 1, .reusable = true}, SHIFT(830),
  [1636] = {.count = 1, .reusable = true}, SHIFT(827),
  [1638] = {.count = 1, .reusable = false}, SHIFT(830),
  [1640] = {.count = 1, .reusable = false}, SHIFT(828),
  [1642] = {.count = 1, .reusable = true}, SHIFT(833),
  [1644] = {.count = 1, .reusable = true}, REDUCE(sym_lambda, 3),
  [1646] = {.count = 1, .reusable = true}, REDUCE(sym__parameters, 2),
  [1648] = {.count = 1, .reusable = false}, SHIFT(835),
  [1650] = {.count = 1, .reusable = true}, SHIFT(836),
  [1652] = {.count = 1, .reusable = false}, SHIFT(837),
  [1654] = {.count = 1, .reusable = true}, SHIFT(841),
  [1656] = {.count = 1, .reusable = true}, SHIFT(838),
  [1658] = {.count = 1, .reusable = false}, SHIFT(841),
  [1660] = {.count = 1, .reusable = false}, SHIFT(839),
  [1662] = {.count = 1, .reusable = true}, SHIFT(844),
  [1664] = {.count = 1, .reusable = true}, REDUCE(sym_yield, 3),
  [1666] = {.count = 1, .reusable = true}, REDUCE(sym_list, 3),
  [1668] = {.count = 1, .reusable = false}, REDUCE(sym_list, 3),
  [1670] = {.count = 1, .reusable = true}, SHIFT(849),
  [1672] = {.count = 1, .reusable = true}, SHIFT(851),
  [1674] = {.count = 1, .reusable = true}, SHIFT(852),
  [1676] = {.count = 1, .reusable = true}, SHIFT(853),
  [1678] = {.count = 1, .reusable = true}, SHIFT(854),
  [1680] = {.count = 1, .reusable = false}, SHIFT(855),
  [1682] = {.count = 1, .reusable = true}, SHIFT(856),
  [1684] = {.count = 1, .reusable = true}, SHIFT(857),
  [1686] = {.count = 1, .reusable = true}, SHIFT(855),
  [1688] = {.count = 1, .reusable = true}, SHIFT(858),
  [1690] = {.count = 1, .reusable = true}, SHIFT(859),
  [1692] = {.count = 1, .reusable = true}, SHIFT(860),
  [1694] = {.count = 1, .reusable = true}, SHIFT(861),
  [1696] = {.count = 1, .reusable = true}, SHIFT(862),
  [1698] = {.count = 1, .reusable = true}, SHIFT(863),
  [1700] = {.count = 1, .reusable = false}, SHIFT(857),
  [1702] = {.count = 1, .reusable = true}, SHIFT(864),
  [1704] = {.count = 1, .reusable = true}, SHIFT(867),
  [1706] = {.count = 1, .reusable = true}, SHIFT(868),
  [1708] = {.count = 1, .reusable = true}, SHIFT(869),
  [1710] = {.count = 1, .reusable = true}, SHIFT(872),
  [1712] = {.count = 1, .reusable = true}, SHIFT(875),
  [1714] = {.count = 1, .reusable = true}, SHIFT(878),
  [1716] = {.count = 1, .reusable = true}, SHIFT(879),
  [1718] = {.count = 1, .reusable = true}, SHIFT(881),
  [1720] = {.count = 1, .reusable = false}, SHIFT(881),
  [1722] = {.count = 1, .reusable = true}, SHIFT(882),
  [1724] = {.count = 1, .reusable = false}, SHIFT(882),
  [1726] = {.count = 1, .reusable = true}, SHIFT(883),
  [1728] = {.count = 1, .reusable = false}, SHIFT(883),
  [1730] = {.count = 1, .reusable = true}, SHIFT(884),
  [1732] = {.count = 1, .reusable = true}, SHIFT(885),
  [1734] = {.count = 1, .reusable = false}, SHIFT(885),
  [1736] = {.count = 1, .reusable = true}, SHIFT(886),
  [1738] = {.count = 1, .reusable = false}, SHIFT(886),
  [1740] = {.count = 1, .reusable = true}, SHIFT(887),
  [1742] = {.count = 1, .reusable = false}, SHIFT(887),
  [1744] = {.count = 1, .reusable = true}, SHIFT(888),
  [1746] = {.count = 1, .reusable = false}, SHIFT(888),
  [1748] = {.count = 1, .reusable = false}, SHIFT(884),
  [1750] = {.count = 1, .reusable = true}, REDUCE(sym_dictionary, 3),
  [1752] = {.count = 1, .reusable = false}, REDUCE(sym_dictionary, 3),
  [1754] = {.count = 1, .reusable = true}, SHIFT(892),
  [1756] = {.count = 1, .reusable = true}, SHIFT(894),
  [1758] = {.count = 1, .reusable = true}, SHIFT(895),
  [1760] = {.count = 1, .reusable = true}, SHIFT(896),
  [1762] = {.count = 1, .reusable = true}, SHIFT(897),
  [1764] = {.count = 1, .reusable = false}, SHIFT(898),
  [1766] = {.count = 1, .reusable = true}, SHIFT(899),
  [1768] = {.count = 1, .reusable = true}, SHIFT(900),
  [1770] = {.count = 1, .reusable = true}, SHIFT(898),
  [1772] = {.count = 1, .reusable = true}, SHIFT(901),
  [1774] = {.count = 1, .reusable = true}, SHIFT(902),
  [1776] = {.count = 1, .reusable = true}, SHIFT(903),
  [1778] = {.count = 1, .reusable = true}, SHIFT(904),
  [1780] = {.count = 1, .reusable = true}, SHIFT(905),
  [1782] = {.count = 1, .reusable = true}, SHIFT(906),
  [1784] = {.count = 1, .reusable = false}, SHIFT(900),
  [1786] = {.count = 1, .reusable = true}, SHIFT(907),
  [1788] = {.count = 1, .reusable = true}, SHIFT(910),
  [1790] = {.count = 1, .reusable = true}, SHIFT(911),
  [1792] = {.count = 1, .reusable = true}, SHIFT(912),
  [1794] = {.count = 1, .reusable = true}, SHIFT(913),
  [1796] = {.count = 1, .reusable = true}, REDUCE(sym_set, 3),
  [1798] = {.count = 1, .reusable = false}, REDUCE(sym_set, 3),
  [1800] = {.count = 1, .reusable = true}, SHIFT(915),
  [1802] = {.count = 1, .reusable = true}, SHIFT(917),
  [1804] = {.count = 1, .reusable = true}, SHIFT(918),
  [1806] = {.count = 1, .reusable = true}, SHIFT(921),
  [1808] = {.count = 1, .reusable = false}, SHIFT(924),
  [1810] = {.count = 1, .reusable = true}, SHIFT(925),
  [1812] = {.count = 1, .reusable = false}, SHIFT(926),
  [1814] = {.count = 1, .reusable = true}, SHIFT(930),
  [1816] = {.count = 1, .reusable = true}, SHIFT(927),
  [1818] = {.count = 1, .reusable = false}, SHIFT(930),
  [1820] = {.count = 1, .reusable = false}, SHIFT(928),
  [1822] = {.count = 1, .reusable = true}, SHIFT(931),
  [1824] = {.count = 1, .reusable = true}, SHIFT(934),
  [1826] = {.count = 1, .reusable = true}, SHIFT(935),
  [1828] = {.count = 1, .reusable = true}, SHIFT(937),
  [1830] = {.count = 1, .reusable = false}, SHIFT(937),
  [1832] = {.count = 1, .reusable = true}, SHIFT(938),
  [1834] = {.count = 1, .reusable = false}, SHIFT(938),
  [1836] = {.count = 1, .reusable = true}, SHIFT(939),
  [1838] = {.count = 1, .reusable = false}, SHIFT(939),
  [1840] = {.count = 1, .reusable = true}, SHIFT(940),
  [1842] = {.count = 1, .reusable = true}, SHIFT(941),
  [1844] = {.count = 1, .reusable = false}, SHIFT(941),
  [1846] = {.count = 1, .reusable = true}, SHIFT(942),
  [1848] = {.count = 1, .reusable = false}, SHIFT(942),
  [1850] = {.count = 1, .reusable = true}, SHIFT(943),
  [1852] = {.count = 1, .reusable = false}, SHIFT(943),
  [1854] = {.count = 1, .reusable = true}, SHIFT(944),
  [1856] = {.count = 1, .reusable = false}, SHIFT(944),
  [1858] = {.count = 1, .reusable = false}, SHIFT(940),
  [1860] = {.count = 1, .reusable = true}, SHIFT(946),
  [1862] = {.count = 1, .reusable = true}, REDUCE(aux_sym_concatenated_string_repeat1, 2),
  [1864] = {.count = 1, .reusable = false}, REDUCE(aux_sym_concatenated_string_repeat1, 2),
  [1866] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenated_string_repeat1, 2), SHIFT_REPEAT(493),
  [1869] = {.count = 1, .reusable = true}, SHIFT(948),
  [1871] = {.count = 1, .reusable = true}, SHIFT(950),
  [1873] = {.count = 1, .reusable = true}, REDUCE(sym_type, 1),
  [1875] = {.count = 1, .reusable = true}, SHIFT(951),
  [1877] = {.count = 1, .reusable = true}, SHIFT(952),
  [1879] = {.count = 1, .reusable = true}, SHIFT(953),
  [1881] = {.count = 1, .reusable = false}, SHIFT(954),
  [1883] = {.count = 1, .reusable = true}, SHIFT(955),
  [1885] = {.count = 1, .reusable = true}, SHIFT(956),
  [1887] = {.count = 1, .reusable = true}, SHIFT(954),
  [1889] = {.count = 1, .reusable = true}, SHIFT(957),
  [1891] = {.count = 1, .reusable = true}, SHIFT(958),
  [1893] = {.count = 1, .reusable = true}, SHIFT(959),
  [1895] = {.count = 1, .reusable = true}, SHIFT(960),
  [1897] = {.count = 1, .reusable = true}, SHIFT(961),
  [1899] = {.count = 1, .reusable = true}, SHIFT(962),
  [1901] = {.count = 1, .reusable = false}, SHIFT(956),
  [1903] = {.count = 1, .reusable = true}, SHIFT(963),
  [1905] = {.count = 1, .reusable = true}, REDUCE(sym_assignment, 3),
  [1907] = {.count = 1, .reusable = true}, SHIFT(965),
  [1909] = {.count = 1, .reusable = true}, REDUCE(sym__right_hand_side, 1),
  [1911] = {.count = 1, .reusable = true}, SHIFT(966),
  [1913] = {.count = 1, .reusable = true}, REDUCE(sym_augmented_assignment, 3),
  [1915] = {.count = 1, .reusable = true}, REDUCE(aux_sym_print_statement_repeat1, 2),
  [1917] = {.count = 1, .reusable = true}, SHIFT(969),
  [1919] = {.count = 1, .reusable = true}, SHIFT(971),
  [1921] = {.count = 1, .reusable = true}, SHIFT(972),
  [1923] = {.count = 1, .reusable = true}, SHIFT(973),
  [1925] = {.count = 1, .reusable = true}, SHIFT(974),
  [1927] = {.count = 1, .reusable = true}, SHIFT(975),
  [1929] = {.count = 1, .reusable = false}, SHIFT(976),
  [1931] = {.count = 1, .reusable = true}, SHIFT(977),
  [1933] = {.count = 1, .reusable = true}, SHIFT(978),
  [1935] = {.count = 1, .reusable = true}, SHIFT(976),
  [1937] = {.count = 1, .reusable = true}, SHIFT(979),
  [1939] = {.count = 1, .reusable = true}, SHIFT(980),
  [1941] = {.count = 1, .reusable = true}, SHIFT(981),
  [1943] = {.count = 1, .reusable = true}, SHIFT(982),
  [1945] = {.count = 1, .reusable = true}, SHIFT(983),
  [1947] = {.count = 1, .reusable = true}, SHIFT(984),
  [1949] = {.count = 1, .reusable = false}, SHIFT(978),
  [1951] = {.count = 1, .reusable = true}, SHIFT(985),
  [1953] = {.count = 1, .reusable = true}, REDUCE(sym_boolean_operator, 3),
  [1955] = {.count = 1, .reusable = true}, REDUCE(sym_expression_statement, 3),
  [1957] = {.count = 1, .reusable = true}, REDUCE(sym_expression_list, 3),
  [1959] = {.count = 2, .reusable = true}, REDUCE(aux_sym_print_statement_repeat1, 2), SHIFT_REPEAT(987),
  [1962] = {.count = 1, .reusable = true}, REDUCE(sym_attribute, 3),
  [1964] = {.count = 1, .reusable = false}, REDUCE(sym_attribute, 3),
  [1966] = {.count = 1, .reusable = true}, REDUCE(sym_argument_list, 2),
  [1968] = {.count = 1, .reusable = false}, REDUCE(sym_argument_list, 2),
  [1970] = {.count = 1, .reusable = true}, SHIFT(988),
  [1972] = {.count = 1, .reusable = true}, SHIFT(989),
  [1974] = {.count = 1, .reusable = false}, SHIFT(991),
  [1976] = {.count = 1, .reusable = false}, SHIFT(992),
  [1978] = {.count = 1, .reusable = true}, SHIFT(993),
  [1980] = {.count = 1, .reusable = true}, REDUCE(sym_binary_operator, 3),
  [1982] = {.count = 1, .reusable = false}, REDUCE(sym_binary_operator, 3),
  [1984] = {.count = 1, .reusable = true}, REDUCE(aux_sym_comparison_operator_repeat1, 2),
  [1986] = {.count = 1, .reusable = false}, REDUCE(aux_sym_comparison_operator_repeat1, 2),
  [1988] = {.count = 1, .reusable = true}, SHIFT(995),
  [1990] = {.count = 1, .reusable = false}, SHIFT(995),
  [1992] = {.count = 1, .reusable = true}, REDUCE(sym_slice, 1),
  [1994] = {.count = 1, .reusable = true}, SHIFT(996),
  [1996] = {.count = 1, .reusable = true}, SHIFT(999),
  [1998] = {.count = 1, .reusable = true}, SHIFT(1001),
  [2000] = {.count = 1, .reusable = true}, SHIFT(1002),
  [2002] = {.count = 1, .reusable = true}, SHIFT(1003),
  [2004] = {.count = 1, .reusable = true}, SHIFT(1004),
  [2006] = {.count = 1, .reusable = true}, SHIFT(1005),
  [2008] = {.count = 1, .reusable = true}, SHIFT(1006),
  [2010] = {.count = 1, .reusable = true}, SHIFT(1007),
  [2012] = {.count = 1, .reusable = false}, SHIFT(1009),
  [2014] = {.count = 1, .reusable = true}, SHIFT(1010),
  [2016] = {.count = 1, .reusable = true}, SHIFT(1011),
  [2018] = {.count = 1, .reusable = true}, SHIFT(1009),
  [2020] = {.count = 1, .reusable = true}, SHIFT(1012),
  [2022] = {.count = 1, .reusable = true}, SHIFT(1013),
  [2024] = {.count = 1, .reusable = true}, SHIFT(1014),
  [2026] = {.count = 1, .reusable = true}, SHIFT(1015),
  [2028] = {.count = 1, .reusable = true}, SHIFT(1016),
  [2030] = {.count = 1, .reusable = true}, SHIFT(1017),
  [2032] = {.count = 1, .reusable = false}, SHIFT(1011),
  [2034] = {.count = 1, .reusable = true}, SHIFT(1018),
  [2036] = {.count = 2, .reusable = true}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(173),
  [2039] = {.count = 2, .reusable = true}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(174),
  [2042] = {.count = 2, .reusable = false}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(173),
  [2045] = {.count = 2, .reusable = true}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(180),
  [2048] = {.count = 1, .reusable = true}, REDUCE(aux_sym_dotted_name_repeat1, 2),
  [2050] = {.count = 2, .reusable = true}, REDUCE(aux_sym_dotted_name_repeat1, 2), SHIFT_REPEAT(188),
  [2053] = {.count = 1, .reusable = true}, REDUCE(aux_sym__import_list_repeat1, 2),
  [2055] = {.count = 1, .reusable = true}, REDUCE(sym__import_list, 3),
  [2057] = {.count = 2, .reusable = true}, REDUCE(aux_sym__import_list_repeat1, 2), SHIFT_REPEAT(1020),
  [2060] = {.count = 1, .reusable = true}, REDUCE(sym_aliased_import, 3),
  [2062] = {.count = 2, .reusable = true}, REDUCE(aux_sym_dotted_name_repeat1, 2), SHIFT_REPEAT(193),
  [2065] = {.count = 1, .reusable = true}, SHIFT(1021),
  [2067] = {.count = 1, .reusable = true}, REDUCE(sym_wildcard_import, 1),
  [2069] = {.count = 1, .reusable = true}, REDUCE(sym_import_from_statement, 4),
  [2071] = {.count = 1, .reusable = true}, SHIFT(1025),
  [2073] = {.count = 1, .reusable = true}, SHIFT(1026),
  [2075] = {.count = 1, .reusable = true}, SHIFT(1027),
  [2077] = {.count = 1, .reusable = true}, SHIFT(1030),
  [2079] = {.count = 1, .reusable = true}, SHIFT(1031),
  [2081] = {.count = 1, .reusable = true}, SHIFT(1035),
  [2083] = {.count = 1, .reusable = true}, SHIFT(1037),
  [2085] = {.count = 1, .reusable = false}, SHIFT(1037),
  [2087] = {.count = 1, .reusable = true}, SHIFT(1038),
  [2089] = {.count = 1, .reusable = false}, SHIFT(1038),
  [2091] = {.count = 1, .reusable = true}, SHIFT(1039),
  [2093] = {.count = 1, .reusable = false}, SHIFT(1039),
  [2095] = {.count = 1, .reusable = true}, SHIFT(1040),
  [2097] = {.count = 1, .reusable = true}, SHIFT(1041),
  [2099] = {.count = 1, .reusable = false}, SHIFT(1041),
  [2101] = {.count = 1, .reusable = true}, SHIFT(1042),
  [2103] = {.count = 1, .reusable = false}, SHIFT(1042),
  [2105] = {.count = 1, .reusable = true}, SHIFT(1043),
  [2107] = {.count = 1, .reusable = false}, SHIFT(1043),
  [2109] = {.count = 1, .reusable = true}, SHIFT(1044),
  [2111] = {.count = 1, .reusable = false}, SHIFT(1044),
  [2113] = {.count = 1, .reusable = false}, SHIFT(1040),
  [2115] = {.count = 1, .reusable = true}, SHIFT(1046),
  [2117] = {.count = 1, .reusable = true}, SHIFT(1047),
  [2119] = {.count = 1, .reusable = true}, SHIFT(1048),
  [2121] = {.count = 1, .reusable = true}, SHIFT(1049),
  [2123] = {.count = 1, .reusable = true}, SHIFT(1050),
  [2125] = {.count = 1, .reusable = true}, SHIFT(1051),
  [2127] = {.count = 1, .reusable = true}, SHIFT(1052),
  [2129] = {.count = 1, .reusable = true}, SHIFT(1053),
  [2131] = {.count = 1, .reusable = true}, SHIFT(1054),
  [2133] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenated_string_repeat1, 2), SHIFT_REPEAT(597),
  [2136] = {.count = 1, .reusable = true}, REDUCE(sym_tuple, 4),
  [2138] = {.count = 1, .reusable = false}, REDUCE(sym_tuple, 4),
  [2140] = {.count = 1, .reusable = true}, REDUCE(aux_sym_tuple_repeat1, 2),
  [2142] = {.count = 1, .reusable = true}, SHIFT(1055),
  [2144] = {.count = 1, .reusable = true}, SHIFT(1057),
  [2146] = {.count = 1, .reusable = false}, REDUCE(sym_boolean_operator, 3),
  [2148] = {.count = 1, .reusable = true}, REDUCE(sym_generator_expression, 4),
  [2150] = {.count = 1, .reusable = false}, REDUCE(sym_generator_expression, 4),
  [2152] = {.count = 1, .reusable = false}, SHIFT(1058),
  [2154] = {.count = 1, .reusable = true}, SHIFT(1059),
  [2156] = {.count = 1, .reusable = false}, SHIFT(1060),
  [2158] = {.count = 1, .reusable = true}, SHIFT(1064),
  [2160] = {.count = 1, .reusable = true}, SHIFT(1061),
  [2162] = {.count = 1, .reusable = false}, SHIFT(1064),
  [2164] = {.count = 1, .reusable = false}, SHIFT(1062),
  [2166] = {.count = 1, .reusable = true}, REDUCE(sym__comprehension_body, 2),
  [2168] = {.count = 1, .reusable = true}, SHIFT(1066),
  [2170] = {.count = 2, .reusable = true}, REDUCE(aux_sym_tuple_repeat1, 2), SHIFT_REPEAT(1067),
  [2173] = {.count = 1, .reusable = true}, SHIFT(1068),
  [2175] = {.count = 1, .reusable = true}, SHIFT(1069),
  [2177] = {.count = 1, .reusable = true}, SHIFT(1071),
  [2179] = {.count = 1, .reusable = false}, SHIFT(1071),
  [2181] = {.count = 1, .reusable = true}, SHIFT(1072),
  [2183] = {.count = 1, .reusable = true}, SHIFT(1073),
  [2185] = {.count = 2, .reusable = true}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(242),
  [2188] = {.count = 2, .reusable = true}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(243),
  [2191] = {.count = 2, .reusable = false}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(242),
  [2194] = {.count = 2, .reusable = true}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(249),
  [2197] = {.count = 1, .reusable = true}, SHIFT(1075),
  [2199] = {.count = 1, .reusable = true}, SHIFT(1076),
  [2201] = {.count = 1, .reusable = true}, SHIFT(1077),
  [2203] = {.count = 1, .reusable = true}, SHIFT(1079),
  [2205] = {.count = 1, .reusable = true}, SHIFT(1080),
  [2207] = {.count = 1, .reusable = true}, SHIFT(1081),
  [2209] = {.count = 1, .reusable = true}, SHIFT(1082),
  [2211] = {.count = 1, .reusable = true}, SHIFT(1083),
  [2213] = {.count = 1, .reusable = true}, SHIFT(1084),
  [2215] = {.count = 1, .reusable = true}, SHIFT(1085),
  [2217] = {.count = 1, .reusable = true}, SHIFT(1086),
  [2219] = {.count = 1, .reusable = true}, SHIFT(1087),
  [2221] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenated_string_repeat1, 2), SHIFT_REPEAT(647),
  [2224] = {.count = 1, .reusable = true}, REDUCE(sym_print_statement, 4),
  [2226] = {.count = 2, .reusable = true}, REDUCE(aux_sym_print_statement_repeat1, 2), SHIFT_REPEAT(293),
  [2229] = {.count = 1, .reusable = true}, SHIFT(1088),
  [2231] = {.count = 1, .reusable = true}, SHIFT(1089),
  [2233] = {.count = 1, .reusable = true}, SHIFT(1090),
  [2235] = {.count = 1, .reusable = true}, SHIFT(1092),
  [2237] = {.count = 1, .reusable = false}, SHIFT(1092),
  [2239] = {.count = 1, .reusable = true}, SHIFT(1093),
  [2241] = {.count = 1, .reusable = true}, SHIFT(1094),
  [2243] = {.count = 2, .reusable = true}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(282),
  [2246] = {.count = 2, .reusable = true}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(283),
  [2249] = {.count = 2, .reusable = false}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(282),
  [2252] = {.count = 2, .reusable = true}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(289),
  [2255] = {.count = 1, .reusable = true}, SHIFT(1097),
  [2257] = {.count = 1, .reusable = true}, SHIFT(1098),
  [2259] = {.count = 1, .reusable = true}, SHIFT(1101),
  [2261] = {.count = 1, .reusable = false}, SHIFT(1101),
  [2263] = {.count = 1, .reusable = true}, SHIFT(1102),
  [2265] = {.count = 1, .reusable = false}, SHIFT(1102),
  [2267] = {.count = 1, .reusable = true}, SHIFT(1103),
  [2269] = {.count = 1, .reusable = false}, SHIFT(1103),
  [2271] = {.count = 1, .reusable = true}, SHIFT(1104),
  [2273] = {.count = 1, .reusable = true}, SHIFT(1105),
  [2275] = {.count = 1, .reusable = false}, SHIFT(1105),
  [2277] = {.count = 1, .reusable = true}, SHIFT(1106),
  [2279] = {.count = 1, .reusable = false}, SHIFT(1106),
  [2281] = {.count = 1, .reusable = true}, SHIFT(1107),
  [2283] = {.count = 1, .reusable = false}, SHIFT(1107),
  [2285] = {.count = 1, .reusable = true}, SHIFT(1108),
  [2287] = {.count = 1, .reusable = false}, SHIFT(1108),
  [2289] = {.count = 1, .reusable = false}, SHIFT(1104),
  [2291] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenated_string_repeat1, 2), SHIFT_REPEAT(691),
  [2294] = {.count = 1, .reusable = true}, REDUCE(sym_raise_statement, 4),
  [2296] = {.count = 1, .reusable = true}, SHIFT(1111),
  [2298] = {.count = 1, .reusable = false}, REDUCE(sym_expression_list, 3),
  [2300] = {.count = 2, .reusable = true}, REDUCE(aux_sym_print_statement_repeat1, 2), SHIFT_REPEAT(1112),
  [2303] = {.count = 1, .reusable = true}, SHIFT(1113),
  [2305] = {.count = 1, .reusable = false}, SHIFT(1113),
  [2307] = {.count = 2, .reusable = true}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(316),
  [2310] = {.count = 2, .reusable = true}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(317),
  [2313] = {.count = 2, .reusable = false}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(316),
  [2316] = {.count = 2, .reusable = true}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(323),
  [2319] = {.count = 1, .reusable = true}, REDUCE(sym__simple_statements, 4),
  [2321] = {.count = 1, .reusable = false}, REDUCE(sym__simple_statements, 4),
  [2323] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenated_string_repeat1, 2), SHIFT_REPEAT(711),
  [2326] = {.count = 1, .reusable = true}, SHIFT(1115),
  [2328] = {.count = 1, .reusable = true}, SHIFT(1116),
  [2330] = {.count = 1, .reusable = true}, SHIFT(1118),
  [2332] = {.count = 1, .reusable = true}, SHIFT(1119),
  [2334] = {.count = 1, .reusable = true}, REDUCE(sym_if_statement, 4),
  [2336] = {.count = 1, .reusable = false}, REDUCE(sym_if_statement, 4),
  [2338] = {.count = 1, .reusable = false}, SHIFT(1121),
  [2340] = {.count = 1, .reusable = false}, SHIFT(1122),
  [2342] = {.count = 1, .reusable = true}, SHIFT(1125),
  [2344] = {.count = 1, .reusable = false}, SHIFT(1125),
  [2346] = {.count = 2, .reusable = true}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(339),
  [2349] = {.count = 2, .reusable = true}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(340),
  [2352] = {.count = 2, .reusable = false}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(339),
  [2355] = {.count = 2, .reusable = true}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(346),
  [2358] = {.count = 1, .reusable = true}, SHIFT(1128),
  [2360] = {.count = 1, .reusable = true}, SHIFT(1129),
  [2362] = {.count = 1, .reusable = true}, SHIFT(1130),
  [2364] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenated_string_repeat1, 2), SHIFT_REPEAT(730),
  [2367] = {.count = 1, .reusable = true}, SHIFT(1131),
  [2369] = {.count = 1, .reusable = true}, SHIFT(1132),
  [2371] = {.count = 1, .reusable = true}, REDUCE(aux_sym_variables_repeat1, 2),
  [2373] = {.count = 1, .reusable = false}, REDUCE(sym_variables, 3),
  [2375] = {.count = 2, .reusable = true}, REDUCE(aux_sym_variables_repeat1, 2), SHIFT_REPEAT(1134),
  [2378] = {.count = 1, .reusable = true}, SHIFT(1135),
  [2380] = {.count = 1, .reusable = true}, SHIFT(1137),
  [2382] = {.count = 1, .reusable = true}, SHIFT(1138),
  [2384] = {.count = 1, .reusable = true}, REDUCE(sym_while_statement, 4),
  [2386] = {.count = 1, .reusable = false}, REDUCE(sym_while_statement, 4),
  [2388] = {.count = 1, .reusable = true}, REDUCE(sym__suite, 2),
  [2390] = {.count = 1, .reusable = false}, REDUCE(sym__suite, 2),
  [2392] = {.count = 1, .reusable = true}, SHIFT(1141),
  [2394] = {.count = 1, .reusable = true}, SHIFT(1142),
  [2396] = {.count = 1, .reusable = true}, SHIFT(1145),
  [2398] = {.count = 1, .reusable = true}, SHIFT(1146),
  [2400] = {.count = 1, .reusable = true}, SHIFT(1147),
  [2402] = {.count = 1, .reusable = true}, SHIFT(1150),
  [2404] = {.count = 1, .reusable = true}, SHIFT(1152),
  [2406] = {.count = 1, .reusable = true}, SHIFT(1153),
  [2408] = {.count = 1, .reusable = true}, SHIFT(1154),
  [2410] = {.count = 1, .reusable = true}, SHIFT(1156),
  [2412] = {.count = 1, .reusable = true}, SHIFT(753),
  [2414] = {.count = 1, .reusable = true}, SHIFT(754),
  [2416] = {.count = 1, .reusable = true}, SHIFT(1158),
  [2418] = {.count = 1, .reusable = true}, SHIFT(1159),
  [2420] = {.count = 1, .reusable = true}, SHIFT(1160),
  [2422] = {.count = 1, .reusable = true}, SHIFT(1162),
  [2424] = {.count = 1, .reusable = true}, REDUCE(sym_try_statement, 4),
  [2426] = {.count = 1, .reusable = false}, REDUCE(sym_try_statement, 4),
  [2428] = {.count = 1, .reusable = false}, SHIFT(1163),
  [2430] = {.count = 1, .reusable = false}, SHIFT(760),
  [2432] = {.count = 1, .reusable = false}, SHIFT(761),
  [2434] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenated_string_repeat1, 2), SHIFT_REPEAT(766),
  [2437] = {.count = 1, .reusable = true}, REDUCE(aux_sym_with_statement_repeat1, 2),
  [2439] = {.count = 1, .reusable = true}, SHIFT(1168),
  [2441] = {.count = 1, .reusable = true}, REDUCE(sym_with_statement, 4),
  [2443] = {.count = 1, .reusable = false}, REDUCE(sym_with_statement, 4),
  [2445] = {.count = 2, .reusable = true}, REDUCE(aux_sym_with_statement_repeat1, 2), SHIFT_REPEAT(370),
  [2448] = {.count = 1, .reusable = true}, REDUCE(sym_with_item, 3),
  [2450] = {.count = 1, .reusable = true}, SHIFT(1170),
  [2452] = {.count = 1, .reusable = true}, SHIFT(1171),
  [2454] = {.count = 1, .reusable = false}, SHIFT(1171),
  [2456] = {.count = 2, .reusable = true}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(379),
  [2459] = {.count = 2, .reusable = true}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(380),
  [2462] = {.count = 2, .reusable = false}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(379),
  [2465] = {.count = 2, .reusable = true}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(386),
  [2468] = {.count = 1, .reusable = true}, REDUCE(sym_parameters, 2),
  [2470] = {.count = 1, .reusable = true}, SHIFT(1172),
  [2472] = {.count = 1, .reusable = false}, SHIFT(1173),
  [2474] = {.count = 1, .reusable = true}, SHIFT(1174),
  [2476] = {.count = 1, .reusable = false}, SHIFT(1175),
  [2478] = {.count = 1, .reusable = true}, SHIFT(1179),
  [2480] = {.count = 1, .reusable = true}, SHIFT(1176),
  [2482] = {.count = 1, .reusable = false}, SHIFT(1179),
  [2484] = {.count = 1, .reusable = false}, SHIFT(1177),
  [2486] = {.count = 1, .reusable = true}, SHIFT(1180),
  [2488] = {.count = 1, .reusable = true}, SHIFT(1181),
  [2490] = {.count = 1, .reusable = true}, SHIFT(1182),
  [2492] = {.count = 1, .reusable = true}, SHIFT(1184),
  [2494] = {.count = 1, .reusable = true}, SHIFT(1185),
  [2496] = {.count = 1, .reusable = true}, SHIFT(1186),
  [2498] = {.count = 1, .reusable = true}, SHIFT(1188),
  [2500] = {.count = 1, .reusable = true}, SHIFT(1189),
  [2502] = {.count = 1, .reusable = true}, REDUCE(aux_sym_global_statement_repeat1, 2),
  [2504] = {.count = 2, .reusable = true}, REDUCE(aux_sym_global_statement_repeat1, 2), SHIFT_REPEAT(390),
  [2507] = {.count = 1, .reusable = true}, REDUCE(sym_exec_statement, 4),
  [2509] = {.count = 1, .reusable = true}, REDUCE(sym_class_definition, 4),
  [2511] = {.count = 1, .reusable = false}, REDUCE(sym_class_definition, 4),
  [2513] = {.count = 1, .reusable = true}, REDUCE(sym_decorator, 4),
  [2515] = {.count = 1, .reusable = true}, REDUCE(sym_dictionary_splat, 3),
  [2517] = {.count = 1, .reusable = true}, SHIFT(1196),
  [2519] = {.count = 1, .reusable = true}, SHIFT(1197),
  [2521] = {.count = 1, .reusable = true}, SHIFT(1200),
  [2523] = {.count = 1, .reusable = false}, SHIFT(1200),
  [2525] = {.count = 1, .reusable = true}, SHIFT(1201),
  [2527] = {.count = 1, .reusable = false}, SHIFT(1201),
  [2529] = {.count = 1, .reusable = true}, SHIFT(1202),
  [2531] = {.count = 1, .reusable = false}, SHIFT(1202),
  [2533] = {.count = 1, .reusable = true}, SHIFT(1203),
  [2535] = {.count = 1, .reusable = true}, SHIFT(1204),
  [2537] = {.count = 1, .reusable = false}, SHIFT(1204),
  [2539] = {.count = 1, .reusable = true}, SHIFT(1205),
  [2541] = {.count = 1, .reusable = false}, SHIFT(1205),
  [2543] = {.count = 1, .reusable = true}, SHIFT(1206),
  [2545] = {.count = 1, .reusable = false}, SHIFT(1206),
  [2547] = {.count = 1, .reusable = true}, SHIFT(1207),
  [2549] = {.count = 1, .reusable = false}, SHIFT(1207),
  [2551] = {.count = 1, .reusable = false}, SHIFT(1203),
  [2553] = {.count = 1, .reusable = true}, REDUCE(aux_sym__parameters_repeat1, 2, .alias_sequence_id = 2),
  [2555] = {.count = 1, .reusable = true}, REDUCE(aux_sym__parameters_repeat1, 2),
  [2557] = {.count = 1, .reusable = true}, SHIFT(1210),
  [2559] = {.count = 1, .reusable = true}, SHIFT(1212),
  [2561] = {.count = 1, .reusable = true}, SHIFT(1213),
  [2563] = {.count = 1, .reusable = true}, SHIFT(1214),
  [2565] = {.count = 1, .reusable = true}, SHIFT(1215),
  [2567] = {.count = 1, .reusable = false}, SHIFT(1216),
  [2569] = {.count = 1, .reusable = true}, SHIFT(1217),
  [2571] = {.count = 1, .reusable = true}, SHIFT(1218),
  [2573] = {.count = 1, .reusable = true}, SHIFT(1216),
  [2575] = {.count = 1, .reusable = true}, SHIFT(1219),
  [2577] = {.count = 1, .reusable = true}, SHIFT(1220),
  [2579] = {.count = 1, .reusable = true}, SHIFT(1221),
  [2581] = {.count = 1, .reusable = true}, SHIFT(1222),
  [2583] = {.count = 1, .reusable = true}, SHIFT(1223),
  [2585] = {.count = 1, .reusable = true}, SHIFT(1224),
  [2587] = {.count = 1, .reusable = false}, SHIFT(1218),
  [2589] = {.count = 1, .reusable = true}, SHIFT(1225),
  [2591] = {.count = 1, .reusable = true}, SHIFT(1227),
  [2593] = {.count = 1, .reusable = true}, REDUCE(sym_default_parameter, 3, .alias_sequence_id = 1),
  [2595] = {.count = 1, .reusable = true}, REDUCE(sym__parameters, 3, .alias_sequence_id = 1),
  [2597] = {.count = 2, .reusable = true}, REDUCE(aux_sym__parameters_repeat1, 2), SHIFT_REPEAT(1228),
  [2600] = {.count = 1, .reusable = true}, SHIFT(1230),
  [2602] = {.count = 1, .reusable = true}, SHIFT(1232),
  [2604] = {.count = 1, .reusable = true}, SHIFT(1233),
  [2606] = {.count = 1, .reusable = true}, SHIFT(1234),
  [2608] = {.count = 1, .reusable = true}, SHIFT(1235),
  [2610] = {.count = 1, .reusable = false}, SHIFT(1236),
  [2612] = {.count = 1, .reusable = true}, SHIFT(1237),
  [2614] = {.count = 1, .reusable = true}, SHIFT(1238),
  [2616] = {.count = 1, .reusable = true}, SHIFT(1236),
  [2618] = {.count = 1, .reusable = true}, SHIFT(1239),
  [2620] = {.count = 1, .reusable = true}, SHIFT(1240),
  [2622] = {.count = 1, .reusable = true}, SHIFT(1241),
  [2624] = {.count = 1, .reusable = true}, SHIFT(1242),
  [2626] = {.count = 1, .reusable = true}, SHIFT(1243),
  [2628] = {.count = 1, .reusable = true}, SHIFT(1244),
  [2630] = {.count = 1, .reusable = false}, SHIFT(1238),
  [2632] = {.count = 1, .reusable = true}, SHIFT(1245),
  [2634] = {.count = 1, .reusable = true}, REDUCE(sym_typed_parameter, 3),
  [2636] = {.count = 1, .reusable = true}, SHIFT(1247),
  [2638] = {.count = 1, .reusable = true}, REDUCE(sym_default_parameter, 3),
  [2640] = {.count = 1, .reusable = true}, REDUCE(sym__parameters, 3),
  [2642] = {.count = 1, .reusable = true}, REDUCE(sym_lambda, 4),
  [2644] = {.count = 1, .reusable = true}, SHIFT(1249),
  [2646] = {.count = 1, .reusable = true}, SHIFT(1250),
  [2648] = {.count = 1, .reusable = true}, SHIFT(1253),
  [2650] = {.count = 1, .reusable = false}, SHIFT(1253),
  [2652] = {.count = 1, .reusable = true}, SHIFT(1254),
  [2654] = {.count = 1, .reusable = false}, SHIFT(1254),
  [2656] = {.count = 1, .reusable = true}, SHIFT(1255),
  [2658] = {.count = 1, .reusable = false}, SHIFT(1255),
  [2660] = {.count = 1, .reusable = true}, SHIFT(1256),
  [2662] = {.count = 1, .reusable = true}, SHIFT(1257),
  [2664] = {.count = 1, .reusable = false}, SHIFT(1257),
  [2666] = {.count = 1, .reusable = true}, SHIFT(1258),
  [2668] = {.count = 1, .reusable = false}, SHIFT(1258),
  [2670] = {.count = 1, .reusable = true}, SHIFT(1259),
  [2672] = {.count = 1, .reusable = false}, SHIFT(1259),
  [2674] = {.count = 1, .reusable = true}, SHIFT(1260),
  [2676] = {.count = 1, .reusable = false}, SHIFT(1260),
  [2678] = {.count = 1, .reusable = false}, SHIFT(1256),
  [2680] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenated_string_repeat1, 2), SHIFT_REPEAT(868),
  [2683] = {.count = 1, .reusable = true}, REDUCE(sym_list, 4),
  [2685] = {.count = 1, .reusable = false}, REDUCE(sym_list, 4),
  [2687] = {.count = 1, .reusable = true}, REDUCE(aux_sym_list_repeat1, 2),
  [2689] = {.count = 1, .reusable = true}, SHIFT(1263),
  [2691] = {.count = 2, .reusable = true}, REDUCE(aux_sym_list_repeat1, 2), SHIFT_REPEAT(1264),
  [2694] = {.count = 1, .reusable = true}, SHIFT(1265),
  [2696] = {.count = 1, .reusable = true}, SHIFT(1267),
  [2698] = {.count = 1, .reusable = true}, REDUCE(sym_list_comprehension, 4),
  [2700] = {.count = 1, .reusable = false}, REDUCE(sym_list_comprehension, 4),
  [2702] = {.count = 1, .reusable = false}, SHIFT(1268),
  [2704] = {.count = 1, .reusable = true}, SHIFT(1269),
  [2706] = {.count = 1, .reusable = false}, SHIFT(1270),
  [2708] = {.count = 1, .reusable = true}, SHIFT(1274),
  [2710] = {.count = 1, .reusable = true}, SHIFT(1271),
  [2712] = {.count = 1, .reusable = false}, SHIFT(1274),
  [2714] = {.count = 1, .reusable = false}, SHIFT(1272),
  [2716] = {.count = 1, .reusable = true}, SHIFT(1276),
  [2718] = {.count = 1, .reusable = false}, SHIFT(1276),
  [2720] = {.count = 2, .reusable = true}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(446),
  [2723] = {.count = 2, .reusable = true}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(447),
  [2726] = {.count = 2, .reusable = false}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(446),
  [2729] = {.count = 2, .reusable = true}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(453),
  [2732] = {.count = 1, .reusable = true}, SHIFT(1278),
  [2734] = {.count = 1, .reusable = true}, SHIFT(1279),
  [2736] = {.count = 1, .reusable = true}, SHIFT(1282),
  [2738] = {.count = 1, .reusable = false}, SHIFT(1282),
  [2740] = {.count = 1, .reusable = true}, SHIFT(1283),
  [2742] = {.count = 1, .reusable = false}, SHIFT(1283),
  [2744] = {.count = 1, .reusable = true}, SHIFT(1284),
  [2746] = {.count = 1, .reusable = false}, SHIFT(1284),
  [2748] = {.count = 1, .reusable = true}, SHIFT(1285),
  [2750] = {.count = 1, .reusable = true}, SHIFT(1286),
  [2752] = {.count = 1, .reusable = false}, SHIFT(1286),
  [2754] = {.count = 1, .reusable = true}, SHIFT(1287),
  [2756] = {.count = 1, .reusable = false}, SHIFT(1287),
  [2758] = {.count = 1, .reusable = true}, SHIFT(1288),
  [2760] = {.count = 1, .reusable = false}, SHIFT(1288),
  [2762] = {.count = 1, .reusable = true}, SHIFT(1289),
  [2764] = {.count = 1, .reusable = false}, SHIFT(1289),
  [2766] = {.count = 1, .reusable = false}, SHIFT(1285),
  [2768] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenated_string_repeat1, 2), SHIFT_REPEAT(911),
  [2771] = {.count = 1, .reusable = true}, REDUCE(sym_set, 4),
  [2773] = {.count = 1, .reusable = false}, REDUCE(sym_set, 4),
  [2775] = {.count = 1, .reusable = true}, SHIFT(1292),
  [2777] = {.count = 2, .reusable = true}, REDUCE(aux_sym_list_repeat1, 2), SHIFT_REPEAT(1293),
  [2780] = {.count = 1, .reusable = true}, REDUCE(sym_dictionary, 4),
  [2782] = {.count = 1, .reusable = false}, REDUCE(sym_dictionary, 4),
  [2784] = {.count = 1, .reusable = true}, REDUCE(aux_sym_dictionary_repeat1, 2),
  [2786] = {.count = 1, .reusable = true}, SHIFT(1294),
  [2788] = {.count = 1, .reusable = true}, SHIFT(1295),
  [2790] = {.count = 2, .reusable = true}, REDUCE(aux_sym_dictionary_repeat1, 2), SHIFT_REPEAT(1296),
  [2793] = {.count = 1, .reusable = true}, SHIFT(1297),
  [2795] = {.count = 1, .reusable = true}, SHIFT(1299),
  [2797] = {.count = 1, .reusable = true}, SHIFT(1301),
  [2799] = {.count = 1, .reusable = true}, REDUCE(sym_pair, 3),
  [2801] = {.count = 1, .reusable = true}, SHIFT(1302),
  [2803] = {.count = 1, .reusable = true}, SHIFT(1303),
  [2805] = {.count = 1, .reusable = true}, SHIFT(1304),
  [2807] = {.count = 1, .reusable = false}, SHIFT(1305),
  [2809] = {.count = 1, .reusable = true}, SHIFT(1306),
  [2811] = {.count = 1, .reusable = true}, SHIFT(1307),
  [2813] = {.count = 1, .reusable = true}, SHIFT(1305),
  [2815] = {.count = 1, .reusable = true}, SHIFT(1308),
  [2817] = {.count = 1, .reusable = true}, SHIFT(1309),
  [2819] = {.count = 1, .reusable = true}, SHIFT(1310),
  [2821] = {.count = 1, .reusable = true}, SHIFT(1311),
  [2823] = {.count = 1, .reusable = true}, SHIFT(1312),
  [2825] = {.count = 1, .reusable = true}, SHIFT(1313),
  [2827] = {.count = 1, .reusable = false}, SHIFT(1307),
  [2829] = {.count = 1, .reusable = true}, SHIFT(1314),
  [2831] = {.count = 1, .reusable = true}, SHIFT(1317),
  [2833] = {.count = 1, .reusable = true}, REDUCE(sym_set_comprehension, 4),
  [2835] = {.count = 1, .reusable = false}, REDUCE(sym_set_comprehension, 4),
  [2837] = {.count = 1, .reusable = false}, SHIFT(1318),
  [2839] = {.count = 1, .reusable = true}, SHIFT(1319),
  [2841] = {.count = 1, .reusable = false}, SHIFT(1320),
  [2843] = {.count = 1, .reusable = true}, SHIFT(1324),
  [2845] = {.count = 1, .reusable = true}, SHIFT(1321),
  [2847] = {.count = 1, .reusable = false}, SHIFT(1324),
  [2849] = {.count = 1, .reusable = false}, SHIFT(1322),
  [2851] = {.count = 1, .reusable = true}, SHIFT(1326),
  [2853] = {.count = 1, .reusable = false}, SHIFT(1326),
  [2855] = {.count = 2, .reusable = true}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(483),
  [2858] = {.count = 2, .reusable = true}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(484),
  [2861] = {.count = 2, .reusable = false}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(483),
  [2864] = {.count = 2, .reusable = true}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(490),
  [2867] = {.count = 1, .reusable = true}, REDUCE(sym_dictionary_comprehension, 4),
  [2869] = {.count = 1, .reusable = false}, REDUCE(sym_dictionary_comprehension, 4),
  [2871] = {.count = 1, .reusable = true}, SHIFT(1328),
  [2873] = {.count = 1, .reusable = true}, SHIFT(1329),
  [2875] = {.count = 1, .reusable = true}, SHIFT(1332),
  [2877] = {.count = 1, .reusable = false}, SHIFT(1332),
  [2879] = {.count = 1, .reusable = true}, SHIFT(1333),
  [2881] = {.count = 1, .reusable = false}, SHIFT(1333),
  [2883] = {.count = 1, .reusable = true}, SHIFT(1334),
  [2885] = {.count = 1, .reusable = false}, SHIFT(1334),
  [2887] = {.count = 1, .reusable = true}, SHIFT(1335),
  [2889] = {.count = 1, .reusable = true}, SHIFT(1336),
  [2891] = {.count = 1, .reusable = false}, SHIFT(1336),
  [2893] = {.count = 1, .reusable = true}, SHIFT(1337),
  [2895] = {.count = 1, .reusable = false}, SHIFT(1337),
  [2897] = {.count = 1, .reusable = true}, SHIFT(1338),
  [2899] = {.count = 1, .reusable = false}, SHIFT(1338),
  [2901] = {.count = 1, .reusable = true}, SHIFT(1339),
  [2903] = {.count = 1, .reusable = false}, SHIFT(1339),
  [2905] = {.count = 1, .reusable = false}, SHIFT(1335),
  [2907] = {.count = 1, .reusable = true}, SHIFT(1342),
  [2909] = {.count = 1, .reusable = true}, SHIFT(1344),
  [2911] = {.count = 1, .reusable = true}, SHIFT(1345),
  [2913] = {.count = 1, .reusable = true}, SHIFT(1349),
  [2915] = {.count = 1, .reusable = false}, SHIFT(1349),
  [2917] = {.count = 1, .reusable = true}, SHIFT(1350),
  [2919] = {.count = 1, .reusable = false}, SHIFT(1350),
  [2921] = {.count = 1, .reusable = true}, SHIFT(1351),
  [2923] = {.count = 1, .reusable = false}, SHIFT(1351),
  [2925] = {.count = 1, .reusable = true}, SHIFT(1352),
  [2927] = {.count = 1, .reusable = true}, SHIFT(1353),
  [2929] = {.count = 1, .reusable = false}, SHIFT(1353),
  [2931] = {.count = 1, .reusable = true}, SHIFT(1354),
  [2933] = {.count = 1, .reusable = false}, SHIFT(1354),
  [2935] = {.count = 1, .reusable = true}, SHIFT(1355),
  [2937] = {.count = 1, .reusable = false}, SHIFT(1355),
  [2939] = {.count = 1, .reusable = true}, SHIFT(1356),
  [2941] = {.count = 1, .reusable = false}, SHIFT(1356),
  [2943] = {.count = 1, .reusable = false}, SHIFT(1352),
  [2945] = {.count = 1, .reusable = true}, REDUCE(sym_argument_list, 3),
  [2947] = {.count = 1, .reusable = false}, REDUCE(sym_argument_list, 3),
  [2949] = {.count = 1, .reusable = true}, SHIFT(1361),
  [2951] = {.count = 1, .reusable = true}, SHIFT(1364),
  [2953] = {.count = 1, .reusable = true}, REDUCE(aux_sym_comparison_operator_repeat1, 3),
  [2955] = {.count = 1, .reusable = false}, REDUCE(aux_sym_comparison_operator_repeat1, 3),
  [2957] = {.count = 1, .reusable = true}, REDUCE(sym_slice, 2),
  [2959] = {.count = 1, .reusable = true}, SHIFT(1367),
  [2961] = {.count = 1, .reusable = true}, SHIFT(1369),
  [2963] = {.count = 1, .reusable = true}, SHIFT(1370),
  [2965] = {.count = 1, .reusable = true}, SHIFT(1371),
  [2967] = {.count = 1, .reusable = true}, REDUCE(sym_subscript, 4),
  [2969] = {.count = 1, .reusable = false}, REDUCE(sym_subscript, 4),
  [2971] = {.count = 1, .reusable = true}, SHIFT(1377),
  [2973] = {.count = 1, .reusable = true}, SHIFT(1379),
  [2975] = {.count = 1, .reusable = false}, SHIFT(1379),
  [2977] = {.count = 1, .reusable = true}, SHIFT(1380),
  [2979] = {.count = 1, .reusable = false}, SHIFT(1380),
  [2981] = {.count = 1, .reusable = true}, SHIFT(1381),
  [2983] = {.count = 1, .reusable = false}, SHIFT(1381),
  [2985] = {.count = 1, .reusable = true}, SHIFT(1382),
  [2987] = {.count = 1, .reusable = true}, SHIFT(1383),
  [2989] = {.count = 1, .reusable = false}, SHIFT(1383),
  [2991] = {.count = 1, .reusable = true}, SHIFT(1384),
  [2993] = {.count = 1, .reusable = false}, SHIFT(1384),
  [2995] = {.count = 1, .reusable = true}, SHIFT(1385),
  [2997] = {.count = 1, .reusable = false}, SHIFT(1385),
  [2999] = {.count = 1, .reusable = true}, SHIFT(1386),
  [3001] = {.count = 1, .reusable = false}, SHIFT(1386),
  [3003] = {.count = 1, .reusable = false}, SHIFT(1382),
  [3005] = {.count = 1, .reusable = true}, SHIFT(1389),
  [3007] = {.count = 1, .reusable = true}, SHIFT(1390),
  [3009] = {.count = 1, .reusable = true}, SHIFT(1392),
  [3011] = {.count = 1, .reusable = true}, SHIFT(1393),
  [3013] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenated_string_repeat1, 2), SHIFT_REPEAT(1031),
  [3016] = {.count = 1, .reusable = true}, SHIFT(1395),
  [3018] = {.count = 2, .reusable = true}, REDUCE(aux_sym_print_statement_repeat1, 2), SHIFT_REPEAT(1396),
  [3021] = {.count = 1, .reusable = true}, SHIFT(1397),
  [3023] = {.count = 1, .reusable = false}, SHIFT(1397),
  [3025] = {.count = 2, .reusable = true}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(576),
  [3028] = {.count = 2, .reusable = true}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(577),
  [3031] = {.count = 2, .reusable = false}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(576),
  [3034] = {.count = 2, .reusable = true}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(583),
  [3037] = {.count = 1, .reusable = true}, SHIFT(1398),
  [3039] = {.count = 1, .reusable = true}, SHIFT(1399),
  [3041] = {.count = 1, .reusable = true}, SHIFT(1400),
  [3043] = {.count = 1, .reusable = true}, SHIFT(1402),
  [3045] = {.count = 1, .reusable = false}, SHIFT(1403),
  [3047] = {.count = 1, .reusable = true}, SHIFT(1408),
  [3049] = {.count = 1, .reusable = true}, SHIFT(1410),
  [3051] = {.count = 1, .reusable = true}, REDUCE(sym_if_clause, 2),
  [3053] = {.count = 1, .reusable = true}, SHIFT(1412),
  [3055] = {.count = 1, .reusable = true}, SHIFT(1413),
  [3057] = {.count = 1, .reusable = false}, SHIFT(1414),
  [3059] = {.count = 1, .reusable = true}, SHIFT(1415),
  [3061] = {.count = 1, .reusable = true}, SHIFT(1416),
  [3063] = {.count = 1, .reusable = true}, SHIFT(1414),
  [3065] = {.count = 1, .reusable = true}, SHIFT(1417),
  [3067] = {.count = 1, .reusable = true}, SHIFT(1418),
  [3069] = {.count = 1, .reusable = true}, SHIFT(1419),
  [3071] = {.count = 1, .reusable = true}, SHIFT(1420),
  [3073] = {.count = 1, .reusable = true}, SHIFT(1421),
  [3075] = {.count = 1, .reusable = true}, SHIFT(1422),
  [3077] = {.count = 1, .reusable = false}, SHIFT(1416),
  [3079] = {.count = 1, .reusable = true}, SHIFT(1423),
  [3081] = {.count = 1, .reusable = true}, REDUCE(aux_sym__comprehension_body_repeat1, 2),
  [3083] = {.count = 2, .reusable = true}, REDUCE(aux_sym__comprehension_body_repeat1, 2), SHIFT_REPEAT(607),
  [3086] = {.count = 2, .reusable = true}, REDUCE(aux_sym__comprehension_body_repeat1, 2), SHIFT_REPEAT(231),
  [3089] = {.count = 2, .reusable = true}, REDUCE(aux_sym__comprehension_body_repeat1, 2), SHIFT_REPEAT(232),
  [3092] = {.count = 1, .reusable = true}, REDUCE(sym_tuple, 5),
  [3094] = {.count = 1, .reusable = false}, REDUCE(sym_tuple, 5),
  [3096] = {.count = 1, .reusable = true}, SHIFT(1425),
  [3098] = {.count = 1, .reusable = true}, SHIFT(1426),
  [3100] = {.count = 1, .reusable = true}, SHIFT(1427),
  [3102] = {.count = 1, .reusable = true}, SHIFT(1428),
  [3104] = {.count = 1, .reusable = true}, SHIFT(1429),
  [3106] = {.count = 1, .reusable = true}, SHIFT(1430),
  [3108] = {.count = 1, .reusable = true}, SHIFT(1431),
  [3110] = {.count = 1, .reusable = true}, SHIFT(1432),
  [3112] = {.count = 1, .reusable = true}, SHIFT(1434),
  [3114] = {.count = 1, .reusable = true}, SHIFT(1435),
  [3116] = {.count = 1, .reusable = true}, SHIFT(1436),
  [3118] = {.count = 1, .reusable = true}, SHIFT(1437),
  [3120] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenated_string_repeat1, 2), SHIFT_REPEAT(1098),
  [3123] = {.count = 1, .reusable = true}, SHIFT(1439),
  [3125] = {.count = 1, .reusable = true}, SHIFT(1440),
  [3127] = {.count = 1, .reusable = false}, SHIFT(1440),
  [3129] = {.count = 2, .reusable = true}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(680),
  [3132] = {.count = 2, .reusable = true}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(681),
  [3135] = {.count = 2, .reusable = false}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(680),
  [3138] = {.count = 2, .reusable = true}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(687),
  [3141] = {.count = 1, .reusable = true}, SHIFT(1443),
  [3143] = {.count = 1, .reusable = true}, SHIFT(1444),
  [3145] = {.count = 1, .reusable = true}, SHIFT(1445),
  [3147] = {.count = 1, .reusable = true}, SHIFT(1447),
  [3149] = {.count = 1, .reusable = true}, REDUCE(sym_if_statement, 5),
  [3151] = {.count = 1, .reusable = false}, REDUCE(sym_if_statement, 5),
  [3153] = {.count = 1, .reusable = true}, SHIFT(1450),
  [3155] = {.count = 1, .reusable = true}, REDUCE(sym_with_statement, 5),
  [3157] = {.count = 1, .reusable = false}, REDUCE(sym_with_statement, 5),
  [3159] = {.count = 1, .reusable = true}, SHIFT(1456),
  [3161] = {.count = 1, .reusable = true}, SHIFT(1458),
  [3163] = {.count = 1, .reusable = true}, SHIFT(1459),
  [3165] = {.count = 1, .reusable = true}, SHIFT(1460),
  [3167] = {.count = 1, .reusable = true}, REDUCE(sym_while_statement, 5),
  [3169] = {.count = 1, .reusable = false}, REDUCE(sym_while_statement, 5),
  [3171] = {.count = 1, .reusable = true}, SHIFT(1461),
  [3173] = {.count = 1, .reusable = true}, SHIFT(1462),
  [3175] = {.count = 1, .reusable = true}, SHIFT(1463),
  [3177] = {.count = 1, .reusable = true}, SHIFT(1466),
  [3179] = {.count = 1, .reusable = true}, SHIFT(1467),
  [3181] = {.count = 1, .reusable = true}, SHIFT(1468),
  [3183] = {.count = 1, .reusable = true}, SHIFT(1470),
  [3185] = {.count = 1, .reusable = true}, SHIFT(1473),
  [3187] = {.count = 1, .reusable = true}, REDUCE(sym__suite, 3),
  [3189] = {.count = 1, .reusable = false}, REDUCE(sym__suite, 3),
  [3191] = {.count = 2, .reusable = false}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(746),
  [3194] = {.count = 2, .reusable = false}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(747),
  [3197] = {.count = 2, .reusable = false}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(748),
  [3200] = {.count = 2, .reusable = false}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(749),
  [3203] = {.count = 2, .reusable = false}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(750),
  [3206] = {.count = 2, .reusable = false}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(751),
  [3209] = {.count = 2, .reusable = false}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(752),
  [3212] = {.count = 2, .reusable = false}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(753),
  [3215] = {.count = 2, .reusable = false}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(754),
  [3218] = {.count = 1, .reusable = true}, SHIFT(1475),
  [3220] = {.count = 1, .reusable = true}, SHIFT(1477),
  [3222] = {.count = 1, .reusable = true}, SHIFT(1478),
  [3224] = {.count = 1, .reusable = true}, SHIFT(1480),
  [3226] = {.count = 1, .reusable = true}, REDUCE(sym_try_statement, 5),
  [3228] = {.count = 1, .reusable = false}, REDUCE(sym_try_statement, 5),
  [3230] = {.count = 1, .reusable = true}, REDUCE(aux_sym_try_statement_repeat1, 2),
  [3232] = {.count = 1, .reusable = false}, REDUCE(aux_sym_try_statement_repeat1, 2),
  [3234] = {.count = 2, .reusable = false}, REDUCE(aux_sym_try_statement_repeat1, 2), SHIFT_REPEAT(760),
  [3237] = {.count = 1, .reusable = true}, SHIFT(1482),
  [3239] = {.count = 1, .reusable = true}, SHIFT(1486),
  [3241] = {.count = 1, .reusable = true}, SHIFT(1488),
  [3243] = {.count = 1, .reusable = true}, SHIFT(1489),
  [3245] = {.count = 1, .reusable = true}, SHIFT(1490),
  [3247] = {.count = 1, .reusable = true}, SHIFT(1491),
  [3249] = {.count = 1, .reusable = false}, SHIFT(1492),
  [3251] = {.count = 1, .reusable = true}, SHIFT(1493),
  [3253] = {.count = 1, .reusable = true}, SHIFT(1494),
  [3255] = {.count = 1, .reusable = true}, SHIFT(1492),
  [3257] = {.count = 1, .reusable = true}, SHIFT(1495),
  [3259] = {.count = 1, .reusable = true}, SHIFT(1496),
  [3261] = {.count = 1, .reusable = true}, SHIFT(1497),
  [3263] = {.count = 1, .reusable = true}, SHIFT(1498),
  [3265] = {.count = 1, .reusable = true}, SHIFT(1499),
  [3267] = {.count = 1, .reusable = true}, SHIFT(1500),
  [3269] = {.count = 1, .reusable = false}, SHIFT(1494),
  [3271] = {.count = 1, .reusable = true}, SHIFT(1501),
  [3273] = {.count = 1, .reusable = false}, SHIFT(1503),
  [3275] = {.count = 1, .reusable = false}, SHIFT(1504),
  [3277] = {.count = 1, .reusable = true}, SHIFT(1508),
  [3279] = {.count = 1, .reusable = false}, SHIFT(1510),
  [3281] = {.count = 1, .reusable = true}, SHIFT(1511),
  [3283] = {.count = 1, .reusable = false}, SHIFT(1512),
  [3285] = {.count = 1, .reusable = true}, SHIFT(1516),
  [3287] = {.count = 1, .reusable = true}, SHIFT(1513),
  [3289] = {.count = 1, .reusable = false}, SHIFT(1516),
  [3291] = {.count = 1, .reusable = false}, SHIFT(1514),
  [3293] = {.count = 1, .reusable = true}, SHIFT(1519),
  [3295] = {.count = 1, .reusable = true}, REDUCE(sym_parameters, 3),
  [3297] = {.count = 1, .reusable = true}, REDUCE(sym_function_definition, 5),
  [3299] = {.count = 1, .reusable = false}, REDUCE(sym_function_definition, 5),
  [3301] = {.count = 1, .reusable = true}, SHIFT(1521),
  [3303] = {.count = 1, .reusable = true}, REDUCE(sym_exec_statement, 5),
  [3305] = {.count = 1, .reusable = true}, REDUCE(sym_class_definition, 5),
  [3307] = {.count = 1, .reusable = false}, REDUCE(sym_class_definition, 5),
  [3309] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenated_string_repeat1, 2), SHIFT_REPEAT(1197),
  [3312] = {.count = 1, .reusable = true}, SHIFT(1523),
  [3314] = {.count = 1, .reusable = true}, SHIFT(1524),
  [3316] = {.count = 1, .reusable = false}, SHIFT(1524),
  [3318] = {.count = 2, .reusable = true}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(811),
  [3321] = {.count = 2, .reusable = true}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(812),
  [3324] = {.count = 2, .reusable = false}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(811),
  [3327] = {.count = 2, .reusable = true}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(818),
  [3330] = {.count = 1, .reusable = true}, SHIFT(1526),
  [3332] = {.count = 1, .reusable = true}, SHIFT(1527),
  [3334] = {.count = 1, .reusable = true}, SHIFT(1530),
  [3336] = {.count = 1, .reusable = false}, SHIFT(1530),
  [3338] = {.count = 1, .reusable = true}, SHIFT(1531),
  [3340] = {.count = 1, .reusable = false}, SHIFT(1531),
  [3342] = {.count = 1, .reusable = true}, SHIFT(1532),
  [3344] = {.count = 1, .reusable = false}, SHIFT(1532),
  [3346] = {.count = 1, .reusable = true}, SHIFT(1533),
  [3348] = {.count = 1, .reusable = true}, SHIFT(1534),
  [3350] = {.count = 1, .reusable = false}, SHIFT(1534),
  [3352] = {.count = 1, .reusable = true}, SHIFT(1535),
  [3354] = {.count = 1, .reusable = false}, SHIFT(1535),
  [3356] = {.count = 1, .reusable = true}, SHIFT(1536),
  [3358] = {.count = 1, .reusable = false}, SHIFT(1536),
  [3360] = {.count = 1, .reusable = true}, SHIFT(1537),
  [3362] = {.count = 1, .reusable = false}, SHIFT(1537),
  [3364] = {.count = 1, .reusable = false}, SHIFT(1533),
  [3366] = {.count = 1, .reusable = true}, SHIFT(1541),
  [3368] = {.count = 1, .reusable = true}, SHIFT(1542),
  [3370] = {.count = 1, .reusable = true}, SHIFT(1545),
  [3372] = {.count = 1, .reusable = false}, SHIFT(1545),
  [3374] = {.count = 1, .reusable = true}, SHIFT(1546),
  [3376] = {.count = 1, .reusable = false}, SHIFT(1546),
  [3378] = {.count = 1, .reusable = true}, SHIFT(1547),
  [3380] = {.count = 1, .reusable = false}, SHIFT(1547),
  [3382] = {.count = 1, .reusable = true}, SHIFT(1548),
  [3384] = {.count = 1, .reusable = true}, SHIFT(1549),
  [3386] = {.count = 1, .reusable = false}, SHIFT(1549),
  [3388] = {.count = 1, .reusable = true}, SHIFT(1550),
  [3390] = {.count = 1, .reusable = false}, SHIFT(1550),
  [3392] = {.count = 1, .reusable = true}, SHIFT(1551),
  [3394] = {.count = 1, .reusable = false}, SHIFT(1551),
  [3396] = {.count = 1, .reusable = true}, SHIFT(1552),
  [3398] = {.count = 1, .reusable = false}, SHIFT(1552),
  [3400] = {.count = 1, .reusable = false}, SHIFT(1548),
  [3402] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenated_string_repeat1, 2), SHIFT_REPEAT(1250),
  [3405] = {.count = 1, .reusable = true}, SHIFT(1556),
  [3407] = {.count = 1, .reusable = true}, SHIFT(1557),
  [3409] = {.count = 1, .reusable = false}, SHIFT(1557),
  [3411] = {.count = 2, .reusable = true}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(857),
  [3414] = {.count = 2, .reusable = true}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(858),
  [3417] = {.count = 2, .reusable = false}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(857),
  [3420] = {.count = 2, .reusable = true}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(864),
  [3423] = {.count = 1, .reusable = true}, REDUCE(sym_list, 5),
  [3425] = {.count = 1, .reusable = false}, REDUCE(sym_list, 5),
  [3427] = {.count = 1, .reusable = true}, SHIFT(1559),
  [3429] = {.count = 1, .reusable = false}, SHIFT(1560),
  [3431] = {.count = 1, .reusable = true}, SHIFT(1564),
  [3433] = {.count = 1, .reusable = true}, SHIFT(1566),
  [3435] = {.count = 1, .reusable = true}, SHIFT(1568),
  [3437] = {.count = 1, .reusable = true}, SHIFT(1569),
  [3439] = {.count = 1, .reusable = false}, SHIFT(1570),
  [3441] = {.count = 1, .reusable = true}, SHIFT(1571),
  [3443] = {.count = 1, .reusable = true}, SHIFT(1572),
  [3445] = {.count = 1, .reusable = true}, SHIFT(1570),
  [3447] = {.count = 1, .reusable = true}, SHIFT(1573),
  [3449] = {.count = 1, .reusable = true}, SHIFT(1574),
  [3451] = {.count = 1, .reusable = true}, SHIFT(1575),
  [3453] = {.count = 1, .reusable = true}, SHIFT(1576),
  [3455] = {.count = 1, .reusable = true}, SHIFT(1577),
  [3457] = {.count = 1, .reusable = true}, SHIFT(1578),
  [3459] = {.count = 1, .reusable = false}, SHIFT(1572),
  [3461] = {.count = 1, .reusable = true}, SHIFT(1579),
  [3463] = {.count = 2, .reusable = true}, REDUCE(aux_sym__comprehension_body_repeat1, 2), SHIFT_REPEAT(879),
  [3466] = {.count = 2, .reusable = true}, REDUCE(aux_sym__comprehension_body_repeat1, 2), SHIFT_REPEAT(438),
  [3469] = {.count = 2, .reusable = true}, REDUCE(aux_sym__comprehension_body_repeat1, 2), SHIFT_REPEAT(439),
  [3472] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenated_string_repeat1, 2), SHIFT_REPEAT(1279),
  [3475] = {.count = 1, .reusable = true}, SHIFT(1582),
  [3477] = {.count = 1, .reusable = true}, SHIFT(1583),
  [3479] = {.count = 1, .reusable = false}, SHIFT(1583),
  [3481] = {.count = 2, .reusable = true}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(900),
  [3484] = {.count = 2, .reusable = true}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(901),
  [3487] = {.count = 2, .reusable = false}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(900),
  [3490] = {.count = 2, .reusable = true}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(907),
  [3493] = {.count = 1, .reusable = true}, REDUCE(sym_set, 5),
  [3495] = {.count = 1, .reusable = false}, REDUCE(sym_set, 5),
  [3497] = {.count = 1, .reusable = true}, REDUCE(sym_dictionary, 5),
  [3499] = {.count = 1, .reusable = false}, REDUCE(sym_dictionary, 5),
  [3501] = {.count = 1, .reusable = true}, SHIFT(1587),
  [3503] = {.count = 1, .reusable = true}, SHIFT(1588),
  [3505] = {.count = 1, .reusable = true}, SHIFT(1591),
  [3507] = {.count = 1, .reusable = false}, SHIFT(1591),
  [3509] = {.count = 1, .reusable = true}, SHIFT(1592),
  [3511] = {.count = 1, .reusable = false}, SHIFT(1592),
  [3513] = {.count = 1, .reusable = true}, SHIFT(1593),
  [3515] = {.count = 1, .reusable = false}, SHIFT(1593),
  [3517] = {.count = 1, .reusable = true}, SHIFT(1594),
  [3519] = {.count = 1, .reusable = true}, SHIFT(1595),
  [3521] = {.count = 1, .reusable = false}, SHIFT(1595),
  [3523] = {.count = 1, .reusable = true}, SHIFT(1596),
  [3525] = {.count = 1, .reusable = false}, SHIFT(1596),
  [3527] = {.count = 1, .reusable = true}, SHIFT(1597),
  [3529] = {.count = 1, .reusable = false}, SHIFT(1597),
  [3531] = {.count = 1, .reusable = true}, SHIFT(1598),
  [3533] = {.count = 1, .reusable = false}, SHIFT(1598),
  [3535] = {.count = 1, .reusable = false}, SHIFT(1594),
  [3537] = {.count = 1, .reusable = true}, SHIFT(1600),
  [3539] = {.count = 1, .reusable = false}, SHIFT(1601),
  [3541] = {.count = 1, .reusable = true}, SHIFT(1605),
  [3543] = {.count = 1, .reusable = true}, SHIFT(1607),
  [3545] = {.count = 1, .reusable = true}, SHIFT(1609),
  [3547] = {.count = 1, .reusable = true}, SHIFT(1610),
  [3549] = {.count = 1, .reusable = false}, SHIFT(1611),
  [3551] = {.count = 1, .reusable = true}, SHIFT(1612),
  [3553] = {.count = 1, .reusable = true}, SHIFT(1613),
  [3555] = {.count = 1, .reusable = true}, SHIFT(1611),
  [3557] = {.count = 1, .reusable = true}, SHIFT(1614),
  [3559] = {.count = 1, .reusable = true}, SHIFT(1615),
  [3561] = {.count = 1, .reusable = true}, SHIFT(1616),
  [3563] = {.count = 1, .reusable = true}, SHIFT(1617),
  [3565] = {.count = 1, .reusable = true}, SHIFT(1618),
  [3567] = {.count = 1, .reusable = true}, SHIFT(1619),
  [3569] = {.count = 1, .reusable = false}, SHIFT(1613),
  [3571] = {.count = 1, .reusable = true}, SHIFT(1620),
  [3573] = {.count = 2, .reusable = true}, REDUCE(aux_sym__comprehension_body_repeat1, 2), SHIFT_REPEAT(935),
  [3576] = {.count = 2, .reusable = true}, REDUCE(aux_sym__comprehension_body_repeat1, 2), SHIFT_REPEAT(475),
  [3579] = {.count = 2, .reusable = true}, REDUCE(aux_sym__comprehension_body_repeat1, 2), SHIFT_REPEAT(476),
  [3582] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenated_string_repeat1, 2), SHIFT_REPEAT(1329),
  [3585] = {.count = 1, .reusable = true}, SHIFT(1623),
  [3587] = {.count = 1, .reusable = true}, SHIFT(1624),
  [3589] = {.count = 1, .reusable = false}, SHIFT(1624),
  [3591] = {.count = 2, .reusable = true}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(956),
  [3594] = {.count = 2, .reusable = true}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(957),
  [3597] = {.count = 2, .reusable = false}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(956),
  [3600] = {.count = 2, .reusable = true}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(963),
  [3603] = {.count = 1, .reusable = true}, REDUCE(sym_assignment, 5),
  [3605] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenated_string_repeat1, 2), SHIFT_REPEAT(1345),
  [3608] = {.count = 1, .reusable = true}, SHIFT(1626),
  [3610] = {.count = 1, .reusable = true}, REDUCE(sym_conditional_expression, 5),
  [3612] = {.count = 1, .reusable = true}, SHIFT(1627),
  [3614] = {.count = 1, .reusable = false}, SHIFT(1627),
  [3616] = {.count = 2, .reusable = true}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(978),
  [3619] = {.count = 2, .reusable = true}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(979),
  [3622] = {.count = 2, .reusable = false}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(978),
  [3625] = {.count = 2, .reusable = true}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(985),
  [3628] = {.count = 1, .reusable = true}, REDUCE(sym_keyword_argument, 3, .alias_sequence_id = 1),
  [3630] = {.count = 1, .reusable = true}, REDUCE(sym_keyword_argument, 3),
  [3632] = {.count = 1, .reusable = true}, REDUCE(sym_argument_list, 4),
  [3634] = {.count = 1, .reusable = false}, REDUCE(sym_argument_list, 4),
  [3636] = {.count = 1, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2),
  [3638] = {.count = 1, .reusable = true}, SHIFT(1628),
  [3640] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(1629),
  [3643] = {.count = 1, .reusable = true}, REDUCE(sym_slice, 3),
  [3645] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenated_string_repeat1, 2), SHIFT_REPEAT(1370),
  [3648] = {.count = 1, .reusable = true}, REDUCE(sym_subscript, 5),
  [3650] = {.count = 1, .reusable = false}, REDUCE(sym_subscript, 5),
  [3652] = {.count = 1, .reusable = true}, REDUCE(aux_sym_subscript_repeat1, 2),
  [3654] = {.count = 1, .reusable = true}, SHIFT(1632),
  [3656] = {.count = 1, .reusable = true}, SHIFT(1633),
  [3658] = {.count = 1, .reusable = true}, SHIFT(1634),
  [3660] = {.count = 2, .reusable = true}, REDUCE(aux_sym_subscript_repeat1, 2), SHIFT_REPEAT(1635),
  [3663] = {.count = 1, .reusable = true}, SHIFT(1636),
  [3665] = {.count = 1, .reusable = false}, SHIFT(1636),
  [3667] = {.count = 2, .reusable = true}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(1011),
  [3670] = {.count = 2, .reusable = true}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(1012),
  [3673] = {.count = 2, .reusable = false}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(1011),
  [3676] = {.count = 2, .reusable = true}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(1018),
  [3679] = {.count = 1, .reusable = true}, REDUCE(sym_import_from_statement, 6),
  [3681] = {.count = 1, .reusable = true}, SHIFT(1640),
  [3683] = {.count = 1, .reusable = true}, SHIFT(1642),
  [3685] = {.count = 1, .reusable = true}, SHIFT(1645),
  [3687] = {.count = 1, .reusable = true}, REDUCE(sym_for_in_clause, 4),
  [3689] = {.count = 1, .reusable = true}, SHIFT(1647),
  [3691] = {.count = 1, .reusable = true}, REDUCE(sym__expression_within_for_in_clause, 1),
  [3693] = {.count = 1, .reusable = true}, REDUCE(sym__expression_within_for_in_clause, 1, .alias_sequence_id = 3),
  [3695] = {.count = 1, .reusable = true}, SHIFT(1650),
  [3697] = {.count = 1, .reusable = true}, SHIFT(1651),
  [3699] = {.count = 1, .reusable = true}, SHIFT(1654),
  [3701] = {.count = 1, .reusable = false}, SHIFT(1654),
  [3703] = {.count = 1, .reusable = true}, SHIFT(1655),
  [3705] = {.count = 1, .reusable = false}, SHIFT(1655),
  [3707] = {.count = 1, .reusable = true}, SHIFT(1656),
  [3709] = {.count = 1, .reusable = false}, SHIFT(1656),
  [3711] = {.count = 1, .reusable = true}, SHIFT(1657),
  [3713] = {.count = 1, .reusable = true}, SHIFT(1658),
  [3715] = {.count = 1, .reusable = false}, SHIFT(1658),
  [3717] = {.count = 1, .reusable = true}, SHIFT(1659),
  [3719] = {.count = 1, .reusable = false}, SHIFT(1659),
  [3721] = {.count = 1, .reusable = true}, SHIFT(1660),
  [3723] = {.count = 1, .reusable = false}, SHIFT(1660),
  [3725] = {.count = 1, .reusable = true}, SHIFT(1661),
  [3727] = {.count = 1, .reusable = false}, SHIFT(1661),
  [3729] = {.count = 1, .reusable = false}, SHIFT(1657),
  [3731] = {.count = 1, .reusable = true}, SHIFT(1663),
  [3733] = {.count = 1, .reusable = true}, SHIFT(1664),
  [3735] = {.count = 1, .reusable = true}, SHIFT(1665),
  [3737] = {.count = 1, .reusable = true}, SHIFT(1666),
  [3739] = {.count = 1, .reusable = true}, SHIFT(1668),
  [3741] = {.count = 1, .reusable = true}, SHIFT(1669),
  [3743] = {.count = 1, .reusable = true}, REDUCE(sym_if_statement, 6),
  [3745] = {.count = 1, .reusable = false}, REDUCE(sym_if_statement, 6),
  [3747] = {.count = 1, .reusable = true}, REDUCE(aux_sym_if_statement_repeat1, 2),
  [3749] = {.count = 1, .reusable = false}, REDUCE(aux_sym_if_statement_repeat1, 2),
  [3751] = {.count = 2, .reusable = false}, REDUCE(aux_sym_if_statement_repeat1, 2), SHIFT_REPEAT(1121),
  [3754] = {.count = 1, .reusable = true}, REDUCE(sym_with_statement, 6),
  [3756] = {.count = 1, .reusable = false}, REDUCE(sym_with_statement, 6),
  [3758] = {.count = 1, .reusable = true}, REDUCE(sym_function_definition, 6),
  [3760] = {.count = 1, .reusable = false}, REDUCE(sym_function_definition, 6),
  [3762] = {.count = 1, .reusable = true}, SHIFT(1672),
  [3764] = {.count = 1, .reusable = true}, REDUCE(sym_for_statement, 6),
  [3766] = {.count = 1, .reusable = false}, REDUCE(sym_for_statement, 6),
  [3768] = {.count = 2, .reusable = true}, REDUCE(aux_sym_print_statement_repeat1, 2), SHIFT_REPEAT(1674),
  [3771] = {.count = 1, .reusable = true}, SHIFT(1675),
  [3773] = {.count = 1, .reusable = true}, SHIFT(1676),
  [3775] = {.count = 1, .reusable = true}, SHIFT(1677),
  [3777] = {.count = 1, .reusable = false}, SHIFT(1678),
  [3779] = {.count = 1, .reusable = true}, SHIFT(1680),
  [3781] = {.count = 1, .reusable = true}, SHIFT(1681),
  [3783] = {.count = 1, .reusable = true}, SHIFT(1685),
  [3785] = {.count = 1, .reusable = false}, SHIFT(1686),
  [3787] = {.count = 1, .reusable = true}, SHIFT(1688),
  [3789] = {.count = 1, .reusable = true}, SHIFT(1689),
  [3791] = {.count = 1, .reusable = true}, SHIFT(1692),
  [3793] = {.count = 1, .reusable = true}, SHIFT(1694),
  [3795] = {.count = 1, .reusable = true}, SHIFT(1695),
  [3797] = {.count = 1, .reusable = true}, SHIFT(1697),
  [3799] = {.count = 1, .reusable = true}, REDUCE(sym_except_clause, 3),
  [3801] = {.count = 1, .reusable = false}, REDUCE(sym_except_clause, 3),
  [3803] = {.count = 1, .reusable = true}, REDUCE(sym_finally_clause, 3),
  [3805] = {.count = 1, .reusable = false}, REDUCE(sym_finally_clause, 3),
  [3807] = {.count = 1, .reusable = true}, SHIFT(1700),
  [3809] = {.count = 1, .reusable = false}, SHIFT(1701),
  [3811] = {.count = 1, .reusable = true}, REDUCE(sym_try_statement, 6),
  [3813] = {.count = 1, .reusable = false}, REDUCE(sym_try_statement, 6),
  [3815] = {.count = 1, .reusable = true}, SHIFT(1704),
  [3817] = {.count = 1, .reusable = true}, SHIFT(1705),
  [3819] = {.count = 1, .reusable = true}, SHIFT(1708),
  [3821] = {.count = 1, .reusable = false}, SHIFT(1708),
  [3823] = {.count = 1, .reusable = true}, SHIFT(1709),
  [3825] = {.count = 1, .reusable = false}, SHIFT(1709),
  [3827] = {.count = 1, .reusable = true}, SHIFT(1710),
  [3829] = {.count = 1, .reusable = false}, SHIFT(1710),
  [3831] = {.count = 1, .reusable = true}, SHIFT(1711),
  [3833] = {.count = 1, .reusable = true}, SHIFT(1712),
  [3835] = {.count = 1, .reusable = false}, SHIFT(1712),
  [3837] = {.count = 1, .reusable = true}, SHIFT(1713),
  [3839] = {.count = 1, .reusable = false}, SHIFT(1713),
  [3841] = {.count = 1, .reusable = true}, SHIFT(1714),
  [3843] = {.count = 1, .reusable = false}, SHIFT(1714),
  [3845] = {.count = 1, .reusable = true}, SHIFT(1715),
  [3847] = {.count = 1, .reusable = false}, SHIFT(1715),
  [3849] = {.count = 1, .reusable = false}, SHIFT(1711),
  [3851] = {.count = 1, .reusable = true}, SHIFT(1717),
  [3853] = {.count = 2, .reusable = true}, REDUCE(aux_sym__parameters_repeat1, 2), SHIFT_REPEAT(1718),
  [3856] = {.count = 1, .reusable = true}, SHIFT(1720),
  [3858] = {.count = 1, .reusable = true}, SHIFT(1722),
  [3860] = {.count = 1, .reusable = true}, SHIFT(1723),
  [3862] = {.count = 1, .reusable = true}, SHIFT(1724),
  [3864] = {.count = 1, .reusable = true}, SHIFT(1725),
  [3866] = {.count = 1, .reusable = false}, SHIFT(1726),
  [3868] = {.count = 1, .reusable = true}, SHIFT(1727),
  [3870] = {.count = 1, .reusable = true}, SHIFT(1728),
  [3872] = {.count = 1, .reusable = true}, SHIFT(1726),
  [3874] = {.count = 1, .reusable = true}, SHIFT(1729),
  [3876] = {.count = 1, .reusable = true}, SHIFT(1730),
  [3878] = {.count = 1, .reusable = true}, SHIFT(1731),
  [3880] = {.count = 1, .reusable = true}, SHIFT(1732),
  [3882] = {.count = 1, .reusable = true}, SHIFT(1733),
  [3884] = {.count = 1, .reusable = true}, SHIFT(1734),
  [3886] = {.count = 1, .reusable = false}, SHIFT(1728),
  [3888] = {.count = 1, .reusable = true}, SHIFT(1735),
  [3890] = {.count = 1, .reusable = true}, SHIFT(1737),
  [3892] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenated_string_repeat1, 2), SHIFT_REPEAT(1527),
  [3895] = {.count = 1, .reusable = true}, SHIFT(1741),
  [3897] = {.count = 1, .reusable = true}, SHIFT(1742),
  [3899] = {.count = 1, .reusable = false}, SHIFT(1742),
  [3901] = {.count = 2, .reusable = true}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(1218),
  [3904] = {.count = 2, .reusable = true}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(1219),
  [3907] = {.count = 2, .reusable = false}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(1218),
  [3910] = {.count = 2, .reusable = true}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(1225),
  [3913] = {.count = 1, .reusable = true}, REDUCE(sym_typed_default_parameter, 5, .alias_sequence_id = 1),
  [3915] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenated_string_repeat1, 2), SHIFT_REPEAT(1542),
  [3918] = {.count = 1, .reusable = true}, SHIFT(1744),
  [3920] = {.count = 1, .reusable = true}, SHIFT(1745),
  [3922] = {.count = 1, .reusable = false}, SHIFT(1745),
  [3924] = {.count = 2, .reusable = true}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(1238),
  [3927] = {.count = 2, .reusable = true}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(1239),
  [3930] = {.count = 2, .reusable = false}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(1238),
  [3933] = {.count = 2, .reusable = true}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(1245),
  [3936] = {.count = 1, .reusable = true}, REDUCE(sym_typed_default_parameter, 5),
  [3938] = {.count = 1, .reusable = true}, SHIFT(1748),
  [3940] = {.count = 1, .reusable = true}, SHIFT(1750),
  [3942] = {.count = 1, .reusable = true}, SHIFT(1753),
  [3944] = {.count = 1, .reusable = true}, SHIFT(1754),
  [3946] = {.count = 1, .reusable = true}, SHIFT(1757),
  [3948] = {.count = 1, .reusable = false}, SHIFT(1757),
  [3950] = {.count = 1, .reusable = true}, SHIFT(1758),
  [3952] = {.count = 1, .reusable = false}, SHIFT(1758),
  [3954] = {.count = 1, .reusable = true}, SHIFT(1759),
  [3956] = {.count = 1, .reusable = false}, SHIFT(1759),
  [3958] = {.count = 1, .reusable = true}, SHIFT(1760),
  [3960] = {.count = 1, .reusable = true}, SHIFT(1761),
  [3962] = {.count = 1, .reusable = false}, SHIFT(1761),
  [3964] = {.count = 1, .reusable = true}, SHIFT(1762),
  [3966] = {.count = 1, .reusable = false}, SHIFT(1762),
  [3968] = {.count = 1, .reusable = true}, SHIFT(1763),
  [3970] = {.count = 1, .reusable = false}, SHIFT(1763),
  [3972] = {.count = 1, .reusable = true}, SHIFT(1764),
  [3974] = {.count = 1, .reusable = false}, SHIFT(1764),
  [3976] = {.count = 1, .reusable = false}, SHIFT(1760),
  [3978] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenated_string_repeat1, 2), SHIFT_REPEAT(1588),
  [3981] = {.count = 1, .reusable = true}, SHIFT(1768),
  [3983] = {.count = 1, .reusable = true}, SHIFT(1769),
  [3985] = {.count = 1, .reusable = false}, SHIFT(1769),
  [3987] = {.count = 2, .reusable = true}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(1307),
  [3990] = {.count = 2, .reusable = true}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(1308),
  [3993] = {.count = 2, .reusable = false}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(1307),
  [3996] = {.count = 2, .reusable = true}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(1314),
  [3999] = {.count = 1, .reusable = true}, SHIFT(1771),
  [4001] = {.count = 1, .reusable = true}, SHIFT(1773),
  [4003] = {.count = 1, .reusable = true}, SHIFT(1776),
  [4005] = {.count = 1, .reusable = true}, SHIFT(1777),
  [4007] = {.count = 1, .reusable = true}, SHIFT(1780),
  [4009] = {.count = 1, .reusable = false}, SHIFT(1780),
  [4011] = {.count = 1, .reusable = true}, SHIFT(1781),
  [4013] = {.count = 1, .reusable = false}, SHIFT(1781),
  [4015] = {.count = 1, .reusable = true}, SHIFT(1782),
  [4017] = {.count = 1, .reusable = false}, SHIFT(1782),
  [4019] = {.count = 1, .reusable = true}, SHIFT(1783),
  [4021] = {.count = 1, .reusable = true}, SHIFT(1784),
  [4023] = {.count = 1, .reusable = false}, SHIFT(1784),
  [4025] = {.count = 1, .reusable = true}, SHIFT(1785),
  [4027] = {.count = 1, .reusable = false}, SHIFT(1785),
  [4029] = {.count = 1, .reusable = true}, SHIFT(1786),
  [4031] = {.count = 1, .reusable = false}, SHIFT(1786),
  [4033] = {.count = 1, .reusable = true}, SHIFT(1787),
  [4035] = {.count = 1, .reusable = false}, SHIFT(1787),
  [4037] = {.count = 1, .reusable = false}, SHIFT(1783),
  [4039] = {.count = 1, .reusable = true}, REDUCE(sym_argument_list, 5),
  [4041] = {.count = 1, .reusable = false}, REDUCE(sym_argument_list, 5),
  [4043] = {.count = 1, .reusable = true}, REDUCE(sym_slice, 4),
  [4045] = {.count = 1, .reusable = true}, REDUCE(sym_subscript, 6),
  [4047] = {.count = 1, .reusable = false}, REDUCE(sym_subscript, 6),
  [4049] = {.count = 2, .reusable = true}, REDUCE(aux_sym__import_list_repeat1, 2), SHIFT_REPEAT(1793),
  [4052] = {.count = 1, .reusable = true}, REDUCE(sym_for_in_clause, 5),
  [4054] = {.count = 1, .reusable = true}, SHIFT(1794),
  [4056] = {.count = 1, .reusable = true}, SHIFT(1797),
  [4058] = {.count = 1, .reusable = false}, REDUCE(sym_for_in_clause, 5),
  [4060] = {.count = 1, .reusable = true}, SHIFT(1411),
  [4062] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenated_string_repeat1, 2), SHIFT_REPEAT(1651),
  [4065] = {.count = 1, .reusable = true}, SHIFT(1801),
  [4067] = {.count = 1, .reusable = true}, SHIFT(1802),
  [4069] = {.count = 1, .reusable = false}, SHIFT(1802),
  [4071] = {.count = 2, .reusable = true}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(1416),
  [4074] = {.count = 2, .reusable = true}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(1417),
  [4077] = {.count = 2, .reusable = false}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(1416),
  [4080] = {.count = 2, .reusable = true}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(1423),
  [4083] = {.count = 1, .reusable = true}, REDUCE(sym_else_clause, 3),
  [4085] = {.count = 1, .reusable = false}, REDUCE(sym_else_clause, 3),
  [4087] = {.count = 1, .reusable = true}, REDUCE(sym_for_statement, 7),
  [4089] = {.count = 1, .reusable = false}, REDUCE(sym_for_statement, 7),
  [4091] = {.count = 1, .reusable = true}, SHIFT(1806),
  [4093] = {.count = 1, .reusable = true}, SHIFT(1808),
  [4095] = {.count = 1, .reusable = true}, SHIFT(1809),
  [4097] = {.count = 1, .reusable = false}, SHIFT(1811),
  [4099] = {.count = 1, .reusable = false}, SHIFT(1812),
  [4101] = {.count = 1, .reusable = true}, SHIFT(1817),
  [4103] = {.count = 1, .reusable = true}, SHIFT(1818),
  [4105] = {.count = 1, .reusable = true}, SHIFT(1819),
  [4107] = {.count = 1, .reusable = true}, SHIFT(1820),
  [4109] = {.count = 1, .reusable = true}, SHIFT(1821),
  [4111] = {.count = 1, .reusable = true}, SHIFT(1823),
  [4113] = {.count = 1, .reusable = true}, SHIFT(1824),
  [4115] = {.count = 1, .reusable = true}, SHIFT(1827),
  [4117] = {.count = 1, .reusable = true}, SHIFT(1829),
  [4119] = {.count = 1, .reusable = false}, SHIFT(1830),
  [4121] = {.count = 1, .reusable = false}, SHIFT(1688),
  [4123] = {.count = 1, .reusable = false}, SHIFT(1689),
  [4125] = {.count = 1, .reusable = true}, SHIFT(1834),
  [4127] = {.count = 1, .reusable = true}, SHIFT(1839),
  [4129] = {.count = 1, .reusable = true}, REDUCE(sym_except_clause, 4),
  [4131] = {.count = 1, .reusable = false}, REDUCE(sym_except_clause, 4),
  [4133] = {.count = 1, .reusable = true}, SHIFT(1840),
  [4135] = {.count = 1, .reusable = true}, SHIFT(1842),
  [4137] = {.count = 1, .reusable = true}, SHIFT(1843),
  [4139] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenated_string_repeat1, 2), SHIFT_REPEAT(1705),
  [4142] = {.count = 1, .reusable = true}, SHIFT(1846),
  [4144] = {.count = 1, .reusable = true}, SHIFT(1847),
  [4146] = {.count = 1, .reusable = false}, SHIFT(1847),
  [4148] = {.count = 2, .reusable = true}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(1494),
  [4151] = {.count = 2, .reusable = true}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(1495),
  [4154] = {.count = 2, .reusable = false}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(1494),
  [4157] = {.count = 2, .reusable = true}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(1501),
  [4160] = {.count = 1, .reusable = true}, SHIFT(1850),
  [4162] = {.count = 1, .reusable = true}, SHIFT(1851),
  [4164] = {.count = 1, .reusable = true}, SHIFT(1854),
  [4166] = {.count = 1, .reusable = false}, SHIFT(1854),
  [4168] = {.count = 1, .reusable = true}, SHIFT(1855),
  [4170] = {.count = 1, .reusable = false}, SHIFT(1855),
  [4172] = {.count = 1, .reusable = true}, SHIFT(1856),
  [4174] = {.count = 1, .reusable = false}, SHIFT(1856),
  [4176] = {.count = 1, .reusable = true}, SHIFT(1857),
  [4178] = {.count = 1, .reusable = true}, SHIFT(1858),
  [4180] = {.count = 1, .reusable = false}, SHIFT(1858),
  [4182] = {.count = 1, .reusable = true}, SHIFT(1859),
  [4184] = {.count = 1, .reusable = false}, SHIFT(1859),
  [4186] = {.count = 1, .reusable = true}, SHIFT(1860),
  [4188] = {.count = 1, .reusable = false}, SHIFT(1860),
  [4190] = {.count = 1, .reusable = true}, SHIFT(1861),
  [4192] = {.count = 1, .reusable = false}, SHIFT(1861),
  [4194] = {.count = 1, .reusable = false}, SHIFT(1857),
  [4196] = {.count = 1, .reusable = true}, REDUCE(sym_function_definition, 7),
  [4198] = {.count = 1, .reusable = false}, REDUCE(sym_function_definition, 7),
  [4200] = {.count = 1, .reusable = true}, SHIFT(1866),
  [4202] = {.count = 1, .reusable = true}, SHIFT(1868),
  [4204] = {.count = 1, .reusable = true}, SHIFT(1567),
  [4206] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenated_string_repeat1, 2), SHIFT_REPEAT(1754),
  [4209] = {.count = 1, .reusable = true}, SHIFT(1871),
  [4211] = {.count = 1, .reusable = true}, SHIFT(1872),
  [4213] = {.count = 1, .reusable = false}, SHIFT(1872),
  [4215] = {.count = 2, .reusable = true}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(1572),
  [4218] = {.count = 2, .reusable = true}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(1573),
  [4221] = {.count = 2, .reusable = false}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(1572),
  [4224] = {.count = 2, .reusable = true}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(1579),
  [4227] = {.count = 1, .reusable = true}, SHIFT(1874),
  [4229] = {.count = 1, .reusable = true}, SHIFT(1876),
  [4231] = {.count = 1, .reusable = true}, SHIFT(1608),
  [4233] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenated_string_repeat1, 2), SHIFT_REPEAT(1777),
  [4236] = {.count = 1, .reusable = true}, SHIFT(1879),
  [4238] = {.count = 1, .reusable = true}, SHIFT(1880),
  [4240] = {.count = 1, .reusable = false}, SHIFT(1880),
  [4242] = {.count = 2, .reusable = true}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(1613),
  [4245] = {.count = 2, .reusable = true}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(1614),
  [4248] = {.count = 2, .reusable = false}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(1613),
  [4251] = {.count = 2, .reusable = true}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(1620),
  [4254] = {.count = 1, .reusable = true}, REDUCE(sym_slice, 5),
  [4256] = {.count = 1, .reusable = true}, REDUCE(sym_for_in_clause, 6),
  [4258] = {.count = 1, .reusable = false}, REDUCE(sym_for_in_clause, 6),
  [4260] = {.count = 1, .reusable = true}, SHIFT(1881),
  [4262] = {.count = 1, .reusable = true}, REDUCE(sym_lambda_within_for_in_clause, 3),
  [4264] = {.count = 1, .reusable = true}, REDUCE(aux_sym_for_in_clause_repeat1, 2),
  [4266] = {.count = 2, .reusable = true}, REDUCE(aux_sym_for_in_clause_repeat1, 2), SHIFT_REPEAT(1883),
  [4269] = {.count = 1, .reusable = true}, REDUCE(sym_elif_clause, 4),
  [4271] = {.count = 1, .reusable = false}, REDUCE(sym_elif_clause, 4),
  [4273] = {.count = 1, .reusable = true}, REDUCE(sym_for_statement, 8),
  [4275] = {.count = 1, .reusable = false}, REDUCE(sym_for_statement, 8),
  [4277] = {.count = 1, .reusable = true}, REDUCE(sym_function_definition, 8),
  [4279] = {.count = 1, .reusable = false}, REDUCE(sym_function_definition, 8),
  [4281] = {.count = 1, .reusable = true}, SHIFT(1885),
  [4283] = {.count = 1, .reusable = true}, SHIFT(1886),
  [4285] = {.count = 1, .reusable = true}, SHIFT(1887),
  [4287] = {.count = 1, .reusable = true}, SHIFT(1889),
  [4289] = {.count = 1, .reusable = true}, SHIFT(1892),
  [4291] = {.count = 1, .reusable = true}, SHIFT(1897),
  [4293] = {.count = 1, .reusable = true}, SHIFT(1898),
  [4295] = {.count = 1, .reusable = true}, SHIFT(1899),
  [4297] = {.count = 1, .reusable = true}, SHIFT(1900),
  [4299] = {.count = 1, .reusable = false}, SHIFT(1901),
  [4301] = {.count = 1, .reusable = true}, SHIFT(1903),
  [4303] = {.count = 1, .reusable = true}, SHIFT(1904),
  [4305] = {.count = 1, .reusable = true}, SHIFT(1906),
  [4307] = {.count = 2, .reusable = false}, REDUCE(aux_sym_try_statement_repeat1, 2), SHIFT_REPEAT(1688),
  [4310] = {.count = 1, .reusable = true}, SHIFT(1908),
  [4312] = {.count = 1, .reusable = true}, SHIFT(1909),
  [4314] = {.count = 1, .reusable = true}, SHIFT(1911),
  [4316] = {.count = 1, .reusable = true}, SHIFT(1912),
  [4318] = {.count = 1, .reusable = true}, SHIFT(1913),
  [4320] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenated_string_repeat1, 2), SHIFT_REPEAT(1851),
  [4323] = {.count = 1, .reusable = true}, SHIFT(1916),
  [4325] = {.count = 1, .reusable = true}, SHIFT(1917),
  [4327] = {.count = 1, .reusable = false}, SHIFT(1917),
  [4329] = {.count = 2, .reusable = true}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(1728),
  [4332] = {.count = 2, .reusable = true}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(1729),
  [4335] = {.count = 2, .reusable = false}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(1728),
  [4338] = {.count = 2, .reusable = true}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(1735),
  [4341] = {.count = 1, .reusable = true}, SHIFT(1918),
  [4343] = {.count = 2, .reusable = true}, REDUCE(aux_sym_for_in_clause_repeat1, 2), SHIFT_REPEAT(1919),
  [4346] = {.count = 1, .reusable = true}, SHIFT(1921),
  [4348] = {.count = 2, .reusable = true}, REDUCE(aux_sym_for_in_clause_repeat1, 2), SHIFT_REPEAT(1922),
  [4351] = {.count = 1, .reusable = true}, REDUCE(sym_for_in_clause, 7),
  [4353] = {.count = 1, .reusable = false}, REDUCE(sym_for_in_clause, 7),
  [4355] = {.count = 1, .reusable = true}, REDUCE(sym_lambda_within_for_in_clause, 4),
  [4357] = {.count = 1, .reusable = true}, SHIFT(1924),
  [4359] = {.count = 1, .reusable = true}, SHIFT(1925),
  [4361] = {.count = 2, .reusable = false}, REDUCE(aux_sym_if_statement_repeat1, 2), SHIFT_REPEAT(1811),
  [4364] = {.count = 1, .reusable = true}, SHIFT(1928),
  [4366] = {.count = 1, .reusable = true}, SHIFT(1930),
  [4368] = {.count = 1, .reusable = true}, SHIFT(1931),
  [4370] = {.count = 1, .reusable = true}, SHIFT(1933),
  [4372] = {.count = 1, .reusable = true}, SHIFT(1934),
  [4374] = {.count = 1, .reusable = true}, SHIFT(1938),
  [4376] = {.count = 1, .reusable = false}, SHIFT(1939),
  [4378] = {.count = 1, .reusable = true}, REDUCE(sym_except_clause, 6),
  [4380] = {.count = 1, .reusable = false}, REDUCE(sym_except_clause, 6),
  [4382] = {.count = 1, .reusable = true}, SHIFT(1942),
  [4384] = {.count = 1, .reusable = true}, SHIFT(1947),
  [4386] = {.count = 1, .reusable = true}, SHIFT(1948),
  [4388] = {.count = 1, .reusable = true}, SHIFT(1949),
  [4390] = {.count = 1, .reusable = true}, SHIFT(1950),
  [4392] = {.count = 1, .reusable = true}, SHIFT(1951),
  [4394] = {.count = 1, .reusable = true}, SHIFT(1953),
  [4396] = {.count = 1, .reusable = true}, SHIFT(1954),
  [4398] = {.count = 1, .reusable = true}, SHIFT(1956),
  [4400] = {.count = 1, .reusable = true}, SHIFT(1958),
  [4402] = {.count = 1, .reusable = true}, SHIFT(1959),
  [4404] = {.count = 1, .reusable = true}, SHIFT(1960),
  [4406] = {.count = 1, .reusable = true}, SHIFT(1961),
};

void *tree_sitter_python_external_scanner_create();
void tree_sitter_python_external_scanner_destroy(void *);
bool tree_sitter_python_external_scanner_scan(void *, TSLexer *, const bool *);
unsigned tree_sitter_python_external_scanner_serialize(void *, char *);
void tree_sitter_python_external_scanner_deserialize(void *, const char *, unsigned);

#ifdef _WIN32
#define extern __declspec(dllexport)
#endif

extern const TSLanguage *tree_sitter_python() {
  static TSLanguage language = {
    .version = LANGUAGE_VERSION,
    .symbol_count = SYMBOL_COUNT,
    .alias_count = ALIAS_COUNT,
    .token_count = TOKEN_COUNT,
    .symbol_metadata = ts_symbol_metadata,
    .parse_table = (const unsigned short *)ts_parse_table,
    .parse_actions = ts_parse_actions,
    .lex_modes = ts_lex_modes,
    .symbol_names = ts_symbol_names,
    .alias_sequences = (const TSSymbol *)ts_alias_sequences,
    .max_alias_sequence_length = MAX_ALIAS_SEQUENCE_LENGTH,
    .lex_fn = ts_lex,
    .keyword_lex_fn = ts_lex_keywords,
    .keyword_capture_token = sym_identifier,
    .external_token_count = EXTERNAL_TOKEN_COUNT,
    .external_scanner = {
      (const bool *)ts_external_scanner_states,
      ts_external_scanner_symbol_map,
      tree_sitter_python_external_scanner_create,
      tree_sitter_python_external_scanner_destroy,
      tree_sitter_python_external_scanner_scan,
      tree_sitter_python_external_scanner_serialize,
      tree_sitter_python_external_scanner_deserialize,
    },
  };
  return &language;
}
